#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 12126
#define LARGE_STATE_COUNT 4301
#define SYMBOL_COUNT 453
#define ALIAS_COUNT 4
#define TOKEN_COUNT 201
#define EXTERNAL_TOKEN_COUNT 20
#define FIELD_COUNT 23
#define MAX_ALIAS_SEQUENCE_LENGTH 11
#define PRODUCTION_ID_COUNT 76

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_namespace = 2,
  anon_sym_global = 3,
  anon_sym_rec = 4,
  anon_sym_module = 5,
  anon_sym_EQ = 6,
  anon_sym_open = 7,
  anon_sym_LBRACK_LT = 8,
  anon_sym_GT_RBRACK = 9,
  anon_sym_COLON = 10,
  anon_sym_assembly = 11,
  anon_sym_return = 12,
  anon_sym_field = 13,
  anon_sym_property = 14,
  anon_sym_param = 15,
  anon_sym_type = 16,
  anon_sym_constructor = 17,
  anon_sym_event = 18,
  anon_sym_do = 19,
  anon_sym_and = 20,
  anon_sym_let = 21,
  anon_sym_let_BANG = 22,
  anon_sym_inline = 23,
  anon_sym_mutable = 24,
  aux_sym_access_modifier_token1 = 25,
  anon_sym_as = 26,
  anon_sym_LPAREN = 27,
  anon_sym_RPAREN = 28,
  anon_sym_COMMA = 29,
  anon_sym_null = 30,
  anon_sym__ = 31,
  anon_sym_QMARK = 32,
  anon_sym_COLON_QMARK = 33,
  anon_sym_COLON_COLON = 34,
  anon_sym_PIPE = 35,
  anon_sym_AMP = 36,
  anon_sym_LBRACK = 37,
  anon_sym_RBRACK = 38,
  anon_sym_LBRACK_PIPE = 39,
  anon_sym_PIPE_RBRACK = 40,
  anon_sym_LBRACE = 41,
  anon_sym_RBRACE = 42,
  anon_sym_LT_AT = 43,
  anon_sym_AT_GT = 44,
  anon_sym_LT_AT_AT = 45,
  anon_sym_AT_AT_GT = 46,
  anon_sym_DOT = 47,
  anon_sym_LBRACE_PIPE = 48,
  anon_sym_PIPE_RBRACE = 49,
  anon_sym_new = 50,
  anon_sym_with = 51,
  anon_sym_return_BANG = 52,
  anon_sym_yield = 53,
  anon_sym_yield_BANG = 54,
  anon_sym_lazy = 55,
  anon_sym_assert = 56,
  anon_sym_upcast = 57,
  anon_sym_downcast = 58,
  anon_sym_COLON_GT = 59,
  anon_sym_COLON_QMARK_GT = 60,
  anon_sym_for = 61,
  anon_sym_in = 62,
  anon_sym_to = 63,
  anon_sym_downto = 64,
  anon_sym_done = 65,
  anon_sym_while = 66,
  anon_sym_else = 67,
  anon_sym_then = 68,
  anon_sym_elif = 69,
  anon_sym_if = 70,
  anon_sym_fun = 71,
  anon_sym_DASH_GT = 72,
  anon_sym_try = 73,
  anon_sym_finally = 74,
  anon_sym_match = 75,
  anon_sym_match_BANG = 76,
  anon_sym_function = 77,
  anon_sym_LT_DASH = 78,
  anon_sym_DOT_LBRACK = 79,
  anon_sym_LT = 80,
  anon_sym_GT = 81,
  anon_sym_use = 82,
  anon_sym_use_BANG = 83,
  anon_sym_do_BANG = 84,
  anon_sym_DOT_DOT = 85,
  anon_sym_when = 86,
  anon_sym_begin = 87,
  anon_sym_end = 88,
  anon_sym_LPAREN2 = 89,
  anon_sym_DOT_DOT2 = 90,
  anon_sym_DOT_DOT3 = 91,
  anon_sym_STAR = 92,
  anon_sym_LT2 = 93,
  anon_sym_LBRACK_RBRACK = 94,
  anon_sym_POUND = 95,
  anon_sym_CARET = 96,
  anon_sym_SQUOTE = 97,
  anon_sym_unit = 98,
  anon_sym_struct = 99,
  anon_sym_not = 100,
  anon_sym_enum = 101,
  anon_sym_unmanaged = 102,
  anon_sym_equality = 103,
  anon_sym_comparison = 104,
  anon_sym_delegate = 105,
  anon_sym_default = 106,
  anon_sym_or = 107,
  anon_sym_static = 108,
  anon_sym_member = 109,
  anon_sym_get = 110,
  anon_sym_set = 111,
  anon_sym_interface = 112,
  anon_sym_id = 113,
  anon_sym_exception = 114,
  anon_sym_of = 115,
  anon_sym_class = 116,
  anon_sym_abstract = 117,
  anon_sym_val = 118,
  anon_sym_override = 119,
  anon_sym_inherit = 120,
  anon_sym_EQ2 = 121,
  sym__escape_char = 122,
  sym__non_escape_char = 123,
  sym__unicodegraph_short = 124,
  sym__unicodegraph_long = 125,
  sym__trigraph = 126,
  aux_sym__simple_string_char_token1 = 127,
  aux_sym_char_token1 = 128,
  anon_sym_LBRACE2 = 129,
  anon_sym_DOLLAR_DQUOTE = 130,
  anon_sym_DQUOTE = 131,
  anon_sym_BSLASH = 132,
  aux_sym__verbatim_string_char_token1 = 133,
  anon_sym_AT_DQUOTE = 134,
  anon_sym_DQUOTE2 = 135,
  anon_sym_DQUOTEB = 136,
  anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE = 137,
  anon_sym_DQUOTE_DQUOTE_DQUOTE = 138,
  sym_bool = 139,
  sym_unit = 140,
  anon_sym_LPAREN_PIPE = 141,
  anon_sym_PIPE_RPAREN = 142,
  sym_op_identifier = 143,
  anon_sym_PLUS = 144,
  anon_sym_DASH = 145,
  anon_sym_PLUS_DOT = 146,
  anon_sym_DASH_DOT = 147,
  anon_sym_PERCENT = 148,
  anon_sym_AMP_AMP = 149,
  anon_sym_TILDE = 150,
  aux_sym_prefix_op_token1 = 151,
  aux_sym_infix_op_token1 = 152,
  aux_sym_infix_op_token2 = 153,
  anon_sym_PIPE_PIPE = 154,
  anon_sym_BANG_EQ = 155,
  anon_sym_COLON_EQ = 156,
  anon_sym_DOLLAR = 157,
  anon_sym_QMARK_LT_DASH = 158,
  sym_int = 159,
  sym_xint = 160,
  anon_sym_y = 161,
  anon_sym_uy = 162,
  anon_sym_s = 163,
  anon_sym_us = 164,
  anon_sym_l = 165,
  aux_sym_uint32_token1 = 166,
  anon_sym_n = 167,
  anon_sym_un = 168,
  anon_sym_L = 169,
  aux_sym_uint64_token1 = 170,
  anon_sym_f = 171,
  anon_sym_lf = 172,
  anon_sym_LF = 173,
  aux_sym_bignum_token1 = 174,
  aux_sym_decimal_token1 = 175,
  anon_sym_DOT2 = 176,
  aux_sym_float_token1 = 177,
  anon_sym_LPAREN_STAR = 178,
  anon_sym_STAR_RPAREN = 179,
  sym_line_comment = 180,
  anon_sym_POUNDnowarn = 181,
  anon_sym_POUNDlight = 182,
  anon_sym_POUNDr = 183,
  anon_sym_POUNDload = 184,
  aux_sym_fsi_directive_decl_token1 = 185,
  aux_sym_preproc_line_token1 = 186,
  anon_sym_POUNDif = 187,
  anon_sym_POUNDendif = 188,
  anon_sym_POUNDelse = 189,
  sym__newline = 190,
  sym__indent = 191,
  sym__dedent = 192,
  sym__struct_begin = 193,
  sym__interface_begin = 194,
  sym__triple_quoted_content = 195,
  sym_block_comment_content = 196,
  sym__inside_string_marker = 197,
  sym__newline_not_aligned = 198,
  sym__tuple_marker = 199,
  sym__error_sentinel = 200,
  sym_file = 201,
  sym_namespace = 202,
  sym_named_module = 203,
  sym_module_abbrev = 204,
  sym_module_defn = 205,
  sym__module_body = 206,
  sym_import_decl = 207,
  sym_attributes = 208,
  sym__attribute_set = 209,
  sym_attribute = 210,
  sym__attribute_target = 211,
  sym__object_construction = 212,
  sym_value_declaration = 213,
  sym_do = 214,
  sym__function_or_value_defns = 215,
  sym_function_or_value_defn = 216,
  sym__function_or_value_defn_body = 217,
  sym_function_declaration_left = 218,
  sym_value_declaration_left = 219,
  sym_access_modifier = 220,
  sym_class_as_reference = 221,
  sym_primary_constr_args = 222,
  sym_repeat_pattern = 223,
  sym__pattern = 224,
  sym_optional_pattern = 225,
  sym_type_check_pattern = 226,
  sym_attribute_pattern = 227,
  sym_paren_pattern = 228,
  sym_as_pattern = 229,
  sym_cons_pattern = 230,
  sym_disjunct_pattern = 231,
  sym_conjunct_pattern = 232,
  sym_typed_pattern = 233,
  sym_argument_patterns = 234,
  sym_field_pattern = 235,
  sym__atomic_pattern = 236,
  sym__list_pattern_content = 237,
  sym_list_pattern = 238,
  sym_array_pattern = 239,
  sym_record_pattern = 240,
  sym_named_field = 241,
  sym_named_field_pattern = 242,
  sym_identifier_pattern = 243,
  sym__expression_block = 244,
  sym__expression = 245,
  sym_literal_expression = 246,
  sym_long_identifier_or_op = 247,
  sym_tuple_expression = 248,
  sym_brace_expression = 249,
  sym_anon_record_expression = 250,
  sym_object_expression = 251,
  sym_with_field_expression = 252,
  sym_prefixed_expression = 253,
  sym_typecast_expression = 254,
  sym_for_expression = 255,
  sym_while_expression = 256,
  sym__else_expression = 257,
  sym_elif_expression = 258,
  sym__if_branch = 259,
  sym_if_expression = 260,
  sym_fun_expression = 261,
  sym_try_expression = 262,
  sym_match_expression = 263,
  sym_function_expression = 264,
  sym_mutate_expression = 265,
  sym_index_expression = 266,
  sym_typed_expression = 267,
  sym_declaration_expression = 268,
  sym_do_expression = 269,
  sym__list_elements = 270,
  sym__list_element = 271,
  sym_list_expression = 272,
  sym_array_expression = 273,
  sym_range_expression = 274,
  sym_rule = 275,
  sym_rules = 276,
  sym_begin_end_expression = 277,
  sym_paren_expression = 278,
  sym__high_prec_app = 279,
  sym__low_prec_app = 280,
  sym_application_expression = 281,
  sym_dot_expression = 282,
  sym_infix_expression = 283,
  sym_ce_expression = 284,
  sym_sequential_expression = 285,
  sym__comp_or_range_expression = 286,
  sym_short_comp_expression = 287,
  sym_slice_ranges = 288,
  sym__slice_range_special = 289,
  sym_slice_range = 290,
  sym__type = 291,
  sym_simple_type = 292,
  sym_generic_type = 293,
  sym_paren_type = 294,
  sym_function_type = 295,
  sym_compound_type = 296,
  sym_postfix_type = 297,
  sym_list_type = 298,
  sym_static_type = 299,
  sym_constrained_type = 300,
  sym_flexible_type = 301,
  sym_anon_record_type = 302,
  sym_types = 303,
  sym__static_type_identifier = 304,
  sym__static_parameter = 305,
  sym_named_static_parameter = 306,
  sym_type_attribute = 307,
  sym_type_attributes = 308,
  sym_atomic_type = 309,
  sym_constraint = 310,
  sym_type_argument_constraints = 311,
  sym_type_argument = 312,
  sym_type_argument_defn = 313,
  sym_type_arguments = 314,
  sym_trait_member_constraint = 315,
  sym_member_signature = 316,
  sym_curried_spec = 317,
  sym_argument_spec = 318,
  sym_arguments_spec = 319,
  sym_argument_name_spec = 320,
  sym_static_parameter_value = 321,
  sym_exception_definition = 322,
  sym_type_definition = 323,
  sym__type_defn_body = 324,
  sym_type_name = 325,
  sym_type_extension = 326,
  sym_delegate_type_defn = 327,
  sym_delegate_signature = 328,
  sym_type_abbrev_defn = 329,
  sym__class_type_body_inner = 330,
  sym__class_type_body = 331,
  sym_record_type_defn = 332,
  sym_record_fields = 333,
  sym_record_field = 334,
  sym_enum_type_defn = 335,
  sym_enum_type_cases = 336,
  sym_enum_type_case = 337,
  sym_union_type_defn = 338,
  sym_union_type_cases = 339,
  sym_union_type_case = 340,
  sym_union_type_fields = 341,
  sym_union_type_field = 342,
  sym_interface_type_defn = 343,
  sym_anon_type_defn = 344,
  sym__class_function_or_value_defn = 345,
  aux_sym__type_extension_inner = 346,
  sym_type_extension_elements = 347,
  sym__type_defn_elements = 348,
  sym_interface_implementation = 349,
  sym__member_defns = 350,
  sym__object_members = 351,
  sym_member_defn = 352,
  sym_property_or_ident = 353,
  sym__method_defn = 354,
  sym__property_accessor_body = 355,
  sym_property_accessor = 356,
  sym__property_defn = 357,
  sym__val_property_defn = 358,
  sym_method_or_prop_defn = 359,
  sym_additional_constr_defn = 360,
  sym_class_inherits_decl = 361,
  sym_field_initializer = 362,
  sym_field_initializers = 363,
  sym__simple_string_char = 364,
  sym__string_char = 365,
  sym_char = 366,
  sym_format_string_eval = 367,
  sym_format_string = 368,
  sym__string_literal = 369,
  sym_string = 370,
  sym__verbatim_string_char = 371,
  sym_verbatim_string = 372,
  sym_bytearray = 373,
  sym_verbatim_bytearray = 374,
  sym_format_triple_quoted_string = 375,
  sym_triple_quoted_string = 376,
  sym_const = 377,
  sym_long_identifier = 378,
  sym_active_pattern = 379,
  sym__identifier_or_op = 380,
  sym__infix_or_prefix_op = 381,
  sym_prefix_op = 382,
  sym_infix_op = 383,
  sym_sbyte = 384,
  sym_byte = 385,
  sym_int16 = 386,
  sym_uint16 = 387,
  sym_int32 = 388,
  sym_uint32 = 389,
  sym_nativeint = 390,
  sym_unativeint = 391,
  sym_int64 = 392,
  sym_uint64 = 393,
  sym_ieee32 = 394,
  sym_ieee64 = 395,
  sym_bignum = 396,
  sym_decimal = 397,
  sym_float = 398,
  sym_block_comment = 399,
  sym_compiler_directive_decl = 400,
  sym_fsi_directive_decl = 401,
  sym_preproc_line = 402,
  sym_preproc_if = 403,
  sym_preproc_else = 404,
  sym_preproc_if_in_expression = 405,
  sym_preproc_else_in_expression = 406,
  sym_preproc_if_in_class_definition = 407,
  sym_preproc_else_in_class_definition = 408,
  aux_sym_file_repeat1 = 409,
  aux_sym_file_repeat2 = 410,
  aux_sym__module_body_repeat1 = 411,
  aux_sym_attributes_repeat1 = 412,
  aux_sym__attribute_set_repeat1 = 413,
  aux_sym__function_or_value_defns_repeat1 = 414,
  aux_sym_repeat_pattern_repeat1 = 415,
  aux_sym_argument_patterns_repeat1 = 416,
  aux_sym__list_pattern_content_repeat1 = 417,
  aux_sym_record_pattern_repeat1 = 418,
  aux_sym_named_field_pattern_repeat1 = 419,
  aux_sym__object_expression_inner_repeat1 = 420,
  aux_sym_if_expression_repeat1 = 421,
  aux_sym__list_elements_repeat1 = 422,
  aux_sym_rules_repeat1 = 423,
  aux_sym_sequential_expression_repeat1 = 424,
  aux_sym_slice_ranges_repeat1 = 425,
  aux_sym_compound_type_repeat1 = 426,
  aux_sym_types_repeat1 = 427,
  aux_sym_type_attributes_repeat1 = 428,
  aux_sym_type_argument_constraints_repeat1 = 429,
  aux_sym_type_argument_repeat1 = 430,
  aux_sym_type_arguments_repeat1 = 431,
  aux_sym_curried_spec_repeat1 = 432,
  aux_sym_arguments_spec_repeat1 = 433,
  aux_sym_type_definition_repeat1 = 434,
  aux_sym__class_type_body_repeat1 = 435,
  aux_sym_record_fields_repeat1 = 436,
  aux_sym_enum_type_cases_repeat1 = 437,
  aux_sym_union_type_cases_repeat1 = 438,
  aux_sym_union_type_fields_repeat1 = 439,
  aux_sym_interface_type_defn_repeat1 = 440,
  aux_sym__member_defns_repeat1 = 441,
  aux_sym__method_defn_repeat1 = 442,
  aux_sym__property_defn_repeat1 = 443,
  aux_sym_field_initializers_repeat1 = 444,
  aux_sym_format_string_repeat1 = 445,
  aux_sym__string_literal_repeat1 = 446,
  aux_sym_verbatim_string_repeat1 = 447,
  aux_sym_long_identifier_repeat1 = 448,
  aux_sym_active_pattern_repeat1 = 449,
  aux_sym_prefix_op_repeat1 = 450,
  aux_sym_preproc_if_in_expression_repeat1 = 451,
  aux_sym_preproc_if_in_class_definition_repeat1 = 452,
  anon_alias_sym_SEMI = 453,
  alias_sym_active_pattern_op_name = 454,
  alias_sym_wildcard_active_pattern_op = 455,
  alias_sym_wildcard_pattern = 456,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_namespace] = "namespace",
  [anon_sym_global] = "global",
  [anon_sym_rec] = "rec",
  [anon_sym_module] = "module",
  [anon_sym_EQ] = "=",
  [anon_sym_open] = "open",
  [anon_sym_LBRACK_LT] = "[<",
  [anon_sym_GT_RBRACK] = ">]",
  [anon_sym_COLON] = ":",
  [anon_sym_assembly] = "assembly",
  [anon_sym_return] = "return",
  [anon_sym_field] = "field",
  [anon_sym_property] = "property",
  [anon_sym_param] = "param",
  [anon_sym_type] = "type",
  [anon_sym_constructor] = "constructor",
  [anon_sym_event] = "event",
  [anon_sym_do] = "do",
  [anon_sym_and] = "and",
  [anon_sym_let] = "let",
  [anon_sym_let_BANG] = "let!",
  [anon_sym_inline] = "inline",
  [anon_sym_mutable] = "mutable",
  [aux_sym_access_modifier_token1] = "access_modifier_token1",
  [anon_sym_as] = "as",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_COMMA] = ",",
  [anon_sym_null] = "null",
  [anon_sym__] = "_",
  [anon_sym_QMARK] = "\?",
  [anon_sym_COLON_QMARK] = ":\?",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP] = "&",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACK_PIPE] = "[|",
  [anon_sym_PIPE_RBRACK] = "|]",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_LT_AT] = "<@",
  [anon_sym_AT_GT] = "@>",
  [anon_sym_LT_AT_AT] = "<@@",
  [anon_sym_AT_AT_GT] = "@@>",
  [anon_sym_DOT] = ".",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [anon_sym_new] = "new",
  [anon_sym_with] = "with",
  [anon_sym_return_BANG] = "return!",
  [anon_sym_yield] = "yield",
  [anon_sym_yield_BANG] = "yield!",
  [anon_sym_lazy] = "lazy",
  [anon_sym_assert] = "assert",
  [anon_sym_upcast] = "upcast",
  [anon_sym_downcast] = "downcast",
  [anon_sym_COLON_GT] = ":>",
  [anon_sym_COLON_QMARK_GT] = ":\?>",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_to] = "to",
  [anon_sym_downto] = "downto",
  [anon_sym_done] = "done",
  [anon_sym_while] = "while",
  [anon_sym_else] = "else",
  [anon_sym_then] = "then",
  [anon_sym_elif] = "elif",
  [anon_sym_if] = "if",
  [anon_sym_fun] = "fun",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_try] = "try",
  [anon_sym_finally] = "finally",
  [anon_sym_match] = "match",
  [anon_sym_match_BANG] = "match!",
  [anon_sym_function] = "function",
  [anon_sym_LT_DASH] = "<-",
  [anon_sym_DOT_LBRACK] = ".[",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_use] = "use",
  [anon_sym_use_BANG] = "use!",
  [anon_sym_do_BANG] = "do!",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_when] = "when",
  [anon_sym_begin] = "begin",
  [anon_sym_end] = "end",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_DOT_DOT2] = "..",
  [anon_sym_DOT_DOT3] = "..",
  [anon_sym_STAR] = "*",
  [anon_sym_LT2] = "<",
  [anon_sym_LBRACK_RBRACK] = "[]",
  [anon_sym_POUND] = "#",
  [anon_sym_CARET] = "^",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_unit] = "unit",
  [anon_sym_struct] = "struct",
  [anon_sym_not] = "not",
  [anon_sym_enum] = "enum",
  [anon_sym_unmanaged] = "unmanaged",
  [anon_sym_equality] = "equality",
  [anon_sym_comparison] = "comparison",
  [anon_sym_delegate] = "delegate",
  [anon_sym_default] = "default",
  [anon_sym_or] = "or",
  [anon_sym_static] = "static",
  [anon_sym_member] = "member",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_interface] = "interface",
  [anon_sym_id] = "id",
  [anon_sym_exception] = "exception",
  [anon_sym_of] = "of",
  [anon_sym_class] = "class",
  [anon_sym_abstract] = "abstract",
  [anon_sym_val] = "val",
  [anon_sym_override] = "override",
  [anon_sym_inherit] = "inherit",
  [anon_sym_EQ2] = "=",
  [sym__escape_char] = "_escape_char",
  [sym__non_escape_char] = "_non_escape_char",
  [sym__unicodegraph_short] = "_unicodegraph_short",
  [sym__unicodegraph_long] = "_unicodegraph_long",
  [sym__trigraph] = "_trigraph",
  [aux_sym__simple_string_char_token1] = "_simple_string_char_token1",
  [aux_sym_char_token1] = "char_token1",
  [anon_sym_LBRACE2] = "{",
  [anon_sym_DOLLAR_DQUOTE] = "$\"",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_BSLASH] = "\\",
  [aux_sym__verbatim_string_char_token1] = "_verbatim_string_char_token1",
  [anon_sym_AT_DQUOTE] = "@\"",
  [anon_sym_DQUOTE2] = "\"",
  [anon_sym_DQUOTEB] = "\"B",
  [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = "$\"\"\"",
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = "\"\"\"",
  [sym_bool] = "bool",
  [sym_unit] = "unit",
  [anon_sym_LPAREN_PIPE] = "(|",
  [anon_sym_PIPE_RPAREN] = "|)",
  [sym_op_identifier] = "op_identifier",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS_DOT] = "+.",
  [anon_sym_DASH_DOT] = "-.",
  [anon_sym_PERCENT] = "%",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_TILDE] = "~",
  [aux_sym_prefix_op_token1] = "prefix_op_token1",
  [aux_sym_infix_op_token1] = "infix_op_token1",
  [aux_sym_infix_op_token2] = "infix_op_token2",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_QMARK_LT_DASH] = "\?<-",
  [sym_int] = "int",
  [sym_xint] = "xint",
  [anon_sym_y] = "y",
  [anon_sym_uy] = "uy",
  [anon_sym_s] = "s",
  [anon_sym_us] = "us",
  [anon_sym_l] = "l",
  [aux_sym_uint32_token1] = "uint32_token1",
  [anon_sym_n] = "n",
  [anon_sym_un] = "un",
  [anon_sym_L] = "L",
  [aux_sym_uint64_token1] = "uint64_token1",
  [anon_sym_f] = "f",
  [anon_sym_lf] = "lf",
  [anon_sym_LF] = "LF",
  [aux_sym_bignum_token1] = "bignum_token1",
  [aux_sym_decimal_token1] = "decimal_token1",
  [anon_sym_DOT2] = "float",
  [aux_sym_float_token1] = "float",
  [anon_sym_LPAREN_STAR] = "(*",
  [anon_sym_STAR_RPAREN] = "*)",
  [sym_line_comment] = "line_comment",
  [anon_sym_POUNDnowarn] = "#nowarn",
  [anon_sym_POUNDlight] = "#light",
  [anon_sym_POUNDr] = "#r",
  [anon_sym_POUNDload] = "#load",
  [aux_sym_fsi_directive_decl_token1] = "fsi_directive_decl_token1",
  [aux_sym_preproc_line_token1] = "#line",
  [anon_sym_POUNDif] = "#if",
  [anon_sym_POUNDendif] = "#endif",
  [anon_sym_POUNDelse] = "#else",
  [sym__newline] = "_newline",
  [sym__indent] = "_indent",
  [sym__dedent] = "_dedent",
  [sym__struct_begin] = "struct",
  [sym__interface_begin] = "interface",
  [sym__triple_quoted_content] = "_triple_quoted_content",
  [sym_block_comment_content] = "block_comment_content",
  [sym__inside_string_marker] = "_inside_string_marker",
  [sym__newline_not_aligned] = "_newline_not_aligned",
  [sym__tuple_marker] = "_tuple_marker",
  [sym__error_sentinel] = "_error_sentinel",
  [sym_file] = "file",
  [sym_namespace] = "namespace",
  [sym_named_module] = "named_module",
  [sym_module_abbrev] = "module_abbrev",
  [sym_module_defn] = "module_defn",
  [sym__module_body] = "_module_body",
  [sym_import_decl] = "import_decl",
  [sym_attributes] = "attributes",
  [sym__attribute_set] = "_attribute_set",
  [sym_attribute] = "attribute",
  [sym__attribute_target] = "_attribute_target",
  [sym__object_construction] = "_object_construction",
  [sym_value_declaration] = "value_declaration",
  [sym_do] = "do",
  [sym__function_or_value_defns] = "_function_or_value_defns",
  [sym_function_or_value_defn] = "function_or_value_defn",
  [sym__function_or_value_defn_body] = "_function_or_value_defn_body",
  [sym_function_declaration_left] = "function_declaration_left",
  [sym_value_declaration_left] = "value_declaration_left",
  [sym_access_modifier] = "access_modifier",
  [sym_class_as_reference] = "class_as_reference",
  [sym_primary_constr_args] = "primary_constr_args",
  [sym_repeat_pattern] = "repeat_pattern",
  [sym__pattern] = "_pattern",
  [sym_optional_pattern] = "optional_pattern",
  [sym_type_check_pattern] = "type_check_pattern",
  [sym_attribute_pattern] = "attribute_pattern",
  [sym_paren_pattern] = "paren_pattern",
  [sym_as_pattern] = "as_pattern",
  [sym_cons_pattern] = "cons_pattern",
  [sym_disjunct_pattern] = "disjunct_pattern",
  [sym_conjunct_pattern] = "conjunct_pattern",
  [sym_typed_pattern] = "typed_pattern",
  [sym_argument_patterns] = "argument_patterns",
  [sym_field_pattern] = "field_pattern",
  [sym__atomic_pattern] = "_atomic_pattern",
  [sym__list_pattern_content] = "_list_pattern_content",
  [sym_list_pattern] = "list_pattern",
  [sym_array_pattern] = "array_pattern",
  [sym_record_pattern] = "record_pattern",
  [sym_named_field] = "named_field",
  [sym_named_field_pattern] = "named_field_pattern",
  [sym_identifier_pattern] = "identifier_pattern",
  [sym__expression_block] = "_expression_block",
  [sym__expression] = "_expression",
  [sym_literal_expression] = "literal_expression",
  [sym_long_identifier_or_op] = "long_identifier_or_op",
  [sym_tuple_expression] = "tuple_expression",
  [sym_brace_expression] = "brace_expression",
  [sym_anon_record_expression] = "anon_record_expression",
  [sym_object_expression] = "object_expression",
  [sym_with_field_expression] = "with_field_expression",
  [sym_prefixed_expression] = "prefixed_expression",
  [sym_typecast_expression] = "typecast_expression",
  [sym_for_expression] = "for_expression",
  [sym_while_expression] = "while_expression",
  [sym__else_expression] = "_else_expression",
  [sym_elif_expression] = "elif_expression",
  [sym__if_branch] = "_if_branch",
  [sym_if_expression] = "if_expression",
  [sym_fun_expression] = "fun_expression",
  [sym_try_expression] = "try_expression",
  [sym_match_expression] = "match_expression",
  [sym_function_expression] = "function_expression",
  [sym_mutate_expression] = "mutate_expression",
  [sym_index_expression] = "index_expression",
  [sym_typed_expression] = "typed_expression",
  [sym_declaration_expression] = "declaration_expression",
  [sym_do_expression] = "do_expression",
  [sym__list_elements] = "_list_elements",
  [sym__list_element] = "_list_element",
  [sym_list_expression] = "list_expression",
  [sym_array_expression] = "array_expression",
  [sym_range_expression] = "range_expression",
  [sym_rule] = "rule",
  [sym_rules] = "rules",
  [sym_begin_end_expression] = "begin_end_expression",
  [sym_paren_expression] = "paren_expression",
  [sym__high_prec_app] = "_high_prec_app",
  [sym__low_prec_app] = "_low_prec_app",
  [sym_application_expression] = "application_expression",
  [sym_dot_expression] = "dot_expression",
  [sym_infix_expression] = "infix_expression",
  [sym_ce_expression] = "ce_expression",
  [sym_sequential_expression] = "sequential_expression",
  [sym__comp_or_range_expression] = "_comp_or_range_expression",
  [sym_short_comp_expression] = "short_comp_expression",
  [sym_slice_ranges] = "slice_ranges",
  [sym__slice_range_special] = "_slice_range_special",
  [sym_slice_range] = "slice_range",
  [sym__type] = "_type",
  [sym_simple_type] = "simple_type",
  [sym_generic_type] = "generic_type",
  [sym_paren_type] = "paren_type",
  [sym_function_type] = "function_type",
  [sym_compound_type] = "compound_type",
  [sym_postfix_type] = "postfix_type",
  [sym_list_type] = "list_type",
  [sym_static_type] = "static_type",
  [sym_constrained_type] = "constrained_type",
  [sym_flexible_type] = "flexible_type",
  [sym_anon_record_type] = "anon_record_type",
  [sym_types] = "types",
  [sym__static_type_identifier] = "_static_type_identifier",
  [sym__static_parameter] = "_static_parameter",
  [sym_named_static_parameter] = "named_static_parameter",
  [sym_type_attribute] = "type_attribute",
  [sym_type_attributes] = "type_attributes",
  [sym_atomic_type] = "atomic_type",
  [sym_constraint] = "constraint",
  [sym_type_argument_constraints] = "type_argument_constraints",
  [sym_type_argument] = "type_argument",
  [sym_type_argument_defn] = "type_argument_defn",
  [sym_type_arguments] = "type_arguments",
  [sym_trait_member_constraint] = "trait_member_constraint",
  [sym_member_signature] = "member_signature",
  [sym_curried_spec] = "curried_spec",
  [sym_argument_spec] = "argument_spec",
  [sym_arguments_spec] = "arguments_spec",
  [sym_argument_name_spec] = "argument_name_spec",
  [sym_static_parameter_value] = "static_parameter_value",
  [sym_exception_definition] = "exception_definition",
  [sym_type_definition] = "type_definition",
  [sym__type_defn_body] = "_type_defn_body",
  [sym_type_name] = "type_name",
  [sym_type_extension] = "type_extension",
  [sym_delegate_type_defn] = "delegate_type_defn",
  [sym_delegate_signature] = "delegate_signature",
  [sym_type_abbrev_defn] = "type_abbrev_defn",
  [sym__class_type_body_inner] = "_class_type_body_inner",
  [sym__class_type_body] = "_class_type_body",
  [sym_record_type_defn] = "record_type_defn",
  [sym_record_fields] = "record_fields",
  [sym_record_field] = "record_field",
  [sym_enum_type_defn] = "enum_type_defn",
  [sym_enum_type_cases] = "enum_type_cases",
  [sym_enum_type_case] = "enum_type_case",
  [sym_union_type_defn] = "union_type_defn",
  [sym_union_type_cases] = "union_type_cases",
  [sym_union_type_case] = "union_type_case",
  [sym_union_type_fields] = "union_type_fields",
  [sym_union_type_field] = "union_type_field",
  [sym_interface_type_defn] = "interface_type_defn",
  [sym_anon_type_defn] = "anon_type_defn",
  [sym__class_function_or_value_defn] = "_class_function_or_value_defn",
  [aux_sym__type_extension_inner] = "_type_extension_inner",
  [sym_type_extension_elements] = "type_extension_elements",
  [sym__type_defn_elements] = "_type_defn_elements",
  [sym_interface_implementation] = "interface_implementation",
  [sym__member_defns] = "_member_defns",
  [sym__object_members] = "_object_members",
  [sym_member_defn] = "member_defn",
  [sym_property_or_ident] = "property_or_ident",
  [sym__method_defn] = "_method_defn",
  [sym__property_accessor_body] = "_property_accessor_body",
  [sym_property_accessor] = "property_accessor",
  [sym__property_defn] = "_property_defn",
  [sym__val_property_defn] = "_val_property_defn",
  [sym_method_or_prop_defn] = "method_or_prop_defn",
  [sym_additional_constr_defn] = "additional_constr_defn",
  [sym_class_inherits_decl] = "class_inherits_decl",
  [sym_field_initializer] = "field_initializer",
  [sym_field_initializers] = "field_initializers",
  [sym__simple_string_char] = "_simple_string_char",
  [sym__string_char] = "_string_char",
  [sym_char] = "char",
  [sym_format_string_eval] = "format_string_eval",
  [sym_format_string] = "format_string",
  [sym__string_literal] = "_string_literal",
  [sym_string] = "string",
  [sym__verbatim_string_char] = "_verbatim_string_char",
  [sym_verbatim_string] = "verbatim_string",
  [sym_bytearray] = "bytearray",
  [sym_verbatim_bytearray] = "verbatim_bytearray",
  [sym_format_triple_quoted_string] = "format_triple_quoted_string",
  [sym_triple_quoted_string] = "triple_quoted_string",
  [sym_const] = "const",
  [sym_long_identifier] = "long_identifier",
  [sym_active_pattern] = "active_pattern",
  [sym__identifier_or_op] = "_identifier_or_op",
  [sym__infix_or_prefix_op] = "_infix_or_prefix_op",
  [sym_prefix_op] = "prefix_op",
  [sym_infix_op] = "infix_op",
  [sym_sbyte] = "sbyte",
  [sym_byte] = "byte",
  [sym_int16] = "int16",
  [sym_uint16] = "uint16",
  [sym_int32] = "int32",
  [sym_uint32] = "uint32",
  [sym_nativeint] = "nativeint",
  [sym_unativeint] = "unativeint",
  [sym_int64] = "int64",
  [sym_uint64] = "uint64",
  [sym_ieee32] = "ieee32",
  [sym_ieee64] = "ieee64",
  [sym_bignum] = "bignum",
  [sym_decimal] = "decimal",
  [sym_float] = "float",
  [sym_block_comment] = "block_comment",
  [sym_compiler_directive_decl] = "compiler_directive_decl",
  [sym_fsi_directive_decl] = "fsi_directive_decl",
  [sym_preproc_line] = "preproc_line",
  [sym_preproc_if] = "preproc_if",
  [sym_preproc_else] = "preproc_else",
  [sym_preproc_if_in_expression] = "preproc_if",
  [sym_preproc_else_in_expression] = "preproc_else",
  [sym_preproc_if_in_class_definition] = "preproc_if",
  [sym_preproc_else_in_class_definition] = "preproc_else",
  [aux_sym_file_repeat1] = "file_repeat1",
  [aux_sym_file_repeat2] = "file_repeat2",
  [aux_sym__module_body_repeat1] = "_module_body_repeat1",
  [aux_sym_attributes_repeat1] = "attributes_repeat1",
  [aux_sym__attribute_set_repeat1] = "_attribute_set_repeat1",
  [aux_sym__function_or_value_defns_repeat1] = "_function_or_value_defns_repeat1",
  [aux_sym_repeat_pattern_repeat1] = "repeat_pattern_repeat1",
  [aux_sym_argument_patterns_repeat1] = "argument_patterns_repeat1",
  [aux_sym__list_pattern_content_repeat1] = "_list_pattern_content_repeat1",
  [aux_sym_record_pattern_repeat1] = "record_pattern_repeat1",
  [aux_sym_named_field_pattern_repeat1] = "named_field_pattern_repeat1",
  [aux_sym__object_expression_inner_repeat1] = "_object_expression_inner_repeat1",
  [aux_sym_if_expression_repeat1] = "if_expression_repeat1",
  [aux_sym__list_elements_repeat1] = "_list_elements_repeat1",
  [aux_sym_rules_repeat1] = "rules_repeat1",
  [aux_sym_sequential_expression_repeat1] = "sequential_expression_repeat1",
  [aux_sym_slice_ranges_repeat1] = "slice_ranges_repeat1",
  [aux_sym_compound_type_repeat1] = "compound_type_repeat1",
  [aux_sym_types_repeat1] = "types_repeat1",
  [aux_sym_type_attributes_repeat1] = "type_attributes_repeat1",
  [aux_sym_type_argument_constraints_repeat1] = "type_argument_constraints_repeat1",
  [aux_sym_type_argument_repeat1] = "type_argument_repeat1",
  [aux_sym_type_arguments_repeat1] = "type_arguments_repeat1",
  [aux_sym_curried_spec_repeat1] = "curried_spec_repeat1",
  [aux_sym_arguments_spec_repeat1] = "arguments_spec_repeat1",
  [aux_sym_type_definition_repeat1] = "type_definition_repeat1",
  [aux_sym__class_type_body_repeat1] = "_class_type_body_repeat1",
  [aux_sym_record_fields_repeat1] = "record_fields_repeat1",
  [aux_sym_enum_type_cases_repeat1] = "enum_type_cases_repeat1",
  [aux_sym_union_type_cases_repeat1] = "union_type_cases_repeat1",
  [aux_sym_union_type_fields_repeat1] = "union_type_fields_repeat1",
  [aux_sym_interface_type_defn_repeat1] = "interface_type_defn_repeat1",
  [aux_sym__member_defns_repeat1] = "_member_defns_repeat1",
  [aux_sym__method_defn_repeat1] = "_method_defn_repeat1",
  [aux_sym__property_defn_repeat1] = "_property_defn_repeat1",
  [aux_sym_field_initializers_repeat1] = "field_initializers_repeat1",
  [aux_sym_format_string_repeat1] = "format_string_repeat1",
  [aux_sym__string_literal_repeat1] = "_string_literal_repeat1",
  [aux_sym_verbatim_string_repeat1] = "verbatim_string_repeat1",
  [aux_sym_long_identifier_repeat1] = "long_identifier_repeat1",
  [aux_sym_active_pattern_repeat1] = "active_pattern_repeat1",
  [aux_sym_prefix_op_repeat1] = "prefix_op_repeat1",
  [aux_sym_preproc_if_in_expression_repeat1] = "preproc_if_in_expression_repeat1",
  [aux_sym_preproc_if_in_class_definition_repeat1] = "preproc_if_in_class_definition_repeat1",
  [anon_alias_sym_SEMI] = ";",
  [alias_sym_active_pattern_op_name] = "active_pattern_op_name",
  [alias_sym_wildcard_active_pattern_op] = "wildcard_active_pattern_op",
  [alias_sym_wildcard_pattern] = "wildcard_pattern",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_rec] = anon_sym_rec,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_open] = anon_sym_open,
  [anon_sym_LBRACK_LT] = anon_sym_LBRACK_LT,
  [anon_sym_GT_RBRACK] = anon_sym_GT_RBRACK,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_assembly] = anon_sym_assembly,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_field] = anon_sym_field,
  [anon_sym_property] = anon_sym_property,
  [anon_sym_param] = anon_sym_param,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_constructor] = anon_sym_constructor,
  [anon_sym_event] = anon_sym_event,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_let_BANG] = anon_sym_let_BANG,
  [anon_sym_inline] = anon_sym_inline,
  [anon_sym_mutable] = anon_sym_mutable,
  [aux_sym_access_modifier_token1] = aux_sym_access_modifier_token1,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_null] = anon_sym_null,
  [anon_sym__] = anon_sym__,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_COLON_QMARK] = anon_sym_COLON_QMARK,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LBRACK_PIPE] = anon_sym_LBRACK_PIPE,
  [anon_sym_PIPE_RBRACK] = anon_sym_PIPE_RBRACK,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_LT_AT] = anon_sym_LT_AT,
  [anon_sym_AT_GT] = anon_sym_AT_GT,
  [anon_sym_LT_AT_AT] = anon_sym_LT_AT_AT,
  [anon_sym_AT_AT_GT] = anon_sym_AT_AT_GT,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_LBRACE_PIPE] = anon_sym_LBRACE_PIPE,
  [anon_sym_PIPE_RBRACE] = anon_sym_PIPE_RBRACE,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_return_BANG] = anon_sym_return_BANG,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_yield_BANG] = anon_sym_yield_BANG,
  [anon_sym_lazy] = anon_sym_lazy,
  [anon_sym_assert] = anon_sym_assert,
  [anon_sym_upcast] = anon_sym_upcast,
  [anon_sym_downcast] = anon_sym_downcast,
  [anon_sym_COLON_GT] = anon_sym_COLON_GT,
  [anon_sym_COLON_QMARK_GT] = anon_sym_COLON_QMARK_GT,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_to] = anon_sym_to,
  [anon_sym_downto] = anon_sym_downto,
  [anon_sym_done] = anon_sym_done,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_then] = anon_sym_then,
  [anon_sym_elif] = anon_sym_elif,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_fun] = anon_sym_fun,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_match] = anon_sym_match,
  [anon_sym_match_BANG] = anon_sym_match_BANG,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_LT_DASH] = anon_sym_LT_DASH,
  [anon_sym_DOT_LBRACK] = anon_sym_DOT_LBRACK,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_use] = anon_sym_use,
  [anon_sym_use_BANG] = anon_sym_use_BANG,
  [anon_sym_do_BANG] = anon_sym_do_BANG,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_when] = anon_sym_when,
  [anon_sym_begin] = anon_sym_begin,
  [anon_sym_end] = anon_sym_end,
  [anon_sym_LPAREN2] = anon_sym_LPAREN,
  [anon_sym_DOT_DOT2] = anon_sym_DOT_DOT,
  [anon_sym_DOT_DOT3] = anon_sym_DOT_DOT,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_LT2] = anon_sym_LT,
  [anon_sym_LBRACK_RBRACK] = anon_sym_LBRACK_RBRACK,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_unit] = anon_sym_unit,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_unmanaged] = anon_sym_unmanaged,
  [anon_sym_equality] = anon_sym_equality,
  [anon_sym_comparison] = anon_sym_comparison,
  [anon_sym_delegate] = anon_sym_delegate,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_member] = anon_sym_member,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_id] = anon_sym_id,
  [anon_sym_exception] = anon_sym_exception,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_val] = anon_sym_val,
  [anon_sym_override] = anon_sym_override,
  [anon_sym_inherit] = anon_sym_inherit,
  [anon_sym_EQ2] = anon_sym_EQ,
  [sym__escape_char] = sym__escape_char,
  [sym__non_escape_char] = sym__non_escape_char,
  [sym__unicodegraph_short] = sym__unicodegraph_short,
  [sym__unicodegraph_long] = sym__unicodegraph_long,
  [sym__trigraph] = sym__trigraph,
  [aux_sym__simple_string_char_token1] = aux_sym__simple_string_char_token1,
  [aux_sym_char_token1] = aux_sym_char_token1,
  [anon_sym_LBRACE2] = anon_sym_LBRACE,
  [anon_sym_DOLLAR_DQUOTE] = anon_sym_DOLLAR_DQUOTE,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_BSLASH] = anon_sym_BSLASH,
  [aux_sym__verbatim_string_char_token1] = aux_sym__verbatim_string_char_token1,
  [anon_sym_AT_DQUOTE] = anon_sym_AT_DQUOTE,
  [anon_sym_DQUOTE2] = anon_sym_DQUOTE,
  [anon_sym_DQUOTEB] = anon_sym_DQUOTEB,
  [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [sym_bool] = sym_bool,
  [sym_unit] = sym_unit,
  [anon_sym_LPAREN_PIPE] = anon_sym_LPAREN_PIPE,
  [anon_sym_PIPE_RPAREN] = anon_sym_PIPE_RPAREN,
  [sym_op_identifier] = sym_op_identifier,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PLUS_DOT] = anon_sym_PLUS_DOT,
  [anon_sym_DASH_DOT] = anon_sym_DASH_DOT,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [aux_sym_prefix_op_token1] = aux_sym_prefix_op_token1,
  [aux_sym_infix_op_token1] = aux_sym_infix_op_token1,
  [aux_sym_infix_op_token2] = aux_sym_infix_op_token2,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_QMARK_LT_DASH] = anon_sym_QMARK_LT_DASH,
  [sym_int] = sym_int,
  [sym_xint] = sym_xint,
  [anon_sym_y] = anon_sym_y,
  [anon_sym_uy] = anon_sym_uy,
  [anon_sym_s] = anon_sym_s,
  [anon_sym_us] = anon_sym_us,
  [anon_sym_l] = anon_sym_l,
  [aux_sym_uint32_token1] = aux_sym_uint32_token1,
  [anon_sym_n] = anon_sym_n,
  [anon_sym_un] = anon_sym_un,
  [anon_sym_L] = anon_sym_L,
  [aux_sym_uint64_token1] = aux_sym_uint64_token1,
  [anon_sym_f] = anon_sym_f,
  [anon_sym_lf] = anon_sym_lf,
  [anon_sym_LF] = anon_sym_LF,
  [aux_sym_bignum_token1] = aux_sym_bignum_token1,
  [aux_sym_decimal_token1] = aux_sym_decimal_token1,
  [anon_sym_DOT2] = anon_sym_DOT2,
  [aux_sym_float_token1] = anon_sym_DOT2,
  [anon_sym_LPAREN_STAR] = anon_sym_LPAREN_STAR,
  [anon_sym_STAR_RPAREN] = anon_sym_STAR_RPAREN,
  [sym_line_comment] = sym_line_comment,
  [anon_sym_POUNDnowarn] = anon_sym_POUNDnowarn,
  [anon_sym_POUNDlight] = anon_sym_POUNDlight,
  [anon_sym_POUNDr] = anon_sym_POUNDr,
  [anon_sym_POUNDload] = anon_sym_POUNDload,
  [aux_sym_fsi_directive_decl_token1] = aux_sym_fsi_directive_decl_token1,
  [aux_sym_preproc_line_token1] = aux_sym_preproc_line_token1,
  [anon_sym_POUNDif] = anon_sym_POUNDif,
  [anon_sym_POUNDendif] = anon_sym_POUNDendif,
  [anon_sym_POUNDelse] = anon_sym_POUNDelse,
  [sym__newline] = sym__newline,
  [sym__indent] = sym__indent,
  [sym__dedent] = sym__dedent,
  [sym__struct_begin] = anon_sym_struct,
  [sym__interface_begin] = anon_sym_interface,
  [sym__triple_quoted_content] = sym__triple_quoted_content,
  [sym_block_comment_content] = sym_block_comment_content,
  [sym__inside_string_marker] = sym__inside_string_marker,
  [sym__newline_not_aligned] = sym__newline_not_aligned,
  [sym__tuple_marker] = sym__tuple_marker,
  [sym__error_sentinel] = sym__error_sentinel,
  [sym_file] = sym_file,
  [sym_namespace] = sym_namespace,
  [sym_named_module] = sym_named_module,
  [sym_module_abbrev] = sym_module_abbrev,
  [sym_module_defn] = sym_module_defn,
  [sym__module_body] = sym__module_body,
  [sym_import_decl] = sym_import_decl,
  [sym_attributes] = sym_attributes,
  [sym__attribute_set] = sym__attribute_set,
  [sym_attribute] = sym_attribute,
  [sym__attribute_target] = sym__attribute_target,
  [sym__object_construction] = sym__object_construction,
  [sym_value_declaration] = sym_value_declaration,
  [sym_do] = sym_do,
  [sym__function_or_value_defns] = sym__function_or_value_defns,
  [sym_function_or_value_defn] = sym_function_or_value_defn,
  [sym__function_or_value_defn_body] = sym__function_or_value_defn_body,
  [sym_function_declaration_left] = sym_function_declaration_left,
  [sym_value_declaration_left] = sym_value_declaration_left,
  [sym_access_modifier] = sym_access_modifier,
  [sym_class_as_reference] = sym_class_as_reference,
  [sym_primary_constr_args] = sym_primary_constr_args,
  [sym_repeat_pattern] = sym_repeat_pattern,
  [sym__pattern] = sym__pattern,
  [sym_optional_pattern] = sym_optional_pattern,
  [sym_type_check_pattern] = sym_type_check_pattern,
  [sym_attribute_pattern] = sym_attribute_pattern,
  [sym_paren_pattern] = sym_paren_pattern,
  [sym_as_pattern] = sym_as_pattern,
  [sym_cons_pattern] = sym_cons_pattern,
  [sym_disjunct_pattern] = sym_disjunct_pattern,
  [sym_conjunct_pattern] = sym_conjunct_pattern,
  [sym_typed_pattern] = sym_typed_pattern,
  [sym_argument_patterns] = sym_argument_patterns,
  [sym_field_pattern] = sym_field_pattern,
  [sym__atomic_pattern] = sym__atomic_pattern,
  [sym__list_pattern_content] = sym__list_pattern_content,
  [sym_list_pattern] = sym_list_pattern,
  [sym_array_pattern] = sym_array_pattern,
  [sym_record_pattern] = sym_record_pattern,
  [sym_named_field] = sym_named_field,
  [sym_named_field_pattern] = sym_named_field_pattern,
  [sym_identifier_pattern] = sym_identifier_pattern,
  [sym__expression_block] = sym__expression_block,
  [sym__expression] = sym__expression,
  [sym_literal_expression] = sym_literal_expression,
  [sym_long_identifier_or_op] = sym_long_identifier_or_op,
  [sym_tuple_expression] = sym_tuple_expression,
  [sym_brace_expression] = sym_brace_expression,
  [sym_anon_record_expression] = sym_anon_record_expression,
  [sym_object_expression] = sym_object_expression,
  [sym_with_field_expression] = sym_with_field_expression,
  [sym_prefixed_expression] = sym_prefixed_expression,
  [sym_typecast_expression] = sym_typecast_expression,
  [sym_for_expression] = sym_for_expression,
  [sym_while_expression] = sym_while_expression,
  [sym__else_expression] = sym__else_expression,
  [sym_elif_expression] = sym_elif_expression,
  [sym__if_branch] = sym__if_branch,
  [sym_if_expression] = sym_if_expression,
  [sym_fun_expression] = sym_fun_expression,
  [sym_try_expression] = sym_try_expression,
  [sym_match_expression] = sym_match_expression,
  [sym_function_expression] = sym_function_expression,
  [sym_mutate_expression] = sym_mutate_expression,
  [sym_index_expression] = sym_index_expression,
  [sym_typed_expression] = sym_typed_expression,
  [sym_declaration_expression] = sym_declaration_expression,
  [sym_do_expression] = sym_do_expression,
  [sym__list_elements] = sym__list_elements,
  [sym__list_element] = sym__list_element,
  [sym_list_expression] = sym_list_expression,
  [sym_array_expression] = sym_array_expression,
  [sym_range_expression] = sym_range_expression,
  [sym_rule] = sym_rule,
  [sym_rules] = sym_rules,
  [sym_begin_end_expression] = sym_begin_end_expression,
  [sym_paren_expression] = sym_paren_expression,
  [sym__high_prec_app] = sym__high_prec_app,
  [sym__low_prec_app] = sym__low_prec_app,
  [sym_application_expression] = sym_application_expression,
  [sym_dot_expression] = sym_dot_expression,
  [sym_infix_expression] = sym_infix_expression,
  [sym_ce_expression] = sym_ce_expression,
  [sym_sequential_expression] = sym_sequential_expression,
  [sym__comp_or_range_expression] = sym__comp_or_range_expression,
  [sym_short_comp_expression] = sym_short_comp_expression,
  [sym_slice_ranges] = sym_slice_ranges,
  [sym__slice_range_special] = sym__slice_range_special,
  [sym_slice_range] = sym_slice_range,
  [sym__type] = sym__type,
  [sym_simple_type] = sym_simple_type,
  [sym_generic_type] = sym_generic_type,
  [sym_paren_type] = sym_paren_type,
  [sym_function_type] = sym_function_type,
  [sym_compound_type] = sym_compound_type,
  [sym_postfix_type] = sym_postfix_type,
  [sym_list_type] = sym_list_type,
  [sym_static_type] = sym_static_type,
  [sym_constrained_type] = sym_constrained_type,
  [sym_flexible_type] = sym_flexible_type,
  [sym_anon_record_type] = sym_anon_record_type,
  [sym_types] = sym_types,
  [sym__static_type_identifier] = sym__static_type_identifier,
  [sym__static_parameter] = sym__static_parameter,
  [sym_named_static_parameter] = sym_named_static_parameter,
  [sym_type_attribute] = sym_type_attribute,
  [sym_type_attributes] = sym_type_attributes,
  [sym_atomic_type] = sym_atomic_type,
  [sym_constraint] = sym_constraint,
  [sym_type_argument_constraints] = sym_type_argument_constraints,
  [sym_type_argument] = sym_type_argument,
  [sym_type_argument_defn] = sym_type_argument_defn,
  [sym_type_arguments] = sym_type_arguments,
  [sym_trait_member_constraint] = sym_trait_member_constraint,
  [sym_member_signature] = sym_member_signature,
  [sym_curried_spec] = sym_curried_spec,
  [sym_argument_spec] = sym_argument_spec,
  [sym_arguments_spec] = sym_arguments_spec,
  [sym_argument_name_spec] = sym_argument_name_spec,
  [sym_static_parameter_value] = sym_static_parameter_value,
  [sym_exception_definition] = sym_exception_definition,
  [sym_type_definition] = sym_type_definition,
  [sym__type_defn_body] = sym__type_defn_body,
  [sym_type_name] = sym_type_name,
  [sym_type_extension] = sym_type_extension,
  [sym_delegate_type_defn] = sym_delegate_type_defn,
  [sym_delegate_signature] = sym_delegate_signature,
  [sym_type_abbrev_defn] = sym_type_abbrev_defn,
  [sym__class_type_body_inner] = sym__class_type_body_inner,
  [sym__class_type_body] = sym__class_type_body,
  [sym_record_type_defn] = sym_record_type_defn,
  [sym_record_fields] = sym_record_fields,
  [sym_record_field] = sym_record_field,
  [sym_enum_type_defn] = sym_enum_type_defn,
  [sym_enum_type_cases] = sym_enum_type_cases,
  [sym_enum_type_case] = sym_enum_type_case,
  [sym_union_type_defn] = sym_union_type_defn,
  [sym_union_type_cases] = sym_union_type_cases,
  [sym_union_type_case] = sym_union_type_case,
  [sym_union_type_fields] = sym_union_type_fields,
  [sym_union_type_field] = sym_union_type_field,
  [sym_interface_type_defn] = sym_interface_type_defn,
  [sym_anon_type_defn] = sym_anon_type_defn,
  [sym__class_function_or_value_defn] = sym__class_function_or_value_defn,
  [aux_sym__type_extension_inner] = aux_sym__type_extension_inner,
  [sym_type_extension_elements] = sym_type_extension_elements,
  [sym__type_defn_elements] = sym__type_defn_elements,
  [sym_interface_implementation] = sym_interface_implementation,
  [sym__member_defns] = sym__member_defns,
  [sym__object_members] = sym__object_members,
  [sym_member_defn] = sym_member_defn,
  [sym_property_or_ident] = sym_property_or_ident,
  [sym__method_defn] = sym__method_defn,
  [sym__property_accessor_body] = sym__property_accessor_body,
  [sym_property_accessor] = sym_property_accessor,
  [sym__property_defn] = sym__property_defn,
  [sym__val_property_defn] = sym__val_property_defn,
  [sym_method_or_prop_defn] = sym_method_or_prop_defn,
  [sym_additional_constr_defn] = sym_additional_constr_defn,
  [sym_class_inherits_decl] = sym_class_inherits_decl,
  [sym_field_initializer] = sym_field_initializer,
  [sym_field_initializers] = sym_field_initializers,
  [sym__simple_string_char] = sym__simple_string_char,
  [sym__string_char] = sym__string_char,
  [sym_char] = sym_char,
  [sym_format_string_eval] = sym_format_string_eval,
  [sym_format_string] = sym_format_string,
  [sym__string_literal] = sym__string_literal,
  [sym_string] = sym_string,
  [sym__verbatim_string_char] = sym__verbatim_string_char,
  [sym_verbatim_string] = sym_verbatim_string,
  [sym_bytearray] = sym_bytearray,
  [sym_verbatim_bytearray] = sym_verbatim_bytearray,
  [sym_format_triple_quoted_string] = sym_format_triple_quoted_string,
  [sym_triple_quoted_string] = sym_triple_quoted_string,
  [sym_const] = sym_const,
  [sym_long_identifier] = sym_long_identifier,
  [sym_active_pattern] = sym_active_pattern,
  [sym__identifier_or_op] = sym__identifier_or_op,
  [sym__infix_or_prefix_op] = sym__infix_or_prefix_op,
  [sym_prefix_op] = sym_prefix_op,
  [sym_infix_op] = sym_infix_op,
  [sym_sbyte] = sym_sbyte,
  [sym_byte] = sym_byte,
  [sym_int16] = sym_int16,
  [sym_uint16] = sym_uint16,
  [sym_int32] = sym_int32,
  [sym_uint32] = sym_uint32,
  [sym_nativeint] = sym_nativeint,
  [sym_unativeint] = sym_unativeint,
  [sym_int64] = sym_int64,
  [sym_uint64] = sym_uint64,
  [sym_ieee32] = sym_ieee32,
  [sym_ieee64] = sym_ieee64,
  [sym_bignum] = sym_bignum,
  [sym_decimal] = sym_decimal,
  [sym_float] = sym_float,
  [sym_block_comment] = sym_block_comment,
  [sym_compiler_directive_decl] = sym_compiler_directive_decl,
  [sym_fsi_directive_decl] = sym_fsi_directive_decl,
  [sym_preproc_line] = sym_preproc_line,
  [sym_preproc_if] = sym_preproc_if,
  [sym_preproc_else] = sym_preproc_else,
  [sym_preproc_if_in_expression] = sym_preproc_if,
  [sym_preproc_else_in_expression] = sym_preproc_else,
  [sym_preproc_if_in_class_definition] = sym_preproc_if,
  [sym_preproc_else_in_class_definition] = sym_preproc_else,
  [aux_sym_file_repeat1] = aux_sym_file_repeat1,
  [aux_sym_file_repeat2] = aux_sym_file_repeat2,
  [aux_sym__module_body_repeat1] = aux_sym__module_body_repeat1,
  [aux_sym_attributes_repeat1] = aux_sym_attributes_repeat1,
  [aux_sym__attribute_set_repeat1] = aux_sym__attribute_set_repeat1,
  [aux_sym__function_or_value_defns_repeat1] = aux_sym__function_or_value_defns_repeat1,
  [aux_sym_repeat_pattern_repeat1] = aux_sym_repeat_pattern_repeat1,
  [aux_sym_argument_patterns_repeat1] = aux_sym_argument_patterns_repeat1,
  [aux_sym__list_pattern_content_repeat1] = aux_sym__list_pattern_content_repeat1,
  [aux_sym_record_pattern_repeat1] = aux_sym_record_pattern_repeat1,
  [aux_sym_named_field_pattern_repeat1] = aux_sym_named_field_pattern_repeat1,
  [aux_sym__object_expression_inner_repeat1] = aux_sym__object_expression_inner_repeat1,
  [aux_sym_if_expression_repeat1] = aux_sym_if_expression_repeat1,
  [aux_sym__list_elements_repeat1] = aux_sym__list_elements_repeat1,
  [aux_sym_rules_repeat1] = aux_sym_rules_repeat1,
  [aux_sym_sequential_expression_repeat1] = aux_sym_sequential_expression_repeat1,
  [aux_sym_slice_ranges_repeat1] = aux_sym_slice_ranges_repeat1,
  [aux_sym_compound_type_repeat1] = aux_sym_compound_type_repeat1,
  [aux_sym_types_repeat1] = aux_sym_types_repeat1,
  [aux_sym_type_attributes_repeat1] = aux_sym_type_attributes_repeat1,
  [aux_sym_type_argument_constraints_repeat1] = aux_sym_type_argument_constraints_repeat1,
  [aux_sym_type_argument_repeat1] = aux_sym_type_argument_repeat1,
  [aux_sym_type_arguments_repeat1] = aux_sym_type_arguments_repeat1,
  [aux_sym_curried_spec_repeat1] = aux_sym_curried_spec_repeat1,
  [aux_sym_arguments_spec_repeat1] = aux_sym_arguments_spec_repeat1,
  [aux_sym_type_definition_repeat1] = aux_sym_type_definition_repeat1,
  [aux_sym__class_type_body_repeat1] = aux_sym__class_type_body_repeat1,
  [aux_sym_record_fields_repeat1] = aux_sym_record_fields_repeat1,
  [aux_sym_enum_type_cases_repeat1] = aux_sym_enum_type_cases_repeat1,
  [aux_sym_union_type_cases_repeat1] = aux_sym_union_type_cases_repeat1,
  [aux_sym_union_type_fields_repeat1] = aux_sym_union_type_fields_repeat1,
  [aux_sym_interface_type_defn_repeat1] = aux_sym_interface_type_defn_repeat1,
  [aux_sym__member_defns_repeat1] = aux_sym__member_defns_repeat1,
  [aux_sym__method_defn_repeat1] = aux_sym__method_defn_repeat1,
  [aux_sym__property_defn_repeat1] = aux_sym__property_defn_repeat1,
  [aux_sym_field_initializers_repeat1] = aux_sym_field_initializers_repeat1,
  [aux_sym_format_string_repeat1] = aux_sym_format_string_repeat1,
  [aux_sym__string_literal_repeat1] = aux_sym__string_literal_repeat1,
  [aux_sym_verbatim_string_repeat1] = aux_sym_verbatim_string_repeat1,
  [aux_sym_long_identifier_repeat1] = aux_sym_long_identifier_repeat1,
  [aux_sym_active_pattern_repeat1] = aux_sym_active_pattern_repeat1,
  [aux_sym_prefix_op_repeat1] = aux_sym_prefix_op_repeat1,
  [aux_sym_preproc_if_in_expression_repeat1] = aux_sym_preproc_if_in_expression_repeat1,
  [aux_sym_preproc_if_in_class_definition_repeat1] = aux_sym_preproc_if_in_class_definition_repeat1,
  [anon_alias_sym_SEMI] = anon_alias_sym_SEMI,
  [alias_sym_active_pattern_op_name] = alias_sym_active_pattern_op_name,
  [alias_sym_wildcard_active_pattern_op] = alias_sym_wildcard_active_pattern_op,
  [alias_sym_wildcard_pattern] = alias_sym_wildcard_pattern,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_open] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assembly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_field] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_property] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_param] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constructor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_event] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mutable] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_access_modifier_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_null] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_AT_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_AT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lazy] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_upcast] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_downcast] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_QMARK_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_to] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_downto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_done] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fun] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_match] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_match_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_use] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_use_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_when] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_begin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unmanaged] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_equality] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_comparison] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delegate] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_member] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_id] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exception] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_val] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inherit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ2] = {
    .visible = true,
    .named = false,
  },
  [sym__escape_char] = {
    .visible = false,
    .named = true,
  },
  [sym__non_escape_char] = {
    .visible = false,
    .named = true,
  },
  [sym__unicodegraph_short] = {
    .visible = false,
    .named = true,
  },
  [sym__unicodegraph_long] = {
    .visible = false,
    .named = true,
  },
  [sym__trigraph] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__simple_string_char_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_char_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LBRACE2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__verbatim_string_char_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_AT_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTEB] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_bool] = {
    .visible = true,
    .named = true,
  },
  [sym_unit] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym_op_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_prefix_op_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_infix_op_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_infix_op_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [sym_int] = {
    .visible = true,
    .named = true,
  },
  [sym_xint] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_y] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uy] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_s] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_us] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_l] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_uint32_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_n] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_un] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_L] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_uint64_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_f] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lf] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_bignum_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decimal_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DOT2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_float_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUNDnowarn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUNDlight] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUNDr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUNDload] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_fsi_directive_decl_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_line_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUNDif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUNDendif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUNDelse] = {
    .visible = true,
    .named = false,
  },
  [sym__newline] = {
    .visible = false,
    .named = true,
  },
  [sym__indent] = {
    .visible = false,
    .named = true,
  },
  [sym__dedent] = {
    .visible = false,
    .named = true,
  },
  [sym__struct_begin] = {
    .visible = true,
    .named = false,
  },
  [sym__interface_begin] = {
    .visible = true,
    .named = false,
  },
  [sym__triple_quoted_content] = {
    .visible = false,
    .named = true,
  },
  [sym_block_comment_content] = {
    .visible = true,
    .named = true,
  },
  [sym__inside_string_marker] = {
    .visible = false,
    .named = true,
  },
  [sym__newline_not_aligned] = {
    .visible = false,
    .named = true,
  },
  [sym__tuple_marker] = {
    .visible = false,
    .named = true,
  },
  [sym__error_sentinel] = {
    .visible = false,
    .named = true,
  },
  [sym_file] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace] = {
    .visible = true,
    .named = true,
  },
  [sym_named_module] = {
    .visible = true,
    .named = true,
  },
  [sym_module_abbrev] = {
    .visible = true,
    .named = true,
  },
  [sym_module_defn] = {
    .visible = true,
    .named = true,
  },
  [sym__module_body] = {
    .visible = false,
    .named = true,
  },
  [sym_import_decl] = {
    .visible = true,
    .named = true,
  },
  [sym_attributes] = {
    .visible = true,
    .named = true,
  },
  [sym__attribute_set] = {
    .visible = false,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym__attribute_target] = {
    .visible = false,
    .named = true,
  },
  [sym__object_construction] = {
    .visible = false,
    .named = true,
  },
  [sym_value_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_do] = {
    .visible = true,
    .named = true,
  },
  [sym__function_or_value_defns] = {
    .visible = false,
    .named = true,
  },
  [sym_function_or_value_defn] = {
    .visible = true,
    .named = true,
  },
  [sym__function_or_value_defn_body] = {
    .visible = false,
    .named = true,
  },
  [sym_function_declaration_left] = {
    .visible = true,
    .named = true,
  },
  [sym_value_declaration_left] = {
    .visible = true,
    .named = true,
  },
  [sym_access_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_class_as_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_primary_constr_args] = {
    .visible = true,
    .named = true,
  },
  [sym_repeat_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_optional_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_type_check_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_paren_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_as_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_cons_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_disjunct_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_conjunct_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_patterns] = {
    .visible = true,
    .named = true,
  },
  [sym_field_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__atomic_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym__list_pattern_content] = {
    .visible = false,
    .named = true,
  },
  [sym_list_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_record_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_named_field] = {
    .visible = true,
    .named = true,
  },
  [sym_named_field_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_block] = {
    .visible = false,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_literal_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_long_identifier_or_op] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_brace_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_anon_record_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_with_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_prefixed_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_typecast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_for_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_while_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__else_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_elif_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__if_branch] = {
    .visible = false,
    .named = true,
  },
  [sym_if_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_fun_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_try_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_match_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_mutate_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_do_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__list_elements] = {
    .visible = false,
    .named = true,
  },
  [sym__list_element] = {
    .visible = false,
    .named = true,
  },
  [sym_list_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_array_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_range_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_rule] = {
    .visible = true,
    .named = true,
  },
  [sym_rules] = {
    .visible = true,
    .named = true,
  },
  [sym_begin_end_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_paren_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__high_prec_app] = {
    .visible = false,
    .named = true,
  },
  [sym__low_prec_app] = {
    .visible = false,
    .named = true,
  },
  [sym_application_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_dot_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_infix_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_ce_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequential_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__comp_or_range_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_short_comp_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_slice_ranges] = {
    .visible = true,
    .named = true,
  },
  [sym__slice_range_special] = {
    .visible = false,
    .named = true,
  },
  [sym_slice_range] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_simple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_paren_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_type] = {
    .visible = true,
    .named = true,
  },
  [sym_postfix_type] = {
    .visible = true,
    .named = true,
  },
  [sym_list_type] = {
    .visible = true,
    .named = true,
  },
  [sym_static_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constrained_type] = {
    .visible = true,
    .named = true,
  },
  [sym_flexible_type] = {
    .visible = true,
    .named = true,
  },
  [sym_anon_record_type] = {
    .visible = true,
    .named = true,
  },
  [sym_types] = {
    .visible = true,
    .named = true,
  },
  [sym__static_type_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym__static_parameter] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_named_static_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_type_attributes] = {
    .visible = true,
    .named = true,
  },
  [sym_atomic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_type_argument_constraints] = {
    .visible = true,
    .named = true,
  },
  [sym_type_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_type_argument_defn] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_trait_member_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_member_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_curried_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_name_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_static_parameter_value] = {
    .visible = true,
    .named = true,
  },
  [sym_exception_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__type_defn_body] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_type_name] = {
    .visible = true,
    .named = true,
  },
  [sym_type_extension] = {
    .visible = true,
    .named = true,
  },
  [sym_delegate_type_defn] = {
    .visible = true,
    .named = true,
  },
  [sym_delegate_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_abbrev_defn] = {
    .visible = true,
    .named = true,
  },
  [sym__class_type_body_inner] = {
    .visible = false,
    .named = true,
  },
  [sym__class_type_body] = {
    .visible = false,
    .named = true,
  },
  [sym_record_type_defn] = {
    .visible = true,
    .named = true,
  },
  [sym_record_fields] = {
    .visible = true,
    .named = true,
  },
  [sym_record_field] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_type_defn] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_type_cases] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_type_case] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type_defn] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type_cases] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type_case] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type_fields] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type_field] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_type_defn] = {
    .visible = true,
    .named = true,
  },
  [sym_anon_type_defn] = {
    .visible = true,
    .named = true,
  },
  [sym__class_function_or_value_defn] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__type_extension_inner] = {
    .visible = false,
    .named = false,
  },
  [sym_type_extension_elements] = {
    .visible = true,
    .named = true,
  },
  [sym__type_defn_elements] = {
    .visible = false,
    .named = true,
  },
  [sym_interface_implementation] = {
    .visible = true,
    .named = true,
  },
  [sym__member_defns] = {
    .visible = false,
    .named = true,
  },
  [sym__object_members] = {
    .visible = false,
    .named = true,
  },
  [sym_member_defn] = {
    .visible = true,
    .named = true,
  },
  [sym_property_or_ident] = {
    .visible = true,
    .named = true,
  },
  [sym__method_defn] = {
    .visible = false,
    .named = true,
  },
  [sym__property_accessor_body] = {
    .visible = false,
    .named = true,
  },
  [sym_property_accessor] = {
    .visible = true,
    .named = true,
  },
  [sym__property_defn] = {
    .visible = false,
    .named = true,
  },
  [sym__val_property_defn] = {
    .visible = false,
    .named = true,
  },
  [sym_method_or_prop_defn] = {
    .visible = true,
    .named = true,
  },
  [sym_additional_constr_defn] = {
    .visible = true,
    .named = true,
  },
  [sym_class_inherits_decl] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializers] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_string_char] = {
    .visible = false,
    .named = true,
  },
  [sym__string_char] = {
    .visible = false,
    .named = true,
  },
  [sym_char] = {
    .visible = true,
    .named = true,
  },
  [sym_format_string_eval] = {
    .visible = true,
    .named = true,
  },
  [sym_format_string] = {
    .visible = true,
    .named = true,
  },
  [sym__string_literal] = {
    .visible = false,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym__verbatim_string_char] = {
    .visible = false,
    .named = true,
  },
  [sym_verbatim_string] = {
    .visible = true,
    .named = true,
  },
  [sym_bytearray] = {
    .visible = true,
    .named = true,
  },
  [sym_verbatim_bytearray] = {
    .visible = true,
    .named = true,
  },
  [sym_format_triple_quoted_string] = {
    .visible = true,
    .named = true,
  },
  [sym_triple_quoted_string] = {
    .visible = true,
    .named = true,
  },
  [sym_const] = {
    .visible = true,
    .named = true,
  },
  [sym_long_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_active_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__identifier_or_op] = {
    .visible = false,
    .named = true,
  },
  [sym__infix_or_prefix_op] = {
    .visible = false,
    .named = true,
  },
  [sym_prefix_op] = {
    .visible = true,
    .named = true,
  },
  [sym_infix_op] = {
    .visible = true,
    .named = true,
  },
  [sym_sbyte] = {
    .visible = true,
    .named = true,
  },
  [sym_byte] = {
    .visible = true,
    .named = true,
  },
  [sym_int16] = {
    .visible = true,
    .named = true,
  },
  [sym_uint16] = {
    .visible = true,
    .named = true,
  },
  [sym_int32] = {
    .visible = true,
    .named = true,
  },
  [sym_uint32] = {
    .visible = true,
    .named = true,
  },
  [sym_nativeint] = {
    .visible = true,
    .named = true,
  },
  [sym_unativeint] = {
    .visible = true,
    .named = true,
  },
  [sym_int64] = {
    .visible = true,
    .named = true,
  },
  [sym_uint64] = {
    .visible = true,
    .named = true,
  },
  [sym_ieee32] = {
    .visible = true,
    .named = true,
  },
  [sym_ieee64] = {
    .visible = true,
    .named = true,
  },
  [sym_bignum] = {
    .visible = true,
    .named = true,
  },
  [sym_decimal] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_block_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_compiler_directive_decl] = {
    .visible = true,
    .named = true,
  },
  [sym_fsi_directive_decl] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_line] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_class_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_class_definition] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_file_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__module_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attributes_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__attribute_set_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__function_or_value_defns_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_repeat_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_patterns_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_pattern_content_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_record_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_field_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__object_expression_inner_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_elements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_rules_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sequential_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_slice_ranges_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_compound_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_types_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_attributes_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_argument_constraints_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_argument_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_curried_spec_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_arguments_spec_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__class_type_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_record_fields_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_type_cases_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_union_type_cases_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_union_type_fields_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interface_type_defn_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__member_defns_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__method_defn_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__property_defn_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_initializers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_format_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_verbatim_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_long_identifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_active_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_prefix_op_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_class_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [anon_alias_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [alias_sym_active_pattern_op_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_wildcard_active_pattern_op] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_wildcard_pattern] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_args = 2,
  field_assignee = 3,
  field_base = 4,
  field_block = 5,
  field_body = 6,
  field_condition = 7,
  field_constraints = 8,
  field_else = 9,
  field_exception_name = 10,
  field_field = 11,
  field_from = 12,
  field_guard = 13,
  field_in = 14,
  field_index = 15,
  field_instance = 16,
  field_method = 17,
  field_name = 18,
  field_pattern = 19,
  field_then = 20,
  field_to = 21,
  field_type_name = 22,
  field_value = 23,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_args] = "args",
  [field_assignee] = "assignee",
  [field_base] = "base",
  [field_block] = "block",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_constraints] = "constraints",
  [field_else] = "else",
  [field_exception_name] = "exception_name",
  [field_field] = "field",
  [field_from] = "from",
  [field_guard] = "guard",
  [field_in] = "in",
  [field_index] = "index",
  [field_instance] = "instance",
  [field_method] = "method",
  [field_name] = "name",
  [field_pattern] = "pattern",
  [field_then] = "then",
  [field_to] = "to",
  [field_type_name] = "type_name",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [5] = {.index = 3, .length = 1},
  [7] = {.index = 4, .length = 1},
  [9] = {.index = 5, .length = 2},
  [10] = {.index = 7, .length = 1},
  [11] = {.index = 8, .length = 1},
  [12] = {.index = 9, .length = 1},
  [13] = {.index = 10, .length = 1},
  [14] = {.index = 11, .length = 2},
  [18] = {.index = 13, .length = 2},
  [19] = {.index = 15, .length = 2},
  [20] = {.index = 17, .length = 2},
  [22] = {.index = 19, .length = 1},
  [23] = {.index = 20, .length = 2},
  [24] = {.index = 22, .length = 1},
  [25] = {.index = 23, .length = 1},
  [26] = {.index = 24, .length = 1},
  [27] = {.index = 25, .length = 1},
  [28] = {.index = 26, .length = 3},
  [29] = {.index = 29, .length = 1},
  [30] = {.index = 30, .length = 1},
  [31] = {.index = 31, .length = 1},
  [32] = {.index = 32, .length = 1},
  [33] = {.index = 33, .length = 3},
  [34] = {.index = 36, .length = 1},
  [35] = {.index = 37, .length = 2},
  [36] = {.index = 39, .length = 2},
  [37] = {.index = 41, .length = 1},
  [38] = {.index = 42, .length = 3},
  [39] = {.index = 45, .length = 1},
  [40] = {.index = 46, .length = 2},
  [41] = {.index = 48, .length = 2},
  [42] = {.index = 50, .length = 2},
  [43] = {.index = 52, .length = 1},
  [46] = {.index = 53, .length = 2},
  [47] = {.index = 55, .length = 1},
  [48] = {.index = 56, .length = 1},
  [49] = {.index = 57, .length = 3},
  [50] = {.index = 60, .length = 3},
  [51] = {.index = 63, .length = 3},
  [52] = {.index = 66, .length = 2},
  [53] = {.index = 68, .length = 4},
  [54] = {.index = 72, .length = 1},
  [56] = {.index = 73, .length = 2},
  [57] = {.index = 75, .length = 3},
  [58] = {.index = 78, .length = 4},
  [59] = {.index = 82, .length = 2},
  [60] = {.index = 84, .length = 1},
  [61] = {.index = 85, .length = 1},
  [62] = {.index = 86, .length = 5},
  [63] = {.index = 91, .length = 1},
  [64] = {.index = 92, .length = 3},
  [65] = {.index = 95, .length = 2},
  [66] = {.index = 97, .length = 5},
  [67] = {.index = 102, .length = 5},
  [68] = {.index = 107, .length = 1},
  [69] = {.index = 108, .length = 2},
  [70] = {.index = 110, .length = 3},
  [71] = {.index = 113, .length = 4},
  [72] = {.index = 117, .length = 7},
  [73] = {.index = 124, .length = 8},
  [74] = {.index = 132, .length = 4},
  [75] = {.index = 136, .length = 9},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 1},
  [1] =
    {field_type_name, 0},
  [2] =
    {field_body, 1, .inherited = true},
  [3] =
    {field_guard, 1},
  [4] =
    {field_in, 1},
  [5] =
    {field_name, 1},
    {field_name, 2},
  [7] =
    {field_name, 2},
  [8] =
    {field_type_name, 1},
  [9] =
    {field_body, 2, .inherited = true},
  [10] =
    {field_body, 0, .inherited = true},
  [11] =
    {field_from, 0, .inherited = true},
    {field_to, 0, .inherited = true},
  [13] =
    {field_base, 0},
    {field_field, 2},
  [15] =
    {field_assignee, 0},
    {field_value, 2},
  [17] =
    {field_guard, 0, .inherited = true},
    {field_then, 2},
  [19] =
    {field_type_name, 2},
  [20] =
    {field_body, 0, .inherited = true},
    {field_body, 1, .inherited = true},
  [22] =
    {field_block, 1, .inherited = true},
  [23] =
    {field_body, 2},
  [24] =
    {field_to, 1},
  [25] =
    {field_from, 0},
  [26] =
    {field_block, 1},
    {field_block, 2},
    {field_block, 3},
  [29] =
    {field_exception_name, 1},
  [30] =
    {field_condition, 1},
  [31] =
    {field_name, 3},
  [32] =
    {field_index, 2},
  [33] =
    {field_else, 3, .inherited = true},
    {field_guard, 0, .inherited = true},
    {field_then, 2},
  [36] =
    {field_type_name, 3},
  [37] =
    {field_args, 1, .inherited = true},
    {field_name, 0},
  [39] =
    {field_block, 1, .inherited = true},
    {field_name, 0},
  [41] =
    {field_block, 2, .inherited = true},
  [42] =
    {field_block, 0},
    {field_block, 1},
    {field_block, 2},
  [45] =
    {field_constraints, 3},
  [46] =
    {field_from, 0},
    {field_to, 2},
  [48] =
    {field_field, 0},
    {field_value, 2},
  [50] =
    {field_block, 2},
    {field_pattern, 0},
  [52] =
    {field_in, 4},
  [53] =
    {field_alternative, 3},
    {field_condition, 1},
  [55] =
    {field_exception_name, 2},
  [56] =
    {field_else, 1},
  [57] =
    {field_else, 4, .inherited = true},
    {field_guard, 0, .inherited = true},
    {field_then, 2},
  [60] =
    {field_block, 3},
    {field_block, 4},
    {field_block, 5},
  [63] =
    {field_block, 2},
    {field_block, 3},
    {field_block, 4},
  [66] =
    {field_instance, 0},
    {field_method, 2},
  [68] =
    {field_block, 0},
    {field_block, 1},
    {field_block, 2},
    {field_block, 3},
  [72] =
    {field_body, 4},
  [73] =
    {field_alternative, 4},
    {field_condition, 1},
  [75] =
    {field_block, 4},
    {field_block, 5},
    {field_block, 6},
  [78] =
    {field_block, 2},
    {field_block, 3},
    {field_block, 4},
    {field_block, 5},
  [82] =
    {field_block, 3},
    {field_block, 4},
  [84] =
    {field_args, 0},
  [85] =
    {field_name, 0},
  [86] =
    {field_block, 0},
    {field_block, 1},
    {field_block, 2},
    {field_block, 3},
    {field_block, 4},
  [91] =
    {field_block, 4, .inherited = true},
  [92] =
    {field_block, 4},
    {field_guard, 2},
    {field_pattern, 0},
  [95] =
    {field_guard, 1},
    {field_then, 3},
  [97] =
    {field_block, 2},
    {field_block, 3},
    {field_block, 4},
    {field_block, 5},
    {field_block, 6},
  [102] =
    {field_block, 2},
    {field_block, 3},
    {field_block, 4},
    {field_body, 3, .inherited = true},
    {field_name, 0},
  [107] =
    {field_args, 1},
  [108] =
    {field_block, 4},
    {field_block, 5},
  [110] =
    {field_block, 5},
    {field_block, 6},
    {field_block, 7},
  [113] =
    {field_block, 1},
    {field_block, 2},
    {field_block, 3},
    {field_block, 4},
  [117] =
    {field_block, 2},
    {field_block, 3},
    {field_block, 4},
    {field_block, 5},
    {field_block, 6},
    {field_block, 7},
    {field_block, 8},
  [124] =
    {field_block, 2},
    {field_block, 3},
    {field_block, 4},
    {field_block, 5},
    {field_block, 6},
    {field_block, 7},
    {field_block, 8},
    {field_block, 9},
  [132] =
    {field_block, 3},
    {field_block, 4},
    {field_block, 5},
    {field_block, 6},
  [136] =
    {field_block, 2},
    {field_block, 3},
    {field_block, 4},
    {field_block, 5},
    {field_block, 6},
    {field_block, 7},
    {field_block, 8},
    {field_block, 9},
    {field_block, 10},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [3] = {
    [0] = alias_sym_wildcard_pattern,
  },
  [6] = {
    [0] = anon_sym_DOT2,
  },
  [8] = {
    [1] = sym_string,
  },
  [15] = {
    [1] = alias_sym_active_pattern_op_name,
  },
  [16] = {
    [0] = anon_sym_DOT2,
    [2] = anon_sym_DOT2,
  },
  [17] = {
    [0] = anon_alias_sym_SEMI,
  },
  [21] = {
    [2] = sym_string,
  },
  [44] = {
    [1] = alias_sym_active_pattern_op_name,
    [3] = alias_sym_wildcard_active_pattern_op,
  },
  [45] = {
    [0] = anon_sym_DOT2,
    [2] = anon_sym_DOT2,
    [4] = anon_sym_DOT2,
  },
  [55] = {
    [1] = alias_sym_active_pattern_op_name,
    [4] = alias_sym_wildcard_active_pattern_op,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__string_literal, 2,
    sym__string_literal,
    sym_string,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 2,
  [14] = 7,
  [15] = 12,
  [16] = 10,
  [17] = 4,
  [18] = 3,
  [19] = 8,
  [20] = 5,
  [21] = 11,
  [22] = 6,
  [23] = 9,
  [24] = 12,
  [25] = 6,
  [26] = 10,
  [27] = 11,
  [28] = 2,
  [29] = 5,
  [30] = 7,
  [31] = 9,
  [32] = 4,
  [33] = 5,
  [34] = 3,
  [35] = 6,
  [36] = 7,
  [37] = 3,
  [38] = 9,
  [39] = 8,
  [40] = 10,
  [41] = 11,
  [42] = 4,
  [43] = 12,
  [44] = 8,
  [45] = 2,
  [46] = 7,
  [47] = 11,
  [48] = 6,
  [49] = 5,
  [50] = 5,
  [51] = 9,
  [52] = 8,
  [53] = 10,
  [54] = 11,
  [55] = 12,
  [56] = 3,
  [57] = 4,
  [58] = 3,
  [59] = 2,
  [60] = 12,
  [61] = 12,
  [62] = 11,
  [63] = 8,
  [64] = 10,
  [65] = 6,
  [66] = 10,
  [67] = 9,
  [68] = 8,
  [69] = 7,
  [70] = 6,
  [71] = 4,
  [72] = 9,
  [73] = 4,
  [74] = 7,
  [75] = 5,
  [76] = 3,
  [77] = 2,
  [78] = 2,
  [79] = 11,
  [80] = 2,
  [81] = 8,
  [82] = 6,
  [83] = 6,
  [84] = 8,
  [85] = 7,
  [86] = 6,
  [87] = 3,
  [88] = 10,
  [89] = 5,
  [90] = 12,
  [91] = 9,
  [92] = 8,
  [93] = 4,
  [94] = 6,
  [95] = 8,
  [96] = 11,
  [97] = 2,
  [98] = 12,
  [99] = 7,
  [100] = 10,
  [101] = 3,
  [102] = 4,
  [103] = 5,
  [104] = 104,
  [105] = 9,
  [106] = 11,
  [107] = 10,
  [108] = 12,
  [109] = 7,
  [110] = 4,
  [111] = 9,
  [112] = 2,
  [113] = 3,
  [114] = 2,
  [115] = 5,
  [116] = 12,
  [117] = 10,
  [118] = 3,
  [119] = 5,
  [120] = 104,
  [121] = 7,
  [122] = 11,
  [123] = 9,
  [124] = 4,
  [125] = 125,
  [126] = 4,
  [127] = 5,
  [128] = 128,
  [129] = 125,
  [130] = 11,
  [131] = 131,
  [132] = 128,
  [133] = 2,
  [134] = 10,
  [135] = 128,
  [136] = 12,
  [137] = 3,
  [138] = 7,
  [139] = 9,
  [140] = 128,
  [141] = 9,
  [142] = 2,
  [143] = 10,
  [144] = 2,
  [145] = 9,
  [146] = 10,
  [147] = 147,
  [148] = 11,
  [149] = 5,
  [150] = 7,
  [151] = 7,
  [152] = 147,
  [153] = 9,
  [154] = 7,
  [155] = 10,
  [156] = 12,
  [157] = 147,
  [158] = 158,
  [159] = 159,
  [160] = 5,
  [161] = 147,
  [162] = 5,
  [163] = 147,
  [164] = 164,
  [165] = 165,
  [166] = 147,
  [167] = 147,
  [168] = 2,
  [169] = 11,
  [170] = 12,
  [171] = 5,
  [172] = 3,
  [173] = 173,
  [174] = 147,
  [175] = 175,
  [176] = 3,
  [177] = 12,
  [178] = 147,
  [179] = 11,
  [180] = 10,
  [181] = 181,
  [182] = 165,
  [183] = 3,
  [184] = 5,
  [185] = 185,
  [186] = 3,
  [187] = 7,
  [188] = 7,
  [189] = 9,
  [190] = 165,
  [191] = 10,
  [192] = 165,
  [193] = 193,
  [194] = 11,
  [195] = 147,
  [196] = 4,
  [197] = 11,
  [198] = 165,
  [199] = 12,
  [200] = 165,
  [201] = 2,
  [202] = 165,
  [203] = 9,
  [204] = 10,
  [205] = 165,
  [206] = 11,
  [207] = 207,
  [208] = 147,
  [209] = 3,
  [210] = 165,
  [211] = 12,
  [212] = 158,
  [213] = 11,
  [214] = 12,
  [215] = 165,
  [216] = 5,
  [217] = 217,
  [218] = 10,
  [219] = 147,
  [220] = 165,
  [221] = 9,
  [222] = 5,
  [223] = 2,
  [224] = 7,
  [225] = 165,
  [226] = 226,
  [227] = 3,
  [228] = 165,
  [229] = 4,
  [230] = 147,
  [231] = 165,
  [232] = 4,
  [233] = 12,
  [234] = 4,
  [235] = 175,
  [236] = 147,
  [237] = 147,
  [238] = 165,
  [239] = 3,
  [240] = 147,
  [241] = 4,
  [242] = 2,
  [243] = 165,
  [244] = 7,
  [245] = 4,
  [246] = 9,
  [247] = 4,
  [248] = 2,
  [249] = 249,
  [250] = 250,
  [251] = 193,
  [252] = 226,
  [253] = 253,
  [254] = 7,
  [255] = 255,
  [256] = 256,
  [257] = 256,
  [258] = 250,
  [259] = 259,
  [260] = 5,
  [261] = 261,
  [262] = 261,
  [263] = 263,
  [264] = 12,
  [265] = 7,
  [266] = 266,
  [267] = 267,
  [268] = 268,
  [269] = 250,
  [270] = 249,
  [271] = 256,
  [272] = 7,
  [273] = 259,
  [274] = 259,
  [275] = 7,
  [276] = 256,
  [277] = 277,
  [278] = 261,
  [279] = 250,
  [280] = 261,
  [281] = 250,
  [282] = 4,
  [283] = 256,
  [284] = 9,
  [285] = 266,
  [286] = 10,
  [287] = 267,
  [288] = 249,
  [289] = 5,
  [290] = 249,
  [291] = 11,
  [292] = 277,
  [293] = 259,
  [294] = 4,
  [295] = 5,
  [296] = 249,
  [297] = 267,
  [298] = 250,
  [299] = 261,
  [300] = 266,
  [301] = 4,
  [302] = 256,
  [303] = 256,
  [304] = 9,
  [305] = 10,
  [306] = 11,
  [307] = 259,
  [308] = 261,
  [309] = 3,
  [310] = 9,
  [311] = 250,
  [312] = 261,
  [313] = 250,
  [314] = 4,
  [315] = 9,
  [316] = 12,
  [317] = 259,
  [318] = 10,
  [319] = 5,
  [320] = 10,
  [321] = 2,
  [322] = 266,
  [323] = 259,
  [324] = 267,
  [325] = 256,
  [326] = 5,
  [327] = 249,
  [328] = 249,
  [329] = 249,
  [330] = 249,
  [331] = 249,
  [332] = 11,
  [333] = 159,
  [334] = 249,
  [335] = 249,
  [336] = 250,
  [337] = 261,
  [338] = 3,
  [339] = 266,
  [340] = 340,
  [341] = 249,
  [342] = 256,
  [343] = 249,
  [344] = 249,
  [345] = 267,
  [346] = 3,
  [347] = 249,
  [348] = 267,
  [349] = 259,
  [350] = 11,
  [351] = 249,
  [352] = 249,
  [353] = 249,
  [354] = 12,
  [355] = 261,
  [356] = 266,
  [357] = 249,
  [358] = 3,
  [359] = 359,
  [360] = 249,
  [361] = 256,
  [362] = 250,
  [363] = 249,
  [364] = 364,
  [365] = 249,
  [366] = 249,
  [367] = 249,
  [368] = 259,
  [369] = 249,
  [370] = 266,
  [371] = 4,
  [372] = 250,
  [373] = 261,
  [374] = 267,
  [375] = 249,
  [376] = 249,
  [377] = 249,
  [378] = 249,
  [379] = 256,
  [380] = 2,
  [381] = 249,
  [382] = 249,
  [383] = 5,
  [384] = 249,
  [385] = 249,
  [386] = 259,
  [387] = 259,
  [388] = 249,
  [389] = 389,
  [390] = 249,
  [391] = 249,
  [392] = 250,
  [393] = 266,
  [394] = 11,
  [395] = 10,
  [396] = 249,
  [397] = 267,
  [398] = 249,
  [399] = 249,
  [400] = 9,
  [401] = 261,
  [402] = 253,
  [403] = 2,
  [404] = 185,
  [405] = 12,
  [406] = 249,
  [407] = 256,
  [408] = 249,
  [409] = 249,
  [410] = 249,
  [411] = 411,
  [412] = 249,
  [413] = 259,
  [414] = 249,
  [415] = 250,
  [416] = 12,
  [417] = 417,
  [418] = 266,
  [419] = 267,
  [420] = 249,
  [421] = 261,
  [422] = 3,
  [423] = 249,
  [424] = 2,
  [425] = 249,
  [426] = 267,
  [427] = 427,
  [428] = 7,
  [429] = 266,
  [430] = 267,
  [431] = 249,
  [432] = 266,
  [433] = 249,
  [434] = 256,
  [435] = 435,
  [436] = 249,
  [437] = 249,
  [438] = 249,
  [439] = 266,
  [440] = 267,
  [441] = 249,
  [442] = 261,
  [443] = 259,
  [444] = 249,
  [445] = 249,
  [446] = 2,
  [447] = 249,
  [448] = 253,
  [449] = 259,
  [450] = 259,
  [451] = 266,
  [452] = 267,
  [453] = 249,
  [454] = 249,
  [455] = 250,
  [456] = 261,
  [457] = 457,
  [458] = 249,
  [459] = 263,
  [460] = 256,
  [461] = 266,
  [462] = 267,
  [463] = 249,
  [464] = 249,
  [465] = 249,
  [466] = 267,
  [467] = 266,
  [468] = 249,
  [469] = 12,
  [470] = 249,
  [471] = 3,
  [472] = 266,
  [473] = 267,
  [474] = 249,
  [475] = 250,
  [476] = 249,
  [477] = 261,
  [478] = 259,
  [479] = 249,
  [480] = 7,
  [481] = 249,
  [482] = 261,
  [483] = 249,
  [484] = 249,
  [485] = 261,
  [486] = 249,
  [487] = 256,
  [488] = 249,
  [489] = 261,
  [490] = 249,
  [491] = 256,
  [492] = 249,
  [493] = 249,
  [494] = 249,
  [495] = 249,
  [496] = 256,
  [497] = 4,
  [498] = 9,
  [499] = 261,
  [500] = 249,
  [501] = 10,
  [502] = 250,
  [503] = 2,
  [504] = 249,
  [505] = 11,
  [506] = 249,
  [507] = 457,
  [508] = 508,
  [509] = 508,
  [510] = 508,
  [511] = 511,
  [512] = 511,
  [513] = 511,
  [514] = 511,
  [515] = 508,
  [516] = 511,
  [517] = 508,
  [518] = 511,
  [519] = 511,
  [520] = 508,
  [521] = 508,
  [522] = 508,
  [523] = 511,
  [524] = 511,
  [525] = 508,
  [526] = 508,
  [527] = 511,
  [528] = 511,
  [529] = 508,
  [530] = 508,
  [531] = 508,
  [532] = 511,
  [533] = 511,
  [534] = 511,
  [535] = 508,
  [536] = 511,
  [537] = 508,
  [538] = 508,
  [539] = 511,
  [540] = 540,
  [541] = 540,
  [542] = 540,
  [543] = 540,
  [544] = 544,
  [545] = 545,
  [546] = 546,
  [547] = 547,
  [548] = 548,
  [549] = 549,
  [550] = 550,
  [551] = 551,
  [552] = 552,
  [553] = 553,
  [554] = 554,
  [555] = 555,
  [556] = 544,
  [557] = 557,
  [558] = 558,
  [559] = 559,
  [560] = 560,
  [561] = 561,
  [562] = 561,
  [563] = 563,
  [564] = 559,
  [565] = 563,
  [566] = 560,
  [567] = 560,
  [568] = 563,
  [569] = 559,
  [570] = 561,
  [571] = 561,
  [572] = 563,
  [573] = 560,
  [574] = 559,
  [575] = 575,
  [576] = 576,
  [577] = 577,
  [578] = 578,
  [579] = 579,
  [580] = 580,
  [581] = 581,
  [582] = 580,
  [583] = 580,
  [584] = 584,
  [585] = 584,
  [586] = 584,
  [587] = 584,
  [588] = 584,
  [589] = 584,
  [590] = 584,
  [591] = 584,
  [592] = 584,
  [593] = 584,
  [594] = 581,
  [595] = 584,
  [596] = 584,
  [597] = 584,
  [598] = 584,
  [599] = 584,
  [600] = 584,
  [601] = 601,
  [602] = 601,
  [603] = 603,
  [604] = 603,
  [605] = 601,
  [606] = 601,
  [607] = 603,
  [608] = 603,
  [609] = 609,
  [610] = 601,
  [611] = 609,
  [612] = 609,
  [613] = 609,
  [614] = 603,
  [615] = 609,
  [616] = 609,
  [617] = 609,
  [618] = 601,
  [619] = 601,
  [620] = 603,
  [621] = 601,
  [622] = 603,
  [623] = 609,
  [624] = 601,
  [625] = 609,
  [626] = 603,
  [627] = 609,
  [628] = 609,
  [629] = 601,
  [630] = 601,
  [631] = 603,
  [632] = 601,
  [633] = 609,
  [634] = 601,
  [635] = 603,
  [636] = 601,
  [637] = 603,
  [638] = 601,
  [639] = 603,
  [640] = 601,
  [641] = 603,
  [642] = 603,
  [643] = 609,
  [644] = 609,
  [645] = 603,
  [646] = 603,
  [647] = 609,
  [648] = 609,
  [649] = 649,
  [650] = 650,
  [651] = 649,
  [652] = 650,
  [653] = 650,
  [654] = 650,
  [655] = 650,
  [656] = 650,
  [657] = 657,
  [658] = 650,
  [659] = 650,
  [660] = 650,
  [661] = 650,
  [662] = 650,
  [663] = 650,
  [664] = 650,
  [665] = 650,
  [666] = 650,
  [667] = 650,
  [668] = 668,
  [669] = 668,
  [670] = 668,
  [671] = 668,
  [672] = 668,
  [673] = 668,
  [674] = 668,
  [675] = 668,
  [676] = 668,
  [677] = 668,
  [678] = 657,
  [679] = 668,
  [680] = 668,
  [681] = 668,
  [682] = 668,
  [683] = 683,
  [684] = 668,
  [685] = 668,
  [686] = 686,
  [687] = 581,
  [688] = 688,
  [689] = 581,
  [690] = 690,
  [691] = 690,
  [692] = 692,
  [693] = 693,
  [694] = 694,
  [695] = 694,
  [696] = 693,
  [697] = 694,
  [698] = 693,
  [699] = 692,
  [700] = 694,
  [701] = 693,
  [702] = 692,
  [703] = 692,
  [704] = 694,
  [705] = 694,
  [706] = 693,
  [707] = 694,
  [708] = 692,
  [709] = 694,
  [710] = 694,
  [711] = 692,
  [712] = 694,
  [713] = 693,
  [714] = 714,
  [715] = 692,
  [716] = 692,
  [717] = 692,
  [718] = 693,
  [719] = 693,
  [720] = 692,
  [721] = 694,
  [722] = 694,
  [723] = 693,
  [724] = 692,
  [725] = 694,
  [726] = 692,
  [727] = 692,
  [728] = 692,
  [729] = 693,
  [730] = 693,
  [731] = 692,
  [732] = 694,
  [733] = 693,
  [734] = 694,
  [735] = 693,
  [736] = 694,
  [737] = 714,
  [738] = 694,
  [739] = 694,
  [740] = 694,
  [741] = 694,
  [742] = 693,
  [743] = 692,
  [744] = 694,
  [745] = 692,
  [746] = 693,
  [747] = 581,
  [748] = 693,
  [749] = 692,
  [750] = 694,
  [751] = 694,
  [752] = 694,
  [753] = 694,
  [754] = 692,
  [755] = 755,
  [756] = 755,
  [757] = 757,
  [758] = 758,
  [759] = 759,
  [760] = 760,
  [761] = 755,
  [762] = 762,
  [763] = 763,
  [764] = 764,
  [765] = 765,
  [766] = 766,
  [767] = 767,
  [768] = 768,
  [769] = 769,
  [770] = 757,
  [771] = 758,
  [772] = 772,
  [773] = 772,
  [774] = 757,
  [775] = 775,
  [776] = 776,
  [777] = 766,
  [778] = 778,
  [779] = 769,
  [780] = 778,
  [781] = 759,
  [782] = 782,
  [783] = 760,
  [784] = 760,
  [785] = 772,
  [786] = 755,
  [787] = 762,
  [788] = 764,
  [789] = 789,
  [790] = 766,
  [791] = 763,
  [792] = 792,
  [793] = 776,
  [794] = 767,
  [795] = 764,
  [796] = 789,
  [797] = 782,
  [798] = 762,
  [799] = 757,
  [800] = 800,
  [801] = 755,
  [802] = 765,
  [803] = 768,
  [804] = 766,
  [805] = 805,
  [806] = 768,
  [807] = 782,
  [808] = 755,
  [809] = 762,
  [810] = 764,
  [811] = 772,
  [812] = 778,
  [813] = 767,
  [814] = 782,
  [815] = 766,
  [816] = 816,
  [817] = 778,
  [818] = 764,
  [819] = 766,
  [820] = 762,
  [821] = 765,
  [822] = 755,
  [823] = 763,
  [824] = 764,
  [825] = 762,
  [826] = 766,
  [827] = 789,
  [828] = 763,
  [829] = 782,
  [830] = 772,
  [831] = 766,
  [832] = 758,
  [833] = 833,
  [834] = 757,
  [835] = 835,
  [836] = 805,
  [837] = 760,
  [838] = 772,
  [839] = 764,
  [840] = 762,
  [841] = 755,
  [842] = 766,
  [843] = 766,
  [844] = 772,
  [845] = 760,
  [846] = 758,
  [847] = 759,
  [848] = 766,
  [849] = 766,
  [850] = 760,
  [851] = 755,
  [852] = 766,
  [853] = 763,
  [854] = 762,
  [855] = 764,
  [856] = 776,
  [857] = 766,
  [858] = 763,
  [859] = 772,
  [860] = 764,
  [861] = 757,
  [862] = 762,
  [863] = 755,
  [864] = 767,
  [865] = 767,
  [866] = 760,
  [867] = 768,
  [868] = 764,
  [869] = 762,
  [870] = 755,
  [871] = 768,
  [872] = 772,
  [873] = 772,
  [874] = 764,
  [875] = 762,
  [876] = 755,
  [877] = 757,
  [878] = 760,
  [879] = 766,
  [880] = 757,
  [881] = 764,
  [882] = 762,
  [883] = 755,
  [884] = 763,
  [885] = 767,
  [886] = 768,
  [887] = 776,
  [888] = 772,
  [889] = 767,
  [890] = 776,
  [891] = 768,
  [892] = 835,
  [893] = 767,
  [894] = 833,
  [895] = 772,
  [896] = 763,
  [897] = 768,
  [898] = 757,
  [899] = 766,
  [900] = 768,
  [901] = 901,
  [902] = 764,
  [903] = 763,
  [904] = 768,
  [905] = 789,
  [906] = 762,
  [907] = 767,
  [908] = 755,
  [909] = 835,
  [910] = 757,
  [911] = 765,
  [912] = 768,
  [913] = 768,
  [914] = 835,
  [915] = 772,
  [916] = 835,
  [917] = 764,
  [918] = 762,
  [919] = 919,
  [920] = 755,
  [921] = 763,
  [922] = 816,
  [923] = 764,
  [924] = 762,
  [925] = 755,
  [926] = 835,
  [927] = 755,
  [928] = 760,
  [929] = 835,
  [930] = 767,
  [931] = 764,
  [932] = 762,
  [933] = 755,
  [934] = 776,
  [935] = 768,
  [936] = 776,
  [937] = 757,
  [938] = 776,
  [939] = 835,
  [940] = 776,
  [941] = 835,
  [942] = 776,
  [943] = 755,
  [944] = 776,
  [945] = 767,
  [946] = 776,
  [947] = 755,
  [948] = 755,
  [949] = 776,
  [950] = 835,
  [951] = 763,
  [952] = 835,
  [953] = 760,
  [954] = 835,
  [955] = 782,
  [956] = 776,
  [957] = 767,
  [958] = 835,
  [959] = 767,
  [960] = 835,
  [961] = 763,
  [962] = 755,
  [963] = 755,
  [964] = 760,
  [965] = 755,
  [966] = 763,
  [967] = 755,
  [968] = 755,
  [969] = 755,
  [970] = 835,
  [971] = 755,
  [972] = 760,
  [973] = 755,
  [974] = 765,
  [975] = 768,
  [976] = 755,
  [977] = 778,
  [978] = 776,
  [979] = 767,
  [980] = 765,
  [981] = 763,
  [982] = 755,
  [983] = 755,
  [984] = 759,
  [985] = 755,
  [986] = 755,
  [987] = 755,
  [988] = 763,
  [989] = 755,
  [990] = 758,
  [991] = 789,
  [992] = 782,
  [993] = 993,
  [994] = 778,
  [995] = 755,
  [996] = 755,
  [997] = 767,
  [998] = 765,
  [999] = 775,
  [1000] = 835,
  [1001] = 778,
  [1002] = 776,
  [1003] = 782,
  [1004] = 778,
  [1005] = 755,
  [1006] = 755,
  [1007] = 765,
  [1008] = 755,
  [1009] = 765,
  [1010] = 755,
  [1011] = 789,
  [1012] = 755,
  [1013] = 757,
  [1014] = 755,
  [1015] = 755,
  [1016] = 755,
  [1017] = 789,
  [1018] = 768,
  [1019] = 755,
  [1020] = 776,
  [1021] = 755,
  [1022] = 776,
  [1023] = 778,
  [1024] = 755,
  [1025] = 755,
  [1026] = 760,
  [1027] = 782,
  [1028] = 757,
  [1029] = 755,
  [1030] = 755,
  [1031] = 778,
  [1032] = 1032,
  [1033] = 760,
  [1034] = 755,
  [1035] = 765,
  [1036] = 782,
  [1037] = 755,
  [1038] = 755,
  [1039] = 789,
  [1040] = 782,
  [1041] = 778,
  [1042] = 765,
  [1043] = 759,
  [1044] = 758,
  [1045] = 776,
  [1046] = 757,
  [1047] = 772,
  [1048] = 768,
  [1049] = 767,
  [1050] = 763,
  [1051] = 765,
  [1052] = 755,
  [1053] = 763,
  [1054] = 760,
  [1055] = 759,
  [1056] = 760,
  [1057] = 767,
  [1058] = 789,
  [1059] = 755,
  [1060] = 772,
  [1061] = 758,
  [1062] = 755,
  [1063] = 759,
  [1064] = 768,
  [1065] = 757,
  [1066] = 763,
  [1067] = 789,
  [1068] = 755,
  [1069] = 767,
  [1070] = 768,
  [1071] = 755,
  [1072] = 755,
  [1073] = 755,
  [1074] = 760,
  [1075] = 782,
  [1076] = 776,
  [1077] = 757,
  [1078] = 772,
  [1079] = 768,
  [1080] = 767,
  [1081] = 755,
  [1082] = 763,
  [1083] = 1083,
  [1084] = 760,
  [1085] = 759,
  [1086] = 772,
  [1087] = 758,
  [1088] = 778,
  [1089] = 765,
  [1090] = 763,
  [1091] = 755,
  [1092] = 755,
  [1093] = 763,
  [1094] = 755,
  [1095] = 757,
  [1096] = 767,
  [1097] = 789,
  [1098] = 767,
  [1099] = 760,
  [1100] = 763,
  [1101] = 767,
  [1102] = 755,
  [1103] = 755,
  [1104] = 768,
  [1105] = 772,
  [1106] = 755,
  [1107] = 901,
  [1108] = 755,
  [1109] = 757,
  [1110] = 755,
  [1111] = 755,
  [1112] = 755,
  [1113] = 776,
  [1114] = 757,
  [1115] = 772,
  [1116] = 768,
  [1117] = 755,
  [1118] = 767,
  [1119] = 755,
  [1120] = 755,
  [1121] = 763,
  [1122] = 760,
  [1123] = 759,
  [1124] = 758,
  [1125] = 755,
  [1126] = 776,
  [1127] = 755,
  [1128] = 782,
  [1129] = 1129,
  [1130] = 772,
  [1131] = 768,
  [1132] = 755,
  [1133] = 778,
  [1134] = 768,
  [1135] = 765,
  [1136] = 772,
  [1137] = 789,
  [1138] = 755,
  [1139] = 755,
  [1140] = 772,
  [1141] = 782,
  [1142] = 778,
  [1143] = 757,
  [1144] = 755,
  [1145] = 765,
  [1146] = 782,
  [1147] = 789,
  [1148] = 782,
  [1149] = 776,
  [1150] = 758,
  [1151] = 776,
  [1152] = 757,
  [1153] = 772,
  [1154] = 768,
  [1155] = 757,
  [1156] = 772,
  [1157] = 759,
  [1158] = 789,
  [1159] = 767,
  [1160] = 765,
  [1161] = 763,
  [1162] = 778,
  [1163] = 760,
  [1164] = 759,
  [1165] = 758,
  [1166] = 760,
  [1167] = 763,
  [1168] = 789,
  [1169] = 778,
  [1170] = 789,
  [1171] = 767,
  [1172] = 768,
  [1173] = 765,
  [1174] = 760,
  [1175] = 757,
  [1176] = 772,
  [1177] = 757,
  [1178] = 776,
  [1179] = 760,
  [1180] = 760,
  [1181] = 757,
  [1182] = 1182,
  [1183] = 1182,
  [1184] = 1184,
  [1185] = 1184,
  [1186] = 1182,
  [1187] = 1182,
  [1188] = 1182,
  [1189] = 1182,
  [1190] = 1182,
  [1191] = 1184,
  [1192] = 1184,
  [1193] = 1182,
  [1194] = 1194,
  [1195] = 1195,
  [1196] = 1184,
  [1197] = 1197,
  [1198] = 1198,
  [1199] = 1184,
  [1200] = 1184,
  [1201] = 1201,
  [1202] = 1184,
  [1203] = 1203,
  [1204] = 1204,
  [1205] = 1205,
  [1206] = 1206,
  [1207] = 1207,
  [1208] = 1208,
  [1209] = 1209,
  [1210] = 1210,
  [1211] = 1211,
  [1212] = 1212,
  [1213] = 1213,
  [1214] = 1214,
  [1215] = 1215,
  [1216] = 1216,
  [1217] = 1217,
  [1218] = 1218,
  [1219] = 1219,
  [1220] = 1220,
  [1221] = 1221,
  [1222] = 1222,
  [1223] = 1223,
  [1224] = 1224,
  [1225] = 1225,
  [1226] = 1226,
  [1227] = 1227,
  [1228] = 1228,
  [1229] = 1229,
  [1230] = 1230,
  [1231] = 1182,
  [1232] = 1198,
  [1233] = 1201,
  [1234] = 1182,
  [1235] = 1197,
  [1236] = 1236,
  [1237] = 1194,
  [1238] = 1197,
  [1239] = 1195,
  [1240] = 1201,
  [1241] = 1194,
  [1242] = 1198,
  [1243] = 1182,
  [1244] = 1195,
  [1245] = 1245,
  [1246] = 1198,
  [1247] = 1184,
  [1248] = 1198,
  [1249] = 1249,
  [1250] = 1250,
  [1251] = 1195,
  [1252] = 1252,
  [1253] = 1253,
  [1254] = 1201,
  [1255] = 1197,
  [1256] = 1201,
  [1257] = 1198,
  [1258] = 1197,
  [1259] = 1197,
  [1260] = 1194,
  [1261] = 1184,
  [1262] = 1262,
  [1263] = 1197,
  [1264] = 1198,
  [1265] = 1201,
  [1266] = 1194,
  [1267] = 1267,
  [1268] = 1268,
  [1269] = 1269,
  [1270] = 1194,
  [1271] = 1195,
  [1272] = 1253,
  [1273] = 1195,
  [1274] = 1274,
  [1275] = 1195,
  [1276] = 1276,
  [1277] = 1201,
  [1278] = 1278,
  [1279] = 1279,
  [1280] = 1194,
  [1281] = 1281,
  [1282] = 1282,
  [1283] = 1207,
  [1284] = 1204,
  [1285] = 1285,
  [1286] = 1286,
  [1287] = 1287,
  [1288] = 1288,
  [1289] = 1211,
  [1290] = 1212,
  [1291] = 1210,
  [1292] = 1206,
  [1293] = 1203,
  [1294] = 1253,
  [1295] = 1295,
  [1296] = 1205,
  [1297] = 1208,
  [1298] = 1203,
  [1299] = 1210,
  [1300] = 1209,
  [1301] = 1301,
  [1302] = 1208,
  [1303] = 1203,
  [1304] = 1210,
  [1305] = 1207,
  [1306] = 1306,
  [1307] = 1209,
  [1308] = 1205,
  [1309] = 1212,
  [1310] = 1184,
  [1311] = 1311,
  [1312] = 1204,
  [1313] = 1206,
  [1314] = 1211,
  [1315] = 1315,
  [1316] = 1225,
  [1317] = 1317,
  [1318] = 1204,
  [1319] = 1209,
  [1320] = 1320,
  [1321] = 1227,
  [1322] = 1322,
  [1323] = 1323,
  [1324] = 1207,
  [1325] = 1230,
  [1326] = 1226,
  [1327] = 1327,
  [1328] = 1203,
  [1329] = 1329,
  [1330] = 1220,
  [1331] = 1225,
  [1332] = 1332,
  [1333] = 1333,
  [1334] = 1334,
  [1335] = 1205,
  [1336] = 1336,
  [1337] = 1227,
  [1338] = 1338,
  [1339] = 1219,
  [1340] = 1286,
  [1341] = 1205,
  [1342] = 1342,
  [1343] = 1343,
  [1344] = 1213,
  [1345] = 1345,
  [1346] = 1346,
  [1347] = 1347,
  [1348] = 1215,
  [1349] = 1205,
  [1350] = 1350,
  [1351] = 1351,
  [1352] = 1281,
  [1353] = 1228,
  [1354] = 1222,
  [1355] = 1355,
  [1356] = 1356,
  [1357] = 1357,
  [1358] = 1358,
  [1359] = 1359,
  [1360] = 1224,
  [1361] = 1206,
  [1362] = 1221,
  [1363] = 1206,
  [1364] = 1211,
  [1365] = 1365,
  [1366] = 1366,
  [1367] = 1203,
  [1368] = 1368,
  [1369] = 1369,
  [1370] = 1208,
  [1371] = 1371,
  [1372] = 1372,
  [1373] = 1218,
  [1374] = 1374,
  [1375] = 1210,
  [1376] = 1376,
  [1377] = 1208,
  [1378] = 1216,
  [1379] = 1379,
  [1380] = 1380,
  [1381] = 1205,
  [1382] = 1382,
  [1383] = 1383,
  [1384] = 1182,
  [1385] = 1385,
  [1386] = 1210,
  [1387] = 1209,
  [1388] = 1229,
  [1389] = 1214,
  [1390] = 1390,
  [1391] = 1203,
  [1392] = 1207,
  [1393] = 1393,
  [1394] = 1394,
  [1395] = 1395,
  [1396] = 1396,
  [1397] = 1209,
  [1398] = 1398,
  [1399] = 1207,
  [1400] = 1212,
  [1401] = 1401,
  [1402] = 1402,
  [1403] = 1403,
  [1404] = 1404,
  [1405] = 1223,
  [1406] = 1211,
  [1407] = 1407,
  [1408] = 1408,
  [1409] = 1409,
  [1410] = 1229,
  [1411] = 1221,
  [1412] = 1217,
  [1413] = 1413,
  [1414] = 1208,
  [1415] = 1206,
  [1416] = 1210,
  [1417] = 1216,
  [1418] = 1218,
  [1419] = 1419,
  [1420] = 1212,
  [1421] = 1212,
  [1422] = 1203,
  [1423] = 1423,
  [1424] = 1424,
  [1425] = 1219,
  [1426] = 1220,
  [1427] = 1214,
  [1428] = 1210,
  [1429] = 1429,
  [1430] = 1211,
  [1431] = 1431,
  [1432] = 1221,
  [1433] = 1217,
  [1434] = 1230,
  [1435] = 1208,
  [1436] = 1226,
  [1437] = 1204,
  [1438] = 1438,
  [1439] = 1439,
  [1440] = 1213,
  [1441] = 1215,
  [1442] = 1442,
  [1443] = 1443,
  [1444] = 1228,
  [1445] = 1222,
  [1446] = 1223,
  [1447] = 1447,
  [1448] = 1224,
  [1449] = 1212,
  [1450] = 1450,
  [1451] = 1451,
  [1452] = 1452,
  [1453] = 1209,
  [1454] = 1454,
  [1455] = 1455,
  [1456] = 1456,
  [1457] = 1457,
  [1458] = 1458,
  [1459] = 1459,
  [1460] = 1206,
  [1461] = 1204,
  [1462] = 1462,
  [1463] = 1463,
  [1464] = 1464,
  [1465] = 1465,
  [1466] = 1211,
  [1467] = 1207,
  [1468] = 1468,
  [1469] = 1469,
  [1470] = 1204,
  [1471] = 1230,
  [1472] = 1226,
  [1473] = 1182,
  [1474] = 1236,
  [1475] = 1218,
  [1476] = 1218,
  [1477] = 1219,
  [1478] = 1219,
  [1479] = 1220,
  [1480] = 1227,
  [1481] = 1222,
  [1482] = 1219,
  [1483] = 1229,
  [1484] = 1222,
  [1485] = 1220,
  [1486] = 1216,
  [1487] = 1230,
  [1488] = 1226,
  [1489] = 1182,
  [1490] = 1214,
  [1491] = 1230,
  [1492] = 1226,
  [1493] = 1216,
  [1494] = 1226,
  [1495] = 1229,
  [1496] = 1182,
  [1497] = 1213,
  [1498] = 1221,
  [1499] = 1229,
  [1500] = 1215,
  [1501] = 1213,
  [1502] = 1217,
  [1503] = 1228,
  [1504] = 1214,
  [1505] = 1222,
  [1506] = 1223,
  [1507] = 1225,
  [1508] = 1221,
  [1509] = 1224,
  [1510] = 1182,
  [1511] = 1214,
  [1512] = 1225,
  [1513] = 1215,
  [1514] = 1214,
  [1515] = 1228,
  [1516] = 1227,
  [1517] = 1221,
  [1518] = 1213,
  [1519] = 1225,
  [1520] = 1217,
  [1521] = 1224,
  [1522] = 1225,
  [1523] = 1182,
  [1524] = 1223,
  [1525] = 1216,
  [1526] = 1215,
  [1527] = 1228,
  [1528] = 1217,
  [1529] = 1227,
  [1530] = 1236,
  [1531] = 1182,
  [1532] = 1224,
  [1533] = 1218,
  [1534] = 1229,
  [1535] = 1230,
  [1536] = 1223,
  [1537] = 1222,
  [1538] = 1228,
  [1539] = 1218,
  [1540] = 1213,
  [1541] = 1220,
  [1542] = 1221,
  [1543] = 1224,
  [1544] = 1227,
  [1545] = 1217,
  [1546] = 1220,
  [1547] = 1216,
  [1548] = 1182,
  [1549] = 1223,
  [1550] = 1215,
  [1551] = 1219,
  [1552] = 1267,
  [1553] = 1245,
  [1554] = 1182,
  [1555] = 1249,
  [1556] = 1249,
  [1557] = 1274,
  [1558] = 1245,
  [1559] = 1262,
  [1560] = 1276,
  [1561] = 1236,
  [1562] = 1279,
  [1563] = 1253,
  [1564] = 1182,
  [1565] = 1236,
  [1566] = 1250,
  [1567] = 1278,
  [1568] = 1267,
  [1569] = 1269,
  [1570] = 1250,
  [1571] = 1278,
  [1572] = 1182,
  [1573] = 1184,
  [1574] = 1253,
  [1575] = 1182,
  [1576] = 1274,
  [1577] = 1262,
  [1578] = 1253,
  [1579] = 1236,
  [1580] = 1252,
  [1581] = 1276,
  [1582] = 1268,
  [1583] = 1279,
  [1584] = 1268,
  [1585] = 1269,
  [1586] = 1182,
  [1587] = 1184,
  [1588] = 1253,
  [1589] = 1182,
  [1590] = 1252,
  [1591] = 1253,
  [1592] = 1267,
  [1593] = 1236,
  [1594] = 1281,
  [1595] = 1279,
  [1596] = 1267,
  [1597] = 1253,
  [1598] = 1267,
  [1599] = 1249,
  [1600] = 1276,
  [1601] = 1195,
  [1602] = 1269,
  [1603] = 1210,
  [1604] = 1278,
  [1605] = 1184,
  [1606] = 1268,
  [1607] = 1301,
  [1608] = 1245,
  [1609] = 1279,
  [1610] = 1195,
  [1611] = 1201,
  [1612] = 1245,
  [1613] = 1268,
  [1614] = 1269,
  [1615] = 1282,
  [1616] = 1311,
  [1617] = 1306,
  [1618] = 1184,
  [1619] = 1276,
  [1620] = 1288,
  [1621] = 1249,
  [1622] = 1250,
  [1623] = 1276,
  [1624] = 1245,
  [1625] = 1285,
  [1626] = 1287,
  [1627] = 1295,
  [1628] = 1210,
  [1629] = 1252,
  [1630] = 1245,
  [1631] = 1295,
  [1632] = 1276,
  [1633] = 1274,
  [1634] = 1286,
  [1635] = 1282,
  [1636] = 1268,
  [1637] = 1194,
  [1638] = 1252,
  [1639] = 1203,
  [1640] = 1269,
  [1641] = 1285,
  [1642] = 1262,
  [1643] = 1301,
  [1644] = 1253,
  [1645] = 1197,
  [1646] = 1184,
  [1647] = 1253,
  [1648] = 1253,
  [1649] = 1262,
  [1650] = 1281,
  [1651] = 1274,
  [1652] = 1286,
  [1653] = 1194,
  [1654] = 1197,
  [1655] = 1253,
  [1656] = 1262,
  [1657] = 1201,
  [1658] = 1198,
  [1659] = 1198,
  [1660] = 1306,
  [1661] = 1274,
  [1662] = 1184,
  [1663] = 1250,
  [1664] = 1311,
  [1665] = 1253,
  [1666] = 1252,
  [1667] = 1262,
  [1668] = 1249,
  [1669] = 1288,
  [1670] = 1278,
  [1671] = 1253,
  [1672] = 1253,
  [1673] = 1253,
  [1674] = 1278,
  [1675] = 1274,
  [1676] = 1252,
  [1677] = 1278,
  [1678] = 1203,
  [1679] = 1279,
  [1680] = 1287,
  [1681] = 1250,
  [1682] = 1249,
  [1683] = 1408,
  [1684] = 1442,
  [1685] = 1203,
  [1686] = 1447,
  [1687] = 1454,
  [1688] = 1455,
  [1689] = 1465,
  [1690] = 1464,
  [1691] = 1463,
  [1692] = 1458,
  [1693] = 1221,
  [1694] = 1451,
  [1695] = 1210,
  [1696] = 1288,
  [1697] = 1333,
  [1698] = 1287,
  [1699] = 1287,
  [1700] = 1250,
  [1701] = 1282,
  [1702] = 1184,
  [1703] = 1459,
  [1704] = 1469,
  [1705] = 1282,
  [1706] = 1281,
  [1707] = 1281,
  [1708] = 1311,
  [1709] = 1457,
  [1710] = 1456,
  [1711] = 1452,
  [1712] = 1306,
  [1713] = 1301,
  [1714] = 1285,
  [1715] = 1329,
  [1716] = 1450,
  [1717] = 1301,
  [1718] = 1401,
  [1719] = 1424,
  [1720] = 1442,
  [1721] = 1423,
  [1722] = 1439,
  [1723] = 1372,
  [1724] = 1371,
  [1725] = 1369,
  [1726] = 1368,
  [1727] = 1295,
  [1728] = 1323,
  [1729] = 1431,
  [1730] = 1359,
  [1731] = 1443,
  [1732] = 1343,
  [1733] = 1350,
  [1734] = 1346,
  [1735] = 1379,
  [1736] = 1380,
  [1737] = 1383,
  [1738] = 1393,
  [1739] = 1383,
  [1740] = 1380,
  [1741] = 1342,
  [1742] = 1393,
  [1743] = 1447,
  [1744] = 1338,
  [1745] = 1379,
  [1746] = 1336,
  [1747] = 1439,
  [1748] = 1468,
  [1749] = 1429,
  [1750] = 1468,
  [1751] = 1334,
  [1752] = 1327,
  [1753] = 1184,
  [1754] = 1401,
  [1755] = 1322,
  [1756] = 1320,
  [1757] = 1465,
  [1758] = 1464,
  [1759] = 1454,
  [1760] = 1210,
  [1761] = 1463,
  [1762] = 1438,
  [1763] = 1394,
  [1764] = 1457,
  [1765] = 1282,
  [1766] = 1456,
  [1767] = 1452,
  [1768] = 1451,
  [1769] = 1203,
  [1770] = 1450,
  [1771] = 1424,
  [1772] = 1423,
  [1773] = 1372,
  [1774] = 1419,
  [1775] = 1366,
  [1776] = 1371,
  [1777] = 1369,
  [1778] = 1295,
  [1779] = 1285,
  [1780] = 1301,
  [1781] = 1253,
  [1782] = 1203,
  [1783] = 1221,
  [1784] = 1210,
  [1785] = 1368,
  [1786] = 1253,
  [1787] = 1343,
  [1788] = 1286,
  [1789] = 1286,
  [1790] = 1287,
  [1791] = 1455,
  [1792] = 1253,
  [1793] = 1210,
  [1794] = 1359,
  [1795] = 1203,
  [1796] = 1350,
  [1797] = 1346,
  [1798] = 1342,
  [1799] = 1184,
  [1800] = 1336,
  [1801] = 1306,
  [1802] = 1253,
  [1803] = 1458,
  [1804] = 1334,
  [1805] = 1338,
  [1806] = 1322,
  [1807] = 1320,
  [1808] = 1311,
  [1809] = 1419,
  [1810] = 1390,
  [1811] = 1413,
  [1812] = 1332,
  [1813] = 1347,
  [1814] = 1355,
  [1815] = 1281,
  [1816] = 1356,
  [1817] = 1357,
  [1818] = 1333,
  [1819] = 1358,
  [1820] = 1462,
  [1821] = 1409,
  [1822] = 1459,
  [1823] = 1253,
  [1824] = 1327,
  [1825] = 1469,
  [1826] = 1408,
  [1827] = 1407,
  [1828] = 1404,
  [1829] = 1403,
  [1830] = 1398,
  [1831] = 1396,
  [1832] = 1395,
  [1833] = 1287,
  [1834] = 1282,
  [1835] = 1385,
  [1836] = 1382,
  [1837] = 1315,
  [1838] = 1376,
  [1839] = 1295,
  [1840] = 1285,
  [1841] = 1374,
  [1842] = 1301,
  [1843] = 1402,
  [1844] = 1317,
  [1845] = 1345,
  [1846] = 1184,
  [1847] = 1351,
  [1848] = 1438,
  [1849] = 1365,
  [1850] = 1365,
  [1851] = 1351,
  [1852] = 1394,
  [1853] = 1345,
  [1854] = 1374,
  [1855] = 1443,
  [1856] = 1431,
  [1857] = 1429,
  [1858] = 1317,
  [1859] = 1402,
  [1860] = 1376,
  [1861] = 1288,
  [1862] = 1184,
  [1863] = 1268,
  [1864] = 1306,
  [1865] = 1269,
  [1866] = 1382,
  [1867] = 1385,
  [1868] = 1395,
  [1869] = 1396,
  [1870] = 1398,
  [1871] = 1286,
  [1872] = 1323,
  [1873] = 1403,
  [1874] = 1288,
  [1875] = 1366,
  [1876] = 1390,
  [1877] = 1404,
  [1878] = 1407,
  [1879] = 1409,
  [1880] = 1315,
  [1881] = 1462,
  [1882] = 1329,
  [1883] = 1358,
  [1884] = 1357,
  [1885] = 1311,
  [1886] = 1356,
  [1887] = 1311,
  [1888] = 1306,
  [1889] = 1285,
  [1890] = 1288,
  [1891] = 1279,
  [1892] = 1355,
  [1893] = 1267,
  [1894] = 1295,
  [1895] = 1347,
  [1896] = 1332,
  [1897] = 1413,
  [1898] = 1374,
  [1899] = 1459,
  [1900] = 1382,
  [1901] = 1385,
  [1902] = 1395,
  [1903] = 1396,
  [1904] = 1369,
  [1905] = 1371,
  [1906] = 1394,
  [1907] = 1374,
  [1908] = 1398,
  [1909] = 1365,
  [1910] = 1351,
  [1911] = 1403,
  [1912] = 1404,
  [1913] = 1372,
  [1914] = 1407,
  [1915] = 1408,
  [1916] = 1423,
  [1917] = 1409,
  [1918] = 1462,
  [1919] = 1345,
  [1920] = 1358,
  [1921] = 1208,
  [1922] = 1357,
  [1923] = 1317,
  [1924] = 1438,
  [1925] = 1402,
  [1926] = 1424,
  [1927] = 1429,
  [1928] = 1401,
  [1929] = 1402,
  [1930] = 1317,
  [1931] = 1431,
  [1932] = 1401,
  [1933] = 1443,
  [1934] = 1454,
  [1935] = 1447,
  [1936] = 1345,
  [1937] = 1351,
  [1938] = 1356,
  [1939] = 1355,
  [1940] = 1469,
  [1941] = 1347,
  [1942] = 1454,
  [1943] = 1332,
  [1944] = 1329,
  [1945] = 1413,
  [1946] = 1320,
  [1947] = 1343,
  [1948] = 1455,
  [1949] = 1458,
  [1950] = 1379,
  [1951] = 1469,
  [1952] = 1459,
  [1953] = 1401,
  [1954] = 1365,
  [1955] = 1374,
  [1956] = 1376,
  [1957] = 1203,
  [1958] = 1315,
  [1959] = 1380,
  [1960] = 1382,
  [1961] = 1383,
  [1962] = 1385,
  [1963] = 1395,
  [1964] = 1419,
  [1965] = 1393,
  [1966] = 1396,
  [1967] = 1398,
  [1968] = 1333,
  [1969] = 1390,
  [1970] = 1322,
  [1971] = 1327,
  [1972] = 1207,
  [1973] = 1334,
  [1974] = 1211,
  [1975] = 1210,
  [1976] = 1336,
  [1977] = 1338,
  [1978] = 1323,
  [1979] = 1394,
  [1980] = 1210,
  [1981] = 1209,
  [1982] = 1333,
  [1983] = 1450,
  [1984] = 1451,
  [1985] = 1342,
  [1986] = 1346,
  [1987] = 1350,
  [1988] = 1359,
  [1989] = 1368,
  [1990] = 1369,
  [1991] = 1371,
  [1992] = 1372,
  [1993] = 1423,
  [1994] = 1452,
  [1995] = 1424,
  [1996] = 1329,
  [1997] = 1450,
  [1998] = 1451,
  [1999] = 1452,
  [2000] = 1456,
  [2001] = 1457,
  [2002] = 1463,
  [2003] = 1323,
  [2004] = 1464,
  [2005] = 1465,
  [2006] = 1468,
  [2007] = 1403,
  [2008] = 1456,
  [2009] = 1457,
  [2010] = 1463,
  [2011] = 1439,
  [2012] = 1464,
  [2013] = 1404,
  [2014] = 1209,
  [2015] = 1465,
  [2016] = 1468,
  [2017] = 1366,
  [2018] = 1407,
  [2019] = 1429,
  [2020] = 1438,
  [2021] = 1342,
  [2022] = 1346,
  [2023] = 1431,
  [2024] = 1443,
  [2025] = 1442,
  [2026] = 1204,
  [2027] = 1350,
  [2028] = 1442,
  [2029] = 1439,
  [2030] = 1390,
  [2031] = 1468,
  [2032] = 1393,
  [2033] = 1383,
  [2034] = 1380,
  [2035] = 1402,
  [2036] = 1379,
  [2037] = 1208,
  [2038] = 1359,
  [2039] = 1465,
  [2040] = 1343,
  [2041] = 1443,
  [2042] = 1343,
  [2043] = 1431,
  [2044] = 1429,
  [2045] = 1408,
  [2046] = 1366,
  [2047] = 1409,
  [2048] = 1462,
  [2049] = 1358,
  [2050] = 1368,
  [2051] = 1402,
  [2052] = 1317,
  [2053] = 1221,
  [2054] = 1459,
  [2055] = 1469,
  [2056] = 1345,
  [2057] = 1351,
  [2058] = 1323,
  [2059] = 1365,
  [2060] = 1379,
  [2061] = 1394,
  [2062] = 1347,
  [2063] = 1315,
  [2064] = 1334,
  [2065] = 1383,
  [2066] = 1357,
  [2067] = 1393,
  [2068] = 1463,
  [2069] = 1329,
  [2070] = 1317,
  [2071] = 1401,
  [2072] = 1376,
  [2073] = 1315,
  [2074] = 1382,
  [2075] = 1345,
  [2076] = 1351,
  [2077] = 1469,
  [2078] = 1459,
  [2079] = 1365,
  [2080] = 1457,
  [2081] = 1385,
  [2082] = 1456,
  [2083] = 1374,
  [2084] = 1447,
  [2085] = 1395,
  [2086] = 1454,
  [2087] = 1338,
  [2088] = 1336,
  [2089] = 1439,
  [2090] = 1442,
  [2091] = 1376,
  [2092] = 1452,
  [2093] = 1455,
  [2094] = 1315,
  [2095] = 1396,
  [2096] = 1398,
  [2097] = 1451,
  [2098] = 1450,
  [2099] = 1382,
  [2100] = 1385,
  [2101] = 1395,
  [2102] = 1221,
  [2103] = 1396,
  [2104] = 1403,
  [2105] = 1404,
  [2106] = 1398,
  [2107] = 1468,
  [2108] = 1407,
  [2109] = 1403,
  [2110] = 1408,
  [2111] = 1409,
  [2112] = 1462,
  [2113] = 1404,
  [2114] = 1424,
  [2115] = 1465,
  [2116] = 1464,
  [2117] = 1423,
  [2118] = 1463,
  [2119] = 1457,
  [2120] = 1281,
  [2121] = 1372,
  [2122] = 1221,
  [2123] = 1456,
  [2124] = 1452,
  [2125] = 1451,
  [2126] = 1450,
  [2127] = 1212,
  [2128] = 1376,
  [2129] = 1371,
  [2130] = 1286,
  [2131] = 1407,
  [2132] = 1442,
  [2133] = 1369,
  [2134] = 1424,
  [2135] = 1423,
  [2136] = 1372,
  [2137] = 1371,
  [2138] = 1358,
  [2139] = 1357,
  [2140] = 1356,
  [2141] = 1369,
  [2142] = 1368,
  [2143] = 1408,
  [2144] = 1439,
  [2145] = 1438,
  [2146] = 1368,
  [2147] = 1359,
  [2148] = 1355,
  [2149] = 1409,
  [2150] = 1347,
  [2151] = 1332,
  [2152] = 1462,
  [2153] = 1413,
  [2154] = 1359,
  [2155] = 1350,
  [2156] = 1350,
  [2157] = 1346,
  [2158] = 1342,
  [2159] = 1358,
  [2160] = 1458,
  [2161] = 1357,
  [2162] = 1329,
  [2163] = 1334,
  [2164] = 1356,
  [2165] = 1355,
  [2166] = 1205,
  [2167] = 1332,
  [2168] = 1346,
  [2169] = 1338,
  [2170] = 1327,
  [2171] = 1323,
  [2172] = 1336,
  [2173] = 1413,
  [2174] = 1334,
  [2175] = 1447,
  [2176] = 1342,
  [2177] = 1390,
  [2178] = 1205,
  [2179] = 1327,
  [2180] = 1333,
  [2181] = 1366,
  [2182] = 1221,
  [2183] = 1454,
  [2184] = 1455,
  [2185] = 1322,
  [2186] = 1320,
  [2187] = 1458,
  [2188] = 1338,
  [2189] = 1336,
  [2190] = 1393,
  [2191] = 1206,
  [2192] = 1419,
  [2193] = 1429,
  [2194] = 1431,
  [2195] = 1443,
  [2196] = 1458,
  [2197] = 1211,
  [2198] = 1383,
  [2199] = 1390,
  [2200] = 1203,
  [2201] = 1380,
  [2202] = 1204,
  [2203] = 1379,
  [2204] = 1356,
  [2205] = 1355,
  [2206] = 1380,
  [2207] = 1394,
  [2208] = 1212,
  [2209] = 1322,
  [2210] = 1438,
  [2211] = 1320,
  [2212] = 1327,
  [2213] = 1419,
  [2214] = 1322,
  [2215] = 1347,
  [2216] = 1320,
  [2217] = 1419,
  [2218] = 1464,
  [2219] = 1206,
  [2220] = 1332,
  [2221] = 1207,
  [2222] = 1413,
  [2223] = 1447,
  [2224] = 1343,
  [2225] = 1455,
  [2226] = 1333,
  [2227] = 1366,
  [2228] = 1215,
  [2229] = 1227,
  [2230] = 1214,
  [2231] = 1219,
  [2232] = 1229,
  [2233] = 1222,
  [2234] = 1218,
  [2235] = 1223,
  [2236] = 1224,
  [2237] = 1218,
  [2238] = 1216,
  [2239] = 1226,
  [2240] = 1225,
  [2241] = 1221,
  [2242] = 1220,
  [2243] = 1225,
  [2244] = 1230,
  [2245] = 1221,
  [2246] = 1213,
  [2247] = 1222,
  [2248] = 1217,
  [2249] = 1226,
  [2250] = 1229,
  [2251] = 1227,
  [2252] = 1223,
  [2253] = 1228,
  [2254] = 1213,
  [2255] = 1215,
  [2256] = 1220,
  [2257] = 1230,
  [2258] = 1228,
  [2259] = 1219,
  [2260] = 1216,
  [2261] = 1217,
  [2262] = 1224,
  [2263] = 1214,
  [2264] = 1236,
  [2265] = 1195,
  [2266] = 1236,
  [2267] = 1201,
  [2268] = 1194,
  [2269] = 1197,
  [2270] = 1198,
  [2271] = 1279,
  [2272] = 1245,
  [2273] = 1195,
  [2274] = 1274,
  [2275] = 1249,
  [2276] = 1276,
  [2277] = 1198,
  [2278] = 1253,
  [2279] = 1276,
  [2280] = 1267,
  [2281] = 1278,
  [2282] = 1269,
  [2283] = 1253,
  [2284] = 1252,
  [2285] = 1262,
  [2286] = 1267,
  [2287] = 1268,
  [2288] = 1197,
  [2289] = 1249,
  [2290] = 1245,
  [2291] = 1201,
  [2292] = 1278,
  [2293] = 1269,
  [2294] = 1250,
  [2295] = 1262,
  [2296] = 1252,
  [2297] = 1274,
  [2298] = 1268,
  [2299] = 1253,
  [2300] = 1253,
  [2301] = 1279,
  [2302] = 1194,
  [2303] = 1201,
  [2304] = 1301,
  [2305] = 1211,
  [2306] = 1194,
  [2307] = 1198,
  [2308] = 1197,
  [2309] = 1197,
  [2310] = 1194,
  [2311] = 1198,
  [2312] = 1253,
  [2313] = 1311,
  [2314] = 1203,
  [2315] = 1311,
  [2316] = 1281,
  [2317] = 1306,
  [2318] = 1203,
  [2319] = 1195,
  [2320] = 1197,
  [2321] = 1210,
  [2322] = 1209,
  [2323] = 1250,
  [2324] = 1282,
  [2325] = 1201,
  [2326] = 1210,
  [2327] = 1208,
  [2328] = 1194,
  [2329] = 1203,
  [2330] = 1285,
  [2331] = 1287,
  [2332] = 1282,
  [2333] = 1295,
  [2334] = 1306,
  [2335] = 1287,
  [2336] = 1201,
  [2337] = 1194,
  [2338] = 1197,
  [2339] = 1253,
  [2340] = 1286,
  [2341] = 1198,
  [2342] = 1204,
  [2343] = 1207,
  [2344] = 1288,
  [2345] = 1206,
  [2346] = 1301,
  [2347] = 1205,
  [2348] = 1195,
  [2349] = 1195,
  [2350] = 1201,
  [2351] = 1288,
  [2352] = 1253,
  [2353] = 1210,
  [2354] = 1212,
  [2355] = 1195,
  [2356] = 1201,
  [2357] = 1198,
  [2358] = 1295,
  [2359] = 1285,
  [2360] = 1452,
  [2361] = 1203,
  [2362] = 1468,
  [2363] = 1439,
  [2364] = 1221,
  [2365] = 1329,
  [2366] = 1323,
  [2367] = 1394,
  [2368] = 1465,
  [2369] = 1464,
  [2370] = 1438,
  [2371] = 1429,
  [2372] = 1431,
  [2373] = 1443,
  [2374] = 1454,
  [2375] = 1463,
  [2376] = 1333,
  [2377] = 1457,
  [2378] = 1456,
  [2379] = 1452,
  [2380] = 1451,
  [2381] = 1286,
  [2382] = 1442,
  [2383] = 1221,
  [2384] = 1450,
  [2385] = 1227,
  [2386] = 1447,
  [2387] = 1413,
  [2388] = 1343,
  [2389] = 1281,
  [2390] = 1332,
  [2391] = 1347,
  [2392] = 1366,
  [2393] = 1329,
  [2394] = 1379,
  [2395] = 1413,
  [2396] = 1332,
  [2397] = 1402,
  [2398] = 1347,
  [2399] = 1366,
  [2400] = 1355,
  [2401] = 1380,
  [2402] = 1356,
  [2403] = 1317,
  [2404] = 1401,
  [2405] = 1383,
  [2406] = 1393,
  [2407] = 1323,
  [2408] = 1345,
  [2409] = 1351,
  [2410] = 1458,
  [2411] = 1355,
  [2412] = 1208,
  [2413] = 1423,
  [2414] = 1209,
  [2415] = 1372,
  [2416] = 1222,
  [2417] = 1371,
  [2418] = 1369,
  [2419] = 1438,
  [2420] = 1223,
  [2421] = 1356,
  [2422] = 1224,
  [2423] = 1439,
  [2424] = 1442,
  [2425] = 1368,
  [2426] = 1205,
  [2427] = 1286,
  [2428] = 1455,
  [2429] = 1357,
  [2430] = 1455,
  [2431] = 1359,
  [2432] = 1358,
  [2433] = 1462,
  [2434] = 1409,
  [2435] = 1350,
  [2436] = 1408,
  [2437] = 1206,
  [2438] = 1346,
  [2439] = 1424,
  [2440] = 1407,
  [2441] = 1404,
  [2442] = 1342,
  [2443] = 1403,
  [2444] = 1393,
  [2445] = 1468,
  [2446] = 1465,
  [2447] = 1212,
  [2448] = 1464,
  [2449] = 1401,
  [2450] = 1398,
  [2451] = 1396,
  [2452] = 1383,
  [2453] = 1395,
  [2454] = 1385,
  [2455] = 1463,
  [2456] = 1382,
  [2457] = 1315,
  [2458] = 1469,
  [2459] = 1376,
  [2460] = 1390,
  [2461] = 1374,
  [2462] = 1457,
  [2463] = 1365,
  [2464] = 1219,
  [2465] = 1469,
  [2466] = 1459,
  [2467] = 1456,
  [2468] = 2468,
  [2469] = 1380,
  [2470] = 1431,
  [2471] = 1451,
  [2472] = 1204,
  [2473] = 1338,
  [2474] = 1443,
  [2475] = 1365,
  [2476] = 1394,
  [2477] = 1450,
  [2478] = 1454,
  [2479] = 1379,
  [2480] = 1336,
  [2481] = 1374,
  [2482] = 1334,
  [2483] = 1228,
  [2484] = 1390,
  [2485] = 1376,
  [2486] = 1315,
  [2487] = 1382,
  [2488] = 1221,
  [2489] = 1385,
  [2490] = 1395,
  [2491] = 1396,
  [2492] = 1398,
  [2493] = 1403,
  [2494] = 1404,
  [2495] = 1407,
  [2496] = 1408,
  [2497] = 1226,
  [2498] = 1409,
  [2499] = 1215,
  [2500] = 1201,
  [2501] = 1462,
  [2502] = 1459,
  [2503] = 1213,
  [2504] = 1351,
  [2505] = 1345,
  [2506] = 1327,
  [2507] = 1207,
  [2508] = 1424,
  [2509] = 1317,
  [2510] = 1423,
  [2511] = 1358,
  [2512] = 1357,
  [2513] = 1402,
  [2514] = 1343,
  [2515] = 1281,
  [2516] = 1372,
  [2517] = 1371,
  [2518] = 1230,
  [2519] = 1369,
  [2520] = 1322,
  [2521] = 1320,
  [2522] = 1368,
  [2523] = 1458,
  [2524] = 1220,
  [2525] = 1419,
  [2526] = 1359,
  [2527] = 1218,
  [2528] = 1216,
  [2529] = 1217,
  [2530] = 1211,
  [2531] = 1419,
  [2532] = 1350,
  [2533] = 1346,
  [2534] = 1342,
  [2535] = 1210,
  [2536] = 1225,
  [2537] = 1338,
  [2538] = 1333,
  [2539] = 1207,
  [2540] = 1204,
  [2541] = 1336,
  [2542] = 1334,
  [2543] = 1327,
  [2544] = 1214,
  [2545] = 1229,
  [2546] = 1429,
  [2547] = 1447,
  [2548] = 1322,
  [2549] = 1320,
  [2550] = 1213,
  [2551] = 1209,
  [2552] = 1203,
  [2553] = 1227,
  [2554] = 1208,
  [2555] = 1206,
  [2556] = 1211,
  [2557] = 1209,
  [2558] = 1208,
  [2559] = 1205,
  [2560] = 1212,
  [2561] = 1236,
  [2562] = 1205,
  [2563] = 1206,
  [2564] = 1212,
  [2565] = 1206,
  [2566] = 1205,
  [2567] = 1204,
  [2568] = 1211,
  [2569] = 1212,
  [2570] = 1207,
  [2571] = 1211,
  [2572] = 1210,
  [2573] = 1221,
  [2574] = 1236,
  [2575] = 1206,
  [2576] = 1204,
  [2577] = 1207,
  [2578] = 1203,
  [2579] = 1209,
  [2580] = 2580,
  [2581] = 1204,
  [2582] = 1208,
  [2583] = 1229,
  [2584] = 1210,
  [2585] = 1214,
  [2586] = 1225,
  [2587] = 1216,
  [2588] = 1210,
  [2589] = 1227,
  [2590] = 1211,
  [2591] = 1226,
  [2592] = 1208,
  [2593] = 1230,
  [2594] = 1222,
  [2595] = 1223,
  [2596] = 1224,
  [2597] = 1218,
  [2598] = 2598,
  [2599] = 1203,
  [2600] = 1203,
  [2601] = 1212,
  [2602] = 1288,
  [2603] = 1207,
  [2604] = 1288,
  [2605] = 1210,
  [2606] = 1228,
  [2607] = 1207,
  [2608] = 1205,
  [2609] = 1220,
  [2610] = 1204,
  [2611] = 1215,
  [2612] = 1219,
  [2613] = 1217,
  [2614] = 1209,
  [2615] = 1213,
  [2616] = 1213,
  [2617] = 1221,
  [2618] = 1225,
  [2619] = 1236,
  [2620] = 1279,
  [2621] = 1227,
  [2622] = 1214,
  [2623] = 1229,
  [2624] = 1214,
  [2625] = 1221,
  [2626] = 1220,
  [2627] = 1219,
  [2628] = 1224,
  [2629] = 1218,
  [2630] = 1252,
  [2631] = 1221,
  [2632] = 1225,
  [2633] = 1223,
  [2634] = 2580,
  [2635] = 1229,
  [2636] = 1262,
  [2637] = 1230,
  [2638] = 1236,
  [2639] = 1249,
  [2640] = 1224,
  [2641] = 1217,
  [2642] = 1236,
  [2643] = 1225,
  [2644] = 1216,
  [2645] = 1223,
  [2646] = 1226,
  [2647] = 1222,
  [2648] = 1253,
  [2649] = 1224,
  [2650] = 2650,
  [2651] = 1278,
  [2652] = 1267,
  [2653] = 1226,
  [2654] = 1253,
  [2655] = 1222,
  [2656] = 1214,
  [2657] = 1223,
  [2658] = 1227,
  [2659] = 1218,
  [2660] = 1230,
  [2661] = 1217,
  [2662] = 1245,
  [2663] = 1223,
  [2664] = 1224,
  [2665] = 1213,
  [2666] = 1215,
  [2667] = 1250,
  [2668] = 2598,
  [2669] = 1268,
  [2670] = 1228,
  [2671] = 1217,
  [2672] = 1214,
  [2673] = 1267,
  [2674] = 1216,
  [2675] = 1218,
  [2676] = 1269,
  [2677] = 1215,
  [2678] = 1221,
  [2679] = 1250,
  [2680] = 1220,
  [2681] = 1219,
  [2682] = 1279,
  [2683] = 1219,
  [2684] = 1229,
  [2685] = 1220,
  [2686] = 1216,
  [2687] = 1222,
  [2688] = 1228,
  [2689] = 1219,
  [2690] = 1225,
  [2691] = 1228,
  [2692] = 1230,
  [2693] = 1274,
  [2694] = 1227,
  [2695] = 1250,
  [2696] = 1215,
  [2697] = 1236,
  [2698] = 1213,
  [2699] = 1226,
  [2700] = 1253,
  [2701] = 1222,
  [2702] = 1230,
  [2703] = 1226,
  [2704] = 1218,
  [2705] = 1220,
  [2706] = 1216,
  [2707] = 2650,
  [2708] = 1215,
  [2709] = 1276,
  [2710] = 1228,
  [2711] = 1253,
  [2712] = 1269,
  [2713] = 1268,
  [2714] = 1227,
  [2715] = 1217,
  [2716] = 1229,
  [2717] = 1276,
  [2718] = 1267,
  [2719] = 1245,
  [2720] = 1252,
  [2721] = 1253,
  [2722] = 1262,
  [2723] = 1250,
  [2724] = 1267,
  [2725] = 2725,
  [2726] = 1286,
  [2727] = 1282,
  [2728] = 1269,
  [2729] = 1245,
  [2730] = 1267,
  [2731] = 2725,
  [2732] = 1268,
  [2733] = 1236,
  [2734] = 1236,
  [2735] = 1311,
  [2736] = 1306,
  [2737] = 2725,
  [2738] = 2725,
  [2739] = 2725,
  [2740] = 1249,
  [2741] = 1278,
  [2742] = 1288,
  [2743] = 1268,
  [2744] = 2725,
  [2745] = 1203,
  [2746] = 1253,
  [2747] = 1253,
  [2748] = 1301,
  [2749] = 1274,
  [2750] = 1210,
  [2751] = 1279,
  [2752] = 1281,
  [2753] = 1287,
  [2754] = 1278,
  [2755] = 1250,
  [2756] = 1249,
  [2757] = 1285,
  [2758] = 2725,
  [2759] = 1295,
  [2760] = 2725,
  [2761] = 1262,
  [2762] = 1279,
  [2763] = 1252,
  [2764] = 1236,
  [2765] = 1268,
  [2766] = 1269,
  [2767] = 1279,
  [2768] = 1274,
  [2769] = 1250,
  [2770] = 1267,
  [2771] = 2725,
  [2772] = 2725,
  [2773] = 1236,
  [2774] = 1203,
  [2775] = 1288,
  [2776] = 1279,
  [2777] = 1276,
  [2778] = 1268,
  [2779] = 1236,
  [2780] = 1210,
  [2781] = 1269,
  [2782] = 1269,
  [2783] = 1253,
  [2784] = 1279,
  [2785] = 1267,
  [2786] = 1269,
  [2787] = 1279,
  [2788] = 1245,
  [2789] = 1253,
  [2790] = 1442,
  [2791] = 1267,
  [2792] = 1276,
  [2793] = 1439,
  [2794] = 1245,
  [2795] = 1288,
  [2796] = 2796,
  [2797] = 1267,
  [2798] = 1253,
  [2799] = 1281,
  [2800] = 1221,
  [2801] = 1253,
  [2802] = 1253,
  [2803] = 1268,
  [2804] = 1252,
  [2805] = 1250,
  [2806] = 1393,
  [2807] = 1262,
  [2808] = 1383,
  [2809] = 1269,
  [2810] = 1394,
  [2811] = 1380,
  [2812] = 1379,
  [2813] = 1464,
  [2814] = 1288,
  [2815] = 1249,
  [2816] = 1278,
  [2817] = 2817,
  [2818] = 2818,
  [2819] = 1343,
  [2820] = 1468,
  [2821] = 1438,
  [2822] = 1274,
  [2823] = 1245,
  [2824] = 1465,
  [2825] = 1281,
  [2826] = 1274,
  [2827] = 1268,
  [2828] = 1268,
  [2829] = 1250,
  [2830] = 1278,
  [2831] = 1269,
  [2832] = 1463,
  [2833] = 1401,
  [2834] = 1333,
  [2835] = 1281,
  [2836] = 1274,
  [2837] = 1249,
  [2838] = 1210,
  [2839] = 1447,
  [2840] = 1276,
  [2841] = 1253,
  [2842] = 1279,
  [2843] = 1286,
  [2844] = 1286,
  [2845] = 1203,
  [2846] = 1281,
  [2847] = 1457,
  [2848] = 1456,
  [2849] = 1452,
  [2850] = 1454,
  [2851] = 1455,
  [2852] = 1287,
  [2853] = 1451,
  [2854] = 1450,
  [2855] = 1458,
  [2856] = 1443,
  [2857] = 1431,
  [2858] = 1429,
  [2859] = 1253,
  [2860] = 1274,
  [2861] = 1424,
  [2862] = 1366,
  [2863] = 1423,
  [2864] = 1390,
  [2865] = 1372,
  [2866] = 1371,
  [2867] = 1369,
  [2868] = 1368,
  [2869] = 1253,
  [2870] = 1252,
  [2871] = 1262,
  [2872] = 1323,
  [2873] = 1262,
  [2874] = 1249,
  [2875] = 1359,
  [2876] = 1350,
  [2877] = 1252,
  [2878] = 1278,
  [2879] = 1210,
  [2880] = 1221,
  [2881] = 1346,
  [2882] = 1342,
  [2883] = 1459,
  [2884] = 1329,
  [2885] = 1469,
  [2886] = 1279,
  [2887] = 1301,
  [2888] = 1282,
  [2889] = 1338,
  [2890] = 1245,
  [2891] = 1203,
  [2892] = 1286,
  [2893] = 1286,
  [2894] = 1269,
  [2895] = 1336,
  [2896] = 1250,
  [2897] = 1413,
  [2898] = 1332,
  [2899] = 1347,
  [2900] = 1253,
  [2901] = 1355,
  [2902] = 1268,
  [2903] = 1356,
  [2904] = 1357,
  [2905] = 1358,
  [2906] = 1334,
  [2907] = 1462,
  [2908] = 1409,
  [2909] = 1408,
  [2910] = 1407,
  [2911] = 2817,
  [2912] = 1311,
  [2913] = 1276,
  [2914] = 1306,
  [2915] = 1327,
  [2916] = 1301,
  [2917] = 1295,
  [2918] = 1285,
  [2919] = 2817,
  [2920] = 1288,
  [2921] = 1286,
  [2922] = 1276,
  [2923] = 1253,
  [2924] = 1267,
  [2925] = 1282,
  [2926] = 1210,
  [2927] = 1322,
  [2928] = 2817,
  [2929] = 1320,
  [2930] = 1404,
  [2931] = 1278,
  [2932] = 1403,
  [2933] = 1398,
  [2934] = 1396,
  [2935] = 1395,
  [2936] = 1385,
  [2937] = 1382,
  [2938] = 1315,
  [2939] = 1376,
  [2940] = 1262,
  [2941] = 1374,
  [2942] = 1249,
  [2943] = 1365,
  [2944] = 1285,
  [2945] = 1295,
  [2946] = 1306,
  [2947] = 1286,
  [2948] = 1419,
  [2949] = 1351,
  [2950] = 1281,
  [2951] = 1345,
  [2952] = 1250,
  [2953] = 1279,
  [2954] = 1311,
  [2955] = 1317,
  [2956] = 1402,
  [2957] = 1268,
  [2958] = 1286,
  [2959] = 1281,
  [2960] = 1253,
  [2961] = 1281,
  [2962] = 1269,
  [2963] = 1252,
  [2964] = 1203,
  [2965] = 1250,
  [2966] = 1267,
  [2967] = 1287,
  [2968] = 2968,
  [2969] = 1374,
  [2970] = 1198,
  [2971] = 1342,
  [2972] = 1281,
  [2973] = 1350,
  [2974] = 1194,
  [2975] = 1369,
  [2976] = 1359,
  [2977] = 2796,
  [2978] = 1371,
  [2979] = 1372,
  [2980] = 1450,
  [2981] = 1451,
  [2982] = 1368,
  [2983] = 1366,
  [2984] = 1452,
  [2985] = 1286,
  [2986] = 2986,
  [2987] = 2987,
  [2988] = 1456,
  [2989] = 1457,
  [2990] = 1463,
  [2991] = 1423,
  [2992] = 1464,
  [2993] = 1465,
  [2994] = 1468,
  [2995] = 1458,
  [2996] = 1346,
  [2997] = 2817,
  [2998] = 1221,
  [2999] = 2999,
  [3000] = 1197,
  [3001] = 1281,
  [3002] = 1288,
  [3003] = 1390,
  [3004] = 1390,
  [3005] = 1285,
  [3006] = 1394,
  [3007] = 1366,
  [3008] = 1288,
  [3009] = 1338,
  [3010] = 1336,
  [3011] = 1334,
  [3012] = 1301,
  [3013] = 1250,
  [3014] = 1419,
  [3015] = 1327,
  [3016] = 1356,
  [3017] = 1438,
  [3018] = 1311,
  [3019] = 1320,
  [3020] = 1322,
  [3021] = 1455,
  [3022] = 1320,
  [3023] = 1442,
  [3024] = 1306,
  [3025] = 1322,
  [3026] = 1327,
  [3027] = 1334,
  [3028] = 1333,
  [3029] = 1306,
  [3030] = 1336,
  [3031] = 1338,
  [3032] = 1286,
  [3033] = 1439,
  [3034] = 1401,
  [3035] = 1288,
  [3036] = 1195,
  [3037] = 1210,
  [3038] = 1454,
  [3039] = 1342,
  [3040] = 1346,
  [3041] = 1350,
  [3042] = 1359,
  [3043] = 1413,
  [3044] = 1332,
  [3045] = 1311,
  [3046] = 1287,
  [3047] = 1368,
  [3048] = 1413,
  [3049] = 1332,
  [3050] = 1347,
  [3051] = 1355,
  [3052] = 1347,
  [3053] = 1356,
  [3054] = 1285,
  [3055] = 1357,
  [3056] = 1358,
  [3057] = 1221,
  [3058] = 1462,
  [3059] = 1409,
  [3060] = 1295,
  [3061] = 1355,
  [3062] = 1369,
  [3063] = 1371,
  [3064] = 1372,
  [3065] = 1423,
  [3066] = 1424,
  [3067] = 1281,
  [3068] = 1408,
  [3069] = 1394,
  [3070] = 1407,
  [3071] = 1203,
  [3072] = 1393,
  [3073] = 1383,
  [3074] = 1404,
  [3075] = 1403,
  [3076] = 1398,
  [3077] = 1396,
  [3078] = 1395,
  [3079] = 1385,
  [3080] = 1382,
  [3081] = 1315,
  [3082] = 1376,
  [3083] = 1424,
  [3084] = 1380,
  [3085] = 1365,
  [3086] = 1282,
  [3087] = 1379,
  [3088] = 2817,
  [3089] = 1450,
  [3090] = 1451,
  [3091] = 1452,
  [3092] = 1456,
  [3093] = 1457,
  [3094] = 2817,
  [3095] = 1463,
  [3096] = 1464,
  [3097] = 1288,
  [3098] = 1419,
  [3099] = 1465,
  [3100] = 1351,
  [3101] = 1345,
  [3102] = 1469,
  [3103] = 1459,
  [3104] = 1468,
  [3105] = 1317,
  [3106] = 1402,
  [3107] = 1402,
  [3108] = 1317,
  [3109] = 1357,
  [3110] = 2968,
  [3111] = 2468,
  [3112] = 1358,
  [3113] = 1462,
  [3114] = 1295,
  [3115] = 1409,
  [3116] = 1442,
  [3117] = 1439,
  [3118] = 1343,
  [3119] = 1281,
  [3120] = 1408,
  [3121] = 1286,
  [3122] = 1286,
  [3123] = 1438,
  [3124] = 1407,
  [3125] = 1447,
  [3126] = 1404,
  [3127] = 1393,
  [3128] = 1443,
  [3129] = 1383,
  [3130] = 1380,
  [3131] = 1379,
  [3132] = 1431,
  [3133] = 1403,
  [3134] = 2817,
  [3135] = 1447,
  [3136] = 1429,
  [3137] = 2968,
  [3138] = 1221,
  [3139] = 1398,
  [3140] = 1281,
  [3141] = 1323,
  [3142] = 1281,
  [3143] = 1396,
  [3144] = 1343,
  [3145] = 1329,
  [3146] = 1295,
  [3147] = 1285,
  [3148] = 1210,
  [3149] = 1311,
  [3150] = 1287,
  [3151] = 1306,
  [3152] = 1395,
  [3153] = 1385,
  [3154] = 1454,
  [3155] = 1287,
  [3156] = 1443,
  [3157] = 1431,
  [3158] = 1429,
  [3159] = 1382,
  [3160] = 1208,
  [3161] = 1323,
  [3162] = 1287,
  [3163] = 1455,
  [3164] = 1315,
  [3165] = 1329,
  [3166] = 1253,
  [3167] = 1253,
  [3168] = 1282,
  [3169] = 1376,
  [3170] = 1374,
  [3171] = 1210,
  [3172] = 1401,
  [3173] = 1209,
  [3174] = 1212,
  [3175] = 1285,
  [3176] = 1295,
  [3177] = 2968,
  [3178] = 1253,
  [3179] = 1365,
  [3180] = 1210,
  [3181] = 1203,
  [3182] = 1203,
  [3183] = 1282,
  [3184] = 1282,
  [3185] = 1306,
  [3186] = 1459,
  [3187] = 1469,
  [3188] = 1253,
  [3189] = 1301,
  [3190] = 1458,
  [3191] = 1301,
  [3192] = 1351,
  [3193] = 1345,
  [3194] = 1311,
  [3195] = 1203,
  [3196] = 1301,
  [3197] = 1286,
  [3198] = 1286,
  [3199] = 1333,
  [3200] = 1346,
  [3201] = 1390,
  [3202] = 3202,
  [3203] = 1469,
  [3204] = 1221,
  [3205] = 3205,
  [3206] = 1225,
  [3207] = 3207,
  [3208] = 1438,
  [3209] = 1424,
  [3210] = 1423,
  [3211] = 1372,
  [3212] = 1371,
  [3213] = 1369,
  [3214] = 1438,
  [3215] = 2817,
  [3216] = 1394,
  [3217] = 3207,
  [3218] = 3202,
  [3219] = 1368,
  [3220] = 1359,
  [3221] = 1350,
  [3222] = 1342,
  [3223] = 1214,
  [3224] = 1413,
  [3225] = 1332,
  [3226] = 1347,
  [3227] = 1366,
  [3228] = 1355,
  [3229] = 1356,
  [3230] = 3205,
  [3231] = 1357,
  [3232] = 1358,
  [3233] = 1462,
  [3234] = 1338,
  [3235] = 1336,
  [3236] = 1390,
  [3237] = 1409,
  [3238] = 1334,
  [3239] = 1327,
  [3240] = 1408,
  [3241] = 1407,
  [3242] = 1404,
  [3243] = 1403,
  [3244] = 1398,
  [3245] = 1396,
  [3246] = 1395,
  [3247] = 1385,
  [3248] = 1382,
  [3249] = 1322,
  [3250] = 1320,
  [3251] = 1315,
  [3252] = 1376,
  [3253] = 1442,
  [3254] = 1374,
  [3255] = 1365,
  [3256] = 1439,
  [3257] = 1394,
  [3258] = 1413,
  [3259] = 1332,
  [3260] = 1351,
  [3261] = 1345,
  [3262] = 1347,
  [3263] = 1383,
  [3264] = 3202,
  [3265] = 1317,
  [3266] = 1402,
  [3267] = 1419,
  [3268] = 1355,
  [3269] = 1393,
  [3270] = 1419,
  [3271] = 1320,
  [3272] = 1322,
  [3273] = 1327,
  [3274] = 1334,
  [3275] = 1336,
  [3276] = 1338,
  [3277] = 1356,
  [3278] = 1451,
  [3279] = 1452,
  [3280] = 1342,
  [3281] = 1346,
  [3282] = 1456,
  [3283] = 1350,
  [3284] = 1359,
  [3285] = 1457,
  [3286] = 3207,
  [3287] = 1368,
  [3288] = 1323,
  [3289] = 1380,
  [3290] = 1463,
  [3291] = 3207,
  [3292] = 1379,
  [3293] = 2817,
  [3294] = 1369,
  [3295] = 1371,
  [3296] = 1372,
  [3297] = 1423,
  [3298] = 1424,
  [3299] = 1468,
  [3300] = 1464,
  [3301] = 1450,
  [3302] = 3202,
  [3303] = 2968,
  [3304] = 1451,
  [3305] = 1452,
  [3306] = 2968,
  [3307] = 1465,
  [3308] = 1464,
  [3309] = 1465,
  [3310] = 1456,
  [3311] = 1357,
  [3312] = 1457,
  [3313] = 1394,
  [3314] = 1463,
  [3315] = 1468,
  [3316] = 1464,
  [3317] = 1358,
  [3318] = 1462,
  [3319] = 1465,
  [3320] = 1468,
  [3321] = 1463,
  [3322] = 1409,
  [3323] = 1408,
  [3324] = 1407,
  [3325] = 3202,
  [3326] = 1456,
  [3327] = 3205,
  [3328] = 1404,
  [3329] = 1442,
  [3330] = 1403,
  [3331] = 1398,
  [3332] = 1439,
  [3333] = 1396,
  [3334] = 1395,
  [3335] = 1385,
  [3336] = 1452,
  [3337] = 1451,
  [3338] = 3207,
  [3339] = 3202,
  [3340] = 1450,
  [3341] = 1382,
  [3342] = 1343,
  [3343] = 1315,
  [3344] = 3344,
  [3345] = 1390,
  [3346] = 1376,
  [3347] = 1374,
  [3348] = 3348,
  [3349] = 1365,
  [3350] = 1345,
  [3351] = 1317,
  [3352] = 1402,
  [3353] = 1333,
  [3354] = 1366,
  [3355] = 1438,
  [3356] = 1221,
  [3357] = 1351,
  [3358] = 3205,
  [3359] = 1424,
  [3360] = 3205,
  [3361] = 1455,
  [3362] = 1459,
  [3363] = 1393,
  [3364] = 1383,
  [3365] = 1380,
  [3366] = 1379,
  [3367] = 1454,
  [3368] = 1458,
  [3369] = 1423,
  [3370] = 1333,
  [3371] = 1372,
  [3372] = 1447,
  [3373] = 1442,
  [3374] = 1413,
  [3375] = 1332,
  [3376] = 1371,
  [3377] = 3207,
  [3378] = 1439,
  [3379] = 3202,
  [3380] = 1369,
  [3381] = 1368,
  [3382] = 1443,
  [3383] = 1343,
  [3384] = 1431,
  [3385] = 1347,
  [3386] = 1429,
  [3387] = 1366,
  [3388] = 1355,
  [3389] = 1356,
  [3390] = 1345,
  [3391] = 1357,
  [3392] = 1359,
  [3393] = 1358,
  [3394] = 3205,
  [3395] = 1462,
  [3396] = 1409,
  [3397] = 1408,
  [3398] = 1407,
  [3399] = 1404,
  [3400] = 1403,
  [3401] = 1459,
  [3402] = 1350,
  [3403] = 1346,
  [3404] = 1342,
  [3405] = 1398,
  [3406] = 1393,
  [3407] = 1383,
  [3408] = 1396,
  [3409] = 1395,
  [3410] = 1380,
  [3411] = 3207,
  [3412] = 1379,
  [3413] = 3207,
  [3414] = 1385,
  [3415] = 1382,
  [3416] = 1458,
  [3417] = 1315,
  [3418] = 1457,
  [3419] = 3202,
  [3420] = 1329,
  [3421] = 1394,
  [3422] = 1455,
  [3423] = 1443,
  [3424] = 1431,
  [3425] = 1429,
  [3426] = 1454,
  [3427] = 1376,
  [3428] = 1338,
  [3429] = 1336,
  [3430] = 1334,
  [3431] = 1343,
  [3432] = 1327,
  [3433] = 3344,
  [3434] = 1450,
  [3435] = 1447,
  [3436] = 1203,
  [3437] = 1374,
  [3438] = 1438,
  [3439] = 3348,
  [3440] = 1365,
  [3441] = 1210,
  [3442] = 2468,
  [3443] = 1211,
  [3444] = 3205,
  [3445] = 1469,
  [3446] = 3205,
  [3447] = 3205,
  [3448] = 1351,
  [3449] = 1317,
  [3450] = 1323,
  [3451] = 1443,
  [3452] = 1431,
  [3453] = 1402,
  [3454] = 1419,
  [3455] = 1329,
  [3456] = 1429,
  [3457] = 2968,
  [3458] = 1322,
  [3459] = 3344,
  [3460] = 1320,
  [3461] = 1322,
  [3462] = 1320,
  [3463] = 1327,
  [3464] = 1334,
  [3465] = 1458,
  [3466] = 1401,
  [3467] = 1338,
  [3468] = 1221,
  [3469] = 3207,
  [3470] = 3470,
  [3471] = 3202,
  [3472] = 1342,
  [3473] = 1419,
  [3474] = 1346,
  [3475] = 1350,
  [3476] = 3207,
  [3477] = 1458,
  [3478] = 1359,
  [3479] = 3202,
  [3480] = 1455,
  [3481] = 1368,
  [3482] = 1221,
  [3483] = 1369,
  [3484] = 1371,
  [3485] = 1372,
  [3486] = 1423,
  [3487] = 1424,
  [3488] = 1401,
  [3489] = 1455,
  [3490] = 3205,
  [3491] = 1450,
  [3492] = 1451,
  [3493] = 1452,
  [3494] = 1456,
  [3495] = 3202,
  [3496] = 3496,
  [3497] = 1457,
  [3498] = 3207,
  [3499] = 3202,
  [3500] = 1463,
  [3501] = 1454,
  [3502] = 1464,
  [3503] = 3348,
  [3504] = 1333,
  [3505] = 1465,
  [3506] = 1468,
  [3507] = 3348,
  [3508] = 1439,
  [3509] = 1333,
  [3510] = 1442,
  [3511] = 2468,
  [3512] = 1336,
  [3513] = 3207,
  [3514] = 1454,
  [3515] = 3202,
  [3516] = 3516,
  [3517] = 1413,
  [3518] = 1332,
  [3519] = 1347,
  [3520] = 3207,
  [3521] = 1366,
  [3522] = 1355,
  [3523] = 1356,
  [3524] = 1447,
  [3525] = 1383,
  [3526] = 3202,
  [3527] = 1380,
  [3528] = 2968,
  [3529] = 1379,
  [3530] = 1459,
  [3531] = 3207,
  [3532] = 1323,
  [3533] = 1393,
  [3534] = 1469,
  [3535] = 1343,
  [3536] = 1357,
  [3537] = 1358,
  [3538] = 1462,
  [3539] = 1409,
  [3540] = 1447,
  [3541] = 1329,
  [3542] = 1408,
  [3543] = 1407,
  [3544] = 3207,
  [3545] = 1402,
  [3546] = 1317,
  [3547] = 3202,
  [3548] = 1404,
  [3549] = 1403,
  [3550] = 1398,
  [3551] = 1396,
  [3552] = 1395,
  [3553] = 1329,
  [3554] = 1385,
  [3555] = 1382,
  [3556] = 1315,
  [3557] = 1376,
  [3558] = 1390,
  [3559] = 1374,
  [3560] = 3207,
  [3561] = 1365,
  [3562] = 1401,
  [3563] = 3202,
  [3564] = 1323,
  [3565] = 1345,
  [3566] = 1443,
  [3567] = 1431,
  [3568] = 1351,
  [3569] = 3569,
  [3570] = 1429,
  [3571] = 3344,
  [3572] = 1469,
  [3573] = 3573,
  [3574] = 3202,
  [3575] = 3207,
  [3576] = 1401,
  [3577] = 1459,
  [3578] = 1205,
  [3579] = 1215,
  [3580] = 3580,
  [3581] = 3580,
  [3582] = 3580,
  [3583] = 3580,
  [3584] = 1229,
  [3585] = 3580,
  [3586] = 3580,
  [3587] = 2968,
  [3588] = 3580,
  [3589] = 3580,
  [3590] = 3580,
  [3591] = 3580,
  [3592] = 1221,
  [3593] = 3580,
  [3594] = 2968,
  [3595] = 3580,
  [3596] = 3580,
  [3597] = 1206,
  [3598] = 3580,
  [3599] = 3580,
  [3600] = 1226,
  [3601] = 1223,
  [3602] = 1218,
  [3603] = 1224,
  [3604] = 1219,
  [3605] = 1230,
  [3606] = 1213,
  [3607] = 1217,
  [3608] = 1216,
  [3609] = 1222,
  [3610] = 1220,
  [3611] = 1228,
  [3612] = 3612,
  [3613] = 3613,
  [3614] = 3612,
  [3615] = 3615,
  [3616] = 3616,
  [3617] = 3617,
  [3618] = 3618,
  [3619] = 3615,
  [3620] = 3617,
  [3621] = 3618,
  [3622] = 3622,
  [3623] = 3622,
  [3624] = 3622,
  [3625] = 3613,
  [3626] = 3612,
  [3627] = 3613,
  [3628] = 3617,
  [3629] = 3617,
  [3630] = 3618,
  [3631] = 3615,
  [3632] = 3615,
  [3633] = 3612,
  [3634] = 3616,
  [3635] = 3618,
  [3636] = 3618,
  [3637] = 3613,
  [3638] = 3616,
  [3639] = 3612,
  [3640] = 3616,
  [3641] = 3618,
  [3642] = 3612,
  [3643] = 3622,
  [3644] = 3617,
  [3645] = 3615,
  [3646] = 3615,
  [3647] = 3616,
  [3648] = 3612,
  [3649] = 3612,
  [3650] = 3617,
  [3651] = 3622,
  [3652] = 3616,
  [3653] = 3612,
  [3654] = 3613,
  [3655] = 3622,
  [3656] = 3622,
  [3657] = 3615,
  [3658] = 3618,
  [3659] = 3616,
  [3660] = 3613,
  [3661] = 3618,
  [3662] = 3612,
  [3663] = 3615,
  [3664] = 3616,
  [3665] = 3616,
  [3666] = 3618,
  [3667] = 3615,
  [3668] = 3613,
  [3669] = 3617,
  [3670] = 3613,
  [3671] = 3615,
  [3672] = 3618,
  [3673] = 3612,
  [3674] = 3615,
  [3675] = 3616,
  [3676] = 3615,
  [3677] = 3617,
  [3678] = 3622,
  [3679] = 3617,
  [3680] = 3618,
  [3681] = 3617,
  [3682] = 3612,
  [3683] = 3613,
  [3684] = 3622,
  [3685] = 3622,
  [3686] = 3622,
  [3687] = 3617,
  [3688] = 3622,
  [3689] = 3617,
  [3690] = 3616,
  [3691] = 3618,
  [3692] = 3613,
  [3693] = 3612,
  [3694] = 3615,
  [3695] = 3617,
  [3696] = 3615,
  [3697] = 3613,
  [3698] = 3613,
  [3699] = 3612,
  [3700] = 3615,
  [3701] = 3622,
  [3702] = 3622,
  [3703] = 3616,
  [3704] = 3618,
  [3705] = 3616,
  [3706] = 3613,
  [3707] = 3612,
  [3708] = 3617,
  [3709] = 3616,
  [3710] = 3618,
  [3711] = 3615,
  [3712] = 3613,
  [3713] = 3613,
  [3714] = 3617,
  [3715] = 3617,
  [3716] = 3613,
  [3717] = 3618,
  [3718] = 3622,
  [3719] = 3616,
  [3720] = 3622,
  [3721] = 3618,
  [3722] = 3612,
  [3723] = 3616,
  [3724] = 3724,
  [3725] = 3725,
  [3726] = 3726,
  [3727] = 3724,
  [3728] = 3728,
  [3729] = 3729,
  [3730] = 3730,
  [3731] = 3724,
  [3732] = 3732,
  [3733] = 3728,
  [3734] = 3734,
  [3735] = 3735,
  [3736] = 3724,
  [3737] = 3724,
  [3738] = 3738,
  [3739] = 3728,
  [3740] = 3740,
  [3741] = 3728,
  [3742] = 3728,
  [3743] = 3724,
  [3744] = 3744,
  [3745] = 3728,
  [3746] = 3724,
  [3747] = 3728,
  [3748] = 3724,
  [3749] = 3749,
  [3750] = 3728,
  [3751] = 3751,
  [3752] = 3724,
  [3753] = 3728,
  [3754] = 3724,
  [3755] = 3755,
  [3756] = 3728,
  [3757] = 3757,
  [3758] = 3758,
  [3759] = 3759,
  [3760] = 3760,
  [3761] = 3760,
  [3762] = 3762,
  [3763] = 3763,
  [3764] = 3764,
  [3765] = 3760,
  [3766] = 3763,
  [3767] = 3763,
  [3768] = 3764,
  [3769] = 3764,
  [3770] = 3760,
  [3771] = 3760,
  [3772] = 3763,
  [3773] = 3763,
  [3774] = 3774,
  [3775] = 3764,
  [3776] = 3776,
  [3777] = 3764,
  [3778] = 3778,
  [3779] = 3779,
  [3780] = 3780,
  [3781] = 3781,
  [3782] = 3763,
  [3783] = 3783,
  [3784] = 3760,
  [3785] = 3760,
  [3786] = 3786,
  [3787] = 3783,
  [3788] = 3788,
  [3789] = 3789,
  [3790] = 3760,
  [3791] = 3764,
  [3792] = 3763,
  [3793] = 3793,
  [3794] = 3763,
  [3795] = 3764,
  [3796] = 3764,
  [3797] = 3797,
  [3798] = 3798,
  [3799] = 3763,
  [3800] = 3800,
  [3801] = 3801,
  [3802] = 3764,
  [3803] = 3760,
  [3804] = 3804,
  [3805] = 3805,
  [3806] = 3783,
  [3807] = 3807,
  [3808] = 3808,
  [3809] = 3809,
  [3810] = 3810,
  [3811] = 3811,
  [3812] = 3812,
  [3813] = 3813,
  [3814] = 3814,
  [3815] = 3760,
  [3816] = 1182,
  [3817] = 3764,
  [3818] = 3818,
  [3819] = 3819,
  [3820] = 3820,
  [3821] = 3760,
  [3822] = 3822,
  [3823] = 3823,
  [3824] = 3824,
  [3825] = 3760,
  [3826] = 3783,
  [3827] = 3764,
  [3828] = 3828,
  [3829] = 3829,
  [3830] = 3830,
  [3831] = 3763,
  [3832] = 1253,
  [3833] = 3833,
  [3834] = 3764,
  [3835] = 3760,
  [3836] = 3763,
  [3837] = 3837,
  [3838] = 3838,
  [3839] = 3812,
  [3840] = 3764,
  [3841] = 3812,
  [3842] = 3812,
  [3843] = 3843,
  [3844] = 3844,
  [3845] = 3763,
  [3846] = 3846,
  [3847] = 3847,
  [3848] = 3848,
  [3849] = 3812,
  [3850] = 3760,
  [3851] = 3851,
  [3852] = 3764,
  [3853] = 3853,
  [3854] = 3854,
  [3855] = 3783,
  [3856] = 3763,
  [3857] = 3763,
  [3858] = 3812,
  [3859] = 3859,
  [3860] = 3860,
  [3861] = 3783,
  [3862] = 3760,
  [3863] = 3863,
  [3864] = 3864,
  [3865] = 3783,
  [3866] = 3812,
  [3867] = 3867,
  [3868] = 3812,
  [3869] = 3764,
  [3870] = 3870,
  [3871] = 3763,
  [3872] = 3760,
  [3873] = 3764,
  [3874] = 3764,
  [3875] = 3763,
  [3876] = 3812,
  [3877] = 3812,
  [3878] = 3763,
  [3879] = 3879,
  [3880] = 3783,
  [3881] = 3760,
  [3882] = 3882,
  [3883] = 3882,
  [3884] = 3882,
  [3885] = 3885,
  [3886] = 3886,
  [3887] = 3887,
  [3888] = 3888,
  [3889] = 3885,
  [3890] = 3886,
  [3891] = 3891,
  [3892] = 3886,
  [3893] = 3893,
  [3894] = 3886,
  [3895] = 3895,
  [3896] = 3896,
  [3897] = 3886,
  [3898] = 3895,
  [3899] = 3899,
  [3900] = 3896,
  [3901] = 3887,
  [3902] = 3899,
  [3903] = 3888,
  [3904] = 3895,
  [3905] = 3891,
  [3906] = 3882,
  [3907] = 3888,
  [3908] = 3886,
  [3909] = 3909,
  [3910] = 3895,
  [3911] = 3882,
  [3912] = 3899,
  [3913] = 3896,
  [3914] = 3887,
  [3915] = 3893,
  [3916] = 3916,
  [3917] = 3888,
  [3918] = 3886,
  [3919] = 3882,
  [3920] = 3882,
  [3921] = 3895,
  [3922] = 3899,
  [3923] = 3886,
  [3924] = 3888,
  [3925] = 3882,
  [3926] = 3882,
  [3927] = 3886,
  [3928] = 3887,
  [3929] = 3886,
  [3930] = 3886,
  [3931] = 3886,
  [3932] = 3896,
  [3933] = 3888,
  [3934] = 3888,
  [3935] = 3882,
  [3936] = 3886,
  [3937] = 3886,
  [3938] = 3888,
  [3939] = 3895,
  [3940] = 3895,
  [3941] = 3886,
  [3942] = 3899,
  [3943] = 3899,
  [3944] = 3888,
  [3945] = 3896,
  [3946] = 3896,
  [3947] = 3887,
  [3948] = 3887,
  [3949] = 3886,
  [3950] = 3887,
  [3951] = 3886,
  [3952] = 3886,
  [3953] = 3891,
  [3954] = 3893,
  [3955] = 3886,
  [3956] = 3893,
  [3957] = 3895,
  [3958] = 3899,
  [3959] = 3893,
  [3960] = 3891,
  [3961] = 3899,
  [3962] = 3888,
  [3963] = 3887,
  [3964] = 3896,
  [3965] = 3896,
  [3966] = 3891,
  [3967] = 3891,
  [3968] = 3891,
  [3969] = 3893,
  [3970] = 3970,
  [3971] = 3887,
  [3972] = 3896,
  [3973] = 3899,
  [3974] = 3895,
  [3975] = 3893,
  [3976] = 3891,
  [3977] = 3893,
  [3978] = 3978,
  [3979] = 3979,
  [3980] = 3980,
  [3981] = 3893,
  [3982] = 3982,
  [3983] = 3891,
  [3984] = 3893,
  [3985] = 3887,
  [3986] = 3896,
  [3987] = 3899,
  [3988] = 3891,
  [3989] = 3895,
  [3990] = 1198,
  [3991] = 1209,
  [3992] = 1197,
  [3993] = 1194,
  [3994] = 1195,
  [3995] = 1212,
  [3996] = 3996,
  [3997] = 1208,
  [3998] = 3998,
  [3999] = 1184,
  [4000] = 1225,
  [4001] = 1210,
  [4002] = 1203,
  [4003] = 1211,
  [4004] = 1214,
  [4005] = 4005,
  [4006] = 1221,
  [4007] = 1206,
  [4008] = 1229,
  [4009] = 1215,
  [4010] = 4010,
  [4011] = 1205,
  [4012] = 4012,
  [4013] = 4013,
  [4014] = 4014,
  [4015] = 1213,
  [4016] = 1217,
  [4017] = 1220,
  [4018] = 4013,
  [4019] = 1222,
  [4020] = 1216,
  [4021] = 1228,
  [4022] = 1223,
  [4023] = 1219,
  [4024] = 4014,
  [4025] = 1224,
  [4026] = 1218,
  [4027] = 1230,
  [4028] = 1226,
  [4029] = 4012,
  [4030] = 4005,
  [4031] = 4010,
  [4032] = 1197,
  [4033] = 4033,
  [4034] = 1208,
  [4035] = 1195,
  [4036] = 4036,
  [4037] = 1203,
  [4038] = 1212,
  [4039] = 1194,
  [4040] = 1209,
  [4041] = 1198,
  [4042] = 1210,
  [4043] = 1211,
  [4044] = 4044,
  [4045] = 4045,
  [4046] = 4046,
  [4047] = 4046,
  [4048] = 1221,
  [4049] = 4049,
  [4050] = 4050,
  [4051] = 4046,
  [4052] = 4046,
  [4053] = 4046,
  [4054] = 4046,
  [4055] = 4046,
  [4056] = 4046,
  [4057] = 4046,
  [4058] = 4046,
  [4059] = 4046,
  [4060] = 4046,
  [4061] = 4061,
  [4062] = 4046,
  [4063] = 4063,
  [4064] = 1214,
  [4065] = 4046,
  [4066] = 4046,
  [4067] = 4046,
  [4068] = 4046,
  [4069] = 1211,
  [4070] = 4046,
  [4071] = 4071,
  [4072] = 4046,
  [4073] = 4073,
  [4074] = 4074,
  [4075] = 1225,
  [4076] = 4046,
  [4077] = 4046,
  [4078] = 4046,
  [4079] = 4046,
  [4080] = 4080,
  [4081] = 4081,
  [4082] = 4046,
  [4083] = 4046,
  [4084] = 4046,
  [4085] = 4046,
  [4086] = 4046,
  [4087] = 4046,
  [4088] = 4046,
  [4089] = 4046,
  [4090] = 4090,
  [4091] = 4091,
  [4092] = 4092,
  [4093] = 4046,
  [4094] = 1210,
  [4095] = 4095,
  [4096] = 1195,
  [4097] = 4097,
  [4098] = 4046,
  [4099] = 4099,
  [4100] = 1203,
  [4101] = 4046,
  [4102] = 4046,
  [4103] = 4103,
  [4104] = 4046,
  [4105] = 4046,
  [4106] = 4046,
  [4107] = 4046,
  [4108] = 4046,
  [4109] = 4046,
  [4110] = 4046,
  [4111] = 4111,
  [4112] = 1212,
  [4113] = 4113,
  [4114] = 4114,
  [4115] = 4046,
  [4116] = 4046,
  [4117] = 4046,
  [4118] = 4046,
  [4119] = 4046,
  [4120] = 4046,
  [4121] = 1198,
  [4122] = 4122,
  [4123] = 1208,
  [4124] = 4124,
  [4125] = 1209,
  [4126] = 4046,
  [4127] = 4046,
  [4128] = 1197,
  [4129] = 4046,
  [4130] = 4046,
  [4131] = 4046,
  [4132] = 1194,
  [4133] = 4046,
  [4134] = 4046,
  [4135] = 4135,
  [4136] = 4046,
  [4137] = 4046,
  [4138] = 4138,
  [4139] = 4046,
  [4140] = 3786,
  [4141] = 4141,
  [4142] = 4142,
  [4143] = 4143,
  [4144] = 1253,
  [4145] = 1225,
  [4146] = 3778,
  [4147] = 4141,
  [4148] = 1210,
  [4149] = 4149,
  [4150] = 3879,
  [4151] = 4151,
  [4152] = 4143,
  [4153] = 4153,
  [4154] = 4154,
  [4155] = 3847,
  [4156] = 1214,
  [4157] = 1206,
  [4158] = 4141,
  [4159] = 1215,
  [4160] = 3776,
  [4161] = 4141,
  [4162] = 1221,
  [4163] = 4163,
  [4164] = 3804,
  [4165] = 4143,
  [4166] = 4166,
  [4167] = 3829,
  [4168] = 4168,
  [4169] = 1203,
  [4170] = 1211,
  [4171] = 4143,
  [4172] = 1229,
  [4173] = 4173,
  [4174] = 4143,
  [4175] = 1205,
  [4176] = 4176,
  [4177] = 4143,
  [4178] = 4143,
  [4179] = 3823,
  [4180] = 4143,
  [4181] = 1215,
  [4182] = 1205,
  [4183] = 1220,
  [4184] = 1226,
  [4185] = 1206,
  [4186] = 1218,
  [4187] = 1224,
  [4188] = 1216,
  [4189] = 1219,
  [4190] = 1228,
  [4191] = 1229,
  [4192] = 1213,
  [4193] = 1230,
  [4194] = 1221,
  [4195] = 1222,
  [4196] = 1217,
  [4197] = 1223,
  [4198] = 4198,
  [4199] = 1236,
  [4200] = 1213,
  [4201] = 1230,
  [4202] = 1226,
  [4203] = 1222,
  [4204] = 1223,
  [4205] = 1217,
  [4206] = 1224,
  [4207] = 1220,
  [4208] = 1219,
  [4209] = 1228,
  [4210] = 1216,
  [4211] = 1218,
  [4212] = 1268,
  [4213] = 3725,
  [4214] = 3751,
  [4215] = 1269,
  [4216] = 3751,
  [4217] = 3740,
  [4218] = 3725,
  [4219] = 1279,
  [4220] = 1267,
  [4221] = 3740,
  [4222] = 3853,
  [4223] = 1253,
  [4224] = 3804,
  [4225] = 1253,
  [4226] = 3786,
  [4227] = 3786,
  [4228] = 3725,
  [4229] = 3751,
  [4230] = 3804,
  [4231] = 3740,
  [4232] = 3853,
  [4233] = 3751,
  [4234] = 1317,
  [4235] = 1438,
  [4236] = 1355,
  [4237] = 3740,
  [4238] = 1356,
  [4239] = 3804,
  [4240] = 3725,
  [4241] = 3786,
  [4242] = 1332,
  [4243] = 1253,
  [4244] = 1357,
  [4245] = 1358,
  [4246] = 1462,
  [4247] = 1409,
  [4248] = 1408,
  [4249] = 1407,
  [4250] = 1404,
  [4251] = 1403,
  [4252] = 1398,
  [4253] = 1396,
  [4254] = 1395,
  [4255] = 1385,
  [4256] = 1382,
  [4257] = 1315,
  [4258] = 1376,
  [4259] = 3778,
  [4260] = 1374,
  [4261] = 3778,
  [4262] = 1347,
  [4263] = 1365,
  [4264] = 3853,
  [4265] = 1351,
  [4266] = 1345,
  [4267] = 3804,
  [4268] = 3879,
  [4269] = 1366,
  [4270] = 1253,
  [4271] = 3786,
  [4272] = 1402,
  [4273] = 3804,
  [4274] = 1390,
  [4275] = 1253,
  [4276] = 3786,
  [4277] = 1413,
  [4278] = 3879,
  [4279] = 1394,
  [4280] = 4280,
  [4281] = 1253,
  [4282] = 1253,
  [4283] = 3879,
  [4284] = 3786,
  [4285] = 3804,
  [4286] = 3853,
  [4287] = 4287,
  [4288] = 3804,
  [4289] = 3778,
  [4290] = 3786,
  [4291] = 4291,
  [4292] = 4292,
  [4293] = 3786,
  [4294] = 4294,
  [4295] = 3804,
  [4296] = 4296,
  [4297] = 3879,
  [4298] = 4298,
  [4299] = 3778,
  [4300] = 1253,
  [4301] = 4301,
  [4302] = 4302,
  [4303] = 4303,
  [4304] = 4304,
  [4305] = 4305,
  [4306] = 4306,
  [4307] = 4306,
  [4308] = 4306,
  [4309] = 4309,
  [4310] = 4306,
  [4311] = 4311,
  [4312] = 4306,
  [4313] = 4306,
  [4314] = 4306,
  [4315] = 4306,
  [4316] = 4306,
  [4317] = 4306,
  [4318] = 4318,
  [4319] = 4306,
  [4320] = 4306,
  [4321] = 4306,
  [4322] = 4306,
  [4323] = 4306,
  [4324] = 4306,
  [4325] = 1182,
  [4326] = 1182,
  [4327] = 1182,
  [4328] = 1182,
  [4329] = 1182,
  [4330] = 1184,
  [4331] = 1184,
  [4332] = 1184,
  [4333] = 1184,
  [4334] = 1184,
  [4335] = 4335,
  [4336] = 1212,
  [4337] = 1197,
  [4338] = 1194,
  [4339] = 1195,
  [4340] = 1195,
  [4341] = 4335,
  [4342] = 1212,
  [4343] = 1209,
  [4344] = 1208,
  [4345] = 1198,
  [4346] = 1208,
  [4347] = 4335,
  [4348] = 1198,
  [4349] = 4349,
  [4350] = 4350,
  [4351] = 1194,
  [4352] = 1209,
  [4353] = 1197,
  [4354] = 1208,
  [4355] = 1197,
  [4356] = 1195,
  [4357] = 4349,
  [4358] = 4358,
  [4359] = 1195,
  [4360] = 4349,
  [4361] = 1212,
  [4362] = 4350,
  [4363] = 1197,
  [4364] = 1194,
  [4365] = 1197,
  [4366] = 1208,
  [4367] = 1209,
  [4368] = 1198,
  [4369] = 1198,
  [4370] = 1225,
  [4371] = 1208,
  [4372] = 1209,
  [4373] = 1195,
  [4374] = 1225,
  [4375] = 1212,
  [4376] = 1194,
  [4377] = 1214,
  [4378] = 1195,
  [4379] = 1209,
  [4380] = 1208,
  [4381] = 1212,
  [4382] = 4335,
  [4383] = 1198,
  [4384] = 1198,
  [4385] = 1203,
  [4386] = 1214,
  [4387] = 1197,
  [4388] = 1209,
  [4389] = 1194,
  [4390] = 1195,
  [4391] = 4350,
  [4392] = 1210,
  [4393] = 1208,
  [4394] = 1209,
  [4395] = 1197,
  [4396] = 1210,
  [4397] = 1211,
  [4398] = 1203,
  [4399] = 1194,
  [4400] = 1212,
  [4401] = 1194,
  [4402] = 1212,
  [4403] = 1211,
  [4404] = 1198,
  [4405] = 4335,
  [4406] = 1225,
  [4407] = 1229,
  [4408] = 4358,
  [4409] = 4349,
  [4410] = 1205,
  [4411] = 1212,
  [4412] = 1195,
  [4413] = 1212,
  [4414] = 1209,
  [4415] = 1210,
  [4416] = 4350,
  [4417] = 1209,
  [4418] = 1208,
  [4419] = 1203,
  [4420] = 1206,
  [4421] = 4349,
  [4422] = 1197,
  [4423] = 4335,
  [4424] = 1195,
  [4425] = 1221,
  [4426] = 1214,
  [4427] = 1195,
  [4428] = 1221,
  [4429] = 1225,
  [4430] = 1208,
  [4431] = 1209,
  [4432] = 1215,
  [4433] = 1198,
  [4434] = 1214,
  [4435] = 1198,
  [4436] = 1194,
  [4437] = 1214,
  [4438] = 1203,
  [4439] = 1211,
  [4440] = 1215,
  [4441] = 1209,
  [4442] = 1197,
  [4443] = 1194,
  [4444] = 1210,
  [4445] = 1203,
  [4446] = 1211,
  [4447] = 4358,
  [4448] = 1195,
  [4449] = 1225,
  [4450] = 1212,
  [4451] = 1210,
  [4452] = 1211,
  [4453] = 1198,
  [4454] = 1211,
  [4455] = 1229,
  [4456] = 1195,
  [4457] = 1212,
  [4458] = 1203,
  [4459] = 1194,
  [4460] = 1211,
  [4461] = 1197,
  [4462] = 1208,
  [4463] = 1225,
  [4464] = 1198,
  [4465] = 1210,
  [4466] = 1203,
  [4467] = 1194,
  [4468] = 1210,
  [4469] = 4350,
  [4470] = 1206,
  [4471] = 1197,
  [4472] = 1225,
  [4473] = 4350,
  [4474] = 4349,
  [4475] = 1198,
  [4476] = 1208,
  [4477] = 1212,
  [4478] = 1205,
  [4479] = 1209,
  [4480] = 1214,
  [4481] = 1208,
  [4482] = 1194,
  [4483] = 1214,
  [4484] = 1197,
  [4485] = 1213,
  [4486] = 1205,
  [4487] = 1216,
  [4488] = 1229,
  [4489] = 1206,
  [4490] = 4490,
  [4491] = 1229,
  [4492] = 1218,
  [4493] = 4493,
  [4494] = 1219,
  [4495] = 1210,
  [4496] = 1215,
  [4497] = 1220,
  [4498] = 1217,
  [4499] = 1211,
  [4500] = 4490,
  [4501] = 1195,
  [4502] = 1230,
  [4503] = 1215,
  [4504] = 1206,
  [4505] = 1205,
  [4506] = 1226,
  [4507] = 4493,
  [4508] = 4490,
  [4509] = 1220,
  [4510] = 1205,
  [4511] = 1206,
  [4512] = 1205,
  [4513] = 1212,
  [4514] = 1213,
  [4515] = 1206,
  [4516] = 1215,
  [4517] = 4490,
  [4518] = 1225,
  [4519] = 1228,
  [4520] = 1228,
  [4521] = 1221,
  [4522] = 4493,
  [4523] = 1211,
  [4524] = 4490,
  [4525] = 1211,
  [4526] = 4358,
  [4527] = 4493,
  [4528] = 1206,
  [4529] = 4490,
  [4530] = 1226,
  [4531] = 4358,
  [4532] = 1214,
  [4533] = 4493,
  [4534] = 1221,
  [4535] = 1229,
  [4536] = 1230,
  [4537] = 1225,
  [4538] = 1215,
  [4539] = 1208,
  [4540] = 1229,
  [4541] = 4490,
  [4542] = 1194,
  [4543] = 1197,
  [4544] = 1221,
  [4545] = 4493,
  [4546] = 1225,
  [4547] = 1224,
  [4548] = 4493,
  [4549] = 1219,
  [4550] = 1223,
  [4551] = 1222,
  [4552] = 1221,
  [4553] = 1209,
  [4554] = 1211,
  [4555] = 1215,
  [4556] = 1218,
  [4557] = 1203,
  [4558] = 1229,
  [4559] = 1211,
  [4560] = 1210,
  [4561] = 1216,
  [4562] = 1210,
  [4563] = 1210,
  [4564] = 1225,
  [4565] = 1198,
  [4566] = 1224,
  [4567] = 4490,
  [4568] = 1223,
  [4569] = 1217,
  [4570] = 1205,
  [4571] = 1214,
  [4572] = 4572,
  [4573] = 1203,
  [4574] = 1203,
  [4575] = 4493,
  [4576] = 1221,
  [4577] = 1210,
  [4578] = 1214,
  [4579] = 1214,
  [4580] = 1214,
  [4581] = 1222,
  [4582] = 1203,
  [4583] = 1203,
  [4584] = 1225,
  [4585] = 1220,
  [4586] = 1229,
  [4587] = 1229,
  [4588] = 1205,
  [4589] = 1210,
  [4590] = 1220,
  [4591] = 1219,
  [4592] = 1203,
  [4593] = 1219,
  [4594] = 1211,
  [4595] = 1222,
  [4596] = 1221,
  [4597] = 1221,
  [4598] = 1223,
  [4599] = 1224,
  [4600] = 1221,
  [4601] = 1205,
  [4602] = 1229,
  [4603] = 1215,
  [4604] = 1206,
  [4605] = 1229,
  [4606] = 1222,
  [4607] = 1206,
  [4608] = 1221,
  [4609] = 1224,
  [4610] = 1217,
  [4611] = 1228,
  [4612] = 1223,
  [4613] = 1213,
  [4614] = 1218,
  [4615] = 1229,
  [4616] = 1205,
  [4617] = 1216,
  [4618] = 1225,
  [4619] = 1228,
  [4620] = 1217,
  [4621] = 1222,
  [4622] = 1215,
  [4623] = 1206,
  [4624] = 1215,
  [4625] = 1224,
  [4626] = 1216,
  [4627] = 1223,
  [4628] = 1223,
  [4629] = 4629,
  [4630] = 1218,
  [4631] = 1217,
  [4632] = 1216,
  [4633] = 1218,
  [4634] = 1213,
  [4635] = 1219,
  [4636] = 1215,
  [4637] = 1224,
  [4638] = 1216,
  [4639] = 1228,
  [4640] = 1222,
  [4641] = 1214,
  [4642] = 1205,
  [4643] = 1217,
  [4644] = 1222,
  [4645] = 1216,
  [4646] = 1226,
  [4647] = 1218,
  [4648] = 1230,
  [4649] = 1223,
  [4650] = 1206,
  [4651] = 1224,
  [4652] = 1230,
  [4653] = 1206,
  [4654] = 1213,
  [4655] = 1226,
  [4656] = 1220,
  [4657] = 1221,
  [4658] = 1230,
  [4659] = 1215,
  [4660] = 1226,
  [4661] = 1213,
  [4662] = 1226,
  [4663] = 1228,
  [4664] = 1230,
  [4665] = 1226,
  [4666] = 1217,
  [4667] = 1219,
  [4668] = 1213,
  [4669] = 1220,
  [4670] = 4670,
  [4671] = 1230,
  [4672] = 1205,
  [4673] = 1219,
  [4674] = 1228,
  [4675] = 1220,
  [4676] = 1218,
  [4677] = 1210,
  [4678] = 1222,
  [4679] = 1222,
  [4680] = 1230,
  [4681] = 1226,
  [4682] = 1226,
  [4683] = 1223,
  [4684] = 1223,
  [4685] = 1213,
  [4686] = 1228,
  [4687] = 1226,
  [4688] = 1230,
  [4689] = 1222,
  [4690] = 1213,
  [4691] = 1228,
  [4692] = 4692,
  [4693] = 1236,
  [4694] = 1224,
  [4695] = 4692,
  [4696] = 1220,
  [4697] = 1219,
  [4698] = 4692,
  [4699] = 1219,
  [4700] = 4692,
  [4701] = 1228,
  [4702] = 1205,
  [4703] = 1213,
  [4704] = 1226,
  [4705] = 1230,
  [4706] = 1220,
  [4707] = 4707,
  [4708] = 1218,
  [4709] = 1228,
  [4710] = 1220,
  [4711] = 1219,
  [4712] = 1216,
  [4713] = 1217,
  [4714] = 1206,
  [4715] = 1218,
  [4716] = 4716,
  [4717] = 1203,
  [4718] = 1218,
  [4719] = 1216,
  [4720] = 1217,
  [4721] = 1224,
  [4722] = 1182,
  [4723] = 1217,
  [4724] = 1216,
  [4725] = 4725,
  [4726] = 1216,
  [4727] = 1218,
  [4728] = 1215,
  [4729] = 4692,
  [4730] = 1219,
  [4731] = 4692,
  [4732] = 1220,
  [4733] = 1224,
  [4734] = 1217,
  [4735] = 1223,
  [4736] = 1222,
  [4737] = 1213,
  [4738] = 1216,
  [4739] = 1211,
  [4740] = 1217,
  [4741] = 1226,
  [4742] = 1230,
  [4743] = 1222,
  [4744] = 1229,
  [4745] = 1224,
  [4746] = 1230,
  [4747] = 4670,
  [4748] = 1224,
  [4749] = 1220,
  [4750] = 1219,
  [4751] = 1213,
  [4752] = 1221,
  [4753] = 1218,
  [4754] = 1236,
  [4755] = 1223,
  [4756] = 1223,
  [4757] = 1228,
  [4758] = 4758,
  [4759] = 1210,
  [4760] = 1224,
  [4761] = 1203,
  [4762] = 1208,
  [4763] = 1203,
  [4764] = 1288,
  [4765] = 1210,
  [4766] = 1268,
  [4767] = 1269,
  [4768] = 1269,
  [4769] = 4769,
  [4770] = 1209,
  [4771] = 4771,
  [4772] = 4772,
  [4773] = 1217,
  [4774] = 1216,
  [4775] = 1279,
  [4776] = 1209,
  [4777] = 4777,
  [4778] = 1268,
  [4779] = 1218,
  [4780] = 4780,
  [4781] = 1267,
  [4782] = 1210,
  [4783] = 1219,
  [4784] = 1220,
  [4785] = 4785,
  [4786] = 4758,
  [4787] = 4785,
  [4788] = 1267,
  [4789] = 1230,
  [4790] = 1226,
  [4791] = 1208,
  [4792] = 1211,
  [4793] = 1236,
  [4794] = 1288,
  [4795] = 1236,
  [4796] = 4758,
  [4797] = 4769,
  [4798] = 1221,
  [4799] = 4758,
  [4800] = 4785,
  [4801] = 1279,
  [4802] = 1213,
  [4803] = 1223,
  [4804] = 1211,
  [4805] = 1228,
  [4806] = 4785,
  [4807] = 1211,
  [4808] = 1203,
  [4809] = 1222,
  [4810] = 4780,
  [4811] = 4811,
  [4812] = 4812,
  [4813] = 4813,
  [4814] = 1267,
  [4815] = 4813,
  [4816] = 4813,
  [4817] = 1210,
  [4818] = 4780,
  [4819] = 4819,
  [4820] = 4772,
  [4821] = 1268,
  [4822] = 4822,
  [4823] = 4823,
  [4824] = 4824,
  [4825] = 4825,
  [4826] = 4823,
  [4827] = 1221,
  [4828] = 1208,
  [4829] = 1209,
  [4830] = 4830,
  [4831] = 1288,
  [4832] = 1236,
  [4833] = 1208,
  [4834] = 1214,
  [4835] = 1209,
  [4836] = 4822,
  [4837] = 4837,
  [4838] = 4838,
  [4839] = 1184,
  [4840] = 4822,
  [4841] = 4825,
  [4842] = 4830,
  [4843] = 4812,
  [4844] = 4811,
  [4845] = 1279,
  [4846] = 4813,
  [4847] = 4847,
  [4848] = 4830,
  [4849] = 1269,
  [4850] = 4777,
  [4851] = 1214,
  [4852] = 4852,
  [4853] = 4813,
  [4854] = 4854,
  [4855] = 4813,
  [4856] = 1203,
  [4857] = 4822,
  [4858] = 4812,
  [4859] = 4854,
  [4860] = 4847,
  [4861] = 1269,
  [4862] = 4813,
  [4863] = 4813,
  [4864] = 4852,
  [4865] = 4813,
  [4866] = 4769,
  [4867] = 4777,
  [4868] = 4812,
  [4869] = 4822,
  [4870] = 4838,
  [4871] = 4813,
  [4872] = 4830,
  [4873] = 1288,
  [4874] = 4813,
  [4875] = 4875,
  [4876] = 4830,
  [4877] = 4822,
  [4878] = 4822,
  [4879] = 1268,
  [4880] = 1279,
  [4881] = 4875,
  [4882] = 1221,
  [4883] = 4830,
  [4884] = 4772,
  [4885] = 4837,
  [4886] = 4777,
  [4887] = 4887,
  [4888] = 4780,
  [4889] = 4889,
  [4890] = 1225,
  [4891] = 1211,
  [4892] = 4892,
  [4893] = 4822,
  [4894] = 4813,
  [4895] = 4830,
  [4896] = 4813,
  [4897] = 4897,
  [4898] = 4813,
  [4899] = 4899,
  [4900] = 4830,
  [4901] = 4901,
  [4902] = 4769,
  [4903] = 4897,
  [4904] = 4892,
  [4905] = 4889,
  [4906] = 4887,
  [4907] = 1469,
  [4908] = 4901,
  [4909] = 1225,
  [4910] = 4830,
  [4911] = 4813,
  [4912] = 4899,
  [4913] = 4772,
  [4914] = 4822,
  [4915] = 4830,
  [4916] = 1267,
  [4917] = 4822,
  [4918] = 1469,
  [4919] = 4813,
  [4920] = 4772,
  [4921] = 4777,
  [4922] = 1221,
  [4923] = 4780,
  [4924] = 4819,
  [4925] = 4819,
  [4926] = 4926,
  [4927] = 1459,
  [4928] = 4928,
  [4929] = 4929,
  [4930] = 4930,
  [4931] = 4811,
  [4932] = 1401,
  [4933] = 4847,
  [4934] = 1390,
  [4935] = 4935,
  [4936] = 1390,
  [4937] = 4854,
  [4938] = 4938,
  [4939] = 2598,
  [4940] = 4852,
  [4941] = 4941,
  [4942] = 4942,
  [4943] = 1455,
  [4944] = 1458,
  [4945] = 1279,
  [4946] = 4946,
  [4947] = 4780,
  [4948] = 4838,
  [4949] = 4935,
  [4950] = 4950,
  [4951] = 1267,
  [4952] = 4952,
  [4953] = 1469,
  [4954] = 4938,
  [4955] = 1458,
  [4956] = 4825,
  [4957] = 4938,
  [4958] = 4952,
  [4959] = 1355,
  [4960] = 4938,
  [4961] = 4950,
  [4962] = 1366,
  [4963] = 4938,
  [4964] = 4777,
  [4965] = 1455,
  [4966] = 1454,
  [4967] = 2580,
  [4968] = 4968,
  [4969] = 4935,
  [4970] = 1413,
  [4971] = 1332,
  [4972] = 1366,
  [4973] = 4973,
  [4974] = 4974,
  [4975] = 1447,
  [4976] = 4928,
  [4977] = 1347,
  [4978] = 4929,
  [4979] = 4875,
  [4980] = 1413,
  [4981] = 4837,
  [4982] = 4930,
  [4983] = 1332,
  [4984] = 1347,
  [4985] = 1356,
  [4986] = 4769,
  [4987] = 1355,
  [4988] = 4926,
  [4989] = 4974,
  [4990] = 4990,
  [4991] = 1229,
  [4992] = 4824,
  [4993] = 1269,
  [4994] = 1357,
  [4995] = 4824,
  [4996] = 1358,
  [4997] = 1462,
  [4998] = 4941,
  [4999] = 1409,
  [5000] = 4823,
  [5001] = 1356,
  [5002] = 5002,
  [5003] = 5003,
  [5004] = 5004,
  [5005] = 5005,
  [5006] = 4990,
  [5007] = 4938,
  [5008] = 1408,
  [5009] = 4938,
  [5010] = 4938,
  [5011] = 1407,
  [5012] = 1454,
  [5013] = 5013,
  [5014] = 1404,
  [5015] = 1221,
  [5016] = 1403,
  [5017] = 4946,
  [5018] = 1333,
  [5019] = 1214,
  [5020] = 1357,
  [5021] = 1398,
  [5022] = 1459,
  [5023] = 1396,
  [5024] = 1358,
  [5025] = 1395,
  [5026] = 1462,
  [5027] = 1385,
  [5028] = 1382,
  [5029] = 1409,
  [5030] = 1315,
  [5031] = 4899,
  [5032] = 4901,
  [5033] = 1376,
  [5034] = 1374,
  [5035] = 4897,
  [5036] = 1365,
  [5037] = 1225,
  [5038] = 1229,
  [5039] = 1268,
  [5040] = 1214,
  [5041] = 1225,
  [5042] = 1469,
  [5043] = 4772,
  [5044] = 1351,
  [5045] = 4819,
  [5046] = 4824,
  [5047] = 4892,
  [5048] = 4938,
  [5049] = 1209,
  [5050] = 4889,
  [5051] = 4887,
  [5052] = 1333,
  [5053] = 1447,
  [5054] = 1345,
  [5055] = 1288,
  [5056] = 4825,
  [5057] = 1408,
  [5058] = 4823,
  [5059] = 1401,
  [5060] = 1438,
  [5061] = 1317,
  [5062] = 1402,
  [5063] = 4811,
  [5064] = 4887,
  [5065] = 4968,
  [5066] = 4973,
  [5067] = 4889,
  [5068] = 4892,
  [5069] = 4897,
  [5070] = 1407,
  [5071] = 1404,
  [5072] = 4901,
  [5073] = 4899,
  [5074] = 1403,
  [5075] = 1208,
  [5076] = 5076,
  [5077] = 1398,
  [5078] = 4847,
  [5079] = 4938,
  [5080] = 5004,
  [5081] = 1394,
  [5082] = 1396,
  [5083] = 5076,
  [5084] = 1395,
  [5085] = 4852,
  [5086] = 1385,
  [5087] = 1382,
  [5088] = 1315,
  [5089] = 1376,
  [5090] = 1374,
  [5091] = 4935,
  [5092] = 4854,
  [5093] = 5093,
  [5094] = 1365,
  [5095] = 1394,
  [5096] = 1351,
  [5097] = 1345,
  [5098] = 4935,
  [5099] = 4838,
  [5100] = 5005,
  [5101] = 1438,
  [5102] = 5003,
  [5103] = 1402,
  [5104] = 5002,
  [5105] = 4837,
  [5106] = 4875,
  [5107] = 5093,
  [5108] = 5108,
  [5109] = 1317,
  [5110] = 4942,
  [5111] = 4990,
  [5112] = 5002,
  [5113] = 1347,
  [5114] = 1332,
  [5115] = 4941,
  [5116] = 4942,
  [5117] = 1401,
  [5118] = 1394,
  [5119] = 5076,
  [5120] = 1413,
  [5121] = 1355,
  [5122] = 1356,
  [5123] = 2580,
  [5124] = 1214,
  [5125] = 4819,
  [5126] = 5005,
  [5127] = 4946,
  [5128] = 5003,
  [5129] = 1390,
  [5130] = 5093,
  [5131] = 1438,
  [5132] = 1402,
  [5133] = 1317,
  [5134] = 4973,
  [5135] = 1345,
  [5136] = 1351,
  [5137] = 4930,
  [5138] = 4929,
  [5139] = 1395,
  [5140] = 4875,
  [5141] = 1365,
  [5142] = 4973,
  [5143] = 4942,
  [5144] = 1374,
  [5145] = 4941,
  [5146] = 1225,
  [5147] = 1376,
  [5148] = 1315,
  [5149] = 4837,
  [5150] = 1382,
  [5151] = 1458,
  [5152] = 4990,
  [5153] = 5004,
  [5154] = 1385,
  [5155] = 1395,
  [5156] = 1396,
  [5157] = 1229,
  [5158] = 1398,
  [5159] = 2598,
  [5160] = 1403,
  [5161] = 4824,
  [5162] = 1459,
  [5163] = 1404,
  [5164] = 1455,
  [5165] = 1407,
  [5166] = 1408,
  [5167] = 1459,
  [5168] = 1454,
  [5169] = 4825,
  [5170] = 1409,
  [5171] = 1462,
  [5172] = 1358,
  [5173] = 1357,
  [5174] = 1357,
  [5175] = 1401,
  [5176] = 4974,
  [5177] = 4926,
  [5178] = 1356,
  [5179] = 1355,
  [5180] = 1347,
  [5181] = 1332,
  [5182] = 1413,
  [5183] = 4926,
  [5184] = 1358,
  [5185] = 1462,
  [5186] = 1409,
  [5187] = 5093,
  [5188] = 4823,
  [5189] = 5002,
  [5190] = 5003,
  [5191] = 1333,
  [5192] = 1408,
  [5193] = 5005,
  [5194] = 1438,
  [5195] = 4974,
  [5196] = 1407,
  [5197] = 1404,
  [5198] = 1403,
  [5199] = 1398,
  [5200] = 5076,
  [5201] = 4952,
  [5202] = 4950,
  [5203] = 4899,
  [5204] = 4901,
  [5205] = 1396,
  [5206] = 1447,
  [5207] = 4897,
  [5208] = 4852,
  [5209] = 4892,
  [5210] = 1385,
  [5211] = 4889,
  [5212] = 4950,
  [5213] = 4887,
  [5214] = 4952,
  [5215] = 5215,
  [5216] = 1366,
  [5217] = 1382,
  [5218] = 1229,
  [5219] = 1458,
  [5220] = 4928,
  [5221] = 1394,
  [5222] = 5004,
  [5223] = 1402,
  [5224] = 1455,
  [5225] = 1315,
  [5226] = 1317,
  [5227] = 1376,
  [5228] = 1469,
  [5229] = 4838,
  [5230] = 1333,
  [5231] = 1374,
  [5232] = 1365,
  [5233] = 4811,
  [5234] = 1366,
  [5235] = 4946,
  [5236] = 4847,
  [5237] = 1447,
  [5238] = 1351,
  [5239] = 1345,
  [5240] = 4854,
  [5241] = 4928,
  [5242] = 4929,
  [5243] = 4930,
  [5244] = 1454,
  [5245] = 1390,
  [5246] = 1351,
  [5247] = 1408,
  [5248] = 1355,
  [5249] = 5249,
  [5250] = 4941,
  [5251] = 2598,
  [5252] = 1459,
  [5253] = 5076,
  [5254] = 1401,
  [5255] = 1398,
  [5256] = 4942,
  [5257] = 1347,
  [5258] = 1229,
  [5259] = 4930,
  [5260] = 4973,
  [5261] = 1454,
  [5262] = 1332,
  [5263] = 5263,
  [5264] = 1447,
  [5265] = 2598,
  [5266] = 5249,
  [5267] = 5267,
  [5268] = 1438,
  [5269] = 5263,
  [5270] = 5270,
  [5271] = 5267,
  [5272] = 4946,
  [5273] = 1455,
  [5274] = 5093,
  [5275] = 4929,
  [5276] = 5002,
  [5277] = 5267,
  [5278] = 5003,
  [5279] = 1402,
  [5280] = 4950,
  [5281] = 1317,
  [5282] = 4952,
  [5283] = 5005,
  [5284] = 1366,
  [5285] = 1356,
  [5286] = 1413,
  [5287] = 4926,
  [5288] = 5270,
  [5289] = 5270,
  [5290] = 4928,
  [5291] = 5291,
  [5292] = 5249,
  [5293] = 4990,
  [5294] = 2580,
  [5295] = 5267,
  [5296] = 1333,
  [5297] = 1357,
  [5298] = 5270,
  [5299] = 1358,
  [5300] = 5249,
  [5301] = 1462,
  [5302] = 5263,
  [5303] = 1409,
  [5304] = 2580,
  [5305] = 5004,
  [5306] = 1407,
  [5307] = 1458,
  [5308] = 1404,
  [5309] = 1403,
  [5310] = 1390,
  [5311] = 5263,
  [5312] = 1345,
  [5313] = 1365,
  [5314] = 1374,
  [5315] = 4974,
  [5316] = 1376,
  [5317] = 1315,
  [5318] = 1382,
  [5319] = 1385,
  [5320] = 1395,
  [5321] = 1396,
  [5322] = 1394,
  [5323] = 2818,
  [5324] = 2598,
  [5325] = 2580,
  [5326] = 2580,
  [5327] = 2598,
  [5328] = 2986,
  [5329] = 1209,
  [5330] = 2580,
  [5331] = 2598,
  [5332] = 5332,
  [5333] = 5332,
  [5334] = 5334,
  [5335] = 5332,
  [5336] = 5332,
  [5337] = 2818,
  [5338] = 5332,
  [5339] = 5332,
  [5340] = 3470,
  [5341] = 1212,
  [5342] = 3496,
  [5343] = 5332,
  [5344] = 1195,
  [5345] = 1198,
  [5346] = 5346,
  [5347] = 1197,
  [5348] = 1194,
  [5349] = 2818,
  [5350] = 5332,
  [5351] = 2818,
  [5352] = 1208,
  [5353] = 2987,
  [5354] = 3573,
  [5355] = 3569,
  [5356] = 3516,
  [5357] = 2999,
  [5358] = 1458,
  [5359] = 5359,
  [5360] = 5359,
  [5361] = 2987,
  [5362] = 2986,
  [5363] = 1212,
  [5364] = 5359,
  [5365] = 1198,
  [5366] = 1225,
  [5367] = 1197,
  [5368] = 1194,
  [5369] = 1455,
  [5370] = 3569,
  [5371] = 1182,
  [5372] = 3470,
  [5373] = 1210,
  [5374] = 1214,
  [5375] = 3496,
  [5376] = 1209,
  [5377] = 2986,
  [5378] = 1454,
  [5379] = 2987,
  [5380] = 1208,
  [5381] = 5359,
  [5382] = 1447,
  [5383] = 5359,
  [5384] = 1211,
  [5385] = 3516,
  [5386] = 5386,
  [5387] = 1195,
  [5388] = 2999,
  [5389] = 3573,
  [5390] = 1198,
  [5391] = 5391,
  [5392] = 1401,
  [5393] = 2999,
  [5394] = 2999,
  [5395] = 5359,
  [5396] = 1209,
  [5397] = 2818,
  [5398] = 2987,
  [5399] = 5359,
  [5400] = 1208,
  [5401] = 1195,
  [5402] = 1212,
  [5403] = 1195,
  [5404] = 2986,
  [5405] = 5359,
  [5406] = 1197,
  [5407] = 1212,
  [5408] = 1208,
  [5409] = 1194,
  [5410] = 1194,
  [5411] = 1203,
  [5412] = 2818,
  [5413] = 1198,
  [5414] = 1209,
  [5415] = 1197,
  [5416] = 2986,
  [5417] = 2986,
  [5418] = 1221,
  [5419] = 3470,
  [5420] = 1209,
  [5421] = 5421,
  [5422] = 3496,
  [5423] = 1208,
  [5424] = 3516,
  [5425] = 1203,
  [5426] = 1210,
  [5427] = 3516,
  [5428] = 1203,
  [5429] = 1210,
  [5430] = 3496,
  [5431] = 5431,
  [5432] = 3573,
  [5433] = 1209,
  [5434] = 1215,
  [5435] = 1214,
  [5436] = 3569,
  [5437] = 1214,
  [5438] = 3470,
  [5439] = 1206,
  [5440] = 1208,
  [5441] = 2818,
  [5442] = 1225,
  [5443] = 1225,
  [5444] = 1198,
  [5445] = 1203,
  [5446] = 1197,
  [5447] = 1198,
  [5448] = 1210,
  [5449] = 5449,
  [5450] = 1205,
  [5451] = 1209,
  [5452] = 3569,
  [5453] = 1208,
  [5454] = 1211,
  [5455] = 2987,
  [5456] = 1195,
  [5457] = 1211,
  [5458] = 1195,
  [5459] = 1229,
  [5460] = 1194,
  [5461] = 1194,
  [5462] = 1197,
  [5463] = 1212,
  [5464] = 1212,
  [5465] = 1198,
  [5466] = 2999,
  [5467] = 1197,
  [5468] = 1194,
  [5469] = 1211,
  [5470] = 3573,
  [5471] = 1195,
  [5472] = 5472,
  [5473] = 1214,
  [5474] = 2987,
  [5475] = 1212,
  [5476] = 1225,
  [5477] = 2999,
  [5478] = 5478,
  [5479] = 1222,
  [5480] = 5480,
  [5481] = 3573,
  [5482] = 5480,
  [5483] = 5480,
  [5484] = 5484,
  [5485] = 1184,
  [5486] = 5480,
  [5487] = 3516,
  [5488] = 1215,
  [5489] = 3516,
  [5490] = 5480,
  [5491] = 3496,
  [5492] = 1225,
  [5493] = 1206,
  [5494] = 3470,
  [5495] = 3573,
  [5496] = 3569,
  [5497] = 1219,
  [5498] = 1214,
  [5499] = 1211,
  [5500] = 3496,
  [5501] = 5480,
  [5502] = 1206,
  [5503] = 1221,
  [5504] = 1205,
  [5505] = 5480,
  [5506] = 5480,
  [5507] = 5480,
  [5508] = 3470,
  [5509] = 1205,
  [5510] = 1215,
  [5511] = 5511,
  [5512] = 1205,
  [5513] = 5480,
  [5514] = 1221,
  [5515] = 5480,
  [5516] = 1229,
  [5517] = 1211,
  [5518] = 1229,
  [5519] = 5480,
  [5520] = 1224,
  [5521] = 1223,
  [5522] = 5522,
  [5523] = 5523,
  [5524] = 1225,
  [5525] = 1228,
  [5526] = 1229,
  [5527] = 5527,
  [5528] = 1213,
  [5529] = 1203,
  [5530] = 1226,
  [5531] = 1230,
  [5532] = 1210,
  [5533] = 5480,
  [5534] = 1206,
  [5535] = 3569,
  [5536] = 5480,
  [5537] = 1214,
  [5538] = 1221,
  [5539] = 5480,
  [5540] = 1203,
  [5541] = 1220,
  [5542] = 1214,
  [5543] = 1225,
  [5544] = 1210,
  [5545] = 1211,
  [5546] = 1210,
  [5547] = 5480,
  [5548] = 2999,
  [5549] = 2987,
  [5550] = 2986,
  [5551] = 1217,
  [5552] = 1215,
  [5553] = 1218,
  [5554] = 1203,
  [5555] = 1216,
  [5556] = 3470,
  [5557] = 1228,
  [5558] = 1216,
  [5559] = 5559,
  [5560] = 1217,
  [5561] = 5559,
  [5562] = 5559,
  [5563] = 5563,
  [5564] = 3569,
  [5565] = 3573,
  [5566] = 1215,
  [5567] = 1203,
  [5568] = 1228,
  [5569] = 1221,
  [5570] = 1216,
  [5571] = 1226,
  [5572] = 1229,
  [5573] = 1221,
  [5574] = 1206,
  [5575] = 5563,
  [5576] = 5563,
  [5577] = 1206,
  [5578] = 1205,
  [5579] = 1230,
  [5580] = 5580,
  [5581] = 5581,
  [5582] = 1229,
  [5583] = 1210,
  [5584] = 5581,
  [5585] = 1221,
  [5586] = 5580,
  [5587] = 1218,
  [5588] = 1236,
  [5589] = 1222,
  [5590] = 1228,
  [5591] = 1223,
  [5592] = 1224,
  [5593] = 1223,
  [5594] = 1217,
  [5595] = 5563,
  [5596] = 5559,
  [5597] = 1213,
  [5598] = 1220,
  [5599] = 1206,
  [5600] = 1220,
  [5601] = 5601,
  [5602] = 1224,
  [5603] = 1216,
  [5604] = 1222,
  [5605] = 5580,
  [5606] = 1219,
  [5607] = 3496,
  [5608] = 1222,
  [5609] = 1218,
  [5610] = 1223,
  [5611] = 1211,
  [5612] = 5581,
  [5613] = 1224,
  [5614] = 3516,
  [5615] = 1205,
  [5616] = 5581,
  [5617] = 1229,
  [5618] = 1215,
  [5619] = 1220,
  [5620] = 5580,
  [5621] = 1230,
  [5622] = 1182,
  [5623] = 5580,
  [5624] = 1226,
  [5625] = 5559,
  [5626] = 1219,
  [5627] = 1213,
  [5628] = 5628,
  [5629] = 1219,
  [5630] = 1215,
  [5631] = 1230,
  [5632] = 5563,
  [5633] = 1217,
  [5634] = 1226,
  [5635] = 1218,
  [5636] = 1205,
  [5637] = 5581,
  [5638] = 1213,
  [5639] = 5639,
  [5640] = 5640,
  [5641] = 5641,
  [5642] = 5642,
  [5643] = 5643,
  [5644] = 5644,
  [5645] = 5645,
  [5646] = 1222,
  [5647] = 5647,
  [5648] = 5648,
  [5649] = 5649,
  [5650] = 5650,
  [5651] = 5651,
  [5652] = 5640,
  [5653] = 5653,
  [5654] = 5654,
  [5655] = 5643,
  [5656] = 5656,
  [5657] = 5657,
  [5658] = 5658,
  [5659] = 5651,
  [5660] = 5660,
  [5661] = 1223,
  [5662] = 5662,
  [5663] = 5640,
  [5664] = 5656,
  [5665] = 5665,
  [5666] = 5666,
  [5667] = 5651,
  [5668] = 5640,
  [5669] = 5656,
  [5670] = 5670,
  [5671] = 5671,
  [5672] = 1224,
  [5673] = 5654,
  [5674] = 5674,
  [5675] = 5675,
  [5676] = 5651,
  [5677] = 5665,
  [5678] = 5640,
  [5679] = 5656,
  [5680] = 5653,
  [5681] = 5656,
  [5682] = 5641,
  [5683] = 5643,
  [5684] = 5640,
  [5685] = 5645,
  [5686] = 5666,
  [5687] = 5651,
  [5688] = 5674,
  [5689] = 5674,
  [5690] = 5690,
  [5691] = 5651,
  [5692] = 5640,
  [5693] = 5656,
  [5694] = 5648,
  [5695] = 5695,
  [5696] = 5639,
  [5697] = 5651,
  [5698] = 5644,
  [5699] = 5640,
  [5700] = 5656,
  [5701] = 5674,
  [5702] = 5651,
  [5703] = 5640,
  [5704] = 5656,
  [5705] = 5649,
  [5706] = 5639,
  [5707] = 5674,
  [5708] = 5675,
  [5709] = 5649,
  [5710] = 5653,
  [5711] = 5671,
  [5712] = 5647,
  [5713] = 5670,
  [5714] = 5651,
  [5715] = 5660,
  [5716] = 5640,
  [5717] = 5656,
  [5718] = 5658,
  [5719] = 5719,
  [5720] = 5658,
  [5721] = 5648,
  [5722] = 5674,
  [5723] = 5675,
  [5724] = 5651,
  [5725] = 5725,
  [5726] = 5648,
  [5727] = 5727,
  [5728] = 5647,
  [5729] = 5660,
  [5730] = 5640,
  [5731] = 5656,
  [5732] = 5657,
  [5733] = 5648,
  [5734] = 5719,
  [5735] = 5648,
  [5736] = 5670,
  [5737] = 5648,
  [5738] = 1267,
  [5739] = 5658,
  [5740] = 5644,
  [5741] = 5670,
  [5742] = 5656,
  [5743] = 5640,
  [5744] = 5651,
  [5745] = 5656,
  [5746] = 5674,
  [5747] = 5747,
  [5748] = 5642,
  [5749] = 5671,
  [5750] = 5656,
  [5751] = 5719,
  [5752] = 5719,
  [5753] = 5648,
  [5754] = 5641,
  [5755] = 5648,
  [5756] = 5648,
  [5757] = 5653,
  [5758] = 5719,
  [5759] = 5648,
  [5760] = 5665,
  [5761] = 5648,
  [5762] = 5662,
  [5763] = 5675,
  [5764] = 5674,
  [5765] = 5653,
  [5766] = 5648,
  [5767] = 5639,
  [5768] = 5719,
  [5769] = 5648,
  [5770] = 5651,
  [5771] = 5640,
  [5772] = 5639,
  [5773] = 5656,
  [5774] = 5656,
  [5775] = 5648,
  [5776] = 5640,
  [5777] = 5651,
  [5778] = 5674,
  [5779] = 5642,
  [5780] = 5648,
  [5781] = 5781,
  [5782] = 5648,
  [5783] = 5674,
  [5784] = 5651,
  [5785] = 5674,
  [5786] = 5651,
  [5787] = 5645,
  [5788] = 5640,
  [5789] = 5640,
  [5790] = 5651,
  [5791] = 5640,
  [5792] = 5792,
  [5793] = 5656,
  [5794] = 5643,
  [5795] = 5645,
  [5796] = 5643,
  [5797] = 1222,
  [5798] = 5656,
  [5799] = 5656,
  [5800] = 5648,
  [5801] = 5674,
  [5802] = 5657,
  [5803] = 5648,
  [5804] = 5675,
  [5805] = 5658,
  [5806] = 5670,
  [5807] = 5656,
  [5808] = 1279,
  [5809] = 5640,
  [5810] = 1223,
  [5811] = 5651,
  [5812] = 5671,
  [5813] = 5642,
  [5814] = 5670,
  [5815] = 5651,
  [5816] = 5816,
  [5817] = 5660,
  [5818] = 5641,
  [5819] = 1224,
  [5820] = 5658,
  [5821] = 5648,
  [5822] = 5671,
  [5823] = 5647,
  [5824] = 5648,
  [5825] = 5648,
  [5826] = 5653,
  [5827] = 5639,
  [5828] = 5644,
  [5829] = 5648,
  [5830] = 5640,
  [5831] = 5648,
  [5832] = 5648,
  [5833] = 5656,
  [5834] = 5648,
  [5835] = 5665,
  [5836] = 5649,
  [5837] = 5837,
  [5838] = 5648,
  [5839] = 5657,
  [5840] = 5641,
  [5841] = 5643,
  [5842] = 5648,
  [5843] = 5645,
  [5844] = 5674,
  [5845] = 5648,
  [5846] = 5651,
  [5847] = 5648,
  [5848] = 5658,
  [5849] = 5670,
  [5850] = 5656,
  [5851] = 5640,
  [5852] = 5651,
  [5853] = 5674,
  [5854] = 5640,
  [5855] = 5648,
  [5856] = 5719,
  [5857] = 5642,
  [5858] = 5666,
  [5859] = 5665,
  [5860] = 5648,
  [5861] = 5656,
  [5862] = 5662,
  [5863] = 5653,
  [5864] = 5648,
  [5865] = 5648,
  [5866] = 5649,
  [5867] = 5653,
  [5868] = 5644,
  [5869] = 5648,
  [5870] = 5640,
  [5871] = 5651,
  [5872] = 5674,
  [5873] = 5651,
  [5874] = 5640,
  [5875] = 5656,
  [5876] = 5648,
  [5877] = 5648,
  [5878] = 5639,
  [5879] = 5674,
  [5880] = 5651,
  [5881] = 5675,
  [5882] = 5648,
  [5883] = 5670,
  [5884] = 5648,
  [5885] = 5671,
  [5886] = 5657,
  [5887] = 5653,
  [5888] = 5640,
  [5889] = 5670,
  [5890] = 5656,
  [5891] = 5891,
  [5892] = 5648,
  [5893] = 5660,
  [5894] = 5656,
  [5895] = 5662,
  [5896] = 5640,
  [5897] = 5665,
  [5898] = 5651,
  [5899] = 5640,
  [5900] = 5658,
  [5901] = 1269,
  [5902] = 5651,
  [5903] = 5666,
  [5904] = 5666,
  [5905] = 5674,
  [5906] = 5648,
  [5907] = 5642,
  [5908] = 5647,
  [5909] = 5648,
  [5910] = 5653,
  [5911] = 5656,
  [5912] = 5644,
  [5913] = 5662,
  [5914] = 5648,
  [5915] = 5649,
  [5916] = 5916,
  [5917] = 5641,
  [5918] = 5648,
  [5919] = 5639,
  [5920] = 5648,
  [5921] = 5656,
  [5922] = 5640,
  [5923] = 5651,
  [5924] = 5654,
  [5925] = 5674,
  [5926] = 5648,
  [5927] = 5674,
  [5928] = 1222,
  [5929] = 5657,
  [5930] = 5674,
  [5931] = 5648,
  [5932] = 5653,
  [5933] = 5665,
  [5934] = 5651,
  [5935] = 5719,
  [5936] = 5662,
  [5937] = 5937,
  [5938] = 5653,
  [5939] = 5642,
  [5940] = 5648,
  [5941] = 1223,
  [5942] = 5647,
  [5943] = 5656,
  [5944] = 5648,
  [5945] = 5656,
  [5946] = 5640,
  [5947] = 5651,
  [5948] = 5640,
  [5949] = 5656,
  [5950] = 5651,
  [5951] = 5674,
  [5952] = 5639,
  [5953] = 5674,
  [5954] = 5660,
  [5955] = 5675,
  [5956] = 5671,
  [5957] = 5670,
  [5958] = 5653,
  [5959] = 5657,
  [5960] = 5660,
  [5961] = 5658,
  [5962] = 1224,
  [5963] = 5656,
  [5964] = 5640,
  [5965] = 5651,
  [5966] = 5674,
  [5967] = 5647,
  [5968] = 5642,
  [5969] = 5651,
  [5970] = 1182,
  [5971] = 5648,
  [5972] = 5644,
  [5973] = 5973,
  [5974] = 5674,
  [5975] = 5656,
  [5976] = 5640,
  [5977] = 5651,
  [5978] = 5640,
  [5979] = 5651,
  [5980] = 5674,
  [5981] = 5640,
  [5982] = 5639,
  [5983] = 5656,
  [5984] = 5656,
  [5985] = 5640,
  [5986] = 5651,
  [5987] = 5674,
  [5988] = 5648,
  [5989] = 5657,
  [5990] = 5666,
  [5991] = 5665,
  [5992] = 5662,
  [5993] = 5648,
  [5994] = 5653,
  [5995] = 5642,
  [5996] = 1228,
  [5997] = 5656,
  [5998] = 5640,
  [5999] = 5651,
  [6000] = 5674,
  [6001] = 6001,
  [6002] = 5651,
  [6003] = 5640,
  [6004] = 5656,
  [6005] = 5639,
  [6006] = 5690,
  [6007] = 5675,
  [6008] = 5656,
  [6009] = 1216,
  [6010] = 5657,
  [6011] = 5674,
  [6012] = 5671,
  [6013] = 5651,
  [6014] = 5640,
  [6015] = 5651,
  [6016] = 5670,
  [6017] = 5674,
  [6018] = 5649,
  [6019] = 5660,
  [6020] = 5648,
  [6021] = 5658,
  [6022] = 5640,
  [6023] = 5656,
  [6024] = 5656,
  [6025] = 5973,
  [6026] = 5640,
  [6027] = 5651,
  [6028] = 5657,
  [6029] = 5642,
  [6030] = 5647,
  [6031] = 5674,
  [6032] = 5644,
  [6033] = 1268,
  [6034] = 5645,
  [6035] = 5643,
  [6036] = 5644,
  [6037] = 5674,
  [6038] = 5651,
  [6039] = 5640,
  [6040] = 5656,
  [6041] = 5656,
  [6042] = 5641,
  [6043] = 5640,
  [6044] = 5651,
  [6045] = 5643,
  [6046] = 1213,
  [6047] = 5674,
  [6048] = 5639,
  [6049] = 5653,
  [6050] = 5645,
  [6051] = 5647,
  [6052] = 5674,
  [6053] = 5651,
  [6054] = 5648,
  [6055] = 5640,
  [6056] = 5656,
  [6057] = 5658,
  [6058] = 5642,
  [6059] = 5641,
  [6060] = 5690,
  [6061] = 6061,
  [6062] = 5656,
  [6063] = 5648,
  [6064] = 5640,
  [6065] = 5651,
  [6066] = 5674,
  [6067] = 5651,
  [6068] = 5665,
  [6069] = 5662,
  [6070] = 5656,
  [6071] = 5640,
  [6072] = 5651,
  [6073] = 5674,
  [6074] = 5653,
  [6075] = 5973,
  [6076] = 5660,
  [6077] = 5639,
  [6078] = 5648,
  [6079] = 6079,
  [6080] = 5656,
  [6081] = 5640,
  [6082] = 5640,
  [6083] = 1226,
  [6084] = 5651,
  [6085] = 1230,
  [6086] = 5656,
  [6087] = 6087,
  [6088] = 5674,
  [6089] = 5651,
  [6090] = 5640,
  [6091] = 5670,
  [6092] = 5656,
  [6093] = 5671,
  [6094] = 1221,
  [6095] = 5649,
  [6096] = 5639,
  [6097] = 5675,
  [6098] = 5675,
  [6099] = 5651,
  [6100] = 5671,
  [6101] = 5656,
  [6102] = 5670,
  [6103] = 5640,
  [6104] = 5639,
  [6105] = 5639,
  [6106] = 5656,
  [6107] = 5640,
  [6108] = 5639,
  [6109] = 5651,
  [6110] = 5660,
  [6111] = 1220,
  [6112] = 1219,
  [6113] = 5656,
  [6114] = 5640,
  [6115] = 1217,
  [6116] = 1218,
  [6117] = 5648,
  [6118] = 5658,
  [6119] = 5656,
  [6120] = 5651,
  [6121] = 5640,
  [6122] = 1218,
  [6123] = 5674,
  [6124] = 1222,
  [6125] = 1219,
  [6126] = 1220,
  [6127] = 1223,
  [6128] = 1224,
  [6129] = 5651,
  [6130] = 1216,
  [6131] = 5647,
  [6132] = 5639,
  [6133] = 5656,
  [6134] = 5640,
  [6135] = 6135,
  [6136] = 5651,
  [6137] = 5644,
  [6138] = 5658,
  [6139] = 5656,
  [6140] = 5640,
  [6141] = 5639,
  [6142] = 5651,
  [6143] = 5674,
  [6144] = 5690,
  [6145] = 1217,
  [6146] = 5645,
  [6147] = 5674,
  [6148] = 5656,
  [6149] = 5651,
  [6150] = 5640,
  [6151] = 5639,
  [6152] = 5651,
  [6153] = 5674,
  [6154] = 1230,
  [6155] = 5640,
  [6156] = 5648,
  [6157] = 5656,
  [6158] = 5640,
  [6159] = 5656,
  [6160] = 1226,
  [6161] = 1228,
  [6162] = 5651,
  [6163] = 6163,
  [6164] = 1213,
  [6165] = 5639,
  [6166] = 5674,
  [6167] = 5639,
  [6168] = 1226,
  [6169] = 1230,
  [6170] = 5674,
  [6171] = 5654,
  [6172] = 5639,
  [6173] = 5656,
  [6174] = 1220,
  [6175] = 1219,
  [6176] = 5640,
  [6177] = 5639,
  [6178] = 5665,
  [6179] = 5651,
  [6180] = 5674,
  [6181] = 5662,
  [6182] = 1218,
  [6183] = 1213,
  [6184] = 1228,
  [6185] = 1216,
  [6186] = 1217,
  [6187] = 5653,
  [6188] = 5656,
  [6189] = 5639,
  [6190] = 5640,
  [6191] = 5639,
  [6192] = 5651,
  [6193] = 5639,
  [6194] = 5639,
  [6195] = 5511,
  [6196] = 3740,
  [6197] = 1184,
  [6198] = 3751,
  [6199] = 2818,
  [6200] = 5523,
  [6201] = 3725,
  [6202] = 1396,
  [6203] = 6203,
  [6204] = 1454,
  [6205] = 6205,
  [6206] = 6206,
  [6207] = 1209,
  [6208] = 1455,
  [6209] = 4946,
  [6210] = 1208,
  [6211] = 2987,
  [6212] = 3786,
  [6213] = 1253,
  [6214] = 1212,
  [6215] = 6215,
  [6216] = 1458,
  [6217] = 2999,
  [6218] = 3804,
  [6219] = 2986,
  [6220] = 1394,
  [6221] = 6205,
  [6222] = 6222,
  [6223] = 3730,
  [6224] = 3726,
  [6225] = 1209,
  [6226] = 3734,
  [6227] = 3735,
  [6228] = 6228,
  [6229] = 3749,
  [6230] = 3755,
  [6231] = 1401,
  [6232] = 1208,
  [6233] = 3732,
  [6234] = 1203,
  [6235] = 3729,
  [6236] = 1402,
  [6237] = 1317,
  [6238] = 1345,
  [6239] = 1351,
  [6240] = 1195,
  [6241] = 6241,
  [6242] = 1374,
  [6243] = 1390,
  [6244] = 1376,
  [6245] = 1315,
  [6246] = 3751,
  [6247] = 1382,
  [6248] = 1385,
  [6249] = 1210,
  [6250] = 1395,
  [6251] = 1197,
  [6252] = 1398,
  [6253] = 1403,
  [6254] = 6205,
  [6255] = 2999,
  [6256] = 4928,
  [6257] = 1404,
  [6258] = 2987,
  [6259] = 1407,
  [6260] = 1408,
  [6261] = 4929,
  [6262] = 1409,
  [6263] = 6222,
  [6264] = 1462,
  [6265] = 6215,
  [6266] = 3853,
  [6267] = 1447,
  [6268] = 1358,
  [6269] = 1357,
  [6270] = 1194,
  [6271] = 1197,
  [6272] = 6272,
  [6273] = 1212,
  [6274] = 6206,
  [6275] = 6272,
  [6276] = 6276,
  [6277] = 3740,
  [6278] = 6215,
  [6279] = 3725,
  [6280] = 6222,
  [6281] = 1356,
  [6282] = 1355,
  [6283] = 6215,
  [6284] = 1438,
  [6285] = 1366,
  [6286] = 1195,
  [6287] = 1347,
  [6288] = 1332,
  [6289] = 6289,
  [6290] = 6272,
  [6291] = 1413,
  [6292] = 1365,
  [6293] = 6293,
  [6294] = 6294,
  [6295] = 6205,
  [6296] = 1198,
  [6297] = 6222,
  [6298] = 4930,
  [6299] = 6206,
  [6300] = 1194,
  [6301] = 4950,
  [6302] = 6272,
  [6303] = 2986,
  [6304] = 6206,
  [6305] = 1198,
  [6306] = 6306,
  [6307] = 4952,
  [6308] = 1184,
  [6309] = 3516,
  [6310] = 3804,
  [6311] = 3496,
  [6312] = 1253,
  [6313] = 6313,
  [6314] = 3569,
  [6315] = 6315,
  [6316] = 1224,
  [6317] = 6317,
  [6318] = 1225,
  [6319] = 3778,
  [6320] = 3814,
  [6321] = 1211,
  [6322] = 3810,
  [6323] = 3759,
  [6324] = 1203,
  [6325] = 6325,
  [6326] = 6326,
  [6327] = 3779,
  [6328] = 1223,
  [6329] = 3496,
  [6330] = 5792,
  [6331] = 1214,
  [6332] = 3819,
  [6333] = 3824,
  [6334] = 6334,
  [6335] = 3573,
  [6336] = 1211,
  [6337] = 3828,
  [6338] = 6338,
  [6339] = 3818,
  [6340] = 3729,
  [6341] = 4124,
  [6342] = 3798,
  [6343] = 1253,
  [6344] = 3744,
  [6345] = 3843,
  [6346] = 3833,
  [6347] = 3846,
  [6348] = 3853,
  [6349] = 3822,
  [6350] = 3762,
  [6351] = 3758,
  [6352] = 3732,
  [6353] = 3844,
  [6354] = 3805,
  [6355] = 1203,
  [6356] = 3859,
  [6357] = 3516,
  [6358] = 3804,
  [6359] = 3837,
  [6360] = 3470,
  [6361] = 1222,
  [6362] = 3830,
  [6363] = 1210,
  [6364] = 6334,
  [6365] = 3786,
  [6366] = 6366,
  [6367] = 3811,
  [6368] = 6368,
  [6369] = 3807,
  [6370] = 5816,
  [6371] = 3781,
  [6372] = 3569,
  [6373] = 3801,
  [6374] = 3870,
  [6375] = 1225,
  [6376] = 3470,
  [6377] = 3780,
  [6378] = 3786,
  [6379] = 3776,
  [6380] = 6380,
  [6381] = 6334,
  [6382] = 3788,
  [6383] = 3829,
  [6384] = 3863,
  [6385] = 3864,
  [6386] = 3789,
  [6387] = 3730,
  [6388] = 3813,
  [6389] = 4335,
  [6390] = 3879,
  [6391] = 3847,
  [6392] = 3820,
  [6393] = 3808,
  [6394] = 5781,
  [6395] = 3726,
  [6396] = 3800,
  [6397] = 3823,
  [6398] = 3573,
  [6399] = 1214,
  [6400] = 3793,
  [6401] = 6401,
  [6402] = 3838,
  [6403] = 3755,
  [6404] = 3749,
  [6405] = 1221,
  [6406] = 6334,
  [6407] = 3854,
  [6408] = 1210,
  [6409] = 6409,
  [6410] = 3860,
  [6411] = 3735,
  [6412] = 3774,
  [6413] = 6413,
  [6414] = 6414,
  [6415] = 3734,
  [6416] = 1206,
  [6417] = 1215,
  [6418] = 3870,
  [6419] = 3735,
  [6420] = 3749,
  [6421] = 1197,
  [6422] = 1209,
  [6423] = 3755,
  [6424] = 1198,
  [6425] = 3798,
  [6426] = 6426,
  [6427] = 1194,
  [6428] = 1198,
  [6429] = 3730,
  [6430] = 3805,
  [6431] = 3726,
  [6432] = 3730,
  [6433] = 6433,
  [6434] = 1221,
  [6435] = 1229,
  [6436] = 3732,
  [6437] = 3758,
  [6438] = 3860,
  [6439] = 1197,
  [6440] = 1194,
  [6441] = 3726,
  [6442] = 3729,
  [6443] = 1209,
  [6444] = 1253,
  [6445] = 3774,
  [6446] = 3864,
  [6447] = 3751,
  [6448] = 3734,
  [6449] = 1195,
  [6450] = 6450,
  [6451] = 1212,
  [6452] = 3735,
  [6453] = 3749,
  [6454] = 3744,
  [6455] = 1195,
  [6456] = 3755,
  [6457] = 3780,
  [6458] = 3788,
  [6459] = 3732,
  [6460] = 4349,
  [6461] = 3786,
  [6462] = 6462,
  [6463] = 3729,
  [6464] = 3811,
  [6465] = 3847,
  [6466] = 3804,
  [6467] = 3808,
  [6468] = 3800,
  [6469] = 3758,
  [6470] = 3776,
  [6471] = 3830,
  [6472] = 3837,
  [6473] = 3859,
  [6474] = 1221,
  [6475] = 1208,
  [6476] = 1205,
  [6477] = 6409,
  [6478] = 3807,
  [6479] = 3789,
  [6480] = 6480,
  [6481] = 3779,
  [6482] = 3781,
  [6483] = 3744,
  [6484] = 3814,
  [6485] = 3823,
  [6486] = 3829,
  [6487] = 3810,
  [6488] = 1215,
  [6489] = 1229,
  [6490] = 3759,
  [6491] = 3819,
  [6492] = 4124,
  [6493] = 6315,
  [6494] = 3844,
  [6495] = 3758,
  [6496] = 6496,
  [6497] = 6317,
  [6498] = 3762,
  [6499] = 4335,
  [6500] = 3725,
  [6501] = 1206,
  [6502] = 3793,
  [6503] = 3801,
  [6504] = 1208,
  [6505] = 3778,
  [6506] = 3846,
  [6507] = 3879,
  [6508] = 3843,
  [6509] = 3833,
  [6510] = 3822,
  [6511] = 4350,
  [6512] = 3744,
  [6513] = 3813,
  [6514] = 3725,
  [6515] = 1212,
  [6516] = 3740,
  [6517] = 3740,
  [6518] = 1205,
  [6519] = 3828,
  [6520] = 3820,
  [6521] = 6521,
  [6522] = 3818,
  [6523] = 3824,
  [6524] = 3838,
  [6525] = 4335,
  [6526] = 3751,
  [6527] = 6527,
  [6528] = 6325,
  [6529] = 3854,
  [6530] = 3863,
  [6531] = 6531,
  [6532] = 6368,
  [6533] = 3734,
  [6534] = 1226,
  [6535] = 3729,
  [6536] = 1198,
  [6537] = 4349,
  [6538] = 3758,
  [6539] = 1208,
  [6540] = 3853,
  [6541] = 1195,
  [6542] = 1194,
  [6543] = 3820,
  [6544] = 3822,
  [6545] = 1214,
  [6546] = 1194,
  [6547] = 3811,
  [6548] = 1197,
  [6549] = 1225,
  [6550] = 1228,
  [6551] = 3833,
  [6552] = 1198,
  [6553] = 3725,
  [6554] = 1217,
  [6555] = 1216,
  [6556] = 3758,
  [6557] = 1218,
  [6558] = 1219,
  [6559] = 1220,
  [6560] = 4335,
  [6561] = 3730,
  [6562] = 3843,
  [6563] = 3810,
  [6564] = 3726,
  [6565] = 1198,
  [6566] = 1203,
  [6567] = 3759,
  [6568] = 1210,
  [6569] = 3819,
  [6570] = 3824,
  [6571] = 6571,
  [6572] = 4350,
  [6573] = 1230,
  [6574] = 3734,
  [6575] = 3744,
  [6576] = 1209,
  [6577] = 6577,
  [6578] = 1197,
  [6579] = 3751,
  [6580] = 3735,
  [6581] = 3781,
  [6582] = 3843,
  [6583] = 3779,
  [6584] = 3833,
  [6585] = 3749,
  [6586] = 3755,
  [6587] = 3828,
  [6588] = 3818,
  [6589] = 3824,
  [6590] = 3798,
  [6591] = 3838,
  [6592] = 3786,
  [6593] = 3822,
  [6594] = 3819,
  [6595] = 3759,
  [6596] = 3828,
  [6597] = 3732,
  [6598] = 1194,
  [6599] = 3800,
  [6600] = 1213,
  [6601] = 3810,
  [6602] = 3818,
  [6603] = 1213,
  [6604] = 1228,
  [6605] = 1211,
  [6606] = 3730,
  [6607] = 3846,
  [6608] = 3726,
  [6609] = 3762,
  [6610] = 3798,
  [6611] = 1211,
  [6612] = 1222,
  [6613] = 3808,
  [6614] = 3734,
  [6615] = 3778,
  [6616] = 3735,
  [6617] = 3749,
  [6618] = 3805,
  [6619] = 3804,
  [6620] = 3755,
  [6621] = 3847,
  [6622] = 3844,
  [6623] = 3732,
  [6624] = 4349,
  [6625] = 6625,
  [6626] = 3859,
  [6627] = 1195,
  [6628] = 3837,
  [6629] = 3830,
  [6630] = 3829,
  [6631] = 1197,
  [6632] = 1212,
  [6633] = 1195,
  [6634] = 3778,
  [6635] = 3870,
  [6636] = 3829,
  [6637] = 1212,
  [6638] = 3863,
  [6639] = 3823,
  [6640] = 3823,
  [6641] = 3864,
  [6642] = 1253,
  [6643] = 3879,
  [6644] = 6644,
  [6645] = 3781,
  [6646] = 3740,
  [6647] = 1224,
  [6648] = 1225,
  [6649] = 1208,
  [6650] = 3776,
  [6651] = 3807,
  [6652] = 3813,
  [6653] = 4335,
  [6654] = 1209,
  [6655] = 1208,
  [6656] = 3814,
  [6657] = 4350,
  [6658] = 3820,
  [6659] = 1214,
  [6660] = 1224,
  [6661] = 3779,
  [6662] = 3853,
  [6663] = 3813,
  [6664] = 1198,
  [6665] = 3774,
  [6666] = 3729,
  [6667] = 1223,
  [6668] = 6668,
  [6669] = 4358,
  [6670] = 1224,
  [6671] = 3780,
  [6672] = 1197,
  [6673] = 1194,
  [6674] = 3788,
  [6675] = 3786,
  [6676] = 3789,
  [6677] = 3846,
  [6678] = 6678,
  [6679] = 1217,
  [6680] = 3762,
  [6681] = 1197,
  [6682] = 3793,
  [6683] = 1194,
  [6684] = 3793,
  [6685] = 3800,
  [6686] = 3789,
  [6687] = 3808,
  [6688] = 3838,
  [6689] = 1212,
  [6690] = 1212,
  [6691] = 3844,
  [6692] = 1198,
  [6693] = 1216,
  [6694] = 3725,
  [6695] = 1226,
  [6696] = 3751,
  [6697] = 3864,
  [6698] = 1230,
  [6699] = 3744,
  [6700] = 3740,
  [6701] = 3863,
  [6702] = 3788,
  [6703] = 3859,
  [6704] = 1195,
  [6705] = 1209,
  [6706] = 3776,
  [6707] = 6707,
  [6708] = 3804,
  [6709] = 1222,
  [6710] = 1209,
  [6711] = 1218,
  [6712] = 3837,
  [6713] = 3860,
  [6714] = 3854,
  [6715] = 3780,
  [6716] = 3774,
  [6717] = 3814,
  [6718] = 1208,
  [6719] = 3879,
  [6720] = 1223,
  [6721] = 1203,
  [6722] = 3870,
  [6723] = 3847,
  [6724] = 6724,
  [6725] = 1195,
  [6726] = 3801,
  [6727] = 6727,
  [6728] = 1210,
  [6729] = 1222,
  [6730] = 1219,
  [6731] = 3860,
  [6732] = 3854,
  [6733] = 1220,
  [6734] = 3830,
  [6735] = 3811,
  [6736] = 1212,
  [6737] = 3807,
  [6738] = 3801,
  [6739] = 1208,
  [6740] = 3805,
  [6741] = 1253,
  [6742] = 1223,
  [6743] = 1209,
  [6744] = 1225,
  [6745] = 4350,
  [6746] = 3800,
  [6747] = 3829,
  [6748] = 1225,
  [6749] = 3823,
  [6750] = 1214,
  [6751] = 3808,
  [6752] = 1195,
  [6753] = 3734,
  [6754] = 3793,
  [6755] = 3843,
  [6756] = 3813,
  [6757] = 3860,
  [6758] = 1214,
  [6759] = 3819,
  [6760] = 4350,
  [6761] = 3805,
  [6762] = 3837,
  [6763] = 3804,
  [6764] = 3776,
  [6765] = 4350,
  [6766] = 6766,
  [6767] = 1212,
  [6768] = 1212,
  [6769] = 3759,
  [6770] = 1211,
  [6771] = 3830,
  [6772] = 3833,
  [6773] = 1211,
  [6774] = 6766,
  [6775] = 3844,
  [6776] = 1221,
  [6777] = 3847,
  [6778] = 1182,
  [6779] = 3804,
  [6780] = 3810,
  [6781] = 3735,
  [6782] = 3726,
  [6783] = 3778,
  [6784] = 1229,
  [6785] = 1211,
  [6786] = 1209,
  [6787] = 3844,
  [6788] = 1208,
  [6789] = 3730,
  [6790] = 1203,
  [6791] = 1210,
  [6792] = 1209,
  [6793] = 1211,
  [6794] = 1198,
  [6795] = 1225,
  [6796] = 6766,
  [6797] = 1197,
  [6798] = 1194,
  [6799] = 1229,
  [6800] = 3749,
  [6801] = 3864,
  [6802] = 1195,
  [6803] = 3762,
  [6804] = 3828,
  [6805] = 4349,
  [6806] = 1225,
  [6807] = 3818,
  [6808] = 3798,
  [6809] = 3808,
  [6810] = 1195,
  [6811] = 3853,
  [6812] = 3800,
  [6813] = 3811,
  [6814] = 3807,
  [6815] = 3879,
  [6816] = 3778,
  [6817] = 3846,
  [6818] = 1253,
  [6819] = 3781,
  [6820] = 4349,
  [6821] = 3779,
  [6822] = 6766,
  [6823] = 1194,
  [6824] = 3854,
  [6825] = 1221,
  [6826] = 1195,
  [6827] = 1214,
  [6828] = 1211,
  [6829] = 3801,
  [6830] = 1198,
  [6831] = 3807,
  [6832] = 3870,
  [6833] = 1197,
  [6834] = 1212,
  [6835] = 3854,
  [6836] = 1210,
  [6837] = 3823,
  [6838] = 3859,
  [6839] = 3829,
  [6840] = 3860,
  [6841] = 1210,
  [6842] = 1198,
  [6843] = 3820,
  [6844] = 1208,
  [6845] = 3813,
  [6846] = 6766,
  [6847] = 3822,
  [6848] = 1197,
  [6849] = 1203,
  [6850] = 1208,
  [6851] = 3786,
  [6852] = 3859,
  [6853] = 1197,
  [6854] = 3755,
  [6855] = 3824,
  [6856] = 3804,
  [6857] = 4349,
  [6858] = 1194,
  [6859] = 1198,
  [6860] = 3779,
  [6861] = 6766,
  [6862] = 3863,
  [6863] = 3781,
  [6864] = 3864,
  [6865] = 1197,
  [6866] = 3798,
  [6867] = 4358,
  [6868] = 3814,
  [6869] = 3786,
  [6870] = 3774,
  [6871] = 1212,
  [6872] = 1209,
  [6873] = 3780,
  [6874] = 1214,
  [6875] = 3788,
  [6876] = 3776,
  [6877] = 3788,
  [6878] = 6766,
  [6879] = 3879,
  [6880] = 1225,
  [6881] = 3762,
  [6882] = 3824,
  [6883] = 1205,
  [6884] = 1212,
  [6885] = 1214,
  [6886] = 3837,
  [6887] = 3830,
  [6888] = 1203,
  [6889] = 3789,
  [6890] = 3811,
  [6891] = 1210,
  [6892] = 1195,
  [6893] = 1253,
  [6894] = 3818,
  [6895] = 3828,
  [6896] = 3786,
  [6897] = 4358,
  [6898] = 1210,
  [6899] = 1194,
  [6900] = 1205,
  [6901] = 3758,
  [6902] = 3822,
  [6903] = 3833,
  [6904] = 4335,
  [6905] = 3805,
  [6906] = 3801,
  [6907] = 3810,
  [6908] = 3863,
  [6909] = 1206,
  [6910] = 1194,
  [6911] = 3843,
  [6912] = 3853,
  [6913] = 3870,
  [6914] = 1215,
  [6915] = 6766,
  [6916] = 1208,
  [6917] = 3846,
  [6918] = 3774,
  [6919] = 1253,
  [6920] = 1208,
  [6921] = 1209,
  [6922] = 1198,
  [6923] = 3838,
  [6924] = 1215,
  [6925] = 3838,
  [6926] = 1203,
  [6927] = 3759,
  [6928] = 3847,
  [6929] = 1206,
  [6930] = 1203,
  [6931] = 3729,
  [6932] = 6766,
  [6933] = 3819,
  [6934] = 3780,
  [6935] = 3793,
  [6936] = 3814,
  [6937] = 3744,
  [6938] = 3732,
  [6939] = 3789,
  [6940] = 1209,
  [6941] = 3820,
  [6942] = 1215,
  [6943] = 1208,
  [6944] = 1225,
  [6945] = 1214,
  [6946] = 3793,
  [6947] = 1230,
  [6948] = 1226,
  [6949] = 1215,
  [6950] = 3828,
  [6951] = 1226,
  [6952] = 1213,
  [6953] = 3818,
  [6954] = 3798,
  [6955] = 1214,
  [6956] = 3789,
  [6957] = 3788,
  [6958] = 1225,
  [6959] = 3781,
  [6960] = 1228,
  [6961] = 3847,
  [6962] = 3779,
  [6963] = 4358,
  [6964] = 1214,
  [6965] = 3854,
  [6966] = 3846,
  [6967] = 3860,
  [6968] = 3762,
  [6969] = 1206,
  [6970] = 1230,
  [6971] = 1194,
  [6972] = 3863,
  [6973] = 3864,
  [6974] = 1220,
  [6975] = 3759,
  [6976] = 3879,
  [6977] = 1197,
  [6978] = 3780,
  [6979] = 1219,
  [6980] = 1195,
  [6981] = 3800,
  [6982] = 3808,
  [6983] = 1221,
  [6984] = 3844,
  [6985] = 6985,
  [6986] = 1229,
  [6987] = 1210,
  [6988] = 1211,
  [6989] = 1198,
  [6990] = 1222,
  [6991] = 3778,
  [6992] = 1205,
  [6993] = 1218,
  [6994] = 1209,
  [6995] = 3820,
  [6996] = 1221,
  [6997] = 3814,
  [6998] = 3813,
  [6999] = 1220,
  [7000] = 1205,
  [7001] = 1219,
  [7002] = 3774,
  [7003] = 1203,
  [7004] = 1218,
  [7005] = 1216,
  [7006] = 3829,
  [7007] = 3804,
  [7008] = 1225,
  [7009] = 1217,
  [7010] = 1209,
  [7011] = 3838,
  [7012] = 1223,
  [7013] = 3786,
  [7014] = 1221,
  [7015] = 1210,
  [7016] = 1216,
  [7017] = 1205,
  [7018] = 1253,
  [7019] = 1205,
  [7020] = 1213,
  [7021] = 1210,
  [7022] = 1212,
  [7023] = 1203,
  [7024] = 1203,
  [7025] = 1205,
  [7026] = 7026,
  [7027] = 1221,
  [7028] = 7026,
  [7029] = 1206,
  [7030] = 1211,
  [7031] = 1210,
  [7032] = 3859,
  [7033] = 7026,
  [7034] = 3807,
  [7035] = 7035,
  [7036] = 1214,
  [7037] = 3837,
  [7038] = 7026,
  [7039] = 3830,
  [7040] = 3811,
  [7041] = 1224,
  [7042] = 1203,
  [7043] = 1210,
  [7044] = 1215,
  [7045] = 1214,
  [7046] = 4358,
  [7047] = 1228,
  [7048] = 1217,
  [7049] = 1210,
  [7050] = 1206,
  [7051] = 1223,
  [7052] = 1211,
  [7053] = 1203,
  [7054] = 1203,
  [7055] = 1208,
  [7056] = 1211,
  [7057] = 1221,
  [7058] = 3843,
  [7059] = 1211,
  [7060] = 5523,
  [7061] = 3833,
  [7062] = 3824,
  [7063] = 7026,
  [7064] = 1225,
  [7065] = 1222,
  [7066] = 1279,
  [7067] = 1215,
  [7068] = 1206,
  [7069] = 3822,
  [7070] = 1236,
  [7071] = 3805,
  [7072] = 3801,
  [7073] = 3819,
  [7074] = 1229,
  [7075] = 3776,
  [7076] = 1229,
  [7077] = 5511,
  [7078] = 1229,
  [7079] = 1229,
  [7080] = 1206,
  [7081] = 3870,
  [7082] = 1211,
  [7083] = 4769,
  [7084] = 1215,
  [7085] = 1225,
  [7086] = 1224,
  [7087] = 3823,
  [7088] = 3810,
  [7089] = 1213,
  [7090] = 1218,
  [7091] = 1229,
  [7092] = 1221,
  [7093] = 1226,
  [7094] = 1230,
  [7095] = 1221,
  [7096] = 1206,
  [7097] = 1209,
  [7098] = 1205,
  [7099] = 4854,
  [7100] = 7100,
  [7101] = 4847,
  [7102] = 1210,
  [7103] = 1229,
  [7104] = 1205,
  [7105] = 1206,
  [7106] = 1220,
  [7107] = 1229,
  [7108] = 1217,
  [7109] = 7100,
  [7110] = 1216,
  [7111] = 1219,
  [7112] = 7100,
  [7113] = 4811,
  [7114] = 1267,
  [7115] = 1203,
  [7116] = 1218,
  [7117] = 1221,
  [7118] = 7100,
  [7119] = 1213,
  [7120] = 1268,
  [7121] = 1215,
  [7122] = 1215,
  [7123] = 1221,
  [7124] = 1269,
  [7125] = 1211,
  [7126] = 4852,
  [7127] = 1217,
  [7128] = 1219,
  [7129] = 1220,
  [7130] = 1216,
  [7131] = 1218,
  [7132] = 1217,
  [7133] = 1216,
  [7134] = 1219,
  [7135] = 1220,
  [7136] = 1221,
  [7137] = 1206,
  [7138] = 1228,
  [7139] = 4838,
  [7140] = 1213,
  [7141] = 1216,
  [7142] = 1230,
  [7143] = 1219,
  [7144] = 1220,
  [7145] = 1229,
  [7146] = 1217,
  [7147] = 1230,
  [7148] = 1226,
  [7149] = 1230,
  [7150] = 1226,
  [7151] = 1205,
  [7152] = 1226,
  [7153] = 1228,
  [7154] = 1228,
  [7155] = 1217,
  [7156] = 1213,
  [7157] = 7100,
  [7158] = 1206,
  [7159] = 1214,
  [7160] = 1184,
  [7161] = 1213,
  [7162] = 7100,
  [7163] = 1215,
  [7164] = 1228,
  [7165] = 1215,
  [7166] = 1228,
  [7167] = 1225,
  [7168] = 1220,
  [7169] = 1226,
  [7170] = 7100,
  [7171] = 1222,
  [7172] = 7100,
  [7173] = 1230,
  [7174] = 1223,
  [7175] = 1225,
  [7176] = 1224,
  [7177] = 1205,
  [7178] = 1218,
  [7179] = 1214,
  [7180] = 7100,
  [7181] = 1215,
  [7182] = 1216,
  [7183] = 1218,
  [7184] = 1224,
  [7185] = 1224,
  [7186] = 1223,
  [7187] = 1208,
  [7188] = 1222,
  [7189] = 1222,
  [7190] = 1224,
  [7191] = 1222,
  [7192] = 1223,
  [7193] = 1206,
  [7194] = 4875,
  [7195] = 1223,
  [7196] = 1221,
  [7197] = 1205,
  [7198] = 1224,
  [7199] = 1222,
  [7200] = 1223,
  [7201] = 1229,
  [7202] = 4837,
  [7203] = 1219,
  [7204] = 7204,
  [7205] = 7204,
  [7206] = 1229,
  [7207] = 1218,
  [7208] = 7208,
  [7209] = 7208,
  [7210] = 3740,
  [7211] = 7208,
  [7212] = 1226,
  [7213] = 7208,
  [7214] = 1224,
  [7215] = 1222,
  [7216] = 1219,
  [7217] = 1215,
  [7218] = 1220,
  [7219] = 1223,
  [7220] = 1223,
  [7221] = 1222,
  [7222] = 7208,
  [7223] = 7204,
  [7224] = 1224,
  [7225] = 7204,
  [7226] = 1218,
  [7227] = 1214,
  [7228] = 1220,
  [7229] = 7204,
  [7230] = 1195,
  [7231] = 1213,
  [7232] = 1228,
  [7233] = 1219,
  [7234] = 7204,
  [7235] = 7204,
  [7236] = 7208,
  [7237] = 7208,
  [7238] = 7204,
  [7239] = 1216,
  [7240] = 1217,
  [7241] = 3751,
  [7242] = 7208,
  [7243] = 1216,
  [7244] = 7204,
  [7245] = 7208,
  [7246] = 5816,
  [7247] = 1228,
  [7248] = 1206,
  [7249] = 1219,
  [7250] = 1228,
  [7251] = 1213,
  [7252] = 1222,
  [7253] = 1222,
  [7254] = 7208,
  [7255] = 7204,
  [7256] = 1223,
  [7257] = 5792,
  [7258] = 7208,
  [7259] = 7208,
  [7260] = 7208,
  [7261] = 1213,
  [7262] = 1224,
  [7263] = 1226,
  [7264] = 1222,
  [7265] = 7204,
  [7266] = 1230,
  [7267] = 1223,
  [7268] = 1230,
  [7269] = 7204,
  [7270] = 1224,
  [7271] = 7204,
  [7272] = 1224,
  [7273] = 7208,
  [7274] = 7204,
  [7275] = 7204,
  [7276] = 1229,
  [7277] = 7208,
  [7278] = 7204,
  [7279] = 1205,
  [7280] = 7208,
  [7281] = 1217,
  [7282] = 7204,
  [7283] = 3740,
  [7284] = 7208,
  [7285] = 7204,
  [7286] = 1216,
  [7287] = 1212,
  [7288] = 7208,
  [7289] = 1228,
  [7290] = 1230,
  [7291] = 3751,
  [7292] = 7208,
  [7293] = 1216,
  [7294] = 1226,
  [7295] = 7204,
  [7296] = 7208,
  [7297] = 1220,
  [7298] = 3725,
  [7299] = 3725,
  [7300] = 1228,
  [7301] = 7204,
  [7302] = 7208,
  [7303] = 5781,
  [7304] = 7208,
  [7305] = 7204,
  [7306] = 7208,
  [7307] = 1213,
  [7308] = 1194,
  [7309] = 7204,
  [7310] = 7204,
  [7311] = 7204,
  [7312] = 7208,
  [7313] = 1223,
  [7314] = 1217,
  [7315] = 1217,
  [7316] = 1226,
  [7317] = 1230,
  [7318] = 1218,
  [7319] = 1216,
  [7320] = 7204,
  [7321] = 7208,
  [7322] = 1219,
  [7323] = 1225,
  [7324] = 1221,
  [7325] = 1220,
  [7326] = 1220,
  [7327] = 1219,
  [7328] = 7208,
  [7329] = 1198,
  [7330] = 1230,
  [7331] = 1197,
  [7332] = 1217,
  [7333] = 1226,
  [7334] = 7208,
  [7335] = 1218,
  [7336] = 7336,
  [7337] = 1218,
  [7338] = 7204,
  [7339] = 1213,
  [7340] = 7204,
  [7341] = 7341,
  [7342] = 7341,
  [7343] = 7343,
  [7344] = 1253,
  [7345] = 7345,
  [7346] = 7341,
  [7347] = 1236,
  [7348] = 1253,
  [7349] = 7343,
  [7350] = 7350,
  [7351] = 4926,
  [7352] = 7352,
  [7353] = 7345,
  [7354] = 4974,
  [7355] = 7341,
  [7356] = 7343,
  [7357] = 3726,
  [7358] = 3730,
  [7359] = 7343,
  [7360] = 5076,
  [7361] = 1217,
  [7362] = 7341,
  [7363] = 7341,
  [7364] = 1402,
  [7365] = 1317,
  [7366] = 5005,
  [7367] = 7343,
  [7368] = 7343,
  [7369] = 7343,
  [7370] = 1345,
  [7371] = 1351,
  [7372] = 4973,
  [7373] = 7341,
  [7374] = 7345,
  [7375] = 7343,
  [7376] = 7341,
  [7377] = 3853,
  [7378] = 4946,
  [7379] = 3744,
  [7380] = 7341,
  [7381] = 7381,
  [7382] = 1279,
  [7383] = 1229,
  [7384] = 7350,
  [7385] = 3853,
  [7386] = 4930,
  [7387] = 4929,
  [7388] = 4928,
  [7389] = 7350,
  [7390] = 7343,
  [7391] = 7341,
  [7392] = 1216,
  [7393] = 7343,
  [7394] = 7341,
  [7395] = 7341,
  [7396] = 1211,
  [7397] = 3758,
  [7398] = 7341,
  [7399] = 7343,
  [7400] = 5003,
  [7401] = 1413,
  [7402] = 5002,
  [7403] = 7343,
  [7404] = 7341,
  [7405] = 1218,
  [7406] = 7343,
  [7407] = 1365,
  [7408] = 4942,
  [7409] = 3786,
  [7410] = 7350,
  [7411] = 7343,
  [7412] = 1374,
  [7413] = 1390,
  [7414] = 1376,
  [7415] = 1315,
  [7416] = 1382,
  [7417] = 1219,
  [7418] = 7345,
  [7419] = 4941,
  [7420] = 1332,
  [7421] = 7341,
  [7422] = 3804,
  [7423] = 1253,
  [7424] = 1220,
  [7425] = 1385,
  [7426] = 7343,
  [7427] = 3786,
  [7428] = 3730,
  [7429] = 7343,
  [7430] = 3744,
  [7431] = 5093,
  [7432] = 7341,
  [7433] = 3734,
  [7434] = 1395,
  [7435] = 3726,
  [7436] = 4952,
  [7437] = 4950,
  [7438] = 4824,
  [7439] = 1398,
  [7440] = 7341,
  [7441] = 7341,
  [7442] = 1347,
  [7443] = 1366,
  [7444] = 7341,
  [7445] = 1355,
  [7446] = 1224,
  [7447] = 4990,
  [7448] = 1223,
  [7449] = 1222,
  [7450] = 5004,
  [7451] = 1356,
  [7452] = 3734,
  [7453] = 1403,
  [7454] = 3735,
  [7455] = 1404,
  [7456] = 1407,
  [7457] = 7343,
  [7458] = 1408,
  [7459] = 7343,
  [7460] = 7343,
  [7461] = 1409,
  [7462] = 3758,
  [7463] = 3749,
  [7464] = 1203,
  [7465] = 7345,
  [7466] = 3755,
  [7467] = 7343,
  [7468] = 1462,
  [7469] = 3729,
  [7470] = 7343,
  [7471] = 1211,
  [7472] = 7341,
  [7473] = 3732,
  [7474] = 1230,
  [7475] = 1358,
  [7476] = 7341,
  [7477] = 1357,
  [7478] = 1226,
  [7479] = 7350,
  [7480] = 7480,
  [7481] = 3804,
  [7482] = 7343,
  [7483] = 7345,
  [7484] = 7341,
  [7485] = 1210,
  [7486] = 7350,
  [7487] = 7341,
  [7488] = 7345,
  [7489] = 7341,
  [7490] = 7343,
  [7491] = 1438,
  [7492] = 7343,
  [7493] = 3729,
  [7494] = 7341,
  [7495] = 1210,
  [7496] = 7345,
  [7497] = 7343,
  [7498] = 7480,
  [7499] = 1203,
  [7500] = 3735,
  [7501] = 1396,
  [7502] = 7350,
  [7503] = 7350,
  [7504] = 7343,
  [7505] = 3755,
  [7506] = 3732,
  [7507] = 1213,
  [7508] = 7381,
  [7509] = 7343,
  [7510] = 1394,
  [7511] = 7341,
  [7512] = 3749,
  [7513] = 7341,
  [7514] = 1228,
  [7515] = 3823,
  [7516] = 3829,
  [7517] = 3776,
  [7518] = 3778,
  [7519] = 7519,
  [7520] = 7520,
  [7521] = 3774,
  [7522] = 7520,
  [7523] = 1206,
  [7524] = 3863,
  [7525] = 3864,
  [7526] = 3838,
  [7527] = 7527,
  [7528] = 3793,
  [7529] = 1221,
  [7530] = 7530,
  [7531] = 3788,
  [7532] = 3789,
  [7533] = 3780,
  [7534] = 4769,
  [7535] = 4777,
  [7536] = 7520,
  [7537] = 1221,
  [7538] = 3776,
  [7539] = 3847,
  [7540] = 7527,
  [7541] = 3780,
  [7542] = 3778,
  [7543] = 7520,
  [7544] = 1267,
  [7545] = 1208,
  [7546] = 3762,
  [7547] = 3788,
  [7548] = 3789,
  [7549] = 3774,
  [7550] = 3879,
  [7551] = 3814,
  [7552] = 3793,
  [7553] = 7527,
  [7554] = 4772,
  [7555] = 3838,
  [7556] = 5523,
  [7557] = 3870,
  [7558] = 7352,
  [7559] = 3804,
  [7560] = 3801,
  [7561] = 3879,
  [7562] = 3807,
  [7563] = 7563,
  [7564] = 3844,
  [7565] = 1236,
  [7566] = 7566,
  [7567] = 1210,
  [7568] = 1203,
  [7569] = 3811,
  [7570] = 3786,
  [7571] = 7527,
  [7572] = 1209,
  [7573] = 3846,
  [7574] = 7520,
  [7575] = 1211,
  [7576] = 3870,
  [7577] = 3830,
  [7578] = 3837,
  [7579] = 3859,
  [7580] = 3844,
  [7581] = 7520,
  [7582] = 7527,
  [7583] = 3847,
  [7584] = 1215,
  [7585] = 3810,
  [7586] = 3759,
  [7587] = 3824,
  [7588] = 7520,
  [7589] = 3762,
  [7590] = 3846,
  [7591] = 7527,
  [7592] = 7592,
  [7593] = 5511,
  [7594] = 7594,
  [7595] = 7520,
  [7596] = 1279,
  [7597] = 3798,
  [7598] = 3819,
  [7599] = 3818,
  [7600] = 7527,
  [7601] = 7601,
  [7602] = 7530,
  [7603] = 3859,
  [7604] = 7563,
  [7605] = 3837,
  [7606] = 4780,
  [7607] = 3828,
  [7608] = 1269,
  [7609] = 3798,
  [7610] = 3830,
  [7611] = 1268,
  [7612] = 3829,
  [7613] = 3818,
  [7614] = 3811,
  [7615] = 3804,
  [7616] = 3786,
  [7617] = 3823,
  [7618] = 7527,
  [7619] = 3801,
  [7620] = 1205,
  [7621] = 7520,
  [7622] = 3819,
  [7623] = 3759,
  [7624] = 7520,
  [7625] = 3810,
  [7626] = 7527,
  [7627] = 3814,
  [7628] = 7527,
  [7629] = 7520,
  [7630] = 7527,
  [7631] = 3828,
  [7632] = 1253,
  [7633] = 7592,
  [7634] = 3864,
  [7635] = 7635,
  [7636] = 7635,
  [7637] = 7637,
  [7638] = 4772,
  [7639] = 7639,
  [7640] = 4777,
  [7641] = 7641,
  [7642] = 4780,
  [7643] = 7643,
  [7644] = 7637,
  [7645] = 7645,
  [7646] = 7635,
  [7647] = 7647,
  [7648] = 7648,
  [7649] = 7643,
  [7650] = 1208,
  [7651] = 7651,
  [7652] = 7641,
  [7653] = 4769,
  [7654] = 7648,
  [7655] = 7655,
  [7656] = 1209,
  [7657] = 7648,
  [7658] = 7651,
  [7659] = 7648,
  [7660] = 7651,
  [7661] = 1218,
  [7662] = 7655,
  [7663] = 7639,
  [7664] = 7651,
  [7665] = 4899,
  [7666] = 7648,
  [7667] = 7667,
  [7668] = 7651,
  [7669] = 7635,
  [7670] = 7641,
  [7671] = 4350,
  [7672] = 4901,
  [7673] = 4837,
  [7674] = 4897,
  [7675] = 7641,
  [7676] = 7648,
  [7677] = 7635,
  [7678] = 7678,
  [7679] = 4897,
  [7680] = 7655,
  [7681] = 4892,
  [7682] = 1219,
  [7683] = 7648,
  [7684] = 4889,
  [7685] = 7648,
  [7686] = 7635,
  [7687] = 7635,
  [7688] = 7635,
  [7689] = 7641,
  [7690] = 7641,
  [7691] = 7635,
  [7692] = 7643,
  [7693] = 7635,
  [7694] = 7694,
  [7695] = 7651,
  [7696] = 7696,
  [7697] = 7639,
  [7698] = 7698,
  [7699] = 7635,
  [7700] = 7637,
  [7701] = 1228,
  [7702] = 7635,
  [7703] = 3996,
  [7704] = 4780,
  [7705] = 7648,
  [7706] = 7651,
  [7707] = 4887,
  [7708] = 1213,
  [7709] = 4852,
  [7710] = 7651,
  [7711] = 7641,
  [7712] = 7635,
  [7713] = 7648,
  [7714] = 1208,
  [7715] = 7715,
  [7716] = 3996,
  [7717] = 7635,
  [7718] = 7637,
  [7719] = 7637,
  [7720] = 7648,
  [7721] = 7641,
  [7722] = 7641,
  [7723] = 4823,
  [7724] = 7635,
  [7725] = 7639,
  [7726] = 4875,
  [7727] = 7727,
  [7728] = 1220,
  [7729] = 7635,
  [7730] = 7648,
  [7731] = 7635,
  [7732] = 7651,
  [7733] = 7648,
  [7734] = 7635,
  [7735] = 7648,
  [7736] = 7643,
  [7737] = 7737,
  [7738] = 7635,
  [7739] = 7651,
  [7740] = 7698,
  [7741] = 7648,
  [7742] = 7635,
  [7743] = 7641,
  [7744] = 7643,
  [7745] = 7635,
  [7746] = 7667,
  [7747] = 1195,
  [7748] = 1209,
  [7749] = 7749,
  [7750] = 7651,
  [7751] = 7635,
  [7752] = 7648,
  [7753] = 7637,
  [7754] = 7648,
  [7755] = 7648,
  [7756] = 4772,
  [7757] = 7635,
  [7758] = 7758,
  [7759] = 7648,
  [7760] = 7698,
  [7761] = 7761,
  [7762] = 7639,
  [7763] = 7763,
  [7764] = 7648,
  [7765] = 7648,
  [7766] = 7651,
  [7767] = 7641,
  [7768] = 7641,
  [7769] = 7635,
  [7770] = 7648,
  [7771] = 7635,
  [7772] = 7635,
  [7773] = 7667,
  [7774] = 7678,
  [7775] = 7651,
  [7776] = 7648,
  [7777] = 4825,
  [7778] = 7641,
  [7779] = 7635,
  [7780] = 7655,
  [7781] = 7648,
  [7782] = 1212,
  [7783] = 4772,
  [7784] = 7648,
  [7785] = 7651,
  [7786] = 1221,
  [7787] = 1194,
  [7788] = 1197,
  [7789] = 7651,
  [7790] = 7639,
  [7791] = 7635,
  [7792] = 1198,
  [7793] = 4838,
  [7794] = 7648,
  [7795] = 7635,
  [7796] = 7648,
  [7797] = 7643,
  [7798] = 7648,
  [7799] = 7648,
  [7800] = 7643,
  [7801] = 7641,
  [7802] = 7635,
  [7803] = 7641,
  [7804] = 7641,
  [7805] = 7641,
  [7806] = 7678,
  [7807] = 7635,
  [7808] = 7648,
  [7809] = 4854,
  [7810] = 7810,
  [7811] = 4847,
  [7812] = 4811,
  [7813] = 3998,
  [7814] = 7651,
  [7815] = 7698,
  [7816] = 7635,
  [7817] = 7648,
  [7818] = 7648,
  [7819] = 1269,
  [7820] = 7639,
  [7821] = 1217,
  [7822] = 7648,
  [7823] = 7651,
  [7824] = 7648,
  [7825] = 7635,
  [7826] = 7635,
  [7827] = 7643,
  [7828] = 7655,
  [7829] = 7635,
  [7830] = 7648,
  [7831] = 7648,
  [7832] = 7648,
  [7833] = 7648,
  [7834] = 7648,
  [7835] = 1214,
  [7836] = 7648,
  [7837] = 7648,
  [7838] = 7651,
  [7839] = 7839,
  [7840] = 1216,
  [7841] = 7639,
  [7842] = 4819,
  [7843] = 7635,
  [7844] = 7651,
  [7845] = 7651,
  [7846] = 7846,
  [7847] = 3998,
  [7848] = 7655,
  [7849] = 7635,
  [7850] = 7635,
  [7851] = 4780,
  [7852] = 7637,
  [7853] = 1222,
  [7854] = 4823,
  [7855] = 4825,
  [7856] = 7648,
  [7857] = 7635,
  [7858] = 7641,
  [7859] = 7648,
  [7860] = 4777,
  [7861] = 7655,
  [7862] = 1198,
  [7863] = 7635,
  [7864] = 1267,
  [7865] = 7655,
  [7866] = 4780,
  [7867] = 7635,
  [7868] = 4772,
  [7869] = 7641,
  [7870] = 7641,
  [7871] = 7639,
  [7872] = 4899,
  [7873] = 4901,
  [7874] = 7641,
  [7875] = 1197,
  [7876] = 1194,
  [7877] = 1223,
  [7878] = 7651,
  [7879] = 7648,
  [7880] = 7635,
  [7881] = 7635,
  [7882] = 1224,
  [7883] = 7637,
  [7884] = 7641,
  [7885] = 1209,
  [7886] = 7648,
  [7887] = 7635,
  [7888] = 7651,
  [7889] = 7641,
  [7890] = 4824,
  [7891] = 7643,
  [7892] = 7651,
  [7893] = 7641,
  [7894] = 7635,
  [7895] = 7635,
  [7896] = 7641,
  [7897] = 7648,
  [7898] = 7898,
  [7899] = 7648,
  [7900] = 7655,
  [7901] = 7637,
  [7902] = 4819,
  [7903] = 7651,
  [7904] = 7637,
  [7905] = 7648,
  [7906] = 7651,
  [7907] = 7635,
  [7908] = 1208,
  [7909] = 7635,
  [7910] = 4777,
  [7911] = 7648,
  [7912] = 7635,
  [7913] = 7648,
  [7914] = 7635,
  [7915] = 7648,
  [7916] = 4349,
  [7917] = 7667,
  [7918] = 7678,
  [7919] = 7635,
  [7920] = 7920,
  [7921] = 7635,
  [7922] = 7648,
  [7923] = 7635,
  [7924] = 1195,
  [7925] = 7635,
  [7926] = 7635,
  [7927] = 7635,
  [7928] = 1230,
  [7929] = 7648,
  [7930] = 1226,
  [7931] = 4777,
  [7932] = 4887,
  [7933] = 7648,
  [7934] = 7651,
  [7935] = 7635,
  [7936] = 7936,
  [7937] = 7635,
  [7938] = 7635,
  [7939] = 4889,
  [7940] = 7643,
  [7941] = 7635,
  [7942] = 7648,
  [7943] = 7651,
  [7944] = 4892,
  [7945] = 7648,
  [7946] = 1212,
  [7947] = 7639,
  [7948] = 1268,
  [7949] = 7920,
  [7950] = 1225,
  [7951] = 7648,
  [7952] = 7635,
  [7953] = 7655,
  [7954] = 7641,
  [7955] = 7641,
  [7956] = 7648,
  [7957] = 7957,
  [7958] = 4852,
  [7959] = 1394,
  [7960] = 7960,
  [7961] = 7961,
  [7962] = 7962,
  [7963] = 1225,
  [7964] = 7964,
  [7965] = 7962,
  [7966] = 7966,
  [7967] = 1194,
  [7968] = 1210,
  [7969] = 7962,
  [7970] = 4928,
  [7971] = 7964,
  [7972] = 1356,
  [7973] = 7962,
  [7974] = 4929,
  [7975] = 1355,
  [7976] = 7976,
  [7977] = 7960,
  [7978] = 7978,
  [7979] = 7962,
  [7980] = 7980,
  [7981] = 1208,
  [7982] = 1347,
  [7983] = 7964,
  [7984] = 7984,
  [7985] = 7957,
  [7986] = 5781,
  [7987] = 4819,
  [7988] = 7988,
  [7989] = 7980,
  [7990] = 7962,
  [7991] = 7991,
  [7992] = 7984,
  [7993] = 4930,
  [7994] = 7962,
  [7995] = 4823,
  [7996] = 4825,
  [7997] = 1332,
  [7998] = 7988,
  [7999] = 7962,
  [8000] = 7964,
  [8001] = 1413,
  [8002] = 1209,
  [8003] = 7976,
  [8004] = 7964,
  [8005] = 7980,
  [8006] = 7962,
  [8007] = 4824,
  [8008] = 7966,
  [8009] = 7957,
  [8010] = 4854,
  [8011] = 8011,
  [8012] = 8012,
  [8013] = 8011,
  [8014] = 1402,
  [8015] = 4780,
  [8016] = 4819,
  [8017] = 1317,
  [8018] = 7966,
  [8019] = 7984,
  [8020] = 7961,
  [8021] = 5004,
  [8022] = 7984,
  [8023] = 5727,
  [8024] = 7964,
  [8025] = 1197,
  [8026] = 7962,
  [8027] = 8027,
  [8028] = 7957,
  [8029] = 8012,
  [8030] = 7957,
  [8031] = 4973,
  [8032] = 8011,
  [8033] = 7962,
  [8034] = 1198,
  [8035] = 7964,
  [8036] = 7964,
  [8037] = 7964,
  [8038] = 7962,
  [8039] = 8039,
  [8040] = 8012,
  [8041] = 5523,
  [8042] = 7964,
  [8043] = 7962,
  [8044] = 8011,
  [8045] = 8045,
  [8046] = 8012,
  [8047] = 8012,
  [8048] = 4777,
  [8049] = 7991,
  [8050] = 8050,
  [8051] = 7962,
  [8052] = 5005,
  [8053] = 4990,
  [8054] = 7964,
  [8055] = 7980,
  [8056] = 8045,
  [8057] = 7964,
  [8058] = 7961,
  [8059] = 8059,
  [8060] = 7964,
  [8061] = 7980,
  [8062] = 4897,
  [8063] = 7964,
  [8064] = 7991,
  [8065] = 1345,
  [8066] = 1351,
  [8067] = 7960,
  [8068] = 7964,
  [8069] = 8069,
  [8070] = 7991,
  [8071] = 8027,
  [8072] = 1211,
  [8073] = 7961,
  [8074] = 8069,
  [8075] = 7961,
  [8076] = 1214,
  [8077] = 5076,
  [8078] = 7962,
  [8079] = 7964,
  [8080] = 8069,
  [8081] = 7964,
  [8082] = 7964,
  [8083] = 8027,
  [8084] = 4952,
  [8085] = 8011,
  [8086] = 8069,
  [8087] = 4950,
  [8088] = 4847,
  [8089] = 1211,
  [8090] = 7960,
  [8091] = 7980,
  [8092] = 7966,
  [8093] = 8011,
  [8094] = 1357,
  [8095] = 4875,
  [8096] = 7962,
  [8097] = 7964,
  [8098] = 7980,
  [8099] = 7964,
  [8100] = 1358,
  [8101] = 7962,
  [8102] = 8102,
  [8103] = 8027,
  [8104] = 7962,
  [8105] = 8069,
  [8106] = 7976,
  [8107] = 5792,
  [8108] = 4887,
  [8109] = 7966,
  [8110] = 7962,
  [8111] = 8111,
  [8112] = 7964,
  [8113] = 4889,
  [8114] = 8114,
  [8115] = 1366,
  [8116] = 7645,
  [8117] = 7964,
  [8118] = 7964,
  [8119] = 4892,
  [8120] = 8120,
  [8121] = 1195,
  [8122] = 8122,
  [8123] = 7966,
  [8124] = 1225,
  [8125] = 4897,
  [8126] = 7966,
  [8127] = 8045,
  [8128] = 8128,
  [8129] = 7988,
  [8130] = 4899,
  [8131] = 8012,
  [8132] = 8012,
  [8133] = 7964,
  [8134] = 7957,
  [8135] = 4901,
  [8136] = 7964,
  [8137] = 8137,
  [8138] = 7957,
  [8139] = 1365,
  [8140] = 5003,
  [8141] = 7964,
  [8142] = 7964,
  [8143] = 7966,
  [8144] = 8144,
  [8145] = 7976,
  [8146] = 8146,
  [8147] = 4901,
  [8148] = 7962,
  [8149] = 8149,
  [8150] = 7962,
  [8151] = 7976,
  [8152] = 7984,
  [8153] = 8069,
  [8154] = 7984,
  [8155] = 8155,
  [8156] = 5511,
  [8157] = 7964,
  [8158] = 7962,
  [8159] = 1214,
  [8160] = 1438,
  [8161] = 4892,
  [8162] = 7988,
  [8163] = 4899,
  [8164] = 5093,
  [8165] = 4941,
  [8166] = 7980,
  [8167] = 7964,
  [8168] = 7964,
  [8169] = 7960,
  [8170] = 4889,
  [8171] = 8171,
  [8172] = 7988,
  [8173] = 5002,
  [8174] = 8027,
  [8175] = 8175,
  [8176] = 7964,
  [8177] = 1212,
  [8178] = 7964,
  [8179] = 7964,
  [8180] = 8180,
  [8181] = 4887,
  [8182] = 7980,
  [8183] = 1408,
  [8184] = 7964,
  [8185] = 3998,
  [8186] = 7976,
  [8187] = 7964,
  [8188] = 8027,
  [8189] = 7984,
  [8190] = 7980,
  [8191] = 4838,
  [8192] = 8027,
  [8193] = 7957,
  [8194] = 4942,
  [8195] = 7960,
  [8196] = 8012,
  [8197] = 7960,
  [8198] = 7976,
  [8199] = 1390,
  [8200] = 8069,
  [8201] = 7964,
  [8202] = 7964,
  [8203] = 7964,
  [8204] = 7980,
  [8205] = 7964,
  [8206] = 1374,
  [8207] = 7961,
  [8208] = 4825,
  [8209] = 1376,
  [8210] = 7964,
  [8211] = 7964,
  [8212] = 7964,
  [8213] = 8011,
  [8214] = 7976,
  [8215] = 1210,
  [8216] = 7966,
  [8217] = 8069,
  [8218] = 7964,
  [8219] = 7964,
  [8220] = 7962,
  [8221] = 7961,
  [8222] = 7964,
  [8223] = 7961,
  [8224] = 7984,
  [8225] = 1315,
  [8226] = 7984,
  [8227] = 8155,
  [8228] = 8171,
  [8229] = 7991,
  [8230] = 4837,
  [8231] = 7964,
  [8232] = 7991,
  [8233] = 7988,
  [8234] = 7980,
  [8235] = 1225,
  [8236] = 7991,
  [8237] = 5816,
  [8238] = 7964,
  [8239] = 1203,
  [8240] = 7964,
  [8241] = 7964,
  [8242] = 7980,
  [8243] = 4811,
  [8244] = 7961,
  [8245] = 7980,
  [8246] = 4946,
  [8247] = 7962,
  [8248] = 1382,
  [8249] = 1385,
  [8250] = 3996,
  [8251] = 7980,
  [8252] = 1409,
  [8253] = 8027,
  [8254] = 8069,
  [8255] = 7964,
  [8256] = 4974,
  [8257] = 8011,
  [8258] = 4926,
  [8259] = 4823,
  [8260] = 7964,
  [8261] = 7964,
  [8262] = 1395,
  [8263] = 7964,
  [8264] = 7988,
  [8265] = 1462,
  [8266] = 7962,
  [8267] = 1229,
  [8268] = 1407,
  [8269] = 1396,
  [8270] = 7991,
  [8271] = 8011,
  [8272] = 7980,
  [8273] = 8011,
  [8274] = 7964,
  [8275] = 1398,
  [8276] = 7964,
  [8277] = 7962,
  [8278] = 7980,
  [8279] = 1214,
  [8280] = 7984,
  [8281] = 8069,
  [8282] = 1203,
  [8283] = 8069,
  [8284] = 7964,
  [8285] = 7961,
  [8286] = 7966,
  [8287] = 7962,
  [8288] = 1403,
  [8289] = 7960,
  [8290] = 1404,
  [8291] = 8045,
  [8292] = 7964,
  [8293] = 7988,
  [8294] = 4772,
  [8295] = 7962,
  [8296] = 7964,
  [8297] = 1365,
  [8298] = 1221,
  [8299] = 1317,
  [8300] = 8300,
  [8301] = 4005,
  [8302] = 1357,
  [8303] = 8303,
  [8304] = 1402,
  [8305] = 5093,
  [8306] = 4926,
  [8307] = 4974,
  [8308] = 1394,
  [8309] = 8309,
  [8310] = 4823,
  [8311] = 1229,
  [8312] = 4012,
  [8313] = 1221,
  [8314] = 4950,
  [8315] = 1203,
  [8316] = 1211,
  [8317] = 8317,
  [8318] = 8303,
  [8319] = 4952,
  [8320] = 8309,
  [8321] = 1215,
  [8322] = 8300,
  [8323] = 1462,
  [8324] = 8317,
  [8325] = 1206,
  [8326] = 8137,
  [8327] = 1409,
  [8328] = 8300,
  [8329] = 4946,
  [8330] = 4825,
  [8331] = 8317,
  [8332] = 1408,
  [8333] = 1205,
  [8334] = 1356,
  [8335] = 1355,
  [8336] = 1407,
  [8337] = 4819,
  [8338] = 1404,
  [8339] = 1358,
  [8340] = 1403,
  [8341] = 4887,
  [8342] = 1398,
  [8343] = 4889,
  [8344] = 4928,
  [8345] = 4897,
  [8346] = 1396,
  [8347] = 8347,
  [8348] = 4901,
  [8349] = 8349,
  [8350] = 4899,
  [8351] = 1332,
  [8352] = 1366,
  [8353] = 1395,
  [8354] = 1385,
  [8355] = 1210,
  [8356] = 8303,
  [8357] = 1413,
  [8358] = 8358,
  [8359] = 4014,
  [8360] = 1382,
  [8361] = 8317,
  [8362] = 4005,
  [8363] = 1315,
  [8364] = 8364,
  [8365] = 1376,
  [8366] = 1374,
  [8367] = 8317,
  [8368] = 1229,
  [8369] = 8309,
  [8370] = 8370,
  [8371] = 8309,
  [8372] = 8309,
  [8373] = 4929,
  [8374] = 5002,
  [8375] = 8309,
  [8376] = 8309,
  [8377] = 8377,
  [8378] = 8378,
  [8379] = 5003,
  [8380] = 8303,
  [8381] = 8300,
  [8382] = 8370,
  [8383] = 4013,
  [8384] = 1345,
  [8385] = 4014,
  [8386] = 8300,
  [8387] = 4930,
  [8388] = 4010,
  [8389] = 4973,
  [8390] = 8390,
  [8391] = 2986,
  [8392] = 8300,
  [8393] = 1390,
  [8394] = 8303,
  [8395] = 1351,
  [8396] = 5005,
  [8397] = 1438,
  [8398] = 4942,
  [8399] = 4012,
  [8400] = 1229,
  [8401] = 8303,
  [8402] = 4941,
  [8403] = 4892,
  [8404] = 1347,
  [8405] = 8303,
  [8406] = 8300,
  [8407] = 8300,
  [8408] = 8309,
  [8409] = 8409,
  [8410] = 4013,
  [8411] = 8309,
  [8412] = 8309,
  [8413] = 8309,
  [8414] = 8309,
  [8415] = 8309,
  [8416] = 8303,
  [8417] = 8303,
  [8418] = 8300,
  [8419] = 5076,
  [8420] = 8303,
  [8421] = 8309,
  [8422] = 5004,
  [8423] = 4990,
  [8424] = 8300,
  [8425] = 1225,
  [8426] = 4010,
  [8427] = 1215,
  [8428] = 8171,
  [8429] = 8309,
  [8430] = 1205,
  [8431] = 8309,
  [8432] = 1214,
  [8433] = 8309,
  [8434] = 8309,
  [8435] = 1206,
  [8436] = 8155,
  [8437] = 8309,
  [8438] = 8438,
  [8439] = 8439,
  [8440] = 8440,
  [8441] = 8441,
  [8442] = 8442,
  [8443] = 8443,
  [8444] = 8439,
  [8445] = 8441,
  [8446] = 8438,
  [8447] = 8447,
  [8448] = 8448,
  [8449] = 8439,
  [8450] = 8443,
  [8451] = 8440,
  [8452] = 8440,
  [8453] = 8453,
  [8454] = 8438,
  [8455] = 8442,
  [8456] = 8453,
  [8457] = 8438,
  [8458] = 8441,
  [8459] = 8438,
  [8460] = 8171,
  [8461] = 5781,
  [8462] = 8440,
  [8463] = 8440,
  [8464] = 8439,
  [8465] = 8439,
  [8466] = 8443,
  [8467] = 8443,
  [8468] = 8453,
  [8469] = 8441,
  [8470] = 8440,
  [8471] = 8439,
  [8472] = 8442,
  [8473] = 8453,
  [8474] = 8438,
  [8475] = 1223,
  [8476] = 1224,
  [8477] = 1219,
  [8478] = 1228,
  [8479] = 1213,
  [8480] = 5816,
  [8481] = 1226,
  [8482] = 8443,
  [8483] = 1230,
  [8484] = 1222,
  [8485] = 1218,
  [8486] = 8441,
  [8487] = 1216,
  [8488] = 1217,
  [8489] = 8439,
  [8490] = 8443,
  [8491] = 8442,
  [8492] = 1222,
  [8493] = 8440,
  [8494] = 1223,
  [8495] = 1224,
  [8496] = 8439,
  [8497] = 1219,
  [8498] = 8440,
  [8499] = 5792,
  [8500] = 1228,
  [8501] = 8442,
  [8502] = 8439,
  [8503] = 1220,
  [8504] = 1226,
  [8505] = 1230,
  [8506] = 1220,
  [8507] = 1213,
  [8508] = 8439,
  [8509] = 1216,
  [8510] = 1217,
  [8511] = 1218,
  [8512] = 8441,
  [8513] = 8439,
  [8514] = 8438,
  [8515] = 8515,
  [8516] = 8439,
  [8517] = 8453,
  [8518] = 8442,
  [8519] = 8439,
  [8520] = 1215,
  [8521] = 8441,
  [8522] = 8522,
  [8523] = 8443,
  [8524] = 1206,
  [8525] = 8438,
  [8526] = 8442,
  [8527] = 8527,
  [8528] = 8439,
  [8529] = 8453,
  [8530] = 8443,
  [8531] = 1205,
  [8532] = 8442,
  [8533] = 8442,
  [8534] = 8440,
  [8535] = 8440,
  [8536] = 8536,
  [8537] = 8440,
  [8538] = 8453,
  [8539] = 8453,
  [8540] = 8439,
  [8541] = 4010,
  [8542] = 8453,
  [8543] = 4014,
  [8544] = 4013,
  [8545] = 4012,
  [8546] = 1229,
  [8547] = 8439,
  [8548] = 8438,
  [8549] = 8440,
  [8550] = 8442,
  [8551] = 8443,
  [8552] = 4005,
  [8553] = 8441,
  [8554] = 8441,
  [8555] = 1221,
  [8556] = 8556,
  [8557] = 8557,
  [8558] = 8441,
  [8559] = 8442,
  [8560] = 8440,
  [8561] = 8438,
  [8562] = 8443,
  [8563] = 8453,
  [8564] = 8564,
  [8565] = 8564,
  [8566] = 8566,
  [8567] = 8564,
  [8568] = 8566,
  [8569] = 8566,
  [8570] = 1217,
  [8571] = 8564,
  [8572] = 1216,
  [8573] = 1218,
  [8574] = 1219,
  [8575] = 8566,
  [8576] = 1220,
  [8577] = 1230,
  [8578] = 8564,
  [8579] = 1226,
  [8580] = 1213,
  [8581] = 1228,
  [8582] = 8566,
  [8583] = 1224,
  [8584] = 1223,
  [8585] = 8515,
  [8586] = 8527,
  [8587] = 8566,
  [8588] = 8566,
  [8589] = 8566,
  [8590] = 1222,
  [8591] = 8564,
  [8592] = 8566,
  [8593] = 8564,
  [8594] = 8171,
  [8595] = 8564,
  [8596] = 8596,
  [8597] = 8564,
  [8598] = 8598,
  [8599] = 8564,
  [8600] = 8564,
  [8601] = 8566,
  [8602] = 8566,
  [8603] = 8603,
  [8604] = 8603,
  [8605] = 8605,
  [8606] = 8603,
  [8607] = 8607,
  [8608] = 8608,
  [8609] = 8603,
  [8610] = 8603,
  [8611] = 8608,
  [8612] = 8603,
  [8613] = 8603,
  [8614] = 8605,
  [8615] = 8608,
  [8616] = 8616,
  [8617] = 8603,
  [8618] = 8608,
  [8619] = 8607,
  [8620] = 8603,
  [8621] = 8621,
  [8622] = 8603,
  [8623] = 8608,
  [8624] = 8608,
  [8625] = 8616,
  [8626] = 8626,
  [8627] = 8608,
  [8628] = 8607,
  [8629] = 8603,
  [8630] = 8608,
  [8631] = 8605,
  [8632] = 8607,
  [8633] = 8608,
  [8634] = 8603,
  [8635] = 8616,
  [8636] = 8636,
  [8637] = 8608,
  [8638] = 8603,
  [8639] = 8636,
  [8640] = 8608,
  [8641] = 8607,
  [8642] = 8608,
  [8643] = 8603,
  [8644] = 8608,
  [8645] = 8645,
  [8646] = 8603,
  [8647] = 8608,
  [8648] = 8603,
  [8649] = 8649,
  [8650] = 8608,
  [8651] = 8603,
  [8652] = 8603,
  [8653] = 8608,
  [8654] = 8626,
  [8655] = 8636,
  [8656] = 8621,
  [8657] = 8608,
  [8658] = 8621,
  [8659] = 8608,
  [8660] = 8636,
  [8661] = 8621,
  [8662] = 8603,
  [8663] = 8603,
  [8664] = 8605,
  [8665] = 8621,
  [8666] = 8608,
  [8667] = 8603,
  [8668] = 8605,
  [8669] = 8608,
  [8670] = 8603,
  [8671] = 8603,
  [8672] = 8607,
  [8673] = 8603,
  [8674] = 8603,
  [8675] = 8616,
  [8676] = 8608,
  [8677] = 8608,
  [8678] = 8605,
  [8679] = 8621,
  [8680] = 8608,
  [8681] = 8603,
  [8682] = 8603,
  [8683] = 1279,
  [8684] = 8608,
  [8685] = 8608,
  [8686] = 8608,
  [8687] = 8636,
  [8688] = 1236,
  [8689] = 8603,
  [8690] = 8621,
  [8691] = 8608,
  [8692] = 8605,
  [8693] = 8636,
  [8694] = 8603,
  [8695] = 8608,
  [8696] = 8608,
  [8697] = 8603,
  [8698] = 8605,
  [8699] = 8603,
  [8700] = 8621,
  [8701] = 8608,
  [8702] = 8603,
  [8703] = 8603,
  [8704] = 8608,
  [8705] = 8608,
  [8706] = 8607,
  [8707] = 8603,
  [8708] = 8603,
  [8709] = 8621,
  [8710] = 8608,
  [8711] = 8608,
  [8712] = 8603,
  [8713] = 8603,
  [8714] = 8608,
  [8715] = 8608,
  [8716] = 8621,
  [8717] = 8603,
  [8718] = 8621,
  [8719] = 8603,
  [8720] = 8603,
  [8721] = 8626,
  [8722] = 8722,
  [8723] = 8608,
  [8724] = 8621,
  [8725] = 8608,
  [8726] = 8603,
  [8727] = 8605,
  [8728] = 8603,
  [8729] = 8608,
  [8730] = 8608,
  [8731] = 8603,
  [8732] = 8608,
  [8733] = 8603,
  [8734] = 8608,
  [8735] = 8616,
  [8736] = 8603,
  [8737] = 8603,
  [8738] = 8608,
  [8739] = 8621,
  [8740] = 8608,
  [8741] = 8621,
  [8742] = 8636,
  [8743] = 8621,
  [8744] = 8621,
  [8745] = 8603,
  [8746] = 8608,
  [8747] = 8608,
  [8748] = 8748,
  [8749] = 8603,
  [8750] = 8605,
  [8751] = 8603,
  [8752] = 8607,
  [8753] = 8616,
  [8754] = 8608,
  [8755] = 8636,
  [8756] = 8603,
  [8757] = 8608,
  [8758] = 4769,
  [8759] = 8608,
  [8760] = 8608,
  [8761] = 8603,
  [8762] = 8616,
  [8763] = 8608,
  [8764] = 8608,
  [8765] = 8607,
  [8766] = 8603,
  [8767] = 8607,
  [8768] = 8603,
  [8769] = 8608,
  [8770] = 8616,
  [8771] = 8608,
  [8772] = 8608,
  [8773] = 8616,
  [8774] = 8603,
  [8775] = 8636,
  [8776] = 8776,
  [8777] = 8605,
  [8778] = 8608,
  [8779] = 8603,
  [8780] = 8608,
  [8781] = 8621,
  [8782] = 8603,
  [8783] = 8626,
  [8784] = 8605,
  [8785] = 8608,
  [8786] = 8621,
  [8787] = 8603,
  [8788] = 8621,
  [8789] = 8616,
  [8790] = 8603,
  [8791] = 8608,
  [8792] = 8621,
  [8793] = 8603,
  [8794] = 8636,
  [8795] = 8603,
  [8796] = 8605,
  [8797] = 8608,
  [8798] = 8621,
  [8799] = 8603,
  [8800] = 8608,
  [8801] = 8801,
  [8802] = 8802,
  [8803] = 4138,
  [8804] = 8804,
  [8805] = 8805,
  [8806] = 8806,
  [8807] = 8807,
  [8808] = 8808,
  [8809] = 5523,
  [8810] = 8810,
  [8811] = 1278,
  [8812] = 8802,
  [8813] = 5511,
  [8814] = 4050,
  [8815] = 4049,
  [8816] = 8801,
  [8817] = 8817,
  [8818] = 1249,
  [8819] = 8819,
  [8820] = 8820,
  [8821] = 8801,
  [8822] = 4091,
  [8823] = 8801,
  [8824] = 8810,
  [8825] = 4071,
  [8826] = 4073,
  [8827] = 4074,
  [8828] = 8810,
  [8829] = 4092,
  [8830] = 4091,
  [8831] = 8819,
  [8832] = 4095,
  [8833] = 4061,
  [8834] = 8804,
  [8835] = 8810,
  [8836] = 4097,
  [8837] = 4113,
  [8838] = 8804,
  [8839] = 8808,
  [8840] = 4081,
  [8841] = 4114,
  [8842] = 8808,
  [8843] = 1262,
  [8844] = 4124,
  [8845] = 4063,
  [8846] = 8801,
  [8847] = 4122,
  [8848] = 1252,
  [8849] = 8819,
  [8850] = 4061,
  [8851] = 4080,
  [8852] = 8808,
  [8853] = 8802,
  [8854] = 4124,
  [8855] = 8855,
  [8856] = 8804,
  [8857] = 8857,
  [8858] = 8858,
  [8859] = 8810,
  [8860] = 8819,
  [8861] = 1268,
  [8862] = 8804,
  [8863] = 4099,
  [8864] = 4097,
  [8865] = 8819,
  [8866] = 8810,
  [8867] = 8806,
  [8868] = 8802,
  [8869] = 4122,
  [8870] = 1269,
  [8871] = 8802,
  [8872] = 8802,
  [8873] = 4114,
  [8874] = 8810,
  [8875] = 4113,
  [8876] = 8810,
  [8877] = 4095,
  [8878] = 4063,
  [8879] = 4092,
  [8880] = 8808,
  [8881] = 8804,
  [8882] = 8801,
  [8883] = 4073,
  [8884] = 1267,
  [8885] = 8819,
  [8886] = 8886,
  [8887] = 4071,
  [8888] = 4049,
  [8889] = 8819,
  [8890] = 3740,
  [8891] = 4050,
  [8892] = 8808,
  [8893] = 8806,
  [8894] = 4135,
  [8895] = 8802,
  [8896] = 8896,
  [8897] = 8810,
  [8898] = 8819,
  [8899] = 4111,
  [8900] = 8808,
  [8901] = 8901,
  [8902] = 8802,
  [8903] = 8810,
  [8904] = 8819,
  [8905] = 8905,
  [8906] = 1276,
  [8907] = 4099,
  [8908] = 8808,
  [8909] = 3751,
  [8910] = 8806,
  [8911] = 3725,
  [8912] = 8912,
  [8913] = 8808,
  [8914] = 4135,
  [8915] = 8801,
  [8916] = 4138,
  [8917] = 8802,
  [8918] = 8804,
  [8919] = 8801,
  [8920] = 8804,
  [8921] = 8921,
  [8922] = 4081,
  [8923] = 8801,
  [8924] = 4111,
  [8925] = 8819,
  [8926] = 8808,
  [8927] = 4074,
  [8928] = 4080,
  [8929] = 8802,
  [8930] = 8801,
  [8931] = 8931,
  [8932] = 8932,
  [8933] = 8933,
  [8934] = 3740,
  [8935] = 8935,
  [8936] = 4772,
  [8937] = 3725,
  [8938] = 3751,
  [8939] = 8939,
  [8940] = 3853,
  [8941] = 4124,
  [8942] = 8942,
  [8943] = 3786,
  [8944] = 8944,
  [8945] = 3804,
  [8946] = 8946,
  [8947] = 8947,
  [8948] = 8948,
  [8949] = 8949,
  [8950] = 8950,
  [8951] = 8951,
  [8952] = 8952,
  [8953] = 8953,
  [8954] = 8954,
  [8955] = 8949,
  [8956] = 8956,
  [8957] = 8931,
  [8958] = 8947,
  [8959] = 8933,
  [8960] = 8960,
  [8961] = 8961,
  [8962] = 8962,
  [8963] = 8963,
  [8964] = 8964,
  [8965] = 8965,
  [8966] = 8966,
  [8967] = 4050,
  [8968] = 4049,
  [8969] = 8964,
  [8970] = 8939,
  [8971] = 8950,
  [8972] = 8972,
  [8973] = 8973,
  [8974] = 8974,
  [8975] = 4071,
  [8976] = 4073,
  [8977] = 8953,
  [8978] = 8978,
  [8979] = 8964,
  [8980] = 8980,
  [8981] = 8978,
  [8982] = 8944,
  [8983] = 8983,
  [8984] = 8974,
  [8985] = 8985,
  [8986] = 4092,
  [8987] = 8987,
  [8988] = 4113,
  [8989] = 4114,
  [8990] = 4122,
  [8991] = 4063,
  [8992] = 8964,
  [8993] = 4081,
  [8994] = 8956,
  [8995] = 8931,
  [8996] = 8944,
  [8997] = 4061,
  [8998] = 8978,
  [8999] = 8973,
  [9000] = 8931,
  [9001] = 8973,
  [9002] = 9002,
  [9003] = 8956,
  [9004] = 9004,
  [9005] = 8974,
  [9006] = 8942,
  [9007] = 8960,
  [9008] = 9008,
  [9009] = 8974,
  [9010] = 8949,
  [9011] = 4097,
  [9012] = 4091,
  [9013] = 8964,
  [9014] = 9014,
  [9015] = 4080,
  [9016] = 4074,
  [9017] = 8953,
  [9018] = 8939,
  [9019] = 9019,
  [9020] = 8978,
  [9021] = 4138,
  [9022] = 8965,
  [9023] = 1253,
  [9024] = 8931,
  [9025] = 8963,
  [9026] = 8956,
  [9027] = 4099,
  [9028] = 4095,
  [9029] = 8947,
  [9030] = 8933,
  [9031] = 9031,
  [9032] = 8933,
  [9033] = 9002,
  [9034] = 8947,
  [9035] = 1285,
  [9036] = 1253,
  [9037] = 8978,
  [9038] = 4135,
  [9039] = 1295,
  [9040] = 8973,
  [9041] = 8953,
  [9042] = 8965,
  [9043] = 8964,
  [9044] = 8960,
  [9045] = 9045,
  [9046] = 8974,
  [9047] = 8963,
  [9048] = 9048,
  [9049] = 9049,
  [9050] = 4111,
  [9051] = 8978,
  [9052] = 8949,
  [9053] = 9053,
  [9054] = 8942,
  [9055] = 8951,
  [9056] = 9056,
  [9057] = 8964,
  [9058] = 9058,
  [9059] = 8960,
  [9060] = 8978,
  [9061] = 8978,
  [9062] = 8978,
  [9063] = 8950,
  [9064] = 8939,
  [9065] = 8954,
  [9066] = 8978,
  [9067] = 8978,
  [9068] = 9068,
  [9069] = 8978,
  [9070] = 8956,
  [9071] = 8947,
  [9072] = 9072,
  [9073] = 8931,
  [9074] = 8978,
  [9075] = 9075,
  [9076] = 8951,
  [9077] = 9077,
  [9078] = 9078,
  [9079] = 8951,
  [9080] = 8978,
  [9081] = 8933,
  [9082] = 8950,
  [9083] = 8947,
  [9084] = 8942,
  [9085] = 9085,
  [9086] = 8978,
  [9087] = 8974,
  [9088] = 8951,
  [9089] = 9019,
  [9090] = 9014,
  [9091] = 8978,
  [9092] = 8978,
  [9093] = 9093,
  [9094] = 8956,
  [9095] = 8931,
  [9096] = 8964,
  [9097] = 8974,
  [9098] = 8978,
  [9099] = 8944,
  [9100] = 8974,
  [9101] = 9101,
  [9102] = 8949,
  [9103] = 8953,
  [9104] = 9104,
  [9105] = 8944,
  [9106] = 8952,
  [9107] = 8978,
  [9108] = 8978,
  [9109] = 8942,
  [9110] = 9110,
  [9111] = 8987,
  [9112] = 9104,
  [9113] = 8965,
  [9114] = 8980,
  [9115] = 8978,
  [9116] = 8952,
  [9117] = 8954,
  [9118] = 8942,
  [9119] = 8964,
  [9120] = 9120,
  [9121] = 8956,
  [9122] = 8974,
  [9123] = 8951,
  [9124] = 8978,
  [9125] = 8931,
  [9126] = 8978,
  [9127] = 8939,
  [9128] = 1311,
  [9129] = 8954,
  [9130] = 8952,
  [9131] = 8964,
  [9132] = 8952,
  [9133] = 8978,
  [9134] = 9134,
  [9135] = 8974,
  [9136] = 8944,
  [9137] = 8964,
  [9138] = 8956,
  [9139] = 8933,
  [9140] = 8978,
  [9141] = 8947,
  [9142] = 8953,
  [9143] = 8964,
  [9144] = 8947,
  [9145] = 9104,
  [9146] = 1306,
  [9147] = 8978,
  [9148] = 8978,
  [9149] = 8951,
  [9150] = 8980,
  [9151] = 8978,
  [9152] = 8950,
  [9153] = 8960,
  [9154] = 8987,
  [9155] = 8949,
  [9156] = 8963,
  [9157] = 8974,
  [9158] = 8978,
  [9159] = 9159,
  [9160] = 8965,
  [9161] = 8978,
  [9162] = 9085,
  [9163] = 8978,
  [9164] = 8973,
  [9165] = 9008,
  [9166] = 8964,
  [9167] = 8960,
  [9168] = 8964,
  [9169] = 8974,
  [9170] = 8942,
  [9171] = 8980,
  [9172] = 8978,
  [9173] = 8978,
  [9174] = 9174,
  [9175] = 8974,
  [9176] = 9176,
  [9177] = 8953,
  [9178] = 9014,
  [9179] = 9019,
  [9180] = 9085,
  [9181] = 9014,
  [9182] = 8931,
  [9183] = 8956,
  [9184] = 8978,
  [9185] = 5346,
  [9186] = 9019,
  [9187] = 8931,
  [9188] = 8956,
  [9189] = 8939,
  [9190] = 8950,
  [9191] = 9191,
  [9192] = 8974,
  [9193] = 9193,
  [9194] = 9194,
  [9195] = 8978,
  [9196] = 8978,
  [9197] = 8953,
  [9198] = 9198,
  [9199] = 8956,
  [9200] = 8931,
  [9201] = 8964,
  [9202] = 8949,
  [9203] = 8973,
  [9204] = 9085,
  [9205] = 9019,
  [9206] = 9174,
  [9207] = 9014,
  [9208] = 9008,
  [9209] = 8950,
  [9210] = 8974,
  [9211] = 9211,
  [9212] = 8947,
  [9213] = 8965,
  [9214] = 8978,
  [9215] = 8963,
  [9216] = 9174,
  [9217] = 8933,
  [9218] = 9104,
  [9219] = 8963,
  [9220] = 8950,
  [9221] = 9221,
  [9222] = 8947,
  [9223] = 8944,
  [9224] = 8960,
  [9225] = 8973,
  [9226] = 8978,
  [9227] = 8974,
  [9228] = 8987,
  [9229] = 8980,
  [9230] = 8965,
  [9231] = 8978,
  [9232] = 9232,
  [9233] = 8978,
  [9234] = 8964,
  [9235] = 8963,
  [9236] = 8964,
  [9237] = 8942,
  [9238] = 8949,
  [9239] = 8978,
  [9240] = 8956,
  [9241] = 8931,
  [9242] = 8978,
  [9243] = 8950,
  [9244] = 8954,
  [9245] = 8952,
  [9246] = 8960,
  [9247] = 8980,
  [9248] = 9134,
  [9249] = 8978,
  [9250] = 8951,
  [9251] = 9008,
  [9252] = 9174,
  [9253] = 8942,
  [9254] = 8944,
  [9255] = 8965,
  [9256] = 8978,
  [9257] = 8963,
  [9258] = 8939,
  [9259] = 8951,
  [9260] = 8974,
  [9261] = 8974,
  [9262] = 8951,
  [9263] = 8978,
  [9264] = 9264,
  [9265] = 8978,
  [9266] = 8933,
  [9267] = 4777,
  [9268] = 8960,
  [9269] = 8978,
  [9270] = 8964,
  [9271] = 8953,
  [9272] = 8947,
  [9273] = 8978,
  [9274] = 8944,
  [9275] = 8947,
  [9276] = 9276,
  [9277] = 8963,
  [9278] = 8965,
  [9279] = 8978,
  [9280] = 8973,
  [9281] = 4780,
  [9282] = 8978,
  [9283] = 8964,
  [9284] = 8939,
  [9285] = 8973,
  [9286] = 9286,
  [9287] = 8956,
  [9288] = 8949,
  [9289] = 8944,
  [9290] = 8931,
  [9291] = 8964,
  [9292] = 8952,
  [9293] = 9293,
  [9294] = 9085,
  [9295] = 9134,
  [9296] = 8978,
  [9297] = 8954,
  [9298] = 8978,
  [9299] = 9019,
  [9300] = 9014,
  [9301] = 8974,
  [9302] = 9104,
  [9303] = 8956,
  [9304] = 8978,
  [9305] = 8978,
  [9306] = 9306,
  [9307] = 8987,
  [9308] = 8980,
  [9309] = 8953,
  [9310] = 8931,
  [9311] = 8939,
  [9312] = 9312,
  [9313] = 8978,
  [9314] = 8964,
  [9315] = 9072,
  [9316] = 8952,
  [9317] = 8964,
  [9318] = 8950,
  [9319] = 8954,
  [9320] = 8978,
  [9321] = 8947,
  [9322] = 8954,
  [9323] = 9323,
  [9324] = 8952,
  [9325] = 9134,
  [9326] = 8978,
  [9327] = 8949,
  [9328] = 8978,
  [9329] = 8980,
  [9330] = 8987,
  [9331] = 8944,
  [9332] = 8964,
  [9333] = 9019,
  [9334] = 8987,
  [9335] = 9019,
  [9336] = 8978,
  [9337] = 9014,
  [9338] = 8978,
  [9339] = 8933,
  [9340] = 8947,
  [9341] = 9014,
  [9342] = 8956,
  [9343] = 8978,
  [9344] = 9104,
  [9345] = 9345,
  [9346] = 8931,
  [9347] = 8951,
  [9348] = 8978,
  [9349] = 8974,
  [9350] = 8974,
  [9351] = 8987,
  [9352] = 8973,
  [9353] = 9353,
  [9354] = 8978,
  [9355] = 9014,
  [9356] = 9019,
  [9357] = 8978,
  [9358] = 9191,
  [9359] = 9085,
  [9360] = 9360,
  [9361] = 8963,
  [9362] = 8965,
  [9363] = 8974,
  [9364] = 8978,
  [9365] = 8974,
  [9366] = 8947,
  [9367] = 8939,
  [9368] = 8947,
  [9369] = 9369,
  [9370] = 8942,
  [9371] = 8931,
  [9372] = 8956,
  [9373] = 8978,
  [9374] = 8960,
  [9375] = 9375,
  [9376] = 8980,
  [9377] = 9377,
  [9378] = 9378,
  [9379] = 9379,
  [9380] = 9380,
  [9381] = 9381,
  [9382] = 9379,
  [9383] = 9383,
  [9384] = 9384,
  [9385] = 9385,
  [9386] = 9386,
  [9387] = 9387,
  [9388] = 9388,
  [9389] = 9389,
  [9390] = 9390,
  [9391] = 9379,
  [9392] = 9392,
  [9393] = 9393,
  [9394] = 9394,
  [9395] = 9395,
  [9396] = 9396,
  [9397] = 9379,
  [9398] = 9398,
  [9399] = 9381,
  [9400] = 9400,
  [9401] = 9377,
  [9402] = 9402,
  [9403] = 9386,
  [9404] = 9404,
  [9405] = 9405,
  [9406] = 9406,
  [9407] = 9407,
  [9408] = 9381,
  [9409] = 9409,
  [9410] = 9393,
  [9411] = 9411,
  [9412] = 9380,
  [9413] = 9413,
  [9414] = 9386,
  [9415] = 9415,
  [9416] = 9416,
  [9417] = 9417,
  [9418] = 9418,
  [9419] = 9419,
  [9420] = 9420,
  [9421] = 9421,
  [9422] = 9422,
  [9423] = 9405,
  [9424] = 9389,
  [9425] = 9393,
  [9426] = 9426,
  [9427] = 9393,
  [9428] = 9383,
  [9429] = 9385,
  [9430] = 9388,
  [9431] = 9405,
  [9432] = 9379,
  [9433] = 9390,
  [9434] = 9386,
  [9435] = 9435,
  [9436] = 6325,
  [9437] = 9437,
  [9438] = 9386,
  [9439] = 9393,
  [9440] = 9440,
  [9441] = 9441,
  [9442] = 9422,
  [9443] = 9384,
  [9444] = 9413,
  [9445] = 9387,
  [9446] = 9446,
  [9447] = 9402,
  [9448] = 9422,
  [9449] = 9381,
  [9450] = 9450,
  [9451] = 9451,
  [9452] = 9404,
  [9453] = 9389,
  [9454] = 9417,
  [9455] = 9418,
  [9456] = 9426,
  [9457] = 9381,
  [9458] = 9393,
  [9459] = 9415,
  [9460] = 9460,
  [9461] = 9394,
  [9462] = 9440,
  [9463] = 9396,
  [9464] = 9400,
  [9465] = 9435,
  [9466] = 9400,
  [9467] = 9467,
  [9468] = 9468,
  [9469] = 9396,
  [9470] = 9416,
  [9471] = 9402,
  [9472] = 9419,
  [9473] = 9437,
  [9474] = 9441,
  [9475] = 9460,
  [9476] = 5391,
  [9477] = 9386,
  [9478] = 9385,
  [9479] = 9405,
  [9480] = 9440,
  [9481] = 9394,
  [9482] = 9409,
  [9483] = 9483,
  [9484] = 9450,
  [9485] = 9485,
  [9486] = 9468,
  [9487] = 9467,
  [9488] = 9379,
  [9489] = 9422,
  [9490] = 9381,
  [9491] = 4151,
  [9492] = 9416,
  [9493] = 9393,
  [9494] = 9380,
  [9495] = 9409,
  [9496] = 9441,
  [9497] = 9419,
  [9498] = 9419,
  [9499] = 9416,
  [9500] = 9381,
  [9501] = 9386,
  [9502] = 9441,
  [9503] = 9415,
  [9504] = 4168,
  [9505] = 9467,
  [9506] = 9387,
  [9507] = 9390,
  [9508] = 9508,
  [9509] = 9440,
  [9510] = 9383,
  [9511] = 9460,
  [9512] = 9468,
  [9513] = 9451,
  [9514] = 9384,
  [9515] = 9388,
  [9516] = 9385,
  [9517] = 9422,
  [9518] = 4176,
  [9519] = 9384,
  [9520] = 9381,
  [9521] = 9521,
  [9522] = 9422,
  [9523] = 9383,
  [9524] = 9389,
  [9525] = 9450,
  [9526] = 9387,
  [9527] = 6409,
  [9528] = 9380,
  [9529] = 9468,
  [9530] = 9467,
  [9531] = 9393,
  [9532] = 9532,
  [9533] = 9381,
  [9534] = 9534,
  [9535] = 9446,
  [9536] = 9405,
  [9537] = 9392,
  [9538] = 9451,
  [9539] = 9422,
  [9540] = 9404,
  [9541] = 9541,
  [9542] = 4124,
  [9543] = 9394,
  [9544] = 9435,
  [9545] = 9441,
  [9546] = 4166,
  [9547] = 4149,
  [9548] = 9548,
  [9549] = 9392,
  [9550] = 9396,
  [9551] = 9400,
  [9552] = 9419,
  [9553] = 9384,
  [9554] = 9405,
  [9555] = 9398,
  [9556] = 9416,
  [9557] = 9467,
  [9558] = 9402,
  [9559] = 9386,
  [9560] = 9381,
  [9561] = 9467,
  [9562] = 9404,
  [9563] = 9563,
  [9564] = 9406,
  [9565] = 9402,
  [9566] = 9405,
  [9567] = 9407,
  [9568] = 9446,
  [9569] = 9422,
  [9570] = 9381,
  [9571] = 9386,
  [9572] = 9440,
  [9573] = 9573,
  [9574] = 9411,
  [9575] = 9388,
  [9576] = 9451,
  [9577] = 9437,
  [9578] = 9435,
  [9579] = 9417,
  [9580] = 9418,
  [9581] = 9420,
  [9582] = 9380,
  [9583] = 9421,
  [9584] = 9402,
  [9585] = 9400,
  [9586] = 9385,
  [9587] = 9426,
  [9588] = 9396,
  [9589] = 9426,
  [9590] = 9379,
  [9591] = 9386,
  [9592] = 9394,
  [9593] = 9435,
  [9594] = 9437,
  [9595] = 9386,
  [9596] = 9421,
  [9597] = 9420,
  [9598] = 9413,
  [9599] = 9437,
  [9600] = 9435,
  [9601] = 9446,
  [9602] = 9379,
  [9603] = 9418,
  [9604] = 9450,
  [9605] = 9605,
  [9606] = 9450,
  [9607] = 9417,
  [9608] = 9383,
  [9609] = 9451,
  [9610] = 9388,
  [9611] = 9411,
  [9612] = 9377,
  [9613] = 9573,
  [9614] = 9440,
  [9615] = 9426,
  [9616] = 9405,
  [9617] = 9421,
  [9618] = 9618,
  [9619] = 9420,
  [9620] = 9393,
  [9621] = 9467,
  [9622] = 9384,
  [9623] = 9407,
  [9624] = 9406,
  [9625] = 9468,
  [9626] = 9418,
  [9627] = 9387,
  [9628] = 9389,
  [9629] = 9387,
  [9630] = 9386,
  [9631] = 9460,
  [9632] = 9440,
  [9633] = 9415,
  [9634] = 9467,
  [9635] = 9384,
  [9636] = 9398,
  [9637] = 9387,
  [9638] = 9383,
  [9639] = 9418,
  [9640] = 9409,
  [9641] = 9377,
  [9642] = 9377,
  [9643] = 4153,
  [9644] = 9644,
  [9645] = 9422,
  [9646] = 9394,
  [9647] = 9422,
  [9648] = 9381,
  [9649] = 9441,
  [9650] = 9419,
  [9651] = 9468,
  [9652] = 9416,
  [9653] = 9396,
  [9654] = 9400,
  [9655] = 9398,
  [9656] = 9398,
  [9657] = 9417,
  [9658] = 9404,
  [9659] = 9381,
  [9660] = 9386,
  [9661] = 9402,
  [9662] = 9380,
  [9663] = 9411,
  [9664] = 9437,
  [9665] = 9390,
  [9666] = 9417,
  [9667] = 9405,
  [9668] = 9407,
  [9669] = 9446,
  [9670] = 9670,
  [9671] = 9405,
  [9672] = 4173,
  [9673] = 9407,
  [9674] = 9388,
  [9675] = 9385,
  [9676] = 9404,
  [9677] = 9677,
  [9678] = 9573,
  [9679] = 9404,
  [9680] = 9393,
  [9681] = 9418,
  [9682] = 9437,
  [9683] = 9386,
  [9684] = 9618,
  [9685] = 9405,
  [9686] = 9392,
  [9687] = 9380,
  [9688] = 9402,
  [9689] = 9400,
  [9690] = 9389,
  [9691] = 9396,
  [9692] = 9422,
  [9693] = 9532,
  [9694] = 9534,
  [9695] = 9381,
  [9696] = 9393,
  [9697] = 9406,
  [9698] = 9435,
  [9699] = 4163,
  [9700] = 9394,
  [9701] = 9437,
  [9702] = 9386,
  [9703] = 9381,
  [9704] = 9402,
  [9705] = 9440,
  [9706] = 5386,
  [9707] = 3847,
  [9708] = 9426,
  [9709] = 9409,
  [9710] = 9418,
  [9711] = 9711,
  [9712] = 3829,
  [9713] = 9713,
  [9714] = 9417,
  [9715] = 9413,
  [9716] = 3823,
  [9717] = 9389,
  [9718] = 9467,
  [9719] = 9383,
  [9720] = 4142,
  [9721] = 9468,
  [9722] = 9387,
  [9723] = 9437,
  [9724] = 9724,
  [9725] = 9385,
  [9726] = 3776,
  [9727] = 9386,
  [9728] = 9388,
  [9729] = 9417,
  [9730] = 9404,
  [9731] = 9573,
  [9732] = 9384,
  [9733] = 9379,
  [9734] = 9422,
  [9735] = 9384,
  [9736] = 9389,
  [9737] = 9380,
  [9738] = 9618,
  [9739] = 9392,
  [9740] = 9740,
  [9741] = 9387,
  [9742] = 9422,
  [9743] = 9381,
  [9744] = 9468,
  [9745] = 9385,
  [9746] = 9388,
  [9747] = 9398,
  [9748] = 9377,
  [9749] = 9413,
  [9750] = 9441,
  [9751] = 9390,
  [9752] = 9404,
  [9753] = 9419,
  [9754] = 9406,
  [9755] = 9407,
  [9756] = 9416,
  [9757] = 9405,
  [9758] = 9411,
  [9759] = 9417,
  [9760] = 9381,
  [9761] = 9417,
  [9762] = 9416,
  [9763] = 9394,
  [9764] = 9418,
  [9765] = 9396,
  [9766] = 9419,
  [9767] = 9400,
  [9768] = 9768,
  [9769] = 9420,
  [9770] = 9421,
  [9771] = 9405,
  [9772] = 9381,
  [9773] = 9451,
  [9774] = 9774,
  [9775] = 9416,
  [9776] = 9441,
  [9777] = 9419,
  [9778] = 9388,
  [9779] = 9402,
  [9780] = 9388,
  [9781] = 9435,
  [9782] = 9485,
  [9783] = 9441,
  [9784] = 9437,
  [9785] = 9386,
  [9786] = 9422,
  [9787] = 9385,
  [9788] = 9788,
  [9789] = 9405,
  [9790] = 9413,
  [9791] = 9422,
  [9792] = 9446,
  [9793] = 9437,
  [9794] = 9386,
  [9795] = 9389,
  [9796] = 9420,
  [9797] = 9450,
  [9798] = 9418,
  [9799] = 9799,
  [9800] = 9800,
  [9801] = 9801,
  [9802] = 9802,
  [9803] = 9440,
  [9804] = 9396,
  [9805] = 9380,
  [9806] = 9467,
  [9807] = 9420,
  [9808] = 9415,
  [9809] = 9468,
  [9810] = 9400,
  [9811] = 9811,
  [9812] = 9415,
  [9813] = 9422,
  [9814] = 9814,
  [9815] = 9381,
  [9816] = 9379,
  [9817] = 9460,
  [9818] = 9415,
  [9819] = 9468,
  [9820] = 9389,
  [9821] = 9409,
  [9822] = 9409,
  [9823] = 9421,
  [9824] = 9396,
  [9825] = 9415,
  [9826] = 9467,
  [9827] = 6368,
  [9828] = 9394,
  [9829] = 9422,
  [9830] = 9460,
  [9831] = 9441,
  [9832] = 9419,
  [9833] = 9416,
  [9834] = 4151,
  [9835] = 9383,
  [9836] = 9814,
  [9837] = 9381,
  [9838] = 9404,
  [9839] = 9405,
  [9840] = 9440,
  [9841] = 9451,
  [9842] = 9389,
  [9843] = 9468,
  [9844] = 9844,
  [9845] = 9450,
  [9846] = 9384,
  [9847] = 9379,
  [9848] = 9467,
  [9849] = 9849,
  [9850] = 9440,
  [9851] = 9387,
  [9852] = 9390,
  [9853] = 9413,
  [9854] = 9451,
  [9855] = 9855,
  [9856] = 9450,
  [9857] = 9857,
  [9858] = 9437,
  [9859] = 9388,
  [9860] = 9446,
  [9861] = 9386,
  [9862] = 4168,
  [9863] = 4176,
  [9864] = 9385,
  [9865] = 9387,
  [9866] = 9866,
  [9867] = 9379,
  [9868] = 9384,
  [9869] = 9446,
  [9870] = 9870,
  [9871] = 9404,
  [9872] = 9422,
  [9873] = 9380,
  [9874] = 9394,
  [9875] = 9386,
  [9876] = 9381,
  [9877] = 9532,
  [9878] = 9396,
  [9879] = 9417,
  [9880] = 9379,
  [9881] = 9413,
  [9882] = 9882,
  [9883] = 9418,
  [9884] = 9400,
  [9885] = 9384,
  [9886] = 9437,
  [9887] = 9380,
  [9888] = 9402,
  [9889] = 9435,
  [9890] = 9386,
  [9891] = 9386,
  [9892] = 9437,
  [9893] = 4173,
  [9894] = 9435,
  [9895] = 9435,
  [9896] = 9896,
  [9897] = 9405,
  [9898] = 9426,
  [9899] = 9405,
  [9900] = 9437,
  [9901] = 9426,
  [9902] = 9421,
  [9903] = 9420,
  [9904] = 9386,
  [9905] = 9389,
  [9906] = 9483,
  [9907] = 9418,
  [9908] = 9417,
  [9909] = 9435,
  [9910] = 9388,
  [9911] = 9437,
  [9912] = 9380,
  [9913] = 9418,
  [9914] = 9386,
  [9915] = 9411,
  [9916] = 9411,
  [9917] = 9532,
  [9918] = 9534,
  [9919] = 9437,
  [9920] = 9920,
  [9921] = 9386,
  [9922] = 9421,
  [9923] = 9402,
  [9924] = 9534,
  [9925] = 4166,
  [9926] = 4149,
  [9927] = 9400,
  [9928] = 9928,
  [9929] = 9440,
  [9930] = 9814,
  [9931] = 9388,
  [9932] = 1253,
  [9933] = 9418,
  [9934] = 9383,
  [9935] = 9935,
  [9936] = 9467,
  [9937] = 9417,
  [9938] = 9420,
  [9939] = 9381,
  [9940] = 4153,
  [9941] = 9384,
  [9942] = 9421,
  [9943] = 9437,
  [9944] = 9422,
  [9945] = 9387,
  [9946] = 9407,
  [9947] = 9467,
  [9948] = 9411,
  [9949] = 9468,
  [9950] = 9381,
  [9951] = 9406,
  [9952] = 9416,
  [9953] = 9953,
  [9954] = 9404,
  [9955] = 4163,
  [9956] = 9393,
  [9957] = 9394,
  [9958] = 9958,
  [9959] = 9393,
  [9960] = 9394,
  [9961] = 9377,
  [9962] = 9407,
  [9963] = 9396,
  [9964] = 5816,
  [9965] = 9400,
  [9966] = 9966,
  [9967] = 9422,
  [9968] = 9402,
  [9969] = 9398,
  [9970] = 9970,
  [9971] = 9387,
  [9972] = 9380,
  [9973] = 9419,
  [9974] = 9392,
  [9975] = 9407,
  [9976] = 9441,
  [9977] = 9405,
  [9978] = 9978,
  [9979] = 9441,
  [9980] = 9393,
  [9981] = 9404,
  [9982] = 4142,
  [9983] = 9411,
  [9984] = 9405,
  [9985] = 5792,
  [9986] = 9419,
  [9987] = 9896,
  [9988] = 9416,
  [9989] = 9380,
  [9990] = 9404,
  [9991] = 9970,
  [9992] = 9381,
  [9993] = 9402,
  [9994] = 5781,
  [9995] = 9417,
  [9996] = 9418,
  [9997] = 9384,
  [9998] = 9998,
  [9999] = 9389,
  [10000] = 9801,
  [10001] = 9405,
  [10002] = 9400,
  [10003] = 9396,
  [10004] = 9388,
  [10005] = 9970,
  [10006] = 9394,
  [10007] = 9435,
  [10008] = 9437,
  [10009] = 9386,
  [10010] = 9422,
  [10011] = 10011,
  [10012] = 9440,
  [10013] = 9381,
  [10014] = 9385,
  [10015] = 9394,
  [10016] = 9379,
  [10017] = 9384,
  [10018] = 9467,
  [10019] = 9379,
  [10020] = 9416,
  [10021] = 9814,
  [10022] = 9387,
  [10023] = 9426,
  [10024] = 9385,
  [10025] = 9384,
  [10026] = 9485,
  [10027] = 9468,
  [10028] = 9618,
  [10029] = 9389,
  [10030] = 9485,
  [10031] = 9405,
  [10032] = 9388,
  [10033] = 9405,
  [10034] = 9389,
  [10035] = 9394,
  [10036] = 9390,
  [10037] = 9400,
  [10038] = 9446,
  [10039] = 9384,
  [10040] = 9392,
  [10041] = 9383,
  [10042] = 9422,
  [10043] = 9384,
  [10044] = 9406,
  [10045] = 9383,
  [10046] = 9441,
  [10047] = 9419,
  [10048] = 9416,
  [10049] = 9435,
  [10050] = 10050,
  [10051] = 9381,
  [10052] = 9415,
  [10053] = 9379,
  [10054] = 9385,
  [10055] = 9388,
  [10056] = 9405,
  [10057] = 9381,
  [10058] = 9394,
  [10059] = 9416,
  [10060] = 9394,
  [10061] = 9392,
  [10062] = 9381,
  [10063] = 9419,
  [10064] = 9416,
  [10065] = 9419,
  [10066] = 9405,
  [10067] = 9441,
  [10068] = 9422,
  [10069] = 9393,
  [10070] = 9441,
  [10071] = 9450,
  [10072] = 9394,
  [10073] = 9398,
  [10074] = 9422,
  [10075] = 9377,
  [10076] = 9451,
  [10077] = 9468,
  [10078] = 9441,
  [10079] = 9404,
  [10080] = 9409,
  [10081] = 9406,
  [10082] = 9407,
  [10083] = 9384,
  [10084] = 9393,
  [10085] = 9970,
  [10086] = 9411,
  [10087] = 9380,
  [10088] = 9419,
  [10089] = 9417,
  [10090] = 9384,
  [10091] = 3786,
  [10092] = 9387,
  [10093] = 3804,
  [10094] = 1253,
  [10095] = 9418,
  [10096] = 9420,
  [10097] = 1390,
  [10098] = 9394,
  [10099] = 9405,
  [10100] = 1438,
  [10101] = 1394,
  [10102] = 9415,
  [10103] = 1366,
  [10104] = 9389,
  [10105] = 9421,
  [10106] = 9460,
  [10107] = 1402,
  [10108] = 9402,
  [10109] = 9426,
  [10110] = 9404,
  [10111] = 9435,
  [10112] = 1413,
  [10113] = 1332,
  [10114] = 1347,
  [10115] = 1355,
  [10116] = 9394,
  [10117] = 9400,
  [10118] = 9396,
  [10119] = 1356,
  [10120] = 1357,
  [10121] = 9394,
  [10122] = 1358,
  [10123] = 9437,
  [10124] = 1462,
  [10125] = 1409,
  [10126] = 1408,
  [10127] = 1407,
  [10128] = 1404,
  [10129] = 9386,
  [10130] = 9417,
  [10131] = 9396,
  [10132] = 9400,
  [10133] = 1403,
  [10134] = 1398,
  [10135] = 1396,
  [10136] = 1395,
  [10137] = 9387,
  [10138] = 9418,
  [10139] = 1385,
  [10140] = 9384,
  [10141] = 9402,
  [10142] = 1382,
  [10143] = 1315,
  [10144] = 1376,
  [10145] = 1374,
  [10146] = 1365,
  [10147] = 9460,
  [10148] = 9422,
  [10149] = 9446,
  [10150] = 1351,
  [10151] = 9405,
  [10152] = 10152,
  [10153] = 10153,
  [10154] = 9383,
  [10155] = 1345,
  [10156] = 1317,
  [10157] = 9390,
  [10158] = 3778,
  [10159] = 9394,
  [10160] = 9468,
  [10161] = 9450,
  [10162] = 9451,
  [10163] = 3879,
  [10164] = 9383,
  [10165] = 9440,
  [10166] = 9467,
  [10167] = 9384,
  [10168] = 9435,
  [10169] = 9467,
  [10170] = 9468,
  [10171] = 9437,
  [10172] = 9386,
  [10173] = 3804,
  [10174] = 9405,
  [10175] = 9440,
  [10176] = 9970,
  [10177] = 3853,
  [10178] = 9380,
  [10179] = 9396,
  [10180] = 3786,
  [10181] = 9394,
  [10182] = 9440,
  [10183] = 9384,
  [10184] = 9405,
  [10185] = 10185,
  [10186] = 10186,
  [10187] = 10187,
  [10188] = 10188,
  [10189] = 10189,
  [10190] = 10190,
  [10191] = 10191,
  [10192] = 10192,
  [10193] = 10193,
  [10194] = 10194,
  [10195] = 10195,
  [10196] = 10196,
  [10197] = 10197,
  [10198] = 10198,
  [10199] = 10190,
  [10200] = 10200,
  [10201] = 10201,
  [10202] = 10202,
  [10203] = 10203,
  [10204] = 10204,
  [10205] = 10205,
  [10206] = 10206,
  [10207] = 10207,
  [10208] = 10208,
  [10209] = 10209,
  [10210] = 10210,
  [10211] = 10211,
  [10212] = 10212,
  [10213] = 10213,
  [10214] = 10214,
  [10215] = 10208,
  [10216] = 10216,
  [10217] = 10217,
  [10218] = 10186,
  [10219] = 10219,
  [10220] = 10219,
  [10221] = 10221,
  [10222] = 10214,
  [10223] = 10186,
  [10224] = 10213,
  [10225] = 10211,
  [10226] = 10210,
  [10227] = 10206,
  [10228] = 10205,
  [10229] = 10217,
  [10230] = 10216,
  [10231] = 10204,
  [10232] = 10201,
  [10233] = 10233,
  [10234] = 10208,
  [10235] = 10194,
  [10236] = 10193,
  [10237] = 10212,
  [10238] = 10192,
  [10239] = 10209,
  [10240] = 10191,
  [10241] = 10241,
  [10242] = 10242,
  [10243] = 10197,
  [10244] = 10195,
  [10245] = 10203,
  [10246] = 10188,
  [10247] = 10200,
  [10248] = 10196,
  [10249] = 10249,
  [10250] = 10250,
  [10251] = 10198,
  [10252] = 10190,
  [10253] = 10187,
  [10254] = 10187,
  [10255] = 10190,
  [10256] = 10187,
  [10257] = 10257,
  [10258] = 10258,
  [10259] = 10259,
  [10260] = 10198,
  [10261] = 10203,
  [10262] = 10209,
  [10263] = 10212,
  [10264] = 10264,
  [10265] = 10265,
  [10266] = 10250,
  [10267] = 10267,
  [10268] = 10216,
  [10269] = 10196,
  [10270] = 10217,
  [10271] = 10186,
  [10272] = 10200,
  [10273] = 10198,
  [10274] = 10274,
  [10275] = 10188,
  [10276] = 10219,
  [10277] = 10195,
  [10278] = 10214,
  [10279] = 10197,
  [10280] = 10213,
  [10281] = 10211,
  [10282] = 10210,
  [10283] = 10206,
  [10284] = 10205,
  [10285] = 10285,
  [10286] = 10204,
  [10287] = 10191,
  [10288] = 10192,
  [10289] = 10193,
  [10290] = 10194,
  [10291] = 10201,
  [10292] = 10292,
  [10293] = 10293,
  [10294] = 10294,
  [10295] = 10194,
  [10296] = 10193,
  [10297] = 10201,
  [10298] = 10192,
  [10299] = 10191,
  [10300] = 10204,
  [10301] = 10301,
  [10302] = 10302,
  [10303] = 10302,
  [10304] = 10210,
  [10305] = 10302,
  [10306] = 10213,
  [10307] = 10214,
  [10308] = 10302,
  [10309] = 10302,
  [10310] = 10302,
  [10311] = 10302,
  [10312] = 10302,
  [10313] = 10313,
  [10314] = 10186,
  [10315] = 10302,
  [10316] = 10302,
  [10317] = 10317,
  [10318] = 10302,
  [10319] = 10217,
  [10320] = 10216,
  [10321] = 10302,
  [10322] = 10302,
  [10323] = 10323,
  [10324] = 10208,
  [10325] = 10302,
  [10326] = 10302,
  [10327] = 10212,
  [10328] = 10302,
  [10329] = 10209,
  [10330] = 10302,
  [10331] = 10203,
  [10332] = 10302,
  [10333] = 10302,
  [10334] = 10334,
  [10335] = 10335,
  [10336] = 10190,
  [10337] = 10302,
  [10338] = 10338,
  [10339] = 10302,
  [10340] = 10302,
  [10341] = 10198,
  [10342] = 10342,
  [10343] = 10343,
  [10344] = 10250,
  [10345] = 10196,
  [10346] = 10302,
  [10347] = 10342,
  [10348] = 10302,
  [10349] = 10195,
  [10350] = 10342,
  [10351] = 10302,
  [10352] = 10342,
  [10353] = 10302,
  [10354] = 10342,
  [10355] = 10189,
  [10356] = 10335,
  [10357] = 10191,
  [10358] = 10192,
  [10359] = 10193,
  [10360] = 10194,
  [10361] = 10302,
  [10362] = 10342,
  [10363] = 10189,
  [10364] = 10335,
  [10365] = 10302,
  [10366] = 10342,
  [10367] = 10201,
  [10368] = 10189,
  [10369] = 10369,
  [10370] = 10204,
  [10371] = 10302,
  [10372] = 10342,
  [10373] = 10189,
  [10374] = 10210,
  [10375] = 10335,
  [10376] = 10213,
  [10377] = 10214,
  [10378] = 10369,
  [10379] = 10379,
  [10380] = 10302,
  [10381] = 10342,
  [10382] = 10189,
  [10383] = 10335,
  [10384] = 10186,
  [10385] = 10369,
  [10386] = 10379,
  [10387] = 10302,
  [10388] = 10342,
  [10389] = 10217,
  [10390] = 10216,
  [10391] = 10189,
  [10392] = 10335,
  [10393] = 10369,
  [10394] = 10208,
  [10395] = 10379,
  [10396] = 10302,
  [10397] = 10212,
  [10398] = 10342,
  [10399] = 10209,
  [10400] = 10189,
  [10401] = 10203,
  [10402] = 10335,
  [10403] = 10369,
  [10404] = 10379,
  [10405] = 10405,
  [10406] = 10190,
  [10407] = 10302,
  [10408] = 10342,
  [10409] = 10189,
  [10410] = 10335,
  [10411] = 10198,
  [10412] = 10369,
  [10413] = 10379,
  [10414] = 10250,
  [10415] = 10196,
  [10416] = 10416,
  [10417] = 10302,
  [10418] = 10342,
  [10419] = 10195,
  [10420] = 10189,
  [10421] = 10335,
  [10422] = 10369,
  [10423] = 10379,
  [10424] = 10302,
  [10425] = 10342,
  [10426] = 10191,
  [10427] = 10192,
  [10428] = 10193,
  [10429] = 10194,
  [10430] = 10189,
  [10431] = 10335,
  [10432] = 10369,
  [10433] = 10379,
  [10434] = 10434,
  [10435] = 10302,
  [10436] = 10201,
  [10437] = 10342,
  [10438] = 10189,
  [10439] = 10204,
  [10440] = 10335,
  [10441] = 10369,
  [10442] = 10379,
  [10443] = 10210,
  [10444] = 10302,
  [10445] = 10213,
  [10446] = 10214,
  [10447] = 10342,
  [10448] = 10189,
  [10449] = 10335,
  [10450] = 10450,
  [10451] = 10369,
  [10452] = 10452,
  [10453] = 10186,
  [10454] = 10379,
  [10455] = 10455,
  [10456] = 10302,
  [10457] = 10342,
  [10458] = 10217,
  [10459] = 10216,
  [10460] = 10189,
  [10461] = 10335,
  [10462] = 10379,
  [10463] = 10208,
  [10464] = 10379,
  [10465] = 10302,
  [10466] = 10212,
  [10467] = 10342,
  [10468] = 10209,
  [10469] = 10189,
  [10470] = 10203,
  [10471] = 10335,
  [10472] = 10369,
  [10473] = 10379,
  [10474] = 10302,
  [10475] = 10190,
  [10476] = 10342,
  [10477] = 10189,
  [10478] = 10335,
  [10479] = 10369,
  [10480] = 10198,
  [10481] = 10379,
  [10482] = 10302,
  [10483] = 10250,
  [10484] = 10196,
  [10485] = 10342,
  [10486] = 10189,
  [10487] = 10335,
  [10488] = 10195,
  [10489] = 10369,
  [10490] = 10379,
  [10491] = 10302,
  [10492] = 10342,
  [10493] = 10189,
  [10494] = 10335,
  [10495] = 10191,
  [10496] = 10192,
  [10497] = 10193,
  [10498] = 10194,
  [10499] = 10369,
  [10500] = 10500,
  [10501] = 10379,
  [10502] = 10302,
  [10503] = 10342,
  [10504] = 10189,
  [10505] = 10201,
  [10506] = 10335,
  [10507] = 10507,
  [10508] = 10204,
  [10509] = 10369,
  [10510] = 10379,
  [10511] = 10302,
  [10512] = 10210,
  [10513] = 10342,
  [10514] = 10213,
  [10515] = 10214,
  [10516] = 10189,
  [10517] = 10335,
  [10518] = 10369,
  [10519] = 10519,
  [10520] = 10379,
  [10521] = 10203,
  [10522] = 10186,
  [10523] = 10302,
  [10524] = 10342,
  [10525] = 10189,
  [10526] = 10335,
  [10527] = 10217,
  [10528] = 10216,
  [10529] = 10369,
  [10530] = 10379,
  [10531] = 10531,
  [10532] = 10208,
  [10533] = 10302,
  [10534] = 10342,
  [10535] = 10212,
  [10536] = 10189,
  [10537] = 10209,
  [10538] = 10335,
  [10539] = 10203,
  [10540] = 10369,
  [10541] = 10379,
  [10542] = 10302,
  [10543] = 10543,
  [10544] = 10190,
  [10545] = 10342,
  [10546] = 10189,
  [10547] = 10335,
  [10548] = 10369,
  [10549] = 10198,
  [10550] = 10379,
  [10551] = 10551,
  [10552] = 10250,
  [10553] = 10196,
  [10554] = 10250,
  [10555] = 10302,
  [10556] = 10342,
  [10557] = 10195,
  [10558] = 10189,
  [10559] = 10335,
  [10560] = 10369,
  [10561] = 10379,
  [10562] = 10302,
  [10563] = 10342,
  [10564] = 10191,
  [10565] = 10192,
  [10566] = 10193,
  [10567] = 10194,
  [10568] = 10189,
  [10569] = 10335,
  [10570] = 10369,
  [10571] = 10379,
  [10572] = 10572,
  [10573] = 10201,
  [10574] = 10302,
  [10575] = 10342,
  [10576] = 10204,
  [10577] = 10189,
  [10578] = 10335,
  [10579] = 10369,
  [10580] = 10210,
  [10581] = 10213,
  [10582] = 10214,
  [10583] = 10379,
  [10584] = 10302,
  [10585] = 10342,
  [10586] = 10189,
  [10587] = 10335,
  [10588] = 10369,
  [10589] = 10186,
  [10590] = 10379,
  [10591] = 10302,
  [10592] = 10342,
  [10593] = 10217,
  [10594] = 10189,
  [10595] = 10335,
  [10596] = 10208,
  [10597] = 10369,
  [10598] = 10379,
  [10599] = 10212,
  [10600] = 10302,
  [10601] = 10209,
  [10602] = 10342,
  [10603] = 10203,
  [10604] = 10189,
  [10605] = 10335,
  [10606] = 10606,
  [10607] = 10607,
  [10608] = 10190,
  [10609] = 10369,
  [10610] = 10610,
  [10611] = 10611,
  [10612] = 10302,
  [10613] = 10198,
  [10614] = 10342,
  [10615] = 10615,
  [10616] = 10250,
  [10617] = 10196,
  [10618] = 10189,
  [10619] = 10335,
  [10620] = 10195,
  [10621] = 10369,
  [10622] = 10379,
  [10623] = 10302,
  [10624] = 10191,
  [10625] = 10192,
  [10626] = 10193,
  [10627] = 10194,
  [10628] = 10342,
  [10629] = 10189,
  [10630] = 10335,
  [10631] = 10369,
  [10632] = 10201,
  [10633] = 10379,
  [10634] = 10634,
  [10635] = 10204,
  [10636] = 10636,
  [10637] = 10302,
  [10638] = 10342,
  [10639] = 10210,
  [10640] = 10213,
  [10641] = 10214,
  [10642] = 10189,
  [10643] = 10335,
  [10644] = 10369,
  [10645] = 10645,
  [10646] = 10646,
  [10647] = 10379,
  [10648] = 10186,
  [10649] = 10649,
  [10650] = 10302,
  [10651] = 10651,
  [10652] = 10217,
  [10653] = 10342,
  [10654] = 10189,
  [10655] = 10208,
  [10656] = 10335,
  [10657] = 10369,
  [10658] = 10212,
  [10659] = 10646,
  [10660] = 10209,
  [10661] = 10379,
  [10662] = 10203,
  [10663] = 10302,
  [10664] = 10651,
  [10665] = 10342,
  [10666] = 10189,
  [10667] = 10190,
  [10668] = 10335,
  [10669] = 10369,
  [10670] = 10646,
  [10671] = 10379,
  [10672] = 10198,
  [10673] = 10302,
  [10674] = 10250,
  [10675] = 10196,
  [10676] = 10651,
  [10677] = 10342,
  [10678] = 10195,
  [10679] = 10189,
  [10680] = 10335,
  [10681] = 10335,
  [10682] = 10191,
  [10683] = 10192,
  [10684] = 10193,
  [10685] = 10194,
  [10686] = 10369,
  [10687] = 10646,
  [10688] = 10379,
  [10689] = 10302,
  [10690] = 10201,
  [10691] = 10651,
  [10692] = 10342,
  [10693] = 10204,
  [10694] = 10189,
  [10695] = 10335,
  [10696] = 10369,
  [10697] = 10210,
  [10698] = 10213,
  [10699] = 10214,
  [10700] = 10646,
  [10701] = 10379,
  [10702] = 10302,
  [10703] = 10703,
  [10704] = 10651,
  [10705] = 10369,
  [10706] = 10186,
  [10707] = 10646,
  [10708] = 10708,
  [10709] = 10208,
  [10710] = 10342,
  [10711] = 10189,
  [10712] = 10212,
  [10713] = 10335,
  [10714] = 10209,
  [10715] = 10369,
  [10716] = 10716,
  [10717] = 10717,
  [10718] = 10190,
  [10719] = 10342,
  [10720] = 10720,
  [10721] = 10250,
  [10722] = 10379,
  [10723] = 10302,
  [10724] = 10651,
  [10725] = 10725,
  [10726] = 10191,
  [10727] = 10192,
  [10728] = 10193,
  [10729] = 10194,
  [10730] = 10610,
  [10731] = 10731,
  [10732] = 10708,
  [10733] = 10733,
  [10734] = 10201,
  [10735] = 10342,
  [10736] = 10189,
  [10737] = 10204,
  [10738] = 10335,
  [10739] = 10369,
  [10740] = 10646,
  [10741] = 10210,
  [10742] = 10213,
  [10743] = 10214,
  [10744] = 10379,
  [10745] = 10302,
  [10746] = 10651,
  [10747] = 10610,
  [10748] = 10708,
  [10749] = 10342,
  [10750] = 10186,
  [10751] = 10189,
  [10752] = 10209,
  [10753] = 10208,
  [10754] = 10335,
  [10755] = 10369,
  [10756] = 10212,
  [10757] = 10646,
  [10758] = 10209,
  [10759] = 10759,
  [10760] = 10760,
  [10761] = 10190,
  [10762] = 10379,
  [10763] = 10302,
  [10764] = 10250,
  [10765] = 10651,
  [10766] = 10646,
  [10767] = 10610,
  [10768] = 10191,
  [10769] = 10192,
  [10770] = 10193,
  [10771] = 10194,
  [10772] = 10708,
  [10773] = 10342,
  [10774] = 10189,
  [10775] = 10293,
  [10776] = 10201,
  [10777] = 10335,
  [10778] = 10778,
  [10779] = 10204,
  [10780] = 10369,
  [10781] = 10646,
  [10782] = 10778,
  [10783] = 10210,
  [10784] = 10213,
  [10785] = 10214,
  [10786] = 10379,
  [10787] = 10302,
  [10788] = 10651,
  [10789] = 10789,
  [10790] = 10610,
  [10791] = 10708,
  [10792] = 10186,
  [10793] = 10646,
  [10794] = 10212,
  [10795] = 10208,
  [10796] = 10189,
  [10797] = 10293,
  [10798] = 10212,
  [10799] = 10335,
  [10800] = 10209,
  [10801] = 10369,
  [10802] = 10646,
  [10803] = 10190,
  [10804] = 10778,
  [10805] = 10379,
  [10806] = 10250,
  [10807] = 10807,
  [10808] = 10302,
  [10809] = 10208,
  [10810] = 10191,
  [10811] = 10192,
  [10812] = 10193,
  [10813] = 10194,
  [10814] = 10651,
  [10815] = 10815,
  [10816] = 10610,
  [10817] = 10708,
  [10818] = 10201,
  [10819] = 10342,
  [10820] = 10189,
  [10821] = 10204,
  [10822] = 10822,
  [10823] = 10293,
  [10824] = 10335,
  [10825] = 10210,
  [10826] = 10213,
  [10827] = 10214,
  [10828] = 10369,
  [10829] = 10646,
  [10830] = 10778,
  [10831] = 10379,
  [10832] = 10302,
  [10833] = 10651,
  [10834] = 10186,
  [10835] = 10610,
  [10836] = 10708,
  [10837] = 10208,
  [10838] = 10342,
  [10839] = 10189,
  [10840] = 10212,
  [10841] = 10293,
  [10842] = 10209,
  [10843] = 10335,
  [10844] = 10369,
  [10845] = 10190,
  [10846] = 10302,
  [10847] = 10778,
  [10848] = 10379,
  [10849] = 10302,
  [10850] = 10191,
  [10851] = 10192,
  [10852] = 10193,
  [10853] = 10194,
  [10854] = 10651,
  [10855] = 10610,
  [10856] = 10708,
  [10857] = 10342,
  [10858] = 10201,
  [10859] = 10189,
  [10860] = 10293,
  [10861] = 10204,
  [10862] = 10335,
  [10863] = 10369,
  [10864] = 10646,
  [10865] = 10210,
  [10866] = 10213,
  [10867] = 10214,
  [10868] = 10778,
  [10869] = 10379,
  [10870] = 10185,
  [10871] = 10651,
  [10872] = 10610,
  [10873] = 10708,
  [10874] = 10186,
  [10875] = 10342,
  [10876] = 10189,
  [10877] = 10208,
  [10878] = 10293,
  [10879] = 10335,
  [10880] = 10212,
  [10881] = 10369,
  [10882] = 10209,
  [10883] = 10646,
  [10884] = 10778,
  [10885] = 10190,
  [10886] = 10379,
  [10887] = 10887,
  [10888] = 10302,
  [10889] = 10651,
  [10890] = 10191,
  [10891] = 10192,
  [10892] = 10193,
  [10893] = 10194,
  [10894] = 10610,
  [10895] = 10895,
  [10896] = 10708,
  [10897] = 10342,
  [10898] = 10201,
  [10899] = 10899,
  [10900] = 10189,
  [10901] = 10204,
  [10902] = 10293,
  [10903] = 10335,
  [10904] = 10369,
  [10905] = 10210,
  [10906] = 10213,
  [10907] = 10214,
  [10908] = 10646,
  [10909] = 10778,
  [10910] = 10910,
  [10911] = 10379,
  [10912] = 10912,
  [10913] = 10302,
  [10914] = 10186,
  [10915] = 10651,
  [10916] = 10610,
  [10917] = 10208,
  [10918] = 10708,
  [10919] = 10342,
  [10920] = 10212,
  [10921] = 10434,
  [10922] = 10209,
  [10923] = 10189,
  [10924] = 10259,
  [10925] = 10190,
  [10926] = 10265,
  [10927] = 10191,
  [10928] = 10192,
  [10929] = 10193,
  [10930] = 10293,
  [10931] = 10931,
  [10932] = 10196,
  [10933] = 10204,
  [10934] = 10313,
  [10935] = 10335,
  [10936] = 10369,
  [10937] = 10186,
  [10938] = 10938,
  [10939] = 10760,
  [10940] = 10212,
  [10941] = 10646,
  [10942] = 10778,
  [10943] = 10191,
  [10944] = 10192,
  [10945] = 10193,
  [10946] = 10789,
  [10947] = 10947,
  [10948] = 10815,
  [10949] = 10204,
  [10950] = 10822,
  [10951] = 10379,
  [10952] = 10186,
  [10953] = 10434,
  [10954] = 10954,
  [10955] = 10955,
  [10956] = 10191,
  [10957] = 10192,
  [10958] = 10193,
  [10959] = 10959,
  [10960] = 10302,
  [10961] = 10651,
  [10962] = 10204,
  [10963] = 10610,
  [10964] = 10708,
  [10965] = 10186,
  [10966] = 10966,
  [10967] = 10967,
  [10968] = 10968,
  [10969] = 10191,
  [10970] = 10192,
  [10971] = 10193,
  [10972] = 10342,
  [10973] = 10973,
  [10974] = 10974,
  [10975] = 10204,
  [10976] = 10189,
  [10977] = 10259,
  [10978] = 10186,
  [10979] = 10265,
  [10980] = 10293,
  [10981] = 10191,
  [10982] = 10192,
  [10983] = 10193,
  [10984] = 10313,
  [10985] = 10216,
  [10986] = 10986,
  [10987] = 10204,
  [10988] = 10335,
  [10989] = 10369,
  [10990] = 10186,
  [10991] = 10760,
  [10992] = 10646,
  [10993] = 10191,
  [10994] = 10192,
  [10995] = 10193,
  [10996] = 10778,
  [10997] = 10997,
  [10998] = 10789,
  [10999] = 10204,
  [11000] = 11000,
  [11001] = 10815,
  [11002] = 10186,
  [11003] = 10822,
  [11004] = 11004,
  [11005] = 10191,
  [11006] = 10192,
  [11007] = 10193,
  [11008] = 10379,
  [11009] = 10217,
  [11010] = 10185,
  [11011] = 10204,
  [11012] = 10954,
  [11013] = 10955,
  [11014] = 10186,
  [11015] = 10959,
  [11016] = 10302,
  [11017] = 10191,
  [11018] = 10192,
  [11019] = 10651,
  [11020] = 10610,
  [11021] = 10708,
  [11022] = 10204,
  [11023] = 11023,
  [11024] = 10186,
  [11025] = 10966,
  [11026] = 10191,
  [11027] = 10192,
  [11028] = 10967,
  [11029] = 10968,
  [11030] = 10342,
  [11031] = 10204,
  [11032] = 10185,
  [11033] = 10186,
  [11034] = 10434,
  [11035] = 10191,
  [11036] = 10192,
  [11037] = 10189,
  [11038] = 10259,
  [11039] = 10265,
  [11040] = 10293,
  [11041] = 10186,
  [11042] = 10313,
  [11043] = 10191,
  [11044] = 10192,
  [11045] = 10335,
  [11046] = 10369,
  [11047] = 10760,
  [11048] = 10646,
  [11049] = 10186,
  [11050] = 10778,
  [11051] = 10789,
  [11052] = 10815,
  [11053] = 10822,
  [11054] = 11054,
  [11055] = 10186,
  [11056] = 10379,
  [11057] = 10185,
  [11058] = 10954,
  [11059] = 10955,
  [11060] = 10186,
  [11061] = 11061,
  [11062] = 10959,
  [11063] = 11063,
  [11064] = 10186,
  [11065] = 11065,
  [11066] = 10302,
  [11067] = 10651,
  [11068] = 10186,
  [11069] = 10610,
  [11070] = 10708,
  [11071] = 10966,
  [11072] = 10186,
  [11073] = 10967,
  [11074] = 10968,
  [11075] = 10188,
  [11076] = 10186,
  [11077] = 10342,
  [11078] = 10200,
  [11079] = 10434,
  [11080] = 10186,
  [11081] = 10189,
  [11082] = 10259,
  [11083] = 10265,
  [11084] = 10186,
  [11085] = 10293,
  [11086] = 10955,
  [11087] = 10313,
  [11088] = 10186,
  [11089] = 10335,
  [11090] = 10369,
  [11091] = 10760,
  [11092] = 10186,
  [11093] = 10646,
  [11094] = 10778,
  [11095] = 10789,
  [11096] = 10186,
  [11097] = 11097,
  [11098] = 10815,
  [11099] = 10822,
  [11100] = 10186,
  [11101] = 10379,
  [11102] = 10959,
  [11103] = 10954,
  [11104] = 10186,
  [11105] = 10955,
  [11106] = 11106,
  [11107] = 10342,
  [11108] = 10186,
  [11109] = 10302,
  [11110] = 11110,
  [11111] = 10651,
  [11112] = 10186,
  [11113] = 10610,
  [11114] = 11114,
  [11115] = 10708,
  [11116] = 10186,
  [11117] = 10966,
  [11118] = 10967,
  [11119] = 10968,
  [11120] = 10186,
  [11121] = 10342,
  [11122] = 10434,
  [11123] = 10189,
  [11124] = 10186,
  [11125] = 10259,
  [11126] = 10265,
  [11127] = 10293,
  [11128] = 10186,
  [11129] = 10195,
  [11130] = 10313,
  [11131] = 11131,
  [11132] = 10186,
  [11133] = 10335,
  [11134] = 10369,
  [11135] = 10760,
  [11136] = 10186,
  [11137] = 10646,
  [11138] = 10778,
  [11139] = 10789,
  [11140] = 10186,
  [11141] = 11141,
  [11142] = 11142,
  [11143] = 10815,
  [11144] = 10186,
  [11145] = 10822,
  [11146] = 10379,
  [11147] = 10185,
  [11148] = 10186,
  [11149] = 10954,
  [11150] = 10379,
  [11151] = 10955,
  [11152] = 10186,
  [11153] = 11153,
  [11154] = 10959,
  [11155] = 11155,
  [11156] = 10250,
  [11157] = 11157,
  [11158] = 10302,
  [11159] = 10651,
  [11160] = 10186,
  [11161] = 10610,
  [11162] = 10708,
  [11163] = 10966,
  [11164] = 10186,
  [11165] = 10967,
  [11166] = 10968,
  [11167] = 11167,
  [11168] = 10186,
  [11169] = 10197,
  [11170] = 10434,
  [11171] = 10189,
  [11172] = 10186,
  [11173] = 10259,
  [11174] = 10265,
  [11175] = 10293,
  [11176] = 10186,
  [11177] = 10313,
  [11178] = 11178,
  [11179] = 10335,
  [11180] = 10369,
  [11181] = 11181,
  [11182] = 10760,
  [11183] = 10646,
  [11184] = 10778,
  [11185] = 10789,
  [11186] = 11186,
  [11187] = 10815,
  [11188] = 10822,
  [11189] = 11189,
  [11190] = 10186,
  [11191] = 11191,
  [11192] = 10379,
  [11193] = 11193,
  [11194] = 10185,
  [11195] = 10954,
  [11196] = 10955,
  [11197] = 11197,
  [11198] = 10959,
  [11199] = 10302,
  [11200] = 11200,
  [11201] = 11201,
  [11202] = 10185,
  [11203] = 3879,
  [11204] = 3778,
  [11205] = 10651,
  [11206] = 10610,
  [11207] = 11207,
  [11208] = 11208,
  [11209] = 10708,
  [11210] = 11210,
  [11211] = 11211,
  [11212] = 10954,
  [11213] = 11213,
  [11214] = 10966,
  [11215] = 10219,
  [11216] = 10967,
  [11217] = 11217,
  [11218] = 11218,
  [11219] = 10968,
  [11220] = 10342,
  [11221] = 11221,
  [11222] = 11222,
  [11223] = 11223,
  [11224] = 11224,
  [11225] = 11225,
  [11226] = 11226,
  [11227] = 11227,
  [11228] = 11201,
  [11229] = 11197,
  [11230] = 11114,
  [11231] = 11106,
  [11232] = 11178,
  [11233] = 11233,
  [11234] = 11234,
  [11235] = 10997,
  [11236] = 11236,
  [11237] = 11227,
  [11238] = 11226,
  [11239] = 11225,
  [11240] = 10931,
  [11241] = 11223,
  [11242] = 11181,
  [11243] = 10759,
  [11244] = 10342,
  [11245] = 10733,
  [11246] = 10731,
  [11247] = 10912,
  [11248] = 10634,
  [11249] = 10434,
  [11250] = 10189,
  [11251] = 10543,
  [11252] = 10259,
  [11253] = 10265,
  [11254] = 10519,
  [11255] = 10507,
  [11256] = 10293,
  [11257] = 10452,
  [11258] = 10323,
  [11259] = 10313,
  [11260] = 11260,
  [11261] = 10264,
  [11262] = 10249,
  [11263] = 10500,
  [11264] = 10335,
  [11265] = 10274,
  [11266] = 10369,
  [11267] = 10760,
  [11268] = 10649,
  [11269] = 10910,
  [11270] = 11000,
  [11271] = 11061,
  [11272] = 11097,
  [11273] = 10646,
  [11274] = 11167,
  [11275] = 10959,
  [11276] = 10778,
  [11277] = 10789,
  [11278] = 10815,
  [11279] = 10822,
  [11280] = 11236,
  [11281] = 11234,
  [11282] = 10379,
  [11283] = 10185,
  [11284] = 10954,
  [11285] = 10955,
  [11286] = 10959,
  [11287] = 11207,
  [11288] = 11208,
  [11289] = 10302,
  [11290] = 11210,
  [11291] = 11211,
  [11292] = 10651,
  [11293] = 10610,
  [11294] = 10708,
  [11295] = 10966,
  [11296] = 10967,
  [11297] = 11217,
  [11298] = 11218,
  [11299] = 10968,
  [11300] = 10822,
  [11301] = 11234,
  [11302] = 11222,
  [11303] = 11236,
  [11304] = 11224,
  [11305] = 11227,
  [11306] = 10214,
  [11307] = 11226,
  [11308] = 11201,
  [11309] = 11197,
  [11310] = 11114,
  [11311] = 11106,
  [11312] = 11225,
  [11313] = 11223,
  [11314] = 10997,
  [11315] = 10213,
  [11316] = 11181,
  [11317] = 10931,
  [11318] = 11178,
  [11319] = 10759,
  [11320] = 10938,
  [11321] = 10733,
  [11322] = 10731,
  [11323] = 10912,
  [11324] = 10634,
  [11325] = 10434,
  [11326] = 10189,
  [11327] = 10543,
  [11328] = 10259,
  [11329] = 10265,
  [11330] = 10519,
  [11331] = 10507,
  [11332] = 10293,
  [11333] = 10452,
  [11334] = 10323,
  [11335] = 11335,
  [11336] = 10264,
  [11337] = 10249,
  [11338] = 10313,
  [11339] = 10500,
  [11340] = 10274,
  [11341] = 10335,
  [11342] = 10369,
  [11343] = 10649,
  [11344] = 10910,
  [11345] = 11000,
  [11346] = 11061,
  [11347] = 11097,
  [11348] = 10760,
  [11349] = 11167,
  [11350] = 10646,
  [11351] = 10778,
  [11352] = 10789,
  [11353] = 11207,
  [11354] = 11208,
  [11355] = 10815,
  [11356] = 11210,
  [11357] = 11211,
  [11358] = 10708,
  [11359] = 10379,
  [11360] = 10185,
  [11361] = 10954,
  [11362] = 10955,
  [11363] = 11217,
  [11364] = 11218,
  [11365] = 10959,
  [11366] = 11366,
  [11367] = 11367,
  [11368] = 11222,
  [11369] = 10302,
  [11370] = 11224,
  [11371] = 10651,
  [11372] = 11372,
  [11373] = 10610,
  [11374] = 11201,
  [11375] = 11197,
  [11376] = 11114,
  [11377] = 11106,
  [11378] = 10895,
  [11379] = 10966,
  [11380] = 10997,
  [11381] = 10967,
  [11382] = 10968,
  [11383] = 10342,
  [11384] = 10759,
  [11385] = 1394,
  [11386] = 10733,
  [11387] = 10731,
  [11388] = 11234,
  [11389] = 11236,
  [11390] = 11227,
  [11391] = 10543,
  [11392] = 11226,
  [11393] = 11225,
  [11394] = 10519,
  [11395] = 10507,
  [11396] = 11223,
  [11397] = 10452,
  [11398] = 10323,
  [11399] = 11399,
  [11400] = 10264,
  [11401] = 10249,
  [11402] = 11181,
  [11403] = 11178,
  [11404] = 10274,
  [11405] = 11157,
  [11406] = 11054,
  [11407] = 10649,
  [11408] = 10910,
  [11409] = 11000,
  [11410] = 11061,
  [11411] = 11097,
  [11412] = 10973,
  [11413] = 11167,
  [11414] = 10938,
  [11415] = 10912,
  [11416] = 10434,
  [11417] = 11207,
  [11418] = 11208,
  [11419] = 11211,
  [11420] = 11366,
  [11421] = 10317,
  [11422] = 11367,
  [11423] = 10189,
  [11424] = 11217,
  [11425] = 10259,
  [11426] = 10265,
  [11427] = 11222,
  [11428] = 10293,
  [11429] = 11224,
  [11430] = 10313,
  [11431] = 10405,
  [11432] = 10500,
  [11433] = 10335,
  [11434] = 10369,
  [11435] = 10997,
  [11436] = 10760,
  [11437] = 10646,
  [11438] = 10778,
  [11439] = 10789,
  [11440] = 10543,
  [11441] = 10815,
  [11442] = 10822,
  [11443] = 10519,
  [11444] = 10938,
  [11445] = 10379,
  [11446] = 10954,
  [11447] = 10955,
  [11448] = 10274,
  [11449] = 10959,
  [11450] = 11372,
  [11451] = 10910,
  [11452] = 11000,
  [11453] = 11061,
  [11454] = 11366,
  [11455] = 11167,
  [11456] = 11367,
  [11457] = 10302,
  [11458] = 10651,
  [11459] = 11207,
  [11460] = 11208,
  [11461] = 11211,
  [11462] = 10610,
  [11463] = 10708,
  [11464] = 10966,
  [11465] = 10967,
  [11466] = 11217,
  [11467] = 10968,
  [11468] = 10342,
  [11469] = 11222,
  [11470] = 11234,
  [11471] = 11224,
  [11472] = 11236,
  [11473] = 11227,
  [11474] = 11226,
  [11475] = 11225,
  [11476] = 11223,
  [11477] = 10997,
  [11478] = 11478,
  [11479] = 11181,
  [11480] = 11178,
  [11481] = 11157,
  [11482] = 10543,
  [11483] = 11054,
  [11484] = 10973,
  [11485] = 10519,
  [11486] = 10507,
  [11487] = 10912,
  [11488] = 11224,
  [11489] = 10342,
  [11490] = 10274,
  [11491] = 10434,
  [11492] = 10317,
  [11493] = 10910,
  [11494] = 11000,
  [11495] = 11061,
  [11496] = 10189,
  [11497] = 11167,
  [11498] = 10259,
  [11499] = 10265,
  [11500] = 10293,
  [11501] = 11207,
  [11502] = 11208,
  [11503] = 11211,
  [11504] = 10313,
  [11505] = 10405,
  [11506] = 10500,
  [11507] = 10335,
  [11508] = 11217,
  [11509] = 10369,
  [11510] = 10760,
  [11511] = 11222,
  [11512] = 10646,
  [11513] = 11224,
  [11514] = 10778,
  [11515] = 11222,
  [11516] = 10789,
  [11517] = 10815,
  [11518] = 10822,
  [11519] = 10997,
  [11520] = 10895,
  [11521] = 10211,
  [11522] = 10379,
  [11523] = 10185,
  [11524] = 10543,
  [11525] = 10954,
  [11526] = 10955,
  [11527] = 10519,
  [11528] = 10507,
  [11529] = 10959,
  [11530] = 11372,
  [11531] = 11366,
  [11532] = 10274,
  [11533] = 11367,
  [11534] = 10302,
  [11535] = 10910,
  [11536] = 11000,
  [11537] = 11061,
  [11538] = 10651,
  [11539] = 11167,
  [11540] = 10610,
  [11541] = 10708,
  [11542] = 10966,
  [11543] = 11207,
  [11544] = 11208,
  [11545] = 11211,
  [11546] = 11546,
  [11547] = 10967,
  [11548] = 10968,
  [11549] = 10210,
  [11550] = 11217,
  [11551] = 10895,
  [11552] = 1438,
  [11553] = 11222,
  [11554] = 11234,
  [11555] = 11224,
  [11556] = 11236,
  [11557] = 11227,
  [11558] = 11226,
  [11559] = 11225,
  [11560] = 11223,
  [11561] = 10997,
  [11562] = 11181,
  [11563] = 11178,
  [11564] = 11157,
  [11565] = 11054,
  [11566] = 10543,
  [11567] = 10973,
  [11568] = 10938,
  [11569] = 10519,
  [11570] = 10912,
  [11571] = 10434,
  [11572] = 10317,
  [11573] = 10274,
  [11574] = 10189,
  [11575] = 10259,
  [11576] = 10910,
  [11577] = 11000,
  [11578] = 11061,
  [11579] = 10265,
  [11580] = 11167,
  [11581] = 10293,
  [11582] = 10313,
  [11583] = 10405,
  [11584] = 11207,
  [11585] = 11208,
  [11586] = 11211,
  [11587] = 10500,
  [11588] = 10335,
  [11589] = 10369,
  [11590] = 10760,
  [11591] = 11217,
  [11592] = 10646,
  [11593] = 10778,
  [11594] = 10789,
  [11595] = 10815,
  [11596] = 10822,
  [11597] = 10302,
  [11598] = 10379,
  [11599] = 10185,
  [11600] = 10997,
  [11601] = 10954,
  [11602] = 11218,
  [11603] = 10955,
  [11604] = 10959,
  [11605] = 10543,
  [11606] = 11606,
  [11607] = 11372,
  [11608] = 10519,
  [11609] = 10507,
  [11610] = 11366,
  [11611] = 11611,
  [11612] = 11367,
  [11613] = 10274,
  [11614] = 10259,
  [11615] = 10651,
  [11616] = 10910,
  [11617] = 11000,
  [11618] = 10610,
  [11619] = 10708,
  [11620] = 10966,
  [11621] = 11207,
  [11622] = 11208,
  [11623] = 11211,
  [11624] = 3776,
  [11625] = 1366,
  [11626] = 3829,
  [11627] = 10967,
  [11628] = 11217,
  [11629] = 10968,
  [11630] = 1390,
  [11631] = 10342,
  [11632] = 11234,
  [11633] = 11236,
  [11634] = 11227,
  [11635] = 11226,
  [11636] = 11225,
  [11637] = 10997,
  [11638] = 11223,
  [11639] = 11181,
  [11640] = 11178,
  [11641] = 11157,
  [11642] = 10543,
  [11643] = 1253,
  [11644] = 11054,
  [11645] = 10519,
  [11646] = 10973,
  [11647] = 10938,
  [11648] = 10912,
  [11649] = 10274,
  [11650] = 10434,
  [11651] = 10317,
  [11652] = 10910,
  [11653] = 11000,
  [11654] = 10189,
  [11655] = 11655,
  [11656] = 10265,
  [11657] = 11207,
  [11658] = 11208,
  [11659] = 11211,
  [11660] = 10293,
  [11661] = 10313,
  [11662] = 10405,
  [11663] = 10500,
  [11664] = 11217,
  [11665] = 10335,
  [11666] = 10369,
  [11667] = 11217,
  [11668] = 10760,
  [11669] = 10646,
  [11670] = 10778,
  [11671] = 10789,
  [11672] = 10815,
  [11673] = 10822,
  [11674] = 10895,
  [11675] = 10379,
  [11676] = 10185,
  [11677] = 11207,
  [11678] = 11208,
  [11679] = 11211,
  [11680] = 10954,
  [11681] = 10955,
  [11682] = 10959,
  [11683] = 11372,
  [11684] = 11217,
  [11685] = 11366,
  [11686] = 11367,
  [11687] = 10206,
  [11688] = 10302,
  [11689] = 10651,
  [11690] = 10302,
  [11691] = 10651,
  [11692] = 10610,
  [11693] = 10610,
  [11694] = 10708,
  [11695] = 10966,
  [11696] = 11207,
  [11697] = 11208,
  [11698] = 11211,
  [11699] = 10708,
  [11700] = 10967,
  [11701] = 10968,
  [11702] = 10342,
  [11703] = 11217,
  [11704] = 10317,
  [11705] = 11234,
  [11706] = 11236,
  [11707] = 11260,
  [11708] = 11227,
  [11709] = 11226,
  [11710] = 11225,
  [11711] = 11223,
  [11712] = 11213,
  [11713] = 11181,
  [11714] = 11178,
  [11715] = 11207,
  [11716] = 11208,
  [11717] = 11211,
  [11718] = 11157,
  [11719] = 10205,
  [11720] = 10204,
  [11721] = 11141,
  [11722] = 11217,
  [11723] = 11054,
  [11724] = 10974,
  [11725] = 11004,
  [11726] = 10973,
  [11727] = 10201,
  [11728] = 10938,
  [11729] = 10912,
  [11730] = 11730,
  [11731] = 10899,
  [11732] = 10887,
  [11733] = 11207,
  [11734] = 11208,
  [11735] = 11211,
  [11736] = 10807,
  [11737] = 10434,
  [11738] = 10966,
  [11739] = 10967,
  [11740] = 11217,
  [11741] = 10267,
  [11742] = 10815,
  [11743] = 10968,
  [11744] = 11211,
  [11745] = 10338,
  [11746] = 10242,
  [11747] = 10189,
  [11748] = 10233,
  [11749] = 10259,
  [11750] = 10265,
  [11751] = 11207,
  [11752] = 11208,
  [11753] = 11211,
  [11754] = 10285,
  [11755] = 10293,
  [11756] = 10313,
  [11757] = 10405,
  [11758] = 11217,
  [11759] = 10500,
  [11760] = 10607,
  [11761] = 10611,
  [11762] = 10615,
  [11763] = 10335,
  [11764] = 10369,
  [11765] = 10720,
  [11766] = 11208,
  [11767] = 10760,
  [11768] = 10646,
  [11769] = 10778,
  [11770] = 10789,
  [11771] = 11208,
  [11772] = 11655,
  [11773] = 10822,
  [11774] = 11774,
  [11775] = 11208,
  [11776] = 10895,
  [11777] = 10379,
  [11778] = 10185,
  [11779] = 11208,
  [11780] = 10954,
  [11781] = 10955,
  [11782] = 11208,
  [11783] = 10959,
  [11784] = 11372,
  [11785] = 11208,
  [11786] = 11366,
  [11787] = 11367,
  [11788] = 11208,
  [11789] = 10302,
  [11790] = 10651,
  [11791] = 11208,
  [11792] = 10610,
  [11793] = 10708,
  [11794] = 11208,
  [11795] = 10966,
  [11796] = 10967,
  [11797] = 10968,
  [11798] = 10342,
  [11799] = 10895,
  [11800] = 11234,
  [11801] = 11236,
  [11802] = 11260,
  [11803] = 11227,
  [11804] = 11226,
  [11805] = 11225,
  [11806] = 11223,
  [11807] = 11213,
  [11808] = 11181,
  [11809] = 11178,
  [11810] = 11157,
  [11811] = 11141,
  [11812] = 11054,
  [11813] = 10974,
  [11814] = 11004,
  [11815] = 10973,
  [11816] = 10938,
  [11817] = 10912,
  [11818] = 10899,
  [11819] = 10887,
  [11820] = 10807,
  [11821] = 10434,
  [11822] = 10267,
  [11823] = 10317,
  [11824] = 10338,
  [11825] = 10242,
  [11826] = 10189,
  [11827] = 10233,
  [11828] = 10259,
  [11829] = 10265,
  [11830] = 10285,
  [11831] = 10293,
  [11832] = 10313,
  [11833] = 11833,
  [11834] = 11834,
  [11835] = 10405,
  [11836] = 11836,
  [11837] = 11837,
  [11838] = 10500,
  [11839] = 10607,
  [11840] = 10611,
  [11841] = 10615,
  [11842] = 10335,
  [11843] = 11478,
  [11844] = 10369,
  [11845] = 11200,
  [11846] = 10720,
  [11847] = 11110,
  [11848] = 10760,
  [11849] = 10646,
  [11850] = 10778,
  [11851] = 10789,
  [11852] = 10725,
  [11853] = 10815,
  [11854] = 10822,
  [11855] = 10302,
  [11856] = 11186,
  [11857] = 10379,
  [11858] = 10185,
  [11859] = 10954,
  [11860] = 10955,
  [11861] = 10959,
  [11862] = 10931,
  [11863] = 11833,
  [11864] = 11834,
  [11865] = 11372,
  [11866] = 11836,
  [11867] = 11837,
  [11868] = 11366,
  [11869] = 11367,
  [11870] = 11655,
  [11871] = 11478,
  [11872] = 11200,
  [11873] = 10651,
  [11874] = 11110,
  [11875] = 10610,
  [11876] = 10708,
  [11877] = 10725,
  [11878] = 10966,
  [11879] = 10967,
  [11880] = 10968,
  [11881] = 11186,
  [11882] = 10931,
  [11883] = 11833,
  [11884] = 11834,
  [11885] = 10342,
  [11886] = 11836,
  [11887] = 11837,
  [11888] = 10267,
  [11889] = 1394,
  [11890] = 1438,
  [11891] = 11478,
  [11892] = 11200,
  [11893] = 1253,
  [11894] = 11110,
  [11895] = 11234,
  [11896] = 11236,
  [11897] = 10725,
  [11898] = 11260,
  [11899] = 11227,
  [11900] = 11226,
  [11901] = 11186,
  [11902] = 10931,
  [11903] = 11833,
  [11904] = 11834,
  [11905] = 11225,
  [11906] = 11836,
  [11907] = 11837,
  [11908] = 11223,
  [11909] = 11909,
  [11910] = 11213,
  [11911] = 11186,
  [11912] = 10931,
  [11913] = 11833,
  [11914] = 11834,
  [11915] = 11181,
  [11916] = 11836,
  [11917] = 11837,
  [11918] = 11178,
  [11919] = 10342,
  [11920] = 11157,
  [11921] = 11186,
  [11922] = 10931,
  [11923] = 11833,
  [11924] = 11834,
  [11925] = 11141,
  [11926] = 11836,
  [11927] = 11837,
  [11928] = 11054,
  [11929] = 11837,
  [11930] = 10974,
  [11931] = 11186,
  [11932] = 10931,
  [11933] = 11833,
  [11934] = 11834,
  [11935] = 11004,
  [11936] = 11836,
  [11937] = 11837,
  [11938] = 10973,
  [11939] = 10938,
  [11940] = 10912,
  [11941] = 11186,
  [11942] = 10931,
  [11943] = 11833,
  [11944] = 11834,
  [11945] = 11945,
  [11946] = 11836,
  [11947] = 11837,
  [11948] = 10899,
  [11949] = 10887,
  [11950] = 11833,
  [11951] = 11834,
  [11952] = 10807,
  [11953] = 11836,
  [11954] = 11837,
  [11955] = 10434,
  [11956] = 10500,
  [11957] = 11833,
  [11958] = 11834,
  [11959] = 10317,
  [11960] = 11836,
  [11961] = 11837,
  [11962] = 10338,
  [11963] = 10242,
  [11964] = 11833,
  [11965] = 11834,
  [11966] = 11655,
  [11967] = 11836,
  [11968] = 11837,
  [11969] = 10189,
  [11970] = 3847,
  [11971] = 11833,
  [11972] = 11834,
  [11973] = 11973,
  [11974] = 11836,
  [11975] = 11837,
  [11976] = 10233,
  [11977] = 10259,
  [11978] = 11833,
  [11979] = 11834,
  [11980] = 11980,
  [11981] = 11836,
  [11982] = 11837,
  [11983] = 10265,
  [11984] = 11984,
  [11985] = 11833,
  [11986] = 11834,
  [11987] = 10285,
  [11988] = 11836,
  [11989] = 11837,
  [11990] = 10293,
  [11991] = 10313,
  [11992] = 11833,
  [11993] = 11834,
  [11994] = 10194,
  [11995] = 11836,
  [11996] = 11837,
  [11997] = 10405,
  [11998] = 11372,
  [11999] = 11837,
  [12000] = 10551,
  [12001] = 11837,
  [12002] = 10607,
  [12003] = 11837,
  [12004] = 10611,
  [12005] = 11837,
  [12006] = 11837,
  [12007] = 11837,
  [12008] = 11837,
  [12009] = 11837,
  [12010] = 11837,
  [12011] = 11837,
  [12012] = 11837,
  [12013] = 11837,
  [12014] = 11837,
  [12015] = 11837,
  [12016] = 11837,
  [12017] = 11837,
  [12018] = 11837,
  [12019] = 11837,
  [12020] = 11837,
  [12021] = 11837,
  [12022] = 11837,
  [12023] = 11837,
  [12024] = 11837,
  [12025] = 11837,
  [12026] = 11837,
  [12027] = 11837,
  [12028] = 11837,
  [12029] = 11837,
  [12030] = 11837,
  [12031] = 11837,
  [12032] = 11837,
  [12033] = 11837,
  [12034] = 11837,
  [12035] = 11837,
  [12036] = 11837,
  [12037] = 11837,
  [12038] = 11837,
  [12039] = 11837,
  [12040] = 11837,
  [12041] = 11837,
  [12042] = 11837,
  [12043] = 11837,
  [12044] = 10615,
  [12045] = 10335,
  [12046] = 10369,
  [12047] = 10720,
  [12048] = 10760,
  [12049] = 10646,
  [12050] = 10778,
  [12051] = 10789,
  [12052] = 12052,
  [12053] = 10815,
  [12054] = 10822,
  [12055] = 12055,
  [12056] = 11210,
  [12057] = 10645,
  [12058] = 10241,
  [12059] = 11063,
  [12060] = 11153,
  [12061] = 10895,
  [12062] = 10379,
  [12063] = 10645,
  [12064] = 10241,
  [12065] = 11063,
  [12066] = 11153,
  [12067] = 10193,
  [12068] = 10192,
  [12069] = 10645,
  [12070] = 10241,
  [12071] = 11063,
  [12072] = 11153,
  [12073] = 10191,
  [12074] = 10185,
  [12075] = 11063,
  [12076] = 11153,
  [12077] = 10954,
  [12078] = 10955,
  [12079] = 11063,
  [12080] = 11153,
  [12081] = 10959,
  [12082] = 11836,
  [12083] = 11063,
  [12084] = 11153,
  [12085] = 4124,
  [12086] = 11208,
  [12087] = 11063,
  [12088] = 11153,
  [12089] = 11207,
  [12090] = 11366,
  [12091] = 11367,
  [12092] = 10302,
  [12093] = 11834,
  [12094] = 11833,
  [12095] = 10651,
  [12096] = 10610,
  [12097] = 10708,
  [12098] = 10966,
  [12099] = 10967,
  [12100] = 10968,
  [12101] = 10342,
  [12102] = 11655,
  [12103] = 4176,
  [12104] = 4173,
  [12105] = 12105,
  [12106] = 4168,
  [12107] = 12107,
  [12108] = 1253,
  [12109] = 4151,
  [12110] = 4149,
  [12111] = 10211,
  [12112] = 4166,
  [12113] = 4163,
  [12114] = 4153,
  [12115] = 4142,
  [12116] = 3804,
  [12117] = 3786,
  [12118] = 3823,
  [12119] = 12119,
  [12120] = 12120,
  [12121] = 12121,
  [12122] = 4142,
  [12123] = 12123,
  [12124] = 12124,
  [12125] = 12125,
};

static TSCharacterRange sym__non_escape_char_character_set_1[] = {
  {0, '!'}, {'#', '&'}, {'(', '`'}, {'c', 'e'}, {'g', 'm'}, {'o', 'q'}, {'s', 's'}, {'u', 'u'},
  {'w', 0x10ffff},
};

static TSCharacterRange aux_sym_infix_op_token2_character_set_1[] = {
  {'%', '\''}, {'*', '+'}, {'-', '-'}, {'/', '/'}, {'<', '<'}, {'>', '>'}, {'@', '@'}, {'^', '^'},
  {'|', '|'},
};

static TSCharacterRange sym_identifier_character_set_1[] = {
  {'A', 'Z'}, {'_', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1},
  {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x370, 0x374}, {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f},
  {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481}, {0x48a, 0x52f}, {0x531, 0x556},
  {0x559, 0x559}, {0x560, 0x588}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x620, 0x64a}, {0x66e, 0x66f}, {0x671, 0x6d3}, {0x6d5, 0x6d5},
  {0x6e5, 0x6e6}, {0x6ee, 0x6ef}, {0x6fa, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x710}, {0x712, 0x72f}, {0x74d, 0x7a5}, {0x7b1, 0x7b1},
  {0x7ca, 0x7ea}, {0x7f4, 0x7f5}, {0x7fa, 0x7fa}, {0x800, 0x815}, {0x81a, 0x81a}, {0x824, 0x824}, {0x828, 0x828}, {0x840, 0x858},
  {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x8a0, 0x8c9}, {0x904, 0x939}, {0x93d, 0x93d}, {0x950, 0x950}, {0x958, 0x961},
  {0x971, 0x980}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9}, {0x9bd, 0x9bd},
  {0x9ce, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e1}, {0x9f0, 0x9f1}, {0x9fc, 0x9fc}, {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28},
  {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa59, 0xa5c}, {0xa5e, 0xa5e}, {0xa72, 0xa74}, {0xa85, 0xa8d},
  {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabd, 0xabd}, {0xad0, 0xad0}, {0xae0, 0xae1},
  {0xaf9, 0xaf9}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3d, 0xb3d},
  {0xb5c, 0xb5d}, {0xb5f, 0xb61}, {0xb71, 0xb71}, {0xb83, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a},
  {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbd0, 0xbd0}, {0xc05, 0xc0c}, {0xc0e, 0xc10},
  {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3d, 0xc3d}, {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc61}, {0xc80, 0xc80}, {0xc85, 0xc8c},
  {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbd, 0xcbd}, {0xcdd, 0xcde}, {0xce0, 0xce1}, {0xcf1, 0xcf2},
  {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3a}, {0xd3d, 0xd3d}, {0xd4e, 0xd4e}, {0xd54, 0xd56}, {0xd5f, 0xd61}, {0xd7a, 0xd7f},
  {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xe01, 0xe30}, {0xe32, 0xe32}, {0xe40, 0xe46},
  {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xeb0}, {0xeb2, 0xeb2}, {0xebd, 0xebd},
  {0xec0, 0xec4}, {0xec6, 0xec6}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf40, 0xf47}, {0xf49, 0xf6c}, {0xf88, 0xf8c}, {0x1000, 0x102a},
  {0x103f, 0x103f}, {0x1050, 0x1055}, {0x105a, 0x105d}, {0x1061, 0x1061}, {0x1065, 0x1066}, {0x106e, 0x1070}, {0x1075, 0x1081}, {0x108e, 0x108e},
  {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256}, {0x1258, 0x1258},
  {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0}, {0x12c2, 0x12c5},
  {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x1380, 0x138f}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c},
  {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1711}, {0x171f, 0x1731}, {0x1740, 0x1751}, {0x1760, 0x176c},
  {0x176e, 0x1770}, {0x1780, 0x17b3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dc}, {0x1820, 0x1878}, {0x1880, 0x18a8}, {0x18aa, 0x18aa}, {0x18b0, 0x18f5},
  {0x1900, 0x191e}, {0x1950, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x1a00, 0x1a16}, {0x1a20, 0x1a54}, {0x1aa7, 0x1aa7},
  {0x1b05, 0x1b33}, {0x1b45, 0x1b4c}, {0x1b83, 0x1ba0}, {0x1bae, 0x1baf}, {0x1bba, 0x1be5}, {0x1c00, 0x1c23}, {0x1c4d, 0x1c4f}, {0x1c5a, 0x1c7d},
  {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1ce9, 0x1cec}, {0x1cee, 0x1cf3}, {0x1cf5, 0x1cf6}, {0x1cfa, 0x1cfa}, {0x1d00, 0x1dbf},
  {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d},
  {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb},
  {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x2102, 0x2102}, {0x2107, 0x2107},
  {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f},
  {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cee}, {0x2cf2, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27},
  {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d80, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe},
  {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x3005, 0x3007}, {0x3021, 0x3029}, {0x3031, 0x3035}, {0x3038, 0x303c},
  {0x3041, 0x3096}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff},
  {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa61f}, {0xa62a, 0xa62b}, {0xa640, 0xa66e}, {0xa67f, 0xa69d},
  {0xa6a0, 0xa6ef}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa801},
  {0xa803, 0xa805}, {0xa807, 0xa80a}, {0xa80c, 0xa822}, {0xa840, 0xa873}, {0xa882, 0xa8b3}, {0xa8f2, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa8fe},
  {0xa90a, 0xa925}, {0xa930, 0xa946}, {0xa960, 0xa97c}, {0xa984, 0xa9b2}, {0xa9cf, 0xa9cf}, {0xa9e0, 0xa9e4}, {0xa9e6, 0xa9ef}, {0xa9fa, 0xa9fe},
  {0xaa00, 0xaa28}, {0xaa40, 0xaa42}, {0xaa44, 0xaa4b}, {0xaa60, 0xaa76}, {0xaa7a, 0xaa7a}, {0xaa7e, 0xaaaf}, {0xaab1, 0xaab1}, {0xaab5, 0xaab6},
  {0xaab9, 0xaabd}, {0xaac0, 0xaac0}, {0xaac2, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaea}, {0xaaf2, 0xaaf4}, {0xab01, 0xab06}, {0xab09, 0xab0e},
  {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabe2}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6},
  {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb1d}, {0xfb1f, 0xfb28}, {0xfb2a, 0xfb36},
  {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f},
  {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d},
  {0xfe7f, 0xfefc}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0xff66, 0xff9d}, {0xffa0, 0xffbe}, {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7},
  {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa},
  {0x10140, 0x10174}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x10375}, {0x10380, 0x1039d}, {0x103a0, 0x103c3},
  {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a},
  {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736},
  {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835},
  {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915},
  {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a00}, {0x10a10, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a60, 0x10a7c},
  {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae4}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91}, {0x10c00, 0x10c48},
  {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d23}, {0x10e80, 0x10ea9}, {0x10eb0, 0x10eb1}, {0x10f00, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f45},
  {0x10f70, 0x10f81}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11003, 0x11037}, {0x11071, 0x11072}, {0x11075, 0x11075}, {0x11083, 0x110af}, {0x110d0, 0x110e8},
  {0x11103, 0x11126}, {0x11144, 0x11144}, {0x11147, 0x11147}, {0x11150, 0x11172}, {0x11176, 0x11176}, {0x11183, 0x111b2}, {0x111c1, 0x111c4}, {0x111da, 0x111da},
  {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x1122b}, {0x1123f, 0x11240}, {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d},
  {0x1129f, 0x112a8}, {0x112b0, 0x112de}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339},
  {0x1133d, 0x1133d}, {0x11350, 0x11350}, {0x1135d, 0x11361}, {0x11400, 0x11434}, {0x11447, 0x1144a}, {0x1145f, 0x11461}, {0x11480, 0x114af}, {0x114c4, 0x114c5},
  {0x114c7, 0x114c7}, {0x11580, 0x115ae}, {0x115d8, 0x115db}, {0x11600, 0x1162f}, {0x11644, 0x11644}, {0x11680, 0x116aa}, {0x116b8, 0x116b8}, {0x11700, 0x1171a},
  {0x11740, 0x11746}, {0x11800, 0x1182b}, {0x118a0, 0x118df}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x1192f},
  {0x1193f, 0x1193f}, {0x11941, 0x11941}, {0x119a0, 0x119a7}, {0x119aa, 0x119d0}, {0x119e1, 0x119e1}, {0x119e3, 0x119e3}, {0x11a00, 0x11a00}, {0x11a0b, 0x11a32},
  {0x11a3a, 0x11a3a}, {0x11a50, 0x11a50}, {0x11a5c, 0x11a89}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c2e}, {0x11c40, 0x11c40},
  {0x11c72, 0x11c8f}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d30}, {0x11d46, 0x11d46}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d89},
  {0x11d98, 0x11d98}, {0x11ee0, 0x11ef2}, {0x11f02, 0x11f02}, {0x11f04, 0x11f10}, {0x11f12, 0x11f33}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e},
  {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342f}, {0x13441, 0x13446}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a70, 0x16abe},
  {0x16ad0, 0x16aed}, {0x16b00, 0x16b2f}, {0x16b40, 0x16b43}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f50, 0x16f50},
  {0x16f93, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe3}, {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb},
  {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132}, {0x1b150, 0x1b152}, {0x1b155, 0x1b155}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a},
  {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6},
  {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c},
  {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da},
  {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2},
  {0x1d7c4, 0x1d7cb}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a}, {0x1e030, 0x1e06d}, {0x1e100, 0x1e12c}, {0x1e137, 0x1e13d}, {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ad},
  {0x1e2c0, 0x1e2eb}, {0x1e4d0, 0x1e4eb}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4}, {0x1e900, 0x1e943},
  {0x1e94b, 0x1e94b}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37},
  {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52},
  {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64},
  {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3},
  {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x20000, 0x2a6df}, {0x2a700, 0x2b739}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2ebf0, 0x2ee5d},
  {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0x31350, 0x323af},
};

static TSCharacterRange sym_identifier_character_set_2[] = {
  {'\'', '\''}, {'0', '9'}, {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xb7, 0xb7},
  {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee},
  {0x300, 0x374}, {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5},
  {0x3f7, 0x481}, {0x483, 0x487}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x591, 0x5bd}, {0x5bf, 0x5bf},
  {0x5c1, 0x5c2}, {0x5c4, 0x5c5}, {0x5c7, 0x5c7}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x610, 0x61a}, {0x620, 0x669}, {0x66e, 0x6d3},
  {0x6d5, 0x6dc}, {0x6df, 0x6e8}, {0x6ea, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x74a}, {0x74d, 0x7b1}, {0x7c0, 0x7f5}, {0x7fa, 0x7fa},
  {0x7fd, 0x7fd}, {0x800, 0x82d}, {0x840, 0x85b}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x898, 0x8e1}, {0x8e3, 0x963},
  {0x966, 0x96f}, {0x971, 0x983}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9},
  {0x9bc, 0x9c4}, {0x9c7, 0x9c8}, {0x9cb, 0x9ce}, {0x9d7, 0x9d7}, {0x9dc, 0x9dd}, {0x9df, 0x9e3}, {0x9e6, 0x9f1}, {0x9fc, 0x9fc},
  {0x9fe, 0x9fe}, {0xa01, 0xa03}, {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36},
  {0xa38, 0xa39}, {0xa3c, 0xa3c}, {0xa3e, 0xa42}, {0xa47, 0xa48}, {0xa4b, 0xa4d}, {0xa51, 0xa51}, {0xa59, 0xa5c}, {0xa5e, 0xa5e},
  {0xa66, 0xa75}, {0xa81, 0xa83}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9},
  {0xabc, 0xac5}, {0xac7, 0xac9}, {0xacb, 0xacd}, {0xad0, 0xad0}, {0xae0, 0xae3}, {0xae6, 0xaef}, {0xaf9, 0xaff}, {0xb01, 0xb03},
  {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3c, 0xb44}, {0xb47, 0xb48},
  {0xb4b, 0xb4d}, {0xb55, 0xb57}, {0xb5c, 0xb5d}, {0xb5f, 0xb63}, {0xb66, 0xb6f}, {0xb71, 0xb71}, {0xb82, 0xb83}, {0xb85, 0xb8a},
  {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9},
  {0xbbe, 0xbc2}, {0xbc6, 0xbc8}, {0xbca, 0xbcd}, {0xbd0, 0xbd0}, {0xbd7, 0xbd7}, {0xbe6, 0xbef}, {0xc00, 0xc0c}, {0xc0e, 0xc10},
  {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3c, 0xc44}, {0xc46, 0xc48}, {0xc4a, 0xc4d}, {0xc55, 0xc56}, {0xc58, 0xc5a}, {0xc5d, 0xc5d},
  {0xc60, 0xc63}, {0xc66, 0xc6f}, {0xc80, 0xc83}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9},
  {0xcbc, 0xcc4}, {0xcc6, 0xcc8}, {0xcca, 0xccd}, {0xcd5, 0xcd6}, {0xcdd, 0xcde}, {0xce0, 0xce3}, {0xce6, 0xcef}, {0xcf1, 0xcf3},
  {0xd00, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd44}, {0xd46, 0xd48}, {0xd4a, 0xd4e}, {0xd54, 0xd57}, {0xd5f, 0xd63}, {0xd66, 0xd6f},
  {0xd7a, 0xd7f}, {0xd81, 0xd83}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xdca, 0xdca},
  {0xdcf, 0xdd4}, {0xdd6, 0xdd6}, {0xdd8, 0xddf}, {0xde6, 0xdef}, {0xdf2, 0xdf3}, {0xe01, 0xe3a}, {0xe40, 0xe4e}, {0xe50, 0xe59},
  {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6},
  {0xec8, 0xece}, {0xed0, 0xed9}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf18, 0xf19}, {0xf20, 0xf29}, {0xf35, 0xf35}, {0xf37, 0xf37},
  {0xf39, 0xf39}, {0xf3e, 0xf47}, {0xf49, 0xf6c}, {0xf71, 0xf84}, {0xf86, 0xf97}, {0xf99, 0xfbc}, {0xfc6, 0xfc6}, {0x1000, 0x1049},
  {0x1050, 0x109d}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256},
  {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0},
  {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x135d, 0x135f}, {0x1369, 0x1371}, {0x1380, 0x138f},
  {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1715},
  {0x171f, 0x1734}, {0x1740, 0x1753}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1772, 0x1773}, {0x1780, 0x17d3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dd},
  {0x17e0, 0x17e9}, {0x180b, 0x180d}, {0x180f, 0x1819}, {0x1820, 0x1878}, {0x1880, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1920, 0x192b},
  {0x1930, 0x193b}, {0x1946, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x19d0, 0x19da}, {0x1a00, 0x1a1b}, {0x1a20, 0x1a5e},
  {0x1a60, 0x1a7c}, {0x1a7f, 0x1a89}, {0x1a90, 0x1a99}, {0x1aa7, 0x1aa7}, {0x1ab0, 0x1abd}, {0x1abf, 0x1ace}, {0x1b00, 0x1b4c}, {0x1b50, 0x1b59},
  {0x1b6b, 0x1b73}, {0x1b80, 0x1bf3}, {0x1c00, 0x1c37}, {0x1c40, 0x1c49}, {0x1c4d, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf},
  {0x1cd0, 0x1cd2}, {0x1cd4, 0x1cfa}, {0x1d00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59},
  {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc},
  {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x200c, 0x200d}, {0x203f, 0x2040}, {0x2054, 0x2054},
  {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x20d0, 0x20dc}, {0x20e1, 0x20e1}, {0x20e5, 0x20f0}, {0x2102, 0x2102}, {0x2107, 0x2107},
  {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f},
  {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d},
  {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d7f, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6},
  {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x2de0, 0x2dff}, {0x3005, 0x3007}, {0x3021, 0x302f}, {0x3031, 0x3035}, {0x3038, 0x303c},
  {0x3041, 0x3096}, {0x3099, 0x309a}, {0x309d, 0x309f}, {0x30a1, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff},
  {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa62b}, {0xa640, 0xa66f}, {0xa674, 0xa67d}, {0xa67f, 0xa6f1},
  {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa827}, {0xa82c, 0xa82c},
  {0xa840, 0xa873}, {0xa880, 0xa8c5}, {0xa8d0, 0xa8d9}, {0xa8e0, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa92d}, {0xa930, 0xa953}, {0xa960, 0xa97c},
  {0xa980, 0xa9c0}, {0xa9cf, 0xa9d9}, {0xa9e0, 0xa9fe}, {0xaa00, 0xaa36}, {0xaa40, 0xaa4d}, {0xaa50, 0xaa59}, {0xaa60, 0xaa76}, {0xaa7a, 0xaac2},
  {0xaadb, 0xaadd}, {0xaae0, 0xaaef}, {0xaaf2, 0xaaf6}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e},
  {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabea}, {0xabec, 0xabed}, {0xabf0, 0xabf9}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb},
  {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e},
  {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9},
  {0xfe00, 0xfe0f}, {0xfe20, 0xfe2f}, {0xfe33, 0xfe34}, {0xfe4d, 0xfe4f}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79},
  {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff10, 0xff19}, {0xff21, 0xff3a}, {0xff3f, 0xff3f}, {0xff41, 0xff5a}, {0xff65, 0xffbe},
  {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d},
  {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x101fd, 0x101fd}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x102e0, 0x102e0},
  {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x1037a}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d},
  {0x104a0, 0x104a9}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592},
  {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767},
  {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c},
  {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7},
  {0x109be, 0x109bf}, {0x10a00, 0x10a03}, {0x10a05, 0x10a06}, {0x10a0c, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a38, 0x10a3a}, {0x10a3f, 0x10a3f},
  {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae6}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91},
  {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d27}, {0x10d30, 0x10d39}, {0x10e80, 0x10ea9}, {0x10eab, 0x10eac}, {0x10eb0, 0x10eb1},
  {0x10efd, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f50}, {0x10f70, 0x10f85}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11000, 0x11046}, {0x11066, 0x11075},
  {0x1107f, 0x110ba}, {0x110c2, 0x110c2}, {0x110d0, 0x110e8}, {0x110f0, 0x110f9}, {0x11100, 0x11134}, {0x11136, 0x1113f}, {0x11144, 0x11147}, {0x11150, 0x11173},
  {0x11176, 0x11176}, {0x11180, 0x111c4}, {0x111c9, 0x111cc}, {0x111ce, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x11237}, {0x1123e, 0x11241},
  {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112ea}, {0x112f0, 0x112f9}, {0x11300, 0x11303},
  {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133b, 0x11344}, {0x11347, 0x11348},
  {0x1134b, 0x1134d}, {0x11350, 0x11350}, {0x11357, 0x11357}, {0x1135d, 0x11363}, {0x11366, 0x1136c}, {0x11370, 0x11374}, {0x11400, 0x1144a}, {0x11450, 0x11459},
  {0x1145e, 0x11461}, {0x11480, 0x114c5}, {0x114c7, 0x114c7}, {0x114d0, 0x114d9}, {0x11580, 0x115b5}, {0x115b8, 0x115c0}, {0x115d8, 0x115dd}, {0x11600, 0x11640},
  {0x11644, 0x11644}, {0x11650, 0x11659}, {0x11680, 0x116b8}, {0x116c0, 0x116c9}, {0x11700, 0x1171a}, {0x1171d, 0x1172b}, {0x11730, 0x11739}, {0x11740, 0x11746},
  {0x11800, 0x1183a}, {0x118a0, 0x118e9}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x11935}, {0x11937, 0x11938},
  {0x1193b, 0x11943}, {0x11950, 0x11959}, {0x119a0, 0x119a7}, {0x119aa, 0x119d7}, {0x119da, 0x119e1}, {0x119e3, 0x119e4}, {0x11a00, 0x11a3e}, {0x11a47, 0x11a47},
  {0x11a50, 0x11a99}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c36}, {0x11c38, 0x11c40}, {0x11c50, 0x11c59}, {0x11c72, 0x11c8f},
  {0x11c92, 0x11ca7}, {0x11ca9, 0x11cb6}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d36}, {0x11d3a, 0x11d3a}, {0x11d3c, 0x11d3d}, {0x11d3f, 0x11d47},
  {0x11d50, 0x11d59}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d8e}, {0x11d90, 0x11d91}, {0x11d93, 0x11d98}, {0x11da0, 0x11da9}, {0x11ee0, 0x11ef6},
  {0x11f00, 0x11f10}, {0x11f12, 0x11f3a}, {0x11f3e, 0x11f42}, {0x11f50, 0x11f59}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543},
  {0x12f90, 0x12ff0}, {0x13000, 0x1342f}, {0x13440, 0x13455}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a60, 0x16a69}, {0x16a70, 0x16abe},
  {0x16ac0, 0x16ac9}, {0x16ad0, 0x16aed}, {0x16af0, 0x16af4}, {0x16b00, 0x16b36}, {0x16b40, 0x16b43}, {0x16b50, 0x16b59}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f},
  {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f4f, 0x16f87}, {0x16f8f, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe4}, {0x16ff0, 0x16ff1}, {0x17000, 0x187f7},
  {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132}, {0x1b150, 0x1b152},
  {0x1b155, 0x1b155}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1bc9d, 0x1bc9e},
  {0x1cf00, 0x1cf2d}, {0x1cf30, 0x1cf46}, {0x1d165, 0x1d169}, {0x1d16d, 0x1d172}, {0x1d17b, 0x1d182}, {0x1d185, 0x1d18b}, {0x1d1aa, 0x1d1ad}, {0x1d242, 0x1d244},
  {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb},
  {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544},
  {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734},
  {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1d7ce, 0x1d7ff}, {0x1da00, 0x1da36},
  {0x1da3b, 0x1da6c}, {0x1da75, 0x1da75}, {0x1da84, 0x1da84}, {0x1da9b, 0x1da9f}, {0x1daa1, 0x1daaf}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a}, {0x1e000, 0x1e006},
  {0x1e008, 0x1e018}, {0x1e01b, 0x1e021}, {0x1e023, 0x1e024}, {0x1e026, 0x1e02a}, {0x1e030, 0x1e06d}, {0x1e08f, 0x1e08f}, {0x1e100, 0x1e12c}, {0x1e130, 0x1e13d},
  {0x1e140, 0x1e149}, {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ae}, {0x1e2c0, 0x1e2f9}, {0x1e4d0, 0x1e4f9}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee},
  {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4}, {0x1e8d0, 0x1e8d6}, {0x1e900, 0x1e94b}, {0x1e950, 0x1e959}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22},
  {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47},
  {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b},
  {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c},
  {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x1fbf0, 0x1fbf9}, {0x20000, 0x2a6df},
  {0x2a700, 0x2b739}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2ebf0, 0x2ee5d}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0x31350, 0x323af},
  {0xe0100, 0xe01ef},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 494,
        '"', 470,
        '#', 445,
        '$', 514,
        '%', 488,
        '&', 388,
        '\'', 448,
        '(', 434,
        ')', 376,
        '*', 438,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 559,
        '/', 205,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 449,
        '>', 427,
        '?', 379,
        '@', 132,
        'L', 548,
        'M', 557,
        'U', 576,
        '[', 390,
        '\\', 2,
        ']', 394,
        '^', 447,
        '`', 216,
        'a', 594,
        'd', 592,
        'f', 552,
        'i', 589,
        'l', 536,
        'm', 556,
        'n', 544,
        'r', 584,
        's', 531,
        'u', 539,
        'w', 585,
        'y', 526,
        '{', 459,
        '|', 385,
        '}', 399,
        '~', 492,
        'E', 564,
        'e', 564,
        'G', 554,
        'I', 554,
        'N', 554,
        'Q', 554,
        'R', 554,
        'Z', 554,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          (' ' <= lookahead && lookahead <= ';') ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(330);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(605);
      if (lookahead == '#') ADVANCE(610);
      if (lookahead == '(') ADVANCE(201);
      if (lookahead == '/') ADVANCE(205);
      if (lookahead == '\\') SKIP(45);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(1);
      END_STATE();
    case 2:
      if (lookahead == '\r') SKIP(234);
      if (lookahead == 'n') SKIP(60);
      if (lookahead == 'u') ADVANCE(318);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(306);
      END_STATE();
    case 3:
      ADVANCE_MAP(
        '\r', 451,
        'n', 450,
        'u', 451,
        '"', 450,
        '\'', 450,
        'a', 450,
        'b', 450,
        'f', 450,
        'r', 450,
        't', 450,
        'v', 450,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(451);
      if (lookahead != 0) ADVANCE(451);
      END_STATE();
    case 4:
      if (lookahead == '\r') SKIP(269);
      if (lookahead == 'n') SKIP(121);
      END_STATE();
    case 5:
      if (lookahead == '\r') SKIP(270);
      if (lookahead == 'n') SKIP(128);
      END_STATE();
    case 6:
      if (lookahead == '\r') SKIP(277);
      if (lookahead == 'n') SKIP(124);
      END_STATE();
    case 7:
      if (lookahead == '\r') SKIP(271);
      if (lookahead == 'n') SKIP(120);
      END_STATE();
    case 8:
      if (lookahead == '\r') SKIP(236);
      if (lookahead == 'n') SKIP(110);
      END_STATE();
    case 9:
      if (lookahead == '\r') SKIP(276);
      if (lookahead == 'n') SKIP(112);
      END_STATE();
    case 10:
      if (lookahead == '\r') SKIP(272);
      if (lookahead == 'n') SKIP(106);
      END_STATE();
    case 11:
      if (lookahead == '\r') SKIP(273);
      if (lookahead == 'n') SKIP(109);
      END_STATE();
    case 12:
      if (lookahead == '\r') SKIP(274);
      if (lookahead == 'n') SKIP(105);
      END_STATE();
    case 13:
      if (lookahead == '\r') SKIP(278);
      if (lookahead == 'n') SKIP(108);
      END_STATE();
    case 14:
      if (lookahead == '\r') SKIP(282);
      if (lookahead == 'n') SKIP(107);
      END_STATE();
    case 15:
      if (lookahead == '\r') SKIP(237);
      if (lookahead == 'n') SKIP(165);
      END_STATE();
    case 16:
      if (lookahead == '\r') SKIP(238);
      if (lookahead == 'n') SKIP(145);
      END_STATE();
    case 17:
      if (lookahead == '\r') SKIP(280);
      if (lookahead == 'n') SKIP(113);
      END_STATE();
    case 18:
      if (lookahead == '\r') SKIP(239);
      if (lookahead == 'n') SKIP(153);
      END_STATE();
    case 19:
      if (lookahead == '\r') SKIP(240);
      if (lookahead == 'n') SKIP(159);
      END_STATE();
    case 20:
      if (lookahead == '\r') SKIP(241);
      if (lookahead == 'n') SKIP(142);
      END_STATE();
    case 21:
      if (lookahead == '\r') SKIP(242);
      if (lookahead == 'n') SKIP(173);
      END_STATE();
    case 22:
      if (lookahead == '\r') SKIP(243);
      if (lookahead == 'n') SKIP(180);
      END_STATE();
    case 23:
      if (lookahead == '\r') SKIP(244);
      if (lookahead == 'n') SKIP(150);
      END_STATE();
    case 24:
      if (lookahead == '\r') SKIP(245);
      if (lookahead == 'n') SKIP(158);
      END_STATE();
    case 25:
      if (lookahead == '\r') SKIP(246);
      if (lookahead == 'n') SKIP(164);
      END_STATE();
    case 26:
      if (lookahead == '\r') SKIP(247);
      if (lookahead == 'n') SKIP(143);
      END_STATE();
    case 27:
      if (lookahead == '\r') SKIP(248);
      if (lookahead == 'n') SKIP(144);
      END_STATE();
    case 28:
      if (lookahead == '\r') SKIP(249);
      if (lookahead == 'n') SKIP(151);
      END_STATE();
    case 29:
      if (lookahead == '\r') SKIP(250);
      if (lookahead == 'n') SKIP(152);
      END_STATE();
    case 30:
      if (lookahead == '\r') SKIP(251);
      if (lookahead == 'n') SKIP(133);
      END_STATE();
    case 31:
      if (lookahead == '\r') SKIP(252);
      if (lookahead == 'n') SKIP(192);
      END_STATE();
    case 32:
      if (lookahead == '\r') SKIP(253);
      if (lookahead == 'n') SKIP(168);
      END_STATE();
    case 33:
      if (lookahead == '\r') SKIP(254);
      if (lookahead == 'n') SKIP(169);
      END_STATE();
    case 34:
      if (lookahead == '\r') SKIP(255);
      if (lookahead == 'n') SKIP(185);
      END_STATE();
    case 35:
      if (lookahead == '\r') SKIP(258);
      if (lookahead == 'n') SKIP(188);
      END_STATE();
    case 36:
      if (lookahead == '\r') SKIP(259);
      if (lookahead == 'n') SKIP(193);
      END_STATE();
    case 37:
      if (lookahead == '\r') SKIP(260);
      if (lookahead == 'n') SKIP(172);
      END_STATE();
    case 38:
      if (lookahead == '\r') SKIP(261);
      if (lookahead == 'n') SKIP(190);
      END_STATE();
    case 39:
      if (lookahead == '\r') SKIP(262);
      if (lookahead == 'n') SKIP(182);
      END_STATE();
    case 40:
      if (lookahead == '\r') SKIP(263);
      if (lookahead == 'n') SKIP(183);
      END_STATE();
    case 41:
      if (lookahead == '\r') SKIP(264);
      if (lookahead == 'n') SKIP(181);
      END_STATE();
    case 42:
      if (lookahead == '\r') SKIP(265);
      if (lookahead == 'n') SKIP(191);
      END_STATE();
    case 43:
      if (lookahead == '\r') SKIP(266);
      if (lookahead == 'n') SKIP(186);
      END_STATE();
    case 44:
      if (lookahead == '\r') SKIP(267);
      if (lookahead == 'n') SKIP(134);
      if (lookahead == 'u') ADVANCE(318);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(306);
      END_STATE();
    case 45:
      if (lookahead == '\r') SKIP(268);
      if (lookahead == 'n') SKIP(1);
      END_STATE();
    case 46:
      if (lookahead == '\r') SKIP(275);
      if (lookahead == 'n') SKIP(114);
      END_STATE();
    case 47:
      if (lookahead == '\r') SKIP(281);
      if (lookahead == 'n') SKIP(125);
      END_STATE();
    case 48:
      if (lookahead == '\r') SKIP(279);
      if (lookahead == 'n') SKIP(115);
      END_STATE();
    case 49:
      if (lookahead == '\r') SKIP(283);
      if (lookahead == 'n') SKIP(127);
      END_STATE();
    case 50:
      if (lookahead == '\r') SKIP(284);
      if (lookahead == 'n') SKIP(116);
      END_STATE();
    case 51:
      if (lookahead == '\r') SKIP(285);
      if (lookahead == 'n') SKIP(118);
      END_STATE();
    case 52:
      if (lookahead == '\r') SKIP(286);
      if (lookahead == 'n') SKIP(122);
      END_STATE();
    case 53:
      if (lookahead == '\r') SKIP(287);
      if (lookahead == 'n') SKIP(126);
      END_STATE();
    case 54:
      if (lookahead == '\r') SKIP(288);
      if (lookahead == 'n') SKIP(111);
      END_STATE();
    case 55:
      if (lookahead == '\r') SKIP(289);
      if (lookahead == 'n') SKIP(129);
      END_STATE();
    case 56:
      if (lookahead == '\r') SKIP(290);
      if (lookahead == 'n') SKIP(123);
      END_STATE();
    case 57:
      if (lookahead == '\r') SKIP(291);
      if (lookahead == 'n') SKIP(117);
      END_STATE();
    case 58:
      if (lookahead == '\r') SKIP(292);
      if (lookahead == 'n') SKIP(119);
      END_STATE();
    case 59:
      if (lookahead == ' ') ADVANCE(198);
      if (lookahead == ')') ADVANCE(477);
      if (('\t' <= lookahead && lookahead <= '\r')) ADVANCE(199);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(200);
      END_STATE();
    case 60:
      ADVANCE_MAP(
        '!', 494,
        '"', 461,
        '#', 445,
        '$', 514,
        '%', 488,
        '&', 388,
        '\'', 448,
        '(', 373,
        ')', 376,
        '*', 437,
        '+', 478,
        ',', 377,
        '-', 480,
        '.', 409,
        '/', 205,
        '0', 516,
        ':', 363,
        '<', 441,
        '=', 449,
        '>', 427,
        '?', 379,
        '@', 132,
        '[', 390,
        '\\', 2,
        ']', 394,
        '^', 447,
        '`', 216,
        'a', 594,
        'd', 592,
        'i', 589,
        'l', 580,
        'm', 577,
        'r', 584,
        'u', 595,
        'w', 585,
        'y', 587,
        '{', 398,
        '|', 385,
        '}', 399,
        '~', 492,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          (' ' <= lookahead && lookahead <= ';') ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(60);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 61:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '*', 439,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '>', 428,
        '?', 379,
        '@', 499,
        '[', 392,
      );
      if (lookahead == '\\') SKIP(12);
      if (lookahead == '^') ADVANCE(508);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(105);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 62:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '*', 439,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 499,
        '[', 392,
      );
      if (lookahead == '\\') SKIP(10);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(106);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 63:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '*', 439,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 497,
        '[', 392,
      );
      if (lookahead == '\\') SKIP(14);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(107);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 64:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '*', 439,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 498,
        '[', 392,
      );
      if (lookahead == '\\') SKIP(13);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(108);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 65:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '*', 439,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 410,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 499,
        '[', 392,
      );
      if (lookahead == '\\') SKIP(11);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(109);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 66:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 559,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 499,
        'L', 548,
        'M', 557,
        'U', 576,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(8);
      if (lookahead == ']') ADVANCE(394);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(536);
      if (lookahead == 'm') ADVANCE(556);
      if (lookahead == 'n') ADVANCE(544);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 's') ADVANCE(531);
      if (lookahead == 'u') ADVANCE(539);
      if (lookahead == 'y') ADVANCE(526);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(564);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(554);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(110);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 67:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 409,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 499,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(53);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(126);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 68:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 561,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '>', 428,
        '?', 379,
        '@', 499,
        'L', 548,
        'M', 557,
        'U', 576,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(9);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(536);
      if (lookahead == 'm') ADVANCE(556);
      if (lookahead == 'n') ADVANCE(544);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 's') ADVANCE(531);
      if (lookahead == 'u') ADVANCE(539);
      if (lookahead == 'y') ADVANCE(526);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(508);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(564);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(554);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(112);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 69:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 561,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 499,
        'L', 548,
        'M', 557,
        'U', 576,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(46);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(536);
      if (lookahead == 'm') ADVANCE(556);
      if (lookahead == 'n') ADVANCE(544);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 's') ADVANCE(531);
      if (lookahead == 'u') ADVANCE(539);
      if (lookahead == 'y') ADVANCE(526);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(564);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(554);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(114);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 70:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 561,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 499,
        'L', 548,
        'M', 557,
        'U', 576,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(49);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(536);
      if (lookahead == 'm') ADVANCE(556);
      if (lookahead == 'n') ADVANCE(544);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 's') ADVANCE(531);
      if (lookahead == 'u') ADVANCE(539);
      if (lookahead == 'y') ADVANCE(526);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(564);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(554);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(127);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 71:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 561,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 497,
        'L', 548,
        'M', 557,
        'U', 576,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(50);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(536);
      if (lookahead == 'm') ADVANCE(556);
      if (lookahead == 'n') ADVANCE(544);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 's') ADVANCE(531);
      if (lookahead == 'u') ADVANCE(539);
      if (lookahead == 'y') ADVANCE(526);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(564);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(554);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(116);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 72:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 561,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 498,
        'L', 548,
        'M', 557,
        'U', 576,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(51);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(536);
      if (lookahead == 'm') ADVANCE(556);
      if (lookahead == 'n') ADVANCE(544);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 's') ADVANCE(531);
      if (lookahead == 'u') ADVANCE(539);
      if (lookahead == 'y') ADVANCE(526);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(564);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(554);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(118);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 73:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 449,
        '?', 379,
        '@', 499,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(54);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(111);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 74:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '>', 428,
        '?', 379,
        '@', 499,
        'L', 548,
        'U', 576,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(9);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(536);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'n') ADVANCE(544);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 's') ADVANCE(531);
      if (lookahead == 'u') ADVANCE(539);
      if (lookahead == 'y') ADVANCE(526);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(112);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 75:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '>', 428,
        '?', 379,
        '@', 499,
        'M', 557,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(9);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'f') ADVANCE(552);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(556);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(508);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(564);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(112);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 76:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '>', 428,
        '?', 379,
        '@', 499,
        'M', 557,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(9);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'f') ADVANCE(552);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(556);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(112);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 77:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '>', 428,
        '?', 379,
        '@', 499,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(17);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(386);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(113);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 78:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 499,
        'L', 548,
        'U', 576,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(46);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(536);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'n') ADVANCE(544);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 's') ADVANCE(531);
      if (lookahead == 'u') ADVANCE(539);
      if (lookahead == 'y') ADVANCE(526);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(114);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 79:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 499,
        'M', 557,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(46);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'f') ADVANCE(552);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(556);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(564);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(114);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 80:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 499,
        'M', 557,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(46);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'f') ADVANCE(552);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(556);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(114);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 81:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 499,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(48);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(386);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(115);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 82:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 497,
        'L', 548,
        'U', 576,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(50);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(536);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'n') ADVANCE(544);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 's') ADVANCE(531);
      if (lookahead == 'u') ADVANCE(539);
      if (lookahead == 'y') ADVANCE(526);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(116);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 83:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 497,
        'M', 557,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(50);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'f') ADVANCE(552);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(556);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(564);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(116);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 84:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 497,
        'M', 557,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(50);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'f') ADVANCE(552);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(556);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(116);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 85:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 497,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(57);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(386);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(117);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 86:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 498,
        'L', 548,
        'U', 576,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(51);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(536);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'n') ADVANCE(544);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 's') ADVANCE(531);
      if (lookahead == 'u') ADVANCE(539);
      if (lookahead == 'y') ADVANCE(526);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(118);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 87:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 498,
        'M', 557,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(51);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'f') ADVANCE(552);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(556);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(564);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(118);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 88:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 498,
        'M', 557,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(51);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'f') ADVANCE(552);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(556);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(118);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 89:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 498,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(58);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(386);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(119);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 90:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 560,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 499,
        'L', 548,
        'M', 557,
        'U', 576,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(5);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(536);
      if (lookahead == 'm') ADVANCE(556);
      if (lookahead == 'n') ADVANCE(544);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 's') ADVANCE(531);
      if (lookahead == 'u') ADVANCE(539);
      if (lookahead == 'y') ADVANCE(526);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(564);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(554);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(128);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 91:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 560,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 499,
        'L', 548,
        'M', 557,
        'U', 576,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(52);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(536);
      if (lookahead == 'm') ADVANCE(556);
      if (lookahead == 'n') ADVANCE(544);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 's') ADVANCE(531);
      if (lookahead == 'u') ADVANCE(539);
      if (lookahead == 'y') ADVANCE(526);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(564);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(554);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(122);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 92:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 410,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '>', 428,
        '?', 379,
        '@', 499,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(7);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(120);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 93:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 410,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 499,
        'L', 548,
        'U', 576,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(5);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(536);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'n') ADVANCE(544);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 's') ADVANCE(531);
      if (lookahead == 'u') ADVANCE(539);
      if (lookahead == 'y') ADVANCE(526);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(128);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 94:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 410,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 499,
        'L', 548,
        'U', 576,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(52);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(536);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'n') ADVANCE(544);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 's') ADVANCE(531);
      if (lookahead == 'u') ADVANCE(539);
      if (lookahead == 'y') ADVANCE(526);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(122);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 95:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 410,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 499,
        'M', 557,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(5);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'f') ADVANCE(552);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(556);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(564);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(128);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 96:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 410,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 499,
        'M', 557,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(5);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'f') ADVANCE(552);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(556);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(128);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 97:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 410,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 499,
        'M', 557,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(52);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'f') ADVANCE(552);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(556);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(564);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(122);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 98:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 410,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 499,
        'M', 557,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(52);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'f') ADVANCE(552);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(556);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(122);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 99:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 410,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 499,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(4);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(121);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 100:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 410,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 499,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(5);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(128);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 101:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 410,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 499,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(55);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(386);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(129);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 102:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 410,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 499,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(56);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(386);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(123);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 103:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 410,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 497,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(6);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(124);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 104:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 410,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '?', 379,
        '@', 498,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(47);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(125);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 105:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 373,
        '*', 439,
        '+', 479,
        ',', 377,
        '-', 482,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 442,
        '=', 358,
        '>', 428,
        '?', 379,
        '@', 499,
        '[', 392,
      );
      if (lookahead == '\\') SKIP(12);
      if (lookahead == '^') ADVANCE(508);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(105);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 106:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 373,
        '*', 439,
        '+', 479,
        ',', 377,
        '-', 482,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 442,
        '=', 358,
        '?', 379,
        '@', 499,
        '[', 392,
      );
      if (lookahead == '\\') SKIP(10);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(106);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 107:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 373,
        '*', 439,
        '+', 479,
        ',', 377,
        '-', 482,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 442,
        '=', 358,
        '?', 379,
        '@', 497,
        '[', 392,
      );
      if (lookahead == '\\') SKIP(14);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(107);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 108:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 373,
        '*', 439,
        '+', 479,
        ',', 377,
        '-', 482,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 442,
        '=', 358,
        '?', 379,
        '@', 498,
        '[', 392,
      );
      if (lookahead == '\\') SKIP(13);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(108);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 109:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 373,
        '*', 439,
        '+', 479,
        ',', 377,
        '-', 482,
        '.', 410,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 442,
        '=', 358,
        '?', 379,
        '@', 499,
        '[', 392,
      );
      if (lookahead == '\\') SKIP(11);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(109);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 110:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 373,
        '+', 479,
        ',', 377,
        '-', 483,
        '.', 409,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 502,
        '=', 358,
        '?', 379,
        '@', 499,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(8);
      if (lookahead == ']') ADVANCE(394);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(110);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 111:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 373,
        '+', 479,
        ',', 377,
        '-', 483,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 502,
        '=', 449,
        '?', 379,
        '@', 499,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(54);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(111);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 112:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 373,
        '+', 479,
        ',', 377,
        '-', 483,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 502,
        '=', 358,
        '>', 428,
        '?', 379,
        '@', 499,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(9);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(112);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 113:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 373,
        '+', 479,
        ',', 377,
        '-', 483,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 502,
        '=', 358,
        '>', 428,
        '?', 379,
        '@', 499,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(17);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(386);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(113);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 114:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 373,
        '+', 479,
        ',', 377,
        '-', 483,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 502,
        '=', 358,
        '?', 379,
        '@', 499,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(46);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(114);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 115:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 373,
        '+', 479,
        ',', 377,
        '-', 483,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 502,
        '=', 358,
        '?', 379,
        '@', 499,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(48);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(386);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(115);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 116:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 373,
        '+', 479,
        ',', 377,
        '-', 483,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 502,
        '=', 358,
        '?', 379,
        '@', 497,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(50);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(116);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 117:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 373,
        '+', 479,
        ',', 377,
        '-', 483,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 502,
        '=', 358,
        '?', 379,
        '@', 497,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(57);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(386);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(117);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 118:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 373,
        '+', 479,
        ',', 377,
        '-', 483,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 502,
        '=', 358,
        '?', 379,
        '@', 498,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(51);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(118);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 119:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 373,
        '+', 479,
        ',', 377,
        '-', 483,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 502,
        '=', 358,
        '?', 379,
        '@', 498,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(58);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(386);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(119);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 120:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 373,
        '+', 479,
        ',', 377,
        '-', 483,
        '.', 410,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 502,
        '=', 358,
        '>', 428,
        '?', 379,
        '@', 499,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(7);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(120);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 121:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 373,
        '+', 479,
        ',', 377,
        '-', 483,
        '.', 410,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 502,
        '=', 358,
        '?', 379,
        '@', 499,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(4);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(121);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 122:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 373,
        '+', 479,
        ',', 377,
        '-', 483,
        '.', 410,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 502,
        '=', 358,
        '?', 379,
        '@', 499,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(52);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(122);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 123:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 373,
        '+', 479,
        ',', 377,
        '-', 483,
        '.', 410,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 502,
        '=', 358,
        '?', 379,
        '@', 499,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(56);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(386);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(123);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 124:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 373,
        '+', 479,
        ',', 377,
        '-', 483,
        '.', 410,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 502,
        '=', 358,
        '?', 379,
        '@', 497,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(6);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(124);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 125:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 373,
        '+', 479,
        ',', 377,
        '-', 483,
        '.', 410,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 502,
        '=', 358,
        '?', 379,
        '@', 498,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(47);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(125);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 126:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 373,
        '+', 479,
        ',', 377,
        '-', 482,
        '.', 409,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 502,
        '=', 358,
        '?', 379,
        '@', 499,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(53);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(126);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 127:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 373,
        '+', 479,
        ',', 377,
        '-', 482,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 502,
        '=', 358,
        '?', 379,
        '@', 499,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(49);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(127);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 128:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 373,
        '+', 479,
        ',', 377,
        '-', 482,
        '.', 410,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 502,
        '=', 358,
        '?', 379,
        '@', 499,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(5);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(128);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 129:
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 609,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 373,
        '+', 479,
        ',', 377,
        '-', 482,
        '.', 410,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 502,
        '=', 358,
        '?', 379,
        '@', 499,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(55);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(386);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(129);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 130:
      if (lookahead == '"') ADVANCE(460);
      END_STATE();
    case 131:
      if (lookahead == '"') ADVANCE(467);
      END_STATE();
    case 132:
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '>') ADVANCE(402);
      if (lookahead == '@') ADVANCE(208);
      END_STATE();
    case 133:
      ADVANCE_MAP(
        '"', 461,
        '#', 607,
        '\'', 448,
        '(', 375,
        '*', 437,
        '+', 303,
        ',', 377,
        '-', 210,
        '.', 408,
        '/', 205,
        ':', 367,
        '<', 440,
        '=', 358,
        '>', 215,
        '@', 131,
        '[', 207,
      );
      if (lookahead == '\\') SKIP(30);
      if (lookahead == '^') ADVANCE(447);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == '|') ADVANCE(383);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(133);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 134:
      if (lookahead == '"') ADVANCE(461);
      if (lookahead == '#') ADVANCE(610);
      if (lookahead == '(') ADVANCE(201);
      if (lookahead == '/') ADVANCE(205);
      if (lookahead == '\\') ADVANCE(44);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(134);
      END_STATE();
    case 135:
      if (lookahead == '"') ADVANCE(461);
      if (lookahead == '#') ADVANCE(455);
      if (lookahead == '(') ADVANCE(455);
      if (lookahead == '/') ADVANCE(455);
      if (lookahead == '\\') ADVANCE(3);
      if (lookahead == '{') ADVANCE(459);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r')) SKIP(134);
      if (lookahead == '\n' ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(455);
      if (lookahead != 0 &&
          (lookahead < 0x07 || '\r' < lookahead)) ADVANCE(455);
      END_STATE();
    case 136:
      if (lookahead == '"') ADVANCE(461);
      if (lookahead == '#') ADVANCE(455);
      if (lookahead == '(') ADVANCE(455);
      if (lookahead == '/') ADVANCE(455);
      if (lookahead == '\\') ADVANCE(3);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r')) SKIP(134);
      if (lookahead == '\n' ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(455);
      if (lookahead != 0 &&
          (lookahead < 0x07 || '\r' < lookahead)) ADVANCE(455);
      END_STATE();
    case 137:
      if (lookahead == '"') ADVANCE(472);
      END_STATE();
    case 138:
      ADVANCE_MAP(
        '"', 462,
        '#', 609,
        '$', 130,
        '%', 488,
        '&', 388,
        '\'', 194,
        '(', 373,
        '+', 478,
        ',', 377,
        '-', 481,
        '.', 558,
        '/', 205,
        '0', 516,
        '<', 211,
        '>', 427,
        '@', 131,
        'L', 548,
        'M', 557,
        'U', 576,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(20);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(536);
      if (lookahead == 'm') ADVANCE(556);
      if (lookahead == 'n') ADVANCE(544);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 's') ADVANCE(531);
      if (lookahead == 'u') ADVANCE(539);
      if (lookahead == 'y') ADVANCE(526);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(495);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(564);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(554);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(142);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 139:
      ADVANCE_MAP(
        '"', 462,
        '#', 609,
        '$', 130,
        '%', 488,
        '&', 388,
        '\'', 194,
        '(', 373,
        '+', 478,
        ',', 377,
        '-', 481,
        '/', 205,
        '0', 516,
        '<', 211,
        '>', 427,
        '@', 131,
        'L', 548,
        'U', 576,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(20);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(536);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'n') ADVANCE(544);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 's') ADVANCE(531);
      if (lookahead == 'u') ADVANCE(539);
      if (lookahead == 'y') ADVANCE(526);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(495);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(142);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 140:
      ADVANCE_MAP(
        '"', 462,
        '#', 609,
        '$', 130,
        '%', 488,
        '&', 388,
        '\'', 194,
        '(', 373,
        '+', 478,
        ',', 377,
        '-', 481,
        '/', 205,
        '0', 516,
        '<', 211,
        '>', 427,
        '@', 131,
        'M', 557,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(20);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'f') ADVANCE(552);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(556);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(495);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(564);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(142);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 141:
      ADVANCE_MAP(
        '"', 462,
        '#', 609,
        '$', 130,
        '%', 488,
        '&', 388,
        '\'', 194,
        '(', 373,
        '+', 478,
        ',', 377,
        '-', 481,
        '/', 205,
        '0', 516,
        '<', 211,
        '>', 427,
        '@', 131,
        'M', 557,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(20);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'f') ADVANCE(552);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(556);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(495);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(142);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 142:
      ADVANCE_MAP(
        '"', 462,
        '#', 609,
        '$', 130,
        '%', 488,
        '&', 388,
        '\'', 194,
        '(', 373,
        '+', 478,
        ',', 377,
        '-', 481,
        '/', 205,
        '0', 516,
        '<', 211,
        '>', 427,
        '@', 131,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(20);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(495);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(142);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 143:
      ADVANCE_MAP(
        '"', 462,
        '#', 610,
        '$', 130,
        '&', 387,
        '\'', 194,
        '(', 373,
        ')', 376,
        '*', 437,
        '+', 303,
        ',', 377,
        '-', 210,
        '.', 408,
        '/', 205,
        '0', 516,
        ':', 365,
        '<', 440,
        '=', 358,
        '?', 378,
        '@', 131,
        '[', 390,
      );
      if (lookahead == '\\') SKIP(26);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'w') ADVANCE(585);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == '|') ADVANCE(383);
      if (lookahead == '}') ADVANCE(399);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(143);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 144:
      ADVANCE_MAP(
        '"', 462,
        '#', 610,
        '$', 130,
        '&', 387,
        '\'', 194,
        '(', 373,
        ')', 376,
        '*', 437,
        '+', 303,
        ',', 377,
        '-', 210,
        '.', 408,
        '/', 205,
        '0', 516,
        ':', 365,
        '<', 440,
        '=', 358,
        '?', 378,
        '@', 131,
        '[', 390,
      );
      if (lookahead == '\\') SKIP(27);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == '|') ADVANCE(383);
      if (lookahead == '}') ADVANCE(399);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(144);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 145:
      ADVANCE_MAP(
        '"', 462,
        '#', 610,
        '$', 130,
        '&', 387,
        '\'', 194,
        '(', 373,
        ')', 376,
        ',', 377,
        '.', 408,
        '/', 205,
        '0', 516,
        ':', 366,
        '<', 440,
        '=', 358,
        '?', 378,
        '@', 131,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(16);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == '|') ADVANCE(383);
      if (lookahead == '}') ADVANCE(399);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(303);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(145);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 146:
      ADVANCE_MAP(
        '"', 462,
        '#', 610,
        '$', 130,
        '&', 387,
        '\'', 194,
        '(', 373,
        ')', 376,
        ',', 377,
        '.', 558,
        '/', 205,
        '0', 516,
        ':', 366,
        '<', 440,
        '=', 358,
        '?', 378,
        '@', 131,
        'L', 548,
        'U', 576,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(23);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'l') ADVANCE(537);
      if (lookahead == 'n') ADVANCE(544);
      if (lookahead == 's') ADVANCE(531);
      if (lookahead == 'u') ADVANCE(540);
      if (lookahead == 'y') ADVANCE(527);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == '|') ADVANCE(383);
      if (lookahead == '}') ADVANCE(399);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(303);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(564);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(557);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(554);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(150);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 147:
      ADVANCE_MAP(
        '"', 462,
        '#', 610,
        '$', 130,
        '&', 387,
        '\'', 194,
        '(', 373,
        ')', 376,
        ',', 377,
        '/', 205,
        '0', 516,
        ':', 366,
        '<', 440,
        '=', 358,
        '?', 378,
        '@', 131,
        'L', 548,
        'U', 576,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(23);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'l') ADVANCE(537);
      if (lookahead == 'n') ADVANCE(544);
      if (lookahead == 's') ADVANCE(531);
      if (lookahead == 'u') ADVANCE(540);
      if (lookahead == 'y') ADVANCE(527);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == '|') ADVANCE(383);
      if (lookahead == '}') ADVANCE(399);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(303);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(150);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 148:
      ADVANCE_MAP(
        '"', 462,
        '#', 610,
        '$', 130,
        '&', 387,
        '\'', 194,
        '(', 373,
        ')', 376,
        ',', 377,
        '/', 205,
        '0', 516,
        ':', 366,
        '<', 440,
        '=', 358,
        '?', 378,
        '@', 131,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(23);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'f') ADVANCE(552);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == '|') ADVANCE(383);
      if (lookahead == '}') ADVANCE(399);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(303);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(564);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(557);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(150);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 149:
      ADVANCE_MAP(
        '"', 462,
        '#', 610,
        '$', 130,
        '&', 387,
        '\'', 194,
        '(', 373,
        ')', 376,
        ',', 377,
        '/', 205,
        '0', 516,
        ':', 366,
        '<', 440,
        '=', 358,
        '?', 378,
        '@', 131,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(23);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'f') ADVANCE(552);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == '|') ADVANCE(383);
      if (lookahead == '}') ADVANCE(399);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(303);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(557);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(150);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 150:
      ADVANCE_MAP(
        '"', 462,
        '#', 610,
        '$', 130,
        '&', 387,
        '\'', 194,
        '(', 373,
        ')', 376,
        ',', 377,
        '/', 205,
        '0', 516,
        ':', 366,
        '<', 440,
        '=', 358,
        '?', 378,
        '@', 131,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(23);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == '|') ADVANCE(383);
      if (lookahead == '}') ADVANCE(399);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(303);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(150);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 151:
      ADVANCE_MAP(
        '"', 462,
        '#', 610,
        '$', 130,
        '&', 387,
        '\'', 194,
        '(', 373,
        '*', 437,
        '+', 303,
        ',', 377,
        '-', 210,
        '.', 408,
        '/', 205,
        '0', 516,
        ':', 365,
        '<', 440,
        '?', 378,
        '@', 131,
        '[', 390,
      );
      if (lookahead == '\\') SKIP(28);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'i') ADVANCE(589);
      if (lookahead == 'w') ADVANCE(585);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == '|') ADVANCE(383);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(151);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 152:
      ADVANCE_MAP(
        '"', 462,
        '#', 610,
        '$', 130,
        '&', 387,
        '\'', 194,
        '(', 373,
        '*', 437,
        '+', 303,
        ',', 377,
        '-', 210,
        '.', 408,
        '/', 205,
        '0', 516,
        ':', 365,
        '<', 440,
        '?', 378,
        '@', 131,
        '[', 390,
      );
      if (lookahead == '\\') SKIP(29);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'i') ADVANCE(589);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == '|') ADVANCE(383);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(152);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 153:
      ADVANCE_MAP(
        '"', 462,
        '#', 610,
        '$', 130,
        '&', 387,
        '\'', 194,
        '(', 373,
        '+', 303,
        ',', 377,
        '-', 210,
        '.', 408,
        '/', 205,
        '0', 516,
        ':', 366,
        '<', 440,
        '?', 378,
        '@', 131,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(18);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'w') ADVANCE(585);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == '|') ADVANCE(383);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(153);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 154:
      ADVANCE_MAP(
        '"', 462,
        '#', 610,
        '$', 130,
        '&', 387,
        '\'', 194,
        '(', 373,
        '+', 303,
        ',', 377,
        '-', 210,
        '.', 558,
        '/', 205,
        '0', 516,
        ':', 366,
        '?', 378,
        '@', 131,
        'L', 548,
        'U', 576,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(24);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'l') ADVANCE(537);
      if (lookahead == 'n') ADVANCE(544);
      if (lookahead == 's') ADVANCE(531);
      if (lookahead == 'u') ADVANCE(540);
      if (lookahead == 'w') ADVANCE(585);
      if (lookahead == 'y') ADVANCE(527);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == '|') ADVANCE(383);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(564);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(557);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(554);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(158);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 155:
      ADVANCE_MAP(
        '"', 462,
        '#', 610,
        '$', 130,
        '&', 387,
        '\'', 194,
        '(', 373,
        '+', 303,
        ',', 377,
        '-', 210,
        '/', 205,
        '0', 516,
        ':', 366,
        '?', 378,
        '@', 131,
        'L', 548,
        'U', 576,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(24);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'l') ADVANCE(537);
      if (lookahead == 'n') ADVANCE(544);
      if (lookahead == 's') ADVANCE(531);
      if (lookahead == 'u') ADVANCE(540);
      if (lookahead == 'w') ADVANCE(585);
      if (lookahead == 'y') ADVANCE(527);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == '|') ADVANCE(383);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(158);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 156:
      ADVANCE_MAP(
        '"', 462,
        '#', 610,
        '$', 130,
        '&', 387,
        '\'', 194,
        '(', 373,
        '+', 303,
        ',', 377,
        '-', 210,
        '/', 205,
        '0', 516,
        ':', 366,
        '?', 378,
        '@', 131,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(24);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'f') ADVANCE(552);
      if (lookahead == 'w') ADVANCE(585);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == '|') ADVANCE(383);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(564);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(557);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(158);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 157:
      ADVANCE_MAP(
        '"', 462,
        '#', 610,
        '$', 130,
        '&', 387,
        '\'', 194,
        '(', 373,
        '+', 303,
        ',', 377,
        '-', 210,
        '/', 205,
        '0', 516,
        ':', 366,
        '?', 378,
        '@', 131,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(24);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'f') ADVANCE(552);
      if (lookahead == 'w') ADVANCE(585);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == '|') ADVANCE(383);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(557);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(158);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 158:
      ADVANCE_MAP(
        '"', 462,
        '#', 610,
        '$', 130,
        '&', 387,
        '\'', 194,
        '(', 373,
        '+', 303,
        ',', 377,
        '-', 210,
        '/', 205,
        '0', 516,
        ':', 366,
        '?', 378,
        '@', 131,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(24);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'w') ADVANCE(585);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == '|') ADVANCE(383);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(158);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 159:
      ADVANCE_MAP(
        '"', 462,
        '#', 610,
        '$', 130,
        '&', 387,
        '\'', 194,
        '(', 373,
        ',', 377,
        '.', 408,
        '/', 205,
        '0', 516,
        ':', 366,
        '<', 440,
        '=', 358,
        '?', 378,
        '@', 131,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(19);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'i') ADVANCE(589);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == '|') ADVANCE(383);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(303);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(159);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 160:
      ADVANCE_MAP(
        '"', 462,
        '#', 610,
        '$', 130,
        '&', 387,
        '\'', 194,
        '(', 373,
        ',', 377,
        '.', 558,
        '/', 205,
        '0', 516,
        ':', 366,
        '?', 378,
        '@', 131,
        'L', 548,
        'U', 576,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(25);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'i') ADVANCE(589);
      if (lookahead == 'l') ADVANCE(537);
      if (lookahead == 'n') ADVANCE(544);
      if (lookahead == 's') ADVANCE(531);
      if (lookahead == 'u') ADVANCE(540);
      if (lookahead == 'y') ADVANCE(527);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == '|') ADVANCE(383);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(303);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(564);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(557);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(554);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(164);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 161:
      ADVANCE_MAP(
        '"', 462,
        '#', 610,
        '$', 130,
        '&', 387,
        '\'', 194,
        '(', 373,
        ',', 377,
        '/', 205,
        '0', 516,
        ':', 366,
        '?', 378,
        '@', 131,
        'L', 548,
        'U', 576,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(25);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'i') ADVANCE(589);
      if (lookahead == 'l') ADVANCE(537);
      if (lookahead == 'n') ADVANCE(544);
      if (lookahead == 's') ADVANCE(531);
      if (lookahead == 'u') ADVANCE(540);
      if (lookahead == 'y') ADVANCE(527);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == '|') ADVANCE(383);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(303);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(164);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 162:
      ADVANCE_MAP(
        '"', 462,
        '#', 610,
        '$', 130,
        '&', 387,
        '\'', 194,
        '(', 373,
        ',', 377,
        '/', 205,
        '0', 516,
        ':', 366,
        '?', 378,
        '@', 131,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(25);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'f') ADVANCE(552);
      if (lookahead == 'i') ADVANCE(589);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == '|') ADVANCE(383);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(303);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(564);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(557);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(164);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 163:
      ADVANCE_MAP(
        '"', 462,
        '#', 610,
        '$', 130,
        '&', 387,
        '\'', 194,
        '(', 373,
        ',', 377,
        '/', 205,
        '0', 516,
        ':', 366,
        '?', 378,
        '@', 131,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(25);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'f') ADVANCE(552);
      if (lookahead == 'i') ADVANCE(589);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == '|') ADVANCE(383);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(303);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(557);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(164);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 164:
      ADVANCE_MAP(
        '"', 462,
        '#', 610,
        '$', 130,
        '&', 387,
        '\'', 194,
        '(', 373,
        ',', 377,
        '/', 205,
        '0', 516,
        ':', 366,
        '?', 378,
        '@', 131,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(25);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'i') ADVANCE(589);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == '|') ADVANCE(383);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(303);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(164);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 165:
      ADVANCE_MAP(
        '"', 462,
        '#', 610,
        '$', 130,
        '\'', 194,
        '(', 373,
        ')', 376,
        '.', 408,
        '/', 205,
        '0', 516,
        ':', 368,
        '<', 440,
        '=', 358,
        '?', 378,
        '@', 131,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(15);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == '|') ADVANCE(383);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(303);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(165);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 166:
      ADVANCE_MAP(
        '"', 462,
        '#', 610,
        '$', 130,
        '\'', 194,
        '(', 374,
        '*', 196,
        '+', 303,
        '-', 210,
        '.', 558,
        '/', 205,
        '0', 516,
        ':', 361,
        '=', 358,
        '@', 131,
        'L', 548,
        'U', 576,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(32);
      if (lookahead == ']') ADVANCE(394);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'l') ADVANCE(537);
      if (lookahead == 'n') ADVANCE(544);
      if (lookahead == 's') ADVANCE(531);
      if (lookahead == 'u') ADVANCE(540);
      if (lookahead == 'y') ADVANCE(527);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == '|') ADVANCE(214);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(564);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(557);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(554);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(168);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 167:
      ADVANCE_MAP(
        '"', 462,
        '#', 610,
        '$', 130,
        '\'', 194,
        '(', 374,
        '+', 303,
        '-', 210,
        '/', 205,
        '0', 516,
        ':', 361,
        '=', 358,
        '@', 131,
        'L', 548,
        'U', 576,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(33);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'l') ADVANCE(537);
      if (lookahead == 'n') ADVANCE(544);
      if (lookahead == 's') ADVANCE(531);
      if (lookahead == 'u') ADVANCE(540);
      if (lookahead == 'y') ADVANCE(527);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == '|') ADVANCE(383);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(169);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 168:
      ADVANCE_MAP(
        '"', 462,
        '#', 610,
        '$', 130,
        '\'', 194,
        '(', 374,
        '+', 303,
        '-', 210,
        '/', 205,
        '0', 516,
        ':', 361,
        '=', 358,
        '@', 131,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(32);
      if (lookahead == ']') ADVANCE(394);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == '|') ADVANCE(214);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(168);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 169:
      ADVANCE_MAP(
        '"', 462,
        '#', 610,
        '$', 130,
        '\'', 194,
        '(', 374,
        '+', 303,
        '-', 210,
        '/', 205,
        '0', 516,
        ':', 361,
        '=', 358,
        '@', 131,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(33);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == '|') ADVANCE(383);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(169);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 170:
      ADVANCE_MAP(
        '"', 462,
        '#', 610,
        '$', 130,
        '\'', 194,
        '(', 374,
        '+', 303,
        '-', 210,
        '/', 205,
        '0', 516,
        ':', 361,
        '=', 358,
        '@', 131,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(37);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'f') ADVANCE(552);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(564);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(557);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(172);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 171:
      ADVANCE_MAP(
        '"', 462,
        '#', 610,
        '$', 130,
        '\'', 194,
        '(', 374,
        '+', 303,
        '-', 210,
        '/', 205,
        '0', 516,
        ':', 361,
        '=', 358,
        '@', 131,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(37);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'f') ADVANCE(552);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(557);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(172);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 172:
      ADVANCE_MAP(
        '"', 462,
        '#', 610,
        '$', 130,
        '\'', 194,
        '(', 374,
        '+', 303,
        '-', 210,
        '/', 205,
        '0', 516,
        ':', 361,
        '=', 358,
        '@', 131,
        '[', 393,
      );
      if (lookahead == '\\') SKIP(37);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == '{') ADVANCE(397);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(172);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 173:
      ADVANCE_MAP(
        '"', 462,
        '#', 446,
        '$', 130,
        '\'', 448,
        '(', 374,
        '/', 205,
        '0', 516,
        '>', 427,
        '@', 131,
      );
      if (lookahead == '\\') SKIP(21);
      if (lookahead == '^') ADVANCE(447);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == '{') ADVANCE(300);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(303);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(173);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 174:
      if (lookahead == '"') ADVANCE(473);
      END_STATE();
    case 175:
      if (lookahead == '"') ADVANCE(463);
      if (lookahead == '#') ADVANCE(455);
      if (lookahead == '(') ADVANCE(455);
      if (lookahead == '/') ADVANCE(455);
      if (lookahead == '\\') ADVANCE(3);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r')) SKIP(134);
      if (lookahead == '\n' ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(455);
      if (lookahead != 0 &&
          (lookahead < 0x07 || '\r' < lookahead)) ADVANCE(455);
      END_STATE();
    case 176:
      if (lookahead == '"') ADVANCE(469);
      if (lookahead == '#') ADVANCE(455);
      if (lookahead == '(') ADVANCE(455);
      if (lookahead == '/') ADVANCE(455);
      if (lookahead == '\\') ADVANCE(465);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r')) SKIP(179);
      if (lookahead == '\n' ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(455);
      if (lookahead != 0 &&
          (lookahead < 0x07 || '\r' < lookahead)) ADVANCE(455);
      END_STATE();
    case 177:
      if (lookahead == '"') ADVANCE(466);
      END_STATE();
    case 178:
      if (lookahead == '"') ADVANCE(468);
      if (lookahead == '#') ADVANCE(455);
      if (lookahead == '(') ADVANCE(455);
      if (lookahead == '/') ADVANCE(455);
      if (lookahead == '\\') ADVANCE(465);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r')) SKIP(179);
      if (lookahead == '\n' ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(455);
      if (lookahead != 0 &&
          (lookahead < 0x07 || '\r' < lookahead)) ADVANCE(455);
      END_STATE();
    case 179:
      if (lookahead == '"') ADVANCE(177);
      if (lookahead == '#') ADVANCE(610);
      if (lookahead == '(') ADVANCE(201);
      if (lookahead == '/') ADVANCE(205);
      if (lookahead == '\\') ADVANCE(464);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(179);
      END_STATE();
    case 180:
      if (lookahead == '#') ADVANCE(445);
      if (lookahead == '\'') ADVANCE(448);
      if (lookahead == '(') ADVANCE(375);
      if (lookahead == '/') ADVANCE(205);
      if (lookahead == '[') ADVANCE(206);
      if (lookahead == '\\') SKIP(22);
      if (lookahead == '^') ADVANCE(447);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(383);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(180);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 181:
      ADVANCE_MAP(
        '#', 610,
        '&', 387,
        '(', 201,
        ')', 376,
        '*', 437,
        ',', 377,
        '-', 209,
        '.', 408,
        '/', 205,
        ':', 364,
        '<', 440,
        '=', 358,
        '>', 427,
        '[', 213,
      );
      if (lookahead == '\\') SKIP(41);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'i') ADVANCE(589);
      if (lookahead == 'w') ADVANCE(585);
      if (lookahead == '|') ADVANCE(383);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(181);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 182:
      ADVANCE_MAP(
        '#', 610,
        '&', 387,
        '(', 201,
        ')', 376,
        '*', 437,
        ',', 377,
        '-', 209,
        '.', 408,
        '/', 205,
        ':', 364,
        '<', 440,
        '=', 358,
        '[', 213,
      );
      if (lookahead == '\\') SKIP(39);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'w') ADVANCE(585);
      if (lookahead == '|') ADVANCE(383);
      if (lookahead == '}') ADVANCE(399);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(182);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 183:
      ADVANCE_MAP(
        '#', 610,
        '&', 387,
        '(', 201,
        ')', 376,
        '*', 437,
        ',', 377,
        '-', 209,
        '.', 408,
        '/', 205,
        ':', 364,
        '<', 440,
        '=', 358,
        '[', 213,
      );
      if (lookahead == '\\') SKIP(40);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == '|') ADVANCE(383);
      if (lookahead == '}') ADVANCE(399);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(183);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 184:
      ADVANCE_MAP(
        '#', 610,
        '&', 387,
        '(', 201,
        ')', 376,
        '+', 303,
        ',', 377,
        '-', 210,
        '.', 558,
        '/', 205,
        ':', 362,
        '<', 440,
        '=', 358,
        '>', 427,
        'L', 547,
        'U', 212,
      );
      if (lookahead == '\\') SKIP(34);
      if (lookahead == 'a') ADVANCE(295);
      if (lookahead == 'f') ADVANCE(551);
      if (lookahead == 'i') ADVANCE(256);
      if (lookahead == 'l') ADVANCE(535);
      if (lookahead == 'n') ADVANCE(543);
      if (lookahead == 's') ADVANCE(530);
      if (lookahead == 'u') ADVANCE(541);
      if (lookahead == 'w') ADVANCE(230);
      if (lookahead == 'y') ADVANCE(525);
      if (lookahead == '|') ADVANCE(383);
      if (lookahead == '}') ADVANCE(399);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(563);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(555);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(553);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(185);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(517);
      END_STATE();
    case 185:
      ADVANCE_MAP(
        '#', 610,
        '&', 387,
        '(', 201,
        ')', 376,
        '+', 303,
        ',', 377,
        '-', 210,
        '/', 205,
        ':', 362,
        '<', 440,
        '=', 358,
        '>', 427,
      );
      if (lookahead == '\\') SKIP(34);
      if (lookahead == 'a') ADVANCE(295);
      if (lookahead == 'i') ADVANCE(256);
      if (lookahead == 'w') ADVANCE(230);
      if (lookahead == '|') ADVANCE(383);
      if (lookahead == '}') ADVANCE(399);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(185);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(517);
      END_STATE();
    case 186:
      ADVANCE_MAP(
        '#', 610,
        '&', 387,
        '(', 201,
        ')', 376,
        ',', 377,
        '-', 209,
        '.', 408,
        '/', 205,
        ':', 362,
        '<', 440,
        '=', 358,
      );
      if (lookahead == '\\') SKIP(43);
      if (lookahead == 'a') ADVANCE(295);
      if (lookahead == 'i') ADVANCE(256);
      if (lookahead == 'w') ADVANCE(230);
      if (lookahead == '|') ADVANCE(383);
      if (lookahead == '}') ADVANCE(399);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(186);
      END_STATE();
    case 187:
      ADVANCE_MAP(
        '#', 610,
        '&', 387,
        '(', 201,
        ')', 376,
        ',', 377,
        '-', 209,
        '/', 205,
        ':', 362,
        '<', 440,
        '=', 358,
        'L', 548,
        'U', 576,
      );
      if (lookahead == '\\') SKIP(35);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'i') ADVANCE(589);
      if (lookahead == 'l') ADVANCE(537);
      if (lookahead == 'n') ADVANCE(544);
      if (lookahead == 's') ADVANCE(531);
      if (lookahead == 'u') ADVANCE(540);
      if (lookahead == 'w') ADVANCE(585);
      if (lookahead == 'y') ADVANCE(527);
      if (lookahead == '|') ADVANCE(383);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(188);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 188:
      ADVANCE_MAP(
        '#', 610,
        '&', 387,
        '(', 201,
        ')', 376,
        ',', 377,
        '-', 209,
        '/', 205,
        ':', 362,
        '<', 440,
        '=', 358,
      );
      if (lookahead == '\\') SKIP(35);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'i') ADVANCE(589);
      if (lookahead == 'w') ADVANCE(585);
      if (lookahead == '|') ADVANCE(383);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(188);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 189:
      ADVANCE_MAP(
        '#', 610,
        '&', 387,
        '(', 201,
        ')', 376,
        ',', 377,
        '/', 205,
        ':', 362,
        '=', 449,
        'L', 548,
        'U', 576,
      );
      if (lookahead == '\\') SKIP(38);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'l') ADVANCE(537);
      if (lookahead == 'n') ADVANCE(544);
      if (lookahead == 's') ADVANCE(531);
      if (lookahead == 'u') ADVANCE(540);
      if (lookahead == 'y') ADVANCE(527);
      if (lookahead == '|') ADVANCE(383);
      if (lookahead == '}') ADVANCE(399);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(190);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 190:
      ADVANCE_MAP(
        '#', 610,
        '&', 387,
        '(', 201,
        ')', 376,
        ',', 377,
        '/', 205,
        ':', 362,
        '=', 449,
      );
      if (lookahead == '\\') SKIP(38);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == '|') ADVANCE(383);
      if (lookahead == '}') ADVANCE(399);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(190);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 191:
      ADVANCE_MAP(
        '#', 610,
        '&', 387,
        '(', 201,
        '*', 437,
        ',', 377,
        '-', 209,
        '.', 408,
        '/', 205,
        ':', 364,
        '<', 440,
        '=', 449,
        '[', 213,
      );
      if (lookahead == '\\') SKIP(42);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'a') ADVANCE(594);
      if (lookahead == 'i') ADVANCE(589);
      if (lookahead == '|') ADVANCE(383);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(191);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 192:
      if (lookahead == '#') ADVANCE(446);
      if (lookahead == '\'') ADVANCE(448);
      if (lookahead == '(') ADVANCE(375);
      if (lookahead == '/') ADVANCE(205);
      if (lookahead == '>') ADVANCE(427);
      if (lookahead == '?') ADVANCE(378);
      if (lookahead == '[') ADVANCE(206);
      if (lookahead == '\\') SKIP(31);
      if (lookahead == '^') ADVANCE(447);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == '{') ADVANCE(300);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(192);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 193:
      ADVANCE_MAP(
        '#', 608,
        '\'', 448,
        '(', 375,
        ')', 376,
        '*', 437,
        ',', 377,
        '-', 209,
        '.', 408,
        '/', 205,
        ':', 367,
        '<', 440,
        '=', 358,
        '>', 427,
        '[', 207,
      );
      if (lookahead == '\\') SKIP(36);
      if (lookahead == '^') ADVANCE(447);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == '|') ADVANCE(383);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(193);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 194:
      if (lookahead == '\'') ADVANCE(457);
      if (lookahead == '\\') ADVANCE(298);
      if (lookahead != 0 &&
          (lookahead < 0x07 || '\r' < lookahead)) ADVANCE(195);
      END_STATE();
    case 195:
      if (lookahead == '\'') ADVANCE(458);
      END_STATE();
    case 196:
      if (lookahead == ')') ADVANCE(567);
      END_STATE();
    case 197:
      if (lookahead == ')') ADVANCE(477);
      if (lookahead == '.') ADVANCE(59);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(199);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(200);
      END_STATE();
    case 198:
      if (lookahead == ')') ADVANCE(477);
      if (lookahead == '.') ADVANCE(203);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(199);
      END_STATE();
    case 199:
      if (lookahead == ')') ADVANCE(477);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(199);
      END_STATE();
    case 200:
      if (lookahead == ')') ADVANCE(477);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(199);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(200);
      END_STATE();
    case 201:
      if (lookahead == '*') ADVANCE(565);
      END_STATE();
    case 202:
      if (lookahead == '.') ADVANCE(197);
      if (lookahead == '?') ADVANCE(199);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(202);
      if (lookahead == '!' ||
          ('$' <= lookahead && lookahead <= '&') ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(200);
      END_STATE();
    case 203:
      if (lookahead == '.') ADVANCE(199);
      END_STATE();
    case 204:
      if (lookahead == '.') ADVANCE(436);
      END_STATE();
    case 205:
      if (lookahead == '/') ADVANCE(568);
      END_STATE();
    case 206:
      if (lookahead == '<') ADVANCE(359);
      END_STATE();
    case 207:
      if (lookahead == '<') ADVANCE(359);
      if (lookahead == ']') ADVANCE(444);
      END_STATE();
    case 208:
      if (lookahead == '>') ADVANCE(406);
      END_STATE();
    case 209:
      if (lookahead == '>') ADVANCE(420);
      END_STATE();
    case 210:
      if (lookahead == '>') ADVANCE(420);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(517);
      END_STATE();
    case 211:
      if (lookahead == '@') ADVANCE(400);
      END_STATE();
    case 212:
      if (lookahead == 'L') ADVANCE(549);
      END_STATE();
    case 213:
      if (lookahead == ']') ADVANCE(444);
      END_STATE();
    case 214:
      if (lookahead == ']') ADVANCE(396);
      if (lookahead == '}') ADVANCE(413);
      END_STATE();
    case 215:
      if (lookahead == ']') ADVANCE(360);
      END_STATE();
    case 216:
      if (lookahead == '`') ADVANCE(320);
      END_STATE();
    case 217:
      if (lookahead == '`') ADVANCE(570);
      END_STATE();
    case 218:
      if (lookahead == '`') ADVANCE(217);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(218);
      END_STATE();
    case 219:
      if (lookahead == 'a') ADVANCE(221);
      END_STATE();
    case 220:
      if (lookahead == 'a') ADVANCE(294);
      END_STATE();
    case 221:
      if (lookahead == 'd') ADVANCE(604);
      END_STATE();
    case 222:
      if (lookahead == 'd') ADVANCE(232);
      END_STATE();
    case 223:
      if (lookahead == 'e') ADVANCE(606);
      END_STATE();
    case 224:
      if (lookahead == 'e') ADVANCE(613);
      END_STATE();
    case 225:
      if (lookahead == 'e') ADVANCE(257);
      END_STATE();
    case 226:
      if (lookahead == 'f') ADVANCE(611);
      END_STATE();
    case 227:
      if (lookahead == 'f') ADVANCE(612);
      END_STATE();
    case 228:
      if (lookahead == 'g') ADVANCE(229);
      if (lookahead == 'n') ADVANCE(223);
      END_STATE();
    case 229:
      if (lookahead == 'h') ADVANCE(297);
      END_STATE();
    case 230:
      if (lookahead == 'h') ADVANCE(225);
      END_STATE();
    case 231:
      if (lookahead == 'i') ADVANCE(228);
      if (lookahead == 'o') ADVANCE(219);
      END_STATE();
    case 232:
      if (lookahead == 'i') ADVANCE(227);
      END_STATE();
    case 233:
      if (lookahead == 'l') ADVANCE(296);
      if (lookahead == 'n') ADVANCE(222);
      END_STATE();
    case 234:
      if (lookahead == 'n') SKIP(60);
      END_STATE();
    case 235:
      if (lookahead == 'n') ADVANCE(601);
      END_STATE();
    case 236:
      if (lookahead == 'n') SKIP(110);
      END_STATE();
    case 237:
      if (lookahead == 'n') SKIP(165);
      END_STATE();
    case 238:
      if (lookahead == 'n') SKIP(145);
      END_STATE();
    case 239:
      if (lookahead == 'n') SKIP(153);
      END_STATE();
    case 240:
      if (lookahead == 'n') SKIP(159);
      END_STATE();
    case 241:
      if (lookahead == 'n') SKIP(142);
      END_STATE();
    case 242:
      if (lookahead == 'n') SKIP(173);
      END_STATE();
    case 243:
      if (lookahead == 'n') SKIP(180);
      END_STATE();
    case 244:
      if (lookahead == 'n') SKIP(150);
      END_STATE();
    case 245:
      if (lookahead == 'n') SKIP(158);
      END_STATE();
    case 246:
      if (lookahead == 'n') SKIP(164);
      END_STATE();
    case 247:
      if (lookahead == 'n') SKIP(143);
      END_STATE();
    case 248:
      if (lookahead == 'n') SKIP(144);
      END_STATE();
    case 249:
      if (lookahead == 'n') SKIP(151);
      END_STATE();
    case 250:
      if (lookahead == 'n') SKIP(152);
      END_STATE();
    case 251:
      if (lookahead == 'n') SKIP(133);
      END_STATE();
    case 252:
      if (lookahead == 'n') SKIP(192);
      END_STATE();
    case 253:
      if (lookahead == 'n') SKIP(168);
      END_STATE();
    case 254:
      if (lookahead == 'n') SKIP(169);
      END_STATE();
    case 255:
      if (lookahead == 'n') SKIP(185);
      END_STATE();
    case 256:
      if (lookahead == 'n') ADVANCE(418);
      END_STATE();
    case 257:
      if (lookahead == 'n') ADVANCE(432);
      END_STATE();
    case 258:
      if (lookahead == 'n') SKIP(188);
      END_STATE();
    case 259:
      if (lookahead == 'n') SKIP(193);
      END_STATE();
    case 260:
      if (lookahead == 'n') SKIP(172);
      END_STATE();
    case 261:
      if (lookahead == 'n') SKIP(190);
      END_STATE();
    case 262:
      if (lookahead == 'n') SKIP(182);
      END_STATE();
    case 263:
      if (lookahead == 'n') SKIP(183);
      END_STATE();
    case 264:
      if (lookahead == 'n') SKIP(181);
      END_STATE();
    case 265:
      if (lookahead == 'n') SKIP(191);
      END_STATE();
    case 266:
      if (lookahead == 'n') SKIP(186);
      END_STATE();
    case 267:
      if (lookahead == 'n') SKIP(134);
      END_STATE();
    case 268:
      if (lookahead == 'n') SKIP(1);
      END_STATE();
    case 269:
      if (lookahead == 'n') SKIP(121);
      END_STATE();
    case 270:
      if (lookahead == 'n') SKIP(128);
      END_STATE();
    case 271:
      if (lookahead == 'n') SKIP(120);
      END_STATE();
    case 272:
      if (lookahead == 'n') SKIP(106);
      END_STATE();
    case 273:
      if (lookahead == 'n') SKIP(109);
      END_STATE();
    case 274:
      if (lookahead == 'n') SKIP(105);
      END_STATE();
    case 275:
      if (lookahead == 'n') SKIP(114);
      END_STATE();
    case 276:
      if (lookahead == 'n') SKIP(112);
      END_STATE();
    case 277:
      if (lookahead == 'n') SKIP(124);
      END_STATE();
    case 278:
      if (lookahead == 'n') SKIP(108);
      END_STATE();
    case 279:
      if (lookahead == 'n') SKIP(115);
      END_STATE();
    case 280:
      if (lookahead == 'n') SKIP(113);
      END_STATE();
    case 281:
      if (lookahead == 'n') SKIP(125);
      END_STATE();
    case 282:
      if (lookahead == 'n') SKIP(107);
      END_STATE();
    case 283:
      if (lookahead == 'n') SKIP(127);
      END_STATE();
    case 284:
      if (lookahead == 'n') SKIP(116);
      END_STATE();
    case 285:
      if (lookahead == 'n') SKIP(118);
      END_STATE();
    case 286:
      if (lookahead == 'n') SKIP(122);
      END_STATE();
    case 287:
      if (lookahead == 'n') SKIP(126);
      END_STATE();
    case 288:
      if (lookahead == 'n') SKIP(111);
      END_STATE();
    case 289:
      if (lookahead == 'n') SKIP(129);
      END_STATE();
    case 290:
      if (lookahead == 'n') SKIP(123);
      END_STATE();
    case 291:
      if (lookahead == 'n') SKIP(117);
      END_STATE();
    case 292:
      if (lookahead == 'n') SKIP(119);
      END_STATE();
    case 293:
      if (lookahead == 'o') ADVANCE(299);
      END_STATE();
    case 294:
      if (lookahead == 'r') ADVANCE(235);
      END_STATE();
    case 295:
      if (lookahead == 's') ADVANCE(371);
      END_STATE();
    case 296:
      if (lookahead == 's') ADVANCE(224);
      END_STATE();
    case 297:
      if (lookahead == 't') ADVANCE(602);
      END_STATE();
    case 298:
      ADVANCE_MAP(
        'u', 319,
        '"', 195,
        '\'', 195,
        '\\', 195,
        'a', 195,
        'b', 195,
        'f', 195,
        'n', 195,
        'r', 195,
        't', 195,
        'v', 195,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(307);
      END_STATE();
    case 299:
      if (lookahead == 'w') ADVANCE(220);
      END_STATE();
    case 300:
      if (lookahead == '|') ADVANCE(412);
      END_STATE();
    case 301:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(519);
      END_STATE();
    case 302:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(520);
      END_STATE();
    case 303:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(517);
      END_STATE();
    case 304:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(454);
      END_STATE();
    case 305:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(195);
      END_STATE();
    case 306:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(304);
      END_STATE();
    case 307:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(305);
      END_STATE();
    case 308:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(521);
      END_STATE();
    case 309:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(452);
      END_STATE();
    case 310:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(453);
      END_STATE();
    case 311:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(195);
      END_STATE();
    case 312:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(309);
      END_STATE();
    case 313:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(310);
      END_STATE();
    case 314:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(311);
      END_STATE();
    case 315:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(312);
      END_STATE();
    case 316:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(313);
      END_STATE();
    case 317:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(314);
      END_STATE();
    case 318:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(315);
      END_STATE();
    case 319:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(317);
      END_STATE();
    case 320:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '`') ADVANCE(218);
      END_STATE();
    case 321:
      if (eof) ADVANCE(357);
      if (lookahead == '\r') SKIP(348);
      if (lookahead == 'n') SKIP(344);
      END_STATE();
    case 322:
      if (eof) ADVANCE(357);
      if (lookahead == '\r') SKIP(352);
      if (lookahead == 'n') SKIP(340);
      END_STATE();
    case 323:
      if (eof) ADVANCE(357);
      if (lookahead == '\r') SKIP(349);
      if (lookahead == 'n') SKIP(345);
      END_STATE();
    case 324:
      if (eof) ADVANCE(357);
      if (lookahead == '\r') SKIP(353);
      if (lookahead == 'n') SKIP(339);
      END_STATE();
    case 325:
      if (eof) ADVANCE(357);
      if (lookahead == '\r') SKIP(350);
      if (lookahead == 'n') SKIP(346);
      END_STATE();
    case 326:
      if (eof) ADVANCE(357);
      if (lookahead == '\r') SKIP(351);
      if (lookahead == 'n') SKIP(347);
      END_STATE();
    case 327:
      if (eof) ADVANCE(357);
      if (lookahead == '\r') SKIP(354);
      if (lookahead == 'n') SKIP(343);
      END_STATE();
    case 328:
      if (eof) ADVANCE(357);
      if (lookahead == '\r') SKIP(355);
      if (lookahead == 'n') SKIP(342);
      END_STATE();
    case 329:
      if (eof) ADVANCE(357);
      if (lookahead == '\r') SKIP(356);
      if (lookahead == 'n') SKIP(341);
      END_STATE();
    case 330:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 494,
        '"', 461,
        '#', 445,
        '$', 514,
        '%', 488,
        '&', 388,
        '\'', 448,
        '(', 373,
        ')', 376,
        '*', 437,
        '+', 478,
        ',', 377,
        '-', 480,
        '.', 409,
        '/', 205,
        '0', 516,
        ':', 363,
        '<', 441,
        '=', 449,
        '>', 427,
        '?', 379,
        '@', 132,
        '[', 390,
        '\\', 2,
        ']', 394,
        '^', 447,
        '`', 216,
        'a', 594,
        'd', 592,
        'i', 589,
        'l', 580,
        'm', 577,
        'r', 584,
        'u', 595,
        'w', 585,
        'y', 587,
        '{', 398,
        '|', 385,
        '}', 399,
        '~', 492,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          (' ' <= lookahead && lookahead <= ';') ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(330);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 331:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 607,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '*', 439,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 409,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '>', 506,
        '?', 379,
        '@', 499,
        '[', 390,
      );
      if (lookahead == '\\') SKIP(324);
      if (lookahead == ']') ADVANCE(394);
      if (lookahead == '^') ADVANCE(508);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '}') ADVANCE(399);
      if (lookahead == '~') ADVANCE(492);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(339);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 332:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 607,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 409,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '>', 506,
        '?', 379,
        '@', 499,
        'L', 548,
        'U', 576,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(322);
      if (lookahead == ']') ADVANCE(394);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(536);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'n') ADVANCE(544);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 's') ADVANCE(531);
      if (lookahead == 'u') ADVANCE(539);
      if (lookahead == 'y') ADVANCE(526);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '}') ADVANCE(399);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(340);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 333:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 607,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 409,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '>', 506,
        '?', 379,
        '@', 499,
        'M', 557,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(322);
      if (lookahead == ']') ADVANCE(394);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'f') ADVANCE(552);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(556);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '}') ADVANCE(399);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(508);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(564);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(340);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 334:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 607,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 409,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '>', 506,
        '?', 379,
        '@', 499,
        'M', 557,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(322);
      if (lookahead == ']') ADVANCE(394);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'f') ADVANCE(552);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(556);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '}') ADVANCE(399);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(340);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 335:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 607,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 409,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '>', 506,
        '?', 379,
        '@', 499,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(322);
      if (lookahead == ']') ADVANCE(394);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '}') ADVANCE(399);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(340);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 336:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 607,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 409,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '>', 506,
        '?', 379,
        '@', 499,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(329);
      if (lookahead == ']') ADVANCE(394);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(386);
      if (lookahead == '}') ADVANCE(399);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(341);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 337:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 607,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 561,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '>', 506,
        '?', 379,
        '@', 499,
        'L', 548,
        'M', 557,
        'U', 576,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(328);
      if (lookahead == ']') ADVANCE(394);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(536);
      if (lookahead == 'm') ADVANCE(556);
      if (lookahead == 'n') ADVANCE(544);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 's') ADVANCE(531);
      if (lookahead == 'u') ADVANCE(539);
      if (lookahead == 'y') ADVANCE(526);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '}') ADVANCE(399);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(508);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(564);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(554);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(342);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 338:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 607,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 434,
        '+', 496,
        ',', 377,
        '-', 496,
        '.', 410,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 426,
        '=', 358,
        '>', 506,
        '?', 379,
        '@', 499,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(327);
      if (lookahead == ']') ADVANCE(394);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '}') ADVANCE(399);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(343);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 339:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 607,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 373,
        '*', 439,
        '+', 479,
        ',', 377,
        '-', 482,
        '.', 409,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 442,
        '=', 358,
        '>', 506,
        '?', 379,
        '@', 499,
        '[', 390,
      );
      if (lookahead == '\\') SKIP(324);
      if (lookahead == ']') ADVANCE(394);
      if (lookahead == '^') ADVANCE(508);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '}') ADVANCE(399);
      if (lookahead == '~') ADVANCE(492);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(339);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 340:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 607,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 373,
        '+', 479,
        ',', 377,
        '-', 483,
        '.', 409,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 502,
        '=', 358,
        '>', 506,
        '?', 379,
        '@', 499,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(322);
      if (lookahead == ']') ADVANCE(394);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '}') ADVANCE(399);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(340);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 341:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 607,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 373,
        '+', 479,
        ',', 377,
        '-', 483,
        '.', 409,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 502,
        '=', 358,
        '>', 506,
        '?', 379,
        '@', 499,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(329);
      if (lookahead == ']') ADVANCE(394);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(386);
      if (lookahead == '}') ADVANCE(399);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(341);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 342:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 607,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 373,
        '+', 479,
        ',', 377,
        '-', 483,
        '.', 411,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 502,
        '=', 358,
        '>', 506,
        '?', 379,
        '@', 499,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(328);
      if (lookahead == ']') ADVANCE(394);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '}') ADVANCE(399);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(342);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 343:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 494,
        '"', 462,
        '#', 607,
        '$', 514,
        '%', 489,
        '&', 389,
        '\'', 500,
        '(', 373,
        '+', 479,
        ',', 377,
        '-', 483,
        '.', 410,
        '/', 503,
        '0', 516,
        ':', 363,
        '<', 502,
        '=', 358,
        '>', 506,
        '?', 379,
        '@', 499,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(327);
      if (lookahead == ']') ADVANCE(394);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '|') ADVANCE(507);
      if (lookahead == '}') ADVANCE(399);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(508);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(343);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 344:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '"', 462,
        '#', 607,
        '$', 130,
        '%', 488,
        '&', 388,
        '\'', 194,
        '(', 373,
        '*', 437,
        '+', 478,
        ',', 377,
        '-', 481,
        '.', 204,
        '/', 205,
        '0', 516,
        '<', 211,
        '>', 427,
        '@', 131,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(321);
      if (lookahead == ']') ADVANCE(394);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(495);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(344);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 345:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '"', 462,
        '#', 609,
        '$', 130,
        '%', 488,
        '&', 388,
        '\'', 194,
        '(', 373,
        '*', 437,
        '+', 478,
        '-', 480,
        '.', 408,
        '/', 205,
        '0', 516,
        ':', 367,
        '<', 443,
        '>', 215,
        '@', 131,
        '[', 390,
      );
      if (lookahead == '\\') SKIP(323);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(495);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(345);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 346:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '"', 462,
        '#', 609,
        '$', 130,
        '%', 488,
        '&', 388,
        '\'', 194,
        '(', 373,
        '+', 478,
        '-', 481,
        '.', 408,
        '/', 205,
        '0', 516,
        '<', 211,
        '=', 358,
        '@', 131,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(325);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(580);
      if (lookahead == 'm') ADVANCE(577);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 'u') ADVANCE(595);
      if (lookahead == 'y') ADVANCE(587);
      if (lookahead == '{') ADVANCE(398);
      if (lookahead == '~') ADVANCE(492);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(495);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(346);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 347:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '"', 462,
        '#', 608,
        '$', 130,
        '\'', 194,
        '(', 374,
        ')', 376,
        '*', 437,
        '+', 303,
        ',', 377,
        '-', 210,
        '.', 408,
        '/', 205,
        '0', 516,
        ':', 367,
        '<', 440,
        '=', 358,
        '>', 427,
        '@', 131,
        '[', 391,
      );
      if (lookahead == '\\') SKIP(326);
      if (lookahead == ']') ADVANCE(394);
      if (lookahead == '`') ADVANCE(216);
      if (lookahead == '{') ADVANCE(397);
      if (lookahead == '|') ADVANCE(384);
      if (lookahead == '}') ADVANCE(399);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(347);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(600);
      END_STATE();
    case 348:
      if (eof) ADVANCE(357);
      if (lookahead == 'n') SKIP(344);
      END_STATE();
    case 349:
      if (eof) ADVANCE(357);
      if (lookahead == 'n') SKIP(345);
      END_STATE();
    case 350:
      if (eof) ADVANCE(357);
      if (lookahead == 'n') SKIP(346);
      END_STATE();
    case 351:
      if (eof) ADVANCE(357);
      if (lookahead == 'n') SKIP(347);
      END_STATE();
    case 352:
      if (eof) ADVANCE(357);
      if (lookahead == 'n') SKIP(340);
      END_STATE();
    case 353:
      if (eof) ADVANCE(357);
      if (lookahead == 'n') SKIP(339);
      END_STATE();
    case 354:
      if (eof) ADVANCE(357);
      if (lookahead == 'n') SKIP(343);
      END_STATE();
    case 355:
      if (eof) ADVANCE(357);
      if (lookahead == 'n') SKIP(342);
      END_STATE();
    case 356:
      if (eof) ADVANCE(357);
      if (lookahead == 'n') SKIP(341);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(anon_sym_LBRACK_LT);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(anon_sym_GT_RBRACK);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(382);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(382);
      if (lookahead == '=') ADVANCE(513);
      if (lookahead == '>') ADVANCE(416);
      if (lookahead == '?') ADVANCE(381);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(382);
      if (lookahead == '>') ADVANCE(416);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(382);
      if (lookahead == '>') ADVANCE(416);
      if (lookahead == '?') ADVANCE(380);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(382);
      if (lookahead == '?') ADVANCE(380);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '>') ADVANCE(416);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '?') ADVANCE(380);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(anon_sym_let);
      if (lookahead == '!') ADVANCE(370);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(anon_sym_let_BANG);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(anon_sym_as);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(anon_sym_as);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == ')') ADVANCE(474);
      if (lookahead == '*') ADVANCE(566);
      if (lookahead == '.') ADVANCE(197);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '|') ADVANCE(475);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(202);
      if (lookahead == '!' ||
          ('$' <= lookahead && lookahead <= '&') ||
          ('+' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(200);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == ')') ADVANCE(474);
      if (lookahead == '*') ADVANCE(565);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == '*') ADVANCE(565);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '<') ADVANCE(493);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('=' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(495);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      if (lookahead == '>') ADVANCE(417);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == ')') ADVANCE(476);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == ')') ADVANCE(476);
      if (lookahead == ']') ADVANCE(396);
      if (lookahead == '|') ADVANCE(510);
      if (lookahead == '}') ADVANCE(413);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(511);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(508);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(490);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(491);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '&' &&
          lookahead != '\'') ADVANCE(508);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '<') ADVANCE(359);
      if (lookahead == ']') ADVANCE(444);
      if (lookahead == '|') ADVANCE(395);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '<') ADVANCE(359);
      if (lookahead == '|') ADVANCE(395);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == ']') ADVANCE(444);
      if (lookahead == '|') ADVANCE(395);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '|') ADVANCE(395);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(anon_sym_LBRACK_PIPE);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACK);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|') ADVANCE(412);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(anon_sym_LT_AT);
      if (lookahead == '@') ADVANCE(404);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(anon_sym_LT_AT);
      if (lookahead == '@') ADVANCE(405);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(508);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(anon_sym_AT_GT);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(anon_sym_AT_GT);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(508);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(anon_sym_LT_AT_AT);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(anon_sym_LT_AT_AT);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(508);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(anon_sym_AT_AT_GT);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(anon_sym_AT_AT_GT);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(508);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(435);
      if (lookahead == '[') ADVANCE(425);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(431);
      if (lookahead == '[') ADVANCE(425);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '[') ADVANCE(425);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(anon_sym_return_BANG);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(anon_sym_yield_BANG);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(anon_sym_COLON_GT);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK_GT);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(anon_sym_in);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(508);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(anon_sym_match_BANG);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(anon_sym_LT_DASH);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(anon_sym_LT_DASH);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(508);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(anon_sym_DOT_LBRACK);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(anon_sym_GT);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(508);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(anon_sym_use_BANG);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(anon_sym_do_BANG);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(anon_sym_when);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(anon_sym_when);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      if (lookahead == ')') ADVANCE(474);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(anon_sym_DOT_DOT2);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(anon_sym_DOT_DOT3);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == ')') ADVANCE(567);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(anon_sym_STAR);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(508);
      END_STATE();
    case 440:
      ACCEPT_TOKEN(anon_sym_LT2);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(anon_sym_LT2);
      if (lookahead == '-') ADVANCE(423);
      if (lookahead == '@') ADVANCE(400);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(anon_sym_LT2);
      if (lookahead == '-') ADVANCE(424);
      if (lookahead == '@') ADVANCE(401);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(508);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(anon_sym_LT2);
      if (lookahead == '@') ADVANCE(400);
      END_STATE();
    case 444:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (lookahead == 'i') ADVANCE(226);
      if (lookahead == 'l') ADVANCE(231);
      if (lookahead == 'n') ADVANCE(293);
      if (lookahead == 'r') ADVANCE(603);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (lookahead == 'l') ADVANCE(231);
      if (lookahead == 'n') ADVANCE(293);
      if (lookahead == 'r') ADVANCE(603);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(anon_sym_EQ2);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(sym__escape_char);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(sym__non_escape_char);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(sym__unicodegraph_short);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(316);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(sym__unicodegraph_long);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(sym__trigraph);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(aux_sym__simple_string_char_token1);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(aux_sym_char_token1);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(aux_sym_char_token1);
      if (lookahead == '\'') ADVANCE(458);
      if (lookahead == 'B') ADVANCE(456);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(aux_sym_char_token1);
      if (lookahead == 'B') ADVANCE(456);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(anon_sym_LBRACE2);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(anon_sym_DOLLAR_DQUOTE);
      if (lookahead == '"') ADVANCE(137);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      if (lookahead == '"') ADVANCE(174);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      if (lookahead == 'B') ADVANCE(471);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      if (lookahead == '\r') ADVANCE(451);
      if ((!eof && set_contains(sym__non_escape_char_character_set_1, 9, lookahead))) ADVANCE(451);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(aux_sym__verbatim_string_char_token1);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(anon_sym_AT_DQUOTE);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(anon_sym_DQUOTE2);
      if (lookahead == '"') ADVANCE(466);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(anon_sym_DQUOTE2);
      if (lookahead == '"') ADVANCE(466);
      if (lookahead == 'B') ADVANCE(471);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(anon_sym_DQUOTE2);
      if (lookahead == 'B') ADVANCE(471);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(anon_sym_DQUOTEB);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(anon_sym_DQUOTE_DQUOTE_DQUOTE);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(sym_unit);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(anon_sym_LPAREN_PIPE);
      if (lookahead == ')') ADVANCE(477);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(199);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(200);
      END_STATE();
    case 476:
      ACCEPT_TOKEN(anon_sym_PIPE_RPAREN);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(sym_op_identifier);
      END_STATE();
    case 478:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '.') ADVANCE(484);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(517);
      END_STATE();
    case 479:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '.') ADVANCE(485);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(508);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(486);
      if (lookahead == '>') ADVANCE(420);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(517);
      END_STATE();
    case 481:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(486);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(517);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(487);
      if (lookahead == '>') ADVANCE(421);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          ('=' <= lookahead && lookahead <= '?') ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(508);
      END_STATE();
    case 483:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(487);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(517);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(508);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(anon_sym_PLUS_DOT);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(anon_sym_PLUS_DOT);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(508);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(anon_sym_DASH_DOT);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(anon_sym_DASH_DOT);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(508);
      END_STATE();
    case 488:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(508);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(508);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(aux_sym_prefix_op_token1);
      if (lookahead == '-') ADVANCE(515);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(495);
      END_STATE();
    case 494:
      ACCEPT_TOKEN(aux_sym_prefix_op_token1);
      if (lookahead == '=') ADVANCE(512);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(495);
      END_STATE();
    case 495:
      ACCEPT_TOKEN(aux_sym_prefix_op_token1);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(495);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(aux_sym_infix_op_token1);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(aux_sym_infix_op_token2);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '>') ADVANCE(403);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          ('=' <= lookahead && lookahead <= '?') ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(508);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(aux_sym_infix_op_token2);
      if (lookahead == '"') ADVANCE(467);
      if (lookahead == '@') ADVANCE(505);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(508);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(aux_sym_infix_op_token2);
      if (lookahead == '"') ADVANCE(467);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(508);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(aux_sym_infix_op_token2);
      if (lookahead == '\'') ADVANCE(457);
      if (lookahead == '\\') ADVANCE(298);
      if (set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') ADVANCE(501);
      if (lookahead != 0 &&
          (lookahead < 0x07 || '\r' < lookahead)) ADVANCE(195);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(aux_sym_infix_op_token2);
      if (lookahead == '\'') ADVANCE(458);
      if (set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') ADVANCE(508);
      END_STATE();
    case 502:
      ACCEPT_TOKEN(aux_sym_infix_op_token2);
      if (lookahead == '-') ADVANCE(424);
      if (lookahead == '@') ADVANCE(401);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(508);
      END_STATE();
    case 503:
      ACCEPT_TOKEN(aux_sym_infix_op_token2);
      if (lookahead == '/') ADVANCE(504);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(508);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(aux_sym_infix_op_token2);
      if (lookahead == '/') ADVANCE(504);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(509);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(569);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(aux_sym_infix_op_token2);
      if (lookahead == '>') ADVANCE(407);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          ('=' <= lookahead && lookahead <= '?') ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(508);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(aux_sym_infix_op_token2);
      if (lookahead == ']') ADVANCE(360);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(508);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(aux_sym_infix_op_token2);
      if (lookahead == '|') ADVANCE(511);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(508);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(aux_sym_infix_op_token2);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(508);
      END_STATE();
    case 509:
      ACCEPT_TOKEN(aux_sym_infix_op_token2);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(509);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(569);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 511:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(508);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(495);
      END_STATE();
    case 513:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 514:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '"') ADVANCE(460);
      END_STATE();
    case 515:
      ACCEPT_TOKEN(anon_sym_QMARK_LT_DASH);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(495);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(sym_int);
      if (lookahead == '_') ADVANCE(518);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(301);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(302);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(308);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(517);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(sym_int);
      if (lookahead == '_') ADVANCE(518);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(517);
      END_STATE();
    case 518:
      ACCEPT_TOKEN(sym_int);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(517);
      END_STATE();
    case 519:
      ACCEPT_TOKEN(sym_xint);
      if (lookahead == '_') ADVANCE(522);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(519);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(sym_xint);
      if (lookahead == '_') ADVANCE(523);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(520);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(sym_xint);
      if (lookahead == '_') ADVANCE(524);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(521);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(sym_xint);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(519);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(sym_xint);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(520);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(sym_xint);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(521);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(anon_sym_y);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(anon_sym_y);
      if (lookahead == 'i') ADVANCE(581);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(anon_sym_y);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(anon_sym_uy);
      END_STATE();
    case 529:
      ACCEPT_TOKEN(anon_sym_uy);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 530:
      ACCEPT_TOKEN(anon_sym_s);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(anon_sym_s);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(anon_sym_us);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(anon_sym_us);
      if (lookahead == 'e') ADVANCE(572);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(anon_sym_us);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(anon_sym_l);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(anon_sym_l);
      if (lookahead == 'e') ADVANCE(596);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(anon_sym_l);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(aux_sym_uint32_token1);
      END_STATE();
    case 539:
      ACCEPT_TOKEN(aux_sym_uint32_token1);
      if (lookahead == 'L') ADVANCE(550);
      if (lookahead == 'l') ADVANCE(542);
      if (lookahead == 'n') ADVANCE(546);
      if (lookahead == 's') ADVANCE(533);
      if (lookahead == 'y') ADVANCE(529);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(aux_sym_uint32_token1);
      if (lookahead == 'L') ADVANCE(550);
      if (lookahead == 'l') ADVANCE(542);
      if (lookahead == 'n') ADVANCE(546);
      if (lookahead == 's') ADVANCE(534);
      if (lookahead == 'y') ADVANCE(529);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 541:
      ACCEPT_TOKEN(aux_sym_uint32_token1);
      if (lookahead == 'L') ADVANCE(549);
      if (lookahead == 'l') ADVANCE(538);
      if (lookahead == 'n') ADVANCE(545);
      if (lookahead == 's') ADVANCE(532);
      if (lookahead == 'y') ADVANCE(528);
      END_STATE();
    case 542:
      ACCEPT_TOKEN(aux_sym_uint32_token1);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 543:
      ACCEPT_TOKEN(anon_sym_n);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(anon_sym_n);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(anon_sym_un);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(anon_sym_un);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 547:
      ACCEPT_TOKEN(anon_sym_L);
      END_STATE();
    case 548:
      ACCEPT_TOKEN(anon_sym_L);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(aux_sym_uint64_token1);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(aux_sym_uint64_token1);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(anon_sym_f);
      END_STATE();
    case 552:
      ACCEPT_TOKEN(anon_sym_f);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(aux_sym_bignum_token1);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(aux_sym_bignum_token1);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 555:
      ACCEPT_TOKEN(aux_sym_decimal_token1);
      END_STATE();
    case 556:
      ACCEPT_TOKEN(aux_sym_decimal_token1);
      if (lookahead == 'a') ADVANCE(597);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 557:
      ACCEPT_TOKEN(aux_sym_decimal_token1);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(anon_sym_DOT2);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(anon_sym_DOT2);
      if (lookahead == '.') ADVANCE(435);
      if (lookahead == '[') ADVANCE(425);
      END_STATE();
    case 560:
      ACCEPT_TOKEN(anon_sym_DOT2);
      if (lookahead == '.') ADVANCE(431);
      if (lookahead == '[') ADVANCE(425);
      END_STATE();
    case 561:
      ACCEPT_TOKEN(anon_sym_DOT2);
      if (lookahead == '[') ADVANCE(425);
      END_STATE();
    case 562:
      ACCEPT_TOKEN(aux_sym_float_token1);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(aux_sym_float_token1);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(562);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(aux_sym_float_token1);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(562);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(anon_sym_LPAREN_STAR);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(anon_sym_LPAREN_STAR);
      if (lookahead == ')') ADVANCE(477);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(199);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(200);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(anon_sym_STAR_RPAREN);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead == '/') ADVANCE(568);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(569);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(569);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(sym_identifier);
      END_STATE();
    case 571:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '!') ADVANCE(430);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 572:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '!') ADVANCE(429);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 573:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '!') ADVANCE(422);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 574:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '!') ADVANCE(415);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 575:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '!') ADVANCE(414);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'L') ADVANCE(550);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 577:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(597);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(586);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 579:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd') ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(596);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 581:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(588);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 582:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(590);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 583:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(572);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 584:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(598);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h') ADVANCE(582);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 586:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h') ADVANCE(573);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 587:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(581);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(579);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(419);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 590:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(433);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(575);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(571);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 593:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(591);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(372);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 595:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(583);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 596:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(369);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 597:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(578);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(599);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 599:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u') ADVANCE(593);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 600:
      ACCEPT_TOKEN(sym_identifier);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(600);
      END_STATE();
    case 601:
      ACCEPT_TOKEN(anon_sym_POUNDnowarn);
      END_STATE();
    case 602:
      ACCEPT_TOKEN(anon_sym_POUNDlight);
      END_STATE();
    case 603:
      ACCEPT_TOKEN(anon_sym_POUNDr);
      END_STATE();
    case 604:
      ACCEPT_TOKEN(anon_sym_POUNDload);
      END_STATE();
    case 605:
      ACCEPT_TOKEN(aux_sym_fsi_directive_decl_token1);
      if (lookahead == '\n') ADVANCE(605);
      END_STATE();
    case 606:
      ACCEPT_TOKEN(aux_sym_preproc_line_token1);
      END_STATE();
    case 607:
      ACCEPT_TOKEN(aux_sym_preproc_line_token1);
      if (lookahead == 'e') ADVANCE(233);
      if (lookahead == 'i') ADVANCE(226);
      if (lookahead == 'l') ADVANCE(231);
      if (lookahead == 'n') ADVANCE(293);
      if (lookahead == 'r') ADVANCE(603);
      END_STATE();
    case 608:
      ACCEPT_TOKEN(aux_sym_preproc_line_token1);
      if (lookahead == 'e') ADVANCE(233);
      if (lookahead == 'l') ADVANCE(231);
      if (lookahead == 'n') ADVANCE(293);
      if (lookahead == 'r') ADVANCE(603);
      END_STATE();
    case 609:
      ACCEPT_TOKEN(aux_sym_preproc_line_token1);
      if (lookahead == 'i') ADVANCE(226);
      if (lookahead == 'l') ADVANCE(231);
      if (lookahead == 'n') ADVANCE(293);
      if (lookahead == 'r') ADVANCE(603);
      END_STATE();
    case 610:
      ACCEPT_TOKEN(aux_sym_preproc_line_token1);
      if (lookahead == 'l') ADVANCE(231);
      if (lookahead == 'n') ADVANCE(293);
      if (lookahead == 'r') ADVANCE(603);
      END_STATE();
    case 611:
      ACCEPT_TOKEN(anon_sym_POUNDif);
      END_STATE();
    case 612:
      ACCEPT_TOKEN(anon_sym_POUNDendif);
      END_STATE();
    case 613:
      ACCEPT_TOKEN(anon_sym_POUNDelse);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'L') ADVANCE(1);
      if (lookahead == '\\') SKIP(2);
      if (lookahead == '_') ADVANCE(3);
      if (lookahead == 'a') ADVANCE(4);
      if (lookahead == 'b') ADVANCE(5);
      if (lookahead == 'c') ADVANCE(6);
      if (lookahead == 'd') ADVANCE(7);
      if (lookahead == 'e') ADVANCE(8);
      if (lookahead == 'f') ADVANCE(9);
      if (lookahead == 'g') ADVANCE(10);
      if (lookahead == 'i') ADVANCE(11);
      if (lookahead == 'l') ADVANCE(12);
      if (lookahead == 'm') ADVANCE(13);
      if (lookahead == 'n') ADVANCE(14);
      if (lookahead == 'o') ADVANCE(15);
      if (lookahead == 'p') ADVANCE(16);
      if (lookahead == 'r') ADVANCE(17);
      if (lookahead == 's') ADVANCE(18);
      if (lookahead == 't') ADVANCE(19);
      if (lookahead == 'u') ADVANCE(20);
      if (lookahead == 'v') ADVANCE(21);
      if (lookahead == 'w') ADVANCE(22);
      if (lookahead == 'y') ADVANCE(23);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(24);
      END_STATE();
    case 1:
      if (lookahead == 'F') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == '\r') SKIP(26);
      if (lookahead == 'n') SKIP(24);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym__);
      END_STATE();
    case 4:
      if (lookahead == 'b') ADVANCE(27);
      if (lookahead == 'n') ADVANCE(28);
      if (lookahead == 's') ADVANCE(29);
      END_STATE();
    case 5:
      if (lookahead == 'e') ADVANCE(30);
      END_STATE();
    case 6:
      if (lookahead == 'l') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(33);
      if (lookahead == 'o') ADVANCE(34);
      END_STATE();
    case 8:
      if (lookahead == 'l') ADVANCE(35);
      if (lookahead == 'n') ADVANCE(36);
      if (lookahead == 'q') ADVANCE(37);
      if (lookahead == 'v') ADVANCE(38);
      if (lookahead == 'x') ADVANCE(39);
      END_STATE();
    case 9:
      if (lookahead == 'a') ADVANCE(40);
      if (lookahead == 'i') ADVANCE(41);
      if (lookahead == 'o') ADVANCE(42);
      if (lookahead == 'u') ADVANCE(43);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(44);
      if (lookahead == 'l') ADVANCE(45);
      END_STATE();
    case 11:
      if (lookahead == 'd') ADVANCE(46);
      if (lookahead == 'f') ADVANCE(47);
      if (lookahead == 'n') ADVANCE(48);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(49);
      if (lookahead == 'f') ADVANCE(50);
      END_STATE();
    case 13:
      if (lookahead == 'a') ADVANCE(51);
      if (lookahead == 'e') ADVANCE(52);
      if (lookahead == 'o') ADVANCE(53);
      if (lookahead == 'u') ADVANCE(54);
      END_STATE();
    case 14:
      if (lookahead == 'a') ADVANCE(55);
      if (lookahead == 'e') ADVANCE(56);
      if (lookahead == 'o') ADVANCE(57);
      if (lookahead == 'u') ADVANCE(58);
      END_STATE();
    case 15:
      if (lookahead == 'f') ADVANCE(59);
      if (lookahead == 'p') ADVANCE(60);
      if (lookahead == 'r') ADVANCE(61);
      if (lookahead == 'v') ADVANCE(62);
      END_STATE();
    case 16:
      if (lookahead == 'a') ADVANCE(63);
      if (lookahead == 'r') ADVANCE(64);
      if (lookahead == 'u') ADVANCE(65);
      END_STATE();
    case 17:
      if (lookahead == 'e') ADVANCE(66);
      END_STATE();
    case 18:
      if (lookahead == 'e') ADVANCE(67);
      if (lookahead == 't') ADVANCE(68);
      END_STATE();
    case 19:
      if (lookahead == 'h') ADVANCE(69);
      if (lookahead == 'o') ADVANCE(70);
      if (lookahead == 'r') ADVANCE(71);
      if (lookahead == 'y') ADVANCE(72);
      END_STATE();
    case 20:
      if (lookahead == 'n') ADVANCE(73);
      if (lookahead == 'p') ADVANCE(74);
      if (lookahead == 's') ADVANCE(75);
      END_STATE();
    case 21:
      if (lookahead == 'a') ADVANCE(76);
      END_STATE();
    case 22:
      if (lookahead == 'h') ADVANCE(77);
      if (lookahead == 'i') ADVANCE(78);
      END_STATE();
    case 23:
      if (lookahead == 'i') ADVANCE(79);
      END_STATE();
    case 24:
      if (lookahead == '\\') SKIP(2);
      if (lookahead == '_') ADVANCE(3);
      if (lookahead == 'a') ADVANCE(4);
      if (lookahead == 'b') ADVANCE(5);
      if (lookahead == 'c') ADVANCE(6);
      if (lookahead == 'd') ADVANCE(7);
      if (lookahead == 'e') ADVANCE(8);
      if (lookahead == 'f') ADVANCE(9);
      if (lookahead == 'g') ADVANCE(10);
      if (lookahead == 'i') ADVANCE(11);
      if (lookahead == 'l') ADVANCE(80);
      if (lookahead == 'm') ADVANCE(13);
      if (lookahead == 'n') ADVANCE(14);
      if (lookahead == 'o') ADVANCE(15);
      if (lookahead == 'p') ADVANCE(16);
      if (lookahead == 'r') ADVANCE(17);
      if (lookahead == 's') ADVANCE(18);
      if (lookahead == 't') ADVANCE(19);
      if (lookahead == 'u') ADVANCE(20);
      if (lookahead == 'v') ADVANCE(21);
      if (lookahead == 'w') ADVANCE(22);
      if (lookahead == 'y') ADVANCE(23);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(24);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_LF);
      END_STATE();
    case 26:
      if (lookahead == 'n') SKIP(24);
      END_STATE();
    case 27:
      if (lookahead == 's') ADVANCE(81);
      END_STATE();
    case 28:
      if (lookahead == 'd') ADVANCE(82);
      END_STATE();
    case 29:
      if (lookahead == 's') ADVANCE(83);
      END_STATE();
    case 30:
      if (lookahead == 'g') ADVANCE(84);
      END_STATE();
    case 31:
      if (lookahead == 'a') ADVANCE(85);
      END_STATE();
    case 32:
      if (lookahead == 'm') ADVANCE(86);
      if (lookahead == 'n') ADVANCE(87);
      END_STATE();
    case 33:
      if (lookahead == 'f') ADVANCE(88);
      if (lookahead == 'l') ADVANCE(89);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'n') ADVANCE(90);
      if (lookahead == 'w') ADVANCE(91);
      END_STATE();
    case 35:
      if (lookahead == 'i') ADVANCE(92);
      if (lookahead == 's') ADVANCE(93);
      END_STATE();
    case 36:
      if (lookahead == 'd') ADVANCE(94);
      if (lookahead == 'u') ADVANCE(95);
      END_STATE();
    case 37:
      if (lookahead == 'u') ADVANCE(96);
      END_STATE();
    case 38:
      if (lookahead == 'e') ADVANCE(97);
      END_STATE();
    case 39:
      if (lookahead == 'c') ADVANCE(98);
      END_STATE();
    case 40:
      if (lookahead == 'l') ADVANCE(99);
      END_STATE();
    case 41:
      if (lookahead == 'e') ADVANCE(100);
      if (lookahead == 'n') ADVANCE(101);
      END_STATE();
    case 42:
      if (lookahead == 'r') ADVANCE(102);
      END_STATE();
    case 43:
      if (lookahead == 'n') ADVANCE(103);
      END_STATE();
    case 44:
      if (lookahead == 't') ADVANCE(104);
      END_STATE();
    case 45:
      if (lookahead == 'o') ADVANCE(105);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_id);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 48:
      if (lookahead == 'h') ADVANCE(106);
      if (lookahead == 'l') ADVANCE(107);
      if (lookahead == 't') ADVANCE(108);
      END_STATE();
    case 49:
      if (lookahead == 'z') ADVANCE(109);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_lf);
      END_STATE();
    case 51:
      if (lookahead == 't') ADVANCE(110);
      END_STATE();
    case 52:
      if (lookahead == 'm') ADVANCE(111);
      END_STATE();
    case 53:
      if (lookahead == 'd') ADVANCE(112);
      END_STATE();
    case 54:
      if (lookahead == 't') ADVANCE(113);
      END_STATE();
    case 55:
      if (lookahead == 'm') ADVANCE(114);
      END_STATE();
    case 56:
      if (lookahead == 'w') ADVANCE(115);
      END_STATE();
    case 57:
      if (lookahead == 't') ADVANCE(116);
      END_STATE();
    case 58:
      if (lookahead == 'l') ADVANCE(117);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 60:
      if (lookahead == 'e') ADVANCE(118);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 62:
      if (lookahead == 'e') ADVANCE(119);
      END_STATE();
    case 63:
      if (lookahead == 'r') ADVANCE(120);
      END_STATE();
    case 64:
      if (lookahead == 'i') ADVANCE(121);
      if (lookahead == 'o') ADVANCE(122);
      END_STATE();
    case 65:
      if (lookahead == 'b') ADVANCE(123);
      END_STATE();
    case 66:
      if (lookahead == 'c') ADVANCE(124);
      if (lookahead == 't') ADVANCE(125);
      END_STATE();
    case 67:
      if (lookahead == 't') ADVANCE(126);
      END_STATE();
    case 68:
      if (lookahead == 'a') ADVANCE(127);
      if (lookahead == 'r') ADVANCE(128);
      END_STATE();
    case 69:
      if (lookahead == 'e') ADVANCE(129);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_to);
      END_STATE();
    case 71:
      if (lookahead == 'u') ADVANCE(130);
      if (lookahead == 'y') ADVANCE(131);
      END_STATE();
    case 72:
      if (lookahead == 'p') ADVANCE(132);
      END_STATE();
    case 73:
      if (lookahead == 'i') ADVANCE(133);
      if (lookahead == 'm') ADVANCE(134);
      END_STATE();
    case 74:
      if (lookahead == 'c') ADVANCE(135);
      END_STATE();
    case 75:
      if (lookahead == 'e') ADVANCE(136);
      END_STATE();
    case 76:
      if (lookahead == 'l') ADVANCE(137);
      END_STATE();
    case 77:
      if (lookahead == 'i') ADVANCE(138);
      END_STATE();
    case 78:
      if (lookahead == 't') ADVANCE(139);
      END_STATE();
    case 79:
      if (lookahead == 'e') ADVANCE(140);
      END_STATE();
    case 80:
      if (lookahead == 'a') ADVANCE(49);
      END_STATE();
    case 81:
      if (lookahead == 't') ADVANCE(141);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 83:
      if (lookahead == 'e') ADVANCE(142);
      END_STATE();
    case 84:
      if (lookahead == 'i') ADVANCE(143);
      END_STATE();
    case 85:
      if (lookahead == 's') ADVANCE(144);
      END_STATE();
    case 86:
      if (lookahead == 'p') ADVANCE(145);
      END_STATE();
    case 87:
      if (lookahead == 's') ADVANCE(146);
      END_STATE();
    case 88:
      if (lookahead == 'a') ADVANCE(147);
      END_STATE();
    case 89:
      if (lookahead == 'e') ADVANCE(148);
      END_STATE();
    case 90:
      if (lookahead == 'e') ADVANCE(149);
      END_STATE();
    case 91:
      if (lookahead == 'n') ADVANCE(150);
      END_STATE();
    case 92:
      if (lookahead == 'f') ADVANCE(151);
      END_STATE();
    case 93:
      if (lookahead == 'e') ADVANCE(152);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 95:
      if (lookahead == 'm') ADVANCE(153);
      END_STATE();
    case 96:
      if (lookahead == 'a') ADVANCE(154);
      END_STATE();
    case 97:
      if (lookahead == 'n') ADVANCE(155);
      END_STATE();
    case 98:
      if (lookahead == 'e') ADVANCE(156);
      END_STATE();
    case 99:
      if (lookahead == 's') ADVANCE(157);
      END_STATE();
    case 100:
      if (lookahead == 'l') ADVANCE(158);
      END_STATE();
    case 101:
      if (lookahead == 'a') ADVANCE(159);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_fun);
      if (lookahead == 'c') ADVANCE(160);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 105:
      if (lookahead == 'b') ADVANCE(161);
      END_STATE();
    case 106:
      if (lookahead == 'e') ADVANCE(162);
      END_STATE();
    case 107:
      if (lookahead == 'i') ADVANCE(163);
      END_STATE();
    case 108:
      if (lookahead == 'e') ADVANCE(164);
      END_STATE();
    case 109:
      if (lookahead == 'y') ADVANCE(165);
      END_STATE();
    case 110:
      if (lookahead == 'c') ADVANCE(166);
      END_STATE();
    case 111:
      if (lookahead == 'b') ADVANCE(167);
      END_STATE();
    case 112:
      if (lookahead == 'u') ADVANCE(168);
      END_STATE();
    case 113:
      if (lookahead == 'a') ADVANCE(169);
      END_STATE();
    case 114:
      if (lookahead == 'e') ADVANCE(170);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 117:
      if (lookahead == 'l') ADVANCE(171);
      END_STATE();
    case 118:
      if (lookahead == 'n') ADVANCE(172);
      END_STATE();
    case 119:
      if (lookahead == 'r') ADVANCE(173);
      END_STATE();
    case 120:
      if (lookahead == 'a') ADVANCE(174);
      END_STATE();
    case 121:
      if (lookahead == 'v') ADVANCE(175);
      END_STATE();
    case 122:
      if (lookahead == 'p') ADVANCE(176);
      END_STATE();
    case 123:
      if (lookahead == 'l') ADVANCE(177);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_rec);
      END_STATE();
    case 125:
      if (lookahead == 'u') ADVANCE(178);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 127:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 128:
      if (lookahead == 'u') ADVANCE(180);
      END_STATE();
    case 129:
      if (lookahead == 'n') ADVANCE(181);
      END_STATE();
    case 130:
      if (lookahead == 'e') ADVANCE(182);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 132:
      if (lookahead == 'e') ADVANCE(183);
      END_STATE();
    case 133:
      if (lookahead == 't') ADVANCE(184);
      END_STATE();
    case 134:
      if (lookahead == 'a') ADVANCE(185);
      END_STATE();
    case 135:
      if (lookahead == 'a') ADVANCE(186);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_use);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_val);
      END_STATE();
    case 138:
      if (lookahead == 'l') ADVANCE(187);
      END_STATE();
    case 139:
      if (lookahead == 'h') ADVANCE(188);
      END_STATE();
    case 140:
      if (lookahead == 'l') ADVANCE(189);
      END_STATE();
    case 141:
      if (lookahead == 'r') ADVANCE(190);
      END_STATE();
    case 142:
      if (lookahead == 'm') ADVANCE(191);
      if (lookahead == 'r') ADVANCE(192);
      END_STATE();
    case 143:
      if (lookahead == 'n') ADVANCE(193);
      END_STATE();
    case 144:
      if (lookahead == 's') ADVANCE(194);
      END_STATE();
    case 145:
      if (lookahead == 'a') ADVANCE(195);
      END_STATE();
    case 146:
      if (lookahead == 't') ADVANCE(196);
      END_STATE();
    case 147:
      if (lookahead == 'u') ADVANCE(197);
      END_STATE();
    case 148:
      if (lookahead == 'g') ADVANCE(198);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_done);
      END_STATE();
    case 150:
      if (lookahead == 'c') ADVANCE(199);
      if (lookahead == 't') ADVANCE(200);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 154:
      if (lookahead == 'l') ADVANCE(201);
      END_STATE();
    case 155:
      if (lookahead == 't') ADVANCE(202);
      END_STATE();
    case 156:
      if (lookahead == 'p') ADVANCE(203);
      END_STATE();
    case 157:
      if (lookahead == 'e') ADVANCE(182);
      END_STATE();
    case 158:
      if (lookahead == 'd') ADVANCE(204);
      END_STATE();
    case 159:
      if (lookahead == 'l') ADVANCE(205);
      END_STATE();
    case 160:
      if (lookahead == 't') ADVANCE(206);
      END_STATE();
    case 161:
      if (lookahead == 'a') ADVANCE(207);
      END_STATE();
    case 162:
      if (lookahead == 'r') ADVANCE(208);
      END_STATE();
    case 163:
      if (lookahead == 'n') ADVANCE(209);
      END_STATE();
    case 164:
      if (lookahead == 'r') ADVANCE(210);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_lazy);
      END_STATE();
    case 166:
      if (lookahead == 'h') ADVANCE(211);
      END_STATE();
    case 167:
      if (lookahead == 'e') ADVANCE(212);
      END_STATE();
    case 168:
      if (lookahead == 'l') ADVANCE(213);
      END_STATE();
    case 169:
      if (lookahead == 'b') ADVANCE(214);
      END_STATE();
    case 170:
      if (lookahead == 's') ADVANCE(215);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_null);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_open);
      END_STATE();
    case 173:
      if (lookahead == 'r') ADVANCE(216);
      END_STATE();
    case 174:
      if (lookahead == 'm') ADVANCE(217);
      END_STATE();
    case 175:
      if (lookahead == 'a') ADVANCE(218);
      END_STATE();
    case 176:
      if (lookahead == 'e') ADVANCE(219);
      END_STATE();
    case 177:
      if (lookahead == 'i') ADVANCE(220);
      END_STATE();
    case 178:
      if (lookahead == 'r') ADVANCE(221);
      END_STATE();
    case 179:
      if (lookahead == 'i') ADVANCE(222);
      END_STATE();
    case 180:
      if (lookahead == 'c') ADVANCE(223);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_bool);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_unit);
      END_STATE();
    case 185:
      if (lookahead == 'n') ADVANCE(224);
      END_STATE();
    case 186:
      if (lookahead == 's') ADVANCE(225);
      END_STATE();
    case 187:
      if (lookahead == 'e') ADVANCE(226);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 189:
      if (lookahead == 'd') ADVANCE(227);
      END_STATE();
    case 190:
      if (lookahead == 'a') ADVANCE(228);
      END_STATE();
    case 191:
      if (lookahead == 'b') ADVANCE(229);
      END_STATE();
    case 192:
      if (lookahead == 't') ADVANCE(230);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_begin);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 195:
      if (lookahead == 'r') ADVANCE(231);
      END_STATE();
    case 196:
      if (lookahead == 'r') ADVANCE(232);
      END_STATE();
    case 197:
      if (lookahead == 'l') ADVANCE(233);
      END_STATE();
    case 198:
      if (lookahead == 'a') ADVANCE(234);
      END_STATE();
    case 199:
      if (lookahead == 'a') ADVANCE(235);
      END_STATE();
    case 200:
      if (lookahead == 'o') ADVANCE(236);
      END_STATE();
    case 201:
      if (lookahead == 'i') ADVANCE(237);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_event);
      END_STATE();
    case 203:
      if (lookahead == 't') ADVANCE(238);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_field);
      END_STATE();
    case 205:
      if (lookahead == 'l') ADVANCE(239);
      END_STATE();
    case 206:
      if (lookahead == 'i') ADVANCE(240);
      END_STATE();
    case 207:
      if (lookahead == 'l') ADVANCE(241);
      END_STATE();
    case 208:
      if (lookahead == 'i') ADVANCE(242);
      END_STATE();
    case 209:
      if (lookahead == 'e') ADVANCE(243);
      END_STATE();
    case 210:
      if (lookahead == 'f') ADVANCE(244);
      if (lookahead == 'n') ADVANCE(245);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_match);
      END_STATE();
    case 212:
      if (lookahead == 'r') ADVANCE(246);
      END_STATE();
    case 213:
      if (lookahead == 'e') ADVANCE(247);
      END_STATE();
    case 214:
      if (lookahead == 'l') ADVANCE(248);
      END_STATE();
    case 215:
      if (lookahead == 'p') ADVANCE(249);
      END_STATE();
    case 216:
      if (lookahead == 'i') ADVANCE(250);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_param);
      END_STATE();
    case 218:
      if (lookahead == 't') ADVANCE(251);
      END_STATE();
    case 219:
      if (lookahead == 'r') ADVANCE(252);
      END_STATE();
    case 220:
      if (lookahead == 'c') ADVANCE(253);
      END_STATE();
    case 221:
      if (lookahead == 'n') ADVANCE(254);
      END_STATE();
    case 222:
      if (lookahead == 'c') ADVANCE(255);
      END_STATE();
    case 223:
      if (lookahead == 't') ADVANCE(256);
      END_STATE();
    case 224:
      if (lookahead == 'a') ADVANCE(257);
      END_STATE();
    case 225:
      if (lookahead == 't') ADVANCE(258);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 228:
      if (lookahead == 'c') ADVANCE(259);
      END_STATE();
    case 229:
      if (lookahead == 'l') ADVANCE(260);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(anon_sym_assert);
      END_STATE();
    case 231:
      if (lookahead == 'i') ADVANCE(261);
      END_STATE();
    case 232:
      if (lookahead == 'u') ADVANCE(262);
      END_STATE();
    case 233:
      if (lookahead == 't') ADVANCE(263);
      END_STATE();
    case 234:
      if (lookahead == 't') ADVANCE(264);
      END_STATE();
    case 235:
      if (lookahead == 's') ADVANCE(265);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(anon_sym_downto);
      END_STATE();
    case 237:
      if (lookahead == 't') ADVANCE(266);
      END_STATE();
    case 238:
      if (lookahead == 'i') ADVANCE(267);
      END_STATE();
    case 239:
      if (lookahead == 'y') ADVANCE(268);
      END_STATE();
    case 240:
      if (lookahead == 'o') ADVANCE(269);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 242:
      if (lookahead == 't') ADVANCE(270);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(anon_sym_inline);
      END_STATE();
    case 244:
      if (lookahead == 'a') ADVANCE(271);
      END_STATE();
    case 245:
      if (lookahead == 'a') ADVANCE(272);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_member);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 248:
      if (lookahead == 'e') ADVANCE(273);
      END_STATE();
    case 249:
      if (lookahead == 'a') ADVANCE(274);
      END_STATE();
    case 250:
      if (lookahead == 'd') ADVANCE(275);
      END_STATE();
    case 251:
      if (lookahead == 'e') ADVANCE(253);
      END_STATE();
    case 252:
      if (lookahead == 't') ADVANCE(276);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(aux_sym_access_modifier_token1);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 257:
      if (lookahead == 'g') ADVANCE(277);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_upcast);
      END_STATE();
    case 259:
      if (lookahead == 't') ADVANCE(278);
      END_STATE();
    case 260:
      if (lookahead == 'y') ADVANCE(279);
      END_STATE();
    case 261:
      if (lookahead == 's') ADVANCE(280);
      END_STATE();
    case 262:
      if (lookahead == 'c') ADVANCE(281);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 264:
      if (lookahead == 'e') ADVANCE(282);
      END_STATE();
    case 265:
      if (lookahead == 't') ADVANCE(283);
      END_STATE();
    case 266:
      if (lookahead == 'y') ADVANCE(284);
      END_STATE();
    case 267:
      if (lookahead == 'o') ADVANCE(285);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 269:
      if (lookahead == 'n') ADVANCE(286);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(anon_sym_inherit);
      END_STATE();
    case 271:
      if (lookahead == 'c') ADVANCE(287);
      END_STATE();
    case 272:
      if (lookahead == 'l') ADVANCE(253);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_mutable);
      END_STATE();
    case 274:
      if (lookahead == 'c') ADVANCE(288);
      END_STATE();
    case 275:
      if (lookahead == 'e') ADVANCE(289);
      END_STATE();
    case 276:
      if (lookahead == 'y') ADVANCE(290);
      END_STATE();
    case 277:
      if (lookahead == 'e') ADVANCE(291);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_assembly);
      END_STATE();
    case 280:
      if (lookahead == 'o') ADVANCE(292);
      END_STATE();
    case 281:
      if (lookahead == 't') ADVANCE(293);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(anon_sym_delegate);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(anon_sym_downcast);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(anon_sym_equality);
      END_STATE();
    case 285:
      if (lookahead == 'n') ADVANCE(294);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 287:
      if (lookahead == 'e') ADVANCE(295);
      END_STATE();
    case 288:
      if (lookahead == 'e') ADVANCE(296);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_property);
      END_STATE();
    case 291:
      if (lookahead == 'd') ADVANCE(297);
      END_STATE();
    case 292:
      if (lookahead == 'n') ADVANCE(298);
      END_STATE();
    case 293:
      if (lookahead == 'o') ADVANCE(299);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(anon_sym_exception);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(anon_sym_unmanaged);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_comparison);
      END_STATE();
    case 299:
      if (lookahead == 'r') ADVANCE(300);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(anon_sym_constructor);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 344, .external_lex_state = 2},
  [2] = {.lex_state = 335, .external_lex_state = 3},
  [3] = {.lex_state = 335, .external_lex_state = 3},
  [4] = {.lex_state = 335, .external_lex_state = 3},
  [5] = {.lex_state = 335, .external_lex_state = 3},
  [6] = {.lex_state = 335, .external_lex_state = 3},
  [7] = {.lex_state = 335, .external_lex_state = 3},
  [8] = {.lex_state = 335, .external_lex_state = 3},
  [9] = {.lex_state = 335, .external_lex_state = 3},
  [10] = {.lex_state = 335, .external_lex_state = 3},
  [11] = {.lex_state = 335, .external_lex_state = 3},
  [12] = {.lex_state = 335, .external_lex_state = 3},
  [13] = {.lex_state = 335, .external_lex_state = 3},
  [14] = {.lex_state = 335, .external_lex_state = 3},
  [15] = {.lex_state = 335, .external_lex_state = 3},
  [16] = {.lex_state = 335, .external_lex_state = 3},
  [17] = {.lex_state = 335, .external_lex_state = 3},
  [18] = {.lex_state = 335, .external_lex_state = 3},
  [19] = {.lex_state = 335, .external_lex_state = 3},
  [20] = {.lex_state = 335, .external_lex_state = 3},
  [21] = {.lex_state = 335, .external_lex_state = 3},
  [22] = {.lex_state = 335, .external_lex_state = 3},
  [23] = {.lex_state = 335, .external_lex_state = 3},
  [24] = {.lex_state = 335, .external_lex_state = 4},
  [25] = {.lex_state = 335, .external_lex_state = 4},
  [26] = {.lex_state = 335, .external_lex_state = 4},
  [27] = {.lex_state = 335, .external_lex_state = 4},
  [28] = {.lex_state = 335, .external_lex_state = 4},
  [29] = {.lex_state = 335, .external_lex_state = 4},
  [30] = {.lex_state = 335, .external_lex_state = 4},
  [31] = {.lex_state = 335, .external_lex_state = 4},
  [32] = {.lex_state = 335, .external_lex_state = 4},
  [33] = {.lex_state = 335, .external_lex_state = 5},
  [34] = {.lex_state = 335, .external_lex_state = 5},
  [35] = {.lex_state = 335, .external_lex_state = 5},
  [36] = {.lex_state = 335, .external_lex_state = 5},
  [37] = {.lex_state = 335, .external_lex_state = 4},
  [38] = {.lex_state = 335, .external_lex_state = 5},
  [39] = {.lex_state = 335, .external_lex_state = 4},
  [40] = {.lex_state = 335, .external_lex_state = 5},
  [41] = {.lex_state = 335, .external_lex_state = 5},
  [42] = {.lex_state = 335, .external_lex_state = 5},
  [43] = {.lex_state = 335, .external_lex_state = 5},
  [44] = {.lex_state = 335, .external_lex_state = 5},
  [45] = {.lex_state = 335, .external_lex_state = 5},
  [46] = {.lex_state = 335, .external_lex_state = 6},
  [47] = {.lex_state = 335, .external_lex_state = 7},
  [48] = {.lex_state = 335, .external_lex_state = 8},
  [49] = {.lex_state = 335, .external_lex_state = 6},
  [50] = {.lex_state = 335, .external_lex_state = 7},
  [51] = {.lex_state = 335, .external_lex_state = 6},
  [52] = {.lex_state = 335, .external_lex_state = 8},
  [53] = {.lex_state = 335, .external_lex_state = 6},
  [54] = {.lex_state = 335, .external_lex_state = 6},
  [55] = {.lex_state = 335, .external_lex_state = 6},
  [56] = {.lex_state = 335, .external_lex_state = 7},
  [57] = {.lex_state = 335, .external_lex_state = 7},
  [58] = {.lex_state = 335, .external_lex_state = 8},
  [59] = {.lex_state = 335, .external_lex_state = 7},
  [60] = {.lex_state = 335, .external_lex_state = 7},
  [61] = {.lex_state = 335, .external_lex_state = 8},
  [62] = {.lex_state = 335, .external_lex_state = 8},
  [63] = {.lex_state = 335, .external_lex_state = 7},
  [64] = {.lex_state = 335, .external_lex_state = 8},
  [65] = {.lex_state = 335, .external_lex_state = 7},
  [66] = {.lex_state = 335, .external_lex_state = 7},
  [67] = {.lex_state = 335, .external_lex_state = 8},
  [68] = {.lex_state = 335, .external_lex_state = 6},
  [69] = {.lex_state = 335, .external_lex_state = 8},
  [70] = {.lex_state = 335, .external_lex_state = 6},
  [71] = {.lex_state = 335, .external_lex_state = 6},
  [72] = {.lex_state = 335, .external_lex_state = 7},
  [73] = {.lex_state = 335, .external_lex_state = 8},
  [74] = {.lex_state = 335, .external_lex_state = 7},
  [75] = {.lex_state = 335, .external_lex_state = 8},
  [76] = {.lex_state = 335, .external_lex_state = 6},
  [77] = {.lex_state = 335, .external_lex_state = 6},
  [78] = {.lex_state = 335, .external_lex_state = 8},
  [79] = {.lex_state = 335, .external_lex_state = 9},
  [80] = {.lex_state = 335, .external_lex_state = 9},
  [81] = {.lex_state = 335, .external_lex_state = 9},
  [82] = {.lex_state = 335, .external_lex_state = 9},
  [83] = {.lex_state = 335, .external_lex_state = 9},
  [84] = {.lex_state = 335, .external_lex_state = 9},
  [85] = {.lex_state = 335, .external_lex_state = 9},
  [86] = {.lex_state = 335, .external_lex_state = 9},
  [87] = {.lex_state = 335, .external_lex_state = 9},
  [88] = {.lex_state = 335, .external_lex_state = 9},
  [89] = {.lex_state = 335, .external_lex_state = 9},
  [90] = {.lex_state = 335, .external_lex_state = 9},
  [91] = {.lex_state = 335, .external_lex_state = 9},
  [92] = {.lex_state = 335, .external_lex_state = 9},
  [93] = {.lex_state = 335, .external_lex_state = 9},
  [94] = {.lex_state = 335, .external_lex_state = 9},
  [95] = {.lex_state = 335, .external_lex_state = 9},
  [96] = {.lex_state = 335, .external_lex_state = 10},
  [97] = {.lex_state = 335, .external_lex_state = 10},
  [98] = {.lex_state = 335, .external_lex_state = 10},
  [99] = {.lex_state = 335, .external_lex_state = 10},
  [100] = {.lex_state = 335, .external_lex_state = 10},
  [101] = {.lex_state = 335, .external_lex_state = 10},
  [102] = {.lex_state = 335, .external_lex_state = 10},
  [103] = {.lex_state = 335, .external_lex_state = 10},
  [104] = {.lex_state = 335, .external_lex_state = 10},
  [105] = {.lex_state = 335, .external_lex_state = 10},
  [106] = {.lex_state = 335, .external_lex_state = 10},
  [107] = {.lex_state = 335, .external_lex_state = 10},
  [108] = {.lex_state = 335, .external_lex_state = 10},
  [109] = {.lex_state = 335, .external_lex_state = 10},
  [110] = {.lex_state = 335, .external_lex_state = 10},
  [111] = {.lex_state = 335, .external_lex_state = 10},
  [112] = {.lex_state = 335, .external_lex_state = 10},
  [113] = {.lex_state = 335, .external_lex_state = 10},
  [114] = {.lex_state = 335, .external_lex_state = 10},
  [115] = {.lex_state = 335, .external_lex_state = 10},
  [116] = {.lex_state = 335, .external_lex_state = 10},
  [117] = {.lex_state = 335, .external_lex_state = 10},
  [118] = {.lex_state = 335, .external_lex_state = 10},
  [119] = {.lex_state = 335, .external_lex_state = 10},
  [120] = {.lex_state = 335, .external_lex_state = 10},
  [121] = {.lex_state = 335, .external_lex_state = 10},
  [122] = {.lex_state = 335, .external_lex_state = 10},
  [123] = {.lex_state = 335, .external_lex_state = 10},
  [124] = {.lex_state = 335, .external_lex_state = 10},
  [125] = {.lex_state = 99, .external_lex_state = 9},
  [126] = {.lex_state = 99, .external_lex_state = 9},
  [127] = {.lex_state = 99, .external_lex_state = 9},
  [128] = {.lex_state = 335, .external_lex_state = 4},
  [129] = {.lex_state = 99, .external_lex_state = 10},
  [130] = {.lex_state = 99, .external_lex_state = 9},
  [131] = {.lex_state = 335, .external_lex_state = 9},
  [132] = {.lex_state = 335, .external_lex_state = 4},
  [133] = {.lex_state = 99, .external_lex_state = 9},
  [134] = {.lex_state = 99, .external_lex_state = 9},
  [135] = {.lex_state = 335, .external_lex_state = 4},
  [136] = {.lex_state = 99, .external_lex_state = 9},
  [137] = {.lex_state = 99, .external_lex_state = 9},
  [138] = {.lex_state = 99, .external_lex_state = 9},
  [139] = {.lex_state = 99, .external_lex_state = 9},
  [140] = {.lex_state = 335, .external_lex_state = 4},
  [141] = {.lex_state = 335, .external_lex_state = 10},
  [142] = {.lex_state = 335, .external_lex_state = 9},
  [143] = {.lex_state = 335, .external_lex_state = 6},
  [144] = {.lex_state = 335, .external_lex_state = 6},
  [145] = {.lex_state = 335, .external_lex_state = 6},
  [146] = {.lex_state = 335, .external_lex_state = 9},
  [147] = {.lex_state = 335, .external_lex_state = 10},
  [148] = {.lex_state = 335, .external_lex_state = 9},
  [149] = {.lex_state = 335, .external_lex_state = 9},
  [150] = {.lex_state = 335, .external_lex_state = 9},
  [151] = {.lex_state = 335, .external_lex_state = 9},
  [152] = {.lex_state = 335, .external_lex_state = 10},
  [153] = {.lex_state = 335, .external_lex_state = 9},
  [154] = {.lex_state = 335, .external_lex_state = 6},
  [155] = {.lex_state = 335, .external_lex_state = 9},
  [156] = {.lex_state = 99, .external_lex_state = 10},
  [157] = {.lex_state = 335, .external_lex_state = 10},
  [158] = {.lex_state = 100, .external_lex_state = 10},
  [159] = {.lex_state = 335, .external_lex_state = 4},
  [160] = {.lex_state = 335, .external_lex_state = 6},
  [161] = {.lex_state = 335, .external_lex_state = 10},
  [162] = {.lex_state = 335, .external_lex_state = 9},
  [163] = {.lex_state = 335, .external_lex_state = 10},
  [164] = {.lex_state = 335, .external_lex_state = 6},
  [165] = {.lex_state = 335, .external_lex_state = 10},
  [166] = {.lex_state = 335, .external_lex_state = 10},
  [167] = {.lex_state = 335, .external_lex_state = 10},
  [168] = {.lex_state = 335, .external_lex_state = 10},
  [169] = {.lex_state = 335, .external_lex_state = 9},
  [170] = {.lex_state = 335, .external_lex_state = 10},
  [171] = {.lex_state = 335, .external_lex_state = 4},
  [172] = {.lex_state = 335, .external_lex_state = 9},
  [173] = {.lex_state = 335, .external_lex_state = 6},
  [174] = {.lex_state = 335, .external_lex_state = 10},
  [175] = {.lex_state = 335, .external_lex_state = 9},
  [176] = {.lex_state = 335, .external_lex_state = 10},
  [177] = {.lex_state = 335, .external_lex_state = 9},
  [178] = {.lex_state = 335, .external_lex_state = 10},
  [179] = {.lex_state = 335, .external_lex_state = 10},
  [180] = {.lex_state = 335, .external_lex_state = 10},
  [181] = {.lex_state = 335, .external_lex_state = 9},
  [182] = {.lex_state = 335, .external_lex_state = 10},
  [183] = {.lex_state = 335, .external_lex_state = 4},
  [184] = {.lex_state = 100, .external_lex_state = 10},
  [185] = {.lex_state = 100, .external_lex_state = 10},
  [186] = {.lex_state = 335, .external_lex_state = 6},
  [187] = {.lex_state = 100, .external_lex_state = 10},
  [188] = {.lex_state = 335, .external_lex_state = 4},
  [189] = {.lex_state = 100, .external_lex_state = 10},
  [190] = {.lex_state = 335, .external_lex_state = 10},
  [191] = {.lex_state = 100, .external_lex_state = 10},
  [192] = {.lex_state = 335, .external_lex_state = 10},
  [193] = {.lex_state = 335, .external_lex_state = 9},
  [194] = {.lex_state = 335, .external_lex_state = 6},
  [195] = {.lex_state = 335, .external_lex_state = 10},
  [196] = {.lex_state = 335, .external_lex_state = 9},
  [197] = {.lex_state = 100, .external_lex_state = 10},
  [198] = {.lex_state = 335, .external_lex_state = 10},
  [199] = {.lex_state = 100, .external_lex_state = 10},
  [200] = {.lex_state = 335, .external_lex_state = 10},
  [201] = {.lex_state = 100, .external_lex_state = 10},
  [202] = {.lex_state = 335, .external_lex_state = 10},
  [203] = {.lex_state = 335, .external_lex_state = 4},
  [204] = {.lex_state = 335, .external_lex_state = 4},
  [205] = {.lex_state = 335, .external_lex_state = 10},
  [206] = {.lex_state = 335, .external_lex_state = 4},
  [207] = {.lex_state = 335, .external_lex_state = 9},
  [208] = {.lex_state = 335, .external_lex_state = 10},
  [209] = {.lex_state = 335, .external_lex_state = 9},
  [210] = {.lex_state = 335, .external_lex_state = 10},
  [211] = {.lex_state = 335, .external_lex_state = 9},
  [212] = {.lex_state = 100, .external_lex_state = 10},
  [213] = {.lex_state = 99, .external_lex_state = 10},
  [214] = {.lex_state = 335, .external_lex_state = 4},
  [215] = {.lex_state = 335, .external_lex_state = 10},
  [216] = {.lex_state = 99, .external_lex_state = 10},
  [217] = {.lex_state = 335, .external_lex_state = 9},
  [218] = {.lex_state = 99, .external_lex_state = 10},
  [219] = {.lex_state = 335, .external_lex_state = 10},
  [220] = {.lex_state = 335, .external_lex_state = 10},
  [221] = {.lex_state = 99, .external_lex_state = 10},
  [222] = {.lex_state = 335, .external_lex_state = 10},
  [223] = {.lex_state = 335, .external_lex_state = 4},
  [224] = {.lex_state = 335, .external_lex_state = 10},
  [225] = {.lex_state = 335, .external_lex_state = 10},
  [226] = {.lex_state = 335, .external_lex_state = 4},
  [227] = {.lex_state = 100, .external_lex_state = 10},
  [228] = {.lex_state = 335, .external_lex_state = 10},
  [229] = {.lex_state = 335, .external_lex_state = 4},
  [230] = {.lex_state = 335, .external_lex_state = 10},
  [231] = {.lex_state = 335, .external_lex_state = 10},
  [232] = {.lex_state = 100, .external_lex_state = 10},
  [233] = {.lex_state = 335, .external_lex_state = 6},
  [234] = {.lex_state = 335, .external_lex_state = 9},
  [235] = {.lex_state = 335, .external_lex_state = 10},
  [236] = {.lex_state = 335, .external_lex_state = 10},
  [237] = {.lex_state = 335, .external_lex_state = 10},
  [238] = {.lex_state = 335, .external_lex_state = 10},
  [239] = {.lex_state = 99, .external_lex_state = 10},
  [240] = {.lex_state = 335, .external_lex_state = 10},
  [241] = {.lex_state = 335, .external_lex_state = 6},
  [242] = {.lex_state = 335, .external_lex_state = 9},
  [243] = {.lex_state = 335, .external_lex_state = 10},
  [244] = {.lex_state = 99, .external_lex_state = 10},
  [245] = {.lex_state = 99, .external_lex_state = 10},
  [246] = {.lex_state = 335, .external_lex_state = 9},
  [247] = {.lex_state = 335, .external_lex_state = 10},
  [248] = {.lex_state = 99, .external_lex_state = 10},
  [249] = {.lex_state = 335, .external_lex_state = 9},
  [250] = {.lex_state = 335, .external_lex_state = 9},
  [251] = {.lex_state = 335, .external_lex_state = 9},
  [252] = {.lex_state = 335, .external_lex_state = 8},
  [253] = {.lex_state = 335, .external_lex_state = 9},
  [254] = {.lex_state = 103, .external_lex_state = 10},
  [255] = {.lex_state = 335, .external_lex_state = 10},
  [256] = {.lex_state = 100, .external_lex_state = 10},
  [257] = {.lex_state = 100, .external_lex_state = 10},
  [258] = {.lex_state = 335, .external_lex_state = 9},
  [259] = {.lex_state = 335, .external_lex_state = 10},
  [260] = {.lex_state = 92, .external_lex_state = 10},
  [261] = {.lex_state = 338, .external_lex_state = 10},
  [262] = {.lex_state = 338, .external_lex_state = 10},
  [263] = {.lex_state = 335, .external_lex_state = 10},
  [264] = {.lex_state = 335, .external_lex_state = 8},
  [265] = {.lex_state = 338, .external_lex_state = 10},
  [266] = {.lex_state = 103, .external_lex_state = 10},
  [267] = {.lex_state = 104, .external_lex_state = 10},
  [268] = {.lex_state = 335, .external_lex_state = 9},
  [269] = {.lex_state = 335, .external_lex_state = 9},
  [270] = {.lex_state = 335, .external_lex_state = 9},
  [271] = {.lex_state = 100, .external_lex_state = 10},
  [272] = {.lex_state = 92, .external_lex_state = 10},
  [273] = {.lex_state = 335, .external_lex_state = 10},
  [274] = {.lex_state = 335, .external_lex_state = 10},
  [275] = {.lex_state = 104, .external_lex_state = 10},
  [276] = {.lex_state = 100, .external_lex_state = 10},
  [277] = {.lex_state = 335, .external_lex_state = 9},
  [278] = {.lex_state = 338, .external_lex_state = 10},
  [279] = {.lex_state = 335, .external_lex_state = 9},
  [280] = {.lex_state = 338, .external_lex_state = 10},
  [281] = {.lex_state = 335, .external_lex_state = 9},
  [282] = {.lex_state = 104, .external_lex_state = 10},
  [283] = {.lex_state = 100, .external_lex_state = 10},
  [284] = {.lex_state = 104, .external_lex_state = 10},
  [285] = {.lex_state = 103, .external_lex_state = 10},
  [286] = {.lex_state = 104, .external_lex_state = 10},
  [287] = {.lex_state = 104, .external_lex_state = 10},
  [288] = {.lex_state = 335, .external_lex_state = 9},
  [289] = {.lex_state = 338, .external_lex_state = 10},
  [290] = {.lex_state = 335, .external_lex_state = 9},
  [291] = {.lex_state = 104, .external_lex_state = 10},
  [292] = {.lex_state = 335, .external_lex_state = 10},
  [293] = {.lex_state = 335, .external_lex_state = 10},
  [294] = {.lex_state = 338, .external_lex_state = 10},
  [295] = {.lex_state = 104, .external_lex_state = 10},
  [296] = {.lex_state = 335, .external_lex_state = 9},
  [297] = {.lex_state = 104, .external_lex_state = 10},
  [298] = {.lex_state = 335, .external_lex_state = 9},
  [299] = {.lex_state = 338, .external_lex_state = 10},
  [300] = {.lex_state = 103, .external_lex_state = 10},
  [301] = {.lex_state = 103, .external_lex_state = 10},
  [302] = {.lex_state = 100, .external_lex_state = 10},
  [303] = {.lex_state = 100, .external_lex_state = 10},
  [304] = {.lex_state = 103, .external_lex_state = 10},
  [305] = {.lex_state = 103, .external_lex_state = 10},
  [306] = {.lex_state = 103, .external_lex_state = 10},
  [307] = {.lex_state = 335, .external_lex_state = 10},
  [308] = {.lex_state = 338, .external_lex_state = 10},
  [309] = {.lex_state = 104, .external_lex_state = 10},
  [310] = {.lex_state = 338, .external_lex_state = 10},
  [311] = {.lex_state = 335, .external_lex_state = 9},
  [312] = {.lex_state = 338, .external_lex_state = 10},
  [313] = {.lex_state = 335, .external_lex_state = 9},
  [314] = {.lex_state = 100, .external_lex_state = 10},
  [315] = {.lex_state = 92, .external_lex_state = 10},
  [316] = {.lex_state = 104, .external_lex_state = 10},
  [317] = {.lex_state = 335, .external_lex_state = 10},
  [318] = {.lex_state = 338, .external_lex_state = 10},
  [319] = {.lex_state = 103, .external_lex_state = 10},
  [320] = {.lex_state = 92, .external_lex_state = 10},
  [321] = {.lex_state = 335, .external_lex_state = 8},
  [322] = {.lex_state = 103, .external_lex_state = 10},
  [323] = {.lex_state = 335, .external_lex_state = 10},
  [324] = {.lex_state = 104, .external_lex_state = 10},
  [325] = {.lex_state = 100, .external_lex_state = 10},
  [326] = {.lex_state = 335, .external_lex_state = 8},
  [327] = {.lex_state = 335, .external_lex_state = 9},
  [328] = {.lex_state = 335, .external_lex_state = 9},
  [329] = {.lex_state = 335, .external_lex_state = 9},
  [330] = {.lex_state = 335, .external_lex_state = 9},
  [331] = {.lex_state = 335, .external_lex_state = 9},
  [332] = {.lex_state = 338, .external_lex_state = 10},
  [333] = {.lex_state = 335, .external_lex_state = 8},
  [334] = {.lex_state = 335, .external_lex_state = 9},
  [335] = {.lex_state = 335, .external_lex_state = 9},
  [336] = {.lex_state = 335, .external_lex_state = 9},
  [337] = {.lex_state = 338, .external_lex_state = 10},
  [338] = {.lex_state = 92, .external_lex_state = 10},
  [339] = {.lex_state = 103, .external_lex_state = 10},
  [340] = {.lex_state = 335, .external_lex_state = 10},
  [341] = {.lex_state = 335, .external_lex_state = 9},
  [342] = {.lex_state = 100, .external_lex_state = 10},
  [343] = {.lex_state = 335, .external_lex_state = 9},
  [344] = {.lex_state = 335, .external_lex_state = 9},
  [345] = {.lex_state = 104, .external_lex_state = 10},
  [346] = {.lex_state = 103, .external_lex_state = 10},
  [347] = {.lex_state = 335, .external_lex_state = 9},
  [348] = {.lex_state = 104, .external_lex_state = 10},
  [349] = {.lex_state = 335, .external_lex_state = 10},
  [350] = {.lex_state = 92, .external_lex_state = 10},
  [351] = {.lex_state = 335, .external_lex_state = 9},
  [352] = {.lex_state = 335, .external_lex_state = 9},
  [353] = {.lex_state = 335, .external_lex_state = 9},
  [354] = {.lex_state = 103, .external_lex_state = 10},
  [355] = {.lex_state = 338, .external_lex_state = 10},
  [356] = {.lex_state = 103, .external_lex_state = 10},
  [357] = {.lex_state = 335, .external_lex_state = 9},
  [358] = {.lex_state = 338, .external_lex_state = 10},
  [359] = {.lex_state = 92, .external_lex_state = 10},
  [360] = {.lex_state = 335, .external_lex_state = 9},
  [361] = {.lex_state = 100, .external_lex_state = 10},
  [362] = {.lex_state = 335, .external_lex_state = 9},
  [363] = {.lex_state = 335, .external_lex_state = 9},
  [364] = {.lex_state = 335, .external_lex_state = 10},
  [365] = {.lex_state = 335, .external_lex_state = 9},
  [366] = {.lex_state = 335, .external_lex_state = 9},
  [367] = {.lex_state = 335, .external_lex_state = 9},
  [368] = {.lex_state = 335, .external_lex_state = 10},
  [369] = {.lex_state = 335, .external_lex_state = 9},
  [370] = {.lex_state = 103, .external_lex_state = 10},
  [371] = {.lex_state = 92, .external_lex_state = 10},
  [372] = {.lex_state = 335, .external_lex_state = 9},
  [373] = {.lex_state = 338, .external_lex_state = 10},
  [374] = {.lex_state = 104, .external_lex_state = 10},
  [375] = {.lex_state = 335, .external_lex_state = 9},
  [376] = {.lex_state = 335, .external_lex_state = 9},
  [377] = {.lex_state = 335, .external_lex_state = 9},
  [378] = {.lex_state = 335, .external_lex_state = 9},
  [379] = {.lex_state = 100, .external_lex_state = 10},
  [380] = {.lex_state = 103, .external_lex_state = 10},
  [381] = {.lex_state = 335, .external_lex_state = 9},
  [382] = {.lex_state = 335, .external_lex_state = 9},
  [383] = {.lex_state = 100, .external_lex_state = 10},
  [384] = {.lex_state = 335, .external_lex_state = 9},
  [385] = {.lex_state = 335, .external_lex_state = 9},
  [386] = {.lex_state = 335, .external_lex_state = 10},
  [387] = {.lex_state = 335, .external_lex_state = 10},
  [388] = {.lex_state = 335, .external_lex_state = 9},
  [389] = {.lex_state = 335, .external_lex_state = 9},
  [390] = {.lex_state = 335, .external_lex_state = 9},
  [391] = {.lex_state = 335, .external_lex_state = 9},
  [392] = {.lex_state = 335, .external_lex_state = 9},
  [393] = {.lex_state = 103, .external_lex_state = 10},
  [394] = {.lex_state = 335, .external_lex_state = 8},
  [395] = {.lex_state = 335, .external_lex_state = 8},
  [396] = {.lex_state = 335, .external_lex_state = 9},
  [397] = {.lex_state = 104, .external_lex_state = 10},
  [398] = {.lex_state = 335, .external_lex_state = 9},
  [399] = {.lex_state = 335, .external_lex_state = 9},
  [400] = {.lex_state = 335, .external_lex_state = 8},
  [401] = {.lex_state = 338, .external_lex_state = 10},
  [402] = {.lex_state = 335, .external_lex_state = 9},
  [403] = {.lex_state = 100, .external_lex_state = 10},
  [404] = {.lex_state = 338, .external_lex_state = 10},
  [405] = {.lex_state = 338, .external_lex_state = 10},
  [406] = {.lex_state = 335, .external_lex_state = 9},
  [407] = {.lex_state = 100, .external_lex_state = 10},
  [408] = {.lex_state = 335, .external_lex_state = 9},
  [409] = {.lex_state = 335, .external_lex_state = 9},
  [410] = {.lex_state = 335, .external_lex_state = 9},
  [411] = {.lex_state = 335, .external_lex_state = 8},
  [412] = {.lex_state = 335, .external_lex_state = 9},
  [413] = {.lex_state = 335, .external_lex_state = 10},
  [414] = {.lex_state = 335, .external_lex_state = 9},
  [415] = {.lex_state = 335, .external_lex_state = 9},
  [416] = {.lex_state = 100, .external_lex_state = 10},
  [417] = {.lex_state = 335, .external_lex_state = 9},
  [418] = {.lex_state = 103, .external_lex_state = 10},
  [419] = {.lex_state = 104, .external_lex_state = 10},
  [420] = {.lex_state = 335, .external_lex_state = 9},
  [421] = {.lex_state = 338, .external_lex_state = 10},
  [422] = {.lex_state = 335, .external_lex_state = 8},
  [423] = {.lex_state = 335, .external_lex_state = 9},
  [424] = {.lex_state = 338, .external_lex_state = 10},
  [425] = {.lex_state = 335, .external_lex_state = 9},
  [426] = {.lex_state = 104, .external_lex_state = 10},
  [427] = {.lex_state = 335, .external_lex_state = 9},
  [428] = {.lex_state = 100, .external_lex_state = 10},
  [429] = {.lex_state = 103, .external_lex_state = 10},
  [430] = {.lex_state = 104, .external_lex_state = 10},
  [431] = {.lex_state = 335, .external_lex_state = 9},
  [432] = {.lex_state = 103, .external_lex_state = 10},
  [433] = {.lex_state = 335, .external_lex_state = 9},
  [434] = {.lex_state = 100, .external_lex_state = 10},
  [435] = {.lex_state = 335, .external_lex_state = 9},
  [436] = {.lex_state = 335, .external_lex_state = 9},
  [437] = {.lex_state = 335, .external_lex_state = 9},
  [438] = {.lex_state = 335, .external_lex_state = 9},
  [439] = {.lex_state = 103, .external_lex_state = 10},
  [440] = {.lex_state = 104, .external_lex_state = 10},
  [441] = {.lex_state = 335, .external_lex_state = 9},
  [442] = {.lex_state = 338, .external_lex_state = 10},
  [443] = {.lex_state = 335, .external_lex_state = 10},
  [444] = {.lex_state = 335, .external_lex_state = 9},
  [445] = {.lex_state = 335, .external_lex_state = 9},
  [446] = {.lex_state = 92, .external_lex_state = 10},
  [447] = {.lex_state = 335, .external_lex_state = 9},
  [448] = {.lex_state = 335, .external_lex_state = 9},
  [449] = {.lex_state = 335, .external_lex_state = 10},
  [450] = {.lex_state = 335, .external_lex_state = 10},
  [451] = {.lex_state = 103, .external_lex_state = 10},
  [452] = {.lex_state = 104, .external_lex_state = 10},
  [453] = {.lex_state = 335, .external_lex_state = 9},
  [454] = {.lex_state = 335, .external_lex_state = 9},
  [455] = {.lex_state = 335, .external_lex_state = 9},
  [456] = {.lex_state = 338, .external_lex_state = 10},
  [457] = {.lex_state = 100, .external_lex_state = 10},
  [458] = {.lex_state = 335, .external_lex_state = 9},
  [459] = {.lex_state = 335, .external_lex_state = 9},
  [460] = {.lex_state = 100, .external_lex_state = 10},
  [461] = {.lex_state = 103, .external_lex_state = 10},
  [462] = {.lex_state = 104, .external_lex_state = 10},
  [463] = {.lex_state = 335, .external_lex_state = 9},
  [464] = {.lex_state = 335, .external_lex_state = 9},
  [465] = {.lex_state = 335, .external_lex_state = 9},
  [466] = {.lex_state = 104, .external_lex_state = 10},
  [467] = {.lex_state = 103, .external_lex_state = 10},
  [468] = {.lex_state = 335, .external_lex_state = 9},
  [469] = {.lex_state = 92, .external_lex_state = 10},
  [470] = {.lex_state = 335, .external_lex_state = 9},
  [471] = {.lex_state = 100, .external_lex_state = 10},
  [472] = {.lex_state = 103, .external_lex_state = 10},
  [473] = {.lex_state = 104, .external_lex_state = 10},
  [474] = {.lex_state = 335, .external_lex_state = 9},
  [475] = {.lex_state = 335, .external_lex_state = 9},
  [476] = {.lex_state = 335, .external_lex_state = 9},
  [477] = {.lex_state = 338, .external_lex_state = 10},
  [478] = {.lex_state = 335, .external_lex_state = 10},
  [479] = {.lex_state = 335, .external_lex_state = 9},
  [480] = {.lex_state = 335, .external_lex_state = 8},
  [481] = {.lex_state = 335, .external_lex_state = 9},
  [482] = {.lex_state = 338, .external_lex_state = 10},
  [483] = {.lex_state = 335, .external_lex_state = 9},
  [484] = {.lex_state = 335, .external_lex_state = 9},
  [485] = {.lex_state = 338, .external_lex_state = 10},
  [486] = {.lex_state = 335, .external_lex_state = 9},
  [487] = {.lex_state = 100, .external_lex_state = 10},
  [488] = {.lex_state = 335, .external_lex_state = 9},
  [489] = {.lex_state = 338, .external_lex_state = 10},
  [490] = {.lex_state = 335, .external_lex_state = 9},
  [491] = {.lex_state = 100, .external_lex_state = 10},
  [492] = {.lex_state = 335, .external_lex_state = 9},
  [493] = {.lex_state = 335, .external_lex_state = 9},
  [494] = {.lex_state = 335, .external_lex_state = 9},
  [495] = {.lex_state = 335, .external_lex_state = 9},
  [496] = {.lex_state = 100, .external_lex_state = 10},
  [497] = {.lex_state = 335, .external_lex_state = 8},
  [498] = {.lex_state = 100, .external_lex_state = 10},
  [499] = {.lex_state = 338, .external_lex_state = 10},
  [500] = {.lex_state = 335, .external_lex_state = 9},
  [501] = {.lex_state = 100, .external_lex_state = 10},
  [502] = {.lex_state = 335, .external_lex_state = 9},
  [503] = {.lex_state = 104, .external_lex_state = 10},
  [504] = {.lex_state = 335, .external_lex_state = 9},
  [505] = {.lex_state = 100, .external_lex_state = 10},
  [506] = {.lex_state = 335, .external_lex_state = 9},
  [507] = {.lex_state = 335, .external_lex_state = 10},
  [508] = {.lex_state = 335, .external_lex_state = 10},
  [509] = {.lex_state = 335, .external_lex_state = 10},
  [510] = {.lex_state = 335, .external_lex_state = 10},
  [511] = {.lex_state = 335, .external_lex_state = 10},
  [512] = {.lex_state = 335, .external_lex_state = 10},
  [513] = {.lex_state = 335, .external_lex_state = 10},
  [514] = {.lex_state = 335, .external_lex_state = 10},
  [515] = {.lex_state = 335, .external_lex_state = 10},
  [516] = {.lex_state = 335, .external_lex_state = 10},
  [517] = {.lex_state = 335, .external_lex_state = 10},
  [518] = {.lex_state = 335, .external_lex_state = 10},
  [519] = {.lex_state = 335, .external_lex_state = 10},
  [520] = {.lex_state = 335, .external_lex_state = 10},
  [521] = {.lex_state = 335, .external_lex_state = 10},
  [522] = {.lex_state = 335, .external_lex_state = 10},
  [523] = {.lex_state = 335, .external_lex_state = 10},
  [524] = {.lex_state = 335, .external_lex_state = 10},
  [525] = {.lex_state = 335, .external_lex_state = 10},
  [526] = {.lex_state = 335, .external_lex_state = 10},
  [527] = {.lex_state = 335, .external_lex_state = 10},
  [528] = {.lex_state = 335, .external_lex_state = 10},
  [529] = {.lex_state = 335, .external_lex_state = 10},
  [530] = {.lex_state = 335, .external_lex_state = 10},
  [531] = {.lex_state = 335, .external_lex_state = 10},
  [532] = {.lex_state = 335, .external_lex_state = 10},
  [533] = {.lex_state = 335, .external_lex_state = 10},
  [534] = {.lex_state = 335, .external_lex_state = 10},
  [535] = {.lex_state = 335, .external_lex_state = 10},
  [536] = {.lex_state = 335, .external_lex_state = 10},
  [537] = {.lex_state = 335, .external_lex_state = 10},
  [538] = {.lex_state = 335, .external_lex_state = 10},
  [539] = {.lex_state = 335, .external_lex_state = 10},
  [540] = {.lex_state = 344, .external_lex_state = 4},
  [541] = {.lex_state = 344, .external_lex_state = 4},
  [542] = {.lex_state = 344, .external_lex_state = 4},
  [543] = {.lex_state = 344, .external_lex_state = 4},
  [544] = {.lex_state = 344, .external_lex_state = 2},
  [545] = {.lex_state = 344, .external_lex_state = 2},
  [546] = {.lex_state = 344, .external_lex_state = 2},
  [547] = {.lex_state = 344, .external_lex_state = 2},
  [548] = {.lex_state = 344, .external_lex_state = 2},
  [549] = {.lex_state = 344, .external_lex_state = 2},
  [550] = {.lex_state = 344, .external_lex_state = 2},
  [551] = {.lex_state = 344, .external_lex_state = 2},
  [552] = {.lex_state = 344, .external_lex_state = 2},
  [553] = {.lex_state = 344, .external_lex_state = 2},
  [554] = {.lex_state = 344, .external_lex_state = 2},
  [555] = {.lex_state = 344, .external_lex_state = 2},
  [556] = {.lex_state = 344, .external_lex_state = 2},
  [557] = {.lex_state = 344, .external_lex_state = 2},
  [558] = {.lex_state = 344, .external_lex_state = 2},
  [559] = {.lex_state = 344, .external_lex_state = 2},
  [560] = {.lex_state = 344, .external_lex_state = 2},
  [561] = {.lex_state = 344, .external_lex_state = 2},
  [562] = {.lex_state = 344, .external_lex_state = 2},
  [563] = {.lex_state = 344, .external_lex_state = 2},
  [564] = {.lex_state = 344, .external_lex_state = 2},
  [565] = {.lex_state = 344, .external_lex_state = 2},
  [566] = {.lex_state = 344, .external_lex_state = 2},
  [567] = {.lex_state = 344, .external_lex_state = 2},
  [568] = {.lex_state = 344, .external_lex_state = 2},
  [569] = {.lex_state = 344, .external_lex_state = 2},
  [570] = {.lex_state = 344, .external_lex_state = 2},
  [571] = {.lex_state = 344, .external_lex_state = 2},
  [572] = {.lex_state = 344, .external_lex_state = 2},
  [573] = {.lex_state = 344, .external_lex_state = 2},
  [574] = {.lex_state = 344, .external_lex_state = 2},
  [575] = {.lex_state = 344, .external_lex_state = 2},
  [576] = {.lex_state = 344, .external_lex_state = 2},
  [577] = {.lex_state = 344, .external_lex_state = 2},
  [578] = {.lex_state = 344, .external_lex_state = 10},
  [579] = {.lex_state = 345, .external_lex_state = 10},
  [580] = {.lex_state = 345, .external_lex_state = 11},
  [581] = {.lex_state = 344, .external_lex_state = 2},
  [582] = {.lex_state = 345, .external_lex_state = 11},
  [583] = {.lex_state = 345, .external_lex_state = 11},
  [584] = {.lex_state = 344, .external_lex_state = 2},
  [585] = {.lex_state = 344, .external_lex_state = 2},
  [586] = {.lex_state = 344, .external_lex_state = 2},
  [587] = {.lex_state = 344, .external_lex_state = 2},
  [588] = {.lex_state = 344, .external_lex_state = 2},
  [589] = {.lex_state = 344, .external_lex_state = 2},
  [590] = {.lex_state = 344, .external_lex_state = 2},
  [591] = {.lex_state = 344, .external_lex_state = 2},
  [592] = {.lex_state = 344, .external_lex_state = 2},
  [593] = {.lex_state = 344, .external_lex_state = 2},
  [594] = {.lex_state = 344, .external_lex_state = 2},
  [595] = {.lex_state = 344, .external_lex_state = 2},
  [596] = {.lex_state = 344, .external_lex_state = 2},
  [597] = {.lex_state = 344, .external_lex_state = 2},
  [598] = {.lex_state = 344, .external_lex_state = 2},
  [599] = {.lex_state = 344, .external_lex_state = 2},
  [600] = {.lex_state = 344, .external_lex_state = 2},
  [601] = {.lex_state = 344, .external_lex_state = 2},
  [602] = {.lex_state = 344, .external_lex_state = 2},
  [603] = {.lex_state = 344, .external_lex_state = 4},
  [604] = {.lex_state = 344, .external_lex_state = 4},
  [605] = {.lex_state = 344, .external_lex_state = 2},
  [606] = {.lex_state = 344, .external_lex_state = 2},
  [607] = {.lex_state = 344, .external_lex_state = 4},
  [608] = {.lex_state = 344, .external_lex_state = 4},
  [609] = {.lex_state = 344, .external_lex_state = 4},
  [610] = {.lex_state = 344, .external_lex_state = 2},
  [611] = {.lex_state = 344, .external_lex_state = 4},
  [612] = {.lex_state = 344, .external_lex_state = 4},
  [613] = {.lex_state = 344, .external_lex_state = 4},
  [614] = {.lex_state = 344, .external_lex_state = 4},
  [615] = {.lex_state = 344, .external_lex_state = 4},
  [616] = {.lex_state = 344, .external_lex_state = 4},
  [617] = {.lex_state = 344, .external_lex_state = 4},
  [618] = {.lex_state = 344, .external_lex_state = 2},
  [619] = {.lex_state = 344, .external_lex_state = 2},
  [620] = {.lex_state = 344, .external_lex_state = 4},
  [621] = {.lex_state = 344, .external_lex_state = 2},
  [622] = {.lex_state = 344, .external_lex_state = 4},
  [623] = {.lex_state = 344, .external_lex_state = 4},
  [624] = {.lex_state = 344, .external_lex_state = 2},
  [625] = {.lex_state = 344, .external_lex_state = 4},
  [626] = {.lex_state = 344, .external_lex_state = 4},
  [627] = {.lex_state = 344, .external_lex_state = 4},
  [628] = {.lex_state = 344, .external_lex_state = 4},
  [629] = {.lex_state = 344, .external_lex_state = 2},
  [630] = {.lex_state = 344, .external_lex_state = 2},
  [631] = {.lex_state = 344, .external_lex_state = 4},
  [632] = {.lex_state = 344, .external_lex_state = 2},
  [633] = {.lex_state = 344, .external_lex_state = 4},
  [634] = {.lex_state = 344, .external_lex_state = 2},
  [635] = {.lex_state = 344, .external_lex_state = 4},
  [636] = {.lex_state = 344, .external_lex_state = 2},
  [637] = {.lex_state = 344, .external_lex_state = 4},
  [638] = {.lex_state = 344, .external_lex_state = 2},
  [639] = {.lex_state = 344, .external_lex_state = 4},
  [640] = {.lex_state = 344, .external_lex_state = 2},
  [641] = {.lex_state = 344, .external_lex_state = 4},
  [642] = {.lex_state = 344, .external_lex_state = 4},
  [643] = {.lex_state = 344, .external_lex_state = 4},
  [644] = {.lex_state = 344, .external_lex_state = 4},
  [645] = {.lex_state = 344, .external_lex_state = 4},
  [646] = {.lex_state = 344, .external_lex_state = 4},
  [647] = {.lex_state = 344, .external_lex_state = 4},
  [648] = {.lex_state = 344, .external_lex_state = 4},
  [649] = {.lex_state = 344, .external_lex_state = 2},
  [650] = {.lex_state = 344, .external_lex_state = 2},
  [651] = {.lex_state = 344, .external_lex_state = 2},
  [652] = {.lex_state = 344, .external_lex_state = 2},
  [653] = {.lex_state = 344, .external_lex_state = 2},
  [654] = {.lex_state = 344, .external_lex_state = 2},
  [655] = {.lex_state = 344, .external_lex_state = 2},
  [656] = {.lex_state = 344, .external_lex_state = 2},
  [657] = {.lex_state = 344, .external_lex_state = 4},
  [658] = {.lex_state = 344, .external_lex_state = 2},
  [659] = {.lex_state = 344, .external_lex_state = 2},
  [660] = {.lex_state = 344, .external_lex_state = 2},
  [661] = {.lex_state = 344, .external_lex_state = 2},
  [662] = {.lex_state = 344, .external_lex_state = 2},
  [663] = {.lex_state = 344, .external_lex_state = 2},
  [664] = {.lex_state = 344, .external_lex_state = 2},
  [665] = {.lex_state = 344, .external_lex_state = 2},
  [666] = {.lex_state = 344, .external_lex_state = 2},
  [667] = {.lex_state = 344, .external_lex_state = 2},
  [668] = {.lex_state = 344, .external_lex_state = 2},
  [669] = {.lex_state = 344, .external_lex_state = 2},
  [670] = {.lex_state = 344, .external_lex_state = 2},
  [671] = {.lex_state = 344, .external_lex_state = 2},
  [672] = {.lex_state = 344, .external_lex_state = 2},
  [673] = {.lex_state = 344, .external_lex_state = 2},
  [674] = {.lex_state = 344, .external_lex_state = 2},
  [675] = {.lex_state = 344, .external_lex_state = 2},
  [676] = {.lex_state = 344, .external_lex_state = 2},
  [677] = {.lex_state = 344, .external_lex_state = 2},
  [678] = {.lex_state = 344, .external_lex_state = 8},
  [679] = {.lex_state = 344, .external_lex_state = 2},
  [680] = {.lex_state = 344, .external_lex_state = 2},
  [681] = {.lex_state = 344, .external_lex_state = 2},
  [682] = {.lex_state = 344, .external_lex_state = 2},
  [683] = {.lex_state = 344, .external_lex_state = 8},
  [684] = {.lex_state = 344, .external_lex_state = 2},
  [685] = {.lex_state = 344, .external_lex_state = 2},
  [686] = {.lex_state = 344, .external_lex_state = 8},
  [687] = {.lex_state = 344, .external_lex_state = 12},
  [688] = {.lex_state = 344, .external_lex_state = 2},
  [689] = {.lex_state = 344, .external_lex_state = 9},
  [690] = {.lex_state = 344, .external_lex_state = 11},
  [691] = {.lex_state = 344, .external_lex_state = 2},
  [692] = {.lex_state = 344, .external_lex_state = 2},
  [693] = {.lex_state = 344, .external_lex_state = 2},
  [694] = {.lex_state = 344, .external_lex_state = 13},
  [695] = {.lex_state = 344, .external_lex_state = 13},
  [696] = {.lex_state = 344, .external_lex_state = 2},
  [697] = {.lex_state = 344, .external_lex_state = 13},
  [698] = {.lex_state = 344, .external_lex_state = 2},
  [699] = {.lex_state = 344, .external_lex_state = 2},
  [700] = {.lex_state = 344, .external_lex_state = 13},
  [701] = {.lex_state = 344, .external_lex_state = 2},
  [702] = {.lex_state = 344, .external_lex_state = 2},
  [703] = {.lex_state = 344, .external_lex_state = 2},
  [704] = {.lex_state = 344, .external_lex_state = 13},
  [705] = {.lex_state = 344, .external_lex_state = 13},
  [706] = {.lex_state = 344, .external_lex_state = 2},
  [707] = {.lex_state = 344, .external_lex_state = 13},
  [708] = {.lex_state = 344, .external_lex_state = 2},
  [709] = {.lex_state = 344, .external_lex_state = 13},
  [710] = {.lex_state = 344, .external_lex_state = 13},
  [711] = {.lex_state = 344, .external_lex_state = 2},
  [712] = {.lex_state = 344, .external_lex_state = 13},
  [713] = {.lex_state = 344, .external_lex_state = 2},
  [714] = {.lex_state = 344, .external_lex_state = 2},
  [715] = {.lex_state = 344, .external_lex_state = 2},
  [716] = {.lex_state = 344, .external_lex_state = 2},
  [717] = {.lex_state = 344, .external_lex_state = 2},
  [718] = {.lex_state = 344, .external_lex_state = 2},
  [719] = {.lex_state = 344, .external_lex_state = 2},
  [720] = {.lex_state = 344, .external_lex_state = 2},
  [721] = {.lex_state = 344, .external_lex_state = 13},
  [722] = {.lex_state = 344, .external_lex_state = 13},
  [723] = {.lex_state = 344, .external_lex_state = 2},
  [724] = {.lex_state = 344, .external_lex_state = 2},
  [725] = {.lex_state = 344, .external_lex_state = 13},
  [726] = {.lex_state = 344, .external_lex_state = 2},
  [727] = {.lex_state = 344, .external_lex_state = 2},
  [728] = {.lex_state = 344, .external_lex_state = 2},
  [729] = {.lex_state = 344, .external_lex_state = 2},
  [730] = {.lex_state = 344, .external_lex_state = 2},
  [731] = {.lex_state = 344, .external_lex_state = 2},
  [732] = {.lex_state = 344, .external_lex_state = 13},
  [733] = {.lex_state = 344, .external_lex_state = 2},
  [734] = {.lex_state = 344, .external_lex_state = 13},
  [735] = {.lex_state = 344, .external_lex_state = 2},
  [736] = {.lex_state = 344, .external_lex_state = 13},
  [737] = {.lex_state = 344, .external_lex_state = 2},
  [738] = {.lex_state = 344, .external_lex_state = 13},
  [739] = {.lex_state = 344, .external_lex_state = 13},
  [740] = {.lex_state = 344, .external_lex_state = 13},
  [741] = {.lex_state = 344, .external_lex_state = 13},
  [742] = {.lex_state = 344, .external_lex_state = 2},
  [743] = {.lex_state = 344, .external_lex_state = 2},
  [744] = {.lex_state = 344, .external_lex_state = 13},
  [745] = {.lex_state = 344, .external_lex_state = 2},
  [746] = {.lex_state = 344, .external_lex_state = 2},
  [747] = {.lex_state = 344, .external_lex_state = 14},
  [748] = {.lex_state = 344, .external_lex_state = 2},
  [749] = {.lex_state = 344, .external_lex_state = 2},
  [750] = {.lex_state = 344, .external_lex_state = 13},
  [751] = {.lex_state = 344, .external_lex_state = 13},
  [752] = {.lex_state = 344, .external_lex_state = 13},
  [753] = {.lex_state = 344, .external_lex_state = 13},
  [754] = {.lex_state = 344, .external_lex_state = 2},
  [755] = {.lex_state = 344, .external_lex_state = 2},
  [756] = {.lex_state = 344, .external_lex_state = 2},
  [757] = {.lex_state = 344, .external_lex_state = 2},
  [758] = {.lex_state = 344, .external_lex_state = 2},
  [759] = {.lex_state = 344, .external_lex_state = 2},
  [760] = {.lex_state = 344, .external_lex_state = 2},
  [761] = {.lex_state = 344, .external_lex_state = 2},
  [762] = {.lex_state = 344, .external_lex_state = 2},
  [763] = {.lex_state = 344, .external_lex_state = 2},
  [764] = {.lex_state = 344, .external_lex_state = 2},
  [765] = {.lex_state = 344, .external_lex_state = 2},
  [766] = {.lex_state = 344, .external_lex_state = 2},
  [767] = {.lex_state = 344, .external_lex_state = 2},
  [768] = {.lex_state = 344, .external_lex_state = 2},
  [769] = {.lex_state = 344, .external_lex_state = 2},
  [770] = {.lex_state = 344, .external_lex_state = 2},
  [771] = {.lex_state = 344, .external_lex_state = 2},
  [772] = {.lex_state = 344, .external_lex_state = 2},
  [773] = {.lex_state = 344, .external_lex_state = 2},
  [774] = {.lex_state = 344, .external_lex_state = 2},
  [775] = {.lex_state = 344, .external_lex_state = 2},
  [776] = {.lex_state = 344, .external_lex_state = 2},
  [777] = {.lex_state = 344, .external_lex_state = 2},
  [778] = {.lex_state = 344, .external_lex_state = 2},
  [779] = {.lex_state = 344, .external_lex_state = 2},
  [780] = {.lex_state = 344, .external_lex_state = 2},
  [781] = {.lex_state = 344, .external_lex_state = 2},
  [782] = {.lex_state = 344, .external_lex_state = 2},
  [783] = {.lex_state = 344, .external_lex_state = 2},
  [784] = {.lex_state = 344, .external_lex_state = 2},
  [785] = {.lex_state = 344, .external_lex_state = 2},
  [786] = {.lex_state = 344, .external_lex_state = 2},
  [787] = {.lex_state = 344, .external_lex_state = 2},
  [788] = {.lex_state = 344, .external_lex_state = 2},
  [789] = {.lex_state = 344, .external_lex_state = 2},
  [790] = {.lex_state = 344, .external_lex_state = 2},
  [791] = {.lex_state = 344, .external_lex_state = 2},
  [792] = {.lex_state = 344, .external_lex_state = 2},
  [793] = {.lex_state = 344, .external_lex_state = 2},
  [794] = {.lex_state = 344, .external_lex_state = 2},
  [795] = {.lex_state = 344, .external_lex_state = 2},
  [796] = {.lex_state = 344, .external_lex_state = 2},
  [797] = {.lex_state = 344, .external_lex_state = 2},
  [798] = {.lex_state = 344, .external_lex_state = 2},
  [799] = {.lex_state = 344, .external_lex_state = 2},
  [800] = {.lex_state = 344, .external_lex_state = 2},
  [801] = {.lex_state = 344, .external_lex_state = 2},
  [802] = {.lex_state = 344, .external_lex_state = 2},
  [803] = {.lex_state = 344, .external_lex_state = 2},
  [804] = {.lex_state = 344, .external_lex_state = 2},
  [805] = {.lex_state = 344, .external_lex_state = 2},
  [806] = {.lex_state = 344, .external_lex_state = 2},
  [807] = {.lex_state = 344, .external_lex_state = 2},
  [808] = {.lex_state = 344, .external_lex_state = 2},
  [809] = {.lex_state = 344, .external_lex_state = 2},
  [810] = {.lex_state = 344, .external_lex_state = 2},
  [811] = {.lex_state = 344, .external_lex_state = 2},
  [812] = {.lex_state = 344, .external_lex_state = 2},
  [813] = {.lex_state = 344, .external_lex_state = 2},
  [814] = {.lex_state = 344, .external_lex_state = 2},
  [815] = {.lex_state = 344, .external_lex_state = 2},
  [816] = {.lex_state = 344, .external_lex_state = 2},
  [817] = {.lex_state = 344, .external_lex_state = 2},
  [818] = {.lex_state = 344, .external_lex_state = 2},
  [819] = {.lex_state = 344, .external_lex_state = 2},
  [820] = {.lex_state = 344, .external_lex_state = 2},
  [821] = {.lex_state = 344, .external_lex_state = 2},
  [822] = {.lex_state = 344, .external_lex_state = 2},
  [823] = {.lex_state = 344, .external_lex_state = 2},
  [824] = {.lex_state = 344, .external_lex_state = 2},
  [825] = {.lex_state = 344, .external_lex_state = 2},
  [826] = {.lex_state = 344, .external_lex_state = 2},
  [827] = {.lex_state = 344, .external_lex_state = 2},
  [828] = {.lex_state = 344, .external_lex_state = 2},
  [829] = {.lex_state = 344, .external_lex_state = 2},
  [830] = {.lex_state = 344, .external_lex_state = 2},
  [831] = {.lex_state = 344, .external_lex_state = 2},
  [832] = {.lex_state = 344, .external_lex_state = 2},
  [833] = {.lex_state = 344, .external_lex_state = 2},
  [834] = {.lex_state = 344, .external_lex_state = 2},
  [835] = {.lex_state = 344, .external_lex_state = 2},
  [836] = {.lex_state = 344, .external_lex_state = 2},
  [837] = {.lex_state = 344, .external_lex_state = 2},
  [838] = {.lex_state = 344, .external_lex_state = 2},
  [839] = {.lex_state = 344, .external_lex_state = 2},
  [840] = {.lex_state = 344, .external_lex_state = 2},
  [841] = {.lex_state = 344, .external_lex_state = 2},
  [842] = {.lex_state = 344, .external_lex_state = 2},
  [843] = {.lex_state = 344, .external_lex_state = 2},
  [844] = {.lex_state = 344, .external_lex_state = 2},
  [845] = {.lex_state = 344, .external_lex_state = 2},
  [846] = {.lex_state = 344, .external_lex_state = 2},
  [847] = {.lex_state = 344, .external_lex_state = 2},
  [848] = {.lex_state = 344, .external_lex_state = 2},
  [849] = {.lex_state = 344, .external_lex_state = 2},
  [850] = {.lex_state = 344, .external_lex_state = 2},
  [851] = {.lex_state = 344, .external_lex_state = 2},
  [852] = {.lex_state = 344, .external_lex_state = 2},
  [853] = {.lex_state = 344, .external_lex_state = 2},
  [854] = {.lex_state = 344, .external_lex_state = 2},
  [855] = {.lex_state = 344, .external_lex_state = 2},
  [856] = {.lex_state = 344, .external_lex_state = 2},
  [857] = {.lex_state = 344, .external_lex_state = 2},
  [858] = {.lex_state = 344, .external_lex_state = 2},
  [859] = {.lex_state = 344, .external_lex_state = 2},
  [860] = {.lex_state = 344, .external_lex_state = 2},
  [861] = {.lex_state = 344, .external_lex_state = 2},
  [862] = {.lex_state = 344, .external_lex_state = 2},
  [863] = {.lex_state = 344, .external_lex_state = 2},
  [864] = {.lex_state = 344, .external_lex_state = 2},
  [865] = {.lex_state = 344, .external_lex_state = 2},
  [866] = {.lex_state = 344, .external_lex_state = 2},
  [867] = {.lex_state = 344, .external_lex_state = 2},
  [868] = {.lex_state = 344, .external_lex_state = 2},
  [869] = {.lex_state = 344, .external_lex_state = 2},
  [870] = {.lex_state = 344, .external_lex_state = 2},
  [871] = {.lex_state = 344, .external_lex_state = 2},
  [872] = {.lex_state = 344, .external_lex_state = 2},
  [873] = {.lex_state = 344, .external_lex_state = 2},
  [874] = {.lex_state = 344, .external_lex_state = 2},
  [875] = {.lex_state = 344, .external_lex_state = 2},
  [876] = {.lex_state = 344, .external_lex_state = 2},
  [877] = {.lex_state = 344, .external_lex_state = 2},
  [878] = {.lex_state = 344, .external_lex_state = 2},
  [879] = {.lex_state = 344, .external_lex_state = 2},
  [880] = {.lex_state = 344, .external_lex_state = 2},
  [881] = {.lex_state = 344, .external_lex_state = 2},
  [882] = {.lex_state = 344, .external_lex_state = 2},
  [883] = {.lex_state = 344, .external_lex_state = 2},
  [884] = {.lex_state = 344, .external_lex_state = 2},
  [885] = {.lex_state = 344, .external_lex_state = 2},
  [886] = {.lex_state = 344, .external_lex_state = 2},
  [887] = {.lex_state = 344, .external_lex_state = 2},
  [888] = {.lex_state = 344, .external_lex_state = 2},
  [889] = {.lex_state = 344, .external_lex_state = 2},
  [890] = {.lex_state = 344, .external_lex_state = 2},
  [891] = {.lex_state = 344, .external_lex_state = 2},
  [892] = {.lex_state = 344, .external_lex_state = 2},
  [893] = {.lex_state = 344, .external_lex_state = 2},
  [894] = {.lex_state = 344, .external_lex_state = 2},
  [895] = {.lex_state = 344, .external_lex_state = 2},
  [896] = {.lex_state = 344, .external_lex_state = 2},
  [897] = {.lex_state = 344, .external_lex_state = 2},
  [898] = {.lex_state = 344, .external_lex_state = 2},
  [899] = {.lex_state = 344, .external_lex_state = 2},
  [900] = {.lex_state = 344, .external_lex_state = 2},
  [901] = {.lex_state = 344, .external_lex_state = 2},
  [902] = {.lex_state = 344, .external_lex_state = 2},
  [903] = {.lex_state = 344, .external_lex_state = 2},
  [904] = {.lex_state = 344, .external_lex_state = 2},
  [905] = {.lex_state = 344, .external_lex_state = 2},
  [906] = {.lex_state = 344, .external_lex_state = 2},
  [907] = {.lex_state = 344, .external_lex_state = 2},
  [908] = {.lex_state = 344, .external_lex_state = 2},
  [909] = {.lex_state = 344, .external_lex_state = 2},
  [910] = {.lex_state = 344, .external_lex_state = 2},
  [911] = {.lex_state = 344, .external_lex_state = 2},
  [912] = {.lex_state = 344, .external_lex_state = 2},
  [913] = {.lex_state = 344, .external_lex_state = 2},
  [914] = {.lex_state = 344, .external_lex_state = 2},
  [915] = {.lex_state = 344, .external_lex_state = 2},
  [916] = {.lex_state = 344, .external_lex_state = 2},
  [917] = {.lex_state = 344, .external_lex_state = 2},
  [918] = {.lex_state = 344, .external_lex_state = 2},
  [919] = {.lex_state = 344, .external_lex_state = 2},
  [920] = {.lex_state = 344, .external_lex_state = 2},
  [921] = {.lex_state = 344, .external_lex_state = 2},
  [922] = {.lex_state = 344, .external_lex_state = 2},
  [923] = {.lex_state = 344, .external_lex_state = 2},
  [924] = {.lex_state = 344, .external_lex_state = 2},
  [925] = {.lex_state = 344, .external_lex_state = 2},
  [926] = {.lex_state = 344, .external_lex_state = 2},
  [927] = {.lex_state = 344, .external_lex_state = 2},
  [928] = {.lex_state = 344, .external_lex_state = 2},
  [929] = {.lex_state = 344, .external_lex_state = 2},
  [930] = {.lex_state = 344, .external_lex_state = 2},
  [931] = {.lex_state = 344, .external_lex_state = 2},
  [932] = {.lex_state = 344, .external_lex_state = 2},
  [933] = {.lex_state = 344, .external_lex_state = 2},
  [934] = {.lex_state = 344, .external_lex_state = 2},
  [935] = {.lex_state = 344, .external_lex_state = 2},
  [936] = {.lex_state = 344, .external_lex_state = 2},
  [937] = {.lex_state = 344, .external_lex_state = 2},
  [938] = {.lex_state = 344, .external_lex_state = 2},
  [939] = {.lex_state = 344, .external_lex_state = 2},
  [940] = {.lex_state = 344, .external_lex_state = 2},
  [941] = {.lex_state = 344, .external_lex_state = 2},
  [942] = {.lex_state = 344, .external_lex_state = 2},
  [943] = {.lex_state = 344, .external_lex_state = 2},
  [944] = {.lex_state = 344, .external_lex_state = 2},
  [945] = {.lex_state = 344, .external_lex_state = 2},
  [946] = {.lex_state = 344, .external_lex_state = 2},
  [947] = {.lex_state = 344, .external_lex_state = 2},
  [948] = {.lex_state = 344, .external_lex_state = 2},
  [949] = {.lex_state = 344, .external_lex_state = 2},
  [950] = {.lex_state = 344, .external_lex_state = 2},
  [951] = {.lex_state = 344, .external_lex_state = 2},
  [952] = {.lex_state = 344, .external_lex_state = 2},
  [953] = {.lex_state = 344, .external_lex_state = 2},
  [954] = {.lex_state = 344, .external_lex_state = 2},
  [955] = {.lex_state = 344, .external_lex_state = 2},
  [956] = {.lex_state = 344, .external_lex_state = 2},
  [957] = {.lex_state = 344, .external_lex_state = 2},
  [958] = {.lex_state = 344, .external_lex_state = 2},
  [959] = {.lex_state = 344, .external_lex_state = 2},
  [960] = {.lex_state = 344, .external_lex_state = 2},
  [961] = {.lex_state = 344, .external_lex_state = 2},
  [962] = {.lex_state = 344, .external_lex_state = 2},
  [963] = {.lex_state = 344, .external_lex_state = 2},
  [964] = {.lex_state = 344, .external_lex_state = 2},
  [965] = {.lex_state = 344, .external_lex_state = 2},
  [966] = {.lex_state = 344, .external_lex_state = 2},
  [967] = {.lex_state = 344, .external_lex_state = 2},
  [968] = {.lex_state = 344, .external_lex_state = 2},
  [969] = {.lex_state = 344, .external_lex_state = 2},
  [970] = {.lex_state = 344, .external_lex_state = 2},
  [971] = {.lex_state = 344, .external_lex_state = 2},
  [972] = {.lex_state = 344, .external_lex_state = 2},
  [973] = {.lex_state = 344, .external_lex_state = 2},
  [974] = {.lex_state = 344, .external_lex_state = 2},
  [975] = {.lex_state = 344, .external_lex_state = 2},
  [976] = {.lex_state = 344, .external_lex_state = 2},
  [977] = {.lex_state = 344, .external_lex_state = 2},
  [978] = {.lex_state = 344, .external_lex_state = 2},
  [979] = {.lex_state = 344, .external_lex_state = 2},
  [980] = {.lex_state = 344, .external_lex_state = 2},
  [981] = {.lex_state = 344, .external_lex_state = 2},
  [982] = {.lex_state = 344, .external_lex_state = 2},
  [983] = {.lex_state = 344, .external_lex_state = 2},
  [984] = {.lex_state = 344, .external_lex_state = 2},
  [985] = {.lex_state = 344, .external_lex_state = 2},
  [986] = {.lex_state = 344, .external_lex_state = 2},
  [987] = {.lex_state = 344, .external_lex_state = 2},
  [988] = {.lex_state = 344, .external_lex_state = 2},
  [989] = {.lex_state = 344, .external_lex_state = 2},
  [990] = {.lex_state = 344, .external_lex_state = 2},
  [991] = {.lex_state = 344, .external_lex_state = 2},
  [992] = {.lex_state = 344, .external_lex_state = 2},
  [993] = {.lex_state = 344, .external_lex_state = 2},
  [994] = {.lex_state = 344, .external_lex_state = 2},
  [995] = {.lex_state = 344, .external_lex_state = 2},
  [996] = {.lex_state = 344, .external_lex_state = 2},
  [997] = {.lex_state = 344, .external_lex_state = 2},
  [998] = {.lex_state = 344, .external_lex_state = 2},
  [999] = {.lex_state = 344, .external_lex_state = 2},
  [1000] = {.lex_state = 344, .external_lex_state = 2},
  [1001] = {.lex_state = 344, .external_lex_state = 2},
  [1002] = {.lex_state = 344, .external_lex_state = 2},
  [1003] = {.lex_state = 344, .external_lex_state = 2},
  [1004] = {.lex_state = 344, .external_lex_state = 2},
  [1005] = {.lex_state = 344, .external_lex_state = 2},
  [1006] = {.lex_state = 344, .external_lex_state = 2},
  [1007] = {.lex_state = 344, .external_lex_state = 2},
  [1008] = {.lex_state = 344, .external_lex_state = 2},
  [1009] = {.lex_state = 344, .external_lex_state = 2},
  [1010] = {.lex_state = 344, .external_lex_state = 2},
  [1011] = {.lex_state = 344, .external_lex_state = 2},
  [1012] = {.lex_state = 344, .external_lex_state = 2},
  [1013] = {.lex_state = 344, .external_lex_state = 2},
  [1014] = {.lex_state = 344, .external_lex_state = 2},
  [1015] = {.lex_state = 344, .external_lex_state = 2},
  [1016] = {.lex_state = 344, .external_lex_state = 2},
  [1017] = {.lex_state = 344, .external_lex_state = 2},
  [1018] = {.lex_state = 344, .external_lex_state = 2},
  [1019] = {.lex_state = 344, .external_lex_state = 2},
  [1020] = {.lex_state = 344, .external_lex_state = 2},
  [1021] = {.lex_state = 344, .external_lex_state = 2},
  [1022] = {.lex_state = 344, .external_lex_state = 2},
  [1023] = {.lex_state = 344, .external_lex_state = 2},
  [1024] = {.lex_state = 344, .external_lex_state = 2},
  [1025] = {.lex_state = 344, .external_lex_state = 2},
  [1026] = {.lex_state = 344, .external_lex_state = 2},
  [1027] = {.lex_state = 344, .external_lex_state = 2},
  [1028] = {.lex_state = 344, .external_lex_state = 2},
  [1029] = {.lex_state = 344, .external_lex_state = 2},
  [1030] = {.lex_state = 344, .external_lex_state = 2},
  [1031] = {.lex_state = 344, .external_lex_state = 2},
  [1032] = {.lex_state = 344, .external_lex_state = 2},
  [1033] = {.lex_state = 344, .external_lex_state = 2},
  [1034] = {.lex_state = 344, .external_lex_state = 2},
  [1035] = {.lex_state = 344, .external_lex_state = 2},
  [1036] = {.lex_state = 344, .external_lex_state = 2},
  [1037] = {.lex_state = 344, .external_lex_state = 2},
  [1038] = {.lex_state = 344, .external_lex_state = 2},
  [1039] = {.lex_state = 344, .external_lex_state = 2},
  [1040] = {.lex_state = 344, .external_lex_state = 2},
  [1041] = {.lex_state = 344, .external_lex_state = 2},
  [1042] = {.lex_state = 344, .external_lex_state = 2},
  [1043] = {.lex_state = 344, .external_lex_state = 2},
  [1044] = {.lex_state = 344, .external_lex_state = 2},
  [1045] = {.lex_state = 344, .external_lex_state = 2},
  [1046] = {.lex_state = 344, .external_lex_state = 2},
  [1047] = {.lex_state = 344, .external_lex_state = 2},
  [1048] = {.lex_state = 344, .external_lex_state = 2},
  [1049] = {.lex_state = 344, .external_lex_state = 2},
  [1050] = {.lex_state = 344, .external_lex_state = 2},
  [1051] = {.lex_state = 344, .external_lex_state = 2},
  [1052] = {.lex_state = 344, .external_lex_state = 2},
  [1053] = {.lex_state = 344, .external_lex_state = 2},
  [1054] = {.lex_state = 344, .external_lex_state = 2},
  [1055] = {.lex_state = 344, .external_lex_state = 2},
  [1056] = {.lex_state = 344, .external_lex_state = 2},
  [1057] = {.lex_state = 344, .external_lex_state = 2},
  [1058] = {.lex_state = 344, .external_lex_state = 2},
  [1059] = {.lex_state = 344, .external_lex_state = 2},
  [1060] = {.lex_state = 344, .external_lex_state = 2},
  [1061] = {.lex_state = 344, .external_lex_state = 2},
  [1062] = {.lex_state = 344, .external_lex_state = 2},
  [1063] = {.lex_state = 344, .external_lex_state = 2},
  [1064] = {.lex_state = 344, .external_lex_state = 2},
  [1065] = {.lex_state = 344, .external_lex_state = 2},
  [1066] = {.lex_state = 344, .external_lex_state = 2},
  [1067] = {.lex_state = 344, .external_lex_state = 2},
  [1068] = {.lex_state = 344, .external_lex_state = 2},
  [1069] = {.lex_state = 344, .external_lex_state = 2},
  [1070] = {.lex_state = 344, .external_lex_state = 2},
  [1071] = {.lex_state = 344, .external_lex_state = 2},
  [1072] = {.lex_state = 344, .external_lex_state = 2},
  [1073] = {.lex_state = 344, .external_lex_state = 2},
  [1074] = {.lex_state = 344, .external_lex_state = 2},
  [1075] = {.lex_state = 344, .external_lex_state = 2},
  [1076] = {.lex_state = 344, .external_lex_state = 2},
  [1077] = {.lex_state = 344, .external_lex_state = 2},
  [1078] = {.lex_state = 344, .external_lex_state = 2},
  [1079] = {.lex_state = 344, .external_lex_state = 2},
  [1080] = {.lex_state = 344, .external_lex_state = 2},
  [1081] = {.lex_state = 344, .external_lex_state = 2},
  [1082] = {.lex_state = 344, .external_lex_state = 2},
  [1083] = {.lex_state = 344, .external_lex_state = 2},
  [1084] = {.lex_state = 344, .external_lex_state = 2},
  [1085] = {.lex_state = 344, .external_lex_state = 2},
  [1086] = {.lex_state = 344, .external_lex_state = 2},
  [1087] = {.lex_state = 344, .external_lex_state = 2},
  [1088] = {.lex_state = 344, .external_lex_state = 2},
  [1089] = {.lex_state = 344, .external_lex_state = 2},
  [1090] = {.lex_state = 344, .external_lex_state = 2},
  [1091] = {.lex_state = 344, .external_lex_state = 2},
  [1092] = {.lex_state = 344, .external_lex_state = 2},
  [1093] = {.lex_state = 344, .external_lex_state = 2},
  [1094] = {.lex_state = 344, .external_lex_state = 2},
  [1095] = {.lex_state = 344, .external_lex_state = 2},
  [1096] = {.lex_state = 344, .external_lex_state = 2},
  [1097] = {.lex_state = 344, .external_lex_state = 2},
  [1098] = {.lex_state = 344, .external_lex_state = 2},
  [1099] = {.lex_state = 344, .external_lex_state = 2},
  [1100] = {.lex_state = 344, .external_lex_state = 2},
  [1101] = {.lex_state = 344, .external_lex_state = 2},
  [1102] = {.lex_state = 344, .external_lex_state = 2},
  [1103] = {.lex_state = 344, .external_lex_state = 2},
  [1104] = {.lex_state = 344, .external_lex_state = 2},
  [1105] = {.lex_state = 344, .external_lex_state = 2},
  [1106] = {.lex_state = 344, .external_lex_state = 2},
  [1107] = {.lex_state = 344, .external_lex_state = 2},
  [1108] = {.lex_state = 344, .external_lex_state = 2},
  [1109] = {.lex_state = 344, .external_lex_state = 2},
  [1110] = {.lex_state = 344, .external_lex_state = 2},
  [1111] = {.lex_state = 344, .external_lex_state = 2},
  [1112] = {.lex_state = 344, .external_lex_state = 2},
  [1113] = {.lex_state = 344, .external_lex_state = 2},
  [1114] = {.lex_state = 344, .external_lex_state = 2},
  [1115] = {.lex_state = 344, .external_lex_state = 2},
  [1116] = {.lex_state = 344, .external_lex_state = 2},
  [1117] = {.lex_state = 344, .external_lex_state = 2},
  [1118] = {.lex_state = 344, .external_lex_state = 2},
  [1119] = {.lex_state = 344, .external_lex_state = 2},
  [1120] = {.lex_state = 344, .external_lex_state = 2},
  [1121] = {.lex_state = 344, .external_lex_state = 2},
  [1122] = {.lex_state = 344, .external_lex_state = 2},
  [1123] = {.lex_state = 344, .external_lex_state = 2},
  [1124] = {.lex_state = 344, .external_lex_state = 2},
  [1125] = {.lex_state = 344, .external_lex_state = 2},
  [1126] = {.lex_state = 344, .external_lex_state = 2},
  [1127] = {.lex_state = 344, .external_lex_state = 2},
  [1128] = {.lex_state = 344, .external_lex_state = 2},
  [1129] = {.lex_state = 344, .external_lex_state = 2},
  [1130] = {.lex_state = 344, .external_lex_state = 2},
  [1131] = {.lex_state = 344, .external_lex_state = 2},
  [1132] = {.lex_state = 344, .external_lex_state = 2},
  [1133] = {.lex_state = 344, .external_lex_state = 2},
  [1134] = {.lex_state = 344, .external_lex_state = 2},
  [1135] = {.lex_state = 344, .external_lex_state = 2},
  [1136] = {.lex_state = 344, .external_lex_state = 2},
  [1137] = {.lex_state = 344, .external_lex_state = 2},
  [1138] = {.lex_state = 344, .external_lex_state = 2},
  [1139] = {.lex_state = 344, .external_lex_state = 2},
  [1140] = {.lex_state = 344, .external_lex_state = 2},
  [1141] = {.lex_state = 344, .external_lex_state = 2},
  [1142] = {.lex_state = 344, .external_lex_state = 2},
  [1143] = {.lex_state = 344, .external_lex_state = 2},
  [1144] = {.lex_state = 344, .external_lex_state = 2},
  [1145] = {.lex_state = 344, .external_lex_state = 2},
  [1146] = {.lex_state = 344, .external_lex_state = 2},
  [1147] = {.lex_state = 344, .external_lex_state = 2},
  [1148] = {.lex_state = 344, .external_lex_state = 2},
  [1149] = {.lex_state = 344, .external_lex_state = 2},
  [1150] = {.lex_state = 344, .external_lex_state = 2},
  [1151] = {.lex_state = 344, .external_lex_state = 2},
  [1152] = {.lex_state = 344, .external_lex_state = 2},
  [1153] = {.lex_state = 344, .external_lex_state = 2},
  [1154] = {.lex_state = 344, .external_lex_state = 2},
  [1155] = {.lex_state = 344, .external_lex_state = 2},
  [1156] = {.lex_state = 344, .external_lex_state = 2},
  [1157] = {.lex_state = 344, .external_lex_state = 2},
  [1158] = {.lex_state = 344, .external_lex_state = 2},
  [1159] = {.lex_state = 344, .external_lex_state = 2},
  [1160] = {.lex_state = 344, .external_lex_state = 2},
  [1161] = {.lex_state = 344, .external_lex_state = 2},
  [1162] = {.lex_state = 344, .external_lex_state = 2},
  [1163] = {.lex_state = 344, .external_lex_state = 2},
  [1164] = {.lex_state = 344, .external_lex_state = 2},
  [1165] = {.lex_state = 344, .external_lex_state = 2},
  [1166] = {.lex_state = 344, .external_lex_state = 2},
  [1167] = {.lex_state = 344, .external_lex_state = 2},
  [1168] = {.lex_state = 344, .external_lex_state = 2},
  [1169] = {.lex_state = 344, .external_lex_state = 2},
  [1170] = {.lex_state = 344, .external_lex_state = 2},
  [1171] = {.lex_state = 344, .external_lex_state = 2},
  [1172] = {.lex_state = 344, .external_lex_state = 2},
  [1173] = {.lex_state = 344, .external_lex_state = 2},
  [1174] = {.lex_state = 344, .external_lex_state = 2},
  [1175] = {.lex_state = 344, .external_lex_state = 2},
  [1176] = {.lex_state = 344, .external_lex_state = 2},
  [1177] = {.lex_state = 344, .external_lex_state = 2},
  [1178] = {.lex_state = 344, .external_lex_state = 2},
  [1179] = {.lex_state = 344, .external_lex_state = 2},
  [1180] = {.lex_state = 344, .external_lex_state = 2},
  [1181] = {.lex_state = 344, .external_lex_state = 2},
  [1182] = {.lex_state = 337, .external_lex_state = 3},
  [1183] = {.lex_state = 337, .external_lex_state = 3},
  [1184] = {.lex_state = 332, .external_lex_state = 3},
  [1185] = {.lex_state = 332, .external_lex_state = 3},
  [1186] = {.lex_state = 337, .external_lex_state = 4},
  [1187] = {.lex_state = 337, .external_lex_state = 5},
  [1188] = {.lex_state = 337, .external_lex_state = 8},
  [1189] = {.lex_state = 337, .external_lex_state = 7},
  [1190] = {.lex_state = 337, .external_lex_state = 6},
  [1191] = {.lex_state = 332, .external_lex_state = 5},
  [1192] = {.lex_state = 332, .external_lex_state = 4},
  [1193] = {.lex_state = 337, .external_lex_state = 9},
  [1194] = {.lex_state = 331, .external_lex_state = 3},
  [1195] = {.lex_state = 331, .external_lex_state = 3},
  [1196] = {.lex_state = 332, .external_lex_state = 8},
  [1197] = {.lex_state = 331, .external_lex_state = 3},
  [1198] = {.lex_state = 331, .external_lex_state = 3},
  [1199] = {.lex_state = 332, .external_lex_state = 7},
  [1200] = {.lex_state = 332, .external_lex_state = 6},
  [1201] = {.lex_state = 331, .external_lex_state = 3},
  [1202] = {.lex_state = 332, .external_lex_state = 9},
  [1203] = {.lex_state = 331, .external_lex_state = 3},
  [1204] = {.lex_state = 335, .external_lex_state = 15},
  [1205] = {.lex_state = 331, .external_lex_state = 3},
  [1206] = {.lex_state = 331, .external_lex_state = 3},
  [1207] = {.lex_state = 335, .external_lex_state = 15},
  [1208] = {.lex_state = 331, .external_lex_state = 3},
  [1209] = {.lex_state = 331, .external_lex_state = 3},
  [1210] = {.lex_state = 331, .external_lex_state = 3},
  [1211] = {.lex_state = 331, .external_lex_state = 3},
  [1212] = {.lex_state = 331, .external_lex_state = 3},
  [1213] = {.lex_state = 331, .external_lex_state = 3},
  [1214] = {.lex_state = 331, .external_lex_state = 3},
  [1215] = {.lex_state = 331, .external_lex_state = 3},
  [1216] = {.lex_state = 331, .external_lex_state = 3},
  [1217] = {.lex_state = 331, .external_lex_state = 3},
  [1218] = {.lex_state = 331, .external_lex_state = 3},
  [1219] = {.lex_state = 331, .external_lex_state = 3},
  [1220] = {.lex_state = 331, .external_lex_state = 3},
  [1221] = {.lex_state = 331, .external_lex_state = 3},
  [1222] = {.lex_state = 331, .external_lex_state = 3},
  [1223] = {.lex_state = 331, .external_lex_state = 3},
  [1224] = {.lex_state = 331, .external_lex_state = 3},
  [1225] = {.lex_state = 331, .external_lex_state = 3},
  [1226] = {.lex_state = 331, .external_lex_state = 3},
  [1227] = {.lex_state = 335, .external_lex_state = 15},
  [1228] = {.lex_state = 331, .external_lex_state = 3},
  [1229] = {.lex_state = 331, .external_lex_state = 3},
  [1230] = {.lex_state = 331, .external_lex_state = 3},
  [1231] = {.lex_state = 337, .external_lex_state = 10},
  [1232] = {.lex_state = 331, .external_lex_state = 5},
  [1233] = {.lex_state = 331, .external_lex_state = 5},
  [1234] = {.lex_state = 337, .external_lex_state = 10},
  [1235] = {.lex_state = 331, .external_lex_state = 5},
  [1236] = {.lex_state = 333, .external_lex_state = 3},
  [1237] = {.lex_state = 331, .external_lex_state = 4},
  [1238] = {.lex_state = 331, .external_lex_state = 4},
  [1239] = {.lex_state = 331, .external_lex_state = 5},
  [1240] = {.lex_state = 331, .external_lex_state = 4},
  [1241] = {.lex_state = 331, .external_lex_state = 5},
  [1242] = {.lex_state = 331, .external_lex_state = 4},
  [1243] = {.lex_state = 337, .external_lex_state = 10},
  [1244] = {.lex_state = 331, .external_lex_state = 4},
  [1245] = {.lex_state = 335, .external_lex_state = 15},
  [1246] = {.lex_state = 331, .external_lex_state = 7},
  [1247] = {.lex_state = 332, .external_lex_state = 10},
  [1248] = {.lex_state = 331, .external_lex_state = 6},
  [1249] = {.lex_state = 336, .external_lex_state = 3},
  [1250] = {.lex_state = 338, .external_lex_state = 3},
  [1251] = {.lex_state = 331, .external_lex_state = 7},
  [1252] = {.lex_state = 336, .external_lex_state = 3},
  [1253] = {.lex_state = 338, .external_lex_state = 3},
  [1254] = {.lex_state = 331, .external_lex_state = 6},
  [1255] = {.lex_state = 331, .external_lex_state = 6},
  [1256] = {.lex_state = 331, .external_lex_state = 9},
  [1257] = {.lex_state = 331, .external_lex_state = 9},
  [1258] = {.lex_state = 331, .external_lex_state = 7},
  [1259] = {.lex_state = 331, .external_lex_state = 9},
  [1260] = {.lex_state = 331, .external_lex_state = 9},
  [1261] = {.lex_state = 332, .external_lex_state = 10},
  [1262] = {.lex_state = 336, .external_lex_state = 3},
  [1263] = {.lex_state = 331, .external_lex_state = 8},
  [1264] = {.lex_state = 331, .external_lex_state = 8},
  [1265] = {.lex_state = 331, .external_lex_state = 8},
  [1266] = {.lex_state = 331, .external_lex_state = 8},
  [1267] = {.lex_state = 334, .external_lex_state = 3},
  [1268] = {.lex_state = 334, .external_lex_state = 3},
  [1269] = {.lex_state = 334, .external_lex_state = 3},
  [1270] = {.lex_state = 331, .external_lex_state = 6},
  [1271] = {.lex_state = 331, .external_lex_state = 9},
  [1272] = {.lex_state = 335, .external_lex_state = 15},
  [1273] = {.lex_state = 331, .external_lex_state = 8},
  [1274] = {.lex_state = 335, .external_lex_state = 15},
  [1275] = {.lex_state = 331, .external_lex_state = 6},
  [1276] = {.lex_state = 336, .external_lex_state = 3},
  [1277] = {.lex_state = 331, .external_lex_state = 7},
  [1278] = {.lex_state = 336, .external_lex_state = 3},
  [1279] = {.lex_state = 334, .external_lex_state = 3},
  [1280] = {.lex_state = 331, .external_lex_state = 7},
  [1281] = {.lex_state = 335, .external_lex_state = 3},
  [1282] = {.lex_state = 335, .external_lex_state = 3},
  [1283] = {.lex_state = 335, .external_lex_state = 16},
  [1284] = {.lex_state = 335, .external_lex_state = 16},
  [1285] = {.lex_state = 336, .external_lex_state = 3},
  [1286] = {.lex_state = 335, .external_lex_state = 3},
  [1287] = {.lex_state = 335, .external_lex_state = 3},
  [1288] = {.lex_state = 335, .external_lex_state = 3},
  [1289] = {.lex_state = 331, .external_lex_state = 5},
  [1290] = {.lex_state = 331, .external_lex_state = 5},
  [1291] = {.lex_state = 331, .external_lex_state = 4},
  [1292] = {.lex_state = 331, .external_lex_state = 5},
  [1293] = {.lex_state = 331, .external_lex_state = 4},
  [1294] = {.lex_state = 336, .external_lex_state = 3},
  [1295] = {.lex_state = 336, .external_lex_state = 3},
  [1296] = {.lex_state = 331, .external_lex_state = 5},
  [1297] = {.lex_state = 331, .external_lex_state = 4},
  [1298] = {.lex_state = 331, .external_lex_state = 5},
  [1299] = {.lex_state = 331, .external_lex_state = 5},
  [1300] = {.lex_state = 331, .external_lex_state = 5},
  [1301] = {.lex_state = 335, .external_lex_state = 3},
  [1302] = {.lex_state = 331, .external_lex_state = 5},
  [1303] = {.lex_state = 335, .external_lex_state = 3},
  [1304] = {.lex_state = 335, .external_lex_state = 3},
  [1305] = {.lex_state = 335, .external_lex_state = 17},
  [1306] = {.lex_state = 336, .external_lex_state = 3},
  [1307] = {.lex_state = 331, .external_lex_state = 4},
  [1308] = {.lex_state = 331, .external_lex_state = 4},
  [1309] = {.lex_state = 331, .external_lex_state = 4},
  [1310] = {.lex_state = 332, .external_lex_state = 10},
  [1311] = {.lex_state = 336, .external_lex_state = 3},
  [1312] = {.lex_state = 335, .external_lex_state = 17},
  [1313] = {.lex_state = 331, .external_lex_state = 4},
  [1314] = {.lex_state = 331, .external_lex_state = 4},
  [1315] = {.lex_state = 335, .external_lex_state = 3},
  [1316] = {.lex_state = 331, .external_lex_state = 5},
  [1317] = {.lex_state = 335, .external_lex_state = 3},
  [1318] = {.lex_state = 335, .external_lex_state = 18},
  [1319] = {.lex_state = 331, .external_lex_state = 8},
  [1320] = {.lex_state = 335, .external_lex_state = 3},
  [1321] = {.lex_state = 335, .external_lex_state = 16},
  [1322] = {.lex_state = 335, .external_lex_state = 3},
  [1323] = {.lex_state = 335, .external_lex_state = 3},
  [1324] = {.lex_state = 335, .external_lex_state = 19},
  [1325] = {.lex_state = 331, .external_lex_state = 4},
  [1326] = {.lex_state = 331, .external_lex_state = 4},
  [1327] = {.lex_state = 335, .external_lex_state = 3},
  [1328] = {.lex_state = 331, .external_lex_state = 9},
  [1329] = {.lex_state = 335, .external_lex_state = 3},
  [1330] = {.lex_state = 331, .external_lex_state = 4},
  [1331] = {.lex_state = 331, .external_lex_state = 4},
  [1332] = {.lex_state = 335, .external_lex_state = 3},
  [1333] = {.lex_state = 335, .external_lex_state = 3},
  [1334] = {.lex_state = 335, .external_lex_state = 3},
  [1335] = {.lex_state = 331, .external_lex_state = 9},
  [1336] = {.lex_state = 335, .external_lex_state = 3},
  [1337] = {.lex_state = 335, .external_lex_state = 17},
  [1338] = {.lex_state = 335, .external_lex_state = 3},
  [1339] = {.lex_state = 331, .external_lex_state = 4},
  [1340] = {.lex_state = 335, .external_lex_state = 3},
  [1341] = {.lex_state = 331, .external_lex_state = 8},
  [1342] = {.lex_state = 335, .external_lex_state = 3},
  [1343] = {.lex_state = 335, .external_lex_state = 3},
  [1344] = {.lex_state = 331, .external_lex_state = 4},
  [1345] = {.lex_state = 335, .external_lex_state = 3},
  [1346] = {.lex_state = 335, .external_lex_state = 3},
  [1347] = {.lex_state = 335, .external_lex_state = 3},
  [1348] = {.lex_state = 331, .external_lex_state = 4},
  [1349] = {.lex_state = 331, .external_lex_state = 7},
  [1350] = {.lex_state = 335, .external_lex_state = 3},
  [1351] = {.lex_state = 335, .external_lex_state = 3},
  [1352] = {.lex_state = 335, .external_lex_state = 3},
  [1353] = {.lex_state = 331, .external_lex_state = 4},
  [1354] = {.lex_state = 331, .external_lex_state = 4},
  [1355] = {.lex_state = 335, .external_lex_state = 3},
  [1356] = {.lex_state = 335, .external_lex_state = 3},
  [1357] = {.lex_state = 335, .external_lex_state = 3},
  [1358] = {.lex_state = 335, .external_lex_state = 3},
  [1359] = {.lex_state = 335, .external_lex_state = 3},
  [1360] = {.lex_state = 331, .external_lex_state = 4},
  [1361] = {.lex_state = 331, .external_lex_state = 9},
  [1362] = {.lex_state = 335, .external_lex_state = 3},
  [1363] = {.lex_state = 331, .external_lex_state = 7},
  [1364] = {.lex_state = 331, .external_lex_state = 8},
  [1365] = {.lex_state = 335, .external_lex_state = 3},
  [1366] = {.lex_state = 335, .external_lex_state = 3},
  [1367] = {.lex_state = 331, .external_lex_state = 8},
  [1368] = {.lex_state = 335, .external_lex_state = 3},
  [1369] = {.lex_state = 335, .external_lex_state = 3},
  [1370] = {.lex_state = 331, .external_lex_state = 9},
  [1371] = {.lex_state = 335, .external_lex_state = 3},
  [1372] = {.lex_state = 335, .external_lex_state = 3},
  [1373] = {.lex_state = 331, .external_lex_state = 4},
  [1374] = {.lex_state = 335, .external_lex_state = 3},
  [1375] = {.lex_state = 331, .external_lex_state = 8},
  [1376] = {.lex_state = 335, .external_lex_state = 3},
  [1377] = {.lex_state = 331, .external_lex_state = 6},
  [1378] = {.lex_state = 331, .external_lex_state = 4},
  [1379] = {.lex_state = 335, .external_lex_state = 3},
  [1380] = {.lex_state = 335, .external_lex_state = 3},
  [1381] = {.lex_state = 331, .external_lex_state = 6},
  [1382] = {.lex_state = 335, .external_lex_state = 3},
  [1383] = {.lex_state = 335, .external_lex_state = 3},
  [1384] = {.lex_state = 69, .external_lex_state = 9},
  [1385] = {.lex_state = 335, .external_lex_state = 3},
  [1386] = {.lex_state = 331, .external_lex_state = 7},
  [1387] = {.lex_state = 331, .external_lex_state = 6},
  [1388] = {.lex_state = 331, .external_lex_state = 5},
  [1389] = {.lex_state = 331, .external_lex_state = 5},
  [1390] = {.lex_state = 335, .external_lex_state = 3},
  [1391] = {.lex_state = 331, .external_lex_state = 7},
  [1392] = {.lex_state = 335, .external_lex_state = 20},
  [1393] = {.lex_state = 335, .external_lex_state = 3},
  [1394] = {.lex_state = 335, .external_lex_state = 3},
  [1395] = {.lex_state = 335, .external_lex_state = 3},
  [1396] = {.lex_state = 335, .external_lex_state = 3},
  [1397] = {.lex_state = 331, .external_lex_state = 9},
  [1398] = {.lex_state = 335, .external_lex_state = 3},
  [1399] = {.lex_state = 335, .external_lex_state = 18},
  [1400] = {.lex_state = 331, .external_lex_state = 7},
  [1401] = {.lex_state = 335, .external_lex_state = 3},
  [1402] = {.lex_state = 335, .external_lex_state = 3},
  [1403] = {.lex_state = 335, .external_lex_state = 3},
  [1404] = {.lex_state = 335, .external_lex_state = 3},
  [1405] = {.lex_state = 331, .external_lex_state = 4},
  [1406] = {.lex_state = 331, .external_lex_state = 6},
  [1407] = {.lex_state = 335, .external_lex_state = 3},
  [1408] = {.lex_state = 335, .external_lex_state = 3},
  [1409] = {.lex_state = 335, .external_lex_state = 3},
  [1410] = {.lex_state = 331, .external_lex_state = 4},
  [1411] = {.lex_state = 331, .external_lex_state = 5},
  [1412] = {.lex_state = 331, .external_lex_state = 5},
  [1413] = {.lex_state = 335, .external_lex_state = 3},
  [1414] = {.lex_state = 331, .external_lex_state = 8},
  [1415] = {.lex_state = 331, .external_lex_state = 8},
  [1416] = {.lex_state = 331, .external_lex_state = 6},
  [1417] = {.lex_state = 331, .external_lex_state = 5},
  [1418] = {.lex_state = 331, .external_lex_state = 5},
  [1419] = {.lex_state = 335, .external_lex_state = 3},
  [1420] = {.lex_state = 331, .external_lex_state = 8},
  [1421] = {.lex_state = 331, .external_lex_state = 9},
  [1422] = {.lex_state = 331, .external_lex_state = 6},
  [1423] = {.lex_state = 335, .external_lex_state = 3},
  [1424] = {.lex_state = 335, .external_lex_state = 3},
  [1425] = {.lex_state = 331, .external_lex_state = 5},
  [1426] = {.lex_state = 331, .external_lex_state = 5},
  [1427] = {.lex_state = 331, .external_lex_state = 4},
  [1428] = {.lex_state = 331, .external_lex_state = 9},
  [1429] = {.lex_state = 335, .external_lex_state = 3},
  [1430] = {.lex_state = 331, .external_lex_state = 9},
  [1431] = {.lex_state = 335, .external_lex_state = 3},
  [1432] = {.lex_state = 331, .external_lex_state = 4},
  [1433] = {.lex_state = 331, .external_lex_state = 4},
  [1434] = {.lex_state = 331, .external_lex_state = 5},
  [1435] = {.lex_state = 331, .external_lex_state = 7},
  [1436] = {.lex_state = 331, .external_lex_state = 5},
  [1437] = {.lex_state = 335, .external_lex_state = 21},
  [1438] = {.lex_state = 335, .external_lex_state = 3},
  [1439] = {.lex_state = 335, .external_lex_state = 3},
  [1440] = {.lex_state = 331, .external_lex_state = 5},
  [1441] = {.lex_state = 331, .external_lex_state = 5},
  [1442] = {.lex_state = 335, .external_lex_state = 3},
  [1443] = {.lex_state = 335, .external_lex_state = 3},
  [1444] = {.lex_state = 331, .external_lex_state = 5},
  [1445] = {.lex_state = 331, .external_lex_state = 5},
  [1446] = {.lex_state = 331, .external_lex_state = 5},
  [1447] = {.lex_state = 335, .external_lex_state = 3},
  [1448] = {.lex_state = 331, .external_lex_state = 5},
  [1449] = {.lex_state = 331, .external_lex_state = 6},
  [1450] = {.lex_state = 335, .external_lex_state = 3},
  [1451] = {.lex_state = 335, .external_lex_state = 3},
  [1452] = {.lex_state = 335, .external_lex_state = 3},
  [1453] = {.lex_state = 331, .external_lex_state = 7},
  [1454] = {.lex_state = 335, .external_lex_state = 3},
  [1455] = {.lex_state = 335, .external_lex_state = 3},
  [1456] = {.lex_state = 335, .external_lex_state = 3},
  [1457] = {.lex_state = 335, .external_lex_state = 3},
  [1458] = {.lex_state = 335, .external_lex_state = 3},
  [1459] = {.lex_state = 335, .external_lex_state = 3},
  [1460] = {.lex_state = 331, .external_lex_state = 6},
  [1461] = {.lex_state = 335, .external_lex_state = 20},
  [1462] = {.lex_state = 335, .external_lex_state = 3},
  [1463] = {.lex_state = 335, .external_lex_state = 3},
  [1464] = {.lex_state = 335, .external_lex_state = 3},
  [1465] = {.lex_state = 335, .external_lex_state = 3},
  [1466] = {.lex_state = 331, .external_lex_state = 7},
  [1467] = {.lex_state = 335, .external_lex_state = 21},
  [1468] = {.lex_state = 335, .external_lex_state = 3},
  [1469] = {.lex_state = 335, .external_lex_state = 3},
  [1470] = {.lex_state = 335, .external_lex_state = 19},
  [1471] = {.lex_state = 331, .external_lex_state = 9},
  [1472] = {.lex_state = 331, .external_lex_state = 8},
  [1473] = {.lex_state = 66, .external_lex_state = 10},
  [1474] = {.lex_state = 333, .external_lex_state = 4},
  [1475] = {.lex_state = 331, .external_lex_state = 6},
  [1476] = {.lex_state = 331, .external_lex_state = 7},
  [1477] = {.lex_state = 331, .external_lex_state = 8},
  [1478] = {.lex_state = 331, .external_lex_state = 6},
  [1479] = {.lex_state = 331, .external_lex_state = 6},
  [1480] = {.lex_state = 335, .external_lex_state = 19},
  [1481] = {.lex_state = 331, .external_lex_state = 6},
  [1482] = {.lex_state = 331, .external_lex_state = 7},
  [1483] = {.lex_state = 331, .external_lex_state = 9},
  [1484] = {.lex_state = 331, .external_lex_state = 7},
  [1485] = {.lex_state = 331, .external_lex_state = 7},
  [1486] = {.lex_state = 331, .external_lex_state = 9},
  [1487] = {.lex_state = 331, .external_lex_state = 7},
  [1488] = {.lex_state = 331, .external_lex_state = 7},
  [1489] = {.lex_state = 69, .external_lex_state = 10},
  [1490] = {.lex_state = 331, .external_lex_state = 9},
  [1491] = {.lex_state = 331, .external_lex_state = 6},
  [1492] = {.lex_state = 331, .external_lex_state = 6},
  [1493] = {.lex_state = 331, .external_lex_state = 6},
  [1494] = {.lex_state = 331, .external_lex_state = 9},
  [1495] = {.lex_state = 331, .external_lex_state = 8},
  [1496] = {.lex_state = 337, .external_lex_state = 9},
  [1497] = {.lex_state = 331, .external_lex_state = 6},
  [1498] = {.lex_state = 331, .external_lex_state = 8},
  [1499] = {.lex_state = 331, .external_lex_state = 6},
  [1500] = {.lex_state = 331, .external_lex_state = 6},
  [1501] = {.lex_state = 331, .external_lex_state = 8},
  [1502] = {.lex_state = 331, .external_lex_state = 6},
  [1503] = {.lex_state = 331, .external_lex_state = 6},
  [1504] = {.lex_state = 331, .external_lex_state = 8},
  [1505] = {.lex_state = 331, .external_lex_state = 9},
  [1506] = {.lex_state = 331, .external_lex_state = 7},
  [1507] = {.lex_state = 331, .external_lex_state = 7},
  [1508] = {.lex_state = 331, .external_lex_state = 9},
  [1509] = {.lex_state = 331, .external_lex_state = 7},
  [1510] = {.lex_state = 90, .external_lex_state = 10},
  [1511] = {.lex_state = 331, .external_lex_state = 6},
  [1512] = {.lex_state = 331, .external_lex_state = 6},
  [1513] = {.lex_state = 331, .external_lex_state = 8},
  [1514] = {.lex_state = 331, .external_lex_state = 7},
  [1515] = {.lex_state = 331, .external_lex_state = 8},
  [1516] = {.lex_state = 335, .external_lex_state = 20},
  [1517] = {.lex_state = 331, .external_lex_state = 7},
  [1518] = {.lex_state = 331, .external_lex_state = 7},
  [1519] = {.lex_state = 331, .external_lex_state = 9},
  [1520] = {.lex_state = 331, .external_lex_state = 8},
  [1521] = {.lex_state = 331, .external_lex_state = 6},
  [1522] = {.lex_state = 331, .external_lex_state = 8},
  [1523] = {.lex_state = 337, .external_lex_state = 4},
  [1524] = {.lex_state = 331, .external_lex_state = 6},
  [1525] = {.lex_state = 331, .external_lex_state = 8},
  [1526] = {.lex_state = 331, .external_lex_state = 7},
  [1527] = {.lex_state = 331, .external_lex_state = 7},
  [1528] = {.lex_state = 331, .external_lex_state = 9},
  [1529] = {.lex_state = 335, .external_lex_state = 18},
  [1530] = {.lex_state = 333, .external_lex_state = 5},
  [1531] = {.lex_state = 66, .external_lex_state = 9},
  [1532] = {.lex_state = 331, .external_lex_state = 9},
  [1533] = {.lex_state = 331, .external_lex_state = 8},
  [1534] = {.lex_state = 331, .external_lex_state = 7},
  [1535] = {.lex_state = 331, .external_lex_state = 8},
  [1536] = {.lex_state = 331, .external_lex_state = 9},
  [1537] = {.lex_state = 331, .external_lex_state = 8},
  [1538] = {.lex_state = 331, .external_lex_state = 9},
  [1539] = {.lex_state = 331, .external_lex_state = 9},
  [1540] = {.lex_state = 331, .external_lex_state = 9},
  [1541] = {.lex_state = 331, .external_lex_state = 9},
  [1542] = {.lex_state = 331, .external_lex_state = 6},
  [1543] = {.lex_state = 331, .external_lex_state = 8},
  [1544] = {.lex_state = 335, .external_lex_state = 21},
  [1545] = {.lex_state = 331, .external_lex_state = 7},
  [1546] = {.lex_state = 331, .external_lex_state = 8},
  [1547] = {.lex_state = 331, .external_lex_state = 7},
  [1548] = {.lex_state = 337, .external_lex_state = 6},
  [1549] = {.lex_state = 331, .external_lex_state = 8},
  [1550] = {.lex_state = 331, .external_lex_state = 9},
  [1551] = {.lex_state = 331, .external_lex_state = 9},
  [1552] = {.lex_state = 334, .external_lex_state = 5},
  [1553] = {.lex_state = 335, .external_lex_state = 17},
  [1554] = {.lex_state = 70, .external_lex_state = 10},
  [1555] = {.lex_state = 336, .external_lex_state = 5},
  [1556] = {.lex_state = 336, .external_lex_state = 4},
  [1557] = {.lex_state = 335, .external_lex_state = 17},
  [1558] = {.lex_state = 335, .external_lex_state = 16},
  [1559] = {.lex_state = 336, .external_lex_state = 4},
  [1560] = {.lex_state = 336, .external_lex_state = 4},
  [1561] = {.lex_state = 333, .external_lex_state = 8},
  [1562] = {.lex_state = 334, .external_lex_state = 5},
  [1563] = {.lex_state = 335, .external_lex_state = 16},
  [1564] = {.lex_state = 71, .external_lex_state = 10},
  [1565] = {.lex_state = 333, .external_lex_state = 7},
  [1566] = {.lex_state = 338, .external_lex_state = 5},
  [1567] = {.lex_state = 336, .external_lex_state = 4},
  [1568] = {.lex_state = 334, .external_lex_state = 4},
  [1569] = {.lex_state = 334, .external_lex_state = 5},
  [1570] = {.lex_state = 338, .external_lex_state = 4},
  [1571] = {.lex_state = 336, .external_lex_state = 5},
  [1572] = {.lex_state = 72, .external_lex_state = 10},
  [1573] = {.lex_state = 78, .external_lex_state = 9},
  [1574] = {.lex_state = 338, .external_lex_state = 4},
  [1575] = {.lex_state = 68, .external_lex_state = 10},
  [1576] = {.lex_state = 335, .external_lex_state = 16},
  [1577] = {.lex_state = 336, .external_lex_state = 5},
  [1578] = {.lex_state = 335, .external_lex_state = 17},
  [1579] = {.lex_state = 333, .external_lex_state = 6},
  [1580] = {.lex_state = 336, .external_lex_state = 5},
  [1581] = {.lex_state = 336, .external_lex_state = 5},
  [1582] = {.lex_state = 334, .external_lex_state = 4},
  [1583] = {.lex_state = 334, .external_lex_state = 4},
  [1584] = {.lex_state = 334, .external_lex_state = 5},
  [1585] = {.lex_state = 334, .external_lex_state = 4},
  [1586] = {.lex_state = 91, .external_lex_state = 10},
  [1587] = {.lex_state = 332, .external_lex_state = 9},
  [1588] = {.lex_state = 338, .external_lex_state = 5},
  [1589] = {.lex_state = 337, .external_lex_state = 8},
  [1590] = {.lex_state = 336, .external_lex_state = 4},
  [1591] = {.lex_state = 335, .external_lex_state = 21},
  [1592] = {.lex_state = 334, .external_lex_state = 8},
  [1593] = {.lex_state = 333, .external_lex_state = 9},
  [1594] = {.lex_state = 335, .external_lex_state = 5},
  [1595] = {.lex_state = 334, .external_lex_state = 6},
  [1596] = {.lex_state = 334, .external_lex_state = 7},
  [1597] = {.lex_state = 338, .external_lex_state = 8},
  [1598] = {.lex_state = 334, .external_lex_state = 6},
  [1599] = {.lex_state = 336, .external_lex_state = 8},
  [1600] = {.lex_state = 336, .external_lex_state = 6},
  [1601] = {.lex_state = 331, .external_lex_state = 10},
  [1602] = {.lex_state = 334, .external_lex_state = 7},
  [1603] = {.lex_state = 335, .external_lex_state = 4},
  [1604] = {.lex_state = 336, .external_lex_state = 8},
  [1605] = {.lex_state = 93, .external_lex_state = 10},
  [1606] = {.lex_state = 334, .external_lex_state = 6},
  [1607] = {.lex_state = 335, .external_lex_state = 4},
  [1608] = {.lex_state = 335, .external_lex_state = 18},
  [1609] = {.lex_state = 334, .external_lex_state = 8},
  [1610] = {.lex_state = 331, .external_lex_state = 10},
  [1611] = {.lex_state = 331, .external_lex_state = 10},
  [1612] = {.lex_state = 335, .external_lex_state = 21},
  [1613] = {.lex_state = 334, .external_lex_state = 8},
  [1614] = {.lex_state = 334, .external_lex_state = 6},
  [1615] = {.lex_state = 335, .external_lex_state = 4},
  [1616] = {.lex_state = 336, .external_lex_state = 5},
  [1617] = {.lex_state = 336, .external_lex_state = 5},
  [1618] = {.lex_state = 332, .external_lex_state = 4},
  [1619] = {.lex_state = 336, .external_lex_state = 7},
  [1620] = {.lex_state = 335, .external_lex_state = 5},
  [1621] = {.lex_state = 336, .external_lex_state = 9},
  [1622] = {.lex_state = 338, .external_lex_state = 8},
  [1623] = {.lex_state = 336, .external_lex_state = 8},
  [1624] = {.lex_state = 335, .external_lex_state = 20},
  [1625] = {.lex_state = 336, .external_lex_state = 5},
  [1626] = {.lex_state = 335, .external_lex_state = 5},
  [1627] = {.lex_state = 336, .external_lex_state = 5},
  [1628] = {.lex_state = 335, .external_lex_state = 5},
  [1629] = {.lex_state = 336, .external_lex_state = 8},
  [1630] = {.lex_state = 335, .external_lex_state = 19},
  [1631] = {.lex_state = 336, .external_lex_state = 4},
  [1632] = {.lex_state = 336, .external_lex_state = 9},
  [1633] = {.lex_state = 335, .external_lex_state = 18},
  [1634] = {.lex_state = 335, .external_lex_state = 4},
  [1635] = {.lex_state = 335, .external_lex_state = 5},
  [1636] = {.lex_state = 334, .external_lex_state = 7},
  [1637] = {.lex_state = 331, .external_lex_state = 10},
  [1638] = {.lex_state = 336, .external_lex_state = 6},
  [1639] = {.lex_state = 335, .external_lex_state = 5},
  [1640] = {.lex_state = 334, .external_lex_state = 8},
  [1641] = {.lex_state = 336, .external_lex_state = 4},
  [1642] = {.lex_state = 336, .external_lex_state = 6},
  [1643] = {.lex_state = 335, .external_lex_state = 5},
  [1644] = {.lex_state = 336, .external_lex_state = 5},
  [1645] = {.lex_state = 331, .external_lex_state = 10},
  [1646] = {.lex_state = 78, .external_lex_state = 10},
  [1647] = {.lex_state = 338, .external_lex_state = 7},
  [1648] = {.lex_state = 335, .external_lex_state = 18},
  [1649] = {.lex_state = 336, .external_lex_state = 8},
  [1650] = {.lex_state = 335, .external_lex_state = 4},
  [1651] = {.lex_state = 335, .external_lex_state = 21},
  [1652] = {.lex_state = 335, .external_lex_state = 5},
  [1653] = {.lex_state = 331, .external_lex_state = 10},
  [1654] = {.lex_state = 331, .external_lex_state = 10},
  [1655] = {.lex_state = 335, .external_lex_state = 20},
  [1656] = {.lex_state = 336, .external_lex_state = 7},
  [1657] = {.lex_state = 331, .external_lex_state = 10},
  [1658] = {.lex_state = 331, .external_lex_state = 10},
  [1659] = {.lex_state = 331, .external_lex_state = 10},
  [1660] = {.lex_state = 336, .external_lex_state = 4},
  [1661] = {.lex_state = 335, .external_lex_state = 20},
  [1662] = {.lex_state = 332, .external_lex_state = 6},
  [1663] = {.lex_state = 338, .external_lex_state = 6},
  [1664] = {.lex_state = 336, .external_lex_state = 4},
  [1665] = {.lex_state = 335, .external_lex_state = 9},
  [1666] = {.lex_state = 336, .external_lex_state = 9},
  [1667] = {.lex_state = 336, .external_lex_state = 9},
  [1668] = {.lex_state = 336, .external_lex_state = 7},
  [1669] = {.lex_state = 335, .external_lex_state = 4},
  [1670] = {.lex_state = 336, .external_lex_state = 9},
  [1671] = {.lex_state = 338, .external_lex_state = 6},
  [1672] = {.lex_state = 335, .external_lex_state = 19},
  [1673] = {.lex_state = 336, .external_lex_state = 4},
  [1674] = {.lex_state = 336, .external_lex_state = 7},
  [1675] = {.lex_state = 335, .external_lex_state = 19},
  [1676] = {.lex_state = 336, .external_lex_state = 7},
  [1677] = {.lex_state = 336, .external_lex_state = 6},
  [1678] = {.lex_state = 335, .external_lex_state = 4},
  [1679] = {.lex_state = 334, .external_lex_state = 7},
  [1680] = {.lex_state = 335, .external_lex_state = 4},
  [1681] = {.lex_state = 338, .external_lex_state = 7},
  [1682] = {.lex_state = 336, .external_lex_state = 6},
  [1683] = {.lex_state = 335, .external_lex_state = 4},
  [1684] = {.lex_state = 335, .external_lex_state = 5},
  [1685] = {.lex_state = 335, .external_lex_state = 9},
  [1686] = {.lex_state = 335, .external_lex_state = 5},
  [1687] = {.lex_state = 335, .external_lex_state = 5},
  [1688] = {.lex_state = 335, .external_lex_state = 5},
  [1689] = {.lex_state = 335, .external_lex_state = 4},
  [1690] = {.lex_state = 335, .external_lex_state = 4},
  [1691] = {.lex_state = 335, .external_lex_state = 4},
  [1692] = {.lex_state = 335, .external_lex_state = 5},
  [1693] = {.lex_state = 335, .external_lex_state = 4},
  [1694] = {.lex_state = 335, .external_lex_state = 4},
  [1695] = {.lex_state = 335, .external_lex_state = 9},
  [1696] = {.lex_state = 335, .external_lex_state = 6},
  [1697] = {.lex_state = 335, .external_lex_state = 4},
  [1698] = {.lex_state = 335, .external_lex_state = 9},
  [1699] = {.lex_state = 335, .external_lex_state = 6},
  [1700] = {.lex_state = 338, .external_lex_state = 9},
  [1701] = {.lex_state = 335, .external_lex_state = 9},
  [1702] = {.lex_state = 94, .external_lex_state = 10},
  [1703] = {.lex_state = 335, .external_lex_state = 4},
  [1704] = {.lex_state = 335, .external_lex_state = 4},
  [1705] = {.lex_state = 335, .external_lex_state = 6},
  [1706] = {.lex_state = 335, .external_lex_state = 6},
  [1707] = {.lex_state = 335, .external_lex_state = 8},
  [1708] = {.lex_state = 336, .external_lex_state = 8},
  [1709] = {.lex_state = 335, .external_lex_state = 4},
  [1710] = {.lex_state = 335, .external_lex_state = 4},
  [1711] = {.lex_state = 335, .external_lex_state = 4},
  [1712] = {.lex_state = 336, .external_lex_state = 8},
  [1713] = {.lex_state = 335, .external_lex_state = 6},
  [1714] = {.lex_state = 336, .external_lex_state = 8},
  [1715] = {.lex_state = 335, .external_lex_state = 5},
  [1716] = {.lex_state = 335, .external_lex_state = 4},
  [1717] = {.lex_state = 335, .external_lex_state = 9},
  [1718] = {.lex_state = 335, .external_lex_state = 4},
  [1719] = {.lex_state = 335, .external_lex_state = 4},
  [1720] = {.lex_state = 335, .external_lex_state = 4},
  [1721] = {.lex_state = 335, .external_lex_state = 4},
  [1722] = {.lex_state = 335, .external_lex_state = 4},
  [1723] = {.lex_state = 335, .external_lex_state = 4},
  [1724] = {.lex_state = 335, .external_lex_state = 4},
  [1725] = {.lex_state = 335, .external_lex_state = 4},
  [1726] = {.lex_state = 335, .external_lex_state = 4},
  [1727] = {.lex_state = 336, .external_lex_state = 8},
  [1728] = {.lex_state = 335, .external_lex_state = 5},
  [1729] = {.lex_state = 335, .external_lex_state = 5},
  [1730] = {.lex_state = 335, .external_lex_state = 4},
  [1731] = {.lex_state = 335, .external_lex_state = 5},
  [1732] = {.lex_state = 335, .external_lex_state = 5},
  [1733] = {.lex_state = 335, .external_lex_state = 4},
  [1734] = {.lex_state = 335, .external_lex_state = 4},
  [1735] = {.lex_state = 335, .external_lex_state = 5},
  [1736] = {.lex_state = 335, .external_lex_state = 5},
  [1737] = {.lex_state = 335, .external_lex_state = 5},
  [1738] = {.lex_state = 335, .external_lex_state = 4},
  [1739] = {.lex_state = 335, .external_lex_state = 4},
  [1740] = {.lex_state = 335, .external_lex_state = 4},
  [1741] = {.lex_state = 335, .external_lex_state = 4},
  [1742] = {.lex_state = 335, .external_lex_state = 5},
  [1743] = {.lex_state = 335, .external_lex_state = 4},
  [1744] = {.lex_state = 335, .external_lex_state = 4},
  [1745] = {.lex_state = 335, .external_lex_state = 4},
  [1746] = {.lex_state = 335, .external_lex_state = 4},
  [1747] = {.lex_state = 335, .external_lex_state = 5},
  [1748] = {.lex_state = 335, .external_lex_state = 4},
  [1749] = {.lex_state = 335, .external_lex_state = 5},
  [1750] = {.lex_state = 335, .external_lex_state = 5},
  [1751] = {.lex_state = 335, .external_lex_state = 4},
  [1752] = {.lex_state = 335, .external_lex_state = 4},
  [1753] = {.lex_state = 332, .external_lex_state = 8},
  [1754] = {.lex_state = 335, .external_lex_state = 5},
  [1755] = {.lex_state = 335, .external_lex_state = 4},
  [1756] = {.lex_state = 335, .external_lex_state = 4},
  [1757] = {.lex_state = 335, .external_lex_state = 5},
  [1758] = {.lex_state = 335, .external_lex_state = 5},
  [1759] = {.lex_state = 335, .external_lex_state = 4},
  [1760] = {.lex_state = 335, .external_lex_state = 7},
  [1761] = {.lex_state = 335, .external_lex_state = 5},
  [1762] = {.lex_state = 335, .external_lex_state = 5},
  [1763] = {.lex_state = 335, .external_lex_state = 5},
  [1764] = {.lex_state = 335, .external_lex_state = 5},
  [1765] = {.lex_state = 335, .external_lex_state = 8},
  [1766] = {.lex_state = 335, .external_lex_state = 5},
  [1767] = {.lex_state = 335, .external_lex_state = 5},
  [1768] = {.lex_state = 335, .external_lex_state = 5},
  [1769] = {.lex_state = 335, .external_lex_state = 7},
  [1770] = {.lex_state = 335, .external_lex_state = 5},
  [1771] = {.lex_state = 335, .external_lex_state = 5},
  [1772] = {.lex_state = 335, .external_lex_state = 5},
  [1773] = {.lex_state = 335, .external_lex_state = 5},
  [1774] = {.lex_state = 335, .external_lex_state = 4},
  [1775] = {.lex_state = 335, .external_lex_state = 5},
  [1776] = {.lex_state = 335, .external_lex_state = 5},
  [1777] = {.lex_state = 335, .external_lex_state = 5},
  [1778] = {.lex_state = 336, .external_lex_state = 6},
  [1779] = {.lex_state = 336, .external_lex_state = 6},
  [1780] = {.lex_state = 335, .external_lex_state = 8},
  [1781] = {.lex_state = 338, .external_lex_state = 9},
  [1782] = {.lex_state = 335, .external_lex_state = 8},
  [1783] = {.lex_state = 335, .external_lex_state = 5},
  [1784] = {.lex_state = 335, .external_lex_state = 8},
  [1785] = {.lex_state = 335, .external_lex_state = 5},
  [1786] = {.lex_state = 336, .external_lex_state = 7},
  [1787] = {.lex_state = 335, .external_lex_state = 4},
  [1788] = {.lex_state = 335, .external_lex_state = 6},
  [1789] = {.lex_state = 335, .external_lex_state = 8},
  [1790] = {.lex_state = 335, .external_lex_state = 8},
  [1791] = {.lex_state = 335, .external_lex_state = 4},
  [1792] = {.lex_state = 336, .external_lex_state = 6},
  [1793] = {.lex_state = 335, .external_lex_state = 6},
  [1794] = {.lex_state = 335, .external_lex_state = 5},
  [1795] = {.lex_state = 335, .external_lex_state = 6},
  [1796] = {.lex_state = 335, .external_lex_state = 5},
  [1797] = {.lex_state = 335, .external_lex_state = 5},
  [1798] = {.lex_state = 335, .external_lex_state = 5},
  [1799] = {.lex_state = 82, .external_lex_state = 10},
  [1800] = {.lex_state = 335, .external_lex_state = 5},
  [1801] = {.lex_state = 336, .external_lex_state = 6},
  [1802] = {.lex_state = 336, .external_lex_state = 9},
  [1803] = {.lex_state = 335, .external_lex_state = 4},
  [1804] = {.lex_state = 335, .external_lex_state = 5},
  [1805] = {.lex_state = 335, .external_lex_state = 5},
  [1806] = {.lex_state = 335, .external_lex_state = 5},
  [1807] = {.lex_state = 335, .external_lex_state = 5},
  [1808] = {.lex_state = 336, .external_lex_state = 6},
  [1809] = {.lex_state = 335, .external_lex_state = 5},
  [1810] = {.lex_state = 335, .external_lex_state = 5},
  [1811] = {.lex_state = 335, .external_lex_state = 5},
  [1812] = {.lex_state = 335, .external_lex_state = 5},
  [1813] = {.lex_state = 335, .external_lex_state = 5},
  [1814] = {.lex_state = 335, .external_lex_state = 5},
  [1815] = {.lex_state = 335, .external_lex_state = 7},
  [1816] = {.lex_state = 335, .external_lex_state = 5},
  [1817] = {.lex_state = 335, .external_lex_state = 5},
  [1818] = {.lex_state = 335, .external_lex_state = 5},
  [1819] = {.lex_state = 335, .external_lex_state = 5},
  [1820] = {.lex_state = 335, .external_lex_state = 5},
  [1821] = {.lex_state = 335, .external_lex_state = 5},
  [1822] = {.lex_state = 335, .external_lex_state = 5},
  [1823] = {.lex_state = 336, .external_lex_state = 8},
  [1824] = {.lex_state = 335, .external_lex_state = 5},
  [1825] = {.lex_state = 335, .external_lex_state = 5},
  [1826] = {.lex_state = 335, .external_lex_state = 5},
  [1827] = {.lex_state = 335, .external_lex_state = 5},
  [1828] = {.lex_state = 335, .external_lex_state = 5},
  [1829] = {.lex_state = 335, .external_lex_state = 5},
  [1830] = {.lex_state = 335, .external_lex_state = 5},
  [1831] = {.lex_state = 335, .external_lex_state = 5},
  [1832] = {.lex_state = 335, .external_lex_state = 5},
  [1833] = {.lex_state = 335, .external_lex_state = 7},
  [1834] = {.lex_state = 335, .external_lex_state = 7},
  [1835] = {.lex_state = 335, .external_lex_state = 5},
  [1836] = {.lex_state = 335, .external_lex_state = 5},
  [1837] = {.lex_state = 335, .external_lex_state = 5},
  [1838] = {.lex_state = 335, .external_lex_state = 5},
  [1839] = {.lex_state = 336, .external_lex_state = 9},
  [1840] = {.lex_state = 336, .external_lex_state = 9},
  [1841] = {.lex_state = 335, .external_lex_state = 5},
  [1842] = {.lex_state = 335, .external_lex_state = 7},
  [1843] = {.lex_state = 335, .external_lex_state = 4},
  [1844] = {.lex_state = 335, .external_lex_state = 4},
  [1845] = {.lex_state = 335, .external_lex_state = 4},
  [1846] = {.lex_state = 86, .external_lex_state = 10},
  [1847] = {.lex_state = 335, .external_lex_state = 4},
  [1848] = {.lex_state = 335, .external_lex_state = 4},
  [1849] = {.lex_state = 335, .external_lex_state = 4},
  [1850] = {.lex_state = 335, .external_lex_state = 5},
  [1851] = {.lex_state = 335, .external_lex_state = 5},
  [1852] = {.lex_state = 335, .external_lex_state = 4},
  [1853] = {.lex_state = 335, .external_lex_state = 5},
  [1854] = {.lex_state = 335, .external_lex_state = 4},
  [1855] = {.lex_state = 335, .external_lex_state = 4},
  [1856] = {.lex_state = 335, .external_lex_state = 4},
  [1857] = {.lex_state = 335, .external_lex_state = 4},
  [1858] = {.lex_state = 335, .external_lex_state = 5},
  [1859] = {.lex_state = 335, .external_lex_state = 5},
  [1860] = {.lex_state = 335, .external_lex_state = 4},
  [1861] = {.lex_state = 335, .external_lex_state = 8},
  [1862] = {.lex_state = 74, .external_lex_state = 10},
  [1863] = {.lex_state = 334, .external_lex_state = 9},
  [1864] = {.lex_state = 336, .external_lex_state = 9},
  [1865] = {.lex_state = 334, .external_lex_state = 9},
  [1866] = {.lex_state = 335, .external_lex_state = 4},
  [1867] = {.lex_state = 335, .external_lex_state = 4},
  [1868] = {.lex_state = 335, .external_lex_state = 4},
  [1869] = {.lex_state = 335, .external_lex_state = 4},
  [1870] = {.lex_state = 335, .external_lex_state = 4},
  [1871] = {.lex_state = 335, .external_lex_state = 7},
  [1872] = {.lex_state = 335, .external_lex_state = 4},
  [1873] = {.lex_state = 335, .external_lex_state = 4},
  [1874] = {.lex_state = 335, .external_lex_state = 9},
  [1875] = {.lex_state = 335, .external_lex_state = 4},
  [1876] = {.lex_state = 335, .external_lex_state = 4},
  [1877] = {.lex_state = 335, .external_lex_state = 4},
  [1878] = {.lex_state = 335, .external_lex_state = 4},
  [1879] = {.lex_state = 335, .external_lex_state = 4},
  [1880] = {.lex_state = 335, .external_lex_state = 4},
  [1881] = {.lex_state = 335, .external_lex_state = 4},
  [1882] = {.lex_state = 335, .external_lex_state = 4},
  [1883] = {.lex_state = 335, .external_lex_state = 4},
  [1884] = {.lex_state = 335, .external_lex_state = 4},
  [1885] = {.lex_state = 336, .external_lex_state = 7},
  [1886] = {.lex_state = 335, .external_lex_state = 4},
  [1887] = {.lex_state = 336, .external_lex_state = 9},
  [1888] = {.lex_state = 336, .external_lex_state = 7},
  [1889] = {.lex_state = 336, .external_lex_state = 7},
  [1890] = {.lex_state = 335, .external_lex_state = 7},
  [1891] = {.lex_state = 334, .external_lex_state = 9},
  [1892] = {.lex_state = 335, .external_lex_state = 4},
  [1893] = {.lex_state = 334, .external_lex_state = 9},
  [1894] = {.lex_state = 336, .external_lex_state = 7},
  [1895] = {.lex_state = 335, .external_lex_state = 4},
  [1896] = {.lex_state = 335, .external_lex_state = 4},
  [1897] = {.lex_state = 335, .external_lex_state = 4},
  [1898] = {.lex_state = 335, .external_lex_state = 7},
  [1899] = {.lex_state = 335, .external_lex_state = 9},
  [1900] = {.lex_state = 335, .external_lex_state = 6},
  [1901] = {.lex_state = 335, .external_lex_state = 6},
  [1902] = {.lex_state = 335, .external_lex_state = 6},
  [1903] = {.lex_state = 335, .external_lex_state = 6},
  [1904] = {.lex_state = 335, .external_lex_state = 9},
  [1905] = {.lex_state = 335, .external_lex_state = 9},
  [1906] = {.lex_state = 335, .external_lex_state = 9},
  [1907] = {.lex_state = 335, .external_lex_state = 6},
  [1908] = {.lex_state = 335, .external_lex_state = 6},
  [1909] = {.lex_state = 335, .external_lex_state = 6},
  [1910] = {.lex_state = 335, .external_lex_state = 6},
  [1911] = {.lex_state = 335, .external_lex_state = 6},
  [1912] = {.lex_state = 335, .external_lex_state = 6},
  [1913] = {.lex_state = 335, .external_lex_state = 9},
  [1914] = {.lex_state = 335, .external_lex_state = 6},
  [1915] = {.lex_state = 335, .external_lex_state = 6},
  [1916] = {.lex_state = 335, .external_lex_state = 9},
  [1917] = {.lex_state = 335, .external_lex_state = 6},
  [1918] = {.lex_state = 335, .external_lex_state = 6},
  [1919] = {.lex_state = 335, .external_lex_state = 6},
  [1920] = {.lex_state = 335, .external_lex_state = 6},
  [1921] = {.lex_state = 331, .external_lex_state = 10},
  [1922] = {.lex_state = 335, .external_lex_state = 6},
  [1923] = {.lex_state = 335, .external_lex_state = 6},
  [1924] = {.lex_state = 335, .external_lex_state = 9},
  [1925] = {.lex_state = 335, .external_lex_state = 6},
  [1926] = {.lex_state = 335, .external_lex_state = 9},
  [1927] = {.lex_state = 335, .external_lex_state = 6},
  [1928] = {.lex_state = 335, .external_lex_state = 8},
  [1929] = {.lex_state = 335, .external_lex_state = 9},
  [1930] = {.lex_state = 335, .external_lex_state = 9},
  [1931] = {.lex_state = 335, .external_lex_state = 6},
  [1932] = {.lex_state = 335, .external_lex_state = 9},
  [1933] = {.lex_state = 335, .external_lex_state = 6},
  [1934] = {.lex_state = 335, .external_lex_state = 9},
  [1935] = {.lex_state = 335, .external_lex_state = 8},
  [1936] = {.lex_state = 335, .external_lex_state = 9},
  [1937] = {.lex_state = 335, .external_lex_state = 9},
  [1938] = {.lex_state = 335, .external_lex_state = 6},
  [1939] = {.lex_state = 335, .external_lex_state = 6},
  [1940] = {.lex_state = 335, .external_lex_state = 9},
  [1941] = {.lex_state = 335, .external_lex_state = 6},
  [1942] = {.lex_state = 335, .external_lex_state = 8},
  [1943] = {.lex_state = 335, .external_lex_state = 6},
  [1944] = {.lex_state = 335, .external_lex_state = 6},
  [1945] = {.lex_state = 335, .external_lex_state = 6},
  [1946] = {.lex_state = 335, .external_lex_state = 7},
  [1947] = {.lex_state = 335, .external_lex_state = 6},
  [1948] = {.lex_state = 335, .external_lex_state = 8},
  [1949] = {.lex_state = 335, .external_lex_state = 8},
  [1950] = {.lex_state = 335, .external_lex_state = 6},
  [1951] = {.lex_state = 335, .external_lex_state = 6},
  [1952] = {.lex_state = 335, .external_lex_state = 6},
  [1953] = {.lex_state = 335, .external_lex_state = 7},
  [1954] = {.lex_state = 335, .external_lex_state = 9},
  [1955] = {.lex_state = 335, .external_lex_state = 9},
  [1956] = {.lex_state = 335, .external_lex_state = 9},
  [1957] = {.lex_state = 331, .external_lex_state = 10},
  [1958] = {.lex_state = 335, .external_lex_state = 9},
  [1959] = {.lex_state = 335, .external_lex_state = 6},
  [1960] = {.lex_state = 335, .external_lex_state = 9},
  [1961] = {.lex_state = 335, .external_lex_state = 6},
  [1962] = {.lex_state = 335, .external_lex_state = 9},
  [1963] = {.lex_state = 335, .external_lex_state = 9},
  [1964] = {.lex_state = 335, .external_lex_state = 7},
  [1965] = {.lex_state = 335, .external_lex_state = 6},
  [1966] = {.lex_state = 335, .external_lex_state = 9},
  [1967] = {.lex_state = 335, .external_lex_state = 9},
  [1968] = {.lex_state = 335, .external_lex_state = 8},
  [1969] = {.lex_state = 335, .external_lex_state = 6},
  [1970] = {.lex_state = 335, .external_lex_state = 7},
  [1971] = {.lex_state = 335, .external_lex_state = 7},
  [1972] = {.lex_state = 335, .external_lex_state = 22},
  [1973] = {.lex_state = 335, .external_lex_state = 7},
  [1974] = {.lex_state = 331, .external_lex_state = 10},
  [1975] = {.lex_state = 331, .external_lex_state = 10},
  [1976] = {.lex_state = 335, .external_lex_state = 7},
  [1977] = {.lex_state = 335, .external_lex_state = 7},
  [1978] = {.lex_state = 335, .external_lex_state = 6},
  [1979] = {.lex_state = 335, .external_lex_state = 8},
  [1980] = {.lex_state = 331, .external_lex_state = 10},
  [1981] = {.lex_state = 331, .external_lex_state = 10},
  [1982] = {.lex_state = 335, .external_lex_state = 6},
  [1983] = {.lex_state = 335, .external_lex_state = 9},
  [1984] = {.lex_state = 335, .external_lex_state = 9},
  [1985] = {.lex_state = 335, .external_lex_state = 7},
  [1986] = {.lex_state = 335, .external_lex_state = 7},
  [1987] = {.lex_state = 335, .external_lex_state = 7},
  [1988] = {.lex_state = 335, .external_lex_state = 7},
  [1989] = {.lex_state = 335, .external_lex_state = 7},
  [1990] = {.lex_state = 335, .external_lex_state = 7},
  [1991] = {.lex_state = 335, .external_lex_state = 7},
  [1992] = {.lex_state = 335, .external_lex_state = 7},
  [1993] = {.lex_state = 335, .external_lex_state = 7},
  [1994] = {.lex_state = 335, .external_lex_state = 9},
  [1995] = {.lex_state = 335, .external_lex_state = 7},
  [1996] = {.lex_state = 335, .external_lex_state = 8},
  [1997] = {.lex_state = 335, .external_lex_state = 7},
  [1998] = {.lex_state = 335, .external_lex_state = 7},
  [1999] = {.lex_state = 335, .external_lex_state = 7},
  [2000] = {.lex_state = 335, .external_lex_state = 7},
  [2001] = {.lex_state = 335, .external_lex_state = 7},
  [2002] = {.lex_state = 335, .external_lex_state = 7},
  [2003] = {.lex_state = 335, .external_lex_state = 8},
  [2004] = {.lex_state = 335, .external_lex_state = 7},
  [2005] = {.lex_state = 335, .external_lex_state = 7},
  [2006] = {.lex_state = 335, .external_lex_state = 7},
  [2007] = {.lex_state = 335, .external_lex_state = 9},
  [2008] = {.lex_state = 335, .external_lex_state = 9},
  [2009] = {.lex_state = 335, .external_lex_state = 9},
  [2010] = {.lex_state = 335, .external_lex_state = 9},
  [2011] = {.lex_state = 335, .external_lex_state = 6},
  [2012] = {.lex_state = 335, .external_lex_state = 9},
  [2013] = {.lex_state = 335, .external_lex_state = 9},
  [2014] = {.lex_state = 331, .external_lex_state = 10},
  [2015] = {.lex_state = 335, .external_lex_state = 9},
  [2016] = {.lex_state = 335, .external_lex_state = 9},
  [2017] = {.lex_state = 335, .external_lex_state = 9},
  [2018] = {.lex_state = 335, .external_lex_state = 9},
  [2019] = {.lex_state = 335, .external_lex_state = 8},
  [2020] = {.lex_state = 335, .external_lex_state = 8},
  [2021] = {.lex_state = 335, .external_lex_state = 9},
  [2022] = {.lex_state = 335, .external_lex_state = 9},
  [2023] = {.lex_state = 335, .external_lex_state = 8},
  [2024] = {.lex_state = 335, .external_lex_state = 8},
  [2025] = {.lex_state = 335, .external_lex_state = 6},
  [2026] = {.lex_state = 335, .external_lex_state = 22},
  [2027] = {.lex_state = 335, .external_lex_state = 9},
  [2028] = {.lex_state = 335, .external_lex_state = 7},
  [2029] = {.lex_state = 335, .external_lex_state = 7},
  [2030] = {.lex_state = 335, .external_lex_state = 9},
  [2031] = {.lex_state = 335, .external_lex_state = 6},
  [2032] = {.lex_state = 335, .external_lex_state = 7},
  [2033] = {.lex_state = 335, .external_lex_state = 7},
  [2034] = {.lex_state = 335, .external_lex_state = 7},
  [2035] = {.lex_state = 335, .external_lex_state = 8},
  [2036] = {.lex_state = 335, .external_lex_state = 7},
  [2037] = {.lex_state = 331, .external_lex_state = 10},
  [2038] = {.lex_state = 335, .external_lex_state = 9},
  [2039] = {.lex_state = 335, .external_lex_state = 6},
  [2040] = {.lex_state = 335, .external_lex_state = 7},
  [2041] = {.lex_state = 335, .external_lex_state = 7},
  [2042] = {.lex_state = 335, .external_lex_state = 8},
  [2043] = {.lex_state = 335, .external_lex_state = 7},
  [2044] = {.lex_state = 335, .external_lex_state = 7},
  [2045] = {.lex_state = 335, .external_lex_state = 9},
  [2046] = {.lex_state = 335, .external_lex_state = 6},
  [2047] = {.lex_state = 335, .external_lex_state = 9},
  [2048] = {.lex_state = 335, .external_lex_state = 9},
  [2049] = {.lex_state = 335, .external_lex_state = 9},
  [2050] = {.lex_state = 335, .external_lex_state = 9},
  [2051] = {.lex_state = 335, .external_lex_state = 7},
  [2052] = {.lex_state = 335, .external_lex_state = 7},
  [2053] = {.lex_state = 335, .external_lex_state = 9},
  [2054] = {.lex_state = 335, .external_lex_state = 8},
  [2055] = {.lex_state = 335, .external_lex_state = 8},
  [2056] = {.lex_state = 335, .external_lex_state = 7},
  [2057] = {.lex_state = 335, .external_lex_state = 7},
  [2058] = {.lex_state = 335, .external_lex_state = 7},
  [2059] = {.lex_state = 335, .external_lex_state = 7},
  [2060] = {.lex_state = 335, .external_lex_state = 8},
  [2061] = {.lex_state = 335, .external_lex_state = 6},
  [2062] = {.lex_state = 335, .external_lex_state = 8},
  [2063] = {.lex_state = 335, .external_lex_state = 6},
  [2064] = {.lex_state = 335, .external_lex_state = 6},
  [2065] = {.lex_state = 335, .external_lex_state = 8},
  [2066] = {.lex_state = 335, .external_lex_state = 9},
  [2067] = {.lex_state = 335, .external_lex_state = 8},
  [2068] = {.lex_state = 335, .external_lex_state = 6},
  [2069] = {.lex_state = 335, .external_lex_state = 7},
  [2070] = {.lex_state = 335, .external_lex_state = 8},
  [2071] = {.lex_state = 335, .external_lex_state = 6},
  [2072] = {.lex_state = 335, .external_lex_state = 7},
  [2073] = {.lex_state = 335, .external_lex_state = 7},
  [2074] = {.lex_state = 335, .external_lex_state = 7},
  [2075] = {.lex_state = 335, .external_lex_state = 8},
  [2076] = {.lex_state = 335, .external_lex_state = 8},
  [2077] = {.lex_state = 335, .external_lex_state = 7},
  [2078] = {.lex_state = 335, .external_lex_state = 7},
  [2079] = {.lex_state = 335, .external_lex_state = 8},
  [2080] = {.lex_state = 335, .external_lex_state = 6},
  [2081] = {.lex_state = 335, .external_lex_state = 7},
  [2082] = {.lex_state = 335, .external_lex_state = 6},
  [2083] = {.lex_state = 335, .external_lex_state = 8},
  [2084] = {.lex_state = 335, .external_lex_state = 7},
  [2085] = {.lex_state = 335, .external_lex_state = 7},
  [2086] = {.lex_state = 335, .external_lex_state = 7},
  [2087] = {.lex_state = 335, .external_lex_state = 9},
  [2088] = {.lex_state = 335, .external_lex_state = 9},
  [2089] = {.lex_state = 335, .external_lex_state = 8},
  [2090] = {.lex_state = 335, .external_lex_state = 8},
  [2091] = {.lex_state = 335, .external_lex_state = 8},
  [2092] = {.lex_state = 335, .external_lex_state = 6},
  [2093] = {.lex_state = 335, .external_lex_state = 7},
  [2094] = {.lex_state = 335, .external_lex_state = 8},
  [2095] = {.lex_state = 335, .external_lex_state = 7},
  [2096] = {.lex_state = 335, .external_lex_state = 7},
  [2097] = {.lex_state = 335, .external_lex_state = 6},
  [2098] = {.lex_state = 335, .external_lex_state = 6},
  [2099] = {.lex_state = 335, .external_lex_state = 8},
  [2100] = {.lex_state = 335, .external_lex_state = 8},
  [2101] = {.lex_state = 335, .external_lex_state = 8},
  [2102] = {.lex_state = 335, .external_lex_state = 6},
  [2103] = {.lex_state = 335, .external_lex_state = 8},
  [2104] = {.lex_state = 335, .external_lex_state = 7},
  [2105] = {.lex_state = 335, .external_lex_state = 7},
  [2106] = {.lex_state = 335, .external_lex_state = 8},
  [2107] = {.lex_state = 335, .external_lex_state = 8},
  [2108] = {.lex_state = 335, .external_lex_state = 7},
  [2109] = {.lex_state = 335, .external_lex_state = 8},
  [2110] = {.lex_state = 335, .external_lex_state = 7},
  [2111] = {.lex_state = 335, .external_lex_state = 7},
  [2112] = {.lex_state = 335, .external_lex_state = 7},
  [2113] = {.lex_state = 335, .external_lex_state = 8},
  [2114] = {.lex_state = 335, .external_lex_state = 6},
  [2115] = {.lex_state = 335, .external_lex_state = 8},
  [2116] = {.lex_state = 335, .external_lex_state = 8},
  [2117] = {.lex_state = 335, .external_lex_state = 6},
  [2118] = {.lex_state = 335, .external_lex_state = 8},
  [2119] = {.lex_state = 335, .external_lex_state = 8},
  [2120] = {.lex_state = 335, .external_lex_state = 9},
  [2121] = {.lex_state = 335, .external_lex_state = 6},
  [2122] = {.lex_state = 335, .external_lex_state = 8},
  [2123] = {.lex_state = 335, .external_lex_state = 8},
  [2124] = {.lex_state = 335, .external_lex_state = 8},
  [2125] = {.lex_state = 335, .external_lex_state = 8},
  [2126] = {.lex_state = 335, .external_lex_state = 8},
  [2127] = {.lex_state = 331, .external_lex_state = 10},
  [2128] = {.lex_state = 335, .external_lex_state = 6},
  [2129] = {.lex_state = 335, .external_lex_state = 6},
  [2130] = {.lex_state = 335, .external_lex_state = 9},
  [2131] = {.lex_state = 335, .external_lex_state = 8},
  [2132] = {.lex_state = 335, .external_lex_state = 9},
  [2133] = {.lex_state = 335, .external_lex_state = 6},
  [2134] = {.lex_state = 335, .external_lex_state = 8},
  [2135] = {.lex_state = 335, .external_lex_state = 8},
  [2136] = {.lex_state = 335, .external_lex_state = 8},
  [2137] = {.lex_state = 335, .external_lex_state = 8},
  [2138] = {.lex_state = 335, .external_lex_state = 7},
  [2139] = {.lex_state = 335, .external_lex_state = 7},
  [2140] = {.lex_state = 335, .external_lex_state = 7},
  [2141] = {.lex_state = 335, .external_lex_state = 8},
  [2142] = {.lex_state = 335, .external_lex_state = 8},
  [2143] = {.lex_state = 335, .external_lex_state = 8},
  [2144] = {.lex_state = 335, .external_lex_state = 9},
  [2145] = {.lex_state = 335, .external_lex_state = 6},
  [2146] = {.lex_state = 335, .external_lex_state = 6},
  [2147] = {.lex_state = 335, .external_lex_state = 6},
  [2148] = {.lex_state = 335, .external_lex_state = 7},
  [2149] = {.lex_state = 335, .external_lex_state = 8},
  [2150] = {.lex_state = 335, .external_lex_state = 7},
  [2151] = {.lex_state = 335, .external_lex_state = 7},
  [2152] = {.lex_state = 335, .external_lex_state = 8},
  [2153] = {.lex_state = 335, .external_lex_state = 7},
  [2154] = {.lex_state = 335, .external_lex_state = 8},
  [2155] = {.lex_state = 335, .external_lex_state = 6},
  [2156] = {.lex_state = 335, .external_lex_state = 8},
  [2157] = {.lex_state = 335, .external_lex_state = 8},
  [2158] = {.lex_state = 335, .external_lex_state = 8},
  [2159] = {.lex_state = 335, .external_lex_state = 8},
  [2160] = {.lex_state = 335, .external_lex_state = 7},
  [2161] = {.lex_state = 335, .external_lex_state = 8},
  [2162] = {.lex_state = 335, .external_lex_state = 9},
  [2163] = {.lex_state = 335, .external_lex_state = 9},
  [2164] = {.lex_state = 335, .external_lex_state = 8},
  [2165] = {.lex_state = 335, .external_lex_state = 8},
  [2166] = {.lex_state = 331, .external_lex_state = 10},
  [2167] = {.lex_state = 335, .external_lex_state = 8},
  [2168] = {.lex_state = 335, .external_lex_state = 6},
  [2169] = {.lex_state = 335, .external_lex_state = 8},
  [2170] = {.lex_state = 335, .external_lex_state = 9},
  [2171] = {.lex_state = 335, .external_lex_state = 9},
  [2172] = {.lex_state = 335, .external_lex_state = 8},
  [2173] = {.lex_state = 335, .external_lex_state = 8},
  [2174] = {.lex_state = 335, .external_lex_state = 8},
  [2175] = {.lex_state = 335, .external_lex_state = 6},
  [2176] = {.lex_state = 335, .external_lex_state = 6},
  [2177] = {.lex_state = 335, .external_lex_state = 7},
  [2178] = {.lex_state = 331, .external_lex_state = 10},
  [2179] = {.lex_state = 335, .external_lex_state = 8},
  [2180] = {.lex_state = 335, .external_lex_state = 7},
  [2181] = {.lex_state = 335, .external_lex_state = 7},
  [2182] = {.lex_state = 335, .external_lex_state = 7},
  [2183] = {.lex_state = 335, .external_lex_state = 6},
  [2184] = {.lex_state = 335, .external_lex_state = 6},
  [2185] = {.lex_state = 335, .external_lex_state = 8},
  [2186] = {.lex_state = 335, .external_lex_state = 8},
  [2187] = {.lex_state = 335, .external_lex_state = 6},
  [2188] = {.lex_state = 335, .external_lex_state = 6},
  [2189] = {.lex_state = 335, .external_lex_state = 6},
  [2190] = {.lex_state = 335, .external_lex_state = 9},
  [2191] = {.lex_state = 331, .external_lex_state = 10},
  [2192] = {.lex_state = 335, .external_lex_state = 8},
  [2193] = {.lex_state = 335, .external_lex_state = 9},
  [2194] = {.lex_state = 335, .external_lex_state = 9},
  [2195] = {.lex_state = 335, .external_lex_state = 9},
  [2196] = {.lex_state = 335, .external_lex_state = 9},
  [2197] = {.lex_state = 331, .external_lex_state = 10},
  [2198] = {.lex_state = 335, .external_lex_state = 9},
  [2199] = {.lex_state = 335, .external_lex_state = 8},
  [2200] = {.lex_state = 331, .external_lex_state = 10},
  [2201] = {.lex_state = 335, .external_lex_state = 9},
  [2202] = {.lex_state = 335, .external_lex_state = 22},
  [2203] = {.lex_state = 335, .external_lex_state = 9},
  [2204] = {.lex_state = 335, .external_lex_state = 9},
  [2205] = {.lex_state = 335, .external_lex_state = 9},
  [2206] = {.lex_state = 335, .external_lex_state = 8},
  [2207] = {.lex_state = 335, .external_lex_state = 7},
  [2208] = {.lex_state = 331, .external_lex_state = 10},
  [2209] = {.lex_state = 335, .external_lex_state = 9},
  [2210] = {.lex_state = 335, .external_lex_state = 7},
  [2211] = {.lex_state = 335, .external_lex_state = 9},
  [2212] = {.lex_state = 335, .external_lex_state = 6},
  [2213] = {.lex_state = 335, .external_lex_state = 9},
  [2214] = {.lex_state = 335, .external_lex_state = 6},
  [2215] = {.lex_state = 335, .external_lex_state = 9},
  [2216] = {.lex_state = 335, .external_lex_state = 6},
  [2217] = {.lex_state = 335, .external_lex_state = 6},
  [2218] = {.lex_state = 335, .external_lex_state = 6},
  [2219] = {.lex_state = 331, .external_lex_state = 10},
  [2220] = {.lex_state = 335, .external_lex_state = 9},
  [2221] = {.lex_state = 335, .external_lex_state = 22},
  [2222] = {.lex_state = 335, .external_lex_state = 9},
  [2223] = {.lex_state = 335, .external_lex_state = 9},
  [2224] = {.lex_state = 335, .external_lex_state = 9},
  [2225] = {.lex_state = 335, .external_lex_state = 9},
  [2226] = {.lex_state = 335, .external_lex_state = 9},
  [2227] = {.lex_state = 335, .external_lex_state = 8},
  [2228] = {.lex_state = 331, .external_lex_state = 10},
  [2229] = {.lex_state = 335, .external_lex_state = 22},
  [2230] = {.lex_state = 331, .external_lex_state = 10},
  [2231] = {.lex_state = 331, .external_lex_state = 10},
  [2232] = {.lex_state = 331, .external_lex_state = 10},
  [2233] = {.lex_state = 331, .external_lex_state = 10},
  [2234] = {.lex_state = 331, .external_lex_state = 10},
  [2235] = {.lex_state = 331, .external_lex_state = 10},
  [2236] = {.lex_state = 331, .external_lex_state = 10},
  [2237] = {.lex_state = 331, .external_lex_state = 10},
  [2238] = {.lex_state = 331, .external_lex_state = 10},
  [2239] = {.lex_state = 331, .external_lex_state = 10},
  [2240] = {.lex_state = 331, .external_lex_state = 10},
  [2241] = {.lex_state = 331, .external_lex_state = 10},
  [2242] = {.lex_state = 331, .external_lex_state = 10},
  [2243] = {.lex_state = 331, .external_lex_state = 10},
  [2244] = {.lex_state = 331, .external_lex_state = 10},
  [2245] = {.lex_state = 331, .external_lex_state = 10},
  [2246] = {.lex_state = 331, .external_lex_state = 10},
  [2247] = {.lex_state = 331, .external_lex_state = 10},
  [2248] = {.lex_state = 331, .external_lex_state = 10},
  [2249] = {.lex_state = 331, .external_lex_state = 10},
  [2250] = {.lex_state = 331, .external_lex_state = 10},
  [2251] = {.lex_state = 335, .external_lex_state = 22},
  [2252] = {.lex_state = 331, .external_lex_state = 10},
  [2253] = {.lex_state = 331, .external_lex_state = 10},
  [2254] = {.lex_state = 331, .external_lex_state = 10},
  [2255] = {.lex_state = 331, .external_lex_state = 10},
  [2256] = {.lex_state = 331, .external_lex_state = 10},
  [2257] = {.lex_state = 331, .external_lex_state = 10},
  [2258] = {.lex_state = 331, .external_lex_state = 10},
  [2259] = {.lex_state = 331, .external_lex_state = 10},
  [2260] = {.lex_state = 331, .external_lex_state = 10},
  [2261] = {.lex_state = 331, .external_lex_state = 10},
  [2262] = {.lex_state = 331, .external_lex_state = 10},
  [2263] = {.lex_state = 331, .external_lex_state = 10},
  [2264] = {.lex_state = 333, .external_lex_state = 10},
  [2265] = {.lex_state = 62, .external_lex_state = 9},
  [2266] = {.lex_state = 333, .external_lex_state = 10},
  [2267] = {.lex_state = 62, .external_lex_state = 9},
  [2268] = {.lex_state = 62, .external_lex_state = 9},
  [2269] = {.lex_state = 62, .external_lex_state = 9},
  [2270] = {.lex_state = 62, .external_lex_state = 9},
  [2271] = {.lex_state = 334, .external_lex_state = 10},
  [2272] = {.lex_state = 335, .external_lex_state = 22},
  [2273] = {.lex_state = 62, .external_lex_state = 10},
  [2274] = {.lex_state = 335, .external_lex_state = 22},
  [2275] = {.lex_state = 336, .external_lex_state = 10},
  [2276] = {.lex_state = 336, .external_lex_state = 10},
  [2277] = {.lex_state = 62, .external_lex_state = 10},
  [2278] = {.lex_state = 335, .external_lex_state = 22},
  [2279] = {.lex_state = 336, .external_lex_state = 10},
  [2280] = {.lex_state = 334, .external_lex_state = 10},
  [2281] = {.lex_state = 336, .external_lex_state = 10},
  [2282] = {.lex_state = 334, .external_lex_state = 10},
  [2283] = {.lex_state = 335, .external_lex_state = 22},
  [2284] = {.lex_state = 336, .external_lex_state = 10},
  [2285] = {.lex_state = 336, .external_lex_state = 10},
  [2286] = {.lex_state = 334, .external_lex_state = 10},
  [2287] = {.lex_state = 334, .external_lex_state = 10},
  [2288] = {.lex_state = 62, .external_lex_state = 10},
  [2289] = {.lex_state = 336, .external_lex_state = 10},
  [2290] = {.lex_state = 335, .external_lex_state = 22},
  [2291] = {.lex_state = 62, .external_lex_state = 10},
  [2292] = {.lex_state = 336, .external_lex_state = 10},
  [2293] = {.lex_state = 334, .external_lex_state = 10},
  [2294] = {.lex_state = 338, .external_lex_state = 10},
  [2295] = {.lex_state = 336, .external_lex_state = 10},
  [2296] = {.lex_state = 336, .external_lex_state = 10},
  [2297] = {.lex_state = 335, .external_lex_state = 22},
  [2298] = {.lex_state = 334, .external_lex_state = 10},
  [2299] = {.lex_state = 338, .external_lex_state = 10},
  [2300] = {.lex_state = 335, .external_lex_state = 10},
  [2301] = {.lex_state = 334, .external_lex_state = 10},
  [2302] = {.lex_state = 62, .external_lex_state = 10},
  [2303] = {.lex_state = 65, .external_lex_state = 10},
  [2304] = {.lex_state = 335, .external_lex_state = 10},
  [2305] = {.lex_state = 62, .external_lex_state = 9},
  [2306] = {.lex_state = 65, .external_lex_state = 10},
  [2307] = {.lex_state = 61, .external_lex_state = 10},
  [2308] = {.lex_state = 65, .external_lex_state = 10},
  [2309] = {.lex_state = 61, .external_lex_state = 10},
  [2310] = {.lex_state = 61, .external_lex_state = 10},
  [2311] = {.lex_state = 65, .external_lex_state = 10},
  [2312] = {.lex_state = 336, .external_lex_state = 10},
  [2313] = {.lex_state = 336, .external_lex_state = 10},
  [2314] = {.lex_state = 335, .external_lex_state = 10},
  [2315] = {.lex_state = 336, .external_lex_state = 10},
  [2316] = {.lex_state = 335, .external_lex_state = 10},
  [2317] = {.lex_state = 336, .external_lex_state = 10},
  [2318] = {.lex_state = 335, .external_lex_state = 10},
  [2319] = {.lex_state = 64, .external_lex_state = 10},
  [2320] = {.lex_state = 63, .external_lex_state = 10},
  [2321] = {.lex_state = 62, .external_lex_state = 9},
  [2322] = {.lex_state = 62, .external_lex_state = 9},
  [2323] = {.lex_state = 338, .external_lex_state = 10},
  [2324] = {.lex_state = 335, .external_lex_state = 10},
  [2325] = {.lex_state = 61, .external_lex_state = 10},
  [2326] = {.lex_state = 335, .external_lex_state = 10},
  [2327] = {.lex_state = 62, .external_lex_state = 9},
  [2328] = {.lex_state = 63, .external_lex_state = 10},
  [2329] = {.lex_state = 62, .external_lex_state = 9},
  [2330] = {.lex_state = 336, .external_lex_state = 10},
  [2331] = {.lex_state = 335, .external_lex_state = 10},
  [2332] = {.lex_state = 335, .external_lex_state = 10},
  [2333] = {.lex_state = 336, .external_lex_state = 10},
  [2334] = {.lex_state = 336, .external_lex_state = 10},
  [2335] = {.lex_state = 335, .external_lex_state = 10},
  [2336] = {.lex_state = 64, .external_lex_state = 10},
  [2337] = {.lex_state = 64, .external_lex_state = 10},
  [2338] = {.lex_state = 64, .external_lex_state = 10},
  [2339] = {.lex_state = 338, .external_lex_state = 10},
  [2340] = {.lex_state = 335, .external_lex_state = 10},
  [2341] = {.lex_state = 64, .external_lex_state = 10},
  [2342] = {.lex_state = 99, .external_lex_state = 20},
  [2343] = {.lex_state = 99, .external_lex_state = 20},
  [2344] = {.lex_state = 335, .external_lex_state = 10},
  [2345] = {.lex_state = 62, .external_lex_state = 9},
  [2346] = {.lex_state = 335, .external_lex_state = 10},
  [2347] = {.lex_state = 62, .external_lex_state = 9},
  [2348] = {.lex_state = 61, .external_lex_state = 10},
  [2349] = {.lex_state = 63, .external_lex_state = 10},
  [2350] = {.lex_state = 63, .external_lex_state = 10},
  [2351] = {.lex_state = 335, .external_lex_state = 10},
  [2352] = {.lex_state = 336, .external_lex_state = 10},
  [2353] = {.lex_state = 335, .external_lex_state = 10},
  [2354] = {.lex_state = 62, .external_lex_state = 9},
  [2355] = {.lex_state = 65, .external_lex_state = 10},
  [2356] = {.lex_state = 65, .external_lex_state = 10},
  [2357] = {.lex_state = 63, .external_lex_state = 10},
  [2358] = {.lex_state = 336, .external_lex_state = 10},
  [2359] = {.lex_state = 336, .external_lex_state = 10},
  [2360] = {.lex_state = 335, .external_lex_state = 10},
  [2361] = {.lex_state = 62, .external_lex_state = 10},
  [2362] = {.lex_state = 335, .external_lex_state = 10},
  [2363] = {.lex_state = 335, .external_lex_state = 10},
  [2364] = {.lex_state = 62, .external_lex_state = 9},
  [2365] = {.lex_state = 335, .external_lex_state = 10},
  [2366] = {.lex_state = 335, .external_lex_state = 10},
  [2367] = {.lex_state = 335, .external_lex_state = 10},
  [2368] = {.lex_state = 335, .external_lex_state = 10},
  [2369] = {.lex_state = 335, .external_lex_state = 10},
  [2370] = {.lex_state = 335, .external_lex_state = 10},
  [2371] = {.lex_state = 335, .external_lex_state = 10},
  [2372] = {.lex_state = 335, .external_lex_state = 10},
  [2373] = {.lex_state = 335, .external_lex_state = 10},
  [2374] = {.lex_state = 335, .external_lex_state = 10},
  [2375] = {.lex_state = 335, .external_lex_state = 10},
  [2376] = {.lex_state = 335, .external_lex_state = 10},
  [2377] = {.lex_state = 335, .external_lex_state = 10},
  [2378] = {.lex_state = 335, .external_lex_state = 10},
  [2379] = {.lex_state = 335, .external_lex_state = 10},
  [2380] = {.lex_state = 335, .external_lex_state = 10},
  [2381] = {.lex_state = 335, .external_lex_state = 10},
  [2382] = {.lex_state = 335, .external_lex_state = 10},
  [2383] = {.lex_state = 335, .external_lex_state = 10},
  [2384] = {.lex_state = 335, .external_lex_state = 10},
  [2385] = {.lex_state = 99, .external_lex_state = 20},
  [2386] = {.lex_state = 335, .external_lex_state = 10},
  [2387] = {.lex_state = 335, .external_lex_state = 10},
  [2388] = {.lex_state = 335, .external_lex_state = 10},
  [2389] = {.lex_state = 335, .external_lex_state = 10},
  [2390] = {.lex_state = 335, .external_lex_state = 10},
  [2391] = {.lex_state = 335, .external_lex_state = 10},
  [2392] = {.lex_state = 335, .external_lex_state = 10},
  [2393] = {.lex_state = 335, .external_lex_state = 10},
  [2394] = {.lex_state = 335, .external_lex_state = 10},
  [2395] = {.lex_state = 335, .external_lex_state = 10},
  [2396] = {.lex_state = 335, .external_lex_state = 10},
  [2397] = {.lex_state = 335, .external_lex_state = 10},
  [2398] = {.lex_state = 335, .external_lex_state = 10},
  [2399] = {.lex_state = 335, .external_lex_state = 10},
  [2400] = {.lex_state = 335, .external_lex_state = 10},
  [2401] = {.lex_state = 335, .external_lex_state = 10},
  [2402] = {.lex_state = 335, .external_lex_state = 10},
  [2403] = {.lex_state = 335, .external_lex_state = 10},
  [2404] = {.lex_state = 335, .external_lex_state = 10},
  [2405] = {.lex_state = 335, .external_lex_state = 10},
  [2406] = {.lex_state = 335, .external_lex_state = 10},
  [2407] = {.lex_state = 335, .external_lex_state = 10},
  [2408] = {.lex_state = 335, .external_lex_state = 10},
  [2409] = {.lex_state = 335, .external_lex_state = 10},
  [2410] = {.lex_state = 335, .external_lex_state = 10},
  [2411] = {.lex_state = 335, .external_lex_state = 10},
  [2412] = {.lex_state = 62, .external_lex_state = 10},
  [2413] = {.lex_state = 335, .external_lex_state = 10},
  [2414] = {.lex_state = 62, .external_lex_state = 10},
  [2415] = {.lex_state = 335, .external_lex_state = 10},
  [2416] = {.lex_state = 62, .external_lex_state = 9},
  [2417] = {.lex_state = 335, .external_lex_state = 10},
  [2418] = {.lex_state = 335, .external_lex_state = 10},
  [2419] = {.lex_state = 335, .external_lex_state = 10},
  [2420] = {.lex_state = 62, .external_lex_state = 9},
  [2421] = {.lex_state = 335, .external_lex_state = 10},
  [2422] = {.lex_state = 62, .external_lex_state = 9},
  [2423] = {.lex_state = 335, .external_lex_state = 10},
  [2424] = {.lex_state = 335, .external_lex_state = 10},
  [2425] = {.lex_state = 335, .external_lex_state = 10},
  [2426] = {.lex_state = 62, .external_lex_state = 10},
  [2427] = {.lex_state = 335, .external_lex_state = 10},
  [2428] = {.lex_state = 335, .external_lex_state = 10},
  [2429] = {.lex_state = 335, .external_lex_state = 10},
  [2430] = {.lex_state = 335, .external_lex_state = 10},
  [2431] = {.lex_state = 335, .external_lex_state = 10},
  [2432] = {.lex_state = 335, .external_lex_state = 10},
  [2433] = {.lex_state = 335, .external_lex_state = 10},
  [2434] = {.lex_state = 335, .external_lex_state = 10},
  [2435] = {.lex_state = 335, .external_lex_state = 10},
  [2436] = {.lex_state = 335, .external_lex_state = 10},
  [2437] = {.lex_state = 62, .external_lex_state = 10},
  [2438] = {.lex_state = 335, .external_lex_state = 10},
  [2439] = {.lex_state = 335, .external_lex_state = 10},
  [2440] = {.lex_state = 335, .external_lex_state = 10},
  [2441] = {.lex_state = 335, .external_lex_state = 10},
  [2442] = {.lex_state = 335, .external_lex_state = 10},
  [2443] = {.lex_state = 335, .external_lex_state = 10},
  [2444] = {.lex_state = 335, .external_lex_state = 10},
  [2445] = {.lex_state = 335, .external_lex_state = 10},
  [2446] = {.lex_state = 335, .external_lex_state = 10},
  [2447] = {.lex_state = 62, .external_lex_state = 10},
  [2448] = {.lex_state = 335, .external_lex_state = 10},
  [2449] = {.lex_state = 335, .external_lex_state = 10},
  [2450] = {.lex_state = 335, .external_lex_state = 10},
  [2451] = {.lex_state = 335, .external_lex_state = 10},
  [2452] = {.lex_state = 335, .external_lex_state = 10},
  [2453] = {.lex_state = 335, .external_lex_state = 10},
  [2454] = {.lex_state = 335, .external_lex_state = 10},
  [2455] = {.lex_state = 335, .external_lex_state = 10},
  [2456] = {.lex_state = 335, .external_lex_state = 10},
  [2457] = {.lex_state = 335, .external_lex_state = 10},
  [2458] = {.lex_state = 335, .external_lex_state = 10},
  [2459] = {.lex_state = 335, .external_lex_state = 10},
  [2460] = {.lex_state = 335, .external_lex_state = 10},
  [2461] = {.lex_state = 335, .external_lex_state = 10},
  [2462] = {.lex_state = 335, .external_lex_state = 10},
  [2463] = {.lex_state = 335, .external_lex_state = 10},
  [2464] = {.lex_state = 62, .external_lex_state = 9},
  [2465] = {.lex_state = 335, .external_lex_state = 10},
  [2466] = {.lex_state = 335, .external_lex_state = 10},
  [2467] = {.lex_state = 335, .external_lex_state = 10},
  [2468] = {.lex_state = 335, .external_lex_state = 10},
  [2469] = {.lex_state = 335, .external_lex_state = 10},
  [2470] = {.lex_state = 335, .external_lex_state = 10},
  [2471] = {.lex_state = 335, .external_lex_state = 10},
  [2472] = {.lex_state = 99, .external_lex_state = 22},
  [2473] = {.lex_state = 335, .external_lex_state = 10},
  [2474] = {.lex_state = 335, .external_lex_state = 10},
  [2475] = {.lex_state = 335, .external_lex_state = 10},
  [2476] = {.lex_state = 335, .external_lex_state = 10},
  [2477] = {.lex_state = 335, .external_lex_state = 10},
  [2478] = {.lex_state = 335, .external_lex_state = 10},
  [2479] = {.lex_state = 335, .external_lex_state = 10},
  [2480] = {.lex_state = 335, .external_lex_state = 10},
  [2481] = {.lex_state = 335, .external_lex_state = 10},
  [2482] = {.lex_state = 335, .external_lex_state = 10},
  [2483] = {.lex_state = 62, .external_lex_state = 9},
  [2484] = {.lex_state = 335, .external_lex_state = 10},
  [2485] = {.lex_state = 335, .external_lex_state = 10},
  [2486] = {.lex_state = 335, .external_lex_state = 10},
  [2487] = {.lex_state = 335, .external_lex_state = 10},
  [2488] = {.lex_state = 335, .external_lex_state = 10},
  [2489] = {.lex_state = 335, .external_lex_state = 10},
  [2490] = {.lex_state = 335, .external_lex_state = 10},
  [2491] = {.lex_state = 335, .external_lex_state = 10},
  [2492] = {.lex_state = 335, .external_lex_state = 10},
  [2493] = {.lex_state = 335, .external_lex_state = 10},
  [2494] = {.lex_state = 335, .external_lex_state = 10},
  [2495] = {.lex_state = 335, .external_lex_state = 10},
  [2496] = {.lex_state = 335, .external_lex_state = 10},
  [2497] = {.lex_state = 62, .external_lex_state = 9},
  [2498] = {.lex_state = 335, .external_lex_state = 10},
  [2499] = {.lex_state = 62, .external_lex_state = 9},
  [2500] = {.lex_state = 331, .external_lex_state = 10},
  [2501] = {.lex_state = 335, .external_lex_state = 10},
  [2502] = {.lex_state = 335, .external_lex_state = 10},
  [2503] = {.lex_state = 62, .external_lex_state = 9},
  [2504] = {.lex_state = 335, .external_lex_state = 10},
  [2505] = {.lex_state = 335, .external_lex_state = 10},
  [2506] = {.lex_state = 335, .external_lex_state = 10},
  [2507] = {.lex_state = 100, .external_lex_state = 22},
  [2508] = {.lex_state = 335, .external_lex_state = 10},
  [2509] = {.lex_state = 335, .external_lex_state = 10},
  [2510] = {.lex_state = 335, .external_lex_state = 10},
  [2511] = {.lex_state = 335, .external_lex_state = 10},
  [2512] = {.lex_state = 335, .external_lex_state = 10},
  [2513] = {.lex_state = 335, .external_lex_state = 10},
  [2514] = {.lex_state = 335, .external_lex_state = 10},
  [2515] = {.lex_state = 335, .external_lex_state = 10},
  [2516] = {.lex_state = 335, .external_lex_state = 10},
  [2517] = {.lex_state = 335, .external_lex_state = 10},
  [2518] = {.lex_state = 62, .external_lex_state = 9},
  [2519] = {.lex_state = 335, .external_lex_state = 10},
  [2520] = {.lex_state = 335, .external_lex_state = 10},
  [2521] = {.lex_state = 335, .external_lex_state = 10},
  [2522] = {.lex_state = 335, .external_lex_state = 10},
  [2523] = {.lex_state = 335, .external_lex_state = 10},
  [2524] = {.lex_state = 62, .external_lex_state = 9},
  [2525] = {.lex_state = 335, .external_lex_state = 10},
  [2526] = {.lex_state = 335, .external_lex_state = 10},
  [2527] = {.lex_state = 62, .external_lex_state = 9},
  [2528] = {.lex_state = 62, .external_lex_state = 9},
  [2529] = {.lex_state = 62, .external_lex_state = 9},
  [2530] = {.lex_state = 62, .external_lex_state = 10},
  [2531] = {.lex_state = 335, .external_lex_state = 10},
  [2532] = {.lex_state = 335, .external_lex_state = 10},
  [2533] = {.lex_state = 335, .external_lex_state = 10},
  [2534] = {.lex_state = 335, .external_lex_state = 10},
  [2535] = {.lex_state = 62, .external_lex_state = 10},
  [2536] = {.lex_state = 62, .external_lex_state = 9},
  [2537] = {.lex_state = 335, .external_lex_state = 10},
  [2538] = {.lex_state = 335, .external_lex_state = 10},
  [2539] = {.lex_state = 99, .external_lex_state = 22},
  [2540] = {.lex_state = 100, .external_lex_state = 22},
  [2541] = {.lex_state = 335, .external_lex_state = 10},
  [2542] = {.lex_state = 335, .external_lex_state = 10},
  [2543] = {.lex_state = 335, .external_lex_state = 10},
  [2544] = {.lex_state = 62, .external_lex_state = 9},
  [2545] = {.lex_state = 62, .external_lex_state = 9},
  [2546] = {.lex_state = 335, .external_lex_state = 10},
  [2547] = {.lex_state = 335, .external_lex_state = 10},
  [2548] = {.lex_state = 335, .external_lex_state = 10},
  [2549] = {.lex_state = 335, .external_lex_state = 10},
  [2550] = {.lex_state = 62, .external_lex_state = 10},
  [2551] = {.lex_state = 65, .external_lex_state = 10},
  [2552] = {.lex_state = 65, .external_lex_state = 10},
  [2553] = {.lex_state = 100, .external_lex_state = 22},
  [2554] = {.lex_state = 65, .external_lex_state = 10},
  [2555] = {.lex_state = 63, .external_lex_state = 10},
  [2556] = {.lex_state = 65, .external_lex_state = 10},
  [2557] = {.lex_state = 64, .external_lex_state = 10},
  [2558] = {.lex_state = 64, .external_lex_state = 10},
  [2559] = {.lex_state = 61, .external_lex_state = 10},
  [2560] = {.lex_state = 63, .external_lex_state = 10},
  [2561] = {.lex_state = 333, .external_lex_state = 9},
  [2562] = {.lex_state = 65, .external_lex_state = 10},
  [2563] = {.lex_state = 61, .external_lex_state = 10},
  [2564] = {.lex_state = 64, .external_lex_state = 10},
  [2565] = {.lex_state = 64, .external_lex_state = 10},
  [2566] = {.lex_state = 63, .external_lex_state = 10},
  [2567] = {.lex_state = 104, .external_lex_state = 22},
  [2568] = {.lex_state = 61, .external_lex_state = 10},
  [2569] = {.lex_state = 61, .external_lex_state = 10},
  [2570] = {.lex_state = 103, .external_lex_state = 22},
  [2571] = {.lex_state = 64, .external_lex_state = 10},
  [2572] = {.lex_state = 65, .external_lex_state = 10},
  [2573] = {.lex_state = 62, .external_lex_state = 10},
  [2574] = {.lex_state = 79, .external_lex_state = 9},
  [2575] = {.lex_state = 65, .external_lex_state = 10},
  [2576] = {.lex_state = 92, .external_lex_state = 22},
  [2577] = {.lex_state = 104, .external_lex_state = 22},
  [2578] = {.lex_state = 64, .external_lex_state = 10},
  [2579] = {.lex_state = 61, .external_lex_state = 10},
  [2580] = {.lex_state = 344, .external_lex_state = 23},
  [2581] = {.lex_state = 338, .external_lex_state = 22},
  [2582] = {.lex_state = 61, .external_lex_state = 10},
  [2583] = {.lex_state = 62, .external_lex_state = 10},
  [2584] = {.lex_state = 64, .external_lex_state = 10},
  [2585] = {.lex_state = 62, .external_lex_state = 10},
  [2586] = {.lex_state = 62, .external_lex_state = 10},
  [2587] = {.lex_state = 62, .external_lex_state = 10},
  [2588] = {.lex_state = 63, .external_lex_state = 10},
  [2589] = {.lex_state = 99, .external_lex_state = 22},
  [2590] = {.lex_state = 63, .external_lex_state = 10},
  [2591] = {.lex_state = 62, .external_lex_state = 10},
  [2592] = {.lex_state = 63, .external_lex_state = 10},
  [2593] = {.lex_state = 62, .external_lex_state = 10},
  [2594] = {.lex_state = 62, .external_lex_state = 10},
  [2595] = {.lex_state = 62, .external_lex_state = 10},
  [2596] = {.lex_state = 62, .external_lex_state = 10},
  [2597] = {.lex_state = 62, .external_lex_state = 10},
  [2598] = {.lex_state = 344, .external_lex_state = 23},
  [2599] = {.lex_state = 63, .external_lex_state = 10},
  [2600] = {.lex_state = 61, .external_lex_state = 10},
  [2601] = {.lex_state = 65, .external_lex_state = 10},
  [2602] = {.lex_state = 331, .external_lex_state = 9},
  [2603] = {.lex_state = 92, .external_lex_state = 22},
  [2604] = {.lex_state = 331, .external_lex_state = 10},
  [2605] = {.lex_state = 61, .external_lex_state = 10},
  [2606] = {.lex_state = 62, .external_lex_state = 10},
  [2607] = {.lex_state = 338, .external_lex_state = 22},
  [2608] = {.lex_state = 64, .external_lex_state = 10},
  [2609] = {.lex_state = 62, .external_lex_state = 10},
  [2610] = {.lex_state = 103, .external_lex_state = 22},
  [2611] = {.lex_state = 62, .external_lex_state = 10},
  [2612] = {.lex_state = 62, .external_lex_state = 10},
  [2613] = {.lex_state = 62, .external_lex_state = 10},
  [2614] = {.lex_state = 63, .external_lex_state = 10},
  [2615] = {.lex_state = 61, .external_lex_state = 10},
  [2616] = {.lex_state = 64, .external_lex_state = 10},
  [2617] = {.lex_state = 63, .external_lex_state = 10},
  [2618] = {.lex_state = 65, .external_lex_state = 10},
  [2619] = {.lex_state = 333, .external_lex_state = 6},
  [2620] = {.lex_state = 334, .external_lex_state = 9},
  [2621] = {.lex_state = 103, .external_lex_state = 22},
  [2622] = {.lex_state = 65, .external_lex_state = 10},
  [2623] = {.lex_state = 65, .external_lex_state = 10},
  [2624] = {.lex_state = 61, .external_lex_state = 10},
  [2625] = {.lex_state = 61, .external_lex_state = 10},
  [2626] = {.lex_state = 64, .external_lex_state = 10},
  [2627] = {.lex_state = 64, .external_lex_state = 10},
  [2628] = {.lex_state = 64, .external_lex_state = 10},
  [2629] = {.lex_state = 64, .external_lex_state = 10},
  [2630] = {.lex_state = 81, .external_lex_state = 9},
  [2631] = {.lex_state = 65, .external_lex_state = 10},
  [2632] = {.lex_state = 63, .external_lex_state = 10},
  [2633] = {.lex_state = 64, .external_lex_state = 10},
  [2634] = {.lex_state = 344, .external_lex_state = 23},
  [2635] = {.lex_state = 61, .external_lex_state = 10},
  [2636] = {.lex_state = 81, .external_lex_state = 9},
  [2637] = {.lex_state = 63, .external_lex_state = 10},
  [2638] = {.lex_state = 333, .external_lex_state = 4},
  [2639] = {.lex_state = 81, .external_lex_state = 9},
  [2640] = {.lex_state = 65, .external_lex_state = 10},
  [2641] = {.lex_state = 61, .external_lex_state = 10},
  [2642] = {.lex_state = 95, .external_lex_state = 10},
  [2643] = {.lex_state = 64, .external_lex_state = 10},
  [2644] = {.lex_state = 61, .external_lex_state = 10},
  [2645] = {.lex_state = 65, .external_lex_state = 10},
  [2646] = {.lex_state = 63, .external_lex_state = 10},
  [2647] = {.lex_state = 65, .external_lex_state = 10},
  [2648] = {.lex_state = 99, .external_lex_state = 9},
  [2649] = {.lex_state = 63, .external_lex_state = 10},
  [2650] = {.lex_state = 331, .external_lex_state = 9},
  [2651] = {.lex_state = 81, .external_lex_state = 9},
  [2652] = {.lex_state = 80, .external_lex_state = 9},
  [2653] = {.lex_state = 64, .external_lex_state = 10},
  [2654] = {.lex_state = 100, .external_lex_state = 9},
  [2655] = {.lex_state = 61, .external_lex_state = 10},
  [2656] = {.lex_state = 64, .external_lex_state = 10},
  [2657] = {.lex_state = 63, .external_lex_state = 10},
  [2658] = {.lex_state = 104, .external_lex_state = 22},
  [2659] = {.lex_state = 61, .external_lex_state = 10},
  [2660] = {.lex_state = 64, .external_lex_state = 10},
  [2661] = {.lex_state = 63, .external_lex_state = 10},
  [2662] = {.lex_state = 99, .external_lex_state = 20},
  [2663] = {.lex_state = 61, .external_lex_state = 10},
  [2664] = {.lex_state = 61, .external_lex_state = 10},
  [2665] = {.lex_state = 63, .external_lex_state = 10},
  [2666] = {.lex_state = 63, .external_lex_state = 10},
  [2667] = {.lex_state = 67, .external_lex_state = 9},
  [2668] = {.lex_state = 344, .external_lex_state = 23},
  [2669] = {.lex_state = 334, .external_lex_state = 9},
  [2670] = {.lex_state = 63, .external_lex_state = 10},
  [2671] = {.lex_state = 65, .external_lex_state = 10},
  [2672] = {.lex_state = 63, .external_lex_state = 10},
  [2673] = {.lex_state = 334, .external_lex_state = 9},
  [2674] = {.lex_state = 65, .external_lex_state = 10},
  [2675] = {.lex_state = 65, .external_lex_state = 10},
  [2676] = {.lex_state = 334, .external_lex_state = 9},
  [2677] = {.lex_state = 64, .external_lex_state = 10},
  [2678] = {.lex_state = 64, .external_lex_state = 10},
  [2679] = {.lex_state = 100, .external_lex_state = 9},
  [2680] = {.lex_state = 63, .external_lex_state = 10},
  [2681] = {.lex_state = 63, .external_lex_state = 10},
  [2682] = {.lex_state = 80, .external_lex_state = 9},
  [2683] = {.lex_state = 61, .external_lex_state = 10},
  [2684] = {.lex_state = 63, .external_lex_state = 10},
  [2685] = {.lex_state = 61, .external_lex_state = 10},
  [2686] = {.lex_state = 63, .external_lex_state = 10},
  [2687] = {.lex_state = 63, .external_lex_state = 10},
  [2688] = {.lex_state = 64, .external_lex_state = 10},
  [2689] = {.lex_state = 65, .external_lex_state = 10},
  [2690] = {.lex_state = 61, .external_lex_state = 10},
  [2691] = {.lex_state = 65, .external_lex_state = 10},
  [2692] = {.lex_state = 61, .external_lex_state = 10},
  [2693] = {.lex_state = 99, .external_lex_state = 20},
  [2694] = {.lex_state = 338, .external_lex_state = 22},
  [2695] = {.lex_state = 99, .external_lex_state = 9},
  [2696] = {.lex_state = 65, .external_lex_state = 10},
  [2697] = {.lex_state = 79, .external_lex_state = 10},
  [2698] = {.lex_state = 65, .external_lex_state = 10},
  [2699] = {.lex_state = 65, .external_lex_state = 10},
  [2700] = {.lex_state = 99, .external_lex_state = 20},
  [2701] = {.lex_state = 64, .external_lex_state = 10},
  [2702] = {.lex_state = 65, .external_lex_state = 10},
  [2703] = {.lex_state = 61, .external_lex_state = 10},
  [2704] = {.lex_state = 63, .external_lex_state = 10},
  [2705] = {.lex_state = 65, .external_lex_state = 10},
  [2706] = {.lex_state = 64, .external_lex_state = 10},
  [2707] = {.lex_state = 331, .external_lex_state = 10},
  [2708] = {.lex_state = 61, .external_lex_state = 10},
  [2709] = {.lex_state = 81, .external_lex_state = 9},
  [2710] = {.lex_state = 61, .external_lex_state = 10},
  [2711] = {.lex_state = 67, .external_lex_state = 9},
  [2712] = {.lex_state = 80, .external_lex_state = 9},
  [2713] = {.lex_state = 80, .external_lex_state = 9},
  [2714] = {.lex_state = 92, .external_lex_state = 22},
  [2715] = {.lex_state = 64, .external_lex_state = 10},
  [2716] = {.lex_state = 64, .external_lex_state = 10},
  [2717] = {.lex_state = 81, .external_lex_state = 10},
  [2718] = {.lex_state = 334, .external_lex_state = 6},
  [2719] = {.lex_state = 100, .external_lex_state = 22},
  [2720] = {.lex_state = 81, .external_lex_state = 10},
  [2721] = {.lex_state = 99, .external_lex_state = 10},
  [2722] = {.lex_state = 81, .external_lex_state = 10},
  [2723] = {.lex_state = 335, .external_lex_state = 9},
  [2724] = {.lex_state = 334, .external_lex_state = 4},
  [2725] = {.lex_state = 165},
  [2726] = {.lex_state = 99, .external_lex_state = 9},
  [2727] = {.lex_state = 99, .external_lex_state = 9},
  [2728] = {.lex_state = 80, .external_lex_state = 10},
  [2729] = {.lex_state = 99, .external_lex_state = 22},
  [2730] = {.lex_state = 96, .external_lex_state = 10},
  [2731] = {.lex_state = 165},
  [2732] = {.lex_state = 334, .external_lex_state = 4},
  [2733] = {.lex_state = 83, .external_lex_state = 10},
  [2734] = {.lex_state = 87, .external_lex_state = 10},
  [2735] = {.lex_state = 81, .external_lex_state = 9},
  [2736] = {.lex_state = 81, .external_lex_state = 9},
  [2737] = {.lex_state = 165},
  [2738] = {.lex_state = 165},
  [2739] = {.lex_state = 165},
  [2740] = {.lex_state = 81, .external_lex_state = 10},
  [2741] = {.lex_state = 81, .external_lex_state = 10},
  [2742] = {.lex_state = 99, .external_lex_state = 9},
  [2743] = {.lex_state = 334, .external_lex_state = 6},
  [2744] = {.lex_state = 165},
  [2745] = {.lex_state = 99, .external_lex_state = 9},
  [2746] = {.lex_state = 100, .external_lex_state = 22},
  [2747] = {.lex_state = 99, .external_lex_state = 22},
  [2748] = {.lex_state = 99, .external_lex_state = 9},
  [2749] = {.lex_state = 100, .external_lex_state = 22},
  [2750] = {.lex_state = 73, .external_lex_state = 9},
  [2751] = {.lex_state = 80, .external_lex_state = 10},
  [2752] = {.lex_state = 99, .external_lex_state = 9},
  [2753] = {.lex_state = 99, .external_lex_state = 9},
  [2754] = {.lex_state = 101, .external_lex_state = 10},
  [2755] = {.lex_state = 335, .external_lex_state = 10},
  [2756] = {.lex_state = 101, .external_lex_state = 10},
  [2757] = {.lex_state = 81, .external_lex_state = 9},
  [2758] = {.lex_state = 165},
  [2759] = {.lex_state = 81, .external_lex_state = 9},
  [2760] = {.lex_state = 165},
  [2761] = {.lex_state = 101, .external_lex_state = 10},
  [2762] = {.lex_state = 96, .external_lex_state = 10},
  [2763] = {.lex_state = 101, .external_lex_state = 10},
  [2764] = {.lex_state = 333, .external_lex_state = 8},
  [2765] = {.lex_state = 80, .external_lex_state = 10},
  [2766] = {.lex_state = 334, .external_lex_state = 4},
  [2767] = {.lex_state = 334, .external_lex_state = 6},
  [2768] = {.lex_state = 99, .external_lex_state = 22},
  [2769] = {.lex_state = 99, .external_lex_state = 10},
  [2770] = {.lex_state = 80, .external_lex_state = 10},
  [2771] = {.lex_state = 165},
  [2772] = {.lex_state = 165},
  [2773] = {.lex_state = 75, .external_lex_state = 10},
  [2774] = {.lex_state = 73, .external_lex_state = 9},
  [2775] = {.lex_state = 73, .external_lex_state = 9},
  [2776] = {.lex_state = 334, .external_lex_state = 4},
  [2777] = {.lex_state = 101, .external_lex_state = 10},
  [2778] = {.lex_state = 96, .external_lex_state = 10},
  [2779] = {.lex_state = 97, .external_lex_state = 10},
  [2780] = {.lex_state = 99, .external_lex_state = 9},
  [2781] = {.lex_state = 334, .external_lex_state = 6},
  [2782] = {.lex_state = 96, .external_lex_state = 10},
  [2783] = {.lex_state = 81, .external_lex_state = 9},
  [2784] = {.lex_state = 334, .external_lex_state = 8},
  [2785] = {.lex_state = 84, .external_lex_state = 10},
  [2786] = {.lex_state = 76, .external_lex_state = 10},
  [2787] = {.lex_state = 76, .external_lex_state = 10},
  [2788] = {.lex_state = 338, .external_lex_state = 22},
  [2789] = {.lex_state = 101, .external_lex_state = 10},
  [2790] = {.lex_state = 99, .external_lex_state = 9},
  [2791] = {.lex_state = 98, .external_lex_state = 10},
  [2792] = {.lex_state = 102, .external_lex_state = 10},
  [2793] = {.lex_state = 99, .external_lex_state = 9},
  [2794] = {.lex_state = 104, .external_lex_state = 22},
  [2795] = {.lex_state = 100, .external_lex_state = 10},
  [2796] = {.lex_state = 73, .external_lex_state = 9},
  [2797] = {.lex_state = 76, .external_lex_state = 10},
  [2798] = {.lex_state = 338, .external_lex_state = 22},
  [2799] = {.lex_state = 335, .external_lex_state = 4},
  [2800] = {.lex_state = 73, .external_lex_state = 9},
  [2801] = {.lex_state = 103, .external_lex_state = 10},
  [2802] = {.lex_state = 92, .external_lex_state = 22},
  [2803] = {.lex_state = 98, .external_lex_state = 10},
  [2804] = {.lex_state = 102, .external_lex_state = 10},
  [2805] = {.lex_state = 104, .external_lex_state = 10},
  [2806] = {.lex_state = 99, .external_lex_state = 9},
  [2807] = {.lex_state = 102, .external_lex_state = 10},
  [2808] = {.lex_state = 99, .external_lex_state = 9},
  [2809] = {.lex_state = 98, .external_lex_state = 10},
  [2810] = {.lex_state = 99, .external_lex_state = 9},
  [2811] = {.lex_state = 99, .external_lex_state = 9},
  [2812] = {.lex_state = 99, .external_lex_state = 9},
  [2813] = {.lex_state = 99, .external_lex_state = 9},
  [2814] = {.lex_state = 99, .external_lex_state = 10},
  [2815] = {.lex_state = 102, .external_lex_state = 10},
  [2816] = {.lex_state = 102, .external_lex_state = 10},
  [2817] = {.lex_state = 145, .external_lex_state = 24},
  [2818] = {.lex_state = 345, .external_lex_state = 23},
  [2819] = {.lex_state = 99, .external_lex_state = 9},
  [2820] = {.lex_state = 99, .external_lex_state = 9},
  [2821] = {.lex_state = 99, .external_lex_state = 9},
  [2822] = {.lex_state = 92, .external_lex_state = 22},
  [2823] = {.lex_state = 92, .external_lex_state = 22},
  [2824] = {.lex_state = 99, .external_lex_state = 9},
  [2825] = {.lex_state = 335, .external_lex_state = 6},
  [2826] = {.lex_state = 338, .external_lex_state = 22},
  [2827] = {.lex_state = 84, .external_lex_state = 10},
  [2828] = {.lex_state = 76, .external_lex_state = 10},
  [2829] = {.lex_state = 100, .external_lex_state = 10},
  [2830] = {.lex_state = 85, .external_lex_state = 10},
  [2831] = {.lex_state = 88, .external_lex_state = 10},
  [2832] = {.lex_state = 99, .external_lex_state = 9},
  [2833] = {.lex_state = 99, .external_lex_state = 9},
  [2834] = {.lex_state = 99, .external_lex_state = 9},
  [2835] = {.lex_state = 335, .external_lex_state = 9},
  [2836] = {.lex_state = 103, .external_lex_state = 22},
  [2837] = {.lex_state = 85, .external_lex_state = 10},
  [2838] = {.lex_state = 73, .external_lex_state = 10},
  [2839] = {.lex_state = 99, .external_lex_state = 9},
  [2840] = {.lex_state = 77, .external_lex_state = 10},
  [2841] = {.lex_state = 103, .external_lex_state = 22},
  [2842] = {.lex_state = 98, .external_lex_state = 10},
  [2843] = {.lex_state = 335, .external_lex_state = 4},
  [2844] = {.lex_state = 99, .external_lex_state = 10},
  [2845] = {.lex_state = 73, .external_lex_state = 10},
  [2846] = {.lex_state = 99, .external_lex_state = 10},
  [2847] = {.lex_state = 99, .external_lex_state = 9},
  [2848] = {.lex_state = 99, .external_lex_state = 9},
  [2849] = {.lex_state = 99, .external_lex_state = 9},
  [2850] = {.lex_state = 99, .external_lex_state = 9},
  [2851] = {.lex_state = 99, .external_lex_state = 9},
  [2852] = {.lex_state = 100, .external_lex_state = 10},
  [2853] = {.lex_state = 99, .external_lex_state = 9},
  [2854] = {.lex_state = 99, .external_lex_state = 9},
  [2855] = {.lex_state = 99, .external_lex_state = 9},
  [2856] = {.lex_state = 99, .external_lex_state = 9},
  [2857] = {.lex_state = 99, .external_lex_state = 9},
  [2858] = {.lex_state = 99, .external_lex_state = 9},
  [2859] = {.lex_state = 100, .external_lex_state = 10},
  [2860] = {.lex_state = 104, .external_lex_state = 22},
  [2861] = {.lex_state = 99, .external_lex_state = 9},
  [2862] = {.lex_state = 99, .external_lex_state = 9},
  [2863] = {.lex_state = 99, .external_lex_state = 9},
  [2864] = {.lex_state = 99, .external_lex_state = 9},
  [2865] = {.lex_state = 99, .external_lex_state = 9},
  [2866] = {.lex_state = 99, .external_lex_state = 9},
  [2867] = {.lex_state = 99, .external_lex_state = 9},
  [2868] = {.lex_state = 99, .external_lex_state = 9},
  [2869] = {.lex_state = 104, .external_lex_state = 22},
  [2870] = {.lex_state = 77, .external_lex_state = 10},
  [2871] = {.lex_state = 77, .external_lex_state = 10},
  [2872] = {.lex_state = 99, .external_lex_state = 9},
  [2873] = {.lex_state = 85, .external_lex_state = 10},
  [2874] = {.lex_state = 77, .external_lex_state = 10},
  [2875] = {.lex_state = 99, .external_lex_state = 9},
  [2876] = {.lex_state = 99, .external_lex_state = 9},
  [2877] = {.lex_state = 85, .external_lex_state = 10},
  [2878] = {.lex_state = 77, .external_lex_state = 10},
  [2879] = {.lex_state = 100, .external_lex_state = 10},
  [2880] = {.lex_state = 99, .external_lex_state = 9},
  [2881] = {.lex_state = 99, .external_lex_state = 9},
  [2882] = {.lex_state = 99, .external_lex_state = 9},
  [2883] = {.lex_state = 99, .external_lex_state = 9},
  [2884] = {.lex_state = 99, .external_lex_state = 9},
  [2885] = {.lex_state = 99, .external_lex_state = 9},
  [2886] = {.lex_state = 88, .external_lex_state = 10},
  [2887] = {.lex_state = 99, .external_lex_state = 10},
  [2888] = {.lex_state = 100, .external_lex_state = 10},
  [2889] = {.lex_state = 99, .external_lex_state = 9},
  [2890] = {.lex_state = 103, .external_lex_state = 22},
  [2891] = {.lex_state = 99, .external_lex_state = 10},
  [2892] = {.lex_state = 335, .external_lex_state = 9},
  [2893] = {.lex_state = 335, .external_lex_state = 10},
  [2894] = {.lex_state = 84, .external_lex_state = 10},
  [2895] = {.lex_state = 99, .external_lex_state = 9},
  [2896] = {.lex_state = 103, .external_lex_state = 10},
  [2897] = {.lex_state = 99, .external_lex_state = 9},
  [2898] = {.lex_state = 99, .external_lex_state = 9},
  [2899] = {.lex_state = 99, .external_lex_state = 9},
  [2900] = {.lex_state = 81, .external_lex_state = 10},
  [2901] = {.lex_state = 99, .external_lex_state = 9},
  [2902] = {.lex_state = 88, .external_lex_state = 10},
  [2903] = {.lex_state = 99, .external_lex_state = 9},
  [2904] = {.lex_state = 99, .external_lex_state = 9},
  [2905] = {.lex_state = 99, .external_lex_state = 9},
  [2906] = {.lex_state = 99, .external_lex_state = 9},
  [2907] = {.lex_state = 99, .external_lex_state = 9},
  [2908] = {.lex_state = 99, .external_lex_state = 9},
  [2909] = {.lex_state = 99, .external_lex_state = 9},
  [2910] = {.lex_state = 99, .external_lex_state = 9},
  [2911] = {.lex_state = 145},
  [2912] = {.lex_state = 101, .external_lex_state = 10},
  [2913] = {.lex_state = 89, .external_lex_state = 10},
  [2914] = {.lex_state = 101, .external_lex_state = 10},
  [2915] = {.lex_state = 99, .external_lex_state = 9},
  [2916] = {.lex_state = 100, .external_lex_state = 10},
  [2917] = {.lex_state = 81, .external_lex_state = 10},
  [2918] = {.lex_state = 81, .external_lex_state = 10},
  [2919] = {.lex_state = 145},
  [2920] = {.lex_state = 73, .external_lex_state = 10},
  [2921] = {.lex_state = 335, .external_lex_state = 6},
  [2922] = {.lex_state = 85, .external_lex_state = 10},
  [2923] = {.lex_state = 104, .external_lex_state = 10},
  [2924] = {.lex_state = 334, .external_lex_state = 8},
  [2925] = {.lex_state = 99, .external_lex_state = 10},
  [2926] = {.lex_state = 99, .external_lex_state = 10},
  [2927] = {.lex_state = 99, .external_lex_state = 9},
  [2928] = {.lex_state = 145, .external_lex_state = 24},
  [2929] = {.lex_state = 99, .external_lex_state = 9},
  [2930] = {.lex_state = 99, .external_lex_state = 9},
  [2931] = {.lex_state = 89, .external_lex_state = 10},
  [2932] = {.lex_state = 99, .external_lex_state = 9},
  [2933] = {.lex_state = 99, .external_lex_state = 9},
  [2934] = {.lex_state = 99, .external_lex_state = 9},
  [2935] = {.lex_state = 99, .external_lex_state = 9},
  [2936] = {.lex_state = 99, .external_lex_state = 9},
  [2937] = {.lex_state = 99, .external_lex_state = 9},
  [2938] = {.lex_state = 99, .external_lex_state = 9},
  [2939] = {.lex_state = 99, .external_lex_state = 9},
  [2940] = {.lex_state = 89, .external_lex_state = 10},
  [2941] = {.lex_state = 99, .external_lex_state = 9},
  [2942] = {.lex_state = 89, .external_lex_state = 10},
  [2943] = {.lex_state = 99, .external_lex_state = 9},
  [2944] = {.lex_state = 101, .external_lex_state = 10},
  [2945] = {.lex_state = 101, .external_lex_state = 10},
  [2946] = {.lex_state = 81, .external_lex_state = 10},
  [2947] = {.lex_state = 335, .external_lex_state = 9},
  [2948] = {.lex_state = 99, .external_lex_state = 9},
  [2949] = {.lex_state = 99, .external_lex_state = 9},
  [2950] = {.lex_state = 100, .external_lex_state = 10},
  [2951] = {.lex_state = 99, .external_lex_state = 9},
  [2952] = {.lex_state = 92, .external_lex_state = 10},
  [2953] = {.lex_state = 84, .external_lex_state = 10},
  [2954] = {.lex_state = 81, .external_lex_state = 10},
  [2955] = {.lex_state = 99, .external_lex_state = 9},
  [2956] = {.lex_state = 99, .external_lex_state = 9},
  [2957] = {.lex_state = 334, .external_lex_state = 8},
  [2958] = {.lex_state = 100, .external_lex_state = 10},
  [2959] = {.lex_state = 335, .external_lex_state = 9},
  [2960] = {.lex_state = 92, .external_lex_state = 10},
  [2961] = {.lex_state = 335, .external_lex_state = 10},
  [2962] = {.lex_state = 334, .external_lex_state = 8},
  [2963] = {.lex_state = 89, .external_lex_state = 10},
  [2964] = {.lex_state = 100, .external_lex_state = 10},
  [2965] = {.lex_state = 100, .external_lex_state = 10},
  [2966] = {.lex_state = 88, .external_lex_state = 10},
  [2967] = {.lex_state = 99, .external_lex_state = 10},
  [2968] = {.lex_state = 145, .external_lex_state = 24},
  [2969] = {.lex_state = 100, .external_lex_state = 10},
  [2970] = {.lex_state = 345, .external_lex_state = 23},
  [2971] = {.lex_state = 99, .external_lex_state = 10},
  [2972] = {.lex_state = 104, .external_lex_state = 10},
  [2973] = {.lex_state = 99, .external_lex_state = 10},
  [2974] = {.lex_state = 345, .external_lex_state = 23},
  [2975] = {.lex_state = 99, .external_lex_state = 10},
  [2976] = {.lex_state = 99, .external_lex_state = 10},
  [2977] = {.lex_state = 73, .external_lex_state = 10},
  [2978] = {.lex_state = 99, .external_lex_state = 10},
  [2979] = {.lex_state = 99, .external_lex_state = 10},
  [2980] = {.lex_state = 99, .external_lex_state = 10},
  [2981] = {.lex_state = 99, .external_lex_state = 10},
  [2982] = {.lex_state = 99, .external_lex_state = 10},
  [2983] = {.lex_state = 100, .external_lex_state = 10},
  [2984] = {.lex_state = 99, .external_lex_state = 10},
  [2985] = {.lex_state = 92, .external_lex_state = 10},
  [2986] = {.lex_state = 345, .external_lex_state = 23},
  [2987] = {.lex_state = 345, .external_lex_state = 23},
  [2988] = {.lex_state = 99, .external_lex_state = 10},
  [2989] = {.lex_state = 99, .external_lex_state = 10},
  [2990] = {.lex_state = 99, .external_lex_state = 10},
  [2991] = {.lex_state = 99, .external_lex_state = 10},
  [2992] = {.lex_state = 99, .external_lex_state = 10},
  [2993] = {.lex_state = 99, .external_lex_state = 10},
  [2994] = {.lex_state = 99, .external_lex_state = 10},
  [2995] = {.lex_state = 99, .external_lex_state = 10},
  [2996] = {.lex_state = 99, .external_lex_state = 10},
  [2997] = {.lex_state = 145, .external_lex_state = 25},
  [2998] = {.lex_state = 99, .external_lex_state = 10},
  [2999] = {.lex_state = 345, .external_lex_state = 23},
  [3000] = {.lex_state = 345, .external_lex_state = 23},
  [3001] = {.lex_state = 335, .external_lex_state = 8},
  [3002] = {.lex_state = 103, .external_lex_state = 10},
  [3003] = {.lex_state = 99, .external_lex_state = 10},
  [3004] = {.lex_state = 100, .external_lex_state = 10},
  [3005] = {.lex_state = 89, .external_lex_state = 10},
  [3006] = {.lex_state = 100, .external_lex_state = 10},
  [3007] = {.lex_state = 99, .external_lex_state = 10},
  [3008] = {.lex_state = 338, .external_lex_state = 10},
  [3009] = {.lex_state = 99, .external_lex_state = 10},
  [3010] = {.lex_state = 99, .external_lex_state = 10},
  [3011] = {.lex_state = 99, .external_lex_state = 10},
  [3012] = {.lex_state = 103, .external_lex_state = 10},
  [3013] = {.lex_state = 338, .external_lex_state = 10},
  [3014] = {.lex_state = 100, .external_lex_state = 10},
  [3015] = {.lex_state = 99, .external_lex_state = 10},
  [3016] = {.lex_state = 99, .external_lex_state = 10},
  [3017] = {.lex_state = 100, .external_lex_state = 10},
  [3018] = {.lex_state = 77, .external_lex_state = 10},
  [3019] = {.lex_state = 100, .external_lex_state = 10},
  [3020] = {.lex_state = 99, .external_lex_state = 10},
  [3021] = {.lex_state = 99, .external_lex_state = 10},
  [3022] = {.lex_state = 99, .external_lex_state = 10},
  [3023] = {.lex_state = 99, .external_lex_state = 10},
  [3024] = {.lex_state = 89, .external_lex_state = 10},
  [3025] = {.lex_state = 100, .external_lex_state = 10},
  [3026] = {.lex_state = 100, .external_lex_state = 10},
  [3027] = {.lex_state = 100, .external_lex_state = 10},
  [3028] = {.lex_state = 100, .external_lex_state = 10},
  [3029] = {.lex_state = 77, .external_lex_state = 10},
  [3030] = {.lex_state = 100, .external_lex_state = 10},
  [3031] = {.lex_state = 100, .external_lex_state = 10},
  [3032] = {.lex_state = 104, .external_lex_state = 10},
  [3033] = {.lex_state = 99, .external_lex_state = 10},
  [3034] = {.lex_state = 100, .external_lex_state = 10},
  [3035] = {.lex_state = 92, .external_lex_state = 10},
  [3036] = {.lex_state = 345, .external_lex_state = 23},
  [3037] = {.lex_state = 103, .external_lex_state = 10},
  [3038] = {.lex_state = 99, .external_lex_state = 10},
  [3039] = {.lex_state = 100, .external_lex_state = 10},
  [3040] = {.lex_state = 100, .external_lex_state = 10},
  [3041] = {.lex_state = 100, .external_lex_state = 10},
  [3042] = {.lex_state = 100, .external_lex_state = 10},
  [3043] = {.lex_state = 99, .external_lex_state = 10},
  [3044] = {.lex_state = 99, .external_lex_state = 10},
  [3045] = {.lex_state = 89, .external_lex_state = 10},
  [3046] = {.lex_state = 104, .external_lex_state = 10},
  [3047] = {.lex_state = 100, .external_lex_state = 10},
  [3048] = {.lex_state = 100, .external_lex_state = 10},
  [3049] = {.lex_state = 100, .external_lex_state = 10},
  [3050] = {.lex_state = 100, .external_lex_state = 10},
  [3051] = {.lex_state = 100, .external_lex_state = 10},
  [3052] = {.lex_state = 99, .external_lex_state = 10},
  [3053] = {.lex_state = 100, .external_lex_state = 10},
  [3054] = {.lex_state = 77, .external_lex_state = 10},
  [3055] = {.lex_state = 100, .external_lex_state = 10},
  [3056] = {.lex_state = 100, .external_lex_state = 10},
  [3057] = {.lex_state = 100, .external_lex_state = 10},
  [3058] = {.lex_state = 100, .external_lex_state = 10},
  [3059] = {.lex_state = 100, .external_lex_state = 10},
  [3060] = {.lex_state = 77, .external_lex_state = 10},
  [3061] = {.lex_state = 99, .external_lex_state = 10},
  [3062] = {.lex_state = 100, .external_lex_state = 10},
  [3063] = {.lex_state = 100, .external_lex_state = 10},
  [3064] = {.lex_state = 100, .external_lex_state = 10},
  [3065] = {.lex_state = 100, .external_lex_state = 10},
  [3066] = {.lex_state = 100, .external_lex_state = 10},
  [3067] = {.lex_state = 92, .external_lex_state = 10},
  [3068] = {.lex_state = 100, .external_lex_state = 10},
  [3069] = {.lex_state = 99, .external_lex_state = 10},
  [3070] = {.lex_state = 100, .external_lex_state = 10},
  [3071] = {.lex_state = 103, .external_lex_state = 10},
  [3072] = {.lex_state = 99, .external_lex_state = 10},
  [3073] = {.lex_state = 99, .external_lex_state = 10},
  [3074] = {.lex_state = 100, .external_lex_state = 10},
  [3075] = {.lex_state = 100, .external_lex_state = 10},
  [3076] = {.lex_state = 100, .external_lex_state = 10},
  [3077] = {.lex_state = 100, .external_lex_state = 10},
  [3078] = {.lex_state = 100, .external_lex_state = 10},
  [3079] = {.lex_state = 100, .external_lex_state = 10},
  [3080] = {.lex_state = 100, .external_lex_state = 10},
  [3081] = {.lex_state = 100, .external_lex_state = 10},
  [3082] = {.lex_state = 100, .external_lex_state = 10},
  [3083] = {.lex_state = 99, .external_lex_state = 10},
  [3084] = {.lex_state = 99, .external_lex_state = 10},
  [3085] = {.lex_state = 100, .external_lex_state = 10},
  [3086] = {.lex_state = 103, .external_lex_state = 10},
  [3087] = {.lex_state = 99, .external_lex_state = 10},
  [3088] = {.lex_state = 153},
  [3089] = {.lex_state = 100, .external_lex_state = 10},
  [3090] = {.lex_state = 100, .external_lex_state = 10},
  [3091] = {.lex_state = 100, .external_lex_state = 10},
  [3092] = {.lex_state = 100, .external_lex_state = 10},
  [3093] = {.lex_state = 100, .external_lex_state = 10},
  [3094] = {.lex_state = 145, .external_lex_state = 25},
  [3095] = {.lex_state = 100, .external_lex_state = 10},
  [3096] = {.lex_state = 100, .external_lex_state = 10},
  [3097] = {.lex_state = 104, .external_lex_state = 10},
  [3098] = {.lex_state = 99, .external_lex_state = 10},
  [3099] = {.lex_state = 100, .external_lex_state = 10},
  [3100] = {.lex_state = 100, .external_lex_state = 10},
  [3101] = {.lex_state = 100, .external_lex_state = 10},
  [3102] = {.lex_state = 99, .external_lex_state = 10},
  [3103] = {.lex_state = 99, .external_lex_state = 10},
  [3104] = {.lex_state = 100, .external_lex_state = 10},
  [3105] = {.lex_state = 100, .external_lex_state = 10},
  [3106] = {.lex_state = 100, .external_lex_state = 10},
  [3107] = {.lex_state = 99, .external_lex_state = 10},
  [3108] = {.lex_state = 99, .external_lex_state = 10},
  [3109] = {.lex_state = 99, .external_lex_state = 10},
  [3110] = {.lex_state = 145},
  [3111] = {.lex_state = 335, .external_lex_state = 4},
  [3112] = {.lex_state = 99, .external_lex_state = 10},
  [3113] = {.lex_state = 99, .external_lex_state = 10},
  [3114] = {.lex_state = 89, .external_lex_state = 10},
  [3115] = {.lex_state = 99, .external_lex_state = 10},
  [3116] = {.lex_state = 100, .external_lex_state = 10},
  [3117] = {.lex_state = 100, .external_lex_state = 10},
  [3118] = {.lex_state = 99, .external_lex_state = 10},
  [3119] = {.lex_state = 338, .external_lex_state = 10},
  [3120] = {.lex_state = 99, .external_lex_state = 10},
  [3121] = {.lex_state = 338, .external_lex_state = 10},
  [3122] = {.lex_state = 335, .external_lex_state = 8},
  [3123] = {.lex_state = 99, .external_lex_state = 10},
  [3124] = {.lex_state = 99, .external_lex_state = 10},
  [3125] = {.lex_state = 99, .external_lex_state = 10},
  [3126] = {.lex_state = 99, .external_lex_state = 10},
  [3127] = {.lex_state = 100, .external_lex_state = 10},
  [3128] = {.lex_state = 99, .external_lex_state = 10},
  [3129] = {.lex_state = 100, .external_lex_state = 10},
  [3130] = {.lex_state = 100, .external_lex_state = 10},
  [3131] = {.lex_state = 100, .external_lex_state = 10},
  [3132] = {.lex_state = 99, .external_lex_state = 10},
  [3133] = {.lex_state = 99, .external_lex_state = 10},
  [3134] = {.lex_state = 153},
  [3135] = {.lex_state = 100, .external_lex_state = 10},
  [3136] = {.lex_state = 99, .external_lex_state = 10},
  [3137] = {.lex_state = 145},
  [3138] = {.lex_state = 73, .external_lex_state = 10},
  [3139] = {.lex_state = 99, .external_lex_state = 10},
  [3140] = {.lex_state = 103, .external_lex_state = 10},
  [3141] = {.lex_state = 99, .external_lex_state = 10},
  [3142] = {.lex_state = 100, .external_lex_state = 10},
  [3143] = {.lex_state = 99, .external_lex_state = 10},
  [3144] = {.lex_state = 100, .external_lex_state = 10},
  [3145] = {.lex_state = 99, .external_lex_state = 10},
  [3146] = {.lex_state = 85, .external_lex_state = 10},
  [3147] = {.lex_state = 85, .external_lex_state = 10},
  [3148] = {.lex_state = 104, .external_lex_state = 10},
  [3149] = {.lex_state = 102, .external_lex_state = 10},
  [3150] = {.lex_state = 338, .external_lex_state = 10},
  [3151] = {.lex_state = 102, .external_lex_state = 10},
  [3152] = {.lex_state = 99, .external_lex_state = 10},
  [3153] = {.lex_state = 99, .external_lex_state = 10},
  [3154] = {.lex_state = 100, .external_lex_state = 10},
  [3155] = {.lex_state = 92, .external_lex_state = 10},
  [3156] = {.lex_state = 100, .external_lex_state = 10},
  [3157] = {.lex_state = 100, .external_lex_state = 10},
  [3158] = {.lex_state = 100, .external_lex_state = 10},
  [3159] = {.lex_state = 99, .external_lex_state = 10},
  [3160] = {.lex_state = 345, .external_lex_state = 23},
  [3161] = {.lex_state = 100, .external_lex_state = 10},
  [3162] = {.lex_state = 103, .external_lex_state = 10},
  [3163] = {.lex_state = 100, .external_lex_state = 10},
  [3164] = {.lex_state = 99, .external_lex_state = 10},
  [3165] = {.lex_state = 100, .external_lex_state = 10},
  [3166] = {.lex_state = 89, .external_lex_state = 10},
  [3167] = {.lex_state = 85, .external_lex_state = 10},
  [3168] = {.lex_state = 338, .external_lex_state = 10},
  [3169] = {.lex_state = 99, .external_lex_state = 10},
  [3170] = {.lex_state = 99, .external_lex_state = 10},
  [3171] = {.lex_state = 92, .external_lex_state = 10},
  [3172] = {.lex_state = 99, .external_lex_state = 10},
  [3173] = {.lex_state = 345, .external_lex_state = 23},
  [3174] = {.lex_state = 345, .external_lex_state = 23},
  [3175] = {.lex_state = 102, .external_lex_state = 10},
  [3176] = {.lex_state = 102, .external_lex_state = 10},
  [3177] = {.lex_state = 145, .external_lex_state = 24},
  [3178] = {.lex_state = 77, .external_lex_state = 10},
  [3179] = {.lex_state = 99, .external_lex_state = 10},
  [3180] = {.lex_state = 338, .external_lex_state = 10},
  [3181] = {.lex_state = 338, .external_lex_state = 10},
  [3182] = {.lex_state = 92, .external_lex_state = 10},
  [3183] = {.lex_state = 92, .external_lex_state = 10},
  [3184] = {.lex_state = 104, .external_lex_state = 10},
  [3185] = {.lex_state = 85, .external_lex_state = 10},
  [3186] = {.lex_state = 100, .external_lex_state = 10},
  [3187] = {.lex_state = 100, .external_lex_state = 10},
  [3188] = {.lex_state = 102, .external_lex_state = 10},
  [3189] = {.lex_state = 92, .external_lex_state = 10},
  [3190] = {.lex_state = 100, .external_lex_state = 10},
  [3191] = {.lex_state = 338, .external_lex_state = 10},
  [3192] = {.lex_state = 99, .external_lex_state = 10},
  [3193] = {.lex_state = 99, .external_lex_state = 10},
  [3194] = {.lex_state = 85, .external_lex_state = 10},
  [3195] = {.lex_state = 104, .external_lex_state = 10},
  [3196] = {.lex_state = 104, .external_lex_state = 10},
  [3197] = {.lex_state = 103, .external_lex_state = 10},
  [3198] = {.lex_state = 100, .external_lex_state = 10},
  [3199] = {.lex_state = 99, .external_lex_state = 10},
  [3200] = {.lex_state = 92, .external_lex_state = 10},
  [3201] = {.lex_state = 104, .external_lex_state = 10},
  [3202] = {.lex_state = 165},
  [3203] = {.lex_state = 92, .external_lex_state = 10},
  [3204] = {.lex_state = 92, .external_lex_state = 10},
  [3205] = {.lex_state = 165},
  [3206] = {.lex_state = 345, .external_lex_state = 23},
  [3207] = {.lex_state = 165},
  [3208] = {.lex_state = 338, .external_lex_state = 10},
  [3209] = {.lex_state = 92, .external_lex_state = 10},
  [3210] = {.lex_state = 92, .external_lex_state = 10},
  [3211] = {.lex_state = 92, .external_lex_state = 10},
  [3212] = {.lex_state = 92, .external_lex_state = 10},
  [3213] = {.lex_state = 92, .external_lex_state = 10},
  [3214] = {.lex_state = 103, .external_lex_state = 10},
  [3215] = {.lex_state = 159},
  [3216] = {.lex_state = 338, .external_lex_state = 10},
  [3217] = {.lex_state = 165},
  [3218] = {.lex_state = 165},
  [3219] = {.lex_state = 92, .external_lex_state = 10},
  [3220] = {.lex_state = 92, .external_lex_state = 10},
  [3221] = {.lex_state = 92, .external_lex_state = 10},
  [3222] = {.lex_state = 92, .external_lex_state = 10},
  [3223] = {.lex_state = 345, .external_lex_state = 23},
  [3224] = {.lex_state = 92, .external_lex_state = 10},
  [3225] = {.lex_state = 92, .external_lex_state = 10},
  [3226] = {.lex_state = 92, .external_lex_state = 10},
  [3227] = {.lex_state = 338, .external_lex_state = 10},
  [3228] = {.lex_state = 92, .external_lex_state = 10},
  [3229] = {.lex_state = 92, .external_lex_state = 10},
  [3230] = {.lex_state = 165},
  [3231] = {.lex_state = 92, .external_lex_state = 10},
  [3232] = {.lex_state = 92, .external_lex_state = 10},
  [3233] = {.lex_state = 92, .external_lex_state = 10},
  [3234] = {.lex_state = 92, .external_lex_state = 10},
  [3235] = {.lex_state = 92, .external_lex_state = 10},
  [3236] = {.lex_state = 338, .external_lex_state = 10},
  [3237] = {.lex_state = 92, .external_lex_state = 10},
  [3238] = {.lex_state = 92, .external_lex_state = 10},
  [3239] = {.lex_state = 92, .external_lex_state = 10},
  [3240] = {.lex_state = 92, .external_lex_state = 10},
  [3241] = {.lex_state = 92, .external_lex_state = 10},
  [3242] = {.lex_state = 92, .external_lex_state = 10},
  [3243] = {.lex_state = 92, .external_lex_state = 10},
  [3244] = {.lex_state = 92, .external_lex_state = 10},
  [3245] = {.lex_state = 92, .external_lex_state = 10},
  [3246] = {.lex_state = 92, .external_lex_state = 10},
  [3247] = {.lex_state = 92, .external_lex_state = 10},
  [3248] = {.lex_state = 92, .external_lex_state = 10},
  [3249] = {.lex_state = 92, .external_lex_state = 10},
  [3250] = {.lex_state = 92, .external_lex_state = 10},
  [3251] = {.lex_state = 92, .external_lex_state = 10},
  [3252] = {.lex_state = 92, .external_lex_state = 10},
  [3253] = {.lex_state = 103, .external_lex_state = 10},
  [3254] = {.lex_state = 92, .external_lex_state = 10},
  [3255] = {.lex_state = 92, .external_lex_state = 10},
  [3256] = {.lex_state = 103, .external_lex_state = 10},
  [3257] = {.lex_state = 103, .external_lex_state = 10},
  [3258] = {.lex_state = 338, .external_lex_state = 10},
  [3259] = {.lex_state = 338, .external_lex_state = 10},
  [3260] = {.lex_state = 92, .external_lex_state = 10},
  [3261] = {.lex_state = 92, .external_lex_state = 10},
  [3262] = {.lex_state = 338, .external_lex_state = 10},
  [3263] = {.lex_state = 103, .external_lex_state = 10},
  [3264] = {.lex_state = 165},
  [3265] = {.lex_state = 92, .external_lex_state = 10},
  [3266] = {.lex_state = 92, .external_lex_state = 10},
  [3267] = {.lex_state = 338, .external_lex_state = 10},
  [3268] = {.lex_state = 338, .external_lex_state = 10},
  [3269] = {.lex_state = 103, .external_lex_state = 10},
  [3270] = {.lex_state = 92, .external_lex_state = 10},
  [3271] = {.lex_state = 338, .external_lex_state = 10},
  [3272] = {.lex_state = 338, .external_lex_state = 10},
  [3273] = {.lex_state = 338, .external_lex_state = 10},
  [3274] = {.lex_state = 338, .external_lex_state = 10},
  [3275] = {.lex_state = 338, .external_lex_state = 10},
  [3276] = {.lex_state = 338, .external_lex_state = 10},
  [3277] = {.lex_state = 338, .external_lex_state = 10},
  [3278] = {.lex_state = 92, .external_lex_state = 10},
  [3279] = {.lex_state = 92, .external_lex_state = 10},
  [3280] = {.lex_state = 338, .external_lex_state = 10},
  [3281] = {.lex_state = 338, .external_lex_state = 10},
  [3282] = {.lex_state = 92, .external_lex_state = 10},
  [3283] = {.lex_state = 338, .external_lex_state = 10},
  [3284] = {.lex_state = 338, .external_lex_state = 10},
  [3285] = {.lex_state = 92, .external_lex_state = 10},
  [3286] = {.lex_state = 165},
  [3287] = {.lex_state = 338, .external_lex_state = 10},
  [3288] = {.lex_state = 103, .external_lex_state = 10},
  [3289] = {.lex_state = 103, .external_lex_state = 10},
  [3290] = {.lex_state = 92, .external_lex_state = 10},
  [3291] = {.lex_state = 165},
  [3292] = {.lex_state = 103, .external_lex_state = 10},
  [3293] = {.lex_state = 159},
  [3294] = {.lex_state = 338, .external_lex_state = 10},
  [3295] = {.lex_state = 338, .external_lex_state = 10},
  [3296] = {.lex_state = 338, .external_lex_state = 10},
  [3297] = {.lex_state = 338, .external_lex_state = 10},
  [3298] = {.lex_state = 338, .external_lex_state = 10},
  [3299] = {.lex_state = 103, .external_lex_state = 10},
  [3300] = {.lex_state = 92, .external_lex_state = 10},
  [3301] = {.lex_state = 338, .external_lex_state = 10},
  [3302] = {.lex_state = 165},
  [3303] = {.lex_state = 153},
  [3304] = {.lex_state = 338, .external_lex_state = 10},
  [3305] = {.lex_state = 338, .external_lex_state = 10},
  [3306] = {.lex_state = 153},
  [3307] = {.lex_state = 103, .external_lex_state = 10},
  [3308] = {.lex_state = 103, .external_lex_state = 10},
  [3309] = {.lex_state = 92, .external_lex_state = 10},
  [3310] = {.lex_state = 338, .external_lex_state = 10},
  [3311] = {.lex_state = 338, .external_lex_state = 10},
  [3312] = {.lex_state = 338, .external_lex_state = 10},
  [3313] = {.lex_state = 104, .external_lex_state = 10},
  [3314] = {.lex_state = 338, .external_lex_state = 10},
  [3315] = {.lex_state = 92, .external_lex_state = 10},
  [3316] = {.lex_state = 338, .external_lex_state = 10},
  [3317] = {.lex_state = 338, .external_lex_state = 10},
  [3318] = {.lex_state = 338, .external_lex_state = 10},
  [3319] = {.lex_state = 338, .external_lex_state = 10},
  [3320] = {.lex_state = 338, .external_lex_state = 10},
  [3321] = {.lex_state = 103, .external_lex_state = 10},
  [3322] = {.lex_state = 338, .external_lex_state = 10},
  [3323] = {.lex_state = 338, .external_lex_state = 10},
  [3324] = {.lex_state = 338, .external_lex_state = 10},
  [3325] = {.lex_state = 165},
  [3326] = {.lex_state = 103, .external_lex_state = 10},
  [3327] = {.lex_state = 165},
  [3328] = {.lex_state = 338, .external_lex_state = 10},
  [3329] = {.lex_state = 338, .external_lex_state = 10},
  [3330] = {.lex_state = 338, .external_lex_state = 10},
  [3331] = {.lex_state = 338, .external_lex_state = 10},
  [3332] = {.lex_state = 338, .external_lex_state = 10},
  [3333] = {.lex_state = 338, .external_lex_state = 10},
  [3334] = {.lex_state = 338, .external_lex_state = 10},
  [3335] = {.lex_state = 338, .external_lex_state = 10},
  [3336] = {.lex_state = 103, .external_lex_state = 10},
  [3337] = {.lex_state = 103, .external_lex_state = 10},
  [3338] = {.lex_state = 165},
  [3339] = {.lex_state = 165},
  [3340] = {.lex_state = 103, .external_lex_state = 10},
  [3341] = {.lex_state = 338, .external_lex_state = 10},
  [3342] = {.lex_state = 103, .external_lex_state = 10},
  [3343] = {.lex_state = 338, .external_lex_state = 10},
  [3344] = {.lex_state = 335, .external_lex_state = 9},
  [3345] = {.lex_state = 92, .external_lex_state = 10},
  [3346] = {.lex_state = 338, .external_lex_state = 10},
  [3347] = {.lex_state = 338, .external_lex_state = 10},
  [3348] = {.lex_state = 335, .external_lex_state = 9},
  [3349] = {.lex_state = 338, .external_lex_state = 10},
  [3350] = {.lex_state = 338, .external_lex_state = 10},
  [3351] = {.lex_state = 338, .external_lex_state = 10},
  [3352] = {.lex_state = 338, .external_lex_state = 10},
  [3353] = {.lex_state = 92, .external_lex_state = 10},
  [3354] = {.lex_state = 92, .external_lex_state = 10},
  [3355] = {.lex_state = 104, .external_lex_state = 10},
  [3356] = {.lex_state = 103, .external_lex_state = 10},
  [3357] = {.lex_state = 338, .external_lex_state = 10},
  [3358] = {.lex_state = 165},
  [3359] = {.lex_state = 103, .external_lex_state = 10},
  [3360] = {.lex_state = 165},
  [3361] = {.lex_state = 104, .external_lex_state = 10},
  [3362] = {.lex_state = 92, .external_lex_state = 10},
  [3363] = {.lex_state = 338, .external_lex_state = 10},
  [3364] = {.lex_state = 338, .external_lex_state = 10},
  [3365] = {.lex_state = 338, .external_lex_state = 10},
  [3366] = {.lex_state = 338, .external_lex_state = 10},
  [3367] = {.lex_state = 104, .external_lex_state = 10},
  [3368] = {.lex_state = 104, .external_lex_state = 10},
  [3369] = {.lex_state = 103, .external_lex_state = 10},
  [3370] = {.lex_state = 104, .external_lex_state = 10},
  [3371] = {.lex_state = 103, .external_lex_state = 10},
  [3372] = {.lex_state = 104, .external_lex_state = 10},
  [3373] = {.lex_state = 92, .external_lex_state = 10},
  [3374] = {.lex_state = 104, .external_lex_state = 10},
  [3375] = {.lex_state = 104, .external_lex_state = 10},
  [3376] = {.lex_state = 103, .external_lex_state = 10},
  [3377] = {.lex_state = 165},
  [3378] = {.lex_state = 92, .external_lex_state = 10},
  [3379] = {.lex_state = 165},
  [3380] = {.lex_state = 103, .external_lex_state = 10},
  [3381] = {.lex_state = 103, .external_lex_state = 10},
  [3382] = {.lex_state = 103, .external_lex_state = 10},
  [3383] = {.lex_state = 338, .external_lex_state = 10},
  [3384] = {.lex_state = 103, .external_lex_state = 10},
  [3385] = {.lex_state = 104, .external_lex_state = 10},
  [3386] = {.lex_state = 103, .external_lex_state = 10},
  [3387] = {.lex_state = 104, .external_lex_state = 10},
  [3388] = {.lex_state = 104, .external_lex_state = 10},
  [3389] = {.lex_state = 104, .external_lex_state = 10},
  [3390] = {.lex_state = 104, .external_lex_state = 10},
  [3391] = {.lex_state = 104, .external_lex_state = 10},
  [3392] = {.lex_state = 103, .external_lex_state = 10},
  [3393] = {.lex_state = 104, .external_lex_state = 10},
  [3394] = {.lex_state = 165},
  [3395] = {.lex_state = 104, .external_lex_state = 10},
  [3396] = {.lex_state = 104, .external_lex_state = 10},
  [3397] = {.lex_state = 104, .external_lex_state = 10},
  [3398] = {.lex_state = 104, .external_lex_state = 10},
  [3399] = {.lex_state = 104, .external_lex_state = 10},
  [3400] = {.lex_state = 104, .external_lex_state = 10},
  [3401] = {.lex_state = 103, .external_lex_state = 10},
  [3402] = {.lex_state = 103, .external_lex_state = 10},
  [3403] = {.lex_state = 103, .external_lex_state = 10},
  [3404] = {.lex_state = 103, .external_lex_state = 10},
  [3405] = {.lex_state = 104, .external_lex_state = 10},
  [3406] = {.lex_state = 92, .external_lex_state = 10},
  [3407] = {.lex_state = 92, .external_lex_state = 10},
  [3408] = {.lex_state = 104, .external_lex_state = 10},
  [3409] = {.lex_state = 104, .external_lex_state = 10},
  [3410] = {.lex_state = 92, .external_lex_state = 10},
  [3411] = {.lex_state = 165},
  [3412] = {.lex_state = 92, .external_lex_state = 10},
  [3413] = {.lex_state = 165},
  [3414] = {.lex_state = 104, .external_lex_state = 10},
  [3415] = {.lex_state = 104, .external_lex_state = 10},
  [3416] = {.lex_state = 338, .external_lex_state = 10},
  [3417] = {.lex_state = 104, .external_lex_state = 10},
  [3418] = {.lex_state = 103, .external_lex_state = 10},
  [3419] = {.lex_state = 165},
  [3420] = {.lex_state = 103, .external_lex_state = 10},
  [3421] = {.lex_state = 92, .external_lex_state = 10},
  [3422] = {.lex_state = 338, .external_lex_state = 10},
  [3423] = {.lex_state = 338, .external_lex_state = 10},
  [3424] = {.lex_state = 338, .external_lex_state = 10},
  [3425] = {.lex_state = 338, .external_lex_state = 10},
  [3426] = {.lex_state = 338, .external_lex_state = 10},
  [3427] = {.lex_state = 104, .external_lex_state = 10},
  [3428] = {.lex_state = 103, .external_lex_state = 10},
  [3429] = {.lex_state = 103, .external_lex_state = 10},
  [3430] = {.lex_state = 103, .external_lex_state = 10},
  [3431] = {.lex_state = 92, .external_lex_state = 10},
  [3432] = {.lex_state = 103, .external_lex_state = 10},
  [3433] = {.lex_state = 335, .external_lex_state = 9},
  [3434] = {.lex_state = 92, .external_lex_state = 10},
  [3435] = {.lex_state = 338, .external_lex_state = 10},
  [3436] = {.lex_state = 345, .external_lex_state = 23},
  [3437] = {.lex_state = 104, .external_lex_state = 10},
  [3438] = {.lex_state = 92, .external_lex_state = 10},
  [3439] = {.lex_state = 335, .external_lex_state = 9},
  [3440] = {.lex_state = 104, .external_lex_state = 10},
  [3441] = {.lex_state = 345, .external_lex_state = 23},
  [3442] = {.lex_state = 335, .external_lex_state = 8},
  [3443] = {.lex_state = 345, .external_lex_state = 23},
  [3444] = {.lex_state = 165},
  [3445] = {.lex_state = 104, .external_lex_state = 10},
  [3446] = {.lex_state = 165},
  [3447] = {.lex_state = 165},
  [3448] = {.lex_state = 104, .external_lex_state = 10},
  [3449] = {.lex_state = 104, .external_lex_state = 10},
  [3450] = {.lex_state = 338, .external_lex_state = 10},
  [3451] = {.lex_state = 92, .external_lex_state = 10},
  [3452] = {.lex_state = 92, .external_lex_state = 10},
  [3453] = {.lex_state = 104, .external_lex_state = 10},
  [3454] = {.lex_state = 104, .external_lex_state = 10},
  [3455] = {.lex_state = 338, .external_lex_state = 10},
  [3456] = {.lex_state = 92, .external_lex_state = 10},
  [3457] = {.lex_state = 145, .external_lex_state = 25},
  [3458] = {.lex_state = 103, .external_lex_state = 10},
  [3459] = {.lex_state = 335, .external_lex_state = 9},
  [3460] = {.lex_state = 104, .external_lex_state = 10},
  [3461] = {.lex_state = 104, .external_lex_state = 10},
  [3462] = {.lex_state = 103, .external_lex_state = 10},
  [3463] = {.lex_state = 104, .external_lex_state = 10},
  [3464] = {.lex_state = 104, .external_lex_state = 10},
  [3465] = {.lex_state = 103, .external_lex_state = 10},
  [3466] = {.lex_state = 104, .external_lex_state = 10},
  [3467] = {.lex_state = 104, .external_lex_state = 10},
  [3468] = {.lex_state = 338, .external_lex_state = 10},
  [3469] = {.lex_state = 165},
  [3470] = {.lex_state = 345, .external_lex_state = 23},
  [3471] = {.lex_state = 165},
  [3472] = {.lex_state = 104, .external_lex_state = 10},
  [3473] = {.lex_state = 103, .external_lex_state = 10},
  [3474] = {.lex_state = 104, .external_lex_state = 10},
  [3475] = {.lex_state = 104, .external_lex_state = 10},
  [3476] = {.lex_state = 165},
  [3477] = {.lex_state = 92, .external_lex_state = 10},
  [3478] = {.lex_state = 104, .external_lex_state = 10},
  [3479] = {.lex_state = 165},
  [3480] = {.lex_state = 103, .external_lex_state = 10},
  [3481] = {.lex_state = 104, .external_lex_state = 10},
  [3482] = {.lex_state = 104, .external_lex_state = 10},
  [3483] = {.lex_state = 104, .external_lex_state = 10},
  [3484] = {.lex_state = 104, .external_lex_state = 10},
  [3485] = {.lex_state = 104, .external_lex_state = 10},
  [3486] = {.lex_state = 104, .external_lex_state = 10},
  [3487] = {.lex_state = 104, .external_lex_state = 10},
  [3488] = {.lex_state = 338, .external_lex_state = 10},
  [3489] = {.lex_state = 92, .external_lex_state = 10},
  [3490] = {.lex_state = 165},
  [3491] = {.lex_state = 104, .external_lex_state = 10},
  [3492] = {.lex_state = 104, .external_lex_state = 10},
  [3493] = {.lex_state = 104, .external_lex_state = 10},
  [3494] = {.lex_state = 104, .external_lex_state = 10},
  [3495] = {.lex_state = 165},
  [3496] = {.lex_state = 345, .external_lex_state = 23},
  [3497] = {.lex_state = 104, .external_lex_state = 10},
  [3498] = {.lex_state = 165},
  [3499] = {.lex_state = 165},
  [3500] = {.lex_state = 104, .external_lex_state = 10},
  [3501] = {.lex_state = 103, .external_lex_state = 10},
  [3502] = {.lex_state = 104, .external_lex_state = 10},
  [3503] = {.lex_state = 335, .external_lex_state = 9},
  [3504] = {.lex_state = 338, .external_lex_state = 10},
  [3505] = {.lex_state = 104, .external_lex_state = 10},
  [3506] = {.lex_state = 104, .external_lex_state = 10},
  [3507] = {.lex_state = 335, .external_lex_state = 9},
  [3508] = {.lex_state = 104, .external_lex_state = 10},
  [3509] = {.lex_state = 103, .external_lex_state = 10},
  [3510] = {.lex_state = 104, .external_lex_state = 10},
  [3511] = {.lex_state = 335, .external_lex_state = 9},
  [3512] = {.lex_state = 104, .external_lex_state = 10},
  [3513] = {.lex_state = 165},
  [3514] = {.lex_state = 92, .external_lex_state = 10},
  [3515] = {.lex_state = 165},
  [3516] = {.lex_state = 345, .external_lex_state = 23},
  [3517] = {.lex_state = 103, .external_lex_state = 10},
  [3518] = {.lex_state = 103, .external_lex_state = 10},
  [3519] = {.lex_state = 103, .external_lex_state = 10},
  [3520] = {.lex_state = 165},
  [3521] = {.lex_state = 103, .external_lex_state = 10},
  [3522] = {.lex_state = 103, .external_lex_state = 10},
  [3523] = {.lex_state = 103, .external_lex_state = 10},
  [3524] = {.lex_state = 103, .external_lex_state = 10},
  [3525] = {.lex_state = 104, .external_lex_state = 10},
  [3526] = {.lex_state = 165},
  [3527] = {.lex_state = 104, .external_lex_state = 10},
  [3528] = {.lex_state = 145, .external_lex_state = 25},
  [3529] = {.lex_state = 104, .external_lex_state = 10},
  [3530] = {.lex_state = 338, .external_lex_state = 10},
  [3531] = {.lex_state = 165},
  [3532] = {.lex_state = 92, .external_lex_state = 10},
  [3533] = {.lex_state = 104, .external_lex_state = 10},
  [3534] = {.lex_state = 338, .external_lex_state = 10},
  [3535] = {.lex_state = 104, .external_lex_state = 10},
  [3536] = {.lex_state = 103, .external_lex_state = 10},
  [3537] = {.lex_state = 103, .external_lex_state = 10},
  [3538] = {.lex_state = 103, .external_lex_state = 10},
  [3539] = {.lex_state = 103, .external_lex_state = 10},
  [3540] = {.lex_state = 92, .external_lex_state = 10},
  [3541] = {.lex_state = 104, .external_lex_state = 10},
  [3542] = {.lex_state = 103, .external_lex_state = 10},
  [3543] = {.lex_state = 103, .external_lex_state = 10},
  [3544] = {.lex_state = 165},
  [3545] = {.lex_state = 103, .external_lex_state = 10},
  [3546] = {.lex_state = 103, .external_lex_state = 10},
  [3547] = {.lex_state = 165},
  [3548] = {.lex_state = 103, .external_lex_state = 10},
  [3549] = {.lex_state = 103, .external_lex_state = 10},
  [3550] = {.lex_state = 103, .external_lex_state = 10},
  [3551] = {.lex_state = 103, .external_lex_state = 10},
  [3552] = {.lex_state = 103, .external_lex_state = 10},
  [3553] = {.lex_state = 92, .external_lex_state = 10},
  [3554] = {.lex_state = 103, .external_lex_state = 10},
  [3555] = {.lex_state = 103, .external_lex_state = 10},
  [3556] = {.lex_state = 103, .external_lex_state = 10},
  [3557] = {.lex_state = 103, .external_lex_state = 10},
  [3558] = {.lex_state = 103, .external_lex_state = 10},
  [3559] = {.lex_state = 103, .external_lex_state = 10},
  [3560] = {.lex_state = 165},
  [3561] = {.lex_state = 103, .external_lex_state = 10},
  [3562] = {.lex_state = 103, .external_lex_state = 10},
  [3563] = {.lex_state = 165},
  [3564] = {.lex_state = 104, .external_lex_state = 10},
  [3565] = {.lex_state = 103, .external_lex_state = 10},
  [3566] = {.lex_state = 104, .external_lex_state = 10},
  [3567] = {.lex_state = 104, .external_lex_state = 10},
  [3568] = {.lex_state = 103, .external_lex_state = 10},
  [3569] = {.lex_state = 345, .external_lex_state = 23},
  [3570] = {.lex_state = 104, .external_lex_state = 10},
  [3571] = {.lex_state = 335, .external_lex_state = 9},
  [3572] = {.lex_state = 103, .external_lex_state = 10},
  [3573] = {.lex_state = 345, .external_lex_state = 23},
  [3574] = {.lex_state = 165},
  [3575] = {.lex_state = 165},
  [3576] = {.lex_state = 92, .external_lex_state = 10},
  [3577] = {.lex_state = 104, .external_lex_state = 10},
  [3578] = {.lex_state = 345, .external_lex_state = 23},
  [3579] = {.lex_state = 345, .external_lex_state = 23},
  [3580] = {.lex_state = 165},
  [3581] = {.lex_state = 165},
  [3582] = {.lex_state = 165},
  [3583] = {.lex_state = 165},
  [3584] = {.lex_state = 345, .external_lex_state = 23},
  [3585] = {.lex_state = 165},
  [3586] = {.lex_state = 165},
  [3587] = {.lex_state = 159},
  [3588] = {.lex_state = 165},
  [3589] = {.lex_state = 165},
  [3590] = {.lex_state = 165},
  [3591] = {.lex_state = 165},
  [3592] = {.lex_state = 345, .external_lex_state = 23},
  [3593] = {.lex_state = 165},
  [3594] = {.lex_state = 159},
  [3595] = {.lex_state = 165},
  [3596] = {.lex_state = 165},
  [3597] = {.lex_state = 345, .external_lex_state = 23},
  [3598] = {.lex_state = 165},
  [3599] = {.lex_state = 165},
  [3600] = {.lex_state = 345, .external_lex_state = 23},
  [3601] = {.lex_state = 345, .external_lex_state = 23},
  [3602] = {.lex_state = 345, .external_lex_state = 23},
  [3603] = {.lex_state = 345, .external_lex_state = 23},
  [3604] = {.lex_state = 345, .external_lex_state = 23},
  [3605] = {.lex_state = 345, .external_lex_state = 23},
  [3606] = {.lex_state = 345, .external_lex_state = 23},
  [3607] = {.lex_state = 345, .external_lex_state = 23},
  [3608] = {.lex_state = 345, .external_lex_state = 23},
  [3609] = {.lex_state = 345, .external_lex_state = 23},
  [3610] = {.lex_state = 345, .external_lex_state = 23},
  [3611] = {.lex_state = 345, .external_lex_state = 23},
  [3612] = {.lex_state = 165},
  [3613] = {.lex_state = 165},
  [3614] = {.lex_state = 165},
  [3615] = {.lex_state = 165},
  [3616] = {.lex_state = 165},
  [3617] = {.lex_state = 165},
  [3618] = {.lex_state = 165},
  [3619] = {.lex_state = 165},
  [3620] = {.lex_state = 165},
  [3621] = {.lex_state = 165},
  [3622] = {.lex_state = 165},
  [3623] = {.lex_state = 165},
  [3624] = {.lex_state = 165},
  [3625] = {.lex_state = 165},
  [3626] = {.lex_state = 165},
  [3627] = {.lex_state = 165},
  [3628] = {.lex_state = 165},
  [3629] = {.lex_state = 165},
  [3630] = {.lex_state = 165},
  [3631] = {.lex_state = 165},
  [3632] = {.lex_state = 165},
  [3633] = {.lex_state = 165},
  [3634] = {.lex_state = 165},
  [3635] = {.lex_state = 165},
  [3636] = {.lex_state = 165},
  [3637] = {.lex_state = 165},
  [3638] = {.lex_state = 165},
  [3639] = {.lex_state = 165},
  [3640] = {.lex_state = 165},
  [3641] = {.lex_state = 165},
  [3642] = {.lex_state = 165},
  [3643] = {.lex_state = 165},
  [3644] = {.lex_state = 165},
  [3645] = {.lex_state = 165},
  [3646] = {.lex_state = 165},
  [3647] = {.lex_state = 165},
  [3648] = {.lex_state = 165},
  [3649] = {.lex_state = 165},
  [3650] = {.lex_state = 165},
  [3651] = {.lex_state = 165},
  [3652] = {.lex_state = 165},
  [3653] = {.lex_state = 165},
  [3654] = {.lex_state = 165},
  [3655] = {.lex_state = 165},
  [3656] = {.lex_state = 165},
  [3657] = {.lex_state = 165},
  [3658] = {.lex_state = 165},
  [3659] = {.lex_state = 165},
  [3660] = {.lex_state = 165},
  [3661] = {.lex_state = 165},
  [3662] = {.lex_state = 165},
  [3663] = {.lex_state = 165},
  [3664] = {.lex_state = 165},
  [3665] = {.lex_state = 165},
  [3666] = {.lex_state = 165},
  [3667] = {.lex_state = 165},
  [3668] = {.lex_state = 165},
  [3669] = {.lex_state = 165},
  [3670] = {.lex_state = 165},
  [3671] = {.lex_state = 165},
  [3672] = {.lex_state = 165},
  [3673] = {.lex_state = 165},
  [3674] = {.lex_state = 165},
  [3675] = {.lex_state = 165},
  [3676] = {.lex_state = 165},
  [3677] = {.lex_state = 165},
  [3678] = {.lex_state = 165},
  [3679] = {.lex_state = 165},
  [3680] = {.lex_state = 165},
  [3681] = {.lex_state = 165},
  [3682] = {.lex_state = 165},
  [3683] = {.lex_state = 165},
  [3684] = {.lex_state = 165},
  [3685] = {.lex_state = 165},
  [3686] = {.lex_state = 165},
  [3687] = {.lex_state = 165},
  [3688] = {.lex_state = 165},
  [3689] = {.lex_state = 165},
  [3690] = {.lex_state = 165},
  [3691] = {.lex_state = 165},
  [3692] = {.lex_state = 165},
  [3693] = {.lex_state = 165},
  [3694] = {.lex_state = 165},
  [3695] = {.lex_state = 165},
  [3696] = {.lex_state = 165},
  [3697] = {.lex_state = 165},
  [3698] = {.lex_state = 165},
  [3699] = {.lex_state = 165},
  [3700] = {.lex_state = 165},
  [3701] = {.lex_state = 165},
  [3702] = {.lex_state = 165},
  [3703] = {.lex_state = 165},
  [3704] = {.lex_state = 165},
  [3705] = {.lex_state = 165},
  [3706] = {.lex_state = 165},
  [3707] = {.lex_state = 165},
  [3708] = {.lex_state = 165},
  [3709] = {.lex_state = 165},
  [3710] = {.lex_state = 165},
  [3711] = {.lex_state = 165},
  [3712] = {.lex_state = 165},
  [3713] = {.lex_state = 165},
  [3714] = {.lex_state = 165},
  [3715] = {.lex_state = 165},
  [3716] = {.lex_state = 165},
  [3717] = {.lex_state = 165},
  [3718] = {.lex_state = 165},
  [3719] = {.lex_state = 165},
  [3720] = {.lex_state = 165},
  [3721] = {.lex_state = 165},
  [3722] = {.lex_state = 165},
  [3723] = {.lex_state = 165},
  [3724] = {.lex_state = 165},
  [3725] = {.lex_state = 344, .external_lex_state = 23},
  [3726] = {.lex_state = 344, .external_lex_state = 23},
  [3727] = {.lex_state = 165},
  [3728] = {.lex_state = 165},
  [3729] = {.lex_state = 344, .external_lex_state = 23},
  [3730] = {.lex_state = 344, .external_lex_state = 23},
  [3731] = {.lex_state = 165},
  [3732] = {.lex_state = 344, .external_lex_state = 23},
  [3733] = {.lex_state = 165},
  [3734] = {.lex_state = 344, .external_lex_state = 23},
  [3735] = {.lex_state = 344, .external_lex_state = 23},
  [3736] = {.lex_state = 165},
  [3737] = {.lex_state = 165},
  [3738] = {.lex_state = 165},
  [3739] = {.lex_state = 165},
  [3740] = {.lex_state = 344, .external_lex_state = 23},
  [3741] = {.lex_state = 165},
  [3742] = {.lex_state = 165},
  [3743] = {.lex_state = 165},
  [3744] = {.lex_state = 344, .external_lex_state = 23},
  [3745] = {.lex_state = 165},
  [3746] = {.lex_state = 165},
  [3747] = {.lex_state = 165},
  [3748] = {.lex_state = 165},
  [3749] = {.lex_state = 344, .external_lex_state = 23},
  [3750] = {.lex_state = 165},
  [3751] = {.lex_state = 344, .external_lex_state = 23},
  [3752] = {.lex_state = 165},
  [3753] = {.lex_state = 165},
  [3754] = {.lex_state = 165},
  [3755] = {.lex_state = 344, .external_lex_state = 23},
  [3756] = {.lex_state = 165},
  [3757] = {.lex_state = 165},
  [3758] = {.lex_state = 344, .external_lex_state = 23},
  [3759] = {.lex_state = 344, .external_lex_state = 23},
  [3760] = {.lex_state = 165},
  [3761] = {.lex_state = 165},
  [3762] = {.lex_state = 344, .external_lex_state = 23},
  [3763] = {.lex_state = 165},
  [3764] = {.lex_state = 165},
  [3765] = {.lex_state = 165},
  [3766] = {.lex_state = 165},
  [3767] = {.lex_state = 165},
  [3768] = {.lex_state = 165},
  [3769] = {.lex_state = 165},
  [3770] = {.lex_state = 165},
  [3771] = {.lex_state = 165},
  [3772] = {.lex_state = 165},
  [3773] = {.lex_state = 165},
  [3774] = {.lex_state = 344, .external_lex_state = 23},
  [3775] = {.lex_state = 165},
  [3776] = {.lex_state = 344, .external_lex_state = 23},
  [3777] = {.lex_state = 165},
  [3778] = {.lex_state = 344, .external_lex_state = 23},
  [3779] = {.lex_state = 344, .external_lex_state = 23},
  [3780] = {.lex_state = 344, .external_lex_state = 23},
  [3781] = {.lex_state = 344, .external_lex_state = 23},
  [3782] = {.lex_state = 165},
  [3783] = {.lex_state = 165},
  [3784] = {.lex_state = 165},
  [3785] = {.lex_state = 165},
  [3786] = {.lex_state = 344, .external_lex_state = 23},
  [3787] = {.lex_state = 165},
  [3788] = {.lex_state = 344, .external_lex_state = 23},
  [3789] = {.lex_state = 344, .external_lex_state = 23},
  [3790] = {.lex_state = 165},
  [3791] = {.lex_state = 165},
  [3792] = {.lex_state = 165},
  [3793] = {.lex_state = 344, .external_lex_state = 23},
  [3794] = {.lex_state = 165},
  [3795] = {.lex_state = 165},
  [3796] = {.lex_state = 165},
  [3797] = {.lex_state = 165},
  [3798] = {.lex_state = 344, .external_lex_state = 23},
  [3799] = {.lex_state = 165},
  [3800] = {.lex_state = 344, .external_lex_state = 23},
  [3801] = {.lex_state = 344, .external_lex_state = 23},
  [3802] = {.lex_state = 165},
  [3803] = {.lex_state = 165},
  [3804] = {.lex_state = 344, .external_lex_state = 23},
  [3805] = {.lex_state = 344, .external_lex_state = 23},
  [3806] = {.lex_state = 165},
  [3807] = {.lex_state = 344, .external_lex_state = 23},
  [3808] = {.lex_state = 344, .external_lex_state = 23},
  [3809] = {.lex_state = 165},
  [3810] = {.lex_state = 344, .external_lex_state = 23},
  [3811] = {.lex_state = 344, .external_lex_state = 23},
  [3812] = {.lex_state = 165},
  [3813] = {.lex_state = 344, .external_lex_state = 23},
  [3814] = {.lex_state = 344, .external_lex_state = 23},
  [3815] = {.lex_state = 165},
  [3816] = {.lex_state = 138, .external_lex_state = 2},
  [3817] = {.lex_state = 165},
  [3818] = {.lex_state = 344, .external_lex_state = 23},
  [3819] = {.lex_state = 344, .external_lex_state = 23},
  [3820] = {.lex_state = 344, .external_lex_state = 23},
  [3821] = {.lex_state = 165},
  [3822] = {.lex_state = 344, .external_lex_state = 23},
  [3823] = {.lex_state = 344, .external_lex_state = 23},
  [3824] = {.lex_state = 344, .external_lex_state = 23},
  [3825] = {.lex_state = 165},
  [3826] = {.lex_state = 165},
  [3827] = {.lex_state = 165},
  [3828] = {.lex_state = 344, .external_lex_state = 23},
  [3829] = {.lex_state = 344, .external_lex_state = 23},
  [3830] = {.lex_state = 344, .external_lex_state = 23},
  [3831] = {.lex_state = 165},
  [3832] = {.lex_state = 344, .external_lex_state = 23},
  [3833] = {.lex_state = 344, .external_lex_state = 23},
  [3834] = {.lex_state = 165},
  [3835] = {.lex_state = 165},
  [3836] = {.lex_state = 165},
  [3837] = {.lex_state = 344, .external_lex_state = 23},
  [3838] = {.lex_state = 344, .external_lex_state = 23},
  [3839] = {.lex_state = 165},
  [3840] = {.lex_state = 165},
  [3841] = {.lex_state = 165},
  [3842] = {.lex_state = 165},
  [3843] = {.lex_state = 344, .external_lex_state = 23},
  [3844] = {.lex_state = 344, .external_lex_state = 23},
  [3845] = {.lex_state = 165},
  [3846] = {.lex_state = 344, .external_lex_state = 23},
  [3847] = {.lex_state = 344, .external_lex_state = 23},
  [3848] = {.lex_state = 165},
  [3849] = {.lex_state = 165},
  [3850] = {.lex_state = 165},
  [3851] = {.lex_state = 165},
  [3852] = {.lex_state = 165},
  [3853] = {.lex_state = 344, .external_lex_state = 23},
  [3854] = {.lex_state = 344, .external_lex_state = 23},
  [3855] = {.lex_state = 165},
  [3856] = {.lex_state = 165},
  [3857] = {.lex_state = 165},
  [3858] = {.lex_state = 165},
  [3859] = {.lex_state = 344, .external_lex_state = 23},
  [3860] = {.lex_state = 344, .external_lex_state = 23},
  [3861] = {.lex_state = 165},
  [3862] = {.lex_state = 165},
  [3863] = {.lex_state = 344, .external_lex_state = 23},
  [3864] = {.lex_state = 344, .external_lex_state = 23},
  [3865] = {.lex_state = 165},
  [3866] = {.lex_state = 165},
  [3867] = {.lex_state = 165, .external_lex_state = 24},
  [3868] = {.lex_state = 165},
  [3869] = {.lex_state = 165},
  [3870] = {.lex_state = 344, .external_lex_state = 23},
  [3871] = {.lex_state = 165},
  [3872] = {.lex_state = 165},
  [3873] = {.lex_state = 165},
  [3874] = {.lex_state = 165},
  [3875] = {.lex_state = 165},
  [3876] = {.lex_state = 165},
  [3877] = {.lex_state = 165},
  [3878] = {.lex_state = 165},
  [3879] = {.lex_state = 344, .external_lex_state = 23},
  [3880] = {.lex_state = 165},
  [3881] = {.lex_state = 165},
  [3882] = {.lex_state = 165},
  [3883] = {.lex_state = 165},
  [3884] = {.lex_state = 165},
  [3885] = {.lex_state = 165},
  [3886] = {.lex_state = 165},
  [3887] = {.lex_state = 165},
  [3888] = {.lex_state = 165},
  [3889] = {.lex_state = 165},
  [3890] = {.lex_state = 165},
  [3891] = {.lex_state = 165},
  [3892] = {.lex_state = 165},
  [3893] = {.lex_state = 165},
  [3894] = {.lex_state = 165},
  [3895] = {.lex_state = 165},
  [3896] = {.lex_state = 165},
  [3897] = {.lex_state = 165},
  [3898] = {.lex_state = 165},
  [3899] = {.lex_state = 165},
  [3900] = {.lex_state = 165},
  [3901] = {.lex_state = 165},
  [3902] = {.lex_state = 165},
  [3903] = {.lex_state = 165},
  [3904] = {.lex_state = 165},
  [3905] = {.lex_state = 165},
  [3906] = {.lex_state = 165},
  [3907] = {.lex_state = 165},
  [3908] = {.lex_state = 165},
  [3909] = {.lex_state = 165},
  [3910] = {.lex_state = 165},
  [3911] = {.lex_state = 165},
  [3912] = {.lex_state = 165},
  [3913] = {.lex_state = 165},
  [3914] = {.lex_state = 165},
  [3915] = {.lex_state = 165},
  [3916] = {.lex_state = 165},
  [3917] = {.lex_state = 165},
  [3918] = {.lex_state = 165},
  [3919] = {.lex_state = 165},
  [3920] = {.lex_state = 165},
  [3921] = {.lex_state = 165},
  [3922] = {.lex_state = 165},
  [3923] = {.lex_state = 165},
  [3924] = {.lex_state = 165},
  [3925] = {.lex_state = 165},
  [3926] = {.lex_state = 165},
  [3927] = {.lex_state = 165},
  [3928] = {.lex_state = 165},
  [3929] = {.lex_state = 165},
  [3930] = {.lex_state = 165},
  [3931] = {.lex_state = 165},
  [3932] = {.lex_state = 165},
  [3933] = {.lex_state = 165},
  [3934] = {.lex_state = 165},
  [3935] = {.lex_state = 165},
  [3936] = {.lex_state = 165},
  [3937] = {.lex_state = 165},
  [3938] = {.lex_state = 165},
  [3939] = {.lex_state = 165},
  [3940] = {.lex_state = 165},
  [3941] = {.lex_state = 165},
  [3942] = {.lex_state = 165},
  [3943] = {.lex_state = 165},
  [3944] = {.lex_state = 165},
  [3945] = {.lex_state = 165},
  [3946] = {.lex_state = 165},
  [3947] = {.lex_state = 165},
  [3948] = {.lex_state = 165},
  [3949] = {.lex_state = 165},
  [3950] = {.lex_state = 165},
  [3951] = {.lex_state = 165},
  [3952] = {.lex_state = 165},
  [3953] = {.lex_state = 165},
  [3954] = {.lex_state = 165},
  [3955] = {.lex_state = 165},
  [3956] = {.lex_state = 165},
  [3957] = {.lex_state = 165},
  [3958] = {.lex_state = 165},
  [3959] = {.lex_state = 165},
  [3960] = {.lex_state = 165},
  [3961] = {.lex_state = 165},
  [3962] = {.lex_state = 165},
  [3963] = {.lex_state = 165},
  [3964] = {.lex_state = 165},
  [3965] = {.lex_state = 165},
  [3966] = {.lex_state = 165},
  [3967] = {.lex_state = 165},
  [3968] = {.lex_state = 165},
  [3969] = {.lex_state = 165},
  [3970] = {.lex_state = 165},
  [3971] = {.lex_state = 165},
  [3972] = {.lex_state = 165},
  [3973] = {.lex_state = 165},
  [3974] = {.lex_state = 165},
  [3975] = {.lex_state = 165},
  [3976] = {.lex_state = 165},
  [3977] = {.lex_state = 165},
  [3978] = {.lex_state = 165},
  [3979] = {.lex_state = 165},
  [3980] = {.lex_state = 165},
  [3981] = {.lex_state = 165},
  [3982] = {.lex_state = 165},
  [3983] = {.lex_state = 165},
  [3984] = {.lex_state = 165},
  [3985] = {.lex_state = 165},
  [3986] = {.lex_state = 165},
  [3987] = {.lex_state = 165},
  [3988] = {.lex_state = 165},
  [3989] = {.lex_state = 165},
  [3990] = {.lex_state = 345, .external_lex_state = 2},
  [3991] = {.lex_state = 345, .external_lex_state = 2},
  [3992] = {.lex_state = 345, .external_lex_state = 2},
  [3993] = {.lex_state = 345, .external_lex_state = 2},
  [3994] = {.lex_state = 345, .external_lex_state = 2},
  [3995] = {.lex_state = 345, .external_lex_state = 2},
  [3996] = {.lex_state = 345, .external_lex_state = 2},
  [3997] = {.lex_state = 345, .external_lex_state = 2},
  [3998] = {.lex_state = 345, .external_lex_state = 2},
  [3999] = {.lex_state = 139, .external_lex_state = 2},
  [4000] = {.lex_state = 345, .external_lex_state = 2},
  [4001] = {.lex_state = 345, .external_lex_state = 2},
  [4002] = {.lex_state = 345, .external_lex_state = 2},
  [4003] = {.lex_state = 345, .external_lex_state = 2},
  [4004] = {.lex_state = 345, .external_lex_state = 2},
  [4005] = {.lex_state = 344, .external_lex_state = 23},
  [4006] = {.lex_state = 345, .external_lex_state = 2},
  [4007] = {.lex_state = 345, .external_lex_state = 2},
  [4008] = {.lex_state = 345, .external_lex_state = 2},
  [4009] = {.lex_state = 345, .external_lex_state = 2},
  [4010] = {.lex_state = 344, .external_lex_state = 23},
  [4011] = {.lex_state = 345, .external_lex_state = 2},
  [4012] = {.lex_state = 344, .external_lex_state = 23},
  [4013] = {.lex_state = 344, .external_lex_state = 23},
  [4014] = {.lex_state = 344, .external_lex_state = 23},
  [4015] = {.lex_state = 345, .external_lex_state = 2},
  [4016] = {.lex_state = 345, .external_lex_state = 2},
  [4017] = {.lex_state = 345, .external_lex_state = 2},
  [4018] = {.lex_state = 344, .external_lex_state = 23},
  [4019] = {.lex_state = 345, .external_lex_state = 2},
  [4020] = {.lex_state = 345, .external_lex_state = 2},
  [4021] = {.lex_state = 345, .external_lex_state = 2},
  [4022] = {.lex_state = 345, .external_lex_state = 2},
  [4023] = {.lex_state = 345, .external_lex_state = 2},
  [4024] = {.lex_state = 344, .external_lex_state = 23},
  [4025] = {.lex_state = 345, .external_lex_state = 2},
  [4026] = {.lex_state = 345, .external_lex_state = 2},
  [4027] = {.lex_state = 345, .external_lex_state = 2},
  [4028] = {.lex_state = 345, .external_lex_state = 2},
  [4029] = {.lex_state = 344, .external_lex_state = 23},
  [4030] = {.lex_state = 344, .external_lex_state = 23},
  [4031] = {.lex_state = 344, .external_lex_state = 23},
  [4032] = {.lex_state = 345, .external_lex_state = 10},
  [4033] = {.lex_state = 346, .external_lex_state = 2},
  [4034] = {.lex_state = 345, .external_lex_state = 10},
  [4035] = {.lex_state = 345, .external_lex_state = 10},
  [4036] = {.lex_state = 346, .external_lex_state = 2},
  [4037] = {.lex_state = 346, .external_lex_state = 2},
  [4038] = {.lex_state = 345, .external_lex_state = 10},
  [4039] = {.lex_state = 345, .external_lex_state = 10},
  [4040] = {.lex_state = 345, .external_lex_state = 10},
  [4041] = {.lex_state = 345, .external_lex_state = 10},
  [4042] = {.lex_state = 346, .external_lex_state = 2},
  [4043] = {.lex_state = 346, .external_lex_state = 2},
  [4044] = {.lex_state = 346, .external_lex_state = 2},
  [4045] = {.lex_state = 346, .external_lex_state = 2},
  [4046] = {.lex_state = 173},
  [4047] = {.lex_state = 173},
  [4048] = {.lex_state = 346, .external_lex_state = 2},
  [4049] = {.lex_state = 344, .external_lex_state = 23},
  [4050] = {.lex_state = 344, .external_lex_state = 23},
  [4051] = {.lex_state = 173},
  [4052] = {.lex_state = 173},
  [4053] = {.lex_state = 173},
  [4054] = {.lex_state = 173},
  [4055] = {.lex_state = 173},
  [4056] = {.lex_state = 173},
  [4057] = {.lex_state = 173},
  [4058] = {.lex_state = 173},
  [4059] = {.lex_state = 173},
  [4060] = {.lex_state = 173},
  [4061] = {.lex_state = 344, .external_lex_state = 23},
  [4062] = {.lex_state = 173},
  [4063] = {.lex_state = 344, .external_lex_state = 23},
  [4064] = {.lex_state = 345, .external_lex_state = 10},
  [4065] = {.lex_state = 173},
  [4066] = {.lex_state = 173},
  [4067] = {.lex_state = 173},
  [4068] = {.lex_state = 173},
  [4069] = {.lex_state = 345, .external_lex_state = 10},
  [4070] = {.lex_state = 173},
  [4071] = {.lex_state = 344, .external_lex_state = 23},
  [4072] = {.lex_state = 173},
  [4073] = {.lex_state = 344, .external_lex_state = 23},
  [4074] = {.lex_state = 344, .external_lex_state = 23},
  [4075] = {.lex_state = 345, .external_lex_state = 10},
  [4076] = {.lex_state = 173},
  [4077] = {.lex_state = 173},
  [4078] = {.lex_state = 173},
  [4079] = {.lex_state = 173},
  [4080] = {.lex_state = 344, .external_lex_state = 23},
  [4081] = {.lex_state = 344, .external_lex_state = 23},
  [4082] = {.lex_state = 173},
  [4083] = {.lex_state = 173},
  [4084] = {.lex_state = 173},
  [4085] = {.lex_state = 173},
  [4086] = {.lex_state = 173},
  [4087] = {.lex_state = 173},
  [4088] = {.lex_state = 173},
  [4089] = {.lex_state = 173},
  [4090] = {.lex_state = 145},
  [4091] = {.lex_state = 344, .external_lex_state = 23},
  [4092] = {.lex_state = 344, .external_lex_state = 23},
  [4093] = {.lex_state = 173},
  [4094] = {.lex_state = 345, .external_lex_state = 10},
  [4095] = {.lex_state = 344, .external_lex_state = 23},
  [4096] = {.lex_state = 345, .external_lex_state = 11},
  [4097] = {.lex_state = 344, .external_lex_state = 23},
  [4098] = {.lex_state = 173},
  [4099] = {.lex_state = 344, .external_lex_state = 23},
  [4100] = {.lex_state = 345, .external_lex_state = 10},
  [4101] = {.lex_state = 173},
  [4102] = {.lex_state = 173},
  [4103] = {.lex_state = 145},
  [4104] = {.lex_state = 173},
  [4105] = {.lex_state = 173},
  [4106] = {.lex_state = 173},
  [4107] = {.lex_state = 173},
  [4108] = {.lex_state = 173},
  [4109] = {.lex_state = 173},
  [4110] = {.lex_state = 173},
  [4111] = {.lex_state = 344, .external_lex_state = 23},
  [4112] = {.lex_state = 345, .external_lex_state = 11},
  [4113] = {.lex_state = 344, .external_lex_state = 23},
  [4114] = {.lex_state = 344, .external_lex_state = 23},
  [4115] = {.lex_state = 173},
  [4116] = {.lex_state = 173},
  [4117] = {.lex_state = 173},
  [4118] = {.lex_state = 173},
  [4119] = {.lex_state = 173},
  [4120] = {.lex_state = 173},
  [4121] = {.lex_state = 345, .external_lex_state = 11},
  [4122] = {.lex_state = 344, .external_lex_state = 23},
  [4123] = {.lex_state = 345, .external_lex_state = 11},
  [4124] = {.lex_state = 344, .external_lex_state = 23},
  [4125] = {.lex_state = 345, .external_lex_state = 11},
  [4126] = {.lex_state = 173},
  [4127] = {.lex_state = 173},
  [4128] = {.lex_state = 345, .external_lex_state = 11},
  [4129] = {.lex_state = 173},
  [4130] = {.lex_state = 173},
  [4131] = {.lex_state = 173},
  [4132] = {.lex_state = 345, .external_lex_state = 11},
  [4133] = {.lex_state = 173},
  [4134] = {.lex_state = 173},
  [4135] = {.lex_state = 344, .external_lex_state = 23},
  [4136] = {.lex_state = 173},
  [4137] = {.lex_state = 173},
  [4138] = {.lex_state = 344, .external_lex_state = 23},
  [4139] = {.lex_state = 173},
  [4140] = {.lex_state = 344, .external_lex_state = 2},
  [4141] = {.lex_state = 180, .external_lex_state = 2},
  [4142] = {.lex_state = 344, .external_lex_state = 2},
  [4143] = {.lex_state = 173},
  [4144] = {.lex_state = 344, .external_lex_state = 2},
  [4145] = {.lex_state = 345, .external_lex_state = 11},
  [4146] = {.lex_state = 344, .external_lex_state = 2},
  [4147] = {.lex_state = 180, .external_lex_state = 2},
  [4148] = {.lex_state = 345, .external_lex_state = 11},
  [4149] = {.lex_state = 344, .external_lex_state = 2},
  [4150] = {.lex_state = 344, .external_lex_state = 2},
  [4151] = {.lex_state = 344, .external_lex_state = 2},
  [4152] = {.lex_state = 173},
  [4153] = {.lex_state = 344, .external_lex_state = 2},
  [4154] = {.lex_state = 344, .external_lex_state = 2},
  [4155] = {.lex_state = 344, .external_lex_state = 2},
  [4156] = {.lex_state = 345, .external_lex_state = 11},
  [4157] = {.lex_state = 345, .external_lex_state = 10},
  [4158] = {.lex_state = 180, .external_lex_state = 2},
  [4159] = {.lex_state = 345, .external_lex_state = 10},
  [4160] = {.lex_state = 344, .external_lex_state = 2},
  [4161] = {.lex_state = 180, .external_lex_state = 2},
  [4162] = {.lex_state = 345, .external_lex_state = 10},
  [4163] = {.lex_state = 344, .external_lex_state = 2},
  [4164] = {.lex_state = 344, .external_lex_state = 2},
  [4165] = {.lex_state = 173},
  [4166] = {.lex_state = 344, .external_lex_state = 2},
  [4167] = {.lex_state = 344, .external_lex_state = 2},
  [4168] = {.lex_state = 344, .external_lex_state = 2},
  [4169] = {.lex_state = 345, .external_lex_state = 11},
  [4170] = {.lex_state = 345, .external_lex_state = 11},
  [4171] = {.lex_state = 173},
  [4172] = {.lex_state = 345, .external_lex_state = 10},
  [4173] = {.lex_state = 344, .external_lex_state = 2},
  [4174] = {.lex_state = 173},
  [4175] = {.lex_state = 345, .external_lex_state = 10},
  [4176] = {.lex_state = 344, .external_lex_state = 2},
  [4177] = {.lex_state = 173},
  [4178] = {.lex_state = 173},
  [4179] = {.lex_state = 344, .external_lex_state = 2},
  [4180] = {.lex_state = 173},
  [4181] = {.lex_state = 345, .external_lex_state = 11},
  [4182] = {.lex_state = 345, .external_lex_state = 11},
  [4183] = {.lex_state = 345, .external_lex_state = 10},
  [4184] = {.lex_state = 345, .external_lex_state = 10},
  [4185] = {.lex_state = 345, .external_lex_state = 11},
  [4186] = {.lex_state = 345, .external_lex_state = 10},
  [4187] = {.lex_state = 345, .external_lex_state = 10},
  [4188] = {.lex_state = 345, .external_lex_state = 10},
  [4189] = {.lex_state = 345, .external_lex_state = 10},
  [4190] = {.lex_state = 345, .external_lex_state = 10},
  [4191] = {.lex_state = 345, .external_lex_state = 11},
  [4192] = {.lex_state = 345, .external_lex_state = 10},
  [4193] = {.lex_state = 345, .external_lex_state = 10},
  [4194] = {.lex_state = 345, .external_lex_state = 11},
  [4195] = {.lex_state = 345, .external_lex_state = 10},
  [4196] = {.lex_state = 345, .external_lex_state = 10},
  [4197] = {.lex_state = 345, .external_lex_state = 10},
  [4198] = {.lex_state = 173},
  [4199] = {.lex_state = 140, .external_lex_state = 2},
  [4200] = {.lex_state = 345, .external_lex_state = 11},
  [4201] = {.lex_state = 345, .external_lex_state = 11},
  [4202] = {.lex_state = 345, .external_lex_state = 11},
  [4203] = {.lex_state = 345, .external_lex_state = 11},
  [4204] = {.lex_state = 345, .external_lex_state = 11},
  [4205] = {.lex_state = 345, .external_lex_state = 11},
  [4206] = {.lex_state = 345, .external_lex_state = 11},
  [4207] = {.lex_state = 345, .external_lex_state = 11},
  [4208] = {.lex_state = 345, .external_lex_state = 11},
  [4209] = {.lex_state = 345, .external_lex_state = 11},
  [4210] = {.lex_state = 345, .external_lex_state = 11},
  [4211] = {.lex_state = 345, .external_lex_state = 11},
  [4212] = {.lex_state = 141, .external_lex_state = 2},
  [4213] = {.lex_state = 344, .external_lex_state = 6},
  [4214] = {.lex_state = 344, .external_lex_state = 6},
  [4215] = {.lex_state = 141, .external_lex_state = 2},
  [4216] = {.lex_state = 344, .external_lex_state = 26},
  [4217] = {.lex_state = 344, .external_lex_state = 26},
  [4218] = {.lex_state = 344, .external_lex_state = 26},
  [4219] = {.lex_state = 141, .external_lex_state = 2},
  [4220] = {.lex_state = 141, .external_lex_state = 2},
  [4221] = {.lex_state = 344, .external_lex_state = 6},
  [4222] = {.lex_state = 344, .external_lex_state = 6},
  [4223] = {.lex_state = 344, .external_lex_state = 6},
  [4224] = {.lex_state = 344, .external_lex_state = 6},
  [4225] = {.lex_state = 344, .external_lex_state = 26},
  [4226] = {.lex_state = 344, .external_lex_state = 26},
  [4227] = {.lex_state = 344, .external_lex_state = 6},
  [4228] = {.lex_state = 344, .external_lex_state = 27},
  [4229] = {.lex_state = 344, .external_lex_state = 27},
  [4230] = {.lex_state = 344, .external_lex_state = 26},
  [4231] = {.lex_state = 344, .external_lex_state = 27},
  [4232] = {.lex_state = 344, .external_lex_state = 26},
  [4233] = {.lex_state = 344, .external_lex_state = 23},
  [4234] = {.lex_state = 344, .external_lex_state = 2},
  [4235] = {.lex_state = 344, .external_lex_state = 2},
  [4236] = {.lex_state = 344, .external_lex_state = 2},
  [4237] = {.lex_state = 344, .external_lex_state = 23},
  [4238] = {.lex_state = 344, .external_lex_state = 2},
  [4239] = {.lex_state = 344, .external_lex_state = 9},
  [4240] = {.lex_state = 344, .external_lex_state = 23},
  [4241] = {.lex_state = 344, .external_lex_state = 12},
  [4242] = {.lex_state = 344, .external_lex_state = 2},
  [4243] = {.lex_state = 344, .external_lex_state = 12},
  [4244] = {.lex_state = 344, .external_lex_state = 2},
  [4245] = {.lex_state = 344, .external_lex_state = 2},
  [4246] = {.lex_state = 344, .external_lex_state = 2},
  [4247] = {.lex_state = 344, .external_lex_state = 2},
  [4248] = {.lex_state = 344, .external_lex_state = 2},
  [4249] = {.lex_state = 344, .external_lex_state = 2},
  [4250] = {.lex_state = 344, .external_lex_state = 2},
  [4251] = {.lex_state = 344, .external_lex_state = 2},
  [4252] = {.lex_state = 344, .external_lex_state = 2},
  [4253] = {.lex_state = 344, .external_lex_state = 2},
  [4254] = {.lex_state = 344, .external_lex_state = 2},
  [4255] = {.lex_state = 344, .external_lex_state = 2},
  [4256] = {.lex_state = 344, .external_lex_state = 2},
  [4257] = {.lex_state = 344, .external_lex_state = 2},
  [4258] = {.lex_state = 344, .external_lex_state = 2},
  [4259] = {.lex_state = 344, .external_lex_state = 12},
  [4260] = {.lex_state = 344, .external_lex_state = 2},
  [4261] = {.lex_state = 344, .external_lex_state = 9},
  [4262] = {.lex_state = 344, .external_lex_state = 2},
  [4263] = {.lex_state = 344, .external_lex_state = 2},
  [4264] = {.lex_state = 344, .external_lex_state = 27},
  [4265] = {.lex_state = 344, .external_lex_state = 2},
  [4266] = {.lex_state = 344, .external_lex_state = 2},
  [4267] = {.lex_state = 344, .external_lex_state = 27},
  [4268] = {.lex_state = 344, .external_lex_state = 9},
  [4269] = {.lex_state = 344, .external_lex_state = 2},
  [4270] = {.lex_state = 344, .external_lex_state = 27},
  [4271] = {.lex_state = 344, .external_lex_state = 9},
  [4272] = {.lex_state = 344, .external_lex_state = 2},
  [4273] = {.lex_state = 344, .external_lex_state = 12},
  [4274] = {.lex_state = 344, .external_lex_state = 2},
  [4275] = {.lex_state = 344, .external_lex_state = 9},
  [4276] = {.lex_state = 344, .external_lex_state = 27},
  [4277] = {.lex_state = 344, .external_lex_state = 2},
  [4278] = {.lex_state = 344, .external_lex_state = 12},
  [4279] = {.lex_state = 344, .external_lex_state = 2},
  [4280] = {.lex_state = 344, .external_lex_state = 2},
  [4281] = {.lex_state = 344, .external_lex_state = 23},
  [4282] = {.lex_state = 344, .external_lex_state = 14},
  [4283] = {.lex_state = 344, .external_lex_state = 14},
  [4284] = {.lex_state = 344, .external_lex_state = 14},
  [4285] = {.lex_state = 344, .external_lex_state = 23},
  [4286] = {.lex_state = 344, .external_lex_state = 23},
  [4287] = {.lex_state = 344, .external_lex_state = 2},
  [4288] = {.lex_state = 344, .external_lex_state = 14},
  [4289] = {.lex_state = 344, .external_lex_state = 14},
  [4290] = {.lex_state = 344, .external_lex_state = 23},
  [4291] = {.lex_state = 344, .external_lex_state = 2},
  [4292] = {.lex_state = 344, .external_lex_state = 2},
  [4293] = {.lex_state = 344, .external_lex_state = 2},
  [4294] = {.lex_state = 344, .external_lex_state = 2},
  [4295] = {.lex_state = 344, .external_lex_state = 2},
  [4296] = {.lex_state = 344, .external_lex_state = 2},
  [4297] = {.lex_state = 344, .external_lex_state = 2},
  [4298] = {.lex_state = 344, .external_lex_state = 2},
  [4299] = {.lex_state = 344, .external_lex_state = 2},
  [4300] = {.lex_state = 344, .external_lex_state = 2},
  [4301] = {.lex_state = 347},
  [4302] = {.lex_state = 347},
  [4303] = {.lex_state = 347},
  [4304] = {.lex_state = 347},
  [4305] = {.lex_state = 347},
  [4306] = {.lex_state = 347},
  [4307] = {.lex_state = 347},
  [4308] = {.lex_state = 347},
  [4309] = {.lex_state = 347},
  [4310] = {.lex_state = 347},
  [4311] = {.lex_state = 347},
  [4312] = {.lex_state = 347},
  [4313] = {.lex_state = 347},
  [4314] = {.lex_state = 347},
  [4315] = {.lex_state = 347},
  [4316] = {.lex_state = 347},
  [4317] = {.lex_state = 347},
  [4318] = {.lex_state = 347},
  [4319] = {.lex_state = 347},
  [4320] = {.lex_state = 347},
  [4321] = {.lex_state = 347},
  [4322] = {.lex_state = 347},
  [4323] = {.lex_state = 347},
  [4324] = {.lex_state = 347},
  [4325] = {.lex_state = 146, .external_lex_state = 24},
  [4326] = {.lex_state = 146},
  [4327] = {.lex_state = 154},
  [4328] = {.lex_state = 146, .external_lex_state = 25},
  [4329] = {.lex_state = 160},
  [4330] = {.lex_state = 147},
  [4331] = {.lex_state = 147, .external_lex_state = 24},
  [4332] = {.lex_state = 147, .external_lex_state = 25},
  [4333] = {.lex_state = 155},
  [4334] = {.lex_state = 161},
  [4335] = {.lex_state = 143, .external_lex_state = 24},
  [4336] = {.lex_state = 143, .external_lex_state = 24},
  [4337] = {.lex_state = 143, .external_lex_state = 24},
  [4338] = {.lex_state = 144, .external_lex_state = 28},
  [4339] = {.lex_state = 144, .external_lex_state = 28},
  [4340] = {.lex_state = 143, .external_lex_state = 24},
  [4341] = {.lex_state = 143},
  [4342] = {.lex_state = 144, .external_lex_state = 28},
  [4343] = {.lex_state = 143, .external_lex_state = 24},
  [4344] = {.lex_state = 144, .external_lex_state = 28},
  [4345] = {.lex_state = 144, .external_lex_state = 28},
  [4346] = {.lex_state = 143, .external_lex_state = 24},
  [4347] = {.lex_state = 143, .external_lex_state = 25},
  [4348] = {.lex_state = 143, .external_lex_state = 24},
  [4349] = {.lex_state = 144, .external_lex_state = 28},
  [4350] = {.lex_state = 144, .external_lex_state = 28},
  [4351] = {.lex_state = 143, .external_lex_state = 24},
  [4352] = {.lex_state = 144, .external_lex_state = 28},
  [4353] = {.lex_state = 144, .external_lex_state = 28},
  [4354] = {.lex_state = 144, .external_lex_state = 24},
  [4355] = {.lex_state = 143, .external_lex_state = 25},
  [4356] = {.lex_state = 144, .external_lex_state = 29},
  [4357] = {.lex_state = 144, .external_lex_state = 30},
  [4358] = {.lex_state = 144, .external_lex_state = 24},
  [4359] = {.lex_state = 144, .external_lex_state = 30},
  [4360] = {.lex_state = 144, .external_lex_state = 29},
  [4361] = {.lex_state = 144, .external_lex_state = 30},
  [4362] = {.lex_state = 144, .external_lex_state = 29},
  [4363] = {.lex_state = 143},
  [4364] = {.lex_state = 144, .external_lex_state = 24},
  [4365] = {.lex_state = 144, .external_lex_state = 24},
  [4366] = {.lex_state = 144, .external_lex_state = 30},
  [4367] = {.lex_state = 143},
  [4368] = {.lex_state = 144, .external_lex_state = 24},
  [4369] = {.lex_state = 143},
  [4370] = {.lex_state = 144, .external_lex_state = 28},
  [4371] = {.lex_state = 144, .external_lex_state = 29},
  [4372] = {.lex_state = 144, .external_lex_state = 29},
  [4373] = {.lex_state = 143},
  [4374] = {.lex_state = 143, .external_lex_state = 24},
  [4375] = {.lex_state = 143, .external_lex_state = 25},
  [4376] = {.lex_state = 143},
  [4377] = {.lex_state = 144, .external_lex_state = 28},
  [4378] = {.lex_state = 143, .external_lex_state = 25},
  [4379] = {.lex_state = 144, .external_lex_state = 30},
  [4380] = {.lex_state = 143},
  [4381] = {.lex_state = 144, .external_lex_state = 29},
  [4382] = {.lex_state = 143},
  [4383] = {.lex_state = 144, .external_lex_state = 30},
  [4384] = {.lex_state = 144, .external_lex_state = 29},
  [4385] = {.lex_state = 143, .external_lex_state = 24},
  [4386] = {.lex_state = 143, .external_lex_state = 24},
  [4387] = {.lex_state = 144, .external_lex_state = 30},
  [4388] = {.lex_state = 143, .external_lex_state = 25},
  [4389] = {.lex_state = 144, .external_lex_state = 30},
  [4390] = {.lex_state = 144, .external_lex_state = 24},
  [4391] = {.lex_state = 144, .external_lex_state = 30},
  [4392] = {.lex_state = 144, .external_lex_state = 28},
  [4393] = {.lex_state = 143, .external_lex_state = 25},
  [4394] = {.lex_state = 144, .external_lex_state = 24},
  [4395] = {.lex_state = 144, .external_lex_state = 29},
  [4396] = {.lex_state = 143, .external_lex_state = 24},
  [4397] = {.lex_state = 144, .external_lex_state = 28},
  [4398] = {.lex_state = 144, .external_lex_state = 28},
  [4399] = {.lex_state = 144, .external_lex_state = 29},
  [4400] = {.lex_state = 144, .external_lex_state = 24},
  [4401] = {.lex_state = 143, .external_lex_state = 25},
  [4402] = {.lex_state = 143},
  [4403] = {.lex_state = 143, .external_lex_state = 24},
  [4404] = {.lex_state = 143, .external_lex_state = 25},
  [4405] = {.lex_state = 151},
  [4406] = {.lex_state = 144, .external_lex_state = 24},
  [4407] = {.lex_state = 144, .external_lex_state = 28},
  [4408] = {.lex_state = 144, .external_lex_state = 25},
  [4409] = {.lex_state = 144, .external_lex_state = 30},
  [4410] = {.lex_state = 143, .external_lex_state = 24},
  [4411] = {.lex_state = 151},
  [4412] = {.lex_state = 144, .external_lex_state = 25},
  [4413] = {.lex_state = 152, .external_lex_state = 30},
  [4414] = {.lex_state = 144, .external_lex_state = 25},
  [4415] = {.lex_state = 143, .external_lex_state = 25},
  [4416] = {.lex_state = 152, .external_lex_state = 30},
  [4417] = {.lex_state = 143, .external_lex_state = 30},
  [4418] = {.lex_state = 152, .external_lex_state = 30},
  [4419] = {.lex_state = 143},
  [4420] = {.lex_state = 143, .external_lex_state = 24},
  [4421] = {.lex_state = 152, .external_lex_state = 30},
  [4422] = {.lex_state = 151},
  [4423] = {.lex_state = 143},
  [4424] = {.lex_state = 152, .external_lex_state = 30},
  [4425] = {.lex_state = 143, .external_lex_state = 24},
  [4426] = {.lex_state = 143, .external_lex_state = 25},
  [4427] = {.lex_state = 143, .external_lex_state = 30},
  [4428] = {.lex_state = 144, .external_lex_state = 28},
  [4429] = {.lex_state = 143, .external_lex_state = 25},
  [4430] = {.lex_state = 144, .external_lex_state = 25},
  [4431] = {.lex_state = 152, .external_lex_state = 30},
  [4432] = {.lex_state = 144, .external_lex_state = 28},
  [4433] = {.lex_state = 143, .external_lex_state = 30},
  [4434] = {.lex_state = 143},
  [4435] = {.lex_state = 144, .external_lex_state = 25},
  [4436] = {.lex_state = 151},
  [4437] = {.lex_state = 144, .external_lex_state = 24},
  [4438] = {.lex_state = 144, .external_lex_state = 29},
  [4439] = {.lex_state = 144, .external_lex_state = 30},
  [4440] = {.lex_state = 143, .external_lex_state = 24},
  [4441] = {.lex_state = 144},
  [4442] = {.lex_state = 144, .external_lex_state = 25},
  [4443] = {.lex_state = 144, .external_lex_state = 25},
  [4444] = {.lex_state = 144, .external_lex_state = 24},
  [4445] = {.lex_state = 144, .external_lex_state = 30},
  [4446] = {.lex_state = 143},
  [4447] = {.lex_state = 144},
  [4448] = {.lex_state = 144},
  [4449] = {.lex_state = 144, .external_lex_state = 30},
  [4450] = {.lex_state = 144},
  [4451] = {.lex_state = 144, .external_lex_state = 29},
  [4452] = {.lex_state = 143, .external_lex_state = 25},
  [4453] = {.lex_state = 144},
  [4454] = {.lex_state = 144, .external_lex_state = 29},
  [4455] = {.lex_state = 143, .external_lex_state = 24},
  [4456] = {.lex_state = 151},
  [4457] = {.lex_state = 143, .external_lex_state = 30},
  [4458] = {.lex_state = 143, .external_lex_state = 25},
  [4459] = {.lex_state = 152, .external_lex_state = 30},
  [4460] = {.lex_state = 144, .external_lex_state = 24},
  [4461] = {.lex_state = 143, .external_lex_state = 30},
  [4462] = {.lex_state = 151},
  [4463] = {.lex_state = 144, .external_lex_state = 29},
  [4464] = {.lex_state = 151},
  [4465] = {.lex_state = 144, .external_lex_state = 30},
  [4466] = {.lex_state = 144, .external_lex_state = 24},
  [4467] = {.lex_state = 143, .external_lex_state = 30},
  [4468] = {.lex_state = 143},
  [4469] = {.lex_state = 144, .external_lex_state = 30},
  [4470] = {.lex_state = 144, .external_lex_state = 28},
  [4471] = {.lex_state = 152, .external_lex_state = 30},
  [4472] = {.lex_state = 143},
  [4473] = {.lex_state = 143, .external_lex_state = 30},
  [4474] = {.lex_state = 143, .external_lex_state = 30},
  [4475] = {.lex_state = 152, .external_lex_state = 30},
  [4476] = {.lex_state = 144},
  [4477] = {.lex_state = 144, .external_lex_state = 25},
  [4478] = {.lex_state = 144, .external_lex_state = 28},
  [4479] = {.lex_state = 151},
  [4480] = {.lex_state = 144, .external_lex_state = 29},
  [4481] = {.lex_state = 143, .external_lex_state = 30},
  [4482] = {.lex_state = 144},
  [4483] = {.lex_state = 144, .external_lex_state = 30},
  [4484] = {.lex_state = 144},
  [4485] = {.lex_state = 143, .external_lex_state = 24},
  [4486] = {.lex_state = 144, .external_lex_state = 30},
  [4487] = {.lex_state = 144, .external_lex_state = 28},
  [4488] = {.lex_state = 144, .external_lex_state = 29},
  [4489] = {.lex_state = 144, .external_lex_state = 29},
  [4490] = {.lex_state = 133, .external_lex_state = 4},
  [4491] = {.lex_state = 144, .external_lex_state = 24},
  [4492] = {.lex_state = 144, .external_lex_state = 28},
  [4493] = {.lex_state = 133, .external_lex_state = 4},
  [4494] = {.lex_state = 144, .external_lex_state = 28},
  [4495] = {.lex_state = 144, .external_lex_state = 25},
  [4496] = {.lex_state = 144, .external_lex_state = 30},
  [4497] = {.lex_state = 144, .external_lex_state = 28},
  [4498] = {.lex_state = 144, .external_lex_state = 28},
  [4499] = {.lex_state = 143, .external_lex_state = 30},
  [4500] = {.lex_state = 133, .external_lex_state = 4},
  [4501] = {.lex_state = 152},
  [4502] = {.lex_state = 144, .external_lex_state = 28},
  [4503] = {.lex_state = 143, .external_lex_state = 25},
  [4504] = {.lex_state = 143, .external_lex_state = 25},
  [4505] = {.lex_state = 144, .external_lex_state = 24},
  [4506] = {.lex_state = 144, .external_lex_state = 28},
  [4507] = {.lex_state = 133, .external_lex_state = 4},
  [4508] = {.lex_state = 133, .external_lex_state = 4},
  [4509] = {.lex_state = 143, .external_lex_state = 24},
  [4510] = {.lex_state = 143, .external_lex_state = 25},
  [4511] = {.lex_state = 143},
  [4512] = {.lex_state = 144, .external_lex_state = 29},
  [4513] = {.lex_state = 152},
  [4514] = {.lex_state = 144, .external_lex_state = 28},
  [4515] = {.lex_state = 144, .external_lex_state = 24},
  [4516] = {.lex_state = 144, .external_lex_state = 29},
  [4517] = {.lex_state = 133, .external_lex_state = 4},
  [4518] = {.lex_state = 152, .external_lex_state = 30},
  [4519] = {.lex_state = 144, .external_lex_state = 28},
  [4520] = {.lex_state = 143, .external_lex_state = 24},
  [4521] = {.lex_state = 143, .external_lex_state = 25},
  [4522] = {.lex_state = 133, .external_lex_state = 4},
  [4523] = {.lex_state = 152, .external_lex_state = 30},
  [4524] = {.lex_state = 133, .external_lex_state = 4},
  [4525] = {.lex_state = 144, .external_lex_state = 25},
  [4526] = {.lex_state = 152},
  [4527] = {.lex_state = 133, .external_lex_state = 4},
  [4528] = {.lex_state = 144, .external_lex_state = 30},
  [4529] = {.lex_state = 133, .external_lex_state = 4},
  [4530] = {.lex_state = 143, .external_lex_state = 24},
  [4531] = {.lex_state = 143},
  [4532] = {.lex_state = 152, .external_lex_state = 30},
  [4533] = {.lex_state = 133, .external_lex_state = 4},
  [4534] = {.lex_state = 144, .external_lex_state = 29},
  [4535] = {.lex_state = 144, .external_lex_state = 30},
  [4536] = {.lex_state = 143, .external_lex_state = 24},
  [4537] = {.lex_state = 143, .external_lex_state = 30},
  [4538] = {.lex_state = 143},
  [4539] = {.lex_state = 152},
  [4540] = {.lex_state = 143, .external_lex_state = 25},
  [4541] = {.lex_state = 133, .external_lex_state = 4},
  [4542] = {.lex_state = 152},
  [4543] = {.lex_state = 152},
  [4544] = {.lex_state = 144, .external_lex_state = 30},
  [4545] = {.lex_state = 133, .external_lex_state = 4},
  [4546] = {.lex_state = 144, .external_lex_state = 25},
  [4547] = {.lex_state = 144, .external_lex_state = 28},
  [4548] = {.lex_state = 133, .external_lex_state = 4},
  [4549] = {.lex_state = 143, .external_lex_state = 24},
  [4550] = {.lex_state = 144, .external_lex_state = 28},
  [4551] = {.lex_state = 144, .external_lex_state = 28},
  [4552] = {.lex_state = 144, .external_lex_state = 24},
  [4553] = {.lex_state = 152},
  [4554] = {.lex_state = 151},
  [4555] = {.lex_state = 144, .external_lex_state = 24},
  [4556] = {.lex_state = 143, .external_lex_state = 24},
  [4557] = {.lex_state = 144},
  [4558] = {.lex_state = 143},
  [4559] = {.lex_state = 144},
  [4560] = {.lex_state = 144},
  [4561] = {.lex_state = 143, .external_lex_state = 24},
  [4562] = {.lex_state = 151},
  [4563] = {.lex_state = 152, .external_lex_state = 30},
  [4564] = {.lex_state = 151},
  [4565] = {.lex_state = 152},
  [4566] = {.lex_state = 143, .external_lex_state = 24},
  [4567] = {.lex_state = 133, .external_lex_state = 4},
  [4568] = {.lex_state = 143, .external_lex_state = 24},
  [4569] = {.lex_state = 143, .external_lex_state = 24},
  [4570] = {.lex_state = 143},
  [4571] = {.lex_state = 144},
  [4572] = {.lex_state = 347},
  [4573] = {.lex_state = 144, .external_lex_state = 25},
  [4574] = {.lex_state = 143, .external_lex_state = 30},
  [4575] = {.lex_state = 133, .external_lex_state = 4},
  [4576] = {.lex_state = 143},
  [4577] = {.lex_state = 143, .external_lex_state = 30},
  [4578] = {.lex_state = 143, .external_lex_state = 30},
  [4579] = {.lex_state = 144, .external_lex_state = 25},
  [4580] = {.lex_state = 151},
  [4581] = {.lex_state = 143, .external_lex_state = 24},
  [4582] = {.lex_state = 152, .external_lex_state = 30},
  [4583] = {.lex_state = 151},
  [4584] = {.lex_state = 144},
  [4585] = {.lex_state = 144, .external_lex_state = 30},
  [4586] = {.lex_state = 151},
  [4587] = {.lex_state = 144, .external_lex_state = 25},
  [4588] = {.lex_state = 152, .external_lex_state = 30},
  [4589] = {.lex_state = 152},
  [4590] = {.lex_state = 143},
  [4591] = {.lex_state = 143},
  [4592] = {.lex_state = 152},
  [4593] = {.lex_state = 144, .external_lex_state = 24},
  [4594] = {.lex_state = 152},
  [4595] = {.lex_state = 143, .external_lex_state = 25},
  [4596] = {.lex_state = 152, .external_lex_state = 30},
  [4597] = {.lex_state = 143, .external_lex_state = 30},
  [4598] = {.lex_state = 143, .external_lex_state = 25},
  [4599] = {.lex_state = 143, .external_lex_state = 25},
  [4600] = {.lex_state = 151},
  [4601] = {.lex_state = 144},
  [4602] = {.lex_state = 143, .external_lex_state = 30},
  [4603] = {.lex_state = 143, .external_lex_state = 30},
  [4604] = {.lex_state = 152, .external_lex_state = 30},
  [4605] = {.lex_state = 152, .external_lex_state = 30},
  [4606] = {.lex_state = 143},
  [4607] = {.lex_state = 143, .external_lex_state = 30},
  [4608] = {.lex_state = 144},
  [4609] = {.lex_state = 144, .external_lex_state = 29},
  [4610] = {.lex_state = 144, .external_lex_state = 29},
  [4611] = {.lex_state = 144, .external_lex_state = 24},
  [4612] = {.lex_state = 144, .external_lex_state = 29},
  [4613] = {.lex_state = 144, .external_lex_state = 24},
  [4614] = {.lex_state = 143},
  [4615] = {.lex_state = 144},
  [4616] = {.lex_state = 143, .external_lex_state = 30},
  [4617] = {.lex_state = 143},
  [4618] = {.lex_state = 152},
  [4619] = {.lex_state = 143},
  [4620] = {.lex_state = 143},
  [4621] = {.lex_state = 144, .external_lex_state = 29},
  [4622] = {.lex_state = 144, .external_lex_state = 25},
  [4623] = {.lex_state = 144, .external_lex_state = 25},
  [4624] = {.lex_state = 152, .external_lex_state = 30},
  [4625] = {.lex_state = 144, .external_lex_state = 24},
  [4626] = {.lex_state = 144, .external_lex_state = 29},
  [4627] = {.lex_state = 143},
  [4628] = {.lex_state = 144, .external_lex_state = 24},
  [4629] = {.lex_state = 347},
  [4630] = {.lex_state = 144, .external_lex_state = 29},
  [4631] = {.lex_state = 144, .external_lex_state = 30},
  [4632] = {.lex_state = 144, .external_lex_state = 30},
  [4633] = {.lex_state = 144, .external_lex_state = 30},
  [4634] = {.lex_state = 143},
  [4635] = {.lex_state = 144, .external_lex_state = 30},
  [4636] = {.lex_state = 151},
  [4637] = {.lex_state = 143},
  [4638] = {.lex_state = 144, .external_lex_state = 24},
  [4639] = {.lex_state = 144, .external_lex_state = 29},
  [4640] = {.lex_state = 144, .external_lex_state = 24},
  [4641] = {.lex_state = 152},
  [4642] = {.lex_state = 151},
  [4643] = {.lex_state = 143, .external_lex_state = 25},
  [4644] = {.lex_state = 144, .external_lex_state = 30},
  [4645] = {.lex_state = 143, .external_lex_state = 25},
  [4646] = {.lex_state = 144, .external_lex_state = 24},
  [4647] = {.lex_state = 143, .external_lex_state = 25},
  [4648] = {.lex_state = 144, .external_lex_state = 24},
  [4649] = {.lex_state = 144, .external_lex_state = 30},
  [4650] = {.lex_state = 144},
  [4651] = {.lex_state = 144, .external_lex_state = 30},
  [4652] = {.lex_state = 143},
  [4653] = {.lex_state = 151},
  [4654] = {.lex_state = 144, .external_lex_state = 29},
  [4655] = {.lex_state = 143},
  [4656] = {.lex_state = 143, .external_lex_state = 25},
  [4657] = {.lex_state = 144, .external_lex_state = 25},
  [4658] = {.lex_state = 143, .external_lex_state = 25},
  [4659] = {.lex_state = 144},
  [4660] = {.lex_state = 143, .external_lex_state = 25},
  [4661] = {.lex_state = 143, .external_lex_state = 25},
  [4662] = {.lex_state = 144, .external_lex_state = 29},
  [4663] = {.lex_state = 143, .external_lex_state = 25},
  [4664] = {.lex_state = 144, .external_lex_state = 30},
  [4665] = {.lex_state = 144, .external_lex_state = 30},
  [4666] = {.lex_state = 144, .external_lex_state = 24},
  [4667] = {.lex_state = 144, .external_lex_state = 29},
  [4668] = {.lex_state = 144, .external_lex_state = 30},
  [4669] = {.lex_state = 144, .external_lex_state = 29},
  [4670] = {.lex_state = 133, .external_lex_state = 4},
  [4671] = {.lex_state = 144, .external_lex_state = 29},
  [4672] = {.lex_state = 144, .external_lex_state = 25},
  [4673] = {.lex_state = 143, .external_lex_state = 25},
  [4674] = {.lex_state = 144, .external_lex_state = 30},
  [4675] = {.lex_state = 144, .external_lex_state = 24},
  [4676] = {.lex_state = 144, .external_lex_state = 24},
  [4677] = {.lex_state = 145, .external_lex_state = 24},
  [4678] = {.lex_state = 144},
  [4679] = {.lex_state = 143, .external_lex_state = 30},
  [4680] = {.lex_state = 151},
  [4681] = {.lex_state = 151},
  [4682] = {.lex_state = 152, .external_lex_state = 30},
  [4683] = {.lex_state = 144, .external_lex_state = 25},
  [4684] = {.lex_state = 143, .external_lex_state = 30},
  [4685] = {.lex_state = 144},
  [4686] = {.lex_state = 144},
  [4687] = {.lex_state = 144},
  [4688] = {.lex_state = 144},
  [4689] = {.lex_state = 144, .external_lex_state = 25},
  [4690] = {.lex_state = 151},
  [4691] = {.lex_state = 151},
  [4692] = {.lex_state = 192},
  [4693] = {.lex_state = 148, .external_lex_state = 24},
  [4694] = {.lex_state = 143, .external_lex_state = 30},
  [4695] = {.lex_state = 192},
  [4696] = {.lex_state = 151},
  [4697] = {.lex_state = 144, .external_lex_state = 25},
  [4698] = {.lex_state = 192},
  [4699] = {.lex_state = 151},
  [4700] = {.lex_state = 192},
  [4701] = {.lex_state = 144, .external_lex_state = 25},
  [4702] = {.lex_state = 152},
  [4703] = {.lex_state = 144, .external_lex_state = 25},
  [4704] = {.lex_state = 144, .external_lex_state = 25},
  [4705] = {.lex_state = 144, .external_lex_state = 25},
  [4706] = {.lex_state = 144, .external_lex_state = 25},
  [4707] = {.lex_state = 133, .external_lex_state = 8},
  [4708] = {.lex_state = 144, .external_lex_state = 25},
  [4709] = {.lex_state = 143, .external_lex_state = 30},
  [4710] = {.lex_state = 144},
  [4711] = {.lex_state = 144},
  [4712] = {.lex_state = 144, .external_lex_state = 25},
  [4713] = {.lex_state = 144, .external_lex_state = 25},
  [4714] = {.lex_state = 152},
  [4715] = {.lex_state = 151},
  [4716] = {.lex_state = 133, .external_lex_state = 8},
  [4717] = {.lex_state = 145, .external_lex_state = 24},
  [4718] = {.lex_state = 144},
  [4719] = {.lex_state = 151},
  [4720] = {.lex_state = 151},
  [4721] = {.lex_state = 144, .external_lex_state = 25},
  [4722] = {.lex_state = 166},
  [4723] = {.lex_state = 152, .external_lex_state = 30},
  [4724] = {.lex_state = 152, .external_lex_state = 30},
  [4725] = {.lex_state = 192},
  [4726] = {.lex_state = 144},
  [4727] = {.lex_state = 152, .external_lex_state = 30},
  [4728] = {.lex_state = 152},
  [4729] = {.lex_state = 192},
  [4730] = {.lex_state = 152, .external_lex_state = 30},
  [4731] = {.lex_state = 192},
  [4732] = {.lex_state = 152, .external_lex_state = 30},
  [4733] = {.lex_state = 151},
  [4734] = {.lex_state = 144},
  [4735] = {.lex_state = 151},
  [4736] = {.lex_state = 151},
  [4737] = {.lex_state = 143, .external_lex_state = 30},
  [4738] = {.lex_state = 143, .external_lex_state = 30},
  [4739] = {.lex_state = 145, .external_lex_state = 24},
  [4740] = {.lex_state = 143, .external_lex_state = 30},
  [4741] = {.lex_state = 143, .external_lex_state = 30},
  [4742] = {.lex_state = 143, .external_lex_state = 30},
  [4743] = {.lex_state = 152, .external_lex_state = 30},
  [4744] = {.lex_state = 152},
  [4745] = {.lex_state = 152, .external_lex_state = 30},
  [4746] = {.lex_state = 152, .external_lex_state = 30},
  [4747] = {.lex_state = 133, .external_lex_state = 8},
  [4748] = {.lex_state = 144},
  [4749] = {.lex_state = 143, .external_lex_state = 30},
  [4750] = {.lex_state = 143, .external_lex_state = 30},
  [4751] = {.lex_state = 152, .external_lex_state = 30},
  [4752] = {.lex_state = 152},
  [4753] = {.lex_state = 143, .external_lex_state = 30},
  [4754] = {.lex_state = 148},
  [4755] = {.lex_state = 152, .external_lex_state = 30},
  [4756] = {.lex_state = 144},
  [4757] = {.lex_state = 152, .external_lex_state = 30},
  [4758] = {.lex_state = 133, .external_lex_state = 11},
  [4759] = {.lex_state = 145},
  [4760] = {.lex_state = 152},
  [4761] = {.lex_state = 145, .external_lex_state = 25},
  [4762] = {.lex_state = 145},
  [4763] = {.lex_state = 153},
  [4764] = {.lex_state = 145},
  [4765] = {.lex_state = 145, .external_lex_state = 25},
  [4766] = {.lex_state = 149, .external_lex_state = 24},
  [4767] = {.lex_state = 149, .external_lex_state = 24},
  [4768] = {.lex_state = 149},
  [4769] = {.lex_state = 145},
  [4770] = {.lex_state = 145},
  [4771] = {.lex_state = 145, .external_lex_state = 24},
  [4772] = {.lex_state = 145, .external_lex_state = 28},
  [4773] = {.lex_state = 152},
  [4774] = {.lex_state = 152},
  [4775] = {.lex_state = 149, .external_lex_state = 24},
  [4776] = {.lex_state = 145, .external_lex_state = 24},
  [4777] = {.lex_state = 145, .external_lex_state = 28},
  [4778] = {.lex_state = 149},
  [4779] = {.lex_state = 152},
  [4780] = {.lex_state = 145, .external_lex_state = 28},
  [4781] = {.lex_state = 149, .external_lex_state = 24},
  [4782] = {.lex_state = 153},
  [4783] = {.lex_state = 152},
  [4784] = {.lex_state = 152},
  [4785] = {.lex_state = 133, .external_lex_state = 11},
  [4786] = {.lex_state = 133, .external_lex_state = 11},
  [4787] = {.lex_state = 133, .external_lex_state = 11},
  [4788] = {.lex_state = 149},
  [4789] = {.lex_state = 152},
  [4790] = {.lex_state = 152},
  [4791] = {.lex_state = 145, .external_lex_state = 24},
  [4792] = {.lex_state = 145},
  [4793] = {.lex_state = 156},
  [4794] = {.lex_state = 145, .external_lex_state = 24},
  [4795] = {.lex_state = 148, .external_lex_state = 25},
  [4796] = {.lex_state = 133, .external_lex_state = 11},
  [4797] = {.lex_state = 145, .external_lex_state = 24},
  [4798] = {.lex_state = 145, .external_lex_state = 24},
  [4799] = {.lex_state = 133, .external_lex_state = 11},
  [4800] = {.lex_state = 133, .external_lex_state = 11},
  [4801] = {.lex_state = 149},
  [4802] = {.lex_state = 152},
  [4803] = {.lex_state = 152},
  [4804] = {.lex_state = 153},
  [4805] = {.lex_state = 152},
  [4806] = {.lex_state = 133, .external_lex_state = 11},
  [4807] = {.lex_state = 145, .external_lex_state = 25},
  [4808] = {.lex_state = 145},
  [4809] = {.lex_state = 152},
  [4810] = {.lex_state = 153, .external_lex_state = 30},
  [4811] = {.lex_state = 145, .external_lex_state = 30},
  [4812] = {.lex_state = 133, .external_lex_state = 2},
  [4813] = {.lex_state = 159},
  [4814] = {.lex_state = 157},
  [4815] = {.lex_state = 159},
  [4816] = {.lex_state = 159},
  [4817] = {.lex_state = 159},
  [4818] = {.lex_state = 145, .external_lex_state = 29},
  [4819] = {.lex_state = 145, .external_lex_state = 24},
  [4820] = {.lex_state = 153, .external_lex_state = 30},
  [4821] = {.lex_state = 149, .external_lex_state = 25},
  [4822] = {.lex_state = 192},
  [4823] = {.lex_state = 145},
  [4824] = {.lex_state = 145, .external_lex_state = 24},
  [4825] = {.lex_state = 145, .external_lex_state = 24},
  [4826] = {.lex_state = 145, .external_lex_state = 24},
  [4827] = {.lex_state = 145},
  [4828] = {.lex_state = 153},
  [4829] = {.lex_state = 145, .external_lex_state = 25},
  [4830] = {.lex_state = 192},
  [4831] = {.lex_state = 145, .external_lex_state = 25},
  [4832] = {.lex_state = 162},
  [4833] = {.lex_state = 145, .external_lex_state = 25},
  [4834] = {.lex_state = 145},
  [4835] = {.lex_state = 153},
  [4836] = {.lex_state = 192},
  [4837] = {.lex_state = 145, .external_lex_state = 30},
  [4838] = {.lex_state = 145, .external_lex_state = 30},
  [4839] = {.lex_state = 167},
  [4840] = {.lex_state = 192},
  [4841] = {.lex_state = 145},
  [4842] = {.lex_state = 192},
  [4843] = {.lex_state = 133, .external_lex_state = 2},
  [4844] = {.lex_state = 145, .external_lex_state = 28},
  [4845] = {.lex_state = 157},
  [4846] = {.lex_state = 159},
  [4847] = {.lex_state = 145, .external_lex_state = 28},
  [4848] = {.lex_state = 192},
  [4849] = {.lex_state = 149, .external_lex_state = 25},
  [4850] = {.lex_state = 145, .external_lex_state = 30},
  [4851] = {.lex_state = 145, .external_lex_state = 24},
  [4852] = {.lex_state = 145, .external_lex_state = 30},
  [4853] = {.lex_state = 159},
  [4854] = {.lex_state = 145, .external_lex_state = 30},
  [4855] = {.lex_state = 159},
  [4856] = {.lex_state = 159},
  [4857] = {.lex_state = 192},
  [4858] = {.lex_state = 133, .external_lex_state = 2},
  [4859] = {.lex_state = 145, .external_lex_state = 28},
  [4860] = {.lex_state = 145, .external_lex_state = 30},
  [4861] = {.lex_state = 157},
  [4862] = {.lex_state = 159},
  [4863] = {.lex_state = 159},
  [4864] = {.lex_state = 145, .external_lex_state = 28},
  [4865] = {.lex_state = 159},
  [4866] = {.lex_state = 145, .external_lex_state = 25},
  [4867] = {.lex_state = 145, .external_lex_state = 29},
  [4868] = {.lex_state = 133, .external_lex_state = 2},
  [4869] = {.lex_state = 192},
  [4870] = {.lex_state = 145, .external_lex_state = 28},
  [4871] = {.lex_state = 159},
  [4872] = {.lex_state = 192},
  [4873] = {.lex_state = 153},
  [4874] = {.lex_state = 159},
  [4875] = {.lex_state = 145, .external_lex_state = 30},
  [4876] = {.lex_state = 192},
  [4877] = {.lex_state = 192},
  [4878] = {.lex_state = 192},
  [4879] = {.lex_state = 157},
  [4880] = {.lex_state = 149, .external_lex_state = 25},
  [4881] = {.lex_state = 145, .external_lex_state = 28},
  [4882] = {.lex_state = 153},
  [4883] = {.lex_state = 192},
  [4884] = {.lex_state = 145, .external_lex_state = 30},
  [4885] = {.lex_state = 145, .external_lex_state = 28},
  [4886] = {.lex_state = 145, .external_lex_state = 30},
  [4887] = {.lex_state = 145},
  [4888] = {.lex_state = 145, .external_lex_state = 30},
  [4889] = {.lex_state = 145},
  [4890] = {.lex_state = 145, .external_lex_state = 24},
  [4891] = {.lex_state = 159},
  [4892] = {.lex_state = 145},
  [4893] = {.lex_state = 192},
  [4894] = {.lex_state = 159},
  [4895] = {.lex_state = 192},
  [4896] = {.lex_state = 159},
  [4897] = {.lex_state = 145},
  [4898] = {.lex_state = 159},
  [4899] = {.lex_state = 145, .external_lex_state = 24},
  [4900] = {.lex_state = 192},
  [4901] = {.lex_state = 145, .external_lex_state = 24},
  [4902] = {.lex_state = 153},
  [4903] = {.lex_state = 145, .external_lex_state = 24},
  [4904] = {.lex_state = 145, .external_lex_state = 24},
  [4905] = {.lex_state = 145, .external_lex_state = 24},
  [4906] = {.lex_state = 145, .external_lex_state = 24},
  [4907] = {.lex_state = 145, .external_lex_state = 24},
  [4908] = {.lex_state = 145},
  [4909] = {.lex_state = 145},
  [4910] = {.lex_state = 192},
  [4911] = {.lex_state = 159},
  [4912] = {.lex_state = 145},
  [4913] = {.lex_state = 145, .external_lex_state = 29},
  [4914] = {.lex_state = 192},
  [4915] = {.lex_state = 192},
  [4916] = {.lex_state = 149, .external_lex_state = 25},
  [4917] = {.lex_state = 192},
  [4918] = {.lex_state = 145},
  [4919] = {.lex_state = 159},
  [4920] = {.lex_state = 145, .external_lex_state = 30},
  [4921] = {.lex_state = 153, .external_lex_state = 30},
  [4922] = {.lex_state = 145, .external_lex_state = 25},
  [4923] = {.lex_state = 145, .external_lex_state = 30},
  [4924] = {.lex_state = 145},
  [4925] = {.lex_state = 145, .external_lex_state = 25},
  [4926] = {.lex_state = 145},
  [4927] = {.lex_state = 145, .external_lex_state = 24},
  [4928] = {.lex_state = 145, .external_lex_state = 24},
  [4929] = {.lex_state = 145, .external_lex_state = 24},
  [4930] = {.lex_state = 145, .external_lex_state = 24},
  [4931] = {.lex_state = 153, .external_lex_state = 30},
  [4932] = {.lex_state = 145},
  [4933] = {.lex_state = 153, .external_lex_state = 30},
  [4934] = {.lex_state = 145},
  [4935] = {.lex_state = 133, .external_lex_state = 2},
  [4936] = {.lex_state = 145, .external_lex_state = 24},
  [4937] = {.lex_state = 153, .external_lex_state = 30},
  [4938] = {.lex_state = 192},
  [4939] = {.lex_state = 133, .external_lex_state = 4},
  [4940] = {.lex_state = 153, .external_lex_state = 30},
  [4941] = {.lex_state = 145, .external_lex_state = 24},
  [4942] = {.lex_state = 145, .external_lex_state = 24},
  [4943] = {.lex_state = 145},
  [4944] = {.lex_state = 145, .external_lex_state = 24},
  [4945] = {.lex_state = 163},
  [4946] = {.lex_state = 145, .external_lex_state = 24},
  [4947] = {.lex_state = 159, .external_lex_state = 30},
  [4948] = {.lex_state = 153, .external_lex_state = 30},
  [4949] = {.lex_state = 133, .external_lex_state = 2},
  [4950] = {.lex_state = 145},
  [4951] = {.lex_state = 163},
  [4952] = {.lex_state = 145},
  [4953] = {.lex_state = 145, .external_lex_state = 25},
  [4954] = {.lex_state = 192},
  [4955] = {.lex_state = 145},
  [4956] = {.lex_state = 145, .external_lex_state = 25},
  [4957] = {.lex_state = 192},
  [4958] = {.lex_state = 145, .external_lex_state = 24},
  [4959] = {.lex_state = 145},
  [4960] = {.lex_state = 192},
  [4961] = {.lex_state = 145, .external_lex_state = 24},
  [4962] = {.lex_state = 145, .external_lex_state = 24},
  [4963] = {.lex_state = 192},
  [4964] = {.lex_state = 159, .external_lex_state = 30},
  [4965] = {.lex_state = 145, .external_lex_state = 24},
  [4966] = {.lex_state = 145, .external_lex_state = 24},
  [4967] = {.lex_state = 133, .external_lex_state = 4},
  [4968] = {.lex_state = 133, .external_lex_state = 2},
  [4969] = {.lex_state = 133, .external_lex_state = 2},
  [4970] = {.lex_state = 145, .external_lex_state = 24},
  [4971] = {.lex_state = 145, .external_lex_state = 24},
  [4972] = {.lex_state = 145},
  [4973] = {.lex_state = 145, .external_lex_state = 24},
  [4974] = {.lex_state = 145},
  [4975] = {.lex_state = 145, .external_lex_state = 24},
  [4976] = {.lex_state = 145},
  [4977] = {.lex_state = 145, .external_lex_state = 24},
  [4978] = {.lex_state = 145},
  [4979] = {.lex_state = 153, .external_lex_state = 30},
  [4980] = {.lex_state = 145},
  [4981] = {.lex_state = 153, .external_lex_state = 30},
  [4982] = {.lex_state = 145},
  [4983] = {.lex_state = 145},
  [4984] = {.lex_state = 145},
  [4985] = {.lex_state = 145},
  [4986] = {.lex_state = 159},
  [4987] = {.lex_state = 145, .external_lex_state = 24},
  [4988] = {.lex_state = 145, .external_lex_state = 24},
  [4989] = {.lex_state = 145, .external_lex_state = 24},
  [4990] = {.lex_state = 145},
  [4991] = {.lex_state = 145, .external_lex_state = 24},
  [4992] = {.lex_state = 145},
  [4993] = {.lex_state = 163},
  [4994] = {.lex_state = 145},
  [4995] = {.lex_state = 145, .external_lex_state = 25},
  [4996] = {.lex_state = 145},
  [4997] = {.lex_state = 145},
  [4998] = {.lex_state = 145},
  [4999] = {.lex_state = 145},
  [5000] = {.lex_state = 145, .external_lex_state = 25},
  [5001] = {.lex_state = 145, .external_lex_state = 24},
  [5002] = {.lex_state = 145, .external_lex_state = 24},
  [5003] = {.lex_state = 145, .external_lex_state = 24},
  [5004] = {.lex_state = 145, .external_lex_state = 24},
  [5005] = {.lex_state = 145, .external_lex_state = 24},
  [5006] = {.lex_state = 145, .external_lex_state = 24},
  [5007] = {.lex_state = 192},
  [5008] = {.lex_state = 145},
  [5009] = {.lex_state = 192},
  [5010] = {.lex_state = 192},
  [5011] = {.lex_state = 145},
  [5012] = {.lex_state = 145},
  [5013] = {.lex_state = 133, .external_lex_state = 2},
  [5014] = {.lex_state = 145},
  [5015] = {.lex_state = 159},
  [5016] = {.lex_state = 145},
  [5017] = {.lex_state = 145},
  [5018] = {.lex_state = 145, .external_lex_state = 24},
  [5019] = {.lex_state = 153},
  [5020] = {.lex_state = 145, .external_lex_state = 24},
  [5021] = {.lex_state = 145},
  [5022] = {.lex_state = 145},
  [5023] = {.lex_state = 145},
  [5024] = {.lex_state = 145, .external_lex_state = 24},
  [5025] = {.lex_state = 145},
  [5026] = {.lex_state = 145, .external_lex_state = 24},
  [5027] = {.lex_state = 145},
  [5028] = {.lex_state = 145},
  [5029] = {.lex_state = 145, .external_lex_state = 24},
  [5030] = {.lex_state = 145},
  [5031] = {.lex_state = 153},
  [5032] = {.lex_state = 153},
  [5033] = {.lex_state = 145},
  [5034] = {.lex_state = 145},
  [5035] = {.lex_state = 153},
  [5036] = {.lex_state = 145},
  [5037] = {.lex_state = 145, .external_lex_state = 25},
  [5038] = {.lex_state = 145},
  [5039] = {.lex_state = 163},
  [5040] = {.lex_state = 145, .external_lex_state = 25},
  [5041] = {.lex_state = 153},
  [5042] = {.lex_state = 153},
  [5043] = {.lex_state = 159, .external_lex_state = 30},
  [5044] = {.lex_state = 145},
  [5045] = {.lex_state = 153},
  [5046] = {.lex_state = 153},
  [5047] = {.lex_state = 153},
  [5048] = {.lex_state = 192},
  [5049] = {.lex_state = 159},
  [5050] = {.lex_state = 153},
  [5051] = {.lex_state = 153},
  [5052] = {.lex_state = 145},
  [5053] = {.lex_state = 145},
  [5054] = {.lex_state = 145},
  [5055] = {.lex_state = 159},
  [5056] = {.lex_state = 153},
  [5057] = {.lex_state = 145, .external_lex_state = 24},
  [5058] = {.lex_state = 153},
  [5059] = {.lex_state = 145, .external_lex_state = 24},
  [5060] = {.lex_state = 145, .external_lex_state = 24},
  [5061] = {.lex_state = 145},
  [5062] = {.lex_state = 145},
  [5063] = {.lex_state = 145, .external_lex_state = 29},
  [5064] = {.lex_state = 145, .external_lex_state = 25},
  [5065] = {.lex_state = 133, .external_lex_state = 2},
  [5066] = {.lex_state = 145},
  [5067] = {.lex_state = 145, .external_lex_state = 25},
  [5068] = {.lex_state = 145, .external_lex_state = 25},
  [5069] = {.lex_state = 145, .external_lex_state = 25},
  [5070] = {.lex_state = 145, .external_lex_state = 24},
  [5071] = {.lex_state = 145, .external_lex_state = 24},
  [5072] = {.lex_state = 145, .external_lex_state = 25},
  [5073] = {.lex_state = 145, .external_lex_state = 25},
  [5074] = {.lex_state = 145, .external_lex_state = 24},
  [5075] = {.lex_state = 159},
  [5076] = {.lex_state = 145},
  [5077] = {.lex_state = 145, .external_lex_state = 24},
  [5078] = {.lex_state = 145, .external_lex_state = 29},
  [5079] = {.lex_state = 192},
  [5080] = {.lex_state = 145},
  [5081] = {.lex_state = 145},
  [5082] = {.lex_state = 145, .external_lex_state = 24},
  [5083] = {.lex_state = 145, .external_lex_state = 24},
  [5084] = {.lex_state = 145, .external_lex_state = 24},
  [5085] = {.lex_state = 145, .external_lex_state = 29},
  [5086] = {.lex_state = 145, .external_lex_state = 24},
  [5087] = {.lex_state = 145, .external_lex_state = 24},
  [5088] = {.lex_state = 145, .external_lex_state = 24},
  [5089] = {.lex_state = 145, .external_lex_state = 24},
  [5090] = {.lex_state = 145, .external_lex_state = 24},
  [5091] = {.lex_state = 133, .external_lex_state = 2},
  [5092] = {.lex_state = 145, .external_lex_state = 29},
  [5093] = {.lex_state = 145, .external_lex_state = 24},
  [5094] = {.lex_state = 145, .external_lex_state = 24},
  [5095] = {.lex_state = 145, .external_lex_state = 24},
  [5096] = {.lex_state = 145, .external_lex_state = 24},
  [5097] = {.lex_state = 145, .external_lex_state = 24},
  [5098] = {.lex_state = 133, .external_lex_state = 2},
  [5099] = {.lex_state = 145, .external_lex_state = 29},
  [5100] = {.lex_state = 145},
  [5101] = {.lex_state = 145},
  [5102] = {.lex_state = 145},
  [5103] = {.lex_state = 145, .external_lex_state = 24},
  [5104] = {.lex_state = 145},
  [5105] = {.lex_state = 145, .external_lex_state = 29},
  [5106] = {.lex_state = 145, .external_lex_state = 29},
  [5107] = {.lex_state = 145},
  [5108] = {.lex_state = 192},
  [5109] = {.lex_state = 145, .external_lex_state = 24},
  [5110] = {.lex_state = 145},
  [5111] = {.lex_state = 145, .external_lex_state = 25},
  [5112] = {.lex_state = 145, .external_lex_state = 25},
  [5113] = {.lex_state = 153},
  [5114] = {.lex_state = 153},
  [5115] = {.lex_state = 153},
  [5116] = {.lex_state = 153},
  [5117] = {.lex_state = 145, .external_lex_state = 25},
  [5118] = {.lex_state = 145, .external_lex_state = 25},
  [5119] = {.lex_state = 145, .external_lex_state = 25},
  [5120] = {.lex_state = 153},
  [5121] = {.lex_state = 153},
  [5122] = {.lex_state = 153},
  [5123] = {.lex_state = 133, .external_lex_state = 8},
  [5124] = {.lex_state = 159},
  [5125] = {.lex_state = 159},
  [5126] = {.lex_state = 145, .external_lex_state = 25},
  [5127] = {.lex_state = 153},
  [5128] = {.lex_state = 145, .external_lex_state = 25},
  [5129] = {.lex_state = 145, .external_lex_state = 25},
  [5130] = {.lex_state = 145, .external_lex_state = 25},
  [5131] = {.lex_state = 145, .external_lex_state = 25},
  [5132] = {.lex_state = 145, .external_lex_state = 25},
  [5133] = {.lex_state = 145, .external_lex_state = 25},
  [5134] = {.lex_state = 145, .external_lex_state = 25},
  [5135] = {.lex_state = 145, .external_lex_state = 25},
  [5136] = {.lex_state = 145, .external_lex_state = 25},
  [5137] = {.lex_state = 153},
  [5138] = {.lex_state = 153},
  [5139] = {.lex_state = 153},
  [5140] = {.lex_state = 159, .external_lex_state = 30},
  [5141] = {.lex_state = 145, .external_lex_state = 25},
  [5142] = {.lex_state = 153},
  [5143] = {.lex_state = 145, .external_lex_state = 25},
  [5144] = {.lex_state = 145, .external_lex_state = 25},
  [5145] = {.lex_state = 145, .external_lex_state = 25},
  [5146] = {.lex_state = 159},
  [5147] = {.lex_state = 145, .external_lex_state = 25},
  [5148] = {.lex_state = 145, .external_lex_state = 25},
  [5149] = {.lex_state = 159, .external_lex_state = 30},
  [5150] = {.lex_state = 145, .external_lex_state = 25},
  [5151] = {.lex_state = 153},
  [5152] = {.lex_state = 153},
  [5153] = {.lex_state = 153},
  [5154] = {.lex_state = 145, .external_lex_state = 25},
  [5155] = {.lex_state = 145, .external_lex_state = 25},
  [5156] = {.lex_state = 145, .external_lex_state = 25},
  [5157] = {.lex_state = 145, .external_lex_state = 25},
  [5158] = {.lex_state = 145, .external_lex_state = 25},
  [5159] = {.lex_state = 133, .external_lex_state = 8},
  [5160] = {.lex_state = 145, .external_lex_state = 25},
  [5161] = {.lex_state = 159},
  [5162] = {.lex_state = 153},
  [5163] = {.lex_state = 145, .external_lex_state = 25},
  [5164] = {.lex_state = 153},
  [5165] = {.lex_state = 145, .external_lex_state = 25},
  [5166] = {.lex_state = 145, .external_lex_state = 25},
  [5167] = {.lex_state = 145, .external_lex_state = 25},
  [5168] = {.lex_state = 153},
  [5169] = {.lex_state = 159},
  [5170] = {.lex_state = 145, .external_lex_state = 25},
  [5171] = {.lex_state = 145, .external_lex_state = 25},
  [5172] = {.lex_state = 145, .external_lex_state = 25},
  [5173] = {.lex_state = 153},
  [5174] = {.lex_state = 145, .external_lex_state = 25},
  [5175] = {.lex_state = 153},
  [5176] = {.lex_state = 153},
  [5177] = {.lex_state = 153},
  [5178] = {.lex_state = 145, .external_lex_state = 25},
  [5179] = {.lex_state = 145, .external_lex_state = 25},
  [5180] = {.lex_state = 145, .external_lex_state = 25},
  [5181] = {.lex_state = 145, .external_lex_state = 25},
  [5182] = {.lex_state = 145, .external_lex_state = 25},
  [5183] = {.lex_state = 145, .external_lex_state = 25},
  [5184] = {.lex_state = 153},
  [5185] = {.lex_state = 153},
  [5186] = {.lex_state = 153},
  [5187] = {.lex_state = 153},
  [5188] = {.lex_state = 159},
  [5189] = {.lex_state = 153},
  [5190] = {.lex_state = 153},
  [5191] = {.lex_state = 145, .external_lex_state = 25},
  [5192] = {.lex_state = 153},
  [5193] = {.lex_state = 153},
  [5194] = {.lex_state = 153},
  [5195] = {.lex_state = 145, .external_lex_state = 25},
  [5196] = {.lex_state = 153},
  [5197] = {.lex_state = 153},
  [5198] = {.lex_state = 153},
  [5199] = {.lex_state = 153},
  [5200] = {.lex_state = 153},
  [5201] = {.lex_state = 153},
  [5202] = {.lex_state = 153},
  [5203] = {.lex_state = 159},
  [5204] = {.lex_state = 159},
  [5205] = {.lex_state = 153},
  [5206] = {.lex_state = 153},
  [5207] = {.lex_state = 159},
  [5208] = {.lex_state = 159, .external_lex_state = 30},
  [5209] = {.lex_state = 159},
  [5210] = {.lex_state = 153},
  [5211] = {.lex_state = 159},
  [5212] = {.lex_state = 145, .external_lex_state = 25},
  [5213] = {.lex_state = 159},
  [5214] = {.lex_state = 145, .external_lex_state = 25},
  [5215] = {.lex_state = 145},
  [5216] = {.lex_state = 153},
  [5217] = {.lex_state = 153},
  [5218] = {.lex_state = 153},
  [5219] = {.lex_state = 145, .external_lex_state = 25},
  [5220] = {.lex_state = 153},
  [5221] = {.lex_state = 153},
  [5222] = {.lex_state = 145, .external_lex_state = 25},
  [5223] = {.lex_state = 153},
  [5224] = {.lex_state = 145, .external_lex_state = 25},
  [5225] = {.lex_state = 153},
  [5226] = {.lex_state = 153},
  [5227] = {.lex_state = 153},
  [5228] = {.lex_state = 159},
  [5229] = {.lex_state = 159, .external_lex_state = 30},
  [5230] = {.lex_state = 153},
  [5231] = {.lex_state = 153},
  [5232] = {.lex_state = 153},
  [5233] = {.lex_state = 159, .external_lex_state = 30},
  [5234] = {.lex_state = 145, .external_lex_state = 25},
  [5235] = {.lex_state = 145, .external_lex_state = 25},
  [5236] = {.lex_state = 159, .external_lex_state = 30},
  [5237] = {.lex_state = 145, .external_lex_state = 25},
  [5238] = {.lex_state = 153},
  [5239] = {.lex_state = 153},
  [5240] = {.lex_state = 159, .external_lex_state = 30},
  [5241] = {.lex_state = 145, .external_lex_state = 25},
  [5242] = {.lex_state = 145, .external_lex_state = 25},
  [5243] = {.lex_state = 145, .external_lex_state = 25},
  [5244] = {.lex_state = 145, .external_lex_state = 25},
  [5245] = {.lex_state = 153},
  [5246] = {.lex_state = 159},
  [5247] = {.lex_state = 159},
  [5248] = {.lex_state = 159},
  [5249] = {.lex_state = 133, .external_lex_state = 11},
  [5250] = {.lex_state = 159},
  [5251] = {.lex_state = 133, .external_lex_state = 6},
  [5252] = {.lex_state = 159},
  [5253] = {.lex_state = 159},
  [5254] = {.lex_state = 159},
  [5255] = {.lex_state = 159},
  [5256] = {.lex_state = 159},
  [5257] = {.lex_state = 159},
  [5258] = {.lex_state = 159},
  [5259] = {.lex_state = 159},
  [5260] = {.lex_state = 159},
  [5261] = {.lex_state = 159},
  [5262] = {.lex_state = 159},
  [5263] = {.lex_state = 133, .external_lex_state = 11},
  [5264] = {.lex_state = 159},
  [5265] = {.lex_state = 133, .external_lex_state = 26},
  [5266] = {.lex_state = 133, .external_lex_state = 11},
  [5267] = {.lex_state = 133, .external_lex_state = 11},
  [5268] = {.lex_state = 159},
  [5269] = {.lex_state = 133, .external_lex_state = 11},
  [5270] = {.lex_state = 133, .external_lex_state = 11},
  [5271] = {.lex_state = 133, .external_lex_state = 11},
  [5272] = {.lex_state = 159},
  [5273] = {.lex_state = 159},
  [5274] = {.lex_state = 159},
  [5275] = {.lex_state = 159},
  [5276] = {.lex_state = 159},
  [5277] = {.lex_state = 133, .external_lex_state = 11},
  [5278] = {.lex_state = 159},
  [5279] = {.lex_state = 159},
  [5280] = {.lex_state = 159},
  [5281] = {.lex_state = 159},
  [5282] = {.lex_state = 159},
  [5283] = {.lex_state = 159},
  [5284] = {.lex_state = 159},
  [5285] = {.lex_state = 159},
  [5286] = {.lex_state = 159},
  [5287] = {.lex_state = 159},
  [5288] = {.lex_state = 133, .external_lex_state = 11},
  [5289] = {.lex_state = 133, .external_lex_state = 11},
  [5290] = {.lex_state = 159},
  [5291] = {.lex_state = 192},
  [5292] = {.lex_state = 133, .external_lex_state = 11},
  [5293] = {.lex_state = 159},
  [5294] = {.lex_state = 133, .external_lex_state = 6},
  [5295] = {.lex_state = 133, .external_lex_state = 11},
  [5296] = {.lex_state = 159},
  [5297] = {.lex_state = 159},
  [5298] = {.lex_state = 133, .external_lex_state = 11},
  [5299] = {.lex_state = 159},
  [5300] = {.lex_state = 133, .external_lex_state = 11},
  [5301] = {.lex_state = 159},
  [5302] = {.lex_state = 133, .external_lex_state = 11},
  [5303] = {.lex_state = 159},
  [5304] = {.lex_state = 133, .external_lex_state = 26},
  [5305] = {.lex_state = 159},
  [5306] = {.lex_state = 159},
  [5307] = {.lex_state = 159},
  [5308] = {.lex_state = 159},
  [5309] = {.lex_state = 159},
  [5310] = {.lex_state = 159},
  [5311] = {.lex_state = 133, .external_lex_state = 11},
  [5312] = {.lex_state = 159},
  [5313] = {.lex_state = 159},
  [5314] = {.lex_state = 159},
  [5315] = {.lex_state = 159},
  [5316] = {.lex_state = 159},
  [5317] = {.lex_state = 159},
  [5318] = {.lex_state = 159},
  [5319] = {.lex_state = 159},
  [5320] = {.lex_state = 159},
  [5321] = {.lex_state = 159},
  [5322] = {.lex_state = 159},
  [5323] = {.lex_state = 133, .external_lex_state = 4},
  [5324] = {.lex_state = 133, .external_lex_state = 9},
  [5325] = {.lex_state = 133, .external_lex_state = 9},
  [5326] = {.lex_state = 133, .external_lex_state = 27},
  [5327] = {.lex_state = 133, .external_lex_state = 27},
  [5328] = {.lex_state = 133, .external_lex_state = 4},
  [5329] = {.lex_state = 133, .external_lex_state = 4},
  [5330] = {.lex_state = 133, .external_lex_state = 11},
  [5331] = {.lex_state = 133, .external_lex_state = 11},
  [5332] = {.lex_state = 133, .external_lex_state = 11},
  [5333] = {.lex_state = 133, .external_lex_state = 11},
  [5334] = {.lex_state = 133, .external_lex_state = 11},
  [5335] = {.lex_state = 133, .external_lex_state = 11},
  [5336] = {.lex_state = 133, .external_lex_state = 11},
  [5337] = {.lex_state = 133, .external_lex_state = 6},
  [5338] = {.lex_state = 133, .external_lex_state = 11},
  [5339] = {.lex_state = 133, .external_lex_state = 11},
  [5340] = {.lex_state = 133, .external_lex_state = 4},
  [5341] = {.lex_state = 133, .external_lex_state = 4},
  [5342] = {.lex_state = 133, .external_lex_state = 4},
  [5343] = {.lex_state = 133, .external_lex_state = 11},
  [5344] = {.lex_state = 133, .external_lex_state = 4},
  [5345] = {.lex_state = 133, .external_lex_state = 4},
  [5346] = {.lex_state = 165},
  [5347] = {.lex_state = 133, .external_lex_state = 4},
  [5348] = {.lex_state = 133, .external_lex_state = 4},
  [5349] = {.lex_state = 133, .external_lex_state = 8},
  [5350] = {.lex_state = 133, .external_lex_state = 11},
  [5351] = {.lex_state = 133, .external_lex_state = 26},
  [5352] = {.lex_state = 133, .external_lex_state = 4},
  [5353] = {.lex_state = 133, .external_lex_state = 4},
  [5354] = {.lex_state = 133, .external_lex_state = 4},
  [5355] = {.lex_state = 133, .external_lex_state = 4},
  [5356] = {.lex_state = 133, .external_lex_state = 4},
  [5357] = {.lex_state = 133, .external_lex_state = 4},
  [5358] = {.lex_state = 165},
  [5359] = {.lex_state = 133, .external_lex_state = 2},
  [5360] = {.lex_state = 133, .external_lex_state = 2},
  [5361] = {.lex_state = 133, .external_lex_state = 26},
  [5362] = {.lex_state = 133, .external_lex_state = 6},
  [5363] = {.lex_state = 133, .external_lex_state = 8},
  [5364] = {.lex_state = 133, .external_lex_state = 2},
  [5365] = {.lex_state = 133, .external_lex_state = 6},
  [5366] = {.lex_state = 133, .external_lex_state = 4},
  [5367] = {.lex_state = 133, .external_lex_state = 6},
  [5368] = {.lex_state = 133, .external_lex_state = 6},
  [5369] = {.lex_state = 165},
  [5370] = {.lex_state = 133, .external_lex_state = 8},
  [5371] = {.lex_state = 184},
  [5372] = {.lex_state = 133, .external_lex_state = 8},
  [5373] = {.lex_state = 133, .external_lex_state = 4},
  [5374] = {.lex_state = 133, .external_lex_state = 4},
  [5375] = {.lex_state = 133, .external_lex_state = 8},
  [5376] = {.lex_state = 133, .external_lex_state = 26},
  [5377] = {.lex_state = 133, .external_lex_state = 26},
  [5378] = {.lex_state = 165},
  [5379] = {.lex_state = 133, .external_lex_state = 6},
  [5380] = {.lex_state = 133, .external_lex_state = 26},
  [5381] = {.lex_state = 133, .external_lex_state = 2},
  [5382] = {.lex_state = 165},
  [5383] = {.lex_state = 133, .external_lex_state = 2},
  [5384] = {.lex_state = 133, .external_lex_state = 4},
  [5385] = {.lex_state = 133, .external_lex_state = 8},
  [5386] = {.lex_state = 165},
  [5387] = {.lex_state = 133, .external_lex_state = 8},
  [5388] = {.lex_state = 133, .external_lex_state = 8},
  [5389] = {.lex_state = 133, .external_lex_state = 8},
  [5390] = {.lex_state = 133, .external_lex_state = 8},
  [5391] = {.lex_state = 165},
  [5392] = {.lex_state = 165},
  [5393] = {.lex_state = 133, .external_lex_state = 6},
  [5394] = {.lex_state = 133, .external_lex_state = 26},
  [5395] = {.lex_state = 133, .external_lex_state = 2},
  [5396] = {.lex_state = 133, .external_lex_state = 8},
  [5397] = {.lex_state = 133, .external_lex_state = 9},
  [5398] = {.lex_state = 133, .external_lex_state = 8},
  [5399] = {.lex_state = 133, .external_lex_state = 2},
  [5400] = {.lex_state = 133, .external_lex_state = 8},
  [5401] = {.lex_state = 133, .external_lex_state = 6},
  [5402] = {.lex_state = 133, .external_lex_state = 26},
  [5403] = {.lex_state = 133, .external_lex_state = 26},
  [5404] = {.lex_state = 133, .external_lex_state = 8},
  [5405] = {.lex_state = 133, .external_lex_state = 2},
  [5406] = {.lex_state = 133, .external_lex_state = 8},
  [5407] = {.lex_state = 133, .external_lex_state = 6},
  [5408] = {.lex_state = 133, .external_lex_state = 6},
  [5409] = {.lex_state = 133, .external_lex_state = 26},
  [5410] = {.lex_state = 133, .external_lex_state = 8},
  [5411] = {.lex_state = 133, .external_lex_state = 4},
  [5412] = {.lex_state = 133, .external_lex_state = 27},
  [5413] = {.lex_state = 133, .external_lex_state = 26},
  [5414] = {.lex_state = 133, .external_lex_state = 6},
  [5415] = {.lex_state = 133, .external_lex_state = 26},
  [5416] = {.lex_state = 133, .external_lex_state = 9},
  [5417] = {.lex_state = 133, .external_lex_state = 27},
  [5418] = {.lex_state = 133, .external_lex_state = 4},
  [5419] = {.lex_state = 133, .external_lex_state = 6},
  [5420] = {.lex_state = 133, .external_lex_state = 27},
  [5421] = {.lex_state = 133, .external_lex_state = 11},
  [5422] = {.lex_state = 133, .external_lex_state = 6},
  [5423] = {.lex_state = 133, .external_lex_state = 27},
  [5424] = {.lex_state = 133, .external_lex_state = 26},
  [5425] = {.lex_state = 133, .external_lex_state = 26},
  [5426] = {.lex_state = 133, .external_lex_state = 26},
  [5427] = {.lex_state = 133, .external_lex_state = 6},
  [5428] = {.lex_state = 133, .external_lex_state = 6},
  [5429] = {.lex_state = 133, .external_lex_state = 6},
  [5430] = {.lex_state = 133, .external_lex_state = 26},
  [5431] = {.lex_state = 133, .external_lex_state = 11},
  [5432] = {.lex_state = 133, .external_lex_state = 6},
  [5433] = {.lex_state = 133, .external_lex_state = 11},
  [5434] = {.lex_state = 133, .external_lex_state = 4},
  [5435] = {.lex_state = 133, .external_lex_state = 26},
  [5436] = {.lex_state = 133, .external_lex_state = 6},
  [5437] = {.lex_state = 133, .external_lex_state = 6},
  [5438] = {.lex_state = 133, .external_lex_state = 26},
  [5439] = {.lex_state = 133, .external_lex_state = 4},
  [5440] = {.lex_state = 133, .external_lex_state = 11},
  [5441] = {.lex_state = 133, .external_lex_state = 11},
  [5442] = {.lex_state = 133, .external_lex_state = 6},
  [5443] = {.lex_state = 133, .external_lex_state = 26},
  [5444] = {.lex_state = 133, .external_lex_state = 11},
  [5445] = {.lex_state = 133, .external_lex_state = 8},
  [5446] = {.lex_state = 133, .external_lex_state = 11},
  [5447] = {.lex_state = 133, .external_lex_state = 9},
  [5448] = {.lex_state = 133, .external_lex_state = 8},
  [5449] = {.lex_state = 133, .external_lex_state = 11},
  [5450] = {.lex_state = 133, .external_lex_state = 4},
  [5451] = {.lex_state = 133, .external_lex_state = 9},
  [5452] = {.lex_state = 133, .external_lex_state = 26},
  [5453] = {.lex_state = 133, .external_lex_state = 9},
  [5454] = {.lex_state = 133, .external_lex_state = 8},
  [5455] = {.lex_state = 133, .external_lex_state = 9},
  [5456] = {.lex_state = 133, .external_lex_state = 9},
  [5457] = {.lex_state = 133, .external_lex_state = 26},
  [5458] = {.lex_state = 133, .external_lex_state = 11},
  [5459] = {.lex_state = 133, .external_lex_state = 4},
  [5460] = {.lex_state = 133, .external_lex_state = 11},
  [5461] = {.lex_state = 133, .external_lex_state = 9},
  [5462] = {.lex_state = 133, .external_lex_state = 9},
  [5463] = {.lex_state = 133, .external_lex_state = 9},
  [5464] = {.lex_state = 133, .external_lex_state = 27},
  [5465] = {.lex_state = 133, .external_lex_state = 27},
  [5466] = {.lex_state = 133, .external_lex_state = 9},
  [5467] = {.lex_state = 133, .external_lex_state = 27},
  [5468] = {.lex_state = 133, .external_lex_state = 27},
  [5469] = {.lex_state = 133, .external_lex_state = 6},
  [5470] = {.lex_state = 133, .external_lex_state = 26},
  [5471] = {.lex_state = 133, .external_lex_state = 27},
  [5472] = {.lex_state = 133, .external_lex_state = 11},
  [5473] = {.lex_state = 133, .external_lex_state = 8},
  [5474] = {.lex_state = 133, .external_lex_state = 27},
  [5475] = {.lex_state = 133, .external_lex_state = 11},
  [5476] = {.lex_state = 133, .external_lex_state = 8},
  [5477] = {.lex_state = 133, .external_lex_state = 27},
  [5478] = {.lex_state = 133, .external_lex_state = 11},
  [5479] = {.lex_state = 133, .external_lex_state = 4},
  [5480] = {.lex_state = 192},
  [5481] = {.lex_state = 133, .external_lex_state = 27},
  [5482] = {.lex_state = 192},
  [5483] = {.lex_state = 192},
  [5484] = {.lex_state = 192},
  [5485] = {.lex_state = 187},
  [5486] = {.lex_state = 192},
  [5487] = {.lex_state = 133, .external_lex_state = 27},
  [5488] = {.lex_state = 133, .external_lex_state = 26},
  [5489] = {.lex_state = 133, .external_lex_state = 9},
  [5490] = {.lex_state = 192},
  [5491] = {.lex_state = 133, .external_lex_state = 27},
  [5492] = {.lex_state = 133, .external_lex_state = 27},
  [5493] = {.lex_state = 133, .external_lex_state = 6},
  [5494] = {.lex_state = 133, .external_lex_state = 27},
  [5495] = {.lex_state = 133, .external_lex_state = 9},
  [5496] = {.lex_state = 133, .external_lex_state = 27},
  [5497] = {.lex_state = 133, .external_lex_state = 4},
  [5498] = {.lex_state = 133, .external_lex_state = 27},
  [5499] = {.lex_state = 133, .external_lex_state = 27},
  [5500] = {.lex_state = 133, .external_lex_state = 9},
  [5501] = {.lex_state = 192},
  [5502] = {.lex_state = 133, .external_lex_state = 26},
  [5503] = {.lex_state = 133, .external_lex_state = 26},
  [5504] = {.lex_state = 133, .external_lex_state = 6},
  [5505] = {.lex_state = 192},
  [5506] = {.lex_state = 192},
  [5507] = {.lex_state = 192},
  [5508] = {.lex_state = 133, .external_lex_state = 9},
  [5509] = {.lex_state = 133, .external_lex_state = 8},
  [5510] = {.lex_state = 133, .external_lex_state = 6},
  [5511] = {.lex_state = 165},
  [5512] = {.lex_state = 133, .external_lex_state = 26},
  [5513] = {.lex_state = 192},
  [5514] = {.lex_state = 133, .external_lex_state = 6},
  [5515] = {.lex_state = 192},
  [5516] = {.lex_state = 133, .external_lex_state = 6},
  [5517] = {.lex_state = 133, .external_lex_state = 9},
  [5518] = {.lex_state = 133, .external_lex_state = 8},
  [5519] = {.lex_state = 192},
  [5520] = {.lex_state = 133, .external_lex_state = 4},
  [5521] = {.lex_state = 133, .external_lex_state = 4},
  [5522] = {.lex_state = 192},
  [5523] = {.lex_state = 165},
  [5524] = {.lex_state = 133, .external_lex_state = 11},
  [5525] = {.lex_state = 133, .external_lex_state = 4},
  [5526] = {.lex_state = 133, .external_lex_state = 26},
  [5527] = {.lex_state = 192},
  [5528] = {.lex_state = 133, .external_lex_state = 4},
  [5529] = {.lex_state = 133, .external_lex_state = 9},
  [5530] = {.lex_state = 133, .external_lex_state = 4},
  [5531] = {.lex_state = 133, .external_lex_state = 4},
  [5532] = {.lex_state = 133, .external_lex_state = 9},
  [5533] = {.lex_state = 192},
  [5534] = {.lex_state = 133, .external_lex_state = 8},
  [5535] = {.lex_state = 133, .external_lex_state = 9},
  [5536] = {.lex_state = 192},
  [5537] = {.lex_state = 133, .external_lex_state = 11},
  [5538] = {.lex_state = 133, .external_lex_state = 8},
  [5539] = {.lex_state = 192},
  [5540] = {.lex_state = 133, .external_lex_state = 11},
  [5541] = {.lex_state = 133, .external_lex_state = 4},
  [5542] = {.lex_state = 133, .external_lex_state = 9},
  [5543] = {.lex_state = 133, .external_lex_state = 9},
  [5544] = {.lex_state = 133, .external_lex_state = 11},
  [5545] = {.lex_state = 133, .external_lex_state = 11},
  [5546] = {.lex_state = 133, .external_lex_state = 27},
  [5547] = {.lex_state = 192},
  [5548] = {.lex_state = 133, .external_lex_state = 11},
  [5549] = {.lex_state = 133, .external_lex_state = 11},
  [5550] = {.lex_state = 133, .external_lex_state = 11},
  [5551] = {.lex_state = 133, .external_lex_state = 4},
  [5552] = {.lex_state = 133, .external_lex_state = 8},
  [5553] = {.lex_state = 133, .external_lex_state = 4},
  [5554] = {.lex_state = 133, .external_lex_state = 27},
  [5555] = {.lex_state = 133, .external_lex_state = 4},
  [5556] = {.lex_state = 133, .external_lex_state = 11},
  [5557] = {.lex_state = 133, .external_lex_state = 26},
  [5558] = {.lex_state = 133, .external_lex_state = 8},
  [5559] = {.lex_state = 193},
  [5560] = {.lex_state = 133, .external_lex_state = 26},
  [5561] = {.lex_state = 193},
  [5562] = {.lex_state = 193},
  [5563] = {.lex_state = 193},
  [5564] = {.lex_state = 133, .external_lex_state = 11},
  [5565] = {.lex_state = 133, .external_lex_state = 11},
  [5566] = {.lex_state = 133, .external_lex_state = 9},
  [5567] = {.lex_state = 347},
  [5568] = {.lex_state = 133, .external_lex_state = 8},
  [5569] = {.lex_state = 133, .external_lex_state = 11},
  [5570] = {.lex_state = 133, .external_lex_state = 26},
  [5571] = {.lex_state = 133, .external_lex_state = 8},
  [5572] = {.lex_state = 133, .external_lex_state = 11},
  [5573] = {.lex_state = 133, .external_lex_state = 27},
  [5574] = {.lex_state = 133, .external_lex_state = 11},
  [5575] = {.lex_state = 193},
  [5576] = {.lex_state = 193},
  [5577] = {.lex_state = 133, .external_lex_state = 9},
  [5578] = {.lex_state = 133, .external_lex_state = 11},
  [5579] = {.lex_state = 133, .external_lex_state = 8},
  [5580] = {.lex_state = 193},
  [5581] = {.lex_state = 193},
  [5582] = {.lex_state = 133, .external_lex_state = 9},
  [5583] = {.lex_state = 347},
  [5584] = {.lex_state = 193},
  [5585] = {.lex_state = 133, .external_lex_state = 9},
  [5586] = {.lex_state = 193},
  [5587] = {.lex_state = 133, .external_lex_state = 26},
  [5588] = {.lex_state = 170},
  [5589] = {.lex_state = 133, .external_lex_state = 6},
  [5590] = {.lex_state = 133, .external_lex_state = 6},
  [5591] = {.lex_state = 133, .external_lex_state = 6},
  [5592] = {.lex_state = 133, .external_lex_state = 8},
  [5593] = {.lex_state = 133, .external_lex_state = 8},
  [5594] = {.lex_state = 133, .external_lex_state = 6},
  [5595] = {.lex_state = 193},
  [5596] = {.lex_state = 193},
  [5597] = {.lex_state = 133, .external_lex_state = 8},
  [5598] = {.lex_state = 133, .external_lex_state = 6},
  [5599] = {.lex_state = 133, .external_lex_state = 27},
  [5600] = {.lex_state = 133, .external_lex_state = 8},
  [5601] = {.lex_state = 192},
  [5602] = {.lex_state = 133, .external_lex_state = 6},
  [5603] = {.lex_state = 133, .external_lex_state = 6},
  [5604] = {.lex_state = 133, .external_lex_state = 8},
  [5605] = {.lex_state = 193},
  [5606] = {.lex_state = 133, .external_lex_state = 8},
  [5607] = {.lex_state = 133, .external_lex_state = 11},
  [5608] = {.lex_state = 133, .external_lex_state = 26},
  [5609] = {.lex_state = 133, .external_lex_state = 6},
  [5610] = {.lex_state = 133, .external_lex_state = 26},
  [5611] = {.lex_state = 347},
  [5612] = {.lex_state = 193},
  [5613] = {.lex_state = 133, .external_lex_state = 26},
  [5614] = {.lex_state = 133, .external_lex_state = 11},
  [5615] = {.lex_state = 133, .external_lex_state = 9},
  [5616] = {.lex_state = 193},
  [5617] = {.lex_state = 133, .external_lex_state = 27},
  [5618] = {.lex_state = 133, .external_lex_state = 27},
  [5619] = {.lex_state = 133, .external_lex_state = 26},
  [5620] = {.lex_state = 193},
  [5621] = {.lex_state = 133, .external_lex_state = 26},
  [5622] = {.lex_state = 184, .external_lex_state = 24},
  [5623] = {.lex_state = 193},
  [5624] = {.lex_state = 133, .external_lex_state = 26},
  [5625] = {.lex_state = 193},
  [5626] = {.lex_state = 133, .external_lex_state = 26},
  [5627] = {.lex_state = 133, .external_lex_state = 26},
  [5628] = {.lex_state = 192},
  [5629] = {.lex_state = 133, .external_lex_state = 6},
  [5630] = {.lex_state = 133, .external_lex_state = 11},
  [5631] = {.lex_state = 133, .external_lex_state = 6},
  [5632] = {.lex_state = 193},
  [5633] = {.lex_state = 133, .external_lex_state = 8},
  [5634] = {.lex_state = 133, .external_lex_state = 6},
  [5635] = {.lex_state = 133, .external_lex_state = 8},
  [5636] = {.lex_state = 133, .external_lex_state = 27},
  [5637] = {.lex_state = 193},
  [5638] = {.lex_state = 133, .external_lex_state = 6},
  [5639] = {.lex_state = 192},
  [5640] = {.lex_state = 192},
  [5641] = {.lex_state = 192},
  [5642] = {.lex_state = 192},
  [5643] = {.lex_state = 192},
  [5644] = {.lex_state = 192},
  [5645] = {.lex_state = 192},
  [5646] = {.lex_state = 165},
  [5647] = {.lex_state = 192},
  [5648] = {.lex_state = 192},
  [5649] = {.lex_state = 192},
  [5650] = {.lex_state = 192},
  [5651] = {.lex_state = 192},
  [5652] = {.lex_state = 192},
  [5653] = {.lex_state = 192},
  [5654] = {.lex_state = 192},
  [5655] = {.lex_state = 192},
  [5656] = {.lex_state = 192},
  [5657] = {.lex_state = 192},
  [5658] = {.lex_state = 192},
  [5659] = {.lex_state = 192},
  [5660] = {.lex_state = 192},
  [5661] = {.lex_state = 165},
  [5662] = {.lex_state = 192},
  [5663] = {.lex_state = 192},
  [5664] = {.lex_state = 192},
  [5665] = {.lex_state = 192},
  [5666] = {.lex_state = 192},
  [5667] = {.lex_state = 192},
  [5668] = {.lex_state = 192},
  [5669] = {.lex_state = 192},
  [5670] = {.lex_state = 192},
  [5671] = {.lex_state = 192},
  [5672] = {.lex_state = 165},
  [5673] = {.lex_state = 192},
  [5674] = {.lex_state = 192},
  [5675] = {.lex_state = 192},
  [5676] = {.lex_state = 192},
  [5677] = {.lex_state = 192},
  [5678] = {.lex_state = 192},
  [5679] = {.lex_state = 192},
  [5680] = {.lex_state = 192},
  [5681] = {.lex_state = 192},
  [5682] = {.lex_state = 192},
  [5683] = {.lex_state = 192},
  [5684] = {.lex_state = 192},
  [5685] = {.lex_state = 192},
  [5686] = {.lex_state = 192},
  [5687] = {.lex_state = 192},
  [5688] = {.lex_state = 192},
  [5689] = {.lex_state = 192},
  [5690] = {.lex_state = 192},
  [5691] = {.lex_state = 192},
  [5692] = {.lex_state = 192},
  [5693] = {.lex_state = 192},
  [5694] = {.lex_state = 192},
  [5695] = {.lex_state = 192},
  [5696] = {.lex_state = 192},
  [5697] = {.lex_state = 192},
  [5698] = {.lex_state = 192},
  [5699] = {.lex_state = 192},
  [5700] = {.lex_state = 192},
  [5701] = {.lex_state = 192},
  [5702] = {.lex_state = 192},
  [5703] = {.lex_state = 192},
  [5704] = {.lex_state = 192},
  [5705] = {.lex_state = 192},
  [5706] = {.lex_state = 192},
  [5707] = {.lex_state = 192},
  [5708] = {.lex_state = 192},
  [5709] = {.lex_state = 192},
  [5710] = {.lex_state = 192},
  [5711] = {.lex_state = 192},
  [5712] = {.lex_state = 192},
  [5713] = {.lex_state = 192},
  [5714] = {.lex_state = 192},
  [5715] = {.lex_state = 192},
  [5716] = {.lex_state = 192},
  [5717] = {.lex_state = 192},
  [5718] = {.lex_state = 192},
  [5719] = {.lex_state = 192},
  [5720] = {.lex_state = 192},
  [5721] = {.lex_state = 192},
  [5722] = {.lex_state = 192},
  [5723] = {.lex_state = 192},
  [5724] = {.lex_state = 192},
  [5725] = {.lex_state = 192},
  [5726] = {.lex_state = 192},
  [5727] = {.lex_state = 165},
  [5728] = {.lex_state = 192},
  [5729] = {.lex_state = 192},
  [5730] = {.lex_state = 192},
  [5731] = {.lex_state = 192},
  [5732] = {.lex_state = 192},
  [5733] = {.lex_state = 192},
  [5734] = {.lex_state = 192},
  [5735] = {.lex_state = 192},
  [5736] = {.lex_state = 192},
  [5737] = {.lex_state = 192},
  [5738] = {.lex_state = 171},
  [5739] = {.lex_state = 192},
  [5740] = {.lex_state = 192},
  [5741] = {.lex_state = 192},
  [5742] = {.lex_state = 192},
  [5743] = {.lex_state = 192},
  [5744] = {.lex_state = 192},
  [5745] = {.lex_state = 192},
  [5746] = {.lex_state = 192},
  [5747] = {.lex_state = 192},
  [5748] = {.lex_state = 192},
  [5749] = {.lex_state = 192},
  [5750] = {.lex_state = 192},
  [5751] = {.lex_state = 192},
  [5752] = {.lex_state = 192},
  [5753] = {.lex_state = 192},
  [5754] = {.lex_state = 192},
  [5755] = {.lex_state = 192},
  [5756] = {.lex_state = 192},
  [5757] = {.lex_state = 192},
  [5758] = {.lex_state = 192},
  [5759] = {.lex_state = 192},
  [5760] = {.lex_state = 192},
  [5761] = {.lex_state = 192},
  [5762] = {.lex_state = 192},
  [5763] = {.lex_state = 192},
  [5764] = {.lex_state = 192},
  [5765] = {.lex_state = 192},
  [5766] = {.lex_state = 192},
  [5767] = {.lex_state = 192},
  [5768] = {.lex_state = 192},
  [5769] = {.lex_state = 192},
  [5770] = {.lex_state = 192},
  [5771] = {.lex_state = 192},
  [5772] = {.lex_state = 192},
  [5773] = {.lex_state = 192},
  [5774] = {.lex_state = 192},
  [5775] = {.lex_state = 192},
  [5776] = {.lex_state = 192},
  [5777] = {.lex_state = 192},
  [5778] = {.lex_state = 192},
  [5779] = {.lex_state = 192},
  [5780] = {.lex_state = 192},
  [5781] = {.lex_state = 165},
  [5782] = {.lex_state = 192},
  [5783] = {.lex_state = 192},
  [5784] = {.lex_state = 192},
  [5785] = {.lex_state = 192},
  [5786] = {.lex_state = 192},
  [5787] = {.lex_state = 192},
  [5788] = {.lex_state = 192},
  [5789] = {.lex_state = 192},
  [5790] = {.lex_state = 192},
  [5791] = {.lex_state = 192},
  [5792] = {.lex_state = 165},
  [5793] = {.lex_state = 192},
  [5794] = {.lex_state = 192},
  [5795] = {.lex_state = 192},
  [5796] = {.lex_state = 192},
  [5797] = {.lex_state = 133, .external_lex_state = 9},
  [5798] = {.lex_state = 192},
  [5799] = {.lex_state = 192},
  [5800] = {.lex_state = 192},
  [5801] = {.lex_state = 192},
  [5802] = {.lex_state = 192},
  [5803] = {.lex_state = 192},
  [5804] = {.lex_state = 192},
  [5805] = {.lex_state = 192},
  [5806] = {.lex_state = 192},
  [5807] = {.lex_state = 192},
  [5808] = {.lex_state = 171},
  [5809] = {.lex_state = 192},
  [5810] = {.lex_state = 133, .external_lex_state = 9},
  [5811] = {.lex_state = 192},
  [5812] = {.lex_state = 192},
  [5813] = {.lex_state = 192},
  [5814] = {.lex_state = 192},
  [5815] = {.lex_state = 192},
  [5816] = {.lex_state = 165},
  [5817] = {.lex_state = 192},
  [5818] = {.lex_state = 192},
  [5819] = {.lex_state = 133, .external_lex_state = 9},
  [5820] = {.lex_state = 192},
  [5821] = {.lex_state = 192},
  [5822] = {.lex_state = 192},
  [5823] = {.lex_state = 192},
  [5824] = {.lex_state = 192},
  [5825] = {.lex_state = 192},
  [5826] = {.lex_state = 192},
  [5827] = {.lex_state = 192},
  [5828] = {.lex_state = 192},
  [5829] = {.lex_state = 192},
  [5830] = {.lex_state = 192},
  [5831] = {.lex_state = 192},
  [5832] = {.lex_state = 192},
  [5833] = {.lex_state = 192},
  [5834] = {.lex_state = 192},
  [5835] = {.lex_state = 192},
  [5836] = {.lex_state = 192},
  [5837] = {.lex_state = 192},
  [5838] = {.lex_state = 192},
  [5839] = {.lex_state = 192},
  [5840] = {.lex_state = 192},
  [5841] = {.lex_state = 192},
  [5842] = {.lex_state = 192},
  [5843] = {.lex_state = 192},
  [5844] = {.lex_state = 192},
  [5845] = {.lex_state = 192},
  [5846] = {.lex_state = 192},
  [5847] = {.lex_state = 192},
  [5848] = {.lex_state = 192},
  [5849] = {.lex_state = 192},
  [5850] = {.lex_state = 192},
  [5851] = {.lex_state = 192},
  [5852] = {.lex_state = 192},
  [5853] = {.lex_state = 192},
  [5854] = {.lex_state = 192},
  [5855] = {.lex_state = 192},
  [5856] = {.lex_state = 192},
  [5857] = {.lex_state = 192},
  [5858] = {.lex_state = 192},
  [5859] = {.lex_state = 192},
  [5860] = {.lex_state = 192},
  [5861] = {.lex_state = 192},
  [5862] = {.lex_state = 192},
  [5863] = {.lex_state = 192},
  [5864] = {.lex_state = 192},
  [5865] = {.lex_state = 192},
  [5866] = {.lex_state = 192},
  [5867] = {.lex_state = 192},
  [5868] = {.lex_state = 192},
  [5869] = {.lex_state = 192},
  [5870] = {.lex_state = 192},
  [5871] = {.lex_state = 192},
  [5872] = {.lex_state = 192},
  [5873] = {.lex_state = 192},
  [5874] = {.lex_state = 192},
  [5875] = {.lex_state = 192},
  [5876] = {.lex_state = 192},
  [5877] = {.lex_state = 192},
  [5878] = {.lex_state = 192},
  [5879] = {.lex_state = 192},
  [5880] = {.lex_state = 192},
  [5881] = {.lex_state = 192},
  [5882] = {.lex_state = 192},
  [5883] = {.lex_state = 192},
  [5884] = {.lex_state = 192},
  [5885] = {.lex_state = 192},
  [5886] = {.lex_state = 192},
  [5887] = {.lex_state = 192},
  [5888] = {.lex_state = 192},
  [5889] = {.lex_state = 192},
  [5890] = {.lex_state = 192},
  [5891] = {.lex_state = 192},
  [5892] = {.lex_state = 192},
  [5893] = {.lex_state = 192},
  [5894] = {.lex_state = 192},
  [5895] = {.lex_state = 192},
  [5896] = {.lex_state = 192},
  [5897] = {.lex_state = 192},
  [5898] = {.lex_state = 192},
  [5899] = {.lex_state = 192},
  [5900] = {.lex_state = 192},
  [5901] = {.lex_state = 171},
  [5902] = {.lex_state = 192},
  [5903] = {.lex_state = 192},
  [5904] = {.lex_state = 192},
  [5905] = {.lex_state = 192},
  [5906] = {.lex_state = 192},
  [5907] = {.lex_state = 192},
  [5908] = {.lex_state = 192},
  [5909] = {.lex_state = 192},
  [5910] = {.lex_state = 192},
  [5911] = {.lex_state = 192},
  [5912] = {.lex_state = 192},
  [5913] = {.lex_state = 192},
  [5914] = {.lex_state = 192},
  [5915] = {.lex_state = 192},
  [5916] = {.lex_state = 192},
  [5917] = {.lex_state = 192},
  [5918] = {.lex_state = 192},
  [5919] = {.lex_state = 192},
  [5920] = {.lex_state = 192},
  [5921] = {.lex_state = 192},
  [5922] = {.lex_state = 192},
  [5923] = {.lex_state = 192},
  [5924] = {.lex_state = 192},
  [5925] = {.lex_state = 192},
  [5926] = {.lex_state = 192},
  [5927] = {.lex_state = 192},
  [5928] = {.lex_state = 133, .external_lex_state = 11},
  [5929] = {.lex_state = 192},
  [5930] = {.lex_state = 192},
  [5931] = {.lex_state = 192},
  [5932] = {.lex_state = 192},
  [5933] = {.lex_state = 192},
  [5934] = {.lex_state = 192},
  [5935] = {.lex_state = 192},
  [5936] = {.lex_state = 192},
  [5937] = {.lex_state = 192},
  [5938] = {.lex_state = 192},
  [5939] = {.lex_state = 192},
  [5940] = {.lex_state = 192},
  [5941] = {.lex_state = 133, .external_lex_state = 11},
  [5942] = {.lex_state = 192},
  [5943] = {.lex_state = 192},
  [5944] = {.lex_state = 192},
  [5945] = {.lex_state = 192},
  [5946] = {.lex_state = 192},
  [5947] = {.lex_state = 192},
  [5948] = {.lex_state = 192},
  [5949] = {.lex_state = 192},
  [5950] = {.lex_state = 192},
  [5951] = {.lex_state = 192},
  [5952] = {.lex_state = 192},
  [5953] = {.lex_state = 192},
  [5954] = {.lex_state = 192},
  [5955] = {.lex_state = 192},
  [5956] = {.lex_state = 192},
  [5957] = {.lex_state = 192},
  [5958] = {.lex_state = 192},
  [5959] = {.lex_state = 192},
  [5960] = {.lex_state = 192},
  [5961] = {.lex_state = 192},
  [5962] = {.lex_state = 133, .external_lex_state = 11},
  [5963] = {.lex_state = 192},
  [5964] = {.lex_state = 192},
  [5965] = {.lex_state = 192},
  [5966] = {.lex_state = 192},
  [5967] = {.lex_state = 192},
  [5968] = {.lex_state = 192},
  [5969] = {.lex_state = 192},
  [5970] = {.lex_state = 184, .external_lex_state = 25},
  [5971] = {.lex_state = 192},
  [5972] = {.lex_state = 192},
  [5973] = {.lex_state = 192},
  [5974] = {.lex_state = 192},
  [5975] = {.lex_state = 192},
  [5976] = {.lex_state = 192},
  [5977] = {.lex_state = 192},
  [5978] = {.lex_state = 192},
  [5979] = {.lex_state = 192},
  [5980] = {.lex_state = 192},
  [5981] = {.lex_state = 192},
  [5982] = {.lex_state = 192},
  [5983] = {.lex_state = 192},
  [5984] = {.lex_state = 192},
  [5985] = {.lex_state = 192},
  [5986] = {.lex_state = 192},
  [5987] = {.lex_state = 192},
  [5988] = {.lex_state = 192},
  [5989] = {.lex_state = 192},
  [5990] = {.lex_state = 192},
  [5991] = {.lex_state = 192},
  [5992] = {.lex_state = 192},
  [5993] = {.lex_state = 192},
  [5994] = {.lex_state = 192},
  [5995] = {.lex_state = 192},
  [5996] = {.lex_state = 133, .external_lex_state = 9},
  [5997] = {.lex_state = 192},
  [5998] = {.lex_state = 192},
  [5999] = {.lex_state = 192},
  [6000] = {.lex_state = 192},
  [6001] = {.lex_state = 192},
  [6002] = {.lex_state = 192},
  [6003] = {.lex_state = 192},
  [6004] = {.lex_state = 192},
  [6005] = {.lex_state = 192},
  [6006] = {.lex_state = 192},
  [6007] = {.lex_state = 192},
  [6008] = {.lex_state = 192},
  [6009] = {.lex_state = 133, .external_lex_state = 11},
  [6010] = {.lex_state = 192},
  [6011] = {.lex_state = 192},
  [6012] = {.lex_state = 192},
  [6013] = {.lex_state = 192},
  [6014] = {.lex_state = 192},
  [6015] = {.lex_state = 192},
  [6016] = {.lex_state = 192},
  [6017] = {.lex_state = 192},
  [6018] = {.lex_state = 192},
  [6019] = {.lex_state = 192},
  [6020] = {.lex_state = 192},
  [6021] = {.lex_state = 192},
  [6022] = {.lex_state = 192},
  [6023] = {.lex_state = 192},
  [6024] = {.lex_state = 192},
  [6025] = {.lex_state = 192},
  [6026] = {.lex_state = 192},
  [6027] = {.lex_state = 192},
  [6028] = {.lex_state = 192},
  [6029] = {.lex_state = 192},
  [6030] = {.lex_state = 192},
  [6031] = {.lex_state = 192},
  [6032] = {.lex_state = 192},
  [6033] = {.lex_state = 171},
  [6034] = {.lex_state = 192},
  [6035] = {.lex_state = 192},
  [6036] = {.lex_state = 192},
  [6037] = {.lex_state = 192},
  [6038] = {.lex_state = 192},
  [6039] = {.lex_state = 192},
  [6040] = {.lex_state = 192},
  [6041] = {.lex_state = 192},
  [6042] = {.lex_state = 192},
  [6043] = {.lex_state = 192},
  [6044] = {.lex_state = 192},
  [6045] = {.lex_state = 192},
  [6046] = {.lex_state = 133, .external_lex_state = 9},
  [6047] = {.lex_state = 192},
  [6048] = {.lex_state = 192},
  [6049] = {.lex_state = 192},
  [6050] = {.lex_state = 192},
  [6051] = {.lex_state = 192},
  [6052] = {.lex_state = 192},
  [6053] = {.lex_state = 192},
  [6054] = {.lex_state = 192},
  [6055] = {.lex_state = 192},
  [6056] = {.lex_state = 192},
  [6057] = {.lex_state = 192},
  [6058] = {.lex_state = 192},
  [6059] = {.lex_state = 192},
  [6060] = {.lex_state = 192},
  [6061] = {.lex_state = 192},
  [6062] = {.lex_state = 192},
  [6063] = {.lex_state = 192},
  [6064] = {.lex_state = 192},
  [6065] = {.lex_state = 192},
  [6066] = {.lex_state = 192},
  [6067] = {.lex_state = 192},
  [6068] = {.lex_state = 192},
  [6069] = {.lex_state = 192},
  [6070] = {.lex_state = 192},
  [6071] = {.lex_state = 192},
  [6072] = {.lex_state = 192},
  [6073] = {.lex_state = 192},
  [6074] = {.lex_state = 192},
  [6075] = {.lex_state = 192},
  [6076] = {.lex_state = 192},
  [6077] = {.lex_state = 192},
  [6078] = {.lex_state = 192},
  [6079] = {.lex_state = 192},
  [6080] = {.lex_state = 192},
  [6081] = {.lex_state = 192},
  [6082] = {.lex_state = 192},
  [6083] = {.lex_state = 133, .external_lex_state = 9},
  [6084] = {.lex_state = 192},
  [6085] = {.lex_state = 133, .external_lex_state = 9},
  [6086] = {.lex_state = 192},
  [6087] = {.lex_state = 192},
  [6088] = {.lex_state = 192},
  [6089] = {.lex_state = 192},
  [6090] = {.lex_state = 192},
  [6091] = {.lex_state = 192},
  [6092] = {.lex_state = 192},
  [6093] = {.lex_state = 192},
  [6094] = {.lex_state = 347},
  [6095] = {.lex_state = 192},
  [6096] = {.lex_state = 192},
  [6097] = {.lex_state = 192},
  [6098] = {.lex_state = 192},
  [6099] = {.lex_state = 192},
  [6100] = {.lex_state = 192},
  [6101] = {.lex_state = 192},
  [6102] = {.lex_state = 192},
  [6103] = {.lex_state = 192},
  [6104] = {.lex_state = 192},
  [6105] = {.lex_state = 192},
  [6106] = {.lex_state = 192},
  [6107] = {.lex_state = 192},
  [6108] = {.lex_state = 192},
  [6109] = {.lex_state = 192},
  [6110] = {.lex_state = 192},
  [6111] = {.lex_state = 133, .external_lex_state = 9},
  [6112] = {.lex_state = 133, .external_lex_state = 9},
  [6113] = {.lex_state = 192},
  [6114] = {.lex_state = 192},
  [6115] = {.lex_state = 133, .external_lex_state = 11},
  [6116] = {.lex_state = 133, .external_lex_state = 9},
  [6117] = {.lex_state = 192},
  [6118] = {.lex_state = 192},
  [6119] = {.lex_state = 192},
  [6120] = {.lex_state = 192},
  [6121] = {.lex_state = 192},
  [6122] = {.lex_state = 133, .external_lex_state = 11},
  [6123] = {.lex_state = 192},
  [6124] = {.lex_state = 133, .external_lex_state = 27},
  [6125] = {.lex_state = 133, .external_lex_state = 11},
  [6126] = {.lex_state = 133, .external_lex_state = 11},
  [6127] = {.lex_state = 133, .external_lex_state = 27},
  [6128] = {.lex_state = 133, .external_lex_state = 27},
  [6129] = {.lex_state = 192},
  [6130] = {.lex_state = 133, .external_lex_state = 9},
  [6131] = {.lex_state = 192},
  [6132] = {.lex_state = 192},
  [6133] = {.lex_state = 192},
  [6134] = {.lex_state = 192},
  [6135] = {.lex_state = 192},
  [6136] = {.lex_state = 192},
  [6137] = {.lex_state = 192},
  [6138] = {.lex_state = 192},
  [6139] = {.lex_state = 192},
  [6140] = {.lex_state = 192},
  [6141] = {.lex_state = 192},
  [6142] = {.lex_state = 192},
  [6143] = {.lex_state = 192},
  [6144] = {.lex_state = 192},
  [6145] = {.lex_state = 133, .external_lex_state = 9},
  [6146] = {.lex_state = 192},
  [6147] = {.lex_state = 192},
  [6148] = {.lex_state = 192},
  [6149] = {.lex_state = 192},
  [6150] = {.lex_state = 192},
  [6151] = {.lex_state = 192},
  [6152] = {.lex_state = 192},
  [6153] = {.lex_state = 192},
  [6154] = {.lex_state = 133, .external_lex_state = 11},
  [6155] = {.lex_state = 192},
  [6156] = {.lex_state = 192},
  [6157] = {.lex_state = 192},
  [6158] = {.lex_state = 192},
  [6159] = {.lex_state = 192},
  [6160] = {.lex_state = 133, .external_lex_state = 11},
  [6161] = {.lex_state = 133, .external_lex_state = 27},
  [6162] = {.lex_state = 192},
  [6163] = {.lex_state = 192},
  [6164] = {.lex_state = 133, .external_lex_state = 27},
  [6165] = {.lex_state = 192},
  [6166] = {.lex_state = 192},
  [6167] = {.lex_state = 192},
  [6168] = {.lex_state = 133, .external_lex_state = 27},
  [6169] = {.lex_state = 133, .external_lex_state = 27},
  [6170] = {.lex_state = 192},
  [6171] = {.lex_state = 192},
  [6172] = {.lex_state = 192},
  [6173] = {.lex_state = 192},
  [6174] = {.lex_state = 133, .external_lex_state = 27},
  [6175] = {.lex_state = 133, .external_lex_state = 27},
  [6176] = {.lex_state = 192},
  [6177] = {.lex_state = 192},
  [6178] = {.lex_state = 192},
  [6179] = {.lex_state = 192},
  [6180] = {.lex_state = 192},
  [6181] = {.lex_state = 192},
  [6182] = {.lex_state = 133, .external_lex_state = 27},
  [6183] = {.lex_state = 133, .external_lex_state = 11},
  [6184] = {.lex_state = 133, .external_lex_state = 11},
  [6185] = {.lex_state = 133, .external_lex_state = 27},
  [6186] = {.lex_state = 133, .external_lex_state = 27},
  [6187] = {.lex_state = 192},
  [6188] = {.lex_state = 192},
  [6189] = {.lex_state = 192},
  [6190] = {.lex_state = 192},
  [6191] = {.lex_state = 192},
  [6192] = {.lex_state = 192},
  [6193] = {.lex_state = 192},
  [6194] = {.lex_state = 192},
  [6195] = {.lex_state = 133},
  [6196] = {.lex_state = 133, .external_lex_state = 5},
  [6197] = {.lex_state = 189, .external_lex_state = 24},
  [6198] = {.lex_state = 133, .external_lex_state = 5},
  [6199] = {.lex_state = 193, .external_lex_state = 31},
  [6200] = {.lex_state = 133},
  [6201] = {.lex_state = 133, .external_lex_state = 5},
  [6202] = {.lex_state = 347},
  [6203] = {.lex_state = 347, .external_lex_state = 31},
  [6204] = {.lex_state = 347},
  [6205] = {.lex_state = 347, .external_lex_state = 31},
  [6206] = {.lex_state = 347, .external_lex_state = 31},
  [6207] = {.lex_state = 193, .external_lex_state = 31},
  [6208] = {.lex_state = 347},
  [6209] = {.lex_state = 347},
  [6210] = {.lex_state = 193, .external_lex_state = 31},
  [6211] = {.lex_state = 193, .external_lex_state = 25},
  [6212] = {.lex_state = 133, .external_lex_state = 5},
  [6213] = {.lex_state = 133, .external_lex_state = 5},
  [6214] = {.lex_state = 193, .external_lex_state = 31},
  [6215] = {.lex_state = 347, .external_lex_state = 31},
  [6216] = {.lex_state = 347},
  [6217] = {.lex_state = 193, .external_lex_state = 25},
  [6218] = {.lex_state = 133, .external_lex_state = 5},
  [6219] = {.lex_state = 193, .external_lex_state = 31},
  [6220] = {.lex_state = 347},
  [6221] = {.lex_state = 347, .external_lex_state = 31},
  [6222] = {.lex_state = 347, .external_lex_state = 31},
  [6223] = {.lex_state = 133, .external_lex_state = 4},
  [6224] = {.lex_state = 133, .external_lex_state = 4},
  [6225] = {.lex_state = 193, .external_lex_state = 25},
  [6226] = {.lex_state = 133, .external_lex_state = 4},
  [6227] = {.lex_state = 133, .external_lex_state = 4},
  [6228] = {.lex_state = 347},
  [6229] = {.lex_state = 133, .external_lex_state = 4},
  [6230] = {.lex_state = 133, .external_lex_state = 4},
  [6231] = {.lex_state = 347},
  [6232] = {.lex_state = 193, .external_lex_state = 25},
  [6233] = {.lex_state = 133, .external_lex_state = 4},
  [6234] = {.lex_state = 133, .external_lex_state = 2},
  [6235] = {.lex_state = 133, .external_lex_state = 4},
  [6236] = {.lex_state = 347},
  [6237] = {.lex_state = 347},
  [6238] = {.lex_state = 347},
  [6239] = {.lex_state = 347},
  [6240] = {.lex_state = 193, .external_lex_state = 31},
  [6241] = {.lex_state = 133, .external_lex_state = 2},
  [6242] = {.lex_state = 347},
  [6243] = {.lex_state = 347},
  [6244] = {.lex_state = 347},
  [6245] = {.lex_state = 347},
  [6246] = {.lex_state = 133, .external_lex_state = 7},
  [6247] = {.lex_state = 347},
  [6248] = {.lex_state = 347},
  [6249] = {.lex_state = 133, .external_lex_state = 2},
  [6250] = {.lex_state = 347},
  [6251] = {.lex_state = 193, .external_lex_state = 25},
  [6252] = {.lex_state = 347},
  [6253] = {.lex_state = 347},
  [6254] = {.lex_state = 347, .external_lex_state = 31},
  [6255] = {.lex_state = 193, .external_lex_state = 31},
  [6256] = {.lex_state = 347},
  [6257] = {.lex_state = 347},
  [6258] = {.lex_state = 193, .external_lex_state = 31},
  [6259] = {.lex_state = 347},
  [6260] = {.lex_state = 347},
  [6261] = {.lex_state = 347},
  [6262] = {.lex_state = 347},
  [6263] = {.lex_state = 347, .external_lex_state = 31},
  [6264] = {.lex_state = 347},
  [6265] = {.lex_state = 347, .external_lex_state = 31},
  [6266] = {.lex_state = 133, .external_lex_state = 5},
  [6267] = {.lex_state = 347},
  [6268] = {.lex_state = 347},
  [6269] = {.lex_state = 347},
  [6270] = {.lex_state = 193, .external_lex_state = 31},
  [6271] = {.lex_state = 193, .external_lex_state = 31},
  [6272] = {.lex_state = 347, .external_lex_state = 31},
  [6273] = {.lex_state = 193, .external_lex_state = 25},
  [6274] = {.lex_state = 347, .external_lex_state = 31},
  [6275] = {.lex_state = 347, .external_lex_state = 31},
  [6276] = {.lex_state = 347},
  [6277] = {.lex_state = 133, .external_lex_state = 7},
  [6278] = {.lex_state = 347, .external_lex_state = 31},
  [6279] = {.lex_state = 133, .external_lex_state = 7},
  [6280] = {.lex_state = 347, .external_lex_state = 31},
  [6281] = {.lex_state = 347},
  [6282] = {.lex_state = 347},
  [6283] = {.lex_state = 347, .external_lex_state = 31},
  [6284] = {.lex_state = 347},
  [6285] = {.lex_state = 347},
  [6286] = {.lex_state = 193, .external_lex_state = 25},
  [6287] = {.lex_state = 347},
  [6288] = {.lex_state = 347},
  [6289] = {.lex_state = 133, .external_lex_state = 11},
  [6290] = {.lex_state = 347, .external_lex_state = 31},
  [6291] = {.lex_state = 347},
  [6292] = {.lex_state = 347},
  [6293] = {.lex_state = 133, .external_lex_state = 2},
  [6294] = {.lex_state = 347},
  [6295] = {.lex_state = 347, .external_lex_state = 31},
  [6296] = {.lex_state = 193, .external_lex_state = 31},
  [6297] = {.lex_state = 347, .external_lex_state = 31},
  [6298] = {.lex_state = 347},
  [6299] = {.lex_state = 347, .external_lex_state = 31},
  [6300] = {.lex_state = 193, .external_lex_state = 25},
  [6301] = {.lex_state = 347},
  [6302] = {.lex_state = 347, .external_lex_state = 31},
  [6303] = {.lex_state = 193, .external_lex_state = 25},
  [6304] = {.lex_state = 347, .external_lex_state = 31},
  [6305] = {.lex_state = 193, .external_lex_state = 25},
  [6306] = {.lex_state = 133, .external_lex_state = 2},
  [6307] = {.lex_state = 347},
  [6308] = {.lex_state = 189, .external_lex_state = 25},
  [6309] = {.lex_state = 193, .external_lex_state = 31},
  [6310] = {.lex_state = 133, .external_lex_state = 4},
  [6311] = {.lex_state = 193, .external_lex_state = 31},
  [6312] = {.lex_state = 133, .external_lex_state = 7},
  [6313] = {.lex_state = 133, .external_lex_state = 2},
  [6314] = {.lex_state = 193, .external_lex_state = 31},
  [6315] = {.lex_state = 133, .external_lex_state = 4},
  [6316] = {.lex_state = 347},
  [6317] = {.lex_state = 133, .external_lex_state = 4},
  [6318] = {.lex_state = 193, .external_lex_state = 31},
  [6319] = {.lex_state = 133, .external_lex_state = 4},
  [6320] = {.lex_state = 133, .external_lex_state = 4},
  [6321] = {.lex_state = 193, .external_lex_state = 31},
  [6322] = {.lex_state = 133, .external_lex_state = 4},
  [6323] = {.lex_state = 133, .external_lex_state = 4},
  [6324] = {.lex_state = 193, .external_lex_state = 25},
  [6325] = {.lex_state = 133, .external_lex_state = 4},
  [6326] = {.lex_state = 133, .external_lex_state = 2},
  [6327] = {.lex_state = 133, .external_lex_state = 4},
  [6328] = {.lex_state = 347},
  [6329] = {.lex_state = 193, .external_lex_state = 25},
  [6330] = {.lex_state = 133},
  [6331] = {.lex_state = 193, .external_lex_state = 31},
  [6332] = {.lex_state = 133, .external_lex_state = 4},
  [6333] = {.lex_state = 133, .external_lex_state = 4},
  [6334] = {.lex_state = 347},
  [6335] = {.lex_state = 193, .external_lex_state = 25},
  [6336] = {.lex_state = 193, .external_lex_state = 25},
  [6337] = {.lex_state = 133, .external_lex_state = 4},
  [6338] = {.lex_state = 133, .external_lex_state = 11},
  [6339] = {.lex_state = 133, .external_lex_state = 4},
  [6340] = {.lex_state = 133, .external_lex_state = 8},
  [6341] = {.lex_state = 133, .external_lex_state = 4},
  [6342] = {.lex_state = 133, .external_lex_state = 4},
  [6343] = {.lex_state = 133, .external_lex_state = 4},
  [6344] = {.lex_state = 133, .external_lex_state = 4},
  [6345] = {.lex_state = 133, .external_lex_state = 4},
  [6346] = {.lex_state = 133, .external_lex_state = 4},
  [6347] = {.lex_state = 133, .external_lex_state = 4},
  [6348] = {.lex_state = 133, .external_lex_state = 7},
  [6349] = {.lex_state = 133, .external_lex_state = 4},
  [6350] = {.lex_state = 133, .external_lex_state = 4},
  [6351] = {.lex_state = 133, .external_lex_state = 4},
  [6352] = {.lex_state = 133, .external_lex_state = 8},
  [6353] = {.lex_state = 133, .external_lex_state = 4},
  [6354] = {.lex_state = 133, .external_lex_state = 4},
  [6355] = {.lex_state = 193, .external_lex_state = 31},
  [6356] = {.lex_state = 133, .external_lex_state = 4},
  [6357] = {.lex_state = 193, .external_lex_state = 25},
  [6358] = {.lex_state = 133, .external_lex_state = 7},
  [6359] = {.lex_state = 133, .external_lex_state = 4},
  [6360] = {.lex_state = 193, .external_lex_state = 31},
  [6361] = {.lex_state = 347},
  [6362] = {.lex_state = 133, .external_lex_state = 4},
  [6363] = {.lex_state = 193, .external_lex_state = 31},
  [6364] = {.lex_state = 347},
  [6365] = {.lex_state = 133, .external_lex_state = 7},
  [6366] = {.lex_state = 133, .external_lex_state = 11},
  [6367] = {.lex_state = 133, .external_lex_state = 4},
  [6368] = {.lex_state = 133, .external_lex_state = 4},
  [6369] = {.lex_state = 133, .external_lex_state = 4},
  [6370] = {.lex_state = 133},
  [6371] = {.lex_state = 133, .external_lex_state = 4},
  [6372] = {.lex_state = 193, .external_lex_state = 25},
  [6373] = {.lex_state = 133, .external_lex_state = 4},
  [6374] = {.lex_state = 133, .external_lex_state = 4},
  [6375] = {.lex_state = 193, .external_lex_state = 25},
  [6376] = {.lex_state = 193, .external_lex_state = 25},
  [6377] = {.lex_state = 133, .external_lex_state = 4},
  [6378] = {.lex_state = 133, .external_lex_state = 4},
  [6379] = {.lex_state = 133, .external_lex_state = 4},
  [6380] = {.lex_state = 133, .external_lex_state = 11},
  [6381] = {.lex_state = 347},
  [6382] = {.lex_state = 133, .external_lex_state = 4},
  [6383] = {.lex_state = 133, .external_lex_state = 4},
  [6384] = {.lex_state = 133, .external_lex_state = 4},
  [6385] = {.lex_state = 133, .external_lex_state = 4},
  [6386] = {.lex_state = 133, .external_lex_state = 4},
  [6387] = {.lex_state = 133, .external_lex_state = 8},
  [6388] = {.lex_state = 133, .external_lex_state = 4},
  [6389] = {.lex_state = 182, .external_lex_state = 24},
  [6390] = {.lex_state = 133, .external_lex_state = 4},
  [6391] = {.lex_state = 133, .external_lex_state = 4},
  [6392] = {.lex_state = 133, .external_lex_state = 4},
  [6393] = {.lex_state = 133, .external_lex_state = 4},
  [6394] = {.lex_state = 133},
  [6395] = {.lex_state = 133, .external_lex_state = 8},
  [6396] = {.lex_state = 133, .external_lex_state = 4},
  [6397] = {.lex_state = 133, .external_lex_state = 4},
  [6398] = {.lex_state = 193, .external_lex_state = 31},
  [6399] = {.lex_state = 193, .external_lex_state = 25},
  [6400] = {.lex_state = 133, .external_lex_state = 4},
  [6401] = {.lex_state = 133, .external_lex_state = 11},
  [6402] = {.lex_state = 133, .external_lex_state = 4},
  [6403] = {.lex_state = 133, .external_lex_state = 8},
  [6404] = {.lex_state = 133, .external_lex_state = 8},
  [6405] = {.lex_state = 133, .external_lex_state = 2},
  [6406] = {.lex_state = 347},
  [6407] = {.lex_state = 133, .external_lex_state = 4},
  [6408] = {.lex_state = 193, .external_lex_state = 25},
  [6409] = {.lex_state = 133, .external_lex_state = 4},
  [6410] = {.lex_state = 133, .external_lex_state = 4},
  [6411] = {.lex_state = 133, .external_lex_state = 8},
  [6412] = {.lex_state = 133, .external_lex_state = 4},
  [6413] = {.lex_state = 133, .external_lex_state = 11},
  [6414] = {.lex_state = 133, .external_lex_state = 2},
  [6415] = {.lex_state = 133, .external_lex_state = 8},
  [6416] = {.lex_state = 193, .external_lex_state = 31},
  [6417] = {.lex_state = 193, .external_lex_state = 25},
  [6418] = {.lex_state = 133, .external_lex_state = 8},
  [6419] = {.lex_state = 133, .external_lex_state = 6},
  [6420] = {.lex_state = 133, .external_lex_state = 6},
  [6421] = {.lex_state = 183, .external_lex_state = 28},
  [6422] = {.lex_state = 183, .external_lex_state = 28},
  [6423] = {.lex_state = 133, .external_lex_state = 6},
  [6424] = {.lex_state = 183, .external_lex_state = 28},
  [6425] = {.lex_state = 133, .external_lex_state = 8},
  [6426] = {.lex_state = 133, .external_lex_state = 11},
  [6427] = {.lex_state = 183, .external_lex_state = 28},
  [6428] = {.lex_state = 182, .external_lex_state = 24},
  [6429] = {.lex_state = 133, .external_lex_state = 26},
  [6430] = {.lex_state = 133, .external_lex_state = 8},
  [6431] = {.lex_state = 133, .external_lex_state = 6},
  [6432] = {.lex_state = 133, .external_lex_state = 6},
  [6433] = {.lex_state = 347, .external_lex_state = 25},
  [6434] = {.lex_state = 193, .external_lex_state = 25},
  [6435] = {.lex_state = 193, .external_lex_state = 25},
  [6436] = {.lex_state = 133, .external_lex_state = 6},
  [6437] = {.lex_state = 133, .external_lex_state = 26},
  [6438] = {.lex_state = 133, .external_lex_state = 8},
  [6439] = {.lex_state = 182, .external_lex_state = 24},
  [6440] = {.lex_state = 182, .external_lex_state = 24},
  [6441] = {.lex_state = 133, .external_lex_state = 26},
  [6442] = {.lex_state = 133, .external_lex_state = 6},
  [6443] = {.lex_state = 182, .external_lex_state = 24},
  [6444] = {.lex_state = 133, .external_lex_state = 8},
  [6445] = {.lex_state = 133, .external_lex_state = 8},
  [6446] = {.lex_state = 133, .external_lex_state = 8},
  [6447] = {.lex_state = 133, .external_lex_state = 6},
  [6448] = {.lex_state = 133, .external_lex_state = 26},
  [6449] = {.lex_state = 183, .external_lex_state = 28},
  [6450] = {.lex_state = 133, .external_lex_state = 11},
  [6451] = {.lex_state = 183, .external_lex_state = 28},
  [6452] = {.lex_state = 133, .external_lex_state = 26},
  [6453] = {.lex_state = 133, .external_lex_state = 26},
  [6454] = {.lex_state = 133, .external_lex_state = 26},
  [6455] = {.lex_state = 182, .external_lex_state = 24},
  [6456] = {.lex_state = 133, .external_lex_state = 26},
  [6457] = {.lex_state = 133, .external_lex_state = 8},
  [6458] = {.lex_state = 133, .external_lex_state = 8},
  [6459] = {.lex_state = 133, .external_lex_state = 26},
  [6460] = {.lex_state = 183, .external_lex_state = 28},
  [6461] = {.lex_state = 133, .external_lex_state = 8},
  [6462] = {.lex_state = 347, .external_lex_state = 25},
  [6463] = {.lex_state = 133, .external_lex_state = 26},
  [6464] = {.lex_state = 133, .external_lex_state = 8},
  [6465] = {.lex_state = 133, .external_lex_state = 8},
  [6466] = {.lex_state = 133, .external_lex_state = 8},
  [6467] = {.lex_state = 133, .external_lex_state = 8},
  [6468] = {.lex_state = 133, .external_lex_state = 8},
  [6469] = {.lex_state = 133, .external_lex_state = 6},
  [6470] = {.lex_state = 133, .external_lex_state = 8},
  [6471] = {.lex_state = 133, .external_lex_state = 8},
  [6472] = {.lex_state = 133, .external_lex_state = 8},
  [6473] = {.lex_state = 133, .external_lex_state = 8},
  [6474] = {.lex_state = 193, .external_lex_state = 31},
  [6475] = {.lex_state = 182, .external_lex_state = 24},
  [6476] = {.lex_state = 193, .external_lex_state = 31},
  [6477] = {.lex_state = 133, .external_lex_state = 8},
  [6478] = {.lex_state = 133, .external_lex_state = 8},
  [6479] = {.lex_state = 133, .external_lex_state = 8},
  [6480] = {.lex_state = 133, .external_lex_state = 11},
  [6481] = {.lex_state = 133, .external_lex_state = 8},
  [6482] = {.lex_state = 133, .external_lex_state = 8},
  [6483] = {.lex_state = 133, .external_lex_state = 6},
  [6484] = {.lex_state = 133, .external_lex_state = 8},
  [6485] = {.lex_state = 133, .external_lex_state = 8},
  [6486] = {.lex_state = 133, .external_lex_state = 8},
  [6487] = {.lex_state = 133, .external_lex_state = 8},
  [6488] = {.lex_state = 193, .external_lex_state = 31},
  [6489] = {.lex_state = 193, .external_lex_state = 31},
  [6490] = {.lex_state = 133, .external_lex_state = 8},
  [6491] = {.lex_state = 133, .external_lex_state = 8},
  [6492] = {.lex_state = 133, .external_lex_state = 8},
  [6493] = {.lex_state = 133, .external_lex_state = 8},
  [6494] = {.lex_state = 133, .external_lex_state = 8},
  [6495] = {.lex_state = 133, .external_lex_state = 8},
  [6496] = {.lex_state = 133, .external_lex_state = 11},
  [6497] = {.lex_state = 133, .external_lex_state = 8},
  [6498] = {.lex_state = 133, .external_lex_state = 8},
  [6499] = {.lex_state = 182},
  [6500] = {.lex_state = 133, .external_lex_state = 6},
  [6501] = {.lex_state = 193, .external_lex_state = 25},
  [6502] = {.lex_state = 133, .external_lex_state = 8},
  [6503] = {.lex_state = 133, .external_lex_state = 8},
  [6504] = {.lex_state = 183, .external_lex_state = 28},
  [6505] = {.lex_state = 133, .external_lex_state = 8},
  [6506] = {.lex_state = 133, .external_lex_state = 8},
  [6507] = {.lex_state = 133, .external_lex_state = 8},
  [6508] = {.lex_state = 133, .external_lex_state = 8},
  [6509] = {.lex_state = 133, .external_lex_state = 8},
  [6510] = {.lex_state = 133, .external_lex_state = 8},
  [6511] = {.lex_state = 183, .external_lex_state = 28},
  [6512] = {.lex_state = 133, .external_lex_state = 8},
  [6513] = {.lex_state = 133, .external_lex_state = 8},
  [6514] = {.lex_state = 133, .external_lex_state = 26},
  [6515] = {.lex_state = 182, .external_lex_state = 24},
  [6516] = {.lex_state = 133, .external_lex_state = 26},
  [6517] = {.lex_state = 133, .external_lex_state = 6},
  [6518] = {.lex_state = 193, .external_lex_state = 25},
  [6519] = {.lex_state = 133, .external_lex_state = 8},
  [6520] = {.lex_state = 133, .external_lex_state = 8},
  [6521] = {.lex_state = 133, .external_lex_state = 11},
  [6522] = {.lex_state = 133, .external_lex_state = 8},
  [6523] = {.lex_state = 133, .external_lex_state = 8},
  [6524] = {.lex_state = 133, .external_lex_state = 8},
  [6525] = {.lex_state = 182, .external_lex_state = 25},
  [6526] = {.lex_state = 133, .external_lex_state = 26},
  [6527] = {.lex_state = 347, .external_lex_state = 25},
  [6528] = {.lex_state = 133, .external_lex_state = 8},
  [6529] = {.lex_state = 133, .external_lex_state = 8},
  [6530] = {.lex_state = 133, .external_lex_state = 8},
  [6531] = {.lex_state = 133, .external_lex_state = 11},
  [6532] = {.lex_state = 133, .external_lex_state = 8},
  [6533] = {.lex_state = 133, .external_lex_state = 6},
  [6534] = {.lex_state = 193, .external_lex_state = 25},
  [6535] = {.lex_state = 133, .external_lex_state = 9},
  [6536] = {.lex_state = 183, .external_lex_state = 30},
  [6537] = {.lex_state = 183, .external_lex_state = 29},
  [6538] = {.lex_state = 133, .external_lex_state = 9},
  [6539] = {.lex_state = 182},
  [6540] = {.lex_state = 133, .external_lex_state = 6},
  [6541] = {.lex_state = 183, .external_lex_state = 24},
  [6542] = {.lex_state = 183, .external_lex_state = 30},
  [6543] = {.lex_state = 133, .external_lex_state = 26},
  [6544] = {.lex_state = 133, .external_lex_state = 26},
  [6545] = {.lex_state = 183, .external_lex_state = 28},
  [6546] = {.lex_state = 183, .external_lex_state = 29},
  [6547] = {.lex_state = 133, .external_lex_state = 6},
  [6548] = {.lex_state = 183, .external_lex_state = 29},
  [6549] = {.lex_state = 183, .external_lex_state = 28},
  [6550] = {.lex_state = 193, .external_lex_state = 31},
  [6551] = {.lex_state = 133, .external_lex_state = 26},
  [6552] = {.lex_state = 183, .external_lex_state = 29},
  [6553] = {.lex_state = 133, .external_lex_state = 32},
  [6554] = {.lex_state = 193, .external_lex_state = 25},
  [6555] = {.lex_state = 193, .external_lex_state = 25},
  [6556] = {.lex_state = 133, .external_lex_state = 27},
  [6557] = {.lex_state = 193, .external_lex_state = 25},
  [6558] = {.lex_state = 193, .external_lex_state = 25},
  [6559] = {.lex_state = 193, .external_lex_state = 25},
  [6560] = {.lex_state = 182},
  [6561] = {.lex_state = 133, .external_lex_state = 27},
  [6562] = {.lex_state = 133, .external_lex_state = 26},
  [6563] = {.lex_state = 133, .external_lex_state = 6},
  [6564] = {.lex_state = 133, .external_lex_state = 27},
  [6565] = {.lex_state = 182, .external_lex_state = 25},
  [6566] = {.lex_state = 183, .external_lex_state = 28},
  [6567] = {.lex_state = 133, .external_lex_state = 6},
  [6568] = {.lex_state = 183, .external_lex_state = 28},
  [6569] = {.lex_state = 133, .external_lex_state = 6},
  [6570] = {.lex_state = 133, .external_lex_state = 6},
  [6571] = {.lex_state = 133, .external_lex_state = 2},
  [6572] = {.lex_state = 183, .external_lex_state = 29},
  [6573] = {.lex_state = 193, .external_lex_state = 25},
  [6574] = {.lex_state = 133, .external_lex_state = 27},
  [6575] = {.lex_state = 133, .external_lex_state = 27},
  [6576] = {.lex_state = 182},
  [6577] = {.lex_state = 133, .external_lex_state = 2},
  [6578] = {.lex_state = 183, .external_lex_state = 30},
  [6579] = {.lex_state = 133, .external_lex_state = 27},
  [6580] = {.lex_state = 133, .external_lex_state = 27},
  [6581] = {.lex_state = 133, .external_lex_state = 26},
  [6582] = {.lex_state = 133, .external_lex_state = 6},
  [6583] = {.lex_state = 133, .external_lex_state = 26},
  [6584] = {.lex_state = 133, .external_lex_state = 6},
  [6585] = {.lex_state = 133, .external_lex_state = 27},
  [6586] = {.lex_state = 133, .external_lex_state = 27},
  [6587] = {.lex_state = 133, .external_lex_state = 6},
  [6588] = {.lex_state = 133, .external_lex_state = 6},
  [6589] = {.lex_state = 133, .external_lex_state = 26},
  [6590] = {.lex_state = 133, .external_lex_state = 6},
  [6591] = {.lex_state = 133, .external_lex_state = 26},
  [6592] = {.lex_state = 133, .external_lex_state = 26},
  [6593] = {.lex_state = 133, .external_lex_state = 6},
  [6594] = {.lex_state = 133, .external_lex_state = 26},
  [6595] = {.lex_state = 133, .external_lex_state = 26},
  [6596] = {.lex_state = 133, .external_lex_state = 26},
  [6597] = {.lex_state = 133, .external_lex_state = 27},
  [6598] = {.lex_state = 183, .external_lex_state = 24},
  [6599] = {.lex_state = 133, .external_lex_state = 26},
  [6600] = {.lex_state = 193, .external_lex_state = 31},
  [6601] = {.lex_state = 133, .external_lex_state = 26},
  [6602] = {.lex_state = 133, .external_lex_state = 26},
  [6603] = {.lex_state = 193, .external_lex_state = 25},
  [6604] = {.lex_state = 193, .external_lex_state = 25},
  [6605] = {.lex_state = 182, .external_lex_state = 24},
  [6606] = {.lex_state = 133, .external_lex_state = 9},
  [6607] = {.lex_state = 133, .external_lex_state = 6},
  [6608] = {.lex_state = 133, .external_lex_state = 9},
  [6609] = {.lex_state = 133, .external_lex_state = 6},
  [6610] = {.lex_state = 133, .external_lex_state = 26},
  [6611] = {.lex_state = 183, .external_lex_state = 28},
  [6612] = {.lex_state = 193, .external_lex_state = 31},
  [6613] = {.lex_state = 133, .external_lex_state = 26},
  [6614] = {.lex_state = 133, .external_lex_state = 9},
  [6615] = {.lex_state = 133, .external_lex_state = 6},
  [6616] = {.lex_state = 133, .external_lex_state = 9},
  [6617] = {.lex_state = 133, .external_lex_state = 9},
  [6618] = {.lex_state = 133, .external_lex_state = 26},
  [6619] = {.lex_state = 133, .external_lex_state = 26},
  [6620] = {.lex_state = 133, .external_lex_state = 9},
  [6621] = {.lex_state = 133, .external_lex_state = 6},
  [6622] = {.lex_state = 133, .external_lex_state = 6},
  [6623] = {.lex_state = 133, .external_lex_state = 9},
  [6624] = {.lex_state = 183, .external_lex_state = 30},
  [6625] = {.lex_state = 133, .external_lex_state = 11},
  [6626] = {.lex_state = 133, .external_lex_state = 6},
  [6627] = {.lex_state = 183, .external_lex_state = 30},
  [6628] = {.lex_state = 133, .external_lex_state = 6},
  [6629] = {.lex_state = 133, .external_lex_state = 6},
  [6630] = {.lex_state = 133, .external_lex_state = 26},
  [6631] = {.lex_state = 183, .external_lex_state = 24},
  [6632] = {.lex_state = 183, .external_lex_state = 30},
  [6633] = {.lex_state = 183, .external_lex_state = 29},
  [6634] = {.lex_state = 133, .external_lex_state = 26},
  [6635] = {.lex_state = 133, .external_lex_state = 6},
  [6636] = {.lex_state = 133, .external_lex_state = 6},
  [6637] = {.lex_state = 183, .external_lex_state = 29},
  [6638] = {.lex_state = 133, .external_lex_state = 6},
  [6639] = {.lex_state = 133, .external_lex_state = 26},
  [6640] = {.lex_state = 133, .external_lex_state = 6},
  [6641] = {.lex_state = 133, .external_lex_state = 6},
  [6642] = {.lex_state = 133, .external_lex_state = 6},
  [6643] = {.lex_state = 133, .external_lex_state = 26},
  [6644] = {.lex_state = 133, .external_lex_state = 2},
  [6645] = {.lex_state = 133, .external_lex_state = 6},
  [6646] = {.lex_state = 133, .external_lex_state = 32},
  [6647] = {.lex_state = 193, .external_lex_state = 25},
  [6648] = {.lex_state = 182, .external_lex_state = 24},
  [6649] = {.lex_state = 182, .external_lex_state = 25},
  [6650] = {.lex_state = 133, .external_lex_state = 6},
  [6651] = {.lex_state = 133, .external_lex_state = 6},
  [6652] = {.lex_state = 133, .external_lex_state = 6},
  [6653] = {.lex_state = 181},
  [6654] = {.lex_state = 182, .external_lex_state = 25},
  [6655] = {.lex_state = 183, .external_lex_state = 24},
  [6656] = {.lex_state = 133, .external_lex_state = 26},
  [6657] = {.lex_state = 183, .external_lex_state = 30},
  [6658] = {.lex_state = 133, .external_lex_state = 6},
  [6659] = {.lex_state = 182, .external_lex_state = 24},
  [6660] = {.lex_state = 133, .external_lex_state = 2},
  [6661] = {.lex_state = 133, .external_lex_state = 6},
  [6662] = {.lex_state = 133, .external_lex_state = 26},
  [6663] = {.lex_state = 133, .external_lex_state = 26},
  [6664] = {.lex_state = 182},
  [6665] = {.lex_state = 133, .external_lex_state = 6},
  [6666] = {.lex_state = 133, .external_lex_state = 27},
  [6667] = {.lex_state = 193, .external_lex_state = 31},
  [6668] = {.lex_state = 133, .external_lex_state = 11},
  [6669] = {.lex_state = 183, .external_lex_state = 24},
  [6670] = {.lex_state = 193, .external_lex_state = 31},
  [6671] = {.lex_state = 133, .external_lex_state = 6},
  [6672] = {.lex_state = 182, .external_lex_state = 25},
  [6673] = {.lex_state = 182, .external_lex_state = 25},
  [6674] = {.lex_state = 133, .external_lex_state = 6},
  [6675] = {.lex_state = 133, .external_lex_state = 6},
  [6676] = {.lex_state = 133, .external_lex_state = 6},
  [6677] = {.lex_state = 133, .external_lex_state = 26},
  [6678] = {.lex_state = 133, .external_lex_state = 2},
  [6679] = {.lex_state = 193, .external_lex_state = 31},
  [6680] = {.lex_state = 133, .external_lex_state = 26},
  [6681] = {.lex_state = 182},
  [6682] = {.lex_state = 133, .external_lex_state = 6},
  [6683] = {.lex_state = 182},
  [6684] = {.lex_state = 133, .external_lex_state = 26},
  [6685] = {.lex_state = 133, .external_lex_state = 6},
  [6686] = {.lex_state = 133, .external_lex_state = 26},
  [6687] = {.lex_state = 133, .external_lex_state = 6},
  [6688] = {.lex_state = 133, .external_lex_state = 6},
  [6689] = {.lex_state = 183, .external_lex_state = 24},
  [6690] = {.lex_state = 182},
  [6691] = {.lex_state = 133, .external_lex_state = 26},
  [6692] = {.lex_state = 183, .external_lex_state = 24},
  [6693] = {.lex_state = 193, .external_lex_state = 31},
  [6694] = {.lex_state = 133, .external_lex_state = 27},
  [6695] = {.lex_state = 193, .external_lex_state = 31},
  [6696] = {.lex_state = 133, .external_lex_state = 32},
  [6697] = {.lex_state = 133, .external_lex_state = 26},
  [6698] = {.lex_state = 193, .external_lex_state = 31},
  [6699] = {.lex_state = 133, .external_lex_state = 9},
  [6700] = {.lex_state = 133, .external_lex_state = 27},
  [6701] = {.lex_state = 133, .external_lex_state = 26},
  [6702] = {.lex_state = 133, .external_lex_state = 26},
  [6703] = {.lex_state = 133, .external_lex_state = 26},
  [6704] = {.lex_state = 182, .external_lex_state = 25},
  [6705] = {.lex_state = 183, .external_lex_state = 30},
  [6706] = {.lex_state = 133, .external_lex_state = 26},
  [6707] = {.lex_state = 133, .external_lex_state = 11},
  [6708] = {.lex_state = 133, .external_lex_state = 6},
  [6709] = {.lex_state = 133, .external_lex_state = 2},
  [6710] = {.lex_state = 183, .external_lex_state = 24},
  [6711] = {.lex_state = 193, .external_lex_state = 31},
  [6712] = {.lex_state = 133, .external_lex_state = 26},
  [6713] = {.lex_state = 133, .external_lex_state = 6},
  [6714] = {.lex_state = 133, .external_lex_state = 6},
  [6715] = {.lex_state = 133, .external_lex_state = 26},
  [6716] = {.lex_state = 133, .external_lex_state = 26},
  [6717] = {.lex_state = 133, .external_lex_state = 6},
  [6718] = {.lex_state = 183, .external_lex_state = 30},
  [6719] = {.lex_state = 133, .external_lex_state = 6},
  [6720] = {.lex_state = 133, .external_lex_state = 2},
  [6721] = {.lex_state = 182, .external_lex_state = 24},
  [6722] = {.lex_state = 133, .external_lex_state = 26},
  [6723] = {.lex_state = 133, .external_lex_state = 26},
  [6724] = {.lex_state = 133, .external_lex_state = 2},
  [6725] = {.lex_state = 182},
  [6726] = {.lex_state = 133, .external_lex_state = 6},
  [6727] = {.lex_state = 133, .external_lex_state = 2},
  [6728] = {.lex_state = 182, .external_lex_state = 24},
  [6729] = {.lex_state = 193, .external_lex_state = 25},
  [6730] = {.lex_state = 193, .external_lex_state = 31},
  [6731] = {.lex_state = 133, .external_lex_state = 26},
  [6732] = {.lex_state = 133, .external_lex_state = 26},
  [6733] = {.lex_state = 193, .external_lex_state = 31},
  [6734] = {.lex_state = 133, .external_lex_state = 26},
  [6735] = {.lex_state = 133, .external_lex_state = 26},
  [6736] = {.lex_state = 182, .external_lex_state = 25},
  [6737] = {.lex_state = 133, .external_lex_state = 26},
  [6738] = {.lex_state = 133, .external_lex_state = 26},
  [6739] = {.lex_state = 183, .external_lex_state = 29},
  [6740] = {.lex_state = 133, .external_lex_state = 6},
  [6741] = {.lex_state = 133, .external_lex_state = 26},
  [6742] = {.lex_state = 193, .external_lex_state = 25},
  [6743] = {.lex_state = 183, .external_lex_state = 29},
  [6744] = {.lex_state = 182},
  [6745] = {.lex_state = 183, .external_lex_state = 30},
  [6746] = {.lex_state = 133, .external_lex_state = 9},
  [6747] = {.lex_state = 133, .external_lex_state = 9},
  [6748] = {.lex_state = 183, .external_lex_state = 29},
  [6749] = {.lex_state = 133, .external_lex_state = 9},
  [6750] = {.lex_state = 183, .external_lex_state = 30},
  [6751] = {.lex_state = 133, .external_lex_state = 9},
  [6752] = {.lex_state = 183},
  [6753] = {.lex_state = 133, .external_lex_state = 11},
  [6754] = {.lex_state = 133, .external_lex_state = 27},
  [6755] = {.lex_state = 133, .external_lex_state = 9},
  [6756] = {.lex_state = 133, .external_lex_state = 9},
  [6757] = {.lex_state = 133, .external_lex_state = 27},
  [6758] = {.lex_state = 183, .external_lex_state = 29},
  [6759] = {.lex_state = 133, .external_lex_state = 9},
  [6760] = {.lex_state = 191, .external_lex_state = 30},
  [6761] = {.lex_state = 133, .external_lex_state = 27},
  [6762] = {.lex_state = 133, .external_lex_state = 27},
  [6763] = {.lex_state = 133, .external_lex_state = 9},
  [6764] = {.lex_state = 133, .external_lex_state = 27},
  [6765] = {.lex_state = 182, .external_lex_state = 30},
  [6766] = {.lex_state = 347},
  [6767] = {.lex_state = 183},
  [6768] = {.lex_state = 181},
  [6769] = {.lex_state = 133, .external_lex_state = 9},
  [6770] = {.lex_state = 182},
  [6771] = {.lex_state = 133, .external_lex_state = 27},
  [6772] = {.lex_state = 133, .external_lex_state = 9},
  [6773] = {.lex_state = 182, .external_lex_state = 25},
  [6774] = {.lex_state = 347},
  [6775] = {.lex_state = 133, .external_lex_state = 9},
  [6776] = {.lex_state = 182, .external_lex_state = 24},
  [6777] = {.lex_state = 133, .external_lex_state = 9},
  [6778] = {.lex_state = 184, .external_lex_state = 31},
  [6779] = {.lex_state = 133, .external_lex_state = 32},
  [6780] = {.lex_state = 133, .external_lex_state = 9},
  [6781] = {.lex_state = 133, .external_lex_state = 11},
  [6782] = {.lex_state = 133, .external_lex_state = 11},
  [6783] = {.lex_state = 133, .external_lex_state = 27},
  [6784] = {.lex_state = 183, .external_lex_state = 28},
  [6785] = {.lex_state = 183, .external_lex_state = 30},
  [6786] = {.lex_state = 183},
  [6787] = {.lex_state = 133, .external_lex_state = 27},
  [6788] = {.lex_state = 181},
  [6789] = {.lex_state = 133, .external_lex_state = 11},
  [6790] = {.lex_state = 183, .external_lex_state = 30},
  [6791] = {.lex_state = 183, .external_lex_state = 30},
  [6792] = {.lex_state = 181},
  [6793] = {.lex_state = 183, .external_lex_state = 24},
  [6794] = {.lex_state = 183, .external_lex_state = 25},
  [6795] = {.lex_state = 183, .external_lex_state = 30},
  [6796] = {.lex_state = 347},
  [6797] = {.lex_state = 183, .external_lex_state = 25},
  [6798] = {.lex_state = 183, .external_lex_state = 25},
  [6799] = {.lex_state = 182, .external_lex_state = 24},
  [6800] = {.lex_state = 133, .external_lex_state = 11},
  [6801] = {.lex_state = 133, .external_lex_state = 27},
  [6802] = {.lex_state = 191, .external_lex_state = 30},
  [6803] = {.lex_state = 133, .external_lex_state = 27},
  [6804] = {.lex_state = 133, .external_lex_state = 9},
  [6805] = {.lex_state = 182, .external_lex_state = 30},
  [6806] = {.lex_state = 183, .external_lex_state = 24},
  [6807] = {.lex_state = 133, .external_lex_state = 9},
  [6808] = {.lex_state = 133, .external_lex_state = 9},
  [6809] = {.lex_state = 133, .external_lex_state = 27},
  [6810] = {.lex_state = 182, .external_lex_state = 30},
  [6811] = {.lex_state = 133, .external_lex_state = 27},
  [6812] = {.lex_state = 133, .external_lex_state = 27},
  [6813] = {.lex_state = 133, .external_lex_state = 27},
  [6814] = {.lex_state = 133, .external_lex_state = 9},
  [6815] = {.lex_state = 133, .external_lex_state = 9},
  [6816] = {.lex_state = 133, .external_lex_state = 9},
  [6817] = {.lex_state = 133, .external_lex_state = 27},
  [6818] = {.lex_state = 133, .external_lex_state = 9},
  [6819] = {.lex_state = 133, .external_lex_state = 9},
  [6820] = {.lex_state = 183, .external_lex_state = 30},
  [6821] = {.lex_state = 133, .external_lex_state = 9},
  [6822] = {.lex_state = 347},
  [6823] = {.lex_state = 181},
  [6824] = {.lex_state = 133, .external_lex_state = 27},
  [6825] = {.lex_state = 183, .external_lex_state = 28},
  [6826] = {.lex_state = 183, .external_lex_state = 25},
  [6827] = {.lex_state = 182},
  [6828] = {.lex_state = 183, .external_lex_state = 29},
  [6829] = {.lex_state = 133, .external_lex_state = 27},
  [6830] = {.lex_state = 183},
  [6831] = {.lex_state = 133, .external_lex_state = 27},
  [6832] = {.lex_state = 133, .external_lex_state = 27},
  [6833] = {.lex_state = 181},
  [6834] = {.lex_state = 191, .external_lex_state = 30},
  [6835] = {.lex_state = 133, .external_lex_state = 9},
  [6836] = {.lex_state = 182},
  [6837] = {.lex_state = 133, .external_lex_state = 27},
  [6838] = {.lex_state = 133, .external_lex_state = 9},
  [6839] = {.lex_state = 133, .external_lex_state = 27},
  [6840] = {.lex_state = 133, .external_lex_state = 9},
  [6841] = {.lex_state = 183, .external_lex_state = 24},
  [6842] = {.lex_state = 191, .external_lex_state = 30},
  [6843] = {.lex_state = 133, .external_lex_state = 9},
  [6844] = {.lex_state = 182, .external_lex_state = 30},
  [6845] = {.lex_state = 133, .external_lex_state = 27},
  [6846] = {.lex_state = 347},
  [6847] = {.lex_state = 133, .external_lex_state = 9},
  [6848] = {.lex_state = 191, .external_lex_state = 30},
  [6849] = {.lex_state = 183, .external_lex_state = 24},
  [6850] = {.lex_state = 191, .external_lex_state = 30},
  [6851] = {.lex_state = 133, .external_lex_state = 32},
  [6852] = {.lex_state = 133, .external_lex_state = 27},
  [6853] = {.lex_state = 182, .external_lex_state = 30},
  [6854] = {.lex_state = 133, .external_lex_state = 11},
  [6855] = {.lex_state = 133, .external_lex_state = 27},
  [6856] = {.lex_state = 133, .external_lex_state = 27},
  [6857] = {.lex_state = 191, .external_lex_state = 30},
  [6858] = {.lex_state = 182, .external_lex_state = 30},
  [6859] = {.lex_state = 181},
  [6860] = {.lex_state = 133, .external_lex_state = 27},
  [6861] = {.lex_state = 347},
  [6862] = {.lex_state = 133, .external_lex_state = 9},
  [6863] = {.lex_state = 133, .external_lex_state = 27},
  [6864] = {.lex_state = 133, .external_lex_state = 9},
  [6865] = {.lex_state = 183},
  [6866] = {.lex_state = 133, .external_lex_state = 27},
  [6867] = {.lex_state = 183, .external_lex_state = 25},
  [6868] = {.lex_state = 133, .external_lex_state = 27},
  [6869] = {.lex_state = 133, .external_lex_state = 27},
  [6870] = {.lex_state = 133, .external_lex_state = 27},
  [6871] = {.lex_state = 183, .external_lex_state = 25},
  [6872] = {.lex_state = 191, .external_lex_state = 30},
  [6873] = {.lex_state = 133, .external_lex_state = 27},
  [6874] = {.lex_state = 183, .external_lex_state = 24},
  [6875] = {.lex_state = 133, .external_lex_state = 27},
  [6876] = {.lex_state = 133, .external_lex_state = 9},
  [6877] = {.lex_state = 133, .external_lex_state = 9},
  [6878] = {.lex_state = 347},
  [6879] = {.lex_state = 133, .external_lex_state = 27},
  [6880] = {.lex_state = 182, .external_lex_state = 25},
  [6881] = {.lex_state = 133, .external_lex_state = 9},
  [6882] = {.lex_state = 133, .external_lex_state = 9},
  [6883] = {.lex_state = 182, .external_lex_state = 24},
  [6884] = {.lex_state = 182, .external_lex_state = 30},
  [6885] = {.lex_state = 182, .external_lex_state = 25},
  [6886] = {.lex_state = 133, .external_lex_state = 9},
  [6887] = {.lex_state = 133, .external_lex_state = 9},
  [6888] = {.lex_state = 183, .external_lex_state = 29},
  [6889] = {.lex_state = 133, .external_lex_state = 27},
  [6890] = {.lex_state = 133, .external_lex_state = 9},
  [6891] = {.lex_state = 183, .external_lex_state = 29},
  [6892] = {.lex_state = 181},
  [6893] = {.lex_state = 133, .external_lex_state = 32},
  [6894] = {.lex_state = 133, .external_lex_state = 27},
  [6895] = {.lex_state = 133, .external_lex_state = 27},
  [6896] = {.lex_state = 133, .external_lex_state = 9},
  [6897] = {.lex_state = 183},
  [6898] = {.lex_state = 182, .external_lex_state = 25},
  [6899] = {.lex_state = 191, .external_lex_state = 30},
  [6900] = {.lex_state = 183, .external_lex_state = 28},
  [6901] = {.lex_state = 133, .external_lex_state = 11},
  [6902] = {.lex_state = 133, .external_lex_state = 27},
  [6903] = {.lex_state = 133, .external_lex_state = 27},
  [6904] = {.lex_state = 182},
  [6905] = {.lex_state = 133, .external_lex_state = 9},
  [6906] = {.lex_state = 133, .external_lex_state = 9},
  [6907] = {.lex_state = 133, .external_lex_state = 27},
  [6908] = {.lex_state = 133, .external_lex_state = 27},
  [6909] = {.lex_state = 183, .external_lex_state = 28},
  [6910] = {.lex_state = 183},
  [6911] = {.lex_state = 133, .external_lex_state = 27},
  [6912] = {.lex_state = 133, .external_lex_state = 32},
  [6913] = {.lex_state = 133, .external_lex_state = 9},
  [6914] = {.lex_state = 182, .external_lex_state = 24},
  [6915] = {.lex_state = 347},
  [6916] = {.lex_state = 183, .external_lex_state = 25},
  [6917] = {.lex_state = 133, .external_lex_state = 9},
  [6918] = {.lex_state = 133, .external_lex_state = 9},
  [6919] = {.lex_state = 133, .external_lex_state = 27},
  [6920] = {.lex_state = 183},
  [6921] = {.lex_state = 182, .external_lex_state = 30},
  [6922] = {.lex_state = 182, .external_lex_state = 30},
  [6923] = {.lex_state = 133, .external_lex_state = 27},
  [6924] = {.lex_state = 183, .external_lex_state = 28},
  [6925] = {.lex_state = 133, .external_lex_state = 9},
  [6926] = {.lex_state = 182, .external_lex_state = 25},
  [6927] = {.lex_state = 133, .external_lex_state = 27},
  [6928] = {.lex_state = 133, .external_lex_state = 27},
  [6929] = {.lex_state = 182, .external_lex_state = 24},
  [6930] = {.lex_state = 182},
  [6931] = {.lex_state = 133, .external_lex_state = 11},
  [6932] = {.lex_state = 347},
  [6933] = {.lex_state = 133, .external_lex_state = 27},
  [6934] = {.lex_state = 133, .external_lex_state = 9},
  [6935] = {.lex_state = 133, .external_lex_state = 9},
  [6936] = {.lex_state = 133, .external_lex_state = 9},
  [6937] = {.lex_state = 133, .external_lex_state = 11},
  [6938] = {.lex_state = 133, .external_lex_state = 11},
  [6939] = {.lex_state = 133, .external_lex_state = 9},
  [6940] = {.lex_state = 183, .external_lex_state = 25},
  [6941] = {.lex_state = 133, .external_lex_state = 27},
  [6942] = {.lex_state = 183, .external_lex_state = 24},
  [6943] = {.lex_state = 181},
  [6944] = {.lex_state = 182, .external_lex_state = 30},
  [6945] = {.lex_state = 183},
  [6946] = {.lex_state = 133, .external_lex_state = 11},
  [6947] = {.lex_state = 182, .external_lex_state = 24},
  [6948] = {.lex_state = 182, .external_lex_state = 24},
  [6949] = {.lex_state = 183, .external_lex_state = 30},
  [6950] = {.lex_state = 133, .external_lex_state = 11},
  [6951] = {.lex_state = 183, .external_lex_state = 28},
  [6952] = {.lex_state = 183, .external_lex_state = 28},
  [6953] = {.lex_state = 133, .external_lex_state = 11},
  [6954] = {.lex_state = 133, .external_lex_state = 11},
  [6955] = {.lex_state = 182, .external_lex_state = 30},
  [6956] = {.lex_state = 133, .external_lex_state = 11},
  [6957] = {.lex_state = 133, .external_lex_state = 11},
  [6958] = {.lex_state = 183, .external_lex_state = 25},
  [6959] = {.lex_state = 133, .external_lex_state = 11},
  [6960] = {.lex_state = 183, .external_lex_state = 28},
  [6961] = {.lex_state = 133, .external_lex_state = 11},
  [6962] = {.lex_state = 133, .external_lex_state = 11},
  [6963] = {.lex_state = 191},
  [6964] = {.lex_state = 183, .external_lex_state = 25},
  [6965] = {.lex_state = 133, .external_lex_state = 11},
  [6966] = {.lex_state = 133, .external_lex_state = 11},
  [6967] = {.lex_state = 133, .external_lex_state = 11},
  [6968] = {.lex_state = 133, .external_lex_state = 11},
  [6969] = {.lex_state = 183, .external_lex_state = 29},
  [6970] = {.lex_state = 183, .external_lex_state = 28},
  [6971] = {.lex_state = 191},
  [6972] = {.lex_state = 133, .external_lex_state = 11},
  [6973] = {.lex_state = 133, .external_lex_state = 11},
  [6974] = {.lex_state = 183, .external_lex_state = 28},
  [6975] = {.lex_state = 133, .external_lex_state = 11},
  [6976] = {.lex_state = 133, .external_lex_state = 11},
  [6977] = {.lex_state = 191},
  [6978] = {.lex_state = 133, .external_lex_state = 11},
  [6979] = {.lex_state = 183, .external_lex_state = 28},
  [6980] = {.lex_state = 191},
  [6981] = {.lex_state = 133, .external_lex_state = 11},
  [6982] = {.lex_state = 133, .external_lex_state = 11},
  [6983] = {.lex_state = 182, .external_lex_state = 25},
  [6984] = {.lex_state = 133, .external_lex_state = 11},
  [6985] = {.lex_state = 133},
  [6986] = {.lex_state = 182, .external_lex_state = 25},
  [6987] = {.lex_state = 181},
  [6988] = {.lex_state = 191},
  [6989] = {.lex_state = 191},
  [6990] = {.lex_state = 182, .external_lex_state = 24},
  [6991] = {.lex_state = 133, .external_lex_state = 11},
  [6992] = {.lex_state = 183, .external_lex_state = 30},
  [6993] = {.lex_state = 183, .external_lex_state = 28},
  [6994] = {.lex_state = 181},
  [6995] = {.lex_state = 133, .external_lex_state = 11},
  [6996] = {.lex_state = 183, .external_lex_state = 29},
  [6997] = {.lex_state = 133, .external_lex_state = 11},
  [6998] = {.lex_state = 133, .external_lex_state = 11},
  [6999] = {.lex_state = 182, .external_lex_state = 24},
  [7000] = {.lex_state = 183, .external_lex_state = 24},
  [7001] = {.lex_state = 182, .external_lex_state = 24},
  [7002] = {.lex_state = 133, .external_lex_state = 11},
  [7003] = {.lex_state = 181},
  [7004] = {.lex_state = 182, .external_lex_state = 24},
  [7005] = {.lex_state = 183, .external_lex_state = 28},
  [7006] = {.lex_state = 133, .external_lex_state = 11},
  [7007] = {.lex_state = 133, .external_lex_state = 11},
  [7008] = {.lex_state = 191, .external_lex_state = 30},
  [7009] = {.lex_state = 183, .external_lex_state = 28},
  [7010] = {.lex_state = 191},
  [7011] = {.lex_state = 133, .external_lex_state = 11},
  [7012] = {.lex_state = 182, .external_lex_state = 24},
  [7013] = {.lex_state = 133, .external_lex_state = 11},
  [7014] = {.lex_state = 182},
  [7015] = {.lex_state = 183, .external_lex_state = 25},
  [7016] = {.lex_state = 182, .external_lex_state = 24},
  [7017] = {.lex_state = 182, .external_lex_state = 25},
  [7018] = {.lex_state = 133, .external_lex_state = 11},
  [7019] = {.lex_state = 183, .external_lex_state = 29},
  [7020] = {.lex_state = 182, .external_lex_state = 24},
  [7021] = {.lex_state = 182, .external_lex_state = 30},
  [7022] = {.lex_state = 191},
  [7023] = {.lex_state = 182, .external_lex_state = 30},
  [7024] = {.lex_state = 183},
  [7025] = {.lex_state = 182},
  [7026] = {.lex_state = 133},
  [7027] = {.lex_state = 183, .external_lex_state = 24},
  [7028] = {.lex_state = 133},
  [7029] = {.lex_state = 183, .external_lex_state = 24},
  [7030] = {.lex_state = 183},
  [7031] = {.lex_state = 191},
  [7032] = {.lex_state = 133, .external_lex_state = 11},
  [7033] = {.lex_state = 133},
  [7034] = {.lex_state = 133, .external_lex_state = 11},
  [7035] = {.lex_state = 347},
  [7036] = {.lex_state = 191, .external_lex_state = 30},
  [7037] = {.lex_state = 133, .external_lex_state = 11},
  [7038] = {.lex_state = 133},
  [7039] = {.lex_state = 133, .external_lex_state = 11},
  [7040] = {.lex_state = 133, .external_lex_state = 11},
  [7041] = {.lex_state = 183, .external_lex_state = 28},
  [7042] = {.lex_state = 183, .external_lex_state = 25},
  [7043] = {.lex_state = 183},
  [7044] = {.lex_state = 182},
  [7045] = {.lex_state = 181},
  [7046] = {.lex_state = 182},
  [7047] = {.lex_state = 182, .external_lex_state = 24},
  [7048] = {.lex_state = 182, .external_lex_state = 24},
  [7049] = {.lex_state = 191, .external_lex_state = 30},
  [7050] = {.lex_state = 182, .external_lex_state = 25},
  [7051] = {.lex_state = 183, .external_lex_state = 28},
  [7052] = {.lex_state = 182, .external_lex_state = 30},
  [7053] = {.lex_state = 191},
  [7054] = {.lex_state = 191, .external_lex_state = 30},
  [7055] = {.lex_state = 191},
  [7056] = {.lex_state = 183, .external_lex_state = 25},
  [7057] = {.lex_state = 183, .external_lex_state = 30},
  [7058] = {.lex_state = 133, .external_lex_state = 11},
  [7059] = {.lex_state = 191, .external_lex_state = 30},
  [7060] = {.lex_state = 133},
  [7061] = {.lex_state = 133, .external_lex_state = 11},
  [7062] = {.lex_state = 133, .external_lex_state = 11},
  [7063] = {.lex_state = 133},
  [7064] = {.lex_state = 181},
  [7065] = {.lex_state = 183, .external_lex_state = 28},
  [7066] = {.lex_state = 184},
  [7067] = {.lex_state = 183, .external_lex_state = 29},
  [7068] = {.lex_state = 182},
  [7069] = {.lex_state = 133, .external_lex_state = 11},
  [7070] = {.lex_state = 184},
  [7071] = {.lex_state = 133, .external_lex_state = 11},
  [7072] = {.lex_state = 133, .external_lex_state = 11},
  [7073] = {.lex_state = 133, .external_lex_state = 11},
  [7074] = {.lex_state = 182},
  [7075] = {.lex_state = 133, .external_lex_state = 11},
  [7076] = {.lex_state = 183, .external_lex_state = 24},
  [7077] = {.lex_state = 133},
  [7078] = {.lex_state = 183, .external_lex_state = 29},
  [7079] = {.lex_state = 183, .external_lex_state = 30},
  [7080] = {.lex_state = 183, .external_lex_state = 30},
  [7081] = {.lex_state = 133, .external_lex_state = 11},
  [7082] = {.lex_state = 181},
  [7083] = {.lex_state = 181},
  [7084] = {.lex_state = 182, .external_lex_state = 25},
  [7085] = {.lex_state = 183},
  [7086] = {.lex_state = 182, .external_lex_state = 24},
  [7087] = {.lex_state = 133, .external_lex_state = 11},
  [7088] = {.lex_state = 133, .external_lex_state = 11},
  [7089] = {.lex_state = 183, .external_lex_state = 30},
  [7090] = {.lex_state = 183, .external_lex_state = 24},
  [7091] = {.lex_state = 181},
  [7092] = {.lex_state = 191, .external_lex_state = 30},
  [7093] = {.lex_state = 183, .external_lex_state = 24},
  [7094] = {.lex_state = 183, .external_lex_state = 24},
  [7095] = {.lex_state = 182, .external_lex_state = 30},
  [7096] = {.lex_state = 182, .external_lex_state = 30},
  [7097] = {.lex_state = 193},
  [7098] = {.lex_state = 183},
  [7099] = {.lex_state = 181, .external_lex_state = 30},
  [7100] = {.lex_state = 133},
  [7101] = {.lex_state = 181, .external_lex_state = 30},
  [7102] = {.lex_state = 186},
  [7103] = {.lex_state = 183},
  [7104] = {.lex_state = 182, .external_lex_state = 30},
  [7105] = {.lex_state = 191, .external_lex_state = 30},
  [7106] = {.lex_state = 183, .external_lex_state = 24},
  [7107] = {.lex_state = 183, .external_lex_state = 25},
  [7108] = {.lex_state = 183, .external_lex_state = 29},
  [7109] = {.lex_state = 133},
  [7110] = {.lex_state = 183, .external_lex_state = 29},
  [7111] = {.lex_state = 183, .external_lex_state = 24},
  [7112] = {.lex_state = 133},
  [7113] = {.lex_state = 181, .external_lex_state = 30},
  [7114] = {.lex_state = 184},
  [7115] = {.lex_state = 186},
  [7116] = {.lex_state = 183, .external_lex_state = 29},
  [7117] = {.lex_state = 183},
  [7118] = {.lex_state = 133},
  [7119] = {.lex_state = 183, .external_lex_state = 24},
  [7120] = {.lex_state = 184},
  [7121] = {.lex_state = 191, .external_lex_state = 30},
  [7122] = {.lex_state = 182, .external_lex_state = 30},
  [7123] = {.lex_state = 181},
  [7124] = {.lex_state = 184},
  [7125] = {.lex_state = 186},
  [7126] = {.lex_state = 181, .external_lex_state = 30},
  [7127] = {.lex_state = 183, .external_lex_state = 30},
  [7128] = {.lex_state = 183, .external_lex_state = 29},
  [7129] = {.lex_state = 183, .external_lex_state = 29},
  [7130] = {.lex_state = 183, .external_lex_state = 30},
  [7131] = {.lex_state = 183, .external_lex_state = 30},
  [7132] = {.lex_state = 182},
  [7133] = {.lex_state = 182, .external_lex_state = 25},
  [7134] = {.lex_state = 182, .external_lex_state = 25},
  [7135] = {.lex_state = 182, .external_lex_state = 25},
  [7136] = {.lex_state = 191},
  [7137] = {.lex_state = 181},
  [7138] = {.lex_state = 182},
  [7139] = {.lex_state = 181, .external_lex_state = 30},
  [7140] = {.lex_state = 182},
  [7141] = {.lex_state = 182},
  [7142] = {.lex_state = 182, .external_lex_state = 25},
  [7143] = {.lex_state = 183, .external_lex_state = 30},
  [7144] = {.lex_state = 183, .external_lex_state = 30},
  [7145] = {.lex_state = 182, .external_lex_state = 30},
  [7146] = {.lex_state = 183, .external_lex_state = 24},
  [7147] = {.lex_state = 183, .external_lex_state = 30},
  [7148] = {.lex_state = 183, .external_lex_state = 30},
  [7149] = {.lex_state = 183, .external_lex_state = 29},
  [7150] = {.lex_state = 183, .external_lex_state = 29},
  [7151] = {.lex_state = 191, .external_lex_state = 30},
  [7152] = {.lex_state = 182, .external_lex_state = 25},
  [7153] = {.lex_state = 183, .external_lex_state = 24},
  [7154] = {.lex_state = 183, .external_lex_state = 30},
  [7155] = {.lex_state = 182, .external_lex_state = 25},
  [7156] = {.lex_state = 183, .external_lex_state = 29},
  [7157] = {.lex_state = 133},
  [7158] = {.lex_state = 183},
  [7159] = {.lex_state = 181},
  [7160] = {.lex_state = 167, .external_lex_state = 31},
  [7161] = {.lex_state = 182, .external_lex_state = 25},
  [7162] = {.lex_state = 133},
  [7163] = {.lex_state = 181},
  [7164] = {.lex_state = 182, .external_lex_state = 25},
  [7165] = {.lex_state = 183},
  [7166] = {.lex_state = 183, .external_lex_state = 29},
  [7167] = {.lex_state = 191},
  [7168] = {.lex_state = 182},
  [7169] = {.lex_state = 182},
  [7170] = {.lex_state = 133},
  [7171] = {.lex_state = 182, .external_lex_state = 25},
  [7172] = {.lex_state = 133},
  [7173] = {.lex_state = 182},
  [7174] = {.lex_state = 182, .external_lex_state = 25},
  [7175] = {.lex_state = 181},
  [7176] = {.lex_state = 182, .external_lex_state = 25},
  [7177] = {.lex_state = 183, .external_lex_state = 25},
  [7178] = {.lex_state = 182, .external_lex_state = 25},
  [7179] = {.lex_state = 191},
  [7180] = {.lex_state = 133},
  [7181] = {.lex_state = 183, .external_lex_state = 25},
  [7182] = {.lex_state = 183, .external_lex_state = 24},
  [7183] = {.lex_state = 182},
  [7184] = {.lex_state = 182},
  [7185] = {.lex_state = 183, .external_lex_state = 24},
  [7186] = {.lex_state = 182},
  [7187] = {.lex_state = 193},
  [7188] = {.lex_state = 182},
  [7189] = {.lex_state = 183, .external_lex_state = 29},
  [7190] = {.lex_state = 183, .external_lex_state = 30},
  [7191] = {.lex_state = 183, .external_lex_state = 24},
  [7192] = {.lex_state = 183, .external_lex_state = 30},
  [7193] = {.lex_state = 183, .external_lex_state = 25},
  [7194] = {.lex_state = 181, .external_lex_state = 30},
  [7195] = {.lex_state = 183, .external_lex_state = 29},
  [7196] = {.lex_state = 183, .external_lex_state = 25},
  [7197] = {.lex_state = 181},
  [7198] = {.lex_state = 183, .external_lex_state = 29},
  [7199] = {.lex_state = 183, .external_lex_state = 30},
  [7200] = {.lex_state = 183, .external_lex_state = 24},
  [7201] = {.lex_state = 191, .external_lex_state = 30},
  [7202] = {.lex_state = 181, .external_lex_state = 30},
  [7203] = {.lex_state = 182},
  [7204] = {.lex_state = 135, .external_lex_state = 33},
  [7205] = {.lex_state = 135, .external_lex_state = 33},
  [7206] = {.lex_state = 191},
  [7207] = {.lex_state = 183, .external_lex_state = 25},
  [7208] = {.lex_state = 135, .external_lex_state = 33},
  [7209] = {.lex_state = 135, .external_lex_state = 33},
  [7210] = {.lex_state = 347, .external_lex_state = 34},
  [7211] = {.lex_state = 135, .external_lex_state = 33},
  [7212] = {.lex_state = 183, .external_lex_state = 25},
  [7213] = {.lex_state = 135, .external_lex_state = 33},
  [7214] = {.lex_state = 183},
  [7215] = {.lex_state = 183, .external_lex_state = 25},
  [7216] = {.lex_state = 181},
  [7217] = {.lex_state = 191},
  [7218] = {.lex_state = 181},
  [7219] = {.lex_state = 183},
  [7220] = {.lex_state = 183, .external_lex_state = 25},
  [7221] = {.lex_state = 183},
  [7222] = {.lex_state = 135, .external_lex_state = 33},
  [7223] = {.lex_state = 135, .external_lex_state = 33},
  [7224] = {.lex_state = 183, .external_lex_state = 25},
  [7225] = {.lex_state = 135, .external_lex_state = 33},
  [7226] = {.lex_state = 181},
  [7227] = {.lex_state = 193},
  [7228] = {.lex_state = 183, .external_lex_state = 25},
  [7229] = {.lex_state = 135, .external_lex_state = 33},
  [7230] = {.lex_state = 193},
  [7231] = {.lex_state = 183, .external_lex_state = 25},
  [7232] = {.lex_state = 183, .external_lex_state = 25},
  [7233] = {.lex_state = 183, .external_lex_state = 25},
  [7234] = {.lex_state = 135, .external_lex_state = 33},
  [7235] = {.lex_state = 135, .external_lex_state = 33},
  [7236] = {.lex_state = 135, .external_lex_state = 33},
  [7237] = {.lex_state = 135, .external_lex_state = 33},
  [7238] = {.lex_state = 135, .external_lex_state = 33},
  [7239] = {.lex_state = 183, .external_lex_state = 25},
  [7240] = {.lex_state = 183, .external_lex_state = 25},
  [7241] = {.lex_state = 347, .external_lex_state = 29},
  [7242] = {.lex_state = 135, .external_lex_state = 33},
  [7243] = {.lex_state = 181},
  [7244] = {.lex_state = 135, .external_lex_state = 33},
  [7245] = {.lex_state = 135, .external_lex_state = 33},
  [7246] = {.lex_state = 133},
  [7247] = {.lex_state = 183},
  [7248] = {.lex_state = 191},
  [7249] = {.lex_state = 183},
  [7250] = {.lex_state = 181},
  [7251] = {.lex_state = 183},
  [7252] = {.lex_state = 182, .external_lex_state = 30},
  [7253] = {.lex_state = 191, .external_lex_state = 30},
  [7254] = {.lex_state = 135, .external_lex_state = 33},
  [7255] = {.lex_state = 135, .external_lex_state = 33},
  [7256] = {.lex_state = 182, .external_lex_state = 30},
  [7257] = {.lex_state = 133},
  [7258] = {.lex_state = 135, .external_lex_state = 33},
  [7259] = {.lex_state = 135, .external_lex_state = 33},
  [7260] = {.lex_state = 135, .external_lex_state = 33},
  [7261] = {.lex_state = 181},
  [7262] = {.lex_state = 182, .external_lex_state = 30},
  [7263] = {.lex_state = 183},
  [7264] = {.lex_state = 181},
  [7265] = {.lex_state = 135, .external_lex_state = 33},
  [7266] = {.lex_state = 183},
  [7267] = {.lex_state = 181},
  [7268] = {.lex_state = 183, .external_lex_state = 25},
  [7269] = {.lex_state = 135, .external_lex_state = 33},
  [7270] = {.lex_state = 181},
  [7271] = {.lex_state = 135, .external_lex_state = 33},
  [7272] = {.lex_state = 191, .external_lex_state = 30},
  [7273] = {.lex_state = 135, .external_lex_state = 33},
  [7274] = {.lex_state = 135, .external_lex_state = 33},
  [7275] = {.lex_state = 135, .external_lex_state = 33},
  [7276] = {.lex_state = 184},
  [7277] = {.lex_state = 135, .external_lex_state = 33},
  [7278] = {.lex_state = 135, .external_lex_state = 33},
  [7279] = {.lex_state = 191},
  [7280] = {.lex_state = 135, .external_lex_state = 33},
  [7281] = {.lex_state = 181},
  [7282] = {.lex_state = 135, .external_lex_state = 33},
  [7283] = {.lex_state = 347, .external_lex_state = 29},
  [7284] = {.lex_state = 135, .external_lex_state = 33},
  [7285] = {.lex_state = 135, .external_lex_state = 33},
  [7286] = {.lex_state = 182, .external_lex_state = 30},
  [7287] = {.lex_state = 193},
  [7288] = {.lex_state = 135, .external_lex_state = 33},
  [7289] = {.lex_state = 182, .external_lex_state = 30},
  [7290] = {.lex_state = 181},
  [7291] = {.lex_state = 347, .external_lex_state = 34},
  [7292] = {.lex_state = 135, .external_lex_state = 33},
  [7293] = {.lex_state = 183},
  [7294] = {.lex_state = 181},
  [7295] = {.lex_state = 135, .external_lex_state = 33},
  [7296] = {.lex_state = 135, .external_lex_state = 33},
  [7297] = {.lex_state = 183},
  [7298] = {.lex_state = 347, .external_lex_state = 34},
  [7299] = {.lex_state = 347, .external_lex_state = 29},
  [7300] = {.lex_state = 191, .external_lex_state = 30},
  [7301] = {.lex_state = 135, .external_lex_state = 33},
  [7302] = {.lex_state = 135, .external_lex_state = 33},
  [7303] = {.lex_state = 133},
  [7304] = {.lex_state = 135, .external_lex_state = 33},
  [7305] = {.lex_state = 135, .external_lex_state = 33},
  [7306] = {.lex_state = 135, .external_lex_state = 33},
  [7307] = {.lex_state = 191, .external_lex_state = 30},
  [7308] = {.lex_state = 193},
  [7309] = {.lex_state = 135, .external_lex_state = 33},
  [7310] = {.lex_state = 135, .external_lex_state = 33},
  [7311] = {.lex_state = 135, .external_lex_state = 33},
  [7312] = {.lex_state = 135, .external_lex_state = 33},
  [7313] = {.lex_state = 191, .external_lex_state = 30},
  [7314] = {.lex_state = 182, .external_lex_state = 30},
  [7315] = {.lex_state = 191, .external_lex_state = 30},
  [7316] = {.lex_state = 191, .external_lex_state = 30},
  [7317] = {.lex_state = 191, .external_lex_state = 30},
  [7318] = {.lex_state = 182, .external_lex_state = 30},
  [7319] = {.lex_state = 191, .external_lex_state = 30},
  [7320] = {.lex_state = 135, .external_lex_state = 33},
  [7321] = {.lex_state = 135, .external_lex_state = 33},
  [7322] = {.lex_state = 182, .external_lex_state = 30},
  [7323] = {.lex_state = 193},
  [7324] = {.lex_state = 186},
  [7325] = {.lex_state = 182, .external_lex_state = 30},
  [7326] = {.lex_state = 191, .external_lex_state = 30},
  [7327] = {.lex_state = 191, .external_lex_state = 30},
  [7328] = {.lex_state = 135, .external_lex_state = 33},
  [7329] = {.lex_state = 193},
  [7330] = {.lex_state = 182, .external_lex_state = 30},
  [7331] = {.lex_state = 193},
  [7332] = {.lex_state = 183},
  [7333] = {.lex_state = 182, .external_lex_state = 30},
  [7334] = {.lex_state = 135, .external_lex_state = 33},
  [7335] = {.lex_state = 191, .external_lex_state = 30},
  [7336] = {.lex_state = 135, .external_lex_state = 33},
  [7337] = {.lex_state = 183},
  [7338] = {.lex_state = 135, .external_lex_state = 33},
  [7339] = {.lex_state = 182, .external_lex_state = 30},
  [7340] = {.lex_state = 135, .external_lex_state = 33},
  [7341] = {.lex_state = 175, .external_lex_state = 33},
  [7342] = {.lex_state = 175, .external_lex_state = 33},
  [7343] = {.lex_state = 175, .external_lex_state = 33},
  [7344] = {.lex_state = 347, .external_lex_state = 34},
  [7345] = {.lex_state = 133},
  [7346] = {.lex_state = 175, .external_lex_state = 33},
  [7347] = {.lex_state = 184, .external_lex_state = 24},
  [7348] = {.lex_state = 347, .external_lex_state = 25},
  [7349] = {.lex_state = 175, .external_lex_state = 33},
  [7350] = {.lex_state = 133},
  [7351] = {.lex_state = 184},
  [7352] = {.lex_state = 175, .external_lex_state = 33},
  [7353] = {.lex_state = 133},
  [7354] = {.lex_state = 184},
  [7355] = {.lex_state = 175, .external_lex_state = 33},
  [7356] = {.lex_state = 175, .external_lex_state = 33},
  [7357] = {.lex_state = 347, .external_lex_state = 31},
  [7358] = {.lex_state = 347, .external_lex_state = 31},
  [7359] = {.lex_state = 175, .external_lex_state = 33},
  [7360] = {.lex_state = 184},
  [7361] = {.lex_state = 191},
  [7362] = {.lex_state = 175, .external_lex_state = 33},
  [7363] = {.lex_state = 175, .external_lex_state = 33},
  [7364] = {.lex_state = 184},
  [7365] = {.lex_state = 184},
  [7366] = {.lex_state = 184},
  [7367] = {.lex_state = 175, .external_lex_state = 33},
  [7368] = {.lex_state = 175, .external_lex_state = 33},
  [7369] = {.lex_state = 175, .external_lex_state = 33},
  [7370] = {.lex_state = 184},
  [7371] = {.lex_state = 184},
  [7372] = {.lex_state = 184},
  [7373] = {.lex_state = 175, .external_lex_state = 33},
  [7374] = {.lex_state = 133},
  [7375] = {.lex_state = 175, .external_lex_state = 33},
  [7376] = {.lex_state = 175, .external_lex_state = 33},
  [7377] = {.lex_state = 347, .external_lex_state = 34},
  [7378] = {.lex_state = 184},
  [7379] = {.lex_state = 347, .external_lex_state = 25},
  [7380] = {.lex_state = 175, .external_lex_state = 33},
  [7381] = {.lex_state = 133},
  [7382] = {.lex_state = 184, .external_lex_state = 24},
  [7383] = {.lex_state = 193},
  [7384] = {.lex_state = 133},
  [7385] = {.lex_state = 347, .external_lex_state = 29},
  [7386] = {.lex_state = 184},
  [7387] = {.lex_state = 184},
  [7388] = {.lex_state = 184},
  [7389] = {.lex_state = 133},
  [7390] = {.lex_state = 175, .external_lex_state = 33},
  [7391] = {.lex_state = 175, .external_lex_state = 33},
  [7392] = {.lex_state = 191},
  [7393] = {.lex_state = 175, .external_lex_state = 33},
  [7394] = {.lex_state = 175, .external_lex_state = 33},
  [7395] = {.lex_state = 175, .external_lex_state = 33},
  [7396] = {.lex_state = 193},
  [7397] = {.lex_state = 347, .external_lex_state = 25},
  [7398] = {.lex_state = 175, .external_lex_state = 33},
  [7399] = {.lex_state = 175, .external_lex_state = 33},
  [7400] = {.lex_state = 184},
  [7401] = {.lex_state = 184},
  [7402] = {.lex_state = 184},
  [7403] = {.lex_state = 175, .external_lex_state = 33},
  [7404] = {.lex_state = 175, .external_lex_state = 33},
  [7405] = {.lex_state = 191},
  [7406] = {.lex_state = 175, .external_lex_state = 33},
  [7407] = {.lex_state = 184},
  [7408] = {.lex_state = 184},
  [7409] = {.lex_state = 347, .external_lex_state = 34},
  [7410] = {.lex_state = 133},
  [7411] = {.lex_state = 175, .external_lex_state = 33},
  [7412] = {.lex_state = 184},
  [7413] = {.lex_state = 184},
  [7414] = {.lex_state = 184},
  [7415] = {.lex_state = 184},
  [7416] = {.lex_state = 184},
  [7417] = {.lex_state = 191},
  [7418] = {.lex_state = 133},
  [7419] = {.lex_state = 184},
  [7420] = {.lex_state = 184},
  [7421] = {.lex_state = 175, .external_lex_state = 33},
  [7422] = {.lex_state = 347, .external_lex_state = 34},
  [7423] = {.lex_state = 347, .external_lex_state = 29},
  [7424] = {.lex_state = 191},
  [7425] = {.lex_state = 184},
  [7426] = {.lex_state = 175, .external_lex_state = 33},
  [7427] = {.lex_state = 347, .external_lex_state = 29},
  [7428] = {.lex_state = 347, .external_lex_state = 25},
  [7429] = {.lex_state = 175, .external_lex_state = 33},
  [7430] = {.lex_state = 347, .external_lex_state = 31},
  [7431] = {.lex_state = 184},
  [7432] = {.lex_state = 175, .external_lex_state = 33},
  [7433] = {.lex_state = 347, .external_lex_state = 31},
  [7434] = {.lex_state = 184},
  [7435] = {.lex_state = 347, .external_lex_state = 25},
  [7436] = {.lex_state = 184},
  [7437] = {.lex_state = 184},
  [7438] = {.lex_state = 184},
  [7439] = {.lex_state = 184},
  [7440] = {.lex_state = 175, .external_lex_state = 33},
  [7441] = {.lex_state = 175, .external_lex_state = 33},
  [7442] = {.lex_state = 184},
  [7443] = {.lex_state = 184},
  [7444] = {.lex_state = 175, .external_lex_state = 33},
  [7445] = {.lex_state = 184},
  [7446] = {.lex_state = 191},
  [7447] = {.lex_state = 184},
  [7448] = {.lex_state = 191},
  [7449] = {.lex_state = 191},
  [7450] = {.lex_state = 184},
  [7451] = {.lex_state = 184},
  [7452] = {.lex_state = 347, .external_lex_state = 25},
  [7453] = {.lex_state = 184},
  [7454] = {.lex_state = 347, .external_lex_state = 25},
  [7455] = {.lex_state = 184},
  [7456] = {.lex_state = 184},
  [7457] = {.lex_state = 175, .external_lex_state = 33},
  [7458] = {.lex_state = 184},
  [7459] = {.lex_state = 175, .external_lex_state = 33},
  [7460] = {.lex_state = 175, .external_lex_state = 33},
  [7461] = {.lex_state = 184},
  [7462] = {.lex_state = 347, .external_lex_state = 31},
  [7463] = {.lex_state = 347, .external_lex_state = 25},
  [7464] = {.lex_state = 193},
  [7465] = {.lex_state = 133},
  [7466] = {.lex_state = 347, .external_lex_state = 25},
  [7467] = {.lex_state = 175, .external_lex_state = 33},
  [7468] = {.lex_state = 184},
  [7469] = {.lex_state = 347, .external_lex_state = 31},
  [7470] = {.lex_state = 175, .external_lex_state = 33},
  [7471] = {.lex_state = 186, .external_lex_state = 24},
  [7472] = {.lex_state = 175, .external_lex_state = 33},
  [7473] = {.lex_state = 347, .external_lex_state = 31},
  [7474] = {.lex_state = 191},
  [7475] = {.lex_state = 184},
  [7476] = {.lex_state = 175, .external_lex_state = 33},
  [7477] = {.lex_state = 184},
  [7478] = {.lex_state = 191},
  [7479] = {.lex_state = 133},
  [7480] = {.lex_state = 133},
  [7481] = {.lex_state = 347, .external_lex_state = 29},
  [7482] = {.lex_state = 175, .external_lex_state = 33},
  [7483] = {.lex_state = 133},
  [7484] = {.lex_state = 175, .external_lex_state = 33},
  [7485] = {.lex_state = 193},
  [7486] = {.lex_state = 133},
  [7487] = {.lex_state = 175, .external_lex_state = 33},
  [7488] = {.lex_state = 133},
  [7489] = {.lex_state = 175, .external_lex_state = 33},
  [7490] = {.lex_state = 175, .external_lex_state = 33},
  [7491] = {.lex_state = 184},
  [7492] = {.lex_state = 175, .external_lex_state = 33},
  [7493] = {.lex_state = 347, .external_lex_state = 25},
  [7494] = {.lex_state = 175, .external_lex_state = 33},
  [7495] = {.lex_state = 186, .external_lex_state = 24},
  [7496] = {.lex_state = 133},
  [7497] = {.lex_state = 175, .external_lex_state = 33},
  [7498] = {.lex_state = 133},
  [7499] = {.lex_state = 186, .external_lex_state = 24},
  [7500] = {.lex_state = 347, .external_lex_state = 31},
  [7501] = {.lex_state = 184},
  [7502] = {.lex_state = 133},
  [7503] = {.lex_state = 133},
  [7504] = {.lex_state = 175, .external_lex_state = 33},
  [7505] = {.lex_state = 347, .external_lex_state = 31},
  [7506] = {.lex_state = 347, .external_lex_state = 25},
  [7507] = {.lex_state = 191},
  [7508] = {.lex_state = 133},
  [7509] = {.lex_state = 175, .external_lex_state = 33},
  [7510] = {.lex_state = 184},
  [7511] = {.lex_state = 175, .external_lex_state = 33},
  [7512] = {.lex_state = 347, .external_lex_state = 31},
  [7513] = {.lex_state = 175, .external_lex_state = 33},
  [7514] = {.lex_state = 191},
  [7515] = {.lex_state = 347, .external_lex_state = 25},
  [7516] = {.lex_state = 347, .external_lex_state = 25},
  [7517] = {.lex_state = 347, .external_lex_state = 31},
  [7518] = {.lex_state = 347, .external_lex_state = 25},
  [7519] = {.lex_state = 347, .external_lex_state = 31},
  [7520] = {.lex_state = 165},
  [7521] = {.lex_state = 347, .external_lex_state = 31},
  [7522] = {.lex_state = 165},
  [7523] = {.lex_state = 193},
  [7524] = {.lex_state = 347, .external_lex_state = 31},
  [7525] = {.lex_state = 347, .external_lex_state = 31},
  [7526] = {.lex_state = 347, .external_lex_state = 25},
  [7527] = {.lex_state = 165},
  [7528] = {.lex_state = 347, .external_lex_state = 25},
  [7529] = {.lex_state = 186, .external_lex_state = 24},
  [7530] = {.lex_state = 136, .external_lex_state = 33},
  [7531] = {.lex_state = 347, .external_lex_state = 25},
  [7532] = {.lex_state = 347, .external_lex_state = 25},
  [7533] = {.lex_state = 347, .external_lex_state = 25},
  [7534] = {.lex_state = 183, .external_lex_state = 24},
  [7535] = {.lex_state = 183, .external_lex_state = 28},
  [7536] = {.lex_state = 165},
  [7537] = {.lex_state = 193},
  [7538] = {.lex_state = 347, .external_lex_state = 25},
  [7539] = {.lex_state = 347, .external_lex_state = 31},
  [7540] = {.lex_state = 165},
  [7541] = {.lex_state = 347, .external_lex_state = 31},
  [7542] = {.lex_state = 347, .external_lex_state = 31},
  [7543] = {.lex_state = 165},
  [7544] = {.lex_state = 184, .external_lex_state = 24},
  [7545] = {.lex_state = 183, .external_lex_state = 24},
  [7546] = {.lex_state = 347, .external_lex_state = 31},
  [7547] = {.lex_state = 347, .external_lex_state = 31},
  [7548] = {.lex_state = 347, .external_lex_state = 31},
  [7549] = {.lex_state = 347, .external_lex_state = 25},
  [7550] = {.lex_state = 347, .external_lex_state = 25},
  [7551] = {.lex_state = 347, .external_lex_state = 31},
  [7552] = {.lex_state = 347, .external_lex_state = 31},
  [7553] = {.lex_state = 165},
  [7554] = {.lex_state = 183, .external_lex_state = 28},
  [7555] = {.lex_state = 347, .external_lex_state = 31},
  [7556] = {.lex_state = 192},
  [7557] = {.lex_state = 347, .external_lex_state = 25},
  [7558] = {.lex_state = 136, .external_lex_state = 33},
  [7559] = {.lex_state = 347, .external_lex_state = 25},
  [7560] = {.lex_state = 347, .external_lex_state = 25},
  [7561] = {.lex_state = 347, .external_lex_state = 31},
  [7562] = {.lex_state = 347, .external_lex_state = 31},
  [7563] = {.lex_state = 347, .external_lex_state = 25},
  [7564] = {.lex_state = 347, .external_lex_state = 31},
  [7565] = {.lex_state = 184, .external_lex_state = 25},
  [7566] = {.lex_state = 347, .external_lex_state = 25},
  [7567] = {.lex_state = 186, .external_lex_state = 25},
  [7568] = {.lex_state = 186, .external_lex_state = 25},
  [7569] = {.lex_state = 347, .external_lex_state = 25},
  [7570] = {.lex_state = 347, .external_lex_state = 25},
  [7571] = {.lex_state = 165},
  [7572] = {.lex_state = 183, .external_lex_state = 24},
  [7573] = {.lex_state = 347, .external_lex_state = 31},
  [7574] = {.lex_state = 165},
  [7575] = {.lex_state = 186, .external_lex_state = 25},
  [7576] = {.lex_state = 347, .external_lex_state = 31},
  [7577] = {.lex_state = 347, .external_lex_state = 25},
  [7578] = {.lex_state = 347, .external_lex_state = 25},
  [7579] = {.lex_state = 347, .external_lex_state = 25},
  [7580] = {.lex_state = 347, .external_lex_state = 25},
  [7581] = {.lex_state = 165},
  [7582] = {.lex_state = 165},
  [7583] = {.lex_state = 347, .external_lex_state = 25},
  [7584] = {.lex_state = 193},
  [7585] = {.lex_state = 347, .external_lex_state = 31},
  [7586] = {.lex_state = 347, .external_lex_state = 31},
  [7587] = {.lex_state = 347, .external_lex_state = 31},
  [7588] = {.lex_state = 165},
  [7589] = {.lex_state = 347, .external_lex_state = 25},
  [7590] = {.lex_state = 347, .external_lex_state = 25},
  [7591] = {.lex_state = 165},
  [7592] = {.lex_state = 136, .external_lex_state = 33},
  [7593] = {.lex_state = 192},
  [7594] = {.lex_state = 347, .external_lex_state = 25},
  [7595] = {.lex_state = 165},
  [7596] = {.lex_state = 184, .external_lex_state = 25},
  [7597] = {.lex_state = 347, .external_lex_state = 25},
  [7598] = {.lex_state = 347, .external_lex_state = 31},
  [7599] = {.lex_state = 347, .external_lex_state = 25},
  [7600] = {.lex_state = 165},
  [7601] = {.lex_state = 193},
  [7602] = {.lex_state = 136, .external_lex_state = 33},
  [7603] = {.lex_state = 347, .external_lex_state = 31},
  [7604] = {.lex_state = 347, .external_lex_state = 31},
  [7605] = {.lex_state = 347, .external_lex_state = 31},
  [7606] = {.lex_state = 183, .external_lex_state = 28},
  [7607] = {.lex_state = 347, .external_lex_state = 25},
  [7608] = {.lex_state = 184, .external_lex_state = 24},
  [7609] = {.lex_state = 347, .external_lex_state = 31},
  [7610] = {.lex_state = 347, .external_lex_state = 31},
  [7611] = {.lex_state = 184, .external_lex_state = 24},
  [7612] = {.lex_state = 347, .external_lex_state = 31},
  [7613] = {.lex_state = 347, .external_lex_state = 31},
  [7614] = {.lex_state = 347, .external_lex_state = 31},
  [7615] = {.lex_state = 347, .external_lex_state = 31},
  [7616] = {.lex_state = 347, .external_lex_state = 31},
  [7617] = {.lex_state = 347, .external_lex_state = 31},
  [7618] = {.lex_state = 165},
  [7619] = {.lex_state = 347, .external_lex_state = 31},
  [7620] = {.lex_state = 193},
  [7621] = {.lex_state = 165},
  [7622] = {.lex_state = 347, .external_lex_state = 25},
  [7623] = {.lex_state = 347, .external_lex_state = 25},
  [7624] = {.lex_state = 165},
  [7625] = {.lex_state = 347, .external_lex_state = 25},
  [7626] = {.lex_state = 165},
  [7627] = {.lex_state = 347, .external_lex_state = 25},
  [7628] = {.lex_state = 165},
  [7629] = {.lex_state = 165},
  [7630] = {.lex_state = 165},
  [7631] = {.lex_state = 347, .external_lex_state = 31},
  [7632] = {.lex_state = 347, .external_lex_state = 31},
  [7633] = {.lex_state = 136, .external_lex_state = 33},
  [7634] = {.lex_state = 347, .external_lex_state = 25},
  [7635] = {.lex_state = 193},
  [7636] = {.lex_state = 193},
  [7637] = {.lex_state = 165},
  [7638] = {.lex_state = 183, .external_lex_state = 30},
  [7639] = {.lex_state = 165},
  [7640] = {.lex_state = 182, .external_lex_state = 30},
  [7641] = {.lex_state = 176, .external_lex_state = 33},
  [7642] = {.lex_state = 182, .external_lex_state = 30},
  [7643] = {.lex_state = 193},
  [7644] = {.lex_state = 165},
  [7645] = {.lex_state = 176, .external_lex_state = 33},
  [7646] = {.lex_state = 193},
  [7647] = {.lex_state = 193},
  [7648] = {.lex_state = 347},
  [7649] = {.lex_state = 193},
  [7650] = {.lex_state = 193, .external_lex_state = 30},
  [7651] = {.lex_state = 176, .external_lex_state = 33},
  [7652] = {.lex_state = 176, .external_lex_state = 33},
  [7653] = {.lex_state = 183, .external_lex_state = 25},
  [7654] = {.lex_state = 347},
  [7655] = {.lex_state = 192},
  [7656] = {.lex_state = 193, .external_lex_state = 30},
  [7657] = {.lex_state = 347},
  [7658] = {.lex_state = 176, .external_lex_state = 33},
  [7659] = {.lex_state = 347},
  [7660] = {.lex_state = 176, .external_lex_state = 33},
  [7661] = {.lex_state = 193},
  [7662] = {.lex_state = 192},
  [7663] = {.lex_state = 165},
  [7664] = {.lex_state = 176, .external_lex_state = 33},
  [7665] = {.lex_state = 184},
  [7666] = {.lex_state = 347},
  [7667] = {.lex_state = 347},
  [7668] = {.lex_state = 176, .external_lex_state = 33},
  [7669] = {.lex_state = 193},
  [7670] = {.lex_state = 176, .external_lex_state = 33},
  [7671] = {.lex_state = 193, .external_lex_state = 30},
  [7672] = {.lex_state = 184},
  [7673] = {.lex_state = 183, .external_lex_state = 28},
  [7674] = {.lex_state = 184, .external_lex_state = 24},
  [7675] = {.lex_state = 176, .external_lex_state = 33},
  [7676] = {.lex_state = 347},
  [7677] = {.lex_state = 193},
  [7678] = {.lex_state = 347},
  [7679] = {.lex_state = 184},
  [7680] = {.lex_state = 192},
  [7681] = {.lex_state = 184},
  [7682] = {.lex_state = 193},
  [7683] = {.lex_state = 347},
  [7684] = {.lex_state = 184},
  [7685] = {.lex_state = 347},
  [7686] = {.lex_state = 193},
  [7687] = {.lex_state = 193},
  [7688] = {.lex_state = 193},
  [7689] = {.lex_state = 176, .external_lex_state = 33},
  [7690] = {.lex_state = 176, .external_lex_state = 33},
  [7691] = {.lex_state = 193},
  [7692] = {.lex_state = 193},
  [7693] = {.lex_state = 193},
  [7694] = {.lex_state = 193},
  [7695] = {.lex_state = 176, .external_lex_state = 33},
  [7696] = {.lex_state = 184},
  [7697] = {.lex_state = 165},
  [7698] = {.lex_state = 347},
  [7699] = {.lex_state = 193},
  [7700] = {.lex_state = 165},
  [7701] = {.lex_state = 193},
  [7702] = {.lex_state = 193},
  [7703] = {.lex_state = 193, .external_lex_state = 35},
  [7704] = {.lex_state = 183, .external_lex_state = 30},
  [7705] = {.lex_state = 347},
  [7706] = {.lex_state = 176, .external_lex_state = 33},
  [7707] = {.lex_state = 184},
  [7708] = {.lex_state = 193},
  [7709] = {.lex_state = 183, .external_lex_state = 28},
  [7710] = {.lex_state = 176, .external_lex_state = 33},
  [7711] = {.lex_state = 176, .external_lex_state = 33},
  [7712] = {.lex_state = 193},
  [7713] = {.lex_state = 347},
  [7714] = {.lex_state = 193, .external_lex_state = 35},
  [7715] = {.lex_state = 193},
  [7716] = {.lex_state = 193, .external_lex_state = 25},
  [7717] = {.lex_state = 193},
  [7718] = {.lex_state = 165},
  [7719] = {.lex_state = 165},
  [7720] = {.lex_state = 347},
  [7721] = {.lex_state = 176, .external_lex_state = 33},
  [7722] = {.lex_state = 176, .external_lex_state = 33},
  [7723] = {.lex_state = 184},
  [7724] = {.lex_state = 193},
  [7725] = {.lex_state = 165},
  [7726] = {.lex_state = 183, .external_lex_state = 28},
  [7727] = {.lex_state = 184, .external_lex_state = 25},
  [7728] = {.lex_state = 193},
  [7729] = {.lex_state = 193},
  [7730] = {.lex_state = 347},
  [7731] = {.lex_state = 193},
  [7732] = {.lex_state = 176, .external_lex_state = 33},
  [7733] = {.lex_state = 347},
  [7734] = {.lex_state = 193},
  [7735] = {.lex_state = 347},
  [7736] = {.lex_state = 193},
  [7737] = {.lex_state = 193, .external_lex_state = 25},
  [7738] = {.lex_state = 193},
  [7739] = {.lex_state = 176, .external_lex_state = 33},
  [7740] = {.lex_state = 347},
  [7741] = {.lex_state = 347},
  [7742] = {.lex_state = 193},
  [7743] = {.lex_state = 176, .external_lex_state = 33},
  [7744] = {.lex_state = 193},
  [7745] = {.lex_state = 193},
  [7746] = {.lex_state = 347},
  [7747] = {.lex_state = 193, .external_lex_state = 35},
  [7748] = {.lex_state = 193, .external_lex_state = 35},
  [7749] = {.lex_state = 193, .external_lex_state = 25},
  [7750] = {.lex_state = 176, .external_lex_state = 33},
  [7751] = {.lex_state = 193},
  [7752] = {.lex_state = 347},
  [7753] = {.lex_state = 165},
  [7754] = {.lex_state = 347},
  [7755] = {.lex_state = 347},
  [7756] = {.lex_state = 183, .external_lex_state = 29},
  [7757] = {.lex_state = 193},
  [7758] = {.lex_state = 193},
  [7759] = {.lex_state = 347},
  [7760] = {.lex_state = 347},
  [7761] = {.lex_state = 347, .external_lex_state = 31},
  [7762] = {.lex_state = 165},
  [7763] = {.lex_state = 184, .external_lex_state = 25},
  [7764] = {.lex_state = 347},
  [7765] = {.lex_state = 347},
  [7766] = {.lex_state = 176, .external_lex_state = 33},
  [7767] = {.lex_state = 176, .external_lex_state = 33},
  [7768] = {.lex_state = 176, .external_lex_state = 33},
  [7769] = {.lex_state = 193},
  [7770] = {.lex_state = 347},
  [7771] = {.lex_state = 193},
  [7772] = {.lex_state = 193},
  [7773] = {.lex_state = 347},
  [7774] = {.lex_state = 347},
  [7775] = {.lex_state = 176, .external_lex_state = 33},
  [7776] = {.lex_state = 347},
  [7777] = {.lex_state = 184},
  [7778] = {.lex_state = 176, .external_lex_state = 33},
  [7779] = {.lex_state = 193},
  [7780] = {.lex_state = 192},
  [7781] = {.lex_state = 347},
  [7782] = {.lex_state = 193, .external_lex_state = 35},
  [7783] = {.lex_state = 183, .external_lex_state = 30},
  [7784] = {.lex_state = 347},
  [7785] = {.lex_state = 176, .external_lex_state = 33},
  [7786] = {.lex_state = 186, .external_lex_state = 25},
  [7787] = {.lex_state = 193, .external_lex_state = 35},
  [7788] = {.lex_state = 193, .external_lex_state = 35},
  [7789] = {.lex_state = 176, .external_lex_state = 33},
  [7790] = {.lex_state = 165},
  [7791] = {.lex_state = 193},
  [7792] = {.lex_state = 193, .external_lex_state = 35},
  [7793] = {.lex_state = 183, .external_lex_state = 28},
  [7794] = {.lex_state = 347},
  [7795] = {.lex_state = 193},
  [7796] = {.lex_state = 347},
  [7797] = {.lex_state = 193},
  [7798] = {.lex_state = 347},
  [7799] = {.lex_state = 347},
  [7800] = {.lex_state = 193},
  [7801] = {.lex_state = 176, .external_lex_state = 33},
  [7802] = {.lex_state = 193},
  [7803] = {.lex_state = 176, .external_lex_state = 33},
  [7804] = {.lex_state = 176, .external_lex_state = 33},
  [7805] = {.lex_state = 176, .external_lex_state = 33},
  [7806] = {.lex_state = 347},
  [7807] = {.lex_state = 193},
  [7808] = {.lex_state = 347},
  [7809] = {.lex_state = 183, .external_lex_state = 28},
  [7810] = {.lex_state = 347, .external_lex_state = 31},
  [7811] = {.lex_state = 183, .external_lex_state = 28},
  [7812] = {.lex_state = 183, .external_lex_state = 28},
  [7813] = {.lex_state = 193, .external_lex_state = 25},
  [7814] = {.lex_state = 176, .external_lex_state = 33},
  [7815] = {.lex_state = 347},
  [7816] = {.lex_state = 193},
  [7817] = {.lex_state = 347},
  [7818] = {.lex_state = 347},
  [7819] = {.lex_state = 184, .external_lex_state = 25},
  [7820] = {.lex_state = 165},
  [7821] = {.lex_state = 193},
  [7822] = {.lex_state = 347},
  [7823] = {.lex_state = 176, .external_lex_state = 33},
  [7824] = {.lex_state = 347},
  [7825] = {.lex_state = 193},
  [7826] = {.lex_state = 193},
  [7827] = {.lex_state = 193},
  [7828] = {.lex_state = 192},
  [7829] = {.lex_state = 193},
  [7830] = {.lex_state = 347},
  [7831] = {.lex_state = 347},
  [7832] = {.lex_state = 347},
  [7833] = {.lex_state = 347},
  [7834] = {.lex_state = 347},
  [7835] = {.lex_state = 183, .external_lex_state = 24},
  [7836] = {.lex_state = 347},
  [7837] = {.lex_state = 347},
  [7838] = {.lex_state = 176, .external_lex_state = 33},
  [7839] = {.lex_state = 184},
  [7840] = {.lex_state = 193},
  [7841] = {.lex_state = 165},
  [7842] = {.lex_state = 184},
  [7843] = {.lex_state = 193},
  [7844] = {.lex_state = 176, .external_lex_state = 33},
  [7845] = {.lex_state = 176, .external_lex_state = 33},
  [7846] = {.lex_state = 193, .external_lex_state = 25},
  [7847] = {.lex_state = 193, .external_lex_state = 35},
  [7848] = {.lex_state = 192},
  [7849] = {.lex_state = 193},
  [7850] = {.lex_state = 193},
  [7851] = {.lex_state = 183, .external_lex_state = 29},
  [7852] = {.lex_state = 165},
  [7853] = {.lex_state = 193},
  [7854] = {.lex_state = 184, .external_lex_state = 24},
  [7855] = {.lex_state = 184, .external_lex_state = 24},
  [7856] = {.lex_state = 347},
  [7857] = {.lex_state = 193},
  [7858] = {.lex_state = 176, .external_lex_state = 33},
  [7859] = {.lex_state = 347},
  [7860] = {.lex_state = 183, .external_lex_state = 30},
  [7861] = {.lex_state = 192},
  [7862] = {.lex_state = 193, .external_lex_state = 30},
  [7863] = {.lex_state = 193},
  [7864] = {.lex_state = 184, .external_lex_state = 25},
  [7865] = {.lex_state = 192},
  [7866] = {.lex_state = 183, .external_lex_state = 30},
  [7867] = {.lex_state = 193},
  [7868] = {.lex_state = 182, .external_lex_state = 30},
  [7869] = {.lex_state = 176, .external_lex_state = 33},
  [7870] = {.lex_state = 176, .external_lex_state = 33},
  [7871] = {.lex_state = 165},
  [7872] = {.lex_state = 184, .external_lex_state = 24},
  [7873] = {.lex_state = 184, .external_lex_state = 24},
  [7874] = {.lex_state = 176, .external_lex_state = 33},
  [7875] = {.lex_state = 193, .external_lex_state = 30},
  [7876] = {.lex_state = 193, .external_lex_state = 30},
  [7877] = {.lex_state = 193},
  [7878] = {.lex_state = 176, .external_lex_state = 33},
  [7879] = {.lex_state = 347},
  [7880] = {.lex_state = 193},
  [7881] = {.lex_state = 193},
  [7882] = {.lex_state = 193},
  [7883] = {.lex_state = 165},
  [7884] = {.lex_state = 176, .external_lex_state = 33},
  [7885] = {.lex_state = 183, .external_lex_state = 25},
  [7886] = {.lex_state = 347},
  [7887] = {.lex_state = 193},
  [7888] = {.lex_state = 176, .external_lex_state = 33},
  [7889] = {.lex_state = 176, .external_lex_state = 33},
  [7890] = {.lex_state = 184, .external_lex_state = 24},
  [7891] = {.lex_state = 193},
  [7892] = {.lex_state = 176, .external_lex_state = 33},
  [7893] = {.lex_state = 176, .external_lex_state = 33},
  [7894] = {.lex_state = 193},
  [7895] = {.lex_state = 193},
  [7896] = {.lex_state = 176, .external_lex_state = 33},
  [7897] = {.lex_state = 347},
  [7898] = {.lex_state = 184},
  [7899] = {.lex_state = 347},
  [7900] = {.lex_state = 192},
  [7901] = {.lex_state = 165},
  [7902] = {.lex_state = 184, .external_lex_state = 24},
  [7903] = {.lex_state = 176, .external_lex_state = 33},
  [7904] = {.lex_state = 165},
  [7905] = {.lex_state = 347},
  [7906] = {.lex_state = 176, .external_lex_state = 33},
  [7907] = {.lex_state = 193},
  [7908] = {.lex_state = 183, .external_lex_state = 25},
  [7909] = {.lex_state = 193},
  [7910] = {.lex_state = 183, .external_lex_state = 29},
  [7911] = {.lex_state = 347},
  [7912] = {.lex_state = 193},
  [7913] = {.lex_state = 347},
  [7914] = {.lex_state = 193},
  [7915] = {.lex_state = 347},
  [7916] = {.lex_state = 193, .external_lex_state = 30},
  [7917] = {.lex_state = 347},
  [7918] = {.lex_state = 347},
  [7919] = {.lex_state = 193},
  [7920] = {.lex_state = 347},
  [7921] = {.lex_state = 193},
  [7922] = {.lex_state = 347},
  [7923] = {.lex_state = 193},
  [7924] = {.lex_state = 193, .external_lex_state = 30},
  [7925] = {.lex_state = 193},
  [7926] = {.lex_state = 193},
  [7927] = {.lex_state = 193},
  [7928] = {.lex_state = 193},
  [7929] = {.lex_state = 347},
  [7930] = {.lex_state = 193},
  [7931] = {.lex_state = 183, .external_lex_state = 30},
  [7932] = {.lex_state = 184, .external_lex_state = 24},
  [7933] = {.lex_state = 347},
  [7934] = {.lex_state = 176, .external_lex_state = 33},
  [7935] = {.lex_state = 193},
  [7936] = {.lex_state = 193, .external_lex_state = 25},
  [7937] = {.lex_state = 193},
  [7938] = {.lex_state = 193},
  [7939] = {.lex_state = 184, .external_lex_state = 24},
  [7940] = {.lex_state = 193},
  [7941] = {.lex_state = 193},
  [7942] = {.lex_state = 347},
  [7943] = {.lex_state = 176, .external_lex_state = 33},
  [7944] = {.lex_state = 184, .external_lex_state = 24},
  [7945] = {.lex_state = 347},
  [7946] = {.lex_state = 193, .external_lex_state = 30},
  [7947] = {.lex_state = 165},
  [7948] = {.lex_state = 184, .external_lex_state = 25},
  [7949] = {.lex_state = 347},
  [7950] = {.lex_state = 183, .external_lex_state = 24},
  [7951] = {.lex_state = 347},
  [7952] = {.lex_state = 193},
  [7953] = {.lex_state = 192},
  [7954] = {.lex_state = 176, .external_lex_state = 33},
  [7955] = {.lex_state = 176, .external_lex_state = 33},
  [7956] = {.lex_state = 347},
  [7957] = {.lex_state = 193},
  [7958] = {.lex_state = 183, .external_lex_state = 29},
  [7959] = {.lex_state = 184, .external_lex_state = 24},
  [7960] = {.lex_state = 193},
  [7961] = {.lex_state = 165},
  [7962] = {.lex_state = 193},
  [7963] = {.lex_state = 183, .external_lex_state = 25},
  [7964] = {.lex_state = 193},
  [7965] = {.lex_state = 193},
  [7966] = {.lex_state = 165},
  [7967] = {.lex_state = 193, .external_lex_state = 36},
  [7968] = {.lex_state = 193, .external_lex_state = 30},
  [7969] = {.lex_state = 193},
  [7970] = {.lex_state = 184, .external_lex_state = 24},
  [7971] = {.lex_state = 193},
  [7972] = {.lex_state = 184, .external_lex_state = 24},
  [7973] = {.lex_state = 193},
  [7974] = {.lex_state = 184, .external_lex_state = 24},
  [7975] = {.lex_state = 184, .external_lex_state = 24},
  [7976] = {.lex_state = 193},
  [7977] = {.lex_state = 193},
  [7978] = {.lex_state = 193},
  [7979] = {.lex_state = 193},
  [7980] = {.lex_state = 184},
  [7981] = {.lex_state = 193, .external_lex_state = 36},
  [7982] = {.lex_state = 184, .external_lex_state = 24},
  [7983] = {.lex_state = 193},
  [7984] = {.lex_state = 165},
  [7985] = {.lex_state = 193},
  [7986] = {.lex_state = 192},
  [7987] = {.lex_state = 184},
  [7988] = {.lex_state = 193},
  [7989] = {.lex_state = 184},
  [7990] = {.lex_state = 193},
  [7991] = {.lex_state = 184, .external_lex_state = 24},
  [7992] = {.lex_state = 165},
  [7993] = {.lex_state = 184, .external_lex_state = 24},
  [7994] = {.lex_state = 193},
  [7995] = {.lex_state = 184, .external_lex_state = 25},
  [7996] = {.lex_state = 184, .external_lex_state = 25},
  [7997] = {.lex_state = 184, .external_lex_state = 24},
  [7998] = {.lex_state = 193},
  [7999] = {.lex_state = 193},
  [8000] = {.lex_state = 193},
  [8001] = {.lex_state = 184, .external_lex_state = 24},
  [8002] = {.lex_state = 193, .external_lex_state = 36},
  [8003] = {.lex_state = 193},
  [8004] = {.lex_state = 193},
  [8005] = {.lex_state = 184},
  [8006] = {.lex_state = 193},
  [8007] = {.lex_state = 184, .external_lex_state = 25},
  [8008] = {.lex_state = 165},
  [8009] = {.lex_state = 193},
  [8010] = {.lex_state = 183, .external_lex_state = 29},
  [8011] = {.lex_state = 165},
  [8012] = {.lex_state = 193},
  [8013] = {.lex_state = 165},
  [8014] = {.lex_state = 184, .external_lex_state = 24},
  [8015] = {.lex_state = 191, .external_lex_state = 30},
  [8016] = {.lex_state = 184, .external_lex_state = 25},
  [8017] = {.lex_state = 184, .external_lex_state = 24},
  [8018] = {.lex_state = 165},
  [8019] = {.lex_state = 165},
  [8020] = {.lex_state = 165},
  [8021] = {.lex_state = 184, .external_lex_state = 24},
  [8022] = {.lex_state = 165},
  [8023] = {.lex_state = 193},
  [8024] = {.lex_state = 193},
  [8025] = {.lex_state = 193, .external_lex_state = 36},
  [8026] = {.lex_state = 193},
  [8027] = {.lex_state = 193},
  [8028] = {.lex_state = 193},
  [8029] = {.lex_state = 193},
  [8030] = {.lex_state = 193},
  [8031] = {.lex_state = 184, .external_lex_state = 24},
  [8032] = {.lex_state = 165},
  [8033] = {.lex_state = 193},
  [8034] = {.lex_state = 193, .external_lex_state = 36},
  [8035] = {.lex_state = 193},
  [8036] = {.lex_state = 193},
  [8037] = {.lex_state = 193},
  [8038] = {.lex_state = 193},
  [8039] = {.lex_state = 192},
  [8040] = {.lex_state = 193},
  [8041] = {.lex_state = 193},
  [8042] = {.lex_state = 193},
  [8043] = {.lex_state = 193},
  [8044] = {.lex_state = 165},
  [8045] = {.lex_state = 193, .external_lex_state = 31},
  [8046] = {.lex_state = 193},
  [8047] = {.lex_state = 193},
  [8048] = {.lex_state = 191, .external_lex_state = 30},
  [8049] = {.lex_state = 184, .external_lex_state = 24},
  [8050] = {.lex_state = 193},
  [8051] = {.lex_state = 193},
  [8052] = {.lex_state = 184, .external_lex_state = 24},
  [8053] = {.lex_state = 184, .external_lex_state = 24},
  [8054] = {.lex_state = 193},
  [8055] = {.lex_state = 184},
  [8056] = {.lex_state = 193, .external_lex_state = 31},
  [8057] = {.lex_state = 193},
  [8058] = {.lex_state = 165},
  [8059] = {.lex_state = 193},
  [8060] = {.lex_state = 193},
  [8061] = {.lex_state = 184},
  [8062] = {.lex_state = 184},
  [8063] = {.lex_state = 193},
  [8064] = {.lex_state = 184, .external_lex_state = 24},
  [8065] = {.lex_state = 184, .external_lex_state = 24},
  [8066] = {.lex_state = 184, .external_lex_state = 24},
  [8067] = {.lex_state = 193},
  [8068] = {.lex_state = 193},
  [8069] = {.lex_state = 193},
  [8070] = {.lex_state = 184, .external_lex_state = 24},
  [8071] = {.lex_state = 193},
  [8072] = {.lex_state = 193, .external_lex_state = 30},
  [8073] = {.lex_state = 165},
  [8074] = {.lex_state = 193},
  [8075] = {.lex_state = 165},
  [8076] = {.lex_state = 183, .external_lex_state = 25},
  [8077] = {.lex_state = 184, .external_lex_state = 24},
  [8078] = {.lex_state = 193},
  [8079] = {.lex_state = 193},
  [8080] = {.lex_state = 193},
  [8081] = {.lex_state = 193},
  [8082] = {.lex_state = 193},
  [8083] = {.lex_state = 193},
  [8084] = {.lex_state = 184, .external_lex_state = 24},
  [8085] = {.lex_state = 165},
  [8086] = {.lex_state = 193},
  [8087] = {.lex_state = 184, .external_lex_state = 24},
  [8088] = {.lex_state = 183, .external_lex_state = 29},
  [8089] = {.lex_state = 193, .external_lex_state = 35},
  [8090] = {.lex_state = 193},
  [8091] = {.lex_state = 184},
  [8092] = {.lex_state = 165},
  [8093] = {.lex_state = 165},
  [8094] = {.lex_state = 184, .external_lex_state = 24},
  [8095] = {.lex_state = 183, .external_lex_state = 29},
  [8096] = {.lex_state = 193},
  [8097] = {.lex_state = 193},
  [8098] = {.lex_state = 184},
  [8099] = {.lex_state = 193},
  [8100] = {.lex_state = 184, .external_lex_state = 24},
  [8101] = {.lex_state = 193},
  [8102] = {.lex_state = 184, .external_lex_state = 24},
  [8103] = {.lex_state = 193},
  [8104] = {.lex_state = 193},
  [8105] = {.lex_state = 193},
  [8106] = {.lex_state = 193},
  [8107] = {.lex_state = 192},
  [8108] = {.lex_state = 184, .external_lex_state = 25},
  [8109] = {.lex_state = 165},
  [8110] = {.lex_state = 193},
  [8111] = {.lex_state = 347},
  [8112] = {.lex_state = 193},
  [8113] = {.lex_state = 184, .external_lex_state = 25},
  [8114] = {.lex_state = 184, .external_lex_state = 24},
  [8115] = {.lex_state = 184, .external_lex_state = 24},
  [8116] = {.lex_state = 178, .external_lex_state = 33},
  [8117] = {.lex_state = 193},
  [8118] = {.lex_state = 193},
  [8119] = {.lex_state = 184, .external_lex_state = 25},
  [8120] = {.lex_state = 193},
  [8121] = {.lex_state = 193, .external_lex_state = 36},
  [8122] = {.lex_state = 184, .external_lex_state = 25},
  [8123] = {.lex_state = 165},
  [8124] = {.lex_state = 193, .external_lex_state = 30},
  [8125] = {.lex_state = 184, .external_lex_state = 25},
  [8126] = {.lex_state = 165},
  [8127] = {.lex_state = 193, .external_lex_state = 31},
  [8128] = {.lex_state = 193, .external_lex_state = 31},
  [8129] = {.lex_state = 193},
  [8130] = {.lex_state = 184},
  [8131] = {.lex_state = 193},
  [8132] = {.lex_state = 193},
  [8133] = {.lex_state = 193},
  [8134] = {.lex_state = 193},
  [8135] = {.lex_state = 184},
  [8136] = {.lex_state = 193},
  [8137] = {.lex_state = 175, .external_lex_state = 33},
  [8138] = {.lex_state = 193},
  [8139] = {.lex_state = 184, .external_lex_state = 24},
  [8140] = {.lex_state = 184, .external_lex_state = 24},
  [8141] = {.lex_state = 193},
  [8142] = {.lex_state = 193},
  [8143] = {.lex_state = 165},
  [8144] = {.lex_state = 135, .external_lex_state = 33},
  [8145] = {.lex_state = 193},
  [8146] = {.lex_state = 135, .external_lex_state = 33},
  [8147] = {.lex_state = 184, .external_lex_state = 25},
  [8148] = {.lex_state = 193},
  [8149] = {.lex_state = 178, .external_lex_state = 33},
  [8150] = {.lex_state = 193},
  [8151] = {.lex_state = 193},
  [8152] = {.lex_state = 165},
  [8153] = {.lex_state = 193},
  [8154] = {.lex_state = 165},
  [8155] = {.lex_state = 135, .external_lex_state = 33},
  [8156] = {.lex_state = 193},
  [8157] = {.lex_state = 193},
  [8158] = {.lex_state = 193},
  [8159] = {.lex_state = 193, .external_lex_state = 30},
  [8160] = {.lex_state = 184, .external_lex_state = 24},
  [8161] = {.lex_state = 184},
  [8162] = {.lex_state = 193},
  [8163] = {.lex_state = 184, .external_lex_state = 25},
  [8164] = {.lex_state = 184, .external_lex_state = 24},
  [8165] = {.lex_state = 184, .external_lex_state = 24},
  [8166] = {.lex_state = 184},
  [8167] = {.lex_state = 193},
  [8168] = {.lex_state = 193},
  [8169] = {.lex_state = 193},
  [8170] = {.lex_state = 184},
  [8171] = {.lex_state = 135, .external_lex_state = 33},
  [8172] = {.lex_state = 193},
  [8173] = {.lex_state = 184, .external_lex_state = 24},
  [8174] = {.lex_state = 193},
  [8175] = {.lex_state = 184, .external_lex_state = 24},
  [8176] = {.lex_state = 193},
  [8177] = {.lex_state = 193, .external_lex_state = 36},
  [8178] = {.lex_state = 193},
  [8179] = {.lex_state = 193},
  [8180] = {.lex_state = 178, .external_lex_state = 33},
  [8181] = {.lex_state = 184},
  [8182] = {.lex_state = 184},
  [8183] = {.lex_state = 184, .external_lex_state = 24},
  [8184] = {.lex_state = 193},
  [8185] = {.lex_state = 193, .external_lex_state = 36},
  [8186] = {.lex_state = 193},
  [8187] = {.lex_state = 193},
  [8188] = {.lex_state = 193},
  [8189] = {.lex_state = 165},
  [8190] = {.lex_state = 184},
  [8191] = {.lex_state = 183, .external_lex_state = 29},
  [8192] = {.lex_state = 193},
  [8193] = {.lex_state = 193},
  [8194] = {.lex_state = 184, .external_lex_state = 24},
  [8195] = {.lex_state = 193},
  [8196] = {.lex_state = 193},
  [8197] = {.lex_state = 193},
  [8198] = {.lex_state = 193},
  [8199] = {.lex_state = 184, .external_lex_state = 24},
  [8200] = {.lex_state = 193},
  [8201] = {.lex_state = 193},
  [8202] = {.lex_state = 193},
  [8203] = {.lex_state = 193},
  [8204] = {.lex_state = 184},
  [8205] = {.lex_state = 193},
  [8206] = {.lex_state = 184, .external_lex_state = 24},
  [8207] = {.lex_state = 165},
  [8208] = {.lex_state = 184},
  [8209] = {.lex_state = 184, .external_lex_state = 24},
  [8210] = {.lex_state = 193},
  [8211] = {.lex_state = 193},
  [8212] = {.lex_state = 193},
  [8213] = {.lex_state = 165},
  [8214] = {.lex_state = 193},
  [8215] = {.lex_state = 193, .external_lex_state = 35},
  [8216] = {.lex_state = 165},
  [8217] = {.lex_state = 193},
  [8218] = {.lex_state = 193},
  [8219] = {.lex_state = 193},
  [8220] = {.lex_state = 193},
  [8221] = {.lex_state = 165},
  [8222] = {.lex_state = 193},
  [8223] = {.lex_state = 165},
  [8224] = {.lex_state = 165},
  [8225] = {.lex_state = 184, .external_lex_state = 24},
  [8226] = {.lex_state = 165},
  [8227] = {.lex_state = 175, .external_lex_state = 33},
  [8228] = {.lex_state = 175, .external_lex_state = 33},
  [8229] = {.lex_state = 184, .external_lex_state = 24},
  [8230] = {.lex_state = 183, .external_lex_state = 29},
  [8231] = {.lex_state = 193},
  [8232] = {.lex_state = 184, .external_lex_state = 24},
  [8233] = {.lex_state = 193},
  [8234] = {.lex_state = 184},
  [8235] = {.lex_state = 193, .external_lex_state = 35},
  [8236] = {.lex_state = 184, .external_lex_state = 24},
  [8237] = {.lex_state = 192},
  [8238] = {.lex_state = 193},
  [8239] = {.lex_state = 193, .external_lex_state = 30},
  [8240] = {.lex_state = 193},
  [8241] = {.lex_state = 193},
  [8242] = {.lex_state = 184},
  [8243] = {.lex_state = 183, .external_lex_state = 29},
  [8244] = {.lex_state = 165},
  [8245] = {.lex_state = 184},
  [8246] = {.lex_state = 184, .external_lex_state = 24},
  [8247] = {.lex_state = 193},
  [8248] = {.lex_state = 184, .external_lex_state = 24},
  [8249] = {.lex_state = 184, .external_lex_state = 24},
  [8250] = {.lex_state = 193, .external_lex_state = 36},
  [8251] = {.lex_state = 184},
  [8252] = {.lex_state = 184, .external_lex_state = 24},
  [8253] = {.lex_state = 193},
  [8254] = {.lex_state = 193},
  [8255] = {.lex_state = 193},
  [8256] = {.lex_state = 184, .external_lex_state = 24},
  [8257] = {.lex_state = 165},
  [8258] = {.lex_state = 184, .external_lex_state = 24},
  [8259] = {.lex_state = 184},
  [8260] = {.lex_state = 193},
  [8261] = {.lex_state = 193},
  [8262] = {.lex_state = 184, .external_lex_state = 24},
  [8263] = {.lex_state = 193},
  [8264] = {.lex_state = 193},
  [8265] = {.lex_state = 184, .external_lex_state = 24},
  [8266] = {.lex_state = 193},
  [8267] = {.lex_state = 184, .external_lex_state = 24},
  [8268] = {.lex_state = 184, .external_lex_state = 24},
  [8269] = {.lex_state = 184, .external_lex_state = 24},
  [8270] = {.lex_state = 184, .external_lex_state = 24},
  [8271] = {.lex_state = 165},
  [8272] = {.lex_state = 184},
  [8273] = {.lex_state = 165},
  [8274] = {.lex_state = 193},
  [8275] = {.lex_state = 184, .external_lex_state = 24},
  [8276] = {.lex_state = 193},
  [8277] = {.lex_state = 193},
  [8278] = {.lex_state = 184},
  [8279] = {.lex_state = 193, .external_lex_state = 35},
  [8280] = {.lex_state = 165},
  [8281] = {.lex_state = 193},
  [8282] = {.lex_state = 193, .external_lex_state = 35},
  [8283] = {.lex_state = 193},
  [8284] = {.lex_state = 193},
  [8285] = {.lex_state = 165},
  [8286] = {.lex_state = 165},
  [8287] = {.lex_state = 193},
  [8288] = {.lex_state = 184, .external_lex_state = 24},
  [8289] = {.lex_state = 193},
  [8290] = {.lex_state = 184, .external_lex_state = 24},
  [8291] = {.lex_state = 193, .external_lex_state = 31},
  [8292] = {.lex_state = 193},
  [8293] = {.lex_state = 193},
  [8294] = {.lex_state = 191, .external_lex_state = 30},
  [8295] = {.lex_state = 193},
  [8296] = {.lex_state = 193},
  [8297] = {.lex_state = 184, .external_lex_state = 25},
  [8298] = {.lex_state = 193, .external_lex_state = 30},
  [8299] = {.lex_state = 184, .external_lex_state = 25},
  [8300] = {.lex_state = 184},
  [8301] = {.lex_state = 347, .external_lex_state = 37},
  [8302] = {.lex_state = 184, .external_lex_state = 25},
  [8303] = {.lex_state = 184},
  [8304] = {.lex_state = 184, .external_lex_state = 25},
  [8305] = {.lex_state = 184, .external_lex_state = 25},
  [8306] = {.lex_state = 184, .external_lex_state = 25},
  [8307] = {.lex_state = 184, .external_lex_state = 25},
  [8308] = {.lex_state = 184, .external_lex_state = 25},
  [8309] = {.lex_state = 184},
  [8310] = {.lex_state = 184},
  [8311] = {.lex_state = 193, .external_lex_state = 30},
  [8312] = {.lex_state = 347, .external_lex_state = 37},
  [8313] = {.lex_state = 193, .external_lex_state = 35},
  [8314] = {.lex_state = 184, .external_lex_state = 25},
  [8315] = {.lex_state = 193, .external_lex_state = 36},
  [8316] = {.lex_state = 193, .external_lex_state = 36},
  [8317] = {.lex_state = 133},
  [8318] = {.lex_state = 184},
  [8319] = {.lex_state = 184, .external_lex_state = 25},
  [8320] = {.lex_state = 184},
  [8321] = {.lex_state = 193, .external_lex_state = 35},
  [8322] = {.lex_state = 184},
  [8323] = {.lex_state = 184, .external_lex_state = 25},
  [8324] = {.lex_state = 133},
  [8325] = {.lex_state = 193, .external_lex_state = 35},
  [8326] = {.lex_state = 136, .external_lex_state = 33},
  [8327] = {.lex_state = 184, .external_lex_state = 25},
  [8328] = {.lex_state = 184},
  [8329] = {.lex_state = 184, .external_lex_state = 25},
  [8330] = {.lex_state = 184},
  [8331] = {.lex_state = 133},
  [8332] = {.lex_state = 184, .external_lex_state = 25},
  [8333] = {.lex_state = 193, .external_lex_state = 35},
  [8334] = {.lex_state = 184, .external_lex_state = 25},
  [8335] = {.lex_state = 184, .external_lex_state = 25},
  [8336] = {.lex_state = 184, .external_lex_state = 25},
  [8337] = {.lex_state = 184},
  [8338] = {.lex_state = 184, .external_lex_state = 25},
  [8339] = {.lex_state = 184, .external_lex_state = 25},
  [8340] = {.lex_state = 184, .external_lex_state = 25},
  [8341] = {.lex_state = 184},
  [8342] = {.lex_state = 184, .external_lex_state = 25},
  [8343] = {.lex_state = 184},
  [8344] = {.lex_state = 184, .external_lex_state = 25},
  [8345] = {.lex_state = 184},
  [8346] = {.lex_state = 184, .external_lex_state = 25},
  [8347] = {.lex_state = 193},
  [8348] = {.lex_state = 184},
  [8349] = {.lex_state = 193},
  [8350] = {.lex_state = 184},
  [8351] = {.lex_state = 184, .external_lex_state = 25},
  [8352] = {.lex_state = 184, .external_lex_state = 25},
  [8353] = {.lex_state = 184, .external_lex_state = 25},
  [8354] = {.lex_state = 184, .external_lex_state = 25},
  [8355] = {.lex_state = 193, .external_lex_state = 36},
  [8356] = {.lex_state = 184},
  [8357] = {.lex_state = 184, .external_lex_state = 25},
  [8358] = {.lex_state = 133},
  [8359] = {.lex_state = 347, .external_lex_state = 29},
  [8360] = {.lex_state = 184, .external_lex_state = 25},
  [8361] = {.lex_state = 133},
  [8362] = {.lex_state = 347, .external_lex_state = 29},
  [8363] = {.lex_state = 184, .external_lex_state = 25},
  [8364] = {.lex_state = 184},
  [8365] = {.lex_state = 184, .external_lex_state = 25},
  [8366] = {.lex_state = 184, .external_lex_state = 25},
  [8367] = {.lex_state = 133},
  [8368] = {.lex_state = 193, .external_lex_state = 35},
  [8369] = {.lex_state = 184},
  [8370] = {.lex_state = 184},
  [8371] = {.lex_state = 184},
  [8372] = {.lex_state = 184},
  [8373] = {.lex_state = 184, .external_lex_state = 25},
  [8374] = {.lex_state = 184, .external_lex_state = 25},
  [8375] = {.lex_state = 184},
  [8376] = {.lex_state = 184},
  [8377] = {.lex_state = 184},
  [8378] = {.lex_state = 184},
  [8379] = {.lex_state = 184, .external_lex_state = 25},
  [8380] = {.lex_state = 184},
  [8381] = {.lex_state = 184},
  [8382] = {.lex_state = 184},
  [8383] = {.lex_state = 347, .external_lex_state = 37},
  [8384] = {.lex_state = 184, .external_lex_state = 25},
  [8385] = {.lex_state = 347, .external_lex_state = 37},
  [8386] = {.lex_state = 184},
  [8387] = {.lex_state = 184, .external_lex_state = 25},
  [8388] = {.lex_state = 347, .external_lex_state = 29},
  [8389] = {.lex_state = 184, .external_lex_state = 25},
  [8390] = {.lex_state = 193},
  [8391] = {.lex_state = 193},
  [8392] = {.lex_state = 184},
  [8393] = {.lex_state = 184, .external_lex_state = 25},
  [8394] = {.lex_state = 184},
  [8395] = {.lex_state = 184, .external_lex_state = 25},
  [8396] = {.lex_state = 184, .external_lex_state = 25},
  [8397] = {.lex_state = 184, .external_lex_state = 25},
  [8398] = {.lex_state = 184, .external_lex_state = 25},
  [8399] = {.lex_state = 347, .external_lex_state = 29},
  [8400] = {.lex_state = 184, .external_lex_state = 25},
  [8401] = {.lex_state = 184},
  [8402] = {.lex_state = 184, .external_lex_state = 25},
  [8403] = {.lex_state = 184},
  [8404] = {.lex_state = 184, .external_lex_state = 25},
  [8405] = {.lex_state = 184},
  [8406] = {.lex_state = 184},
  [8407] = {.lex_state = 184},
  [8408] = {.lex_state = 184},
  [8409] = {.lex_state = 184},
  [8410] = {.lex_state = 347, .external_lex_state = 29},
  [8411] = {.lex_state = 184},
  [8412] = {.lex_state = 184},
  [8413] = {.lex_state = 184},
  [8414] = {.lex_state = 184},
  [8415] = {.lex_state = 184},
  [8416] = {.lex_state = 184},
  [8417] = {.lex_state = 184},
  [8418] = {.lex_state = 184},
  [8419] = {.lex_state = 184, .external_lex_state = 25},
  [8420] = {.lex_state = 184},
  [8421] = {.lex_state = 184},
  [8422] = {.lex_state = 184, .external_lex_state = 25},
  [8423] = {.lex_state = 184, .external_lex_state = 25},
  [8424] = {.lex_state = 184},
  [8425] = {.lex_state = 193, .external_lex_state = 36},
  [8426] = {.lex_state = 347, .external_lex_state = 37},
  [8427] = {.lex_state = 193, .external_lex_state = 30},
  [8428] = {.lex_state = 136, .external_lex_state = 33},
  [8429] = {.lex_state = 184},
  [8430] = {.lex_state = 193, .external_lex_state = 30},
  [8431] = {.lex_state = 184},
  [8432] = {.lex_state = 193, .external_lex_state = 36},
  [8433] = {.lex_state = 184},
  [8434] = {.lex_state = 184},
  [8435] = {.lex_state = 193, .external_lex_state = 30},
  [8436] = {.lex_state = 136, .external_lex_state = 33},
  [8437] = {.lex_state = 184},
  [8438] = {.lex_state = 165},
  [8439] = {.lex_state = 165},
  [8440] = {.lex_state = 193},
  [8441] = {.lex_state = 165},
  [8442] = {.lex_state = 193},
  [8443] = {.lex_state = 165},
  [8444] = {.lex_state = 165},
  [8445] = {.lex_state = 165},
  [8446] = {.lex_state = 165},
  [8447] = {.lex_state = 192},
  [8448] = {.lex_state = 193},
  [8449] = {.lex_state = 165},
  [8450] = {.lex_state = 165},
  [8451] = {.lex_state = 193},
  [8452] = {.lex_state = 193},
  [8453] = {.lex_state = 165},
  [8454] = {.lex_state = 165},
  [8455] = {.lex_state = 193},
  [8456] = {.lex_state = 165},
  [8457] = {.lex_state = 165},
  [8458] = {.lex_state = 165},
  [8459] = {.lex_state = 165},
  [8460] = {.lex_state = 176, .external_lex_state = 33},
  [8461] = {.lex_state = 193},
  [8462] = {.lex_state = 193},
  [8463] = {.lex_state = 193},
  [8464] = {.lex_state = 165},
  [8465] = {.lex_state = 165},
  [8466] = {.lex_state = 165},
  [8467] = {.lex_state = 165},
  [8468] = {.lex_state = 165},
  [8469] = {.lex_state = 165},
  [8470] = {.lex_state = 193},
  [8471] = {.lex_state = 165},
  [8472] = {.lex_state = 193},
  [8473] = {.lex_state = 165},
  [8474] = {.lex_state = 165},
  [8475] = {.lex_state = 193, .external_lex_state = 35},
  [8476] = {.lex_state = 193, .external_lex_state = 35},
  [8477] = {.lex_state = 193, .external_lex_state = 35},
  [8478] = {.lex_state = 193, .external_lex_state = 35},
  [8479] = {.lex_state = 193, .external_lex_state = 35},
  [8480] = {.lex_state = 193},
  [8481] = {.lex_state = 193, .external_lex_state = 35},
  [8482] = {.lex_state = 165},
  [8483] = {.lex_state = 193, .external_lex_state = 35},
  [8484] = {.lex_state = 193, .external_lex_state = 35},
  [8485] = {.lex_state = 193, .external_lex_state = 35},
  [8486] = {.lex_state = 165},
  [8487] = {.lex_state = 193, .external_lex_state = 35},
  [8488] = {.lex_state = 193, .external_lex_state = 35},
  [8489] = {.lex_state = 165},
  [8490] = {.lex_state = 165},
  [8491] = {.lex_state = 193},
  [8492] = {.lex_state = 193, .external_lex_state = 30},
  [8493] = {.lex_state = 193},
  [8494] = {.lex_state = 193, .external_lex_state = 30},
  [8495] = {.lex_state = 193, .external_lex_state = 30},
  [8496] = {.lex_state = 165},
  [8497] = {.lex_state = 193, .external_lex_state = 30},
  [8498] = {.lex_state = 193},
  [8499] = {.lex_state = 193},
  [8500] = {.lex_state = 193, .external_lex_state = 30},
  [8501] = {.lex_state = 193},
  [8502] = {.lex_state = 165},
  [8503] = {.lex_state = 193, .external_lex_state = 35},
  [8504] = {.lex_state = 193, .external_lex_state = 30},
  [8505] = {.lex_state = 193, .external_lex_state = 30},
  [8506] = {.lex_state = 193, .external_lex_state = 30},
  [8507] = {.lex_state = 193, .external_lex_state = 30},
  [8508] = {.lex_state = 165},
  [8509] = {.lex_state = 193, .external_lex_state = 30},
  [8510] = {.lex_state = 193, .external_lex_state = 30},
  [8511] = {.lex_state = 193, .external_lex_state = 30},
  [8512] = {.lex_state = 165},
  [8513] = {.lex_state = 165},
  [8514] = {.lex_state = 165},
  [8515] = {.lex_state = 176, .external_lex_state = 33},
  [8516] = {.lex_state = 165},
  [8517] = {.lex_state = 165},
  [8518] = {.lex_state = 193},
  [8519] = {.lex_state = 165},
  [8520] = {.lex_state = 193, .external_lex_state = 36},
  [8521] = {.lex_state = 165},
  [8522] = {.lex_state = 192},
  [8523] = {.lex_state = 165},
  [8524] = {.lex_state = 193, .external_lex_state = 36},
  [8525] = {.lex_state = 165},
  [8526] = {.lex_state = 193},
  [8527] = {.lex_state = 176, .external_lex_state = 33},
  [8528] = {.lex_state = 165},
  [8529] = {.lex_state = 165},
  [8530] = {.lex_state = 165},
  [8531] = {.lex_state = 193, .external_lex_state = 36},
  [8532] = {.lex_state = 193},
  [8533] = {.lex_state = 193},
  [8534] = {.lex_state = 193},
  [8535] = {.lex_state = 193},
  [8536] = {.lex_state = 193},
  [8537] = {.lex_state = 193},
  [8538] = {.lex_state = 165},
  [8539] = {.lex_state = 165},
  [8540] = {.lex_state = 165},
  [8541] = {.lex_state = 347, .external_lex_state = 38},
  [8542] = {.lex_state = 165},
  [8543] = {.lex_state = 347, .external_lex_state = 38},
  [8544] = {.lex_state = 347, .external_lex_state = 38},
  [8545] = {.lex_state = 347, .external_lex_state = 38},
  [8546] = {.lex_state = 193, .external_lex_state = 36},
  [8547] = {.lex_state = 165},
  [8548] = {.lex_state = 165},
  [8549] = {.lex_state = 193},
  [8550] = {.lex_state = 193},
  [8551] = {.lex_state = 165},
  [8552] = {.lex_state = 347, .external_lex_state = 38},
  [8553] = {.lex_state = 165},
  [8554] = {.lex_state = 165},
  [8555] = {.lex_state = 193, .external_lex_state = 36},
  [8556] = {.lex_state = 165},
  [8557] = {.lex_state = 347},
  [8558] = {.lex_state = 165},
  [8559] = {.lex_state = 193},
  [8560] = {.lex_state = 193},
  [8561] = {.lex_state = 165},
  [8562] = {.lex_state = 165},
  [8563] = {.lex_state = 165},
  [8564] = {.lex_state = 165},
  [8565] = {.lex_state = 165},
  [8566] = {.lex_state = 165},
  [8567] = {.lex_state = 165},
  [8568] = {.lex_state = 165},
  [8569] = {.lex_state = 165},
  [8570] = {.lex_state = 193, .external_lex_state = 36},
  [8571] = {.lex_state = 165},
  [8572] = {.lex_state = 193, .external_lex_state = 36},
  [8573] = {.lex_state = 193, .external_lex_state = 36},
  [8574] = {.lex_state = 193, .external_lex_state = 36},
  [8575] = {.lex_state = 165},
  [8576] = {.lex_state = 193, .external_lex_state = 36},
  [8577] = {.lex_state = 193, .external_lex_state = 36},
  [8578] = {.lex_state = 165},
  [8579] = {.lex_state = 193, .external_lex_state = 36},
  [8580] = {.lex_state = 193, .external_lex_state = 36},
  [8581] = {.lex_state = 193, .external_lex_state = 36},
  [8582] = {.lex_state = 165},
  [8583] = {.lex_state = 193, .external_lex_state = 36},
  [8584] = {.lex_state = 193, .external_lex_state = 36},
  [8585] = {.lex_state = 178, .external_lex_state = 33},
  [8586] = {.lex_state = 178, .external_lex_state = 33},
  [8587] = {.lex_state = 165},
  [8588] = {.lex_state = 165},
  [8589] = {.lex_state = 165},
  [8590] = {.lex_state = 193, .external_lex_state = 36},
  [8591] = {.lex_state = 165},
  [8592] = {.lex_state = 165},
  [8593] = {.lex_state = 165},
  [8594] = {.lex_state = 178, .external_lex_state = 33},
  [8595] = {.lex_state = 165},
  [8596] = {.lex_state = 347},
  [8597] = {.lex_state = 165},
  [8598] = {.lex_state = 347},
  [8599] = {.lex_state = 165},
  [8600] = {.lex_state = 165},
  [8601] = {.lex_state = 165},
  [8602] = {.lex_state = 165},
  [8603] = {.lex_state = 184},
  [8604] = {.lex_state = 184},
  [8605] = {.lex_state = 193},
  [8606] = {.lex_state = 184},
  [8607] = {.lex_state = 347},
  [8608] = {.lex_state = 184},
  [8609] = {.lex_state = 184},
  [8610] = {.lex_state = 184},
  [8611] = {.lex_state = 184},
  [8612] = {.lex_state = 184},
  [8613] = {.lex_state = 184},
  [8614] = {.lex_state = 193},
  [8615] = {.lex_state = 184},
  [8616] = {.lex_state = 133},
  [8617] = {.lex_state = 184},
  [8618] = {.lex_state = 184},
  [8619] = {.lex_state = 347},
  [8620] = {.lex_state = 184},
  [8621] = {.lex_state = 165},
  [8622] = {.lex_state = 184},
  [8623] = {.lex_state = 184},
  [8624] = {.lex_state = 184},
  [8625] = {.lex_state = 133},
  [8626] = {.lex_state = 347, .external_lex_state = 39},
  [8627] = {.lex_state = 184},
  [8628] = {.lex_state = 347},
  [8629] = {.lex_state = 184},
  [8630] = {.lex_state = 184},
  [8631] = {.lex_state = 193},
  [8632] = {.lex_state = 347},
  [8633] = {.lex_state = 184},
  [8634] = {.lex_state = 184},
  [8635] = {.lex_state = 133},
  [8636] = {.lex_state = 347},
  [8637] = {.lex_state = 184},
  [8638] = {.lex_state = 184},
  [8639] = {.lex_state = 347},
  [8640] = {.lex_state = 184},
  [8641] = {.lex_state = 347},
  [8642] = {.lex_state = 184},
  [8643] = {.lex_state = 184},
  [8644] = {.lex_state = 184},
  [8645] = {.lex_state = 133, .external_lex_state = 40},
  [8646] = {.lex_state = 184},
  [8647] = {.lex_state = 184},
  [8648] = {.lex_state = 184},
  [8649] = {.lex_state = 165},
  [8650] = {.lex_state = 184},
  [8651] = {.lex_state = 184},
  [8652] = {.lex_state = 184},
  [8653] = {.lex_state = 184},
  [8654] = {.lex_state = 347, .external_lex_state = 39},
  [8655] = {.lex_state = 347},
  [8656] = {.lex_state = 165},
  [8657] = {.lex_state = 184},
  [8658] = {.lex_state = 165},
  [8659] = {.lex_state = 184},
  [8660] = {.lex_state = 347},
  [8661] = {.lex_state = 165},
  [8662] = {.lex_state = 184},
  [8663] = {.lex_state = 184},
  [8664] = {.lex_state = 193},
  [8665] = {.lex_state = 165},
  [8666] = {.lex_state = 184},
  [8667] = {.lex_state = 184},
  [8668] = {.lex_state = 193},
  [8669] = {.lex_state = 184},
  [8670] = {.lex_state = 184},
  [8671] = {.lex_state = 184},
  [8672] = {.lex_state = 347},
  [8673] = {.lex_state = 184},
  [8674] = {.lex_state = 184},
  [8675] = {.lex_state = 133},
  [8676] = {.lex_state = 184},
  [8677] = {.lex_state = 184},
  [8678] = {.lex_state = 193},
  [8679] = {.lex_state = 165},
  [8680] = {.lex_state = 184},
  [8681] = {.lex_state = 184},
  [8682] = {.lex_state = 184},
  [8683] = {.lex_state = 184, .external_lex_state = 31},
  [8684] = {.lex_state = 184},
  [8685] = {.lex_state = 184},
  [8686] = {.lex_state = 184},
  [8687] = {.lex_state = 347},
  [8688] = {.lex_state = 184, .external_lex_state = 31},
  [8689] = {.lex_state = 184},
  [8690] = {.lex_state = 165},
  [8691] = {.lex_state = 184},
  [8692] = {.lex_state = 193},
  [8693] = {.lex_state = 347},
  [8694] = {.lex_state = 184},
  [8695] = {.lex_state = 184},
  [8696] = {.lex_state = 184},
  [8697] = {.lex_state = 184},
  [8698] = {.lex_state = 193},
  [8699] = {.lex_state = 184},
  [8700] = {.lex_state = 165},
  [8701] = {.lex_state = 184},
  [8702] = {.lex_state = 184},
  [8703] = {.lex_state = 184},
  [8704] = {.lex_state = 184},
  [8705] = {.lex_state = 184},
  [8706] = {.lex_state = 347},
  [8707] = {.lex_state = 184},
  [8708] = {.lex_state = 184},
  [8709] = {.lex_state = 165},
  [8710] = {.lex_state = 184},
  [8711] = {.lex_state = 184},
  [8712] = {.lex_state = 184},
  [8713] = {.lex_state = 184},
  [8714] = {.lex_state = 184},
  [8715] = {.lex_state = 184},
  [8716] = {.lex_state = 165},
  [8717] = {.lex_state = 184},
  [8718] = {.lex_state = 165},
  [8719] = {.lex_state = 184},
  [8720] = {.lex_state = 184},
  [8721] = {.lex_state = 347, .external_lex_state = 39},
  [8722] = {.lex_state = 193},
  [8723] = {.lex_state = 184},
  [8724] = {.lex_state = 165},
  [8725] = {.lex_state = 184},
  [8726] = {.lex_state = 184},
  [8727] = {.lex_state = 193},
  [8728] = {.lex_state = 184},
  [8729] = {.lex_state = 184},
  [8730] = {.lex_state = 184},
  [8731] = {.lex_state = 184},
  [8732] = {.lex_state = 184},
  [8733] = {.lex_state = 184},
  [8734] = {.lex_state = 184},
  [8735] = {.lex_state = 133},
  [8736] = {.lex_state = 184},
  [8737] = {.lex_state = 184},
  [8738] = {.lex_state = 184},
  [8739] = {.lex_state = 165},
  [8740] = {.lex_state = 184},
  [8741] = {.lex_state = 165},
  [8742] = {.lex_state = 347},
  [8743] = {.lex_state = 165},
  [8744] = {.lex_state = 165},
  [8745] = {.lex_state = 184},
  [8746] = {.lex_state = 184},
  [8747] = {.lex_state = 184},
  [8748] = {.lex_state = 165},
  [8749] = {.lex_state = 184},
  [8750] = {.lex_state = 193},
  [8751] = {.lex_state = 184},
  [8752] = {.lex_state = 347},
  [8753] = {.lex_state = 133},
  [8754] = {.lex_state = 184},
  [8755] = {.lex_state = 347},
  [8756] = {.lex_state = 184},
  [8757] = {.lex_state = 184},
  [8758] = {.lex_state = 347},
  [8759] = {.lex_state = 184},
  [8760] = {.lex_state = 184},
  [8761] = {.lex_state = 184},
  [8762] = {.lex_state = 133},
  [8763] = {.lex_state = 184},
  [8764] = {.lex_state = 184},
  [8765] = {.lex_state = 347},
  [8766] = {.lex_state = 184},
  [8767] = {.lex_state = 347},
  [8768] = {.lex_state = 184},
  [8769] = {.lex_state = 184},
  [8770] = {.lex_state = 133},
  [8771] = {.lex_state = 184},
  [8772] = {.lex_state = 184},
  [8773] = {.lex_state = 133},
  [8774] = {.lex_state = 184},
  [8775] = {.lex_state = 347},
  [8776] = {.lex_state = 165},
  [8777] = {.lex_state = 193},
  [8778] = {.lex_state = 184},
  [8779] = {.lex_state = 184},
  [8780] = {.lex_state = 184},
  [8781] = {.lex_state = 165},
  [8782] = {.lex_state = 184},
  [8783] = {.lex_state = 347, .external_lex_state = 39},
  [8784] = {.lex_state = 193},
  [8785] = {.lex_state = 184},
  [8786] = {.lex_state = 165},
  [8787] = {.lex_state = 184},
  [8788] = {.lex_state = 165},
  [8789] = {.lex_state = 133},
  [8790] = {.lex_state = 184},
  [8791] = {.lex_state = 184},
  [8792] = {.lex_state = 165},
  [8793] = {.lex_state = 184},
  [8794] = {.lex_state = 347},
  [8795] = {.lex_state = 184},
  [8796] = {.lex_state = 193},
  [8797] = {.lex_state = 184},
  [8798] = {.lex_state = 165},
  [8799] = {.lex_state = 184},
  [8800] = {.lex_state = 184},
  [8801] = {.lex_state = 347},
  [8802] = {.lex_state = 347},
  [8803] = {.lex_state = 347, .external_lex_state = 37},
  [8804] = {.lex_state = 347},
  [8805] = {.lex_state = 347},
  [8806] = {.lex_state = 347, .external_lex_state = 41},
  [8807] = {.lex_state = 347},
  [8808] = {.lex_state = 347},
  [8809] = {.lex_state = 347, .external_lex_state = 30},
  [8810] = {.lex_state = 347},
  [8811] = {.lex_state = 347, .external_lex_state = 25},
  [8812] = {.lex_state = 347},
  [8813] = {.lex_state = 347, .external_lex_state = 30},
  [8814] = {.lex_state = 347, .external_lex_state = 29},
  [8815] = {.lex_state = 347, .external_lex_state = 29},
  [8816] = {.lex_state = 347},
  [8817] = {.lex_state = 347},
  [8818] = {.lex_state = 347, .external_lex_state = 25},
  [8819] = {.lex_state = 347},
  [8820] = {.lex_state = 347},
  [8821] = {.lex_state = 347},
  [8822] = {.lex_state = 347, .external_lex_state = 29},
  [8823] = {.lex_state = 347},
  [8824] = {.lex_state = 347},
  [8825] = {.lex_state = 347, .external_lex_state = 29},
  [8826] = {.lex_state = 347, .external_lex_state = 29},
  [8827] = {.lex_state = 347, .external_lex_state = 37},
  [8828] = {.lex_state = 347},
  [8829] = {.lex_state = 347, .external_lex_state = 29},
  [8830] = {.lex_state = 347, .external_lex_state = 37},
  [8831] = {.lex_state = 347},
  [8832] = {.lex_state = 347, .external_lex_state = 37},
  [8833] = {.lex_state = 347, .external_lex_state = 37},
  [8834] = {.lex_state = 347},
  [8835] = {.lex_state = 347},
  [8836] = {.lex_state = 347, .external_lex_state = 37},
  [8837] = {.lex_state = 347, .external_lex_state = 29},
  [8838] = {.lex_state = 347},
  [8839] = {.lex_state = 347},
  [8840] = {.lex_state = 347, .external_lex_state = 37},
  [8841] = {.lex_state = 347, .external_lex_state = 29},
  [8842] = {.lex_state = 347},
  [8843] = {.lex_state = 347, .external_lex_state = 25},
  [8844] = {.lex_state = 347, .external_lex_state = 37},
  [8845] = {.lex_state = 347, .external_lex_state = 37},
  [8846] = {.lex_state = 347},
  [8847] = {.lex_state = 347, .external_lex_state = 29},
  [8848] = {.lex_state = 347, .external_lex_state = 25},
  [8849] = {.lex_state = 347},
  [8850] = {.lex_state = 347, .external_lex_state = 29},
  [8851] = {.lex_state = 347, .external_lex_state = 37},
  [8852] = {.lex_state = 347},
  [8853] = {.lex_state = 347},
  [8854] = {.lex_state = 347, .external_lex_state = 29},
  [8855] = {.lex_state = 347},
  [8856] = {.lex_state = 347},
  [8857] = {.lex_state = 347},
  [8858] = {.lex_state = 347, .external_lex_state = 31},
  [8859] = {.lex_state = 347},
  [8860] = {.lex_state = 347},
  [8861] = {.lex_state = 184, .external_lex_state = 31},
  [8862] = {.lex_state = 347},
  [8863] = {.lex_state = 347, .external_lex_state = 37},
  [8864] = {.lex_state = 347, .external_lex_state = 29},
  [8865] = {.lex_state = 347},
  [8866] = {.lex_state = 347},
  [8867] = {.lex_state = 347, .external_lex_state = 41},
  [8868] = {.lex_state = 347},
  [8869] = {.lex_state = 347, .external_lex_state = 37},
  [8870] = {.lex_state = 184, .external_lex_state = 31},
  [8871] = {.lex_state = 347},
  [8872] = {.lex_state = 347},
  [8873] = {.lex_state = 347, .external_lex_state = 37},
  [8874] = {.lex_state = 347},
  [8875] = {.lex_state = 347, .external_lex_state = 37},
  [8876] = {.lex_state = 347},
  [8877] = {.lex_state = 347, .external_lex_state = 29},
  [8878] = {.lex_state = 347, .external_lex_state = 29},
  [8879] = {.lex_state = 347, .external_lex_state = 37},
  [8880] = {.lex_state = 347},
  [8881] = {.lex_state = 347},
  [8882] = {.lex_state = 347},
  [8883] = {.lex_state = 347, .external_lex_state = 37},
  [8884] = {.lex_state = 184, .external_lex_state = 31},
  [8885] = {.lex_state = 347},
  [8886] = {.lex_state = 184},
  [8887] = {.lex_state = 347, .external_lex_state = 37},
  [8888] = {.lex_state = 347, .external_lex_state = 37},
  [8889] = {.lex_state = 347},
  [8890] = {.lex_state = 347, .external_lex_state = 37},
  [8891] = {.lex_state = 347, .external_lex_state = 37},
  [8892] = {.lex_state = 347},
  [8893] = {.lex_state = 347, .external_lex_state = 41},
  [8894] = {.lex_state = 347, .external_lex_state = 29},
  [8895] = {.lex_state = 347},
  [8896] = {.lex_state = 347, .external_lex_state = 31},
  [8897] = {.lex_state = 347},
  [8898] = {.lex_state = 347},
  [8899] = {.lex_state = 347, .external_lex_state = 29},
  [8900] = {.lex_state = 347},
  [8901] = {.lex_state = 347, .external_lex_state = 31},
  [8902] = {.lex_state = 347},
  [8903] = {.lex_state = 347},
  [8904] = {.lex_state = 347},
  [8905] = {.lex_state = 347, .external_lex_state = 31},
  [8906] = {.lex_state = 347, .external_lex_state = 25},
  [8907] = {.lex_state = 347, .external_lex_state = 29},
  [8908] = {.lex_state = 347},
  [8909] = {.lex_state = 347, .external_lex_state = 37},
  [8910] = {.lex_state = 347, .external_lex_state = 41},
  [8911] = {.lex_state = 347, .external_lex_state = 37},
  [8912] = {.lex_state = 347},
  [8913] = {.lex_state = 347},
  [8914] = {.lex_state = 347, .external_lex_state = 37},
  [8915] = {.lex_state = 347},
  [8916] = {.lex_state = 347, .external_lex_state = 29},
  [8917] = {.lex_state = 347},
  [8918] = {.lex_state = 347},
  [8919] = {.lex_state = 347},
  [8920] = {.lex_state = 347},
  [8921] = {.lex_state = 347, .external_lex_state = 31},
  [8922] = {.lex_state = 347, .external_lex_state = 29},
  [8923] = {.lex_state = 347},
  [8924] = {.lex_state = 347, .external_lex_state = 37},
  [8925] = {.lex_state = 347},
  [8926] = {.lex_state = 347},
  [8927] = {.lex_state = 347, .external_lex_state = 29},
  [8928] = {.lex_state = 347, .external_lex_state = 29},
  [8929] = {.lex_state = 347},
  [8930] = {.lex_state = 347},
  [8931] = {.lex_state = 166, .external_lex_state = 42},
  [8932] = {.lex_state = 347, .external_lex_state = 25},
  [8933] = {.lex_state = 347},
  [8934] = {.lex_state = 347, .external_lex_state = 38},
  [8935] = {.lex_state = 347, .external_lex_state = 25},
  [8936] = {.lex_state = 347, .external_lex_state = 30},
  [8937] = {.lex_state = 347, .external_lex_state = 38},
  [8938] = {.lex_state = 347, .external_lex_state = 38},
  [8939] = {.lex_state = 347},
  [8940] = {.lex_state = 347, .external_lex_state = 37},
  [8941] = {.lex_state = 347, .external_lex_state = 38},
  [8942] = {.lex_state = 347},
  [8943] = {.lex_state = 347, .external_lex_state = 37},
  [8944] = {.lex_state = 347},
  [8945] = {.lex_state = 347, .external_lex_state = 37},
  [8946] = {.lex_state = 347},
  [8947] = {.lex_state = 347, .external_lex_state = 24},
  [8948] = {.lex_state = 347, .external_lex_state = 31},
  [8949] = {.lex_state = 347},
  [8950] = {.lex_state = 347},
  [8951] = {.lex_state = 347},
  [8952] = {.lex_state = 347, .external_lex_state = 24},
  [8953] = {.lex_state = 347},
  [8954] = {.lex_state = 347, .external_lex_state = 24},
  [8955] = {.lex_state = 347},
  [8956] = {.lex_state = 347, .external_lex_state = 42},
  [8957] = {.lex_state = 166, .external_lex_state = 42},
  [8958] = {.lex_state = 347, .external_lex_state = 24},
  [8959] = {.lex_state = 347},
  [8960] = {.lex_state = 347, .external_lex_state = 34},
  [8961] = {.lex_state = 184},
  [8962] = {.lex_state = 347, .external_lex_state = 25},
  [8963] = {.lex_state = 347, .external_lex_state = 34},
  [8964] = {.lex_state = 347},
  [8965] = {.lex_state = 347, .external_lex_state = 34},
  [8966] = {.lex_state = 184},
  [8967] = {.lex_state = 347, .external_lex_state = 38},
  [8968] = {.lex_state = 347, .external_lex_state = 38},
  [8969] = {.lex_state = 347},
  [8970] = {.lex_state = 347},
  [8971] = {.lex_state = 347},
  [8972] = {.lex_state = 347, .external_lex_state = 25},
  [8973] = {.lex_state = 347, .external_lex_state = 34},
  [8974] = {.lex_state = 347},
  [8975] = {.lex_state = 347, .external_lex_state = 38},
  [8976] = {.lex_state = 347, .external_lex_state = 38},
  [8977] = {.lex_state = 347},
  [8978] = {.lex_state = 133},
  [8979] = {.lex_state = 347},
  [8980] = {.lex_state = 347, .external_lex_state = 24},
  [8981] = {.lex_state = 133},
  [8982] = {.lex_state = 347},
  [8983] = {.lex_state = 347},
  [8984] = {.lex_state = 347},
  [8985] = {.lex_state = 347},
  [8986] = {.lex_state = 347, .external_lex_state = 38},
  [8987] = {.lex_state = 347, .external_lex_state = 24},
  [8988] = {.lex_state = 347, .external_lex_state = 38},
  [8989] = {.lex_state = 347, .external_lex_state = 38},
  [8990] = {.lex_state = 347, .external_lex_state = 38},
  [8991] = {.lex_state = 347, .external_lex_state = 38},
  [8992] = {.lex_state = 347},
  [8993] = {.lex_state = 347, .external_lex_state = 38},
  [8994] = {.lex_state = 347, .external_lex_state = 42},
  [8995] = {.lex_state = 166, .external_lex_state = 42},
  [8996] = {.lex_state = 347},
  [8997] = {.lex_state = 347, .external_lex_state = 38},
  [8998] = {.lex_state = 133},
  [8999] = {.lex_state = 347, .external_lex_state = 34},
  [9000] = {.lex_state = 166, .external_lex_state = 42},
  [9001] = {.lex_state = 347, .external_lex_state = 34},
  [9002] = {.lex_state = 347},
  [9003] = {.lex_state = 347, .external_lex_state = 42},
  [9004] = {.lex_state = 347, .external_lex_state = 25},
  [9005] = {.lex_state = 347},
  [9006] = {.lex_state = 347},
  [9007] = {.lex_state = 347, .external_lex_state = 34},
  [9008] = {.lex_state = 347},
  [9009] = {.lex_state = 347},
  [9010] = {.lex_state = 347},
  [9011] = {.lex_state = 347, .external_lex_state = 38},
  [9012] = {.lex_state = 347, .external_lex_state = 38},
  [9013] = {.lex_state = 347},
  [9014] = {.lex_state = 166, .external_lex_state = 42},
  [9015] = {.lex_state = 347, .external_lex_state = 38},
  [9016] = {.lex_state = 347, .external_lex_state = 38},
  [9017] = {.lex_state = 347},
  [9018] = {.lex_state = 347},
  [9019] = {.lex_state = 347, .external_lex_state = 42},
  [9020] = {.lex_state = 133},
  [9021] = {.lex_state = 347, .external_lex_state = 38},
  [9022] = {.lex_state = 347, .external_lex_state = 34},
  [9023] = {.lex_state = 347, .external_lex_state = 24},
  [9024] = {.lex_state = 166, .external_lex_state = 42},
  [9025] = {.lex_state = 347, .external_lex_state = 34},
  [9026] = {.lex_state = 347, .external_lex_state = 42},
  [9027] = {.lex_state = 347, .external_lex_state = 38},
  [9028] = {.lex_state = 347, .external_lex_state = 38},
  [9029] = {.lex_state = 347, .external_lex_state = 24},
  [9030] = {.lex_state = 347},
  [9031] = {.lex_state = 347},
  [9032] = {.lex_state = 347},
  [9033] = {.lex_state = 347, .external_lex_state = 31},
  [9034] = {.lex_state = 347, .external_lex_state = 24},
  [9035] = {.lex_state = 347, .external_lex_state = 25},
  [9036] = {.lex_state = 347, .external_lex_state = 37},
  [9037] = {.lex_state = 133},
  [9038] = {.lex_state = 347, .external_lex_state = 38},
  [9039] = {.lex_state = 347, .external_lex_state = 25},
  [9040] = {.lex_state = 347, .external_lex_state = 34},
  [9041] = {.lex_state = 347},
  [9042] = {.lex_state = 347, .external_lex_state = 34},
  [9043] = {.lex_state = 347},
  [9044] = {.lex_state = 347, .external_lex_state = 34},
  [9045] = {.lex_state = 347},
  [9046] = {.lex_state = 347},
  [9047] = {.lex_state = 347, .external_lex_state = 34},
  [9048] = {.lex_state = 347, .external_lex_state = 25},
  [9049] = {.lex_state = 133, .external_lex_state = 24},
  [9050] = {.lex_state = 347, .external_lex_state = 38},
  [9051] = {.lex_state = 133},
  [9052] = {.lex_state = 347},
  [9053] = {.lex_state = 184},
  [9054] = {.lex_state = 347},
  [9055] = {.lex_state = 347},
  [9056] = {.lex_state = 347, .external_lex_state = 25},
  [9057] = {.lex_state = 347},
  [9058] = {.lex_state = 184},
  [9059] = {.lex_state = 347, .external_lex_state = 34},
  [9060] = {.lex_state = 133},
  [9061] = {.lex_state = 133},
  [9062] = {.lex_state = 133},
  [9063] = {.lex_state = 347},
  [9064] = {.lex_state = 347},
  [9065] = {.lex_state = 347, .external_lex_state = 24},
  [9066] = {.lex_state = 133},
  [9067] = {.lex_state = 133},
  [9068] = {.lex_state = 347, .external_lex_state = 25},
  [9069] = {.lex_state = 133},
  [9070] = {.lex_state = 347, .external_lex_state = 42},
  [9071] = {.lex_state = 347, .external_lex_state = 24},
  [9072] = {.lex_state = 347, .external_lex_state = 31},
  [9073] = {.lex_state = 166, .external_lex_state = 42},
  [9074] = {.lex_state = 133},
  [9075] = {.lex_state = 347, .external_lex_state = 25},
  [9076] = {.lex_state = 347},
  [9077] = {.lex_state = 347, .external_lex_state = 25},
  [9078] = {.lex_state = 347, .external_lex_state = 25},
  [9079] = {.lex_state = 347},
  [9080] = {.lex_state = 133},
  [9081] = {.lex_state = 347},
  [9082] = {.lex_state = 347},
  [9083] = {.lex_state = 347, .external_lex_state = 24},
  [9084] = {.lex_state = 347},
  [9085] = {.lex_state = 133, .external_lex_state = 24},
  [9086] = {.lex_state = 133},
  [9087] = {.lex_state = 347},
  [9088] = {.lex_state = 347},
  [9089] = {.lex_state = 347, .external_lex_state = 42},
  [9090] = {.lex_state = 166, .external_lex_state = 42},
  [9091] = {.lex_state = 133},
  [9092] = {.lex_state = 133},
  [9093] = {.lex_state = 347, .external_lex_state = 24},
  [9094] = {.lex_state = 347, .external_lex_state = 42},
  [9095] = {.lex_state = 166, .external_lex_state = 42},
  [9096] = {.lex_state = 347},
  [9097] = {.lex_state = 347},
  [9098] = {.lex_state = 133},
  [9099] = {.lex_state = 347},
  [9100] = {.lex_state = 347},
  [9101] = {.lex_state = 347, .external_lex_state = 34},
  [9102] = {.lex_state = 347},
  [9103] = {.lex_state = 347},
  [9104] = {.lex_state = 133, .external_lex_state = 24},
  [9105] = {.lex_state = 347},
  [9106] = {.lex_state = 347, .external_lex_state = 24},
  [9107] = {.lex_state = 133},
  [9108] = {.lex_state = 133},
  [9109] = {.lex_state = 347},
  [9110] = {.lex_state = 347, .external_lex_state = 25},
  [9111] = {.lex_state = 347, .external_lex_state = 24},
  [9112] = {.lex_state = 133, .external_lex_state = 24},
  [9113] = {.lex_state = 347, .external_lex_state = 34},
  [9114] = {.lex_state = 347, .external_lex_state = 24},
  [9115] = {.lex_state = 133},
  [9116] = {.lex_state = 347, .external_lex_state = 24},
  [9117] = {.lex_state = 347, .external_lex_state = 24},
  [9118] = {.lex_state = 347},
  [9119] = {.lex_state = 347},
  [9120] = {.lex_state = 347, .external_lex_state = 24},
  [9121] = {.lex_state = 347, .external_lex_state = 42},
  [9122] = {.lex_state = 347},
  [9123] = {.lex_state = 347},
  [9124] = {.lex_state = 133},
  [9125] = {.lex_state = 166, .external_lex_state = 42},
  [9126] = {.lex_state = 133},
  [9127] = {.lex_state = 347},
  [9128] = {.lex_state = 347, .external_lex_state = 25},
  [9129] = {.lex_state = 347, .external_lex_state = 24},
  [9130] = {.lex_state = 347, .external_lex_state = 24},
  [9131] = {.lex_state = 347},
  [9132] = {.lex_state = 347, .external_lex_state = 24},
  [9133] = {.lex_state = 133},
  [9134] = {.lex_state = 347, .external_lex_state = 35},
  [9135] = {.lex_state = 347},
  [9136] = {.lex_state = 347},
  [9137] = {.lex_state = 347},
  [9138] = {.lex_state = 347, .external_lex_state = 42},
  [9139] = {.lex_state = 347},
  [9140] = {.lex_state = 133},
  [9141] = {.lex_state = 347, .external_lex_state = 24},
  [9142] = {.lex_state = 347},
  [9143] = {.lex_state = 347},
  [9144] = {.lex_state = 347, .external_lex_state = 24},
  [9145] = {.lex_state = 133, .external_lex_state = 24},
  [9146] = {.lex_state = 347, .external_lex_state = 25},
  [9147] = {.lex_state = 133},
  [9148] = {.lex_state = 133},
  [9149] = {.lex_state = 347},
  [9150] = {.lex_state = 347, .external_lex_state = 24},
  [9151] = {.lex_state = 133},
  [9152] = {.lex_state = 347},
  [9153] = {.lex_state = 347, .external_lex_state = 34},
  [9154] = {.lex_state = 347, .external_lex_state = 24},
  [9155] = {.lex_state = 347},
  [9156] = {.lex_state = 347, .external_lex_state = 34},
  [9157] = {.lex_state = 347},
  [9158] = {.lex_state = 133},
  [9159] = {.lex_state = 347},
  [9160] = {.lex_state = 347, .external_lex_state = 34},
  [9161] = {.lex_state = 133},
  [9162] = {.lex_state = 133, .external_lex_state = 24},
  [9163] = {.lex_state = 133},
  [9164] = {.lex_state = 347, .external_lex_state = 34},
  [9165] = {.lex_state = 347},
  [9166] = {.lex_state = 347},
  [9167] = {.lex_state = 347, .external_lex_state = 34},
  [9168] = {.lex_state = 347},
  [9169] = {.lex_state = 347},
  [9170] = {.lex_state = 347},
  [9171] = {.lex_state = 347, .external_lex_state = 24},
  [9172] = {.lex_state = 133},
  [9173] = {.lex_state = 133},
  [9174] = {.lex_state = 347},
  [9175] = {.lex_state = 347},
  [9176] = {.lex_state = 347, .external_lex_state = 25},
  [9177] = {.lex_state = 347},
  [9178] = {.lex_state = 166, .external_lex_state = 42},
  [9179] = {.lex_state = 347, .external_lex_state = 42},
  [9180] = {.lex_state = 133, .external_lex_state = 24},
  [9181] = {.lex_state = 166, .external_lex_state = 42},
  [9182] = {.lex_state = 166, .external_lex_state = 42},
  [9183] = {.lex_state = 347, .external_lex_state = 42},
  [9184] = {.lex_state = 133},
  [9185] = {.lex_state = 347},
  [9186] = {.lex_state = 347, .external_lex_state = 42},
  [9187] = {.lex_state = 166, .external_lex_state = 42},
  [9188] = {.lex_state = 347, .external_lex_state = 42},
  [9189] = {.lex_state = 347},
  [9190] = {.lex_state = 347},
  [9191] = {.lex_state = 347, .external_lex_state = 31},
  [9192] = {.lex_state = 347},
  [9193] = {.lex_state = 347, .external_lex_state = 25},
  [9194] = {.lex_state = 347},
  [9195] = {.lex_state = 133},
  [9196] = {.lex_state = 133},
  [9197] = {.lex_state = 347},
  [9198] = {.lex_state = 347, .external_lex_state = 25},
  [9199] = {.lex_state = 347, .external_lex_state = 42},
  [9200] = {.lex_state = 166, .external_lex_state = 42},
  [9201] = {.lex_state = 347},
  [9202] = {.lex_state = 347},
  [9203] = {.lex_state = 347, .external_lex_state = 34},
  [9204] = {.lex_state = 133, .external_lex_state = 24},
  [9205] = {.lex_state = 347, .external_lex_state = 42},
  [9206] = {.lex_state = 347},
  [9207] = {.lex_state = 166, .external_lex_state = 42},
  [9208] = {.lex_state = 347},
  [9209] = {.lex_state = 347},
  [9210] = {.lex_state = 347},
  [9211] = {.lex_state = 347},
  [9212] = {.lex_state = 347, .external_lex_state = 24},
  [9213] = {.lex_state = 347, .external_lex_state = 34},
  [9214] = {.lex_state = 133},
  [9215] = {.lex_state = 347, .external_lex_state = 34},
  [9216] = {.lex_state = 347},
  [9217] = {.lex_state = 347},
  [9218] = {.lex_state = 133, .external_lex_state = 24},
  [9219] = {.lex_state = 347, .external_lex_state = 34},
  [9220] = {.lex_state = 347},
  [9221] = {.lex_state = 347, .external_lex_state = 25},
  [9222] = {.lex_state = 347, .external_lex_state = 24},
  [9223] = {.lex_state = 347},
  [9224] = {.lex_state = 347, .external_lex_state = 34},
  [9225] = {.lex_state = 347, .external_lex_state = 34},
  [9226] = {.lex_state = 133},
  [9227] = {.lex_state = 347},
  [9228] = {.lex_state = 347, .external_lex_state = 24},
  [9229] = {.lex_state = 347, .external_lex_state = 24},
  [9230] = {.lex_state = 347, .external_lex_state = 34},
  [9231] = {.lex_state = 133},
  [9232] = {.lex_state = 347},
  [9233] = {.lex_state = 133},
  [9234] = {.lex_state = 347},
  [9235] = {.lex_state = 347, .external_lex_state = 34},
  [9236] = {.lex_state = 347},
  [9237] = {.lex_state = 347},
  [9238] = {.lex_state = 347},
  [9239] = {.lex_state = 133},
  [9240] = {.lex_state = 347, .external_lex_state = 42},
  [9241] = {.lex_state = 166, .external_lex_state = 42},
  [9242] = {.lex_state = 133},
  [9243] = {.lex_state = 347},
  [9244] = {.lex_state = 347, .external_lex_state = 24},
  [9245] = {.lex_state = 347, .external_lex_state = 24},
  [9246] = {.lex_state = 347, .external_lex_state = 34},
  [9247] = {.lex_state = 347, .external_lex_state = 24},
  [9248] = {.lex_state = 347, .external_lex_state = 35},
  [9249] = {.lex_state = 133},
  [9250] = {.lex_state = 347},
  [9251] = {.lex_state = 347},
  [9252] = {.lex_state = 347},
  [9253] = {.lex_state = 347},
  [9254] = {.lex_state = 347},
  [9255] = {.lex_state = 347, .external_lex_state = 34},
  [9256] = {.lex_state = 133},
  [9257] = {.lex_state = 347, .external_lex_state = 34},
  [9258] = {.lex_state = 347},
  [9259] = {.lex_state = 347},
  [9260] = {.lex_state = 347},
  [9261] = {.lex_state = 347},
  [9262] = {.lex_state = 347},
  [9263] = {.lex_state = 133},
  [9264] = {.lex_state = 184},
  [9265] = {.lex_state = 133},
  [9266] = {.lex_state = 347},
  [9267] = {.lex_state = 347, .external_lex_state = 30},
  [9268] = {.lex_state = 347, .external_lex_state = 34},
  [9269] = {.lex_state = 133},
  [9270] = {.lex_state = 347},
  [9271] = {.lex_state = 347},
  [9272] = {.lex_state = 347, .external_lex_state = 24},
  [9273] = {.lex_state = 133},
  [9274] = {.lex_state = 347},
  [9275] = {.lex_state = 347, .external_lex_state = 24},
  [9276] = {.lex_state = 347},
  [9277] = {.lex_state = 347, .external_lex_state = 34},
  [9278] = {.lex_state = 347, .external_lex_state = 34},
  [9279] = {.lex_state = 133},
  [9280] = {.lex_state = 347, .external_lex_state = 34},
  [9281] = {.lex_state = 347, .external_lex_state = 30},
  [9282] = {.lex_state = 133},
  [9283] = {.lex_state = 347},
  [9284] = {.lex_state = 347},
  [9285] = {.lex_state = 347, .external_lex_state = 34},
  [9286] = {.lex_state = 184},
  [9287] = {.lex_state = 347, .external_lex_state = 42},
  [9288] = {.lex_state = 347},
  [9289] = {.lex_state = 347},
  [9290] = {.lex_state = 166, .external_lex_state = 42},
  [9291] = {.lex_state = 347},
  [9292] = {.lex_state = 347, .external_lex_state = 24},
  [9293] = {.lex_state = 347},
  [9294] = {.lex_state = 133, .external_lex_state = 24},
  [9295] = {.lex_state = 347, .external_lex_state = 35},
  [9296] = {.lex_state = 133},
  [9297] = {.lex_state = 347, .external_lex_state = 24},
  [9298] = {.lex_state = 133},
  [9299] = {.lex_state = 347, .external_lex_state = 42},
  [9300] = {.lex_state = 166, .external_lex_state = 42},
  [9301] = {.lex_state = 347},
  [9302] = {.lex_state = 133, .external_lex_state = 24},
  [9303] = {.lex_state = 347, .external_lex_state = 42},
  [9304] = {.lex_state = 133},
  [9305] = {.lex_state = 133},
  [9306] = {.lex_state = 347, .external_lex_state = 25},
  [9307] = {.lex_state = 347, .external_lex_state = 24},
  [9308] = {.lex_state = 347, .external_lex_state = 24},
  [9309] = {.lex_state = 347},
  [9310] = {.lex_state = 166, .external_lex_state = 42},
  [9311] = {.lex_state = 347},
  [9312] = {.lex_state = 347, .external_lex_state = 31},
  [9313] = {.lex_state = 133},
  [9314] = {.lex_state = 347},
  [9315] = {.lex_state = 347},
  [9316] = {.lex_state = 347, .external_lex_state = 24},
  [9317] = {.lex_state = 347},
  [9318] = {.lex_state = 347},
  [9319] = {.lex_state = 347, .external_lex_state = 24},
  [9320] = {.lex_state = 133},
  [9321] = {.lex_state = 347, .external_lex_state = 24},
  [9322] = {.lex_state = 347, .external_lex_state = 24},
  [9323] = {.lex_state = 347},
  [9324] = {.lex_state = 347, .external_lex_state = 24},
  [9325] = {.lex_state = 347, .external_lex_state = 35},
  [9326] = {.lex_state = 133},
  [9327] = {.lex_state = 347},
  [9328] = {.lex_state = 133},
  [9329] = {.lex_state = 347, .external_lex_state = 24},
  [9330] = {.lex_state = 347, .external_lex_state = 24},
  [9331] = {.lex_state = 347},
  [9332] = {.lex_state = 347},
  [9333] = {.lex_state = 347, .external_lex_state = 42},
  [9334] = {.lex_state = 347, .external_lex_state = 24},
  [9335] = {.lex_state = 347, .external_lex_state = 42},
  [9336] = {.lex_state = 133},
  [9337] = {.lex_state = 166, .external_lex_state = 42},
  [9338] = {.lex_state = 133},
  [9339] = {.lex_state = 347},
  [9340] = {.lex_state = 347, .external_lex_state = 24},
  [9341] = {.lex_state = 166, .external_lex_state = 42},
  [9342] = {.lex_state = 347, .external_lex_state = 42},
  [9343] = {.lex_state = 133},
  [9344] = {.lex_state = 133, .external_lex_state = 24},
  [9345] = {.lex_state = 347},
  [9346] = {.lex_state = 166, .external_lex_state = 42},
  [9347] = {.lex_state = 347},
  [9348] = {.lex_state = 133},
  [9349] = {.lex_state = 347},
  [9350] = {.lex_state = 347},
  [9351] = {.lex_state = 347, .external_lex_state = 24},
  [9352] = {.lex_state = 347, .external_lex_state = 34},
  [9353] = {.lex_state = 347, .external_lex_state = 25},
  [9354] = {.lex_state = 133},
  [9355] = {.lex_state = 166, .external_lex_state = 42},
  [9356] = {.lex_state = 347, .external_lex_state = 42},
  [9357] = {.lex_state = 133},
  [9358] = {.lex_state = 347},
  [9359] = {.lex_state = 133, .external_lex_state = 24},
  [9360] = {.lex_state = 184},
  [9361] = {.lex_state = 347, .external_lex_state = 34},
  [9362] = {.lex_state = 347, .external_lex_state = 34},
  [9363] = {.lex_state = 347},
  [9364] = {.lex_state = 133},
  [9365] = {.lex_state = 347},
  [9366] = {.lex_state = 347, .external_lex_state = 24},
  [9367] = {.lex_state = 347},
  [9368] = {.lex_state = 347, .external_lex_state = 24},
  [9369] = {.lex_state = 347, .external_lex_state = 31},
  [9370] = {.lex_state = 347},
  [9371] = {.lex_state = 166, .external_lex_state = 42},
  [9372] = {.lex_state = 347, .external_lex_state = 42},
  [9373] = {.lex_state = 133},
  [9374] = {.lex_state = 347, .external_lex_state = 34},
  [9375] = {.lex_state = 347},
  [9376] = {.lex_state = 347, .external_lex_state = 24},
  [9377] = {.lex_state = 347},
  [9378] = {.lex_state = 347},
  [9379] = {.lex_state = 347, .external_lex_state = 42},
  [9380] = {.lex_state = 347, .external_lex_state = 42},
  [9381] = {.lex_state = 347, .external_lex_state = 42},
  [9382] = {.lex_state = 347, .external_lex_state = 42},
  [9383] = {.lex_state = 347},
  [9384] = {.lex_state = 347},
  [9385] = {.lex_state = 347, .external_lex_state = 42},
  [9386] = {.lex_state = 347, .external_lex_state = 42},
  [9387] = {.lex_state = 347, .external_lex_state = 43},
  [9388] = {.lex_state = 347, .external_lex_state = 42},
  [9389] = {.lex_state = 347, .external_lex_state = 42},
  [9390] = {.lex_state = 347, .external_lex_state = 42},
  [9391] = {.lex_state = 347, .external_lex_state = 42},
  [9392] = {.lex_state = 347},
  [9393] = {.lex_state = 347, .external_lex_state = 42},
  [9394] = {.lex_state = 347},
  [9395] = {.lex_state = 347, .external_lex_state = 31},
  [9396] = {.lex_state = 347, .external_lex_state = 43},
  [9397] = {.lex_state = 347, .external_lex_state = 42},
  [9398] = {.lex_state = 347},
  [9399] = {.lex_state = 347, .external_lex_state = 42},
  [9400] = {.lex_state = 347},
  [9401] = {.lex_state = 347},
  [9402] = {.lex_state = 347, .external_lex_state = 42},
  [9403] = {.lex_state = 347, .external_lex_state = 42},
  [9404] = {.lex_state = 347, .external_lex_state = 42},
  [9405] = {.lex_state = 347},
  [9406] = {.lex_state = 347},
  [9407] = {.lex_state = 347, .external_lex_state = 42},
  [9408] = {.lex_state = 347, .external_lex_state = 42},
  [9409] = {.lex_state = 347, .external_lex_state = 42},
  [9410] = {.lex_state = 347, .external_lex_state = 42},
  [9411] = {.lex_state = 347, .external_lex_state = 42},
  [9412] = {.lex_state = 347, .external_lex_state = 42},
  [9413] = {.lex_state = 347, .external_lex_state = 42},
  [9414] = {.lex_state = 347, .external_lex_state = 42},
  [9415] = {.lex_state = 347},
  [9416] = {.lex_state = 347, .external_lex_state = 42},
  [9417] = {.lex_state = 347, .external_lex_state = 42},
  [9418] = {.lex_state = 347, .external_lex_state = 42},
  [9419] = {.lex_state = 347, .external_lex_state = 42},
  [9420] = {.lex_state = 347, .external_lex_state = 42},
  [9421] = {.lex_state = 347},
  [9422] = {.lex_state = 347, .external_lex_state = 42},
  [9423] = {.lex_state = 347},
  [9424] = {.lex_state = 347, .external_lex_state = 42},
  [9425] = {.lex_state = 347, .external_lex_state = 42},
  [9426] = {.lex_state = 347, .external_lex_state = 42},
  [9427] = {.lex_state = 347, .external_lex_state = 42},
  [9428] = {.lex_state = 347},
  [9429] = {.lex_state = 347, .external_lex_state = 42},
  [9430] = {.lex_state = 347, .external_lex_state = 42},
  [9431] = {.lex_state = 347},
  [9432] = {.lex_state = 347, .external_lex_state = 42},
  [9433] = {.lex_state = 347, .external_lex_state = 42},
  [9434] = {.lex_state = 347, .external_lex_state = 42},
  [9435] = {.lex_state = 347, .external_lex_state = 42},
  [9436] = {.lex_state = 347, .external_lex_state = 25},
  [9437] = {.lex_state = 347, .external_lex_state = 42},
  [9438] = {.lex_state = 347, .external_lex_state = 42},
  [9439] = {.lex_state = 347, .external_lex_state = 42},
  [9440] = {.lex_state = 347, .external_lex_state = 42},
  [9441] = {.lex_state = 347, .external_lex_state = 42},
  [9442] = {.lex_state = 347, .external_lex_state = 42},
  [9443] = {.lex_state = 347},
  [9444] = {.lex_state = 347, .external_lex_state = 42},
  [9445] = {.lex_state = 347, .external_lex_state = 43},
  [9446] = {.lex_state = 347},
  [9447] = {.lex_state = 347, .external_lex_state = 42},
  [9448] = {.lex_state = 347, .external_lex_state = 42},
  [9449] = {.lex_state = 347, .external_lex_state = 42},
  [9450] = {.lex_state = 347, .external_lex_state = 42},
  [9451] = {.lex_state = 347, .external_lex_state = 42},
  [9452] = {.lex_state = 347, .external_lex_state = 42},
  [9453] = {.lex_state = 347, .external_lex_state = 42},
  [9454] = {.lex_state = 347, .external_lex_state = 42},
  [9455] = {.lex_state = 347, .external_lex_state = 42},
  [9456] = {.lex_state = 347, .external_lex_state = 42},
  [9457] = {.lex_state = 347, .external_lex_state = 42},
  [9458] = {.lex_state = 347, .external_lex_state = 42},
  [9459] = {.lex_state = 347},
  [9460] = {.lex_state = 347, .external_lex_state = 42},
  [9461] = {.lex_state = 347},
  [9462] = {.lex_state = 347, .external_lex_state = 42},
  [9463] = {.lex_state = 347, .external_lex_state = 43},
  [9464] = {.lex_state = 347},
  [9465] = {.lex_state = 347, .external_lex_state = 42},
  [9466] = {.lex_state = 347},
  [9467] = {.lex_state = 347, .external_lex_state = 42},
  [9468] = {.lex_state = 347, .external_lex_state = 42},
  [9469] = {.lex_state = 347, .external_lex_state = 43},
  [9470] = {.lex_state = 347, .external_lex_state = 42},
  [9471] = {.lex_state = 347, .external_lex_state = 42},
  [9472] = {.lex_state = 347, .external_lex_state = 42},
  [9473] = {.lex_state = 347, .external_lex_state = 42},
  [9474] = {.lex_state = 347, .external_lex_state = 42},
  [9475] = {.lex_state = 347, .external_lex_state = 42},
  [9476] = {.lex_state = 347},
  [9477] = {.lex_state = 347, .external_lex_state = 42},
  [9478] = {.lex_state = 347, .external_lex_state = 42},
  [9479] = {.lex_state = 347},
  [9480] = {.lex_state = 347, .external_lex_state = 42},
  [9481] = {.lex_state = 347},
  [9482] = {.lex_state = 347, .external_lex_state = 42},
  [9483] = {.lex_state = 347},
  [9484] = {.lex_state = 347, .external_lex_state = 42},
  [9485] = {.lex_state = 347},
  [9486] = {.lex_state = 347, .external_lex_state = 42},
  [9487] = {.lex_state = 347, .external_lex_state = 42},
  [9488] = {.lex_state = 347, .external_lex_state = 42},
  [9489] = {.lex_state = 347, .external_lex_state = 42},
  [9490] = {.lex_state = 347, .external_lex_state = 42},
  [9491] = {.lex_state = 347, .external_lex_state = 35},
  [9492] = {.lex_state = 347, .external_lex_state = 42},
  [9493] = {.lex_state = 347, .external_lex_state = 42},
  [9494] = {.lex_state = 347, .external_lex_state = 42},
  [9495] = {.lex_state = 347, .external_lex_state = 42},
  [9496] = {.lex_state = 347, .external_lex_state = 42},
  [9497] = {.lex_state = 347, .external_lex_state = 42},
  [9498] = {.lex_state = 347, .external_lex_state = 42},
  [9499] = {.lex_state = 347, .external_lex_state = 42},
  [9500] = {.lex_state = 347, .external_lex_state = 42},
  [9501] = {.lex_state = 347, .external_lex_state = 42},
  [9502] = {.lex_state = 347, .external_lex_state = 42},
  [9503] = {.lex_state = 347},
  [9504] = {.lex_state = 347, .external_lex_state = 35},
  [9505] = {.lex_state = 347, .external_lex_state = 42},
  [9506] = {.lex_state = 347, .external_lex_state = 43},
  [9507] = {.lex_state = 347, .external_lex_state = 42},
  [9508] = {.lex_state = 347},
  [9509] = {.lex_state = 347, .external_lex_state = 42},
  [9510] = {.lex_state = 347},
  [9511] = {.lex_state = 347, .external_lex_state = 42},
  [9512] = {.lex_state = 347, .external_lex_state = 42},
  [9513] = {.lex_state = 347, .external_lex_state = 42},
  [9514] = {.lex_state = 347},
  [9515] = {.lex_state = 347, .external_lex_state = 42},
  [9516] = {.lex_state = 347, .external_lex_state = 42},
  [9517] = {.lex_state = 347, .external_lex_state = 42},
  [9518] = {.lex_state = 347, .external_lex_state = 35},
  [9519] = {.lex_state = 347},
  [9520] = {.lex_state = 347, .external_lex_state = 42},
  [9521] = {.lex_state = 347, .external_lex_state = 31},
  [9522] = {.lex_state = 347, .external_lex_state = 42},
  [9523] = {.lex_state = 347},
  [9524] = {.lex_state = 347, .external_lex_state = 42},
  [9525] = {.lex_state = 347, .external_lex_state = 42},
  [9526] = {.lex_state = 347, .external_lex_state = 43},
  [9527] = {.lex_state = 347, .external_lex_state = 25},
  [9528] = {.lex_state = 347, .external_lex_state = 42},
  [9529] = {.lex_state = 347, .external_lex_state = 42},
  [9530] = {.lex_state = 347, .external_lex_state = 42},
  [9531] = {.lex_state = 347, .external_lex_state = 42},
  [9532] = {.lex_state = 347, .external_lex_state = 42},
  [9533] = {.lex_state = 347, .external_lex_state = 42},
  [9534] = {.lex_state = 347},
  [9535] = {.lex_state = 347},
  [9536] = {.lex_state = 347},
  [9537] = {.lex_state = 347},
  [9538] = {.lex_state = 347, .external_lex_state = 42},
  [9539] = {.lex_state = 347, .external_lex_state = 42},
  [9540] = {.lex_state = 347, .external_lex_state = 42},
  [9541] = {.lex_state = 347},
  [9542] = {.lex_state = 347, .external_lex_state = 25},
  [9543] = {.lex_state = 347},
  [9544] = {.lex_state = 347, .external_lex_state = 42},
  [9545] = {.lex_state = 347, .external_lex_state = 42},
  [9546] = {.lex_state = 347, .external_lex_state = 35},
  [9547] = {.lex_state = 347, .external_lex_state = 35},
  [9548] = {.lex_state = 347, .external_lex_state = 34},
  [9549] = {.lex_state = 347},
  [9550] = {.lex_state = 347, .external_lex_state = 43},
  [9551] = {.lex_state = 347},
  [9552] = {.lex_state = 347, .external_lex_state = 42},
  [9553] = {.lex_state = 347},
  [9554] = {.lex_state = 347},
  [9555] = {.lex_state = 347},
  [9556] = {.lex_state = 347, .external_lex_state = 42},
  [9557] = {.lex_state = 347, .external_lex_state = 42},
  [9558] = {.lex_state = 347, .external_lex_state = 42},
  [9559] = {.lex_state = 347, .external_lex_state = 42},
  [9560] = {.lex_state = 347, .external_lex_state = 42},
  [9561] = {.lex_state = 347, .external_lex_state = 42},
  [9562] = {.lex_state = 347, .external_lex_state = 42},
  [9563] = {.lex_state = 347},
  [9564] = {.lex_state = 347},
  [9565] = {.lex_state = 347, .external_lex_state = 42},
  [9566] = {.lex_state = 347},
  [9567] = {.lex_state = 347, .external_lex_state = 42},
  [9568] = {.lex_state = 347},
  [9569] = {.lex_state = 347, .external_lex_state = 42},
  [9570] = {.lex_state = 347, .external_lex_state = 42},
  [9571] = {.lex_state = 347, .external_lex_state = 42},
  [9572] = {.lex_state = 347, .external_lex_state = 42},
  [9573] = {.lex_state = 193},
  [9574] = {.lex_state = 347, .external_lex_state = 42},
  [9575] = {.lex_state = 347, .external_lex_state = 42},
  [9576] = {.lex_state = 347, .external_lex_state = 42},
  [9577] = {.lex_state = 347, .external_lex_state = 42},
  [9578] = {.lex_state = 347, .external_lex_state = 42},
  [9579] = {.lex_state = 347, .external_lex_state = 42},
  [9580] = {.lex_state = 347, .external_lex_state = 42},
  [9581] = {.lex_state = 347, .external_lex_state = 42},
  [9582] = {.lex_state = 347, .external_lex_state = 42},
  [9583] = {.lex_state = 347},
  [9584] = {.lex_state = 347, .external_lex_state = 42},
  [9585] = {.lex_state = 347},
  [9586] = {.lex_state = 347, .external_lex_state = 42},
  [9587] = {.lex_state = 347, .external_lex_state = 42},
  [9588] = {.lex_state = 347, .external_lex_state = 43},
  [9589] = {.lex_state = 347, .external_lex_state = 42},
  [9590] = {.lex_state = 347, .external_lex_state = 42},
  [9591] = {.lex_state = 347, .external_lex_state = 42},
  [9592] = {.lex_state = 347},
  [9593] = {.lex_state = 347, .external_lex_state = 42},
  [9594] = {.lex_state = 347, .external_lex_state = 42},
  [9595] = {.lex_state = 347, .external_lex_state = 42},
  [9596] = {.lex_state = 347},
  [9597] = {.lex_state = 347, .external_lex_state = 42},
  [9598] = {.lex_state = 347, .external_lex_state = 42},
  [9599] = {.lex_state = 347, .external_lex_state = 42},
  [9600] = {.lex_state = 347, .external_lex_state = 42},
  [9601] = {.lex_state = 347},
  [9602] = {.lex_state = 347, .external_lex_state = 42},
  [9603] = {.lex_state = 347, .external_lex_state = 42},
  [9604] = {.lex_state = 347, .external_lex_state = 42},
  [9605] = {.lex_state = 347, .external_lex_state = 25},
  [9606] = {.lex_state = 347, .external_lex_state = 42},
  [9607] = {.lex_state = 347, .external_lex_state = 42},
  [9608] = {.lex_state = 347},
  [9609] = {.lex_state = 347, .external_lex_state = 42},
  [9610] = {.lex_state = 347, .external_lex_state = 42},
  [9611] = {.lex_state = 347, .external_lex_state = 42},
  [9612] = {.lex_state = 347},
  [9613] = {.lex_state = 193},
  [9614] = {.lex_state = 347, .external_lex_state = 42},
  [9615] = {.lex_state = 347, .external_lex_state = 42},
  [9616] = {.lex_state = 347},
  [9617] = {.lex_state = 347},
  [9618] = {.lex_state = 193},
  [9619] = {.lex_state = 347, .external_lex_state = 42},
  [9620] = {.lex_state = 347, .external_lex_state = 42},
  [9621] = {.lex_state = 347, .external_lex_state = 42},
  [9622] = {.lex_state = 347},
  [9623] = {.lex_state = 347, .external_lex_state = 42},
  [9624] = {.lex_state = 347},
  [9625] = {.lex_state = 347, .external_lex_state = 42},
  [9626] = {.lex_state = 347, .external_lex_state = 42},
  [9627] = {.lex_state = 347, .external_lex_state = 43},
  [9628] = {.lex_state = 347, .external_lex_state = 42},
  [9629] = {.lex_state = 347, .external_lex_state = 43},
  [9630] = {.lex_state = 347, .external_lex_state = 42},
  [9631] = {.lex_state = 347, .external_lex_state = 42},
  [9632] = {.lex_state = 347, .external_lex_state = 42},
  [9633] = {.lex_state = 347},
  [9634] = {.lex_state = 347, .external_lex_state = 42},
  [9635] = {.lex_state = 347},
  [9636] = {.lex_state = 347},
  [9637] = {.lex_state = 347, .external_lex_state = 43},
  [9638] = {.lex_state = 347},
  [9639] = {.lex_state = 347, .external_lex_state = 42},
  [9640] = {.lex_state = 347, .external_lex_state = 42},
  [9641] = {.lex_state = 347},
  [9642] = {.lex_state = 347},
  [9643] = {.lex_state = 347, .external_lex_state = 35},
  [9644] = {.lex_state = 347},
  [9645] = {.lex_state = 347, .external_lex_state = 42},
  [9646] = {.lex_state = 347},
  [9647] = {.lex_state = 347, .external_lex_state = 42},
  [9648] = {.lex_state = 347, .external_lex_state = 42},
  [9649] = {.lex_state = 347, .external_lex_state = 42},
  [9650] = {.lex_state = 347, .external_lex_state = 42},
  [9651] = {.lex_state = 347, .external_lex_state = 42},
  [9652] = {.lex_state = 347, .external_lex_state = 42},
  [9653] = {.lex_state = 347, .external_lex_state = 43},
  [9654] = {.lex_state = 347},
  [9655] = {.lex_state = 347},
  [9656] = {.lex_state = 347},
  [9657] = {.lex_state = 347, .external_lex_state = 42},
  [9658] = {.lex_state = 347, .external_lex_state = 42},
  [9659] = {.lex_state = 347, .external_lex_state = 42},
  [9660] = {.lex_state = 347, .external_lex_state = 42},
  [9661] = {.lex_state = 347, .external_lex_state = 42},
  [9662] = {.lex_state = 347, .external_lex_state = 42},
  [9663] = {.lex_state = 347, .external_lex_state = 42},
  [9664] = {.lex_state = 347, .external_lex_state = 42},
  [9665] = {.lex_state = 347, .external_lex_state = 42},
  [9666] = {.lex_state = 347, .external_lex_state = 42},
  [9667] = {.lex_state = 347},
  [9668] = {.lex_state = 347, .external_lex_state = 42},
  [9669] = {.lex_state = 347},
  [9670] = {.lex_state = 347},
  [9671] = {.lex_state = 347},
  [9672] = {.lex_state = 347, .external_lex_state = 25},
  [9673] = {.lex_state = 347, .external_lex_state = 42},
  [9674] = {.lex_state = 347, .external_lex_state = 42},
  [9675] = {.lex_state = 347, .external_lex_state = 42},
  [9676] = {.lex_state = 347, .external_lex_state = 42},
  [9677] = {.lex_state = 347, .external_lex_state = 25},
  [9678] = {.lex_state = 193},
  [9679] = {.lex_state = 347, .external_lex_state = 42},
  [9680] = {.lex_state = 347, .external_lex_state = 42},
  [9681] = {.lex_state = 347, .external_lex_state = 42},
  [9682] = {.lex_state = 347, .external_lex_state = 42},
  [9683] = {.lex_state = 347, .external_lex_state = 42},
  [9684] = {.lex_state = 193},
  [9685] = {.lex_state = 347},
  [9686] = {.lex_state = 347},
  [9687] = {.lex_state = 347, .external_lex_state = 42},
  [9688] = {.lex_state = 347, .external_lex_state = 42},
  [9689] = {.lex_state = 347},
  [9690] = {.lex_state = 347, .external_lex_state = 42},
  [9691] = {.lex_state = 347, .external_lex_state = 43},
  [9692] = {.lex_state = 347, .external_lex_state = 42},
  [9693] = {.lex_state = 347, .external_lex_state = 42},
  [9694] = {.lex_state = 347},
  [9695] = {.lex_state = 347, .external_lex_state = 42},
  [9696] = {.lex_state = 347, .external_lex_state = 42},
  [9697] = {.lex_state = 347},
  [9698] = {.lex_state = 347, .external_lex_state = 42},
  [9699] = {.lex_state = 347, .external_lex_state = 35},
  [9700] = {.lex_state = 347},
  [9701] = {.lex_state = 347, .external_lex_state = 42},
  [9702] = {.lex_state = 347, .external_lex_state = 42},
  [9703] = {.lex_state = 347, .external_lex_state = 42},
  [9704] = {.lex_state = 347, .external_lex_state = 42},
  [9705] = {.lex_state = 347, .external_lex_state = 42},
  [9706] = {.lex_state = 347},
  [9707] = {.lex_state = 347, .external_lex_state = 35},
  [9708] = {.lex_state = 347, .external_lex_state = 42},
  [9709] = {.lex_state = 347, .external_lex_state = 42},
  [9710] = {.lex_state = 347, .external_lex_state = 42},
  [9711] = {.lex_state = 166},
  [9712] = {.lex_state = 347, .external_lex_state = 35},
  [9713] = {.lex_state = 347, .external_lex_state = 25},
  [9714] = {.lex_state = 347, .external_lex_state = 42},
  [9715] = {.lex_state = 347, .external_lex_state = 42},
  [9716] = {.lex_state = 347, .external_lex_state = 35},
  [9717] = {.lex_state = 347, .external_lex_state = 42},
  [9718] = {.lex_state = 347, .external_lex_state = 42},
  [9719] = {.lex_state = 347},
  [9720] = {.lex_state = 347, .external_lex_state = 35},
  [9721] = {.lex_state = 347, .external_lex_state = 42},
  [9722] = {.lex_state = 347, .external_lex_state = 43},
  [9723] = {.lex_state = 347, .external_lex_state = 42},
  [9724] = {.lex_state = 347},
  [9725] = {.lex_state = 347, .external_lex_state = 42},
  [9726] = {.lex_state = 347, .external_lex_state = 35},
  [9727] = {.lex_state = 347, .external_lex_state = 42},
  [9728] = {.lex_state = 347, .external_lex_state = 42},
  [9729] = {.lex_state = 347, .external_lex_state = 42},
  [9730] = {.lex_state = 347, .external_lex_state = 42},
  [9731] = {.lex_state = 193},
  [9732] = {.lex_state = 347},
  [9733] = {.lex_state = 347, .external_lex_state = 42},
  [9734] = {.lex_state = 347, .external_lex_state = 42},
  [9735] = {.lex_state = 347},
  [9736] = {.lex_state = 347, .external_lex_state = 42},
  [9737] = {.lex_state = 347, .external_lex_state = 42},
  [9738] = {.lex_state = 193},
  [9739] = {.lex_state = 347},
  [9740] = {.lex_state = 133, .external_lex_state = 24},
  [9741] = {.lex_state = 347, .external_lex_state = 43},
  [9742] = {.lex_state = 347, .external_lex_state = 42},
  [9743] = {.lex_state = 347, .external_lex_state = 42},
  [9744] = {.lex_state = 347, .external_lex_state = 42},
  [9745] = {.lex_state = 347, .external_lex_state = 42},
  [9746] = {.lex_state = 347, .external_lex_state = 42},
  [9747] = {.lex_state = 347},
  [9748] = {.lex_state = 347},
  [9749] = {.lex_state = 347, .external_lex_state = 42},
  [9750] = {.lex_state = 347, .external_lex_state = 42},
  [9751] = {.lex_state = 347, .external_lex_state = 42},
  [9752] = {.lex_state = 347, .external_lex_state = 42},
  [9753] = {.lex_state = 347, .external_lex_state = 42},
  [9754] = {.lex_state = 347},
  [9755] = {.lex_state = 347, .external_lex_state = 42},
  [9756] = {.lex_state = 347, .external_lex_state = 42},
  [9757] = {.lex_state = 347},
  [9758] = {.lex_state = 347, .external_lex_state = 42},
  [9759] = {.lex_state = 347, .external_lex_state = 42},
  [9760] = {.lex_state = 347, .external_lex_state = 42},
  [9761] = {.lex_state = 347, .external_lex_state = 42},
  [9762] = {.lex_state = 347, .external_lex_state = 42},
  [9763] = {.lex_state = 347},
  [9764] = {.lex_state = 347, .external_lex_state = 42},
  [9765] = {.lex_state = 347, .external_lex_state = 43},
  [9766] = {.lex_state = 347, .external_lex_state = 42},
  [9767] = {.lex_state = 347},
  [9768] = {.lex_state = 347},
  [9769] = {.lex_state = 347, .external_lex_state = 42},
  [9770] = {.lex_state = 347},
  [9771] = {.lex_state = 347},
  [9772] = {.lex_state = 347, .external_lex_state = 42},
  [9773] = {.lex_state = 347, .external_lex_state = 42},
  [9774] = {.lex_state = 347},
  [9775] = {.lex_state = 347, .external_lex_state = 42},
  [9776] = {.lex_state = 347, .external_lex_state = 42},
  [9777] = {.lex_state = 347, .external_lex_state = 42},
  [9778] = {.lex_state = 347, .external_lex_state = 42},
  [9779] = {.lex_state = 347, .external_lex_state = 42},
  [9780] = {.lex_state = 347, .external_lex_state = 42},
  [9781] = {.lex_state = 347, .external_lex_state = 42},
  [9782] = {.lex_state = 347},
  [9783] = {.lex_state = 347, .external_lex_state = 42},
  [9784] = {.lex_state = 347, .external_lex_state = 42},
  [9785] = {.lex_state = 347, .external_lex_state = 42},
  [9786] = {.lex_state = 347, .external_lex_state = 42},
  [9787] = {.lex_state = 347, .external_lex_state = 42},
  [9788] = {.lex_state = 347},
  [9789] = {.lex_state = 347},
  [9790] = {.lex_state = 347, .external_lex_state = 42},
  [9791] = {.lex_state = 347, .external_lex_state = 42},
  [9792] = {.lex_state = 347},
  [9793] = {.lex_state = 347, .external_lex_state = 42},
  [9794] = {.lex_state = 347, .external_lex_state = 42},
  [9795] = {.lex_state = 347, .external_lex_state = 42},
  [9796] = {.lex_state = 347, .external_lex_state = 42},
  [9797] = {.lex_state = 347, .external_lex_state = 42},
  [9798] = {.lex_state = 347, .external_lex_state = 42},
  [9799] = {.lex_state = 347, .external_lex_state = 24},
  [9800] = {.lex_state = 347},
  [9801] = {.lex_state = 347, .external_lex_state = 31},
  [9802] = {.lex_state = 347},
  [9803] = {.lex_state = 347, .external_lex_state = 42},
  [9804] = {.lex_state = 347, .external_lex_state = 43},
  [9805] = {.lex_state = 347, .external_lex_state = 42},
  [9806] = {.lex_state = 347, .external_lex_state = 42},
  [9807] = {.lex_state = 347, .external_lex_state = 42},
  [9808] = {.lex_state = 347},
  [9809] = {.lex_state = 347, .external_lex_state = 42},
  [9810] = {.lex_state = 347},
  [9811] = {.lex_state = 347},
  [9812] = {.lex_state = 347},
  [9813] = {.lex_state = 347, .external_lex_state = 42},
  [9814] = {.lex_state = 347},
  [9815] = {.lex_state = 347, .external_lex_state = 42},
  [9816] = {.lex_state = 347, .external_lex_state = 42},
  [9817] = {.lex_state = 347, .external_lex_state = 42},
  [9818] = {.lex_state = 347},
  [9819] = {.lex_state = 347, .external_lex_state = 42},
  [9820] = {.lex_state = 347, .external_lex_state = 42},
  [9821] = {.lex_state = 347, .external_lex_state = 42},
  [9822] = {.lex_state = 347, .external_lex_state = 42},
  [9823] = {.lex_state = 347},
  [9824] = {.lex_state = 347, .external_lex_state = 43},
  [9825] = {.lex_state = 347},
  [9826] = {.lex_state = 347, .external_lex_state = 42},
  [9827] = {.lex_state = 347, .external_lex_state = 25},
  [9828] = {.lex_state = 347},
  [9829] = {.lex_state = 347, .external_lex_state = 42},
  [9830] = {.lex_state = 347, .external_lex_state = 42},
  [9831] = {.lex_state = 347, .external_lex_state = 42},
  [9832] = {.lex_state = 347, .external_lex_state = 42},
  [9833] = {.lex_state = 347, .external_lex_state = 42},
  [9834] = {.lex_state = 347, .external_lex_state = 25},
  [9835] = {.lex_state = 347},
  [9836] = {.lex_state = 347},
  [9837] = {.lex_state = 347, .external_lex_state = 42},
  [9838] = {.lex_state = 347, .external_lex_state = 42},
  [9839] = {.lex_state = 347},
  [9840] = {.lex_state = 347, .external_lex_state = 42},
  [9841] = {.lex_state = 347, .external_lex_state = 42},
  [9842] = {.lex_state = 347, .external_lex_state = 42},
  [9843] = {.lex_state = 347, .external_lex_state = 42},
  [9844] = {.lex_state = 166},
  [9845] = {.lex_state = 347, .external_lex_state = 42},
  [9846] = {.lex_state = 347},
  [9847] = {.lex_state = 347, .external_lex_state = 42},
  [9848] = {.lex_state = 347, .external_lex_state = 42},
  [9849] = {.lex_state = 347, .external_lex_state = 34},
  [9850] = {.lex_state = 347, .external_lex_state = 42},
  [9851] = {.lex_state = 347, .external_lex_state = 43},
  [9852] = {.lex_state = 347, .external_lex_state = 42},
  [9853] = {.lex_state = 347, .external_lex_state = 42},
  [9854] = {.lex_state = 347, .external_lex_state = 42},
  [9855] = {.lex_state = 347, .external_lex_state = 31},
  [9856] = {.lex_state = 347, .external_lex_state = 42},
  [9857] = {.lex_state = 347, .external_lex_state = 24},
  [9858] = {.lex_state = 347, .external_lex_state = 42},
  [9859] = {.lex_state = 347, .external_lex_state = 42},
  [9860] = {.lex_state = 347},
  [9861] = {.lex_state = 347, .external_lex_state = 42},
  [9862] = {.lex_state = 347, .external_lex_state = 25},
  [9863] = {.lex_state = 347, .external_lex_state = 25},
  [9864] = {.lex_state = 347, .external_lex_state = 42},
  [9865] = {.lex_state = 347, .external_lex_state = 43},
  [9866] = {.lex_state = 347, .external_lex_state = 42},
  [9867] = {.lex_state = 347, .external_lex_state = 42},
  [9868] = {.lex_state = 347},
  [9869] = {.lex_state = 347},
  [9870] = {.lex_state = 347},
  [9871] = {.lex_state = 347, .external_lex_state = 42},
  [9872] = {.lex_state = 347, .external_lex_state = 42},
  [9873] = {.lex_state = 347, .external_lex_state = 42},
  [9874] = {.lex_state = 347},
  [9875] = {.lex_state = 347, .external_lex_state = 42},
  [9876] = {.lex_state = 347, .external_lex_state = 42},
  [9877] = {.lex_state = 347, .external_lex_state = 42},
  [9878] = {.lex_state = 347, .external_lex_state = 43},
  [9879] = {.lex_state = 347, .external_lex_state = 42},
  [9880] = {.lex_state = 347, .external_lex_state = 42},
  [9881] = {.lex_state = 347, .external_lex_state = 42},
  [9882] = {.lex_state = 347},
  [9883] = {.lex_state = 347, .external_lex_state = 42},
  [9884] = {.lex_state = 347},
  [9885] = {.lex_state = 347},
  [9886] = {.lex_state = 347, .external_lex_state = 42},
  [9887] = {.lex_state = 347, .external_lex_state = 42},
  [9888] = {.lex_state = 347, .external_lex_state = 42},
  [9889] = {.lex_state = 347, .external_lex_state = 42},
  [9890] = {.lex_state = 347, .external_lex_state = 42},
  [9891] = {.lex_state = 347, .external_lex_state = 42},
  [9892] = {.lex_state = 347, .external_lex_state = 42},
  [9893] = {.lex_state = 347, .external_lex_state = 35},
  [9894] = {.lex_state = 347, .external_lex_state = 42},
  [9895] = {.lex_state = 347, .external_lex_state = 42},
  [9896] = {.lex_state = 347, .external_lex_state = 31},
  [9897] = {.lex_state = 347},
  [9898] = {.lex_state = 347, .external_lex_state = 42},
  [9899] = {.lex_state = 347},
  [9900] = {.lex_state = 347, .external_lex_state = 42},
  [9901] = {.lex_state = 347, .external_lex_state = 42},
  [9902] = {.lex_state = 347},
  [9903] = {.lex_state = 347, .external_lex_state = 42},
  [9904] = {.lex_state = 347, .external_lex_state = 42},
  [9905] = {.lex_state = 347, .external_lex_state = 42},
  [9906] = {.lex_state = 347, .external_lex_state = 31},
  [9907] = {.lex_state = 347, .external_lex_state = 42},
  [9908] = {.lex_state = 347, .external_lex_state = 42},
  [9909] = {.lex_state = 347, .external_lex_state = 42},
  [9910] = {.lex_state = 347, .external_lex_state = 42},
  [9911] = {.lex_state = 347, .external_lex_state = 42},
  [9912] = {.lex_state = 347, .external_lex_state = 42},
  [9913] = {.lex_state = 347, .external_lex_state = 42},
  [9914] = {.lex_state = 347, .external_lex_state = 42},
  [9915] = {.lex_state = 347, .external_lex_state = 42},
  [9916] = {.lex_state = 347, .external_lex_state = 42},
  [9917] = {.lex_state = 347, .external_lex_state = 42},
  [9918] = {.lex_state = 347},
  [9919] = {.lex_state = 347, .external_lex_state = 42},
  [9920] = {.lex_state = 166},
  [9921] = {.lex_state = 347, .external_lex_state = 42},
  [9922] = {.lex_state = 347},
  [9923] = {.lex_state = 347, .external_lex_state = 42},
  [9924] = {.lex_state = 347},
  [9925] = {.lex_state = 347, .external_lex_state = 25},
  [9926] = {.lex_state = 347, .external_lex_state = 25},
  [9927] = {.lex_state = 347},
  [9928] = {.lex_state = 347},
  [9929] = {.lex_state = 347, .external_lex_state = 42},
  [9930] = {.lex_state = 347},
  [9931] = {.lex_state = 347, .external_lex_state = 42},
  [9932] = {.lex_state = 347, .external_lex_state = 38},
  [9933] = {.lex_state = 347, .external_lex_state = 42},
  [9934] = {.lex_state = 347},
  [9935] = {.lex_state = 347, .external_lex_state = 25},
  [9936] = {.lex_state = 347, .external_lex_state = 42},
  [9937] = {.lex_state = 347, .external_lex_state = 42},
  [9938] = {.lex_state = 347, .external_lex_state = 42},
  [9939] = {.lex_state = 347, .external_lex_state = 42},
  [9940] = {.lex_state = 347, .external_lex_state = 25},
  [9941] = {.lex_state = 347},
  [9942] = {.lex_state = 347},
  [9943] = {.lex_state = 347, .external_lex_state = 42},
  [9944] = {.lex_state = 347, .external_lex_state = 42},
  [9945] = {.lex_state = 347, .external_lex_state = 43},
  [9946] = {.lex_state = 347, .external_lex_state = 42},
  [9947] = {.lex_state = 347, .external_lex_state = 42},
  [9948] = {.lex_state = 347, .external_lex_state = 42},
  [9949] = {.lex_state = 347, .external_lex_state = 42},
  [9950] = {.lex_state = 347, .external_lex_state = 42},
  [9951] = {.lex_state = 347},
  [9952] = {.lex_state = 347, .external_lex_state = 42},
  [9953] = {.lex_state = 133, .external_lex_state = 24},
  [9954] = {.lex_state = 347, .external_lex_state = 42},
  [9955] = {.lex_state = 347, .external_lex_state = 25},
  [9956] = {.lex_state = 347, .external_lex_state = 42},
  [9957] = {.lex_state = 347},
  [9958] = {.lex_state = 133, .external_lex_state = 24},
  [9959] = {.lex_state = 347, .external_lex_state = 42},
  [9960] = {.lex_state = 347},
  [9961] = {.lex_state = 347},
  [9962] = {.lex_state = 347, .external_lex_state = 42},
  [9963] = {.lex_state = 347, .external_lex_state = 43},
  [9964] = {.lex_state = 347, .external_lex_state = 30},
  [9965] = {.lex_state = 347},
  [9966] = {.lex_state = 347},
  [9967] = {.lex_state = 347, .external_lex_state = 42},
  [9968] = {.lex_state = 347, .external_lex_state = 42},
  [9969] = {.lex_state = 347},
  [9970] = {.lex_state = 133},
  [9971] = {.lex_state = 347, .external_lex_state = 43},
  [9972] = {.lex_state = 347, .external_lex_state = 42},
  [9973] = {.lex_state = 347, .external_lex_state = 42},
  [9974] = {.lex_state = 347},
  [9975] = {.lex_state = 347, .external_lex_state = 42},
  [9976] = {.lex_state = 347, .external_lex_state = 42},
  [9977] = {.lex_state = 347},
  [9978] = {.lex_state = 166},
  [9979] = {.lex_state = 347, .external_lex_state = 42},
  [9980] = {.lex_state = 347, .external_lex_state = 42},
  [9981] = {.lex_state = 347, .external_lex_state = 42},
  [9982] = {.lex_state = 347, .external_lex_state = 25},
  [9983] = {.lex_state = 347, .external_lex_state = 42},
  [9984] = {.lex_state = 347},
  [9985] = {.lex_state = 347, .external_lex_state = 30},
  [9986] = {.lex_state = 347, .external_lex_state = 42},
  [9987] = {.lex_state = 347},
  [9988] = {.lex_state = 347, .external_lex_state = 42},
  [9989] = {.lex_state = 347, .external_lex_state = 42},
  [9990] = {.lex_state = 347, .external_lex_state = 42},
  [9991] = {.lex_state = 133},
  [9992] = {.lex_state = 347, .external_lex_state = 42},
  [9993] = {.lex_state = 347, .external_lex_state = 42},
  [9994] = {.lex_state = 347, .external_lex_state = 30},
  [9995] = {.lex_state = 347, .external_lex_state = 42},
  [9996] = {.lex_state = 347, .external_lex_state = 42},
  [9997] = {.lex_state = 347},
  [9998] = {.lex_state = 347},
  [9999] = {.lex_state = 347, .external_lex_state = 42},
  [10000] = {.lex_state = 347},
  [10001] = {.lex_state = 347},
  [10002] = {.lex_state = 347},
  [10003] = {.lex_state = 347, .external_lex_state = 43},
  [10004] = {.lex_state = 347, .external_lex_state = 42},
  [10005] = {.lex_state = 133},
  [10006] = {.lex_state = 347},
  [10007] = {.lex_state = 347, .external_lex_state = 42},
  [10008] = {.lex_state = 347, .external_lex_state = 42},
  [10009] = {.lex_state = 347, .external_lex_state = 42},
  [10010] = {.lex_state = 347, .external_lex_state = 42},
  [10011] = {.lex_state = 133},
  [10012] = {.lex_state = 347, .external_lex_state = 42},
  [10013] = {.lex_state = 347, .external_lex_state = 42},
  [10014] = {.lex_state = 347, .external_lex_state = 42},
  [10015] = {.lex_state = 347},
  [10016] = {.lex_state = 347, .external_lex_state = 42},
  [10017] = {.lex_state = 347},
  [10018] = {.lex_state = 347, .external_lex_state = 42},
  [10019] = {.lex_state = 347, .external_lex_state = 42},
  [10020] = {.lex_state = 347, .external_lex_state = 42},
  [10021] = {.lex_state = 347},
  [10022] = {.lex_state = 347, .external_lex_state = 43},
  [10023] = {.lex_state = 347, .external_lex_state = 42},
  [10024] = {.lex_state = 347, .external_lex_state = 42},
  [10025] = {.lex_state = 347},
  [10026] = {.lex_state = 347},
  [10027] = {.lex_state = 347, .external_lex_state = 42},
  [10028] = {.lex_state = 193},
  [10029] = {.lex_state = 347, .external_lex_state = 42},
  [10030] = {.lex_state = 347},
  [10031] = {.lex_state = 347},
  [10032] = {.lex_state = 347, .external_lex_state = 42},
  [10033] = {.lex_state = 347},
  [10034] = {.lex_state = 347, .external_lex_state = 42},
  [10035] = {.lex_state = 347},
  [10036] = {.lex_state = 347, .external_lex_state = 42},
  [10037] = {.lex_state = 347},
  [10038] = {.lex_state = 347},
  [10039] = {.lex_state = 347},
  [10040] = {.lex_state = 347},
  [10041] = {.lex_state = 347},
  [10042] = {.lex_state = 347, .external_lex_state = 42},
  [10043] = {.lex_state = 347},
  [10044] = {.lex_state = 347},
  [10045] = {.lex_state = 347},
  [10046] = {.lex_state = 347, .external_lex_state = 42},
  [10047] = {.lex_state = 347, .external_lex_state = 42},
  [10048] = {.lex_state = 347, .external_lex_state = 42},
  [10049] = {.lex_state = 347, .external_lex_state = 42},
  [10050] = {.lex_state = 347},
  [10051] = {.lex_state = 347, .external_lex_state = 42},
  [10052] = {.lex_state = 347},
  [10053] = {.lex_state = 347, .external_lex_state = 42},
  [10054] = {.lex_state = 347, .external_lex_state = 42},
  [10055] = {.lex_state = 347, .external_lex_state = 42},
  [10056] = {.lex_state = 347},
  [10057] = {.lex_state = 347, .external_lex_state = 42},
  [10058] = {.lex_state = 347},
  [10059] = {.lex_state = 347, .external_lex_state = 42},
  [10060] = {.lex_state = 347},
  [10061] = {.lex_state = 347},
  [10062] = {.lex_state = 347, .external_lex_state = 42},
  [10063] = {.lex_state = 347, .external_lex_state = 42},
  [10064] = {.lex_state = 347, .external_lex_state = 42},
  [10065] = {.lex_state = 347, .external_lex_state = 42},
  [10066] = {.lex_state = 347},
  [10067] = {.lex_state = 347, .external_lex_state = 42},
  [10068] = {.lex_state = 347, .external_lex_state = 42},
  [10069] = {.lex_state = 347, .external_lex_state = 42},
  [10070] = {.lex_state = 347, .external_lex_state = 42},
  [10071] = {.lex_state = 347, .external_lex_state = 42},
  [10072] = {.lex_state = 347},
  [10073] = {.lex_state = 347},
  [10074] = {.lex_state = 347, .external_lex_state = 42},
  [10075] = {.lex_state = 347},
  [10076] = {.lex_state = 347, .external_lex_state = 42},
  [10077] = {.lex_state = 347, .external_lex_state = 42},
  [10078] = {.lex_state = 347, .external_lex_state = 42},
  [10079] = {.lex_state = 347, .external_lex_state = 42},
  [10080] = {.lex_state = 347, .external_lex_state = 42},
  [10081] = {.lex_state = 347},
  [10082] = {.lex_state = 347, .external_lex_state = 42},
  [10083] = {.lex_state = 347},
  [10084] = {.lex_state = 347, .external_lex_state = 42},
  [10085] = {.lex_state = 133},
  [10086] = {.lex_state = 347, .external_lex_state = 42},
  [10087] = {.lex_state = 347, .external_lex_state = 42},
  [10088] = {.lex_state = 347, .external_lex_state = 42},
  [10089] = {.lex_state = 347, .external_lex_state = 42},
  [10090] = {.lex_state = 347},
  [10091] = {.lex_state = 347, .external_lex_state = 38},
  [10092] = {.lex_state = 347, .external_lex_state = 43},
  [10093] = {.lex_state = 347, .external_lex_state = 38},
  [10094] = {.lex_state = 347, .external_lex_state = 35},
  [10095] = {.lex_state = 347, .external_lex_state = 42},
  [10096] = {.lex_state = 347, .external_lex_state = 42},
  [10097] = {.lex_state = 347, .external_lex_state = 31},
  [10098] = {.lex_state = 347},
  [10099] = {.lex_state = 347},
  [10100] = {.lex_state = 347, .external_lex_state = 31},
  [10101] = {.lex_state = 347, .external_lex_state = 31},
  [10102] = {.lex_state = 347},
  [10103] = {.lex_state = 347, .external_lex_state = 31},
  [10104] = {.lex_state = 347, .external_lex_state = 42},
  [10105] = {.lex_state = 347},
  [10106] = {.lex_state = 347, .external_lex_state = 42},
  [10107] = {.lex_state = 347, .external_lex_state = 31},
  [10108] = {.lex_state = 347, .external_lex_state = 42},
  [10109] = {.lex_state = 347, .external_lex_state = 42},
  [10110] = {.lex_state = 347, .external_lex_state = 42},
  [10111] = {.lex_state = 347, .external_lex_state = 42},
  [10112] = {.lex_state = 347, .external_lex_state = 31},
  [10113] = {.lex_state = 347, .external_lex_state = 31},
  [10114] = {.lex_state = 347, .external_lex_state = 31},
  [10115] = {.lex_state = 347, .external_lex_state = 31},
  [10116] = {.lex_state = 347},
  [10117] = {.lex_state = 347},
  [10118] = {.lex_state = 347, .external_lex_state = 43},
  [10119] = {.lex_state = 347, .external_lex_state = 31},
  [10120] = {.lex_state = 347, .external_lex_state = 31},
  [10121] = {.lex_state = 347},
  [10122] = {.lex_state = 347, .external_lex_state = 31},
  [10123] = {.lex_state = 347, .external_lex_state = 42},
  [10124] = {.lex_state = 347, .external_lex_state = 31},
  [10125] = {.lex_state = 347, .external_lex_state = 31},
  [10126] = {.lex_state = 347, .external_lex_state = 31},
  [10127] = {.lex_state = 347, .external_lex_state = 31},
  [10128] = {.lex_state = 347, .external_lex_state = 31},
  [10129] = {.lex_state = 347, .external_lex_state = 42},
  [10130] = {.lex_state = 347, .external_lex_state = 42},
  [10131] = {.lex_state = 347, .external_lex_state = 43},
  [10132] = {.lex_state = 347},
  [10133] = {.lex_state = 347, .external_lex_state = 31},
  [10134] = {.lex_state = 347, .external_lex_state = 31},
  [10135] = {.lex_state = 347, .external_lex_state = 31},
  [10136] = {.lex_state = 347, .external_lex_state = 31},
  [10137] = {.lex_state = 347, .external_lex_state = 43},
  [10138] = {.lex_state = 347, .external_lex_state = 42},
  [10139] = {.lex_state = 347, .external_lex_state = 31},
  [10140] = {.lex_state = 347},
  [10141] = {.lex_state = 347, .external_lex_state = 42},
  [10142] = {.lex_state = 347, .external_lex_state = 31},
  [10143] = {.lex_state = 347, .external_lex_state = 31},
  [10144] = {.lex_state = 347, .external_lex_state = 31},
  [10145] = {.lex_state = 347, .external_lex_state = 31},
  [10146] = {.lex_state = 347, .external_lex_state = 31},
  [10147] = {.lex_state = 347, .external_lex_state = 42},
  [10148] = {.lex_state = 347, .external_lex_state = 42},
  [10149] = {.lex_state = 347},
  [10150] = {.lex_state = 347, .external_lex_state = 31},
  [10151] = {.lex_state = 347},
  [10152] = {.lex_state = 347},
  [10153] = {.lex_state = 347},
  [10154] = {.lex_state = 347},
  [10155] = {.lex_state = 347, .external_lex_state = 31},
  [10156] = {.lex_state = 347, .external_lex_state = 31},
  [10157] = {.lex_state = 347, .external_lex_state = 42},
  [10158] = {.lex_state = 347, .external_lex_state = 35},
  [10159] = {.lex_state = 347},
  [10160] = {.lex_state = 347, .external_lex_state = 42},
  [10161] = {.lex_state = 347, .external_lex_state = 42},
  [10162] = {.lex_state = 347, .external_lex_state = 42},
  [10163] = {.lex_state = 347, .external_lex_state = 35},
  [10164] = {.lex_state = 347},
  [10165] = {.lex_state = 347, .external_lex_state = 42},
  [10166] = {.lex_state = 347, .external_lex_state = 42},
  [10167] = {.lex_state = 347},
  [10168] = {.lex_state = 347, .external_lex_state = 42},
  [10169] = {.lex_state = 347, .external_lex_state = 42},
  [10170] = {.lex_state = 347, .external_lex_state = 42},
  [10171] = {.lex_state = 347, .external_lex_state = 42},
  [10172] = {.lex_state = 347, .external_lex_state = 42},
  [10173] = {.lex_state = 347, .external_lex_state = 35},
  [10174] = {.lex_state = 347},
  [10175] = {.lex_state = 347, .external_lex_state = 42},
  [10176] = {.lex_state = 133},
  [10177] = {.lex_state = 347, .external_lex_state = 38},
  [10178] = {.lex_state = 347, .external_lex_state = 42},
  [10179] = {.lex_state = 347, .external_lex_state = 43},
  [10180] = {.lex_state = 347, .external_lex_state = 35},
  [10181] = {.lex_state = 347},
  [10182] = {.lex_state = 347, .external_lex_state = 42},
  [10183] = {.lex_state = 347},
  [10184] = {.lex_state = 347},
  [10185] = {.lex_state = 347},
  [10186] = {.lex_state = 347, .external_lex_state = 31},
  [10187] = {.lex_state = 347, .external_lex_state = 31},
  [10188] = {.lex_state = 347},
  [10189] = {.lex_state = 347},
  [10190] = {.lex_state = 347, .external_lex_state = 44},
  [10191] = {.lex_state = 347, .external_lex_state = 45},
  [10192] = {.lex_state = 347, .external_lex_state = 45},
  [10193] = {.lex_state = 347},
  [10194] = {.lex_state = 347, .external_lex_state = 44},
  [10195] = {.lex_state = 347},
  [10196] = {.lex_state = 347},
  [10197] = {.lex_state = 347},
  [10198] = {.lex_state = 347},
  [10199] = {.lex_state = 347, .external_lex_state = 44},
  [10200] = {.lex_state = 347, .external_lex_state = 31},
  [10201] = {.lex_state = 347},
  [10202] = {.lex_state = 347},
  [10203] = {.lex_state = 347},
  [10204] = {.lex_state = 347},
  [10205] = {.lex_state = 347},
  [10206] = {.lex_state = 347, .external_lex_state = 40},
  [10207] = {.lex_state = 347},
  [10208] = {.lex_state = 347},
  [10209] = {.lex_state = 347, .external_lex_state = 31},
  [10210] = {.lex_state = 347, .external_lex_state = 40},
  [10211] = {.lex_state = 347, .external_lex_state = 30},
  [10212] = {.lex_state = 347},
  [10213] = {.lex_state = 347, .external_lex_state = 31},
  [10214] = {.lex_state = 347, .external_lex_state = 31},
  [10215] = {.lex_state = 347},
  [10216] = {.lex_state = 347, .external_lex_state = 40},
  [10217] = {.lex_state = 347},
  [10218] = {.lex_state = 347, .external_lex_state = 31},
  [10219] = {.lex_state = 347},
  [10220] = {.lex_state = 347},
  [10221] = {.lex_state = 347},
  [10222] = {.lex_state = 347, .external_lex_state = 31},
  [10223] = {.lex_state = 347, .external_lex_state = 31},
  [10224] = {.lex_state = 347, .external_lex_state = 31},
  [10225] = {.lex_state = 347, .external_lex_state = 30},
  [10226] = {.lex_state = 347, .external_lex_state = 40},
  [10227] = {.lex_state = 347, .external_lex_state = 40},
  [10228] = {.lex_state = 347},
  [10229] = {.lex_state = 347},
  [10230] = {.lex_state = 347, .external_lex_state = 40},
  [10231] = {.lex_state = 347},
  [10232] = {.lex_state = 347},
  [10233] = {.lex_state = 347, .external_lex_state = 31},
  [10234] = {.lex_state = 347},
  [10235] = {.lex_state = 347, .external_lex_state = 44},
  [10236] = {.lex_state = 347},
  [10237] = {.lex_state = 347},
  [10238] = {.lex_state = 347, .external_lex_state = 45},
  [10239] = {.lex_state = 347, .external_lex_state = 31},
  [10240] = {.lex_state = 347, .external_lex_state = 45},
  [10241] = {.lex_state = 347, .external_lex_state = 42},
  [10242] = {.lex_state = 347, .external_lex_state = 31},
  [10243] = {.lex_state = 347},
  [10244] = {.lex_state = 347},
  [10245] = {.lex_state = 347},
  [10246] = {.lex_state = 347},
  [10247] = {.lex_state = 347, .external_lex_state = 31},
  [10248] = {.lex_state = 347},
  [10249] = {.lex_state = 347},
  [10250] = {.lex_state = 347},
  [10251] = {.lex_state = 347},
  [10252] = {.lex_state = 347, .external_lex_state = 44},
  [10253] = {.lex_state = 347, .external_lex_state = 31},
  [10254] = {.lex_state = 347, .external_lex_state = 31},
  [10255] = {.lex_state = 347, .external_lex_state = 44},
  [10256] = {.lex_state = 347, .external_lex_state = 31},
  [10257] = {.lex_state = 347},
  [10258] = {.lex_state = 347},
  [10259] = {.lex_state = 347},
  [10260] = {.lex_state = 347},
  [10261] = {.lex_state = 347},
  [10262] = {.lex_state = 347, .external_lex_state = 31},
  [10263] = {.lex_state = 347},
  [10264] = {.lex_state = 347, .external_lex_state = 42},
  [10265] = {.lex_state = 347, .external_lex_state = 36},
  [10266] = {.lex_state = 347},
  [10267] = {.lex_state = 347, .external_lex_state = 31},
  [10268] = {.lex_state = 347, .external_lex_state = 40},
  [10269] = {.lex_state = 347},
  [10270] = {.lex_state = 347},
  [10271] = {.lex_state = 347, .external_lex_state = 31},
  [10272] = {.lex_state = 347, .external_lex_state = 31},
  [10273] = {.lex_state = 347},
  [10274] = {.lex_state = 347},
  [10275] = {.lex_state = 347},
  [10276] = {.lex_state = 347},
  [10277] = {.lex_state = 347},
  [10278] = {.lex_state = 347, .external_lex_state = 31},
  [10279] = {.lex_state = 347},
  [10280] = {.lex_state = 347, .external_lex_state = 31},
  [10281] = {.lex_state = 347, .external_lex_state = 30},
  [10282] = {.lex_state = 347, .external_lex_state = 40},
  [10283] = {.lex_state = 347, .external_lex_state = 40},
  [10284] = {.lex_state = 347},
  [10285] = {.lex_state = 347, .external_lex_state = 36},
  [10286] = {.lex_state = 347},
  [10287] = {.lex_state = 347, .external_lex_state = 45},
  [10288] = {.lex_state = 347, .external_lex_state = 45},
  [10289] = {.lex_state = 347},
  [10290] = {.lex_state = 347, .external_lex_state = 44},
  [10291] = {.lex_state = 347},
  [10292] = {.lex_state = 347},
  [10293] = {.lex_state = 347},
  [10294] = {.lex_state = 347},
  [10295] = {.lex_state = 347, .external_lex_state = 44},
  [10296] = {.lex_state = 347},
  [10297] = {.lex_state = 347},
  [10298] = {.lex_state = 347, .external_lex_state = 45},
  [10299] = {.lex_state = 347, .external_lex_state = 45},
  [10300] = {.lex_state = 347},
  [10301] = {.lex_state = 347},
  [10302] = {.lex_state = 347},
  [10303] = {.lex_state = 347},
  [10304] = {.lex_state = 347, .external_lex_state = 40},
  [10305] = {.lex_state = 347},
  [10306] = {.lex_state = 347, .external_lex_state = 31},
  [10307] = {.lex_state = 347, .external_lex_state = 31},
  [10308] = {.lex_state = 347},
  [10309] = {.lex_state = 347},
  [10310] = {.lex_state = 347},
  [10311] = {.lex_state = 347},
  [10312] = {.lex_state = 347},
  [10313] = {.lex_state = 347, .external_lex_state = 31},
  [10314] = {.lex_state = 347, .external_lex_state = 31},
  [10315] = {.lex_state = 347},
  [10316] = {.lex_state = 347},
  [10317] = {.lex_state = 347, .external_lex_state = 36},
  [10318] = {.lex_state = 347},
  [10319] = {.lex_state = 347},
  [10320] = {.lex_state = 347, .external_lex_state = 40},
  [10321] = {.lex_state = 347},
  [10322] = {.lex_state = 347},
  [10323] = {.lex_state = 347, .external_lex_state = 42},
  [10324] = {.lex_state = 347},
  [10325] = {.lex_state = 347},
  [10326] = {.lex_state = 347},
  [10327] = {.lex_state = 347},
  [10328] = {.lex_state = 347},
  [10329] = {.lex_state = 347, .external_lex_state = 31},
  [10330] = {.lex_state = 347},
  [10331] = {.lex_state = 347},
  [10332] = {.lex_state = 347},
  [10333] = {.lex_state = 347},
  [10334] = {.lex_state = 189},
  [10335] = {.lex_state = 347},
  [10336] = {.lex_state = 347, .external_lex_state = 44},
  [10337] = {.lex_state = 347},
  [10338] = {.lex_state = 347, .external_lex_state = 46},
  [10339] = {.lex_state = 347},
  [10340] = {.lex_state = 347},
  [10341] = {.lex_state = 347},
  [10342] = {.lex_state = 347},
  [10343] = {.lex_state = 347},
  [10344] = {.lex_state = 347},
  [10345] = {.lex_state = 347},
  [10346] = {.lex_state = 347},
  [10347] = {.lex_state = 347},
  [10348] = {.lex_state = 347},
  [10349] = {.lex_state = 347},
  [10350] = {.lex_state = 347},
  [10351] = {.lex_state = 347},
  [10352] = {.lex_state = 347},
  [10353] = {.lex_state = 347},
  [10354] = {.lex_state = 347},
  [10355] = {.lex_state = 347},
  [10356] = {.lex_state = 347},
  [10357] = {.lex_state = 347, .external_lex_state = 45},
  [10358] = {.lex_state = 347, .external_lex_state = 45},
  [10359] = {.lex_state = 347},
  [10360] = {.lex_state = 347, .external_lex_state = 44},
  [10361] = {.lex_state = 347},
  [10362] = {.lex_state = 347},
  [10363] = {.lex_state = 347},
  [10364] = {.lex_state = 347},
  [10365] = {.lex_state = 347},
  [10366] = {.lex_state = 347},
  [10367] = {.lex_state = 347},
  [10368] = {.lex_state = 347},
  [10369] = {.lex_state = 166},
  [10370] = {.lex_state = 347},
  [10371] = {.lex_state = 347},
  [10372] = {.lex_state = 347},
  [10373] = {.lex_state = 347},
  [10374] = {.lex_state = 347, .external_lex_state = 40},
  [10375] = {.lex_state = 347},
  [10376] = {.lex_state = 347, .external_lex_state = 31},
  [10377] = {.lex_state = 347, .external_lex_state = 31},
  [10378] = {.lex_state = 166},
  [10379] = {.lex_state = 347},
  [10380] = {.lex_state = 347},
  [10381] = {.lex_state = 347},
  [10382] = {.lex_state = 347},
  [10383] = {.lex_state = 347},
  [10384] = {.lex_state = 347, .external_lex_state = 31},
  [10385] = {.lex_state = 166},
  [10386] = {.lex_state = 347},
  [10387] = {.lex_state = 347},
  [10388] = {.lex_state = 347},
  [10389] = {.lex_state = 347},
  [10390] = {.lex_state = 347, .external_lex_state = 40},
  [10391] = {.lex_state = 347},
  [10392] = {.lex_state = 347},
  [10393] = {.lex_state = 166},
  [10394] = {.lex_state = 347},
  [10395] = {.lex_state = 347},
  [10396] = {.lex_state = 347},
  [10397] = {.lex_state = 347},
  [10398] = {.lex_state = 347},
  [10399] = {.lex_state = 347, .external_lex_state = 31},
  [10400] = {.lex_state = 347},
  [10401] = {.lex_state = 347},
  [10402] = {.lex_state = 347},
  [10403] = {.lex_state = 166},
  [10404] = {.lex_state = 347},
  [10405] = {.lex_state = 347},
  [10406] = {.lex_state = 347, .external_lex_state = 44},
  [10407] = {.lex_state = 347},
  [10408] = {.lex_state = 347},
  [10409] = {.lex_state = 347},
  [10410] = {.lex_state = 347},
  [10411] = {.lex_state = 347},
  [10412] = {.lex_state = 166},
  [10413] = {.lex_state = 347},
  [10414] = {.lex_state = 347},
  [10415] = {.lex_state = 347},
  [10416] = {.lex_state = 347, .external_lex_state = 31},
  [10417] = {.lex_state = 347},
  [10418] = {.lex_state = 347},
  [10419] = {.lex_state = 347},
  [10420] = {.lex_state = 347},
  [10421] = {.lex_state = 347},
  [10422] = {.lex_state = 166},
  [10423] = {.lex_state = 347},
  [10424] = {.lex_state = 347},
  [10425] = {.lex_state = 347},
  [10426] = {.lex_state = 347, .external_lex_state = 45},
  [10427] = {.lex_state = 347, .external_lex_state = 45},
  [10428] = {.lex_state = 347},
  [10429] = {.lex_state = 347, .external_lex_state = 44},
  [10430] = {.lex_state = 347},
  [10431] = {.lex_state = 347},
  [10432] = {.lex_state = 166},
  [10433] = {.lex_state = 347},
  [10434] = {.lex_state = 347, .external_lex_state = 31},
  [10435] = {.lex_state = 347},
  [10436] = {.lex_state = 347},
  [10437] = {.lex_state = 347},
  [10438] = {.lex_state = 347},
  [10439] = {.lex_state = 347},
  [10440] = {.lex_state = 347},
  [10441] = {.lex_state = 166},
  [10442] = {.lex_state = 347},
  [10443] = {.lex_state = 347, .external_lex_state = 40},
  [10444] = {.lex_state = 347},
  [10445] = {.lex_state = 347, .external_lex_state = 31},
  [10446] = {.lex_state = 347, .external_lex_state = 31},
  [10447] = {.lex_state = 347},
  [10448] = {.lex_state = 347},
  [10449] = {.lex_state = 347},
  [10450] = {.lex_state = 347},
  [10451] = {.lex_state = 166},
  [10452] = {.lex_state = 347, .external_lex_state = 42},
  [10453] = {.lex_state = 347, .external_lex_state = 31},
  [10454] = {.lex_state = 347},
  [10455] = {.lex_state = 347, .external_lex_state = 36},
  [10456] = {.lex_state = 347},
  [10457] = {.lex_state = 347},
  [10458] = {.lex_state = 347},
  [10459] = {.lex_state = 347, .external_lex_state = 40},
  [10460] = {.lex_state = 347},
  [10461] = {.lex_state = 347},
  [10462] = {.lex_state = 347},
  [10463] = {.lex_state = 347},
  [10464] = {.lex_state = 347},
  [10465] = {.lex_state = 347},
  [10466] = {.lex_state = 347},
  [10467] = {.lex_state = 347},
  [10468] = {.lex_state = 347, .external_lex_state = 31},
  [10469] = {.lex_state = 347},
  [10470] = {.lex_state = 347},
  [10471] = {.lex_state = 347},
  [10472] = {.lex_state = 166},
  [10473] = {.lex_state = 347},
  [10474] = {.lex_state = 347},
  [10475] = {.lex_state = 347, .external_lex_state = 44},
  [10476] = {.lex_state = 347},
  [10477] = {.lex_state = 347},
  [10478] = {.lex_state = 347},
  [10479] = {.lex_state = 166},
  [10480] = {.lex_state = 347},
  [10481] = {.lex_state = 347},
  [10482] = {.lex_state = 347},
  [10483] = {.lex_state = 347},
  [10484] = {.lex_state = 347},
  [10485] = {.lex_state = 347},
  [10486] = {.lex_state = 347},
  [10487] = {.lex_state = 347},
  [10488] = {.lex_state = 347},
  [10489] = {.lex_state = 166},
  [10490] = {.lex_state = 347},
  [10491] = {.lex_state = 347},
  [10492] = {.lex_state = 347},
  [10493] = {.lex_state = 347},
  [10494] = {.lex_state = 347},
  [10495] = {.lex_state = 347, .external_lex_state = 45},
  [10496] = {.lex_state = 347, .external_lex_state = 45},
  [10497] = {.lex_state = 347},
  [10498] = {.lex_state = 347, .external_lex_state = 44},
  [10499] = {.lex_state = 166},
  [10500] = {.lex_state = 347},
  [10501] = {.lex_state = 347},
  [10502] = {.lex_state = 347},
  [10503] = {.lex_state = 347},
  [10504] = {.lex_state = 347},
  [10505] = {.lex_state = 347},
  [10506] = {.lex_state = 347},
  [10507] = {.lex_state = 347, .external_lex_state = 42},
  [10508] = {.lex_state = 347},
  [10509] = {.lex_state = 166},
  [10510] = {.lex_state = 347},
  [10511] = {.lex_state = 347},
  [10512] = {.lex_state = 347, .external_lex_state = 40},
  [10513] = {.lex_state = 347},
  [10514] = {.lex_state = 347, .external_lex_state = 31},
  [10515] = {.lex_state = 347, .external_lex_state = 31},
  [10516] = {.lex_state = 347},
  [10517] = {.lex_state = 347},
  [10518] = {.lex_state = 166},
  [10519] = {.lex_state = 347},
  [10520] = {.lex_state = 347},
  [10521] = {.lex_state = 347},
  [10522] = {.lex_state = 347, .external_lex_state = 31},
  [10523] = {.lex_state = 347},
  [10524] = {.lex_state = 347},
  [10525] = {.lex_state = 347},
  [10526] = {.lex_state = 347},
  [10527] = {.lex_state = 347},
  [10528] = {.lex_state = 347, .external_lex_state = 40},
  [10529] = {.lex_state = 166},
  [10530] = {.lex_state = 347},
  [10531] = {.lex_state = 347},
  [10532] = {.lex_state = 347},
  [10533] = {.lex_state = 347},
  [10534] = {.lex_state = 347},
  [10535] = {.lex_state = 347},
  [10536] = {.lex_state = 347},
  [10537] = {.lex_state = 347, .external_lex_state = 31},
  [10538] = {.lex_state = 347},
  [10539] = {.lex_state = 347},
  [10540] = {.lex_state = 166},
  [10541] = {.lex_state = 347},
  [10542] = {.lex_state = 347},
  [10543] = {.lex_state = 347, .external_lex_state = 42},
  [10544] = {.lex_state = 347, .external_lex_state = 44},
  [10545] = {.lex_state = 347},
  [10546] = {.lex_state = 347},
  [10547] = {.lex_state = 347},
  [10548] = {.lex_state = 166},
  [10549] = {.lex_state = 347},
  [10550] = {.lex_state = 347},
  [10551] = {.lex_state = 347},
  [10552] = {.lex_state = 347},
  [10553] = {.lex_state = 347},
  [10554] = {.lex_state = 347},
  [10555] = {.lex_state = 347},
  [10556] = {.lex_state = 347},
  [10557] = {.lex_state = 347},
  [10558] = {.lex_state = 347},
  [10559] = {.lex_state = 347},
  [10560] = {.lex_state = 166},
  [10561] = {.lex_state = 347},
  [10562] = {.lex_state = 347},
  [10563] = {.lex_state = 347},
  [10564] = {.lex_state = 347, .external_lex_state = 45},
  [10565] = {.lex_state = 347, .external_lex_state = 45},
  [10566] = {.lex_state = 347},
  [10567] = {.lex_state = 347, .external_lex_state = 44},
  [10568] = {.lex_state = 347},
  [10569] = {.lex_state = 347},
  [10570] = {.lex_state = 166},
  [10571] = {.lex_state = 347},
  [10572] = {.lex_state = 347},
  [10573] = {.lex_state = 347},
  [10574] = {.lex_state = 347},
  [10575] = {.lex_state = 347},
  [10576] = {.lex_state = 347},
  [10577] = {.lex_state = 347},
  [10578] = {.lex_state = 347},
  [10579] = {.lex_state = 166},
  [10580] = {.lex_state = 347, .external_lex_state = 40},
  [10581] = {.lex_state = 347, .external_lex_state = 31},
  [10582] = {.lex_state = 347, .external_lex_state = 31},
  [10583] = {.lex_state = 347},
  [10584] = {.lex_state = 347},
  [10585] = {.lex_state = 347},
  [10586] = {.lex_state = 347},
  [10587] = {.lex_state = 347},
  [10588] = {.lex_state = 166},
  [10589] = {.lex_state = 347, .external_lex_state = 31},
  [10590] = {.lex_state = 347},
  [10591] = {.lex_state = 347},
  [10592] = {.lex_state = 347},
  [10593] = {.lex_state = 347},
  [10594] = {.lex_state = 347},
  [10595] = {.lex_state = 347},
  [10596] = {.lex_state = 347},
  [10597] = {.lex_state = 166},
  [10598] = {.lex_state = 347},
  [10599] = {.lex_state = 347},
  [10600] = {.lex_state = 347},
  [10601] = {.lex_state = 347, .external_lex_state = 31},
  [10602] = {.lex_state = 347},
  [10603] = {.lex_state = 347},
  [10604] = {.lex_state = 347},
  [10605] = {.lex_state = 347},
  [10606] = {.lex_state = 347, .external_lex_state = 31},
  [10607] = {.lex_state = 347, .external_lex_state = 31},
  [10608] = {.lex_state = 347, .external_lex_state = 44},
  [10609] = {.lex_state = 166},
  [10610] = {.lex_state = 347},
  [10611] = {.lex_state = 347, .external_lex_state = 31},
  [10612] = {.lex_state = 347},
  [10613] = {.lex_state = 347},
  [10614] = {.lex_state = 347},
  [10615] = {.lex_state = 347, .external_lex_state = 31},
  [10616] = {.lex_state = 347},
  [10617] = {.lex_state = 347},
  [10618] = {.lex_state = 347},
  [10619] = {.lex_state = 347},
  [10620] = {.lex_state = 347},
  [10621] = {.lex_state = 166},
  [10622] = {.lex_state = 347},
  [10623] = {.lex_state = 347},
  [10624] = {.lex_state = 347, .external_lex_state = 45},
  [10625] = {.lex_state = 347, .external_lex_state = 45},
  [10626] = {.lex_state = 347},
  [10627] = {.lex_state = 347, .external_lex_state = 44},
  [10628] = {.lex_state = 347},
  [10629] = {.lex_state = 347},
  [10630] = {.lex_state = 347},
  [10631] = {.lex_state = 166},
  [10632] = {.lex_state = 347},
  [10633] = {.lex_state = 347},
  [10634] = {.lex_state = 347, .external_lex_state = 42},
  [10635] = {.lex_state = 347},
  [10636] = {.lex_state = 347},
  [10637] = {.lex_state = 347},
  [10638] = {.lex_state = 347},
  [10639] = {.lex_state = 347, .external_lex_state = 40},
  [10640] = {.lex_state = 347, .external_lex_state = 31},
  [10641] = {.lex_state = 347, .external_lex_state = 31},
  [10642] = {.lex_state = 347},
  [10643] = {.lex_state = 347},
  [10644] = {.lex_state = 166},
  [10645] = {.lex_state = 347, .external_lex_state = 42},
  [10646] = {.lex_state = 133},
  [10647] = {.lex_state = 347},
  [10648] = {.lex_state = 347, .external_lex_state = 31},
  [10649] = {.lex_state = 347, .external_lex_state = 31},
  [10650] = {.lex_state = 347},
  [10651] = {.lex_state = 133},
  [10652] = {.lex_state = 347},
  [10653] = {.lex_state = 347},
  [10654] = {.lex_state = 347},
  [10655] = {.lex_state = 347},
  [10656] = {.lex_state = 347},
  [10657] = {.lex_state = 166},
  [10658] = {.lex_state = 347},
  [10659] = {.lex_state = 133},
  [10660] = {.lex_state = 347, .external_lex_state = 31},
  [10661] = {.lex_state = 347},
  [10662] = {.lex_state = 347},
  [10663] = {.lex_state = 347},
  [10664] = {.lex_state = 133},
  [10665] = {.lex_state = 347},
  [10666] = {.lex_state = 347},
  [10667] = {.lex_state = 347, .external_lex_state = 44},
  [10668] = {.lex_state = 347},
  [10669] = {.lex_state = 166},
  [10670] = {.lex_state = 133},
  [10671] = {.lex_state = 347},
  [10672] = {.lex_state = 347},
  [10673] = {.lex_state = 347},
  [10674] = {.lex_state = 347},
  [10675] = {.lex_state = 347},
  [10676] = {.lex_state = 133},
  [10677] = {.lex_state = 347},
  [10678] = {.lex_state = 347},
  [10679] = {.lex_state = 347},
  [10680] = {.lex_state = 347},
  [10681] = {.lex_state = 347},
  [10682] = {.lex_state = 347, .external_lex_state = 45},
  [10683] = {.lex_state = 347, .external_lex_state = 45},
  [10684] = {.lex_state = 347},
  [10685] = {.lex_state = 347, .external_lex_state = 44},
  [10686] = {.lex_state = 166},
  [10687] = {.lex_state = 133},
  [10688] = {.lex_state = 347},
  [10689] = {.lex_state = 347},
  [10690] = {.lex_state = 347},
  [10691] = {.lex_state = 133},
  [10692] = {.lex_state = 347},
  [10693] = {.lex_state = 347},
  [10694] = {.lex_state = 347},
  [10695] = {.lex_state = 347},
  [10696] = {.lex_state = 166},
  [10697] = {.lex_state = 347, .external_lex_state = 40},
  [10698] = {.lex_state = 347, .external_lex_state = 31},
  [10699] = {.lex_state = 347, .external_lex_state = 31},
  [10700] = {.lex_state = 133},
  [10701] = {.lex_state = 347},
  [10702] = {.lex_state = 347},
  [10703] = {.lex_state = 347, .external_lex_state = 42},
  [10704] = {.lex_state = 133},
  [10705] = {.lex_state = 166},
  [10706] = {.lex_state = 347, .external_lex_state = 31},
  [10707] = {.lex_state = 133},
  [10708] = {.lex_state = 347},
  [10709] = {.lex_state = 347},
  [10710] = {.lex_state = 347},
  [10711] = {.lex_state = 347},
  [10712] = {.lex_state = 347},
  [10713] = {.lex_state = 347},
  [10714] = {.lex_state = 347, .external_lex_state = 31},
  [10715] = {.lex_state = 166},
  [10716] = {.lex_state = 347},
  [10717] = {.lex_state = 347},
  [10718] = {.lex_state = 347, .external_lex_state = 44},
  [10719] = {.lex_state = 347},
  [10720] = {.lex_state = 347, .external_lex_state = 31},
  [10721] = {.lex_state = 347},
  [10722] = {.lex_state = 347},
  [10723] = {.lex_state = 347},
  [10724] = {.lex_state = 133},
  [10725] = {.lex_state = 347},
  [10726] = {.lex_state = 347, .external_lex_state = 45},
  [10727] = {.lex_state = 347, .external_lex_state = 45},
  [10728] = {.lex_state = 347},
  [10729] = {.lex_state = 347, .external_lex_state = 44},
  [10730] = {.lex_state = 347},
  [10731] = {.lex_state = 347},
  [10732] = {.lex_state = 347},
  [10733] = {.lex_state = 347},
  [10734] = {.lex_state = 347},
  [10735] = {.lex_state = 347},
  [10736] = {.lex_state = 347},
  [10737] = {.lex_state = 347},
  [10738] = {.lex_state = 347},
  [10739] = {.lex_state = 166},
  [10740] = {.lex_state = 133},
  [10741] = {.lex_state = 347, .external_lex_state = 40},
  [10742] = {.lex_state = 347, .external_lex_state = 31},
  [10743] = {.lex_state = 347, .external_lex_state = 31},
  [10744] = {.lex_state = 347},
  [10745] = {.lex_state = 347},
  [10746] = {.lex_state = 133},
  [10747] = {.lex_state = 347},
  [10748] = {.lex_state = 347},
  [10749] = {.lex_state = 347},
  [10750] = {.lex_state = 347, .external_lex_state = 31},
  [10751] = {.lex_state = 347},
  [10752] = {.lex_state = 347, .external_lex_state = 31},
  [10753] = {.lex_state = 347},
  [10754] = {.lex_state = 347},
  [10755] = {.lex_state = 166},
  [10756] = {.lex_state = 347},
  [10757] = {.lex_state = 133},
  [10758] = {.lex_state = 347, .external_lex_state = 31},
  [10759] = {.lex_state = 347, .external_lex_state = 42},
  [10760] = {.lex_state = 347, .external_lex_state = 36},
  [10761] = {.lex_state = 347, .external_lex_state = 44},
  [10762] = {.lex_state = 347},
  [10763] = {.lex_state = 347},
  [10764] = {.lex_state = 347},
  [10765] = {.lex_state = 133},
  [10766] = {.lex_state = 133},
  [10767] = {.lex_state = 347},
  [10768] = {.lex_state = 347, .external_lex_state = 45},
  [10769] = {.lex_state = 347, .external_lex_state = 45},
  [10770] = {.lex_state = 347},
  [10771] = {.lex_state = 347, .external_lex_state = 44},
  [10772] = {.lex_state = 347},
  [10773] = {.lex_state = 347},
  [10774] = {.lex_state = 347},
  [10775] = {.lex_state = 347},
  [10776] = {.lex_state = 347},
  [10777] = {.lex_state = 347},
  [10778] = {.lex_state = 347},
  [10779] = {.lex_state = 347},
  [10780] = {.lex_state = 166},
  [10781] = {.lex_state = 133},
  [10782] = {.lex_state = 347},
  [10783] = {.lex_state = 347, .external_lex_state = 40},
  [10784] = {.lex_state = 347, .external_lex_state = 31},
  [10785] = {.lex_state = 347, .external_lex_state = 31},
  [10786] = {.lex_state = 347},
  [10787] = {.lex_state = 347},
  [10788] = {.lex_state = 133},
  [10789] = {.lex_state = 347, .external_lex_state = 46},
  [10790] = {.lex_state = 347},
  [10791] = {.lex_state = 347},
  [10792] = {.lex_state = 347, .external_lex_state = 31},
  [10793] = {.lex_state = 133},
  [10794] = {.lex_state = 347},
  [10795] = {.lex_state = 347},
  [10796] = {.lex_state = 347},
  [10797] = {.lex_state = 347},
  [10798] = {.lex_state = 347},
  [10799] = {.lex_state = 347},
  [10800] = {.lex_state = 347, .external_lex_state = 31},
  [10801] = {.lex_state = 166},
  [10802] = {.lex_state = 133},
  [10803] = {.lex_state = 347, .external_lex_state = 44},
  [10804] = {.lex_state = 347},
  [10805] = {.lex_state = 347},
  [10806] = {.lex_state = 347},
  [10807] = {.lex_state = 347, .external_lex_state = 31},
  [10808] = {.lex_state = 347},
  [10809] = {.lex_state = 347},
  [10810] = {.lex_state = 347, .external_lex_state = 45},
  [10811] = {.lex_state = 347, .external_lex_state = 45},
  [10812] = {.lex_state = 347},
  [10813] = {.lex_state = 347, .external_lex_state = 44},
  [10814] = {.lex_state = 133},
  [10815] = {.lex_state = 166},
  [10816] = {.lex_state = 347},
  [10817] = {.lex_state = 347},
  [10818] = {.lex_state = 347},
  [10819] = {.lex_state = 347},
  [10820] = {.lex_state = 347},
  [10821] = {.lex_state = 347},
  [10822] = {.lex_state = 347},
  [10823] = {.lex_state = 347},
  [10824] = {.lex_state = 347},
  [10825] = {.lex_state = 347, .external_lex_state = 40},
  [10826] = {.lex_state = 347, .external_lex_state = 31},
  [10827] = {.lex_state = 347, .external_lex_state = 31},
  [10828] = {.lex_state = 166},
  [10829] = {.lex_state = 133},
  [10830] = {.lex_state = 347},
  [10831] = {.lex_state = 347},
  [10832] = {.lex_state = 347},
  [10833] = {.lex_state = 133},
  [10834] = {.lex_state = 347, .external_lex_state = 31},
  [10835] = {.lex_state = 347},
  [10836] = {.lex_state = 347},
  [10837] = {.lex_state = 347},
  [10838] = {.lex_state = 347},
  [10839] = {.lex_state = 347},
  [10840] = {.lex_state = 347},
  [10841] = {.lex_state = 347},
  [10842] = {.lex_state = 347, .external_lex_state = 31},
  [10843] = {.lex_state = 347},
  [10844] = {.lex_state = 166},
  [10845] = {.lex_state = 347, .external_lex_state = 44},
  [10846] = {.lex_state = 347},
  [10847] = {.lex_state = 347},
  [10848] = {.lex_state = 347},
  [10849] = {.lex_state = 347},
  [10850] = {.lex_state = 347, .external_lex_state = 45},
  [10851] = {.lex_state = 347, .external_lex_state = 45},
  [10852] = {.lex_state = 347},
  [10853] = {.lex_state = 347, .external_lex_state = 44},
  [10854] = {.lex_state = 133},
  [10855] = {.lex_state = 347},
  [10856] = {.lex_state = 347},
  [10857] = {.lex_state = 347},
  [10858] = {.lex_state = 347},
  [10859] = {.lex_state = 347},
  [10860] = {.lex_state = 347},
  [10861] = {.lex_state = 347},
  [10862] = {.lex_state = 347},
  [10863] = {.lex_state = 166},
  [10864] = {.lex_state = 133},
  [10865] = {.lex_state = 347, .external_lex_state = 40},
  [10866] = {.lex_state = 347, .external_lex_state = 31},
  [10867] = {.lex_state = 347, .external_lex_state = 31},
  [10868] = {.lex_state = 347},
  [10869] = {.lex_state = 347},
  [10870] = {.lex_state = 347},
  [10871] = {.lex_state = 133},
  [10872] = {.lex_state = 347},
  [10873] = {.lex_state = 347},
  [10874] = {.lex_state = 347, .external_lex_state = 31},
  [10875] = {.lex_state = 347},
  [10876] = {.lex_state = 347},
  [10877] = {.lex_state = 347},
  [10878] = {.lex_state = 347},
  [10879] = {.lex_state = 347},
  [10880] = {.lex_state = 347},
  [10881] = {.lex_state = 166},
  [10882] = {.lex_state = 347, .external_lex_state = 31},
  [10883] = {.lex_state = 133},
  [10884] = {.lex_state = 347},
  [10885] = {.lex_state = 347, .external_lex_state = 44},
  [10886] = {.lex_state = 347},
  [10887] = {.lex_state = 347, .external_lex_state = 46},
  [10888] = {.lex_state = 347},
  [10889] = {.lex_state = 133},
  [10890] = {.lex_state = 347, .external_lex_state = 45},
  [10891] = {.lex_state = 347, .external_lex_state = 45},
  [10892] = {.lex_state = 347},
  [10893] = {.lex_state = 347, .external_lex_state = 44},
  [10894] = {.lex_state = 347},
  [10895] = {.lex_state = 347},
  [10896] = {.lex_state = 347},
  [10897] = {.lex_state = 347},
  [10898] = {.lex_state = 347},
  [10899] = {.lex_state = 347, .external_lex_state = 46},
  [10900] = {.lex_state = 347},
  [10901] = {.lex_state = 347},
  [10902] = {.lex_state = 347},
  [10903] = {.lex_state = 347},
  [10904] = {.lex_state = 166},
  [10905] = {.lex_state = 347, .external_lex_state = 40},
  [10906] = {.lex_state = 347, .external_lex_state = 31},
  [10907] = {.lex_state = 347, .external_lex_state = 31},
  [10908] = {.lex_state = 133},
  [10909] = {.lex_state = 347},
  [10910] = {.lex_state = 347, .external_lex_state = 42},
  [10911] = {.lex_state = 347},
  [10912] = {.lex_state = 347, .external_lex_state = 31},
  [10913] = {.lex_state = 347},
  [10914] = {.lex_state = 347, .external_lex_state = 31},
  [10915] = {.lex_state = 133},
  [10916] = {.lex_state = 347},
  [10917] = {.lex_state = 347},
  [10918] = {.lex_state = 347},
  [10919] = {.lex_state = 347},
  [10920] = {.lex_state = 347},
  [10921] = {.lex_state = 347, .external_lex_state = 31},
  [10922] = {.lex_state = 347, .external_lex_state = 31},
  [10923] = {.lex_state = 347},
  [10924] = {.lex_state = 347},
  [10925] = {.lex_state = 347, .external_lex_state = 44},
  [10926] = {.lex_state = 347, .external_lex_state = 36},
  [10927] = {.lex_state = 347, .external_lex_state = 45},
  [10928] = {.lex_state = 347, .external_lex_state = 45},
  [10929] = {.lex_state = 347},
  [10930] = {.lex_state = 347},
  [10931] = {.lex_state = 347},
  [10932] = {.lex_state = 347},
  [10933] = {.lex_state = 347},
  [10934] = {.lex_state = 347, .external_lex_state = 31},
  [10935] = {.lex_state = 347},
  [10936] = {.lex_state = 166},
  [10937] = {.lex_state = 347, .external_lex_state = 31},
  [10938] = {.lex_state = 347, .external_lex_state = 31},
  [10939] = {.lex_state = 347, .external_lex_state = 36},
  [10940] = {.lex_state = 347},
  [10941] = {.lex_state = 133},
  [10942] = {.lex_state = 347},
  [10943] = {.lex_state = 347, .external_lex_state = 45},
  [10944] = {.lex_state = 347, .external_lex_state = 45},
  [10945] = {.lex_state = 347},
  [10946] = {.lex_state = 347, .external_lex_state = 46},
  [10947] = {.lex_state = 347},
  [10948] = {.lex_state = 166},
  [10949] = {.lex_state = 347},
  [10950] = {.lex_state = 347},
  [10951] = {.lex_state = 347},
  [10952] = {.lex_state = 347, .external_lex_state = 31},
  [10953] = {.lex_state = 347, .external_lex_state = 31},
  [10954] = {.lex_state = 347},
  [10955] = {.lex_state = 347},
  [10956] = {.lex_state = 347, .external_lex_state = 45},
  [10957] = {.lex_state = 347, .external_lex_state = 45},
  [10958] = {.lex_state = 347},
  [10959] = {.lex_state = 347, .external_lex_state = 31},
  [10960] = {.lex_state = 347},
  [10961] = {.lex_state = 133},
  [10962] = {.lex_state = 347},
  [10963] = {.lex_state = 347},
  [10964] = {.lex_state = 347},
  [10965] = {.lex_state = 347, .external_lex_state = 31},
  [10966] = {.lex_state = 166},
  [10967] = {.lex_state = 347},
  [10968] = {.lex_state = 347},
  [10969] = {.lex_state = 347, .external_lex_state = 45},
  [10970] = {.lex_state = 347, .external_lex_state = 45},
  [10971] = {.lex_state = 347},
  [10972] = {.lex_state = 347},
  [10973] = {.lex_state = 347, .external_lex_state = 36},
  [10974] = {.lex_state = 347, .external_lex_state = 31},
  [10975] = {.lex_state = 347},
  [10976] = {.lex_state = 347},
  [10977] = {.lex_state = 347},
  [10978] = {.lex_state = 347, .external_lex_state = 31},
  [10979] = {.lex_state = 347, .external_lex_state = 36},
  [10980] = {.lex_state = 347},
  [10981] = {.lex_state = 347, .external_lex_state = 45},
  [10982] = {.lex_state = 347, .external_lex_state = 45},
  [10983] = {.lex_state = 347},
  [10984] = {.lex_state = 347, .external_lex_state = 31},
  [10985] = {.lex_state = 347, .external_lex_state = 40},
  [10986] = {.lex_state = 347},
  [10987] = {.lex_state = 347},
  [10988] = {.lex_state = 347},
  [10989] = {.lex_state = 166},
  [10990] = {.lex_state = 347, .external_lex_state = 31},
  [10991] = {.lex_state = 347, .external_lex_state = 36},
  [10992] = {.lex_state = 133},
  [10993] = {.lex_state = 347, .external_lex_state = 45},
  [10994] = {.lex_state = 347, .external_lex_state = 45},
  [10995] = {.lex_state = 347},
  [10996] = {.lex_state = 347},
  [10997] = {.lex_state = 347},
  [10998] = {.lex_state = 347, .external_lex_state = 46},
  [10999] = {.lex_state = 347},
  [11000] = {.lex_state = 347},
  [11001] = {.lex_state = 166},
  [11002] = {.lex_state = 347, .external_lex_state = 31},
  [11003] = {.lex_state = 347},
  [11004] = {.lex_state = 347, .external_lex_state = 46},
  [11005] = {.lex_state = 347, .external_lex_state = 45},
  [11006] = {.lex_state = 347, .external_lex_state = 45},
  [11007] = {.lex_state = 347},
  [11008] = {.lex_state = 347},
  [11009] = {.lex_state = 347},
  [11010] = {.lex_state = 347},
  [11011] = {.lex_state = 347},
  [11012] = {.lex_state = 347},
  [11013] = {.lex_state = 347},
  [11014] = {.lex_state = 347, .external_lex_state = 31},
  [11015] = {.lex_state = 347, .external_lex_state = 31},
  [11016] = {.lex_state = 347},
  [11017] = {.lex_state = 347, .external_lex_state = 45},
  [11018] = {.lex_state = 347, .external_lex_state = 45},
  [11019] = {.lex_state = 133},
  [11020] = {.lex_state = 347},
  [11021] = {.lex_state = 347},
  [11022] = {.lex_state = 347},
  [11023] = {.lex_state = 347, .external_lex_state = 31},
  [11024] = {.lex_state = 347, .external_lex_state = 31},
  [11025] = {.lex_state = 166},
  [11026] = {.lex_state = 347, .external_lex_state = 45},
  [11027] = {.lex_state = 347, .external_lex_state = 45},
  [11028] = {.lex_state = 347},
  [11029] = {.lex_state = 347},
  [11030] = {.lex_state = 347},
  [11031] = {.lex_state = 347},
  [11032] = {.lex_state = 347},
  [11033] = {.lex_state = 347, .external_lex_state = 31},
  [11034] = {.lex_state = 347, .external_lex_state = 31},
  [11035] = {.lex_state = 347, .external_lex_state = 45},
  [11036] = {.lex_state = 347, .external_lex_state = 45},
  [11037] = {.lex_state = 347},
  [11038] = {.lex_state = 347},
  [11039] = {.lex_state = 347, .external_lex_state = 36},
  [11040] = {.lex_state = 347},
  [11041] = {.lex_state = 347, .external_lex_state = 31},
  [11042] = {.lex_state = 347, .external_lex_state = 31},
  [11043] = {.lex_state = 347, .external_lex_state = 45},
  [11044] = {.lex_state = 347, .external_lex_state = 45},
  [11045] = {.lex_state = 347},
  [11046] = {.lex_state = 166},
  [11047] = {.lex_state = 347, .external_lex_state = 36},
  [11048] = {.lex_state = 133},
  [11049] = {.lex_state = 347, .external_lex_state = 31},
  [11050] = {.lex_state = 347},
  [11051] = {.lex_state = 347, .external_lex_state = 46},
  [11052] = {.lex_state = 166},
  [11053] = {.lex_state = 347},
  [11054] = {.lex_state = 347},
  [11055] = {.lex_state = 347, .external_lex_state = 31},
  [11056] = {.lex_state = 347},
  [11057] = {.lex_state = 347},
  [11058] = {.lex_state = 347},
  [11059] = {.lex_state = 347},
  [11060] = {.lex_state = 347, .external_lex_state = 31},
  [11061] = {.lex_state = 347},
  [11062] = {.lex_state = 347, .external_lex_state = 31},
  [11063] = {.lex_state = 347},
  [11064] = {.lex_state = 347, .external_lex_state = 31},
  [11065] = {.lex_state = 347},
  [11066] = {.lex_state = 347},
  [11067] = {.lex_state = 133},
  [11068] = {.lex_state = 347, .external_lex_state = 31},
  [11069] = {.lex_state = 347},
  [11070] = {.lex_state = 347},
  [11071] = {.lex_state = 166},
  [11072] = {.lex_state = 347, .external_lex_state = 31},
  [11073] = {.lex_state = 347},
  [11074] = {.lex_state = 347},
  [11075] = {.lex_state = 347},
  [11076] = {.lex_state = 347, .external_lex_state = 31},
  [11077] = {.lex_state = 347},
  [11078] = {.lex_state = 347, .external_lex_state = 31},
  [11079] = {.lex_state = 347, .external_lex_state = 31},
  [11080] = {.lex_state = 347, .external_lex_state = 31},
  [11081] = {.lex_state = 347},
  [11082] = {.lex_state = 347},
  [11083] = {.lex_state = 347, .external_lex_state = 36},
  [11084] = {.lex_state = 347, .external_lex_state = 31},
  [11085] = {.lex_state = 347},
  [11086] = {.lex_state = 347},
  [11087] = {.lex_state = 347, .external_lex_state = 31},
  [11088] = {.lex_state = 347, .external_lex_state = 31},
  [11089] = {.lex_state = 347},
  [11090] = {.lex_state = 166},
  [11091] = {.lex_state = 347, .external_lex_state = 36},
  [11092] = {.lex_state = 347, .external_lex_state = 31},
  [11093] = {.lex_state = 133},
  [11094] = {.lex_state = 347},
  [11095] = {.lex_state = 347, .external_lex_state = 46},
  [11096] = {.lex_state = 347, .external_lex_state = 31},
  [11097] = {.lex_state = 347, .external_lex_state = 31},
  [11098] = {.lex_state = 166},
  [11099] = {.lex_state = 347},
  [11100] = {.lex_state = 347, .external_lex_state = 31},
  [11101] = {.lex_state = 347},
  [11102] = {.lex_state = 347, .external_lex_state = 31},
  [11103] = {.lex_state = 347},
  [11104] = {.lex_state = 347, .external_lex_state = 31},
  [11105] = {.lex_state = 347},
  [11106] = {.lex_state = 347, .external_lex_state = 42},
  [11107] = {.lex_state = 347},
  [11108] = {.lex_state = 347, .external_lex_state = 31},
  [11109] = {.lex_state = 347},
  [11110] = {.lex_state = 347, .external_lex_state = 42},
  [11111] = {.lex_state = 133},
  [11112] = {.lex_state = 347, .external_lex_state = 31},
  [11113] = {.lex_state = 347},
  [11114] = {.lex_state = 347, .external_lex_state = 42},
  [11115] = {.lex_state = 347},
  [11116] = {.lex_state = 347, .external_lex_state = 31},
  [11117] = {.lex_state = 166},
  [11118] = {.lex_state = 347},
  [11119] = {.lex_state = 347},
  [11120] = {.lex_state = 347, .external_lex_state = 31},
  [11121] = {.lex_state = 347},
  [11122] = {.lex_state = 347, .external_lex_state = 31},
  [11123] = {.lex_state = 347},
  [11124] = {.lex_state = 347, .external_lex_state = 31},
  [11125] = {.lex_state = 347},
  [11126] = {.lex_state = 347, .external_lex_state = 36},
  [11127] = {.lex_state = 347},
  [11128] = {.lex_state = 347, .external_lex_state = 31},
  [11129] = {.lex_state = 347},
  [11130] = {.lex_state = 347, .external_lex_state = 31},
  [11131] = {.lex_state = 347},
  [11132] = {.lex_state = 347, .external_lex_state = 31},
  [11133] = {.lex_state = 347},
  [11134] = {.lex_state = 166},
  [11135] = {.lex_state = 347, .external_lex_state = 36},
  [11136] = {.lex_state = 347, .external_lex_state = 31},
  [11137] = {.lex_state = 133},
  [11138] = {.lex_state = 347},
  [11139] = {.lex_state = 347, .external_lex_state = 46},
  [11140] = {.lex_state = 347, .external_lex_state = 31},
  [11141] = {.lex_state = 347, .external_lex_state = 46},
  [11142] = {.lex_state = 347},
  [11143] = {.lex_state = 166},
  [11144] = {.lex_state = 347, .external_lex_state = 31},
  [11145] = {.lex_state = 347},
  [11146] = {.lex_state = 347},
  [11147] = {.lex_state = 347},
  [11148] = {.lex_state = 347, .external_lex_state = 31},
  [11149] = {.lex_state = 347},
  [11150] = {.lex_state = 347},
  [11151] = {.lex_state = 347},
  [11152] = {.lex_state = 347, .external_lex_state = 31},
  [11153] = {.lex_state = 347},
  [11154] = {.lex_state = 347, .external_lex_state = 31},
  [11155] = {.lex_state = 347},
  [11156] = {.lex_state = 347},
  [11157] = {.lex_state = 347},
  [11158] = {.lex_state = 347},
  [11159] = {.lex_state = 133},
  [11160] = {.lex_state = 347, .external_lex_state = 31},
  [11161] = {.lex_state = 347},
  [11162] = {.lex_state = 347},
  [11163] = {.lex_state = 166},
  [11164] = {.lex_state = 347, .external_lex_state = 31},
  [11165] = {.lex_state = 347},
  [11166] = {.lex_state = 347},
  [11167] = {.lex_state = 347},
  [11168] = {.lex_state = 347, .external_lex_state = 31},
  [11169] = {.lex_state = 347},
  [11170] = {.lex_state = 347, .external_lex_state = 31},
  [11171] = {.lex_state = 347},
  [11172] = {.lex_state = 347, .external_lex_state = 31},
  [11173] = {.lex_state = 347},
  [11174] = {.lex_state = 347, .external_lex_state = 36},
  [11175] = {.lex_state = 347},
  [11176] = {.lex_state = 347, .external_lex_state = 31},
  [11177] = {.lex_state = 347, .external_lex_state = 31},
  [11178] = {.lex_state = 347},
  [11179] = {.lex_state = 347},
  [11180] = {.lex_state = 166},
  [11181] = {.lex_state = 347},
  [11182] = {.lex_state = 347, .external_lex_state = 36},
  [11183] = {.lex_state = 133},
  [11184] = {.lex_state = 347},
  [11185] = {.lex_state = 347, .external_lex_state = 46},
  [11186] = {.lex_state = 347},
  [11187] = {.lex_state = 166},
  [11188] = {.lex_state = 347},
  [11189] = {.lex_state = 347},
  [11190] = {.lex_state = 347, .external_lex_state = 31},
  [11191] = {.lex_state = 347},
  [11192] = {.lex_state = 347},
  [11193] = {.lex_state = 347},
  [11194] = {.lex_state = 347},
  [11195] = {.lex_state = 347},
  [11196] = {.lex_state = 347},
  [11197] = {.lex_state = 347, .external_lex_state = 42},
  [11198] = {.lex_state = 347, .external_lex_state = 31},
  [11199] = {.lex_state = 347},
  [11200] = {.lex_state = 347},
  [11201] = {.lex_state = 347},
  [11202] = {.lex_state = 347},
  [11203] = {.lex_state = 347, .external_lex_state = 36},
  [11204] = {.lex_state = 347, .external_lex_state = 36},
  [11205] = {.lex_state = 133},
  [11206] = {.lex_state = 347},
  [11207] = {.lex_state = 347, .external_lex_state = 42},
  [11208] = {.lex_state = 347},
  [11209] = {.lex_state = 347},
  [11210] = {.lex_state = 347},
  [11211] = {.lex_state = 347},
  [11212] = {.lex_state = 347},
  [11213] = {.lex_state = 347, .external_lex_state = 31},
  [11214] = {.lex_state = 166},
  [11215] = {.lex_state = 347},
  [11216] = {.lex_state = 347},
  [11217] = {.lex_state = 347, .external_lex_state = 42},
  [11218] = {.lex_state = 347, .external_lex_state = 42},
  [11219] = {.lex_state = 347},
  [11220] = {.lex_state = 347},
  [11221] = {.lex_state = 347, .external_lex_state = 31},
  [11222] = {.lex_state = 347, .external_lex_state = 42},
  [11223] = {.lex_state = 347},
  [11224] = {.lex_state = 347},
  [11225] = {.lex_state = 347},
  [11226] = {.lex_state = 347},
  [11227] = {.lex_state = 347},
  [11228] = {.lex_state = 347},
  [11229] = {.lex_state = 347, .external_lex_state = 42},
  [11230] = {.lex_state = 347, .external_lex_state = 42},
  [11231] = {.lex_state = 347, .external_lex_state = 42},
  [11232] = {.lex_state = 347},
  [11233] = {.lex_state = 347},
  [11234] = {.lex_state = 347},
  [11235] = {.lex_state = 347},
  [11236] = {.lex_state = 347},
  [11237] = {.lex_state = 347},
  [11238] = {.lex_state = 347},
  [11239] = {.lex_state = 347},
  [11240] = {.lex_state = 347},
  [11241] = {.lex_state = 347},
  [11242] = {.lex_state = 347},
  [11243] = {.lex_state = 347, .external_lex_state = 42},
  [11244] = {.lex_state = 347},
  [11245] = {.lex_state = 347},
  [11246] = {.lex_state = 347},
  [11247] = {.lex_state = 347, .external_lex_state = 31},
  [11248] = {.lex_state = 347, .external_lex_state = 42},
  [11249] = {.lex_state = 347, .external_lex_state = 31},
  [11250] = {.lex_state = 347},
  [11251] = {.lex_state = 347, .external_lex_state = 42},
  [11252] = {.lex_state = 347},
  [11253] = {.lex_state = 347, .external_lex_state = 36},
  [11254] = {.lex_state = 347},
  [11255] = {.lex_state = 347, .external_lex_state = 42},
  [11256] = {.lex_state = 347},
  [11257] = {.lex_state = 347, .external_lex_state = 42},
  [11258] = {.lex_state = 347, .external_lex_state = 42},
  [11259] = {.lex_state = 347, .external_lex_state = 31},
  [11260] = {.lex_state = 347, .external_lex_state = 31},
  [11261] = {.lex_state = 347, .external_lex_state = 42},
  [11262] = {.lex_state = 347},
  [11263] = {.lex_state = 347},
  [11264] = {.lex_state = 347},
  [11265] = {.lex_state = 347},
  [11266] = {.lex_state = 166},
  [11267] = {.lex_state = 347, .external_lex_state = 36},
  [11268] = {.lex_state = 347, .external_lex_state = 31},
  [11269] = {.lex_state = 347, .external_lex_state = 42},
  [11270] = {.lex_state = 347},
  [11271] = {.lex_state = 347},
  [11272] = {.lex_state = 347, .external_lex_state = 31},
  [11273] = {.lex_state = 133},
  [11274] = {.lex_state = 347},
  [11275] = {.lex_state = 347, .external_lex_state = 31},
  [11276] = {.lex_state = 347},
  [11277] = {.lex_state = 347, .external_lex_state = 46},
  [11278] = {.lex_state = 166},
  [11279] = {.lex_state = 347},
  [11280] = {.lex_state = 347},
  [11281] = {.lex_state = 347},
  [11282] = {.lex_state = 347},
  [11283] = {.lex_state = 347},
  [11284] = {.lex_state = 347},
  [11285] = {.lex_state = 347},
  [11286] = {.lex_state = 347, .external_lex_state = 31},
  [11287] = {.lex_state = 347, .external_lex_state = 42},
  [11288] = {.lex_state = 347},
  [11289] = {.lex_state = 347},
  [11290] = {.lex_state = 347},
  [11291] = {.lex_state = 347},
  [11292] = {.lex_state = 133},
  [11293] = {.lex_state = 347},
  [11294] = {.lex_state = 347},
  [11295] = {.lex_state = 166},
  [11296] = {.lex_state = 347},
  [11297] = {.lex_state = 347, .external_lex_state = 42},
  [11298] = {.lex_state = 347, .external_lex_state = 42},
  [11299] = {.lex_state = 347},
  [11300] = {.lex_state = 347},
  [11301] = {.lex_state = 347},
  [11302] = {.lex_state = 347, .external_lex_state = 42},
  [11303] = {.lex_state = 347},
  [11304] = {.lex_state = 347},
  [11305] = {.lex_state = 347},
  [11306] = {.lex_state = 347, .external_lex_state = 31},
  [11307] = {.lex_state = 347},
  [11308] = {.lex_state = 347},
  [11309] = {.lex_state = 347, .external_lex_state = 42},
  [11310] = {.lex_state = 347, .external_lex_state = 42},
  [11311] = {.lex_state = 347, .external_lex_state = 42},
  [11312] = {.lex_state = 347},
  [11313] = {.lex_state = 347},
  [11314] = {.lex_state = 347},
  [11315] = {.lex_state = 347, .external_lex_state = 31},
  [11316] = {.lex_state = 347},
  [11317] = {.lex_state = 347},
  [11318] = {.lex_state = 347},
  [11319] = {.lex_state = 347, .external_lex_state = 42},
  [11320] = {.lex_state = 347, .external_lex_state = 31},
  [11321] = {.lex_state = 347},
  [11322] = {.lex_state = 347},
  [11323] = {.lex_state = 347, .external_lex_state = 31},
  [11324] = {.lex_state = 347, .external_lex_state = 42},
  [11325] = {.lex_state = 347, .external_lex_state = 31},
  [11326] = {.lex_state = 347},
  [11327] = {.lex_state = 347, .external_lex_state = 42},
  [11328] = {.lex_state = 347},
  [11329] = {.lex_state = 347, .external_lex_state = 36},
  [11330] = {.lex_state = 347},
  [11331] = {.lex_state = 347, .external_lex_state = 42},
  [11332] = {.lex_state = 347},
  [11333] = {.lex_state = 347, .external_lex_state = 42},
  [11334] = {.lex_state = 347, .external_lex_state = 42},
  [11335] = {.lex_state = 347, .external_lex_state = 31},
  [11336] = {.lex_state = 347, .external_lex_state = 42},
  [11337] = {.lex_state = 347},
  [11338] = {.lex_state = 347, .external_lex_state = 31},
  [11339] = {.lex_state = 347},
  [11340] = {.lex_state = 347},
  [11341] = {.lex_state = 347},
  [11342] = {.lex_state = 166},
  [11343] = {.lex_state = 347, .external_lex_state = 31},
  [11344] = {.lex_state = 347, .external_lex_state = 42},
  [11345] = {.lex_state = 347},
  [11346] = {.lex_state = 347},
  [11347] = {.lex_state = 347, .external_lex_state = 31},
  [11348] = {.lex_state = 347, .external_lex_state = 36},
  [11349] = {.lex_state = 347},
  [11350] = {.lex_state = 133},
  [11351] = {.lex_state = 347},
  [11352] = {.lex_state = 347, .external_lex_state = 46},
  [11353] = {.lex_state = 347, .external_lex_state = 42},
  [11354] = {.lex_state = 347},
  [11355] = {.lex_state = 166},
  [11356] = {.lex_state = 347},
  [11357] = {.lex_state = 347},
  [11358] = {.lex_state = 347},
  [11359] = {.lex_state = 347},
  [11360] = {.lex_state = 347},
  [11361] = {.lex_state = 347},
  [11362] = {.lex_state = 347},
  [11363] = {.lex_state = 347, .external_lex_state = 42},
  [11364] = {.lex_state = 347, .external_lex_state = 42},
  [11365] = {.lex_state = 347, .external_lex_state = 31},
  [11366] = {.lex_state = 166},
  [11367] = {.lex_state = 347},
  [11368] = {.lex_state = 347, .external_lex_state = 42},
  [11369] = {.lex_state = 347},
  [11370] = {.lex_state = 347},
  [11371] = {.lex_state = 133},
  [11372] = {.lex_state = 347},
  [11373] = {.lex_state = 347},
  [11374] = {.lex_state = 347},
  [11375] = {.lex_state = 347, .external_lex_state = 42},
  [11376] = {.lex_state = 347, .external_lex_state = 42},
  [11377] = {.lex_state = 347, .external_lex_state = 42},
  [11378] = {.lex_state = 347},
  [11379] = {.lex_state = 166},
  [11380] = {.lex_state = 347},
  [11381] = {.lex_state = 347},
  [11382] = {.lex_state = 347},
  [11383] = {.lex_state = 347},
  [11384] = {.lex_state = 347, .external_lex_state = 42},
  [11385] = {.lex_state = 347, .external_lex_state = 40},
  [11386] = {.lex_state = 347},
  [11387] = {.lex_state = 347},
  [11388] = {.lex_state = 347},
  [11389] = {.lex_state = 347},
  [11390] = {.lex_state = 347},
  [11391] = {.lex_state = 347, .external_lex_state = 42},
  [11392] = {.lex_state = 347},
  [11393] = {.lex_state = 347},
  [11394] = {.lex_state = 347},
  [11395] = {.lex_state = 347, .external_lex_state = 42},
  [11396] = {.lex_state = 347},
  [11397] = {.lex_state = 347, .external_lex_state = 42},
  [11398] = {.lex_state = 347, .external_lex_state = 42},
  [11399] = {.lex_state = 347},
  [11400] = {.lex_state = 347, .external_lex_state = 42},
  [11401] = {.lex_state = 347},
  [11402] = {.lex_state = 347},
  [11403] = {.lex_state = 347},
  [11404] = {.lex_state = 347},
  [11405] = {.lex_state = 347},
  [11406] = {.lex_state = 347},
  [11407] = {.lex_state = 347, .external_lex_state = 31},
  [11408] = {.lex_state = 347, .external_lex_state = 42},
  [11409] = {.lex_state = 347},
  [11410] = {.lex_state = 347},
  [11411] = {.lex_state = 347, .external_lex_state = 31},
  [11412] = {.lex_state = 347, .external_lex_state = 36},
  [11413] = {.lex_state = 347},
  [11414] = {.lex_state = 347, .external_lex_state = 31},
  [11415] = {.lex_state = 347, .external_lex_state = 31},
  [11416] = {.lex_state = 347, .external_lex_state = 31},
  [11417] = {.lex_state = 347, .external_lex_state = 42},
  [11418] = {.lex_state = 347},
  [11419] = {.lex_state = 347},
  [11420] = {.lex_state = 166},
  [11421] = {.lex_state = 347, .external_lex_state = 36},
  [11422] = {.lex_state = 347},
  [11423] = {.lex_state = 347},
  [11424] = {.lex_state = 347, .external_lex_state = 42},
  [11425] = {.lex_state = 347},
  [11426] = {.lex_state = 347, .external_lex_state = 36},
  [11427] = {.lex_state = 347, .external_lex_state = 42},
  [11428] = {.lex_state = 347},
  [11429] = {.lex_state = 347},
  [11430] = {.lex_state = 347, .external_lex_state = 31},
  [11431] = {.lex_state = 347},
  [11432] = {.lex_state = 347},
  [11433] = {.lex_state = 347},
  [11434] = {.lex_state = 166},
  [11435] = {.lex_state = 347},
  [11436] = {.lex_state = 347, .external_lex_state = 36},
  [11437] = {.lex_state = 133},
  [11438] = {.lex_state = 347},
  [11439] = {.lex_state = 347, .external_lex_state = 46},
  [11440] = {.lex_state = 347, .external_lex_state = 42},
  [11441] = {.lex_state = 166},
  [11442] = {.lex_state = 347},
  [11443] = {.lex_state = 347},
  [11444] = {.lex_state = 347, .external_lex_state = 31},
  [11445] = {.lex_state = 347},
  [11446] = {.lex_state = 347},
  [11447] = {.lex_state = 347},
  [11448] = {.lex_state = 347},
  [11449] = {.lex_state = 347, .external_lex_state = 31},
  [11450] = {.lex_state = 347},
  [11451] = {.lex_state = 347, .external_lex_state = 42},
  [11452] = {.lex_state = 347},
  [11453] = {.lex_state = 347},
  [11454] = {.lex_state = 166},
  [11455] = {.lex_state = 347},
  [11456] = {.lex_state = 347},
  [11457] = {.lex_state = 347},
  [11458] = {.lex_state = 133},
  [11459] = {.lex_state = 347, .external_lex_state = 42},
  [11460] = {.lex_state = 347},
  [11461] = {.lex_state = 347},
  [11462] = {.lex_state = 347},
  [11463] = {.lex_state = 347},
  [11464] = {.lex_state = 166},
  [11465] = {.lex_state = 347},
  [11466] = {.lex_state = 347, .external_lex_state = 42},
  [11467] = {.lex_state = 347},
  [11468] = {.lex_state = 347},
  [11469] = {.lex_state = 347, .external_lex_state = 42},
  [11470] = {.lex_state = 347},
  [11471] = {.lex_state = 347},
  [11472] = {.lex_state = 347},
  [11473] = {.lex_state = 347},
  [11474] = {.lex_state = 347},
  [11475] = {.lex_state = 347},
  [11476] = {.lex_state = 347},
  [11477] = {.lex_state = 347},
  [11478] = {.lex_state = 347},
  [11479] = {.lex_state = 347},
  [11480] = {.lex_state = 347},
  [11481] = {.lex_state = 347},
  [11482] = {.lex_state = 347, .external_lex_state = 42},
  [11483] = {.lex_state = 347},
  [11484] = {.lex_state = 347, .external_lex_state = 36},
  [11485] = {.lex_state = 347},
  [11486] = {.lex_state = 347, .external_lex_state = 42},
  [11487] = {.lex_state = 347, .external_lex_state = 31},
  [11488] = {.lex_state = 347},
  [11489] = {.lex_state = 347},
  [11490] = {.lex_state = 347},
  [11491] = {.lex_state = 347, .external_lex_state = 31},
  [11492] = {.lex_state = 347, .external_lex_state = 36},
  [11493] = {.lex_state = 347, .external_lex_state = 42},
  [11494] = {.lex_state = 347},
  [11495] = {.lex_state = 347},
  [11496] = {.lex_state = 347},
  [11497] = {.lex_state = 347},
  [11498] = {.lex_state = 347},
  [11499] = {.lex_state = 347, .external_lex_state = 36},
  [11500] = {.lex_state = 347},
  [11501] = {.lex_state = 347, .external_lex_state = 42},
  [11502] = {.lex_state = 347},
  [11503] = {.lex_state = 347},
  [11504] = {.lex_state = 347, .external_lex_state = 31},
  [11505] = {.lex_state = 347},
  [11506] = {.lex_state = 347},
  [11507] = {.lex_state = 347},
  [11508] = {.lex_state = 347, .external_lex_state = 42},
  [11509] = {.lex_state = 166},
  [11510] = {.lex_state = 347, .external_lex_state = 36},
  [11511] = {.lex_state = 347, .external_lex_state = 42},
  [11512] = {.lex_state = 133},
  [11513] = {.lex_state = 347},
  [11514] = {.lex_state = 347},
  [11515] = {.lex_state = 347, .external_lex_state = 42},
  [11516] = {.lex_state = 347, .external_lex_state = 46},
  [11517] = {.lex_state = 166},
  [11518] = {.lex_state = 347},
  [11519] = {.lex_state = 347},
  [11520] = {.lex_state = 347},
  [11521] = {.lex_state = 347, .external_lex_state = 30},
  [11522] = {.lex_state = 347},
  [11523] = {.lex_state = 347},
  [11524] = {.lex_state = 347, .external_lex_state = 42},
  [11525] = {.lex_state = 347},
  [11526] = {.lex_state = 347},
  [11527] = {.lex_state = 347},
  [11528] = {.lex_state = 347, .external_lex_state = 42},
  [11529] = {.lex_state = 347, .external_lex_state = 31},
  [11530] = {.lex_state = 347},
  [11531] = {.lex_state = 166},
  [11532] = {.lex_state = 347},
  [11533] = {.lex_state = 347},
  [11534] = {.lex_state = 347},
  [11535] = {.lex_state = 347, .external_lex_state = 42},
  [11536] = {.lex_state = 347},
  [11537] = {.lex_state = 347},
  [11538] = {.lex_state = 133},
  [11539] = {.lex_state = 347},
  [11540] = {.lex_state = 347},
  [11541] = {.lex_state = 347},
  [11542] = {.lex_state = 166},
  [11543] = {.lex_state = 347, .external_lex_state = 42},
  [11544] = {.lex_state = 347},
  [11545] = {.lex_state = 347},
  [11546] = {.lex_state = 347},
  [11547] = {.lex_state = 347},
  [11548] = {.lex_state = 347},
  [11549] = {.lex_state = 347, .external_lex_state = 40},
  [11550] = {.lex_state = 347, .external_lex_state = 42},
  [11551] = {.lex_state = 347},
  [11552] = {.lex_state = 347, .external_lex_state = 40},
  [11553] = {.lex_state = 347, .external_lex_state = 42},
  [11554] = {.lex_state = 347},
  [11555] = {.lex_state = 347},
  [11556] = {.lex_state = 347},
  [11557] = {.lex_state = 347},
  [11558] = {.lex_state = 347},
  [11559] = {.lex_state = 347},
  [11560] = {.lex_state = 347},
  [11561] = {.lex_state = 347},
  [11562] = {.lex_state = 347},
  [11563] = {.lex_state = 347},
  [11564] = {.lex_state = 347},
  [11565] = {.lex_state = 347},
  [11566] = {.lex_state = 347, .external_lex_state = 42},
  [11567] = {.lex_state = 347, .external_lex_state = 36},
  [11568] = {.lex_state = 347, .external_lex_state = 31},
  [11569] = {.lex_state = 347},
  [11570] = {.lex_state = 347, .external_lex_state = 31},
  [11571] = {.lex_state = 347, .external_lex_state = 31},
  [11572] = {.lex_state = 347, .external_lex_state = 36},
  [11573] = {.lex_state = 347},
  [11574] = {.lex_state = 347},
  [11575] = {.lex_state = 347},
  [11576] = {.lex_state = 347, .external_lex_state = 42},
  [11577] = {.lex_state = 347},
  [11578] = {.lex_state = 347},
  [11579] = {.lex_state = 347, .external_lex_state = 36},
  [11580] = {.lex_state = 347},
  [11581] = {.lex_state = 347},
  [11582] = {.lex_state = 347, .external_lex_state = 31},
  [11583] = {.lex_state = 347},
  [11584] = {.lex_state = 347, .external_lex_state = 42},
  [11585] = {.lex_state = 347},
  [11586] = {.lex_state = 347},
  [11587] = {.lex_state = 347},
  [11588] = {.lex_state = 347},
  [11589] = {.lex_state = 166},
  [11590] = {.lex_state = 347, .external_lex_state = 36},
  [11591] = {.lex_state = 347, .external_lex_state = 42},
  [11592] = {.lex_state = 133},
  [11593] = {.lex_state = 347},
  [11594] = {.lex_state = 347, .external_lex_state = 46},
  [11595] = {.lex_state = 166},
  [11596] = {.lex_state = 347},
  [11597] = {.lex_state = 347},
  [11598] = {.lex_state = 347},
  [11599] = {.lex_state = 347},
  [11600] = {.lex_state = 347},
  [11601] = {.lex_state = 347},
  [11602] = {.lex_state = 347, .external_lex_state = 42},
  [11603] = {.lex_state = 347},
  [11604] = {.lex_state = 347, .external_lex_state = 31},
  [11605] = {.lex_state = 347, .external_lex_state = 42},
  [11606] = {.lex_state = 347, .external_lex_state = 40},
  [11607] = {.lex_state = 347},
  [11608] = {.lex_state = 347},
  [11609] = {.lex_state = 347, .external_lex_state = 42},
  [11610] = {.lex_state = 166},
  [11611] = {.lex_state = 347, .external_lex_state = 40},
  [11612] = {.lex_state = 347},
  [11613] = {.lex_state = 347},
  [11614] = {.lex_state = 347},
  [11615] = {.lex_state = 133},
  [11616] = {.lex_state = 347, .external_lex_state = 42},
  [11617] = {.lex_state = 347},
  [11618] = {.lex_state = 347},
  [11619] = {.lex_state = 347},
  [11620] = {.lex_state = 166},
  [11621] = {.lex_state = 347, .external_lex_state = 42},
  [11622] = {.lex_state = 347},
  [11623] = {.lex_state = 347},
  [11624] = {.lex_state = 347, .external_lex_state = 36},
  [11625] = {.lex_state = 347, .external_lex_state = 40},
  [11626] = {.lex_state = 347, .external_lex_state = 36},
  [11627] = {.lex_state = 347},
  [11628] = {.lex_state = 347, .external_lex_state = 42},
  [11629] = {.lex_state = 347},
  [11630] = {.lex_state = 347, .external_lex_state = 40},
  [11631] = {.lex_state = 347},
  [11632] = {.lex_state = 347},
  [11633] = {.lex_state = 347},
  [11634] = {.lex_state = 347},
  [11635] = {.lex_state = 347},
  [11636] = {.lex_state = 347},
  [11637] = {.lex_state = 347},
  [11638] = {.lex_state = 347},
  [11639] = {.lex_state = 347},
  [11640] = {.lex_state = 347},
  [11641] = {.lex_state = 347},
  [11642] = {.lex_state = 347, .external_lex_state = 42},
  [11643] = {.lex_state = 347},
  [11644] = {.lex_state = 347},
  [11645] = {.lex_state = 347},
  [11646] = {.lex_state = 347, .external_lex_state = 36},
  [11647] = {.lex_state = 347, .external_lex_state = 31},
  [11648] = {.lex_state = 347, .external_lex_state = 31},
  [11649] = {.lex_state = 347},
  [11650] = {.lex_state = 347, .external_lex_state = 31},
  [11651] = {.lex_state = 347, .external_lex_state = 36},
  [11652] = {.lex_state = 347, .external_lex_state = 42},
  [11653] = {.lex_state = 347},
  [11654] = {.lex_state = 347},
  [11655] = {.lex_state = 1},
  [11656] = {.lex_state = 347, .external_lex_state = 36},
  [11657] = {.lex_state = 347, .external_lex_state = 42},
  [11658] = {.lex_state = 347},
  [11659] = {.lex_state = 347},
  [11660] = {.lex_state = 347},
  [11661] = {.lex_state = 347, .external_lex_state = 31},
  [11662] = {.lex_state = 347},
  [11663] = {.lex_state = 347},
  [11664] = {.lex_state = 347, .external_lex_state = 42},
  [11665] = {.lex_state = 347},
  [11666] = {.lex_state = 166},
  [11667] = {.lex_state = 347, .external_lex_state = 42},
  [11668] = {.lex_state = 347, .external_lex_state = 36},
  [11669] = {.lex_state = 133},
  [11670] = {.lex_state = 347},
  [11671] = {.lex_state = 347, .external_lex_state = 46},
  [11672] = {.lex_state = 166},
  [11673] = {.lex_state = 347},
  [11674] = {.lex_state = 347},
  [11675] = {.lex_state = 347},
  [11676] = {.lex_state = 347},
  [11677] = {.lex_state = 347, .external_lex_state = 42},
  [11678] = {.lex_state = 347},
  [11679] = {.lex_state = 347},
  [11680] = {.lex_state = 347},
  [11681] = {.lex_state = 347},
  [11682] = {.lex_state = 347, .external_lex_state = 31},
  [11683] = {.lex_state = 347},
  [11684] = {.lex_state = 347, .external_lex_state = 42},
  [11685] = {.lex_state = 166},
  [11686] = {.lex_state = 347},
  [11687] = {.lex_state = 347, .external_lex_state = 40},
  [11688] = {.lex_state = 347},
  [11689] = {.lex_state = 133},
  [11690] = {.lex_state = 347},
  [11691] = {.lex_state = 133},
  [11692] = {.lex_state = 347},
  [11693] = {.lex_state = 347},
  [11694] = {.lex_state = 347},
  [11695] = {.lex_state = 166},
  [11696] = {.lex_state = 347, .external_lex_state = 42},
  [11697] = {.lex_state = 347},
  [11698] = {.lex_state = 347},
  [11699] = {.lex_state = 347},
  [11700] = {.lex_state = 347},
  [11701] = {.lex_state = 347},
  [11702] = {.lex_state = 347},
  [11703] = {.lex_state = 347, .external_lex_state = 42},
  [11704] = {.lex_state = 347, .external_lex_state = 36},
  [11705] = {.lex_state = 347},
  [11706] = {.lex_state = 347},
  [11707] = {.lex_state = 347, .external_lex_state = 31},
  [11708] = {.lex_state = 347},
  [11709] = {.lex_state = 347},
  [11710] = {.lex_state = 347},
  [11711] = {.lex_state = 347},
  [11712] = {.lex_state = 347, .external_lex_state = 31},
  [11713] = {.lex_state = 347},
  [11714] = {.lex_state = 347},
  [11715] = {.lex_state = 347, .external_lex_state = 42},
  [11716] = {.lex_state = 347},
  [11717] = {.lex_state = 347},
  [11718] = {.lex_state = 347},
  [11719] = {.lex_state = 347},
  [11720] = {.lex_state = 347},
  [11721] = {.lex_state = 347, .external_lex_state = 46},
  [11722] = {.lex_state = 347, .external_lex_state = 42},
  [11723] = {.lex_state = 347},
  [11724] = {.lex_state = 347, .external_lex_state = 31},
  [11725] = {.lex_state = 347, .external_lex_state = 46},
  [11726] = {.lex_state = 347, .external_lex_state = 36},
  [11727] = {.lex_state = 347},
  [11728] = {.lex_state = 347, .external_lex_state = 31},
  [11729] = {.lex_state = 347, .external_lex_state = 31},
  [11730] = {.lex_state = 347, .external_lex_state = 44},
  [11731] = {.lex_state = 347, .external_lex_state = 46},
  [11732] = {.lex_state = 347, .external_lex_state = 46},
  [11733] = {.lex_state = 347, .external_lex_state = 42},
  [11734] = {.lex_state = 347},
  [11735] = {.lex_state = 347},
  [11736] = {.lex_state = 347, .external_lex_state = 31},
  [11737] = {.lex_state = 347, .external_lex_state = 31},
  [11738] = {.lex_state = 166},
  [11739] = {.lex_state = 347},
  [11740] = {.lex_state = 347, .external_lex_state = 42},
  [11741] = {.lex_state = 347, .external_lex_state = 31},
  [11742] = {.lex_state = 166},
  [11743] = {.lex_state = 347},
  [11744] = {.lex_state = 347},
  [11745] = {.lex_state = 347, .external_lex_state = 46},
  [11746] = {.lex_state = 347, .external_lex_state = 31},
  [11747] = {.lex_state = 347},
  [11748] = {.lex_state = 347, .external_lex_state = 31},
  [11749] = {.lex_state = 347},
  [11750] = {.lex_state = 347, .external_lex_state = 36},
  [11751] = {.lex_state = 347, .external_lex_state = 42},
  [11752] = {.lex_state = 347},
  [11753] = {.lex_state = 347},
  [11754] = {.lex_state = 347, .external_lex_state = 36},
  [11755] = {.lex_state = 347},
  [11756] = {.lex_state = 347, .external_lex_state = 31},
  [11757] = {.lex_state = 347},
  [11758] = {.lex_state = 347, .external_lex_state = 42},
  [11759] = {.lex_state = 347},
  [11760] = {.lex_state = 347, .external_lex_state = 31},
  [11761] = {.lex_state = 347, .external_lex_state = 31},
  [11762] = {.lex_state = 347, .external_lex_state = 31},
  [11763] = {.lex_state = 347},
  [11764] = {.lex_state = 166},
  [11765] = {.lex_state = 347, .external_lex_state = 31},
  [11766] = {.lex_state = 347},
  [11767] = {.lex_state = 347, .external_lex_state = 36},
  [11768] = {.lex_state = 133},
  [11769] = {.lex_state = 347},
  [11770] = {.lex_state = 347, .external_lex_state = 46},
  [11771] = {.lex_state = 347},
  [11772] = {.lex_state = 1},
  [11773] = {.lex_state = 347},
  [11774] = {.lex_state = 347},
  [11775] = {.lex_state = 347},
  [11776] = {.lex_state = 347},
  [11777] = {.lex_state = 347},
  [11778] = {.lex_state = 347},
  [11779] = {.lex_state = 347},
  [11780] = {.lex_state = 347},
  [11781] = {.lex_state = 347},
  [11782] = {.lex_state = 347},
  [11783] = {.lex_state = 347, .external_lex_state = 31},
  [11784] = {.lex_state = 347},
  [11785] = {.lex_state = 347},
  [11786] = {.lex_state = 166},
  [11787] = {.lex_state = 347},
  [11788] = {.lex_state = 347},
  [11789] = {.lex_state = 347},
  [11790] = {.lex_state = 133},
  [11791] = {.lex_state = 347},
  [11792] = {.lex_state = 347},
  [11793] = {.lex_state = 347},
  [11794] = {.lex_state = 347},
  [11795] = {.lex_state = 166},
  [11796] = {.lex_state = 347},
  [11797] = {.lex_state = 347},
  [11798] = {.lex_state = 347},
  [11799] = {.lex_state = 347},
  [11800] = {.lex_state = 347},
  [11801] = {.lex_state = 347},
  [11802] = {.lex_state = 347, .external_lex_state = 31},
  [11803] = {.lex_state = 347},
  [11804] = {.lex_state = 347},
  [11805] = {.lex_state = 347},
  [11806] = {.lex_state = 347},
  [11807] = {.lex_state = 347, .external_lex_state = 31},
  [11808] = {.lex_state = 347},
  [11809] = {.lex_state = 347},
  [11810] = {.lex_state = 347},
  [11811] = {.lex_state = 347, .external_lex_state = 46},
  [11812] = {.lex_state = 347},
  [11813] = {.lex_state = 347, .external_lex_state = 31},
  [11814] = {.lex_state = 347, .external_lex_state = 46},
  [11815] = {.lex_state = 347, .external_lex_state = 36},
  [11816] = {.lex_state = 347, .external_lex_state = 31},
  [11817] = {.lex_state = 347, .external_lex_state = 31},
  [11818] = {.lex_state = 347, .external_lex_state = 46},
  [11819] = {.lex_state = 347, .external_lex_state = 46},
  [11820] = {.lex_state = 347, .external_lex_state = 31},
  [11821] = {.lex_state = 347, .external_lex_state = 31},
  [11822] = {.lex_state = 347, .external_lex_state = 31},
  [11823] = {.lex_state = 347, .external_lex_state = 36},
  [11824] = {.lex_state = 347, .external_lex_state = 46},
  [11825] = {.lex_state = 347, .external_lex_state = 31},
  [11826] = {.lex_state = 347},
  [11827] = {.lex_state = 347, .external_lex_state = 31},
  [11828] = {.lex_state = 347},
  [11829] = {.lex_state = 347, .external_lex_state = 36},
  [11830] = {.lex_state = 347, .external_lex_state = 36},
  [11831] = {.lex_state = 347},
  [11832] = {.lex_state = 347, .external_lex_state = 31},
  [11833] = {.lex_state = 347, .external_lex_state = 42},
  [11834] = {.lex_state = 347, .external_lex_state = 42},
  [11835] = {.lex_state = 347},
  [11836] = {.lex_state = 347, .external_lex_state = 42},
  [11837] = {.lex_state = 347, .external_lex_state = 42},
  [11838] = {.lex_state = 347},
  [11839] = {.lex_state = 347, .external_lex_state = 31},
  [11840] = {.lex_state = 347, .external_lex_state = 31},
  [11841] = {.lex_state = 347, .external_lex_state = 31},
  [11842] = {.lex_state = 347},
  [11843] = {.lex_state = 347},
  [11844] = {.lex_state = 166},
  [11845] = {.lex_state = 347},
  [11846] = {.lex_state = 347, .external_lex_state = 31},
  [11847] = {.lex_state = 347, .external_lex_state = 42},
  [11848] = {.lex_state = 347, .external_lex_state = 36},
  [11849] = {.lex_state = 133},
  [11850] = {.lex_state = 347},
  [11851] = {.lex_state = 347, .external_lex_state = 46},
  [11852] = {.lex_state = 347},
  [11853] = {.lex_state = 166},
  [11854] = {.lex_state = 347},
  [11855] = {.lex_state = 347},
  [11856] = {.lex_state = 347},
  [11857] = {.lex_state = 347},
  [11858] = {.lex_state = 347},
  [11859] = {.lex_state = 347},
  [11860] = {.lex_state = 347},
  [11861] = {.lex_state = 347, .external_lex_state = 31},
  [11862] = {.lex_state = 347},
  [11863] = {.lex_state = 347, .external_lex_state = 42},
  [11864] = {.lex_state = 347, .external_lex_state = 42},
  [11865] = {.lex_state = 347},
  [11866] = {.lex_state = 347, .external_lex_state = 42},
  [11867] = {.lex_state = 347, .external_lex_state = 42},
  [11868] = {.lex_state = 166},
  [11869] = {.lex_state = 347},
  [11870] = {.lex_state = 1},
  [11871] = {.lex_state = 347},
  [11872] = {.lex_state = 347},
  [11873] = {.lex_state = 133},
  [11874] = {.lex_state = 347, .external_lex_state = 42},
  [11875] = {.lex_state = 347},
  [11876] = {.lex_state = 347},
  [11877] = {.lex_state = 347},
  [11878] = {.lex_state = 166},
  [11879] = {.lex_state = 347},
  [11880] = {.lex_state = 347},
  [11881] = {.lex_state = 347},
  [11882] = {.lex_state = 347},
  [11883] = {.lex_state = 347, .external_lex_state = 42},
  [11884] = {.lex_state = 347, .external_lex_state = 42},
  [11885] = {.lex_state = 347},
  [11886] = {.lex_state = 347, .external_lex_state = 42},
  [11887] = {.lex_state = 347, .external_lex_state = 42},
  [11888] = {.lex_state = 347, .external_lex_state = 31},
  [11889] = {.lex_state = 1},
  [11890] = {.lex_state = 1},
  [11891] = {.lex_state = 347},
  [11892] = {.lex_state = 347},
  [11893] = {.lex_state = 347, .external_lex_state = 44},
  [11894] = {.lex_state = 347, .external_lex_state = 42},
  [11895] = {.lex_state = 347},
  [11896] = {.lex_state = 347},
  [11897] = {.lex_state = 347},
  [11898] = {.lex_state = 347, .external_lex_state = 31},
  [11899] = {.lex_state = 347},
  [11900] = {.lex_state = 347},
  [11901] = {.lex_state = 347},
  [11902] = {.lex_state = 347},
  [11903] = {.lex_state = 347, .external_lex_state = 42},
  [11904] = {.lex_state = 347, .external_lex_state = 42},
  [11905] = {.lex_state = 347},
  [11906] = {.lex_state = 347, .external_lex_state = 42},
  [11907] = {.lex_state = 347, .external_lex_state = 42},
  [11908] = {.lex_state = 347},
  [11909] = {.lex_state = 347},
  [11910] = {.lex_state = 347, .external_lex_state = 31},
  [11911] = {.lex_state = 347},
  [11912] = {.lex_state = 347},
  [11913] = {.lex_state = 347, .external_lex_state = 42},
  [11914] = {.lex_state = 347, .external_lex_state = 42},
  [11915] = {.lex_state = 347},
  [11916] = {.lex_state = 347, .external_lex_state = 42},
  [11917] = {.lex_state = 347, .external_lex_state = 42},
  [11918] = {.lex_state = 347},
  [11919] = {.lex_state = 347},
  [11920] = {.lex_state = 347},
  [11921] = {.lex_state = 347},
  [11922] = {.lex_state = 347},
  [11923] = {.lex_state = 347, .external_lex_state = 42},
  [11924] = {.lex_state = 347, .external_lex_state = 42},
  [11925] = {.lex_state = 347, .external_lex_state = 46},
  [11926] = {.lex_state = 347, .external_lex_state = 42},
  [11927] = {.lex_state = 347, .external_lex_state = 42},
  [11928] = {.lex_state = 347},
  [11929] = {.lex_state = 347, .external_lex_state = 42},
  [11930] = {.lex_state = 347, .external_lex_state = 31},
  [11931] = {.lex_state = 347},
  [11932] = {.lex_state = 347},
  [11933] = {.lex_state = 347, .external_lex_state = 42},
  [11934] = {.lex_state = 347, .external_lex_state = 42},
  [11935] = {.lex_state = 347, .external_lex_state = 46},
  [11936] = {.lex_state = 347, .external_lex_state = 42},
  [11937] = {.lex_state = 347, .external_lex_state = 42},
  [11938] = {.lex_state = 347, .external_lex_state = 36},
  [11939] = {.lex_state = 347, .external_lex_state = 31},
  [11940] = {.lex_state = 347, .external_lex_state = 31},
  [11941] = {.lex_state = 347},
  [11942] = {.lex_state = 347},
  [11943] = {.lex_state = 347, .external_lex_state = 42},
  [11944] = {.lex_state = 347, .external_lex_state = 42},
  [11945] = {.lex_state = 347},
  [11946] = {.lex_state = 347, .external_lex_state = 42},
  [11947] = {.lex_state = 347, .external_lex_state = 42},
  [11948] = {.lex_state = 347, .external_lex_state = 46},
  [11949] = {.lex_state = 347, .external_lex_state = 46},
  [11950] = {.lex_state = 347, .external_lex_state = 42},
  [11951] = {.lex_state = 347, .external_lex_state = 42},
  [11952] = {.lex_state = 347, .external_lex_state = 31},
  [11953] = {.lex_state = 347, .external_lex_state = 42},
  [11954] = {.lex_state = 347, .external_lex_state = 42},
  [11955] = {.lex_state = 347, .external_lex_state = 31},
  [11956] = {.lex_state = 347},
  [11957] = {.lex_state = 347, .external_lex_state = 42},
  [11958] = {.lex_state = 347, .external_lex_state = 42},
  [11959] = {.lex_state = 347, .external_lex_state = 36},
  [11960] = {.lex_state = 347, .external_lex_state = 42},
  [11961] = {.lex_state = 347, .external_lex_state = 42},
  [11962] = {.lex_state = 347, .external_lex_state = 46},
  [11963] = {.lex_state = 347, .external_lex_state = 31},
  [11964] = {.lex_state = 347, .external_lex_state = 42},
  [11965] = {.lex_state = 347, .external_lex_state = 42},
  [11966] = {.lex_state = 1},
  [11967] = {.lex_state = 347, .external_lex_state = 42},
  [11968] = {.lex_state = 347, .external_lex_state = 42},
  [11969] = {.lex_state = 347},
  [11970] = {.lex_state = 347, .external_lex_state = 36},
  [11971] = {.lex_state = 347, .external_lex_state = 42},
  [11972] = {.lex_state = 347, .external_lex_state = 42},
  [11973] = {.lex_state = 347, .external_lex_state = 40},
  [11974] = {.lex_state = 347, .external_lex_state = 42},
  [11975] = {.lex_state = 347, .external_lex_state = 42},
  [11976] = {.lex_state = 347, .external_lex_state = 31},
  [11977] = {.lex_state = 347},
  [11978] = {.lex_state = 347, .external_lex_state = 42},
  [11979] = {.lex_state = 347, .external_lex_state = 42},
  [11980] = {.lex_state = 166},
  [11981] = {.lex_state = 347, .external_lex_state = 42},
  [11982] = {.lex_state = 347, .external_lex_state = 42},
  [11983] = {.lex_state = 347, .external_lex_state = 36},
  [11984] = {.lex_state = 347, .external_lex_state = 47},
  [11985] = {.lex_state = 347, .external_lex_state = 42},
  [11986] = {.lex_state = 347, .external_lex_state = 42},
  [11987] = {.lex_state = 347, .external_lex_state = 36},
  [11988] = {.lex_state = 347, .external_lex_state = 42},
  [11989] = {.lex_state = 347, .external_lex_state = 42},
  [11990] = {.lex_state = 347},
  [11991] = {.lex_state = 347, .external_lex_state = 31},
  [11992] = {.lex_state = 347, .external_lex_state = 42},
  [11993] = {.lex_state = 347, .external_lex_state = 42},
  [11994] = {.lex_state = 347, .external_lex_state = 44},
  [11995] = {.lex_state = 347, .external_lex_state = 42},
  [11996] = {.lex_state = 347, .external_lex_state = 42},
  [11997] = {.lex_state = 347},
  [11998] = {.lex_state = 347},
  [11999] = {.lex_state = 347, .external_lex_state = 42},
  [12000] = {.lex_state = 347},
  [12001] = {.lex_state = 347, .external_lex_state = 42},
  [12002] = {.lex_state = 347, .external_lex_state = 31},
  [12003] = {.lex_state = 347, .external_lex_state = 42},
  [12004] = {.lex_state = 347, .external_lex_state = 31},
  [12005] = {.lex_state = 347, .external_lex_state = 42},
  [12006] = {.lex_state = 347, .external_lex_state = 42},
  [12007] = {.lex_state = 347, .external_lex_state = 42},
  [12008] = {.lex_state = 347, .external_lex_state = 42},
  [12009] = {.lex_state = 347, .external_lex_state = 42},
  [12010] = {.lex_state = 347, .external_lex_state = 42},
  [12011] = {.lex_state = 347, .external_lex_state = 42},
  [12012] = {.lex_state = 347, .external_lex_state = 42},
  [12013] = {.lex_state = 347, .external_lex_state = 42},
  [12014] = {.lex_state = 347, .external_lex_state = 42},
  [12015] = {.lex_state = 347, .external_lex_state = 42},
  [12016] = {.lex_state = 347, .external_lex_state = 42},
  [12017] = {.lex_state = 347, .external_lex_state = 42},
  [12018] = {.lex_state = 347, .external_lex_state = 42},
  [12019] = {.lex_state = 347, .external_lex_state = 42},
  [12020] = {.lex_state = 347, .external_lex_state = 42},
  [12021] = {.lex_state = 347, .external_lex_state = 42},
  [12022] = {.lex_state = 347, .external_lex_state = 42},
  [12023] = {.lex_state = 347, .external_lex_state = 42},
  [12024] = {.lex_state = 347, .external_lex_state = 42},
  [12025] = {.lex_state = 347, .external_lex_state = 42},
  [12026] = {.lex_state = 347, .external_lex_state = 42},
  [12027] = {.lex_state = 347, .external_lex_state = 42},
  [12028] = {.lex_state = 347, .external_lex_state = 42},
  [12029] = {.lex_state = 347, .external_lex_state = 42},
  [12030] = {.lex_state = 347, .external_lex_state = 42},
  [12031] = {.lex_state = 347, .external_lex_state = 42},
  [12032] = {.lex_state = 347, .external_lex_state = 42},
  [12033] = {.lex_state = 347, .external_lex_state = 42},
  [12034] = {.lex_state = 347, .external_lex_state = 42},
  [12035] = {.lex_state = 347, .external_lex_state = 42},
  [12036] = {.lex_state = 347, .external_lex_state = 42},
  [12037] = {.lex_state = 347, .external_lex_state = 42},
  [12038] = {.lex_state = 347, .external_lex_state = 42},
  [12039] = {.lex_state = 347, .external_lex_state = 42},
  [12040] = {.lex_state = 347, .external_lex_state = 42},
  [12041] = {.lex_state = 347, .external_lex_state = 42},
  [12042] = {.lex_state = 347, .external_lex_state = 42},
  [12043] = {.lex_state = 347, .external_lex_state = 42},
  [12044] = {.lex_state = 347, .external_lex_state = 31},
  [12045] = {.lex_state = 347},
  [12046] = {.lex_state = 166},
  [12047] = {.lex_state = 347, .external_lex_state = 31},
  [12048] = {.lex_state = 347, .external_lex_state = 36},
  [12049] = {.lex_state = 133},
  [12050] = {.lex_state = 347},
  [12051] = {.lex_state = 347, .external_lex_state = 46},
  [12052] = {.lex_state = 347},
  [12053] = {.lex_state = 166},
  [12054] = {.lex_state = 347},
  [12055] = {.lex_state = 347},
  [12056] = {.lex_state = 347},
  [12057] = {.lex_state = 347, .external_lex_state = 42},
  [12058] = {.lex_state = 347, .external_lex_state = 42},
  [12059] = {.lex_state = 347},
  [12060] = {.lex_state = 347},
  [12061] = {.lex_state = 347},
  [12062] = {.lex_state = 347},
  [12063] = {.lex_state = 347, .external_lex_state = 42},
  [12064] = {.lex_state = 347, .external_lex_state = 42},
  [12065] = {.lex_state = 347},
  [12066] = {.lex_state = 347},
  [12067] = {.lex_state = 347},
  [12068] = {.lex_state = 347, .external_lex_state = 45},
  [12069] = {.lex_state = 347, .external_lex_state = 42},
  [12070] = {.lex_state = 347, .external_lex_state = 42},
  [12071] = {.lex_state = 347},
  [12072] = {.lex_state = 347},
  [12073] = {.lex_state = 347, .external_lex_state = 45},
  [12074] = {.lex_state = 347},
  [12075] = {.lex_state = 347},
  [12076] = {.lex_state = 347},
  [12077] = {.lex_state = 347},
  [12078] = {.lex_state = 347},
  [12079] = {.lex_state = 347},
  [12080] = {.lex_state = 347},
  [12081] = {.lex_state = 347, .external_lex_state = 31},
  [12082] = {.lex_state = 347, .external_lex_state = 42},
  [12083] = {.lex_state = 347},
  [12084] = {.lex_state = 347},
  [12085] = {.lex_state = 347, .external_lex_state = 31},
  [12086] = {.lex_state = 347},
  [12087] = {.lex_state = 347},
  [12088] = {.lex_state = 347},
  [12089] = {.lex_state = 347, .external_lex_state = 42},
  [12090] = {.lex_state = 166},
  [12091] = {.lex_state = 347},
  [12092] = {.lex_state = 347},
  [12093] = {.lex_state = 347, .external_lex_state = 42},
  [12094] = {.lex_state = 347, .external_lex_state = 42},
  [12095] = {.lex_state = 133},
  [12096] = {.lex_state = 347},
  [12097] = {.lex_state = 347},
  [12098] = {.lex_state = 166},
  [12099] = {.lex_state = 347},
  [12100] = {.lex_state = 347},
  [12101] = {.lex_state = 347},
  [12102] = {.lex_state = 1},
  [12103] = {.lex_state = 347, .external_lex_state = 36},
  [12104] = {.lex_state = 347, .external_lex_state = 36},
  [12105] = {.lex_state = 133},
  [12106] = {.lex_state = 347, .external_lex_state = 36},
  [12107] = {.lex_state = 347, .external_lex_state = 40},
  [12108] = {.lex_state = 347, .external_lex_state = 36},
  [12109] = {.lex_state = 347, .external_lex_state = 36},
  [12110] = {.lex_state = 347, .external_lex_state = 36},
  [12111] = {.lex_state = 347, .external_lex_state = 30},
  [12112] = {.lex_state = 347, .external_lex_state = 36},
  [12113] = {.lex_state = 347, .external_lex_state = 36},
  [12114] = {.lex_state = 347, .external_lex_state = 36},
  [12115] = {.lex_state = 347, .external_lex_state = 36},
  [12116] = {.lex_state = 347, .external_lex_state = 36},
  [12117] = {.lex_state = 347, .external_lex_state = 36},
  [12118] = {.lex_state = 347, .external_lex_state = 36},
  [12119] = {(TSStateId)(-1)},
  [12120] = {(TSStateId)(-1)},
  [12121] = {(TSStateId)(-1)},
  [12122] = {(TSStateId)(-1)},
  [12123] = {(TSStateId)(-1)},
  [12124] = {(TSStateId)(-1)},
  [12125] = {(TSStateId)(-1)},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_block_comment] = STATE(0),
    [sym_compiler_directive_decl] = STATE(0),
    [sym_fsi_directive_decl] = STATE(0),
    [sym_preproc_line] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_rec] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_open] = ACTIONS(1),
    [anon_sym_LBRACK_LT] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_assembly] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_field] = ACTIONS(1),
    [anon_sym_property] = ACTIONS(1),
    [anon_sym_param] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_constructor] = ACTIONS(1),
    [anon_sym_event] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_let_BANG] = ACTIONS(1),
    [anon_sym_inline] = ACTIONS(1),
    [anon_sym_mutable] = ACTIONS(1),
    [aux_sym_access_modifier_token1] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_null] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_COLON_QMARK] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_LT_AT] = ACTIONS(1),
    [anon_sym_AT_GT] = ACTIONS(1),
    [anon_sym_LT_AT_AT] = ACTIONS(1),
    [anon_sym_AT_AT_GT] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_return_BANG] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_yield_BANG] = ACTIONS(1),
    [anon_sym_lazy] = ACTIONS(1),
    [anon_sym_assert] = ACTIONS(1),
    [anon_sym_upcast] = ACTIONS(1),
    [anon_sym_downcast] = ACTIONS(1),
    [anon_sym_COLON_GT] = ACTIONS(1),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_to] = ACTIONS(1),
    [anon_sym_downto] = ACTIONS(1),
    [anon_sym_done] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_elif] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_fun] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_match] = ACTIONS(1),
    [anon_sym_match_BANG] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_LT_DASH] = ACTIONS(1),
    [anon_sym_DOT_LBRACK] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_use] = ACTIONS(1),
    [anon_sym_use_BANG] = ACTIONS(1),
    [anon_sym_do_BANG] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_when] = ACTIONS(1),
    [anon_sym_begin] = ACTIONS(1),
    [anon_sym_end] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_DOT_DOT2] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_LT2] = ACTIONS(1),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_unit] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_unmanaged] = ACTIONS(1),
    [anon_sym_equality] = ACTIONS(1),
    [anon_sym_comparison] = ACTIONS(1),
    [anon_sym_delegate] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_member] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_id] = ACTIONS(1),
    [anon_sym_exception] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_val] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_inherit] = ACTIONS(1),
    [anon_sym_EQ2] = ACTIONS(1),
    [sym__unicodegraph_short] = ACTIONS(1),
    [sym__unicodegraph_long] = ACTIONS(1),
    [sym__trigraph] = ACTIONS(1),
    [aux_sym_char_token1] = ACTIONS(1),
    [anon_sym_LBRACE2] = ACTIONS(1),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_AT_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE2] = ACTIONS(1),
    [anon_sym_DQUOTEB] = ACTIONS(1),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1),
    [sym_bool] = ACTIONS(1),
    [sym_unit] = ACTIONS(1),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RPAREN] = ACTIONS(1),
    [sym_op_identifier] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PLUS_DOT] = ACTIONS(1),
    [anon_sym_DASH_DOT] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [aux_sym_prefix_op_token1] = ACTIONS(1),
    [aux_sym_infix_op_token1] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(1),
    [sym_int] = ACTIONS(1),
    [sym_xint] = ACTIONS(1),
    [anon_sym_y] = ACTIONS(1),
    [anon_sym_uy] = ACTIONS(1),
    [anon_sym_s] = ACTIONS(1),
    [anon_sym_us] = ACTIONS(1),
    [anon_sym_l] = ACTIONS(1),
    [aux_sym_uint32_token1] = ACTIONS(1),
    [anon_sym_n] = ACTIONS(1),
    [anon_sym_un] = ACTIONS(1),
    [anon_sym_L] = ACTIONS(1),
    [aux_sym_uint64_token1] = ACTIONS(1),
    [anon_sym_f] = ACTIONS(1),
    [anon_sym_lf] = ACTIONS(1),
    [anon_sym_LF] = ACTIONS(1),
    [aux_sym_bignum_token1] = ACTIONS(1),
    [aux_sym_decimal_token1] = ACTIONS(1),
    [anon_sym_DOT2] = ACTIONS(1),
    [aux_sym_float_token1] = ACTIONS(1),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [anon_sym_STAR_RPAREN] = ACTIONS(1),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1),
    [sym__newline] = ACTIONS(1),
    [sym__indent] = ACTIONS(1),
    [sym__dedent] = ACTIONS(1),
    [sym__struct_begin] = ACTIONS(1),
    [sym__interface_begin] = ACTIONS(1),
    [sym__triple_quoted_content] = ACTIONS(1),
    [sym_block_comment_content] = ACTIONS(1),
    [sym__inside_string_marker] = ACTIONS(1),
    [sym__newline_not_aligned] = ACTIONS(1),
    [sym__tuple_marker] = ACTIONS(1),
    [sym__error_sentinel] = ACTIONS(1),
  },
  [1] = {
    [sym_file] = STATE(12055),
    [sym_namespace] = STATE(9811),
    [sym_named_module] = STATE(12052),
    [sym_module_abbrev] = STATE(4154),
    [sym_module_defn] = STATE(4154),
    [sym_import_decl] = STATE(4154),
    [sym_attributes] = STATE(8358),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(4154),
    [sym_do] = STATE(4155),
    [sym_function_or_value_defn] = STATE(594),
    [sym__expression] = STATE(120),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_exception_definition] = STATE(4154),
    [sym_type_definition] = STATE(4154),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(793),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(1),
    [sym_compiler_directive_decl] = STATE(1),
    [sym_fsi_directive_decl] = STATE(1),
    [sym_preproc_line] = STATE(1),
    [sym_preproc_if] = STATE(4154),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_file_repeat1] = STATE(8912),
    [aux_sym_file_repeat2] = STATE(551),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(17),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_open] = ACTIONS(25),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_type] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_let_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(53),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(29),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_upcast] = ACTIONS(29),
    [anon_sym_downcast] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_exception] = ACTIONS(83),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(99),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(111),
    [sym_xint] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(115),
    [anon_sym_POUNDload] = ACTIONS(115),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(117),
  },
  [2] = {
    [sym_function_or_value_defn] = STATE(850),
    [sym__expression] = STATE(3),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(949),
    [sym_infix_op] = STATE(871),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(2),
    [sym_compiler_directive_decl] = STATE(2),
    [sym_fsi_directive_decl] = STATE(2),
    [sym_preproc_line] = STATE(2),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_sequential_expression_repeat1] = STATE(1281),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(119),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_namespace] = ACTIONS(123),
    [anon_sym_module] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_LBRACK_LT] = ACTIONS(119),
    [anon_sym_COLON] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_type] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_and] = ACTIONS(123),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(119),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(139),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(127),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(149),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(153),
    [anon_sym_DOT] = ACTIONS(155),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(129),
    [anon_sym_with] = ACTIONS(123),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(129),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(129),
    [anon_sym_assert] = ACTIONS(129),
    [anon_sym_upcast] = ACTIONS(129),
    [anon_sym_downcast] = ACTIONS(129),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_default] = ACTIONS(123),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(123),
    [anon_sym_member] = ACTIONS(123),
    [anon_sym_interface] = ACTIONS(123),
    [anon_sym_exception] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(123),
    [anon_sym_val] = ACTIONS(123),
    [anon_sym_override] = ACTIONS(123),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(207),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(215),
    [sym_xint] = ACTIONS(217),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(119),
    [anon_sym_POUNDload] = ACTIONS(119),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
    [sym__newline] = ACTIONS(119),
  },
  [3] = {
    [sym_function_or_value_defn] = STATE(850),
    [sym__expression] = STATE(3),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(949),
    [sym_infix_op] = STATE(871),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(3),
    [sym_compiler_directive_decl] = STATE(3),
    [sym_fsi_directive_decl] = STATE(3),
    [sym_preproc_line] = STATE(3),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_sequential_expression_repeat1] = STATE(1281),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(223),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(225),
    [anon_sym_module] = ACTIONS(225),
    [anon_sym_EQ] = ACTIONS(223),
    [anon_sym_open] = ACTIONS(225),
    [anon_sym_LBRACK_LT] = ACTIONS(223),
    [anon_sym_COLON] = ACTIONS(225),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_type] = ACTIONS(225),
    [anon_sym_do] = ACTIONS(225),
    [anon_sym_and] = ACTIONS(225),
    [anon_sym_let] = ACTIONS(225),
    [anon_sym_let_BANG] = ACTIONS(223),
    [aux_sym_access_modifier_token1] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_COMMA] = ACTIONS(223),
    [anon_sym_null] = ACTIONS(225),
    [anon_sym_QMARK] = ACTIONS(225),
    [anon_sym_COLON_QMARK] = ACTIONS(225),
    [anon_sym_COLON_COLON] = ACTIONS(223),
    [anon_sym_AMP] = ACTIONS(225),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LBRACK_PIPE] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(225),
    [anon_sym_LT_AT] = ACTIONS(225),
    [anon_sym_LT_AT_AT] = ACTIONS(225),
    [anon_sym_DOT] = ACTIONS(155),
    [anon_sym_LBRACE_PIPE] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(225),
    [anon_sym_with] = ACTIONS(225),
    [anon_sym_return_BANG] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(225),
    [anon_sym_yield_BANG] = ACTIONS(223),
    [anon_sym_lazy] = ACTIONS(225),
    [anon_sym_assert] = ACTIONS(225),
    [anon_sym_upcast] = ACTIONS(225),
    [anon_sym_downcast] = ACTIONS(225),
    [anon_sym_COLON_GT] = ACTIONS(223),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(223),
    [anon_sym_for] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_fun] = ACTIONS(225),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_match] = ACTIONS(225),
    [anon_sym_match_BANG] = ACTIONS(223),
    [anon_sym_function] = ACTIONS(225),
    [anon_sym_LT_DASH] = ACTIONS(225),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(225),
    [anon_sym_use_BANG] = ACTIONS(223),
    [anon_sym_do_BANG] = ACTIONS(223),
    [anon_sym_begin] = ACTIONS(225),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_or] = ACTIONS(225),
    [anon_sym_static] = ACTIONS(225),
    [anon_sym_member] = ACTIONS(225),
    [anon_sym_interface] = ACTIONS(225),
    [anon_sym_exception] = ACTIONS(225),
    [anon_sym_abstract] = ACTIONS(225),
    [anon_sym_val] = ACTIONS(225),
    [anon_sym_override] = ACTIONS(225),
    [aux_sym_char_token1] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_AT_DQUOTE] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [sym_bool] = ACTIONS(225),
    [sym_unit] = ACTIONS(207),
    [anon_sym_LPAREN_PIPE] = ACTIONS(225),
    [sym_op_identifier] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(225),
    [anon_sym_DASH] = ACTIONS(225),
    [anon_sym_PLUS_DOT] = ACTIONS(225),
    [anon_sym_DASH_DOT] = ACTIONS(225),
    [anon_sym_PERCENT] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_TILDE] = ACTIONS(223),
    [aux_sym_prefix_op_token1] = ACTIONS(225),
    [aux_sym_infix_op_token1] = ACTIONS(223),
    [aux_sym_infix_op_token2] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_BANG_EQ] = ACTIONS(225),
    [anon_sym_COLON_EQ] = ACTIONS(223),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(225),
    [sym_int] = ACTIONS(225),
    [sym_xint] = ACTIONS(223),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(223),
    [anon_sym_POUNDload] = ACTIONS(223),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(223),
    [sym__newline] = ACTIONS(223),
  },
  [4] = {
    [sym_function_or_value_defn] = STATE(850),
    [sym__expression] = STATE(3),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(949),
    [sym_infix_op] = STATE(871),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(4),
    [sym_compiler_directive_decl] = STATE(4),
    [sym_fsi_directive_decl] = STATE(4),
    [sym_preproc_line] = STATE(4),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_sequential_expression_repeat1] = STATE(1281),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(227),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_module] = ACTIONS(229),
    [anon_sym_EQ] = ACTIONS(227),
    [anon_sym_open] = ACTIONS(229),
    [anon_sym_LBRACK_LT] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(229),
    [anon_sym_return] = ACTIONS(229),
    [anon_sym_type] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_and] = ACTIONS(229),
    [anon_sym_let] = ACTIONS(229),
    [anon_sym_let_BANG] = ACTIONS(227),
    [aux_sym_access_modifier_token1] = ACTIONS(227),
    [anon_sym_LPAREN] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(227),
    [anon_sym_null] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_COLON_QMARK] = ACTIONS(229),
    [anon_sym_COLON_COLON] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_LBRACK] = ACTIONS(229),
    [anon_sym_LBRACK_PIPE] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(229),
    [anon_sym_LT_AT] = ACTIONS(229),
    [anon_sym_LT_AT_AT] = ACTIONS(229),
    [anon_sym_DOT] = ACTIONS(155),
    [anon_sym_LBRACE_PIPE] = ACTIONS(227),
    [anon_sym_new] = ACTIONS(229),
    [anon_sym_with] = ACTIONS(229),
    [anon_sym_return_BANG] = ACTIONS(227),
    [anon_sym_yield] = ACTIONS(229),
    [anon_sym_yield_BANG] = ACTIONS(227),
    [anon_sym_lazy] = ACTIONS(229),
    [anon_sym_assert] = ACTIONS(229),
    [anon_sym_upcast] = ACTIONS(229),
    [anon_sym_downcast] = ACTIONS(229),
    [anon_sym_COLON_GT] = ACTIONS(227),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_fun] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(229),
    [anon_sym_match_BANG] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(229),
    [anon_sym_LT_DASH] = ACTIONS(229),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(229),
    [anon_sym_use_BANG] = ACTIONS(227),
    [anon_sym_do_BANG] = ACTIONS(227),
    [anon_sym_begin] = ACTIONS(229),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_default] = ACTIONS(229),
    [anon_sym_or] = ACTIONS(229),
    [anon_sym_static] = ACTIONS(229),
    [anon_sym_member] = ACTIONS(229),
    [anon_sym_interface] = ACTIONS(229),
    [anon_sym_exception] = ACTIONS(229),
    [anon_sym_abstract] = ACTIONS(229),
    [anon_sym_val] = ACTIONS(229),
    [anon_sym_override] = ACTIONS(229),
    [aux_sym_char_token1] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_AT_DQUOTE] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [sym_bool] = ACTIONS(229),
    [sym_unit] = ACTIONS(207),
    [anon_sym_LPAREN_PIPE] = ACTIONS(229),
    [sym_op_identifier] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(229),
    [anon_sym_PLUS_DOT] = ACTIONS(229),
    [anon_sym_DASH_DOT] = ACTIONS(229),
    [anon_sym_PERCENT] = ACTIONS(229),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(227),
    [aux_sym_prefix_op_token1] = ACTIONS(229),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token2] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(229),
    [anon_sym_BANG_EQ] = ACTIONS(229),
    [anon_sym_COLON_EQ] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(229),
    [sym_int] = ACTIONS(229),
    [sym_xint] = ACTIONS(227),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(227),
    [anon_sym_POUNDload] = ACTIONS(227),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(227),
    [sym__newline] = ACTIONS(227),
  },
  [5] = {
    [sym_function_or_value_defn] = STATE(850),
    [sym__expression] = STATE(3),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(949),
    [sym_infix_op] = STATE(871),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(5),
    [sym_compiler_directive_decl] = STATE(5),
    [sym_fsi_directive_decl] = STATE(5),
    [sym_preproc_line] = STATE(5),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_sequential_expression_repeat1] = STATE(1281),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(231),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_namespace] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(233),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(233),
    [anon_sym_LBRACK_LT] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_type] = ACTIONS(233),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_and] = ACTIONS(233),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(139),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(127),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(149),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(153),
    [anon_sym_DOT] = ACTIONS(155),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(129),
    [anon_sym_with] = ACTIONS(233),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(129),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(129),
    [anon_sym_assert] = ACTIONS(129),
    [anon_sym_upcast] = ACTIONS(129),
    [anon_sym_downcast] = ACTIONS(129),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_default] = ACTIONS(233),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(233),
    [anon_sym_member] = ACTIONS(233),
    [anon_sym_interface] = ACTIONS(233),
    [anon_sym_exception] = ACTIONS(233),
    [anon_sym_abstract] = ACTIONS(233),
    [anon_sym_val] = ACTIONS(233),
    [anon_sym_override] = ACTIONS(233),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(207),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(215),
    [sym_xint] = ACTIONS(217),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(231),
    [anon_sym_POUNDload] = ACTIONS(231),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
    [sym__newline] = ACTIONS(235),
  },
  [6] = {
    [sym_function_or_value_defn] = STATE(850),
    [sym__expression] = STATE(3),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(949),
    [sym_infix_op] = STATE(871),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(6),
    [sym_compiler_directive_decl] = STATE(6),
    [sym_fsi_directive_decl] = STATE(6),
    [sym_preproc_line] = STATE(6),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_sequential_expression_repeat1] = STATE(1281),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(237),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_module] = ACTIONS(239),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(239),
    [anon_sym_LBRACK_LT] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_type] = ACTIONS(239),
    [anon_sym_do] = ACTIONS(239),
    [anon_sym_and] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(239),
    [anon_sym_let_BANG] = ACTIONS(237),
    [aux_sym_access_modifier_token1] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(139),
    [anon_sym_null] = ACTIONS(239),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(127),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_LBRACK_PIPE] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LT_AT] = ACTIONS(239),
    [anon_sym_LT_AT_AT] = ACTIONS(239),
    [anon_sym_DOT] = ACTIONS(155),
    [anon_sym_LBRACE_PIPE] = ACTIONS(237),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_with] = ACTIONS(241),
    [anon_sym_return_BANG] = ACTIONS(237),
    [anon_sym_yield] = ACTIONS(239),
    [anon_sym_yield_BANG] = ACTIONS(237),
    [anon_sym_lazy] = ACTIONS(239),
    [anon_sym_assert] = ACTIONS(239),
    [anon_sym_upcast] = ACTIONS(239),
    [anon_sym_downcast] = ACTIONS(239),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(239),
    [anon_sym_while] = ACTIONS(239),
    [anon_sym_if] = ACTIONS(239),
    [anon_sym_fun] = ACTIONS(239),
    [anon_sym_try] = ACTIONS(239),
    [anon_sym_match] = ACTIONS(239),
    [anon_sym_match_BANG] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(239),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(237),
    [anon_sym_do_BANG] = ACTIONS(237),
    [anon_sym_begin] = ACTIONS(239),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_default] = ACTIONS(239),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(239),
    [anon_sym_member] = ACTIONS(239),
    [anon_sym_interface] = ACTIONS(239),
    [anon_sym_exception] = ACTIONS(239),
    [anon_sym_abstract] = ACTIONS(239),
    [anon_sym_val] = ACTIONS(239),
    [anon_sym_override] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [anon_sym_AT_DQUOTE] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [sym_bool] = ACTIONS(239),
    [sym_unit] = ACTIONS(237),
    [anon_sym_LPAREN_PIPE] = ACTIONS(239),
    [sym_op_identifier] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_PLUS_DOT] = ACTIONS(239),
    [anon_sym_DASH_DOT] = ACTIONS(239),
    [anon_sym_PERCENT] = ACTIONS(239),
    [anon_sym_AMP_AMP] = ACTIONS(239),
    [anon_sym_TILDE] = ACTIONS(237),
    [aux_sym_prefix_op_token1] = ACTIONS(239),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(239),
    [sym_xint] = ACTIONS(237),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(237),
    [anon_sym_POUNDload] = ACTIONS(237),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(237),
    [sym__newline] = ACTIONS(235),
  },
  [7] = {
    [sym_function_or_value_defn] = STATE(850),
    [sym__expression] = STATE(3),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(949),
    [sym_infix_op] = STATE(871),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(7),
    [sym_compiler_directive_decl] = STATE(7),
    [sym_fsi_directive_decl] = STATE(7),
    [sym_preproc_line] = STATE(7),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_sequential_expression_repeat1] = STATE(1281),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(243),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_namespace] = ACTIONS(245),
    [anon_sym_module] = ACTIONS(245),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(245),
    [anon_sym_LBRACK_LT] = ACTIONS(243),
    [anon_sym_COLON] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_type] = ACTIONS(245),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_and] = ACTIONS(245),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(139),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(127),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(153),
    [anon_sym_DOT] = ACTIONS(155),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(129),
    [anon_sym_with] = ACTIONS(245),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(129),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(129),
    [anon_sym_assert] = ACTIONS(129),
    [anon_sym_upcast] = ACTIONS(129),
    [anon_sym_downcast] = ACTIONS(129),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_default] = ACTIONS(245),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_member] = ACTIONS(245),
    [anon_sym_interface] = ACTIONS(245),
    [anon_sym_exception] = ACTIONS(245),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_val] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(207),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(215),
    [sym_xint] = ACTIONS(217),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(243),
    [anon_sym_POUNDload] = ACTIONS(243),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
    [sym__newline] = ACTIONS(243),
  },
  [8] = {
    [sym_function_or_value_defn] = STATE(850),
    [sym__expression] = STATE(3),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(949),
    [sym_infix_op] = STATE(871),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(8),
    [sym_compiler_directive_decl] = STATE(8),
    [sym_fsi_directive_decl] = STATE(8),
    [sym_preproc_line] = STATE(8),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_sequential_expression_repeat1] = STATE(1281),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(247),
    [sym_identifier] = ACTIONS(249),
    [anon_sym_namespace] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(249),
    [anon_sym_LBRACK_LT] = ACTIONS(247),
    [anon_sym_COLON] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(249),
    [anon_sym_type] = ACTIONS(249),
    [anon_sym_do] = ACTIONS(249),
    [anon_sym_and] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(249),
    [anon_sym_let_BANG] = ACTIONS(247),
    [aux_sym_access_modifier_token1] = ACTIONS(247),
    [anon_sym_LPAREN] = ACTIONS(249),
    [anon_sym_COMMA] = ACTIONS(139),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(127),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(249),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_LBRACK_PIPE] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_LT_AT] = ACTIONS(249),
    [anon_sym_LT_AT_AT] = ACTIONS(249),
    [anon_sym_DOT] = ACTIONS(155),
    [anon_sym_LBRACE_PIPE] = ACTIONS(247),
    [anon_sym_new] = ACTIONS(249),
    [anon_sym_with] = ACTIONS(251),
    [anon_sym_return_BANG] = ACTIONS(247),
    [anon_sym_yield] = ACTIONS(249),
    [anon_sym_yield_BANG] = ACTIONS(247),
    [anon_sym_lazy] = ACTIONS(249),
    [anon_sym_assert] = ACTIONS(249),
    [anon_sym_upcast] = ACTIONS(249),
    [anon_sym_downcast] = ACTIONS(249),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(249),
    [anon_sym_while] = ACTIONS(249),
    [anon_sym_if] = ACTIONS(249),
    [anon_sym_fun] = ACTIONS(249),
    [anon_sym_try] = ACTIONS(249),
    [anon_sym_match] = ACTIONS(249),
    [anon_sym_match_BANG] = ACTIONS(247),
    [anon_sym_function] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(249),
    [anon_sym_use_BANG] = ACTIONS(247),
    [anon_sym_do_BANG] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_default] = ACTIONS(249),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(249),
    [anon_sym_member] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(249),
    [anon_sym_exception] = ACTIONS(249),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_val] = ACTIONS(249),
    [anon_sym_override] = ACTIONS(249),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(249),
    [anon_sym_AT_DQUOTE] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(247),
    [sym_bool] = ACTIONS(249),
    [sym_unit] = ACTIONS(247),
    [anon_sym_LPAREN_PIPE] = ACTIONS(249),
    [sym_op_identifier] = ACTIONS(249),
    [anon_sym_PLUS] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_PLUS_DOT] = ACTIONS(249),
    [anon_sym_DASH_DOT] = ACTIONS(249),
    [anon_sym_PERCENT] = ACTIONS(249),
    [anon_sym_AMP_AMP] = ACTIONS(249),
    [anon_sym_TILDE] = ACTIONS(247),
    [aux_sym_prefix_op_token1] = ACTIONS(249),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(249),
    [sym_xint] = ACTIONS(247),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(247),
    [anon_sym_POUNDload] = ACTIONS(247),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(247),
    [sym__newline] = ACTIONS(235),
  },
  [9] = {
    [sym_function_or_value_defn] = STATE(850),
    [sym__expression] = STATE(3),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(949),
    [sym_infix_op] = STATE(871),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(9),
    [sym_compiler_directive_decl] = STATE(9),
    [sym_fsi_directive_decl] = STATE(9),
    [sym_preproc_line] = STATE(9),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_sequential_expression_repeat1] = STATE(1281),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(253),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_module] = ACTIONS(255),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(255),
    [anon_sym_LBRACK_LT] = ACTIONS(253),
    [anon_sym_COLON] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_type] = ACTIONS(255),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(139),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(127),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(255),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(153),
    [anon_sym_DOT] = ACTIONS(155),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(129),
    [anon_sym_with] = ACTIONS(255),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(129),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(129),
    [anon_sym_assert] = ACTIONS(129),
    [anon_sym_upcast] = ACTIONS(129),
    [anon_sym_downcast] = ACTIONS(129),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_default] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(255),
    [anon_sym_member] = ACTIONS(255),
    [anon_sym_interface] = ACTIONS(255),
    [anon_sym_exception] = ACTIONS(255),
    [anon_sym_abstract] = ACTIONS(255),
    [anon_sym_val] = ACTIONS(255),
    [anon_sym_override] = ACTIONS(255),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(207),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(215),
    [sym_xint] = ACTIONS(217),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(253),
    [anon_sym_POUNDload] = ACTIONS(253),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
    [sym__newline] = ACTIONS(253),
  },
  [10] = {
    [sym_function_or_value_defn] = STATE(850),
    [sym__expression] = STATE(3),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(949),
    [sym_infix_op] = STATE(871),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(10),
    [sym_compiler_directive_decl] = STATE(10),
    [sym_fsi_directive_decl] = STATE(10),
    [sym_preproc_line] = STATE(10),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_sequential_expression_repeat1] = STATE(1281),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(257),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_namespace] = ACTIONS(259),
    [anon_sym_module] = ACTIONS(259),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(259),
    [anon_sym_LBRACK_LT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_type] = ACTIONS(259),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_and] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(257),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(139),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(127),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(259),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(153),
    [anon_sym_DOT] = ACTIONS(155),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(129),
    [anon_sym_with] = ACTIONS(259),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(129),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(129),
    [anon_sym_assert] = ACTIONS(129),
    [anon_sym_upcast] = ACTIONS(129),
    [anon_sym_downcast] = ACTIONS(129),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_default] = ACTIONS(259),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(259),
    [anon_sym_member] = ACTIONS(259),
    [anon_sym_interface] = ACTIONS(259),
    [anon_sym_exception] = ACTIONS(259),
    [anon_sym_abstract] = ACTIONS(259),
    [anon_sym_val] = ACTIONS(259),
    [anon_sym_override] = ACTIONS(259),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(207),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(215),
    [sym_xint] = ACTIONS(217),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(257),
    [anon_sym_POUNDload] = ACTIONS(257),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
    [sym__newline] = ACTIONS(257),
  },
  [11] = {
    [sym_function_or_value_defn] = STATE(850),
    [sym__expression] = STATE(3),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(949),
    [sym_infix_op] = STATE(871),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(11),
    [sym_compiler_directive_decl] = STATE(11),
    [sym_fsi_directive_decl] = STATE(11),
    [sym_preproc_line] = STATE(11),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_sequential_expression_repeat1] = STATE(1281),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(261),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(263),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(263),
    [anon_sym_LBRACK_LT] = ACTIONS(261),
    [anon_sym_COLON] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_type] = ACTIONS(263),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_and] = ACTIONS(263),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(261),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(139),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(127),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(149),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(153),
    [anon_sym_DOT] = ACTIONS(155),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(129),
    [anon_sym_with] = ACTIONS(263),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(129),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(129),
    [anon_sym_assert] = ACTIONS(129),
    [anon_sym_upcast] = ACTIONS(129),
    [anon_sym_downcast] = ACTIONS(129),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_default] = ACTIONS(263),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(263),
    [anon_sym_member] = ACTIONS(263),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_exception] = ACTIONS(263),
    [anon_sym_abstract] = ACTIONS(263),
    [anon_sym_val] = ACTIONS(263),
    [anon_sym_override] = ACTIONS(263),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(207),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(215),
    [sym_xint] = ACTIONS(217),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(261),
    [anon_sym_POUNDload] = ACTIONS(261),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
    [sym__newline] = ACTIONS(235),
  },
  [12] = {
    [sym_function_or_value_defn] = STATE(850),
    [sym__expression] = STATE(3),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(949),
    [sym_infix_op] = STATE(871),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(12),
    [sym_compiler_directive_decl] = STATE(12),
    [sym_fsi_directive_decl] = STATE(12),
    [sym_preproc_line] = STATE(12),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_sequential_expression_repeat1] = STATE(1281),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(265),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_namespace] = ACTIONS(267),
    [anon_sym_module] = ACTIONS(267),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(267),
    [anon_sym_LBRACK_LT] = ACTIONS(265),
    [anon_sym_COLON] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_type] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_and] = ACTIONS(267),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(265),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(139),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(127),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(149),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(153),
    [anon_sym_DOT] = ACTIONS(155),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(129),
    [anon_sym_with] = ACTIONS(267),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(129),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(129),
    [anon_sym_assert] = ACTIONS(129),
    [anon_sym_upcast] = ACTIONS(129),
    [anon_sym_downcast] = ACTIONS(129),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(177),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_default] = ACTIONS(267),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(267),
    [anon_sym_member] = ACTIONS(267),
    [anon_sym_interface] = ACTIONS(267),
    [anon_sym_exception] = ACTIONS(267),
    [anon_sym_abstract] = ACTIONS(267),
    [anon_sym_val] = ACTIONS(267),
    [anon_sym_override] = ACTIONS(267),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(207),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(215),
    [sym_xint] = ACTIONS(217),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(265),
    [anon_sym_POUNDload] = ACTIONS(265),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
    [sym__newline] = ACTIONS(235),
  },
  [13] = {
    [sym_function_or_value_defn] = STATE(760),
    [sym__expression] = STATE(18),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(956),
    [sym_infix_op] = STATE(768),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(13),
    [sym_compiler_directive_decl] = STATE(13),
    [sym_fsi_directive_decl] = STATE(13),
    [sym_preproc_line] = STATE(13),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_sequential_expression_repeat1] = STATE(1352),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(119),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_module] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_LBRACK_LT] = ACTIONS(119),
    [anon_sym_COLON] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_and] = ACTIONS(123),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(119),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(127),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(149),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(153),
    [anon_sym_DOT] = ACTIONS(155),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(269),
    [anon_sym_with] = ACTIONS(123),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(269),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(269),
    [anon_sym_assert] = ACTIONS(269),
    [anon_sym_upcast] = ACTIONS(269),
    [anon_sym_downcast] = ACTIONS(269),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(275),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(277),
    [anon_sym_use_BANG] = ACTIONS(279),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_default] = ACTIONS(123),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(123),
    [anon_sym_member] = ACTIONS(123),
    [anon_sym_interface] = ACTIONS(123),
    [anon_sym_exception] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(123),
    [anon_sym_val] = ACTIONS(123),
    [anon_sym_override] = ACTIONS(123),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(207),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(281),
    [sym_xint] = ACTIONS(283),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(119),
    [anon_sym_POUNDload] = ACTIONS(119),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
    [sym__newline] = ACTIONS(119),
  },
  [14] = {
    [sym_function_or_value_defn] = STATE(760),
    [sym__expression] = STATE(18),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(956),
    [sym_infix_op] = STATE(768),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(14),
    [sym_compiler_directive_decl] = STATE(14),
    [sym_fsi_directive_decl] = STATE(14),
    [sym_preproc_line] = STATE(14),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_sequential_expression_repeat1] = STATE(1352),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(243),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_module] = ACTIONS(245),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(245),
    [anon_sym_LBRACK_LT] = ACTIONS(243),
    [anon_sym_COLON] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(245),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_and] = ACTIONS(245),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(127),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(153),
    [anon_sym_DOT] = ACTIONS(155),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(269),
    [anon_sym_with] = ACTIONS(245),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(269),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(269),
    [anon_sym_assert] = ACTIONS(269),
    [anon_sym_upcast] = ACTIONS(269),
    [anon_sym_downcast] = ACTIONS(269),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(275),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(277),
    [anon_sym_use_BANG] = ACTIONS(279),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_default] = ACTIONS(245),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_member] = ACTIONS(245),
    [anon_sym_interface] = ACTIONS(245),
    [anon_sym_exception] = ACTIONS(245),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_val] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(207),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(281),
    [sym_xint] = ACTIONS(283),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(243),
    [anon_sym_POUNDload] = ACTIONS(243),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
    [sym__newline] = ACTIONS(243),
  },
  [15] = {
    [sym_function_or_value_defn] = STATE(760),
    [sym__expression] = STATE(18),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(956),
    [sym_infix_op] = STATE(768),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(15),
    [sym_compiler_directive_decl] = STATE(15),
    [sym_fsi_directive_decl] = STATE(15),
    [sym_preproc_line] = STATE(15),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_sequential_expression_repeat1] = STATE(1352),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(265),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_module] = ACTIONS(267),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(267),
    [anon_sym_LBRACK_LT] = ACTIONS(265),
    [anon_sym_COLON] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_and] = ACTIONS(267),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(265),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(127),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(149),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(153),
    [anon_sym_DOT] = ACTIONS(155),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(269),
    [anon_sym_with] = ACTIONS(267),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(269),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(269),
    [anon_sym_assert] = ACTIONS(269),
    [anon_sym_upcast] = ACTIONS(269),
    [anon_sym_downcast] = ACTIONS(269),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(275),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(277),
    [anon_sym_use_BANG] = ACTIONS(279),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_default] = ACTIONS(267),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(267),
    [anon_sym_member] = ACTIONS(267),
    [anon_sym_interface] = ACTIONS(267),
    [anon_sym_exception] = ACTIONS(267),
    [anon_sym_abstract] = ACTIONS(267),
    [anon_sym_val] = ACTIONS(267),
    [anon_sym_override] = ACTIONS(267),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(207),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(281),
    [sym_xint] = ACTIONS(283),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(265),
    [anon_sym_POUNDload] = ACTIONS(265),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
    [sym__newline] = ACTIONS(285),
  },
  [16] = {
    [sym_function_or_value_defn] = STATE(760),
    [sym__expression] = STATE(18),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(956),
    [sym_infix_op] = STATE(768),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(16),
    [sym_compiler_directive_decl] = STATE(16),
    [sym_fsi_directive_decl] = STATE(16),
    [sym_preproc_line] = STATE(16),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_sequential_expression_repeat1] = STATE(1352),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(257),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_module] = ACTIONS(259),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(259),
    [anon_sym_LBRACK_LT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(259),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_and] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(257),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(127),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(259),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(153),
    [anon_sym_DOT] = ACTIONS(155),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(269),
    [anon_sym_with] = ACTIONS(259),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(269),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(269),
    [anon_sym_assert] = ACTIONS(269),
    [anon_sym_upcast] = ACTIONS(269),
    [anon_sym_downcast] = ACTIONS(269),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(275),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(277),
    [anon_sym_use_BANG] = ACTIONS(279),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_default] = ACTIONS(259),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(259),
    [anon_sym_member] = ACTIONS(259),
    [anon_sym_interface] = ACTIONS(259),
    [anon_sym_exception] = ACTIONS(259),
    [anon_sym_abstract] = ACTIONS(259),
    [anon_sym_val] = ACTIONS(259),
    [anon_sym_override] = ACTIONS(259),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(207),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(281),
    [sym_xint] = ACTIONS(283),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(257),
    [anon_sym_POUNDload] = ACTIONS(257),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
    [sym__newline] = ACTIONS(257),
  },
  [17] = {
    [sym_function_or_value_defn] = STATE(760),
    [sym__expression] = STATE(18),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(956),
    [sym_infix_op] = STATE(768),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(17),
    [sym_compiler_directive_decl] = STATE(17),
    [sym_fsi_directive_decl] = STATE(17),
    [sym_preproc_line] = STATE(17),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_sequential_expression_repeat1] = STATE(1352),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(227),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_module] = ACTIONS(229),
    [anon_sym_EQ] = ACTIONS(227),
    [anon_sym_open] = ACTIONS(229),
    [anon_sym_LBRACK_LT] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(229),
    [anon_sym_return] = ACTIONS(229),
    [anon_sym_type] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_and] = ACTIONS(229),
    [anon_sym_let] = ACTIONS(229),
    [anon_sym_let_BANG] = ACTIONS(227),
    [aux_sym_access_modifier_token1] = ACTIONS(227),
    [anon_sym_LPAREN] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(227),
    [anon_sym_null] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_COLON_QMARK] = ACTIONS(229),
    [anon_sym_COLON_COLON] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_LBRACK] = ACTIONS(229),
    [anon_sym_LBRACK_PIPE] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(229),
    [anon_sym_LT_AT] = ACTIONS(229),
    [anon_sym_LT_AT_AT] = ACTIONS(229),
    [anon_sym_DOT] = ACTIONS(155),
    [anon_sym_LBRACE_PIPE] = ACTIONS(227),
    [anon_sym_new] = ACTIONS(229),
    [anon_sym_with] = ACTIONS(229),
    [anon_sym_return_BANG] = ACTIONS(227),
    [anon_sym_yield] = ACTIONS(229),
    [anon_sym_yield_BANG] = ACTIONS(227),
    [anon_sym_lazy] = ACTIONS(229),
    [anon_sym_assert] = ACTIONS(229),
    [anon_sym_upcast] = ACTIONS(229),
    [anon_sym_downcast] = ACTIONS(229),
    [anon_sym_COLON_GT] = ACTIONS(227),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_fun] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(229),
    [anon_sym_match_BANG] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(229),
    [anon_sym_LT_DASH] = ACTIONS(229),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(229),
    [anon_sym_use_BANG] = ACTIONS(227),
    [anon_sym_do_BANG] = ACTIONS(227),
    [anon_sym_begin] = ACTIONS(229),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_default] = ACTIONS(229),
    [anon_sym_or] = ACTIONS(229),
    [anon_sym_static] = ACTIONS(229),
    [anon_sym_member] = ACTIONS(229),
    [anon_sym_interface] = ACTIONS(229),
    [anon_sym_exception] = ACTIONS(229),
    [anon_sym_abstract] = ACTIONS(229),
    [anon_sym_val] = ACTIONS(229),
    [anon_sym_override] = ACTIONS(229),
    [aux_sym_char_token1] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_AT_DQUOTE] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [sym_bool] = ACTIONS(229),
    [sym_unit] = ACTIONS(207),
    [anon_sym_LPAREN_PIPE] = ACTIONS(229),
    [sym_op_identifier] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(229),
    [anon_sym_PLUS_DOT] = ACTIONS(229),
    [anon_sym_DASH_DOT] = ACTIONS(229),
    [anon_sym_PERCENT] = ACTIONS(229),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(227),
    [aux_sym_prefix_op_token1] = ACTIONS(229),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token2] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(229),
    [anon_sym_BANG_EQ] = ACTIONS(229),
    [anon_sym_COLON_EQ] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(229),
    [sym_int] = ACTIONS(229),
    [sym_xint] = ACTIONS(227),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(227),
    [anon_sym_POUNDload] = ACTIONS(227),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(227),
    [sym__newline] = ACTIONS(227),
  },
  [18] = {
    [sym_function_or_value_defn] = STATE(760),
    [sym__expression] = STATE(18),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(956),
    [sym_infix_op] = STATE(768),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(18),
    [sym_compiler_directive_decl] = STATE(18),
    [sym_fsi_directive_decl] = STATE(18),
    [sym_preproc_line] = STATE(18),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_sequential_expression_repeat1] = STATE(1352),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(223),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_module] = ACTIONS(225),
    [anon_sym_EQ] = ACTIONS(223),
    [anon_sym_open] = ACTIONS(225),
    [anon_sym_LBRACK_LT] = ACTIONS(223),
    [anon_sym_COLON] = ACTIONS(225),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_type] = ACTIONS(225),
    [anon_sym_do] = ACTIONS(225),
    [anon_sym_and] = ACTIONS(225),
    [anon_sym_let] = ACTIONS(225),
    [anon_sym_let_BANG] = ACTIONS(223),
    [aux_sym_access_modifier_token1] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_COMMA] = ACTIONS(223),
    [anon_sym_null] = ACTIONS(225),
    [anon_sym_QMARK] = ACTIONS(225),
    [anon_sym_COLON_QMARK] = ACTIONS(225),
    [anon_sym_COLON_COLON] = ACTIONS(223),
    [anon_sym_AMP] = ACTIONS(225),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LBRACK_PIPE] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(225),
    [anon_sym_LT_AT] = ACTIONS(225),
    [anon_sym_LT_AT_AT] = ACTIONS(225),
    [anon_sym_DOT] = ACTIONS(155),
    [anon_sym_LBRACE_PIPE] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(225),
    [anon_sym_with] = ACTIONS(225),
    [anon_sym_return_BANG] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(225),
    [anon_sym_yield_BANG] = ACTIONS(223),
    [anon_sym_lazy] = ACTIONS(225),
    [anon_sym_assert] = ACTIONS(225),
    [anon_sym_upcast] = ACTIONS(225),
    [anon_sym_downcast] = ACTIONS(225),
    [anon_sym_COLON_GT] = ACTIONS(223),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(223),
    [anon_sym_for] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_fun] = ACTIONS(225),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_match] = ACTIONS(225),
    [anon_sym_match_BANG] = ACTIONS(223),
    [anon_sym_function] = ACTIONS(225),
    [anon_sym_LT_DASH] = ACTIONS(225),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(225),
    [anon_sym_use_BANG] = ACTIONS(223),
    [anon_sym_do_BANG] = ACTIONS(223),
    [anon_sym_begin] = ACTIONS(225),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_or] = ACTIONS(225),
    [anon_sym_static] = ACTIONS(225),
    [anon_sym_member] = ACTIONS(225),
    [anon_sym_interface] = ACTIONS(225),
    [anon_sym_exception] = ACTIONS(225),
    [anon_sym_abstract] = ACTIONS(225),
    [anon_sym_val] = ACTIONS(225),
    [anon_sym_override] = ACTIONS(225),
    [aux_sym_char_token1] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_AT_DQUOTE] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [sym_bool] = ACTIONS(225),
    [sym_unit] = ACTIONS(207),
    [anon_sym_LPAREN_PIPE] = ACTIONS(225),
    [sym_op_identifier] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(225),
    [anon_sym_DASH] = ACTIONS(225),
    [anon_sym_PLUS_DOT] = ACTIONS(225),
    [anon_sym_DASH_DOT] = ACTIONS(225),
    [anon_sym_PERCENT] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_TILDE] = ACTIONS(223),
    [aux_sym_prefix_op_token1] = ACTIONS(225),
    [aux_sym_infix_op_token1] = ACTIONS(223),
    [aux_sym_infix_op_token2] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_BANG_EQ] = ACTIONS(225),
    [anon_sym_COLON_EQ] = ACTIONS(223),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(225),
    [sym_int] = ACTIONS(225),
    [sym_xint] = ACTIONS(223),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(223),
    [anon_sym_POUNDload] = ACTIONS(223),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(223),
    [sym__newline] = ACTIONS(223),
  },
  [19] = {
    [sym_function_or_value_defn] = STATE(760),
    [sym__expression] = STATE(18),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(956),
    [sym_infix_op] = STATE(768),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(19),
    [sym_compiler_directive_decl] = STATE(19),
    [sym_fsi_directive_decl] = STATE(19),
    [sym_preproc_line] = STATE(19),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_sequential_expression_repeat1] = STATE(1352),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(247),
    [sym_identifier] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(249),
    [anon_sym_LBRACK_LT] = ACTIONS(247),
    [anon_sym_COLON] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(249),
    [anon_sym_type] = ACTIONS(249),
    [anon_sym_do] = ACTIONS(249),
    [anon_sym_and] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(249),
    [anon_sym_let_BANG] = ACTIONS(247),
    [aux_sym_access_modifier_token1] = ACTIONS(247),
    [anon_sym_LPAREN] = ACTIONS(249),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(127),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(249),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_LBRACK_PIPE] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_LT_AT] = ACTIONS(249),
    [anon_sym_LT_AT_AT] = ACTIONS(249),
    [anon_sym_DOT] = ACTIONS(155),
    [anon_sym_LBRACE_PIPE] = ACTIONS(247),
    [anon_sym_new] = ACTIONS(249),
    [anon_sym_with] = ACTIONS(251),
    [anon_sym_return_BANG] = ACTIONS(247),
    [anon_sym_yield] = ACTIONS(249),
    [anon_sym_yield_BANG] = ACTIONS(247),
    [anon_sym_lazy] = ACTIONS(249),
    [anon_sym_assert] = ACTIONS(249),
    [anon_sym_upcast] = ACTIONS(249),
    [anon_sym_downcast] = ACTIONS(249),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(249),
    [anon_sym_while] = ACTIONS(249),
    [anon_sym_if] = ACTIONS(249),
    [anon_sym_fun] = ACTIONS(249),
    [anon_sym_try] = ACTIONS(249),
    [anon_sym_match] = ACTIONS(249),
    [anon_sym_match_BANG] = ACTIONS(247),
    [anon_sym_function] = ACTIONS(249),
    [anon_sym_LT_DASH] = ACTIONS(275),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(249),
    [anon_sym_use_BANG] = ACTIONS(247),
    [anon_sym_do_BANG] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_default] = ACTIONS(249),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(249),
    [anon_sym_member] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(249),
    [anon_sym_exception] = ACTIONS(249),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_val] = ACTIONS(249),
    [anon_sym_override] = ACTIONS(249),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(249),
    [anon_sym_AT_DQUOTE] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(247),
    [sym_bool] = ACTIONS(249),
    [sym_unit] = ACTIONS(247),
    [anon_sym_LPAREN_PIPE] = ACTIONS(249),
    [sym_op_identifier] = ACTIONS(249),
    [anon_sym_PLUS] = ACTIONS(249),
    [anon_sym_DASH] = ACTIONS(249),
    [anon_sym_PLUS_DOT] = ACTIONS(249),
    [anon_sym_DASH_DOT] = ACTIONS(249),
    [anon_sym_PERCENT] = ACTIONS(249),
    [anon_sym_AMP_AMP] = ACTIONS(249),
    [anon_sym_TILDE] = ACTIONS(247),
    [aux_sym_prefix_op_token1] = ACTIONS(249),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(249),
    [sym_xint] = ACTIONS(247),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(247),
    [anon_sym_POUNDload] = ACTIONS(247),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(247),
    [sym__newline] = ACTIONS(285),
  },
  [20] = {
    [sym_function_or_value_defn] = STATE(760),
    [sym__expression] = STATE(18),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(956),
    [sym_infix_op] = STATE(768),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(20),
    [sym_compiler_directive_decl] = STATE(20),
    [sym_fsi_directive_decl] = STATE(20),
    [sym_preproc_line] = STATE(20),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_sequential_expression_repeat1] = STATE(1352),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(231),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_module] = ACTIONS(233),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(233),
    [anon_sym_LBRACK_LT] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(233),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_and] = ACTIONS(233),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(127),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(149),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(153),
    [anon_sym_DOT] = ACTIONS(155),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(269),
    [anon_sym_with] = ACTIONS(233),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(269),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(269),
    [anon_sym_assert] = ACTIONS(269),
    [anon_sym_upcast] = ACTIONS(269),
    [anon_sym_downcast] = ACTIONS(269),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(275),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(277),
    [anon_sym_use_BANG] = ACTIONS(279),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_default] = ACTIONS(233),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(233),
    [anon_sym_member] = ACTIONS(233),
    [anon_sym_interface] = ACTIONS(233),
    [anon_sym_exception] = ACTIONS(233),
    [anon_sym_abstract] = ACTIONS(233),
    [anon_sym_val] = ACTIONS(233),
    [anon_sym_override] = ACTIONS(233),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(207),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(281),
    [sym_xint] = ACTIONS(283),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(231),
    [anon_sym_POUNDload] = ACTIONS(231),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
    [sym__newline] = ACTIONS(285),
  },
  [21] = {
    [sym_function_or_value_defn] = STATE(760),
    [sym__expression] = STATE(18),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(956),
    [sym_infix_op] = STATE(768),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(21),
    [sym_compiler_directive_decl] = STATE(21),
    [sym_fsi_directive_decl] = STATE(21),
    [sym_preproc_line] = STATE(21),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_sequential_expression_repeat1] = STATE(1352),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(261),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_module] = ACTIONS(263),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(263),
    [anon_sym_LBRACK_LT] = ACTIONS(261),
    [anon_sym_COLON] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(263),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_and] = ACTIONS(263),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(261),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(127),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(149),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(153),
    [anon_sym_DOT] = ACTIONS(155),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(269),
    [anon_sym_with] = ACTIONS(263),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(269),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(269),
    [anon_sym_assert] = ACTIONS(269),
    [anon_sym_upcast] = ACTIONS(269),
    [anon_sym_downcast] = ACTIONS(269),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(275),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(277),
    [anon_sym_use_BANG] = ACTIONS(279),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_default] = ACTIONS(263),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(263),
    [anon_sym_member] = ACTIONS(263),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_exception] = ACTIONS(263),
    [anon_sym_abstract] = ACTIONS(263),
    [anon_sym_val] = ACTIONS(263),
    [anon_sym_override] = ACTIONS(263),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(207),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(281),
    [sym_xint] = ACTIONS(283),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(261),
    [anon_sym_POUNDload] = ACTIONS(261),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
    [sym__newline] = ACTIONS(285),
  },
  [22] = {
    [sym_function_or_value_defn] = STATE(760),
    [sym__expression] = STATE(18),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(956),
    [sym_infix_op] = STATE(768),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(22),
    [sym_compiler_directive_decl] = STATE(22),
    [sym_fsi_directive_decl] = STATE(22),
    [sym_preproc_line] = STATE(22),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_sequential_expression_repeat1] = STATE(1352),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(237),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_module] = ACTIONS(239),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(239),
    [anon_sym_LBRACK_LT] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_type] = ACTIONS(239),
    [anon_sym_do] = ACTIONS(239),
    [anon_sym_and] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(239),
    [anon_sym_let_BANG] = ACTIONS(237),
    [aux_sym_access_modifier_token1] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_null] = ACTIONS(239),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(127),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_LBRACK_PIPE] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LT_AT] = ACTIONS(239),
    [anon_sym_LT_AT_AT] = ACTIONS(239),
    [anon_sym_DOT] = ACTIONS(155),
    [anon_sym_LBRACE_PIPE] = ACTIONS(237),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_with] = ACTIONS(241),
    [anon_sym_return_BANG] = ACTIONS(237),
    [anon_sym_yield] = ACTIONS(239),
    [anon_sym_yield_BANG] = ACTIONS(237),
    [anon_sym_lazy] = ACTIONS(239),
    [anon_sym_assert] = ACTIONS(239),
    [anon_sym_upcast] = ACTIONS(239),
    [anon_sym_downcast] = ACTIONS(239),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(239),
    [anon_sym_while] = ACTIONS(239),
    [anon_sym_if] = ACTIONS(239),
    [anon_sym_fun] = ACTIONS(239),
    [anon_sym_try] = ACTIONS(239),
    [anon_sym_match] = ACTIONS(239),
    [anon_sym_match_BANG] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(239),
    [anon_sym_LT_DASH] = ACTIONS(275),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(237),
    [anon_sym_do_BANG] = ACTIONS(237),
    [anon_sym_begin] = ACTIONS(239),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_default] = ACTIONS(239),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(239),
    [anon_sym_member] = ACTIONS(239),
    [anon_sym_interface] = ACTIONS(239),
    [anon_sym_exception] = ACTIONS(239),
    [anon_sym_abstract] = ACTIONS(239),
    [anon_sym_val] = ACTIONS(239),
    [anon_sym_override] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [anon_sym_AT_DQUOTE] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [sym_bool] = ACTIONS(239),
    [sym_unit] = ACTIONS(237),
    [anon_sym_LPAREN_PIPE] = ACTIONS(239),
    [sym_op_identifier] = ACTIONS(239),
    [anon_sym_PLUS] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_PLUS_DOT] = ACTIONS(239),
    [anon_sym_DASH_DOT] = ACTIONS(239),
    [anon_sym_PERCENT] = ACTIONS(239),
    [anon_sym_AMP_AMP] = ACTIONS(239),
    [anon_sym_TILDE] = ACTIONS(237),
    [aux_sym_prefix_op_token1] = ACTIONS(239),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(239),
    [sym_xint] = ACTIONS(237),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(237),
    [anon_sym_POUNDload] = ACTIONS(237),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(237),
    [sym__newline] = ACTIONS(285),
  },
  [23] = {
    [sym_function_or_value_defn] = STATE(760),
    [sym__expression] = STATE(18),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(956),
    [sym_infix_op] = STATE(768),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(23),
    [sym_compiler_directive_decl] = STATE(23),
    [sym_fsi_directive_decl] = STATE(23),
    [sym_preproc_line] = STATE(23),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_sequential_expression_repeat1] = STATE(1352),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(253),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_module] = ACTIONS(255),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(255),
    [anon_sym_LBRACK_LT] = ACTIONS(253),
    [anon_sym_COLON] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(255),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(127),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(255),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(153),
    [anon_sym_DOT] = ACTIONS(155),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(269),
    [anon_sym_with] = ACTIONS(255),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(269),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(269),
    [anon_sym_assert] = ACTIONS(269),
    [anon_sym_upcast] = ACTIONS(269),
    [anon_sym_downcast] = ACTIONS(269),
    [anon_sym_COLON_GT] = ACTIONS(161),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_LT_DASH] = ACTIONS(275),
    [anon_sym_DOT_LBRACK] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(277),
    [anon_sym_use_BANG] = ACTIONS(279),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_default] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(255),
    [anon_sym_member] = ACTIONS(255),
    [anon_sym_interface] = ACTIONS(255),
    [anon_sym_exception] = ACTIONS(255),
    [anon_sym_abstract] = ACTIONS(255),
    [anon_sym_val] = ACTIONS(255),
    [anon_sym_override] = ACTIONS(255),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(207),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(281),
    [sym_xint] = ACTIONS(283),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(253),
    [anon_sym_POUNDload] = ACTIONS(253),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
    [sym__newline] = ACTIONS(253),
  },
  [24] = {
    [sym_function_or_value_defn] = STATE(953),
    [sym__expression] = STATE(37),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(942),
    [sym_infix_op] = STATE(913),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(1568),
    [sym_block_comment] = STATE(24),
    [sym_compiler_directive_decl] = STATE(24),
    [sym_fsi_directive_decl] = STATE(24),
    [sym_preproc_line] = STATE(24),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_sequential_expression_repeat1] = STATE(1650),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(265),
    [anon_sym_COLON] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(265),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(289),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(309),
    [anon_sym_DOT] = ACTIONS(311),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(291),
    [anon_sym_with] = ACTIONS(267),
    [anon_sym_return_BANG] = ACTIONS(315),
    [anon_sym_yield] = ACTIONS(291),
    [anon_sym_yield_BANG] = ACTIONS(315),
    [anon_sym_lazy] = ACTIONS(291),
    [anon_sym_assert] = ACTIONS(291),
    [anon_sym_upcast] = ACTIONS(291),
    [anon_sym_downcast] = ACTIONS(291),
    [anon_sym_COLON_GT] = ACTIONS(317),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_LT_DASH] = ACTIONS(333),
    [anon_sym_DOT_LBRACK] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_use] = ACTIONS(339),
    [anon_sym_use_BANG] = ACTIONS(341),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [anon_sym_LPAREN2] = ACTIONS(347),
    [anon_sym_default] = ACTIONS(267),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(267),
    [anon_sym_member] = ACTIONS(267),
    [anon_sym_interface] = ACTIONS(267),
    [anon_sym_abstract] = ACTIONS(267),
    [anon_sym_val] = ACTIONS(267),
    [anon_sym_override] = ACTIONS(267),
    [anon_sym_inherit] = ACTIONS(267),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(369),
    [sym_xint] = ACTIONS(371),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(265),
    [anon_sym_POUNDelse] = ACTIONS(265),
    [sym__newline] = ACTIONS(375),
  },
  [25] = {
    [sym_function_or_value_defn] = STATE(953),
    [sym__expression] = STATE(37),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(942),
    [sym_infix_op] = STATE(913),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(1568),
    [sym_block_comment] = STATE(25),
    [sym_compiler_directive_decl] = STATE(25),
    [sym_fsi_directive_decl] = STATE(25),
    [sym_preproc_line] = STATE(25),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_sequential_expression_repeat1] = STATE(1650),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_do] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(239),
    [anon_sym_let_BANG] = ACTIONS(237),
    [aux_sym_access_modifier_token1] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(289),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(309),
    [anon_sym_DOT] = ACTIONS(311),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_with] = ACTIONS(239),
    [anon_sym_return_BANG] = ACTIONS(315),
    [anon_sym_yield] = ACTIONS(291),
    [anon_sym_yield_BANG] = ACTIONS(315),
    [anon_sym_lazy] = ACTIONS(291),
    [anon_sym_assert] = ACTIONS(291),
    [anon_sym_upcast] = ACTIONS(291),
    [anon_sym_downcast] = ACTIONS(291),
    [anon_sym_COLON_GT] = ACTIONS(317),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_LT_DASH] = ACTIONS(333),
    [anon_sym_DOT_LBRACK] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_use] = ACTIONS(339),
    [anon_sym_use_BANG] = ACTIONS(341),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [anon_sym_LPAREN2] = ACTIONS(347),
    [anon_sym_default] = ACTIONS(239),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(239),
    [anon_sym_member] = ACTIONS(239),
    [anon_sym_interface] = ACTIONS(239),
    [anon_sym_abstract] = ACTIONS(239),
    [anon_sym_val] = ACTIONS(239),
    [anon_sym_override] = ACTIONS(239),
    [anon_sym_inherit] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(369),
    [sym_xint] = ACTIONS(371),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(237),
    [anon_sym_POUNDendif] = ACTIONS(237),
    [anon_sym_POUNDelse] = ACTIONS(237),
    [sym__newline] = ACTIONS(237),
  },
  [26] = {
    [sym_function_or_value_defn] = STATE(953),
    [sym__expression] = STATE(37),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(942),
    [sym_infix_op] = STATE(913),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(1568),
    [sym_block_comment] = STATE(26),
    [sym_compiler_directive_decl] = STATE(26),
    [sym_fsi_directive_decl] = STATE(26),
    [sym_preproc_line] = STATE(26),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_sequential_expression_repeat1] = STATE(1650),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(257),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(289),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(259),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(309),
    [anon_sym_DOT] = ACTIONS(311),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(291),
    [anon_sym_with] = ACTIONS(259),
    [anon_sym_return_BANG] = ACTIONS(315),
    [anon_sym_yield] = ACTIONS(291),
    [anon_sym_yield_BANG] = ACTIONS(315),
    [anon_sym_lazy] = ACTIONS(291),
    [anon_sym_assert] = ACTIONS(291),
    [anon_sym_upcast] = ACTIONS(291),
    [anon_sym_downcast] = ACTIONS(291),
    [anon_sym_COLON_GT] = ACTIONS(317),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_LT_DASH] = ACTIONS(333),
    [anon_sym_DOT_LBRACK] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_use] = ACTIONS(339),
    [anon_sym_use_BANG] = ACTIONS(341),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [anon_sym_LPAREN2] = ACTIONS(347),
    [anon_sym_default] = ACTIONS(259),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(259),
    [anon_sym_member] = ACTIONS(259),
    [anon_sym_interface] = ACTIONS(259),
    [anon_sym_abstract] = ACTIONS(259),
    [anon_sym_val] = ACTIONS(259),
    [anon_sym_override] = ACTIONS(259),
    [anon_sym_inherit] = ACTIONS(259),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(369),
    [sym_xint] = ACTIONS(371),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(257),
    [anon_sym_POUNDelse] = ACTIONS(257),
    [sym__newline] = ACTIONS(257),
  },
  [27] = {
    [sym_function_or_value_defn] = STATE(953),
    [sym__expression] = STATE(37),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(942),
    [sym_infix_op] = STATE(913),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(1568),
    [sym_block_comment] = STATE(27),
    [sym_compiler_directive_decl] = STATE(27),
    [sym_fsi_directive_decl] = STATE(27),
    [sym_preproc_line] = STATE(27),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_sequential_expression_repeat1] = STATE(1650),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(261),
    [anon_sym_COLON] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(261),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(289),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(309),
    [anon_sym_DOT] = ACTIONS(311),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(291),
    [anon_sym_with] = ACTIONS(263),
    [anon_sym_return_BANG] = ACTIONS(315),
    [anon_sym_yield] = ACTIONS(291),
    [anon_sym_yield_BANG] = ACTIONS(315),
    [anon_sym_lazy] = ACTIONS(291),
    [anon_sym_assert] = ACTIONS(291),
    [anon_sym_upcast] = ACTIONS(291),
    [anon_sym_downcast] = ACTIONS(291),
    [anon_sym_COLON_GT] = ACTIONS(317),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_LT_DASH] = ACTIONS(333),
    [anon_sym_DOT_LBRACK] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_use] = ACTIONS(339),
    [anon_sym_use_BANG] = ACTIONS(341),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [anon_sym_LPAREN2] = ACTIONS(347),
    [anon_sym_default] = ACTIONS(263),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(263),
    [anon_sym_member] = ACTIONS(263),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_abstract] = ACTIONS(263),
    [anon_sym_val] = ACTIONS(263),
    [anon_sym_override] = ACTIONS(263),
    [anon_sym_inherit] = ACTIONS(263),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(369),
    [sym_xint] = ACTIONS(371),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(261),
    [anon_sym_POUNDelse] = ACTIONS(261),
    [sym__newline] = ACTIONS(375),
  },
  [28] = {
    [sym_function_or_value_defn] = STATE(953),
    [sym__expression] = STATE(37),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(942),
    [sym_infix_op] = STATE(913),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(1568),
    [sym_block_comment] = STATE(28),
    [sym_compiler_directive_decl] = STATE(28),
    [sym_fsi_directive_decl] = STATE(28),
    [sym_preproc_line] = STATE(28),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_sequential_expression_repeat1] = STATE(1650),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(119),
    [anon_sym_COLON] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(119),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(289),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(309),
    [anon_sym_DOT] = ACTIONS(311),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(291),
    [anon_sym_with] = ACTIONS(123),
    [anon_sym_return_BANG] = ACTIONS(315),
    [anon_sym_yield] = ACTIONS(291),
    [anon_sym_yield_BANG] = ACTIONS(315),
    [anon_sym_lazy] = ACTIONS(291),
    [anon_sym_assert] = ACTIONS(291),
    [anon_sym_upcast] = ACTIONS(291),
    [anon_sym_downcast] = ACTIONS(291),
    [anon_sym_COLON_GT] = ACTIONS(317),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_LT_DASH] = ACTIONS(333),
    [anon_sym_DOT_LBRACK] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_use] = ACTIONS(339),
    [anon_sym_use_BANG] = ACTIONS(341),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [anon_sym_LPAREN2] = ACTIONS(347),
    [anon_sym_default] = ACTIONS(123),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(123),
    [anon_sym_member] = ACTIONS(123),
    [anon_sym_interface] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(123),
    [anon_sym_val] = ACTIONS(123),
    [anon_sym_override] = ACTIONS(123),
    [anon_sym_inherit] = ACTIONS(123),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(369),
    [sym_xint] = ACTIONS(371),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(119),
    [anon_sym_POUNDelse] = ACTIONS(119),
    [sym__newline] = ACTIONS(119),
  },
  [29] = {
    [sym_function_or_value_defn] = STATE(953),
    [sym__expression] = STATE(37),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(942),
    [sym_infix_op] = STATE(913),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(1568),
    [sym_block_comment] = STATE(29),
    [sym_compiler_directive_decl] = STATE(29),
    [sym_fsi_directive_decl] = STATE(29),
    [sym_preproc_line] = STATE(29),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_sequential_expression_repeat1] = STATE(1650),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(289),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(309),
    [anon_sym_DOT] = ACTIONS(311),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(291),
    [anon_sym_with] = ACTIONS(233),
    [anon_sym_return_BANG] = ACTIONS(315),
    [anon_sym_yield] = ACTIONS(291),
    [anon_sym_yield_BANG] = ACTIONS(315),
    [anon_sym_lazy] = ACTIONS(291),
    [anon_sym_assert] = ACTIONS(291),
    [anon_sym_upcast] = ACTIONS(291),
    [anon_sym_downcast] = ACTIONS(291),
    [anon_sym_COLON_GT] = ACTIONS(317),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_LT_DASH] = ACTIONS(333),
    [anon_sym_DOT_LBRACK] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_use] = ACTIONS(339),
    [anon_sym_use_BANG] = ACTIONS(341),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [anon_sym_LPAREN2] = ACTIONS(347),
    [anon_sym_default] = ACTIONS(233),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(233),
    [anon_sym_member] = ACTIONS(233),
    [anon_sym_interface] = ACTIONS(233),
    [anon_sym_abstract] = ACTIONS(233),
    [anon_sym_val] = ACTIONS(233),
    [anon_sym_override] = ACTIONS(233),
    [anon_sym_inherit] = ACTIONS(233),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(369),
    [sym_xint] = ACTIONS(371),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(231),
    [anon_sym_POUNDelse] = ACTIONS(231),
    [sym__newline] = ACTIONS(375),
  },
  [30] = {
    [sym_function_or_value_defn] = STATE(953),
    [sym__expression] = STATE(37),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(942),
    [sym_infix_op] = STATE(913),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(1568),
    [sym_block_comment] = STATE(30),
    [sym_compiler_directive_decl] = STATE(30),
    [sym_fsi_directive_decl] = STATE(30),
    [sym_preproc_line] = STATE(30),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_sequential_expression_repeat1] = STATE(1650),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(243),
    [anon_sym_COLON] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(289),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(309),
    [anon_sym_DOT] = ACTIONS(311),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(291),
    [anon_sym_with] = ACTIONS(245),
    [anon_sym_return_BANG] = ACTIONS(315),
    [anon_sym_yield] = ACTIONS(291),
    [anon_sym_yield_BANG] = ACTIONS(315),
    [anon_sym_lazy] = ACTIONS(291),
    [anon_sym_assert] = ACTIONS(291),
    [anon_sym_upcast] = ACTIONS(291),
    [anon_sym_downcast] = ACTIONS(291),
    [anon_sym_COLON_GT] = ACTIONS(317),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_LT_DASH] = ACTIONS(333),
    [anon_sym_DOT_LBRACK] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_use] = ACTIONS(339),
    [anon_sym_use_BANG] = ACTIONS(341),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [anon_sym_LPAREN2] = ACTIONS(347),
    [anon_sym_default] = ACTIONS(245),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_member] = ACTIONS(245),
    [anon_sym_interface] = ACTIONS(245),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_val] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_inherit] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(369),
    [sym_xint] = ACTIONS(371),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(243),
    [anon_sym_POUNDelse] = ACTIONS(243),
    [sym__newline] = ACTIONS(243),
  },
  [31] = {
    [sym_function_or_value_defn] = STATE(953),
    [sym__expression] = STATE(37),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(942),
    [sym_infix_op] = STATE(913),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(1568),
    [sym_block_comment] = STATE(31),
    [sym_compiler_directive_decl] = STATE(31),
    [sym_fsi_directive_decl] = STATE(31),
    [sym_preproc_line] = STATE(31),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_sequential_expression_repeat1] = STATE(1650),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(253),
    [anon_sym_COLON] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(289),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(255),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(309),
    [anon_sym_DOT] = ACTIONS(311),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(291),
    [anon_sym_with] = ACTIONS(255),
    [anon_sym_return_BANG] = ACTIONS(315),
    [anon_sym_yield] = ACTIONS(291),
    [anon_sym_yield_BANG] = ACTIONS(315),
    [anon_sym_lazy] = ACTIONS(291),
    [anon_sym_assert] = ACTIONS(291),
    [anon_sym_upcast] = ACTIONS(291),
    [anon_sym_downcast] = ACTIONS(291),
    [anon_sym_COLON_GT] = ACTIONS(317),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_LT_DASH] = ACTIONS(333),
    [anon_sym_DOT_LBRACK] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_use] = ACTIONS(339),
    [anon_sym_use_BANG] = ACTIONS(341),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [anon_sym_LPAREN2] = ACTIONS(347),
    [anon_sym_default] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(255),
    [anon_sym_member] = ACTIONS(255),
    [anon_sym_interface] = ACTIONS(255),
    [anon_sym_abstract] = ACTIONS(255),
    [anon_sym_val] = ACTIONS(255),
    [anon_sym_override] = ACTIONS(255),
    [anon_sym_inherit] = ACTIONS(255),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(369),
    [sym_xint] = ACTIONS(371),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(253),
    [anon_sym_POUNDelse] = ACTIONS(253),
    [sym__newline] = ACTIONS(253),
  },
  [32] = {
    [sym_function_or_value_defn] = STATE(953),
    [sym__expression] = STATE(37),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(942),
    [sym_infix_op] = STATE(913),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(1568),
    [sym_block_comment] = STATE(32),
    [sym_compiler_directive_decl] = STATE(32),
    [sym_fsi_directive_decl] = STATE(32),
    [sym_preproc_line] = STATE(32),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_sequential_expression_repeat1] = STATE(1650),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_EQ] = ACTIONS(227),
    [anon_sym_LBRACK_LT] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(229),
    [anon_sym_return] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_let] = ACTIONS(229),
    [anon_sym_let_BANG] = ACTIONS(227),
    [aux_sym_access_modifier_token1] = ACTIONS(227),
    [anon_sym_LPAREN] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(227),
    [anon_sym_null] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_COLON_QMARK] = ACTIONS(229),
    [anon_sym_COLON_COLON] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_LBRACK] = ACTIONS(229),
    [anon_sym_LBRACK_PIPE] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(229),
    [anon_sym_LT_AT] = ACTIONS(229),
    [anon_sym_LT_AT_AT] = ACTIONS(229),
    [anon_sym_DOT] = ACTIONS(311),
    [anon_sym_LBRACE_PIPE] = ACTIONS(227),
    [anon_sym_new] = ACTIONS(229),
    [anon_sym_with] = ACTIONS(229),
    [anon_sym_return_BANG] = ACTIONS(227),
    [anon_sym_yield] = ACTIONS(229),
    [anon_sym_yield_BANG] = ACTIONS(227),
    [anon_sym_lazy] = ACTIONS(229),
    [anon_sym_assert] = ACTIONS(229),
    [anon_sym_upcast] = ACTIONS(229),
    [anon_sym_downcast] = ACTIONS(229),
    [anon_sym_COLON_GT] = ACTIONS(227),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_fun] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(229),
    [anon_sym_match_BANG] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(229),
    [anon_sym_LT_DASH] = ACTIONS(229),
    [anon_sym_DOT_LBRACK] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_use] = ACTIONS(229),
    [anon_sym_use_BANG] = ACTIONS(227),
    [anon_sym_do_BANG] = ACTIONS(227),
    [anon_sym_begin] = ACTIONS(229),
    [anon_sym_LPAREN2] = ACTIONS(347),
    [anon_sym_default] = ACTIONS(229),
    [anon_sym_or] = ACTIONS(229),
    [anon_sym_static] = ACTIONS(229),
    [anon_sym_member] = ACTIONS(229),
    [anon_sym_interface] = ACTIONS(229),
    [anon_sym_abstract] = ACTIONS(229),
    [anon_sym_val] = ACTIONS(229),
    [anon_sym_override] = ACTIONS(229),
    [anon_sym_inherit] = ACTIONS(229),
    [aux_sym_char_token1] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_AT_DQUOTE] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [sym_bool] = ACTIONS(229),
    [sym_unit] = ACTIONS(363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(229),
    [sym_op_identifier] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(229),
    [anon_sym_PLUS_DOT] = ACTIONS(229),
    [anon_sym_DASH_DOT] = ACTIONS(229),
    [anon_sym_PERCENT] = ACTIONS(229),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(227),
    [aux_sym_prefix_op_token1] = ACTIONS(229),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token2] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(229),
    [anon_sym_BANG_EQ] = ACTIONS(229),
    [anon_sym_COLON_EQ] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(229),
    [sym_int] = ACTIONS(229),
    [sym_xint] = ACTIONS(227),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(227),
    [anon_sym_POUNDendif] = ACTIONS(227),
    [anon_sym_POUNDelse] = ACTIONS(227),
    [sym__newline] = ACTIONS(227),
  },
  [33] = {
    [sym_function_or_value_defn] = STATE(1163),
    [sym__expression] = STATE(34),
    [sym_literal_expression] = STATE(1715),
    [sym_long_identifier_or_op] = STATE(1715),
    [sym_tuple_expression] = STATE(1715),
    [sym_brace_expression] = STATE(1715),
    [sym_anon_record_expression] = STATE(1715),
    [sym_prefixed_expression] = STATE(1715),
    [sym_typecast_expression] = STATE(1715),
    [sym_for_expression] = STATE(1715),
    [sym_while_expression] = STATE(1715),
    [sym__if_branch] = STATE(10853),
    [sym_if_expression] = STATE(1715),
    [sym_fun_expression] = STATE(1715),
    [sym_try_expression] = STATE(1715),
    [sym_match_expression] = STATE(1715),
    [sym_function_expression] = STATE(1715),
    [sym_mutate_expression] = STATE(1715),
    [sym_index_expression] = STATE(1715),
    [sym_typed_expression] = STATE(1715),
    [sym_declaration_expression] = STATE(1715),
    [sym_do_expression] = STATE(1715),
    [sym_list_expression] = STATE(1715),
    [sym_array_expression] = STATE(1715),
    [sym_begin_end_expression] = STATE(1715),
    [sym_paren_expression] = STATE(1715),
    [sym__high_prec_app] = STATE(1728),
    [sym__low_prec_app] = STATE(1728),
    [sym_application_expression] = STATE(1715),
    [sym_dot_expression] = STATE(1715),
    [sym_infix_expression] = STATE(1715),
    [sym_ce_expression] = STATE(1715),
    [sym_sequential_expression] = STATE(1715),
    [sym_char] = STATE(1858),
    [sym_format_string] = STATE(1853),
    [sym__string_literal] = STATE(1853),
    [sym_string] = STATE(1858),
    [sym_verbatim_string] = STATE(1858),
    [sym_bytearray] = STATE(1858),
    [sym_verbatim_bytearray] = STATE(1858),
    [sym_format_triple_quoted_string] = STATE(1851),
    [sym_triple_quoted_string] = STATE(1858),
    [sym_const] = STATE(1715),
    [sym_long_identifier] = STATE(1825),
    [sym_active_pattern] = STATE(1754),
    [sym__identifier_or_op] = STATE(1822),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(940),
    [sym_infix_op] = STATE(1154),
    [sym_sbyte] = STATE(1858),
    [sym_byte] = STATE(1858),
    [sym_int16] = STATE(1858),
    [sym_uint16] = STATE(1858),
    [sym_int32] = STATE(1858),
    [sym_uint32] = STATE(1858),
    [sym_nativeint] = STATE(1858),
    [sym_unativeint] = STATE(1858),
    [sym_int64] = STATE(1858),
    [sym_uint64] = STATE(1858),
    [sym_ieee32] = STATE(1858),
    [sym_ieee64] = STATE(1858),
    [sym_bignum] = STATE(1858),
    [sym_decimal] = STATE(1858),
    [sym_float] = STATE(1552),
    [sym_block_comment] = STATE(33),
    [sym_compiler_directive_decl] = STATE(33),
    [sym_fsi_directive_decl] = STATE(33),
    [sym_preproc_line] = STATE(33),
    [sym_preproc_if_in_expression] = STATE(1715),
    [aux_sym_sequential_expression_repeat1] = STATE(1594),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_do] = ACTIONS(383),
    [anon_sym_and] = ACTIONS(233),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(387),
    [anon_sym_null] = ACTIONS(389),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(379),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_LBRACK_PIPE] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_LT_AT] = ACTIONS(397),
    [anon_sym_LT_AT_AT] = ACTIONS(399),
    [anon_sym_DOT] = ACTIONS(401),
    [anon_sym_LBRACE_PIPE] = ACTIONS(403),
    [anon_sym_new] = ACTIONS(381),
    [anon_sym_with] = ACTIONS(233),
    [anon_sym_return_BANG] = ACTIONS(405),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_yield_BANG] = ACTIONS(405),
    [anon_sym_lazy] = ACTIONS(381),
    [anon_sym_assert] = ACTIONS(381),
    [anon_sym_upcast] = ACTIONS(381),
    [anon_sym_downcast] = ACTIONS(381),
    [anon_sym_COLON_GT] = ACTIONS(407),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(407),
    [anon_sym_for] = ACTIONS(409),
    [anon_sym_while] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(413),
    [anon_sym_try] = ACTIONS(415),
    [anon_sym_match] = ACTIONS(417),
    [anon_sym_match_BANG] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(421),
    [anon_sym_LT_DASH] = ACTIONS(423),
    [anon_sym_DOT_LBRACK] = ACTIONS(425),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_use] = ACTIONS(429),
    [anon_sym_use_BANG] = ACTIONS(431),
    [anon_sym_do_BANG] = ACTIONS(433),
    [anon_sym_begin] = ACTIONS(435),
    [anon_sym_LPAREN2] = ACTIONS(437),
    [anon_sym_default] = ACTIONS(233),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(233),
    [anon_sym_member] = ACTIONS(233),
    [anon_sym_interface] = ACTIONS(233),
    [anon_sym_abstract] = ACTIONS(233),
    [anon_sym_val] = ACTIONS(233),
    [anon_sym_override] = ACTIONS(233),
    [aux_sym_char_token1] = ACTIONS(439),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(443),
    [anon_sym_AT_DQUOTE] = ACTIONS(445),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(447),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(449),
    [sym_bool] = ACTIONS(451),
    [sym_unit] = ACTIONS(453),
    [anon_sym_LPAREN_PIPE] = ACTIONS(455),
    [sym_op_identifier] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(459),
    [sym_xint] = ACTIONS(461),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(463),
    [anon_sym_POUNDendif] = ACTIONS(231),
    [anon_sym_POUNDelse] = ACTIONS(231),
    [sym__newline] = ACTIONS(465),
  },
  [34] = {
    [sym_function_or_value_defn] = STATE(1163),
    [sym__expression] = STATE(34),
    [sym_literal_expression] = STATE(1715),
    [sym_long_identifier_or_op] = STATE(1715),
    [sym_tuple_expression] = STATE(1715),
    [sym_brace_expression] = STATE(1715),
    [sym_anon_record_expression] = STATE(1715),
    [sym_prefixed_expression] = STATE(1715),
    [sym_typecast_expression] = STATE(1715),
    [sym_for_expression] = STATE(1715),
    [sym_while_expression] = STATE(1715),
    [sym__if_branch] = STATE(10853),
    [sym_if_expression] = STATE(1715),
    [sym_fun_expression] = STATE(1715),
    [sym_try_expression] = STATE(1715),
    [sym_match_expression] = STATE(1715),
    [sym_function_expression] = STATE(1715),
    [sym_mutate_expression] = STATE(1715),
    [sym_index_expression] = STATE(1715),
    [sym_typed_expression] = STATE(1715),
    [sym_declaration_expression] = STATE(1715),
    [sym_do_expression] = STATE(1715),
    [sym_list_expression] = STATE(1715),
    [sym_array_expression] = STATE(1715),
    [sym_begin_end_expression] = STATE(1715),
    [sym_paren_expression] = STATE(1715),
    [sym__high_prec_app] = STATE(1728),
    [sym__low_prec_app] = STATE(1728),
    [sym_application_expression] = STATE(1715),
    [sym_dot_expression] = STATE(1715),
    [sym_infix_expression] = STATE(1715),
    [sym_ce_expression] = STATE(1715),
    [sym_sequential_expression] = STATE(1715),
    [sym_char] = STATE(1858),
    [sym_format_string] = STATE(1853),
    [sym__string_literal] = STATE(1853),
    [sym_string] = STATE(1858),
    [sym_verbatim_string] = STATE(1858),
    [sym_bytearray] = STATE(1858),
    [sym_verbatim_bytearray] = STATE(1858),
    [sym_format_triple_quoted_string] = STATE(1851),
    [sym_triple_quoted_string] = STATE(1858),
    [sym_const] = STATE(1715),
    [sym_long_identifier] = STATE(1825),
    [sym_active_pattern] = STATE(1754),
    [sym__identifier_or_op] = STATE(1822),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(940),
    [sym_infix_op] = STATE(1154),
    [sym_sbyte] = STATE(1858),
    [sym_byte] = STATE(1858),
    [sym_int16] = STATE(1858),
    [sym_uint16] = STATE(1858),
    [sym_int32] = STATE(1858),
    [sym_uint32] = STATE(1858),
    [sym_nativeint] = STATE(1858),
    [sym_unativeint] = STATE(1858),
    [sym_int64] = STATE(1858),
    [sym_uint64] = STATE(1858),
    [sym_ieee32] = STATE(1858),
    [sym_ieee64] = STATE(1858),
    [sym_bignum] = STATE(1858),
    [sym_decimal] = STATE(1858),
    [sym_float] = STATE(1552),
    [sym_block_comment] = STATE(34),
    [sym_compiler_directive_decl] = STATE(34),
    [sym_fsi_directive_decl] = STATE(34),
    [sym_preproc_line] = STATE(34),
    [sym_preproc_if_in_expression] = STATE(1715),
    [aux_sym_sequential_expression_repeat1] = STATE(1594),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_EQ] = ACTIONS(223),
    [anon_sym_LBRACK_LT] = ACTIONS(223),
    [anon_sym_COLON] = ACTIONS(225),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_do] = ACTIONS(225),
    [anon_sym_and] = ACTIONS(225),
    [anon_sym_let] = ACTIONS(225),
    [anon_sym_let_BANG] = ACTIONS(223),
    [aux_sym_access_modifier_token1] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_COMMA] = ACTIONS(223),
    [anon_sym_null] = ACTIONS(225),
    [anon_sym_QMARK] = ACTIONS(225),
    [anon_sym_COLON_QMARK] = ACTIONS(225),
    [anon_sym_COLON_COLON] = ACTIONS(223),
    [anon_sym_AMP] = ACTIONS(225),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LBRACK_PIPE] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(225),
    [anon_sym_LT_AT] = ACTIONS(225),
    [anon_sym_LT_AT_AT] = ACTIONS(225),
    [anon_sym_DOT] = ACTIONS(401),
    [anon_sym_LBRACE_PIPE] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(225),
    [anon_sym_with] = ACTIONS(225),
    [anon_sym_return_BANG] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(225),
    [anon_sym_yield_BANG] = ACTIONS(223),
    [anon_sym_lazy] = ACTIONS(225),
    [anon_sym_assert] = ACTIONS(225),
    [anon_sym_upcast] = ACTIONS(225),
    [anon_sym_downcast] = ACTIONS(225),
    [anon_sym_COLON_GT] = ACTIONS(223),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(223),
    [anon_sym_for] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_fun] = ACTIONS(225),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_match] = ACTIONS(225),
    [anon_sym_match_BANG] = ACTIONS(223),
    [anon_sym_function] = ACTIONS(225),
    [anon_sym_LT_DASH] = ACTIONS(225),
    [anon_sym_DOT_LBRACK] = ACTIONS(425),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_use] = ACTIONS(225),
    [anon_sym_use_BANG] = ACTIONS(223),
    [anon_sym_do_BANG] = ACTIONS(223),
    [anon_sym_begin] = ACTIONS(225),
    [anon_sym_LPAREN2] = ACTIONS(437),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_or] = ACTIONS(225),
    [anon_sym_static] = ACTIONS(225),
    [anon_sym_member] = ACTIONS(225),
    [anon_sym_interface] = ACTIONS(225),
    [anon_sym_abstract] = ACTIONS(225),
    [anon_sym_val] = ACTIONS(225),
    [anon_sym_override] = ACTIONS(225),
    [aux_sym_char_token1] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_AT_DQUOTE] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [sym_bool] = ACTIONS(225),
    [sym_unit] = ACTIONS(453),
    [anon_sym_LPAREN_PIPE] = ACTIONS(225),
    [sym_op_identifier] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(225),
    [anon_sym_DASH] = ACTIONS(225),
    [anon_sym_PLUS_DOT] = ACTIONS(225),
    [anon_sym_DASH_DOT] = ACTIONS(225),
    [anon_sym_PERCENT] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_TILDE] = ACTIONS(223),
    [aux_sym_prefix_op_token1] = ACTIONS(225),
    [aux_sym_infix_op_token1] = ACTIONS(223),
    [aux_sym_infix_op_token2] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_BANG_EQ] = ACTIONS(225),
    [anon_sym_COLON_EQ] = ACTIONS(223),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(225),
    [sym_int] = ACTIONS(225),
    [sym_xint] = ACTIONS(223),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(223),
    [anon_sym_POUNDendif] = ACTIONS(223),
    [anon_sym_POUNDelse] = ACTIONS(223),
    [sym__newline] = ACTIONS(223),
  },
  [35] = {
    [sym_function_or_value_defn] = STATE(1163),
    [sym__expression] = STATE(34),
    [sym_literal_expression] = STATE(1715),
    [sym_long_identifier_or_op] = STATE(1715),
    [sym_tuple_expression] = STATE(1715),
    [sym_brace_expression] = STATE(1715),
    [sym_anon_record_expression] = STATE(1715),
    [sym_prefixed_expression] = STATE(1715),
    [sym_typecast_expression] = STATE(1715),
    [sym_for_expression] = STATE(1715),
    [sym_while_expression] = STATE(1715),
    [sym__if_branch] = STATE(10853),
    [sym_if_expression] = STATE(1715),
    [sym_fun_expression] = STATE(1715),
    [sym_try_expression] = STATE(1715),
    [sym_match_expression] = STATE(1715),
    [sym_function_expression] = STATE(1715),
    [sym_mutate_expression] = STATE(1715),
    [sym_index_expression] = STATE(1715),
    [sym_typed_expression] = STATE(1715),
    [sym_declaration_expression] = STATE(1715),
    [sym_do_expression] = STATE(1715),
    [sym_list_expression] = STATE(1715),
    [sym_array_expression] = STATE(1715),
    [sym_begin_end_expression] = STATE(1715),
    [sym_paren_expression] = STATE(1715),
    [sym__high_prec_app] = STATE(1728),
    [sym__low_prec_app] = STATE(1728),
    [sym_application_expression] = STATE(1715),
    [sym_dot_expression] = STATE(1715),
    [sym_infix_expression] = STATE(1715),
    [sym_ce_expression] = STATE(1715),
    [sym_sequential_expression] = STATE(1715),
    [sym_char] = STATE(1858),
    [sym_format_string] = STATE(1853),
    [sym__string_literal] = STATE(1853),
    [sym_string] = STATE(1858),
    [sym_verbatim_string] = STATE(1858),
    [sym_bytearray] = STATE(1858),
    [sym_verbatim_bytearray] = STATE(1858),
    [sym_format_triple_quoted_string] = STATE(1851),
    [sym_triple_quoted_string] = STATE(1858),
    [sym_const] = STATE(1715),
    [sym_long_identifier] = STATE(1825),
    [sym_active_pattern] = STATE(1754),
    [sym__identifier_or_op] = STATE(1822),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(940),
    [sym_infix_op] = STATE(1154),
    [sym_sbyte] = STATE(1858),
    [sym_byte] = STATE(1858),
    [sym_int16] = STATE(1858),
    [sym_uint16] = STATE(1858),
    [sym_int32] = STATE(1858),
    [sym_uint32] = STATE(1858),
    [sym_nativeint] = STATE(1858),
    [sym_unativeint] = STATE(1858),
    [sym_int64] = STATE(1858),
    [sym_uint64] = STATE(1858),
    [sym_ieee32] = STATE(1858),
    [sym_ieee64] = STATE(1858),
    [sym_bignum] = STATE(1858),
    [sym_decimal] = STATE(1858),
    [sym_float] = STATE(1552),
    [sym_block_comment] = STATE(35),
    [sym_compiler_directive_decl] = STATE(35),
    [sym_fsi_directive_decl] = STATE(35),
    [sym_preproc_line] = STATE(35),
    [sym_preproc_if_in_expression] = STATE(1715),
    [aux_sym_sequential_expression_repeat1] = STATE(1594),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_do] = ACTIONS(239),
    [anon_sym_and] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(239),
    [anon_sym_let_BANG] = ACTIONS(237),
    [aux_sym_access_modifier_token1] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(387),
    [anon_sym_null] = ACTIONS(389),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(379),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_LBRACK_PIPE] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_LT_AT] = ACTIONS(397),
    [anon_sym_LT_AT_AT] = ACTIONS(399),
    [anon_sym_DOT] = ACTIONS(401),
    [anon_sym_LBRACE_PIPE] = ACTIONS(403),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_with] = ACTIONS(467),
    [anon_sym_return_BANG] = ACTIONS(405),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_yield_BANG] = ACTIONS(405),
    [anon_sym_lazy] = ACTIONS(381),
    [anon_sym_assert] = ACTIONS(381),
    [anon_sym_upcast] = ACTIONS(381),
    [anon_sym_downcast] = ACTIONS(381),
    [anon_sym_COLON_GT] = ACTIONS(407),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(407),
    [anon_sym_for] = ACTIONS(409),
    [anon_sym_while] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(413),
    [anon_sym_try] = ACTIONS(415),
    [anon_sym_match] = ACTIONS(417),
    [anon_sym_match_BANG] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(421),
    [anon_sym_LT_DASH] = ACTIONS(423),
    [anon_sym_DOT_LBRACK] = ACTIONS(425),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_use] = ACTIONS(429),
    [anon_sym_use_BANG] = ACTIONS(431),
    [anon_sym_do_BANG] = ACTIONS(433),
    [anon_sym_begin] = ACTIONS(435),
    [anon_sym_LPAREN2] = ACTIONS(437),
    [anon_sym_default] = ACTIONS(239),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(239),
    [anon_sym_member] = ACTIONS(239),
    [anon_sym_interface] = ACTIONS(239),
    [anon_sym_abstract] = ACTIONS(239),
    [anon_sym_val] = ACTIONS(239),
    [anon_sym_override] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(439),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(443),
    [anon_sym_AT_DQUOTE] = ACTIONS(445),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(447),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(449),
    [sym_bool] = ACTIONS(451),
    [sym_unit] = ACTIONS(453),
    [anon_sym_LPAREN_PIPE] = ACTIONS(455),
    [sym_op_identifier] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(459),
    [sym_xint] = ACTIONS(461),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(237),
    [anon_sym_POUNDendif] = ACTIONS(237),
    [anon_sym_POUNDelse] = ACTIONS(237),
    [sym__newline] = ACTIONS(465),
  },
  [36] = {
    [sym_function_or_value_defn] = STATE(1163),
    [sym__expression] = STATE(34),
    [sym_literal_expression] = STATE(1715),
    [sym_long_identifier_or_op] = STATE(1715),
    [sym_tuple_expression] = STATE(1715),
    [sym_brace_expression] = STATE(1715),
    [sym_anon_record_expression] = STATE(1715),
    [sym_prefixed_expression] = STATE(1715),
    [sym_typecast_expression] = STATE(1715),
    [sym_for_expression] = STATE(1715),
    [sym_while_expression] = STATE(1715),
    [sym__if_branch] = STATE(10853),
    [sym_if_expression] = STATE(1715),
    [sym_fun_expression] = STATE(1715),
    [sym_try_expression] = STATE(1715),
    [sym_match_expression] = STATE(1715),
    [sym_function_expression] = STATE(1715),
    [sym_mutate_expression] = STATE(1715),
    [sym_index_expression] = STATE(1715),
    [sym_typed_expression] = STATE(1715),
    [sym_declaration_expression] = STATE(1715),
    [sym_do_expression] = STATE(1715),
    [sym_list_expression] = STATE(1715),
    [sym_array_expression] = STATE(1715),
    [sym_begin_end_expression] = STATE(1715),
    [sym_paren_expression] = STATE(1715),
    [sym__high_prec_app] = STATE(1728),
    [sym__low_prec_app] = STATE(1728),
    [sym_application_expression] = STATE(1715),
    [sym_dot_expression] = STATE(1715),
    [sym_infix_expression] = STATE(1715),
    [sym_ce_expression] = STATE(1715),
    [sym_sequential_expression] = STATE(1715),
    [sym_char] = STATE(1858),
    [sym_format_string] = STATE(1853),
    [sym__string_literal] = STATE(1853),
    [sym_string] = STATE(1858),
    [sym_verbatim_string] = STATE(1858),
    [sym_bytearray] = STATE(1858),
    [sym_verbatim_bytearray] = STATE(1858),
    [sym_format_triple_quoted_string] = STATE(1851),
    [sym_triple_quoted_string] = STATE(1858),
    [sym_const] = STATE(1715),
    [sym_long_identifier] = STATE(1825),
    [sym_active_pattern] = STATE(1754),
    [sym__identifier_or_op] = STATE(1822),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(940),
    [sym_infix_op] = STATE(1154),
    [sym_sbyte] = STATE(1858),
    [sym_byte] = STATE(1858),
    [sym_int16] = STATE(1858),
    [sym_uint16] = STATE(1858),
    [sym_int32] = STATE(1858),
    [sym_uint32] = STATE(1858),
    [sym_nativeint] = STATE(1858),
    [sym_unativeint] = STATE(1858),
    [sym_int64] = STATE(1858),
    [sym_uint64] = STATE(1858),
    [sym_ieee32] = STATE(1858),
    [sym_ieee64] = STATE(1858),
    [sym_bignum] = STATE(1858),
    [sym_decimal] = STATE(1858),
    [sym_float] = STATE(1552),
    [sym_block_comment] = STATE(36),
    [sym_compiler_directive_decl] = STATE(36),
    [sym_fsi_directive_decl] = STATE(36),
    [sym_preproc_line] = STATE(36),
    [sym_preproc_if_in_expression] = STATE(1715),
    [aux_sym_sequential_expression_repeat1] = STATE(1594),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(243),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_do] = ACTIONS(383),
    [anon_sym_and] = ACTIONS(245),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(387),
    [anon_sym_null] = ACTIONS(389),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(379),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_LBRACK_PIPE] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_LT_AT] = ACTIONS(397),
    [anon_sym_LT_AT_AT] = ACTIONS(399),
    [anon_sym_DOT] = ACTIONS(401),
    [anon_sym_LBRACE_PIPE] = ACTIONS(403),
    [anon_sym_new] = ACTIONS(381),
    [anon_sym_with] = ACTIONS(245),
    [anon_sym_return_BANG] = ACTIONS(405),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_yield_BANG] = ACTIONS(405),
    [anon_sym_lazy] = ACTIONS(381),
    [anon_sym_assert] = ACTIONS(381),
    [anon_sym_upcast] = ACTIONS(381),
    [anon_sym_downcast] = ACTIONS(381),
    [anon_sym_COLON_GT] = ACTIONS(407),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(407),
    [anon_sym_for] = ACTIONS(409),
    [anon_sym_while] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(413),
    [anon_sym_try] = ACTIONS(415),
    [anon_sym_match] = ACTIONS(417),
    [anon_sym_match_BANG] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(421),
    [anon_sym_LT_DASH] = ACTIONS(423),
    [anon_sym_DOT_LBRACK] = ACTIONS(425),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_use] = ACTIONS(429),
    [anon_sym_use_BANG] = ACTIONS(431),
    [anon_sym_do_BANG] = ACTIONS(433),
    [anon_sym_begin] = ACTIONS(435),
    [anon_sym_LPAREN2] = ACTIONS(437),
    [anon_sym_default] = ACTIONS(245),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_member] = ACTIONS(245),
    [anon_sym_interface] = ACTIONS(245),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_val] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(439),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(443),
    [anon_sym_AT_DQUOTE] = ACTIONS(445),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(447),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(449),
    [sym_bool] = ACTIONS(451),
    [sym_unit] = ACTIONS(453),
    [anon_sym_LPAREN_PIPE] = ACTIONS(455),
    [sym_op_identifier] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(459),
    [sym_xint] = ACTIONS(461),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(463),
    [anon_sym_POUNDendif] = ACTIONS(243),
    [anon_sym_POUNDelse] = ACTIONS(243),
    [sym__newline] = ACTIONS(243),
  },
  [37] = {
    [sym_function_or_value_defn] = STATE(953),
    [sym__expression] = STATE(37),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(942),
    [sym_infix_op] = STATE(913),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(1568),
    [sym_block_comment] = STATE(37),
    [sym_compiler_directive_decl] = STATE(37),
    [sym_fsi_directive_decl] = STATE(37),
    [sym_preproc_line] = STATE(37),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_sequential_expression_repeat1] = STATE(1650),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_EQ] = ACTIONS(223),
    [anon_sym_LBRACK_LT] = ACTIONS(223),
    [anon_sym_COLON] = ACTIONS(225),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_do] = ACTIONS(225),
    [anon_sym_let] = ACTIONS(225),
    [anon_sym_let_BANG] = ACTIONS(223),
    [aux_sym_access_modifier_token1] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_COMMA] = ACTIONS(223),
    [anon_sym_null] = ACTIONS(225),
    [anon_sym_QMARK] = ACTIONS(225),
    [anon_sym_COLON_QMARK] = ACTIONS(225),
    [anon_sym_COLON_COLON] = ACTIONS(223),
    [anon_sym_AMP] = ACTIONS(225),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LBRACK_PIPE] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(225),
    [anon_sym_LT_AT] = ACTIONS(225),
    [anon_sym_LT_AT_AT] = ACTIONS(225),
    [anon_sym_DOT] = ACTIONS(311),
    [anon_sym_LBRACE_PIPE] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(225),
    [anon_sym_with] = ACTIONS(225),
    [anon_sym_return_BANG] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(225),
    [anon_sym_yield_BANG] = ACTIONS(223),
    [anon_sym_lazy] = ACTIONS(225),
    [anon_sym_assert] = ACTIONS(225),
    [anon_sym_upcast] = ACTIONS(225),
    [anon_sym_downcast] = ACTIONS(225),
    [anon_sym_COLON_GT] = ACTIONS(223),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(223),
    [anon_sym_for] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_fun] = ACTIONS(225),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_match] = ACTIONS(225),
    [anon_sym_match_BANG] = ACTIONS(223),
    [anon_sym_function] = ACTIONS(225),
    [anon_sym_LT_DASH] = ACTIONS(225),
    [anon_sym_DOT_LBRACK] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_use] = ACTIONS(225),
    [anon_sym_use_BANG] = ACTIONS(223),
    [anon_sym_do_BANG] = ACTIONS(223),
    [anon_sym_begin] = ACTIONS(225),
    [anon_sym_LPAREN2] = ACTIONS(347),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_or] = ACTIONS(225),
    [anon_sym_static] = ACTIONS(225),
    [anon_sym_member] = ACTIONS(225),
    [anon_sym_interface] = ACTIONS(225),
    [anon_sym_abstract] = ACTIONS(225),
    [anon_sym_val] = ACTIONS(225),
    [anon_sym_override] = ACTIONS(225),
    [anon_sym_inherit] = ACTIONS(225),
    [aux_sym_char_token1] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_AT_DQUOTE] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [sym_bool] = ACTIONS(225),
    [sym_unit] = ACTIONS(363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(225),
    [sym_op_identifier] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(225),
    [anon_sym_DASH] = ACTIONS(225),
    [anon_sym_PLUS_DOT] = ACTIONS(225),
    [anon_sym_DASH_DOT] = ACTIONS(225),
    [anon_sym_PERCENT] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_TILDE] = ACTIONS(223),
    [aux_sym_prefix_op_token1] = ACTIONS(225),
    [aux_sym_infix_op_token1] = ACTIONS(223),
    [aux_sym_infix_op_token2] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_BANG_EQ] = ACTIONS(225),
    [anon_sym_COLON_EQ] = ACTIONS(223),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(225),
    [sym_int] = ACTIONS(225),
    [sym_xint] = ACTIONS(223),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(223),
    [anon_sym_POUNDendif] = ACTIONS(223),
    [anon_sym_POUNDelse] = ACTIONS(223),
    [sym__newline] = ACTIONS(223),
  },
  [38] = {
    [sym_function_or_value_defn] = STATE(1163),
    [sym__expression] = STATE(34),
    [sym_literal_expression] = STATE(1715),
    [sym_long_identifier_or_op] = STATE(1715),
    [sym_tuple_expression] = STATE(1715),
    [sym_brace_expression] = STATE(1715),
    [sym_anon_record_expression] = STATE(1715),
    [sym_prefixed_expression] = STATE(1715),
    [sym_typecast_expression] = STATE(1715),
    [sym_for_expression] = STATE(1715),
    [sym_while_expression] = STATE(1715),
    [sym__if_branch] = STATE(10853),
    [sym_if_expression] = STATE(1715),
    [sym_fun_expression] = STATE(1715),
    [sym_try_expression] = STATE(1715),
    [sym_match_expression] = STATE(1715),
    [sym_function_expression] = STATE(1715),
    [sym_mutate_expression] = STATE(1715),
    [sym_index_expression] = STATE(1715),
    [sym_typed_expression] = STATE(1715),
    [sym_declaration_expression] = STATE(1715),
    [sym_do_expression] = STATE(1715),
    [sym_list_expression] = STATE(1715),
    [sym_array_expression] = STATE(1715),
    [sym_begin_end_expression] = STATE(1715),
    [sym_paren_expression] = STATE(1715),
    [sym__high_prec_app] = STATE(1728),
    [sym__low_prec_app] = STATE(1728),
    [sym_application_expression] = STATE(1715),
    [sym_dot_expression] = STATE(1715),
    [sym_infix_expression] = STATE(1715),
    [sym_ce_expression] = STATE(1715),
    [sym_sequential_expression] = STATE(1715),
    [sym_char] = STATE(1858),
    [sym_format_string] = STATE(1853),
    [sym__string_literal] = STATE(1853),
    [sym_string] = STATE(1858),
    [sym_verbatim_string] = STATE(1858),
    [sym_bytearray] = STATE(1858),
    [sym_verbatim_bytearray] = STATE(1858),
    [sym_format_triple_quoted_string] = STATE(1851),
    [sym_triple_quoted_string] = STATE(1858),
    [sym_const] = STATE(1715),
    [sym_long_identifier] = STATE(1825),
    [sym_active_pattern] = STATE(1754),
    [sym__identifier_or_op] = STATE(1822),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(940),
    [sym_infix_op] = STATE(1154),
    [sym_sbyte] = STATE(1858),
    [sym_byte] = STATE(1858),
    [sym_int16] = STATE(1858),
    [sym_uint16] = STATE(1858),
    [sym_int32] = STATE(1858),
    [sym_uint32] = STATE(1858),
    [sym_nativeint] = STATE(1858),
    [sym_unativeint] = STATE(1858),
    [sym_int64] = STATE(1858),
    [sym_uint64] = STATE(1858),
    [sym_ieee32] = STATE(1858),
    [sym_ieee64] = STATE(1858),
    [sym_bignum] = STATE(1858),
    [sym_decimal] = STATE(1858),
    [sym_float] = STATE(1552),
    [sym_block_comment] = STATE(38),
    [sym_compiler_directive_decl] = STATE(38),
    [sym_fsi_directive_decl] = STATE(38),
    [sym_preproc_line] = STATE(38),
    [sym_preproc_if_in_expression] = STATE(1715),
    [aux_sym_sequential_expression_repeat1] = STATE(1594),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(253),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_do] = ACTIONS(383),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(387),
    [anon_sym_null] = ACTIONS(389),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(379),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_LBRACK_PIPE] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(255),
    [anon_sym_LT_AT] = ACTIONS(397),
    [anon_sym_LT_AT_AT] = ACTIONS(399),
    [anon_sym_DOT] = ACTIONS(401),
    [anon_sym_LBRACE_PIPE] = ACTIONS(403),
    [anon_sym_new] = ACTIONS(381),
    [anon_sym_with] = ACTIONS(255),
    [anon_sym_return_BANG] = ACTIONS(405),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_yield_BANG] = ACTIONS(405),
    [anon_sym_lazy] = ACTIONS(381),
    [anon_sym_assert] = ACTIONS(381),
    [anon_sym_upcast] = ACTIONS(381),
    [anon_sym_downcast] = ACTIONS(381),
    [anon_sym_COLON_GT] = ACTIONS(407),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(407),
    [anon_sym_for] = ACTIONS(409),
    [anon_sym_while] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(413),
    [anon_sym_try] = ACTIONS(415),
    [anon_sym_match] = ACTIONS(417),
    [anon_sym_match_BANG] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(421),
    [anon_sym_LT_DASH] = ACTIONS(423),
    [anon_sym_DOT_LBRACK] = ACTIONS(425),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_use] = ACTIONS(429),
    [anon_sym_use_BANG] = ACTIONS(431),
    [anon_sym_do_BANG] = ACTIONS(433),
    [anon_sym_begin] = ACTIONS(435),
    [anon_sym_LPAREN2] = ACTIONS(437),
    [anon_sym_default] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(255),
    [anon_sym_member] = ACTIONS(255),
    [anon_sym_interface] = ACTIONS(255),
    [anon_sym_abstract] = ACTIONS(255),
    [anon_sym_val] = ACTIONS(255),
    [anon_sym_override] = ACTIONS(255),
    [aux_sym_char_token1] = ACTIONS(439),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(443),
    [anon_sym_AT_DQUOTE] = ACTIONS(445),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(447),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(449),
    [sym_bool] = ACTIONS(451),
    [sym_unit] = ACTIONS(453),
    [anon_sym_LPAREN_PIPE] = ACTIONS(455),
    [sym_op_identifier] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(459),
    [sym_xint] = ACTIONS(461),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(463),
    [anon_sym_POUNDendif] = ACTIONS(253),
    [anon_sym_POUNDelse] = ACTIONS(253),
    [sym__newline] = ACTIONS(253),
  },
  [39] = {
    [sym_function_or_value_defn] = STATE(953),
    [sym__expression] = STATE(37),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(942),
    [sym_infix_op] = STATE(913),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(1568),
    [sym_block_comment] = STATE(39),
    [sym_compiler_directive_decl] = STATE(39),
    [sym_fsi_directive_decl] = STATE(39),
    [sym_preproc_line] = STATE(39),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_sequential_expression_repeat1] = STATE(1650),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(247),
    [anon_sym_COLON] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_do] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(249),
    [anon_sym_let_BANG] = ACTIONS(247),
    [aux_sym_access_modifier_token1] = ACTIONS(247),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(289),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(309),
    [anon_sym_DOT] = ACTIONS(311),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(249),
    [anon_sym_with] = ACTIONS(249),
    [anon_sym_return_BANG] = ACTIONS(315),
    [anon_sym_yield] = ACTIONS(291),
    [anon_sym_yield_BANG] = ACTIONS(315),
    [anon_sym_lazy] = ACTIONS(291),
    [anon_sym_assert] = ACTIONS(291),
    [anon_sym_upcast] = ACTIONS(291),
    [anon_sym_downcast] = ACTIONS(291),
    [anon_sym_COLON_GT] = ACTIONS(317),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_LT_DASH] = ACTIONS(333),
    [anon_sym_DOT_LBRACK] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_use] = ACTIONS(339),
    [anon_sym_use_BANG] = ACTIONS(341),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [anon_sym_LPAREN2] = ACTIONS(347),
    [anon_sym_default] = ACTIONS(249),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(249),
    [anon_sym_member] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(249),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_val] = ACTIONS(249),
    [anon_sym_override] = ACTIONS(249),
    [anon_sym_inherit] = ACTIONS(249),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(369),
    [sym_xint] = ACTIONS(371),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(247),
    [anon_sym_POUNDendif] = ACTIONS(247),
    [anon_sym_POUNDelse] = ACTIONS(247),
    [sym__newline] = ACTIONS(247),
  },
  [40] = {
    [sym_function_or_value_defn] = STATE(1163),
    [sym__expression] = STATE(34),
    [sym_literal_expression] = STATE(1715),
    [sym_long_identifier_or_op] = STATE(1715),
    [sym_tuple_expression] = STATE(1715),
    [sym_brace_expression] = STATE(1715),
    [sym_anon_record_expression] = STATE(1715),
    [sym_prefixed_expression] = STATE(1715),
    [sym_typecast_expression] = STATE(1715),
    [sym_for_expression] = STATE(1715),
    [sym_while_expression] = STATE(1715),
    [sym__if_branch] = STATE(10853),
    [sym_if_expression] = STATE(1715),
    [sym_fun_expression] = STATE(1715),
    [sym_try_expression] = STATE(1715),
    [sym_match_expression] = STATE(1715),
    [sym_function_expression] = STATE(1715),
    [sym_mutate_expression] = STATE(1715),
    [sym_index_expression] = STATE(1715),
    [sym_typed_expression] = STATE(1715),
    [sym_declaration_expression] = STATE(1715),
    [sym_do_expression] = STATE(1715),
    [sym_list_expression] = STATE(1715),
    [sym_array_expression] = STATE(1715),
    [sym_begin_end_expression] = STATE(1715),
    [sym_paren_expression] = STATE(1715),
    [sym__high_prec_app] = STATE(1728),
    [sym__low_prec_app] = STATE(1728),
    [sym_application_expression] = STATE(1715),
    [sym_dot_expression] = STATE(1715),
    [sym_infix_expression] = STATE(1715),
    [sym_ce_expression] = STATE(1715),
    [sym_sequential_expression] = STATE(1715),
    [sym_char] = STATE(1858),
    [sym_format_string] = STATE(1853),
    [sym__string_literal] = STATE(1853),
    [sym_string] = STATE(1858),
    [sym_verbatim_string] = STATE(1858),
    [sym_bytearray] = STATE(1858),
    [sym_verbatim_bytearray] = STATE(1858),
    [sym_format_triple_quoted_string] = STATE(1851),
    [sym_triple_quoted_string] = STATE(1858),
    [sym_const] = STATE(1715),
    [sym_long_identifier] = STATE(1825),
    [sym_active_pattern] = STATE(1754),
    [sym__identifier_or_op] = STATE(1822),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(940),
    [sym_infix_op] = STATE(1154),
    [sym_sbyte] = STATE(1858),
    [sym_byte] = STATE(1858),
    [sym_int16] = STATE(1858),
    [sym_uint16] = STATE(1858),
    [sym_int32] = STATE(1858),
    [sym_uint32] = STATE(1858),
    [sym_nativeint] = STATE(1858),
    [sym_unativeint] = STATE(1858),
    [sym_int64] = STATE(1858),
    [sym_uint64] = STATE(1858),
    [sym_ieee32] = STATE(1858),
    [sym_ieee64] = STATE(1858),
    [sym_bignum] = STATE(1858),
    [sym_decimal] = STATE(1858),
    [sym_float] = STATE(1552),
    [sym_block_comment] = STATE(40),
    [sym_compiler_directive_decl] = STATE(40),
    [sym_fsi_directive_decl] = STATE(40),
    [sym_preproc_line] = STATE(40),
    [sym_preproc_if_in_expression] = STATE(1715),
    [aux_sym_sequential_expression_repeat1] = STATE(1594),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_do] = ACTIONS(383),
    [anon_sym_and] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(257),
    [anon_sym_LPAREN] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(387),
    [anon_sym_null] = ACTIONS(389),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(379),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_LBRACK_PIPE] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(259),
    [anon_sym_LT_AT] = ACTIONS(397),
    [anon_sym_LT_AT_AT] = ACTIONS(399),
    [anon_sym_DOT] = ACTIONS(401),
    [anon_sym_LBRACE_PIPE] = ACTIONS(403),
    [anon_sym_new] = ACTIONS(381),
    [anon_sym_with] = ACTIONS(259),
    [anon_sym_return_BANG] = ACTIONS(405),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_yield_BANG] = ACTIONS(405),
    [anon_sym_lazy] = ACTIONS(381),
    [anon_sym_assert] = ACTIONS(381),
    [anon_sym_upcast] = ACTIONS(381),
    [anon_sym_downcast] = ACTIONS(381),
    [anon_sym_COLON_GT] = ACTIONS(407),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(407),
    [anon_sym_for] = ACTIONS(409),
    [anon_sym_while] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(413),
    [anon_sym_try] = ACTIONS(415),
    [anon_sym_match] = ACTIONS(417),
    [anon_sym_match_BANG] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(421),
    [anon_sym_LT_DASH] = ACTIONS(423),
    [anon_sym_DOT_LBRACK] = ACTIONS(425),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_use] = ACTIONS(429),
    [anon_sym_use_BANG] = ACTIONS(431),
    [anon_sym_do_BANG] = ACTIONS(433),
    [anon_sym_begin] = ACTIONS(435),
    [anon_sym_LPAREN2] = ACTIONS(437),
    [anon_sym_default] = ACTIONS(259),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(259),
    [anon_sym_member] = ACTIONS(259),
    [anon_sym_interface] = ACTIONS(259),
    [anon_sym_abstract] = ACTIONS(259),
    [anon_sym_val] = ACTIONS(259),
    [anon_sym_override] = ACTIONS(259),
    [aux_sym_char_token1] = ACTIONS(439),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(443),
    [anon_sym_AT_DQUOTE] = ACTIONS(445),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(447),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(449),
    [sym_bool] = ACTIONS(451),
    [sym_unit] = ACTIONS(453),
    [anon_sym_LPAREN_PIPE] = ACTIONS(455),
    [sym_op_identifier] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(459),
    [sym_xint] = ACTIONS(461),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(463),
    [anon_sym_POUNDendif] = ACTIONS(257),
    [anon_sym_POUNDelse] = ACTIONS(257),
    [sym__newline] = ACTIONS(257),
  },
  [41] = {
    [sym_function_or_value_defn] = STATE(1163),
    [sym__expression] = STATE(34),
    [sym_literal_expression] = STATE(1715),
    [sym_long_identifier_or_op] = STATE(1715),
    [sym_tuple_expression] = STATE(1715),
    [sym_brace_expression] = STATE(1715),
    [sym_anon_record_expression] = STATE(1715),
    [sym_prefixed_expression] = STATE(1715),
    [sym_typecast_expression] = STATE(1715),
    [sym_for_expression] = STATE(1715),
    [sym_while_expression] = STATE(1715),
    [sym__if_branch] = STATE(10853),
    [sym_if_expression] = STATE(1715),
    [sym_fun_expression] = STATE(1715),
    [sym_try_expression] = STATE(1715),
    [sym_match_expression] = STATE(1715),
    [sym_function_expression] = STATE(1715),
    [sym_mutate_expression] = STATE(1715),
    [sym_index_expression] = STATE(1715),
    [sym_typed_expression] = STATE(1715),
    [sym_declaration_expression] = STATE(1715),
    [sym_do_expression] = STATE(1715),
    [sym_list_expression] = STATE(1715),
    [sym_array_expression] = STATE(1715),
    [sym_begin_end_expression] = STATE(1715),
    [sym_paren_expression] = STATE(1715),
    [sym__high_prec_app] = STATE(1728),
    [sym__low_prec_app] = STATE(1728),
    [sym_application_expression] = STATE(1715),
    [sym_dot_expression] = STATE(1715),
    [sym_infix_expression] = STATE(1715),
    [sym_ce_expression] = STATE(1715),
    [sym_sequential_expression] = STATE(1715),
    [sym_char] = STATE(1858),
    [sym_format_string] = STATE(1853),
    [sym__string_literal] = STATE(1853),
    [sym_string] = STATE(1858),
    [sym_verbatim_string] = STATE(1858),
    [sym_bytearray] = STATE(1858),
    [sym_verbatim_bytearray] = STATE(1858),
    [sym_format_triple_quoted_string] = STATE(1851),
    [sym_triple_quoted_string] = STATE(1858),
    [sym_const] = STATE(1715),
    [sym_long_identifier] = STATE(1825),
    [sym_active_pattern] = STATE(1754),
    [sym__identifier_or_op] = STATE(1822),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(940),
    [sym_infix_op] = STATE(1154),
    [sym_sbyte] = STATE(1858),
    [sym_byte] = STATE(1858),
    [sym_int16] = STATE(1858),
    [sym_uint16] = STATE(1858),
    [sym_int32] = STATE(1858),
    [sym_uint32] = STATE(1858),
    [sym_nativeint] = STATE(1858),
    [sym_unativeint] = STATE(1858),
    [sym_int64] = STATE(1858),
    [sym_uint64] = STATE(1858),
    [sym_ieee32] = STATE(1858),
    [sym_ieee64] = STATE(1858),
    [sym_bignum] = STATE(1858),
    [sym_decimal] = STATE(1858),
    [sym_float] = STATE(1552),
    [sym_block_comment] = STATE(41),
    [sym_compiler_directive_decl] = STATE(41),
    [sym_fsi_directive_decl] = STATE(41),
    [sym_preproc_line] = STATE(41),
    [sym_preproc_if_in_expression] = STATE(1715),
    [aux_sym_sequential_expression_repeat1] = STATE(1594),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(261),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_do] = ACTIONS(383),
    [anon_sym_and] = ACTIONS(263),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(261),
    [anon_sym_LPAREN] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(387),
    [anon_sym_null] = ACTIONS(389),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(379),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_LBRACK_PIPE] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_LT_AT] = ACTIONS(397),
    [anon_sym_LT_AT_AT] = ACTIONS(399),
    [anon_sym_DOT] = ACTIONS(401),
    [anon_sym_LBRACE_PIPE] = ACTIONS(403),
    [anon_sym_new] = ACTIONS(381),
    [anon_sym_with] = ACTIONS(263),
    [anon_sym_return_BANG] = ACTIONS(405),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_yield_BANG] = ACTIONS(405),
    [anon_sym_lazy] = ACTIONS(381),
    [anon_sym_assert] = ACTIONS(381),
    [anon_sym_upcast] = ACTIONS(381),
    [anon_sym_downcast] = ACTIONS(381),
    [anon_sym_COLON_GT] = ACTIONS(407),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(407),
    [anon_sym_for] = ACTIONS(409),
    [anon_sym_while] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(413),
    [anon_sym_try] = ACTIONS(415),
    [anon_sym_match] = ACTIONS(417),
    [anon_sym_match_BANG] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(421),
    [anon_sym_LT_DASH] = ACTIONS(423),
    [anon_sym_DOT_LBRACK] = ACTIONS(425),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_use] = ACTIONS(429),
    [anon_sym_use_BANG] = ACTIONS(431),
    [anon_sym_do_BANG] = ACTIONS(433),
    [anon_sym_begin] = ACTIONS(435),
    [anon_sym_LPAREN2] = ACTIONS(437),
    [anon_sym_default] = ACTIONS(263),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(263),
    [anon_sym_member] = ACTIONS(263),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_abstract] = ACTIONS(263),
    [anon_sym_val] = ACTIONS(263),
    [anon_sym_override] = ACTIONS(263),
    [aux_sym_char_token1] = ACTIONS(439),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(443),
    [anon_sym_AT_DQUOTE] = ACTIONS(445),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(447),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(449),
    [sym_bool] = ACTIONS(451),
    [sym_unit] = ACTIONS(453),
    [anon_sym_LPAREN_PIPE] = ACTIONS(455),
    [sym_op_identifier] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(459),
    [sym_xint] = ACTIONS(461),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(463),
    [anon_sym_POUNDendif] = ACTIONS(261),
    [anon_sym_POUNDelse] = ACTIONS(261),
    [sym__newline] = ACTIONS(465),
  },
  [42] = {
    [sym_function_or_value_defn] = STATE(1163),
    [sym__expression] = STATE(34),
    [sym_literal_expression] = STATE(1715),
    [sym_long_identifier_or_op] = STATE(1715),
    [sym_tuple_expression] = STATE(1715),
    [sym_brace_expression] = STATE(1715),
    [sym_anon_record_expression] = STATE(1715),
    [sym_prefixed_expression] = STATE(1715),
    [sym_typecast_expression] = STATE(1715),
    [sym_for_expression] = STATE(1715),
    [sym_while_expression] = STATE(1715),
    [sym__if_branch] = STATE(10853),
    [sym_if_expression] = STATE(1715),
    [sym_fun_expression] = STATE(1715),
    [sym_try_expression] = STATE(1715),
    [sym_match_expression] = STATE(1715),
    [sym_function_expression] = STATE(1715),
    [sym_mutate_expression] = STATE(1715),
    [sym_index_expression] = STATE(1715),
    [sym_typed_expression] = STATE(1715),
    [sym_declaration_expression] = STATE(1715),
    [sym_do_expression] = STATE(1715),
    [sym_list_expression] = STATE(1715),
    [sym_array_expression] = STATE(1715),
    [sym_begin_end_expression] = STATE(1715),
    [sym_paren_expression] = STATE(1715),
    [sym__high_prec_app] = STATE(1728),
    [sym__low_prec_app] = STATE(1728),
    [sym_application_expression] = STATE(1715),
    [sym_dot_expression] = STATE(1715),
    [sym_infix_expression] = STATE(1715),
    [sym_ce_expression] = STATE(1715),
    [sym_sequential_expression] = STATE(1715),
    [sym_char] = STATE(1858),
    [sym_format_string] = STATE(1853),
    [sym__string_literal] = STATE(1853),
    [sym_string] = STATE(1858),
    [sym_verbatim_string] = STATE(1858),
    [sym_bytearray] = STATE(1858),
    [sym_verbatim_bytearray] = STATE(1858),
    [sym_format_triple_quoted_string] = STATE(1851),
    [sym_triple_quoted_string] = STATE(1858),
    [sym_const] = STATE(1715),
    [sym_long_identifier] = STATE(1825),
    [sym_active_pattern] = STATE(1754),
    [sym__identifier_or_op] = STATE(1822),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(940),
    [sym_infix_op] = STATE(1154),
    [sym_sbyte] = STATE(1858),
    [sym_byte] = STATE(1858),
    [sym_int16] = STATE(1858),
    [sym_uint16] = STATE(1858),
    [sym_int32] = STATE(1858),
    [sym_uint32] = STATE(1858),
    [sym_nativeint] = STATE(1858),
    [sym_unativeint] = STATE(1858),
    [sym_int64] = STATE(1858),
    [sym_uint64] = STATE(1858),
    [sym_ieee32] = STATE(1858),
    [sym_ieee64] = STATE(1858),
    [sym_bignum] = STATE(1858),
    [sym_decimal] = STATE(1858),
    [sym_float] = STATE(1552),
    [sym_block_comment] = STATE(42),
    [sym_compiler_directive_decl] = STATE(42),
    [sym_fsi_directive_decl] = STATE(42),
    [sym_preproc_line] = STATE(42),
    [sym_preproc_if_in_expression] = STATE(1715),
    [aux_sym_sequential_expression_repeat1] = STATE(1594),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_EQ] = ACTIONS(227),
    [anon_sym_LBRACK_LT] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(229),
    [anon_sym_return] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_and] = ACTIONS(229),
    [anon_sym_let] = ACTIONS(229),
    [anon_sym_let_BANG] = ACTIONS(227),
    [aux_sym_access_modifier_token1] = ACTIONS(227),
    [anon_sym_LPAREN] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(227),
    [anon_sym_null] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_COLON_QMARK] = ACTIONS(229),
    [anon_sym_COLON_COLON] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_LBRACK] = ACTIONS(229),
    [anon_sym_LBRACK_PIPE] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(229),
    [anon_sym_LT_AT] = ACTIONS(229),
    [anon_sym_LT_AT_AT] = ACTIONS(229),
    [anon_sym_DOT] = ACTIONS(401),
    [anon_sym_LBRACE_PIPE] = ACTIONS(227),
    [anon_sym_new] = ACTIONS(229),
    [anon_sym_with] = ACTIONS(229),
    [anon_sym_return_BANG] = ACTIONS(227),
    [anon_sym_yield] = ACTIONS(229),
    [anon_sym_yield_BANG] = ACTIONS(227),
    [anon_sym_lazy] = ACTIONS(229),
    [anon_sym_assert] = ACTIONS(229),
    [anon_sym_upcast] = ACTIONS(229),
    [anon_sym_downcast] = ACTIONS(229),
    [anon_sym_COLON_GT] = ACTIONS(227),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_fun] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(229),
    [anon_sym_match_BANG] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(229),
    [anon_sym_LT_DASH] = ACTIONS(229),
    [anon_sym_DOT_LBRACK] = ACTIONS(425),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_use] = ACTIONS(229),
    [anon_sym_use_BANG] = ACTIONS(227),
    [anon_sym_do_BANG] = ACTIONS(227),
    [anon_sym_begin] = ACTIONS(229),
    [anon_sym_LPAREN2] = ACTIONS(437),
    [anon_sym_default] = ACTIONS(229),
    [anon_sym_or] = ACTIONS(229),
    [anon_sym_static] = ACTIONS(229),
    [anon_sym_member] = ACTIONS(229),
    [anon_sym_interface] = ACTIONS(229),
    [anon_sym_abstract] = ACTIONS(229),
    [anon_sym_val] = ACTIONS(229),
    [anon_sym_override] = ACTIONS(229),
    [aux_sym_char_token1] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_AT_DQUOTE] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [sym_bool] = ACTIONS(229),
    [sym_unit] = ACTIONS(453),
    [anon_sym_LPAREN_PIPE] = ACTIONS(229),
    [sym_op_identifier] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(229),
    [anon_sym_PLUS_DOT] = ACTIONS(229),
    [anon_sym_DASH_DOT] = ACTIONS(229),
    [anon_sym_PERCENT] = ACTIONS(229),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(227),
    [aux_sym_prefix_op_token1] = ACTIONS(229),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token2] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(229),
    [anon_sym_BANG_EQ] = ACTIONS(229),
    [anon_sym_COLON_EQ] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(229),
    [sym_int] = ACTIONS(229),
    [sym_xint] = ACTIONS(227),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(227),
    [anon_sym_POUNDendif] = ACTIONS(227),
    [anon_sym_POUNDelse] = ACTIONS(227),
    [sym__newline] = ACTIONS(227),
  },
  [43] = {
    [sym_function_or_value_defn] = STATE(1163),
    [sym__expression] = STATE(34),
    [sym_literal_expression] = STATE(1715),
    [sym_long_identifier_or_op] = STATE(1715),
    [sym_tuple_expression] = STATE(1715),
    [sym_brace_expression] = STATE(1715),
    [sym_anon_record_expression] = STATE(1715),
    [sym_prefixed_expression] = STATE(1715),
    [sym_typecast_expression] = STATE(1715),
    [sym_for_expression] = STATE(1715),
    [sym_while_expression] = STATE(1715),
    [sym__if_branch] = STATE(10853),
    [sym_if_expression] = STATE(1715),
    [sym_fun_expression] = STATE(1715),
    [sym_try_expression] = STATE(1715),
    [sym_match_expression] = STATE(1715),
    [sym_function_expression] = STATE(1715),
    [sym_mutate_expression] = STATE(1715),
    [sym_index_expression] = STATE(1715),
    [sym_typed_expression] = STATE(1715),
    [sym_declaration_expression] = STATE(1715),
    [sym_do_expression] = STATE(1715),
    [sym_list_expression] = STATE(1715),
    [sym_array_expression] = STATE(1715),
    [sym_begin_end_expression] = STATE(1715),
    [sym_paren_expression] = STATE(1715),
    [sym__high_prec_app] = STATE(1728),
    [sym__low_prec_app] = STATE(1728),
    [sym_application_expression] = STATE(1715),
    [sym_dot_expression] = STATE(1715),
    [sym_infix_expression] = STATE(1715),
    [sym_ce_expression] = STATE(1715),
    [sym_sequential_expression] = STATE(1715),
    [sym_char] = STATE(1858),
    [sym_format_string] = STATE(1853),
    [sym__string_literal] = STATE(1853),
    [sym_string] = STATE(1858),
    [sym_verbatim_string] = STATE(1858),
    [sym_bytearray] = STATE(1858),
    [sym_verbatim_bytearray] = STATE(1858),
    [sym_format_triple_quoted_string] = STATE(1851),
    [sym_triple_quoted_string] = STATE(1858),
    [sym_const] = STATE(1715),
    [sym_long_identifier] = STATE(1825),
    [sym_active_pattern] = STATE(1754),
    [sym__identifier_or_op] = STATE(1822),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(940),
    [sym_infix_op] = STATE(1154),
    [sym_sbyte] = STATE(1858),
    [sym_byte] = STATE(1858),
    [sym_int16] = STATE(1858),
    [sym_uint16] = STATE(1858),
    [sym_int32] = STATE(1858),
    [sym_uint32] = STATE(1858),
    [sym_nativeint] = STATE(1858),
    [sym_unativeint] = STATE(1858),
    [sym_int64] = STATE(1858),
    [sym_uint64] = STATE(1858),
    [sym_ieee32] = STATE(1858),
    [sym_ieee64] = STATE(1858),
    [sym_bignum] = STATE(1858),
    [sym_decimal] = STATE(1858),
    [sym_float] = STATE(1552),
    [sym_block_comment] = STATE(43),
    [sym_compiler_directive_decl] = STATE(43),
    [sym_fsi_directive_decl] = STATE(43),
    [sym_preproc_line] = STATE(43),
    [sym_preproc_if_in_expression] = STATE(1715),
    [aux_sym_sequential_expression_repeat1] = STATE(1594),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(265),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_do] = ACTIONS(383),
    [anon_sym_and] = ACTIONS(267),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(265),
    [anon_sym_LPAREN] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(387),
    [anon_sym_null] = ACTIONS(389),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(379),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_LBRACK_PIPE] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_LT_AT] = ACTIONS(397),
    [anon_sym_LT_AT_AT] = ACTIONS(399),
    [anon_sym_DOT] = ACTIONS(401),
    [anon_sym_LBRACE_PIPE] = ACTIONS(403),
    [anon_sym_new] = ACTIONS(381),
    [anon_sym_with] = ACTIONS(267),
    [anon_sym_return_BANG] = ACTIONS(405),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_yield_BANG] = ACTIONS(405),
    [anon_sym_lazy] = ACTIONS(381),
    [anon_sym_assert] = ACTIONS(381),
    [anon_sym_upcast] = ACTIONS(381),
    [anon_sym_downcast] = ACTIONS(381),
    [anon_sym_COLON_GT] = ACTIONS(407),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(407),
    [anon_sym_for] = ACTIONS(409),
    [anon_sym_while] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(413),
    [anon_sym_try] = ACTIONS(415),
    [anon_sym_match] = ACTIONS(417),
    [anon_sym_match_BANG] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(421),
    [anon_sym_LT_DASH] = ACTIONS(423),
    [anon_sym_DOT_LBRACK] = ACTIONS(425),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_use] = ACTIONS(429),
    [anon_sym_use_BANG] = ACTIONS(431),
    [anon_sym_do_BANG] = ACTIONS(433),
    [anon_sym_begin] = ACTIONS(435),
    [anon_sym_LPAREN2] = ACTIONS(437),
    [anon_sym_default] = ACTIONS(267),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(267),
    [anon_sym_member] = ACTIONS(267),
    [anon_sym_interface] = ACTIONS(267),
    [anon_sym_abstract] = ACTIONS(267),
    [anon_sym_val] = ACTIONS(267),
    [anon_sym_override] = ACTIONS(267),
    [aux_sym_char_token1] = ACTIONS(439),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(443),
    [anon_sym_AT_DQUOTE] = ACTIONS(445),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(447),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(449),
    [sym_bool] = ACTIONS(451),
    [sym_unit] = ACTIONS(453),
    [anon_sym_LPAREN_PIPE] = ACTIONS(455),
    [sym_op_identifier] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(459),
    [sym_xint] = ACTIONS(461),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(463),
    [anon_sym_POUNDendif] = ACTIONS(265),
    [anon_sym_POUNDelse] = ACTIONS(265),
    [sym__newline] = ACTIONS(465),
  },
  [44] = {
    [sym_function_or_value_defn] = STATE(1163),
    [sym__expression] = STATE(34),
    [sym_literal_expression] = STATE(1715),
    [sym_long_identifier_or_op] = STATE(1715),
    [sym_tuple_expression] = STATE(1715),
    [sym_brace_expression] = STATE(1715),
    [sym_anon_record_expression] = STATE(1715),
    [sym_prefixed_expression] = STATE(1715),
    [sym_typecast_expression] = STATE(1715),
    [sym_for_expression] = STATE(1715),
    [sym_while_expression] = STATE(1715),
    [sym__if_branch] = STATE(10853),
    [sym_if_expression] = STATE(1715),
    [sym_fun_expression] = STATE(1715),
    [sym_try_expression] = STATE(1715),
    [sym_match_expression] = STATE(1715),
    [sym_function_expression] = STATE(1715),
    [sym_mutate_expression] = STATE(1715),
    [sym_index_expression] = STATE(1715),
    [sym_typed_expression] = STATE(1715),
    [sym_declaration_expression] = STATE(1715),
    [sym_do_expression] = STATE(1715),
    [sym_list_expression] = STATE(1715),
    [sym_array_expression] = STATE(1715),
    [sym_begin_end_expression] = STATE(1715),
    [sym_paren_expression] = STATE(1715),
    [sym__high_prec_app] = STATE(1728),
    [sym__low_prec_app] = STATE(1728),
    [sym_application_expression] = STATE(1715),
    [sym_dot_expression] = STATE(1715),
    [sym_infix_expression] = STATE(1715),
    [sym_ce_expression] = STATE(1715),
    [sym_sequential_expression] = STATE(1715),
    [sym_char] = STATE(1858),
    [sym_format_string] = STATE(1853),
    [sym__string_literal] = STATE(1853),
    [sym_string] = STATE(1858),
    [sym_verbatim_string] = STATE(1858),
    [sym_bytearray] = STATE(1858),
    [sym_verbatim_bytearray] = STATE(1858),
    [sym_format_triple_quoted_string] = STATE(1851),
    [sym_triple_quoted_string] = STATE(1858),
    [sym_const] = STATE(1715),
    [sym_long_identifier] = STATE(1825),
    [sym_active_pattern] = STATE(1754),
    [sym__identifier_or_op] = STATE(1822),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(940),
    [sym_infix_op] = STATE(1154),
    [sym_sbyte] = STATE(1858),
    [sym_byte] = STATE(1858),
    [sym_int16] = STATE(1858),
    [sym_uint16] = STATE(1858),
    [sym_int32] = STATE(1858),
    [sym_uint32] = STATE(1858),
    [sym_nativeint] = STATE(1858),
    [sym_unativeint] = STATE(1858),
    [sym_int64] = STATE(1858),
    [sym_uint64] = STATE(1858),
    [sym_ieee32] = STATE(1858),
    [sym_ieee64] = STATE(1858),
    [sym_bignum] = STATE(1858),
    [sym_decimal] = STATE(1858),
    [sym_float] = STATE(1552),
    [sym_block_comment] = STATE(44),
    [sym_compiler_directive_decl] = STATE(44),
    [sym_fsi_directive_decl] = STATE(44),
    [sym_preproc_line] = STATE(44),
    [sym_preproc_if_in_expression] = STATE(1715),
    [aux_sym_sequential_expression_repeat1] = STATE(1594),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(247),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_do] = ACTIONS(249),
    [anon_sym_and] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(249),
    [anon_sym_let_BANG] = ACTIONS(247),
    [aux_sym_access_modifier_token1] = ACTIONS(247),
    [anon_sym_LPAREN] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(387),
    [anon_sym_null] = ACTIONS(389),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(379),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_LBRACK_PIPE] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_LT_AT] = ACTIONS(397),
    [anon_sym_LT_AT_AT] = ACTIONS(399),
    [anon_sym_DOT] = ACTIONS(401),
    [anon_sym_LBRACE_PIPE] = ACTIONS(403),
    [anon_sym_new] = ACTIONS(249),
    [anon_sym_with] = ACTIONS(469),
    [anon_sym_return_BANG] = ACTIONS(405),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_yield_BANG] = ACTIONS(405),
    [anon_sym_lazy] = ACTIONS(381),
    [anon_sym_assert] = ACTIONS(381),
    [anon_sym_upcast] = ACTIONS(381),
    [anon_sym_downcast] = ACTIONS(381),
    [anon_sym_COLON_GT] = ACTIONS(407),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(407),
    [anon_sym_for] = ACTIONS(409),
    [anon_sym_while] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(413),
    [anon_sym_try] = ACTIONS(415),
    [anon_sym_match] = ACTIONS(417),
    [anon_sym_match_BANG] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(421),
    [anon_sym_LT_DASH] = ACTIONS(423),
    [anon_sym_DOT_LBRACK] = ACTIONS(425),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_use] = ACTIONS(429),
    [anon_sym_use_BANG] = ACTIONS(431),
    [anon_sym_do_BANG] = ACTIONS(433),
    [anon_sym_begin] = ACTIONS(435),
    [anon_sym_LPAREN2] = ACTIONS(437),
    [anon_sym_default] = ACTIONS(249),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(249),
    [anon_sym_member] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(249),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_val] = ACTIONS(249),
    [anon_sym_override] = ACTIONS(249),
    [aux_sym_char_token1] = ACTIONS(439),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(443),
    [anon_sym_AT_DQUOTE] = ACTIONS(445),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(447),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(449),
    [sym_bool] = ACTIONS(451),
    [sym_unit] = ACTIONS(453),
    [anon_sym_LPAREN_PIPE] = ACTIONS(455),
    [sym_op_identifier] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(459),
    [sym_xint] = ACTIONS(461),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(247),
    [anon_sym_POUNDendif] = ACTIONS(247),
    [anon_sym_POUNDelse] = ACTIONS(247),
    [sym__newline] = ACTIONS(465),
  },
  [45] = {
    [sym_function_or_value_defn] = STATE(1163),
    [sym__expression] = STATE(34),
    [sym_literal_expression] = STATE(1715),
    [sym_long_identifier_or_op] = STATE(1715),
    [sym_tuple_expression] = STATE(1715),
    [sym_brace_expression] = STATE(1715),
    [sym_anon_record_expression] = STATE(1715),
    [sym_prefixed_expression] = STATE(1715),
    [sym_typecast_expression] = STATE(1715),
    [sym_for_expression] = STATE(1715),
    [sym_while_expression] = STATE(1715),
    [sym__if_branch] = STATE(10853),
    [sym_if_expression] = STATE(1715),
    [sym_fun_expression] = STATE(1715),
    [sym_try_expression] = STATE(1715),
    [sym_match_expression] = STATE(1715),
    [sym_function_expression] = STATE(1715),
    [sym_mutate_expression] = STATE(1715),
    [sym_index_expression] = STATE(1715),
    [sym_typed_expression] = STATE(1715),
    [sym_declaration_expression] = STATE(1715),
    [sym_do_expression] = STATE(1715),
    [sym_list_expression] = STATE(1715),
    [sym_array_expression] = STATE(1715),
    [sym_begin_end_expression] = STATE(1715),
    [sym_paren_expression] = STATE(1715),
    [sym__high_prec_app] = STATE(1728),
    [sym__low_prec_app] = STATE(1728),
    [sym_application_expression] = STATE(1715),
    [sym_dot_expression] = STATE(1715),
    [sym_infix_expression] = STATE(1715),
    [sym_ce_expression] = STATE(1715),
    [sym_sequential_expression] = STATE(1715),
    [sym_char] = STATE(1858),
    [sym_format_string] = STATE(1853),
    [sym__string_literal] = STATE(1853),
    [sym_string] = STATE(1858),
    [sym_verbatim_string] = STATE(1858),
    [sym_bytearray] = STATE(1858),
    [sym_verbatim_bytearray] = STATE(1858),
    [sym_format_triple_quoted_string] = STATE(1851),
    [sym_triple_quoted_string] = STATE(1858),
    [sym_const] = STATE(1715),
    [sym_long_identifier] = STATE(1825),
    [sym_active_pattern] = STATE(1754),
    [sym__identifier_or_op] = STATE(1822),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(940),
    [sym_infix_op] = STATE(1154),
    [sym_sbyte] = STATE(1858),
    [sym_byte] = STATE(1858),
    [sym_int16] = STATE(1858),
    [sym_uint16] = STATE(1858),
    [sym_int32] = STATE(1858),
    [sym_uint32] = STATE(1858),
    [sym_nativeint] = STATE(1858),
    [sym_unativeint] = STATE(1858),
    [sym_int64] = STATE(1858),
    [sym_uint64] = STATE(1858),
    [sym_ieee32] = STATE(1858),
    [sym_ieee64] = STATE(1858),
    [sym_bignum] = STATE(1858),
    [sym_decimal] = STATE(1858),
    [sym_float] = STATE(1552),
    [sym_block_comment] = STATE(45),
    [sym_compiler_directive_decl] = STATE(45),
    [sym_fsi_directive_decl] = STATE(45),
    [sym_preproc_line] = STATE(45),
    [sym_preproc_if_in_expression] = STATE(1715),
    [aux_sym_sequential_expression_repeat1] = STATE(1594),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(119),
    [anon_sym_COLON] = ACTIONS(379),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_do] = ACTIONS(383),
    [anon_sym_and] = ACTIONS(123),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(119),
    [anon_sym_LPAREN] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(387),
    [anon_sym_null] = ACTIONS(389),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(379),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_LBRACK_PIPE] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_LT_AT] = ACTIONS(397),
    [anon_sym_LT_AT_AT] = ACTIONS(399),
    [anon_sym_DOT] = ACTIONS(401),
    [anon_sym_LBRACE_PIPE] = ACTIONS(403),
    [anon_sym_new] = ACTIONS(381),
    [anon_sym_with] = ACTIONS(123),
    [anon_sym_return_BANG] = ACTIONS(405),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_yield_BANG] = ACTIONS(405),
    [anon_sym_lazy] = ACTIONS(381),
    [anon_sym_assert] = ACTIONS(381),
    [anon_sym_upcast] = ACTIONS(381),
    [anon_sym_downcast] = ACTIONS(381),
    [anon_sym_COLON_GT] = ACTIONS(407),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(407),
    [anon_sym_for] = ACTIONS(409),
    [anon_sym_while] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(413),
    [anon_sym_try] = ACTIONS(415),
    [anon_sym_match] = ACTIONS(417),
    [anon_sym_match_BANG] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(421),
    [anon_sym_LT_DASH] = ACTIONS(423),
    [anon_sym_DOT_LBRACK] = ACTIONS(425),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_use] = ACTIONS(429),
    [anon_sym_use_BANG] = ACTIONS(431),
    [anon_sym_do_BANG] = ACTIONS(433),
    [anon_sym_begin] = ACTIONS(435),
    [anon_sym_LPAREN2] = ACTIONS(437),
    [anon_sym_default] = ACTIONS(123),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(123),
    [anon_sym_member] = ACTIONS(123),
    [anon_sym_interface] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(123),
    [anon_sym_val] = ACTIONS(123),
    [anon_sym_override] = ACTIONS(123),
    [aux_sym_char_token1] = ACTIONS(439),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(443),
    [anon_sym_AT_DQUOTE] = ACTIONS(445),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(447),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(449),
    [sym_bool] = ACTIONS(451),
    [sym_unit] = ACTIONS(453),
    [anon_sym_LPAREN_PIPE] = ACTIONS(455),
    [sym_op_identifier] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(459),
    [sym_xint] = ACTIONS(461),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(463),
    [anon_sym_POUNDendif] = ACTIONS(119),
    [anon_sym_POUNDelse] = ACTIONS(119),
    [sym__newline] = ACTIONS(119),
  },
  [46] = {
    [sym_function_or_value_defn] = STATE(1122),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(938),
    [sym_infix_op] = STATE(1116),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(1598),
    [sym_block_comment] = STATE(46),
    [sym_compiler_directive_decl] = STATE(46),
    [sym_fsi_directive_decl] = STATE(46),
    [sym_preproc_line] = STATE(46),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_sequential_expression_repeat1] = STATE(1706),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(243),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_return] = ACTIONS(475),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_and] = ACTIONS(245),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(481),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(475),
    [anon_sym_with] = ACTIONS(245),
    [anon_sym_return_BANG] = ACTIONS(497),
    [anon_sym_yield] = ACTIONS(475),
    [anon_sym_yield_BANG] = ACTIONS(497),
    [anon_sym_lazy] = ACTIONS(475),
    [anon_sym_assert] = ACTIONS(475),
    [anon_sym_upcast] = ACTIONS(475),
    [anon_sym_downcast] = ACTIONS(475),
    [anon_sym_COLON_GT] = ACTIONS(499),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_LT_DASH] = ACTIONS(515),
    [anon_sym_DOT_LBRACK] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_use] = ACTIONS(521),
    [anon_sym_use_BANG] = ACTIONS(523),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [anon_sym_LPAREN2] = ACTIONS(529),
    [anon_sym_default] = ACTIONS(245),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_member] = ACTIONS(245),
    [anon_sym_interface] = ACTIONS(245),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_val] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(551),
    [sym_xint] = ACTIONS(553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
    [sym__newline] = ACTIONS(243),
    [sym__dedent] = ACTIONS(243),
  },
  [47] = {
    [sym_function_or_value_defn] = STATE(1054),
    [sym__expression] = STATE(56),
    [sym_literal_expression] = STATE(2069),
    [sym_long_identifier_or_op] = STATE(2069),
    [sym_tuple_expression] = STATE(2069),
    [sym_brace_expression] = STATE(2069),
    [sym_anon_record_expression] = STATE(2069),
    [sym_prefixed_expression] = STATE(2069),
    [sym_typecast_expression] = STATE(2069),
    [sym_for_expression] = STATE(2069),
    [sym_while_expression] = STATE(2069),
    [sym__if_branch] = STATE(10893),
    [sym_if_expression] = STATE(2069),
    [sym_fun_expression] = STATE(2069),
    [sym_try_expression] = STATE(2069),
    [sym_match_expression] = STATE(2069),
    [sym_function_expression] = STATE(2069),
    [sym_mutate_expression] = STATE(2069),
    [sym_index_expression] = STATE(2069),
    [sym_typed_expression] = STATE(2069),
    [sym_declaration_expression] = STATE(2069),
    [sym_do_expression] = STATE(2069),
    [sym_list_expression] = STATE(2069),
    [sym_array_expression] = STATE(2069),
    [sym_begin_end_expression] = STATE(2069),
    [sym_paren_expression] = STATE(2069),
    [sym__high_prec_app] = STATE(2058),
    [sym__low_prec_app] = STATE(2058),
    [sym_application_expression] = STATE(2069),
    [sym_dot_expression] = STATE(2069),
    [sym_infix_expression] = STATE(2069),
    [sym_ce_expression] = STATE(2069),
    [sym_sequential_expression] = STATE(2069),
    [sym_char] = STATE(2052),
    [sym_format_string] = STATE(2056),
    [sym__string_literal] = STATE(2056),
    [sym_string] = STATE(2052),
    [sym_verbatim_string] = STATE(2052),
    [sym_bytearray] = STATE(2052),
    [sym_verbatim_bytearray] = STATE(2052),
    [sym_format_triple_quoted_string] = STATE(2057),
    [sym_triple_quoted_string] = STATE(2052),
    [sym_const] = STATE(2069),
    [sym_long_identifier] = STATE(2077),
    [sym_active_pattern] = STATE(1953),
    [sym__identifier_or_op] = STATE(2078),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(934),
    [sym_infix_op] = STATE(1048),
    [sym_sbyte] = STATE(2052),
    [sym_byte] = STATE(2052),
    [sym_int16] = STATE(2052),
    [sym_uint16] = STATE(2052),
    [sym_int32] = STATE(2052),
    [sym_uint32] = STATE(2052),
    [sym_nativeint] = STATE(2052),
    [sym_unativeint] = STATE(2052),
    [sym_int64] = STATE(2052),
    [sym_uint64] = STATE(2052),
    [sym_ieee32] = STATE(2052),
    [sym_ieee64] = STATE(2052),
    [sym_bignum] = STATE(2052),
    [sym_decimal] = STATE(2052),
    [sym_float] = STATE(1596),
    [sym_block_comment] = STATE(47),
    [sym_compiler_directive_decl] = STATE(47),
    [sym_fsi_directive_decl] = STATE(47),
    [sym_preproc_line] = STATE(47),
    [sym_preproc_if_in_expression] = STATE(2069),
    [aux_sym_sequential_expression_repeat1] = STATE(1815),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(557),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(261),
    [anon_sym_COLON] = ACTIONS(559),
    [anon_sym_return] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(563),
    [anon_sym_and] = ACTIONS(263),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(261),
    [anon_sym_LPAREN] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(567),
    [anon_sym_null] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(559),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(571),
    [anon_sym_LBRACK_PIPE] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(575),
    [anon_sym_LT_AT] = ACTIONS(577),
    [anon_sym_LT_AT_AT] = ACTIONS(579),
    [anon_sym_DOT] = ACTIONS(581),
    [anon_sym_LBRACE_PIPE] = ACTIONS(583),
    [anon_sym_new] = ACTIONS(561),
    [anon_sym_with] = ACTIONS(263),
    [anon_sym_return_BANG] = ACTIONS(585),
    [anon_sym_yield] = ACTIONS(561),
    [anon_sym_yield_BANG] = ACTIONS(585),
    [anon_sym_lazy] = ACTIONS(561),
    [anon_sym_assert] = ACTIONS(561),
    [anon_sym_upcast] = ACTIONS(561),
    [anon_sym_downcast] = ACTIONS(561),
    [anon_sym_COLON_GT] = ACTIONS(587),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(587),
    [anon_sym_for] = ACTIONS(589),
    [anon_sym_while] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(593),
    [anon_sym_try] = ACTIONS(595),
    [anon_sym_match] = ACTIONS(597),
    [anon_sym_match_BANG] = ACTIONS(599),
    [anon_sym_function] = ACTIONS(601),
    [anon_sym_LT_DASH] = ACTIONS(603),
    [anon_sym_DOT_LBRACK] = ACTIONS(605),
    [anon_sym_LT] = ACTIONS(607),
    [anon_sym_use] = ACTIONS(609),
    [anon_sym_use_BANG] = ACTIONS(611),
    [anon_sym_do_BANG] = ACTIONS(613),
    [anon_sym_begin] = ACTIONS(615),
    [anon_sym_LPAREN2] = ACTIONS(617),
    [anon_sym_default] = ACTIONS(263),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(263),
    [anon_sym_member] = ACTIONS(263),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_abstract] = ACTIONS(263),
    [anon_sym_val] = ACTIONS(263),
    [anon_sym_override] = ACTIONS(263),
    [aux_sym_char_token1] = ACTIONS(619),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(621),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [anon_sym_AT_DQUOTE] = ACTIONS(625),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(627),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(629),
    [sym_bool] = ACTIONS(631),
    [sym_unit] = ACTIONS(633),
    [anon_sym_LPAREN_PIPE] = ACTIONS(635),
    [sym_op_identifier] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(639),
    [sym_xint] = ACTIONS(641),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(643),
    [anon_sym_POUNDendif] = ACTIONS(261),
    [sym__newline] = ACTIONS(645),
  },
  [48] = {
    [sym_function_or_value_defn] = STATE(1084),
    [sym__expression] = STATE(58),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(936),
    [sym_infix_op] = STATE(1079),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(1592),
    [sym_block_comment] = STATE(48),
    [sym_compiler_directive_decl] = STATE(48),
    [sym_fsi_directive_decl] = STATE(48),
    [sym_preproc_line] = STATE(48),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_sequential_expression_repeat1] = STATE(1707),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_return] = ACTIONS(651),
    [anon_sym_do] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(239),
    [anon_sym_let_BANG] = ACTIONS(237),
    [aux_sym_access_modifier_token1] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(655),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(649),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(667),
    [anon_sym_DOT] = ACTIONS(669),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_with] = ACTIONS(239),
    [anon_sym_return_BANG] = ACTIONS(673),
    [anon_sym_yield] = ACTIONS(651),
    [anon_sym_yield_BANG] = ACTIONS(673),
    [anon_sym_lazy] = ACTIONS(651),
    [anon_sym_assert] = ACTIONS(651),
    [anon_sym_upcast] = ACTIONS(651),
    [anon_sym_downcast] = ACTIONS(651),
    [anon_sym_COLON_GT] = ACTIONS(675),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_LT_DASH] = ACTIONS(691),
    [anon_sym_DOT_LBRACK] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_use] = ACTIONS(697),
    [anon_sym_use_BANG] = ACTIONS(699),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [anon_sym_LPAREN2] = ACTIONS(705),
    [anon_sym_default] = ACTIONS(239),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(239),
    [anon_sym_member] = ACTIONS(239),
    [anon_sym_interface] = ACTIONS(239),
    [anon_sym_abstract] = ACTIONS(239),
    [anon_sym_val] = ACTIONS(239),
    [anon_sym_override] = ACTIONS(239),
    [anon_sym_inherit] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(721),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(727),
    [sym_xint] = ACTIONS(729),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(237),
    [anon_sym_POUNDendif] = ACTIONS(237),
    [sym__newline] = ACTIONS(237),
  },
  [49] = {
    [sym_function_or_value_defn] = STATE(1122),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(938),
    [sym_infix_op] = STATE(1116),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(1598),
    [sym_block_comment] = STATE(49),
    [sym_compiler_directive_decl] = STATE(49),
    [sym_fsi_directive_decl] = STATE(49),
    [sym_preproc_line] = STATE(49),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_sequential_expression_repeat1] = STATE(1706),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_return] = ACTIONS(475),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_and] = ACTIONS(233),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(481),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(731),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(475),
    [anon_sym_with] = ACTIONS(233),
    [anon_sym_return_BANG] = ACTIONS(497),
    [anon_sym_yield] = ACTIONS(475),
    [anon_sym_yield_BANG] = ACTIONS(497),
    [anon_sym_lazy] = ACTIONS(475),
    [anon_sym_assert] = ACTIONS(475),
    [anon_sym_upcast] = ACTIONS(475),
    [anon_sym_downcast] = ACTIONS(475),
    [anon_sym_COLON_GT] = ACTIONS(499),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_LT_DASH] = ACTIONS(515),
    [anon_sym_DOT_LBRACK] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_use] = ACTIONS(521),
    [anon_sym_use_BANG] = ACTIONS(523),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [anon_sym_LPAREN2] = ACTIONS(529),
    [anon_sym_default] = ACTIONS(233),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(233),
    [anon_sym_member] = ACTIONS(233),
    [anon_sym_interface] = ACTIONS(233),
    [anon_sym_abstract] = ACTIONS(233),
    [anon_sym_val] = ACTIONS(233),
    [anon_sym_override] = ACTIONS(233),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(551),
    [sym_xint] = ACTIONS(553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
    [sym__newline] = ACTIONS(733),
    [sym__dedent] = ACTIONS(231),
  },
  [50] = {
    [sym_function_or_value_defn] = STATE(1054),
    [sym__expression] = STATE(56),
    [sym_literal_expression] = STATE(2069),
    [sym_long_identifier_or_op] = STATE(2069),
    [sym_tuple_expression] = STATE(2069),
    [sym_brace_expression] = STATE(2069),
    [sym_anon_record_expression] = STATE(2069),
    [sym_prefixed_expression] = STATE(2069),
    [sym_typecast_expression] = STATE(2069),
    [sym_for_expression] = STATE(2069),
    [sym_while_expression] = STATE(2069),
    [sym__if_branch] = STATE(10893),
    [sym_if_expression] = STATE(2069),
    [sym_fun_expression] = STATE(2069),
    [sym_try_expression] = STATE(2069),
    [sym_match_expression] = STATE(2069),
    [sym_function_expression] = STATE(2069),
    [sym_mutate_expression] = STATE(2069),
    [sym_index_expression] = STATE(2069),
    [sym_typed_expression] = STATE(2069),
    [sym_declaration_expression] = STATE(2069),
    [sym_do_expression] = STATE(2069),
    [sym_list_expression] = STATE(2069),
    [sym_array_expression] = STATE(2069),
    [sym_begin_end_expression] = STATE(2069),
    [sym_paren_expression] = STATE(2069),
    [sym__high_prec_app] = STATE(2058),
    [sym__low_prec_app] = STATE(2058),
    [sym_application_expression] = STATE(2069),
    [sym_dot_expression] = STATE(2069),
    [sym_infix_expression] = STATE(2069),
    [sym_ce_expression] = STATE(2069),
    [sym_sequential_expression] = STATE(2069),
    [sym_char] = STATE(2052),
    [sym_format_string] = STATE(2056),
    [sym__string_literal] = STATE(2056),
    [sym_string] = STATE(2052),
    [sym_verbatim_string] = STATE(2052),
    [sym_bytearray] = STATE(2052),
    [sym_verbatim_bytearray] = STATE(2052),
    [sym_format_triple_quoted_string] = STATE(2057),
    [sym_triple_quoted_string] = STATE(2052),
    [sym_const] = STATE(2069),
    [sym_long_identifier] = STATE(2077),
    [sym_active_pattern] = STATE(1953),
    [sym__identifier_or_op] = STATE(2078),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(934),
    [sym_infix_op] = STATE(1048),
    [sym_sbyte] = STATE(2052),
    [sym_byte] = STATE(2052),
    [sym_int16] = STATE(2052),
    [sym_uint16] = STATE(2052),
    [sym_int32] = STATE(2052),
    [sym_uint32] = STATE(2052),
    [sym_nativeint] = STATE(2052),
    [sym_unativeint] = STATE(2052),
    [sym_int64] = STATE(2052),
    [sym_uint64] = STATE(2052),
    [sym_ieee32] = STATE(2052),
    [sym_ieee64] = STATE(2052),
    [sym_bignum] = STATE(2052),
    [sym_decimal] = STATE(2052),
    [sym_float] = STATE(1596),
    [sym_block_comment] = STATE(50),
    [sym_compiler_directive_decl] = STATE(50),
    [sym_fsi_directive_decl] = STATE(50),
    [sym_preproc_line] = STATE(50),
    [sym_preproc_if_in_expression] = STATE(2069),
    [aux_sym_sequential_expression_repeat1] = STATE(1815),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(557),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(559),
    [anon_sym_return] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(563),
    [anon_sym_and] = ACTIONS(233),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(567),
    [anon_sym_null] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(559),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(571),
    [anon_sym_LBRACK_PIPE] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(575),
    [anon_sym_LT_AT] = ACTIONS(577),
    [anon_sym_LT_AT_AT] = ACTIONS(579),
    [anon_sym_DOT] = ACTIONS(581),
    [anon_sym_LBRACE_PIPE] = ACTIONS(583),
    [anon_sym_new] = ACTIONS(561),
    [anon_sym_with] = ACTIONS(233),
    [anon_sym_return_BANG] = ACTIONS(585),
    [anon_sym_yield] = ACTIONS(561),
    [anon_sym_yield_BANG] = ACTIONS(585),
    [anon_sym_lazy] = ACTIONS(561),
    [anon_sym_assert] = ACTIONS(561),
    [anon_sym_upcast] = ACTIONS(561),
    [anon_sym_downcast] = ACTIONS(561),
    [anon_sym_COLON_GT] = ACTIONS(587),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(587),
    [anon_sym_for] = ACTIONS(589),
    [anon_sym_while] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(593),
    [anon_sym_try] = ACTIONS(595),
    [anon_sym_match] = ACTIONS(597),
    [anon_sym_match_BANG] = ACTIONS(599),
    [anon_sym_function] = ACTIONS(601),
    [anon_sym_LT_DASH] = ACTIONS(603),
    [anon_sym_DOT_LBRACK] = ACTIONS(605),
    [anon_sym_LT] = ACTIONS(607),
    [anon_sym_use] = ACTIONS(609),
    [anon_sym_use_BANG] = ACTIONS(611),
    [anon_sym_do_BANG] = ACTIONS(613),
    [anon_sym_begin] = ACTIONS(615),
    [anon_sym_LPAREN2] = ACTIONS(617),
    [anon_sym_default] = ACTIONS(233),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(233),
    [anon_sym_member] = ACTIONS(233),
    [anon_sym_interface] = ACTIONS(233),
    [anon_sym_abstract] = ACTIONS(233),
    [anon_sym_val] = ACTIONS(233),
    [anon_sym_override] = ACTIONS(233),
    [aux_sym_char_token1] = ACTIONS(619),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(621),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [anon_sym_AT_DQUOTE] = ACTIONS(625),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(627),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(629),
    [sym_bool] = ACTIONS(631),
    [sym_unit] = ACTIONS(633),
    [anon_sym_LPAREN_PIPE] = ACTIONS(635),
    [sym_op_identifier] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(639),
    [sym_xint] = ACTIONS(641),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(643),
    [anon_sym_POUNDendif] = ACTIONS(231),
    [sym__newline] = ACTIONS(645),
  },
  [51] = {
    [sym_function_or_value_defn] = STATE(1122),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(938),
    [sym_infix_op] = STATE(1116),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(1598),
    [sym_block_comment] = STATE(51),
    [sym_compiler_directive_decl] = STATE(51),
    [sym_fsi_directive_decl] = STATE(51),
    [sym_preproc_line] = STATE(51),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_sequential_expression_repeat1] = STATE(1706),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(253),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_return] = ACTIONS(475),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(481),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(255),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(475),
    [anon_sym_with] = ACTIONS(255),
    [anon_sym_return_BANG] = ACTIONS(497),
    [anon_sym_yield] = ACTIONS(475),
    [anon_sym_yield_BANG] = ACTIONS(497),
    [anon_sym_lazy] = ACTIONS(475),
    [anon_sym_assert] = ACTIONS(475),
    [anon_sym_upcast] = ACTIONS(475),
    [anon_sym_downcast] = ACTIONS(475),
    [anon_sym_COLON_GT] = ACTIONS(499),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_LT_DASH] = ACTIONS(515),
    [anon_sym_DOT_LBRACK] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_use] = ACTIONS(521),
    [anon_sym_use_BANG] = ACTIONS(523),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [anon_sym_LPAREN2] = ACTIONS(529),
    [anon_sym_default] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(255),
    [anon_sym_member] = ACTIONS(255),
    [anon_sym_interface] = ACTIONS(255),
    [anon_sym_abstract] = ACTIONS(255),
    [anon_sym_val] = ACTIONS(255),
    [anon_sym_override] = ACTIONS(255),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(551),
    [sym_xint] = ACTIONS(553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
    [sym__newline] = ACTIONS(253),
    [sym__dedent] = ACTIONS(253),
  },
  [52] = {
    [sym_function_or_value_defn] = STATE(1084),
    [sym__expression] = STATE(58),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(936),
    [sym_infix_op] = STATE(1079),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(1592),
    [sym_block_comment] = STATE(52),
    [sym_compiler_directive_decl] = STATE(52),
    [sym_fsi_directive_decl] = STATE(52),
    [sym_preproc_line] = STATE(52),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_sequential_expression_repeat1] = STATE(1707),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(247),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_return] = ACTIONS(651),
    [anon_sym_do] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(249),
    [anon_sym_let_BANG] = ACTIONS(247),
    [aux_sym_access_modifier_token1] = ACTIONS(247),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(655),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(649),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(667),
    [anon_sym_DOT] = ACTIONS(669),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(249),
    [anon_sym_with] = ACTIONS(249),
    [anon_sym_return_BANG] = ACTIONS(673),
    [anon_sym_yield] = ACTIONS(651),
    [anon_sym_yield_BANG] = ACTIONS(673),
    [anon_sym_lazy] = ACTIONS(651),
    [anon_sym_assert] = ACTIONS(651),
    [anon_sym_upcast] = ACTIONS(651),
    [anon_sym_downcast] = ACTIONS(651),
    [anon_sym_COLON_GT] = ACTIONS(675),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_LT_DASH] = ACTIONS(691),
    [anon_sym_DOT_LBRACK] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_use] = ACTIONS(697),
    [anon_sym_use_BANG] = ACTIONS(699),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [anon_sym_LPAREN2] = ACTIONS(705),
    [anon_sym_default] = ACTIONS(249),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(249),
    [anon_sym_member] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(249),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_val] = ACTIONS(249),
    [anon_sym_override] = ACTIONS(249),
    [anon_sym_inherit] = ACTIONS(249),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(721),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(727),
    [sym_xint] = ACTIONS(729),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(247),
    [anon_sym_POUNDendif] = ACTIONS(247),
    [sym__newline] = ACTIONS(247),
  },
  [53] = {
    [sym_function_or_value_defn] = STATE(1122),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(938),
    [sym_infix_op] = STATE(1116),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(1598),
    [sym_block_comment] = STATE(53),
    [sym_compiler_directive_decl] = STATE(53),
    [sym_fsi_directive_decl] = STATE(53),
    [sym_preproc_line] = STATE(53),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_sequential_expression_repeat1] = STATE(1706),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_return] = ACTIONS(475),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_and] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(257),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(481),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(259),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(475),
    [anon_sym_with] = ACTIONS(259),
    [anon_sym_return_BANG] = ACTIONS(497),
    [anon_sym_yield] = ACTIONS(475),
    [anon_sym_yield_BANG] = ACTIONS(497),
    [anon_sym_lazy] = ACTIONS(475),
    [anon_sym_assert] = ACTIONS(475),
    [anon_sym_upcast] = ACTIONS(475),
    [anon_sym_downcast] = ACTIONS(475),
    [anon_sym_COLON_GT] = ACTIONS(499),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_LT_DASH] = ACTIONS(515),
    [anon_sym_DOT_LBRACK] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_use] = ACTIONS(521),
    [anon_sym_use_BANG] = ACTIONS(523),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [anon_sym_LPAREN2] = ACTIONS(529),
    [anon_sym_default] = ACTIONS(259),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(259),
    [anon_sym_member] = ACTIONS(259),
    [anon_sym_interface] = ACTIONS(259),
    [anon_sym_abstract] = ACTIONS(259),
    [anon_sym_val] = ACTIONS(259),
    [anon_sym_override] = ACTIONS(259),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(551),
    [sym_xint] = ACTIONS(553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
    [sym__newline] = ACTIONS(257),
    [sym__dedent] = ACTIONS(257),
  },
  [54] = {
    [sym_function_or_value_defn] = STATE(1122),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(938),
    [sym_infix_op] = STATE(1116),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(1598),
    [sym_block_comment] = STATE(54),
    [sym_compiler_directive_decl] = STATE(54),
    [sym_fsi_directive_decl] = STATE(54),
    [sym_preproc_line] = STATE(54),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_sequential_expression_repeat1] = STATE(1706),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(261),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_return] = ACTIONS(475),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_and] = ACTIONS(263),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(261),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(481),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(731),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(475),
    [anon_sym_with] = ACTIONS(263),
    [anon_sym_return_BANG] = ACTIONS(497),
    [anon_sym_yield] = ACTIONS(475),
    [anon_sym_yield_BANG] = ACTIONS(497),
    [anon_sym_lazy] = ACTIONS(475),
    [anon_sym_assert] = ACTIONS(475),
    [anon_sym_upcast] = ACTIONS(475),
    [anon_sym_downcast] = ACTIONS(475),
    [anon_sym_COLON_GT] = ACTIONS(499),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_LT_DASH] = ACTIONS(515),
    [anon_sym_DOT_LBRACK] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_use] = ACTIONS(521),
    [anon_sym_use_BANG] = ACTIONS(523),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [anon_sym_LPAREN2] = ACTIONS(529),
    [anon_sym_default] = ACTIONS(263),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(263),
    [anon_sym_member] = ACTIONS(263),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_abstract] = ACTIONS(263),
    [anon_sym_val] = ACTIONS(263),
    [anon_sym_override] = ACTIONS(263),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(551),
    [sym_xint] = ACTIONS(553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
    [sym__newline] = ACTIONS(733),
    [sym__dedent] = ACTIONS(261),
  },
  [55] = {
    [sym_function_or_value_defn] = STATE(1122),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(938),
    [sym_infix_op] = STATE(1116),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(1598),
    [sym_block_comment] = STATE(55),
    [sym_compiler_directive_decl] = STATE(55),
    [sym_fsi_directive_decl] = STATE(55),
    [sym_preproc_line] = STATE(55),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_sequential_expression_repeat1] = STATE(1706),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(265),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_return] = ACTIONS(475),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_and] = ACTIONS(267),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(265),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(481),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(731),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(475),
    [anon_sym_with] = ACTIONS(267),
    [anon_sym_return_BANG] = ACTIONS(497),
    [anon_sym_yield] = ACTIONS(475),
    [anon_sym_yield_BANG] = ACTIONS(497),
    [anon_sym_lazy] = ACTIONS(475),
    [anon_sym_assert] = ACTIONS(475),
    [anon_sym_upcast] = ACTIONS(475),
    [anon_sym_downcast] = ACTIONS(475),
    [anon_sym_COLON_GT] = ACTIONS(499),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_LT_DASH] = ACTIONS(515),
    [anon_sym_DOT_LBRACK] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_use] = ACTIONS(521),
    [anon_sym_use_BANG] = ACTIONS(523),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [anon_sym_LPAREN2] = ACTIONS(529),
    [anon_sym_default] = ACTIONS(267),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(267),
    [anon_sym_member] = ACTIONS(267),
    [anon_sym_interface] = ACTIONS(267),
    [anon_sym_abstract] = ACTIONS(267),
    [anon_sym_val] = ACTIONS(267),
    [anon_sym_override] = ACTIONS(267),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(551),
    [sym_xint] = ACTIONS(553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
    [sym__newline] = ACTIONS(733),
    [sym__dedent] = ACTIONS(265),
  },
  [56] = {
    [sym_function_or_value_defn] = STATE(1054),
    [sym__expression] = STATE(56),
    [sym_literal_expression] = STATE(2069),
    [sym_long_identifier_or_op] = STATE(2069),
    [sym_tuple_expression] = STATE(2069),
    [sym_brace_expression] = STATE(2069),
    [sym_anon_record_expression] = STATE(2069),
    [sym_prefixed_expression] = STATE(2069),
    [sym_typecast_expression] = STATE(2069),
    [sym_for_expression] = STATE(2069),
    [sym_while_expression] = STATE(2069),
    [sym__if_branch] = STATE(10893),
    [sym_if_expression] = STATE(2069),
    [sym_fun_expression] = STATE(2069),
    [sym_try_expression] = STATE(2069),
    [sym_match_expression] = STATE(2069),
    [sym_function_expression] = STATE(2069),
    [sym_mutate_expression] = STATE(2069),
    [sym_index_expression] = STATE(2069),
    [sym_typed_expression] = STATE(2069),
    [sym_declaration_expression] = STATE(2069),
    [sym_do_expression] = STATE(2069),
    [sym_list_expression] = STATE(2069),
    [sym_array_expression] = STATE(2069),
    [sym_begin_end_expression] = STATE(2069),
    [sym_paren_expression] = STATE(2069),
    [sym__high_prec_app] = STATE(2058),
    [sym__low_prec_app] = STATE(2058),
    [sym_application_expression] = STATE(2069),
    [sym_dot_expression] = STATE(2069),
    [sym_infix_expression] = STATE(2069),
    [sym_ce_expression] = STATE(2069),
    [sym_sequential_expression] = STATE(2069),
    [sym_char] = STATE(2052),
    [sym_format_string] = STATE(2056),
    [sym__string_literal] = STATE(2056),
    [sym_string] = STATE(2052),
    [sym_verbatim_string] = STATE(2052),
    [sym_bytearray] = STATE(2052),
    [sym_verbatim_bytearray] = STATE(2052),
    [sym_format_triple_quoted_string] = STATE(2057),
    [sym_triple_quoted_string] = STATE(2052),
    [sym_const] = STATE(2069),
    [sym_long_identifier] = STATE(2077),
    [sym_active_pattern] = STATE(1953),
    [sym__identifier_or_op] = STATE(2078),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(934),
    [sym_infix_op] = STATE(1048),
    [sym_sbyte] = STATE(2052),
    [sym_byte] = STATE(2052),
    [sym_int16] = STATE(2052),
    [sym_uint16] = STATE(2052),
    [sym_int32] = STATE(2052),
    [sym_uint32] = STATE(2052),
    [sym_nativeint] = STATE(2052),
    [sym_unativeint] = STATE(2052),
    [sym_int64] = STATE(2052),
    [sym_uint64] = STATE(2052),
    [sym_ieee32] = STATE(2052),
    [sym_ieee64] = STATE(2052),
    [sym_bignum] = STATE(2052),
    [sym_decimal] = STATE(2052),
    [sym_float] = STATE(1596),
    [sym_block_comment] = STATE(56),
    [sym_compiler_directive_decl] = STATE(56),
    [sym_fsi_directive_decl] = STATE(56),
    [sym_preproc_line] = STATE(56),
    [sym_preproc_if_in_expression] = STATE(2069),
    [aux_sym_sequential_expression_repeat1] = STATE(1815),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_EQ] = ACTIONS(223),
    [anon_sym_LBRACK_LT] = ACTIONS(223),
    [anon_sym_COLON] = ACTIONS(225),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_do] = ACTIONS(225),
    [anon_sym_and] = ACTIONS(225),
    [anon_sym_let] = ACTIONS(225),
    [anon_sym_let_BANG] = ACTIONS(223),
    [aux_sym_access_modifier_token1] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_COMMA] = ACTIONS(223),
    [anon_sym_null] = ACTIONS(225),
    [anon_sym_QMARK] = ACTIONS(225),
    [anon_sym_COLON_QMARK] = ACTIONS(225),
    [anon_sym_COLON_COLON] = ACTIONS(223),
    [anon_sym_AMP] = ACTIONS(225),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LBRACK_PIPE] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(225),
    [anon_sym_LT_AT] = ACTIONS(225),
    [anon_sym_LT_AT_AT] = ACTIONS(225),
    [anon_sym_DOT] = ACTIONS(581),
    [anon_sym_LBRACE_PIPE] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(225),
    [anon_sym_with] = ACTIONS(225),
    [anon_sym_return_BANG] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(225),
    [anon_sym_yield_BANG] = ACTIONS(223),
    [anon_sym_lazy] = ACTIONS(225),
    [anon_sym_assert] = ACTIONS(225),
    [anon_sym_upcast] = ACTIONS(225),
    [anon_sym_downcast] = ACTIONS(225),
    [anon_sym_COLON_GT] = ACTIONS(223),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(223),
    [anon_sym_for] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_fun] = ACTIONS(225),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_match] = ACTIONS(225),
    [anon_sym_match_BANG] = ACTIONS(223),
    [anon_sym_function] = ACTIONS(225),
    [anon_sym_LT_DASH] = ACTIONS(225),
    [anon_sym_DOT_LBRACK] = ACTIONS(605),
    [anon_sym_LT] = ACTIONS(607),
    [anon_sym_use] = ACTIONS(225),
    [anon_sym_use_BANG] = ACTIONS(223),
    [anon_sym_do_BANG] = ACTIONS(223),
    [anon_sym_begin] = ACTIONS(225),
    [anon_sym_LPAREN2] = ACTIONS(617),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_or] = ACTIONS(225),
    [anon_sym_static] = ACTIONS(225),
    [anon_sym_member] = ACTIONS(225),
    [anon_sym_interface] = ACTIONS(225),
    [anon_sym_abstract] = ACTIONS(225),
    [anon_sym_val] = ACTIONS(225),
    [anon_sym_override] = ACTIONS(225),
    [aux_sym_char_token1] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_AT_DQUOTE] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [sym_bool] = ACTIONS(225),
    [sym_unit] = ACTIONS(633),
    [anon_sym_LPAREN_PIPE] = ACTIONS(225),
    [sym_op_identifier] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(225),
    [anon_sym_DASH] = ACTIONS(225),
    [anon_sym_PLUS_DOT] = ACTIONS(225),
    [anon_sym_DASH_DOT] = ACTIONS(225),
    [anon_sym_PERCENT] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_TILDE] = ACTIONS(223),
    [aux_sym_prefix_op_token1] = ACTIONS(225),
    [aux_sym_infix_op_token1] = ACTIONS(223),
    [aux_sym_infix_op_token2] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_BANG_EQ] = ACTIONS(225),
    [anon_sym_COLON_EQ] = ACTIONS(223),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(225),
    [sym_int] = ACTIONS(225),
    [sym_xint] = ACTIONS(223),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(223),
    [anon_sym_POUNDendif] = ACTIONS(223),
    [sym__newline] = ACTIONS(223),
  },
  [57] = {
    [sym_function_or_value_defn] = STATE(1054),
    [sym__expression] = STATE(56),
    [sym_literal_expression] = STATE(2069),
    [sym_long_identifier_or_op] = STATE(2069),
    [sym_tuple_expression] = STATE(2069),
    [sym_brace_expression] = STATE(2069),
    [sym_anon_record_expression] = STATE(2069),
    [sym_prefixed_expression] = STATE(2069),
    [sym_typecast_expression] = STATE(2069),
    [sym_for_expression] = STATE(2069),
    [sym_while_expression] = STATE(2069),
    [sym__if_branch] = STATE(10893),
    [sym_if_expression] = STATE(2069),
    [sym_fun_expression] = STATE(2069),
    [sym_try_expression] = STATE(2069),
    [sym_match_expression] = STATE(2069),
    [sym_function_expression] = STATE(2069),
    [sym_mutate_expression] = STATE(2069),
    [sym_index_expression] = STATE(2069),
    [sym_typed_expression] = STATE(2069),
    [sym_declaration_expression] = STATE(2069),
    [sym_do_expression] = STATE(2069),
    [sym_list_expression] = STATE(2069),
    [sym_array_expression] = STATE(2069),
    [sym_begin_end_expression] = STATE(2069),
    [sym_paren_expression] = STATE(2069),
    [sym__high_prec_app] = STATE(2058),
    [sym__low_prec_app] = STATE(2058),
    [sym_application_expression] = STATE(2069),
    [sym_dot_expression] = STATE(2069),
    [sym_infix_expression] = STATE(2069),
    [sym_ce_expression] = STATE(2069),
    [sym_sequential_expression] = STATE(2069),
    [sym_char] = STATE(2052),
    [sym_format_string] = STATE(2056),
    [sym__string_literal] = STATE(2056),
    [sym_string] = STATE(2052),
    [sym_verbatim_string] = STATE(2052),
    [sym_bytearray] = STATE(2052),
    [sym_verbatim_bytearray] = STATE(2052),
    [sym_format_triple_quoted_string] = STATE(2057),
    [sym_triple_quoted_string] = STATE(2052),
    [sym_const] = STATE(2069),
    [sym_long_identifier] = STATE(2077),
    [sym_active_pattern] = STATE(1953),
    [sym__identifier_or_op] = STATE(2078),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(934),
    [sym_infix_op] = STATE(1048),
    [sym_sbyte] = STATE(2052),
    [sym_byte] = STATE(2052),
    [sym_int16] = STATE(2052),
    [sym_uint16] = STATE(2052),
    [sym_int32] = STATE(2052),
    [sym_uint32] = STATE(2052),
    [sym_nativeint] = STATE(2052),
    [sym_unativeint] = STATE(2052),
    [sym_int64] = STATE(2052),
    [sym_uint64] = STATE(2052),
    [sym_ieee32] = STATE(2052),
    [sym_ieee64] = STATE(2052),
    [sym_bignum] = STATE(2052),
    [sym_decimal] = STATE(2052),
    [sym_float] = STATE(1596),
    [sym_block_comment] = STATE(57),
    [sym_compiler_directive_decl] = STATE(57),
    [sym_fsi_directive_decl] = STATE(57),
    [sym_preproc_line] = STATE(57),
    [sym_preproc_if_in_expression] = STATE(2069),
    [aux_sym_sequential_expression_repeat1] = STATE(1815),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_EQ] = ACTIONS(227),
    [anon_sym_LBRACK_LT] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(229),
    [anon_sym_return] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_and] = ACTIONS(229),
    [anon_sym_let] = ACTIONS(229),
    [anon_sym_let_BANG] = ACTIONS(227),
    [aux_sym_access_modifier_token1] = ACTIONS(227),
    [anon_sym_LPAREN] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(227),
    [anon_sym_null] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_COLON_QMARK] = ACTIONS(229),
    [anon_sym_COLON_COLON] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_LBRACK] = ACTIONS(229),
    [anon_sym_LBRACK_PIPE] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(229),
    [anon_sym_LT_AT] = ACTIONS(229),
    [anon_sym_LT_AT_AT] = ACTIONS(229),
    [anon_sym_DOT] = ACTIONS(581),
    [anon_sym_LBRACE_PIPE] = ACTIONS(227),
    [anon_sym_new] = ACTIONS(229),
    [anon_sym_with] = ACTIONS(229),
    [anon_sym_return_BANG] = ACTIONS(227),
    [anon_sym_yield] = ACTIONS(229),
    [anon_sym_yield_BANG] = ACTIONS(227),
    [anon_sym_lazy] = ACTIONS(229),
    [anon_sym_assert] = ACTIONS(229),
    [anon_sym_upcast] = ACTIONS(229),
    [anon_sym_downcast] = ACTIONS(229),
    [anon_sym_COLON_GT] = ACTIONS(227),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_fun] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(229),
    [anon_sym_match_BANG] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(229),
    [anon_sym_LT_DASH] = ACTIONS(229),
    [anon_sym_DOT_LBRACK] = ACTIONS(605),
    [anon_sym_LT] = ACTIONS(607),
    [anon_sym_use] = ACTIONS(229),
    [anon_sym_use_BANG] = ACTIONS(227),
    [anon_sym_do_BANG] = ACTIONS(227),
    [anon_sym_begin] = ACTIONS(229),
    [anon_sym_LPAREN2] = ACTIONS(617),
    [anon_sym_default] = ACTIONS(229),
    [anon_sym_or] = ACTIONS(229),
    [anon_sym_static] = ACTIONS(229),
    [anon_sym_member] = ACTIONS(229),
    [anon_sym_interface] = ACTIONS(229),
    [anon_sym_abstract] = ACTIONS(229),
    [anon_sym_val] = ACTIONS(229),
    [anon_sym_override] = ACTIONS(229),
    [aux_sym_char_token1] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_AT_DQUOTE] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [sym_bool] = ACTIONS(229),
    [sym_unit] = ACTIONS(633),
    [anon_sym_LPAREN_PIPE] = ACTIONS(229),
    [sym_op_identifier] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(229),
    [anon_sym_PLUS_DOT] = ACTIONS(229),
    [anon_sym_DASH_DOT] = ACTIONS(229),
    [anon_sym_PERCENT] = ACTIONS(229),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(227),
    [aux_sym_prefix_op_token1] = ACTIONS(229),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token2] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(229),
    [anon_sym_BANG_EQ] = ACTIONS(229),
    [anon_sym_COLON_EQ] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(229),
    [sym_int] = ACTIONS(229),
    [sym_xint] = ACTIONS(227),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(227),
    [anon_sym_POUNDendif] = ACTIONS(227),
    [sym__newline] = ACTIONS(227),
  },
  [58] = {
    [sym_function_or_value_defn] = STATE(1084),
    [sym__expression] = STATE(58),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(936),
    [sym_infix_op] = STATE(1079),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(1592),
    [sym_block_comment] = STATE(58),
    [sym_compiler_directive_decl] = STATE(58),
    [sym_fsi_directive_decl] = STATE(58),
    [sym_preproc_line] = STATE(58),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_sequential_expression_repeat1] = STATE(1707),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_EQ] = ACTIONS(223),
    [anon_sym_LBRACK_LT] = ACTIONS(223),
    [anon_sym_COLON] = ACTIONS(225),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_do] = ACTIONS(225),
    [anon_sym_let] = ACTIONS(225),
    [anon_sym_let_BANG] = ACTIONS(223),
    [aux_sym_access_modifier_token1] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_COMMA] = ACTIONS(223),
    [anon_sym_null] = ACTIONS(225),
    [anon_sym_QMARK] = ACTIONS(225),
    [anon_sym_COLON_QMARK] = ACTIONS(225),
    [anon_sym_COLON_COLON] = ACTIONS(223),
    [anon_sym_AMP] = ACTIONS(225),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LBRACK_PIPE] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(225),
    [anon_sym_LT_AT] = ACTIONS(225),
    [anon_sym_LT_AT_AT] = ACTIONS(225),
    [anon_sym_DOT] = ACTIONS(669),
    [anon_sym_LBRACE_PIPE] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(225),
    [anon_sym_with] = ACTIONS(225),
    [anon_sym_return_BANG] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(225),
    [anon_sym_yield_BANG] = ACTIONS(223),
    [anon_sym_lazy] = ACTIONS(225),
    [anon_sym_assert] = ACTIONS(225),
    [anon_sym_upcast] = ACTIONS(225),
    [anon_sym_downcast] = ACTIONS(225),
    [anon_sym_COLON_GT] = ACTIONS(223),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(223),
    [anon_sym_for] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_fun] = ACTIONS(225),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_match] = ACTIONS(225),
    [anon_sym_match_BANG] = ACTIONS(223),
    [anon_sym_function] = ACTIONS(225),
    [anon_sym_LT_DASH] = ACTIONS(225),
    [anon_sym_DOT_LBRACK] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_use] = ACTIONS(225),
    [anon_sym_use_BANG] = ACTIONS(223),
    [anon_sym_do_BANG] = ACTIONS(223),
    [anon_sym_begin] = ACTIONS(225),
    [anon_sym_LPAREN2] = ACTIONS(705),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_or] = ACTIONS(225),
    [anon_sym_static] = ACTIONS(225),
    [anon_sym_member] = ACTIONS(225),
    [anon_sym_interface] = ACTIONS(225),
    [anon_sym_abstract] = ACTIONS(225),
    [anon_sym_val] = ACTIONS(225),
    [anon_sym_override] = ACTIONS(225),
    [anon_sym_inherit] = ACTIONS(225),
    [aux_sym_char_token1] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_AT_DQUOTE] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [sym_bool] = ACTIONS(225),
    [sym_unit] = ACTIONS(721),
    [anon_sym_LPAREN_PIPE] = ACTIONS(225),
    [sym_op_identifier] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(225),
    [anon_sym_DASH] = ACTIONS(225),
    [anon_sym_PLUS_DOT] = ACTIONS(225),
    [anon_sym_DASH_DOT] = ACTIONS(225),
    [anon_sym_PERCENT] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_TILDE] = ACTIONS(223),
    [aux_sym_prefix_op_token1] = ACTIONS(225),
    [aux_sym_infix_op_token1] = ACTIONS(223),
    [aux_sym_infix_op_token2] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_BANG_EQ] = ACTIONS(225),
    [anon_sym_COLON_EQ] = ACTIONS(223),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(225),
    [sym_int] = ACTIONS(225),
    [sym_xint] = ACTIONS(223),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(223),
    [anon_sym_POUNDendif] = ACTIONS(223),
    [sym__newline] = ACTIONS(223),
  },
  [59] = {
    [sym_function_or_value_defn] = STATE(1054),
    [sym__expression] = STATE(56),
    [sym_literal_expression] = STATE(2069),
    [sym_long_identifier_or_op] = STATE(2069),
    [sym_tuple_expression] = STATE(2069),
    [sym_brace_expression] = STATE(2069),
    [sym_anon_record_expression] = STATE(2069),
    [sym_prefixed_expression] = STATE(2069),
    [sym_typecast_expression] = STATE(2069),
    [sym_for_expression] = STATE(2069),
    [sym_while_expression] = STATE(2069),
    [sym__if_branch] = STATE(10893),
    [sym_if_expression] = STATE(2069),
    [sym_fun_expression] = STATE(2069),
    [sym_try_expression] = STATE(2069),
    [sym_match_expression] = STATE(2069),
    [sym_function_expression] = STATE(2069),
    [sym_mutate_expression] = STATE(2069),
    [sym_index_expression] = STATE(2069),
    [sym_typed_expression] = STATE(2069),
    [sym_declaration_expression] = STATE(2069),
    [sym_do_expression] = STATE(2069),
    [sym_list_expression] = STATE(2069),
    [sym_array_expression] = STATE(2069),
    [sym_begin_end_expression] = STATE(2069),
    [sym_paren_expression] = STATE(2069),
    [sym__high_prec_app] = STATE(2058),
    [sym__low_prec_app] = STATE(2058),
    [sym_application_expression] = STATE(2069),
    [sym_dot_expression] = STATE(2069),
    [sym_infix_expression] = STATE(2069),
    [sym_ce_expression] = STATE(2069),
    [sym_sequential_expression] = STATE(2069),
    [sym_char] = STATE(2052),
    [sym_format_string] = STATE(2056),
    [sym__string_literal] = STATE(2056),
    [sym_string] = STATE(2052),
    [sym_verbatim_string] = STATE(2052),
    [sym_bytearray] = STATE(2052),
    [sym_verbatim_bytearray] = STATE(2052),
    [sym_format_triple_quoted_string] = STATE(2057),
    [sym_triple_quoted_string] = STATE(2052),
    [sym_const] = STATE(2069),
    [sym_long_identifier] = STATE(2077),
    [sym_active_pattern] = STATE(1953),
    [sym__identifier_or_op] = STATE(2078),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(934),
    [sym_infix_op] = STATE(1048),
    [sym_sbyte] = STATE(2052),
    [sym_byte] = STATE(2052),
    [sym_int16] = STATE(2052),
    [sym_uint16] = STATE(2052),
    [sym_int32] = STATE(2052),
    [sym_uint32] = STATE(2052),
    [sym_nativeint] = STATE(2052),
    [sym_unativeint] = STATE(2052),
    [sym_int64] = STATE(2052),
    [sym_uint64] = STATE(2052),
    [sym_ieee32] = STATE(2052),
    [sym_ieee64] = STATE(2052),
    [sym_bignum] = STATE(2052),
    [sym_decimal] = STATE(2052),
    [sym_float] = STATE(1596),
    [sym_block_comment] = STATE(59),
    [sym_compiler_directive_decl] = STATE(59),
    [sym_fsi_directive_decl] = STATE(59),
    [sym_preproc_line] = STATE(59),
    [sym_preproc_if_in_expression] = STATE(2069),
    [aux_sym_sequential_expression_repeat1] = STATE(1815),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(557),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(119),
    [anon_sym_COLON] = ACTIONS(559),
    [anon_sym_return] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(563),
    [anon_sym_and] = ACTIONS(123),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(119),
    [anon_sym_LPAREN] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(567),
    [anon_sym_null] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(559),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(571),
    [anon_sym_LBRACK_PIPE] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(575),
    [anon_sym_LT_AT] = ACTIONS(577),
    [anon_sym_LT_AT_AT] = ACTIONS(579),
    [anon_sym_DOT] = ACTIONS(581),
    [anon_sym_LBRACE_PIPE] = ACTIONS(583),
    [anon_sym_new] = ACTIONS(561),
    [anon_sym_with] = ACTIONS(123),
    [anon_sym_return_BANG] = ACTIONS(585),
    [anon_sym_yield] = ACTIONS(561),
    [anon_sym_yield_BANG] = ACTIONS(585),
    [anon_sym_lazy] = ACTIONS(561),
    [anon_sym_assert] = ACTIONS(561),
    [anon_sym_upcast] = ACTIONS(561),
    [anon_sym_downcast] = ACTIONS(561),
    [anon_sym_COLON_GT] = ACTIONS(587),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(587),
    [anon_sym_for] = ACTIONS(589),
    [anon_sym_while] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(593),
    [anon_sym_try] = ACTIONS(595),
    [anon_sym_match] = ACTIONS(597),
    [anon_sym_match_BANG] = ACTIONS(599),
    [anon_sym_function] = ACTIONS(601),
    [anon_sym_LT_DASH] = ACTIONS(603),
    [anon_sym_DOT_LBRACK] = ACTIONS(605),
    [anon_sym_LT] = ACTIONS(607),
    [anon_sym_use] = ACTIONS(609),
    [anon_sym_use_BANG] = ACTIONS(611),
    [anon_sym_do_BANG] = ACTIONS(613),
    [anon_sym_begin] = ACTIONS(615),
    [anon_sym_LPAREN2] = ACTIONS(617),
    [anon_sym_default] = ACTIONS(123),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(123),
    [anon_sym_member] = ACTIONS(123),
    [anon_sym_interface] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(123),
    [anon_sym_val] = ACTIONS(123),
    [anon_sym_override] = ACTIONS(123),
    [aux_sym_char_token1] = ACTIONS(619),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(621),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [anon_sym_AT_DQUOTE] = ACTIONS(625),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(627),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(629),
    [sym_bool] = ACTIONS(631),
    [sym_unit] = ACTIONS(633),
    [anon_sym_LPAREN_PIPE] = ACTIONS(635),
    [sym_op_identifier] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(639),
    [sym_xint] = ACTIONS(641),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(643),
    [anon_sym_POUNDendif] = ACTIONS(119),
    [sym__newline] = ACTIONS(119),
  },
  [60] = {
    [sym_function_or_value_defn] = STATE(1054),
    [sym__expression] = STATE(56),
    [sym_literal_expression] = STATE(2069),
    [sym_long_identifier_or_op] = STATE(2069),
    [sym_tuple_expression] = STATE(2069),
    [sym_brace_expression] = STATE(2069),
    [sym_anon_record_expression] = STATE(2069),
    [sym_prefixed_expression] = STATE(2069),
    [sym_typecast_expression] = STATE(2069),
    [sym_for_expression] = STATE(2069),
    [sym_while_expression] = STATE(2069),
    [sym__if_branch] = STATE(10893),
    [sym_if_expression] = STATE(2069),
    [sym_fun_expression] = STATE(2069),
    [sym_try_expression] = STATE(2069),
    [sym_match_expression] = STATE(2069),
    [sym_function_expression] = STATE(2069),
    [sym_mutate_expression] = STATE(2069),
    [sym_index_expression] = STATE(2069),
    [sym_typed_expression] = STATE(2069),
    [sym_declaration_expression] = STATE(2069),
    [sym_do_expression] = STATE(2069),
    [sym_list_expression] = STATE(2069),
    [sym_array_expression] = STATE(2069),
    [sym_begin_end_expression] = STATE(2069),
    [sym_paren_expression] = STATE(2069),
    [sym__high_prec_app] = STATE(2058),
    [sym__low_prec_app] = STATE(2058),
    [sym_application_expression] = STATE(2069),
    [sym_dot_expression] = STATE(2069),
    [sym_infix_expression] = STATE(2069),
    [sym_ce_expression] = STATE(2069),
    [sym_sequential_expression] = STATE(2069),
    [sym_char] = STATE(2052),
    [sym_format_string] = STATE(2056),
    [sym__string_literal] = STATE(2056),
    [sym_string] = STATE(2052),
    [sym_verbatim_string] = STATE(2052),
    [sym_bytearray] = STATE(2052),
    [sym_verbatim_bytearray] = STATE(2052),
    [sym_format_triple_quoted_string] = STATE(2057),
    [sym_triple_quoted_string] = STATE(2052),
    [sym_const] = STATE(2069),
    [sym_long_identifier] = STATE(2077),
    [sym_active_pattern] = STATE(1953),
    [sym__identifier_or_op] = STATE(2078),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(934),
    [sym_infix_op] = STATE(1048),
    [sym_sbyte] = STATE(2052),
    [sym_byte] = STATE(2052),
    [sym_int16] = STATE(2052),
    [sym_uint16] = STATE(2052),
    [sym_int32] = STATE(2052),
    [sym_uint32] = STATE(2052),
    [sym_nativeint] = STATE(2052),
    [sym_unativeint] = STATE(2052),
    [sym_int64] = STATE(2052),
    [sym_uint64] = STATE(2052),
    [sym_ieee32] = STATE(2052),
    [sym_ieee64] = STATE(2052),
    [sym_bignum] = STATE(2052),
    [sym_decimal] = STATE(2052),
    [sym_float] = STATE(1596),
    [sym_block_comment] = STATE(60),
    [sym_compiler_directive_decl] = STATE(60),
    [sym_fsi_directive_decl] = STATE(60),
    [sym_preproc_line] = STATE(60),
    [sym_preproc_if_in_expression] = STATE(2069),
    [aux_sym_sequential_expression_repeat1] = STATE(1815),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(557),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(265),
    [anon_sym_COLON] = ACTIONS(559),
    [anon_sym_return] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(563),
    [anon_sym_and] = ACTIONS(267),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(265),
    [anon_sym_LPAREN] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(567),
    [anon_sym_null] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(559),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(571),
    [anon_sym_LBRACK_PIPE] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(575),
    [anon_sym_LT_AT] = ACTIONS(577),
    [anon_sym_LT_AT_AT] = ACTIONS(579),
    [anon_sym_DOT] = ACTIONS(581),
    [anon_sym_LBRACE_PIPE] = ACTIONS(583),
    [anon_sym_new] = ACTIONS(561),
    [anon_sym_with] = ACTIONS(267),
    [anon_sym_return_BANG] = ACTIONS(585),
    [anon_sym_yield] = ACTIONS(561),
    [anon_sym_yield_BANG] = ACTIONS(585),
    [anon_sym_lazy] = ACTIONS(561),
    [anon_sym_assert] = ACTIONS(561),
    [anon_sym_upcast] = ACTIONS(561),
    [anon_sym_downcast] = ACTIONS(561),
    [anon_sym_COLON_GT] = ACTIONS(587),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(587),
    [anon_sym_for] = ACTIONS(589),
    [anon_sym_while] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(593),
    [anon_sym_try] = ACTIONS(595),
    [anon_sym_match] = ACTIONS(597),
    [anon_sym_match_BANG] = ACTIONS(599),
    [anon_sym_function] = ACTIONS(601),
    [anon_sym_LT_DASH] = ACTIONS(603),
    [anon_sym_DOT_LBRACK] = ACTIONS(605),
    [anon_sym_LT] = ACTIONS(607),
    [anon_sym_use] = ACTIONS(609),
    [anon_sym_use_BANG] = ACTIONS(611),
    [anon_sym_do_BANG] = ACTIONS(613),
    [anon_sym_begin] = ACTIONS(615),
    [anon_sym_LPAREN2] = ACTIONS(617),
    [anon_sym_default] = ACTIONS(267),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(267),
    [anon_sym_member] = ACTIONS(267),
    [anon_sym_interface] = ACTIONS(267),
    [anon_sym_abstract] = ACTIONS(267),
    [anon_sym_val] = ACTIONS(267),
    [anon_sym_override] = ACTIONS(267),
    [aux_sym_char_token1] = ACTIONS(619),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(621),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [anon_sym_AT_DQUOTE] = ACTIONS(625),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(627),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(629),
    [sym_bool] = ACTIONS(631),
    [sym_unit] = ACTIONS(633),
    [anon_sym_LPAREN_PIPE] = ACTIONS(635),
    [sym_op_identifier] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(639),
    [sym_xint] = ACTIONS(641),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(643),
    [anon_sym_POUNDendif] = ACTIONS(265),
    [sym__newline] = ACTIONS(645),
  },
  [61] = {
    [sym_function_or_value_defn] = STATE(1084),
    [sym__expression] = STATE(58),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(936),
    [sym_infix_op] = STATE(1079),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(1592),
    [sym_block_comment] = STATE(61),
    [sym_compiler_directive_decl] = STATE(61),
    [sym_fsi_directive_decl] = STATE(61),
    [sym_preproc_line] = STATE(61),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_sequential_expression_repeat1] = STATE(1707),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(265),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_return] = ACTIONS(651),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(265),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(655),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(649),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(667),
    [anon_sym_DOT] = ACTIONS(669),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(651),
    [anon_sym_with] = ACTIONS(267),
    [anon_sym_return_BANG] = ACTIONS(673),
    [anon_sym_yield] = ACTIONS(651),
    [anon_sym_yield_BANG] = ACTIONS(673),
    [anon_sym_lazy] = ACTIONS(651),
    [anon_sym_assert] = ACTIONS(651),
    [anon_sym_upcast] = ACTIONS(651),
    [anon_sym_downcast] = ACTIONS(651),
    [anon_sym_COLON_GT] = ACTIONS(675),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_LT_DASH] = ACTIONS(691),
    [anon_sym_DOT_LBRACK] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_use] = ACTIONS(697),
    [anon_sym_use_BANG] = ACTIONS(699),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [anon_sym_LPAREN2] = ACTIONS(705),
    [anon_sym_default] = ACTIONS(267),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(267),
    [anon_sym_member] = ACTIONS(267),
    [anon_sym_interface] = ACTIONS(267),
    [anon_sym_abstract] = ACTIONS(267),
    [anon_sym_val] = ACTIONS(267),
    [anon_sym_override] = ACTIONS(267),
    [anon_sym_inherit] = ACTIONS(267),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(721),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(727),
    [sym_xint] = ACTIONS(729),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
    [anon_sym_POUNDendif] = ACTIONS(265),
    [sym__newline] = ACTIONS(739),
  },
  [62] = {
    [sym_function_or_value_defn] = STATE(1084),
    [sym__expression] = STATE(58),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(936),
    [sym_infix_op] = STATE(1079),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(1592),
    [sym_block_comment] = STATE(62),
    [sym_compiler_directive_decl] = STATE(62),
    [sym_fsi_directive_decl] = STATE(62),
    [sym_preproc_line] = STATE(62),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_sequential_expression_repeat1] = STATE(1707),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(261),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_return] = ACTIONS(651),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(261),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(655),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(649),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(667),
    [anon_sym_DOT] = ACTIONS(669),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(651),
    [anon_sym_with] = ACTIONS(263),
    [anon_sym_return_BANG] = ACTIONS(673),
    [anon_sym_yield] = ACTIONS(651),
    [anon_sym_yield_BANG] = ACTIONS(673),
    [anon_sym_lazy] = ACTIONS(651),
    [anon_sym_assert] = ACTIONS(651),
    [anon_sym_upcast] = ACTIONS(651),
    [anon_sym_downcast] = ACTIONS(651),
    [anon_sym_COLON_GT] = ACTIONS(675),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_LT_DASH] = ACTIONS(691),
    [anon_sym_DOT_LBRACK] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_use] = ACTIONS(697),
    [anon_sym_use_BANG] = ACTIONS(699),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [anon_sym_LPAREN2] = ACTIONS(705),
    [anon_sym_default] = ACTIONS(263),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(263),
    [anon_sym_member] = ACTIONS(263),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_abstract] = ACTIONS(263),
    [anon_sym_val] = ACTIONS(263),
    [anon_sym_override] = ACTIONS(263),
    [anon_sym_inherit] = ACTIONS(263),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(721),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(727),
    [sym_xint] = ACTIONS(729),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
    [anon_sym_POUNDendif] = ACTIONS(261),
    [sym__newline] = ACTIONS(739),
  },
  [63] = {
    [sym_function_or_value_defn] = STATE(1054),
    [sym__expression] = STATE(56),
    [sym_literal_expression] = STATE(2069),
    [sym_long_identifier_or_op] = STATE(2069),
    [sym_tuple_expression] = STATE(2069),
    [sym_brace_expression] = STATE(2069),
    [sym_anon_record_expression] = STATE(2069),
    [sym_prefixed_expression] = STATE(2069),
    [sym_typecast_expression] = STATE(2069),
    [sym_for_expression] = STATE(2069),
    [sym_while_expression] = STATE(2069),
    [sym__if_branch] = STATE(10893),
    [sym_if_expression] = STATE(2069),
    [sym_fun_expression] = STATE(2069),
    [sym_try_expression] = STATE(2069),
    [sym_match_expression] = STATE(2069),
    [sym_function_expression] = STATE(2069),
    [sym_mutate_expression] = STATE(2069),
    [sym_index_expression] = STATE(2069),
    [sym_typed_expression] = STATE(2069),
    [sym_declaration_expression] = STATE(2069),
    [sym_do_expression] = STATE(2069),
    [sym_list_expression] = STATE(2069),
    [sym_array_expression] = STATE(2069),
    [sym_begin_end_expression] = STATE(2069),
    [sym_paren_expression] = STATE(2069),
    [sym__high_prec_app] = STATE(2058),
    [sym__low_prec_app] = STATE(2058),
    [sym_application_expression] = STATE(2069),
    [sym_dot_expression] = STATE(2069),
    [sym_infix_expression] = STATE(2069),
    [sym_ce_expression] = STATE(2069),
    [sym_sequential_expression] = STATE(2069),
    [sym_char] = STATE(2052),
    [sym_format_string] = STATE(2056),
    [sym__string_literal] = STATE(2056),
    [sym_string] = STATE(2052),
    [sym_verbatim_string] = STATE(2052),
    [sym_bytearray] = STATE(2052),
    [sym_verbatim_bytearray] = STATE(2052),
    [sym_format_triple_quoted_string] = STATE(2057),
    [sym_triple_quoted_string] = STATE(2052),
    [sym_const] = STATE(2069),
    [sym_long_identifier] = STATE(2077),
    [sym_active_pattern] = STATE(1953),
    [sym__identifier_or_op] = STATE(2078),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(934),
    [sym_infix_op] = STATE(1048),
    [sym_sbyte] = STATE(2052),
    [sym_byte] = STATE(2052),
    [sym_int16] = STATE(2052),
    [sym_uint16] = STATE(2052),
    [sym_int32] = STATE(2052),
    [sym_uint32] = STATE(2052),
    [sym_nativeint] = STATE(2052),
    [sym_unativeint] = STATE(2052),
    [sym_int64] = STATE(2052),
    [sym_uint64] = STATE(2052),
    [sym_ieee32] = STATE(2052),
    [sym_ieee64] = STATE(2052),
    [sym_bignum] = STATE(2052),
    [sym_decimal] = STATE(2052),
    [sym_float] = STATE(1596),
    [sym_block_comment] = STATE(63),
    [sym_compiler_directive_decl] = STATE(63),
    [sym_fsi_directive_decl] = STATE(63),
    [sym_preproc_line] = STATE(63),
    [sym_preproc_if_in_expression] = STATE(2069),
    [aux_sym_sequential_expression_repeat1] = STATE(1815),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(557),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(247),
    [anon_sym_COLON] = ACTIONS(559),
    [anon_sym_return] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(249),
    [anon_sym_and] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(249),
    [anon_sym_let_BANG] = ACTIONS(247),
    [aux_sym_access_modifier_token1] = ACTIONS(247),
    [anon_sym_LPAREN] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(567),
    [anon_sym_null] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(559),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(571),
    [anon_sym_LBRACK_PIPE] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(575),
    [anon_sym_LT_AT] = ACTIONS(577),
    [anon_sym_LT_AT_AT] = ACTIONS(579),
    [anon_sym_DOT] = ACTIONS(581),
    [anon_sym_LBRACE_PIPE] = ACTIONS(583),
    [anon_sym_new] = ACTIONS(249),
    [anon_sym_with] = ACTIONS(741),
    [anon_sym_return_BANG] = ACTIONS(585),
    [anon_sym_yield] = ACTIONS(561),
    [anon_sym_yield_BANG] = ACTIONS(585),
    [anon_sym_lazy] = ACTIONS(561),
    [anon_sym_assert] = ACTIONS(561),
    [anon_sym_upcast] = ACTIONS(561),
    [anon_sym_downcast] = ACTIONS(561),
    [anon_sym_COLON_GT] = ACTIONS(587),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(587),
    [anon_sym_for] = ACTIONS(589),
    [anon_sym_while] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(593),
    [anon_sym_try] = ACTIONS(595),
    [anon_sym_match] = ACTIONS(597),
    [anon_sym_match_BANG] = ACTIONS(599),
    [anon_sym_function] = ACTIONS(601),
    [anon_sym_LT_DASH] = ACTIONS(603),
    [anon_sym_DOT_LBRACK] = ACTIONS(605),
    [anon_sym_LT] = ACTIONS(607),
    [anon_sym_use] = ACTIONS(609),
    [anon_sym_use_BANG] = ACTIONS(611),
    [anon_sym_do_BANG] = ACTIONS(613),
    [anon_sym_begin] = ACTIONS(615),
    [anon_sym_LPAREN2] = ACTIONS(617),
    [anon_sym_default] = ACTIONS(249),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(249),
    [anon_sym_member] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(249),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_val] = ACTIONS(249),
    [anon_sym_override] = ACTIONS(249),
    [aux_sym_char_token1] = ACTIONS(619),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(621),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [anon_sym_AT_DQUOTE] = ACTIONS(625),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(627),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(629),
    [sym_bool] = ACTIONS(631),
    [sym_unit] = ACTIONS(633),
    [anon_sym_LPAREN_PIPE] = ACTIONS(635),
    [sym_op_identifier] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(639),
    [sym_xint] = ACTIONS(641),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(247),
    [anon_sym_POUNDendif] = ACTIONS(247),
    [sym__newline] = ACTIONS(645),
  },
  [64] = {
    [sym_function_or_value_defn] = STATE(1084),
    [sym__expression] = STATE(58),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(936),
    [sym_infix_op] = STATE(1079),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(1592),
    [sym_block_comment] = STATE(64),
    [sym_compiler_directive_decl] = STATE(64),
    [sym_fsi_directive_decl] = STATE(64),
    [sym_preproc_line] = STATE(64),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_sequential_expression_repeat1] = STATE(1707),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_return] = ACTIONS(651),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(257),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(655),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(649),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(259),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(667),
    [anon_sym_DOT] = ACTIONS(669),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(651),
    [anon_sym_with] = ACTIONS(259),
    [anon_sym_return_BANG] = ACTIONS(673),
    [anon_sym_yield] = ACTIONS(651),
    [anon_sym_yield_BANG] = ACTIONS(673),
    [anon_sym_lazy] = ACTIONS(651),
    [anon_sym_assert] = ACTIONS(651),
    [anon_sym_upcast] = ACTIONS(651),
    [anon_sym_downcast] = ACTIONS(651),
    [anon_sym_COLON_GT] = ACTIONS(675),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_LT_DASH] = ACTIONS(691),
    [anon_sym_DOT_LBRACK] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_use] = ACTIONS(697),
    [anon_sym_use_BANG] = ACTIONS(699),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [anon_sym_LPAREN2] = ACTIONS(705),
    [anon_sym_default] = ACTIONS(259),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(259),
    [anon_sym_member] = ACTIONS(259),
    [anon_sym_interface] = ACTIONS(259),
    [anon_sym_abstract] = ACTIONS(259),
    [anon_sym_val] = ACTIONS(259),
    [anon_sym_override] = ACTIONS(259),
    [anon_sym_inherit] = ACTIONS(259),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(721),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(727),
    [sym_xint] = ACTIONS(729),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
    [anon_sym_POUNDendif] = ACTIONS(257),
    [sym__newline] = ACTIONS(257),
  },
  [65] = {
    [sym_function_or_value_defn] = STATE(1054),
    [sym__expression] = STATE(56),
    [sym_literal_expression] = STATE(2069),
    [sym_long_identifier_or_op] = STATE(2069),
    [sym_tuple_expression] = STATE(2069),
    [sym_brace_expression] = STATE(2069),
    [sym_anon_record_expression] = STATE(2069),
    [sym_prefixed_expression] = STATE(2069),
    [sym_typecast_expression] = STATE(2069),
    [sym_for_expression] = STATE(2069),
    [sym_while_expression] = STATE(2069),
    [sym__if_branch] = STATE(10893),
    [sym_if_expression] = STATE(2069),
    [sym_fun_expression] = STATE(2069),
    [sym_try_expression] = STATE(2069),
    [sym_match_expression] = STATE(2069),
    [sym_function_expression] = STATE(2069),
    [sym_mutate_expression] = STATE(2069),
    [sym_index_expression] = STATE(2069),
    [sym_typed_expression] = STATE(2069),
    [sym_declaration_expression] = STATE(2069),
    [sym_do_expression] = STATE(2069),
    [sym_list_expression] = STATE(2069),
    [sym_array_expression] = STATE(2069),
    [sym_begin_end_expression] = STATE(2069),
    [sym_paren_expression] = STATE(2069),
    [sym__high_prec_app] = STATE(2058),
    [sym__low_prec_app] = STATE(2058),
    [sym_application_expression] = STATE(2069),
    [sym_dot_expression] = STATE(2069),
    [sym_infix_expression] = STATE(2069),
    [sym_ce_expression] = STATE(2069),
    [sym_sequential_expression] = STATE(2069),
    [sym_char] = STATE(2052),
    [sym_format_string] = STATE(2056),
    [sym__string_literal] = STATE(2056),
    [sym_string] = STATE(2052),
    [sym_verbatim_string] = STATE(2052),
    [sym_bytearray] = STATE(2052),
    [sym_verbatim_bytearray] = STATE(2052),
    [sym_format_triple_quoted_string] = STATE(2057),
    [sym_triple_quoted_string] = STATE(2052),
    [sym_const] = STATE(2069),
    [sym_long_identifier] = STATE(2077),
    [sym_active_pattern] = STATE(1953),
    [sym__identifier_or_op] = STATE(2078),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(934),
    [sym_infix_op] = STATE(1048),
    [sym_sbyte] = STATE(2052),
    [sym_byte] = STATE(2052),
    [sym_int16] = STATE(2052),
    [sym_uint16] = STATE(2052),
    [sym_int32] = STATE(2052),
    [sym_uint32] = STATE(2052),
    [sym_nativeint] = STATE(2052),
    [sym_unativeint] = STATE(2052),
    [sym_int64] = STATE(2052),
    [sym_uint64] = STATE(2052),
    [sym_ieee32] = STATE(2052),
    [sym_ieee64] = STATE(2052),
    [sym_bignum] = STATE(2052),
    [sym_decimal] = STATE(2052),
    [sym_float] = STATE(1596),
    [sym_block_comment] = STATE(65),
    [sym_compiler_directive_decl] = STATE(65),
    [sym_fsi_directive_decl] = STATE(65),
    [sym_preproc_line] = STATE(65),
    [sym_preproc_if_in_expression] = STATE(2069),
    [aux_sym_sequential_expression_repeat1] = STATE(1815),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(557),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(559),
    [anon_sym_return] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(239),
    [anon_sym_and] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(239),
    [anon_sym_let_BANG] = ACTIONS(237),
    [aux_sym_access_modifier_token1] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(567),
    [anon_sym_null] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(559),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(571),
    [anon_sym_LBRACK_PIPE] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(575),
    [anon_sym_LT_AT] = ACTIONS(577),
    [anon_sym_LT_AT_AT] = ACTIONS(579),
    [anon_sym_DOT] = ACTIONS(581),
    [anon_sym_LBRACE_PIPE] = ACTIONS(583),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_with] = ACTIONS(743),
    [anon_sym_return_BANG] = ACTIONS(585),
    [anon_sym_yield] = ACTIONS(561),
    [anon_sym_yield_BANG] = ACTIONS(585),
    [anon_sym_lazy] = ACTIONS(561),
    [anon_sym_assert] = ACTIONS(561),
    [anon_sym_upcast] = ACTIONS(561),
    [anon_sym_downcast] = ACTIONS(561),
    [anon_sym_COLON_GT] = ACTIONS(587),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(587),
    [anon_sym_for] = ACTIONS(589),
    [anon_sym_while] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(593),
    [anon_sym_try] = ACTIONS(595),
    [anon_sym_match] = ACTIONS(597),
    [anon_sym_match_BANG] = ACTIONS(599),
    [anon_sym_function] = ACTIONS(601),
    [anon_sym_LT_DASH] = ACTIONS(603),
    [anon_sym_DOT_LBRACK] = ACTIONS(605),
    [anon_sym_LT] = ACTIONS(607),
    [anon_sym_use] = ACTIONS(609),
    [anon_sym_use_BANG] = ACTIONS(611),
    [anon_sym_do_BANG] = ACTIONS(613),
    [anon_sym_begin] = ACTIONS(615),
    [anon_sym_LPAREN2] = ACTIONS(617),
    [anon_sym_default] = ACTIONS(239),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(239),
    [anon_sym_member] = ACTIONS(239),
    [anon_sym_interface] = ACTIONS(239),
    [anon_sym_abstract] = ACTIONS(239),
    [anon_sym_val] = ACTIONS(239),
    [anon_sym_override] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(619),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(621),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [anon_sym_AT_DQUOTE] = ACTIONS(625),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(627),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(629),
    [sym_bool] = ACTIONS(631),
    [sym_unit] = ACTIONS(633),
    [anon_sym_LPAREN_PIPE] = ACTIONS(635),
    [sym_op_identifier] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(639),
    [sym_xint] = ACTIONS(641),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(237),
    [anon_sym_POUNDendif] = ACTIONS(237),
    [sym__newline] = ACTIONS(645),
  },
  [66] = {
    [sym_function_or_value_defn] = STATE(1054),
    [sym__expression] = STATE(56),
    [sym_literal_expression] = STATE(2069),
    [sym_long_identifier_or_op] = STATE(2069),
    [sym_tuple_expression] = STATE(2069),
    [sym_brace_expression] = STATE(2069),
    [sym_anon_record_expression] = STATE(2069),
    [sym_prefixed_expression] = STATE(2069),
    [sym_typecast_expression] = STATE(2069),
    [sym_for_expression] = STATE(2069),
    [sym_while_expression] = STATE(2069),
    [sym__if_branch] = STATE(10893),
    [sym_if_expression] = STATE(2069),
    [sym_fun_expression] = STATE(2069),
    [sym_try_expression] = STATE(2069),
    [sym_match_expression] = STATE(2069),
    [sym_function_expression] = STATE(2069),
    [sym_mutate_expression] = STATE(2069),
    [sym_index_expression] = STATE(2069),
    [sym_typed_expression] = STATE(2069),
    [sym_declaration_expression] = STATE(2069),
    [sym_do_expression] = STATE(2069),
    [sym_list_expression] = STATE(2069),
    [sym_array_expression] = STATE(2069),
    [sym_begin_end_expression] = STATE(2069),
    [sym_paren_expression] = STATE(2069),
    [sym__high_prec_app] = STATE(2058),
    [sym__low_prec_app] = STATE(2058),
    [sym_application_expression] = STATE(2069),
    [sym_dot_expression] = STATE(2069),
    [sym_infix_expression] = STATE(2069),
    [sym_ce_expression] = STATE(2069),
    [sym_sequential_expression] = STATE(2069),
    [sym_char] = STATE(2052),
    [sym_format_string] = STATE(2056),
    [sym__string_literal] = STATE(2056),
    [sym_string] = STATE(2052),
    [sym_verbatim_string] = STATE(2052),
    [sym_bytearray] = STATE(2052),
    [sym_verbatim_bytearray] = STATE(2052),
    [sym_format_triple_quoted_string] = STATE(2057),
    [sym_triple_quoted_string] = STATE(2052),
    [sym_const] = STATE(2069),
    [sym_long_identifier] = STATE(2077),
    [sym_active_pattern] = STATE(1953),
    [sym__identifier_or_op] = STATE(2078),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(934),
    [sym_infix_op] = STATE(1048),
    [sym_sbyte] = STATE(2052),
    [sym_byte] = STATE(2052),
    [sym_int16] = STATE(2052),
    [sym_uint16] = STATE(2052),
    [sym_int32] = STATE(2052),
    [sym_uint32] = STATE(2052),
    [sym_nativeint] = STATE(2052),
    [sym_unativeint] = STATE(2052),
    [sym_int64] = STATE(2052),
    [sym_uint64] = STATE(2052),
    [sym_ieee32] = STATE(2052),
    [sym_ieee64] = STATE(2052),
    [sym_bignum] = STATE(2052),
    [sym_decimal] = STATE(2052),
    [sym_float] = STATE(1596),
    [sym_block_comment] = STATE(66),
    [sym_compiler_directive_decl] = STATE(66),
    [sym_fsi_directive_decl] = STATE(66),
    [sym_preproc_line] = STATE(66),
    [sym_preproc_if_in_expression] = STATE(2069),
    [aux_sym_sequential_expression_repeat1] = STATE(1815),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(557),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(559),
    [anon_sym_return] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(563),
    [anon_sym_and] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(257),
    [anon_sym_LPAREN] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(567),
    [anon_sym_null] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(559),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(571),
    [anon_sym_LBRACK_PIPE] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(259),
    [anon_sym_LT_AT] = ACTIONS(577),
    [anon_sym_LT_AT_AT] = ACTIONS(579),
    [anon_sym_DOT] = ACTIONS(581),
    [anon_sym_LBRACE_PIPE] = ACTIONS(583),
    [anon_sym_new] = ACTIONS(561),
    [anon_sym_with] = ACTIONS(259),
    [anon_sym_return_BANG] = ACTIONS(585),
    [anon_sym_yield] = ACTIONS(561),
    [anon_sym_yield_BANG] = ACTIONS(585),
    [anon_sym_lazy] = ACTIONS(561),
    [anon_sym_assert] = ACTIONS(561),
    [anon_sym_upcast] = ACTIONS(561),
    [anon_sym_downcast] = ACTIONS(561),
    [anon_sym_COLON_GT] = ACTIONS(587),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(587),
    [anon_sym_for] = ACTIONS(589),
    [anon_sym_while] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(593),
    [anon_sym_try] = ACTIONS(595),
    [anon_sym_match] = ACTIONS(597),
    [anon_sym_match_BANG] = ACTIONS(599),
    [anon_sym_function] = ACTIONS(601),
    [anon_sym_LT_DASH] = ACTIONS(603),
    [anon_sym_DOT_LBRACK] = ACTIONS(605),
    [anon_sym_LT] = ACTIONS(607),
    [anon_sym_use] = ACTIONS(609),
    [anon_sym_use_BANG] = ACTIONS(611),
    [anon_sym_do_BANG] = ACTIONS(613),
    [anon_sym_begin] = ACTIONS(615),
    [anon_sym_LPAREN2] = ACTIONS(617),
    [anon_sym_default] = ACTIONS(259),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(259),
    [anon_sym_member] = ACTIONS(259),
    [anon_sym_interface] = ACTIONS(259),
    [anon_sym_abstract] = ACTIONS(259),
    [anon_sym_val] = ACTIONS(259),
    [anon_sym_override] = ACTIONS(259),
    [aux_sym_char_token1] = ACTIONS(619),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(621),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [anon_sym_AT_DQUOTE] = ACTIONS(625),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(627),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(629),
    [sym_bool] = ACTIONS(631),
    [sym_unit] = ACTIONS(633),
    [anon_sym_LPAREN_PIPE] = ACTIONS(635),
    [sym_op_identifier] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(639),
    [sym_xint] = ACTIONS(641),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(643),
    [anon_sym_POUNDendif] = ACTIONS(257),
    [sym__newline] = ACTIONS(257),
  },
  [67] = {
    [sym_function_or_value_defn] = STATE(1084),
    [sym__expression] = STATE(58),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(936),
    [sym_infix_op] = STATE(1079),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(1592),
    [sym_block_comment] = STATE(67),
    [sym_compiler_directive_decl] = STATE(67),
    [sym_fsi_directive_decl] = STATE(67),
    [sym_preproc_line] = STATE(67),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_sequential_expression_repeat1] = STATE(1707),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(253),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_return] = ACTIONS(651),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(655),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(649),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(255),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(667),
    [anon_sym_DOT] = ACTIONS(669),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(651),
    [anon_sym_with] = ACTIONS(255),
    [anon_sym_return_BANG] = ACTIONS(673),
    [anon_sym_yield] = ACTIONS(651),
    [anon_sym_yield_BANG] = ACTIONS(673),
    [anon_sym_lazy] = ACTIONS(651),
    [anon_sym_assert] = ACTIONS(651),
    [anon_sym_upcast] = ACTIONS(651),
    [anon_sym_downcast] = ACTIONS(651),
    [anon_sym_COLON_GT] = ACTIONS(675),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_LT_DASH] = ACTIONS(691),
    [anon_sym_DOT_LBRACK] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_use] = ACTIONS(697),
    [anon_sym_use_BANG] = ACTIONS(699),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [anon_sym_LPAREN2] = ACTIONS(705),
    [anon_sym_default] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(255),
    [anon_sym_member] = ACTIONS(255),
    [anon_sym_interface] = ACTIONS(255),
    [anon_sym_abstract] = ACTIONS(255),
    [anon_sym_val] = ACTIONS(255),
    [anon_sym_override] = ACTIONS(255),
    [anon_sym_inherit] = ACTIONS(255),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(721),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(727),
    [sym_xint] = ACTIONS(729),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
    [anon_sym_POUNDendif] = ACTIONS(253),
    [sym__newline] = ACTIONS(253),
  },
  [68] = {
    [sym_function_or_value_defn] = STATE(1122),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(938),
    [sym_infix_op] = STATE(1116),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(1598),
    [sym_block_comment] = STATE(68),
    [sym_compiler_directive_decl] = STATE(68),
    [sym_fsi_directive_decl] = STATE(68),
    [sym_preproc_line] = STATE(68),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_sequential_expression_repeat1] = STATE(1706),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(247),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_return] = ACTIONS(475),
    [anon_sym_do] = ACTIONS(249),
    [anon_sym_and] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(249),
    [anon_sym_let_BANG] = ACTIONS(247),
    [aux_sym_access_modifier_token1] = ACTIONS(247),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(481),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(731),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(249),
    [anon_sym_with] = ACTIONS(745),
    [anon_sym_return_BANG] = ACTIONS(497),
    [anon_sym_yield] = ACTIONS(475),
    [anon_sym_yield_BANG] = ACTIONS(497),
    [anon_sym_lazy] = ACTIONS(475),
    [anon_sym_assert] = ACTIONS(475),
    [anon_sym_upcast] = ACTIONS(475),
    [anon_sym_downcast] = ACTIONS(475),
    [anon_sym_COLON_GT] = ACTIONS(499),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_LT_DASH] = ACTIONS(515),
    [anon_sym_DOT_LBRACK] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_use] = ACTIONS(521),
    [anon_sym_use_BANG] = ACTIONS(523),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [anon_sym_LPAREN2] = ACTIONS(529),
    [anon_sym_default] = ACTIONS(249),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(249),
    [anon_sym_member] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(249),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_val] = ACTIONS(249),
    [anon_sym_override] = ACTIONS(249),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(551),
    [sym_xint] = ACTIONS(553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(247),
    [sym__newline] = ACTIONS(247),
    [sym__dedent] = ACTIONS(247),
  },
  [69] = {
    [sym_function_or_value_defn] = STATE(1084),
    [sym__expression] = STATE(58),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(936),
    [sym_infix_op] = STATE(1079),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(1592),
    [sym_block_comment] = STATE(69),
    [sym_compiler_directive_decl] = STATE(69),
    [sym_fsi_directive_decl] = STATE(69),
    [sym_preproc_line] = STATE(69),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_sequential_expression_repeat1] = STATE(1707),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(243),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_return] = ACTIONS(651),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(655),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(649),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(667),
    [anon_sym_DOT] = ACTIONS(669),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(651),
    [anon_sym_with] = ACTIONS(245),
    [anon_sym_return_BANG] = ACTIONS(673),
    [anon_sym_yield] = ACTIONS(651),
    [anon_sym_yield_BANG] = ACTIONS(673),
    [anon_sym_lazy] = ACTIONS(651),
    [anon_sym_assert] = ACTIONS(651),
    [anon_sym_upcast] = ACTIONS(651),
    [anon_sym_downcast] = ACTIONS(651),
    [anon_sym_COLON_GT] = ACTIONS(675),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_LT_DASH] = ACTIONS(691),
    [anon_sym_DOT_LBRACK] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_use] = ACTIONS(697),
    [anon_sym_use_BANG] = ACTIONS(699),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [anon_sym_LPAREN2] = ACTIONS(705),
    [anon_sym_default] = ACTIONS(245),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_member] = ACTIONS(245),
    [anon_sym_interface] = ACTIONS(245),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_val] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_inherit] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(721),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(727),
    [sym_xint] = ACTIONS(729),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
    [anon_sym_POUNDendif] = ACTIONS(243),
    [sym__newline] = ACTIONS(243),
  },
  [70] = {
    [sym_function_or_value_defn] = STATE(1122),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(938),
    [sym_infix_op] = STATE(1116),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(1598),
    [sym_block_comment] = STATE(70),
    [sym_compiler_directive_decl] = STATE(70),
    [sym_fsi_directive_decl] = STATE(70),
    [sym_preproc_line] = STATE(70),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_sequential_expression_repeat1] = STATE(1706),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_return] = ACTIONS(475),
    [anon_sym_do] = ACTIONS(239),
    [anon_sym_and] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(239),
    [anon_sym_let_BANG] = ACTIONS(237),
    [aux_sym_access_modifier_token1] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(481),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(731),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_with] = ACTIONS(747),
    [anon_sym_return_BANG] = ACTIONS(497),
    [anon_sym_yield] = ACTIONS(475),
    [anon_sym_yield_BANG] = ACTIONS(497),
    [anon_sym_lazy] = ACTIONS(475),
    [anon_sym_assert] = ACTIONS(475),
    [anon_sym_upcast] = ACTIONS(475),
    [anon_sym_downcast] = ACTIONS(475),
    [anon_sym_COLON_GT] = ACTIONS(499),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_LT_DASH] = ACTIONS(515),
    [anon_sym_DOT_LBRACK] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_use] = ACTIONS(521),
    [anon_sym_use_BANG] = ACTIONS(523),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [anon_sym_LPAREN2] = ACTIONS(529),
    [anon_sym_default] = ACTIONS(239),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(239),
    [anon_sym_member] = ACTIONS(239),
    [anon_sym_interface] = ACTIONS(239),
    [anon_sym_abstract] = ACTIONS(239),
    [anon_sym_val] = ACTIONS(239),
    [anon_sym_override] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(551),
    [sym_xint] = ACTIONS(553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(237),
    [sym__newline] = ACTIONS(237),
    [sym__dedent] = ACTIONS(237),
  },
  [71] = {
    [sym_function_or_value_defn] = STATE(1122),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(938),
    [sym_infix_op] = STATE(1116),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(1598),
    [sym_block_comment] = STATE(71),
    [sym_compiler_directive_decl] = STATE(71),
    [sym_fsi_directive_decl] = STATE(71),
    [sym_preproc_line] = STATE(71),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_sequential_expression_repeat1] = STATE(1706),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_EQ] = ACTIONS(227),
    [anon_sym_LBRACK_LT] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(229),
    [anon_sym_return] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_and] = ACTIONS(229),
    [anon_sym_let] = ACTIONS(229),
    [anon_sym_let_BANG] = ACTIONS(227),
    [aux_sym_access_modifier_token1] = ACTIONS(227),
    [anon_sym_LPAREN] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(227),
    [anon_sym_null] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_COLON_QMARK] = ACTIONS(229),
    [anon_sym_COLON_COLON] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_LBRACK] = ACTIONS(229),
    [anon_sym_LBRACK_PIPE] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(229),
    [anon_sym_LT_AT] = ACTIONS(229),
    [anon_sym_LT_AT_AT] = ACTIONS(229),
    [anon_sym_DOT] = ACTIONS(493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(227),
    [anon_sym_new] = ACTIONS(229),
    [anon_sym_with] = ACTIONS(229),
    [anon_sym_return_BANG] = ACTIONS(227),
    [anon_sym_yield] = ACTIONS(229),
    [anon_sym_yield_BANG] = ACTIONS(227),
    [anon_sym_lazy] = ACTIONS(229),
    [anon_sym_assert] = ACTIONS(229),
    [anon_sym_upcast] = ACTIONS(229),
    [anon_sym_downcast] = ACTIONS(229),
    [anon_sym_COLON_GT] = ACTIONS(227),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_fun] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(229),
    [anon_sym_match_BANG] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(229),
    [anon_sym_LT_DASH] = ACTIONS(229),
    [anon_sym_DOT_LBRACK] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_use] = ACTIONS(229),
    [anon_sym_use_BANG] = ACTIONS(227),
    [anon_sym_do_BANG] = ACTIONS(227),
    [anon_sym_begin] = ACTIONS(229),
    [anon_sym_LPAREN2] = ACTIONS(529),
    [anon_sym_default] = ACTIONS(229),
    [anon_sym_or] = ACTIONS(229),
    [anon_sym_static] = ACTIONS(229),
    [anon_sym_member] = ACTIONS(229),
    [anon_sym_interface] = ACTIONS(229),
    [anon_sym_abstract] = ACTIONS(229),
    [anon_sym_val] = ACTIONS(229),
    [anon_sym_override] = ACTIONS(229),
    [aux_sym_char_token1] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_AT_DQUOTE] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [sym_bool] = ACTIONS(229),
    [sym_unit] = ACTIONS(545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(229),
    [sym_op_identifier] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(229),
    [anon_sym_PLUS_DOT] = ACTIONS(229),
    [anon_sym_DASH_DOT] = ACTIONS(229),
    [anon_sym_PERCENT] = ACTIONS(229),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(227),
    [aux_sym_prefix_op_token1] = ACTIONS(229),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token2] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(229),
    [anon_sym_BANG_EQ] = ACTIONS(229),
    [anon_sym_COLON_EQ] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(229),
    [sym_int] = ACTIONS(229),
    [sym_xint] = ACTIONS(227),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(227),
    [sym__newline] = ACTIONS(227),
    [sym__dedent] = ACTIONS(227),
  },
  [72] = {
    [sym_function_or_value_defn] = STATE(1054),
    [sym__expression] = STATE(56),
    [sym_literal_expression] = STATE(2069),
    [sym_long_identifier_or_op] = STATE(2069),
    [sym_tuple_expression] = STATE(2069),
    [sym_brace_expression] = STATE(2069),
    [sym_anon_record_expression] = STATE(2069),
    [sym_prefixed_expression] = STATE(2069),
    [sym_typecast_expression] = STATE(2069),
    [sym_for_expression] = STATE(2069),
    [sym_while_expression] = STATE(2069),
    [sym__if_branch] = STATE(10893),
    [sym_if_expression] = STATE(2069),
    [sym_fun_expression] = STATE(2069),
    [sym_try_expression] = STATE(2069),
    [sym_match_expression] = STATE(2069),
    [sym_function_expression] = STATE(2069),
    [sym_mutate_expression] = STATE(2069),
    [sym_index_expression] = STATE(2069),
    [sym_typed_expression] = STATE(2069),
    [sym_declaration_expression] = STATE(2069),
    [sym_do_expression] = STATE(2069),
    [sym_list_expression] = STATE(2069),
    [sym_array_expression] = STATE(2069),
    [sym_begin_end_expression] = STATE(2069),
    [sym_paren_expression] = STATE(2069),
    [sym__high_prec_app] = STATE(2058),
    [sym__low_prec_app] = STATE(2058),
    [sym_application_expression] = STATE(2069),
    [sym_dot_expression] = STATE(2069),
    [sym_infix_expression] = STATE(2069),
    [sym_ce_expression] = STATE(2069),
    [sym_sequential_expression] = STATE(2069),
    [sym_char] = STATE(2052),
    [sym_format_string] = STATE(2056),
    [sym__string_literal] = STATE(2056),
    [sym_string] = STATE(2052),
    [sym_verbatim_string] = STATE(2052),
    [sym_bytearray] = STATE(2052),
    [sym_verbatim_bytearray] = STATE(2052),
    [sym_format_triple_quoted_string] = STATE(2057),
    [sym_triple_quoted_string] = STATE(2052),
    [sym_const] = STATE(2069),
    [sym_long_identifier] = STATE(2077),
    [sym_active_pattern] = STATE(1953),
    [sym__identifier_or_op] = STATE(2078),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(934),
    [sym_infix_op] = STATE(1048),
    [sym_sbyte] = STATE(2052),
    [sym_byte] = STATE(2052),
    [sym_int16] = STATE(2052),
    [sym_uint16] = STATE(2052),
    [sym_int32] = STATE(2052),
    [sym_uint32] = STATE(2052),
    [sym_nativeint] = STATE(2052),
    [sym_unativeint] = STATE(2052),
    [sym_int64] = STATE(2052),
    [sym_uint64] = STATE(2052),
    [sym_ieee32] = STATE(2052),
    [sym_ieee64] = STATE(2052),
    [sym_bignum] = STATE(2052),
    [sym_decimal] = STATE(2052),
    [sym_float] = STATE(1596),
    [sym_block_comment] = STATE(72),
    [sym_compiler_directive_decl] = STATE(72),
    [sym_fsi_directive_decl] = STATE(72),
    [sym_preproc_line] = STATE(72),
    [sym_preproc_if_in_expression] = STATE(2069),
    [aux_sym_sequential_expression_repeat1] = STATE(1815),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(557),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(253),
    [anon_sym_COLON] = ACTIONS(559),
    [anon_sym_return] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(563),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(567),
    [anon_sym_null] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(559),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(571),
    [anon_sym_LBRACK_PIPE] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(255),
    [anon_sym_LT_AT] = ACTIONS(577),
    [anon_sym_LT_AT_AT] = ACTIONS(579),
    [anon_sym_DOT] = ACTIONS(581),
    [anon_sym_LBRACE_PIPE] = ACTIONS(583),
    [anon_sym_new] = ACTIONS(561),
    [anon_sym_with] = ACTIONS(255),
    [anon_sym_return_BANG] = ACTIONS(585),
    [anon_sym_yield] = ACTIONS(561),
    [anon_sym_yield_BANG] = ACTIONS(585),
    [anon_sym_lazy] = ACTIONS(561),
    [anon_sym_assert] = ACTIONS(561),
    [anon_sym_upcast] = ACTIONS(561),
    [anon_sym_downcast] = ACTIONS(561),
    [anon_sym_COLON_GT] = ACTIONS(587),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(587),
    [anon_sym_for] = ACTIONS(589),
    [anon_sym_while] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(593),
    [anon_sym_try] = ACTIONS(595),
    [anon_sym_match] = ACTIONS(597),
    [anon_sym_match_BANG] = ACTIONS(599),
    [anon_sym_function] = ACTIONS(601),
    [anon_sym_LT_DASH] = ACTIONS(603),
    [anon_sym_DOT_LBRACK] = ACTIONS(605),
    [anon_sym_LT] = ACTIONS(607),
    [anon_sym_use] = ACTIONS(609),
    [anon_sym_use_BANG] = ACTIONS(611),
    [anon_sym_do_BANG] = ACTIONS(613),
    [anon_sym_begin] = ACTIONS(615),
    [anon_sym_LPAREN2] = ACTIONS(617),
    [anon_sym_default] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(255),
    [anon_sym_member] = ACTIONS(255),
    [anon_sym_interface] = ACTIONS(255),
    [anon_sym_abstract] = ACTIONS(255),
    [anon_sym_val] = ACTIONS(255),
    [anon_sym_override] = ACTIONS(255),
    [aux_sym_char_token1] = ACTIONS(619),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(621),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [anon_sym_AT_DQUOTE] = ACTIONS(625),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(627),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(629),
    [sym_bool] = ACTIONS(631),
    [sym_unit] = ACTIONS(633),
    [anon_sym_LPAREN_PIPE] = ACTIONS(635),
    [sym_op_identifier] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(639),
    [sym_xint] = ACTIONS(641),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(643),
    [anon_sym_POUNDendif] = ACTIONS(253),
    [sym__newline] = ACTIONS(253),
  },
  [73] = {
    [sym_function_or_value_defn] = STATE(1084),
    [sym__expression] = STATE(58),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(936),
    [sym_infix_op] = STATE(1079),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(1592),
    [sym_block_comment] = STATE(73),
    [sym_compiler_directive_decl] = STATE(73),
    [sym_fsi_directive_decl] = STATE(73),
    [sym_preproc_line] = STATE(73),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_sequential_expression_repeat1] = STATE(1707),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_EQ] = ACTIONS(227),
    [anon_sym_LBRACK_LT] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(229),
    [anon_sym_return] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_let] = ACTIONS(229),
    [anon_sym_let_BANG] = ACTIONS(227),
    [aux_sym_access_modifier_token1] = ACTIONS(227),
    [anon_sym_LPAREN] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(227),
    [anon_sym_null] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_COLON_QMARK] = ACTIONS(229),
    [anon_sym_COLON_COLON] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_LBRACK] = ACTIONS(229),
    [anon_sym_LBRACK_PIPE] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(229),
    [anon_sym_LT_AT] = ACTIONS(229),
    [anon_sym_LT_AT_AT] = ACTIONS(229),
    [anon_sym_DOT] = ACTIONS(669),
    [anon_sym_LBRACE_PIPE] = ACTIONS(227),
    [anon_sym_new] = ACTIONS(229),
    [anon_sym_with] = ACTIONS(229),
    [anon_sym_return_BANG] = ACTIONS(227),
    [anon_sym_yield] = ACTIONS(229),
    [anon_sym_yield_BANG] = ACTIONS(227),
    [anon_sym_lazy] = ACTIONS(229),
    [anon_sym_assert] = ACTIONS(229),
    [anon_sym_upcast] = ACTIONS(229),
    [anon_sym_downcast] = ACTIONS(229),
    [anon_sym_COLON_GT] = ACTIONS(227),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_fun] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(229),
    [anon_sym_match_BANG] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(229),
    [anon_sym_LT_DASH] = ACTIONS(229),
    [anon_sym_DOT_LBRACK] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_use] = ACTIONS(229),
    [anon_sym_use_BANG] = ACTIONS(227),
    [anon_sym_do_BANG] = ACTIONS(227),
    [anon_sym_begin] = ACTIONS(229),
    [anon_sym_LPAREN2] = ACTIONS(705),
    [anon_sym_default] = ACTIONS(229),
    [anon_sym_or] = ACTIONS(229),
    [anon_sym_static] = ACTIONS(229),
    [anon_sym_member] = ACTIONS(229),
    [anon_sym_interface] = ACTIONS(229),
    [anon_sym_abstract] = ACTIONS(229),
    [anon_sym_val] = ACTIONS(229),
    [anon_sym_override] = ACTIONS(229),
    [anon_sym_inherit] = ACTIONS(229),
    [aux_sym_char_token1] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_AT_DQUOTE] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [sym_bool] = ACTIONS(229),
    [sym_unit] = ACTIONS(721),
    [anon_sym_LPAREN_PIPE] = ACTIONS(229),
    [sym_op_identifier] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(229),
    [anon_sym_PLUS_DOT] = ACTIONS(229),
    [anon_sym_DASH_DOT] = ACTIONS(229),
    [anon_sym_PERCENT] = ACTIONS(229),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(227),
    [aux_sym_prefix_op_token1] = ACTIONS(229),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token2] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(229),
    [anon_sym_BANG_EQ] = ACTIONS(229),
    [anon_sym_COLON_EQ] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(229),
    [sym_int] = ACTIONS(229),
    [sym_xint] = ACTIONS(227),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(227),
    [anon_sym_POUNDendif] = ACTIONS(227),
    [sym__newline] = ACTIONS(227),
  },
  [74] = {
    [sym_function_or_value_defn] = STATE(1054),
    [sym__expression] = STATE(56),
    [sym_literal_expression] = STATE(2069),
    [sym_long_identifier_or_op] = STATE(2069),
    [sym_tuple_expression] = STATE(2069),
    [sym_brace_expression] = STATE(2069),
    [sym_anon_record_expression] = STATE(2069),
    [sym_prefixed_expression] = STATE(2069),
    [sym_typecast_expression] = STATE(2069),
    [sym_for_expression] = STATE(2069),
    [sym_while_expression] = STATE(2069),
    [sym__if_branch] = STATE(10893),
    [sym_if_expression] = STATE(2069),
    [sym_fun_expression] = STATE(2069),
    [sym_try_expression] = STATE(2069),
    [sym_match_expression] = STATE(2069),
    [sym_function_expression] = STATE(2069),
    [sym_mutate_expression] = STATE(2069),
    [sym_index_expression] = STATE(2069),
    [sym_typed_expression] = STATE(2069),
    [sym_declaration_expression] = STATE(2069),
    [sym_do_expression] = STATE(2069),
    [sym_list_expression] = STATE(2069),
    [sym_array_expression] = STATE(2069),
    [sym_begin_end_expression] = STATE(2069),
    [sym_paren_expression] = STATE(2069),
    [sym__high_prec_app] = STATE(2058),
    [sym__low_prec_app] = STATE(2058),
    [sym_application_expression] = STATE(2069),
    [sym_dot_expression] = STATE(2069),
    [sym_infix_expression] = STATE(2069),
    [sym_ce_expression] = STATE(2069),
    [sym_sequential_expression] = STATE(2069),
    [sym_char] = STATE(2052),
    [sym_format_string] = STATE(2056),
    [sym__string_literal] = STATE(2056),
    [sym_string] = STATE(2052),
    [sym_verbatim_string] = STATE(2052),
    [sym_bytearray] = STATE(2052),
    [sym_verbatim_bytearray] = STATE(2052),
    [sym_format_triple_quoted_string] = STATE(2057),
    [sym_triple_quoted_string] = STATE(2052),
    [sym_const] = STATE(2069),
    [sym_long_identifier] = STATE(2077),
    [sym_active_pattern] = STATE(1953),
    [sym__identifier_or_op] = STATE(2078),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(934),
    [sym_infix_op] = STATE(1048),
    [sym_sbyte] = STATE(2052),
    [sym_byte] = STATE(2052),
    [sym_int16] = STATE(2052),
    [sym_uint16] = STATE(2052),
    [sym_int32] = STATE(2052),
    [sym_uint32] = STATE(2052),
    [sym_nativeint] = STATE(2052),
    [sym_unativeint] = STATE(2052),
    [sym_int64] = STATE(2052),
    [sym_uint64] = STATE(2052),
    [sym_ieee32] = STATE(2052),
    [sym_ieee64] = STATE(2052),
    [sym_bignum] = STATE(2052),
    [sym_decimal] = STATE(2052),
    [sym_float] = STATE(1596),
    [sym_block_comment] = STATE(74),
    [sym_compiler_directive_decl] = STATE(74),
    [sym_fsi_directive_decl] = STATE(74),
    [sym_preproc_line] = STATE(74),
    [sym_preproc_if_in_expression] = STATE(2069),
    [aux_sym_sequential_expression_repeat1] = STATE(1815),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(557),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(243),
    [anon_sym_COLON] = ACTIONS(559),
    [anon_sym_return] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(563),
    [anon_sym_and] = ACTIONS(245),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(567),
    [anon_sym_null] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(559),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(571),
    [anon_sym_LBRACK_PIPE] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_LT_AT] = ACTIONS(577),
    [anon_sym_LT_AT_AT] = ACTIONS(579),
    [anon_sym_DOT] = ACTIONS(581),
    [anon_sym_LBRACE_PIPE] = ACTIONS(583),
    [anon_sym_new] = ACTIONS(561),
    [anon_sym_with] = ACTIONS(245),
    [anon_sym_return_BANG] = ACTIONS(585),
    [anon_sym_yield] = ACTIONS(561),
    [anon_sym_yield_BANG] = ACTIONS(585),
    [anon_sym_lazy] = ACTIONS(561),
    [anon_sym_assert] = ACTIONS(561),
    [anon_sym_upcast] = ACTIONS(561),
    [anon_sym_downcast] = ACTIONS(561),
    [anon_sym_COLON_GT] = ACTIONS(587),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(587),
    [anon_sym_for] = ACTIONS(589),
    [anon_sym_while] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(593),
    [anon_sym_try] = ACTIONS(595),
    [anon_sym_match] = ACTIONS(597),
    [anon_sym_match_BANG] = ACTIONS(599),
    [anon_sym_function] = ACTIONS(601),
    [anon_sym_LT_DASH] = ACTIONS(603),
    [anon_sym_DOT_LBRACK] = ACTIONS(605),
    [anon_sym_LT] = ACTIONS(607),
    [anon_sym_use] = ACTIONS(609),
    [anon_sym_use_BANG] = ACTIONS(611),
    [anon_sym_do_BANG] = ACTIONS(613),
    [anon_sym_begin] = ACTIONS(615),
    [anon_sym_LPAREN2] = ACTIONS(617),
    [anon_sym_default] = ACTIONS(245),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_member] = ACTIONS(245),
    [anon_sym_interface] = ACTIONS(245),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_val] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(619),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(621),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [anon_sym_AT_DQUOTE] = ACTIONS(625),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(627),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(629),
    [sym_bool] = ACTIONS(631),
    [sym_unit] = ACTIONS(633),
    [anon_sym_LPAREN_PIPE] = ACTIONS(635),
    [sym_op_identifier] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(639),
    [sym_xint] = ACTIONS(641),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(643),
    [anon_sym_POUNDendif] = ACTIONS(243),
    [sym__newline] = ACTIONS(243),
  },
  [75] = {
    [sym_function_or_value_defn] = STATE(1084),
    [sym__expression] = STATE(58),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(936),
    [sym_infix_op] = STATE(1079),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(1592),
    [sym_block_comment] = STATE(75),
    [sym_compiler_directive_decl] = STATE(75),
    [sym_fsi_directive_decl] = STATE(75),
    [sym_preproc_line] = STATE(75),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_sequential_expression_repeat1] = STATE(1707),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_return] = ACTIONS(651),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(655),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(649),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(667),
    [anon_sym_DOT] = ACTIONS(669),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(651),
    [anon_sym_with] = ACTIONS(233),
    [anon_sym_return_BANG] = ACTIONS(673),
    [anon_sym_yield] = ACTIONS(651),
    [anon_sym_yield_BANG] = ACTIONS(673),
    [anon_sym_lazy] = ACTIONS(651),
    [anon_sym_assert] = ACTIONS(651),
    [anon_sym_upcast] = ACTIONS(651),
    [anon_sym_downcast] = ACTIONS(651),
    [anon_sym_COLON_GT] = ACTIONS(675),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_LT_DASH] = ACTIONS(691),
    [anon_sym_DOT_LBRACK] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_use] = ACTIONS(697),
    [anon_sym_use_BANG] = ACTIONS(699),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [anon_sym_LPAREN2] = ACTIONS(705),
    [anon_sym_default] = ACTIONS(233),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(233),
    [anon_sym_member] = ACTIONS(233),
    [anon_sym_interface] = ACTIONS(233),
    [anon_sym_abstract] = ACTIONS(233),
    [anon_sym_val] = ACTIONS(233),
    [anon_sym_override] = ACTIONS(233),
    [anon_sym_inherit] = ACTIONS(233),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(721),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(727),
    [sym_xint] = ACTIONS(729),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
    [anon_sym_POUNDendif] = ACTIONS(231),
    [sym__newline] = ACTIONS(739),
  },
  [76] = {
    [sym_function_or_value_defn] = STATE(1122),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(938),
    [sym_infix_op] = STATE(1116),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(1598),
    [sym_block_comment] = STATE(76),
    [sym_compiler_directive_decl] = STATE(76),
    [sym_fsi_directive_decl] = STATE(76),
    [sym_preproc_line] = STATE(76),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_sequential_expression_repeat1] = STATE(1706),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_EQ] = ACTIONS(223),
    [anon_sym_LBRACK_LT] = ACTIONS(223),
    [anon_sym_COLON] = ACTIONS(225),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_do] = ACTIONS(225),
    [anon_sym_and] = ACTIONS(225),
    [anon_sym_let] = ACTIONS(225),
    [anon_sym_let_BANG] = ACTIONS(223),
    [aux_sym_access_modifier_token1] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_COMMA] = ACTIONS(223),
    [anon_sym_null] = ACTIONS(225),
    [anon_sym_QMARK] = ACTIONS(225),
    [anon_sym_COLON_QMARK] = ACTIONS(225),
    [anon_sym_COLON_COLON] = ACTIONS(223),
    [anon_sym_AMP] = ACTIONS(225),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LBRACK_PIPE] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(225),
    [anon_sym_LT_AT] = ACTIONS(225),
    [anon_sym_LT_AT_AT] = ACTIONS(225),
    [anon_sym_DOT] = ACTIONS(493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(225),
    [anon_sym_with] = ACTIONS(225),
    [anon_sym_return_BANG] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(225),
    [anon_sym_yield_BANG] = ACTIONS(223),
    [anon_sym_lazy] = ACTIONS(225),
    [anon_sym_assert] = ACTIONS(225),
    [anon_sym_upcast] = ACTIONS(225),
    [anon_sym_downcast] = ACTIONS(225),
    [anon_sym_COLON_GT] = ACTIONS(223),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(223),
    [anon_sym_for] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_fun] = ACTIONS(225),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_match] = ACTIONS(225),
    [anon_sym_match_BANG] = ACTIONS(223),
    [anon_sym_function] = ACTIONS(225),
    [anon_sym_LT_DASH] = ACTIONS(225),
    [anon_sym_DOT_LBRACK] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_use] = ACTIONS(225),
    [anon_sym_use_BANG] = ACTIONS(223),
    [anon_sym_do_BANG] = ACTIONS(223),
    [anon_sym_begin] = ACTIONS(225),
    [anon_sym_LPAREN2] = ACTIONS(529),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_or] = ACTIONS(225),
    [anon_sym_static] = ACTIONS(225),
    [anon_sym_member] = ACTIONS(225),
    [anon_sym_interface] = ACTIONS(225),
    [anon_sym_abstract] = ACTIONS(225),
    [anon_sym_val] = ACTIONS(225),
    [anon_sym_override] = ACTIONS(225),
    [aux_sym_char_token1] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_AT_DQUOTE] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [sym_bool] = ACTIONS(225),
    [sym_unit] = ACTIONS(545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(225),
    [sym_op_identifier] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(225),
    [anon_sym_DASH] = ACTIONS(225),
    [anon_sym_PLUS_DOT] = ACTIONS(225),
    [anon_sym_DASH_DOT] = ACTIONS(225),
    [anon_sym_PERCENT] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_TILDE] = ACTIONS(223),
    [aux_sym_prefix_op_token1] = ACTIONS(225),
    [aux_sym_infix_op_token1] = ACTIONS(223),
    [aux_sym_infix_op_token2] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_BANG_EQ] = ACTIONS(225),
    [anon_sym_COLON_EQ] = ACTIONS(223),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(225),
    [sym_int] = ACTIONS(225),
    [sym_xint] = ACTIONS(223),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(223),
    [sym__newline] = ACTIONS(223),
    [sym__dedent] = ACTIONS(223),
  },
  [77] = {
    [sym_function_or_value_defn] = STATE(1122),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(938),
    [sym_infix_op] = STATE(1116),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(1598),
    [sym_block_comment] = STATE(77),
    [sym_compiler_directive_decl] = STATE(77),
    [sym_fsi_directive_decl] = STATE(77),
    [sym_preproc_line] = STATE(77),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_sequential_expression_repeat1] = STATE(1706),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(119),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_return] = ACTIONS(475),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_and] = ACTIONS(123),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(119),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(481),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(731),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(475),
    [anon_sym_with] = ACTIONS(123),
    [anon_sym_return_BANG] = ACTIONS(497),
    [anon_sym_yield] = ACTIONS(475),
    [anon_sym_yield_BANG] = ACTIONS(497),
    [anon_sym_lazy] = ACTIONS(475),
    [anon_sym_assert] = ACTIONS(475),
    [anon_sym_upcast] = ACTIONS(475),
    [anon_sym_downcast] = ACTIONS(475),
    [anon_sym_COLON_GT] = ACTIONS(499),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_LT_DASH] = ACTIONS(515),
    [anon_sym_DOT_LBRACK] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_use] = ACTIONS(521),
    [anon_sym_use_BANG] = ACTIONS(523),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [anon_sym_LPAREN2] = ACTIONS(529),
    [anon_sym_default] = ACTIONS(123),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(123),
    [anon_sym_member] = ACTIONS(123),
    [anon_sym_interface] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(123),
    [anon_sym_val] = ACTIONS(123),
    [anon_sym_override] = ACTIONS(123),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(551),
    [sym_xint] = ACTIONS(553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
    [sym__newline] = ACTIONS(119),
    [sym__dedent] = ACTIONS(119),
  },
  [78] = {
    [sym_function_or_value_defn] = STATE(1084),
    [sym__expression] = STATE(58),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(936),
    [sym_infix_op] = STATE(1079),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(1592),
    [sym_block_comment] = STATE(78),
    [sym_compiler_directive_decl] = STATE(78),
    [sym_fsi_directive_decl] = STATE(78),
    [sym_preproc_line] = STATE(78),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_sequential_expression_repeat1] = STATE(1707),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(119),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_return] = ACTIONS(651),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(119),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(655),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(649),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(667),
    [anon_sym_DOT] = ACTIONS(669),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(651),
    [anon_sym_with] = ACTIONS(123),
    [anon_sym_return_BANG] = ACTIONS(673),
    [anon_sym_yield] = ACTIONS(651),
    [anon_sym_yield_BANG] = ACTIONS(673),
    [anon_sym_lazy] = ACTIONS(651),
    [anon_sym_assert] = ACTIONS(651),
    [anon_sym_upcast] = ACTIONS(651),
    [anon_sym_downcast] = ACTIONS(651),
    [anon_sym_COLON_GT] = ACTIONS(675),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_LT_DASH] = ACTIONS(691),
    [anon_sym_DOT_LBRACK] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_use] = ACTIONS(697),
    [anon_sym_use_BANG] = ACTIONS(699),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [anon_sym_LPAREN2] = ACTIONS(705),
    [anon_sym_default] = ACTIONS(123),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(123),
    [anon_sym_member] = ACTIONS(123),
    [anon_sym_interface] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(123),
    [anon_sym_val] = ACTIONS(123),
    [anon_sym_override] = ACTIONS(123),
    [anon_sym_inherit] = ACTIONS(123),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(721),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(727),
    [sym_xint] = ACTIONS(729),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
    [anon_sym_POUNDendif] = ACTIONS(119),
    [sym__newline] = ACTIONS(119),
  },
  [79] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(946),
    [sym_infix_op] = STATE(1070),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(79),
    [sym_compiler_directive_decl] = STATE(79),
    [sym_fsi_directive_decl] = STATE(79),
    [sym_preproc_line] = STATE(79),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2120),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(261),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(261),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(759),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(753),
    [anon_sym_with] = ACTIONS(263),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(795),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_default] = ACTIONS(263),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(263),
    [anon_sym_member] = ACTIONS(263),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_abstract] = ACTIONS(263),
    [anon_sym_val] = ACTIONS(263),
    [anon_sym_override] = ACTIONS(263),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(837),
    [sym__dedent] = ACTIONS(261),
  },
  [80] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(946),
    [sym_infix_op] = STATE(1070),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(80),
    [sym_compiler_directive_decl] = STATE(80),
    [sym_fsi_directive_decl] = STATE(80),
    [sym_preproc_line] = STATE(80),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2120),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(119),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(119),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(759),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(753),
    [anon_sym_with] = ACTIONS(123),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(795),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_default] = ACTIONS(123),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(123),
    [anon_sym_member] = ACTIONS(123),
    [anon_sym_interface] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(123),
    [anon_sym_val] = ACTIONS(123),
    [anon_sym_override] = ACTIONS(123),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(119),
    [sym__dedent] = ACTIONS(119),
  },
  [81] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(946),
    [sym_infix_op] = STATE(1070),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(81),
    [sym_compiler_directive_decl] = STATE(81),
    [sym_fsi_directive_decl] = STATE(81),
    [sym_preproc_line] = STATE(81),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2120),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(247),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(247),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(759),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(249),
    [anon_sym_with] = ACTIONS(839),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(795),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_default] = ACTIONS(249),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(249),
    [anon_sym_member] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(249),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_val] = ACTIONS(249),
    [anon_sym_override] = ACTIONS(249),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(837),
    [sym__dedent] = ACTIONS(247),
  },
  [82] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(946),
    [sym_infix_op] = STATE(1070),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(82),
    [sym_compiler_directive_decl] = STATE(82),
    [sym_fsi_directive_decl] = STATE(82),
    [sym_preproc_line] = STATE(82),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2120),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(239),
    [anon_sym_let_BANG] = ACTIONS(237),
    [aux_sym_access_modifier_token1] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(759),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_with] = ACTIONS(841),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(795),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_default] = ACTIONS(239),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(239),
    [anon_sym_member] = ACTIONS(239),
    [anon_sym_interface] = ACTIONS(239),
    [anon_sym_abstract] = ACTIONS(239),
    [anon_sym_val] = ACTIONS(239),
    [anon_sym_override] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(237),
    [sym__newline] = ACTIONS(837),
    [sym__dedent] = ACTIONS(237),
  },
  [83] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(946),
    [sym_infix_op] = STATE(1070),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(83),
    [sym_compiler_directive_decl] = STATE(83),
    [sym_fsi_directive_decl] = STATE(83),
    [sym_preproc_line] = STATE(83),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2120),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(759),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_with] = ACTIONS(843),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(795),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_default] = ACTIONS(239),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(239),
    [anon_sym_member] = ACTIONS(239),
    [anon_sym_interface] = ACTIONS(239),
    [anon_sym_abstract] = ACTIONS(239),
    [anon_sym_val] = ACTIONS(239),
    [anon_sym_override] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(837),
    [sym__dedent] = ACTIONS(237),
  },
  [84] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(946),
    [sym_infix_op] = STATE(1070),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(84),
    [sym_compiler_directive_decl] = STATE(84),
    [sym_fsi_directive_decl] = STATE(84),
    [sym_preproc_line] = STATE(84),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2120),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(247),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(249),
    [anon_sym_let_BANG] = ACTIONS(247),
    [aux_sym_access_modifier_token1] = ACTIONS(247),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(759),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(249),
    [anon_sym_with] = ACTIONS(845),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(795),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_default] = ACTIONS(249),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(249),
    [anon_sym_member] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(249),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_val] = ACTIONS(249),
    [anon_sym_override] = ACTIONS(249),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(247),
    [sym__newline] = ACTIONS(247),
    [sym__dedent] = ACTIONS(247),
  },
  [85] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(946),
    [sym_infix_op] = STATE(1070),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(85),
    [sym_compiler_directive_decl] = STATE(85),
    [sym_fsi_directive_decl] = STATE(85),
    [sym_preproc_line] = STATE(85),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2120),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(243),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(759),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(753),
    [anon_sym_with] = ACTIONS(245),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(795),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_default] = ACTIONS(245),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_member] = ACTIONS(245),
    [anon_sym_interface] = ACTIONS(245),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_val] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(243),
    [sym__dedent] = ACTIONS(243),
  },
  [86] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(946),
    [sym_infix_op] = STATE(1070),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(86),
    [sym_compiler_directive_decl] = STATE(86),
    [sym_fsi_directive_decl] = STATE(86),
    [sym_preproc_line] = STATE(86),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2120),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(239),
    [anon_sym_let_BANG] = ACTIONS(237),
    [aux_sym_access_modifier_token1] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(759),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_with] = ACTIONS(847),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(795),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_default] = ACTIONS(239),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(239),
    [anon_sym_member] = ACTIONS(239),
    [anon_sym_interface] = ACTIONS(239),
    [anon_sym_abstract] = ACTIONS(239),
    [anon_sym_val] = ACTIONS(239),
    [anon_sym_override] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(237),
    [sym__newline] = ACTIONS(237),
    [sym__dedent] = ACTIONS(237),
  },
  [87] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(946),
    [sym_infix_op] = STATE(1070),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(87),
    [sym_compiler_directive_decl] = STATE(87),
    [sym_fsi_directive_decl] = STATE(87),
    [sym_preproc_line] = STATE(87),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2120),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_EQ] = ACTIONS(223),
    [anon_sym_LBRACK_LT] = ACTIONS(223),
    [anon_sym_COLON] = ACTIONS(225),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_do] = ACTIONS(225),
    [anon_sym_let] = ACTIONS(225),
    [anon_sym_let_BANG] = ACTIONS(223),
    [aux_sym_access_modifier_token1] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_COMMA] = ACTIONS(223),
    [anon_sym_null] = ACTIONS(225),
    [anon_sym_QMARK] = ACTIONS(225),
    [anon_sym_COLON_QMARK] = ACTIONS(225),
    [anon_sym_COLON_COLON] = ACTIONS(223),
    [anon_sym_AMP] = ACTIONS(225),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LBRACK_PIPE] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(225),
    [anon_sym_LT_AT] = ACTIONS(225),
    [anon_sym_LT_AT_AT] = ACTIONS(225),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(225),
    [anon_sym_with] = ACTIONS(225),
    [anon_sym_return_BANG] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(225),
    [anon_sym_yield_BANG] = ACTIONS(223),
    [anon_sym_lazy] = ACTIONS(225),
    [anon_sym_assert] = ACTIONS(225),
    [anon_sym_upcast] = ACTIONS(225),
    [anon_sym_downcast] = ACTIONS(225),
    [anon_sym_COLON_GT] = ACTIONS(223),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(223),
    [anon_sym_for] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_fun] = ACTIONS(225),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_match] = ACTIONS(225),
    [anon_sym_match_BANG] = ACTIONS(223),
    [anon_sym_function] = ACTIONS(225),
    [anon_sym_LT_DASH] = ACTIONS(225),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(225),
    [anon_sym_use_BANG] = ACTIONS(223),
    [anon_sym_do_BANG] = ACTIONS(223),
    [anon_sym_begin] = ACTIONS(225),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_or] = ACTIONS(225),
    [anon_sym_static] = ACTIONS(225),
    [anon_sym_member] = ACTIONS(225),
    [anon_sym_interface] = ACTIONS(225),
    [anon_sym_abstract] = ACTIONS(225),
    [anon_sym_val] = ACTIONS(225),
    [anon_sym_override] = ACTIONS(225),
    [aux_sym_char_token1] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_AT_DQUOTE] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [sym_bool] = ACTIONS(225),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(225),
    [sym_op_identifier] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(225),
    [anon_sym_DASH] = ACTIONS(225),
    [anon_sym_PLUS_DOT] = ACTIONS(225),
    [anon_sym_DASH_DOT] = ACTIONS(225),
    [anon_sym_PERCENT] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_TILDE] = ACTIONS(223),
    [aux_sym_prefix_op_token1] = ACTIONS(225),
    [aux_sym_infix_op_token1] = ACTIONS(223),
    [aux_sym_infix_op_token2] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_BANG_EQ] = ACTIONS(225),
    [anon_sym_COLON_EQ] = ACTIONS(223),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(225),
    [sym_int] = ACTIONS(225),
    [sym_xint] = ACTIONS(223),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(223),
    [sym__newline] = ACTIONS(223),
    [sym__dedent] = ACTIONS(223),
  },
  [88] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(946),
    [sym_infix_op] = STATE(1070),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(88),
    [sym_compiler_directive_decl] = STATE(88),
    [sym_fsi_directive_decl] = STATE(88),
    [sym_preproc_line] = STATE(88),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2120),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(257),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(759),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(259),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(753),
    [anon_sym_with] = ACTIONS(259),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(795),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_default] = ACTIONS(259),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(259),
    [anon_sym_member] = ACTIONS(259),
    [anon_sym_interface] = ACTIONS(259),
    [anon_sym_abstract] = ACTIONS(259),
    [anon_sym_val] = ACTIONS(259),
    [anon_sym_override] = ACTIONS(259),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(257),
    [sym__dedent] = ACTIONS(257),
  },
  [89] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(946),
    [sym_infix_op] = STATE(1070),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(89),
    [sym_compiler_directive_decl] = STATE(89),
    [sym_fsi_directive_decl] = STATE(89),
    [sym_preproc_line] = STATE(89),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2120),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(759),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(753),
    [anon_sym_with] = ACTIONS(233),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(795),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_default] = ACTIONS(233),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(233),
    [anon_sym_member] = ACTIONS(233),
    [anon_sym_interface] = ACTIONS(233),
    [anon_sym_abstract] = ACTIONS(233),
    [anon_sym_val] = ACTIONS(233),
    [anon_sym_override] = ACTIONS(233),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(837),
    [sym__dedent] = ACTIONS(231),
  },
  [90] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(946),
    [sym_infix_op] = STATE(1070),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(90),
    [sym_compiler_directive_decl] = STATE(90),
    [sym_fsi_directive_decl] = STATE(90),
    [sym_preproc_line] = STATE(90),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2120),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(265),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(265),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(759),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(753),
    [anon_sym_with] = ACTIONS(267),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(795),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_default] = ACTIONS(267),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(267),
    [anon_sym_member] = ACTIONS(267),
    [anon_sym_interface] = ACTIONS(267),
    [anon_sym_abstract] = ACTIONS(267),
    [anon_sym_val] = ACTIONS(267),
    [anon_sym_override] = ACTIONS(267),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(837),
    [sym__dedent] = ACTIONS(265),
  },
  [91] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(946),
    [sym_infix_op] = STATE(1070),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(91),
    [sym_compiler_directive_decl] = STATE(91),
    [sym_fsi_directive_decl] = STATE(91),
    [sym_preproc_line] = STATE(91),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2120),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(253),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(759),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(255),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(753),
    [anon_sym_with] = ACTIONS(255),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(795),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_default] = ACTIONS(255),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(255),
    [anon_sym_member] = ACTIONS(255),
    [anon_sym_interface] = ACTIONS(255),
    [anon_sym_abstract] = ACTIONS(255),
    [anon_sym_val] = ACTIONS(255),
    [anon_sym_override] = ACTIONS(255),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(253),
    [sym__dedent] = ACTIONS(253),
  },
  [92] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(946),
    [sym_infix_op] = STATE(1070),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(92),
    [sym_compiler_directive_decl] = STATE(92),
    [sym_fsi_directive_decl] = STATE(92),
    [sym_preproc_line] = STATE(92),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2120),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(247),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(249),
    [anon_sym_let_BANG] = ACTIONS(247),
    [aux_sym_access_modifier_token1] = ACTIONS(247),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(759),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(249),
    [anon_sym_with] = ACTIONS(849),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(795),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_default] = ACTIONS(249),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(249),
    [anon_sym_member] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(249),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_val] = ACTIONS(249),
    [anon_sym_override] = ACTIONS(249),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(247),
    [sym__newline] = ACTIONS(837),
    [sym__dedent] = ACTIONS(247),
  },
  [93] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(946),
    [sym_infix_op] = STATE(1070),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(93),
    [sym_compiler_directive_decl] = STATE(93),
    [sym_fsi_directive_decl] = STATE(93),
    [sym_preproc_line] = STATE(93),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2120),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_EQ] = ACTIONS(227),
    [anon_sym_LBRACK_LT] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(229),
    [anon_sym_return] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_let] = ACTIONS(229),
    [anon_sym_let_BANG] = ACTIONS(227),
    [aux_sym_access_modifier_token1] = ACTIONS(227),
    [anon_sym_LPAREN] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(227),
    [anon_sym_null] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_COLON_QMARK] = ACTIONS(229),
    [anon_sym_COLON_COLON] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_LBRACK] = ACTIONS(229),
    [anon_sym_LBRACK_PIPE] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(229),
    [anon_sym_LT_AT] = ACTIONS(229),
    [anon_sym_LT_AT_AT] = ACTIONS(229),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(227),
    [anon_sym_new] = ACTIONS(229),
    [anon_sym_with] = ACTIONS(229),
    [anon_sym_return_BANG] = ACTIONS(227),
    [anon_sym_yield] = ACTIONS(229),
    [anon_sym_yield_BANG] = ACTIONS(227),
    [anon_sym_lazy] = ACTIONS(229),
    [anon_sym_assert] = ACTIONS(229),
    [anon_sym_upcast] = ACTIONS(229),
    [anon_sym_downcast] = ACTIONS(229),
    [anon_sym_COLON_GT] = ACTIONS(227),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_fun] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(229),
    [anon_sym_match_BANG] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(229),
    [anon_sym_LT_DASH] = ACTIONS(229),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(229),
    [anon_sym_use_BANG] = ACTIONS(227),
    [anon_sym_do_BANG] = ACTIONS(227),
    [anon_sym_begin] = ACTIONS(229),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_default] = ACTIONS(229),
    [anon_sym_or] = ACTIONS(229),
    [anon_sym_static] = ACTIONS(229),
    [anon_sym_member] = ACTIONS(229),
    [anon_sym_interface] = ACTIONS(229),
    [anon_sym_abstract] = ACTIONS(229),
    [anon_sym_val] = ACTIONS(229),
    [anon_sym_override] = ACTIONS(229),
    [aux_sym_char_token1] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_AT_DQUOTE] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [sym_bool] = ACTIONS(229),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(229),
    [sym_op_identifier] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(229),
    [anon_sym_PLUS_DOT] = ACTIONS(229),
    [anon_sym_DASH_DOT] = ACTIONS(229),
    [anon_sym_PERCENT] = ACTIONS(229),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(227),
    [aux_sym_prefix_op_token1] = ACTIONS(229),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token2] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(229),
    [anon_sym_BANG_EQ] = ACTIONS(229),
    [anon_sym_COLON_EQ] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(229),
    [sym_int] = ACTIONS(229),
    [sym_xint] = ACTIONS(227),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(227),
    [sym__newline] = ACTIONS(227),
    [sym__dedent] = ACTIONS(227),
  },
  [94] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(946),
    [sym_infix_op] = STATE(1070),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(94),
    [sym_compiler_directive_decl] = STATE(94),
    [sym_fsi_directive_decl] = STATE(94),
    [sym_preproc_line] = STATE(94),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2120),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(759),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_with] = ACTIONS(851),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(795),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_default] = ACTIONS(239),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(239),
    [anon_sym_member] = ACTIONS(239),
    [anon_sym_abstract] = ACTIONS(239),
    [anon_sym_val] = ACTIONS(239),
    [anon_sym_override] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(237),
    [sym__dedent] = ACTIONS(237),
  },
  [95] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(946),
    [sym_infix_op] = STATE(1070),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(95),
    [sym_compiler_directive_decl] = STATE(95),
    [sym_fsi_directive_decl] = STATE(95),
    [sym_preproc_line] = STATE(95),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2120),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_LBRACK_LT] = ACTIONS(247),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [aux_sym_access_modifier_token1] = ACTIONS(247),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(759),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(249),
    [anon_sym_with] = ACTIONS(853),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(795),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_default] = ACTIONS(249),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_static] = ACTIONS(249),
    [anon_sym_member] = ACTIONS(249),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_val] = ACTIONS(249),
    [anon_sym_override] = ACTIONS(249),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(247),
    [sym__dedent] = ACTIONS(247),
  },
  [96] = {
    [sym_function_or_value_defn] = STATE(866),
    [sym__expression] = STATE(101),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1178),
    [sym_infix_op] = STATE(935),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(96),
    [sym_compiler_directive_decl] = STATE(96),
    [sym_fsi_directive_decl] = STATE(96),
    [sym_preproc_line] = STATE(96),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_sequential_expression_repeat1] = STATE(2316),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(261),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(263),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(263),
    [anon_sym_LBRACK_LT] = ACTIONS(261),
    [anon_sym_COLON] = ACTIONS(855),
    [anon_sym_return] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(263),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_COMMA] = ACTIONS(861),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(855),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(863),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(865),
    [anon_sym_DOT] = ACTIONS(867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(857),
    [anon_sym_return_BANG] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(857),
    [anon_sym_yield_BANG] = ACTIONS(869),
    [anon_sym_lazy] = ACTIONS(857),
    [anon_sym_assert] = ACTIONS(857),
    [anon_sym_upcast] = ACTIONS(857),
    [anon_sym_downcast] = ACTIONS(857),
    [anon_sym_COLON_GT] = ACTIONS(871),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(871),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(873),
    [anon_sym_DOT_LBRACK] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_use] = ACTIONS(879),
    [anon_sym_use_BANG] = ACTIONS(881),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_LPAREN2] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_exception] = ACTIONS(263),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(889),
    [sym_xint] = ACTIONS(891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(261),
    [anon_sym_POUNDload] = ACTIONS(261),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
    [sym__newline] = ACTIONS(895),
  },
  [97] = {
    [sym_function_or_value_defn] = STATE(866),
    [sym__expression] = STATE(101),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1178),
    [sym_infix_op] = STATE(935),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(97),
    [sym_compiler_directive_decl] = STATE(97),
    [sym_fsi_directive_decl] = STATE(97),
    [sym_preproc_line] = STATE(97),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_sequential_expression_repeat1] = STATE(2316),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(119),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(123),
    [anon_sym_module] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_LBRACK_LT] = ACTIONS(119),
    [anon_sym_COLON] = ACTIONS(855),
    [anon_sym_return] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_COMMA] = ACTIONS(861),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(855),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(863),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(865),
    [anon_sym_DOT] = ACTIONS(867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(857),
    [anon_sym_return_BANG] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(857),
    [anon_sym_yield_BANG] = ACTIONS(869),
    [anon_sym_lazy] = ACTIONS(857),
    [anon_sym_assert] = ACTIONS(857),
    [anon_sym_upcast] = ACTIONS(857),
    [anon_sym_downcast] = ACTIONS(857),
    [anon_sym_COLON_GT] = ACTIONS(871),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(871),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(873),
    [anon_sym_DOT_LBRACK] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_use] = ACTIONS(879),
    [anon_sym_use_BANG] = ACTIONS(881),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_LPAREN2] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_exception] = ACTIONS(123),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(889),
    [sym_xint] = ACTIONS(891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(119),
    [anon_sym_POUNDload] = ACTIONS(119),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
    [sym__newline] = ACTIONS(119),
  },
  [98] = {
    [sym_function_or_value_defn] = STATE(866),
    [sym__expression] = STATE(101),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1178),
    [sym_infix_op] = STATE(935),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(98),
    [sym_compiler_directive_decl] = STATE(98),
    [sym_fsi_directive_decl] = STATE(98),
    [sym_preproc_line] = STATE(98),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_sequential_expression_repeat1] = STATE(2316),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(265),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(267),
    [anon_sym_module] = ACTIONS(267),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(267),
    [anon_sym_LBRACK_LT] = ACTIONS(265),
    [anon_sym_COLON] = ACTIONS(855),
    [anon_sym_return] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_COMMA] = ACTIONS(861),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(855),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(863),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(865),
    [anon_sym_DOT] = ACTIONS(867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(857),
    [anon_sym_return_BANG] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(857),
    [anon_sym_yield_BANG] = ACTIONS(869),
    [anon_sym_lazy] = ACTIONS(857),
    [anon_sym_assert] = ACTIONS(857),
    [anon_sym_upcast] = ACTIONS(857),
    [anon_sym_downcast] = ACTIONS(857),
    [anon_sym_COLON_GT] = ACTIONS(871),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(871),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(873),
    [anon_sym_DOT_LBRACK] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_use] = ACTIONS(879),
    [anon_sym_use_BANG] = ACTIONS(881),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_LPAREN2] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_exception] = ACTIONS(267),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(889),
    [sym_xint] = ACTIONS(891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(265),
    [anon_sym_POUNDload] = ACTIONS(265),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
    [sym__newline] = ACTIONS(895),
  },
  [99] = {
    [sym_function_or_value_defn] = STATE(866),
    [sym__expression] = STATE(101),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1178),
    [sym_infix_op] = STATE(935),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(99),
    [sym_compiler_directive_decl] = STATE(99),
    [sym_fsi_directive_decl] = STATE(99),
    [sym_preproc_line] = STATE(99),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_sequential_expression_repeat1] = STATE(2316),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(243),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(245),
    [anon_sym_module] = ACTIONS(245),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(245),
    [anon_sym_LBRACK_LT] = ACTIONS(243),
    [anon_sym_COLON] = ACTIONS(855),
    [anon_sym_return] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(245),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_COMMA] = ACTIONS(861),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(855),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(865),
    [anon_sym_DOT] = ACTIONS(867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(857),
    [anon_sym_return_BANG] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(857),
    [anon_sym_yield_BANG] = ACTIONS(869),
    [anon_sym_lazy] = ACTIONS(857),
    [anon_sym_assert] = ACTIONS(857),
    [anon_sym_upcast] = ACTIONS(857),
    [anon_sym_downcast] = ACTIONS(857),
    [anon_sym_COLON_GT] = ACTIONS(871),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(871),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(873),
    [anon_sym_DOT_LBRACK] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_use] = ACTIONS(879),
    [anon_sym_use_BANG] = ACTIONS(881),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_LPAREN2] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_exception] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(889),
    [sym_xint] = ACTIONS(891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(243),
    [anon_sym_POUNDload] = ACTIONS(243),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
    [sym__newline] = ACTIONS(243),
  },
  [100] = {
    [sym_function_or_value_defn] = STATE(866),
    [sym__expression] = STATE(101),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1178),
    [sym_infix_op] = STATE(935),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(100),
    [sym_compiler_directive_decl] = STATE(100),
    [sym_fsi_directive_decl] = STATE(100),
    [sym_preproc_line] = STATE(100),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_sequential_expression_repeat1] = STATE(2316),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(257),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(259),
    [anon_sym_module] = ACTIONS(259),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(259),
    [anon_sym_LBRACK_LT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(855),
    [anon_sym_return] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(259),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_COMMA] = ACTIONS(861),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(855),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(259),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(865),
    [anon_sym_DOT] = ACTIONS(867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(857),
    [anon_sym_return_BANG] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(857),
    [anon_sym_yield_BANG] = ACTIONS(869),
    [anon_sym_lazy] = ACTIONS(857),
    [anon_sym_assert] = ACTIONS(857),
    [anon_sym_upcast] = ACTIONS(857),
    [anon_sym_downcast] = ACTIONS(857),
    [anon_sym_COLON_GT] = ACTIONS(871),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(871),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(873),
    [anon_sym_DOT_LBRACK] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_use] = ACTIONS(879),
    [anon_sym_use_BANG] = ACTIONS(881),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_LPAREN2] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_exception] = ACTIONS(259),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(889),
    [sym_xint] = ACTIONS(891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(257),
    [anon_sym_POUNDload] = ACTIONS(257),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
    [sym__newline] = ACTIONS(257),
  },
  [101] = {
    [sym_function_or_value_defn] = STATE(866),
    [sym__expression] = STATE(101),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1178),
    [sym_infix_op] = STATE(935),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(101),
    [sym_compiler_directive_decl] = STATE(101),
    [sym_fsi_directive_decl] = STATE(101),
    [sym_preproc_line] = STATE(101),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_sequential_expression_repeat1] = STATE(2316),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(223),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(225),
    [anon_sym_module] = ACTIONS(225),
    [anon_sym_EQ] = ACTIONS(223),
    [anon_sym_open] = ACTIONS(225),
    [anon_sym_LBRACK_LT] = ACTIONS(223),
    [anon_sym_COLON] = ACTIONS(225),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_type] = ACTIONS(225),
    [anon_sym_do] = ACTIONS(225),
    [anon_sym_let] = ACTIONS(225),
    [anon_sym_let_BANG] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_COMMA] = ACTIONS(223),
    [anon_sym_null] = ACTIONS(225),
    [anon_sym_QMARK] = ACTIONS(225),
    [anon_sym_COLON_QMARK] = ACTIONS(225),
    [anon_sym_COLON_COLON] = ACTIONS(223),
    [anon_sym_AMP] = ACTIONS(225),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LBRACK_PIPE] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(225),
    [anon_sym_LT_AT] = ACTIONS(225),
    [anon_sym_LT_AT_AT] = ACTIONS(225),
    [anon_sym_DOT] = ACTIONS(867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(225),
    [anon_sym_return_BANG] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(225),
    [anon_sym_yield_BANG] = ACTIONS(223),
    [anon_sym_lazy] = ACTIONS(225),
    [anon_sym_assert] = ACTIONS(225),
    [anon_sym_upcast] = ACTIONS(225),
    [anon_sym_downcast] = ACTIONS(225),
    [anon_sym_COLON_GT] = ACTIONS(223),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(223),
    [anon_sym_for] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_fun] = ACTIONS(225),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_match] = ACTIONS(225),
    [anon_sym_match_BANG] = ACTIONS(223),
    [anon_sym_function] = ACTIONS(225),
    [anon_sym_LT_DASH] = ACTIONS(225),
    [anon_sym_DOT_LBRACK] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_use] = ACTIONS(225),
    [anon_sym_use_BANG] = ACTIONS(223),
    [anon_sym_do_BANG] = ACTIONS(223),
    [anon_sym_begin] = ACTIONS(225),
    [anon_sym_LPAREN2] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(225),
    [anon_sym_exception] = ACTIONS(225),
    [aux_sym_char_token1] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_AT_DQUOTE] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [sym_bool] = ACTIONS(225),
    [sym_unit] = ACTIONS(885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(225),
    [sym_op_identifier] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(225),
    [anon_sym_DASH] = ACTIONS(225),
    [anon_sym_PLUS_DOT] = ACTIONS(225),
    [anon_sym_DASH_DOT] = ACTIONS(225),
    [anon_sym_PERCENT] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_TILDE] = ACTIONS(223),
    [aux_sym_prefix_op_token1] = ACTIONS(225),
    [aux_sym_infix_op_token1] = ACTIONS(223),
    [aux_sym_infix_op_token2] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_BANG_EQ] = ACTIONS(225),
    [anon_sym_COLON_EQ] = ACTIONS(223),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(225),
    [sym_int] = ACTIONS(225),
    [sym_xint] = ACTIONS(223),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(223),
    [anon_sym_POUNDload] = ACTIONS(223),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(223),
    [sym__newline] = ACTIONS(223),
  },
  [102] = {
    [sym_function_or_value_defn] = STATE(866),
    [sym__expression] = STATE(101),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1178),
    [sym_infix_op] = STATE(935),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(102),
    [sym_compiler_directive_decl] = STATE(102),
    [sym_fsi_directive_decl] = STATE(102),
    [sym_preproc_line] = STATE(102),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_sequential_expression_repeat1] = STATE(2316),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(227),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_module] = ACTIONS(229),
    [anon_sym_EQ] = ACTIONS(227),
    [anon_sym_open] = ACTIONS(229),
    [anon_sym_LBRACK_LT] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(229),
    [anon_sym_return] = ACTIONS(229),
    [anon_sym_type] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_let] = ACTIONS(229),
    [anon_sym_let_BANG] = ACTIONS(227),
    [anon_sym_LPAREN] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(227),
    [anon_sym_null] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_COLON_QMARK] = ACTIONS(229),
    [anon_sym_COLON_COLON] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_LBRACK] = ACTIONS(229),
    [anon_sym_LBRACK_PIPE] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(229),
    [anon_sym_LT_AT] = ACTIONS(229),
    [anon_sym_LT_AT_AT] = ACTIONS(229),
    [anon_sym_DOT] = ACTIONS(867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(227),
    [anon_sym_new] = ACTIONS(229),
    [anon_sym_return_BANG] = ACTIONS(227),
    [anon_sym_yield] = ACTIONS(229),
    [anon_sym_yield_BANG] = ACTIONS(227),
    [anon_sym_lazy] = ACTIONS(229),
    [anon_sym_assert] = ACTIONS(229),
    [anon_sym_upcast] = ACTIONS(229),
    [anon_sym_downcast] = ACTIONS(229),
    [anon_sym_COLON_GT] = ACTIONS(227),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_fun] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(229),
    [anon_sym_match_BANG] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(229),
    [anon_sym_LT_DASH] = ACTIONS(229),
    [anon_sym_DOT_LBRACK] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_use] = ACTIONS(229),
    [anon_sym_use_BANG] = ACTIONS(227),
    [anon_sym_do_BANG] = ACTIONS(227),
    [anon_sym_begin] = ACTIONS(229),
    [anon_sym_LPAREN2] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(229),
    [anon_sym_exception] = ACTIONS(229),
    [aux_sym_char_token1] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_AT_DQUOTE] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [sym_bool] = ACTIONS(229),
    [sym_unit] = ACTIONS(885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(229),
    [sym_op_identifier] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(229),
    [anon_sym_PLUS_DOT] = ACTIONS(229),
    [anon_sym_DASH_DOT] = ACTIONS(229),
    [anon_sym_PERCENT] = ACTIONS(229),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(227),
    [aux_sym_prefix_op_token1] = ACTIONS(229),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token2] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(229),
    [anon_sym_BANG_EQ] = ACTIONS(229),
    [anon_sym_COLON_EQ] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(229),
    [sym_int] = ACTIONS(229),
    [sym_xint] = ACTIONS(227),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(227),
    [anon_sym_POUNDload] = ACTIONS(227),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(227),
    [sym__newline] = ACTIONS(227),
  },
  [103] = {
    [sym_function_or_value_defn] = STATE(866),
    [sym__expression] = STATE(101),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1178),
    [sym_infix_op] = STATE(935),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(103),
    [sym_compiler_directive_decl] = STATE(103),
    [sym_fsi_directive_decl] = STATE(103),
    [sym_preproc_line] = STATE(103),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_sequential_expression_repeat1] = STATE(2316),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(231),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(233),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(233),
    [anon_sym_LBRACK_LT] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(855),
    [anon_sym_return] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(233),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_COMMA] = ACTIONS(861),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(855),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(863),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(865),
    [anon_sym_DOT] = ACTIONS(867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(857),
    [anon_sym_return_BANG] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(857),
    [anon_sym_yield_BANG] = ACTIONS(869),
    [anon_sym_lazy] = ACTIONS(857),
    [anon_sym_assert] = ACTIONS(857),
    [anon_sym_upcast] = ACTIONS(857),
    [anon_sym_downcast] = ACTIONS(857),
    [anon_sym_COLON_GT] = ACTIONS(871),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(871),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(873),
    [anon_sym_DOT_LBRACK] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_use] = ACTIONS(879),
    [anon_sym_use_BANG] = ACTIONS(881),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_LPAREN2] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_exception] = ACTIONS(233),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(889),
    [sym_xint] = ACTIONS(891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(231),
    [anon_sym_POUNDload] = ACTIONS(231),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
    [sym__newline] = ACTIONS(895),
  },
  [104] = {
    [sym_function_or_value_defn] = STATE(866),
    [sym__expression] = STATE(101),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1178),
    [sym_infix_op] = STATE(935),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(104),
    [sym_compiler_directive_decl] = STATE(104),
    [sym_fsi_directive_decl] = STATE(104),
    [sym_preproc_line] = STATE(104),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_sequential_expression_repeat1] = STATE(2316),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(897),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(899),
    [anon_sym_module] = ACTIONS(899),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(899),
    [anon_sym_LBRACK_LT] = ACTIONS(897),
    [anon_sym_COLON] = ACTIONS(855),
    [anon_sym_return] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(899),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_COMMA] = ACTIONS(861),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(855),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(863),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(865),
    [anon_sym_DOT] = ACTIONS(867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(857),
    [anon_sym_return_BANG] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(857),
    [anon_sym_yield_BANG] = ACTIONS(869),
    [anon_sym_lazy] = ACTIONS(857),
    [anon_sym_assert] = ACTIONS(857),
    [anon_sym_upcast] = ACTIONS(857),
    [anon_sym_downcast] = ACTIONS(857),
    [anon_sym_COLON_GT] = ACTIONS(871),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(871),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(873),
    [anon_sym_DOT_LBRACK] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_use] = ACTIONS(879),
    [anon_sym_use_BANG] = ACTIONS(881),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_LPAREN2] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_exception] = ACTIONS(899),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(889),
    [sym_xint] = ACTIONS(891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(897),
    [anon_sym_POUNDload] = ACTIONS(897),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
    [sym__newline] = ACTIONS(895),
  },
  [105] = {
    [sym_function_or_value_defn] = STATE(866),
    [sym__expression] = STATE(101),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1178),
    [sym_infix_op] = STATE(935),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(105),
    [sym_compiler_directive_decl] = STATE(105),
    [sym_fsi_directive_decl] = STATE(105),
    [sym_preproc_line] = STATE(105),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_sequential_expression_repeat1] = STATE(2316),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(253),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(255),
    [anon_sym_module] = ACTIONS(255),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(255),
    [anon_sym_LBRACK_LT] = ACTIONS(253),
    [anon_sym_COLON] = ACTIONS(855),
    [anon_sym_return] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(255),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_COMMA] = ACTIONS(861),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(855),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(255),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(865),
    [anon_sym_DOT] = ACTIONS(867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(857),
    [anon_sym_return_BANG] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(857),
    [anon_sym_yield_BANG] = ACTIONS(869),
    [anon_sym_lazy] = ACTIONS(857),
    [anon_sym_assert] = ACTIONS(857),
    [anon_sym_upcast] = ACTIONS(857),
    [anon_sym_downcast] = ACTIONS(857),
    [anon_sym_COLON_GT] = ACTIONS(871),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(871),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(873),
    [anon_sym_DOT_LBRACK] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_use] = ACTIONS(879),
    [anon_sym_use_BANG] = ACTIONS(881),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_LPAREN2] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_exception] = ACTIONS(255),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(889),
    [sym_xint] = ACTIONS(891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(253),
    [anon_sym_POUNDload] = ACTIONS(253),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
    [sym__newline] = ACTIONS(253),
  },
  [106] = {
    [sym_function_or_value_defn] = STATE(964),
    [sym__expression] = STATE(118),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(793),
    [sym_infix_op] = STATE(1131),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(106),
    [sym_compiler_directive_decl] = STATE(106),
    [sym_fsi_directive_decl] = STATE(106),
    [sym_preproc_line] = STATE(106),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_sequential_expression_repeat1] = STATE(2515),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(261),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(263),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(263),
    [anon_sym_LBRACK_LT] = ACTIONS(261),
    [anon_sym_COLON] = ACTIONS(855),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_type] = ACTIONS(263),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(855),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(863),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(865),
    [anon_sym_DOT] = ACTIONS(867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(29),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_upcast] = ACTIONS(29),
    [anon_sym_downcast] = ACTIONS(29),
    [anon_sym_COLON_GT] = ACTIONS(871),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(871),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(903),
    [anon_sym_DOT_LBRACK] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_LPAREN2] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_exception] = ACTIONS(263),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(111),
    [sym_xint] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(261),
    [anon_sym_POUNDload] = ACTIONS(261),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
    [sym__newline] = ACTIONS(905),
  },
  [107] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(107),
    [sym_compiler_directive_decl] = STATE(107),
    [sym_fsi_directive_decl] = STATE(107),
    [sym_preproc_line] = STATE(107),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_GT_RBRACK] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(257),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(259),
    [anon_sym_RBRACE] = ACTIONS(257),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(259),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_to] = ACTIONS(259),
    [anon_sym_downto] = ACTIONS(259),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(257),
  },
  [108] = {
    [sym_function_or_value_defn] = STATE(964),
    [sym__expression] = STATE(118),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(793),
    [sym_infix_op] = STATE(1131),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(108),
    [sym_compiler_directive_decl] = STATE(108),
    [sym_fsi_directive_decl] = STATE(108),
    [sym_preproc_line] = STATE(108),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_sequential_expression_repeat1] = STATE(2515),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(265),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(267),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(267),
    [anon_sym_LBRACK_LT] = ACTIONS(265),
    [anon_sym_COLON] = ACTIONS(855),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_type] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(855),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(863),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(865),
    [anon_sym_DOT] = ACTIONS(867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(29),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_upcast] = ACTIONS(29),
    [anon_sym_downcast] = ACTIONS(29),
    [anon_sym_COLON_GT] = ACTIONS(871),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(871),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(903),
    [anon_sym_DOT_LBRACK] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_LPAREN2] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_exception] = ACTIONS(267),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(111),
    [sym_xint] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(265),
    [anon_sym_POUNDload] = ACTIONS(265),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
    [sym__newline] = ACTIONS(905),
  },
  [109] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(109),
    [sym_compiler_directive_decl] = STATE(109),
    [sym_fsi_directive_decl] = STATE(109),
    [sym_preproc_line] = STATE(109),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_GT_RBRACK] = ACTIONS(243),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(243),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_RBRACE] = ACTIONS(243),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(245),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_to] = ACTIONS(245),
    [anon_sym_downto] = ACTIONS(245),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(243),
  },
  [110] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(110),
    [sym_compiler_directive_decl] = STATE(110),
    [sym_fsi_directive_decl] = STATE(110),
    [sym_preproc_line] = STATE(110),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_EQ] = ACTIONS(227),
    [anon_sym_GT_RBRACK] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(229),
    [anon_sym_return] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_let] = ACTIONS(229),
    [anon_sym_let_BANG] = ACTIONS(227),
    [anon_sym_LPAREN] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(227),
    [anon_sym_null] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_COLON_QMARK] = ACTIONS(229),
    [anon_sym_COLON_COLON] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_LBRACK] = ACTIONS(229),
    [anon_sym_RBRACK] = ACTIONS(227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(229),
    [anon_sym_RBRACE] = ACTIONS(227),
    [anon_sym_LT_AT] = ACTIONS(229),
    [anon_sym_LT_AT_AT] = ACTIONS(229),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(227),
    [anon_sym_new] = ACTIONS(229),
    [anon_sym_with] = ACTIONS(229),
    [anon_sym_return_BANG] = ACTIONS(227),
    [anon_sym_yield] = ACTIONS(229),
    [anon_sym_yield_BANG] = ACTIONS(227),
    [anon_sym_lazy] = ACTIONS(229),
    [anon_sym_assert] = ACTIONS(229),
    [anon_sym_upcast] = ACTIONS(229),
    [anon_sym_downcast] = ACTIONS(229),
    [anon_sym_COLON_GT] = ACTIONS(227),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_to] = ACTIONS(229),
    [anon_sym_downto] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_fun] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(229),
    [anon_sym_match_BANG] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(229),
    [anon_sym_LT_DASH] = ACTIONS(229),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(229),
    [anon_sym_use_BANG] = ACTIONS(227),
    [anon_sym_do_BANG] = ACTIONS(227),
    [anon_sym_begin] = ACTIONS(229),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(229),
    [aux_sym_char_token1] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_AT_DQUOTE] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [sym_bool] = ACTIONS(229),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(229),
    [sym_op_identifier] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(229),
    [anon_sym_PLUS_DOT] = ACTIONS(229),
    [anon_sym_DASH_DOT] = ACTIONS(229),
    [anon_sym_PERCENT] = ACTIONS(229),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(227),
    [aux_sym_prefix_op_token1] = ACTIONS(229),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token2] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(229),
    [anon_sym_BANG_EQ] = ACTIONS(229),
    [anon_sym_COLON_EQ] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(229),
    [sym_int] = ACTIONS(229),
    [sym_xint] = ACTIONS(227),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(227),
    [sym__newline] = ACTIONS(227),
  },
  [111] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(111),
    [sym_compiler_directive_decl] = STATE(111),
    [sym_fsi_directive_decl] = STATE(111),
    [sym_preproc_line] = STATE(111),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_GT_RBRACK] = ACTIONS(253),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(253),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(255),
    [anon_sym_RBRACE] = ACTIONS(253),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(255),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_to] = ACTIONS(255),
    [anon_sym_downto] = ACTIONS(255),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(253),
  },
  [112] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(112),
    [sym_compiler_directive_decl] = STATE(112),
    [sym_fsi_directive_decl] = STATE(112),
    [sym_preproc_line] = STATE(112),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_GT_RBRACK] = ACTIONS(119),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(119),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(119),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(123),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_to] = ACTIONS(123),
    [anon_sym_downto] = ACTIONS(123),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(119),
  },
  [113] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(113),
    [sym_compiler_directive_decl] = STATE(113),
    [sym_fsi_directive_decl] = STATE(113),
    [sym_preproc_line] = STATE(113),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_EQ] = ACTIONS(223),
    [anon_sym_GT_RBRACK] = ACTIONS(223),
    [anon_sym_COLON] = ACTIONS(225),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_do] = ACTIONS(225),
    [anon_sym_let] = ACTIONS(225),
    [anon_sym_let_BANG] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_COMMA] = ACTIONS(223),
    [anon_sym_null] = ACTIONS(225),
    [anon_sym_QMARK] = ACTIONS(225),
    [anon_sym_COLON_QMARK] = ACTIONS(225),
    [anon_sym_COLON_COLON] = ACTIONS(223),
    [anon_sym_AMP] = ACTIONS(225),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_RBRACK] = ACTIONS(223),
    [anon_sym_LBRACK_PIPE] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(225),
    [anon_sym_RBRACE] = ACTIONS(223),
    [anon_sym_LT_AT] = ACTIONS(225),
    [anon_sym_LT_AT_AT] = ACTIONS(225),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(225),
    [anon_sym_with] = ACTIONS(225),
    [anon_sym_return_BANG] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(225),
    [anon_sym_yield_BANG] = ACTIONS(223),
    [anon_sym_lazy] = ACTIONS(225),
    [anon_sym_assert] = ACTIONS(225),
    [anon_sym_upcast] = ACTIONS(225),
    [anon_sym_downcast] = ACTIONS(225),
    [anon_sym_COLON_GT] = ACTIONS(223),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(223),
    [anon_sym_for] = ACTIONS(225),
    [anon_sym_to] = ACTIONS(225),
    [anon_sym_downto] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_fun] = ACTIONS(225),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_match] = ACTIONS(225),
    [anon_sym_match_BANG] = ACTIONS(223),
    [anon_sym_function] = ACTIONS(225),
    [anon_sym_LT_DASH] = ACTIONS(225),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(225),
    [anon_sym_use_BANG] = ACTIONS(223),
    [anon_sym_do_BANG] = ACTIONS(223),
    [anon_sym_begin] = ACTIONS(225),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(225),
    [aux_sym_char_token1] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_AT_DQUOTE] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [sym_bool] = ACTIONS(225),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(225),
    [sym_op_identifier] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(225),
    [anon_sym_DASH] = ACTIONS(225),
    [anon_sym_PLUS_DOT] = ACTIONS(225),
    [anon_sym_DASH_DOT] = ACTIONS(225),
    [anon_sym_PERCENT] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_TILDE] = ACTIONS(223),
    [aux_sym_prefix_op_token1] = ACTIONS(225),
    [aux_sym_infix_op_token1] = ACTIONS(223),
    [aux_sym_infix_op_token2] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_BANG_EQ] = ACTIONS(225),
    [anon_sym_COLON_EQ] = ACTIONS(223),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(225),
    [sym_int] = ACTIONS(225),
    [sym_xint] = ACTIONS(223),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(223),
    [sym__newline] = ACTIONS(223),
  },
  [114] = {
    [sym_function_or_value_defn] = STATE(964),
    [sym__expression] = STATE(118),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(793),
    [sym_infix_op] = STATE(1131),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(114),
    [sym_compiler_directive_decl] = STATE(114),
    [sym_fsi_directive_decl] = STATE(114),
    [sym_preproc_line] = STATE(114),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_sequential_expression_repeat1] = STATE(2515),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(119),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(123),
    [anon_sym_LBRACK_LT] = ACTIONS(119),
    [anon_sym_COLON] = ACTIONS(855),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_type] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(855),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(863),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(865),
    [anon_sym_DOT] = ACTIONS(867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(29),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_upcast] = ACTIONS(29),
    [anon_sym_downcast] = ACTIONS(29),
    [anon_sym_COLON_GT] = ACTIONS(871),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(871),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(903),
    [anon_sym_DOT_LBRACK] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_LPAREN2] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_exception] = ACTIONS(123),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(111),
    [sym_xint] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(119),
    [anon_sym_POUNDload] = ACTIONS(119),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
    [sym__newline] = ACTIONS(119),
  },
  [115] = {
    [sym_function_or_value_defn] = STATE(964),
    [sym__expression] = STATE(118),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(793),
    [sym_infix_op] = STATE(1131),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(115),
    [sym_compiler_directive_decl] = STATE(115),
    [sym_fsi_directive_decl] = STATE(115),
    [sym_preproc_line] = STATE(115),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_sequential_expression_repeat1] = STATE(2515),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(231),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(233),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(233),
    [anon_sym_LBRACK_LT] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(855),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_type] = ACTIONS(233),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(855),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(863),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(865),
    [anon_sym_DOT] = ACTIONS(867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(29),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_upcast] = ACTIONS(29),
    [anon_sym_downcast] = ACTIONS(29),
    [anon_sym_COLON_GT] = ACTIONS(871),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(871),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(903),
    [anon_sym_DOT_LBRACK] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_LPAREN2] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_exception] = ACTIONS(233),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(111),
    [sym_xint] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(231),
    [anon_sym_POUNDload] = ACTIONS(231),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
    [sym__newline] = ACTIONS(905),
  },
  [116] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(116),
    [sym_compiler_directive_decl] = STATE(116),
    [sym_fsi_directive_decl] = STATE(116),
    [sym_preproc_line] = STATE(116),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_GT_RBRACK] = ACTIONS(265),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(265),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(265),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(267),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_to] = ACTIONS(267),
    [anon_sym_downto] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [117] = {
    [sym_function_or_value_defn] = STATE(964),
    [sym__expression] = STATE(118),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(793),
    [sym_infix_op] = STATE(1131),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(117),
    [sym_compiler_directive_decl] = STATE(117),
    [sym_fsi_directive_decl] = STATE(117),
    [sym_preproc_line] = STATE(117),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_sequential_expression_repeat1] = STATE(2515),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(257),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(259),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(259),
    [anon_sym_LBRACK_LT] = ACTIONS(257),
    [anon_sym_COLON] = ACTIONS(855),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_type] = ACTIONS(259),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(855),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(259),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(865),
    [anon_sym_DOT] = ACTIONS(867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(29),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_upcast] = ACTIONS(29),
    [anon_sym_downcast] = ACTIONS(29),
    [anon_sym_COLON_GT] = ACTIONS(871),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(871),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(903),
    [anon_sym_DOT_LBRACK] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_LPAREN2] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_exception] = ACTIONS(259),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(111),
    [sym_xint] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(257),
    [anon_sym_POUNDload] = ACTIONS(257),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
    [sym__newline] = ACTIONS(257),
  },
  [118] = {
    [sym_function_or_value_defn] = STATE(964),
    [sym__expression] = STATE(118),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(793),
    [sym_infix_op] = STATE(1131),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(118),
    [sym_compiler_directive_decl] = STATE(118),
    [sym_fsi_directive_decl] = STATE(118),
    [sym_preproc_line] = STATE(118),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_sequential_expression_repeat1] = STATE(2515),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(223),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_module] = ACTIONS(225),
    [anon_sym_EQ] = ACTIONS(223),
    [anon_sym_open] = ACTIONS(225),
    [anon_sym_LBRACK_LT] = ACTIONS(223),
    [anon_sym_COLON] = ACTIONS(225),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_type] = ACTIONS(225),
    [anon_sym_do] = ACTIONS(225),
    [anon_sym_let] = ACTIONS(225),
    [anon_sym_let_BANG] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_COMMA] = ACTIONS(223),
    [anon_sym_null] = ACTIONS(225),
    [anon_sym_QMARK] = ACTIONS(225),
    [anon_sym_COLON_QMARK] = ACTIONS(225),
    [anon_sym_COLON_COLON] = ACTIONS(223),
    [anon_sym_AMP] = ACTIONS(225),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LBRACK_PIPE] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(225),
    [anon_sym_LT_AT] = ACTIONS(225),
    [anon_sym_LT_AT_AT] = ACTIONS(225),
    [anon_sym_DOT] = ACTIONS(867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(225),
    [anon_sym_return_BANG] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(225),
    [anon_sym_yield_BANG] = ACTIONS(223),
    [anon_sym_lazy] = ACTIONS(225),
    [anon_sym_assert] = ACTIONS(225),
    [anon_sym_upcast] = ACTIONS(225),
    [anon_sym_downcast] = ACTIONS(225),
    [anon_sym_COLON_GT] = ACTIONS(223),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(223),
    [anon_sym_for] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_fun] = ACTIONS(225),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_match] = ACTIONS(225),
    [anon_sym_match_BANG] = ACTIONS(223),
    [anon_sym_function] = ACTIONS(225),
    [anon_sym_LT_DASH] = ACTIONS(225),
    [anon_sym_DOT_LBRACK] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_use] = ACTIONS(225),
    [anon_sym_use_BANG] = ACTIONS(223),
    [anon_sym_do_BANG] = ACTIONS(223),
    [anon_sym_begin] = ACTIONS(225),
    [anon_sym_LPAREN2] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(225),
    [anon_sym_exception] = ACTIONS(225),
    [aux_sym_char_token1] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_AT_DQUOTE] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [sym_bool] = ACTIONS(225),
    [sym_unit] = ACTIONS(885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(225),
    [sym_op_identifier] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(225),
    [anon_sym_DASH] = ACTIONS(225),
    [anon_sym_PLUS_DOT] = ACTIONS(225),
    [anon_sym_DASH_DOT] = ACTIONS(225),
    [anon_sym_PERCENT] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_TILDE] = ACTIONS(223),
    [aux_sym_prefix_op_token1] = ACTIONS(225),
    [aux_sym_infix_op_token1] = ACTIONS(223),
    [aux_sym_infix_op_token2] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_BANG_EQ] = ACTIONS(225),
    [anon_sym_COLON_EQ] = ACTIONS(223),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(225),
    [sym_int] = ACTIONS(225),
    [sym_xint] = ACTIONS(223),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(223),
    [anon_sym_POUNDload] = ACTIONS(223),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(223),
    [sym__newline] = ACTIONS(223),
  },
  [119] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(119),
    [sym_compiler_directive_decl] = STATE(119),
    [sym_fsi_directive_decl] = STATE(119),
    [sym_preproc_line] = STATE(119),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_GT_RBRACK] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(231),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(231),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(233),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_to] = ACTIONS(233),
    [anon_sym_downto] = ACTIONS(233),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [120] = {
    [sym_function_or_value_defn] = STATE(964),
    [sym__expression] = STATE(118),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(793),
    [sym_infix_op] = STATE(1131),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(120),
    [sym_compiler_directive_decl] = STATE(120),
    [sym_fsi_directive_decl] = STATE(120),
    [sym_preproc_line] = STATE(120),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_sequential_expression_repeat1] = STATE(2515),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(897),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(899),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(899),
    [anon_sym_LBRACK_LT] = ACTIONS(897),
    [anon_sym_COLON] = ACTIONS(855),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_type] = ACTIONS(899),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(855),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(863),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(865),
    [anon_sym_DOT] = ACTIONS(867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(29),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_upcast] = ACTIONS(29),
    [anon_sym_downcast] = ACTIONS(29),
    [anon_sym_COLON_GT] = ACTIONS(871),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(871),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(903),
    [anon_sym_DOT_LBRACK] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_LPAREN2] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_exception] = ACTIONS(899),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(111),
    [sym_xint] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(897),
    [anon_sym_POUNDload] = ACTIONS(897),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
    [sym__newline] = ACTIONS(905),
  },
  [121] = {
    [sym_function_or_value_defn] = STATE(964),
    [sym__expression] = STATE(118),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(793),
    [sym_infix_op] = STATE(1131),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(121),
    [sym_compiler_directive_decl] = STATE(121),
    [sym_fsi_directive_decl] = STATE(121),
    [sym_preproc_line] = STATE(121),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_sequential_expression_repeat1] = STATE(2515),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(243),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(245),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(245),
    [anon_sym_LBRACK_LT] = ACTIONS(243),
    [anon_sym_COLON] = ACTIONS(855),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_type] = ACTIONS(245),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(855),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(865),
    [anon_sym_DOT] = ACTIONS(867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(29),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_upcast] = ACTIONS(29),
    [anon_sym_downcast] = ACTIONS(29),
    [anon_sym_COLON_GT] = ACTIONS(871),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(871),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(903),
    [anon_sym_DOT_LBRACK] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_LPAREN2] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_exception] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(111),
    [sym_xint] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(243),
    [anon_sym_POUNDload] = ACTIONS(243),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
    [sym__newline] = ACTIONS(243),
  },
  [122] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(122),
    [sym_compiler_directive_decl] = STATE(122),
    [sym_fsi_directive_decl] = STATE(122),
    [sym_preproc_line] = STATE(122),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_GT_RBRACK] = ACTIONS(261),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(261),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(261),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(263),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_to] = ACTIONS(263),
    [anon_sym_downto] = ACTIONS(263),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [123] = {
    [sym_function_or_value_defn] = STATE(964),
    [sym__expression] = STATE(118),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(793),
    [sym_infix_op] = STATE(1131),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(123),
    [sym_compiler_directive_decl] = STATE(123),
    [sym_fsi_directive_decl] = STATE(123),
    [sym_preproc_line] = STATE(123),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_sequential_expression_repeat1] = STATE(2515),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(253),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(255),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_open] = ACTIONS(255),
    [anon_sym_LBRACK_LT] = ACTIONS(253),
    [anon_sym_COLON] = ACTIONS(855),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_type] = ACTIONS(255),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(855),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(255),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(865),
    [anon_sym_DOT] = ACTIONS(867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(29),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_upcast] = ACTIONS(29),
    [anon_sym_downcast] = ACTIONS(29),
    [anon_sym_COLON_GT] = ACTIONS(871),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(871),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(903),
    [anon_sym_DOT_LBRACK] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_LPAREN2] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(143),
    [anon_sym_exception] = ACTIONS(255),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(111),
    [sym_xint] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(253),
    [anon_sym_POUNDload] = ACTIONS(253),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
    [sym__newline] = ACTIONS(253),
  },
  [124] = {
    [sym_function_or_value_defn] = STATE(964),
    [sym__expression] = STATE(118),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(793),
    [sym_infix_op] = STATE(1131),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(124),
    [sym_compiler_directive_decl] = STATE(124),
    [sym_fsi_directive_decl] = STATE(124),
    [sym_preproc_line] = STATE(124),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_sequential_expression_repeat1] = STATE(2515),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(227),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_module] = ACTIONS(229),
    [anon_sym_EQ] = ACTIONS(227),
    [anon_sym_open] = ACTIONS(229),
    [anon_sym_LBRACK_LT] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(229),
    [anon_sym_return] = ACTIONS(229),
    [anon_sym_type] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_let] = ACTIONS(229),
    [anon_sym_let_BANG] = ACTIONS(227),
    [anon_sym_LPAREN] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(227),
    [anon_sym_null] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_COLON_QMARK] = ACTIONS(229),
    [anon_sym_COLON_COLON] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_LBRACK] = ACTIONS(229),
    [anon_sym_LBRACK_PIPE] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(229),
    [anon_sym_LT_AT] = ACTIONS(229),
    [anon_sym_LT_AT_AT] = ACTIONS(229),
    [anon_sym_DOT] = ACTIONS(867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(227),
    [anon_sym_new] = ACTIONS(229),
    [anon_sym_return_BANG] = ACTIONS(227),
    [anon_sym_yield] = ACTIONS(229),
    [anon_sym_yield_BANG] = ACTIONS(227),
    [anon_sym_lazy] = ACTIONS(229),
    [anon_sym_assert] = ACTIONS(229),
    [anon_sym_upcast] = ACTIONS(229),
    [anon_sym_downcast] = ACTIONS(229),
    [anon_sym_COLON_GT] = ACTIONS(227),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_fun] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(229),
    [anon_sym_match_BANG] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(229),
    [anon_sym_LT_DASH] = ACTIONS(229),
    [anon_sym_DOT_LBRACK] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_use] = ACTIONS(229),
    [anon_sym_use_BANG] = ACTIONS(227),
    [anon_sym_do_BANG] = ACTIONS(227),
    [anon_sym_begin] = ACTIONS(229),
    [anon_sym_LPAREN2] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(229),
    [anon_sym_exception] = ACTIONS(229),
    [aux_sym_char_token1] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_AT_DQUOTE] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [sym_bool] = ACTIONS(229),
    [sym_unit] = ACTIONS(885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(229),
    [sym_op_identifier] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(229),
    [anon_sym_PLUS_DOT] = ACTIONS(229),
    [anon_sym_DASH_DOT] = ACTIONS(229),
    [anon_sym_PERCENT] = ACTIONS(229),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(227),
    [aux_sym_prefix_op_token1] = ACTIONS(229),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token2] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(229),
    [anon_sym_BANG_EQ] = ACTIONS(229),
    [anon_sym_COLON_EQ] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(229),
    [sym_int] = ACTIONS(229),
    [sym_xint] = ACTIONS(227),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(227),
    [anon_sym_POUNDload] = ACTIONS(227),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(227),
    [sym__newline] = ACTIONS(227),
  },
  [125] = {
    [sym_function_or_value_defn] = STATE(1166),
    [sym__expression] = STATE(137),
    [sym_literal_expression] = STATE(2884),
    [sym_long_identifier_or_op] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_brace_expression] = STATE(2884),
    [sym_anon_record_expression] = STATE(2884),
    [sym_prefixed_expression] = STATE(2884),
    [sym_typecast_expression] = STATE(2884),
    [sym_for_expression] = STATE(2884),
    [sym_while_expression] = STATE(2884),
    [sym__if_branch] = STATE(10729),
    [sym_if_expression] = STATE(2884),
    [sym_fun_expression] = STATE(2884),
    [sym_try_expression] = STATE(2884),
    [sym_match_expression] = STATE(2884),
    [sym_function_expression] = STATE(2884),
    [sym_mutate_expression] = STATE(2884),
    [sym_index_expression] = STATE(2884),
    [sym_typed_expression] = STATE(2884),
    [sym_declaration_expression] = STATE(2884),
    [sym_do_expression] = STATE(2884),
    [sym_list_expression] = STATE(2884),
    [sym_array_expression] = STATE(2884),
    [sym_begin_end_expression] = STATE(2884),
    [sym_paren_expression] = STATE(2884),
    [sym__high_prec_app] = STATE(2872),
    [sym__low_prec_app] = STATE(2872),
    [sym_application_expression] = STATE(2884),
    [sym_dot_expression] = STATE(2884),
    [sym_infix_expression] = STATE(2884),
    [sym_ce_expression] = STATE(2884),
    [sym_sequential_expression] = STATE(2884),
    [sym__object_members] = STATE(8858),
    [sym_char] = STATE(2955),
    [sym_format_string] = STATE(2951),
    [sym__string_literal] = STATE(2951),
    [sym_string] = STATE(2955),
    [sym_verbatim_string] = STATE(2955),
    [sym_bytearray] = STATE(2955),
    [sym_verbatim_bytearray] = STATE(2955),
    [sym_format_triple_quoted_string] = STATE(2949),
    [sym_triple_quoted_string] = STATE(2955),
    [sym_const] = STATE(2884),
    [sym_long_identifier] = STATE(2885),
    [sym_active_pattern] = STATE(2833),
    [sym__identifier_or_op] = STATE(2883),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1002),
    [sym_infix_op] = STATE(1172),
    [sym_sbyte] = STATE(2955),
    [sym_byte] = STATE(2955),
    [sym_int16] = STATE(2955),
    [sym_uint16] = STATE(2955),
    [sym_int32] = STATE(2955),
    [sym_uint32] = STATE(2955),
    [sym_nativeint] = STATE(2955),
    [sym_unativeint] = STATE(2955),
    [sym_int64] = STATE(2955),
    [sym_uint64] = STATE(2955),
    [sym_ieee32] = STATE(2955),
    [sym_ieee64] = STATE(2955),
    [sym_bignum] = STATE(2955),
    [sym_decimal] = STATE(2955),
    [sym_float] = STATE(2652),
    [sym_block_comment] = STATE(125),
    [sym_compiler_directive_decl] = STATE(125),
    [sym_fsi_directive_decl] = STATE(125),
    [sym_preproc_line] = STATE(125),
    [sym_preproc_if_in_expression] = STATE(2884),
    [aux_sym_sequential_expression_repeat1] = STATE(2752),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(999),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_do] = ACTIONS(1003),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(1005),
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_COMMA] = ACTIONS(1009),
    [anon_sym_null] = ACTIONS(1011),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(999),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1013),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1015),
    [anon_sym_LBRACE] = ACTIONS(1017),
    [anon_sym_LT_AT] = ACTIONS(1019),
    [anon_sym_LT_AT_AT] = ACTIONS(1021),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1025),
    [anon_sym_new] = ACTIONS(1001),
    [anon_sym_with] = ACTIONS(1027),
    [anon_sym_return_BANG] = ACTIONS(1029),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_yield_BANG] = ACTIONS(1029),
    [anon_sym_lazy] = ACTIONS(1001),
    [anon_sym_assert] = ACTIONS(1001),
    [anon_sym_upcast] = ACTIONS(1001),
    [anon_sym_downcast] = ACTIONS(1001),
    [anon_sym_COLON_GT] = ACTIONS(1031),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1031),
    [anon_sym_for] = ACTIONS(1033),
    [anon_sym_while] = ACTIONS(1035),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1037),
    [anon_sym_try] = ACTIONS(1039),
    [anon_sym_match] = ACTIONS(1041),
    [anon_sym_match_BANG] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(1045),
    [anon_sym_LT_DASH] = ACTIONS(1047),
    [anon_sym_DOT_LBRACK] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_use] = ACTIONS(1053),
    [anon_sym_use_BANG] = ACTIONS(1055),
    [anon_sym_do_BANG] = ACTIONS(1057),
    [anon_sym_begin] = ACTIONS(1059),
    [anon_sym_LPAREN2] = ACTIONS(1061),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1063),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1067),
    [anon_sym_AT_DQUOTE] = ACTIONS(1069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1073),
    [sym_bool] = ACTIONS(1075),
    [sym_unit] = ACTIONS(1077),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1079),
    [sym_op_identifier] = ACTIONS(1081),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1083),
    [sym_xint] = ACTIONS(1085),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1087),
    [sym__newline] = ACTIONS(119),
    [sym__dedent] = ACTIONS(119),
  },
  [126] = {
    [sym_function_or_value_defn] = STATE(1166),
    [sym__expression] = STATE(137),
    [sym_literal_expression] = STATE(2884),
    [sym_long_identifier_or_op] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_brace_expression] = STATE(2884),
    [sym_anon_record_expression] = STATE(2884),
    [sym_prefixed_expression] = STATE(2884),
    [sym_typecast_expression] = STATE(2884),
    [sym_for_expression] = STATE(2884),
    [sym_while_expression] = STATE(2884),
    [sym__if_branch] = STATE(10729),
    [sym_if_expression] = STATE(2884),
    [sym_fun_expression] = STATE(2884),
    [sym_try_expression] = STATE(2884),
    [sym_match_expression] = STATE(2884),
    [sym_function_expression] = STATE(2884),
    [sym_mutate_expression] = STATE(2884),
    [sym_index_expression] = STATE(2884),
    [sym_typed_expression] = STATE(2884),
    [sym_declaration_expression] = STATE(2884),
    [sym_do_expression] = STATE(2884),
    [sym_list_expression] = STATE(2884),
    [sym_array_expression] = STATE(2884),
    [sym_begin_end_expression] = STATE(2884),
    [sym_paren_expression] = STATE(2884),
    [sym__high_prec_app] = STATE(2872),
    [sym__low_prec_app] = STATE(2872),
    [sym_application_expression] = STATE(2884),
    [sym_dot_expression] = STATE(2884),
    [sym_infix_expression] = STATE(2884),
    [sym_ce_expression] = STATE(2884),
    [sym_sequential_expression] = STATE(2884),
    [sym_char] = STATE(2955),
    [sym_format_string] = STATE(2951),
    [sym__string_literal] = STATE(2951),
    [sym_string] = STATE(2955),
    [sym_verbatim_string] = STATE(2955),
    [sym_bytearray] = STATE(2955),
    [sym_verbatim_bytearray] = STATE(2955),
    [sym_format_triple_quoted_string] = STATE(2949),
    [sym_triple_quoted_string] = STATE(2955),
    [sym_const] = STATE(2884),
    [sym_long_identifier] = STATE(2885),
    [sym_active_pattern] = STATE(2833),
    [sym__identifier_or_op] = STATE(2883),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1002),
    [sym_infix_op] = STATE(1172),
    [sym_sbyte] = STATE(2955),
    [sym_byte] = STATE(2955),
    [sym_int16] = STATE(2955),
    [sym_uint16] = STATE(2955),
    [sym_int32] = STATE(2955),
    [sym_uint32] = STATE(2955),
    [sym_nativeint] = STATE(2955),
    [sym_unativeint] = STATE(2955),
    [sym_int64] = STATE(2955),
    [sym_uint64] = STATE(2955),
    [sym_ieee32] = STATE(2955),
    [sym_ieee64] = STATE(2955),
    [sym_bignum] = STATE(2955),
    [sym_decimal] = STATE(2955),
    [sym_float] = STATE(2652),
    [sym_block_comment] = STATE(126),
    [sym_compiler_directive_decl] = STATE(126),
    [sym_fsi_directive_decl] = STATE(126),
    [sym_preproc_line] = STATE(126),
    [sym_preproc_if_in_expression] = STATE(2884),
    [aux_sym_sequential_expression_repeat1] = STATE(2752),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_EQ] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(229),
    [anon_sym_return] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_let] = ACTIONS(229),
    [anon_sym_let_BANG] = ACTIONS(227),
    [anon_sym_as] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(227),
    [anon_sym_null] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_COLON_QMARK] = ACTIONS(229),
    [anon_sym_COLON_COLON] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_LBRACK] = ACTIONS(229),
    [anon_sym_LBRACK_PIPE] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(229),
    [anon_sym_LT_AT] = ACTIONS(229),
    [anon_sym_LT_AT_AT] = ACTIONS(229),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_LBRACE_PIPE] = ACTIONS(227),
    [anon_sym_new] = ACTIONS(229),
    [anon_sym_with] = ACTIONS(229),
    [anon_sym_return_BANG] = ACTIONS(227),
    [anon_sym_yield] = ACTIONS(229),
    [anon_sym_yield_BANG] = ACTIONS(227),
    [anon_sym_lazy] = ACTIONS(229),
    [anon_sym_assert] = ACTIONS(229),
    [anon_sym_upcast] = ACTIONS(229),
    [anon_sym_downcast] = ACTIONS(229),
    [anon_sym_COLON_GT] = ACTIONS(227),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_fun] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(229),
    [anon_sym_match_BANG] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(229),
    [anon_sym_LT_DASH] = ACTIONS(229),
    [anon_sym_DOT_LBRACK] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_use] = ACTIONS(229),
    [anon_sym_use_BANG] = ACTIONS(227),
    [anon_sym_do_BANG] = ACTIONS(227),
    [anon_sym_begin] = ACTIONS(229),
    [anon_sym_LPAREN2] = ACTIONS(1061),
    [anon_sym_or] = ACTIONS(229),
    [aux_sym_char_token1] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_AT_DQUOTE] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [sym_bool] = ACTIONS(229),
    [sym_unit] = ACTIONS(1077),
    [anon_sym_LPAREN_PIPE] = ACTIONS(229),
    [sym_op_identifier] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(229),
    [anon_sym_PLUS_DOT] = ACTIONS(229),
    [anon_sym_DASH_DOT] = ACTIONS(229),
    [anon_sym_PERCENT] = ACTIONS(229),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(227),
    [aux_sym_prefix_op_token1] = ACTIONS(229),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token2] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(229),
    [anon_sym_BANG_EQ] = ACTIONS(229),
    [anon_sym_COLON_EQ] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(229),
    [sym_int] = ACTIONS(229),
    [sym_xint] = ACTIONS(227),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(227),
    [sym__newline] = ACTIONS(227),
    [sym__dedent] = ACTIONS(227),
  },
  [127] = {
    [sym_function_or_value_defn] = STATE(1166),
    [sym__expression] = STATE(137),
    [sym_literal_expression] = STATE(2884),
    [sym_long_identifier_or_op] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_brace_expression] = STATE(2884),
    [sym_anon_record_expression] = STATE(2884),
    [sym_prefixed_expression] = STATE(2884),
    [sym_typecast_expression] = STATE(2884),
    [sym_for_expression] = STATE(2884),
    [sym_while_expression] = STATE(2884),
    [sym__if_branch] = STATE(10729),
    [sym_if_expression] = STATE(2884),
    [sym_fun_expression] = STATE(2884),
    [sym_try_expression] = STATE(2884),
    [sym_match_expression] = STATE(2884),
    [sym_function_expression] = STATE(2884),
    [sym_mutate_expression] = STATE(2884),
    [sym_index_expression] = STATE(2884),
    [sym_typed_expression] = STATE(2884),
    [sym_declaration_expression] = STATE(2884),
    [sym_do_expression] = STATE(2884),
    [sym_list_expression] = STATE(2884),
    [sym_array_expression] = STATE(2884),
    [sym_begin_end_expression] = STATE(2884),
    [sym_paren_expression] = STATE(2884),
    [sym__high_prec_app] = STATE(2872),
    [sym__low_prec_app] = STATE(2872),
    [sym_application_expression] = STATE(2884),
    [sym_dot_expression] = STATE(2884),
    [sym_infix_expression] = STATE(2884),
    [sym_ce_expression] = STATE(2884),
    [sym_sequential_expression] = STATE(2884),
    [sym_char] = STATE(2955),
    [sym_format_string] = STATE(2951),
    [sym__string_literal] = STATE(2951),
    [sym_string] = STATE(2955),
    [sym_verbatim_string] = STATE(2955),
    [sym_bytearray] = STATE(2955),
    [sym_verbatim_bytearray] = STATE(2955),
    [sym_format_triple_quoted_string] = STATE(2949),
    [sym_triple_quoted_string] = STATE(2955),
    [sym_const] = STATE(2884),
    [sym_long_identifier] = STATE(2885),
    [sym_active_pattern] = STATE(2833),
    [sym__identifier_or_op] = STATE(2883),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1002),
    [sym_infix_op] = STATE(1172),
    [sym_sbyte] = STATE(2955),
    [sym_byte] = STATE(2955),
    [sym_int16] = STATE(2955),
    [sym_uint16] = STATE(2955),
    [sym_int32] = STATE(2955),
    [sym_uint32] = STATE(2955),
    [sym_nativeint] = STATE(2955),
    [sym_unativeint] = STATE(2955),
    [sym_int64] = STATE(2955),
    [sym_uint64] = STATE(2955),
    [sym_ieee32] = STATE(2955),
    [sym_ieee64] = STATE(2955),
    [sym_bignum] = STATE(2955),
    [sym_decimal] = STATE(2955),
    [sym_float] = STATE(2652),
    [sym_block_comment] = STATE(127),
    [sym_compiler_directive_decl] = STATE(127),
    [sym_fsi_directive_decl] = STATE(127),
    [sym_preproc_line] = STATE(127),
    [sym_preproc_if_in_expression] = STATE(2884),
    [aux_sym_sequential_expression_repeat1] = STATE(2752),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(999),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_do] = ACTIONS(1003),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_COMMA] = ACTIONS(1009),
    [anon_sym_null] = ACTIONS(1011),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(999),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1013),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1015),
    [anon_sym_LBRACE] = ACTIONS(1017),
    [anon_sym_LT_AT] = ACTIONS(1019),
    [anon_sym_LT_AT_AT] = ACTIONS(1021),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1025),
    [anon_sym_new] = ACTIONS(1001),
    [anon_sym_with] = ACTIONS(233),
    [anon_sym_return_BANG] = ACTIONS(1029),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_yield_BANG] = ACTIONS(1029),
    [anon_sym_lazy] = ACTIONS(1001),
    [anon_sym_assert] = ACTIONS(1001),
    [anon_sym_upcast] = ACTIONS(1001),
    [anon_sym_downcast] = ACTIONS(1001),
    [anon_sym_COLON_GT] = ACTIONS(1031),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1031),
    [anon_sym_for] = ACTIONS(1033),
    [anon_sym_while] = ACTIONS(1035),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1037),
    [anon_sym_try] = ACTIONS(1039),
    [anon_sym_match] = ACTIONS(1041),
    [anon_sym_match_BANG] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(1045),
    [anon_sym_LT_DASH] = ACTIONS(1047),
    [anon_sym_DOT_LBRACK] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_use] = ACTIONS(1053),
    [anon_sym_use_BANG] = ACTIONS(1055),
    [anon_sym_do_BANG] = ACTIONS(1057),
    [anon_sym_begin] = ACTIONS(1059),
    [anon_sym_LPAREN2] = ACTIONS(1061),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1063),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1067),
    [anon_sym_AT_DQUOTE] = ACTIONS(1069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1073),
    [sym_bool] = ACTIONS(1075),
    [sym_unit] = ACTIONS(1077),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1079),
    [sym_op_identifier] = ACTIONS(1081),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1083),
    [sym_xint] = ACTIONS(1085),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1087),
    [sym__newline] = ACTIONS(1089),
    [sym__dedent] = ACTIONS(231),
  },
  [128] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(183),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1113),
    [sym_infix_op] = STATE(900),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(128),
    [sym_compiler_directive_decl] = STATE(128),
    [sym_fsi_directive_decl] = STATE(128),
    [sym_preproc_line] = STATE(128),
    [sym_preproc_else] = STATE(11754),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_sequential_expression_repeat1] = STATE(2799),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(289),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(309),
    [anon_sym_DOT] = ACTIONS(311),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_COLON_GT] = ACTIONS(317),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_LT_DASH] = ACTIONS(1097),
    [anon_sym_DOT_LBRACK] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [anon_sym_LPAREN2] = ACTIONS(347),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(1107),
    [anon_sym_POUNDelse] = ACTIONS(1110),
    [sym__newline] = ACTIONS(1113),
  },
  [129] = {
    [sym_function_or_value_defn] = STATE(1180),
    [sym__expression] = STATE(239),
    [sym_literal_expression] = STATE(3145),
    [sym_long_identifier_or_op] = STATE(3145),
    [sym_tuple_expression] = STATE(3145),
    [sym_brace_expression] = STATE(3145),
    [sym_anon_record_expression] = STATE(3145),
    [sym_prefixed_expression] = STATE(3145),
    [sym_typecast_expression] = STATE(3145),
    [sym_for_expression] = STATE(3145),
    [sym_while_expression] = STATE(3145),
    [sym__if_branch] = STATE(10360),
    [sym_if_expression] = STATE(3145),
    [sym_fun_expression] = STATE(3145),
    [sym_try_expression] = STATE(3145),
    [sym_match_expression] = STATE(3145),
    [sym_function_expression] = STATE(3145),
    [sym_mutate_expression] = STATE(3145),
    [sym_index_expression] = STATE(3145),
    [sym_typed_expression] = STATE(3145),
    [sym_declaration_expression] = STATE(3145),
    [sym_do_expression] = STATE(3145),
    [sym_list_expression] = STATE(3145),
    [sym_array_expression] = STATE(3145),
    [sym_begin_end_expression] = STATE(3145),
    [sym_paren_expression] = STATE(3145),
    [sym__high_prec_app] = STATE(3141),
    [sym__low_prec_app] = STATE(3141),
    [sym_application_expression] = STATE(3145),
    [sym_dot_expression] = STATE(3145),
    [sym_infix_expression] = STATE(3145),
    [sym_ce_expression] = STATE(3145),
    [sym_sequential_expression] = STATE(3145),
    [sym__object_members] = STATE(8858),
    [sym_char] = STATE(3108),
    [sym_format_string] = STATE(3193),
    [sym__string_literal] = STATE(3193),
    [sym_string] = STATE(3108),
    [sym_verbatim_string] = STATE(3108),
    [sym_bytearray] = STATE(3108),
    [sym_verbatim_bytearray] = STATE(3108),
    [sym_format_triple_quoted_string] = STATE(3192),
    [sym_triple_quoted_string] = STATE(3108),
    [sym_const] = STATE(3145),
    [sym_long_identifier] = STATE(3102),
    [sym_active_pattern] = STATE(3172),
    [sym__identifier_or_op] = STATE(3103),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1149),
    [sym_infix_op] = STATE(912),
    [sym_sbyte] = STATE(3108),
    [sym_byte] = STATE(3108),
    [sym_int16] = STATE(3108),
    [sym_uint16] = STATE(3108),
    [sym_int32] = STATE(3108),
    [sym_uint32] = STATE(3108),
    [sym_nativeint] = STATE(3108),
    [sym_unativeint] = STATE(3108),
    [sym_int64] = STATE(3108),
    [sym_uint64] = STATE(3108),
    [sym_ieee32] = STATE(3108),
    [sym_ieee64] = STATE(3108),
    [sym_bignum] = STATE(3108),
    [sym_decimal] = STATE(3108),
    [sym_float] = STATE(2770),
    [sym_block_comment] = STATE(129),
    [sym_compiler_directive_decl] = STATE(129),
    [sym_fsi_directive_decl] = STATE(129),
    [sym_preproc_line] = STATE(129),
    [sym_preproc_if_in_expression] = STATE(3145),
    [aux_sym_sequential_expression_repeat1] = STATE(2846),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1117),
    [anon_sym_return] = ACTIONS(1119),
    [anon_sym_do] = ACTIONS(1121),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(1005),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1125),
    [anon_sym_null] = ACTIONS(1127),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1117),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1131),
    [anon_sym_LBRACE] = ACTIONS(1133),
    [anon_sym_LT_AT] = ACTIONS(1135),
    [anon_sym_LT_AT_AT] = ACTIONS(1137),
    [anon_sym_DOT] = ACTIONS(1139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1141),
    [anon_sym_new] = ACTIONS(1119),
    [anon_sym_with] = ACTIONS(1027),
    [anon_sym_return_BANG] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1119),
    [anon_sym_yield_BANG] = ACTIONS(1143),
    [anon_sym_lazy] = ACTIONS(1119),
    [anon_sym_assert] = ACTIONS(1119),
    [anon_sym_upcast] = ACTIONS(1119),
    [anon_sym_downcast] = ACTIONS(1119),
    [anon_sym_COLON_GT] = ACTIONS(1145),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1145),
    [anon_sym_for] = ACTIONS(1147),
    [anon_sym_while] = ACTIONS(1149),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1151),
    [anon_sym_try] = ACTIONS(1153),
    [anon_sym_match] = ACTIONS(1155),
    [anon_sym_match_BANG] = ACTIONS(1157),
    [anon_sym_function] = ACTIONS(1159),
    [anon_sym_LT_DASH] = ACTIONS(1161),
    [anon_sym_DOT_LBRACK] = ACTIONS(1163),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_use] = ACTIONS(1167),
    [anon_sym_use_BANG] = ACTIONS(1169),
    [anon_sym_do_BANG] = ACTIONS(1171),
    [anon_sym_begin] = ACTIONS(1173),
    [anon_sym_LPAREN2] = ACTIONS(1175),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1177),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(1181),
    [anon_sym_AT_DQUOTE] = ACTIONS(1183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1185),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1187),
    [sym_bool] = ACTIONS(1189),
    [sym_unit] = ACTIONS(1191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1193),
    [sym_op_identifier] = ACTIONS(1195),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1197),
    [sym_xint] = ACTIONS(1199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1201),
    [sym__newline] = ACTIONS(119),
  },
  [130] = {
    [sym_function_or_value_defn] = STATE(1166),
    [sym__expression] = STATE(137),
    [sym_literal_expression] = STATE(2884),
    [sym_long_identifier_or_op] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_brace_expression] = STATE(2884),
    [sym_anon_record_expression] = STATE(2884),
    [sym_prefixed_expression] = STATE(2884),
    [sym_typecast_expression] = STATE(2884),
    [sym_for_expression] = STATE(2884),
    [sym_while_expression] = STATE(2884),
    [sym__if_branch] = STATE(10729),
    [sym_if_expression] = STATE(2884),
    [sym_fun_expression] = STATE(2884),
    [sym_try_expression] = STATE(2884),
    [sym_match_expression] = STATE(2884),
    [sym_function_expression] = STATE(2884),
    [sym_mutate_expression] = STATE(2884),
    [sym_index_expression] = STATE(2884),
    [sym_typed_expression] = STATE(2884),
    [sym_declaration_expression] = STATE(2884),
    [sym_do_expression] = STATE(2884),
    [sym_list_expression] = STATE(2884),
    [sym_array_expression] = STATE(2884),
    [sym_begin_end_expression] = STATE(2884),
    [sym_paren_expression] = STATE(2884),
    [sym__high_prec_app] = STATE(2872),
    [sym__low_prec_app] = STATE(2872),
    [sym_application_expression] = STATE(2884),
    [sym_dot_expression] = STATE(2884),
    [sym_infix_expression] = STATE(2884),
    [sym_ce_expression] = STATE(2884),
    [sym_sequential_expression] = STATE(2884),
    [sym_char] = STATE(2955),
    [sym_format_string] = STATE(2951),
    [sym__string_literal] = STATE(2951),
    [sym_string] = STATE(2955),
    [sym_verbatim_string] = STATE(2955),
    [sym_bytearray] = STATE(2955),
    [sym_verbatim_bytearray] = STATE(2955),
    [sym_format_triple_quoted_string] = STATE(2949),
    [sym_triple_quoted_string] = STATE(2955),
    [sym_const] = STATE(2884),
    [sym_long_identifier] = STATE(2885),
    [sym_active_pattern] = STATE(2833),
    [sym__identifier_or_op] = STATE(2883),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1002),
    [sym_infix_op] = STATE(1172),
    [sym_sbyte] = STATE(2955),
    [sym_byte] = STATE(2955),
    [sym_int16] = STATE(2955),
    [sym_uint16] = STATE(2955),
    [sym_int32] = STATE(2955),
    [sym_uint32] = STATE(2955),
    [sym_nativeint] = STATE(2955),
    [sym_unativeint] = STATE(2955),
    [sym_int64] = STATE(2955),
    [sym_uint64] = STATE(2955),
    [sym_ieee32] = STATE(2955),
    [sym_ieee64] = STATE(2955),
    [sym_bignum] = STATE(2955),
    [sym_decimal] = STATE(2955),
    [sym_float] = STATE(2652),
    [sym_block_comment] = STATE(130),
    [sym_compiler_directive_decl] = STATE(130),
    [sym_fsi_directive_decl] = STATE(130),
    [sym_preproc_line] = STATE(130),
    [sym_preproc_if_in_expression] = STATE(2884),
    [aux_sym_sequential_expression_repeat1] = STATE(2752),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(999),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_do] = ACTIONS(1003),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(263),
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_COMMA] = ACTIONS(1009),
    [anon_sym_null] = ACTIONS(1011),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(999),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1013),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1015),
    [anon_sym_LBRACE] = ACTIONS(1017),
    [anon_sym_LT_AT] = ACTIONS(1019),
    [anon_sym_LT_AT_AT] = ACTIONS(1021),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1025),
    [anon_sym_new] = ACTIONS(1001),
    [anon_sym_with] = ACTIONS(263),
    [anon_sym_return_BANG] = ACTIONS(1029),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_yield_BANG] = ACTIONS(1029),
    [anon_sym_lazy] = ACTIONS(1001),
    [anon_sym_assert] = ACTIONS(1001),
    [anon_sym_upcast] = ACTIONS(1001),
    [anon_sym_downcast] = ACTIONS(1001),
    [anon_sym_COLON_GT] = ACTIONS(1031),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1031),
    [anon_sym_for] = ACTIONS(1033),
    [anon_sym_while] = ACTIONS(1035),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1037),
    [anon_sym_try] = ACTIONS(1039),
    [anon_sym_match] = ACTIONS(1041),
    [anon_sym_match_BANG] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(1045),
    [anon_sym_LT_DASH] = ACTIONS(1047),
    [anon_sym_DOT_LBRACK] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_use] = ACTIONS(1053),
    [anon_sym_use_BANG] = ACTIONS(1055),
    [anon_sym_do_BANG] = ACTIONS(1057),
    [anon_sym_begin] = ACTIONS(1059),
    [anon_sym_LPAREN2] = ACTIONS(1061),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1063),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1067),
    [anon_sym_AT_DQUOTE] = ACTIONS(1069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1073),
    [sym_bool] = ACTIONS(1075),
    [sym_unit] = ACTIONS(1077),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1079),
    [sym_op_identifier] = ACTIONS(1081),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1083),
    [sym_xint] = ACTIONS(1085),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1087),
    [sym__newline] = ACTIONS(1089),
    [sym__dedent] = ACTIONS(261),
  },
  [131] = {
    [sym_function_or_value_defn] = STATE(845),
    [sym__expression] = STATE(209),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(776),
    [sym_infix_op] = STATE(867),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(131),
    [sym_compiler_directive_decl] = STATE(131),
    [sym_fsi_directive_decl] = STATE(131),
    [sym_preproc_line] = STATE(131),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym__list_elements_repeat1] = STATE(9176),
    [aux_sym_sequential_expression_repeat1] = STATE(2959),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1203),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1205),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1203),
    [anon_sym_return_BANG] = ACTIONS(1207),
    [anon_sym_yield] = ACTIONS(1203),
    [anon_sym_yield_BANG] = ACTIONS(1207),
    [anon_sym_lazy] = ACTIONS(1203),
    [anon_sym_assert] = ACTIONS(1203),
    [anon_sym_upcast] = ACTIONS(1203),
    [anon_sym_downcast] = ACTIONS(1203),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(1209),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1211),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1213),
    [anon_sym_use_BANG] = ACTIONS(1215),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_DOT_DOT2] = ACTIONS(1217),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1219),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1223),
    [sym__dedent] = ACTIONS(1225),
  },
  [132] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(183),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1113),
    [sym_infix_op] = STATE(900),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(132),
    [sym_compiler_directive_decl] = STATE(132),
    [sym_fsi_directive_decl] = STATE(132),
    [sym_preproc_line] = STATE(132),
    [sym_preproc_else] = STATE(11987),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_sequential_expression_repeat1] = STATE(2799),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(289),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(309),
    [anon_sym_DOT] = ACTIONS(311),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_COLON_GT] = ACTIONS(317),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_LT_DASH] = ACTIONS(1097),
    [anon_sym_DOT_LBRACK] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [anon_sym_LPAREN2] = ACTIONS(347),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(1227),
    [anon_sym_POUNDelse] = ACTIONS(1110),
    [sym__newline] = ACTIONS(1113),
  },
  [133] = {
    [sym_function_or_value_defn] = STATE(1166),
    [sym__expression] = STATE(137),
    [sym_literal_expression] = STATE(2884),
    [sym_long_identifier_or_op] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_brace_expression] = STATE(2884),
    [sym_anon_record_expression] = STATE(2884),
    [sym_prefixed_expression] = STATE(2884),
    [sym_typecast_expression] = STATE(2884),
    [sym_for_expression] = STATE(2884),
    [sym_while_expression] = STATE(2884),
    [sym__if_branch] = STATE(10729),
    [sym_if_expression] = STATE(2884),
    [sym_fun_expression] = STATE(2884),
    [sym_try_expression] = STATE(2884),
    [sym_match_expression] = STATE(2884),
    [sym_function_expression] = STATE(2884),
    [sym_mutate_expression] = STATE(2884),
    [sym_index_expression] = STATE(2884),
    [sym_typed_expression] = STATE(2884),
    [sym_declaration_expression] = STATE(2884),
    [sym_do_expression] = STATE(2884),
    [sym_list_expression] = STATE(2884),
    [sym_array_expression] = STATE(2884),
    [sym_begin_end_expression] = STATE(2884),
    [sym_paren_expression] = STATE(2884),
    [sym__high_prec_app] = STATE(2872),
    [sym__low_prec_app] = STATE(2872),
    [sym_application_expression] = STATE(2884),
    [sym_dot_expression] = STATE(2884),
    [sym_infix_expression] = STATE(2884),
    [sym_ce_expression] = STATE(2884),
    [sym_sequential_expression] = STATE(2884),
    [sym_char] = STATE(2955),
    [sym_format_string] = STATE(2951),
    [sym__string_literal] = STATE(2951),
    [sym_string] = STATE(2955),
    [sym_verbatim_string] = STATE(2955),
    [sym_bytearray] = STATE(2955),
    [sym_verbatim_bytearray] = STATE(2955),
    [sym_format_triple_quoted_string] = STATE(2949),
    [sym_triple_quoted_string] = STATE(2955),
    [sym_const] = STATE(2884),
    [sym_long_identifier] = STATE(2885),
    [sym_active_pattern] = STATE(2833),
    [sym__identifier_or_op] = STATE(2883),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1002),
    [sym_infix_op] = STATE(1172),
    [sym_sbyte] = STATE(2955),
    [sym_byte] = STATE(2955),
    [sym_int16] = STATE(2955),
    [sym_uint16] = STATE(2955),
    [sym_int32] = STATE(2955),
    [sym_uint32] = STATE(2955),
    [sym_nativeint] = STATE(2955),
    [sym_unativeint] = STATE(2955),
    [sym_int64] = STATE(2955),
    [sym_uint64] = STATE(2955),
    [sym_ieee32] = STATE(2955),
    [sym_ieee64] = STATE(2955),
    [sym_bignum] = STATE(2955),
    [sym_decimal] = STATE(2955),
    [sym_float] = STATE(2652),
    [sym_block_comment] = STATE(133),
    [sym_compiler_directive_decl] = STATE(133),
    [sym_fsi_directive_decl] = STATE(133),
    [sym_preproc_line] = STATE(133),
    [sym_preproc_if_in_expression] = STATE(2884),
    [aux_sym_sequential_expression_repeat1] = STATE(2752),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(999),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_do] = ACTIONS(1003),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(123),
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_COMMA] = ACTIONS(1009),
    [anon_sym_null] = ACTIONS(1011),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(999),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1013),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1015),
    [anon_sym_LBRACE] = ACTIONS(1017),
    [anon_sym_LT_AT] = ACTIONS(1019),
    [anon_sym_LT_AT_AT] = ACTIONS(1021),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1025),
    [anon_sym_new] = ACTIONS(1001),
    [anon_sym_with] = ACTIONS(123),
    [anon_sym_return_BANG] = ACTIONS(1029),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_yield_BANG] = ACTIONS(1029),
    [anon_sym_lazy] = ACTIONS(1001),
    [anon_sym_assert] = ACTIONS(1001),
    [anon_sym_upcast] = ACTIONS(1001),
    [anon_sym_downcast] = ACTIONS(1001),
    [anon_sym_COLON_GT] = ACTIONS(1031),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1031),
    [anon_sym_for] = ACTIONS(1033),
    [anon_sym_while] = ACTIONS(1035),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1037),
    [anon_sym_try] = ACTIONS(1039),
    [anon_sym_match] = ACTIONS(1041),
    [anon_sym_match_BANG] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(1045),
    [anon_sym_LT_DASH] = ACTIONS(1047),
    [anon_sym_DOT_LBRACK] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_use] = ACTIONS(1053),
    [anon_sym_use_BANG] = ACTIONS(1055),
    [anon_sym_do_BANG] = ACTIONS(1057),
    [anon_sym_begin] = ACTIONS(1059),
    [anon_sym_LPAREN2] = ACTIONS(1061),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1063),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1067),
    [anon_sym_AT_DQUOTE] = ACTIONS(1069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1073),
    [sym_bool] = ACTIONS(1075),
    [sym_unit] = ACTIONS(1077),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1079),
    [sym_op_identifier] = ACTIONS(1081),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1083),
    [sym_xint] = ACTIONS(1085),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1087),
    [sym__newline] = ACTIONS(119),
    [sym__dedent] = ACTIONS(119),
  },
  [134] = {
    [sym_function_or_value_defn] = STATE(1166),
    [sym__expression] = STATE(137),
    [sym_literal_expression] = STATE(2884),
    [sym_long_identifier_or_op] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_brace_expression] = STATE(2884),
    [sym_anon_record_expression] = STATE(2884),
    [sym_prefixed_expression] = STATE(2884),
    [sym_typecast_expression] = STATE(2884),
    [sym_for_expression] = STATE(2884),
    [sym_while_expression] = STATE(2884),
    [sym__if_branch] = STATE(10729),
    [sym_if_expression] = STATE(2884),
    [sym_fun_expression] = STATE(2884),
    [sym_try_expression] = STATE(2884),
    [sym_match_expression] = STATE(2884),
    [sym_function_expression] = STATE(2884),
    [sym_mutate_expression] = STATE(2884),
    [sym_index_expression] = STATE(2884),
    [sym_typed_expression] = STATE(2884),
    [sym_declaration_expression] = STATE(2884),
    [sym_do_expression] = STATE(2884),
    [sym_list_expression] = STATE(2884),
    [sym_array_expression] = STATE(2884),
    [sym_begin_end_expression] = STATE(2884),
    [sym_paren_expression] = STATE(2884),
    [sym__high_prec_app] = STATE(2872),
    [sym__low_prec_app] = STATE(2872),
    [sym_application_expression] = STATE(2884),
    [sym_dot_expression] = STATE(2884),
    [sym_infix_expression] = STATE(2884),
    [sym_ce_expression] = STATE(2884),
    [sym_sequential_expression] = STATE(2884),
    [sym_char] = STATE(2955),
    [sym_format_string] = STATE(2951),
    [sym__string_literal] = STATE(2951),
    [sym_string] = STATE(2955),
    [sym_verbatim_string] = STATE(2955),
    [sym_bytearray] = STATE(2955),
    [sym_verbatim_bytearray] = STATE(2955),
    [sym_format_triple_quoted_string] = STATE(2949),
    [sym_triple_quoted_string] = STATE(2955),
    [sym_const] = STATE(2884),
    [sym_long_identifier] = STATE(2885),
    [sym_active_pattern] = STATE(2833),
    [sym__identifier_or_op] = STATE(2883),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1002),
    [sym_infix_op] = STATE(1172),
    [sym_sbyte] = STATE(2955),
    [sym_byte] = STATE(2955),
    [sym_int16] = STATE(2955),
    [sym_uint16] = STATE(2955),
    [sym_int32] = STATE(2955),
    [sym_uint32] = STATE(2955),
    [sym_nativeint] = STATE(2955),
    [sym_unativeint] = STATE(2955),
    [sym_int64] = STATE(2955),
    [sym_uint64] = STATE(2955),
    [sym_ieee32] = STATE(2955),
    [sym_ieee64] = STATE(2955),
    [sym_bignum] = STATE(2955),
    [sym_decimal] = STATE(2955),
    [sym_float] = STATE(2652),
    [sym_block_comment] = STATE(134),
    [sym_compiler_directive_decl] = STATE(134),
    [sym_fsi_directive_decl] = STATE(134),
    [sym_preproc_line] = STATE(134),
    [sym_preproc_if_in_expression] = STATE(2884),
    [aux_sym_sequential_expression_repeat1] = STATE(2752),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(999),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_do] = ACTIONS(1003),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(259),
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_COMMA] = ACTIONS(1009),
    [anon_sym_null] = ACTIONS(1011),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(999),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1013),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1015),
    [anon_sym_LBRACE] = ACTIONS(259),
    [anon_sym_LT_AT] = ACTIONS(1019),
    [anon_sym_LT_AT_AT] = ACTIONS(1021),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1025),
    [anon_sym_new] = ACTIONS(1001),
    [anon_sym_with] = ACTIONS(259),
    [anon_sym_return_BANG] = ACTIONS(1029),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_yield_BANG] = ACTIONS(1029),
    [anon_sym_lazy] = ACTIONS(1001),
    [anon_sym_assert] = ACTIONS(1001),
    [anon_sym_upcast] = ACTIONS(1001),
    [anon_sym_downcast] = ACTIONS(1001),
    [anon_sym_COLON_GT] = ACTIONS(1031),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1031),
    [anon_sym_for] = ACTIONS(1033),
    [anon_sym_while] = ACTIONS(1035),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1037),
    [anon_sym_try] = ACTIONS(1039),
    [anon_sym_match] = ACTIONS(1041),
    [anon_sym_match_BANG] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(1045),
    [anon_sym_LT_DASH] = ACTIONS(1047),
    [anon_sym_DOT_LBRACK] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_use] = ACTIONS(1053),
    [anon_sym_use_BANG] = ACTIONS(1055),
    [anon_sym_do_BANG] = ACTIONS(1057),
    [anon_sym_begin] = ACTIONS(1059),
    [anon_sym_LPAREN2] = ACTIONS(1061),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1063),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1067),
    [anon_sym_AT_DQUOTE] = ACTIONS(1069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1073),
    [sym_bool] = ACTIONS(1075),
    [sym_unit] = ACTIONS(1077),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1079),
    [sym_op_identifier] = ACTIONS(1081),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1083),
    [sym_xint] = ACTIONS(1085),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1087),
    [sym__newline] = ACTIONS(257),
    [sym__dedent] = ACTIONS(257),
  },
  [135] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(183),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1113),
    [sym_infix_op] = STATE(900),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(135),
    [sym_compiler_directive_decl] = STATE(135),
    [sym_fsi_directive_decl] = STATE(135),
    [sym_preproc_line] = STATE(135),
    [sym_preproc_else] = STATE(11830),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_sequential_expression_repeat1] = STATE(2799),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(289),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(309),
    [anon_sym_DOT] = ACTIONS(311),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_COLON_GT] = ACTIONS(317),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_LT_DASH] = ACTIONS(1097),
    [anon_sym_DOT_LBRACK] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [anon_sym_LPAREN2] = ACTIONS(347),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(1230),
    [anon_sym_POUNDelse] = ACTIONS(1110),
    [sym__newline] = ACTIONS(1113),
  },
  [136] = {
    [sym_function_or_value_defn] = STATE(1166),
    [sym__expression] = STATE(137),
    [sym_literal_expression] = STATE(2884),
    [sym_long_identifier_or_op] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_brace_expression] = STATE(2884),
    [sym_anon_record_expression] = STATE(2884),
    [sym_prefixed_expression] = STATE(2884),
    [sym_typecast_expression] = STATE(2884),
    [sym_for_expression] = STATE(2884),
    [sym_while_expression] = STATE(2884),
    [sym__if_branch] = STATE(10729),
    [sym_if_expression] = STATE(2884),
    [sym_fun_expression] = STATE(2884),
    [sym_try_expression] = STATE(2884),
    [sym_match_expression] = STATE(2884),
    [sym_function_expression] = STATE(2884),
    [sym_mutate_expression] = STATE(2884),
    [sym_index_expression] = STATE(2884),
    [sym_typed_expression] = STATE(2884),
    [sym_declaration_expression] = STATE(2884),
    [sym_do_expression] = STATE(2884),
    [sym_list_expression] = STATE(2884),
    [sym_array_expression] = STATE(2884),
    [sym_begin_end_expression] = STATE(2884),
    [sym_paren_expression] = STATE(2884),
    [sym__high_prec_app] = STATE(2872),
    [sym__low_prec_app] = STATE(2872),
    [sym_application_expression] = STATE(2884),
    [sym_dot_expression] = STATE(2884),
    [sym_infix_expression] = STATE(2884),
    [sym_ce_expression] = STATE(2884),
    [sym_sequential_expression] = STATE(2884),
    [sym_char] = STATE(2955),
    [sym_format_string] = STATE(2951),
    [sym__string_literal] = STATE(2951),
    [sym_string] = STATE(2955),
    [sym_verbatim_string] = STATE(2955),
    [sym_bytearray] = STATE(2955),
    [sym_verbatim_bytearray] = STATE(2955),
    [sym_format_triple_quoted_string] = STATE(2949),
    [sym_triple_quoted_string] = STATE(2955),
    [sym_const] = STATE(2884),
    [sym_long_identifier] = STATE(2885),
    [sym_active_pattern] = STATE(2833),
    [sym__identifier_or_op] = STATE(2883),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1002),
    [sym_infix_op] = STATE(1172),
    [sym_sbyte] = STATE(2955),
    [sym_byte] = STATE(2955),
    [sym_int16] = STATE(2955),
    [sym_uint16] = STATE(2955),
    [sym_int32] = STATE(2955),
    [sym_uint32] = STATE(2955),
    [sym_nativeint] = STATE(2955),
    [sym_unativeint] = STATE(2955),
    [sym_int64] = STATE(2955),
    [sym_uint64] = STATE(2955),
    [sym_ieee32] = STATE(2955),
    [sym_ieee64] = STATE(2955),
    [sym_bignum] = STATE(2955),
    [sym_decimal] = STATE(2955),
    [sym_float] = STATE(2652),
    [sym_block_comment] = STATE(136),
    [sym_compiler_directive_decl] = STATE(136),
    [sym_fsi_directive_decl] = STATE(136),
    [sym_preproc_line] = STATE(136),
    [sym_preproc_if_in_expression] = STATE(2884),
    [aux_sym_sequential_expression_repeat1] = STATE(2752),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(999),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_do] = ACTIONS(1003),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(267),
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_COMMA] = ACTIONS(1009),
    [anon_sym_null] = ACTIONS(1011),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(999),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1013),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1015),
    [anon_sym_LBRACE] = ACTIONS(1017),
    [anon_sym_LT_AT] = ACTIONS(1019),
    [anon_sym_LT_AT_AT] = ACTIONS(1021),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1025),
    [anon_sym_new] = ACTIONS(1001),
    [anon_sym_with] = ACTIONS(267),
    [anon_sym_return_BANG] = ACTIONS(1029),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_yield_BANG] = ACTIONS(1029),
    [anon_sym_lazy] = ACTIONS(1001),
    [anon_sym_assert] = ACTIONS(1001),
    [anon_sym_upcast] = ACTIONS(1001),
    [anon_sym_downcast] = ACTIONS(1001),
    [anon_sym_COLON_GT] = ACTIONS(1031),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1031),
    [anon_sym_for] = ACTIONS(1033),
    [anon_sym_while] = ACTIONS(1035),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1037),
    [anon_sym_try] = ACTIONS(1039),
    [anon_sym_match] = ACTIONS(1041),
    [anon_sym_match_BANG] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(1045),
    [anon_sym_LT_DASH] = ACTIONS(1047),
    [anon_sym_DOT_LBRACK] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_use] = ACTIONS(1053),
    [anon_sym_use_BANG] = ACTIONS(1055),
    [anon_sym_do_BANG] = ACTIONS(1057),
    [anon_sym_begin] = ACTIONS(1059),
    [anon_sym_LPAREN2] = ACTIONS(1061),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1063),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1067),
    [anon_sym_AT_DQUOTE] = ACTIONS(1069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1073),
    [sym_bool] = ACTIONS(1075),
    [sym_unit] = ACTIONS(1077),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1079),
    [sym_op_identifier] = ACTIONS(1081),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1083),
    [sym_xint] = ACTIONS(1085),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1087),
    [sym__newline] = ACTIONS(1089),
    [sym__dedent] = ACTIONS(265),
  },
  [137] = {
    [sym_function_or_value_defn] = STATE(1166),
    [sym__expression] = STATE(137),
    [sym_literal_expression] = STATE(2884),
    [sym_long_identifier_or_op] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_brace_expression] = STATE(2884),
    [sym_anon_record_expression] = STATE(2884),
    [sym_prefixed_expression] = STATE(2884),
    [sym_typecast_expression] = STATE(2884),
    [sym_for_expression] = STATE(2884),
    [sym_while_expression] = STATE(2884),
    [sym__if_branch] = STATE(10729),
    [sym_if_expression] = STATE(2884),
    [sym_fun_expression] = STATE(2884),
    [sym_try_expression] = STATE(2884),
    [sym_match_expression] = STATE(2884),
    [sym_function_expression] = STATE(2884),
    [sym_mutate_expression] = STATE(2884),
    [sym_index_expression] = STATE(2884),
    [sym_typed_expression] = STATE(2884),
    [sym_declaration_expression] = STATE(2884),
    [sym_do_expression] = STATE(2884),
    [sym_list_expression] = STATE(2884),
    [sym_array_expression] = STATE(2884),
    [sym_begin_end_expression] = STATE(2884),
    [sym_paren_expression] = STATE(2884),
    [sym__high_prec_app] = STATE(2872),
    [sym__low_prec_app] = STATE(2872),
    [sym_application_expression] = STATE(2884),
    [sym_dot_expression] = STATE(2884),
    [sym_infix_expression] = STATE(2884),
    [sym_ce_expression] = STATE(2884),
    [sym_sequential_expression] = STATE(2884),
    [sym_char] = STATE(2955),
    [sym_format_string] = STATE(2951),
    [sym__string_literal] = STATE(2951),
    [sym_string] = STATE(2955),
    [sym_verbatim_string] = STATE(2955),
    [sym_bytearray] = STATE(2955),
    [sym_verbatim_bytearray] = STATE(2955),
    [sym_format_triple_quoted_string] = STATE(2949),
    [sym_triple_quoted_string] = STATE(2955),
    [sym_const] = STATE(2884),
    [sym_long_identifier] = STATE(2885),
    [sym_active_pattern] = STATE(2833),
    [sym__identifier_or_op] = STATE(2883),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1002),
    [sym_infix_op] = STATE(1172),
    [sym_sbyte] = STATE(2955),
    [sym_byte] = STATE(2955),
    [sym_int16] = STATE(2955),
    [sym_uint16] = STATE(2955),
    [sym_int32] = STATE(2955),
    [sym_uint32] = STATE(2955),
    [sym_nativeint] = STATE(2955),
    [sym_unativeint] = STATE(2955),
    [sym_int64] = STATE(2955),
    [sym_uint64] = STATE(2955),
    [sym_ieee32] = STATE(2955),
    [sym_ieee64] = STATE(2955),
    [sym_bignum] = STATE(2955),
    [sym_decimal] = STATE(2955),
    [sym_float] = STATE(2652),
    [sym_block_comment] = STATE(137),
    [sym_compiler_directive_decl] = STATE(137),
    [sym_fsi_directive_decl] = STATE(137),
    [sym_preproc_line] = STATE(137),
    [sym_preproc_if_in_expression] = STATE(2884),
    [aux_sym_sequential_expression_repeat1] = STATE(2752),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_EQ] = ACTIONS(223),
    [anon_sym_COLON] = ACTIONS(225),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_do] = ACTIONS(225),
    [anon_sym_let] = ACTIONS(225),
    [anon_sym_let_BANG] = ACTIONS(223),
    [anon_sym_as] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_COMMA] = ACTIONS(223),
    [anon_sym_null] = ACTIONS(225),
    [anon_sym_QMARK] = ACTIONS(225),
    [anon_sym_COLON_QMARK] = ACTIONS(225),
    [anon_sym_COLON_COLON] = ACTIONS(223),
    [anon_sym_AMP] = ACTIONS(225),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LBRACK_PIPE] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(225),
    [anon_sym_LT_AT] = ACTIONS(225),
    [anon_sym_LT_AT_AT] = ACTIONS(225),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_LBRACE_PIPE] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(225),
    [anon_sym_with] = ACTIONS(225),
    [anon_sym_return_BANG] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(225),
    [anon_sym_yield_BANG] = ACTIONS(223),
    [anon_sym_lazy] = ACTIONS(225),
    [anon_sym_assert] = ACTIONS(225),
    [anon_sym_upcast] = ACTIONS(225),
    [anon_sym_downcast] = ACTIONS(225),
    [anon_sym_COLON_GT] = ACTIONS(223),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(223),
    [anon_sym_for] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_fun] = ACTIONS(225),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_match] = ACTIONS(225),
    [anon_sym_match_BANG] = ACTIONS(223),
    [anon_sym_function] = ACTIONS(225),
    [anon_sym_LT_DASH] = ACTIONS(225),
    [anon_sym_DOT_LBRACK] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_use] = ACTIONS(225),
    [anon_sym_use_BANG] = ACTIONS(223),
    [anon_sym_do_BANG] = ACTIONS(223),
    [anon_sym_begin] = ACTIONS(225),
    [anon_sym_LPAREN2] = ACTIONS(1061),
    [anon_sym_or] = ACTIONS(225),
    [aux_sym_char_token1] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_AT_DQUOTE] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [sym_bool] = ACTIONS(225),
    [sym_unit] = ACTIONS(1077),
    [anon_sym_LPAREN_PIPE] = ACTIONS(225),
    [sym_op_identifier] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(225),
    [anon_sym_DASH] = ACTIONS(225),
    [anon_sym_PLUS_DOT] = ACTIONS(225),
    [anon_sym_DASH_DOT] = ACTIONS(225),
    [anon_sym_PERCENT] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_TILDE] = ACTIONS(223),
    [aux_sym_prefix_op_token1] = ACTIONS(225),
    [aux_sym_infix_op_token1] = ACTIONS(223),
    [aux_sym_infix_op_token2] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_BANG_EQ] = ACTIONS(225),
    [anon_sym_COLON_EQ] = ACTIONS(223),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(225),
    [sym_int] = ACTIONS(225),
    [sym_xint] = ACTIONS(223),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(223),
    [sym__newline] = ACTIONS(223),
    [sym__dedent] = ACTIONS(223),
  },
  [138] = {
    [sym_function_or_value_defn] = STATE(1166),
    [sym__expression] = STATE(137),
    [sym_literal_expression] = STATE(2884),
    [sym_long_identifier_or_op] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_brace_expression] = STATE(2884),
    [sym_anon_record_expression] = STATE(2884),
    [sym_prefixed_expression] = STATE(2884),
    [sym_typecast_expression] = STATE(2884),
    [sym_for_expression] = STATE(2884),
    [sym_while_expression] = STATE(2884),
    [sym__if_branch] = STATE(10729),
    [sym_if_expression] = STATE(2884),
    [sym_fun_expression] = STATE(2884),
    [sym_try_expression] = STATE(2884),
    [sym_match_expression] = STATE(2884),
    [sym_function_expression] = STATE(2884),
    [sym_mutate_expression] = STATE(2884),
    [sym_index_expression] = STATE(2884),
    [sym_typed_expression] = STATE(2884),
    [sym_declaration_expression] = STATE(2884),
    [sym_do_expression] = STATE(2884),
    [sym_list_expression] = STATE(2884),
    [sym_array_expression] = STATE(2884),
    [sym_begin_end_expression] = STATE(2884),
    [sym_paren_expression] = STATE(2884),
    [sym__high_prec_app] = STATE(2872),
    [sym__low_prec_app] = STATE(2872),
    [sym_application_expression] = STATE(2884),
    [sym_dot_expression] = STATE(2884),
    [sym_infix_expression] = STATE(2884),
    [sym_ce_expression] = STATE(2884),
    [sym_sequential_expression] = STATE(2884),
    [sym_char] = STATE(2955),
    [sym_format_string] = STATE(2951),
    [sym__string_literal] = STATE(2951),
    [sym_string] = STATE(2955),
    [sym_verbatim_string] = STATE(2955),
    [sym_bytearray] = STATE(2955),
    [sym_verbatim_bytearray] = STATE(2955),
    [sym_format_triple_quoted_string] = STATE(2949),
    [sym_triple_quoted_string] = STATE(2955),
    [sym_const] = STATE(2884),
    [sym_long_identifier] = STATE(2885),
    [sym_active_pattern] = STATE(2833),
    [sym__identifier_or_op] = STATE(2883),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1002),
    [sym_infix_op] = STATE(1172),
    [sym_sbyte] = STATE(2955),
    [sym_byte] = STATE(2955),
    [sym_int16] = STATE(2955),
    [sym_uint16] = STATE(2955),
    [sym_int32] = STATE(2955),
    [sym_uint32] = STATE(2955),
    [sym_nativeint] = STATE(2955),
    [sym_unativeint] = STATE(2955),
    [sym_int64] = STATE(2955),
    [sym_uint64] = STATE(2955),
    [sym_ieee32] = STATE(2955),
    [sym_ieee64] = STATE(2955),
    [sym_bignum] = STATE(2955),
    [sym_decimal] = STATE(2955),
    [sym_float] = STATE(2652),
    [sym_block_comment] = STATE(138),
    [sym_compiler_directive_decl] = STATE(138),
    [sym_fsi_directive_decl] = STATE(138),
    [sym_preproc_line] = STATE(138),
    [sym_preproc_if_in_expression] = STATE(2884),
    [aux_sym_sequential_expression_repeat1] = STATE(2752),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(999),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_do] = ACTIONS(1003),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(245),
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_COMMA] = ACTIONS(1009),
    [anon_sym_null] = ACTIONS(1011),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(999),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1013),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1015),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_LT_AT] = ACTIONS(1019),
    [anon_sym_LT_AT_AT] = ACTIONS(1021),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1025),
    [anon_sym_new] = ACTIONS(1001),
    [anon_sym_with] = ACTIONS(245),
    [anon_sym_return_BANG] = ACTIONS(1029),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_yield_BANG] = ACTIONS(1029),
    [anon_sym_lazy] = ACTIONS(1001),
    [anon_sym_assert] = ACTIONS(1001),
    [anon_sym_upcast] = ACTIONS(1001),
    [anon_sym_downcast] = ACTIONS(1001),
    [anon_sym_COLON_GT] = ACTIONS(1031),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1031),
    [anon_sym_for] = ACTIONS(1033),
    [anon_sym_while] = ACTIONS(1035),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1037),
    [anon_sym_try] = ACTIONS(1039),
    [anon_sym_match] = ACTIONS(1041),
    [anon_sym_match_BANG] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(1045),
    [anon_sym_LT_DASH] = ACTIONS(1047),
    [anon_sym_DOT_LBRACK] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_use] = ACTIONS(1053),
    [anon_sym_use_BANG] = ACTIONS(1055),
    [anon_sym_do_BANG] = ACTIONS(1057),
    [anon_sym_begin] = ACTIONS(1059),
    [anon_sym_LPAREN2] = ACTIONS(1061),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1063),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1067),
    [anon_sym_AT_DQUOTE] = ACTIONS(1069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1073),
    [sym_bool] = ACTIONS(1075),
    [sym_unit] = ACTIONS(1077),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1079),
    [sym_op_identifier] = ACTIONS(1081),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1083),
    [sym_xint] = ACTIONS(1085),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1087),
    [sym__newline] = ACTIONS(243),
    [sym__dedent] = ACTIONS(243),
  },
  [139] = {
    [sym_function_or_value_defn] = STATE(1166),
    [sym__expression] = STATE(137),
    [sym_literal_expression] = STATE(2884),
    [sym_long_identifier_or_op] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_brace_expression] = STATE(2884),
    [sym_anon_record_expression] = STATE(2884),
    [sym_prefixed_expression] = STATE(2884),
    [sym_typecast_expression] = STATE(2884),
    [sym_for_expression] = STATE(2884),
    [sym_while_expression] = STATE(2884),
    [sym__if_branch] = STATE(10729),
    [sym_if_expression] = STATE(2884),
    [sym_fun_expression] = STATE(2884),
    [sym_try_expression] = STATE(2884),
    [sym_match_expression] = STATE(2884),
    [sym_function_expression] = STATE(2884),
    [sym_mutate_expression] = STATE(2884),
    [sym_index_expression] = STATE(2884),
    [sym_typed_expression] = STATE(2884),
    [sym_declaration_expression] = STATE(2884),
    [sym_do_expression] = STATE(2884),
    [sym_list_expression] = STATE(2884),
    [sym_array_expression] = STATE(2884),
    [sym_begin_end_expression] = STATE(2884),
    [sym_paren_expression] = STATE(2884),
    [sym__high_prec_app] = STATE(2872),
    [sym__low_prec_app] = STATE(2872),
    [sym_application_expression] = STATE(2884),
    [sym_dot_expression] = STATE(2884),
    [sym_infix_expression] = STATE(2884),
    [sym_ce_expression] = STATE(2884),
    [sym_sequential_expression] = STATE(2884),
    [sym_char] = STATE(2955),
    [sym_format_string] = STATE(2951),
    [sym__string_literal] = STATE(2951),
    [sym_string] = STATE(2955),
    [sym_verbatim_string] = STATE(2955),
    [sym_bytearray] = STATE(2955),
    [sym_verbatim_bytearray] = STATE(2955),
    [sym_format_triple_quoted_string] = STATE(2949),
    [sym_triple_quoted_string] = STATE(2955),
    [sym_const] = STATE(2884),
    [sym_long_identifier] = STATE(2885),
    [sym_active_pattern] = STATE(2833),
    [sym__identifier_or_op] = STATE(2883),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1002),
    [sym_infix_op] = STATE(1172),
    [sym_sbyte] = STATE(2955),
    [sym_byte] = STATE(2955),
    [sym_int16] = STATE(2955),
    [sym_uint16] = STATE(2955),
    [sym_int32] = STATE(2955),
    [sym_uint32] = STATE(2955),
    [sym_nativeint] = STATE(2955),
    [sym_unativeint] = STATE(2955),
    [sym_int64] = STATE(2955),
    [sym_uint64] = STATE(2955),
    [sym_ieee32] = STATE(2955),
    [sym_ieee64] = STATE(2955),
    [sym_bignum] = STATE(2955),
    [sym_decimal] = STATE(2955),
    [sym_float] = STATE(2652),
    [sym_block_comment] = STATE(139),
    [sym_compiler_directive_decl] = STATE(139),
    [sym_fsi_directive_decl] = STATE(139),
    [sym_preproc_line] = STATE(139),
    [sym_preproc_if_in_expression] = STATE(2884),
    [aux_sym_sequential_expression_repeat1] = STATE(2752),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(999),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_do] = ACTIONS(1003),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(255),
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_COMMA] = ACTIONS(1009),
    [anon_sym_null] = ACTIONS(1011),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(999),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1013),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1015),
    [anon_sym_LBRACE] = ACTIONS(255),
    [anon_sym_LT_AT] = ACTIONS(1019),
    [anon_sym_LT_AT_AT] = ACTIONS(1021),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1025),
    [anon_sym_new] = ACTIONS(1001),
    [anon_sym_with] = ACTIONS(255),
    [anon_sym_return_BANG] = ACTIONS(1029),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_yield_BANG] = ACTIONS(1029),
    [anon_sym_lazy] = ACTIONS(1001),
    [anon_sym_assert] = ACTIONS(1001),
    [anon_sym_upcast] = ACTIONS(1001),
    [anon_sym_downcast] = ACTIONS(1001),
    [anon_sym_COLON_GT] = ACTIONS(1031),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1031),
    [anon_sym_for] = ACTIONS(1033),
    [anon_sym_while] = ACTIONS(1035),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1037),
    [anon_sym_try] = ACTIONS(1039),
    [anon_sym_match] = ACTIONS(1041),
    [anon_sym_match_BANG] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(1045),
    [anon_sym_LT_DASH] = ACTIONS(1047),
    [anon_sym_DOT_LBRACK] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_use] = ACTIONS(1053),
    [anon_sym_use_BANG] = ACTIONS(1055),
    [anon_sym_do_BANG] = ACTIONS(1057),
    [anon_sym_begin] = ACTIONS(1059),
    [anon_sym_LPAREN2] = ACTIONS(1061),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1063),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1067),
    [anon_sym_AT_DQUOTE] = ACTIONS(1069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1073),
    [sym_bool] = ACTIONS(1075),
    [sym_unit] = ACTIONS(1077),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1079),
    [sym_op_identifier] = ACTIONS(1081),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1083),
    [sym_xint] = ACTIONS(1085),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1087),
    [sym__newline] = ACTIONS(253),
    [sym__dedent] = ACTIONS(253),
  },
  [140] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(183),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1113),
    [sym_infix_op] = STATE(900),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(140),
    [sym_compiler_directive_decl] = STATE(140),
    [sym_fsi_directive_decl] = STATE(140),
    [sym_preproc_line] = STATE(140),
    [sym_preproc_else] = STATE(10285),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_sequential_expression_repeat1] = STATE(2799),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(289),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(309),
    [anon_sym_DOT] = ACTIONS(311),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_COLON_GT] = ACTIONS(317),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_LT_DASH] = ACTIONS(1097),
    [anon_sym_DOT_LBRACK] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [anon_sym_LPAREN2] = ACTIONS(347),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(1233),
    [anon_sym_POUNDelse] = ACTIONS(1110),
    [sym__newline] = ACTIONS(1113),
  },
  [141] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(176),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(887),
    [sym_infix_op] = STATE(803),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(141),
    [sym_compiler_directive_decl] = STATE(141),
    [sym_fsi_directive_decl] = STATE(141),
    [sym_preproc_line] = STATE(141),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2961),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1238),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(253),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(255),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(1244),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_DOT_DOT2] = ACTIONS(253),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(253),
  },
  [142] = {
    [sym_function_or_value_defn] = STATE(845),
    [sym__expression] = STATE(209),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(776),
    [sym_infix_op] = STATE(867),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(142),
    [sym_compiler_directive_decl] = STATE(142),
    [sym_fsi_directive_decl] = STATE(142),
    [sym_preproc_line] = STATE(142),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2959),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1203),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1205),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1203),
    [anon_sym_return_BANG] = ACTIONS(1207),
    [anon_sym_yield] = ACTIONS(1203),
    [anon_sym_yield_BANG] = ACTIONS(1207),
    [anon_sym_lazy] = ACTIONS(1203),
    [anon_sym_assert] = ACTIONS(1203),
    [anon_sym_upcast] = ACTIONS(1203),
    [anon_sym_downcast] = ACTIONS(1203),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(1209),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1211),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1213),
    [anon_sym_use_BANG] = ACTIONS(1215),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_DOT_DOT2] = ACTIONS(119),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1219),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(119),
    [sym__dedent] = ACTIONS(119),
  },
  [143] = {
    [sym_function_or_value_defn] = STATE(1074),
    [sym__expression] = STATE(186),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(944),
    [sym_infix_op] = STATE(1134),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(2718),
    [sym_block_comment] = STATE(143),
    [sym_compiler_directive_decl] = STATE(143),
    [sym_fsi_directive_decl] = STATE(143),
    [sym_preproc_line] = STATE(143),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_sequential_expression_repeat1] = STATE(2825),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_return] = ACTIONS(1252),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_and] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(1254),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(259),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_return_BANG] = ACTIONS(1256),
    [anon_sym_yield] = ACTIONS(1252),
    [anon_sym_yield_BANG] = ACTIONS(1256),
    [anon_sym_lazy] = ACTIONS(1252),
    [anon_sym_assert] = ACTIONS(1252),
    [anon_sym_upcast] = ACTIONS(1252),
    [anon_sym_downcast] = ACTIONS(1252),
    [anon_sym_COLON_GT] = ACTIONS(499),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_LT_DASH] = ACTIONS(1258),
    [anon_sym_DOT_LBRACK] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_use] = ACTIONS(1260),
    [anon_sym_use_BANG] = ACTIONS(1262),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [anon_sym_LPAREN2] = ACTIONS(529),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1264),
    [sym_xint] = ACTIONS(1266),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
    [sym__newline] = ACTIONS(257),
    [sym__dedent] = ACTIONS(257),
  },
  [144] = {
    [sym_function_or_value_defn] = STATE(1074),
    [sym__expression] = STATE(186),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(944),
    [sym_infix_op] = STATE(1134),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(2718),
    [sym_block_comment] = STATE(144),
    [sym_compiler_directive_decl] = STATE(144),
    [sym_fsi_directive_decl] = STATE(144),
    [sym_preproc_line] = STATE(144),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_sequential_expression_repeat1] = STATE(2825),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_return] = ACTIONS(1252),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_and] = ACTIONS(123),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(1254),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(731),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_return_BANG] = ACTIONS(1256),
    [anon_sym_yield] = ACTIONS(1252),
    [anon_sym_yield_BANG] = ACTIONS(1256),
    [anon_sym_lazy] = ACTIONS(1252),
    [anon_sym_assert] = ACTIONS(1252),
    [anon_sym_upcast] = ACTIONS(1252),
    [anon_sym_downcast] = ACTIONS(1252),
    [anon_sym_COLON_GT] = ACTIONS(499),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_LT_DASH] = ACTIONS(1258),
    [anon_sym_DOT_LBRACK] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_use] = ACTIONS(1260),
    [anon_sym_use_BANG] = ACTIONS(1262),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [anon_sym_LPAREN2] = ACTIONS(529),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1264),
    [sym_xint] = ACTIONS(1266),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
    [sym__newline] = ACTIONS(119),
    [sym__dedent] = ACTIONS(119),
  },
  [145] = {
    [sym_function_or_value_defn] = STATE(1074),
    [sym__expression] = STATE(186),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(944),
    [sym_infix_op] = STATE(1134),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(2718),
    [sym_block_comment] = STATE(145),
    [sym_compiler_directive_decl] = STATE(145),
    [sym_fsi_directive_decl] = STATE(145),
    [sym_preproc_line] = STATE(145),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_sequential_expression_repeat1] = STATE(2825),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_return] = ACTIONS(1252),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_and] = ACTIONS(255),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(1254),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(255),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_return_BANG] = ACTIONS(1256),
    [anon_sym_yield] = ACTIONS(1252),
    [anon_sym_yield_BANG] = ACTIONS(1256),
    [anon_sym_lazy] = ACTIONS(1252),
    [anon_sym_assert] = ACTIONS(1252),
    [anon_sym_upcast] = ACTIONS(1252),
    [anon_sym_downcast] = ACTIONS(1252),
    [anon_sym_COLON_GT] = ACTIONS(499),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_LT_DASH] = ACTIONS(1258),
    [anon_sym_DOT_LBRACK] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_use] = ACTIONS(1260),
    [anon_sym_use_BANG] = ACTIONS(1262),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [anon_sym_LPAREN2] = ACTIONS(529),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1264),
    [sym_xint] = ACTIONS(1266),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
    [sym__newline] = ACTIONS(253),
    [sym__dedent] = ACTIONS(253),
  },
  [146] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(146),
    [sym_compiler_directive_decl] = STATE(146),
    [sym_fsi_directive_decl] = STATE(146),
    [sym_preproc_line] = STATE(146),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(259),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_with] = ACTIONS(259),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(257),
    [sym__dedent] = ACTIONS(257),
  },
  [147] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(176),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(887),
    [sym_infix_op] = STATE(803),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(147),
    [sym_compiler_directive_decl] = STATE(147),
    [sym_fsi_directive_decl] = STATE(147),
    [sym_preproc_line] = STATE(147),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2961),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1238),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(1282),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(1244),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_DOT_DOT2] = ACTIONS(1284),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(1286),
  },
  [148] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(148),
    [sym_compiler_directive_decl] = STATE(148),
    [sym_fsi_directive_decl] = STATE(148),
    [sym_preproc_line] = STATE(148),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_with] = ACTIONS(263),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(261),
  },
  [149] = {
    [sym_function_or_value_defn] = STATE(845),
    [sym__expression] = STATE(209),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(776),
    [sym_infix_op] = STATE(867),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(149),
    [sym_compiler_directive_decl] = STATE(149),
    [sym_fsi_directive_decl] = STATE(149),
    [sym_preproc_line] = STATE(149),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2959),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1203),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1205),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1203),
    [anon_sym_return_BANG] = ACTIONS(1207),
    [anon_sym_yield] = ACTIONS(1203),
    [anon_sym_yield_BANG] = ACTIONS(1207),
    [anon_sym_lazy] = ACTIONS(1203),
    [anon_sym_assert] = ACTIONS(1203),
    [anon_sym_upcast] = ACTIONS(1203),
    [anon_sym_downcast] = ACTIONS(1203),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(1209),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1211),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1213),
    [anon_sym_use_BANG] = ACTIONS(1215),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_DOT_DOT2] = ACTIONS(231),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1219),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1290),
    [sym__dedent] = ACTIONS(231),
  },
  [150] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(150),
    [sym_compiler_directive_decl] = STATE(150),
    [sym_fsi_directive_decl] = STATE(150),
    [sym_preproc_line] = STATE(150),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_with] = ACTIONS(245),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(243),
    [sym__dedent] = ACTIONS(243),
  },
  [151] = {
    [sym_function_or_value_defn] = STATE(845),
    [sym__expression] = STATE(209),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(776),
    [sym_infix_op] = STATE(867),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(151),
    [sym_compiler_directive_decl] = STATE(151),
    [sym_fsi_directive_decl] = STATE(151),
    [sym_preproc_line] = STATE(151),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2959),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1203),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1205),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1203),
    [anon_sym_return_BANG] = ACTIONS(1207),
    [anon_sym_yield] = ACTIONS(1203),
    [anon_sym_yield_BANG] = ACTIONS(1207),
    [anon_sym_lazy] = ACTIONS(1203),
    [anon_sym_assert] = ACTIONS(1203),
    [anon_sym_upcast] = ACTIONS(1203),
    [anon_sym_downcast] = ACTIONS(1203),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(1209),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1211),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1213),
    [anon_sym_use_BANG] = ACTIONS(1215),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_DOT_DOT2] = ACTIONS(243),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1219),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(243),
    [sym__dedent] = ACTIONS(243),
  },
  [152] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(176),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(887),
    [sym_infix_op] = STATE(803),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(152),
    [sym_compiler_directive_decl] = STATE(152),
    [sym_fsi_directive_decl] = STATE(152),
    [sym_preproc_line] = STATE(152),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2961),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1238),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(1292),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(1244),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_DOT_DOT2] = ACTIONS(1284),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(1286),
  },
  [153] = {
    [sym_function_or_value_defn] = STATE(845),
    [sym__expression] = STATE(209),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(776),
    [sym_infix_op] = STATE(867),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(153),
    [sym_compiler_directive_decl] = STATE(153),
    [sym_fsi_directive_decl] = STATE(153),
    [sym_preproc_line] = STATE(153),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2959),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1203),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1205),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(255),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1203),
    [anon_sym_return_BANG] = ACTIONS(1207),
    [anon_sym_yield] = ACTIONS(1203),
    [anon_sym_yield_BANG] = ACTIONS(1207),
    [anon_sym_lazy] = ACTIONS(1203),
    [anon_sym_assert] = ACTIONS(1203),
    [anon_sym_upcast] = ACTIONS(1203),
    [anon_sym_downcast] = ACTIONS(1203),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(1209),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1211),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1213),
    [anon_sym_use_BANG] = ACTIONS(1215),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_DOT_DOT2] = ACTIONS(253),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1219),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(253),
    [sym__dedent] = ACTIONS(253),
  },
  [154] = {
    [sym_function_or_value_defn] = STATE(1074),
    [sym__expression] = STATE(186),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(944),
    [sym_infix_op] = STATE(1134),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(2718),
    [sym_block_comment] = STATE(154),
    [sym_compiler_directive_decl] = STATE(154),
    [sym_fsi_directive_decl] = STATE(154),
    [sym_preproc_line] = STATE(154),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_sequential_expression_repeat1] = STATE(2825),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_return] = ACTIONS(1252),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_and] = ACTIONS(245),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(1254),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_return_BANG] = ACTIONS(1256),
    [anon_sym_yield] = ACTIONS(1252),
    [anon_sym_yield_BANG] = ACTIONS(1256),
    [anon_sym_lazy] = ACTIONS(1252),
    [anon_sym_assert] = ACTIONS(1252),
    [anon_sym_upcast] = ACTIONS(1252),
    [anon_sym_downcast] = ACTIONS(1252),
    [anon_sym_COLON_GT] = ACTIONS(499),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_LT_DASH] = ACTIONS(1258),
    [anon_sym_DOT_LBRACK] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_use] = ACTIONS(1260),
    [anon_sym_use_BANG] = ACTIONS(1262),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [anon_sym_LPAREN2] = ACTIONS(529),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1264),
    [sym_xint] = ACTIONS(1266),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
    [sym__newline] = ACTIONS(243),
    [sym__dedent] = ACTIONS(243),
  },
  [155] = {
    [sym_function_or_value_defn] = STATE(845),
    [sym__expression] = STATE(209),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(776),
    [sym_infix_op] = STATE(867),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(155),
    [sym_compiler_directive_decl] = STATE(155),
    [sym_fsi_directive_decl] = STATE(155),
    [sym_preproc_line] = STATE(155),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2959),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1203),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1205),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(259),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1203),
    [anon_sym_return_BANG] = ACTIONS(1207),
    [anon_sym_yield] = ACTIONS(1203),
    [anon_sym_yield_BANG] = ACTIONS(1207),
    [anon_sym_lazy] = ACTIONS(1203),
    [anon_sym_assert] = ACTIONS(1203),
    [anon_sym_upcast] = ACTIONS(1203),
    [anon_sym_downcast] = ACTIONS(1203),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(1209),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1211),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1213),
    [anon_sym_use_BANG] = ACTIONS(1215),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_DOT_DOT2] = ACTIONS(257),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1219),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(257),
    [sym__dedent] = ACTIONS(257),
  },
  [156] = {
    [sym_function_or_value_defn] = STATE(1180),
    [sym__expression] = STATE(239),
    [sym_literal_expression] = STATE(3145),
    [sym_long_identifier_or_op] = STATE(3145),
    [sym_tuple_expression] = STATE(3145),
    [sym_brace_expression] = STATE(3145),
    [sym_anon_record_expression] = STATE(3145),
    [sym_prefixed_expression] = STATE(3145),
    [sym_typecast_expression] = STATE(3145),
    [sym_for_expression] = STATE(3145),
    [sym_while_expression] = STATE(3145),
    [sym__if_branch] = STATE(10360),
    [sym_if_expression] = STATE(3145),
    [sym_fun_expression] = STATE(3145),
    [sym_try_expression] = STATE(3145),
    [sym_match_expression] = STATE(3145),
    [sym_function_expression] = STATE(3145),
    [sym_mutate_expression] = STATE(3145),
    [sym_index_expression] = STATE(3145),
    [sym_typed_expression] = STATE(3145),
    [sym_declaration_expression] = STATE(3145),
    [sym_do_expression] = STATE(3145),
    [sym_list_expression] = STATE(3145),
    [sym_array_expression] = STATE(3145),
    [sym_begin_end_expression] = STATE(3145),
    [sym_paren_expression] = STATE(3145),
    [sym__high_prec_app] = STATE(3141),
    [sym__low_prec_app] = STATE(3141),
    [sym_application_expression] = STATE(3145),
    [sym_dot_expression] = STATE(3145),
    [sym_infix_expression] = STATE(3145),
    [sym_ce_expression] = STATE(3145),
    [sym_sequential_expression] = STATE(3145),
    [sym_char] = STATE(3108),
    [sym_format_string] = STATE(3193),
    [sym__string_literal] = STATE(3193),
    [sym_string] = STATE(3108),
    [sym_verbatim_string] = STATE(3108),
    [sym_bytearray] = STATE(3108),
    [sym_verbatim_bytearray] = STATE(3108),
    [sym_format_triple_quoted_string] = STATE(3192),
    [sym_triple_quoted_string] = STATE(3108),
    [sym_const] = STATE(3145),
    [sym_long_identifier] = STATE(3102),
    [sym_active_pattern] = STATE(3172),
    [sym__identifier_or_op] = STATE(3103),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1149),
    [sym_infix_op] = STATE(912),
    [sym_sbyte] = STATE(3108),
    [sym_byte] = STATE(3108),
    [sym_int16] = STATE(3108),
    [sym_uint16] = STATE(3108),
    [sym_int32] = STATE(3108),
    [sym_uint32] = STATE(3108),
    [sym_nativeint] = STATE(3108),
    [sym_unativeint] = STATE(3108),
    [sym_int64] = STATE(3108),
    [sym_uint64] = STATE(3108),
    [sym_ieee32] = STATE(3108),
    [sym_ieee64] = STATE(3108),
    [sym_bignum] = STATE(3108),
    [sym_decimal] = STATE(3108),
    [sym_float] = STATE(2770),
    [sym_block_comment] = STATE(156),
    [sym_compiler_directive_decl] = STATE(156),
    [sym_fsi_directive_decl] = STATE(156),
    [sym_preproc_line] = STATE(156),
    [sym_preproc_if_in_expression] = STATE(3145),
    [aux_sym_sequential_expression_repeat1] = STATE(2846),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1117),
    [anon_sym_return] = ACTIONS(1119),
    [anon_sym_do] = ACTIONS(1121),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(267),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1125),
    [anon_sym_null] = ACTIONS(1127),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1117),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1131),
    [anon_sym_LBRACE] = ACTIONS(1133),
    [anon_sym_LT_AT] = ACTIONS(1135),
    [anon_sym_LT_AT_AT] = ACTIONS(1137),
    [anon_sym_DOT] = ACTIONS(1139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1141),
    [anon_sym_new] = ACTIONS(1119),
    [anon_sym_with] = ACTIONS(267),
    [anon_sym_return_BANG] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1119),
    [anon_sym_yield_BANG] = ACTIONS(1143),
    [anon_sym_lazy] = ACTIONS(1119),
    [anon_sym_assert] = ACTIONS(1119),
    [anon_sym_upcast] = ACTIONS(1119),
    [anon_sym_downcast] = ACTIONS(1119),
    [anon_sym_COLON_GT] = ACTIONS(1145),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1145),
    [anon_sym_for] = ACTIONS(1147),
    [anon_sym_while] = ACTIONS(1149),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1151),
    [anon_sym_try] = ACTIONS(1153),
    [anon_sym_match] = ACTIONS(1155),
    [anon_sym_match_BANG] = ACTIONS(1157),
    [anon_sym_function] = ACTIONS(1159),
    [anon_sym_LT_DASH] = ACTIONS(1161),
    [anon_sym_DOT_LBRACK] = ACTIONS(1163),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_use] = ACTIONS(1167),
    [anon_sym_use_BANG] = ACTIONS(1169),
    [anon_sym_do_BANG] = ACTIONS(1171),
    [anon_sym_begin] = ACTIONS(1173),
    [anon_sym_LPAREN2] = ACTIONS(1175),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1177),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(1181),
    [anon_sym_AT_DQUOTE] = ACTIONS(1183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1185),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1187),
    [sym_bool] = ACTIONS(1189),
    [sym_unit] = ACTIONS(1191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1193),
    [sym_op_identifier] = ACTIONS(1195),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1197),
    [sym_xint] = ACTIONS(1199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1201),
    [sym__newline] = ACTIONS(1294),
  },
  [157] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(176),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(887),
    [sym_infix_op] = STATE(803),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(157),
    [sym_compiler_directive_decl] = STATE(157),
    [sym_fsi_directive_decl] = STATE(157),
    [sym_preproc_line] = STATE(157),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2961),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1238),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(1296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(1244),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_DOT_DOT2] = ACTIONS(1284),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(1286),
  },
  [158] = {
    [sym_function_or_value_defn] = STATE(972),
    [sym__expression] = STATE(227),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(978),
    [sym_infix_op] = STATE(897),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(158),
    [sym_compiler_directive_decl] = STATE(158),
    [sym_fsi_directive_decl] = STATE(158),
    [sym_preproc_line] = STATE(158),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(2950),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1300),
    [anon_sym_return] = ACTIONS(1302),
    [anon_sym_do] = ACTIONS(1304),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1308),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1300),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1302),
    [anon_sym_return_BANG] = ACTIONS(1326),
    [anon_sym_yield] = ACTIONS(1302),
    [anon_sym_yield_BANG] = ACTIONS(1326),
    [anon_sym_lazy] = ACTIONS(1302),
    [anon_sym_assert] = ACTIONS(1302),
    [anon_sym_upcast] = ACTIONS(1302),
    [anon_sym_downcast] = ACTIONS(1302),
    [anon_sym_COLON_GT] = ACTIONS(1328),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1328),
    [anon_sym_for] = ACTIONS(1330),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(1336),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1346),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1352),
    [anon_sym_use_BANG] = ACTIONS(1354),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_DOT_DOT] = ACTIONS(1358),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1384),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(1390),
  },
  [159] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(183),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1113),
    [sym_infix_op] = STATE(900),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(159),
    [sym_compiler_directive_decl] = STATE(159),
    [sym_fsi_directive_decl] = STATE(159),
    [sym_preproc_line] = STATE(159),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_sequential_expression_repeat1] = STATE(2799),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(289),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(309),
    [anon_sym_DOT] = ACTIONS(311),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_COLON_GT] = ACTIONS(317),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_LT_DASH] = ACTIONS(1097),
    [anon_sym_DOT_LBRACK] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [anon_sym_LPAREN2] = ACTIONS(347),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(1392),
    [anon_sym_POUNDelse] = ACTIONS(1392),
    [sym__newline] = ACTIONS(1113),
  },
  [160] = {
    [sym_function_or_value_defn] = STATE(1074),
    [sym__expression] = STATE(186),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(944),
    [sym_infix_op] = STATE(1134),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(2718),
    [sym_block_comment] = STATE(160),
    [sym_compiler_directive_decl] = STATE(160),
    [sym_fsi_directive_decl] = STATE(160),
    [sym_preproc_line] = STATE(160),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_sequential_expression_repeat1] = STATE(2825),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_return] = ACTIONS(1252),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_and] = ACTIONS(233),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(1254),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(731),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_return_BANG] = ACTIONS(1256),
    [anon_sym_yield] = ACTIONS(1252),
    [anon_sym_yield_BANG] = ACTIONS(1256),
    [anon_sym_lazy] = ACTIONS(1252),
    [anon_sym_assert] = ACTIONS(1252),
    [anon_sym_upcast] = ACTIONS(1252),
    [anon_sym_downcast] = ACTIONS(1252),
    [anon_sym_COLON_GT] = ACTIONS(499),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_LT_DASH] = ACTIONS(1258),
    [anon_sym_DOT_LBRACK] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_use] = ACTIONS(1260),
    [anon_sym_use_BANG] = ACTIONS(1262),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [anon_sym_LPAREN2] = ACTIONS(529),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1264),
    [sym_xint] = ACTIONS(1266),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
    [sym__newline] = ACTIONS(1394),
    [sym__dedent] = ACTIONS(231),
  },
  [161] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(176),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(887),
    [sym_infix_op] = STATE(803),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(161),
    [sym_compiler_directive_decl] = STATE(161),
    [sym_fsi_directive_decl] = STATE(161),
    [sym_preproc_line] = STATE(161),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2961),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1238),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(1396),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(1244),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_DOT_DOT2] = ACTIONS(1284),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(1286),
  },
  [162] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(162),
    [sym_compiler_directive_decl] = STATE(162),
    [sym_fsi_directive_decl] = STATE(162),
    [sym_preproc_line] = STATE(162),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_with] = ACTIONS(233),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(231),
  },
  [163] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(176),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(887),
    [sym_infix_op] = STATE(803),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(163),
    [sym_compiler_directive_decl] = STATE(163),
    [sym_fsi_directive_decl] = STATE(163),
    [sym_preproc_line] = STATE(163),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2961),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1238),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(1398),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(1244),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_DOT_DOT2] = ACTIONS(1284),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(1286),
  },
  [164] = {
    [sym_function_or_value_defn] = STATE(1074),
    [sym__expression] = STATE(186),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(944),
    [sym_infix_op] = STATE(1134),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(2718),
    [sym_block_comment] = STATE(164),
    [sym_compiler_directive_decl] = STATE(164),
    [sym_fsi_directive_decl] = STATE(164),
    [sym_preproc_line] = STATE(164),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_sequential_expression_repeat1] = STATE(2825),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_return] = ACTIONS(1252),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_and] = ACTIONS(1400),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(1254),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(731),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_return_BANG] = ACTIONS(1256),
    [anon_sym_yield] = ACTIONS(1252),
    [anon_sym_yield_BANG] = ACTIONS(1256),
    [anon_sym_lazy] = ACTIONS(1252),
    [anon_sym_assert] = ACTIONS(1252),
    [anon_sym_upcast] = ACTIONS(1252),
    [anon_sym_downcast] = ACTIONS(1252),
    [anon_sym_COLON_GT] = ACTIONS(499),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_LT_DASH] = ACTIONS(1258),
    [anon_sym_DOT_LBRACK] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_use] = ACTIONS(1260),
    [anon_sym_use_BANG] = ACTIONS(1262),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [anon_sym_LPAREN2] = ACTIONS(529),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1264),
    [sym_xint] = ACTIONS(1266),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
    [sym__newline] = ACTIONS(1394),
    [sym__dedent] = ACTIONS(1402),
  },
  [165] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(165),
    [sym_compiler_directive_decl] = STATE(165),
    [sym_fsi_directive_decl] = STATE(165),
    [sym_preproc_line] = STATE(165),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_to] = ACTIONS(1404),
    [anon_sym_downto] = ACTIONS(1404),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [166] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(176),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(887),
    [sym_infix_op] = STATE(803),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(166),
    [sym_compiler_directive_decl] = STATE(166),
    [sym_fsi_directive_decl] = STATE(166),
    [sym_preproc_line] = STATE(166),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2961),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1238),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(1406),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(1244),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_DOT_DOT2] = ACTIONS(1284),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(1286),
  },
  [167] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(176),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(887),
    [sym_infix_op] = STATE(803),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(167),
    [sym_compiler_directive_decl] = STATE(167),
    [sym_fsi_directive_decl] = STATE(167),
    [sym_preproc_line] = STATE(167),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2961),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1238),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(1408),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(1244),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_DOT_DOT2] = ACTIONS(1284),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(1286),
  },
  [168] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(176),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(887),
    [sym_infix_op] = STATE(803),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(168),
    [sym_compiler_directive_decl] = STATE(168),
    [sym_fsi_directive_decl] = STATE(168),
    [sym_preproc_line] = STATE(168),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2961),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1238),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(119),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(1244),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_DOT_DOT2] = ACTIONS(119),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(119),
  },
  [169] = {
    [sym_function_or_value_defn] = STATE(845),
    [sym__expression] = STATE(209),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(776),
    [sym_infix_op] = STATE(867),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(169),
    [sym_compiler_directive_decl] = STATE(169),
    [sym_fsi_directive_decl] = STATE(169),
    [sym_preproc_line] = STATE(169),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2959),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1203),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1205),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1203),
    [anon_sym_return_BANG] = ACTIONS(1207),
    [anon_sym_yield] = ACTIONS(1203),
    [anon_sym_yield_BANG] = ACTIONS(1207),
    [anon_sym_lazy] = ACTIONS(1203),
    [anon_sym_assert] = ACTIONS(1203),
    [anon_sym_upcast] = ACTIONS(1203),
    [anon_sym_downcast] = ACTIONS(1203),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(1209),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1211),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1213),
    [anon_sym_use_BANG] = ACTIONS(1215),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_DOT_DOT2] = ACTIONS(261),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1219),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1290),
    [sym__dedent] = ACTIONS(261),
  },
  [170] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(176),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(887),
    [sym_infix_op] = STATE(803),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(170),
    [sym_compiler_directive_decl] = STATE(170),
    [sym_fsi_directive_decl] = STATE(170),
    [sym_preproc_line] = STATE(170),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2961),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1238),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(265),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(1244),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_DOT_DOT2] = ACTIONS(265),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(1286),
  },
  [171] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(183),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1113),
    [sym_infix_op] = STATE(900),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(171),
    [sym_compiler_directive_decl] = STATE(171),
    [sym_fsi_directive_decl] = STATE(171),
    [sym_preproc_line] = STATE(171),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_sequential_expression_repeat1] = STATE(2799),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(289),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(309),
    [anon_sym_DOT] = ACTIONS(311),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_COLON_GT] = ACTIONS(317),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_LT_DASH] = ACTIONS(1097),
    [anon_sym_DOT_LBRACK] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [anon_sym_LPAREN2] = ACTIONS(347),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(231),
    [anon_sym_POUNDelse] = ACTIONS(231),
    [sym__newline] = ACTIONS(1113),
  },
  [172] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(172),
    [sym_compiler_directive_decl] = STATE(172),
    [sym_fsi_directive_decl] = STATE(172),
    [sym_preproc_line] = STATE(172),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_EQ] = ACTIONS(223),
    [anon_sym_COLON] = ACTIONS(225),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_do] = ACTIONS(225),
    [anon_sym_let] = ACTIONS(225),
    [anon_sym_let_BANG] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_COMMA] = ACTIONS(223),
    [anon_sym_null] = ACTIONS(225),
    [anon_sym_QMARK] = ACTIONS(225),
    [anon_sym_COLON_QMARK] = ACTIONS(225),
    [anon_sym_COLON_COLON] = ACTIONS(223),
    [anon_sym_AMP] = ACTIONS(225),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LBRACK_PIPE] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(225),
    [anon_sym_LT_AT] = ACTIONS(225),
    [anon_sym_LT_AT_AT] = ACTIONS(225),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(225),
    [anon_sym_with] = ACTIONS(225),
    [anon_sym_return_BANG] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(225),
    [anon_sym_yield_BANG] = ACTIONS(223),
    [anon_sym_lazy] = ACTIONS(225),
    [anon_sym_assert] = ACTIONS(225),
    [anon_sym_upcast] = ACTIONS(225),
    [anon_sym_downcast] = ACTIONS(225),
    [anon_sym_COLON_GT] = ACTIONS(223),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(223),
    [anon_sym_for] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_fun] = ACTIONS(225),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_match] = ACTIONS(225),
    [anon_sym_match_BANG] = ACTIONS(223),
    [anon_sym_function] = ACTIONS(225),
    [anon_sym_LT_DASH] = ACTIONS(225),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(225),
    [anon_sym_use_BANG] = ACTIONS(223),
    [anon_sym_do_BANG] = ACTIONS(223),
    [anon_sym_begin] = ACTIONS(225),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(225),
    [aux_sym_char_token1] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_AT_DQUOTE] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [sym_bool] = ACTIONS(225),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(225),
    [sym_op_identifier] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(225),
    [anon_sym_DASH] = ACTIONS(225),
    [anon_sym_PLUS_DOT] = ACTIONS(225),
    [anon_sym_DASH_DOT] = ACTIONS(225),
    [anon_sym_PERCENT] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_TILDE] = ACTIONS(223),
    [aux_sym_prefix_op_token1] = ACTIONS(225),
    [aux_sym_infix_op_token1] = ACTIONS(223),
    [aux_sym_infix_op_token2] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_BANG_EQ] = ACTIONS(225),
    [anon_sym_COLON_EQ] = ACTIONS(223),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(225),
    [sym_int] = ACTIONS(225),
    [sym_xint] = ACTIONS(223),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(223),
    [sym__newline] = ACTIONS(223),
    [sym__dedent] = ACTIONS(223),
  },
  [173] = {
    [sym_function_or_value_defn] = STATE(1074),
    [sym__expression] = STATE(186),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(944),
    [sym_infix_op] = STATE(1134),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(2718),
    [sym_block_comment] = STATE(173),
    [sym_compiler_directive_decl] = STATE(173),
    [sym_fsi_directive_decl] = STATE(173),
    [sym_preproc_line] = STATE(173),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_sequential_expression_repeat1] = STATE(2825),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_return] = ACTIONS(1252),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_and] = ACTIONS(1410),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(1254),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(731),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_return_BANG] = ACTIONS(1256),
    [anon_sym_yield] = ACTIONS(1252),
    [anon_sym_yield_BANG] = ACTIONS(1256),
    [anon_sym_lazy] = ACTIONS(1252),
    [anon_sym_assert] = ACTIONS(1252),
    [anon_sym_upcast] = ACTIONS(1252),
    [anon_sym_downcast] = ACTIONS(1252),
    [anon_sym_COLON_GT] = ACTIONS(499),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_LT_DASH] = ACTIONS(1258),
    [anon_sym_DOT_LBRACK] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_use] = ACTIONS(1260),
    [anon_sym_use_BANG] = ACTIONS(1262),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [anon_sym_LPAREN2] = ACTIONS(529),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1264),
    [sym_xint] = ACTIONS(1266),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
    [sym__newline] = ACTIONS(1394),
    [sym__dedent] = ACTIONS(1412),
  },
  [174] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(176),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(887),
    [sym_infix_op] = STATE(803),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(174),
    [sym_compiler_directive_decl] = STATE(174),
    [sym_fsi_directive_decl] = STATE(174),
    [sym_preproc_line] = STATE(174),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2961),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1238),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(1414),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(1244),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_DOT_DOT2] = ACTIONS(1284),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(1286),
  },
  [175] = {
    [sym_function_or_value_defn] = STATE(845),
    [sym__expression] = STATE(209),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(776),
    [sym_infix_op] = STATE(867),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(175),
    [sym_compiler_directive_decl] = STATE(175),
    [sym_fsi_directive_decl] = STATE(175),
    [sym_preproc_line] = STATE(175),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2959),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1203),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1205),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1203),
    [anon_sym_return_BANG] = ACTIONS(1207),
    [anon_sym_yield] = ACTIONS(1203),
    [anon_sym_yield_BANG] = ACTIONS(1207),
    [anon_sym_lazy] = ACTIONS(1203),
    [anon_sym_assert] = ACTIONS(1203),
    [anon_sym_upcast] = ACTIONS(1203),
    [anon_sym_downcast] = ACTIONS(1203),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(1209),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1211),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1213),
    [anon_sym_use_BANG] = ACTIONS(1215),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_DOT_DOT2] = ACTIONS(1217),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1219),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1290),
    [sym__dedent] = ACTIONS(1416),
  },
  [176] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(176),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(887),
    [sym_infix_op] = STATE(803),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(176),
    [sym_compiler_directive_decl] = STATE(176),
    [sym_fsi_directive_decl] = STATE(176),
    [sym_preproc_line] = STATE(176),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2961),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_EQ] = ACTIONS(223),
    [anon_sym_COLON] = ACTIONS(225),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_do] = ACTIONS(225),
    [anon_sym_let] = ACTIONS(225),
    [anon_sym_let_BANG] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_COMMA] = ACTIONS(223),
    [anon_sym_null] = ACTIONS(225),
    [anon_sym_QMARK] = ACTIONS(225),
    [anon_sym_COLON_QMARK] = ACTIONS(225),
    [anon_sym_COLON_COLON] = ACTIONS(223),
    [anon_sym_AMP] = ACTIONS(225),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_RBRACK] = ACTIONS(223),
    [anon_sym_LBRACK_PIPE] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(225),
    [anon_sym_LT_AT] = ACTIONS(225),
    [anon_sym_LT_AT_AT] = ACTIONS(225),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(225),
    [anon_sym_return_BANG] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(225),
    [anon_sym_yield_BANG] = ACTIONS(223),
    [anon_sym_lazy] = ACTIONS(225),
    [anon_sym_assert] = ACTIONS(225),
    [anon_sym_upcast] = ACTIONS(225),
    [anon_sym_downcast] = ACTIONS(225),
    [anon_sym_COLON_GT] = ACTIONS(223),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(223),
    [anon_sym_for] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_fun] = ACTIONS(225),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_match] = ACTIONS(225),
    [anon_sym_match_BANG] = ACTIONS(223),
    [anon_sym_function] = ACTIONS(225),
    [anon_sym_LT_DASH] = ACTIONS(225),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(225),
    [anon_sym_use_BANG] = ACTIONS(223),
    [anon_sym_do_BANG] = ACTIONS(223),
    [anon_sym_begin] = ACTIONS(225),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_DOT_DOT2] = ACTIONS(223),
    [anon_sym_or] = ACTIONS(225),
    [aux_sym_char_token1] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_AT_DQUOTE] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [sym_bool] = ACTIONS(225),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(225),
    [sym_op_identifier] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(225),
    [anon_sym_DASH] = ACTIONS(225),
    [anon_sym_PLUS_DOT] = ACTIONS(225),
    [anon_sym_DASH_DOT] = ACTIONS(225),
    [anon_sym_PERCENT] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_TILDE] = ACTIONS(223),
    [aux_sym_prefix_op_token1] = ACTIONS(225),
    [aux_sym_infix_op_token1] = ACTIONS(223),
    [aux_sym_infix_op_token2] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_BANG_EQ] = ACTIONS(225),
    [anon_sym_COLON_EQ] = ACTIONS(223),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(225),
    [sym_int] = ACTIONS(225),
    [sym_xint] = ACTIONS(223),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(223),
    [sym__newline] = ACTIONS(223),
  },
  [177] = {
    [sym_function_or_value_defn] = STATE(845),
    [sym__expression] = STATE(209),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(776),
    [sym_infix_op] = STATE(867),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(177),
    [sym_compiler_directive_decl] = STATE(177),
    [sym_fsi_directive_decl] = STATE(177),
    [sym_preproc_line] = STATE(177),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2959),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1203),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1205),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1203),
    [anon_sym_return_BANG] = ACTIONS(1207),
    [anon_sym_yield] = ACTIONS(1203),
    [anon_sym_yield_BANG] = ACTIONS(1207),
    [anon_sym_lazy] = ACTIONS(1203),
    [anon_sym_assert] = ACTIONS(1203),
    [anon_sym_upcast] = ACTIONS(1203),
    [anon_sym_downcast] = ACTIONS(1203),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(1209),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1211),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1213),
    [anon_sym_use_BANG] = ACTIONS(1215),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_DOT_DOT2] = ACTIONS(265),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1219),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1290),
    [sym__dedent] = ACTIONS(265),
  },
  [178] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(176),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(887),
    [sym_infix_op] = STATE(803),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(178),
    [sym_compiler_directive_decl] = STATE(178),
    [sym_fsi_directive_decl] = STATE(178),
    [sym_preproc_line] = STATE(178),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2961),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1238),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(1418),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(1244),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_DOT_DOT2] = ACTIONS(1284),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(1286),
  },
  [179] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(176),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(887),
    [sym_infix_op] = STATE(803),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(179),
    [sym_compiler_directive_decl] = STATE(179),
    [sym_fsi_directive_decl] = STATE(179),
    [sym_preproc_line] = STATE(179),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2961),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1238),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(261),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(1244),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_DOT_DOT2] = ACTIONS(261),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(1286),
  },
  [180] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(176),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(887),
    [sym_infix_op] = STATE(803),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(180),
    [sym_compiler_directive_decl] = STATE(180),
    [sym_fsi_directive_decl] = STATE(180),
    [sym_preproc_line] = STATE(180),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2961),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1238),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(257),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(259),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(1244),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_DOT_DOT2] = ACTIONS(257),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(257),
  },
  [181] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(181),
    [sym_compiler_directive_decl] = STATE(181),
    [sym_fsi_directive_decl] = STATE(181),
    [sym_preproc_line] = STATE(181),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym__list_elements_repeat1] = STATE(9077),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1420),
    [sym__dedent] = ACTIONS(1422),
  },
  [182] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(182),
    [sym_compiler_directive_decl] = STATE(182),
    [sym_fsi_directive_decl] = STATE(182),
    [sym_preproc_line] = STATE(182),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_to] = ACTIONS(1424),
    [anon_sym_downto] = ACTIONS(1424),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [183] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(183),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1113),
    [sym_infix_op] = STATE(900),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(183),
    [sym_compiler_directive_decl] = STATE(183),
    [sym_fsi_directive_decl] = STATE(183),
    [sym_preproc_line] = STATE(183),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_sequential_expression_repeat1] = STATE(2799),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_EQ] = ACTIONS(223),
    [anon_sym_COLON] = ACTIONS(225),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_do] = ACTIONS(225),
    [anon_sym_let] = ACTIONS(225),
    [anon_sym_let_BANG] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_COMMA] = ACTIONS(223),
    [anon_sym_null] = ACTIONS(225),
    [anon_sym_QMARK] = ACTIONS(225),
    [anon_sym_COLON_QMARK] = ACTIONS(225),
    [anon_sym_COLON_COLON] = ACTIONS(223),
    [anon_sym_AMP] = ACTIONS(225),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LBRACK_PIPE] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(225),
    [anon_sym_LT_AT] = ACTIONS(225),
    [anon_sym_LT_AT_AT] = ACTIONS(225),
    [anon_sym_DOT] = ACTIONS(311),
    [anon_sym_LBRACE_PIPE] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(225),
    [anon_sym_return_BANG] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(225),
    [anon_sym_yield_BANG] = ACTIONS(223),
    [anon_sym_lazy] = ACTIONS(225),
    [anon_sym_assert] = ACTIONS(225),
    [anon_sym_upcast] = ACTIONS(225),
    [anon_sym_downcast] = ACTIONS(225),
    [anon_sym_COLON_GT] = ACTIONS(223),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(223),
    [anon_sym_for] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_fun] = ACTIONS(225),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_match] = ACTIONS(225),
    [anon_sym_match_BANG] = ACTIONS(223),
    [anon_sym_function] = ACTIONS(225),
    [anon_sym_LT_DASH] = ACTIONS(225),
    [anon_sym_DOT_LBRACK] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_use] = ACTIONS(225),
    [anon_sym_use_BANG] = ACTIONS(223),
    [anon_sym_do_BANG] = ACTIONS(223),
    [anon_sym_begin] = ACTIONS(225),
    [anon_sym_LPAREN2] = ACTIONS(347),
    [anon_sym_or] = ACTIONS(225),
    [aux_sym_char_token1] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_AT_DQUOTE] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [sym_bool] = ACTIONS(225),
    [sym_unit] = ACTIONS(363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(225),
    [sym_op_identifier] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(225),
    [anon_sym_DASH] = ACTIONS(225),
    [anon_sym_PLUS_DOT] = ACTIONS(225),
    [anon_sym_DASH_DOT] = ACTIONS(225),
    [anon_sym_PERCENT] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_TILDE] = ACTIONS(223),
    [aux_sym_prefix_op_token1] = ACTIONS(225),
    [aux_sym_infix_op_token1] = ACTIONS(223),
    [aux_sym_infix_op_token2] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_BANG_EQ] = ACTIONS(225),
    [anon_sym_COLON_EQ] = ACTIONS(223),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(225),
    [sym_int] = ACTIONS(225),
    [sym_xint] = ACTIONS(223),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(223),
    [anon_sym_POUNDendif] = ACTIONS(223),
    [anon_sym_POUNDelse] = ACTIONS(223),
    [sym__newline] = ACTIONS(223),
  },
  [184] = {
    [sym_function_or_value_defn] = STATE(972),
    [sym__expression] = STATE(227),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(978),
    [sym_infix_op] = STATE(897),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(184),
    [sym_compiler_directive_decl] = STATE(184),
    [sym_fsi_directive_decl] = STATE(184),
    [sym_preproc_line] = STATE(184),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(2950),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1300),
    [anon_sym_return] = ACTIONS(1302),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1308),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1300),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1302),
    [anon_sym_return_BANG] = ACTIONS(1326),
    [anon_sym_yield] = ACTIONS(1302),
    [anon_sym_yield_BANG] = ACTIONS(1326),
    [anon_sym_lazy] = ACTIONS(1302),
    [anon_sym_assert] = ACTIONS(1302),
    [anon_sym_upcast] = ACTIONS(1302),
    [anon_sym_downcast] = ACTIONS(1302),
    [anon_sym_COLON_GT] = ACTIONS(1328),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1328),
    [anon_sym_for] = ACTIONS(1330),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(233),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1346),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1352),
    [anon_sym_use_BANG] = ACTIONS(1354),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_DOT_DOT] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1384),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(1390),
  },
  [185] = {
    [sym_function_or_value_defn] = STATE(972),
    [sym__expression] = STATE(227),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(978),
    [sym_infix_op] = STATE(897),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(185),
    [sym_compiler_directive_decl] = STATE(185),
    [sym_fsi_directive_decl] = STATE(185),
    [sym_preproc_line] = STATE(185),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(2950),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1300),
    [anon_sym_return] = ACTIONS(1302),
    [anon_sym_do] = ACTIONS(1428),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1308),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1300),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1302),
    [anon_sym_return_BANG] = ACTIONS(1326),
    [anon_sym_yield] = ACTIONS(1302),
    [anon_sym_yield_BANG] = ACTIONS(1326),
    [anon_sym_lazy] = ACTIONS(1302),
    [anon_sym_assert] = ACTIONS(1302),
    [anon_sym_upcast] = ACTIONS(1302),
    [anon_sym_downcast] = ACTIONS(1302),
    [anon_sym_COLON_GT] = ACTIONS(1328),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1328),
    [anon_sym_for] = ACTIONS(1330),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(1428),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1346),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1352),
    [anon_sym_use_BANG] = ACTIONS(1354),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_DOT_DOT] = ACTIONS(1430),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1384),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(1390),
  },
  [186] = {
    [sym_function_or_value_defn] = STATE(1074),
    [sym__expression] = STATE(186),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(944),
    [sym_infix_op] = STATE(1134),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(2718),
    [sym_block_comment] = STATE(186),
    [sym_compiler_directive_decl] = STATE(186),
    [sym_fsi_directive_decl] = STATE(186),
    [sym_preproc_line] = STATE(186),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_sequential_expression_repeat1] = STATE(2825),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_EQ] = ACTIONS(223),
    [anon_sym_COLON] = ACTIONS(225),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_do] = ACTIONS(225),
    [anon_sym_and] = ACTIONS(225),
    [anon_sym_let] = ACTIONS(225),
    [anon_sym_let_BANG] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_COMMA] = ACTIONS(223),
    [anon_sym_null] = ACTIONS(225),
    [anon_sym_QMARK] = ACTIONS(225),
    [anon_sym_COLON_QMARK] = ACTIONS(225),
    [anon_sym_COLON_COLON] = ACTIONS(223),
    [anon_sym_AMP] = ACTIONS(225),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LBRACK_PIPE] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(225),
    [anon_sym_LT_AT] = ACTIONS(225),
    [anon_sym_LT_AT_AT] = ACTIONS(225),
    [anon_sym_DOT] = ACTIONS(493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(225),
    [anon_sym_return_BANG] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(225),
    [anon_sym_yield_BANG] = ACTIONS(223),
    [anon_sym_lazy] = ACTIONS(225),
    [anon_sym_assert] = ACTIONS(225),
    [anon_sym_upcast] = ACTIONS(225),
    [anon_sym_downcast] = ACTIONS(225),
    [anon_sym_COLON_GT] = ACTIONS(223),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(223),
    [anon_sym_for] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_fun] = ACTIONS(225),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_match] = ACTIONS(225),
    [anon_sym_match_BANG] = ACTIONS(223),
    [anon_sym_function] = ACTIONS(225),
    [anon_sym_LT_DASH] = ACTIONS(225),
    [anon_sym_DOT_LBRACK] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_use] = ACTIONS(225),
    [anon_sym_use_BANG] = ACTIONS(223),
    [anon_sym_do_BANG] = ACTIONS(223),
    [anon_sym_begin] = ACTIONS(225),
    [anon_sym_LPAREN2] = ACTIONS(529),
    [anon_sym_or] = ACTIONS(225),
    [aux_sym_char_token1] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_AT_DQUOTE] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [sym_bool] = ACTIONS(225),
    [sym_unit] = ACTIONS(545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(225),
    [sym_op_identifier] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(225),
    [anon_sym_DASH] = ACTIONS(225),
    [anon_sym_PLUS_DOT] = ACTIONS(225),
    [anon_sym_DASH_DOT] = ACTIONS(225),
    [anon_sym_PERCENT] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_TILDE] = ACTIONS(223),
    [aux_sym_prefix_op_token1] = ACTIONS(225),
    [aux_sym_infix_op_token1] = ACTIONS(223),
    [aux_sym_infix_op_token2] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_BANG_EQ] = ACTIONS(225),
    [anon_sym_COLON_EQ] = ACTIONS(223),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(225),
    [sym_int] = ACTIONS(225),
    [sym_xint] = ACTIONS(223),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(223),
    [sym__newline] = ACTIONS(223),
    [sym__dedent] = ACTIONS(223),
  },
  [187] = {
    [sym_function_or_value_defn] = STATE(972),
    [sym__expression] = STATE(227),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(978),
    [sym_infix_op] = STATE(897),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(187),
    [sym_compiler_directive_decl] = STATE(187),
    [sym_fsi_directive_decl] = STATE(187),
    [sym_preproc_line] = STATE(187),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(2950),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1300),
    [anon_sym_return] = ACTIONS(1302),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1308),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1300),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1302),
    [anon_sym_return_BANG] = ACTIONS(1326),
    [anon_sym_yield] = ACTIONS(1302),
    [anon_sym_yield_BANG] = ACTIONS(1326),
    [anon_sym_lazy] = ACTIONS(1302),
    [anon_sym_assert] = ACTIONS(1302),
    [anon_sym_upcast] = ACTIONS(1302),
    [anon_sym_downcast] = ACTIONS(1302),
    [anon_sym_COLON_GT] = ACTIONS(1328),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1328),
    [anon_sym_for] = ACTIONS(1330),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(245),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1346),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1352),
    [anon_sym_use_BANG] = ACTIONS(1354),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_DOT_DOT] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1384),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(243),
  },
  [188] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(183),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1113),
    [sym_infix_op] = STATE(900),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(188),
    [sym_compiler_directive_decl] = STATE(188),
    [sym_fsi_directive_decl] = STATE(188),
    [sym_preproc_line] = STATE(188),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_sequential_expression_repeat1] = STATE(2799),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(289),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(309),
    [anon_sym_DOT] = ACTIONS(311),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_COLON_GT] = ACTIONS(317),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_LT_DASH] = ACTIONS(1097),
    [anon_sym_DOT_LBRACK] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [anon_sym_LPAREN2] = ACTIONS(347),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(243),
    [anon_sym_POUNDelse] = ACTIONS(243),
    [sym__newline] = ACTIONS(243),
  },
  [189] = {
    [sym_function_or_value_defn] = STATE(972),
    [sym__expression] = STATE(227),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(978),
    [sym_infix_op] = STATE(897),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(189),
    [sym_compiler_directive_decl] = STATE(189),
    [sym_fsi_directive_decl] = STATE(189),
    [sym_preproc_line] = STATE(189),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(2950),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1300),
    [anon_sym_return] = ACTIONS(1302),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1308),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1300),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(255),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1302),
    [anon_sym_return_BANG] = ACTIONS(1326),
    [anon_sym_yield] = ACTIONS(1302),
    [anon_sym_yield_BANG] = ACTIONS(1326),
    [anon_sym_lazy] = ACTIONS(1302),
    [anon_sym_assert] = ACTIONS(1302),
    [anon_sym_upcast] = ACTIONS(1302),
    [anon_sym_downcast] = ACTIONS(1302),
    [anon_sym_COLON_GT] = ACTIONS(1328),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1328),
    [anon_sym_for] = ACTIONS(1330),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1346),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1352),
    [anon_sym_use_BANG] = ACTIONS(1354),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_DOT_DOT] = ACTIONS(253),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1384),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(253),
  },
  [190] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(190),
    [sym_compiler_directive_decl] = STATE(190),
    [sym_fsi_directive_decl] = STATE(190),
    [sym_preproc_line] = STATE(190),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_to] = ACTIONS(1432),
    [anon_sym_downto] = ACTIONS(1432),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [191] = {
    [sym_function_or_value_defn] = STATE(972),
    [sym__expression] = STATE(227),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(978),
    [sym_infix_op] = STATE(897),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(191),
    [sym_compiler_directive_decl] = STATE(191),
    [sym_fsi_directive_decl] = STATE(191),
    [sym_preproc_line] = STATE(191),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(2950),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1300),
    [anon_sym_return] = ACTIONS(1302),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1308),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1300),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(259),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1302),
    [anon_sym_return_BANG] = ACTIONS(1326),
    [anon_sym_yield] = ACTIONS(1302),
    [anon_sym_yield_BANG] = ACTIONS(1326),
    [anon_sym_lazy] = ACTIONS(1302),
    [anon_sym_assert] = ACTIONS(1302),
    [anon_sym_upcast] = ACTIONS(1302),
    [anon_sym_downcast] = ACTIONS(1302),
    [anon_sym_COLON_GT] = ACTIONS(1328),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1328),
    [anon_sym_for] = ACTIONS(1330),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(259),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1346),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1352),
    [anon_sym_use_BANG] = ACTIONS(1354),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_DOT_DOT] = ACTIONS(257),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1384),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(257),
  },
  [192] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(192),
    [sym_compiler_directive_decl] = STATE(192),
    [sym_fsi_directive_decl] = STATE(192),
    [sym_preproc_line] = STATE(192),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_to] = ACTIONS(1434),
    [anon_sym_downto] = ACTIONS(1434),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [193] = {
    [sym_function_or_value_defn] = STATE(845),
    [sym__expression] = STATE(209),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(776),
    [sym_infix_op] = STATE(867),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(193),
    [sym_compiler_directive_decl] = STATE(193),
    [sym_fsi_directive_decl] = STATE(193),
    [sym_preproc_line] = STATE(193),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2959),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1203),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1205),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1203),
    [anon_sym_return_BANG] = ACTIONS(1207),
    [anon_sym_yield] = ACTIONS(1203),
    [anon_sym_yield_BANG] = ACTIONS(1207),
    [anon_sym_lazy] = ACTIONS(1203),
    [anon_sym_assert] = ACTIONS(1203),
    [anon_sym_upcast] = ACTIONS(1203),
    [anon_sym_downcast] = ACTIONS(1203),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(1209),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1211),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1213),
    [anon_sym_use_BANG] = ACTIONS(1215),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_DOT_DOT2] = ACTIONS(261),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1219),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1436),
    [sym__dedent] = ACTIONS(1436),
  },
  [194] = {
    [sym_function_or_value_defn] = STATE(1074),
    [sym__expression] = STATE(186),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(944),
    [sym_infix_op] = STATE(1134),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(2718),
    [sym_block_comment] = STATE(194),
    [sym_compiler_directive_decl] = STATE(194),
    [sym_fsi_directive_decl] = STATE(194),
    [sym_preproc_line] = STATE(194),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_sequential_expression_repeat1] = STATE(2825),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_return] = ACTIONS(1252),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_and] = ACTIONS(263),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(1254),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(731),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_return_BANG] = ACTIONS(1256),
    [anon_sym_yield] = ACTIONS(1252),
    [anon_sym_yield_BANG] = ACTIONS(1256),
    [anon_sym_lazy] = ACTIONS(1252),
    [anon_sym_assert] = ACTIONS(1252),
    [anon_sym_upcast] = ACTIONS(1252),
    [anon_sym_downcast] = ACTIONS(1252),
    [anon_sym_COLON_GT] = ACTIONS(499),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_LT_DASH] = ACTIONS(1258),
    [anon_sym_DOT_LBRACK] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_use] = ACTIONS(1260),
    [anon_sym_use_BANG] = ACTIONS(1262),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [anon_sym_LPAREN2] = ACTIONS(529),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1264),
    [sym_xint] = ACTIONS(1266),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
    [sym__newline] = ACTIONS(1394),
    [sym__dedent] = ACTIONS(261),
  },
  [195] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(176),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(887),
    [sym_infix_op] = STATE(803),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(195),
    [sym_compiler_directive_decl] = STATE(195),
    [sym_fsi_directive_decl] = STATE(195),
    [sym_preproc_line] = STATE(195),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2961),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1238),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(1438),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(1244),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_DOT_DOT2] = ACTIONS(1284),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(1286),
  },
  [196] = {
    [sym_function_or_value_defn] = STATE(845),
    [sym__expression] = STATE(209),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(776),
    [sym_infix_op] = STATE(867),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(196),
    [sym_compiler_directive_decl] = STATE(196),
    [sym_fsi_directive_decl] = STATE(196),
    [sym_preproc_line] = STATE(196),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2959),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_EQ] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(229),
    [anon_sym_return] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_let] = ACTIONS(229),
    [anon_sym_let_BANG] = ACTIONS(227),
    [anon_sym_LPAREN] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(227),
    [anon_sym_null] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_COLON_QMARK] = ACTIONS(229),
    [anon_sym_COLON_COLON] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_LBRACK] = ACTIONS(229),
    [anon_sym_LBRACK_PIPE] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(229),
    [anon_sym_LT_AT] = ACTIONS(229),
    [anon_sym_LT_AT_AT] = ACTIONS(229),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(227),
    [anon_sym_new] = ACTIONS(229),
    [anon_sym_return_BANG] = ACTIONS(227),
    [anon_sym_yield] = ACTIONS(229),
    [anon_sym_yield_BANG] = ACTIONS(227),
    [anon_sym_lazy] = ACTIONS(229),
    [anon_sym_assert] = ACTIONS(229),
    [anon_sym_upcast] = ACTIONS(229),
    [anon_sym_downcast] = ACTIONS(229),
    [anon_sym_COLON_GT] = ACTIONS(227),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_fun] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(229),
    [anon_sym_match_BANG] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(229),
    [anon_sym_LT_DASH] = ACTIONS(229),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(229),
    [anon_sym_use_BANG] = ACTIONS(227),
    [anon_sym_do_BANG] = ACTIONS(227),
    [anon_sym_begin] = ACTIONS(229),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_DOT_DOT2] = ACTIONS(227),
    [anon_sym_or] = ACTIONS(229),
    [aux_sym_char_token1] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_AT_DQUOTE] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [sym_bool] = ACTIONS(229),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(229),
    [sym_op_identifier] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(229),
    [anon_sym_PLUS_DOT] = ACTIONS(229),
    [anon_sym_DASH_DOT] = ACTIONS(229),
    [anon_sym_PERCENT] = ACTIONS(229),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(227),
    [aux_sym_prefix_op_token1] = ACTIONS(229),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token2] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(229),
    [anon_sym_BANG_EQ] = ACTIONS(229),
    [anon_sym_COLON_EQ] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(229),
    [sym_int] = ACTIONS(229),
    [sym_xint] = ACTIONS(227),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(227),
    [sym__newline] = ACTIONS(227),
    [sym__dedent] = ACTIONS(227),
  },
  [197] = {
    [sym_function_or_value_defn] = STATE(972),
    [sym__expression] = STATE(227),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(978),
    [sym_infix_op] = STATE(897),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(197),
    [sym_compiler_directive_decl] = STATE(197),
    [sym_fsi_directive_decl] = STATE(197),
    [sym_preproc_line] = STATE(197),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(2950),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1300),
    [anon_sym_return] = ACTIONS(1302),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1308),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1300),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1302),
    [anon_sym_return_BANG] = ACTIONS(1326),
    [anon_sym_yield] = ACTIONS(1302),
    [anon_sym_yield_BANG] = ACTIONS(1326),
    [anon_sym_lazy] = ACTIONS(1302),
    [anon_sym_assert] = ACTIONS(1302),
    [anon_sym_upcast] = ACTIONS(1302),
    [anon_sym_downcast] = ACTIONS(1302),
    [anon_sym_COLON_GT] = ACTIONS(1328),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1328),
    [anon_sym_for] = ACTIONS(1330),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1346),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1352),
    [anon_sym_use_BANG] = ACTIONS(1354),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_DOT_DOT] = ACTIONS(261),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1384),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(1390),
  },
  [198] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(198),
    [sym_compiler_directive_decl] = STATE(198),
    [sym_fsi_directive_decl] = STATE(198),
    [sym_preproc_line] = STATE(198),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_to] = ACTIONS(1440),
    [anon_sym_downto] = ACTIONS(1440),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [199] = {
    [sym_function_or_value_defn] = STATE(972),
    [sym__expression] = STATE(227),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(978),
    [sym_infix_op] = STATE(897),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(199),
    [sym_compiler_directive_decl] = STATE(199),
    [sym_fsi_directive_decl] = STATE(199),
    [sym_preproc_line] = STATE(199),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(2950),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1300),
    [anon_sym_return] = ACTIONS(1302),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1308),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1300),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1302),
    [anon_sym_return_BANG] = ACTIONS(1326),
    [anon_sym_yield] = ACTIONS(1302),
    [anon_sym_yield_BANG] = ACTIONS(1326),
    [anon_sym_lazy] = ACTIONS(1302),
    [anon_sym_assert] = ACTIONS(1302),
    [anon_sym_upcast] = ACTIONS(1302),
    [anon_sym_downcast] = ACTIONS(1302),
    [anon_sym_COLON_GT] = ACTIONS(1328),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1328),
    [anon_sym_for] = ACTIONS(1330),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(267),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1346),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1352),
    [anon_sym_use_BANG] = ACTIONS(1354),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_DOT_DOT] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1384),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(1390),
  },
  [200] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(200),
    [sym_compiler_directive_decl] = STATE(200),
    [sym_fsi_directive_decl] = STATE(200),
    [sym_preproc_line] = STATE(200),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_to] = ACTIONS(1442),
    [anon_sym_downto] = ACTIONS(1442),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [201] = {
    [sym_function_or_value_defn] = STATE(972),
    [sym__expression] = STATE(227),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(978),
    [sym_infix_op] = STATE(897),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(201),
    [sym_compiler_directive_decl] = STATE(201),
    [sym_fsi_directive_decl] = STATE(201),
    [sym_preproc_line] = STATE(201),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(2950),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1300),
    [anon_sym_return] = ACTIONS(1302),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1308),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1300),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1302),
    [anon_sym_return_BANG] = ACTIONS(1326),
    [anon_sym_yield] = ACTIONS(1302),
    [anon_sym_yield_BANG] = ACTIONS(1326),
    [anon_sym_lazy] = ACTIONS(1302),
    [anon_sym_assert] = ACTIONS(1302),
    [anon_sym_upcast] = ACTIONS(1302),
    [anon_sym_downcast] = ACTIONS(1302),
    [anon_sym_COLON_GT] = ACTIONS(1328),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1328),
    [anon_sym_for] = ACTIONS(1330),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(123),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1346),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1352),
    [anon_sym_use_BANG] = ACTIONS(1354),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1384),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(119),
  },
  [202] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(202),
    [sym_compiler_directive_decl] = STATE(202),
    [sym_fsi_directive_decl] = STATE(202),
    [sym_preproc_line] = STATE(202),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_to] = ACTIONS(1444),
    [anon_sym_downto] = ACTIONS(1444),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [203] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(183),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1113),
    [sym_infix_op] = STATE(900),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(203),
    [sym_compiler_directive_decl] = STATE(203),
    [sym_fsi_directive_decl] = STATE(203),
    [sym_preproc_line] = STATE(203),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_sequential_expression_repeat1] = STATE(2799),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(289),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(255),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(309),
    [anon_sym_DOT] = ACTIONS(311),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_COLON_GT] = ACTIONS(317),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_LT_DASH] = ACTIONS(1097),
    [anon_sym_DOT_LBRACK] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [anon_sym_LPAREN2] = ACTIONS(347),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(253),
    [anon_sym_POUNDelse] = ACTIONS(253),
    [sym__newline] = ACTIONS(253),
  },
  [204] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(183),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1113),
    [sym_infix_op] = STATE(900),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(204),
    [sym_compiler_directive_decl] = STATE(204),
    [sym_fsi_directive_decl] = STATE(204),
    [sym_preproc_line] = STATE(204),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_sequential_expression_repeat1] = STATE(2799),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(289),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(259),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(309),
    [anon_sym_DOT] = ACTIONS(311),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_COLON_GT] = ACTIONS(317),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_LT_DASH] = ACTIONS(1097),
    [anon_sym_DOT_LBRACK] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [anon_sym_LPAREN2] = ACTIONS(347),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(257),
    [anon_sym_POUNDelse] = ACTIONS(257),
    [sym__newline] = ACTIONS(257),
  },
  [205] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(205),
    [sym_compiler_directive_decl] = STATE(205),
    [sym_fsi_directive_decl] = STATE(205),
    [sym_preproc_line] = STATE(205),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_to] = ACTIONS(1446),
    [anon_sym_downto] = ACTIONS(1446),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [206] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(183),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1113),
    [sym_infix_op] = STATE(900),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(206),
    [sym_compiler_directive_decl] = STATE(206),
    [sym_fsi_directive_decl] = STATE(206),
    [sym_preproc_line] = STATE(206),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_sequential_expression_repeat1] = STATE(2799),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(289),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(309),
    [anon_sym_DOT] = ACTIONS(311),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_COLON_GT] = ACTIONS(317),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_LT_DASH] = ACTIONS(1097),
    [anon_sym_DOT_LBRACK] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [anon_sym_LPAREN2] = ACTIONS(347),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(261),
    [anon_sym_POUNDelse] = ACTIONS(261),
    [sym__newline] = ACTIONS(1113),
  },
  [207] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(207),
    [sym_compiler_directive_decl] = STATE(207),
    [sym_fsi_directive_decl] = STATE(207),
    [sym_preproc_line] = STATE(207),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_with] = ACTIONS(1448),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(1450),
  },
  [208] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(176),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(887),
    [sym_infix_op] = STATE(803),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(208),
    [sym_compiler_directive_decl] = STATE(208),
    [sym_fsi_directive_decl] = STATE(208),
    [sym_preproc_line] = STATE(208),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2961),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1238),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(1452),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(1244),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_DOT_DOT2] = ACTIONS(1284),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(1286),
  },
  [209] = {
    [sym_function_or_value_defn] = STATE(845),
    [sym__expression] = STATE(209),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(776),
    [sym_infix_op] = STATE(867),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(209),
    [sym_compiler_directive_decl] = STATE(209),
    [sym_fsi_directive_decl] = STATE(209),
    [sym_preproc_line] = STATE(209),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2959),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_EQ] = ACTIONS(223),
    [anon_sym_COLON] = ACTIONS(225),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_do] = ACTIONS(225),
    [anon_sym_let] = ACTIONS(225),
    [anon_sym_let_BANG] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_COMMA] = ACTIONS(223),
    [anon_sym_null] = ACTIONS(225),
    [anon_sym_QMARK] = ACTIONS(225),
    [anon_sym_COLON_QMARK] = ACTIONS(225),
    [anon_sym_COLON_COLON] = ACTIONS(223),
    [anon_sym_AMP] = ACTIONS(225),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LBRACK_PIPE] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(225),
    [anon_sym_LT_AT] = ACTIONS(225),
    [anon_sym_LT_AT_AT] = ACTIONS(225),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(225),
    [anon_sym_return_BANG] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(225),
    [anon_sym_yield_BANG] = ACTIONS(223),
    [anon_sym_lazy] = ACTIONS(225),
    [anon_sym_assert] = ACTIONS(225),
    [anon_sym_upcast] = ACTIONS(225),
    [anon_sym_downcast] = ACTIONS(225),
    [anon_sym_COLON_GT] = ACTIONS(223),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(223),
    [anon_sym_for] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_fun] = ACTIONS(225),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_match] = ACTIONS(225),
    [anon_sym_match_BANG] = ACTIONS(223),
    [anon_sym_function] = ACTIONS(225),
    [anon_sym_LT_DASH] = ACTIONS(225),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(225),
    [anon_sym_use_BANG] = ACTIONS(223),
    [anon_sym_do_BANG] = ACTIONS(223),
    [anon_sym_begin] = ACTIONS(225),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_DOT_DOT2] = ACTIONS(223),
    [anon_sym_or] = ACTIONS(225),
    [aux_sym_char_token1] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_AT_DQUOTE] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [sym_bool] = ACTIONS(225),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(225),
    [sym_op_identifier] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(225),
    [anon_sym_DASH] = ACTIONS(225),
    [anon_sym_PLUS_DOT] = ACTIONS(225),
    [anon_sym_DASH_DOT] = ACTIONS(225),
    [anon_sym_PERCENT] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_TILDE] = ACTIONS(223),
    [aux_sym_prefix_op_token1] = ACTIONS(225),
    [aux_sym_infix_op_token1] = ACTIONS(223),
    [aux_sym_infix_op_token2] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_BANG_EQ] = ACTIONS(225),
    [anon_sym_COLON_EQ] = ACTIONS(223),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(225),
    [sym_int] = ACTIONS(225),
    [sym_xint] = ACTIONS(223),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(223),
    [sym__newline] = ACTIONS(223),
    [sym__dedent] = ACTIONS(223),
  },
  [210] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(210),
    [sym_compiler_directive_decl] = STATE(210),
    [sym_fsi_directive_decl] = STATE(210),
    [sym_preproc_line] = STATE(210),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_to] = ACTIONS(1454),
    [anon_sym_downto] = ACTIONS(1454),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [211] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(211),
    [sym_compiler_directive_decl] = STATE(211),
    [sym_fsi_directive_decl] = STATE(211),
    [sym_preproc_line] = STATE(211),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_with] = ACTIONS(267),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(265),
  },
  [212] = {
    [sym_function_or_value_defn] = STATE(972),
    [sym__expression] = STATE(227),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(978),
    [sym_infix_op] = STATE(897),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(212),
    [sym_compiler_directive_decl] = STATE(212),
    [sym_fsi_directive_decl] = STATE(212),
    [sym_preproc_line] = STATE(212),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(2950),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1300),
    [anon_sym_return] = ACTIONS(1302),
    [anon_sym_do] = ACTIONS(1456),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1308),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1300),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1302),
    [anon_sym_return_BANG] = ACTIONS(1326),
    [anon_sym_yield] = ACTIONS(1302),
    [anon_sym_yield_BANG] = ACTIONS(1326),
    [anon_sym_lazy] = ACTIONS(1302),
    [anon_sym_assert] = ACTIONS(1302),
    [anon_sym_upcast] = ACTIONS(1302),
    [anon_sym_downcast] = ACTIONS(1302),
    [anon_sym_COLON_GT] = ACTIONS(1328),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1328),
    [anon_sym_for] = ACTIONS(1330),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(1336),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1346),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1352),
    [anon_sym_use_BANG] = ACTIONS(1354),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_DOT_DOT] = ACTIONS(1358),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1384),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(1390),
  },
  [213] = {
    [sym_function_or_value_defn] = STATE(1180),
    [sym__expression] = STATE(239),
    [sym_literal_expression] = STATE(3145),
    [sym_long_identifier_or_op] = STATE(3145),
    [sym_tuple_expression] = STATE(3145),
    [sym_brace_expression] = STATE(3145),
    [sym_anon_record_expression] = STATE(3145),
    [sym_prefixed_expression] = STATE(3145),
    [sym_typecast_expression] = STATE(3145),
    [sym_for_expression] = STATE(3145),
    [sym_while_expression] = STATE(3145),
    [sym__if_branch] = STATE(10360),
    [sym_if_expression] = STATE(3145),
    [sym_fun_expression] = STATE(3145),
    [sym_try_expression] = STATE(3145),
    [sym_match_expression] = STATE(3145),
    [sym_function_expression] = STATE(3145),
    [sym_mutate_expression] = STATE(3145),
    [sym_index_expression] = STATE(3145),
    [sym_typed_expression] = STATE(3145),
    [sym_declaration_expression] = STATE(3145),
    [sym_do_expression] = STATE(3145),
    [sym_list_expression] = STATE(3145),
    [sym_array_expression] = STATE(3145),
    [sym_begin_end_expression] = STATE(3145),
    [sym_paren_expression] = STATE(3145),
    [sym__high_prec_app] = STATE(3141),
    [sym__low_prec_app] = STATE(3141),
    [sym_application_expression] = STATE(3145),
    [sym_dot_expression] = STATE(3145),
    [sym_infix_expression] = STATE(3145),
    [sym_ce_expression] = STATE(3145),
    [sym_sequential_expression] = STATE(3145),
    [sym_char] = STATE(3108),
    [sym_format_string] = STATE(3193),
    [sym__string_literal] = STATE(3193),
    [sym_string] = STATE(3108),
    [sym_verbatim_string] = STATE(3108),
    [sym_bytearray] = STATE(3108),
    [sym_verbatim_bytearray] = STATE(3108),
    [sym_format_triple_quoted_string] = STATE(3192),
    [sym_triple_quoted_string] = STATE(3108),
    [sym_const] = STATE(3145),
    [sym_long_identifier] = STATE(3102),
    [sym_active_pattern] = STATE(3172),
    [sym__identifier_or_op] = STATE(3103),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1149),
    [sym_infix_op] = STATE(912),
    [sym_sbyte] = STATE(3108),
    [sym_byte] = STATE(3108),
    [sym_int16] = STATE(3108),
    [sym_uint16] = STATE(3108),
    [sym_int32] = STATE(3108),
    [sym_uint32] = STATE(3108),
    [sym_nativeint] = STATE(3108),
    [sym_unativeint] = STATE(3108),
    [sym_int64] = STATE(3108),
    [sym_uint64] = STATE(3108),
    [sym_ieee32] = STATE(3108),
    [sym_ieee64] = STATE(3108),
    [sym_bignum] = STATE(3108),
    [sym_decimal] = STATE(3108),
    [sym_float] = STATE(2770),
    [sym_block_comment] = STATE(213),
    [sym_compiler_directive_decl] = STATE(213),
    [sym_fsi_directive_decl] = STATE(213),
    [sym_preproc_line] = STATE(213),
    [sym_preproc_if_in_expression] = STATE(3145),
    [aux_sym_sequential_expression_repeat1] = STATE(2846),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1117),
    [anon_sym_return] = ACTIONS(1119),
    [anon_sym_do] = ACTIONS(1121),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(263),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1125),
    [anon_sym_null] = ACTIONS(1127),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1117),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1131),
    [anon_sym_LBRACE] = ACTIONS(1133),
    [anon_sym_LT_AT] = ACTIONS(1135),
    [anon_sym_LT_AT_AT] = ACTIONS(1137),
    [anon_sym_DOT] = ACTIONS(1139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1141),
    [anon_sym_new] = ACTIONS(1119),
    [anon_sym_with] = ACTIONS(263),
    [anon_sym_return_BANG] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1119),
    [anon_sym_yield_BANG] = ACTIONS(1143),
    [anon_sym_lazy] = ACTIONS(1119),
    [anon_sym_assert] = ACTIONS(1119),
    [anon_sym_upcast] = ACTIONS(1119),
    [anon_sym_downcast] = ACTIONS(1119),
    [anon_sym_COLON_GT] = ACTIONS(1145),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1145),
    [anon_sym_for] = ACTIONS(1147),
    [anon_sym_while] = ACTIONS(1149),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1151),
    [anon_sym_try] = ACTIONS(1153),
    [anon_sym_match] = ACTIONS(1155),
    [anon_sym_match_BANG] = ACTIONS(1157),
    [anon_sym_function] = ACTIONS(1159),
    [anon_sym_LT_DASH] = ACTIONS(1161),
    [anon_sym_DOT_LBRACK] = ACTIONS(1163),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_use] = ACTIONS(1167),
    [anon_sym_use_BANG] = ACTIONS(1169),
    [anon_sym_do_BANG] = ACTIONS(1171),
    [anon_sym_begin] = ACTIONS(1173),
    [anon_sym_LPAREN2] = ACTIONS(1175),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1177),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(1181),
    [anon_sym_AT_DQUOTE] = ACTIONS(1183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1185),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1187),
    [sym_bool] = ACTIONS(1189),
    [sym_unit] = ACTIONS(1191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1193),
    [sym_op_identifier] = ACTIONS(1195),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1197),
    [sym_xint] = ACTIONS(1199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1201),
    [sym__newline] = ACTIONS(1294),
  },
  [214] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(183),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1113),
    [sym_infix_op] = STATE(900),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(214),
    [sym_compiler_directive_decl] = STATE(214),
    [sym_fsi_directive_decl] = STATE(214),
    [sym_preproc_line] = STATE(214),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_sequential_expression_repeat1] = STATE(2799),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(289),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(309),
    [anon_sym_DOT] = ACTIONS(311),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_COLON_GT] = ACTIONS(317),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_LT_DASH] = ACTIONS(1097),
    [anon_sym_DOT_LBRACK] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [anon_sym_LPAREN2] = ACTIONS(347),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(265),
    [anon_sym_POUNDelse] = ACTIONS(265),
    [sym__newline] = ACTIONS(1113),
  },
  [215] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(215),
    [sym_compiler_directive_decl] = STATE(215),
    [sym_fsi_directive_decl] = STATE(215),
    [sym_preproc_line] = STATE(215),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_to] = ACTIONS(1458),
    [anon_sym_downto] = ACTIONS(1458),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [216] = {
    [sym_function_or_value_defn] = STATE(1180),
    [sym__expression] = STATE(239),
    [sym_literal_expression] = STATE(3145),
    [sym_long_identifier_or_op] = STATE(3145),
    [sym_tuple_expression] = STATE(3145),
    [sym_brace_expression] = STATE(3145),
    [sym_anon_record_expression] = STATE(3145),
    [sym_prefixed_expression] = STATE(3145),
    [sym_typecast_expression] = STATE(3145),
    [sym_for_expression] = STATE(3145),
    [sym_while_expression] = STATE(3145),
    [sym__if_branch] = STATE(10360),
    [sym_if_expression] = STATE(3145),
    [sym_fun_expression] = STATE(3145),
    [sym_try_expression] = STATE(3145),
    [sym_match_expression] = STATE(3145),
    [sym_function_expression] = STATE(3145),
    [sym_mutate_expression] = STATE(3145),
    [sym_index_expression] = STATE(3145),
    [sym_typed_expression] = STATE(3145),
    [sym_declaration_expression] = STATE(3145),
    [sym_do_expression] = STATE(3145),
    [sym_list_expression] = STATE(3145),
    [sym_array_expression] = STATE(3145),
    [sym_begin_end_expression] = STATE(3145),
    [sym_paren_expression] = STATE(3145),
    [sym__high_prec_app] = STATE(3141),
    [sym__low_prec_app] = STATE(3141),
    [sym_application_expression] = STATE(3145),
    [sym_dot_expression] = STATE(3145),
    [sym_infix_expression] = STATE(3145),
    [sym_ce_expression] = STATE(3145),
    [sym_sequential_expression] = STATE(3145),
    [sym_char] = STATE(3108),
    [sym_format_string] = STATE(3193),
    [sym__string_literal] = STATE(3193),
    [sym_string] = STATE(3108),
    [sym_verbatim_string] = STATE(3108),
    [sym_bytearray] = STATE(3108),
    [sym_verbatim_bytearray] = STATE(3108),
    [sym_format_triple_quoted_string] = STATE(3192),
    [sym_triple_quoted_string] = STATE(3108),
    [sym_const] = STATE(3145),
    [sym_long_identifier] = STATE(3102),
    [sym_active_pattern] = STATE(3172),
    [sym__identifier_or_op] = STATE(3103),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1149),
    [sym_infix_op] = STATE(912),
    [sym_sbyte] = STATE(3108),
    [sym_byte] = STATE(3108),
    [sym_int16] = STATE(3108),
    [sym_uint16] = STATE(3108),
    [sym_int32] = STATE(3108),
    [sym_uint32] = STATE(3108),
    [sym_nativeint] = STATE(3108),
    [sym_unativeint] = STATE(3108),
    [sym_int64] = STATE(3108),
    [sym_uint64] = STATE(3108),
    [sym_ieee32] = STATE(3108),
    [sym_ieee64] = STATE(3108),
    [sym_bignum] = STATE(3108),
    [sym_decimal] = STATE(3108),
    [sym_float] = STATE(2770),
    [sym_block_comment] = STATE(216),
    [sym_compiler_directive_decl] = STATE(216),
    [sym_fsi_directive_decl] = STATE(216),
    [sym_preproc_line] = STATE(216),
    [sym_preproc_if_in_expression] = STATE(3145),
    [aux_sym_sequential_expression_repeat1] = STATE(2846),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1117),
    [anon_sym_return] = ACTIONS(1119),
    [anon_sym_do] = ACTIONS(1121),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1125),
    [anon_sym_null] = ACTIONS(1127),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1117),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1131),
    [anon_sym_LBRACE] = ACTIONS(1133),
    [anon_sym_LT_AT] = ACTIONS(1135),
    [anon_sym_LT_AT_AT] = ACTIONS(1137),
    [anon_sym_DOT] = ACTIONS(1139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1141),
    [anon_sym_new] = ACTIONS(1119),
    [anon_sym_with] = ACTIONS(233),
    [anon_sym_return_BANG] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1119),
    [anon_sym_yield_BANG] = ACTIONS(1143),
    [anon_sym_lazy] = ACTIONS(1119),
    [anon_sym_assert] = ACTIONS(1119),
    [anon_sym_upcast] = ACTIONS(1119),
    [anon_sym_downcast] = ACTIONS(1119),
    [anon_sym_COLON_GT] = ACTIONS(1145),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1145),
    [anon_sym_for] = ACTIONS(1147),
    [anon_sym_while] = ACTIONS(1149),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1151),
    [anon_sym_try] = ACTIONS(1153),
    [anon_sym_match] = ACTIONS(1155),
    [anon_sym_match_BANG] = ACTIONS(1157),
    [anon_sym_function] = ACTIONS(1159),
    [anon_sym_LT_DASH] = ACTIONS(1161),
    [anon_sym_DOT_LBRACK] = ACTIONS(1163),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_use] = ACTIONS(1167),
    [anon_sym_use_BANG] = ACTIONS(1169),
    [anon_sym_do_BANG] = ACTIONS(1171),
    [anon_sym_begin] = ACTIONS(1173),
    [anon_sym_LPAREN2] = ACTIONS(1175),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1177),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(1181),
    [anon_sym_AT_DQUOTE] = ACTIONS(1183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1185),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1187),
    [sym_bool] = ACTIONS(1189),
    [sym_unit] = ACTIONS(1191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1193),
    [sym_op_identifier] = ACTIONS(1195),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1197),
    [sym_xint] = ACTIONS(1199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1201),
    [sym__newline] = ACTIONS(1294),
  },
  [217] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(217),
    [sym_compiler_directive_decl] = STATE(217),
    [sym_fsi_directive_decl] = STATE(217),
    [sym_preproc_line] = STATE(217),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym__module_body_repeat1] = STATE(8972),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1460),
    [sym__dedent] = ACTIONS(1462),
  },
  [218] = {
    [sym_function_or_value_defn] = STATE(1180),
    [sym__expression] = STATE(239),
    [sym_literal_expression] = STATE(3145),
    [sym_long_identifier_or_op] = STATE(3145),
    [sym_tuple_expression] = STATE(3145),
    [sym_brace_expression] = STATE(3145),
    [sym_anon_record_expression] = STATE(3145),
    [sym_prefixed_expression] = STATE(3145),
    [sym_typecast_expression] = STATE(3145),
    [sym_for_expression] = STATE(3145),
    [sym_while_expression] = STATE(3145),
    [sym__if_branch] = STATE(10360),
    [sym_if_expression] = STATE(3145),
    [sym_fun_expression] = STATE(3145),
    [sym_try_expression] = STATE(3145),
    [sym_match_expression] = STATE(3145),
    [sym_function_expression] = STATE(3145),
    [sym_mutate_expression] = STATE(3145),
    [sym_index_expression] = STATE(3145),
    [sym_typed_expression] = STATE(3145),
    [sym_declaration_expression] = STATE(3145),
    [sym_do_expression] = STATE(3145),
    [sym_list_expression] = STATE(3145),
    [sym_array_expression] = STATE(3145),
    [sym_begin_end_expression] = STATE(3145),
    [sym_paren_expression] = STATE(3145),
    [sym__high_prec_app] = STATE(3141),
    [sym__low_prec_app] = STATE(3141),
    [sym_application_expression] = STATE(3145),
    [sym_dot_expression] = STATE(3145),
    [sym_infix_expression] = STATE(3145),
    [sym_ce_expression] = STATE(3145),
    [sym_sequential_expression] = STATE(3145),
    [sym_char] = STATE(3108),
    [sym_format_string] = STATE(3193),
    [sym__string_literal] = STATE(3193),
    [sym_string] = STATE(3108),
    [sym_verbatim_string] = STATE(3108),
    [sym_bytearray] = STATE(3108),
    [sym_verbatim_bytearray] = STATE(3108),
    [sym_format_triple_quoted_string] = STATE(3192),
    [sym_triple_quoted_string] = STATE(3108),
    [sym_const] = STATE(3145),
    [sym_long_identifier] = STATE(3102),
    [sym_active_pattern] = STATE(3172),
    [sym__identifier_or_op] = STATE(3103),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1149),
    [sym_infix_op] = STATE(912),
    [sym_sbyte] = STATE(3108),
    [sym_byte] = STATE(3108),
    [sym_int16] = STATE(3108),
    [sym_uint16] = STATE(3108),
    [sym_int32] = STATE(3108),
    [sym_uint32] = STATE(3108),
    [sym_nativeint] = STATE(3108),
    [sym_unativeint] = STATE(3108),
    [sym_int64] = STATE(3108),
    [sym_uint64] = STATE(3108),
    [sym_ieee32] = STATE(3108),
    [sym_ieee64] = STATE(3108),
    [sym_bignum] = STATE(3108),
    [sym_decimal] = STATE(3108),
    [sym_float] = STATE(2770),
    [sym_block_comment] = STATE(218),
    [sym_compiler_directive_decl] = STATE(218),
    [sym_fsi_directive_decl] = STATE(218),
    [sym_preproc_line] = STATE(218),
    [sym_preproc_if_in_expression] = STATE(3145),
    [aux_sym_sequential_expression_repeat1] = STATE(2846),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1117),
    [anon_sym_return] = ACTIONS(1119),
    [anon_sym_do] = ACTIONS(1121),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(259),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1125),
    [anon_sym_null] = ACTIONS(1127),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1117),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1131),
    [anon_sym_LBRACE] = ACTIONS(259),
    [anon_sym_LT_AT] = ACTIONS(1135),
    [anon_sym_LT_AT_AT] = ACTIONS(1137),
    [anon_sym_DOT] = ACTIONS(1139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1141),
    [anon_sym_new] = ACTIONS(1119),
    [anon_sym_with] = ACTIONS(259),
    [anon_sym_return_BANG] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1119),
    [anon_sym_yield_BANG] = ACTIONS(1143),
    [anon_sym_lazy] = ACTIONS(1119),
    [anon_sym_assert] = ACTIONS(1119),
    [anon_sym_upcast] = ACTIONS(1119),
    [anon_sym_downcast] = ACTIONS(1119),
    [anon_sym_COLON_GT] = ACTIONS(1145),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1145),
    [anon_sym_for] = ACTIONS(1147),
    [anon_sym_while] = ACTIONS(1149),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1151),
    [anon_sym_try] = ACTIONS(1153),
    [anon_sym_match] = ACTIONS(1155),
    [anon_sym_match_BANG] = ACTIONS(1157),
    [anon_sym_function] = ACTIONS(1159),
    [anon_sym_LT_DASH] = ACTIONS(1161),
    [anon_sym_DOT_LBRACK] = ACTIONS(1163),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_use] = ACTIONS(1167),
    [anon_sym_use_BANG] = ACTIONS(1169),
    [anon_sym_do_BANG] = ACTIONS(1171),
    [anon_sym_begin] = ACTIONS(1173),
    [anon_sym_LPAREN2] = ACTIONS(1175),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1177),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(1181),
    [anon_sym_AT_DQUOTE] = ACTIONS(1183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1185),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1187),
    [sym_bool] = ACTIONS(1189),
    [sym_unit] = ACTIONS(1191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1193),
    [sym_op_identifier] = ACTIONS(1195),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1197),
    [sym_xint] = ACTIONS(1199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1201),
    [sym__newline] = ACTIONS(257),
  },
  [219] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(176),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(887),
    [sym_infix_op] = STATE(803),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(219),
    [sym_compiler_directive_decl] = STATE(219),
    [sym_fsi_directive_decl] = STATE(219),
    [sym_preproc_line] = STATE(219),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2961),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1238),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(1464),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(1244),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_DOT_DOT2] = ACTIONS(1284),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(1286),
  },
  [220] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(220),
    [sym_compiler_directive_decl] = STATE(220),
    [sym_fsi_directive_decl] = STATE(220),
    [sym_preproc_line] = STATE(220),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_to] = ACTIONS(1466),
    [anon_sym_downto] = ACTIONS(1466),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [221] = {
    [sym_function_or_value_defn] = STATE(1180),
    [sym__expression] = STATE(239),
    [sym_literal_expression] = STATE(3145),
    [sym_long_identifier_or_op] = STATE(3145),
    [sym_tuple_expression] = STATE(3145),
    [sym_brace_expression] = STATE(3145),
    [sym_anon_record_expression] = STATE(3145),
    [sym_prefixed_expression] = STATE(3145),
    [sym_typecast_expression] = STATE(3145),
    [sym_for_expression] = STATE(3145),
    [sym_while_expression] = STATE(3145),
    [sym__if_branch] = STATE(10360),
    [sym_if_expression] = STATE(3145),
    [sym_fun_expression] = STATE(3145),
    [sym_try_expression] = STATE(3145),
    [sym_match_expression] = STATE(3145),
    [sym_function_expression] = STATE(3145),
    [sym_mutate_expression] = STATE(3145),
    [sym_index_expression] = STATE(3145),
    [sym_typed_expression] = STATE(3145),
    [sym_declaration_expression] = STATE(3145),
    [sym_do_expression] = STATE(3145),
    [sym_list_expression] = STATE(3145),
    [sym_array_expression] = STATE(3145),
    [sym_begin_end_expression] = STATE(3145),
    [sym_paren_expression] = STATE(3145),
    [sym__high_prec_app] = STATE(3141),
    [sym__low_prec_app] = STATE(3141),
    [sym_application_expression] = STATE(3145),
    [sym_dot_expression] = STATE(3145),
    [sym_infix_expression] = STATE(3145),
    [sym_ce_expression] = STATE(3145),
    [sym_sequential_expression] = STATE(3145),
    [sym_char] = STATE(3108),
    [sym_format_string] = STATE(3193),
    [sym__string_literal] = STATE(3193),
    [sym_string] = STATE(3108),
    [sym_verbatim_string] = STATE(3108),
    [sym_bytearray] = STATE(3108),
    [sym_verbatim_bytearray] = STATE(3108),
    [sym_format_triple_quoted_string] = STATE(3192),
    [sym_triple_quoted_string] = STATE(3108),
    [sym_const] = STATE(3145),
    [sym_long_identifier] = STATE(3102),
    [sym_active_pattern] = STATE(3172),
    [sym__identifier_or_op] = STATE(3103),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1149),
    [sym_infix_op] = STATE(912),
    [sym_sbyte] = STATE(3108),
    [sym_byte] = STATE(3108),
    [sym_int16] = STATE(3108),
    [sym_uint16] = STATE(3108),
    [sym_int32] = STATE(3108),
    [sym_uint32] = STATE(3108),
    [sym_nativeint] = STATE(3108),
    [sym_unativeint] = STATE(3108),
    [sym_int64] = STATE(3108),
    [sym_uint64] = STATE(3108),
    [sym_ieee32] = STATE(3108),
    [sym_ieee64] = STATE(3108),
    [sym_bignum] = STATE(3108),
    [sym_decimal] = STATE(3108),
    [sym_float] = STATE(2770),
    [sym_block_comment] = STATE(221),
    [sym_compiler_directive_decl] = STATE(221),
    [sym_fsi_directive_decl] = STATE(221),
    [sym_preproc_line] = STATE(221),
    [sym_preproc_if_in_expression] = STATE(3145),
    [aux_sym_sequential_expression_repeat1] = STATE(2846),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1117),
    [anon_sym_return] = ACTIONS(1119),
    [anon_sym_do] = ACTIONS(1121),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(255),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1125),
    [anon_sym_null] = ACTIONS(1127),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1117),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1131),
    [anon_sym_LBRACE] = ACTIONS(255),
    [anon_sym_LT_AT] = ACTIONS(1135),
    [anon_sym_LT_AT_AT] = ACTIONS(1137),
    [anon_sym_DOT] = ACTIONS(1139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1141),
    [anon_sym_new] = ACTIONS(1119),
    [anon_sym_with] = ACTIONS(255),
    [anon_sym_return_BANG] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1119),
    [anon_sym_yield_BANG] = ACTIONS(1143),
    [anon_sym_lazy] = ACTIONS(1119),
    [anon_sym_assert] = ACTIONS(1119),
    [anon_sym_upcast] = ACTIONS(1119),
    [anon_sym_downcast] = ACTIONS(1119),
    [anon_sym_COLON_GT] = ACTIONS(1145),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1145),
    [anon_sym_for] = ACTIONS(1147),
    [anon_sym_while] = ACTIONS(1149),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1151),
    [anon_sym_try] = ACTIONS(1153),
    [anon_sym_match] = ACTIONS(1155),
    [anon_sym_match_BANG] = ACTIONS(1157),
    [anon_sym_function] = ACTIONS(1159),
    [anon_sym_LT_DASH] = ACTIONS(1161),
    [anon_sym_DOT_LBRACK] = ACTIONS(1163),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_use] = ACTIONS(1167),
    [anon_sym_use_BANG] = ACTIONS(1169),
    [anon_sym_do_BANG] = ACTIONS(1171),
    [anon_sym_begin] = ACTIONS(1173),
    [anon_sym_LPAREN2] = ACTIONS(1175),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1177),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(1181),
    [anon_sym_AT_DQUOTE] = ACTIONS(1183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1185),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1187),
    [sym_bool] = ACTIONS(1189),
    [sym_unit] = ACTIONS(1191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1193),
    [sym_op_identifier] = ACTIONS(1195),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1197),
    [sym_xint] = ACTIONS(1199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1201),
    [sym__newline] = ACTIONS(253),
  },
  [222] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(176),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(887),
    [sym_infix_op] = STATE(803),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(222),
    [sym_compiler_directive_decl] = STATE(222),
    [sym_fsi_directive_decl] = STATE(222),
    [sym_preproc_line] = STATE(222),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2961),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1238),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(231),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(1244),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_DOT_DOT2] = ACTIONS(231),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(1286),
  },
  [223] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(183),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1113),
    [sym_infix_op] = STATE(900),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(223),
    [sym_compiler_directive_decl] = STATE(223),
    [sym_fsi_directive_decl] = STATE(223),
    [sym_preproc_line] = STATE(223),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_sequential_expression_repeat1] = STATE(2799),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(289),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(309),
    [anon_sym_DOT] = ACTIONS(311),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_COLON_GT] = ACTIONS(317),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_LT_DASH] = ACTIONS(1097),
    [anon_sym_DOT_LBRACK] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [anon_sym_LPAREN2] = ACTIONS(347),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(119),
    [anon_sym_POUNDelse] = ACTIONS(119),
    [sym__newline] = ACTIONS(119),
  },
  [224] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(176),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(887),
    [sym_infix_op] = STATE(803),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(224),
    [sym_compiler_directive_decl] = STATE(224),
    [sym_fsi_directive_decl] = STATE(224),
    [sym_preproc_line] = STATE(224),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2961),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1238),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(243),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(1244),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_DOT_DOT2] = ACTIONS(243),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(243),
  },
  [225] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(225),
    [sym_compiler_directive_decl] = STATE(225),
    [sym_fsi_directive_decl] = STATE(225),
    [sym_preproc_line] = STATE(225),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_to] = ACTIONS(1468),
    [anon_sym_downto] = ACTIONS(1468),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [226] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(183),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1113),
    [sym_infix_op] = STATE(900),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(226),
    [sym_compiler_directive_decl] = STATE(226),
    [sym_fsi_directive_decl] = STATE(226),
    [sym_preproc_line] = STATE(226),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_sequential_expression_repeat1] = STATE(2799),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(289),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(309),
    [anon_sym_DOT] = ACTIONS(311),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_COLON_GT] = ACTIONS(317),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_LT_DASH] = ACTIONS(1097),
    [anon_sym_DOT_LBRACK] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [anon_sym_LPAREN2] = ACTIONS(347),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(1470),
    [anon_sym_POUNDelse] = ACTIONS(1470),
    [sym__newline] = ACTIONS(1113),
  },
  [227] = {
    [sym_function_or_value_defn] = STATE(972),
    [sym__expression] = STATE(227),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(978),
    [sym_infix_op] = STATE(897),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(227),
    [sym_compiler_directive_decl] = STATE(227),
    [sym_fsi_directive_decl] = STATE(227),
    [sym_preproc_line] = STATE(227),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(2950),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_EQ] = ACTIONS(223),
    [anon_sym_COLON] = ACTIONS(225),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_do] = ACTIONS(225),
    [anon_sym_let] = ACTIONS(225),
    [anon_sym_let_BANG] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_COMMA] = ACTIONS(223),
    [anon_sym_null] = ACTIONS(225),
    [anon_sym_QMARK] = ACTIONS(225),
    [anon_sym_COLON_QMARK] = ACTIONS(225),
    [anon_sym_COLON_COLON] = ACTIONS(223),
    [anon_sym_AMP] = ACTIONS(225),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LBRACK_PIPE] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(225),
    [anon_sym_LT_AT] = ACTIONS(225),
    [anon_sym_LT_AT_AT] = ACTIONS(225),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(225),
    [anon_sym_return_BANG] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(225),
    [anon_sym_yield_BANG] = ACTIONS(223),
    [anon_sym_lazy] = ACTIONS(225),
    [anon_sym_assert] = ACTIONS(225),
    [anon_sym_upcast] = ACTIONS(225),
    [anon_sym_downcast] = ACTIONS(225),
    [anon_sym_COLON_GT] = ACTIONS(223),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(223),
    [anon_sym_for] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_fun] = ACTIONS(225),
    [anon_sym_DASH_GT] = ACTIONS(225),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_match] = ACTIONS(225),
    [anon_sym_match_BANG] = ACTIONS(223),
    [anon_sym_function] = ACTIONS(225),
    [anon_sym_LT_DASH] = ACTIONS(225),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(225),
    [anon_sym_use_BANG] = ACTIONS(223),
    [anon_sym_do_BANG] = ACTIONS(223),
    [anon_sym_DOT_DOT] = ACTIONS(223),
    [anon_sym_begin] = ACTIONS(225),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(225),
    [aux_sym_char_token1] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_AT_DQUOTE] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [sym_bool] = ACTIONS(225),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(225),
    [sym_op_identifier] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(225),
    [anon_sym_DASH] = ACTIONS(225),
    [anon_sym_PLUS_DOT] = ACTIONS(225),
    [anon_sym_DASH_DOT] = ACTIONS(225),
    [anon_sym_PERCENT] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_TILDE] = ACTIONS(223),
    [aux_sym_prefix_op_token1] = ACTIONS(225),
    [aux_sym_infix_op_token1] = ACTIONS(223),
    [aux_sym_infix_op_token2] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_BANG_EQ] = ACTIONS(225),
    [anon_sym_COLON_EQ] = ACTIONS(223),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(225),
    [sym_int] = ACTIONS(225),
    [sym_xint] = ACTIONS(223),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(223),
    [sym__newline] = ACTIONS(223),
  },
  [228] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(228),
    [sym_compiler_directive_decl] = STATE(228),
    [sym_fsi_directive_decl] = STATE(228),
    [sym_preproc_line] = STATE(228),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_to] = ACTIONS(1472),
    [anon_sym_downto] = ACTIONS(1472),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [229] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(183),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1113),
    [sym_infix_op] = STATE(900),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(229),
    [sym_compiler_directive_decl] = STATE(229),
    [sym_fsi_directive_decl] = STATE(229),
    [sym_preproc_line] = STATE(229),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_sequential_expression_repeat1] = STATE(2799),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_EQ] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(229),
    [anon_sym_return] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_let] = ACTIONS(229),
    [anon_sym_let_BANG] = ACTIONS(227),
    [anon_sym_LPAREN] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(227),
    [anon_sym_null] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_COLON_QMARK] = ACTIONS(229),
    [anon_sym_COLON_COLON] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_LBRACK] = ACTIONS(229),
    [anon_sym_LBRACK_PIPE] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(229),
    [anon_sym_LT_AT] = ACTIONS(229),
    [anon_sym_LT_AT_AT] = ACTIONS(229),
    [anon_sym_DOT] = ACTIONS(311),
    [anon_sym_LBRACE_PIPE] = ACTIONS(227),
    [anon_sym_new] = ACTIONS(229),
    [anon_sym_return_BANG] = ACTIONS(227),
    [anon_sym_yield] = ACTIONS(229),
    [anon_sym_yield_BANG] = ACTIONS(227),
    [anon_sym_lazy] = ACTIONS(229),
    [anon_sym_assert] = ACTIONS(229),
    [anon_sym_upcast] = ACTIONS(229),
    [anon_sym_downcast] = ACTIONS(229),
    [anon_sym_COLON_GT] = ACTIONS(227),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_fun] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(229),
    [anon_sym_match_BANG] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(229),
    [anon_sym_LT_DASH] = ACTIONS(229),
    [anon_sym_DOT_LBRACK] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_use] = ACTIONS(229),
    [anon_sym_use_BANG] = ACTIONS(227),
    [anon_sym_do_BANG] = ACTIONS(227),
    [anon_sym_begin] = ACTIONS(229),
    [anon_sym_LPAREN2] = ACTIONS(347),
    [anon_sym_or] = ACTIONS(229),
    [aux_sym_char_token1] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_AT_DQUOTE] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [sym_bool] = ACTIONS(229),
    [sym_unit] = ACTIONS(363),
    [anon_sym_LPAREN_PIPE] = ACTIONS(229),
    [sym_op_identifier] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(229),
    [anon_sym_PLUS_DOT] = ACTIONS(229),
    [anon_sym_DASH_DOT] = ACTIONS(229),
    [anon_sym_PERCENT] = ACTIONS(229),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(227),
    [aux_sym_prefix_op_token1] = ACTIONS(229),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token2] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(229),
    [anon_sym_BANG_EQ] = ACTIONS(229),
    [anon_sym_COLON_EQ] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(229),
    [sym_int] = ACTIONS(229),
    [sym_xint] = ACTIONS(227),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(227),
    [anon_sym_POUNDendif] = ACTIONS(227),
    [anon_sym_POUNDelse] = ACTIONS(227),
    [sym__newline] = ACTIONS(227),
  },
  [230] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(176),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(887),
    [sym_infix_op] = STATE(803),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(230),
    [sym_compiler_directive_decl] = STATE(230),
    [sym_fsi_directive_decl] = STATE(230),
    [sym_preproc_line] = STATE(230),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2961),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1238),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(1474),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(1244),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_DOT_DOT2] = ACTIONS(1284),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(1286),
  },
  [231] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(231),
    [sym_compiler_directive_decl] = STATE(231),
    [sym_fsi_directive_decl] = STATE(231),
    [sym_preproc_line] = STATE(231),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_to] = ACTIONS(1476),
    [anon_sym_downto] = ACTIONS(1476),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [232] = {
    [sym_function_or_value_defn] = STATE(972),
    [sym__expression] = STATE(227),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(978),
    [sym_infix_op] = STATE(897),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(232),
    [sym_compiler_directive_decl] = STATE(232),
    [sym_fsi_directive_decl] = STATE(232),
    [sym_preproc_line] = STATE(232),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(2950),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_EQ] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(229),
    [anon_sym_return] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_let] = ACTIONS(229),
    [anon_sym_let_BANG] = ACTIONS(227),
    [anon_sym_LPAREN] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(227),
    [anon_sym_null] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_COLON_QMARK] = ACTIONS(229),
    [anon_sym_COLON_COLON] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_LBRACK] = ACTIONS(229),
    [anon_sym_LBRACK_PIPE] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(229),
    [anon_sym_LT_AT] = ACTIONS(229),
    [anon_sym_LT_AT_AT] = ACTIONS(229),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(227),
    [anon_sym_new] = ACTIONS(229),
    [anon_sym_return_BANG] = ACTIONS(227),
    [anon_sym_yield] = ACTIONS(229),
    [anon_sym_yield_BANG] = ACTIONS(227),
    [anon_sym_lazy] = ACTIONS(229),
    [anon_sym_assert] = ACTIONS(229),
    [anon_sym_upcast] = ACTIONS(229),
    [anon_sym_downcast] = ACTIONS(229),
    [anon_sym_COLON_GT] = ACTIONS(227),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_fun] = ACTIONS(229),
    [anon_sym_DASH_GT] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(229),
    [anon_sym_match_BANG] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(229),
    [anon_sym_LT_DASH] = ACTIONS(229),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(229),
    [anon_sym_use_BANG] = ACTIONS(227),
    [anon_sym_do_BANG] = ACTIONS(227),
    [anon_sym_DOT_DOT] = ACTIONS(227),
    [anon_sym_begin] = ACTIONS(229),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(229),
    [aux_sym_char_token1] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_AT_DQUOTE] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [sym_bool] = ACTIONS(229),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(229),
    [sym_op_identifier] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(229),
    [anon_sym_PLUS_DOT] = ACTIONS(229),
    [anon_sym_DASH_DOT] = ACTIONS(229),
    [anon_sym_PERCENT] = ACTIONS(229),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(227),
    [aux_sym_prefix_op_token1] = ACTIONS(229),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token2] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(229),
    [anon_sym_BANG_EQ] = ACTIONS(229),
    [anon_sym_COLON_EQ] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(229),
    [sym_int] = ACTIONS(229),
    [sym_xint] = ACTIONS(227),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(227),
    [sym__newline] = ACTIONS(227),
  },
  [233] = {
    [sym_function_or_value_defn] = STATE(1074),
    [sym__expression] = STATE(186),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(944),
    [sym_infix_op] = STATE(1134),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(2718),
    [sym_block_comment] = STATE(233),
    [sym_compiler_directive_decl] = STATE(233),
    [sym_fsi_directive_decl] = STATE(233),
    [sym_preproc_line] = STATE(233),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_sequential_expression_repeat1] = STATE(2825),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(473),
    [anon_sym_return] = ACTIONS(1252),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_and] = ACTIONS(267),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(1254),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(731),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_return_BANG] = ACTIONS(1256),
    [anon_sym_yield] = ACTIONS(1252),
    [anon_sym_yield_BANG] = ACTIONS(1256),
    [anon_sym_lazy] = ACTIONS(1252),
    [anon_sym_assert] = ACTIONS(1252),
    [anon_sym_upcast] = ACTIONS(1252),
    [anon_sym_downcast] = ACTIONS(1252),
    [anon_sym_COLON_GT] = ACTIONS(499),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_LT_DASH] = ACTIONS(1258),
    [anon_sym_DOT_LBRACK] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_use] = ACTIONS(1260),
    [anon_sym_use_BANG] = ACTIONS(1262),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [anon_sym_LPAREN2] = ACTIONS(529),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1264),
    [sym_xint] = ACTIONS(1266),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
    [sym__newline] = ACTIONS(1394),
    [sym__dedent] = ACTIONS(265),
  },
  [234] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(234),
    [sym_compiler_directive_decl] = STATE(234),
    [sym_fsi_directive_decl] = STATE(234),
    [sym_preproc_line] = STATE(234),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_EQ] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(229),
    [anon_sym_return] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_let] = ACTIONS(229),
    [anon_sym_let_BANG] = ACTIONS(227),
    [anon_sym_LPAREN] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(227),
    [anon_sym_null] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_COLON_QMARK] = ACTIONS(229),
    [anon_sym_COLON_COLON] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_LBRACK] = ACTIONS(229),
    [anon_sym_LBRACK_PIPE] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(229),
    [anon_sym_LT_AT] = ACTIONS(229),
    [anon_sym_LT_AT_AT] = ACTIONS(229),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(227),
    [anon_sym_new] = ACTIONS(229),
    [anon_sym_with] = ACTIONS(229),
    [anon_sym_return_BANG] = ACTIONS(227),
    [anon_sym_yield] = ACTIONS(229),
    [anon_sym_yield_BANG] = ACTIONS(227),
    [anon_sym_lazy] = ACTIONS(229),
    [anon_sym_assert] = ACTIONS(229),
    [anon_sym_upcast] = ACTIONS(229),
    [anon_sym_downcast] = ACTIONS(229),
    [anon_sym_COLON_GT] = ACTIONS(227),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_fun] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(229),
    [anon_sym_match_BANG] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(229),
    [anon_sym_LT_DASH] = ACTIONS(229),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(229),
    [anon_sym_use_BANG] = ACTIONS(227),
    [anon_sym_do_BANG] = ACTIONS(227),
    [anon_sym_begin] = ACTIONS(229),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(229),
    [aux_sym_char_token1] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_AT_DQUOTE] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [sym_bool] = ACTIONS(229),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(229),
    [sym_op_identifier] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(229),
    [anon_sym_PLUS_DOT] = ACTIONS(229),
    [anon_sym_DASH_DOT] = ACTIONS(229),
    [anon_sym_PERCENT] = ACTIONS(229),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(227),
    [aux_sym_prefix_op_token1] = ACTIONS(229),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token2] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(229),
    [anon_sym_BANG_EQ] = ACTIONS(229),
    [anon_sym_COLON_EQ] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(229),
    [sym_int] = ACTIONS(229),
    [sym_xint] = ACTIONS(227),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(227),
    [sym__newline] = ACTIONS(227),
    [sym__dedent] = ACTIONS(227),
  },
  [235] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(176),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(887),
    [sym_infix_op] = STATE(803),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(235),
    [sym_compiler_directive_decl] = STATE(235),
    [sym_fsi_directive_decl] = STATE(235),
    [sym_preproc_line] = STATE(235),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2961),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1238),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(1416),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(1244),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_DOT_DOT2] = ACTIONS(1284),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(1286),
  },
  [236] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(176),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(887),
    [sym_infix_op] = STATE(803),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(236),
    [sym_compiler_directive_decl] = STATE(236),
    [sym_fsi_directive_decl] = STATE(236),
    [sym_preproc_line] = STATE(236),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2961),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1238),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(1478),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(1244),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_DOT_DOT2] = ACTIONS(1284),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(1286),
  },
  [237] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(176),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(887),
    [sym_infix_op] = STATE(803),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(237),
    [sym_compiler_directive_decl] = STATE(237),
    [sym_fsi_directive_decl] = STATE(237),
    [sym_preproc_line] = STATE(237),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2961),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1238),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(1480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(1244),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_DOT_DOT2] = ACTIONS(1284),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(1286),
  },
  [238] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(238),
    [sym_compiler_directive_decl] = STATE(238),
    [sym_fsi_directive_decl] = STATE(238),
    [sym_preproc_line] = STATE(238),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_to] = ACTIONS(1482),
    [anon_sym_downto] = ACTIONS(1482),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [239] = {
    [sym_function_or_value_defn] = STATE(1180),
    [sym__expression] = STATE(239),
    [sym_literal_expression] = STATE(3145),
    [sym_long_identifier_or_op] = STATE(3145),
    [sym_tuple_expression] = STATE(3145),
    [sym_brace_expression] = STATE(3145),
    [sym_anon_record_expression] = STATE(3145),
    [sym_prefixed_expression] = STATE(3145),
    [sym_typecast_expression] = STATE(3145),
    [sym_for_expression] = STATE(3145),
    [sym_while_expression] = STATE(3145),
    [sym__if_branch] = STATE(10360),
    [sym_if_expression] = STATE(3145),
    [sym_fun_expression] = STATE(3145),
    [sym_try_expression] = STATE(3145),
    [sym_match_expression] = STATE(3145),
    [sym_function_expression] = STATE(3145),
    [sym_mutate_expression] = STATE(3145),
    [sym_index_expression] = STATE(3145),
    [sym_typed_expression] = STATE(3145),
    [sym_declaration_expression] = STATE(3145),
    [sym_do_expression] = STATE(3145),
    [sym_list_expression] = STATE(3145),
    [sym_array_expression] = STATE(3145),
    [sym_begin_end_expression] = STATE(3145),
    [sym_paren_expression] = STATE(3145),
    [sym__high_prec_app] = STATE(3141),
    [sym__low_prec_app] = STATE(3141),
    [sym_application_expression] = STATE(3145),
    [sym_dot_expression] = STATE(3145),
    [sym_infix_expression] = STATE(3145),
    [sym_ce_expression] = STATE(3145),
    [sym_sequential_expression] = STATE(3145),
    [sym_char] = STATE(3108),
    [sym_format_string] = STATE(3193),
    [sym__string_literal] = STATE(3193),
    [sym_string] = STATE(3108),
    [sym_verbatim_string] = STATE(3108),
    [sym_bytearray] = STATE(3108),
    [sym_verbatim_bytearray] = STATE(3108),
    [sym_format_triple_quoted_string] = STATE(3192),
    [sym_triple_quoted_string] = STATE(3108),
    [sym_const] = STATE(3145),
    [sym_long_identifier] = STATE(3102),
    [sym_active_pattern] = STATE(3172),
    [sym__identifier_or_op] = STATE(3103),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1149),
    [sym_infix_op] = STATE(912),
    [sym_sbyte] = STATE(3108),
    [sym_byte] = STATE(3108),
    [sym_int16] = STATE(3108),
    [sym_uint16] = STATE(3108),
    [sym_int32] = STATE(3108),
    [sym_uint32] = STATE(3108),
    [sym_nativeint] = STATE(3108),
    [sym_unativeint] = STATE(3108),
    [sym_int64] = STATE(3108),
    [sym_uint64] = STATE(3108),
    [sym_ieee32] = STATE(3108),
    [sym_ieee64] = STATE(3108),
    [sym_bignum] = STATE(3108),
    [sym_decimal] = STATE(3108),
    [sym_float] = STATE(2770),
    [sym_block_comment] = STATE(239),
    [sym_compiler_directive_decl] = STATE(239),
    [sym_fsi_directive_decl] = STATE(239),
    [sym_preproc_line] = STATE(239),
    [sym_preproc_if_in_expression] = STATE(3145),
    [aux_sym_sequential_expression_repeat1] = STATE(2846),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_EQ] = ACTIONS(223),
    [anon_sym_COLON] = ACTIONS(225),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_do] = ACTIONS(225),
    [anon_sym_let] = ACTIONS(225),
    [anon_sym_let_BANG] = ACTIONS(223),
    [anon_sym_as] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_COMMA] = ACTIONS(223),
    [anon_sym_null] = ACTIONS(225),
    [anon_sym_QMARK] = ACTIONS(225),
    [anon_sym_COLON_QMARK] = ACTIONS(225),
    [anon_sym_COLON_COLON] = ACTIONS(223),
    [anon_sym_AMP] = ACTIONS(225),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LBRACK_PIPE] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(225),
    [anon_sym_LT_AT] = ACTIONS(225),
    [anon_sym_LT_AT_AT] = ACTIONS(225),
    [anon_sym_DOT] = ACTIONS(1139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(225),
    [anon_sym_with] = ACTIONS(225),
    [anon_sym_return_BANG] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(225),
    [anon_sym_yield_BANG] = ACTIONS(223),
    [anon_sym_lazy] = ACTIONS(225),
    [anon_sym_assert] = ACTIONS(225),
    [anon_sym_upcast] = ACTIONS(225),
    [anon_sym_downcast] = ACTIONS(225),
    [anon_sym_COLON_GT] = ACTIONS(223),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(223),
    [anon_sym_for] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_fun] = ACTIONS(225),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_match] = ACTIONS(225),
    [anon_sym_match_BANG] = ACTIONS(223),
    [anon_sym_function] = ACTIONS(225),
    [anon_sym_LT_DASH] = ACTIONS(225),
    [anon_sym_DOT_LBRACK] = ACTIONS(1163),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_use] = ACTIONS(225),
    [anon_sym_use_BANG] = ACTIONS(223),
    [anon_sym_do_BANG] = ACTIONS(223),
    [anon_sym_begin] = ACTIONS(225),
    [anon_sym_LPAREN2] = ACTIONS(1175),
    [anon_sym_or] = ACTIONS(225),
    [aux_sym_char_token1] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_AT_DQUOTE] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [sym_bool] = ACTIONS(225),
    [sym_unit] = ACTIONS(1191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(225),
    [sym_op_identifier] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(225),
    [anon_sym_DASH] = ACTIONS(225),
    [anon_sym_PLUS_DOT] = ACTIONS(225),
    [anon_sym_DASH_DOT] = ACTIONS(225),
    [anon_sym_PERCENT] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_TILDE] = ACTIONS(223),
    [aux_sym_prefix_op_token1] = ACTIONS(225),
    [aux_sym_infix_op_token1] = ACTIONS(223),
    [aux_sym_infix_op_token2] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_BANG_EQ] = ACTIONS(225),
    [anon_sym_COLON_EQ] = ACTIONS(223),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(225),
    [sym_int] = ACTIONS(225),
    [sym_xint] = ACTIONS(223),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(223),
    [sym__newline] = ACTIONS(223),
  },
  [240] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(176),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(887),
    [sym_infix_op] = STATE(803),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(240),
    [sym_compiler_directive_decl] = STATE(240),
    [sym_fsi_directive_decl] = STATE(240),
    [sym_preproc_line] = STATE(240),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2961),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1238),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(1484),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(1244),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_DOT_DOT2] = ACTIONS(1284),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(1286),
  },
  [241] = {
    [sym_function_or_value_defn] = STATE(1074),
    [sym__expression] = STATE(186),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(944),
    [sym_infix_op] = STATE(1134),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(2718),
    [sym_block_comment] = STATE(241),
    [sym_compiler_directive_decl] = STATE(241),
    [sym_fsi_directive_decl] = STATE(241),
    [sym_preproc_line] = STATE(241),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_sequential_expression_repeat1] = STATE(2825),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_EQ] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(229),
    [anon_sym_return] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_and] = ACTIONS(229),
    [anon_sym_let] = ACTIONS(229),
    [anon_sym_let_BANG] = ACTIONS(227),
    [anon_sym_LPAREN] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(227),
    [anon_sym_null] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_COLON_QMARK] = ACTIONS(229),
    [anon_sym_COLON_COLON] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_LBRACK] = ACTIONS(229),
    [anon_sym_LBRACK_PIPE] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(229),
    [anon_sym_LT_AT] = ACTIONS(229),
    [anon_sym_LT_AT_AT] = ACTIONS(229),
    [anon_sym_DOT] = ACTIONS(493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(227),
    [anon_sym_new] = ACTIONS(229),
    [anon_sym_return_BANG] = ACTIONS(227),
    [anon_sym_yield] = ACTIONS(229),
    [anon_sym_yield_BANG] = ACTIONS(227),
    [anon_sym_lazy] = ACTIONS(229),
    [anon_sym_assert] = ACTIONS(229),
    [anon_sym_upcast] = ACTIONS(229),
    [anon_sym_downcast] = ACTIONS(229),
    [anon_sym_COLON_GT] = ACTIONS(227),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_fun] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(229),
    [anon_sym_match_BANG] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(229),
    [anon_sym_LT_DASH] = ACTIONS(229),
    [anon_sym_DOT_LBRACK] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_use] = ACTIONS(229),
    [anon_sym_use_BANG] = ACTIONS(227),
    [anon_sym_do_BANG] = ACTIONS(227),
    [anon_sym_begin] = ACTIONS(229),
    [anon_sym_LPAREN2] = ACTIONS(529),
    [anon_sym_or] = ACTIONS(229),
    [aux_sym_char_token1] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_AT_DQUOTE] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [sym_bool] = ACTIONS(229),
    [sym_unit] = ACTIONS(545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(229),
    [sym_op_identifier] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(229),
    [anon_sym_PLUS_DOT] = ACTIONS(229),
    [anon_sym_DASH_DOT] = ACTIONS(229),
    [anon_sym_PERCENT] = ACTIONS(229),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(227),
    [aux_sym_prefix_op_token1] = ACTIONS(229),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token2] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(229),
    [anon_sym_BANG_EQ] = ACTIONS(229),
    [anon_sym_COLON_EQ] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(229),
    [sym_int] = ACTIONS(229),
    [sym_xint] = ACTIONS(227),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(227),
    [sym__newline] = ACTIONS(227),
    [sym__dedent] = ACTIONS(227),
  },
  [242] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(242),
    [sym_compiler_directive_decl] = STATE(242),
    [sym_fsi_directive_decl] = STATE(242),
    [sym_preproc_line] = STATE(242),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_with] = ACTIONS(123),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(119),
    [sym__dedent] = ACTIONS(119),
  },
  [243] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(243),
    [sym_compiler_directive_decl] = STATE(243),
    [sym_fsi_directive_decl] = STATE(243),
    [sym_preproc_line] = STATE(243),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_to] = ACTIONS(1486),
    [anon_sym_downto] = ACTIONS(1486),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [244] = {
    [sym_function_or_value_defn] = STATE(1180),
    [sym__expression] = STATE(239),
    [sym_literal_expression] = STATE(3145),
    [sym_long_identifier_or_op] = STATE(3145),
    [sym_tuple_expression] = STATE(3145),
    [sym_brace_expression] = STATE(3145),
    [sym_anon_record_expression] = STATE(3145),
    [sym_prefixed_expression] = STATE(3145),
    [sym_typecast_expression] = STATE(3145),
    [sym_for_expression] = STATE(3145),
    [sym_while_expression] = STATE(3145),
    [sym__if_branch] = STATE(10360),
    [sym_if_expression] = STATE(3145),
    [sym_fun_expression] = STATE(3145),
    [sym_try_expression] = STATE(3145),
    [sym_match_expression] = STATE(3145),
    [sym_function_expression] = STATE(3145),
    [sym_mutate_expression] = STATE(3145),
    [sym_index_expression] = STATE(3145),
    [sym_typed_expression] = STATE(3145),
    [sym_declaration_expression] = STATE(3145),
    [sym_do_expression] = STATE(3145),
    [sym_list_expression] = STATE(3145),
    [sym_array_expression] = STATE(3145),
    [sym_begin_end_expression] = STATE(3145),
    [sym_paren_expression] = STATE(3145),
    [sym__high_prec_app] = STATE(3141),
    [sym__low_prec_app] = STATE(3141),
    [sym_application_expression] = STATE(3145),
    [sym_dot_expression] = STATE(3145),
    [sym_infix_expression] = STATE(3145),
    [sym_ce_expression] = STATE(3145),
    [sym_sequential_expression] = STATE(3145),
    [sym_char] = STATE(3108),
    [sym_format_string] = STATE(3193),
    [sym__string_literal] = STATE(3193),
    [sym_string] = STATE(3108),
    [sym_verbatim_string] = STATE(3108),
    [sym_bytearray] = STATE(3108),
    [sym_verbatim_bytearray] = STATE(3108),
    [sym_format_triple_quoted_string] = STATE(3192),
    [sym_triple_quoted_string] = STATE(3108),
    [sym_const] = STATE(3145),
    [sym_long_identifier] = STATE(3102),
    [sym_active_pattern] = STATE(3172),
    [sym__identifier_or_op] = STATE(3103),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1149),
    [sym_infix_op] = STATE(912),
    [sym_sbyte] = STATE(3108),
    [sym_byte] = STATE(3108),
    [sym_int16] = STATE(3108),
    [sym_uint16] = STATE(3108),
    [sym_int32] = STATE(3108),
    [sym_uint32] = STATE(3108),
    [sym_nativeint] = STATE(3108),
    [sym_unativeint] = STATE(3108),
    [sym_int64] = STATE(3108),
    [sym_uint64] = STATE(3108),
    [sym_ieee32] = STATE(3108),
    [sym_ieee64] = STATE(3108),
    [sym_bignum] = STATE(3108),
    [sym_decimal] = STATE(3108),
    [sym_float] = STATE(2770),
    [sym_block_comment] = STATE(244),
    [sym_compiler_directive_decl] = STATE(244),
    [sym_fsi_directive_decl] = STATE(244),
    [sym_preproc_line] = STATE(244),
    [sym_preproc_if_in_expression] = STATE(3145),
    [aux_sym_sequential_expression_repeat1] = STATE(2846),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1117),
    [anon_sym_return] = ACTIONS(1119),
    [anon_sym_do] = ACTIONS(1121),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(245),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1125),
    [anon_sym_null] = ACTIONS(1127),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1117),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1131),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_LT_AT] = ACTIONS(1135),
    [anon_sym_LT_AT_AT] = ACTIONS(1137),
    [anon_sym_DOT] = ACTIONS(1139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1141),
    [anon_sym_new] = ACTIONS(1119),
    [anon_sym_with] = ACTIONS(245),
    [anon_sym_return_BANG] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1119),
    [anon_sym_yield_BANG] = ACTIONS(1143),
    [anon_sym_lazy] = ACTIONS(1119),
    [anon_sym_assert] = ACTIONS(1119),
    [anon_sym_upcast] = ACTIONS(1119),
    [anon_sym_downcast] = ACTIONS(1119),
    [anon_sym_COLON_GT] = ACTIONS(1145),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1145),
    [anon_sym_for] = ACTIONS(1147),
    [anon_sym_while] = ACTIONS(1149),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1151),
    [anon_sym_try] = ACTIONS(1153),
    [anon_sym_match] = ACTIONS(1155),
    [anon_sym_match_BANG] = ACTIONS(1157),
    [anon_sym_function] = ACTIONS(1159),
    [anon_sym_LT_DASH] = ACTIONS(1161),
    [anon_sym_DOT_LBRACK] = ACTIONS(1163),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_use] = ACTIONS(1167),
    [anon_sym_use_BANG] = ACTIONS(1169),
    [anon_sym_do_BANG] = ACTIONS(1171),
    [anon_sym_begin] = ACTIONS(1173),
    [anon_sym_LPAREN2] = ACTIONS(1175),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1177),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(1181),
    [anon_sym_AT_DQUOTE] = ACTIONS(1183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1185),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1187),
    [sym_bool] = ACTIONS(1189),
    [sym_unit] = ACTIONS(1191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1193),
    [sym_op_identifier] = ACTIONS(1195),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1197),
    [sym_xint] = ACTIONS(1199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1201),
    [sym__newline] = ACTIONS(243),
  },
  [245] = {
    [sym_function_or_value_defn] = STATE(1180),
    [sym__expression] = STATE(239),
    [sym_literal_expression] = STATE(3145),
    [sym_long_identifier_or_op] = STATE(3145),
    [sym_tuple_expression] = STATE(3145),
    [sym_brace_expression] = STATE(3145),
    [sym_anon_record_expression] = STATE(3145),
    [sym_prefixed_expression] = STATE(3145),
    [sym_typecast_expression] = STATE(3145),
    [sym_for_expression] = STATE(3145),
    [sym_while_expression] = STATE(3145),
    [sym__if_branch] = STATE(10360),
    [sym_if_expression] = STATE(3145),
    [sym_fun_expression] = STATE(3145),
    [sym_try_expression] = STATE(3145),
    [sym_match_expression] = STATE(3145),
    [sym_function_expression] = STATE(3145),
    [sym_mutate_expression] = STATE(3145),
    [sym_index_expression] = STATE(3145),
    [sym_typed_expression] = STATE(3145),
    [sym_declaration_expression] = STATE(3145),
    [sym_do_expression] = STATE(3145),
    [sym_list_expression] = STATE(3145),
    [sym_array_expression] = STATE(3145),
    [sym_begin_end_expression] = STATE(3145),
    [sym_paren_expression] = STATE(3145),
    [sym__high_prec_app] = STATE(3141),
    [sym__low_prec_app] = STATE(3141),
    [sym_application_expression] = STATE(3145),
    [sym_dot_expression] = STATE(3145),
    [sym_infix_expression] = STATE(3145),
    [sym_ce_expression] = STATE(3145),
    [sym_sequential_expression] = STATE(3145),
    [sym_char] = STATE(3108),
    [sym_format_string] = STATE(3193),
    [sym__string_literal] = STATE(3193),
    [sym_string] = STATE(3108),
    [sym_verbatim_string] = STATE(3108),
    [sym_bytearray] = STATE(3108),
    [sym_verbatim_bytearray] = STATE(3108),
    [sym_format_triple_quoted_string] = STATE(3192),
    [sym_triple_quoted_string] = STATE(3108),
    [sym_const] = STATE(3145),
    [sym_long_identifier] = STATE(3102),
    [sym_active_pattern] = STATE(3172),
    [sym__identifier_or_op] = STATE(3103),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1149),
    [sym_infix_op] = STATE(912),
    [sym_sbyte] = STATE(3108),
    [sym_byte] = STATE(3108),
    [sym_int16] = STATE(3108),
    [sym_uint16] = STATE(3108),
    [sym_int32] = STATE(3108),
    [sym_uint32] = STATE(3108),
    [sym_nativeint] = STATE(3108),
    [sym_unativeint] = STATE(3108),
    [sym_int64] = STATE(3108),
    [sym_uint64] = STATE(3108),
    [sym_ieee32] = STATE(3108),
    [sym_ieee64] = STATE(3108),
    [sym_bignum] = STATE(3108),
    [sym_decimal] = STATE(3108),
    [sym_float] = STATE(2770),
    [sym_block_comment] = STATE(245),
    [sym_compiler_directive_decl] = STATE(245),
    [sym_fsi_directive_decl] = STATE(245),
    [sym_preproc_line] = STATE(245),
    [sym_preproc_if_in_expression] = STATE(3145),
    [aux_sym_sequential_expression_repeat1] = STATE(2846),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_EQ] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(229),
    [anon_sym_return] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_let] = ACTIONS(229),
    [anon_sym_let_BANG] = ACTIONS(227),
    [anon_sym_as] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(227),
    [anon_sym_null] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_COLON_QMARK] = ACTIONS(229),
    [anon_sym_COLON_COLON] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_LBRACK] = ACTIONS(229),
    [anon_sym_LBRACK_PIPE] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(229),
    [anon_sym_LT_AT] = ACTIONS(229),
    [anon_sym_LT_AT_AT] = ACTIONS(229),
    [anon_sym_DOT] = ACTIONS(1139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(227),
    [anon_sym_new] = ACTIONS(229),
    [anon_sym_with] = ACTIONS(229),
    [anon_sym_return_BANG] = ACTIONS(227),
    [anon_sym_yield] = ACTIONS(229),
    [anon_sym_yield_BANG] = ACTIONS(227),
    [anon_sym_lazy] = ACTIONS(229),
    [anon_sym_assert] = ACTIONS(229),
    [anon_sym_upcast] = ACTIONS(229),
    [anon_sym_downcast] = ACTIONS(229),
    [anon_sym_COLON_GT] = ACTIONS(227),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_fun] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(229),
    [anon_sym_match_BANG] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(229),
    [anon_sym_LT_DASH] = ACTIONS(229),
    [anon_sym_DOT_LBRACK] = ACTIONS(1163),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_use] = ACTIONS(229),
    [anon_sym_use_BANG] = ACTIONS(227),
    [anon_sym_do_BANG] = ACTIONS(227),
    [anon_sym_begin] = ACTIONS(229),
    [anon_sym_LPAREN2] = ACTIONS(1175),
    [anon_sym_or] = ACTIONS(229),
    [aux_sym_char_token1] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_AT_DQUOTE] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [sym_bool] = ACTIONS(229),
    [sym_unit] = ACTIONS(1191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(229),
    [sym_op_identifier] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(229),
    [anon_sym_PLUS_DOT] = ACTIONS(229),
    [anon_sym_DASH_DOT] = ACTIONS(229),
    [anon_sym_PERCENT] = ACTIONS(229),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(227),
    [aux_sym_prefix_op_token1] = ACTIONS(229),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token2] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(229),
    [anon_sym_BANG_EQ] = ACTIONS(229),
    [anon_sym_COLON_EQ] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(229),
    [sym_int] = ACTIONS(229),
    [sym_xint] = ACTIONS(227),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(227),
    [sym__newline] = ACTIONS(227),
  },
  [246] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(246),
    [sym_compiler_directive_decl] = STATE(246),
    [sym_fsi_directive_decl] = STATE(246),
    [sym_preproc_line] = STATE(246),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(255),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_with] = ACTIONS(255),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(253),
    [sym__dedent] = ACTIONS(253),
  },
  [247] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(176),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(887),
    [sym_infix_op] = STATE(803),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(247),
    [sym_compiler_directive_decl] = STATE(247),
    [sym_fsi_directive_decl] = STATE(247),
    [sym_preproc_line] = STATE(247),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2961),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_EQ] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(229),
    [anon_sym_return] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_let] = ACTIONS(229),
    [anon_sym_let_BANG] = ACTIONS(227),
    [anon_sym_LPAREN] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(227),
    [anon_sym_null] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_COLON_QMARK] = ACTIONS(229),
    [anon_sym_COLON_COLON] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_LBRACK] = ACTIONS(229),
    [anon_sym_RBRACK] = ACTIONS(227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(229),
    [anon_sym_LT_AT] = ACTIONS(229),
    [anon_sym_LT_AT_AT] = ACTIONS(229),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(227),
    [anon_sym_new] = ACTIONS(229),
    [anon_sym_return_BANG] = ACTIONS(227),
    [anon_sym_yield] = ACTIONS(229),
    [anon_sym_yield_BANG] = ACTIONS(227),
    [anon_sym_lazy] = ACTIONS(229),
    [anon_sym_assert] = ACTIONS(229),
    [anon_sym_upcast] = ACTIONS(229),
    [anon_sym_downcast] = ACTIONS(229),
    [anon_sym_COLON_GT] = ACTIONS(227),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_fun] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(229),
    [anon_sym_match_BANG] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(229),
    [anon_sym_LT_DASH] = ACTIONS(229),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(229),
    [anon_sym_use_BANG] = ACTIONS(227),
    [anon_sym_do_BANG] = ACTIONS(227),
    [anon_sym_begin] = ACTIONS(229),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_DOT_DOT2] = ACTIONS(227),
    [anon_sym_or] = ACTIONS(229),
    [aux_sym_char_token1] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_AT_DQUOTE] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [sym_bool] = ACTIONS(229),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(229),
    [sym_op_identifier] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(229),
    [anon_sym_PLUS_DOT] = ACTIONS(229),
    [anon_sym_DASH_DOT] = ACTIONS(229),
    [anon_sym_PERCENT] = ACTIONS(229),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(227),
    [aux_sym_prefix_op_token1] = ACTIONS(229),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token2] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(229),
    [anon_sym_BANG_EQ] = ACTIONS(229),
    [anon_sym_COLON_EQ] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(229),
    [sym_int] = ACTIONS(229),
    [sym_xint] = ACTIONS(227),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(227),
    [sym__newline] = ACTIONS(227),
  },
  [248] = {
    [sym_function_or_value_defn] = STATE(1180),
    [sym__expression] = STATE(239),
    [sym_literal_expression] = STATE(3145),
    [sym_long_identifier_or_op] = STATE(3145),
    [sym_tuple_expression] = STATE(3145),
    [sym_brace_expression] = STATE(3145),
    [sym_anon_record_expression] = STATE(3145),
    [sym_prefixed_expression] = STATE(3145),
    [sym_typecast_expression] = STATE(3145),
    [sym_for_expression] = STATE(3145),
    [sym_while_expression] = STATE(3145),
    [sym__if_branch] = STATE(10360),
    [sym_if_expression] = STATE(3145),
    [sym_fun_expression] = STATE(3145),
    [sym_try_expression] = STATE(3145),
    [sym_match_expression] = STATE(3145),
    [sym_function_expression] = STATE(3145),
    [sym_mutate_expression] = STATE(3145),
    [sym_index_expression] = STATE(3145),
    [sym_typed_expression] = STATE(3145),
    [sym_declaration_expression] = STATE(3145),
    [sym_do_expression] = STATE(3145),
    [sym_list_expression] = STATE(3145),
    [sym_array_expression] = STATE(3145),
    [sym_begin_end_expression] = STATE(3145),
    [sym_paren_expression] = STATE(3145),
    [sym__high_prec_app] = STATE(3141),
    [sym__low_prec_app] = STATE(3141),
    [sym_application_expression] = STATE(3145),
    [sym_dot_expression] = STATE(3145),
    [sym_infix_expression] = STATE(3145),
    [sym_ce_expression] = STATE(3145),
    [sym_sequential_expression] = STATE(3145),
    [sym_char] = STATE(3108),
    [sym_format_string] = STATE(3193),
    [sym__string_literal] = STATE(3193),
    [sym_string] = STATE(3108),
    [sym_verbatim_string] = STATE(3108),
    [sym_bytearray] = STATE(3108),
    [sym_verbatim_bytearray] = STATE(3108),
    [sym_format_triple_quoted_string] = STATE(3192),
    [sym_triple_quoted_string] = STATE(3108),
    [sym_const] = STATE(3145),
    [sym_long_identifier] = STATE(3102),
    [sym_active_pattern] = STATE(3172),
    [sym__identifier_or_op] = STATE(3103),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1149),
    [sym_infix_op] = STATE(912),
    [sym_sbyte] = STATE(3108),
    [sym_byte] = STATE(3108),
    [sym_int16] = STATE(3108),
    [sym_uint16] = STATE(3108),
    [sym_int32] = STATE(3108),
    [sym_uint32] = STATE(3108),
    [sym_nativeint] = STATE(3108),
    [sym_unativeint] = STATE(3108),
    [sym_int64] = STATE(3108),
    [sym_uint64] = STATE(3108),
    [sym_ieee32] = STATE(3108),
    [sym_ieee64] = STATE(3108),
    [sym_bignum] = STATE(3108),
    [sym_decimal] = STATE(3108),
    [sym_float] = STATE(2770),
    [sym_block_comment] = STATE(248),
    [sym_compiler_directive_decl] = STATE(248),
    [sym_fsi_directive_decl] = STATE(248),
    [sym_preproc_line] = STATE(248),
    [sym_preproc_if_in_expression] = STATE(3145),
    [aux_sym_sequential_expression_repeat1] = STATE(2846),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1117),
    [anon_sym_return] = ACTIONS(1119),
    [anon_sym_do] = ACTIONS(1121),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1125),
    [anon_sym_null] = ACTIONS(1127),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1117),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1131),
    [anon_sym_LBRACE] = ACTIONS(1133),
    [anon_sym_LT_AT] = ACTIONS(1135),
    [anon_sym_LT_AT_AT] = ACTIONS(1137),
    [anon_sym_DOT] = ACTIONS(1139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1141),
    [anon_sym_new] = ACTIONS(1119),
    [anon_sym_with] = ACTIONS(123),
    [anon_sym_return_BANG] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1119),
    [anon_sym_yield_BANG] = ACTIONS(1143),
    [anon_sym_lazy] = ACTIONS(1119),
    [anon_sym_assert] = ACTIONS(1119),
    [anon_sym_upcast] = ACTIONS(1119),
    [anon_sym_downcast] = ACTIONS(1119),
    [anon_sym_COLON_GT] = ACTIONS(1145),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1145),
    [anon_sym_for] = ACTIONS(1147),
    [anon_sym_while] = ACTIONS(1149),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1151),
    [anon_sym_try] = ACTIONS(1153),
    [anon_sym_match] = ACTIONS(1155),
    [anon_sym_match_BANG] = ACTIONS(1157),
    [anon_sym_function] = ACTIONS(1159),
    [anon_sym_LT_DASH] = ACTIONS(1161),
    [anon_sym_DOT_LBRACK] = ACTIONS(1163),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_use] = ACTIONS(1167),
    [anon_sym_use_BANG] = ACTIONS(1169),
    [anon_sym_do_BANG] = ACTIONS(1171),
    [anon_sym_begin] = ACTIONS(1173),
    [anon_sym_LPAREN2] = ACTIONS(1175),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1177),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(1181),
    [anon_sym_AT_DQUOTE] = ACTIONS(1183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1185),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1187),
    [sym_bool] = ACTIONS(1189),
    [sym_unit] = ACTIONS(1191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1193),
    [sym_op_identifier] = ACTIONS(1195),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1197),
    [sym_xint] = ACTIONS(1199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1201),
    [sym__newline] = ACTIONS(119),
  },
  [249] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(249),
    [sym_compiler_directive_decl] = STATE(249),
    [sym_fsi_directive_decl] = STATE(249),
    [sym_preproc_line] = STATE(249),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(1488),
  },
  [250] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(250),
    [sym_compiler_directive_decl] = STATE(250),
    [sym_fsi_directive_decl] = STATE(250),
    [sym_preproc_line] = STATE(250),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(1490),
  },
  [251] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(251),
    [sym_compiler_directive_decl] = STATE(251),
    [sym_fsi_directive_decl] = STATE(251),
    [sym_preproc_line] = STATE(251),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1436),
    [sym__dedent] = ACTIONS(1436),
  },
  [252] = {
    [sym_function_or_value_defn] = STATE(1099),
    [sym__expression] = STATE(422),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1020),
    [sym_infix_op] = STATE(1104),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(2924),
    [sym_block_comment] = STATE(252),
    [sym_compiler_directive_decl] = STATE(252),
    [sym_fsi_directive_decl] = STATE(252),
    [sym_preproc_line] = STATE(252),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_sequential_expression_repeat1] = STATE(3001),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(1494),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(649),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(667),
    [anon_sym_DOT] = ACTIONS(669),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(1492),
    [anon_sym_return_BANG] = ACTIONS(1496),
    [anon_sym_yield] = ACTIONS(1492),
    [anon_sym_yield_BANG] = ACTIONS(1496),
    [anon_sym_lazy] = ACTIONS(1492),
    [anon_sym_assert] = ACTIONS(1492),
    [anon_sym_upcast] = ACTIONS(1492),
    [anon_sym_downcast] = ACTIONS(1492),
    [anon_sym_COLON_GT] = ACTIONS(675),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_LT_DASH] = ACTIONS(1498),
    [anon_sym_DOT_LBRACK] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_use] = ACTIONS(1500),
    [anon_sym_use_BANG] = ACTIONS(1502),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [anon_sym_LPAREN2] = ACTIONS(705),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(721),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1504),
    [sym_xint] = ACTIONS(1506),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
    [anon_sym_POUNDendif] = ACTIONS(1470),
    [sym__newline] = ACTIONS(1508),
  },
  [253] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(253),
    [sym_compiler_directive_decl] = STATE(253),
    [sym_fsi_directive_decl] = STATE(253),
    [sym_preproc_line] = STATE(253),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(1510),
  },
  [254] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(346),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(890),
    [sym_infix_op] = STATE(904),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(254),
    [sym_compiler_directive_decl] = STATE(254),
    [sym_fsi_directive_decl] = STATE(254),
    [sym_preproc_line] = STATE(254),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_sequential_expression_repeat1] = STATE(3140),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_COMMA] = ACTIONS(1522),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1514),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_AT_GT] = ACTIONS(245),
    [anon_sym_LT_AT_AT] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1534),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_COLON_GT] = ACTIONS(1540),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_LT_DASH] = ACTIONS(1556),
    [anon_sym_DOT_LBRACK] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [anon_sym_LPAREN2] = ACTIONS(1570),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(1586),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(1590),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
    [sym__newline] = ACTIONS(243),
  },
  [255] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(255),
    [sym_compiler_directive_decl] = STATE(255),
    [sym_fsi_directive_decl] = STATE(255),
    [sym_preproc_line] = STATE(255),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_GT_RBRACK] = ACTIONS(1598),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(1598),
  },
  [256] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(471),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1045),
    [sym_infix_op] = STATE(886),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(256),
    [sym_compiler_directive_decl] = STATE(256),
    [sym_fsi_directive_decl] = STATE(256),
    [sym_preproc_line] = STATE(256),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(3142),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1600),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1604),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1600),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_COLON_GT] = ACTIONS(1608),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1608),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(1612),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1614),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(1622),
  },
  [257] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(471),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1045),
    [sym_infix_op] = STATE(886),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(257),
    [sym_compiler_directive_decl] = STATE(257),
    [sym_fsi_directive_decl] = STATE(257),
    [sym_preproc_line] = STATE(257),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(3142),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1600),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1604),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1600),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_COLON_GT] = ACTIONS(1608),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1608),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(1624),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1614),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(1622),
  },
  [258] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(258),
    [sym_compiler_directive_decl] = STATE(258),
    [sym_fsi_directive_decl] = STATE(258),
    [sym_preproc_line] = STATE(258),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(1626),
  },
  [259] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(259),
    [sym_compiler_directive_decl] = STATE(259),
    [sym_fsi_directive_decl] = STATE(259),
    [sym_preproc_line] = STATE(259),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(1628),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(1630),
  },
  [260] = {
    [sym_function_or_value_defn] = STATE(783),
    [sym__expression] = STATE(338),
    [sym_literal_expression] = STATE(3553),
    [sym_long_identifier_or_op] = STATE(3553),
    [sym_tuple_expression] = STATE(3553),
    [sym_brace_expression] = STATE(3553),
    [sym_anon_record_expression] = STATE(3553),
    [sym_prefixed_expression] = STATE(3553),
    [sym_typecast_expression] = STATE(3553),
    [sym_for_expression] = STATE(3553),
    [sym_while_expression] = STATE(3553),
    [sym__if_branch] = STATE(10567),
    [sym_if_expression] = STATE(3553),
    [sym_fun_expression] = STATE(3553),
    [sym_try_expression] = STATE(3553),
    [sym_match_expression] = STATE(3553),
    [sym_function_expression] = STATE(3553),
    [sym_mutate_expression] = STATE(3553),
    [sym_index_expression] = STATE(3553),
    [sym_typed_expression] = STATE(3553),
    [sym_declaration_expression] = STATE(3553),
    [sym_do_expression] = STATE(3553),
    [sym_list_expression] = STATE(3553),
    [sym_array_expression] = STATE(3553),
    [sym_begin_end_expression] = STATE(3553),
    [sym_paren_expression] = STATE(3553),
    [sym__high_prec_app] = STATE(3532),
    [sym__low_prec_app] = STATE(3532),
    [sym_application_expression] = STATE(3553),
    [sym_dot_expression] = STATE(3553),
    [sym_infix_expression] = STATE(3553),
    [sym_ce_expression] = STATE(3553),
    [sym_sequential_expression] = STATE(3553),
    [sym_char] = STATE(3265),
    [sym_format_string] = STATE(3261),
    [sym__string_literal] = STATE(3261),
    [sym_string] = STATE(3265),
    [sym_verbatim_string] = STATE(3265),
    [sym_bytearray] = STATE(3265),
    [sym_verbatim_bytearray] = STATE(3265),
    [sym_format_triple_quoted_string] = STATE(3260),
    [sym_triple_quoted_string] = STATE(3265),
    [sym_const] = STATE(3553),
    [sym_long_identifier] = STATE(3203),
    [sym_active_pattern] = STATE(3576),
    [sym__identifier_or_op] = STATE(3362),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1076),
    [sym_infix_op] = STATE(975),
    [sym_sbyte] = STATE(3265),
    [sym_byte] = STATE(3265),
    [sym_int16] = STATE(3265),
    [sym_uint16] = STATE(3265),
    [sym_int32] = STATE(3265),
    [sym_uint32] = STATE(3265),
    [sym_nativeint] = STATE(3265),
    [sym_unativeint] = STATE(3265),
    [sym_int64] = STATE(3265),
    [sym_uint64] = STATE(3265),
    [sym_ieee32] = STATE(3265),
    [sym_ieee64] = STATE(3265),
    [sym_bignum] = STATE(3265),
    [sym_decimal] = STATE(3265),
    [sym_float] = STATE(2797),
    [sym_block_comment] = STATE(260),
    [sym_compiler_directive_decl] = STATE(260),
    [sym_fsi_directive_decl] = STATE(260),
    [sym_preproc_line] = STATE(260),
    [sym_preproc_if_in_expression] = STATE(3553),
    [aux_sym_sequential_expression_repeat1] = STATE(3067),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1632),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1634),
    [anon_sym_return] = ACTIONS(1636),
    [anon_sym_do] = ACTIONS(1638),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1640),
    [anon_sym_COMMA] = ACTIONS(1642),
    [anon_sym_null] = ACTIONS(1644),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1634),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1646),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1650),
    [anon_sym_LT_AT] = ACTIONS(1652),
    [anon_sym_LT_AT_AT] = ACTIONS(1654),
    [anon_sym_DOT] = ACTIONS(1656),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1658),
    [anon_sym_new] = ACTIONS(1636),
    [anon_sym_return_BANG] = ACTIONS(1660),
    [anon_sym_yield] = ACTIONS(1636),
    [anon_sym_yield_BANG] = ACTIONS(1660),
    [anon_sym_lazy] = ACTIONS(1636),
    [anon_sym_assert] = ACTIONS(1636),
    [anon_sym_upcast] = ACTIONS(1636),
    [anon_sym_downcast] = ACTIONS(1636),
    [anon_sym_COLON_GT] = ACTIONS(1662),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1662),
    [anon_sym_for] = ACTIONS(1664),
    [anon_sym_while] = ACTIONS(1666),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1668),
    [anon_sym_try] = ACTIONS(1670),
    [anon_sym_match] = ACTIONS(1672),
    [anon_sym_match_BANG] = ACTIONS(1674),
    [anon_sym_function] = ACTIONS(1676),
    [anon_sym_LT_DASH] = ACTIONS(1678),
    [anon_sym_DOT_LBRACK] = ACTIONS(1680),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(233),
    [anon_sym_use] = ACTIONS(1684),
    [anon_sym_use_BANG] = ACTIONS(1686),
    [anon_sym_do_BANG] = ACTIONS(1688),
    [anon_sym_begin] = ACTIONS(1690),
    [anon_sym_LPAREN2] = ACTIONS(1692),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1694),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1696),
    [anon_sym_DQUOTE] = ACTIONS(1698),
    [anon_sym_AT_DQUOTE] = ACTIONS(1700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1704),
    [sym_bool] = ACTIONS(1706),
    [sym_unit] = ACTIONS(1708),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1710),
    [sym_op_identifier] = ACTIONS(1712),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1714),
    [sym_xint] = ACTIONS(1716),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1718),
    [sym__newline] = ACTIONS(1720),
  },
  [261] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(358),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1151),
    [sym_infix_op] = STATE(1064),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(261),
    [sym_compiler_directive_decl] = STATE(261),
    [sym_fsi_directive_decl] = STATE(261),
    [sym_preproc_line] = STATE(261),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_sequential_expression_repeat1] = STATE(3119),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1728),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1724),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(1744),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_COLON_GT] = ACTIONS(1752),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_LT_DASH] = ACTIONS(1768),
    [anon_sym_DOT_LBRACK] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_DOT_DOT] = ACTIONS(1780),
    [anon_sym_begin] = ACTIONS(1782),
    [anon_sym_LPAREN2] = ACTIONS(1784),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(1800),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(1804),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
    [sym__newline] = ACTIONS(1812),
  },
  [262] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(358),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1151),
    [sym_infix_op] = STATE(1064),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(262),
    [sym_compiler_directive_decl] = STATE(262),
    [sym_fsi_directive_decl] = STATE(262),
    [sym_preproc_line] = STATE(262),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_sequential_expression_repeat1] = STATE(3119),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1814),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1724),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(1744),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_COLON_GT] = ACTIONS(1752),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_LT_DASH] = ACTIONS(1768),
    [anon_sym_DOT_LBRACK] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_DOT_DOT] = ACTIONS(1780),
    [anon_sym_begin] = ACTIONS(1782),
    [anon_sym_LPAREN2] = ACTIONS(1784),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(1800),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(1804),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
    [sym__newline] = ACTIONS(1812),
  },
  [263] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(263),
    [sym_compiler_directive_decl] = STATE(263),
    [sym_fsi_directive_decl] = STATE(263),
    [sym_preproc_line] = STATE(263),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1816),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(1816),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [264] = {
    [sym_function_or_value_defn] = STATE(1099),
    [sym__expression] = STATE(422),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1020),
    [sym_infix_op] = STATE(1104),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(2924),
    [sym_block_comment] = STATE(264),
    [sym_compiler_directive_decl] = STATE(264),
    [sym_fsi_directive_decl] = STATE(264),
    [sym_preproc_line] = STATE(264),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_sequential_expression_repeat1] = STATE(3001),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(1494),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(649),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(667),
    [anon_sym_DOT] = ACTIONS(669),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(1492),
    [anon_sym_return_BANG] = ACTIONS(1496),
    [anon_sym_yield] = ACTIONS(1492),
    [anon_sym_yield_BANG] = ACTIONS(1496),
    [anon_sym_lazy] = ACTIONS(1492),
    [anon_sym_assert] = ACTIONS(1492),
    [anon_sym_upcast] = ACTIONS(1492),
    [anon_sym_downcast] = ACTIONS(1492),
    [anon_sym_COLON_GT] = ACTIONS(675),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_LT_DASH] = ACTIONS(1498),
    [anon_sym_DOT_LBRACK] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_use] = ACTIONS(1500),
    [anon_sym_use_BANG] = ACTIONS(1502),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [anon_sym_LPAREN2] = ACTIONS(705),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(721),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1504),
    [sym_xint] = ACTIONS(1506),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
    [anon_sym_POUNDendif] = ACTIONS(265),
    [sym__newline] = ACTIONS(1508),
  },
  [265] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(358),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1151),
    [sym_infix_op] = STATE(1064),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(265),
    [sym_compiler_directive_decl] = STATE(265),
    [sym_fsi_directive_decl] = STATE(265),
    [sym_preproc_line] = STATE(265),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_sequential_expression_repeat1] = STATE(3119),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1724),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(1744),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_COLON_GT] = ACTIONS(1752),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_LT_DASH] = ACTIONS(1768),
    [anon_sym_DOT_LBRACK] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_DOT_DOT] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(1782),
    [anon_sym_LPAREN2] = ACTIONS(1784),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(1800),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(1804),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
    [sym__newline] = ACTIONS(243),
  },
  [266] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(346),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(890),
    [sym_infix_op] = STATE(904),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(266),
    [sym_compiler_directive_decl] = STATE(266),
    [sym_fsi_directive_decl] = STATE(266),
    [sym_preproc_line] = STATE(266),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_sequential_expression_repeat1] = STATE(3140),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_COMMA] = ACTIONS(1522),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1514),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(1820),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_AT_GT] = ACTIONS(1822),
    [anon_sym_LT_AT_AT] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1534),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_COLON_GT] = ACTIONS(1540),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_LT_DASH] = ACTIONS(1556),
    [anon_sym_DOT_LBRACK] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [anon_sym_LPAREN2] = ACTIONS(1570),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(1586),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(1590),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
    [sym__newline] = ACTIONS(1824),
  },
  [267] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(309),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1022),
    [sym_infix_op] = STATE(891),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(267),
    [sym_compiler_directive_decl] = STATE(267),
    [sym_fsi_directive_decl] = STATE(267),
    [sym_preproc_line] = STATE(267),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_sequential_expression_repeat1] = STATE(2972),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_COMMA] = ACTIONS(1836),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(1848),
    [anon_sym_AT_AT_GT] = ACTIONS(1822),
    [anon_sym_DOT] = ACTIONS(1850),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_COLON_GT] = ACTIONS(1856),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1856),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_LT_DASH] = ACTIONS(1872),
    [anon_sym_DOT_LBRACK] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [anon_sym_LPAREN2] = ACTIONS(1886),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(1902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(1906),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
    [sym__newline] = ACTIONS(1914),
  },
  [268] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(268),
    [sym_compiler_directive_decl] = STATE(268),
    [sym_fsi_directive_decl] = STATE(268),
    [sym_preproc_line] = STATE(268),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1916),
    [sym__dedent] = ACTIONS(1916),
  },
  [269] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(269),
    [sym_compiler_directive_decl] = STATE(269),
    [sym_fsi_directive_decl] = STATE(269),
    [sym_preproc_line] = STATE(269),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(1918),
  },
  [270] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(270),
    [sym_compiler_directive_decl] = STATE(270),
    [sym_fsi_directive_decl] = STATE(270),
    [sym_preproc_line] = STATE(270),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(1920),
  },
  [271] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(471),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1045),
    [sym_infix_op] = STATE(886),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(271),
    [sym_compiler_directive_decl] = STATE(271),
    [sym_fsi_directive_decl] = STATE(271),
    [sym_preproc_line] = STATE(271),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(3142),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1600),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1604),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1600),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_COLON_GT] = ACTIONS(1608),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1608),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(1922),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1614),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(1622),
  },
  [272] = {
    [sym_function_or_value_defn] = STATE(783),
    [sym__expression] = STATE(338),
    [sym_literal_expression] = STATE(3553),
    [sym_long_identifier_or_op] = STATE(3553),
    [sym_tuple_expression] = STATE(3553),
    [sym_brace_expression] = STATE(3553),
    [sym_anon_record_expression] = STATE(3553),
    [sym_prefixed_expression] = STATE(3553),
    [sym_typecast_expression] = STATE(3553),
    [sym_for_expression] = STATE(3553),
    [sym_while_expression] = STATE(3553),
    [sym__if_branch] = STATE(10567),
    [sym_if_expression] = STATE(3553),
    [sym_fun_expression] = STATE(3553),
    [sym_try_expression] = STATE(3553),
    [sym_match_expression] = STATE(3553),
    [sym_function_expression] = STATE(3553),
    [sym_mutate_expression] = STATE(3553),
    [sym_index_expression] = STATE(3553),
    [sym_typed_expression] = STATE(3553),
    [sym_declaration_expression] = STATE(3553),
    [sym_do_expression] = STATE(3553),
    [sym_list_expression] = STATE(3553),
    [sym_array_expression] = STATE(3553),
    [sym_begin_end_expression] = STATE(3553),
    [sym_paren_expression] = STATE(3553),
    [sym__high_prec_app] = STATE(3532),
    [sym__low_prec_app] = STATE(3532),
    [sym_application_expression] = STATE(3553),
    [sym_dot_expression] = STATE(3553),
    [sym_infix_expression] = STATE(3553),
    [sym_ce_expression] = STATE(3553),
    [sym_sequential_expression] = STATE(3553),
    [sym_char] = STATE(3265),
    [sym_format_string] = STATE(3261),
    [sym__string_literal] = STATE(3261),
    [sym_string] = STATE(3265),
    [sym_verbatim_string] = STATE(3265),
    [sym_bytearray] = STATE(3265),
    [sym_verbatim_bytearray] = STATE(3265),
    [sym_format_triple_quoted_string] = STATE(3260),
    [sym_triple_quoted_string] = STATE(3265),
    [sym_const] = STATE(3553),
    [sym_long_identifier] = STATE(3203),
    [sym_active_pattern] = STATE(3576),
    [sym__identifier_or_op] = STATE(3362),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1076),
    [sym_infix_op] = STATE(975),
    [sym_sbyte] = STATE(3265),
    [sym_byte] = STATE(3265),
    [sym_int16] = STATE(3265),
    [sym_uint16] = STATE(3265),
    [sym_int32] = STATE(3265),
    [sym_uint32] = STATE(3265),
    [sym_nativeint] = STATE(3265),
    [sym_unativeint] = STATE(3265),
    [sym_int64] = STATE(3265),
    [sym_uint64] = STATE(3265),
    [sym_ieee32] = STATE(3265),
    [sym_ieee64] = STATE(3265),
    [sym_bignum] = STATE(3265),
    [sym_decimal] = STATE(3265),
    [sym_float] = STATE(2797),
    [sym_block_comment] = STATE(272),
    [sym_compiler_directive_decl] = STATE(272),
    [sym_fsi_directive_decl] = STATE(272),
    [sym_preproc_line] = STATE(272),
    [sym_preproc_if_in_expression] = STATE(3553),
    [aux_sym_sequential_expression_repeat1] = STATE(3067),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1632),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1634),
    [anon_sym_return] = ACTIONS(1636),
    [anon_sym_do] = ACTIONS(1638),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1640),
    [anon_sym_COMMA] = ACTIONS(1642),
    [anon_sym_null] = ACTIONS(1644),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1634),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1646),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_LT_AT] = ACTIONS(1652),
    [anon_sym_LT_AT_AT] = ACTIONS(1654),
    [anon_sym_DOT] = ACTIONS(1656),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1658),
    [anon_sym_new] = ACTIONS(1636),
    [anon_sym_return_BANG] = ACTIONS(1660),
    [anon_sym_yield] = ACTIONS(1636),
    [anon_sym_yield_BANG] = ACTIONS(1660),
    [anon_sym_lazy] = ACTIONS(1636),
    [anon_sym_assert] = ACTIONS(1636),
    [anon_sym_upcast] = ACTIONS(1636),
    [anon_sym_downcast] = ACTIONS(1636),
    [anon_sym_COLON_GT] = ACTIONS(1662),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1662),
    [anon_sym_for] = ACTIONS(1664),
    [anon_sym_while] = ACTIONS(1666),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1668),
    [anon_sym_try] = ACTIONS(1670),
    [anon_sym_match] = ACTIONS(1672),
    [anon_sym_match_BANG] = ACTIONS(1674),
    [anon_sym_function] = ACTIONS(1676),
    [anon_sym_LT_DASH] = ACTIONS(1678),
    [anon_sym_DOT_LBRACK] = ACTIONS(1680),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(245),
    [anon_sym_use] = ACTIONS(1684),
    [anon_sym_use_BANG] = ACTIONS(1686),
    [anon_sym_do_BANG] = ACTIONS(1688),
    [anon_sym_begin] = ACTIONS(1690),
    [anon_sym_LPAREN2] = ACTIONS(1692),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1694),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1696),
    [anon_sym_DQUOTE] = ACTIONS(1698),
    [anon_sym_AT_DQUOTE] = ACTIONS(1700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1704),
    [sym_bool] = ACTIONS(1706),
    [sym_unit] = ACTIONS(1708),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1710),
    [sym_op_identifier] = ACTIONS(1712),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1714),
    [sym_xint] = ACTIONS(1716),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1718),
    [sym__newline] = ACTIONS(243),
  },
  [273] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(273),
    [sym_compiler_directive_decl] = STATE(273),
    [sym_fsi_directive_decl] = STATE(273),
    [sym_preproc_line] = STATE(273),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(1924),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(1926),
  },
  [274] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(274),
    [sym_compiler_directive_decl] = STATE(274),
    [sym_fsi_directive_decl] = STATE(274),
    [sym_preproc_line] = STATE(274),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(1928),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(1930),
  },
  [275] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(309),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1022),
    [sym_infix_op] = STATE(891),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(275),
    [sym_compiler_directive_decl] = STATE(275),
    [sym_fsi_directive_decl] = STATE(275),
    [sym_preproc_line] = STATE(275),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_sequential_expression_repeat1] = STATE(2972),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_COMMA] = ACTIONS(1836),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(1848),
    [anon_sym_AT_AT_GT] = ACTIONS(245),
    [anon_sym_DOT] = ACTIONS(1850),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_COLON_GT] = ACTIONS(1856),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1856),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_LT_DASH] = ACTIONS(1872),
    [anon_sym_DOT_LBRACK] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [anon_sym_LPAREN2] = ACTIONS(1886),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(1902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(1906),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
    [sym__newline] = ACTIONS(243),
  },
  [276] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(471),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1045),
    [sym_infix_op] = STATE(886),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(276),
    [sym_compiler_directive_decl] = STATE(276),
    [sym_fsi_directive_decl] = STATE(276),
    [sym_preproc_line] = STATE(276),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(3142),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1600),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1604),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1600),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_COLON_GT] = ACTIONS(1608),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1608),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(1932),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1614),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(1622),
  },
  [277] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(277),
    [sym_compiler_directive_decl] = STATE(277),
    [sym_fsi_directive_decl] = STATE(277),
    [sym_preproc_line] = STATE(277),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1934),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(1934),
  },
  [278] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(358),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1151),
    [sym_infix_op] = STATE(1064),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(278),
    [sym_compiler_directive_decl] = STATE(278),
    [sym_fsi_directive_decl] = STATE(278),
    [sym_preproc_line] = STATE(278),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_sequential_expression_repeat1] = STATE(3119),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1936),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1724),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(1744),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_COLON_GT] = ACTIONS(1752),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_LT_DASH] = ACTIONS(1768),
    [anon_sym_DOT_LBRACK] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_DOT_DOT] = ACTIONS(1780),
    [anon_sym_begin] = ACTIONS(1782),
    [anon_sym_LPAREN2] = ACTIONS(1784),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(1800),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(1804),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
    [sym__newline] = ACTIONS(1812),
  },
  [279] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(279),
    [sym_compiler_directive_decl] = STATE(279),
    [sym_fsi_directive_decl] = STATE(279),
    [sym_preproc_line] = STATE(279),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(1938),
  },
  [280] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(358),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1151),
    [sym_infix_op] = STATE(1064),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(280),
    [sym_compiler_directive_decl] = STATE(280),
    [sym_fsi_directive_decl] = STATE(280),
    [sym_preproc_line] = STATE(280),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_sequential_expression_repeat1] = STATE(3119),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1940),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1724),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(1744),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_COLON_GT] = ACTIONS(1752),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_LT_DASH] = ACTIONS(1768),
    [anon_sym_DOT_LBRACK] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_DOT_DOT] = ACTIONS(1780),
    [anon_sym_begin] = ACTIONS(1782),
    [anon_sym_LPAREN2] = ACTIONS(1784),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(1800),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(1804),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
    [sym__newline] = ACTIONS(1812),
  },
  [281] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(281),
    [sym_compiler_directive_decl] = STATE(281),
    [sym_fsi_directive_decl] = STATE(281),
    [sym_preproc_line] = STATE(281),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(1942),
  },
  [282] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(309),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1022),
    [sym_infix_op] = STATE(891),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(282),
    [sym_compiler_directive_decl] = STATE(282),
    [sym_fsi_directive_decl] = STATE(282),
    [sym_preproc_line] = STATE(282),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_sequential_expression_repeat1] = STATE(2972),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_EQ] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(229),
    [anon_sym_return] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_let] = ACTIONS(229),
    [anon_sym_let_BANG] = ACTIONS(227),
    [anon_sym_LPAREN] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(227),
    [anon_sym_null] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_COLON_QMARK] = ACTIONS(229),
    [anon_sym_COLON_COLON] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_LBRACK] = ACTIONS(229),
    [anon_sym_LBRACK_PIPE] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(229),
    [anon_sym_LT_AT] = ACTIONS(229),
    [anon_sym_LT_AT_AT] = ACTIONS(229),
    [anon_sym_AT_AT_GT] = ACTIONS(229),
    [anon_sym_DOT] = ACTIONS(1850),
    [anon_sym_LBRACE_PIPE] = ACTIONS(227),
    [anon_sym_new] = ACTIONS(229),
    [anon_sym_return_BANG] = ACTIONS(227),
    [anon_sym_yield] = ACTIONS(229),
    [anon_sym_yield_BANG] = ACTIONS(227),
    [anon_sym_lazy] = ACTIONS(229),
    [anon_sym_assert] = ACTIONS(229),
    [anon_sym_upcast] = ACTIONS(229),
    [anon_sym_downcast] = ACTIONS(229),
    [anon_sym_COLON_GT] = ACTIONS(227),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_fun] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(229),
    [anon_sym_match_BANG] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(229),
    [anon_sym_LT_DASH] = ACTIONS(229),
    [anon_sym_DOT_LBRACK] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_use] = ACTIONS(229),
    [anon_sym_use_BANG] = ACTIONS(227),
    [anon_sym_do_BANG] = ACTIONS(227),
    [anon_sym_begin] = ACTIONS(229),
    [anon_sym_LPAREN2] = ACTIONS(1886),
    [anon_sym_or] = ACTIONS(229),
    [aux_sym_char_token1] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_AT_DQUOTE] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [sym_bool] = ACTIONS(229),
    [sym_unit] = ACTIONS(1902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(229),
    [sym_op_identifier] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(229),
    [anon_sym_PLUS_DOT] = ACTIONS(229),
    [anon_sym_DASH_DOT] = ACTIONS(229),
    [anon_sym_PERCENT] = ACTIONS(229),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(227),
    [aux_sym_prefix_op_token1] = ACTIONS(229),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token2] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(229),
    [anon_sym_BANG_EQ] = ACTIONS(229),
    [anon_sym_COLON_EQ] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(229),
    [sym_int] = ACTIONS(229),
    [sym_xint] = ACTIONS(227),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(227),
    [sym__newline] = ACTIONS(227),
  },
  [283] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(471),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1045),
    [sym_infix_op] = STATE(886),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(283),
    [sym_compiler_directive_decl] = STATE(283),
    [sym_fsi_directive_decl] = STATE(283),
    [sym_preproc_line] = STATE(283),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(3142),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1600),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1604),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1600),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_COLON_GT] = ACTIONS(1608),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1608),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(1944),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1614),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(1622),
  },
  [284] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(309),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1022),
    [sym_infix_op] = STATE(891),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(284),
    [sym_compiler_directive_decl] = STATE(284),
    [sym_fsi_directive_decl] = STATE(284),
    [sym_preproc_line] = STATE(284),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_sequential_expression_repeat1] = STATE(2972),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_COMMA] = ACTIONS(1836),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(255),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(1848),
    [anon_sym_AT_AT_GT] = ACTIONS(255),
    [anon_sym_DOT] = ACTIONS(1850),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_COLON_GT] = ACTIONS(1856),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1856),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_LT_DASH] = ACTIONS(1872),
    [anon_sym_DOT_LBRACK] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [anon_sym_LPAREN2] = ACTIONS(1886),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(1902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(1906),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
    [sym__newline] = ACTIONS(253),
  },
  [285] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(346),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(890),
    [sym_infix_op] = STATE(904),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(285),
    [sym_compiler_directive_decl] = STATE(285),
    [sym_fsi_directive_decl] = STATE(285),
    [sym_preproc_line] = STATE(285),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_sequential_expression_repeat1] = STATE(3140),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_COMMA] = ACTIONS(1522),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1514),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(1820),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_AT_GT] = ACTIONS(1946),
    [anon_sym_LT_AT_AT] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1534),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_COLON_GT] = ACTIONS(1540),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_LT_DASH] = ACTIONS(1556),
    [anon_sym_DOT_LBRACK] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [anon_sym_LPAREN2] = ACTIONS(1570),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(1586),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(1590),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
    [sym__newline] = ACTIONS(1824),
  },
  [286] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(309),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1022),
    [sym_infix_op] = STATE(891),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(286),
    [sym_compiler_directive_decl] = STATE(286),
    [sym_fsi_directive_decl] = STATE(286),
    [sym_preproc_line] = STATE(286),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_sequential_expression_repeat1] = STATE(2972),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_COMMA] = ACTIONS(1836),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(259),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(1848),
    [anon_sym_AT_AT_GT] = ACTIONS(259),
    [anon_sym_DOT] = ACTIONS(1850),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_COLON_GT] = ACTIONS(1856),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1856),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_LT_DASH] = ACTIONS(1872),
    [anon_sym_DOT_LBRACK] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [anon_sym_LPAREN2] = ACTIONS(1886),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(1902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(1906),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
    [sym__newline] = ACTIONS(257),
  },
  [287] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(309),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1022),
    [sym_infix_op] = STATE(891),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(287),
    [sym_compiler_directive_decl] = STATE(287),
    [sym_fsi_directive_decl] = STATE(287),
    [sym_preproc_line] = STATE(287),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_sequential_expression_repeat1] = STATE(2972),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_COMMA] = ACTIONS(1836),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(1848),
    [anon_sym_AT_AT_GT] = ACTIONS(1946),
    [anon_sym_DOT] = ACTIONS(1850),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_COLON_GT] = ACTIONS(1856),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1856),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_LT_DASH] = ACTIONS(1872),
    [anon_sym_DOT_LBRACK] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [anon_sym_LPAREN2] = ACTIONS(1886),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(1902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(1906),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
    [sym__newline] = ACTIONS(1914),
  },
  [288] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(288),
    [sym_compiler_directive_decl] = STATE(288),
    [sym_fsi_directive_decl] = STATE(288),
    [sym_preproc_line] = STATE(288),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(1948),
  },
  [289] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(358),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1151),
    [sym_infix_op] = STATE(1064),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(289),
    [sym_compiler_directive_decl] = STATE(289),
    [sym_fsi_directive_decl] = STATE(289),
    [sym_preproc_line] = STATE(289),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_sequential_expression_repeat1] = STATE(3119),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1724),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(1744),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_COLON_GT] = ACTIONS(1752),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_LT_DASH] = ACTIONS(1768),
    [anon_sym_DOT_LBRACK] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_DOT_DOT] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(1782),
    [anon_sym_LPAREN2] = ACTIONS(1784),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(1800),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(1804),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
    [sym__newline] = ACTIONS(1812),
  },
  [290] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(290),
    [sym_compiler_directive_decl] = STATE(290),
    [sym_fsi_directive_decl] = STATE(290),
    [sym_preproc_line] = STATE(290),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(1950),
  },
  [291] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(309),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1022),
    [sym_infix_op] = STATE(891),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(291),
    [sym_compiler_directive_decl] = STATE(291),
    [sym_fsi_directive_decl] = STATE(291),
    [sym_preproc_line] = STATE(291),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_sequential_expression_repeat1] = STATE(2972),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_COMMA] = ACTIONS(1836),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(1848),
    [anon_sym_AT_AT_GT] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(1850),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_COLON_GT] = ACTIONS(1856),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1856),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_LT_DASH] = ACTIONS(1872),
    [anon_sym_DOT_LBRACK] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [anon_sym_LPAREN2] = ACTIONS(1886),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(1902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(1906),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
    [sym__newline] = ACTIONS(1914),
  },
  [292] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(292),
    [sym_compiler_directive_decl] = STATE(292),
    [sym_fsi_directive_decl] = STATE(292),
    [sym_preproc_line] = STATE(292),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(1934),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(1934),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [293] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(293),
    [sym_compiler_directive_decl] = STATE(293),
    [sym_fsi_directive_decl] = STATE(293),
    [sym_preproc_line] = STATE(293),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(1952),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(1954),
  },
  [294] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(358),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1151),
    [sym_infix_op] = STATE(1064),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(294),
    [sym_compiler_directive_decl] = STATE(294),
    [sym_fsi_directive_decl] = STATE(294),
    [sym_preproc_line] = STATE(294),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_sequential_expression_repeat1] = STATE(3119),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_EQ] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(229),
    [anon_sym_return] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_let] = ACTIONS(229),
    [anon_sym_let_BANG] = ACTIONS(227),
    [anon_sym_LPAREN] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(227),
    [anon_sym_null] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_COLON_QMARK] = ACTIONS(229),
    [anon_sym_COLON_COLON] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_LBRACK] = ACTIONS(229),
    [anon_sym_LBRACK_PIPE] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(229),
    [anon_sym_LT_AT] = ACTIONS(229),
    [anon_sym_LT_AT_AT] = ACTIONS(229),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(227),
    [anon_sym_new] = ACTIONS(229),
    [anon_sym_return_BANG] = ACTIONS(227),
    [anon_sym_yield] = ACTIONS(229),
    [anon_sym_yield_BANG] = ACTIONS(227),
    [anon_sym_lazy] = ACTIONS(229),
    [anon_sym_assert] = ACTIONS(229),
    [anon_sym_upcast] = ACTIONS(229),
    [anon_sym_downcast] = ACTIONS(229),
    [anon_sym_COLON_GT] = ACTIONS(227),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_fun] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(229),
    [anon_sym_match_BANG] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(229),
    [anon_sym_LT_DASH] = ACTIONS(229),
    [anon_sym_DOT_LBRACK] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(229),
    [anon_sym_use_BANG] = ACTIONS(227),
    [anon_sym_do_BANG] = ACTIONS(227),
    [anon_sym_DOT_DOT] = ACTIONS(227),
    [anon_sym_begin] = ACTIONS(229),
    [anon_sym_LPAREN2] = ACTIONS(1784),
    [anon_sym_or] = ACTIONS(229),
    [aux_sym_char_token1] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_AT_DQUOTE] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [sym_bool] = ACTIONS(229),
    [sym_unit] = ACTIONS(1800),
    [anon_sym_LPAREN_PIPE] = ACTIONS(229),
    [sym_op_identifier] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(229),
    [anon_sym_PLUS_DOT] = ACTIONS(229),
    [anon_sym_DASH_DOT] = ACTIONS(229),
    [anon_sym_PERCENT] = ACTIONS(229),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(227),
    [aux_sym_prefix_op_token1] = ACTIONS(229),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token2] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(229),
    [anon_sym_BANG_EQ] = ACTIONS(229),
    [anon_sym_COLON_EQ] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(229),
    [sym_int] = ACTIONS(229),
    [sym_xint] = ACTIONS(227),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(227),
    [sym__newline] = ACTIONS(227),
  },
  [295] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(309),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1022),
    [sym_infix_op] = STATE(891),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(295),
    [sym_compiler_directive_decl] = STATE(295),
    [sym_fsi_directive_decl] = STATE(295),
    [sym_preproc_line] = STATE(295),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_sequential_expression_repeat1] = STATE(2972),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_COMMA] = ACTIONS(1836),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(1848),
    [anon_sym_AT_AT_GT] = ACTIONS(233),
    [anon_sym_DOT] = ACTIONS(1850),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_COLON_GT] = ACTIONS(1856),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1856),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_LT_DASH] = ACTIONS(1872),
    [anon_sym_DOT_LBRACK] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [anon_sym_LPAREN2] = ACTIONS(1886),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(1902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(1906),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
    [sym__newline] = ACTIONS(1914),
  },
  [296] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(296),
    [sym_compiler_directive_decl] = STATE(296),
    [sym_fsi_directive_decl] = STATE(296),
    [sym_preproc_line] = STATE(296),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(1956),
  },
  [297] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(309),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1022),
    [sym_infix_op] = STATE(891),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(297),
    [sym_compiler_directive_decl] = STATE(297),
    [sym_fsi_directive_decl] = STATE(297),
    [sym_preproc_line] = STATE(297),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_sequential_expression_repeat1] = STATE(2972),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_COMMA] = ACTIONS(1836),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(1848),
    [anon_sym_AT_AT_GT] = ACTIONS(1958),
    [anon_sym_DOT] = ACTIONS(1850),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_COLON_GT] = ACTIONS(1856),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1856),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_LT_DASH] = ACTIONS(1872),
    [anon_sym_DOT_LBRACK] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [anon_sym_LPAREN2] = ACTIONS(1886),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(1902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(1906),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
    [sym__newline] = ACTIONS(1914),
  },
  [298] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(298),
    [sym_compiler_directive_decl] = STATE(298),
    [sym_fsi_directive_decl] = STATE(298),
    [sym_preproc_line] = STATE(298),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(1960),
  },
  [299] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(358),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1151),
    [sym_infix_op] = STATE(1064),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(299),
    [sym_compiler_directive_decl] = STATE(299),
    [sym_fsi_directive_decl] = STATE(299),
    [sym_preproc_line] = STATE(299),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_sequential_expression_repeat1] = STATE(3119),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1962),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1724),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(1744),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_COLON_GT] = ACTIONS(1752),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_LT_DASH] = ACTIONS(1768),
    [anon_sym_DOT_LBRACK] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_DOT_DOT] = ACTIONS(1780),
    [anon_sym_begin] = ACTIONS(1782),
    [anon_sym_LPAREN2] = ACTIONS(1784),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(1800),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(1804),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
    [sym__newline] = ACTIONS(1812),
  },
  [300] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(346),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(890),
    [sym_infix_op] = STATE(904),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(300),
    [sym_compiler_directive_decl] = STATE(300),
    [sym_fsi_directive_decl] = STATE(300),
    [sym_preproc_line] = STATE(300),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_sequential_expression_repeat1] = STATE(3140),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_COMMA] = ACTIONS(1522),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1514),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(1820),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_AT_GT] = ACTIONS(1958),
    [anon_sym_LT_AT_AT] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1534),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_COLON_GT] = ACTIONS(1540),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_LT_DASH] = ACTIONS(1556),
    [anon_sym_DOT_LBRACK] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [anon_sym_LPAREN2] = ACTIONS(1570),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(1586),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(1590),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
    [sym__newline] = ACTIONS(1824),
  },
  [301] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(346),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(890),
    [sym_infix_op] = STATE(904),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(301),
    [sym_compiler_directive_decl] = STATE(301),
    [sym_fsi_directive_decl] = STATE(301),
    [sym_preproc_line] = STATE(301),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_sequential_expression_repeat1] = STATE(3140),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_EQ] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(229),
    [anon_sym_return] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_let] = ACTIONS(229),
    [anon_sym_let_BANG] = ACTIONS(227),
    [anon_sym_LPAREN] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(227),
    [anon_sym_null] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_COLON_QMARK] = ACTIONS(229),
    [anon_sym_COLON_COLON] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_LBRACK] = ACTIONS(229),
    [anon_sym_LBRACK_PIPE] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(229),
    [anon_sym_LT_AT] = ACTIONS(229),
    [anon_sym_AT_GT] = ACTIONS(229),
    [anon_sym_LT_AT_AT] = ACTIONS(229),
    [anon_sym_DOT] = ACTIONS(1534),
    [anon_sym_LBRACE_PIPE] = ACTIONS(227),
    [anon_sym_new] = ACTIONS(229),
    [anon_sym_return_BANG] = ACTIONS(227),
    [anon_sym_yield] = ACTIONS(229),
    [anon_sym_yield_BANG] = ACTIONS(227),
    [anon_sym_lazy] = ACTIONS(229),
    [anon_sym_assert] = ACTIONS(229),
    [anon_sym_upcast] = ACTIONS(229),
    [anon_sym_downcast] = ACTIONS(229),
    [anon_sym_COLON_GT] = ACTIONS(227),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_fun] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(229),
    [anon_sym_match_BANG] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(229),
    [anon_sym_LT_DASH] = ACTIONS(229),
    [anon_sym_DOT_LBRACK] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_use] = ACTIONS(229),
    [anon_sym_use_BANG] = ACTIONS(227),
    [anon_sym_do_BANG] = ACTIONS(227),
    [anon_sym_begin] = ACTIONS(229),
    [anon_sym_LPAREN2] = ACTIONS(1570),
    [anon_sym_or] = ACTIONS(229),
    [aux_sym_char_token1] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_AT_DQUOTE] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [sym_bool] = ACTIONS(229),
    [sym_unit] = ACTIONS(1586),
    [anon_sym_LPAREN_PIPE] = ACTIONS(229),
    [sym_op_identifier] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(229),
    [anon_sym_PLUS_DOT] = ACTIONS(229),
    [anon_sym_DASH_DOT] = ACTIONS(229),
    [anon_sym_PERCENT] = ACTIONS(229),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(227),
    [aux_sym_prefix_op_token1] = ACTIONS(229),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token2] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(229),
    [anon_sym_BANG_EQ] = ACTIONS(229),
    [anon_sym_COLON_EQ] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(229),
    [sym_int] = ACTIONS(229),
    [sym_xint] = ACTIONS(227),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(227),
    [sym__newline] = ACTIONS(227),
  },
  [302] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(471),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1045),
    [sym_infix_op] = STATE(886),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(302),
    [sym_compiler_directive_decl] = STATE(302),
    [sym_fsi_directive_decl] = STATE(302),
    [sym_preproc_line] = STATE(302),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(3142),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1600),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1604),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1600),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_COLON_GT] = ACTIONS(1608),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1608),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(1964),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1614),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(1622),
  },
  [303] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(471),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1045),
    [sym_infix_op] = STATE(886),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(303),
    [sym_compiler_directive_decl] = STATE(303),
    [sym_fsi_directive_decl] = STATE(303),
    [sym_preproc_line] = STATE(303),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(3142),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1600),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1604),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1600),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_COLON_GT] = ACTIONS(1608),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1608),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(1966),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1614),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(1622),
  },
  [304] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(346),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(890),
    [sym_infix_op] = STATE(904),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(304),
    [sym_compiler_directive_decl] = STATE(304),
    [sym_fsi_directive_decl] = STATE(304),
    [sym_preproc_line] = STATE(304),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_sequential_expression_repeat1] = STATE(3140),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_COMMA] = ACTIONS(1522),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1514),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(255),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_AT_GT] = ACTIONS(255),
    [anon_sym_LT_AT_AT] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1534),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_COLON_GT] = ACTIONS(1540),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_LT_DASH] = ACTIONS(1556),
    [anon_sym_DOT_LBRACK] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [anon_sym_LPAREN2] = ACTIONS(1570),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(1586),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(1590),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
    [sym__newline] = ACTIONS(253),
  },
  [305] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(346),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(890),
    [sym_infix_op] = STATE(904),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(305),
    [sym_compiler_directive_decl] = STATE(305),
    [sym_fsi_directive_decl] = STATE(305),
    [sym_preproc_line] = STATE(305),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_sequential_expression_repeat1] = STATE(3140),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_COMMA] = ACTIONS(1522),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1514),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(259),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_AT_GT] = ACTIONS(259),
    [anon_sym_LT_AT_AT] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1534),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_COLON_GT] = ACTIONS(1540),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_LT_DASH] = ACTIONS(1556),
    [anon_sym_DOT_LBRACK] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [anon_sym_LPAREN2] = ACTIONS(1570),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(1586),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(1590),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
    [sym__newline] = ACTIONS(257),
  },
  [306] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(346),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(890),
    [sym_infix_op] = STATE(904),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(306),
    [sym_compiler_directive_decl] = STATE(306),
    [sym_fsi_directive_decl] = STATE(306),
    [sym_preproc_line] = STATE(306),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_sequential_expression_repeat1] = STATE(3140),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_COMMA] = ACTIONS(1522),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1514),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(1820),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_AT_GT] = ACTIONS(263),
    [anon_sym_LT_AT_AT] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1534),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_COLON_GT] = ACTIONS(1540),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_LT_DASH] = ACTIONS(1556),
    [anon_sym_DOT_LBRACK] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [anon_sym_LPAREN2] = ACTIONS(1570),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(1586),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(1590),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
    [sym__newline] = ACTIONS(1824),
  },
  [307] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(307),
    [sym_compiler_directive_decl] = STATE(307),
    [sym_fsi_directive_decl] = STATE(307),
    [sym_preproc_line] = STATE(307),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(1968),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(1970),
  },
  [308] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(358),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1151),
    [sym_infix_op] = STATE(1064),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(308),
    [sym_compiler_directive_decl] = STATE(308),
    [sym_fsi_directive_decl] = STATE(308),
    [sym_preproc_line] = STATE(308),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_sequential_expression_repeat1] = STATE(3119),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1972),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1724),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(1744),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_COLON_GT] = ACTIONS(1752),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_LT_DASH] = ACTIONS(1768),
    [anon_sym_DOT_LBRACK] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_DOT_DOT] = ACTIONS(1780),
    [anon_sym_begin] = ACTIONS(1782),
    [anon_sym_LPAREN2] = ACTIONS(1784),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(1800),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(1804),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
    [sym__newline] = ACTIONS(1812),
  },
  [309] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(309),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1022),
    [sym_infix_op] = STATE(891),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(309),
    [sym_compiler_directive_decl] = STATE(309),
    [sym_fsi_directive_decl] = STATE(309),
    [sym_preproc_line] = STATE(309),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_sequential_expression_repeat1] = STATE(2972),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_EQ] = ACTIONS(223),
    [anon_sym_COLON] = ACTIONS(225),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_do] = ACTIONS(225),
    [anon_sym_let] = ACTIONS(225),
    [anon_sym_let_BANG] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_COMMA] = ACTIONS(223),
    [anon_sym_null] = ACTIONS(225),
    [anon_sym_QMARK] = ACTIONS(225),
    [anon_sym_COLON_QMARK] = ACTIONS(225),
    [anon_sym_COLON_COLON] = ACTIONS(223),
    [anon_sym_AMP] = ACTIONS(225),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LBRACK_PIPE] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(225),
    [anon_sym_LT_AT] = ACTIONS(225),
    [anon_sym_LT_AT_AT] = ACTIONS(225),
    [anon_sym_AT_AT_GT] = ACTIONS(225),
    [anon_sym_DOT] = ACTIONS(1850),
    [anon_sym_LBRACE_PIPE] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(225),
    [anon_sym_return_BANG] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(225),
    [anon_sym_yield_BANG] = ACTIONS(223),
    [anon_sym_lazy] = ACTIONS(225),
    [anon_sym_assert] = ACTIONS(225),
    [anon_sym_upcast] = ACTIONS(225),
    [anon_sym_downcast] = ACTIONS(225),
    [anon_sym_COLON_GT] = ACTIONS(223),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(223),
    [anon_sym_for] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_fun] = ACTIONS(225),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_match] = ACTIONS(225),
    [anon_sym_match_BANG] = ACTIONS(223),
    [anon_sym_function] = ACTIONS(225),
    [anon_sym_LT_DASH] = ACTIONS(225),
    [anon_sym_DOT_LBRACK] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_use] = ACTIONS(225),
    [anon_sym_use_BANG] = ACTIONS(223),
    [anon_sym_do_BANG] = ACTIONS(223),
    [anon_sym_begin] = ACTIONS(225),
    [anon_sym_LPAREN2] = ACTIONS(1886),
    [anon_sym_or] = ACTIONS(225),
    [aux_sym_char_token1] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_AT_DQUOTE] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [sym_bool] = ACTIONS(225),
    [sym_unit] = ACTIONS(1902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(225),
    [sym_op_identifier] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(225),
    [anon_sym_DASH] = ACTIONS(225),
    [anon_sym_PLUS_DOT] = ACTIONS(225),
    [anon_sym_DASH_DOT] = ACTIONS(225),
    [anon_sym_PERCENT] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_TILDE] = ACTIONS(223),
    [aux_sym_prefix_op_token1] = ACTIONS(225),
    [aux_sym_infix_op_token1] = ACTIONS(223),
    [aux_sym_infix_op_token2] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_BANG_EQ] = ACTIONS(225),
    [anon_sym_COLON_EQ] = ACTIONS(223),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(225),
    [sym_int] = ACTIONS(225),
    [sym_xint] = ACTIONS(223),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(223),
    [sym__newline] = ACTIONS(223),
  },
  [310] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(358),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1151),
    [sym_infix_op] = STATE(1064),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(310),
    [sym_compiler_directive_decl] = STATE(310),
    [sym_fsi_directive_decl] = STATE(310),
    [sym_preproc_line] = STATE(310),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_sequential_expression_repeat1] = STATE(3119),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1724),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(255),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(1744),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_COLON_GT] = ACTIONS(1752),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_LT_DASH] = ACTIONS(1768),
    [anon_sym_DOT_LBRACK] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_DOT_DOT] = ACTIONS(253),
    [anon_sym_begin] = ACTIONS(1782),
    [anon_sym_LPAREN2] = ACTIONS(1784),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(1800),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(1804),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
    [sym__newline] = ACTIONS(253),
  },
  [311] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(311),
    [sym_compiler_directive_decl] = STATE(311),
    [sym_fsi_directive_decl] = STATE(311),
    [sym_preproc_line] = STATE(311),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(1974),
  },
  [312] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(358),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1151),
    [sym_infix_op] = STATE(1064),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(312),
    [sym_compiler_directive_decl] = STATE(312),
    [sym_fsi_directive_decl] = STATE(312),
    [sym_preproc_line] = STATE(312),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_sequential_expression_repeat1] = STATE(3119),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1976),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1724),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(1744),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_COLON_GT] = ACTIONS(1752),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_LT_DASH] = ACTIONS(1768),
    [anon_sym_DOT_LBRACK] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_DOT_DOT] = ACTIONS(1780),
    [anon_sym_begin] = ACTIONS(1782),
    [anon_sym_LPAREN2] = ACTIONS(1784),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(1800),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(1804),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
    [sym__newline] = ACTIONS(1812),
  },
  [313] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(313),
    [sym_compiler_directive_decl] = STATE(313),
    [sym_fsi_directive_decl] = STATE(313),
    [sym_preproc_line] = STATE(313),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(1978),
  },
  [314] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(471),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1045),
    [sym_infix_op] = STATE(886),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(314),
    [sym_compiler_directive_decl] = STATE(314),
    [sym_fsi_directive_decl] = STATE(314),
    [sym_preproc_line] = STATE(314),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(3142),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_EQ] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(229),
    [anon_sym_return] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_let] = ACTIONS(229),
    [anon_sym_let_BANG] = ACTIONS(227),
    [anon_sym_LPAREN] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(227),
    [anon_sym_null] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_COLON_QMARK] = ACTIONS(229),
    [anon_sym_COLON_COLON] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_LBRACK] = ACTIONS(229),
    [anon_sym_LBRACK_PIPE] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(229),
    [anon_sym_LT_AT] = ACTIONS(229),
    [anon_sym_LT_AT_AT] = ACTIONS(229),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(227),
    [anon_sym_new] = ACTIONS(229),
    [anon_sym_return_BANG] = ACTIONS(227),
    [anon_sym_yield] = ACTIONS(229),
    [anon_sym_yield_BANG] = ACTIONS(227),
    [anon_sym_lazy] = ACTIONS(229),
    [anon_sym_assert] = ACTIONS(229),
    [anon_sym_upcast] = ACTIONS(229),
    [anon_sym_downcast] = ACTIONS(229),
    [anon_sym_COLON_GT] = ACTIONS(227),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_fun] = ACTIONS(229),
    [anon_sym_DASH_GT] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(229),
    [anon_sym_match_BANG] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(229),
    [anon_sym_LT_DASH] = ACTIONS(229),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(229),
    [anon_sym_use_BANG] = ACTIONS(227),
    [anon_sym_do_BANG] = ACTIONS(227),
    [anon_sym_begin] = ACTIONS(229),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(229),
    [aux_sym_char_token1] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_AT_DQUOTE] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [sym_bool] = ACTIONS(229),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(229),
    [sym_op_identifier] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(229),
    [anon_sym_PLUS_DOT] = ACTIONS(229),
    [anon_sym_DASH_DOT] = ACTIONS(229),
    [anon_sym_PERCENT] = ACTIONS(229),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(227),
    [aux_sym_prefix_op_token1] = ACTIONS(229),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token2] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(229),
    [anon_sym_BANG_EQ] = ACTIONS(229),
    [anon_sym_COLON_EQ] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(229),
    [sym_int] = ACTIONS(229),
    [sym_xint] = ACTIONS(227),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(227),
    [sym__newline] = ACTIONS(227),
  },
  [315] = {
    [sym_function_or_value_defn] = STATE(783),
    [sym__expression] = STATE(338),
    [sym_literal_expression] = STATE(3553),
    [sym_long_identifier_or_op] = STATE(3553),
    [sym_tuple_expression] = STATE(3553),
    [sym_brace_expression] = STATE(3553),
    [sym_anon_record_expression] = STATE(3553),
    [sym_prefixed_expression] = STATE(3553),
    [sym_typecast_expression] = STATE(3553),
    [sym_for_expression] = STATE(3553),
    [sym_while_expression] = STATE(3553),
    [sym__if_branch] = STATE(10567),
    [sym_if_expression] = STATE(3553),
    [sym_fun_expression] = STATE(3553),
    [sym_try_expression] = STATE(3553),
    [sym_match_expression] = STATE(3553),
    [sym_function_expression] = STATE(3553),
    [sym_mutate_expression] = STATE(3553),
    [sym_index_expression] = STATE(3553),
    [sym_typed_expression] = STATE(3553),
    [sym_declaration_expression] = STATE(3553),
    [sym_do_expression] = STATE(3553),
    [sym_list_expression] = STATE(3553),
    [sym_array_expression] = STATE(3553),
    [sym_begin_end_expression] = STATE(3553),
    [sym_paren_expression] = STATE(3553),
    [sym__high_prec_app] = STATE(3532),
    [sym__low_prec_app] = STATE(3532),
    [sym_application_expression] = STATE(3553),
    [sym_dot_expression] = STATE(3553),
    [sym_infix_expression] = STATE(3553),
    [sym_ce_expression] = STATE(3553),
    [sym_sequential_expression] = STATE(3553),
    [sym_char] = STATE(3265),
    [sym_format_string] = STATE(3261),
    [sym__string_literal] = STATE(3261),
    [sym_string] = STATE(3265),
    [sym_verbatim_string] = STATE(3265),
    [sym_bytearray] = STATE(3265),
    [sym_verbatim_bytearray] = STATE(3265),
    [sym_format_triple_quoted_string] = STATE(3260),
    [sym_triple_quoted_string] = STATE(3265),
    [sym_const] = STATE(3553),
    [sym_long_identifier] = STATE(3203),
    [sym_active_pattern] = STATE(3576),
    [sym__identifier_or_op] = STATE(3362),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1076),
    [sym_infix_op] = STATE(975),
    [sym_sbyte] = STATE(3265),
    [sym_byte] = STATE(3265),
    [sym_int16] = STATE(3265),
    [sym_uint16] = STATE(3265),
    [sym_int32] = STATE(3265),
    [sym_uint32] = STATE(3265),
    [sym_nativeint] = STATE(3265),
    [sym_unativeint] = STATE(3265),
    [sym_int64] = STATE(3265),
    [sym_uint64] = STATE(3265),
    [sym_ieee32] = STATE(3265),
    [sym_ieee64] = STATE(3265),
    [sym_bignum] = STATE(3265),
    [sym_decimal] = STATE(3265),
    [sym_float] = STATE(2797),
    [sym_block_comment] = STATE(315),
    [sym_compiler_directive_decl] = STATE(315),
    [sym_fsi_directive_decl] = STATE(315),
    [sym_preproc_line] = STATE(315),
    [sym_preproc_if_in_expression] = STATE(3553),
    [aux_sym_sequential_expression_repeat1] = STATE(3067),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1632),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1634),
    [anon_sym_return] = ACTIONS(1636),
    [anon_sym_do] = ACTIONS(1638),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1640),
    [anon_sym_COMMA] = ACTIONS(1642),
    [anon_sym_null] = ACTIONS(1644),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1634),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1646),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(255),
    [anon_sym_LT_AT] = ACTIONS(1652),
    [anon_sym_LT_AT_AT] = ACTIONS(1654),
    [anon_sym_DOT] = ACTIONS(1656),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1658),
    [anon_sym_new] = ACTIONS(1636),
    [anon_sym_return_BANG] = ACTIONS(1660),
    [anon_sym_yield] = ACTIONS(1636),
    [anon_sym_yield_BANG] = ACTIONS(1660),
    [anon_sym_lazy] = ACTIONS(1636),
    [anon_sym_assert] = ACTIONS(1636),
    [anon_sym_upcast] = ACTIONS(1636),
    [anon_sym_downcast] = ACTIONS(1636),
    [anon_sym_COLON_GT] = ACTIONS(1662),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1662),
    [anon_sym_for] = ACTIONS(1664),
    [anon_sym_while] = ACTIONS(1666),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1668),
    [anon_sym_try] = ACTIONS(1670),
    [anon_sym_match] = ACTIONS(1672),
    [anon_sym_match_BANG] = ACTIONS(1674),
    [anon_sym_function] = ACTIONS(1676),
    [anon_sym_LT_DASH] = ACTIONS(1678),
    [anon_sym_DOT_LBRACK] = ACTIONS(1680),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(255),
    [anon_sym_use] = ACTIONS(1684),
    [anon_sym_use_BANG] = ACTIONS(1686),
    [anon_sym_do_BANG] = ACTIONS(1688),
    [anon_sym_begin] = ACTIONS(1690),
    [anon_sym_LPAREN2] = ACTIONS(1692),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1694),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1696),
    [anon_sym_DQUOTE] = ACTIONS(1698),
    [anon_sym_AT_DQUOTE] = ACTIONS(1700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1704),
    [sym_bool] = ACTIONS(1706),
    [sym_unit] = ACTIONS(1708),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1710),
    [sym_op_identifier] = ACTIONS(1712),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1714),
    [sym_xint] = ACTIONS(1716),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1718),
    [sym__newline] = ACTIONS(253),
  },
  [316] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(309),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1022),
    [sym_infix_op] = STATE(891),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(316),
    [sym_compiler_directive_decl] = STATE(316),
    [sym_fsi_directive_decl] = STATE(316),
    [sym_preproc_line] = STATE(316),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_sequential_expression_repeat1] = STATE(2972),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_COMMA] = ACTIONS(1836),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(1848),
    [anon_sym_AT_AT_GT] = ACTIONS(267),
    [anon_sym_DOT] = ACTIONS(1850),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_COLON_GT] = ACTIONS(1856),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1856),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_LT_DASH] = ACTIONS(1872),
    [anon_sym_DOT_LBRACK] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [anon_sym_LPAREN2] = ACTIONS(1886),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(1902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(1906),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
    [sym__newline] = ACTIONS(1914),
  },
  [317] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(317),
    [sym_compiler_directive_decl] = STATE(317),
    [sym_fsi_directive_decl] = STATE(317),
    [sym_preproc_line] = STATE(317),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(1980),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(1982),
  },
  [318] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(358),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1151),
    [sym_infix_op] = STATE(1064),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(318),
    [sym_compiler_directive_decl] = STATE(318),
    [sym_fsi_directive_decl] = STATE(318),
    [sym_preproc_line] = STATE(318),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_sequential_expression_repeat1] = STATE(3119),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1724),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(259),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(1744),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_COLON_GT] = ACTIONS(1752),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_LT_DASH] = ACTIONS(1768),
    [anon_sym_DOT_LBRACK] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_DOT_DOT] = ACTIONS(257),
    [anon_sym_begin] = ACTIONS(1782),
    [anon_sym_LPAREN2] = ACTIONS(1784),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(1800),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(1804),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
    [sym__newline] = ACTIONS(257),
  },
  [319] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(346),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(890),
    [sym_infix_op] = STATE(904),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(319),
    [sym_compiler_directive_decl] = STATE(319),
    [sym_fsi_directive_decl] = STATE(319),
    [sym_preproc_line] = STATE(319),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_sequential_expression_repeat1] = STATE(3140),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_COMMA] = ACTIONS(1522),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1514),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(1820),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_AT_GT] = ACTIONS(233),
    [anon_sym_LT_AT_AT] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1534),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_COLON_GT] = ACTIONS(1540),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_LT_DASH] = ACTIONS(1556),
    [anon_sym_DOT_LBRACK] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [anon_sym_LPAREN2] = ACTIONS(1570),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(1586),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(1590),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
    [sym__newline] = ACTIONS(1824),
  },
  [320] = {
    [sym_function_or_value_defn] = STATE(783),
    [sym__expression] = STATE(338),
    [sym_literal_expression] = STATE(3553),
    [sym_long_identifier_or_op] = STATE(3553),
    [sym_tuple_expression] = STATE(3553),
    [sym_brace_expression] = STATE(3553),
    [sym_anon_record_expression] = STATE(3553),
    [sym_prefixed_expression] = STATE(3553),
    [sym_typecast_expression] = STATE(3553),
    [sym_for_expression] = STATE(3553),
    [sym_while_expression] = STATE(3553),
    [sym__if_branch] = STATE(10567),
    [sym_if_expression] = STATE(3553),
    [sym_fun_expression] = STATE(3553),
    [sym_try_expression] = STATE(3553),
    [sym_match_expression] = STATE(3553),
    [sym_function_expression] = STATE(3553),
    [sym_mutate_expression] = STATE(3553),
    [sym_index_expression] = STATE(3553),
    [sym_typed_expression] = STATE(3553),
    [sym_declaration_expression] = STATE(3553),
    [sym_do_expression] = STATE(3553),
    [sym_list_expression] = STATE(3553),
    [sym_array_expression] = STATE(3553),
    [sym_begin_end_expression] = STATE(3553),
    [sym_paren_expression] = STATE(3553),
    [sym__high_prec_app] = STATE(3532),
    [sym__low_prec_app] = STATE(3532),
    [sym_application_expression] = STATE(3553),
    [sym_dot_expression] = STATE(3553),
    [sym_infix_expression] = STATE(3553),
    [sym_ce_expression] = STATE(3553),
    [sym_sequential_expression] = STATE(3553),
    [sym_char] = STATE(3265),
    [sym_format_string] = STATE(3261),
    [sym__string_literal] = STATE(3261),
    [sym_string] = STATE(3265),
    [sym_verbatim_string] = STATE(3265),
    [sym_bytearray] = STATE(3265),
    [sym_verbatim_bytearray] = STATE(3265),
    [sym_format_triple_quoted_string] = STATE(3260),
    [sym_triple_quoted_string] = STATE(3265),
    [sym_const] = STATE(3553),
    [sym_long_identifier] = STATE(3203),
    [sym_active_pattern] = STATE(3576),
    [sym__identifier_or_op] = STATE(3362),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1076),
    [sym_infix_op] = STATE(975),
    [sym_sbyte] = STATE(3265),
    [sym_byte] = STATE(3265),
    [sym_int16] = STATE(3265),
    [sym_uint16] = STATE(3265),
    [sym_int32] = STATE(3265),
    [sym_uint32] = STATE(3265),
    [sym_nativeint] = STATE(3265),
    [sym_unativeint] = STATE(3265),
    [sym_int64] = STATE(3265),
    [sym_uint64] = STATE(3265),
    [sym_ieee32] = STATE(3265),
    [sym_ieee64] = STATE(3265),
    [sym_bignum] = STATE(3265),
    [sym_decimal] = STATE(3265),
    [sym_float] = STATE(2797),
    [sym_block_comment] = STATE(320),
    [sym_compiler_directive_decl] = STATE(320),
    [sym_fsi_directive_decl] = STATE(320),
    [sym_preproc_line] = STATE(320),
    [sym_preproc_if_in_expression] = STATE(3553),
    [aux_sym_sequential_expression_repeat1] = STATE(3067),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1632),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1634),
    [anon_sym_return] = ACTIONS(1636),
    [anon_sym_do] = ACTIONS(1638),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1640),
    [anon_sym_COMMA] = ACTIONS(1642),
    [anon_sym_null] = ACTIONS(1644),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1634),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1646),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(259),
    [anon_sym_LT_AT] = ACTIONS(1652),
    [anon_sym_LT_AT_AT] = ACTIONS(1654),
    [anon_sym_DOT] = ACTIONS(1656),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1658),
    [anon_sym_new] = ACTIONS(1636),
    [anon_sym_return_BANG] = ACTIONS(1660),
    [anon_sym_yield] = ACTIONS(1636),
    [anon_sym_yield_BANG] = ACTIONS(1660),
    [anon_sym_lazy] = ACTIONS(1636),
    [anon_sym_assert] = ACTIONS(1636),
    [anon_sym_upcast] = ACTIONS(1636),
    [anon_sym_downcast] = ACTIONS(1636),
    [anon_sym_COLON_GT] = ACTIONS(1662),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1662),
    [anon_sym_for] = ACTIONS(1664),
    [anon_sym_while] = ACTIONS(1666),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1668),
    [anon_sym_try] = ACTIONS(1670),
    [anon_sym_match] = ACTIONS(1672),
    [anon_sym_match_BANG] = ACTIONS(1674),
    [anon_sym_function] = ACTIONS(1676),
    [anon_sym_LT_DASH] = ACTIONS(1678),
    [anon_sym_DOT_LBRACK] = ACTIONS(1680),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(259),
    [anon_sym_use] = ACTIONS(1684),
    [anon_sym_use_BANG] = ACTIONS(1686),
    [anon_sym_do_BANG] = ACTIONS(1688),
    [anon_sym_begin] = ACTIONS(1690),
    [anon_sym_LPAREN2] = ACTIONS(1692),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1694),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1696),
    [anon_sym_DQUOTE] = ACTIONS(1698),
    [anon_sym_AT_DQUOTE] = ACTIONS(1700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1704),
    [sym_bool] = ACTIONS(1706),
    [sym_unit] = ACTIONS(1708),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1710),
    [sym_op_identifier] = ACTIONS(1712),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1714),
    [sym_xint] = ACTIONS(1716),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1718),
    [sym__newline] = ACTIONS(257),
  },
  [321] = {
    [sym_function_or_value_defn] = STATE(1099),
    [sym__expression] = STATE(422),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1020),
    [sym_infix_op] = STATE(1104),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(2924),
    [sym_block_comment] = STATE(321),
    [sym_compiler_directive_decl] = STATE(321),
    [sym_fsi_directive_decl] = STATE(321),
    [sym_preproc_line] = STATE(321),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_sequential_expression_repeat1] = STATE(3001),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(1494),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(649),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(667),
    [anon_sym_DOT] = ACTIONS(669),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(1492),
    [anon_sym_return_BANG] = ACTIONS(1496),
    [anon_sym_yield] = ACTIONS(1492),
    [anon_sym_yield_BANG] = ACTIONS(1496),
    [anon_sym_lazy] = ACTIONS(1492),
    [anon_sym_assert] = ACTIONS(1492),
    [anon_sym_upcast] = ACTIONS(1492),
    [anon_sym_downcast] = ACTIONS(1492),
    [anon_sym_COLON_GT] = ACTIONS(675),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_LT_DASH] = ACTIONS(1498),
    [anon_sym_DOT_LBRACK] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_use] = ACTIONS(1500),
    [anon_sym_use_BANG] = ACTIONS(1502),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [anon_sym_LPAREN2] = ACTIONS(705),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(721),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1504),
    [sym_xint] = ACTIONS(1506),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
    [anon_sym_POUNDendif] = ACTIONS(119),
    [sym__newline] = ACTIONS(119),
  },
  [322] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(346),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(890),
    [sym_infix_op] = STATE(904),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(322),
    [sym_compiler_directive_decl] = STATE(322),
    [sym_fsi_directive_decl] = STATE(322),
    [sym_preproc_line] = STATE(322),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_sequential_expression_repeat1] = STATE(3140),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_COMMA] = ACTIONS(1522),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1514),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(1820),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_AT_GT] = ACTIONS(1984),
    [anon_sym_LT_AT_AT] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1534),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_COLON_GT] = ACTIONS(1540),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_LT_DASH] = ACTIONS(1556),
    [anon_sym_DOT_LBRACK] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [anon_sym_LPAREN2] = ACTIONS(1570),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(1586),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(1590),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
    [sym__newline] = ACTIONS(1824),
  },
  [323] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(323),
    [sym_compiler_directive_decl] = STATE(323),
    [sym_fsi_directive_decl] = STATE(323),
    [sym_preproc_line] = STATE(323),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(1986),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(1988),
  },
  [324] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(309),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1022),
    [sym_infix_op] = STATE(891),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(324),
    [sym_compiler_directive_decl] = STATE(324),
    [sym_fsi_directive_decl] = STATE(324),
    [sym_preproc_line] = STATE(324),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_sequential_expression_repeat1] = STATE(2972),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_COMMA] = ACTIONS(1836),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(1848),
    [anon_sym_AT_AT_GT] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1850),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_COLON_GT] = ACTIONS(1856),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1856),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_LT_DASH] = ACTIONS(1872),
    [anon_sym_DOT_LBRACK] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [anon_sym_LPAREN2] = ACTIONS(1886),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(1902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(1906),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
    [sym__newline] = ACTIONS(1914),
  },
  [325] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(471),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1045),
    [sym_infix_op] = STATE(886),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(325),
    [sym_compiler_directive_decl] = STATE(325),
    [sym_fsi_directive_decl] = STATE(325),
    [sym_preproc_line] = STATE(325),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(3142),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1600),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1604),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1600),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_COLON_GT] = ACTIONS(1608),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1608),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(1990),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1614),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(1622),
  },
  [326] = {
    [sym_function_or_value_defn] = STATE(1099),
    [sym__expression] = STATE(422),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1020),
    [sym_infix_op] = STATE(1104),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(2924),
    [sym_block_comment] = STATE(326),
    [sym_compiler_directive_decl] = STATE(326),
    [sym_fsi_directive_decl] = STATE(326),
    [sym_preproc_line] = STATE(326),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_sequential_expression_repeat1] = STATE(3001),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(1494),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(649),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(667),
    [anon_sym_DOT] = ACTIONS(669),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(1492),
    [anon_sym_return_BANG] = ACTIONS(1496),
    [anon_sym_yield] = ACTIONS(1492),
    [anon_sym_yield_BANG] = ACTIONS(1496),
    [anon_sym_lazy] = ACTIONS(1492),
    [anon_sym_assert] = ACTIONS(1492),
    [anon_sym_upcast] = ACTIONS(1492),
    [anon_sym_downcast] = ACTIONS(1492),
    [anon_sym_COLON_GT] = ACTIONS(675),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_LT_DASH] = ACTIONS(1498),
    [anon_sym_DOT_LBRACK] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_use] = ACTIONS(1500),
    [anon_sym_use_BANG] = ACTIONS(1502),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [anon_sym_LPAREN2] = ACTIONS(705),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(721),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1504),
    [sym_xint] = ACTIONS(1506),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
    [anon_sym_POUNDendif] = ACTIONS(231),
    [sym__newline] = ACTIONS(1508),
  },
  [327] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(327),
    [sym_compiler_directive_decl] = STATE(327),
    [sym_fsi_directive_decl] = STATE(327),
    [sym_preproc_line] = STATE(327),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(1992),
  },
  [328] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(328),
    [sym_compiler_directive_decl] = STATE(328),
    [sym_fsi_directive_decl] = STATE(328),
    [sym_preproc_line] = STATE(328),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(1994),
  },
  [329] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(329),
    [sym_compiler_directive_decl] = STATE(329),
    [sym_fsi_directive_decl] = STATE(329),
    [sym_preproc_line] = STATE(329),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(1996),
  },
  [330] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(330),
    [sym_compiler_directive_decl] = STATE(330),
    [sym_fsi_directive_decl] = STATE(330),
    [sym_preproc_line] = STATE(330),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(1998),
  },
  [331] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(331),
    [sym_compiler_directive_decl] = STATE(331),
    [sym_fsi_directive_decl] = STATE(331),
    [sym_preproc_line] = STATE(331),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2000),
  },
  [332] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(358),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1151),
    [sym_infix_op] = STATE(1064),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(332),
    [sym_compiler_directive_decl] = STATE(332),
    [sym_fsi_directive_decl] = STATE(332),
    [sym_preproc_line] = STATE(332),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_sequential_expression_repeat1] = STATE(3119),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1724),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(1744),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_COLON_GT] = ACTIONS(1752),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_LT_DASH] = ACTIONS(1768),
    [anon_sym_DOT_LBRACK] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_DOT_DOT] = ACTIONS(261),
    [anon_sym_begin] = ACTIONS(1782),
    [anon_sym_LPAREN2] = ACTIONS(1784),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(1800),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(1804),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
    [sym__newline] = ACTIONS(1812),
  },
  [333] = {
    [sym_function_or_value_defn] = STATE(1099),
    [sym__expression] = STATE(422),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1020),
    [sym_infix_op] = STATE(1104),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(2924),
    [sym_block_comment] = STATE(333),
    [sym_compiler_directive_decl] = STATE(333),
    [sym_fsi_directive_decl] = STATE(333),
    [sym_preproc_line] = STATE(333),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_sequential_expression_repeat1] = STATE(3001),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(1494),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(649),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(667),
    [anon_sym_DOT] = ACTIONS(669),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(1492),
    [anon_sym_return_BANG] = ACTIONS(1496),
    [anon_sym_yield] = ACTIONS(1492),
    [anon_sym_yield_BANG] = ACTIONS(1496),
    [anon_sym_lazy] = ACTIONS(1492),
    [anon_sym_assert] = ACTIONS(1492),
    [anon_sym_upcast] = ACTIONS(1492),
    [anon_sym_downcast] = ACTIONS(1492),
    [anon_sym_COLON_GT] = ACTIONS(675),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_LT_DASH] = ACTIONS(1498),
    [anon_sym_DOT_LBRACK] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_use] = ACTIONS(1500),
    [anon_sym_use_BANG] = ACTIONS(1502),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [anon_sym_LPAREN2] = ACTIONS(705),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(721),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1504),
    [sym_xint] = ACTIONS(1506),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
    [anon_sym_POUNDendif] = ACTIONS(1392),
    [sym__newline] = ACTIONS(1508),
  },
  [334] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(334),
    [sym_compiler_directive_decl] = STATE(334),
    [sym_fsi_directive_decl] = STATE(334),
    [sym_preproc_line] = STATE(334),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2002),
  },
  [335] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(335),
    [sym_compiler_directive_decl] = STATE(335),
    [sym_fsi_directive_decl] = STATE(335),
    [sym_preproc_line] = STATE(335),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2004),
  },
  [336] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(336),
    [sym_compiler_directive_decl] = STATE(336),
    [sym_fsi_directive_decl] = STATE(336),
    [sym_preproc_line] = STATE(336),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2006),
  },
  [337] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(358),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1151),
    [sym_infix_op] = STATE(1064),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(337),
    [sym_compiler_directive_decl] = STATE(337),
    [sym_fsi_directive_decl] = STATE(337),
    [sym_preproc_line] = STATE(337),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_sequential_expression_repeat1] = STATE(3119),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(2008),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1724),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(1744),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_COLON_GT] = ACTIONS(1752),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_LT_DASH] = ACTIONS(1768),
    [anon_sym_DOT_LBRACK] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_DOT_DOT] = ACTIONS(1780),
    [anon_sym_begin] = ACTIONS(1782),
    [anon_sym_LPAREN2] = ACTIONS(1784),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(1800),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(1804),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
    [sym__newline] = ACTIONS(1812),
  },
  [338] = {
    [sym_function_or_value_defn] = STATE(783),
    [sym__expression] = STATE(338),
    [sym_literal_expression] = STATE(3553),
    [sym_long_identifier_or_op] = STATE(3553),
    [sym_tuple_expression] = STATE(3553),
    [sym_brace_expression] = STATE(3553),
    [sym_anon_record_expression] = STATE(3553),
    [sym_prefixed_expression] = STATE(3553),
    [sym_typecast_expression] = STATE(3553),
    [sym_for_expression] = STATE(3553),
    [sym_while_expression] = STATE(3553),
    [sym__if_branch] = STATE(10567),
    [sym_if_expression] = STATE(3553),
    [sym_fun_expression] = STATE(3553),
    [sym_try_expression] = STATE(3553),
    [sym_match_expression] = STATE(3553),
    [sym_function_expression] = STATE(3553),
    [sym_mutate_expression] = STATE(3553),
    [sym_index_expression] = STATE(3553),
    [sym_typed_expression] = STATE(3553),
    [sym_declaration_expression] = STATE(3553),
    [sym_do_expression] = STATE(3553),
    [sym_list_expression] = STATE(3553),
    [sym_array_expression] = STATE(3553),
    [sym_begin_end_expression] = STATE(3553),
    [sym_paren_expression] = STATE(3553),
    [sym__high_prec_app] = STATE(3532),
    [sym__low_prec_app] = STATE(3532),
    [sym_application_expression] = STATE(3553),
    [sym_dot_expression] = STATE(3553),
    [sym_infix_expression] = STATE(3553),
    [sym_ce_expression] = STATE(3553),
    [sym_sequential_expression] = STATE(3553),
    [sym_char] = STATE(3265),
    [sym_format_string] = STATE(3261),
    [sym__string_literal] = STATE(3261),
    [sym_string] = STATE(3265),
    [sym_verbatim_string] = STATE(3265),
    [sym_bytearray] = STATE(3265),
    [sym_verbatim_bytearray] = STATE(3265),
    [sym_format_triple_quoted_string] = STATE(3260),
    [sym_triple_quoted_string] = STATE(3265),
    [sym_const] = STATE(3553),
    [sym_long_identifier] = STATE(3203),
    [sym_active_pattern] = STATE(3576),
    [sym__identifier_or_op] = STATE(3362),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1076),
    [sym_infix_op] = STATE(975),
    [sym_sbyte] = STATE(3265),
    [sym_byte] = STATE(3265),
    [sym_int16] = STATE(3265),
    [sym_uint16] = STATE(3265),
    [sym_int32] = STATE(3265),
    [sym_uint32] = STATE(3265),
    [sym_nativeint] = STATE(3265),
    [sym_unativeint] = STATE(3265),
    [sym_int64] = STATE(3265),
    [sym_uint64] = STATE(3265),
    [sym_ieee32] = STATE(3265),
    [sym_ieee64] = STATE(3265),
    [sym_bignum] = STATE(3265),
    [sym_decimal] = STATE(3265),
    [sym_float] = STATE(2797),
    [sym_block_comment] = STATE(338),
    [sym_compiler_directive_decl] = STATE(338),
    [sym_fsi_directive_decl] = STATE(338),
    [sym_preproc_line] = STATE(338),
    [sym_preproc_if_in_expression] = STATE(3553),
    [aux_sym_sequential_expression_repeat1] = STATE(3067),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_EQ] = ACTIONS(223),
    [anon_sym_COLON] = ACTIONS(225),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_do] = ACTIONS(225),
    [anon_sym_let] = ACTIONS(225),
    [anon_sym_let_BANG] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_COMMA] = ACTIONS(223),
    [anon_sym_null] = ACTIONS(225),
    [anon_sym_QMARK] = ACTIONS(225),
    [anon_sym_COLON_QMARK] = ACTIONS(225),
    [anon_sym_COLON_COLON] = ACTIONS(223),
    [anon_sym_AMP] = ACTIONS(225),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LBRACK_PIPE] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(225),
    [anon_sym_LT_AT] = ACTIONS(225),
    [anon_sym_LT_AT_AT] = ACTIONS(225),
    [anon_sym_DOT] = ACTIONS(1656),
    [anon_sym_LBRACE_PIPE] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(225),
    [anon_sym_return_BANG] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(225),
    [anon_sym_yield_BANG] = ACTIONS(223),
    [anon_sym_lazy] = ACTIONS(225),
    [anon_sym_assert] = ACTIONS(225),
    [anon_sym_upcast] = ACTIONS(225),
    [anon_sym_downcast] = ACTIONS(225),
    [anon_sym_COLON_GT] = ACTIONS(223),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(223),
    [anon_sym_for] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_fun] = ACTIONS(225),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_match] = ACTIONS(225),
    [anon_sym_match_BANG] = ACTIONS(223),
    [anon_sym_function] = ACTIONS(225),
    [anon_sym_LT_DASH] = ACTIONS(225),
    [anon_sym_DOT_LBRACK] = ACTIONS(1680),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(225),
    [anon_sym_use] = ACTIONS(225),
    [anon_sym_use_BANG] = ACTIONS(223),
    [anon_sym_do_BANG] = ACTIONS(223),
    [anon_sym_begin] = ACTIONS(225),
    [anon_sym_LPAREN2] = ACTIONS(1692),
    [anon_sym_or] = ACTIONS(225),
    [aux_sym_char_token1] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_AT_DQUOTE] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [sym_bool] = ACTIONS(225),
    [sym_unit] = ACTIONS(1708),
    [anon_sym_LPAREN_PIPE] = ACTIONS(225),
    [sym_op_identifier] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(225),
    [anon_sym_DASH] = ACTIONS(225),
    [anon_sym_PLUS_DOT] = ACTIONS(225),
    [anon_sym_DASH_DOT] = ACTIONS(225),
    [anon_sym_PERCENT] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_TILDE] = ACTIONS(223),
    [aux_sym_prefix_op_token1] = ACTIONS(225),
    [aux_sym_infix_op_token1] = ACTIONS(223),
    [aux_sym_infix_op_token2] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_BANG_EQ] = ACTIONS(225),
    [anon_sym_COLON_EQ] = ACTIONS(223),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(225),
    [sym_int] = ACTIONS(225),
    [sym_xint] = ACTIONS(223),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(223),
    [sym__newline] = ACTIONS(223),
  },
  [339] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(346),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(890),
    [sym_infix_op] = STATE(904),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(339),
    [sym_compiler_directive_decl] = STATE(339),
    [sym_fsi_directive_decl] = STATE(339),
    [sym_preproc_line] = STATE(339),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_sequential_expression_repeat1] = STATE(3140),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_COMMA] = ACTIONS(1522),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1514),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(1820),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_AT_GT] = ACTIONS(2010),
    [anon_sym_LT_AT_AT] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1534),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_COLON_GT] = ACTIONS(1540),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_LT_DASH] = ACTIONS(1556),
    [anon_sym_DOT_LBRACK] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [anon_sym_LPAREN2] = ACTIONS(1570),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(1586),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(1590),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
    [sym__newline] = ACTIONS(1824),
  },
  [340] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(340),
    [sym_compiler_directive_decl] = STATE(340),
    [sym_fsi_directive_decl] = STATE(340),
    [sym_preproc_line] = STATE(340),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(1448),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [341] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(341),
    [sym_compiler_directive_decl] = STATE(341),
    [sym_fsi_directive_decl] = STATE(341),
    [sym_preproc_line] = STATE(341),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2012),
  },
  [342] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(471),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1045),
    [sym_infix_op] = STATE(886),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(342),
    [sym_compiler_directive_decl] = STATE(342),
    [sym_fsi_directive_decl] = STATE(342),
    [sym_preproc_line] = STATE(342),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(3142),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1600),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1604),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1600),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_COLON_GT] = ACTIONS(1608),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1608),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(2014),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1614),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(1622),
  },
  [343] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(343),
    [sym_compiler_directive_decl] = STATE(343),
    [sym_fsi_directive_decl] = STATE(343),
    [sym_preproc_line] = STATE(343),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2016),
  },
  [344] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(344),
    [sym_compiler_directive_decl] = STATE(344),
    [sym_fsi_directive_decl] = STATE(344),
    [sym_preproc_line] = STATE(344),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2018),
  },
  [345] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(309),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1022),
    [sym_infix_op] = STATE(891),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(345),
    [sym_compiler_directive_decl] = STATE(345),
    [sym_fsi_directive_decl] = STATE(345),
    [sym_preproc_line] = STATE(345),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_sequential_expression_repeat1] = STATE(2972),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_COMMA] = ACTIONS(1836),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(1848),
    [anon_sym_AT_AT_GT] = ACTIONS(2010),
    [anon_sym_DOT] = ACTIONS(1850),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_COLON_GT] = ACTIONS(1856),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1856),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_LT_DASH] = ACTIONS(1872),
    [anon_sym_DOT_LBRACK] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [anon_sym_LPAREN2] = ACTIONS(1886),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(1902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(1906),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
    [sym__newline] = ACTIONS(1914),
  },
  [346] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(346),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(890),
    [sym_infix_op] = STATE(904),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(346),
    [sym_compiler_directive_decl] = STATE(346),
    [sym_fsi_directive_decl] = STATE(346),
    [sym_preproc_line] = STATE(346),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_sequential_expression_repeat1] = STATE(3140),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_EQ] = ACTIONS(223),
    [anon_sym_COLON] = ACTIONS(225),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_do] = ACTIONS(225),
    [anon_sym_let] = ACTIONS(225),
    [anon_sym_let_BANG] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_COMMA] = ACTIONS(223),
    [anon_sym_null] = ACTIONS(225),
    [anon_sym_QMARK] = ACTIONS(225),
    [anon_sym_COLON_QMARK] = ACTIONS(225),
    [anon_sym_COLON_COLON] = ACTIONS(223),
    [anon_sym_AMP] = ACTIONS(225),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LBRACK_PIPE] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(225),
    [anon_sym_LT_AT] = ACTIONS(225),
    [anon_sym_AT_GT] = ACTIONS(225),
    [anon_sym_LT_AT_AT] = ACTIONS(225),
    [anon_sym_DOT] = ACTIONS(1534),
    [anon_sym_LBRACE_PIPE] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(225),
    [anon_sym_return_BANG] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(225),
    [anon_sym_yield_BANG] = ACTIONS(223),
    [anon_sym_lazy] = ACTIONS(225),
    [anon_sym_assert] = ACTIONS(225),
    [anon_sym_upcast] = ACTIONS(225),
    [anon_sym_downcast] = ACTIONS(225),
    [anon_sym_COLON_GT] = ACTIONS(223),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(223),
    [anon_sym_for] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_fun] = ACTIONS(225),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_match] = ACTIONS(225),
    [anon_sym_match_BANG] = ACTIONS(223),
    [anon_sym_function] = ACTIONS(225),
    [anon_sym_LT_DASH] = ACTIONS(225),
    [anon_sym_DOT_LBRACK] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_use] = ACTIONS(225),
    [anon_sym_use_BANG] = ACTIONS(223),
    [anon_sym_do_BANG] = ACTIONS(223),
    [anon_sym_begin] = ACTIONS(225),
    [anon_sym_LPAREN2] = ACTIONS(1570),
    [anon_sym_or] = ACTIONS(225),
    [aux_sym_char_token1] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_AT_DQUOTE] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [sym_bool] = ACTIONS(225),
    [sym_unit] = ACTIONS(1586),
    [anon_sym_LPAREN_PIPE] = ACTIONS(225),
    [sym_op_identifier] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(225),
    [anon_sym_DASH] = ACTIONS(225),
    [anon_sym_PLUS_DOT] = ACTIONS(225),
    [anon_sym_DASH_DOT] = ACTIONS(225),
    [anon_sym_PERCENT] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_TILDE] = ACTIONS(223),
    [aux_sym_prefix_op_token1] = ACTIONS(225),
    [aux_sym_infix_op_token1] = ACTIONS(223),
    [aux_sym_infix_op_token2] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_BANG_EQ] = ACTIONS(225),
    [anon_sym_COLON_EQ] = ACTIONS(223),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(225),
    [sym_int] = ACTIONS(225),
    [sym_xint] = ACTIONS(223),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(223),
    [sym__newline] = ACTIONS(223),
  },
  [347] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(347),
    [sym_compiler_directive_decl] = STATE(347),
    [sym_fsi_directive_decl] = STATE(347),
    [sym_preproc_line] = STATE(347),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2020),
  },
  [348] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(309),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1022),
    [sym_infix_op] = STATE(891),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(348),
    [sym_compiler_directive_decl] = STATE(348),
    [sym_fsi_directive_decl] = STATE(348),
    [sym_preproc_line] = STATE(348),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_sequential_expression_repeat1] = STATE(2972),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_COMMA] = ACTIONS(1836),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(1848),
    [anon_sym_AT_AT_GT] = ACTIONS(2022),
    [anon_sym_DOT] = ACTIONS(1850),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_COLON_GT] = ACTIONS(1856),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1856),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_LT_DASH] = ACTIONS(1872),
    [anon_sym_DOT_LBRACK] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [anon_sym_LPAREN2] = ACTIONS(1886),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(1902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(1906),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
    [sym__newline] = ACTIONS(1914),
  },
  [349] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(349),
    [sym_compiler_directive_decl] = STATE(349),
    [sym_fsi_directive_decl] = STATE(349),
    [sym_preproc_line] = STATE(349),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(2024),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(2026),
  },
  [350] = {
    [sym_function_or_value_defn] = STATE(783),
    [sym__expression] = STATE(338),
    [sym_literal_expression] = STATE(3553),
    [sym_long_identifier_or_op] = STATE(3553),
    [sym_tuple_expression] = STATE(3553),
    [sym_brace_expression] = STATE(3553),
    [sym_anon_record_expression] = STATE(3553),
    [sym_prefixed_expression] = STATE(3553),
    [sym_typecast_expression] = STATE(3553),
    [sym_for_expression] = STATE(3553),
    [sym_while_expression] = STATE(3553),
    [sym__if_branch] = STATE(10567),
    [sym_if_expression] = STATE(3553),
    [sym_fun_expression] = STATE(3553),
    [sym_try_expression] = STATE(3553),
    [sym_match_expression] = STATE(3553),
    [sym_function_expression] = STATE(3553),
    [sym_mutate_expression] = STATE(3553),
    [sym_index_expression] = STATE(3553),
    [sym_typed_expression] = STATE(3553),
    [sym_declaration_expression] = STATE(3553),
    [sym_do_expression] = STATE(3553),
    [sym_list_expression] = STATE(3553),
    [sym_array_expression] = STATE(3553),
    [sym_begin_end_expression] = STATE(3553),
    [sym_paren_expression] = STATE(3553),
    [sym__high_prec_app] = STATE(3532),
    [sym__low_prec_app] = STATE(3532),
    [sym_application_expression] = STATE(3553),
    [sym_dot_expression] = STATE(3553),
    [sym_infix_expression] = STATE(3553),
    [sym_ce_expression] = STATE(3553),
    [sym_sequential_expression] = STATE(3553),
    [sym_char] = STATE(3265),
    [sym_format_string] = STATE(3261),
    [sym__string_literal] = STATE(3261),
    [sym_string] = STATE(3265),
    [sym_verbatim_string] = STATE(3265),
    [sym_bytearray] = STATE(3265),
    [sym_verbatim_bytearray] = STATE(3265),
    [sym_format_triple_quoted_string] = STATE(3260),
    [sym_triple_quoted_string] = STATE(3265),
    [sym_const] = STATE(3553),
    [sym_long_identifier] = STATE(3203),
    [sym_active_pattern] = STATE(3576),
    [sym__identifier_or_op] = STATE(3362),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1076),
    [sym_infix_op] = STATE(975),
    [sym_sbyte] = STATE(3265),
    [sym_byte] = STATE(3265),
    [sym_int16] = STATE(3265),
    [sym_uint16] = STATE(3265),
    [sym_int32] = STATE(3265),
    [sym_uint32] = STATE(3265),
    [sym_nativeint] = STATE(3265),
    [sym_unativeint] = STATE(3265),
    [sym_int64] = STATE(3265),
    [sym_uint64] = STATE(3265),
    [sym_ieee32] = STATE(3265),
    [sym_ieee64] = STATE(3265),
    [sym_bignum] = STATE(3265),
    [sym_decimal] = STATE(3265),
    [sym_float] = STATE(2797),
    [sym_block_comment] = STATE(350),
    [sym_compiler_directive_decl] = STATE(350),
    [sym_fsi_directive_decl] = STATE(350),
    [sym_preproc_line] = STATE(350),
    [sym_preproc_if_in_expression] = STATE(3553),
    [aux_sym_sequential_expression_repeat1] = STATE(3067),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1632),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1634),
    [anon_sym_return] = ACTIONS(1636),
    [anon_sym_do] = ACTIONS(1638),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1640),
    [anon_sym_COMMA] = ACTIONS(1642),
    [anon_sym_null] = ACTIONS(1644),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1634),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1646),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1650),
    [anon_sym_LT_AT] = ACTIONS(1652),
    [anon_sym_LT_AT_AT] = ACTIONS(1654),
    [anon_sym_DOT] = ACTIONS(1656),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1658),
    [anon_sym_new] = ACTIONS(1636),
    [anon_sym_return_BANG] = ACTIONS(1660),
    [anon_sym_yield] = ACTIONS(1636),
    [anon_sym_yield_BANG] = ACTIONS(1660),
    [anon_sym_lazy] = ACTIONS(1636),
    [anon_sym_assert] = ACTIONS(1636),
    [anon_sym_upcast] = ACTIONS(1636),
    [anon_sym_downcast] = ACTIONS(1636),
    [anon_sym_COLON_GT] = ACTIONS(1662),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1662),
    [anon_sym_for] = ACTIONS(1664),
    [anon_sym_while] = ACTIONS(1666),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1668),
    [anon_sym_try] = ACTIONS(1670),
    [anon_sym_match] = ACTIONS(1672),
    [anon_sym_match_BANG] = ACTIONS(1674),
    [anon_sym_function] = ACTIONS(1676),
    [anon_sym_LT_DASH] = ACTIONS(1678),
    [anon_sym_DOT_LBRACK] = ACTIONS(1680),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_use] = ACTIONS(1684),
    [anon_sym_use_BANG] = ACTIONS(1686),
    [anon_sym_do_BANG] = ACTIONS(1688),
    [anon_sym_begin] = ACTIONS(1690),
    [anon_sym_LPAREN2] = ACTIONS(1692),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1694),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1696),
    [anon_sym_DQUOTE] = ACTIONS(1698),
    [anon_sym_AT_DQUOTE] = ACTIONS(1700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1704),
    [sym_bool] = ACTIONS(1706),
    [sym_unit] = ACTIONS(1708),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1710),
    [sym_op_identifier] = ACTIONS(1712),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1714),
    [sym_xint] = ACTIONS(1716),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1718),
    [sym__newline] = ACTIONS(1720),
  },
  [351] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(351),
    [sym_compiler_directive_decl] = STATE(351),
    [sym_fsi_directive_decl] = STATE(351),
    [sym_preproc_line] = STATE(351),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2028),
  },
  [352] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(352),
    [sym_compiler_directive_decl] = STATE(352),
    [sym_fsi_directive_decl] = STATE(352),
    [sym_preproc_line] = STATE(352),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2030),
  },
  [353] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(353),
    [sym_compiler_directive_decl] = STATE(353),
    [sym_fsi_directive_decl] = STATE(353),
    [sym_preproc_line] = STATE(353),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2032),
  },
  [354] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(346),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(890),
    [sym_infix_op] = STATE(904),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(354),
    [sym_compiler_directive_decl] = STATE(354),
    [sym_fsi_directive_decl] = STATE(354),
    [sym_preproc_line] = STATE(354),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_sequential_expression_repeat1] = STATE(3140),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_COMMA] = ACTIONS(1522),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1514),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(1820),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_AT_GT] = ACTIONS(267),
    [anon_sym_LT_AT_AT] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1534),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_COLON_GT] = ACTIONS(1540),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_LT_DASH] = ACTIONS(1556),
    [anon_sym_DOT_LBRACK] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [anon_sym_LPAREN2] = ACTIONS(1570),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(1586),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(1590),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
    [sym__newline] = ACTIONS(1824),
  },
  [355] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(358),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1151),
    [sym_infix_op] = STATE(1064),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(355),
    [sym_compiler_directive_decl] = STATE(355),
    [sym_fsi_directive_decl] = STATE(355),
    [sym_preproc_line] = STATE(355),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_sequential_expression_repeat1] = STATE(3119),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(2034),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1724),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(1744),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_COLON_GT] = ACTIONS(1752),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_LT_DASH] = ACTIONS(1768),
    [anon_sym_DOT_LBRACK] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_DOT_DOT] = ACTIONS(1780),
    [anon_sym_begin] = ACTIONS(1782),
    [anon_sym_LPAREN2] = ACTIONS(1784),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(1800),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(1804),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
    [sym__newline] = ACTIONS(1812),
  },
  [356] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(346),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(890),
    [sym_infix_op] = STATE(904),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(356),
    [sym_compiler_directive_decl] = STATE(356),
    [sym_fsi_directive_decl] = STATE(356),
    [sym_preproc_line] = STATE(356),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_sequential_expression_repeat1] = STATE(3140),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_COMMA] = ACTIONS(1522),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1514),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(1820),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_AT_GT] = ACTIONS(2022),
    [anon_sym_LT_AT_AT] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1534),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_COLON_GT] = ACTIONS(1540),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_LT_DASH] = ACTIONS(1556),
    [anon_sym_DOT_LBRACK] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [anon_sym_LPAREN2] = ACTIONS(1570),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(1586),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(1590),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
    [sym__newline] = ACTIONS(1824),
  },
  [357] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(357),
    [sym_compiler_directive_decl] = STATE(357),
    [sym_fsi_directive_decl] = STATE(357),
    [sym_preproc_line] = STATE(357),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2036),
  },
  [358] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(358),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1151),
    [sym_infix_op] = STATE(1064),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(358),
    [sym_compiler_directive_decl] = STATE(358),
    [sym_fsi_directive_decl] = STATE(358),
    [sym_preproc_line] = STATE(358),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_sequential_expression_repeat1] = STATE(3119),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_EQ] = ACTIONS(223),
    [anon_sym_COLON] = ACTIONS(225),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_do] = ACTIONS(225),
    [anon_sym_let] = ACTIONS(225),
    [anon_sym_let_BANG] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_COMMA] = ACTIONS(223),
    [anon_sym_null] = ACTIONS(225),
    [anon_sym_QMARK] = ACTIONS(225),
    [anon_sym_COLON_QMARK] = ACTIONS(225),
    [anon_sym_COLON_COLON] = ACTIONS(223),
    [anon_sym_AMP] = ACTIONS(225),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LBRACK_PIPE] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(225),
    [anon_sym_LT_AT] = ACTIONS(225),
    [anon_sym_LT_AT_AT] = ACTIONS(225),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(225),
    [anon_sym_return_BANG] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(225),
    [anon_sym_yield_BANG] = ACTIONS(223),
    [anon_sym_lazy] = ACTIONS(225),
    [anon_sym_assert] = ACTIONS(225),
    [anon_sym_upcast] = ACTIONS(225),
    [anon_sym_downcast] = ACTIONS(225),
    [anon_sym_COLON_GT] = ACTIONS(223),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(223),
    [anon_sym_for] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_fun] = ACTIONS(225),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_match] = ACTIONS(225),
    [anon_sym_match_BANG] = ACTIONS(223),
    [anon_sym_function] = ACTIONS(225),
    [anon_sym_LT_DASH] = ACTIONS(225),
    [anon_sym_DOT_LBRACK] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(225),
    [anon_sym_use_BANG] = ACTIONS(223),
    [anon_sym_do_BANG] = ACTIONS(223),
    [anon_sym_DOT_DOT] = ACTIONS(223),
    [anon_sym_begin] = ACTIONS(225),
    [anon_sym_LPAREN2] = ACTIONS(1784),
    [anon_sym_or] = ACTIONS(225),
    [aux_sym_char_token1] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_AT_DQUOTE] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [sym_bool] = ACTIONS(225),
    [sym_unit] = ACTIONS(1800),
    [anon_sym_LPAREN_PIPE] = ACTIONS(225),
    [sym_op_identifier] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(225),
    [anon_sym_DASH] = ACTIONS(225),
    [anon_sym_PLUS_DOT] = ACTIONS(225),
    [anon_sym_DASH_DOT] = ACTIONS(225),
    [anon_sym_PERCENT] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_TILDE] = ACTIONS(223),
    [aux_sym_prefix_op_token1] = ACTIONS(225),
    [aux_sym_infix_op_token1] = ACTIONS(223),
    [aux_sym_infix_op_token2] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_BANG_EQ] = ACTIONS(225),
    [anon_sym_COLON_EQ] = ACTIONS(223),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(225),
    [sym_int] = ACTIONS(225),
    [sym_xint] = ACTIONS(223),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(223),
    [sym__newline] = ACTIONS(223),
  },
  [359] = {
    [sym_function_or_value_defn] = STATE(783),
    [sym__expression] = STATE(338),
    [sym_literal_expression] = STATE(3553),
    [sym_long_identifier_or_op] = STATE(3553),
    [sym_tuple_expression] = STATE(3553),
    [sym_brace_expression] = STATE(3553),
    [sym_anon_record_expression] = STATE(3553),
    [sym_prefixed_expression] = STATE(3553),
    [sym_typecast_expression] = STATE(3553),
    [sym_for_expression] = STATE(3553),
    [sym_while_expression] = STATE(3553),
    [sym__if_branch] = STATE(10567),
    [sym_if_expression] = STATE(3553),
    [sym_fun_expression] = STATE(3553),
    [sym_try_expression] = STATE(3553),
    [sym_match_expression] = STATE(3553),
    [sym_function_expression] = STATE(3553),
    [sym_mutate_expression] = STATE(3553),
    [sym_index_expression] = STATE(3553),
    [sym_typed_expression] = STATE(3553),
    [sym_declaration_expression] = STATE(3553),
    [sym_do_expression] = STATE(3553),
    [sym_list_expression] = STATE(3553),
    [sym_array_expression] = STATE(3553),
    [sym_begin_end_expression] = STATE(3553),
    [sym_paren_expression] = STATE(3553),
    [sym__high_prec_app] = STATE(3532),
    [sym__low_prec_app] = STATE(3532),
    [sym_application_expression] = STATE(3553),
    [sym_dot_expression] = STATE(3553),
    [sym_infix_expression] = STATE(3553),
    [sym_ce_expression] = STATE(3553),
    [sym_sequential_expression] = STATE(3553),
    [sym_char] = STATE(3265),
    [sym_format_string] = STATE(3261),
    [sym__string_literal] = STATE(3261),
    [sym_string] = STATE(3265),
    [sym_verbatim_string] = STATE(3265),
    [sym_bytearray] = STATE(3265),
    [sym_verbatim_bytearray] = STATE(3265),
    [sym_format_triple_quoted_string] = STATE(3260),
    [sym_triple_quoted_string] = STATE(3265),
    [sym_const] = STATE(3553),
    [sym_long_identifier] = STATE(3203),
    [sym_active_pattern] = STATE(3576),
    [sym__identifier_or_op] = STATE(3362),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1076),
    [sym_infix_op] = STATE(975),
    [sym_sbyte] = STATE(3265),
    [sym_byte] = STATE(3265),
    [sym_int16] = STATE(3265),
    [sym_uint16] = STATE(3265),
    [sym_int32] = STATE(3265),
    [sym_uint32] = STATE(3265),
    [sym_nativeint] = STATE(3265),
    [sym_unativeint] = STATE(3265),
    [sym_int64] = STATE(3265),
    [sym_uint64] = STATE(3265),
    [sym_ieee32] = STATE(3265),
    [sym_ieee64] = STATE(3265),
    [sym_bignum] = STATE(3265),
    [sym_decimal] = STATE(3265),
    [sym_float] = STATE(2797),
    [sym_block_comment] = STATE(359),
    [sym_compiler_directive_decl] = STATE(359),
    [sym_fsi_directive_decl] = STATE(359),
    [sym_preproc_line] = STATE(359),
    [sym_preproc_if_in_expression] = STATE(3553),
    [aux_sym_sequential_expression_repeat1] = STATE(3067),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1632),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1634),
    [anon_sym_return] = ACTIONS(1636),
    [anon_sym_do] = ACTIONS(1638),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1640),
    [anon_sym_COMMA] = ACTIONS(1642),
    [anon_sym_null] = ACTIONS(1644),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1634),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1646),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1650),
    [anon_sym_LT_AT] = ACTIONS(1652),
    [anon_sym_LT_AT_AT] = ACTIONS(1654),
    [anon_sym_DOT] = ACTIONS(1656),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1658),
    [anon_sym_new] = ACTIONS(1636),
    [anon_sym_return_BANG] = ACTIONS(1660),
    [anon_sym_yield] = ACTIONS(1636),
    [anon_sym_yield_BANG] = ACTIONS(1660),
    [anon_sym_lazy] = ACTIONS(1636),
    [anon_sym_assert] = ACTIONS(1636),
    [anon_sym_upcast] = ACTIONS(1636),
    [anon_sym_downcast] = ACTIONS(1636),
    [anon_sym_COLON_GT] = ACTIONS(1662),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1662),
    [anon_sym_for] = ACTIONS(1664),
    [anon_sym_while] = ACTIONS(1666),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1668),
    [anon_sym_try] = ACTIONS(1670),
    [anon_sym_match] = ACTIONS(1672),
    [anon_sym_match_BANG] = ACTIONS(1674),
    [anon_sym_function] = ACTIONS(1676),
    [anon_sym_LT_DASH] = ACTIONS(1678),
    [anon_sym_DOT_LBRACK] = ACTIONS(1680),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(2038),
    [anon_sym_use] = ACTIONS(1684),
    [anon_sym_use_BANG] = ACTIONS(1686),
    [anon_sym_do_BANG] = ACTIONS(1688),
    [anon_sym_begin] = ACTIONS(1690),
    [anon_sym_LPAREN2] = ACTIONS(1692),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1694),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1696),
    [anon_sym_DQUOTE] = ACTIONS(1698),
    [anon_sym_AT_DQUOTE] = ACTIONS(1700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1704),
    [sym_bool] = ACTIONS(1706),
    [sym_unit] = ACTIONS(1708),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1710),
    [sym_op_identifier] = ACTIONS(1712),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1714),
    [sym_xint] = ACTIONS(1716),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1718),
    [sym__newline] = ACTIONS(1720),
  },
  [360] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(360),
    [sym_compiler_directive_decl] = STATE(360),
    [sym_fsi_directive_decl] = STATE(360),
    [sym_preproc_line] = STATE(360),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2040),
  },
  [361] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(471),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1045),
    [sym_infix_op] = STATE(886),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(361),
    [sym_compiler_directive_decl] = STATE(361),
    [sym_fsi_directive_decl] = STATE(361),
    [sym_preproc_line] = STATE(361),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(3142),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1600),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1604),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1600),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_COLON_GT] = ACTIONS(1608),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1608),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(2042),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1614),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(1622),
  },
  [362] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(362),
    [sym_compiler_directive_decl] = STATE(362),
    [sym_fsi_directive_decl] = STATE(362),
    [sym_preproc_line] = STATE(362),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2044),
  },
  [363] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(363),
    [sym_compiler_directive_decl] = STATE(363),
    [sym_fsi_directive_decl] = STATE(363),
    [sym_preproc_line] = STATE(363),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2046),
  },
  [364] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(364),
    [sym_compiler_directive_decl] = STATE(364),
    [sym_fsi_directive_decl] = STATE(364),
    [sym_preproc_line] = STATE(364),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(2048),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [365] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(365),
    [sym_compiler_directive_decl] = STATE(365),
    [sym_fsi_directive_decl] = STATE(365),
    [sym_preproc_line] = STATE(365),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2050),
  },
  [366] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(366),
    [sym_compiler_directive_decl] = STATE(366),
    [sym_fsi_directive_decl] = STATE(366),
    [sym_preproc_line] = STATE(366),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2052),
  },
  [367] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(367),
    [sym_compiler_directive_decl] = STATE(367),
    [sym_fsi_directive_decl] = STATE(367),
    [sym_preproc_line] = STATE(367),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2054),
  },
  [368] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(368),
    [sym_compiler_directive_decl] = STATE(368),
    [sym_fsi_directive_decl] = STATE(368),
    [sym_preproc_line] = STATE(368),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(2056),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(2058),
  },
  [369] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(369),
    [sym_compiler_directive_decl] = STATE(369),
    [sym_fsi_directive_decl] = STATE(369),
    [sym_preproc_line] = STATE(369),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2060),
  },
  [370] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(346),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(890),
    [sym_infix_op] = STATE(904),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(370),
    [sym_compiler_directive_decl] = STATE(370),
    [sym_fsi_directive_decl] = STATE(370),
    [sym_preproc_line] = STATE(370),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_sequential_expression_repeat1] = STATE(3140),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_COMMA] = ACTIONS(1522),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1514),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(1820),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_AT_GT] = ACTIONS(2062),
    [anon_sym_LT_AT_AT] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1534),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_COLON_GT] = ACTIONS(1540),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_LT_DASH] = ACTIONS(1556),
    [anon_sym_DOT_LBRACK] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [anon_sym_LPAREN2] = ACTIONS(1570),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(1586),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(1590),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
    [sym__newline] = ACTIONS(1824),
  },
  [371] = {
    [sym_function_or_value_defn] = STATE(783),
    [sym__expression] = STATE(338),
    [sym_literal_expression] = STATE(3553),
    [sym_long_identifier_or_op] = STATE(3553),
    [sym_tuple_expression] = STATE(3553),
    [sym_brace_expression] = STATE(3553),
    [sym_anon_record_expression] = STATE(3553),
    [sym_prefixed_expression] = STATE(3553),
    [sym_typecast_expression] = STATE(3553),
    [sym_for_expression] = STATE(3553),
    [sym_while_expression] = STATE(3553),
    [sym__if_branch] = STATE(10567),
    [sym_if_expression] = STATE(3553),
    [sym_fun_expression] = STATE(3553),
    [sym_try_expression] = STATE(3553),
    [sym_match_expression] = STATE(3553),
    [sym_function_expression] = STATE(3553),
    [sym_mutate_expression] = STATE(3553),
    [sym_index_expression] = STATE(3553),
    [sym_typed_expression] = STATE(3553),
    [sym_declaration_expression] = STATE(3553),
    [sym_do_expression] = STATE(3553),
    [sym_list_expression] = STATE(3553),
    [sym_array_expression] = STATE(3553),
    [sym_begin_end_expression] = STATE(3553),
    [sym_paren_expression] = STATE(3553),
    [sym__high_prec_app] = STATE(3532),
    [sym__low_prec_app] = STATE(3532),
    [sym_application_expression] = STATE(3553),
    [sym_dot_expression] = STATE(3553),
    [sym_infix_expression] = STATE(3553),
    [sym_ce_expression] = STATE(3553),
    [sym_sequential_expression] = STATE(3553),
    [sym_char] = STATE(3265),
    [sym_format_string] = STATE(3261),
    [sym__string_literal] = STATE(3261),
    [sym_string] = STATE(3265),
    [sym_verbatim_string] = STATE(3265),
    [sym_bytearray] = STATE(3265),
    [sym_verbatim_bytearray] = STATE(3265),
    [sym_format_triple_quoted_string] = STATE(3260),
    [sym_triple_quoted_string] = STATE(3265),
    [sym_const] = STATE(3553),
    [sym_long_identifier] = STATE(3203),
    [sym_active_pattern] = STATE(3576),
    [sym__identifier_or_op] = STATE(3362),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1076),
    [sym_infix_op] = STATE(975),
    [sym_sbyte] = STATE(3265),
    [sym_byte] = STATE(3265),
    [sym_int16] = STATE(3265),
    [sym_uint16] = STATE(3265),
    [sym_int32] = STATE(3265),
    [sym_uint32] = STATE(3265),
    [sym_nativeint] = STATE(3265),
    [sym_unativeint] = STATE(3265),
    [sym_int64] = STATE(3265),
    [sym_uint64] = STATE(3265),
    [sym_ieee32] = STATE(3265),
    [sym_ieee64] = STATE(3265),
    [sym_bignum] = STATE(3265),
    [sym_decimal] = STATE(3265),
    [sym_float] = STATE(2797),
    [sym_block_comment] = STATE(371),
    [sym_compiler_directive_decl] = STATE(371),
    [sym_fsi_directive_decl] = STATE(371),
    [sym_preproc_line] = STATE(371),
    [sym_preproc_if_in_expression] = STATE(3553),
    [aux_sym_sequential_expression_repeat1] = STATE(3067),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_EQ] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(229),
    [anon_sym_return] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_let] = ACTIONS(229),
    [anon_sym_let_BANG] = ACTIONS(227),
    [anon_sym_LPAREN] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(227),
    [anon_sym_null] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_COLON_QMARK] = ACTIONS(229),
    [anon_sym_COLON_COLON] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_LBRACK] = ACTIONS(229),
    [anon_sym_LBRACK_PIPE] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(229),
    [anon_sym_LT_AT] = ACTIONS(229),
    [anon_sym_LT_AT_AT] = ACTIONS(229),
    [anon_sym_DOT] = ACTIONS(1656),
    [anon_sym_LBRACE_PIPE] = ACTIONS(227),
    [anon_sym_new] = ACTIONS(229),
    [anon_sym_return_BANG] = ACTIONS(227),
    [anon_sym_yield] = ACTIONS(229),
    [anon_sym_yield_BANG] = ACTIONS(227),
    [anon_sym_lazy] = ACTIONS(229),
    [anon_sym_assert] = ACTIONS(229),
    [anon_sym_upcast] = ACTIONS(229),
    [anon_sym_downcast] = ACTIONS(229),
    [anon_sym_COLON_GT] = ACTIONS(227),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_fun] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(229),
    [anon_sym_match_BANG] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(229),
    [anon_sym_LT_DASH] = ACTIONS(229),
    [anon_sym_DOT_LBRACK] = ACTIONS(1680),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(229),
    [anon_sym_use] = ACTIONS(229),
    [anon_sym_use_BANG] = ACTIONS(227),
    [anon_sym_do_BANG] = ACTIONS(227),
    [anon_sym_begin] = ACTIONS(229),
    [anon_sym_LPAREN2] = ACTIONS(1692),
    [anon_sym_or] = ACTIONS(229),
    [aux_sym_char_token1] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_AT_DQUOTE] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [sym_bool] = ACTIONS(229),
    [sym_unit] = ACTIONS(1708),
    [anon_sym_LPAREN_PIPE] = ACTIONS(229),
    [sym_op_identifier] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(229),
    [anon_sym_PLUS_DOT] = ACTIONS(229),
    [anon_sym_DASH_DOT] = ACTIONS(229),
    [anon_sym_PERCENT] = ACTIONS(229),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(227),
    [aux_sym_prefix_op_token1] = ACTIONS(229),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token2] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(229),
    [anon_sym_BANG_EQ] = ACTIONS(229),
    [anon_sym_COLON_EQ] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(229),
    [sym_int] = ACTIONS(229),
    [sym_xint] = ACTIONS(227),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(227),
    [sym__newline] = ACTIONS(227),
  },
  [372] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(372),
    [sym_compiler_directive_decl] = STATE(372),
    [sym_fsi_directive_decl] = STATE(372),
    [sym_preproc_line] = STATE(372),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2064),
  },
  [373] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(358),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1151),
    [sym_infix_op] = STATE(1064),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(373),
    [sym_compiler_directive_decl] = STATE(373),
    [sym_fsi_directive_decl] = STATE(373),
    [sym_preproc_line] = STATE(373),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_sequential_expression_repeat1] = STATE(3119),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(2066),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1724),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(1744),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_COLON_GT] = ACTIONS(1752),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_LT_DASH] = ACTIONS(1768),
    [anon_sym_DOT_LBRACK] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_DOT_DOT] = ACTIONS(1780),
    [anon_sym_begin] = ACTIONS(1782),
    [anon_sym_LPAREN2] = ACTIONS(1784),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(1800),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(1804),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
    [sym__newline] = ACTIONS(1812),
  },
  [374] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(309),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1022),
    [sym_infix_op] = STATE(891),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(374),
    [sym_compiler_directive_decl] = STATE(374),
    [sym_fsi_directive_decl] = STATE(374),
    [sym_preproc_line] = STATE(374),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_sequential_expression_repeat1] = STATE(2972),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_COMMA] = ACTIONS(1836),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(1848),
    [anon_sym_AT_AT_GT] = ACTIONS(2062),
    [anon_sym_DOT] = ACTIONS(1850),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_COLON_GT] = ACTIONS(1856),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1856),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_LT_DASH] = ACTIONS(1872),
    [anon_sym_DOT_LBRACK] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [anon_sym_LPAREN2] = ACTIONS(1886),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(1902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(1906),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
    [sym__newline] = ACTIONS(1914),
  },
  [375] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(375),
    [sym_compiler_directive_decl] = STATE(375),
    [sym_fsi_directive_decl] = STATE(375),
    [sym_preproc_line] = STATE(375),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2068),
  },
  [376] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(376),
    [sym_compiler_directive_decl] = STATE(376),
    [sym_fsi_directive_decl] = STATE(376),
    [sym_preproc_line] = STATE(376),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2070),
  },
  [377] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(377),
    [sym_compiler_directive_decl] = STATE(377),
    [sym_fsi_directive_decl] = STATE(377),
    [sym_preproc_line] = STATE(377),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2072),
  },
  [378] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(378),
    [sym_compiler_directive_decl] = STATE(378),
    [sym_fsi_directive_decl] = STATE(378),
    [sym_preproc_line] = STATE(378),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2074),
  },
  [379] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(471),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1045),
    [sym_infix_op] = STATE(886),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(379),
    [sym_compiler_directive_decl] = STATE(379),
    [sym_fsi_directive_decl] = STATE(379),
    [sym_preproc_line] = STATE(379),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(3142),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1600),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1604),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1600),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_COLON_GT] = ACTIONS(1608),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1608),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(2076),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1614),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(1622),
  },
  [380] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(346),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(890),
    [sym_infix_op] = STATE(904),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(380),
    [sym_compiler_directive_decl] = STATE(380),
    [sym_fsi_directive_decl] = STATE(380),
    [sym_preproc_line] = STATE(380),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_sequential_expression_repeat1] = STATE(3140),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_COMMA] = ACTIONS(1522),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1514),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(1820),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_AT_GT] = ACTIONS(123),
    [anon_sym_LT_AT_AT] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1534),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_COLON_GT] = ACTIONS(1540),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_LT_DASH] = ACTIONS(1556),
    [anon_sym_DOT_LBRACK] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [anon_sym_LPAREN2] = ACTIONS(1570),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(1586),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(1590),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
    [sym__newline] = ACTIONS(119),
  },
  [381] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(381),
    [sym_compiler_directive_decl] = STATE(381),
    [sym_fsi_directive_decl] = STATE(381),
    [sym_preproc_line] = STATE(381),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2078),
  },
  [382] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(382),
    [sym_compiler_directive_decl] = STATE(382),
    [sym_fsi_directive_decl] = STATE(382),
    [sym_preproc_line] = STATE(382),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2080),
  },
  [383] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(471),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1045),
    [sym_infix_op] = STATE(886),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(383),
    [sym_compiler_directive_decl] = STATE(383),
    [sym_fsi_directive_decl] = STATE(383),
    [sym_preproc_line] = STATE(383),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(3142),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1600),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1604),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1600),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_COLON_GT] = ACTIONS(1608),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1608),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(233),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1614),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(1622),
  },
  [384] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(384),
    [sym_compiler_directive_decl] = STATE(384),
    [sym_fsi_directive_decl] = STATE(384),
    [sym_preproc_line] = STATE(384),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2082),
  },
  [385] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(385),
    [sym_compiler_directive_decl] = STATE(385),
    [sym_fsi_directive_decl] = STATE(385),
    [sym_preproc_line] = STATE(385),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2084),
  },
  [386] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(386),
    [sym_compiler_directive_decl] = STATE(386),
    [sym_fsi_directive_decl] = STATE(386),
    [sym_preproc_line] = STATE(386),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(2086),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(2088),
  },
  [387] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(387),
    [sym_compiler_directive_decl] = STATE(387),
    [sym_fsi_directive_decl] = STATE(387),
    [sym_preproc_line] = STATE(387),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(2090),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(2092),
  },
  [388] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(388),
    [sym_compiler_directive_decl] = STATE(388),
    [sym_fsi_directive_decl] = STATE(388),
    [sym_preproc_line] = STATE(388),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2094),
  },
  [389] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(389),
    [sym_compiler_directive_decl] = STATE(389),
    [sym_fsi_directive_decl] = STATE(389),
    [sym_preproc_line] = STATE(389),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1436),
    [sym__dedent] = ACTIONS(1436),
  },
  [390] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(390),
    [sym_compiler_directive_decl] = STATE(390),
    [sym_fsi_directive_decl] = STATE(390),
    [sym_preproc_line] = STATE(390),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2096),
  },
  [391] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(391),
    [sym_compiler_directive_decl] = STATE(391),
    [sym_fsi_directive_decl] = STATE(391),
    [sym_preproc_line] = STATE(391),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2098),
  },
  [392] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(392),
    [sym_compiler_directive_decl] = STATE(392),
    [sym_fsi_directive_decl] = STATE(392),
    [sym_preproc_line] = STATE(392),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2100),
  },
  [393] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(346),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(890),
    [sym_infix_op] = STATE(904),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(393),
    [sym_compiler_directive_decl] = STATE(393),
    [sym_fsi_directive_decl] = STATE(393),
    [sym_preproc_line] = STATE(393),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_sequential_expression_repeat1] = STATE(3140),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_COMMA] = ACTIONS(1522),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1514),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(1820),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_AT_GT] = ACTIONS(2102),
    [anon_sym_LT_AT_AT] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1534),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_COLON_GT] = ACTIONS(1540),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_LT_DASH] = ACTIONS(1556),
    [anon_sym_DOT_LBRACK] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [anon_sym_LPAREN2] = ACTIONS(1570),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(1586),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(1590),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
    [sym__newline] = ACTIONS(1824),
  },
  [394] = {
    [sym_function_or_value_defn] = STATE(1099),
    [sym__expression] = STATE(422),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1020),
    [sym_infix_op] = STATE(1104),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(2924),
    [sym_block_comment] = STATE(394),
    [sym_compiler_directive_decl] = STATE(394),
    [sym_fsi_directive_decl] = STATE(394),
    [sym_preproc_line] = STATE(394),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_sequential_expression_repeat1] = STATE(3001),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(1494),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(649),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(667),
    [anon_sym_DOT] = ACTIONS(669),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(1492),
    [anon_sym_return_BANG] = ACTIONS(1496),
    [anon_sym_yield] = ACTIONS(1492),
    [anon_sym_yield_BANG] = ACTIONS(1496),
    [anon_sym_lazy] = ACTIONS(1492),
    [anon_sym_assert] = ACTIONS(1492),
    [anon_sym_upcast] = ACTIONS(1492),
    [anon_sym_downcast] = ACTIONS(1492),
    [anon_sym_COLON_GT] = ACTIONS(675),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_LT_DASH] = ACTIONS(1498),
    [anon_sym_DOT_LBRACK] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_use] = ACTIONS(1500),
    [anon_sym_use_BANG] = ACTIONS(1502),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [anon_sym_LPAREN2] = ACTIONS(705),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(721),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1504),
    [sym_xint] = ACTIONS(1506),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
    [anon_sym_POUNDendif] = ACTIONS(261),
    [sym__newline] = ACTIONS(1508),
  },
  [395] = {
    [sym_function_or_value_defn] = STATE(1099),
    [sym__expression] = STATE(422),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1020),
    [sym_infix_op] = STATE(1104),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(2924),
    [sym_block_comment] = STATE(395),
    [sym_compiler_directive_decl] = STATE(395),
    [sym_fsi_directive_decl] = STATE(395),
    [sym_preproc_line] = STATE(395),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_sequential_expression_repeat1] = STATE(3001),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(1494),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(649),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(259),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(667),
    [anon_sym_DOT] = ACTIONS(669),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(1492),
    [anon_sym_return_BANG] = ACTIONS(1496),
    [anon_sym_yield] = ACTIONS(1492),
    [anon_sym_yield_BANG] = ACTIONS(1496),
    [anon_sym_lazy] = ACTIONS(1492),
    [anon_sym_assert] = ACTIONS(1492),
    [anon_sym_upcast] = ACTIONS(1492),
    [anon_sym_downcast] = ACTIONS(1492),
    [anon_sym_COLON_GT] = ACTIONS(675),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_LT_DASH] = ACTIONS(1498),
    [anon_sym_DOT_LBRACK] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_use] = ACTIONS(1500),
    [anon_sym_use_BANG] = ACTIONS(1502),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [anon_sym_LPAREN2] = ACTIONS(705),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(721),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1504),
    [sym_xint] = ACTIONS(1506),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
    [anon_sym_POUNDendif] = ACTIONS(257),
    [sym__newline] = ACTIONS(257),
  },
  [396] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(396),
    [sym_compiler_directive_decl] = STATE(396),
    [sym_fsi_directive_decl] = STATE(396),
    [sym_preproc_line] = STATE(396),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2104),
  },
  [397] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(309),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1022),
    [sym_infix_op] = STATE(891),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(397),
    [sym_compiler_directive_decl] = STATE(397),
    [sym_fsi_directive_decl] = STATE(397),
    [sym_preproc_line] = STATE(397),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_sequential_expression_repeat1] = STATE(2972),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_COMMA] = ACTIONS(1836),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(1848),
    [anon_sym_AT_AT_GT] = ACTIONS(2102),
    [anon_sym_DOT] = ACTIONS(1850),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_COLON_GT] = ACTIONS(1856),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1856),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_LT_DASH] = ACTIONS(1872),
    [anon_sym_DOT_LBRACK] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [anon_sym_LPAREN2] = ACTIONS(1886),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(1902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(1906),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
    [sym__newline] = ACTIONS(1914),
  },
  [398] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(398),
    [sym_compiler_directive_decl] = STATE(398),
    [sym_fsi_directive_decl] = STATE(398),
    [sym_preproc_line] = STATE(398),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2106),
  },
  [399] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(399),
    [sym_compiler_directive_decl] = STATE(399),
    [sym_fsi_directive_decl] = STATE(399),
    [sym_preproc_line] = STATE(399),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2108),
  },
  [400] = {
    [sym_function_or_value_defn] = STATE(1099),
    [sym__expression] = STATE(422),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1020),
    [sym_infix_op] = STATE(1104),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(2924),
    [sym_block_comment] = STATE(400),
    [sym_compiler_directive_decl] = STATE(400),
    [sym_fsi_directive_decl] = STATE(400),
    [sym_preproc_line] = STATE(400),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_sequential_expression_repeat1] = STATE(3001),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(1494),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(649),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(255),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(667),
    [anon_sym_DOT] = ACTIONS(669),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(1492),
    [anon_sym_return_BANG] = ACTIONS(1496),
    [anon_sym_yield] = ACTIONS(1492),
    [anon_sym_yield_BANG] = ACTIONS(1496),
    [anon_sym_lazy] = ACTIONS(1492),
    [anon_sym_assert] = ACTIONS(1492),
    [anon_sym_upcast] = ACTIONS(1492),
    [anon_sym_downcast] = ACTIONS(1492),
    [anon_sym_COLON_GT] = ACTIONS(675),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_LT_DASH] = ACTIONS(1498),
    [anon_sym_DOT_LBRACK] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_use] = ACTIONS(1500),
    [anon_sym_use_BANG] = ACTIONS(1502),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [anon_sym_LPAREN2] = ACTIONS(705),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(721),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1504),
    [sym_xint] = ACTIONS(1506),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
    [anon_sym_POUNDendif] = ACTIONS(253),
    [sym__newline] = ACTIONS(253),
  },
  [401] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(358),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1151),
    [sym_infix_op] = STATE(1064),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(401),
    [sym_compiler_directive_decl] = STATE(401),
    [sym_fsi_directive_decl] = STATE(401),
    [sym_preproc_line] = STATE(401),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_sequential_expression_repeat1] = STATE(3119),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(2110),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1724),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(1744),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_COLON_GT] = ACTIONS(1752),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_LT_DASH] = ACTIONS(1768),
    [anon_sym_DOT_LBRACK] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_DOT_DOT] = ACTIONS(1780),
    [anon_sym_begin] = ACTIONS(1782),
    [anon_sym_LPAREN2] = ACTIONS(1784),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(1800),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(1804),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
    [sym__newline] = ACTIONS(1812),
  },
  [402] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(402),
    [sym_compiler_directive_decl] = STATE(402),
    [sym_fsi_directive_decl] = STATE(402),
    [sym_preproc_line] = STATE(402),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2112),
  },
  [403] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(471),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1045),
    [sym_infix_op] = STATE(886),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(403),
    [sym_compiler_directive_decl] = STATE(403),
    [sym_fsi_directive_decl] = STATE(403),
    [sym_preproc_line] = STATE(403),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(3142),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1600),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1604),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1600),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_COLON_GT] = ACTIONS(1608),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1608),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(123),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1614),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(119),
  },
  [404] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(358),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1151),
    [sym_infix_op] = STATE(1064),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(404),
    [sym_compiler_directive_decl] = STATE(404),
    [sym_fsi_directive_decl] = STATE(404),
    [sym_preproc_line] = STATE(404),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_sequential_expression_repeat1] = STATE(3119),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1428),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1724),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(1744),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_COLON_GT] = ACTIONS(1752),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_LT_DASH] = ACTIONS(1768),
    [anon_sym_DOT_LBRACK] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_DOT_DOT] = ACTIONS(2114),
    [anon_sym_begin] = ACTIONS(1782),
    [anon_sym_LPAREN2] = ACTIONS(1784),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(1800),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(1804),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
    [sym__newline] = ACTIONS(1812),
  },
  [405] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(358),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1151),
    [sym_infix_op] = STATE(1064),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(405),
    [sym_compiler_directive_decl] = STATE(405),
    [sym_fsi_directive_decl] = STATE(405),
    [sym_preproc_line] = STATE(405),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_sequential_expression_repeat1] = STATE(3119),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1724),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(1744),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_COLON_GT] = ACTIONS(1752),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_LT_DASH] = ACTIONS(1768),
    [anon_sym_DOT_LBRACK] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_DOT_DOT] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(1782),
    [anon_sym_LPAREN2] = ACTIONS(1784),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(1800),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(1804),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
    [sym__newline] = ACTIONS(1812),
  },
  [406] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(406),
    [sym_compiler_directive_decl] = STATE(406),
    [sym_fsi_directive_decl] = STATE(406),
    [sym_preproc_line] = STATE(406),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2116),
  },
  [407] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(471),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1045),
    [sym_infix_op] = STATE(886),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(407),
    [sym_compiler_directive_decl] = STATE(407),
    [sym_fsi_directive_decl] = STATE(407),
    [sym_preproc_line] = STATE(407),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(3142),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1600),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1604),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1600),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_COLON_GT] = ACTIONS(1608),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1608),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(2118),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1614),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(1622),
  },
  [408] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(408),
    [sym_compiler_directive_decl] = STATE(408),
    [sym_fsi_directive_decl] = STATE(408),
    [sym_preproc_line] = STATE(408),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2120),
  },
  [409] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(409),
    [sym_compiler_directive_decl] = STATE(409),
    [sym_fsi_directive_decl] = STATE(409),
    [sym_preproc_line] = STATE(409),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2122),
  },
  [410] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(410),
    [sym_compiler_directive_decl] = STATE(410),
    [sym_fsi_directive_decl] = STATE(410),
    [sym_preproc_line] = STATE(410),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2124),
  },
  [411] = {
    [sym_function_or_value_defn] = STATE(1099),
    [sym__expression] = STATE(422),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1020),
    [sym_infix_op] = STATE(1104),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(2924),
    [sym_block_comment] = STATE(411),
    [sym_compiler_directive_decl] = STATE(411),
    [sym_fsi_directive_decl] = STATE(411),
    [sym_preproc_line] = STATE(411),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_sequential_expression_repeat1] = STATE(3001),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(1494),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(649),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(667),
    [anon_sym_DOT] = ACTIONS(669),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(1492),
    [anon_sym_return_BANG] = ACTIONS(1496),
    [anon_sym_yield] = ACTIONS(1492),
    [anon_sym_yield_BANG] = ACTIONS(1496),
    [anon_sym_lazy] = ACTIONS(1492),
    [anon_sym_assert] = ACTIONS(1492),
    [anon_sym_upcast] = ACTIONS(1492),
    [anon_sym_downcast] = ACTIONS(1492),
    [anon_sym_COLON_GT] = ACTIONS(675),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_LT_DASH] = ACTIONS(1498),
    [anon_sym_DOT_LBRACK] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_use] = ACTIONS(1500),
    [anon_sym_use_BANG] = ACTIONS(1502),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [anon_sym_LPAREN2] = ACTIONS(705),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(721),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1504),
    [sym_xint] = ACTIONS(1506),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
    [anon_sym_POUNDendif] = ACTIONS(2126),
    [sym__newline] = ACTIONS(1508),
  },
  [412] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(412),
    [sym_compiler_directive_decl] = STATE(412),
    [sym_fsi_directive_decl] = STATE(412),
    [sym_preproc_line] = STATE(412),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2128),
  },
  [413] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(413),
    [sym_compiler_directive_decl] = STATE(413),
    [sym_fsi_directive_decl] = STATE(413),
    [sym_preproc_line] = STATE(413),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(2130),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(2132),
  },
  [414] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(414),
    [sym_compiler_directive_decl] = STATE(414),
    [sym_fsi_directive_decl] = STATE(414),
    [sym_preproc_line] = STATE(414),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2134),
  },
  [415] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(415),
    [sym_compiler_directive_decl] = STATE(415),
    [sym_fsi_directive_decl] = STATE(415),
    [sym_preproc_line] = STATE(415),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2136),
  },
  [416] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(471),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1045),
    [sym_infix_op] = STATE(886),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(416),
    [sym_compiler_directive_decl] = STATE(416),
    [sym_fsi_directive_decl] = STATE(416),
    [sym_preproc_line] = STATE(416),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(3142),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1600),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1604),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1600),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_COLON_GT] = ACTIONS(1608),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1608),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(267),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1614),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(1622),
  },
  [417] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(417),
    [sym_compiler_directive_decl] = STATE(417),
    [sym_fsi_directive_decl] = STATE(417),
    [sym_preproc_line] = STATE(417),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(2138),
    [sym__dedent] = ACTIONS(2138),
  },
  [418] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(346),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(890),
    [sym_infix_op] = STATE(904),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(418),
    [sym_compiler_directive_decl] = STATE(418),
    [sym_fsi_directive_decl] = STATE(418),
    [sym_preproc_line] = STATE(418),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_sequential_expression_repeat1] = STATE(3140),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_COMMA] = ACTIONS(1522),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1514),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(1820),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_AT_GT] = ACTIONS(2140),
    [anon_sym_LT_AT_AT] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1534),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_COLON_GT] = ACTIONS(1540),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_LT_DASH] = ACTIONS(1556),
    [anon_sym_DOT_LBRACK] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [anon_sym_LPAREN2] = ACTIONS(1570),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(1586),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(1590),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
    [sym__newline] = ACTIONS(1824),
  },
  [419] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(309),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1022),
    [sym_infix_op] = STATE(891),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(419),
    [sym_compiler_directive_decl] = STATE(419),
    [sym_fsi_directive_decl] = STATE(419),
    [sym_preproc_line] = STATE(419),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_sequential_expression_repeat1] = STATE(2972),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_COMMA] = ACTIONS(1836),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(1848),
    [anon_sym_AT_AT_GT] = ACTIONS(2140),
    [anon_sym_DOT] = ACTIONS(1850),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_COLON_GT] = ACTIONS(1856),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1856),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_LT_DASH] = ACTIONS(1872),
    [anon_sym_DOT_LBRACK] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [anon_sym_LPAREN2] = ACTIONS(1886),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(1902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(1906),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
    [sym__newline] = ACTIONS(1914),
  },
  [420] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(420),
    [sym_compiler_directive_decl] = STATE(420),
    [sym_fsi_directive_decl] = STATE(420),
    [sym_preproc_line] = STATE(420),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2142),
  },
  [421] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(358),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1151),
    [sym_infix_op] = STATE(1064),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(421),
    [sym_compiler_directive_decl] = STATE(421),
    [sym_fsi_directive_decl] = STATE(421),
    [sym_preproc_line] = STATE(421),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_sequential_expression_repeat1] = STATE(3119),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(2144),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1724),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(1744),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_COLON_GT] = ACTIONS(1752),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_LT_DASH] = ACTIONS(1768),
    [anon_sym_DOT_LBRACK] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_DOT_DOT] = ACTIONS(1780),
    [anon_sym_begin] = ACTIONS(1782),
    [anon_sym_LPAREN2] = ACTIONS(1784),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(1800),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(1804),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
    [sym__newline] = ACTIONS(1812),
  },
  [422] = {
    [sym_function_or_value_defn] = STATE(1099),
    [sym__expression] = STATE(422),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1020),
    [sym_infix_op] = STATE(1104),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(2924),
    [sym_block_comment] = STATE(422),
    [sym_compiler_directive_decl] = STATE(422),
    [sym_fsi_directive_decl] = STATE(422),
    [sym_preproc_line] = STATE(422),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_sequential_expression_repeat1] = STATE(3001),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_EQ] = ACTIONS(223),
    [anon_sym_COLON] = ACTIONS(225),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_do] = ACTIONS(225),
    [anon_sym_let] = ACTIONS(225),
    [anon_sym_let_BANG] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_COMMA] = ACTIONS(223),
    [anon_sym_null] = ACTIONS(225),
    [anon_sym_QMARK] = ACTIONS(225),
    [anon_sym_COLON_QMARK] = ACTIONS(225),
    [anon_sym_COLON_COLON] = ACTIONS(223),
    [anon_sym_AMP] = ACTIONS(225),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LBRACK_PIPE] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(225),
    [anon_sym_LT_AT] = ACTIONS(225),
    [anon_sym_LT_AT_AT] = ACTIONS(225),
    [anon_sym_DOT] = ACTIONS(669),
    [anon_sym_LBRACE_PIPE] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(225),
    [anon_sym_return_BANG] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(225),
    [anon_sym_yield_BANG] = ACTIONS(223),
    [anon_sym_lazy] = ACTIONS(225),
    [anon_sym_assert] = ACTIONS(225),
    [anon_sym_upcast] = ACTIONS(225),
    [anon_sym_downcast] = ACTIONS(225),
    [anon_sym_COLON_GT] = ACTIONS(223),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(223),
    [anon_sym_for] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_fun] = ACTIONS(225),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_match] = ACTIONS(225),
    [anon_sym_match_BANG] = ACTIONS(223),
    [anon_sym_function] = ACTIONS(225),
    [anon_sym_LT_DASH] = ACTIONS(225),
    [anon_sym_DOT_LBRACK] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_use] = ACTIONS(225),
    [anon_sym_use_BANG] = ACTIONS(223),
    [anon_sym_do_BANG] = ACTIONS(223),
    [anon_sym_begin] = ACTIONS(225),
    [anon_sym_LPAREN2] = ACTIONS(705),
    [anon_sym_or] = ACTIONS(225),
    [aux_sym_char_token1] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_AT_DQUOTE] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [sym_bool] = ACTIONS(225),
    [sym_unit] = ACTIONS(721),
    [anon_sym_LPAREN_PIPE] = ACTIONS(225),
    [sym_op_identifier] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(225),
    [anon_sym_DASH] = ACTIONS(225),
    [anon_sym_PLUS_DOT] = ACTIONS(225),
    [anon_sym_DASH_DOT] = ACTIONS(225),
    [anon_sym_PERCENT] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_TILDE] = ACTIONS(223),
    [aux_sym_prefix_op_token1] = ACTIONS(225),
    [aux_sym_infix_op_token1] = ACTIONS(223),
    [aux_sym_infix_op_token2] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_BANG_EQ] = ACTIONS(225),
    [anon_sym_COLON_EQ] = ACTIONS(223),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(225),
    [sym_int] = ACTIONS(225),
    [sym_xint] = ACTIONS(223),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(223),
    [anon_sym_POUNDendif] = ACTIONS(223),
    [sym__newline] = ACTIONS(223),
  },
  [423] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(423),
    [sym_compiler_directive_decl] = STATE(423),
    [sym_fsi_directive_decl] = STATE(423),
    [sym_preproc_line] = STATE(423),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2146),
  },
  [424] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(358),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1151),
    [sym_infix_op] = STATE(1064),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(424),
    [sym_compiler_directive_decl] = STATE(424),
    [sym_fsi_directive_decl] = STATE(424),
    [sym_preproc_line] = STATE(424),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_sequential_expression_repeat1] = STATE(3119),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1724),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(1744),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_COLON_GT] = ACTIONS(1752),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_LT_DASH] = ACTIONS(1768),
    [anon_sym_DOT_LBRACK] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_DOT_DOT] = ACTIONS(119),
    [anon_sym_begin] = ACTIONS(1782),
    [anon_sym_LPAREN2] = ACTIONS(1784),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(1800),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(1804),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
    [sym__newline] = ACTIONS(119),
  },
  [425] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(425),
    [sym_compiler_directive_decl] = STATE(425),
    [sym_fsi_directive_decl] = STATE(425),
    [sym_preproc_line] = STATE(425),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2148),
  },
  [426] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(309),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1022),
    [sym_infix_op] = STATE(891),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(426),
    [sym_compiler_directive_decl] = STATE(426),
    [sym_fsi_directive_decl] = STATE(426),
    [sym_preproc_line] = STATE(426),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_sequential_expression_repeat1] = STATE(2972),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_COMMA] = ACTIONS(1836),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(1848),
    [anon_sym_AT_AT_GT] = ACTIONS(2150),
    [anon_sym_DOT] = ACTIONS(1850),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_COLON_GT] = ACTIONS(1856),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1856),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_LT_DASH] = ACTIONS(1872),
    [anon_sym_DOT_LBRACK] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [anon_sym_LPAREN2] = ACTIONS(1886),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(1902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(1906),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
    [sym__newline] = ACTIONS(1914),
  },
  [427] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(427),
    [sym_compiler_directive_decl] = STATE(427),
    [sym_fsi_directive_decl] = STATE(427),
    [sym_preproc_line] = STATE(427),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(2138),
    [sym__dedent] = ACTIONS(2138),
  },
  [428] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(471),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1045),
    [sym_infix_op] = STATE(886),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(428),
    [sym_compiler_directive_decl] = STATE(428),
    [sym_fsi_directive_decl] = STATE(428),
    [sym_preproc_line] = STATE(428),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(3142),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1600),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1604),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1600),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_COLON_GT] = ACTIONS(1608),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1608),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(245),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1614),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(243),
  },
  [429] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(346),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(890),
    [sym_infix_op] = STATE(904),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(429),
    [sym_compiler_directive_decl] = STATE(429),
    [sym_fsi_directive_decl] = STATE(429),
    [sym_preproc_line] = STATE(429),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_sequential_expression_repeat1] = STATE(3140),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_COMMA] = ACTIONS(1522),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1514),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(1820),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_AT_GT] = ACTIONS(2152),
    [anon_sym_LT_AT_AT] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1534),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_COLON_GT] = ACTIONS(1540),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_LT_DASH] = ACTIONS(1556),
    [anon_sym_DOT_LBRACK] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [anon_sym_LPAREN2] = ACTIONS(1570),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(1586),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(1590),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
    [sym__newline] = ACTIONS(1824),
  },
  [430] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(309),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1022),
    [sym_infix_op] = STATE(891),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(430),
    [sym_compiler_directive_decl] = STATE(430),
    [sym_fsi_directive_decl] = STATE(430),
    [sym_preproc_line] = STATE(430),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_sequential_expression_repeat1] = STATE(2972),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_COMMA] = ACTIONS(1836),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(1848),
    [anon_sym_AT_AT_GT] = ACTIONS(2152),
    [anon_sym_DOT] = ACTIONS(1850),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_COLON_GT] = ACTIONS(1856),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1856),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_LT_DASH] = ACTIONS(1872),
    [anon_sym_DOT_LBRACK] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [anon_sym_LPAREN2] = ACTIONS(1886),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(1902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(1906),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
    [sym__newline] = ACTIONS(1914),
  },
  [431] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(431),
    [sym_compiler_directive_decl] = STATE(431),
    [sym_fsi_directive_decl] = STATE(431),
    [sym_preproc_line] = STATE(431),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2154),
  },
  [432] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(346),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(890),
    [sym_infix_op] = STATE(904),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(432),
    [sym_compiler_directive_decl] = STATE(432),
    [sym_fsi_directive_decl] = STATE(432),
    [sym_preproc_line] = STATE(432),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_sequential_expression_repeat1] = STATE(3140),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_COMMA] = ACTIONS(1522),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1514),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(1820),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_AT_GT] = ACTIONS(2150),
    [anon_sym_LT_AT_AT] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1534),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_COLON_GT] = ACTIONS(1540),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_LT_DASH] = ACTIONS(1556),
    [anon_sym_DOT_LBRACK] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [anon_sym_LPAREN2] = ACTIONS(1570),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(1586),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(1590),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
    [sym__newline] = ACTIONS(1824),
  },
  [433] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(433),
    [sym_compiler_directive_decl] = STATE(433),
    [sym_fsi_directive_decl] = STATE(433),
    [sym_preproc_line] = STATE(433),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2156),
  },
  [434] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(471),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1045),
    [sym_infix_op] = STATE(886),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(434),
    [sym_compiler_directive_decl] = STATE(434),
    [sym_fsi_directive_decl] = STATE(434),
    [sym_preproc_line] = STATE(434),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(3142),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1600),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1604),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1600),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_COLON_GT] = ACTIONS(1608),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1608),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1614),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(1622),
  },
  [435] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(435),
    [sym_compiler_directive_decl] = STATE(435),
    [sym_fsi_directive_decl] = STATE(435),
    [sym_preproc_line] = STATE(435),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2160),
  },
  [436] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(436),
    [sym_compiler_directive_decl] = STATE(436),
    [sym_fsi_directive_decl] = STATE(436),
    [sym_preproc_line] = STATE(436),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2162),
  },
  [437] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(437),
    [sym_compiler_directive_decl] = STATE(437),
    [sym_fsi_directive_decl] = STATE(437),
    [sym_preproc_line] = STATE(437),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2164),
  },
  [438] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(438),
    [sym_compiler_directive_decl] = STATE(438),
    [sym_fsi_directive_decl] = STATE(438),
    [sym_preproc_line] = STATE(438),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2166),
  },
  [439] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(346),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(890),
    [sym_infix_op] = STATE(904),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(439),
    [sym_compiler_directive_decl] = STATE(439),
    [sym_fsi_directive_decl] = STATE(439),
    [sym_preproc_line] = STATE(439),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_sequential_expression_repeat1] = STATE(3140),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_COMMA] = ACTIONS(1522),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1514),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(1820),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_AT_GT] = ACTIONS(2168),
    [anon_sym_LT_AT_AT] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1534),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_COLON_GT] = ACTIONS(1540),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_LT_DASH] = ACTIONS(1556),
    [anon_sym_DOT_LBRACK] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [anon_sym_LPAREN2] = ACTIONS(1570),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(1586),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(1590),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
    [sym__newline] = ACTIONS(1824),
  },
  [440] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(309),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1022),
    [sym_infix_op] = STATE(891),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(440),
    [sym_compiler_directive_decl] = STATE(440),
    [sym_fsi_directive_decl] = STATE(440),
    [sym_preproc_line] = STATE(440),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_sequential_expression_repeat1] = STATE(2972),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_COMMA] = ACTIONS(1836),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(1848),
    [anon_sym_AT_AT_GT] = ACTIONS(2168),
    [anon_sym_DOT] = ACTIONS(1850),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_COLON_GT] = ACTIONS(1856),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1856),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_LT_DASH] = ACTIONS(1872),
    [anon_sym_DOT_LBRACK] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [anon_sym_LPAREN2] = ACTIONS(1886),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(1902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(1906),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
    [sym__newline] = ACTIONS(1914),
  },
  [441] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(441),
    [sym_compiler_directive_decl] = STATE(441),
    [sym_fsi_directive_decl] = STATE(441),
    [sym_preproc_line] = STATE(441),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2170),
  },
  [442] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(358),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1151),
    [sym_infix_op] = STATE(1064),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(442),
    [sym_compiler_directive_decl] = STATE(442),
    [sym_fsi_directive_decl] = STATE(442),
    [sym_preproc_line] = STATE(442),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_sequential_expression_repeat1] = STATE(3119),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(2172),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1724),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(1744),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_COLON_GT] = ACTIONS(1752),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_LT_DASH] = ACTIONS(1768),
    [anon_sym_DOT_LBRACK] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_DOT_DOT] = ACTIONS(1780),
    [anon_sym_begin] = ACTIONS(1782),
    [anon_sym_LPAREN2] = ACTIONS(1784),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(1800),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(1804),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
    [sym__newline] = ACTIONS(1812),
  },
  [443] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(443),
    [sym_compiler_directive_decl] = STATE(443),
    [sym_fsi_directive_decl] = STATE(443),
    [sym_preproc_line] = STATE(443),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(2174),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(2176),
  },
  [444] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(444),
    [sym_compiler_directive_decl] = STATE(444),
    [sym_fsi_directive_decl] = STATE(444),
    [sym_preproc_line] = STATE(444),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2178),
  },
  [445] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(445),
    [sym_compiler_directive_decl] = STATE(445),
    [sym_fsi_directive_decl] = STATE(445),
    [sym_preproc_line] = STATE(445),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2180),
  },
  [446] = {
    [sym_function_or_value_defn] = STATE(783),
    [sym__expression] = STATE(338),
    [sym_literal_expression] = STATE(3553),
    [sym_long_identifier_or_op] = STATE(3553),
    [sym_tuple_expression] = STATE(3553),
    [sym_brace_expression] = STATE(3553),
    [sym_anon_record_expression] = STATE(3553),
    [sym_prefixed_expression] = STATE(3553),
    [sym_typecast_expression] = STATE(3553),
    [sym_for_expression] = STATE(3553),
    [sym_while_expression] = STATE(3553),
    [sym__if_branch] = STATE(10567),
    [sym_if_expression] = STATE(3553),
    [sym_fun_expression] = STATE(3553),
    [sym_try_expression] = STATE(3553),
    [sym_match_expression] = STATE(3553),
    [sym_function_expression] = STATE(3553),
    [sym_mutate_expression] = STATE(3553),
    [sym_index_expression] = STATE(3553),
    [sym_typed_expression] = STATE(3553),
    [sym_declaration_expression] = STATE(3553),
    [sym_do_expression] = STATE(3553),
    [sym_list_expression] = STATE(3553),
    [sym_array_expression] = STATE(3553),
    [sym_begin_end_expression] = STATE(3553),
    [sym_paren_expression] = STATE(3553),
    [sym__high_prec_app] = STATE(3532),
    [sym__low_prec_app] = STATE(3532),
    [sym_application_expression] = STATE(3553),
    [sym_dot_expression] = STATE(3553),
    [sym_infix_expression] = STATE(3553),
    [sym_ce_expression] = STATE(3553),
    [sym_sequential_expression] = STATE(3553),
    [sym_char] = STATE(3265),
    [sym_format_string] = STATE(3261),
    [sym__string_literal] = STATE(3261),
    [sym_string] = STATE(3265),
    [sym_verbatim_string] = STATE(3265),
    [sym_bytearray] = STATE(3265),
    [sym_verbatim_bytearray] = STATE(3265),
    [sym_format_triple_quoted_string] = STATE(3260),
    [sym_triple_quoted_string] = STATE(3265),
    [sym_const] = STATE(3553),
    [sym_long_identifier] = STATE(3203),
    [sym_active_pattern] = STATE(3576),
    [sym__identifier_or_op] = STATE(3362),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1076),
    [sym_infix_op] = STATE(975),
    [sym_sbyte] = STATE(3265),
    [sym_byte] = STATE(3265),
    [sym_int16] = STATE(3265),
    [sym_uint16] = STATE(3265),
    [sym_int32] = STATE(3265),
    [sym_uint32] = STATE(3265),
    [sym_nativeint] = STATE(3265),
    [sym_unativeint] = STATE(3265),
    [sym_int64] = STATE(3265),
    [sym_uint64] = STATE(3265),
    [sym_ieee32] = STATE(3265),
    [sym_ieee64] = STATE(3265),
    [sym_bignum] = STATE(3265),
    [sym_decimal] = STATE(3265),
    [sym_float] = STATE(2797),
    [sym_block_comment] = STATE(446),
    [sym_compiler_directive_decl] = STATE(446),
    [sym_fsi_directive_decl] = STATE(446),
    [sym_preproc_line] = STATE(446),
    [sym_preproc_if_in_expression] = STATE(3553),
    [aux_sym_sequential_expression_repeat1] = STATE(3067),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1632),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1634),
    [anon_sym_return] = ACTIONS(1636),
    [anon_sym_do] = ACTIONS(1638),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1640),
    [anon_sym_COMMA] = ACTIONS(1642),
    [anon_sym_null] = ACTIONS(1644),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1634),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1646),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1650),
    [anon_sym_LT_AT] = ACTIONS(1652),
    [anon_sym_LT_AT_AT] = ACTIONS(1654),
    [anon_sym_DOT] = ACTIONS(1656),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1658),
    [anon_sym_new] = ACTIONS(1636),
    [anon_sym_return_BANG] = ACTIONS(1660),
    [anon_sym_yield] = ACTIONS(1636),
    [anon_sym_yield_BANG] = ACTIONS(1660),
    [anon_sym_lazy] = ACTIONS(1636),
    [anon_sym_assert] = ACTIONS(1636),
    [anon_sym_upcast] = ACTIONS(1636),
    [anon_sym_downcast] = ACTIONS(1636),
    [anon_sym_COLON_GT] = ACTIONS(1662),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1662),
    [anon_sym_for] = ACTIONS(1664),
    [anon_sym_while] = ACTIONS(1666),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1668),
    [anon_sym_try] = ACTIONS(1670),
    [anon_sym_match] = ACTIONS(1672),
    [anon_sym_match_BANG] = ACTIONS(1674),
    [anon_sym_function] = ACTIONS(1676),
    [anon_sym_LT_DASH] = ACTIONS(1678),
    [anon_sym_DOT_LBRACK] = ACTIONS(1680),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(123),
    [anon_sym_use] = ACTIONS(1684),
    [anon_sym_use_BANG] = ACTIONS(1686),
    [anon_sym_do_BANG] = ACTIONS(1688),
    [anon_sym_begin] = ACTIONS(1690),
    [anon_sym_LPAREN2] = ACTIONS(1692),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1694),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1696),
    [anon_sym_DQUOTE] = ACTIONS(1698),
    [anon_sym_AT_DQUOTE] = ACTIONS(1700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1704),
    [sym_bool] = ACTIONS(1706),
    [sym_unit] = ACTIONS(1708),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1710),
    [sym_op_identifier] = ACTIONS(1712),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1714),
    [sym_xint] = ACTIONS(1716),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1718),
    [sym__newline] = ACTIONS(119),
  },
  [447] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(447),
    [sym_compiler_directive_decl] = STATE(447),
    [sym_fsi_directive_decl] = STATE(447),
    [sym_preproc_line] = STATE(447),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2182),
  },
  [448] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(448),
    [sym_compiler_directive_decl] = STATE(448),
    [sym_fsi_directive_decl] = STATE(448),
    [sym_preproc_line] = STATE(448),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2184),
  },
  [449] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(449),
    [sym_compiler_directive_decl] = STATE(449),
    [sym_fsi_directive_decl] = STATE(449),
    [sym_preproc_line] = STATE(449),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(2186),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(2188),
  },
  [450] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(450),
    [sym_compiler_directive_decl] = STATE(450),
    [sym_fsi_directive_decl] = STATE(450),
    [sym_preproc_line] = STATE(450),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(2190),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(2192),
  },
  [451] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(346),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(890),
    [sym_infix_op] = STATE(904),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(451),
    [sym_compiler_directive_decl] = STATE(451),
    [sym_fsi_directive_decl] = STATE(451),
    [sym_preproc_line] = STATE(451),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_sequential_expression_repeat1] = STATE(3140),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_COMMA] = ACTIONS(1522),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1514),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(1820),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_AT_GT] = ACTIONS(2194),
    [anon_sym_LT_AT_AT] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1534),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_COLON_GT] = ACTIONS(1540),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_LT_DASH] = ACTIONS(1556),
    [anon_sym_DOT_LBRACK] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [anon_sym_LPAREN2] = ACTIONS(1570),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(1586),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(1590),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
    [sym__newline] = ACTIONS(1824),
  },
  [452] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(309),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1022),
    [sym_infix_op] = STATE(891),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(452),
    [sym_compiler_directive_decl] = STATE(452),
    [sym_fsi_directive_decl] = STATE(452),
    [sym_preproc_line] = STATE(452),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_sequential_expression_repeat1] = STATE(2972),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_COMMA] = ACTIONS(1836),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(1848),
    [anon_sym_AT_AT_GT] = ACTIONS(2194),
    [anon_sym_DOT] = ACTIONS(1850),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_COLON_GT] = ACTIONS(1856),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1856),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_LT_DASH] = ACTIONS(1872),
    [anon_sym_DOT_LBRACK] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [anon_sym_LPAREN2] = ACTIONS(1886),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(1902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(1906),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
    [sym__newline] = ACTIONS(1914),
  },
  [453] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(453),
    [sym_compiler_directive_decl] = STATE(453),
    [sym_fsi_directive_decl] = STATE(453),
    [sym_preproc_line] = STATE(453),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2196),
  },
  [454] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(454),
    [sym_compiler_directive_decl] = STATE(454),
    [sym_fsi_directive_decl] = STATE(454),
    [sym_preproc_line] = STATE(454),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2198),
  },
  [455] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(455),
    [sym_compiler_directive_decl] = STATE(455),
    [sym_fsi_directive_decl] = STATE(455),
    [sym_preproc_line] = STATE(455),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2200),
  },
  [456] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(358),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1151),
    [sym_infix_op] = STATE(1064),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(456),
    [sym_compiler_directive_decl] = STATE(456),
    [sym_fsi_directive_decl] = STATE(456),
    [sym_preproc_line] = STATE(456),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_sequential_expression_repeat1] = STATE(3119),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(2202),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1724),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(1744),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_COLON_GT] = ACTIONS(1752),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_LT_DASH] = ACTIONS(1768),
    [anon_sym_DOT_LBRACK] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_DOT_DOT] = ACTIONS(1780),
    [anon_sym_begin] = ACTIONS(1782),
    [anon_sym_LPAREN2] = ACTIONS(1784),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(1800),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(1804),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
    [sym__newline] = ACTIONS(1812),
  },
  [457] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(471),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1045),
    [sym_infix_op] = STATE(886),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(457),
    [sym_compiler_directive_decl] = STATE(457),
    [sym_fsi_directive_decl] = STATE(457),
    [sym_preproc_line] = STATE(457),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(3142),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1600),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(2204),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1604),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1600),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_COLON_GT] = ACTIONS(1608),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1608),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(2204),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1614),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(1622),
  },
  [458] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(458),
    [sym_compiler_directive_decl] = STATE(458),
    [sym_fsi_directive_decl] = STATE(458),
    [sym_preproc_line] = STATE(458),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2206),
  },
  [459] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(459),
    [sym_compiler_directive_decl] = STATE(459),
    [sym_fsi_directive_decl] = STATE(459),
    [sym_preproc_line] = STATE(459),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1816),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(1816),
  },
  [460] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(471),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1045),
    [sym_infix_op] = STATE(886),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(460),
    [sym_compiler_directive_decl] = STATE(460),
    [sym_fsi_directive_decl] = STATE(460),
    [sym_preproc_line] = STATE(460),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(3142),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1600),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1604),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1600),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_COLON_GT] = ACTIONS(1608),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1608),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(2208),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1614),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(1622),
  },
  [461] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(346),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(890),
    [sym_infix_op] = STATE(904),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(461),
    [sym_compiler_directive_decl] = STATE(461),
    [sym_fsi_directive_decl] = STATE(461),
    [sym_preproc_line] = STATE(461),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_sequential_expression_repeat1] = STATE(3140),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_COMMA] = ACTIONS(1522),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1514),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(1820),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_AT_GT] = ACTIONS(2210),
    [anon_sym_LT_AT_AT] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1534),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_COLON_GT] = ACTIONS(1540),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_LT_DASH] = ACTIONS(1556),
    [anon_sym_DOT_LBRACK] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [anon_sym_LPAREN2] = ACTIONS(1570),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(1586),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(1590),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
    [sym__newline] = ACTIONS(1824),
  },
  [462] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(309),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1022),
    [sym_infix_op] = STATE(891),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(462),
    [sym_compiler_directive_decl] = STATE(462),
    [sym_fsi_directive_decl] = STATE(462),
    [sym_preproc_line] = STATE(462),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_sequential_expression_repeat1] = STATE(2972),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_COMMA] = ACTIONS(1836),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(1848),
    [anon_sym_AT_AT_GT] = ACTIONS(2210),
    [anon_sym_DOT] = ACTIONS(1850),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_COLON_GT] = ACTIONS(1856),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1856),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_LT_DASH] = ACTIONS(1872),
    [anon_sym_DOT_LBRACK] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [anon_sym_LPAREN2] = ACTIONS(1886),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(1902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(1906),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
    [sym__newline] = ACTIONS(1914),
  },
  [463] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(463),
    [sym_compiler_directive_decl] = STATE(463),
    [sym_fsi_directive_decl] = STATE(463),
    [sym_preproc_line] = STATE(463),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2212),
  },
  [464] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(464),
    [sym_compiler_directive_decl] = STATE(464),
    [sym_fsi_directive_decl] = STATE(464),
    [sym_preproc_line] = STATE(464),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2214),
  },
  [465] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(465),
    [sym_compiler_directive_decl] = STATE(465),
    [sym_fsi_directive_decl] = STATE(465),
    [sym_preproc_line] = STATE(465),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2216),
  },
  [466] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(309),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1022),
    [sym_infix_op] = STATE(891),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(466),
    [sym_compiler_directive_decl] = STATE(466),
    [sym_fsi_directive_decl] = STATE(466),
    [sym_preproc_line] = STATE(466),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_sequential_expression_repeat1] = STATE(2972),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_COMMA] = ACTIONS(1836),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(1848),
    [anon_sym_AT_AT_GT] = ACTIONS(2218),
    [anon_sym_DOT] = ACTIONS(1850),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_COLON_GT] = ACTIONS(1856),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1856),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_LT_DASH] = ACTIONS(1872),
    [anon_sym_DOT_LBRACK] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [anon_sym_LPAREN2] = ACTIONS(1886),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(1902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(1906),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
    [sym__newline] = ACTIONS(1914),
  },
  [467] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(346),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(890),
    [sym_infix_op] = STATE(904),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(467),
    [sym_compiler_directive_decl] = STATE(467),
    [sym_fsi_directive_decl] = STATE(467),
    [sym_preproc_line] = STATE(467),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_sequential_expression_repeat1] = STATE(3140),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_COMMA] = ACTIONS(1522),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1514),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(1820),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_AT_GT] = ACTIONS(2218),
    [anon_sym_LT_AT_AT] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1534),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_COLON_GT] = ACTIONS(1540),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_LT_DASH] = ACTIONS(1556),
    [anon_sym_DOT_LBRACK] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [anon_sym_LPAREN2] = ACTIONS(1570),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(1586),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(1590),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
    [sym__newline] = ACTIONS(1824),
  },
  [468] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(468),
    [sym_compiler_directive_decl] = STATE(468),
    [sym_fsi_directive_decl] = STATE(468),
    [sym_preproc_line] = STATE(468),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2220),
  },
  [469] = {
    [sym_function_or_value_defn] = STATE(783),
    [sym__expression] = STATE(338),
    [sym_literal_expression] = STATE(3553),
    [sym_long_identifier_or_op] = STATE(3553),
    [sym_tuple_expression] = STATE(3553),
    [sym_brace_expression] = STATE(3553),
    [sym_anon_record_expression] = STATE(3553),
    [sym_prefixed_expression] = STATE(3553),
    [sym_typecast_expression] = STATE(3553),
    [sym_for_expression] = STATE(3553),
    [sym_while_expression] = STATE(3553),
    [sym__if_branch] = STATE(10567),
    [sym_if_expression] = STATE(3553),
    [sym_fun_expression] = STATE(3553),
    [sym_try_expression] = STATE(3553),
    [sym_match_expression] = STATE(3553),
    [sym_function_expression] = STATE(3553),
    [sym_mutate_expression] = STATE(3553),
    [sym_index_expression] = STATE(3553),
    [sym_typed_expression] = STATE(3553),
    [sym_declaration_expression] = STATE(3553),
    [sym_do_expression] = STATE(3553),
    [sym_list_expression] = STATE(3553),
    [sym_array_expression] = STATE(3553),
    [sym_begin_end_expression] = STATE(3553),
    [sym_paren_expression] = STATE(3553),
    [sym__high_prec_app] = STATE(3532),
    [sym__low_prec_app] = STATE(3532),
    [sym_application_expression] = STATE(3553),
    [sym_dot_expression] = STATE(3553),
    [sym_infix_expression] = STATE(3553),
    [sym_ce_expression] = STATE(3553),
    [sym_sequential_expression] = STATE(3553),
    [sym_char] = STATE(3265),
    [sym_format_string] = STATE(3261),
    [sym__string_literal] = STATE(3261),
    [sym_string] = STATE(3265),
    [sym_verbatim_string] = STATE(3265),
    [sym_bytearray] = STATE(3265),
    [sym_verbatim_bytearray] = STATE(3265),
    [sym_format_triple_quoted_string] = STATE(3260),
    [sym_triple_quoted_string] = STATE(3265),
    [sym_const] = STATE(3553),
    [sym_long_identifier] = STATE(3203),
    [sym_active_pattern] = STATE(3576),
    [sym__identifier_or_op] = STATE(3362),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1076),
    [sym_infix_op] = STATE(975),
    [sym_sbyte] = STATE(3265),
    [sym_byte] = STATE(3265),
    [sym_int16] = STATE(3265),
    [sym_uint16] = STATE(3265),
    [sym_int32] = STATE(3265),
    [sym_uint32] = STATE(3265),
    [sym_nativeint] = STATE(3265),
    [sym_unativeint] = STATE(3265),
    [sym_int64] = STATE(3265),
    [sym_uint64] = STATE(3265),
    [sym_ieee32] = STATE(3265),
    [sym_ieee64] = STATE(3265),
    [sym_bignum] = STATE(3265),
    [sym_decimal] = STATE(3265),
    [sym_float] = STATE(2797),
    [sym_block_comment] = STATE(469),
    [sym_compiler_directive_decl] = STATE(469),
    [sym_fsi_directive_decl] = STATE(469),
    [sym_preproc_line] = STATE(469),
    [sym_preproc_if_in_expression] = STATE(3553),
    [aux_sym_sequential_expression_repeat1] = STATE(3067),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1632),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1634),
    [anon_sym_return] = ACTIONS(1636),
    [anon_sym_do] = ACTIONS(1638),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1640),
    [anon_sym_COMMA] = ACTIONS(1642),
    [anon_sym_null] = ACTIONS(1644),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1634),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1646),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1650),
    [anon_sym_LT_AT] = ACTIONS(1652),
    [anon_sym_LT_AT_AT] = ACTIONS(1654),
    [anon_sym_DOT] = ACTIONS(1656),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1658),
    [anon_sym_new] = ACTIONS(1636),
    [anon_sym_return_BANG] = ACTIONS(1660),
    [anon_sym_yield] = ACTIONS(1636),
    [anon_sym_yield_BANG] = ACTIONS(1660),
    [anon_sym_lazy] = ACTIONS(1636),
    [anon_sym_assert] = ACTIONS(1636),
    [anon_sym_upcast] = ACTIONS(1636),
    [anon_sym_downcast] = ACTIONS(1636),
    [anon_sym_COLON_GT] = ACTIONS(1662),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1662),
    [anon_sym_for] = ACTIONS(1664),
    [anon_sym_while] = ACTIONS(1666),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1668),
    [anon_sym_try] = ACTIONS(1670),
    [anon_sym_match] = ACTIONS(1672),
    [anon_sym_match_BANG] = ACTIONS(1674),
    [anon_sym_function] = ACTIONS(1676),
    [anon_sym_LT_DASH] = ACTIONS(1678),
    [anon_sym_DOT_LBRACK] = ACTIONS(1680),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(267),
    [anon_sym_use] = ACTIONS(1684),
    [anon_sym_use_BANG] = ACTIONS(1686),
    [anon_sym_do_BANG] = ACTIONS(1688),
    [anon_sym_begin] = ACTIONS(1690),
    [anon_sym_LPAREN2] = ACTIONS(1692),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1694),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1696),
    [anon_sym_DQUOTE] = ACTIONS(1698),
    [anon_sym_AT_DQUOTE] = ACTIONS(1700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1704),
    [sym_bool] = ACTIONS(1706),
    [sym_unit] = ACTIONS(1708),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1710),
    [sym_op_identifier] = ACTIONS(1712),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1714),
    [sym_xint] = ACTIONS(1716),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1718),
    [sym__newline] = ACTIONS(1720),
  },
  [470] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(470),
    [sym_compiler_directive_decl] = STATE(470),
    [sym_fsi_directive_decl] = STATE(470),
    [sym_preproc_line] = STATE(470),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2222),
  },
  [471] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(471),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1045),
    [sym_infix_op] = STATE(886),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(471),
    [sym_compiler_directive_decl] = STATE(471),
    [sym_fsi_directive_decl] = STATE(471),
    [sym_preproc_line] = STATE(471),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(3142),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_EQ] = ACTIONS(223),
    [anon_sym_COLON] = ACTIONS(225),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_do] = ACTIONS(225),
    [anon_sym_let] = ACTIONS(225),
    [anon_sym_let_BANG] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_COMMA] = ACTIONS(223),
    [anon_sym_null] = ACTIONS(225),
    [anon_sym_QMARK] = ACTIONS(225),
    [anon_sym_COLON_QMARK] = ACTIONS(225),
    [anon_sym_COLON_COLON] = ACTIONS(223),
    [anon_sym_AMP] = ACTIONS(225),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LBRACK_PIPE] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(225),
    [anon_sym_LT_AT] = ACTIONS(225),
    [anon_sym_LT_AT_AT] = ACTIONS(225),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(225),
    [anon_sym_return_BANG] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(225),
    [anon_sym_yield_BANG] = ACTIONS(223),
    [anon_sym_lazy] = ACTIONS(225),
    [anon_sym_assert] = ACTIONS(225),
    [anon_sym_upcast] = ACTIONS(225),
    [anon_sym_downcast] = ACTIONS(225),
    [anon_sym_COLON_GT] = ACTIONS(223),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(223),
    [anon_sym_for] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_fun] = ACTIONS(225),
    [anon_sym_DASH_GT] = ACTIONS(225),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_match] = ACTIONS(225),
    [anon_sym_match_BANG] = ACTIONS(223),
    [anon_sym_function] = ACTIONS(225),
    [anon_sym_LT_DASH] = ACTIONS(225),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(225),
    [anon_sym_use_BANG] = ACTIONS(223),
    [anon_sym_do_BANG] = ACTIONS(223),
    [anon_sym_begin] = ACTIONS(225),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(225),
    [aux_sym_char_token1] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [anon_sym_AT_DQUOTE] = ACTIONS(223),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(223),
    [sym_bool] = ACTIONS(225),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(225),
    [sym_op_identifier] = ACTIONS(225),
    [anon_sym_PLUS] = ACTIONS(225),
    [anon_sym_DASH] = ACTIONS(225),
    [anon_sym_PLUS_DOT] = ACTIONS(225),
    [anon_sym_DASH_DOT] = ACTIONS(225),
    [anon_sym_PERCENT] = ACTIONS(225),
    [anon_sym_AMP_AMP] = ACTIONS(225),
    [anon_sym_TILDE] = ACTIONS(223),
    [aux_sym_prefix_op_token1] = ACTIONS(225),
    [aux_sym_infix_op_token1] = ACTIONS(223),
    [aux_sym_infix_op_token2] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(225),
    [anon_sym_BANG_EQ] = ACTIONS(225),
    [anon_sym_COLON_EQ] = ACTIONS(223),
    [anon_sym_DOLLAR] = ACTIONS(225),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(225),
    [sym_int] = ACTIONS(225),
    [sym_xint] = ACTIONS(223),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(223),
    [sym__newline] = ACTIONS(223),
  },
  [472] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(346),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(890),
    [sym_infix_op] = STATE(904),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(472),
    [sym_compiler_directive_decl] = STATE(472),
    [sym_fsi_directive_decl] = STATE(472),
    [sym_preproc_line] = STATE(472),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_sequential_expression_repeat1] = STATE(3140),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_COMMA] = ACTIONS(1522),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1514),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(1820),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_AT_GT] = ACTIONS(2224),
    [anon_sym_LT_AT_AT] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1534),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_COLON_GT] = ACTIONS(1540),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_LT_DASH] = ACTIONS(1556),
    [anon_sym_DOT_LBRACK] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [anon_sym_LPAREN2] = ACTIONS(1570),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(1586),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(1590),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
    [sym__newline] = ACTIONS(1824),
  },
  [473] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(309),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1022),
    [sym_infix_op] = STATE(891),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(473),
    [sym_compiler_directive_decl] = STATE(473),
    [sym_fsi_directive_decl] = STATE(473),
    [sym_preproc_line] = STATE(473),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_sequential_expression_repeat1] = STATE(2972),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_COMMA] = ACTIONS(1836),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(1848),
    [anon_sym_AT_AT_GT] = ACTIONS(2224),
    [anon_sym_DOT] = ACTIONS(1850),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_COLON_GT] = ACTIONS(1856),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1856),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_LT_DASH] = ACTIONS(1872),
    [anon_sym_DOT_LBRACK] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [anon_sym_LPAREN2] = ACTIONS(1886),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(1902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(1906),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
    [sym__newline] = ACTIONS(1914),
  },
  [474] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(474),
    [sym_compiler_directive_decl] = STATE(474),
    [sym_fsi_directive_decl] = STATE(474),
    [sym_preproc_line] = STATE(474),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2226),
  },
  [475] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(475),
    [sym_compiler_directive_decl] = STATE(475),
    [sym_fsi_directive_decl] = STATE(475),
    [sym_preproc_line] = STATE(475),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2228),
  },
  [476] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(476),
    [sym_compiler_directive_decl] = STATE(476),
    [sym_fsi_directive_decl] = STATE(476),
    [sym_preproc_line] = STATE(476),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2230),
  },
  [477] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(358),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1151),
    [sym_infix_op] = STATE(1064),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(477),
    [sym_compiler_directive_decl] = STATE(477),
    [sym_fsi_directive_decl] = STATE(477),
    [sym_preproc_line] = STATE(477),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_sequential_expression_repeat1] = STATE(3119),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(2232),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1724),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(1744),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_COLON_GT] = ACTIONS(1752),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_LT_DASH] = ACTIONS(1768),
    [anon_sym_DOT_LBRACK] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_DOT_DOT] = ACTIONS(1780),
    [anon_sym_begin] = ACTIONS(1782),
    [anon_sym_LPAREN2] = ACTIONS(1784),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(1800),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(1804),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
    [sym__newline] = ACTIONS(1812),
  },
  [478] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(478),
    [sym_compiler_directive_decl] = STATE(478),
    [sym_fsi_directive_decl] = STATE(478),
    [sym_preproc_line] = STATE(478),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(2234),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(2236),
  },
  [479] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(479),
    [sym_compiler_directive_decl] = STATE(479),
    [sym_fsi_directive_decl] = STATE(479),
    [sym_preproc_line] = STATE(479),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2238),
  },
  [480] = {
    [sym_function_or_value_defn] = STATE(1099),
    [sym__expression] = STATE(422),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1020),
    [sym_infix_op] = STATE(1104),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(2924),
    [sym_block_comment] = STATE(480),
    [sym_compiler_directive_decl] = STATE(480),
    [sym_fsi_directive_decl] = STATE(480),
    [sym_preproc_line] = STATE(480),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_sequential_expression_repeat1] = STATE(3001),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(1494),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(649),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(667),
    [anon_sym_DOT] = ACTIONS(669),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(1492),
    [anon_sym_return_BANG] = ACTIONS(1496),
    [anon_sym_yield] = ACTIONS(1492),
    [anon_sym_yield_BANG] = ACTIONS(1496),
    [anon_sym_lazy] = ACTIONS(1492),
    [anon_sym_assert] = ACTIONS(1492),
    [anon_sym_upcast] = ACTIONS(1492),
    [anon_sym_downcast] = ACTIONS(1492),
    [anon_sym_COLON_GT] = ACTIONS(675),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_LT_DASH] = ACTIONS(1498),
    [anon_sym_DOT_LBRACK] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_use] = ACTIONS(1500),
    [anon_sym_use_BANG] = ACTIONS(1502),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [anon_sym_LPAREN2] = ACTIONS(705),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(721),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1504),
    [sym_xint] = ACTIONS(1506),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
    [anon_sym_POUNDendif] = ACTIONS(243),
    [sym__newline] = ACTIONS(243),
  },
  [481] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(481),
    [sym_compiler_directive_decl] = STATE(481),
    [sym_fsi_directive_decl] = STATE(481),
    [sym_preproc_line] = STATE(481),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2240),
  },
  [482] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(358),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1151),
    [sym_infix_op] = STATE(1064),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(482),
    [sym_compiler_directive_decl] = STATE(482),
    [sym_fsi_directive_decl] = STATE(482),
    [sym_preproc_line] = STATE(482),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_sequential_expression_repeat1] = STATE(3119),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(2242),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1724),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(1744),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_COLON_GT] = ACTIONS(1752),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_LT_DASH] = ACTIONS(1768),
    [anon_sym_DOT_LBRACK] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_DOT_DOT] = ACTIONS(1780),
    [anon_sym_begin] = ACTIONS(1782),
    [anon_sym_LPAREN2] = ACTIONS(1784),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(1800),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(1804),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
    [sym__newline] = ACTIONS(1812),
  },
  [483] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(483),
    [sym_compiler_directive_decl] = STATE(483),
    [sym_fsi_directive_decl] = STATE(483),
    [sym_preproc_line] = STATE(483),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2244),
  },
  [484] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(484),
    [sym_compiler_directive_decl] = STATE(484),
    [sym_fsi_directive_decl] = STATE(484),
    [sym_preproc_line] = STATE(484),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2246),
  },
  [485] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(358),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1151),
    [sym_infix_op] = STATE(1064),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(485),
    [sym_compiler_directive_decl] = STATE(485),
    [sym_fsi_directive_decl] = STATE(485),
    [sym_preproc_line] = STATE(485),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_sequential_expression_repeat1] = STATE(3119),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(2248),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1724),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(1744),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_COLON_GT] = ACTIONS(1752),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_LT_DASH] = ACTIONS(1768),
    [anon_sym_DOT_LBRACK] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_DOT_DOT] = ACTIONS(1780),
    [anon_sym_begin] = ACTIONS(1782),
    [anon_sym_LPAREN2] = ACTIONS(1784),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(1800),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(1804),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
    [sym__newline] = ACTIONS(1812),
  },
  [486] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(486),
    [sym_compiler_directive_decl] = STATE(486),
    [sym_fsi_directive_decl] = STATE(486),
    [sym_preproc_line] = STATE(486),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2250),
  },
  [487] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(471),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1045),
    [sym_infix_op] = STATE(886),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(487),
    [sym_compiler_directive_decl] = STATE(487),
    [sym_fsi_directive_decl] = STATE(487),
    [sym_preproc_line] = STATE(487),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(3142),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1600),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1604),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1600),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_COLON_GT] = ACTIONS(1608),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1608),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(2252),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1614),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(1622),
  },
  [488] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(488),
    [sym_compiler_directive_decl] = STATE(488),
    [sym_fsi_directive_decl] = STATE(488),
    [sym_preproc_line] = STATE(488),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2254),
  },
  [489] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(358),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1151),
    [sym_infix_op] = STATE(1064),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(489),
    [sym_compiler_directive_decl] = STATE(489),
    [sym_fsi_directive_decl] = STATE(489),
    [sym_preproc_line] = STATE(489),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_sequential_expression_repeat1] = STATE(3119),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(2256),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1724),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(1744),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_COLON_GT] = ACTIONS(1752),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_LT_DASH] = ACTIONS(1768),
    [anon_sym_DOT_LBRACK] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_DOT_DOT] = ACTIONS(1780),
    [anon_sym_begin] = ACTIONS(1782),
    [anon_sym_LPAREN2] = ACTIONS(1784),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(1800),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(1804),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
    [sym__newline] = ACTIONS(1812),
  },
  [490] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(490),
    [sym_compiler_directive_decl] = STATE(490),
    [sym_fsi_directive_decl] = STATE(490),
    [sym_preproc_line] = STATE(490),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2258),
  },
  [491] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(471),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1045),
    [sym_infix_op] = STATE(886),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(491),
    [sym_compiler_directive_decl] = STATE(491),
    [sym_fsi_directive_decl] = STATE(491),
    [sym_preproc_line] = STATE(491),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(3142),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1600),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1604),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1600),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_COLON_GT] = ACTIONS(1608),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1608),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(2260),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1614),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(1622),
  },
  [492] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(492),
    [sym_compiler_directive_decl] = STATE(492),
    [sym_fsi_directive_decl] = STATE(492),
    [sym_preproc_line] = STATE(492),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2262),
  },
  [493] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(493),
    [sym_compiler_directive_decl] = STATE(493),
    [sym_fsi_directive_decl] = STATE(493),
    [sym_preproc_line] = STATE(493),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2264),
  },
  [494] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(494),
    [sym_compiler_directive_decl] = STATE(494),
    [sym_fsi_directive_decl] = STATE(494),
    [sym_preproc_line] = STATE(494),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2266),
  },
  [495] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(495),
    [sym_compiler_directive_decl] = STATE(495),
    [sym_fsi_directive_decl] = STATE(495),
    [sym_preproc_line] = STATE(495),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2268),
  },
  [496] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(471),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1045),
    [sym_infix_op] = STATE(886),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(496),
    [sym_compiler_directive_decl] = STATE(496),
    [sym_fsi_directive_decl] = STATE(496),
    [sym_preproc_line] = STATE(496),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(3142),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1600),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1604),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1600),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_COLON_GT] = ACTIONS(1608),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1608),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(2270),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1614),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(1622),
  },
  [497] = {
    [sym_function_or_value_defn] = STATE(1099),
    [sym__expression] = STATE(422),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1020),
    [sym_infix_op] = STATE(1104),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(2924),
    [sym_block_comment] = STATE(497),
    [sym_compiler_directive_decl] = STATE(497),
    [sym_fsi_directive_decl] = STATE(497),
    [sym_preproc_line] = STATE(497),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_sequential_expression_repeat1] = STATE(3001),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_EQ] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(229),
    [anon_sym_return] = ACTIONS(229),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_let] = ACTIONS(229),
    [anon_sym_let_BANG] = ACTIONS(227),
    [anon_sym_LPAREN] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(227),
    [anon_sym_null] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_COLON_QMARK] = ACTIONS(229),
    [anon_sym_COLON_COLON] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_LBRACK] = ACTIONS(229),
    [anon_sym_LBRACK_PIPE] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(229),
    [anon_sym_LT_AT] = ACTIONS(229),
    [anon_sym_LT_AT_AT] = ACTIONS(229),
    [anon_sym_DOT] = ACTIONS(669),
    [anon_sym_LBRACE_PIPE] = ACTIONS(227),
    [anon_sym_new] = ACTIONS(229),
    [anon_sym_return_BANG] = ACTIONS(227),
    [anon_sym_yield] = ACTIONS(229),
    [anon_sym_yield_BANG] = ACTIONS(227),
    [anon_sym_lazy] = ACTIONS(229),
    [anon_sym_assert] = ACTIONS(229),
    [anon_sym_upcast] = ACTIONS(229),
    [anon_sym_downcast] = ACTIONS(229),
    [anon_sym_COLON_GT] = ACTIONS(227),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_fun] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(229),
    [anon_sym_match_BANG] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(229),
    [anon_sym_LT_DASH] = ACTIONS(229),
    [anon_sym_DOT_LBRACK] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_use] = ACTIONS(229),
    [anon_sym_use_BANG] = ACTIONS(227),
    [anon_sym_do_BANG] = ACTIONS(227),
    [anon_sym_begin] = ACTIONS(229),
    [anon_sym_LPAREN2] = ACTIONS(705),
    [anon_sym_or] = ACTIONS(229),
    [aux_sym_char_token1] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_AT_DQUOTE] = ACTIONS(227),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(227),
    [sym_bool] = ACTIONS(229),
    [sym_unit] = ACTIONS(721),
    [anon_sym_LPAREN_PIPE] = ACTIONS(229),
    [sym_op_identifier] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(229),
    [anon_sym_PLUS_DOT] = ACTIONS(229),
    [anon_sym_DASH_DOT] = ACTIONS(229),
    [anon_sym_PERCENT] = ACTIONS(229),
    [anon_sym_AMP_AMP] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(227),
    [aux_sym_prefix_op_token1] = ACTIONS(229),
    [aux_sym_infix_op_token1] = ACTIONS(227),
    [aux_sym_infix_op_token2] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(229),
    [anon_sym_BANG_EQ] = ACTIONS(229),
    [anon_sym_COLON_EQ] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(229),
    [sym_int] = ACTIONS(229),
    [sym_xint] = ACTIONS(227),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(227),
    [anon_sym_POUNDendif] = ACTIONS(227),
    [sym__newline] = ACTIONS(227),
  },
  [498] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(471),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1045),
    [sym_infix_op] = STATE(886),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(498),
    [sym_compiler_directive_decl] = STATE(498),
    [sym_fsi_directive_decl] = STATE(498),
    [sym_preproc_line] = STATE(498),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(3142),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1600),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1604),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1600),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(255),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_COLON_GT] = ACTIONS(1608),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1608),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(255),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1614),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(253),
  },
  [499] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(358),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1151),
    [sym_infix_op] = STATE(1064),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(499),
    [sym_compiler_directive_decl] = STATE(499),
    [sym_fsi_directive_decl] = STATE(499),
    [sym_preproc_line] = STATE(499),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_sequential_expression_repeat1] = STATE(3119),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1724),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(1744),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_COLON_GT] = ACTIONS(1752),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_LT_DASH] = ACTIONS(1768),
    [anon_sym_DOT_LBRACK] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_DOT_DOT] = ACTIONS(1780),
    [anon_sym_begin] = ACTIONS(1782),
    [anon_sym_LPAREN2] = ACTIONS(1784),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(1800),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(1804),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
    [sym__newline] = ACTIONS(1812),
  },
  [500] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(500),
    [sym_compiler_directive_decl] = STATE(500),
    [sym_fsi_directive_decl] = STATE(500),
    [sym_preproc_line] = STATE(500),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2274),
  },
  [501] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(471),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1045),
    [sym_infix_op] = STATE(886),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(501),
    [sym_compiler_directive_decl] = STATE(501),
    [sym_fsi_directive_decl] = STATE(501),
    [sym_preproc_line] = STATE(501),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(3142),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1600),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1604),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1600),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(259),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_COLON_GT] = ACTIONS(1608),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1608),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(259),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1614),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(257),
  },
  [502] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(502),
    [sym_compiler_directive_decl] = STATE(502),
    [sym_fsi_directive_decl] = STATE(502),
    [sym_preproc_line] = STATE(502),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2276),
  },
  [503] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(309),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1022),
    [sym_infix_op] = STATE(891),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(503),
    [sym_compiler_directive_decl] = STATE(503),
    [sym_fsi_directive_decl] = STATE(503),
    [sym_preproc_line] = STATE(503),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_sequential_expression_repeat1] = STATE(2972),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_COMMA] = ACTIONS(1836),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1828),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(1848),
    [anon_sym_AT_AT_GT] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(1850),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_COLON_GT] = ACTIONS(1856),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1856),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_LT_DASH] = ACTIONS(1872),
    [anon_sym_DOT_LBRACK] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [anon_sym_LPAREN2] = ACTIONS(1886),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(1902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(1906),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
    [sym__newline] = ACTIONS(119),
  },
  [504] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(504),
    [sym_compiler_directive_decl] = STATE(504),
    [sym_fsi_directive_decl] = STATE(504),
    [sym_preproc_line] = STATE(504),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2278),
  },
  [505] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(471),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1045),
    [sym_infix_op] = STATE(886),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(505),
    [sym_compiler_directive_decl] = STATE(505),
    [sym_fsi_directive_decl] = STATE(505),
    [sym_preproc_line] = STATE(505),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_sequential_expression_repeat1] = STATE(3142),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(1600),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_COMMA] = ACTIONS(1604),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(1600),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_COLON_GT] = ACTIONS(1608),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1608),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_DASH_GT] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_LT_DASH] = ACTIONS(1614),
    [anon_sym_DOT_LBRACK] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(1378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__newline] = ACTIONS(1622),
  },
  [506] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(856),
    [sym_infix_op] = STATE(806),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(506),
    [sym_compiler_directive_decl] = STATE(506),
    [sym_fsi_directive_decl] = STATE(506),
    [sym_preproc_line] = STATE(506),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_sequential_expression_repeat1] = STATE(2835),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_COLON_GT] = ACTIONS(779),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_LT_DASH] = ACTIONS(1274),
    [anon_sym_DOT_LBRACK] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_LPAREN2] = ACTIONS(809),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(825),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(1288),
    [sym__dedent] = ACTIONS(2280),
  },
  [507] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(507),
    [sym_compiler_directive_decl] = STATE(507),
    [sym_fsi_directive_decl] = STATE(507),
    [sym_preproc_line] = STATE(507),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2204),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [508] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(508),
    [sym_compiler_directive_decl] = STATE(508),
    [sym_fsi_directive_decl] = STATE(508),
    [sym_preproc_line] = STATE(508),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2282),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [509] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(509),
    [sym_compiler_directive_decl] = STATE(509),
    [sym_fsi_directive_decl] = STATE(509),
    [sym_preproc_line] = STATE(509),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2284),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [510] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(510),
    [sym_compiler_directive_decl] = STATE(510),
    [sym_fsi_directive_decl] = STATE(510),
    [sym_preproc_line] = STATE(510),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2286),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [511] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(511),
    [sym_compiler_directive_decl] = STATE(511),
    [sym_fsi_directive_decl] = STATE(511),
    [sym_preproc_line] = STATE(511),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [512] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(512),
    [sym_compiler_directive_decl] = STATE(512),
    [sym_fsi_directive_decl] = STATE(512),
    [sym_preproc_line] = STATE(512),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2290),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [513] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(513),
    [sym_compiler_directive_decl] = STATE(513),
    [sym_fsi_directive_decl] = STATE(513),
    [sym_preproc_line] = STATE(513),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [514] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(514),
    [sym_compiler_directive_decl] = STATE(514),
    [sym_fsi_directive_decl] = STATE(514),
    [sym_preproc_line] = STATE(514),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2294),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [515] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(515),
    [sym_compiler_directive_decl] = STATE(515),
    [sym_fsi_directive_decl] = STATE(515),
    [sym_preproc_line] = STATE(515),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2296),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [516] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(516),
    [sym_compiler_directive_decl] = STATE(516),
    [sym_fsi_directive_decl] = STATE(516),
    [sym_preproc_line] = STATE(516),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2298),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [517] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(517),
    [sym_compiler_directive_decl] = STATE(517),
    [sym_fsi_directive_decl] = STATE(517),
    [sym_preproc_line] = STATE(517),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [518] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(518),
    [sym_compiler_directive_decl] = STATE(518),
    [sym_fsi_directive_decl] = STATE(518),
    [sym_preproc_line] = STATE(518),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2302),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [519] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(519),
    [sym_compiler_directive_decl] = STATE(519),
    [sym_fsi_directive_decl] = STATE(519),
    [sym_preproc_line] = STATE(519),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [520] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(520),
    [sym_compiler_directive_decl] = STATE(520),
    [sym_fsi_directive_decl] = STATE(520),
    [sym_preproc_line] = STATE(520),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2306),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [521] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(521),
    [sym_compiler_directive_decl] = STATE(521),
    [sym_fsi_directive_decl] = STATE(521),
    [sym_preproc_line] = STATE(521),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [522] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(522),
    [sym_compiler_directive_decl] = STATE(522),
    [sym_fsi_directive_decl] = STATE(522),
    [sym_preproc_line] = STATE(522),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2310),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [523] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(523),
    [sym_compiler_directive_decl] = STATE(523),
    [sym_fsi_directive_decl] = STATE(523),
    [sym_preproc_line] = STATE(523),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [524] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(524),
    [sym_compiler_directive_decl] = STATE(524),
    [sym_fsi_directive_decl] = STATE(524),
    [sym_preproc_line] = STATE(524),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2314),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [525] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(525),
    [sym_compiler_directive_decl] = STATE(525),
    [sym_fsi_directive_decl] = STATE(525),
    [sym_preproc_line] = STATE(525),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2316),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [526] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(526),
    [sym_compiler_directive_decl] = STATE(526),
    [sym_fsi_directive_decl] = STATE(526),
    [sym_preproc_line] = STATE(526),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2318),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [527] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(527),
    [sym_compiler_directive_decl] = STATE(527),
    [sym_fsi_directive_decl] = STATE(527),
    [sym_preproc_line] = STATE(527),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2320),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [528] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(528),
    [sym_compiler_directive_decl] = STATE(528),
    [sym_fsi_directive_decl] = STATE(528),
    [sym_preproc_line] = STATE(528),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2322),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [529] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(529),
    [sym_compiler_directive_decl] = STATE(529),
    [sym_fsi_directive_decl] = STATE(529),
    [sym_preproc_line] = STATE(529),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2324),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [530] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(530),
    [sym_compiler_directive_decl] = STATE(530),
    [sym_fsi_directive_decl] = STATE(530),
    [sym_preproc_line] = STATE(530),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2326),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [531] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(531),
    [sym_compiler_directive_decl] = STATE(531),
    [sym_fsi_directive_decl] = STATE(531),
    [sym_preproc_line] = STATE(531),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2328),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [532] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(532),
    [sym_compiler_directive_decl] = STATE(532),
    [sym_fsi_directive_decl] = STATE(532),
    [sym_preproc_line] = STATE(532),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2330),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [533] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(533),
    [sym_compiler_directive_decl] = STATE(533),
    [sym_fsi_directive_decl] = STATE(533),
    [sym_preproc_line] = STATE(533),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [534] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(534),
    [sym_compiler_directive_decl] = STATE(534),
    [sym_fsi_directive_decl] = STATE(534),
    [sym_preproc_line] = STATE(534),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2334),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [535] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(535),
    [sym_compiler_directive_decl] = STATE(535),
    [sym_fsi_directive_decl] = STATE(535),
    [sym_preproc_line] = STATE(535),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2336),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [536] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(536),
    [sym_compiler_directive_decl] = STATE(536),
    [sym_fsi_directive_decl] = STATE(536),
    [sym_preproc_line] = STATE(536),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2338),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [537] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(537),
    [sym_compiler_directive_decl] = STATE(537),
    [sym_fsi_directive_decl] = STATE(537),
    [sym_preproc_line] = STATE(537),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [538] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(538),
    [sym_compiler_directive_decl] = STATE(538),
    [sym_fsi_directive_decl] = STATE(538),
    [sym_preproc_line] = STATE(538),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2342),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [539] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4298),
    [sym_prefix_op] = STATE(1126),
    [sym_infix_op] = STATE(1018),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(539),
    [sym_compiler_directive_decl] = STATE(539),
    [sym_fsi_directive_decl] = STATE(539),
    [sym_preproc_line] = STATE(539),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_sequential_expression_repeat1] = STATE(2389),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(909),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(2344),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON_QMARK] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_COLON_GT] = ACTIONS(935),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_LT_DASH] = ACTIONS(951),
    [anon_sym_DOT_LBRACK] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(143),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(981),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(43),
    [anon_sym_DASH_DOT] = ACTIONS(43),
    [anon_sym_PERCENT] = ACTIONS(43),
    [anon_sym_AMP_AMP] = ACTIONS(43),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(213),
    [aux_sym_infix_op_token1] = ACTIONS(125),
    [aux_sym_infix_op_token2] = ACTIONS(143),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_COLON_EQ] = ACTIONS(125),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(143),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(995),
  },
  [540] = {
    [sym_module_abbrev] = STATE(9325),
    [sym_module_defn] = STATE(9325),
    [sym_import_decl] = STATE(9325),
    [sym_attributes] = STATE(8367),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(9325),
    [sym_do] = STATE(9707),
    [sym_function_or_value_defn] = STATE(687),
    [sym__expression] = STATE(128),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_exception_definition] = STATE(9325),
    [sym_type_definition] = STATE(9325),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(540),
    [sym_compiler_directive_decl] = STATE(540),
    [sym_fsi_directive_decl] = STATE(540),
    [sym_preproc_line] = STATE(540),
    [sym_preproc_if] = STATE(9325),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(11182),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(625),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_module] = ACTIONS(2346),
    [anon_sym_open] = ACTIONS(2348),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_type] = ACTIONS(2350),
    [anon_sym_do] = ACTIONS(2352),
    [anon_sym_let] = ACTIONS(2354),
    [anon_sym_let_BANG] = ACTIONS(2356),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [anon_sym_exception] = ACTIONS(2362),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2368),
    [anon_sym_POUNDload] = ACTIONS(2368),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2370),
    [anon_sym_POUNDendif] = ACTIONS(2372),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [541] = {
    [sym_module_abbrev] = STATE(9134),
    [sym_module_defn] = STATE(9134),
    [sym_import_decl] = STATE(9134),
    [sym_attributes] = STATE(8367),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(9134),
    [sym_do] = STATE(9707),
    [sym_function_or_value_defn] = STATE(687),
    [sym__expression] = STATE(132),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_exception_definition] = STATE(9134),
    [sym_type_definition] = STATE(9134),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(541),
    [sym_compiler_directive_decl] = STATE(541),
    [sym_fsi_directive_decl] = STATE(541),
    [sym_preproc_line] = STATE(541),
    [sym_preproc_if] = STATE(9134),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(11436),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(623),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_module] = ACTIONS(2346),
    [anon_sym_open] = ACTIONS(2348),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_type] = ACTIONS(2350),
    [anon_sym_do] = ACTIONS(2352),
    [anon_sym_let] = ACTIONS(2354),
    [anon_sym_let_BANG] = ACTIONS(2356),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [anon_sym_exception] = ACTIONS(2362),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2368),
    [anon_sym_POUNDload] = ACTIONS(2368),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2370),
    [anon_sym_POUNDendif] = ACTIONS(2378),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [542] = {
    [sym_module_abbrev] = STATE(9248),
    [sym_module_defn] = STATE(9248),
    [sym_import_decl] = STATE(9248),
    [sym_attributes] = STATE(8367),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(9248),
    [sym_do] = STATE(9707),
    [sym_function_or_value_defn] = STATE(687),
    [sym__expression] = STATE(135),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_exception_definition] = STATE(9248),
    [sym_type_definition] = STATE(9248),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(542),
    [sym_compiler_directive_decl] = STATE(542),
    [sym_fsi_directive_decl] = STATE(542),
    [sym_preproc_line] = STATE(542),
    [sym_preproc_if] = STATE(9248),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(11668),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(611),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_module] = ACTIONS(2346),
    [anon_sym_open] = ACTIONS(2348),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_type] = ACTIONS(2350),
    [anon_sym_do] = ACTIONS(2352),
    [anon_sym_let] = ACTIONS(2354),
    [anon_sym_let_BANG] = ACTIONS(2356),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [anon_sym_exception] = ACTIONS(2362),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2368),
    [anon_sym_POUNDload] = ACTIONS(2368),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2370),
    [anon_sym_POUNDendif] = ACTIONS(2380),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [543] = {
    [sym_module_abbrev] = STATE(9295),
    [sym_module_defn] = STATE(9295),
    [sym_import_decl] = STATE(9295),
    [sym_attributes] = STATE(8367),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(9295),
    [sym_do] = STATE(9707),
    [sym_function_or_value_defn] = STATE(687),
    [sym__expression] = STATE(140),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_exception_definition] = STATE(9295),
    [sym_type_definition] = STATE(9295),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(543),
    [sym_compiler_directive_decl] = STATE(543),
    [sym_fsi_directive_decl] = STATE(543),
    [sym_preproc_line] = STATE(543),
    [sym_preproc_if] = STATE(9295),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(10760),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(615),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_module] = ACTIONS(2346),
    [anon_sym_open] = ACTIONS(2348),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_type] = ACTIONS(2350),
    [anon_sym_do] = ACTIONS(2352),
    [anon_sym_let] = ACTIONS(2354),
    [anon_sym_let_BANG] = ACTIONS(2356),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [anon_sym_exception] = ACTIONS(2362),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2368),
    [anon_sym_POUNDload] = ACTIONS(2368),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2370),
    [anon_sym_POUNDendif] = ACTIONS(2382),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [544] = {
    [sym_module_abbrev] = STATE(4154),
    [sym_module_defn] = STATE(4154),
    [sym_import_decl] = STATE(4154),
    [sym_attributes] = STATE(8361),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(4154),
    [sym_do] = STATE(4155),
    [sym_function_or_value_defn] = STATE(581),
    [sym__expression] = STATE(104),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_exception_definition] = STATE(4154),
    [sym_type_definition] = STATE(4154),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1178),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(544),
    [sym_compiler_directive_decl] = STATE(544),
    [sym_fsi_directive_decl] = STATE(544),
    [sym_preproc_line] = STATE(544),
    [sym_preproc_if] = STATE(4154),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_file_repeat2] = STATE(544),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(2384),
    [sym_identifier] = ACTIONS(2386),
    [anon_sym_namespace] = ACTIONS(2389),
    [anon_sym_module] = ACTIONS(2391),
    [anon_sym_open] = ACTIONS(2394),
    [anon_sym_LBRACK_LT] = ACTIONS(2397),
    [anon_sym_return] = ACTIONS(2400),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_do] = ACTIONS(2406),
    [anon_sym_let] = ACTIONS(2409),
    [anon_sym_let_BANG] = ACTIONS(2412),
    [anon_sym_LPAREN] = ACTIONS(2415),
    [anon_sym_null] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(2421),
    [anon_sym_LBRACK] = ACTIONS(2424),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2427),
    [anon_sym_LBRACE] = ACTIONS(2430),
    [anon_sym_LT_AT] = ACTIONS(2433),
    [anon_sym_LT_AT_AT] = ACTIONS(2436),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2439),
    [anon_sym_new] = ACTIONS(2400),
    [anon_sym_return_BANG] = ACTIONS(2442),
    [anon_sym_yield] = ACTIONS(2400),
    [anon_sym_yield_BANG] = ACTIONS(2442),
    [anon_sym_lazy] = ACTIONS(2400),
    [anon_sym_assert] = ACTIONS(2400),
    [anon_sym_upcast] = ACTIONS(2400),
    [anon_sym_downcast] = ACTIONS(2400),
    [anon_sym_for] = ACTIONS(2445),
    [anon_sym_while] = ACTIONS(2448),
    [anon_sym_if] = ACTIONS(2451),
    [anon_sym_fun] = ACTIONS(2454),
    [anon_sym_try] = ACTIONS(2457),
    [anon_sym_match] = ACTIONS(2460),
    [anon_sym_match_BANG] = ACTIONS(2463),
    [anon_sym_function] = ACTIONS(2466),
    [anon_sym_use] = ACTIONS(2469),
    [anon_sym_use_BANG] = ACTIONS(2472),
    [anon_sym_do_BANG] = ACTIONS(2475),
    [anon_sym_begin] = ACTIONS(2478),
    [anon_sym_exception] = ACTIONS(2481),
    [aux_sym_char_token1] = ACTIONS(2484),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2487),
    [anon_sym_DQUOTE] = ACTIONS(2490),
    [anon_sym_AT_DQUOTE] = ACTIONS(2493),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2499),
    [sym_bool] = ACTIONS(2502),
    [sym_unit] = ACTIONS(2505),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2508),
    [sym_op_identifier] = ACTIONS(2511),
    [anon_sym_PLUS] = ACTIONS(2421),
    [anon_sym_DASH] = ACTIONS(2421),
    [anon_sym_PLUS_DOT] = ACTIONS(2514),
    [anon_sym_DASH_DOT] = ACTIONS(2514),
    [anon_sym_PERCENT] = ACTIONS(2514),
    [anon_sym_AMP_AMP] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2517),
    [aux_sym_prefix_op_token1] = ACTIONS(2520),
    [sym_int] = ACTIONS(2523),
    [sym_xint] = ACTIONS(2526),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2529),
    [anon_sym_POUNDload] = ACTIONS(2529),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2532),
  },
  [545] = {
    [sym_module_abbrev] = STATE(4154),
    [sym_module_defn] = STATE(4154),
    [sym_import_decl] = STATE(4154),
    [sym_attributes] = STATE(8361),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(4154),
    [sym_do] = STATE(4155),
    [sym_function_or_value_defn] = STATE(581),
    [sym__expression] = STATE(104),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_exception_definition] = STATE(4154),
    [sym_type_definition] = STATE(4154),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1178),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(545),
    [sym_compiler_directive_decl] = STATE(545),
    [sym_fsi_directive_decl] = STATE(545),
    [sym_preproc_line] = STATE(545),
    [sym_preproc_if] = STATE(4154),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_file_repeat2] = STATE(547),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(2535),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(2537),
    [anon_sym_module] = ACTIONS(2539),
    [anon_sym_open] = ACTIONS(25),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(2541),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_let_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(53),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(857),
    [anon_sym_return_BANG] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(857),
    [anon_sym_yield_BANG] = ACTIONS(869),
    [anon_sym_lazy] = ACTIONS(857),
    [anon_sym_assert] = ACTIONS(857),
    [anon_sym_upcast] = ACTIONS(857),
    [anon_sym_downcast] = ACTIONS(857),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(879),
    [anon_sym_use_BANG] = ACTIONS(881),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_exception] = ACTIONS(83),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(99),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(889),
    [sym_xint] = ACTIONS(891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(115),
    [anon_sym_POUNDload] = ACTIONS(115),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(117),
  },
  [546] = {
    [sym_module_abbrev] = STATE(4154),
    [sym_module_defn] = STATE(4154),
    [sym_import_decl] = STATE(4154),
    [sym_attributes] = STATE(8361),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(4154),
    [sym_do] = STATE(4155),
    [sym_function_or_value_defn] = STATE(581),
    [sym__expression] = STATE(104),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_exception_definition] = STATE(4154),
    [sym_type_definition] = STATE(4154),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1178),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(546),
    [sym_compiler_directive_decl] = STATE(546),
    [sym_fsi_directive_decl] = STATE(546),
    [sym_preproc_line] = STATE(546),
    [sym_preproc_if] = STATE(4154),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_file_repeat2] = STATE(549),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(2543),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(2545),
    [anon_sym_module] = ACTIONS(2539),
    [anon_sym_open] = ACTIONS(25),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(2541),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_let_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(53),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(857),
    [anon_sym_return_BANG] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(857),
    [anon_sym_yield_BANG] = ACTIONS(869),
    [anon_sym_lazy] = ACTIONS(857),
    [anon_sym_assert] = ACTIONS(857),
    [anon_sym_upcast] = ACTIONS(857),
    [anon_sym_downcast] = ACTIONS(857),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(879),
    [anon_sym_use_BANG] = ACTIONS(881),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_exception] = ACTIONS(83),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(99),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(889),
    [sym_xint] = ACTIONS(891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(115),
    [anon_sym_POUNDload] = ACTIONS(115),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(117),
  },
  [547] = {
    [sym_module_abbrev] = STATE(4154),
    [sym_module_defn] = STATE(4154),
    [sym_import_decl] = STATE(4154),
    [sym_attributes] = STATE(8361),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(4154),
    [sym_do] = STATE(4155),
    [sym_function_or_value_defn] = STATE(581),
    [sym__expression] = STATE(104),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_exception_definition] = STATE(4154),
    [sym_type_definition] = STATE(4154),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1178),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(547),
    [sym_compiler_directive_decl] = STATE(547),
    [sym_fsi_directive_decl] = STATE(547),
    [sym_preproc_line] = STATE(547),
    [sym_preproc_if] = STATE(4154),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_file_repeat2] = STATE(544),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(2547),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(2549),
    [anon_sym_module] = ACTIONS(2539),
    [anon_sym_open] = ACTIONS(25),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(2541),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_let_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(53),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(857),
    [anon_sym_return_BANG] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(857),
    [anon_sym_yield_BANG] = ACTIONS(869),
    [anon_sym_lazy] = ACTIONS(857),
    [anon_sym_assert] = ACTIONS(857),
    [anon_sym_upcast] = ACTIONS(857),
    [anon_sym_downcast] = ACTIONS(857),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(879),
    [anon_sym_use_BANG] = ACTIONS(881),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_exception] = ACTIONS(83),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(99),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(889),
    [sym_xint] = ACTIONS(891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(115),
    [anon_sym_POUNDload] = ACTIONS(115),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(117),
  },
  [548] = {
    [sym_module_abbrev] = STATE(4154),
    [sym_module_defn] = STATE(4154),
    [sym_import_decl] = STATE(4154),
    [sym_attributes] = STATE(8361),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(4154),
    [sym_do] = STATE(4155),
    [sym_function_or_value_defn] = STATE(581),
    [sym__expression] = STATE(104),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_exception_definition] = STATE(4154),
    [sym_type_definition] = STATE(4154),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1178),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(548),
    [sym_compiler_directive_decl] = STATE(548),
    [sym_fsi_directive_decl] = STATE(548),
    [sym_preproc_line] = STATE(548),
    [sym_preproc_if] = STATE(4154),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_file_repeat2] = STATE(550),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(2551),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(2553),
    [anon_sym_module] = ACTIONS(2539),
    [anon_sym_open] = ACTIONS(25),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(2541),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_let_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(53),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(857),
    [anon_sym_return_BANG] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(857),
    [anon_sym_yield_BANG] = ACTIONS(869),
    [anon_sym_lazy] = ACTIONS(857),
    [anon_sym_assert] = ACTIONS(857),
    [anon_sym_upcast] = ACTIONS(857),
    [anon_sym_downcast] = ACTIONS(857),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(879),
    [anon_sym_use_BANG] = ACTIONS(881),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_exception] = ACTIONS(83),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(99),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(889),
    [sym_xint] = ACTIONS(891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(115),
    [anon_sym_POUNDload] = ACTIONS(115),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(117),
  },
  [549] = {
    [sym_module_abbrev] = STATE(4154),
    [sym_module_defn] = STATE(4154),
    [sym_import_decl] = STATE(4154),
    [sym_attributes] = STATE(8361),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(4154),
    [sym_do] = STATE(4155),
    [sym_function_or_value_defn] = STATE(581),
    [sym__expression] = STATE(104),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_exception_definition] = STATE(4154),
    [sym_type_definition] = STATE(4154),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1178),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(549),
    [sym_compiler_directive_decl] = STATE(549),
    [sym_fsi_directive_decl] = STATE(549),
    [sym_preproc_line] = STATE(549),
    [sym_preproc_if] = STATE(4154),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_file_repeat2] = STATE(544),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(2555),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(2557),
    [anon_sym_module] = ACTIONS(2539),
    [anon_sym_open] = ACTIONS(25),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(2541),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_let_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(53),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(857),
    [anon_sym_return_BANG] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(857),
    [anon_sym_yield_BANG] = ACTIONS(869),
    [anon_sym_lazy] = ACTIONS(857),
    [anon_sym_assert] = ACTIONS(857),
    [anon_sym_upcast] = ACTIONS(857),
    [anon_sym_downcast] = ACTIONS(857),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(879),
    [anon_sym_use_BANG] = ACTIONS(881),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_exception] = ACTIONS(83),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(99),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(889),
    [sym_xint] = ACTIONS(891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(115),
    [anon_sym_POUNDload] = ACTIONS(115),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(117),
  },
  [550] = {
    [sym_module_abbrev] = STATE(4154),
    [sym_module_defn] = STATE(4154),
    [sym_import_decl] = STATE(4154),
    [sym_attributes] = STATE(8361),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(4154),
    [sym_do] = STATE(4155),
    [sym_function_or_value_defn] = STATE(581),
    [sym__expression] = STATE(104),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_exception_definition] = STATE(4154),
    [sym_type_definition] = STATE(4154),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1178),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(550),
    [sym_compiler_directive_decl] = STATE(550),
    [sym_fsi_directive_decl] = STATE(550),
    [sym_preproc_line] = STATE(550),
    [sym_preproc_if] = STATE(4154),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_file_repeat2] = STATE(544),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(2559),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(2561),
    [anon_sym_module] = ACTIONS(2539),
    [anon_sym_open] = ACTIONS(25),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(2541),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_let_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(53),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(857),
    [anon_sym_return_BANG] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(857),
    [anon_sym_yield_BANG] = ACTIONS(869),
    [anon_sym_lazy] = ACTIONS(857),
    [anon_sym_assert] = ACTIONS(857),
    [anon_sym_upcast] = ACTIONS(857),
    [anon_sym_downcast] = ACTIONS(857),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(879),
    [anon_sym_use_BANG] = ACTIONS(881),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_exception] = ACTIONS(83),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(99),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(889),
    [sym_xint] = ACTIONS(891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(115),
    [anon_sym_POUNDload] = ACTIONS(115),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(117),
  },
  [551] = {
    [sym_module_abbrev] = STATE(4154),
    [sym_module_defn] = STATE(4154),
    [sym_import_decl] = STATE(4154),
    [sym_attributes] = STATE(8317),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(4154),
    [sym_do] = STATE(4155),
    [sym_function_or_value_defn] = STATE(594),
    [sym__expression] = STATE(120),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_exception_definition] = STATE(4154),
    [sym_type_definition] = STATE(4154),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(793),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(551),
    [sym_compiler_directive_decl] = STATE(551),
    [sym_fsi_directive_decl] = STATE(551),
    [sym_preproc_line] = STATE(551),
    [sym_preproc_if] = STATE(4154),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_file_repeat2] = STATE(556),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(2563),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(2539),
    [anon_sym_open] = ACTIONS(25),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_type] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_let_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(53),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(29),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_upcast] = ACTIONS(29),
    [anon_sym_downcast] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_exception] = ACTIONS(83),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(99),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(111),
    [sym_xint] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(115),
    [anon_sym_POUNDload] = ACTIONS(115),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(117),
  },
  [552] = {
    [sym_module_abbrev] = STATE(4154),
    [sym_module_defn] = STATE(4154),
    [sym_import_decl] = STATE(4154),
    [sym_attributes] = STATE(8317),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(4154),
    [sym_do] = STATE(4155),
    [sym_function_or_value_defn] = STATE(594),
    [sym__expression] = STATE(120),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_exception_definition] = STATE(4154),
    [sym_type_definition] = STATE(4154),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(793),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(552),
    [sym_compiler_directive_decl] = STATE(552),
    [sym_fsi_directive_decl] = STATE(552),
    [sym_preproc_line] = STATE(552),
    [sym_preproc_if] = STATE(4154),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_file_repeat2] = STATE(556),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(2565),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(2539),
    [anon_sym_open] = ACTIONS(25),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_type] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_let_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(53),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(29),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_upcast] = ACTIONS(29),
    [anon_sym_downcast] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_exception] = ACTIONS(83),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(99),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(111),
    [sym_xint] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(115),
    [anon_sym_POUNDload] = ACTIONS(115),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(117),
  },
  [553] = {
    [sym_module_abbrev] = STATE(4154),
    [sym_module_defn] = STATE(4154),
    [sym_import_decl] = STATE(4154),
    [sym_attributes] = STATE(8317),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(4154),
    [sym_do] = STATE(4155),
    [sym_function_or_value_defn] = STATE(594),
    [sym__expression] = STATE(120),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_exception_definition] = STATE(4154),
    [sym_type_definition] = STATE(4154),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(793),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(553),
    [sym_compiler_directive_decl] = STATE(553),
    [sym_fsi_directive_decl] = STATE(553),
    [sym_preproc_line] = STATE(553),
    [sym_preproc_if] = STATE(4154),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_file_repeat2] = STATE(555),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(2567),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(2539),
    [anon_sym_open] = ACTIONS(25),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_type] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_let_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(53),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(29),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_upcast] = ACTIONS(29),
    [anon_sym_downcast] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_exception] = ACTIONS(83),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(99),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(111),
    [sym_xint] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(115),
    [anon_sym_POUNDload] = ACTIONS(115),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(117),
  },
  [554] = {
    [sym_module_abbrev] = STATE(4154),
    [sym_module_defn] = STATE(4154),
    [sym_import_decl] = STATE(4154),
    [sym_attributes] = STATE(8317),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(4154),
    [sym_do] = STATE(4155),
    [sym_function_or_value_defn] = STATE(594),
    [sym__expression] = STATE(120),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_exception_definition] = STATE(4154),
    [sym_type_definition] = STATE(4154),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(793),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(554),
    [sym_compiler_directive_decl] = STATE(554),
    [sym_fsi_directive_decl] = STATE(554),
    [sym_preproc_line] = STATE(554),
    [sym_preproc_if] = STATE(4154),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_file_repeat2] = STATE(556),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(2539),
    [anon_sym_open] = ACTIONS(25),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_type] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_let_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(53),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(29),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_upcast] = ACTIONS(29),
    [anon_sym_downcast] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_exception] = ACTIONS(83),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(99),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(111),
    [sym_xint] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(115),
    [anon_sym_POUNDload] = ACTIONS(115),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(117),
  },
  [555] = {
    [sym_module_abbrev] = STATE(4154),
    [sym_module_defn] = STATE(4154),
    [sym_import_decl] = STATE(4154),
    [sym_attributes] = STATE(8317),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(4154),
    [sym_do] = STATE(4155),
    [sym_function_or_value_defn] = STATE(594),
    [sym__expression] = STATE(120),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_exception_definition] = STATE(4154),
    [sym_type_definition] = STATE(4154),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(793),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(555),
    [sym_compiler_directive_decl] = STATE(555),
    [sym_fsi_directive_decl] = STATE(555),
    [sym_preproc_line] = STATE(555),
    [sym_preproc_if] = STATE(4154),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_file_repeat2] = STATE(556),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(2571),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(2539),
    [anon_sym_open] = ACTIONS(25),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_type] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_let_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(53),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(29),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_upcast] = ACTIONS(29),
    [anon_sym_downcast] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_exception] = ACTIONS(83),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(99),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(111),
    [sym_xint] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(115),
    [anon_sym_POUNDload] = ACTIONS(115),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(117),
  },
  [556] = {
    [sym_module_abbrev] = STATE(4154),
    [sym_module_defn] = STATE(4154),
    [sym_import_decl] = STATE(4154),
    [sym_attributes] = STATE(8317),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(4154),
    [sym_do] = STATE(4155),
    [sym_function_or_value_defn] = STATE(594),
    [sym__expression] = STATE(120),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_exception_definition] = STATE(4154),
    [sym_type_definition] = STATE(4154),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(793),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(556),
    [sym_compiler_directive_decl] = STATE(556),
    [sym_fsi_directive_decl] = STATE(556),
    [sym_preproc_line] = STATE(556),
    [sym_preproc_if] = STATE(4154),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_file_repeat2] = STATE(556),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(2384),
    [sym_identifier] = ACTIONS(2386),
    [anon_sym_module] = ACTIONS(2391),
    [anon_sym_open] = ACTIONS(2394),
    [anon_sym_LBRACK_LT] = ACTIONS(2397),
    [anon_sym_return] = ACTIONS(2573),
    [anon_sym_type] = ACTIONS(2576),
    [anon_sym_do] = ACTIONS(2406),
    [anon_sym_let] = ACTIONS(2409),
    [anon_sym_let_BANG] = ACTIONS(2412),
    [anon_sym_LPAREN] = ACTIONS(2415),
    [anon_sym_null] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(2421),
    [anon_sym_LBRACK] = ACTIONS(2424),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2427),
    [anon_sym_LBRACE] = ACTIONS(2430),
    [anon_sym_LT_AT] = ACTIONS(2433),
    [anon_sym_LT_AT_AT] = ACTIONS(2436),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2439),
    [anon_sym_new] = ACTIONS(2573),
    [anon_sym_return_BANG] = ACTIONS(2579),
    [anon_sym_yield] = ACTIONS(2573),
    [anon_sym_yield_BANG] = ACTIONS(2579),
    [anon_sym_lazy] = ACTIONS(2573),
    [anon_sym_assert] = ACTIONS(2573),
    [anon_sym_upcast] = ACTIONS(2573),
    [anon_sym_downcast] = ACTIONS(2573),
    [anon_sym_for] = ACTIONS(2445),
    [anon_sym_while] = ACTIONS(2448),
    [anon_sym_if] = ACTIONS(2451),
    [anon_sym_fun] = ACTIONS(2454),
    [anon_sym_try] = ACTIONS(2457),
    [anon_sym_match] = ACTIONS(2460),
    [anon_sym_match_BANG] = ACTIONS(2463),
    [anon_sym_function] = ACTIONS(2466),
    [anon_sym_use] = ACTIONS(2582),
    [anon_sym_use_BANG] = ACTIONS(2585),
    [anon_sym_do_BANG] = ACTIONS(2475),
    [anon_sym_begin] = ACTIONS(2478),
    [anon_sym_exception] = ACTIONS(2481),
    [aux_sym_char_token1] = ACTIONS(2484),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2487),
    [anon_sym_DQUOTE] = ACTIONS(2490),
    [anon_sym_AT_DQUOTE] = ACTIONS(2493),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2499),
    [sym_bool] = ACTIONS(2502),
    [sym_unit] = ACTIONS(2505),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2508),
    [sym_op_identifier] = ACTIONS(2511),
    [anon_sym_PLUS] = ACTIONS(2421),
    [anon_sym_DASH] = ACTIONS(2421),
    [anon_sym_PLUS_DOT] = ACTIONS(2514),
    [anon_sym_DASH_DOT] = ACTIONS(2514),
    [anon_sym_PERCENT] = ACTIONS(2514),
    [anon_sym_AMP_AMP] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2517),
    [aux_sym_prefix_op_token1] = ACTIONS(2520),
    [sym_int] = ACTIONS(2588),
    [sym_xint] = ACTIONS(2591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2529),
    [anon_sym_POUNDload] = ACTIONS(2529),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2532),
  },
  [557] = {
    [sym_module_abbrev] = STATE(4154),
    [sym_module_defn] = STATE(4154),
    [sym_import_decl] = STATE(4154),
    [sym_attributes] = STATE(8317),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(4154),
    [sym_do] = STATE(4155),
    [sym_function_or_value_defn] = STATE(594),
    [sym__expression] = STATE(120),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_exception_definition] = STATE(4154),
    [sym_type_definition] = STATE(4154),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(793),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(557),
    [sym_compiler_directive_decl] = STATE(557),
    [sym_fsi_directive_decl] = STATE(557),
    [sym_preproc_line] = STATE(557),
    [sym_preproc_if] = STATE(4154),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_file_repeat2] = STATE(554),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(2594),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(2539),
    [anon_sym_open] = ACTIONS(25),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_type] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_let_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(53),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(29),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_upcast] = ACTIONS(29),
    [anon_sym_downcast] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_exception] = ACTIONS(83),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(99),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(111),
    [sym_xint] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(115),
    [anon_sym_POUNDload] = ACTIONS(115),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(117),
  },
  [558] = {
    [sym_module_abbrev] = STATE(4154),
    [sym_module_defn] = STATE(4154),
    [sym_import_decl] = STATE(4154),
    [sym_attributes] = STATE(8317),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(4154),
    [sym_do] = STATE(4155),
    [sym_function_or_value_defn] = STATE(594),
    [sym__expression] = STATE(120),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_exception_definition] = STATE(4154),
    [sym_type_definition] = STATE(4154),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(793),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(558),
    [sym_compiler_directive_decl] = STATE(558),
    [sym_fsi_directive_decl] = STATE(558),
    [sym_preproc_line] = STATE(558),
    [sym_preproc_if] = STATE(4154),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_file_repeat2] = STATE(552),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(2596),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(2539),
    [anon_sym_open] = ACTIONS(25),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_type] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_let_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(53),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(29),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_upcast] = ACTIONS(29),
    [anon_sym_downcast] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [anon_sym_exception] = ACTIONS(83),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(99),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(111),
    [sym_xint] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(115),
    [anon_sym_POUNDload] = ACTIONS(115),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(117),
  },
  [559] = {
    [sym_module_abbrev] = STATE(9353),
    [sym_module_defn] = STATE(9353),
    [sym__module_body] = STATE(10974),
    [sym_import_decl] = STATE(9353),
    [sym_attributes] = STATE(8324),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(9353),
    [sym_do] = STATE(7583),
    [sym_function_or_value_defn] = STATE(689),
    [sym__expression] = STATE(217),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_exception_definition] = STATE(9353),
    [sym_type_definition] = STATE(9353),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(559),
    [sym_compiler_directive_decl] = STATE(559),
    [sym_fsi_directive_decl] = STATE(559),
    [sym_preproc_line] = STATE(559),
    [sym_preproc_if] = STATE(9353),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(2598),
    [anon_sym_open] = ACTIONS(2600),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_type] = ACTIONS(2602),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2606),
    [anon_sym_let_BANG] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_exception] = ACTIONS(2614),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2620),
    [anon_sym_POUNDload] = ACTIONS(2620),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2622),
  },
  [560] = {
    [sym_module_abbrev] = STATE(9353),
    [sym_module_defn] = STATE(9353),
    [sym__module_body] = STATE(10720),
    [sym_import_decl] = STATE(9353),
    [sym_attributes] = STATE(8324),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(9353),
    [sym_do] = STATE(7583),
    [sym_function_or_value_defn] = STATE(689),
    [sym__expression] = STATE(217),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_exception_definition] = STATE(9353),
    [sym_type_definition] = STATE(9353),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(3503),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(560),
    [sym_compiler_directive_decl] = STATE(560),
    [sym_fsi_directive_decl] = STATE(560),
    [sym_preproc_line] = STATE(560),
    [sym_preproc_if] = STATE(9353),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(2598),
    [anon_sym_open] = ACTIONS(2600),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_type] = ACTIONS(2602),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2606),
    [anon_sym_let_BANG] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_exception] = ACTIONS(2614),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2620),
    [anon_sym_POUNDload] = ACTIONS(2620),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2622),
  },
  [561] = {
    [sym_module_abbrev] = STATE(9353),
    [sym_module_defn] = STATE(9353),
    [sym__module_body] = STATE(11748),
    [sym_import_decl] = STATE(9353),
    [sym_attributes] = STATE(8324),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(9353),
    [sym_do] = STATE(7583),
    [sym_function_or_value_defn] = STATE(689),
    [sym__expression] = STATE(217),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_exception_definition] = STATE(9353),
    [sym_type_definition] = STATE(9353),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(3344),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(561),
    [sym_compiler_directive_decl] = STATE(561),
    [sym_fsi_directive_decl] = STATE(561),
    [sym_preproc_line] = STATE(561),
    [sym_preproc_if] = STATE(9353),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(2598),
    [anon_sym_open] = ACTIONS(2600),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_type] = ACTIONS(2602),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2606),
    [anon_sym_let_BANG] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_exception] = ACTIONS(2614),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2620),
    [anon_sym_POUNDload] = ACTIONS(2620),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2622),
  },
  [562] = {
    [sym_module_abbrev] = STATE(9353),
    [sym_module_defn] = STATE(9353),
    [sym__module_body] = STATE(10233),
    [sym_import_decl] = STATE(9353),
    [sym_attributes] = STATE(8324),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(9353),
    [sym_do] = STATE(7583),
    [sym_function_or_value_defn] = STATE(689),
    [sym__expression] = STATE(217),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_exception_definition] = STATE(9353),
    [sym_type_definition] = STATE(9353),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(3571),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(562),
    [sym_compiler_directive_decl] = STATE(562),
    [sym_fsi_directive_decl] = STATE(562),
    [sym_preproc_line] = STATE(562),
    [sym_preproc_if] = STATE(9353),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(2598),
    [anon_sym_open] = ACTIONS(2600),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_type] = ACTIONS(2602),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2606),
    [anon_sym_let_BANG] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_exception] = ACTIONS(2614),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2620),
    [anon_sym_POUNDload] = ACTIONS(2620),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2622),
  },
  [563] = {
    [sym_module_abbrev] = STATE(9353),
    [sym_module_defn] = STATE(9353),
    [sym__module_body] = STATE(10233),
    [sym_import_decl] = STATE(9353),
    [sym_attributes] = STATE(8324),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(9353),
    [sym_do] = STATE(7583),
    [sym_function_or_value_defn] = STATE(689),
    [sym__expression] = STATE(217),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_exception_definition] = STATE(9353),
    [sym_type_definition] = STATE(9353),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(563),
    [sym_compiler_directive_decl] = STATE(563),
    [sym_fsi_directive_decl] = STATE(563),
    [sym_preproc_line] = STATE(563),
    [sym_preproc_if] = STATE(9353),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(2598),
    [anon_sym_open] = ACTIONS(2600),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_type] = ACTIONS(2602),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2606),
    [anon_sym_let_BANG] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_exception] = ACTIONS(2614),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2620),
    [anon_sym_POUNDload] = ACTIONS(2620),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2622),
  },
  [564] = {
    [sym_module_abbrev] = STATE(9353),
    [sym_module_defn] = STATE(9353),
    [sym__module_body] = STATE(11724),
    [sym_import_decl] = STATE(9353),
    [sym_attributes] = STATE(8324),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(9353),
    [sym_do] = STATE(7583),
    [sym_function_or_value_defn] = STATE(689),
    [sym__expression] = STATE(217),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_exception_definition] = STATE(9353),
    [sym_type_definition] = STATE(9353),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(564),
    [sym_compiler_directive_decl] = STATE(564),
    [sym_fsi_directive_decl] = STATE(564),
    [sym_preproc_line] = STATE(564),
    [sym_preproc_if] = STATE(9353),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(2598),
    [anon_sym_open] = ACTIONS(2600),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_type] = ACTIONS(2602),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2606),
    [anon_sym_let_BANG] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_exception] = ACTIONS(2614),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2620),
    [anon_sym_POUNDload] = ACTIONS(2620),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2622),
  },
  [565] = {
    [sym_module_abbrev] = STATE(9353),
    [sym_module_defn] = STATE(9353),
    [sym__module_body] = STATE(11748),
    [sym_import_decl] = STATE(9353),
    [sym_attributes] = STATE(8324),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(9353),
    [sym_do] = STATE(7583),
    [sym_function_or_value_defn] = STATE(689),
    [sym__expression] = STATE(217),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_exception_definition] = STATE(9353),
    [sym_type_definition] = STATE(9353),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(565),
    [sym_compiler_directive_decl] = STATE(565),
    [sym_fsi_directive_decl] = STATE(565),
    [sym_preproc_line] = STATE(565),
    [sym_preproc_if] = STATE(9353),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(2598),
    [anon_sym_open] = ACTIONS(2600),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_type] = ACTIONS(2602),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2606),
    [anon_sym_let_BANG] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_exception] = ACTIONS(2614),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2620),
    [anon_sym_POUNDload] = ACTIONS(2620),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2622),
  },
  [566] = {
    [sym_module_abbrev] = STATE(9353),
    [sym_module_defn] = STATE(9353),
    [sym__module_body] = STATE(12047),
    [sym_import_decl] = STATE(9353),
    [sym_attributes] = STATE(8324),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(9353),
    [sym_do] = STATE(7583),
    [sym_function_or_value_defn] = STATE(689),
    [sym__expression] = STATE(217),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_exception_definition] = STATE(9353),
    [sym_type_definition] = STATE(9353),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(3507),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(566),
    [sym_compiler_directive_decl] = STATE(566),
    [sym_fsi_directive_decl] = STATE(566),
    [sym_preproc_line] = STATE(566),
    [sym_preproc_if] = STATE(9353),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(2598),
    [anon_sym_open] = ACTIONS(2600),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_type] = ACTIONS(2602),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2606),
    [anon_sym_let_BANG] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_exception] = ACTIONS(2614),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2620),
    [anon_sym_POUNDload] = ACTIONS(2620),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2622),
  },
  [567] = {
    [sym_module_abbrev] = STATE(9353),
    [sym_module_defn] = STATE(9353),
    [sym__module_body] = STATE(11765),
    [sym_import_decl] = STATE(9353),
    [sym_attributes] = STATE(8324),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(9353),
    [sym_do] = STATE(7583),
    [sym_function_or_value_defn] = STATE(689),
    [sym__expression] = STATE(217),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_exception_definition] = STATE(9353),
    [sym_type_definition] = STATE(9353),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(3348),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(567),
    [sym_compiler_directive_decl] = STATE(567),
    [sym_fsi_directive_decl] = STATE(567),
    [sym_preproc_line] = STATE(567),
    [sym_preproc_if] = STATE(9353),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(2598),
    [anon_sym_open] = ACTIONS(2600),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_type] = ACTIONS(2602),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2606),
    [anon_sym_let_BANG] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_exception] = ACTIONS(2614),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2620),
    [anon_sym_POUNDload] = ACTIONS(2620),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2622),
  },
  [568] = {
    [sym_module_abbrev] = STATE(9353),
    [sym_module_defn] = STATE(9353),
    [sym__module_body] = STATE(11976),
    [sym_import_decl] = STATE(9353),
    [sym_attributes] = STATE(8324),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(9353),
    [sym_do] = STATE(7583),
    [sym_function_or_value_defn] = STATE(689),
    [sym__expression] = STATE(217),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_exception_definition] = STATE(9353),
    [sym_type_definition] = STATE(9353),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(568),
    [sym_compiler_directive_decl] = STATE(568),
    [sym_fsi_directive_decl] = STATE(568),
    [sym_preproc_line] = STATE(568),
    [sym_preproc_if] = STATE(9353),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(2598),
    [anon_sym_open] = ACTIONS(2600),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_type] = ACTIONS(2602),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2606),
    [anon_sym_let_BANG] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_exception] = ACTIONS(2614),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2620),
    [anon_sym_POUNDload] = ACTIONS(2620),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2622),
  },
  [569] = {
    [sym_module_abbrev] = STATE(9353),
    [sym_module_defn] = STATE(9353),
    [sym__module_body] = STATE(11813),
    [sym_import_decl] = STATE(9353),
    [sym_attributes] = STATE(8324),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(9353),
    [sym_do] = STATE(7583),
    [sym_function_or_value_defn] = STATE(689),
    [sym__expression] = STATE(217),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_exception_definition] = STATE(9353),
    [sym_type_definition] = STATE(9353),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(569),
    [sym_compiler_directive_decl] = STATE(569),
    [sym_fsi_directive_decl] = STATE(569),
    [sym_preproc_line] = STATE(569),
    [sym_preproc_if] = STATE(9353),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(2598),
    [anon_sym_open] = ACTIONS(2600),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_type] = ACTIONS(2602),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2606),
    [anon_sym_let_BANG] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_exception] = ACTIONS(2614),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2620),
    [anon_sym_POUNDload] = ACTIONS(2620),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2622),
  },
  [570] = {
    [sym_module_abbrev] = STATE(9353),
    [sym_module_defn] = STATE(9353),
    [sym__module_body] = STATE(11976),
    [sym_import_decl] = STATE(9353),
    [sym_attributes] = STATE(8324),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(9353),
    [sym_do] = STATE(7583),
    [sym_function_or_value_defn] = STATE(689),
    [sym__expression] = STATE(217),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_exception_definition] = STATE(9353),
    [sym_type_definition] = STATE(9353),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(3459),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(570),
    [sym_compiler_directive_decl] = STATE(570),
    [sym_fsi_directive_decl] = STATE(570),
    [sym_preproc_line] = STATE(570),
    [sym_preproc_if] = STATE(9353),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(2598),
    [anon_sym_open] = ACTIONS(2600),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_type] = ACTIONS(2602),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2606),
    [anon_sym_let_BANG] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_exception] = ACTIONS(2614),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2620),
    [anon_sym_POUNDload] = ACTIONS(2620),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2622),
  },
  [571] = {
    [sym_module_abbrev] = STATE(9353),
    [sym_module_defn] = STATE(9353),
    [sym__module_body] = STATE(11827),
    [sym_import_decl] = STATE(9353),
    [sym_attributes] = STATE(8324),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(9353),
    [sym_do] = STATE(7583),
    [sym_function_or_value_defn] = STATE(689),
    [sym__expression] = STATE(217),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_exception_definition] = STATE(9353),
    [sym_type_definition] = STATE(9353),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(3433),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(571),
    [sym_compiler_directive_decl] = STATE(571),
    [sym_fsi_directive_decl] = STATE(571),
    [sym_preproc_line] = STATE(571),
    [sym_preproc_if] = STATE(9353),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(2598),
    [anon_sym_open] = ACTIONS(2600),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_type] = ACTIONS(2602),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2606),
    [anon_sym_let_BANG] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_exception] = ACTIONS(2614),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2620),
    [anon_sym_POUNDload] = ACTIONS(2620),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2622),
  },
  [572] = {
    [sym_module_abbrev] = STATE(9353),
    [sym_module_defn] = STATE(9353),
    [sym__module_body] = STATE(11827),
    [sym_import_decl] = STATE(9353),
    [sym_attributes] = STATE(8324),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(9353),
    [sym_do] = STATE(7583),
    [sym_function_or_value_defn] = STATE(689),
    [sym__expression] = STATE(217),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_exception_definition] = STATE(9353),
    [sym_type_definition] = STATE(9353),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(572),
    [sym_compiler_directive_decl] = STATE(572),
    [sym_fsi_directive_decl] = STATE(572),
    [sym_preproc_line] = STATE(572),
    [sym_preproc_if] = STATE(9353),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(2598),
    [anon_sym_open] = ACTIONS(2600),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_type] = ACTIONS(2602),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2606),
    [anon_sym_let_BANG] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_exception] = ACTIONS(2614),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2620),
    [anon_sym_POUNDload] = ACTIONS(2620),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2622),
  },
  [573] = {
    [sym_module_abbrev] = STATE(9353),
    [sym_module_defn] = STATE(9353),
    [sym__module_body] = STATE(11846),
    [sym_import_decl] = STATE(9353),
    [sym_attributes] = STATE(8324),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(9353),
    [sym_do] = STATE(7583),
    [sym_function_or_value_defn] = STATE(689),
    [sym__expression] = STATE(217),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_exception_definition] = STATE(9353),
    [sym_type_definition] = STATE(9353),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(3439),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(573),
    [sym_compiler_directive_decl] = STATE(573),
    [sym_fsi_directive_decl] = STATE(573),
    [sym_preproc_line] = STATE(573),
    [sym_preproc_if] = STATE(9353),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(2598),
    [anon_sym_open] = ACTIONS(2600),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_type] = ACTIONS(2602),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2606),
    [anon_sym_let_BANG] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_exception] = ACTIONS(2614),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2620),
    [anon_sym_POUNDload] = ACTIONS(2620),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2622),
  },
  [574] = {
    [sym_module_abbrev] = STATE(9353),
    [sym_module_defn] = STATE(9353),
    [sym__module_body] = STATE(11930),
    [sym_import_decl] = STATE(9353),
    [sym_attributes] = STATE(8324),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(9353),
    [sym_do] = STATE(7583),
    [sym_function_or_value_defn] = STATE(689),
    [sym__expression] = STATE(217),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_exception_definition] = STATE(9353),
    [sym_type_definition] = STATE(9353),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(574),
    [sym_compiler_directive_decl] = STATE(574),
    [sym_fsi_directive_decl] = STATE(574),
    [sym_preproc_line] = STATE(574),
    [sym_preproc_if] = STATE(9353),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(2598),
    [anon_sym_open] = ACTIONS(2600),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_type] = ACTIONS(2602),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2606),
    [anon_sym_let_BANG] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_exception] = ACTIONS(2614),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2620),
    [anon_sym_POUNDload] = ACTIONS(2620),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2622),
  },
  [575] = {
    [sym_module_abbrev] = STATE(10455),
    [sym_module_defn] = STATE(10455),
    [sym_import_decl] = STATE(10455),
    [sym_attributes] = STATE(8331),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(10455),
    [sym_do] = STATE(11970),
    [sym_function_or_value_defn] = STATE(747),
    [sym__expression] = STATE(411),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_exception_definition] = STATE(10455),
    [sym_type_definition] = STATE(10455),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1020),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(2924),
    [sym_block_comment] = STATE(575),
    [sym_compiler_directive_decl] = STATE(575),
    [sym_fsi_directive_decl] = STATE(575),
    [sym_preproc_line] = STATE(575),
    [sym_preproc_if] = STATE(10455),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_open] = ACTIONS(2626),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_type] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2630),
    [anon_sym_let] = ACTIONS(2632),
    [anon_sym_let_BANG] = ACTIONS(2634),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(2638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(1492),
    [anon_sym_return_BANG] = ACTIONS(1496),
    [anon_sym_yield] = ACTIONS(1492),
    [anon_sym_yield_BANG] = ACTIONS(1496),
    [anon_sym_lazy] = ACTIONS(1492),
    [anon_sym_assert] = ACTIONS(1492),
    [anon_sym_upcast] = ACTIONS(1492),
    [anon_sym_downcast] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_use] = ACTIONS(1500),
    [anon_sym_use_BANG] = ACTIONS(1502),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [anon_sym_exception] = ACTIONS(2640),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(2642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1504),
    [sym_xint] = ACTIONS(1506),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2646),
    [anon_sym_POUNDload] = ACTIONS(2646),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2648),
  },
  [576] = {
    [sym_module_abbrev] = STATE(9713),
    [sym_module_defn] = STATE(9713),
    [sym_import_decl] = STATE(9713),
    [sym_attributes] = STATE(8324),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(9713),
    [sym_do] = STATE(7583),
    [sym_function_or_value_defn] = STATE(689),
    [sym__expression] = STATE(417),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_exception_definition] = STATE(9713),
    [sym_type_definition] = STATE(9713),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(576),
    [sym_compiler_directive_decl] = STATE(576),
    [sym_fsi_directive_decl] = STATE(576),
    [sym_preproc_line] = STATE(576),
    [sym_preproc_if] = STATE(9713),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(2598),
    [anon_sym_open] = ACTIONS(2600),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_type] = ACTIONS(2602),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2606),
    [anon_sym_let_BANG] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_exception] = ACTIONS(2614),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2620),
    [anon_sym_POUNDload] = ACTIONS(2620),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2622),
  },
  [577] = {
    [sym_module_abbrev] = STATE(9713),
    [sym_module_defn] = STATE(9713),
    [sym_import_decl] = STATE(9713),
    [sym_attributes] = STATE(8324),
    [sym__attribute_set] = STATE(6370),
    [sym_value_declaration] = STATE(9713),
    [sym_do] = STATE(7583),
    [sym_function_or_value_defn] = STATE(689),
    [sym__expression] = STATE(427),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_exception_definition] = STATE(9713),
    [sym_type_definition] = STATE(9713),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(577),
    [sym_compiler_directive_decl] = STATE(577),
    [sym_fsi_directive_decl] = STATE(577),
    [sym_preproc_line] = STATE(577),
    [sym_preproc_if] = STATE(9713),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(2598),
    [anon_sym_open] = ACTIONS(2600),
    [anon_sym_LBRACK_LT] = ACTIONS(27),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_type] = ACTIONS(2602),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2606),
    [anon_sym_let_BANG] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_exception] = ACTIONS(2614),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2620),
    [anon_sym_POUNDload] = ACTIONS(2620),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2622),
  },
  [578] = {
    [sym_function_or_value_defn] = STATE(845),
    [sym__expression] = STATE(131),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym__list_elements] = STATE(11221),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym__comp_or_range_expression] = STATE(11221),
    [sym_short_comp_expression] = STATE(11335),
    [sym_slice_ranges] = STATE(11221),
    [sym__slice_range_special] = STATE(9896),
    [sym_slice_range] = STATE(9033),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(776),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(578),
    [sym_compiler_directive_decl] = STATE(578),
    [sym_fsi_directive_decl] = STATE(578),
    [sym_preproc_line] = STATE(578),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1203),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1203),
    [anon_sym_return_BANG] = ACTIONS(1207),
    [anon_sym_yield] = ACTIONS(1203),
    [anon_sym_yield_BANG] = ACTIONS(1207),
    [anon_sym_lazy] = ACTIONS(1203),
    [anon_sym_assert] = ACTIONS(1203),
    [anon_sym_upcast] = ACTIONS(1203),
    [anon_sym_downcast] = ACTIONS(1203),
    [anon_sym_for] = ACTIONS(2650),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1213),
    [anon_sym_use_BANG] = ACTIONS(1215),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_DOT_DOT3] = ACTIONS(2652),
    [anon_sym_STAR] = ACTIONS(2654),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1219),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(2656),
  },
  [579] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(255),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_type_arguments] = STATE(4193),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2707),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(579),
    [sym_compiler_directive_decl] = STATE(579),
    [sym_fsi_directive_decl] = STATE(579),
    [sym_preproc_line] = STATE(579),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_compound_type_repeat1] = STATE(4157),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2658),
    [anon_sym_GT_RBRACK] = ACTIONS(2660),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_DASH_GT] = ACTIONS(2666),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_STAR] = ACTIONS(2668),
    [anon_sym_LT2] = ACTIONS(2670),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2672),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__newline] = ACTIONS(2660),
  },
  [580] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(402),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_type_arguments] = STATE(4201),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(2650),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(580),
    [sym_compiler_directive_decl] = STATE(580),
    [sym_fsi_directive_decl] = STATE(580),
    [sym_preproc_line] = STATE(580),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_compound_type_repeat1] = STATE(4185),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_DASH_GT] = ACTIONS(2680),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_STAR] = ACTIONS(2682),
    [anon_sym_LT2] = ACTIONS(2684),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2686),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__dedent] = ACTIONS(2688),
  },
  [581] = {
    [sym_function_or_value_defn] = STATE(866),
    [sym__expression] = STATE(98),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1178),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(581),
    [sym_compiler_directive_decl] = STATE(581),
    [sym_fsi_directive_decl] = STATE(581),
    [sym_preproc_line] = STATE(581),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(2690),
    [sym_identifier] = ACTIONS(2692),
    [anon_sym_namespace] = ACTIONS(2692),
    [anon_sym_module] = ACTIONS(2692),
    [anon_sym_open] = ACTIONS(2692),
    [anon_sym_LBRACK_LT] = ACTIONS(2690),
    [anon_sym_return] = ACTIONS(2692),
    [anon_sym_type] = ACTIONS(2692),
    [anon_sym_do] = ACTIONS(2692),
    [anon_sym_let] = ACTIONS(2692),
    [anon_sym_let_BANG] = ACTIONS(2690),
    [anon_sym_LPAREN] = ACTIONS(2692),
    [anon_sym_null] = ACTIONS(2692),
    [anon_sym_AMP] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2692),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2690),
    [anon_sym_LBRACE] = ACTIONS(2692),
    [anon_sym_LT_AT] = ACTIONS(2692),
    [anon_sym_LT_AT_AT] = ACTIONS(2690),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2690),
    [anon_sym_new] = ACTIONS(2692),
    [anon_sym_return_BANG] = ACTIONS(2690),
    [anon_sym_yield] = ACTIONS(2692),
    [anon_sym_yield_BANG] = ACTIONS(2690),
    [anon_sym_lazy] = ACTIONS(2692),
    [anon_sym_assert] = ACTIONS(2692),
    [anon_sym_upcast] = ACTIONS(2692),
    [anon_sym_downcast] = ACTIONS(2692),
    [anon_sym_for] = ACTIONS(2692),
    [anon_sym_while] = ACTIONS(2692),
    [anon_sym_if] = ACTIONS(2692),
    [anon_sym_fun] = ACTIONS(2692),
    [anon_sym_try] = ACTIONS(2692),
    [anon_sym_match] = ACTIONS(2692),
    [anon_sym_match_BANG] = ACTIONS(2690),
    [anon_sym_function] = ACTIONS(2692),
    [anon_sym_use] = ACTIONS(2692),
    [anon_sym_use_BANG] = ACTIONS(2690),
    [anon_sym_do_BANG] = ACTIONS(2690),
    [anon_sym_begin] = ACTIONS(2692),
    [anon_sym_exception] = ACTIONS(2692),
    [aux_sym_char_token1] = ACTIONS(2690),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2692),
    [anon_sym_DQUOTE] = ACTIONS(2692),
    [anon_sym_AT_DQUOTE] = ACTIONS(2690),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2690),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2690),
    [sym_bool] = ACTIONS(2692),
    [sym_unit] = ACTIONS(2690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2692),
    [sym_op_identifier] = ACTIONS(2690),
    [anon_sym_PLUS] = ACTIONS(2692),
    [anon_sym_DASH] = ACTIONS(2692),
    [anon_sym_PLUS_DOT] = ACTIONS(2690),
    [anon_sym_DASH_DOT] = ACTIONS(2690),
    [anon_sym_PERCENT] = ACTIONS(2690),
    [anon_sym_AMP_AMP] = ACTIONS(2690),
    [anon_sym_TILDE] = ACTIONS(2690),
    [aux_sym_prefix_op_token1] = ACTIONS(2690),
    [sym_int] = ACTIONS(2692),
    [sym_xint] = ACTIONS(2690),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2690),
    [anon_sym_POUNDload] = ACTIONS(2690),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2690),
  },
  [582] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(448),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_type_arguments] = STATE(4201),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(2650),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(582),
    [sym_compiler_directive_decl] = STATE(582),
    [sym_fsi_directive_decl] = STATE(582),
    [sym_preproc_line] = STATE(582),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_compound_type_repeat1] = STATE(4185),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_DASH_GT] = ACTIONS(2680),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_STAR] = ACTIONS(2682),
    [anon_sym_LT2] = ACTIONS(2684),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2686),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__dedent] = ACTIONS(2694),
  },
  [583] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(253),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_type_arguments] = STATE(4201),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(2650),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(583),
    [sym_compiler_directive_decl] = STATE(583),
    [sym_fsi_directive_decl] = STATE(583),
    [sym_preproc_line] = STATE(583),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_compound_type_repeat1] = STATE(4185),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_DASH_GT] = ACTIONS(2680),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_STAR] = ACTIONS(2682),
    [anon_sym_LT2] = ACTIONS(2684),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2686),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__dedent] = ACTIONS(2696),
  },
  [584] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(207),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_object_expression] = STATE(10224),
    [sym_with_field_expression] = STATE(10224),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym__comp_or_range_expression] = STATE(10209),
    [sym_short_comp_expression] = STATE(11335),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10224),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(2796),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(584),
    [sym_compiler_directive_decl] = STATE(584),
    [sym_fsi_directive_decl] = STATE(584),
    [sym_preproc_line] = STATE(584),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(2700),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [585] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(207),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_object_expression] = STATE(10376),
    [sym_with_field_expression] = STATE(10376),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym__comp_or_range_expression] = STATE(10399),
    [sym_short_comp_expression] = STATE(11335),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10376),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(2796),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(585),
    [sym_compiler_directive_decl] = STATE(585),
    [sym_fsi_directive_decl] = STATE(585),
    [sym_preproc_line] = STATE(585),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(2700),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [586] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(207),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_object_expression] = STATE(10445),
    [sym_with_field_expression] = STATE(10445),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym__comp_or_range_expression] = STATE(10468),
    [sym_short_comp_expression] = STATE(11335),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10445),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(2796),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(586),
    [sym_compiler_directive_decl] = STATE(586),
    [sym_fsi_directive_decl] = STATE(586),
    [sym_preproc_line] = STATE(586),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(2700),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [587] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(207),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_object_expression] = STATE(10906),
    [sym_with_field_expression] = STATE(10906),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym__comp_or_range_expression] = STATE(10922),
    [sym_short_comp_expression] = STATE(11335),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10906),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(2796),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(587),
    [sym_compiler_directive_decl] = STATE(587),
    [sym_fsi_directive_decl] = STATE(587),
    [sym_preproc_line] = STATE(587),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(2700),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [588] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(207),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_object_expression] = STATE(10866),
    [sym_with_field_expression] = STATE(10866),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym__comp_or_range_expression] = STATE(10882),
    [sym_short_comp_expression] = STATE(11335),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10866),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(2796),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(588),
    [sym_compiler_directive_decl] = STATE(588),
    [sym_fsi_directive_decl] = STATE(588),
    [sym_preproc_line] = STATE(588),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(2700),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [589] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(207),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_object_expression] = STATE(10784),
    [sym_with_field_expression] = STATE(10784),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym__comp_or_range_expression] = STATE(10800),
    [sym_short_comp_expression] = STATE(11335),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10784),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(2796),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(589),
    [sym_compiler_directive_decl] = STATE(589),
    [sym_fsi_directive_decl] = STATE(589),
    [sym_preproc_line] = STATE(589),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(2700),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [590] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(207),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_object_expression] = STATE(10213),
    [sym_with_field_expression] = STATE(10213),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym__comp_or_range_expression] = STATE(10239),
    [sym_short_comp_expression] = STATE(11335),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10213),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(2796),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(590),
    [sym_compiler_directive_decl] = STATE(590),
    [sym_fsi_directive_decl] = STATE(590),
    [sym_preproc_line] = STATE(590),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(2700),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [591] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(207),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_object_expression] = STATE(10280),
    [sym_with_field_expression] = STATE(10280),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym__comp_or_range_expression] = STATE(10262),
    [sym_short_comp_expression] = STATE(11335),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10280),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(2796),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(591),
    [sym_compiler_directive_decl] = STATE(591),
    [sym_fsi_directive_decl] = STATE(591),
    [sym_preproc_line] = STATE(591),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(2700),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [592] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(207),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_object_expression] = STATE(10581),
    [sym_with_field_expression] = STATE(10581),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym__comp_or_range_expression] = STATE(10601),
    [sym_short_comp_expression] = STATE(11335),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10581),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(2796),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(592),
    [sym_compiler_directive_decl] = STATE(592),
    [sym_fsi_directive_decl] = STATE(592),
    [sym_preproc_line] = STATE(592),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(2700),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [593] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(207),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_object_expression] = STATE(10514),
    [sym_with_field_expression] = STATE(10514),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym__comp_or_range_expression] = STATE(10537),
    [sym_short_comp_expression] = STATE(11335),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10514),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(2796),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(593),
    [sym_compiler_directive_decl] = STATE(593),
    [sym_fsi_directive_decl] = STATE(593),
    [sym_preproc_line] = STATE(593),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(2700),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [594] = {
    [sym_function_or_value_defn] = STATE(964),
    [sym__expression] = STATE(108),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(793),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(594),
    [sym_compiler_directive_decl] = STATE(594),
    [sym_fsi_directive_decl] = STATE(594),
    [sym_preproc_line] = STATE(594),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [ts_builtin_sym_end] = ACTIONS(2690),
    [sym_identifier] = ACTIONS(2692),
    [anon_sym_module] = ACTIONS(2692),
    [anon_sym_open] = ACTIONS(2692),
    [anon_sym_LBRACK_LT] = ACTIONS(2690),
    [anon_sym_return] = ACTIONS(2692),
    [anon_sym_type] = ACTIONS(2692),
    [anon_sym_do] = ACTIONS(2692),
    [anon_sym_let] = ACTIONS(2692),
    [anon_sym_let_BANG] = ACTIONS(2690),
    [anon_sym_LPAREN] = ACTIONS(2692),
    [anon_sym_null] = ACTIONS(2692),
    [anon_sym_AMP] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2692),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2690),
    [anon_sym_LBRACE] = ACTIONS(2692),
    [anon_sym_LT_AT] = ACTIONS(2692),
    [anon_sym_LT_AT_AT] = ACTIONS(2690),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2690),
    [anon_sym_new] = ACTIONS(2692),
    [anon_sym_return_BANG] = ACTIONS(2690),
    [anon_sym_yield] = ACTIONS(2692),
    [anon_sym_yield_BANG] = ACTIONS(2690),
    [anon_sym_lazy] = ACTIONS(2692),
    [anon_sym_assert] = ACTIONS(2692),
    [anon_sym_upcast] = ACTIONS(2692),
    [anon_sym_downcast] = ACTIONS(2692),
    [anon_sym_for] = ACTIONS(2692),
    [anon_sym_while] = ACTIONS(2692),
    [anon_sym_if] = ACTIONS(2692),
    [anon_sym_fun] = ACTIONS(2692),
    [anon_sym_try] = ACTIONS(2692),
    [anon_sym_match] = ACTIONS(2692),
    [anon_sym_match_BANG] = ACTIONS(2690),
    [anon_sym_function] = ACTIONS(2692),
    [anon_sym_use] = ACTIONS(2692),
    [anon_sym_use_BANG] = ACTIONS(2690),
    [anon_sym_do_BANG] = ACTIONS(2690),
    [anon_sym_begin] = ACTIONS(2692),
    [anon_sym_exception] = ACTIONS(2692),
    [aux_sym_char_token1] = ACTIONS(2690),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2692),
    [anon_sym_DQUOTE] = ACTIONS(2692),
    [anon_sym_AT_DQUOTE] = ACTIONS(2690),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2690),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2690),
    [sym_bool] = ACTIONS(2692),
    [sym_unit] = ACTIONS(2690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2692),
    [sym_op_identifier] = ACTIONS(2690),
    [anon_sym_PLUS] = ACTIONS(2692),
    [anon_sym_DASH] = ACTIONS(2692),
    [anon_sym_PLUS_DOT] = ACTIONS(2690),
    [anon_sym_DASH_DOT] = ACTIONS(2690),
    [anon_sym_PERCENT] = ACTIONS(2690),
    [anon_sym_AMP_AMP] = ACTIONS(2690),
    [anon_sym_TILDE] = ACTIONS(2690),
    [aux_sym_prefix_op_token1] = ACTIONS(2690),
    [sym_int] = ACTIONS(2692),
    [sym_xint] = ACTIONS(2690),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2690),
    [anon_sym_POUNDload] = ACTIONS(2690),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2690),
  },
  [595] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(207),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_object_expression] = STATE(10306),
    [sym_with_field_expression] = STATE(10306),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym__comp_or_range_expression] = STATE(10329),
    [sym_short_comp_expression] = STATE(11335),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10306),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(2796),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(595),
    [sym_compiler_directive_decl] = STATE(595),
    [sym_fsi_directive_decl] = STATE(595),
    [sym_preproc_line] = STATE(595),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(2700),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [596] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(207),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_object_expression] = STATE(10698),
    [sym_with_field_expression] = STATE(10698),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym__comp_or_range_expression] = STATE(10714),
    [sym_short_comp_expression] = STATE(11335),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10698),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(2796),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(596),
    [sym_compiler_directive_decl] = STATE(596),
    [sym_fsi_directive_decl] = STATE(596),
    [sym_preproc_line] = STATE(596),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(2700),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [597] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(207),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_object_expression] = STATE(10742),
    [sym_with_field_expression] = STATE(10742),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym__comp_or_range_expression] = STATE(10758),
    [sym_short_comp_expression] = STATE(11335),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10742),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(2796),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(597),
    [sym_compiler_directive_decl] = STATE(597),
    [sym_fsi_directive_decl] = STATE(597),
    [sym_preproc_line] = STATE(597),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(2700),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [598] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(207),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_object_expression] = STATE(11315),
    [sym_with_field_expression] = STATE(11315),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym__comp_or_range_expression] = STATE(10752),
    [sym_short_comp_expression] = STATE(11335),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(11315),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(2796),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(598),
    [sym_compiler_directive_decl] = STATE(598),
    [sym_fsi_directive_decl] = STATE(598),
    [sym_preproc_line] = STATE(598),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(2700),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [599] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(207),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_object_expression] = STATE(10640),
    [sym_with_field_expression] = STATE(10640),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym__comp_or_range_expression] = STATE(10660),
    [sym_short_comp_expression] = STATE(11335),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10640),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(2796),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(599),
    [sym_compiler_directive_decl] = STATE(599),
    [sym_fsi_directive_decl] = STATE(599),
    [sym_preproc_line] = STATE(599),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(2700),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [600] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(207),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_object_expression] = STATE(10826),
    [sym_with_field_expression] = STATE(10826),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym__comp_or_range_expression] = STATE(10842),
    [sym_short_comp_expression] = STATE(11335),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10826),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(2796),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(600),
    [sym_compiler_directive_decl] = STATE(600),
    [sym_fsi_directive_decl] = STATE(600),
    [sym_preproc_line] = STATE(600),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(2700),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [601] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(163),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_slice_ranges] = STATE(11860),
    [sym__slice_range_special] = STATE(9987),
    [sym_slice_range] = STATE(9002),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(887),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(601),
    [sym_compiler_directive_decl] = STATE(601),
    [sym_fsi_directive_decl] = STATE(601),
    [sym_preproc_line] = STATE(601),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_DOT_DOT3] = ACTIONS(2704),
    [anon_sym_STAR] = ACTIONS(2706),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [602] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(195),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_slice_ranges] = STATE(11362),
    [sym__slice_range_special] = STATE(9987),
    [sym_slice_range] = STATE(9002),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(887),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(602),
    [sym_compiler_directive_decl] = STATE(602),
    [sym_fsi_directive_decl] = STATE(602),
    [sym_preproc_line] = STATE(602),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_DOT_DOT3] = ACTIONS(2704),
    [anon_sym_STAR] = ACTIONS(2706),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [603] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(603),
    [sym_compiler_directive_decl] = STATE(603),
    [sym_fsi_directive_decl] = STATE(603),
    [sym_preproc_line] = STATE(603),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(10991),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(647),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2708),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [604] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(604),
    [sym_compiler_directive_decl] = STATE(604),
    [sym_fsi_directive_decl] = STATE(604),
    [sym_preproc_line] = STATE(604),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(11590),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(627),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2710),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [605] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(157),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_slice_ranges] = STATE(11151),
    [sym__slice_range_special] = STATE(9987),
    [sym_slice_range] = STATE(9002),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(887),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(605),
    [sym_compiler_directive_decl] = STATE(605),
    [sym_fsi_directive_decl] = STATE(605),
    [sym_preproc_line] = STATE(605),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_DOT_DOT3] = ACTIONS(2704),
    [anon_sym_STAR] = ACTIONS(2706),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [606] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(219),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_slice_ranges] = STATE(11526),
    [sym__slice_range_special] = STATE(9987),
    [sym_slice_range] = STATE(9002),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(887),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(606),
    [sym_compiler_directive_decl] = STATE(606),
    [sym_fsi_directive_decl] = STATE(606),
    [sym_preproc_line] = STATE(606),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_DOT_DOT3] = ACTIONS(2704),
    [anon_sym_STAR] = ACTIONS(2706),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [607] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(607),
    [sym_compiler_directive_decl] = STATE(607),
    [sym_fsi_directive_decl] = STATE(607),
    [sym_preproc_line] = STATE(607),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(10760),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(615),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2382),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [608] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(608),
    [sym_compiler_directive_decl] = STATE(608),
    [sym_fsi_directive_decl] = STATE(608),
    [sym_preproc_line] = STATE(608),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(11767),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(644),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2712),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [609] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(609),
    [sym_compiler_directive_decl] = STATE(609),
    [sym_fsi_directive_decl] = STATE(609),
    [sym_preproc_line] = STATE(609),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(11253),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(657),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2714),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [610] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(166),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_slice_ranges] = STATE(11013),
    [sym__slice_range_special] = STATE(9987),
    [sym_slice_range] = STATE(9002),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(887),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(610),
    [sym_compiler_directive_decl] = STATE(610),
    [sym_fsi_directive_decl] = STATE(610),
    [sym_preproc_line] = STATE(610),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_DOT_DOT3] = ACTIONS(2704),
    [anon_sym_STAR] = ACTIONS(2706),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [611] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(611),
    [sym_compiler_directive_decl] = STATE(611),
    [sym_fsi_directive_decl] = STATE(611),
    [sym_preproc_line] = STATE(611),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(11656),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(657),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2716),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [612] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(612),
    [sym_compiler_directive_decl] = STATE(612),
    [sym_fsi_directive_decl] = STATE(612),
    [sym_preproc_line] = STATE(612),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(11083),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(657),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2718),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [613] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(613),
    [sym_compiler_directive_decl] = STATE(613),
    [sym_fsi_directive_decl] = STATE(613),
    [sym_preproc_line] = STATE(613),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(11329),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(657),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2720),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [614] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(614),
    [sym_compiler_directive_decl] = STATE(614),
    [sym_fsi_directive_decl] = STATE(614),
    [sym_preproc_line] = STATE(614),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(11436),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(623),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2378),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [615] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(615),
    [sym_compiler_directive_decl] = STATE(615),
    [sym_fsi_directive_decl] = STATE(615),
    [sym_preproc_line] = STATE(615),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(10265),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(657),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2722),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [616] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(616),
    [sym_compiler_directive_decl] = STATE(616),
    [sym_fsi_directive_decl] = STATE(616),
    [sym_preproc_line] = STATE(616),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(11039),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(657),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2724),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [617] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(617),
    [sym_compiler_directive_decl] = STATE(617),
    [sym_fsi_directive_decl] = STATE(617),
    [sym_preproc_line] = STATE(617),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(11126),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(657),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2726),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [618] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(240),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_slice_ranges] = STATE(11681),
    [sym__slice_range_special] = STATE(9987),
    [sym_slice_range] = STATE(9002),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(887),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(618),
    [sym_compiler_directive_decl] = STATE(618),
    [sym_fsi_directive_decl] = STATE(618),
    [sym_preproc_line] = STATE(618),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_DOT_DOT3] = ACTIONS(2704),
    [anon_sym_STAR] = ACTIONS(2706),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [619] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(161),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_slice_ranges] = STATE(11196),
    [sym__slice_range_special] = STATE(9987),
    [sym_slice_range] = STATE(9002),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(887),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(619),
    [sym_compiler_directive_decl] = STATE(619),
    [sym_fsi_directive_decl] = STATE(619),
    [sym_preproc_line] = STATE(619),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_DOT_DOT3] = ACTIONS(2704),
    [anon_sym_STAR] = ACTIONS(2706),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [620] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(620),
    [sym_compiler_directive_decl] = STATE(620),
    [sym_fsi_directive_decl] = STATE(620),
    [sym_preproc_line] = STATE(620),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(11267),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(609),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2728),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [621] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(208),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_slice_ranges] = STATE(11447),
    [sym__slice_range_special] = STATE(9987),
    [sym_slice_range] = STATE(9002),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(887),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(621),
    [sym_compiler_directive_decl] = STATE(621),
    [sym_fsi_directive_decl] = STATE(621),
    [sym_preproc_line] = STATE(621),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_DOT_DOT3] = ACTIONS(2704),
    [anon_sym_STAR] = ACTIONS(2706),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [622] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(622),
    [sym_compiler_directive_decl] = STATE(622),
    [sym_fsi_directive_decl] = STATE(622),
    [sym_preproc_line] = STATE(622),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(11135),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(617),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2730),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [623] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(623),
    [sym_compiler_directive_decl] = STATE(623),
    [sym_fsi_directive_decl] = STATE(623),
    [sym_preproc_line] = STATE(623),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(11426),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(657),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2732),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [624] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(178),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_slice_ranges] = STATE(11086),
    [sym__slice_range_special] = STATE(9987),
    [sym_slice_range] = STATE(9002),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(887),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(624),
    [sym_compiler_directive_decl] = STATE(624),
    [sym_fsi_directive_decl] = STATE(624),
    [sym_preproc_line] = STATE(624),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_DOT_DOT3] = ACTIONS(2704),
    [anon_sym_STAR] = ACTIONS(2706),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [625] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(625),
    [sym_compiler_directive_decl] = STATE(625),
    [sym_fsi_directive_decl] = STATE(625),
    [sym_preproc_line] = STATE(625),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(11174),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(657),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2734),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [626] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(626),
    [sym_compiler_directive_decl] = STATE(626),
    [sym_fsi_directive_decl] = STATE(626),
    [sym_preproc_line] = STATE(626),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(11348),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(613),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2736),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [627] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(627),
    [sym_compiler_directive_decl] = STATE(627),
    [sym_fsi_directive_decl] = STATE(627),
    [sym_preproc_line] = STATE(627),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(11579),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(657),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2738),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [628] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(628),
    [sym_compiler_directive_decl] = STATE(628),
    [sym_fsi_directive_decl] = STATE(628),
    [sym_preproc_line] = STATE(628),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(11829),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(657),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2740),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [629] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(236),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_slice_ranges] = STATE(11603),
    [sym__slice_range_special] = STATE(9987),
    [sym_slice_range] = STATE(9002),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(887),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(629),
    [sym_compiler_directive_decl] = STATE(629),
    [sym_fsi_directive_decl] = STATE(629),
    [sym_preproc_line] = STATE(629),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_DOT_DOT3] = ACTIONS(2704),
    [anon_sym_STAR] = ACTIONS(2706),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [630] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(237),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_slice_ranges] = STATE(12078),
    [sym__slice_range_special] = STATE(9987),
    [sym_slice_range] = STATE(9002),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(887),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(630),
    [sym_compiler_directive_decl] = STATE(630),
    [sym_fsi_directive_decl] = STATE(630),
    [sym_preproc_line] = STATE(630),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_DOT_DOT3] = ACTIONS(2704),
    [anon_sym_STAR] = ACTIONS(2706),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [631] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(631),
    [sym_compiler_directive_decl] = STATE(631),
    [sym_fsi_directive_decl] = STATE(631),
    [sym_preproc_line] = STATE(631),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(11091),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(612),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2742),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [632] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(174),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_slice_ranges] = STATE(11285),
    [sym__slice_range_special] = STATE(9987),
    [sym_slice_range] = STATE(9002),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(887),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(632),
    [sym_compiler_directive_decl] = STATE(632),
    [sym_fsi_directive_decl] = STATE(632),
    [sym_preproc_line] = STATE(632),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_DOT_DOT3] = ACTIONS(2704),
    [anon_sym_STAR] = ACTIONS(2706),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [633] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(633),
    [sym_compiler_directive_decl] = STATE(633),
    [sym_fsi_directive_decl] = STATE(633),
    [sym_preproc_line] = STATE(633),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(11983),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(657),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2744),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [634] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(167),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_slice_ranges] = STATE(10955),
    [sym__slice_range_special] = STATE(9987),
    [sym_slice_range] = STATE(9002),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(887),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(634),
    [sym_compiler_directive_decl] = STATE(634),
    [sym_fsi_directive_decl] = STATE(634),
    [sym_preproc_line] = STATE(634),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_DOT_DOT3] = ACTIONS(2704),
    [anon_sym_STAR] = ACTIONS(2706),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [635] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(635),
    [sym_compiler_directive_decl] = STATE(635),
    [sym_fsi_directive_decl] = STATE(635),
    [sym_preproc_line] = STATE(635),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(11182),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(625),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2372),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [636] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(152),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_slice_ranges] = STATE(11105),
    [sym__slice_range_special] = STATE(9987),
    [sym_slice_range] = STATE(9002),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(887),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(636),
    [sym_compiler_directive_decl] = STATE(636),
    [sym_fsi_directive_decl] = STATE(636),
    [sym_preproc_line] = STATE(636),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_DOT_DOT3] = ACTIONS(2704),
    [anon_sym_STAR] = ACTIONS(2706),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [637] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(637),
    [sym_compiler_directive_decl] = STATE(637),
    [sym_fsi_directive_decl] = STATE(637),
    [sym_preproc_line] = STATE(637),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(11668),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(611),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2380),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [638] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(230),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_slice_ranges] = STATE(11781),
    [sym__slice_range_special] = STATE(9987),
    [sym_slice_range] = STATE(9002),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(887),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(638),
    [sym_compiler_directive_decl] = STATE(638),
    [sym_fsi_directive_decl] = STATE(638),
    [sym_preproc_line] = STATE(638),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_DOT_DOT3] = ACTIONS(2704),
    [anon_sym_STAR] = ACTIONS(2706),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [639] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(639),
    [sym_compiler_directive_decl] = STATE(639),
    [sym_fsi_directive_decl] = STATE(639),
    [sym_preproc_line] = STATE(639),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(12048),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(633),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2746),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [640] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(147),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_slice_ranges] = STATE(11059),
    [sym__slice_range_special] = STATE(9987),
    [sym_slice_range] = STATE(9002),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(887),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(640),
    [sym_compiler_directive_decl] = STATE(640),
    [sym_fsi_directive_decl] = STATE(640),
    [sym_preproc_line] = STATE(640),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_DOT_DOT3] = ACTIONS(2704),
    [anon_sym_STAR] = ACTIONS(2706),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [641] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(641),
    [sym_compiler_directive_decl] = STATE(641),
    [sym_fsi_directive_decl] = STATE(641),
    [sym_preproc_line] = STATE(641),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(11848),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(628),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2748),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [642] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(642),
    [sym_compiler_directive_decl] = STATE(642),
    [sym_fsi_directive_decl] = STATE(642),
    [sym_preproc_line] = STATE(642),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(11047),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(616),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2750),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [643] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(643),
    [sym_compiler_directive_decl] = STATE(643),
    [sym_fsi_directive_decl] = STATE(643),
    [sym_preproc_line] = STATE(643),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(10926),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(657),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2752),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [644] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(644),
    [sym_compiler_directive_decl] = STATE(644),
    [sym_fsi_directive_decl] = STATE(644),
    [sym_preproc_line] = STATE(644),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(11750),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(657),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2754),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [645] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(645),
    [sym_compiler_directive_decl] = STATE(645),
    [sym_fsi_directive_decl] = STATE(645),
    [sym_preproc_line] = STATE(645),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(10939),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(643),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2756),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [646] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(646),
    [sym_compiler_directive_decl] = STATE(646),
    [sym_fsi_directive_decl] = STATE(646),
    [sym_preproc_line] = STATE(646),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(11510),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(648),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2758),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [647] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(647),
    [sym_compiler_directive_decl] = STATE(647),
    [sym_fsi_directive_decl] = STATE(647),
    [sym_preproc_line] = STATE(647),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(10979),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(657),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2760),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [648] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(648),
    [sym_compiler_directive_decl] = STATE(648),
    [sym_fsi_directive_decl] = STATE(648),
    [sym_preproc_line] = STATE(648),
    [sym_preproc_if_in_expression] = STATE(1882),
    [sym_preproc_else_in_expression] = STATE(11499),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(657),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2762),
    [anon_sym_POUNDelse] = ACTIONS(2374),
    [sym__newline] = ACTIONS(2376),
  },
  [649] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(235),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym__slice_range_special] = STATE(9987),
    [sym_slice_range] = STATE(9483),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(887),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(649),
    [sym_compiler_directive_decl] = STATE(649),
    [sym_fsi_directive_decl] = STATE(649),
    [sym_preproc_line] = STATE(649),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [anon_sym_DOT_DOT3] = ACTIONS(2704),
    [anon_sym_STAR] = ACTIONS(2706),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [650] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_object_expression] = STATE(10742),
    [sym_with_field_expression] = STATE(10742),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10742),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(650),
    [sym_compiler_directive_decl] = STATE(650),
    [sym_fsi_directive_decl] = STATE(650),
    [sym_preproc_line] = STATE(650),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(2766),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [651] = {
    [sym_function_or_value_defn] = STATE(845),
    [sym__expression] = STATE(175),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym__slice_range_special] = STATE(9896),
    [sym_slice_range] = STATE(9906),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(776),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(651),
    [sym_compiler_directive_decl] = STATE(651),
    [sym_fsi_directive_decl] = STATE(651),
    [sym_preproc_line] = STATE(651),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1203),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1203),
    [anon_sym_return_BANG] = ACTIONS(1207),
    [anon_sym_yield] = ACTIONS(1203),
    [anon_sym_yield_BANG] = ACTIONS(1207),
    [anon_sym_lazy] = ACTIONS(1203),
    [anon_sym_assert] = ACTIONS(1203),
    [anon_sym_upcast] = ACTIONS(1203),
    [anon_sym_downcast] = ACTIONS(1203),
    [anon_sym_for] = ACTIONS(1209),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1213),
    [anon_sym_use_BANG] = ACTIONS(1215),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [anon_sym_DOT_DOT3] = ACTIONS(2652),
    [anon_sym_STAR] = ACTIONS(2654),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1219),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [652] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_object_expression] = STATE(10280),
    [sym_with_field_expression] = STATE(10280),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10280),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(652),
    [sym_compiler_directive_decl] = STATE(652),
    [sym_fsi_directive_decl] = STATE(652),
    [sym_preproc_line] = STATE(652),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(2766),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [653] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_object_expression] = STATE(10376),
    [sym_with_field_expression] = STATE(10376),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10376),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(653),
    [sym_compiler_directive_decl] = STATE(653),
    [sym_fsi_directive_decl] = STATE(653),
    [sym_preproc_line] = STATE(653),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(2766),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [654] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_object_expression] = STATE(10866),
    [sym_with_field_expression] = STATE(10866),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10866),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(654),
    [sym_compiler_directive_decl] = STATE(654),
    [sym_fsi_directive_decl] = STATE(654),
    [sym_preproc_line] = STATE(654),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(2766),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [655] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_object_expression] = STATE(10213),
    [sym_with_field_expression] = STATE(10213),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10213),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(655),
    [sym_compiler_directive_decl] = STATE(655),
    [sym_fsi_directive_decl] = STATE(655),
    [sym_preproc_line] = STATE(655),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(2766),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [656] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_object_expression] = STATE(10906),
    [sym_with_field_expression] = STATE(10906),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10906),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(656),
    [sym_compiler_directive_decl] = STATE(656),
    [sym_fsi_directive_decl] = STATE(656),
    [sym_preproc_line] = STATE(656),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(2766),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [657] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(657),
    [sym_compiler_directive_decl] = STATE(657),
    [sym_fsi_directive_decl] = STATE(657),
    [sym_preproc_line] = STATE(657),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(657),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2771),
    [anon_sym_do] = ACTIONS(2774),
    [anon_sym_let] = ACTIONS(2777),
    [anon_sym_let_BANG] = ACTIONS(2780),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_null] = ACTIONS(2786),
    [anon_sym_AMP] = ACTIONS(2789),
    [anon_sym_LBRACK] = ACTIONS(2792),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(2798),
    [anon_sym_LT_AT] = ACTIONS(2801),
    [anon_sym_LT_AT_AT] = ACTIONS(2804),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2807),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_return_BANG] = ACTIONS(2810),
    [anon_sym_yield] = ACTIONS(2771),
    [anon_sym_yield_BANG] = ACTIONS(2810),
    [anon_sym_lazy] = ACTIONS(2771),
    [anon_sym_assert] = ACTIONS(2771),
    [anon_sym_upcast] = ACTIONS(2771),
    [anon_sym_downcast] = ACTIONS(2771),
    [anon_sym_for] = ACTIONS(2813),
    [anon_sym_while] = ACTIONS(2816),
    [anon_sym_if] = ACTIONS(2819),
    [anon_sym_fun] = ACTIONS(2822),
    [anon_sym_try] = ACTIONS(2825),
    [anon_sym_match] = ACTIONS(2828),
    [anon_sym_match_BANG] = ACTIONS(2831),
    [anon_sym_function] = ACTIONS(2834),
    [anon_sym_use] = ACTIONS(2837),
    [anon_sym_use_BANG] = ACTIONS(2840),
    [anon_sym_do_BANG] = ACTIONS(2843),
    [anon_sym_begin] = ACTIONS(2846),
    [aux_sym_char_token1] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2852),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_AT_DQUOTE] = ACTIONS(2858),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2864),
    [sym_bool] = ACTIONS(2867),
    [sym_unit] = ACTIONS(2870),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2873),
    [sym_op_identifier] = ACTIONS(2876),
    [anon_sym_PLUS] = ACTIONS(2789),
    [anon_sym_DASH] = ACTIONS(2789),
    [anon_sym_PLUS_DOT] = ACTIONS(2879),
    [anon_sym_DASH_DOT] = ACTIONS(2879),
    [anon_sym_PERCENT] = ACTIONS(2879),
    [anon_sym_AMP_AMP] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2882),
    [aux_sym_prefix_op_token1] = ACTIONS(2885),
    [sym_int] = ACTIONS(2888),
    [sym_xint] = ACTIONS(2891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2894),
    [anon_sym_POUNDendif] = ACTIONS(1392),
    [anon_sym_POUNDelse] = ACTIONS(1392),
    [sym__newline] = ACTIONS(2897),
  },
  [658] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_object_expression] = STATE(11315),
    [sym_with_field_expression] = STATE(11315),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(11315),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(658),
    [sym_compiler_directive_decl] = STATE(658),
    [sym_fsi_directive_decl] = STATE(658),
    [sym_preproc_line] = STATE(658),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(2766),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [659] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_object_expression] = STATE(10224),
    [sym_with_field_expression] = STATE(10224),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10224),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(659),
    [sym_compiler_directive_decl] = STATE(659),
    [sym_fsi_directive_decl] = STATE(659),
    [sym_preproc_line] = STATE(659),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(2766),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [660] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_object_expression] = STATE(10581),
    [sym_with_field_expression] = STATE(10581),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10581),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(660),
    [sym_compiler_directive_decl] = STATE(660),
    [sym_fsi_directive_decl] = STATE(660),
    [sym_preproc_line] = STATE(660),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(2766),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [661] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_object_expression] = STATE(10784),
    [sym_with_field_expression] = STATE(10784),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10784),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(661),
    [sym_compiler_directive_decl] = STATE(661),
    [sym_fsi_directive_decl] = STATE(661),
    [sym_preproc_line] = STATE(661),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(2766),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [662] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_object_expression] = STATE(10306),
    [sym_with_field_expression] = STATE(10306),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10306),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(662),
    [sym_compiler_directive_decl] = STATE(662),
    [sym_fsi_directive_decl] = STATE(662),
    [sym_preproc_line] = STATE(662),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(2766),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [663] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_object_expression] = STATE(10514),
    [sym_with_field_expression] = STATE(10514),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10514),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(663),
    [sym_compiler_directive_decl] = STATE(663),
    [sym_fsi_directive_decl] = STATE(663),
    [sym_preproc_line] = STATE(663),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(2766),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [664] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_object_expression] = STATE(10640),
    [sym_with_field_expression] = STATE(10640),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10640),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(664),
    [sym_compiler_directive_decl] = STATE(664),
    [sym_fsi_directive_decl] = STATE(664),
    [sym_preproc_line] = STATE(664),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(2766),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [665] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_object_expression] = STATE(10698),
    [sym_with_field_expression] = STATE(10698),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10698),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(665),
    [sym_compiler_directive_decl] = STATE(665),
    [sym_fsi_directive_decl] = STATE(665),
    [sym_preproc_line] = STATE(665),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(2766),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [666] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_object_expression] = STATE(10826),
    [sym_with_field_expression] = STATE(10826),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10826),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(666),
    [sym_compiler_directive_decl] = STATE(666),
    [sym_fsi_directive_decl] = STATE(666),
    [sym_preproc_line] = STATE(666),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(2766),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [667] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_object_expression] = STATE(10445),
    [sym_with_field_expression] = STATE(10445),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10445),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(667),
    [sym_compiler_directive_decl] = STATE(667),
    [sym_fsi_directive_decl] = STATE(667),
    [sym_preproc_line] = STATE(667),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(2766),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [668] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_with_field_expression] = STATE(10582),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10582),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(668),
    [sym_compiler_directive_decl] = STATE(668),
    [sym_fsi_directive_decl] = STATE(668),
    [sym_preproc_line] = STATE(668),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [669] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_with_field_expression] = STATE(10307),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10307),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(669),
    [sym_compiler_directive_decl] = STATE(669),
    [sym_fsi_directive_decl] = STATE(669),
    [sym_preproc_line] = STATE(669),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [670] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_with_field_expression] = STATE(10699),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10699),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(670),
    [sym_compiler_directive_decl] = STATE(670),
    [sym_fsi_directive_decl] = STATE(670),
    [sym_preproc_line] = STATE(670),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [671] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_with_field_expression] = STATE(10377),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10377),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(671),
    [sym_compiler_directive_decl] = STATE(671),
    [sym_fsi_directive_decl] = STATE(671),
    [sym_preproc_line] = STATE(671),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [672] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_with_field_expression] = STATE(10867),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10867),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(672),
    [sym_compiler_directive_decl] = STATE(672),
    [sym_fsi_directive_decl] = STATE(672),
    [sym_preproc_line] = STATE(672),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [673] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_with_field_expression] = STATE(10641),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10641),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(673),
    [sym_compiler_directive_decl] = STATE(673),
    [sym_fsi_directive_decl] = STATE(673),
    [sym_preproc_line] = STATE(673),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [674] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_with_field_expression] = STATE(10515),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10515),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(674),
    [sym_compiler_directive_decl] = STATE(674),
    [sym_fsi_directive_decl] = STATE(674),
    [sym_preproc_line] = STATE(674),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [675] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_with_field_expression] = STATE(10827),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10827),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(675),
    [sym_compiler_directive_decl] = STATE(675),
    [sym_fsi_directive_decl] = STATE(675),
    [sym_preproc_line] = STATE(675),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [676] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_with_field_expression] = STATE(10743),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10743),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(676),
    [sym_compiler_directive_decl] = STATE(676),
    [sym_fsi_directive_decl] = STATE(676),
    [sym_preproc_line] = STATE(676),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [677] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_with_field_expression] = STATE(10446),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10446),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(677),
    [sym_compiler_directive_decl] = STATE(677),
    [sym_fsi_directive_decl] = STATE(677),
    [sym_preproc_line] = STATE(677),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [678] = {
    [sym_function_or_value_defn] = STATE(1099),
    [sym__expression] = STATE(252),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1020),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(2924),
    [sym_block_comment] = STATE(678),
    [sym_compiler_directive_decl] = STATE(678),
    [sym_fsi_directive_decl] = STATE(678),
    [sym_preproc_line] = STATE(678),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(678),
    [sym_identifier] = ACTIONS(2900),
    [anon_sym_return] = ACTIONS(2903),
    [anon_sym_do] = ACTIONS(2906),
    [anon_sym_let] = ACTIONS(2777),
    [anon_sym_let_BANG] = ACTIONS(2780),
    [anon_sym_LPAREN] = ACTIONS(2909),
    [anon_sym_null] = ACTIONS(2912),
    [anon_sym_AMP] = ACTIONS(2789),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2918),
    [anon_sym_LBRACE] = ACTIONS(2921),
    [anon_sym_LT_AT] = ACTIONS(2924),
    [anon_sym_LT_AT_AT] = ACTIONS(2927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2930),
    [anon_sym_new] = ACTIONS(2903),
    [anon_sym_return_BANG] = ACTIONS(2933),
    [anon_sym_yield] = ACTIONS(2903),
    [anon_sym_yield_BANG] = ACTIONS(2933),
    [anon_sym_lazy] = ACTIONS(2903),
    [anon_sym_assert] = ACTIONS(2903),
    [anon_sym_upcast] = ACTIONS(2903),
    [anon_sym_downcast] = ACTIONS(2903),
    [anon_sym_for] = ACTIONS(2936),
    [anon_sym_while] = ACTIONS(2939),
    [anon_sym_if] = ACTIONS(2819),
    [anon_sym_fun] = ACTIONS(2942),
    [anon_sym_try] = ACTIONS(2945),
    [anon_sym_match] = ACTIONS(2948),
    [anon_sym_match_BANG] = ACTIONS(2951),
    [anon_sym_function] = ACTIONS(2954),
    [anon_sym_use] = ACTIONS(2957),
    [anon_sym_use_BANG] = ACTIONS(2960),
    [anon_sym_do_BANG] = ACTIONS(2963),
    [anon_sym_begin] = ACTIONS(2966),
    [aux_sym_char_token1] = ACTIONS(2969),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2972),
    [anon_sym_DQUOTE] = ACTIONS(2975),
    [anon_sym_AT_DQUOTE] = ACTIONS(2978),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2981),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2984),
    [sym_bool] = ACTIONS(2987),
    [sym_unit] = ACTIONS(2990),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2993),
    [sym_op_identifier] = ACTIONS(2996),
    [anon_sym_PLUS] = ACTIONS(2789),
    [anon_sym_DASH] = ACTIONS(2789),
    [anon_sym_PLUS_DOT] = ACTIONS(2879),
    [anon_sym_DASH_DOT] = ACTIONS(2879),
    [anon_sym_PERCENT] = ACTIONS(2879),
    [anon_sym_AMP_AMP] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2882),
    [aux_sym_prefix_op_token1] = ACTIONS(2885),
    [sym_int] = ACTIONS(2999),
    [sym_xint] = ACTIONS(3002),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3005),
    [anon_sym_POUNDendif] = ACTIONS(1392),
    [sym__newline] = ACTIONS(3008),
  },
  [679] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_with_field_expression] = STATE(10222),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10222),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(679),
    [sym_compiler_directive_decl] = STATE(679),
    [sym_fsi_directive_decl] = STATE(679),
    [sym_preproc_line] = STATE(679),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [680] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_with_field_expression] = STATE(10785),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10785),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(680),
    [sym_compiler_directive_decl] = STATE(680),
    [sym_fsi_directive_decl] = STATE(680),
    [sym_preproc_line] = STATE(680),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [681] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_with_field_expression] = STATE(11306),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(11306),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(681),
    [sym_compiler_directive_decl] = STATE(681),
    [sym_fsi_directive_decl] = STATE(681),
    [sym_preproc_line] = STATE(681),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [682] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_with_field_expression] = STATE(10214),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10214),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(682),
    [sym_compiler_directive_decl] = STATE(682),
    [sym_fsi_directive_decl] = STATE(682),
    [sym_preproc_line] = STATE(682),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [683] = {
    [sym_function_or_value_defn] = STATE(1099),
    [sym__expression] = STATE(252),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1020),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(2924),
    [sym_block_comment] = STATE(683),
    [sym_compiler_directive_decl] = STATE(683),
    [sym_fsi_directive_decl] = STATE(683),
    [sym_preproc_line] = STATE(683),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(686),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(2638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(1492),
    [anon_sym_return_BANG] = ACTIONS(1496),
    [anon_sym_yield] = ACTIONS(1492),
    [anon_sym_yield_BANG] = ACTIONS(1496),
    [anon_sym_lazy] = ACTIONS(1492),
    [anon_sym_assert] = ACTIONS(1492),
    [anon_sym_upcast] = ACTIONS(1492),
    [anon_sym_downcast] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_use] = ACTIONS(1500),
    [anon_sym_use_BANG] = ACTIONS(1502),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(2642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1504),
    [sym_xint] = ACTIONS(1506),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
    [anon_sym_POUNDendif] = ACTIONS(3011),
    [sym__newline] = ACTIONS(3013),
  },
  [684] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_with_field_expression] = STATE(10278),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10278),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(684),
    [sym_compiler_directive_decl] = STATE(684),
    [sym_fsi_directive_decl] = STATE(684),
    [sym_preproc_line] = STATE(684),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [685] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_with_field_expression] = STATE(10907),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_field_initializer] = STATE(9004),
    [sym_field_initializers] = STATE(10907),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2977),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(685),
    [sym_compiler_directive_decl] = STATE(685),
    [sym_fsi_directive_decl] = STATE(685),
    [sym_preproc_line] = STATE(685),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [686] = {
    [sym_function_or_value_defn] = STATE(1099),
    [sym__expression] = STATE(252),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1020),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(2924),
    [sym_block_comment] = STATE(686),
    [sym_compiler_directive_decl] = STATE(686),
    [sym_fsi_directive_decl] = STATE(686),
    [sym_preproc_line] = STATE(686),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(678),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(2638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(1492),
    [anon_sym_return_BANG] = ACTIONS(1496),
    [anon_sym_yield] = ACTIONS(1492),
    [anon_sym_yield_BANG] = ACTIONS(1496),
    [anon_sym_lazy] = ACTIONS(1492),
    [anon_sym_assert] = ACTIONS(1492),
    [anon_sym_upcast] = ACTIONS(1492),
    [anon_sym_downcast] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_use] = ACTIONS(1500),
    [anon_sym_use_BANG] = ACTIONS(1502),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(2642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1504),
    [sym_xint] = ACTIONS(1506),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
    [anon_sym_POUNDendif] = ACTIONS(3015),
    [sym__newline] = ACTIONS(3013),
  },
  [687] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(214),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(687),
    [sym_compiler_directive_decl] = STATE(687),
    [sym_fsi_directive_decl] = STATE(687),
    [sym_preproc_line] = STATE(687),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [anon_sym_POUNDendif] = ACTIONS(2690),
    [anon_sym_POUNDelse] = ACTIONS(2690),
  },
  [688] = {
    [sym_function_or_value_defn] = STATE(783),
    [sym__expression] = STATE(359),
    [sym_literal_expression] = STATE(3553),
    [sym_long_identifier_or_op] = STATE(3553),
    [sym_tuple_expression] = STATE(3553),
    [sym_brace_expression] = STATE(3553),
    [sym_anon_record_expression] = STATE(3553),
    [sym_prefixed_expression] = STATE(3553),
    [sym_typecast_expression] = STATE(3553),
    [sym_for_expression] = STATE(3553),
    [sym_while_expression] = STATE(3553),
    [sym__if_branch] = STATE(10567),
    [sym_if_expression] = STATE(3553),
    [sym_fun_expression] = STATE(3553),
    [sym_try_expression] = STATE(3553),
    [sym_match_expression] = STATE(3553),
    [sym_function_expression] = STATE(3553),
    [sym_mutate_expression] = STATE(3553),
    [sym_index_expression] = STATE(3553),
    [sym_typed_expression] = STATE(3553),
    [sym_declaration_expression] = STATE(3553),
    [sym_do_expression] = STATE(3553),
    [sym_list_expression] = STATE(3553),
    [sym_array_expression] = STATE(3553),
    [sym_begin_end_expression] = STATE(3553),
    [sym_paren_expression] = STATE(3553),
    [sym__high_prec_app] = STATE(3532),
    [sym__low_prec_app] = STATE(3532),
    [sym_application_expression] = STATE(3553),
    [sym_dot_expression] = STATE(3553),
    [sym_infix_expression] = STATE(3553),
    [sym_ce_expression] = STATE(3553),
    [sym_sequential_expression] = STATE(3553),
    [sym_char] = STATE(3265),
    [sym_format_string] = STATE(3261),
    [sym__string_literal] = STATE(3261),
    [sym_string] = STATE(3265),
    [sym_verbatim_string] = STATE(3265),
    [sym_bytearray] = STATE(3265),
    [sym_verbatim_bytearray] = STATE(3265),
    [sym_format_triple_quoted_string] = STATE(3260),
    [sym_triple_quoted_string] = STATE(3265),
    [sym_const] = STATE(3553),
    [sym_long_identifier] = STATE(3203),
    [sym_active_pattern] = STATE(3576),
    [sym__identifier_or_op] = STATE(3362),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1076),
    [sym_sbyte] = STATE(3265),
    [sym_byte] = STATE(3265),
    [sym_int16] = STATE(3265),
    [sym_uint16] = STATE(3265),
    [sym_int32] = STATE(3265),
    [sym_uint32] = STATE(3265),
    [sym_nativeint] = STATE(3265),
    [sym_unativeint] = STATE(3265),
    [sym_int64] = STATE(3265),
    [sym_uint64] = STATE(3265),
    [sym_ieee32] = STATE(3265),
    [sym_ieee64] = STATE(3265),
    [sym_bignum] = STATE(3265),
    [sym_decimal] = STATE(3265),
    [sym_float] = STATE(2797),
    [sym_block_comment] = STATE(688),
    [sym_compiler_directive_decl] = STATE(688),
    [sym_fsi_directive_decl] = STATE(688),
    [sym_preproc_line] = STATE(688),
    [sym_preproc_if_in_expression] = STATE(3553),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1632),
    [anon_sym_return] = ACTIONS(1636),
    [anon_sym_do] = ACTIONS(1638),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1640),
    [anon_sym_COMMA] = ACTIONS(3017),
    [anon_sym_null] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1646),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_LT_AT] = ACTIONS(1652),
    [anon_sym_LT_AT_AT] = ACTIONS(3021),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1658),
    [anon_sym_new] = ACTIONS(1636),
    [anon_sym_return_BANG] = ACTIONS(1660),
    [anon_sym_yield] = ACTIONS(1636),
    [anon_sym_yield_BANG] = ACTIONS(1660),
    [anon_sym_lazy] = ACTIONS(1636),
    [anon_sym_assert] = ACTIONS(1636),
    [anon_sym_upcast] = ACTIONS(1636),
    [anon_sym_downcast] = ACTIONS(1636),
    [anon_sym_for] = ACTIONS(1664),
    [anon_sym_while] = ACTIONS(1666),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1668),
    [anon_sym_try] = ACTIONS(1670),
    [anon_sym_match] = ACTIONS(1672),
    [anon_sym_match_BANG] = ACTIONS(1674),
    [anon_sym_function] = ACTIONS(1676),
    [anon_sym_GT] = ACTIONS(3017),
    [anon_sym_use] = ACTIONS(1684),
    [anon_sym_use_BANG] = ACTIONS(1686),
    [anon_sym_do_BANG] = ACTIONS(1688),
    [anon_sym_begin] = ACTIONS(1690),
    [aux_sym_char_token1] = ACTIONS(1694),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1696),
    [anon_sym_DQUOTE] = ACTIONS(1698),
    [anon_sym_AT_DQUOTE] = ACTIONS(1700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1704),
    [sym_bool] = ACTIONS(1706),
    [sym_unit] = ACTIONS(3023),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1710),
    [sym_op_identifier] = ACTIONS(3025),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1714),
    [sym_xint] = ACTIONS(1716),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1718),
  },
  [689] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(211),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(689),
    [sym_compiler_directive_decl] = STATE(689),
    [sym_fsi_directive_decl] = STATE(689),
    [sym_preproc_line] = STATE(689),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__newline] = ACTIONS(2690),
    [sym__dedent] = ACTIONS(2690),
  },
  [690] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(277),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(690),
    [sym_compiler_directive_decl] = STATE(690),
    [sym_fsi_directive_decl] = STATE(690),
    [sym_preproc_line] = STATE(690),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_COMMA] = ACTIONS(3027),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__dedent] = ACTIONS(3027),
  },
  [691] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(292),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(691),
    [sym_compiler_directive_decl] = STATE(691),
    [sym_fsi_directive_decl] = STATE(691),
    [sym_preproc_line] = STATE(691),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(3027),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_RBRACK] = ACTIONS(3027),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [692] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(442),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_range_expression] = STATE(10809),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1151),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(692),
    [sym_compiler_directive_decl] = STATE(692),
    [sym_fsi_directive_decl] = STATE(692),
    [sym_preproc_line] = STATE(692),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_begin] = ACTIONS(1782),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
  },
  [693] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(122),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(693),
    [sym_compiler_directive_decl] = STATE(693),
    [sym_fsi_directive_decl] = STATE(693),
    [sym_preproc_line] = STATE(693),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(3037),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [694] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(146),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(694),
    [sym_compiler_directive_decl] = STATE(694),
    [sym_fsi_directive_decl] = STATE(694),
    [sym_preproc_line] = STATE(694),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__tuple_marker] = ACTIONS(3039),
  },
  [695] = {
    [sym_function_or_value_defn] = STATE(845),
    [sym__expression] = STATE(155),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(776),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(695),
    [sym_compiler_directive_decl] = STATE(695),
    [sym_fsi_directive_decl] = STATE(695),
    [sym_preproc_line] = STATE(695),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1203),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1203),
    [anon_sym_return_BANG] = ACTIONS(1207),
    [anon_sym_yield] = ACTIONS(1203),
    [anon_sym_yield_BANG] = ACTIONS(1207),
    [anon_sym_lazy] = ACTIONS(1203),
    [anon_sym_assert] = ACTIONS(1203),
    [anon_sym_upcast] = ACTIONS(1203),
    [anon_sym_downcast] = ACTIONS(1203),
    [anon_sym_for] = ACTIONS(1209),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1213),
    [anon_sym_use_BANG] = ACTIONS(1215),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1219),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__tuple_marker] = ACTIONS(3041),
  },
  [696] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(122),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(696),
    [sym_compiler_directive_decl] = STATE(696),
    [sym_fsi_directive_decl] = STATE(696),
    [sym_preproc_line] = STATE(696),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(3043),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [697] = {
    [sym_function_or_value_defn] = STATE(783),
    [sym__expression] = STATE(320),
    [sym_literal_expression] = STATE(3553),
    [sym_long_identifier_or_op] = STATE(3553),
    [sym_tuple_expression] = STATE(3553),
    [sym_brace_expression] = STATE(3553),
    [sym_anon_record_expression] = STATE(3553),
    [sym_prefixed_expression] = STATE(3553),
    [sym_typecast_expression] = STATE(3553),
    [sym_for_expression] = STATE(3553),
    [sym_while_expression] = STATE(3553),
    [sym__if_branch] = STATE(10567),
    [sym_if_expression] = STATE(3553),
    [sym_fun_expression] = STATE(3553),
    [sym_try_expression] = STATE(3553),
    [sym_match_expression] = STATE(3553),
    [sym_function_expression] = STATE(3553),
    [sym_mutate_expression] = STATE(3553),
    [sym_index_expression] = STATE(3553),
    [sym_typed_expression] = STATE(3553),
    [sym_declaration_expression] = STATE(3553),
    [sym_do_expression] = STATE(3553),
    [sym_list_expression] = STATE(3553),
    [sym_array_expression] = STATE(3553),
    [sym_begin_end_expression] = STATE(3553),
    [sym_paren_expression] = STATE(3553),
    [sym__high_prec_app] = STATE(3532),
    [sym__low_prec_app] = STATE(3532),
    [sym_application_expression] = STATE(3553),
    [sym_dot_expression] = STATE(3553),
    [sym_infix_expression] = STATE(3553),
    [sym_ce_expression] = STATE(3553),
    [sym_sequential_expression] = STATE(3553),
    [sym_char] = STATE(3265),
    [sym_format_string] = STATE(3261),
    [sym__string_literal] = STATE(3261),
    [sym_string] = STATE(3265),
    [sym_verbatim_string] = STATE(3265),
    [sym_bytearray] = STATE(3265),
    [sym_verbatim_bytearray] = STATE(3265),
    [sym_format_triple_quoted_string] = STATE(3260),
    [sym_triple_quoted_string] = STATE(3265),
    [sym_const] = STATE(3553),
    [sym_long_identifier] = STATE(3203),
    [sym_active_pattern] = STATE(3576),
    [sym__identifier_or_op] = STATE(3362),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1076),
    [sym_sbyte] = STATE(3265),
    [sym_byte] = STATE(3265),
    [sym_int16] = STATE(3265),
    [sym_uint16] = STATE(3265),
    [sym_int32] = STATE(3265),
    [sym_uint32] = STATE(3265),
    [sym_nativeint] = STATE(3265),
    [sym_unativeint] = STATE(3265),
    [sym_int64] = STATE(3265),
    [sym_uint64] = STATE(3265),
    [sym_ieee32] = STATE(3265),
    [sym_ieee64] = STATE(3265),
    [sym_bignum] = STATE(3265),
    [sym_decimal] = STATE(3265),
    [sym_float] = STATE(2797),
    [sym_block_comment] = STATE(697),
    [sym_compiler_directive_decl] = STATE(697),
    [sym_fsi_directive_decl] = STATE(697),
    [sym_preproc_line] = STATE(697),
    [sym_preproc_if_in_expression] = STATE(3553),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1632),
    [anon_sym_return] = ACTIONS(1636),
    [anon_sym_do] = ACTIONS(1638),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1640),
    [anon_sym_null] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1646),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_LT_AT] = ACTIONS(1652),
    [anon_sym_LT_AT_AT] = ACTIONS(3021),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1658),
    [anon_sym_new] = ACTIONS(1636),
    [anon_sym_return_BANG] = ACTIONS(1660),
    [anon_sym_yield] = ACTIONS(1636),
    [anon_sym_yield_BANG] = ACTIONS(1660),
    [anon_sym_lazy] = ACTIONS(1636),
    [anon_sym_assert] = ACTIONS(1636),
    [anon_sym_upcast] = ACTIONS(1636),
    [anon_sym_downcast] = ACTIONS(1636),
    [anon_sym_for] = ACTIONS(1664),
    [anon_sym_while] = ACTIONS(1666),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1668),
    [anon_sym_try] = ACTIONS(1670),
    [anon_sym_match] = ACTIONS(1672),
    [anon_sym_match_BANG] = ACTIONS(1674),
    [anon_sym_function] = ACTIONS(1676),
    [anon_sym_use] = ACTIONS(1684),
    [anon_sym_use_BANG] = ACTIONS(1686),
    [anon_sym_do_BANG] = ACTIONS(1688),
    [anon_sym_begin] = ACTIONS(1690),
    [aux_sym_char_token1] = ACTIONS(1694),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1696),
    [anon_sym_DQUOTE] = ACTIONS(1698),
    [anon_sym_AT_DQUOTE] = ACTIONS(1700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1704),
    [sym_bool] = ACTIONS(1706),
    [sym_unit] = ACTIONS(3023),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1710),
    [sym_op_identifier] = ACTIONS(3025),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1714),
    [sym_xint] = ACTIONS(1716),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1718),
    [sym__tuple_marker] = ACTIONS(3045),
  },
  [698] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(122),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(698),
    [sym_compiler_directive_decl] = STATE(698),
    [sym_fsi_directive_decl] = STATE(698),
    [sym_preproc_line] = STATE(698),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(3047),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [699] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(280),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_range_expression] = STATE(10234),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1151),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(699),
    [sym_compiler_directive_decl] = STATE(699),
    [sym_fsi_directive_decl] = STATE(699),
    [sym_preproc_line] = STATE(699),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_begin] = ACTIONS(1782),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
  },
  [700] = {
    [sym_function_or_value_defn] = STATE(972),
    [sym__expression] = STATE(191),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(978),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(700),
    [sym_compiler_directive_decl] = STATE(700),
    [sym_fsi_directive_decl] = STATE(700),
    [sym_preproc_line] = STATE(700),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1302),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1302),
    [anon_sym_return_BANG] = ACTIONS(1326),
    [anon_sym_yield] = ACTIONS(1302),
    [anon_sym_yield_BANG] = ACTIONS(1326),
    [anon_sym_lazy] = ACTIONS(1302),
    [anon_sym_assert] = ACTIONS(1302),
    [anon_sym_upcast] = ACTIONS(1302),
    [anon_sym_downcast] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1330),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1352),
    [anon_sym_use_BANG] = ACTIONS(1354),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1384),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__tuple_marker] = ACTIONS(3057),
  },
  [701] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(122),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(701),
    [sym_compiler_directive_decl] = STATE(701),
    [sym_fsi_directive_decl] = STATE(701),
    [sym_preproc_line] = STATE(701),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(3059),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [702] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(482),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_range_expression] = STATE(10917),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1151),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(702),
    [sym_compiler_directive_decl] = STATE(702),
    [sym_fsi_directive_decl] = STATE(702),
    [sym_preproc_line] = STATE(702),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_begin] = ACTIONS(1782),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
  },
  [703] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(262),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_range_expression] = STATE(10324),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1151),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(703),
    [sym_compiler_directive_decl] = STATE(703),
    [sym_fsi_directive_decl] = STATE(703),
    [sym_preproc_line] = STATE(703),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_begin] = ACTIONS(1782),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
  },
  [704] = {
    [sym_function_or_value_defn] = STATE(866),
    [sym__expression] = STATE(100),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1178),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(704),
    [sym_compiler_directive_decl] = STATE(704),
    [sym_fsi_directive_decl] = STATE(704),
    [sym_preproc_line] = STATE(704),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(857),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(53),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(857),
    [anon_sym_return_BANG] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(857),
    [anon_sym_yield_BANG] = ACTIONS(869),
    [anon_sym_lazy] = ACTIONS(857),
    [anon_sym_assert] = ACTIONS(857),
    [anon_sym_upcast] = ACTIONS(857),
    [anon_sym_downcast] = ACTIONS(857),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(879),
    [anon_sym_use_BANG] = ACTIONS(881),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(99),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(889),
    [sym_xint] = ACTIONS(891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
    [sym__tuple_marker] = ACTIONS(3061),
  },
  [705] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(501),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1045),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(705),
    [sym_compiler_directive_decl] = STATE(705),
    [sym_fsi_directive_decl] = STATE(705),
    [sym_preproc_line] = STATE(705),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
    [sym__tuple_marker] = ACTIONS(3063),
  },
  [706] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(122),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(706),
    [sym_compiler_directive_decl] = STATE(706),
    [sym_fsi_directive_decl] = STATE(706),
    [sym_preproc_line] = STATE(706),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(3065),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [707] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(286),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1022),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(707),
    [sym_compiler_directive_decl] = STATE(707),
    [sym_fsi_directive_decl] = STATE(707),
    [sym_preproc_line] = STATE(707),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(3069),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(3071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
    [sym__tuple_marker] = ACTIONS(3075),
  },
  [708] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(337),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_range_expression] = STATE(10463),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1151),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(708),
    [sym_compiler_directive_decl] = STATE(708),
    [sym_fsi_directive_decl] = STATE(708),
    [sym_preproc_line] = STATE(708),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_begin] = ACTIONS(1782),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
  },
  [709] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(318),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1151),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(709),
    [sym_compiler_directive_decl] = STATE(709),
    [sym_fsi_directive_decl] = STATE(709),
    [sym_preproc_line] = STATE(709),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_begin] = ACTIONS(1782),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
    [sym__tuple_marker] = ACTIONS(3077),
  },
  [710] = {
    [sym_function_or_value_defn] = STATE(1122),
    [sym__expression] = STATE(53),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(938),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(1598),
    [sym_block_comment] = STATE(710),
    [sym_compiler_directive_decl] = STATE(710),
    [sym_fsi_directive_decl] = STATE(710),
    [sym_preproc_line] = STATE(710),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_return] = ACTIONS(475),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(3081),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(475),
    [anon_sym_return_BANG] = ACTIONS(497),
    [anon_sym_yield] = ACTIONS(475),
    [anon_sym_yield_BANG] = ACTIONS(497),
    [anon_sym_lazy] = ACTIONS(475),
    [anon_sym_assert] = ACTIONS(475),
    [anon_sym_upcast] = ACTIONS(475),
    [anon_sym_downcast] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_use] = ACTIONS(521),
    [anon_sym_use_BANG] = ACTIONS(523),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(3083),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(3085),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(551),
    [sym_xint] = ACTIONS(553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
    [sym__tuple_marker] = ACTIONS(3087),
  },
  [711] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(485),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_range_expression] = STATE(10877),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1151),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(711),
    [sym_compiler_directive_decl] = STATE(711),
    [sym_fsi_directive_decl] = STATE(711),
    [sym_preproc_line] = STATE(711),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_begin] = ACTIONS(1782),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
  },
  [712] = {
    [sym_function_or_value_defn] = STATE(760),
    [sym__expression] = STATE(16),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(956),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(712),
    [sym_compiler_directive_decl] = STATE(712),
    [sym_fsi_directive_decl] = STATE(712),
    [sym_preproc_line] = STATE(712),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_return] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(269),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(269),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(269),
    [anon_sym_assert] = ACTIONS(269),
    [anon_sym_upcast] = ACTIONS(269),
    [anon_sym_downcast] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(277),
    [anon_sym_use_BANG] = ACTIONS(279),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(281),
    [sym_xint] = ACTIONS(283),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
    [sym__tuple_marker] = ACTIONS(3097),
  },
  [713] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(122),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(713),
    [sym_compiler_directive_decl] = STATE(713),
    [sym_fsi_directive_decl] = STATE(713),
    [sym_preproc_line] = STATE(713),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(3099),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [714] = {
    [sym_function_or_value_defn] = STATE(972),
    [sym__expression] = STATE(212),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_range_expression] = STATE(9882),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(978),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(714),
    [sym_compiler_directive_decl] = STATE(714),
    [sym_fsi_directive_decl] = STATE(714),
    [sym_preproc_line] = STATE(714),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1302),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1302),
    [anon_sym_return_BANG] = ACTIONS(1326),
    [anon_sym_yield] = ACTIONS(1302),
    [anon_sym_yield_BANG] = ACTIONS(1326),
    [anon_sym_lazy] = ACTIONS(1302),
    [anon_sym_assert] = ACTIONS(1302),
    [anon_sym_upcast] = ACTIONS(1302),
    [anon_sym_downcast] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1330),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1352),
    [anon_sym_use_BANG] = ACTIONS(1354),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1384),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [715] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(261),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_range_expression] = STATE(10234),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1151),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(715),
    [sym_compiler_directive_decl] = STATE(715),
    [sym_fsi_directive_decl] = STATE(715),
    [sym_preproc_line] = STATE(715),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_begin] = ACTIONS(1782),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
  },
  [716] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(355),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_range_expression] = STATE(10532),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1151),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(716),
    [sym_compiler_directive_decl] = STATE(716),
    [sym_fsi_directive_decl] = STATE(716),
    [sym_preproc_line] = STATE(716),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_begin] = ACTIONS(1782),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
  },
  [717] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(489),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_range_expression] = STATE(10837),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1151),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(717),
    [sym_compiler_directive_decl] = STATE(717),
    [sym_fsi_directive_decl] = STATE(717),
    [sym_preproc_line] = STATE(717),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_begin] = ACTIONS(1782),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
  },
  [718] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(122),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(718),
    [sym_compiler_directive_decl] = STATE(718),
    [sym_fsi_directive_decl] = STATE(718),
    [sym_preproc_line] = STATE(718),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(3101),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [719] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(122),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(719),
    [sym_compiler_directive_decl] = STATE(719),
    [sym_fsi_directive_decl] = STATE(719),
    [sym_preproc_line] = STATE(719),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(3103),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [720] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(421),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_range_expression] = STATE(10709),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1151),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(720),
    [sym_compiler_directive_decl] = STATE(720),
    [sym_fsi_directive_decl] = STATE(720),
    [sym_preproc_line] = STATE(720),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_begin] = ACTIONS(1782),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
  },
  [721] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(204),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(721),
    [sym_compiler_directive_decl] = STATE(721),
    [sym_fsi_directive_decl] = STATE(721),
    [sym_preproc_line] = STATE(721),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [sym__tuple_marker] = ACTIONS(3105),
  },
  [722] = {
    [sym_function_or_value_defn] = STATE(850),
    [sym__expression] = STATE(10),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(949),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(722),
    [sym_compiler_directive_decl] = STATE(722),
    [sym_fsi_directive_decl] = STATE(722),
    [sym_preproc_line] = STATE(722),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(129),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(129),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(129),
    [anon_sym_assert] = ACTIONS(129),
    [anon_sym_upcast] = ACTIONS(129),
    [anon_sym_downcast] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(215),
    [sym_xint] = ACTIONS(217),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
    [sym__tuple_marker] = ACTIONS(3107),
  },
  [723] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(122),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(723),
    [sym_compiler_directive_decl] = STATE(723),
    [sym_fsi_directive_decl] = STATE(723),
    [sym_preproc_line] = STATE(723),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(3109),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [724] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(373),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_range_expression] = STATE(10596),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1151),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(724),
    [sym_compiler_directive_decl] = STATE(724),
    [sym_fsi_directive_decl] = STATE(724),
    [sym_preproc_line] = STATE(724),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_begin] = ACTIONS(1782),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
  },
  [725] = {
    [sym_function_or_value_defn] = STATE(953),
    [sym__expression] = STATE(26),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(942),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(1568),
    [sym_block_comment] = STATE(725),
    [sym_compiler_directive_decl] = STATE(725),
    [sym_fsi_directive_decl] = STATE(725),
    [sym_preproc_line] = STATE(725),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(291),
    [anon_sym_return_BANG] = ACTIONS(315),
    [anon_sym_yield] = ACTIONS(291),
    [anon_sym_yield_BANG] = ACTIONS(315),
    [anon_sym_lazy] = ACTIONS(291),
    [anon_sym_assert] = ACTIONS(291),
    [anon_sym_upcast] = ACTIONS(291),
    [anon_sym_downcast] = ACTIONS(291),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(339),
    [anon_sym_use_BANG] = ACTIONS(341),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(369),
    [sym_xint] = ACTIONS(371),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
    [sym__tuple_marker] = ACTIONS(3111),
  },
  [726] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(477),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_range_expression] = STATE(10655),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1151),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(726),
    [sym_compiler_directive_decl] = STATE(726),
    [sym_fsi_directive_decl] = STATE(726),
    [sym_preproc_line] = STATE(726),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_begin] = ACTIONS(1782),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
  },
  [727] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(278),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_range_expression] = STATE(10215),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1151),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(727),
    [sym_compiler_directive_decl] = STATE(727),
    [sym_fsi_directive_decl] = STATE(727),
    [sym_preproc_line] = STATE(727),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_begin] = ACTIONS(1782),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
  },
  [728] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(299),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_range_expression] = STATE(10324),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1151),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(728),
    [sym_compiler_directive_decl] = STATE(728),
    [sym_fsi_directive_decl] = STATE(728),
    [sym_preproc_line] = STATE(728),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_begin] = ACTIONS(1782),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
  },
  [729] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(122),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(729),
    [sym_compiler_directive_decl] = STATE(729),
    [sym_fsi_directive_decl] = STATE(729),
    [sym_preproc_line] = STATE(729),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(3113),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [730] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(122),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(730),
    [sym_compiler_directive_decl] = STATE(730),
    [sym_fsi_directive_decl] = STATE(730),
    [sym_preproc_line] = STATE(730),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(3115),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [731] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(456),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_range_expression] = STATE(10753),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1151),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(731),
    [sym_compiler_directive_decl] = STATE(731),
    [sym_fsi_directive_decl] = STATE(731),
    [sym_preproc_line] = STATE(731),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_begin] = ACTIONS(1782),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
  },
  [732] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(305),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(890),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(732),
    [sym_compiler_directive_decl] = STATE(732),
    [sym_fsi_directive_decl] = STATE(732),
    [sym_preproc_line] = STATE(732),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
    [sym__tuple_marker] = ACTIONS(3125),
  },
  [733] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(122),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(733),
    [sym_compiler_directive_decl] = STATE(733),
    [sym_fsi_directive_decl] = STATE(733),
    [sym_preproc_line] = STATE(733),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(3127),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [734] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(107),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(734),
    [sym_compiler_directive_decl] = STATE(734),
    [sym_fsi_directive_decl] = STATE(734),
    [sym_preproc_line] = STATE(734),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__tuple_marker] = ACTIONS(3129),
  },
  [735] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(122),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(735),
    [sym_compiler_directive_decl] = STATE(735),
    [sym_fsi_directive_decl] = STATE(735),
    [sym_preproc_line] = STATE(735),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(3131),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [736] = {
    [sym_function_or_value_defn] = STATE(1084),
    [sym__expression] = STATE(64),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(936),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(1592),
    [sym_block_comment] = STATE(736),
    [sym_compiler_directive_decl] = STATE(736),
    [sym_fsi_directive_decl] = STATE(736),
    [sym_preproc_line] = STATE(736),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(651),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(2638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(651),
    [anon_sym_return_BANG] = ACTIONS(673),
    [anon_sym_yield] = ACTIONS(651),
    [anon_sym_yield_BANG] = ACTIONS(673),
    [anon_sym_lazy] = ACTIONS(651),
    [anon_sym_assert] = ACTIONS(651),
    [anon_sym_upcast] = ACTIONS(651),
    [anon_sym_downcast] = ACTIONS(651),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_use] = ACTIONS(697),
    [anon_sym_use_BANG] = ACTIONS(699),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(2642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(727),
    [sym_xint] = ACTIONS(729),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
    [sym__tuple_marker] = ACTIONS(3133),
  },
  [737] = {
    [sym_function_or_value_defn] = STATE(972),
    [sym__expression] = STATE(158),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_range_expression] = STATE(9882),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(978),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(737),
    [sym_compiler_directive_decl] = STATE(737),
    [sym_fsi_directive_decl] = STATE(737),
    [sym_preproc_line] = STATE(737),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1302),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1302),
    [anon_sym_return_BANG] = ACTIONS(1326),
    [anon_sym_yield] = ACTIONS(1302),
    [anon_sym_yield_BANG] = ACTIONS(1326),
    [anon_sym_lazy] = ACTIONS(1302),
    [anon_sym_assert] = ACTIONS(1302),
    [anon_sym_upcast] = ACTIONS(1302),
    [anon_sym_downcast] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1330),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1352),
    [anon_sym_use_BANG] = ACTIONS(1354),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1384),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [738] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(180),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(887),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(738),
    [sym_compiler_directive_decl] = STATE(738),
    [sym_fsi_directive_decl] = STATE(738),
    [sym_preproc_line] = STATE(738),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
    [sym__tuple_marker] = ACTIONS(3135),
  },
  [739] = {
    [sym_function_or_value_defn] = STATE(1099),
    [sym__expression] = STATE(395),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1020),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(2924),
    [sym_block_comment] = STATE(739),
    [sym_compiler_directive_decl] = STATE(739),
    [sym_fsi_directive_decl] = STATE(739),
    [sym_preproc_line] = STATE(739),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(2638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(1492),
    [anon_sym_return_BANG] = ACTIONS(1496),
    [anon_sym_yield] = ACTIONS(1492),
    [anon_sym_yield_BANG] = ACTIONS(1496),
    [anon_sym_lazy] = ACTIONS(1492),
    [anon_sym_assert] = ACTIONS(1492),
    [anon_sym_upcast] = ACTIONS(1492),
    [anon_sym_downcast] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_use] = ACTIONS(1500),
    [anon_sym_use_BANG] = ACTIONS(1502),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(2642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1504),
    [sym_xint] = ACTIONS(1506),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
    [sym__tuple_marker] = ACTIONS(3137),
  },
  [740] = {
    [sym_function_or_value_defn] = STATE(1074),
    [sym__expression] = STATE(143),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(944),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(2718),
    [sym_block_comment] = STATE(740),
    [sym_compiler_directive_decl] = STATE(740),
    [sym_fsi_directive_decl] = STATE(740),
    [sym_preproc_line] = STATE(740),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_return] = ACTIONS(1252),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(3081),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_return_BANG] = ACTIONS(1256),
    [anon_sym_yield] = ACTIONS(1252),
    [anon_sym_yield_BANG] = ACTIONS(1256),
    [anon_sym_lazy] = ACTIONS(1252),
    [anon_sym_assert] = ACTIONS(1252),
    [anon_sym_upcast] = ACTIONS(1252),
    [anon_sym_downcast] = ACTIONS(1252),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_use] = ACTIONS(1260),
    [anon_sym_use_BANG] = ACTIONS(1262),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(3083),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(3085),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1264),
    [sym_xint] = ACTIONS(1266),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
    [sym__tuple_marker] = ACTIONS(3139),
  },
  [741] = {
    [sym_function_or_value_defn] = STATE(964),
    [sym__expression] = STATE(117),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(793),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(741),
    [sym_compiler_directive_decl] = STATE(741),
    [sym_fsi_directive_decl] = STATE(741),
    [sym_preproc_line] = STATE(741),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(53),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(29),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_upcast] = ACTIONS(29),
    [anon_sym_downcast] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(99),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(111),
    [sym_xint] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
    [sym__tuple_marker] = ACTIONS(3141),
  },
  [742] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(122),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(742),
    [sym_compiler_directive_decl] = STATE(742),
    [sym_fsi_directive_decl] = STATE(742),
    [sym_preproc_line] = STATE(742),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(3143),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [743] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(312),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_range_expression] = STATE(10394),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1151),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(743),
    [sym_compiler_directive_decl] = STATE(743),
    [sym_fsi_directive_decl] = STATE(743),
    [sym_preproc_line] = STATE(743),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_begin] = ACTIONS(1782),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
  },
  [744] = {
    [sym_function_or_value_defn] = STATE(1054),
    [sym__expression] = STATE(66),
    [sym_literal_expression] = STATE(2069),
    [sym_long_identifier_or_op] = STATE(2069),
    [sym_tuple_expression] = STATE(2069),
    [sym_brace_expression] = STATE(2069),
    [sym_anon_record_expression] = STATE(2069),
    [sym_prefixed_expression] = STATE(2069),
    [sym_typecast_expression] = STATE(2069),
    [sym_for_expression] = STATE(2069),
    [sym_while_expression] = STATE(2069),
    [sym__if_branch] = STATE(10893),
    [sym_if_expression] = STATE(2069),
    [sym_fun_expression] = STATE(2069),
    [sym_try_expression] = STATE(2069),
    [sym_match_expression] = STATE(2069),
    [sym_function_expression] = STATE(2069),
    [sym_mutate_expression] = STATE(2069),
    [sym_index_expression] = STATE(2069),
    [sym_typed_expression] = STATE(2069),
    [sym_declaration_expression] = STATE(2069),
    [sym_do_expression] = STATE(2069),
    [sym_list_expression] = STATE(2069),
    [sym_array_expression] = STATE(2069),
    [sym_begin_end_expression] = STATE(2069),
    [sym_paren_expression] = STATE(2069),
    [sym__high_prec_app] = STATE(2058),
    [sym__low_prec_app] = STATE(2058),
    [sym_application_expression] = STATE(2069),
    [sym_dot_expression] = STATE(2069),
    [sym_infix_expression] = STATE(2069),
    [sym_ce_expression] = STATE(2069),
    [sym_sequential_expression] = STATE(2069),
    [sym_char] = STATE(2052),
    [sym_format_string] = STATE(2056),
    [sym__string_literal] = STATE(2056),
    [sym_string] = STATE(2052),
    [sym_verbatim_string] = STATE(2052),
    [sym_bytearray] = STATE(2052),
    [sym_verbatim_bytearray] = STATE(2052),
    [sym_format_triple_quoted_string] = STATE(2057),
    [sym_triple_quoted_string] = STATE(2052),
    [sym_const] = STATE(2069),
    [sym_long_identifier] = STATE(2077),
    [sym_active_pattern] = STATE(1953),
    [sym__identifier_or_op] = STATE(2078),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(934),
    [sym_sbyte] = STATE(2052),
    [sym_byte] = STATE(2052),
    [sym_int16] = STATE(2052),
    [sym_uint16] = STATE(2052),
    [sym_int32] = STATE(2052),
    [sym_uint32] = STATE(2052),
    [sym_nativeint] = STATE(2052),
    [sym_unativeint] = STATE(2052),
    [sym_int64] = STATE(2052),
    [sym_uint64] = STATE(2052),
    [sym_ieee32] = STATE(2052),
    [sym_ieee64] = STATE(2052),
    [sym_bignum] = STATE(2052),
    [sym_decimal] = STATE(2052),
    [sym_float] = STATE(1596),
    [sym_block_comment] = STATE(744),
    [sym_compiler_directive_decl] = STATE(744),
    [sym_fsi_directive_decl] = STATE(744),
    [sym_preproc_line] = STATE(744),
    [sym_preproc_if_in_expression] = STATE(2069),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(565),
    [anon_sym_null] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(571),
    [anon_sym_LBRACK_PIPE] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(3145),
    [anon_sym_LT_AT] = ACTIONS(577),
    [anon_sym_LT_AT_AT] = ACTIONS(3147),
    [anon_sym_LBRACE_PIPE] = ACTIONS(583),
    [anon_sym_new] = ACTIONS(561),
    [anon_sym_return_BANG] = ACTIONS(585),
    [anon_sym_yield] = ACTIONS(561),
    [anon_sym_yield_BANG] = ACTIONS(585),
    [anon_sym_lazy] = ACTIONS(561),
    [anon_sym_assert] = ACTIONS(561),
    [anon_sym_upcast] = ACTIONS(561),
    [anon_sym_downcast] = ACTIONS(561),
    [anon_sym_for] = ACTIONS(589),
    [anon_sym_while] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(593),
    [anon_sym_try] = ACTIONS(595),
    [anon_sym_match] = ACTIONS(597),
    [anon_sym_match_BANG] = ACTIONS(599),
    [anon_sym_function] = ACTIONS(601),
    [anon_sym_use] = ACTIONS(609),
    [anon_sym_use_BANG] = ACTIONS(611),
    [anon_sym_do_BANG] = ACTIONS(613),
    [anon_sym_begin] = ACTIONS(615),
    [aux_sym_char_token1] = ACTIONS(619),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(621),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [anon_sym_AT_DQUOTE] = ACTIONS(625),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(627),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(629),
    [sym_bool] = ACTIONS(631),
    [sym_unit] = ACTIONS(3149),
    [anon_sym_LPAREN_PIPE] = ACTIONS(635),
    [sym_op_identifier] = ACTIONS(3151),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(639),
    [sym_xint] = ACTIONS(641),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(643),
    [sym__tuple_marker] = ACTIONS(3153),
  },
  [745] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(499),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_range_expression] = STATE(10795),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1151),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(745),
    [sym_compiler_directive_decl] = STATE(745),
    [sym_fsi_directive_decl] = STATE(745),
    [sym_preproc_line] = STATE(745),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_begin] = ACTIONS(1782),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
  },
  [746] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(122),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(746),
    [sym_compiler_directive_decl] = STATE(746),
    [sym_fsi_directive_decl] = STATE(746),
    [sym_preproc_line] = STATE(746),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(3155),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [747] = {
    [sym_function_or_value_defn] = STATE(1099),
    [sym__expression] = STATE(264),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1020),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(2924),
    [sym_block_comment] = STATE(747),
    [sym_compiler_directive_decl] = STATE(747),
    [sym_fsi_directive_decl] = STATE(747),
    [sym_preproc_line] = STATE(747),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(2638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(1492),
    [anon_sym_return_BANG] = ACTIONS(1496),
    [anon_sym_yield] = ACTIONS(1492),
    [anon_sym_yield_BANG] = ACTIONS(1496),
    [anon_sym_lazy] = ACTIONS(1492),
    [anon_sym_assert] = ACTIONS(1492),
    [anon_sym_upcast] = ACTIONS(1492),
    [anon_sym_downcast] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_use] = ACTIONS(1500),
    [anon_sym_use_BANG] = ACTIONS(1502),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(2642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1504),
    [sym_xint] = ACTIONS(1506),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
    [anon_sym_POUNDendif] = ACTIONS(2690),
  },
  [748] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(122),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(748),
    [sym_compiler_directive_decl] = STATE(748),
    [sym_fsi_directive_decl] = STATE(748),
    [sym_preproc_line] = STATE(748),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(3157),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [749] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(308),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_range_expression] = STATE(10208),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1151),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(749),
    [sym_compiler_directive_decl] = STATE(749),
    [sym_fsi_directive_decl] = STATE(749),
    [sym_preproc_line] = STATE(749),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_begin] = ACTIONS(1782),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
  },
  [750] = {
    [sym_function_or_value_defn] = STATE(1163),
    [sym__expression] = STATE(40),
    [sym_literal_expression] = STATE(1715),
    [sym_long_identifier_or_op] = STATE(1715),
    [sym_tuple_expression] = STATE(1715),
    [sym_brace_expression] = STATE(1715),
    [sym_anon_record_expression] = STATE(1715),
    [sym_prefixed_expression] = STATE(1715),
    [sym_typecast_expression] = STATE(1715),
    [sym_for_expression] = STATE(1715),
    [sym_while_expression] = STATE(1715),
    [sym__if_branch] = STATE(10853),
    [sym_if_expression] = STATE(1715),
    [sym_fun_expression] = STATE(1715),
    [sym_try_expression] = STATE(1715),
    [sym_match_expression] = STATE(1715),
    [sym_function_expression] = STATE(1715),
    [sym_mutate_expression] = STATE(1715),
    [sym_index_expression] = STATE(1715),
    [sym_typed_expression] = STATE(1715),
    [sym_declaration_expression] = STATE(1715),
    [sym_do_expression] = STATE(1715),
    [sym_list_expression] = STATE(1715),
    [sym_array_expression] = STATE(1715),
    [sym_begin_end_expression] = STATE(1715),
    [sym_paren_expression] = STATE(1715),
    [sym__high_prec_app] = STATE(1728),
    [sym__low_prec_app] = STATE(1728),
    [sym_application_expression] = STATE(1715),
    [sym_dot_expression] = STATE(1715),
    [sym_infix_expression] = STATE(1715),
    [sym_ce_expression] = STATE(1715),
    [sym_sequential_expression] = STATE(1715),
    [sym_char] = STATE(1858),
    [sym_format_string] = STATE(1853),
    [sym__string_literal] = STATE(1853),
    [sym_string] = STATE(1858),
    [sym_verbatim_string] = STATE(1858),
    [sym_bytearray] = STATE(1858),
    [sym_verbatim_bytearray] = STATE(1858),
    [sym_format_triple_quoted_string] = STATE(1851),
    [sym_triple_quoted_string] = STATE(1858),
    [sym_const] = STATE(1715),
    [sym_long_identifier] = STATE(1825),
    [sym_active_pattern] = STATE(1754),
    [sym__identifier_or_op] = STATE(1822),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(940),
    [sym_sbyte] = STATE(1858),
    [sym_byte] = STATE(1858),
    [sym_int16] = STATE(1858),
    [sym_uint16] = STATE(1858),
    [sym_int32] = STATE(1858),
    [sym_uint32] = STATE(1858),
    [sym_nativeint] = STATE(1858),
    [sym_unativeint] = STATE(1858),
    [sym_int64] = STATE(1858),
    [sym_uint64] = STATE(1858),
    [sym_ieee32] = STATE(1858),
    [sym_ieee64] = STATE(1858),
    [sym_bignum] = STATE(1858),
    [sym_decimal] = STATE(1858),
    [sym_float] = STATE(1552),
    [sym_block_comment] = STATE(750),
    [sym_compiler_directive_decl] = STATE(750),
    [sym_fsi_directive_decl] = STATE(750),
    [sym_preproc_line] = STATE(750),
    [sym_preproc_if_in_expression] = STATE(1715),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_do] = ACTIONS(383),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(385),
    [anon_sym_null] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_LBRACK_PIPE] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(3159),
    [anon_sym_LT_AT] = ACTIONS(397),
    [anon_sym_LT_AT_AT] = ACTIONS(3161),
    [anon_sym_LBRACE_PIPE] = ACTIONS(403),
    [anon_sym_new] = ACTIONS(381),
    [anon_sym_return_BANG] = ACTIONS(405),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_yield_BANG] = ACTIONS(405),
    [anon_sym_lazy] = ACTIONS(381),
    [anon_sym_assert] = ACTIONS(381),
    [anon_sym_upcast] = ACTIONS(381),
    [anon_sym_downcast] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(409),
    [anon_sym_while] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(413),
    [anon_sym_try] = ACTIONS(415),
    [anon_sym_match] = ACTIONS(417),
    [anon_sym_match_BANG] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(421),
    [anon_sym_use] = ACTIONS(429),
    [anon_sym_use_BANG] = ACTIONS(431),
    [anon_sym_do_BANG] = ACTIONS(433),
    [anon_sym_begin] = ACTIONS(435),
    [aux_sym_char_token1] = ACTIONS(439),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(443),
    [anon_sym_AT_DQUOTE] = ACTIONS(445),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(447),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(449),
    [sym_bool] = ACTIONS(451),
    [sym_unit] = ACTIONS(3163),
    [anon_sym_LPAREN_PIPE] = ACTIONS(455),
    [sym_op_identifier] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(459),
    [sym_xint] = ACTIONS(461),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(463),
    [sym__tuple_marker] = ACTIONS(3167),
  },
  [751] = {
    [sym_function_or_value_defn] = STATE(1180),
    [sym__expression] = STATE(218),
    [sym_literal_expression] = STATE(3145),
    [sym_long_identifier_or_op] = STATE(3145),
    [sym_tuple_expression] = STATE(3145),
    [sym_brace_expression] = STATE(3145),
    [sym_anon_record_expression] = STATE(3145),
    [sym_prefixed_expression] = STATE(3145),
    [sym_typecast_expression] = STATE(3145),
    [sym_for_expression] = STATE(3145),
    [sym_while_expression] = STATE(3145),
    [sym__if_branch] = STATE(10360),
    [sym_if_expression] = STATE(3145),
    [sym_fun_expression] = STATE(3145),
    [sym_try_expression] = STATE(3145),
    [sym_match_expression] = STATE(3145),
    [sym_function_expression] = STATE(3145),
    [sym_mutate_expression] = STATE(3145),
    [sym_index_expression] = STATE(3145),
    [sym_typed_expression] = STATE(3145),
    [sym_declaration_expression] = STATE(3145),
    [sym_do_expression] = STATE(3145),
    [sym_list_expression] = STATE(3145),
    [sym_array_expression] = STATE(3145),
    [sym_begin_end_expression] = STATE(3145),
    [sym_paren_expression] = STATE(3145),
    [sym__high_prec_app] = STATE(3141),
    [sym__low_prec_app] = STATE(3141),
    [sym_application_expression] = STATE(3145),
    [sym_dot_expression] = STATE(3145),
    [sym_infix_expression] = STATE(3145),
    [sym_ce_expression] = STATE(3145),
    [sym_sequential_expression] = STATE(3145),
    [sym_char] = STATE(3108),
    [sym_format_string] = STATE(3193),
    [sym__string_literal] = STATE(3193),
    [sym_string] = STATE(3108),
    [sym_verbatim_string] = STATE(3108),
    [sym_bytearray] = STATE(3108),
    [sym_verbatim_bytearray] = STATE(3108),
    [sym_format_triple_quoted_string] = STATE(3192),
    [sym_triple_quoted_string] = STATE(3108),
    [sym_const] = STATE(3145),
    [sym_long_identifier] = STATE(3102),
    [sym_active_pattern] = STATE(3172),
    [sym__identifier_or_op] = STATE(3103),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1149),
    [sym_sbyte] = STATE(3108),
    [sym_byte] = STATE(3108),
    [sym_int16] = STATE(3108),
    [sym_uint16] = STATE(3108),
    [sym_int32] = STATE(3108),
    [sym_uint32] = STATE(3108),
    [sym_nativeint] = STATE(3108),
    [sym_unativeint] = STATE(3108),
    [sym_int64] = STATE(3108),
    [sym_uint64] = STATE(3108),
    [sym_ieee32] = STATE(3108),
    [sym_ieee64] = STATE(3108),
    [sym_bignum] = STATE(3108),
    [sym_decimal] = STATE(3108),
    [sym_float] = STATE(2770),
    [sym_block_comment] = STATE(751),
    [sym_compiler_directive_decl] = STATE(751),
    [sym_fsi_directive_decl] = STATE(751),
    [sym_preproc_line] = STATE(751),
    [sym_preproc_if_in_expression] = STATE(3145),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_return] = ACTIONS(1119),
    [anon_sym_do] = ACTIONS(1121),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_null] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1131),
    [anon_sym_LBRACE] = ACTIONS(3169),
    [anon_sym_LT_AT] = ACTIONS(1135),
    [anon_sym_LT_AT_AT] = ACTIONS(3171),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1141),
    [anon_sym_new] = ACTIONS(1119),
    [anon_sym_return_BANG] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1119),
    [anon_sym_yield_BANG] = ACTIONS(1143),
    [anon_sym_lazy] = ACTIONS(1119),
    [anon_sym_assert] = ACTIONS(1119),
    [anon_sym_upcast] = ACTIONS(1119),
    [anon_sym_downcast] = ACTIONS(1119),
    [anon_sym_for] = ACTIONS(1147),
    [anon_sym_while] = ACTIONS(1149),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1151),
    [anon_sym_try] = ACTIONS(1153),
    [anon_sym_match] = ACTIONS(1155),
    [anon_sym_match_BANG] = ACTIONS(1157),
    [anon_sym_function] = ACTIONS(1159),
    [anon_sym_use] = ACTIONS(1167),
    [anon_sym_use_BANG] = ACTIONS(1169),
    [anon_sym_do_BANG] = ACTIONS(1171),
    [anon_sym_begin] = ACTIONS(1173),
    [aux_sym_char_token1] = ACTIONS(1177),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(1181),
    [anon_sym_AT_DQUOTE] = ACTIONS(1183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1185),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1187),
    [sym_bool] = ACTIONS(1189),
    [sym_unit] = ACTIONS(3173),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1193),
    [sym_op_identifier] = ACTIONS(3175),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1197),
    [sym_xint] = ACTIONS(1199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1201),
    [sym__tuple_marker] = ACTIONS(3177),
  },
  [752] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(946),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(752),
    [sym_compiler_directive_decl] = STATE(752),
    [sym_fsi_directive_decl] = STATE(752),
    [sym_preproc_line] = STATE(752),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(753),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
    [sym__tuple_marker] = ACTIONS(3179),
  },
  [753] = {
    [sym_function_or_value_defn] = STATE(1166),
    [sym__expression] = STATE(134),
    [sym_literal_expression] = STATE(2884),
    [sym_long_identifier_or_op] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_brace_expression] = STATE(2884),
    [sym_anon_record_expression] = STATE(2884),
    [sym_prefixed_expression] = STATE(2884),
    [sym_typecast_expression] = STATE(2884),
    [sym_for_expression] = STATE(2884),
    [sym_while_expression] = STATE(2884),
    [sym__if_branch] = STATE(10729),
    [sym_if_expression] = STATE(2884),
    [sym_fun_expression] = STATE(2884),
    [sym_try_expression] = STATE(2884),
    [sym_match_expression] = STATE(2884),
    [sym_function_expression] = STATE(2884),
    [sym_mutate_expression] = STATE(2884),
    [sym_index_expression] = STATE(2884),
    [sym_typed_expression] = STATE(2884),
    [sym_declaration_expression] = STATE(2884),
    [sym_do_expression] = STATE(2884),
    [sym_list_expression] = STATE(2884),
    [sym_array_expression] = STATE(2884),
    [sym_begin_end_expression] = STATE(2884),
    [sym_paren_expression] = STATE(2884),
    [sym__high_prec_app] = STATE(2872),
    [sym__low_prec_app] = STATE(2872),
    [sym_application_expression] = STATE(2884),
    [sym_dot_expression] = STATE(2884),
    [sym_infix_expression] = STATE(2884),
    [sym_ce_expression] = STATE(2884),
    [sym_sequential_expression] = STATE(2884),
    [sym_char] = STATE(2955),
    [sym_format_string] = STATE(2951),
    [sym__string_literal] = STATE(2951),
    [sym_string] = STATE(2955),
    [sym_verbatim_string] = STATE(2955),
    [sym_bytearray] = STATE(2955),
    [sym_verbatim_bytearray] = STATE(2955),
    [sym_format_triple_quoted_string] = STATE(2949),
    [sym_triple_quoted_string] = STATE(2955),
    [sym_const] = STATE(2884),
    [sym_long_identifier] = STATE(2885),
    [sym_active_pattern] = STATE(2833),
    [sym__identifier_or_op] = STATE(2883),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1002),
    [sym_sbyte] = STATE(2955),
    [sym_byte] = STATE(2955),
    [sym_int16] = STATE(2955),
    [sym_uint16] = STATE(2955),
    [sym_int32] = STATE(2955),
    [sym_uint32] = STATE(2955),
    [sym_nativeint] = STATE(2955),
    [sym_unativeint] = STATE(2955),
    [sym_int64] = STATE(2955),
    [sym_uint64] = STATE(2955),
    [sym_ieee32] = STATE(2955),
    [sym_ieee64] = STATE(2955),
    [sym_bignum] = STATE(2955),
    [sym_decimal] = STATE(2955),
    [sym_float] = STATE(2652),
    [sym_block_comment] = STATE(753),
    [sym_compiler_directive_decl] = STATE(753),
    [sym_fsi_directive_decl] = STATE(753),
    [sym_preproc_line] = STATE(753),
    [sym_preproc_if_in_expression] = STATE(2884),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_do] = ACTIONS(1003),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_null] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1013),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1015),
    [anon_sym_LBRACE] = ACTIONS(3181),
    [anon_sym_LT_AT] = ACTIONS(1019),
    [anon_sym_LT_AT_AT] = ACTIONS(3183),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1025),
    [anon_sym_new] = ACTIONS(1001),
    [anon_sym_return_BANG] = ACTIONS(1029),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_yield_BANG] = ACTIONS(1029),
    [anon_sym_lazy] = ACTIONS(1001),
    [anon_sym_assert] = ACTIONS(1001),
    [anon_sym_upcast] = ACTIONS(1001),
    [anon_sym_downcast] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1033),
    [anon_sym_while] = ACTIONS(1035),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1037),
    [anon_sym_try] = ACTIONS(1039),
    [anon_sym_match] = ACTIONS(1041),
    [anon_sym_match_BANG] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(1045),
    [anon_sym_use] = ACTIONS(1053),
    [anon_sym_use_BANG] = ACTIONS(1055),
    [anon_sym_do_BANG] = ACTIONS(1057),
    [anon_sym_begin] = ACTIONS(1059),
    [aux_sym_char_token1] = ACTIONS(1063),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1067),
    [anon_sym_AT_DQUOTE] = ACTIONS(1069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1073),
    [sym_bool] = ACTIONS(1075),
    [sym_unit] = ACTIONS(3185),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1079),
    [sym_op_identifier] = ACTIONS(3187),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1083),
    [sym_xint] = ACTIONS(1085),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1087),
    [sym__tuple_marker] = ACTIONS(3189),
  },
  [754] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(401),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_range_expression] = STATE(10655),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1151),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(754),
    [sym_compiler_directive_decl] = STATE(754),
    [sym_fsi_directive_decl] = STATE(754),
    [sym_preproc_line] = STATE(754),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_begin] = ACTIONS(1782),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
  },
  [755] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(363),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(755),
    [sym_compiler_directive_decl] = STATE(755),
    [sym_fsi_directive_decl] = STATE(755),
    [sym_preproc_line] = STATE(755),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [756] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(433),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(756),
    [sym_compiler_directive_decl] = STATE(756),
    [sym_fsi_directive_decl] = STATE(756),
    [sym_preproc_line] = STATE(756),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [757] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(295),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1022),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(757),
    [sym_compiler_directive_decl] = STATE(757),
    [sym_fsi_directive_decl] = STATE(757),
    [sym_preproc_line] = STATE(757),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(3069),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(3071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
  },
  [758] = {
    [sym_function_or_value_defn] = STATE(953),
    [sym__expression] = STATE(39),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(942),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(1568),
    [sym_block_comment] = STATE(758),
    [sym_compiler_directive_decl] = STATE(758),
    [sym_fsi_directive_decl] = STATE(758),
    [sym_preproc_line] = STATE(758),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(291),
    [anon_sym_return_BANG] = ACTIONS(315),
    [anon_sym_yield] = ACTIONS(291),
    [anon_sym_yield_BANG] = ACTIONS(315),
    [anon_sym_lazy] = ACTIONS(291),
    [anon_sym_assert] = ACTIONS(291),
    [anon_sym_upcast] = ACTIONS(291),
    [anon_sym_downcast] = ACTIONS(291),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(339),
    [anon_sym_use_BANG] = ACTIONS(341),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(369),
    [sym_xint] = ACTIONS(371),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
  },
  [759] = {
    [sym_function_or_value_defn] = STATE(953),
    [sym__expression] = STATE(25),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(942),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(1568),
    [sym_block_comment] = STATE(759),
    [sym_compiler_directive_decl] = STATE(759),
    [sym_fsi_directive_decl] = STATE(759),
    [sym_preproc_line] = STATE(759),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(291),
    [anon_sym_return_BANG] = ACTIONS(315),
    [anon_sym_yield] = ACTIONS(291),
    [anon_sym_yield_BANG] = ACTIONS(315),
    [anon_sym_lazy] = ACTIONS(291),
    [anon_sym_assert] = ACTIONS(291),
    [anon_sym_upcast] = ACTIONS(291),
    [anon_sym_downcast] = ACTIONS(291),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(339),
    [anon_sym_use_BANG] = ACTIONS(341),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(369),
    [sym_xint] = ACTIONS(371),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
  },
  [760] = {
    [sym_function_or_value_defn] = STATE(760),
    [sym__expression] = STATE(15),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(956),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(760),
    [sym_compiler_directive_decl] = STATE(760),
    [sym_fsi_directive_decl] = STATE(760),
    [sym_preproc_line] = STATE(760),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_return] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(269),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(269),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(269),
    [anon_sym_assert] = ACTIONS(269),
    [anon_sym_upcast] = ACTIONS(269),
    [anon_sym_downcast] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(277),
    [anon_sym_use_BANG] = ACTIONS(279),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(281),
    [sym_xint] = ACTIONS(283),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
  },
  [761] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(270),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(761),
    [sym_compiler_directive_decl] = STATE(761),
    [sym_fsi_directive_decl] = STATE(761),
    [sym_preproc_line] = STATE(761),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [762] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(267),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1022),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(762),
    [sym_compiler_directive_decl] = STATE(762),
    [sym_fsi_directive_decl] = STATE(762),
    [sym_preproc_line] = STATE(762),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(3069),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(3071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
  },
  [763] = {
    [sym_function_or_value_defn] = STATE(760),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(956),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(763),
    [sym_compiler_directive_decl] = STATE(763),
    [sym_fsi_directive_decl] = STATE(763),
    [sym_preproc_line] = STATE(763),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_return] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(269),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(269),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(269),
    [anon_sym_assert] = ACTIONS(269),
    [anon_sym_upcast] = ACTIONS(269),
    [anon_sym_downcast] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(277),
    [anon_sym_use_BANG] = ACTIONS(279),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(281),
    [sym_xint] = ACTIONS(283),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
  },
  [764] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(266),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(890),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(764),
    [sym_compiler_directive_decl] = STATE(764),
    [sym_fsi_directive_decl] = STATE(764),
    [sym_preproc_line] = STATE(764),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
  },
  [765] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(256),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1045),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(765),
    [sym_compiler_directive_decl] = STATE(765),
    [sym_fsi_directive_decl] = STATE(765),
    [sym_preproc_line] = STATE(765),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [766] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(165),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(766),
    [sym_compiler_directive_decl] = STATE(766),
    [sym_fsi_directive_decl] = STATE(766),
    [sym_preproc_line] = STATE(766),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [767] = {
    [sym_function_or_value_defn] = STATE(760),
    [sym__expression] = STATE(23),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(956),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(767),
    [sym_compiler_directive_decl] = STATE(767),
    [sym_fsi_directive_decl] = STATE(767),
    [sym_preproc_line] = STATE(767),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_return] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(269),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(269),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(269),
    [anon_sym_assert] = ACTIONS(269),
    [anon_sym_upcast] = ACTIONS(269),
    [anon_sym_downcast] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(277),
    [anon_sym_use_BANG] = ACTIONS(279),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(281),
    [sym_xint] = ACTIONS(283),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
  },
  [768] = {
    [sym_function_or_value_defn] = STATE(760),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(956),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(768),
    [sym_compiler_directive_decl] = STATE(768),
    [sym_fsi_directive_decl] = STATE(768),
    [sym_preproc_line] = STATE(768),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_return] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(269),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(269),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(269),
    [anon_sym_assert] = ACTIONS(269),
    [anon_sym_upcast] = ACTIONS(269),
    [anon_sym_downcast] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(277),
    [anon_sym_use_BANG] = ACTIONS(279),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(281),
    [sym_xint] = ACTIONS(283),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
  },
  [769] = {
    [sym_function_or_value_defn] = STATE(972),
    [sym__expression] = STATE(185),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(978),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(769),
    [sym_compiler_directive_decl] = STATE(769),
    [sym_fsi_directive_decl] = STATE(769),
    [sym_preproc_line] = STATE(769),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1302),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1302),
    [anon_sym_return_BANG] = ACTIONS(1326),
    [anon_sym_yield] = ACTIONS(1302),
    [anon_sym_yield_BANG] = ACTIONS(1326),
    [anon_sym_lazy] = ACTIONS(1302),
    [anon_sym_assert] = ACTIONS(1302),
    [anon_sym_upcast] = ACTIONS(1302),
    [anon_sym_downcast] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1330),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1352),
    [anon_sym_use_BANG] = ACTIONS(1354),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1384),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [770] = {
    [sym_function_or_value_defn] = STATE(1180),
    [sym__expression] = STATE(216),
    [sym_literal_expression] = STATE(3145),
    [sym_long_identifier_or_op] = STATE(3145),
    [sym_tuple_expression] = STATE(3145),
    [sym_brace_expression] = STATE(3145),
    [sym_anon_record_expression] = STATE(3145),
    [sym_prefixed_expression] = STATE(3145),
    [sym_typecast_expression] = STATE(3145),
    [sym_for_expression] = STATE(3145),
    [sym_while_expression] = STATE(3145),
    [sym__if_branch] = STATE(10360),
    [sym_if_expression] = STATE(3145),
    [sym_fun_expression] = STATE(3145),
    [sym_try_expression] = STATE(3145),
    [sym_match_expression] = STATE(3145),
    [sym_function_expression] = STATE(3145),
    [sym_mutate_expression] = STATE(3145),
    [sym_index_expression] = STATE(3145),
    [sym_typed_expression] = STATE(3145),
    [sym_declaration_expression] = STATE(3145),
    [sym_do_expression] = STATE(3145),
    [sym_list_expression] = STATE(3145),
    [sym_array_expression] = STATE(3145),
    [sym_begin_end_expression] = STATE(3145),
    [sym_paren_expression] = STATE(3145),
    [sym__high_prec_app] = STATE(3141),
    [sym__low_prec_app] = STATE(3141),
    [sym_application_expression] = STATE(3145),
    [sym_dot_expression] = STATE(3145),
    [sym_infix_expression] = STATE(3145),
    [sym_ce_expression] = STATE(3145),
    [sym_sequential_expression] = STATE(3145),
    [sym_char] = STATE(3108),
    [sym_format_string] = STATE(3193),
    [sym__string_literal] = STATE(3193),
    [sym_string] = STATE(3108),
    [sym_verbatim_string] = STATE(3108),
    [sym_bytearray] = STATE(3108),
    [sym_verbatim_bytearray] = STATE(3108),
    [sym_format_triple_quoted_string] = STATE(3192),
    [sym_triple_quoted_string] = STATE(3108),
    [sym_const] = STATE(3145),
    [sym_long_identifier] = STATE(3102),
    [sym_active_pattern] = STATE(3172),
    [sym__identifier_or_op] = STATE(3103),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1149),
    [sym_sbyte] = STATE(3108),
    [sym_byte] = STATE(3108),
    [sym_int16] = STATE(3108),
    [sym_uint16] = STATE(3108),
    [sym_int32] = STATE(3108),
    [sym_uint32] = STATE(3108),
    [sym_nativeint] = STATE(3108),
    [sym_unativeint] = STATE(3108),
    [sym_int64] = STATE(3108),
    [sym_uint64] = STATE(3108),
    [sym_ieee32] = STATE(3108),
    [sym_ieee64] = STATE(3108),
    [sym_bignum] = STATE(3108),
    [sym_decimal] = STATE(3108),
    [sym_float] = STATE(2770),
    [sym_block_comment] = STATE(770),
    [sym_compiler_directive_decl] = STATE(770),
    [sym_fsi_directive_decl] = STATE(770),
    [sym_preproc_line] = STATE(770),
    [sym_preproc_if_in_expression] = STATE(3145),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_return] = ACTIONS(1119),
    [anon_sym_do] = ACTIONS(1121),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_null] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1131),
    [anon_sym_LBRACE] = ACTIONS(3169),
    [anon_sym_LT_AT] = ACTIONS(1135),
    [anon_sym_LT_AT_AT] = ACTIONS(3171),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1141),
    [anon_sym_new] = ACTIONS(1119),
    [anon_sym_return_BANG] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1119),
    [anon_sym_yield_BANG] = ACTIONS(1143),
    [anon_sym_lazy] = ACTIONS(1119),
    [anon_sym_assert] = ACTIONS(1119),
    [anon_sym_upcast] = ACTIONS(1119),
    [anon_sym_downcast] = ACTIONS(1119),
    [anon_sym_for] = ACTIONS(1147),
    [anon_sym_while] = ACTIONS(1149),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1151),
    [anon_sym_try] = ACTIONS(1153),
    [anon_sym_match] = ACTIONS(1155),
    [anon_sym_match_BANG] = ACTIONS(1157),
    [anon_sym_function] = ACTIONS(1159),
    [anon_sym_use] = ACTIONS(1167),
    [anon_sym_use_BANG] = ACTIONS(1169),
    [anon_sym_do_BANG] = ACTIONS(1171),
    [anon_sym_begin] = ACTIONS(1173),
    [aux_sym_char_token1] = ACTIONS(1177),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(1181),
    [anon_sym_AT_DQUOTE] = ACTIONS(1183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1185),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1187),
    [sym_bool] = ACTIONS(1189),
    [sym_unit] = ACTIONS(3173),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1193),
    [sym_op_identifier] = ACTIONS(3175),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1197),
    [sym_xint] = ACTIONS(1199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1201),
  },
  [771] = {
    [sym_function_or_value_defn] = STATE(850),
    [sym__expression] = STATE(8),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(949),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(771),
    [sym_compiler_directive_decl] = STATE(771),
    [sym_fsi_directive_decl] = STATE(771),
    [sym_preproc_line] = STATE(771),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(129),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(129),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(129),
    [anon_sym_assert] = ACTIONS(129),
    [anon_sym_upcast] = ACTIONS(129),
    [anon_sym_downcast] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(215),
    [sym_xint] = ACTIONS(217),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
  },
  [772] = {
    [sym_function_or_value_defn] = STATE(760),
    [sym__expression] = STATE(14),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(956),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(772),
    [sym_compiler_directive_decl] = STATE(772),
    [sym_fsi_directive_decl] = STATE(772),
    [sym_preproc_line] = STATE(772),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_return] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(269),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(269),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(269),
    [anon_sym_assert] = ACTIONS(269),
    [anon_sym_upcast] = ACTIONS(269),
    [anon_sym_downcast] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(277),
    [anon_sym_use_BANG] = ACTIONS(279),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(281),
    [sym_xint] = ACTIONS(283),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
  },
  [773] = {
    [sym_function_or_value_defn] = STATE(866),
    [sym__expression] = STATE(99),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1178),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(773),
    [sym_compiler_directive_decl] = STATE(773),
    [sym_fsi_directive_decl] = STATE(773),
    [sym_preproc_line] = STATE(773),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(857),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(53),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(857),
    [anon_sym_return_BANG] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(857),
    [anon_sym_yield_BANG] = ACTIONS(869),
    [anon_sym_lazy] = ACTIONS(857),
    [anon_sym_assert] = ACTIONS(857),
    [anon_sym_upcast] = ACTIONS(857),
    [anon_sym_downcast] = ACTIONS(857),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(879),
    [anon_sym_use_BANG] = ACTIONS(881),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(99),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(889),
    [sym_xint] = ACTIONS(891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
  },
  [774] = {
    [sym_function_or_value_defn] = STATE(760),
    [sym__expression] = STATE(20),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(956),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(774),
    [sym_compiler_directive_decl] = STATE(774),
    [sym_fsi_directive_decl] = STATE(774),
    [sym_preproc_line] = STATE(774),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_return] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(269),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(269),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(269),
    [anon_sym_assert] = ACTIONS(269),
    [anon_sym_upcast] = ACTIONS(269),
    [anon_sym_downcast] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(277),
    [anon_sym_use_BANG] = ACTIONS(279),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(281),
    [sym_xint] = ACTIONS(283),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
  },
  [775] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(457),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1045),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(775),
    [sym_compiler_directive_decl] = STATE(775),
    [sym_fsi_directive_decl] = STATE(775),
    [sym_preproc_line] = STATE(775),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [776] = {
    [sym_function_or_value_defn] = STATE(845),
    [sym__expression] = STATE(142),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(776),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(776),
    [sym_compiler_directive_decl] = STATE(776),
    [sym_fsi_directive_decl] = STATE(776),
    [sym_preproc_line] = STATE(776),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1203),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1203),
    [anon_sym_return_BANG] = ACTIONS(1207),
    [anon_sym_yield] = ACTIONS(1203),
    [anon_sym_yield_BANG] = ACTIONS(1207),
    [anon_sym_lazy] = ACTIONS(1203),
    [anon_sym_assert] = ACTIONS(1203),
    [anon_sym_upcast] = ACTIONS(1203),
    [anon_sym_downcast] = ACTIONS(1203),
    [anon_sym_for] = ACTIONS(1209),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1213),
    [anon_sym_use_BANG] = ACTIONS(1215),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1219),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [777] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(243),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(777),
    [sym_compiler_directive_decl] = STATE(777),
    [sym_fsi_directive_decl] = STATE(777),
    [sym_preproc_line] = STATE(777),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [778] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(523),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(778),
    [sym_compiler_directive_decl] = STATE(778),
    [sym_fsi_directive_decl] = STATE(778),
    [sym_preproc_line] = STATE(778),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [779] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(404),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1151),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(779),
    [sym_compiler_directive_decl] = STATE(779),
    [sym_fsi_directive_decl] = STATE(779),
    [sym_preproc_line] = STATE(779),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_begin] = ACTIONS(1782),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
  },
  [780] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(516),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(780),
    [sym_compiler_directive_decl] = STATE(780),
    [sym_fsi_directive_decl] = STATE(780),
    [sym_preproc_line] = STATE(780),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [781] = {
    [sym_function_or_value_defn] = STATE(850),
    [sym__expression] = STATE(6),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(949),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(781),
    [sym_compiler_directive_decl] = STATE(781),
    [sym_fsi_directive_decl] = STATE(781),
    [sym_preproc_line] = STATE(781),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(129),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(129),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(129),
    [anon_sym_assert] = ACTIONS(129),
    [anon_sym_upcast] = ACTIONS(129),
    [anon_sym_downcast] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(215),
    [sym_xint] = ACTIONS(217),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
  },
  [782] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(509),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(782),
    [sym_compiler_directive_decl] = STATE(782),
    [sym_fsi_directive_decl] = STATE(782),
    [sym_preproc_line] = STATE(782),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [783] = {
    [sym_function_or_value_defn] = STATE(783),
    [sym__expression] = STATE(469),
    [sym_literal_expression] = STATE(3553),
    [sym_long_identifier_or_op] = STATE(3553),
    [sym_tuple_expression] = STATE(3553),
    [sym_brace_expression] = STATE(3553),
    [sym_anon_record_expression] = STATE(3553),
    [sym_prefixed_expression] = STATE(3553),
    [sym_typecast_expression] = STATE(3553),
    [sym_for_expression] = STATE(3553),
    [sym_while_expression] = STATE(3553),
    [sym__if_branch] = STATE(10567),
    [sym_if_expression] = STATE(3553),
    [sym_fun_expression] = STATE(3553),
    [sym_try_expression] = STATE(3553),
    [sym_match_expression] = STATE(3553),
    [sym_function_expression] = STATE(3553),
    [sym_mutate_expression] = STATE(3553),
    [sym_index_expression] = STATE(3553),
    [sym_typed_expression] = STATE(3553),
    [sym_declaration_expression] = STATE(3553),
    [sym_do_expression] = STATE(3553),
    [sym_list_expression] = STATE(3553),
    [sym_array_expression] = STATE(3553),
    [sym_begin_end_expression] = STATE(3553),
    [sym_paren_expression] = STATE(3553),
    [sym__high_prec_app] = STATE(3532),
    [sym__low_prec_app] = STATE(3532),
    [sym_application_expression] = STATE(3553),
    [sym_dot_expression] = STATE(3553),
    [sym_infix_expression] = STATE(3553),
    [sym_ce_expression] = STATE(3553),
    [sym_sequential_expression] = STATE(3553),
    [sym_char] = STATE(3265),
    [sym_format_string] = STATE(3261),
    [sym__string_literal] = STATE(3261),
    [sym_string] = STATE(3265),
    [sym_verbatim_string] = STATE(3265),
    [sym_bytearray] = STATE(3265),
    [sym_verbatim_bytearray] = STATE(3265),
    [sym_format_triple_quoted_string] = STATE(3260),
    [sym_triple_quoted_string] = STATE(3265),
    [sym_const] = STATE(3553),
    [sym_long_identifier] = STATE(3203),
    [sym_active_pattern] = STATE(3576),
    [sym__identifier_or_op] = STATE(3362),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1076),
    [sym_sbyte] = STATE(3265),
    [sym_byte] = STATE(3265),
    [sym_int16] = STATE(3265),
    [sym_uint16] = STATE(3265),
    [sym_int32] = STATE(3265),
    [sym_uint32] = STATE(3265),
    [sym_nativeint] = STATE(3265),
    [sym_unativeint] = STATE(3265),
    [sym_int64] = STATE(3265),
    [sym_uint64] = STATE(3265),
    [sym_ieee32] = STATE(3265),
    [sym_ieee64] = STATE(3265),
    [sym_bignum] = STATE(3265),
    [sym_decimal] = STATE(3265),
    [sym_float] = STATE(2797),
    [sym_block_comment] = STATE(783),
    [sym_compiler_directive_decl] = STATE(783),
    [sym_fsi_directive_decl] = STATE(783),
    [sym_preproc_line] = STATE(783),
    [sym_preproc_if_in_expression] = STATE(3553),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1632),
    [anon_sym_return] = ACTIONS(1636),
    [anon_sym_do] = ACTIONS(1638),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1640),
    [anon_sym_null] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1646),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_LT_AT] = ACTIONS(1652),
    [anon_sym_LT_AT_AT] = ACTIONS(3021),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1658),
    [anon_sym_new] = ACTIONS(1636),
    [anon_sym_return_BANG] = ACTIONS(1660),
    [anon_sym_yield] = ACTIONS(1636),
    [anon_sym_yield_BANG] = ACTIONS(1660),
    [anon_sym_lazy] = ACTIONS(1636),
    [anon_sym_assert] = ACTIONS(1636),
    [anon_sym_upcast] = ACTIONS(1636),
    [anon_sym_downcast] = ACTIONS(1636),
    [anon_sym_for] = ACTIONS(1664),
    [anon_sym_while] = ACTIONS(1666),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1668),
    [anon_sym_try] = ACTIONS(1670),
    [anon_sym_match] = ACTIONS(1672),
    [anon_sym_match_BANG] = ACTIONS(1674),
    [anon_sym_function] = ACTIONS(1676),
    [anon_sym_use] = ACTIONS(1684),
    [anon_sym_use_BANG] = ACTIONS(1686),
    [anon_sym_do_BANG] = ACTIONS(1688),
    [anon_sym_begin] = ACTIONS(1690),
    [aux_sym_char_token1] = ACTIONS(1694),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1696),
    [anon_sym_DQUOTE] = ACTIONS(1698),
    [anon_sym_AT_DQUOTE] = ACTIONS(1700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1704),
    [sym_bool] = ACTIONS(1706),
    [sym_unit] = ACTIONS(3023),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1710),
    [sym_op_identifier] = ACTIONS(3025),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1714),
    [sym_xint] = ACTIONS(1716),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1718),
  },
  [784] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(170),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(887),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(784),
    [sym_compiler_directive_decl] = STATE(784),
    [sym_fsi_directive_decl] = STATE(784),
    [sym_preproc_line] = STATE(784),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [785] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(254),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(890),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(785),
    [sym_compiler_directive_decl] = STATE(785),
    [sym_fsi_directive_decl] = STATE(785),
    [sym_preproc_line] = STATE(785),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
  },
  [786] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(344),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(786),
    [sym_compiler_directive_decl] = STATE(786),
    [sym_fsi_directive_decl] = STATE(786),
    [sym_preproc_line] = STATE(786),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [787] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(348),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1022),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(787),
    [sym_compiler_directive_decl] = STATE(787),
    [sym_fsi_directive_decl] = STATE(787),
    [sym_preproc_line] = STATE(787),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(3069),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(3071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
  },
  [788] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(356),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(890),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(788),
    [sym_compiler_directive_decl] = STATE(788),
    [sym_fsi_directive_decl] = STATE(788),
    [sym_preproc_line] = STATE(788),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
  },
  [789] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(269),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(789),
    [sym_compiler_directive_decl] = STATE(789),
    [sym_fsi_directive_decl] = STATE(789),
    [sym_preproc_line] = STATE(789),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [790] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(238),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(790),
    [sym_compiler_directive_decl] = STATE(790),
    [sym_fsi_directive_decl] = STATE(790),
    [sym_preproc_line] = STATE(790),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [791] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(179),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(887),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(791),
    [sym_compiler_directive_decl] = STATE(791),
    [sym_fsi_directive_decl] = STATE(791),
    [sym_preproc_line] = STATE(791),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [792] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(181),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(792),
    [sym_compiler_directive_decl] = STATE(792),
    [sym_fsi_directive_decl] = STATE(792),
    [sym_preproc_line] = STATE(792),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [793] = {
    [sym_function_or_value_defn] = STATE(964),
    [sym__expression] = STATE(114),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(793),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(793),
    [sym_compiler_directive_decl] = STATE(793),
    [sym_fsi_directive_decl] = STATE(793),
    [sym_preproc_line] = STATE(793),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(53),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(29),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_upcast] = ACTIONS(29),
    [anon_sym_downcast] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(99),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(111),
    [sym_xint] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
  },
  [794] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(141),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(887),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(794),
    [sym_compiler_directive_decl] = STATE(794),
    [sym_fsi_directive_decl] = STATE(794),
    [sym_preproc_line] = STATE(794),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [795] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(285),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(890),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(795),
    [sym_compiler_directive_decl] = STATE(795),
    [sym_fsi_directive_decl] = STATE(795),
    [sym_preproc_line] = STATE(795),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
  },
  [796] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(258),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(796),
    [sym_compiler_directive_decl] = STATE(796),
    [sym_fsi_directive_decl] = STATE(796),
    [sym_preproc_line] = STATE(796),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [797] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(529),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(797),
    [sym_compiler_directive_decl] = STATE(797),
    [sym_fsi_directive_decl] = STATE(797),
    [sym_preproc_line] = STATE(797),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [798] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(287),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1022),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(798),
    [sym_compiler_directive_decl] = STATE(798),
    [sym_fsi_directive_decl] = STATE(798),
    [sym_preproc_line] = STATE(798),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(3069),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(3071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
  },
  [799] = {
    [sym_function_or_value_defn] = STATE(783),
    [sym__expression] = STATE(260),
    [sym_literal_expression] = STATE(3553),
    [sym_long_identifier_or_op] = STATE(3553),
    [sym_tuple_expression] = STATE(3553),
    [sym_brace_expression] = STATE(3553),
    [sym_anon_record_expression] = STATE(3553),
    [sym_prefixed_expression] = STATE(3553),
    [sym_typecast_expression] = STATE(3553),
    [sym_for_expression] = STATE(3553),
    [sym_while_expression] = STATE(3553),
    [sym__if_branch] = STATE(10567),
    [sym_if_expression] = STATE(3553),
    [sym_fun_expression] = STATE(3553),
    [sym_try_expression] = STATE(3553),
    [sym_match_expression] = STATE(3553),
    [sym_function_expression] = STATE(3553),
    [sym_mutate_expression] = STATE(3553),
    [sym_index_expression] = STATE(3553),
    [sym_typed_expression] = STATE(3553),
    [sym_declaration_expression] = STATE(3553),
    [sym_do_expression] = STATE(3553),
    [sym_list_expression] = STATE(3553),
    [sym_array_expression] = STATE(3553),
    [sym_begin_end_expression] = STATE(3553),
    [sym_paren_expression] = STATE(3553),
    [sym__high_prec_app] = STATE(3532),
    [sym__low_prec_app] = STATE(3532),
    [sym_application_expression] = STATE(3553),
    [sym_dot_expression] = STATE(3553),
    [sym_infix_expression] = STATE(3553),
    [sym_ce_expression] = STATE(3553),
    [sym_sequential_expression] = STATE(3553),
    [sym_char] = STATE(3265),
    [sym_format_string] = STATE(3261),
    [sym__string_literal] = STATE(3261),
    [sym_string] = STATE(3265),
    [sym_verbatim_string] = STATE(3265),
    [sym_bytearray] = STATE(3265),
    [sym_verbatim_bytearray] = STATE(3265),
    [sym_format_triple_quoted_string] = STATE(3260),
    [sym_triple_quoted_string] = STATE(3265),
    [sym_const] = STATE(3553),
    [sym_long_identifier] = STATE(3203),
    [sym_active_pattern] = STATE(3576),
    [sym__identifier_or_op] = STATE(3362),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1076),
    [sym_sbyte] = STATE(3265),
    [sym_byte] = STATE(3265),
    [sym_int16] = STATE(3265),
    [sym_uint16] = STATE(3265),
    [sym_int32] = STATE(3265),
    [sym_uint32] = STATE(3265),
    [sym_nativeint] = STATE(3265),
    [sym_unativeint] = STATE(3265),
    [sym_int64] = STATE(3265),
    [sym_uint64] = STATE(3265),
    [sym_ieee32] = STATE(3265),
    [sym_ieee64] = STATE(3265),
    [sym_bignum] = STATE(3265),
    [sym_decimal] = STATE(3265),
    [sym_float] = STATE(2797),
    [sym_block_comment] = STATE(799),
    [sym_compiler_directive_decl] = STATE(799),
    [sym_fsi_directive_decl] = STATE(799),
    [sym_preproc_line] = STATE(799),
    [sym_preproc_if_in_expression] = STATE(3553),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1632),
    [anon_sym_return] = ACTIONS(1636),
    [anon_sym_do] = ACTIONS(1638),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1640),
    [anon_sym_null] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1646),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_LT_AT] = ACTIONS(1652),
    [anon_sym_LT_AT_AT] = ACTIONS(3021),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1658),
    [anon_sym_new] = ACTIONS(1636),
    [anon_sym_return_BANG] = ACTIONS(1660),
    [anon_sym_yield] = ACTIONS(1636),
    [anon_sym_yield_BANG] = ACTIONS(1660),
    [anon_sym_lazy] = ACTIONS(1636),
    [anon_sym_assert] = ACTIONS(1636),
    [anon_sym_upcast] = ACTIONS(1636),
    [anon_sym_downcast] = ACTIONS(1636),
    [anon_sym_for] = ACTIONS(1664),
    [anon_sym_while] = ACTIONS(1666),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1668),
    [anon_sym_try] = ACTIONS(1670),
    [anon_sym_match] = ACTIONS(1672),
    [anon_sym_match_BANG] = ACTIONS(1674),
    [anon_sym_function] = ACTIONS(1676),
    [anon_sym_use] = ACTIONS(1684),
    [anon_sym_use_BANG] = ACTIONS(1686),
    [anon_sym_do_BANG] = ACTIONS(1688),
    [anon_sym_begin] = ACTIONS(1690),
    [aux_sym_char_token1] = ACTIONS(1694),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1696),
    [anon_sym_DQUOTE] = ACTIONS(1698),
    [anon_sym_AT_DQUOTE] = ACTIONS(1700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1704),
    [sym_bool] = ACTIONS(1706),
    [sym_unit] = ACTIONS(3023),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1710),
    [sym_op_identifier] = ACTIONS(3025),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1714),
    [sym_xint] = ACTIONS(1716),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1718),
  },
  [800] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(389),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(800),
    [sym_compiler_directive_decl] = STATE(800),
    [sym_fsi_directive_decl] = STATE(800),
    [sym_preproc_line] = STATE(800),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [801] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(288),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(801),
    [sym_compiler_directive_decl] = STATE(801),
    [sym_fsi_directive_decl] = STATE(801),
    [sym_preproc_line] = STATE(801),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [802] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(271),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1045),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(802),
    [sym_compiler_directive_decl] = STATE(802),
    [sym_fsi_directive_decl] = STATE(802),
    [sym_preproc_line] = STATE(802),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [803] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(247),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(887),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(803),
    [sym_compiler_directive_decl] = STATE(803),
    [sym_fsi_directive_decl] = STATE(803),
    [sym_preproc_line] = STATE(803),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [804] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(231),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(804),
    [sym_compiler_directive_decl] = STATE(804),
    [sym_fsi_directive_decl] = STATE(804),
    [sym_preproc_line] = STATE(804),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [805] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(459),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(805),
    [sym_compiler_directive_decl] = STATE(805),
    [sym_fsi_directive_decl] = STATE(805),
    [sym_preproc_line] = STATE(805),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [806] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(234),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(806),
    [sym_compiler_directive_decl] = STATE(806),
    [sym_fsi_directive_decl] = STATE(806),
    [sym_preproc_line] = STATE(806),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [807] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(510),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(807),
    [sym_compiler_directive_decl] = STATE(807),
    [sym_fsi_directive_decl] = STATE(807),
    [sym_preproc_line] = STATE(807),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [808] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(425),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(808),
    [sym_compiler_directive_decl] = STATE(808),
    [sym_fsi_directive_decl] = STATE(808),
    [sym_preproc_line] = STATE(808),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [809] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(426),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1022),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(809),
    [sym_compiler_directive_decl] = STATE(809),
    [sym_fsi_directive_decl] = STATE(809),
    [sym_preproc_line] = STATE(809),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(3069),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(3071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
  },
  [810] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(432),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(890),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(810),
    [sym_compiler_directive_decl] = STATE(810),
    [sym_fsi_directive_decl] = STATE(810),
    [sym_preproc_line] = STATE(810),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
  },
  [811] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(224),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(887),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(811),
    [sym_compiler_directive_decl] = STATE(811),
    [sym_fsi_directive_decl] = STATE(811),
    [sym_preproc_line] = STATE(811),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [812] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(514),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(812),
    [sym_compiler_directive_decl] = STATE(812),
    [sym_fsi_directive_decl] = STATE(812),
    [sym_preproc_line] = STATE(812),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [813] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(246),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(813),
    [sym_compiler_directive_decl] = STATE(813),
    [sym_fsi_directive_decl] = STATE(813),
    [sym_preproc_line] = STATE(813),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [814] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(515),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(814),
    [sym_compiler_directive_decl] = STATE(814),
    [sym_fsi_directive_decl] = STATE(814),
    [sym_preproc_line] = STATE(814),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [815] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(228),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(815),
    [sym_compiler_directive_decl] = STATE(815),
    [sym_fsi_directive_decl] = STATE(815),
    [sym_preproc_line] = STATE(815),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [816] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(251),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(816),
    [sym_compiler_directive_decl] = STATE(816),
    [sym_fsi_directive_decl] = STATE(816),
    [sym_preproc_line] = STATE(816),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [817] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(513),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(817),
    [sym_compiler_directive_decl] = STATE(817),
    [sym_fsi_directive_decl] = STATE(817),
    [sym_preproc_line] = STATE(817),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [818] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(322),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(890),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(818),
    [sym_compiler_directive_decl] = STATE(818),
    [sym_fsi_directive_decl] = STATE(818),
    [sym_preproc_line] = STATE(818),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
  },
  [819] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(225),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(819),
    [sym_compiler_directive_decl] = STATE(819),
    [sym_fsi_directive_decl] = STATE(819),
    [sym_preproc_line] = STATE(819),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [820] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(324),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1022),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(820),
    [sym_compiler_directive_decl] = STATE(820),
    [sym_fsi_directive_decl] = STATE(820),
    [sym_preproc_line] = STATE(820),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(3069),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(3071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
  },
  [821] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(276),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1045),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(821),
    [sym_compiler_directive_decl] = STATE(821),
    [sym_fsi_directive_decl] = STATE(821),
    [sym_preproc_line] = STATE(821),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [822] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(328),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(822),
    [sym_compiler_directive_decl] = STATE(822),
    [sym_fsi_directive_decl] = STATE(822),
    [sym_preproc_line] = STATE(822),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [823] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(148),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(823),
    [sym_compiler_directive_decl] = STATE(823),
    [sym_fsi_directive_decl] = STATE(823),
    [sym_preproc_line] = STATE(823),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [824] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(467),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(890),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(824),
    [sym_compiler_directive_decl] = STATE(824),
    [sym_fsi_directive_decl] = STATE(824),
    [sym_preproc_line] = STATE(824),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
  },
  [825] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(466),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1022),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(825),
    [sym_compiler_directive_decl] = STATE(825),
    [sym_fsi_directive_decl] = STATE(825),
    [sym_preproc_line] = STATE(825),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(3069),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(3071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
  },
  [826] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(220),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(826),
    [sym_compiler_directive_decl] = STATE(826),
    [sym_fsi_directive_decl] = STATE(826),
    [sym_preproc_line] = STATE(826),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [827] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(279),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(827),
    [sym_compiler_directive_decl] = STATE(827),
    [sym_fsi_directive_decl] = STATE(827),
    [sym_preproc_line] = STATE(827),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [828] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(206),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(828),
    [sym_compiler_directive_decl] = STATE(828),
    [sym_fsi_directive_decl] = STATE(828),
    [sym_preproc_line] = STATE(828),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
  },
  [829] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(531),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(829),
    [sym_compiler_directive_decl] = STATE(829),
    [sym_fsi_directive_decl] = STATE(829),
    [sym_preproc_line] = STATE(829),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [830] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(275),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1022),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(830),
    [sym_compiler_directive_decl] = STATE(830),
    [sym_fsi_directive_decl] = STATE(830),
    [sym_preproc_line] = STATE(830),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(3069),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(3071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
  },
  [831] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(215),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(831),
    [sym_compiler_directive_decl] = STATE(831),
    [sym_fsi_directive_decl] = STATE(831),
    [sym_preproc_line] = STATE(831),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [832] = {
    [sym_function_or_value_defn] = STATE(1163),
    [sym__expression] = STATE(44),
    [sym_literal_expression] = STATE(1715),
    [sym_long_identifier_or_op] = STATE(1715),
    [sym_tuple_expression] = STATE(1715),
    [sym_brace_expression] = STATE(1715),
    [sym_anon_record_expression] = STATE(1715),
    [sym_prefixed_expression] = STATE(1715),
    [sym_typecast_expression] = STATE(1715),
    [sym_for_expression] = STATE(1715),
    [sym_while_expression] = STATE(1715),
    [sym__if_branch] = STATE(10853),
    [sym_if_expression] = STATE(1715),
    [sym_fun_expression] = STATE(1715),
    [sym_try_expression] = STATE(1715),
    [sym_match_expression] = STATE(1715),
    [sym_function_expression] = STATE(1715),
    [sym_mutate_expression] = STATE(1715),
    [sym_index_expression] = STATE(1715),
    [sym_typed_expression] = STATE(1715),
    [sym_declaration_expression] = STATE(1715),
    [sym_do_expression] = STATE(1715),
    [sym_list_expression] = STATE(1715),
    [sym_array_expression] = STATE(1715),
    [sym_begin_end_expression] = STATE(1715),
    [sym_paren_expression] = STATE(1715),
    [sym__high_prec_app] = STATE(1728),
    [sym__low_prec_app] = STATE(1728),
    [sym_application_expression] = STATE(1715),
    [sym_dot_expression] = STATE(1715),
    [sym_infix_expression] = STATE(1715),
    [sym_ce_expression] = STATE(1715),
    [sym_sequential_expression] = STATE(1715),
    [sym_char] = STATE(1858),
    [sym_format_string] = STATE(1853),
    [sym__string_literal] = STATE(1853),
    [sym_string] = STATE(1858),
    [sym_verbatim_string] = STATE(1858),
    [sym_bytearray] = STATE(1858),
    [sym_verbatim_bytearray] = STATE(1858),
    [sym_format_triple_quoted_string] = STATE(1851),
    [sym_triple_quoted_string] = STATE(1858),
    [sym_const] = STATE(1715),
    [sym_long_identifier] = STATE(1825),
    [sym_active_pattern] = STATE(1754),
    [sym__identifier_or_op] = STATE(1822),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(940),
    [sym_sbyte] = STATE(1858),
    [sym_byte] = STATE(1858),
    [sym_int16] = STATE(1858),
    [sym_uint16] = STATE(1858),
    [sym_int32] = STATE(1858),
    [sym_uint32] = STATE(1858),
    [sym_nativeint] = STATE(1858),
    [sym_unativeint] = STATE(1858),
    [sym_int64] = STATE(1858),
    [sym_uint64] = STATE(1858),
    [sym_ieee32] = STATE(1858),
    [sym_ieee64] = STATE(1858),
    [sym_bignum] = STATE(1858),
    [sym_decimal] = STATE(1858),
    [sym_float] = STATE(1552),
    [sym_block_comment] = STATE(832),
    [sym_compiler_directive_decl] = STATE(832),
    [sym_fsi_directive_decl] = STATE(832),
    [sym_preproc_line] = STATE(832),
    [sym_preproc_if_in_expression] = STATE(1715),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_do] = ACTIONS(383),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(385),
    [anon_sym_null] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_LBRACK_PIPE] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(3159),
    [anon_sym_LT_AT] = ACTIONS(397),
    [anon_sym_LT_AT_AT] = ACTIONS(3161),
    [anon_sym_LBRACE_PIPE] = ACTIONS(403),
    [anon_sym_new] = ACTIONS(381),
    [anon_sym_return_BANG] = ACTIONS(405),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_yield_BANG] = ACTIONS(405),
    [anon_sym_lazy] = ACTIONS(381),
    [anon_sym_assert] = ACTIONS(381),
    [anon_sym_upcast] = ACTIONS(381),
    [anon_sym_downcast] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(409),
    [anon_sym_while] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(413),
    [anon_sym_try] = ACTIONS(415),
    [anon_sym_match] = ACTIONS(417),
    [anon_sym_match_BANG] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(421),
    [anon_sym_use] = ACTIONS(429),
    [anon_sym_use_BANG] = ACTIONS(431),
    [anon_sym_do_BANG] = ACTIONS(433),
    [anon_sym_begin] = ACTIONS(435),
    [aux_sym_char_token1] = ACTIONS(439),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(443),
    [anon_sym_AT_DQUOTE] = ACTIONS(445),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(447),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(449),
    [sym_bool] = ACTIONS(451),
    [sym_unit] = ACTIONS(3163),
    [anon_sym_LPAREN_PIPE] = ACTIONS(455),
    [sym_op_identifier] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(459),
    [sym_xint] = ACTIONS(461),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(463),
  },
  [833] = {
    [sym_function_or_value_defn] = STATE(1166),
    [sym__expression] = STATE(125),
    [sym_literal_expression] = STATE(2884),
    [sym_long_identifier_or_op] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_brace_expression] = STATE(2884),
    [sym_anon_record_expression] = STATE(2884),
    [sym_prefixed_expression] = STATE(2884),
    [sym_typecast_expression] = STATE(2884),
    [sym_for_expression] = STATE(2884),
    [sym_while_expression] = STATE(2884),
    [sym__if_branch] = STATE(10729),
    [sym_if_expression] = STATE(2884),
    [sym_fun_expression] = STATE(2884),
    [sym_try_expression] = STATE(2884),
    [sym_match_expression] = STATE(2884),
    [sym_function_expression] = STATE(2884),
    [sym_mutate_expression] = STATE(2884),
    [sym_index_expression] = STATE(2884),
    [sym_typed_expression] = STATE(2884),
    [sym_declaration_expression] = STATE(2884),
    [sym_do_expression] = STATE(2884),
    [sym_list_expression] = STATE(2884),
    [sym_array_expression] = STATE(2884),
    [sym_begin_end_expression] = STATE(2884),
    [sym_paren_expression] = STATE(2884),
    [sym__high_prec_app] = STATE(2872),
    [sym__low_prec_app] = STATE(2872),
    [sym_application_expression] = STATE(2884),
    [sym_dot_expression] = STATE(2884),
    [sym_infix_expression] = STATE(2884),
    [sym_ce_expression] = STATE(2884),
    [sym_sequential_expression] = STATE(2884),
    [sym_char] = STATE(2955),
    [sym_format_string] = STATE(2951),
    [sym__string_literal] = STATE(2951),
    [sym_string] = STATE(2955),
    [sym_verbatim_string] = STATE(2955),
    [sym_bytearray] = STATE(2955),
    [sym_verbatim_bytearray] = STATE(2955),
    [sym_format_triple_quoted_string] = STATE(2949),
    [sym_triple_quoted_string] = STATE(2955),
    [sym_const] = STATE(2884),
    [sym_long_identifier] = STATE(2885),
    [sym_active_pattern] = STATE(2833),
    [sym__identifier_or_op] = STATE(2883),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1002),
    [sym_sbyte] = STATE(2955),
    [sym_byte] = STATE(2955),
    [sym_int16] = STATE(2955),
    [sym_uint16] = STATE(2955),
    [sym_int32] = STATE(2955),
    [sym_uint32] = STATE(2955),
    [sym_nativeint] = STATE(2955),
    [sym_unativeint] = STATE(2955),
    [sym_int64] = STATE(2955),
    [sym_uint64] = STATE(2955),
    [sym_ieee32] = STATE(2955),
    [sym_ieee64] = STATE(2955),
    [sym_bignum] = STATE(2955),
    [sym_decimal] = STATE(2955),
    [sym_float] = STATE(2652),
    [sym_block_comment] = STATE(833),
    [sym_compiler_directive_decl] = STATE(833),
    [sym_fsi_directive_decl] = STATE(833),
    [sym_preproc_line] = STATE(833),
    [sym_preproc_if_in_expression] = STATE(2884),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_do] = ACTIONS(1003),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_null] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1013),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1015),
    [anon_sym_LBRACE] = ACTIONS(3181),
    [anon_sym_LT_AT] = ACTIONS(1019),
    [anon_sym_LT_AT_AT] = ACTIONS(3183),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1025),
    [anon_sym_new] = ACTIONS(1001),
    [anon_sym_return_BANG] = ACTIONS(1029),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_yield_BANG] = ACTIONS(1029),
    [anon_sym_lazy] = ACTIONS(1001),
    [anon_sym_assert] = ACTIONS(1001),
    [anon_sym_upcast] = ACTIONS(1001),
    [anon_sym_downcast] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1033),
    [anon_sym_while] = ACTIONS(1035),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1037),
    [anon_sym_try] = ACTIONS(1039),
    [anon_sym_match] = ACTIONS(1041),
    [anon_sym_match_BANG] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(1045),
    [anon_sym_use] = ACTIONS(1053),
    [anon_sym_use_BANG] = ACTIONS(1055),
    [anon_sym_do_BANG] = ACTIONS(1057),
    [anon_sym_begin] = ACTIONS(1059),
    [aux_sym_char_token1] = ACTIONS(1063),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1067),
    [anon_sym_AT_DQUOTE] = ACTIONS(1069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1073),
    [sym_bool] = ACTIONS(1075),
    [sym_unit] = ACTIONS(3185),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1079),
    [sym_op_identifier] = ACTIONS(3187),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1083),
    [sym_xint] = ACTIONS(1085),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1087),
  },
  [834] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(222),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(887),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(834),
    [sym_compiler_directive_decl] = STATE(834),
    [sym_fsi_directive_decl] = STATE(834),
    [sym_preproc_line] = STATE(834),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [835] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(449),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(835),
    [sym_compiler_directive_decl] = STATE(835),
    [sym_fsi_directive_decl] = STATE(835),
    [sym_preproc_line] = STATE(835),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [836] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(263),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(836),
    [sym_compiler_directive_decl] = STATE(836),
    [sym_fsi_directive_decl] = STATE(836),
    [sym_preproc_line] = STATE(836),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [837] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(211),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(837),
    [sym_compiler_directive_decl] = STATE(837),
    [sym_fsi_directive_decl] = STATE(837),
    [sym_preproc_line] = STATE(837),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [838] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(150),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(838),
    [sym_compiler_directive_decl] = STATE(838),
    [sym_fsi_directive_decl] = STATE(838),
    [sym_preproc_line] = STATE(838),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [839] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(339),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(890),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(839),
    [sym_compiler_directive_decl] = STATE(839),
    [sym_fsi_directive_decl] = STATE(839),
    [sym_preproc_line] = STATE(839),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
  },
  [840] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(345),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1022),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(840),
    [sym_compiler_directive_decl] = STATE(840),
    [sym_fsi_directive_decl] = STATE(840),
    [sym_preproc_line] = STATE(840),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(3069),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(3071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
  },
  [841] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(352),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(841),
    [sym_compiler_directive_decl] = STATE(841),
    [sym_fsi_directive_decl] = STATE(841),
    [sym_preproc_line] = STATE(841),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [842] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(210),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(842),
    [sym_compiler_directive_decl] = STATE(842),
    [sym_fsi_directive_decl] = STATE(842),
    [sym_preproc_line] = STATE(842),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [843] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(205),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(843),
    [sym_compiler_directive_decl] = STATE(843),
    [sym_fsi_directive_decl] = STATE(843),
    [sym_preproc_line] = STATE(843),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [844] = {
    [sym_function_or_value_defn] = STATE(1180),
    [sym__expression] = STATE(244),
    [sym_literal_expression] = STATE(3145),
    [sym_long_identifier_or_op] = STATE(3145),
    [sym_tuple_expression] = STATE(3145),
    [sym_brace_expression] = STATE(3145),
    [sym_anon_record_expression] = STATE(3145),
    [sym_prefixed_expression] = STATE(3145),
    [sym_typecast_expression] = STATE(3145),
    [sym_for_expression] = STATE(3145),
    [sym_while_expression] = STATE(3145),
    [sym__if_branch] = STATE(10360),
    [sym_if_expression] = STATE(3145),
    [sym_fun_expression] = STATE(3145),
    [sym_try_expression] = STATE(3145),
    [sym_match_expression] = STATE(3145),
    [sym_function_expression] = STATE(3145),
    [sym_mutate_expression] = STATE(3145),
    [sym_index_expression] = STATE(3145),
    [sym_typed_expression] = STATE(3145),
    [sym_declaration_expression] = STATE(3145),
    [sym_do_expression] = STATE(3145),
    [sym_list_expression] = STATE(3145),
    [sym_array_expression] = STATE(3145),
    [sym_begin_end_expression] = STATE(3145),
    [sym_paren_expression] = STATE(3145),
    [sym__high_prec_app] = STATE(3141),
    [sym__low_prec_app] = STATE(3141),
    [sym_application_expression] = STATE(3145),
    [sym_dot_expression] = STATE(3145),
    [sym_infix_expression] = STATE(3145),
    [sym_ce_expression] = STATE(3145),
    [sym_sequential_expression] = STATE(3145),
    [sym_char] = STATE(3108),
    [sym_format_string] = STATE(3193),
    [sym__string_literal] = STATE(3193),
    [sym_string] = STATE(3108),
    [sym_verbatim_string] = STATE(3108),
    [sym_bytearray] = STATE(3108),
    [sym_verbatim_bytearray] = STATE(3108),
    [sym_format_triple_quoted_string] = STATE(3192),
    [sym_triple_quoted_string] = STATE(3108),
    [sym_const] = STATE(3145),
    [sym_long_identifier] = STATE(3102),
    [sym_active_pattern] = STATE(3172),
    [sym__identifier_or_op] = STATE(3103),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1149),
    [sym_sbyte] = STATE(3108),
    [sym_byte] = STATE(3108),
    [sym_int16] = STATE(3108),
    [sym_uint16] = STATE(3108),
    [sym_int32] = STATE(3108),
    [sym_uint32] = STATE(3108),
    [sym_nativeint] = STATE(3108),
    [sym_unativeint] = STATE(3108),
    [sym_int64] = STATE(3108),
    [sym_uint64] = STATE(3108),
    [sym_ieee32] = STATE(3108),
    [sym_ieee64] = STATE(3108),
    [sym_bignum] = STATE(3108),
    [sym_decimal] = STATE(3108),
    [sym_float] = STATE(2770),
    [sym_block_comment] = STATE(844),
    [sym_compiler_directive_decl] = STATE(844),
    [sym_fsi_directive_decl] = STATE(844),
    [sym_preproc_line] = STATE(844),
    [sym_preproc_if_in_expression] = STATE(3145),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_return] = ACTIONS(1119),
    [anon_sym_do] = ACTIONS(1121),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_null] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1131),
    [anon_sym_LBRACE] = ACTIONS(3169),
    [anon_sym_LT_AT] = ACTIONS(1135),
    [anon_sym_LT_AT_AT] = ACTIONS(3171),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1141),
    [anon_sym_new] = ACTIONS(1119),
    [anon_sym_return_BANG] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1119),
    [anon_sym_yield_BANG] = ACTIONS(1143),
    [anon_sym_lazy] = ACTIONS(1119),
    [anon_sym_assert] = ACTIONS(1119),
    [anon_sym_upcast] = ACTIONS(1119),
    [anon_sym_downcast] = ACTIONS(1119),
    [anon_sym_for] = ACTIONS(1147),
    [anon_sym_while] = ACTIONS(1149),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1151),
    [anon_sym_try] = ACTIONS(1153),
    [anon_sym_match] = ACTIONS(1155),
    [anon_sym_match_BANG] = ACTIONS(1157),
    [anon_sym_function] = ACTIONS(1159),
    [anon_sym_use] = ACTIONS(1167),
    [anon_sym_use_BANG] = ACTIONS(1169),
    [anon_sym_do_BANG] = ACTIONS(1171),
    [anon_sym_begin] = ACTIONS(1173),
    [aux_sym_char_token1] = ACTIONS(1177),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(1181),
    [anon_sym_AT_DQUOTE] = ACTIONS(1183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1185),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1187),
    [sym_bool] = ACTIONS(1189),
    [sym_unit] = ACTIONS(3173),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1193),
    [sym_op_identifier] = ACTIONS(3175),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1197),
    [sym_xint] = ACTIONS(1199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1201),
  },
  [845] = {
    [sym_function_or_value_defn] = STATE(845),
    [sym__expression] = STATE(177),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(776),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(845),
    [sym_compiler_directive_decl] = STATE(845),
    [sym_fsi_directive_decl] = STATE(845),
    [sym_preproc_line] = STATE(845),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1203),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1203),
    [anon_sym_return_BANG] = ACTIONS(1207),
    [anon_sym_yield] = ACTIONS(1203),
    [anon_sym_yield_BANG] = ACTIONS(1207),
    [anon_sym_lazy] = ACTIONS(1203),
    [anon_sym_assert] = ACTIONS(1203),
    [anon_sym_upcast] = ACTIONS(1203),
    [anon_sym_downcast] = ACTIONS(1203),
    [anon_sym_for] = ACTIONS(1209),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1213),
    [anon_sym_use_BANG] = ACTIONS(1215),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1219),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [846] = {
    [sym_function_or_value_defn] = STATE(760),
    [sym__expression] = STATE(19),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(956),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(846),
    [sym_compiler_directive_decl] = STATE(846),
    [sym_fsi_directive_decl] = STATE(846),
    [sym_preproc_line] = STATE(846),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_return] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(269),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(269),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(269),
    [anon_sym_assert] = ACTIONS(269),
    [anon_sym_upcast] = ACTIONS(269),
    [anon_sym_downcast] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(277),
    [anon_sym_use_BANG] = ACTIONS(279),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(281),
    [sym_xint] = ACTIONS(283),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
  },
  [847] = {
    [sym_function_or_value_defn] = STATE(1163),
    [sym__expression] = STATE(35),
    [sym_literal_expression] = STATE(1715),
    [sym_long_identifier_or_op] = STATE(1715),
    [sym_tuple_expression] = STATE(1715),
    [sym_brace_expression] = STATE(1715),
    [sym_anon_record_expression] = STATE(1715),
    [sym_prefixed_expression] = STATE(1715),
    [sym_typecast_expression] = STATE(1715),
    [sym_for_expression] = STATE(1715),
    [sym_while_expression] = STATE(1715),
    [sym__if_branch] = STATE(10853),
    [sym_if_expression] = STATE(1715),
    [sym_fun_expression] = STATE(1715),
    [sym_try_expression] = STATE(1715),
    [sym_match_expression] = STATE(1715),
    [sym_function_expression] = STATE(1715),
    [sym_mutate_expression] = STATE(1715),
    [sym_index_expression] = STATE(1715),
    [sym_typed_expression] = STATE(1715),
    [sym_declaration_expression] = STATE(1715),
    [sym_do_expression] = STATE(1715),
    [sym_list_expression] = STATE(1715),
    [sym_array_expression] = STATE(1715),
    [sym_begin_end_expression] = STATE(1715),
    [sym_paren_expression] = STATE(1715),
    [sym__high_prec_app] = STATE(1728),
    [sym__low_prec_app] = STATE(1728),
    [sym_application_expression] = STATE(1715),
    [sym_dot_expression] = STATE(1715),
    [sym_infix_expression] = STATE(1715),
    [sym_ce_expression] = STATE(1715),
    [sym_sequential_expression] = STATE(1715),
    [sym_char] = STATE(1858),
    [sym_format_string] = STATE(1853),
    [sym__string_literal] = STATE(1853),
    [sym_string] = STATE(1858),
    [sym_verbatim_string] = STATE(1858),
    [sym_bytearray] = STATE(1858),
    [sym_verbatim_bytearray] = STATE(1858),
    [sym_format_triple_quoted_string] = STATE(1851),
    [sym_triple_quoted_string] = STATE(1858),
    [sym_const] = STATE(1715),
    [sym_long_identifier] = STATE(1825),
    [sym_active_pattern] = STATE(1754),
    [sym__identifier_or_op] = STATE(1822),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(940),
    [sym_sbyte] = STATE(1858),
    [sym_byte] = STATE(1858),
    [sym_int16] = STATE(1858),
    [sym_uint16] = STATE(1858),
    [sym_int32] = STATE(1858),
    [sym_uint32] = STATE(1858),
    [sym_nativeint] = STATE(1858),
    [sym_unativeint] = STATE(1858),
    [sym_int64] = STATE(1858),
    [sym_uint64] = STATE(1858),
    [sym_ieee32] = STATE(1858),
    [sym_ieee64] = STATE(1858),
    [sym_bignum] = STATE(1858),
    [sym_decimal] = STATE(1858),
    [sym_float] = STATE(1552),
    [sym_block_comment] = STATE(847),
    [sym_compiler_directive_decl] = STATE(847),
    [sym_fsi_directive_decl] = STATE(847),
    [sym_preproc_line] = STATE(847),
    [sym_preproc_if_in_expression] = STATE(1715),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_do] = ACTIONS(383),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(385),
    [anon_sym_null] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_LBRACK_PIPE] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(3159),
    [anon_sym_LT_AT] = ACTIONS(397),
    [anon_sym_LT_AT_AT] = ACTIONS(3161),
    [anon_sym_LBRACE_PIPE] = ACTIONS(403),
    [anon_sym_new] = ACTIONS(381),
    [anon_sym_return_BANG] = ACTIONS(405),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_yield_BANG] = ACTIONS(405),
    [anon_sym_lazy] = ACTIONS(381),
    [anon_sym_assert] = ACTIONS(381),
    [anon_sym_upcast] = ACTIONS(381),
    [anon_sym_downcast] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(409),
    [anon_sym_while] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(413),
    [anon_sym_try] = ACTIONS(415),
    [anon_sym_match] = ACTIONS(417),
    [anon_sym_match_BANG] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(421),
    [anon_sym_use] = ACTIONS(429),
    [anon_sym_use_BANG] = ACTIONS(431),
    [anon_sym_do_BANG] = ACTIONS(433),
    [anon_sym_begin] = ACTIONS(435),
    [aux_sym_char_token1] = ACTIONS(439),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(443),
    [anon_sym_AT_DQUOTE] = ACTIONS(445),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(447),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(449),
    [sym_bool] = ACTIONS(451),
    [sym_unit] = ACTIONS(3163),
    [anon_sym_LPAREN_PIPE] = ACTIONS(455),
    [sym_op_identifier] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(459),
    [sym_xint] = ACTIONS(461),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(463),
  },
  [848] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(202),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(848),
    [sym_compiler_directive_decl] = STATE(848),
    [sym_fsi_directive_decl] = STATE(848),
    [sym_preproc_line] = STATE(848),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [849] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(200),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(849),
    [sym_compiler_directive_decl] = STATE(849),
    [sym_fsi_directive_decl] = STATE(849),
    [sym_preproc_line] = STATE(849),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [850] = {
    [sym_function_or_value_defn] = STATE(850),
    [sym__expression] = STATE(12),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(949),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(850),
    [sym_compiler_directive_decl] = STATE(850),
    [sym_fsi_directive_decl] = STATE(850),
    [sym_preproc_line] = STATE(850),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(129),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(129),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(129),
    [anon_sym_assert] = ACTIONS(129),
    [anon_sym_upcast] = ACTIONS(129),
    [anon_sym_downcast] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(215),
    [sym_xint] = ACTIONS(217),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
  },
  [851] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(296),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(851),
    [sym_compiler_directive_decl] = STATE(851),
    [sym_fsi_directive_decl] = STATE(851),
    [sym_preproc_line] = STATE(851),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [852] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(198),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(852),
    [sym_compiler_directive_decl] = STATE(852),
    [sym_fsi_directive_decl] = STATE(852),
    [sym_preproc_line] = STATE(852),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [853] = {
    [sym_function_or_value_defn] = STATE(850),
    [sym__expression] = STATE(11),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(949),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(853),
    [sym_compiler_directive_decl] = STATE(853),
    [sym_fsi_directive_decl] = STATE(853),
    [sym_preproc_line] = STATE(853),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(129),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(129),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(129),
    [anon_sym_assert] = ACTIONS(129),
    [anon_sym_upcast] = ACTIONS(129),
    [anon_sym_downcast] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(215),
    [sym_xint] = ACTIONS(217),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
  },
  [854] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(297),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1022),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(854),
    [sym_compiler_directive_decl] = STATE(854),
    [sym_fsi_directive_decl] = STATE(854),
    [sym_preproc_line] = STATE(854),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(3069),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(3071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
  },
  [855] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(300),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(890),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(855),
    [sym_compiler_directive_decl] = STATE(855),
    [sym_fsi_directive_decl] = STATE(855),
    [sym_preproc_line] = STATE(855),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
  },
  [856] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(242),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(856),
    [sym_compiler_directive_decl] = STATE(856),
    [sym_fsi_directive_decl] = STATE(856),
    [sym_preproc_line] = STATE(856),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [857] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(192),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(857),
    [sym_compiler_directive_decl] = STATE(857),
    [sym_fsi_directive_decl] = STATE(857),
    [sym_preproc_line] = STATE(857),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [858] = {
    [sym_function_or_value_defn] = STATE(845),
    [sym__expression] = STATE(169),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(776),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(858),
    [sym_compiler_directive_decl] = STATE(858),
    [sym_fsi_directive_decl] = STATE(858),
    [sym_preproc_line] = STATE(858),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1203),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1203),
    [anon_sym_return_BANG] = ACTIONS(1207),
    [anon_sym_yield] = ACTIONS(1203),
    [anon_sym_yield_BANG] = ACTIONS(1207),
    [anon_sym_lazy] = ACTIONS(1203),
    [anon_sym_assert] = ACTIONS(1203),
    [anon_sym_upcast] = ACTIONS(1203),
    [anon_sym_downcast] = ACTIONS(1203),
    [anon_sym_for] = ACTIONS(1209),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1213),
    [anon_sym_use_BANG] = ACTIONS(1215),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1219),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [859] = {
    [sym_function_or_value_defn] = STATE(783),
    [sym__expression] = STATE(272),
    [sym_literal_expression] = STATE(3553),
    [sym_long_identifier_or_op] = STATE(3553),
    [sym_tuple_expression] = STATE(3553),
    [sym_brace_expression] = STATE(3553),
    [sym_anon_record_expression] = STATE(3553),
    [sym_prefixed_expression] = STATE(3553),
    [sym_typecast_expression] = STATE(3553),
    [sym_for_expression] = STATE(3553),
    [sym_while_expression] = STATE(3553),
    [sym__if_branch] = STATE(10567),
    [sym_if_expression] = STATE(3553),
    [sym_fun_expression] = STATE(3553),
    [sym_try_expression] = STATE(3553),
    [sym_match_expression] = STATE(3553),
    [sym_function_expression] = STATE(3553),
    [sym_mutate_expression] = STATE(3553),
    [sym_index_expression] = STATE(3553),
    [sym_typed_expression] = STATE(3553),
    [sym_declaration_expression] = STATE(3553),
    [sym_do_expression] = STATE(3553),
    [sym_list_expression] = STATE(3553),
    [sym_array_expression] = STATE(3553),
    [sym_begin_end_expression] = STATE(3553),
    [sym_paren_expression] = STATE(3553),
    [sym__high_prec_app] = STATE(3532),
    [sym__low_prec_app] = STATE(3532),
    [sym_application_expression] = STATE(3553),
    [sym_dot_expression] = STATE(3553),
    [sym_infix_expression] = STATE(3553),
    [sym_ce_expression] = STATE(3553),
    [sym_sequential_expression] = STATE(3553),
    [sym_char] = STATE(3265),
    [sym_format_string] = STATE(3261),
    [sym__string_literal] = STATE(3261),
    [sym_string] = STATE(3265),
    [sym_verbatim_string] = STATE(3265),
    [sym_bytearray] = STATE(3265),
    [sym_verbatim_bytearray] = STATE(3265),
    [sym_format_triple_quoted_string] = STATE(3260),
    [sym_triple_quoted_string] = STATE(3265),
    [sym_const] = STATE(3553),
    [sym_long_identifier] = STATE(3203),
    [sym_active_pattern] = STATE(3576),
    [sym__identifier_or_op] = STATE(3362),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1076),
    [sym_sbyte] = STATE(3265),
    [sym_byte] = STATE(3265),
    [sym_int16] = STATE(3265),
    [sym_uint16] = STATE(3265),
    [sym_int32] = STATE(3265),
    [sym_uint32] = STATE(3265),
    [sym_nativeint] = STATE(3265),
    [sym_unativeint] = STATE(3265),
    [sym_int64] = STATE(3265),
    [sym_uint64] = STATE(3265),
    [sym_ieee32] = STATE(3265),
    [sym_ieee64] = STATE(3265),
    [sym_bignum] = STATE(3265),
    [sym_decimal] = STATE(3265),
    [sym_float] = STATE(2797),
    [sym_block_comment] = STATE(859),
    [sym_compiler_directive_decl] = STATE(859),
    [sym_fsi_directive_decl] = STATE(859),
    [sym_preproc_line] = STATE(859),
    [sym_preproc_if_in_expression] = STATE(3553),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1632),
    [anon_sym_return] = ACTIONS(1636),
    [anon_sym_do] = ACTIONS(1638),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1640),
    [anon_sym_null] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1646),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_LT_AT] = ACTIONS(1652),
    [anon_sym_LT_AT_AT] = ACTIONS(3021),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1658),
    [anon_sym_new] = ACTIONS(1636),
    [anon_sym_return_BANG] = ACTIONS(1660),
    [anon_sym_yield] = ACTIONS(1636),
    [anon_sym_yield_BANG] = ACTIONS(1660),
    [anon_sym_lazy] = ACTIONS(1636),
    [anon_sym_assert] = ACTIONS(1636),
    [anon_sym_upcast] = ACTIONS(1636),
    [anon_sym_downcast] = ACTIONS(1636),
    [anon_sym_for] = ACTIONS(1664),
    [anon_sym_while] = ACTIONS(1666),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1668),
    [anon_sym_try] = ACTIONS(1670),
    [anon_sym_match] = ACTIONS(1672),
    [anon_sym_match_BANG] = ACTIONS(1674),
    [anon_sym_function] = ACTIONS(1676),
    [anon_sym_use] = ACTIONS(1684),
    [anon_sym_use_BANG] = ACTIONS(1686),
    [anon_sym_do_BANG] = ACTIONS(1688),
    [anon_sym_begin] = ACTIONS(1690),
    [aux_sym_char_token1] = ACTIONS(1694),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1696),
    [anon_sym_DQUOTE] = ACTIONS(1698),
    [anon_sym_AT_DQUOTE] = ACTIONS(1700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1704),
    [sym_bool] = ACTIONS(1706),
    [sym_unit] = ACTIONS(3023),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1710),
    [sym_op_identifier] = ACTIONS(3025),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1714),
    [sym_xint] = ACTIONS(1716),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1718),
  },
  [860] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(370),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(890),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(860),
    [sym_compiler_directive_decl] = STATE(860),
    [sym_fsi_directive_decl] = STATE(860),
    [sym_preproc_line] = STATE(860),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
  },
  [861] = {
    [sym_function_or_value_defn] = STATE(972),
    [sym__expression] = STATE(184),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(978),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(861),
    [sym_compiler_directive_decl] = STATE(861),
    [sym_fsi_directive_decl] = STATE(861),
    [sym_preproc_line] = STATE(861),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1302),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1302),
    [anon_sym_return_BANG] = ACTIONS(1326),
    [anon_sym_yield] = ACTIONS(1302),
    [anon_sym_yield_BANG] = ACTIONS(1326),
    [anon_sym_lazy] = ACTIONS(1302),
    [anon_sym_assert] = ACTIONS(1302),
    [anon_sym_upcast] = ACTIONS(1302),
    [anon_sym_downcast] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1330),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1352),
    [anon_sym_use_BANG] = ACTIONS(1354),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1384),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [862] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(374),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1022),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(862),
    [sym_compiler_directive_decl] = STATE(862),
    [sym_fsi_directive_decl] = STATE(862),
    [sym_preproc_line] = STATE(862),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(3069),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(3071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
  },
  [863] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(376),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(863),
    [sym_compiler_directive_decl] = STATE(863),
    [sym_fsi_directive_decl] = STATE(863),
    [sym_preproc_line] = STATE(863),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [864] = {
    [sym_function_or_value_defn] = STATE(850),
    [sym__expression] = STATE(9),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(949),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(864),
    [sym_compiler_directive_decl] = STATE(864),
    [sym_fsi_directive_decl] = STATE(864),
    [sym_preproc_line] = STATE(864),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(129),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(129),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(129),
    [anon_sym_assert] = ACTIONS(129),
    [anon_sym_upcast] = ACTIONS(129),
    [anon_sym_downcast] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(215),
    [sym_xint] = ACTIONS(217),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
  },
  [865] = {
    [sym_function_or_value_defn] = STATE(845),
    [sym__expression] = STATE(153),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(776),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(865),
    [sym_compiler_directive_decl] = STATE(865),
    [sym_fsi_directive_decl] = STATE(865),
    [sym_preproc_line] = STATE(865),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1203),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1203),
    [anon_sym_return_BANG] = ACTIONS(1207),
    [anon_sym_yield] = ACTIONS(1203),
    [anon_sym_yield_BANG] = ACTIONS(1207),
    [anon_sym_lazy] = ACTIONS(1203),
    [anon_sym_assert] = ACTIONS(1203),
    [anon_sym_upcast] = ACTIONS(1203),
    [anon_sym_downcast] = ACTIONS(1203),
    [anon_sym_for] = ACTIONS(1209),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1213),
    [anon_sym_use_BANG] = ACTIONS(1215),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1219),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [866] = {
    [sym_function_or_value_defn] = STATE(866),
    [sym__expression] = STATE(98),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1178),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(866),
    [sym_compiler_directive_decl] = STATE(866),
    [sym_fsi_directive_decl] = STATE(866),
    [sym_preproc_line] = STATE(866),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(857),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(53),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(857),
    [anon_sym_return_BANG] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(857),
    [anon_sym_yield_BANG] = ACTIONS(869),
    [anon_sym_lazy] = ACTIONS(857),
    [anon_sym_assert] = ACTIONS(857),
    [anon_sym_upcast] = ACTIONS(857),
    [anon_sym_downcast] = ACTIONS(857),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(879),
    [anon_sym_use_BANG] = ACTIONS(881),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(99),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(889),
    [sym_xint] = ACTIONS(891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
  },
  [867] = {
    [sym_function_or_value_defn] = STATE(845),
    [sym__expression] = STATE(196),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(776),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(867),
    [sym_compiler_directive_decl] = STATE(867),
    [sym_fsi_directive_decl] = STATE(867),
    [sym_preproc_line] = STATE(867),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1203),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1203),
    [anon_sym_return_BANG] = ACTIONS(1207),
    [anon_sym_yield] = ACTIONS(1203),
    [anon_sym_yield_BANG] = ACTIONS(1207),
    [anon_sym_lazy] = ACTIONS(1203),
    [anon_sym_assert] = ACTIONS(1203),
    [anon_sym_upcast] = ACTIONS(1203),
    [anon_sym_downcast] = ACTIONS(1203),
    [anon_sym_for] = ACTIONS(1209),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1213),
    [anon_sym_use_BANG] = ACTIONS(1215),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1219),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [868] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(393),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(890),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(868),
    [sym_compiler_directive_decl] = STATE(868),
    [sym_fsi_directive_decl] = STATE(868),
    [sym_preproc_line] = STATE(868),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
  },
  [869] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(397),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1022),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(869),
    [sym_compiler_directive_decl] = STATE(869),
    [sym_fsi_directive_decl] = STATE(869),
    [sym_preproc_line] = STATE(869),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(3069),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(3071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
  },
  [870] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(399),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(870),
    [sym_compiler_directive_decl] = STATE(870),
    [sym_fsi_directive_decl] = STATE(870),
    [sym_preproc_line] = STATE(870),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [871] = {
    [sym_function_or_value_defn] = STATE(850),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(949),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(871),
    [sym_compiler_directive_decl] = STATE(871),
    [sym_fsi_directive_decl] = STATE(871),
    [sym_preproc_line] = STATE(871),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(129),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(129),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(129),
    [anon_sym_assert] = ACTIONS(129),
    [anon_sym_upcast] = ACTIONS(129),
    [anon_sym_downcast] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(215),
    [sym_xint] = ACTIONS(217),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
  },
  [872] = {
    [sym_function_or_value_defn] = STATE(850),
    [sym__expression] = STATE(7),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(949),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(872),
    [sym_compiler_directive_decl] = STATE(872),
    [sym_fsi_directive_decl] = STATE(872),
    [sym_preproc_line] = STATE(872),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(129),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(129),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(129),
    [anon_sym_assert] = ACTIONS(129),
    [anon_sym_upcast] = ACTIONS(129),
    [anon_sym_downcast] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(215),
    [sym_xint] = ACTIONS(217),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
  },
  [873] = {
    [sym_function_or_value_defn] = STATE(845),
    [sym__expression] = STATE(151),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(776),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(873),
    [sym_compiler_directive_decl] = STATE(873),
    [sym_fsi_directive_decl] = STATE(873),
    [sym_preproc_line] = STATE(873),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1203),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1203),
    [anon_sym_return_BANG] = ACTIONS(1207),
    [anon_sym_yield] = ACTIONS(1203),
    [anon_sym_yield_BANG] = ACTIONS(1207),
    [anon_sym_lazy] = ACTIONS(1203),
    [anon_sym_assert] = ACTIONS(1203),
    [anon_sym_upcast] = ACTIONS(1203),
    [anon_sym_downcast] = ACTIONS(1203),
    [anon_sym_for] = ACTIONS(1209),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1213),
    [anon_sym_use_BANG] = ACTIONS(1215),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1219),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [874] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(418),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(890),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(874),
    [sym_compiler_directive_decl] = STATE(874),
    [sym_fsi_directive_decl] = STATE(874),
    [sym_preproc_line] = STATE(874),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
  },
  [875] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(419),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1022),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(875),
    [sym_compiler_directive_decl] = STATE(875),
    [sym_fsi_directive_decl] = STATE(875),
    [sym_preproc_line] = STATE(875),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(3069),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(3071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
  },
  [876] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(420),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(876),
    [sym_compiler_directive_decl] = STATE(876),
    [sym_fsi_directive_decl] = STATE(876),
    [sym_preproc_line] = STATE(876),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [877] = {
    [sym_function_or_value_defn] = STATE(845),
    [sym__expression] = STATE(149),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(776),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(877),
    [sym_compiler_directive_decl] = STATE(877),
    [sym_fsi_directive_decl] = STATE(877),
    [sym_preproc_line] = STATE(877),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1203),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1203),
    [anon_sym_return_BANG] = ACTIONS(1207),
    [anon_sym_yield] = ACTIONS(1203),
    [anon_sym_yield_BANG] = ACTIONS(1207),
    [anon_sym_lazy] = ACTIONS(1203),
    [anon_sym_assert] = ACTIONS(1203),
    [anon_sym_upcast] = ACTIONS(1203),
    [anon_sym_downcast] = ACTIONS(1203),
    [anon_sym_for] = ACTIONS(1209),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1213),
    [anon_sym_use_BANG] = ACTIONS(1215),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1219),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [878] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(416),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1045),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(878),
    [sym_compiler_directive_decl] = STATE(878),
    [sym_fsi_directive_decl] = STATE(878),
    [sym_preproc_line] = STATE(878),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [879] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(190),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(879),
    [sym_compiler_directive_decl] = STATE(879),
    [sym_fsi_directive_decl] = STATE(879),
    [sym_preproc_line] = STATE(879),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [880] = {
    [sym_function_or_value_defn] = STATE(850),
    [sym__expression] = STATE(5),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(949),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(880),
    [sym_compiler_directive_decl] = STATE(880),
    [sym_fsi_directive_decl] = STATE(880),
    [sym_preproc_line] = STATE(880),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(129),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(129),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(129),
    [anon_sym_assert] = ACTIONS(129),
    [anon_sym_upcast] = ACTIONS(129),
    [anon_sym_downcast] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(215),
    [sym_xint] = ACTIONS(217),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
  },
  [881] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(429),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(890),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(881),
    [sym_compiler_directive_decl] = STATE(881),
    [sym_fsi_directive_decl] = STATE(881),
    [sym_preproc_line] = STATE(881),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
  },
  [882] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(430),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1022),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(882),
    [sym_compiler_directive_decl] = STATE(882),
    [sym_fsi_directive_decl] = STATE(882),
    [sym_preproc_line] = STATE(882),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(3069),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(3071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
  },
  [883] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(431),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(883),
    [sym_compiler_directive_decl] = STATE(883),
    [sym_fsi_directive_decl] = STATE(883),
    [sym_preproc_line] = STATE(883),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [884] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(505),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1045),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(884),
    [sym_compiler_directive_decl] = STATE(884),
    [sym_fsi_directive_decl] = STATE(884),
    [sym_preproc_line] = STATE(884),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [885] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(498),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1045),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(885),
    [sym_compiler_directive_decl] = STATE(885),
    [sym_fsi_directive_decl] = STATE(885),
    [sym_preproc_line] = STATE(885),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [886] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(314),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1045),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(886),
    [sym_compiler_directive_decl] = STATE(886),
    [sym_fsi_directive_decl] = STATE(886),
    [sym_preproc_line] = STATE(886),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [887] = {
    [sym_function_or_value_defn] = STATE(784),
    [sym__expression] = STATE(168),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(887),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(887),
    [sym_compiler_directive_decl] = STATE(887),
    [sym_fsi_directive_decl] = STATE(887),
    [sym_preproc_line] = STATE(887),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_return_BANG] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1236),
    [anon_sym_yield_BANG] = ACTIONS(1240),
    [anon_sym_lazy] = ACTIONS(1236),
    [anon_sym_assert] = ACTIONS(1236),
    [anon_sym_upcast] = ACTIONS(1236),
    [anon_sym_downcast] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_use_BANG] = ACTIONS(1248),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1250),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [888] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(428),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1045),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(888),
    [sym_compiler_directive_decl] = STATE(888),
    [sym_fsi_directive_decl] = STATE(888),
    [sym_preproc_line] = STATE(888),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [889] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(203),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(889),
    [sym_compiler_directive_decl] = STATE(889),
    [sym_fsi_directive_decl] = STATE(889),
    [sym_preproc_line] = STATE(889),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
  },
  [890] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(380),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(890),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(890),
    [sym_compiler_directive_decl] = STATE(890),
    [sym_fsi_directive_decl] = STATE(890),
    [sym_preproc_line] = STATE(890),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
  },
  [891] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(282),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1022),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(891),
    [sym_compiler_directive_decl] = STATE(891),
    [sym_fsi_directive_decl] = STATE(891),
    [sym_preproc_line] = STATE(891),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(3069),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(3071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
  },
  [892] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(443),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(892),
    [sym_compiler_directive_decl] = STATE(892),
    [sym_fsi_directive_decl] = STATE(892),
    [sym_preproc_line] = STATE(892),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [893] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(284),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1022),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(893),
    [sym_compiler_directive_decl] = STATE(893),
    [sym_fsi_directive_decl] = STATE(893),
    [sym_preproc_line] = STATE(893),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(3069),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(3071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
  },
  [894] = {
    [sym_function_or_value_defn] = STATE(1180),
    [sym__expression] = STATE(129),
    [sym_literal_expression] = STATE(3145),
    [sym_long_identifier_or_op] = STATE(3145),
    [sym_tuple_expression] = STATE(3145),
    [sym_brace_expression] = STATE(3145),
    [sym_anon_record_expression] = STATE(3145),
    [sym_prefixed_expression] = STATE(3145),
    [sym_typecast_expression] = STATE(3145),
    [sym_for_expression] = STATE(3145),
    [sym_while_expression] = STATE(3145),
    [sym__if_branch] = STATE(10360),
    [sym_if_expression] = STATE(3145),
    [sym_fun_expression] = STATE(3145),
    [sym_try_expression] = STATE(3145),
    [sym_match_expression] = STATE(3145),
    [sym_function_expression] = STATE(3145),
    [sym_mutate_expression] = STATE(3145),
    [sym_index_expression] = STATE(3145),
    [sym_typed_expression] = STATE(3145),
    [sym_declaration_expression] = STATE(3145),
    [sym_do_expression] = STATE(3145),
    [sym_list_expression] = STATE(3145),
    [sym_array_expression] = STATE(3145),
    [sym_begin_end_expression] = STATE(3145),
    [sym_paren_expression] = STATE(3145),
    [sym__high_prec_app] = STATE(3141),
    [sym__low_prec_app] = STATE(3141),
    [sym_application_expression] = STATE(3145),
    [sym_dot_expression] = STATE(3145),
    [sym_infix_expression] = STATE(3145),
    [sym_ce_expression] = STATE(3145),
    [sym_sequential_expression] = STATE(3145),
    [sym_char] = STATE(3108),
    [sym_format_string] = STATE(3193),
    [sym__string_literal] = STATE(3193),
    [sym_string] = STATE(3108),
    [sym_verbatim_string] = STATE(3108),
    [sym_bytearray] = STATE(3108),
    [sym_verbatim_bytearray] = STATE(3108),
    [sym_format_triple_quoted_string] = STATE(3192),
    [sym_triple_quoted_string] = STATE(3108),
    [sym_const] = STATE(3145),
    [sym_long_identifier] = STATE(3102),
    [sym_active_pattern] = STATE(3172),
    [sym__identifier_or_op] = STATE(3103),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1149),
    [sym_sbyte] = STATE(3108),
    [sym_byte] = STATE(3108),
    [sym_int16] = STATE(3108),
    [sym_uint16] = STATE(3108),
    [sym_int32] = STATE(3108),
    [sym_uint32] = STATE(3108),
    [sym_nativeint] = STATE(3108),
    [sym_unativeint] = STATE(3108),
    [sym_int64] = STATE(3108),
    [sym_uint64] = STATE(3108),
    [sym_ieee32] = STATE(3108),
    [sym_ieee64] = STATE(3108),
    [sym_bignum] = STATE(3108),
    [sym_decimal] = STATE(3108),
    [sym_float] = STATE(2770),
    [sym_block_comment] = STATE(894),
    [sym_compiler_directive_decl] = STATE(894),
    [sym_fsi_directive_decl] = STATE(894),
    [sym_preproc_line] = STATE(894),
    [sym_preproc_if_in_expression] = STATE(3145),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_return] = ACTIONS(1119),
    [anon_sym_do] = ACTIONS(1121),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_null] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1131),
    [anon_sym_LBRACE] = ACTIONS(3169),
    [anon_sym_LT_AT] = ACTIONS(1135),
    [anon_sym_LT_AT_AT] = ACTIONS(3171),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1141),
    [anon_sym_new] = ACTIONS(1119),
    [anon_sym_return_BANG] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1119),
    [anon_sym_yield_BANG] = ACTIONS(1143),
    [anon_sym_lazy] = ACTIONS(1119),
    [anon_sym_assert] = ACTIONS(1119),
    [anon_sym_upcast] = ACTIONS(1119),
    [anon_sym_downcast] = ACTIONS(1119),
    [anon_sym_for] = ACTIONS(1147),
    [anon_sym_while] = ACTIONS(1149),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1151),
    [anon_sym_try] = ACTIONS(1153),
    [anon_sym_match] = ACTIONS(1155),
    [anon_sym_match_BANG] = ACTIONS(1157),
    [anon_sym_function] = ACTIONS(1159),
    [anon_sym_use] = ACTIONS(1167),
    [anon_sym_use_BANG] = ACTIONS(1169),
    [anon_sym_do_BANG] = ACTIONS(1171),
    [anon_sym_begin] = ACTIONS(1173),
    [aux_sym_char_token1] = ACTIONS(1177),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(1181),
    [anon_sym_AT_DQUOTE] = ACTIONS(1183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1185),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1187),
    [sym_bool] = ACTIONS(1189),
    [sym_unit] = ACTIONS(3173),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1193),
    [sym_op_identifier] = ACTIONS(3175),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1197),
    [sym_xint] = ACTIONS(1199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1201),
  },
  [895] = {
    [sym_function_or_value_defn] = STATE(972),
    [sym__expression] = STATE(187),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(978),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(895),
    [sym_compiler_directive_decl] = STATE(895),
    [sym_fsi_directive_decl] = STATE(895),
    [sym_preproc_line] = STATE(895),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1302),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1302),
    [anon_sym_return_BANG] = ACTIONS(1326),
    [anon_sym_yield] = ACTIONS(1302),
    [anon_sym_yield_BANG] = ACTIONS(1326),
    [anon_sym_lazy] = ACTIONS(1302),
    [anon_sym_assert] = ACTIONS(1302),
    [anon_sym_upcast] = ACTIONS(1302),
    [anon_sym_downcast] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1330),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1352),
    [anon_sym_use_BANG] = ACTIONS(1354),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1384),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [896] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(291),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1022),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(896),
    [sym_compiler_directive_decl] = STATE(896),
    [sym_fsi_directive_decl] = STATE(896),
    [sym_preproc_line] = STATE(896),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(3069),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(3071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
  },
  [897] = {
    [sym_function_or_value_defn] = STATE(972),
    [sym__expression] = STATE(232),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(978),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(897),
    [sym_compiler_directive_decl] = STATE(897),
    [sym_fsi_directive_decl] = STATE(897),
    [sym_preproc_line] = STATE(897),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1302),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1302),
    [anon_sym_return_BANG] = ACTIONS(1326),
    [anon_sym_yield] = ACTIONS(1302),
    [anon_sym_yield_BANG] = ACTIONS(1326),
    [anon_sym_lazy] = ACTIONS(1302),
    [anon_sym_assert] = ACTIONS(1302),
    [anon_sym_upcast] = ACTIONS(1302),
    [anon_sym_downcast] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1330),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1352),
    [anon_sym_use_BANG] = ACTIONS(1354),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1384),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [898] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(383),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1045),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(898),
    [sym_compiler_directive_decl] = STATE(898),
    [sym_fsi_directive_decl] = STATE(898),
    [sym_preproc_line] = STATE(898),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [899] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(182),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(899),
    [sym_compiler_directive_decl] = STATE(899),
    [sym_fsi_directive_decl] = STATE(899),
    [sym_preproc_line] = STATE(899),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [900] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(229),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(900),
    [sym_compiler_directive_decl] = STATE(900),
    [sym_fsi_directive_decl] = STATE(900),
    [sym_preproc_line] = STATE(900),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
  },
  [901] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(159),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(901),
    [sym_compiler_directive_decl] = STATE(901),
    [sym_fsi_directive_decl] = STATE(901),
    [sym_preproc_line] = STATE(901),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
  },
  [902] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(439),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(890),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(902),
    [sym_compiler_directive_decl] = STATE(902),
    [sym_fsi_directive_decl] = STATE(902),
    [sym_preproc_line] = STATE(902),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
  },
  [903] = {
    [sym_function_or_value_defn] = STATE(953),
    [sym__expression] = STATE(27),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(942),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(1568),
    [sym_block_comment] = STATE(903),
    [sym_compiler_directive_decl] = STATE(903),
    [sym_fsi_directive_decl] = STATE(903),
    [sym_preproc_line] = STATE(903),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(291),
    [anon_sym_return_BANG] = ACTIONS(315),
    [anon_sym_yield] = ACTIONS(291),
    [anon_sym_yield_BANG] = ACTIONS(315),
    [anon_sym_lazy] = ACTIONS(291),
    [anon_sym_assert] = ACTIONS(291),
    [anon_sym_upcast] = ACTIONS(291),
    [anon_sym_downcast] = ACTIONS(291),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(339),
    [anon_sym_use_BANG] = ACTIONS(341),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(369),
    [sym_xint] = ACTIONS(371),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
  },
  [904] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(301),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(890),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(904),
    [sym_compiler_directive_decl] = STATE(904),
    [sym_fsi_directive_decl] = STATE(904),
    [sym_preproc_line] = STATE(904),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
  },
  [905] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(281),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(905),
    [sym_compiler_directive_decl] = STATE(905),
    [sym_fsi_directive_decl] = STATE(905),
    [sym_preproc_line] = STATE(905),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [906] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(440),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1022),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(906),
    [sym_compiler_directive_decl] = STATE(906),
    [sym_fsi_directive_decl] = STATE(906),
    [sym_preproc_line] = STATE(906),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(3069),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(3071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
  },
  [907] = {
    [sym_function_or_value_defn] = STATE(953),
    [sym__expression] = STATE(31),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(942),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(1568),
    [sym_block_comment] = STATE(907),
    [sym_compiler_directive_decl] = STATE(907),
    [sym_fsi_directive_decl] = STATE(907),
    [sym_preproc_line] = STATE(907),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(291),
    [anon_sym_return_BANG] = ACTIONS(315),
    [anon_sym_yield] = ACTIONS(291),
    [anon_sym_yield_BANG] = ACTIONS(315),
    [anon_sym_lazy] = ACTIONS(291),
    [anon_sym_assert] = ACTIONS(291),
    [anon_sym_upcast] = ACTIONS(291),
    [anon_sym_downcast] = ACTIONS(291),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(339),
    [anon_sym_use_BANG] = ACTIONS(341),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(369),
    [sym_xint] = ACTIONS(371),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
  },
  [908] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(441),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(908),
    [sym_compiler_directive_decl] = STATE(908),
    [sym_fsi_directive_decl] = STATE(908),
    [sym_preproc_line] = STATE(908),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [909] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(450),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(909),
    [sym_compiler_directive_decl] = STATE(909),
    [sym_fsi_directive_decl] = STATE(909),
    [sym_preproc_line] = STATE(909),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [910] = {
    [sym_function_or_value_defn] = STATE(964),
    [sym__expression] = STATE(115),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(793),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(910),
    [sym_compiler_directive_decl] = STATE(910),
    [sym_fsi_directive_decl] = STATE(910),
    [sym_preproc_line] = STATE(910),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(53),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(29),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_upcast] = ACTIONS(29),
    [anon_sym_downcast] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(99),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(111),
    [sym_xint] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
  },
  [911] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(257),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1045),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(911),
    [sym_compiler_directive_decl] = STATE(911),
    [sym_fsi_directive_decl] = STATE(911),
    [sym_preproc_line] = STATE(911),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [912] = {
    [sym_function_or_value_defn] = STATE(1180),
    [sym__expression] = STATE(245),
    [sym_literal_expression] = STATE(3145),
    [sym_long_identifier_or_op] = STATE(3145),
    [sym_tuple_expression] = STATE(3145),
    [sym_brace_expression] = STATE(3145),
    [sym_anon_record_expression] = STATE(3145),
    [sym_prefixed_expression] = STATE(3145),
    [sym_typecast_expression] = STATE(3145),
    [sym_for_expression] = STATE(3145),
    [sym_while_expression] = STATE(3145),
    [sym__if_branch] = STATE(10360),
    [sym_if_expression] = STATE(3145),
    [sym_fun_expression] = STATE(3145),
    [sym_try_expression] = STATE(3145),
    [sym_match_expression] = STATE(3145),
    [sym_function_expression] = STATE(3145),
    [sym_mutate_expression] = STATE(3145),
    [sym_index_expression] = STATE(3145),
    [sym_typed_expression] = STATE(3145),
    [sym_declaration_expression] = STATE(3145),
    [sym_do_expression] = STATE(3145),
    [sym_list_expression] = STATE(3145),
    [sym_array_expression] = STATE(3145),
    [sym_begin_end_expression] = STATE(3145),
    [sym_paren_expression] = STATE(3145),
    [sym__high_prec_app] = STATE(3141),
    [sym__low_prec_app] = STATE(3141),
    [sym_application_expression] = STATE(3145),
    [sym_dot_expression] = STATE(3145),
    [sym_infix_expression] = STATE(3145),
    [sym_ce_expression] = STATE(3145),
    [sym_sequential_expression] = STATE(3145),
    [sym_char] = STATE(3108),
    [sym_format_string] = STATE(3193),
    [sym__string_literal] = STATE(3193),
    [sym_string] = STATE(3108),
    [sym_verbatim_string] = STATE(3108),
    [sym_bytearray] = STATE(3108),
    [sym_verbatim_bytearray] = STATE(3108),
    [sym_format_triple_quoted_string] = STATE(3192),
    [sym_triple_quoted_string] = STATE(3108),
    [sym_const] = STATE(3145),
    [sym_long_identifier] = STATE(3102),
    [sym_active_pattern] = STATE(3172),
    [sym__identifier_or_op] = STATE(3103),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1149),
    [sym_sbyte] = STATE(3108),
    [sym_byte] = STATE(3108),
    [sym_int16] = STATE(3108),
    [sym_uint16] = STATE(3108),
    [sym_int32] = STATE(3108),
    [sym_uint32] = STATE(3108),
    [sym_nativeint] = STATE(3108),
    [sym_unativeint] = STATE(3108),
    [sym_int64] = STATE(3108),
    [sym_uint64] = STATE(3108),
    [sym_ieee32] = STATE(3108),
    [sym_ieee64] = STATE(3108),
    [sym_bignum] = STATE(3108),
    [sym_decimal] = STATE(3108),
    [sym_float] = STATE(2770),
    [sym_block_comment] = STATE(912),
    [sym_compiler_directive_decl] = STATE(912),
    [sym_fsi_directive_decl] = STATE(912),
    [sym_preproc_line] = STATE(912),
    [sym_preproc_if_in_expression] = STATE(3145),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_return] = ACTIONS(1119),
    [anon_sym_do] = ACTIONS(1121),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_null] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1131),
    [anon_sym_LBRACE] = ACTIONS(3169),
    [anon_sym_LT_AT] = ACTIONS(1135),
    [anon_sym_LT_AT_AT] = ACTIONS(3171),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1141),
    [anon_sym_new] = ACTIONS(1119),
    [anon_sym_return_BANG] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1119),
    [anon_sym_yield_BANG] = ACTIONS(1143),
    [anon_sym_lazy] = ACTIONS(1119),
    [anon_sym_assert] = ACTIONS(1119),
    [anon_sym_upcast] = ACTIONS(1119),
    [anon_sym_downcast] = ACTIONS(1119),
    [anon_sym_for] = ACTIONS(1147),
    [anon_sym_while] = ACTIONS(1149),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1151),
    [anon_sym_try] = ACTIONS(1153),
    [anon_sym_match] = ACTIONS(1155),
    [anon_sym_match_BANG] = ACTIONS(1157),
    [anon_sym_function] = ACTIONS(1159),
    [anon_sym_use] = ACTIONS(1167),
    [anon_sym_use_BANG] = ACTIONS(1169),
    [anon_sym_do_BANG] = ACTIONS(1171),
    [anon_sym_begin] = ACTIONS(1173),
    [aux_sym_char_token1] = ACTIONS(1177),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(1181),
    [anon_sym_AT_DQUOTE] = ACTIONS(1183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1185),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1187),
    [sym_bool] = ACTIONS(1189),
    [sym_unit] = ACTIONS(3173),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1193),
    [sym_op_identifier] = ACTIONS(3175),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1197),
    [sym_xint] = ACTIONS(1199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1201),
  },
  [913] = {
    [sym_function_or_value_defn] = STATE(953),
    [sym__expression] = STATE(32),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(942),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(1568),
    [sym_block_comment] = STATE(913),
    [sym_compiler_directive_decl] = STATE(913),
    [sym_fsi_directive_decl] = STATE(913),
    [sym_preproc_line] = STATE(913),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(291),
    [anon_sym_return_BANG] = ACTIONS(315),
    [anon_sym_yield] = ACTIONS(291),
    [anon_sym_yield_BANG] = ACTIONS(315),
    [anon_sym_lazy] = ACTIONS(291),
    [anon_sym_assert] = ACTIONS(291),
    [anon_sym_upcast] = ACTIONS(291),
    [anon_sym_downcast] = ACTIONS(291),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(339),
    [anon_sym_use_BANG] = ACTIONS(341),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(369),
    [sym_xint] = ACTIONS(371),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
  },
  [914] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(413),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(914),
    [sym_compiler_directive_decl] = STATE(914),
    [sym_fsi_directive_decl] = STATE(914),
    [sym_preproc_line] = STATE(914),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [915] = {
    [sym_function_or_value_defn] = STATE(953),
    [sym__expression] = STATE(30),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(942),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(1568),
    [sym_block_comment] = STATE(915),
    [sym_compiler_directive_decl] = STATE(915),
    [sym_fsi_directive_decl] = STATE(915),
    [sym_preproc_line] = STATE(915),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(291),
    [anon_sym_return_BANG] = ACTIONS(315),
    [anon_sym_yield] = ACTIONS(291),
    [anon_sym_yield_BANG] = ACTIONS(315),
    [anon_sym_lazy] = ACTIONS(291),
    [anon_sym_assert] = ACTIONS(291),
    [anon_sym_upcast] = ACTIONS(291),
    [anon_sym_downcast] = ACTIONS(291),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(339),
    [anon_sym_use_BANG] = ACTIONS(341),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(369),
    [sym_xint] = ACTIONS(371),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
  },
  [916] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(386),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(916),
    [sym_compiler_directive_decl] = STATE(916),
    [sym_fsi_directive_decl] = STATE(916),
    [sym_preproc_line] = STATE(916),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [917] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(451),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(890),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(917),
    [sym_compiler_directive_decl] = STATE(917),
    [sym_fsi_directive_decl] = STATE(917),
    [sym_preproc_line] = STATE(917),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
  },
  [918] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(452),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1022),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(918),
    [sym_compiler_directive_decl] = STATE(918),
    [sym_fsi_directive_decl] = STATE(918),
    [sym_preproc_line] = STATE(918),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(3069),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(3071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
  },
  [919] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(268),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(919),
    [sym_compiler_directive_decl] = STATE(919),
    [sym_fsi_directive_decl] = STATE(919),
    [sym_preproc_line] = STATE(919),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [920] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(453),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(920),
    [sym_compiler_directive_decl] = STATE(920),
    [sym_fsi_directive_decl] = STATE(920),
    [sym_preproc_line] = STATE(920),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [921] = {
    [sym_function_or_value_defn] = STATE(866),
    [sym__expression] = STATE(96),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1178),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(921),
    [sym_compiler_directive_decl] = STATE(921),
    [sym_fsi_directive_decl] = STATE(921),
    [sym_preproc_line] = STATE(921),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(857),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(53),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(857),
    [anon_sym_return_BANG] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(857),
    [anon_sym_yield_BANG] = ACTIONS(869),
    [anon_sym_lazy] = ACTIONS(857),
    [anon_sym_assert] = ACTIONS(857),
    [anon_sym_upcast] = ACTIONS(857),
    [anon_sym_downcast] = ACTIONS(857),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(879),
    [anon_sym_use_BANG] = ACTIONS(881),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(99),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(889),
    [sym_xint] = ACTIONS(891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
  },
  [922] = {
    [sym_function_or_value_defn] = STATE(845),
    [sym__expression] = STATE(193),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(776),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(922),
    [sym_compiler_directive_decl] = STATE(922),
    [sym_fsi_directive_decl] = STATE(922),
    [sym_preproc_line] = STATE(922),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1203),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1203),
    [anon_sym_return_BANG] = ACTIONS(1207),
    [anon_sym_yield] = ACTIONS(1203),
    [anon_sym_yield_BANG] = ACTIONS(1207),
    [anon_sym_lazy] = ACTIONS(1203),
    [anon_sym_assert] = ACTIONS(1203),
    [anon_sym_upcast] = ACTIONS(1203),
    [anon_sym_downcast] = ACTIONS(1203),
    [anon_sym_for] = ACTIONS(1209),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1213),
    [anon_sym_use_BANG] = ACTIONS(1215),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1219),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [923] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(461),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(890),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(923),
    [sym_compiler_directive_decl] = STATE(923),
    [sym_fsi_directive_decl] = STATE(923),
    [sym_preproc_line] = STATE(923),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
  },
  [924] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(462),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1022),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(924),
    [sym_compiler_directive_decl] = STATE(924),
    [sym_fsi_directive_decl] = STATE(924),
    [sym_preproc_line] = STATE(924),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(3069),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(3071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
  },
  [925] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(463),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(925),
    [sym_compiler_directive_decl] = STATE(925),
    [sym_fsi_directive_decl] = STATE(925),
    [sym_preproc_line] = STATE(925),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [926] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(368),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(926),
    [sym_compiler_directive_decl] = STATE(926),
    [sym_fsi_directive_decl] = STATE(926),
    [sym_preproc_line] = STATE(926),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [927] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(396),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(927),
    [sym_compiler_directive_decl] = STATE(927),
    [sym_fsi_directive_decl] = STATE(927),
    [sym_preproc_line] = STATE(927),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [928] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(316),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1022),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(928),
    [sym_compiler_directive_decl] = STATE(928),
    [sym_fsi_directive_decl] = STATE(928),
    [sym_preproc_line] = STATE(928),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(3069),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(3071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
  },
  [929] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(317),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(929),
    [sym_compiler_directive_decl] = STATE(929),
    [sym_fsi_directive_decl] = STATE(929),
    [sym_preproc_line] = STATE(929),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [930] = {
    [sym_function_or_value_defn] = STATE(866),
    [sym__expression] = STATE(105),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1178),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(930),
    [sym_compiler_directive_decl] = STATE(930),
    [sym_fsi_directive_decl] = STATE(930),
    [sym_preproc_line] = STATE(930),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(857),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(53),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(857),
    [anon_sym_return_BANG] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(857),
    [anon_sym_yield_BANG] = ACTIONS(869),
    [anon_sym_lazy] = ACTIONS(857),
    [anon_sym_assert] = ACTIONS(857),
    [anon_sym_upcast] = ACTIONS(857),
    [anon_sym_downcast] = ACTIONS(857),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(879),
    [anon_sym_use_BANG] = ACTIONS(881),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(99),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(889),
    [sym_xint] = ACTIONS(891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
  },
  [931] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(472),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(890),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(931),
    [sym_compiler_directive_decl] = STATE(931),
    [sym_fsi_directive_decl] = STATE(931),
    [sym_preproc_line] = STATE(931),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
  },
  [932] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(473),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1022),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(932),
    [sym_compiler_directive_decl] = STATE(932),
    [sym_fsi_directive_decl] = STATE(932),
    [sym_preproc_line] = STATE(932),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(3069),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(3071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
  },
  [933] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(474),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(933),
    [sym_compiler_directive_decl] = STATE(933),
    [sym_fsi_directive_decl] = STATE(933),
    [sym_preproc_line] = STATE(933),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [934] = {
    [sym_function_or_value_defn] = STATE(1054),
    [sym__expression] = STATE(59),
    [sym_literal_expression] = STATE(2069),
    [sym_long_identifier_or_op] = STATE(2069),
    [sym_tuple_expression] = STATE(2069),
    [sym_brace_expression] = STATE(2069),
    [sym_anon_record_expression] = STATE(2069),
    [sym_prefixed_expression] = STATE(2069),
    [sym_typecast_expression] = STATE(2069),
    [sym_for_expression] = STATE(2069),
    [sym_while_expression] = STATE(2069),
    [sym__if_branch] = STATE(10893),
    [sym_if_expression] = STATE(2069),
    [sym_fun_expression] = STATE(2069),
    [sym_try_expression] = STATE(2069),
    [sym_match_expression] = STATE(2069),
    [sym_function_expression] = STATE(2069),
    [sym_mutate_expression] = STATE(2069),
    [sym_index_expression] = STATE(2069),
    [sym_typed_expression] = STATE(2069),
    [sym_declaration_expression] = STATE(2069),
    [sym_do_expression] = STATE(2069),
    [sym_list_expression] = STATE(2069),
    [sym_array_expression] = STATE(2069),
    [sym_begin_end_expression] = STATE(2069),
    [sym_paren_expression] = STATE(2069),
    [sym__high_prec_app] = STATE(2058),
    [sym__low_prec_app] = STATE(2058),
    [sym_application_expression] = STATE(2069),
    [sym_dot_expression] = STATE(2069),
    [sym_infix_expression] = STATE(2069),
    [sym_ce_expression] = STATE(2069),
    [sym_sequential_expression] = STATE(2069),
    [sym_char] = STATE(2052),
    [sym_format_string] = STATE(2056),
    [sym__string_literal] = STATE(2056),
    [sym_string] = STATE(2052),
    [sym_verbatim_string] = STATE(2052),
    [sym_bytearray] = STATE(2052),
    [sym_verbatim_bytearray] = STATE(2052),
    [sym_format_triple_quoted_string] = STATE(2057),
    [sym_triple_quoted_string] = STATE(2052),
    [sym_const] = STATE(2069),
    [sym_long_identifier] = STATE(2077),
    [sym_active_pattern] = STATE(1953),
    [sym__identifier_or_op] = STATE(2078),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(934),
    [sym_sbyte] = STATE(2052),
    [sym_byte] = STATE(2052),
    [sym_int16] = STATE(2052),
    [sym_uint16] = STATE(2052),
    [sym_int32] = STATE(2052),
    [sym_uint32] = STATE(2052),
    [sym_nativeint] = STATE(2052),
    [sym_unativeint] = STATE(2052),
    [sym_int64] = STATE(2052),
    [sym_uint64] = STATE(2052),
    [sym_ieee32] = STATE(2052),
    [sym_ieee64] = STATE(2052),
    [sym_bignum] = STATE(2052),
    [sym_decimal] = STATE(2052),
    [sym_float] = STATE(1596),
    [sym_block_comment] = STATE(934),
    [sym_compiler_directive_decl] = STATE(934),
    [sym_fsi_directive_decl] = STATE(934),
    [sym_preproc_line] = STATE(934),
    [sym_preproc_if_in_expression] = STATE(2069),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(565),
    [anon_sym_null] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(571),
    [anon_sym_LBRACK_PIPE] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(3145),
    [anon_sym_LT_AT] = ACTIONS(577),
    [anon_sym_LT_AT_AT] = ACTIONS(3147),
    [anon_sym_LBRACE_PIPE] = ACTIONS(583),
    [anon_sym_new] = ACTIONS(561),
    [anon_sym_return_BANG] = ACTIONS(585),
    [anon_sym_yield] = ACTIONS(561),
    [anon_sym_yield_BANG] = ACTIONS(585),
    [anon_sym_lazy] = ACTIONS(561),
    [anon_sym_assert] = ACTIONS(561),
    [anon_sym_upcast] = ACTIONS(561),
    [anon_sym_downcast] = ACTIONS(561),
    [anon_sym_for] = ACTIONS(589),
    [anon_sym_while] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(593),
    [anon_sym_try] = ACTIONS(595),
    [anon_sym_match] = ACTIONS(597),
    [anon_sym_match_BANG] = ACTIONS(599),
    [anon_sym_function] = ACTIONS(601),
    [anon_sym_use] = ACTIONS(609),
    [anon_sym_use_BANG] = ACTIONS(611),
    [anon_sym_do_BANG] = ACTIONS(613),
    [anon_sym_begin] = ACTIONS(615),
    [aux_sym_char_token1] = ACTIONS(619),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(621),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [anon_sym_AT_DQUOTE] = ACTIONS(625),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(627),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(629),
    [sym_bool] = ACTIONS(631),
    [sym_unit] = ACTIONS(3149),
    [anon_sym_LPAREN_PIPE] = ACTIONS(635),
    [sym_op_identifier] = ACTIONS(3151),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(639),
    [sym_xint] = ACTIONS(641),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(643),
  },
  [935] = {
    [sym_function_or_value_defn] = STATE(866),
    [sym__expression] = STATE(102),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1178),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(935),
    [sym_compiler_directive_decl] = STATE(935),
    [sym_fsi_directive_decl] = STATE(935),
    [sym_preproc_line] = STATE(935),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(857),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(53),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(857),
    [anon_sym_return_BANG] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(857),
    [anon_sym_yield_BANG] = ACTIONS(869),
    [anon_sym_lazy] = ACTIONS(857),
    [anon_sym_assert] = ACTIONS(857),
    [anon_sym_upcast] = ACTIONS(857),
    [anon_sym_downcast] = ACTIONS(857),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(879),
    [anon_sym_use_BANG] = ACTIONS(881),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(99),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(889),
    [sym_xint] = ACTIONS(891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
  },
  [936] = {
    [sym_function_or_value_defn] = STATE(1084),
    [sym__expression] = STATE(78),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(936),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(1592),
    [sym_block_comment] = STATE(936),
    [sym_compiler_directive_decl] = STATE(936),
    [sym_fsi_directive_decl] = STATE(936),
    [sym_preproc_line] = STATE(936),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(651),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(2638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(651),
    [anon_sym_return_BANG] = ACTIONS(673),
    [anon_sym_yield] = ACTIONS(651),
    [anon_sym_yield_BANG] = ACTIONS(673),
    [anon_sym_lazy] = ACTIONS(651),
    [anon_sym_assert] = ACTIONS(651),
    [anon_sym_upcast] = ACTIONS(651),
    [anon_sym_downcast] = ACTIONS(651),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_use] = ACTIONS(697),
    [anon_sym_use_BANG] = ACTIONS(699),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(2642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(727),
    [sym_xint] = ACTIONS(729),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
  },
  [937] = {
    [sym_function_or_value_defn] = STATE(953),
    [sym__expression] = STATE(29),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(942),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(1568),
    [sym_block_comment] = STATE(937),
    [sym_compiler_directive_decl] = STATE(937),
    [sym_fsi_directive_decl] = STATE(937),
    [sym_preproc_line] = STATE(937),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(291),
    [anon_sym_return_BANG] = ACTIONS(315),
    [anon_sym_yield] = ACTIONS(291),
    [anon_sym_yield_BANG] = ACTIONS(315),
    [anon_sym_lazy] = ACTIONS(291),
    [anon_sym_assert] = ACTIONS(291),
    [anon_sym_upcast] = ACTIONS(291),
    [anon_sym_downcast] = ACTIONS(291),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(339),
    [anon_sym_use_BANG] = ACTIONS(341),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(369),
    [sym_xint] = ACTIONS(371),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
  },
  [938] = {
    [sym_function_or_value_defn] = STATE(1122),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(938),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(1598),
    [sym_block_comment] = STATE(938),
    [sym_compiler_directive_decl] = STATE(938),
    [sym_fsi_directive_decl] = STATE(938),
    [sym_preproc_line] = STATE(938),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_return] = ACTIONS(475),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(3081),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(475),
    [anon_sym_return_BANG] = ACTIONS(497),
    [anon_sym_yield] = ACTIONS(475),
    [anon_sym_yield_BANG] = ACTIONS(497),
    [anon_sym_lazy] = ACTIONS(475),
    [anon_sym_assert] = ACTIONS(475),
    [anon_sym_upcast] = ACTIONS(475),
    [anon_sym_downcast] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_use] = ACTIONS(521),
    [anon_sym_use_BANG] = ACTIONS(523),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(3083),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(3085),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(551),
    [sym_xint] = ACTIONS(553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
  },
  [939] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(273),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(939),
    [sym_compiler_directive_decl] = STATE(939),
    [sym_fsi_directive_decl] = STATE(939),
    [sym_preproc_line] = STATE(939),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [940] = {
    [sym_function_or_value_defn] = STATE(1163),
    [sym__expression] = STATE(45),
    [sym_literal_expression] = STATE(1715),
    [sym_long_identifier_or_op] = STATE(1715),
    [sym_tuple_expression] = STATE(1715),
    [sym_brace_expression] = STATE(1715),
    [sym_anon_record_expression] = STATE(1715),
    [sym_prefixed_expression] = STATE(1715),
    [sym_typecast_expression] = STATE(1715),
    [sym_for_expression] = STATE(1715),
    [sym_while_expression] = STATE(1715),
    [sym__if_branch] = STATE(10853),
    [sym_if_expression] = STATE(1715),
    [sym_fun_expression] = STATE(1715),
    [sym_try_expression] = STATE(1715),
    [sym_match_expression] = STATE(1715),
    [sym_function_expression] = STATE(1715),
    [sym_mutate_expression] = STATE(1715),
    [sym_index_expression] = STATE(1715),
    [sym_typed_expression] = STATE(1715),
    [sym_declaration_expression] = STATE(1715),
    [sym_do_expression] = STATE(1715),
    [sym_list_expression] = STATE(1715),
    [sym_array_expression] = STATE(1715),
    [sym_begin_end_expression] = STATE(1715),
    [sym_paren_expression] = STATE(1715),
    [sym__high_prec_app] = STATE(1728),
    [sym__low_prec_app] = STATE(1728),
    [sym_application_expression] = STATE(1715),
    [sym_dot_expression] = STATE(1715),
    [sym_infix_expression] = STATE(1715),
    [sym_ce_expression] = STATE(1715),
    [sym_sequential_expression] = STATE(1715),
    [sym_char] = STATE(1858),
    [sym_format_string] = STATE(1853),
    [sym__string_literal] = STATE(1853),
    [sym_string] = STATE(1858),
    [sym_verbatim_string] = STATE(1858),
    [sym_bytearray] = STATE(1858),
    [sym_verbatim_bytearray] = STATE(1858),
    [sym_format_triple_quoted_string] = STATE(1851),
    [sym_triple_quoted_string] = STATE(1858),
    [sym_const] = STATE(1715),
    [sym_long_identifier] = STATE(1825),
    [sym_active_pattern] = STATE(1754),
    [sym__identifier_or_op] = STATE(1822),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(940),
    [sym_sbyte] = STATE(1858),
    [sym_byte] = STATE(1858),
    [sym_int16] = STATE(1858),
    [sym_uint16] = STATE(1858),
    [sym_int32] = STATE(1858),
    [sym_uint32] = STATE(1858),
    [sym_nativeint] = STATE(1858),
    [sym_unativeint] = STATE(1858),
    [sym_int64] = STATE(1858),
    [sym_uint64] = STATE(1858),
    [sym_ieee32] = STATE(1858),
    [sym_ieee64] = STATE(1858),
    [sym_bignum] = STATE(1858),
    [sym_decimal] = STATE(1858),
    [sym_float] = STATE(1552),
    [sym_block_comment] = STATE(940),
    [sym_compiler_directive_decl] = STATE(940),
    [sym_fsi_directive_decl] = STATE(940),
    [sym_preproc_line] = STATE(940),
    [sym_preproc_if_in_expression] = STATE(1715),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_do] = ACTIONS(383),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(385),
    [anon_sym_null] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_LBRACK_PIPE] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(3159),
    [anon_sym_LT_AT] = ACTIONS(397),
    [anon_sym_LT_AT_AT] = ACTIONS(3161),
    [anon_sym_LBRACE_PIPE] = ACTIONS(403),
    [anon_sym_new] = ACTIONS(381),
    [anon_sym_return_BANG] = ACTIONS(405),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_yield_BANG] = ACTIONS(405),
    [anon_sym_lazy] = ACTIONS(381),
    [anon_sym_assert] = ACTIONS(381),
    [anon_sym_upcast] = ACTIONS(381),
    [anon_sym_downcast] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(409),
    [anon_sym_while] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(413),
    [anon_sym_try] = ACTIONS(415),
    [anon_sym_match] = ACTIONS(417),
    [anon_sym_match_BANG] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(421),
    [anon_sym_use] = ACTIONS(429),
    [anon_sym_use_BANG] = ACTIONS(431),
    [anon_sym_do_BANG] = ACTIONS(433),
    [anon_sym_begin] = ACTIONS(435),
    [aux_sym_char_token1] = ACTIONS(439),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(443),
    [anon_sym_AT_DQUOTE] = ACTIONS(445),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(447),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(449),
    [sym_bool] = ACTIONS(451),
    [sym_unit] = ACTIONS(3163),
    [anon_sym_LPAREN_PIPE] = ACTIONS(455),
    [sym_op_identifier] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(459),
    [sym_xint] = ACTIONS(461),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(463),
  },
  [941] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(259),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(941),
    [sym_compiler_directive_decl] = STATE(941),
    [sym_fsi_directive_decl] = STATE(941),
    [sym_preproc_line] = STATE(941),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [942] = {
    [sym_function_or_value_defn] = STATE(953),
    [sym__expression] = STATE(28),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(942),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(1568),
    [sym_block_comment] = STATE(942),
    [sym_compiler_directive_decl] = STATE(942),
    [sym_fsi_directive_decl] = STATE(942),
    [sym_preproc_line] = STATE(942),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(291),
    [anon_sym_return_BANG] = ACTIONS(315),
    [anon_sym_yield] = ACTIONS(291),
    [anon_sym_yield_BANG] = ACTIONS(315),
    [anon_sym_lazy] = ACTIONS(291),
    [anon_sym_assert] = ACTIONS(291),
    [anon_sym_upcast] = ACTIONS(291),
    [anon_sym_downcast] = ACTIONS(291),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(339),
    [anon_sym_use_BANG] = ACTIONS(341),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(369),
    [sym_xint] = ACTIONS(371),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
  },
  [943] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(481),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(943),
    [sym_compiler_directive_decl] = STATE(943),
    [sym_fsi_directive_decl] = STATE(943),
    [sym_preproc_line] = STATE(943),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [944] = {
    [sym_function_or_value_defn] = STATE(1074),
    [sym__expression] = STATE(144),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(944),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(2718),
    [sym_block_comment] = STATE(944),
    [sym_compiler_directive_decl] = STATE(944),
    [sym_fsi_directive_decl] = STATE(944),
    [sym_preproc_line] = STATE(944),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_return] = ACTIONS(1252),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(3081),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_return_BANG] = ACTIONS(1256),
    [anon_sym_yield] = ACTIONS(1252),
    [anon_sym_yield_BANG] = ACTIONS(1256),
    [anon_sym_lazy] = ACTIONS(1252),
    [anon_sym_assert] = ACTIONS(1252),
    [anon_sym_upcast] = ACTIONS(1252),
    [anon_sym_downcast] = ACTIONS(1252),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_use] = ACTIONS(1260),
    [anon_sym_use_BANG] = ACTIONS(1262),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(3083),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(3085),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1264),
    [sym_xint] = ACTIONS(1266),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
  },
  [945] = {
    [sym_function_or_value_defn] = STATE(1180),
    [sym__expression] = STATE(221),
    [sym_literal_expression] = STATE(3145),
    [sym_long_identifier_or_op] = STATE(3145),
    [sym_tuple_expression] = STATE(3145),
    [sym_brace_expression] = STATE(3145),
    [sym_anon_record_expression] = STATE(3145),
    [sym_prefixed_expression] = STATE(3145),
    [sym_typecast_expression] = STATE(3145),
    [sym_for_expression] = STATE(3145),
    [sym_while_expression] = STATE(3145),
    [sym__if_branch] = STATE(10360),
    [sym_if_expression] = STATE(3145),
    [sym_fun_expression] = STATE(3145),
    [sym_try_expression] = STATE(3145),
    [sym_match_expression] = STATE(3145),
    [sym_function_expression] = STATE(3145),
    [sym_mutate_expression] = STATE(3145),
    [sym_index_expression] = STATE(3145),
    [sym_typed_expression] = STATE(3145),
    [sym_declaration_expression] = STATE(3145),
    [sym_do_expression] = STATE(3145),
    [sym_list_expression] = STATE(3145),
    [sym_array_expression] = STATE(3145),
    [sym_begin_end_expression] = STATE(3145),
    [sym_paren_expression] = STATE(3145),
    [sym__high_prec_app] = STATE(3141),
    [sym__low_prec_app] = STATE(3141),
    [sym_application_expression] = STATE(3145),
    [sym_dot_expression] = STATE(3145),
    [sym_infix_expression] = STATE(3145),
    [sym_ce_expression] = STATE(3145),
    [sym_sequential_expression] = STATE(3145),
    [sym_char] = STATE(3108),
    [sym_format_string] = STATE(3193),
    [sym__string_literal] = STATE(3193),
    [sym_string] = STATE(3108),
    [sym_verbatim_string] = STATE(3108),
    [sym_bytearray] = STATE(3108),
    [sym_verbatim_bytearray] = STATE(3108),
    [sym_format_triple_quoted_string] = STATE(3192),
    [sym_triple_quoted_string] = STATE(3108),
    [sym_const] = STATE(3145),
    [sym_long_identifier] = STATE(3102),
    [sym_active_pattern] = STATE(3172),
    [sym__identifier_or_op] = STATE(3103),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1149),
    [sym_sbyte] = STATE(3108),
    [sym_byte] = STATE(3108),
    [sym_int16] = STATE(3108),
    [sym_uint16] = STATE(3108),
    [sym_int32] = STATE(3108),
    [sym_uint32] = STATE(3108),
    [sym_nativeint] = STATE(3108),
    [sym_unativeint] = STATE(3108),
    [sym_int64] = STATE(3108),
    [sym_uint64] = STATE(3108),
    [sym_ieee32] = STATE(3108),
    [sym_ieee64] = STATE(3108),
    [sym_bignum] = STATE(3108),
    [sym_decimal] = STATE(3108),
    [sym_float] = STATE(2770),
    [sym_block_comment] = STATE(945),
    [sym_compiler_directive_decl] = STATE(945),
    [sym_fsi_directive_decl] = STATE(945),
    [sym_preproc_line] = STATE(945),
    [sym_preproc_if_in_expression] = STATE(3145),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_return] = ACTIONS(1119),
    [anon_sym_do] = ACTIONS(1121),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_null] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1131),
    [anon_sym_LBRACE] = ACTIONS(3169),
    [anon_sym_LT_AT] = ACTIONS(1135),
    [anon_sym_LT_AT_AT] = ACTIONS(3171),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1141),
    [anon_sym_new] = ACTIONS(1119),
    [anon_sym_return_BANG] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1119),
    [anon_sym_yield_BANG] = ACTIONS(1143),
    [anon_sym_lazy] = ACTIONS(1119),
    [anon_sym_assert] = ACTIONS(1119),
    [anon_sym_upcast] = ACTIONS(1119),
    [anon_sym_downcast] = ACTIONS(1119),
    [anon_sym_for] = ACTIONS(1147),
    [anon_sym_while] = ACTIONS(1149),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1151),
    [anon_sym_try] = ACTIONS(1153),
    [anon_sym_match] = ACTIONS(1155),
    [anon_sym_match_BANG] = ACTIONS(1157),
    [anon_sym_function] = ACTIONS(1159),
    [anon_sym_use] = ACTIONS(1167),
    [anon_sym_use_BANG] = ACTIONS(1169),
    [anon_sym_do_BANG] = ACTIONS(1171),
    [anon_sym_begin] = ACTIONS(1173),
    [aux_sym_char_token1] = ACTIONS(1177),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(1181),
    [anon_sym_AT_DQUOTE] = ACTIONS(1183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1185),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1187),
    [sym_bool] = ACTIONS(1189),
    [sym_unit] = ACTIONS(3173),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1193),
    [sym_op_identifier] = ACTIONS(3175),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1197),
    [sym_xint] = ACTIONS(1199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1201),
  },
  [946] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(80),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(946),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(946),
    [sym_compiler_directive_decl] = STATE(946),
    [sym_fsi_directive_decl] = STATE(946),
    [sym_preproc_line] = STATE(946),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(753),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [947] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(484),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(947),
    [sym_compiler_directive_decl] = STATE(947),
    [sym_fsi_directive_decl] = STATE(947),
    [sym_preproc_line] = STATE(947),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [948] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(486),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(948),
    [sym_compiler_directive_decl] = STATE(948),
    [sym_fsi_directive_decl] = STATE(948),
    [sym_preproc_line] = STATE(948),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [949] = {
    [sym_function_or_value_defn] = STATE(850),
    [sym__expression] = STATE(2),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(949),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(949),
    [sym_compiler_directive_decl] = STATE(949),
    [sym_fsi_directive_decl] = STATE(949),
    [sym_preproc_line] = STATE(949),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(129),
    [anon_sym_return_BANG] = ACTIONS(159),
    [anon_sym_yield] = ACTIONS(129),
    [anon_sym_yield_BANG] = ACTIONS(159),
    [anon_sym_lazy] = ACTIONS(129),
    [anon_sym_assert] = ACTIONS(129),
    [anon_sym_upcast] = ACTIONS(129),
    [anon_sym_downcast] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(183),
    [anon_sym_use_BANG] = ACTIONS(185),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(215),
    [sym_xint] = ACTIONS(217),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
  },
  [950] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(274),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(950),
    [sym_compiler_directive_decl] = STATE(950),
    [sym_fsi_directive_decl] = STATE(950),
    [sym_preproc_line] = STATE(950),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [951] = {
    [sym_function_or_value_defn] = STATE(1180),
    [sym__expression] = STATE(213),
    [sym_literal_expression] = STATE(3145),
    [sym_long_identifier_or_op] = STATE(3145),
    [sym_tuple_expression] = STATE(3145),
    [sym_brace_expression] = STATE(3145),
    [sym_anon_record_expression] = STATE(3145),
    [sym_prefixed_expression] = STATE(3145),
    [sym_typecast_expression] = STATE(3145),
    [sym_for_expression] = STATE(3145),
    [sym_while_expression] = STATE(3145),
    [sym__if_branch] = STATE(10360),
    [sym_if_expression] = STATE(3145),
    [sym_fun_expression] = STATE(3145),
    [sym_try_expression] = STATE(3145),
    [sym_match_expression] = STATE(3145),
    [sym_function_expression] = STATE(3145),
    [sym_mutate_expression] = STATE(3145),
    [sym_index_expression] = STATE(3145),
    [sym_typed_expression] = STATE(3145),
    [sym_declaration_expression] = STATE(3145),
    [sym_do_expression] = STATE(3145),
    [sym_list_expression] = STATE(3145),
    [sym_array_expression] = STATE(3145),
    [sym_begin_end_expression] = STATE(3145),
    [sym_paren_expression] = STATE(3145),
    [sym__high_prec_app] = STATE(3141),
    [sym__low_prec_app] = STATE(3141),
    [sym_application_expression] = STATE(3145),
    [sym_dot_expression] = STATE(3145),
    [sym_infix_expression] = STATE(3145),
    [sym_ce_expression] = STATE(3145),
    [sym_sequential_expression] = STATE(3145),
    [sym_char] = STATE(3108),
    [sym_format_string] = STATE(3193),
    [sym__string_literal] = STATE(3193),
    [sym_string] = STATE(3108),
    [sym_verbatim_string] = STATE(3108),
    [sym_bytearray] = STATE(3108),
    [sym_verbatim_bytearray] = STATE(3108),
    [sym_format_triple_quoted_string] = STATE(3192),
    [sym_triple_quoted_string] = STATE(3108),
    [sym_const] = STATE(3145),
    [sym_long_identifier] = STATE(3102),
    [sym_active_pattern] = STATE(3172),
    [sym__identifier_or_op] = STATE(3103),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1149),
    [sym_sbyte] = STATE(3108),
    [sym_byte] = STATE(3108),
    [sym_int16] = STATE(3108),
    [sym_uint16] = STATE(3108),
    [sym_int32] = STATE(3108),
    [sym_uint32] = STATE(3108),
    [sym_nativeint] = STATE(3108),
    [sym_unativeint] = STATE(3108),
    [sym_int64] = STATE(3108),
    [sym_uint64] = STATE(3108),
    [sym_ieee32] = STATE(3108),
    [sym_ieee64] = STATE(3108),
    [sym_bignum] = STATE(3108),
    [sym_decimal] = STATE(3108),
    [sym_float] = STATE(2770),
    [sym_block_comment] = STATE(951),
    [sym_compiler_directive_decl] = STATE(951),
    [sym_fsi_directive_decl] = STATE(951),
    [sym_preproc_line] = STATE(951),
    [sym_preproc_if_in_expression] = STATE(3145),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_return] = ACTIONS(1119),
    [anon_sym_do] = ACTIONS(1121),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_null] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1131),
    [anon_sym_LBRACE] = ACTIONS(3169),
    [anon_sym_LT_AT] = ACTIONS(1135),
    [anon_sym_LT_AT_AT] = ACTIONS(3171),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1141),
    [anon_sym_new] = ACTIONS(1119),
    [anon_sym_return_BANG] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1119),
    [anon_sym_yield_BANG] = ACTIONS(1143),
    [anon_sym_lazy] = ACTIONS(1119),
    [anon_sym_assert] = ACTIONS(1119),
    [anon_sym_upcast] = ACTIONS(1119),
    [anon_sym_downcast] = ACTIONS(1119),
    [anon_sym_for] = ACTIONS(1147),
    [anon_sym_while] = ACTIONS(1149),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1151),
    [anon_sym_try] = ACTIONS(1153),
    [anon_sym_match] = ACTIONS(1155),
    [anon_sym_match_BANG] = ACTIONS(1157),
    [anon_sym_function] = ACTIONS(1159),
    [anon_sym_use] = ACTIONS(1167),
    [anon_sym_use_BANG] = ACTIONS(1169),
    [anon_sym_do_BANG] = ACTIONS(1171),
    [anon_sym_begin] = ACTIONS(1173),
    [aux_sym_char_token1] = ACTIONS(1177),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(1181),
    [anon_sym_AT_DQUOTE] = ACTIONS(1183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1185),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1187),
    [sym_bool] = ACTIONS(1189),
    [sym_unit] = ACTIONS(3173),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1193),
    [sym_op_identifier] = ACTIONS(3175),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1197),
    [sym_xint] = ACTIONS(1199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1201),
  },
  [952] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(293),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(952),
    [sym_compiler_directive_decl] = STATE(952),
    [sym_fsi_directive_decl] = STATE(952),
    [sym_preproc_line] = STATE(952),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [953] = {
    [sym_function_or_value_defn] = STATE(953),
    [sym__expression] = STATE(24),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(942),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(1568),
    [sym_block_comment] = STATE(953),
    [sym_compiler_directive_decl] = STATE(953),
    [sym_fsi_directive_decl] = STATE(953),
    [sym_preproc_line] = STATE(953),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(291),
    [anon_sym_return_BANG] = ACTIONS(315),
    [anon_sym_yield] = ACTIONS(291),
    [anon_sym_yield_BANG] = ACTIONS(315),
    [anon_sym_lazy] = ACTIONS(291),
    [anon_sym_assert] = ACTIONS(291),
    [anon_sym_upcast] = ACTIONS(291),
    [anon_sym_downcast] = ACTIONS(291),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(339),
    [anon_sym_use_BANG] = ACTIONS(341),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(369),
    [sym_xint] = ACTIONS(371),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
  },
  [954] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(307),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(954),
    [sym_compiler_directive_decl] = STATE(954),
    [sym_fsi_directive_decl] = STATE(954),
    [sym_preproc_line] = STATE(954),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [955] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(517),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(955),
    [sym_compiler_directive_decl] = STATE(955),
    [sym_fsi_directive_decl] = STATE(955),
    [sym_preproc_line] = STATE(955),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [956] = {
    [sym_function_or_value_defn] = STATE(760),
    [sym__expression] = STATE(13),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(956),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(956),
    [sym_compiler_directive_decl] = STATE(956),
    [sym_fsi_directive_decl] = STATE(956),
    [sym_preproc_line] = STATE(956),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_return] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(269),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(269),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(269),
    [anon_sym_assert] = ACTIONS(269),
    [anon_sym_upcast] = ACTIONS(269),
    [anon_sym_downcast] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(277),
    [anon_sym_use_BANG] = ACTIONS(279),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(281),
    [sym_xint] = ACTIONS(283),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
  },
  [957] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(304),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(890),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(957),
    [sym_compiler_directive_decl] = STATE(957),
    [sym_fsi_directive_decl] = STATE(957),
    [sym_preproc_line] = STATE(957),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
  },
  [958] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(323),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(958),
    [sym_compiler_directive_decl] = STATE(958),
    [sym_fsi_directive_decl] = STATE(958),
    [sym_preproc_line] = STATE(958),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [959] = {
    [sym_function_or_value_defn] = STATE(972),
    [sym__expression] = STATE(189),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(978),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(959),
    [sym_compiler_directive_decl] = STATE(959),
    [sym_fsi_directive_decl] = STATE(959),
    [sym_preproc_line] = STATE(959),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1302),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1302),
    [anon_sym_return_BANG] = ACTIONS(1326),
    [anon_sym_yield] = ACTIONS(1302),
    [anon_sym_yield_BANG] = ACTIONS(1326),
    [anon_sym_lazy] = ACTIONS(1302),
    [anon_sym_assert] = ACTIONS(1302),
    [anon_sym_upcast] = ACTIONS(1302),
    [anon_sym_downcast] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1330),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1352),
    [anon_sym_use_BANG] = ACTIONS(1354),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1384),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [960] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(349),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(960),
    [sym_compiler_directive_decl] = STATE(960),
    [sym_fsi_directive_decl] = STATE(960),
    [sym_preproc_line] = STATE(960),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [961] = {
    [sym_function_or_value_defn] = STATE(972),
    [sym__expression] = STATE(197),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(978),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(961),
    [sym_compiler_directive_decl] = STATE(961),
    [sym_fsi_directive_decl] = STATE(961),
    [sym_preproc_line] = STATE(961),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1302),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1302),
    [anon_sym_return_BANG] = ACTIONS(1326),
    [anon_sym_yield] = ACTIONS(1302),
    [anon_sym_yield_BANG] = ACTIONS(1326),
    [anon_sym_lazy] = ACTIONS(1302),
    [anon_sym_assert] = ACTIONS(1302),
    [anon_sym_upcast] = ACTIONS(1302),
    [anon_sym_downcast] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1330),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1352),
    [anon_sym_use_BANG] = ACTIONS(1354),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1384),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [962] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(488),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(962),
    [sym_compiler_directive_decl] = STATE(962),
    [sym_fsi_directive_decl] = STATE(962),
    [sym_preproc_line] = STATE(962),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [963] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(490),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(963),
    [sym_compiler_directive_decl] = STATE(963),
    [sym_fsi_directive_decl] = STATE(963),
    [sym_preproc_line] = STATE(963),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [964] = {
    [sym_function_or_value_defn] = STATE(964),
    [sym__expression] = STATE(108),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(793),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(964),
    [sym_compiler_directive_decl] = STATE(964),
    [sym_fsi_directive_decl] = STATE(964),
    [sym_preproc_line] = STATE(964),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(53),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(29),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_upcast] = ACTIONS(29),
    [anon_sym_downcast] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(99),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(111),
    [sym_xint] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
  },
  [965] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(492),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(965),
    [sym_compiler_directive_decl] = STATE(965),
    [sym_fsi_directive_decl] = STATE(965),
    [sym_preproc_line] = STATE(965),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [966] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(306),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(890),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(966),
    [sym_compiler_directive_decl] = STATE(966),
    [sym_fsi_directive_decl] = STATE(966),
    [sym_preproc_line] = STATE(966),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
  },
  [967] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(493),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(967),
    [sym_compiler_directive_decl] = STATE(967),
    [sym_fsi_directive_decl] = STATE(967),
    [sym_preproc_line] = STATE(967),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [968] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(494),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(968),
    [sym_compiler_directive_decl] = STATE(968),
    [sym_fsi_directive_decl] = STATE(968),
    [sym_preproc_line] = STATE(968),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [969] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(495),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(969),
    [sym_compiler_directive_decl] = STATE(969),
    [sym_fsi_directive_decl] = STATE(969),
    [sym_preproc_line] = STATE(969),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [970] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(387),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(970),
    [sym_compiler_directive_decl] = STATE(970),
    [sym_fsi_directive_decl] = STATE(970),
    [sym_preproc_line] = STATE(970),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [971] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(506),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(971),
    [sym_compiler_directive_decl] = STATE(971),
    [sym_fsi_directive_decl] = STATE(971),
    [sym_preproc_line] = STATE(971),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [972] = {
    [sym_function_or_value_defn] = STATE(972),
    [sym__expression] = STATE(199),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(978),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(972),
    [sym_compiler_directive_decl] = STATE(972),
    [sym_fsi_directive_decl] = STATE(972),
    [sym_preproc_line] = STATE(972),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1302),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1302),
    [anon_sym_return_BANG] = ACTIONS(1326),
    [anon_sym_yield] = ACTIONS(1302),
    [anon_sym_yield_BANG] = ACTIONS(1326),
    [anon_sym_lazy] = ACTIONS(1302),
    [anon_sym_assert] = ACTIONS(1302),
    [anon_sym_upcast] = ACTIONS(1302),
    [anon_sym_downcast] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1330),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1352),
    [anon_sym_use_BANG] = ACTIONS(1354),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1384),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [973] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(504),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(973),
    [sym_compiler_directive_decl] = STATE(973),
    [sym_fsi_directive_decl] = STATE(973),
    [sym_preproc_line] = STATE(973),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [974] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(487),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1045),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(974),
    [sym_compiler_directive_decl] = STATE(974),
    [sym_fsi_directive_decl] = STATE(974),
    [sym_preproc_line] = STATE(974),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [975] = {
    [sym_function_or_value_defn] = STATE(783),
    [sym__expression] = STATE(371),
    [sym_literal_expression] = STATE(3553),
    [sym_long_identifier_or_op] = STATE(3553),
    [sym_tuple_expression] = STATE(3553),
    [sym_brace_expression] = STATE(3553),
    [sym_anon_record_expression] = STATE(3553),
    [sym_prefixed_expression] = STATE(3553),
    [sym_typecast_expression] = STATE(3553),
    [sym_for_expression] = STATE(3553),
    [sym_while_expression] = STATE(3553),
    [sym__if_branch] = STATE(10567),
    [sym_if_expression] = STATE(3553),
    [sym_fun_expression] = STATE(3553),
    [sym_try_expression] = STATE(3553),
    [sym_match_expression] = STATE(3553),
    [sym_function_expression] = STATE(3553),
    [sym_mutate_expression] = STATE(3553),
    [sym_index_expression] = STATE(3553),
    [sym_typed_expression] = STATE(3553),
    [sym_declaration_expression] = STATE(3553),
    [sym_do_expression] = STATE(3553),
    [sym_list_expression] = STATE(3553),
    [sym_array_expression] = STATE(3553),
    [sym_begin_end_expression] = STATE(3553),
    [sym_paren_expression] = STATE(3553),
    [sym__high_prec_app] = STATE(3532),
    [sym__low_prec_app] = STATE(3532),
    [sym_application_expression] = STATE(3553),
    [sym_dot_expression] = STATE(3553),
    [sym_infix_expression] = STATE(3553),
    [sym_ce_expression] = STATE(3553),
    [sym_sequential_expression] = STATE(3553),
    [sym_char] = STATE(3265),
    [sym_format_string] = STATE(3261),
    [sym__string_literal] = STATE(3261),
    [sym_string] = STATE(3265),
    [sym_verbatim_string] = STATE(3265),
    [sym_bytearray] = STATE(3265),
    [sym_verbatim_bytearray] = STATE(3265),
    [sym_format_triple_quoted_string] = STATE(3260),
    [sym_triple_quoted_string] = STATE(3265),
    [sym_const] = STATE(3553),
    [sym_long_identifier] = STATE(3203),
    [sym_active_pattern] = STATE(3576),
    [sym__identifier_or_op] = STATE(3362),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1076),
    [sym_sbyte] = STATE(3265),
    [sym_byte] = STATE(3265),
    [sym_int16] = STATE(3265),
    [sym_uint16] = STATE(3265),
    [sym_int32] = STATE(3265),
    [sym_uint32] = STATE(3265),
    [sym_nativeint] = STATE(3265),
    [sym_unativeint] = STATE(3265),
    [sym_int64] = STATE(3265),
    [sym_uint64] = STATE(3265),
    [sym_ieee32] = STATE(3265),
    [sym_ieee64] = STATE(3265),
    [sym_bignum] = STATE(3265),
    [sym_decimal] = STATE(3265),
    [sym_float] = STATE(2797),
    [sym_block_comment] = STATE(975),
    [sym_compiler_directive_decl] = STATE(975),
    [sym_fsi_directive_decl] = STATE(975),
    [sym_preproc_line] = STATE(975),
    [sym_preproc_if_in_expression] = STATE(3553),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1632),
    [anon_sym_return] = ACTIONS(1636),
    [anon_sym_do] = ACTIONS(1638),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1640),
    [anon_sym_null] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1646),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_LT_AT] = ACTIONS(1652),
    [anon_sym_LT_AT_AT] = ACTIONS(3021),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1658),
    [anon_sym_new] = ACTIONS(1636),
    [anon_sym_return_BANG] = ACTIONS(1660),
    [anon_sym_yield] = ACTIONS(1636),
    [anon_sym_yield_BANG] = ACTIONS(1660),
    [anon_sym_lazy] = ACTIONS(1636),
    [anon_sym_assert] = ACTIONS(1636),
    [anon_sym_upcast] = ACTIONS(1636),
    [anon_sym_downcast] = ACTIONS(1636),
    [anon_sym_for] = ACTIONS(1664),
    [anon_sym_while] = ACTIONS(1666),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1668),
    [anon_sym_try] = ACTIONS(1670),
    [anon_sym_match] = ACTIONS(1672),
    [anon_sym_match_BANG] = ACTIONS(1674),
    [anon_sym_function] = ACTIONS(1676),
    [anon_sym_use] = ACTIONS(1684),
    [anon_sym_use_BANG] = ACTIONS(1686),
    [anon_sym_do_BANG] = ACTIONS(1688),
    [anon_sym_begin] = ACTIONS(1690),
    [aux_sym_char_token1] = ACTIONS(1694),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1696),
    [anon_sym_DQUOTE] = ACTIONS(1698),
    [anon_sym_AT_DQUOTE] = ACTIONS(1700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1704),
    [sym_bool] = ACTIONS(1706),
    [sym_unit] = ACTIONS(3023),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1710),
    [sym_op_identifier] = ACTIONS(3025),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1714),
    [sym_xint] = ACTIONS(1716),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1718),
  },
  [976] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(500),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(976),
    [sym_compiler_directive_decl] = STATE(976),
    [sym_fsi_directive_decl] = STATE(976),
    [sym_preproc_line] = STATE(976),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [977] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(512),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(977),
    [sym_compiler_directive_decl] = STATE(977),
    [sym_fsi_directive_decl] = STATE(977),
    [sym_preproc_line] = STATE(977),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [978] = {
    [sym_function_or_value_defn] = STATE(972),
    [sym__expression] = STATE(201),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(978),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(978),
    [sym_compiler_directive_decl] = STATE(978),
    [sym_fsi_directive_decl] = STATE(978),
    [sym_preproc_line] = STATE(978),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1302),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1302),
    [anon_sym_return_BANG] = ACTIONS(1326),
    [anon_sym_yield] = ACTIONS(1302),
    [anon_sym_yield_BANG] = ACTIONS(1326),
    [anon_sym_lazy] = ACTIONS(1302),
    [anon_sym_assert] = ACTIONS(1302),
    [anon_sym_upcast] = ACTIONS(1302),
    [anon_sym_downcast] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1330),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1352),
    [anon_sym_use_BANG] = ACTIONS(1354),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1384),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [979] = {
    [sym_function_or_value_defn] = STATE(783),
    [sym__expression] = STATE(315),
    [sym_literal_expression] = STATE(3553),
    [sym_long_identifier_or_op] = STATE(3553),
    [sym_tuple_expression] = STATE(3553),
    [sym_brace_expression] = STATE(3553),
    [sym_anon_record_expression] = STATE(3553),
    [sym_prefixed_expression] = STATE(3553),
    [sym_typecast_expression] = STATE(3553),
    [sym_for_expression] = STATE(3553),
    [sym_while_expression] = STATE(3553),
    [sym__if_branch] = STATE(10567),
    [sym_if_expression] = STATE(3553),
    [sym_fun_expression] = STATE(3553),
    [sym_try_expression] = STATE(3553),
    [sym_match_expression] = STATE(3553),
    [sym_function_expression] = STATE(3553),
    [sym_mutate_expression] = STATE(3553),
    [sym_index_expression] = STATE(3553),
    [sym_typed_expression] = STATE(3553),
    [sym_declaration_expression] = STATE(3553),
    [sym_do_expression] = STATE(3553),
    [sym_list_expression] = STATE(3553),
    [sym_array_expression] = STATE(3553),
    [sym_begin_end_expression] = STATE(3553),
    [sym_paren_expression] = STATE(3553),
    [sym__high_prec_app] = STATE(3532),
    [sym__low_prec_app] = STATE(3532),
    [sym_application_expression] = STATE(3553),
    [sym_dot_expression] = STATE(3553),
    [sym_infix_expression] = STATE(3553),
    [sym_ce_expression] = STATE(3553),
    [sym_sequential_expression] = STATE(3553),
    [sym_char] = STATE(3265),
    [sym_format_string] = STATE(3261),
    [sym__string_literal] = STATE(3261),
    [sym_string] = STATE(3265),
    [sym_verbatim_string] = STATE(3265),
    [sym_bytearray] = STATE(3265),
    [sym_verbatim_bytearray] = STATE(3265),
    [sym_format_triple_quoted_string] = STATE(3260),
    [sym_triple_quoted_string] = STATE(3265),
    [sym_const] = STATE(3553),
    [sym_long_identifier] = STATE(3203),
    [sym_active_pattern] = STATE(3576),
    [sym__identifier_or_op] = STATE(3362),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1076),
    [sym_sbyte] = STATE(3265),
    [sym_byte] = STATE(3265),
    [sym_int16] = STATE(3265),
    [sym_uint16] = STATE(3265),
    [sym_int32] = STATE(3265),
    [sym_uint32] = STATE(3265),
    [sym_nativeint] = STATE(3265),
    [sym_unativeint] = STATE(3265),
    [sym_int64] = STATE(3265),
    [sym_uint64] = STATE(3265),
    [sym_ieee32] = STATE(3265),
    [sym_ieee64] = STATE(3265),
    [sym_bignum] = STATE(3265),
    [sym_decimal] = STATE(3265),
    [sym_float] = STATE(2797),
    [sym_block_comment] = STATE(979),
    [sym_compiler_directive_decl] = STATE(979),
    [sym_fsi_directive_decl] = STATE(979),
    [sym_preproc_line] = STATE(979),
    [sym_preproc_if_in_expression] = STATE(3553),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1632),
    [anon_sym_return] = ACTIONS(1636),
    [anon_sym_do] = ACTIONS(1638),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1640),
    [anon_sym_null] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1646),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_LT_AT] = ACTIONS(1652),
    [anon_sym_LT_AT_AT] = ACTIONS(3021),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1658),
    [anon_sym_new] = ACTIONS(1636),
    [anon_sym_return_BANG] = ACTIONS(1660),
    [anon_sym_yield] = ACTIONS(1636),
    [anon_sym_yield_BANG] = ACTIONS(1660),
    [anon_sym_lazy] = ACTIONS(1636),
    [anon_sym_assert] = ACTIONS(1636),
    [anon_sym_upcast] = ACTIONS(1636),
    [anon_sym_downcast] = ACTIONS(1636),
    [anon_sym_for] = ACTIONS(1664),
    [anon_sym_while] = ACTIONS(1666),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1668),
    [anon_sym_try] = ACTIONS(1670),
    [anon_sym_match] = ACTIONS(1672),
    [anon_sym_match_BANG] = ACTIONS(1674),
    [anon_sym_function] = ACTIONS(1676),
    [anon_sym_use] = ACTIONS(1684),
    [anon_sym_use_BANG] = ACTIONS(1686),
    [anon_sym_do_BANG] = ACTIONS(1688),
    [anon_sym_begin] = ACTIONS(1690),
    [aux_sym_char_token1] = ACTIONS(1694),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1696),
    [anon_sym_DQUOTE] = ACTIONS(1698),
    [anon_sym_AT_DQUOTE] = ACTIONS(1700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1704),
    [sym_bool] = ACTIONS(1706),
    [sym_unit] = ACTIONS(3023),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1710),
    [sym_op_identifier] = ACTIONS(3025),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1714),
    [sym_xint] = ACTIONS(1716),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1718),
  },
  [980] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(496),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1045),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(980),
    [sym_compiler_directive_decl] = STATE(980),
    [sym_fsi_directive_decl] = STATE(980),
    [sym_preproc_line] = STATE(980),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [981] = {
    [sym_function_or_value_defn] = STATE(783),
    [sym__expression] = STATE(350),
    [sym_literal_expression] = STATE(3553),
    [sym_long_identifier_or_op] = STATE(3553),
    [sym_tuple_expression] = STATE(3553),
    [sym_brace_expression] = STATE(3553),
    [sym_anon_record_expression] = STATE(3553),
    [sym_prefixed_expression] = STATE(3553),
    [sym_typecast_expression] = STATE(3553),
    [sym_for_expression] = STATE(3553),
    [sym_while_expression] = STATE(3553),
    [sym__if_branch] = STATE(10567),
    [sym_if_expression] = STATE(3553),
    [sym_fun_expression] = STATE(3553),
    [sym_try_expression] = STATE(3553),
    [sym_match_expression] = STATE(3553),
    [sym_function_expression] = STATE(3553),
    [sym_mutate_expression] = STATE(3553),
    [sym_index_expression] = STATE(3553),
    [sym_typed_expression] = STATE(3553),
    [sym_declaration_expression] = STATE(3553),
    [sym_do_expression] = STATE(3553),
    [sym_list_expression] = STATE(3553),
    [sym_array_expression] = STATE(3553),
    [sym_begin_end_expression] = STATE(3553),
    [sym_paren_expression] = STATE(3553),
    [sym__high_prec_app] = STATE(3532),
    [sym__low_prec_app] = STATE(3532),
    [sym_application_expression] = STATE(3553),
    [sym_dot_expression] = STATE(3553),
    [sym_infix_expression] = STATE(3553),
    [sym_ce_expression] = STATE(3553),
    [sym_sequential_expression] = STATE(3553),
    [sym_char] = STATE(3265),
    [sym_format_string] = STATE(3261),
    [sym__string_literal] = STATE(3261),
    [sym_string] = STATE(3265),
    [sym_verbatim_string] = STATE(3265),
    [sym_bytearray] = STATE(3265),
    [sym_verbatim_bytearray] = STATE(3265),
    [sym_format_triple_quoted_string] = STATE(3260),
    [sym_triple_quoted_string] = STATE(3265),
    [sym_const] = STATE(3553),
    [sym_long_identifier] = STATE(3203),
    [sym_active_pattern] = STATE(3576),
    [sym__identifier_or_op] = STATE(3362),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1076),
    [sym_sbyte] = STATE(3265),
    [sym_byte] = STATE(3265),
    [sym_int16] = STATE(3265),
    [sym_uint16] = STATE(3265),
    [sym_int32] = STATE(3265),
    [sym_uint32] = STATE(3265),
    [sym_nativeint] = STATE(3265),
    [sym_unativeint] = STATE(3265),
    [sym_int64] = STATE(3265),
    [sym_uint64] = STATE(3265),
    [sym_ieee32] = STATE(3265),
    [sym_ieee64] = STATE(3265),
    [sym_bignum] = STATE(3265),
    [sym_decimal] = STATE(3265),
    [sym_float] = STATE(2797),
    [sym_block_comment] = STATE(981),
    [sym_compiler_directive_decl] = STATE(981),
    [sym_fsi_directive_decl] = STATE(981),
    [sym_preproc_line] = STATE(981),
    [sym_preproc_if_in_expression] = STATE(3553),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1632),
    [anon_sym_return] = ACTIONS(1636),
    [anon_sym_do] = ACTIONS(1638),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1640),
    [anon_sym_null] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1646),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_LT_AT] = ACTIONS(1652),
    [anon_sym_LT_AT_AT] = ACTIONS(3021),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1658),
    [anon_sym_new] = ACTIONS(1636),
    [anon_sym_return_BANG] = ACTIONS(1660),
    [anon_sym_yield] = ACTIONS(1636),
    [anon_sym_yield_BANG] = ACTIONS(1660),
    [anon_sym_lazy] = ACTIONS(1636),
    [anon_sym_assert] = ACTIONS(1636),
    [anon_sym_upcast] = ACTIONS(1636),
    [anon_sym_downcast] = ACTIONS(1636),
    [anon_sym_for] = ACTIONS(1664),
    [anon_sym_while] = ACTIONS(1666),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1668),
    [anon_sym_try] = ACTIONS(1670),
    [anon_sym_match] = ACTIONS(1672),
    [anon_sym_match_BANG] = ACTIONS(1674),
    [anon_sym_function] = ACTIONS(1676),
    [anon_sym_use] = ACTIONS(1684),
    [anon_sym_use_BANG] = ACTIONS(1686),
    [anon_sym_do_BANG] = ACTIONS(1688),
    [anon_sym_begin] = ACTIONS(1690),
    [aux_sym_char_token1] = ACTIONS(1694),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1696),
    [anon_sym_DQUOTE] = ACTIONS(1698),
    [anon_sym_AT_DQUOTE] = ACTIONS(1700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1704),
    [sym_bool] = ACTIONS(1706),
    [sym_unit] = ACTIONS(3023),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1710),
    [sym_op_identifier] = ACTIONS(3025),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1714),
    [sym_xint] = ACTIONS(1716),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1718),
  },
  [982] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(483),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(982),
    [sym_compiler_directive_decl] = STATE(982),
    [sym_fsi_directive_decl] = STATE(982),
    [sym_preproc_line] = STATE(982),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [983] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(479),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(983),
    [sym_compiler_directive_decl] = STATE(983),
    [sym_fsi_directive_decl] = STATE(983),
    [sym_preproc_line] = STATE(983),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [984] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(83),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(946),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(984),
    [sym_compiler_directive_decl] = STATE(984),
    [sym_fsi_directive_decl] = STATE(984),
    [sym_preproc_line] = STATE(984),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(753),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [985] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(476),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(985),
    [sym_compiler_directive_decl] = STATE(985),
    [sym_fsi_directive_decl] = STATE(985),
    [sym_preproc_line] = STATE(985),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [986] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(290),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(986),
    [sym_compiler_directive_decl] = STATE(986),
    [sym_fsi_directive_decl] = STATE(986),
    [sym_preproc_line] = STATE(986),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [987] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(470),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(987),
    [sym_compiler_directive_decl] = STATE(987),
    [sym_fsi_directive_decl] = STATE(987),
    [sym_preproc_line] = STATE(987),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [988] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(122),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(988),
    [sym_compiler_directive_decl] = STATE(988),
    [sym_fsi_directive_decl] = STATE(988),
    [sym_preproc_line] = STATE(988),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [989] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(468),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(989),
    [sym_compiler_directive_decl] = STATE(989),
    [sym_fsi_directive_decl] = STATE(989),
    [sym_preproc_line] = STATE(989),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [990] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(81),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(946),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(990),
    [sym_compiler_directive_decl] = STATE(990),
    [sym_fsi_directive_decl] = STATE(990),
    [sym_preproc_line] = STATE(990),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(753),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [991] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(502),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(991),
    [sym_compiler_directive_decl] = STATE(991),
    [sym_fsi_directive_decl] = STATE(991),
    [sym_preproc_line] = STATE(991),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [992] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(508),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(992),
    [sym_compiler_directive_decl] = STATE(992),
    [sym_fsi_directive_decl] = STATE(992),
    [sym_preproc_line] = STATE(992),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [993] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(435),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(993),
    [sym_compiler_directive_decl] = STATE(993),
    [sym_fsi_directive_decl] = STATE(993),
    [sym_preproc_line] = STATE(993),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [994] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(511),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(994),
    [sym_compiler_directive_decl] = STATE(994),
    [sym_fsi_directive_decl] = STATE(994),
    [sym_preproc_line] = STATE(994),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [995] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(465),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(995),
    [sym_compiler_directive_decl] = STATE(995),
    [sym_fsi_directive_decl] = STATE(995),
    [sym_preproc_line] = STATE(995),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [996] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(464),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(996),
    [sym_compiler_directive_decl] = STATE(996),
    [sym_fsi_directive_decl] = STATE(996),
    [sym_preproc_line] = STATE(996),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [997] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(111),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(997),
    [sym_compiler_directive_decl] = STATE(997),
    [sym_fsi_directive_decl] = STATE(997),
    [sym_preproc_line] = STATE(997),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [998] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(491),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1045),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(998),
    [sym_compiler_directive_decl] = STATE(998),
    [sym_fsi_directive_decl] = STATE(998),
    [sym_preproc_line] = STATE(998),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [999] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(507),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(999),
    [sym_compiler_directive_decl] = STATE(999),
    [sym_fsi_directive_decl] = STATE(999),
    [sym_preproc_line] = STATE(999),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [1000] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(478),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(1000),
    [sym_compiler_directive_decl] = STATE(1000),
    [sym_fsi_directive_decl] = STATE(1000),
    [sym_preproc_line] = STATE(1000),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [1001] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(527),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(1001),
    [sym_compiler_directive_decl] = STATE(1001),
    [sym_fsi_directive_decl] = STATE(1001),
    [sym_preproc_line] = STATE(1001),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [1002] = {
    [sym_function_or_value_defn] = STATE(1166),
    [sym__expression] = STATE(133),
    [sym_literal_expression] = STATE(2884),
    [sym_long_identifier_or_op] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_brace_expression] = STATE(2884),
    [sym_anon_record_expression] = STATE(2884),
    [sym_prefixed_expression] = STATE(2884),
    [sym_typecast_expression] = STATE(2884),
    [sym_for_expression] = STATE(2884),
    [sym_while_expression] = STATE(2884),
    [sym__if_branch] = STATE(10729),
    [sym_if_expression] = STATE(2884),
    [sym_fun_expression] = STATE(2884),
    [sym_try_expression] = STATE(2884),
    [sym_match_expression] = STATE(2884),
    [sym_function_expression] = STATE(2884),
    [sym_mutate_expression] = STATE(2884),
    [sym_index_expression] = STATE(2884),
    [sym_typed_expression] = STATE(2884),
    [sym_declaration_expression] = STATE(2884),
    [sym_do_expression] = STATE(2884),
    [sym_list_expression] = STATE(2884),
    [sym_array_expression] = STATE(2884),
    [sym_begin_end_expression] = STATE(2884),
    [sym_paren_expression] = STATE(2884),
    [sym__high_prec_app] = STATE(2872),
    [sym__low_prec_app] = STATE(2872),
    [sym_application_expression] = STATE(2884),
    [sym_dot_expression] = STATE(2884),
    [sym_infix_expression] = STATE(2884),
    [sym_ce_expression] = STATE(2884),
    [sym_sequential_expression] = STATE(2884),
    [sym_char] = STATE(2955),
    [sym_format_string] = STATE(2951),
    [sym__string_literal] = STATE(2951),
    [sym_string] = STATE(2955),
    [sym_verbatim_string] = STATE(2955),
    [sym_bytearray] = STATE(2955),
    [sym_verbatim_bytearray] = STATE(2955),
    [sym_format_triple_quoted_string] = STATE(2949),
    [sym_triple_quoted_string] = STATE(2955),
    [sym_const] = STATE(2884),
    [sym_long_identifier] = STATE(2885),
    [sym_active_pattern] = STATE(2833),
    [sym__identifier_or_op] = STATE(2883),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1002),
    [sym_sbyte] = STATE(2955),
    [sym_byte] = STATE(2955),
    [sym_int16] = STATE(2955),
    [sym_uint16] = STATE(2955),
    [sym_int32] = STATE(2955),
    [sym_uint32] = STATE(2955),
    [sym_nativeint] = STATE(2955),
    [sym_unativeint] = STATE(2955),
    [sym_int64] = STATE(2955),
    [sym_uint64] = STATE(2955),
    [sym_ieee32] = STATE(2955),
    [sym_ieee64] = STATE(2955),
    [sym_bignum] = STATE(2955),
    [sym_decimal] = STATE(2955),
    [sym_float] = STATE(2652),
    [sym_block_comment] = STATE(1002),
    [sym_compiler_directive_decl] = STATE(1002),
    [sym_fsi_directive_decl] = STATE(1002),
    [sym_preproc_line] = STATE(1002),
    [sym_preproc_if_in_expression] = STATE(2884),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_do] = ACTIONS(1003),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_null] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1013),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1015),
    [anon_sym_LBRACE] = ACTIONS(3181),
    [anon_sym_LT_AT] = ACTIONS(1019),
    [anon_sym_LT_AT_AT] = ACTIONS(3183),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1025),
    [anon_sym_new] = ACTIONS(1001),
    [anon_sym_return_BANG] = ACTIONS(1029),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_yield_BANG] = ACTIONS(1029),
    [anon_sym_lazy] = ACTIONS(1001),
    [anon_sym_assert] = ACTIONS(1001),
    [anon_sym_upcast] = ACTIONS(1001),
    [anon_sym_downcast] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1033),
    [anon_sym_while] = ACTIONS(1035),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1037),
    [anon_sym_try] = ACTIONS(1039),
    [anon_sym_match] = ACTIONS(1041),
    [anon_sym_match_BANG] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(1045),
    [anon_sym_use] = ACTIONS(1053),
    [anon_sym_use_BANG] = ACTIONS(1055),
    [anon_sym_do_BANG] = ACTIONS(1057),
    [anon_sym_begin] = ACTIONS(1059),
    [aux_sym_char_token1] = ACTIONS(1063),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1067),
    [anon_sym_AT_DQUOTE] = ACTIONS(1069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1073),
    [sym_bool] = ACTIONS(1075),
    [sym_unit] = ACTIONS(3185),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1079),
    [sym_op_identifier] = ACTIONS(3187),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1083),
    [sym_xint] = ACTIONS(1085),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1087),
  },
  [1003] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(521),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(1003),
    [sym_compiler_directive_decl] = STATE(1003),
    [sym_fsi_directive_decl] = STATE(1003),
    [sym_preproc_line] = STATE(1003),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [1004] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(524),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(1004),
    [sym_compiler_directive_decl] = STATE(1004),
    [sym_fsi_directive_decl] = STATE(1004),
    [sym_preproc_line] = STATE(1004),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [1005] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(458),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1005),
    [sym_compiler_directive_decl] = STATE(1005),
    [sym_fsi_directive_decl] = STATE(1005),
    [sym_preproc_line] = STATE(1005),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1006] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(454),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1006),
    [sym_compiler_directive_decl] = STATE(1006),
    [sym_fsi_directive_decl] = STATE(1006),
    [sym_preproc_line] = STATE(1006),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1007] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(283),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1045),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(1007),
    [sym_compiler_directive_decl] = STATE(1007),
    [sym_fsi_directive_decl] = STATE(1007),
    [sym_preproc_line] = STATE(1007),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [1008] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(447),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1008),
    [sym_compiler_directive_decl] = STATE(1008),
    [sym_fsi_directive_decl] = STATE(1008),
    [sym_preproc_line] = STATE(1008),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1009] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(460),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1045),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(1009),
    [sym_compiler_directive_decl] = STATE(1009),
    [sym_fsi_directive_decl] = STATE(1009),
    [sym_preproc_line] = STATE(1009),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [1010] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(445),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1010),
    [sym_compiler_directive_decl] = STATE(1010),
    [sym_fsi_directive_decl] = STATE(1010),
    [sym_preproc_line] = STATE(1010),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1011] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(455),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1011),
    [sym_compiler_directive_decl] = STATE(1011),
    [sym_fsi_directive_decl] = STATE(1011),
    [sym_preproc_line] = STATE(1011),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1012] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(444),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1012),
    [sym_compiler_directive_decl] = STATE(1012),
    [sym_fsi_directive_decl] = STATE(1012),
    [sym_preproc_line] = STATE(1012),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1013] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(162),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1013),
    [sym_compiler_directive_decl] = STATE(1013),
    [sym_fsi_directive_decl] = STATE(1013),
    [sym_preproc_line] = STATE(1013),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1014] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(438),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1014),
    [sym_compiler_directive_decl] = STATE(1014),
    [sym_fsi_directive_decl] = STATE(1014),
    [sym_preproc_line] = STATE(1014),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1015] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(437),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1015),
    [sym_compiler_directive_decl] = STATE(1015),
    [sym_fsi_directive_decl] = STATE(1015),
    [sym_preproc_line] = STATE(1015),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1016] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(436),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1016),
    [sym_compiler_directive_decl] = STATE(1016),
    [sym_fsi_directive_decl] = STATE(1016),
    [sym_preproc_line] = STATE(1016),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1017] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(362),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1017),
    [sym_compiler_directive_decl] = STATE(1017),
    [sym_fsi_directive_decl] = STATE(1017),
    [sym_preproc_line] = STATE(1017),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1018] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(110),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(1018),
    [sym_compiler_directive_decl] = STATE(1018),
    [sym_fsi_directive_decl] = STATE(1018),
    [sym_preproc_line] = STATE(1018),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [1019] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(423),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1019),
    [sym_compiler_directive_decl] = STATE(1019),
    [sym_fsi_directive_decl] = STATE(1019),
    [sym_preproc_line] = STATE(1019),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1020] = {
    [sym_function_or_value_defn] = STATE(1099),
    [sym__expression] = STATE(321),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1020),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(2924),
    [sym_block_comment] = STATE(1020),
    [sym_compiler_directive_decl] = STATE(1020),
    [sym_fsi_directive_decl] = STATE(1020),
    [sym_preproc_line] = STATE(1020),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(2638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(1492),
    [anon_sym_return_BANG] = ACTIONS(1496),
    [anon_sym_yield] = ACTIONS(1492),
    [anon_sym_yield_BANG] = ACTIONS(1496),
    [anon_sym_lazy] = ACTIONS(1492),
    [anon_sym_assert] = ACTIONS(1492),
    [anon_sym_upcast] = ACTIONS(1492),
    [anon_sym_downcast] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_use] = ACTIONS(1500),
    [anon_sym_use_BANG] = ACTIONS(1502),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(2642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1504),
    [sym_xint] = ACTIONS(1506),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
  },
  [1021] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(414),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1021),
    [sym_compiler_directive_decl] = STATE(1021),
    [sym_fsi_directive_decl] = STATE(1021),
    [sym_preproc_line] = STATE(1021),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1022] = {
    [sym_function_or_value_defn] = STATE(928),
    [sym__expression] = STATE(503),
    [sym_literal_expression] = STATE(3541),
    [sym_long_identifier_or_op] = STATE(3541),
    [sym_tuple_expression] = STATE(3541),
    [sym_brace_expression] = STATE(3541),
    [sym_anon_record_expression] = STATE(3541),
    [sym_prefixed_expression] = STATE(3541),
    [sym_typecast_expression] = STATE(3541),
    [sym_for_expression] = STATE(3541),
    [sym_while_expression] = STATE(3541),
    [sym__if_branch] = STATE(10235),
    [sym_if_expression] = STATE(3541),
    [sym_fun_expression] = STATE(3541),
    [sym_try_expression] = STATE(3541),
    [sym_match_expression] = STATE(3541),
    [sym_function_expression] = STATE(3541),
    [sym_mutate_expression] = STATE(3541),
    [sym_index_expression] = STATE(3541),
    [sym_typed_expression] = STATE(3541),
    [sym_declaration_expression] = STATE(3541),
    [sym_do_expression] = STATE(3541),
    [sym_list_expression] = STATE(3541),
    [sym_array_expression] = STATE(3541),
    [sym_begin_end_expression] = STATE(3541),
    [sym_paren_expression] = STATE(3541),
    [sym__high_prec_app] = STATE(3564),
    [sym__low_prec_app] = STATE(3564),
    [sym_application_expression] = STATE(3541),
    [sym_dot_expression] = STATE(3541),
    [sym_infix_expression] = STATE(3541),
    [sym_ce_expression] = STATE(3541),
    [sym_sequential_expression] = STATE(3541),
    [sym_char] = STATE(3449),
    [sym_format_string] = STATE(3390),
    [sym__string_literal] = STATE(3390),
    [sym_string] = STATE(3449),
    [sym_verbatim_string] = STATE(3449),
    [sym_bytearray] = STATE(3449),
    [sym_verbatim_bytearray] = STATE(3449),
    [sym_format_triple_quoted_string] = STATE(3448),
    [sym_triple_quoted_string] = STATE(3449),
    [sym_const] = STATE(3541),
    [sym_long_identifier] = STATE(3445),
    [sym_active_pattern] = STATE(3466),
    [sym__identifier_or_op] = STATE(3577),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1022),
    [sym_sbyte] = STATE(3449),
    [sym_byte] = STATE(3449),
    [sym_int16] = STATE(3449),
    [sym_uint16] = STATE(3449),
    [sym_int32] = STATE(3449),
    [sym_uint32] = STATE(3449),
    [sym_nativeint] = STATE(3449),
    [sym_unativeint] = STATE(3449),
    [sym_int64] = STATE(3449),
    [sym_uint64] = STATE(3449),
    [sym_ieee32] = STATE(3449),
    [sym_ieee64] = STATE(3449),
    [sym_bignum] = STATE(3449),
    [sym_decimal] = STATE(3449),
    [sym_float] = STATE(2966),
    [sym_block_comment] = STATE(1022),
    [sym_compiler_directive_decl] = STATE(1022),
    [sym_fsi_directive_decl] = STATE(1022),
    [sym_preproc_line] = STATE(1022),
    [sym_preproc_if_in_expression] = STATE(3541),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_return] = ACTIONS(1830),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_null] = ACTIONS(1838),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(1846),
    [anon_sym_LT_AT_AT] = ACTIONS(3069),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1830),
    [anon_sym_return_BANG] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1830),
    [anon_sym_yield_BANG] = ACTIONS(1854),
    [anon_sym_lazy] = ACTIONS(1830),
    [anon_sym_assert] = ACTIONS(1830),
    [anon_sym_upcast] = ACTIONS(1830),
    [anon_sym_downcast] = ACTIONS(1830),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_match] = ACTIONS(1866),
    [anon_sym_match_BANG] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_use] = ACTIONS(1878),
    [anon_sym_use_BANG] = ACTIONS(1880),
    [anon_sym_do_BANG] = ACTIONS(1882),
    [anon_sym_begin] = ACTIONS(1884),
    [aux_sym_char_token1] = ACTIONS(1888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1892),
    [anon_sym_AT_DQUOTE] = ACTIONS(1894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1898),
    [sym_bool] = ACTIONS(1900),
    [sym_unit] = ACTIONS(3071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1904),
    [sym_op_identifier] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1908),
    [sym_xint] = ACTIONS(1910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1912),
  },
  [1023] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(518),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(1023),
    [sym_compiler_directive_decl] = STATE(1023),
    [sym_fsi_directive_decl] = STATE(1023),
    [sym_preproc_line] = STATE(1023),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [1024] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(249),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1024),
    [sym_compiler_directive_decl] = STATE(1024),
    [sym_fsi_directive_decl] = STATE(1024),
    [sym_preproc_line] = STATE(1024),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1025] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(412),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1025),
    [sym_compiler_directive_decl] = STATE(1025),
    [sym_fsi_directive_decl] = STATE(1025),
    [sym_preproc_line] = STATE(1025),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1026] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(214),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(1026),
    [sym_compiler_directive_decl] = STATE(1026),
    [sym_fsi_directive_decl] = STATE(1026),
    [sym_preproc_line] = STATE(1026),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
  },
  [1027] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(538),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(1027),
    [sym_compiler_directive_decl] = STATE(1027),
    [sym_fsi_directive_decl] = STATE(1027),
    [sym_preproc_line] = STATE(1027),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [1028] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(119),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(1028),
    [sym_compiler_directive_decl] = STATE(1028),
    [sym_fsi_directive_decl] = STATE(1028),
    [sym_preproc_line] = STATE(1028),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [1029] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(410),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1029),
    [sym_compiler_directive_decl] = STATE(1029),
    [sym_fsi_directive_decl] = STATE(1029),
    [sym_preproc_line] = STATE(1029),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1030] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(409),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1030),
    [sym_compiler_directive_decl] = STATE(1030),
    [sym_fsi_directive_decl] = STATE(1030),
    [sym_preproc_line] = STATE(1030),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1031] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(532),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(1031),
    [sym_compiler_directive_decl] = STATE(1031),
    [sym_fsi_directive_decl] = STATE(1031),
    [sym_preproc_line] = STATE(1031),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [1032] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(364),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(1032),
    [sym_compiler_directive_decl] = STATE(1032),
    [sym_fsi_directive_decl] = STATE(1032),
    [sym_preproc_line] = STATE(1032),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [1033] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(405),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1151),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(1033),
    [sym_compiler_directive_decl] = STATE(1033),
    [sym_fsi_directive_decl] = STATE(1033),
    [sym_preproc_line] = STATE(1033),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_begin] = ACTIONS(1782),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
  },
  [1034] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(408),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1034),
    [sym_compiler_directive_decl] = STATE(1034),
    [sym_fsi_directive_decl] = STATE(1034),
    [sym_preproc_line] = STATE(1034),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1035] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(434),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1045),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(1035),
    [sym_compiler_directive_decl] = STATE(1035),
    [sym_fsi_directive_decl] = STATE(1035),
    [sym_preproc_line] = STATE(1035),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [1036] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(522),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(1036),
    [sym_compiler_directive_decl] = STATE(1036),
    [sym_fsi_directive_decl] = STATE(1036),
    [sym_preproc_line] = STATE(1036),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [1037] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(406),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1037),
    [sym_compiler_directive_decl] = STATE(1037),
    [sym_fsi_directive_decl] = STATE(1037),
    [sym_preproc_line] = STATE(1037),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1038] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(398),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1038),
    [sym_compiler_directive_decl] = STATE(1038),
    [sym_fsi_directive_decl] = STATE(1038),
    [sym_preproc_line] = STATE(1038),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1039] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(415),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1039),
    [sym_compiler_directive_decl] = STATE(1039),
    [sym_fsi_directive_decl] = STATE(1039),
    [sym_preproc_line] = STATE(1039),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1040] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(526),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(1040),
    [sym_compiler_directive_decl] = STATE(1040),
    [sym_fsi_directive_decl] = STATE(1040),
    [sym_preproc_line] = STATE(1040),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [1041] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(519),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(1041),
    [sym_compiler_directive_decl] = STATE(1041),
    [sym_fsi_directive_decl] = STATE(1041),
    [sym_preproc_line] = STATE(1041),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [1042] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(407),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1045),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(1042),
    [sym_compiler_directive_decl] = STATE(1042),
    [sym_fsi_directive_decl] = STATE(1042),
    [sym_preproc_line] = STATE(1042),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [1043] = {
    [sym_function_or_value_defn] = STATE(760),
    [sym__expression] = STATE(22),
    [sym_literal_expression] = STATE(1329),
    [sym_long_identifier_or_op] = STATE(1329),
    [sym_tuple_expression] = STATE(1329),
    [sym_brace_expression] = STATE(1329),
    [sym_anon_record_expression] = STATE(1329),
    [sym_prefixed_expression] = STATE(1329),
    [sym_typecast_expression] = STATE(1329),
    [sym_for_expression] = STATE(1329),
    [sym_while_expression] = STATE(1329),
    [sym__if_branch] = STATE(10771),
    [sym_if_expression] = STATE(1329),
    [sym_fun_expression] = STATE(1329),
    [sym_try_expression] = STATE(1329),
    [sym_match_expression] = STATE(1329),
    [sym_function_expression] = STATE(1329),
    [sym_mutate_expression] = STATE(1329),
    [sym_index_expression] = STATE(1329),
    [sym_typed_expression] = STATE(1329),
    [sym_declaration_expression] = STATE(1329),
    [sym_do_expression] = STATE(1329),
    [sym_list_expression] = STATE(1329),
    [sym_array_expression] = STATE(1329),
    [sym_begin_end_expression] = STATE(1329),
    [sym_paren_expression] = STATE(1329),
    [sym__high_prec_app] = STATE(1323),
    [sym__low_prec_app] = STATE(1323),
    [sym_application_expression] = STATE(1329),
    [sym_dot_expression] = STATE(1329),
    [sym_infix_expression] = STATE(1329),
    [sym_ce_expression] = STATE(1329),
    [sym_sequential_expression] = STATE(1329),
    [sym_char] = STATE(1317),
    [sym_format_string] = STATE(1345),
    [sym__string_literal] = STATE(1345),
    [sym_string] = STATE(1317),
    [sym_verbatim_string] = STATE(1317),
    [sym_bytearray] = STATE(1317),
    [sym_verbatim_bytearray] = STATE(1317),
    [sym_format_triple_quoted_string] = STATE(1351),
    [sym_triple_quoted_string] = STATE(1317),
    [sym_const] = STATE(1329),
    [sym_long_identifier] = STATE(1469),
    [sym_active_pattern] = STATE(1401),
    [sym__identifier_or_op] = STATE(1459),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(956),
    [sym_sbyte] = STATE(1317),
    [sym_byte] = STATE(1317),
    [sym_int16] = STATE(1317),
    [sym_uint16] = STATE(1317),
    [sym_int32] = STATE(1317),
    [sym_uint32] = STATE(1317),
    [sym_nativeint] = STATE(1317),
    [sym_unativeint] = STATE(1317),
    [sym_int64] = STATE(1317),
    [sym_uint64] = STATE(1317),
    [sym_ieee32] = STATE(1317),
    [sym_ieee64] = STATE(1317),
    [sym_bignum] = STATE(1317),
    [sym_decimal] = STATE(1317),
    [sym_float] = STATE(1267),
    [sym_block_comment] = STATE(1043),
    [sym_compiler_directive_decl] = STATE(1043),
    [sym_fsi_directive_decl] = STATE(1043),
    [sym_preproc_line] = STATE(1043),
    [sym_preproc_if_in_expression] = STATE(1329),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_return] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(131),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_null] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_LT_AT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(269),
    [anon_sym_return_BANG] = ACTIONS(273),
    [anon_sym_yield] = ACTIONS(269),
    [anon_sym_yield_BANG] = ACTIONS(273),
    [anon_sym_lazy] = ACTIONS(269),
    [anon_sym_assert] = ACTIONS(269),
    [anon_sym_upcast] = ACTIONS(269),
    [anon_sym_downcast] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_match] = ACTIONS(171),
    [anon_sym_match_BANG] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(277),
    [anon_sym_use_BANG] = ACTIONS(279),
    [anon_sym_do_BANG] = ACTIONS(187),
    [anon_sym_begin] = ACTIONS(189),
    [aux_sym_char_token1] = ACTIONS(193),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(195),
    [anon_sym_DQUOTE] = ACTIONS(197),
    [anon_sym_AT_DQUOTE] = ACTIONS(199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(203),
    [sym_bool] = ACTIONS(205),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(209),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(281),
    [sym_xint] = ACTIONS(283),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(221),
  },
  [1044] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(84),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(946),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(1044),
    [sym_compiler_directive_decl] = STATE(1044),
    [sym_fsi_directive_decl] = STATE(1044),
    [sym_preproc_line] = STATE(1044),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(753),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1045] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(403),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1045),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(1045),
    [sym_compiler_directive_decl] = STATE(1045),
    [sym_fsi_directive_decl] = STATE(1045),
    [sym_preproc_line] = STATE(1045),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [1046] = {
    [sym_function_or_value_defn] = STATE(1054),
    [sym__expression] = STATE(50),
    [sym_literal_expression] = STATE(2069),
    [sym_long_identifier_or_op] = STATE(2069),
    [sym_tuple_expression] = STATE(2069),
    [sym_brace_expression] = STATE(2069),
    [sym_anon_record_expression] = STATE(2069),
    [sym_prefixed_expression] = STATE(2069),
    [sym_typecast_expression] = STATE(2069),
    [sym_for_expression] = STATE(2069),
    [sym_while_expression] = STATE(2069),
    [sym__if_branch] = STATE(10893),
    [sym_if_expression] = STATE(2069),
    [sym_fun_expression] = STATE(2069),
    [sym_try_expression] = STATE(2069),
    [sym_match_expression] = STATE(2069),
    [sym_function_expression] = STATE(2069),
    [sym_mutate_expression] = STATE(2069),
    [sym_index_expression] = STATE(2069),
    [sym_typed_expression] = STATE(2069),
    [sym_declaration_expression] = STATE(2069),
    [sym_do_expression] = STATE(2069),
    [sym_list_expression] = STATE(2069),
    [sym_array_expression] = STATE(2069),
    [sym_begin_end_expression] = STATE(2069),
    [sym_paren_expression] = STATE(2069),
    [sym__high_prec_app] = STATE(2058),
    [sym__low_prec_app] = STATE(2058),
    [sym_application_expression] = STATE(2069),
    [sym_dot_expression] = STATE(2069),
    [sym_infix_expression] = STATE(2069),
    [sym_ce_expression] = STATE(2069),
    [sym_sequential_expression] = STATE(2069),
    [sym_char] = STATE(2052),
    [sym_format_string] = STATE(2056),
    [sym__string_literal] = STATE(2056),
    [sym_string] = STATE(2052),
    [sym_verbatim_string] = STATE(2052),
    [sym_bytearray] = STATE(2052),
    [sym_verbatim_bytearray] = STATE(2052),
    [sym_format_triple_quoted_string] = STATE(2057),
    [sym_triple_quoted_string] = STATE(2052),
    [sym_const] = STATE(2069),
    [sym_long_identifier] = STATE(2077),
    [sym_active_pattern] = STATE(1953),
    [sym__identifier_or_op] = STATE(2078),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(934),
    [sym_sbyte] = STATE(2052),
    [sym_byte] = STATE(2052),
    [sym_int16] = STATE(2052),
    [sym_uint16] = STATE(2052),
    [sym_int32] = STATE(2052),
    [sym_uint32] = STATE(2052),
    [sym_nativeint] = STATE(2052),
    [sym_unativeint] = STATE(2052),
    [sym_int64] = STATE(2052),
    [sym_uint64] = STATE(2052),
    [sym_ieee32] = STATE(2052),
    [sym_ieee64] = STATE(2052),
    [sym_bignum] = STATE(2052),
    [sym_decimal] = STATE(2052),
    [sym_float] = STATE(1596),
    [sym_block_comment] = STATE(1046),
    [sym_compiler_directive_decl] = STATE(1046),
    [sym_fsi_directive_decl] = STATE(1046),
    [sym_preproc_line] = STATE(1046),
    [sym_preproc_if_in_expression] = STATE(2069),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(565),
    [anon_sym_null] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(571),
    [anon_sym_LBRACK_PIPE] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(3145),
    [anon_sym_LT_AT] = ACTIONS(577),
    [anon_sym_LT_AT_AT] = ACTIONS(3147),
    [anon_sym_LBRACE_PIPE] = ACTIONS(583),
    [anon_sym_new] = ACTIONS(561),
    [anon_sym_return_BANG] = ACTIONS(585),
    [anon_sym_yield] = ACTIONS(561),
    [anon_sym_yield_BANG] = ACTIONS(585),
    [anon_sym_lazy] = ACTIONS(561),
    [anon_sym_assert] = ACTIONS(561),
    [anon_sym_upcast] = ACTIONS(561),
    [anon_sym_downcast] = ACTIONS(561),
    [anon_sym_for] = ACTIONS(589),
    [anon_sym_while] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(593),
    [anon_sym_try] = ACTIONS(595),
    [anon_sym_match] = ACTIONS(597),
    [anon_sym_match_BANG] = ACTIONS(599),
    [anon_sym_function] = ACTIONS(601),
    [anon_sym_use] = ACTIONS(609),
    [anon_sym_use_BANG] = ACTIONS(611),
    [anon_sym_do_BANG] = ACTIONS(613),
    [anon_sym_begin] = ACTIONS(615),
    [aux_sym_char_token1] = ACTIONS(619),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(621),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [anon_sym_AT_DQUOTE] = ACTIONS(625),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(627),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(629),
    [sym_bool] = ACTIONS(631),
    [sym_unit] = ACTIONS(3149),
    [anon_sym_LPAREN_PIPE] = ACTIONS(635),
    [sym_op_identifier] = ACTIONS(3151),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(639),
    [sym_xint] = ACTIONS(641),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(643),
  },
  [1047] = {
    [sym_function_or_value_defn] = STATE(1054),
    [sym__expression] = STATE(74),
    [sym_literal_expression] = STATE(2069),
    [sym_long_identifier_or_op] = STATE(2069),
    [sym_tuple_expression] = STATE(2069),
    [sym_brace_expression] = STATE(2069),
    [sym_anon_record_expression] = STATE(2069),
    [sym_prefixed_expression] = STATE(2069),
    [sym_typecast_expression] = STATE(2069),
    [sym_for_expression] = STATE(2069),
    [sym_while_expression] = STATE(2069),
    [sym__if_branch] = STATE(10893),
    [sym_if_expression] = STATE(2069),
    [sym_fun_expression] = STATE(2069),
    [sym_try_expression] = STATE(2069),
    [sym_match_expression] = STATE(2069),
    [sym_function_expression] = STATE(2069),
    [sym_mutate_expression] = STATE(2069),
    [sym_index_expression] = STATE(2069),
    [sym_typed_expression] = STATE(2069),
    [sym_declaration_expression] = STATE(2069),
    [sym_do_expression] = STATE(2069),
    [sym_list_expression] = STATE(2069),
    [sym_array_expression] = STATE(2069),
    [sym_begin_end_expression] = STATE(2069),
    [sym_paren_expression] = STATE(2069),
    [sym__high_prec_app] = STATE(2058),
    [sym__low_prec_app] = STATE(2058),
    [sym_application_expression] = STATE(2069),
    [sym_dot_expression] = STATE(2069),
    [sym_infix_expression] = STATE(2069),
    [sym_ce_expression] = STATE(2069),
    [sym_sequential_expression] = STATE(2069),
    [sym_char] = STATE(2052),
    [sym_format_string] = STATE(2056),
    [sym__string_literal] = STATE(2056),
    [sym_string] = STATE(2052),
    [sym_verbatim_string] = STATE(2052),
    [sym_bytearray] = STATE(2052),
    [sym_verbatim_bytearray] = STATE(2052),
    [sym_format_triple_quoted_string] = STATE(2057),
    [sym_triple_quoted_string] = STATE(2052),
    [sym_const] = STATE(2069),
    [sym_long_identifier] = STATE(2077),
    [sym_active_pattern] = STATE(1953),
    [sym__identifier_or_op] = STATE(2078),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(934),
    [sym_sbyte] = STATE(2052),
    [sym_byte] = STATE(2052),
    [sym_int16] = STATE(2052),
    [sym_uint16] = STATE(2052),
    [sym_int32] = STATE(2052),
    [sym_uint32] = STATE(2052),
    [sym_nativeint] = STATE(2052),
    [sym_unativeint] = STATE(2052),
    [sym_int64] = STATE(2052),
    [sym_uint64] = STATE(2052),
    [sym_ieee32] = STATE(2052),
    [sym_ieee64] = STATE(2052),
    [sym_bignum] = STATE(2052),
    [sym_decimal] = STATE(2052),
    [sym_float] = STATE(1596),
    [sym_block_comment] = STATE(1047),
    [sym_compiler_directive_decl] = STATE(1047),
    [sym_fsi_directive_decl] = STATE(1047),
    [sym_preproc_line] = STATE(1047),
    [sym_preproc_if_in_expression] = STATE(2069),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(565),
    [anon_sym_null] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(571),
    [anon_sym_LBRACK_PIPE] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(3145),
    [anon_sym_LT_AT] = ACTIONS(577),
    [anon_sym_LT_AT_AT] = ACTIONS(3147),
    [anon_sym_LBRACE_PIPE] = ACTIONS(583),
    [anon_sym_new] = ACTIONS(561),
    [anon_sym_return_BANG] = ACTIONS(585),
    [anon_sym_yield] = ACTIONS(561),
    [anon_sym_yield_BANG] = ACTIONS(585),
    [anon_sym_lazy] = ACTIONS(561),
    [anon_sym_assert] = ACTIONS(561),
    [anon_sym_upcast] = ACTIONS(561),
    [anon_sym_downcast] = ACTIONS(561),
    [anon_sym_for] = ACTIONS(589),
    [anon_sym_while] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(593),
    [anon_sym_try] = ACTIONS(595),
    [anon_sym_match] = ACTIONS(597),
    [anon_sym_match_BANG] = ACTIONS(599),
    [anon_sym_function] = ACTIONS(601),
    [anon_sym_use] = ACTIONS(609),
    [anon_sym_use_BANG] = ACTIONS(611),
    [anon_sym_do_BANG] = ACTIONS(613),
    [anon_sym_begin] = ACTIONS(615),
    [aux_sym_char_token1] = ACTIONS(619),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(621),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [anon_sym_AT_DQUOTE] = ACTIONS(625),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(627),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(629),
    [sym_bool] = ACTIONS(631),
    [sym_unit] = ACTIONS(3149),
    [anon_sym_LPAREN_PIPE] = ACTIONS(635),
    [sym_op_identifier] = ACTIONS(3151),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(639),
    [sym_xint] = ACTIONS(641),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(643),
  },
  [1048] = {
    [sym_function_or_value_defn] = STATE(1054),
    [sym__expression] = STATE(57),
    [sym_literal_expression] = STATE(2069),
    [sym_long_identifier_or_op] = STATE(2069),
    [sym_tuple_expression] = STATE(2069),
    [sym_brace_expression] = STATE(2069),
    [sym_anon_record_expression] = STATE(2069),
    [sym_prefixed_expression] = STATE(2069),
    [sym_typecast_expression] = STATE(2069),
    [sym_for_expression] = STATE(2069),
    [sym_while_expression] = STATE(2069),
    [sym__if_branch] = STATE(10893),
    [sym_if_expression] = STATE(2069),
    [sym_fun_expression] = STATE(2069),
    [sym_try_expression] = STATE(2069),
    [sym_match_expression] = STATE(2069),
    [sym_function_expression] = STATE(2069),
    [sym_mutate_expression] = STATE(2069),
    [sym_index_expression] = STATE(2069),
    [sym_typed_expression] = STATE(2069),
    [sym_declaration_expression] = STATE(2069),
    [sym_do_expression] = STATE(2069),
    [sym_list_expression] = STATE(2069),
    [sym_array_expression] = STATE(2069),
    [sym_begin_end_expression] = STATE(2069),
    [sym_paren_expression] = STATE(2069),
    [sym__high_prec_app] = STATE(2058),
    [sym__low_prec_app] = STATE(2058),
    [sym_application_expression] = STATE(2069),
    [sym_dot_expression] = STATE(2069),
    [sym_infix_expression] = STATE(2069),
    [sym_ce_expression] = STATE(2069),
    [sym_sequential_expression] = STATE(2069),
    [sym_char] = STATE(2052),
    [sym_format_string] = STATE(2056),
    [sym__string_literal] = STATE(2056),
    [sym_string] = STATE(2052),
    [sym_verbatim_string] = STATE(2052),
    [sym_bytearray] = STATE(2052),
    [sym_verbatim_bytearray] = STATE(2052),
    [sym_format_triple_quoted_string] = STATE(2057),
    [sym_triple_quoted_string] = STATE(2052),
    [sym_const] = STATE(2069),
    [sym_long_identifier] = STATE(2077),
    [sym_active_pattern] = STATE(1953),
    [sym__identifier_or_op] = STATE(2078),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(934),
    [sym_sbyte] = STATE(2052),
    [sym_byte] = STATE(2052),
    [sym_int16] = STATE(2052),
    [sym_uint16] = STATE(2052),
    [sym_int32] = STATE(2052),
    [sym_uint32] = STATE(2052),
    [sym_nativeint] = STATE(2052),
    [sym_unativeint] = STATE(2052),
    [sym_int64] = STATE(2052),
    [sym_uint64] = STATE(2052),
    [sym_ieee32] = STATE(2052),
    [sym_ieee64] = STATE(2052),
    [sym_bignum] = STATE(2052),
    [sym_decimal] = STATE(2052),
    [sym_float] = STATE(1596),
    [sym_block_comment] = STATE(1048),
    [sym_compiler_directive_decl] = STATE(1048),
    [sym_fsi_directive_decl] = STATE(1048),
    [sym_preproc_line] = STATE(1048),
    [sym_preproc_if_in_expression] = STATE(2069),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(565),
    [anon_sym_null] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(571),
    [anon_sym_LBRACK_PIPE] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(3145),
    [anon_sym_LT_AT] = ACTIONS(577),
    [anon_sym_LT_AT_AT] = ACTIONS(3147),
    [anon_sym_LBRACE_PIPE] = ACTIONS(583),
    [anon_sym_new] = ACTIONS(561),
    [anon_sym_return_BANG] = ACTIONS(585),
    [anon_sym_yield] = ACTIONS(561),
    [anon_sym_yield_BANG] = ACTIONS(585),
    [anon_sym_lazy] = ACTIONS(561),
    [anon_sym_assert] = ACTIONS(561),
    [anon_sym_upcast] = ACTIONS(561),
    [anon_sym_downcast] = ACTIONS(561),
    [anon_sym_for] = ACTIONS(589),
    [anon_sym_while] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(593),
    [anon_sym_try] = ACTIONS(595),
    [anon_sym_match] = ACTIONS(597),
    [anon_sym_match_BANG] = ACTIONS(599),
    [anon_sym_function] = ACTIONS(601),
    [anon_sym_use] = ACTIONS(609),
    [anon_sym_use_BANG] = ACTIONS(611),
    [anon_sym_do_BANG] = ACTIONS(613),
    [anon_sym_begin] = ACTIONS(615),
    [aux_sym_char_token1] = ACTIONS(619),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(621),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [anon_sym_AT_DQUOTE] = ACTIONS(625),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(627),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(629),
    [sym_bool] = ACTIONS(631),
    [sym_unit] = ACTIONS(3149),
    [anon_sym_LPAREN_PIPE] = ACTIONS(635),
    [sym_op_identifier] = ACTIONS(3151),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(639),
    [sym_xint] = ACTIONS(641),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(643),
  },
  [1049] = {
    [sym_function_or_value_defn] = STATE(1054),
    [sym__expression] = STATE(72),
    [sym_literal_expression] = STATE(2069),
    [sym_long_identifier_or_op] = STATE(2069),
    [sym_tuple_expression] = STATE(2069),
    [sym_brace_expression] = STATE(2069),
    [sym_anon_record_expression] = STATE(2069),
    [sym_prefixed_expression] = STATE(2069),
    [sym_typecast_expression] = STATE(2069),
    [sym_for_expression] = STATE(2069),
    [sym_while_expression] = STATE(2069),
    [sym__if_branch] = STATE(10893),
    [sym_if_expression] = STATE(2069),
    [sym_fun_expression] = STATE(2069),
    [sym_try_expression] = STATE(2069),
    [sym_match_expression] = STATE(2069),
    [sym_function_expression] = STATE(2069),
    [sym_mutate_expression] = STATE(2069),
    [sym_index_expression] = STATE(2069),
    [sym_typed_expression] = STATE(2069),
    [sym_declaration_expression] = STATE(2069),
    [sym_do_expression] = STATE(2069),
    [sym_list_expression] = STATE(2069),
    [sym_array_expression] = STATE(2069),
    [sym_begin_end_expression] = STATE(2069),
    [sym_paren_expression] = STATE(2069),
    [sym__high_prec_app] = STATE(2058),
    [sym__low_prec_app] = STATE(2058),
    [sym_application_expression] = STATE(2069),
    [sym_dot_expression] = STATE(2069),
    [sym_infix_expression] = STATE(2069),
    [sym_ce_expression] = STATE(2069),
    [sym_sequential_expression] = STATE(2069),
    [sym_char] = STATE(2052),
    [sym_format_string] = STATE(2056),
    [sym__string_literal] = STATE(2056),
    [sym_string] = STATE(2052),
    [sym_verbatim_string] = STATE(2052),
    [sym_bytearray] = STATE(2052),
    [sym_verbatim_bytearray] = STATE(2052),
    [sym_format_triple_quoted_string] = STATE(2057),
    [sym_triple_quoted_string] = STATE(2052),
    [sym_const] = STATE(2069),
    [sym_long_identifier] = STATE(2077),
    [sym_active_pattern] = STATE(1953),
    [sym__identifier_or_op] = STATE(2078),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(934),
    [sym_sbyte] = STATE(2052),
    [sym_byte] = STATE(2052),
    [sym_int16] = STATE(2052),
    [sym_uint16] = STATE(2052),
    [sym_int32] = STATE(2052),
    [sym_uint32] = STATE(2052),
    [sym_nativeint] = STATE(2052),
    [sym_unativeint] = STATE(2052),
    [sym_int64] = STATE(2052),
    [sym_uint64] = STATE(2052),
    [sym_ieee32] = STATE(2052),
    [sym_ieee64] = STATE(2052),
    [sym_bignum] = STATE(2052),
    [sym_decimal] = STATE(2052),
    [sym_float] = STATE(1596),
    [sym_block_comment] = STATE(1049),
    [sym_compiler_directive_decl] = STATE(1049),
    [sym_fsi_directive_decl] = STATE(1049),
    [sym_preproc_line] = STATE(1049),
    [sym_preproc_if_in_expression] = STATE(2069),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(565),
    [anon_sym_null] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(571),
    [anon_sym_LBRACK_PIPE] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(3145),
    [anon_sym_LT_AT] = ACTIONS(577),
    [anon_sym_LT_AT_AT] = ACTIONS(3147),
    [anon_sym_LBRACE_PIPE] = ACTIONS(583),
    [anon_sym_new] = ACTIONS(561),
    [anon_sym_return_BANG] = ACTIONS(585),
    [anon_sym_yield] = ACTIONS(561),
    [anon_sym_yield_BANG] = ACTIONS(585),
    [anon_sym_lazy] = ACTIONS(561),
    [anon_sym_assert] = ACTIONS(561),
    [anon_sym_upcast] = ACTIONS(561),
    [anon_sym_downcast] = ACTIONS(561),
    [anon_sym_for] = ACTIONS(589),
    [anon_sym_while] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(593),
    [anon_sym_try] = ACTIONS(595),
    [anon_sym_match] = ACTIONS(597),
    [anon_sym_match_BANG] = ACTIONS(599),
    [anon_sym_function] = ACTIONS(601),
    [anon_sym_use] = ACTIONS(609),
    [anon_sym_use_BANG] = ACTIONS(611),
    [anon_sym_do_BANG] = ACTIONS(613),
    [anon_sym_begin] = ACTIONS(615),
    [aux_sym_char_token1] = ACTIONS(619),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(621),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [anon_sym_AT_DQUOTE] = ACTIONS(625),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(627),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(629),
    [sym_bool] = ACTIONS(631),
    [sym_unit] = ACTIONS(3149),
    [anon_sym_LPAREN_PIPE] = ACTIONS(635),
    [sym_op_identifier] = ACTIONS(3151),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(639),
    [sym_xint] = ACTIONS(641),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(643),
  },
  [1050] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(332),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1151),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(1050),
    [sym_compiler_directive_decl] = STATE(1050),
    [sym_fsi_directive_decl] = STATE(1050),
    [sym_preproc_line] = STATE(1050),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_begin] = ACTIONS(1782),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
  },
  [1051] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(303),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1045),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(1051),
    [sym_compiler_directive_decl] = STATE(1051),
    [sym_fsi_directive_decl] = STATE(1051),
    [sym_preproc_line] = STATE(1051),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [1052] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(391),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1052),
    [sym_compiler_directive_decl] = STATE(1052),
    [sym_fsi_directive_decl] = STATE(1052),
    [sym_preproc_line] = STATE(1052),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1053] = {
    [sym_function_or_value_defn] = STATE(1054),
    [sym__expression] = STATE(47),
    [sym_literal_expression] = STATE(2069),
    [sym_long_identifier_or_op] = STATE(2069),
    [sym_tuple_expression] = STATE(2069),
    [sym_brace_expression] = STATE(2069),
    [sym_anon_record_expression] = STATE(2069),
    [sym_prefixed_expression] = STATE(2069),
    [sym_typecast_expression] = STATE(2069),
    [sym_for_expression] = STATE(2069),
    [sym_while_expression] = STATE(2069),
    [sym__if_branch] = STATE(10893),
    [sym_if_expression] = STATE(2069),
    [sym_fun_expression] = STATE(2069),
    [sym_try_expression] = STATE(2069),
    [sym_match_expression] = STATE(2069),
    [sym_function_expression] = STATE(2069),
    [sym_mutate_expression] = STATE(2069),
    [sym_index_expression] = STATE(2069),
    [sym_typed_expression] = STATE(2069),
    [sym_declaration_expression] = STATE(2069),
    [sym_do_expression] = STATE(2069),
    [sym_list_expression] = STATE(2069),
    [sym_array_expression] = STATE(2069),
    [sym_begin_end_expression] = STATE(2069),
    [sym_paren_expression] = STATE(2069),
    [sym__high_prec_app] = STATE(2058),
    [sym__low_prec_app] = STATE(2058),
    [sym_application_expression] = STATE(2069),
    [sym_dot_expression] = STATE(2069),
    [sym_infix_expression] = STATE(2069),
    [sym_ce_expression] = STATE(2069),
    [sym_sequential_expression] = STATE(2069),
    [sym_char] = STATE(2052),
    [sym_format_string] = STATE(2056),
    [sym__string_literal] = STATE(2056),
    [sym_string] = STATE(2052),
    [sym_verbatim_string] = STATE(2052),
    [sym_bytearray] = STATE(2052),
    [sym_verbatim_bytearray] = STATE(2052),
    [sym_format_triple_quoted_string] = STATE(2057),
    [sym_triple_quoted_string] = STATE(2052),
    [sym_const] = STATE(2069),
    [sym_long_identifier] = STATE(2077),
    [sym_active_pattern] = STATE(1953),
    [sym__identifier_or_op] = STATE(2078),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(934),
    [sym_sbyte] = STATE(2052),
    [sym_byte] = STATE(2052),
    [sym_int16] = STATE(2052),
    [sym_uint16] = STATE(2052),
    [sym_int32] = STATE(2052),
    [sym_uint32] = STATE(2052),
    [sym_nativeint] = STATE(2052),
    [sym_unativeint] = STATE(2052),
    [sym_int64] = STATE(2052),
    [sym_uint64] = STATE(2052),
    [sym_ieee32] = STATE(2052),
    [sym_ieee64] = STATE(2052),
    [sym_bignum] = STATE(2052),
    [sym_decimal] = STATE(2052),
    [sym_float] = STATE(1596),
    [sym_block_comment] = STATE(1053),
    [sym_compiler_directive_decl] = STATE(1053),
    [sym_fsi_directive_decl] = STATE(1053),
    [sym_preproc_line] = STATE(1053),
    [sym_preproc_if_in_expression] = STATE(2069),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(565),
    [anon_sym_null] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(571),
    [anon_sym_LBRACK_PIPE] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(3145),
    [anon_sym_LT_AT] = ACTIONS(577),
    [anon_sym_LT_AT_AT] = ACTIONS(3147),
    [anon_sym_LBRACE_PIPE] = ACTIONS(583),
    [anon_sym_new] = ACTIONS(561),
    [anon_sym_return_BANG] = ACTIONS(585),
    [anon_sym_yield] = ACTIONS(561),
    [anon_sym_yield_BANG] = ACTIONS(585),
    [anon_sym_lazy] = ACTIONS(561),
    [anon_sym_assert] = ACTIONS(561),
    [anon_sym_upcast] = ACTIONS(561),
    [anon_sym_downcast] = ACTIONS(561),
    [anon_sym_for] = ACTIONS(589),
    [anon_sym_while] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(593),
    [anon_sym_try] = ACTIONS(595),
    [anon_sym_match] = ACTIONS(597),
    [anon_sym_match_BANG] = ACTIONS(599),
    [anon_sym_function] = ACTIONS(601),
    [anon_sym_use] = ACTIONS(609),
    [anon_sym_use_BANG] = ACTIONS(611),
    [anon_sym_do_BANG] = ACTIONS(613),
    [anon_sym_begin] = ACTIONS(615),
    [aux_sym_char_token1] = ACTIONS(619),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(621),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [anon_sym_AT_DQUOTE] = ACTIONS(625),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(627),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(629),
    [sym_bool] = ACTIONS(631),
    [sym_unit] = ACTIONS(3149),
    [anon_sym_LPAREN_PIPE] = ACTIONS(635),
    [sym_op_identifier] = ACTIONS(3151),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(639),
    [sym_xint] = ACTIONS(641),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(643),
  },
  [1054] = {
    [sym_function_or_value_defn] = STATE(1054),
    [sym__expression] = STATE(60),
    [sym_literal_expression] = STATE(2069),
    [sym_long_identifier_or_op] = STATE(2069),
    [sym_tuple_expression] = STATE(2069),
    [sym_brace_expression] = STATE(2069),
    [sym_anon_record_expression] = STATE(2069),
    [sym_prefixed_expression] = STATE(2069),
    [sym_typecast_expression] = STATE(2069),
    [sym_for_expression] = STATE(2069),
    [sym_while_expression] = STATE(2069),
    [sym__if_branch] = STATE(10893),
    [sym_if_expression] = STATE(2069),
    [sym_fun_expression] = STATE(2069),
    [sym_try_expression] = STATE(2069),
    [sym_match_expression] = STATE(2069),
    [sym_function_expression] = STATE(2069),
    [sym_mutate_expression] = STATE(2069),
    [sym_index_expression] = STATE(2069),
    [sym_typed_expression] = STATE(2069),
    [sym_declaration_expression] = STATE(2069),
    [sym_do_expression] = STATE(2069),
    [sym_list_expression] = STATE(2069),
    [sym_array_expression] = STATE(2069),
    [sym_begin_end_expression] = STATE(2069),
    [sym_paren_expression] = STATE(2069),
    [sym__high_prec_app] = STATE(2058),
    [sym__low_prec_app] = STATE(2058),
    [sym_application_expression] = STATE(2069),
    [sym_dot_expression] = STATE(2069),
    [sym_infix_expression] = STATE(2069),
    [sym_ce_expression] = STATE(2069),
    [sym_sequential_expression] = STATE(2069),
    [sym_char] = STATE(2052),
    [sym_format_string] = STATE(2056),
    [sym__string_literal] = STATE(2056),
    [sym_string] = STATE(2052),
    [sym_verbatim_string] = STATE(2052),
    [sym_bytearray] = STATE(2052),
    [sym_verbatim_bytearray] = STATE(2052),
    [sym_format_triple_quoted_string] = STATE(2057),
    [sym_triple_quoted_string] = STATE(2052),
    [sym_const] = STATE(2069),
    [sym_long_identifier] = STATE(2077),
    [sym_active_pattern] = STATE(1953),
    [sym__identifier_or_op] = STATE(2078),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(934),
    [sym_sbyte] = STATE(2052),
    [sym_byte] = STATE(2052),
    [sym_int16] = STATE(2052),
    [sym_uint16] = STATE(2052),
    [sym_int32] = STATE(2052),
    [sym_uint32] = STATE(2052),
    [sym_nativeint] = STATE(2052),
    [sym_unativeint] = STATE(2052),
    [sym_int64] = STATE(2052),
    [sym_uint64] = STATE(2052),
    [sym_ieee32] = STATE(2052),
    [sym_ieee64] = STATE(2052),
    [sym_bignum] = STATE(2052),
    [sym_decimal] = STATE(2052),
    [sym_float] = STATE(1596),
    [sym_block_comment] = STATE(1054),
    [sym_compiler_directive_decl] = STATE(1054),
    [sym_fsi_directive_decl] = STATE(1054),
    [sym_preproc_line] = STATE(1054),
    [sym_preproc_if_in_expression] = STATE(2069),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(565),
    [anon_sym_null] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(571),
    [anon_sym_LBRACK_PIPE] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(3145),
    [anon_sym_LT_AT] = ACTIONS(577),
    [anon_sym_LT_AT_AT] = ACTIONS(3147),
    [anon_sym_LBRACE_PIPE] = ACTIONS(583),
    [anon_sym_new] = ACTIONS(561),
    [anon_sym_return_BANG] = ACTIONS(585),
    [anon_sym_yield] = ACTIONS(561),
    [anon_sym_yield_BANG] = ACTIONS(585),
    [anon_sym_lazy] = ACTIONS(561),
    [anon_sym_assert] = ACTIONS(561),
    [anon_sym_upcast] = ACTIONS(561),
    [anon_sym_downcast] = ACTIONS(561),
    [anon_sym_for] = ACTIONS(589),
    [anon_sym_while] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(593),
    [anon_sym_try] = ACTIONS(595),
    [anon_sym_match] = ACTIONS(597),
    [anon_sym_match_BANG] = ACTIONS(599),
    [anon_sym_function] = ACTIONS(601),
    [anon_sym_use] = ACTIONS(609),
    [anon_sym_use_BANG] = ACTIONS(611),
    [anon_sym_do_BANG] = ACTIONS(613),
    [anon_sym_begin] = ACTIONS(615),
    [aux_sym_char_token1] = ACTIONS(619),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(621),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [anon_sym_AT_DQUOTE] = ACTIONS(625),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(627),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(629),
    [sym_bool] = ACTIONS(631),
    [sym_unit] = ACTIONS(3149),
    [anon_sym_LPAREN_PIPE] = ACTIONS(635),
    [sym_op_identifier] = ACTIONS(3151),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(639),
    [sym_xint] = ACTIONS(641),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(643),
  },
  [1055] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(86),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(946),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(1055),
    [sym_compiler_directive_decl] = STATE(1055),
    [sym_fsi_directive_decl] = STATE(1055),
    [sym_preproc_line] = STATE(1055),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(753),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1056] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(90),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(946),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(1056),
    [sym_compiler_directive_decl] = STATE(1056),
    [sym_fsi_directive_decl] = STATE(1056),
    [sym_preproc_line] = STATE(1056),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(753),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1057] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(310),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1151),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(1057),
    [sym_compiler_directive_decl] = STATE(1057),
    [sym_fsi_directive_decl] = STATE(1057),
    [sym_preproc_line] = STATE(1057),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_begin] = ACTIONS(1782),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
  },
  [1058] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(298),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1058),
    [sym_compiler_directive_decl] = STATE(1058),
    [sym_fsi_directive_decl] = STATE(1058),
    [sym_preproc_line] = STATE(1058),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1059] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(390),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1059),
    [sym_compiler_directive_decl] = STATE(1059),
    [sym_fsi_directive_decl] = STATE(1059),
    [sym_preproc_line] = STATE(1059),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1060] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(188),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(1060),
    [sym_compiler_directive_decl] = STATE(1060),
    [sym_fsi_directive_decl] = STATE(1060),
    [sym_preproc_line] = STATE(1060),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
  },
  [1061] = {
    [sym_function_or_value_defn] = STATE(1122),
    [sym__expression] = STATE(68),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(938),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(1598),
    [sym_block_comment] = STATE(1061),
    [sym_compiler_directive_decl] = STATE(1061),
    [sym_fsi_directive_decl] = STATE(1061),
    [sym_preproc_line] = STATE(1061),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_return] = ACTIONS(475),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(3081),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(475),
    [anon_sym_return_BANG] = ACTIONS(497),
    [anon_sym_yield] = ACTIONS(475),
    [anon_sym_yield_BANG] = ACTIONS(497),
    [anon_sym_lazy] = ACTIONS(475),
    [anon_sym_assert] = ACTIONS(475),
    [anon_sym_upcast] = ACTIONS(475),
    [anon_sym_downcast] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_use] = ACTIONS(521),
    [anon_sym_use_BANG] = ACTIONS(523),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(3083),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(3085),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(551),
    [sym_xint] = ACTIONS(553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
  },
  [1062] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(388),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1062),
    [sym_compiler_directive_decl] = STATE(1062),
    [sym_fsi_directive_decl] = STATE(1062),
    [sym_preproc_line] = STATE(1062),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1063] = {
    [sym_function_or_value_defn] = STATE(1122),
    [sym__expression] = STATE(70),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(938),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(1598),
    [sym_block_comment] = STATE(1063),
    [sym_compiler_directive_decl] = STATE(1063),
    [sym_fsi_directive_decl] = STATE(1063),
    [sym_preproc_line] = STATE(1063),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_return] = ACTIONS(475),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(3081),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(475),
    [anon_sym_return_BANG] = ACTIONS(497),
    [anon_sym_yield] = ACTIONS(475),
    [anon_sym_yield_BANG] = ACTIONS(497),
    [anon_sym_lazy] = ACTIONS(475),
    [anon_sym_assert] = ACTIONS(475),
    [anon_sym_upcast] = ACTIONS(475),
    [anon_sym_downcast] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_use] = ACTIONS(521),
    [anon_sym_use_BANG] = ACTIONS(523),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(3083),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(3085),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(551),
    [sym_xint] = ACTIONS(553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
  },
  [1064] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(294),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1151),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(1064),
    [sym_compiler_directive_decl] = STATE(1064),
    [sym_fsi_directive_decl] = STATE(1064),
    [sym_preproc_line] = STATE(1064),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_begin] = ACTIONS(1782),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
  },
  [1065] = {
    [sym_function_or_value_defn] = STATE(866),
    [sym__expression] = STATE(103),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1178),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(1065),
    [sym_compiler_directive_decl] = STATE(1065),
    [sym_fsi_directive_decl] = STATE(1065),
    [sym_preproc_line] = STATE(1065),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(857),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(53),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(857),
    [anon_sym_return_BANG] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(857),
    [anon_sym_yield_BANG] = ACTIONS(869),
    [anon_sym_lazy] = ACTIONS(857),
    [anon_sym_assert] = ACTIONS(857),
    [anon_sym_upcast] = ACTIONS(857),
    [anon_sym_downcast] = ACTIONS(857),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(879),
    [anon_sym_use_BANG] = ACTIONS(881),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(99),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(889),
    [sym_xint] = ACTIONS(891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
  },
  [1066] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(79),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(946),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(1066),
    [sym_compiler_directive_decl] = STATE(1066),
    [sym_fsi_directive_decl] = STATE(1066),
    [sym_preproc_line] = STATE(1066),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(753),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1067] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(475),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1067),
    [sym_compiler_directive_decl] = STATE(1067),
    [sym_fsi_directive_decl] = STATE(1067),
    [sym_preproc_line] = STATE(1067),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1068] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(385),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1068),
    [sym_compiler_directive_decl] = STATE(1068),
    [sym_fsi_directive_decl] = STATE(1068),
    [sym_preproc_line] = STATE(1068),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1069] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(91),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(946),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(1069),
    [sym_compiler_directive_decl] = STATE(1069),
    [sym_fsi_directive_decl] = STATE(1069),
    [sym_preproc_line] = STATE(1069),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(753),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1070] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(93),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(946),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(1070),
    [sym_compiler_directive_decl] = STATE(1070),
    [sym_fsi_directive_decl] = STATE(1070),
    [sym_preproc_line] = STATE(1070),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(753),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1071] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(384),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1071),
    [sym_compiler_directive_decl] = STATE(1071),
    [sym_fsi_directive_decl] = STATE(1071),
    [sym_preproc_line] = STATE(1071),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1072] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(382),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1072),
    [sym_compiler_directive_decl] = STATE(1072),
    [sym_fsi_directive_decl] = STATE(1072),
    [sym_preproc_line] = STATE(1072),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1073] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(381),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1073),
    [sym_compiler_directive_decl] = STATE(1073),
    [sym_fsi_directive_decl] = STATE(1073),
    [sym_preproc_line] = STATE(1073),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1074] = {
    [sym_function_or_value_defn] = STATE(1074),
    [sym__expression] = STATE(233),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(944),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(2718),
    [sym_block_comment] = STATE(1074),
    [sym_compiler_directive_decl] = STATE(1074),
    [sym_fsi_directive_decl] = STATE(1074),
    [sym_preproc_line] = STATE(1074),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_return] = ACTIONS(1252),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(3081),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_return_BANG] = ACTIONS(1256),
    [anon_sym_yield] = ACTIONS(1252),
    [anon_sym_yield_BANG] = ACTIONS(1256),
    [anon_sym_lazy] = ACTIONS(1252),
    [anon_sym_assert] = ACTIONS(1252),
    [anon_sym_upcast] = ACTIONS(1252),
    [anon_sym_downcast] = ACTIONS(1252),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_use] = ACTIONS(1260),
    [anon_sym_use_BANG] = ACTIONS(1262),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(3083),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(3085),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1264),
    [sym_xint] = ACTIONS(1266),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
  },
  [1075] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(525),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(1075),
    [sym_compiler_directive_decl] = STATE(1075),
    [sym_fsi_directive_decl] = STATE(1075),
    [sym_preproc_line] = STATE(1075),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [1076] = {
    [sym_function_or_value_defn] = STATE(783),
    [sym__expression] = STATE(446),
    [sym_literal_expression] = STATE(3553),
    [sym_long_identifier_or_op] = STATE(3553),
    [sym_tuple_expression] = STATE(3553),
    [sym_brace_expression] = STATE(3553),
    [sym_anon_record_expression] = STATE(3553),
    [sym_prefixed_expression] = STATE(3553),
    [sym_typecast_expression] = STATE(3553),
    [sym_for_expression] = STATE(3553),
    [sym_while_expression] = STATE(3553),
    [sym__if_branch] = STATE(10567),
    [sym_if_expression] = STATE(3553),
    [sym_fun_expression] = STATE(3553),
    [sym_try_expression] = STATE(3553),
    [sym_match_expression] = STATE(3553),
    [sym_function_expression] = STATE(3553),
    [sym_mutate_expression] = STATE(3553),
    [sym_index_expression] = STATE(3553),
    [sym_typed_expression] = STATE(3553),
    [sym_declaration_expression] = STATE(3553),
    [sym_do_expression] = STATE(3553),
    [sym_list_expression] = STATE(3553),
    [sym_array_expression] = STATE(3553),
    [sym_begin_end_expression] = STATE(3553),
    [sym_paren_expression] = STATE(3553),
    [sym__high_prec_app] = STATE(3532),
    [sym__low_prec_app] = STATE(3532),
    [sym_application_expression] = STATE(3553),
    [sym_dot_expression] = STATE(3553),
    [sym_infix_expression] = STATE(3553),
    [sym_ce_expression] = STATE(3553),
    [sym_sequential_expression] = STATE(3553),
    [sym_char] = STATE(3265),
    [sym_format_string] = STATE(3261),
    [sym__string_literal] = STATE(3261),
    [sym_string] = STATE(3265),
    [sym_verbatim_string] = STATE(3265),
    [sym_bytearray] = STATE(3265),
    [sym_verbatim_bytearray] = STATE(3265),
    [sym_format_triple_quoted_string] = STATE(3260),
    [sym_triple_quoted_string] = STATE(3265),
    [sym_const] = STATE(3553),
    [sym_long_identifier] = STATE(3203),
    [sym_active_pattern] = STATE(3576),
    [sym__identifier_or_op] = STATE(3362),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1076),
    [sym_sbyte] = STATE(3265),
    [sym_byte] = STATE(3265),
    [sym_int16] = STATE(3265),
    [sym_uint16] = STATE(3265),
    [sym_int32] = STATE(3265),
    [sym_uint32] = STATE(3265),
    [sym_nativeint] = STATE(3265),
    [sym_unativeint] = STATE(3265),
    [sym_int64] = STATE(3265),
    [sym_uint64] = STATE(3265),
    [sym_ieee32] = STATE(3265),
    [sym_ieee64] = STATE(3265),
    [sym_bignum] = STATE(3265),
    [sym_decimal] = STATE(3265),
    [sym_float] = STATE(2797),
    [sym_block_comment] = STATE(1076),
    [sym_compiler_directive_decl] = STATE(1076),
    [sym_fsi_directive_decl] = STATE(1076),
    [sym_preproc_line] = STATE(1076),
    [sym_preproc_if_in_expression] = STATE(3553),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1632),
    [anon_sym_return] = ACTIONS(1636),
    [anon_sym_do] = ACTIONS(1638),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1640),
    [anon_sym_null] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1646),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_LT_AT] = ACTIONS(1652),
    [anon_sym_LT_AT_AT] = ACTIONS(3021),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1658),
    [anon_sym_new] = ACTIONS(1636),
    [anon_sym_return_BANG] = ACTIONS(1660),
    [anon_sym_yield] = ACTIONS(1636),
    [anon_sym_yield_BANG] = ACTIONS(1660),
    [anon_sym_lazy] = ACTIONS(1636),
    [anon_sym_assert] = ACTIONS(1636),
    [anon_sym_upcast] = ACTIONS(1636),
    [anon_sym_downcast] = ACTIONS(1636),
    [anon_sym_for] = ACTIONS(1664),
    [anon_sym_while] = ACTIONS(1666),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1668),
    [anon_sym_try] = ACTIONS(1670),
    [anon_sym_match] = ACTIONS(1672),
    [anon_sym_match_BANG] = ACTIONS(1674),
    [anon_sym_function] = ACTIONS(1676),
    [anon_sym_use] = ACTIONS(1684),
    [anon_sym_use_BANG] = ACTIONS(1686),
    [anon_sym_do_BANG] = ACTIONS(1688),
    [anon_sym_begin] = ACTIONS(1690),
    [aux_sym_char_token1] = ACTIONS(1694),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1696),
    [anon_sym_DQUOTE] = ACTIONS(1698),
    [anon_sym_AT_DQUOTE] = ACTIONS(1700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1704),
    [sym_bool] = ACTIONS(1706),
    [sym_unit] = ACTIONS(3023),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1710),
    [sym_op_identifier] = ACTIONS(3025),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1714),
    [sym_xint] = ACTIONS(1716),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1718),
  },
  [1077] = {
    [sym_function_or_value_defn] = STATE(1084),
    [sym__expression] = STATE(75),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(936),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(1592),
    [sym_block_comment] = STATE(1077),
    [sym_compiler_directive_decl] = STATE(1077),
    [sym_fsi_directive_decl] = STATE(1077),
    [sym_preproc_line] = STATE(1077),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(651),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(2638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(651),
    [anon_sym_return_BANG] = ACTIONS(673),
    [anon_sym_yield] = ACTIONS(651),
    [anon_sym_yield_BANG] = ACTIONS(673),
    [anon_sym_lazy] = ACTIONS(651),
    [anon_sym_assert] = ACTIONS(651),
    [anon_sym_upcast] = ACTIONS(651),
    [anon_sym_downcast] = ACTIONS(651),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_use] = ACTIONS(697),
    [anon_sym_use_BANG] = ACTIONS(699),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(2642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(727),
    [sym_xint] = ACTIONS(729),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
  },
  [1078] = {
    [sym_function_or_value_defn] = STATE(1084),
    [sym__expression] = STATE(69),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(936),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(1592),
    [sym_block_comment] = STATE(1078),
    [sym_compiler_directive_decl] = STATE(1078),
    [sym_fsi_directive_decl] = STATE(1078),
    [sym_preproc_line] = STATE(1078),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(651),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(2638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(651),
    [anon_sym_return_BANG] = ACTIONS(673),
    [anon_sym_yield] = ACTIONS(651),
    [anon_sym_yield_BANG] = ACTIONS(673),
    [anon_sym_lazy] = ACTIONS(651),
    [anon_sym_assert] = ACTIONS(651),
    [anon_sym_upcast] = ACTIONS(651),
    [anon_sym_downcast] = ACTIONS(651),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_use] = ACTIONS(697),
    [anon_sym_use_BANG] = ACTIONS(699),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(2642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(727),
    [sym_xint] = ACTIONS(729),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
  },
  [1079] = {
    [sym_function_or_value_defn] = STATE(1084),
    [sym__expression] = STATE(73),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(936),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(1592),
    [sym_block_comment] = STATE(1079),
    [sym_compiler_directive_decl] = STATE(1079),
    [sym_fsi_directive_decl] = STATE(1079),
    [sym_preproc_line] = STATE(1079),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(651),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(2638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(651),
    [anon_sym_return_BANG] = ACTIONS(673),
    [anon_sym_yield] = ACTIONS(651),
    [anon_sym_yield_BANG] = ACTIONS(673),
    [anon_sym_lazy] = ACTIONS(651),
    [anon_sym_assert] = ACTIONS(651),
    [anon_sym_upcast] = ACTIONS(651),
    [anon_sym_downcast] = ACTIONS(651),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_use] = ACTIONS(697),
    [anon_sym_use_BANG] = ACTIONS(699),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(2642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(727),
    [sym_xint] = ACTIONS(729),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
  },
  [1080] = {
    [sym_function_or_value_defn] = STATE(1084),
    [sym__expression] = STATE(67),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(936),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(1592),
    [sym_block_comment] = STATE(1080),
    [sym_compiler_directive_decl] = STATE(1080),
    [sym_fsi_directive_decl] = STATE(1080),
    [sym_preproc_line] = STATE(1080),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(651),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(2638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(651),
    [anon_sym_return_BANG] = ACTIONS(673),
    [anon_sym_yield] = ACTIONS(651),
    [anon_sym_yield_BANG] = ACTIONS(673),
    [anon_sym_lazy] = ACTIONS(651),
    [anon_sym_assert] = ACTIONS(651),
    [anon_sym_upcast] = ACTIONS(651),
    [anon_sym_downcast] = ACTIONS(651),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_use] = ACTIONS(697),
    [anon_sym_use_BANG] = ACTIONS(699),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(2642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(727),
    [sym_xint] = ACTIONS(729),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
  },
  [1081] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(378),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1081),
    [sym_compiler_directive_decl] = STATE(1081),
    [sym_fsi_directive_decl] = STATE(1081),
    [sym_preproc_line] = STATE(1081),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1082] = {
    [sym_function_or_value_defn] = STATE(1084),
    [sym__expression] = STATE(62),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(936),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(1592),
    [sym_block_comment] = STATE(1082),
    [sym_compiler_directive_decl] = STATE(1082),
    [sym_fsi_directive_decl] = STATE(1082),
    [sym_preproc_line] = STATE(1082),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(651),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(2638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(651),
    [anon_sym_return_BANG] = ACTIONS(673),
    [anon_sym_yield] = ACTIONS(651),
    [anon_sym_yield_BANG] = ACTIONS(673),
    [anon_sym_lazy] = ACTIONS(651),
    [anon_sym_assert] = ACTIONS(651),
    [anon_sym_upcast] = ACTIONS(651),
    [anon_sym_downcast] = ACTIONS(651),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_use] = ACTIONS(697),
    [anon_sym_use_BANG] = ACTIONS(699),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(2642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(727),
    [sym_xint] = ACTIONS(729),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
  },
  [1083] = {
    [sym_function_or_value_defn] = STATE(1074),
    [sym__expression] = STATE(164),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(944),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(2718),
    [sym_block_comment] = STATE(1083),
    [sym_compiler_directive_decl] = STATE(1083),
    [sym_fsi_directive_decl] = STATE(1083),
    [sym_preproc_line] = STATE(1083),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_return] = ACTIONS(1252),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(3081),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_return_BANG] = ACTIONS(1256),
    [anon_sym_yield] = ACTIONS(1252),
    [anon_sym_yield_BANG] = ACTIONS(1256),
    [anon_sym_lazy] = ACTIONS(1252),
    [anon_sym_assert] = ACTIONS(1252),
    [anon_sym_upcast] = ACTIONS(1252),
    [anon_sym_downcast] = ACTIONS(1252),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_use] = ACTIONS(1260),
    [anon_sym_use_BANG] = ACTIONS(1262),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(3083),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(3085),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1264),
    [sym_xint] = ACTIONS(1266),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
  },
  [1084] = {
    [sym_function_or_value_defn] = STATE(1084),
    [sym__expression] = STATE(61),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(936),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(1592),
    [sym_block_comment] = STATE(1084),
    [sym_compiler_directive_decl] = STATE(1084),
    [sym_fsi_directive_decl] = STATE(1084),
    [sym_preproc_line] = STATE(1084),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(651),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(2638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(651),
    [anon_sym_return_BANG] = ACTIONS(673),
    [anon_sym_yield] = ACTIONS(651),
    [anon_sym_yield_BANG] = ACTIONS(673),
    [anon_sym_lazy] = ACTIONS(651),
    [anon_sym_assert] = ACTIONS(651),
    [anon_sym_upcast] = ACTIONS(651),
    [anon_sym_downcast] = ACTIONS(651),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_use] = ACTIONS(697),
    [anon_sym_use_BANG] = ACTIONS(699),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(2642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(727),
    [sym_xint] = ACTIONS(729),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
  },
  [1085] = {
    [sym_function_or_value_defn] = STATE(1054),
    [sym__expression] = STATE(65),
    [sym_literal_expression] = STATE(2069),
    [sym_long_identifier_or_op] = STATE(2069),
    [sym_tuple_expression] = STATE(2069),
    [sym_brace_expression] = STATE(2069),
    [sym_anon_record_expression] = STATE(2069),
    [sym_prefixed_expression] = STATE(2069),
    [sym_typecast_expression] = STATE(2069),
    [sym_for_expression] = STATE(2069),
    [sym_while_expression] = STATE(2069),
    [sym__if_branch] = STATE(10893),
    [sym_if_expression] = STATE(2069),
    [sym_fun_expression] = STATE(2069),
    [sym_try_expression] = STATE(2069),
    [sym_match_expression] = STATE(2069),
    [sym_function_expression] = STATE(2069),
    [sym_mutate_expression] = STATE(2069),
    [sym_index_expression] = STATE(2069),
    [sym_typed_expression] = STATE(2069),
    [sym_declaration_expression] = STATE(2069),
    [sym_do_expression] = STATE(2069),
    [sym_list_expression] = STATE(2069),
    [sym_array_expression] = STATE(2069),
    [sym_begin_end_expression] = STATE(2069),
    [sym_paren_expression] = STATE(2069),
    [sym__high_prec_app] = STATE(2058),
    [sym__low_prec_app] = STATE(2058),
    [sym_application_expression] = STATE(2069),
    [sym_dot_expression] = STATE(2069),
    [sym_infix_expression] = STATE(2069),
    [sym_ce_expression] = STATE(2069),
    [sym_sequential_expression] = STATE(2069),
    [sym_char] = STATE(2052),
    [sym_format_string] = STATE(2056),
    [sym__string_literal] = STATE(2056),
    [sym_string] = STATE(2052),
    [sym_verbatim_string] = STATE(2052),
    [sym_bytearray] = STATE(2052),
    [sym_verbatim_bytearray] = STATE(2052),
    [sym_format_triple_quoted_string] = STATE(2057),
    [sym_triple_quoted_string] = STATE(2052),
    [sym_const] = STATE(2069),
    [sym_long_identifier] = STATE(2077),
    [sym_active_pattern] = STATE(1953),
    [sym__identifier_or_op] = STATE(2078),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(934),
    [sym_sbyte] = STATE(2052),
    [sym_byte] = STATE(2052),
    [sym_int16] = STATE(2052),
    [sym_uint16] = STATE(2052),
    [sym_int32] = STATE(2052),
    [sym_uint32] = STATE(2052),
    [sym_nativeint] = STATE(2052),
    [sym_unativeint] = STATE(2052),
    [sym_int64] = STATE(2052),
    [sym_uint64] = STATE(2052),
    [sym_ieee32] = STATE(2052),
    [sym_ieee64] = STATE(2052),
    [sym_bignum] = STATE(2052),
    [sym_decimal] = STATE(2052),
    [sym_float] = STATE(1596),
    [sym_block_comment] = STATE(1085),
    [sym_compiler_directive_decl] = STATE(1085),
    [sym_fsi_directive_decl] = STATE(1085),
    [sym_preproc_line] = STATE(1085),
    [sym_preproc_if_in_expression] = STATE(2069),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(565),
    [anon_sym_null] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(571),
    [anon_sym_LBRACK_PIPE] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(3145),
    [anon_sym_LT_AT] = ACTIONS(577),
    [anon_sym_LT_AT_AT] = ACTIONS(3147),
    [anon_sym_LBRACE_PIPE] = ACTIONS(583),
    [anon_sym_new] = ACTIONS(561),
    [anon_sym_return_BANG] = ACTIONS(585),
    [anon_sym_yield] = ACTIONS(561),
    [anon_sym_yield_BANG] = ACTIONS(585),
    [anon_sym_lazy] = ACTIONS(561),
    [anon_sym_assert] = ACTIONS(561),
    [anon_sym_upcast] = ACTIONS(561),
    [anon_sym_downcast] = ACTIONS(561),
    [anon_sym_for] = ACTIONS(589),
    [anon_sym_while] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(593),
    [anon_sym_try] = ACTIONS(595),
    [anon_sym_match] = ACTIONS(597),
    [anon_sym_match_BANG] = ACTIONS(599),
    [anon_sym_function] = ACTIONS(601),
    [anon_sym_use] = ACTIONS(609),
    [anon_sym_use_BANG] = ACTIONS(611),
    [anon_sym_do_BANG] = ACTIONS(613),
    [anon_sym_begin] = ACTIONS(615),
    [aux_sym_char_token1] = ACTIONS(619),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(621),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [anon_sym_AT_DQUOTE] = ACTIONS(625),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(627),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(629),
    [sym_bool] = ACTIONS(631),
    [sym_unit] = ACTIONS(3149),
    [anon_sym_LPAREN_PIPE] = ACTIONS(635),
    [sym_op_identifier] = ACTIONS(3151),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(639),
    [sym_xint] = ACTIONS(641),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(643),
  },
  [1086] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(85),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(946),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(1086),
    [sym_compiler_directive_decl] = STATE(1086),
    [sym_fsi_directive_decl] = STATE(1086),
    [sym_preproc_line] = STATE(1086),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(753),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1087] = {
    [sym_function_or_value_defn] = STATE(1054),
    [sym__expression] = STATE(63),
    [sym_literal_expression] = STATE(2069),
    [sym_long_identifier_or_op] = STATE(2069),
    [sym_tuple_expression] = STATE(2069),
    [sym_brace_expression] = STATE(2069),
    [sym_anon_record_expression] = STATE(2069),
    [sym_prefixed_expression] = STATE(2069),
    [sym_typecast_expression] = STATE(2069),
    [sym_for_expression] = STATE(2069),
    [sym_while_expression] = STATE(2069),
    [sym__if_branch] = STATE(10893),
    [sym_if_expression] = STATE(2069),
    [sym_fun_expression] = STATE(2069),
    [sym_try_expression] = STATE(2069),
    [sym_match_expression] = STATE(2069),
    [sym_function_expression] = STATE(2069),
    [sym_mutate_expression] = STATE(2069),
    [sym_index_expression] = STATE(2069),
    [sym_typed_expression] = STATE(2069),
    [sym_declaration_expression] = STATE(2069),
    [sym_do_expression] = STATE(2069),
    [sym_list_expression] = STATE(2069),
    [sym_array_expression] = STATE(2069),
    [sym_begin_end_expression] = STATE(2069),
    [sym_paren_expression] = STATE(2069),
    [sym__high_prec_app] = STATE(2058),
    [sym__low_prec_app] = STATE(2058),
    [sym_application_expression] = STATE(2069),
    [sym_dot_expression] = STATE(2069),
    [sym_infix_expression] = STATE(2069),
    [sym_ce_expression] = STATE(2069),
    [sym_sequential_expression] = STATE(2069),
    [sym_char] = STATE(2052),
    [sym_format_string] = STATE(2056),
    [sym__string_literal] = STATE(2056),
    [sym_string] = STATE(2052),
    [sym_verbatim_string] = STATE(2052),
    [sym_bytearray] = STATE(2052),
    [sym_verbatim_bytearray] = STATE(2052),
    [sym_format_triple_quoted_string] = STATE(2057),
    [sym_triple_quoted_string] = STATE(2052),
    [sym_const] = STATE(2069),
    [sym_long_identifier] = STATE(2077),
    [sym_active_pattern] = STATE(1953),
    [sym__identifier_or_op] = STATE(2078),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(934),
    [sym_sbyte] = STATE(2052),
    [sym_byte] = STATE(2052),
    [sym_int16] = STATE(2052),
    [sym_uint16] = STATE(2052),
    [sym_int32] = STATE(2052),
    [sym_uint32] = STATE(2052),
    [sym_nativeint] = STATE(2052),
    [sym_unativeint] = STATE(2052),
    [sym_int64] = STATE(2052),
    [sym_uint64] = STATE(2052),
    [sym_ieee32] = STATE(2052),
    [sym_ieee64] = STATE(2052),
    [sym_bignum] = STATE(2052),
    [sym_decimal] = STATE(2052),
    [sym_float] = STATE(1596),
    [sym_block_comment] = STATE(1087),
    [sym_compiler_directive_decl] = STATE(1087),
    [sym_fsi_directive_decl] = STATE(1087),
    [sym_preproc_line] = STATE(1087),
    [sym_preproc_if_in_expression] = STATE(2069),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(557),
    [anon_sym_return] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(565),
    [anon_sym_null] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(571),
    [anon_sym_LBRACK_PIPE] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(3145),
    [anon_sym_LT_AT] = ACTIONS(577),
    [anon_sym_LT_AT_AT] = ACTIONS(3147),
    [anon_sym_LBRACE_PIPE] = ACTIONS(583),
    [anon_sym_new] = ACTIONS(561),
    [anon_sym_return_BANG] = ACTIONS(585),
    [anon_sym_yield] = ACTIONS(561),
    [anon_sym_yield_BANG] = ACTIONS(585),
    [anon_sym_lazy] = ACTIONS(561),
    [anon_sym_assert] = ACTIONS(561),
    [anon_sym_upcast] = ACTIONS(561),
    [anon_sym_downcast] = ACTIONS(561),
    [anon_sym_for] = ACTIONS(589),
    [anon_sym_while] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(593),
    [anon_sym_try] = ACTIONS(595),
    [anon_sym_match] = ACTIONS(597),
    [anon_sym_match_BANG] = ACTIONS(599),
    [anon_sym_function] = ACTIONS(601),
    [anon_sym_use] = ACTIONS(609),
    [anon_sym_use_BANG] = ACTIONS(611),
    [anon_sym_do_BANG] = ACTIONS(613),
    [anon_sym_begin] = ACTIONS(615),
    [aux_sym_char_token1] = ACTIONS(619),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(621),
    [anon_sym_DQUOTE] = ACTIONS(623),
    [anon_sym_AT_DQUOTE] = ACTIONS(625),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(627),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(629),
    [sym_bool] = ACTIONS(631),
    [sym_unit] = ACTIONS(3149),
    [anon_sym_LPAREN_PIPE] = ACTIONS(635),
    [sym_op_identifier] = ACTIONS(3151),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(639),
    [sym_xint] = ACTIONS(641),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(643),
  },
  [1088] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(539),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(1088),
    [sym_compiler_directive_decl] = STATE(1088),
    [sym_fsi_directive_decl] = STATE(1088),
    [sym_preproc_line] = STATE(1088),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [1089] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(379),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1045),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(1089),
    [sym_compiler_directive_decl] = STATE(1089),
    [sym_fsi_directive_decl] = STATE(1089),
    [sym_preproc_line] = STATE(1089),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [1090] = {
    [sym_function_or_value_defn] = STATE(964),
    [sym__expression] = STATE(106),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(793),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(1090),
    [sym_compiler_directive_decl] = STATE(1090),
    [sym_fsi_directive_decl] = STATE(1090),
    [sym_preproc_line] = STATE(1090),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(53),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(29),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_upcast] = ACTIONS(29),
    [anon_sym_downcast] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(99),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(111),
    [sym_xint] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
  },
  [1091] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(377),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1091),
    [sym_compiler_directive_decl] = STATE(1091),
    [sym_fsi_directive_decl] = STATE(1091),
    [sym_preproc_line] = STATE(1091),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1092] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(375),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1092),
    [sym_compiler_directive_decl] = STATE(1092),
    [sym_fsi_directive_decl] = STATE(1092),
    [sym_preproc_line] = STATE(1092),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1093] = {
    [sym_function_or_value_defn] = STATE(1074),
    [sym__expression] = STATE(194),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(944),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(2718),
    [sym_block_comment] = STATE(1093),
    [sym_compiler_directive_decl] = STATE(1093),
    [sym_fsi_directive_decl] = STATE(1093),
    [sym_preproc_line] = STATE(1093),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_return] = ACTIONS(1252),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(3081),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_return_BANG] = ACTIONS(1256),
    [anon_sym_yield] = ACTIONS(1252),
    [anon_sym_yield_BANG] = ACTIONS(1256),
    [anon_sym_lazy] = ACTIONS(1252),
    [anon_sym_assert] = ACTIONS(1252),
    [anon_sym_upcast] = ACTIONS(1252),
    [anon_sym_downcast] = ACTIONS(1252),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_use] = ACTIONS(1260),
    [anon_sym_use_BANG] = ACTIONS(1262),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(3083),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(3085),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1264),
    [sym_xint] = ACTIONS(1266),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
  },
  [1094] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(369),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1094),
    [sym_compiler_directive_decl] = STATE(1094),
    [sym_fsi_directive_decl] = STATE(1094),
    [sym_preproc_line] = STATE(1094),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1095] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(89),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(946),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(1095),
    [sym_compiler_directive_decl] = STATE(1095),
    [sym_fsi_directive_decl] = STATE(1095),
    [sym_preproc_line] = STATE(1095),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(753),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1096] = {
    [sym_function_or_value_defn] = STATE(1074),
    [sym__expression] = STATE(145),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(944),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(2718),
    [sym_block_comment] = STATE(1096),
    [sym_compiler_directive_decl] = STATE(1096),
    [sym_fsi_directive_decl] = STATE(1096),
    [sym_preproc_line] = STATE(1096),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_return] = ACTIONS(1252),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(3081),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_return_BANG] = ACTIONS(1256),
    [anon_sym_yield] = ACTIONS(1252),
    [anon_sym_yield_BANG] = ACTIONS(1256),
    [anon_sym_lazy] = ACTIONS(1252),
    [anon_sym_assert] = ACTIONS(1252),
    [anon_sym_upcast] = ACTIONS(1252),
    [anon_sym_downcast] = ACTIONS(1252),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_use] = ACTIONS(1260),
    [anon_sym_use_BANG] = ACTIONS(1262),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(3083),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(3085),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1264),
    [sym_xint] = ACTIONS(1266),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
  },
  [1097] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(372),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1097),
    [sym_compiler_directive_decl] = STATE(1097),
    [sym_fsi_directive_decl] = STATE(1097),
    [sym_preproc_line] = STATE(1097),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1098] = {
    [sym_function_or_value_defn] = STATE(964),
    [sym__expression] = STATE(123),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(793),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(1098),
    [sym_compiler_directive_decl] = STATE(1098),
    [sym_fsi_directive_decl] = STATE(1098),
    [sym_preproc_line] = STATE(1098),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(53),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(29),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_upcast] = ACTIONS(29),
    [anon_sym_downcast] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(99),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(111),
    [sym_xint] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
  },
  [1099] = {
    [sym_function_or_value_defn] = STATE(1099),
    [sym__expression] = STATE(264),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1020),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(2924),
    [sym_block_comment] = STATE(1099),
    [sym_compiler_directive_decl] = STATE(1099),
    [sym_fsi_directive_decl] = STATE(1099),
    [sym_preproc_line] = STATE(1099),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(2638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(1492),
    [anon_sym_return_BANG] = ACTIONS(1496),
    [anon_sym_yield] = ACTIONS(1492),
    [anon_sym_yield_BANG] = ACTIONS(1496),
    [anon_sym_lazy] = ACTIONS(1492),
    [anon_sym_assert] = ACTIONS(1492),
    [anon_sym_upcast] = ACTIONS(1492),
    [anon_sym_downcast] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_use] = ACTIONS(1500),
    [anon_sym_use_BANG] = ACTIONS(1502),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(2642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1504),
    [sym_xint] = ACTIONS(1506),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
  },
  [1100] = {
    [sym_function_or_value_defn] = STATE(1099),
    [sym__expression] = STATE(394),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1020),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(2924),
    [sym_block_comment] = STATE(1100),
    [sym_compiler_directive_decl] = STATE(1100),
    [sym_fsi_directive_decl] = STATE(1100),
    [sym_preproc_line] = STATE(1100),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(2638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(1492),
    [anon_sym_return_BANG] = ACTIONS(1496),
    [anon_sym_yield] = ACTIONS(1492),
    [anon_sym_yield_BANG] = ACTIONS(1496),
    [anon_sym_lazy] = ACTIONS(1492),
    [anon_sym_assert] = ACTIONS(1492),
    [anon_sym_upcast] = ACTIONS(1492),
    [anon_sym_downcast] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_use] = ACTIONS(1500),
    [anon_sym_use_BANG] = ACTIONS(1502),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(2642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1504),
    [sym_xint] = ACTIONS(1506),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
  },
  [1101] = {
    [sym_function_or_value_defn] = STATE(1099),
    [sym__expression] = STATE(400),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1020),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(2924),
    [sym_block_comment] = STATE(1101),
    [sym_compiler_directive_decl] = STATE(1101),
    [sym_fsi_directive_decl] = STATE(1101),
    [sym_preproc_line] = STATE(1101),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(2638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(1492),
    [anon_sym_return_BANG] = ACTIONS(1496),
    [anon_sym_yield] = ACTIONS(1492),
    [anon_sym_yield_BANG] = ACTIONS(1496),
    [anon_sym_lazy] = ACTIONS(1492),
    [anon_sym_assert] = ACTIONS(1492),
    [anon_sym_upcast] = ACTIONS(1492),
    [anon_sym_downcast] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_use] = ACTIONS(1500),
    [anon_sym_use_BANG] = ACTIONS(1502),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(2642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1504),
    [sym_xint] = ACTIONS(1506),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
  },
  [1102] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(367),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1102),
    [sym_compiler_directive_decl] = STATE(1102),
    [sym_fsi_directive_decl] = STATE(1102),
    [sym_preproc_line] = STATE(1102),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1103] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(366),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1103),
    [sym_compiler_directive_decl] = STATE(1103),
    [sym_fsi_directive_decl] = STATE(1103),
    [sym_preproc_line] = STATE(1103),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1104] = {
    [sym_function_or_value_defn] = STATE(1099),
    [sym__expression] = STATE(497),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1020),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(2924),
    [sym_block_comment] = STATE(1104),
    [sym_compiler_directive_decl] = STATE(1104),
    [sym_fsi_directive_decl] = STATE(1104),
    [sym_preproc_line] = STATE(1104),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(2638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(1492),
    [anon_sym_return_BANG] = ACTIONS(1496),
    [anon_sym_yield] = ACTIONS(1492),
    [anon_sym_yield_BANG] = ACTIONS(1496),
    [anon_sym_lazy] = ACTIONS(1492),
    [anon_sym_assert] = ACTIONS(1492),
    [anon_sym_upcast] = ACTIONS(1492),
    [anon_sym_downcast] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_use] = ACTIONS(1500),
    [anon_sym_use_BANG] = ACTIONS(1502),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(2642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1504),
    [sym_xint] = ACTIONS(1506),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
  },
  [1105] = {
    [sym_function_or_value_defn] = STATE(1099),
    [sym__expression] = STATE(480),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1020),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(2924),
    [sym_block_comment] = STATE(1105),
    [sym_compiler_directive_decl] = STATE(1105),
    [sym_fsi_directive_decl] = STATE(1105),
    [sym_preproc_line] = STATE(1105),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(2638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(1492),
    [anon_sym_return_BANG] = ACTIONS(1496),
    [anon_sym_yield] = ACTIONS(1492),
    [anon_sym_yield_BANG] = ACTIONS(1496),
    [anon_sym_lazy] = ACTIONS(1492),
    [anon_sym_assert] = ACTIONS(1492),
    [anon_sym_upcast] = ACTIONS(1492),
    [anon_sym_downcast] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_use] = ACTIONS(1500),
    [anon_sym_use_BANG] = ACTIONS(1502),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(2642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1504),
    [sym_xint] = ACTIONS(1506),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
  },
  [1106] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(365),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1106),
    [sym_compiler_directive_decl] = STATE(1106),
    [sym_fsi_directive_decl] = STATE(1106),
    [sym_preproc_line] = STATE(1106),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1107] = {
    [sym_function_or_value_defn] = STATE(1099),
    [sym__expression] = STATE(333),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1020),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(2924),
    [sym_block_comment] = STATE(1107),
    [sym_compiler_directive_decl] = STATE(1107),
    [sym_fsi_directive_decl] = STATE(1107),
    [sym_preproc_line] = STATE(1107),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(2638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(1492),
    [anon_sym_return_BANG] = ACTIONS(1496),
    [anon_sym_yield] = ACTIONS(1492),
    [anon_sym_yield_BANG] = ACTIONS(1496),
    [anon_sym_lazy] = ACTIONS(1492),
    [anon_sym_assert] = ACTIONS(1492),
    [anon_sym_upcast] = ACTIONS(1492),
    [anon_sym_downcast] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_use] = ACTIONS(1500),
    [anon_sym_use_BANG] = ACTIONS(1502),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(2642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1504),
    [sym_xint] = ACTIONS(1506),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
  },
  [1108] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(360),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1108),
    [sym_compiler_directive_decl] = STATE(1108),
    [sym_fsi_directive_decl] = STATE(1108),
    [sym_preproc_line] = STATE(1108),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1109] = {
    [sym_function_or_value_defn] = STATE(1099),
    [sym__expression] = STATE(326),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1020),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(2924),
    [sym_block_comment] = STATE(1109),
    [sym_compiler_directive_decl] = STATE(1109),
    [sym_fsi_directive_decl] = STATE(1109),
    [sym_preproc_line] = STATE(1109),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(2638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(1492),
    [anon_sym_return_BANG] = ACTIONS(1496),
    [anon_sym_yield] = ACTIONS(1492),
    [anon_sym_yield_BANG] = ACTIONS(1496),
    [anon_sym_lazy] = ACTIONS(1492),
    [anon_sym_assert] = ACTIONS(1492),
    [anon_sym_upcast] = ACTIONS(1492),
    [anon_sym_downcast] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_use] = ACTIONS(1500),
    [anon_sym_use_BANG] = ACTIONS(1502),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(2642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1504),
    [sym_xint] = ACTIONS(1506),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
  },
  [1110] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(357),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1110),
    [sym_compiler_directive_decl] = STATE(1110),
    [sym_fsi_directive_decl] = STATE(1110),
    [sym_preproc_line] = STATE(1110),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1111] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(353),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1111),
    [sym_compiler_directive_decl] = STATE(1111),
    [sym_fsi_directive_decl] = STATE(1111),
    [sym_preproc_line] = STATE(1111),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1112] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(351),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1112),
    [sym_compiler_directive_decl] = STATE(1112),
    [sym_fsi_directive_decl] = STATE(1112),
    [sym_preproc_line] = STATE(1112),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1113] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(223),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(1113),
    [sym_compiler_directive_decl] = STATE(1113),
    [sym_fsi_directive_decl] = STATE(1113),
    [sym_preproc_line] = STATE(1113),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
  },
  [1114] = {
    [sym_function_or_value_defn] = STATE(1122),
    [sym__expression] = STATE(49),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(938),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(1598),
    [sym_block_comment] = STATE(1114),
    [sym_compiler_directive_decl] = STATE(1114),
    [sym_fsi_directive_decl] = STATE(1114),
    [sym_preproc_line] = STATE(1114),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_return] = ACTIONS(475),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(3081),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(475),
    [anon_sym_return_BANG] = ACTIONS(497),
    [anon_sym_yield] = ACTIONS(475),
    [anon_sym_yield_BANG] = ACTIONS(497),
    [anon_sym_lazy] = ACTIONS(475),
    [anon_sym_assert] = ACTIONS(475),
    [anon_sym_upcast] = ACTIONS(475),
    [anon_sym_downcast] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_use] = ACTIONS(521),
    [anon_sym_use_BANG] = ACTIONS(523),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(3083),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(3085),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(551),
    [sym_xint] = ACTIONS(553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
  },
  [1115] = {
    [sym_function_or_value_defn] = STATE(1122),
    [sym__expression] = STATE(46),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(938),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(1598),
    [sym_block_comment] = STATE(1115),
    [sym_compiler_directive_decl] = STATE(1115),
    [sym_fsi_directive_decl] = STATE(1115),
    [sym_preproc_line] = STATE(1115),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_return] = ACTIONS(475),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(3081),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(475),
    [anon_sym_return_BANG] = ACTIONS(497),
    [anon_sym_yield] = ACTIONS(475),
    [anon_sym_yield_BANG] = ACTIONS(497),
    [anon_sym_lazy] = ACTIONS(475),
    [anon_sym_assert] = ACTIONS(475),
    [anon_sym_upcast] = ACTIONS(475),
    [anon_sym_downcast] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_use] = ACTIONS(521),
    [anon_sym_use_BANG] = ACTIONS(523),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(3083),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(3085),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(551),
    [sym_xint] = ACTIONS(553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
  },
  [1116] = {
    [sym_function_or_value_defn] = STATE(1122),
    [sym__expression] = STATE(71),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(938),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(1598),
    [sym_block_comment] = STATE(1116),
    [sym_compiler_directive_decl] = STATE(1116),
    [sym_fsi_directive_decl] = STATE(1116),
    [sym_preproc_line] = STATE(1116),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_return] = ACTIONS(475),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(3081),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(475),
    [anon_sym_return_BANG] = ACTIONS(497),
    [anon_sym_yield] = ACTIONS(475),
    [anon_sym_yield_BANG] = ACTIONS(497),
    [anon_sym_lazy] = ACTIONS(475),
    [anon_sym_assert] = ACTIONS(475),
    [anon_sym_upcast] = ACTIONS(475),
    [anon_sym_downcast] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_use] = ACTIONS(521),
    [anon_sym_use_BANG] = ACTIONS(523),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(3083),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(3085),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(551),
    [sym_xint] = ACTIONS(553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
  },
  [1117] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(347),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1117),
    [sym_compiler_directive_decl] = STATE(1117),
    [sym_fsi_directive_decl] = STATE(1117),
    [sym_preproc_line] = STATE(1117),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1118] = {
    [sym_function_or_value_defn] = STATE(1122),
    [sym__expression] = STATE(51),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(938),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(1598),
    [sym_block_comment] = STATE(1118),
    [sym_compiler_directive_decl] = STATE(1118),
    [sym_fsi_directive_decl] = STATE(1118),
    [sym_preproc_line] = STATE(1118),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_return] = ACTIONS(475),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(3081),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(475),
    [anon_sym_return_BANG] = ACTIONS(497),
    [anon_sym_yield] = ACTIONS(475),
    [anon_sym_yield_BANG] = ACTIONS(497),
    [anon_sym_lazy] = ACTIONS(475),
    [anon_sym_assert] = ACTIONS(475),
    [anon_sym_upcast] = ACTIONS(475),
    [anon_sym_downcast] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_use] = ACTIONS(521),
    [anon_sym_use_BANG] = ACTIONS(523),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(3083),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(3085),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(551),
    [sym_xint] = ACTIONS(553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
  },
  [1119] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(343),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1119),
    [sym_compiler_directive_decl] = STATE(1119),
    [sym_fsi_directive_decl] = STATE(1119),
    [sym_preproc_line] = STATE(1119),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1120] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(341),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1120),
    [sym_compiler_directive_decl] = STATE(1120),
    [sym_fsi_directive_decl] = STATE(1120),
    [sym_preproc_line] = STATE(1120),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1121] = {
    [sym_function_or_value_defn] = STATE(1122),
    [sym__expression] = STATE(54),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(938),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(1598),
    [sym_block_comment] = STATE(1121),
    [sym_compiler_directive_decl] = STATE(1121),
    [sym_fsi_directive_decl] = STATE(1121),
    [sym_preproc_line] = STATE(1121),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_return] = ACTIONS(475),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(3081),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(475),
    [anon_sym_return_BANG] = ACTIONS(497),
    [anon_sym_yield] = ACTIONS(475),
    [anon_sym_yield_BANG] = ACTIONS(497),
    [anon_sym_lazy] = ACTIONS(475),
    [anon_sym_assert] = ACTIONS(475),
    [anon_sym_upcast] = ACTIONS(475),
    [anon_sym_downcast] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_use] = ACTIONS(521),
    [anon_sym_use_BANG] = ACTIONS(523),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(3083),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(3085),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(551),
    [sym_xint] = ACTIONS(553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
  },
  [1122] = {
    [sym_function_or_value_defn] = STATE(1122),
    [sym__expression] = STATE(55),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(938),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(1598),
    [sym_block_comment] = STATE(1122),
    [sym_compiler_directive_decl] = STATE(1122),
    [sym_fsi_directive_decl] = STATE(1122),
    [sym_preproc_line] = STATE(1122),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_return] = ACTIONS(475),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(3081),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(475),
    [anon_sym_return_BANG] = ACTIONS(497),
    [anon_sym_yield] = ACTIONS(475),
    [anon_sym_yield_BANG] = ACTIONS(497),
    [anon_sym_lazy] = ACTIONS(475),
    [anon_sym_assert] = ACTIONS(475),
    [anon_sym_upcast] = ACTIONS(475),
    [anon_sym_downcast] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_use] = ACTIONS(521),
    [anon_sym_use_BANG] = ACTIONS(523),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(3083),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(3085),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(551),
    [sym_xint] = ACTIONS(553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
  },
  [1123] = {
    [sym_function_or_value_defn] = STATE(1084),
    [sym__expression] = STATE(48),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(936),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(1592),
    [sym_block_comment] = STATE(1123),
    [sym_compiler_directive_decl] = STATE(1123),
    [sym_fsi_directive_decl] = STATE(1123),
    [sym_preproc_line] = STATE(1123),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(651),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(2638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(651),
    [anon_sym_return_BANG] = ACTIONS(673),
    [anon_sym_yield] = ACTIONS(651),
    [anon_sym_yield_BANG] = ACTIONS(673),
    [anon_sym_lazy] = ACTIONS(651),
    [anon_sym_assert] = ACTIONS(651),
    [anon_sym_upcast] = ACTIONS(651),
    [anon_sym_downcast] = ACTIONS(651),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_use] = ACTIONS(697),
    [anon_sym_use_BANG] = ACTIONS(699),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(2642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(727),
    [sym_xint] = ACTIONS(729),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
  },
  [1124] = {
    [sym_function_or_value_defn] = STATE(1084),
    [sym__expression] = STATE(52),
    [sym_literal_expression] = STATE(1996),
    [sym_long_identifier_or_op] = STATE(1996),
    [sym_tuple_expression] = STATE(1996),
    [sym_brace_expression] = STATE(1996),
    [sym_anon_record_expression] = STATE(1996),
    [sym_prefixed_expression] = STATE(1996),
    [sym_typecast_expression] = STATE(1996),
    [sym_for_expression] = STATE(1996),
    [sym_while_expression] = STATE(1996),
    [sym__if_branch] = STATE(10685),
    [sym_if_expression] = STATE(1996),
    [sym_fun_expression] = STATE(1996),
    [sym_try_expression] = STATE(1996),
    [sym_match_expression] = STATE(1996),
    [sym_function_expression] = STATE(1996),
    [sym_mutate_expression] = STATE(1996),
    [sym_index_expression] = STATE(1996),
    [sym_typed_expression] = STATE(1996),
    [sym_declaration_expression] = STATE(1996),
    [sym_do_expression] = STATE(1996),
    [sym_list_expression] = STATE(1996),
    [sym_array_expression] = STATE(1996),
    [sym_begin_end_expression] = STATE(1996),
    [sym_paren_expression] = STATE(1996),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(1996),
    [sym_dot_expression] = STATE(1996),
    [sym_infix_expression] = STATE(1996),
    [sym_ce_expression] = STATE(1996),
    [sym_sequential_expression] = STATE(1996),
    [sym_char] = STATE(2070),
    [sym_format_string] = STATE(2075),
    [sym__string_literal] = STATE(2075),
    [sym_string] = STATE(2070),
    [sym_verbatim_string] = STATE(2070),
    [sym_bytearray] = STATE(2070),
    [sym_verbatim_bytearray] = STATE(2070),
    [sym_format_triple_quoted_string] = STATE(2076),
    [sym_triple_quoted_string] = STATE(2070),
    [sym_const] = STATE(1996),
    [sym_long_identifier] = STATE(2055),
    [sym_active_pattern] = STATE(1928),
    [sym__identifier_or_op] = STATE(2054),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(936),
    [sym_sbyte] = STATE(2070),
    [sym_byte] = STATE(2070),
    [sym_int16] = STATE(2070),
    [sym_uint16] = STATE(2070),
    [sym_int32] = STATE(2070),
    [sym_uint32] = STATE(2070),
    [sym_nativeint] = STATE(2070),
    [sym_unativeint] = STATE(2070),
    [sym_int64] = STATE(2070),
    [sym_uint64] = STATE(2070),
    [sym_ieee32] = STATE(2070),
    [sym_ieee64] = STATE(2070),
    [sym_bignum] = STATE(2070),
    [sym_decimal] = STATE(2070),
    [sym_float] = STATE(1592),
    [sym_block_comment] = STATE(1124),
    [sym_compiler_directive_decl] = STATE(1124),
    [sym_fsi_directive_decl] = STATE(1124),
    [sym_preproc_line] = STATE(1124),
    [sym_preproc_if_in_expression] = STATE(1996),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(651),
    [anon_sym_do] = ACTIONS(735),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LBRACK_PIPE] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_LT_AT] = ACTIONS(665),
    [anon_sym_LT_AT_AT] = ACTIONS(2638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(651),
    [anon_sym_return_BANG] = ACTIONS(673),
    [anon_sym_yield] = ACTIONS(651),
    [anon_sym_yield_BANG] = ACTIONS(673),
    [anon_sym_lazy] = ACTIONS(651),
    [anon_sym_assert] = ACTIONS(651),
    [anon_sym_upcast] = ACTIONS(651),
    [anon_sym_downcast] = ACTIONS(651),
    [anon_sym_for] = ACTIONS(677),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(681),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_match_BANG] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_use] = ACTIONS(697),
    [anon_sym_use_BANG] = ACTIONS(699),
    [anon_sym_do_BANG] = ACTIONS(701),
    [anon_sym_begin] = ACTIONS(703),
    [aux_sym_char_token1] = ACTIONS(707),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_AT_DQUOTE] = ACTIONS(713),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(717),
    [sym_bool] = ACTIONS(719),
    [sym_unit] = ACTIONS(2642),
    [anon_sym_LPAREN_PIPE] = ACTIONS(723),
    [sym_op_identifier] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(727),
    [sym_xint] = ACTIONS(729),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(737),
  },
  [1125] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(335),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1125),
    [sym_compiler_directive_decl] = STATE(1125),
    [sym_fsi_directive_decl] = STATE(1125),
    [sym_preproc_line] = STATE(1125),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1126] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(112),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(1126),
    [sym_compiler_directive_decl] = STATE(1126),
    [sym_fsi_directive_decl] = STATE(1126),
    [sym_preproc_line] = STATE(1126),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [1127] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(334),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1127),
    [sym_compiler_directive_decl] = STATE(1127),
    [sym_fsi_directive_decl] = STATE(1127),
    [sym_preproc_line] = STATE(1127),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1128] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(520),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(1128),
    [sym_compiler_directive_decl] = STATE(1128),
    [sym_fsi_directive_decl] = STATE(1128),
    [sym_preproc_line] = STATE(1128),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [1129] = {
    [sym_function_or_value_defn] = STATE(1074),
    [sym__expression] = STATE(173),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(944),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(2718),
    [sym_block_comment] = STATE(1129),
    [sym_compiler_directive_decl] = STATE(1129),
    [sym_fsi_directive_decl] = STATE(1129),
    [sym_preproc_line] = STATE(1129),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_return] = ACTIONS(1252),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(3081),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_return_BANG] = ACTIONS(1256),
    [anon_sym_yield] = ACTIONS(1252),
    [anon_sym_yield_BANG] = ACTIONS(1256),
    [anon_sym_lazy] = ACTIONS(1252),
    [anon_sym_assert] = ACTIONS(1252),
    [anon_sym_upcast] = ACTIONS(1252),
    [anon_sym_downcast] = ACTIONS(1252),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_use] = ACTIONS(1260),
    [anon_sym_use_BANG] = ACTIONS(1262),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(3083),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(3085),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1264),
    [sym_xint] = ACTIONS(1266),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
  },
  [1130] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(109),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(1130),
    [sym_compiler_directive_decl] = STATE(1130),
    [sym_fsi_directive_decl] = STATE(1130),
    [sym_preproc_line] = STATE(1130),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [1131] = {
    [sym_function_or_value_defn] = STATE(964),
    [sym__expression] = STATE(124),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(793),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(1131),
    [sym_compiler_directive_decl] = STATE(1131),
    [sym_fsi_directive_decl] = STATE(1131),
    [sym_preproc_line] = STATE(1131),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(53),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(29),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_upcast] = ACTIONS(29),
    [anon_sym_downcast] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(99),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(111),
    [sym_xint] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
  },
  [1132] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(331),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1132),
    [sym_compiler_directive_decl] = STATE(1132),
    [sym_fsi_directive_decl] = STATE(1132),
    [sym_preproc_line] = STATE(1132),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1133] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(534),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(1133),
    [sym_compiler_directive_decl] = STATE(1133),
    [sym_fsi_directive_decl] = STATE(1133),
    [sym_preproc_line] = STATE(1133),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [1134] = {
    [sym_function_or_value_defn] = STATE(1074),
    [sym__expression] = STATE(241),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(944),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(2718),
    [sym_block_comment] = STATE(1134),
    [sym_compiler_directive_decl] = STATE(1134),
    [sym_fsi_directive_decl] = STATE(1134),
    [sym_preproc_line] = STATE(1134),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_return] = ACTIONS(1252),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(3081),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_return_BANG] = ACTIONS(1256),
    [anon_sym_yield] = ACTIONS(1252),
    [anon_sym_yield_BANG] = ACTIONS(1256),
    [anon_sym_lazy] = ACTIONS(1252),
    [anon_sym_assert] = ACTIONS(1252),
    [anon_sym_upcast] = ACTIONS(1252),
    [anon_sym_downcast] = ACTIONS(1252),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_use] = ACTIONS(1260),
    [anon_sym_use_BANG] = ACTIONS(1262),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(3083),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(3085),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1264),
    [sym_xint] = ACTIONS(1266),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
  },
  [1135] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(361),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1045),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(1135),
    [sym_compiler_directive_decl] = STATE(1135),
    [sym_fsi_directive_decl] = STATE(1135),
    [sym_preproc_line] = STATE(1135),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [1136] = {
    [sym_function_or_value_defn] = STATE(1074),
    [sym__expression] = STATE(154),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(944),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(2718),
    [sym_block_comment] = STATE(1136),
    [sym_compiler_directive_decl] = STATE(1136),
    [sym_fsi_directive_decl] = STATE(1136),
    [sym_preproc_line] = STATE(1136),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_return] = ACTIONS(1252),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(3081),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_return_BANG] = ACTIONS(1256),
    [anon_sym_yield] = ACTIONS(1252),
    [anon_sym_yield_BANG] = ACTIONS(1256),
    [anon_sym_lazy] = ACTIONS(1252),
    [anon_sym_assert] = ACTIONS(1252),
    [anon_sym_upcast] = ACTIONS(1252),
    [anon_sym_downcast] = ACTIONS(1252),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_use] = ACTIONS(1260),
    [anon_sym_use_BANG] = ACTIONS(1262),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(3083),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(3085),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1264),
    [sym_xint] = ACTIONS(1266),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
  },
  [1137] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(250),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1137),
    [sym_compiler_directive_decl] = STATE(1137),
    [sym_fsi_directive_decl] = STATE(1137),
    [sym_preproc_line] = STATE(1137),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1138] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(330),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1138),
    [sym_compiler_directive_decl] = STATE(1138),
    [sym_fsi_directive_decl] = STATE(1138),
    [sym_preproc_line] = STATE(1138),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1139] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(329),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1139),
    [sym_compiler_directive_decl] = STATE(1139),
    [sym_fsi_directive_decl] = STATE(1139),
    [sym_preproc_line] = STATE(1139),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1140] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(265),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1151),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(1140),
    [sym_compiler_directive_decl] = STATE(1140),
    [sym_fsi_directive_decl] = STATE(1140),
    [sym_preproc_line] = STATE(1140),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_begin] = ACTIONS(1782),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
  },
  [1141] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(537),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(1141),
    [sym_compiler_directive_decl] = STATE(1141),
    [sym_fsi_directive_decl] = STATE(1141),
    [sym_preproc_line] = STATE(1141),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [1142] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(536),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(1142),
    [sym_compiler_directive_decl] = STATE(1142),
    [sym_fsi_directive_decl] = STATE(1142),
    [sym_preproc_line] = STATE(1142),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [1143] = {
    [sym_function_or_value_defn] = STATE(1074),
    [sym__expression] = STATE(160),
    [sym_literal_expression] = STATE(1944),
    [sym_long_identifier_or_op] = STATE(1944),
    [sym_tuple_expression] = STATE(1944),
    [sym_brace_expression] = STATE(1944),
    [sym_anon_record_expression] = STATE(1944),
    [sym_prefixed_expression] = STATE(1944),
    [sym_typecast_expression] = STATE(1944),
    [sym_for_expression] = STATE(1944),
    [sym_while_expression] = STATE(1944),
    [sym__if_branch] = STATE(10813),
    [sym_if_expression] = STATE(1944),
    [sym_fun_expression] = STATE(1944),
    [sym_try_expression] = STATE(1944),
    [sym_match_expression] = STATE(1944),
    [sym_function_expression] = STATE(1944),
    [sym_mutate_expression] = STATE(1944),
    [sym_index_expression] = STATE(1944),
    [sym_typed_expression] = STATE(1944),
    [sym_declaration_expression] = STATE(1944),
    [sym_do_expression] = STATE(1944),
    [sym_list_expression] = STATE(1944),
    [sym_array_expression] = STATE(1944),
    [sym_begin_end_expression] = STATE(1944),
    [sym_paren_expression] = STATE(1944),
    [sym__high_prec_app] = STATE(1978),
    [sym__low_prec_app] = STATE(1978),
    [sym_application_expression] = STATE(1944),
    [sym_dot_expression] = STATE(1944),
    [sym_infix_expression] = STATE(1944),
    [sym_ce_expression] = STATE(1944),
    [sym_sequential_expression] = STATE(1944),
    [sym_char] = STATE(1923),
    [sym_format_string] = STATE(1919),
    [sym__string_literal] = STATE(1919),
    [sym_string] = STATE(1923),
    [sym_verbatim_string] = STATE(1923),
    [sym_bytearray] = STATE(1923),
    [sym_verbatim_bytearray] = STATE(1923),
    [sym_format_triple_quoted_string] = STATE(1910),
    [sym_triple_quoted_string] = STATE(1923),
    [sym_const] = STATE(1944),
    [sym_long_identifier] = STATE(1951),
    [sym_active_pattern] = STATE(2071),
    [sym__identifier_or_op] = STATE(1952),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(944),
    [sym_sbyte] = STATE(1923),
    [sym_byte] = STATE(1923),
    [sym_int16] = STATE(1923),
    [sym_uint16] = STATE(1923),
    [sym_int32] = STATE(1923),
    [sym_uint32] = STATE(1923),
    [sym_nativeint] = STATE(1923),
    [sym_unativeint] = STATE(1923),
    [sym_int64] = STATE(1923),
    [sym_uint64] = STATE(1923),
    [sym_ieee32] = STATE(1923),
    [sym_ieee64] = STATE(1923),
    [sym_bignum] = STATE(1923),
    [sym_decimal] = STATE(1923),
    [sym_float] = STATE(2718),
    [sym_block_comment] = STATE(1143),
    [sym_compiler_directive_decl] = STATE(1143),
    [sym_fsi_directive_decl] = STATE(1143),
    [sym_preproc_line] = STATE(1143),
    [sym_preproc_if_in_expression] = STATE(1944),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_return] = ACTIONS(1252),
    [anon_sym_do] = ACTIONS(477),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(489),
    [anon_sym_LT_AT_AT] = ACTIONS(3081),
    [anon_sym_LBRACE_PIPE] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_return_BANG] = ACTIONS(1256),
    [anon_sym_yield] = ACTIONS(1252),
    [anon_sym_yield_BANG] = ACTIONS(1256),
    [anon_sym_lazy] = ACTIONS(1252),
    [anon_sym_assert] = ACTIONS(1252),
    [anon_sym_upcast] = ACTIONS(1252),
    [anon_sym_downcast] = ACTIONS(1252),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_match_BANG] = ACTIONS(511),
    [anon_sym_function] = ACTIONS(513),
    [anon_sym_use] = ACTIONS(1260),
    [anon_sym_use_BANG] = ACTIONS(1262),
    [anon_sym_do_BANG] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(527),
    [aux_sym_char_token1] = ACTIONS(531),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(535),
    [anon_sym_AT_DQUOTE] = ACTIONS(537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(541),
    [sym_bool] = ACTIONS(543),
    [sym_unit] = ACTIONS(3083),
    [anon_sym_LPAREN_PIPE] = ACTIONS(547),
    [sym_op_identifier] = ACTIONS(3085),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1264),
    [sym_xint] = ACTIONS(1266),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(555),
  },
  [1144] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(327),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1144),
    [sym_compiler_directive_decl] = STATE(1144),
    [sym_fsi_directive_decl] = STATE(1144),
    [sym_preproc_line] = STATE(1144),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1145] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(342),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1045),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(1145),
    [sym_compiler_directive_decl] = STATE(1145),
    [sym_fsi_directive_decl] = STATE(1145),
    [sym_preproc_line] = STATE(1145),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [1146] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(530),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(1146),
    [sym_compiler_directive_decl] = STATE(1146),
    [sym_fsi_directive_decl] = STATE(1146),
    [sym_preproc_line] = STATE(1146),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [1147] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(336),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1147),
    [sym_compiler_directive_decl] = STATE(1147),
    [sym_fsi_directive_decl] = STATE(1147),
    [sym_preproc_line] = STATE(1147),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1148] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(535),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(1148),
    [sym_compiler_directive_decl] = STATE(1148),
    [sym_fsi_directive_decl] = STATE(1148),
    [sym_preproc_line] = STATE(1148),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [1149] = {
    [sym_function_or_value_defn] = STATE(1180),
    [sym__expression] = STATE(248),
    [sym_literal_expression] = STATE(3145),
    [sym_long_identifier_or_op] = STATE(3145),
    [sym_tuple_expression] = STATE(3145),
    [sym_brace_expression] = STATE(3145),
    [sym_anon_record_expression] = STATE(3145),
    [sym_prefixed_expression] = STATE(3145),
    [sym_typecast_expression] = STATE(3145),
    [sym_for_expression] = STATE(3145),
    [sym_while_expression] = STATE(3145),
    [sym__if_branch] = STATE(10360),
    [sym_if_expression] = STATE(3145),
    [sym_fun_expression] = STATE(3145),
    [sym_try_expression] = STATE(3145),
    [sym_match_expression] = STATE(3145),
    [sym_function_expression] = STATE(3145),
    [sym_mutate_expression] = STATE(3145),
    [sym_index_expression] = STATE(3145),
    [sym_typed_expression] = STATE(3145),
    [sym_declaration_expression] = STATE(3145),
    [sym_do_expression] = STATE(3145),
    [sym_list_expression] = STATE(3145),
    [sym_array_expression] = STATE(3145),
    [sym_begin_end_expression] = STATE(3145),
    [sym_paren_expression] = STATE(3145),
    [sym__high_prec_app] = STATE(3141),
    [sym__low_prec_app] = STATE(3141),
    [sym_application_expression] = STATE(3145),
    [sym_dot_expression] = STATE(3145),
    [sym_infix_expression] = STATE(3145),
    [sym_ce_expression] = STATE(3145),
    [sym_sequential_expression] = STATE(3145),
    [sym_char] = STATE(3108),
    [sym_format_string] = STATE(3193),
    [sym__string_literal] = STATE(3193),
    [sym_string] = STATE(3108),
    [sym_verbatim_string] = STATE(3108),
    [sym_bytearray] = STATE(3108),
    [sym_verbatim_bytearray] = STATE(3108),
    [sym_format_triple_quoted_string] = STATE(3192),
    [sym_triple_quoted_string] = STATE(3108),
    [sym_const] = STATE(3145),
    [sym_long_identifier] = STATE(3102),
    [sym_active_pattern] = STATE(3172),
    [sym__identifier_or_op] = STATE(3103),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1149),
    [sym_sbyte] = STATE(3108),
    [sym_byte] = STATE(3108),
    [sym_int16] = STATE(3108),
    [sym_uint16] = STATE(3108),
    [sym_int32] = STATE(3108),
    [sym_uint32] = STATE(3108),
    [sym_nativeint] = STATE(3108),
    [sym_unativeint] = STATE(3108),
    [sym_int64] = STATE(3108),
    [sym_uint64] = STATE(3108),
    [sym_ieee32] = STATE(3108),
    [sym_ieee64] = STATE(3108),
    [sym_bignum] = STATE(3108),
    [sym_decimal] = STATE(3108),
    [sym_float] = STATE(2770),
    [sym_block_comment] = STATE(1149),
    [sym_compiler_directive_decl] = STATE(1149),
    [sym_fsi_directive_decl] = STATE(1149),
    [sym_preproc_line] = STATE(1149),
    [sym_preproc_if_in_expression] = STATE(3145),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_return] = ACTIONS(1119),
    [anon_sym_do] = ACTIONS(1121),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_null] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1131),
    [anon_sym_LBRACE] = ACTIONS(3169),
    [anon_sym_LT_AT] = ACTIONS(1135),
    [anon_sym_LT_AT_AT] = ACTIONS(3171),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1141),
    [anon_sym_new] = ACTIONS(1119),
    [anon_sym_return_BANG] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1119),
    [anon_sym_yield_BANG] = ACTIONS(1143),
    [anon_sym_lazy] = ACTIONS(1119),
    [anon_sym_assert] = ACTIONS(1119),
    [anon_sym_upcast] = ACTIONS(1119),
    [anon_sym_downcast] = ACTIONS(1119),
    [anon_sym_for] = ACTIONS(1147),
    [anon_sym_while] = ACTIONS(1149),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1151),
    [anon_sym_try] = ACTIONS(1153),
    [anon_sym_match] = ACTIONS(1155),
    [anon_sym_match_BANG] = ACTIONS(1157),
    [anon_sym_function] = ACTIONS(1159),
    [anon_sym_use] = ACTIONS(1167),
    [anon_sym_use_BANG] = ACTIONS(1169),
    [anon_sym_do_BANG] = ACTIONS(1171),
    [anon_sym_begin] = ACTIONS(1173),
    [aux_sym_char_token1] = ACTIONS(1177),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(1181),
    [anon_sym_AT_DQUOTE] = ACTIONS(1183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1185),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1187),
    [sym_bool] = ACTIONS(1189),
    [sym_unit] = ACTIONS(3173),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1193),
    [sym_op_identifier] = ACTIONS(3175),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1197),
    [sym_xint] = ACTIONS(1199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1201),
  },
  [1150] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(92),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(946),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(1150),
    [sym_compiler_directive_decl] = STATE(1150),
    [sym_fsi_directive_decl] = STATE(1150),
    [sym_preproc_line] = STATE(1150),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(753),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1151] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(424),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1151),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(1151),
    [sym_compiler_directive_decl] = STATE(1151),
    [sym_fsi_directive_decl] = STATE(1151),
    [sym_preproc_line] = STATE(1151),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_begin] = ACTIONS(1782),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
  },
  [1152] = {
    [sym_function_or_value_defn] = STATE(1163),
    [sym__expression] = STATE(33),
    [sym_literal_expression] = STATE(1715),
    [sym_long_identifier_or_op] = STATE(1715),
    [sym_tuple_expression] = STATE(1715),
    [sym_brace_expression] = STATE(1715),
    [sym_anon_record_expression] = STATE(1715),
    [sym_prefixed_expression] = STATE(1715),
    [sym_typecast_expression] = STATE(1715),
    [sym_for_expression] = STATE(1715),
    [sym_while_expression] = STATE(1715),
    [sym__if_branch] = STATE(10853),
    [sym_if_expression] = STATE(1715),
    [sym_fun_expression] = STATE(1715),
    [sym_try_expression] = STATE(1715),
    [sym_match_expression] = STATE(1715),
    [sym_function_expression] = STATE(1715),
    [sym_mutate_expression] = STATE(1715),
    [sym_index_expression] = STATE(1715),
    [sym_typed_expression] = STATE(1715),
    [sym_declaration_expression] = STATE(1715),
    [sym_do_expression] = STATE(1715),
    [sym_list_expression] = STATE(1715),
    [sym_array_expression] = STATE(1715),
    [sym_begin_end_expression] = STATE(1715),
    [sym_paren_expression] = STATE(1715),
    [sym__high_prec_app] = STATE(1728),
    [sym__low_prec_app] = STATE(1728),
    [sym_application_expression] = STATE(1715),
    [sym_dot_expression] = STATE(1715),
    [sym_infix_expression] = STATE(1715),
    [sym_ce_expression] = STATE(1715),
    [sym_sequential_expression] = STATE(1715),
    [sym_char] = STATE(1858),
    [sym_format_string] = STATE(1853),
    [sym__string_literal] = STATE(1853),
    [sym_string] = STATE(1858),
    [sym_verbatim_string] = STATE(1858),
    [sym_bytearray] = STATE(1858),
    [sym_verbatim_bytearray] = STATE(1858),
    [sym_format_triple_quoted_string] = STATE(1851),
    [sym_triple_quoted_string] = STATE(1858),
    [sym_const] = STATE(1715),
    [sym_long_identifier] = STATE(1825),
    [sym_active_pattern] = STATE(1754),
    [sym__identifier_or_op] = STATE(1822),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(940),
    [sym_sbyte] = STATE(1858),
    [sym_byte] = STATE(1858),
    [sym_int16] = STATE(1858),
    [sym_uint16] = STATE(1858),
    [sym_int32] = STATE(1858),
    [sym_uint32] = STATE(1858),
    [sym_nativeint] = STATE(1858),
    [sym_unativeint] = STATE(1858),
    [sym_int64] = STATE(1858),
    [sym_uint64] = STATE(1858),
    [sym_ieee32] = STATE(1858),
    [sym_ieee64] = STATE(1858),
    [sym_bignum] = STATE(1858),
    [sym_decimal] = STATE(1858),
    [sym_float] = STATE(1552),
    [sym_block_comment] = STATE(1152),
    [sym_compiler_directive_decl] = STATE(1152),
    [sym_fsi_directive_decl] = STATE(1152),
    [sym_preproc_line] = STATE(1152),
    [sym_preproc_if_in_expression] = STATE(1715),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_do] = ACTIONS(383),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(385),
    [anon_sym_null] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_LBRACK_PIPE] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(3159),
    [anon_sym_LT_AT] = ACTIONS(397),
    [anon_sym_LT_AT_AT] = ACTIONS(3161),
    [anon_sym_LBRACE_PIPE] = ACTIONS(403),
    [anon_sym_new] = ACTIONS(381),
    [anon_sym_return_BANG] = ACTIONS(405),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_yield_BANG] = ACTIONS(405),
    [anon_sym_lazy] = ACTIONS(381),
    [anon_sym_assert] = ACTIONS(381),
    [anon_sym_upcast] = ACTIONS(381),
    [anon_sym_downcast] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(409),
    [anon_sym_while] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(413),
    [anon_sym_try] = ACTIONS(415),
    [anon_sym_match] = ACTIONS(417),
    [anon_sym_match_BANG] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(421),
    [anon_sym_use] = ACTIONS(429),
    [anon_sym_use_BANG] = ACTIONS(431),
    [anon_sym_do_BANG] = ACTIONS(433),
    [anon_sym_begin] = ACTIONS(435),
    [aux_sym_char_token1] = ACTIONS(439),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(443),
    [anon_sym_AT_DQUOTE] = ACTIONS(445),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(447),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(449),
    [sym_bool] = ACTIONS(451),
    [sym_unit] = ACTIONS(3163),
    [anon_sym_LPAREN_PIPE] = ACTIONS(455),
    [sym_op_identifier] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(459),
    [sym_xint] = ACTIONS(461),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(463),
  },
  [1153] = {
    [sym_function_or_value_defn] = STATE(1163),
    [sym__expression] = STATE(36),
    [sym_literal_expression] = STATE(1715),
    [sym_long_identifier_or_op] = STATE(1715),
    [sym_tuple_expression] = STATE(1715),
    [sym_brace_expression] = STATE(1715),
    [sym_anon_record_expression] = STATE(1715),
    [sym_prefixed_expression] = STATE(1715),
    [sym_typecast_expression] = STATE(1715),
    [sym_for_expression] = STATE(1715),
    [sym_while_expression] = STATE(1715),
    [sym__if_branch] = STATE(10853),
    [sym_if_expression] = STATE(1715),
    [sym_fun_expression] = STATE(1715),
    [sym_try_expression] = STATE(1715),
    [sym_match_expression] = STATE(1715),
    [sym_function_expression] = STATE(1715),
    [sym_mutate_expression] = STATE(1715),
    [sym_index_expression] = STATE(1715),
    [sym_typed_expression] = STATE(1715),
    [sym_declaration_expression] = STATE(1715),
    [sym_do_expression] = STATE(1715),
    [sym_list_expression] = STATE(1715),
    [sym_array_expression] = STATE(1715),
    [sym_begin_end_expression] = STATE(1715),
    [sym_paren_expression] = STATE(1715),
    [sym__high_prec_app] = STATE(1728),
    [sym__low_prec_app] = STATE(1728),
    [sym_application_expression] = STATE(1715),
    [sym_dot_expression] = STATE(1715),
    [sym_infix_expression] = STATE(1715),
    [sym_ce_expression] = STATE(1715),
    [sym_sequential_expression] = STATE(1715),
    [sym_char] = STATE(1858),
    [sym_format_string] = STATE(1853),
    [sym__string_literal] = STATE(1853),
    [sym_string] = STATE(1858),
    [sym_verbatim_string] = STATE(1858),
    [sym_bytearray] = STATE(1858),
    [sym_verbatim_bytearray] = STATE(1858),
    [sym_format_triple_quoted_string] = STATE(1851),
    [sym_triple_quoted_string] = STATE(1858),
    [sym_const] = STATE(1715),
    [sym_long_identifier] = STATE(1825),
    [sym_active_pattern] = STATE(1754),
    [sym__identifier_or_op] = STATE(1822),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(940),
    [sym_sbyte] = STATE(1858),
    [sym_byte] = STATE(1858),
    [sym_int16] = STATE(1858),
    [sym_uint16] = STATE(1858),
    [sym_int32] = STATE(1858),
    [sym_uint32] = STATE(1858),
    [sym_nativeint] = STATE(1858),
    [sym_unativeint] = STATE(1858),
    [sym_int64] = STATE(1858),
    [sym_uint64] = STATE(1858),
    [sym_ieee32] = STATE(1858),
    [sym_ieee64] = STATE(1858),
    [sym_bignum] = STATE(1858),
    [sym_decimal] = STATE(1858),
    [sym_float] = STATE(1552),
    [sym_block_comment] = STATE(1153),
    [sym_compiler_directive_decl] = STATE(1153),
    [sym_fsi_directive_decl] = STATE(1153),
    [sym_preproc_line] = STATE(1153),
    [sym_preproc_if_in_expression] = STATE(1715),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_do] = ACTIONS(383),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(385),
    [anon_sym_null] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_LBRACK_PIPE] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(3159),
    [anon_sym_LT_AT] = ACTIONS(397),
    [anon_sym_LT_AT_AT] = ACTIONS(3161),
    [anon_sym_LBRACE_PIPE] = ACTIONS(403),
    [anon_sym_new] = ACTIONS(381),
    [anon_sym_return_BANG] = ACTIONS(405),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_yield_BANG] = ACTIONS(405),
    [anon_sym_lazy] = ACTIONS(381),
    [anon_sym_assert] = ACTIONS(381),
    [anon_sym_upcast] = ACTIONS(381),
    [anon_sym_downcast] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(409),
    [anon_sym_while] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(413),
    [anon_sym_try] = ACTIONS(415),
    [anon_sym_match] = ACTIONS(417),
    [anon_sym_match_BANG] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(421),
    [anon_sym_use] = ACTIONS(429),
    [anon_sym_use_BANG] = ACTIONS(431),
    [anon_sym_do_BANG] = ACTIONS(433),
    [anon_sym_begin] = ACTIONS(435),
    [aux_sym_char_token1] = ACTIONS(439),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(443),
    [anon_sym_AT_DQUOTE] = ACTIONS(445),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(447),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(449),
    [sym_bool] = ACTIONS(451),
    [sym_unit] = ACTIONS(3163),
    [anon_sym_LPAREN_PIPE] = ACTIONS(455),
    [sym_op_identifier] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(459),
    [sym_xint] = ACTIONS(461),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(463),
  },
  [1154] = {
    [sym_function_or_value_defn] = STATE(1163),
    [sym__expression] = STATE(42),
    [sym_literal_expression] = STATE(1715),
    [sym_long_identifier_or_op] = STATE(1715),
    [sym_tuple_expression] = STATE(1715),
    [sym_brace_expression] = STATE(1715),
    [sym_anon_record_expression] = STATE(1715),
    [sym_prefixed_expression] = STATE(1715),
    [sym_typecast_expression] = STATE(1715),
    [sym_for_expression] = STATE(1715),
    [sym_while_expression] = STATE(1715),
    [sym__if_branch] = STATE(10853),
    [sym_if_expression] = STATE(1715),
    [sym_fun_expression] = STATE(1715),
    [sym_try_expression] = STATE(1715),
    [sym_match_expression] = STATE(1715),
    [sym_function_expression] = STATE(1715),
    [sym_mutate_expression] = STATE(1715),
    [sym_index_expression] = STATE(1715),
    [sym_typed_expression] = STATE(1715),
    [sym_declaration_expression] = STATE(1715),
    [sym_do_expression] = STATE(1715),
    [sym_list_expression] = STATE(1715),
    [sym_array_expression] = STATE(1715),
    [sym_begin_end_expression] = STATE(1715),
    [sym_paren_expression] = STATE(1715),
    [sym__high_prec_app] = STATE(1728),
    [sym__low_prec_app] = STATE(1728),
    [sym_application_expression] = STATE(1715),
    [sym_dot_expression] = STATE(1715),
    [sym_infix_expression] = STATE(1715),
    [sym_ce_expression] = STATE(1715),
    [sym_sequential_expression] = STATE(1715),
    [sym_char] = STATE(1858),
    [sym_format_string] = STATE(1853),
    [sym__string_literal] = STATE(1853),
    [sym_string] = STATE(1858),
    [sym_verbatim_string] = STATE(1858),
    [sym_bytearray] = STATE(1858),
    [sym_verbatim_bytearray] = STATE(1858),
    [sym_format_triple_quoted_string] = STATE(1851),
    [sym_triple_quoted_string] = STATE(1858),
    [sym_const] = STATE(1715),
    [sym_long_identifier] = STATE(1825),
    [sym_active_pattern] = STATE(1754),
    [sym__identifier_or_op] = STATE(1822),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(940),
    [sym_sbyte] = STATE(1858),
    [sym_byte] = STATE(1858),
    [sym_int16] = STATE(1858),
    [sym_uint16] = STATE(1858),
    [sym_int32] = STATE(1858),
    [sym_uint32] = STATE(1858),
    [sym_nativeint] = STATE(1858),
    [sym_unativeint] = STATE(1858),
    [sym_int64] = STATE(1858),
    [sym_uint64] = STATE(1858),
    [sym_ieee32] = STATE(1858),
    [sym_ieee64] = STATE(1858),
    [sym_bignum] = STATE(1858),
    [sym_decimal] = STATE(1858),
    [sym_float] = STATE(1552),
    [sym_block_comment] = STATE(1154),
    [sym_compiler_directive_decl] = STATE(1154),
    [sym_fsi_directive_decl] = STATE(1154),
    [sym_preproc_line] = STATE(1154),
    [sym_preproc_if_in_expression] = STATE(1715),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_do] = ACTIONS(383),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(385),
    [anon_sym_null] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_LBRACK_PIPE] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(3159),
    [anon_sym_LT_AT] = ACTIONS(397),
    [anon_sym_LT_AT_AT] = ACTIONS(3161),
    [anon_sym_LBRACE_PIPE] = ACTIONS(403),
    [anon_sym_new] = ACTIONS(381),
    [anon_sym_return_BANG] = ACTIONS(405),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_yield_BANG] = ACTIONS(405),
    [anon_sym_lazy] = ACTIONS(381),
    [anon_sym_assert] = ACTIONS(381),
    [anon_sym_upcast] = ACTIONS(381),
    [anon_sym_downcast] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(409),
    [anon_sym_while] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(413),
    [anon_sym_try] = ACTIONS(415),
    [anon_sym_match] = ACTIONS(417),
    [anon_sym_match_BANG] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(421),
    [anon_sym_use] = ACTIONS(429),
    [anon_sym_use_BANG] = ACTIONS(431),
    [anon_sym_do_BANG] = ACTIONS(433),
    [anon_sym_begin] = ACTIONS(435),
    [aux_sym_char_token1] = ACTIONS(439),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(443),
    [anon_sym_AT_DQUOTE] = ACTIONS(445),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(447),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(449),
    [sym_bool] = ACTIONS(451),
    [sym_unit] = ACTIONS(3163),
    [anon_sym_LPAREN_PIPE] = ACTIONS(455),
    [sym_op_identifier] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(459),
    [sym_xint] = ACTIONS(461),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(463),
  },
  [1155] = {
    [sym_function_or_value_defn] = STATE(1026),
    [sym__expression] = STATE(171),
    [sym_literal_expression] = STATE(1882),
    [sym_long_identifier_or_op] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_brace_expression] = STATE(1882),
    [sym_anon_record_expression] = STATE(1882),
    [sym_prefixed_expression] = STATE(1882),
    [sym_typecast_expression] = STATE(1882),
    [sym_for_expression] = STATE(1882),
    [sym_while_expression] = STATE(1882),
    [sym__if_branch] = STATE(10498),
    [sym_if_expression] = STATE(1882),
    [sym_fun_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_match_expression] = STATE(1882),
    [sym_function_expression] = STATE(1882),
    [sym_mutate_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_typed_expression] = STATE(1882),
    [sym_declaration_expression] = STATE(1882),
    [sym_do_expression] = STATE(1882),
    [sym_list_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_begin_end_expression] = STATE(1882),
    [sym_paren_expression] = STATE(1882),
    [sym__high_prec_app] = STATE(1872),
    [sym__low_prec_app] = STATE(1872),
    [sym_application_expression] = STATE(1882),
    [sym_dot_expression] = STATE(1882),
    [sym_infix_expression] = STATE(1882),
    [sym_ce_expression] = STATE(1882),
    [sym_sequential_expression] = STATE(1882),
    [sym_char] = STATE(1844),
    [sym_format_string] = STATE(1845),
    [sym__string_literal] = STATE(1845),
    [sym_string] = STATE(1844),
    [sym_verbatim_string] = STATE(1844),
    [sym_bytearray] = STATE(1844),
    [sym_verbatim_bytearray] = STATE(1844),
    [sym_format_triple_quoted_string] = STATE(1847),
    [sym_triple_quoted_string] = STATE(1844),
    [sym_const] = STATE(1882),
    [sym_long_identifier] = STATE(1704),
    [sym_active_pattern] = STATE(1718),
    [sym__identifier_or_op] = STATE(1703),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1113),
    [sym_sbyte] = STATE(1844),
    [sym_byte] = STATE(1844),
    [sym_int16] = STATE(1844),
    [sym_uint16] = STATE(1844),
    [sym_int32] = STATE(1844),
    [sym_uint32] = STATE(1844),
    [sym_nativeint] = STATE(1844),
    [sym_unativeint] = STATE(1844),
    [sym_int64] = STATE(1844),
    [sym_uint64] = STATE(1844),
    [sym_ieee32] = STATE(1844),
    [sym_ieee64] = STATE(1844),
    [sym_bignum] = STATE(1844),
    [sym_decimal] = STATE(1844),
    [sym_float] = STATE(2724),
    [sym_block_comment] = STATE(1155),
    [sym_compiler_directive_decl] = STATE(1155),
    [sym_fsi_directive_decl] = STATE(1155),
    [sym_preproc_line] = STATE(1155),
    [sym_preproc_if_in_expression] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(293),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_LBRACK_PIPE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_LT_AT] = ACTIONS(307),
    [anon_sym_LT_AT_AT] = ACTIONS(2360),
    [anon_sym_LBRACE_PIPE] = ACTIONS(313),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_return_BANG] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_yield_BANG] = ACTIONS(1095),
    [anon_sym_lazy] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_upcast] = ACTIONS(1091),
    [anon_sym_downcast] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(325),
    [anon_sym_match] = ACTIONS(327),
    [anon_sym_match_BANG] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_use] = ACTIONS(1099),
    [anon_sym_use_BANG] = ACTIONS(1101),
    [anon_sym_do_BANG] = ACTIONS(343),
    [anon_sym_begin] = ACTIONS(345),
    [aux_sym_char_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_AT_DQUOTE] = ACTIONS(355),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(357),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(359),
    [sym_bool] = ACTIONS(361),
    [sym_unit] = ACTIONS(2364),
    [anon_sym_LPAREN_PIPE] = ACTIONS(365),
    [sym_op_identifier] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1103),
    [sym_xint] = ACTIONS(1105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(373),
  },
  [1156] = {
    [sym_function_or_value_defn] = STATE(964),
    [sym__expression] = STATE(121),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(793),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(1156),
    [sym_compiler_directive_decl] = STATE(1156),
    [sym_fsi_directive_decl] = STATE(1156),
    [sym_preproc_line] = STATE(1156),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(29),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(53),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_return_BANG] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(29),
    [anon_sym_yield_BANG] = ACTIONS(57),
    [anon_sym_lazy] = ACTIONS(29),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_upcast] = ACTIONS(29),
    [anon_sym_downcast] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_use_BANG] = ACTIONS(77),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(99),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(111),
    [sym_xint] = ACTIONS(113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
  },
  [1157] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(82),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(946),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(1157),
    [sym_compiler_directive_decl] = STATE(1157),
    [sym_fsi_directive_decl] = STATE(1157),
    [sym_preproc_line] = STATE(1157),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(753),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1158] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(313),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1158),
    [sym_compiler_directive_decl] = STATE(1158),
    [sym_fsi_directive_decl] = STATE(1158),
    [sym_preproc_line] = STATE(1158),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1159] = {
    [sym_function_or_value_defn] = STATE(1163),
    [sym__expression] = STATE(38),
    [sym_literal_expression] = STATE(1715),
    [sym_long_identifier_or_op] = STATE(1715),
    [sym_tuple_expression] = STATE(1715),
    [sym_brace_expression] = STATE(1715),
    [sym_anon_record_expression] = STATE(1715),
    [sym_prefixed_expression] = STATE(1715),
    [sym_typecast_expression] = STATE(1715),
    [sym_for_expression] = STATE(1715),
    [sym_while_expression] = STATE(1715),
    [sym__if_branch] = STATE(10853),
    [sym_if_expression] = STATE(1715),
    [sym_fun_expression] = STATE(1715),
    [sym_try_expression] = STATE(1715),
    [sym_match_expression] = STATE(1715),
    [sym_function_expression] = STATE(1715),
    [sym_mutate_expression] = STATE(1715),
    [sym_index_expression] = STATE(1715),
    [sym_typed_expression] = STATE(1715),
    [sym_declaration_expression] = STATE(1715),
    [sym_do_expression] = STATE(1715),
    [sym_list_expression] = STATE(1715),
    [sym_array_expression] = STATE(1715),
    [sym_begin_end_expression] = STATE(1715),
    [sym_paren_expression] = STATE(1715),
    [sym__high_prec_app] = STATE(1728),
    [sym__low_prec_app] = STATE(1728),
    [sym_application_expression] = STATE(1715),
    [sym_dot_expression] = STATE(1715),
    [sym_infix_expression] = STATE(1715),
    [sym_ce_expression] = STATE(1715),
    [sym_sequential_expression] = STATE(1715),
    [sym_char] = STATE(1858),
    [sym_format_string] = STATE(1853),
    [sym__string_literal] = STATE(1853),
    [sym_string] = STATE(1858),
    [sym_verbatim_string] = STATE(1858),
    [sym_bytearray] = STATE(1858),
    [sym_verbatim_bytearray] = STATE(1858),
    [sym_format_triple_quoted_string] = STATE(1851),
    [sym_triple_quoted_string] = STATE(1858),
    [sym_const] = STATE(1715),
    [sym_long_identifier] = STATE(1825),
    [sym_active_pattern] = STATE(1754),
    [sym__identifier_or_op] = STATE(1822),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(940),
    [sym_sbyte] = STATE(1858),
    [sym_byte] = STATE(1858),
    [sym_int16] = STATE(1858),
    [sym_uint16] = STATE(1858),
    [sym_int32] = STATE(1858),
    [sym_uint32] = STATE(1858),
    [sym_nativeint] = STATE(1858),
    [sym_unativeint] = STATE(1858),
    [sym_int64] = STATE(1858),
    [sym_uint64] = STATE(1858),
    [sym_ieee32] = STATE(1858),
    [sym_ieee64] = STATE(1858),
    [sym_bignum] = STATE(1858),
    [sym_decimal] = STATE(1858),
    [sym_float] = STATE(1552),
    [sym_block_comment] = STATE(1159),
    [sym_compiler_directive_decl] = STATE(1159),
    [sym_fsi_directive_decl] = STATE(1159),
    [sym_preproc_line] = STATE(1159),
    [sym_preproc_if_in_expression] = STATE(1715),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_do] = ACTIONS(383),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(385),
    [anon_sym_null] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_LBRACK_PIPE] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(3159),
    [anon_sym_LT_AT] = ACTIONS(397),
    [anon_sym_LT_AT_AT] = ACTIONS(3161),
    [anon_sym_LBRACE_PIPE] = ACTIONS(403),
    [anon_sym_new] = ACTIONS(381),
    [anon_sym_return_BANG] = ACTIONS(405),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_yield_BANG] = ACTIONS(405),
    [anon_sym_lazy] = ACTIONS(381),
    [anon_sym_assert] = ACTIONS(381),
    [anon_sym_upcast] = ACTIONS(381),
    [anon_sym_downcast] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(409),
    [anon_sym_while] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(413),
    [anon_sym_try] = ACTIONS(415),
    [anon_sym_match] = ACTIONS(417),
    [anon_sym_match_BANG] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(421),
    [anon_sym_use] = ACTIONS(429),
    [anon_sym_use_BANG] = ACTIONS(431),
    [anon_sym_do_BANG] = ACTIONS(433),
    [anon_sym_begin] = ACTIONS(435),
    [aux_sym_char_token1] = ACTIONS(439),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(443),
    [anon_sym_AT_DQUOTE] = ACTIONS(445),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(447),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(449),
    [sym_bool] = ACTIONS(451),
    [sym_unit] = ACTIONS(3163),
    [anon_sym_LPAREN_PIPE] = ACTIONS(455),
    [sym_op_identifier] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(459),
    [sym_xint] = ACTIONS(461),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(463),
  },
  [1160] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(302),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1045),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(1160),
    [sym_compiler_directive_decl] = STATE(1160),
    [sym_fsi_directive_decl] = STATE(1160),
    [sym_preproc_line] = STATE(1160),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [1161] = {
    [sym_function_or_value_defn] = STATE(1163),
    [sym__expression] = STATE(41),
    [sym_literal_expression] = STATE(1715),
    [sym_long_identifier_or_op] = STATE(1715),
    [sym_tuple_expression] = STATE(1715),
    [sym_brace_expression] = STATE(1715),
    [sym_anon_record_expression] = STATE(1715),
    [sym_prefixed_expression] = STATE(1715),
    [sym_typecast_expression] = STATE(1715),
    [sym_for_expression] = STATE(1715),
    [sym_while_expression] = STATE(1715),
    [sym__if_branch] = STATE(10853),
    [sym_if_expression] = STATE(1715),
    [sym_fun_expression] = STATE(1715),
    [sym_try_expression] = STATE(1715),
    [sym_match_expression] = STATE(1715),
    [sym_function_expression] = STATE(1715),
    [sym_mutate_expression] = STATE(1715),
    [sym_index_expression] = STATE(1715),
    [sym_typed_expression] = STATE(1715),
    [sym_declaration_expression] = STATE(1715),
    [sym_do_expression] = STATE(1715),
    [sym_list_expression] = STATE(1715),
    [sym_array_expression] = STATE(1715),
    [sym_begin_end_expression] = STATE(1715),
    [sym_paren_expression] = STATE(1715),
    [sym__high_prec_app] = STATE(1728),
    [sym__low_prec_app] = STATE(1728),
    [sym_application_expression] = STATE(1715),
    [sym_dot_expression] = STATE(1715),
    [sym_infix_expression] = STATE(1715),
    [sym_ce_expression] = STATE(1715),
    [sym_sequential_expression] = STATE(1715),
    [sym_char] = STATE(1858),
    [sym_format_string] = STATE(1853),
    [sym__string_literal] = STATE(1853),
    [sym_string] = STATE(1858),
    [sym_verbatim_string] = STATE(1858),
    [sym_bytearray] = STATE(1858),
    [sym_verbatim_bytearray] = STATE(1858),
    [sym_format_triple_quoted_string] = STATE(1851),
    [sym_triple_quoted_string] = STATE(1858),
    [sym_const] = STATE(1715),
    [sym_long_identifier] = STATE(1825),
    [sym_active_pattern] = STATE(1754),
    [sym__identifier_or_op] = STATE(1822),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(940),
    [sym_sbyte] = STATE(1858),
    [sym_byte] = STATE(1858),
    [sym_int16] = STATE(1858),
    [sym_uint16] = STATE(1858),
    [sym_int32] = STATE(1858),
    [sym_uint32] = STATE(1858),
    [sym_nativeint] = STATE(1858),
    [sym_unativeint] = STATE(1858),
    [sym_int64] = STATE(1858),
    [sym_uint64] = STATE(1858),
    [sym_ieee32] = STATE(1858),
    [sym_ieee64] = STATE(1858),
    [sym_bignum] = STATE(1858),
    [sym_decimal] = STATE(1858),
    [sym_float] = STATE(1552),
    [sym_block_comment] = STATE(1161),
    [sym_compiler_directive_decl] = STATE(1161),
    [sym_fsi_directive_decl] = STATE(1161),
    [sym_preproc_line] = STATE(1161),
    [sym_preproc_if_in_expression] = STATE(1715),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_do] = ACTIONS(383),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(385),
    [anon_sym_null] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_LBRACK_PIPE] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(3159),
    [anon_sym_LT_AT] = ACTIONS(397),
    [anon_sym_LT_AT_AT] = ACTIONS(3161),
    [anon_sym_LBRACE_PIPE] = ACTIONS(403),
    [anon_sym_new] = ACTIONS(381),
    [anon_sym_return_BANG] = ACTIONS(405),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_yield_BANG] = ACTIONS(405),
    [anon_sym_lazy] = ACTIONS(381),
    [anon_sym_assert] = ACTIONS(381),
    [anon_sym_upcast] = ACTIONS(381),
    [anon_sym_downcast] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(409),
    [anon_sym_while] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(413),
    [anon_sym_try] = ACTIONS(415),
    [anon_sym_match] = ACTIONS(417),
    [anon_sym_match_BANG] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(421),
    [anon_sym_use] = ACTIONS(429),
    [anon_sym_use_BANG] = ACTIONS(431),
    [anon_sym_do_BANG] = ACTIONS(433),
    [anon_sym_begin] = ACTIONS(435),
    [aux_sym_char_token1] = ACTIONS(439),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(443),
    [anon_sym_AT_DQUOTE] = ACTIONS(445),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(447),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(449),
    [sym_bool] = ACTIONS(451),
    [sym_unit] = ACTIONS(3163),
    [anon_sym_LPAREN_PIPE] = ACTIONS(455),
    [sym_op_identifier] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(459),
    [sym_xint] = ACTIONS(461),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(463),
  },
  [1162] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(528),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(1162),
    [sym_compiler_directive_decl] = STATE(1162),
    [sym_fsi_directive_decl] = STATE(1162),
    [sym_preproc_line] = STATE(1162),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [1163] = {
    [sym_function_or_value_defn] = STATE(1163),
    [sym__expression] = STATE(43),
    [sym_literal_expression] = STATE(1715),
    [sym_long_identifier_or_op] = STATE(1715),
    [sym_tuple_expression] = STATE(1715),
    [sym_brace_expression] = STATE(1715),
    [sym_anon_record_expression] = STATE(1715),
    [sym_prefixed_expression] = STATE(1715),
    [sym_typecast_expression] = STATE(1715),
    [sym_for_expression] = STATE(1715),
    [sym_while_expression] = STATE(1715),
    [sym__if_branch] = STATE(10853),
    [sym_if_expression] = STATE(1715),
    [sym_fun_expression] = STATE(1715),
    [sym_try_expression] = STATE(1715),
    [sym_match_expression] = STATE(1715),
    [sym_function_expression] = STATE(1715),
    [sym_mutate_expression] = STATE(1715),
    [sym_index_expression] = STATE(1715),
    [sym_typed_expression] = STATE(1715),
    [sym_declaration_expression] = STATE(1715),
    [sym_do_expression] = STATE(1715),
    [sym_list_expression] = STATE(1715),
    [sym_array_expression] = STATE(1715),
    [sym_begin_end_expression] = STATE(1715),
    [sym_paren_expression] = STATE(1715),
    [sym__high_prec_app] = STATE(1728),
    [sym__low_prec_app] = STATE(1728),
    [sym_application_expression] = STATE(1715),
    [sym_dot_expression] = STATE(1715),
    [sym_infix_expression] = STATE(1715),
    [sym_ce_expression] = STATE(1715),
    [sym_sequential_expression] = STATE(1715),
    [sym_char] = STATE(1858),
    [sym_format_string] = STATE(1853),
    [sym__string_literal] = STATE(1853),
    [sym_string] = STATE(1858),
    [sym_verbatim_string] = STATE(1858),
    [sym_bytearray] = STATE(1858),
    [sym_verbatim_bytearray] = STATE(1858),
    [sym_format_triple_quoted_string] = STATE(1851),
    [sym_triple_quoted_string] = STATE(1858),
    [sym_const] = STATE(1715),
    [sym_long_identifier] = STATE(1825),
    [sym_active_pattern] = STATE(1754),
    [sym__identifier_or_op] = STATE(1822),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(940),
    [sym_sbyte] = STATE(1858),
    [sym_byte] = STATE(1858),
    [sym_int16] = STATE(1858),
    [sym_uint16] = STATE(1858),
    [sym_int32] = STATE(1858),
    [sym_uint32] = STATE(1858),
    [sym_nativeint] = STATE(1858),
    [sym_unativeint] = STATE(1858),
    [sym_int64] = STATE(1858),
    [sym_uint64] = STATE(1858),
    [sym_ieee32] = STATE(1858),
    [sym_ieee64] = STATE(1858),
    [sym_bignum] = STATE(1858),
    [sym_decimal] = STATE(1858),
    [sym_float] = STATE(1552),
    [sym_block_comment] = STATE(1163),
    [sym_compiler_directive_decl] = STATE(1163),
    [sym_fsi_directive_decl] = STATE(1163),
    [sym_preproc_line] = STATE(1163),
    [sym_preproc_if_in_expression] = STATE(1715),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_do] = ACTIONS(383),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(385),
    [anon_sym_null] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_LBRACK_PIPE] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(3159),
    [anon_sym_LT_AT] = ACTIONS(397),
    [anon_sym_LT_AT_AT] = ACTIONS(3161),
    [anon_sym_LBRACE_PIPE] = ACTIONS(403),
    [anon_sym_new] = ACTIONS(381),
    [anon_sym_return_BANG] = ACTIONS(405),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_yield_BANG] = ACTIONS(405),
    [anon_sym_lazy] = ACTIONS(381),
    [anon_sym_assert] = ACTIONS(381),
    [anon_sym_upcast] = ACTIONS(381),
    [anon_sym_downcast] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(409),
    [anon_sym_while] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(413),
    [anon_sym_try] = ACTIONS(415),
    [anon_sym_match] = ACTIONS(417),
    [anon_sym_match_BANG] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(421),
    [anon_sym_use] = ACTIONS(429),
    [anon_sym_use_BANG] = ACTIONS(431),
    [anon_sym_do_BANG] = ACTIONS(433),
    [anon_sym_begin] = ACTIONS(435),
    [aux_sym_char_token1] = ACTIONS(439),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(443),
    [anon_sym_AT_DQUOTE] = ACTIONS(445),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(447),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(449),
    [sym_bool] = ACTIONS(451),
    [sym_unit] = ACTIONS(3163),
    [anon_sym_LPAREN_PIPE] = ACTIONS(455),
    [sym_op_identifier] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(459),
    [sym_xint] = ACTIONS(461),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(463),
  },
  [1164] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(94),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(946),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(1164),
    [sym_compiler_directive_decl] = STATE(1164),
    [sym_fsi_directive_decl] = STATE(1164),
    [sym_preproc_line] = STATE(1164),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(753),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1165] = {
    [sym_function_or_value_defn] = STATE(1056),
    [sym__expression] = STATE(95),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(946),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(1893),
    [sym_block_comment] = STATE(1165),
    [sym_compiler_directive_decl] = STATE(1165),
    [sym_fsi_directive_decl] = STATE(1165),
    [sym_preproc_line] = STATE(1165),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(753),
    [anon_sym_return_BANG] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_yield_BANG] = ACTIONS(777),
    [anon_sym_lazy] = ACTIONS(753),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_upcast] = ACTIONS(753),
    [anon_sym_downcast] = ACTIONS(753),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_use_BANG] = ACTIONS(803),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(831),
    [sym_xint] = ACTIONS(833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1166] = {
    [sym_function_or_value_defn] = STATE(1166),
    [sym__expression] = STATE(136),
    [sym_literal_expression] = STATE(2884),
    [sym_long_identifier_or_op] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_brace_expression] = STATE(2884),
    [sym_anon_record_expression] = STATE(2884),
    [sym_prefixed_expression] = STATE(2884),
    [sym_typecast_expression] = STATE(2884),
    [sym_for_expression] = STATE(2884),
    [sym_while_expression] = STATE(2884),
    [sym__if_branch] = STATE(10729),
    [sym_if_expression] = STATE(2884),
    [sym_fun_expression] = STATE(2884),
    [sym_try_expression] = STATE(2884),
    [sym_match_expression] = STATE(2884),
    [sym_function_expression] = STATE(2884),
    [sym_mutate_expression] = STATE(2884),
    [sym_index_expression] = STATE(2884),
    [sym_typed_expression] = STATE(2884),
    [sym_declaration_expression] = STATE(2884),
    [sym_do_expression] = STATE(2884),
    [sym_list_expression] = STATE(2884),
    [sym_array_expression] = STATE(2884),
    [sym_begin_end_expression] = STATE(2884),
    [sym_paren_expression] = STATE(2884),
    [sym__high_prec_app] = STATE(2872),
    [sym__low_prec_app] = STATE(2872),
    [sym_application_expression] = STATE(2884),
    [sym_dot_expression] = STATE(2884),
    [sym_infix_expression] = STATE(2884),
    [sym_ce_expression] = STATE(2884),
    [sym_sequential_expression] = STATE(2884),
    [sym_char] = STATE(2955),
    [sym_format_string] = STATE(2951),
    [sym__string_literal] = STATE(2951),
    [sym_string] = STATE(2955),
    [sym_verbatim_string] = STATE(2955),
    [sym_bytearray] = STATE(2955),
    [sym_verbatim_bytearray] = STATE(2955),
    [sym_format_triple_quoted_string] = STATE(2949),
    [sym_triple_quoted_string] = STATE(2955),
    [sym_const] = STATE(2884),
    [sym_long_identifier] = STATE(2885),
    [sym_active_pattern] = STATE(2833),
    [sym__identifier_or_op] = STATE(2883),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1002),
    [sym_sbyte] = STATE(2955),
    [sym_byte] = STATE(2955),
    [sym_int16] = STATE(2955),
    [sym_uint16] = STATE(2955),
    [sym_int32] = STATE(2955),
    [sym_uint32] = STATE(2955),
    [sym_nativeint] = STATE(2955),
    [sym_unativeint] = STATE(2955),
    [sym_int64] = STATE(2955),
    [sym_uint64] = STATE(2955),
    [sym_ieee32] = STATE(2955),
    [sym_ieee64] = STATE(2955),
    [sym_bignum] = STATE(2955),
    [sym_decimal] = STATE(2955),
    [sym_float] = STATE(2652),
    [sym_block_comment] = STATE(1166),
    [sym_compiler_directive_decl] = STATE(1166),
    [sym_fsi_directive_decl] = STATE(1166),
    [sym_preproc_line] = STATE(1166),
    [sym_preproc_if_in_expression] = STATE(2884),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_do] = ACTIONS(1003),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_null] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1013),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1015),
    [anon_sym_LBRACE] = ACTIONS(3181),
    [anon_sym_LT_AT] = ACTIONS(1019),
    [anon_sym_LT_AT_AT] = ACTIONS(3183),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1025),
    [anon_sym_new] = ACTIONS(1001),
    [anon_sym_return_BANG] = ACTIONS(1029),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_yield_BANG] = ACTIONS(1029),
    [anon_sym_lazy] = ACTIONS(1001),
    [anon_sym_assert] = ACTIONS(1001),
    [anon_sym_upcast] = ACTIONS(1001),
    [anon_sym_downcast] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1033),
    [anon_sym_while] = ACTIONS(1035),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1037),
    [anon_sym_try] = ACTIONS(1039),
    [anon_sym_match] = ACTIONS(1041),
    [anon_sym_match_BANG] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(1045),
    [anon_sym_use] = ACTIONS(1053),
    [anon_sym_use_BANG] = ACTIONS(1055),
    [anon_sym_do_BANG] = ACTIONS(1057),
    [anon_sym_begin] = ACTIONS(1059),
    [aux_sym_char_token1] = ACTIONS(1063),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1067),
    [anon_sym_AT_DQUOTE] = ACTIONS(1069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1073),
    [sym_bool] = ACTIONS(1075),
    [sym_unit] = ACTIONS(3185),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1079),
    [sym_op_identifier] = ACTIONS(3187),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1083),
    [sym_xint] = ACTIONS(1085),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1087),
  },
  [1167] = {
    [sym_function_or_value_defn] = STATE(1166),
    [sym__expression] = STATE(130),
    [sym_literal_expression] = STATE(2884),
    [sym_long_identifier_or_op] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_brace_expression] = STATE(2884),
    [sym_anon_record_expression] = STATE(2884),
    [sym_prefixed_expression] = STATE(2884),
    [sym_typecast_expression] = STATE(2884),
    [sym_for_expression] = STATE(2884),
    [sym_while_expression] = STATE(2884),
    [sym__if_branch] = STATE(10729),
    [sym_if_expression] = STATE(2884),
    [sym_fun_expression] = STATE(2884),
    [sym_try_expression] = STATE(2884),
    [sym_match_expression] = STATE(2884),
    [sym_function_expression] = STATE(2884),
    [sym_mutate_expression] = STATE(2884),
    [sym_index_expression] = STATE(2884),
    [sym_typed_expression] = STATE(2884),
    [sym_declaration_expression] = STATE(2884),
    [sym_do_expression] = STATE(2884),
    [sym_list_expression] = STATE(2884),
    [sym_array_expression] = STATE(2884),
    [sym_begin_end_expression] = STATE(2884),
    [sym_paren_expression] = STATE(2884),
    [sym__high_prec_app] = STATE(2872),
    [sym__low_prec_app] = STATE(2872),
    [sym_application_expression] = STATE(2884),
    [sym_dot_expression] = STATE(2884),
    [sym_infix_expression] = STATE(2884),
    [sym_ce_expression] = STATE(2884),
    [sym_sequential_expression] = STATE(2884),
    [sym_char] = STATE(2955),
    [sym_format_string] = STATE(2951),
    [sym__string_literal] = STATE(2951),
    [sym_string] = STATE(2955),
    [sym_verbatim_string] = STATE(2955),
    [sym_bytearray] = STATE(2955),
    [sym_verbatim_bytearray] = STATE(2955),
    [sym_format_triple_quoted_string] = STATE(2949),
    [sym_triple_quoted_string] = STATE(2955),
    [sym_const] = STATE(2884),
    [sym_long_identifier] = STATE(2885),
    [sym_active_pattern] = STATE(2833),
    [sym__identifier_or_op] = STATE(2883),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1002),
    [sym_sbyte] = STATE(2955),
    [sym_byte] = STATE(2955),
    [sym_int16] = STATE(2955),
    [sym_uint16] = STATE(2955),
    [sym_int32] = STATE(2955),
    [sym_uint32] = STATE(2955),
    [sym_nativeint] = STATE(2955),
    [sym_unativeint] = STATE(2955),
    [sym_int64] = STATE(2955),
    [sym_uint64] = STATE(2955),
    [sym_ieee32] = STATE(2955),
    [sym_ieee64] = STATE(2955),
    [sym_bignum] = STATE(2955),
    [sym_decimal] = STATE(2955),
    [sym_float] = STATE(2652),
    [sym_block_comment] = STATE(1167),
    [sym_compiler_directive_decl] = STATE(1167),
    [sym_fsi_directive_decl] = STATE(1167),
    [sym_preproc_line] = STATE(1167),
    [sym_preproc_if_in_expression] = STATE(2884),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_do] = ACTIONS(1003),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_null] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1013),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1015),
    [anon_sym_LBRACE] = ACTIONS(3181),
    [anon_sym_LT_AT] = ACTIONS(1019),
    [anon_sym_LT_AT_AT] = ACTIONS(3183),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1025),
    [anon_sym_new] = ACTIONS(1001),
    [anon_sym_return_BANG] = ACTIONS(1029),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_yield_BANG] = ACTIONS(1029),
    [anon_sym_lazy] = ACTIONS(1001),
    [anon_sym_assert] = ACTIONS(1001),
    [anon_sym_upcast] = ACTIONS(1001),
    [anon_sym_downcast] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1033),
    [anon_sym_while] = ACTIONS(1035),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1037),
    [anon_sym_try] = ACTIONS(1039),
    [anon_sym_match] = ACTIONS(1041),
    [anon_sym_match_BANG] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(1045),
    [anon_sym_use] = ACTIONS(1053),
    [anon_sym_use_BANG] = ACTIONS(1055),
    [anon_sym_do_BANG] = ACTIONS(1057),
    [anon_sym_begin] = ACTIONS(1059),
    [aux_sym_char_token1] = ACTIONS(1063),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1067),
    [anon_sym_AT_DQUOTE] = ACTIONS(1069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1073),
    [sym_bool] = ACTIONS(1075),
    [sym_unit] = ACTIONS(3185),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1079),
    [sym_op_identifier] = ACTIONS(3187),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1083),
    [sym_xint] = ACTIONS(1085),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1087),
  },
  [1168] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(392),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1168),
    [sym_compiler_directive_decl] = STATE(1168),
    [sym_fsi_directive_decl] = STATE(1168),
    [sym_preproc_line] = STATE(1168),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1169] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(533),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(1169),
    [sym_compiler_directive_decl] = STATE(1169),
    [sym_fsi_directive_decl] = STATE(1169),
    [sym_preproc_line] = STATE(1169),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [1170] = {
    [sym_function_or_value_defn] = STATE(837),
    [sym__expression] = STATE(311),
    [sym_literal_expression] = STATE(2162),
    [sym_long_identifier_or_op] = STATE(2162),
    [sym_tuple_expression] = STATE(2162),
    [sym_brace_expression] = STATE(2162),
    [sym_anon_record_expression] = STATE(2162),
    [sym_prefixed_expression] = STATE(2162),
    [sym_typecast_expression] = STATE(2162),
    [sym_for_expression] = STATE(2162),
    [sym_while_expression] = STATE(2162),
    [sym__if_branch] = STATE(10290),
    [sym_if_expression] = STATE(2162),
    [sym_fun_expression] = STATE(2162),
    [sym_try_expression] = STATE(2162),
    [sym_match_expression] = STATE(2162),
    [sym_function_expression] = STATE(2162),
    [sym_mutate_expression] = STATE(2162),
    [sym_index_expression] = STATE(2162),
    [sym_typed_expression] = STATE(2162),
    [sym_declaration_expression] = STATE(2162),
    [sym_do_expression] = STATE(2162),
    [sym_list_expression] = STATE(2162),
    [sym_array_expression] = STATE(2162),
    [sym_begin_end_expression] = STATE(2162),
    [sym_paren_expression] = STATE(2162),
    [sym__high_prec_app] = STATE(2171),
    [sym__low_prec_app] = STATE(2171),
    [sym_application_expression] = STATE(2162),
    [sym_dot_expression] = STATE(2162),
    [sym_infix_expression] = STATE(2162),
    [sym_ce_expression] = STATE(2162),
    [sym_sequential_expression] = STATE(2162),
    [sym_char] = STATE(1930),
    [sym_format_string] = STATE(1936),
    [sym__string_literal] = STATE(1936),
    [sym_string] = STATE(1930),
    [sym_verbatim_string] = STATE(1930),
    [sym_bytearray] = STATE(1930),
    [sym_verbatim_bytearray] = STATE(1930),
    [sym_format_triple_quoted_string] = STATE(1937),
    [sym_triple_quoted_string] = STATE(1930),
    [sym_const] = STATE(2162),
    [sym_long_identifier] = STATE(1940),
    [sym_active_pattern] = STATE(1932),
    [sym__identifier_or_op] = STATE(1899),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(856),
    [sym_sbyte] = STATE(1930),
    [sym_byte] = STATE(1930),
    [sym_int16] = STATE(1930),
    [sym_uint16] = STATE(1930),
    [sym_int32] = STATE(1930),
    [sym_uint32] = STATE(1930),
    [sym_nativeint] = STATE(1930),
    [sym_unativeint] = STATE(1930),
    [sym_int64] = STATE(1930),
    [sym_uint64] = STATE(1930),
    [sym_ieee32] = STATE(1930),
    [sym_ieee64] = STATE(1930),
    [sym_bignum] = STATE(1930),
    [sym_decimal] = STATE(1930),
    [sym_float] = STATE(2673),
    [sym_block_comment] = STATE(1170),
    [sym_compiler_directive_decl] = STATE(1170),
    [sym_fsi_directive_decl] = STATE(1170),
    [sym_preproc_line] = STATE(1170),
    [sym_preproc_if_in_expression] = STATE(2162),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_null] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LT_AT] = ACTIONS(769),
    [anon_sym_LT_AT_AT] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_return_BANG] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1268),
    [anon_sym_yield_BANG] = ACTIONS(1272),
    [anon_sym_lazy] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_upcast] = ACTIONS(1268),
    [anon_sym_downcast] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_match_BANG] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_use_BANG] = ACTIONS(1278),
    [anon_sym_do_BANG] = ACTIONS(805),
    [anon_sym_begin] = ACTIONS(807),
    [aux_sym_char_token1] = ACTIONS(811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_AT_DQUOTE] = ACTIONS(817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(821),
    [sym_bool] = ACTIONS(823),
    [sym_unit] = ACTIONS(2616),
    [anon_sym_LPAREN_PIPE] = ACTIONS(827),
    [sym_op_identifier] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1280),
    [sym_xint] = ACTIONS(1221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(835),
  },
  [1171] = {
    [sym_function_or_value_defn] = STATE(1166),
    [sym__expression] = STATE(139),
    [sym_literal_expression] = STATE(2884),
    [sym_long_identifier_or_op] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_brace_expression] = STATE(2884),
    [sym_anon_record_expression] = STATE(2884),
    [sym_prefixed_expression] = STATE(2884),
    [sym_typecast_expression] = STATE(2884),
    [sym_for_expression] = STATE(2884),
    [sym_while_expression] = STATE(2884),
    [sym__if_branch] = STATE(10729),
    [sym_if_expression] = STATE(2884),
    [sym_fun_expression] = STATE(2884),
    [sym_try_expression] = STATE(2884),
    [sym_match_expression] = STATE(2884),
    [sym_function_expression] = STATE(2884),
    [sym_mutate_expression] = STATE(2884),
    [sym_index_expression] = STATE(2884),
    [sym_typed_expression] = STATE(2884),
    [sym_declaration_expression] = STATE(2884),
    [sym_do_expression] = STATE(2884),
    [sym_list_expression] = STATE(2884),
    [sym_array_expression] = STATE(2884),
    [sym_begin_end_expression] = STATE(2884),
    [sym_paren_expression] = STATE(2884),
    [sym__high_prec_app] = STATE(2872),
    [sym__low_prec_app] = STATE(2872),
    [sym_application_expression] = STATE(2884),
    [sym_dot_expression] = STATE(2884),
    [sym_infix_expression] = STATE(2884),
    [sym_ce_expression] = STATE(2884),
    [sym_sequential_expression] = STATE(2884),
    [sym_char] = STATE(2955),
    [sym_format_string] = STATE(2951),
    [sym__string_literal] = STATE(2951),
    [sym_string] = STATE(2955),
    [sym_verbatim_string] = STATE(2955),
    [sym_bytearray] = STATE(2955),
    [sym_verbatim_bytearray] = STATE(2955),
    [sym_format_triple_quoted_string] = STATE(2949),
    [sym_triple_quoted_string] = STATE(2955),
    [sym_const] = STATE(2884),
    [sym_long_identifier] = STATE(2885),
    [sym_active_pattern] = STATE(2833),
    [sym__identifier_or_op] = STATE(2883),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1002),
    [sym_sbyte] = STATE(2955),
    [sym_byte] = STATE(2955),
    [sym_int16] = STATE(2955),
    [sym_uint16] = STATE(2955),
    [sym_int32] = STATE(2955),
    [sym_uint32] = STATE(2955),
    [sym_nativeint] = STATE(2955),
    [sym_unativeint] = STATE(2955),
    [sym_int64] = STATE(2955),
    [sym_uint64] = STATE(2955),
    [sym_ieee32] = STATE(2955),
    [sym_ieee64] = STATE(2955),
    [sym_bignum] = STATE(2955),
    [sym_decimal] = STATE(2955),
    [sym_float] = STATE(2652),
    [sym_block_comment] = STATE(1171),
    [sym_compiler_directive_decl] = STATE(1171),
    [sym_fsi_directive_decl] = STATE(1171),
    [sym_preproc_line] = STATE(1171),
    [sym_preproc_if_in_expression] = STATE(2884),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_do] = ACTIONS(1003),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_null] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1013),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1015),
    [anon_sym_LBRACE] = ACTIONS(3181),
    [anon_sym_LT_AT] = ACTIONS(1019),
    [anon_sym_LT_AT_AT] = ACTIONS(3183),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1025),
    [anon_sym_new] = ACTIONS(1001),
    [anon_sym_return_BANG] = ACTIONS(1029),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_yield_BANG] = ACTIONS(1029),
    [anon_sym_lazy] = ACTIONS(1001),
    [anon_sym_assert] = ACTIONS(1001),
    [anon_sym_upcast] = ACTIONS(1001),
    [anon_sym_downcast] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1033),
    [anon_sym_while] = ACTIONS(1035),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1037),
    [anon_sym_try] = ACTIONS(1039),
    [anon_sym_match] = ACTIONS(1041),
    [anon_sym_match_BANG] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(1045),
    [anon_sym_use] = ACTIONS(1053),
    [anon_sym_use_BANG] = ACTIONS(1055),
    [anon_sym_do_BANG] = ACTIONS(1057),
    [anon_sym_begin] = ACTIONS(1059),
    [aux_sym_char_token1] = ACTIONS(1063),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1067),
    [anon_sym_AT_DQUOTE] = ACTIONS(1069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1073),
    [sym_bool] = ACTIONS(1075),
    [sym_unit] = ACTIONS(3185),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1079),
    [sym_op_identifier] = ACTIONS(3187),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1083),
    [sym_xint] = ACTIONS(1085),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1087),
  },
  [1172] = {
    [sym_function_or_value_defn] = STATE(1166),
    [sym__expression] = STATE(126),
    [sym_literal_expression] = STATE(2884),
    [sym_long_identifier_or_op] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_brace_expression] = STATE(2884),
    [sym_anon_record_expression] = STATE(2884),
    [sym_prefixed_expression] = STATE(2884),
    [sym_typecast_expression] = STATE(2884),
    [sym_for_expression] = STATE(2884),
    [sym_while_expression] = STATE(2884),
    [sym__if_branch] = STATE(10729),
    [sym_if_expression] = STATE(2884),
    [sym_fun_expression] = STATE(2884),
    [sym_try_expression] = STATE(2884),
    [sym_match_expression] = STATE(2884),
    [sym_function_expression] = STATE(2884),
    [sym_mutate_expression] = STATE(2884),
    [sym_index_expression] = STATE(2884),
    [sym_typed_expression] = STATE(2884),
    [sym_declaration_expression] = STATE(2884),
    [sym_do_expression] = STATE(2884),
    [sym_list_expression] = STATE(2884),
    [sym_array_expression] = STATE(2884),
    [sym_begin_end_expression] = STATE(2884),
    [sym_paren_expression] = STATE(2884),
    [sym__high_prec_app] = STATE(2872),
    [sym__low_prec_app] = STATE(2872),
    [sym_application_expression] = STATE(2884),
    [sym_dot_expression] = STATE(2884),
    [sym_infix_expression] = STATE(2884),
    [sym_ce_expression] = STATE(2884),
    [sym_sequential_expression] = STATE(2884),
    [sym_char] = STATE(2955),
    [sym_format_string] = STATE(2951),
    [sym__string_literal] = STATE(2951),
    [sym_string] = STATE(2955),
    [sym_verbatim_string] = STATE(2955),
    [sym_bytearray] = STATE(2955),
    [sym_verbatim_bytearray] = STATE(2955),
    [sym_format_triple_quoted_string] = STATE(2949),
    [sym_triple_quoted_string] = STATE(2955),
    [sym_const] = STATE(2884),
    [sym_long_identifier] = STATE(2885),
    [sym_active_pattern] = STATE(2833),
    [sym__identifier_or_op] = STATE(2883),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1002),
    [sym_sbyte] = STATE(2955),
    [sym_byte] = STATE(2955),
    [sym_int16] = STATE(2955),
    [sym_uint16] = STATE(2955),
    [sym_int32] = STATE(2955),
    [sym_uint32] = STATE(2955),
    [sym_nativeint] = STATE(2955),
    [sym_unativeint] = STATE(2955),
    [sym_int64] = STATE(2955),
    [sym_uint64] = STATE(2955),
    [sym_ieee32] = STATE(2955),
    [sym_ieee64] = STATE(2955),
    [sym_bignum] = STATE(2955),
    [sym_decimal] = STATE(2955),
    [sym_float] = STATE(2652),
    [sym_block_comment] = STATE(1172),
    [sym_compiler_directive_decl] = STATE(1172),
    [sym_fsi_directive_decl] = STATE(1172),
    [sym_preproc_line] = STATE(1172),
    [sym_preproc_if_in_expression] = STATE(2884),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_do] = ACTIONS(1003),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_null] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1013),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1015),
    [anon_sym_LBRACE] = ACTIONS(3181),
    [anon_sym_LT_AT] = ACTIONS(1019),
    [anon_sym_LT_AT_AT] = ACTIONS(3183),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1025),
    [anon_sym_new] = ACTIONS(1001),
    [anon_sym_return_BANG] = ACTIONS(1029),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_yield_BANG] = ACTIONS(1029),
    [anon_sym_lazy] = ACTIONS(1001),
    [anon_sym_assert] = ACTIONS(1001),
    [anon_sym_upcast] = ACTIONS(1001),
    [anon_sym_downcast] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1033),
    [anon_sym_while] = ACTIONS(1035),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1037),
    [anon_sym_try] = ACTIONS(1039),
    [anon_sym_match] = ACTIONS(1041),
    [anon_sym_match_BANG] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(1045),
    [anon_sym_use] = ACTIONS(1053),
    [anon_sym_use_BANG] = ACTIONS(1055),
    [anon_sym_do_BANG] = ACTIONS(1057),
    [anon_sym_begin] = ACTIONS(1059),
    [aux_sym_char_token1] = ACTIONS(1063),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1067),
    [anon_sym_AT_DQUOTE] = ACTIONS(1069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1073),
    [sym_bool] = ACTIONS(1075),
    [sym_unit] = ACTIONS(3185),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1079),
    [sym_op_identifier] = ACTIONS(3187),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1083),
    [sym_xint] = ACTIONS(1085),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1087),
  },
  [1173] = {
    [sym_function_or_value_defn] = STATE(878),
    [sym__expression] = STATE(325),
    [sym_literal_expression] = STATE(3165),
    [sym_long_identifier_or_op] = STATE(3165),
    [sym_tuple_expression] = STATE(3165),
    [sym_brace_expression] = STATE(3165),
    [sym_anon_record_expression] = STATE(3165),
    [sym_prefixed_expression] = STATE(3165),
    [sym_typecast_expression] = STATE(3165),
    [sym_for_expression] = STATE(3165),
    [sym_while_expression] = STATE(3165),
    [sym__if_branch] = STATE(10627),
    [sym_if_expression] = STATE(3165),
    [sym_fun_expression] = STATE(3165),
    [sym_try_expression] = STATE(3165),
    [sym_match_expression] = STATE(3165),
    [sym_function_expression] = STATE(3165),
    [sym_mutate_expression] = STATE(3165),
    [sym_index_expression] = STATE(3165),
    [sym_typed_expression] = STATE(3165),
    [sym_declaration_expression] = STATE(3165),
    [sym_do_expression] = STATE(3165),
    [sym_list_expression] = STATE(3165),
    [sym_array_expression] = STATE(3165),
    [sym_begin_end_expression] = STATE(3165),
    [sym_paren_expression] = STATE(3165),
    [sym__high_prec_app] = STATE(3161),
    [sym__low_prec_app] = STATE(3161),
    [sym_application_expression] = STATE(3165),
    [sym_dot_expression] = STATE(3165),
    [sym_infix_expression] = STATE(3165),
    [sym_ce_expression] = STATE(3165),
    [sym_sequential_expression] = STATE(3165),
    [sym_char] = STATE(3105),
    [sym_format_string] = STATE(3101),
    [sym__string_literal] = STATE(3101),
    [sym_string] = STATE(3105),
    [sym_verbatim_string] = STATE(3105),
    [sym_bytearray] = STATE(3105),
    [sym_verbatim_bytearray] = STATE(3105),
    [sym_format_triple_quoted_string] = STATE(3100),
    [sym_triple_quoted_string] = STATE(3105),
    [sym_const] = STATE(3165),
    [sym_long_identifier] = STATE(3187),
    [sym_active_pattern] = STATE(3034),
    [sym__identifier_or_op] = STATE(3186),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1045),
    [sym_sbyte] = STATE(3105),
    [sym_byte] = STATE(3105),
    [sym_int16] = STATE(3105),
    [sym_uint16] = STATE(3105),
    [sym_int32] = STATE(3105),
    [sym_uint32] = STATE(3105),
    [sym_nativeint] = STATE(3105),
    [sym_unativeint] = STATE(3105),
    [sym_int64] = STATE(3105),
    [sym_uint64] = STATE(3105),
    [sym_ieee32] = STATE(3105),
    [sym_ieee64] = STATE(3105),
    [sym_bignum] = STATE(3105),
    [sym_decimal] = STATE(3105),
    [sym_float] = STATE(2730),
    [sym_block_comment] = STATE(1173),
    [sym_compiler_directive_decl] = STATE(1173),
    [sym_fsi_directive_decl] = STATE(1173),
    [sym_preproc_line] = STATE(1173),
    [sym_preproc_if_in_expression] = STATE(3165),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1602),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(1318),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1602),
    [anon_sym_return_BANG] = ACTIONS(1606),
    [anon_sym_yield] = ACTIONS(1602),
    [anon_sym_yield_BANG] = ACTIONS(1606),
    [anon_sym_lazy] = ACTIONS(1602),
    [anon_sym_assert] = ACTIONS(1602),
    [anon_sym_upcast] = ACTIONS(1602),
    [anon_sym_downcast] = ACTIONS(1602),
    [anon_sym_for] = ACTIONS(1610),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1334),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_match_BANG] = ACTIONS(1342),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_use] = ACTIONS(1616),
    [anon_sym_use_BANG] = ACTIONS(1618),
    [anon_sym_do_BANG] = ACTIONS(1356),
    [anon_sym_begin] = ACTIONS(1360),
    [aux_sym_char_token1] = ACTIONS(1364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [anon_sym_AT_DQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1374),
    [sym_bool] = ACTIONS(1376),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1380),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1620),
    [sym_xint] = ACTIONS(1386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1388),
  },
  [1174] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(354),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(890),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(1174),
    [sym_compiler_directive_decl] = STATE(1174),
    [sym_fsi_directive_decl] = STATE(1174),
    [sym_preproc_line] = STATE(1174),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
  },
  [1175] = {
    [sym_function_or_value_defn] = STATE(1033),
    [sym__expression] = STATE(289),
    [sym_literal_expression] = STATE(3455),
    [sym_long_identifier_or_op] = STATE(3455),
    [sym_tuple_expression] = STATE(3455),
    [sym_brace_expression] = STATE(3455),
    [sym_anon_record_expression] = STATE(3455),
    [sym_prefixed_expression] = STATE(3455),
    [sym_typecast_expression] = STATE(3455),
    [sym_for_expression] = STATE(3455),
    [sym_while_expression] = STATE(3455),
    [sym__if_branch] = STATE(10429),
    [sym_if_expression] = STATE(3455),
    [sym_fun_expression] = STATE(3455),
    [sym_try_expression] = STATE(3455),
    [sym_match_expression] = STATE(3455),
    [sym_function_expression] = STATE(3455),
    [sym_mutate_expression] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_typed_expression] = STATE(3455),
    [sym_declaration_expression] = STATE(3455),
    [sym_do_expression] = STATE(3455),
    [sym_list_expression] = STATE(3455),
    [sym_array_expression] = STATE(3455),
    [sym_begin_end_expression] = STATE(3455),
    [sym_paren_expression] = STATE(3455),
    [sym__high_prec_app] = STATE(3450),
    [sym__low_prec_app] = STATE(3450),
    [sym_application_expression] = STATE(3455),
    [sym_dot_expression] = STATE(3455),
    [sym_infix_expression] = STATE(3455),
    [sym_ce_expression] = STATE(3455),
    [sym_sequential_expression] = STATE(3455),
    [sym_char] = STATE(3351),
    [sym_format_string] = STATE(3350),
    [sym__string_literal] = STATE(3350),
    [sym_string] = STATE(3351),
    [sym_verbatim_string] = STATE(3351),
    [sym_bytearray] = STATE(3351),
    [sym_verbatim_bytearray] = STATE(3351),
    [sym_format_triple_quoted_string] = STATE(3357),
    [sym_triple_quoted_string] = STATE(3351),
    [sym_const] = STATE(3455),
    [sym_long_identifier] = STATE(3534),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3530),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1151),
    [sym_sbyte] = STATE(3351),
    [sym_byte] = STATE(3351),
    [sym_int16] = STATE(3351),
    [sym_uint16] = STATE(3351),
    [sym_int32] = STATE(3351),
    [sym_uint32] = STATE(3351),
    [sym_nativeint] = STATE(3351),
    [sym_unativeint] = STATE(3351),
    [sym_int64] = STATE(3351),
    [sym_uint64] = STATE(3351),
    [sym_ieee32] = STATE(3351),
    [sym_ieee64] = STATE(3351),
    [sym_bignum] = STATE(3351),
    [sym_decimal] = STATE(3351),
    [sym_float] = STATE(2791),
    [sym_block_comment] = STATE(1175),
    [sym_compiler_directive_decl] = STATE(1175),
    [sym_fsi_directive_decl] = STATE(1175),
    [sym_preproc_line] = STATE(1175),
    [sym_preproc_if_in_expression] = STATE(3455),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_null] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(3029),
    [anon_sym_LT_AT] = ACTIONS(1742),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1748),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_return_BANG] = ACTIONS(1750),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_yield_BANG] = ACTIONS(1750),
    [anon_sym_lazy] = ACTIONS(1726),
    [anon_sym_assert] = ACTIONS(1726),
    [anon_sym_upcast] = ACTIONS(1726),
    [anon_sym_downcast] = ACTIONS(1726),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1758),
    [anon_sym_try] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1762),
    [anon_sym_match_BANG] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_use] = ACTIONS(1774),
    [anon_sym_use_BANG] = ACTIONS(1776),
    [anon_sym_do_BANG] = ACTIONS(1778),
    [anon_sym_begin] = ACTIONS(1782),
    [aux_sym_char_token1] = ACTIONS(1786),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_AT_DQUOTE] = ACTIONS(1792),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1796),
    [sym_bool] = ACTIONS(1798),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1802),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1806),
    [sym_xint] = ACTIONS(1808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1810),
  },
  [1176] = {
    [sym_function_or_value_defn] = STATE(1166),
    [sym__expression] = STATE(138),
    [sym_literal_expression] = STATE(2884),
    [sym_long_identifier_or_op] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_brace_expression] = STATE(2884),
    [sym_anon_record_expression] = STATE(2884),
    [sym_prefixed_expression] = STATE(2884),
    [sym_typecast_expression] = STATE(2884),
    [sym_for_expression] = STATE(2884),
    [sym_while_expression] = STATE(2884),
    [sym__if_branch] = STATE(10729),
    [sym_if_expression] = STATE(2884),
    [sym_fun_expression] = STATE(2884),
    [sym_try_expression] = STATE(2884),
    [sym_match_expression] = STATE(2884),
    [sym_function_expression] = STATE(2884),
    [sym_mutate_expression] = STATE(2884),
    [sym_index_expression] = STATE(2884),
    [sym_typed_expression] = STATE(2884),
    [sym_declaration_expression] = STATE(2884),
    [sym_do_expression] = STATE(2884),
    [sym_list_expression] = STATE(2884),
    [sym_array_expression] = STATE(2884),
    [sym_begin_end_expression] = STATE(2884),
    [sym_paren_expression] = STATE(2884),
    [sym__high_prec_app] = STATE(2872),
    [sym__low_prec_app] = STATE(2872),
    [sym_application_expression] = STATE(2884),
    [sym_dot_expression] = STATE(2884),
    [sym_infix_expression] = STATE(2884),
    [sym_ce_expression] = STATE(2884),
    [sym_sequential_expression] = STATE(2884),
    [sym_char] = STATE(2955),
    [sym_format_string] = STATE(2951),
    [sym__string_literal] = STATE(2951),
    [sym_string] = STATE(2955),
    [sym_verbatim_string] = STATE(2955),
    [sym_bytearray] = STATE(2955),
    [sym_verbatim_bytearray] = STATE(2955),
    [sym_format_triple_quoted_string] = STATE(2949),
    [sym_triple_quoted_string] = STATE(2955),
    [sym_const] = STATE(2884),
    [sym_long_identifier] = STATE(2885),
    [sym_active_pattern] = STATE(2833),
    [sym__identifier_or_op] = STATE(2883),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1002),
    [sym_sbyte] = STATE(2955),
    [sym_byte] = STATE(2955),
    [sym_int16] = STATE(2955),
    [sym_uint16] = STATE(2955),
    [sym_int32] = STATE(2955),
    [sym_uint32] = STATE(2955),
    [sym_nativeint] = STATE(2955),
    [sym_unativeint] = STATE(2955),
    [sym_int64] = STATE(2955),
    [sym_uint64] = STATE(2955),
    [sym_ieee32] = STATE(2955),
    [sym_ieee64] = STATE(2955),
    [sym_bignum] = STATE(2955),
    [sym_decimal] = STATE(2955),
    [sym_float] = STATE(2652),
    [sym_block_comment] = STATE(1176),
    [sym_compiler_directive_decl] = STATE(1176),
    [sym_fsi_directive_decl] = STATE(1176),
    [sym_preproc_line] = STATE(1176),
    [sym_preproc_if_in_expression] = STATE(2884),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_do] = ACTIONS(1003),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_null] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1013),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1015),
    [anon_sym_LBRACE] = ACTIONS(3181),
    [anon_sym_LT_AT] = ACTIONS(1019),
    [anon_sym_LT_AT_AT] = ACTIONS(3183),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1025),
    [anon_sym_new] = ACTIONS(1001),
    [anon_sym_return_BANG] = ACTIONS(1029),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_yield_BANG] = ACTIONS(1029),
    [anon_sym_lazy] = ACTIONS(1001),
    [anon_sym_assert] = ACTIONS(1001),
    [anon_sym_upcast] = ACTIONS(1001),
    [anon_sym_downcast] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1033),
    [anon_sym_while] = ACTIONS(1035),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1037),
    [anon_sym_try] = ACTIONS(1039),
    [anon_sym_match] = ACTIONS(1041),
    [anon_sym_match_BANG] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(1045),
    [anon_sym_use] = ACTIONS(1053),
    [anon_sym_use_BANG] = ACTIONS(1055),
    [anon_sym_do_BANG] = ACTIONS(1057),
    [anon_sym_begin] = ACTIONS(1059),
    [aux_sym_char_token1] = ACTIONS(1063),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1067),
    [anon_sym_AT_DQUOTE] = ACTIONS(1069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1073),
    [sym_bool] = ACTIONS(1075),
    [sym_unit] = ACTIONS(3185),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1079),
    [sym_op_identifier] = ACTIONS(3187),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1083),
    [sym_xint] = ACTIONS(1085),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1087),
  },
  [1177] = {
    [sym_function_or_value_defn] = STATE(1166),
    [sym__expression] = STATE(127),
    [sym_literal_expression] = STATE(2884),
    [sym_long_identifier_or_op] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_brace_expression] = STATE(2884),
    [sym_anon_record_expression] = STATE(2884),
    [sym_prefixed_expression] = STATE(2884),
    [sym_typecast_expression] = STATE(2884),
    [sym_for_expression] = STATE(2884),
    [sym_while_expression] = STATE(2884),
    [sym__if_branch] = STATE(10729),
    [sym_if_expression] = STATE(2884),
    [sym_fun_expression] = STATE(2884),
    [sym_try_expression] = STATE(2884),
    [sym_match_expression] = STATE(2884),
    [sym_function_expression] = STATE(2884),
    [sym_mutate_expression] = STATE(2884),
    [sym_index_expression] = STATE(2884),
    [sym_typed_expression] = STATE(2884),
    [sym_declaration_expression] = STATE(2884),
    [sym_do_expression] = STATE(2884),
    [sym_list_expression] = STATE(2884),
    [sym_array_expression] = STATE(2884),
    [sym_begin_end_expression] = STATE(2884),
    [sym_paren_expression] = STATE(2884),
    [sym__high_prec_app] = STATE(2872),
    [sym__low_prec_app] = STATE(2872),
    [sym_application_expression] = STATE(2884),
    [sym_dot_expression] = STATE(2884),
    [sym_infix_expression] = STATE(2884),
    [sym_ce_expression] = STATE(2884),
    [sym_sequential_expression] = STATE(2884),
    [sym_char] = STATE(2955),
    [sym_format_string] = STATE(2951),
    [sym__string_literal] = STATE(2951),
    [sym_string] = STATE(2955),
    [sym_verbatim_string] = STATE(2955),
    [sym_bytearray] = STATE(2955),
    [sym_verbatim_bytearray] = STATE(2955),
    [sym_format_triple_quoted_string] = STATE(2949),
    [sym_triple_quoted_string] = STATE(2955),
    [sym_const] = STATE(2884),
    [sym_long_identifier] = STATE(2885),
    [sym_active_pattern] = STATE(2833),
    [sym__identifier_or_op] = STATE(2883),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1002),
    [sym_sbyte] = STATE(2955),
    [sym_byte] = STATE(2955),
    [sym_int16] = STATE(2955),
    [sym_uint16] = STATE(2955),
    [sym_int32] = STATE(2955),
    [sym_uint32] = STATE(2955),
    [sym_nativeint] = STATE(2955),
    [sym_unativeint] = STATE(2955),
    [sym_int64] = STATE(2955),
    [sym_uint64] = STATE(2955),
    [sym_ieee32] = STATE(2955),
    [sym_ieee64] = STATE(2955),
    [sym_bignum] = STATE(2955),
    [sym_decimal] = STATE(2955),
    [sym_float] = STATE(2652),
    [sym_block_comment] = STATE(1177),
    [sym_compiler_directive_decl] = STATE(1177),
    [sym_fsi_directive_decl] = STATE(1177),
    [sym_preproc_line] = STATE(1177),
    [sym_preproc_if_in_expression] = STATE(2884),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_do] = ACTIONS(1003),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_null] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1013),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1015),
    [anon_sym_LBRACE] = ACTIONS(3181),
    [anon_sym_LT_AT] = ACTIONS(1019),
    [anon_sym_LT_AT_AT] = ACTIONS(3183),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1025),
    [anon_sym_new] = ACTIONS(1001),
    [anon_sym_return_BANG] = ACTIONS(1029),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_yield_BANG] = ACTIONS(1029),
    [anon_sym_lazy] = ACTIONS(1001),
    [anon_sym_assert] = ACTIONS(1001),
    [anon_sym_upcast] = ACTIONS(1001),
    [anon_sym_downcast] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1033),
    [anon_sym_while] = ACTIONS(1035),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1037),
    [anon_sym_try] = ACTIONS(1039),
    [anon_sym_match] = ACTIONS(1041),
    [anon_sym_match_BANG] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(1045),
    [anon_sym_use] = ACTIONS(1053),
    [anon_sym_use_BANG] = ACTIONS(1055),
    [anon_sym_do_BANG] = ACTIONS(1057),
    [anon_sym_begin] = ACTIONS(1059),
    [aux_sym_char_token1] = ACTIONS(1063),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1067),
    [anon_sym_AT_DQUOTE] = ACTIONS(1069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1073),
    [sym_bool] = ACTIONS(1075),
    [sym_unit] = ACTIONS(3185),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1079),
    [sym_op_identifier] = ACTIONS(3187),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1083),
    [sym_xint] = ACTIONS(1085),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1087),
  },
  [1178] = {
    [sym_function_or_value_defn] = STATE(866),
    [sym__expression] = STATE(97),
    [sym_literal_expression] = STATE(2393),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_tuple_expression] = STATE(2393),
    [sym_brace_expression] = STATE(2393),
    [sym_anon_record_expression] = STATE(2393),
    [sym_prefixed_expression] = STATE(2393),
    [sym_typecast_expression] = STATE(2393),
    [sym_for_expression] = STATE(2393),
    [sym_while_expression] = STATE(2393),
    [sym__if_branch] = STATE(11994),
    [sym_if_expression] = STATE(2393),
    [sym_fun_expression] = STATE(2393),
    [sym_try_expression] = STATE(2393),
    [sym_match_expression] = STATE(2393),
    [sym_function_expression] = STATE(2393),
    [sym_mutate_expression] = STATE(2393),
    [sym_index_expression] = STATE(2393),
    [sym_typed_expression] = STATE(2393),
    [sym_declaration_expression] = STATE(2393),
    [sym_do_expression] = STATE(2393),
    [sym_list_expression] = STATE(2393),
    [sym_array_expression] = STATE(2393),
    [sym_begin_end_expression] = STATE(2393),
    [sym_paren_expression] = STATE(2393),
    [sym__high_prec_app] = STATE(2407),
    [sym__low_prec_app] = STATE(2407),
    [sym_application_expression] = STATE(2393),
    [sym_dot_expression] = STATE(2393),
    [sym_infix_expression] = STATE(2393),
    [sym_ce_expression] = STATE(2393),
    [sym_sequential_expression] = STATE(2393),
    [sym_char] = STATE(2403),
    [sym_format_string] = STATE(2408),
    [sym__string_literal] = STATE(2408),
    [sym_string] = STATE(2403),
    [sym_verbatim_string] = STATE(2403),
    [sym_bytearray] = STATE(2403),
    [sym_verbatim_bytearray] = STATE(2403),
    [sym_format_triple_quoted_string] = STATE(2409),
    [sym_triple_quoted_string] = STATE(2403),
    [sym_const] = STATE(2393),
    [sym_long_identifier] = STATE(2465),
    [sym_active_pattern] = STATE(2404),
    [sym__identifier_or_op] = STATE(2466),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1178),
    [sym_sbyte] = STATE(2403),
    [sym_byte] = STATE(2403),
    [sym_int16] = STATE(2403),
    [sym_uint16] = STATE(2403),
    [sym_int32] = STATE(2403),
    [sym_uint32] = STATE(2403),
    [sym_nativeint] = STATE(2403),
    [sym_unativeint] = STATE(2403),
    [sym_int64] = STATE(2403),
    [sym_uint64] = STATE(2403),
    [sym_ieee32] = STATE(2403),
    [sym_ieee64] = STATE(2403),
    [sym_bignum] = STATE(2403),
    [sym_decimal] = STATE(2403),
    [sym_float] = STATE(2286),
    [sym_block_comment] = STATE(1178),
    [sym_compiler_directive_decl] = STATE(1178),
    [sym_fsi_directive_decl] = STATE(1178),
    [sym_preproc_line] = STATE(1178),
    [sym_preproc_if_in_expression] = STATE(2393),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(857),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_null] = ACTIONS(41),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_LBRACK_PIPE] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(49),
    [anon_sym_LT_AT] = ACTIONS(51),
    [anon_sym_LT_AT_AT] = ACTIONS(53),
    [anon_sym_LBRACE_PIPE] = ACTIONS(55),
    [anon_sym_new] = ACTIONS(857),
    [anon_sym_return_BANG] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(857),
    [anon_sym_yield_BANG] = ACTIONS(869),
    [anon_sym_lazy] = ACTIONS(857),
    [anon_sym_assert] = ACTIONS(857),
    [anon_sym_upcast] = ACTIONS(857),
    [anon_sym_downcast] = ACTIONS(857),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(65),
    [anon_sym_try] = ACTIONS(67),
    [anon_sym_match] = ACTIONS(69),
    [anon_sym_match_BANG] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_use] = ACTIONS(879),
    [anon_sym_use_BANG] = ACTIONS(881),
    [anon_sym_do_BANG] = ACTIONS(79),
    [anon_sym_begin] = ACTIONS(81),
    [aux_sym_char_token1] = ACTIONS(85),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(89),
    [anon_sym_AT_DQUOTE] = ACTIONS(91),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(93),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [sym_bool] = ACTIONS(97),
    [sym_unit] = ACTIONS(99),
    [anon_sym_LPAREN_PIPE] = ACTIONS(101),
    [sym_op_identifier] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(889),
    [sym_xint] = ACTIONS(891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(893),
  },
  [1179] = {
    [sym_function_or_value_defn] = STATE(1179),
    [sym__expression] = STATE(116),
    [sym_literal_expression] = STATE(2365),
    [sym_long_identifier_or_op] = STATE(2365),
    [sym_tuple_expression] = STATE(2365),
    [sym_brace_expression] = STATE(2365),
    [sym_anon_record_expression] = STATE(2365),
    [sym_prefixed_expression] = STATE(2365),
    [sym_typecast_expression] = STATE(2365),
    [sym_for_expression] = STATE(2365),
    [sym_while_expression] = STATE(2365),
    [sym__if_branch] = STATE(10194),
    [sym_if_expression] = STATE(2365),
    [sym_fun_expression] = STATE(2365),
    [sym_try_expression] = STATE(2365),
    [sym_match_expression] = STATE(2365),
    [sym_function_expression] = STATE(2365),
    [sym_mutate_expression] = STATE(2365),
    [sym_index_expression] = STATE(2365),
    [sym_typed_expression] = STATE(2365),
    [sym_declaration_expression] = STATE(2365),
    [sym_do_expression] = STATE(2365),
    [sym_list_expression] = STATE(2365),
    [sym_array_expression] = STATE(2365),
    [sym_begin_end_expression] = STATE(2365),
    [sym_paren_expression] = STATE(2365),
    [sym__high_prec_app] = STATE(2366),
    [sym__low_prec_app] = STATE(2366),
    [sym_application_expression] = STATE(2365),
    [sym_dot_expression] = STATE(2365),
    [sym_infix_expression] = STATE(2365),
    [sym_ce_expression] = STATE(2365),
    [sym_sequential_expression] = STATE(2365),
    [sym_char] = STATE(2509),
    [sym_format_string] = STATE(2505),
    [sym__string_literal] = STATE(2505),
    [sym_string] = STATE(2509),
    [sym_verbatim_string] = STATE(2509),
    [sym_bytearray] = STATE(2509),
    [sym_verbatim_bytearray] = STATE(2509),
    [sym_format_triple_quoted_string] = STATE(2504),
    [sym_triple_quoted_string] = STATE(2509),
    [sym_const] = STATE(2365),
    [sym_long_identifier] = STATE(2458),
    [sym_active_pattern] = STATE(2449),
    [sym__identifier_or_op] = STATE(2502),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1126),
    [sym_sbyte] = STATE(2509),
    [sym_byte] = STATE(2509),
    [sym_int16] = STATE(2509),
    [sym_uint16] = STATE(2509),
    [sym_int32] = STATE(2509),
    [sym_uint32] = STATE(2509),
    [sym_nativeint] = STATE(2509),
    [sym_unativeint] = STATE(2509),
    [sym_int64] = STATE(2509),
    [sym_uint64] = STATE(2509),
    [sym_ieee32] = STATE(2509),
    [sym_ieee64] = STATE(2509),
    [sym_bignum] = STATE(2509),
    [sym_decimal] = STATE(2509),
    [sym_float] = STATE(2280),
    [sym_block_comment] = STATE(1179),
    [sym_compiler_directive_decl] = STATE(1179),
    [sym_fsi_directive_decl] = STATE(1179),
    [sym_preproc_line] = STATE(1179),
    [sym_preproc_if_in_expression] = STATE(2365),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_LT_AT] = ACTIONS(925),
    [anon_sym_LT_AT_AT] = ACTIONS(2664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_return_BANG] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_yield_BANG] = ACTIONS(933),
    [anon_sym_lazy] = ACTIONS(911),
    [anon_sym_assert] = ACTIONS(911),
    [anon_sym_upcast] = ACTIONS(911),
    [anon_sym_downcast] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(941),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_match_BANG] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_use_BANG] = ACTIONS(959),
    [anon_sym_do_BANG] = ACTIONS(961),
    [anon_sym_begin] = ACTIONS(963),
    [aux_sym_char_token1] = ACTIONS(967),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_AT_DQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(977),
    [sym_bool] = ACTIONS(979),
    [sym_unit] = ACTIONS(2674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(983),
    [sym_op_identifier] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(991),
  },
  [1180] = {
    [sym_function_or_value_defn] = STATE(1180),
    [sym__expression] = STATE(156),
    [sym_literal_expression] = STATE(3145),
    [sym_long_identifier_or_op] = STATE(3145),
    [sym_tuple_expression] = STATE(3145),
    [sym_brace_expression] = STATE(3145),
    [sym_anon_record_expression] = STATE(3145),
    [sym_prefixed_expression] = STATE(3145),
    [sym_typecast_expression] = STATE(3145),
    [sym_for_expression] = STATE(3145),
    [sym_while_expression] = STATE(3145),
    [sym__if_branch] = STATE(10360),
    [sym_if_expression] = STATE(3145),
    [sym_fun_expression] = STATE(3145),
    [sym_try_expression] = STATE(3145),
    [sym_match_expression] = STATE(3145),
    [sym_function_expression] = STATE(3145),
    [sym_mutate_expression] = STATE(3145),
    [sym_index_expression] = STATE(3145),
    [sym_typed_expression] = STATE(3145),
    [sym_declaration_expression] = STATE(3145),
    [sym_do_expression] = STATE(3145),
    [sym_list_expression] = STATE(3145),
    [sym_array_expression] = STATE(3145),
    [sym_begin_end_expression] = STATE(3145),
    [sym_paren_expression] = STATE(3145),
    [sym__high_prec_app] = STATE(3141),
    [sym__low_prec_app] = STATE(3141),
    [sym_application_expression] = STATE(3145),
    [sym_dot_expression] = STATE(3145),
    [sym_infix_expression] = STATE(3145),
    [sym_ce_expression] = STATE(3145),
    [sym_sequential_expression] = STATE(3145),
    [sym_char] = STATE(3108),
    [sym_format_string] = STATE(3193),
    [sym__string_literal] = STATE(3193),
    [sym_string] = STATE(3108),
    [sym_verbatim_string] = STATE(3108),
    [sym_bytearray] = STATE(3108),
    [sym_verbatim_bytearray] = STATE(3108),
    [sym_format_triple_quoted_string] = STATE(3192),
    [sym_triple_quoted_string] = STATE(3108),
    [sym_const] = STATE(3145),
    [sym_long_identifier] = STATE(3102),
    [sym_active_pattern] = STATE(3172),
    [sym__identifier_or_op] = STATE(3103),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(1149),
    [sym_sbyte] = STATE(3108),
    [sym_byte] = STATE(3108),
    [sym_int16] = STATE(3108),
    [sym_uint16] = STATE(3108),
    [sym_int32] = STATE(3108),
    [sym_uint32] = STATE(3108),
    [sym_nativeint] = STATE(3108),
    [sym_unativeint] = STATE(3108),
    [sym_int64] = STATE(3108),
    [sym_uint64] = STATE(3108),
    [sym_ieee32] = STATE(3108),
    [sym_ieee64] = STATE(3108),
    [sym_bignum] = STATE(3108),
    [sym_decimal] = STATE(3108),
    [sym_float] = STATE(2770),
    [sym_block_comment] = STATE(1180),
    [sym_compiler_directive_decl] = STATE(1180),
    [sym_fsi_directive_decl] = STATE(1180),
    [sym_preproc_line] = STATE(1180),
    [sym_preproc_if_in_expression] = STATE(3145),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_return] = ACTIONS(1119),
    [anon_sym_do] = ACTIONS(1121),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_null] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1131),
    [anon_sym_LBRACE] = ACTIONS(3169),
    [anon_sym_LT_AT] = ACTIONS(1135),
    [anon_sym_LT_AT_AT] = ACTIONS(3171),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1141),
    [anon_sym_new] = ACTIONS(1119),
    [anon_sym_return_BANG] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1119),
    [anon_sym_yield_BANG] = ACTIONS(1143),
    [anon_sym_lazy] = ACTIONS(1119),
    [anon_sym_assert] = ACTIONS(1119),
    [anon_sym_upcast] = ACTIONS(1119),
    [anon_sym_downcast] = ACTIONS(1119),
    [anon_sym_for] = ACTIONS(1147),
    [anon_sym_while] = ACTIONS(1149),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1151),
    [anon_sym_try] = ACTIONS(1153),
    [anon_sym_match] = ACTIONS(1155),
    [anon_sym_match_BANG] = ACTIONS(1157),
    [anon_sym_function] = ACTIONS(1159),
    [anon_sym_use] = ACTIONS(1167),
    [anon_sym_use_BANG] = ACTIONS(1169),
    [anon_sym_do_BANG] = ACTIONS(1171),
    [anon_sym_begin] = ACTIONS(1173),
    [aux_sym_char_token1] = ACTIONS(1177),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(1181),
    [anon_sym_AT_DQUOTE] = ACTIONS(1183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1185),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1187),
    [sym_bool] = ACTIONS(1189),
    [sym_unit] = ACTIONS(3173),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1193),
    [sym_op_identifier] = ACTIONS(3175),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1197),
    [sym_xint] = ACTIONS(1199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1201),
  },
  [1181] = {
    [sym_function_or_value_defn] = STATE(1174),
    [sym__expression] = STATE(319),
    [sym_literal_expression] = STATE(3420),
    [sym_long_identifier_or_op] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_brace_expression] = STATE(3420),
    [sym_anon_record_expression] = STATE(3420),
    [sym_prefixed_expression] = STATE(3420),
    [sym_typecast_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym__if_branch] = STATE(10295),
    [sym_if_expression] = STATE(3420),
    [sym_fun_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_function_expression] = STATE(3420),
    [sym_mutate_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_typed_expression] = STATE(3420),
    [sym_declaration_expression] = STATE(3420),
    [sym_do_expression] = STATE(3420),
    [sym_list_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_begin_end_expression] = STATE(3420),
    [sym_paren_expression] = STATE(3420),
    [sym__high_prec_app] = STATE(3288),
    [sym__low_prec_app] = STATE(3288),
    [sym_application_expression] = STATE(3420),
    [sym_dot_expression] = STATE(3420),
    [sym_infix_expression] = STATE(3420),
    [sym_ce_expression] = STATE(3420),
    [sym_sequential_expression] = STATE(3420),
    [sym_char] = STATE(3546),
    [sym_format_string] = STATE(3565),
    [sym__string_literal] = STATE(3565),
    [sym_string] = STATE(3546),
    [sym_verbatim_string] = STATE(3546),
    [sym_bytearray] = STATE(3546),
    [sym_verbatim_bytearray] = STATE(3546),
    [sym_format_triple_quoted_string] = STATE(3568),
    [sym_triple_quoted_string] = STATE(3546),
    [sym_const] = STATE(3420),
    [sym_long_identifier] = STATE(3572),
    [sym_active_pattern] = STATE(3562),
    [sym__identifier_or_op] = STATE(3401),
    [sym__infix_or_prefix_op] = STATE(4292),
    [sym_prefix_op] = STATE(890),
    [sym_sbyte] = STATE(3546),
    [sym_byte] = STATE(3546),
    [sym_int16] = STATE(3546),
    [sym_uint16] = STATE(3546),
    [sym_int32] = STATE(3546),
    [sym_uint32] = STATE(3546),
    [sym_nativeint] = STATE(3546),
    [sym_unativeint] = STATE(3546),
    [sym_int64] = STATE(3546),
    [sym_uint64] = STATE(3546),
    [sym_ieee32] = STATE(3546),
    [sym_ieee64] = STATE(3546),
    [sym_bignum] = STATE(3546),
    [sym_decimal] = STATE(3546),
    [sym_float] = STATE(2785),
    [sym_block_comment] = STATE(1181),
    [sym_compiler_directive_decl] = STATE(1181),
    [sym_fsi_directive_decl] = STATE(1181),
    [sym_preproc_line] = STATE(1181),
    [sym_preproc_if_in_expression] = STATE(3420),
    [aux_sym_prefix_op_repeat1] = STATE(4280),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(133),
    [anon_sym_let_BANG] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_LT_AT] = ACTIONS(1530),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_return_BANG] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_yield_BANG] = ACTIONS(1538),
    [anon_sym_lazy] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_upcast] = ACTIONS(1516),
    [anon_sym_downcast] = ACTIONS(1516),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_fun] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_match_BANG] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_use_BANG] = ACTIONS(1564),
    [anon_sym_do_BANG] = ACTIONS(1566),
    [anon_sym_begin] = ACTIONS(1568),
    [aux_sym_char_token1] = ACTIONS(1572),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1576),
    [anon_sym_AT_DQUOTE] = ACTIONS(1578),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1580),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1582),
    [sym_bool] = ACTIONS(1584),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1588),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(43),
    [anon_sym_DASH] = ACTIONS(43),
    [anon_sym_PLUS_DOT] = ACTIONS(105),
    [anon_sym_DASH_DOT] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_AMP_AMP] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(107),
    [aux_sym_prefix_op_token1] = ACTIONS(109),
    [sym_int] = ACTIONS(1592),
    [sym_xint] = ACTIONS(1594),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1596),
  },
  [1182] = {
    [sym_block_comment] = STATE(1182),
    [sym_compiler_directive_decl] = STATE(1182),
    [sym_fsi_directive_decl] = STATE(1182),
    [sym_preproc_line] = STATE(1182),
    [ts_builtin_sym_end] = ACTIONS(3191),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_namespace] = ACTIONS(3193),
    [anon_sym_module] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_open] = ACTIONS(3193),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_type] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_and] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [aux_sym_access_modifier_token1] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_member] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_exception] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_val] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3195),
    [anon_sym_uy] = ACTIONS(3197),
    [anon_sym_s] = ACTIONS(3199),
    [anon_sym_us] = ACTIONS(3201),
    [anon_sym_l] = ACTIONS(3203),
    [aux_sym_uint32_token1] = ACTIONS(3205),
    [anon_sym_n] = ACTIONS(3207),
    [anon_sym_un] = ACTIONS(3209),
    [anon_sym_L] = ACTIONS(3211),
    [aux_sym_uint64_token1] = ACTIONS(3213),
    [aux_sym_bignum_token1] = ACTIONS(3215),
    [aux_sym_decimal_token1] = ACTIONS(3217),
    [anon_sym_DOT2] = ACTIONS(3219),
    [aux_sym_float_token1] = ACTIONS(3221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3191),
    [anon_sym_POUNDload] = ACTIONS(3191),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1183] = {
    [sym_block_comment] = STATE(1183),
    [sym_compiler_directive_decl] = STATE(1183),
    [sym_fsi_directive_decl] = STATE(1183),
    [sym_preproc_line] = STATE(1183),
    [ts_builtin_sym_end] = ACTIONS(3191),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_module] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_open] = ACTIONS(3193),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_type] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_and] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [aux_sym_access_modifier_token1] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_member] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_exception] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_val] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3195),
    [anon_sym_uy] = ACTIONS(3197),
    [anon_sym_s] = ACTIONS(3199),
    [anon_sym_us] = ACTIONS(3201),
    [anon_sym_l] = ACTIONS(3203),
    [aux_sym_uint32_token1] = ACTIONS(3205),
    [anon_sym_n] = ACTIONS(3207),
    [anon_sym_un] = ACTIONS(3209),
    [anon_sym_L] = ACTIONS(3211),
    [aux_sym_uint64_token1] = ACTIONS(3213),
    [aux_sym_bignum_token1] = ACTIONS(3215),
    [aux_sym_decimal_token1] = ACTIONS(3217),
    [anon_sym_DOT2] = ACTIONS(3219),
    [aux_sym_float_token1] = ACTIONS(3221),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3191),
    [anon_sym_POUNDload] = ACTIONS(3191),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1184] = {
    [sym_block_comment] = STATE(1184),
    [sym_compiler_directive_decl] = STATE(1184),
    [sym_fsi_directive_decl] = STATE(1184),
    [sym_preproc_line] = STATE(1184),
    [ts_builtin_sym_end] = ACTIONS(3191),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_namespace] = ACTIONS(3193),
    [anon_sym_module] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_open] = ACTIONS(3193),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_type] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_and] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [aux_sym_access_modifier_token1] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_member] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_exception] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_val] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3195),
    [anon_sym_uy] = ACTIONS(3197),
    [anon_sym_s] = ACTIONS(3199),
    [anon_sym_us] = ACTIONS(3201),
    [anon_sym_l] = ACTIONS(3203),
    [aux_sym_uint32_token1] = ACTIONS(3205),
    [anon_sym_n] = ACTIONS(3207),
    [anon_sym_un] = ACTIONS(3209),
    [anon_sym_L] = ACTIONS(3211),
    [aux_sym_uint64_token1] = ACTIONS(3213),
    [anon_sym_lf] = ACTIONS(3223),
    [anon_sym_LF] = ACTIONS(3225),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3191),
    [anon_sym_POUNDload] = ACTIONS(3191),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1185] = {
    [sym_block_comment] = STATE(1185),
    [sym_compiler_directive_decl] = STATE(1185),
    [sym_fsi_directive_decl] = STATE(1185),
    [sym_preproc_line] = STATE(1185),
    [ts_builtin_sym_end] = ACTIONS(3191),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_module] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_open] = ACTIONS(3193),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_type] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_and] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [aux_sym_access_modifier_token1] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_member] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_exception] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_val] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3195),
    [anon_sym_uy] = ACTIONS(3197),
    [anon_sym_s] = ACTIONS(3199),
    [anon_sym_us] = ACTIONS(3201),
    [anon_sym_l] = ACTIONS(3203),
    [aux_sym_uint32_token1] = ACTIONS(3205),
    [anon_sym_n] = ACTIONS(3207),
    [anon_sym_un] = ACTIONS(3209),
    [anon_sym_L] = ACTIONS(3211),
    [aux_sym_uint64_token1] = ACTIONS(3213),
    [anon_sym_lf] = ACTIONS(3223),
    [anon_sym_LF] = ACTIONS(3225),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3191),
    [anon_sym_POUNDload] = ACTIONS(3191),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1186] = {
    [sym_block_comment] = STATE(1186),
    [sym_compiler_directive_decl] = STATE(1186),
    [sym_fsi_directive_decl] = STATE(1186),
    [sym_preproc_line] = STATE(1186),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [aux_sym_access_modifier_token1] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_member] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_val] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [anon_sym_inherit] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3227),
    [anon_sym_uy] = ACTIONS(3229),
    [anon_sym_s] = ACTIONS(3231),
    [anon_sym_us] = ACTIONS(3233),
    [anon_sym_l] = ACTIONS(3235),
    [aux_sym_uint32_token1] = ACTIONS(3237),
    [anon_sym_n] = ACTIONS(3239),
    [anon_sym_un] = ACTIONS(3241),
    [anon_sym_L] = ACTIONS(3243),
    [aux_sym_uint64_token1] = ACTIONS(3245),
    [aux_sym_bignum_token1] = ACTIONS(3247),
    [aux_sym_decimal_token1] = ACTIONS(3249),
    [anon_sym_DOT2] = ACTIONS(3251),
    [aux_sym_float_token1] = ACTIONS(3253),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [anon_sym_POUNDendif] = ACTIONS(3191),
    [anon_sym_POUNDelse] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1187] = {
    [sym_block_comment] = STATE(1187),
    [sym_compiler_directive_decl] = STATE(1187),
    [sym_fsi_directive_decl] = STATE(1187),
    [sym_preproc_line] = STATE(1187),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_and] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [aux_sym_access_modifier_token1] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_member] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_val] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3255),
    [anon_sym_uy] = ACTIONS(3257),
    [anon_sym_s] = ACTIONS(3259),
    [anon_sym_us] = ACTIONS(3261),
    [anon_sym_l] = ACTIONS(3263),
    [aux_sym_uint32_token1] = ACTIONS(3265),
    [anon_sym_n] = ACTIONS(3267),
    [anon_sym_un] = ACTIONS(3269),
    [anon_sym_L] = ACTIONS(3271),
    [aux_sym_uint64_token1] = ACTIONS(3273),
    [aux_sym_bignum_token1] = ACTIONS(3275),
    [aux_sym_decimal_token1] = ACTIONS(3277),
    [anon_sym_DOT2] = ACTIONS(3279),
    [aux_sym_float_token1] = ACTIONS(3281),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [anon_sym_POUNDendif] = ACTIONS(3191),
    [anon_sym_POUNDelse] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1188] = {
    [sym_block_comment] = STATE(1188),
    [sym_compiler_directive_decl] = STATE(1188),
    [sym_fsi_directive_decl] = STATE(1188),
    [sym_preproc_line] = STATE(1188),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [aux_sym_access_modifier_token1] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_member] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_val] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [anon_sym_inherit] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3283),
    [anon_sym_uy] = ACTIONS(3285),
    [anon_sym_s] = ACTIONS(3287),
    [anon_sym_us] = ACTIONS(3289),
    [anon_sym_l] = ACTIONS(3291),
    [aux_sym_uint32_token1] = ACTIONS(3293),
    [anon_sym_n] = ACTIONS(3295),
    [anon_sym_un] = ACTIONS(3297),
    [anon_sym_L] = ACTIONS(3299),
    [aux_sym_uint64_token1] = ACTIONS(3301),
    [aux_sym_bignum_token1] = ACTIONS(3303),
    [aux_sym_decimal_token1] = ACTIONS(3305),
    [anon_sym_DOT2] = ACTIONS(3307),
    [aux_sym_float_token1] = ACTIONS(3309),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [anon_sym_POUNDendif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1189] = {
    [sym_block_comment] = STATE(1189),
    [sym_compiler_directive_decl] = STATE(1189),
    [sym_fsi_directive_decl] = STATE(1189),
    [sym_preproc_line] = STATE(1189),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_and] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [aux_sym_access_modifier_token1] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_member] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_val] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3311),
    [anon_sym_uy] = ACTIONS(3313),
    [anon_sym_s] = ACTIONS(3315),
    [anon_sym_us] = ACTIONS(3317),
    [anon_sym_l] = ACTIONS(3319),
    [aux_sym_uint32_token1] = ACTIONS(3321),
    [anon_sym_n] = ACTIONS(3323),
    [anon_sym_un] = ACTIONS(3325),
    [anon_sym_L] = ACTIONS(3327),
    [aux_sym_uint64_token1] = ACTIONS(3329),
    [aux_sym_bignum_token1] = ACTIONS(3331),
    [aux_sym_decimal_token1] = ACTIONS(3333),
    [anon_sym_DOT2] = ACTIONS(3335),
    [aux_sym_float_token1] = ACTIONS(3337),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [anon_sym_POUNDendif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1190] = {
    [sym_block_comment] = STATE(1190),
    [sym_compiler_directive_decl] = STATE(1190),
    [sym_fsi_directive_decl] = STATE(1190),
    [sym_preproc_line] = STATE(1190),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_and] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [aux_sym_access_modifier_token1] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_member] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_val] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3339),
    [anon_sym_uy] = ACTIONS(3341),
    [anon_sym_s] = ACTIONS(3343),
    [anon_sym_us] = ACTIONS(3345),
    [anon_sym_l] = ACTIONS(3347),
    [aux_sym_uint32_token1] = ACTIONS(3349),
    [anon_sym_n] = ACTIONS(3351),
    [anon_sym_un] = ACTIONS(3353),
    [anon_sym_L] = ACTIONS(3355),
    [aux_sym_uint64_token1] = ACTIONS(3357),
    [aux_sym_bignum_token1] = ACTIONS(3359),
    [aux_sym_decimal_token1] = ACTIONS(3361),
    [anon_sym_DOT2] = ACTIONS(3363),
    [aux_sym_float_token1] = ACTIONS(3365),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
    [sym__dedent] = ACTIONS(3191),
  },
  [1191] = {
    [sym_block_comment] = STATE(1191),
    [sym_compiler_directive_decl] = STATE(1191),
    [sym_fsi_directive_decl] = STATE(1191),
    [sym_preproc_line] = STATE(1191),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_and] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [aux_sym_access_modifier_token1] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_member] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_val] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3255),
    [anon_sym_uy] = ACTIONS(3257),
    [anon_sym_s] = ACTIONS(3259),
    [anon_sym_us] = ACTIONS(3261),
    [anon_sym_l] = ACTIONS(3263),
    [aux_sym_uint32_token1] = ACTIONS(3265),
    [anon_sym_n] = ACTIONS(3267),
    [anon_sym_un] = ACTIONS(3269),
    [anon_sym_L] = ACTIONS(3271),
    [aux_sym_uint64_token1] = ACTIONS(3273),
    [anon_sym_lf] = ACTIONS(3367),
    [anon_sym_LF] = ACTIONS(3369),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [anon_sym_POUNDendif] = ACTIONS(3191),
    [anon_sym_POUNDelse] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1192] = {
    [sym_block_comment] = STATE(1192),
    [sym_compiler_directive_decl] = STATE(1192),
    [sym_fsi_directive_decl] = STATE(1192),
    [sym_preproc_line] = STATE(1192),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [aux_sym_access_modifier_token1] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_member] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_val] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [anon_sym_inherit] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3227),
    [anon_sym_uy] = ACTIONS(3229),
    [anon_sym_s] = ACTIONS(3231),
    [anon_sym_us] = ACTIONS(3233),
    [anon_sym_l] = ACTIONS(3235),
    [aux_sym_uint32_token1] = ACTIONS(3237),
    [anon_sym_n] = ACTIONS(3239),
    [anon_sym_un] = ACTIONS(3241),
    [anon_sym_L] = ACTIONS(3243),
    [aux_sym_uint64_token1] = ACTIONS(3245),
    [anon_sym_lf] = ACTIONS(3371),
    [anon_sym_LF] = ACTIONS(3373),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [anon_sym_POUNDendif] = ACTIONS(3191),
    [anon_sym_POUNDelse] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1193] = {
    [sym_block_comment] = STATE(1193),
    [sym_compiler_directive_decl] = STATE(1193),
    [sym_fsi_directive_decl] = STATE(1193),
    [sym_preproc_line] = STATE(1193),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [aux_sym_access_modifier_token1] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_member] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_val] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3375),
    [anon_sym_uy] = ACTIONS(3377),
    [anon_sym_s] = ACTIONS(3379),
    [anon_sym_us] = ACTIONS(3381),
    [anon_sym_l] = ACTIONS(3383),
    [aux_sym_uint32_token1] = ACTIONS(3385),
    [anon_sym_n] = ACTIONS(3387),
    [anon_sym_un] = ACTIONS(3389),
    [anon_sym_L] = ACTIONS(3391),
    [aux_sym_uint64_token1] = ACTIONS(3393),
    [aux_sym_bignum_token1] = ACTIONS(3395),
    [aux_sym_decimal_token1] = ACTIONS(3397),
    [anon_sym_DOT2] = ACTIONS(3399),
    [aux_sym_float_token1] = ACTIONS(3401),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
    [sym__dedent] = ACTIONS(3191),
  },
  [1194] = {
    [sym_type_arguments] = STATE(1230),
    [sym_long_identifier] = STATE(1219),
    [sym_block_comment] = STATE(1194),
    [sym_compiler_directive_decl] = STATE(1194),
    [sym_fsi_directive_decl] = STATE(1194),
    [sym_preproc_line] = STATE(1194),
    [aux_sym_compound_type_repeat1] = STATE(1206),
    [ts_builtin_sym_end] = ACTIONS(3403),
    [sym_identifier] = ACTIONS(3405),
    [anon_sym_namespace] = ACTIONS(3407),
    [anon_sym_module] = ACTIONS(3407),
    [anon_sym_EQ] = ACTIONS(3403),
    [anon_sym_open] = ACTIONS(3407),
    [anon_sym_LBRACK_LT] = ACTIONS(3403),
    [anon_sym_COLON] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_type] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_and] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_let_BANG] = ACTIONS(3403),
    [aux_sym_access_modifier_token1] = ACTIONS(3403),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_COMMA] = ACTIONS(3403),
    [anon_sym_null] = ACTIONS(3407),
    [anon_sym_QMARK] = ACTIONS(3407),
    [anon_sym_COLON_QMARK] = ACTIONS(3407),
    [anon_sym_COLON_COLON] = ACTIONS(3403),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3407),
    [anon_sym_LT_AT] = ACTIONS(3407),
    [anon_sym_LT_AT_AT] = ACTIONS(3407),
    [anon_sym_DOT] = ACTIONS(3407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_with] = ACTIONS(3407),
    [anon_sym_return_BANG] = ACTIONS(3403),
    [anon_sym_yield] = ACTIONS(3407),
    [anon_sym_yield_BANG] = ACTIONS(3403),
    [anon_sym_lazy] = ACTIONS(3407),
    [anon_sym_assert] = ACTIONS(3407),
    [anon_sym_upcast] = ACTIONS(3407),
    [anon_sym_downcast] = ACTIONS(3407),
    [anon_sym_COLON_GT] = ACTIONS(3403),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_fun] = ACTIONS(3407),
    [anon_sym_DASH_GT] = ACTIONS(3409),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_match] = ACTIONS(3407),
    [anon_sym_match_BANG] = ACTIONS(3403),
    [anon_sym_function] = ACTIONS(3407),
    [anon_sym_LT_DASH] = ACTIONS(3407),
    [anon_sym_DOT_LBRACK] = ACTIONS(3403),
    [anon_sym_LT] = ACTIONS(3403),
    [anon_sym_use] = ACTIONS(3407),
    [anon_sym_use_BANG] = ACTIONS(3403),
    [anon_sym_do_BANG] = ACTIONS(3403),
    [anon_sym_begin] = ACTIONS(3407),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3411),
    [anon_sym_LT2] = ACTIONS(3413),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3415),
    [anon_sym_default] = ACTIONS(3407),
    [anon_sym_or] = ACTIONS(3407),
    [anon_sym_static] = ACTIONS(3407),
    [anon_sym_member] = ACTIONS(3407),
    [anon_sym_interface] = ACTIONS(3407),
    [anon_sym_exception] = ACTIONS(3407),
    [anon_sym_abstract] = ACTIONS(3407),
    [anon_sym_val] = ACTIONS(3407),
    [anon_sym_override] = ACTIONS(3407),
    [aux_sym_char_token1] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3407),
    [anon_sym_DQUOTE] = ACTIONS(3407),
    [anon_sym_AT_DQUOTE] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [sym_bool] = ACTIONS(3407),
    [sym_unit] = ACTIONS(3403),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3407),
    [sym_op_identifier] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_PLUS_DOT] = ACTIONS(3407),
    [anon_sym_DASH_DOT] = ACTIONS(3407),
    [anon_sym_PERCENT] = ACTIONS(3407),
    [anon_sym_AMP_AMP] = ACTIONS(3407),
    [anon_sym_TILDE] = ACTIONS(3403),
    [aux_sym_prefix_op_token1] = ACTIONS(3407),
    [aux_sym_infix_op_token1] = ACTIONS(3403),
    [aux_sym_infix_op_token2] = ACTIONS(3407),
    [anon_sym_PIPE_PIPE] = ACTIONS(3407),
    [anon_sym_BANG_EQ] = ACTIONS(3407),
    [anon_sym_COLON_EQ] = ACTIONS(3403),
    [anon_sym_DOLLAR] = ACTIONS(3407),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3407),
    [sym_int] = ACTIONS(3407),
    [sym_xint] = ACTIONS(3403),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3403),
    [anon_sym_POUNDload] = ACTIONS(3403),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3403),
    [sym__newline] = ACTIONS(3403),
  },
  [1195] = {
    [sym_type_arguments] = STATE(1230),
    [sym_long_identifier] = STATE(1219),
    [sym_block_comment] = STATE(1195),
    [sym_compiler_directive_decl] = STATE(1195),
    [sym_fsi_directive_decl] = STATE(1195),
    [sym_preproc_line] = STATE(1195),
    [aux_sym_compound_type_repeat1] = STATE(1206),
    [ts_builtin_sym_end] = ACTIONS(3417),
    [sym_identifier] = ACTIONS(3405),
    [anon_sym_namespace] = ACTIONS(3419),
    [anon_sym_module] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(3417),
    [anon_sym_open] = ACTIONS(3419),
    [anon_sym_LBRACK_LT] = ACTIONS(3417),
    [anon_sym_COLON] = ACTIONS(3419),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_type] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_and] = ACTIONS(3419),
    [anon_sym_let] = ACTIONS(3419),
    [anon_sym_let_BANG] = ACTIONS(3417),
    [aux_sym_access_modifier_token1] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(3419),
    [anon_sym_COMMA] = ACTIONS(3417),
    [anon_sym_null] = ACTIONS(3419),
    [anon_sym_QMARK] = ACTIONS(3419),
    [anon_sym_COLON_QMARK] = ACTIONS(3419),
    [anon_sym_COLON_COLON] = ACTIONS(3417),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_LT_AT] = ACTIONS(3419),
    [anon_sym_LT_AT_AT] = ACTIONS(3419),
    [anon_sym_DOT] = ACTIONS(3419),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_with] = ACTIONS(3419),
    [anon_sym_return_BANG] = ACTIONS(3417),
    [anon_sym_yield] = ACTIONS(3419),
    [anon_sym_yield_BANG] = ACTIONS(3417),
    [anon_sym_lazy] = ACTIONS(3419),
    [anon_sym_assert] = ACTIONS(3419),
    [anon_sym_upcast] = ACTIONS(3419),
    [anon_sym_downcast] = ACTIONS(3419),
    [anon_sym_COLON_GT] = ACTIONS(3417),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3417),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_fun] = ACTIONS(3419),
    [anon_sym_DASH_GT] = ACTIONS(3409),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_match] = ACTIONS(3419),
    [anon_sym_match_BANG] = ACTIONS(3417),
    [anon_sym_function] = ACTIONS(3419),
    [anon_sym_LT_DASH] = ACTIONS(3419),
    [anon_sym_DOT_LBRACK] = ACTIONS(3417),
    [anon_sym_LT] = ACTIONS(3417),
    [anon_sym_use] = ACTIONS(3419),
    [anon_sym_use_BANG] = ACTIONS(3417),
    [anon_sym_do_BANG] = ACTIONS(3417),
    [anon_sym_begin] = ACTIONS(3419),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(3411),
    [anon_sym_LT2] = ACTIONS(3413),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3415),
    [anon_sym_default] = ACTIONS(3419),
    [anon_sym_or] = ACTIONS(3419),
    [anon_sym_static] = ACTIONS(3419),
    [anon_sym_member] = ACTIONS(3419),
    [anon_sym_interface] = ACTIONS(3419),
    [anon_sym_exception] = ACTIONS(3419),
    [anon_sym_abstract] = ACTIONS(3419),
    [anon_sym_val] = ACTIONS(3419),
    [anon_sym_override] = ACTIONS(3419),
    [aux_sym_char_token1] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3419),
    [anon_sym_AT_DQUOTE] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [sym_bool] = ACTIONS(3419),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3419),
    [sym_op_identifier] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_PLUS_DOT] = ACTIONS(3419),
    [anon_sym_DASH_DOT] = ACTIONS(3419),
    [anon_sym_PERCENT] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3419),
    [anon_sym_TILDE] = ACTIONS(3417),
    [aux_sym_prefix_op_token1] = ACTIONS(3419),
    [aux_sym_infix_op_token1] = ACTIONS(3417),
    [aux_sym_infix_op_token2] = ACTIONS(3419),
    [anon_sym_PIPE_PIPE] = ACTIONS(3419),
    [anon_sym_BANG_EQ] = ACTIONS(3419),
    [anon_sym_COLON_EQ] = ACTIONS(3417),
    [anon_sym_DOLLAR] = ACTIONS(3419),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3419),
    [sym_int] = ACTIONS(3419),
    [sym_xint] = ACTIONS(3417),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3417),
    [anon_sym_POUNDload] = ACTIONS(3417),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3417),
    [sym__newline] = ACTIONS(3417),
  },
  [1196] = {
    [sym_block_comment] = STATE(1196),
    [sym_compiler_directive_decl] = STATE(1196),
    [sym_fsi_directive_decl] = STATE(1196),
    [sym_preproc_line] = STATE(1196),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [aux_sym_access_modifier_token1] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_member] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_val] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [anon_sym_inherit] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3283),
    [anon_sym_uy] = ACTIONS(3285),
    [anon_sym_s] = ACTIONS(3287),
    [anon_sym_us] = ACTIONS(3289),
    [anon_sym_l] = ACTIONS(3291),
    [aux_sym_uint32_token1] = ACTIONS(3293),
    [anon_sym_n] = ACTIONS(3295),
    [anon_sym_un] = ACTIONS(3297),
    [anon_sym_L] = ACTIONS(3299),
    [aux_sym_uint64_token1] = ACTIONS(3301),
    [anon_sym_lf] = ACTIONS(3421),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [anon_sym_POUNDendif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1197] = {
    [sym_type_arguments] = STATE(1230),
    [sym_long_identifier] = STATE(1219),
    [sym_block_comment] = STATE(1197),
    [sym_compiler_directive_decl] = STATE(1197),
    [sym_fsi_directive_decl] = STATE(1197),
    [sym_preproc_line] = STATE(1197),
    [aux_sym_compound_type_repeat1] = STATE(1206),
    [ts_builtin_sym_end] = ACTIONS(3425),
    [sym_identifier] = ACTIONS(3405),
    [anon_sym_namespace] = ACTIONS(3427),
    [anon_sym_module] = ACTIONS(3427),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_open] = ACTIONS(3427),
    [anon_sym_LBRACK_LT] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_type] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_and] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [aux_sym_access_modifier_token1] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3427),
    [anon_sym_DOT] = ACTIONS(3427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_with] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_COLON_GT] = ACTIONS(3425),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(3409),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_LT_DASH] = ACTIONS(3427),
    [anon_sym_DOT_LBRACK] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(3411),
    [anon_sym_LT2] = ACTIONS(3413),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3415),
    [anon_sym_default] = ACTIONS(3427),
    [anon_sym_or] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_member] = ACTIONS(3427),
    [anon_sym_interface] = ACTIONS(3427),
    [anon_sym_exception] = ACTIONS(3427),
    [anon_sym_abstract] = ACTIONS(3427),
    [anon_sym_val] = ACTIONS(3427),
    [anon_sym_override] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3427),
    [anon_sym_DASH_DOT] = ACTIONS(3427),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3427),
    [aux_sym_infix_op_token1] = ACTIONS(3425),
    [aux_sym_infix_op_token2] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3427),
    [anon_sym_COLON_EQ] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3427),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3425),
    [anon_sym_POUNDload] = ACTIONS(3425),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
  },
  [1198] = {
    [sym_type_arguments] = STATE(1230),
    [sym_long_identifier] = STATE(1219),
    [sym_block_comment] = STATE(1198),
    [sym_compiler_directive_decl] = STATE(1198),
    [sym_fsi_directive_decl] = STATE(1198),
    [sym_preproc_line] = STATE(1198),
    [aux_sym_compound_type_repeat1] = STATE(1206),
    [ts_builtin_sym_end] = ACTIONS(3429),
    [sym_identifier] = ACTIONS(3405),
    [anon_sym_namespace] = ACTIONS(3431),
    [anon_sym_module] = ACTIONS(3431),
    [anon_sym_EQ] = ACTIONS(3429),
    [anon_sym_open] = ACTIONS(3431),
    [anon_sym_LBRACK_LT] = ACTIONS(3429),
    [anon_sym_COLON] = ACTIONS(3431),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_type] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_and] = ACTIONS(3431),
    [anon_sym_let] = ACTIONS(3431),
    [anon_sym_let_BANG] = ACTIONS(3429),
    [aux_sym_access_modifier_token1] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(3431),
    [anon_sym_COMMA] = ACTIONS(3429),
    [anon_sym_null] = ACTIONS(3431),
    [anon_sym_QMARK] = ACTIONS(3431),
    [anon_sym_COLON_QMARK] = ACTIONS(3431),
    [anon_sym_COLON_COLON] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_LT_AT] = ACTIONS(3431),
    [anon_sym_LT_AT_AT] = ACTIONS(3431),
    [anon_sym_DOT] = ACTIONS(3431),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_with] = ACTIONS(3431),
    [anon_sym_return_BANG] = ACTIONS(3429),
    [anon_sym_yield] = ACTIONS(3431),
    [anon_sym_yield_BANG] = ACTIONS(3429),
    [anon_sym_lazy] = ACTIONS(3431),
    [anon_sym_assert] = ACTIONS(3431),
    [anon_sym_upcast] = ACTIONS(3431),
    [anon_sym_downcast] = ACTIONS(3431),
    [anon_sym_COLON_GT] = ACTIONS(3429),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_fun] = ACTIONS(3431),
    [anon_sym_DASH_GT] = ACTIONS(3409),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_match] = ACTIONS(3431),
    [anon_sym_match_BANG] = ACTIONS(3429),
    [anon_sym_function] = ACTIONS(3431),
    [anon_sym_LT_DASH] = ACTIONS(3431),
    [anon_sym_DOT_LBRACK] = ACTIONS(3429),
    [anon_sym_LT] = ACTIONS(3429),
    [anon_sym_use] = ACTIONS(3431),
    [anon_sym_use_BANG] = ACTIONS(3429),
    [anon_sym_do_BANG] = ACTIONS(3429),
    [anon_sym_begin] = ACTIONS(3431),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3411),
    [anon_sym_LT2] = ACTIONS(3413),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3415),
    [anon_sym_default] = ACTIONS(3431),
    [anon_sym_or] = ACTIONS(3431),
    [anon_sym_static] = ACTIONS(3431),
    [anon_sym_member] = ACTIONS(3431),
    [anon_sym_interface] = ACTIONS(3431),
    [anon_sym_exception] = ACTIONS(3431),
    [anon_sym_abstract] = ACTIONS(3431),
    [anon_sym_val] = ACTIONS(3431),
    [anon_sym_override] = ACTIONS(3431),
    [aux_sym_char_token1] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [anon_sym_AT_DQUOTE] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [sym_bool] = ACTIONS(3431),
    [sym_unit] = ACTIONS(3429),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3431),
    [sym_op_identifier] = ACTIONS(3431),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_DOT] = ACTIONS(3431),
    [anon_sym_DASH_DOT] = ACTIONS(3431),
    [anon_sym_PERCENT] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3429),
    [aux_sym_prefix_op_token1] = ACTIONS(3431),
    [aux_sym_infix_op_token1] = ACTIONS(3429),
    [aux_sym_infix_op_token2] = ACTIONS(3431),
    [anon_sym_PIPE_PIPE] = ACTIONS(3431),
    [anon_sym_BANG_EQ] = ACTIONS(3431),
    [anon_sym_COLON_EQ] = ACTIONS(3429),
    [anon_sym_DOLLAR] = ACTIONS(3431),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3431),
    [sym_int] = ACTIONS(3431),
    [sym_xint] = ACTIONS(3429),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3429),
    [anon_sym_POUNDload] = ACTIONS(3429),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3429),
    [sym__newline] = ACTIONS(3429),
  },
  [1199] = {
    [sym_block_comment] = STATE(1199),
    [sym_compiler_directive_decl] = STATE(1199),
    [sym_fsi_directive_decl] = STATE(1199),
    [sym_preproc_line] = STATE(1199),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_and] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [aux_sym_access_modifier_token1] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_member] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_val] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3311),
    [anon_sym_uy] = ACTIONS(3313),
    [anon_sym_s] = ACTIONS(3315),
    [anon_sym_us] = ACTIONS(3317),
    [anon_sym_l] = ACTIONS(3319),
    [aux_sym_uint32_token1] = ACTIONS(3321),
    [anon_sym_n] = ACTIONS(3323),
    [anon_sym_un] = ACTIONS(3325),
    [anon_sym_L] = ACTIONS(3327),
    [aux_sym_uint64_token1] = ACTIONS(3329),
    [anon_sym_lf] = ACTIONS(3433),
    [anon_sym_LF] = ACTIONS(3435),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [anon_sym_POUNDendif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1200] = {
    [sym_block_comment] = STATE(1200),
    [sym_compiler_directive_decl] = STATE(1200),
    [sym_fsi_directive_decl] = STATE(1200),
    [sym_preproc_line] = STATE(1200),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_and] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [aux_sym_access_modifier_token1] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_member] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_val] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3339),
    [anon_sym_uy] = ACTIONS(3341),
    [anon_sym_s] = ACTIONS(3343),
    [anon_sym_us] = ACTIONS(3345),
    [anon_sym_l] = ACTIONS(3347),
    [aux_sym_uint32_token1] = ACTIONS(3349),
    [anon_sym_n] = ACTIONS(3351),
    [anon_sym_un] = ACTIONS(3353),
    [anon_sym_L] = ACTIONS(3355),
    [aux_sym_uint64_token1] = ACTIONS(3357),
    [anon_sym_lf] = ACTIONS(3437),
    [anon_sym_LF] = ACTIONS(3439),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
    [sym__dedent] = ACTIONS(3191),
  },
  [1201] = {
    [sym_type_arguments] = STATE(1230),
    [sym_long_identifier] = STATE(1219),
    [sym_block_comment] = STATE(1201),
    [sym_compiler_directive_decl] = STATE(1201),
    [sym_fsi_directive_decl] = STATE(1201),
    [sym_preproc_line] = STATE(1201),
    [aux_sym_compound_type_repeat1] = STATE(1206),
    [ts_builtin_sym_end] = ACTIONS(3441),
    [sym_identifier] = ACTIONS(3443),
    [anon_sym_namespace] = ACTIONS(3443),
    [anon_sym_module] = ACTIONS(3443),
    [anon_sym_EQ] = ACTIONS(3441),
    [anon_sym_open] = ACTIONS(3443),
    [anon_sym_LBRACK_LT] = ACTIONS(3441),
    [anon_sym_COLON] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_type] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_and] = ACTIONS(3443),
    [anon_sym_let] = ACTIONS(3443),
    [anon_sym_let_BANG] = ACTIONS(3441),
    [aux_sym_access_modifier_token1] = ACTIONS(3441),
    [anon_sym_LPAREN] = ACTIONS(3443),
    [anon_sym_COMMA] = ACTIONS(3441),
    [anon_sym_null] = ACTIONS(3443),
    [anon_sym_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_LT_AT] = ACTIONS(3443),
    [anon_sym_LT_AT_AT] = ACTIONS(3443),
    [anon_sym_DOT] = ACTIONS(3443),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_with] = ACTIONS(3443),
    [anon_sym_return_BANG] = ACTIONS(3441),
    [anon_sym_yield] = ACTIONS(3443),
    [anon_sym_yield_BANG] = ACTIONS(3441),
    [anon_sym_lazy] = ACTIONS(3443),
    [anon_sym_assert] = ACTIONS(3443),
    [anon_sym_upcast] = ACTIONS(3443),
    [anon_sym_downcast] = ACTIONS(3443),
    [anon_sym_COLON_GT] = ACTIONS(3441),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3441),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_fun] = ACTIONS(3443),
    [anon_sym_DASH_GT] = ACTIONS(3409),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_match] = ACTIONS(3443),
    [anon_sym_match_BANG] = ACTIONS(3441),
    [anon_sym_function] = ACTIONS(3443),
    [anon_sym_LT_DASH] = ACTIONS(3443),
    [anon_sym_DOT_LBRACK] = ACTIONS(3441),
    [anon_sym_LT] = ACTIONS(3441),
    [anon_sym_use] = ACTIONS(3443),
    [anon_sym_use_BANG] = ACTIONS(3441),
    [anon_sym_do_BANG] = ACTIONS(3441),
    [anon_sym_begin] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(3411),
    [anon_sym_LT2] = ACTIONS(3413),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3415),
    [anon_sym_default] = ACTIONS(3443),
    [anon_sym_or] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_member] = ACTIONS(3443),
    [anon_sym_interface] = ACTIONS(3443),
    [anon_sym_exception] = ACTIONS(3443),
    [anon_sym_abstract] = ACTIONS(3443),
    [anon_sym_val] = ACTIONS(3443),
    [anon_sym_override] = ACTIONS(3443),
    [aux_sym_char_token1] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3443),
    [anon_sym_AT_DQUOTE] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [sym_bool] = ACTIONS(3443),
    [sym_unit] = ACTIONS(3441),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3443),
    [sym_op_identifier] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_PLUS_DOT] = ACTIONS(3443),
    [anon_sym_DASH_DOT] = ACTIONS(3443),
    [anon_sym_PERCENT] = ACTIONS(3443),
    [anon_sym_AMP_AMP] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3441),
    [aux_sym_prefix_op_token1] = ACTIONS(3443),
    [aux_sym_infix_op_token1] = ACTIONS(3441),
    [aux_sym_infix_op_token2] = ACTIONS(3443),
    [anon_sym_PIPE_PIPE] = ACTIONS(3443),
    [anon_sym_BANG_EQ] = ACTIONS(3443),
    [anon_sym_COLON_EQ] = ACTIONS(3441),
    [anon_sym_DOLLAR] = ACTIONS(3443),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3443),
    [sym_int] = ACTIONS(3443),
    [sym_xint] = ACTIONS(3441),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3441),
    [anon_sym_POUNDload] = ACTIONS(3441),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3441),
    [sym__newline] = ACTIONS(3441),
  },
  [1202] = {
    [sym_block_comment] = STATE(1202),
    [sym_compiler_directive_decl] = STATE(1202),
    [sym_fsi_directive_decl] = STATE(1202),
    [sym_preproc_line] = STATE(1202),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [aux_sym_access_modifier_token1] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_member] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_val] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3375),
    [anon_sym_uy] = ACTIONS(3377),
    [anon_sym_s] = ACTIONS(3379),
    [anon_sym_us] = ACTIONS(3381),
    [anon_sym_l] = ACTIONS(3383),
    [aux_sym_uint32_token1] = ACTIONS(3385),
    [anon_sym_n] = ACTIONS(3387),
    [anon_sym_un] = ACTIONS(3389),
    [anon_sym_L] = ACTIONS(3391),
    [aux_sym_uint64_token1] = ACTIONS(3393),
    [anon_sym_lf] = ACTIONS(3445),
    [anon_sym_LF] = ACTIONS(3447),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
    [sym__dedent] = ACTIONS(3191),
  },
  [1203] = {
    [sym_block_comment] = STATE(1203),
    [sym_compiler_directive_decl] = STATE(1203),
    [sym_fsi_directive_decl] = STATE(1203),
    [sym_preproc_line] = STATE(1203),
    [aux_sym_long_identifier_repeat1] = STATE(1210),
    [ts_builtin_sym_end] = ACTIONS(3449),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_namespace] = ACTIONS(3451),
    [anon_sym_module] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_open] = ACTIONS(3451),
    [anon_sym_LBRACK_LT] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_type] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_and] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [aux_sym_access_modifier_token1] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(3453),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_DASH_GT] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_STAR] = ACTIONS(3451),
    [anon_sym_LT2] = ACTIONS(3451),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3449),
    [anon_sym_default] = ACTIONS(3451),
    [anon_sym_or] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_member] = ACTIONS(3451),
    [anon_sym_interface] = ACTIONS(3451),
    [anon_sym_exception] = ACTIONS(3451),
    [anon_sym_abstract] = ACTIONS(3451),
    [anon_sym_val] = ACTIONS(3451),
    [anon_sym_override] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3449),
    [anon_sym_POUNDload] = ACTIONS(3449),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
  },
  [1204] = {
    [sym__else_expression] = STATE(1342),
    [sym_elif_expression] = STATE(1274),
    [sym_block_comment] = STATE(1204),
    [sym_compiler_directive_decl] = STATE(1204),
    [sym_fsi_directive_decl] = STATE(1204),
    [sym_preproc_line] = STATE(1204),
    [aux_sym_if_expression_repeat1] = STATE(1227),
    [ts_builtin_sym_end] = ACTIONS(3455),
    [sym_identifier] = ACTIONS(3457),
    [anon_sym_namespace] = ACTIONS(3457),
    [anon_sym_module] = ACTIONS(3457),
    [anon_sym_EQ] = ACTIONS(3455),
    [anon_sym_open] = ACTIONS(3457),
    [anon_sym_LBRACK_LT] = ACTIONS(3455),
    [anon_sym_COLON] = ACTIONS(3457),
    [anon_sym_return] = ACTIONS(3457),
    [anon_sym_type] = ACTIONS(3457),
    [anon_sym_do] = ACTIONS(3457),
    [anon_sym_and] = ACTIONS(3457),
    [anon_sym_let] = ACTIONS(3457),
    [anon_sym_let_BANG] = ACTIONS(3455),
    [aux_sym_access_modifier_token1] = ACTIONS(3455),
    [anon_sym_LPAREN] = ACTIONS(3457),
    [anon_sym_COMMA] = ACTIONS(3455),
    [anon_sym_null] = ACTIONS(3457),
    [anon_sym_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_COLON] = ACTIONS(3455),
    [anon_sym_AMP] = ACTIONS(3457),
    [anon_sym_LBRACK] = ACTIONS(3457),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3457),
    [anon_sym_LT_AT] = ACTIONS(3457),
    [anon_sym_LT_AT_AT] = ACTIONS(3457),
    [anon_sym_DOT] = ACTIONS(3457),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3457),
    [anon_sym_with] = ACTIONS(3457),
    [anon_sym_return_BANG] = ACTIONS(3455),
    [anon_sym_yield] = ACTIONS(3457),
    [anon_sym_yield_BANG] = ACTIONS(3455),
    [anon_sym_lazy] = ACTIONS(3457),
    [anon_sym_assert] = ACTIONS(3457),
    [anon_sym_upcast] = ACTIONS(3457),
    [anon_sym_downcast] = ACTIONS(3457),
    [anon_sym_COLON_GT] = ACTIONS(3455),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3457),
    [anon_sym_while] = ACTIONS(3457),
    [anon_sym_else] = ACTIONS(3459),
    [anon_sym_elif] = ACTIONS(3461),
    [anon_sym_if] = ACTIONS(3457),
    [anon_sym_fun] = ACTIONS(3457),
    [anon_sym_try] = ACTIONS(3457),
    [anon_sym_match] = ACTIONS(3457),
    [anon_sym_match_BANG] = ACTIONS(3455),
    [anon_sym_function] = ACTIONS(3457),
    [anon_sym_LT_DASH] = ACTIONS(3457),
    [anon_sym_DOT_LBRACK] = ACTIONS(3455),
    [anon_sym_LT] = ACTIONS(3455),
    [anon_sym_use] = ACTIONS(3457),
    [anon_sym_use_BANG] = ACTIONS(3455),
    [anon_sym_do_BANG] = ACTIONS(3455),
    [anon_sym_begin] = ACTIONS(3457),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_default] = ACTIONS(3457),
    [anon_sym_or] = ACTIONS(3457),
    [anon_sym_static] = ACTIONS(3457),
    [anon_sym_member] = ACTIONS(3457),
    [anon_sym_interface] = ACTIONS(3457),
    [anon_sym_exception] = ACTIONS(3457),
    [anon_sym_abstract] = ACTIONS(3457),
    [anon_sym_val] = ACTIONS(3457),
    [anon_sym_override] = ACTIONS(3457),
    [aux_sym_char_token1] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [anon_sym_AT_DQUOTE] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [sym_bool] = ACTIONS(3457),
    [sym_unit] = ACTIONS(3455),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3457),
    [sym_op_identifier] = ACTIONS(3457),
    [anon_sym_PLUS] = ACTIONS(3457),
    [anon_sym_DASH] = ACTIONS(3457),
    [anon_sym_PLUS_DOT] = ACTIONS(3457),
    [anon_sym_DASH_DOT] = ACTIONS(3457),
    [anon_sym_PERCENT] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3455),
    [aux_sym_prefix_op_token1] = ACTIONS(3457),
    [aux_sym_infix_op_token1] = ACTIONS(3455),
    [aux_sym_infix_op_token2] = ACTIONS(3457),
    [anon_sym_PIPE_PIPE] = ACTIONS(3457),
    [anon_sym_BANG_EQ] = ACTIONS(3457),
    [anon_sym_COLON_EQ] = ACTIONS(3455),
    [anon_sym_DOLLAR] = ACTIONS(3457),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3457),
    [sym_int] = ACTIONS(3457),
    [sym_xint] = ACTIONS(3455),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3455),
    [anon_sym_POUNDload] = ACTIONS(3455),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3455),
    [sym__newline] = ACTIONS(3455),
  },
  [1205] = {
    [sym_block_comment] = STATE(1205),
    [sym_compiler_directive_decl] = STATE(1205),
    [sym_fsi_directive_decl] = STATE(1205),
    [sym_preproc_line] = STATE(1205),
    [aux_sym_compound_type_repeat1] = STATE(1205),
    [ts_builtin_sym_end] = ACTIONS(3425),
    [sym_identifier] = ACTIONS(3427),
    [anon_sym_namespace] = ACTIONS(3427),
    [anon_sym_module] = ACTIONS(3427),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_open] = ACTIONS(3427),
    [anon_sym_LBRACK_LT] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_type] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_and] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [aux_sym_access_modifier_token1] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3427),
    [anon_sym_DOT] = ACTIONS(3427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_with] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_COLON_GT] = ACTIONS(3425),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(3427),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_LT_DASH] = ACTIONS(3427),
    [anon_sym_DOT_LBRACK] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(3463),
    [anon_sym_LT2] = ACTIONS(3427),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3425),
    [anon_sym_default] = ACTIONS(3427),
    [anon_sym_or] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_member] = ACTIONS(3427),
    [anon_sym_interface] = ACTIONS(3427),
    [anon_sym_exception] = ACTIONS(3427),
    [anon_sym_abstract] = ACTIONS(3427),
    [anon_sym_val] = ACTIONS(3427),
    [anon_sym_override] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3427),
    [anon_sym_DASH_DOT] = ACTIONS(3427),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3427),
    [aux_sym_infix_op_token1] = ACTIONS(3425),
    [aux_sym_infix_op_token2] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3427),
    [anon_sym_COLON_EQ] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3427),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3425),
    [anon_sym_POUNDload] = ACTIONS(3425),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
  },
  [1206] = {
    [sym_block_comment] = STATE(1206),
    [sym_compiler_directive_decl] = STATE(1206),
    [sym_fsi_directive_decl] = STATE(1206),
    [sym_preproc_line] = STATE(1206),
    [aux_sym_compound_type_repeat1] = STATE(1205),
    [ts_builtin_sym_end] = ACTIONS(3466),
    [sym_identifier] = ACTIONS(3468),
    [anon_sym_namespace] = ACTIONS(3468),
    [anon_sym_module] = ACTIONS(3468),
    [anon_sym_EQ] = ACTIONS(3466),
    [anon_sym_open] = ACTIONS(3468),
    [anon_sym_LBRACK_LT] = ACTIONS(3466),
    [anon_sym_COLON] = ACTIONS(3468),
    [anon_sym_return] = ACTIONS(3468),
    [anon_sym_type] = ACTIONS(3468),
    [anon_sym_do] = ACTIONS(3468),
    [anon_sym_and] = ACTIONS(3468),
    [anon_sym_let] = ACTIONS(3468),
    [anon_sym_let_BANG] = ACTIONS(3466),
    [aux_sym_access_modifier_token1] = ACTIONS(3466),
    [anon_sym_LPAREN] = ACTIONS(3468),
    [anon_sym_COMMA] = ACTIONS(3466),
    [anon_sym_null] = ACTIONS(3468),
    [anon_sym_QMARK] = ACTIONS(3468),
    [anon_sym_COLON_QMARK] = ACTIONS(3468),
    [anon_sym_COLON_COLON] = ACTIONS(3466),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LBRACK] = ACTIONS(3468),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3466),
    [anon_sym_LBRACE] = ACTIONS(3468),
    [anon_sym_LT_AT] = ACTIONS(3468),
    [anon_sym_LT_AT_AT] = ACTIONS(3468),
    [anon_sym_DOT] = ACTIONS(3468),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3466),
    [anon_sym_new] = ACTIONS(3468),
    [anon_sym_with] = ACTIONS(3468),
    [anon_sym_return_BANG] = ACTIONS(3466),
    [anon_sym_yield] = ACTIONS(3468),
    [anon_sym_yield_BANG] = ACTIONS(3466),
    [anon_sym_lazy] = ACTIONS(3468),
    [anon_sym_assert] = ACTIONS(3468),
    [anon_sym_upcast] = ACTIONS(3468),
    [anon_sym_downcast] = ACTIONS(3468),
    [anon_sym_COLON_GT] = ACTIONS(3466),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3466),
    [anon_sym_for] = ACTIONS(3468),
    [anon_sym_while] = ACTIONS(3468),
    [anon_sym_if] = ACTIONS(3468),
    [anon_sym_fun] = ACTIONS(3468),
    [anon_sym_DASH_GT] = ACTIONS(3468),
    [anon_sym_try] = ACTIONS(3468),
    [anon_sym_match] = ACTIONS(3468),
    [anon_sym_match_BANG] = ACTIONS(3466),
    [anon_sym_function] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3468),
    [anon_sym_DOT_LBRACK] = ACTIONS(3466),
    [anon_sym_LT] = ACTIONS(3466),
    [anon_sym_use] = ACTIONS(3468),
    [anon_sym_use_BANG] = ACTIONS(3466),
    [anon_sym_do_BANG] = ACTIONS(3466),
    [anon_sym_begin] = ACTIONS(3468),
    [anon_sym_LPAREN2] = ACTIONS(3468),
    [anon_sym_STAR] = ACTIONS(3411),
    [anon_sym_LT2] = ACTIONS(3468),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3466),
    [anon_sym_default] = ACTIONS(3468),
    [anon_sym_or] = ACTIONS(3468),
    [anon_sym_static] = ACTIONS(3468),
    [anon_sym_member] = ACTIONS(3468),
    [anon_sym_interface] = ACTIONS(3468),
    [anon_sym_exception] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(3468),
    [anon_sym_val] = ACTIONS(3468),
    [anon_sym_override] = ACTIONS(3468),
    [aux_sym_char_token1] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3468),
    [anon_sym_DQUOTE] = ACTIONS(3468),
    [anon_sym_AT_DQUOTE] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [sym_bool] = ACTIONS(3468),
    [sym_unit] = ACTIONS(3466),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3468),
    [sym_op_identifier] = ACTIONS(3468),
    [anon_sym_PLUS] = ACTIONS(3468),
    [anon_sym_DASH] = ACTIONS(3468),
    [anon_sym_PLUS_DOT] = ACTIONS(3468),
    [anon_sym_DASH_DOT] = ACTIONS(3468),
    [anon_sym_PERCENT] = ACTIONS(3468),
    [anon_sym_AMP_AMP] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3466),
    [aux_sym_prefix_op_token1] = ACTIONS(3468),
    [aux_sym_infix_op_token1] = ACTIONS(3466),
    [aux_sym_infix_op_token2] = ACTIONS(3468),
    [anon_sym_PIPE_PIPE] = ACTIONS(3468),
    [anon_sym_BANG_EQ] = ACTIONS(3468),
    [anon_sym_COLON_EQ] = ACTIONS(3466),
    [anon_sym_DOLLAR] = ACTIONS(3468),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3468),
    [sym_int] = ACTIONS(3468),
    [sym_xint] = ACTIONS(3466),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3466),
    [anon_sym_POUNDload] = ACTIONS(3466),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3466),
    [sym__newline] = ACTIONS(3466),
  },
  [1207] = {
    [sym__else_expression] = STATE(1450),
    [sym_elif_expression] = STATE(1274),
    [sym_block_comment] = STATE(1207),
    [sym_compiler_directive_decl] = STATE(1207),
    [sym_fsi_directive_decl] = STATE(1207),
    [sym_preproc_line] = STATE(1207),
    [aux_sym_if_expression_repeat1] = STATE(1204),
    [ts_builtin_sym_end] = ACTIONS(3470),
    [sym_identifier] = ACTIONS(3472),
    [anon_sym_namespace] = ACTIONS(3472),
    [anon_sym_module] = ACTIONS(3472),
    [anon_sym_EQ] = ACTIONS(3470),
    [anon_sym_open] = ACTIONS(3472),
    [anon_sym_LBRACK_LT] = ACTIONS(3470),
    [anon_sym_COLON] = ACTIONS(3472),
    [anon_sym_return] = ACTIONS(3472),
    [anon_sym_type] = ACTIONS(3472),
    [anon_sym_do] = ACTIONS(3472),
    [anon_sym_and] = ACTIONS(3472),
    [anon_sym_let] = ACTIONS(3472),
    [anon_sym_let_BANG] = ACTIONS(3470),
    [aux_sym_access_modifier_token1] = ACTIONS(3470),
    [anon_sym_LPAREN] = ACTIONS(3472),
    [anon_sym_COMMA] = ACTIONS(3470),
    [anon_sym_null] = ACTIONS(3472),
    [anon_sym_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_COLON] = ACTIONS(3470),
    [anon_sym_AMP] = ACTIONS(3472),
    [anon_sym_LBRACK] = ACTIONS(3472),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3470),
    [anon_sym_LBRACE] = ACTIONS(3472),
    [anon_sym_LT_AT] = ACTIONS(3472),
    [anon_sym_LT_AT_AT] = ACTIONS(3472),
    [anon_sym_DOT] = ACTIONS(3472),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3470),
    [anon_sym_new] = ACTIONS(3472),
    [anon_sym_with] = ACTIONS(3472),
    [anon_sym_return_BANG] = ACTIONS(3470),
    [anon_sym_yield] = ACTIONS(3472),
    [anon_sym_yield_BANG] = ACTIONS(3470),
    [anon_sym_lazy] = ACTIONS(3472),
    [anon_sym_assert] = ACTIONS(3472),
    [anon_sym_upcast] = ACTIONS(3472),
    [anon_sym_downcast] = ACTIONS(3472),
    [anon_sym_COLON_GT] = ACTIONS(3470),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3470),
    [anon_sym_for] = ACTIONS(3472),
    [anon_sym_while] = ACTIONS(3472),
    [anon_sym_else] = ACTIONS(3459),
    [anon_sym_elif] = ACTIONS(3461),
    [anon_sym_if] = ACTIONS(3472),
    [anon_sym_fun] = ACTIONS(3472),
    [anon_sym_try] = ACTIONS(3472),
    [anon_sym_match] = ACTIONS(3472),
    [anon_sym_match_BANG] = ACTIONS(3470),
    [anon_sym_function] = ACTIONS(3472),
    [anon_sym_LT_DASH] = ACTIONS(3472),
    [anon_sym_DOT_LBRACK] = ACTIONS(3470),
    [anon_sym_LT] = ACTIONS(3470),
    [anon_sym_use] = ACTIONS(3472),
    [anon_sym_use_BANG] = ACTIONS(3470),
    [anon_sym_do_BANG] = ACTIONS(3470),
    [anon_sym_begin] = ACTIONS(3472),
    [anon_sym_LPAREN2] = ACTIONS(3472),
    [anon_sym_default] = ACTIONS(3472),
    [anon_sym_or] = ACTIONS(3472),
    [anon_sym_static] = ACTIONS(3472),
    [anon_sym_member] = ACTIONS(3472),
    [anon_sym_interface] = ACTIONS(3472),
    [anon_sym_exception] = ACTIONS(3472),
    [anon_sym_abstract] = ACTIONS(3472),
    [anon_sym_val] = ACTIONS(3472),
    [anon_sym_override] = ACTIONS(3472),
    [aux_sym_char_token1] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3472),
    [anon_sym_DQUOTE] = ACTIONS(3472),
    [anon_sym_AT_DQUOTE] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [sym_bool] = ACTIONS(3472),
    [sym_unit] = ACTIONS(3470),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3472),
    [sym_op_identifier] = ACTIONS(3472),
    [anon_sym_PLUS] = ACTIONS(3472),
    [anon_sym_DASH] = ACTIONS(3472),
    [anon_sym_PLUS_DOT] = ACTIONS(3472),
    [anon_sym_DASH_DOT] = ACTIONS(3472),
    [anon_sym_PERCENT] = ACTIONS(3472),
    [anon_sym_AMP_AMP] = ACTIONS(3472),
    [anon_sym_TILDE] = ACTIONS(3470),
    [aux_sym_prefix_op_token1] = ACTIONS(3472),
    [aux_sym_infix_op_token1] = ACTIONS(3470),
    [aux_sym_infix_op_token2] = ACTIONS(3472),
    [anon_sym_PIPE_PIPE] = ACTIONS(3472),
    [anon_sym_BANG_EQ] = ACTIONS(3472),
    [anon_sym_COLON_EQ] = ACTIONS(3470),
    [anon_sym_DOLLAR] = ACTIONS(3472),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3472),
    [sym_int] = ACTIONS(3472),
    [sym_xint] = ACTIONS(3470),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3470),
    [anon_sym_POUNDload] = ACTIONS(3470),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3470),
    [sym__newline] = ACTIONS(3470),
  },
  [1208] = {
    [sym_block_comment] = STATE(1208),
    [sym_compiler_directive_decl] = STATE(1208),
    [sym_fsi_directive_decl] = STATE(1208),
    [sym_preproc_line] = STATE(1208),
    [aux_sym_type_argument_repeat1] = STATE(1209),
    [ts_builtin_sym_end] = ACTIONS(3474),
    [sym_identifier] = ACTIONS(3476),
    [anon_sym_namespace] = ACTIONS(3476),
    [anon_sym_module] = ACTIONS(3476),
    [anon_sym_EQ] = ACTIONS(3474),
    [anon_sym_open] = ACTIONS(3476),
    [anon_sym_LBRACK_LT] = ACTIONS(3474),
    [anon_sym_COLON] = ACTIONS(3476),
    [anon_sym_return] = ACTIONS(3476),
    [anon_sym_type] = ACTIONS(3476),
    [anon_sym_do] = ACTIONS(3476),
    [anon_sym_and] = ACTIONS(3476),
    [anon_sym_let] = ACTIONS(3476),
    [anon_sym_let_BANG] = ACTIONS(3474),
    [aux_sym_access_modifier_token1] = ACTIONS(3474),
    [anon_sym_LPAREN] = ACTIONS(3476),
    [anon_sym_COMMA] = ACTIONS(3474),
    [anon_sym_null] = ACTIONS(3476),
    [anon_sym_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_COLON] = ACTIONS(3474),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym_LBRACK] = ACTIONS(3476),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3474),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_LT_AT] = ACTIONS(3476),
    [anon_sym_LT_AT_AT] = ACTIONS(3476),
    [anon_sym_DOT] = ACTIONS(3476),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3474),
    [anon_sym_new] = ACTIONS(3476),
    [anon_sym_with] = ACTIONS(3476),
    [anon_sym_return_BANG] = ACTIONS(3474),
    [anon_sym_yield] = ACTIONS(3476),
    [anon_sym_yield_BANG] = ACTIONS(3474),
    [anon_sym_lazy] = ACTIONS(3476),
    [anon_sym_assert] = ACTIONS(3476),
    [anon_sym_upcast] = ACTIONS(3476),
    [anon_sym_downcast] = ACTIONS(3476),
    [anon_sym_COLON_GT] = ACTIONS(3474),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3474),
    [anon_sym_for] = ACTIONS(3476),
    [anon_sym_while] = ACTIONS(3476),
    [anon_sym_if] = ACTIONS(3476),
    [anon_sym_fun] = ACTIONS(3476),
    [anon_sym_DASH_GT] = ACTIONS(3476),
    [anon_sym_try] = ACTIONS(3476),
    [anon_sym_match] = ACTIONS(3476),
    [anon_sym_match_BANG] = ACTIONS(3474),
    [anon_sym_function] = ACTIONS(3476),
    [anon_sym_LT_DASH] = ACTIONS(3476),
    [anon_sym_DOT_LBRACK] = ACTIONS(3474),
    [anon_sym_LT] = ACTIONS(3474),
    [anon_sym_use] = ACTIONS(3476),
    [anon_sym_use_BANG] = ACTIONS(3474),
    [anon_sym_do_BANG] = ACTIONS(3474),
    [anon_sym_begin] = ACTIONS(3476),
    [anon_sym_LPAREN2] = ACTIONS(3476),
    [anon_sym_STAR] = ACTIONS(3476),
    [anon_sym_LT2] = ACTIONS(3476),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3474),
    [anon_sym_default] = ACTIONS(3476),
    [anon_sym_or] = ACTIONS(3476),
    [anon_sym_static] = ACTIONS(3476),
    [anon_sym_member] = ACTIONS(3476),
    [anon_sym_interface] = ACTIONS(3476),
    [anon_sym_exception] = ACTIONS(3476),
    [anon_sym_abstract] = ACTIONS(3476),
    [anon_sym_val] = ACTIONS(3476),
    [anon_sym_override] = ACTIONS(3476),
    [aux_sym_char_token1] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3476),
    [anon_sym_DQUOTE] = ACTIONS(3476),
    [anon_sym_AT_DQUOTE] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [sym_bool] = ACTIONS(3476),
    [sym_unit] = ACTIONS(3474),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3476),
    [sym_op_identifier] = ACTIONS(3476),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3476),
    [anon_sym_PLUS_DOT] = ACTIONS(3476),
    [anon_sym_DASH_DOT] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [anon_sym_AMP_AMP] = ACTIONS(3476),
    [anon_sym_TILDE] = ACTIONS(3474),
    [aux_sym_prefix_op_token1] = ACTIONS(3476),
    [aux_sym_infix_op_token1] = ACTIONS(3474),
    [aux_sym_infix_op_token2] = ACTIONS(3476),
    [anon_sym_PIPE_PIPE] = ACTIONS(3476),
    [anon_sym_BANG_EQ] = ACTIONS(3476),
    [anon_sym_COLON_EQ] = ACTIONS(3474),
    [anon_sym_DOLLAR] = ACTIONS(3476),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3476),
    [sym_int] = ACTIONS(3476),
    [sym_xint] = ACTIONS(3474),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3474),
    [anon_sym_POUNDload] = ACTIONS(3474),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3474),
    [sym__newline] = ACTIONS(3474),
  },
  [1209] = {
    [sym_block_comment] = STATE(1209),
    [sym_compiler_directive_decl] = STATE(1209),
    [sym_fsi_directive_decl] = STATE(1209),
    [sym_preproc_line] = STATE(1209),
    [aux_sym_type_argument_repeat1] = STATE(1209),
    [ts_builtin_sym_end] = ACTIONS(3478),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_namespace] = ACTIONS(3480),
    [anon_sym_module] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_open] = ACTIONS(3480),
    [anon_sym_LBRACK_LT] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_type] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_and] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [aux_sym_access_modifier_token1] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_COLON] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_with] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_LT_DASH] = ACTIONS(3480),
    [anon_sym_DOT_LBRACK] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_default] = ACTIONS(3480),
    [anon_sym_or] = ACTIONS(3482),
    [anon_sym_static] = ACTIONS(3480),
    [anon_sym_member] = ACTIONS(3480),
    [anon_sym_interface] = ACTIONS(3480),
    [anon_sym_exception] = ACTIONS(3480),
    [anon_sym_abstract] = ACTIONS(3480),
    [anon_sym_val] = ACTIONS(3480),
    [anon_sym_override] = ACTIONS(3480),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3480),
    [anon_sym_DASH_DOT] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3480),
    [aux_sym_infix_op_token1] = ACTIONS(3478),
    [aux_sym_infix_op_token2] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3480),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3478),
    [anon_sym_POUNDload] = ACTIONS(3478),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
  },
  [1210] = {
    [sym_block_comment] = STATE(1210),
    [sym_compiler_directive_decl] = STATE(1210),
    [sym_fsi_directive_decl] = STATE(1210),
    [sym_preproc_line] = STATE(1210),
    [aux_sym_long_identifier_repeat1] = STATE(1210),
    [ts_builtin_sym_end] = ACTIONS(3485),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_namespace] = ACTIONS(3487),
    [anon_sym_module] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_open] = ACTIONS(3487),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_type] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_and] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [aux_sym_access_modifier_token1] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3489),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_member] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_exception] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_val] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3485),
    [anon_sym_POUNDload] = ACTIONS(3485),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [1211] = {
    [sym_block_comment] = STATE(1211),
    [sym_compiler_directive_decl] = STATE(1211),
    [sym_fsi_directive_decl] = STATE(1211),
    [sym_preproc_line] = STATE(1211),
    [aux_sym_long_identifier_repeat1] = STATE(1203),
    [ts_builtin_sym_end] = ACTIONS(3492),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_namespace] = ACTIONS(3494),
    [anon_sym_module] = ACTIONS(3494),
    [anon_sym_EQ] = ACTIONS(3492),
    [anon_sym_open] = ACTIONS(3494),
    [anon_sym_LBRACK_LT] = ACTIONS(3492),
    [anon_sym_COLON] = ACTIONS(3494),
    [anon_sym_return] = ACTIONS(3494),
    [anon_sym_type] = ACTIONS(3494),
    [anon_sym_do] = ACTIONS(3494),
    [anon_sym_and] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_let_BANG] = ACTIONS(3492),
    [aux_sym_access_modifier_token1] = ACTIONS(3492),
    [anon_sym_LPAREN] = ACTIONS(3494),
    [anon_sym_COMMA] = ACTIONS(3492),
    [anon_sym_null] = ACTIONS(3494),
    [anon_sym_QMARK] = ACTIONS(3494),
    [anon_sym_COLON_QMARK] = ACTIONS(3494),
    [anon_sym_COLON_COLON] = ACTIONS(3492),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3492),
    [anon_sym_LBRACE] = ACTIONS(3494),
    [anon_sym_LT_AT] = ACTIONS(3494),
    [anon_sym_LT_AT_AT] = ACTIONS(3494),
    [anon_sym_DOT] = ACTIONS(3453),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3492),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_with] = ACTIONS(3494),
    [anon_sym_return_BANG] = ACTIONS(3492),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_yield_BANG] = ACTIONS(3492),
    [anon_sym_lazy] = ACTIONS(3494),
    [anon_sym_assert] = ACTIONS(3494),
    [anon_sym_upcast] = ACTIONS(3494),
    [anon_sym_downcast] = ACTIONS(3494),
    [anon_sym_COLON_GT] = ACTIONS(3492),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3492),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_while] = ACTIONS(3494),
    [anon_sym_if] = ACTIONS(3494),
    [anon_sym_fun] = ACTIONS(3494),
    [anon_sym_DASH_GT] = ACTIONS(3494),
    [anon_sym_try] = ACTIONS(3494),
    [anon_sym_match] = ACTIONS(3494),
    [anon_sym_match_BANG] = ACTIONS(3492),
    [anon_sym_function] = ACTIONS(3494),
    [anon_sym_LT_DASH] = ACTIONS(3494),
    [anon_sym_DOT_LBRACK] = ACTIONS(3492),
    [anon_sym_LT] = ACTIONS(3492),
    [anon_sym_use] = ACTIONS(3494),
    [anon_sym_use_BANG] = ACTIONS(3492),
    [anon_sym_do_BANG] = ACTIONS(3492),
    [anon_sym_begin] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(3494),
    [anon_sym_STAR] = ACTIONS(3494),
    [anon_sym_LT2] = ACTIONS(3494),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3492),
    [anon_sym_default] = ACTIONS(3494),
    [anon_sym_or] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_member] = ACTIONS(3494),
    [anon_sym_interface] = ACTIONS(3494),
    [anon_sym_exception] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_val] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [aux_sym_char_token1] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3494),
    [anon_sym_DQUOTE] = ACTIONS(3494),
    [anon_sym_AT_DQUOTE] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [sym_bool] = ACTIONS(3494),
    [sym_unit] = ACTIONS(3492),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3494),
    [sym_op_identifier] = ACTIONS(3494),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_PLUS_DOT] = ACTIONS(3494),
    [anon_sym_DASH_DOT] = ACTIONS(3494),
    [anon_sym_PERCENT] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_TILDE] = ACTIONS(3492),
    [aux_sym_prefix_op_token1] = ACTIONS(3494),
    [aux_sym_infix_op_token1] = ACTIONS(3492),
    [aux_sym_infix_op_token2] = ACTIONS(3494),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_COLON_EQ] = ACTIONS(3492),
    [anon_sym_DOLLAR] = ACTIONS(3494),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3494),
    [sym_int] = ACTIONS(3494),
    [sym_xint] = ACTIONS(3492),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3492),
    [anon_sym_POUNDload] = ACTIONS(3492),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3492),
    [sym__newline] = ACTIONS(3492),
  },
  [1212] = {
    [sym_block_comment] = STATE(1212),
    [sym_compiler_directive_decl] = STATE(1212),
    [sym_fsi_directive_decl] = STATE(1212),
    [sym_preproc_line] = STATE(1212),
    [aux_sym_type_argument_repeat1] = STATE(1208),
    [ts_builtin_sym_end] = ACTIONS(3496),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_namespace] = ACTIONS(3498),
    [anon_sym_module] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_open] = ACTIONS(3498),
    [anon_sym_LBRACK_LT] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_type] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_and] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [aux_sym_access_modifier_token1] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_with] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [anon_sym_DOT_LBRACK] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_default] = ACTIONS(3498),
    [anon_sym_or] = ACTIONS(3500),
    [anon_sym_static] = ACTIONS(3498),
    [anon_sym_member] = ACTIONS(3498),
    [anon_sym_interface] = ACTIONS(3498),
    [anon_sym_exception] = ACTIONS(3498),
    [anon_sym_abstract] = ACTIONS(3498),
    [anon_sym_val] = ACTIONS(3498),
    [anon_sym_override] = ACTIONS(3498),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3498),
    [anon_sym_DASH_DOT] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3498),
    [aux_sym_infix_op_token1] = ACTIONS(3496),
    [aux_sym_infix_op_token2] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_COLON_EQ] = ACTIONS(3496),
    [anon_sym_DOLLAR] = ACTIONS(3498),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3498),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3496),
    [anon_sym_POUNDload] = ACTIONS(3496),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
  },
  [1213] = {
    [sym_block_comment] = STATE(1213),
    [sym_compiler_directive_decl] = STATE(1213),
    [sym_fsi_directive_decl] = STATE(1213),
    [sym_preproc_line] = STATE(1213),
    [ts_builtin_sym_end] = ACTIONS(3503),
    [sym_identifier] = ACTIONS(3505),
    [anon_sym_namespace] = ACTIONS(3505),
    [anon_sym_module] = ACTIONS(3505),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_open] = ACTIONS(3505),
    [anon_sym_LBRACK_LT] = ACTIONS(3503),
    [anon_sym_COLON] = ACTIONS(3505),
    [anon_sym_return] = ACTIONS(3505),
    [anon_sym_type] = ACTIONS(3505),
    [anon_sym_do] = ACTIONS(3505),
    [anon_sym_and] = ACTIONS(3505),
    [anon_sym_let] = ACTIONS(3505),
    [anon_sym_let_BANG] = ACTIONS(3503),
    [aux_sym_access_modifier_token1] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3505),
    [anon_sym_COMMA] = ACTIONS(3503),
    [anon_sym_null] = ACTIONS(3505),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_COLON_QMARK] = ACTIONS(3505),
    [anon_sym_COLON_COLON] = ACTIONS(3503),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3503),
    [anon_sym_LBRACE] = ACTIONS(3505),
    [anon_sym_LT_AT] = ACTIONS(3505),
    [anon_sym_LT_AT_AT] = ACTIONS(3505),
    [anon_sym_DOT] = ACTIONS(3505),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3503),
    [anon_sym_new] = ACTIONS(3505),
    [anon_sym_with] = ACTIONS(3505),
    [anon_sym_return_BANG] = ACTIONS(3503),
    [anon_sym_yield] = ACTIONS(3505),
    [anon_sym_yield_BANG] = ACTIONS(3503),
    [anon_sym_lazy] = ACTIONS(3505),
    [anon_sym_assert] = ACTIONS(3505),
    [anon_sym_upcast] = ACTIONS(3505),
    [anon_sym_downcast] = ACTIONS(3505),
    [anon_sym_COLON_GT] = ACTIONS(3503),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3503),
    [anon_sym_for] = ACTIONS(3505),
    [anon_sym_while] = ACTIONS(3505),
    [anon_sym_if] = ACTIONS(3505),
    [anon_sym_fun] = ACTIONS(3505),
    [anon_sym_DASH_GT] = ACTIONS(3505),
    [anon_sym_try] = ACTIONS(3505),
    [anon_sym_match] = ACTIONS(3505),
    [anon_sym_match_BANG] = ACTIONS(3503),
    [anon_sym_function] = ACTIONS(3505),
    [anon_sym_LT_DASH] = ACTIONS(3505),
    [anon_sym_DOT_LBRACK] = ACTIONS(3503),
    [anon_sym_LT] = ACTIONS(3503),
    [anon_sym_use] = ACTIONS(3505),
    [anon_sym_use_BANG] = ACTIONS(3503),
    [anon_sym_do_BANG] = ACTIONS(3503),
    [anon_sym_begin] = ACTIONS(3505),
    [anon_sym_LPAREN2] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3505),
    [anon_sym_LT2] = ACTIONS(3507),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_default] = ACTIONS(3505),
    [anon_sym_or] = ACTIONS(3505),
    [anon_sym_static] = ACTIONS(3505),
    [anon_sym_member] = ACTIONS(3505),
    [anon_sym_interface] = ACTIONS(3505),
    [anon_sym_exception] = ACTIONS(3505),
    [anon_sym_abstract] = ACTIONS(3505),
    [anon_sym_val] = ACTIONS(3505),
    [anon_sym_override] = ACTIONS(3505),
    [aux_sym_char_token1] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3505),
    [anon_sym_DQUOTE] = ACTIONS(3505),
    [anon_sym_AT_DQUOTE] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [sym_bool] = ACTIONS(3505),
    [sym_unit] = ACTIONS(3503),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3505),
    [sym_op_identifier] = ACTIONS(3505),
    [anon_sym_PLUS] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3505),
    [anon_sym_PLUS_DOT] = ACTIONS(3505),
    [anon_sym_DASH_DOT] = ACTIONS(3505),
    [anon_sym_PERCENT] = ACTIONS(3505),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3503),
    [aux_sym_prefix_op_token1] = ACTIONS(3505),
    [aux_sym_infix_op_token1] = ACTIONS(3503),
    [aux_sym_infix_op_token2] = ACTIONS(3505),
    [anon_sym_PIPE_PIPE] = ACTIONS(3505),
    [anon_sym_BANG_EQ] = ACTIONS(3505),
    [anon_sym_COLON_EQ] = ACTIONS(3503),
    [anon_sym_DOLLAR] = ACTIONS(3505),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3505),
    [sym_int] = ACTIONS(3505),
    [sym_xint] = ACTIONS(3503),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3503),
    [anon_sym_POUNDload] = ACTIONS(3503),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3503),
    [sym__newline] = ACTIONS(3503),
  },
  [1214] = {
    [sym_block_comment] = STATE(1214),
    [sym_compiler_directive_decl] = STATE(1214),
    [sym_fsi_directive_decl] = STATE(1214),
    [sym_preproc_line] = STATE(1214),
    [ts_builtin_sym_end] = ACTIONS(3509),
    [sym_identifier] = ACTIONS(3511),
    [anon_sym_namespace] = ACTIONS(3511),
    [anon_sym_module] = ACTIONS(3511),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_open] = ACTIONS(3511),
    [anon_sym_LBRACK_LT] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3511),
    [anon_sym_return] = ACTIONS(3511),
    [anon_sym_type] = ACTIONS(3511),
    [anon_sym_do] = ACTIONS(3511),
    [anon_sym_and] = ACTIONS(3511),
    [anon_sym_let] = ACTIONS(3511),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [aux_sym_access_modifier_token1] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3511),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3511),
    [anon_sym_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(3511),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_LT_AT] = ACTIONS(3511),
    [anon_sym_LT_AT_AT] = ACTIONS(3511),
    [anon_sym_DOT] = ACTIONS(3511),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3511),
    [anon_sym_with] = ACTIONS(3511),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3511),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3511),
    [anon_sym_assert] = ACTIONS(3511),
    [anon_sym_upcast] = ACTIONS(3511),
    [anon_sym_downcast] = ACTIONS(3511),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3511),
    [anon_sym_while] = ACTIONS(3511),
    [anon_sym_if] = ACTIONS(3511),
    [anon_sym_fun] = ACTIONS(3511),
    [anon_sym_DASH_GT] = ACTIONS(3511),
    [anon_sym_try] = ACTIONS(3511),
    [anon_sym_match] = ACTIONS(3511),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3511),
    [anon_sym_LT_DASH] = ACTIONS(3511),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3511),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3511),
    [anon_sym_LPAREN2] = ACTIONS(3511),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_LT2] = ACTIONS(3511),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3509),
    [anon_sym_default] = ACTIONS(3511),
    [anon_sym_or] = ACTIONS(3511),
    [anon_sym_static] = ACTIONS(3511),
    [anon_sym_member] = ACTIONS(3511),
    [anon_sym_interface] = ACTIONS(3511),
    [anon_sym_exception] = ACTIONS(3511),
    [anon_sym_abstract] = ACTIONS(3511),
    [anon_sym_val] = ACTIONS(3511),
    [anon_sym_override] = ACTIONS(3511),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3511),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3511),
    [sym_unit] = ACTIONS(3509),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3511),
    [sym_op_identifier] = ACTIONS(3511),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3511),
    [anon_sym_PLUS_DOT] = ACTIONS(3511),
    [anon_sym_DASH_DOT] = ACTIONS(3511),
    [anon_sym_PERCENT] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3511),
    [aux_sym_infix_op_token1] = ACTIONS(3509),
    [aux_sym_infix_op_token2] = ACTIONS(3511),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_BANG_EQ] = ACTIONS(3511),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3511),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3511),
    [sym_int] = ACTIONS(3511),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3509),
    [anon_sym_POUNDload] = ACTIONS(3509),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [1215] = {
    [sym_block_comment] = STATE(1215),
    [sym_compiler_directive_decl] = STATE(1215),
    [sym_fsi_directive_decl] = STATE(1215),
    [sym_preproc_line] = STATE(1215),
    [ts_builtin_sym_end] = ACTIONS(3513),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_namespace] = ACTIONS(3515),
    [anon_sym_module] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_open] = ACTIONS(3515),
    [anon_sym_LBRACK_LT] = ACTIONS(3513),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_type] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_and] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [aux_sym_access_modifier_token1] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_COLON] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_with] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(3513),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_LT_DASH] = ACTIONS(3515),
    [anon_sym_DOT_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3515),
    [anon_sym_or] = ACTIONS(3515),
    [anon_sym_static] = ACTIONS(3515),
    [anon_sym_member] = ACTIONS(3515),
    [anon_sym_interface] = ACTIONS(3515),
    [anon_sym_exception] = ACTIONS(3515),
    [anon_sym_abstract] = ACTIONS(3515),
    [anon_sym_val] = ACTIONS(3515),
    [anon_sym_override] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3515),
    [anon_sym_DASH_DOT] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3515),
    [aux_sym_infix_op_token1] = ACTIONS(3513),
    [aux_sym_infix_op_token2] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3515),
    [anon_sym_COLON_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(3515),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3515),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3513),
    [anon_sym_POUNDload] = ACTIONS(3513),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
  },
  [1216] = {
    [sym_block_comment] = STATE(1216),
    [sym_compiler_directive_decl] = STATE(1216),
    [sym_fsi_directive_decl] = STATE(1216),
    [sym_preproc_line] = STATE(1216),
    [ts_builtin_sym_end] = ACTIONS(3517),
    [sym_identifier] = ACTIONS(3519),
    [anon_sym_namespace] = ACTIONS(3519),
    [anon_sym_module] = ACTIONS(3519),
    [anon_sym_EQ] = ACTIONS(3517),
    [anon_sym_open] = ACTIONS(3519),
    [anon_sym_LBRACK_LT] = ACTIONS(3517),
    [anon_sym_COLON] = ACTIONS(3519),
    [anon_sym_return] = ACTIONS(3519),
    [anon_sym_type] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(3519),
    [anon_sym_and] = ACTIONS(3519),
    [anon_sym_let] = ACTIONS(3519),
    [anon_sym_let_BANG] = ACTIONS(3517),
    [aux_sym_access_modifier_token1] = ACTIONS(3517),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [anon_sym_COMMA] = ACTIONS(3517),
    [anon_sym_null] = ACTIONS(3519),
    [anon_sym_QMARK] = ACTIONS(3519),
    [anon_sym_COLON_QMARK] = ACTIONS(3519),
    [anon_sym_COLON_COLON] = ACTIONS(3517),
    [anon_sym_AMP] = ACTIONS(3519),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_LT_AT] = ACTIONS(3519),
    [anon_sym_LT_AT_AT] = ACTIONS(3519),
    [anon_sym_DOT] = ACTIONS(3519),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3519),
    [anon_sym_with] = ACTIONS(3519),
    [anon_sym_return_BANG] = ACTIONS(3517),
    [anon_sym_yield] = ACTIONS(3519),
    [anon_sym_yield_BANG] = ACTIONS(3517),
    [anon_sym_lazy] = ACTIONS(3519),
    [anon_sym_assert] = ACTIONS(3519),
    [anon_sym_upcast] = ACTIONS(3519),
    [anon_sym_downcast] = ACTIONS(3519),
    [anon_sym_COLON_GT] = ACTIONS(3517),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3517),
    [anon_sym_for] = ACTIONS(3519),
    [anon_sym_while] = ACTIONS(3519),
    [anon_sym_if] = ACTIONS(3519),
    [anon_sym_fun] = ACTIONS(3519),
    [anon_sym_DASH_GT] = ACTIONS(3519),
    [anon_sym_try] = ACTIONS(3519),
    [anon_sym_match] = ACTIONS(3519),
    [anon_sym_match_BANG] = ACTIONS(3517),
    [anon_sym_function] = ACTIONS(3519),
    [anon_sym_LT_DASH] = ACTIONS(3519),
    [anon_sym_DOT_LBRACK] = ACTIONS(3517),
    [anon_sym_LT] = ACTIONS(3517),
    [anon_sym_use] = ACTIONS(3519),
    [anon_sym_use_BANG] = ACTIONS(3517),
    [anon_sym_do_BANG] = ACTIONS(3517),
    [anon_sym_begin] = ACTIONS(3519),
    [anon_sym_LPAREN2] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_LT2] = ACTIONS(3519),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3517),
    [anon_sym_default] = ACTIONS(3519),
    [anon_sym_or] = ACTIONS(3519),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_member] = ACTIONS(3519),
    [anon_sym_interface] = ACTIONS(3519),
    [anon_sym_exception] = ACTIONS(3519),
    [anon_sym_abstract] = ACTIONS(3519),
    [anon_sym_val] = ACTIONS(3519),
    [anon_sym_override] = ACTIONS(3519),
    [aux_sym_char_token1] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [anon_sym_AT_DQUOTE] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [sym_bool] = ACTIONS(3519),
    [sym_unit] = ACTIONS(3517),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3519),
    [sym_op_identifier] = ACTIONS(3519),
    [anon_sym_PLUS] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_DOT] = ACTIONS(3519),
    [anon_sym_DASH_DOT] = ACTIONS(3519),
    [anon_sym_PERCENT] = ACTIONS(3519),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3517),
    [aux_sym_prefix_op_token1] = ACTIONS(3519),
    [aux_sym_infix_op_token1] = ACTIONS(3517),
    [aux_sym_infix_op_token2] = ACTIONS(3519),
    [anon_sym_PIPE_PIPE] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_COLON_EQ] = ACTIONS(3517),
    [anon_sym_DOLLAR] = ACTIONS(3519),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3519),
    [sym_int] = ACTIONS(3519),
    [sym_xint] = ACTIONS(3517),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3517),
    [anon_sym_POUNDload] = ACTIONS(3517),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3517),
    [sym__newline] = ACTIONS(3517),
  },
  [1217] = {
    [sym_block_comment] = STATE(1217),
    [sym_compiler_directive_decl] = STATE(1217),
    [sym_fsi_directive_decl] = STATE(1217),
    [sym_preproc_line] = STATE(1217),
    [ts_builtin_sym_end] = ACTIONS(3521),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_namespace] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(3521),
    [anon_sym_open] = ACTIONS(3523),
    [anon_sym_LBRACK_LT] = ACTIONS(3521),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_type] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_and] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3521),
    [aux_sym_access_modifier_token1] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_COMMA] = ACTIONS(3521),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_COLON] = ACTIONS(3521),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_with] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3521),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3521),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_COLON_GT] = ACTIONS(3521),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_DASH_GT] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3521),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_LT_DASH] = ACTIONS(3523),
    [anon_sym_DOT_LBRACK] = ACTIONS(3521),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3521),
    [anon_sym_do_BANG] = ACTIONS(3521),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_LPAREN2] = ACTIONS(3523),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_LT2] = ACTIONS(3523),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3521),
    [anon_sym_default] = ACTIONS(3523),
    [anon_sym_or] = ACTIONS(3523),
    [anon_sym_static] = ACTIONS(3523),
    [anon_sym_member] = ACTIONS(3523),
    [anon_sym_interface] = ACTIONS(3523),
    [anon_sym_exception] = ACTIONS(3523),
    [anon_sym_abstract] = ACTIONS(3523),
    [anon_sym_val] = ACTIONS(3523),
    [anon_sym_override] = ACTIONS(3523),
    [aux_sym_char_token1] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3521),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3523),
    [anon_sym_DASH_DOT] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3521),
    [aux_sym_prefix_op_token1] = ACTIONS(3523),
    [aux_sym_infix_op_token1] = ACTIONS(3521),
    [aux_sym_infix_op_token2] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3523),
    [anon_sym_COLON_EQ] = ACTIONS(3521),
    [anon_sym_DOLLAR] = ACTIONS(3523),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3523),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3521),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3521),
    [anon_sym_POUNDload] = ACTIONS(3521),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3521),
    [sym__newline] = ACTIONS(3521),
  },
  [1218] = {
    [sym_block_comment] = STATE(1218),
    [sym_compiler_directive_decl] = STATE(1218),
    [sym_fsi_directive_decl] = STATE(1218),
    [sym_preproc_line] = STATE(1218),
    [ts_builtin_sym_end] = ACTIONS(3525),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_namespace] = ACTIONS(3527),
    [anon_sym_module] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3525),
    [anon_sym_open] = ACTIONS(3527),
    [anon_sym_LBRACK_LT] = ACTIONS(3525),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_type] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_and] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [aux_sym_access_modifier_token1] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_COLON] = ACTIONS(3525),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_with] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_COLON_GT] = ACTIONS(3525),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_DASH_GT] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_LT_DASH] = ACTIONS(3527),
    [anon_sym_DOT_LBRACK] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_LPAREN2] = ACTIONS(3527),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_LT2] = ACTIONS(3527),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_default] = ACTIONS(3527),
    [anon_sym_or] = ACTIONS(3527),
    [anon_sym_static] = ACTIONS(3527),
    [anon_sym_member] = ACTIONS(3527),
    [anon_sym_interface] = ACTIONS(3527),
    [anon_sym_exception] = ACTIONS(3527),
    [anon_sym_abstract] = ACTIONS(3527),
    [anon_sym_val] = ACTIONS(3527),
    [anon_sym_override] = ACTIONS(3527),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3525),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3527),
    [anon_sym_DASH_DOT] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3527),
    [aux_sym_infix_op_token1] = ACTIONS(3525),
    [aux_sym_infix_op_token2] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_COLON_EQ] = ACTIONS(3525),
    [anon_sym_DOLLAR] = ACTIONS(3527),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3527),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3525),
    [anon_sym_POUNDload] = ACTIONS(3525),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3525),
    [sym__newline] = ACTIONS(3525),
  },
  [1219] = {
    [sym_block_comment] = STATE(1219),
    [sym_compiler_directive_decl] = STATE(1219),
    [sym_fsi_directive_decl] = STATE(1219),
    [sym_preproc_line] = STATE(1219),
    [ts_builtin_sym_end] = ACTIONS(3529),
    [sym_identifier] = ACTIONS(3531),
    [anon_sym_namespace] = ACTIONS(3531),
    [anon_sym_module] = ACTIONS(3531),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_open] = ACTIONS(3531),
    [anon_sym_LBRACK_LT] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(3531),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_type] = ACTIONS(3531),
    [anon_sym_do] = ACTIONS(3531),
    [anon_sym_and] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [aux_sym_access_modifier_token1] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_null] = ACTIONS(3531),
    [anon_sym_QMARK] = ACTIONS(3531),
    [anon_sym_COLON_QMARK] = ACTIONS(3531),
    [anon_sym_COLON_COLON] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3531),
    [anon_sym_LT_AT] = ACTIONS(3531),
    [anon_sym_LT_AT_AT] = ACTIONS(3531),
    [anon_sym_DOT] = ACTIONS(3531),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3531),
    [anon_sym_with] = ACTIONS(3531),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3531),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3531),
    [anon_sym_assert] = ACTIONS(3531),
    [anon_sym_upcast] = ACTIONS(3531),
    [anon_sym_downcast] = ACTIONS(3531),
    [anon_sym_COLON_GT] = ACTIONS(3529),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3531),
    [anon_sym_while] = ACTIONS(3531),
    [anon_sym_if] = ACTIONS(3531),
    [anon_sym_fun] = ACTIONS(3531),
    [anon_sym_DASH_GT] = ACTIONS(3531),
    [anon_sym_try] = ACTIONS(3531),
    [anon_sym_match] = ACTIONS(3531),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3531),
    [anon_sym_LT_DASH] = ACTIONS(3531),
    [anon_sym_DOT_LBRACK] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_use] = ACTIONS(3531),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3531),
    [anon_sym_LPAREN2] = ACTIONS(3531),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LT2] = ACTIONS(3531),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_default] = ACTIONS(3531),
    [anon_sym_or] = ACTIONS(3531),
    [anon_sym_static] = ACTIONS(3531),
    [anon_sym_member] = ACTIONS(3531),
    [anon_sym_interface] = ACTIONS(3531),
    [anon_sym_exception] = ACTIONS(3531),
    [anon_sym_abstract] = ACTIONS(3531),
    [anon_sym_val] = ACTIONS(3531),
    [anon_sym_override] = ACTIONS(3531),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3531),
    [anon_sym_DQUOTE] = ACTIONS(3531),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3531),
    [sym_unit] = ACTIONS(3529),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3531),
    [sym_op_identifier] = ACTIONS(3531),
    [anon_sym_PLUS] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(3531),
    [anon_sym_PLUS_DOT] = ACTIONS(3531),
    [anon_sym_DASH_DOT] = ACTIONS(3531),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_AMP_AMP] = ACTIONS(3531),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3531),
    [aux_sym_infix_op_token1] = ACTIONS(3529),
    [aux_sym_infix_op_token2] = ACTIONS(3531),
    [anon_sym_PIPE_PIPE] = ACTIONS(3531),
    [anon_sym_BANG_EQ] = ACTIONS(3531),
    [anon_sym_COLON_EQ] = ACTIONS(3529),
    [anon_sym_DOLLAR] = ACTIONS(3531),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3531),
    [sym_int] = ACTIONS(3531),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3529),
    [anon_sym_POUNDload] = ACTIONS(3529),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [sym__newline] = ACTIONS(3529),
  },
  [1220] = {
    [sym_block_comment] = STATE(1220),
    [sym_compiler_directive_decl] = STATE(1220),
    [sym_fsi_directive_decl] = STATE(1220),
    [sym_preproc_line] = STATE(1220),
    [ts_builtin_sym_end] = ACTIONS(3533),
    [sym_identifier] = ACTIONS(3535),
    [anon_sym_namespace] = ACTIONS(3535),
    [anon_sym_module] = ACTIONS(3535),
    [anon_sym_EQ] = ACTIONS(3533),
    [anon_sym_open] = ACTIONS(3535),
    [anon_sym_LBRACK_LT] = ACTIONS(3533),
    [anon_sym_COLON] = ACTIONS(3535),
    [anon_sym_return] = ACTIONS(3535),
    [anon_sym_type] = ACTIONS(3535),
    [anon_sym_do] = ACTIONS(3535),
    [anon_sym_and] = ACTIONS(3535),
    [anon_sym_let] = ACTIONS(3535),
    [anon_sym_let_BANG] = ACTIONS(3533),
    [aux_sym_access_modifier_token1] = ACTIONS(3533),
    [anon_sym_LPAREN] = ACTIONS(3535),
    [anon_sym_COMMA] = ACTIONS(3533),
    [anon_sym_null] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(3535),
    [anon_sym_COLON_QMARK] = ACTIONS(3535),
    [anon_sym_COLON_COLON] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3533),
    [anon_sym_LBRACE] = ACTIONS(3535),
    [anon_sym_LT_AT] = ACTIONS(3535),
    [anon_sym_LT_AT_AT] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(3535),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3533),
    [anon_sym_new] = ACTIONS(3535),
    [anon_sym_with] = ACTIONS(3535),
    [anon_sym_return_BANG] = ACTIONS(3533),
    [anon_sym_yield] = ACTIONS(3535),
    [anon_sym_yield_BANG] = ACTIONS(3533),
    [anon_sym_lazy] = ACTIONS(3535),
    [anon_sym_assert] = ACTIONS(3535),
    [anon_sym_upcast] = ACTIONS(3535),
    [anon_sym_downcast] = ACTIONS(3535),
    [anon_sym_COLON_GT] = ACTIONS(3533),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3533),
    [anon_sym_for] = ACTIONS(3535),
    [anon_sym_while] = ACTIONS(3535),
    [anon_sym_if] = ACTIONS(3535),
    [anon_sym_fun] = ACTIONS(3535),
    [anon_sym_DASH_GT] = ACTIONS(3535),
    [anon_sym_try] = ACTIONS(3535),
    [anon_sym_match] = ACTIONS(3535),
    [anon_sym_match_BANG] = ACTIONS(3533),
    [anon_sym_function] = ACTIONS(3535),
    [anon_sym_LT_DASH] = ACTIONS(3535),
    [anon_sym_DOT_LBRACK] = ACTIONS(3533),
    [anon_sym_LT] = ACTIONS(3533),
    [anon_sym_use] = ACTIONS(3535),
    [anon_sym_use_BANG] = ACTIONS(3533),
    [anon_sym_do_BANG] = ACTIONS(3533),
    [anon_sym_begin] = ACTIONS(3535),
    [anon_sym_LPAREN2] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(3535),
    [anon_sym_LT2] = ACTIONS(3535),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3533),
    [anon_sym_default] = ACTIONS(3535),
    [anon_sym_or] = ACTIONS(3535),
    [anon_sym_static] = ACTIONS(3535),
    [anon_sym_member] = ACTIONS(3535),
    [anon_sym_interface] = ACTIONS(3535),
    [anon_sym_exception] = ACTIONS(3535),
    [anon_sym_abstract] = ACTIONS(3535),
    [anon_sym_val] = ACTIONS(3535),
    [anon_sym_override] = ACTIONS(3535),
    [aux_sym_char_token1] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE] = ACTIONS(3535),
    [anon_sym_AT_DQUOTE] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [sym_bool] = ACTIONS(3535),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3535),
    [sym_op_identifier] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS_DOT] = ACTIONS(3535),
    [anon_sym_DASH_DOT] = ACTIONS(3535),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(3535),
    [anon_sym_TILDE] = ACTIONS(3533),
    [aux_sym_prefix_op_token1] = ACTIONS(3535),
    [aux_sym_infix_op_token1] = ACTIONS(3533),
    [aux_sym_infix_op_token2] = ACTIONS(3535),
    [anon_sym_PIPE_PIPE] = ACTIONS(3535),
    [anon_sym_BANG_EQ] = ACTIONS(3535),
    [anon_sym_COLON_EQ] = ACTIONS(3533),
    [anon_sym_DOLLAR] = ACTIONS(3535),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3535),
    [sym_int] = ACTIONS(3535),
    [sym_xint] = ACTIONS(3533),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3533),
    [anon_sym_POUNDload] = ACTIONS(3533),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3533),
    [sym__newline] = ACTIONS(3533),
  },
  [1221] = {
    [sym_block_comment] = STATE(1221),
    [sym_compiler_directive_decl] = STATE(1221),
    [sym_fsi_directive_decl] = STATE(1221),
    [sym_preproc_line] = STATE(1221),
    [ts_builtin_sym_end] = ACTIONS(3485),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_namespace] = ACTIONS(3487),
    [anon_sym_module] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_open] = ACTIONS(3487),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_type] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_and] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [aux_sym_access_modifier_token1] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_member] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_exception] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_val] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3485),
    [anon_sym_POUNDload] = ACTIONS(3485),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [1222] = {
    [sym_block_comment] = STATE(1222),
    [sym_compiler_directive_decl] = STATE(1222),
    [sym_fsi_directive_decl] = STATE(1222),
    [sym_preproc_line] = STATE(1222),
    [ts_builtin_sym_end] = ACTIONS(3537),
    [sym_identifier] = ACTIONS(3539),
    [anon_sym_namespace] = ACTIONS(3539),
    [anon_sym_module] = ACTIONS(3539),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_open] = ACTIONS(3539),
    [anon_sym_LBRACK_LT] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3539),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_type] = ACTIONS(3539),
    [anon_sym_do] = ACTIONS(3539),
    [anon_sym_and] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3539),
    [anon_sym_let_BANG] = ACTIONS(3537),
    [aux_sym_access_modifier_token1] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_null] = ACTIONS(3539),
    [anon_sym_QMARK] = ACTIONS(3539),
    [anon_sym_COLON_QMARK] = ACTIONS(3539),
    [anon_sym_COLON_COLON] = ACTIONS(3537),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3537),
    [anon_sym_LBRACE] = ACTIONS(3539),
    [anon_sym_LT_AT] = ACTIONS(3539),
    [anon_sym_LT_AT_AT] = ACTIONS(3539),
    [anon_sym_DOT] = ACTIONS(3539),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3537),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_with] = ACTIONS(3539),
    [anon_sym_return_BANG] = ACTIONS(3537),
    [anon_sym_yield] = ACTIONS(3539),
    [anon_sym_yield_BANG] = ACTIONS(3537),
    [anon_sym_lazy] = ACTIONS(3539),
    [anon_sym_assert] = ACTIONS(3539),
    [anon_sym_upcast] = ACTIONS(3539),
    [anon_sym_downcast] = ACTIONS(3539),
    [anon_sym_COLON_GT] = ACTIONS(3537),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3537),
    [anon_sym_for] = ACTIONS(3539),
    [anon_sym_while] = ACTIONS(3539),
    [anon_sym_if] = ACTIONS(3539),
    [anon_sym_fun] = ACTIONS(3539),
    [anon_sym_DASH_GT] = ACTIONS(3539),
    [anon_sym_try] = ACTIONS(3539),
    [anon_sym_match] = ACTIONS(3539),
    [anon_sym_match_BANG] = ACTIONS(3537),
    [anon_sym_function] = ACTIONS(3539),
    [anon_sym_LT_DASH] = ACTIONS(3539),
    [anon_sym_DOT_LBRACK] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_use] = ACTIONS(3539),
    [anon_sym_use_BANG] = ACTIONS(3537),
    [anon_sym_do_BANG] = ACTIONS(3537),
    [anon_sym_begin] = ACTIONS(3539),
    [anon_sym_LPAREN2] = ACTIONS(3539),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_LT2] = ACTIONS(3539),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_default] = ACTIONS(3539),
    [anon_sym_or] = ACTIONS(3539),
    [anon_sym_static] = ACTIONS(3539),
    [anon_sym_member] = ACTIONS(3539),
    [anon_sym_interface] = ACTIONS(3539),
    [anon_sym_exception] = ACTIONS(3539),
    [anon_sym_abstract] = ACTIONS(3539),
    [anon_sym_val] = ACTIONS(3539),
    [anon_sym_override] = ACTIONS(3539),
    [aux_sym_char_token1] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3539),
    [anon_sym_DQUOTE] = ACTIONS(3539),
    [anon_sym_AT_DQUOTE] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [sym_bool] = ACTIONS(3539),
    [sym_unit] = ACTIONS(3537),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3539),
    [sym_op_identifier] = ACTIONS(3539),
    [anon_sym_PLUS] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(3539),
    [anon_sym_PLUS_DOT] = ACTIONS(3539),
    [anon_sym_DASH_DOT] = ACTIONS(3539),
    [anon_sym_PERCENT] = ACTIONS(3539),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_TILDE] = ACTIONS(3537),
    [aux_sym_prefix_op_token1] = ACTIONS(3539),
    [aux_sym_infix_op_token1] = ACTIONS(3537),
    [aux_sym_infix_op_token2] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3539),
    [anon_sym_BANG_EQ] = ACTIONS(3539),
    [anon_sym_COLON_EQ] = ACTIONS(3537),
    [anon_sym_DOLLAR] = ACTIONS(3539),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3539),
    [sym_int] = ACTIONS(3539),
    [sym_xint] = ACTIONS(3537),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3537),
    [anon_sym_POUNDload] = ACTIONS(3537),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3537),
    [sym__newline] = ACTIONS(3537),
  },
  [1223] = {
    [sym_block_comment] = STATE(1223),
    [sym_compiler_directive_decl] = STATE(1223),
    [sym_fsi_directive_decl] = STATE(1223),
    [sym_preproc_line] = STATE(1223),
    [ts_builtin_sym_end] = ACTIONS(3541),
    [sym_identifier] = ACTIONS(3543),
    [anon_sym_namespace] = ACTIONS(3543),
    [anon_sym_module] = ACTIONS(3543),
    [anon_sym_EQ] = ACTIONS(3541),
    [anon_sym_open] = ACTIONS(3543),
    [anon_sym_LBRACK_LT] = ACTIONS(3541),
    [anon_sym_COLON] = ACTIONS(3543),
    [anon_sym_return] = ACTIONS(3543),
    [anon_sym_type] = ACTIONS(3543),
    [anon_sym_do] = ACTIONS(3543),
    [anon_sym_and] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3543),
    [anon_sym_let_BANG] = ACTIONS(3541),
    [aux_sym_access_modifier_token1] = ACTIONS(3541),
    [anon_sym_LPAREN] = ACTIONS(3543),
    [anon_sym_COMMA] = ACTIONS(3541),
    [anon_sym_null] = ACTIONS(3543),
    [anon_sym_QMARK] = ACTIONS(3543),
    [anon_sym_COLON_QMARK] = ACTIONS(3543),
    [anon_sym_COLON_COLON] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3543),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3541),
    [anon_sym_LBRACE] = ACTIONS(3543),
    [anon_sym_LT_AT] = ACTIONS(3543),
    [anon_sym_LT_AT_AT] = ACTIONS(3543),
    [anon_sym_DOT] = ACTIONS(3543),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3541),
    [anon_sym_new] = ACTIONS(3543),
    [anon_sym_with] = ACTIONS(3543),
    [anon_sym_return_BANG] = ACTIONS(3541),
    [anon_sym_yield] = ACTIONS(3543),
    [anon_sym_yield_BANG] = ACTIONS(3541),
    [anon_sym_lazy] = ACTIONS(3543),
    [anon_sym_assert] = ACTIONS(3543),
    [anon_sym_upcast] = ACTIONS(3543),
    [anon_sym_downcast] = ACTIONS(3543),
    [anon_sym_COLON_GT] = ACTIONS(3541),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3541),
    [anon_sym_for] = ACTIONS(3543),
    [anon_sym_while] = ACTIONS(3543),
    [anon_sym_if] = ACTIONS(3543),
    [anon_sym_fun] = ACTIONS(3543),
    [anon_sym_DASH_GT] = ACTIONS(3543),
    [anon_sym_try] = ACTIONS(3543),
    [anon_sym_match] = ACTIONS(3543),
    [anon_sym_match_BANG] = ACTIONS(3541),
    [anon_sym_function] = ACTIONS(3543),
    [anon_sym_LT_DASH] = ACTIONS(3543),
    [anon_sym_DOT_LBRACK] = ACTIONS(3541),
    [anon_sym_LT] = ACTIONS(3541),
    [anon_sym_use] = ACTIONS(3543),
    [anon_sym_use_BANG] = ACTIONS(3541),
    [anon_sym_do_BANG] = ACTIONS(3541),
    [anon_sym_begin] = ACTIONS(3543),
    [anon_sym_LPAREN2] = ACTIONS(3543),
    [anon_sym_STAR] = ACTIONS(3543),
    [anon_sym_LT2] = ACTIONS(3543),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_default] = ACTIONS(3543),
    [anon_sym_or] = ACTIONS(3543),
    [anon_sym_static] = ACTIONS(3543),
    [anon_sym_member] = ACTIONS(3543),
    [anon_sym_interface] = ACTIONS(3543),
    [anon_sym_exception] = ACTIONS(3543),
    [anon_sym_abstract] = ACTIONS(3543),
    [anon_sym_val] = ACTIONS(3543),
    [anon_sym_override] = ACTIONS(3543),
    [aux_sym_char_token1] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3543),
    [anon_sym_DQUOTE] = ACTIONS(3543),
    [anon_sym_AT_DQUOTE] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [sym_bool] = ACTIONS(3543),
    [sym_unit] = ACTIONS(3541),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3543),
    [sym_op_identifier] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(3543),
    [anon_sym_DASH] = ACTIONS(3543),
    [anon_sym_PLUS_DOT] = ACTIONS(3543),
    [anon_sym_DASH_DOT] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3543),
    [anon_sym_AMP_AMP] = ACTIONS(3543),
    [anon_sym_TILDE] = ACTIONS(3541),
    [aux_sym_prefix_op_token1] = ACTIONS(3543),
    [aux_sym_infix_op_token1] = ACTIONS(3541),
    [aux_sym_infix_op_token2] = ACTIONS(3543),
    [anon_sym_PIPE_PIPE] = ACTIONS(3543),
    [anon_sym_BANG_EQ] = ACTIONS(3543),
    [anon_sym_COLON_EQ] = ACTIONS(3541),
    [anon_sym_DOLLAR] = ACTIONS(3543),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3543),
    [sym_int] = ACTIONS(3543),
    [sym_xint] = ACTIONS(3541),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3541),
    [anon_sym_POUNDload] = ACTIONS(3541),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3541),
    [sym__newline] = ACTIONS(3541),
  },
  [1224] = {
    [sym_block_comment] = STATE(1224),
    [sym_compiler_directive_decl] = STATE(1224),
    [sym_fsi_directive_decl] = STATE(1224),
    [sym_preproc_line] = STATE(1224),
    [ts_builtin_sym_end] = ACTIONS(3545),
    [sym_identifier] = ACTIONS(3547),
    [anon_sym_namespace] = ACTIONS(3547),
    [anon_sym_module] = ACTIONS(3547),
    [anon_sym_EQ] = ACTIONS(3545),
    [anon_sym_open] = ACTIONS(3547),
    [anon_sym_LBRACK_LT] = ACTIONS(3545),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_return] = ACTIONS(3547),
    [anon_sym_type] = ACTIONS(3547),
    [anon_sym_do] = ACTIONS(3547),
    [anon_sym_and] = ACTIONS(3547),
    [anon_sym_let] = ACTIONS(3547),
    [anon_sym_let_BANG] = ACTIONS(3545),
    [aux_sym_access_modifier_token1] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(3547),
    [anon_sym_COMMA] = ACTIONS(3545),
    [anon_sym_null] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3547),
    [anon_sym_COLON_QMARK] = ACTIONS(3547),
    [anon_sym_COLON_COLON] = ACTIONS(3545),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3545),
    [anon_sym_LBRACE] = ACTIONS(3547),
    [anon_sym_LT_AT] = ACTIONS(3547),
    [anon_sym_LT_AT_AT] = ACTIONS(3547),
    [anon_sym_DOT] = ACTIONS(3547),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3545),
    [anon_sym_new] = ACTIONS(3547),
    [anon_sym_with] = ACTIONS(3547),
    [anon_sym_return_BANG] = ACTIONS(3545),
    [anon_sym_yield] = ACTIONS(3547),
    [anon_sym_yield_BANG] = ACTIONS(3545),
    [anon_sym_lazy] = ACTIONS(3547),
    [anon_sym_assert] = ACTIONS(3547),
    [anon_sym_upcast] = ACTIONS(3547),
    [anon_sym_downcast] = ACTIONS(3547),
    [anon_sym_COLON_GT] = ACTIONS(3545),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3545),
    [anon_sym_for] = ACTIONS(3547),
    [anon_sym_while] = ACTIONS(3547),
    [anon_sym_if] = ACTIONS(3547),
    [anon_sym_fun] = ACTIONS(3547),
    [anon_sym_DASH_GT] = ACTIONS(3547),
    [anon_sym_try] = ACTIONS(3547),
    [anon_sym_match] = ACTIONS(3547),
    [anon_sym_match_BANG] = ACTIONS(3545),
    [anon_sym_function] = ACTIONS(3547),
    [anon_sym_LT_DASH] = ACTIONS(3547),
    [anon_sym_DOT_LBRACK] = ACTIONS(3545),
    [anon_sym_LT] = ACTIONS(3545),
    [anon_sym_use] = ACTIONS(3547),
    [anon_sym_use_BANG] = ACTIONS(3545),
    [anon_sym_do_BANG] = ACTIONS(3545),
    [anon_sym_begin] = ACTIONS(3547),
    [anon_sym_LPAREN2] = ACTIONS(3547),
    [anon_sym_STAR] = ACTIONS(3547),
    [anon_sym_LT2] = ACTIONS(3547),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_default] = ACTIONS(3547),
    [anon_sym_or] = ACTIONS(3547),
    [anon_sym_static] = ACTIONS(3547),
    [anon_sym_member] = ACTIONS(3547),
    [anon_sym_interface] = ACTIONS(3547),
    [anon_sym_exception] = ACTIONS(3547),
    [anon_sym_abstract] = ACTIONS(3547),
    [anon_sym_val] = ACTIONS(3547),
    [anon_sym_override] = ACTIONS(3547),
    [aux_sym_char_token1] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3547),
    [anon_sym_DQUOTE] = ACTIONS(3547),
    [anon_sym_AT_DQUOTE] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [sym_bool] = ACTIONS(3547),
    [sym_unit] = ACTIONS(3545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3547),
    [sym_op_identifier] = ACTIONS(3547),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PLUS_DOT] = ACTIONS(3547),
    [anon_sym_DASH_DOT] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3547),
    [anon_sym_AMP_AMP] = ACTIONS(3547),
    [anon_sym_TILDE] = ACTIONS(3545),
    [aux_sym_prefix_op_token1] = ACTIONS(3547),
    [aux_sym_infix_op_token1] = ACTIONS(3545),
    [aux_sym_infix_op_token2] = ACTIONS(3547),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_BANG_EQ] = ACTIONS(3547),
    [anon_sym_COLON_EQ] = ACTIONS(3545),
    [anon_sym_DOLLAR] = ACTIONS(3547),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3547),
    [sym_int] = ACTIONS(3547),
    [sym_xint] = ACTIONS(3545),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3545),
    [anon_sym_POUNDload] = ACTIONS(3545),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3545),
    [sym__newline] = ACTIONS(3545),
  },
  [1225] = {
    [sym_block_comment] = STATE(1225),
    [sym_compiler_directive_decl] = STATE(1225),
    [sym_fsi_directive_decl] = STATE(1225),
    [sym_preproc_line] = STATE(1225),
    [ts_builtin_sym_end] = ACTIONS(3478),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_namespace] = ACTIONS(3480),
    [anon_sym_module] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_open] = ACTIONS(3480),
    [anon_sym_LBRACK_LT] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_type] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_and] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [aux_sym_access_modifier_token1] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_COLON] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_with] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_LT_DASH] = ACTIONS(3480),
    [anon_sym_DOT_LBRACK] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_default] = ACTIONS(3480),
    [anon_sym_or] = ACTIONS(3480),
    [anon_sym_static] = ACTIONS(3480),
    [anon_sym_member] = ACTIONS(3480),
    [anon_sym_interface] = ACTIONS(3480),
    [anon_sym_exception] = ACTIONS(3480),
    [anon_sym_abstract] = ACTIONS(3480),
    [anon_sym_val] = ACTIONS(3480),
    [anon_sym_override] = ACTIONS(3480),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3480),
    [anon_sym_DASH_DOT] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3480),
    [aux_sym_infix_op_token1] = ACTIONS(3478),
    [aux_sym_infix_op_token2] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3480),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3478),
    [anon_sym_POUNDload] = ACTIONS(3478),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
  },
  [1226] = {
    [sym_block_comment] = STATE(1226),
    [sym_compiler_directive_decl] = STATE(1226),
    [sym_fsi_directive_decl] = STATE(1226),
    [sym_preproc_line] = STATE(1226),
    [ts_builtin_sym_end] = ACTIONS(3549),
    [sym_identifier] = ACTIONS(3551),
    [anon_sym_namespace] = ACTIONS(3551),
    [anon_sym_module] = ACTIONS(3551),
    [anon_sym_EQ] = ACTIONS(3549),
    [anon_sym_open] = ACTIONS(3551),
    [anon_sym_LBRACK_LT] = ACTIONS(3549),
    [anon_sym_COLON] = ACTIONS(3551),
    [anon_sym_return] = ACTIONS(3551),
    [anon_sym_type] = ACTIONS(3551),
    [anon_sym_do] = ACTIONS(3551),
    [anon_sym_and] = ACTIONS(3551),
    [anon_sym_let] = ACTIONS(3551),
    [anon_sym_let_BANG] = ACTIONS(3549),
    [aux_sym_access_modifier_token1] = ACTIONS(3549),
    [anon_sym_LPAREN] = ACTIONS(3551),
    [anon_sym_COMMA] = ACTIONS(3549),
    [anon_sym_null] = ACTIONS(3551),
    [anon_sym_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_COLON] = ACTIONS(3549),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(3551),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3549),
    [anon_sym_LBRACE] = ACTIONS(3551),
    [anon_sym_LT_AT] = ACTIONS(3551),
    [anon_sym_LT_AT_AT] = ACTIONS(3551),
    [anon_sym_DOT] = ACTIONS(3551),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3549),
    [anon_sym_new] = ACTIONS(3551),
    [anon_sym_with] = ACTIONS(3551),
    [anon_sym_return_BANG] = ACTIONS(3549),
    [anon_sym_yield] = ACTIONS(3551),
    [anon_sym_yield_BANG] = ACTIONS(3549),
    [anon_sym_lazy] = ACTIONS(3551),
    [anon_sym_assert] = ACTIONS(3551),
    [anon_sym_upcast] = ACTIONS(3551),
    [anon_sym_downcast] = ACTIONS(3551),
    [anon_sym_COLON_GT] = ACTIONS(3549),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3549),
    [anon_sym_for] = ACTIONS(3551),
    [anon_sym_while] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(3551),
    [anon_sym_fun] = ACTIONS(3551),
    [anon_sym_DASH_GT] = ACTIONS(3551),
    [anon_sym_try] = ACTIONS(3551),
    [anon_sym_match] = ACTIONS(3551),
    [anon_sym_match_BANG] = ACTIONS(3549),
    [anon_sym_function] = ACTIONS(3551),
    [anon_sym_LT_DASH] = ACTIONS(3551),
    [anon_sym_DOT_LBRACK] = ACTIONS(3549),
    [anon_sym_LT] = ACTIONS(3549),
    [anon_sym_use] = ACTIONS(3551),
    [anon_sym_use_BANG] = ACTIONS(3549),
    [anon_sym_do_BANG] = ACTIONS(3549),
    [anon_sym_begin] = ACTIONS(3551),
    [anon_sym_LPAREN2] = ACTIONS(3551),
    [anon_sym_STAR] = ACTIONS(3551),
    [anon_sym_LT2] = ACTIONS(3551),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3549),
    [anon_sym_default] = ACTIONS(3551),
    [anon_sym_or] = ACTIONS(3551),
    [anon_sym_static] = ACTIONS(3551),
    [anon_sym_member] = ACTIONS(3551),
    [anon_sym_interface] = ACTIONS(3551),
    [anon_sym_exception] = ACTIONS(3551),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_val] = ACTIONS(3551),
    [anon_sym_override] = ACTIONS(3551),
    [aux_sym_char_token1] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [anon_sym_AT_DQUOTE] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [sym_bool] = ACTIONS(3551),
    [sym_unit] = ACTIONS(3549),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3551),
    [sym_op_identifier] = ACTIONS(3551),
    [anon_sym_PLUS] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(3551),
    [anon_sym_PLUS_DOT] = ACTIONS(3551),
    [anon_sym_DASH_DOT] = ACTIONS(3551),
    [anon_sym_PERCENT] = ACTIONS(3551),
    [anon_sym_AMP_AMP] = ACTIONS(3551),
    [anon_sym_TILDE] = ACTIONS(3549),
    [aux_sym_prefix_op_token1] = ACTIONS(3551),
    [aux_sym_infix_op_token1] = ACTIONS(3549),
    [aux_sym_infix_op_token2] = ACTIONS(3551),
    [anon_sym_PIPE_PIPE] = ACTIONS(3551),
    [anon_sym_BANG_EQ] = ACTIONS(3551),
    [anon_sym_COLON_EQ] = ACTIONS(3549),
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3551),
    [sym_int] = ACTIONS(3551),
    [sym_xint] = ACTIONS(3549),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3549),
    [anon_sym_POUNDload] = ACTIONS(3549),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3549),
    [sym__newline] = ACTIONS(3549),
  },
  [1227] = {
    [sym_elif_expression] = STATE(1274),
    [sym_block_comment] = STATE(1227),
    [sym_compiler_directive_decl] = STATE(1227),
    [sym_fsi_directive_decl] = STATE(1227),
    [sym_preproc_line] = STATE(1227),
    [aux_sym_if_expression_repeat1] = STATE(1227),
    [ts_builtin_sym_end] = ACTIONS(3553),
    [sym_identifier] = ACTIONS(3555),
    [anon_sym_namespace] = ACTIONS(3555),
    [anon_sym_module] = ACTIONS(3555),
    [anon_sym_EQ] = ACTIONS(3553),
    [anon_sym_open] = ACTIONS(3555),
    [anon_sym_LBRACK_LT] = ACTIONS(3553),
    [anon_sym_COLON] = ACTIONS(3555),
    [anon_sym_return] = ACTIONS(3555),
    [anon_sym_type] = ACTIONS(3555),
    [anon_sym_do] = ACTIONS(3555),
    [anon_sym_and] = ACTIONS(3555),
    [anon_sym_let] = ACTIONS(3555),
    [anon_sym_let_BANG] = ACTIONS(3553),
    [aux_sym_access_modifier_token1] = ACTIONS(3553),
    [anon_sym_LPAREN] = ACTIONS(3555),
    [anon_sym_COMMA] = ACTIONS(3553),
    [anon_sym_null] = ACTIONS(3555),
    [anon_sym_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_COLON] = ACTIONS(3553),
    [anon_sym_AMP] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(3555),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3553),
    [anon_sym_LBRACE] = ACTIONS(3555),
    [anon_sym_LT_AT] = ACTIONS(3555),
    [anon_sym_LT_AT_AT] = ACTIONS(3555),
    [anon_sym_DOT] = ACTIONS(3555),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3553),
    [anon_sym_new] = ACTIONS(3555),
    [anon_sym_with] = ACTIONS(3555),
    [anon_sym_return_BANG] = ACTIONS(3553),
    [anon_sym_yield] = ACTIONS(3555),
    [anon_sym_yield_BANG] = ACTIONS(3553),
    [anon_sym_lazy] = ACTIONS(3555),
    [anon_sym_assert] = ACTIONS(3555),
    [anon_sym_upcast] = ACTIONS(3555),
    [anon_sym_downcast] = ACTIONS(3555),
    [anon_sym_COLON_GT] = ACTIONS(3553),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3553),
    [anon_sym_for] = ACTIONS(3555),
    [anon_sym_while] = ACTIONS(3555),
    [anon_sym_else] = ACTIONS(3555),
    [anon_sym_elif] = ACTIONS(3557),
    [anon_sym_if] = ACTIONS(3555),
    [anon_sym_fun] = ACTIONS(3555),
    [anon_sym_try] = ACTIONS(3555),
    [anon_sym_match] = ACTIONS(3555),
    [anon_sym_match_BANG] = ACTIONS(3553),
    [anon_sym_function] = ACTIONS(3555),
    [anon_sym_LT_DASH] = ACTIONS(3555),
    [anon_sym_DOT_LBRACK] = ACTIONS(3553),
    [anon_sym_LT] = ACTIONS(3553),
    [anon_sym_use] = ACTIONS(3555),
    [anon_sym_use_BANG] = ACTIONS(3553),
    [anon_sym_do_BANG] = ACTIONS(3553),
    [anon_sym_begin] = ACTIONS(3555),
    [anon_sym_LPAREN2] = ACTIONS(3555),
    [anon_sym_default] = ACTIONS(3555),
    [anon_sym_or] = ACTIONS(3555),
    [anon_sym_static] = ACTIONS(3555),
    [anon_sym_member] = ACTIONS(3555),
    [anon_sym_interface] = ACTIONS(3555),
    [anon_sym_exception] = ACTIONS(3555),
    [anon_sym_abstract] = ACTIONS(3555),
    [anon_sym_val] = ACTIONS(3555),
    [anon_sym_override] = ACTIONS(3555),
    [aux_sym_char_token1] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3555),
    [anon_sym_DQUOTE] = ACTIONS(3555),
    [anon_sym_AT_DQUOTE] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [sym_bool] = ACTIONS(3555),
    [sym_unit] = ACTIONS(3553),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3555),
    [sym_op_identifier] = ACTIONS(3555),
    [anon_sym_PLUS] = ACTIONS(3555),
    [anon_sym_DASH] = ACTIONS(3555),
    [anon_sym_PLUS_DOT] = ACTIONS(3555),
    [anon_sym_DASH_DOT] = ACTIONS(3555),
    [anon_sym_PERCENT] = ACTIONS(3555),
    [anon_sym_AMP_AMP] = ACTIONS(3555),
    [anon_sym_TILDE] = ACTIONS(3553),
    [aux_sym_prefix_op_token1] = ACTIONS(3555),
    [aux_sym_infix_op_token1] = ACTIONS(3553),
    [aux_sym_infix_op_token2] = ACTIONS(3555),
    [anon_sym_PIPE_PIPE] = ACTIONS(3555),
    [anon_sym_BANG_EQ] = ACTIONS(3555),
    [anon_sym_COLON_EQ] = ACTIONS(3553),
    [anon_sym_DOLLAR] = ACTIONS(3555),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3555),
    [sym_int] = ACTIONS(3555),
    [sym_xint] = ACTIONS(3553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3553),
    [anon_sym_POUNDload] = ACTIONS(3553),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3553),
    [sym__newline] = ACTIONS(3553),
  },
  [1228] = {
    [sym_block_comment] = STATE(1228),
    [sym_compiler_directive_decl] = STATE(1228),
    [sym_fsi_directive_decl] = STATE(1228),
    [sym_preproc_line] = STATE(1228),
    [ts_builtin_sym_end] = ACTIONS(3513),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_namespace] = ACTIONS(3515),
    [anon_sym_module] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_open] = ACTIONS(3515),
    [anon_sym_LBRACK_LT] = ACTIONS(3513),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_type] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_and] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [aux_sym_access_modifier_token1] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_COLON] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_with] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(3513),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_LT_DASH] = ACTIONS(3515),
    [anon_sym_DOT_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3515),
    [anon_sym_or] = ACTIONS(3515),
    [anon_sym_static] = ACTIONS(3515),
    [anon_sym_member] = ACTIONS(3515),
    [anon_sym_interface] = ACTIONS(3515),
    [anon_sym_exception] = ACTIONS(3515),
    [anon_sym_abstract] = ACTIONS(3515),
    [anon_sym_val] = ACTIONS(3515),
    [anon_sym_override] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3515),
    [anon_sym_DASH_DOT] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3515),
    [aux_sym_infix_op_token1] = ACTIONS(3513),
    [aux_sym_infix_op_token2] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3515),
    [anon_sym_COLON_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(3515),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3515),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3513),
    [anon_sym_POUNDload] = ACTIONS(3513),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
  },
  [1229] = {
    [sym_block_comment] = STATE(1229),
    [sym_compiler_directive_decl] = STATE(1229),
    [sym_fsi_directive_decl] = STATE(1229),
    [sym_preproc_line] = STATE(1229),
    [ts_builtin_sym_end] = ACTIONS(3496),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_namespace] = ACTIONS(3498),
    [anon_sym_module] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_open] = ACTIONS(3498),
    [anon_sym_LBRACK_LT] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_type] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_and] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [aux_sym_access_modifier_token1] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_with] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [anon_sym_DOT_LBRACK] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_default] = ACTIONS(3498),
    [anon_sym_or] = ACTIONS(3498),
    [anon_sym_static] = ACTIONS(3498),
    [anon_sym_member] = ACTIONS(3498),
    [anon_sym_interface] = ACTIONS(3498),
    [anon_sym_exception] = ACTIONS(3498),
    [anon_sym_abstract] = ACTIONS(3498),
    [anon_sym_val] = ACTIONS(3498),
    [anon_sym_override] = ACTIONS(3498),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3498),
    [anon_sym_DASH_DOT] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3498),
    [aux_sym_infix_op_token1] = ACTIONS(3496),
    [aux_sym_infix_op_token2] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_COLON_EQ] = ACTIONS(3496),
    [anon_sym_DOLLAR] = ACTIONS(3498),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3498),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3496),
    [anon_sym_POUNDload] = ACTIONS(3496),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
  },
  [1230] = {
    [sym_block_comment] = STATE(1230),
    [sym_compiler_directive_decl] = STATE(1230),
    [sym_fsi_directive_decl] = STATE(1230),
    [sym_preproc_line] = STATE(1230),
    [ts_builtin_sym_end] = ACTIONS(3560),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_namespace] = ACTIONS(3562),
    [anon_sym_module] = ACTIONS(3562),
    [anon_sym_EQ] = ACTIONS(3560),
    [anon_sym_open] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3560),
    [anon_sym_COLON] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_type] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_and] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_let_BANG] = ACTIONS(3560),
    [aux_sym_access_modifier_token1] = ACTIONS(3560),
    [anon_sym_LPAREN] = ACTIONS(3562),
    [anon_sym_COMMA] = ACTIONS(3560),
    [anon_sym_null] = ACTIONS(3562),
    [anon_sym_QMARK] = ACTIONS(3562),
    [anon_sym_COLON_QMARK] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3560),
    [anon_sym_LBRACE] = ACTIONS(3562),
    [anon_sym_LT_AT] = ACTIONS(3562),
    [anon_sym_LT_AT_AT] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(3562),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3560),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_with] = ACTIONS(3562),
    [anon_sym_return_BANG] = ACTIONS(3560),
    [anon_sym_yield] = ACTIONS(3562),
    [anon_sym_yield_BANG] = ACTIONS(3560),
    [anon_sym_lazy] = ACTIONS(3562),
    [anon_sym_assert] = ACTIONS(3562),
    [anon_sym_upcast] = ACTIONS(3562),
    [anon_sym_downcast] = ACTIONS(3562),
    [anon_sym_COLON_GT] = ACTIONS(3560),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3560),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_fun] = ACTIONS(3562),
    [anon_sym_DASH_GT] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_match] = ACTIONS(3562),
    [anon_sym_match_BANG] = ACTIONS(3560),
    [anon_sym_function] = ACTIONS(3562),
    [anon_sym_LT_DASH] = ACTIONS(3562),
    [anon_sym_DOT_LBRACK] = ACTIONS(3560),
    [anon_sym_LT] = ACTIONS(3560),
    [anon_sym_use] = ACTIONS(3562),
    [anon_sym_use_BANG] = ACTIONS(3560),
    [anon_sym_do_BANG] = ACTIONS(3560),
    [anon_sym_begin] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3562),
    [anon_sym_LT2] = ACTIONS(3562),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3560),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_or] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_member] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_exception] = ACTIONS(3562),
    [anon_sym_abstract] = ACTIONS(3562),
    [anon_sym_val] = ACTIONS(3562),
    [anon_sym_override] = ACTIONS(3562),
    [aux_sym_char_token1] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(3562),
    [anon_sym_AT_DQUOTE] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [sym_bool] = ACTIONS(3562),
    [sym_unit] = ACTIONS(3560),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3562),
    [sym_op_identifier] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS_DOT] = ACTIONS(3562),
    [anon_sym_DASH_DOT] = ACTIONS(3562),
    [anon_sym_PERCENT] = ACTIONS(3562),
    [anon_sym_AMP_AMP] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3560),
    [aux_sym_prefix_op_token1] = ACTIONS(3562),
    [aux_sym_infix_op_token1] = ACTIONS(3560),
    [aux_sym_infix_op_token2] = ACTIONS(3562),
    [anon_sym_PIPE_PIPE] = ACTIONS(3562),
    [anon_sym_BANG_EQ] = ACTIONS(3562),
    [anon_sym_COLON_EQ] = ACTIONS(3560),
    [anon_sym_DOLLAR] = ACTIONS(3562),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3562),
    [sym_int] = ACTIONS(3562),
    [sym_xint] = ACTIONS(3560),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3560),
    [anon_sym_POUNDload] = ACTIONS(3560),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3560),
    [sym__newline] = ACTIONS(3560),
  },
  [1231] = {
    [sym_block_comment] = STATE(1231),
    [sym_compiler_directive_decl] = STATE(1231),
    [sym_fsi_directive_decl] = STATE(1231),
    [sym_preproc_line] = STATE(1231),
    [ts_builtin_sym_end] = ACTIONS(3191),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_namespace] = ACTIONS(3193),
    [anon_sym_module] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_open] = ACTIONS(3193),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_type] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_exception] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3564),
    [anon_sym_uy] = ACTIONS(3566),
    [anon_sym_s] = ACTIONS(3568),
    [anon_sym_us] = ACTIONS(3570),
    [anon_sym_l] = ACTIONS(3572),
    [aux_sym_uint32_token1] = ACTIONS(3574),
    [anon_sym_n] = ACTIONS(3576),
    [anon_sym_un] = ACTIONS(3578),
    [anon_sym_L] = ACTIONS(3580),
    [aux_sym_uint64_token1] = ACTIONS(3582),
    [aux_sym_bignum_token1] = ACTIONS(3584),
    [aux_sym_decimal_token1] = ACTIONS(3586),
    [anon_sym_DOT2] = ACTIONS(3588),
    [aux_sym_float_token1] = ACTIONS(3590),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3191),
    [anon_sym_POUNDload] = ACTIONS(3191),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1232] = {
    [sym_type_arguments] = STATE(1434),
    [sym_long_identifier] = STATE(1425),
    [sym_block_comment] = STATE(1232),
    [sym_compiler_directive_decl] = STATE(1232),
    [sym_fsi_directive_decl] = STATE(1232),
    [sym_preproc_line] = STATE(1232),
    [aux_sym_compound_type_repeat1] = STATE(1292),
    [sym_identifier] = ACTIONS(3592),
    [anon_sym_EQ] = ACTIONS(3429),
    [anon_sym_LBRACK_LT] = ACTIONS(3429),
    [anon_sym_COLON] = ACTIONS(3431),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_and] = ACTIONS(3431),
    [anon_sym_let] = ACTIONS(3431),
    [anon_sym_let_BANG] = ACTIONS(3429),
    [aux_sym_access_modifier_token1] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(3431),
    [anon_sym_COMMA] = ACTIONS(3429),
    [anon_sym_null] = ACTIONS(3431),
    [anon_sym_QMARK] = ACTIONS(3431),
    [anon_sym_COLON_QMARK] = ACTIONS(3431),
    [anon_sym_COLON_COLON] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_LT_AT] = ACTIONS(3431),
    [anon_sym_LT_AT_AT] = ACTIONS(3431),
    [anon_sym_DOT] = ACTIONS(3431),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_with] = ACTIONS(3431),
    [anon_sym_return_BANG] = ACTIONS(3429),
    [anon_sym_yield] = ACTIONS(3431),
    [anon_sym_yield_BANG] = ACTIONS(3429),
    [anon_sym_lazy] = ACTIONS(3431),
    [anon_sym_assert] = ACTIONS(3431),
    [anon_sym_upcast] = ACTIONS(3431),
    [anon_sym_downcast] = ACTIONS(3431),
    [anon_sym_COLON_GT] = ACTIONS(3429),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_fun] = ACTIONS(3431),
    [anon_sym_DASH_GT] = ACTIONS(3594),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_match] = ACTIONS(3431),
    [anon_sym_match_BANG] = ACTIONS(3429),
    [anon_sym_function] = ACTIONS(3431),
    [anon_sym_LT_DASH] = ACTIONS(3431),
    [anon_sym_DOT_LBRACK] = ACTIONS(3429),
    [anon_sym_LT] = ACTIONS(3429),
    [anon_sym_use] = ACTIONS(3431),
    [anon_sym_use_BANG] = ACTIONS(3429),
    [anon_sym_do_BANG] = ACTIONS(3429),
    [anon_sym_begin] = ACTIONS(3431),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3596),
    [anon_sym_LT2] = ACTIONS(3598),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3600),
    [anon_sym_default] = ACTIONS(3431),
    [anon_sym_or] = ACTIONS(3431),
    [anon_sym_static] = ACTIONS(3431),
    [anon_sym_member] = ACTIONS(3431),
    [anon_sym_interface] = ACTIONS(3431),
    [anon_sym_abstract] = ACTIONS(3431),
    [anon_sym_val] = ACTIONS(3431),
    [anon_sym_override] = ACTIONS(3431),
    [aux_sym_char_token1] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [anon_sym_AT_DQUOTE] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [sym_bool] = ACTIONS(3431),
    [sym_unit] = ACTIONS(3429),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3431),
    [sym_op_identifier] = ACTIONS(3431),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_DOT] = ACTIONS(3431),
    [anon_sym_DASH_DOT] = ACTIONS(3431),
    [anon_sym_PERCENT] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3429),
    [aux_sym_prefix_op_token1] = ACTIONS(3431),
    [aux_sym_infix_op_token1] = ACTIONS(3429),
    [aux_sym_infix_op_token2] = ACTIONS(3431),
    [anon_sym_PIPE_PIPE] = ACTIONS(3431),
    [anon_sym_BANG_EQ] = ACTIONS(3431),
    [anon_sym_COLON_EQ] = ACTIONS(3429),
    [anon_sym_DOLLAR] = ACTIONS(3431),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3431),
    [sym_int] = ACTIONS(3431),
    [sym_xint] = ACTIONS(3429),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3429),
    [anon_sym_POUNDendif] = ACTIONS(3429),
    [anon_sym_POUNDelse] = ACTIONS(3429),
    [sym__newline] = ACTIONS(3429),
  },
  [1233] = {
    [sym_type_arguments] = STATE(1434),
    [sym_long_identifier] = STATE(1425),
    [sym_block_comment] = STATE(1233),
    [sym_compiler_directive_decl] = STATE(1233),
    [sym_fsi_directive_decl] = STATE(1233),
    [sym_preproc_line] = STATE(1233),
    [aux_sym_compound_type_repeat1] = STATE(1292),
    [sym_identifier] = ACTIONS(3443),
    [anon_sym_EQ] = ACTIONS(3441),
    [anon_sym_LBRACK_LT] = ACTIONS(3441),
    [anon_sym_COLON] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_and] = ACTIONS(3443),
    [anon_sym_let] = ACTIONS(3443),
    [anon_sym_let_BANG] = ACTIONS(3441),
    [aux_sym_access_modifier_token1] = ACTIONS(3441),
    [anon_sym_LPAREN] = ACTIONS(3443),
    [anon_sym_COMMA] = ACTIONS(3441),
    [anon_sym_null] = ACTIONS(3443),
    [anon_sym_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_LT_AT] = ACTIONS(3443),
    [anon_sym_LT_AT_AT] = ACTIONS(3443),
    [anon_sym_DOT] = ACTIONS(3443),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_with] = ACTIONS(3443),
    [anon_sym_return_BANG] = ACTIONS(3441),
    [anon_sym_yield] = ACTIONS(3443),
    [anon_sym_yield_BANG] = ACTIONS(3441),
    [anon_sym_lazy] = ACTIONS(3443),
    [anon_sym_assert] = ACTIONS(3443),
    [anon_sym_upcast] = ACTIONS(3443),
    [anon_sym_downcast] = ACTIONS(3443),
    [anon_sym_COLON_GT] = ACTIONS(3441),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3441),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_fun] = ACTIONS(3443),
    [anon_sym_DASH_GT] = ACTIONS(3594),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_match] = ACTIONS(3443),
    [anon_sym_match_BANG] = ACTIONS(3441),
    [anon_sym_function] = ACTIONS(3443),
    [anon_sym_LT_DASH] = ACTIONS(3443),
    [anon_sym_DOT_LBRACK] = ACTIONS(3441),
    [anon_sym_LT] = ACTIONS(3441),
    [anon_sym_use] = ACTIONS(3443),
    [anon_sym_use_BANG] = ACTIONS(3441),
    [anon_sym_do_BANG] = ACTIONS(3441),
    [anon_sym_begin] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(3596),
    [anon_sym_LT2] = ACTIONS(3598),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3600),
    [anon_sym_default] = ACTIONS(3443),
    [anon_sym_or] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_member] = ACTIONS(3443),
    [anon_sym_interface] = ACTIONS(3443),
    [anon_sym_abstract] = ACTIONS(3443),
    [anon_sym_val] = ACTIONS(3443),
    [anon_sym_override] = ACTIONS(3443),
    [aux_sym_char_token1] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3443),
    [anon_sym_AT_DQUOTE] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [sym_bool] = ACTIONS(3443),
    [sym_unit] = ACTIONS(3441),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3443),
    [sym_op_identifier] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_PLUS_DOT] = ACTIONS(3443),
    [anon_sym_DASH_DOT] = ACTIONS(3443),
    [anon_sym_PERCENT] = ACTIONS(3443),
    [anon_sym_AMP_AMP] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3441),
    [aux_sym_prefix_op_token1] = ACTIONS(3443),
    [aux_sym_infix_op_token1] = ACTIONS(3441),
    [aux_sym_infix_op_token2] = ACTIONS(3443),
    [anon_sym_PIPE_PIPE] = ACTIONS(3443),
    [anon_sym_BANG_EQ] = ACTIONS(3443),
    [anon_sym_COLON_EQ] = ACTIONS(3441),
    [anon_sym_DOLLAR] = ACTIONS(3443),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3443),
    [sym_int] = ACTIONS(3443),
    [sym_xint] = ACTIONS(3441),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3441),
    [anon_sym_POUNDendif] = ACTIONS(3441),
    [anon_sym_POUNDelse] = ACTIONS(3441),
    [sym__newline] = ACTIONS(3441),
  },
  [1234] = {
    [sym_block_comment] = STATE(1234),
    [sym_compiler_directive_decl] = STATE(1234),
    [sym_fsi_directive_decl] = STATE(1234),
    [sym_preproc_line] = STATE(1234),
    [ts_builtin_sym_end] = ACTIONS(3191),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_module] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_open] = ACTIONS(3193),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_type] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_exception] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3564),
    [anon_sym_uy] = ACTIONS(3566),
    [anon_sym_s] = ACTIONS(3568),
    [anon_sym_us] = ACTIONS(3570),
    [anon_sym_l] = ACTIONS(3572),
    [aux_sym_uint32_token1] = ACTIONS(3574),
    [anon_sym_n] = ACTIONS(3576),
    [anon_sym_un] = ACTIONS(3578),
    [anon_sym_L] = ACTIONS(3580),
    [aux_sym_uint64_token1] = ACTIONS(3582),
    [aux_sym_bignum_token1] = ACTIONS(3584),
    [aux_sym_decimal_token1] = ACTIONS(3586),
    [anon_sym_DOT2] = ACTIONS(3588),
    [aux_sym_float_token1] = ACTIONS(3590),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3191),
    [anon_sym_POUNDload] = ACTIONS(3191),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1235] = {
    [sym_type_arguments] = STATE(1434),
    [sym_long_identifier] = STATE(1425),
    [sym_block_comment] = STATE(1235),
    [sym_compiler_directive_decl] = STATE(1235),
    [sym_fsi_directive_decl] = STATE(1235),
    [sym_preproc_line] = STATE(1235),
    [aux_sym_compound_type_repeat1] = STATE(1292),
    [sym_identifier] = ACTIONS(3592),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_LBRACK_LT] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_and] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [aux_sym_access_modifier_token1] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3427),
    [anon_sym_DOT] = ACTIONS(3427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_with] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_COLON_GT] = ACTIONS(3425),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(3594),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_LT_DASH] = ACTIONS(3427),
    [anon_sym_DOT_LBRACK] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(3596),
    [anon_sym_LT2] = ACTIONS(3598),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3600),
    [anon_sym_default] = ACTIONS(3427),
    [anon_sym_or] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_member] = ACTIONS(3427),
    [anon_sym_interface] = ACTIONS(3427),
    [anon_sym_abstract] = ACTIONS(3427),
    [anon_sym_val] = ACTIONS(3427),
    [anon_sym_override] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3427),
    [anon_sym_DASH_DOT] = ACTIONS(3427),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3427),
    [aux_sym_infix_op_token1] = ACTIONS(3425),
    [aux_sym_infix_op_token2] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3427),
    [anon_sym_COLON_EQ] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3427),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [anon_sym_POUNDendif] = ACTIONS(3425),
    [anon_sym_POUNDelse] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
  },
  [1236] = {
    [sym_block_comment] = STATE(1236),
    [sym_compiler_directive_decl] = STATE(1236),
    [sym_fsi_directive_decl] = STATE(1236),
    [sym_preproc_line] = STATE(1236),
    [ts_builtin_sym_end] = ACTIONS(3602),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_namespace] = ACTIONS(3604),
    [anon_sym_module] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_open] = ACTIONS(3604),
    [anon_sym_LBRACK_LT] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_type] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_and] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [aux_sym_access_modifier_token1] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_with] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_default] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [anon_sym_static] = ACTIONS(3604),
    [anon_sym_member] = ACTIONS(3604),
    [anon_sym_interface] = ACTIONS(3604),
    [anon_sym_exception] = ACTIONS(3604),
    [anon_sym_abstract] = ACTIONS(3604),
    [anon_sym_val] = ACTIONS(3604),
    [anon_sym_override] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [aux_sym_float_token1] = ACTIONS(3606),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3602),
    [anon_sym_POUNDload] = ACTIONS(3602),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
  },
  [1237] = {
    [sym_type_arguments] = STATE(1325),
    [sym_long_identifier] = STATE(1339),
    [sym_block_comment] = STATE(1237),
    [sym_compiler_directive_decl] = STATE(1237),
    [sym_fsi_directive_decl] = STATE(1237),
    [sym_preproc_line] = STATE(1237),
    [aux_sym_compound_type_repeat1] = STATE(1313),
    [sym_identifier] = ACTIONS(3608),
    [anon_sym_EQ] = ACTIONS(3403),
    [anon_sym_LBRACK_LT] = ACTIONS(3403),
    [anon_sym_COLON] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_let_BANG] = ACTIONS(3403),
    [aux_sym_access_modifier_token1] = ACTIONS(3403),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_COMMA] = ACTIONS(3403),
    [anon_sym_null] = ACTIONS(3407),
    [anon_sym_QMARK] = ACTIONS(3407),
    [anon_sym_COLON_QMARK] = ACTIONS(3407),
    [anon_sym_COLON_COLON] = ACTIONS(3403),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3407),
    [anon_sym_LT_AT] = ACTIONS(3407),
    [anon_sym_LT_AT_AT] = ACTIONS(3407),
    [anon_sym_DOT] = ACTIONS(3407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_with] = ACTIONS(3407),
    [anon_sym_return_BANG] = ACTIONS(3403),
    [anon_sym_yield] = ACTIONS(3407),
    [anon_sym_yield_BANG] = ACTIONS(3403),
    [anon_sym_lazy] = ACTIONS(3407),
    [anon_sym_assert] = ACTIONS(3407),
    [anon_sym_upcast] = ACTIONS(3407),
    [anon_sym_downcast] = ACTIONS(3407),
    [anon_sym_COLON_GT] = ACTIONS(3403),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_fun] = ACTIONS(3407),
    [anon_sym_DASH_GT] = ACTIONS(3610),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_match] = ACTIONS(3407),
    [anon_sym_match_BANG] = ACTIONS(3403),
    [anon_sym_function] = ACTIONS(3407),
    [anon_sym_LT_DASH] = ACTIONS(3407),
    [anon_sym_DOT_LBRACK] = ACTIONS(3403),
    [anon_sym_LT] = ACTIONS(3403),
    [anon_sym_use] = ACTIONS(3407),
    [anon_sym_use_BANG] = ACTIONS(3403),
    [anon_sym_do_BANG] = ACTIONS(3403),
    [anon_sym_begin] = ACTIONS(3407),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3612),
    [anon_sym_LT2] = ACTIONS(3614),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3616),
    [anon_sym_default] = ACTIONS(3407),
    [anon_sym_or] = ACTIONS(3407),
    [anon_sym_static] = ACTIONS(3407),
    [anon_sym_member] = ACTIONS(3407),
    [anon_sym_interface] = ACTIONS(3407),
    [anon_sym_abstract] = ACTIONS(3407),
    [anon_sym_val] = ACTIONS(3407),
    [anon_sym_override] = ACTIONS(3407),
    [anon_sym_inherit] = ACTIONS(3407),
    [aux_sym_char_token1] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3407),
    [anon_sym_DQUOTE] = ACTIONS(3407),
    [anon_sym_AT_DQUOTE] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [sym_bool] = ACTIONS(3407),
    [sym_unit] = ACTIONS(3403),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3407),
    [sym_op_identifier] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_PLUS_DOT] = ACTIONS(3407),
    [anon_sym_DASH_DOT] = ACTIONS(3407),
    [anon_sym_PERCENT] = ACTIONS(3407),
    [anon_sym_AMP_AMP] = ACTIONS(3407),
    [anon_sym_TILDE] = ACTIONS(3403),
    [aux_sym_prefix_op_token1] = ACTIONS(3407),
    [aux_sym_infix_op_token1] = ACTIONS(3403),
    [aux_sym_infix_op_token2] = ACTIONS(3407),
    [anon_sym_PIPE_PIPE] = ACTIONS(3407),
    [anon_sym_BANG_EQ] = ACTIONS(3407),
    [anon_sym_COLON_EQ] = ACTIONS(3403),
    [anon_sym_DOLLAR] = ACTIONS(3407),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3407),
    [sym_int] = ACTIONS(3407),
    [sym_xint] = ACTIONS(3403),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3403),
    [anon_sym_POUNDendif] = ACTIONS(3403),
    [anon_sym_POUNDelse] = ACTIONS(3403),
    [sym__newline] = ACTIONS(3403),
  },
  [1238] = {
    [sym_type_arguments] = STATE(1325),
    [sym_long_identifier] = STATE(1339),
    [sym_block_comment] = STATE(1238),
    [sym_compiler_directive_decl] = STATE(1238),
    [sym_fsi_directive_decl] = STATE(1238),
    [sym_preproc_line] = STATE(1238),
    [aux_sym_compound_type_repeat1] = STATE(1313),
    [sym_identifier] = ACTIONS(3608),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_LBRACK_LT] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [aux_sym_access_modifier_token1] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3427),
    [anon_sym_DOT] = ACTIONS(3427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_with] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_COLON_GT] = ACTIONS(3425),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(3610),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_LT_DASH] = ACTIONS(3427),
    [anon_sym_DOT_LBRACK] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(3612),
    [anon_sym_LT2] = ACTIONS(3614),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3616),
    [anon_sym_default] = ACTIONS(3427),
    [anon_sym_or] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_member] = ACTIONS(3427),
    [anon_sym_interface] = ACTIONS(3427),
    [anon_sym_abstract] = ACTIONS(3427),
    [anon_sym_val] = ACTIONS(3427),
    [anon_sym_override] = ACTIONS(3427),
    [anon_sym_inherit] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3427),
    [anon_sym_DASH_DOT] = ACTIONS(3427),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3427),
    [aux_sym_infix_op_token1] = ACTIONS(3425),
    [aux_sym_infix_op_token2] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3427),
    [anon_sym_COLON_EQ] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3427),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [anon_sym_POUNDendif] = ACTIONS(3425),
    [anon_sym_POUNDelse] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
  },
  [1239] = {
    [sym_type_arguments] = STATE(1434),
    [sym_long_identifier] = STATE(1425),
    [sym_block_comment] = STATE(1239),
    [sym_compiler_directive_decl] = STATE(1239),
    [sym_fsi_directive_decl] = STATE(1239),
    [sym_preproc_line] = STATE(1239),
    [aux_sym_compound_type_repeat1] = STATE(1292),
    [sym_identifier] = ACTIONS(3592),
    [anon_sym_EQ] = ACTIONS(3417),
    [anon_sym_LBRACK_LT] = ACTIONS(3417),
    [anon_sym_COLON] = ACTIONS(3419),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_and] = ACTIONS(3419),
    [anon_sym_let] = ACTIONS(3419),
    [anon_sym_let_BANG] = ACTIONS(3417),
    [aux_sym_access_modifier_token1] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(3419),
    [anon_sym_COMMA] = ACTIONS(3417),
    [anon_sym_null] = ACTIONS(3419),
    [anon_sym_QMARK] = ACTIONS(3419),
    [anon_sym_COLON_QMARK] = ACTIONS(3419),
    [anon_sym_COLON_COLON] = ACTIONS(3417),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_LT_AT] = ACTIONS(3419),
    [anon_sym_LT_AT_AT] = ACTIONS(3419),
    [anon_sym_DOT] = ACTIONS(3419),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_with] = ACTIONS(3419),
    [anon_sym_return_BANG] = ACTIONS(3417),
    [anon_sym_yield] = ACTIONS(3419),
    [anon_sym_yield_BANG] = ACTIONS(3417),
    [anon_sym_lazy] = ACTIONS(3419),
    [anon_sym_assert] = ACTIONS(3419),
    [anon_sym_upcast] = ACTIONS(3419),
    [anon_sym_downcast] = ACTIONS(3419),
    [anon_sym_COLON_GT] = ACTIONS(3417),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3417),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_fun] = ACTIONS(3419),
    [anon_sym_DASH_GT] = ACTIONS(3594),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_match] = ACTIONS(3419),
    [anon_sym_match_BANG] = ACTIONS(3417),
    [anon_sym_function] = ACTIONS(3419),
    [anon_sym_LT_DASH] = ACTIONS(3419),
    [anon_sym_DOT_LBRACK] = ACTIONS(3417),
    [anon_sym_LT] = ACTIONS(3417),
    [anon_sym_use] = ACTIONS(3419),
    [anon_sym_use_BANG] = ACTIONS(3417),
    [anon_sym_do_BANG] = ACTIONS(3417),
    [anon_sym_begin] = ACTIONS(3419),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(3596),
    [anon_sym_LT2] = ACTIONS(3598),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3600),
    [anon_sym_default] = ACTIONS(3419),
    [anon_sym_or] = ACTIONS(3419),
    [anon_sym_static] = ACTIONS(3419),
    [anon_sym_member] = ACTIONS(3419),
    [anon_sym_interface] = ACTIONS(3419),
    [anon_sym_abstract] = ACTIONS(3419),
    [anon_sym_val] = ACTIONS(3419),
    [anon_sym_override] = ACTIONS(3419),
    [aux_sym_char_token1] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3419),
    [anon_sym_AT_DQUOTE] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [sym_bool] = ACTIONS(3419),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3419),
    [sym_op_identifier] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_PLUS_DOT] = ACTIONS(3419),
    [anon_sym_DASH_DOT] = ACTIONS(3419),
    [anon_sym_PERCENT] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3419),
    [anon_sym_TILDE] = ACTIONS(3417),
    [aux_sym_prefix_op_token1] = ACTIONS(3419),
    [aux_sym_infix_op_token1] = ACTIONS(3417),
    [aux_sym_infix_op_token2] = ACTIONS(3419),
    [anon_sym_PIPE_PIPE] = ACTIONS(3419),
    [anon_sym_BANG_EQ] = ACTIONS(3419),
    [anon_sym_COLON_EQ] = ACTIONS(3417),
    [anon_sym_DOLLAR] = ACTIONS(3419),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3419),
    [sym_int] = ACTIONS(3419),
    [sym_xint] = ACTIONS(3417),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3417),
    [anon_sym_POUNDendif] = ACTIONS(3417),
    [anon_sym_POUNDelse] = ACTIONS(3417),
    [sym__newline] = ACTIONS(3417),
  },
  [1240] = {
    [sym_type_arguments] = STATE(1325),
    [sym_long_identifier] = STATE(1339),
    [sym_block_comment] = STATE(1240),
    [sym_compiler_directive_decl] = STATE(1240),
    [sym_fsi_directive_decl] = STATE(1240),
    [sym_preproc_line] = STATE(1240),
    [aux_sym_compound_type_repeat1] = STATE(1313),
    [sym_identifier] = ACTIONS(3443),
    [anon_sym_EQ] = ACTIONS(3441),
    [anon_sym_LBRACK_LT] = ACTIONS(3441),
    [anon_sym_COLON] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_let] = ACTIONS(3443),
    [anon_sym_let_BANG] = ACTIONS(3441),
    [aux_sym_access_modifier_token1] = ACTIONS(3441),
    [anon_sym_LPAREN] = ACTIONS(3443),
    [anon_sym_COMMA] = ACTIONS(3441),
    [anon_sym_null] = ACTIONS(3443),
    [anon_sym_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_LT_AT] = ACTIONS(3443),
    [anon_sym_LT_AT_AT] = ACTIONS(3443),
    [anon_sym_DOT] = ACTIONS(3443),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_with] = ACTIONS(3443),
    [anon_sym_return_BANG] = ACTIONS(3441),
    [anon_sym_yield] = ACTIONS(3443),
    [anon_sym_yield_BANG] = ACTIONS(3441),
    [anon_sym_lazy] = ACTIONS(3443),
    [anon_sym_assert] = ACTIONS(3443),
    [anon_sym_upcast] = ACTIONS(3443),
    [anon_sym_downcast] = ACTIONS(3443),
    [anon_sym_COLON_GT] = ACTIONS(3441),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3441),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_fun] = ACTIONS(3443),
    [anon_sym_DASH_GT] = ACTIONS(3610),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_match] = ACTIONS(3443),
    [anon_sym_match_BANG] = ACTIONS(3441),
    [anon_sym_function] = ACTIONS(3443),
    [anon_sym_LT_DASH] = ACTIONS(3443),
    [anon_sym_DOT_LBRACK] = ACTIONS(3441),
    [anon_sym_LT] = ACTIONS(3441),
    [anon_sym_use] = ACTIONS(3443),
    [anon_sym_use_BANG] = ACTIONS(3441),
    [anon_sym_do_BANG] = ACTIONS(3441),
    [anon_sym_begin] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(3612),
    [anon_sym_LT2] = ACTIONS(3614),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3616),
    [anon_sym_default] = ACTIONS(3443),
    [anon_sym_or] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_member] = ACTIONS(3443),
    [anon_sym_interface] = ACTIONS(3443),
    [anon_sym_abstract] = ACTIONS(3443),
    [anon_sym_val] = ACTIONS(3443),
    [anon_sym_override] = ACTIONS(3443),
    [anon_sym_inherit] = ACTIONS(3443),
    [aux_sym_char_token1] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3443),
    [anon_sym_AT_DQUOTE] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [sym_bool] = ACTIONS(3443),
    [sym_unit] = ACTIONS(3441),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3443),
    [sym_op_identifier] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_PLUS_DOT] = ACTIONS(3443),
    [anon_sym_DASH_DOT] = ACTIONS(3443),
    [anon_sym_PERCENT] = ACTIONS(3443),
    [anon_sym_AMP_AMP] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3441),
    [aux_sym_prefix_op_token1] = ACTIONS(3443),
    [aux_sym_infix_op_token1] = ACTIONS(3441),
    [aux_sym_infix_op_token2] = ACTIONS(3443),
    [anon_sym_PIPE_PIPE] = ACTIONS(3443),
    [anon_sym_BANG_EQ] = ACTIONS(3443),
    [anon_sym_COLON_EQ] = ACTIONS(3441),
    [anon_sym_DOLLAR] = ACTIONS(3443),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3443),
    [sym_int] = ACTIONS(3443),
    [sym_xint] = ACTIONS(3441),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3441),
    [anon_sym_POUNDendif] = ACTIONS(3441),
    [anon_sym_POUNDelse] = ACTIONS(3441),
    [sym__newline] = ACTIONS(3441),
  },
  [1241] = {
    [sym_type_arguments] = STATE(1434),
    [sym_long_identifier] = STATE(1425),
    [sym_block_comment] = STATE(1241),
    [sym_compiler_directive_decl] = STATE(1241),
    [sym_fsi_directive_decl] = STATE(1241),
    [sym_preproc_line] = STATE(1241),
    [aux_sym_compound_type_repeat1] = STATE(1292),
    [sym_identifier] = ACTIONS(3592),
    [anon_sym_EQ] = ACTIONS(3403),
    [anon_sym_LBRACK_LT] = ACTIONS(3403),
    [anon_sym_COLON] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_and] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_let_BANG] = ACTIONS(3403),
    [aux_sym_access_modifier_token1] = ACTIONS(3403),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_COMMA] = ACTIONS(3403),
    [anon_sym_null] = ACTIONS(3407),
    [anon_sym_QMARK] = ACTIONS(3407),
    [anon_sym_COLON_QMARK] = ACTIONS(3407),
    [anon_sym_COLON_COLON] = ACTIONS(3403),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3407),
    [anon_sym_LT_AT] = ACTIONS(3407),
    [anon_sym_LT_AT_AT] = ACTIONS(3407),
    [anon_sym_DOT] = ACTIONS(3407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_with] = ACTIONS(3407),
    [anon_sym_return_BANG] = ACTIONS(3403),
    [anon_sym_yield] = ACTIONS(3407),
    [anon_sym_yield_BANG] = ACTIONS(3403),
    [anon_sym_lazy] = ACTIONS(3407),
    [anon_sym_assert] = ACTIONS(3407),
    [anon_sym_upcast] = ACTIONS(3407),
    [anon_sym_downcast] = ACTIONS(3407),
    [anon_sym_COLON_GT] = ACTIONS(3403),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_fun] = ACTIONS(3407),
    [anon_sym_DASH_GT] = ACTIONS(3594),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_match] = ACTIONS(3407),
    [anon_sym_match_BANG] = ACTIONS(3403),
    [anon_sym_function] = ACTIONS(3407),
    [anon_sym_LT_DASH] = ACTIONS(3407),
    [anon_sym_DOT_LBRACK] = ACTIONS(3403),
    [anon_sym_LT] = ACTIONS(3403),
    [anon_sym_use] = ACTIONS(3407),
    [anon_sym_use_BANG] = ACTIONS(3403),
    [anon_sym_do_BANG] = ACTIONS(3403),
    [anon_sym_begin] = ACTIONS(3407),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3596),
    [anon_sym_LT2] = ACTIONS(3598),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3600),
    [anon_sym_default] = ACTIONS(3407),
    [anon_sym_or] = ACTIONS(3407),
    [anon_sym_static] = ACTIONS(3407),
    [anon_sym_member] = ACTIONS(3407),
    [anon_sym_interface] = ACTIONS(3407),
    [anon_sym_abstract] = ACTIONS(3407),
    [anon_sym_val] = ACTIONS(3407),
    [anon_sym_override] = ACTIONS(3407),
    [aux_sym_char_token1] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3407),
    [anon_sym_DQUOTE] = ACTIONS(3407),
    [anon_sym_AT_DQUOTE] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [sym_bool] = ACTIONS(3407),
    [sym_unit] = ACTIONS(3403),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3407),
    [sym_op_identifier] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_PLUS_DOT] = ACTIONS(3407),
    [anon_sym_DASH_DOT] = ACTIONS(3407),
    [anon_sym_PERCENT] = ACTIONS(3407),
    [anon_sym_AMP_AMP] = ACTIONS(3407),
    [anon_sym_TILDE] = ACTIONS(3403),
    [aux_sym_prefix_op_token1] = ACTIONS(3407),
    [aux_sym_infix_op_token1] = ACTIONS(3403),
    [aux_sym_infix_op_token2] = ACTIONS(3407),
    [anon_sym_PIPE_PIPE] = ACTIONS(3407),
    [anon_sym_BANG_EQ] = ACTIONS(3407),
    [anon_sym_COLON_EQ] = ACTIONS(3403),
    [anon_sym_DOLLAR] = ACTIONS(3407),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3407),
    [sym_int] = ACTIONS(3407),
    [sym_xint] = ACTIONS(3403),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3403),
    [anon_sym_POUNDendif] = ACTIONS(3403),
    [anon_sym_POUNDelse] = ACTIONS(3403),
    [sym__newline] = ACTIONS(3403),
  },
  [1242] = {
    [sym_type_arguments] = STATE(1325),
    [sym_long_identifier] = STATE(1339),
    [sym_block_comment] = STATE(1242),
    [sym_compiler_directive_decl] = STATE(1242),
    [sym_fsi_directive_decl] = STATE(1242),
    [sym_preproc_line] = STATE(1242),
    [aux_sym_compound_type_repeat1] = STATE(1313),
    [sym_identifier] = ACTIONS(3608),
    [anon_sym_EQ] = ACTIONS(3429),
    [anon_sym_LBRACK_LT] = ACTIONS(3429),
    [anon_sym_COLON] = ACTIONS(3431),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_let] = ACTIONS(3431),
    [anon_sym_let_BANG] = ACTIONS(3429),
    [aux_sym_access_modifier_token1] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(3431),
    [anon_sym_COMMA] = ACTIONS(3429),
    [anon_sym_null] = ACTIONS(3431),
    [anon_sym_QMARK] = ACTIONS(3431),
    [anon_sym_COLON_QMARK] = ACTIONS(3431),
    [anon_sym_COLON_COLON] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_LT_AT] = ACTIONS(3431),
    [anon_sym_LT_AT_AT] = ACTIONS(3431),
    [anon_sym_DOT] = ACTIONS(3431),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_with] = ACTIONS(3431),
    [anon_sym_return_BANG] = ACTIONS(3429),
    [anon_sym_yield] = ACTIONS(3431),
    [anon_sym_yield_BANG] = ACTIONS(3429),
    [anon_sym_lazy] = ACTIONS(3431),
    [anon_sym_assert] = ACTIONS(3431),
    [anon_sym_upcast] = ACTIONS(3431),
    [anon_sym_downcast] = ACTIONS(3431),
    [anon_sym_COLON_GT] = ACTIONS(3429),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_fun] = ACTIONS(3431),
    [anon_sym_DASH_GT] = ACTIONS(3610),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_match] = ACTIONS(3431),
    [anon_sym_match_BANG] = ACTIONS(3429),
    [anon_sym_function] = ACTIONS(3431),
    [anon_sym_LT_DASH] = ACTIONS(3431),
    [anon_sym_DOT_LBRACK] = ACTIONS(3429),
    [anon_sym_LT] = ACTIONS(3429),
    [anon_sym_use] = ACTIONS(3431),
    [anon_sym_use_BANG] = ACTIONS(3429),
    [anon_sym_do_BANG] = ACTIONS(3429),
    [anon_sym_begin] = ACTIONS(3431),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3612),
    [anon_sym_LT2] = ACTIONS(3614),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3616),
    [anon_sym_default] = ACTIONS(3431),
    [anon_sym_or] = ACTIONS(3431),
    [anon_sym_static] = ACTIONS(3431),
    [anon_sym_member] = ACTIONS(3431),
    [anon_sym_interface] = ACTIONS(3431),
    [anon_sym_abstract] = ACTIONS(3431),
    [anon_sym_val] = ACTIONS(3431),
    [anon_sym_override] = ACTIONS(3431),
    [anon_sym_inherit] = ACTIONS(3431),
    [aux_sym_char_token1] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [anon_sym_AT_DQUOTE] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [sym_bool] = ACTIONS(3431),
    [sym_unit] = ACTIONS(3429),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3431),
    [sym_op_identifier] = ACTIONS(3431),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_DOT] = ACTIONS(3431),
    [anon_sym_DASH_DOT] = ACTIONS(3431),
    [anon_sym_PERCENT] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3429),
    [aux_sym_prefix_op_token1] = ACTIONS(3431),
    [aux_sym_infix_op_token1] = ACTIONS(3429),
    [aux_sym_infix_op_token2] = ACTIONS(3431),
    [anon_sym_PIPE_PIPE] = ACTIONS(3431),
    [anon_sym_BANG_EQ] = ACTIONS(3431),
    [anon_sym_COLON_EQ] = ACTIONS(3429),
    [anon_sym_DOLLAR] = ACTIONS(3431),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3431),
    [sym_int] = ACTIONS(3431),
    [sym_xint] = ACTIONS(3429),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3429),
    [anon_sym_POUNDendif] = ACTIONS(3429),
    [anon_sym_POUNDelse] = ACTIONS(3429),
    [sym__newline] = ACTIONS(3429),
  },
  [1243] = {
    [sym_block_comment] = STATE(1243),
    [sym_compiler_directive_decl] = STATE(1243),
    [sym_fsi_directive_decl] = STATE(1243),
    [sym_preproc_line] = STATE(1243),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_GT_RBRACK] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_RBRACK] = ACTIONS(3191),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_RBRACE] = ACTIONS(3191),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_to] = ACTIONS(3193),
    [anon_sym_downto] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3618),
    [anon_sym_uy] = ACTIONS(3620),
    [anon_sym_s] = ACTIONS(3622),
    [anon_sym_us] = ACTIONS(3624),
    [anon_sym_l] = ACTIONS(3626),
    [aux_sym_uint32_token1] = ACTIONS(3628),
    [anon_sym_n] = ACTIONS(3630),
    [anon_sym_un] = ACTIONS(3632),
    [anon_sym_L] = ACTIONS(3634),
    [aux_sym_uint64_token1] = ACTIONS(3636),
    [aux_sym_bignum_token1] = ACTIONS(3638),
    [aux_sym_decimal_token1] = ACTIONS(3640),
    [anon_sym_DOT2] = ACTIONS(3642),
    [aux_sym_float_token1] = ACTIONS(3644),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1244] = {
    [sym_type_arguments] = STATE(1325),
    [sym_long_identifier] = STATE(1339),
    [sym_block_comment] = STATE(1244),
    [sym_compiler_directive_decl] = STATE(1244),
    [sym_fsi_directive_decl] = STATE(1244),
    [sym_preproc_line] = STATE(1244),
    [aux_sym_compound_type_repeat1] = STATE(1313),
    [sym_identifier] = ACTIONS(3608),
    [anon_sym_EQ] = ACTIONS(3417),
    [anon_sym_LBRACK_LT] = ACTIONS(3417),
    [anon_sym_COLON] = ACTIONS(3419),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_let] = ACTIONS(3419),
    [anon_sym_let_BANG] = ACTIONS(3417),
    [aux_sym_access_modifier_token1] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(3419),
    [anon_sym_COMMA] = ACTIONS(3417),
    [anon_sym_null] = ACTIONS(3419),
    [anon_sym_QMARK] = ACTIONS(3419),
    [anon_sym_COLON_QMARK] = ACTIONS(3419),
    [anon_sym_COLON_COLON] = ACTIONS(3417),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_LT_AT] = ACTIONS(3419),
    [anon_sym_LT_AT_AT] = ACTIONS(3419),
    [anon_sym_DOT] = ACTIONS(3419),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_with] = ACTIONS(3419),
    [anon_sym_return_BANG] = ACTIONS(3417),
    [anon_sym_yield] = ACTIONS(3419),
    [anon_sym_yield_BANG] = ACTIONS(3417),
    [anon_sym_lazy] = ACTIONS(3419),
    [anon_sym_assert] = ACTIONS(3419),
    [anon_sym_upcast] = ACTIONS(3419),
    [anon_sym_downcast] = ACTIONS(3419),
    [anon_sym_COLON_GT] = ACTIONS(3417),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3417),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_fun] = ACTIONS(3419),
    [anon_sym_DASH_GT] = ACTIONS(3610),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_match] = ACTIONS(3419),
    [anon_sym_match_BANG] = ACTIONS(3417),
    [anon_sym_function] = ACTIONS(3419),
    [anon_sym_LT_DASH] = ACTIONS(3419),
    [anon_sym_DOT_LBRACK] = ACTIONS(3417),
    [anon_sym_LT] = ACTIONS(3417),
    [anon_sym_use] = ACTIONS(3419),
    [anon_sym_use_BANG] = ACTIONS(3417),
    [anon_sym_do_BANG] = ACTIONS(3417),
    [anon_sym_begin] = ACTIONS(3419),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(3612),
    [anon_sym_LT2] = ACTIONS(3614),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3616),
    [anon_sym_default] = ACTIONS(3419),
    [anon_sym_or] = ACTIONS(3419),
    [anon_sym_static] = ACTIONS(3419),
    [anon_sym_member] = ACTIONS(3419),
    [anon_sym_interface] = ACTIONS(3419),
    [anon_sym_abstract] = ACTIONS(3419),
    [anon_sym_val] = ACTIONS(3419),
    [anon_sym_override] = ACTIONS(3419),
    [anon_sym_inherit] = ACTIONS(3419),
    [aux_sym_char_token1] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3419),
    [anon_sym_AT_DQUOTE] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [sym_bool] = ACTIONS(3419),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3419),
    [sym_op_identifier] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_PLUS_DOT] = ACTIONS(3419),
    [anon_sym_DASH_DOT] = ACTIONS(3419),
    [anon_sym_PERCENT] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3419),
    [anon_sym_TILDE] = ACTIONS(3417),
    [aux_sym_prefix_op_token1] = ACTIONS(3419),
    [aux_sym_infix_op_token1] = ACTIONS(3417),
    [aux_sym_infix_op_token2] = ACTIONS(3419),
    [anon_sym_PIPE_PIPE] = ACTIONS(3419),
    [anon_sym_BANG_EQ] = ACTIONS(3419),
    [anon_sym_COLON_EQ] = ACTIONS(3417),
    [anon_sym_DOLLAR] = ACTIONS(3419),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3419),
    [sym_int] = ACTIONS(3419),
    [sym_xint] = ACTIONS(3417),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3417),
    [anon_sym_POUNDendif] = ACTIONS(3417),
    [anon_sym_POUNDelse] = ACTIONS(3417),
    [sym__newline] = ACTIONS(3417),
  },
  [1245] = {
    [sym_block_comment] = STATE(1245),
    [sym_compiler_directive_decl] = STATE(1245),
    [sym_fsi_directive_decl] = STATE(1245),
    [sym_preproc_line] = STATE(1245),
    [ts_builtin_sym_end] = ACTIONS(3646),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_namespace] = ACTIONS(3648),
    [anon_sym_module] = ACTIONS(3648),
    [anon_sym_EQ] = ACTIONS(3646),
    [anon_sym_open] = ACTIONS(3648),
    [anon_sym_LBRACK_LT] = ACTIONS(3646),
    [anon_sym_COLON] = ACTIONS(3648),
    [anon_sym_return] = ACTIONS(3648),
    [anon_sym_type] = ACTIONS(3648),
    [anon_sym_do] = ACTIONS(3648),
    [anon_sym_and] = ACTIONS(3648),
    [anon_sym_let] = ACTIONS(3648),
    [anon_sym_let_BANG] = ACTIONS(3646),
    [aux_sym_access_modifier_token1] = ACTIONS(3646),
    [anon_sym_LPAREN] = ACTIONS(3648),
    [anon_sym_COMMA] = ACTIONS(3646),
    [anon_sym_null] = ACTIONS(3648),
    [anon_sym_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_COLON] = ACTIONS(3646),
    [anon_sym_AMP] = ACTIONS(3648),
    [anon_sym_LBRACK] = ACTIONS(3648),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3646),
    [anon_sym_LBRACE] = ACTIONS(3648),
    [anon_sym_LT_AT] = ACTIONS(3648),
    [anon_sym_LT_AT_AT] = ACTIONS(3648),
    [anon_sym_DOT] = ACTIONS(3648),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3646),
    [anon_sym_new] = ACTIONS(3648),
    [anon_sym_with] = ACTIONS(3648),
    [anon_sym_return_BANG] = ACTIONS(3646),
    [anon_sym_yield] = ACTIONS(3648),
    [anon_sym_yield_BANG] = ACTIONS(3646),
    [anon_sym_lazy] = ACTIONS(3648),
    [anon_sym_assert] = ACTIONS(3648),
    [anon_sym_upcast] = ACTIONS(3648),
    [anon_sym_downcast] = ACTIONS(3648),
    [anon_sym_COLON_GT] = ACTIONS(3646),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3646),
    [anon_sym_for] = ACTIONS(3648),
    [anon_sym_while] = ACTIONS(3648),
    [anon_sym_else] = ACTIONS(3648),
    [anon_sym_elif] = ACTIONS(3648),
    [anon_sym_if] = ACTIONS(3648),
    [anon_sym_fun] = ACTIONS(3648),
    [anon_sym_try] = ACTIONS(3648),
    [anon_sym_match] = ACTIONS(3648),
    [anon_sym_match_BANG] = ACTIONS(3646),
    [anon_sym_function] = ACTIONS(3648),
    [anon_sym_LT_DASH] = ACTIONS(3648),
    [anon_sym_DOT_LBRACK] = ACTIONS(3646),
    [anon_sym_LT] = ACTIONS(3646),
    [anon_sym_use] = ACTIONS(3648),
    [anon_sym_use_BANG] = ACTIONS(3646),
    [anon_sym_do_BANG] = ACTIONS(3646),
    [anon_sym_begin] = ACTIONS(3648),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_default] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3648),
    [anon_sym_static] = ACTIONS(3648),
    [anon_sym_member] = ACTIONS(3648),
    [anon_sym_interface] = ACTIONS(3648),
    [anon_sym_exception] = ACTIONS(3648),
    [anon_sym_abstract] = ACTIONS(3648),
    [anon_sym_val] = ACTIONS(3648),
    [anon_sym_override] = ACTIONS(3648),
    [aux_sym_char_token1] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3648),
    [anon_sym_AT_DQUOTE] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [sym_bool] = ACTIONS(3648),
    [sym_unit] = ACTIONS(3646),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3648),
    [sym_op_identifier] = ACTIONS(3648),
    [anon_sym_PLUS] = ACTIONS(3648),
    [anon_sym_DASH] = ACTIONS(3648),
    [anon_sym_PLUS_DOT] = ACTIONS(3648),
    [anon_sym_DASH_DOT] = ACTIONS(3648),
    [anon_sym_PERCENT] = ACTIONS(3648),
    [anon_sym_AMP_AMP] = ACTIONS(3648),
    [anon_sym_TILDE] = ACTIONS(3646),
    [aux_sym_prefix_op_token1] = ACTIONS(3648),
    [aux_sym_infix_op_token1] = ACTIONS(3646),
    [aux_sym_infix_op_token2] = ACTIONS(3648),
    [anon_sym_PIPE_PIPE] = ACTIONS(3648),
    [anon_sym_BANG_EQ] = ACTIONS(3648),
    [anon_sym_COLON_EQ] = ACTIONS(3646),
    [anon_sym_DOLLAR] = ACTIONS(3648),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3648),
    [sym_int] = ACTIONS(3648),
    [sym_xint] = ACTIONS(3646),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3646),
    [anon_sym_POUNDload] = ACTIONS(3646),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3646),
    [sym__newline] = ACTIONS(3646),
  },
  [1246] = {
    [sym_type_arguments] = STATE(1487),
    [sym_long_identifier] = STATE(1482),
    [sym_block_comment] = STATE(1246),
    [sym_compiler_directive_decl] = STATE(1246),
    [sym_fsi_directive_decl] = STATE(1246),
    [sym_preproc_line] = STATE(1246),
    [aux_sym_compound_type_repeat1] = STATE(1363),
    [sym_identifier] = ACTIONS(3650),
    [anon_sym_EQ] = ACTIONS(3429),
    [anon_sym_LBRACK_LT] = ACTIONS(3429),
    [anon_sym_COLON] = ACTIONS(3431),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_and] = ACTIONS(3431),
    [anon_sym_let] = ACTIONS(3431),
    [anon_sym_let_BANG] = ACTIONS(3429),
    [aux_sym_access_modifier_token1] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(3431),
    [anon_sym_COMMA] = ACTIONS(3429),
    [anon_sym_null] = ACTIONS(3431),
    [anon_sym_QMARK] = ACTIONS(3431),
    [anon_sym_COLON_QMARK] = ACTIONS(3431),
    [anon_sym_COLON_COLON] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_LT_AT] = ACTIONS(3431),
    [anon_sym_LT_AT_AT] = ACTIONS(3431),
    [anon_sym_DOT] = ACTIONS(3431),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_with] = ACTIONS(3431),
    [anon_sym_return_BANG] = ACTIONS(3429),
    [anon_sym_yield] = ACTIONS(3431),
    [anon_sym_yield_BANG] = ACTIONS(3429),
    [anon_sym_lazy] = ACTIONS(3431),
    [anon_sym_assert] = ACTIONS(3431),
    [anon_sym_upcast] = ACTIONS(3431),
    [anon_sym_downcast] = ACTIONS(3431),
    [anon_sym_COLON_GT] = ACTIONS(3429),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_fun] = ACTIONS(3431),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_match] = ACTIONS(3431),
    [anon_sym_match_BANG] = ACTIONS(3429),
    [anon_sym_function] = ACTIONS(3431),
    [anon_sym_LT_DASH] = ACTIONS(3431),
    [anon_sym_DOT_LBRACK] = ACTIONS(3429),
    [anon_sym_LT] = ACTIONS(3429),
    [anon_sym_use] = ACTIONS(3431),
    [anon_sym_use_BANG] = ACTIONS(3429),
    [anon_sym_do_BANG] = ACTIONS(3429),
    [anon_sym_begin] = ACTIONS(3431),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_LT2] = ACTIONS(3656),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3658),
    [anon_sym_default] = ACTIONS(3431),
    [anon_sym_or] = ACTIONS(3431),
    [anon_sym_static] = ACTIONS(3431),
    [anon_sym_member] = ACTIONS(3431),
    [anon_sym_interface] = ACTIONS(3431),
    [anon_sym_abstract] = ACTIONS(3431),
    [anon_sym_val] = ACTIONS(3431),
    [anon_sym_override] = ACTIONS(3431),
    [aux_sym_char_token1] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [anon_sym_AT_DQUOTE] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [sym_bool] = ACTIONS(3431),
    [sym_unit] = ACTIONS(3429),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3431),
    [sym_op_identifier] = ACTIONS(3431),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_DOT] = ACTIONS(3431),
    [anon_sym_DASH_DOT] = ACTIONS(3431),
    [anon_sym_PERCENT] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3429),
    [aux_sym_prefix_op_token1] = ACTIONS(3431),
    [aux_sym_infix_op_token1] = ACTIONS(3429),
    [aux_sym_infix_op_token2] = ACTIONS(3431),
    [anon_sym_PIPE_PIPE] = ACTIONS(3431),
    [anon_sym_BANG_EQ] = ACTIONS(3431),
    [anon_sym_COLON_EQ] = ACTIONS(3429),
    [anon_sym_DOLLAR] = ACTIONS(3431),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3431),
    [sym_int] = ACTIONS(3431),
    [sym_xint] = ACTIONS(3429),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3429),
    [anon_sym_POUNDendif] = ACTIONS(3429),
    [sym__newline] = ACTIONS(3429),
  },
  [1247] = {
    [sym_block_comment] = STATE(1247),
    [sym_compiler_directive_decl] = STATE(1247),
    [sym_fsi_directive_decl] = STATE(1247),
    [sym_preproc_line] = STATE(1247),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_GT_RBRACK] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_RBRACK] = ACTIONS(3191),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_RBRACE] = ACTIONS(3191),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_to] = ACTIONS(3193),
    [anon_sym_downto] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_DOT_DOT2] = ACTIONS(3191),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3618),
    [anon_sym_uy] = ACTIONS(3620),
    [anon_sym_s] = ACTIONS(3622),
    [anon_sym_us] = ACTIONS(3624),
    [anon_sym_l] = ACTIONS(3626),
    [aux_sym_uint32_token1] = ACTIONS(3628),
    [anon_sym_n] = ACTIONS(3630),
    [anon_sym_un] = ACTIONS(3632),
    [anon_sym_L] = ACTIONS(3634),
    [aux_sym_uint64_token1] = ACTIONS(3636),
    [anon_sym_lf] = ACTIONS(3660),
    [anon_sym_LF] = ACTIONS(3662),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1248] = {
    [sym_type_arguments] = STATE(1491),
    [sym_long_identifier] = STATE(1478),
    [sym_block_comment] = STATE(1248),
    [sym_compiler_directive_decl] = STATE(1248),
    [sym_fsi_directive_decl] = STATE(1248),
    [sym_preproc_line] = STATE(1248),
    [aux_sym_compound_type_repeat1] = STATE(1460),
    [sym_identifier] = ACTIONS(3664),
    [anon_sym_EQ] = ACTIONS(3429),
    [anon_sym_LBRACK_LT] = ACTIONS(3429),
    [anon_sym_COLON] = ACTIONS(3431),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_and] = ACTIONS(3431),
    [anon_sym_let] = ACTIONS(3431),
    [anon_sym_let_BANG] = ACTIONS(3429),
    [aux_sym_access_modifier_token1] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(3431),
    [anon_sym_COMMA] = ACTIONS(3429),
    [anon_sym_null] = ACTIONS(3431),
    [anon_sym_QMARK] = ACTIONS(3431),
    [anon_sym_COLON_QMARK] = ACTIONS(3431),
    [anon_sym_COLON_COLON] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_LT_AT] = ACTIONS(3431),
    [anon_sym_LT_AT_AT] = ACTIONS(3431),
    [anon_sym_DOT] = ACTIONS(3431),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_with] = ACTIONS(3431),
    [anon_sym_return_BANG] = ACTIONS(3429),
    [anon_sym_yield] = ACTIONS(3431),
    [anon_sym_yield_BANG] = ACTIONS(3429),
    [anon_sym_lazy] = ACTIONS(3431),
    [anon_sym_assert] = ACTIONS(3431),
    [anon_sym_upcast] = ACTIONS(3431),
    [anon_sym_downcast] = ACTIONS(3431),
    [anon_sym_COLON_GT] = ACTIONS(3429),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_fun] = ACTIONS(3431),
    [anon_sym_DASH_GT] = ACTIONS(3666),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_match] = ACTIONS(3431),
    [anon_sym_match_BANG] = ACTIONS(3429),
    [anon_sym_function] = ACTIONS(3431),
    [anon_sym_LT_DASH] = ACTIONS(3431),
    [anon_sym_DOT_LBRACK] = ACTIONS(3429),
    [anon_sym_LT] = ACTIONS(3429),
    [anon_sym_use] = ACTIONS(3431),
    [anon_sym_use_BANG] = ACTIONS(3429),
    [anon_sym_do_BANG] = ACTIONS(3429),
    [anon_sym_begin] = ACTIONS(3431),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3668),
    [anon_sym_LT2] = ACTIONS(3670),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3672),
    [anon_sym_default] = ACTIONS(3431),
    [anon_sym_or] = ACTIONS(3431),
    [anon_sym_static] = ACTIONS(3431),
    [anon_sym_member] = ACTIONS(3431),
    [anon_sym_interface] = ACTIONS(3431),
    [anon_sym_abstract] = ACTIONS(3431),
    [anon_sym_val] = ACTIONS(3431),
    [anon_sym_override] = ACTIONS(3431),
    [aux_sym_char_token1] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [anon_sym_AT_DQUOTE] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [sym_bool] = ACTIONS(3431),
    [sym_unit] = ACTIONS(3429),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3431),
    [sym_op_identifier] = ACTIONS(3431),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_DOT] = ACTIONS(3431),
    [anon_sym_DASH_DOT] = ACTIONS(3431),
    [anon_sym_PERCENT] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3429),
    [aux_sym_prefix_op_token1] = ACTIONS(3431),
    [aux_sym_infix_op_token1] = ACTIONS(3429),
    [aux_sym_infix_op_token2] = ACTIONS(3431),
    [anon_sym_PIPE_PIPE] = ACTIONS(3431),
    [anon_sym_BANG_EQ] = ACTIONS(3431),
    [anon_sym_COLON_EQ] = ACTIONS(3429),
    [anon_sym_DOLLAR] = ACTIONS(3431),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3431),
    [sym_int] = ACTIONS(3431),
    [sym_xint] = ACTIONS(3429),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3429),
    [sym__newline] = ACTIONS(3429),
    [sym__dedent] = ACTIONS(3429),
  },
  [1249] = {
    [sym_block_comment] = STATE(1249),
    [sym_compiler_directive_decl] = STATE(1249),
    [sym_fsi_directive_decl] = STATE(1249),
    [sym_preproc_line] = STATE(1249),
    [aux_sym_rules_repeat1] = STATE(1278),
    [ts_builtin_sym_end] = ACTIONS(3674),
    [sym_identifier] = ACTIONS(3676),
    [anon_sym_namespace] = ACTIONS(3676),
    [anon_sym_module] = ACTIONS(3676),
    [anon_sym_EQ] = ACTIONS(3674),
    [anon_sym_open] = ACTIONS(3676),
    [anon_sym_LBRACK_LT] = ACTIONS(3674),
    [anon_sym_COLON] = ACTIONS(3676),
    [anon_sym_return] = ACTIONS(3676),
    [anon_sym_type] = ACTIONS(3676),
    [anon_sym_do] = ACTIONS(3676),
    [anon_sym_and] = ACTIONS(3676),
    [anon_sym_let] = ACTIONS(3676),
    [anon_sym_let_BANG] = ACTIONS(3674),
    [aux_sym_access_modifier_token1] = ACTIONS(3674),
    [anon_sym_LPAREN] = ACTIONS(3676),
    [anon_sym_COMMA] = ACTIONS(3674),
    [anon_sym_null] = ACTIONS(3676),
    [anon_sym_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_COLON] = ACTIONS(3674),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3676),
    [anon_sym_LBRACK] = ACTIONS(3676),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3674),
    [anon_sym_LBRACE] = ACTIONS(3676),
    [anon_sym_LT_AT] = ACTIONS(3676),
    [anon_sym_LT_AT_AT] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3674),
    [anon_sym_new] = ACTIONS(3676),
    [anon_sym_with] = ACTIONS(3676),
    [anon_sym_return_BANG] = ACTIONS(3674),
    [anon_sym_yield] = ACTIONS(3676),
    [anon_sym_yield_BANG] = ACTIONS(3674),
    [anon_sym_lazy] = ACTIONS(3676),
    [anon_sym_assert] = ACTIONS(3676),
    [anon_sym_upcast] = ACTIONS(3676),
    [anon_sym_downcast] = ACTIONS(3676),
    [anon_sym_COLON_GT] = ACTIONS(3674),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3674),
    [anon_sym_for] = ACTIONS(3676),
    [anon_sym_while] = ACTIONS(3676),
    [anon_sym_if] = ACTIONS(3676),
    [anon_sym_fun] = ACTIONS(3676),
    [anon_sym_try] = ACTIONS(3676),
    [anon_sym_match] = ACTIONS(3676),
    [anon_sym_match_BANG] = ACTIONS(3674),
    [anon_sym_function] = ACTIONS(3676),
    [anon_sym_LT_DASH] = ACTIONS(3676),
    [anon_sym_DOT_LBRACK] = ACTIONS(3674),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_use] = ACTIONS(3676),
    [anon_sym_use_BANG] = ACTIONS(3674),
    [anon_sym_do_BANG] = ACTIONS(3674),
    [anon_sym_begin] = ACTIONS(3676),
    [anon_sym_LPAREN2] = ACTIONS(3676),
    [anon_sym_default] = ACTIONS(3676),
    [anon_sym_or] = ACTIONS(3676),
    [anon_sym_static] = ACTIONS(3676),
    [anon_sym_member] = ACTIONS(3676),
    [anon_sym_interface] = ACTIONS(3676),
    [anon_sym_exception] = ACTIONS(3676),
    [anon_sym_abstract] = ACTIONS(3676),
    [anon_sym_val] = ACTIONS(3676),
    [anon_sym_override] = ACTIONS(3676),
    [aux_sym_char_token1] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3676),
    [anon_sym_DQUOTE] = ACTIONS(3676),
    [anon_sym_AT_DQUOTE] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [sym_bool] = ACTIONS(3676),
    [sym_unit] = ACTIONS(3674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3676),
    [sym_op_identifier] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_PLUS_DOT] = ACTIONS(3676),
    [anon_sym_DASH_DOT] = ACTIONS(3676),
    [anon_sym_PERCENT] = ACTIONS(3676),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_TILDE] = ACTIONS(3674),
    [aux_sym_prefix_op_token1] = ACTIONS(3676),
    [aux_sym_infix_op_token1] = ACTIONS(3674),
    [aux_sym_infix_op_token2] = ACTIONS(3676),
    [anon_sym_PIPE_PIPE] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3676),
    [anon_sym_COLON_EQ] = ACTIONS(3674),
    [anon_sym_DOLLAR] = ACTIONS(3676),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3676),
    [sym_int] = ACTIONS(3676),
    [sym_xint] = ACTIONS(3674),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3674),
    [anon_sym_POUNDload] = ACTIONS(3674),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3674),
    [sym__newline] = ACTIONS(3680),
  },
  [1250] = {
    [sym_block_comment] = STATE(1250),
    [sym_compiler_directive_decl] = STATE(1250),
    [sym_fsi_directive_decl] = STATE(1250),
    [sym_preproc_line] = STATE(1250),
    [ts_builtin_sym_end] = ACTIONS(3683),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_namespace] = ACTIONS(3685),
    [anon_sym_module] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_open] = ACTIONS(3685),
    [anon_sym_LBRACK_LT] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_type] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_and] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [aux_sym_access_modifier_token1] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_with] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(3687),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_DOT_DOT] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_default] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [anon_sym_static] = ACTIONS(3685),
    [anon_sym_member] = ACTIONS(3685),
    [anon_sym_interface] = ACTIONS(3685),
    [anon_sym_exception] = ACTIONS(3685),
    [anon_sym_abstract] = ACTIONS(3685),
    [anon_sym_val] = ACTIONS(3685),
    [anon_sym_override] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3683),
    [anon_sym_POUNDload] = ACTIONS(3683),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
  },
  [1251] = {
    [sym_type_arguments] = STATE(1487),
    [sym_long_identifier] = STATE(1482),
    [sym_block_comment] = STATE(1251),
    [sym_compiler_directive_decl] = STATE(1251),
    [sym_fsi_directive_decl] = STATE(1251),
    [sym_preproc_line] = STATE(1251),
    [aux_sym_compound_type_repeat1] = STATE(1363),
    [sym_identifier] = ACTIONS(3650),
    [anon_sym_EQ] = ACTIONS(3417),
    [anon_sym_LBRACK_LT] = ACTIONS(3417),
    [anon_sym_COLON] = ACTIONS(3419),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_and] = ACTIONS(3419),
    [anon_sym_let] = ACTIONS(3419),
    [anon_sym_let_BANG] = ACTIONS(3417),
    [aux_sym_access_modifier_token1] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(3419),
    [anon_sym_COMMA] = ACTIONS(3417),
    [anon_sym_null] = ACTIONS(3419),
    [anon_sym_QMARK] = ACTIONS(3419),
    [anon_sym_COLON_QMARK] = ACTIONS(3419),
    [anon_sym_COLON_COLON] = ACTIONS(3417),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_LT_AT] = ACTIONS(3419),
    [anon_sym_LT_AT_AT] = ACTIONS(3419),
    [anon_sym_DOT] = ACTIONS(3419),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_with] = ACTIONS(3419),
    [anon_sym_return_BANG] = ACTIONS(3417),
    [anon_sym_yield] = ACTIONS(3419),
    [anon_sym_yield_BANG] = ACTIONS(3417),
    [anon_sym_lazy] = ACTIONS(3419),
    [anon_sym_assert] = ACTIONS(3419),
    [anon_sym_upcast] = ACTIONS(3419),
    [anon_sym_downcast] = ACTIONS(3419),
    [anon_sym_COLON_GT] = ACTIONS(3417),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3417),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_fun] = ACTIONS(3419),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_match] = ACTIONS(3419),
    [anon_sym_match_BANG] = ACTIONS(3417),
    [anon_sym_function] = ACTIONS(3419),
    [anon_sym_LT_DASH] = ACTIONS(3419),
    [anon_sym_DOT_LBRACK] = ACTIONS(3417),
    [anon_sym_LT] = ACTIONS(3417),
    [anon_sym_use] = ACTIONS(3419),
    [anon_sym_use_BANG] = ACTIONS(3417),
    [anon_sym_do_BANG] = ACTIONS(3417),
    [anon_sym_begin] = ACTIONS(3419),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_LT2] = ACTIONS(3656),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3658),
    [anon_sym_default] = ACTIONS(3419),
    [anon_sym_or] = ACTIONS(3419),
    [anon_sym_static] = ACTIONS(3419),
    [anon_sym_member] = ACTIONS(3419),
    [anon_sym_interface] = ACTIONS(3419),
    [anon_sym_abstract] = ACTIONS(3419),
    [anon_sym_val] = ACTIONS(3419),
    [anon_sym_override] = ACTIONS(3419),
    [aux_sym_char_token1] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3419),
    [anon_sym_AT_DQUOTE] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [sym_bool] = ACTIONS(3419),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3419),
    [sym_op_identifier] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_PLUS_DOT] = ACTIONS(3419),
    [anon_sym_DASH_DOT] = ACTIONS(3419),
    [anon_sym_PERCENT] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3419),
    [anon_sym_TILDE] = ACTIONS(3417),
    [aux_sym_prefix_op_token1] = ACTIONS(3419),
    [aux_sym_infix_op_token1] = ACTIONS(3417),
    [aux_sym_infix_op_token2] = ACTIONS(3419),
    [anon_sym_PIPE_PIPE] = ACTIONS(3419),
    [anon_sym_BANG_EQ] = ACTIONS(3419),
    [anon_sym_COLON_EQ] = ACTIONS(3417),
    [anon_sym_DOLLAR] = ACTIONS(3419),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3419),
    [sym_int] = ACTIONS(3419),
    [sym_xint] = ACTIONS(3417),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3417),
    [anon_sym_POUNDendif] = ACTIONS(3417),
    [sym__newline] = ACTIONS(3417),
  },
  [1252] = {
    [sym_block_comment] = STATE(1252),
    [sym_compiler_directive_decl] = STATE(1252),
    [sym_fsi_directive_decl] = STATE(1252),
    [sym_preproc_line] = STATE(1252),
    [aux_sym_rules_repeat1] = STATE(1249),
    [ts_builtin_sym_end] = ACTIONS(3691),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_namespace] = ACTIONS(3693),
    [anon_sym_module] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_open] = ACTIONS(3693),
    [anon_sym_LBRACK_LT] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_type] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_and] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [aux_sym_access_modifier_token1] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_with] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_default] = ACTIONS(3693),
    [anon_sym_or] = ACTIONS(3693),
    [anon_sym_static] = ACTIONS(3693),
    [anon_sym_member] = ACTIONS(3693),
    [anon_sym_interface] = ACTIONS(3693),
    [anon_sym_exception] = ACTIONS(3693),
    [anon_sym_abstract] = ACTIONS(3693),
    [anon_sym_val] = ACTIONS(3693),
    [anon_sym_override] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3691),
    [anon_sym_POUNDload] = ACTIONS(3691),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(3695),
  },
  [1253] = {
    [sym_block_comment] = STATE(1253),
    [sym_compiler_directive_decl] = STATE(1253),
    [sym_fsi_directive_decl] = STATE(1253),
    [sym_preproc_line] = STATE(1253),
    [ts_builtin_sym_end] = ACTIONS(3698),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_namespace] = ACTIONS(3700),
    [anon_sym_module] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_open] = ACTIONS(3700),
    [anon_sym_LBRACK_LT] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_type] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_and] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [aux_sym_access_modifier_token1] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_done] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_DOT_DOT] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_default] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [anon_sym_static] = ACTIONS(3700),
    [anon_sym_member] = ACTIONS(3700),
    [anon_sym_interface] = ACTIONS(3700),
    [anon_sym_exception] = ACTIONS(3700),
    [anon_sym_abstract] = ACTIONS(3700),
    [anon_sym_val] = ACTIONS(3700),
    [anon_sym_override] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3698),
    [anon_sym_POUNDload] = ACTIONS(3698),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [1254] = {
    [sym_type_arguments] = STATE(1491),
    [sym_long_identifier] = STATE(1478),
    [sym_block_comment] = STATE(1254),
    [sym_compiler_directive_decl] = STATE(1254),
    [sym_fsi_directive_decl] = STATE(1254),
    [sym_preproc_line] = STATE(1254),
    [aux_sym_compound_type_repeat1] = STATE(1460),
    [sym_identifier] = ACTIONS(3443),
    [anon_sym_EQ] = ACTIONS(3441),
    [anon_sym_LBRACK_LT] = ACTIONS(3441),
    [anon_sym_COLON] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_and] = ACTIONS(3443),
    [anon_sym_let] = ACTIONS(3443),
    [anon_sym_let_BANG] = ACTIONS(3441),
    [aux_sym_access_modifier_token1] = ACTIONS(3441),
    [anon_sym_LPAREN] = ACTIONS(3443),
    [anon_sym_COMMA] = ACTIONS(3441),
    [anon_sym_null] = ACTIONS(3443),
    [anon_sym_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_LT_AT] = ACTIONS(3443),
    [anon_sym_LT_AT_AT] = ACTIONS(3443),
    [anon_sym_DOT] = ACTIONS(3443),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_with] = ACTIONS(3443),
    [anon_sym_return_BANG] = ACTIONS(3441),
    [anon_sym_yield] = ACTIONS(3443),
    [anon_sym_yield_BANG] = ACTIONS(3441),
    [anon_sym_lazy] = ACTIONS(3443),
    [anon_sym_assert] = ACTIONS(3443),
    [anon_sym_upcast] = ACTIONS(3443),
    [anon_sym_downcast] = ACTIONS(3443),
    [anon_sym_COLON_GT] = ACTIONS(3441),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3441),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_fun] = ACTIONS(3443),
    [anon_sym_DASH_GT] = ACTIONS(3666),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_match] = ACTIONS(3443),
    [anon_sym_match_BANG] = ACTIONS(3441),
    [anon_sym_function] = ACTIONS(3443),
    [anon_sym_LT_DASH] = ACTIONS(3443),
    [anon_sym_DOT_LBRACK] = ACTIONS(3441),
    [anon_sym_LT] = ACTIONS(3441),
    [anon_sym_use] = ACTIONS(3443),
    [anon_sym_use_BANG] = ACTIONS(3441),
    [anon_sym_do_BANG] = ACTIONS(3441),
    [anon_sym_begin] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(3668),
    [anon_sym_LT2] = ACTIONS(3670),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3672),
    [anon_sym_default] = ACTIONS(3443),
    [anon_sym_or] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_member] = ACTIONS(3443),
    [anon_sym_interface] = ACTIONS(3443),
    [anon_sym_abstract] = ACTIONS(3443),
    [anon_sym_val] = ACTIONS(3443),
    [anon_sym_override] = ACTIONS(3443),
    [aux_sym_char_token1] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3443),
    [anon_sym_AT_DQUOTE] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [sym_bool] = ACTIONS(3443),
    [sym_unit] = ACTIONS(3441),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3443),
    [sym_op_identifier] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_PLUS_DOT] = ACTIONS(3443),
    [anon_sym_DASH_DOT] = ACTIONS(3443),
    [anon_sym_PERCENT] = ACTIONS(3443),
    [anon_sym_AMP_AMP] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3441),
    [aux_sym_prefix_op_token1] = ACTIONS(3443),
    [aux_sym_infix_op_token1] = ACTIONS(3441),
    [aux_sym_infix_op_token2] = ACTIONS(3443),
    [anon_sym_PIPE_PIPE] = ACTIONS(3443),
    [anon_sym_BANG_EQ] = ACTIONS(3443),
    [anon_sym_COLON_EQ] = ACTIONS(3441),
    [anon_sym_DOLLAR] = ACTIONS(3443),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3443),
    [sym_int] = ACTIONS(3443),
    [sym_xint] = ACTIONS(3441),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3441),
    [sym__newline] = ACTIONS(3441),
    [sym__dedent] = ACTIONS(3441),
  },
  [1255] = {
    [sym_type_arguments] = STATE(1491),
    [sym_long_identifier] = STATE(1478),
    [sym_block_comment] = STATE(1255),
    [sym_compiler_directive_decl] = STATE(1255),
    [sym_fsi_directive_decl] = STATE(1255),
    [sym_preproc_line] = STATE(1255),
    [aux_sym_compound_type_repeat1] = STATE(1460),
    [sym_identifier] = ACTIONS(3664),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_LBRACK_LT] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_and] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [aux_sym_access_modifier_token1] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3427),
    [anon_sym_DOT] = ACTIONS(3427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_with] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_COLON_GT] = ACTIONS(3425),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(3666),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_LT_DASH] = ACTIONS(3427),
    [anon_sym_DOT_LBRACK] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(3668),
    [anon_sym_LT2] = ACTIONS(3670),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3672),
    [anon_sym_default] = ACTIONS(3427),
    [anon_sym_or] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_member] = ACTIONS(3427),
    [anon_sym_interface] = ACTIONS(3427),
    [anon_sym_abstract] = ACTIONS(3427),
    [anon_sym_val] = ACTIONS(3427),
    [anon_sym_override] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3427),
    [anon_sym_DASH_DOT] = ACTIONS(3427),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3427),
    [aux_sym_infix_op_token1] = ACTIONS(3425),
    [aux_sym_infix_op_token2] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3427),
    [anon_sym_COLON_EQ] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3427),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
    [sym__dedent] = ACTIONS(3425),
  },
  [1256] = {
    [sym_type_arguments] = STATE(1471),
    [sym_long_identifier] = STATE(1551),
    [sym_block_comment] = STATE(1256),
    [sym_compiler_directive_decl] = STATE(1256),
    [sym_fsi_directive_decl] = STATE(1256),
    [sym_preproc_line] = STATE(1256),
    [aux_sym_compound_type_repeat1] = STATE(1361),
    [sym_identifier] = ACTIONS(3443),
    [anon_sym_EQ] = ACTIONS(3441),
    [anon_sym_LBRACK_LT] = ACTIONS(3441),
    [anon_sym_COLON] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_let] = ACTIONS(3443),
    [anon_sym_let_BANG] = ACTIONS(3441),
    [aux_sym_access_modifier_token1] = ACTIONS(3441),
    [anon_sym_LPAREN] = ACTIONS(3443),
    [anon_sym_COMMA] = ACTIONS(3441),
    [anon_sym_null] = ACTIONS(3443),
    [anon_sym_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_LT_AT] = ACTIONS(3443),
    [anon_sym_LT_AT_AT] = ACTIONS(3443),
    [anon_sym_DOT] = ACTIONS(3443),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_with] = ACTIONS(3443),
    [anon_sym_return_BANG] = ACTIONS(3441),
    [anon_sym_yield] = ACTIONS(3443),
    [anon_sym_yield_BANG] = ACTIONS(3441),
    [anon_sym_lazy] = ACTIONS(3443),
    [anon_sym_assert] = ACTIONS(3443),
    [anon_sym_upcast] = ACTIONS(3443),
    [anon_sym_downcast] = ACTIONS(3443),
    [anon_sym_COLON_GT] = ACTIONS(3441),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3441),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_fun] = ACTIONS(3443),
    [anon_sym_DASH_GT] = ACTIONS(3702),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_match] = ACTIONS(3443),
    [anon_sym_match_BANG] = ACTIONS(3441),
    [anon_sym_function] = ACTIONS(3443),
    [anon_sym_LT_DASH] = ACTIONS(3443),
    [anon_sym_DOT_LBRACK] = ACTIONS(3441),
    [anon_sym_LT] = ACTIONS(3441),
    [anon_sym_use] = ACTIONS(3443),
    [anon_sym_use_BANG] = ACTIONS(3441),
    [anon_sym_do_BANG] = ACTIONS(3441),
    [anon_sym_begin] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3443),
    [anon_sym_DOT_DOT2] = ACTIONS(3441),
    [anon_sym_STAR] = ACTIONS(3704),
    [anon_sym_LT2] = ACTIONS(3706),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3708),
    [anon_sym_default] = ACTIONS(3443),
    [anon_sym_or] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_member] = ACTIONS(3443),
    [anon_sym_interface] = ACTIONS(3443),
    [anon_sym_abstract] = ACTIONS(3443),
    [anon_sym_val] = ACTIONS(3443),
    [anon_sym_override] = ACTIONS(3443),
    [aux_sym_char_token1] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3443),
    [anon_sym_AT_DQUOTE] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [sym_bool] = ACTIONS(3443),
    [sym_unit] = ACTIONS(3441),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3443),
    [sym_op_identifier] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_PLUS_DOT] = ACTIONS(3443),
    [anon_sym_DASH_DOT] = ACTIONS(3443),
    [anon_sym_PERCENT] = ACTIONS(3443),
    [anon_sym_AMP_AMP] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3441),
    [aux_sym_prefix_op_token1] = ACTIONS(3443),
    [aux_sym_infix_op_token1] = ACTIONS(3441),
    [aux_sym_infix_op_token2] = ACTIONS(3443),
    [anon_sym_PIPE_PIPE] = ACTIONS(3443),
    [anon_sym_BANG_EQ] = ACTIONS(3443),
    [anon_sym_COLON_EQ] = ACTIONS(3441),
    [anon_sym_DOLLAR] = ACTIONS(3443),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3443),
    [sym_int] = ACTIONS(3443),
    [sym_xint] = ACTIONS(3441),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3441),
    [sym__newline] = ACTIONS(3441),
    [sym__dedent] = ACTIONS(3441),
  },
  [1257] = {
    [sym_type_arguments] = STATE(1471),
    [sym_long_identifier] = STATE(1551),
    [sym_block_comment] = STATE(1257),
    [sym_compiler_directive_decl] = STATE(1257),
    [sym_fsi_directive_decl] = STATE(1257),
    [sym_preproc_line] = STATE(1257),
    [aux_sym_compound_type_repeat1] = STATE(1361),
    [sym_identifier] = ACTIONS(3710),
    [anon_sym_EQ] = ACTIONS(3429),
    [anon_sym_LBRACK_LT] = ACTIONS(3429),
    [anon_sym_COLON] = ACTIONS(3431),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_let] = ACTIONS(3431),
    [anon_sym_let_BANG] = ACTIONS(3429),
    [aux_sym_access_modifier_token1] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(3431),
    [anon_sym_COMMA] = ACTIONS(3429),
    [anon_sym_null] = ACTIONS(3431),
    [anon_sym_QMARK] = ACTIONS(3431),
    [anon_sym_COLON_QMARK] = ACTIONS(3431),
    [anon_sym_COLON_COLON] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_LT_AT] = ACTIONS(3431),
    [anon_sym_LT_AT_AT] = ACTIONS(3431),
    [anon_sym_DOT] = ACTIONS(3431),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_with] = ACTIONS(3431),
    [anon_sym_return_BANG] = ACTIONS(3429),
    [anon_sym_yield] = ACTIONS(3431),
    [anon_sym_yield_BANG] = ACTIONS(3429),
    [anon_sym_lazy] = ACTIONS(3431),
    [anon_sym_assert] = ACTIONS(3431),
    [anon_sym_upcast] = ACTIONS(3431),
    [anon_sym_downcast] = ACTIONS(3431),
    [anon_sym_COLON_GT] = ACTIONS(3429),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_fun] = ACTIONS(3431),
    [anon_sym_DASH_GT] = ACTIONS(3702),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_match] = ACTIONS(3431),
    [anon_sym_match_BANG] = ACTIONS(3429),
    [anon_sym_function] = ACTIONS(3431),
    [anon_sym_LT_DASH] = ACTIONS(3431),
    [anon_sym_DOT_LBRACK] = ACTIONS(3429),
    [anon_sym_LT] = ACTIONS(3429),
    [anon_sym_use] = ACTIONS(3431),
    [anon_sym_use_BANG] = ACTIONS(3429),
    [anon_sym_do_BANG] = ACTIONS(3429),
    [anon_sym_begin] = ACTIONS(3431),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_DOT_DOT2] = ACTIONS(3429),
    [anon_sym_STAR] = ACTIONS(3704),
    [anon_sym_LT2] = ACTIONS(3706),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3708),
    [anon_sym_default] = ACTIONS(3431),
    [anon_sym_or] = ACTIONS(3431),
    [anon_sym_static] = ACTIONS(3431),
    [anon_sym_member] = ACTIONS(3431),
    [anon_sym_interface] = ACTIONS(3431),
    [anon_sym_abstract] = ACTIONS(3431),
    [anon_sym_val] = ACTIONS(3431),
    [anon_sym_override] = ACTIONS(3431),
    [aux_sym_char_token1] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [anon_sym_AT_DQUOTE] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [sym_bool] = ACTIONS(3431),
    [sym_unit] = ACTIONS(3429),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3431),
    [sym_op_identifier] = ACTIONS(3431),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_DOT] = ACTIONS(3431),
    [anon_sym_DASH_DOT] = ACTIONS(3431),
    [anon_sym_PERCENT] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3429),
    [aux_sym_prefix_op_token1] = ACTIONS(3431),
    [aux_sym_infix_op_token1] = ACTIONS(3429),
    [aux_sym_infix_op_token2] = ACTIONS(3431),
    [anon_sym_PIPE_PIPE] = ACTIONS(3431),
    [anon_sym_BANG_EQ] = ACTIONS(3431),
    [anon_sym_COLON_EQ] = ACTIONS(3429),
    [anon_sym_DOLLAR] = ACTIONS(3431),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3431),
    [sym_int] = ACTIONS(3431),
    [sym_xint] = ACTIONS(3429),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3429),
    [sym__newline] = ACTIONS(3429),
    [sym__dedent] = ACTIONS(3429),
  },
  [1258] = {
    [sym_type_arguments] = STATE(1487),
    [sym_long_identifier] = STATE(1482),
    [sym_block_comment] = STATE(1258),
    [sym_compiler_directive_decl] = STATE(1258),
    [sym_fsi_directive_decl] = STATE(1258),
    [sym_preproc_line] = STATE(1258),
    [aux_sym_compound_type_repeat1] = STATE(1363),
    [sym_identifier] = ACTIONS(3650),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_LBRACK_LT] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_and] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [aux_sym_access_modifier_token1] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3427),
    [anon_sym_DOT] = ACTIONS(3427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_with] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_COLON_GT] = ACTIONS(3425),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_LT_DASH] = ACTIONS(3427),
    [anon_sym_DOT_LBRACK] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_LT2] = ACTIONS(3656),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3658),
    [anon_sym_default] = ACTIONS(3427),
    [anon_sym_or] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_member] = ACTIONS(3427),
    [anon_sym_interface] = ACTIONS(3427),
    [anon_sym_abstract] = ACTIONS(3427),
    [anon_sym_val] = ACTIONS(3427),
    [anon_sym_override] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3427),
    [anon_sym_DASH_DOT] = ACTIONS(3427),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3427),
    [aux_sym_infix_op_token1] = ACTIONS(3425),
    [aux_sym_infix_op_token2] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3427),
    [anon_sym_COLON_EQ] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3427),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [anon_sym_POUNDendif] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
  },
  [1259] = {
    [sym_type_arguments] = STATE(1471),
    [sym_long_identifier] = STATE(1551),
    [sym_block_comment] = STATE(1259),
    [sym_compiler_directive_decl] = STATE(1259),
    [sym_fsi_directive_decl] = STATE(1259),
    [sym_preproc_line] = STATE(1259),
    [aux_sym_compound_type_repeat1] = STATE(1361),
    [sym_identifier] = ACTIONS(3710),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_LBRACK_LT] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [aux_sym_access_modifier_token1] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3427),
    [anon_sym_DOT] = ACTIONS(3427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_with] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_COLON_GT] = ACTIONS(3425),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(3702),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_LT_DASH] = ACTIONS(3427),
    [anon_sym_DOT_LBRACK] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_DOT_DOT2] = ACTIONS(3425),
    [anon_sym_STAR] = ACTIONS(3704),
    [anon_sym_LT2] = ACTIONS(3706),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3708),
    [anon_sym_default] = ACTIONS(3427),
    [anon_sym_or] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_member] = ACTIONS(3427),
    [anon_sym_interface] = ACTIONS(3427),
    [anon_sym_abstract] = ACTIONS(3427),
    [anon_sym_val] = ACTIONS(3427),
    [anon_sym_override] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3427),
    [anon_sym_DASH_DOT] = ACTIONS(3427),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3427),
    [aux_sym_infix_op_token1] = ACTIONS(3425),
    [aux_sym_infix_op_token2] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3427),
    [anon_sym_COLON_EQ] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3427),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
    [sym__dedent] = ACTIONS(3425),
  },
  [1260] = {
    [sym_type_arguments] = STATE(1471),
    [sym_long_identifier] = STATE(1551),
    [sym_block_comment] = STATE(1260),
    [sym_compiler_directive_decl] = STATE(1260),
    [sym_fsi_directive_decl] = STATE(1260),
    [sym_preproc_line] = STATE(1260),
    [aux_sym_compound_type_repeat1] = STATE(1361),
    [sym_identifier] = ACTIONS(3710),
    [anon_sym_EQ] = ACTIONS(3403),
    [anon_sym_LBRACK_LT] = ACTIONS(3403),
    [anon_sym_COLON] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_let_BANG] = ACTIONS(3403),
    [aux_sym_access_modifier_token1] = ACTIONS(3403),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_COMMA] = ACTIONS(3403),
    [anon_sym_null] = ACTIONS(3407),
    [anon_sym_QMARK] = ACTIONS(3407),
    [anon_sym_COLON_QMARK] = ACTIONS(3407),
    [anon_sym_COLON_COLON] = ACTIONS(3403),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3407),
    [anon_sym_LT_AT] = ACTIONS(3407),
    [anon_sym_LT_AT_AT] = ACTIONS(3407),
    [anon_sym_DOT] = ACTIONS(3407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_with] = ACTIONS(3407),
    [anon_sym_return_BANG] = ACTIONS(3403),
    [anon_sym_yield] = ACTIONS(3407),
    [anon_sym_yield_BANG] = ACTIONS(3403),
    [anon_sym_lazy] = ACTIONS(3407),
    [anon_sym_assert] = ACTIONS(3407),
    [anon_sym_upcast] = ACTIONS(3407),
    [anon_sym_downcast] = ACTIONS(3407),
    [anon_sym_COLON_GT] = ACTIONS(3403),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_fun] = ACTIONS(3407),
    [anon_sym_DASH_GT] = ACTIONS(3702),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_match] = ACTIONS(3407),
    [anon_sym_match_BANG] = ACTIONS(3403),
    [anon_sym_function] = ACTIONS(3407),
    [anon_sym_LT_DASH] = ACTIONS(3407),
    [anon_sym_DOT_LBRACK] = ACTIONS(3403),
    [anon_sym_LT] = ACTIONS(3403),
    [anon_sym_use] = ACTIONS(3407),
    [anon_sym_use_BANG] = ACTIONS(3403),
    [anon_sym_do_BANG] = ACTIONS(3403),
    [anon_sym_begin] = ACTIONS(3407),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_DOT_DOT2] = ACTIONS(3403),
    [anon_sym_STAR] = ACTIONS(3704),
    [anon_sym_LT2] = ACTIONS(3706),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3708),
    [anon_sym_default] = ACTIONS(3407),
    [anon_sym_or] = ACTIONS(3407),
    [anon_sym_static] = ACTIONS(3407),
    [anon_sym_member] = ACTIONS(3407),
    [anon_sym_interface] = ACTIONS(3407),
    [anon_sym_abstract] = ACTIONS(3407),
    [anon_sym_val] = ACTIONS(3407),
    [anon_sym_override] = ACTIONS(3407),
    [aux_sym_char_token1] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3407),
    [anon_sym_DQUOTE] = ACTIONS(3407),
    [anon_sym_AT_DQUOTE] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [sym_bool] = ACTIONS(3407),
    [sym_unit] = ACTIONS(3403),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3407),
    [sym_op_identifier] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_PLUS_DOT] = ACTIONS(3407),
    [anon_sym_DASH_DOT] = ACTIONS(3407),
    [anon_sym_PERCENT] = ACTIONS(3407),
    [anon_sym_AMP_AMP] = ACTIONS(3407),
    [anon_sym_TILDE] = ACTIONS(3403),
    [aux_sym_prefix_op_token1] = ACTIONS(3407),
    [aux_sym_infix_op_token1] = ACTIONS(3403),
    [aux_sym_infix_op_token2] = ACTIONS(3407),
    [anon_sym_PIPE_PIPE] = ACTIONS(3407),
    [anon_sym_BANG_EQ] = ACTIONS(3407),
    [anon_sym_COLON_EQ] = ACTIONS(3403),
    [anon_sym_DOLLAR] = ACTIONS(3407),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3407),
    [sym_int] = ACTIONS(3407),
    [sym_xint] = ACTIONS(3403),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3403),
    [sym__newline] = ACTIONS(3403),
    [sym__dedent] = ACTIONS(3403),
  },
  [1261] = {
    [sym_block_comment] = STATE(1261),
    [sym_compiler_directive_decl] = STATE(1261),
    [sym_fsi_directive_decl] = STATE(1261),
    [sym_preproc_line] = STATE(1261),
    [ts_builtin_sym_end] = ACTIONS(3191),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_namespace] = ACTIONS(3193),
    [anon_sym_module] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_open] = ACTIONS(3193),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_type] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_exception] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3564),
    [anon_sym_uy] = ACTIONS(3566),
    [anon_sym_s] = ACTIONS(3568),
    [anon_sym_us] = ACTIONS(3570),
    [anon_sym_l] = ACTIONS(3572),
    [aux_sym_uint32_token1] = ACTIONS(3574),
    [anon_sym_n] = ACTIONS(3576),
    [anon_sym_un] = ACTIONS(3578),
    [anon_sym_L] = ACTIONS(3580),
    [aux_sym_uint64_token1] = ACTIONS(3582),
    [anon_sym_lf] = ACTIONS(3712),
    [anon_sym_LF] = ACTIONS(3714),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3191),
    [anon_sym_POUNDload] = ACTIONS(3191),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1262] = {
    [sym_block_comment] = STATE(1262),
    [sym_compiler_directive_decl] = STATE(1262),
    [sym_fsi_directive_decl] = STATE(1262),
    [sym_preproc_line] = STATE(1262),
    [aux_sym_rules_repeat1] = STATE(1278),
    [ts_builtin_sym_end] = ACTIONS(3691),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_namespace] = ACTIONS(3693),
    [anon_sym_module] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_open] = ACTIONS(3693),
    [anon_sym_LBRACK_LT] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_type] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_and] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [aux_sym_access_modifier_token1] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_with] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_default] = ACTIONS(3693),
    [anon_sym_or] = ACTIONS(3693),
    [anon_sym_static] = ACTIONS(3693),
    [anon_sym_member] = ACTIONS(3693),
    [anon_sym_interface] = ACTIONS(3693),
    [anon_sym_exception] = ACTIONS(3693),
    [anon_sym_abstract] = ACTIONS(3693),
    [anon_sym_val] = ACTIONS(3693),
    [anon_sym_override] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3691),
    [anon_sym_POUNDload] = ACTIONS(3691),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(3695),
  },
  [1263] = {
    [sym_type_arguments] = STATE(1535),
    [sym_long_identifier] = STATE(1477),
    [sym_block_comment] = STATE(1263),
    [sym_compiler_directive_decl] = STATE(1263),
    [sym_fsi_directive_decl] = STATE(1263),
    [sym_preproc_line] = STATE(1263),
    [aux_sym_compound_type_repeat1] = STATE(1415),
    [sym_identifier] = ACTIONS(3716),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_LBRACK_LT] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [aux_sym_access_modifier_token1] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3427),
    [anon_sym_DOT] = ACTIONS(3427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_with] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_COLON_GT] = ACTIONS(3425),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(3718),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_LT_DASH] = ACTIONS(3427),
    [anon_sym_DOT_LBRACK] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(3720),
    [anon_sym_LT2] = ACTIONS(3722),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3724),
    [anon_sym_default] = ACTIONS(3427),
    [anon_sym_or] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_member] = ACTIONS(3427),
    [anon_sym_interface] = ACTIONS(3427),
    [anon_sym_abstract] = ACTIONS(3427),
    [anon_sym_val] = ACTIONS(3427),
    [anon_sym_override] = ACTIONS(3427),
    [anon_sym_inherit] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3427),
    [anon_sym_DASH_DOT] = ACTIONS(3427),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3427),
    [aux_sym_infix_op_token1] = ACTIONS(3425),
    [aux_sym_infix_op_token2] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3427),
    [anon_sym_COLON_EQ] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3427),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [anon_sym_POUNDendif] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
  },
  [1264] = {
    [sym_type_arguments] = STATE(1535),
    [sym_long_identifier] = STATE(1477),
    [sym_block_comment] = STATE(1264),
    [sym_compiler_directive_decl] = STATE(1264),
    [sym_fsi_directive_decl] = STATE(1264),
    [sym_preproc_line] = STATE(1264),
    [aux_sym_compound_type_repeat1] = STATE(1415),
    [sym_identifier] = ACTIONS(3716),
    [anon_sym_EQ] = ACTIONS(3429),
    [anon_sym_LBRACK_LT] = ACTIONS(3429),
    [anon_sym_COLON] = ACTIONS(3431),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_let] = ACTIONS(3431),
    [anon_sym_let_BANG] = ACTIONS(3429),
    [aux_sym_access_modifier_token1] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(3431),
    [anon_sym_COMMA] = ACTIONS(3429),
    [anon_sym_null] = ACTIONS(3431),
    [anon_sym_QMARK] = ACTIONS(3431),
    [anon_sym_COLON_QMARK] = ACTIONS(3431),
    [anon_sym_COLON_COLON] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_LT_AT] = ACTIONS(3431),
    [anon_sym_LT_AT_AT] = ACTIONS(3431),
    [anon_sym_DOT] = ACTIONS(3431),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_with] = ACTIONS(3431),
    [anon_sym_return_BANG] = ACTIONS(3429),
    [anon_sym_yield] = ACTIONS(3431),
    [anon_sym_yield_BANG] = ACTIONS(3429),
    [anon_sym_lazy] = ACTIONS(3431),
    [anon_sym_assert] = ACTIONS(3431),
    [anon_sym_upcast] = ACTIONS(3431),
    [anon_sym_downcast] = ACTIONS(3431),
    [anon_sym_COLON_GT] = ACTIONS(3429),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_fun] = ACTIONS(3431),
    [anon_sym_DASH_GT] = ACTIONS(3718),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_match] = ACTIONS(3431),
    [anon_sym_match_BANG] = ACTIONS(3429),
    [anon_sym_function] = ACTIONS(3431),
    [anon_sym_LT_DASH] = ACTIONS(3431),
    [anon_sym_DOT_LBRACK] = ACTIONS(3429),
    [anon_sym_LT] = ACTIONS(3429),
    [anon_sym_use] = ACTIONS(3431),
    [anon_sym_use_BANG] = ACTIONS(3429),
    [anon_sym_do_BANG] = ACTIONS(3429),
    [anon_sym_begin] = ACTIONS(3431),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3720),
    [anon_sym_LT2] = ACTIONS(3722),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3724),
    [anon_sym_default] = ACTIONS(3431),
    [anon_sym_or] = ACTIONS(3431),
    [anon_sym_static] = ACTIONS(3431),
    [anon_sym_member] = ACTIONS(3431),
    [anon_sym_interface] = ACTIONS(3431),
    [anon_sym_abstract] = ACTIONS(3431),
    [anon_sym_val] = ACTIONS(3431),
    [anon_sym_override] = ACTIONS(3431),
    [anon_sym_inherit] = ACTIONS(3431),
    [aux_sym_char_token1] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [anon_sym_AT_DQUOTE] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [sym_bool] = ACTIONS(3431),
    [sym_unit] = ACTIONS(3429),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3431),
    [sym_op_identifier] = ACTIONS(3431),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_DOT] = ACTIONS(3431),
    [anon_sym_DASH_DOT] = ACTIONS(3431),
    [anon_sym_PERCENT] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3429),
    [aux_sym_prefix_op_token1] = ACTIONS(3431),
    [aux_sym_infix_op_token1] = ACTIONS(3429),
    [aux_sym_infix_op_token2] = ACTIONS(3431),
    [anon_sym_PIPE_PIPE] = ACTIONS(3431),
    [anon_sym_BANG_EQ] = ACTIONS(3431),
    [anon_sym_COLON_EQ] = ACTIONS(3429),
    [anon_sym_DOLLAR] = ACTIONS(3431),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3431),
    [sym_int] = ACTIONS(3431),
    [sym_xint] = ACTIONS(3429),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3429),
    [anon_sym_POUNDendif] = ACTIONS(3429),
    [sym__newline] = ACTIONS(3429),
  },
  [1265] = {
    [sym_type_arguments] = STATE(1535),
    [sym_long_identifier] = STATE(1477),
    [sym_block_comment] = STATE(1265),
    [sym_compiler_directive_decl] = STATE(1265),
    [sym_fsi_directive_decl] = STATE(1265),
    [sym_preproc_line] = STATE(1265),
    [aux_sym_compound_type_repeat1] = STATE(1415),
    [sym_identifier] = ACTIONS(3443),
    [anon_sym_EQ] = ACTIONS(3441),
    [anon_sym_LBRACK_LT] = ACTIONS(3441),
    [anon_sym_COLON] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_let] = ACTIONS(3443),
    [anon_sym_let_BANG] = ACTIONS(3441),
    [aux_sym_access_modifier_token1] = ACTIONS(3441),
    [anon_sym_LPAREN] = ACTIONS(3443),
    [anon_sym_COMMA] = ACTIONS(3441),
    [anon_sym_null] = ACTIONS(3443),
    [anon_sym_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_LT_AT] = ACTIONS(3443),
    [anon_sym_LT_AT_AT] = ACTIONS(3443),
    [anon_sym_DOT] = ACTIONS(3443),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_with] = ACTIONS(3443),
    [anon_sym_return_BANG] = ACTIONS(3441),
    [anon_sym_yield] = ACTIONS(3443),
    [anon_sym_yield_BANG] = ACTIONS(3441),
    [anon_sym_lazy] = ACTIONS(3443),
    [anon_sym_assert] = ACTIONS(3443),
    [anon_sym_upcast] = ACTIONS(3443),
    [anon_sym_downcast] = ACTIONS(3443),
    [anon_sym_COLON_GT] = ACTIONS(3441),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3441),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_fun] = ACTIONS(3443),
    [anon_sym_DASH_GT] = ACTIONS(3718),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_match] = ACTIONS(3443),
    [anon_sym_match_BANG] = ACTIONS(3441),
    [anon_sym_function] = ACTIONS(3443),
    [anon_sym_LT_DASH] = ACTIONS(3443),
    [anon_sym_DOT_LBRACK] = ACTIONS(3441),
    [anon_sym_LT] = ACTIONS(3441),
    [anon_sym_use] = ACTIONS(3443),
    [anon_sym_use_BANG] = ACTIONS(3441),
    [anon_sym_do_BANG] = ACTIONS(3441),
    [anon_sym_begin] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(3720),
    [anon_sym_LT2] = ACTIONS(3722),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3724),
    [anon_sym_default] = ACTIONS(3443),
    [anon_sym_or] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_member] = ACTIONS(3443),
    [anon_sym_interface] = ACTIONS(3443),
    [anon_sym_abstract] = ACTIONS(3443),
    [anon_sym_val] = ACTIONS(3443),
    [anon_sym_override] = ACTIONS(3443),
    [anon_sym_inherit] = ACTIONS(3443),
    [aux_sym_char_token1] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3443),
    [anon_sym_AT_DQUOTE] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [sym_bool] = ACTIONS(3443),
    [sym_unit] = ACTIONS(3441),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3443),
    [sym_op_identifier] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_PLUS_DOT] = ACTIONS(3443),
    [anon_sym_DASH_DOT] = ACTIONS(3443),
    [anon_sym_PERCENT] = ACTIONS(3443),
    [anon_sym_AMP_AMP] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3441),
    [aux_sym_prefix_op_token1] = ACTIONS(3443),
    [aux_sym_infix_op_token1] = ACTIONS(3441),
    [aux_sym_infix_op_token2] = ACTIONS(3443),
    [anon_sym_PIPE_PIPE] = ACTIONS(3443),
    [anon_sym_BANG_EQ] = ACTIONS(3443),
    [anon_sym_COLON_EQ] = ACTIONS(3441),
    [anon_sym_DOLLAR] = ACTIONS(3443),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3443),
    [sym_int] = ACTIONS(3443),
    [sym_xint] = ACTIONS(3441),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3441),
    [anon_sym_POUNDendif] = ACTIONS(3441),
    [sym__newline] = ACTIONS(3441),
  },
  [1266] = {
    [sym_type_arguments] = STATE(1535),
    [sym_long_identifier] = STATE(1477),
    [sym_block_comment] = STATE(1266),
    [sym_compiler_directive_decl] = STATE(1266),
    [sym_fsi_directive_decl] = STATE(1266),
    [sym_preproc_line] = STATE(1266),
    [aux_sym_compound_type_repeat1] = STATE(1415),
    [sym_identifier] = ACTIONS(3716),
    [anon_sym_EQ] = ACTIONS(3403),
    [anon_sym_LBRACK_LT] = ACTIONS(3403),
    [anon_sym_COLON] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_let_BANG] = ACTIONS(3403),
    [aux_sym_access_modifier_token1] = ACTIONS(3403),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_COMMA] = ACTIONS(3403),
    [anon_sym_null] = ACTIONS(3407),
    [anon_sym_QMARK] = ACTIONS(3407),
    [anon_sym_COLON_QMARK] = ACTIONS(3407),
    [anon_sym_COLON_COLON] = ACTIONS(3403),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3407),
    [anon_sym_LT_AT] = ACTIONS(3407),
    [anon_sym_LT_AT_AT] = ACTIONS(3407),
    [anon_sym_DOT] = ACTIONS(3407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_with] = ACTIONS(3407),
    [anon_sym_return_BANG] = ACTIONS(3403),
    [anon_sym_yield] = ACTIONS(3407),
    [anon_sym_yield_BANG] = ACTIONS(3403),
    [anon_sym_lazy] = ACTIONS(3407),
    [anon_sym_assert] = ACTIONS(3407),
    [anon_sym_upcast] = ACTIONS(3407),
    [anon_sym_downcast] = ACTIONS(3407),
    [anon_sym_COLON_GT] = ACTIONS(3403),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_fun] = ACTIONS(3407),
    [anon_sym_DASH_GT] = ACTIONS(3718),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_match] = ACTIONS(3407),
    [anon_sym_match_BANG] = ACTIONS(3403),
    [anon_sym_function] = ACTIONS(3407),
    [anon_sym_LT_DASH] = ACTIONS(3407),
    [anon_sym_DOT_LBRACK] = ACTIONS(3403),
    [anon_sym_LT] = ACTIONS(3403),
    [anon_sym_use] = ACTIONS(3407),
    [anon_sym_use_BANG] = ACTIONS(3403),
    [anon_sym_do_BANG] = ACTIONS(3403),
    [anon_sym_begin] = ACTIONS(3407),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3720),
    [anon_sym_LT2] = ACTIONS(3722),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3724),
    [anon_sym_default] = ACTIONS(3407),
    [anon_sym_or] = ACTIONS(3407),
    [anon_sym_static] = ACTIONS(3407),
    [anon_sym_member] = ACTIONS(3407),
    [anon_sym_interface] = ACTIONS(3407),
    [anon_sym_abstract] = ACTIONS(3407),
    [anon_sym_val] = ACTIONS(3407),
    [anon_sym_override] = ACTIONS(3407),
    [anon_sym_inherit] = ACTIONS(3407),
    [aux_sym_char_token1] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3407),
    [anon_sym_DQUOTE] = ACTIONS(3407),
    [anon_sym_AT_DQUOTE] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [sym_bool] = ACTIONS(3407),
    [sym_unit] = ACTIONS(3403),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3407),
    [sym_op_identifier] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_PLUS_DOT] = ACTIONS(3407),
    [anon_sym_DASH_DOT] = ACTIONS(3407),
    [anon_sym_PERCENT] = ACTIONS(3407),
    [anon_sym_AMP_AMP] = ACTIONS(3407),
    [anon_sym_TILDE] = ACTIONS(3403),
    [aux_sym_prefix_op_token1] = ACTIONS(3407),
    [aux_sym_infix_op_token1] = ACTIONS(3403),
    [aux_sym_infix_op_token2] = ACTIONS(3407),
    [anon_sym_PIPE_PIPE] = ACTIONS(3407),
    [anon_sym_BANG_EQ] = ACTIONS(3407),
    [anon_sym_COLON_EQ] = ACTIONS(3403),
    [anon_sym_DOLLAR] = ACTIONS(3407),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3407),
    [sym_int] = ACTIONS(3407),
    [sym_xint] = ACTIONS(3403),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3403),
    [anon_sym_POUNDendif] = ACTIONS(3403),
    [sym__newline] = ACTIONS(3403),
  },
  [1267] = {
    [sym_block_comment] = STATE(1267),
    [sym_compiler_directive_decl] = STATE(1267),
    [sym_fsi_directive_decl] = STATE(1267),
    [sym_preproc_line] = STATE(1267),
    [ts_builtin_sym_end] = ACTIONS(3191),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_namespace] = ACTIONS(3193),
    [anon_sym_module] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_open] = ACTIONS(3193),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_type] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_and] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [aux_sym_access_modifier_token1] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_member] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_exception] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_val] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_f] = ACTIONS(3223),
    [aux_sym_decimal_token1] = ACTIONS(3217),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3191),
    [anon_sym_POUNDload] = ACTIONS(3191),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1268] = {
    [sym_block_comment] = STATE(1268),
    [sym_compiler_directive_decl] = STATE(1268),
    [sym_fsi_directive_decl] = STATE(1268),
    [sym_preproc_line] = STATE(1268),
    [ts_builtin_sym_end] = ACTIONS(3726),
    [sym_identifier] = ACTIONS(3728),
    [anon_sym_namespace] = ACTIONS(3728),
    [anon_sym_module] = ACTIONS(3728),
    [anon_sym_EQ] = ACTIONS(3726),
    [anon_sym_open] = ACTIONS(3728),
    [anon_sym_LBRACK_LT] = ACTIONS(3726),
    [anon_sym_COLON] = ACTIONS(3728),
    [anon_sym_return] = ACTIONS(3728),
    [anon_sym_type] = ACTIONS(3728),
    [anon_sym_do] = ACTIONS(3728),
    [anon_sym_and] = ACTIONS(3728),
    [anon_sym_let] = ACTIONS(3728),
    [anon_sym_let_BANG] = ACTIONS(3726),
    [aux_sym_access_modifier_token1] = ACTIONS(3726),
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_COMMA] = ACTIONS(3726),
    [anon_sym_null] = ACTIONS(3728),
    [anon_sym_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(3726),
    [anon_sym_AMP] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3726),
    [anon_sym_LBRACE] = ACTIONS(3728),
    [anon_sym_LT_AT] = ACTIONS(3728),
    [anon_sym_LT_AT_AT] = ACTIONS(3728),
    [anon_sym_DOT] = ACTIONS(3728),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3726),
    [anon_sym_new] = ACTIONS(3728),
    [anon_sym_with] = ACTIONS(3728),
    [anon_sym_return_BANG] = ACTIONS(3726),
    [anon_sym_yield] = ACTIONS(3728),
    [anon_sym_yield_BANG] = ACTIONS(3726),
    [anon_sym_lazy] = ACTIONS(3728),
    [anon_sym_assert] = ACTIONS(3728),
    [anon_sym_upcast] = ACTIONS(3728),
    [anon_sym_downcast] = ACTIONS(3728),
    [anon_sym_COLON_GT] = ACTIONS(3726),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3726),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_fun] = ACTIONS(3728),
    [anon_sym_try] = ACTIONS(3728),
    [anon_sym_match] = ACTIONS(3728),
    [anon_sym_match_BANG] = ACTIONS(3726),
    [anon_sym_function] = ACTIONS(3728),
    [anon_sym_LT_DASH] = ACTIONS(3728),
    [anon_sym_DOT_LBRACK] = ACTIONS(3726),
    [anon_sym_LT] = ACTIONS(3726),
    [anon_sym_use] = ACTIONS(3728),
    [anon_sym_use_BANG] = ACTIONS(3726),
    [anon_sym_do_BANG] = ACTIONS(3726),
    [anon_sym_begin] = ACTIONS(3728),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_default] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [anon_sym_static] = ACTIONS(3728),
    [anon_sym_member] = ACTIONS(3728),
    [anon_sym_interface] = ACTIONS(3728),
    [anon_sym_exception] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(3728),
    [anon_sym_val] = ACTIONS(3728),
    [anon_sym_override] = ACTIONS(3728),
    [aux_sym_char_token1] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3728),
    [anon_sym_AT_DQUOTE] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [sym_bool] = ACTIONS(3728),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3728),
    [sym_op_identifier] = ACTIONS(3728),
    [anon_sym_PLUS] = ACTIONS(3728),
    [anon_sym_DASH] = ACTIONS(3728),
    [anon_sym_PLUS_DOT] = ACTIONS(3728),
    [anon_sym_DASH_DOT] = ACTIONS(3728),
    [anon_sym_PERCENT] = ACTIONS(3728),
    [anon_sym_AMP_AMP] = ACTIONS(3728),
    [anon_sym_TILDE] = ACTIONS(3726),
    [aux_sym_prefix_op_token1] = ACTIONS(3728),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token2] = ACTIONS(3728),
    [anon_sym_PIPE_PIPE] = ACTIONS(3728),
    [anon_sym_BANG_EQ] = ACTIONS(3728),
    [anon_sym_COLON_EQ] = ACTIONS(3726),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3728),
    [sym_int] = ACTIONS(3728),
    [sym_xint] = ACTIONS(3726),
    [anon_sym_f] = ACTIONS(3728),
    [aux_sym_decimal_token1] = ACTIONS(3728),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3726),
    [anon_sym_POUNDload] = ACTIONS(3726),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3726),
    [sym__newline] = ACTIONS(3726),
  },
  [1269] = {
    [sym_block_comment] = STATE(1269),
    [sym_compiler_directive_decl] = STATE(1269),
    [sym_fsi_directive_decl] = STATE(1269),
    [sym_preproc_line] = STATE(1269),
    [ts_builtin_sym_end] = ACTIONS(3602),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_namespace] = ACTIONS(3604),
    [anon_sym_module] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_open] = ACTIONS(3604),
    [anon_sym_LBRACK_LT] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_type] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_and] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [aux_sym_access_modifier_token1] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_with] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_default] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [anon_sym_static] = ACTIONS(3604),
    [anon_sym_member] = ACTIONS(3604),
    [anon_sym_interface] = ACTIONS(3604),
    [anon_sym_exception] = ACTIONS(3604),
    [anon_sym_abstract] = ACTIONS(3604),
    [anon_sym_val] = ACTIONS(3604),
    [anon_sym_override] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3602),
    [anon_sym_POUNDload] = ACTIONS(3602),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
  },
  [1270] = {
    [sym_type_arguments] = STATE(1491),
    [sym_long_identifier] = STATE(1478),
    [sym_block_comment] = STATE(1270),
    [sym_compiler_directive_decl] = STATE(1270),
    [sym_fsi_directive_decl] = STATE(1270),
    [sym_preproc_line] = STATE(1270),
    [aux_sym_compound_type_repeat1] = STATE(1460),
    [sym_identifier] = ACTIONS(3664),
    [anon_sym_EQ] = ACTIONS(3403),
    [anon_sym_LBRACK_LT] = ACTIONS(3403),
    [anon_sym_COLON] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_and] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_let_BANG] = ACTIONS(3403),
    [aux_sym_access_modifier_token1] = ACTIONS(3403),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_COMMA] = ACTIONS(3403),
    [anon_sym_null] = ACTIONS(3407),
    [anon_sym_QMARK] = ACTIONS(3407),
    [anon_sym_COLON_QMARK] = ACTIONS(3407),
    [anon_sym_COLON_COLON] = ACTIONS(3403),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3407),
    [anon_sym_LT_AT] = ACTIONS(3407),
    [anon_sym_LT_AT_AT] = ACTIONS(3407),
    [anon_sym_DOT] = ACTIONS(3407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_with] = ACTIONS(3407),
    [anon_sym_return_BANG] = ACTIONS(3403),
    [anon_sym_yield] = ACTIONS(3407),
    [anon_sym_yield_BANG] = ACTIONS(3403),
    [anon_sym_lazy] = ACTIONS(3407),
    [anon_sym_assert] = ACTIONS(3407),
    [anon_sym_upcast] = ACTIONS(3407),
    [anon_sym_downcast] = ACTIONS(3407),
    [anon_sym_COLON_GT] = ACTIONS(3403),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_fun] = ACTIONS(3407),
    [anon_sym_DASH_GT] = ACTIONS(3666),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_match] = ACTIONS(3407),
    [anon_sym_match_BANG] = ACTIONS(3403),
    [anon_sym_function] = ACTIONS(3407),
    [anon_sym_LT_DASH] = ACTIONS(3407),
    [anon_sym_DOT_LBRACK] = ACTIONS(3403),
    [anon_sym_LT] = ACTIONS(3403),
    [anon_sym_use] = ACTIONS(3407),
    [anon_sym_use_BANG] = ACTIONS(3403),
    [anon_sym_do_BANG] = ACTIONS(3403),
    [anon_sym_begin] = ACTIONS(3407),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3668),
    [anon_sym_LT2] = ACTIONS(3670),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3672),
    [anon_sym_default] = ACTIONS(3407),
    [anon_sym_or] = ACTIONS(3407),
    [anon_sym_static] = ACTIONS(3407),
    [anon_sym_member] = ACTIONS(3407),
    [anon_sym_interface] = ACTIONS(3407),
    [anon_sym_abstract] = ACTIONS(3407),
    [anon_sym_val] = ACTIONS(3407),
    [anon_sym_override] = ACTIONS(3407),
    [aux_sym_char_token1] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3407),
    [anon_sym_DQUOTE] = ACTIONS(3407),
    [anon_sym_AT_DQUOTE] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [sym_bool] = ACTIONS(3407),
    [sym_unit] = ACTIONS(3403),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3407),
    [sym_op_identifier] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_PLUS_DOT] = ACTIONS(3407),
    [anon_sym_DASH_DOT] = ACTIONS(3407),
    [anon_sym_PERCENT] = ACTIONS(3407),
    [anon_sym_AMP_AMP] = ACTIONS(3407),
    [anon_sym_TILDE] = ACTIONS(3403),
    [aux_sym_prefix_op_token1] = ACTIONS(3407),
    [aux_sym_infix_op_token1] = ACTIONS(3403),
    [aux_sym_infix_op_token2] = ACTIONS(3407),
    [anon_sym_PIPE_PIPE] = ACTIONS(3407),
    [anon_sym_BANG_EQ] = ACTIONS(3407),
    [anon_sym_COLON_EQ] = ACTIONS(3403),
    [anon_sym_DOLLAR] = ACTIONS(3407),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3407),
    [sym_int] = ACTIONS(3407),
    [sym_xint] = ACTIONS(3403),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3403),
    [sym__newline] = ACTIONS(3403),
    [sym__dedent] = ACTIONS(3403),
  },
  [1271] = {
    [sym_type_arguments] = STATE(1471),
    [sym_long_identifier] = STATE(1551),
    [sym_block_comment] = STATE(1271),
    [sym_compiler_directive_decl] = STATE(1271),
    [sym_fsi_directive_decl] = STATE(1271),
    [sym_preproc_line] = STATE(1271),
    [aux_sym_compound_type_repeat1] = STATE(1361),
    [sym_identifier] = ACTIONS(3710),
    [anon_sym_EQ] = ACTIONS(3417),
    [anon_sym_LBRACK_LT] = ACTIONS(3417),
    [anon_sym_COLON] = ACTIONS(3419),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_let] = ACTIONS(3419),
    [anon_sym_let_BANG] = ACTIONS(3417),
    [aux_sym_access_modifier_token1] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(3419),
    [anon_sym_COMMA] = ACTIONS(3417),
    [anon_sym_null] = ACTIONS(3419),
    [anon_sym_QMARK] = ACTIONS(3419),
    [anon_sym_COLON_QMARK] = ACTIONS(3419),
    [anon_sym_COLON_COLON] = ACTIONS(3417),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_LT_AT] = ACTIONS(3419),
    [anon_sym_LT_AT_AT] = ACTIONS(3419),
    [anon_sym_DOT] = ACTIONS(3419),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_with] = ACTIONS(3419),
    [anon_sym_return_BANG] = ACTIONS(3417),
    [anon_sym_yield] = ACTIONS(3419),
    [anon_sym_yield_BANG] = ACTIONS(3417),
    [anon_sym_lazy] = ACTIONS(3419),
    [anon_sym_assert] = ACTIONS(3419),
    [anon_sym_upcast] = ACTIONS(3419),
    [anon_sym_downcast] = ACTIONS(3419),
    [anon_sym_COLON_GT] = ACTIONS(3417),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3417),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_fun] = ACTIONS(3419),
    [anon_sym_DASH_GT] = ACTIONS(3702),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_match] = ACTIONS(3419),
    [anon_sym_match_BANG] = ACTIONS(3417),
    [anon_sym_function] = ACTIONS(3419),
    [anon_sym_LT_DASH] = ACTIONS(3419),
    [anon_sym_DOT_LBRACK] = ACTIONS(3417),
    [anon_sym_LT] = ACTIONS(3417),
    [anon_sym_use] = ACTIONS(3419),
    [anon_sym_use_BANG] = ACTIONS(3417),
    [anon_sym_do_BANG] = ACTIONS(3417),
    [anon_sym_begin] = ACTIONS(3419),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_DOT_DOT2] = ACTIONS(3417),
    [anon_sym_STAR] = ACTIONS(3704),
    [anon_sym_LT2] = ACTIONS(3706),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3708),
    [anon_sym_default] = ACTIONS(3419),
    [anon_sym_or] = ACTIONS(3419),
    [anon_sym_static] = ACTIONS(3419),
    [anon_sym_member] = ACTIONS(3419),
    [anon_sym_interface] = ACTIONS(3419),
    [anon_sym_abstract] = ACTIONS(3419),
    [anon_sym_val] = ACTIONS(3419),
    [anon_sym_override] = ACTIONS(3419),
    [aux_sym_char_token1] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3419),
    [anon_sym_AT_DQUOTE] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [sym_bool] = ACTIONS(3419),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3419),
    [sym_op_identifier] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_PLUS_DOT] = ACTIONS(3419),
    [anon_sym_DASH_DOT] = ACTIONS(3419),
    [anon_sym_PERCENT] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3419),
    [anon_sym_TILDE] = ACTIONS(3417),
    [aux_sym_prefix_op_token1] = ACTIONS(3419),
    [aux_sym_infix_op_token1] = ACTIONS(3417),
    [aux_sym_infix_op_token2] = ACTIONS(3419),
    [anon_sym_PIPE_PIPE] = ACTIONS(3419),
    [anon_sym_BANG_EQ] = ACTIONS(3419),
    [anon_sym_COLON_EQ] = ACTIONS(3417),
    [anon_sym_DOLLAR] = ACTIONS(3419),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3419),
    [sym_int] = ACTIONS(3419),
    [sym_xint] = ACTIONS(3417),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3417),
    [sym__newline] = ACTIONS(3417),
    [sym__dedent] = ACTIONS(3417),
  },
  [1272] = {
    [sym_block_comment] = STATE(1272),
    [sym_compiler_directive_decl] = STATE(1272),
    [sym_fsi_directive_decl] = STATE(1272),
    [sym_preproc_line] = STATE(1272),
    [ts_builtin_sym_end] = ACTIONS(3698),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_namespace] = ACTIONS(3700),
    [anon_sym_module] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_open] = ACTIONS(3700),
    [anon_sym_LBRACK_LT] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_type] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_and] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [aux_sym_access_modifier_token1] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_else] = ACTIONS(3700),
    [anon_sym_elif] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_default] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [anon_sym_static] = ACTIONS(3700),
    [anon_sym_member] = ACTIONS(3700),
    [anon_sym_interface] = ACTIONS(3700),
    [anon_sym_exception] = ACTIONS(3700),
    [anon_sym_abstract] = ACTIONS(3700),
    [anon_sym_val] = ACTIONS(3700),
    [anon_sym_override] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3698),
    [anon_sym_POUNDload] = ACTIONS(3698),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [1273] = {
    [sym_type_arguments] = STATE(1535),
    [sym_long_identifier] = STATE(1477),
    [sym_block_comment] = STATE(1273),
    [sym_compiler_directive_decl] = STATE(1273),
    [sym_fsi_directive_decl] = STATE(1273),
    [sym_preproc_line] = STATE(1273),
    [aux_sym_compound_type_repeat1] = STATE(1415),
    [sym_identifier] = ACTIONS(3716),
    [anon_sym_EQ] = ACTIONS(3417),
    [anon_sym_LBRACK_LT] = ACTIONS(3417),
    [anon_sym_COLON] = ACTIONS(3419),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_let] = ACTIONS(3419),
    [anon_sym_let_BANG] = ACTIONS(3417),
    [aux_sym_access_modifier_token1] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(3419),
    [anon_sym_COMMA] = ACTIONS(3417),
    [anon_sym_null] = ACTIONS(3419),
    [anon_sym_QMARK] = ACTIONS(3419),
    [anon_sym_COLON_QMARK] = ACTIONS(3419),
    [anon_sym_COLON_COLON] = ACTIONS(3417),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_LT_AT] = ACTIONS(3419),
    [anon_sym_LT_AT_AT] = ACTIONS(3419),
    [anon_sym_DOT] = ACTIONS(3419),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_with] = ACTIONS(3419),
    [anon_sym_return_BANG] = ACTIONS(3417),
    [anon_sym_yield] = ACTIONS(3419),
    [anon_sym_yield_BANG] = ACTIONS(3417),
    [anon_sym_lazy] = ACTIONS(3419),
    [anon_sym_assert] = ACTIONS(3419),
    [anon_sym_upcast] = ACTIONS(3419),
    [anon_sym_downcast] = ACTIONS(3419),
    [anon_sym_COLON_GT] = ACTIONS(3417),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3417),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_fun] = ACTIONS(3419),
    [anon_sym_DASH_GT] = ACTIONS(3718),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_match] = ACTIONS(3419),
    [anon_sym_match_BANG] = ACTIONS(3417),
    [anon_sym_function] = ACTIONS(3419),
    [anon_sym_LT_DASH] = ACTIONS(3419),
    [anon_sym_DOT_LBRACK] = ACTIONS(3417),
    [anon_sym_LT] = ACTIONS(3417),
    [anon_sym_use] = ACTIONS(3419),
    [anon_sym_use_BANG] = ACTIONS(3417),
    [anon_sym_do_BANG] = ACTIONS(3417),
    [anon_sym_begin] = ACTIONS(3419),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(3720),
    [anon_sym_LT2] = ACTIONS(3722),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3724),
    [anon_sym_default] = ACTIONS(3419),
    [anon_sym_or] = ACTIONS(3419),
    [anon_sym_static] = ACTIONS(3419),
    [anon_sym_member] = ACTIONS(3419),
    [anon_sym_interface] = ACTIONS(3419),
    [anon_sym_abstract] = ACTIONS(3419),
    [anon_sym_val] = ACTIONS(3419),
    [anon_sym_override] = ACTIONS(3419),
    [anon_sym_inherit] = ACTIONS(3419),
    [aux_sym_char_token1] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3419),
    [anon_sym_AT_DQUOTE] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [sym_bool] = ACTIONS(3419),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3419),
    [sym_op_identifier] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_PLUS_DOT] = ACTIONS(3419),
    [anon_sym_DASH_DOT] = ACTIONS(3419),
    [anon_sym_PERCENT] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3419),
    [anon_sym_TILDE] = ACTIONS(3417),
    [aux_sym_prefix_op_token1] = ACTIONS(3419),
    [aux_sym_infix_op_token1] = ACTIONS(3417),
    [aux_sym_infix_op_token2] = ACTIONS(3419),
    [anon_sym_PIPE_PIPE] = ACTIONS(3419),
    [anon_sym_BANG_EQ] = ACTIONS(3419),
    [anon_sym_COLON_EQ] = ACTIONS(3417),
    [anon_sym_DOLLAR] = ACTIONS(3419),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3419),
    [sym_int] = ACTIONS(3419),
    [sym_xint] = ACTIONS(3417),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3417),
    [anon_sym_POUNDendif] = ACTIONS(3417),
    [sym__newline] = ACTIONS(3417),
  },
  [1274] = {
    [sym_block_comment] = STATE(1274),
    [sym_compiler_directive_decl] = STATE(1274),
    [sym_fsi_directive_decl] = STATE(1274),
    [sym_preproc_line] = STATE(1274),
    [ts_builtin_sym_end] = ACTIONS(3730),
    [sym_identifier] = ACTIONS(3732),
    [anon_sym_namespace] = ACTIONS(3732),
    [anon_sym_module] = ACTIONS(3732),
    [anon_sym_EQ] = ACTIONS(3730),
    [anon_sym_open] = ACTIONS(3732),
    [anon_sym_LBRACK_LT] = ACTIONS(3730),
    [anon_sym_COLON] = ACTIONS(3732),
    [anon_sym_return] = ACTIONS(3732),
    [anon_sym_type] = ACTIONS(3732),
    [anon_sym_do] = ACTIONS(3732),
    [anon_sym_and] = ACTIONS(3732),
    [anon_sym_let] = ACTIONS(3732),
    [anon_sym_let_BANG] = ACTIONS(3730),
    [aux_sym_access_modifier_token1] = ACTIONS(3730),
    [anon_sym_LPAREN] = ACTIONS(3732),
    [anon_sym_COMMA] = ACTIONS(3730),
    [anon_sym_null] = ACTIONS(3732),
    [anon_sym_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_LBRACK] = ACTIONS(3732),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3730),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_LT_AT] = ACTIONS(3732),
    [anon_sym_LT_AT_AT] = ACTIONS(3732),
    [anon_sym_DOT] = ACTIONS(3732),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3730),
    [anon_sym_new] = ACTIONS(3732),
    [anon_sym_with] = ACTIONS(3732),
    [anon_sym_return_BANG] = ACTIONS(3730),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_yield_BANG] = ACTIONS(3730),
    [anon_sym_lazy] = ACTIONS(3732),
    [anon_sym_assert] = ACTIONS(3732),
    [anon_sym_upcast] = ACTIONS(3732),
    [anon_sym_downcast] = ACTIONS(3732),
    [anon_sym_COLON_GT] = ACTIONS(3730),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3730),
    [anon_sym_for] = ACTIONS(3732),
    [anon_sym_while] = ACTIONS(3732),
    [anon_sym_else] = ACTIONS(3732),
    [anon_sym_elif] = ACTIONS(3732),
    [anon_sym_if] = ACTIONS(3732),
    [anon_sym_fun] = ACTIONS(3732),
    [anon_sym_try] = ACTIONS(3732),
    [anon_sym_match] = ACTIONS(3732),
    [anon_sym_match_BANG] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3732),
    [anon_sym_LT_DASH] = ACTIONS(3732),
    [anon_sym_DOT_LBRACK] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3730),
    [anon_sym_use] = ACTIONS(3732),
    [anon_sym_use_BANG] = ACTIONS(3730),
    [anon_sym_do_BANG] = ACTIONS(3730),
    [anon_sym_begin] = ACTIONS(3732),
    [anon_sym_LPAREN2] = ACTIONS(3732),
    [anon_sym_default] = ACTIONS(3732),
    [anon_sym_or] = ACTIONS(3732),
    [anon_sym_static] = ACTIONS(3732),
    [anon_sym_member] = ACTIONS(3732),
    [anon_sym_interface] = ACTIONS(3732),
    [anon_sym_exception] = ACTIONS(3732),
    [anon_sym_abstract] = ACTIONS(3732),
    [anon_sym_val] = ACTIONS(3732),
    [anon_sym_override] = ACTIONS(3732),
    [aux_sym_char_token1] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3732),
    [anon_sym_DQUOTE] = ACTIONS(3732),
    [anon_sym_AT_DQUOTE] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [sym_bool] = ACTIONS(3732),
    [sym_unit] = ACTIONS(3730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3732),
    [sym_op_identifier] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PLUS_DOT] = ACTIONS(3732),
    [anon_sym_DASH_DOT] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3732),
    [anon_sym_AMP_AMP] = ACTIONS(3732),
    [anon_sym_TILDE] = ACTIONS(3730),
    [aux_sym_prefix_op_token1] = ACTIONS(3732),
    [aux_sym_infix_op_token1] = ACTIONS(3730),
    [aux_sym_infix_op_token2] = ACTIONS(3732),
    [anon_sym_PIPE_PIPE] = ACTIONS(3732),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_COLON_EQ] = ACTIONS(3730),
    [anon_sym_DOLLAR] = ACTIONS(3732),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3732),
    [sym_int] = ACTIONS(3732),
    [sym_xint] = ACTIONS(3730),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3730),
    [anon_sym_POUNDload] = ACTIONS(3730),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3730),
    [sym__newline] = ACTIONS(3730),
  },
  [1275] = {
    [sym_type_arguments] = STATE(1491),
    [sym_long_identifier] = STATE(1478),
    [sym_block_comment] = STATE(1275),
    [sym_compiler_directive_decl] = STATE(1275),
    [sym_fsi_directive_decl] = STATE(1275),
    [sym_preproc_line] = STATE(1275),
    [aux_sym_compound_type_repeat1] = STATE(1460),
    [sym_identifier] = ACTIONS(3664),
    [anon_sym_EQ] = ACTIONS(3417),
    [anon_sym_LBRACK_LT] = ACTIONS(3417),
    [anon_sym_COLON] = ACTIONS(3419),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_and] = ACTIONS(3419),
    [anon_sym_let] = ACTIONS(3419),
    [anon_sym_let_BANG] = ACTIONS(3417),
    [aux_sym_access_modifier_token1] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(3419),
    [anon_sym_COMMA] = ACTIONS(3417),
    [anon_sym_null] = ACTIONS(3419),
    [anon_sym_QMARK] = ACTIONS(3419),
    [anon_sym_COLON_QMARK] = ACTIONS(3419),
    [anon_sym_COLON_COLON] = ACTIONS(3417),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_LT_AT] = ACTIONS(3419),
    [anon_sym_LT_AT_AT] = ACTIONS(3419),
    [anon_sym_DOT] = ACTIONS(3419),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_with] = ACTIONS(3419),
    [anon_sym_return_BANG] = ACTIONS(3417),
    [anon_sym_yield] = ACTIONS(3419),
    [anon_sym_yield_BANG] = ACTIONS(3417),
    [anon_sym_lazy] = ACTIONS(3419),
    [anon_sym_assert] = ACTIONS(3419),
    [anon_sym_upcast] = ACTIONS(3419),
    [anon_sym_downcast] = ACTIONS(3419),
    [anon_sym_COLON_GT] = ACTIONS(3417),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3417),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_fun] = ACTIONS(3419),
    [anon_sym_DASH_GT] = ACTIONS(3666),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_match] = ACTIONS(3419),
    [anon_sym_match_BANG] = ACTIONS(3417),
    [anon_sym_function] = ACTIONS(3419),
    [anon_sym_LT_DASH] = ACTIONS(3419),
    [anon_sym_DOT_LBRACK] = ACTIONS(3417),
    [anon_sym_LT] = ACTIONS(3417),
    [anon_sym_use] = ACTIONS(3419),
    [anon_sym_use_BANG] = ACTIONS(3417),
    [anon_sym_do_BANG] = ACTIONS(3417),
    [anon_sym_begin] = ACTIONS(3419),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(3668),
    [anon_sym_LT2] = ACTIONS(3670),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3672),
    [anon_sym_default] = ACTIONS(3419),
    [anon_sym_or] = ACTIONS(3419),
    [anon_sym_static] = ACTIONS(3419),
    [anon_sym_member] = ACTIONS(3419),
    [anon_sym_interface] = ACTIONS(3419),
    [anon_sym_abstract] = ACTIONS(3419),
    [anon_sym_val] = ACTIONS(3419),
    [anon_sym_override] = ACTIONS(3419),
    [aux_sym_char_token1] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3419),
    [anon_sym_AT_DQUOTE] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [sym_bool] = ACTIONS(3419),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3419),
    [sym_op_identifier] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_PLUS_DOT] = ACTIONS(3419),
    [anon_sym_DASH_DOT] = ACTIONS(3419),
    [anon_sym_PERCENT] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3419),
    [anon_sym_TILDE] = ACTIONS(3417),
    [aux_sym_prefix_op_token1] = ACTIONS(3419),
    [aux_sym_infix_op_token1] = ACTIONS(3417),
    [aux_sym_infix_op_token2] = ACTIONS(3419),
    [anon_sym_PIPE_PIPE] = ACTIONS(3419),
    [anon_sym_BANG_EQ] = ACTIONS(3419),
    [anon_sym_COLON_EQ] = ACTIONS(3417),
    [anon_sym_DOLLAR] = ACTIONS(3419),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3419),
    [sym_int] = ACTIONS(3419),
    [sym_xint] = ACTIONS(3417),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3417),
    [sym__newline] = ACTIONS(3417),
    [sym__dedent] = ACTIONS(3417),
  },
  [1276] = {
    [sym_block_comment] = STATE(1276),
    [sym_compiler_directive_decl] = STATE(1276),
    [sym_fsi_directive_decl] = STATE(1276),
    [sym_preproc_line] = STATE(1276),
    [aux_sym_rules_repeat1] = STATE(1262),
    [ts_builtin_sym_end] = ACTIONS(3734),
    [sym_identifier] = ACTIONS(3736),
    [anon_sym_namespace] = ACTIONS(3736),
    [anon_sym_module] = ACTIONS(3736),
    [anon_sym_EQ] = ACTIONS(3734),
    [anon_sym_open] = ACTIONS(3736),
    [anon_sym_LBRACK_LT] = ACTIONS(3734),
    [anon_sym_COLON] = ACTIONS(3736),
    [anon_sym_return] = ACTIONS(3736),
    [anon_sym_type] = ACTIONS(3736),
    [anon_sym_do] = ACTIONS(3736),
    [anon_sym_and] = ACTIONS(3736),
    [anon_sym_let] = ACTIONS(3736),
    [anon_sym_let_BANG] = ACTIONS(3734),
    [aux_sym_access_modifier_token1] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3736),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_null] = ACTIONS(3736),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_COLON] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3736),
    [anon_sym_LBRACK] = ACTIONS(3736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3734),
    [anon_sym_LBRACE] = ACTIONS(3736),
    [anon_sym_LT_AT] = ACTIONS(3736),
    [anon_sym_LT_AT_AT] = ACTIONS(3736),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3734),
    [anon_sym_new] = ACTIONS(3736),
    [anon_sym_with] = ACTIONS(3736),
    [anon_sym_return_BANG] = ACTIONS(3734),
    [anon_sym_yield] = ACTIONS(3736),
    [anon_sym_yield_BANG] = ACTIONS(3734),
    [anon_sym_lazy] = ACTIONS(3736),
    [anon_sym_assert] = ACTIONS(3736),
    [anon_sym_upcast] = ACTIONS(3736),
    [anon_sym_downcast] = ACTIONS(3736),
    [anon_sym_COLON_GT] = ACTIONS(3734),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3734),
    [anon_sym_for] = ACTIONS(3736),
    [anon_sym_while] = ACTIONS(3736),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_fun] = ACTIONS(3736),
    [anon_sym_try] = ACTIONS(3736),
    [anon_sym_match] = ACTIONS(3736),
    [anon_sym_match_BANG] = ACTIONS(3734),
    [anon_sym_function] = ACTIONS(3736),
    [anon_sym_LT_DASH] = ACTIONS(3736),
    [anon_sym_DOT_LBRACK] = ACTIONS(3734),
    [anon_sym_LT] = ACTIONS(3734),
    [anon_sym_use] = ACTIONS(3736),
    [anon_sym_use_BANG] = ACTIONS(3734),
    [anon_sym_do_BANG] = ACTIONS(3734),
    [anon_sym_begin] = ACTIONS(3736),
    [anon_sym_LPAREN2] = ACTIONS(3736),
    [anon_sym_default] = ACTIONS(3736),
    [anon_sym_or] = ACTIONS(3736),
    [anon_sym_static] = ACTIONS(3736),
    [anon_sym_member] = ACTIONS(3736),
    [anon_sym_interface] = ACTIONS(3736),
    [anon_sym_exception] = ACTIONS(3736),
    [anon_sym_abstract] = ACTIONS(3736),
    [anon_sym_val] = ACTIONS(3736),
    [anon_sym_override] = ACTIONS(3736),
    [aux_sym_char_token1] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3736),
    [anon_sym_DQUOTE] = ACTIONS(3736),
    [anon_sym_AT_DQUOTE] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [sym_bool] = ACTIONS(3736),
    [sym_unit] = ACTIONS(3734),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3736),
    [sym_op_identifier] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS_DOT] = ACTIONS(3736),
    [anon_sym_DASH_DOT] = ACTIONS(3736),
    [anon_sym_PERCENT] = ACTIONS(3736),
    [anon_sym_AMP_AMP] = ACTIONS(3736),
    [anon_sym_TILDE] = ACTIONS(3734),
    [aux_sym_prefix_op_token1] = ACTIONS(3736),
    [aux_sym_infix_op_token1] = ACTIONS(3734),
    [aux_sym_infix_op_token2] = ACTIONS(3736),
    [anon_sym_PIPE_PIPE] = ACTIONS(3736),
    [anon_sym_BANG_EQ] = ACTIONS(3736),
    [anon_sym_COLON_EQ] = ACTIONS(3734),
    [anon_sym_DOLLAR] = ACTIONS(3736),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3736),
    [sym_int] = ACTIONS(3736),
    [sym_xint] = ACTIONS(3734),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3734),
    [anon_sym_POUNDload] = ACTIONS(3734),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3734),
    [sym__newline] = ACTIONS(3738),
  },
  [1277] = {
    [sym_type_arguments] = STATE(1487),
    [sym_long_identifier] = STATE(1482),
    [sym_block_comment] = STATE(1277),
    [sym_compiler_directive_decl] = STATE(1277),
    [sym_fsi_directive_decl] = STATE(1277),
    [sym_preproc_line] = STATE(1277),
    [aux_sym_compound_type_repeat1] = STATE(1363),
    [sym_identifier] = ACTIONS(3443),
    [anon_sym_EQ] = ACTIONS(3441),
    [anon_sym_LBRACK_LT] = ACTIONS(3441),
    [anon_sym_COLON] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_and] = ACTIONS(3443),
    [anon_sym_let] = ACTIONS(3443),
    [anon_sym_let_BANG] = ACTIONS(3441),
    [aux_sym_access_modifier_token1] = ACTIONS(3441),
    [anon_sym_LPAREN] = ACTIONS(3443),
    [anon_sym_COMMA] = ACTIONS(3441),
    [anon_sym_null] = ACTIONS(3443),
    [anon_sym_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_LT_AT] = ACTIONS(3443),
    [anon_sym_LT_AT_AT] = ACTIONS(3443),
    [anon_sym_DOT] = ACTIONS(3443),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_with] = ACTIONS(3443),
    [anon_sym_return_BANG] = ACTIONS(3441),
    [anon_sym_yield] = ACTIONS(3443),
    [anon_sym_yield_BANG] = ACTIONS(3441),
    [anon_sym_lazy] = ACTIONS(3443),
    [anon_sym_assert] = ACTIONS(3443),
    [anon_sym_upcast] = ACTIONS(3443),
    [anon_sym_downcast] = ACTIONS(3443),
    [anon_sym_COLON_GT] = ACTIONS(3441),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3441),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_fun] = ACTIONS(3443),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_match] = ACTIONS(3443),
    [anon_sym_match_BANG] = ACTIONS(3441),
    [anon_sym_function] = ACTIONS(3443),
    [anon_sym_LT_DASH] = ACTIONS(3443),
    [anon_sym_DOT_LBRACK] = ACTIONS(3441),
    [anon_sym_LT] = ACTIONS(3441),
    [anon_sym_use] = ACTIONS(3443),
    [anon_sym_use_BANG] = ACTIONS(3441),
    [anon_sym_do_BANG] = ACTIONS(3441),
    [anon_sym_begin] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_LT2] = ACTIONS(3656),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3658),
    [anon_sym_default] = ACTIONS(3443),
    [anon_sym_or] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_member] = ACTIONS(3443),
    [anon_sym_interface] = ACTIONS(3443),
    [anon_sym_abstract] = ACTIONS(3443),
    [anon_sym_val] = ACTIONS(3443),
    [anon_sym_override] = ACTIONS(3443),
    [aux_sym_char_token1] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3443),
    [anon_sym_AT_DQUOTE] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [sym_bool] = ACTIONS(3443),
    [sym_unit] = ACTIONS(3441),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3443),
    [sym_op_identifier] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_PLUS_DOT] = ACTIONS(3443),
    [anon_sym_DASH_DOT] = ACTIONS(3443),
    [anon_sym_PERCENT] = ACTIONS(3443),
    [anon_sym_AMP_AMP] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3441),
    [aux_sym_prefix_op_token1] = ACTIONS(3443),
    [aux_sym_infix_op_token1] = ACTIONS(3441),
    [aux_sym_infix_op_token2] = ACTIONS(3443),
    [anon_sym_PIPE_PIPE] = ACTIONS(3443),
    [anon_sym_BANG_EQ] = ACTIONS(3443),
    [anon_sym_COLON_EQ] = ACTIONS(3441),
    [anon_sym_DOLLAR] = ACTIONS(3443),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3443),
    [sym_int] = ACTIONS(3443),
    [sym_xint] = ACTIONS(3441),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3441),
    [anon_sym_POUNDendif] = ACTIONS(3441),
    [sym__newline] = ACTIONS(3441),
  },
  [1278] = {
    [sym_block_comment] = STATE(1278),
    [sym_compiler_directive_decl] = STATE(1278),
    [sym_fsi_directive_decl] = STATE(1278),
    [sym_preproc_line] = STATE(1278),
    [aux_sym_rules_repeat1] = STATE(1278),
    [ts_builtin_sym_end] = ACTIONS(3741),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_namespace] = ACTIONS(3743),
    [anon_sym_module] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_open] = ACTIONS(3743),
    [anon_sym_LBRACK_LT] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_type] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_and] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [aux_sym_access_modifier_token1] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(3745),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_with] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_default] = ACTIONS(3743),
    [anon_sym_or] = ACTIONS(3743),
    [anon_sym_static] = ACTIONS(3743),
    [anon_sym_member] = ACTIONS(3743),
    [anon_sym_interface] = ACTIONS(3743),
    [anon_sym_exception] = ACTIONS(3743),
    [anon_sym_abstract] = ACTIONS(3743),
    [anon_sym_val] = ACTIONS(3743),
    [anon_sym_override] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3741),
    [anon_sym_POUNDload] = ACTIONS(3741),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [sym__newline] = ACTIONS(3748),
  },
  [1279] = {
    [sym_block_comment] = STATE(1279),
    [sym_compiler_directive_decl] = STATE(1279),
    [sym_fsi_directive_decl] = STATE(1279),
    [sym_preproc_line] = STATE(1279),
    [ts_builtin_sym_end] = ACTIONS(3751),
    [sym_identifier] = ACTIONS(3753),
    [anon_sym_namespace] = ACTIONS(3753),
    [anon_sym_module] = ACTIONS(3753),
    [anon_sym_EQ] = ACTIONS(3751),
    [anon_sym_open] = ACTIONS(3753),
    [anon_sym_LBRACK_LT] = ACTIONS(3751),
    [anon_sym_COLON] = ACTIONS(3753),
    [anon_sym_return] = ACTIONS(3753),
    [anon_sym_type] = ACTIONS(3753),
    [anon_sym_do] = ACTIONS(3753),
    [anon_sym_and] = ACTIONS(3753),
    [anon_sym_let] = ACTIONS(3753),
    [anon_sym_let_BANG] = ACTIONS(3751),
    [aux_sym_access_modifier_token1] = ACTIONS(3751),
    [anon_sym_LPAREN] = ACTIONS(3753),
    [anon_sym_COMMA] = ACTIONS(3751),
    [anon_sym_null] = ACTIONS(3753),
    [anon_sym_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_COLON] = ACTIONS(3751),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3751),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_LT_AT] = ACTIONS(3753),
    [anon_sym_LT_AT_AT] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3753),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3751),
    [anon_sym_new] = ACTIONS(3753),
    [anon_sym_with] = ACTIONS(3753),
    [anon_sym_return_BANG] = ACTIONS(3751),
    [anon_sym_yield] = ACTIONS(3753),
    [anon_sym_yield_BANG] = ACTIONS(3751),
    [anon_sym_lazy] = ACTIONS(3753),
    [anon_sym_assert] = ACTIONS(3753),
    [anon_sym_upcast] = ACTIONS(3753),
    [anon_sym_downcast] = ACTIONS(3753),
    [anon_sym_COLON_GT] = ACTIONS(3751),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3751),
    [anon_sym_for] = ACTIONS(3753),
    [anon_sym_while] = ACTIONS(3753),
    [anon_sym_if] = ACTIONS(3753),
    [anon_sym_fun] = ACTIONS(3753),
    [anon_sym_try] = ACTIONS(3753),
    [anon_sym_match] = ACTIONS(3753),
    [anon_sym_match_BANG] = ACTIONS(3751),
    [anon_sym_function] = ACTIONS(3753),
    [anon_sym_LT_DASH] = ACTIONS(3753),
    [anon_sym_DOT_LBRACK] = ACTIONS(3751),
    [anon_sym_LT] = ACTIONS(3751),
    [anon_sym_use] = ACTIONS(3753),
    [anon_sym_use_BANG] = ACTIONS(3751),
    [anon_sym_do_BANG] = ACTIONS(3751),
    [anon_sym_begin] = ACTIONS(3753),
    [anon_sym_LPAREN2] = ACTIONS(3753),
    [anon_sym_default] = ACTIONS(3753),
    [anon_sym_or] = ACTIONS(3753),
    [anon_sym_static] = ACTIONS(3753),
    [anon_sym_member] = ACTIONS(3753),
    [anon_sym_interface] = ACTIONS(3753),
    [anon_sym_exception] = ACTIONS(3753),
    [anon_sym_abstract] = ACTIONS(3753),
    [anon_sym_val] = ACTIONS(3753),
    [anon_sym_override] = ACTIONS(3753),
    [aux_sym_char_token1] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3753),
    [anon_sym_AT_DQUOTE] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [sym_bool] = ACTIONS(3753),
    [sym_unit] = ACTIONS(3751),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3753),
    [sym_op_identifier] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PLUS_DOT] = ACTIONS(3753),
    [anon_sym_DASH_DOT] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3753),
    [anon_sym_AMP_AMP] = ACTIONS(3753),
    [anon_sym_TILDE] = ACTIONS(3751),
    [aux_sym_prefix_op_token1] = ACTIONS(3753),
    [aux_sym_infix_op_token1] = ACTIONS(3751),
    [aux_sym_infix_op_token2] = ACTIONS(3753),
    [anon_sym_PIPE_PIPE] = ACTIONS(3753),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_COLON_EQ] = ACTIONS(3751),
    [anon_sym_DOLLAR] = ACTIONS(3753),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3753),
    [sym_int] = ACTIONS(3755),
    [sym_xint] = ACTIONS(3751),
    [anon_sym_f] = ACTIONS(3753),
    [aux_sym_decimal_token1] = ACTIONS(3753),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3751),
    [anon_sym_POUNDload] = ACTIONS(3751),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3751),
    [sym__newline] = ACTIONS(3751),
  },
  [1280] = {
    [sym_type_arguments] = STATE(1487),
    [sym_long_identifier] = STATE(1482),
    [sym_block_comment] = STATE(1280),
    [sym_compiler_directive_decl] = STATE(1280),
    [sym_fsi_directive_decl] = STATE(1280),
    [sym_preproc_line] = STATE(1280),
    [aux_sym_compound_type_repeat1] = STATE(1363),
    [sym_identifier] = ACTIONS(3650),
    [anon_sym_EQ] = ACTIONS(3403),
    [anon_sym_LBRACK_LT] = ACTIONS(3403),
    [anon_sym_COLON] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_and] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_let_BANG] = ACTIONS(3403),
    [aux_sym_access_modifier_token1] = ACTIONS(3403),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_COMMA] = ACTIONS(3403),
    [anon_sym_null] = ACTIONS(3407),
    [anon_sym_QMARK] = ACTIONS(3407),
    [anon_sym_COLON_QMARK] = ACTIONS(3407),
    [anon_sym_COLON_COLON] = ACTIONS(3403),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3407),
    [anon_sym_LT_AT] = ACTIONS(3407),
    [anon_sym_LT_AT_AT] = ACTIONS(3407),
    [anon_sym_DOT] = ACTIONS(3407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_with] = ACTIONS(3407),
    [anon_sym_return_BANG] = ACTIONS(3403),
    [anon_sym_yield] = ACTIONS(3407),
    [anon_sym_yield_BANG] = ACTIONS(3403),
    [anon_sym_lazy] = ACTIONS(3407),
    [anon_sym_assert] = ACTIONS(3407),
    [anon_sym_upcast] = ACTIONS(3407),
    [anon_sym_downcast] = ACTIONS(3407),
    [anon_sym_COLON_GT] = ACTIONS(3403),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_fun] = ACTIONS(3407),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_match] = ACTIONS(3407),
    [anon_sym_match_BANG] = ACTIONS(3403),
    [anon_sym_function] = ACTIONS(3407),
    [anon_sym_LT_DASH] = ACTIONS(3407),
    [anon_sym_DOT_LBRACK] = ACTIONS(3403),
    [anon_sym_LT] = ACTIONS(3403),
    [anon_sym_use] = ACTIONS(3407),
    [anon_sym_use_BANG] = ACTIONS(3403),
    [anon_sym_do_BANG] = ACTIONS(3403),
    [anon_sym_begin] = ACTIONS(3407),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_LT2] = ACTIONS(3656),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3658),
    [anon_sym_default] = ACTIONS(3407),
    [anon_sym_or] = ACTIONS(3407),
    [anon_sym_static] = ACTIONS(3407),
    [anon_sym_member] = ACTIONS(3407),
    [anon_sym_interface] = ACTIONS(3407),
    [anon_sym_abstract] = ACTIONS(3407),
    [anon_sym_val] = ACTIONS(3407),
    [anon_sym_override] = ACTIONS(3407),
    [aux_sym_char_token1] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3407),
    [anon_sym_DQUOTE] = ACTIONS(3407),
    [anon_sym_AT_DQUOTE] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [sym_bool] = ACTIONS(3407),
    [sym_unit] = ACTIONS(3403),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3407),
    [sym_op_identifier] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_PLUS_DOT] = ACTIONS(3407),
    [anon_sym_DASH_DOT] = ACTIONS(3407),
    [anon_sym_PERCENT] = ACTIONS(3407),
    [anon_sym_AMP_AMP] = ACTIONS(3407),
    [anon_sym_TILDE] = ACTIONS(3403),
    [aux_sym_prefix_op_token1] = ACTIONS(3407),
    [aux_sym_infix_op_token1] = ACTIONS(3403),
    [aux_sym_infix_op_token2] = ACTIONS(3407),
    [anon_sym_PIPE_PIPE] = ACTIONS(3407),
    [anon_sym_BANG_EQ] = ACTIONS(3407),
    [anon_sym_COLON_EQ] = ACTIONS(3403),
    [anon_sym_DOLLAR] = ACTIONS(3407),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3407),
    [sym_int] = ACTIONS(3407),
    [sym_xint] = ACTIONS(3403),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3403),
    [anon_sym_POUNDendif] = ACTIONS(3403),
    [sym__newline] = ACTIONS(3403),
  },
  [1281] = {
    [sym_block_comment] = STATE(1281),
    [sym_compiler_directive_decl] = STATE(1281),
    [sym_fsi_directive_decl] = STATE(1281),
    [sym_preproc_line] = STATE(1281),
    [aux_sym_sequential_expression_repeat1] = STATE(1286),
    [ts_builtin_sym_end] = ACTIONS(3757),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_namespace] = ACTIONS(3759),
    [anon_sym_module] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_open] = ACTIONS(3759),
    [anon_sym_LBRACK_LT] = ACTIONS(3757),
    [anon_sym_COLON] = ACTIONS(3759),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_type] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_and] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_let_BANG] = ACTIONS(3757),
    [aux_sym_access_modifier_token1] = ACTIONS(3757),
    [anon_sym_LPAREN] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3757),
    [anon_sym_null] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3757),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_LT_AT] = ACTIONS(3759),
    [anon_sym_LT_AT_AT] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(3759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_with] = ACTIONS(3759),
    [anon_sym_return_BANG] = ACTIONS(3757),
    [anon_sym_yield] = ACTIONS(3759),
    [anon_sym_yield_BANG] = ACTIONS(3757),
    [anon_sym_lazy] = ACTIONS(3759),
    [anon_sym_assert] = ACTIONS(3759),
    [anon_sym_upcast] = ACTIONS(3759),
    [anon_sym_downcast] = ACTIONS(3759),
    [anon_sym_COLON_GT] = ACTIONS(3757),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3757),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_fun] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_match] = ACTIONS(3759),
    [anon_sym_match_BANG] = ACTIONS(3757),
    [anon_sym_function] = ACTIONS(3759),
    [anon_sym_LT_DASH] = ACTIONS(3759),
    [anon_sym_DOT_LBRACK] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_use] = ACTIONS(3759),
    [anon_sym_use_BANG] = ACTIONS(3757),
    [anon_sym_do_BANG] = ACTIONS(3757),
    [anon_sym_begin] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_default] = ACTIONS(3759),
    [anon_sym_or] = ACTIONS(3759),
    [anon_sym_static] = ACTIONS(3759),
    [anon_sym_member] = ACTIONS(3759),
    [anon_sym_interface] = ACTIONS(3759),
    [anon_sym_exception] = ACTIONS(3759),
    [anon_sym_abstract] = ACTIONS(3759),
    [anon_sym_val] = ACTIONS(3759),
    [anon_sym_override] = ACTIONS(3759),
    [aux_sym_char_token1] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3759),
    [anon_sym_DQUOTE] = ACTIONS(3759),
    [anon_sym_AT_DQUOTE] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [sym_bool] = ACTIONS(3759),
    [sym_unit] = ACTIONS(3757),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3759),
    [sym_op_identifier] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS_DOT] = ACTIONS(3759),
    [anon_sym_DASH_DOT] = ACTIONS(3759),
    [anon_sym_PERCENT] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_TILDE] = ACTIONS(3757),
    [aux_sym_prefix_op_token1] = ACTIONS(3759),
    [aux_sym_infix_op_token1] = ACTIONS(3757),
    [aux_sym_infix_op_token2] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_COLON_EQ] = ACTIONS(3757),
    [anon_sym_DOLLAR] = ACTIONS(3759),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3759),
    [sym_int] = ACTIONS(3759),
    [sym_xint] = ACTIONS(3757),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3757),
    [anon_sym_POUNDload] = ACTIONS(3757),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3757),
    [sym__newline] = ACTIONS(3757),
  },
  [1282] = {
    [sym_block_comment] = STATE(1282),
    [sym_compiler_directive_decl] = STATE(1282),
    [sym_fsi_directive_decl] = STATE(1282),
    [sym_preproc_line] = STATE(1282),
    [ts_builtin_sym_end] = ACTIONS(3683),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_namespace] = ACTIONS(3685),
    [anon_sym_module] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_open] = ACTIONS(3685),
    [anon_sym_LBRACK_LT] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_type] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_and] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [aux_sym_access_modifier_token1] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_with] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(3687),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_default] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [anon_sym_static] = ACTIONS(3685),
    [anon_sym_member] = ACTIONS(3685),
    [anon_sym_interface] = ACTIONS(3685),
    [anon_sym_exception] = ACTIONS(3685),
    [anon_sym_abstract] = ACTIONS(3685),
    [anon_sym_val] = ACTIONS(3685),
    [anon_sym_override] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3683),
    [anon_sym_POUNDload] = ACTIONS(3683),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
  },
  [1283] = {
    [sym__else_expression] = STATE(1770),
    [sym_elif_expression] = STATE(1576),
    [sym_block_comment] = STATE(1283),
    [sym_compiler_directive_decl] = STATE(1283),
    [sym_fsi_directive_decl] = STATE(1283),
    [sym_preproc_line] = STATE(1283),
    [aux_sym_if_expression_repeat1] = STATE(1284),
    [sym_identifier] = ACTIONS(3472),
    [anon_sym_EQ] = ACTIONS(3470),
    [anon_sym_LBRACK_LT] = ACTIONS(3470),
    [anon_sym_COLON] = ACTIONS(3472),
    [anon_sym_return] = ACTIONS(3472),
    [anon_sym_do] = ACTIONS(3472),
    [anon_sym_and] = ACTIONS(3472),
    [anon_sym_let] = ACTIONS(3472),
    [anon_sym_let_BANG] = ACTIONS(3470),
    [aux_sym_access_modifier_token1] = ACTIONS(3470),
    [anon_sym_LPAREN] = ACTIONS(3472),
    [anon_sym_COMMA] = ACTIONS(3470),
    [anon_sym_null] = ACTIONS(3472),
    [anon_sym_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_COLON] = ACTIONS(3470),
    [anon_sym_AMP] = ACTIONS(3472),
    [anon_sym_LBRACK] = ACTIONS(3472),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3470),
    [anon_sym_LBRACE] = ACTIONS(3472),
    [anon_sym_LT_AT] = ACTIONS(3472),
    [anon_sym_LT_AT_AT] = ACTIONS(3472),
    [anon_sym_DOT] = ACTIONS(3472),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3470),
    [anon_sym_new] = ACTIONS(3472),
    [anon_sym_with] = ACTIONS(3472),
    [anon_sym_return_BANG] = ACTIONS(3470),
    [anon_sym_yield] = ACTIONS(3472),
    [anon_sym_yield_BANG] = ACTIONS(3470),
    [anon_sym_lazy] = ACTIONS(3472),
    [anon_sym_assert] = ACTIONS(3472),
    [anon_sym_upcast] = ACTIONS(3472),
    [anon_sym_downcast] = ACTIONS(3472),
    [anon_sym_COLON_GT] = ACTIONS(3470),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3470),
    [anon_sym_for] = ACTIONS(3472),
    [anon_sym_while] = ACTIONS(3472),
    [anon_sym_else] = ACTIONS(3761),
    [anon_sym_elif] = ACTIONS(3763),
    [anon_sym_if] = ACTIONS(3472),
    [anon_sym_fun] = ACTIONS(3472),
    [anon_sym_try] = ACTIONS(3472),
    [anon_sym_match] = ACTIONS(3472),
    [anon_sym_match_BANG] = ACTIONS(3470),
    [anon_sym_function] = ACTIONS(3472),
    [anon_sym_LT_DASH] = ACTIONS(3472),
    [anon_sym_DOT_LBRACK] = ACTIONS(3470),
    [anon_sym_LT] = ACTIONS(3470),
    [anon_sym_use] = ACTIONS(3472),
    [anon_sym_use_BANG] = ACTIONS(3470),
    [anon_sym_do_BANG] = ACTIONS(3470),
    [anon_sym_begin] = ACTIONS(3472),
    [anon_sym_LPAREN2] = ACTIONS(3472),
    [anon_sym_default] = ACTIONS(3472),
    [anon_sym_or] = ACTIONS(3472),
    [anon_sym_static] = ACTIONS(3472),
    [anon_sym_member] = ACTIONS(3472),
    [anon_sym_interface] = ACTIONS(3472),
    [anon_sym_abstract] = ACTIONS(3472),
    [anon_sym_val] = ACTIONS(3472),
    [anon_sym_override] = ACTIONS(3472),
    [aux_sym_char_token1] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3472),
    [anon_sym_DQUOTE] = ACTIONS(3472),
    [anon_sym_AT_DQUOTE] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [sym_bool] = ACTIONS(3472),
    [sym_unit] = ACTIONS(3470),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3472),
    [sym_op_identifier] = ACTIONS(3472),
    [anon_sym_PLUS] = ACTIONS(3472),
    [anon_sym_DASH] = ACTIONS(3472),
    [anon_sym_PLUS_DOT] = ACTIONS(3472),
    [anon_sym_DASH_DOT] = ACTIONS(3472),
    [anon_sym_PERCENT] = ACTIONS(3472),
    [anon_sym_AMP_AMP] = ACTIONS(3472),
    [anon_sym_TILDE] = ACTIONS(3470),
    [aux_sym_prefix_op_token1] = ACTIONS(3472),
    [aux_sym_infix_op_token1] = ACTIONS(3470),
    [aux_sym_infix_op_token2] = ACTIONS(3472),
    [anon_sym_PIPE_PIPE] = ACTIONS(3472),
    [anon_sym_BANG_EQ] = ACTIONS(3472),
    [anon_sym_COLON_EQ] = ACTIONS(3470),
    [anon_sym_DOLLAR] = ACTIONS(3472),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3472),
    [sym_int] = ACTIONS(3472),
    [sym_xint] = ACTIONS(3470),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3470),
    [anon_sym_POUNDendif] = ACTIONS(3470),
    [anon_sym_POUNDelse] = ACTIONS(3470),
    [sym__newline] = ACTIONS(3470),
  },
  [1284] = {
    [sym__else_expression] = STATE(1798),
    [sym_elif_expression] = STATE(1576),
    [sym_block_comment] = STATE(1284),
    [sym_compiler_directive_decl] = STATE(1284),
    [sym_fsi_directive_decl] = STATE(1284),
    [sym_preproc_line] = STATE(1284),
    [aux_sym_if_expression_repeat1] = STATE(1321),
    [sym_identifier] = ACTIONS(3457),
    [anon_sym_EQ] = ACTIONS(3455),
    [anon_sym_LBRACK_LT] = ACTIONS(3455),
    [anon_sym_COLON] = ACTIONS(3457),
    [anon_sym_return] = ACTIONS(3457),
    [anon_sym_do] = ACTIONS(3457),
    [anon_sym_and] = ACTIONS(3457),
    [anon_sym_let] = ACTIONS(3457),
    [anon_sym_let_BANG] = ACTIONS(3455),
    [aux_sym_access_modifier_token1] = ACTIONS(3455),
    [anon_sym_LPAREN] = ACTIONS(3457),
    [anon_sym_COMMA] = ACTIONS(3455),
    [anon_sym_null] = ACTIONS(3457),
    [anon_sym_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_COLON] = ACTIONS(3455),
    [anon_sym_AMP] = ACTIONS(3457),
    [anon_sym_LBRACK] = ACTIONS(3457),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3457),
    [anon_sym_LT_AT] = ACTIONS(3457),
    [anon_sym_LT_AT_AT] = ACTIONS(3457),
    [anon_sym_DOT] = ACTIONS(3457),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3457),
    [anon_sym_with] = ACTIONS(3457),
    [anon_sym_return_BANG] = ACTIONS(3455),
    [anon_sym_yield] = ACTIONS(3457),
    [anon_sym_yield_BANG] = ACTIONS(3455),
    [anon_sym_lazy] = ACTIONS(3457),
    [anon_sym_assert] = ACTIONS(3457),
    [anon_sym_upcast] = ACTIONS(3457),
    [anon_sym_downcast] = ACTIONS(3457),
    [anon_sym_COLON_GT] = ACTIONS(3455),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3457),
    [anon_sym_while] = ACTIONS(3457),
    [anon_sym_else] = ACTIONS(3761),
    [anon_sym_elif] = ACTIONS(3763),
    [anon_sym_if] = ACTIONS(3457),
    [anon_sym_fun] = ACTIONS(3457),
    [anon_sym_try] = ACTIONS(3457),
    [anon_sym_match] = ACTIONS(3457),
    [anon_sym_match_BANG] = ACTIONS(3455),
    [anon_sym_function] = ACTIONS(3457),
    [anon_sym_LT_DASH] = ACTIONS(3457),
    [anon_sym_DOT_LBRACK] = ACTIONS(3455),
    [anon_sym_LT] = ACTIONS(3455),
    [anon_sym_use] = ACTIONS(3457),
    [anon_sym_use_BANG] = ACTIONS(3455),
    [anon_sym_do_BANG] = ACTIONS(3455),
    [anon_sym_begin] = ACTIONS(3457),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_default] = ACTIONS(3457),
    [anon_sym_or] = ACTIONS(3457),
    [anon_sym_static] = ACTIONS(3457),
    [anon_sym_member] = ACTIONS(3457),
    [anon_sym_interface] = ACTIONS(3457),
    [anon_sym_abstract] = ACTIONS(3457),
    [anon_sym_val] = ACTIONS(3457),
    [anon_sym_override] = ACTIONS(3457),
    [aux_sym_char_token1] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [anon_sym_AT_DQUOTE] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [sym_bool] = ACTIONS(3457),
    [sym_unit] = ACTIONS(3455),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3457),
    [sym_op_identifier] = ACTIONS(3457),
    [anon_sym_PLUS] = ACTIONS(3457),
    [anon_sym_DASH] = ACTIONS(3457),
    [anon_sym_PLUS_DOT] = ACTIONS(3457),
    [anon_sym_DASH_DOT] = ACTIONS(3457),
    [anon_sym_PERCENT] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3455),
    [aux_sym_prefix_op_token1] = ACTIONS(3457),
    [aux_sym_infix_op_token1] = ACTIONS(3455),
    [aux_sym_infix_op_token2] = ACTIONS(3457),
    [anon_sym_PIPE_PIPE] = ACTIONS(3457),
    [anon_sym_BANG_EQ] = ACTIONS(3457),
    [anon_sym_COLON_EQ] = ACTIONS(3455),
    [anon_sym_DOLLAR] = ACTIONS(3457),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3457),
    [sym_int] = ACTIONS(3457),
    [sym_xint] = ACTIONS(3455),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3455),
    [anon_sym_POUNDendif] = ACTIONS(3455),
    [anon_sym_POUNDelse] = ACTIONS(3455),
    [sym__newline] = ACTIONS(3455),
  },
  [1285] = {
    [sym_block_comment] = STATE(1285),
    [sym_compiler_directive_decl] = STATE(1285),
    [sym_fsi_directive_decl] = STATE(1285),
    [sym_preproc_line] = STATE(1285),
    [ts_builtin_sym_end] = ACTIONS(3741),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_namespace] = ACTIONS(3743),
    [anon_sym_module] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_open] = ACTIONS(3743),
    [anon_sym_LBRACK_LT] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_type] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_and] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [aux_sym_access_modifier_token1] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_with] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_default] = ACTIONS(3743),
    [anon_sym_or] = ACTIONS(3743),
    [anon_sym_static] = ACTIONS(3743),
    [anon_sym_member] = ACTIONS(3743),
    [anon_sym_interface] = ACTIONS(3743),
    [anon_sym_exception] = ACTIONS(3743),
    [anon_sym_abstract] = ACTIONS(3743),
    [anon_sym_val] = ACTIONS(3743),
    [anon_sym_override] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3741),
    [anon_sym_POUNDload] = ACTIONS(3741),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [sym__newline] = ACTIONS(3741),
  },
  [1286] = {
    [sym_block_comment] = STATE(1286),
    [sym_compiler_directive_decl] = STATE(1286),
    [sym_fsi_directive_decl] = STATE(1286),
    [sym_preproc_line] = STATE(1286),
    [aux_sym_sequential_expression_repeat1] = STATE(1286),
    [ts_builtin_sym_end] = ACTIONS(3765),
    [sym_identifier] = ACTIONS(3767),
    [anon_sym_namespace] = ACTIONS(3767),
    [anon_sym_module] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3765),
    [anon_sym_open] = ACTIONS(3767),
    [anon_sym_LBRACK_LT] = ACTIONS(3765),
    [anon_sym_COLON] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_type] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_and] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_let_BANG] = ACTIONS(3765),
    [aux_sym_access_modifier_token1] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(3767),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_null] = ACTIONS(3767),
    [anon_sym_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3765),
    [anon_sym_LBRACE] = ACTIONS(3767),
    [anon_sym_LT_AT] = ACTIONS(3767),
    [anon_sym_LT_AT_AT] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3765),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_with] = ACTIONS(3767),
    [anon_sym_return_BANG] = ACTIONS(3765),
    [anon_sym_yield] = ACTIONS(3767),
    [anon_sym_yield_BANG] = ACTIONS(3765),
    [anon_sym_lazy] = ACTIONS(3767),
    [anon_sym_assert] = ACTIONS(3767),
    [anon_sym_upcast] = ACTIONS(3767),
    [anon_sym_downcast] = ACTIONS(3767),
    [anon_sym_COLON_GT] = ACTIONS(3765),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3765),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_fun] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_match] = ACTIONS(3767),
    [anon_sym_match_BANG] = ACTIONS(3765),
    [anon_sym_function] = ACTIONS(3767),
    [anon_sym_LT_DASH] = ACTIONS(3767),
    [anon_sym_DOT_LBRACK] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(3765),
    [anon_sym_use] = ACTIONS(3767),
    [anon_sym_use_BANG] = ACTIONS(3765),
    [anon_sym_do_BANG] = ACTIONS(3765),
    [anon_sym_begin] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3767),
    [anon_sym_default] = ACTIONS(3767),
    [anon_sym_or] = ACTIONS(3767),
    [anon_sym_static] = ACTIONS(3767),
    [anon_sym_member] = ACTIONS(3767),
    [anon_sym_interface] = ACTIONS(3767),
    [anon_sym_exception] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(3767),
    [anon_sym_val] = ACTIONS(3767),
    [anon_sym_override] = ACTIONS(3767),
    [aux_sym_char_token1] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3767),
    [anon_sym_DQUOTE] = ACTIONS(3767),
    [anon_sym_AT_DQUOTE] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [sym_bool] = ACTIONS(3767),
    [sym_unit] = ACTIONS(3765),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3767),
    [sym_op_identifier] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_PLUS_DOT] = ACTIONS(3767),
    [anon_sym_DASH_DOT] = ACTIONS(3767),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_AMP_AMP] = ACTIONS(3767),
    [anon_sym_TILDE] = ACTIONS(3765),
    [aux_sym_prefix_op_token1] = ACTIONS(3767),
    [aux_sym_infix_op_token1] = ACTIONS(3765),
    [aux_sym_infix_op_token2] = ACTIONS(3767),
    [anon_sym_PIPE_PIPE] = ACTIONS(3767),
    [anon_sym_BANG_EQ] = ACTIONS(3767),
    [anon_sym_COLON_EQ] = ACTIONS(3765),
    [anon_sym_DOLLAR] = ACTIONS(3767),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3767),
    [sym_int] = ACTIONS(3767),
    [sym_xint] = ACTIONS(3765),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3765),
    [anon_sym_POUNDload] = ACTIONS(3765),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3765),
    [sym__newline] = ACTIONS(3769),
  },
  [1287] = {
    [sym_block_comment] = STATE(1287),
    [sym_compiler_directive_decl] = STATE(1287),
    [sym_fsi_directive_decl] = STATE(1287),
    [sym_preproc_line] = STATE(1287),
    [ts_builtin_sym_end] = ACTIONS(3772),
    [sym_identifier] = ACTIONS(3774),
    [anon_sym_namespace] = ACTIONS(3774),
    [anon_sym_module] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3772),
    [anon_sym_open] = ACTIONS(3774),
    [anon_sym_LBRACK_LT] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3774),
    [anon_sym_type] = ACTIONS(3774),
    [anon_sym_do] = ACTIONS(3774),
    [anon_sym_and] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3774),
    [anon_sym_let_BANG] = ACTIONS(3772),
    [aux_sym_access_modifier_token1] = ACTIONS(3772),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3772),
    [anon_sym_null] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_COLON] = ACTIONS(3772),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_LT_AT] = ACTIONS(3774),
    [anon_sym_LT_AT_AT] = ACTIONS(3774),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3772),
    [anon_sym_new] = ACTIONS(3774),
    [anon_sym_with] = ACTIONS(3774),
    [anon_sym_return_BANG] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3774),
    [anon_sym_yield_BANG] = ACTIONS(3772),
    [anon_sym_lazy] = ACTIONS(3774),
    [anon_sym_assert] = ACTIONS(3774),
    [anon_sym_upcast] = ACTIONS(3774),
    [anon_sym_downcast] = ACTIONS(3774),
    [anon_sym_COLON_GT] = ACTIONS(3772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3774),
    [anon_sym_done] = ACTIONS(3776),
    [anon_sym_while] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3774),
    [anon_sym_fun] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3774),
    [anon_sym_match] = ACTIONS(3774),
    [anon_sym_match_BANG] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3774),
    [anon_sym_LT_DASH] = ACTIONS(3774),
    [anon_sym_DOT_LBRACK] = ACTIONS(3772),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_use] = ACTIONS(3774),
    [anon_sym_use_BANG] = ACTIONS(3772),
    [anon_sym_do_BANG] = ACTIONS(3772),
    [anon_sym_begin] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3774),
    [anon_sym_default] = ACTIONS(3774),
    [anon_sym_or] = ACTIONS(3774),
    [anon_sym_static] = ACTIONS(3774),
    [anon_sym_member] = ACTIONS(3774),
    [anon_sym_interface] = ACTIONS(3774),
    [anon_sym_exception] = ACTIONS(3774),
    [anon_sym_abstract] = ACTIONS(3774),
    [anon_sym_val] = ACTIONS(3774),
    [anon_sym_override] = ACTIONS(3774),
    [aux_sym_char_token1] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_AT_DQUOTE] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [sym_bool] = ACTIONS(3774),
    [sym_unit] = ACTIONS(3772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3774),
    [sym_op_identifier] = ACTIONS(3774),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_DOT] = ACTIONS(3774),
    [anon_sym_DASH_DOT] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3772),
    [aux_sym_prefix_op_token1] = ACTIONS(3774),
    [aux_sym_infix_op_token1] = ACTIONS(3772),
    [aux_sym_infix_op_token2] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3774),
    [anon_sym_COLON_EQ] = ACTIONS(3772),
    [anon_sym_DOLLAR] = ACTIONS(3774),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3774),
    [sym_int] = ACTIONS(3774),
    [sym_xint] = ACTIONS(3772),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3772),
    [anon_sym_POUNDload] = ACTIONS(3772),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3772),
    [sym__newline] = ACTIONS(3772),
  },
  [1288] = {
    [sym_block_comment] = STATE(1288),
    [sym_compiler_directive_decl] = STATE(1288),
    [sym_fsi_directive_decl] = STATE(1288),
    [sym_preproc_line] = STATE(1288),
    [aux_sym_long_identifier_repeat1] = STATE(1303),
    [ts_builtin_sym_end] = ACTIONS(3778),
    [sym_identifier] = ACTIONS(3781),
    [anon_sym_namespace] = ACTIONS(3781),
    [anon_sym_module] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3778),
    [anon_sym_open] = ACTIONS(3781),
    [anon_sym_LBRACK_LT] = ACTIONS(3778),
    [anon_sym_COLON] = ACTIONS(3781),
    [anon_sym_return] = ACTIONS(3781),
    [anon_sym_type] = ACTIONS(3781),
    [anon_sym_do] = ACTIONS(3781),
    [anon_sym_and] = ACTIONS(3781),
    [anon_sym_let] = ACTIONS(3781),
    [anon_sym_let_BANG] = ACTIONS(3778),
    [aux_sym_access_modifier_token1] = ACTIONS(3778),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3778),
    [anon_sym_null] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3781),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_LT_AT] = ACTIONS(3781),
    [anon_sym_LT_AT_AT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(3784),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3778),
    [anon_sym_new] = ACTIONS(3781),
    [anon_sym_with] = ACTIONS(3781),
    [anon_sym_return_BANG] = ACTIONS(3778),
    [anon_sym_yield] = ACTIONS(3781),
    [anon_sym_yield_BANG] = ACTIONS(3778),
    [anon_sym_lazy] = ACTIONS(3781),
    [anon_sym_assert] = ACTIONS(3781),
    [anon_sym_upcast] = ACTIONS(3781),
    [anon_sym_downcast] = ACTIONS(3781),
    [anon_sym_COLON_GT] = ACTIONS(3778),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3778),
    [anon_sym_for] = ACTIONS(3781),
    [anon_sym_while] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_fun] = ACTIONS(3781),
    [anon_sym_try] = ACTIONS(3781),
    [anon_sym_match] = ACTIONS(3781),
    [anon_sym_match_BANG] = ACTIONS(3778),
    [anon_sym_function] = ACTIONS(3781),
    [anon_sym_LT_DASH] = ACTIONS(3781),
    [anon_sym_DOT_LBRACK] = ACTIONS(3778),
    [anon_sym_LT] = ACTIONS(3778),
    [anon_sym_use] = ACTIONS(3781),
    [anon_sym_use_BANG] = ACTIONS(3778),
    [anon_sym_do_BANG] = ACTIONS(3778),
    [anon_sym_begin] = ACTIONS(3781),
    [anon_sym_LPAREN2] = ACTIONS(3781),
    [anon_sym_default] = ACTIONS(3781),
    [anon_sym_or] = ACTIONS(3781),
    [anon_sym_static] = ACTIONS(3781),
    [anon_sym_member] = ACTIONS(3781),
    [anon_sym_interface] = ACTIONS(3781),
    [anon_sym_exception] = ACTIONS(3781),
    [anon_sym_abstract] = ACTIONS(3781),
    [anon_sym_val] = ACTIONS(3781),
    [anon_sym_override] = ACTIONS(3781),
    [aux_sym_char_token1] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3781),
    [anon_sym_DQUOTE] = ACTIONS(3781),
    [anon_sym_AT_DQUOTE] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [sym_bool] = ACTIONS(3781),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3781),
    [sym_op_identifier] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3781),
    [anon_sym_DASH] = ACTIONS(3781),
    [anon_sym_PLUS_DOT] = ACTIONS(3781),
    [anon_sym_DASH_DOT] = ACTIONS(3781),
    [anon_sym_PERCENT] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3781),
    [anon_sym_TILDE] = ACTIONS(3778),
    [aux_sym_prefix_op_token1] = ACTIONS(3781),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token2] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_COLON_EQ] = ACTIONS(3778),
    [anon_sym_DOLLAR] = ACTIONS(3781),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3781),
    [sym_int] = ACTIONS(3781),
    [sym_xint] = ACTIONS(3778),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3778),
    [anon_sym_POUNDload] = ACTIONS(3778),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3778),
    [sym__newline] = ACTIONS(3778),
  },
  [1289] = {
    [sym_block_comment] = STATE(1289),
    [sym_compiler_directive_decl] = STATE(1289),
    [sym_fsi_directive_decl] = STATE(1289),
    [sym_preproc_line] = STATE(1289),
    [aux_sym_long_identifier_repeat1] = STATE(1298),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_EQ] = ACTIONS(3492),
    [anon_sym_LBRACK_LT] = ACTIONS(3492),
    [anon_sym_COLON] = ACTIONS(3494),
    [anon_sym_return] = ACTIONS(3494),
    [anon_sym_do] = ACTIONS(3494),
    [anon_sym_and] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_let_BANG] = ACTIONS(3492),
    [aux_sym_access_modifier_token1] = ACTIONS(3492),
    [anon_sym_LPAREN] = ACTIONS(3494),
    [anon_sym_COMMA] = ACTIONS(3492),
    [anon_sym_null] = ACTIONS(3494),
    [anon_sym_QMARK] = ACTIONS(3494),
    [anon_sym_COLON_QMARK] = ACTIONS(3494),
    [anon_sym_COLON_COLON] = ACTIONS(3492),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3492),
    [anon_sym_LBRACE] = ACTIONS(3494),
    [anon_sym_LT_AT] = ACTIONS(3494),
    [anon_sym_LT_AT_AT] = ACTIONS(3494),
    [anon_sym_DOT] = ACTIONS(3788),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3492),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_with] = ACTIONS(3494),
    [anon_sym_return_BANG] = ACTIONS(3492),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_yield_BANG] = ACTIONS(3492),
    [anon_sym_lazy] = ACTIONS(3494),
    [anon_sym_assert] = ACTIONS(3494),
    [anon_sym_upcast] = ACTIONS(3494),
    [anon_sym_downcast] = ACTIONS(3494),
    [anon_sym_COLON_GT] = ACTIONS(3492),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3492),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_while] = ACTIONS(3494),
    [anon_sym_if] = ACTIONS(3494),
    [anon_sym_fun] = ACTIONS(3494),
    [anon_sym_DASH_GT] = ACTIONS(3494),
    [anon_sym_try] = ACTIONS(3494),
    [anon_sym_match] = ACTIONS(3494),
    [anon_sym_match_BANG] = ACTIONS(3492),
    [anon_sym_function] = ACTIONS(3494),
    [anon_sym_LT_DASH] = ACTIONS(3494),
    [anon_sym_DOT_LBRACK] = ACTIONS(3492),
    [anon_sym_LT] = ACTIONS(3492),
    [anon_sym_use] = ACTIONS(3494),
    [anon_sym_use_BANG] = ACTIONS(3492),
    [anon_sym_do_BANG] = ACTIONS(3492),
    [anon_sym_begin] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(3494),
    [anon_sym_STAR] = ACTIONS(3494),
    [anon_sym_LT2] = ACTIONS(3494),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3492),
    [anon_sym_default] = ACTIONS(3494),
    [anon_sym_or] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_member] = ACTIONS(3494),
    [anon_sym_interface] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_val] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [aux_sym_char_token1] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3494),
    [anon_sym_DQUOTE] = ACTIONS(3494),
    [anon_sym_AT_DQUOTE] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [sym_bool] = ACTIONS(3494),
    [sym_unit] = ACTIONS(3492),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3494),
    [sym_op_identifier] = ACTIONS(3494),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_PLUS_DOT] = ACTIONS(3494),
    [anon_sym_DASH_DOT] = ACTIONS(3494),
    [anon_sym_PERCENT] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_TILDE] = ACTIONS(3492),
    [aux_sym_prefix_op_token1] = ACTIONS(3494),
    [aux_sym_infix_op_token1] = ACTIONS(3492),
    [aux_sym_infix_op_token2] = ACTIONS(3494),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_COLON_EQ] = ACTIONS(3492),
    [anon_sym_DOLLAR] = ACTIONS(3494),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3494),
    [sym_int] = ACTIONS(3494),
    [sym_xint] = ACTIONS(3492),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3492),
    [anon_sym_POUNDendif] = ACTIONS(3492),
    [anon_sym_POUNDelse] = ACTIONS(3492),
    [sym__newline] = ACTIONS(3492),
  },
  [1290] = {
    [sym_block_comment] = STATE(1290),
    [sym_compiler_directive_decl] = STATE(1290),
    [sym_fsi_directive_decl] = STATE(1290),
    [sym_preproc_line] = STATE(1290),
    [aux_sym_type_argument_repeat1] = STATE(1302),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_LBRACK_LT] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_and] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [aux_sym_access_modifier_token1] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_with] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [anon_sym_DOT_LBRACK] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_default] = ACTIONS(3498),
    [anon_sym_or] = ACTIONS(3790),
    [anon_sym_static] = ACTIONS(3498),
    [anon_sym_member] = ACTIONS(3498),
    [anon_sym_interface] = ACTIONS(3498),
    [anon_sym_abstract] = ACTIONS(3498),
    [anon_sym_val] = ACTIONS(3498),
    [anon_sym_override] = ACTIONS(3498),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3498),
    [anon_sym_DASH_DOT] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3498),
    [aux_sym_infix_op_token1] = ACTIONS(3496),
    [aux_sym_infix_op_token2] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_COLON_EQ] = ACTIONS(3496),
    [anon_sym_DOLLAR] = ACTIONS(3498),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3498),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [anon_sym_POUNDendif] = ACTIONS(3496),
    [anon_sym_POUNDelse] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
  },
  [1291] = {
    [sym_block_comment] = STATE(1291),
    [sym_compiler_directive_decl] = STATE(1291),
    [sym_fsi_directive_decl] = STATE(1291),
    [sym_preproc_line] = STATE(1291),
    [aux_sym_long_identifier_repeat1] = STATE(1291),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [aux_sym_access_modifier_token1] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3793),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_member] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_val] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [anon_sym_inherit] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [anon_sym_POUNDendif] = ACTIONS(3485),
    [anon_sym_POUNDelse] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [1292] = {
    [sym_block_comment] = STATE(1292),
    [sym_compiler_directive_decl] = STATE(1292),
    [sym_fsi_directive_decl] = STATE(1292),
    [sym_preproc_line] = STATE(1292),
    [aux_sym_compound_type_repeat1] = STATE(1296),
    [sym_identifier] = ACTIONS(3468),
    [anon_sym_EQ] = ACTIONS(3466),
    [anon_sym_LBRACK_LT] = ACTIONS(3466),
    [anon_sym_COLON] = ACTIONS(3468),
    [anon_sym_return] = ACTIONS(3468),
    [anon_sym_do] = ACTIONS(3468),
    [anon_sym_and] = ACTIONS(3468),
    [anon_sym_let] = ACTIONS(3468),
    [anon_sym_let_BANG] = ACTIONS(3466),
    [aux_sym_access_modifier_token1] = ACTIONS(3466),
    [anon_sym_LPAREN] = ACTIONS(3468),
    [anon_sym_COMMA] = ACTIONS(3466),
    [anon_sym_null] = ACTIONS(3468),
    [anon_sym_QMARK] = ACTIONS(3468),
    [anon_sym_COLON_QMARK] = ACTIONS(3468),
    [anon_sym_COLON_COLON] = ACTIONS(3466),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LBRACK] = ACTIONS(3468),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3466),
    [anon_sym_LBRACE] = ACTIONS(3468),
    [anon_sym_LT_AT] = ACTIONS(3468),
    [anon_sym_LT_AT_AT] = ACTIONS(3468),
    [anon_sym_DOT] = ACTIONS(3468),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3466),
    [anon_sym_new] = ACTIONS(3468),
    [anon_sym_with] = ACTIONS(3468),
    [anon_sym_return_BANG] = ACTIONS(3466),
    [anon_sym_yield] = ACTIONS(3468),
    [anon_sym_yield_BANG] = ACTIONS(3466),
    [anon_sym_lazy] = ACTIONS(3468),
    [anon_sym_assert] = ACTIONS(3468),
    [anon_sym_upcast] = ACTIONS(3468),
    [anon_sym_downcast] = ACTIONS(3468),
    [anon_sym_COLON_GT] = ACTIONS(3466),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3466),
    [anon_sym_for] = ACTIONS(3468),
    [anon_sym_while] = ACTIONS(3468),
    [anon_sym_if] = ACTIONS(3468),
    [anon_sym_fun] = ACTIONS(3468),
    [anon_sym_DASH_GT] = ACTIONS(3468),
    [anon_sym_try] = ACTIONS(3468),
    [anon_sym_match] = ACTIONS(3468),
    [anon_sym_match_BANG] = ACTIONS(3466),
    [anon_sym_function] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3468),
    [anon_sym_DOT_LBRACK] = ACTIONS(3466),
    [anon_sym_LT] = ACTIONS(3466),
    [anon_sym_use] = ACTIONS(3468),
    [anon_sym_use_BANG] = ACTIONS(3466),
    [anon_sym_do_BANG] = ACTIONS(3466),
    [anon_sym_begin] = ACTIONS(3468),
    [anon_sym_LPAREN2] = ACTIONS(3468),
    [anon_sym_STAR] = ACTIONS(3596),
    [anon_sym_LT2] = ACTIONS(3468),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3466),
    [anon_sym_default] = ACTIONS(3468),
    [anon_sym_or] = ACTIONS(3468),
    [anon_sym_static] = ACTIONS(3468),
    [anon_sym_member] = ACTIONS(3468),
    [anon_sym_interface] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(3468),
    [anon_sym_val] = ACTIONS(3468),
    [anon_sym_override] = ACTIONS(3468),
    [aux_sym_char_token1] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3468),
    [anon_sym_DQUOTE] = ACTIONS(3468),
    [anon_sym_AT_DQUOTE] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [sym_bool] = ACTIONS(3468),
    [sym_unit] = ACTIONS(3466),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3468),
    [sym_op_identifier] = ACTIONS(3468),
    [anon_sym_PLUS] = ACTIONS(3468),
    [anon_sym_DASH] = ACTIONS(3468),
    [anon_sym_PLUS_DOT] = ACTIONS(3468),
    [anon_sym_DASH_DOT] = ACTIONS(3468),
    [anon_sym_PERCENT] = ACTIONS(3468),
    [anon_sym_AMP_AMP] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3466),
    [aux_sym_prefix_op_token1] = ACTIONS(3468),
    [aux_sym_infix_op_token1] = ACTIONS(3466),
    [aux_sym_infix_op_token2] = ACTIONS(3468),
    [anon_sym_PIPE_PIPE] = ACTIONS(3468),
    [anon_sym_BANG_EQ] = ACTIONS(3468),
    [anon_sym_COLON_EQ] = ACTIONS(3466),
    [anon_sym_DOLLAR] = ACTIONS(3468),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3468),
    [sym_int] = ACTIONS(3468),
    [sym_xint] = ACTIONS(3466),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3466),
    [anon_sym_POUNDendif] = ACTIONS(3466),
    [anon_sym_POUNDelse] = ACTIONS(3466),
    [sym__newline] = ACTIONS(3466),
  },
  [1293] = {
    [sym_block_comment] = STATE(1293),
    [sym_compiler_directive_decl] = STATE(1293),
    [sym_fsi_directive_decl] = STATE(1293),
    [sym_preproc_line] = STATE(1293),
    [aux_sym_long_identifier_repeat1] = STATE(1291),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_LBRACK_LT] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [aux_sym_access_modifier_token1] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(3796),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_DASH_GT] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_STAR] = ACTIONS(3451),
    [anon_sym_LT2] = ACTIONS(3451),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3449),
    [anon_sym_default] = ACTIONS(3451),
    [anon_sym_or] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_member] = ACTIONS(3451),
    [anon_sym_interface] = ACTIONS(3451),
    [anon_sym_abstract] = ACTIONS(3451),
    [anon_sym_val] = ACTIONS(3451),
    [anon_sym_override] = ACTIONS(3451),
    [anon_sym_inherit] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [anon_sym_POUNDendif] = ACTIONS(3449),
    [anon_sym_POUNDelse] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
  },
  [1294] = {
    [sym_block_comment] = STATE(1294),
    [sym_compiler_directive_decl] = STATE(1294),
    [sym_fsi_directive_decl] = STATE(1294),
    [sym_preproc_line] = STATE(1294),
    [ts_builtin_sym_end] = ACTIONS(3698),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_namespace] = ACTIONS(3700),
    [anon_sym_module] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_open] = ACTIONS(3700),
    [anon_sym_LBRACK_LT] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_type] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_and] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [aux_sym_access_modifier_token1] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_default] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [anon_sym_static] = ACTIONS(3700),
    [anon_sym_member] = ACTIONS(3700),
    [anon_sym_interface] = ACTIONS(3700),
    [anon_sym_exception] = ACTIONS(3700),
    [anon_sym_abstract] = ACTIONS(3700),
    [anon_sym_val] = ACTIONS(3700),
    [anon_sym_override] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3698),
    [anon_sym_POUNDload] = ACTIONS(3698),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [1295] = {
    [sym_block_comment] = STATE(1295),
    [sym_compiler_directive_decl] = STATE(1295),
    [sym_fsi_directive_decl] = STATE(1295),
    [sym_preproc_line] = STATE(1295),
    [ts_builtin_sym_end] = ACTIONS(3798),
    [sym_identifier] = ACTIONS(3800),
    [anon_sym_namespace] = ACTIONS(3800),
    [anon_sym_module] = ACTIONS(3800),
    [anon_sym_EQ] = ACTIONS(3798),
    [anon_sym_open] = ACTIONS(3800),
    [anon_sym_LBRACK_LT] = ACTIONS(3798),
    [anon_sym_COLON] = ACTIONS(3800),
    [anon_sym_return] = ACTIONS(3800),
    [anon_sym_type] = ACTIONS(3800),
    [anon_sym_do] = ACTIONS(3800),
    [anon_sym_and] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_let_BANG] = ACTIONS(3798),
    [aux_sym_access_modifier_token1] = ACTIONS(3798),
    [anon_sym_LPAREN] = ACTIONS(3800),
    [anon_sym_COMMA] = ACTIONS(3798),
    [anon_sym_null] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_COLON] = ACTIONS(3798),
    [anon_sym_PIPE] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3800),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3798),
    [anon_sym_LBRACE] = ACTIONS(3800),
    [anon_sym_LT_AT] = ACTIONS(3800),
    [anon_sym_LT_AT_AT] = ACTIONS(3800),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3798),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_with] = ACTIONS(3800),
    [anon_sym_return_BANG] = ACTIONS(3798),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_yield_BANG] = ACTIONS(3798),
    [anon_sym_lazy] = ACTIONS(3800),
    [anon_sym_assert] = ACTIONS(3800),
    [anon_sym_upcast] = ACTIONS(3800),
    [anon_sym_downcast] = ACTIONS(3800),
    [anon_sym_COLON_GT] = ACTIONS(3798),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3798),
    [anon_sym_for] = ACTIONS(3800),
    [anon_sym_while] = ACTIONS(3800),
    [anon_sym_if] = ACTIONS(3800),
    [anon_sym_fun] = ACTIONS(3800),
    [anon_sym_try] = ACTIONS(3800),
    [anon_sym_match] = ACTIONS(3800),
    [anon_sym_match_BANG] = ACTIONS(3798),
    [anon_sym_function] = ACTIONS(3800),
    [anon_sym_LT_DASH] = ACTIONS(3800),
    [anon_sym_DOT_LBRACK] = ACTIONS(3798),
    [anon_sym_LT] = ACTIONS(3798),
    [anon_sym_use] = ACTIONS(3800),
    [anon_sym_use_BANG] = ACTIONS(3798),
    [anon_sym_do_BANG] = ACTIONS(3798),
    [anon_sym_begin] = ACTIONS(3800),
    [anon_sym_LPAREN2] = ACTIONS(3800),
    [anon_sym_default] = ACTIONS(3800),
    [anon_sym_or] = ACTIONS(3800),
    [anon_sym_static] = ACTIONS(3800),
    [anon_sym_member] = ACTIONS(3800),
    [anon_sym_interface] = ACTIONS(3800),
    [anon_sym_exception] = ACTIONS(3800),
    [anon_sym_abstract] = ACTIONS(3800),
    [anon_sym_val] = ACTIONS(3800),
    [anon_sym_override] = ACTIONS(3800),
    [aux_sym_char_token1] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3800),
    [anon_sym_DQUOTE] = ACTIONS(3800),
    [anon_sym_AT_DQUOTE] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [sym_bool] = ACTIONS(3800),
    [sym_unit] = ACTIONS(3798),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3800),
    [sym_op_identifier] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS_DOT] = ACTIONS(3800),
    [anon_sym_DASH_DOT] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3800),
    [anon_sym_AMP_AMP] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3798),
    [aux_sym_prefix_op_token1] = ACTIONS(3800),
    [aux_sym_infix_op_token1] = ACTIONS(3798),
    [aux_sym_infix_op_token2] = ACTIONS(3800),
    [anon_sym_PIPE_PIPE] = ACTIONS(3800),
    [anon_sym_BANG_EQ] = ACTIONS(3800),
    [anon_sym_COLON_EQ] = ACTIONS(3798),
    [anon_sym_DOLLAR] = ACTIONS(3800),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3800),
    [sym_int] = ACTIONS(3800),
    [sym_xint] = ACTIONS(3798),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3798),
    [anon_sym_POUNDload] = ACTIONS(3798),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3798),
    [sym__newline] = ACTIONS(3798),
  },
  [1296] = {
    [sym_block_comment] = STATE(1296),
    [sym_compiler_directive_decl] = STATE(1296),
    [sym_fsi_directive_decl] = STATE(1296),
    [sym_preproc_line] = STATE(1296),
    [aux_sym_compound_type_repeat1] = STATE(1296),
    [sym_identifier] = ACTIONS(3427),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_LBRACK_LT] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_and] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [aux_sym_access_modifier_token1] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3427),
    [anon_sym_DOT] = ACTIONS(3427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_with] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_COLON_GT] = ACTIONS(3425),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(3427),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_LT_DASH] = ACTIONS(3427),
    [anon_sym_DOT_LBRACK] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(3802),
    [anon_sym_LT2] = ACTIONS(3427),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3425),
    [anon_sym_default] = ACTIONS(3427),
    [anon_sym_or] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_member] = ACTIONS(3427),
    [anon_sym_interface] = ACTIONS(3427),
    [anon_sym_abstract] = ACTIONS(3427),
    [anon_sym_val] = ACTIONS(3427),
    [anon_sym_override] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3427),
    [anon_sym_DASH_DOT] = ACTIONS(3427),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3427),
    [aux_sym_infix_op_token1] = ACTIONS(3425),
    [aux_sym_infix_op_token2] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3427),
    [anon_sym_COLON_EQ] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3427),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [anon_sym_POUNDendif] = ACTIONS(3425),
    [anon_sym_POUNDelse] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
  },
  [1297] = {
    [sym_block_comment] = STATE(1297),
    [sym_compiler_directive_decl] = STATE(1297),
    [sym_fsi_directive_decl] = STATE(1297),
    [sym_preproc_line] = STATE(1297),
    [aux_sym_type_argument_repeat1] = STATE(1307),
    [sym_identifier] = ACTIONS(3476),
    [anon_sym_EQ] = ACTIONS(3474),
    [anon_sym_LBRACK_LT] = ACTIONS(3474),
    [anon_sym_COLON] = ACTIONS(3476),
    [anon_sym_return] = ACTIONS(3476),
    [anon_sym_do] = ACTIONS(3476),
    [anon_sym_let] = ACTIONS(3476),
    [anon_sym_let_BANG] = ACTIONS(3474),
    [aux_sym_access_modifier_token1] = ACTIONS(3474),
    [anon_sym_LPAREN] = ACTIONS(3476),
    [anon_sym_COMMA] = ACTIONS(3474),
    [anon_sym_null] = ACTIONS(3476),
    [anon_sym_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_COLON] = ACTIONS(3474),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym_LBRACK] = ACTIONS(3476),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3474),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_LT_AT] = ACTIONS(3476),
    [anon_sym_LT_AT_AT] = ACTIONS(3476),
    [anon_sym_DOT] = ACTIONS(3476),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3474),
    [anon_sym_new] = ACTIONS(3476),
    [anon_sym_with] = ACTIONS(3476),
    [anon_sym_return_BANG] = ACTIONS(3474),
    [anon_sym_yield] = ACTIONS(3476),
    [anon_sym_yield_BANG] = ACTIONS(3474),
    [anon_sym_lazy] = ACTIONS(3476),
    [anon_sym_assert] = ACTIONS(3476),
    [anon_sym_upcast] = ACTIONS(3476),
    [anon_sym_downcast] = ACTIONS(3476),
    [anon_sym_COLON_GT] = ACTIONS(3474),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3474),
    [anon_sym_for] = ACTIONS(3476),
    [anon_sym_while] = ACTIONS(3476),
    [anon_sym_if] = ACTIONS(3476),
    [anon_sym_fun] = ACTIONS(3476),
    [anon_sym_DASH_GT] = ACTIONS(3476),
    [anon_sym_try] = ACTIONS(3476),
    [anon_sym_match] = ACTIONS(3476),
    [anon_sym_match_BANG] = ACTIONS(3474),
    [anon_sym_function] = ACTIONS(3476),
    [anon_sym_LT_DASH] = ACTIONS(3476),
    [anon_sym_DOT_LBRACK] = ACTIONS(3474),
    [anon_sym_LT] = ACTIONS(3474),
    [anon_sym_use] = ACTIONS(3476),
    [anon_sym_use_BANG] = ACTIONS(3474),
    [anon_sym_do_BANG] = ACTIONS(3474),
    [anon_sym_begin] = ACTIONS(3476),
    [anon_sym_LPAREN2] = ACTIONS(3476),
    [anon_sym_STAR] = ACTIONS(3476),
    [anon_sym_LT2] = ACTIONS(3476),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3474),
    [anon_sym_default] = ACTIONS(3476),
    [anon_sym_or] = ACTIONS(3476),
    [anon_sym_static] = ACTIONS(3476),
    [anon_sym_member] = ACTIONS(3476),
    [anon_sym_interface] = ACTIONS(3476),
    [anon_sym_abstract] = ACTIONS(3476),
    [anon_sym_val] = ACTIONS(3476),
    [anon_sym_override] = ACTIONS(3476),
    [anon_sym_inherit] = ACTIONS(3476),
    [aux_sym_char_token1] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3476),
    [anon_sym_DQUOTE] = ACTIONS(3476),
    [anon_sym_AT_DQUOTE] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [sym_bool] = ACTIONS(3476),
    [sym_unit] = ACTIONS(3474),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3476),
    [sym_op_identifier] = ACTIONS(3476),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3476),
    [anon_sym_PLUS_DOT] = ACTIONS(3476),
    [anon_sym_DASH_DOT] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [anon_sym_AMP_AMP] = ACTIONS(3476),
    [anon_sym_TILDE] = ACTIONS(3474),
    [aux_sym_prefix_op_token1] = ACTIONS(3476),
    [aux_sym_infix_op_token1] = ACTIONS(3474),
    [aux_sym_infix_op_token2] = ACTIONS(3476),
    [anon_sym_PIPE_PIPE] = ACTIONS(3476),
    [anon_sym_BANG_EQ] = ACTIONS(3476),
    [anon_sym_COLON_EQ] = ACTIONS(3474),
    [anon_sym_DOLLAR] = ACTIONS(3476),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3476),
    [sym_int] = ACTIONS(3476),
    [sym_xint] = ACTIONS(3474),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3474),
    [anon_sym_POUNDendif] = ACTIONS(3474),
    [anon_sym_POUNDelse] = ACTIONS(3474),
    [sym__newline] = ACTIONS(3474),
  },
  [1298] = {
    [sym_block_comment] = STATE(1298),
    [sym_compiler_directive_decl] = STATE(1298),
    [sym_fsi_directive_decl] = STATE(1298),
    [sym_preproc_line] = STATE(1298),
    [aux_sym_long_identifier_repeat1] = STATE(1299),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_LBRACK_LT] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_and] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [aux_sym_access_modifier_token1] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(3788),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_DASH_GT] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_STAR] = ACTIONS(3451),
    [anon_sym_LT2] = ACTIONS(3451),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3449),
    [anon_sym_default] = ACTIONS(3451),
    [anon_sym_or] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_member] = ACTIONS(3451),
    [anon_sym_interface] = ACTIONS(3451),
    [anon_sym_abstract] = ACTIONS(3451),
    [anon_sym_val] = ACTIONS(3451),
    [anon_sym_override] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [anon_sym_POUNDendif] = ACTIONS(3449),
    [anon_sym_POUNDelse] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
  },
  [1299] = {
    [sym_block_comment] = STATE(1299),
    [sym_compiler_directive_decl] = STATE(1299),
    [sym_fsi_directive_decl] = STATE(1299),
    [sym_preproc_line] = STATE(1299),
    [aux_sym_long_identifier_repeat1] = STATE(1299),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_and] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [aux_sym_access_modifier_token1] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3805),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_member] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_val] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [anon_sym_POUNDendif] = ACTIONS(3485),
    [anon_sym_POUNDelse] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [1300] = {
    [sym_block_comment] = STATE(1300),
    [sym_compiler_directive_decl] = STATE(1300),
    [sym_fsi_directive_decl] = STATE(1300),
    [sym_preproc_line] = STATE(1300),
    [aux_sym_type_argument_repeat1] = STATE(1300),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_LBRACK_LT] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_and] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [aux_sym_access_modifier_token1] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_COLON] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_with] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_LT_DASH] = ACTIONS(3480),
    [anon_sym_DOT_LBRACK] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_default] = ACTIONS(3480),
    [anon_sym_or] = ACTIONS(3808),
    [anon_sym_static] = ACTIONS(3480),
    [anon_sym_member] = ACTIONS(3480),
    [anon_sym_interface] = ACTIONS(3480),
    [anon_sym_abstract] = ACTIONS(3480),
    [anon_sym_val] = ACTIONS(3480),
    [anon_sym_override] = ACTIONS(3480),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3480),
    [anon_sym_DASH_DOT] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3480),
    [aux_sym_infix_op_token1] = ACTIONS(3478),
    [aux_sym_infix_op_token2] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3480),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [anon_sym_POUNDendif] = ACTIONS(3478),
    [anon_sym_POUNDelse] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
  },
  [1301] = {
    [sym_block_comment] = STATE(1301),
    [sym_compiler_directive_decl] = STATE(1301),
    [sym_fsi_directive_decl] = STATE(1301),
    [sym_preproc_line] = STATE(1301),
    [ts_builtin_sym_end] = ACTIONS(3811),
    [sym_identifier] = ACTIONS(3813),
    [anon_sym_namespace] = ACTIONS(3813),
    [anon_sym_module] = ACTIONS(3813),
    [anon_sym_EQ] = ACTIONS(3811),
    [anon_sym_open] = ACTIONS(3813),
    [anon_sym_LBRACK_LT] = ACTIONS(3811),
    [anon_sym_COLON] = ACTIONS(3813),
    [anon_sym_return] = ACTIONS(3813),
    [anon_sym_type] = ACTIONS(3813),
    [anon_sym_do] = ACTIONS(3813),
    [anon_sym_and] = ACTIONS(3813),
    [anon_sym_let] = ACTIONS(3813),
    [anon_sym_let_BANG] = ACTIONS(3811),
    [aux_sym_access_modifier_token1] = ACTIONS(3811),
    [anon_sym_LPAREN] = ACTIONS(3813),
    [anon_sym_COMMA] = ACTIONS(3811),
    [anon_sym_null] = ACTIONS(3813),
    [anon_sym_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_COLON] = ACTIONS(3811),
    [anon_sym_AMP] = ACTIONS(3813),
    [anon_sym_LBRACK] = ACTIONS(3813),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3811),
    [anon_sym_LBRACE] = ACTIONS(3813),
    [anon_sym_LT_AT] = ACTIONS(3813),
    [anon_sym_LT_AT_AT] = ACTIONS(3813),
    [anon_sym_DOT] = ACTIONS(3813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3811),
    [anon_sym_new] = ACTIONS(3813),
    [anon_sym_with] = ACTIONS(3813),
    [anon_sym_return_BANG] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_yield_BANG] = ACTIONS(3811),
    [anon_sym_lazy] = ACTIONS(3813),
    [anon_sym_assert] = ACTIONS(3813),
    [anon_sym_upcast] = ACTIONS(3813),
    [anon_sym_downcast] = ACTIONS(3813),
    [anon_sym_COLON_GT] = ACTIONS(3811),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3811),
    [anon_sym_for] = ACTIONS(3813),
    [anon_sym_done] = ACTIONS(3815),
    [anon_sym_while] = ACTIONS(3813),
    [anon_sym_if] = ACTIONS(3813),
    [anon_sym_fun] = ACTIONS(3813),
    [anon_sym_try] = ACTIONS(3813),
    [anon_sym_match] = ACTIONS(3813),
    [anon_sym_match_BANG] = ACTIONS(3811),
    [anon_sym_function] = ACTIONS(3813),
    [anon_sym_LT_DASH] = ACTIONS(3813),
    [anon_sym_DOT_LBRACK] = ACTIONS(3811),
    [anon_sym_LT] = ACTIONS(3811),
    [anon_sym_use] = ACTIONS(3813),
    [anon_sym_use_BANG] = ACTIONS(3811),
    [anon_sym_do_BANG] = ACTIONS(3811),
    [anon_sym_begin] = ACTIONS(3813),
    [anon_sym_LPAREN2] = ACTIONS(3813),
    [anon_sym_default] = ACTIONS(3813),
    [anon_sym_or] = ACTIONS(3813),
    [anon_sym_static] = ACTIONS(3813),
    [anon_sym_member] = ACTIONS(3813),
    [anon_sym_interface] = ACTIONS(3813),
    [anon_sym_exception] = ACTIONS(3813),
    [anon_sym_abstract] = ACTIONS(3813),
    [anon_sym_val] = ACTIONS(3813),
    [anon_sym_override] = ACTIONS(3813),
    [aux_sym_char_token1] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3813),
    [anon_sym_DQUOTE] = ACTIONS(3813),
    [anon_sym_AT_DQUOTE] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [sym_bool] = ACTIONS(3813),
    [sym_unit] = ACTIONS(3811),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3813),
    [sym_op_identifier] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PLUS_DOT] = ACTIONS(3813),
    [anon_sym_DASH_DOT] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3813),
    [anon_sym_AMP_AMP] = ACTIONS(3813),
    [anon_sym_TILDE] = ACTIONS(3811),
    [aux_sym_prefix_op_token1] = ACTIONS(3813),
    [aux_sym_infix_op_token1] = ACTIONS(3811),
    [aux_sym_infix_op_token2] = ACTIONS(3813),
    [anon_sym_PIPE_PIPE] = ACTIONS(3813),
    [anon_sym_BANG_EQ] = ACTIONS(3813),
    [anon_sym_COLON_EQ] = ACTIONS(3811),
    [anon_sym_DOLLAR] = ACTIONS(3813),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3813),
    [sym_int] = ACTIONS(3813),
    [sym_xint] = ACTIONS(3811),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3811),
    [anon_sym_POUNDload] = ACTIONS(3811),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3811),
    [sym__newline] = ACTIONS(3811),
  },
  [1302] = {
    [sym_block_comment] = STATE(1302),
    [sym_compiler_directive_decl] = STATE(1302),
    [sym_fsi_directive_decl] = STATE(1302),
    [sym_preproc_line] = STATE(1302),
    [aux_sym_type_argument_repeat1] = STATE(1300),
    [sym_identifier] = ACTIONS(3476),
    [anon_sym_EQ] = ACTIONS(3474),
    [anon_sym_LBRACK_LT] = ACTIONS(3474),
    [anon_sym_COLON] = ACTIONS(3476),
    [anon_sym_return] = ACTIONS(3476),
    [anon_sym_do] = ACTIONS(3476),
    [anon_sym_and] = ACTIONS(3476),
    [anon_sym_let] = ACTIONS(3476),
    [anon_sym_let_BANG] = ACTIONS(3474),
    [aux_sym_access_modifier_token1] = ACTIONS(3474),
    [anon_sym_LPAREN] = ACTIONS(3476),
    [anon_sym_COMMA] = ACTIONS(3474),
    [anon_sym_null] = ACTIONS(3476),
    [anon_sym_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_COLON] = ACTIONS(3474),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym_LBRACK] = ACTIONS(3476),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3474),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_LT_AT] = ACTIONS(3476),
    [anon_sym_LT_AT_AT] = ACTIONS(3476),
    [anon_sym_DOT] = ACTIONS(3476),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3474),
    [anon_sym_new] = ACTIONS(3476),
    [anon_sym_with] = ACTIONS(3476),
    [anon_sym_return_BANG] = ACTIONS(3474),
    [anon_sym_yield] = ACTIONS(3476),
    [anon_sym_yield_BANG] = ACTIONS(3474),
    [anon_sym_lazy] = ACTIONS(3476),
    [anon_sym_assert] = ACTIONS(3476),
    [anon_sym_upcast] = ACTIONS(3476),
    [anon_sym_downcast] = ACTIONS(3476),
    [anon_sym_COLON_GT] = ACTIONS(3474),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3474),
    [anon_sym_for] = ACTIONS(3476),
    [anon_sym_while] = ACTIONS(3476),
    [anon_sym_if] = ACTIONS(3476),
    [anon_sym_fun] = ACTIONS(3476),
    [anon_sym_DASH_GT] = ACTIONS(3476),
    [anon_sym_try] = ACTIONS(3476),
    [anon_sym_match] = ACTIONS(3476),
    [anon_sym_match_BANG] = ACTIONS(3474),
    [anon_sym_function] = ACTIONS(3476),
    [anon_sym_LT_DASH] = ACTIONS(3476),
    [anon_sym_DOT_LBRACK] = ACTIONS(3474),
    [anon_sym_LT] = ACTIONS(3474),
    [anon_sym_use] = ACTIONS(3476),
    [anon_sym_use_BANG] = ACTIONS(3474),
    [anon_sym_do_BANG] = ACTIONS(3474),
    [anon_sym_begin] = ACTIONS(3476),
    [anon_sym_LPAREN2] = ACTIONS(3476),
    [anon_sym_STAR] = ACTIONS(3476),
    [anon_sym_LT2] = ACTIONS(3476),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3474),
    [anon_sym_default] = ACTIONS(3476),
    [anon_sym_or] = ACTIONS(3476),
    [anon_sym_static] = ACTIONS(3476),
    [anon_sym_member] = ACTIONS(3476),
    [anon_sym_interface] = ACTIONS(3476),
    [anon_sym_abstract] = ACTIONS(3476),
    [anon_sym_val] = ACTIONS(3476),
    [anon_sym_override] = ACTIONS(3476),
    [aux_sym_char_token1] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3476),
    [anon_sym_DQUOTE] = ACTIONS(3476),
    [anon_sym_AT_DQUOTE] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [sym_bool] = ACTIONS(3476),
    [sym_unit] = ACTIONS(3474),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3476),
    [sym_op_identifier] = ACTIONS(3476),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3476),
    [anon_sym_PLUS_DOT] = ACTIONS(3476),
    [anon_sym_DASH_DOT] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [anon_sym_AMP_AMP] = ACTIONS(3476),
    [anon_sym_TILDE] = ACTIONS(3474),
    [aux_sym_prefix_op_token1] = ACTIONS(3476),
    [aux_sym_infix_op_token1] = ACTIONS(3474),
    [aux_sym_infix_op_token2] = ACTIONS(3476),
    [anon_sym_PIPE_PIPE] = ACTIONS(3476),
    [anon_sym_BANG_EQ] = ACTIONS(3476),
    [anon_sym_COLON_EQ] = ACTIONS(3474),
    [anon_sym_DOLLAR] = ACTIONS(3476),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3476),
    [sym_int] = ACTIONS(3476),
    [sym_xint] = ACTIONS(3474),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3474),
    [anon_sym_POUNDendif] = ACTIONS(3474),
    [anon_sym_POUNDelse] = ACTIONS(3474),
    [sym__newline] = ACTIONS(3474),
  },
  [1303] = {
    [sym_block_comment] = STATE(1303),
    [sym_compiler_directive_decl] = STATE(1303),
    [sym_fsi_directive_decl] = STATE(1303),
    [sym_preproc_line] = STATE(1303),
    [aux_sym_long_identifier_repeat1] = STATE(1304),
    [ts_builtin_sym_end] = ACTIONS(3449),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_namespace] = ACTIONS(3451),
    [anon_sym_module] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_open] = ACTIONS(3451),
    [anon_sym_LBRACK_LT] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_type] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_and] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [aux_sym_access_modifier_token1] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(3817),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_default] = ACTIONS(3451),
    [anon_sym_or] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_member] = ACTIONS(3451),
    [anon_sym_interface] = ACTIONS(3451),
    [anon_sym_exception] = ACTIONS(3451),
    [anon_sym_abstract] = ACTIONS(3451),
    [anon_sym_val] = ACTIONS(3451),
    [anon_sym_override] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3449),
    [anon_sym_POUNDload] = ACTIONS(3449),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
  },
  [1304] = {
    [sym_block_comment] = STATE(1304),
    [sym_compiler_directive_decl] = STATE(1304),
    [sym_fsi_directive_decl] = STATE(1304),
    [sym_preproc_line] = STATE(1304),
    [aux_sym_long_identifier_repeat1] = STATE(1304),
    [ts_builtin_sym_end] = ACTIONS(3485),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_namespace] = ACTIONS(3487),
    [anon_sym_module] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_open] = ACTIONS(3487),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_type] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_and] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [aux_sym_access_modifier_token1] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3819),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_member] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_exception] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_val] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3485),
    [anon_sym_POUNDload] = ACTIONS(3485),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [1305] = {
    [sym__else_expression] = STATE(1716),
    [sym_elif_expression] = STATE(1557),
    [sym_block_comment] = STATE(1305),
    [sym_compiler_directive_decl] = STATE(1305),
    [sym_fsi_directive_decl] = STATE(1305),
    [sym_preproc_line] = STATE(1305),
    [aux_sym_if_expression_repeat1] = STATE(1312),
    [sym_identifier] = ACTIONS(3472),
    [anon_sym_EQ] = ACTIONS(3470),
    [anon_sym_LBRACK_LT] = ACTIONS(3470),
    [anon_sym_COLON] = ACTIONS(3472),
    [anon_sym_return] = ACTIONS(3472),
    [anon_sym_do] = ACTIONS(3472),
    [anon_sym_let] = ACTIONS(3472),
    [anon_sym_let_BANG] = ACTIONS(3470),
    [aux_sym_access_modifier_token1] = ACTIONS(3470),
    [anon_sym_LPAREN] = ACTIONS(3472),
    [anon_sym_COMMA] = ACTIONS(3470),
    [anon_sym_null] = ACTIONS(3472),
    [anon_sym_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_COLON] = ACTIONS(3470),
    [anon_sym_AMP] = ACTIONS(3472),
    [anon_sym_LBRACK] = ACTIONS(3472),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3470),
    [anon_sym_LBRACE] = ACTIONS(3472),
    [anon_sym_LT_AT] = ACTIONS(3472),
    [anon_sym_LT_AT_AT] = ACTIONS(3472),
    [anon_sym_DOT] = ACTIONS(3472),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3470),
    [anon_sym_new] = ACTIONS(3472),
    [anon_sym_with] = ACTIONS(3472),
    [anon_sym_return_BANG] = ACTIONS(3470),
    [anon_sym_yield] = ACTIONS(3472),
    [anon_sym_yield_BANG] = ACTIONS(3470),
    [anon_sym_lazy] = ACTIONS(3472),
    [anon_sym_assert] = ACTIONS(3472),
    [anon_sym_upcast] = ACTIONS(3472),
    [anon_sym_downcast] = ACTIONS(3472),
    [anon_sym_COLON_GT] = ACTIONS(3470),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3470),
    [anon_sym_for] = ACTIONS(3472),
    [anon_sym_while] = ACTIONS(3472),
    [anon_sym_else] = ACTIONS(3822),
    [anon_sym_elif] = ACTIONS(3824),
    [anon_sym_if] = ACTIONS(3472),
    [anon_sym_fun] = ACTIONS(3472),
    [anon_sym_try] = ACTIONS(3472),
    [anon_sym_match] = ACTIONS(3472),
    [anon_sym_match_BANG] = ACTIONS(3470),
    [anon_sym_function] = ACTIONS(3472),
    [anon_sym_LT_DASH] = ACTIONS(3472),
    [anon_sym_DOT_LBRACK] = ACTIONS(3470),
    [anon_sym_LT] = ACTIONS(3470),
    [anon_sym_use] = ACTIONS(3472),
    [anon_sym_use_BANG] = ACTIONS(3470),
    [anon_sym_do_BANG] = ACTIONS(3470),
    [anon_sym_begin] = ACTIONS(3472),
    [anon_sym_LPAREN2] = ACTIONS(3472),
    [anon_sym_default] = ACTIONS(3472),
    [anon_sym_or] = ACTIONS(3472),
    [anon_sym_static] = ACTIONS(3472),
    [anon_sym_member] = ACTIONS(3472),
    [anon_sym_interface] = ACTIONS(3472),
    [anon_sym_abstract] = ACTIONS(3472),
    [anon_sym_val] = ACTIONS(3472),
    [anon_sym_override] = ACTIONS(3472),
    [anon_sym_inherit] = ACTIONS(3472),
    [aux_sym_char_token1] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3472),
    [anon_sym_DQUOTE] = ACTIONS(3472),
    [anon_sym_AT_DQUOTE] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [sym_bool] = ACTIONS(3472),
    [sym_unit] = ACTIONS(3470),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3472),
    [sym_op_identifier] = ACTIONS(3472),
    [anon_sym_PLUS] = ACTIONS(3472),
    [anon_sym_DASH] = ACTIONS(3472),
    [anon_sym_PLUS_DOT] = ACTIONS(3472),
    [anon_sym_DASH_DOT] = ACTIONS(3472),
    [anon_sym_PERCENT] = ACTIONS(3472),
    [anon_sym_AMP_AMP] = ACTIONS(3472),
    [anon_sym_TILDE] = ACTIONS(3470),
    [aux_sym_prefix_op_token1] = ACTIONS(3472),
    [aux_sym_infix_op_token1] = ACTIONS(3470),
    [aux_sym_infix_op_token2] = ACTIONS(3472),
    [anon_sym_PIPE_PIPE] = ACTIONS(3472),
    [anon_sym_BANG_EQ] = ACTIONS(3472),
    [anon_sym_COLON_EQ] = ACTIONS(3470),
    [anon_sym_DOLLAR] = ACTIONS(3472),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3472),
    [sym_int] = ACTIONS(3472),
    [sym_xint] = ACTIONS(3470),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3470),
    [anon_sym_POUNDendif] = ACTIONS(3470),
    [anon_sym_POUNDelse] = ACTIONS(3470),
    [sym__newline] = ACTIONS(3470),
  },
  [1306] = {
    [sym_block_comment] = STATE(1306),
    [sym_compiler_directive_decl] = STATE(1306),
    [sym_fsi_directive_decl] = STATE(1306),
    [sym_preproc_line] = STATE(1306),
    [ts_builtin_sym_end] = ACTIONS(3826),
    [sym_identifier] = ACTIONS(3828),
    [anon_sym_namespace] = ACTIONS(3828),
    [anon_sym_module] = ACTIONS(3828),
    [anon_sym_EQ] = ACTIONS(3826),
    [anon_sym_open] = ACTIONS(3828),
    [anon_sym_LBRACK_LT] = ACTIONS(3826),
    [anon_sym_COLON] = ACTIONS(3828),
    [anon_sym_return] = ACTIONS(3828),
    [anon_sym_type] = ACTIONS(3828),
    [anon_sym_do] = ACTIONS(3828),
    [anon_sym_and] = ACTIONS(3828),
    [anon_sym_let] = ACTIONS(3828),
    [anon_sym_let_BANG] = ACTIONS(3826),
    [aux_sym_access_modifier_token1] = ACTIONS(3826),
    [anon_sym_LPAREN] = ACTIONS(3828),
    [anon_sym_COMMA] = ACTIONS(3826),
    [anon_sym_null] = ACTIONS(3828),
    [anon_sym_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_COLON] = ACTIONS(3826),
    [anon_sym_PIPE] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3828),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3826),
    [anon_sym_LBRACE] = ACTIONS(3828),
    [anon_sym_LT_AT] = ACTIONS(3828),
    [anon_sym_LT_AT_AT] = ACTIONS(3828),
    [anon_sym_DOT] = ACTIONS(3828),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3826),
    [anon_sym_new] = ACTIONS(3828),
    [anon_sym_with] = ACTIONS(3828),
    [anon_sym_return_BANG] = ACTIONS(3826),
    [anon_sym_yield] = ACTIONS(3828),
    [anon_sym_yield_BANG] = ACTIONS(3826),
    [anon_sym_lazy] = ACTIONS(3828),
    [anon_sym_assert] = ACTIONS(3828),
    [anon_sym_upcast] = ACTIONS(3828),
    [anon_sym_downcast] = ACTIONS(3828),
    [anon_sym_COLON_GT] = ACTIONS(3826),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3826),
    [anon_sym_for] = ACTIONS(3828),
    [anon_sym_while] = ACTIONS(3828),
    [anon_sym_if] = ACTIONS(3828),
    [anon_sym_fun] = ACTIONS(3828),
    [anon_sym_try] = ACTIONS(3828),
    [anon_sym_match] = ACTIONS(3828),
    [anon_sym_match_BANG] = ACTIONS(3826),
    [anon_sym_function] = ACTIONS(3828),
    [anon_sym_LT_DASH] = ACTIONS(3828),
    [anon_sym_DOT_LBRACK] = ACTIONS(3826),
    [anon_sym_LT] = ACTIONS(3826),
    [anon_sym_use] = ACTIONS(3828),
    [anon_sym_use_BANG] = ACTIONS(3826),
    [anon_sym_do_BANG] = ACTIONS(3826),
    [anon_sym_begin] = ACTIONS(3828),
    [anon_sym_LPAREN2] = ACTIONS(3828),
    [anon_sym_default] = ACTIONS(3828),
    [anon_sym_or] = ACTIONS(3828),
    [anon_sym_static] = ACTIONS(3828),
    [anon_sym_member] = ACTIONS(3828),
    [anon_sym_interface] = ACTIONS(3828),
    [anon_sym_exception] = ACTIONS(3828),
    [anon_sym_abstract] = ACTIONS(3828),
    [anon_sym_val] = ACTIONS(3828),
    [anon_sym_override] = ACTIONS(3828),
    [aux_sym_char_token1] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3828),
    [anon_sym_DQUOTE] = ACTIONS(3828),
    [anon_sym_AT_DQUOTE] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [sym_bool] = ACTIONS(3828),
    [sym_unit] = ACTIONS(3826),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3828),
    [sym_op_identifier] = ACTIONS(3828),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_DASH] = ACTIONS(3828),
    [anon_sym_PLUS_DOT] = ACTIONS(3828),
    [anon_sym_DASH_DOT] = ACTIONS(3828),
    [anon_sym_PERCENT] = ACTIONS(3828),
    [anon_sym_AMP_AMP] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3826),
    [aux_sym_prefix_op_token1] = ACTIONS(3828),
    [aux_sym_infix_op_token1] = ACTIONS(3826),
    [aux_sym_infix_op_token2] = ACTIONS(3828),
    [anon_sym_PIPE_PIPE] = ACTIONS(3828),
    [anon_sym_BANG_EQ] = ACTIONS(3828),
    [anon_sym_COLON_EQ] = ACTIONS(3826),
    [anon_sym_DOLLAR] = ACTIONS(3828),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3828),
    [sym_int] = ACTIONS(3828),
    [sym_xint] = ACTIONS(3826),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3826),
    [anon_sym_POUNDload] = ACTIONS(3826),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3826),
    [sym__newline] = ACTIONS(3826),
  },
  [1307] = {
    [sym_block_comment] = STATE(1307),
    [sym_compiler_directive_decl] = STATE(1307),
    [sym_fsi_directive_decl] = STATE(1307),
    [sym_preproc_line] = STATE(1307),
    [aux_sym_type_argument_repeat1] = STATE(1307),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_LBRACK_LT] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [aux_sym_access_modifier_token1] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_COLON] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_with] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_LT_DASH] = ACTIONS(3480),
    [anon_sym_DOT_LBRACK] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_default] = ACTIONS(3480),
    [anon_sym_or] = ACTIONS(3830),
    [anon_sym_static] = ACTIONS(3480),
    [anon_sym_member] = ACTIONS(3480),
    [anon_sym_interface] = ACTIONS(3480),
    [anon_sym_abstract] = ACTIONS(3480),
    [anon_sym_val] = ACTIONS(3480),
    [anon_sym_override] = ACTIONS(3480),
    [anon_sym_inherit] = ACTIONS(3480),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3480),
    [anon_sym_DASH_DOT] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3480),
    [aux_sym_infix_op_token1] = ACTIONS(3478),
    [aux_sym_infix_op_token2] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3480),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [anon_sym_POUNDendif] = ACTIONS(3478),
    [anon_sym_POUNDelse] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
  },
  [1308] = {
    [sym_block_comment] = STATE(1308),
    [sym_compiler_directive_decl] = STATE(1308),
    [sym_fsi_directive_decl] = STATE(1308),
    [sym_preproc_line] = STATE(1308),
    [aux_sym_compound_type_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(3427),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_LBRACK_LT] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [aux_sym_access_modifier_token1] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3427),
    [anon_sym_DOT] = ACTIONS(3427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_with] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_COLON_GT] = ACTIONS(3425),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(3427),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_LT_DASH] = ACTIONS(3427),
    [anon_sym_DOT_LBRACK] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(3833),
    [anon_sym_LT2] = ACTIONS(3427),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3425),
    [anon_sym_default] = ACTIONS(3427),
    [anon_sym_or] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_member] = ACTIONS(3427),
    [anon_sym_interface] = ACTIONS(3427),
    [anon_sym_abstract] = ACTIONS(3427),
    [anon_sym_val] = ACTIONS(3427),
    [anon_sym_override] = ACTIONS(3427),
    [anon_sym_inherit] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3427),
    [anon_sym_DASH_DOT] = ACTIONS(3427),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3427),
    [aux_sym_infix_op_token1] = ACTIONS(3425),
    [aux_sym_infix_op_token2] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3427),
    [anon_sym_COLON_EQ] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3427),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [anon_sym_POUNDendif] = ACTIONS(3425),
    [anon_sym_POUNDelse] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
  },
  [1309] = {
    [sym_block_comment] = STATE(1309),
    [sym_compiler_directive_decl] = STATE(1309),
    [sym_fsi_directive_decl] = STATE(1309),
    [sym_preproc_line] = STATE(1309),
    [aux_sym_type_argument_repeat1] = STATE(1297),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_LBRACK_LT] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [aux_sym_access_modifier_token1] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_with] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [anon_sym_DOT_LBRACK] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_default] = ACTIONS(3498),
    [anon_sym_or] = ACTIONS(3836),
    [anon_sym_static] = ACTIONS(3498),
    [anon_sym_member] = ACTIONS(3498),
    [anon_sym_interface] = ACTIONS(3498),
    [anon_sym_abstract] = ACTIONS(3498),
    [anon_sym_val] = ACTIONS(3498),
    [anon_sym_override] = ACTIONS(3498),
    [anon_sym_inherit] = ACTIONS(3498),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3498),
    [anon_sym_DASH_DOT] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3498),
    [aux_sym_infix_op_token1] = ACTIONS(3496),
    [aux_sym_infix_op_token2] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_COLON_EQ] = ACTIONS(3496),
    [anon_sym_DOLLAR] = ACTIONS(3498),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3498),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [anon_sym_POUNDendif] = ACTIONS(3496),
    [anon_sym_POUNDelse] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
  },
  [1310] = {
    [sym_block_comment] = STATE(1310),
    [sym_compiler_directive_decl] = STATE(1310),
    [sym_fsi_directive_decl] = STATE(1310),
    [sym_preproc_line] = STATE(1310),
    [ts_builtin_sym_end] = ACTIONS(3191),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_module] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_open] = ACTIONS(3193),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_type] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_exception] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3564),
    [anon_sym_uy] = ACTIONS(3566),
    [anon_sym_s] = ACTIONS(3568),
    [anon_sym_us] = ACTIONS(3570),
    [anon_sym_l] = ACTIONS(3572),
    [aux_sym_uint32_token1] = ACTIONS(3574),
    [anon_sym_n] = ACTIONS(3576),
    [anon_sym_un] = ACTIONS(3578),
    [anon_sym_L] = ACTIONS(3580),
    [aux_sym_uint64_token1] = ACTIONS(3582),
    [anon_sym_lf] = ACTIONS(3712),
    [anon_sym_LF] = ACTIONS(3714),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3191),
    [anon_sym_POUNDload] = ACTIONS(3191),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1311] = {
    [sym_block_comment] = STATE(1311),
    [sym_compiler_directive_decl] = STATE(1311),
    [sym_fsi_directive_decl] = STATE(1311),
    [sym_preproc_line] = STATE(1311),
    [ts_builtin_sym_end] = ACTIONS(3839),
    [sym_identifier] = ACTIONS(3841),
    [anon_sym_namespace] = ACTIONS(3841),
    [anon_sym_module] = ACTIONS(3841),
    [anon_sym_EQ] = ACTIONS(3839),
    [anon_sym_open] = ACTIONS(3841),
    [anon_sym_LBRACK_LT] = ACTIONS(3839),
    [anon_sym_COLON] = ACTIONS(3841),
    [anon_sym_return] = ACTIONS(3841),
    [anon_sym_type] = ACTIONS(3841),
    [anon_sym_do] = ACTIONS(3841),
    [anon_sym_and] = ACTIONS(3841),
    [anon_sym_let] = ACTIONS(3841),
    [anon_sym_let_BANG] = ACTIONS(3839),
    [aux_sym_access_modifier_token1] = ACTIONS(3839),
    [anon_sym_LPAREN] = ACTIONS(3841),
    [anon_sym_COMMA] = ACTIONS(3839),
    [anon_sym_null] = ACTIONS(3841),
    [anon_sym_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_COLON] = ACTIONS(3839),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_AMP] = ACTIONS(3841),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(3841),
    [anon_sym_LT_AT] = ACTIONS(3841),
    [anon_sym_LT_AT_AT] = ACTIONS(3841),
    [anon_sym_DOT] = ACTIONS(3841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3839),
    [anon_sym_new] = ACTIONS(3841),
    [anon_sym_with] = ACTIONS(3841),
    [anon_sym_return_BANG] = ACTIONS(3839),
    [anon_sym_yield] = ACTIONS(3841),
    [anon_sym_yield_BANG] = ACTIONS(3839),
    [anon_sym_lazy] = ACTIONS(3841),
    [anon_sym_assert] = ACTIONS(3841),
    [anon_sym_upcast] = ACTIONS(3841),
    [anon_sym_downcast] = ACTIONS(3841),
    [anon_sym_COLON_GT] = ACTIONS(3839),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3839),
    [anon_sym_for] = ACTIONS(3841),
    [anon_sym_while] = ACTIONS(3841),
    [anon_sym_if] = ACTIONS(3841),
    [anon_sym_fun] = ACTIONS(3841),
    [anon_sym_try] = ACTIONS(3841),
    [anon_sym_match] = ACTIONS(3841),
    [anon_sym_match_BANG] = ACTIONS(3839),
    [anon_sym_function] = ACTIONS(3841),
    [anon_sym_LT_DASH] = ACTIONS(3841),
    [anon_sym_DOT_LBRACK] = ACTIONS(3839),
    [anon_sym_LT] = ACTIONS(3839),
    [anon_sym_use] = ACTIONS(3841),
    [anon_sym_use_BANG] = ACTIONS(3839),
    [anon_sym_do_BANG] = ACTIONS(3839),
    [anon_sym_begin] = ACTIONS(3841),
    [anon_sym_LPAREN2] = ACTIONS(3841),
    [anon_sym_default] = ACTIONS(3841),
    [anon_sym_or] = ACTIONS(3841),
    [anon_sym_static] = ACTIONS(3841),
    [anon_sym_member] = ACTIONS(3841),
    [anon_sym_interface] = ACTIONS(3841),
    [anon_sym_exception] = ACTIONS(3841),
    [anon_sym_abstract] = ACTIONS(3841),
    [anon_sym_val] = ACTIONS(3841),
    [anon_sym_override] = ACTIONS(3841),
    [aux_sym_char_token1] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3841),
    [anon_sym_DQUOTE] = ACTIONS(3841),
    [anon_sym_AT_DQUOTE] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [sym_bool] = ACTIONS(3841),
    [sym_unit] = ACTIONS(3839),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3841),
    [sym_op_identifier] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_PLUS_DOT] = ACTIONS(3841),
    [anon_sym_DASH_DOT] = ACTIONS(3841),
    [anon_sym_PERCENT] = ACTIONS(3841),
    [anon_sym_AMP_AMP] = ACTIONS(3841),
    [anon_sym_TILDE] = ACTIONS(3839),
    [aux_sym_prefix_op_token1] = ACTIONS(3841),
    [aux_sym_infix_op_token1] = ACTIONS(3839),
    [aux_sym_infix_op_token2] = ACTIONS(3841),
    [anon_sym_PIPE_PIPE] = ACTIONS(3841),
    [anon_sym_BANG_EQ] = ACTIONS(3841),
    [anon_sym_COLON_EQ] = ACTIONS(3839),
    [anon_sym_DOLLAR] = ACTIONS(3841),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3841),
    [sym_int] = ACTIONS(3841),
    [sym_xint] = ACTIONS(3839),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3839),
    [anon_sym_POUNDload] = ACTIONS(3839),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3839),
    [sym__newline] = ACTIONS(3839),
  },
  [1312] = {
    [sym__else_expression] = STATE(1741),
    [sym_elif_expression] = STATE(1557),
    [sym_block_comment] = STATE(1312),
    [sym_compiler_directive_decl] = STATE(1312),
    [sym_fsi_directive_decl] = STATE(1312),
    [sym_preproc_line] = STATE(1312),
    [aux_sym_if_expression_repeat1] = STATE(1337),
    [sym_identifier] = ACTIONS(3457),
    [anon_sym_EQ] = ACTIONS(3455),
    [anon_sym_LBRACK_LT] = ACTIONS(3455),
    [anon_sym_COLON] = ACTIONS(3457),
    [anon_sym_return] = ACTIONS(3457),
    [anon_sym_do] = ACTIONS(3457),
    [anon_sym_let] = ACTIONS(3457),
    [anon_sym_let_BANG] = ACTIONS(3455),
    [aux_sym_access_modifier_token1] = ACTIONS(3455),
    [anon_sym_LPAREN] = ACTIONS(3457),
    [anon_sym_COMMA] = ACTIONS(3455),
    [anon_sym_null] = ACTIONS(3457),
    [anon_sym_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_COLON] = ACTIONS(3455),
    [anon_sym_AMP] = ACTIONS(3457),
    [anon_sym_LBRACK] = ACTIONS(3457),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3457),
    [anon_sym_LT_AT] = ACTIONS(3457),
    [anon_sym_LT_AT_AT] = ACTIONS(3457),
    [anon_sym_DOT] = ACTIONS(3457),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3457),
    [anon_sym_with] = ACTIONS(3457),
    [anon_sym_return_BANG] = ACTIONS(3455),
    [anon_sym_yield] = ACTIONS(3457),
    [anon_sym_yield_BANG] = ACTIONS(3455),
    [anon_sym_lazy] = ACTIONS(3457),
    [anon_sym_assert] = ACTIONS(3457),
    [anon_sym_upcast] = ACTIONS(3457),
    [anon_sym_downcast] = ACTIONS(3457),
    [anon_sym_COLON_GT] = ACTIONS(3455),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3457),
    [anon_sym_while] = ACTIONS(3457),
    [anon_sym_else] = ACTIONS(3822),
    [anon_sym_elif] = ACTIONS(3824),
    [anon_sym_if] = ACTIONS(3457),
    [anon_sym_fun] = ACTIONS(3457),
    [anon_sym_try] = ACTIONS(3457),
    [anon_sym_match] = ACTIONS(3457),
    [anon_sym_match_BANG] = ACTIONS(3455),
    [anon_sym_function] = ACTIONS(3457),
    [anon_sym_LT_DASH] = ACTIONS(3457),
    [anon_sym_DOT_LBRACK] = ACTIONS(3455),
    [anon_sym_LT] = ACTIONS(3455),
    [anon_sym_use] = ACTIONS(3457),
    [anon_sym_use_BANG] = ACTIONS(3455),
    [anon_sym_do_BANG] = ACTIONS(3455),
    [anon_sym_begin] = ACTIONS(3457),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_default] = ACTIONS(3457),
    [anon_sym_or] = ACTIONS(3457),
    [anon_sym_static] = ACTIONS(3457),
    [anon_sym_member] = ACTIONS(3457),
    [anon_sym_interface] = ACTIONS(3457),
    [anon_sym_abstract] = ACTIONS(3457),
    [anon_sym_val] = ACTIONS(3457),
    [anon_sym_override] = ACTIONS(3457),
    [anon_sym_inherit] = ACTIONS(3457),
    [aux_sym_char_token1] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [anon_sym_AT_DQUOTE] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [sym_bool] = ACTIONS(3457),
    [sym_unit] = ACTIONS(3455),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3457),
    [sym_op_identifier] = ACTIONS(3457),
    [anon_sym_PLUS] = ACTIONS(3457),
    [anon_sym_DASH] = ACTIONS(3457),
    [anon_sym_PLUS_DOT] = ACTIONS(3457),
    [anon_sym_DASH_DOT] = ACTIONS(3457),
    [anon_sym_PERCENT] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3455),
    [aux_sym_prefix_op_token1] = ACTIONS(3457),
    [aux_sym_infix_op_token1] = ACTIONS(3455),
    [aux_sym_infix_op_token2] = ACTIONS(3457),
    [anon_sym_PIPE_PIPE] = ACTIONS(3457),
    [anon_sym_BANG_EQ] = ACTIONS(3457),
    [anon_sym_COLON_EQ] = ACTIONS(3455),
    [anon_sym_DOLLAR] = ACTIONS(3457),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3457),
    [sym_int] = ACTIONS(3457),
    [sym_xint] = ACTIONS(3455),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3455),
    [anon_sym_POUNDendif] = ACTIONS(3455),
    [anon_sym_POUNDelse] = ACTIONS(3455),
    [sym__newline] = ACTIONS(3455),
  },
  [1313] = {
    [sym_block_comment] = STATE(1313),
    [sym_compiler_directive_decl] = STATE(1313),
    [sym_fsi_directive_decl] = STATE(1313),
    [sym_preproc_line] = STATE(1313),
    [aux_sym_compound_type_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(3468),
    [anon_sym_EQ] = ACTIONS(3466),
    [anon_sym_LBRACK_LT] = ACTIONS(3466),
    [anon_sym_COLON] = ACTIONS(3468),
    [anon_sym_return] = ACTIONS(3468),
    [anon_sym_do] = ACTIONS(3468),
    [anon_sym_let] = ACTIONS(3468),
    [anon_sym_let_BANG] = ACTIONS(3466),
    [aux_sym_access_modifier_token1] = ACTIONS(3466),
    [anon_sym_LPAREN] = ACTIONS(3468),
    [anon_sym_COMMA] = ACTIONS(3466),
    [anon_sym_null] = ACTIONS(3468),
    [anon_sym_QMARK] = ACTIONS(3468),
    [anon_sym_COLON_QMARK] = ACTIONS(3468),
    [anon_sym_COLON_COLON] = ACTIONS(3466),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LBRACK] = ACTIONS(3468),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3466),
    [anon_sym_LBRACE] = ACTIONS(3468),
    [anon_sym_LT_AT] = ACTIONS(3468),
    [anon_sym_LT_AT_AT] = ACTIONS(3468),
    [anon_sym_DOT] = ACTIONS(3468),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3466),
    [anon_sym_new] = ACTIONS(3468),
    [anon_sym_with] = ACTIONS(3468),
    [anon_sym_return_BANG] = ACTIONS(3466),
    [anon_sym_yield] = ACTIONS(3468),
    [anon_sym_yield_BANG] = ACTIONS(3466),
    [anon_sym_lazy] = ACTIONS(3468),
    [anon_sym_assert] = ACTIONS(3468),
    [anon_sym_upcast] = ACTIONS(3468),
    [anon_sym_downcast] = ACTIONS(3468),
    [anon_sym_COLON_GT] = ACTIONS(3466),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3466),
    [anon_sym_for] = ACTIONS(3468),
    [anon_sym_while] = ACTIONS(3468),
    [anon_sym_if] = ACTIONS(3468),
    [anon_sym_fun] = ACTIONS(3468),
    [anon_sym_DASH_GT] = ACTIONS(3468),
    [anon_sym_try] = ACTIONS(3468),
    [anon_sym_match] = ACTIONS(3468),
    [anon_sym_match_BANG] = ACTIONS(3466),
    [anon_sym_function] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3468),
    [anon_sym_DOT_LBRACK] = ACTIONS(3466),
    [anon_sym_LT] = ACTIONS(3466),
    [anon_sym_use] = ACTIONS(3468),
    [anon_sym_use_BANG] = ACTIONS(3466),
    [anon_sym_do_BANG] = ACTIONS(3466),
    [anon_sym_begin] = ACTIONS(3468),
    [anon_sym_LPAREN2] = ACTIONS(3468),
    [anon_sym_STAR] = ACTIONS(3612),
    [anon_sym_LT2] = ACTIONS(3468),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3466),
    [anon_sym_default] = ACTIONS(3468),
    [anon_sym_or] = ACTIONS(3468),
    [anon_sym_static] = ACTIONS(3468),
    [anon_sym_member] = ACTIONS(3468),
    [anon_sym_interface] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(3468),
    [anon_sym_val] = ACTIONS(3468),
    [anon_sym_override] = ACTIONS(3468),
    [anon_sym_inherit] = ACTIONS(3468),
    [aux_sym_char_token1] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3468),
    [anon_sym_DQUOTE] = ACTIONS(3468),
    [anon_sym_AT_DQUOTE] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [sym_bool] = ACTIONS(3468),
    [sym_unit] = ACTIONS(3466),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3468),
    [sym_op_identifier] = ACTIONS(3468),
    [anon_sym_PLUS] = ACTIONS(3468),
    [anon_sym_DASH] = ACTIONS(3468),
    [anon_sym_PLUS_DOT] = ACTIONS(3468),
    [anon_sym_DASH_DOT] = ACTIONS(3468),
    [anon_sym_PERCENT] = ACTIONS(3468),
    [anon_sym_AMP_AMP] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3466),
    [aux_sym_prefix_op_token1] = ACTIONS(3468),
    [aux_sym_infix_op_token1] = ACTIONS(3466),
    [aux_sym_infix_op_token2] = ACTIONS(3468),
    [anon_sym_PIPE_PIPE] = ACTIONS(3468),
    [anon_sym_BANG_EQ] = ACTIONS(3468),
    [anon_sym_COLON_EQ] = ACTIONS(3466),
    [anon_sym_DOLLAR] = ACTIONS(3468),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3468),
    [sym_int] = ACTIONS(3468),
    [sym_xint] = ACTIONS(3466),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3466),
    [anon_sym_POUNDendif] = ACTIONS(3466),
    [anon_sym_POUNDelse] = ACTIONS(3466),
    [sym__newline] = ACTIONS(3466),
  },
  [1314] = {
    [sym_block_comment] = STATE(1314),
    [sym_compiler_directive_decl] = STATE(1314),
    [sym_fsi_directive_decl] = STATE(1314),
    [sym_preproc_line] = STATE(1314),
    [aux_sym_long_identifier_repeat1] = STATE(1293),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_EQ] = ACTIONS(3492),
    [anon_sym_LBRACK_LT] = ACTIONS(3492),
    [anon_sym_COLON] = ACTIONS(3494),
    [anon_sym_return] = ACTIONS(3494),
    [anon_sym_do] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_let_BANG] = ACTIONS(3492),
    [aux_sym_access_modifier_token1] = ACTIONS(3492),
    [anon_sym_LPAREN] = ACTIONS(3494),
    [anon_sym_COMMA] = ACTIONS(3492),
    [anon_sym_null] = ACTIONS(3494),
    [anon_sym_QMARK] = ACTIONS(3494),
    [anon_sym_COLON_QMARK] = ACTIONS(3494),
    [anon_sym_COLON_COLON] = ACTIONS(3492),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3492),
    [anon_sym_LBRACE] = ACTIONS(3494),
    [anon_sym_LT_AT] = ACTIONS(3494),
    [anon_sym_LT_AT_AT] = ACTIONS(3494),
    [anon_sym_DOT] = ACTIONS(3796),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3492),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_with] = ACTIONS(3494),
    [anon_sym_return_BANG] = ACTIONS(3492),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_yield_BANG] = ACTIONS(3492),
    [anon_sym_lazy] = ACTIONS(3494),
    [anon_sym_assert] = ACTIONS(3494),
    [anon_sym_upcast] = ACTIONS(3494),
    [anon_sym_downcast] = ACTIONS(3494),
    [anon_sym_COLON_GT] = ACTIONS(3492),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3492),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_while] = ACTIONS(3494),
    [anon_sym_if] = ACTIONS(3494),
    [anon_sym_fun] = ACTIONS(3494),
    [anon_sym_DASH_GT] = ACTIONS(3494),
    [anon_sym_try] = ACTIONS(3494),
    [anon_sym_match] = ACTIONS(3494),
    [anon_sym_match_BANG] = ACTIONS(3492),
    [anon_sym_function] = ACTIONS(3494),
    [anon_sym_LT_DASH] = ACTIONS(3494),
    [anon_sym_DOT_LBRACK] = ACTIONS(3492),
    [anon_sym_LT] = ACTIONS(3492),
    [anon_sym_use] = ACTIONS(3494),
    [anon_sym_use_BANG] = ACTIONS(3492),
    [anon_sym_do_BANG] = ACTIONS(3492),
    [anon_sym_begin] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(3494),
    [anon_sym_STAR] = ACTIONS(3494),
    [anon_sym_LT2] = ACTIONS(3494),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3492),
    [anon_sym_default] = ACTIONS(3494),
    [anon_sym_or] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_member] = ACTIONS(3494),
    [anon_sym_interface] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_val] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_inherit] = ACTIONS(3494),
    [aux_sym_char_token1] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3494),
    [anon_sym_DQUOTE] = ACTIONS(3494),
    [anon_sym_AT_DQUOTE] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [sym_bool] = ACTIONS(3494),
    [sym_unit] = ACTIONS(3492),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3494),
    [sym_op_identifier] = ACTIONS(3494),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_PLUS_DOT] = ACTIONS(3494),
    [anon_sym_DASH_DOT] = ACTIONS(3494),
    [anon_sym_PERCENT] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_TILDE] = ACTIONS(3492),
    [aux_sym_prefix_op_token1] = ACTIONS(3494),
    [aux_sym_infix_op_token1] = ACTIONS(3492),
    [aux_sym_infix_op_token2] = ACTIONS(3494),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_COLON_EQ] = ACTIONS(3492),
    [anon_sym_DOLLAR] = ACTIONS(3494),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3494),
    [sym_int] = ACTIONS(3494),
    [sym_xint] = ACTIONS(3492),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3492),
    [anon_sym_POUNDendif] = ACTIONS(3492),
    [anon_sym_POUNDelse] = ACTIONS(3492),
    [sym__newline] = ACTIONS(3492),
  },
  [1315] = {
    [sym_block_comment] = STATE(1315),
    [sym_compiler_directive_decl] = STATE(1315),
    [sym_fsi_directive_decl] = STATE(1315),
    [sym_preproc_line] = STATE(1315),
    [ts_builtin_sym_end] = ACTIONS(3843),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_namespace] = ACTIONS(3845),
    [anon_sym_module] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3843),
    [anon_sym_open] = ACTIONS(3845),
    [anon_sym_LBRACK_LT] = ACTIONS(3843),
    [anon_sym_COLON] = ACTIONS(3845),
    [anon_sym_return] = ACTIONS(3845),
    [anon_sym_type] = ACTIONS(3845),
    [anon_sym_do] = ACTIONS(3845),
    [anon_sym_and] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_let_BANG] = ACTIONS(3843),
    [aux_sym_access_modifier_token1] = ACTIONS(3843),
    [anon_sym_LPAREN] = ACTIONS(3845),
    [anon_sym_COMMA] = ACTIONS(3843),
    [anon_sym_null] = ACTIONS(3845),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3843),
    [anon_sym_LBRACE] = ACTIONS(3845),
    [anon_sym_LT_AT] = ACTIONS(3845),
    [anon_sym_LT_AT_AT] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3843),
    [anon_sym_new] = ACTIONS(3845),
    [anon_sym_with] = ACTIONS(3845),
    [anon_sym_return_BANG] = ACTIONS(3843),
    [anon_sym_yield] = ACTIONS(3845),
    [anon_sym_yield_BANG] = ACTIONS(3843),
    [anon_sym_lazy] = ACTIONS(3845),
    [anon_sym_assert] = ACTIONS(3845),
    [anon_sym_upcast] = ACTIONS(3845),
    [anon_sym_downcast] = ACTIONS(3845),
    [anon_sym_COLON_GT] = ACTIONS(3843),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3843),
    [anon_sym_for] = ACTIONS(3845),
    [anon_sym_while] = ACTIONS(3845),
    [anon_sym_if] = ACTIONS(3845),
    [anon_sym_fun] = ACTIONS(3845),
    [anon_sym_try] = ACTIONS(3845),
    [anon_sym_match] = ACTIONS(3845),
    [anon_sym_match_BANG] = ACTIONS(3843),
    [anon_sym_function] = ACTIONS(3845),
    [anon_sym_LT_DASH] = ACTIONS(3845),
    [anon_sym_DOT_LBRACK] = ACTIONS(3843),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_use] = ACTIONS(3845),
    [anon_sym_use_BANG] = ACTIONS(3843),
    [anon_sym_do_BANG] = ACTIONS(3843),
    [anon_sym_begin] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(3845),
    [anon_sym_default] = ACTIONS(3845),
    [anon_sym_or] = ACTIONS(3845),
    [anon_sym_static] = ACTIONS(3845),
    [anon_sym_member] = ACTIONS(3845),
    [anon_sym_interface] = ACTIONS(3845),
    [anon_sym_exception] = ACTIONS(3845),
    [anon_sym_abstract] = ACTIONS(3845),
    [anon_sym_val] = ACTIONS(3845),
    [anon_sym_override] = ACTIONS(3845),
    [aux_sym_char_token1] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3845),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_AT_DQUOTE] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [sym_bool] = ACTIONS(3845),
    [sym_unit] = ACTIONS(3843),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3845),
    [sym_op_identifier] = ACTIONS(3845),
    [anon_sym_PLUS] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_PLUS_DOT] = ACTIONS(3845),
    [anon_sym_DASH_DOT] = ACTIONS(3845),
    [anon_sym_PERCENT] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3845),
    [anon_sym_TILDE] = ACTIONS(3843),
    [aux_sym_prefix_op_token1] = ACTIONS(3845),
    [aux_sym_infix_op_token1] = ACTIONS(3843),
    [aux_sym_infix_op_token2] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(3845),
    [anon_sym_BANG_EQ] = ACTIONS(3845),
    [anon_sym_COLON_EQ] = ACTIONS(3843),
    [anon_sym_DOLLAR] = ACTIONS(3845),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3845),
    [sym_int] = ACTIONS(3845),
    [sym_xint] = ACTIONS(3843),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3843),
    [anon_sym_POUNDload] = ACTIONS(3843),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3843),
    [sym__newline] = ACTIONS(3843),
  },
  [1316] = {
    [sym_block_comment] = STATE(1316),
    [sym_compiler_directive_decl] = STATE(1316),
    [sym_fsi_directive_decl] = STATE(1316),
    [sym_preproc_line] = STATE(1316),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_LBRACK_LT] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_and] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [aux_sym_access_modifier_token1] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_COLON] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_with] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_LT_DASH] = ACTIONS(3480),
    [anon_sym_DOT_LBRACK] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_default] = ACTIONS(3480),
    [anon_sym_or] = ACTIONS(3480),
    [anon_sym_static] = ACTIONS(3480),
    [anon_sym_member] = ACTIONS(3480),
    [anon_sym_interface] = ACTIONS(3480),
    [anon_sym_abstract] = ACTIONS(3480),
    [anon_sym_val] = ACTIONS(3480),
    [anon_sym_override] = ACTIONS(3480),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3480),
    [anon_sym_DASH_DOT] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3480),
    [aux_sym_infix_op_token1] = ACTIONS(3478),
    [aux_sym_infix_op_token2] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3480),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [anon_sym_POUNDendif] = ACTIONS(3478),
    [anon_sym_POUNDelse] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
  },
  [1317] = {
    [sym_block_comment] = STATE(1317),
    [sym_compiler_directive_decl] = STATE(1317),
    [sym_fsi_directive_decl] = STATE(1317),
    [sym_preproc_line] = STATE(1317),
    [ts_builtin_sym_end] = ACTIONS(3191),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_namespace] = ACTIONS(3193),
    [anon_sym_module] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_open] = ACTIONS(3193),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_type] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_and] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [aux_sym_access_modifier_token1] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_member] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_exception] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_val] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3191),
    [anon_sym_POUNDload] = ACTIONS(3191),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1318] = {
    [sym__else_expression] = STATE(2176),
    [sym_elif_expression] = STATE(1633),
    [sym_block_comment] = STATE(1318),
    [sym_compiler_directive_decl] = STATE(1318),
    [sym_fsi_directive_decl] = STATE(1318),
    [sym_preproc_line] = STATE(1318),
    [aux_sym_if_expression_repeat1] = STATE(1529),
    [sym_identifier] = ACTIONS(3457),
    [anon_sym_EQ] = ACTIONS(3455),
    [anon_sym_LBRACK_LT] = ACTIONS(3455),
    [anon_sym_COLON] = ACTIONS(3457),
    [anon_sym_return] = ACTIONS(3457),
    [anon_sym_do] = ACTIONS(3457),
    [anon_sym_and] = ACTIONS(3457),
    [anon_sym_let] = ACTIONS(3457),
    [anon_sym_let_BANG] = ACTIONS(3455),
    [aux_sym_access_modifier_token1] = ACTIONS(3455),
    [anon_sym_LPAREN] = ACTIONS(3457),
    [anon_sym_COMMA] = ACTIONS(3455),
    [anon_sym_null] = ACTIONS(3457),
    [anon_sym_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_COLON] = ACTIONS(3455),
    [anon_sym_AMP] = ACTIONS(3457),
    [anon_sym_LBRACK] = ACTIONS(3457),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3457),
    [anon_sym_LT_AT] = ACTIONS(3457),
    [anon_sym_LT_AT_AT] = ACTIONS(3457),
    [anon_sym_DOT] = ACTIONS(3457),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3457),
    [anon_sym_with] = ACTIONS(3457),
    [anon_sym_return_BANG] = ACTIONS(3455),
    [anon_sym_yield] = ACTIONS(3457),
    [anon_sym_yield_BANG] = ACTIONS(3455),
    [anon_sym_lazy] = ACTIONS(3457),
    [anon_sym_assert] = ACTIONS(3457),
    [anon_sym_upcast] = ACTIONS(3457),
    [anon_sym_downcast] = ACTIONS(3457),
    [anon_sym_COLON_GT] = ACTIONS(3455),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3457),
    [anon_sym_while] = ACTIONS(3457),
    [anon_sym_else] = ACTIONS(3847),
    [anon_sym_elif] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3457),
    [anon_sym_fun] = ACTIONS(3457),
    [anon_sym_try] = ACTIONS(3457),
    [anon_sym_match] = ACTIONS(3457),
    [anon_sym_match_BANG] = ACTIONS(3455),
    [anon_sym_function] = ACTIONS(3457),
    [anon_sym_LT_DASH] = ACTIONS(3457),
    [anon_sym_DOT_LBRACK] = ACTIONS(3455),
    [anon_sym_LT] = ACTIONS(3455),
    [anon_sym_use] = ACTIONS(3457),
    [anon_sym_use_BANG] = ACTIONS(3455),
    [anon_sym_do_BANG] = ACTIONS(3455),
    [anon_sym_begin] = ACTIONS(3457),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_default] = ACTIONS(3457),
    [anon_sym_or] = ACTIONS(3457),
    [anon_sym_static] = ACTIONS(3457),
    [anon_sym_member] = ACTIONS(3457),
    [anon_sym_interface] = ACTIONS(3457),
    [anon_sym_abstract] = ACTIONS(3457),
    [anon_sym_val] = ACTIONS(3457),
    [anon_sym_override] = ACTIONS(3457),
    [aux_sym_char_token1] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [anon_sym_AT_DQUOTE] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [sym_bool] = ACTIONS(3457),
    [sym_unit] = ACTIONS(3455),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3457),
    [sym_op_identifier] = ACTIONS(3457),
    [anon_sym_PLUS] = ACTIONS(3457),
    [anon_sym_DASH] = ACTIONS(3457),
    [anon_sym_PLUS_DOT] = ACTIONS(3457),
    [anon_sym_DASH_DOT] = ACTIONS(3457),
    [anon_sym_PERCENT] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3455),
    [aux_sym_prefix_op_token1] = ACTIONS(3457),
    [aux_sym_infix_op_token1] = ACTIONS(3455),
    [aux_sym_infix_op_token2] = ACTIONS(3457),
    [anon_sym_PIPE_PIPE] = ACTIONS(3457),
    [anon_sym_BANG_EQ] = ACTIONS(3457),
    [anon_sym_COLON_EQ] = ACTIONS(3455),
    [anon_sym_DOLLAR] = ACTIONS(3457),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3457),
    [sym_int] = ACTIONS(3457),
    [sym_xint] = ACTIONS(3455),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3455),
    [sym__newline] = ACTIONS(3455),
    [sym__dedent] = ACTIONS(3455),
  },
  [1319] = {
    [sym_block_comment] = STATE(1319),
    [sym_compiler_directive_decl] = STATE(1319),
    [sym_fsi_directive_decl] = STATE(1319),
    [sym_preproc_line] = STATE(1319),
    [aux_sym_type_argument_repeat1] = STATE(1319),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_LBRACK_LT] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [aux_sym_access_modifier_token1] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_COLON] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_with] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_LT_DASH] = ACTIONS(3480),
    [anon_sym_DOT_LBRACK] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_default] = ACTIONS(3480),
    [anon_sym_or] = ACTIONS(3851),
    [anon_sym_static] = ACTIONS(3480),
    [anon_sym_member] = ACTIONS(3480),
    [anon_sym_interface] = ACTIONS(3480),
    [anon_sym_abstract] = ACTIONS(3480),
    [anon_sym_val] = ACTIONS(3480),
    [anon_sym_override] = ACTIONS(3480),
    [anon_sym_inherit] = ACTIONS(3480),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3480),
    [anon_sym_DASH_DOT] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3480),
    [aux_sym_infix_op_token1] = ACTIONS(3478),
    [aux_sym_infix_op_token2] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3480),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [anon_sym_POUNDendif] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
  },
  [1320] = {
    [sym_block_comment] = STATE(1320),
    [sym_compiler_directive_decl] = STATE(1320),
    [sym_fsi_directive_decl] = STATE(1320),
    [sym_preproc_line] = STATE(1320),
    [ts_builtin_sym_end] = ACTIONS(3854),
    [sym_identifier] = ACTIONS(3856),
    [anon_sym_namespace] = ACTIONS(3856),
    [anon_sym_module] = ACTIONS(3856),
    [anon_sym_EQ] = ACTIONS(3854),
    [anon_sym_open] = ACTIONS(3856),
    [anon_sym_LBRACK_LT] = ACTIONS(3854),
    [anon_sym_COLON] = ACTIONS(3856),
    [anon_sym_return] = ACTIONS(3856),
    [anon_sym_type] = ACTIONS(3856),
    [anon_sym_do] = ACTIONS(3856),
    [anon_sym_and] = ACTIONS(3856),
    [anon_sym_let] = ACTIONS(3856),
    [anon_sym_let_BANG] = ACTIONS(3854),
    [aux_sym_access_modifier_token1] = ACTIONS(3854),
    [anon_sym_LPAREN] = ACTIONS(3856),
    [anon_sym_COMMA] = ACTIONS(3854),
    [anon_sym_null] = ACTIONS(3856),
    [anon_sym_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_AMP] = ACTIONS(3856),
    [anon_sym_LBRACK] = ACTIONS(3856),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3854),
    [anon_sym_LBRACE] = ACTIONS(3856),
    [anon_sym_LT_AT] = ACTIONS(3856),
    [anon_sym_LT_AT_AT] = ACTIONS(3856),
    [anon_sym_DOT] = ACTIONS(3856),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3854),
    [anon_sym_new] = ACTIONS(3856),
    [anon_sym_with] = ACTIONS(3856),
    [anon_sym_return_BANG] = ACTIONS(3854),
    [anon_sym_yield] = ACTIONS(3856),
    [anon_sym_yield_BANG] = ACTIONS(3854),
    [anon_sym_lazy] = ACTIONS(3856),
    [anon_sym_assert] = ACTIONS(3856),
    [anon_sym_upcast] = ACTIONS(3856),
    [anon_sym_downcast] = ACTIONS(3856),
    [anon_sym_COLON_GT] = ACTIONS(3854),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3854),
    [anon_sym_for] = ACTIONS(3856),
    [anon_sym_while] = ACTIONS(3856),
    [anon_sym_if] = ACTIONS(3856),
    [anon_sym_fun] = ACTIONS(3856),
    [anon_sym_try] = ACTIONS(3856),
    [anon_sym_match] = ACTIONS(3856),
    [anon_sym_match_BANG] = ACTIONS(3854),
    [anon_sym_function] = ACTIONS(3856),
    [anon_sym_LT_DASH] = ACTIONS(3856),
    [anon_sym_DOT_LBRACK] = ACTIONS(3854),
    [anon_sym_LT] = ACTIONS(3854),
    [anon_sym_use] = ACTIONS(3856),
    [anon_sym_use_BANG] = ACTIONS(3854),
    [anon_sym_do_BANG] = ACTIONS(3854),
    [anon_sym_begin] = ACTIONS(3856),
    [anon_sym_LPAREN2] = ACTIONS(3856),
    [anon_sym_default] = ACTIONS(3856),
    [anon_sym_or] = ACTIONS(3856),
    [anon_sym_static] = ACTIONS(3856),
    [anon_sym_member] = ACTIONS(3856),
    [anon_sym_interface] = ACTIONS(3856),
    [anon_sym_exception] = ACTIONS(3856),
    [anon_sym_abstract] = ACTIONS(3856),
    [anon_sym_val] = ACTIONS(3856),
    [anon_sym_override] = ACTIONS(3856),
    [aux_sym_char_token1] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3856),
    [anon_sym_DQUOTE] = ACTIONS(3856),
    [anon_sym_AT_DQUOTE] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [sym_bool] = ACTIONS(3856),
    [sym_unit] = ACTIONS(3854),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3856),
    [sym_op_identifier] = ACTIONS(3856),
    [anon_sym_PLUS] = ACTIONS(3856),
    [anon_sym_DASH] = ACTIONS(3856),
    [anon_sym_PLUS_DOT] = ACTIONS(3856),
    [anon_sym_DASH_DOT] = ACTIONS(3856),
    [anon_sym_PERCENT] = ACTIONS(3856),
    [anon_sym_AMP_AMP] = ACTIONS(3856),
    [anon_sym_TILDE] = ACTIONS(3854),
    [aux_sym_prefix_op_token1] = ACTIONS(3856),
    [aux_sym_infix_op_token1] = ACTIONS(3854),
    [aux_sym_infix_op_token2] = ACTIONS(3856),
    [anon_sym_PIPE_PIPE] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3856),
    [anon_sym_COLON_EQ] = ACTIONS(3854),
    [anon_sym_DOLLAR] = ACTIONS(3856),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3856),
    [sym_int] = ACTIONS(3856),
    [sym_xint] = ACTIONS(3854),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3854),
    [anon_sym_POUNDload] = ACTIONS(3854),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3854),
    [sym__newline] = ACTIONS(3854),
  },
  [1321] = {
    [sym_elif_expression] = STATE(1576),
    [sym_block_comment] = STATE(1321),
    [sym_compiler_directive_decl] = STATE(1321),
    [sym_fsi_directive_decl] = STATE(1321),
    [sym_preproc_line] = STATE(1321),
    [aux_sym_if_expression_repeat1] = STATE(1321),
    [sym_identifier] = ACTIONS(3555),
    [anon_sym_EQ] = ACTIONS(3553),
    [anon_sym_LBRACK_LT] = ACTIONS(3553),
    [anon_sym_COLON] = ACTIONS(3555),
    [anon_sym_return] = ACTIONS(3555),
    [anon_sym_do] = ACTIONS(3555),
    [anon_sym_and] = ACTIONS(3555),
    [anon_sym_let] = ACTIONS(3555),
    [anon_sym_let_BANG] = ACTIONS(3553),
    [aux_sym_access_modifier_token1] = ACTIONS(3553),
    [anon_sym_LPAREN] = ACTIONS(3555),
    [anon_sym_COMMA] = ACTIONS(3553),
    [anon_sym_null] = ACTIONS(3555),
    [anon_sym_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_COLON] = ACTIONS(3553),
    [anon_sym_AMP] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(3555),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3553),
    [anon_sym_LBRACE] = ACTIONS(3555),
    [anon_sym_LT_AT] = ACTIONS(3555),
    [anon_sym_LT_AT_AT] = ACTIONS(3555),
    [anon_sym_DOT] = ACTIONS(3555),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3553),
    [anon_sym_new] = ACTIONS(3555),
    [anon_sym_with] = ACTIONS(3555),
    [anon_sym_return_BANG] = ACTIONS(3553),
    [anon_sym_yield] = ACTIONS(3555),
    [anon_sym_yield_BANG] = ACTIONS(3553),
    [anon_sym_lazy] = ACTIONS(3555),
    [anon_sym_assert] = ACTIONS(3555),
    [anon_sym_upcast] = ACTIONS(3555),
    [anon_sym_downcast] = ACTIONS(3555),
    [anon_sym_COLON_GT] = ACTIONS(3553),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3553),
    [anon_sym_for] = ACTIONS(3555),
    [anon_sym_while] = ACTIONS(3555),
    [anon_sym_else] = ACTIONS(3555),
    [anon_sym_elif] = ACTIONS(3858),
    [anon_sym_if] = ACTIONS(3555),
    [anon_sym_fun] = ACTIONS(3555),
    [anon_sym_try] = ACTIONS(3555),
    [anon_sym_match] = ACTIONS(3555),
    [anon_sym_match_BANG] = ACTIONS(3553),
    [anon_sym_function] = ACTIONS(3555),
    [anon_sym_LT_DASH] = ACTIONS(3555),
    [anon_sym_DOT_LBRACK] = ACTIONS(3553),
    [anon_sym_LT] = ACTIONS(3553),
    [anon_sym_use] = ACTIONS(3555),
    [anon_sym_use_BANG] = ACTIONS(3553),
    [anon_sym_do_BANG] = ACTIONS(3553),
    [anon_sym_begin] = ACTIONS(3555),
    [anon_sym_LPAREN2] = ACTIONS(3555),
    [anon_sym_default] = ACTIONS(3555),
    [anon_sym_or] = ACTIONS(3555),
    [anon_sym_static] = ACTIONS(3555),
    [anon_sym_member] = ACTIONS(3555),
    [anon_sym_interface] = ACTIONS(3555),
    [anon_sym_abstract] = ACTIONS(3555),
    [anon_sym_val] = ACTIONS(3555),
    [anon_sym_override] = ACTIONS(3555),
    [aux_sym_char_token1] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3555),
    [anon_sym_DQUOTE] = ACTIONS(3555),
    [anon_sym_AT_DQUOTE] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [sym_bool] = ACTIONS(3555),
    [sym_unit] = ACTIONS(3553),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3555),
    [sym_op_identifier] = ACTIONS(3555),
    [anon_sym_PLUS] = ACTIONS(3555),
    [anon_sym_DASH] = ACTIONS(3555),
    [anon_sym_PLUS_DOT] = ACTIONS(3555),
    [anon_sym_DASH_DOT] = ACTIONS(3555),
    [anon_sym_PERCENT] = ACTIONS(3555),
    [anon_sym_AMP_AMP] = ACTIONS(3555),
    [anon_sym_TILDE] = ACTIONS(3553),
    [aux_sym_prefix_op_token1] = ACTIONS(3555),
    [aux_sym_infix_op_token1] = ACTIONS(3553),
    [aux_sym_infix_op_token2] = ACTIONS(3555),
    [anon_sym_PIPE_PIPE] = ACTIONS(3555),
    [anon_sym_BANG_EQ] = ACTIONS(3555),
    [anon_sym_COLON_EQ] = ACTIONS(3553),
    [anon_sym_DOLLAR] = ACTIONS(3555),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3555),
    [sym_int] = ACTIONS(3555),
    [sym_xint] = ACTIONS(3553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3553),
    [anon_sym_POUNDendif] = ACTIONS(3553),
    [anon_sym_POUNDelse] = ACTIONS(3553),
    [sym__newline] = ACTIONS(3553),
  },
  [1322] = {
    [sym_block_comment] = STATE(1322),
    [sym_compiler_directive_decl] = STATE(1322),
    [sym_fsi_directive_decl] = STATE(1322),
    [sym_preproc_line] = STATE(1322),
    [ts_builtin_sym_end] = ACTIONS(3861),
    [sym_identifier] = ACTIONS(3863),
    [anon_sym_namespace] = ACTIONS(3863),
    [anon_sym_module] = ACTIONS(3863),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_open] = ACTIONS(3863),
    [anon_sym_LBRACK_LT] = ACTIONS(3861),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_type] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_and] = ACTIONS(3863),
    [anon_sym_let] = ACTIONS(3863),
    [anon_sym_let_BANG] = ACTIONS(3861),
    [aux_sym_access_modifier_token1] = ACTIONS(3861),
    [anon_sym_LPAREN] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3861),
    [anon_sym_null] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_COLON] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_LT_AT] = ACTIONS(3863),
    [anon_sym_LT_AT_AT] = ACTIONS(3863),
    [anon_sym_DOT] = ACTIONS(3863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3861),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_with] = ACTIONS(3863),
    [anon_sym_return_BANG] = ACTIONS(3861),
    [anon_sym_yield] = ACTIONS(3863),
    [anon_sym_yield_BANG] = ACTIONS(3861),
    [anon_sym_lazy] = ACTIONS(3863),
    [anon_sym_assert] = ACTIONS(3863),
    [anon_sym_upcast] = ACTIONS(3863),
    [anon_sym_downcast] = ACTIONS(3863),
    [anon_sym_COLON_GT] = ACTIONS(3861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_fun] = ACTIONS(3863),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_match] = ACTIONS(3863),
    [anon_sym_match_BANG] = ACTIONS(3861),
    [anon_sym_function] = ACTIONS(3863),
    [anon_sym_LT_DASH] = ACTIONS(3863),
    [anon_sym_DOT_LBRACK] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_use] = ACTIONS(3863),
    [anon_sym_use_BANG] = ACTIONS(3861),
    [anon_sym_do_BANG] = ACTIONS(3861),
    [anon_sym_begin] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(3863),
    [anon_sym_default] = ACTIONS(3863),
    [anon_sym_or] = ACTIONS(3863),
    [anon_sym_static] = ACTIONS(3863),
    [anon_sym_member] = ACTIONS(3863),
    [anon_sym_interface] = ACTIONS(3863),
    [anon_sym_exception] = ACTIONS(3863),
    [anon_sym_abstract] = ACTIONS(3863),
    [anon_sym_val] = ACTIONS(3863),
    [anon_sym_override] = ACTIONS(3863),
    [aux_sym_char_token1] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [anon_sym_AT_DQUOTE] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [sym_bool] = ACTIONS(3863),
    [sym_unit] = ACTIONS(3861),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3863),
    [sym_op_identifier] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_DOT] = ACTIONS(3863),
    [anon_sym_DASH_DOT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3861),
    [aux_sym_prefix_op_token1] = ACTIONS(3863),
    [aux_sym_infix_op_token1] = ACTIONS(3861),
    [aux_sym_infix_op_token2] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_COLON_EQ] = ACTIONS(3861),
    [anon_sym_DOLLAR] = ACTIONS(3863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3863),
    [sym_int] = ACTIONS(3863),
    [sym_xint] = ACTIONS(3861),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3861),
    [anon_sym_POUNDload] = ACTIONS(3861),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3861),
    [sym__newline] = ACTIONS(3861),
  },
  [1323] = {
    [sym_block_comment] = STATE(1323),
    [sym_compiler_directive_decl] = STATE(1323),
    [sym_fsi_directive_decl] = STATE(1323),
    [sym_preproc_line] = STATE(1323),
    [ts_builtin_sym_end] = ACTIONS(3865),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_namespace] = ACTIONS(3867),
    [anon_sym_module] = ACTIONS(3867),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_open] = ACTIONS(3867),
    [anon_sym_LBRACK_LT] = ACTIONS(3865),
    [anon_sym_COLON] = ACTIONS(3867),
    [anon_sym_return] = ACTIONS(3867),
    [anon_sym_type] = ACTIONS(3867),
    [anon_sym_do] = ACTIONS(3867),
    [anon_sym_and] = ACTIONS(3867),
    [anon_sym_let] = ACTIONS(3867),
    [anon_sym_let_BANG] = ACTIONS(3865),
    [aux_sym_access_modifier_token1] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(3867),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_null] = ACTIONS(3867),
    [anon_sym_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_COLON] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3867),
    [anon_sym_LBRACK] = ACTIONS(3867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3867),
    [anon_sym_LT_AT] = ACTIONS(3867),
    [anon_sym_LT_AT_AT] = ACTIONS(3867),
    [anon_sym_DOT] = ACTIONS(3867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3867),
    [anon_sym_with] = ACTIONS(3867),
    [anon_sym_return_BANG] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3867),
    [anon_sym_yield_BANG] = ACTIONS(3865),
    [anon_sym_lazy] = ACTIONS(3867),
    [anon_sym_assert] = ACTIONS(3867),
    [anon_sym_upcast] = ACTIONS(3867),
    [anon_sym_downcast] = ACTIONS(3867),
    [anon_sym_COLON_GT] = ACTIONS(3865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3867),
    [anon_sym_while] = ACTIONS(3867),
    [anon_sym_if] = ACTIONS(3867),
    [anon_sym_fun] = ACTIONS(3867),
    [anon_sym_try] = ACTIONS(3867),
    [anon_sym_match] = ACTIONS(3867),
    [anon_sym_match_BANG] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(3867),
    [anon_sym_DOT_LBRACK] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_use] = ACTIONS(3867),
    [anon_sym_use_BANG] = ACTIONS(3865),
    [anon_sym_do_BANG] = ACTIONS(3865),
    [anon_sym_begin] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(3867),
    [anon_sym_default] = ACTIONS(3867),
    [anon_sym_or] = ACTIONS(3867),
    [anon_sym_static] = ACTIONS(3867),
    [anon_sym_member] = ACTIONS(3867),
    [anon_sym_interface] = ACTIONS(3867),
    [anon_sym_exception] = ACTIONS(3867),
    [anon_sym_abstract] = ACTIONS(3867),
    [anon_sym_val] = ACTIONS(3867),
    [anon_sym_override] = ACTIONS(3867),
    [aux_sym_char_token1] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3867),
    [anon_sym_DQUOTE] = ACTIONS(3867),
    [anon_sym_AT_DQUOTE] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [sym_bool] = ACTIONS(3867),
    [sym_unit] = ACTIONS(3865),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3867),
    [sym_op_identifier] = ACTIONS(3867),
    [anon_sym_PLUS] = ACTIONS(3867),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_PLUS_DOT] = ACTIONS(3867),
    [anon_sym_DASH_DOT] = ACTIONS(3867),
    [anon_sym_PERCENT] = ACTIONS(3867),
    [anon_sym_AMP_AMP] = ACTIONS(3867),
    [anon_sym_TILDE] = ACTIONS(3865),
    [aux_sym_prefix_op_token1] = ACTIONS(3867),
    [aux_sym_infix_op_token1] = ACTIONS(3865),
    [aux_sym_infix_op_token2] = ACTIONS(3867),
    [anon_sym_PIPE_PIPE] = ACTIONS(3867),
    [anon_sym_BANG_EQ] = ACTIONS(3867),
    [anon_sym_COLON_EQ] = ACTIONS(3865),
    [anon_sym_DOLLAR] = ACTIONS(3867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3867),
    [sym_int] = ACTIONS(3867),
    [sym_xint] = ACTIONS(3865),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3865),
    [anon_sym_POUNDload] = ACTIONS(3865),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3865),
    [sym__newline] = ACTIONS(3865),
  },
  [1324] = {
    [sym__else_expression] = STATE(2126),
    [sym_elif_expression] = STATE(1675),
    [sym_block_comment] = STATE(1324),
    [sym_compiler_directive_decl] = STATE(1324),
    [sym_fsi_directive_decl] = STATE(1324),
    [sym_preproc_line] = STATE(1324),
    [aux_sym_if_expression_repeat1] = STATE(1470),
    [sym_identifier] = ACTIONS(3472),
    [anon_sym_EQ] = ACTIONS(3470),
    [anon_sym_LBRACK_LT] = ACTIONS(3470),
    [anon_sym_COLON] = ACTIONS(3472),
    [anon_sym_return] = ACTIONS(3472),
    [anon_sym_do] = ACTIONS(3472),
    [anon_sym_let] = ACTIONS(3472),
    [anon_sym_let_BANG] = ACTIONS(3470),
    [aux_sym_access_modifier_token1] = ACTIONS(3470),
    [anon_sym_LPAREN] = ACTIONS(3472),
    [anon_sym_COMMA] = ACTIONS(3470),
    [anon_sym_null] = ACTIONS(3472),
    [anon_sym_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_COLON] = ACTIONS(3470),
    [anon_sym_AMP] = ACTIONS(3472),
    [anon_sym_LBRACK] = ACTIONS(3472),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3470),
    [anon_sym_LBRACE] = ACTIONS(3472),
    [anon_sym_LT_AT] = ACTIONS(3472),
    [anon_sym_LT_AT_AT] = ACTIONS(3472),
    [anon_sym_DOT] = ACTIONS(3472),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3470),
    [anon_sym_new] = ACTIONS(3472),
    [anon_sym_with] = ACTIONS(3472),
    [anon_sym_return_BANG] = ACTIONS(3470),
    [anon_sym_yield] = ACTIONS(3472),
    [anon_sym_yield_BANG] = ACTIONS(3470),
    [anon_sym_lazy] = ACTIONS(3472),
    [anon_sym_assert] = ACTIONS(3472),
    [anon_sym_upcast] = ACTIONS(3472),
    [anon_sym_downcast] = ACTIONS(3472),
    [anon_sym_COLON_GT] = ACTIONS(3470),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3470),
    [anon_sym_for] = ACTIONS(3472),
    [anon_sym_while] = ACTIONS(3472),
    [anon_sym_else] = ACTIONS(3869),
    [anon_sym_elif] = ACTIONS(3871),
    [anon_sym_if] = ACTIONS(3472),
    [anon_sym_fun] = ACTIONS(3472),
    [anon_sym_try] = ACTIONS(3472),
    [anon_sym_match] = ACTIONS(3472),
    [anon_sym_match_BANG] = ACTIONS(3470),
    [anon_sym_function] = ACTIONS(3472),
    [anon_sym_LT_DASH] = ACTIONS(3472),
    [anon_sym_DOT_LBRACK] = ACTIONS(3470),
    [anon_sym_LT] = ACTIONS(3470),
    [anon_sym_use] = ACTIONS(3472),
    [anon_sym_use_BANG] = ACTIONS(3470),
    [anon_sym_do_BANG] = ACTIONS(3470),
    [anon_sym_begin] = ACTIONS(3472),
    [anon_sym_LPAREN2] = ACTIONS(3472),
    [anon_sym_default] = ACTIONS(3472),
    [anon_sym_or] = ACTIONS(3472),
    [anon_sym_static] = ACTIONS(3472),
    [anon_sym_member] = ACTIONS(3472),
    [anon_sym_interface] = ACTIONS(3472),
    [anon_sym_abstract] = ACTIONS(3472),
    [anon_sym_val] = ACTIONS(3472),
    [anon_sym_override] = ACTIONS(3472),
    [anon_sym_inherit] = ACTIONS(3472),
    [aux_sym_char_token1] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3472),
    [anon_sym_DQUOTE] = ACTIONS(3472),
    [anon_sym_AT_DQUOTE] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [sym_bool] = ACTIONS(3472),
    [sym_unit] = ACTIONS(3470),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3472),
    [sym_op_identifier] = ACTIONS(3472),
    [anon_sym_PLUS] = ACTIONS(3472),
    [anon_sym_DASH] = ACTIONS(3472),
    [anon_sym_PLUS_DOT] = ACTIONS(3472),
    [anon_sym_DASH_DOT] = ACTIONS(3472),
    [anon_sym_PERCENT] = ACTIONS(3472),
    [anon_sym_AMP_AMP] = ACTIONS(3472),
    [anon_sym_TILDE] = ACTIONS(3470),
    [aux_sym_prefix_op_token1] = ACTIONS(3472),
    [aux_sym_infix_op_token1] = ACTIONS(3470),
    [aux_sym_infix_op_token2] = ACTIONS(3472),
    [anon_sym_PIPE_PIPE] = ACTIONS(3472),
    [anon_sym_BANG_EQ] = ACTIONS(3472),
    [anon_sym_COLON_EQ] = ACTIONS(3470),
    [anon_sym_DOLLAR] = ACTIONS(3472),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3472),
    [sym_int] = ACTIONS(3472),
    [sym_xint] = ACTIONS(3470),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3470),
    [anon_sym_POUNDendif] = ACTIONS(3470),
    [sym__newline] = ACTIONS(3470),
  },
  [1325] = {
    [sym_block_comment] = STATE(1325),
    [sym_compiler_directive_decl] = STATE(1325),
    [sym_fsi_directive_decl] = STATE(1325),
    [sym_preproc_line] = STATE(1325),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_EQ] = ACTIONS(3560),
    [anon_sym_LBRACK_LT] = ACTIONS(3560),
    [anon_sym_COLON] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_let_BANG] = ACTIONS(3560),
    [aux_sym_access_modifier_token1] = ACTIONS(3560),
    [anon_sym_LPAREN] = ACTIONS(3562),
    [anon_sym_COMMA] = ACTIONS(3560),
    [anon_sym_null] = ACTIONS(3562),
    [anon_sym_QMARK] = ACTIONS(3562),
    [anon_sym_COLON_QMARK] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3560),
    [anon_sym_LBRACE] = ACTIONS(3562),
    [anon_sym_LT_AT] = ACTIONS(3562),
    [anon_sym_LT_AT_AT] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(3562),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3560),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_with] = ACTIONS(3562),
    [anon_sym_return_BANG] = ACTIONS(3560),
    [anon_sym_yield] = ACTIONS(3562),
    [anon_sym_yield_BANG] = ACTIONS(3560),
    [anon_sym_lazy] = ACTIONS(3562),
    [anon_sym_assert] = ACTIONS(3562),
    [anon_sym_upcast] = ACTIONS(3562),
    [anon_sym_downcast] = ACTIONS(3562),
    [anon_sym_COLON_GT] = ACTIONS(3560),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3560),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_fun] = ACTIONS(3562),
    [anon_sym_DASH_GT] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_match] = ACTIONS(3562),
    [anon_sym_match_BANG] = ACTIONS(3560),
    [anon_sym_function] = ACTIONS(3562),
    [anon_sym_LT_DASH] = ACTIONS(3562),
    [anon_sym_DOT_LBRACK] = ACTIONS(3560),
    [anon_sym_LT] = ACTIONS(3560),
    [anon_sym_use] = ACTIONS(3562),
    [anon_sym_use_BANG] = ACTIONS(3560),
    [anon_sym_do_BANG] = ACTIONS(3560),
    [anon_sym_begin] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3562),
    [anon_sym_LT2] = ACTIONS(3562),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3560),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_or] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_member] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_abstract] = ACTIONS(3562),
    [anon_sym_val] = ACTIONS(3562),
    [anon_sym_override] = ACTIONS(3562),
    [anon_sym_inherit] = ACTIONS(3562),
    [aux_sym_char_token1] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(3562),
    [anon_sym_AT_DQUOTE] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [sym_bool] = ACTIONS(3562),
    [sym_unit] = ACTIONS(3560),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3562),
    [sym_op_identifier] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS_DOT] = ACTIONS(3562),
    [anon_sym_DASH_DOT] = ACTIONS(3562),
    [anon_sym_PERCENT] = ACTIONS(3562),
    [anon_sym_AMP_AMP] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3560),
    [aux_sym_prefix_op_token1] = ACTIONS(3562),
    [aux_sym_infix_op_token1] = ACTIONS(3560),
    [aux_sym_infix_op_token2] = ACTIONS(3562),
    [anon_sym_PIPE_PIPE] = ACTIONS(3562),
    [anon_sym_BANG_EQ] = ACTIONS(3562),
    [anon_sym_COLON_EQ] = ACTIONS(3560),
    [anon_sym_DOLLAR] = ACTIONS(3562),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3562),
    [sym_int] = ACTIONS(3562),
    [sym_xint] = ACTIONS(3560),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3560),
    [anon_sym_POUNDendif] = ACTIONS(3560),
    [anon_sym_POUNDelse] = ACTIONS(3560),
    [sym__newline] = ACTIONS(3560),
  },
  [1326] = {
    [sym_block_comment] = STATE(1326),
    [sym_compiler_directive_decl] = STATE(1326),
    [sym_fsi_directive_decl] = STATE(1326),
    [sym_preproc_line] = STATE(1326),
    [sym_identifier] = ACTIONS(3551),
    [anon_sym_EQ] = ACTIONS(3549),
    [anon_sym_LBRACK_LT] = ACTIONS(3549),
    [anon_sym_COLON] = ACTIONS(3551),
    [anon_sym_return] = ACTIONS(3551),
    [anon_sym_do] = ACTIONS(3551),
    [anon_sym_let] = ACTIONS(3551),
    [anon_sym_let_BANG] = ACTIONS(3549),
    [aux_sym_access_modifier_token1] = ACTIONS(3549),
    [anon_sym_LPAREN] = ACTIONS(3551),
    [anon_sym_COMMA] = ACTIONS(3549),
    [anon_sym_null] = ACTIONS(3551),
    [anon_sym_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_COLON] = ACTIONS(3549),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(3551),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3549),
    [anon_sym_LBRACE] = ACTIONS(3551),
    [anon_sym_LT_AT] = ACTIONS(3551),
    [anon_sym_LT_AT_AT] = ACTIONS(3551),
    [anon_sym_DOT] = ACTIONS(3551),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3549),
    [anon_sym_new] = ACTIONS(3551),
    [anon_sym_with] = ACTIONS(3551),
    [anon_sym_return_BANG] = ACTIONS(3549),
    [anon_sym_yield] = ACTIONS(3551),
    [anon_sym_yield_BANG] = ACTIONS(3549),
    [anon_sym_lazy] = ACTIONS(3551),
    [anon_sym_assert] = ACTIONS(3551),
    [anon_sym_upcast] = ACTIONS(3551),
    [anon_sym_downcast] = ACTIONS(3551),
    [anon_sym_COLON_GT] = ACTIONS(3549),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3549),
    [anon_sym_for] = ACTIONS(3551),
    [anon_sym_while] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(3551),
    [anon_sym_fun] = ACTIONS(3551),
    [anon_sym_DASH_GT] = ACTIONS(3551),
    [anon_sym_try] = ACTIONS(3551),
    [anon_sym_match] = ACTIONS(3551),
    [anon_sym_match_BANG] = ACTIONS(3549),
    [anon_sym_function] = ACTIONS(3551),
    [anon_sym_LT_DASH] = ACTIONS(3551),
    [anon_sym_DOT_LBRACK] = ACTIONS(3549),
    [anon_sym_LT] = ACTIONS(3549),
    [anon_sym_use] = ACTIONS(3551),
    [anon_sym_use_BANG] = ACTIONS(3549),
    [anon_sym_do_BANG] = ACTIONS(3549),
    [anon_sym_begin] = ACTIONS(3551),
    [anon_sym_LPAREN2] = ACTIONS(3551),
    [anon_sym_STAR] = ACTIONS(3551),
    [anon_sym_LT2] = ACTIONS(3551),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3549),
    [anon_sym_default] = ACTIONS(3551),
    [anon_sym_or] = ACTIONS(3551),
    [anon_sym_static] = ACTIONS(3551),
    [anon_sym_member] = ACTIONS(3551),
    [anon_sym_interface] = ACTIONS(3551),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_val] = ACTIONS(3551),
    [anon_sym_override] = ACTIONS(3551),
    [anon_sym_inherit] = ACTIONS(3551),
    [aux_sym_char_token1] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [anon_sym_AT_DQUOTE] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [sym_bool] = ACTIONS(3551),
    [sym_unit] = ACTIONS(3549),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3551),
    [sym_op_identifier] = ACTIONS(3551),
    [anon_sym_PLUS] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(3551),
    [anon_sym_PLUS_DOT] = ACTIONS(3551),
    [anon_sym_DASH_DOT] = ACTIONS(3551),
    [anon_sym_PERCENT] = ACTIONS(3551),
    [anon_sym_AMP_AMP] = ACTIONS(3551),
    [anon_sym_TILDE] = ACTIONS(3549),
    [aux_sym_prefix_op_token1] = ACTIONS(3551),
    [aux_sym_infix_op_token1] = ACTIONS(3549),
    [aux_sym_infix_op_token2] = ACTIONS(3551),
    [anon_sym_PIPE_PIPE] = ACTIONS(3551),
    [anon_sym_BANG_EQ] = ACTIONS(3551),
    [anon_sym_COLON_EQ] = ACTIONS(3549),
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3551),
    [sym_int] = ACTIONS(3551),
    [sym_xint] = ACTIONS(3549),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3549),
    [anon_sym_POUNDendif] = ACTIONS(3549),
    [anon_sym_POUNDelse] = ACTIONS(3549),
    [sym__newline] = ACTIONS(3549),
  },
  [1327] = {
    [sym_block_comment] = STATE(1327),
    [sym_compiler_directive_decl] = STATE(1327),
    [sym_fsi_directive_decl] = STATE(1327),
    [sym_preproc_line] = STATE(1327),
    [ts_builtin_sym_end] = ACTIONS(3873),
    [sym_identifier] = ACTIONS(3875),
    [anon_sym_namespace] = ACTIONS(3875),
    [anon_sym_module] = ACTIONS(3875),
    [anon_sym_EQ] = ACTIONS(3873),
    [anon_sym_open] = ACTIONS(3875),
    [anon_sym_LBRACK_LT] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(3875),
    [anon_sym_return] = ACTIONS(3875),
    [anon_sym_type] = ACTIONS(3875),
    [anon_sym_do] = ACTIONS(3875),
    [anon_sym_and] = ACTIONS(3875),
    [anon_sym_let] = ACTIONS(3875),
    [anon_sym_let_BANG] = ACTIONS(3873),
    [aux_sym_access_modifier_token1] = ACTIONS(3873),
    [anon_sym_LPAREN] = ACTIONS(3875),
    [anon_sym_COMMA] = ACTIONS(3873),
    [anon_sym_null] = ACTIONS(3875),
    [anon_sym_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_COLON] = ACTIONS(3873),
    [anon_sym_AMP] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(3875),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3873),
    [anon_sym_LBRACE] = ACTIONS(3875),
    [anon_sym_LT_AT] = ACTIONS(3875),
    [anon_sym_LT_AT_AT] = ACTIONS(3875),
    [anon_sym_DOT] = ACTIONS(3875),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3873),
    [anon_sym_new] = ACTIONS(3875),
    [anon_sym_with] = ACTIONS(3875),
    [anon_sym_return_BANG] = ACTIONS(3873),
    [anon_sym_yield] = ACTIONS(3875),
    [anon_sym_yield_BANG] = ACTIONS(3873),
    [anon_sym_lazy] = ACTIONS(3875),
    [anon_sym_assert] = ACTIONS(3875),
    [anon_sym_upcast] = ACTIONS(3875),
    [anon_sym_downcast] = ACTIONS(3875),
    [anon_sym_COLON_GT] = ACTIONS(3873),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3873),
    [anon_sym_for] = ACTIONS(3875),
    [anon_sym_while] = ACTIONS(3875),
    [anon_sym_if] = ACTIONS(3875),
    [anon_sym_fun] = ACTIONS(3875),
    [anon_sym_try] = ACTIONS(3875),
    [anon_sym_match] = ACTIONS(3875),
    [anon_sym_match_BANG] = ACTIONS(3873),
    [anon_sym_function] = ACTIONS(3875),
    [anon_sym_LT_DASH] = ACTIONS(3875),
    [anon_sym_DOT_LBRACK] = ACTIONS(3873),
    [anon_sym_LT] = ACTIONS(3873),
    [anon_sym_use] = ACTIONS(3875),
    [anon_sym_use_BANG] = ACTIONS(3873),
    [anon_sym_do_BANG] = ACTIONS(3873),
    [anon_sym_begin] = ACTIONS(3875),
    [anon_sym_LPAREN2] = ACTIONS(3875),
    [anon_sym_default] = ACTIONS(3875),
    [anon_sym_or] = ACTIONS(3875),
    [anon_sym_static] = ACTIONS(3875),
    [anon_sym_member] = ACTIONS(3875),
    [anon_sym_interface] = ACTIONS(3875),
    [anon_sym_exception] = ACTIONS(3875),
    [anon_sym_abstract] = ACTIONS(3875),
    [anon_sym_val] = ACTIONS(3875),
    [anon_sym_override] = ACTIONS(3875),
    [aux_sym_char_token1] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3875),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [anon_sym_AT_DQUOTE] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [sym_bool] = ACTIONS(3875),
    [sym_unit] = ACTIONS(3873),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3875),
    [sym_op_identifier] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS_DOT] = ACTIONS(3875),
    [anon_sym_DASH_DOT] = ACTIONS(3875),
    [anon_sym_PERCENT] = ACTIONS(3875),
    [anon_sym_AMP_AMP] = ACTIONS(3875),
    [anon_sym_TILDE] = ACTIONS(3873),
    [aux_sym_prefix_op_token1] = ACTIONS(3875),
    [aux_sym_infix_op_token1] = ACTIONS(3873),
    [aux_sym_infix_op_token2] = ACTIONS(3875),
    [anon_sym_PIPE_PIPE] = ACTIONS(3875),
    [anon_sym_BANG_EQ] = ACTIONS(3875),
    [anon_sym_COLON_EQ] = ACTIONS(3873),
    [anon_sym_DOLLAR] = ACTIONS(3875),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3875),
    [sym_int] = ACTIONS(3875),
    [sym_xint] = ACTIONS(3873),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3873),
    [anon_sym_POUNDload] = ACTIONS(3873),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3873),
    [sym__newline] = ACTIONS(3873),
  },
  [1328] = {
    [sym_block_comment] = STATE(1328),
    [sym_compiler_directive_decl] = STATE(1328),
    [sym_fsi_directive_decl] = STATE(1328),
    [sym_preproc_line] = STATE(1328),
    [aux_sym_long_identifier_repeat1] = STATE(1428),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_LBRACK_LT] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [aux_sym_access_modifier_token1] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(3877),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_DASH_GT] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_DOT_DOT2] = ACTIONS(3449),
    [anon_sym_STAR] = ACTIONS(3451),
    [anon_sym_LT2] = ACTIONS(3451),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3449),
    [anon_sym_default] = ACTIONS(3451),
    [anon_sym_or] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_member] = ACTIONS(3451),
    [anon_sym_interface] = ACTIONS(3451),
    [anon_sym_abstract] = ACTIONS(3451),
    [anon_sym_val] = ACTIONS(3451),
    [anon_sym_override] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
    [sym__dedent] = ACTIONS(3449),
  },
  [1329] = {
    [sym_block_comment] = STATE(1329),
    [sym_compiler_directive_decl] = STATE(1329),
    [sym_fsi_directive_decl] = STATE(1329),
    [sym_preproc_line] = STATE(1329),
    [ts_builtin_sym_end] = ACTIONS(3879),
    [sym_identifier] = ACTIONS(3881),
    [anon_sym_namespace] = ACTIONS(3881),
    [anon_sym_module] = ACTIONS(3881),
    [anon_sym_EQ] = ACTIONS(3879),
    [anon_sym_open] = ACTIONS(3881),
    [anon_sym_LBRACK_LT] = ACTIONS(3879),
    [anon_sym_COLON] = ACTIONS(3881),
    [anon_sym_return] = ACTIONS(3881),
    [anon_sym_type] = ACTIONS(3881),
    [anon_sym_do] = ACTIONS(3881),
    [anon_sym_and] = ACTIONS(3881),
    [anon_sym_let] = ACTIONS(3881),
    [anon_sym_let_BANG] = ACTIONS(3879),
    [aux_sym_access_modifier_token1] = ACTIONS(3879),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3879),
    [anon_sym_null] = ACTIONS(3881),
    [anon_sym_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3879),
    [anon_sym_LBRACE] = ACTIONS(3881),
    [anon_sym_LT_AT] = ACTIONS(3881),
    [anon_sym_LT_AT_AT] = ACTIONS(3881),
    [anon_sym_DOT] = ACTIONS(3881),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3879),
    [anon_sym_new] = ACTIONS(3881),
    [anon_sym_with] = ACTIONS(3881),
    [anon_sym_return_BANG] = ACTIONS(3879),
    [anon_sym_yield] = ACTIONS(3881),
    [anon_sym_yield_BANG] = ACTIONS(3879),
    [anon_sym_lazy] = ACTIONS(3881),
    [anon_sym_assert] = ACTIONS(3881),
    [anon_sym_upcast] = ACTIONS(3881),
    [anon_sym_downcast] = ACTIONS(3881),
    [anon_sym_COLON_GT] = ACTIONS(3879),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3879),
    [anon_sym_for] = ACTIONS(3881),
    [anon_sym_while] = ACTIONS(3881),
    [anon_sym_if] = ACTIONS(3881),
    [anon_sym_fun] = ACTIONS(3881),
    [anon_sym_try] = ACTIONS(3881),
    [anon_sym_match] = ACTIONS(3881),
    [anon_sym_match_BANG] = ACTIONS(3879),
    [anon_sym_function] = ACTIONS(3881),
    [anon_sym_LT_DASH] = ACTIONS(3881),
    [anon_sym_DOT_LBRACK] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_use] = ACTIONS(3881),
    [anon_sym_use_BANG] = ACTIONS(3879),
    [anon_sym_do_BANG] = ACTIONS(3879),
    [anon_sym_begin] = ACTIONS(3881),
    [anon_sym_LPAREN2] = ACTIONS(3881),
    [anon_sym_default] = ACTIONS(3881),
    [anon_sym_or] = ACTIONS(3881),
    [anon_sym_static] = ACTIONS(3881),
    [anon_sym_member] = ACTIONS(3881),
    [anon_sym_interface] = ACTIONS(3881),
    [anon_sym_exception] = ACTIONS(3881),
    [anon_sym_abstract] = ACTIONS(3881),
    [anon_sym_val] = ACTIONS(3881),
    [anon_sym_override] = ACTIONS(3881),
    [aux_sym_char_token1] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3881),
    [anon_sym_DQUOTE] = ACTIONS(3881),
    [anon_sym_AT_DQUOTE] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [sym_bool] = ACTIONS(3881),
    [sym_unit] = ACTIONS(3879),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3881),
    [sym_op_identifier] = ACTIONS(3881),
    [anon_sym_PLUS] = ACTIONS(3881),
    [anon_sym_DASH] = ACTIONS(3881),
    [anon_sym_PLUS_DOT] = ACTIONS(3881),
    [anon_sym_DASH_DOT] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(3881),
    [anon_sym_AMP_AMP] = ACTIONS(3881),
    [anon_sym_TILDE] = ACTIONS(3879),
    [aux_sym_prefix_op_token1] = ACTIONS(3881),
    [aux_sym_infix_op_token1] = ACTIONS(3879),
    [aux_sym_infix_op_token2] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE] = ACTIONS(3881),
    [anon_sym_BANG_EQ] = ACTIONS(3881),
    [anon_sym_COLON_EQ] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3881),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3881),
    [sym_int] = ACTIONS(3881),
    [sym_xint] = ACTIONS(3879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3879),
    [anon_sym_POUNDload] = ACTIONS(3879),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3879),
    [sym__newline] = ACTIONS(3879),
  },
  [1330] = {
    [sym_block_comment] = STATE(1330),
    [sym_compiler_directive_decl] = STATE(1330),
    [sym_fsi_directive_decl] = STATE(1330),
    [sym_preproc_line] = STATE(1330),
    [sym_identifier] = ACTIONS(3535),
    [anon_sym_EQ] = ACTIONS(3533),
    [anon_sym_LBRACK_LT] = ACTIONS(3533),
    [anon_sym_COLON] = ACTIONS(3535),
    [anon_sym_return] = ACTIONS(3535),
    [anon_sym_do] = ACTIONS(3535),
    [anon_sym_let] = ACTIONS(3535),
    [anon_sym_let_BANG] = ACTIONS(3533),
    [aux_sym_access_modifier_token1] = ACTIONS(3533),
    [anon_sym_LPAREN] = ACTIONS(3535),
    [anon_sym_COMMA] = ACTIONS(3533),
    [anon_sym_null] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(3535),
    [anon_sym_COLON_QMARK] = ACTIONS(3535),
    [anon_sym_COLON_COLON] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3533),
    [anon_sym_LBRACE] = ACTIONS(3535),
    [anon_sym_LT_AT] = ACTIONS(3535),
    [anon_sym_LT_AT_AT] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(3535),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3533),
    [anon_sym_new] = ACTIONS(3535),
    [anon_sym_with] = ACTIONS(3535),
    [anon_sym_return_BANG] = ACTIONS(3533),
    [anon_sym_yield] = ACTIONS(3535),
    [anon_sym_yield_BANG] = ACTIONS(3533),
    [anon_sym_lazy] = ACTIONS(3535),
    [anon_sym_assert] = ACTIONS(3535),
    [anon_sym_upcast] = ACTIONS(3535),
    [anon_sym_downcast] = ACTIONS(3535),
    [anon_sym_COLON_GT] = ACTIONS(3533),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3533),
    [anon_sym_for] = ACTIONS(3535),
    [anon_sym_while] = ACTIONS(3535),
    [anon_sym_if] = ACTIONS(3535),
    [anon_sym_fun] = ACTIONS(3535),
    [anon_sym_DASH_GT] = ACTIONS(3535),
    [anon_sym_try] = ACTIONS(3535),
    [anon_sym_match] = ACTIONS(3535),
    [anon_sym_match_BANG] = ACTIONS(3533),
    [anon_sym_function] = ACTIONS(3535),
    [anon_sym_LT_DASH] = ACTIONS(3535),
    [anon_sym_DOT_LBRACK] = ACTIONS(3533),
    [anon_sym_LT] = ACTIONS(3533),
    [anon_sym_use] = ACTIONS(3535),
    [anon_sym_use_BANG] = ACTIONS(3533),
    [anon_sym_do_BANG] = ACTIONS(3533),
    [anon_sym_begin] = ACTIONS(3535),
    [anon_sym_LPAREN2] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(3535),
    [anon_sym_LT2] = ACTIONS(3535),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3533),
    [anon_sym_default] = ACTIONS(3535),
    [anon_sym_or] = ACTIONS(3535),
    [anon_sym_static] = ACTIONS(3535),
    [anon_sym_member] = ACTIONS(3535),
    [anon_sym_interface] = ACTIONS(3535),
    [anon_sym_abstract] = ACTIONS(3535),
    [anon_sym_val] = ACTIONS(3535),
    [anon_sym_override] = ACTIONS(3535),
    [anon_sym_inherit] = ACTIONS(3535),
    [aux_sym_char_token1] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE] = ACTIONS(3535),
    [anon_sym_AT_DQUOTE] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [sym_bool] = ACTIONS(3535),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3535),
    [sym_op_identifier] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS_DOT] = ACTIONS(3535),
    [anon_sym_DASH_DOT] = ACTIONS(3535),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(3535),
    [anon_sym_TILDE] = ACTIONS(3533),
    [aux_sym_prefix_op_token1] = ACTIONS(3535),
    [aux_sym_infix_op_token1] = ACTIONS(3533),
    [aux_sym_infix_op_token2] = ACTIONS(3535),
    [anon_sym_PIPE_PIPE] = ACTIONS(3535),
    [anon_sym_BANG_EQ] = ACTIONS(3535),
    [anon_sym_COLON_EQ] = ACTIONS(3533),
    [anon_sym_DOLLAR] = ACTIONS(3535),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3535),
    [sym_int] = ACTIONS(3535),
    [sym_xint] = ACTIONS(3533),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3533),
    [anon_sym_POUNDendif] = ACTIONS(3533),
    [anon_sym_POUNDelse] = ACTIONS(3533),
    [sym__newline] = ACTIONS(3533),
  },
  [1331] = {
    [sym_block_comment] = STATE(1331),
    [sym_compiler_directive_decl] = STATE(1331),
    [sym_fsi_directive_decl] = STATE(1331),
    [sym_preproc_line] = STATE(1331),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_LBRACK_LT] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [aux_sym_access_modifier_token1] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_COLON] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_with] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_LT_DASH] = ACTIONS(3480),
    [anon_sym_DOT_LBRACK] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_default] = ACTIONS(3480),
    [anon_sym_or] = ACTIONS(3480),
    [anon_sym_static] = ACTIONS(3480),
    [anon_sym_member] = ACTIONS(3480),
    [anon_sym_interface] = ACTIONS(3480),
    [anon_sym_abstract] = ACTIONS(3480),
    [anon_sym_val] = ACTIONS(3480),
    [anon_sym_override] = ACTIONS(3480),
    [anon_sym_inherit] = ACTIONS(3480),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3480),
    [anon_sym_DASH_DOT] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3480),
    [aux_sym_infix_op_token1] = ACTIONS(3478),
    [aux_sym_infix_op_token2] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3480),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [anon_sym_POUNDendif] = ACTIONS(3478),
    [anon_sym_POUNDelse] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
  },
  [1332] = {
    [sym_block_comment] = STATE(1332),
    [sym_compiler_directive_decl] = STATE(1332),
    [sym_fsi_directive_decl] = STATE(1332),
    [sym_preproc_line] = STATE(1332),
    [ts_builtin_sym_end] = ACTIONS(3883),
    [sym_identifier] = ACTIONS(3885),
    [anon_sym_namespace] = ACTIONS(3885),
    [anon_sym_module] = ACTIONS(3885),
    [anon_sym_EQ] = ACTIONS(3883),
    [anon_sym_open] = ACTIONS(3885),
    [anon_sym_LBRACK_LT] = ACTIONS(3883),
    [anon_sym_COLON] = ACTIONS(3885),
    [anon_sym_return] = ACTIONS(3885),
    [anon_sym_type] = ACTIONS(3885),
    [anon_sym_do] = ACTIONS(3885),
    [anon_sym_and] = ACTIONS(3885),
    [anon_sym_let] = ACTIONS(3885),
    [anon_sym_let_BANG] = ACTIONS(3883),
    [aux_sym_access_modifier_token1] = ACTIONS(3883),
    [anon_sym_LPAREN] = ACTIONS(3885),
    [anon_sym_COMMA] = ACTIONS(3883),
    [anon_sym_null] = ACTIONS(3885),
    [anon_sym_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3883),
    [anon_sym_AMP] = ACTIONS(3885),
    [anon_sym_LBRACK] = ACTIONS(3885),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3883),
    [anon_sym_LBRACE] = ACTIONS(3885),
    [anon_sym_LT_AT] = ACTIONS(3885),
    [anon_sym_LT_AT_AT] = ACTIONS(3885),
    [anon_sym_DOT] = ACTIONS(3885),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3883),
    [anon_sym_new] = ACTIONS(3885),
    [anon_sym_with] = ACTIONS(3885),
    [anon_sym_return_BANG] = ACTIONS(3883),
    [anon_sym_yield] = ACTIONS(3885),
    [anon_sym_yield_BANG] = ACTIONS(3883),
    [anon_sym_lazy] = ACTIONS(3885),
    [anon_sym_assert] = ACTIONS(3885),
    [anon_sym_upcast] = ACTIONS(3885),
    [anon_sym_downcast] = ACTIONS(3885),
    [anon_sym_COLON_GT] = ACTIONS(3883),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3883),
    [anon_sym_for] = ACTIONS(3885),
    [anon_sym_while] = ACTIONS(3885),
    [anon_sym_if] = ACTIONS(3885),
    [anon_sym_fun] = ACTIONS(3885),
    [anon_sym_try] = ACTIONS(3885),
    [anon_sym_match] = ACTIONS(3885),
    [anon_sym_match_BANG] = ACTIONS(3883),
    [anon_sym_function] = ACTIONS(3885),
    [anon_sym_LT_DASH] = ACTIONS(3885),
    [anon_sym_DOT_LBRACK] = ACTIONS(3883),
    [anon_sym_LT] = ACTIONS(3883),
    [anon_sym_use] = ACTIONS(3885),
    [anon_sym_use_BANG] = ACTIONS(3883),
    [anon_sym_do_BANG] = ACTIONS(3883),
    [anon_sym_begin] = ACTIONS(3885),
    [anon_sym_LPAREN2] = ACTIONS(3885),
    [anon_sym_default] = ACTIONS(3885),
    [anon_sym_or] = ACTIONS(3885),
    [anon_sym_static] = ACTIONS(3885),
    [anon_sym_member] = ACTIONS(3885),
    [anon_sym_interface] = ACTIONS(3885),
    [anon_sym_exception] = ACTIONS(3885),
    [anon_sym_abstract] = ACTIONS(3885),
    [anon_sym_val] = ACTIONS(3885),
    [anon_sym_override] = ACTIONS(3885),
    [aux_sym_char_token1] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3885),
    [anon_sym_DQUOTE] = ACTIONS(3885),
    [anon_sym_AT_DQUOTE] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [sym_bool] = ACTIONS(3885),
    [sym_unit] = ACTIONS(3883),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3885),
    [sym_op_identifier] = ACTIONS(3885),
    [anon_sym_PLUS] = ACTIONS(3885),
    [anon_sym_DASH] = ACTIONS(3885),
    [anon_sym_PLUS_DOT] = ACTIONS(3885),
    [anon_sym_DASH_DOT] = ACTIONS(3885),
    [anon_sym_PERCENT] = ACTIONS(3885),
    [anon_sym_AMP_AMP] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3883),
    [aux_sym_prefix_op_token1] = ACTIONS(3885),
    [aux_sym_infix_op_token1] = ACTIONS(3883),
    [aux_sym_infix_op_token2] = ACTIONS(3885),
    [anon_sym_PIPE_PIPE] = ACTIONS(3885),
    [anon_sym_BANG_EQ] = ACTIONS(3885),
    [anon_sym_COLON_EQ] = ACTIONS(3883),
    [anon_sym_DOLLAR] = ACTIONS(3885),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3885),
    [sym_int] = ACTIONS(3885),
    [sym_xint] = ACTIONS(3883),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3883),
    [anon_sym_POUNDload] = ACTIONS(3883),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3883),
    [sym__newline] = ACTIONS(3883),
  },
  [1333] = {
    [sym_block_comment] = STATE(1333),
    [sym_compiler_directive_decl] = STATE(1333),
    [sym_fsi_directive_decl] = STATE(1333),
    [sym_preproc_line] = STATE(1333),
    [ts_builtin_sym_end] = ACTIONS(3887),
    [sym_identifier] = ACTIONS(3889),
    [anon_sym_namespace] = ACTIONS(3889),
    [anon_sym_module] = ACTIONS(3889),
    [anon_sym_EQ] = ACTIONS(3887),
    [anon_sym_open] = ACTIONS(3889),
    [anon_sym_LBRACK_LT] = ACTIONS(3887),
    [anon_sym_COLON] = ACTIONS(3889),
    [anon_sym_return] = ACTIONS(3889),
    [anon_sym_type] = ACTIONS(3889),
    [anon_sym_do] = ACTIONS(3889),
    [anon_sym_and] = ACTIONS(3889),
    [anon_sym_let] = ACTIONS(3889),
    [anon_sym_let_BANG] = ACTIONS(3887),
    [aux_sym_access_modifier_token1] = ACTIONS(3887),
    [anon_sym_LPAREN] = ACTIONS(3889),
    [anon_sym_COMMA] = ACTIONS(3887),
    [anon_sym_null] = ACTIONS(3889),
    [anon_sym_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_COLON] = ACTIONS(3887),
    [anon_sym_AMP] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3887),
    [anon_sym_LBRACE] = ACTIONS(3889),
    [anon_sym_LT_AT] = ACTIONS(3889),
    [anon_sym_LT_AT_AT] = ACTIONS(3889),
    [anon_sym_DOT] = ACTIONS(3889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [anon_sym_new] = ACTIONS(3889),
    [anon_sym_with] = ACTIONS(3889),
    [anon_sym_return_BANG] = ACTIONS(3887),
    [anon_sym_yield] = ACTIONS(3889),
    [anon_sym_yield_BANG] = ACTIONS(3887),
    [anon_sym_lazy] = ACTIONS(3889),
    [anon_sym_assert] = ACTIONS(3889),
    [anon_sym_upcast] = ACTIONS(3889),
    [anon_sym_downcast] = ACTIONS(3889),
    [anon_sym_COLON_GT] = ACTIONS(3887),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3887),
    [anon_sym_for] = ACTIONS(3889),
    [anon_sym_while] = ACTIONS(3889),
    [anon_sym_if] = ACTIONS(3889),
    [anon_sym_fun] = ACTIONS(3889),
    [anon_sym_try] = ACTIONS(3889),
    [anon_sym_match] = ACTIONS(3889),
    [anon_sym_match_BANG] = ACTIONS(3887),
    [anon_sym_function] = ACTIONS(3889),
    [anon_sym_LT_DASH] = ACTIONS(3889),
    [anon_sym_DOT_LBRACK] = ACTIONS(3887),
    [anon_sym_LT] = ACTIONS(3887),
    [anon_sym_use] = ACTIONS(3889),
    [anon_sym_use_BANG] = ACTIONS(3887),
    [anon_sym_do_BANG] = ACTIONS(3887),
    [anon_sym_begin] = ACTIONS(3889),
    [anon_sym_LPAREN2] = ACTIONS(3889),
    [anon_sym_default] = ACTIONS(3889),
    [anon_sym_or] = ACTIONS(3889),
    [anon_sym_static] = ACTIONS(3889),
    [anon_sym_member] = ACTIONS(3889),
    [anon_sym_interface] = ACTIONS(3889),
    [anon_sym_exception] = ACTIONS(3889),
    [anon_sym_abstract] = ACTIONS(3889),
    [anon_sym_val] = ACTIONS(3889),
    [anon_sym_override] = ACTIONS(3889),
    [aux_sym_char_token1] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3889),
    [anon_sym_DQUOTE] = ACTIONS(3889),
    [anon_sym_AT_DQUOTE] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [sym_bool] = ACTIONS(3889),
    [sym_unit] = ACTIONS(3887),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3889),
    [sym_op_identifier] = ACTIONS(3889),
    [anon_sym_PLUS] = ACTIONS(3889),
    [anon_sym_DASH] = ACTIONS(3889),
    [anon_sym_PLUS_DOT] = ACTIONS(3889),
    [anon_sym_DASH_DOT] = ACTIONS(3889),
    [anon_sym_PERCENT] = ACTIONS(3889),
    [anon_sym_AMP_AMP] = ACTIONS(3889),
    [anon_sym_TILDE] = ACTIONS(3887),
    [aux_sym_prefix_op_token1] = ACTIONS(3889),
    [aux_sym_infix_op_token1] = ACTIONS(3887),
    [aux_sym_infix_op_token2] = ACTIONS(3889),
    [anon_sym_PIPE_PIPE] = ACTIONS(3889),
    [anon_sym_BANG_EQ] = ACTIONS(3889),
    [anon_sym_COLON_EQ] = ACTIONS(3887),
    [anon_sym_DOLLAR] = ACTIONS(3889),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3889),
    [sym_int] = ACTIONS(3889),
    [sym_xint] = ACTIONS(3887),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3887),
    [anon_sym_POUNDload] = ACTIONS(3887),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3887),
    [sym__newline] = ACTIONS(3887),
  },
  [1334] = {
    [sym_block_comment] = STATE(1334),
    [sym_compiler_directive_decl] = STATE(1334),
    [sym_fsi_directive_decl] = STATE(1334),
    [sym_preproc_line] = STATE(1334),
    [ts_builtin_sym_end] = ACTIONS(3891),
    [sym_identifier] = ACTIONS(3893),
    [anon_sym_namespace] = ACTIONS(3893),
    [anon_sym_module] = ACTIONS(3893),
    [anon_sym_EQ] = ACTIONS(3891),
    [anon_sym_open] = ACTIONS(3893),
    [anon_sym_LBRACK_LT] = ACTIONS(3891),
    [anon_sym_COLON] = ACTIONS(3893),
    [anon_sym_return] = ACTIONS(3893),
    [anon_sym_type] = ACTIONS(3893),
    [anon_sym_do] = ACTIONS(3893),
    [anon_sym_and] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_let_BANG] = ACTIONS(3891),
    [aux_sym_access_modifier_token1] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_COMMA] = ACTIONS(3891),
    [anon_sym_null] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_COLON] = ACTIONS(3891),
    [anon_sym_AMP] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3891),
    [anon_sym_LBRACE] = ACTIONS(3893),
    [anon_sym_LT_AT] = ACTIONS(3893),
    [anon_sym_LT_AT_AT] = ACTIONS(3893),
    [anon_sym_DOT] = ACTIONS(3893),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3891),
    [anon_sym_new] = ACTIONS(3893),
    [anon_sym_with] = ACTIONS(3893),
    [anon_sym_return_BANG] = ACTIONS(3891),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_yield_BANG] = ACTIONS(3891),
    [anon_sym_lazy] = ACTIONS(3893),
    [anon_sym_assert] = ACTIONS(3893),
    [anon_sym_upcast] = ACTIONS(3893),
    [anon_sym_downcast] = ACTIONS(3893),
    [anon_sym_COLON_GT] = ACTIONS(3891),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3891),
    [anon_sym_for] = ACTIONS(3893),
    [anon_sym_while] = ACTIONS(3893),
    [anon_sym_if] = ACTIONS(3893),
    [anon_sym_fun] = ACTIONS(3893),
    [anon_sym_try] = ACTIONS(3893),
    [anon_sym_match] = ACTIONS(3893),
    [anon_sym_match_BANG] = ACTIONS(3891),
    [anon_sym_function] = ACTIONS(3893),
    [anon_sym_LT_DASH] = ACTIONS(3893),
    [anon_sym_DOT_LBRACK] = ACTIONS(3891),
    [anon_sym_LT] = ACTIONS(3891),
    [anon_sym_use] = ACTIONS(3893),
    [anon_sym_use_BANG] = ACTIONS(3891),
    [anon_sym_do_BANG] = ACTIONS(3891),
    [anon_sym_begin] = ACTIONS(3893),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_default] = ACTIONS(3893),
    [anon_sym_or] = ACTIONS(3893),
    [anon_sym_static] = ACTIONS(3893),
    [anon_sym_member] = ACTIONS(3893),
    [anon_sym_interface] = ACTIONS(3893),
    [anon_sym_exception] = ACTIONS(3893),
    [anon_sym_abstract] = ACTIONS(3893),
    [anon_sym_val] = ACTIONS(3893),
    [anon_sym_override] = ACTIONS(3893),
    [aux_sym_char_token1] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3893),
    [anon_sym_DQUOTE] = ACTIONS(3893),
    [anon_sym_AT_DQUOTE] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [sym_bool] = ACTIONS(3893),
    [sym_unit] = ACTIONS(3891),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3893),
    [sym_op_identifier] = ACTIONS(3893),
    [anon_sym_PLUS] = ACTIONS(3893),
    [anon_sym_DASH] = ACTIONS(3893),
    [anon_sym_PLUS_DOT] = ACTIONS(3893),
    [anon_sym_DASH_DOT] = ACTIONS(3893),
    [anon_sym_PERCENT] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_TILDE] = ACTIONS(3891),
    [aux_sym_prefix_op_token1] = ACTIONS(3893),
    [aux_sym_infix_op_token1] = ACTIONS(3891),
    [aux_sym_infix_op_token2] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [anon_sym_BANG_EQ] = ACTIONS(3893),
    [anon_sym_COLON_EQ] = ACTIONS(3891),
    [anon_sym_DOLLAR] = ACTIONS(3893),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3893),
    [sym_int] = ACTIONS(3893),
    [sym_xint] = ACTIONS(3891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3891),
    [anon_sym_POUNDload] = ACTIONS(3891),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3891),
    [sym__newline] = ACTIONS(3891),
  },
  [1335] = {
    [sym_block_comment] = STATE(1335),
    [sym_compiler_directive_decl] = STATE(1335),
    [sym_fsi_directive_decl] = STATE(1335),
    [sym_preproc_line] = STATE(1335),
    [aux_sym_compound_type_repeat1] = STATE(1335),
    [sym_identifier] = ACTIONS(3427),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_LBRACK_LT] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [aux_sym_access_modifier_token1] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3427),
    [anon_sym_DOT] = ACTIONS(3427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_with] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_COLON_GT] = ACTIONS(3425),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(3427),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_LT_DASH] = ACTIONS(3427),
    [anon_sym_DOT_LBRACK] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_DOT_DOT2] = ACTIONS(3425),
    [anon_sym_STAR] = ACTIONS(3895),
    [anon_sym_LT2] = ACTIONS(3427),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3425),
    [anon_sym_default] = ACTIONS(3427),
    [anon_sym_or] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_member] = ACTIONS(3427),
    [anon_sym_interface] = ACTIONS(3427),
    [anon_sym_abstract] = ACTIONS(3427),
    [anon_sym_val] = ACTIONS(3427),
    [anon_sym_override] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3427),
    [anon_sym_DASH_DOT] = ACTIONS(3427),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3427),
    [aux_sym_infix_op_token1] = ACTIONS(3425),
    [aux_sym_infix_op_token2] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3427),
    [anon_sym_COLON_EQ] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3427),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
    [sym__dedent] = ACTIONS(3425),
  },
  [1336] = {
    [sym_block_comment] = STATE(1336),
    [sym_compiler_directive_decl] = STATE(1336),
    [sym_fsi_directive_decl] = STATE(1336),
    [sym_preproc_line] = STATE(1336),
    [ts_builtin_sym_end] = ACTIONS(3898),
    [sym_identifier] = ACTIONS(3900),
    [anon_sym_namespace] = ACTIONS(3900),
    [anon_sym_module] = ACTIONS(3900),
    [anon_sym_EQ] = ACTIONS(3898),
    [anon_sym_open] = ACTIONS(3900),
    [anon_sym_LBRACK_LT] = ACTIONS(3898),
    [anon_sym_COLON] = ACTIONS(3900),
    [anon_sym_return] = ACTIONS(3900),
    [anon_sym_type] = ACTIONS(3900),
    [anon_sym_do] = ACTIONS(3900),
    [anon_sym_and] = ACTIONS(3900),
    [anon_sym_let] = ACTIONS(3900),
    [anon_sym_let_BANG] = ACTIONS(3898),
    [aux_sym_access_modifier_token1] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3898),
    [anon_sym_null] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_COLON] = ACTIONS(3898),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_LBRACK] = ACTIONS(3900),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3898),
    [anon_sym_LBRACE] = ACTIONS(3900),
    [anon_sym_LT_AT] = ACTIONS(3900),
    [anon_sym_LT_AT_AT] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(3900),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3898),
    [anon_sym_new] = ACTIONS(3900),
    [anon_sym_with] = ACTIONS(3900),
    [anon_sym_return_BANG] = ACTIONS(3898),
    [anon_sym_yield] = ACTIONS(3900),
    [anon_sym_yield_BANG] = ACTIONS(3898),
    [anon_sym_lazy] = ACTIONS(3900),
    [anon_sym_assert] = ACTIONS(3900),
    [anon_sym_upcast] = ACTIONS(3900),
    [anon_sym_downcast] = ACTIONS(3900),
    [anon_sym_COLON_GT] = ACTIONS(3898),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3898),
    [anon_sym_for] = ACTIONS(3900),
    [anon_sym_while] = ACTIONS(3900),
    [anon_sym_if] = ACTIONS(3900),
    [anon_sym_fun] = ACTIONS(3900),
    [anon_sym_try] = ACTIONS(3900),
    [anon_sym_match] = ACTIONS(3900),
    [anon_sym_match_BANG] = ACTIONS(3898),
    [anon_sym_function] = ACTIONS(3900),
    [anon_sym_LT_DASH] = ACTIONS(3900),
    [anon_sym_DOT_LBRACK] = ACTIONS(3898),
    [anon_sym_LT] = ACTIONS(3898),
    [anon_sym_use] = ACTIONS(3900),
    [anon_sym_use_BANG] = ACTIONS(3898),
    [anon_sym_do_BANG] = ACTIONS(3898),
    [anon_sym_begin] = ACTIONS(3900),
    [anon_sym_LPAREN2] = ACTIONS(3900),
    [anon_sym_default] = ACTIONS(3900),
    [anon_sym_or] = ACTIONS(3900),
    [anon_sym_static] = ACTIONS(3900),
    [anon_sym_member] = ACTIONS(3900),
    [anon_sym_interface] = ACTIONS(3900),
    [anon_sym_exception] = ACTIONS(3900),
    [anon_sym_abstract] = ACTIONS(3900),
    [anon_sym_val] = ACTIONS(3900),
    [anon_sym_override] = ACTIONS(3900),
    [aux_sym_char_token1] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3900),
    [anon_sym_DQUOTE] = ACTIONS(3900),
    [anon_sym_AT_DQUOTE] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3898),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3900),
    [sym_op_identifier] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(3900),
    [anon_sym_DASH] = ACTIONS(3900),
    [anon_sym_PLUS_DOT] = ACTIONS(3900),
    [anon_sym_DASH_DOT] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(3900),
    [anon_sym_AMP_AMP] = ACTIONS(3900),
    [anon_sym_TILDE] = ACTIONS(3898),
    [aux_sym_prefix_op_token1] = ACTIONS(3900),
    [aux_sym_infix_op_token1] = ACTIONS(3898),
    [aux_sym_infix_op_token2] = ACTIONS(3900),
    [anon_sym_PIPE_PIPE] = ACTIONS(3900),
    [anon_sym_BANG_EQ] = ACTIONS(3900),
    [anon_sym_COLON_EQ] = ACTIONS(3898),
    [anon_sym_DOLLAR] = ACTIONS(3900),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3900),
    [sym_int] = ACTIONS(3900),
    [sym_xint] = ACTIONS(3898),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3898),
    [anon_sym_POUNDload] = ACTIONS(3898),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3898),
    [sym__newline] = ACTIONS(3898),
  },
  [1337] = {
    [sym_elif_expression] = STATE(1557),
    [sym_block_comment] = STATE(1337),
    [sym_compiler_directive_decl] = STATE(1337),
    [sym_fsi_directive_decl] = STATE(1337),
    [sym_preproc_line] = STATE(1337),
    [aux_sym_if_expression_repeat1] = STATE(1337),
    [sym_identifier] = ACTIONS(3555),
    [anon_sym_EQ] = ACTIONS(3553),
    [anon_sym_LBRACK_LT] = ACTIONS(3553),
    [anon_sym_COLON] = ACTIONS(3555),
    [anon_sym_return] = ACTIONS(3555),
    [anon_sym_do] = ACTIONS(3555),
    [anon_sym_let] = ACTIONS(3555),
    [anon_sym_let_BANG] = ACTIONS(3553),
    [aux_sym_access_modifier_token1] = ACTIONS(3553),
    [anon_sym_LPAREN] = ACTIONS(3555),
    [anon_sym_COMMA] = ACTIONS(3553),
    [anon_sym_null] = ACTIONS(3555),
    [anon_sym_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_COLON] = ACTIONS(3553),
    [anon_sym_AMP] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(3555),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3553),
    [anon_sym_LBRACE] = ACTIONS(3555),
    [anon_sym_LT_AT] = ACTIONS(3555),
    [anon_sym_LT_AT_AT] = ACTIONS(3555),
    [anon_sym_DOT] = ACTIONS(3555),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3553),
    [anon_sym_new] = ACTIONS(3555),
    [anon_sym_with] = ACTIONS(3555),
    [anon_sym_return_BANG] = ACTIONS(3553),
    [anon_sym_yield] = ACTIONS(3555),
    [anon_sym_yield_BANG] = ACTIONS(3553),
    [anon_sym_lazy] = ACTIONS(3555),
    [anon_sym_assert] = ACTIONS(3555),
    [anon_sym_upcast] = ACTIONS(3555),
    [anon_sym_downcast] = ACTIONS(3555),
    [anon_sym_COLON_GT] = ACTIONS(3553),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3553),
    [anon_sym_for] = ACTIONS(3555),
    [anon_sym_while] = ACTIONS(3555),
    [anon_sym_else] = ACTIONS(3555),
    [anon_sym_elif] = ACTIONS(3902),
    [anon_sym_if] = ACTIONS(3555),
    [anon_sym_fun] = ACTIONS(3555),
    [anon_sym_try] = ACTIONS(3555),
    [anon_sym_match] = ACTIONS(3555),
    [anon_sym_match_BANG] = ACTIONS(3553),
    [anon_sym_function] = ACTIONS(3555),
    [anon_sym_LT_DASH] = ACTIONS(3555),
    [anon_sym_DOT_LBRACK] = ACTIONS(3553),
    [anon_sym_LT] = ACTIONS(3553),
    [anon_sym_use] = ACTIONS(3555),
    [anon_sym_use_BANG] = ACTIONS(3553),
    [anon_sym_do_BANG] = ACTIONS(3553),
    [anon_sym_begin] = ACTIONS(3555),
    [anon_sym_LPAREN2] = ACTIONS(3555),
    [anon_sym_default] = ACTIONS(3555),
    [anon_sym_or] = ACTIONS(3555),
    [anon_sym_static] = ACTIONS(3555),
    [anon_sym_member] = ACTIONS(3555),
    [anon_sym_interface] = ACTIONS(3555),
    [anon_sym_abstract] = ACTIONS(3555),
    [anon_sym_val] = ACTIONS(3555),
    [anon_sym_override] = ACTIONS(3555),
    [anon_sym_inherit] = ACTIONS(3555),
    [aux_sym_char_token1] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3555),
    [anon_sym_DQUOTE] = ACTIONS(3555),
    [anon_sym_AT_DQUOTE] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [sym_bool] = ACTIONS(3555),
    [sym_unit] = ACTIONS(3553),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3555),
    [sym_op_identifier] = ACTIONS(3555),
    [anon_sym_PLUS] = ACTIONS(3555),
    [anon_sym_DASH] = ACTIONS(3555),
    [anon_sym_PLUS_DOT] = ACTIONS(3555),
    [anon_sym_DASH_DOT] = ACTIONS(3555),
    [anon_sym_PERCENT] = ACTIONS(3555),
    [anon_sym_AMP_AMP] = ACTIONS(3555),
    [anon_sym_TILDE] = ACTIONS(3553),
    [aux_sym_prefix_op_token1] = ACTIONS(3555),
    [aux_sym_infix_op_token1] = ACTIONS(3553),
    [aux_sym_infix_op_token2] = ACTIONS(3555),
    [anon_sym_PIPE_PIPE] = ACTIONS(3555),
    [anon_sym_BANG_EQ] = ACTIONS(3555),
    [anon_sym_COLON_EQ] = ACTIONS(3553),
    [anon_sym_DOLLAR] = ACTIONS(3555),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3555),
    [sym_int] = ACTIONS(3555),
    [sym_xint] = ACTIONS(3553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3553),
    [anon_sym_POUNDendif] = ACTIONS(3553),
    [anon_sym_POUNDelse] = ACTIONS(3553),
    [sym__newline] = ACTIONS(3553),
  },
  [1338] = {
    [sym_block_comment] = STATE(1338),
    [sym_compiler_directive_decl] = STATE(1338),
    [sym_fsi_directive_decl] = STATE(1338),
    [sym_preproc_line] = STATE(1338),
    [ts_builtin_sym_end] = ACTIONS(3905),
    [sym_identifier] = ACTIONS(3907),
    [anon_sym_namespace] = ACTIONS(3907),
    [anon_sym_module] = ACTIONS(3907),
    [anon_sym_EQ] = ACTIONS(3905),
    [anon_sym_open] = ACTIONS(3907),
    [anon_sym_LBRACK_LT] = ACTIONS(3905),
    [anon_sym_COLON] = ACTIONS(3907),
    [anon_sym_return] = ACTIONS(3907),
    [anon_sym_type] = ACTIONS(3907),
    [anon_sym_do] = ACTIONS(3907),
    [anon_sym_and] = ACTIONS(3907),
    [anon_sym_let] = ACTIONS(3907),
    [anon_sym_let_BANG] = ACTIONS(3905),
    [aux_sym_access_modifier_token1] = ACTIONS(3905),
    [anon_sym_LPAREN] = ACTIONS(3907),
    [anon_sym_COMMA] = ACTIONS(3905),
    [anon_sym_null] = ACTIONS(3907),
    [anon_sym_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_COLON] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3907),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3905),
    [anon_sym_LBRACE] = ACTIONS(3907),
    [anon_sym_LT_AT] = ACTIONS(3907),
    [anon_sym_LT_AT_AT] = ACTIONS(3907),
    [anon_sym_DOT] = ACTIONS(3907),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3905),
    [anon_sym_new] = ACTIONS(3907),
    [anon_sym_with] = ACTIONS(3907),
    [anon_sym_return_BANG] = ACTIONS(3905),
    [anon_sym_yield] = ACTIONS(3907),
    [anon_sym_yield_BANG] = ACTIONS(3905),
    [anon_sym_lazy] = ACTIONS(3907),
    [anon_sym_assert] = ACTIONS(3907),
    [anon_sym_upcast] = ACTIONS(3907),
    [anon_sym_downcast] = ACTIONS(3907),
    [anon_sym_COLON_GT] = ACTIONS(3905),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3905),
    [anon_sym_for] = ACTIONS(3907),
    [anon_sym_while] = ACTIONS(3907),
    [anon_sym_if] = ACTIONS(3907),
    [anon_sym_fun] = ACTIONS(3907),
    [anon_sym_try] = ACTIONS(3907),
    [anon_sym_match] = ACTIONS(3907),
    [anon_sym_match_BANG] = ACTIONS(3905),
    [anon_sym_function] = ACTIONS(3907),
    [anon_sym_LT_DASH] = ACTIONS(3907),
    [anon_sym_DOT_LBRACK] = ACTIONS(3905),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_use] = ACTIONS(3907),
    [anon_sym_use_BANG] = ACTIONS(3905),
    [anon_sym_do_BANG] = ACTIONS(3905),
    [anon_sym_begin] = ACTIONS(3907),
    [anon_sym_LPAREN2] = ACTIONS(3907),
    [anon_sym_default] = ACTIONS(3907),
    [anon_sym_or] = ACTIONS(3907),
    [anon_sym_static] = ACTIONS(3907),
    [anon_sym_member] = ACTIONS(3907),
    [anon_sym_interface] = ACTIONS(3907),
    [anon_sym_exception] = ACTIONS(3907),
    [anon_sym_abstract] = ACTIONS(3907),
    [anon_sym_val] = ACTIONS(3907),
    [anon_sym_override] = ACTIONS(3907),
    [aux_sym_char_token1] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3907),
    [anon_sym_DQUOTE] = ACTIONS(3907),
    [anon_sym_AT_DQUOTE] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [sym_bool] = ACTIONS(3907),
    [sym_unit] = ACTIONS(3905),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3907),
    [sym_op_identifier] = ACTIONS(3907),
    [anon_sym_PLUS] = ACTIONS(3907),
    [anon_sym_DASH] = ACTIONS(3907),
    [anon_sym_PLUS_DOT] = ACTIONS(3907),
    [anon_sym_DASH_DOT] = ACTIONS(3907),
    [anon_sym_PERCENT] = ACTIONS(3907),
    [anon_sym_AMP_AMP] = ACTIONS(3907),
    [anon_sym_TILDE] = ACTIONS(3905),
    [aux_sym_prefix_op_token1] = ACTIONS(3907),
    [aux_sym_infix_op_token1] = ACTIONS(3905),
    [aux_sym_infix_op_token2] = ACTIONS(3907),
    [anon_sym_PIPE_PIPE] = ACTIONS(3907),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_COLON_EQ] = ACTIONS(3905),
    [anon_sym_DOLLAR] = ACTIONS(3907),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3907),
    [sym_int] = ACTIONS(3907),
    [sym_xint] = ACTIONS(3905),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3905),
    [anon_sym_POUNDload] = ACTIONS(3905),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3905),
    [sym__newline] = ACTIONS(3905),
  },
  [1339] = {
    [sym_block_comment] = STATE(1339),
    [sym_compiler_directive_decl] = STATE(1339),
    [sym_fsi_directive_decl] = STATE(1339),
    [sym_preproc_line] = STATE(1339),
    [sym_identifier] = ACTIONS(3531),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_LBRACK_LT] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(3531),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_do] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [aux_sym_access_modifier_token1] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_null] = ACTIONS(3531),
    [anon_sym_QMARK] = ACTIONS(3531),
    [anon_sym_COLON_QMARK] = ACTIONS(3531),
    [anon_sym_COLON_COLON] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3531),
    [anon_sym_LT_AT] = ACTIONS(3531),
    [anon_sym_LT_AT_AT] = ACTIONS(3531),
    [anon_sym_DOT] = ACTIONS(3531),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3531),
    [anon_sym_with] = ACTIONS(3531),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3531),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3531),
    [anon_sym_assert] = ACTIONS(3531),
    [anon_sym_upcast] = ACTIONS(3531),
    [anon_sym_downcast] = ACTIONS(3531),
    [anon_sym_COLON_GT] = ACTIONS(3529),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3531),
    [anon_sym_while] = ACTIONS(3531),
    [anon_sym_if] = ACTIONS(3531),
    [anon_sym_fun] = ACTIONS(3531),
    [anon_sym_DASH_GT] = ACTIONS(3531),
    [anon_sym_try] = ACTIONS(3531),
    [anon_sym_match] = ACTIONS(3531),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3531),
    [anon_sym_LT_DASH] = ACTIONS(3531),
    [anon_sym_DOT_LBRACK] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_use] = ACTIONS(3531),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3531),
    [anon_sym_LPAREN2] = ACTIONS(3531),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LT2] = ACTIONS(3531),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_default] = ACTIONS(3531),
    [anon_sym_or] = ACTIONS(3531),
    [anon_sym_static] = ACTIONS(3531),
    [anon_sym_member] = ACTIONS(3531),
    [anon_sym_interface] = ACTIONS(3531),
    [anon_sym_abstract] = ACTIONS(3531),
    [anon_sym_val] = ACTIONS(3531),
    [anon_sym_override] = ACTIONS(3531),
    [anon_sym_inherit] = ACTIONS(3531),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3531),
    [anon_sym_DQUOTE] = ACTIONS(3531),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3531),
    [sym_unit] = ACTIONS(3529),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3531),
    [sym_op_identifier] = ACTIONS(3531),
    [anon_sym_PLUS] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(3531),
    [anon_sym_PLUS_DOT] = ACTIONS(3531),
    [anon_sym_DASH_DOT] = ACTIONS(3531),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_AMP_AMP] = ACTIONS(3531),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3531),
    [aux_sym_infix_op_token1] = ACTIONS(3529),
    [aux_sym_infix_op_token2] = ACTIONS(3531),
    [anon_sym_PIPE_PIPE] = ACTIONS(3531),
    [anon_sym_BANG_EQ] = ACTIONS(3531),
    [anon_sym_COLON_EQ] = ACTIONS(3529),
    [anon_sym_DOLLAR] = ACTIONS(3531),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3531),
    [sym_int] = ACTIONS(3531),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [anon_sym_POUNDendif] = ACTIONS(3529),
    [anon_sym_POUNDelse] = ACTIONS(3529),
    [sym__newline] = ACTIONS(3529),
  },
  [1340] = {
    [sym_block_comment] = STATE(1340),
    [sym_compiler_directive_decl] = STATE(1340),
    [sym_fsi_directive_decl] = STATE(1340),
    [sym_preproc_line] = STATE(1340),
    [aux_sym_sequential_expression_repeat1] = STATE(1340),
    [ts_builtin_sym_end] = ACTIONS(3765),
    [sym_identifier] = ACTIONS(3767),
    [anon_sym_module] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3765),
    [anon_sym_open] = ACTIONS(3767),
    [anon_sym_LBRACK_LT] = ACTIONS(3765),
    [anon_sym_COLON] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_type] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_and] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_let_BANG] = ACTIONS(3765),
    [aux_sym_access_modifier_token1] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(3767),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_null] = ACTIONS(3767),
    [anon_sym_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3765),
    [anon_sym_LBRACE] = ACTIONS(3767),
    [anon_sym_LT_AT] = ACTIONS(3767),
    [anon_sym_LT_AT_AT] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3765),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_with] = ACTIONS(3767),
    [anon_sym_return_BANG] = ACTIONS(3765),
    [anon_sym_yield] = ACTIONS(3767),
    [anon_sym_yield_BANG] = ACTIONS(3765),
    [anon_sym_lazy] = ACTIONS(3767),
    [anon_sym_assert] = ACTIONS(3767),
    [anon_sym_upcast] = ACTIONS(3767),
    [anon_sym_downcast] = ACTIONS(3767),
    [anon_sym_COLON_GT] = ACTIONS(3765),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3765),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_fun] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_match] = ACTIONS(3767),
    [anon_sym_match_BANG] = ACTIONS(3765),
    [anon_sym_function] = ACTIONS(3767),
    [anon_sym_LT_DASH] = ACTIONS(3767),
    [anon_sym_DOT_LBRACK] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(3765),
    [anon_sym_use] = ACTIONS(3767),
    [anon_sym_use_BANG] = ACTIONS(3765),
    [anon_sym_do_BANG] = ACTIONS(3765),
    [anon_sym_begin] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3767),
    [anon_sym_default] = ACTIONS(3767),
    [anon_sym_or] = ACTIONS(3767),
    [anon_sym_static] = ACTIONS(3767),
    [anon_sym_member] = ACTIONS(3767),
    [anon_sym_interface] = ACTIONS(3767),
    [anon_sym_exception] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(3767),
    [anon_sym_val] = ACTIONS(3767),
    [anon_sym_override] = ACTIONS(3767),
    [aux_sym_char_token1] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3767),
    [anon_sym_DQUOTE] = ACTIONS(3767),
    [anon_sym_AT_DQUOTE] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [sym_bool] = ACTIONS(3767),
    [sym_unit] = ACTIONS(3765),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3767),
    [sym_op_identifier] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_PLUS_DOT] = ACTIONS(3767),
    [anon_sym_DASH_DOT] = ACTIONS(3767),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_AMP_AMP] = ACTIONS(3767),
    [anon_sym_TILDE] = ACTIONS(3765),
    [aux_sym_prefix_op_token1] = ACTIONS(3767),
    [aux_sym_infix_op_token1] = ACTIONS(3765),
    [aux_sym_infix_op_token2] = ACTIONS(3767),
    [anon_sym_PIPE_PIPE] = ACTIONS(3767),
    [anon_sym_BANG_EQ] = ACTIONS(3767),
    [anon_sym_COLON_EQ] = ACTIONS(3765),
    [anon_sym_DOLLAR] = ACTIONS(3767),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3767),
    [sym_int] = ACTIONS(3767),
    [sym_xint] = ACTIONS(3765),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3765),
    [anon_sym_POUNDload] = ACTIONS(3765),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3765),
    [sym__newline] = ACTIONS(3909),
  },
  [1341] = {
    [sym_block_comment] = STATE(1341),
    [sym_compiler_directive_decl] = STATE(1341),
    [sym_fsi_directive_decl] = STATE(1341),
    [sym_preproc_line] = STATE(1341),
    [aux_sym_compound_type_repeat1] = STATE(1341),
    [sym_identifier] = ACTIONS(3427),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_LBRACK_LT] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [aux_sym_access_modifier_token1] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3427),
    [anon_sym_DOT] = ACTIONS(3427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_with] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_COLON_GT] = ACTIONS(3425),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(3427),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_LT_DASH] = ACTIONS(3427),
    [anon_sym_DOT_LBRACK] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(3912),
    [anon_sym_LT2] = ACTIONS(3427),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3425),
    [anon_sym_default] = ACTIONS(3427),
    [anon_sym_or] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_member] = ACTIONS(3427),
    [anon_sym_interface] = ACTIONS(3427),
    [anon_sym_abstract] = ACTIONS(3427),
    [anon_sym_val] = ACTIONS(3427),
    [anon_sym_override] = ACTIONS(3427),
    [anon_sym_inherit] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3427),
    [anon_sym_DASH_DOT] = ACTIONS(3427),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3427),
    [aux_sym_infix_op_token1] = ACTIONS(3425),
    [aux_sym_infix_op_token2] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3427),
    [anon_sym_COLON_EQ] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3427),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [anon_sym_POUNDendif] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
  },
  [1342] = {
    [sym_block_comment] = STATE(1342),
    [sym_compiler_directive_decl] = STATE(1342),
    [sym_fsi_directive_decl] = STATE(1342),
    [sym_preproc_line] = STATE(1342),
    [ts_builtin_sym_end] = ACTIONS(3915),
    [sym_identifier] = ACTIONS(3917),
    [anon_sym_namespace] = ACTIONS(3917),
    [anon_sym_module] = ACTIONS(3917),
    [anon_sym_EQ] = ACTIONS(3915),
    [anon_sym_open] = ACTIONS(3917),
    [anon_sym_LBRACK_LT] = ACTIONS(3915),
    [anon_sym_COLON] = ACTIONS(3917),
    [anon_sym_return] = ACTIONS(3917),
    [anon_sym_type] = ACTIONS(3917),
    [anon_sym_do] = ACTIONS(3917),
    [anon_sym_and] = ACTIONS(3917),
    [anon_sym_let] = ACTIONS(3917),
    [anon_sym_let_BANG] = ACTIONS(3915),
    [aux_sym_access_modifier_token1] = ACTIONS(3915),
    [anon_sym_LPAREN] = ACTIONS(3917),
    [anon_sym_COMMA] = ACTIONS(3915),
    [anon_sym_null] = ACTIONS(3917),
    [anon_sym_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_COLON] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(3917),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3915),
    [anon_sym_LBRACE] = ACTIONS(3917),
    [anon_sym_LT_AT] = ACTIONS(3917),
    [anon_sym_LT_AT_AT] = ACTIONS(3917),
    [anon_sym_DOT] = ACTIONS(3917),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3915),
    [anon_sym_new] = ACTIONS(3917),
    [anon_sym_with] = ACTIONS(3917),
    [anon_sym_return_BANG] = ACTIONS(3915),
    [anon_sym_yield] = ACTIONS(3917),
    [anon_sym_yield_BANG] = ACTIONS(3915),
    [anon_sym_lazy] = ACTIONS(3917),
    [anon_sym_assert] = ACTIONS(3917),
    [anon_sym_upcast] = ACTIONS(3917),
    [anon_sym_downcast] = ACTIONS(3917),
    [anon_sym_COLON_GT] = ACTIONS(3915),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3915),
    [anon_sym_for] = ACTIONS(3917),
    [anon_sym_while] = ACTIONS(3917),
    [anon_sym_if] = ACTIONS(3917),
    [anon_sym_fun] = ACTIONS(3917),
    [anon_sym_try] = ACTIONS(3917),
    [anon_sym_match] = ACTIONS(3917),
    [anon_sym_match_BANG] = ACTIONS(3915),
    [anon_sym_function] = ACTIONS(3917),
    [anon_sym_LT_DASH] = ACTIONS(3917),
    [anon_sym_DOT_LBRACK] = ACTIONS(3915),
    [anon_sym_LT] = ACTIONS(3915),
    [anon_sym_use] = ACTIONS(3917),
    [anon_sym_use_BANG] = ACTIONS(3915),
    [anon_sym_do_BANG] = ACTIONS(3915),
    [anon_sym_begin] = ACTIONS(3917),
    [anon_sym_LPAREN2] = ACTIONS(3917),
    [anon_sym_default] = ACTIONS(3917),
    [anon_sym_or] = ACTIONS(3917),
    [anon_sym_static] = ACTIONS(3917),
    [anon_sym_member] = ACTIONS(3917),
    [anon_sym_interface] = ACTIONS(3917),
    [anon_sym_exception] = ACTIONS(3917),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_val] = ACTIONS(3917),
    [anon_sym_override] = ACTIONS(3917),
    [aux_sym_char_token1] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_AT_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [sym_bool] = ACTIONS(3917),
    [sym_unit] = ACTIONS(3915),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3917),
    [sym_op_identifier] = ACTIONS(3917),
    [anon_sym_PLUS] = ACTIONS(3917),
    [anon_sym_DASH] = ACTIONS(3917),
    [anon_sym_PLUS_DOT] = ACTIONS(3917),
    [anon_sym_DASH_DOT] = ACTIONS(3917),
    [anon_sym_PERCENT] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_TILDE] = ACTIONS(3915),
    [aux_sym_prefix_op_token1] = ACTIONS(3917),
    [aux_sym_infix_op_token1] = ACTIONS(3915),
    [aux_sym_infix_op_token2] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_BANG_EQ] = ACTIONS(3917),
    [anon_sym_COLON_EQ] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3917),
    [sym_int] = ACTIONS(3917),
    [sym_xint] = ACTIONS(3915),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3915),
    [anon_sym_POUNDload] = ACTIONS(3915),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3915),
    [sym__newline] = ACTIONS(3915),
  },
  [1343] = {
    [sym_block_comment] = STATE(1343),
    [sym_compiler_directive_decl] = STATE(1343),
    [sym_fsi_directive_decl] = STATE(1343),
    [sym_preproc_line] = STATE(1343),
    [ts_builtin_sym_end] = ACTIONS(3919),
    [sym_identifier] = ACTIONS(3921),
    [anon_sym_namespace] = ACTIONS(3921),
    [anon_sym_module] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3919),
    [anon_sym_open] = ACTIONS(3921),
    [anon_sym_LBRACK_LT] = ACTIONS(3919),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_return] = ACTIONS(3921),
    [anon_sym_type] = ACTIONS(3921),
    [anon_sym_do] = ACTIONS(3921),
    [anon_sym_and] = ACTIONS(3921),
    [anon_sym_let] = ACTIONS(3921),
    [anon_sym_let_BANG] = ACTIONS(3919),
    [aux_sym_access_modifier_token1] = ACTIONS(3919),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3919),
    [anon_sym_null] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_COLON] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3919),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_LT_AT] = ACTIONS(3921),
    [anon_sym_LT_AT_AT] = ACTIONS(3921),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3919),
    [anon_sym_new] = ACTIONS(3921),
    [anon_sym_with] = ACTIONS(3921),
    [anon_sym_return_BANG] = ACTIONS(3919),
    [anon_sym_yield] = ACTIONS(3921),
    [anon_sym_yield_BANG] = ACTIONS(3919),
    [anon_sym_lazy] = ACTIONS(3921),
    [anon_sym_assert] = ACTIONS(3921),
    [anon_sym_upcast] = ACTIONS(3921),
    [anon_sym_downcast] = ACTIONS(3921),
    [anon_sym_COLON_GT] = ACTIONS(3919),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3919),
    [anon_sym_for] = ACTIONS(3921),
    [anon_sym_while] = ACTIONS(3921),
    [anon_sym_if] = ACTIONS(3921),
    [anon_sym_fun] = ACTIONS(3921),
    [anon_sym_try] = ACTIONS(3921),
    [anon_sym_match] = ACTIONS(3921),
    [anon_sym_match_BANG] = ACTIONS(3919),
    [anon_sym_function] = ACTIONS(3921),
    [anon_sym_LT_DASH] = ACTIONS(3921),
    [anon_sym_DOT_LBRACK] = ACTIONS(3919),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_use] = ACTIONS(3921),
    [anon_sym_use_BANG] = ACTIONS(3919),
    [anon_sym_do_BANG] = ACTIONS(3919),
    [anon_sym_begin] = ACTIONS(3921),
    [anon_sym_LPAREN2] = ACTIONS(3921),
    [anon_sym_default] = ACTIONS(3921),
    [anon_sym_or] = ACTIONS(3921),
    [anon_sym_static] = ACTIONS(3921),
    [anon_sym_member] = ACTIONS(3921),
    [anon_sym_interface] = ACTIONS(3921),
    [anon_sym_exception] = ACTIONS(3921),
    [anon_sym_abstract] = ACTIONS(3921),
    [anon_sym_val] = ACTIONS(3921),
    [anon_sym_override] = ACTIONS(3921),
    [aux_sym_char_token1] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_AT_DQUOTE] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [sym_bool] = ACTIONS(3921),
    [sym_unit] = ACTIONS(3919),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3921),
    [sym_op_identifier] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_DOT] = ACTIONS(3921),
    [anon_sym_DASH_DOT] = ACTIONS(3921),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3919),
    [aux_sym_prefix_op_token1] = ACTIONS(3921),
    [aux_sym_infix_op_token1] = ACTIONS(3919),
    [aux_sym_infix_op_token2] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_COLON_EQ] = ACTIONS(3919),
    [anon_sym_DOLLAR] = ACTIONS(3921),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3921),
    [sym_int] = ACTIONS(3921),
    [sym_xint] = ACTIONS(3919),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3919),
    [anon_sym_POUNDload] = ACTIONS(3919),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3919),
    [sym__newline] = ACTIONS(3919),
  },
  [1344] = {
    [sym_block_comment] = STATE(1344),
    [sym_compiler_directive_decl] = STATE(1344),
    [sym_fsi_directive_decl] = STATE(1344),
    [sym_preproc_line] = STATE(1344),
    [sym_identifier] = ACTIONS(3505),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_LBRACK_LT] = ACTIONS(3503),
    [anon_sym_COLON] = ACTIONS(3505),
    [anon_sym_return] = ACTIONS(3505),
    [anon_sym_do] = ACTIONS(3505),
    [anon_sym_let] = ACTIONS(3505),
    [anon_sym_let_BANG] = ACTIONS(3503),
    [aux_sym_access_modifier_token1] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3505),
    [anon_sym_COMMA] = ACTIONS(3503),
    [anon_sym_null] = ACTIONS(3505),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_COLON_QMARK] = ACTIONS(3505),
    [anon_sym_COLON_COLON] = ACTIONS(3503),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3503),
    [anon_sym_LBRACE] = ACTIONS(3505),
    [anon_sym_LT_AT] = ACTIONS(3505),
    [anon_sym_LT_AT_AT] = ACTIONS(3505),
    [anon_sym_DOT] = ACTIONS(3505),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3503),
    [anon_sym_new] = ACTIONS(3505),
    [anon_sym_with] = ACTIONS(3505),
    [anon_sym_return_BANG] = ACTIONS(3503),
    [anon_sym_yield] = ACTIONS(3505),
    [anon_sym_yield_BANG] = ACTIONS(3503),
    [anon_sym_lazy] = ACTIONS(3505),
    [anon_sym_assert] = ACTIONS(3505),
    [anon_sym_upcast] = ACTIONS(3505),
    [anon_sym_downcast] = ACTIONS(3505),
    [anon_sym_COLON_GT] = ACTIONS(3503),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3503),
    [anon_sym_for] = ACTIONS(3505),
    [anon_sym_while] = ACTIONS(3505),
    [anon_sym_if] = ACTIONS(3505),
    [anon_sym_fun] = ACTIONS(3505),
    [anon_sym_DASH_GT] = ACTIONS(3505),
    [anon_sym_try] = ACTIONS(3505),
    [anon_sym_match] = ACTIONS(3505),
    [anon_sym_match_BANG] = ACTIONS(3503),
    [anon_sym_function] = ACTIONS(3505),
    [anon_sym_LT_DASH] = ACTIONS(3505),
    [anon_sym_DOT_LBRACK] = ACTIONS(3503),
    [anon_sym_LT] = ACTIONS(3503),
    [anon_sym_use] = ACTIONS(3505),
    [anon_sym_use_BANG] = ACTIONS(3503),
    [anon_sym_do_BANG] = ACTIONS(3503),
    [anon_sym_begin] = ACTIONS(3505),
    [anon_sym_LPAREN2] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3505),
    [anon_sym_LT2] = ACTIONS(3923),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_default] = ACTIONS(3505),
    [anon_sym_or] = ACTIONS(3505),
    [anon_sym_static] = ACTIONS(3505),
    [anon_sym_member] = ACTIONS(3505),
    [anon_sym_interface] = ACTIONS(3505),
    [anon_sym_abstract] = ACTIONS(3505),
    [anon_sym_val] = ACTIONS(3505),
    [anon_sym_override] = ACTIONS(3505),
    [anon_sym_inherit] = ACTIONS(3505),
    [aux_sym_char_token1] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3505),
    [anon_sym_DQUOTE] = ACTIONS(3505),
    [anon_sym_AT_DQUOTE] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [sym_bool] = ACTIONS(3505),
    [sym_unit] = ACTIONS(3503),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3505),
    [sym_op_identifier] = ACTIONS(3505),
    [anon_sym_PLUS] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3505),
    [anon_sym_PLUS_DOT] = ACTIONS(3505),
    [anon_sym_DASH_DOT] = ACTIONS(3505),
    [anon_sym_PERCENT] = ACTIONS(3505),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3503),
    [aux_sym_prefix_op_token1] = ACTIONS(3505),
    [aux_sym_infix_op_token1] = ACTIONS(3503),
    [aux_sym_infix_op_token2] = ACTIONS(3505),
    [anon_sym_PIPE_PIPE] = ACTIONS(3505),
    [anon_sym_BANG_EQ] = ACTIONS(3505),
    [anon_sym_COLON_EQ] = ACTIONS(3503),
    [anon_sym_DOLLAR] = ACTIONS(3505),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3505),
    [sym_int] = ACTIONS(3505),
    [sym_xint] = ACTIONS(3503),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3503),
    [anon_sym_POUNDendif] = ACTIONS(3503),
    [anon_sym_POUNDelse] = ACTIONS(3503),
    [sym__newline] = ACTIONS(3503),
  },
  [1345] = {
    [sym_block_comment] = STATE(1345),
    [sym_compiler_directive_decl] = STATE(1345),
    [sym_fsi_directive_decl] = STATE(1345),
    [sym_preproc_line] = STATE(1345),
    [ts_builtin_sym_end] = ACTIONS(3925),
    [sym_identifier] = ACTIONS(3927),
    [anon_sym_namespace] = ACTIONS(3927),
    [anon_sym_module] = ACTIONS(3927),
    [anon_sym_EQ] = ACTIONS(3925),
    [anon_sym_open] = ACTIONS(3927),
    [anon_sym_LBRACK_LT] = ACTIONS(3925),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_return] = ACTIONS(3927),
    [anon_sym_type] = ACTIONS(3927),
    [anon_sym_do] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3927),
    [anon_sym_let] = ACTIONS(3927),
    [anon_sym_let_BANG] = ACTIONS(3925),
    [aux_sym_access_modifier_token1] = ACTIONS(3925),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_COMMA] = ACTIONS(3925),
    [anon_sym_null] = ACTIONS(3927),
    [anon_sym_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_COLON] = ACTIONS(3925),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3925),
    [anon_sym_LBRACE] = ACTIONS(3927),
    [anon_sym_LT_AT] = ACTIONS(3927),
    [anon_sym_LT_AT_AT] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3925),
    [anon_sym_new] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3927),
    [anon_sym_return_BANG] = ACTIONS(3925),
    [anon_sym_yield] = ACTIONS(3927),
    [anon_sym_yield_BANG] = ACTIONS(3925),
    [anon_sym_lazy] = ACTIONS(3927),
    [anon_sym_assert] = ACTIONS(3927),
    [anon_sym_upcast] = ACTIONS(3927),
    [anon_sym_downcast] = ACTIONS(3927),
    [anon_sym_COLON_GT] = ACTIONS(3925),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3925),
    [anon_sym_for] = ACTIONS(3927),
    [anon_sym_while] = ACTIONS(3927),
    [anon_sym_if] = ACTIONS(3927),
    [anon_sym_fun] = ACTIONS(3927),
    [anon_sym_try] = ACTIONS(3927),
    [anon_sym_match] = ACTIONS(3927),
    [anon_sym_match_BANG] = ACTIONS(3925),
    [anon_sym_function] = ACTIONS(3927),
    [anon_sym_LT_DASH] = ACTIONS(3927),
    [anon_sym_DOT_LBRACK] = ACTIONS(3925),
    [anon_sym_LT] = ACTIONS(3925),
    [anon_sym_use] = ACTIONS(3927),
    [anon_sym_use_BANG] = ACTIONS(3925),
    [anon_sym_do_BANG] = ACTIONS(3925),
    [anon_sym_begin] = ACTIONS(3927),
    [anon_sym_LPAREN2] = ACTIONS(3927),
    [anon_sym_default] = ACTIONS(3927),
    [anon_sym_or] = ACTIONS(3927),
    [anon_sym_static] = ACTIONS(3927),
    [anon_sym_member] = ACTIONS(3927),
    [anon_sym_interface] = ACTIONS(3927),
    [anon_sym_exception] = ACTIONS(3927),
    [anon_sym_abstract] = ACTIONS(3927),
    [anon_sym_val] = ACTIONS(3927),
    [anon_sym_override] = ACTIONS(3927),
    [aux_sym_char_token1] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_AT_DQUOTE] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [sym_bool] = ACTIONS(3927),
    [sym_unit] = ACTIONS(3925),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3927),
    [sym_op_identifier] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3927),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_PLUS_DOT] = ACTIONS(3927),
    [anon_sym_DASH_DOT] = ACTIONS(3927),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_TILDE] = ACTIONS(3925),
    [aux_sym_prefix_op_token1] = ACTIONS(3927),
    [aux_sym_infix_op_token1] = ACTIONS(3925),
    [aux_sym_infix_op_token2] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_COLON_EQ] = ACTIONS(3925),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3927),
    [sym_int] = ACTIONS(3927),
    [sym_xint] = ACTIONS(3925),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3925),
    [anon_sym_POUNDload] = ACTIONS(3925),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3925),
    [sym__newline] = ACTIONS(3925),
  },
  [1346] = {
    [sym_block_comment] = STATE(1346),
    [sym_compiler_directive_decl] = STATE(1346),
    [sym_fsi_directive_decl] = STATE(1346),
    [sym_preproc_line] = STATE(1346),
    [ts_builtin_sym_end] = ACTIONS(3929),
    [sym_identifier] = ACTIONS(3931),
    [anon_sym_namespace] = ACTIONS(3931),
    [anon_sym_module] = ACTIONS(3931),
    [anon_sym_EQ] = ACTIONS(3929),
    [anon_sym_open] = ACTIONS(3931),
    [anon_sym_LBRACK_LT] = ACTIONS(3929),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_type] = ACTIONS(3931),
    [anon_sym_do] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3931),
    [anon_sym_let] = ACTIONS(3931),
    [anon_sym_let_BANG] = ACTIONS(3929),
    [aux_sym_access_modifier_token1] = ACTIONS(3929),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_COMMA] = ACTIONS(3929),
    [anon_sym_null] = ACTIONS(3931),
    [anon_sym_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_COLON] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3931),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_LT_AT] = ACTIONS(3931),
    [anon_sym_LT_AT_AT] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3931),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3929),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3931),
    [anon_sym_return_BANG] = ACTIONS(3929),
    [anon_sym_yield] = ACTIONS(3931),
    [anon_sym_yield_BANG] = ACTIONS(3929),
    [anon_sym_lazy] = ACTIONS(3931),
    [anon_sym_assert] = ACTIONS(3931),
    [anon_sym_upcast] = ACTIONS(3931),
    [anon_sym_downcast] = ACTIONS(3931),
    [anon_sym_COLON_GT] = ACTIONS(3929),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3929),
    [anon_sym_for] = ACTIONS(3931),
    [anon_sym_while] = ACTIONS(3931),
    [anon_sym_if] = ACTIONS(3931),
    [anon_sym_fun] = ACTIONS(3931),
    [anon_sym_try] = ACTIONS(3931),
    [anon_sym_match] = ACTIONS(3931),
    [anon_sym_match_BANG] = ACTIONS(3929),
    [anon_sym_function] = ACTIONS(3931),
    [anon_sym_LT_DASH] = ACTIONS(3931),
    [anon_sym_DOT_LBRACK] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_use] = ACTIONS(3931),
    [anon_sym_use_BANG] = ACTIONS(3929),
    [anon_sym_do_BANG] = ACTIONS(3929),
    [anon_sym_begin] = ACTIONS(3931),
    [anon_sym_LPAREN2] = ACTIONS(3931),
    [anon_sym_default] = ACTIONS(3931),
    [anon_sym_or] = ACTIONS(3931),
    [anon_sym_static] = ACTIONS(3931),
    [anon_sym_member] = ACTIONS(3931),
    [anon_sym_interface] = ACTIONS(3931),
    [anon_sym_exception] = ACTIONS(3931),
    [anon_sym_abstract] = ACTIONS(3931),
    [anon_sym_val] = ACTIONS(3931),
    [anon_sym_override] = ACTIONS(3931),
    [aux_sym_char_token1] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3931),
    [anon_sym_DQUOTE] = ACTIONS(3931),
    [anon_sym_AT_DQUOTE] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [sym_bool] = ACTIONS(3931),
    [sym_unit] = ACTIONS(3929),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3931),
    [sym_op_identifier] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3931),
    [anon_sym_DASH] = ACTIONS(3931),
    [anon_sym_PLUS_DOT] = ACTIONS(3931),
    [anon_sym_DASH_DOT] = ACTIONS(3931),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_TILDE] = ACTIONS(3929),
    [aux_sym_prefix_op_token1] = ACTIONS(3931),
    [aux_sym_infix_op_token1] = ACTIONS(3929),
    [aux_sym_infix_op_token2] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_COLON_EQ] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3931),
    [sym_int] = ACTIONS(3931),
    [sym_xint] = ACTIONS(3929),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3929),
    [anon_sym_POUNDload] = ACTIONS(3929),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3929),
    [sym__newline] = ACTIONS(3929),
  },
  [1347] = {
    [sym_block_comment] = STATE(1347),
    [sym_compiler_directive_decl] = STATE(1347),
    [sym_fsi_directive_decl] = STATE(1347),
    [sym_preproc_line] = STATE(1347),
    [ts_builtin_sym_end] = ACTIONS(3933),
    [sym_identifier] = ACTIONS(3935),
    [anon_sym_namespace] = ACTIONS(3935),
    [anon_sym_module] = ACTIONS(3935),
    [anon_sym_EQ] = ACTIONS(3933),
    [anon_sym_open] = ACTIONS(3935),
    [anon_sym_LBRACK_LT] = ACTIONS(3933),
    [anon_sym_COLON] = ACTIONS(3935),
    [anon_sym_return] = ACTIONS(3935),
    [anon_sym_type] = ACTIONS(3935),
    [anon_sym_do] = ACTIONS(3935),
    [anon_sym_and] = ACTIONS(3935),
    [anon_sym_let] = ACTIONS(3935),
    [anon_sym_let_BANG] = ACTIONS(3933),
    [aux_sym_access_modifier_token1] = ACTIONS(3933),
    [anon_sym_LPAREN] = ACTIONS(3935),
    [anon_sym_COMMA] = ACTIONS(3933),
    [anon_sym_null] = ACTIONS(3935),
    [anon_sym_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3935),
    [anon_sym_LBRACK] = ACTIONS(3935),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3933),
    [anon_sym_LBRACE] = ACTIONS(3935),
    [anon_sym_LT_AT] = ACTIONS(3935),
    [anon_sym_LT_AT_AT] = ACTIONS(3935),
    [anon_sym_DOT] = ACTIONS(3935),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3933),
    [anon_sym_new] = ACTIONS(3935),
    [anon_sym_with] = ACTIONS(3935),
    [anon_sym_return_BANG] = ACTIONS(3933),
    [anon_sym_yield] = ACTIONS(3935),
    [anon_sym_yield_BANG] = ACTIONS(3933),
    [anon_sym_lazy] = ACTIONS(3935),
    [anon_sym_assert] = ACTIONS(3935),
    [anon_sym_upcast] = ACTIONS(3935),
    [anon_sym_downcast] = ACTIONS(3935),
    [anon_sym_COLON_GT] = ACTIONS(3933),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3933),
    [anon_sym_for] = ACTIONS(3935),
    [anon_sym_while] = ACTIONS(3935),
    [anon_sym_if] = ACTIONS(3935),
    [anon_sym_fun] = ACTIONS(3935),
    [anon_sym_try] = ACTIONS(3935),
    [anon_sym_match] = ACTIONS(3935),
    [anon_sym_match_BANG] = ACTIONS(3933),
    [anon_sym_function] = ACTIONS(3935),
    [anon_sym_LT_DASH] = ACTIONS(3935),
    [anon_sym_DOT_LBRACK] = ACTIONS(3933),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_use] = ACTIONS(3935),
    [anon_sym_use_BANG] = ACTIONS(3933),
    [anon_sym_do_BANG] = ACTIONS(3933),
    [anon_sym_begin] = ACTIONS(3935),
    [anon_sym_LPAREN2] = ACTIONS(3935),
    [anon_sym_default] = ACTIONS(3935),
    [anon_sym_or] = ACTIONS(3935),
    [anon_sym_static] = ACTIONS(3935),
    [anon_sym_member] = ACTIONS(3935),
    [anon_sym_interface] = ACTIONS(3935),
    [anon_sym_exception] = ACTIONS(3935),
    [anon_sym_abstract] = ACTIONS(3935),
    [anon_sym_val] = ACTIONS(3935),
    [anon_sym_override] = ACTIONS(3935),
    [aux_sym_char_token1] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3935),
    [anon_sym_DQUOTE] = ACTIONS(3935),
    [anon_sym_AT_DQUOTE] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [sym_bool] = ACTIONS(3935),
    [sym_unit] = ACTIONS(3933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3935),
    [sym_op_identifier] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(3935),
    [anon_sym_DASH] = ACTIONS(3935),
    [anon_sym_PLUS_DOT] = ACTIONS(3935),
    [anon_sym_DASH_DOT] = ACTIONS(3935),
    [anon_sym_PERCENT] = ACTIONS(3935),
    [anon_sym_AMP_AMP] = ACTIONS(3935),
    [anon_sym_TILDE] = ACTIONS(3933),
    [aux_sym_prefix_op_token1] = ACTIONS(3935),
    [aux_sym_infix_op_token1] = ACTIONS(3933),
    [aux_sym_infix_op_token2] = ACTIONS(3935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3935),
    [anon_sym_BANG_EQ] = ACTIONS(3935),
    [anon_sym_COLON_EQ] = ACTIONS(3933),
    [anon_sym_DOLLAR] = ACTIONS(3935),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3935),
    [sym_int] = ACTIONS(3935),
    [sym_xint] = ACTIONS(3933),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3933),
    [anon_sym_POUNDload] = ACTIONS(3933),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3933),
    [sym__newline] = ACTIONS(3933),
  },
  [1348] = {
    [sym_block_comment] = STATE(1348),
    [sym_compiler_directive_decl] = STATE(1348),
    [sym_fsi_directive_decl] = STATE(1348),
    [sym_preproc_line] = STATE(1348),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_LBRACK_LT] = ACTIONS(3513),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [aux_sym_access_modifier_token1] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_COLON] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_with] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(3513),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_LT_DASH] = ACTIONS(3515),
    [anon_sym_DOT_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3515),
    [anon_sym_or] = ACTIONS(3515),
    [anon_sym_static] = ACTIONS(3515),
    [anon_sym_member] = ACTIONS(3515),
    [anon_sym_interface] = ACTIONS(3515),
    [anon_sym_abstract] = ACTIONS(3515),
    [anon_sym_val] = ACTIONS(3515),
    [anon_sym_override] = ACTIONS(3515),
    [anon_sym_inherit] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3515),
    [anon_sym_DASH_DOT] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3515),
    [aux_sym_infix_op_token1] = ACTIONS(3513),
    [aux_sym_infix_op_token2] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3515),
    [anon_sym_COLON_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(3515),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3515),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [anon_sym_POUNDendif] = ACTIONS(3513),
    [anon_sym_POUNDelse] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
  },
  [1349] = {
    [sym_block_comment] = STATE(1349),
    [sym_compiler_directive_decl] = STATE(1349),
    [sym_fsi_directive_decl] = STATE(1349),
    [sym_preproc_line] = STATE(1349),
    [aux_sym_compound_type_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(3427),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_LBRACK_LT] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_and] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [aux_sym_access_modifier_token1] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3427),
    [anon_sym_DOT] = ACTIONS(3427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_with] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_COLON_GT] = ACTIONS(3425),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(3427),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_LT_DASH] = ACTIONS(3427),
    [anon_sym_DOT_LBRACK] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(3937),
    [anon_sym_LT2] = ACTIONS(3427),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3425),
    [anon_sym_default] = ACTIONS(3427),
    [anon_sym_or] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_member] = ACTIONS(3427),
    [anon_sym_interface] = ACTIONS(3427),
    [anon_sym_abstract] = ACTIONS(3427),
    [anon_sym_val] = ACTIONS(3427),
    [anon_sym_override] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3427),
    [anon_sym_DASH_DOT] = ACTIONS(3427),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3427),
    [aux_sym_infix_op_token1] = ACTIONS(3425),
    [aux_sym_infix_op_token2] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3427),
    [anon_sym_COLON_EQ] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3427),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [anon_sym_POUNDendif] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
  },
  [1350] = {
    [sym_block_comment] = STATE(1350),
    [sym_compiler_directive_decl] = STATE(1350),
    [sym_fsi_directive_decl] = STATE(1350),
    [sym_preproc_line] = STATE(1350),
    [ts_builtin_sym_end] = ACTIONS(3940),
    [sym_identifier] = ACTIONS(3942),
    [anon_sym_namespace] = ACTIONS(3942),
    [anon_sym_module] = ACTIONS(3942),
    [anon_sym_EQ] = ACTIONS(3940),
    [anon_sym_open] = ACTIONS(3942),
    [anon_sym_LBRACK_LT] = ACTIONS(3940),
    [anon_sym_COLON] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_type] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_and] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_let_BANG] = ACTIONS(3940),
    [aux_sym_access_modifier_token1] = ACTIONS(3940),
    [anon_sym_LPAREN] = ACTIONS(3942),
    [anon_sym_COMMA] = ACTIONS(3940),
    [anon_sym_null] = ACTIONS(3942),
    [anon_sym_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3940),
    [anon_sym_LBRACE] = ACTIONS(3942),
    [anon_sym_LT_AT] = ACTIONS(3942),
    [anon_sym_LT_AT_AT] = ACTIONS(3942),
    [anon_sym_DOT] = ACTIONS(3942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3940),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_with] = ACTIONS(3942),
    [anon_sym_return_BANG] = ACTIONS(3940),
    [anon_sym_yield] = ACTIONS(3942),
    [anon_sym_yield_BANG] = ACTIONS(3940),
    [anon_sym_lazy] = ACTIONS(3942),
    [anon_sym_assert] = ACTIONS(3942),
    [anon_sym_upcast] = ACTIONS(3942),
    [anon_sym_downcast] = ACTIONS(3942),
    [anon_sym_COLON_GT] = ACTIONS(3940),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3940),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_fun] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_match] = ACTIONS(3942),
    [anon_sym_match_BANG] = ACTIONS(3940),
    [anon_sym_function] = ACTIONS(3942),
    [anon_sym_LT_DASH] = ACTIONS(3942),
    [anon_sym_DOT_LBRACK] = ACTIONS(3940),
    [anon_sym_LT] = ACTIONS(3940),
    [anon_sym_use] = ACTIONS(3942),
    [anon_sym_use_BANG] = ACTIONS(3940),
    [anon_sym_do_BANG] = ACTIONS(3940),
    [anon_sym_begin] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3942),
    [anon_sym_default] = ACTIONS(3942),
    [anon_sym_or] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_member] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_exception] = ACTIONS(3942),
    [anon_sym_abstract] = ACTIONS(3942),
    [anon_sym_val] = ACTIONS(3942),
    [anon_sym_override] = ACTIONS(3942),
    [aux_sym_char_token1] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3942),
    [anon_sym_DQUOTE] = ACTIONS(3942),
    [anon_sym_AT_DQUOTE] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [sym_bool] = ACTIONS(3942),
    [sym_unit] = ACTIONS(3940),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3942),
    [sym_op_identifier] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS_DOT] = ACTIONS(3942),
    [anon_sym_DASH_DOT] = ACTIONS(3942),
    [anon_sym_PERCENT] = ACTIONS(3942),
    [anon_sym_AMP_AMP] = ACTIONS(3942),
    [anon_sym_TILDE] = ACTIONS(3940),
    [aux_sym_prefix_op_token1] = ACTIONS(3942),
    [aux_sym_infix_op_token1] = ACTIONS(3940),
    [aux_sym_infix_op_token2] = ACTIONS(3942),
    [anon_sym_PIPE_PIPE] = ACTIONS(3942),
    [anon_sym_BANG_EQ] = ACTIONS(3942),
    [anon_sym_COLON_EQ] = ACTIONS(3940),
    [anon_sym_DOLLAR] = ACTIONS(3942),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3942),
    [sym_int] = ACTIONS(3942),
    [sym_xint] = ACTIONS(3940),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3940),
    [anon_sym_POUNDload] = ACTIONS(3940),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3940),
    [sym__newline] = ACTIONS(3940),
  },
  [1351] = {
    [sym_block_comment] = STATE(1351),
    [sym_compiler_directive_decl] = STATE(1351),
    [sym_fsi_directive_decl] = STATE(1351),
    [sym_preproc_line] = STATE(1351),
    [ts_builtin_sym_end] = ACTIONS(3944),
    [sym_identifier] = ACTIONS(3946),
    [anon_sym_namespace] = ACTIONS(3946),
    [anon_sym_module] = ACTIONS(3946),
    [anon_sym_EQ] = ACTIONS(3944),
    [anon_sym_open] = ACTIONS(3946),
    [anon_sym_LBRACK_LT] = ACTIONS(3944),
    [anon_sym_COLON] = ACTIONS(3946),
    [anon_sym_return] = ACTIONS(3946),
    [anon_sym_type] = ACTIONS(3946),
    [anon_sym_do] = ACTIONS(3946),
    [anon_sym_and] = ACTIONS(3946),
    [anon_sym_let] = ACTIONS(3946),
    [anon_sym_let_BANG] = ACTIONS(3944),
    [aux_sym_access_modifier_token1] = ACTIONS(3944),
    [anon_sym_LPAREN] = ACTIONS(3946),
    [anon_sym_COMMA] = ACTIONS(3944),
    [anon_sym_null] = ACTIONS(3946),
    [anon_sym_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LBRACK] = ACTIONS(3946),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3944),
    [anon_sym_LBRACE] = ACTIONS(3946),
    [anon_sym_LT_AT] = ACTIONS(3946),
    [anon_sym_LT_AT_AT] = ACTIONS(3946),
    [anon_sym_DOT] = ACTIONS(3946),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3944),
    [anon_sym_new] = ACTIONS(3946),
    [anon_sym_with] = ACTIONS(3946),
    [anon_sym_return_BANG] = ACTIONS(3944),
    [anon_sym_yield] = ACTIONS(3946),
    [anon_sym_yield_BANG] = ACTIONS(3944),
    [anon_sym_lazy] = ACTIONS(3946),
    [anon_sym_assert] = ACTIONS(3946),
    [anon_sym_upcast] = ACTIONS(3946),
    [anon_sym_downcast] = ACTIONS(3946),
    [anon_sym_COLON_GT] = ACTIONS(3944),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3944),
    [anon_sym_for] = ACTIONS(3946),
    [anon_sym_while] = ACTIONS(3946),
    [anon_sym_if] = ACTIONS(3946),
    [anon_sym_fun] = ACTIONS(3946),
    [anon_sym_try] = ACTIONS(3946),
    [anon_sym_match] = ACTIONS(3946),
    [anon_sym_match_BANG] = ACTIONS(3944),
    [anon_sym_function] = ACTIONS(3946),
    [anon_sym_LT_DASH] = ACTIONS(3946),
    [anon_sym_DOT_LBRACK] = ACTIONS(3944),
    [anon_sym_LT] = ACTIONS(3944),
    [anon_sym_use] = ACTIONS(3946),
    [anon_sym_use_BANG] = ACTIONS(3944),
    [anon_sym_do_BANG] = ACTIONS(3944),
    [anon_sym_begin] = ACTIONS(3946),
    [anon_sym_LPAREN2] = ACTIONS(3946),
    [anon_sym_default] = ACTIONS(3946),
    [anon_sym_or] = ACTIONS(3946),
    [anon_sym_static] = ACTIONS(3946),
    [anon_sym_member] = ACTIONS(3946),
    [anon_sym_interface] = ACTIONS(3946),
    [anon_sym_exception] = ACTIONS(3946),
    [anon_sym_abstract] = ACTIONS(3946),
    [anon_sym_val] = ACTIONS(3946),
    [anon_sym_override] = ACTIONS(3946),
    [aux_sym_char_token1] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_AT_DQUOTE] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [sym_bool] = ACTIONS(3946),
    [sym_unit] = ACTIONS(3944),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3946),
    [sym_op_identifier] = ACTIONS(3946),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PLUS_DOT] = ACTIONS(3946),
    [anon_sym_DASH_DOT] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3946),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_TILDE] = ACTIONS(3944),
    [aux_sym_prefix_op_token1] = ACTIONS(3946),
    [aux_sym_infix_op_token1] = ACTIONS(3944),
    [aux_sym_infix_op_token2] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [anon_sym_BANG_EQ] = ACTIONS(3946),
    [anon_sym_COLON_EQ] = ACTIONS(3944),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3946),
    [sym_int] = ACTIONS(3946),
    [sym_xint] = ACTIONS(3944),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3944),
    [anon_sym_POUNDload] = ACTIONS(3944),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3944),
    [sym__newline] = ACTIONS(3944),
  },
  [1352] = {
    [sym_block_comment] = STATE(1352),
    [sym_compiler_directive_decl] = STATE(1352),
    [sym_fsi_directive_decl] = STATE(1352),
    [sym_preproc_line] = STATE(1352),
    [aux_sym_sequential_expression_repeat1] = STATE(1340),
    [ts_builtin_sym_end] = ACTIONS(3757),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_module] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_open] = ACTIONS(3759),
    [anon_sym_LBRACK_LT] = ACTIONS(3757),
    [anon_sym_COLON] = ACTIONS(3759),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_type] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_and] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_let_BANG] = ACTIONS(3757),
    [aux_sym_access_modifier_token1] = ACTIONS(3757),
    [anon_sym_LPAREN] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3757),
    [anon_sym_null] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3757),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_LT_AT] = ACTIONS(3759),
    [anon_sym_LT_AT_AT] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(3759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_with] = ACTIONS(3759),
    [anon_sym_return_BANG] = ACTIONS(3757),
    [anon_sym_yield] = ACTIONS(3759),
    [anon_sym_yield_BANG] = ACTIONS(3757),
    [anon_sym_lazy] = ACTIONS(3759),
    [anon_sym_assert] = ACTIONS(3759),
    [anon_sym_upcast] = ACTIONS(3759),
    [anon_sym_downcast] = ACTIONS(3759),
    [anon_sym_COLON_GT] = ACTIONS(3757),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3757),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_fun] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_match] = ACTIONS(3759),
    [anon_sym_match_BANG] = ACTIONS(3757),
    [anon_sym_function] = ACTIONS(3759),
    [anon_sym_LT_DASH] = ACTIONS(3759),
    [anon_sym_DOT_LBRACK] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_use] = ACTIONS(3759),
    [anon_sym_use_BANG] = ACTIONS(3757),
    [anon_sym_do_BANG] = ACTIONS(3757),
    [anon_sym_begin] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_default] = ACTIONS(3759),
    [anon_sym_or] = ACTIONS(3759),
    [anon_sym_static] = ACTIONS(3759),
    [anon_sym_member] = ACTIONS(3759),
    [anon_sym_interface] = ACTIONS(3759),
    [anon_sym_exception] = ACTIONS(3759),
    [anon_sym_abstract] = ACTIONS(3759),
    [anon_sym_val] = ACTIONS(3759),
    [anon_sym_override] = ACTIONS(3759),
    [aux_sym_char_token1] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3759),
    [anon_sym_DQUOTE] = ACTIONS(3759),
    [anon_sym_AT_DQUOTE] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [sym_bool] = ACTIONS(3759),
    [sym_unit] = ACTIONS(3757),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3759),
    [sym_op_identifier] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS_DOT] = ACTIONS(3759),
    [anon_sym_DASH_DOT] = ACTIONS(3759),
    [anon_sym_PERCENT] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_TILDE] = ACTIONS(3757),
    [aux_sym_prefix_op_token1] = ACTIONS(3759),
    [aux_sym_infix_op_token1] = ACTIONS(3757),
    [aux_sym_infix_op_token2] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_COLON_EQ] = ACTIONS(3757),
    [anon_sym_DOLLAR] = ACTIONS(3759),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3759),
    [sym_int] = ACTIONS(3759),
    [sym_xint] = ACTIONS(3757),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3757),
    [anon_sym_POUNDload] = ACTIONS(3757),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3757),
    [sym__newline] = ACTIONS(3757),
  },
  [1353] = {
    [sym_block_comment] = STATE(1353),
    [sym_compiler_directive_decl] = STATE(1353),
    [sym_fsi_directive_decl] = STATE(1353),
    [sym_preproc_line] = STATE(1353),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_LBRACK_LT] = ACTIONS(3513),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [aux_sym_access_modifier_token1] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_COLON] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_with] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(3513),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_LT_DASH] = ACTIONS(3515),
    [anon_sym_DOT_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3515),
    [anon_sym_or] = ACTIONS(3515),
    [anon_sym_static] = ACTIONS(3515),
    [anon_sym_member] = ACTIONS(3515),
    [anon_sym_interface] = ACTIONS(3515),
    [anon_sym_abstract] = ACTIONS(3515),
    [anon_sym_val] = ACTIONS(3515),
    [anon_sym_override] = ACTIONS(3515),
    [anon_sym_inherit] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3515),
    [anon_sym_DASH_DOT] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3515),
    [aux_sym_infix_op_token1] = ACTIONS(3513),
    [aux_sym_infix_op_token2] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3515),
    [anon_sym_COLON_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(3515),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3515),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [anon_sym_POUNDendif] = ACTIONS(3513),
    [anon_sym_POUNDelse] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
  },
  [1354] = {
    [sym_block_comment] = STATE(1354),
    [sym_compiler_directive_decl] = STATE(1354),
    [sym_fsi_directive_decl] = STATE(1354),
    [sym_preproc_line] = STATE(1354),
    [sym_identifier] = ACTIONS(3539),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_LBRACK_LT] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3539),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_do] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3539),
    [anon_sym_let_BANG] = ACTIONS(3537),
    [aux_sym_access_modifier_token1] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_null] = ACTIONS(3539),
    [anon_sym_QMARK] = ACTIONS(3539),
    [anon_sym_COLON_QMARK] = ACTIONS(3539),
    [anon_sym_COLON_COLON] = ACTIONS(3537),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3537),
    [anon_sym_LBRACE] = ACTIONS(3539),
    [anon_sym_LT_AT] = ACTIONS(3539),
    [anon_sym_LT_AT_AT] = ACTIONS(3539),
    [anon_sym_DOT] = ACTIONS(3539),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3537),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_with] = ACTIONS(3539),
    [anon_sym_return_BANG] = ACTIONS(3537),
    [anon_sym_yield] = ACTIONS(3539),
    [anon_sym_yield_BANG] = ACTIONS(3537),
    [anon_sym_lazy] = ACTIONS(3539),
    [anon_sym_assert] = ACTIONS(3539),
    [anon_sym_upcast] = ACTIONS(3539),
    [anon_sym_downcast] = ACTIONS(3539),
    [anon_sym_COLON_GT] = ACTIONS(3537),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3537),
    [anon_sym_for] = ACTIONS(3539),
    [anon_sym_while] = ACTIONS(3539),
    [anon_sym_if] = ACTIONS(3539),
    [anon_sym_fun] = ACTIONS(3539),
    [anon_sym_DASH_GT] = ACTIONS(3539),
    [anon_sym_try] = ACTIONS(3539),
    [anon_sym_match] = ACTIONS(3539),
    [anon_sym_match_BANG] = ACTIONS(3537),
    [anon_sym_function] = ACTIONS(3539),
    [anon_sym_LT_DASH] = ACTIONS(3539),
    [anon_sym_DOT_LBRACK] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_use] = ACTIONS(3539),
    [anon_sym_use_BANG] = ACTIONS(3537),
    [anon_sym_do_BANG] = ACTIONS(3537),
    [anon_sym_begin] = ACTIONS(3539),
    [anon_sym_LPAREN2] = ACTIONS(3539),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_LT2] = ACTIONS(3539),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_default] = ACTIONS(3539),
    [anon_sym_or] = ACTIONS(3539),
    [anon_sym_static] = ACTIONS(3539),
    [anon_sym_member] = ACTIONS(3539),
    [anon_sym_interface] = ACTIONS(3539),
    [anon_sym_abstract] = ACTIONS(3539),
    [anon_sym_val] = ACTIONS(3539),
    [anon_sym_override] = ACTIONS(3539),
    [anon_sym_inherit] = ACTIONS(3539),
    [aux_sym_char_token1] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3539),
    [anon_sym_DQUOTE] = ACTIONS(3539),
    [anon_sym_AT_DQUOTE] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [sym_bool] = ACTIONS(3539),
    [sym_unit] = ACTIONS(3537),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3539),
    [sym_op_identifier] = ACTIONS(3539),
    [anon_sym_PLUS] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(3539),
    [anon_sym_PLUS_DOT] = ACTIONS(3539),
    [anon_sym_DASH_DOT] = ACTIONS(3539),
    [anon_sym_PERCENT] = ACTIONS(3539),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_TILDE] = ACTIONS(3537),
    [aux_sym_prefix_op_token1] = ACTIONS(3539),
    [aux_sym_infix_op_token1] = ACTIONS(3537),
    [aux_sym_infix_op_token2] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3539),
    [anon_sym_BANG_EQ] = ACTIONS(3539),
    [anon_sym_COLON_EQ] = ACTIONS(3537),
    [anon_sym_DOLLAR] = ACTIONS(3539),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3539),
    [sym_int] = ACTIONS(3539),
    [sym_xint] = ACTIONS(3537),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3537),
    [anon_sym_POUNDendif] = ACTIONS(3537),
    [anon_sym_POUNDelse] = ACTIONS(3537),
    [sym__newline] = ACTIONS(3537),
  },
  [1355] = {
    [sym_block_comment] = STATE(1355),
    [sym_compiler_directive_decl] = STATE(1355),
    [sym_fsi_directive_decl] = STATE(1355),
    [sym_preproc_line] = STATE(1355),
    [ts_builtin_sym_end] = ACTIONS(3948),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_namespace] = ACTIONS(3950),
    [anon_sym_module] = ACTIONS(3950),
    [anon_sym_EQ] = ACTIONS(3948),
    [anon_sym_open] = ACTIONS(3950),
    [anon_sym_LBRACK_LT] = ACTIONS(3948),
    [anon_sym_COLON] = ACTIONS(3950),
    [anon_sym_return] = ACTIONS(3950),
    [anon_sym_type] = ACTIONS(3950),
    [anon_sym_do] = ACTIONS(3950),
    [anon_sym_and] = ACTIONS(3950),
    [anon_sym_let] = ACTIONS(3950),
    [anon_sym_let_BANG] = ACTIONS(3948),
    [aux_sym_access_modifier_token1] = ACTIONS(3948),
    [anon_sym_LPAREN] = ACTIONS(3950),
    [anon_sym_COMMA] = ACTIONS(3948),
    [anon_sym_null] = ACTIONS(3950),
    [anon_sym_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_COLON] = ACTIONS(3948),
    [anon_sym_AMP] = ACTIONS(3950),
    [anon_sym_LBRACK] = ACTIONS(3950),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3948),
    [anon_sym_LBRACE] = ACTIONS(3950),
    [anon_sym_LT_AT] = ACTIONS(3950),
    [anon_sym_LT_AT_AT] = ACTIONS(3950),
    [anon_sym_DOT] = ACTIONS(3950),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3948),
    [anon_sym_new] = ACTIONS(3950),
    [anon_sym_with] = ACTIONS(3950),
    [anon_sym_return_BANG] = ACTIONS(3948),
    [anon_sym_yield] = ACTIONS(3950),
    [anon_sym_yield_BANG] = ACTIONS(3948),
    [anon_sym_lazy] = ACTIONS(3950),
    [anon_sym_assert] = ACTIONS(3950),
    [anon_sym_upcast] = ACTIONS(3950),
    [anon_sym_downcast] = ACTIONS(3950),
    [anon_sym_COLON_GT] = ACTIONS(3948),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3948),
    [anon_sym_for] = ACTIONS(3950),
    [anon_sym_while] = ACTIONS(3950),
    [anon_sym_if] = ACTIONS(3950),
    [anon_sym_fun] = ACTIONS(3950),
    [anon_sym_try] = ACTIONS(3950),
    [anon_sym_match] = ACTIONS(3950),
    [anon_sym_match_BANG] = ACTIONS(3948),
    [anon_sym_function] = ACTIONS(3950),
    [anon_sym_LT_DASH] = ACTIONS(3950),
    [anon_sym_DOT_LBRACK] = ACTIONS(3948),
    [anon_sym_LT] = ACTIONS(3948),
    [anon_sym_use] = ACTIONS(3950),
    [anon_sym_use_BANG] = ACTIONS(3948),
    [anon_sym_do_BANG] = ACTIONS(3948),
    [anon_sym_begin] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3950),
    [anon_sym_default] = ACTIONS(3950),
    [anon_sym_or] = ACTIONS(3950),
    [anon_sym_static] = ACTIONS(3950),
    [anon_sym_member] = ACTIONS(3950),
    [anon_sym_interface] = ACTIONS(3950),
    [anon_sym_exception] = ACTIONS(3950),
    [anon_sym_abstract] = ACTIONS(3950),
    [anon_sym_val] = ACTIONS(3950),
    [anon_sym_override] = ACTIONS(3950),
    [aux_sym_char_token1] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3950),
    [anon_sym_DQUOTE] = ACTIONS(3950),
    [anon_sym_AT_DQUOTE] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [sym_bool] = ACTIONS(3950),
    [sym_unit] = ACTIONS(3948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3950),
    [sym_op_identifier] = ACTIONS(3950),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_DASH] = ACTIONS(3950),
    [anon_sym_PLUS_DOT] = ACTIONS(3950),
    [anon_sym_DASH_DOT] = ACTIONS(3950),
    [anon_sym_PERCENT] = ACTIONS(3950),
    [anon_sym_AMP_AMP] = ACTIONS(3950),
    [anon_sym_TILDE] = ACTIONS(3948),
    [aux_sym_prefix_op_token1] = ACTIONS(3950),
    [aux_sym_infix_op_token1] = ACTIONS(3948),
    [aux_sym_infix_op_token2] = ACTIONS(3950),
    [anon_sym_PIPE_PIPE] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3950),
    [anon_sym_COLON_EQ] = ACTIONS(3948),
    [anon_sym_DOLLAR] = ACTIONS(3950),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3950),
    [sym_int] = ACTIONS(3950),
    [sym_xint] = ACTIONS(3948),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3948),
    [anon_sym_POUNDload] = ACTIONS(3948),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3948),
    [sym__newline] = ACTIONS(3948),
  },
  [1356] = {
    [sym_block_comment] = STATE(1356),
    [sym_compiler_directive_decl] = STATE(1356),
    [sym_fsi_directive_decl] = STATE(1356),
    [sym_preproc_line] = STATE(1356),
    [ts_builtin_sym_end] = ACTIONS(3952),
    [sym_identifier] = ACTIONS(3954),
    [anon_sym_namespace] = ACTIONS(3954),
    [anon_sym_module] = ACTIONS(3954),
    [anon_sym_EQ] = ACTIONS(3952),
    [anon_sym_open] = ACTIONS(3954),
    [anon_sym_LBRACK_LT] = ACTIONS(3952),
    [anon_sym_COLON] = ACTIONS(3954),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_type] = ACTIONS(3954),
    [anon_sym_do] = ACTIONS(3954),
    [anon_sym_and] = ACTIONS(3954),
    [anon_sym_let] = ACTIONS(3954),
    [anon_sym_let_BANG] = ACTIONS(3952),
    [aux_sym_access_modifier_token1] = ACTIONS(3952),
    [anon_sym_LPAREN] = ACTIONS(3954),
    [anon_sym_COMMA] = ACTIONS(3952),
    [anon_sym_null] = ACTIONS(3954),
    [anon_sym_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_COLON] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3954),
    [anon_sym_LBRACK] = ACTIONS(3954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(3954),
    [anon_sym_LT_AT] = ACTIONS(3954),
    [anon_sym_LT_AT_AT] = ACTIONS(3954),
    [anon_sym_DOT] = ACTIONS(3954),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3952),
    [anon_sym_new] = ACTIONS(3954),
    [anon_sym_with] = ACTIONS(3954),
    [anon_sym_return_BANG] = ACTIONS(3952),
    [anon_sym_yield] = ACTIONS(3954),
    [anon_sym_yield_BANG] = ACTIONS(3952),
    [anon_sym_lazy] = ACTIONS(3954),
    [anon_sym_assert] = ACTIONS(3954),
    [anon_sym_upcast] = ACTIONS(3954),
    [anon_sym_downcast] = ACTIONS(3954),
    [anon_sym_COLON_GT] = ACTIONS(3952),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3952),
    [anon_sym_for] = ACTIONS(3954),
    [anon_sym_while] = ACTIONS(3954),
    [anon_sym_if] = ACTIONS(3954),
    [anon_sym_fun] = ACTIONS(3954),
    [anon_sym_try] = ACTIONS(3954),
    [anon_sym_match] = ACTIONS(3954),
    [anon_sym_match_BANG] = ACTIONS(3952),
    [anon_sym_function] = ACTIONS(3954),
    [anon_sym_LT_DASH] = ACTIONS(3954),
    [anon_sym_DOT_LBRACK] = ACTIONS(3952),
    [anon_sym_LT] = ACTIONS(3952),
    [anon_sym_use] = ACTIONS(3954),
    [anon_sym_use_BANG] = ACTIONS(3952),
    [anon_sym_do_BANG] = ACTIONS(3952),
    [anon_sym_begin] = ACTIONS(3954),
    [anon_sym_LPAREN2] = ACTIONS(3954),
    [anon_sym_default] = ACTIONS(3954),
    [anon_sym_or] = ACTIONS(3954),
    [anon_sym_static] = ACTIONS(3954),
    [anon_sym_member] = ACTIONS(3954),
    [anon_sym_interface] = ACTIONS(3954),
    [anon_sym_exception] = ACTIONS(3954),
    [anon_sym_abstract] = ACTIONS(3954),
    [anon_sym_val] = ACTIONS(3954),
    [anon_sym_override] = ACTIONS(3954),
    [aux_sym_char_token1] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3954),
    [anon_sym_DQUOTE] = ACTIONS(3954),
    [anon_sym_AT_DQUOTE] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [sym_bool] = ACTIONS(3954),
    [sym_unit] = ACTIONS(3952),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3954),
    [sym_op_identifier] = ACTIONS(3954),
    [anon_sym_PLUS] = ACTIONS(3954),
    [anon_sym_DASH] = ACTIONS(3954),
    [anon_sym_PLUS_DOT] = ACTIONS(3954),
    [anon_sym_DASH_DOT] = ACTIONS(3954),
    [anon_sym_PERCENT] = ACTIONS(3954),
    [anon_sym_AMP_AMP] = ACTIONS(3954),
    [anon_sym_TILDE] = ACTIONS(3952),
    [aux_sym_prefix_op_token1] = ACTIONS(3954),
    [aux_sym_infix_op_token1] = ACTIONS(3952),
    [aux_sym_infix_op_token2] = ACTIONS(3954),
    [anon_sym_PIPE_PIPE] = ACTIONS(3954),
    [anon_sym_BANG_EQ] = ACTIONS(3954),
    [anon_sym_COLON_EQ] = ACTIONS(3952),
    [anon_sym_DOLLAR] = ACTIONS(3954),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3954),
    [sym_int] = ACTIONS(3954),
    [sym_xint] = ACTIONS(3952),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3952),
    [anon_sym_POUNDload] = ACTIONS(3952),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3952),
    [sym__newline] = ACTIONS(3952),
  },
  [1357] = {
    [sym_block_comment] = STATE(1357),
    [sym_compiler_directive_decl] = STATE(1357),
    [sym_fsi_directive_decl] = STATE(1357),
    [sym_preproc_line] = STATE(1357),
    [ts_builtin_sym_end] = ACTIONS(3956),
    [sym_identifier] = ACTIONS(3958),
    [anon_sym_namespace] = ACTIONS(3958),
    [anon_sym_module] = ACTIONS(3958),
    [anon_sym_EQ] = ACTIONS(3956),
    [anon_sym_open] = ACTIONS(3958),
    [anon_sym_LBRACK_LT] = ACTIONS(3956),
    [anon_sym_COLON] = ACTIONS(3958),
    [anon_sym_return] = ACTIONS(3958),
    [anon_sym_type] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(3958),
    [anon_sym_and] = ACTIONS(3958),
    [anon_sym_let] = ACTIONS(3958),
    [anon_sym_let_BANG] = ACTIONS(3956),
    [aux_sym_access_modifier_token1] = ACTIONS(3956),
    [anon_sym_LPAREN] = ACTIONS(3958),
    [anon_sym_COMMA] = ACTIONS(3956),
    [anon_sym_null] = ACTIONS(3958),
    [anon_sym_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_COLON] = ACTIONS(3956),
    [anon_sym_AMP] = ACTIONS(3958),
    [anon_sym_LBRACK] = ACTIONS(3958),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3956),
    [anon_sym_LBRACE] = ACTIONS(3958),
    [anon_sym_LT_AT] = ACTIONS(3958),
    [anon_sym_LT_AT_AT] = ACTIONS(3958),
    [anon_sym_DOT] = ACTIONS(3958),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3956),
    [anon_sym_new] = ACTIONS(3958),
    [anon_sym_with] = ACTIONS(3958),
    [anon_sym_return_BANG] = ACTIONS(3956),
    [anon_sym_yield] = ACTIONS(3958),
    [anon_sym_yield_BANG] = ACTIONS(3956),
    [anon_sym_lazy] = ACTIONS(3958),
    [anon_sym_assert] = ACTIONS(3958),
    [anon_sym_upcast] = ACTIONS(3958),
    [anon_sym_downcast] = ACTIONS(3958),
    [anon_sym_COLON_GT] = ACTIONS(3956),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3956),
    [anon_sym_for] = ACTIONS(3958),
    [anon_sym_while] = ACTIONS(3958),
    [anon_sym_if] = ACTIONS(3958),
    [anon_sym_fun] = ACTIONS(3958),
    [anon_sym_try] = ACTIONS(3958),
    [anon_sym_match] = ACTIONS(3958),
    [anon_sym_match_BANG] = ACTIONS(3956),
    [anon_sym_function] = ACTIONS(3958),
    [anon_sym_LT_DASH] = ACTIONS(3958),
    [anon_sym_DOT_LBRACK] = ACTIONS(3956),
    [anon_sym_LT] = ACTIONS(3956),
    [anon_sym_use] = ACTIONS(3958),
    [anon_sym_use_BANG] = ACTIONS(3956),
    [anon_sym_do_BANG] = ACTIONS(3956),
    [anon_sym_begin] = ACTIONS(3958),
    [anon_sym_LPAREN2] = ACTIONS(3958),
    [anon_sym_default] = ACTIONS(3958),
    [anon_sym_or] = ACTIONS(3958),
    [anon_sym_static] = ACTIONS(3958),
    [anon_sym_member] = ACTIONS(3958),
    [anon_sym_interface] = ACTIONS(3958),
    [anon_sym_exception] = ACTIONS(3958),
    [anon_sym_abstract] = ACTIONS(3958),
    [anon_sym_val] = ACTIONS(3958),
    [anon_sym_override] = ACTIONS(3958),
    [aux_sym_char_token1] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [anon_sym_AT_DQUOTE] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [sym_bool] = ACTIONS(3958),
    [sym_unit] = ACTIONS(3956),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3958),
    [sym_op_identifier] = ACTIONS(3958),
    [anon_sym_PLUS] = ACTIONS(3958),
    [anon_sym_DASH] = ACTIONS(3958),
    [anon_sym_PLUS_DOT] = ACTIONS(3958),
    [anon_sym_DASH_DOT] = ACTIONS(3958),
    [anon_sym_PERCENT] = ACTIONS(3958),
    [anon_sym_AMP_AMP] = ACTIONS(3958),
    [anon_sym_TILDE] = ACTIONS(3956),
    [aux_sym_prefix_op_token1] = ACTIONS(3958),
    [aux_sym_infix_op_token1] = ACTIONS(3956),
    [aux_sym_infix_op_token2] = ACTIONS(3958),
    [anon_sym_PIPE_PIPE] = ACTIONS(3958),
    [anon_sym_BANG_EQ] = ACTIONS(3958),
    [anon_sym_COLON_EQ] = ACTIONS(3956),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3958),
    [sym_int] = ACTIONS(3958),
    [sym_xint] = ACTIONS(3956),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3956),
    [anon_sym_POUNDload] = ACTIONS(3956),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3956),
    [sym__newline] = ACTIONS(3956),
  },
  [1358] = {
    [sym_block_comment] = STATE(1358),
    [sym_compiler_directive_decl] = STATE(1358),
    [sym_fsi_directive_decl] = STATE(1358),
    [sym_preproc_line] = STATE(1358),
    [ts_builtin_sym_end] = ACTIONS(3960),
    [sym_identifier] = ACTIONS(3962),
    [anon_sym_namespace] = ACTIONS(3962),
    [anon_sym_module] = ACTIONS(3962),
    [anon_sym_EQ] = ACTIONS(3960),
    [anon_sym_open] = ACTIONS(3962),
    [anon_sym_LBRACK_LT] = ACTIONS(3960),
    [anon_sym_COLON] = ACTIONS(3962),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_type] = ACTIONS(3962),
    [anon_sym_do] = ACTIONS(3962),
    [anon_sym_and] = ACTIONS(3962),
    [anon_sym_let] = ACTIONS(3962),
    [anon_sym_let_BANG] = ACTIONS(3960),
    [aux_sym_access_modifier_token1] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_COMMA] = ACTIONS(3960),
    [anon_sym_null] = ACTIONS(3962),
    [anon_sym_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_COLON] = ACTIONS(3960),
    [anon_sym_AMP] = ACTIONS(3962),
    [anon_sym_LBRACK] = ACTIONS(3962),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_LT_AT] = ACTIONS(3962),
    [anon_sym_LT_AT_AT] = ACTIONS(3962),
    [anon_sym_DOT] = ACTIONS(3962),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3960),
    [anon_sym_new] = ACTIONS(3962),
    [anon_sym_with] = ACTIONS(3962),
    [anon_sym_return_BANG] = ACTIONS(3960),
    [anon_sym_yield] = ACTIONS(3962),
    [anon_sym_yield_BANG] = ACTIONS(3960),
    [anon_sym_lazy] = ACTIONS(3962),
    [anon_sym_assert] = ACTIONS(3962),
    [anon_sym_upcast] = ACTIONS(3962),
    [anon_sym_downcast] = ACTIONS(3962),
    [anon_sym_COLON_GT] = ACTIONS(3960),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3960),
    [anon_sym_for] = ACTIONS(3962),
    [anon_sym_while] = ACTIONS(3962),
    [anon_sym_if] = ACTIONS(3962),
    [anon_sym_fun] = ACTIONS(3962),
    [anon_sym_try] = ACTIONS(3962),
    [anon_sym_match] = ACTIONS(3962),
    [anon_sym_match_BANG] = ACTIONS(3960),
    [anon_sym_function] = ACTIONS(3962),
    [anon_sym_LT_DASH] = ACTIONS(3962),
    [anon_sym_DOT_LBRACK] = ACTIONS(3960),
    [anon_sym_LT] = ACTIONS(3960),
    [anon_sym_use] = ACTIONS(3962),
    [anon_sym_use_BANG] = ACTIONS(3960),
    [anon_sym_do_BANG] = ACTIONS(3960),
    [anon_sym_begin] = ACTIONS(3962),
    [anon_sym_LPAREN2] = ACTIONS(3962),
    [anon_sym_default] = ACTIONS(3962),
    [anon_sym_or] = ACTIONS(3962),
    [anon_sym_static] = ACTIONS(3962),
    [anon_sym_member] = ACTIONS(3962),
    [anon_sym_interface] = ACTIONS(3962),
    [anon_sym_exception] = ACTIONS(3962),
    [anon_sym_abstract] = ACTIONS(3962),
    [anon_sym_val] = ACTIONS(3962),
    [anon_sym_override] = ACTIONS(3962),
    [aux_sym_char_token1] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3962),
    [anon_sym_DQUOTE] = ACTIONS(3962),
    [anon_sym_AT_DQUOTE] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [sym_bool] = ACTIONS(3962),
    [sym_unit] = ACTIONS(3960),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3962),
    [sym_op_identifier] = ACTIONS(3962),
    [anon_sym_PLUS] = ACTIONS(3962),
    [anon_sym_DASH] = ACTIONS(3962),
    [anon_sym_PLUS_DOT] = ACTIONS(3962),
    [anon_sym_DASH_DOT] = ACTIONS(3962),
    [anon_sym_PERCENT] = ACTIONS(3962),
    [anon_sym_AMP_AMP] = ACTIONS(3962),
    [anon_sym_TILDE] = ACTIONS(3960),
    [aux_sym_prefix_op_token1] = ACTIONS(3962),
    [aux_sym_infix_op_token1] = ACTIONS(3960),
    [aux_sym_infix_op_token2] = ACTIONS(3962),
    [anon_sym_PIPE_PIPE] = ACTIONS(3962),
    [anon_sym_BANG_EQ] = ACTIONS(3962),
    [anon_sym_COLON_EQ] = ACTIONS(3960),
    [anon_sym_DOLLAR] = ACTIONS(3962),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3962),
    [sym_int] = ACTIONS(3962),
    [sym_xint] = ACTIONS(3960),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3960),
    [anon_sym_POUNDload] = ACTIONS(3960),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3960),
    [sym__newline] = ACTIONS(3960),
  },
  [1359] = {
    [sym_block_comment] = STATE(1359),
    [sym_compiler_directive_decl] = STATE(1359),
    [sym_fsi_directive_decl] = STATE(1359),
    [sym_preproc_line] = STATE(1359),
    [ts_builtin_sym_end] = ACTIONS(3964),
    [sym_identifier] = ACTIONS(3966),
    [anon_sym_namespace] = ACTIONS(3966),
    [anon_sym_module] = ACTIONS(3966),
    [anon_sym_EQ] = ACTIONS(3964),
    [anon_sym_open] = ACTIONS(3966),
    [anon_sym_LBRACK_LT] = ACTIONS(3964),
    [anon_sym_COLON] = ACTIONS(3966),
    [anon_sym_return] = ACTIONS(3966),
    [anon_sym_type] = ACTIONS(3966),
    [anon_sym_do] = ACTIONS(3966),
    [anon_sym_and] = ACTIONS(3966),
    [anon_sym_let] = ACTIONS(3966),
    [anon_sym_let_BANG] = ACTIONS(3964),
    [aux_sym_access_modifier_token1] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COMMA] = ACTIONS(3964),
    [anon_sym_null] = ACTIONS(3966),
    [anon_sym_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(3964),
    [anon_sym_AMP] = ACTIONS(3966),
    [anon_sym_LBRACK] = ACTIONS(3966),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3964),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_LT_AT] = ACTIONS(3966),
    [anon_sym_LT_AT_AT] = ACTIONS(3966),
    [anon_sym_DOT] = ACTIONS(3966),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3964),
    [anon_sym_new] = ACTIONS(3966),
    [anon_sym_with] = ACTIONS(3966),
    [anon_sym_return_BANG] = ACTIONS(3964),
    [anon_sym_yield] = ACTIONS(3966),
    [anon_sym_yield_BANG] = ACTIONS(3964),
    [anon_sym_lazy] = ACTIONS(3966),
    [anon_sym_assert] = ACTIONS(3966),
    [anon_sym_upcast] = ACTIONS(3966),
    [anon_sym_downcast] = ACTIONS(3966),
    [anon_sym_COLON_GT] = ACTIONS(3964),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3964),
    [anon_sym_for] = ACTIONS(3966),
    [anon_sym_while] = ACTIONS(3966),
    [anon_sym_if] = ACTIONS(3966),
    [anon_sym_fun] = ACTIONS(3966),
    [anon_sym_try] = ACTIONS(3966),
    [anon_sym_match] = ACTIONS(3966),
    [anon_sym_match_BANG] = ACTIONS(3964),
    [anon_sym_function] = ACTIONS(3966),
    [anon_sym_LT_DASH] = ACTIONS(3966),
    [anon_sym_DOT_LBRACK] = ACTIONS(3964),
    [anon_sym_LT] = ACTIONS(3964),
    [anon_sym_use] = ACTIONS(3966),
    [anon_sym_use_BANG] = ACTIONS(3964),
    [anon_sym_do_BANG] = ACTIONS(3964),
    [anon_sym_begin] = ACTIONS(3966),
    [anon_sym_LPAREN2] = ACTIONS(3966),
    [anon_sym_default] = ACTIONS(3966),
    [anon_sym_or] = ACTIONS(3966),
    [anon_sym_static] = ACTIONS(3966),
    [anon_sym_member] = ACTIONS(3966),
    [anon_sym_interface] = ACTIONS(3966),
    [anon_sym_exception] = ACTIONS(3966),
    [anon_sym_abstract] = ACTIONS(3966),
    [anon_sym_val] = ACTIONS(3966),
    [anon_sym_override] = ACTIONS(3966),
    [aux_sym_char_token1] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3966),
    [anon_sym_DQUOTE] = ACTIONS(3966),
    [anon_sym_AT_DQUOTE] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [sym_bool] = ACTIONS(3966),
    [sym_unit] = ACTIONS(3964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3966),
    [sym_op_identifier] = ACTIONS(3966),
    [anon_sym_PLUS] = ACTIONS(3966),
    [anon_sym_DASH] = ACTIONS(3966),
    [anon_sym_PLUS_DOT] = ACTIONS(3966),
    [anon_sym_DASH_DOT] = ACTIONS(3966),
    [anon_sym_PERCENT] = ACTIONS(3966),
    [anon_sym_AMP_AMP] = ACTIONS(3966),
    [anon_sym_TILDE] = ACTIONS(3964),
    [aux_sym_prefix_op_token1] = ACTIONS(3966),
    [aux_sym_infix_op_token1] = ACTIONS(3964),
    [aux_sym_infix_op_token2] = ACTIONS(3966),
    [anon_sym_PIPE_PIPE] = ACTIONS(3966),
    [anon_sym_BANG_EQ] = ACTIONS(3966),
    [anon_sym_COLON_EQ] = ACTIONS(3964),
    [anon_sym_DOLLAR] = ACTIONS(3966),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3966),
    [sym_int] = ACTIONS(3966),
    [sym_xint] = ACTIONS(3964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3964),
    [anon_sym_POUNDload] = ACTIONS(3964),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3964),
    [sym__newline] = ACTIONS(3964),
  },
  [1360] = {
    [sym_block_comment] = STATE(1360),
    [sym_compiler_directive_decl] = STATE(1360),
    [sym_fsi_directive_decl] = STATE(1360),
    [sym_preproc_line] = STATE(1360),
    [sym_identifier] = ACTIONS(3547),
    [anon_sym_EQ] = ACTIONS(3545),
    [anon_sym_LBRACK_LT] = ACTIONS(3545),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_return] = ACTIONS(3547),
    [anon_sym_do] = ACTIONS(3547),
    [anon_sym_let] = ACTIONS(3547),
    [anon_sym_let_BANG] = ACTIONS(3545),
    [aux_sym_access_modifier_token1] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(3547),
    [anon_sym_COMMA] = ACTIONS(3545),
    [anon_sym_null] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3547),
    [anon_sym_COLON_QMARK] = ACTIONS(3547),
    [anon_sym_COLON_COLON] = ACTIONS(3545),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3545),
    [anon_sym_LBRACE] = ACTIONS(3547),
    [anon_sym_LT_AT] = ACTIONS(3547),
    [anon_sym_LT_AT_AT] = ACTIONS(3547),
    [anon_sym_DOT] = ACTIONS(3547),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3545),
    [anon_sym_new] = ACTIONS(3547),
    [anon_sym_with] = ACTIONS(3547),
    [anon_sym_return_BANG] = ACTIONS(3545),
    [anon_sym_yield] = ACTIONS(3547),
    [anon_sym_yield_BANG] = ACTIONS(3545),
    [anon_sym_lazy] = ACTIONS(3547),
    [anon_sym_assert] = ACTIONS(3547),
    [anon_sym_upcast] = ACTIONS(3547),
    [anon_sym_downcast] = ACTIONS(3547),
    [anon_sym_COLON_GT] = ACTIONS(3545),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3545),
    [anon_sym_for] = ACTIONS(3547),
    [anon_sym_while] = ACTIONS(3547),
    [anon_sym_if] = ACTIONS(3547),
    [anon_sym_fun] = ACTIONS(3547),
    [anon_sym_DASH_GT] = ACTIONS(3547),
    [anon_sym_try] = ACTIONS(3547),
    [anon_sym_match] = ACTIONS(3547),
    [anon_sym_match_BANG] = ACTIONS(3545),
    [anon_sym_function] = ACTIONS(3547),
    [anon_sym_LT_DASH] = ACTIONS(3547),
    [anon_sym_DOT_LBRACK] = ACTIONS(3545),
    [anon_sym_LT] = ACTIONS(3545),
    [anon_sym_use] = ACTIONS(3547),
    [anon_sym_use_BANG] = ACTIONS(3545),
    [anon_sym_do_BANG] = ACTIONS(3545),
    [anon_sym_begin] = ACTIONS(3547),
    [anon_sym_LPAREN2] = ACTIONS(3547),
    [anon_sym_STAR] = ACTIONS(3547),
    [anon_sym_LT2] = ACTIONS(3547),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_default] = ACTIONS(3547),
    [anon_sym_or] = ACTIONS(3547),
    [anon_sym_static] = ACTIONS(3547),
    [anon_sym_member] = ACTIONS(3547),
    [anon_sym_interface] = ACTIONS(3547),
    [anon_sym_abstract] = ACTIONS(3547),
    [anon_sym_val] = ACTIONS(3547),
    [anon_sym_override] = ACTIONS(3547),
    [anon_sym_inherit] = ACTIONS(3547),
    [aux_sym_char_token1] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3547),
    [anon_sym_DQUOTE] = ACTIONS(3547),
    [anon_sym_AT_DQUOTE] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [sym_bool] = ACTIONS(3547),
    [sym_unit] = ACTIONS(3545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3547),
    [sym_op_identifier] = ACTIONS(3547),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PLUS_DOT] = ACTIONS(3547),
    [anon_sym_DASH_DOT] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3547),
    [anon_sym_AMP_AMP] = ACTIONS(3547),
    [anon_sym_TILDE] = ACTIONS(3545),
    [aux_sym_prefix_op_token1] = ACTIONS(3547),
    [aux_sym_infix_op_token1] = ACTIONS(3545),
    [aux_sym_infix_op_token2] = ACTIONS(3547),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_BANG_EQ] = ACTIONS(3547),
    [anon_sym_COLON_EQ] = ACTIONS(3545),
    [anon_sym_DOLLAR] = ACTIONS(3547),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3547),
    [sym_int] = ACTIONS(3547),
    [sym_xint] = ACTIONS(3545),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3545),
    [anon_sym_POUNDendif] = ACTIONS(3545),
    [anon_sym_POUNDelse] = ACTIONS(3545),
    [sym__newline] = ACTIONS(3545),
  },
  [1361] = {
    [sym_block_comment] = STATE(1361),
    [sym_compiler_directive_decl] = STATE(1361),
    [sym_fsi_directive_decl] = STATE(1361),
    [sym_preproc_line] = STATE(1361),
    [aux_sym_compound_type_repeat1] = STATE(1335),
    [sym_identifier] = ACTIONS(3468),
    [anon_sym_EQ] = ACTIONS(3466),
    [anon_sym_LBRACK_LT] = ACTIONS(3466),
    [anon_sym_COLON] = ACTIONS(3468),
    [anon_sym_return] = ACTIONS(3468),
    [anon_sym_do] = ACTIONS(3468),
    [anon_sym_let] = ACTIONS(3468),
    [anon_sym_let_BANG] = ACTIONS(3466),
    [aux_sym_access_modifier_token1] = ACTIONS(3466),
    [anon_sym_LPAREN] = ACTIONS(3468),
    [anon_sym_COMMA] = ACTIONS(3466),
    [anon_sym_null] = ACTIONS(3468),
    [anon_sym_QMARK] = ACTIONS(3468),
    [anon_sym_COLON_QMARK] = ACTIONS(3468),
    [anon_sym_COLON_COLON] = ACTIONS(3466),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LBRACK] = ACTIONS(3468),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3466),
    [anon_sym_LBRACE] = ACTIONS(3468),
    [anon_sym_LT_AT] = ACTIONS(3468),
    [anon_sym_LT_AT_AT] = ACTIONS(3468),
    [anon_sym_DOT] = ACTIONS(3468),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3466),
    [anon_sym_new] = ACTIONS(3468),
    [anon_sym_with] = ACTIONS(3468),
    [anon_sym_return_BANG] = ACTIONS(3466),
    [anon_sym_yield] = ACTIONS(3468),
    [anon_sym_yield_BANG] = ACTIONS(3466),
    [anon_sym_lazy] = ACTIONS(3468),
    [anon_sym_assert] = ACTIONS(3468),
    [anon_sym_upcast] = ACTIONS(3468),
    [anon_sym_downcast] = ACTIONS(3468),
    [anon_sym_COLON_GT] = ACTIONS(3466),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3466),
    [anon_sym_for] = ACTIONS(3468),
    [anon_sym_while] = ACTIONS(3468),
    [anon_sym_if] = ACTIONS(3468),
    [anon_sym_fun] = ACTIONS(3468),
    [anon_sym_DASH_GT] = ACTIONS(3468),
    [anon_sym_try] = ACTIONS(3468),
    [anon_sym_match] = ACTIONS(3468),
    [anon_sym_match_BANG] = ACTIONS(3466),
    [anon_sym_function] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3468),
    [anon_sym_DOT_LBRACK] = ACTIONS(3466),
    [anon_sym_LT] = ACTIONS(3466),
    [anon_sym_use] = ACTIONS(3468),
    [anon_sym_use_BANG] = ACTIONS(3466),
    [anon_sym_do_BANG] = ACTIONS(3466),
    [anon_sym_begin] = ACTIONS(3468),
    [anon_sym_LPAREN2] = ACTIONS(3468),
    [anon_sym_DOT_DOT2] = ACTIONS(3466),
    [anon_sym_STAR] = ACTIONS(3704),
    [anon_sym_LT2] = ACTIONS(3468),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3466),
    [anon_sym_default] = ACTIONS(3468),
    [anon_sym_or] = ACTIONS(3468),
    [anon_sym_static] = ACTIONS(3468),
    [anon_sym_member] = ACTIONS(3468),
    [anon_sym_interface] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(3468),
    [anon_sym_val] = ACTIONS(3468),
    [anon_sym_override] = ACTIONS(3468),
    [aux_sym_char_token1] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3468),
    [anon_sym_DQUOTE] = ACTIONS(3468),
    [anon_sym_AT_DQUOTE] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [sym_bool] = ACTIONS(3468),
    [sym_unit] = ACTIONS(3466),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3468),
    [sym_op_identifier] = ACTIONS(3468),
    [anon_sym_PLUS] = ACTIONS(3468),
    [anon_sym_DASH] = ACTIONS(3468),
    [anon_sym_PLUS_DOT] = ACTIONS(3468),
    [anon_sym_DASH_DOT] = ACTIONS(3468),
    [anon_sym_PERCENT] = ACTIONS(3468),
    [anon_sym_AMP_AMP] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3466),
    [aux_sym_prefix_op_token1] = ACTIONS(3468),
    [aux_sym_infix_op_token1] = ACTIONS(3466),
    [aux_sym_infix_op_token2] = ACTIONS(3468),
    [anon_sym_PIPE_PIPE] = ACTIONS(3468),
    [anon_sym_BANG_EQ] = ACTIONS(3468),
    [anon_sym_COLON_EQ] = ACTIONS(3466),
    [anon_sym_DOLLAR] = ACTIONS(3468),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3468),
    [sym_int] = ACTIONS(3468),
    [sym_xint] = ACTIONS(3466),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3466),
    [sym__newline] = ACTIONS(3466),
    [sym__dedent] = ACTIONS(3466),
  },
  [1362] = {
    [sym_block_comment] = STATE(1362),
    [sym_compiler_directive_decl] = STATE(1362),
    [sym_fsi_directive_decl] = STATE(1362),
    [sym_preproc_line] = STATE(1362),
    [ts_builtin_sym_end] = ACTIONS(3485),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_namespace] = ACTIONS(3487),
    [anon_sym_module] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_open] = ACTIONS(3487),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_type] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_and] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [aux_sym_access_modifier_token1] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_member] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_exception] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_val] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3485),
    [anon_sym_POUNDload] = ACTIONS(3485),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [1363] = {
    [sym_block_comment] = STATE(1363),
    [sym_compiler_directive_decl] = STATE(1363),
    [sym_fsi_directive_decl] = STATE(1363),
    [sym_preproc_line] = STATE(1363),
    [aux_sym_compound_type_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(3468),
    [anon_sym_EQ] = ACTIONS(3466),
    [anon_sym_LBRACK_LT] = ACTIONS(3466),
    [anon_sym_COLON] = ACTIONS(3468),
    [anon_sym_return] = ACTIONS(3468),
    [anon_sym_do] = ACTIONS(3468),
    [anon_sym_and] = ACTIONS(3468),
    [anon_sym_let] = ACTIONS(3468),
    [anon_sym_let_BANG] = ACTIONS(3466),
    [aux_sym_access_modifier_token1] = ACTIONS(3466),
    [anon_sym_LPAREN] = ACTIONS(3468),
    [anon_sym_COMMA] = ACTIONS(3466),
    [anon_sym_null] = ACTIONS(3468),
    [anon_sym_QMARK] = ACTIONS(3468),
    [anon_sym_COLON_QMARK] = ACTIONS(3468),
    [anon_sym_COLON_COLON] = ACTIONS(3466),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LBRACK] = ACTIONS(3468),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3466),
    [anon_sym_LBRACE] = ACTIONS(3468),
    [anon_sym_LT_AT] = ACTIONS(3468),
    [anon_sym_LT_AT_AT] = ACTIONS(3468),
    [anon_sym_DOT] = ACTIONS(3468),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3466),
    [anon_sym_new] = ACTIONS(3468),
    [anon_sym_with] = ACTIONS(3468),
    [anon_sym_return_BANG] = ACTIONS(3466),
    [anon_sym_yield] = ACTIONS(3468),
    [anon_sym_yield_BANG] = ACTIONS(3466),
    [anon_sym_lazy] = ACTIONS(3468),
    [anon_sym_assert] = ACTIONS(3468),
    [anon_sym_upcast] = ACTIONS(3468),
    [anon_sym_downcast] = ACTIONS(3468),
    [anon_sym_COLON_GT] = ACTIONS(3466),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3466),
    [anon_sym_for] = ACTIONS(3468),
    [anon_sym_while] = ACTIONS(3468),
    [anon_sym_if] = ACTIONS(3468),
    [anon_sym_fun] = ACTIONS(3468),
    [anon_sym_DASH_GT] = ACTIONS(3468),
    [anon_sym_try] = ACTIONS(3468),
    [anon_sym_match] = ACTIONS(3468),
    [anon_sym_match_BANG] = ACTIONS(3466),
    [anon_sym_function] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3468),
    [anon_sym_DOT_LBRACK] = ACTIONS(3466),
    [anon_sym_LT] = ACTIONS(3466),
    [anon_sym_use] = ACTIONS(3468),
    [anon_sym_use_BANG] = ACTIONS(3466),
    [anon_sym_do_BANG] = ACTIONS(3466),
    [anon_sym_begin] = ACTIONS(3468),
    [anon_sym_LPAREN2] = ACTIONS(3468),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_LT2] = ACTIONS(3468),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3466),
    [anon_sym_default] = ACTIONS(3468),
    [anon_sym_or] = ACTIONS(3468),
    [anon_sym_static] = ACTIONS(3468),
    [anon_sym_member] = ACTIONS(3468),
    [anon_sym_interface] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(3468),
    [anon_sym_val] = ACTIONS(3468),
    [anon_sym_override] = ACTIONS(3468),
    [aux_sym_char_token1] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3468),
    [anon_sym_DQUOTE] = ACTIONS(3468),
    [anon_sym_AT_DQUOTE] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [sym_bool] = ACTIONS(3468),
    [sym_unit] = ACTIONS(3466),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3468),
    [sym_op_identifier] = ACTIONS(3468),
    [anon_sym_PLUS] = ACTIONS(3468),
    [anon_sym_DASH] = ACTIONS(3468),
    [anon_sym_PLUS_DOT] = ACTIONS(3468),
    [anon_sym_DASH_DOT] = ACTIONS(3468),
    [anon_sym_PERCENT] = ACTIONS(3468),
    [anon_sym_AMP_AMP] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3466),
    [aux_sym_prefix_op_token1] = ACTIONS(3468),
    [aux_sym_infix_op_token1] = ACTIONS(3466),
    [aux_sym_infix_op_token2] = ACTIONS(3468),
    [anon_sym_PIPE_PIPE] = ACTIONS(3468),
    [anon_sym_BANG_EQ] = ACTIONS(3468),
    [anon_sym_COLON_EQ] = ACTIONS(3466),
    [anon_sym_DOLLAR] = ACTIONS(3468),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3468),
    [sym_int] = ACTIONS(3468),
    [sym_xint] = ACTIONS(3466),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3466),
    [anon_sym_POUNDendif] = ACTIONS(3466),
    [sym__newline] = ACTIONS(3466),
  },
  [1364] = {
    [sym_block_comment] = STATE(1364),
    [sym_compiler_directive_decl] = STATE(1364),
    [sym_fsi_directive_decl] = STATE(1364),
    [sym_preproc_line] = STATE(1364),
    [aux_sym_long_identifier_repeat1] = STATE(1367),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_EQ] = ACTIONS(3492),
    [anon_sym_LBRACK_LT] = ACTIONS(3492),
    [anon_sym_COLON] = ACTIONS(3494),
    [anon_sym_return] = ACTIONS(3494),
    [anon_sym_do] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_let_BANG] = ACTIONS(3492),
    [aux_sym_access_modifier_token1] = ACTIONS(3492),
    [anon_sym_LPAREN] = ACTIONS(3494),
    [anon_sym_COMMA] = ACTIONS(3492),
    [anon_sym_null] = ACTIONS(3494),
    [anon_sym_QMARK] = ACTIONS(3494),
    [anon_sym_COLON_QMARK] = ACTIONS(3494),
    [anon_sym_COLON_COLON] = ACTIONS(3492),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3492),
    [anon_sym_LBRACE] = ACTIONS(3494),
    [anon_sym_LT_AT] = ACTIONS(3494),
    [anon_sym_LT_AT_AT] = ACTIONS(3494),
    [anon_sym_DOT] = ACTIONS(3968),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3492),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_with] = ACTIONS(3494),
    [anon_sym_return_BANG] = ACTIONS(3492),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_yield_BANG] = ACTIONS(3492),
    [anon_sym_lazy] = ACTIONS(3494),
    [anon_sym_assert] = ACTIONS(3494),
    [anon_sym_upcast] = ACTIONS(3494),
    [anon_sym_downcast] = ACTIONS(3494),
    [anon_sym_COLON_GT] = ACTIONS(3492),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3492),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_while] = ACTIONS(3494),
    [anon_sym_if] = ACTIONS(3494),
    [anon_sym_fun] = ACTIONS(3494),
    [anon_sym_DASH_GT] = ACTIONS(3494),
    [anon_sym_try] = ACTIONS(3494),
    [anon_sym_match] = ACTIONS(3494),
    [anon_sym_match_BANG] = ACTIONS(3492),
    [anon_sym_function] = ACTIONS(3494),
    [anon_sym_LT_DASH] = ACTIONS(3494),
    [anon_sym_DOT_LBRACK] = ACTIONS(3492),
    [anon_sym_LT] = ACTIONS(3492),
    [anon_sym_use] = ACTIONS(3494),
    [anon_sym_use_BANG] = ACTIONS(3492),
    [anon_sym_do_BANG] = ACTIONS(3492),
    [anon_sym_begin] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(3494),
    [anon_sym_STAR] = ACTIONS(3494),
    [anon_sym_LT2] = ACTIONS(3494),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3492),
    [anon_sym_default] = ACTIONS(3494),
    [anon_sym_or] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_member] = ACTIONS(3494),
    [anon_sym_interface] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_val] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [anon_sym_inherit] = ACTIONS(3494),
    [aux_sym_char_token1] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3494),
    [anon_sym_DQUOTE] = ACTIONS(3494),
    [anon_sym_AT_DQUOTE] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [sym_bool] = ACTIONS(3494),
    [sym_unit] = ACTIONS(3492),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3494),
    [sym_op_identifier] = ACTIONS(3494),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_PLUS_DOT] = ACTIONS(3494),
    [anon_sym_DASH_DOT] = ACTIONS(3494),
    [anon_sym_PERCENT] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_TILDE] = ACTIONS(3492),
    [aux_sym_prefix_op_token1] = ACTIONS(3494),
    [aux_sym_infix_op_token1] = ACTIONS(3492),
    [aux_sym_infix_op_token2] = ACTIONS(3494),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_COLON_EQ] = ACTIONS(3492),
    [anon_sym_DOLLAR] = ACTIONS(3494),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3494),
    [sym_int] = ACTIONS(3494),
    [sym_xint] = ACTIONS(3492),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3492),
    [anon_sym_POUNDendif] = ACTIONS(3492),
    [sym__newline] = ACTIONS(3492),
  },
  [1365] = {
    [sym_block_comment] = STATE(1365),
    [sym_compiler_directive_decl] = STATE(1365),
    [sym_fsi_directive_decl] = STATE(1365),
    [sym_preproc_line] = STATE(1365),
    [ts_builtin_sym_end] = ACTIONS(3970),
    [sym_identifier] = ACTIONS(3972),
    [anon_sym_namespace] = ACTIONS(3972),
    [anon_sym_module] = ACTIONS(3972),
    [anon_sym_EQ] = ACTIONS(3970),
    [anon_sym_open] = ACTIONS(3972),
    [anon_sym_LBRACK_LT] = ACTIONS(3970),
    [anon_sym_COLON] = ACTIONS(3972),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_type] = ACTIONS(3972),
    [anon_sym_do] = ACTIONS(3972),
    [anon_sym_and] = ACTIONS(3972),
    [anon_sym_let] = ACTIONS(3972),
    [anon_sym_let_BANG] = ACTIONS(3970),
    [aux_sym_access_modifier_token1] = ACTIONS(3970),
    [anon_sym_LPAREN] = ACTIONS(3972),
    [anon_sym_COMMA] = ACTIONS(3970),
    [anon_sym_null] = ACTIONS(3972),
    [anon_sym_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_COLON] = ACTIONS(3970),
    [anon_sym_AMP] = ACTIONS(3972),
    [anon_sym_LBRACK] = ACTIONS(3972),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3970),
    [anon_sym_LBRACE] = ACTIONS(3972),
    [anon_sym_LT_AT] = ACTIONS(3972),
    [anon_sym_LT_AT_AT] = ACTIONS(3972),
    [anon_sym_DOT] = ACTIONS(3972),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3970),
    [anon_sym_new] = ACTIONS(3972),
    [anon_sym_with] = ACTIONS(3972),
    [anon_sym_return_BANG] = ACTIONS(3970),
    [anon_sym_yield] = ACTIONS(3972),
    [anon_sym_yield_BANG] = ACTIONS(3970),
    [anon_sym_lazy] = ACTIONS(3972),
    [anon_sym_assert] = ACTIONS(3972),
    [anon_sym_upcast] = ACTIONS(3972),
    [anon_sym_downcast] = ACTIONS(3972),
    [anon_sym_COLON_GT] = ACTIONS(3970),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3970),
    [anon_sym_for] = ACTIONS(3972),
    [anon_sym_while] = ACTIONS(3972),
    [anon_sym_if] = ACTIONS(3972),
    [anon_sym_fun] = ACTIONS(3972),
    [anon_sym_try] = ACTIONS(3972),
    [anon_sym_match] = ACTIONS(3972),
    [anon_sym_match_BANG] = ACTIONS(3970),
    [anon_sym_function] = ACTIONS(3972),
    [anon_sym_LT_DASH] = ACTIONS(3972),
    [anon_sym_DOT_LBRACK] = ACTIONS(3970),
    [anon_sym_LT] = ACTIONS(3970),
    [anon_sym_use] = ACTIONS(3972),
    [anon_sym_use_BANG] = ACTIONS(3970),
    [anon_sym_do_BANG] = ACTIONS(3970),
    [anon_sym_begin] = ACTIONS(3972),
    [anon_sym_LPAREN2] = ACTIONS(3972),
    [anon_sym_default] = ACTIONS(3972),
    [anon_sym_or] = ACTIONS(3972),
    [anon_sym_static] = ACTIONS(3972),
    [anon_sym_member] = ACTIONS(3972),
    [anon_sym_interface] = ACTIONS(3972),
    [anon_sym_exception] = ACTIONS(3972),
    [anon_sym_abstract] = ACTIONS(3972),
    [anon_sym_val] = ACTIONS(3972),
    [anon_sym_override] = ACTIONS(3972),
    [aux_sym_char_token1] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3972),
    [anon_sym_DQUOTE] = ACTIONS(3972),
    [anon_sym_AT_DQUOTE] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [sym_bool] = ACTIONS(3972),
    [sym_unit] = ACTIONS(3970),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3972),
    [sym_op_identifier] = ACTIONS(3972),
    [anon_sym_PLUS] = ACTIONS(3972),
    [anon_sym_DASH] = ACTIONS(3972),
    [anon_sym_PLUS_DOT] = ACTIONS(3972),
    [anon_sym_DASH_DOT] = ACTIONS(3972),
    [anon_sym_PERCENT] = ACTIONS(3972),
    [anon_sym_AMP_AMP] = ACTIONS(3972),
    [anon_sym_TILDE] = ACTIONS(3970),
    [aux_sym_prefix_op_token1] = ACTIONS(3972),
    [aux_sym_infix_op_token1] = ACTIONS(3970),
    [aux_sym_infix_op_token2] = ACTIONS(3972),
    [anon_sym_PIPE_PIPE] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3972),
    [anon_sym_COLON_EQ] = ACTIONS(3970),
    [anon_sym_DOLLAR] = ACTIONS(3972),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3972),
    [sym_int] = ACTIONS(3972),
    [sym_xint] = ACTIONS(3970),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3970),
    [anon_sym_POUNDload] = ACTIONS(3970),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3970),
    [sym__newline] = ACTIONS(3970),
  },
  [1366] = {
    [sym_block_comment] = STATE(1366),
    [sym_compiler_directive_decl] = STATE(1366),
    [sym_fsi_directive_decl] = STATE(1366),
    [sym_preproc_line] = STATE(1366),
    [ts_builtin_sym_end] = ACTIONS(3974),
    [sym_identifier] = ACTIONS(3976),
    [anon_sym_namespace] = ACTIONS(3976),
    [anon_sym_module] = ACTIONS(3976),
    [anon_sym_EQ] = ACTIONS(3974),
    [anon_sym_open] = ACTIONS(3976),
    [anon_sym_LBRACK_LT] = ACTIONS(3974),
    [anon_sym_COLON] = ACTIONS(3976),
    [anon_sym_return] = ACTIONS(3976),
    [anon_sym_type] = ACTIONS(3976),
    [anon_sym_do] = ACTIONS(3976),
    [anon_sym_and] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_let_BANG] = ACTIONS(3974),
    [aux_sym_access_modifier_token1] = ACTIONS(3974),
    [anon_sym_LPAREN] = ACTIONS(3976),
    [anon_sym_COMMA] = ACTIONS(3974),
    [anon_sym_null] = ACTIONS(3976),
    [anon_sym_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_COLON] = ACTIONS(3974),
    [anon_sym_AMP] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(3976),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3974),
    [anon_sym_LBRACE] = ACTIONS(3976),
    [anon_sym_LT_AT] = ACTIONS(3976),
    [anon_sym_LT_AT_AT] = ACTIONS(3976),
    [anon_sym_DOT] = ACTIONS(3976),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3974),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_with] = ACTIONS(3976),
    [anon_sym_return_BANG] = ACTIONS(3974),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_yield_BANG] = ACTIONS(3974),
    [anon_sym_lazy] = ACTIONS(3976),
    [anon_sym_assert] = ACTIONS(3976),
    [anon_sym_upcast] = ACTIONS(3976),
    [anon_sym_downcast] = ACTIONS(3976),
    [anon_sym_COLON_GT] = ACTIONS(3974),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3974),
    [anon_sym_for] = ACTIONS(3976),
    [anon_sym_while] = ACTIONS(3976),
    [anon_sym_if] = ACTIONS(3976),
    [anon_sym_fun] = ACTIONS(3976),
    [anon_sym_try] = ACTIONS(3976),
    [anon_sym_match] = ACTIONS(3976),
    [anon_sym_match_BANG] = ACTIONS(3974),
    [anon_sym_function] = ACTIONS(3976),
    [anon_sym_LT_DASH] = ACTIONS(3976),
    [anon_sym_DOT_LBRACK] = ACTIONS(3974),
    [anon_sym_LT] = ACTIONS(3974),
    [anon_sym_use] = ACTIONS(3976),
    [anon_sym_use_BANG] = ACTIONS(3974),
    [anon_sym_do_BANG] = ACTIONS(3974),
    [anon_sym_begin] = ACTIONS(3976),
    [anon_sym_LPAREN2] = ACTIONS(3976),
    [anon_sym_default] = ACTIONS(3976),
    [anon_sym_or] = ACTIONS(3976),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_member] = ACTIONS(3976),
    [anon_sym_interface] = ACTIONS(3976),
    [anon_sym_exception] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_val] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [aux_sym_char_token1] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3976),
    [anon_sym_DQUOTE] = ACTIONS(3976),
    [anon_sym_AT_DQUOTE] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [sym_bool] = ACTIONS(3976),
    [sym_unit] = ACTIONS(3974),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3976),
    [sym_op_identifier] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3976),
    [anon_sym_DASH] = ACTIONS(3976),
    [anon_sym_PLUS_DOT] = ACTIONS(3976),
    [anon_sym_DASH_DOT] = ACTIONS(3976),
    [anon_sym_PERCENT] = ACTIONS(3976),
    [anon_sym_AMP_AMP] = ACTIONS(3976),
    [anon_sym_TILDE] = ACTIONS(3974),
    [aux_sym_prefix_op_token1] = ACTIONS(3976),
    [aux_sym_infix_op_token1] = ACTIONS(3974),
    [aux_sym_infix_op_token2] = ACTIONS(3976),
    [anon_sym_PIPE_PIPE] = ACTIONS(3976),
    [anon_sym_BANG_EQ] = ACTIONS(3976),
    [anon_sym_COLON_EQ] = ACTIONS(3974),
    [anon_sym_DOLLAR] = ACTIONS(3976),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3976),
    [sym_int] = ACTIONS(3976),
    [sym_xint] = ACTIONS(3974),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3974),
    [anon_sym_POUNDload] = ACTIONS(3974),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3974),
    [sym__newline] = ACTIONS(3974),
  },
  [1367] = {
    [sym_block_comment] = STATE(1367),
    [sym_compiler_directive_decl] = STATE(1367),
    [sym_fsi_directive_decl] = STATE(1367),
    [sym_preproc_line] = STATE(1367),
    [aux_sym_long_identifier_repeat1] = STATE(1375),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_LBRACK_LT] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [aux_sym_access_modifier_token1] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(3968),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_DASH_GT] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_STAR] = ACTIONS(3451),
    [anon_sym_LT2] = ACTIONS(3451),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3449),
    [anon_sym_default] = ACTIONS(3451),
    [anon_sym_or] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_member] = ACTIONS(3451),
    [anon_sym_interface] = ACTIONS(3451),
    [anon_sym_abstract] = ACTIONS(3451),
    [anon_sym_val] = ACTIONS(3451),
    [anon_sym_override] = ACTIONS(3451),
    [anon_sym_inherit] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [anon_sym_POUNDendif] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
  },
  [1368] = {
    [sym_block_comment] = STATE(1368),
    [sym_compiler_directive_decl] = STATE(1368),
    [sym_fsi_directive_decl] = STATE(1368),
    [sym_preproc_line] = STATE(1368),
    [ts_builtin_sym_end] = ACTIONS(3978),
    [sym_identifier] = ACTIONS(3980),
    [anon_sym_namespace] = ACTIONS(3980),
    [anon_sym_module] = ACTIONS(3980),
    [anon_sym_EQ] = ACTIONS(3978),
    [anon_sym_open] = ACTIONS(3980),
    [anon_sym_LBRACK_LT] = ACTIONS(3978),
    [anon_sym_COLON] = ACTIONS(3980),
    [anon_sym_return] = ACTIONS(3980),
    [anon_sym_type] = ACTIONS(3980),
    [anon_sym_do] = ACTIONS(3980),
    [anon_sym_and] = ACTIONS(3980),
    [anon_sym_let] = ACTIONS(3980),
    [anon_sym_let_BANG] = ACTIONS(3978),
    [aux_sym_access_modifier_token1] = ACTIONS(3978),
    [anon_sym_LPAREN] = ACTIONS(3980),
    [anon_sym_COMMA] = ACTIONS(3978),
    [anon_sym_null] = ACTIONS(3980),
    [anon_sym_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3978),
    [anon_sym_AMP] = ACTIONS(3980),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3978),
    [anon_sym_LBRACE] = ACTIONS(3980),
    [anon_sym_LT_AT] = ACTIONS(3980),
    [anon_sym_LT_AT_AT] = ACTIONS(3980),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3978),
    [anon_sym_new] = ACTIONS(3980),
    [anon_sym_with] = ACTIONS(3980),
    [anon_sym_return_BANG] = ACTIONS(3978),
    [anon_sym_yield] = ACTIONS(3980),
    [anon_sym_yield_BANG] = ACTIONS(3978),
    [anon_sym_lazy] = ACTIONS(3980),
    [anon_sym_assert] = ACTIONS(3980),
    [anon_sym_upcast] = ACTIONS(3980),
    [anon_sym_downcast] = ACTIONS(3980),
    [anon_sym_COLON_GT] = ACTIONS(3978),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3978),
    [anon_sym_for] = ACTIONS(3980),
    [anon_sym_while] = ACTIONS(3980),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_fun] = ACTIONS(3980),
    [anon_sym_try] = ACTIONS(3980),
    [anon_sym_match] = ACTIONS(3980),
    [anon_sym_match_BANG] = ACTIONS(3978),
    [anon_sym_function] = ACTIONS(3980),
    [anon_sym_LT_DASH] = ACTIONS(3980),
    [anon_sym_DOT_LBRACK] = ACTIONS(3978),
    [anon_sym_LT] = ACTIONS(3978),
    [anon_sym_use] = ACTIONS(3980),
    [anon_sym_use_BANG] = ACTIONS(3978),
    [anon_sym_do_BANG] = ACTIONS(3978),
    [anon_sym_begin] = ACTIONS(3980),
    [anon_sym_LPAREN2] = ACTIONS(3980),
    [anon_sym_default] = ACTIONS(3980),
    [anon_sym_or] = ACTIONS(3980),
    [anon_sym_static] = ACTIONS(3980),
    [anon_sym_member] = ACTIONS(3980),
    [anon_sym_interface] = ACTIONS(3980),
    [anon_sym_exception] = ACTIONS(3980),
    [anon_sym_abstract] = ACTIONS(3980),
    [anon_sym_val] = ACTIONS(3980),
    [anon_sym_override] = ACTIONS(3980),
    [aux_sym_char_token1] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3980),
    [anon_sym_DQUOTE] = ACTIONS(3980),
    [anon_sym_AT_DQUOTE] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [sym_bool] = ACTIONS(3980),
    [sym_unit] = ACTIONS(3978),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3980),
    [sym_op_identifier] = ACTIONS(3980),
    [anon_sym_PLUS] = ACTIONS(3980),
    [anon_sym_DASH] = ACTIONS(3980),
    [anon_sym_PLUS_DOT] = ACTIONS(3980),
    [anon_sym_DASH_DOT] = ACTIONS(3980),
    [anon_sym_PERCENT] = ACTIONS(3980),
    [anon_sym_AMP_AMP] = ACTIONS(3980),
    [anon_sym_TILDE] = ACTIONS(3978),
    [aux_sym_prefix_op_token1] = ACTIONS(3980),
    [aux_sym_infix_op_token1] = ACTIONS(3978),
    [aux_sym_infix_op_token2] = ACTIONS(3980),
    [anon_sym_PIPE_PIPE] = ACTIONS(3980),
    [anon_sym_BANG_EQ] = ACTIONS(3980),
    [anon_sym_COLON_EQ] = ACTIONS(3978),
    [anon_sym_DOLLAR] = ACTIONS(3980),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3980),
    [sym_int] = ACTIONS(3980),
    [sym_xint] = ACTIONS(3978),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3978),
    [anon_sym_POUNDload] = ACTIONS(3978),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3978),
    [sym__newline] = ACTIONS(3978),
  },
  [1369] = {
    [sym_block_comment] = STATE(1369),
    [sym_compiler_directive_decl] = STATE(1369),
    [sym_fsi_directive_decl] = STATE(1369),
    [sym_preproc_line] = STATE(1369),
    [ts_builtin_sym_end] = ACTIONS(3982),
    [sym_identifier] = ACTIONS(3984),
    [anon_sym_namespace] = ACTIONS(3984),
    [anon_sym_module] = ACTIONS(3984),
    [anon_sym_EQ] = ACTIONS(3982),
    [anon_sym_open] = ACTIONS(3984),
    [anon_sym_LBRACK_LT] = ACTIONS(3982),
    [anon_sym_COLON] = ACTIONS(3984),
    [anon_sym_return] = ACTIONS(3984),
    [anon_sym_type] = ACTIONS(3984),
    [anon_sym_do] = ACTIONS(3984),
    [anon_sym_and] = ACTIONS(3984),
    [anon_sym_let] = ACTIONS(3984),
    [anon_sym_let_BANG] = ACTIONS(3982),
    [aux_sym_access_modifier_token1] = ACTIONS(3982),
    [anon_sym_LPAREN] = ACTIONS(3984),
    [anon_sym_COMMA] = ACTIONS(3982),
    [anon_sym_null] = ACTIONS(3984),
    [anon_sym_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AMP] = ACTIONS(3984),
    [anon_sym_LBRACK] = ACTIONS(3984),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(3984),
    [anon_sym_LT_AT] = ACTIONS(3984),
    [anon_sym_LT_AT_AT] = ACTIONS(3984),
    [anon_sym_DOT] = ACTIONS(3984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3982),
    [anon_sym_new] = ACTIONS(3984),
    [anon_sym_with] = ACTIONS(3984),
    [anon_sym_return_BANG] = ACTIONS(3982),
    [anon_sym_yield] = ACTIONS(3984),
    [anon_sym_yield_BANG] = ACTIONS(3982),
    [anon_sym_lazy] = ACTIONS(3984),
    [anon_sym_assert] = ACTIONS(3984),
    [anon_sym_upcast] = ACTIONS(3984),
    [anon_sym_downcast] = ACTIONS(3984),
    [anon_sym_COLON_GT] = ACTIONS(3982),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3982),
    [anon_sym_for] = ACTIONS(3984),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_if] = ACTIONS(3984),
    [anon_sym_fun] = ACTIONS(3984),
    [anon_sym_try] = ACTIONS(3984),
    [anon_sym_match] = ACTIONS(3984),
    [anon_sym_match_BANG] = ACTIONS(3982),
    [anon_sym_function] = ACTIONS(3984),
    [anon_sym_LT_DASH] = ACTIONS(3984),
    [anon_sym_DOT_LBRACK] = ACTIONS(3982),
    [anon_sym_LT] = ACTIONS(3982),
    [anon_sym_use] = ACTIONS(3984),
    [anon_sym_use_BANG] = ACTIONS(3982),
    [anon_sym_do_BANG] = ACTIONS(3982),
    [anon_sym_begin] = ACTIONS(3984),
    [anon_sym_LPAREN2] = ACTIONS(3984),
    [anon_sym_default] = ACTIONS(3984),
    [anon_sym_or] = ACTIONS(3984),
    [anon_sym_static] = ACTIONS(3984),
    [anon_sym_member] = ACTIONS(3984),
    [anon_sym_interface] = ACTIONS(3984),
    [anon_sym_exception] = ACTIONS(3984),
    [anon_sym_abstract] = ACTIONS(3984),
    [anon_sym_val] = ACTIONS(3984),
    [anon_sym_override] = ACTIONS(3984),
    [aux_sym_char_token1] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3984),
    [anon_sym_DQUOTE] = ACTIONS(3984),
    [anon_sym_AT_DQUOTE] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [sym_bool] = ACTIONS(3984),
    [sym_unit] = ACTIONS(3982),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3984),
    [sym_op_identifier] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3984),
    [anon_sym_DASH] = ACTIONS(3984),
    [anon_sym_PLUS_DOT] = ACTIONS(3984),
    [anon_sym_DASH_DOT] = ACTIONS(3984),
    [anon_sym_PERCENT] = ACTIONS(3984),
    [anon_sym_AMP_AMP] = ACTIONS(3984),
    [anon_sym_TILDE] = ACTIONS(3982),
    [aux_sym_prefix_op_token1] = ACTIONS(3984),
    [aux_sym_infix_op_token1] = ACTIONS(3982),
    [aux_sym_infix_op_token2] = ACTIONS(3984),
    [anon_sym_PIPE_PIPE] = ACTIONS(3984),
    [anon_sym_BANG_EQ] = ACTIONS(3984),
    [anon_sym_COLON_EQ] = ACTIONS(3982),
    [anon_sym_DOLLAR] = ACTIONS(3984),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3984),
    [sym_int] = ACTIONS(3984),
    [sym_xint] = ACTIONS(3982),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3982),
    [anon_sym_POUNDload] = ACTIONS(3982),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3982),
    [sym__newline] = ACTIONS(3982),
  },
  [1370] = {
    [sym_block_comment] = STATE(1370),
    [sym_compiler_directive_decl] = STATE(1370),
    [sym_fsi_directive_decl] = STATE(1370),
    [sym_preproc_line] = STATE(1370),
    [aux_sym_type_argument_repeat1] = STATE(1397),
    [sym_identifier] = ACTIONS(3476),
    [anon_sym_EQ] = ACTIONS(3474),
    [anon_sym_LBRACK_LT] = ACTIONS(3474),
    [anon_sym_COLON] = ACTIONS(3476),
    [anon_sym_return] = ACTIONS(3476),
    [anon_sym_do] = ACTIONS(3476),
    [anon_sym_let] = ACTIONS(3476),
    [anon_sym_let_BANG] = ACTIONS(3474),
    [aux_sym_access_modifier_token1] = ACTIONS(3474),
    [anon_sym_LPAREN] = ACTIONS(3476),
    [anon_sym_COMMA] = ACTIONS(3474),
    [anon_sym_null] = ACTIONS(3476),
    [anon_sym_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_COLON] = ACTIONS(3474),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym_LBRACK] = ACTIONS(3476),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3474),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_LT_AT] = ACTIONS(3476),
    [anon_sym_LT_AT_AT] = ACTIONS(3476),
    [anon_sym_DOT] = ACTIONS(3476),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3474),
    [anon_sym_new] = ACTIONS(3476),
    [anon_sym_with] = ACTIONS(3476),
    [anon_sym_return_BANG] = ACTIONS(3474),
    [anon_sym_yield] = ACTIONS(3476),
    [anon_sym_yield_BANG] = ACTIONS(3474),
    [anon_sym_lazy] = ACTIONS(3476),
    [anon_sym_assert] = ACTIONS(3476),
    [anon_sym_upcast] = ACTIONS(3476),
    [anon_sym_downcast] = ACTIONS(3476),
    [anon_sym_COLON_GT] = ACTIONS(3474),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3474),
    [anon_sym_for] = ACTIONS(3476),
    [anon_sym_while] = ACTIONS(3476),
    [anon_sym_if] = ACTIONS(3476),
    [anon_sym_fun] = ACTIONS(3476),
    [anon_sym_DASH_GT] = ACTIONS(3476),
    [anon_sym_try] = ACTIONS(3476),
    [anon_sym_match] = ACTIONS(3476),
    [anon_sym_match_BANG] = ACTIONS(3474),
    [anon_sym_function] = ACTIONS(3476),
    [anon_sym_LT_DASH] = ACTIONS(3476),
    [anon_sym_DOT_LBRACK] = ACTIONS(3474),
    [anon_sym_LT] = ACTIONS(3474),
    [anon_sym_use] = ACTIONS(3476),
    [anon_sym_use_BANG] = ACTIONS(3474),
    [anon_sym_do_BANG] = ACTIONS(3474),
    [anon_sym_begin] = ACTIONS(3476),
    [anon_sym_LPAREN2] = ACTIONS(3476),
    [anon_sym_DOT_DOT2] = ACTIONS(3474),
    [anon_sym_STAR] = ACTIONS(3476),
    [anon_sym_LT2] = ACTIONS(3476),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3474),
    [anon_sym_default] = ACTIONS(3476),
    [anon_sym_or] = ACTIONS(3476),
    [anon_sym_static] = ACTIONS(3476),
    [anon_sym_member] = ACTIONS(3476),
    [anon_sym_interface] = ACTIONS(3476),
    [anon_sym_abstract] = ACTIONS(3476),
    [anon_sym_val] = ACTIONS(3476),
    [anon_sym_override] = ACTIONS(3476),
    [aux_sym_char_token1] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3476),
    [anon_sym_DQUOTE] = ACTIONS(3476),
    [anon_sym_AT_DQUOTE] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [sym_bool] = ACTIONS(3476),
    [sym_unit] = ACTIONS(3474),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3476),
    [sym_op_identifier] = ACTIONS(3476),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3476),
    [anon_sym_PLUS_DOT] = ACTIONS(3476),
    [anon_sym_DASH_DOT] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [anon_sym_AMP_AMP] = ACTIONS(3476),
    [anon_sym_TILDE] = ACTIONS(3474),
    [aux_sym_prefix_op_token1] = ACTIONS(3476),
    [aux_sym_infix_op_token1] = ACTIONS(3474),
    [aux_sym_infix_op_token2] = ACTIONS(3476),
    [anon_sym_PIPE_PIPE] = ACTIONS(3476),
    [anon_sym_BANG_EQ] = ACTIONS(3476),
    [anon_sym_COLON_EQ] = ACTIONS(3474),
    [anon_sym_DOLLAR] = ACTIONS(3476),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3476),
    [sym_int] = ACTIONS(3476),
    [sym_xint] = ACTIONS(3474),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3474),
    [sym__newline] = ACTIONS(3474),
    [sym__dedent] = ACTIONS(3474),
  },
  [1371] = {
    [sym_block_comment] = STATE(1371),
    [sym_compiler_directive_decl] = STATE(1371),
    [sym_fsi_directive_decl] = STATE(1371),
    [sym_preproc_line] = STATE(1371),
    [ts_builtin_sym_end] = ACTIONS(3986),
    [sym_identifier] = ACTIONS(3988),
    [anon_sym_namespace] = ACTIONS(3988),
    [anon_sym_module] = ACTIONS(3988),
    [anon_sym_EQ] = ACTIONS(3986),
    [anon_sym_open] = ACTIONS(3988),
    [anon_sym_LBRACK_LT] = ACTIONS(3986),
    [anon_sym_COLON] = ACTIONS(3988),
    [anon_sym_return] = ACTIONS(3988),
    [anon_sym_type] = ACTIONS(3988),
    [anon_sym_do] = ACTIONS(3988),
    [anon_sym_and] = ACTIONS(3988),
    [anon_sym_let] = ACTIONS(3988),
    [anon_sym_let_BANG] = ACTIONS(3986),
    [aux_sym_access_modifier_token1] = ACTIONS(3986),
    [anon_sym_LPAREN] = ACTIONS(3988),
    [anon_sym_COMMA] = ACTIONS(3986),
    [anon_sym_null] = ACTIONS(3988),
    [anon_sym_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_COLON] = ACTIONS(3986),
    [anon_sym_AMP] = ACTIONS(3988),
    [anon_sym_LBRACK] = ACTIONS(3988),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3986),
    [anon_sym_LBRACE] = ACTIONS(3988),
    [anon_sym_LT_AT] = ACTIONS(3988),
    [anon_sym_LT_AT_AT] = ACTIONS(3988),
    [anon_sym_DOT] = ACTIONS(3988),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3986),
    [anon_sym_new] = ACTIONS(3988),
    [anon_sym_with] = ACTIONS(3988),
    [anon_sym_return_BANG] = ACTIONS(3986),
    [anon_sym_yield] = ACTIONS(3988),
    [anon_sym_yield_BANG] = ACTIONS(3986),
    [anon_sym_lazy] = ACTIONS(3988),
    [anon_sym_assert] = ACTIONS(3988),
    [anon_sym_upcast] = ACTIONS(3988),
    [anon_sym_downcast] = ACTIONS(3988),
    [anon_sym_COLON_GT] = ACTIONS(3986),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_while] = ACTIONS(3988),
    [anon_sym_if] = ACTIONS(3988),
    [anon_sym_fun] = ACTIONS(3988),
    [anon_sym_try] = ACTIONS(3988),
    [anon_sym_match] = ACTIONS(3988),
    [anon_sym_match_BANG] = ACTIONS(3986),
    [anon_sym_function] = ACTIONS(3988),
    [anon_sym_LT_DASH] = ACTIONS(3988),
    [anon_sym_DOT_LBRACK] = ACTIONS(3986),
    [anon_sym_LT] = ACTIONS(3986),
    [anon_sym_use] = ACTIONS(3988),
    [anon_sym_use_BANG] = ACTIONS(3986),
    [anon_sym_do_BANG] = ACTIONS(3986),
    [anon_sym_begin] = ACTIONS(3988),
    [anon_sym_LPAREN2] = ACTIONS(3988),
    [anon_sym_default] = ACTIONS(3988),
    [anon_sym_or] = ACTIONS(3988),
    [anon_sym_static] = ACTIONS(3988),
    [anon_sym_member] = ACTIONS(3988),
    [anon_sym_interface] = ACTIONS(3988),
    [anon_sym_exception] = ACTIONS(3988),
    [anon_sym_abstract] = ACTIONS(3988),
    [anon_sym_val] = ACTIONS(3988),
    [anon_sym_override] = ACTIONS(3988),
    [aux_sym_char_token1] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3988),
    [anon_sym_DQUOTE] = ACTIONS(3988),
    [anon_sym_AT_DQUOTE] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [sym_bool] = ACTIONS(3988),
    [sym_unit] = ACTIONS(3986),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3988),
    [sym_op_identifier] = ACTIONS(3988),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_PLUS_DOT] = ACTIONS(3988),
    [anon_sym_DASH_DOT] = ACTIONS(3988),
    [anon_sym_PERCENT] = ACTIONS(3988),
    [anon_sym_AMP_AMP] = ACTIONS(3988),
    [anon_sym_TILDE] = ACTIONS(3986),
    [aux_sym_prefix_op_token1] = ACTIONS(3988),
    [aux_sym_infix_op_token1] = ACTIONS(3986),
    [aux_sym_infix_op_token2] = ACTIONS(3988),
    [anon_sym_PIPE_PIPE] = ACTIONS(3988),
    [anon_sym_BANG_EQ] = ACTIONS(3988),
    [anon_sym_COLON_EQ] = ACTIONS(3986),
    [anon_sym_DOLLAR] = ACTIONS(3988),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3988),
    [sym_int] = ACTIONS(3988),
    [sym_xint] = ACTIONS(3986),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3986),
    [anon_sym_POUNDload] = ACTIONS(3986),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3986),
    [sym__newline] = ACTIONS(3986),
  },
  [1372] = {
    [sym_block_comment] = STATE(1372),
    [sym_compiler_directive_decl] = STATE(1372),
    [sym_fsi_directive_decl] = STATE(1372),
    [sym_preproc_line] = STATE(1372),
    [ts_builtin_sym_end] = ACTIONS(3990),
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_namespace] = ACTIONS(3992),
    [anon_sym_module] = ACTIONS(3992),
    [anon_sym_EQ] = ACTIONS(3990),
    [anon_sym_open] = ACTIONS(3992),
    [anon_sym_LBRACK_LT] = ACTIONS(3990),
    [anon_sym_COLON] = ACTIONS(3992),
    [anon_sym_return] = ACTIONS(3992),
    [anon_sym_type] = ACTIONS(3992),
    [anon_sym_do] = ACTIONS(3992),
    [anon_sym_and] = ACTIONS(3992),
    [anon_sym_let] = ACTIONS(3992),
    [anon_sym_let_BANG] = ACTIONS(3990),
    [aux_sym_access_modifier_token1] = ACTIONS(3990),
    [anon_sym_LPAREN] = ACTIONS(3992),
    [anon_sym_COMMA] = ACTIONS(3990),
    [anon_sym_null] = ACTIONS(3992),
    [anon_sym_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [anon_sym_AMP] = ACTIONS(3992),
    [anon_sym_LBRACK] = ACTIONS(3992),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3990),
    [anon_sym_LBRACE] = ACTIONS(3992),
    [anon_sym_LT_AT] = ACTIONS(3992),
    [anon_sym_LT_AT_AT] = ACTIONS(3992),
    [anon_sym_DOT] = ACTIONS(3992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3990),
    [anon_sym_new] = ACTIONS(3992),
    [anon_sym_with] = ACTIONS(3992),
    [anon_sym_return_BANG] = ACTIONS(3990),
    [anon_sym_yield] = ACTIONS(3992),
    [anon_sym_yield_BANG] = ACTIONS(3990),
    [anon_sym_lazy] = ACTIONS(3992),
    [anon_sym_assert] = ACTIONS(3992),
    [anon_sym_upcast] = ACTIONS(3992),
    [anon_sym_downcast] = ACTIONS(3992),
    [anon_sym_COLON_GT] = ACTIONS(3990),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3990),
    [anon_sym_for] = ACTIONS(3992),
    [anon_sym_while] = ACTIONS(3992),
    [anon_sym_if] = ACTIONS(3992),
    [anon_sym_fun] = ACTIONS(3992),
    [anon_sym_try] = ACTIONS(3992),
    [anon_sym_match] = ACTIONS(3992),
    [anon_sym_match_BANG] = ACTIONS(3990),
    [anon_sym_function] = ACTIONS(3992),
    [anon_sym_LT_DASH] = ACTIONS(3992),
    [anon_sym_DOT_LBRACK] = ACTIONS(3990),
    [anon_sym_LT] = ACTIONS(3990),
    [anon_sym_use] = ACTIONS(3992),
    [anon_sym_use_BANG] = ACTIONS(3990),
    [anon_sym_do_BANG] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_LPAREN2] = ACTIONS(3992),
    [anon_sym_default] = ACTIONS(3992),
    [anon_sym_or] = ACTIONS(3992),
    [anon_sym_static] = ACTIONS(3992),
    [anon_sym_member] = ACTIONS(3992),
    [anon_sym_interface] = ACTIONS(3992),
    [anon_sym_exception] = ACTIONS(3992),
    [anon_sym_abstract] = ACTIONS(3992),
    [anon_sym_val] = ACTIONS(3992),
    [anon_sym_override] = ACTIONS(3992),
    [aux_sym_char_token1] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3992),
    [anon_sym_DQUOTE] = ACTIONS(3992),
    [anon_sym_AT_DQUOTE] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [sym_bool] = ACTIONS(3992),
    [sym_unit] = ACTIONS(3990),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3992),
    [sym_op_identifier] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3992),
    [anon_sym_DASH] = ACTIONS(3992),
    [anon_sym_PLUS_DOT] = ACTIONS(3992),
    [anon_sym_DASH_DOT] = ACTIONS(3992),
    [anon_sym_PERCENT] = ACTIONS(3992),
    [anon_sym_AMP_AMP] = ACTIONS(3992),
    [anon_sym_TILDE] = ACTIONS(3990),
    [aux_sym_prefix_op_token1] = ACTIONS(3992),
    [aux_sym_infix_op_token1] = ACTIONS(3990),
    [aux_sym_infix_op_token2] = ACTIONS(3992),
    [anon_sym_PIPE_PIPE] = ACTIONS(3992),
    [anon_sym_BANG_EQ] = ACTIONS(3992),
    [anon_sym_COLON_EQ] = ACTIONS(3990),
    [anon_sym_DOLLAR] = ACTIONS(3992),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3992),
    [sym_int] = ACTIONS(3992),
    [sym_xint] = ACTIONS(3990),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3990),
    [anon_sym_POUNDload] = ACTIONS(3990),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3990),
    [sym__newline] = ACTIONS(3990),
  },
  [1373] = {
    [sym_block_comment] = STATE(1373),
    [sym_compiler_directive_decl] = STATE(1373),
    [sym_fsi_directive_decl] = STATE(1373),
    [sym_preproc_line] = STATE(1373),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3525),
    [anon_sym_LBRACK_LT] = ACTIONS(3525),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [aux_sym_access_modifier_token1] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_COLON] = ACTIONS(3525),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_with] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_COLON_GT] = ACTIONS(3525),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_DASH_GT] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_LT_DASH] = ACTIONS(3527),
    [anon_sym_DOT_LBRACK] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_LPAREN2] = ACTIONS(3527),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_LT2] = ACTIONS(3527),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_default] = ACTIONS(3527),
    [anon_sym_or] = ACTIONS(3527),
    [anon_sym_static] = ACTIONS(3527),
    [anon_sym_member] = ACTIONS(3527),
    [anon_sym_interface] = ACTIONS(3527),
    [anon_sym_abstract] = ACTIONS(3527),
    [anon_sym_val] = ACTIONS(3527),
    [anon_sym_override] = ACTIONS(3527),
    [anon_sym_inherit] = ACTIONS(3527),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3525),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3527),
    [anon_sym_DASH_DOT] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3527),
    [aux_sym_infix_op_token1] = ACTIONS(3525),
    [aux_sym_infix_op_token2] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_COLON_EQ] = ACTIONS(3525),
    [anon_sym_DOLLAR] = ACTIONS(3527),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3527),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3525),
    [anon_sym_POUNDendif] = ACTIONS(3525),
    [anon_sym_POUNDelse] = ACTIONS(3525),
    [sym__newline] = ACTIONS(3525),
  },
  [1374] = {
    [sym_block_comment] = STATE(1374),
    [sym_compiler_directive_decl] = STATE(1374),
    [sym_fsi_directive_decl] = STATE(1374),
    [sym_preproc_line] = STATE(1374),
    [ts_builtin_sym_end] = ACTIONS(3994),
    [sym_identifier] = ACTIONS(3996),
    [anon_sym_namespace] = ACTIONS(3996),
    [anon_sym_module] = ACTIONS(3996),
    [anon_sym_EQ] = ACTIONS(3994),
    [anon_sym_open] = ACTIONS(3996),
    [anon_sym_LBRACK_LT] = ACTIONS(3994),
    [anon_sym_COLON] = ACTIONS(3996),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_type] = ACTIONS(3996),
    [anon_sym_do] = ACTIONS(3996),
    [anon_sym_and] = ACTIONS(3996),
    [anon_sym_let] = ACTIONS(3996),
    [anon_sym_let_BANG] = ACTIONS(3994),
    [aux_sym_access_modifier_token1] = ACTIONS(3994),
    [anon_sym_LPAREN] = ACTIONS(3996),
    [anon_sym_COMMA] = ACTIONS(3994),
    [anon_sym_null] = ACTIONS(3996),
    [anon_sym_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_COLON] = ACTIONS(3994),
    [anon_sym_AMP] = ACTIONS(3996),
    [anon_sym_LBRACK] = ACTIONS(3996),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3994),
    [anon_sym_LBRACE] = ACTIONS(3996),
    [anon_sym_LT_AT] = ACTIONS(3996),
    [anon_sym_LT_AT_AT] = ACTIONS(3996),
    [anon_sym_DOT] = ACTIONS(3996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3994),
    [anon_sym_new] = ACTIONS(3996),
    [anon_sym_with] = ACTIONS(3996),
    [anon_sym_return_BANG] = ACTIONS(3994),
    [anon_sym_yield] = ACTIONS(3996),
    [anon_sym_yield_BANG] = ACTIONS(3994),
    [anon_sym_lazy] = ACTIONS(3996),
    [anon_sym_assert] = ACTIONS(3996),
    [anon_sym_upcast] = ACTIONS(3996),
    [anon_sym_downcast] = ACTIONS(3996),
    [anon_sym_COLON_GT] = ACTIONS(3994),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3994),
    [anon_sym_for] = ACTIONS(3996),
    [anon_sym_while] = ACTIONS(3996),
    [anon_sym_if] = ACTIONS(3996),
    [anon_sym_fun] = ACTIONS(3996),
    [anon_sym_try] = ACTIONS(3996),
    [anon_sym_match] = ACTIONS(3996),
    [anon_sym_match_BANG] = ACTIONS(3994),
    [anon_sym_function] = ACTIONS(3996),
    [anon_sym_LT_DASH] = ACTIONS(3996),
    [anon_sym_DOT_LBRACK] = ACTIONS(3994),
    [anon_sym_LT] = ACTIONS(3994),
    [anon_sym_use] = ACTIONS(3996),
    [anon_sym_use_BANG] = ACTIONS(3994),
    [anon_sym_do_BANG] = ACTIONS(3994),
    [anon_sym_begin] = ACTIONS(3996),
    [anon_sym_LPAREN2] = ACTIONS(3996),
    [anon_sym_default] = ACTIONS(3996),
    [anon_sym_or] = ACTIONS(3996),
    [anon_sym_static] = ACTIONS(3996),
    [anon_sym_member] = ACTIONS(3996),
    [anon_sym_interface] = ACTIONS(3996),
    [anon_sym_exception] = ACTIONS(3996),
    [anon_sym_abstract] = ACTIONS(3996),
    [anon_sym_val] = ACTIONS(3996),
    [anon_sym_override] = ACTIONS(3996),
    [aux_sym_char_token1] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3996),
    [anon_sym_DQUOTE] = ACTIONS(3996),
    [anon_sym_AT_DQUOTE] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [sym_bool] = ACTIONS(3996),
    [sym_unit] = ACTIONS(3994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3996),
    [sym_op_identifier] = ACTIONS(3996),
    [anon_sym_PLUS] = ACTIONS(3996),
    [anon_sym_DASH] = ACTIONS(3996),
    [anon_sym_PLUS_DOT] = ACTIONS(3996),
    [anon_sym_DASH_DOT] = ACTIONS(3996),
    [anon_sym_PERCENT] = ACTIONS(3996),
    [anon_sym_AMP_AMP] = ACTIONS(3996),
    [anon_sym_TILDE] = ACTIONS(3994),
    [aux_sym_prefix_op_token1] = ACTIONS(3996),
    [aux_sym_infix_op_token1] = ACTIONS(3994),
    [aux_sym_infix_op_token2] = ACTIONS(3996),
    [anon_sym_PIPE_PIPE] = ACTIONS(3996),
    [anon_sym_BANG_EQ] = ACTIONS(3996),
    [anon_sym_COLON_EQ] = ACTIONS(3994),
    [anon_sym_DOLLAR] = ACTIONS(3996),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3996),
    [sym_int] = ACTIONS(3996),
    [sym_xint] = ACTIONS(3994),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3994),
    [anon_sym_POUNDload] = ACTIONS(3994),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3994),
    [sym__newline] = ACTIONS(3994),
  },
  [1375] = {
    [sym_block_comment] = STATE(1375),
    [sym_compiler_directive_decl] = STATE(1375),
    [sym_fsi_directive_decl] = STATE(1375),
    [sym_preproc_line] = STATE(1375),
    [aux_sym_long_identifier_repeat1] = STATE(1375),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [aux_sym_access_modifier_token1] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3998),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_member] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_val] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [anon_sym_inherit] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [anon_sym_POUNDendif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [1376] = {
    [sym_block_comment] = STATE(1376),
    [sym_compiler_directive_decl] = STATE(1376),
    [sym_fsi_directive_decl] = STATE(1376),
    [sym_preproc_line] = STATE(1376),
    [ts_builtin_sym_end] = ACTIONS(4001),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_namespace] = ACTIONS(4003),
    [anon_sym_module] = ACTIONS(4003),
    [anon_sym_EQ] = ACTIONS(4001),
    [anon_sym_open] = ACTIONS(4003),
    [anon_sym_LBRACK_LT] = ACTIONS(4001),
    [anon_sym_COLON] = ACTIONS(4003),
    [anon_sym_return] = ACTIONS(4003),
    [anon_sym_type] = ACTIONS(4003),
    [anon_sym_do] = ACTIONS(4003),
    [anon_sym_and] = ACTIONS(4003),
    [anon_sym_let] = ACTIONS(4003),
    [anon_sym_let_BANG] = ACTIONS(4001),
    [aux_sym_access_modifier_token1] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4003),
    [anon_sym_COMMA] = ACTIONS(4001),
    [anon_sym_null] = ACTIONS(4003),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_COLON] = ACTIONS(4001),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LBRACK] = ACTIONS(4003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4001),
    [anon_sym_LBRACE] = ACTIONS(4003),
    [anon_sym_LT_AT] = ACTIONS(4003),
    [anon_sym_LT_AT_AT] = ACTIONS(4003),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4001),
    [anon_sym_new] = ACTIONS(4003),
    [anon_sym_with] = ACTIONS(4003),
    [anon_sym_return_BANG] = ACTIONS(4001),
    [anon_sym_yield] = ACTIONS(4003),
    [anon_sym_yield_BANG] = ACTIONS(4001),
    [anon_sym_lazy] = ACTIONS(4003),
    [anon_sym_assert] = ACTIONS(4003),
    [anon_sym_upcast] = ACTIONS(4003),
    [anon_sym_downcast] = ACTIONS(4003),
    [anon_sym_COLON_GT] = ACTIONS(4001),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4001),
    [anon_sym_for] = ACTIONS(4003),
    [anon_sym_while] = ACTIONS(4003),
    [anon_sym_if] = ACTIONS(4003),
    [anon_sym_fun] = ACTIONS(4003),
    [anon_sym_try] = ACTIONS(4003),
    [anon_sym_match] = ACTIONS(4003),
    [anon_sym_match_BANG] = ACTIONS(4001),
    [anon_sym_function] = ACTIONS(4003),
    [anon_sym_LT_DASH] = ACTIONS(4003),
    [anon_sym_DOT_LBRACK] = ACTIONS(4001),
    [anon_sym_LT] = ACTIONS(4001),
    [anon_sym_use] = ACTIONS(4003),
    [anon_sym_use_BANG] = ACTIONS(4001),
    [anon_sym_do_BANG] = ACTIONS(4001),
    [anon_sym_begin] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4003),
    [anon_sym_default] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [anon_sym_static] = ACTIONS(4003),
    [anon_sym_member] = ACTIONS(4003),
    [anon_sym_interface] = ACTIONS(4003),
    [anon_sym_exception] = ACTIONS(4003),
    [anon_sym_abstract] = ACTIONS(4003),
    [anon_sym_val] = ACTIONS(4003),
    [anon_sym_override] = ACTIONS(4003),
    [aux_sym_char_token1] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4003),
    [anon_sym_DQUOTE] = ACTIONS(4003),
    [anon_sym_AT_DQUOTE] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [sym_bool] = ACTIONS(4003),
    [sym_unit] = ACTIONS(4001),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4003),
    [sym_op_identifier] = ACTIONS(4003),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_PLUS_DOT] = ACTIONS(4003),
    [anon_sym_DASH_DOT] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4003),
    [anon_sym_TILDE] = ACTIONS(4001),
    [aux_sym_prefix_op_token1] = ACTIONS(4003),
    [aux_sym_infix_op_token1] = ACTIONS(4001),
    [aux_sym_infix_op_token2] = ACTIONS(4003),
    [anon_sym_PIPE_PIPE] = ACTIONS(4003),
    [anon_sym_BANG_EQ] = ACTIONS(4003),
    [anon_sym_COLON_EQ] = ACTIONS(4001),
    [anon_sym_DOLLAR] = ACTIONS(4003),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4003),
    [sym_int] = ACTIONS(4003),
    [sym_xint] = ACTIONS(4001),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4001),
    [anon_sym_POUNDload] = ACTIONS(4001),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4001),
    [sym__newline] = ACTIONS(4001),
  },
  [1377] = {
    [sym_block_comment] = STATE(1377),
    [sym_compiler_directive_decl] = STATE(1377),
    [sym_fsi_directive_decl] = STATE(1377),
    [sym_preproc_line] = STATE(1377),
    [aux_sym_type_argument_repeat1] = STATE(1387),
    [sym_identifier] = ACTIONS(3476),
    [anon_sym_EQ] = ACTIONS(3474),
    [anon_sym_LBRACK_LT] = ACTIONS(3474),
    [anon_sym_COLON] = ACTIONS(3476),
    [anon_sym_return] = ACTIONS(3476),
    [anon_sym_do] = ACTIONS(3476),
    [anon_sym_and] = ACTIONS(3476),
    [anon_sym_let] = ACTIONS(3476),
    [anon_sym_let_BANG] = ACTIONS(3474),
    [aux_sym_access_modifier_token1] = ACTIONS(3474),
    [anon_sym_LPAREN] = ACTIONS(3476),
    [anon_sym_COMMA] = ACTIONS(3474),
    [anon_sym_null] = ACTIONS(3476),
    [anon_sym_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_COLON] = ACTIONS(3474),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym_LBRACK] = ACTIONS(3476),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3474),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_LT_AT] = ACTIONS(3476),
    [anon_sym_LT_AT_AT] = ACTIONS(3476),
    [anon_sym_DOT] = ACTIONS(3476),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3474),
    [anon_sym_new] = ACTIONS(3476),
    [anon_sym_with] = ACTIONS(3476),
    [anon_sym_return_BANG] = ACTIONS(3474),
    [anon_sym_yield] = ACTIONS(3476),
    [anon_sym_yield_BANG] = ACTIONS(3474),
    [anon_sym_lazy] = ACTIONS(3476),
    [anon_sym_assert] = ACTIONS(3476),
    [anon_sym_upcast] = ACTIONS(3476),
    [anon_sym_downcast] = ACTIONS(3476),
    [anon_sym_COLON_GT] = ACTIONS(3474),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3474),
    [anon_sym_for] = ACTIONS(3476),
    [anon_sym_while] = ACTIONS(3476),
    [anon_sym_if] = ACTIONS(3476),
    [anon_sym_fun] = ACTIONS(3476),
    [anon_sym_DASH_GT] = ACTIONS(3476),
    [anon_sym_try] = ACTIONS(3476),
    [anon_sym_match] = ACTIONS(3476),
    [anon_sym_match_BANG] = ACTIONS(3474),
    [anon_sym_function] = ACTIONS(3476),
    [anon_sym_LT_DASH] = ACTIONS(3476),
    [anon_sym_DOT_LBRACK] = ACTIONS(3474),
    [anon_sym_LT] = ACTIONS(3474),
    [anon_sym_use] = ACTIONS(3476),
    [anon_sym_use_BANG] = ACTIONS(3474),
    [anon_sym_do_BANG] = ACTIONS(3474),
    [anon_sym_begin] = ACTIONS(3476),
    [anon_sym_LPAREN2] = ACTIONS(3476),
    [anon_sym_STAR] = ACTIONS(3476),
    [anon_sym_LT2] = ACTIONS(3476),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3474),
    [anon_sym_default] = ACTIONS(3476),
    [anon_sym_or] = ACTIONS(3476),
    [anon_sym_static] = ACTIONS(3476),
    [anon_sym_member] = ACTIONS(3476),
    [anon_sym_interface] = ACTIONS(3476),
    [anon_sym_abstract] = ACTIONS(3476),
    [anon_sym_val] = ACTIONS(3476),
    [anon_sym_override] = ACTIONS(3476),
    [aux_sym_char_token1] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3476),
    [anon_sym_DQUOTE] = ACTIONS(3476),
    [anon_sym_AT_DQUOTE] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [sym_bool] = ACTIONS(3476),
    [sym_unit] = ACTIONS(3474),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3476),
    [sym_op_identifier] = ACTIONS(3476),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3476),
    [anon_sym_PLUS_DOT] = ACTIONS(3476),
    [anon_sym_DASH_DOT] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [anon_sym_AMP_AMP] = ACTIONS(3476),
    [anon_sym_TILDE] = ACTIONS(3474),
    [aux_sym_prefix_op_token1] = ACTIONS(3476),
    [aux_sym_infix_op_token1] = ACTIONS(3474),
    [aux_sym_infix_op_token2] = ACTIONS(3476),
    [anon_sym_PIPE_PIPE] = ACTIONS(3476),
    [anon_sym_BANG_EQ] = ACTIONS(3476),
    [anon_sym_COLON_EQ] = ACTIONS(3474),
    [anon_sym_DOLLAR] = ACTIONS(3476),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3476),
    [sym_int] = ACTIONS(3476),
    [sym_xint] = ACTIONS(3474),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3474),
    [sym__newline] = ACTIONS(3474),
    [sym__dedent] = ACTIONS(3474),
  },
  [1378] = {
    [sym_block_comment] = STATE(1378),
    [sym_compiler_directive_decl] = STATE(1378),
    [sym_fsi_directive_decl] = STATE(1378),
    [sym_preproc_line] = STATE(1378),
    [sym_identifier] = ACTIONS(3519),
    [anon_sym_EQ] = ACTIONS(3517),
    [anon_sym_LBRACK_LT] = ACTIONS(3517),
    [anon_sym_COLON] = ACTIONS(3519),
    [anon_sym_return] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(3519),
    [anon_sym_let] = ACTIONS(3519),
    [anon_sym_let_BANG] = ACTIONS(3517),
    [aux_sym_access_modifier_token1] = ACTIONS(3517),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [anon_sym_COMMA] = ACTIONS(3517),
    [anon_sym_null] = ACTIONS(3519),
    [anon_sym_QMARK] = ACTIONS(3519),
    [anon_sym_COLON_QMARK] = ACTIONS(3519),
    [anon_sym_COLON_COLON] = ACTIONS(3517),
    [anon_sym_AMP] = ACTIONS(3519),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_LT_AT] = ACTIONS(3519),
    [anon_sym_LT_AT_AT] = ACTIONS(3519),
    [anon_sym_DOT] = ACTIONS(3519),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3519),
    [anon_sym_with] = ACTIONS(3519),
    [anon_sym_return_BANG] = ACTIONS(3517),
    [anon_sym_yield] = ACTIONS(3519),
    [anon_sym_yield_BANG] = ACTIONS(3517),
    [anon_sym_lazy] = ACTIONS(3519),
    [anon_sym_assert] = ACTIONS(3519),
    [anon_sym_upcast] = ACTIONS(3519),
    [anon_sym_downcast] = ACTIONS(3519),
    [anon_sym_COLON_GT] = ACTIONS(3517),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3517),
    [anon_sym_for] = ACTIONS(3519),
    [anon_sym_while] = ACTIONS(3519),
    [anon_sym_if] = ACTIONS(3519),
    [anon_sym_fun] = ACTIONS(3519),
    [anon_sym_DASH_GT] = ACTIONS(3519),
    [anon_sym_try] = ACTIONS(3519),
    [anon_sym_match] = ACTIONS(3519),
    [anon_sym_match_BANG] = ACTIONS(3517),
    [anon_sym_function] = ACTIONS(3519),
    [anon_sym_LT_DASH] = ACTIONS(3519),
    [anon_sym_DOT_LBRACK] = ACTIONS(3517),
    [anon_sym_LT] = ACTIONS(3517),
    [anon_sym_use] = ACTIONS(3519),
    [anon_sym_use_BANG] = ACTIONS(3517),
    [anon_sym_do_BANG] = ACTIONS(3517),
    [anon_sym_begin] = ACTIONS(3519),
    [anon_sym_LPAREN2] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_LT2] = ACTIONS(3519),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3517),
    [anon_sym_default] = ACTIONS(3519),
    [anon_sym_or] = ACTIONS(3519),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_member] = ACTIONS(3519),
    [anon_sym_interface] = ACTIONS(3519),
    [anon_sym_abstract] = ACTIONS(3519),
    [anon_sym_val] = ACTIONS(3519),
    [anon_sym_override] = ACTIONS(3519),
    [anon_sym_inherit] = ACTIONS(3519),
    [aux_sym_char_token1] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [anon_sym_AT_DQUOTE] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [sym_bool] = ACTIONS(3519),
    [sym_unit] = ACTIONS(3517),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3519),
    [sym_op_identifier] = ACTIONS(3519),
    [anon_sym_PLUS] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_DOT] = ACTIONS(3519),
    [anon_sym_DASH_DOT] = ACTIONS(3519),
    [anon_sym_PERCENT] = ACTIONS(3519),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3517),
    [aux_sym_prefix_op_token1] = ACTIONS(3519),
    [aux_sym_infix_op_token1] = ACTIONS(3517),
    [aux_sym_infix_op_token2] = ACTIONS(3519),
    [anon_sym_PIPE_PIPE] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_COLON_EQ] = ACTIONS(3517),
    [anon_sym_DOLLAR] = ACTIONS(3519),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3519),
    [sym_int] = ACTIONS(3519),
    [sym_xint] = ACTIONS(3517),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3517),
    [anon_sym_POUNDendif] = ACTIONS(3517),
    [anon_sym_POUNDelse] = ACTIONS(3517),
    [sym__newline] = ACTIONS(3517),
  },
  [1379] = {
    [sym_block_comment] = STATE(1379),
    [sym_compiler_directive_decl] = STATE(1379),
    [sym_fsi_directive_decl] = STATE(1379),
    [sym_preproc_line] = STATE(1379),
    [ts_builtin_sym_end] = ACTIONS(4005),
    [sym_identifier] = ACTIONS(4007),
    [anon_sym_namespace] = ACTIONS(4007),
    [anon_sym_module] = ACTIONS(4007),
    [anon_sym_EQ] = ACTIONS(4005),
    [anon_sym_open] = ACTIONS(4007),
    [anon_sym_LBRACK_LT] = ACTIONS(4005),
    [anon_sym_COLON] = ACTIONS(4007),
    [anon_sym_return] = ACTIONS(4007),
    [anon_sym_type] = ACTIONS(4007),
    [anon_sym_do] = ACTIONS(4007),
    [anon_sym_and] = ACTIONS(4007),
    [anon_sym_let] = ACTIONS(4007),
    [anon_sym_let_BANG] = ACTIONS(4005),
    [aux_sym_access_modifier_token1] = ACTIONS(4005),
    [anon_sym_LPAREN] = ACTIONS(4007),
    [anon_sym_COMMA] = ACTIONS(4005),
    [anon_sym_null] = ACTIONS(4007),
    [anon_sym_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_COLON] = ACTIONS(4005),
    [anon_sym_AMP] = ACTIONS(4007),
    [anon_sym_LBRACK] = ACTIONS(4007),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4005),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_LT_AT] = ACTIONS(4007),
    [anon_sym_LT_AT_AT] = ACTIONS(4007),
    [anon_sym_DOT] = ACTIONS(4007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4005),
    [anon_sym_new] = ACTIONS(4007),
    [anon_sym_with] = ACTIONS(4007),
    [anon_sym_return_BANG] = ACTIONS(4005),
    [anon_sym_yield] = ACTIONS(4007),
    [anon_sym_yield_BANG] = ACTIONS(4005),
    [anon_sym_lazy] = ACTIONS(4007),
    [anon_sym_assert] = ACTIONS(4007),
    [anon_sym_upcast] = ACTIONS(4007),
    [anon_sym_downcast] = ACTIONS(4007),
    [anon_sym_COLON_GT] = ACTIONS(4005),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4005),
    [anon_sym_for] = ACTIONS(4007),
    [anon_sym_while] = ACTIONS(4007),
    [anon_sym_if] = ACTIONS(4007),
    [anon_sym_fun] = ACTIONS(4007),
    [anon_sym_try] = ACTIONS(4007),
    [anon_sym_match] = ACTIONS(4007),
    [anon_sym_match_BANG] = ACTIONS(4005),
    [anon_sym_function] = ACTIONS(4007),
    [anon_sym_LT_DASH] = ACTIONS(4007),
    [anon_sym_DOT_LBRACK] = ACTIONS(4005),
    [anon_sym_LT] = ACTIONS(4005),
    [anon_sym_use] = ACTIONS(4007),
    [anon_sym_use_BANG] = ACTIONS(4005),
    [anon_sym_do_BANG] = ACTIONS(4005),
    [anon_sym_begin] = ACTIONS(4007),
    [anon_sym_LPAREN2] = ACTIONS(4007),
    [anon_sym_default] = ACTIONS(4007),
    [anon_sym_or] = ACTIONS(4007),
    [anon_sym_static] = ACTIONS(4007),
    [anon_sym_member] = ACTIONS(4007),
    [anon_sym_interface] = ACTIONS(4007),
    [anon_sym_exception] = ACTIONS(4007),
    [anon_sym_abstract] = ACTIONS(4007),
    [anon_sym_val] = ACTIONS(4007),
    [anon_sym_override] = ACTIONS(4007),
    [aux_sym_char_token1] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4007),
    [anon_sym_DQUOTE] = ACTIONS(4007),
    [anon_sym_AT_DQUOTE] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [sym_bool] = ACTIONS(4007),
    [sym_unit] = ACTIONS(4005),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4007),
    [sym_op_identifier] = ACTIONS(4007),
    [anon_sym_PLUS] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4007),
    [anon_sym_PLUS_DOT] = ACTIONS(4007),
    [anon_sym_DASH_DOT] = ACTIONS(4007),
    [anon_sym_PERCENT] = ACTIONS(4007),
    [anon_sym_AMP_AMP] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4005),
    [aux_sym_prefix_op_token1] = ACTIONS(4007),
    [aux_sym_infix_op_token1] = ACTIONS(4005),
    [aux_sym_infix_op_token2] = ACTIONS(4007),
    [anon_sym_PIPE_PIPE] = ACTIONS(4007),
    [anon_sym_BANG_EQ] = ACTIONS(4007),
    [anon_sym_COLON_EQ] = ACTIONS(4005),
    [anon_sym_DOLLAR] = ACTIONS(4007),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4007),
    [sym_int] = ACTIONS(4007),
    [sym_xint] = ACTIONS(4005),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4005),
    [anon_sym_POUNDload] = ACTIONS(4005),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4005),
    [sym__newline] = ACTIONS(4005),
  },
  [1380] = {
    [sym_block_comment] = STATE(1380),
    [sym_compiler_directive_decl] = STATE(1380),
    [sym_fsi_directive_decl] = STATE(1380),
    [sym_preproc_line] = STATE(1380),
    [ts_builtin_sym_end] = ACTIONS(4009),
    [sym_identifier] = ACTIONS(4011),
    [anon_sym_namespace] = ACTIONS(4011),
    [anon_sym_module] = ACTIONS(4011),
    [anon_sym_EQ] = ACTIONS(4009),
    [anon_sym_open] = ACTIONS(4011),
    [anon_sym_LBRACK_LT] = ACTIONS(4009),
    [anon_sym_COLON] = ACTIONS(4011),
    [anon_sym_return] = ACTIONS(4011),
    [anon_sym_type] = ACTIONS(4011),
    [anon_sym_do] = ACTIONS(4011),
    [anon_sym_and] = ACTIONS(4011),
    [anon_sym_let] = ACTIONS(4011),
    [anon_sym_let_BANG] = ACTIONS(4009),
    [aux_sym_access_modifier_token1] = ACTIONS(4009),
    [anon_sym_LPAREN] = ACTIONS(4011),
    [anon_sym_COMMA] = ACTIONS(4009),
    [anon_sym_null] = ACTIONS(4011),
    [anon_sym_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(4011),
    [anon_sym_LBRACK] = ACTIONS(4011),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4009),
    [anon_sym_LBRACE] = ACTIONS(4011),
    [anon_sym_LT_AT] = ACTIONS(4011),
    [anon_sym_LT_AT_AT] = ACTIONS(4011),
    [anon_sym_DOT] = ACTIONS(4011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4009),
    [anon_sym_new] = ACTIONS(4011),
    [anon_sym_with] = ACTIONS(4011),
    [anon_sym_return_BANG] = ACTIONS(4009),
    [anon_sym_yield] = ACTIONS(4011),
    [anon_sym_yield_BANG] = ACTIONS(4009),
    [anon_sym_lazy] = ACTIONS(4011),
    [anon_sym_assert] = ACTIONS(4011),
    [anon_sym_upcast] = ACTIONS(4011),
    [anon_sym_downcast] = ACTIONS(4011),
    [anon_sym_COLON_GT] = ACTIONS(4009),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4009),
    [anon_sym_for] = ACTIONS(4011),
    [anon_sym_while] = ACTIONS(4011),
    [anon_sym_if] = ACTIONS(4011),
    [anon_sym_fun] = ACTIONS(4011),
    [anon_sym_try] = ACTIONS(4011),
    [anon_sym_match] = ACTIONS(4011),
    [anon_sym_match_BANG] = ACTIONS(4009),
    [anon_sym_function] = ACTIONS(4011),
    [anon_sym_LT_DASH] = ACTIONS(4011),
    [anon_sym_DOT_LBRACK] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(4009),
    [anon_sym_use] = ACTIONS(4011),
    [anon_sym_use_BANG] = ACTIONS(4009),
    [anon_sym_do_BANG] = ACTIONS(4009),
    [anon_sym_begin] = ACTIONS(4011),
    [anon_sym_LPAREN2] = ACTIONS(4011),
    [anon_sym_default] = ACTIONS(4011),
    [anon_sym_or] = ACTIONS(4011),
    [anon_sym_static] = ACTIONS(4011),
    [anon_sym_member] = ACTIONS(4011),
    [anon_sym_interface] = ACTIONS(4011),
    [anon_sym_exception] = ACTIONS(4011),
    [anon_sym_abstract] = ACTIONS(4011),
    [anon_sym_val] = ACTIONS(4011),
    [anon_sym_override] = ACTIONS(4011),
    [aux_sym_char_token1] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4011),
    [anon_sym_DQUOTE] = ACTIONS(4011),
    [anon_sym_AT_DQUOTE] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [sym_bool] = ACTIONS(4011),
    [sym_unit] = ACTIONS(4009),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4011),
    [sym_op_identifier] = ACTIONS(4011),
    [anon_sym_PLUS] = ACTIONS(4011),
    [anon_sym_DASH] = ACTIONS(4011),
    [anon_sym_PLUS_DOT] = ACTIONS(4011),
    [anon_sym_DASH_DOT] = ACTIONS(4011),
    [anon_sym_PERCENT] = ACTIONS(4011),
    [anon_sym_AMP_AMP] = ACTIONS(4011),
    [anon_sym_TILDE] = ACTIONS(4009),
    [aux_sym_prefix_op_token1] = ACTIONS(4011),
    [aux_sym_infix_op_token1] = ACTIONS(4009),
    [aux_sym_infix_op_token2] = ACTIONS(4011),
    [anon_sym_PIPE_PIPE] = ACTIONS(4011),
    [anon_sym_BANG_EQ] = ACTIONS(4011),
    [anon_sym_COLON_EQ] = ACTIONS(4009),
    [anon_sym_DOLLAR] = ACTIONS(4011),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4011),
    [sym_int] = ACTIONS(4011),
    [sym_xint] = ACTIONS(4009),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4009),
    [anon_sym_POUNDload] = ACTIONS(4009),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4009),
    [sym__newline] = ACTIONS(4009),
  },
  [1381] = {
    [sym_block_comment] = STATE(1381),
    [sym_compiler_directive_decl] = STATE(1381),
    [sym_fsi_directive_decl] = STATE(1381),
    [sym_preproc_line] = STATE(1381),
    [aux_sym_compound_type_repeat1] = STATE(1381),
    [sym_identifier] = ACTIONS(3427),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_LBRACK_LT] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_and] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [aux_sym_access_modifier_token1] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3427),
    [anon_sym_DOT] = ACTIONS(3427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_with] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_COLON_GT] = ACTIONS(3425),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(3427),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_LT_DASH] = ACTIONS(3427),
    [anon_sym_DOT_LBRACK] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(4013),
    [anon_sym_LT2] = ACTIONS(3427),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3425),
    [anon_sym_default] = ACTIONS(3427),
    [anon_sym_or] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_member] = ACTIONS(3427),
    [anon_sym_interface] = ACTIONS(3427),
    [anon_sym_abstract] = ACTIONS(3427),
    [anon_sym_val] = ACTIONS(3427),
    [anon_sym_override] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3427),
    [anon_sym_DASH_DOT] = ACTIONS(3427),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3427),
    [aux_sym_infix_op_token1] = ACTIONS(3425),
    [aux_sym_infix_op_token2] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3427),
    [anon_sym_COLON_EQ] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3427),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
    [sym__dedent] = ACTIONS(3425),
  },
  [1382] = {
    [sym_block_comment] = STATE(1382),
    [sym_compiler_directive_decl] = STATE(1382),
    [sym_fsi_directive_decl] = STATE(1382),
    [sym_preproc_line] = STATE(1382),
    [ts_builtin_sym_end] = ACTIONS(4016),
    [sym_identifier] = ACTIONS(4018),
    [anon_sym_namespace] = ACTIONS(4018),
    [anon_sym_module] = ACTIONS(4018),
    [anon_sym_EQ] = ACTIONS(4016),
    [anon_sym_open] = ACTIONS(4018),
    [anon_sym_LBRACK_LT] = ACTIONS(4016),
    [anon_sym_COLON] = ACTIONS(4018),
    [anon_sym_return] = ACTIONS(4018),
    [anon_sym_type] = ACTIONS(4018),
    [anon_sym_do] = ACTIONS(4018),
    [anon_sym_and] = ACTIONS(4018),
    [anon_sym_let] = ACTIONS(4018),
    [anon_sym_let_BANG] = ACTIONS(4016),
    [aux_sym_access_modifier_token1] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(4018),
    [anon_sym_COMMA] = ACTIONS(4016),
    [anon_sym_null] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_COLON] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4018),
    [anon_sym_LBRACK] = ACTIONS(4018),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4016),
    [anon_sym_LBRACE] = ACTIONS(4018),
    [anon_sym_LT_AT] = ACTIONS(4018),
    [anon_sym_LT_AT_AT] = ACTIONS(4018),
    [anon_sym_DOT] = ACTIONS(4018),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4016),
    [anon_sym_new] = ACTIONS(4018),
    [anon_sym_with] = ACTIONS(4018),
    [anon_sym_return_BANG] = ACTIONS(4016),
    [anon_sym_yield] = ACTIONS(4018),
    [anon_sym_yield_BANG] = ACTIONS(4016),
    [anon_sym_lazy] = ACTIONS(4018),
    [anon_sym_assert] = ACTIONS(4018),
    [anon_sym_upcast] = ACTIONS(4018),
    [anon_sym_downcast] = ACTIONS(4018),
    [anon_sym_COLON_GT] = ACTIONS(4016),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4016),
    [anon_sym_for] = ACTIONS(4018),
    [anon_sym_while] = ACTIONS(4018),
    [anon_sym_if] = ACTIONS(4018),
    [anon_sym_fun] = ACTIONS(4018),
    [anon_sym_try] = ACTIONS(4018),
    [anon_sym_match] = ACTIONS(4018),
    [anon_sym_match_BANG] = ACTIONS(4016),
    [anon_sym_function] = ACTIONS(4018),
    [anon_sym_LT_DASH] = ACTIONS(4018),
    [anon_sym_DOT_LBRACK] = ACTIONS(4016),
    [anon_sym_LT] = ACTIONS(4016),
    [anon_sym_use] = ACTIONS(4018),
    [anon_sym_use_BANG] = ACTIONS(4016),
    [anon_sym_do_BANG] = ACTIONS(4016),
    [anon_sym_begin] = ACTIONS(4018),
    [anon_sym_LPAREN2] = ACTIONS(4018),
    [anon_sym_default] = ACTIONS(4018),
    [anon_sym_or] = ACTIONS(4018),
    [anon_sym_static] = ACTIONS(4018),
    [anon_sym_member] = ACTIONS(4018),
    [anon_sym_interface] = ACTIONS(4018),
    [anon_sym_exception] = ACTIONS(4018),
    [anon_sym_abstract] = ACTIONS(4018),
    [anon_sym_val] = ACTIONS(4018),
    [anon_sym_override] = ACTIONS(4018),
    [aux_sym_char_token1] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(4018),
    [anon_sym_AT_DQUOTE] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [sym_bool] = ACTIONS(4018),
    [sym_unit] = ACTIONS(4016),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4018),
    [sym_op_identifier] = ACTIONS(4018),
    [anon_sym_PLUS] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_PLUS_DOT] = ACTIONS(4018),
    [anon_sym_DASH_DOT] = ACTIONS(4018),
    [anon_sym_PERCENT] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4016),
    [aux_sym_prefix_op_token1] = ACTIONS(4018),
    [aux_sym_infix_op_token1] = ACTIONS(4016),
    [aux_sym_infix_op_token2] = ACTIONS(4018),
    [anon_sym_PIPE_PIPE] = ACTIONS(4018),
    [anon_sym_BANG_EQ] = ACTIONS(4018),
    [anon_sym_COLON_EQ] = ACTIONS(4016),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4018),
    [sym_int] = ACTIONS(4018),
    [sym_xint] = ACTIONS(4016),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4016),
    [anon_sym_POUNDload] = ACTIONS(4016),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4016),
    [sym__newline] = ACTIONS(4016),
  },
  [1383] = {
    [sym_block_comment] = STATE(1383),
    [sym_compiler_directive_decl] = STATE(1383),
    [sym_fsi_directive_decl] = STATE(1383),
    [sym_preproc_line] = STATE(1383),
    [ts_builtin_sym_end] = ACTIONS(4020),
    [sym_identifier] = ACTIONS(4022),
    [anon_sym_namespace] = ACTIONS(4022),
    [anon_sym_module] = ACTIONS(4022),
    [anon_sym_EQ] = ACTIONS(4020),
    [anon_sym_open] = ACTIONS(4022),
    [anon_sym_LBRACK_LT] = ACTIONS(4020),
    [anon_sym_COLON] = ACTIONS(4022),
    [anon_sym_return] = ACTIONS(4022),
    [anon_sym_type] = ACTIONS(4022),
    [anon_sym_do] = ACTIONS(4022),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_let_BANG] = ACTIONS(4020),
    [aux_sym_access_modifier_token1] = ACTIONS(4020),
    [anon_sym_LPAREN] = ACTIONS(4022),
    [anon_sym_COMMA] = ACTIONS(4020),
    [anon_sym_null] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_COLON] = ACTIONS(4020),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4022),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(4022),
    [anon_sym_LT_AT] = ACTIONS(4022),
    [anon_sym_LT_AT_AT] = ACTIONS(4022),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4020),
    [anon_sym_new] = ACTIONS(4022),
    [anon_sym_with] = ACTIONS(4022),
    [anon_sym_return_BANG] = ACTIONS(4020),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_yield_BANG] = ACTIONS(4020),
    [anon_sym_lazy] = ACTIONS(4022),
    [anon_sym_assert] = ACTIONS(4022),
    [anon_sym_upcast] = ACTIONS(4022),
    [anon_sym_downcast] = ACTIONS(4022),
    [anon_sym_COLON_GT] = ACTIONS(4020),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4020),
    [anon_sym_for] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4022),
    [anon_sym_if] = ACTIONS(4022),
    [anon_sym_fun] = ACTIONS(4022),
    [anon_sym_try] = ACTIONS(4022),
    [anon_sym_match] = ACTIONS(4022),
    [anon_sym_match_BANG] = ACTIONS(4020),
    [anon_sym_function] = ACTIONS(4022),
    [anon_sym_LT_DASH] = ACTIONS(4022),
    [anon_sym_DOT_LBRACK] = ACTIONS(4020),
    [anon_sym_LT] = ACTIONS(4020),
    [anon_sym_use] = ACTIONS(4022),
    [anon_sym_use_BANG] = ACTIONS(4020),
    [anon_sym_do_BANG] = ACTIONS(4020),
    [anon_sym_begin] = ACTIONS(4022),
    [anon_sym_LPAREN2] = ACTIONS(4022),
    [anon_sym_default] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_static] = ACTIONS(4022),
    [anon_sym_member] = ACTIONS(4022),
    [anon_sym_interface] = ACTIONS(4022),
    [anon_sym_exception] = ACTIONS(4022),
    [anon_sym_abstract] = ACTIONS(4022),
    [anon_sym_val] = ACTIONS(4022),
    [anon_sym_override] = ACTIONS(4022),
    [aux_sym_char_token1] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4022),
    [anon_sym_DQUOTE] = ACTIONS(4022),
    [anon_sym_AT_DQUOTE] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [sym_bool] = ACTIONS(4022),
    [sym_unit] = ACTIONS(4020),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4022),
    [sym_op_identifier] = ACTIONS(4022),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_PLUS_DOT] = ACTIONS(4022),
    [anon_sym_DASH_DOT] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4022),
    [anon_sym_TILDE] = ACTIONS(4020),
    [aux_sym_prefix_op_token1] = ACTIONS(4022),
    [aux_sym_infix_op_token1] = ACTIONS(4020),
    [aux_sym_infix_op_token2] = ACTIONS(4022),
    [anon_sym_PIPE_PIPE] = ACTIONS(4022),
    [anon_sym_BANG_EQ] = ACTIONS(4022),
    [anon_sym_COLON_EQ] = ACTIONS(4020),
    [anon_sym_DOLLAR] = ACTIONS(4022),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4022),
    [sym_int] = ACTIONS(4022),
    [sym_xint] = ACTIONS(4020),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4020),
    [anon_sym_POUNDload] = ACTIONS(4020),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4020),
    [sym__newline] = ACTIONS(4020),
  },
  [1384] = {
    [sym_block_comment] = STATE(1384),
    [sym_compiler_directive_decl] = STATE(1384),
    [sym_fsi_directive_decl] = STATE(1384),
    [sym_preproc_line] = STATE(1384),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_as] = ACTIONS(3193),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(4024),
    [anon_sym_uy] = ACTIONS(4026),
    [anon_sym_s] = ACTIONS(4028),
    [anon_sym_us] = ACTIONS(4030),
    [anon_sym_l] = ACTIONS(4032),
    [aux_sym_uint32_token1] = ACTIONS(4034),
    [anon_sym_n] = ACTIONS(4036),
    [anon_sym_un] = ACTIONS(4038),
    [anon_sym_L] = ACTIONS(4040),
    [aux_sym_uint64_token1] = ACTIONS(4042),
    [aux_sym_bignum_token1] = ACTIONS(4044),
    [aux_sym_decimal_token1] = ACTIONS(4046),
    [anon_sym_DOT2] = ACTIONS(4048),
    [aux_sym_float_token1] = ACTIONS(4050),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
    [sym__dedent] = ACTIONS(3191),
  },
  [1385] = {
    [sym_block_comment] = STATE(1385),
    [sym_compiler_directive_decl] = STATE(1385),
    [sym_fsi_directive_decl] = STATE(1385),
    [sym_preproc_line] = STATE(1385),
    [ts_builtin_sym_end] = ACTIONS(4052),
    [sym_identifier] = ACTIONS(4054),
    [anon_sym_namespace] = ACTIONS(4054),
    [anon_sym_module] = ACTIONS(4054),
    [anon_sym_EQ] = ACTIONS(4052),
    [anon_sym_open] = ACTIONS(4054),
    [anon_sym_LBRACK_LT] = ACTIONS(4052),
    [anon_sym_COLON] = ACTIONS(4054),
    [anon_sym_return] = ACTIONS(4054),
    [anon_sym_type] = ACTIONS(4054),
    [anon_sym_do] = ACTIONS(4054),
    [anon_sym_and] = ACTIONS(4054),
    [anon_sym_let] = ACTIONS(4054),
    [anon_sym_let_BANG] = ACTIONS(4052),
    [aux_sym_access_modifier_token1] = ACTIONS(4052),
    [anon_sym_LPAREN] = ACTIONS(4054),
    [anon_sym_COMMA] = ACTIONS(4052),
    [anon_sym_null] = ACTIONS(4054),
    [anon_sym_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_COLON] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(4054),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4052),
    [anon_sym_LBRACE] = ACTIONS(4054),
    [anon_sym_LT_AT] = ACTIONS(4054),
    [anon_sym_LT_AT_AT] = ACTIONS(4054),
    [anon_sym_DOT] = ACTIONS(4054),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_with] = ACTIONS(4054),
    [anon_sym_return_BANG] = ACTIONS(4052),
    [anon_sym_yield] = ACTIONS(4054),
    [anon_sym_yield_BANG] = ACTIONS(4052),
    [anon_sym_lazy] = ACTIONS(4054),
    [anon_sym_assert] = ACTIONS(4054),
    [anon_sym_upcast] = ACTIONS(4054),
    [anon_sym_downcast] = ACTIONS(4054),
    [anon_sym_COLON_GT] = ACTIONS(4052),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4052),
    [anon_sym_for] = ACTIONS(4054),
    [anon_sym_while] = ACTIONS(4054),
    [anon_sym_if] = ACTIONS(4054),
    [anon_sym_fun] = ACTIONS(4054),
    [anon_sym_try] = ACTIONS(4054),
    [anon_sym_match] = ACTIONS(4054),
    [anon_sym_match_BANG] = ACTIONS(4052),
    [anon_sym_function] = ACTIONS(4054),
    [anon_sym_LT_DASH] = ACTIONS(4054),
    [anon_sym_DOT_LBRACK] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_use] = ACTIONS(4054),
    [anon_sym_use_BANG] = ACTIONS(4052),
    [anon_sym_do_BANG] = ACTIONS(4052),
    [anon_sym_begin] = ACTIONS(4054),
    [anon_sym_LPAREN2] = ACTIONS(4054),
    [anon_sym_default] = ACTIONS(4054),
    [anon_sym_or] = ACTIONS(4054),
    [anon_sym_static] = ACTIONS(4054),
    [anon_sym_member] = ACTIONS(4054),
    [anon_sym_interface] = ACTIONS(4054),
    [anon_sym_exception] = ACTIONS(4054),
    [anon_sym_abstract] = ACTIONS(4054),
    [anon_sym_val] = ACTIONS(4054),
    [anon_sym_override] = ACTIONS(4054),
    [aux_sym_char_token1] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4054),
    [anon_sym_DQUOTE] = ACTIONS(4054),
    [anon_sym_AT_DQUOTE] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [sym_bool] = ACTIONS(4054),
    [sym_unit] = ACTIONS(4052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4054),
    [sym_op_identifier] = ACTIONS(4054),
    [anon_sym_PLUS] = ACTIONS(4054),
    [anon_sym_DASH] = ACTIONS(4054),
    [anon_sym_PLUS_DOT] = ACTIONS(4054),
    [anon_sym_DASH_DOT] = ACTIONS(4054),
    [anon_sym_PERCENT] = ACTIONS(4054),
    [anon_sym_AMP_AMP] = ACTIONS(4054),
    [anon_sym_TILDE] = ACTIONS(4052),
    [aux_sym_prefix_op_token1] = ACTIONS(4054),
    [aux_sym_infix_op_token1] = ACTIONS(4052),
    [aux_sym_infix_op_token2] = ACTIONS(4054),
    [anon_sym_PIPE_PIPE] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4054),
    [anon_sym_COLON_EQ] = ACTIONS(4052),
    [anon_sym_DOLLAR] = ACTIONS(4054),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4054),
    [sym_int] = ACTIONS(4054),
    [sym_xint] = ACTIONS(4052),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4052),
    [anon_sym_POUNDload] = ACTIONS(4052),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4052),
    [sym__newline] = ACTIONS(4052),
  },
  [1386] = {
    [sym_block_comment] = STATE(1386),
    [sym_compiler_directive_decl] = STATE(1386),
    [sym_fsi_directive_decl] = STATE(1386),
    [sym_preproc_line] = STATE(1386),
    [aux_sym_long_identifier_repeat1] = STATE(1386),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_and] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [aux_sym_access_modifier_token1] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(4056),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_member] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_val] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [anon_sym_POUNDendif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [1387] = {
    [sym_block_comment] = STATE(1387),
    [sym_compiler_directive_decl] = STATE(1387),
    [sym_fsi_directive_decl] = STATE(1387),
    [sym_preproc_line] = STATE(1387),
    [aux_sym_type_argument_repeat1] = STATE(1387),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_LBRACK_LT] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_and] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [aux_sym_access_modifier_token1] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_COLON] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_with] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_LT_DASH] = ACTIONS(3480),
    [anon_sym_DOT_LBRACK] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_default] = ACTIONS(3480),
    [anon_sym_or] = ACTIONS(4059),
    [anon_sym_static] = ACTIONS(3480),
    [anon_sym_member] = ACTIONS(3480),
    [anon_sym_interface] = ACTIONS(3480),
    [anon_sym_abstract] = ACTIONS(3480),
    [anon_sym_val] = ACTIONS(3480),
    [anon_sym_override] = ACTIONS(3480),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3480),
    [anon_sym_DASH_DOT] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3480),
    [aux_sym_infix_op_token1] = ACTIONS(3478),
    [aux_sym_infix_op_token2] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3480),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
    [sym__dedent] = ACTIONS(3478),
  },
  [1388] = {
    [sym_block_comment] = STATE(1388),
    [sym_compiler_directive_decl] = STATE(1388),
    [sym_fsi_directive_decl] = STATE(1388),
    [sym_preproc_line] = STATE(1388),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_LBRACK_LT] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_and] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [aux_sym_access_modifier_token1] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_with] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [anon_sym_DOT_LBRACK] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_default] = ACTIONS(3498),
    [anon_sym_or] = ACTIONS(3498),
    [anon_sym_static] = ACTIONS(3498),
    [anon_sym_member] = ACTIONS(3498),
    [anon_sym_interface] = ACTIONS(3498),
    [anon_sym_abstract] = ACTIONS(3498),
    [anon_sym_val] = ACTIONS(3498),
    [anon_sym_override] = ACTIONS(3498),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3498),
    [anon_sym_DASH_DOT] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3498),
    [aux_sym_infix_op_token1] = ACTIONS(3496),
    [aux_sym_infix_op_token2] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_COLON_EQ] = ACTIONS(3496),
    [anon_sym_DOLLAR] = ACTIONS(3498),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3498),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [anon_sym_POUNDendif] = ACTIONS(3496),
    [anon_sym_POUNDelse] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
  },
  [1389] = {
    [sym_block_comment] = STATE(1389),
    [sym_compiler_directive_decl] = STATE(1389),
    [sym_fsi_directive_decl] = STATE(1389),
    [sym_preproc_line] = STATE(1389),
    [sym_identifier] = ACTIONS(3511),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_LBRACK_LT] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3511),
    [anon_sym_return] = ACTIONS(3511),
    [anon_sym_do] = ACTIONS(3511),
    [anon_sym_and] = ACTIONS(3511),
    [anon_sym_let] = ACTIONS(3511),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [aux_sym_access_modifier_token1] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3511),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3511),
    [anon_sym_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(3511),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_LT_AT] = ACTIONS(3511),
    [anon_sym_LT_AT_AT] = ACTIONS(3511),
    [anon_sym_DOT] = ACTIONS(3511),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3511),
    [anon_sym_with] = ACTIONS(3511),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3511),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3511),
    [anon_sym_assert] = ACTIONS(3511),
    [anon_sym_upcast] = ACTIONS(3511),
    [anon_sym_downcast] = ACTIONS(3511),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3511),
    [anon_sym_while] = ACTIONS(3511),
    [anon_sym_if] = ACTIONS(3511),
    [anon_sym_fun] = ACTIONS(3511),
    [anon_sym_DASH_GT] = ACTIONS(3511),
    [anon_sym_try] = ACTIONS(3511),
    [anon_sym_match] = ACTIONS(3511),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3511),
    [anon_sym_LT_DASH] = ACTIONS(3511),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3511),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3511),
    [anon_sym_LPAREN2] = ACTIONS(3511),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_LT2] = ACTIONS(3511),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3509),
    [anon_sym_default] = ACTIONS(3511),
    [anon_sym_or] = ACTIONS(3511),
    [anon_sym_static] = ACTIONS(3511),
    [anon_sym_member] = ACTIONS(3511),
    [anon_sym_interface] = ACTIONS(3511),
    [anon_sym_abstract] = ACTIONS(3511),
    [anon_sym_val] = ACTIONS(3511),
    [anon_sym_override] = ACTIONS(3511),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3511),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3511),
    [sym_unit] = ACTIONS(3509),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3511),
    [sym_op_identifier] = ACTIONS(3511),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3511),
    [anon_sym_PLUS_DOT] = ACTIONS(3511),
    [anon_sym_DASH_DOT] = ACTIONS(3511),
    [anon_sym_PERCENT] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3511),
    [aux_sym_infix_op_token1] = ACTIONS(3509),
    [aux_sym_infix_op_token2] = ACTIONS(3511),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_BANG_EQ] = ACTIONS(3511),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3511),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3511),
    [sym_int] = ACTIONS(3511),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [anon_sym_POUNDendif] = ACTIONS(3509),
    [anon_sym_POUNDelse] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [1390] = {
    [sym_block_comment] = STATE(1390),
    [sym_compiler_directive_decl] = STATE(1390),
    [sym_fsi_directive_decl] = STATE(1390),
    [sym_preproc_line] = STATE(1390),
    [ts_builtin_sym_end] = ACTIONS(4062),
    [sym_identifier] = ACTIONS(4064),
    [anon_sym_namespace] = ACTIONS(4064),
    [anon_sym_module] = ACTIONS(4064),
    [anon_sym_EQ] = ACTIONS(4062),
    [anon_sym_open] = ACTIONS(4064),
    [anon_sym_LBRACK_LT] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4064),
    [anon_sym_return] = ACTIONS(4064),
    [anon_sym_type] = ACTIONS(4064),
    [anon_sym_do] = ACTIONS(4064),
    [anon_sym_and] = ACTIONS(4064),
    [anon_sym_let] = ACTIONS(4064),
    [anon_sym_let_BANG] = ACTIONS(4062),
    [aux_sym_access_modifier_token1] = ACTIONS(4062),
    [anon_sym_LPAREN] = ACTIONS(4064),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_null] = ACTIONS(4064),
    [anon_sym_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_COLON] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4062),
    [anon_sym_LBRACE] = ACTIONS(4064),
    [anon_sym_LT_AT] = ACTIONS(4064),
    [anon_sym_LT_AT_AT] = ACTIONS(4064),
    [anon_sym_DOT] = ACTIONS(4064),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4062),
    [anon_sym_new] = ACTIONS(4064),
    [anon_sym_with] = ACTIONS(4064),
    [anon_sym_return_BANG] = ACTIONS(4062),
    [anon_sym_yield] = ACTIONS(4064),
    [anon_sym_yield_BANG] = ACTIONS(4062),
    [anon_sym_lazy] = ACTIONS(4064),
    [anon_sym_assert] = ACTIONS(4064),
    [anon_sym_upcast] = ACTIONS(4064),
    [anon_sym_downcast] = ACTIONS(4064),
    [anon_sym_COLON_GT] = ACTIONS(4062),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4062),
    [anon_sym_for] = ACTIONS(4064),
    [anon_sym_while] = ACTIONS(4064),
    [anon_sym_if] = ACTIONS(4064),
    [anon_sym_fun] = ACTIONS(4064),
    [anon_sym_try] = ACTIONS(4064),
    [anon_sym_match] = ACTIONS(4064),
    [anon_sym_match_BANG] = ACTIONS(4062),
    [anon_sym_function] = ACTIONS(4064),
    [anon_sym_LT_DASH] = ACTIONS(4064),
    [anon_sym_DOT_LBRACK] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(4062),
    [anon_sym_use] = ACTIONS(4064),
    [anon_sym_use_BANG] = ACTIONS(4062),
    [anon_sym_do_BANG] = ACTIONS(4062),
    [anon_sym_begin] = ACTIONS(4064),
    [anon_sym_LPAREN2] = ACTIONS(4064),
    [anon_sym_default] = ACTIONS(4064),
    [anon_sym_or] = ACTIONS(4064),
    [anon_sym_static] = ACTIONS(4064),
    [anon_sym_member] = ACTIONS(4064),
    [anon_sym_interface] = ACTIONS(4064),
    [anon_sym_exception] = ACTIONS(4064),
    [anon_sym_abstract] = ACTIONS(4064),
    [anon_sym_val] = ACTIONS(4064),
    [anon_sym_override] = ACTIONS(4064),
    [aux_sym_char_token1] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_AT_DQUOTE] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [sym_bool] = ACTIONS(4064),
    [sym_unit] = ACTIONS(4062),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4064),
    [sym_op_identifier] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4064),
    [anon_sym_DASH] = ACTIONS(4064),
    [anon_sym_PLUS_DOT] = ACTIONS(4064),
    [anon_sym_DASH_DOT] = ACTIONS(4064),
    [anon_sym_PERCENT] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_TILDE] = ACTIONS(4062),
    [aux_sym_prefix_op_token1] = ACTIONS(4064),
    [aux_sym_infix_op_token1] = ACTIONS(4062),
    [aux_sym_infix_op_token2] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_BANG_EQ] = ACTIONS(4064),
    [anon_sym_COLON_EQ] = ACTIONS(4062),
    [anon_sym_DOLLAR] = ACTIONS(4064),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4064),
    [sym_int] = ACTIONS(4064),
    [sym_xint] = ACTIONS(4062),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4062),
    [anon_sym_POUNDload] = ACTIONS(4062),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4062),
    [sym__newline] = ACTIONS(4062),
  },
  [1391] = {
    [sym_block_comment] = STATE(1391),
    [sym_compiler_directive_decl] = STATE(1391),
    [sym_fsi_directive_decl] = STATE(1391),
    [sym_preproc_line] = STATE(1391),
    [aux_sym_long_identifier_repeat1] = STATE(1386),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_LBRACK_LT] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_and] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [aux_sym_access_modifier_token1] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(4066),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_DASH_GT] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_STAR] = ACTIONS(3451),
    [anon_sym_LT2] = ACTIONS(3451),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3449),
    [anon_sym_default] = ACTIONS(3451),
    [anon_sym_or] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_member] = ACTIONS(3451),
    [anon_sym_interface] = ACTIONS(3451),
    [anon_sym_abstract] = ACTIONS(3451),
    [anon_sym_val] = ACTIONS(3451),
    [anon_sym_override] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [anon_sym_POUNDendif] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
  },
  [1392] = {
    [sym__else_expression] = STATE(1983),
    [sym_elif_expression] = STATE(1661),
    [sym_block_comment] = STATE(1392),
    [sym_compiler_directive_decl] = STATE(1392),
    [sym_fsi_directive_decl] = STATE(1392),
    [sym_preproc_line] = STATE(1392),
    [aux_sym_if_expression_repeat1] = STATE(1461),
    [sym_identifier] = ACTIONS(3472),
    [anon_sym_EQ] = ACTIONS(3470),
    [anon_sym_LBRACK_LT] = ACTIONS(3470),
    [anon_sym_COLON] = ACTIONS(3472),
    [anon_sym_return] = ACTIONS(3472),
    [anon_sym_do] = ACTIONS(3472),
    [anon_sym_let] = ACTIONS(3472),
    [anon_sym_let_BANG] = ACTIONS(3470),
    [aux_sym_access_modifier_token1] = ACTIONS(3470),
    [anon_sym_LPAREN] = ACTIONS(3472),
    [anon_sym_COMMA] = ACTIONS(3470),
    [anon_sym_null] = ACTIONS(3472),
    [anon_sym_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_COLON] = ACTIONS(3470),
    [anon_sym_AMP] = ACTIONS(3472),
    [anon_sym_LBRACK] = ACTIONS(3472),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3470),
    [anon_sym_LBRACE] = ACTIONS(3472),
    [anon_sym_LT_AT] = ACTIONS(3472),
    [anon_sym_LT_AT_AT] = ACTIONS(3472),
    [anon_sym_DOT] = ACTIONS(3472),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3470),
    [anon_sym_new] = ACTIONS(3472),
    [anon_sym_with] = ACTIONS(3472),
    [anon_sym_return_BANG] = ACTIONS(3470),
    [anon_sym_yield] = ACTIONS(3472),
    [anon_sym_yield_BANG] = ACTIONS(3470),
    [anon_sym_lazy] = ACTIONS(3472),
    [anon_sym_assert] = ACTIONS(3472),
    [anon_sym_upcast] = ACTIONS(3472),
    [anon_sym_downcast] = ACTIONS(3472),
    [anon_sym_COLON_GT] = ACTIONS(3470),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3470),
    [anon_sym_for] = ACTIONS(3472),
    [anon_sym_while] = ACTIONS(3472),
    [anon_sym_else] = ACTIONS(4068),
    [anon_sym_elif] = ACTIONS(4070),
    [anon_sym_if] = ACTIONS(3472),
    [anon_sym_fun] = ACTIONS(3472),
    [anon_sym_try] = ACTIONS(3472),
    [anon_sym_match] = ACTIONS(3472),
    [anon_sym_match_BANG] = ACTIONS(3470),
    [anon_sym_function] = ACTIONS(3472),
    [anon_sym_LT_DASH] = ACTIONS(3472),
    [anon_sym_DOT_LBRACK] = ACTIONS(3470),
    [anon_sym_LT] = ACTIONS(3470),
    [anon_sym_use] = ACTIONS(3472),
    [anon_sym_use_BANG] = ACTIONS(3470),
    [anon_sym_do_BANG] = ACTIONS(3470),
    [anon_sym_begin] = ACTIONS(3472),
    [anon_sym_LPAREN2] = ACTIONS(3472),
    [anon_sym_DOT_DOT2] = ACTIONS(3470),
    [anon_sym_default] = ACTIONS(3472),
    [anon_sym_or] = ACTIONS(3472),
    [anon_sym_static] = ACTIONS(3472),
    [anon_sym_member] = ACTIONS(3472),
    [anon_sym_interface] = ACTIONS(3472),
    [anon_sym_abstract] = ACTIONS(3472),
    [anon_sym_val] = ACTIONS(3472),
    [anon_sym_override] = ACTIONS(3472),
    [aux_sym_char_token1] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3472),
    [anon_sym_DQUOTE] = ACTIONS(3472),
    [anon_sym_AT_DQUOTE] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [sym_bool] = ACTIONS(3472),
    [sym_unit] = ACTIONS(3470),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3472),
    [sym_op_identifier] = ACTIONS(3472),
    [anon_sym_PLUS] = ACTIONS(3472),
    [anon_sym_DASH] = ACTIONS(3472),
    [anon_sym_PLUS_DOT] = ACTIONS(3472),
    [anon_sym_DASH_DOT] = ACTIONS(3472),
    [anon_sym_PERCENT] = ACTIONS(3472),
    [anon_sym_AMP_AMP] = ACTIONS(3472),
    [anon_sym_TILDE] = ACTIONS(3470),
    [aux_sym_prefix_op_token1] = ACTIONS(3472),
    [aux_sym_infix_op_token1] = ACTIONS(3470),
    [aux_sym_infix_op_token2] = ACTIONS(3472),
    [anon_sym_PIPE_PIPE] = ACTIONS(3472),
    [anon_sym_BANG_EQ] = ACTIONS(3472),
    [anon_sym_COLON_EQ] = ACTIONS(3470),
    [anon_sym_DOLLAR] = ACTIONS(3472),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3472),
    [sym_int] = ACTIONS(3472),
    [sym_xint] = ACTIONS(3470),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3470),
    [sym__newline] = ACTIONS(3470),
    [sym__dedent] = ACTIONS(3470),
  },
  [1393] = {
    [sym_block_comment] = STATE(1393),
    [sym_compiler_directive_decl] = STATE(1393),
    [sym_fsi_directive_decl] = STATE(1393),
    [sym_preproc_line] = STATE(1393),
    [ts_builtin_sym_end] = ACTIONS(4072),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_namespace] = ACTIONS(4074),
    [anon_sym_module] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4072),
    [anon_sym_open] = ACTIONS(4074),
    [anon_sym_LBRACK_LT] = ACTIONS(4072),
    [anon_sym_COLON] = ACTIONS(4074),
    [anon_sym_return] = ACTIONS(4074),
    [anon_sym_type] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_let_BANG] = ACTIONS(4072),
    [aux_sym_access_modifier_token1] = ACTIONS(4072),
    [anon_sym_LPAREN] = ACTIONS(4074),
    [anon_sym_COMMA] = ACTIONS(4072),
    [anon_sym_null] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_COLON] = ACTIONS(4072),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_LT_AT] = ACTIONS(4074),
    [anon_sym_LT_AT_AT] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4072),
    [anon_sym_new] = ACTIONS(4074),
    [anon_sym_with] = ACTIONS(4074),
    [anon_sym_return_BANG] = ACTIONS(4072),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_yield_BANG] = ACTIONS(4072),
    [anon_sym_lazy] = ACTIONS(4074),
    [anon_sym_assert] = ACTIONS(4074),
    [anon_sym_upcast] = ACTIONS(4074),
    [anon_sym_downcast] = ACTIONS(4074),
    [anon_sym_COLON_GT] = ACTIONS(4072),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4072),
    [anon_sym_for] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_fun] = ACTIONS(4074),
    [anon_sym_try] = ACTIONS(4074),
    [anon_sym_match] = ACTIONS(4074),
    [anon_sym_match_BANG] = ACTIONS(4072),
    [anon_sym_function] = ACTIONS(4074),
    [anon_sym_LT_DASH] = ACTIONS(4074),
    [anon_sym_DOT_LBRACK] = ACTIONS(4072),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_use] = ACTIONS(4074),
    [anon_sym_use_BANG] = ACTIONS(4072),
    [anon_sym_do_BANG] = ACTIONS(4072),
    [anon_sym_begin] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(4074),
    [anon_sym_default] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_static] = ACTIONS(4074),
    [anon_sym_member] = ACTIONS(4074),
    [anon_sym_interface] = ACTIONS(4074),
    [anon_sym_exception] = ACTIONS(4074),
    [anon_sym_abstract] = ACTIONS(4074),
    [anon_sym_val] = ACTIONS(4074),
    [anon_sym_override] = ACTIONS(4074),
    [aux_sym_char_token1] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4074),
    [anon_sym_DQUOTE] = ACTIONS(4074),
    [anon_sym_AT_DQUOTE] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [sym_bool] = ACTIONS(4074),
    [sym_unit] = ACTIONS(4072),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4074),
    [sym_op_identifier] = ACTIONS(4074),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_PLUS_DOT] = ACTIONS(4074),
    [anon_sym_DASH_DOT] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_TILDE] = ACTIONS(4072),
    [aux_sym_prefix_op_token1] = ACTIONS(4074),
    [aux_sym_infix_op_token1] = ACTIONS(4072),
    [aux_sym_infix_op_token2] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [anon_sym_BANG_EQ] = ACTIONS(4074),
    [anon_sym_COLON_EQ] = ACTIONS(4072),
    [anon_sym_DOLLAR] = ACTIONS(4074),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4074),
    [sym_int] = ACTIONS(4074),
    [sym_xint] = ACTIONS(4072),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4072),
    [anon_sym_POUNDload] = ACTIONS(4072),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4072),
    [sym__newline] = ACTIONS(4072),
  },
  [1394] = {
    [sym_block_comment] = STATE(1394),
    [sym_compiler_directive_decl] = STATE(1394),
    [sym_fsi_directive_decl] = STATE(1394),
    [sym_preproc_line] = STATE(1394),
    [ts_builtin_sym_end] = ACTIONS(4076),
    [sym_identifier] = ACTIONS(4078),
    [anon_sym_namespace] = ACTIONS(4078),
    [anon_sym_module] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(4076),
    [anon_sym_open] = ACTIONS(4078),
    [anon_sym_LBRACK_LT] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4078),
    [anon_sym_return] = ACTIONS(4078),
    [anon_sym_type] = ACTIONS(4078),
    [anon_sym_do] = ACTIONS(4078),
    [anon_sym_and] = ACTIONS(4078),
    [anon_sym_let] = ACTIONS(4078),
    [anon_sym_let_BANG] = ACTIONS(4076),
    [aux_sym_access_modifier_token1] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_null] = ACTIONS(4078),
    [anon_sym_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(4076),
    [anon_sym_AMP] = ACTIONS(4078),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4078),
    [anon_sym_LT_AT] = ACTIONS(4078),
    [anon_sym_LT_AT_AT] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(4078),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4076),
    [anon_sym_new] = ACTIONS(4078),
    [anon_sym_with] = ACTIONS(4078),
    [anon_sym_return_BANG] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(4078),
    [anon_sym_yield_BANG] = ACTIONS(4076),
    [anon_sym_lazy] = ACTIONS(4078),
    [anon_sym_assert] = ACTIONS(4078),
    [anon_sym_upcast] = ACTIONS(4078),
    [anon_sym_downcast] = ACTIONS(4078),
    [anon_sym_COLON_GT] = ACTIONS(4076),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4076),
    [anon_sym_for] = ACTIONS(4078),
    [anon_sym_while] = ACTIONS(4078),
    [anon_sym_if] = ACTIONS(4078),
    [anon_sym_fun] = ACTIONS(4078),
    [anon_sym_try] = ACTIONS(4078),
    [anon_sym_match] = ACTIONS(4078),
    [anon_sym_match_BANG] = ACTIONS(4076),
    [anon_sym_function] = ACTIONS(4078),
    [anon_sym_LT_DASH] = ACTIONS(4078),
    [anon_sym_DOT_LBRACK] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4076),
    [anon_sym_use] = ACTIONS(4078),
    [anon_sym_use_BANG] = ACTIONS(4076),
    [anon_sym_do_BANG] = ACTIONS(4076),
    [anon_sym_begin] = ACTIONS(4078),
    [anon_sym_LPAREN2] = ACTIONS(4078),
    [anon_sym_default] = ACTIONS(4078),
    [anon_sym_or] = ACTIONS(4078),
    [anon_sym_static] = ACTIONS(4078),
    [anon_sym_member] = ACTIONS(4078),
    [anon_sym_interface] = ACTIONS(4078),
    [anon_sym_exception] = ACTIONS(4078),
    [anon_sym_abstract] = ACTIONS(4078),
    [anon_sym_val] = ACTIONS(4078),
    [anon_sym_override] = ACTIONS(4078),
    [aux_sym_char_token1] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4078),
    [anon_sym_DQUOTE] = ACTIONS(4078),
    [anon_sym_AT_DQUOTE] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [sym_bool] = ACTIONS(4078),
    [sym_unit] = ACTIONS(4076),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4078),
    [sym_op_identifier] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(4078),
    [anon_sym_PLUS_DOT] = ACTIONS(4078),
    [anon_sym_DASH_DOT] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [anon_sym_AMP_AMP] = ACTIONS(4078),
    [anon_sym_TILDE] = ACTIONS(4076),
    [aux_sym_prefix_op_token1] = ACTIONS(4078),
    [aux_sym_infix_op_token1] = ACTIONS(4076),
    [aux_sym_infix_op_token2] = ACTIONS(4078),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_BANG_EQ] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4076),
    [anon_sym_DOLLAR] = ACTIONS(4078),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4078),
    [sym_int] = ACTIONS(4078),
    [sym_xint] = ACTIONS(4076),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4076),
    [anon_sym_POUNDload] = ACTIONS(4076),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4076),
    [sym__newline] = ACTIONS(4076),
  },
  [1395] = {
    [sym_block_comment] = STATE(1395),
    [sym_compiler_directive_decl] = STATE(1395),
    [sym_fsi_directive_decl] = STATE(1395),
    [sym_preproc_line] = STATE(1395),
    [ts_builtin_sym_end] = ACTIONS(4080),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_namespace] = ACTIONS(4082),
    [anon_sym_module] = ACTIONS(4082),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_open] = ACTIONS(4082),
    [anon_sym_LBRACK_LT] = ACTIONS(4080),
    [anon_sym_COLON] = ACTIONS(4082),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_type] = ACTIONS(4082),
    [anon_sym_do] = ACTIONS(4082),
    [anon_sym_and] = ACTIONS(4082),
    [anon_sym_let] = ACTIONS(4082),
    [anon_sym_let_BANG] = ACTIONS(4080),
    [aux_sym_access_modifier_token1] = ACTIONS(4080),
    [anon_sym_LPAREN] = ACTIONS(4082),
    [anon_sym_COMMA] = ACTIONS(4080),
    [anon_sym_null] = ACTIONS(4082),
    [anon_sym_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_COLON] = ACTIONS(4080),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_LBRACK] = ACTIONS(4082),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(4082),
    [anon_sym_LT_AT] = ACTIONS(4082),
    [anon_sym_LT_AT_AT] = ACTIONS(4082),
    [anon_sym_DOT] = ACTIONS(4082),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4080),
    [anon_sym_new] = ACTIONS(4082),
    [anon_sym_with] = ACTIONS(4082),
    [anon_sym_return_BANG] = ACTIONS(4080),
    [anon_sym_yield] = ACTIONS(4082),
    [anon_sym_yield_BANG] = ACTIONS(4080),
    [anon_sym_lazy] = ACTIONS(4082),
    [anon_sym_assert] = ACTIONS(4082),
    [anon_sym_upcast] = ACTIONS(4082),
    [anon_sym_downcast] = ACTIONS(4082),
    [anon_sym_COLON_GT] = ACTIONS(4080),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4080),
    [anon_sym_for] = ACTIONS(4082),
    [anon_sym_while] = ACTIONS(4082),
    [anon_sym_if] = ACTIONS(4082),
    [anon_sym_fun] = ACTIONS(4082),
    [anon_sym_try] = ACTIONS(4082),
    [anon_sym_match] = ACTIONS(4082),
    [anon_sym_match_BANG] = ACTIONS(4080),
    [anon_sym_function] = ACTIONS(4082),
    [anon_sym_LT_DASH] = ACTIONS(4082),
    [anon_sym_DOT_LBRACK] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(4080),
    [anon_sym_use] = ACTIONS(4082),
    [anon_sym_use_BANG] = ACTIONS(4080),
    [anon_sym_do_BANG] = ACTIONS(4080),
    [anon_sym_begin] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4082),
    [anon_sym_default] = ACTIONS(4082),
    [anon_sym_or] = ACTIONS(4082),
    [anon_sym_static] = ACTIONS(4082),
    [anon_sym_member] = ACTIONS(4082),
    [anon_sym_interface] = ACTIONS(4082),
    [anon_sym_exception] = ACTIONS(4082),
    [anon_sym_abstract] = ACTIONS(4082),
    [anon_sym_val] = ACTIONS(4082),
    [anon_sym_override] = ACTIONS(4082),
    [aux_sym_char_token1] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4082),
    [anon_sym_DQUOTE] = ACTIONS(4082),
    [anon_sym_AT_DQUOTE] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [sym_bool] = ACTIONS(4082),
    [sym_unit] = ACTIONS(4080),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4082),
    [sym_op_identifier] = ACTIONS(4082),
    [anon_sym_PLUS] = ACTIONS(4082),
    [anon_sym_DASH] = ACTIONS(4082),
    [anon_sym_PLUS_DOT] = ACTIONS(4082),
    [anon_sym_DASH_DOT] = ACTIONS(4082),
    [anon_sym_PERCENT] = ACTIONS(4082),
    [anon_sym_AMP_AMP] = ACTIONS(4082),
    [anon_sym_TILDE] = ACTIONS(4080),
    [aux_sym_prefix_op_token1] = ACTIONS(4082),
    [aux_sym_infix_op_token1] = ACTIONS(4080),
    [aux_sym_infix_op_token2] = ACTIONS(4082),
    [anon_sym_PIPE_PIPE] = ACTIONS(4082),
    [anon_sym_BANG_EQ] = ACTIONS(4082),
    [anon_sym_COLON_EQ] = ACTIONS(4080),
    [anon_sym_DOLLAR] = ACTIONS(4082),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4082),
    [sym_int] = ACTIONS(4082),
    [sym_xint] = ACTIONS(4080),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4080),
    [anon_sym_POUNDload] = ACTIONS(4080),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4080),
    [sym__newline] = ACTIONS(4080),
  },
  [1396] = {
    [sym_block_comment] = STATE(1396),
    [sym_compiler_directive_decl] = STATE(1396),
    [sym_fsi_directive_decl] = STATE(1396),
    [sym_preproc_line] = STATE(1396),
    [ts_builtin_sym_end] = ACTIONS(4084),
    [sym_identifier] = ACTIONS(4086),
    [anon_sym_namespace] = ACTIONS(4086),
    [anon_sym_module] = ACTIONS(4086),
    [anon_sym_EQ] = ACTIONS(4084),
    [anon_sym_open] = ACTIONS(4086),
    [anon_sym_LBRACK_LT] = ACTIONS(4084),
    [anon_sym_COLON] = ACTIONS(4086),
    [anon_sym_return] = ACTIONS(4086),
    [anon_sym_type] = ACTIONS(4086),
    [anon_sym_do] = ACTIONS(4086),
    [anon_sym_and] = ACTIONS(4086),
    [anon_sym_let] = ACTIONS(4086),
    [anon_sym_let_BANG] = ACTIONS(4084),
    [aux_sym_access_modifier_token1] = ACTIONS(4084),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_COMMA] = ACTIONS(4084),
    [anon_sym_null] = ACTIONS(4086),
    [anon_sym_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_COLON] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4084),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_LT_AT] = ACTIONS(4086),
    [anon_sym_LT_AT_AT] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4086),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4084),
    [anon_sym_new] = ACTIONS(4086),
    [anon_sym_with] = ACTIONS(4086),
    [anon_sym_return_BANG] = ACTIONS(4084),
    [anon_sym_yield] = ACTIONS(4086),
    [anon_sym_yield_BANG] = ACTIONS(4084),
    [anon_sym_lazy] = ACTIONS(4086),
    [anon_sym_assert] = ACTIONS(4086),
    [anon_sym_upcast] = ACTIONS(4086),
    [anon_sym_downcast] = ACTIONS(4086),
    [anon_sym_COLON_GT] = ACTIONS(4084),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4084),
    [anon_sym_for] = ACTIONS(4086),
    [anon_sym_while] = ACTIONS(4086),
    [anon_sym_if] = ACTIONS(4086),
    [anon_sym_fun] = ACTIONS(4086),
    [anon_sym_try] = ACTIONS(4086),
    [anon_sym_match] = ACTIONS(4086),
    [anon_sym_match_BANG] = ACTIONS(4084),
    [anon_sym_function] = ACTIONS(4086),
    [anon_sym_LT_DASH] = ACTIONS(4086),
    [anon_sym_DOT_LBRACK] = ACTIONS(4084),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_use] = ACTIONS(4086),
    [anon_sym_use_BANG] = ACTIONS(4084),
    [anon_sym_do_BANG] = ACTIONS(4084),
    [anon_sym_begin] = ACTIONS(4086),
    [anon_sym_LPAREN2] = ACTIONS(4086),
    [anon_sym_default] = ACTIONS(4086),
    [anon_sym_or] = ACTIONS(4086),
    [anon_sym_static] = ACTIONS(4086),
    [anon_sym_member] = ACTIONS(4086),
    [anon_sym_interface] = ACTIONS(4086),
    [anon_sym_exception] = ACTIONS(4086),
    [anon_sym_abstract] = ACTIONS(4086),
    [anon_sym_val] = ACTIONS(4086),
    [anon_sym_override] = ACTIONS(4086),
    [aux_sym_char_token1] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4086),
    [anon_sym_DQUOTE] = ACTIONS(4086),
    [anon_sym_AT_DQUOTE] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [sym_bool] = ACTIONS(4086),
    [sym_unit] = ACTIONS(4084),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4086),
    [sym_op_identifier] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4086),
    [anon_sym_DASH] = ACTIONS(4086),
    [anon_sym_PLUS_DOT] = ACTIONS(4086),
    [anon_sym_DASH_DOT] = ACTIONS(4086),
    [anon_sym_PERCENT] = ACTIONS(4086),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_TILDE] = ACTIONS(4084),
    [aux_sym_prefix_op_token1] = ACTIONS(4086),
    [aux_sym_infix_op_token1] = ACTIONS(4084),
    [aux_sym_infix_op_token2] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_COLON_EQ] = ACTIONS(4084),
    [anon_sym_DOLLAR] = ACTIONS(4086),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4086),
    [sym_int] = ACTIONS(4086),
    [sym_xint] = ACTIONS(4084),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4084),
    [anon_sym_POUNDload] = ACTIONS(4084),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4084),
    [sym__newline] = ACTIONS(4084),
  },
  [1397] = {
    [sym_block_comment] = STATE(1397),
    [sym_compiler_directive_decl] = STATE(1397),
    [sym_fsi_directive_decl] = STATE(1397),
    [sym_preproc_line] = STATE(1397),
    [aux_sym_type_argument_repeat1] = STATE(1397),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_LBRACK_LT] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [aux_sym_access_modifier_token1] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_COLON] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_with] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_LT_DASH] = ACTIONS(3480),
    [anon_sym_DOT_LBRACK] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_DOT_DOT2] = ACTIONS(3478),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_default] = ACTIONS(3480),
    [anon_sym_or] = ACTIONS(4088),
    [anon_sym_static] = ACTIONS(3480),
    [anon_sym_member] = ACTIONS(3480),
    [anon_sym_interface] = ACTIONS(3480),
    [anon_sym_abstract] = ACTIONS(3480),
    [anon_sym_val] = ACTIONS(3480),
    [anon_sym_override] = ACTIONS(3480),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3480),
    [anon_sym_DASH_DOT] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3480),
    [aux_sym_infix_op_token1] = ACTIONS(3478),
    [aux_sym_infix_op_token2] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3480),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
    [sym__dedent] = ACTIONS(3478),
  },
  [1398] = {
    [sym_block_comment] = STATE(1398),
    [sym_compiler_directive_decl] = STATE(1398),
    [sym_fsi_directive_decl] = STATE(1398),
    [sym_preproc_line] = STATE(1398),
    [ts_builtin_sym_end] = ACTIONS(4091),
    [sym_identifier] = ACTIONS(4093),
    [anon_sym_namespace] = ACTIONS(4093),
    [anon_sym_module] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(4091),
    [anon_sym_open] = ACTIONS(4093),
    [anon_sym_LBRACK_LT] = ACTIONS(4091),
    [anon_sym_COLON] = ACTIONS(4093),
    [anon_sym_return] = ACTIONS(4093),
    [anon_sym_type] = ACTIONS(4093),
    [anon_sym_do] = ACTIONS(4093),
    [anon_sym_and] = ACTIONS(4093),
    [anon_sym_let] = ACTIONS(4093),
    [anon_sym_let_BANG] = ACTIONS(4091),
    [aux_sym_access_modifier_token1] = ACTIONS(4091),
    [anon_sym_LPAREN] = ACTIONS(4093),
    [anon_sym_COMMA] = ACTIONS(4091),
    [anon_sym_null] = ACTIONS(4093),
    [anon_sym_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_COLON] = ACTIONS(4091),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(4093),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4091),
    [anon_sym_LBRACE] = ACTIONS(4093),
    [anon_sym_LT_AT] = ACTIONS(4093),
    [anon_sym_LT_AT_AT] = ACTIONS(4093),
    [anon_sym_DOT] = ACTIONS(4093),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4091),
    [anon_sym_new] = ACTIONS(4093),
    [anon_sym_with] = ACTIONS(4093),
    [anon_sym_return_BANG] = ACTIONS(4091),
    [anon_sym_yield] = ACTIONS(4093),
    [anon_sym_yield_BANG] = ACTIONS(4091),
    [anon_sym_lazy] = ACTIONS(4093),
    [anon_sym_assert] = ACTIONS(4093),
    [anon_sym_upcast] = ACTIONS(4093),
    [anon_sym_downcast] = ACTIONS(4093),
    [anon_sym_COLON_GT] = ACTIONS(4091),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4091),
    [anon_sym_for] = ACTIONS(4093),
    [anon_sym_while] = ACTIONS(4093),
    [anon_sym_if] = ACTIONS(4093),
    [anon_sym_fun] = ACTIONS(4093),
    [anon_sym_try] = ACTIONS(4093),
    [anon_sym_match] = ACTIONS(4093),
    [anon_sym_match_BANG] = ACTIONS(4091),
    [anon_sym_function] = ACTIONS(4093),
    [anon_sym_LT_DASH] = ACTIONS(4093),
    [anon_sym_DOT_LBRACK] = ACTIONS(4091),
    [anon_sym_LT] = ACTIONS(4091),
    [anon_sym_use] = ACTIONS(4093),
    [anon_sym_use_BANG] = ACTIONS(4091),
    [anon_sym_do_BANG] = ACTIONS(4091),
    [anon_sym_begin] = ACTIONS(4093),
    [anon_sym_LPAREN2] = ACTIONS(4093),
    [anon_sym_default] = ACTIONS(4093),
    [anon_sym_or] = ACTIONS(4093),
    [anon_sym_static] = ACTIONS(4093),
    [anon_sym_member] = ACTIONS(4093),
    [anon_sym_interface] = ACTIONS(4093),
    [anon_sym_exception] = ACTIONS(4093),
    [anon_sym_abstract] = ACTIONS(4093),
    [anon_sym_val] = ACTIONS(4093),
    [anon_sym_override] = ACTIONS(4093),
    [aux_sym_char_token1] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4093),
    [anon_sym_DQUOTE] = ACTIONS(4093),
    [anon_sym_AT_DQUOTE] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [sym_bool] = ACTIONS(4093),
    [sym_unit] = ACTIONS(4091),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4093),
    [sym_op_identifier] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS_DOT] = ACTIONS(4093),
    [anon_sym_DASH_DOT] = ACTIONS(4093),
    [anon_sym_PERCENT] = ACTIONS(4093),
    [anon_sym_AMP_AMP] = ACTIONS(4093),
    [anon_sym_TILDE] = ACTIONS(4091),
    [aux_sym_prefix_op_token1] = ACTIONS(4093),
    [aux_sym_infix_op_token1] = ACTIONS(4091),
    [aux_sym_infix_op_token2] = ACTIONS(4093),
    [anon_sym_PIPE_PIPE] = ACTIONS(4093),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_COLON_EQ] = ACTIONS(4091),
    [anon_sym_DOLLAR] = ACTIONS(4093),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4093),
    [sym_int] = ACTIONS(4093),
    [sym_xint] = ACTIONS(4091),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4091),
    [anon_sym_POUNDload] = ACTIONS(4091),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4091),
    [sym__newline] = ACTIONS(4091),
  },
  [1399] = {
    [sym__else_expression] = STATE(2098),
    [sym_elif_expression] = STATE(1633),
    [sym_block_comment] = STATE(1399),
    [sym_compiler_directive_decl] = STATE(1399),
    [sym_fsi_directive_decl] = STATE(1399),
    [sym_preproc_line] = STATE(1399),
    [aux_sym_if_expression_repeat1] = STATE(1318),
    [sym_identifier] = ACTIONS(3472),
    [anon_sym_EQ] = ACTIONS(3470),
    [anon_sym_LBRACK_LT] = ACTIONS(3470),
    [anon_sym_COLON] = ACTIONS(3472),
    [anon_sym_return] = ACTIONS(3472),
    [anon_sym_do] = ACTIONS(3472),
    [anon_sym_and] = ACTIONS(3472),
    [anon_sym_let] = ACTIONS(3472),
    [anon_sym_let_BANG] = ACTIONS(3470),
    [aux_sym_access_modifier_token1] = ACTIONS(3470),
    [anon_sym_LPAREN] = ACTIONS(3472),
    [anon_sym_COMMA] = ACTIONS(3470),
    [anon_sym_null] = ACTIONS(3472),
    [anon_sym_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_COLON] = ACTIONS(3470),
    [anon_sym_AMP] = ACTIONS(3472),
    [anon_sym_LBRACK] = ACTIONS(3472),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3470),
    [anon_sym_LBRACE] = ACTIONS(3472),
    [anon_sym_LT_AT] = ACTIONS(3472),
    [anon_sym_LT_AT_AT] = ACTIONS(3472),
    [anon_sym_DOT] = ACTIONS(3472),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3470),
    [anon_sym_new] = ACTIONS(3472),
    [anon_sym_with] = ACTIONS(3472),
    [anon_sym_return_BANG] = ACTIONS(3470),
    [anon_sym_yield] = ACTIONS(3472),
    [anon_sym_yield_BANG] = ACTIONS(3470),
    [anon_sym_lazy] = ACTIONS(3472),
    [anon_sym_assert] = ACTIONS(3472),
    [anon_sym_upcast] = ACTIONS(3472),
    [anon_sym_downcast] = ACTIONS(3472),
    [anon_sym_COLON_GT] = ACTIONS(3470),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3470),
    [anon_sym_for] = ACTIONS(3472),
    [anon_sym_while] = ACTIONS(3472),
    [anon_sym_else] = ACTIONS(3847),
    [anon_sym_elif] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3472),
    [anon_sym_fun] = ACTIONS(3472),
    [anon_sym_try] = ACTIONS(3472),
    [anon_sym_match] = ACTIONS(3472),
    [anon_sym_match_BANG] = ACTIONS(3470),
    [anon_sym_function] = ACTIONS(3472),
    [anon_sym_LT_DASH] = ACTIONS(3472),
    [anon_sym_DOT_LBRACK] = ACTIONS(3470),
    [anon_sym_LT] = ACTIONS(3470),
    [anon_sym_use] = ACTIONS(3472),
    [anon_sym_use_BANG] = ACTIONS(3470),
    [anon_sym_do_BANG] = ACTIONS(3470),
    [anon_sym_begin] = ACTIONS(3472),
    [anon_sym_LPAREN2] = ACTIONS(3472),
    [anon_sym_default] = ACTIONS(3472),
    [anon_sym_or] = ACTIONS(3472),
    [anon_sym_static] = ACTIONS(3472),
    [anon_sym_member] = ACTIONS(3472),
    [anon_sym_interface] = ACTIONS(3472),
    [anon_sym_abstract] = ACTIONS(3472),
    [anon_sym_val] = ACTIONS(3472),
    [anon_sym_override] = ACTIONS(3472),
    [aux_sym_char_token1] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3472),
    [anon_sym_DQUOTE] = ACTIONS(3472),
    [anon_sym_AT_DQUOTE] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [sym_bool] = ACTIONS(3472),
    [sym_unit] = ACTIONS(3470),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3472),
    [sym_op_identifier] = ACTIONS(3472),
    [anon_sym_PLUS] = ACTIONS(3472),
    [anon_sym_DASH] = ACTIONS(3472),
    [anon_sym_PLUS_DOT] = ACTIONS(3472),
    [anon_sym_DASH_DOT] = ACTIONS(3472),
    [anon_sym_PERCENT] = ACTIONS(3472),
    [anon_sym_AMP_AMP] = ACTIONS(3472),
    [anon_sym_TILDE] = ACTIONS(3470),
    [aux_sym_prefix_op_token1] = ACTIONS(3472),
    [aux_sym_infix_op_token1] = ACTIONS(3470),
    [aux_sym_infix_op_token2] = ACTIONS(3472),
    [anon_sym_PIPE_PIPE] = ACTIONS(3472),
    [anon_sym_BANG_EQ] = ACTIONS(3472),
    [anon_sym_COLON_EQ] = ACTIONS(3470),
    [anon_sym_DOLLAR] = ACTIONS(3472),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3472),
    [sym_int] = ACTIONS(3472),
    [sym_xint] = ACTIONS(3470),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3470),
    [sym__newline] = ACTIONS(3470),
    [sym__dedent] = ACTIONS(3470),
  },
  [1400] = {
    [sym_block_comment] = STATE(1400),
    [sym_compiler_directive_decl] = STATE(1400),
    [sym_fsi_directive_decl] = STATE(1400),
    [sym_preproc_line] = STATE(1400),
    [aux_sym_type_argument_repeat1] = STATE(1435),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_LBRACK_LT] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_and] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [aux_sym_access_modifier_token1] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_with] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [anon_sym_DOT_LBRACK] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_default] = ACTIONS(3498),
    [anon_sym_or] = ACTIONS(4095),
    [anon_sym_static] = ACTIONS(3498),
    [anon_sym_member] = ACTIONS(3498),
    [anon_sym_interface] = ACTIONS(3498),
    [anon_sym_abstract] = ACTIONS(3498),
    [anon_sym_val] = ACTIONS(3498),
    [anon_sym_override] = ACTIONS(3498),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3498),
    [anon_sym_DASH_DOT] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3498),
    [aux_sym_infix_op_token1] = ACTIONS(3496),
    [aux_sym_infix_op_token2] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_COLON_EQ] = ACTIONS(3496),
    [anon_sym_DOLLAR] = ACTIONS(3498),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3498),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [anon_sym_POUNDendif] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
  },
  [1401] = {
    [sym_block_comment] = STATE(1401),
    [sym_compiler_directive_decl] = STATE(1401),
    [sym_fsi_directive_decl] = STATE(1401),
    [sym_preproc_line] = STATE(1401),
    [ts_builtin_sym_end] = ACTIONS(4098),
    [sym_identifier] = ACTIONS(4100),
    [anon_sym_namespace] = ACTIONS(4100),
    [anon_sym_module] = ACTIONS(4100),
    [anon_sym_EQ] = ACTIONS(4098),
    [anon_sym_open] = ACTIONS(4100),
    [anon_sym_LBRACK_LT] = ACTIONS(4098),
    [anon_sym_COLON] = ACTIONS(4100),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_type] = ACTIONS(4100),
    [anon_sym_do] = ACTIONS(4100),
    [anon_sym_and] = ACTIONS(4100),
    [anon_sym_let] = ACTIONS(4100),
    [anon_sym_let_BANG] = ACTIONS(4098),
    [aux_sym_access_modifier_token1] = ACTIONS(4098),
    [anon_sym_LPAREN] = ACTIONS(4100),
    [anon_sym_COMMA] = ACTIONS(4098),
    [anon_sym_null] = ACTIONS(4100),
    [anon_sym_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_COLON] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4100),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4098),
    [anon_sym_LBRACE] = ACTIONS(4100),
    [anon_sym_LT_AT] = ACTIONS(4100),
    [anon_sym_LT_AT_AT] = ACTIONS(4100),
    [anon_sym_DOT] = ACTIONS(4100),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4098),
    [anon_sym_new] = ACTIONS(4100),
    [anon_sym_with] = ACTIONS(4100),
    [anon_sym_return_BANG] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4100),
    [anon_sym_yield_BANG] = ACTIONS(4098),
    [anon_sym_lazy] = ACTIONS(4100),
    [anon_sym_assert] = ACTIONS(4100),
    [anon_sym_upcast] = ACTIONS(4100),
    [anon_sym_downcast] = ACTIONS(4100),
    [anon_sym_COLON_GT] = ACTIONS(4098),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4098),
    [anon_sym_for] = ACTIONS(4100),
    [anon_sym_while] = ACTIONS(4100),
    [anon_sym_if] = ACTIONS(4100),
    [anon_sym_fun] = ACTIONS(4100),
    [anon_sym_try] = ACTIONS(4100),
    [anon_sym_match] = ACTIONS(4100),
    [anon_sym_match_BANG] = ACTIONS(4098),
    [anon_sym_function] = ACTIONS(4100),
    [anon_sym_LT_DASH] = ACTIONS(4100),
    [anon_sym_DOT_LBRACK] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(4098),
    [anon_sym_use] = ACTIONS(4100),
    [anon_sym_use_BANG] = ACTIONS(4098),
    [anon_sym_do_BANG] = ACTIONS(4098),
    [anon_sym_begin] = ACTIONS(4100),
    [anon_sym_LPAREN2] = ACTIONS(4100),
    [anon_sym_default] = ACTIONS(4100),
    [anon_sym_or] = ACTIONS(4100),
    [anon_sym_static] = ACTIONS(4100),
    [anon_sym_member] = ACTIONS(4100),
    [anon_sym_interface] = ACTIONS(4100),
    [anon_sym_exception] = ACTIONS(4100),
    [anon_sym_abstract] = ACTIONS(4100),
    [anon_sym_val] = ACTIONS(4100),
    [anon_sym_override] = ACTIONS(4100),
    [aux_sym_char_token1] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4100),
    [anon_sym_DQUOTE] = ACTIONS(4100),
    [anon_sym_AT_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [sym_bool] = ACTIONS(4100),
    [sym_unit] = ACTIONS(4098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4100),
    [sym_op_identifier] = ACTIONS(4100),
    [anon_sym_PLUS] = ACTIONS(4100),
    [anon_sym_DASH] = ACTIONS(4100),
    [anon_sym_PLUS_DOT] = ACTIONS(4100),
    [anon_sym_DASH_DOT] = ACTIONS(4100),
    [anon_sym_PERCENT] = ACTIONS(4100),
    [anon_sym_AMP_AMP] = ACTIONS(4100),
    [anon_sym_TILDE] = ACTIONS(4098),
    [aux_sym_prefix_op_token1] = ACTIONS(4100),
    [aux_sym_infix_op_token1] = ACTIONS(4098),
    [aux_sym_infix_op_token2] = ACTIONS(4100),
    [anon_sym_PIPE_PIPE] = ACTIONS(4100),
    [anon_sym_BANG_EQ] = ACTIONS(4100),
    [anon_sym_COLON_EQ] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4100),
    [sym_int] = ACTIONS(4100),
    [sym_xint] = ACTIONS(4098),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4098),
    [anon_sym_POUNDload] = ACTIONS(4098),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4098),
    [sym__newline] = ACTIONS(4098),
  },
  [1402] = {
    [sym_block_comment] = STATE(1402),
    [sym_compiler_directive_decl] = STATE(1402),
    [sym_fsi_directive_decl] = STATE(1402),
    [sym_preproc_line] = STATE(1402),
    [ts_builtin_sym_end] = ACTIONS(4102),
    [sym_identifier] = ACTIONS(4104),
    [anon_sym_namespace] = ACTIONS(4104),
    [anon_sym_module] = ACTIONS(4104),
    [anon_sym_EQ] = ACTIONS(4102),
    [anon_sym_open] = ACTIONS(4104),
    [anon_sym_LBRACK_LT] = ACTIONS(4102),
    [anon_sym_COLON] = ACTIONS(4104),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_type] = ACTIONS(4104),
    [anon_sym_do] = ACTIONS(4104),
    [anon_sym_and] = ACTIONS(4104),
    [anon_sym_let] = ACTIONS(4104),
    [anon_sym_let_BANG] = ACTIONS(4102),
    [aux_sym_access_modifier_token1] = ACTIONS(4102),
    [anon_sym_LPAREN] = ACTIONS(4104),
    [anon_sym_COMMA] = ACTIONS(4102),
    [anon_sym_null] = ACTIONS(4104),
    [anon_sym_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_COLON] = ACTIONS(4102),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4104),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4102),
    [anon_sym_LBRACE] = ACTIONS(4104),
    [anon_sym_LT_AT] = ACTIONS(4104),
    [anon_sym_LT_AT_AT] = ACTIONS(4104),
    [anon_sym_DOT] = ACTIONS(4104),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4102),
    [anon_sym_new] = ACTIONS(4104),
    [anon_sym_with] = ACTIONS(4104),
    [anon_sym_return_BANG] = ACTIONS(4102),
    [anon_sym_yield] = ACTIONS(4104),
    [anon_sym_yield_BANG] = ACTIONS(4102),
    [anon_sym_lazy] = ACTIONS(4104),
    [anon_sym_assert] = ACTIONS(4104),
    [anon_sym_upcast] = ACTIONS(4104),
    [anon_sym_downcast] = ACTIONS(4104),
    [anon_sym_COLON_GT] = ACTIONS(4102),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4102),
    [anon_sym_for] = ACTIONS(4104),
    [anon_sym_while] = ACTIONS(4104),
    [anon_sym_if] = ACTIONS(4104),
    [anon_sym_fun] = ACTIONS(4104),
    [anon_sym_try] = ACTIONS(4104),
    [anon_sym_match] = ACTIONS(4104),
    [anon_sym_match_BANG] = ACTIONS(4102),
    [anon_sym_function] = ACTIONS(4104),
    [anon_sym_LT_DASH] = ACTIONS(4104),
    [anon_sym_DOT_LBRACK] = ACTIONS(4102),
    [anon_sym_LT] = ACTIONS(4102),
    [anon_sym_use] = ACTIONS(4104),
    [anon_sym_use_BANG] = ACTIONS(4102),
    [anon_sym_do_BANG] = ACTIONS(4102),
    [anon_sym_begin] = ACTIONS(4104),
    [anon_sym_LPAREN2] = ACTIONS(4104),
    [anon_sym_default] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [anon_sym_static] = ACTIONS(4104),
    [anon_sym_member] = ACTIONS(4104),
    [anon_sym_interface] = ACTIONS(4104),
    [anon_sym_exception] = ACTIONS(4104),
    [anon_sym_abstract] = ACTIONS(4104),
    [anon_sym_val] = ACTIONS(4104),
    [anon_sym_override] = ACTIONS(4104),
    [aux_sym_char_token1] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4104),
    [anon_sym_DQUOTE] = ACTIONS(4104),
    [anon_sym_AT_DQUOTE] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [sym_bool] = ACTIONS(4104),
    [sym_unit] = ACTIONS(4102),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4104),
    [sym_op_identifier] = ACTIONS(4104),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_PLUS_DOT] = ACTIONS(4104),
    [anon_sym_DASH_DOT] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_AMP_AMP] = ACTIONS(4104),
    [anon_sym_TILDE] = ACTIONS(4102),
    [aux_sym_prefix_op_token1] = ACTIONS(4104),
    [aux_sym_infix_op_token1] = ACTIONS(4102),
    [aux_sym_infix_op_token2] = ACTIONS(4104),
    [anon_sym_PIPE_PIPE] = ACTIONS(4104),
    [anon_sym_BANG_EQ] = ACTIONS(4104),
    [anon_sym_COLON_EQ] = ACTIONS(4102),
    [anon_sym_DOLLAR] = ACTIONS(4104),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4104),
    [sym_int] = ACTIONS(4104),
    [sym_xint] = ACTIONS(4102),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4102),
    [anon_sym_POUNDload] = ACTIONS(4102),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4102),
    [sym__newline] = ACTIONS(4102),
  },
  [1403] = {
    [sym_block_comment] = STATE(1403),
    [sym_compiler_directive_decl] = STATE(1403),
    [sym_fsi_directive_decl] = STATE(1403),
    [sym_preproc_line] = STATE(1403),
    [ts_builtin_sym_end] = ACTIONS(4106),
    [sym_identifier] = ACTIONS(4108),
    [anon_sym_namespace] = ACTIONS(4108),
    [anon_sym_module] = ACTIONS(4108),
    [anon_sym_EQ] = ACTIONS(4106),
    [anon_sym_open] = ACTIONS(4108),
    [anon_sym_LBRACK_LT] = ACTIONS(4106),
    [anon_sym_COLON] = ACTIONS(4108),
    [anon_sym_return] = ACTIONS(4108),
    [anon_sym_type] = ACTIONS(4108),
    [anon_sym_do] = ACTIONS(4108),
    [anon_sym_and] = ACTIONS(4108),
    [anon_sym_let] = ACTIONS(4108),
    [anon_sym_let_BANG] = ACTIONS(4106),
    [aux_sym_access_modifier_token1] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(4108),
    [anon_sym_COMMA] = ACTIONS(4106),
    [anon_sym_null] = ACTIONS(4108),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_COLON] = ACTIONS(4106),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LBRACK] = ACTIONS(4108),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(4108),
    [anon_sym_LT_AT] = ACTIONS(4108),
    [anon_sym_LT_AT_AT] = ACTIONS(4108),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4106),
    [anon_sym_new] = ACTIONS(4108),
    [anon_sym_with] = ACTIONS(4108),
    [anon_sym_return_BANG] = ACTIONS(4106),
    [anon_sym_yield] = ACTIONS(4108),
    [anon_sym_yield_BANG] = ACTIONS(4106),
    [anon_sym_lazy] = ACTIONS(4108),
    [anon_sym_assert] = ACTIONS(4108),
    [anon_sym_upcast] = ACTIONS(4108),
    [anon_sym_downcast] = ACTIONS(4108),
    [anon_sym_COLON_GT] = ACTIONS(4106),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4106),
    [anon_sym_for] = ACTIONS(4108),
    [anon_sym_while] = ACTIONS(4108),
    [anon_sym_if] = ACTIONS(4108),
    [anon_sym_fun] = ACTIONS(4108),
    [anon_sym_try] = ACTIONS(4108),
    [anon_sym_match] = ACTIONS(4108),
    [anon_sym_match_BANG] = ACTIONS(4106),
    [anon_sym_function] = ACTIONS(4108),
    [anon_sym_LT_DASH] = ACTIONS(4108),
    [anon_sym_DOT_LBRACK] = ACTIONS(4106),
    [anon_sym_LT] = ACTIONS(4106),
    [anon_sym_use] = ACTIONS(4108),
    [anon_sym_use_BANG] = ACTIONS(4106),
    [anon_sym_do_BANG] = ACTIONS(4106),
    [anon_sym_begin] = ACTIONS(4108),
    [anon_sym_LPAREN2] = ACTIONS(4108),
    [anon_sym_default] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [anon_sym_static] = ACTIONS(4108),
    [anon_sym_member] = ACTIONS(4108),
    [anon_sym_interface] = ACTIONS(4108),
    [anon_sym_exception] = ACTIONS(4108),
    [anon_sym_abstract] = ACTIONS(4108),
    [anon_sym_val] = ACTIONS(4108),
    [anon_sym_override] = ACTIONS(4108),
    [aux_sym_char_token1] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4108),
    [anon_sym_DQUOTE] = ACTIONS(4108),
    [anon_sym_AT_DQUOTE] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [sym_bool] = ACTIONS(4108),
    [sym_unit] = ACTIONS(4106),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4108),
    [sym_op_identifier] = ACTIONS(4108),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_PLUS_DOT] = ACTIONS(4108),
    [anon_sym_DASH_DOT] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_AMP_AMP] = ACTIONS(4108),
    [anon_sym_TILDE] = ACTIONS(4106),
    [aux_sym_prefix_op_token1] = ACTIONS(4108),
    [aux_sym_infix_op_token1] = ACTIONS(4106),
    [aux_sym_infix_op_token2] = ACTIONS(4108),
    [anon_sym_PIPE_PIPE] = ACTIONS(4108),
    [anon_sym_BANG_EQ] = ACTIONS(4108),
    [anon_sym_COLON_EQ] = ACTIONS(4106),
    [anon_sym_DOLLAR] = ACTIONS(4108),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4108),
    [sym_int] = ACTIONS(4108),
    [sym_xint] = ACTIONS(4106),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4106),
    [anon_sym_POUNDload] = ACTIONS(4106),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4106),
    [sym__newline] = ACTIONS(4106),
  },
  [1404] = {
    [sym_block_comment] = STATE(1404),
    [sym_compiler_directive_decl] = STATE(1404),
    [sym_fsi_directive_decl] = STATE(1404),
    [sym_preproc_line] = STATE(1404),
    [ts_builtin_sym_end] = ACTIONS(4110),
    [sym_identifier] = ACTIONS(4112),
    [anon_sym_namespace] = ACTIONS(4112),
    [anon_sym_module] = ACTIONS(4112),
    [anon_sym_EQ] = ACTIONS(4110),
    [anon_sym_open] = ACTIONS(4112),
    [anon_sym_LBRACK_LT] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4112),
    [anon_sym_return] = ACTIONS(4112),
    [anon_sym_type] = ACTIONS(4112),
    [anon_sym_do] = ACTIONS(4112),
    [anon_sym_and] = ACTIONS(4112),
    [anon_sym_let] = ACTIONS(4112),
    [anon_sym_let_BANG] = ACTIONS(4110),
    [aux_sym_access_modifier_token1] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_null] = ACTIONS(4112),
    [anon_sym_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_COLON] = ACTIONS(4110),
    [anon_sym_AMP] = ACTIONS(4112),
    [anon_sym_LBRACK] = ACTIONS(4112),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4110),
    [anon_sym_LBRACE] = ACTIONS(4112),
    [anon_sym_LT_AT] = ACTIONS(4112),
    [anon_sym_LT_AT_AT] = ACTIONS(4112),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4110),
    [anon_sym_new] = ACTIONS(4112),
    [anon_sym_with] = ACTIONS(4112),
    [anon_sym_return_BANG] = ACTIONS(4110),
    [anon_sym_yield] = ACTIONS(4112),
    [anon_sym_yield_BANG] = ACTIONS(4110),
    [anon_sym_lazy] = ACTIONS(4112),
    [anon_sym_assert] = ACTIONS(4112),
    [anon_sym_upcast] = ACTIONS(4112),
    [anon_sym_downcast] = ACTIONS(4112),
    [anon_sym_COLON_GT] = ACTIONS(4110),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4110),
    [anon_sym_for] = ACTIONS(4112),
    [anon_sym_while] = ACTIONS(4112),
    [anon_sym_if] = ACTIONS(4112),
    [anon_sym_fun] = ACTIONS(4112),
    [anon_sym_try] = ACTIONS(4112),
    [anon_sym_match] = ACTIONS(4112),
    [anon_sym_match_BANG] = ACTIONS(4110),
    [anon_sym_function] = ACTIONS(4112),
    [anon_sym_LT_DASH] = ACTIONS(4112),
    [anon_sym_DOT_LBRACK] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(4110),
    [anon_sym_use] = ACTIONS(4112),
    [anon_sym_use_BANG] = ACTIONS(4110),
    [anon_sym_do_BANG] = ACTIONS(4110),
    [anon_sym_begin] = ACTIONS(4112),
    [anon_sym_LPAREN2] = ACTIONS(4112),
    [anon_sym_default] = ACTIONS(4112),
    [anon_sym_or] = ACTIONS(4112),
    [anon_sym_static] = ACTIONS(4112),
    [anon_sym_member] = ACTIONS(4112),
    [anon_sym_interface] = ACTIONS(4112),
    [anon_sym_exception] = ACTIONS(4112),
    [anon_sym_abstract] = ACTIONS(4112),
    [anon_sym_val] = ACTIONS(4112),
    [anon_sym_override] = ACTIONS(4112),
    [aux_sym_char_token1] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4112),
    [anon_sym_DQUOTE] = ACTIONS(4112),
    [anon_sym_AT_DQUOTE] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [sym_bool] = ACTIONS(4112),
    [sym_unit] = ACTIONS(4110),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4112),
    [sym_op_identifier] = ACTIONS(4112),
    [anon_sym_PLUS] = ACTIONS(4112),
    [anon_sym_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_DOT] = ACTIONS(4112),
    [anon_sym_DASH_DOT] = ACTIONS(4112),
    [anon_sym_PERCENT] = ACTIONS(4112),
    [anon_sym_AMP_AMP] = ACTIONS(4112),
    [anon_sym_TILDE] = ACTIONS(4110),
    [aux_sym_prefix_op_token1] = ACTIONS(4112),
    [aux_sym_infix_op_token1] = ACTIONS(4110),
    [aux_sym_infix_op_token2] = ACTIONS(4112),
    [anon_sym_PIPE_PIPE] = ACTIONS(4112),
    [anon_sym_BANG_EQ] = ACTIONS(4112),
    [anon_sym_COLON_EQ] = ACTIONS(4110),
    [anon_sym_DOLLAR] = ACTIONS(4112),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4112),
    [sym_int] = ACTIONS(4112),
    [sym_xint] = ACTIONS(4110),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4110),
    [anon_sym_POUNDload] = ACTIONS(4110),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4110),
    [sym__newline] = ACTIONS(4110),
  },
  [1405] = {
    [sym_block_comment] = STATE(1405),
    [sym_compiler_directive_decl] = STATE(1405),
    [sym_fsi_directive_decl] = STATE(1405),
    [sym_preproc_line] = STATE(1405),
    [sym_identifier] = ACTIONS(3543),
    [anon_sym_EQ] = ACTIONS(3541),
    [anon_sym_LBRACK_LT] = ACTIONS(3541),
    [anon_sym_COLON] = ACTIONS(3543),
    [anon_sym_return] = ACTIONS(3543),
    [anon_sym_do] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3543),
    [anon_sym_let_BANG] = ACTIONS(3541),
    [aux_sym_access_modifier_token1] = ACTIONS(3541),
    [anon_sym_LPAREN] = ACTIONS(3543),
    [anon_sym_COMMA] = ACTIONS(3541),
    [anon_sym_null] = ACTIONS(3543),
    [anon_sym_QMARK] = ACTIONS(3543),
    [anon_sym_COLON_QMARK] = ACTIONS(3543),
    [anon_sym_COLON_COLON] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3543),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3541),
    [anon_sym_LBRACE] = ACTIONS(3543),
    [anon_sym_LT_AT] = ACTIONS(3543),
    [anon_sym_LT_AT_AT] = ACTIONS(3543),
    [anon_sym_DOT] = ACTIONS(3543),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3541),
    [anon_sym_new] = ACTIONS(3543),
    [anon_sym_with] = ACTIONS(3543),
    [anon_sym_return_BANG] = ACTIONS(3541),
    [anon_sym_yield] = ACTIONS(3543),
    [anon_sym_yield_BANG] = ACTIONS(3541),
    [anon_sym_lazy] = ACTIONS(3543),
    [anon_sym_assert] = ACTIONS(3543),
    [anon_sym_upcast] = ACTIONS(3543),
    [anon_sym_downcast] = ACTIONS(3543),
    [anon_sym_COLON_GT] = ACTIONS(3541),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3541),
    [anon_sym_for] = ACTIONS(3543),
    [anon_sym_while] = ACTIONS(3543),
    [anon_sym_if] = ACTIONS(3543),
    [anon_sym_fun] = ACTIONS(3543),
    [anon_sym_DASH_GT] = ACTIONS(3543),
    [anon_sym_try] = ACTIONS(3543),
    [anon_sym_match] = ACTIONS(3543),
    [anon_sym_match_BANG] = ACTIONS(3541),
    [anon_sym_function] = ACTIONS(3543),
    [anon_sym_LT_DASH] = ACTIONS(3543),
    [anon_sym_DOT_LBRACK] = ACTIONS(3541),
    [anon_sym_LT] = ACTIONS(3541),
    [anon_sym_use] = ACTIONS(3543),
    [anon_sym_use_BANG] = ACTIONS(3541),
    [anon_sym_do_BANG] = ACTIONS(3541),
    [anon_sym_begin] = ACTIONS(3543),
    [anon_sym_LPAREN2] = ACTIONS(3543),
    [anon_sym_STAR] = ACTIONS(3543),
    [anon_sym_LT2] = ACTIONS(3543),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_default] = ACTIONS(3543),
    [anon_sym_or] = ACTIONS(3543),
    [anon_sym_static] = ACTIONS(3543),
    [anon_sym_member] = ACTIONS(3543),
    [anon_sym_interface] = ACTIONS(3543),
    [anon_sym_abstract] = ACTIONS(3543),
    [anon_sym_val] = ACTIONS(3543),
    [anon_sym_override] = ACTIONS(3543),
    [anon_sym_inherit] = ACTIONS(3543),
    [aux_sym_char_token1] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3543),
    [anon_sym_DQUOTE] = ACTIONS(3543),
    [anon_sym_AT_DQUOTE] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [sym_bool] = ACTIONS(3543),
    [sym_unit] = ACTIONS(3541),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3543),
    [sym_op_identifier] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(3543),
    [anon_sym_DASH] = ACTIONS(3543),
    [anon_sym_PLUS_DOT] = ACTIONS(3543),
    [anon_sym_DASH_DOT] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3543),
    [anon_sym_AMP_AMP] = ACTIONS(3543),
    [anon_sym_TILDE] = ACTIONS(3541),
    [aux_sym_prefix_op_token1] = ACTIONS(3543),
    [aux_sym_infix_op_token1] = ACTIONS(3541),
    [aux_sym_infix_op_token2] = ACTIONS(3543),
    [anon_sym_PIPE_PIPE] = ACTIONS(3543),
    [anon_sym_BANG_EQ] = ACTIONS(3543),
    [anon_sym_COLON_EQ] = ACTIONS(3541),
    [anon_sym_DOLLAR] = ACTIONS(3543),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3543),
    [sym_int] = ACTIONS(3543),
    [sym_xint] = ACTIONS(3541),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3541),
    [anon_sym_POUNDendif] = ACTIONS(3541),
    [anon_sym_POUNDelse] = ACTIONS(3541),
    [sym__newline] = ACTIONS(3541),
  },
  [1406] = {
    [sym_block_comment] = STATE(1406),
    [sym_compiler_directive_decl] = STATE(1406),
    [sym_fsi_directive_decl] = STATE(1406),
    [sym_preproc_line] = STATE(1406),
    [aux_sym_long_identifier_repeat1] = STATE(1422),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_EQ] = ACTIONS(3492),
    [anon_sym_LBRACK_LT] = ACTIONS(3492),
    [anon_sym_COLON] = ACTIONS(3494),
    [anon_sym_return] = ACTIONS(3494),
    [anon_sym_do] = ACTIONS(3494),
    [anon_sym_and] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_let_BANG] = ACTIONS(3492),
    [aux_sym_access_modifier_token1] = ACTIONS(3492),
    [anon_sym_LPAREN] = ACTIONS(3494),
    [anon_sym_COMMA] = ACTIONS(3492),
    [anon_sym_null] = ACTIONS(3494),
    [anon_sym_QMARK] = ACTIONS(3494),
    [anon_sym_COLON_QMARK] = ACTIONS(3494),
    [anon_sym_COLON_COLON] = ACTIONS(3492),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3492),
    [anon_sym_LBRACE] = ACTIONS(3494),
    [anon_sym_LT_AT] = ACTIONS(3494),
    [anon_sym_LT_AT_AT] = ACTIONS(3494),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3492),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_with] = ACTIONS(3494),
    [anon_sym_return_BANG] = ACTIONS(3492),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_yield_BANG] = ACTIONS(3492),
    [anon_sym_lazy] = ACTIONS(3494),
    [anon_sym_assert] = ACTIONS(3494),
    [anon_sym_upcast] = ACTIONS(3494),
    [anon_sym_downcast] = ACTIONS(3494),
    [anon_sym_COLON_GT] = ACTIONS(3492),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3492),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_while] = ACTIONS(3494),
    [anon_sym_if] = ACTIONS(3494),
    [anon_sym_fun] = ACTIONS(3494),
    [anon_sym_DASH_GT] = ACTIONS(3494),
    [anon_sym_try] = ACTIONS(3494),
    [anon_sym_match] = ACTIONS(3494),
    [anon_sym_match_BANG] = ACTIONS(3492),
    [anon_sym_function] = ACTIONS(3494),
    [anon_sym_LT_DASH] = ACTIONS(3494),
    [anon_sym_DOT_LBRACK] = ACTIONS(3492),
    [anon_sym_LT] = ACTIONS(3492),
    [anon_sym_use] = ACTIONS(3494),
    [anon_sym_use_BANG] = ACTIONS(3492),
    [anon_sym_do_BANG] = ACTIONS(3492),
    [anon_sym_begin] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(3494),
    [anon_sym_STAR] = ACTIONS(3494),
    [anon_sym_LT2] = ACTIONS(3494),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3492),
    [anon_sym_default] = ACTIONS(3494),
    [anon_sym_or] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_member] = ACTIONS(3494),
    [anon_sym_interface] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_val] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [aux_sym_char_token1] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3494),
    [anon_sym_DQUOTE] = ACTIONS(3494),
    [anon_sym_AT_DQUOTE] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [sym_bool] = ACTIONS(3494),
    [sym_unit] = ACTIONS(3492),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3494),
    [sym_op_identifier] = ACTIONS(3494),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_PLUS_DOT] = ACTIONS(3494),
    [anon_sym_DASH_DOT] = ACTIONS(3494),
    [anon_sym_PERCENT] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_TILDE] = ACTIONS(3492),
    [aux_sym_prefix_op_token1] = ACTIONS(3494),
    [aux_sym_infix_op_token1] = ACTIONS(3492),
    [aux_sym_infix_op_token2] = ACTIONS(3494),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_COLON_EQ] = ACTIONS(3492),
    [anon_sym_DOLLAR] = ACTIONS(3494),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3494),
    [sym_int] = ACTIONS(3494),
    [sym_xint] = ACTIONS(3492),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3492),
    [sym__newline] = ACTIONS(3492),
    [sym__dedent] = ACTIONS(3492),
  },
  [1407] = {
    [sym_block_comment] = STATE(1407),
    [sym_compiler_directive_decl] = STATE(1407),
    [sym_fsi_directive_decl] = STATE(1407),
    [sym_preproc_line] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(4116),
    [sym_identifier] = ACTIONS(4118),
    [anon_sym_namespace] = ACTIONS(4118),
    [anon_sym_module] = ACTIONS(4118),
    [anon_sym_EQ] = ACTIONS(4116),
    [anon_sym_open] = ACTIONS(4118),
    [anon_sym_LBRACK_LT] = ACTIONS(4116),
    [anon_sym_COLON] = ACTIONS(4118),
    [anon_sym_return] = ACTIONS(4118),
    [anon_sym_type] = ACTIONS(4118),
    [anon_sym_do] = ACTIONS(4118),
    [anon_sym_and] = ACTIONS(4118),
    [anon_sym_let] = ACTIONS(4118),
    [anon_sym_let_BANG] = ACTIONS(4116),
    [aux_sym_access_modifier_token1] = ACTIONS(4116),
    [anon_sym_LPAREN] = ACTIONS(4118),
    [anon_sym_COMMA] = ACTIONS(4116),
    [anon_sym_null] = ACTIONS(4118),
    [anon_sym_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_COLON] = ACTIONS(4116),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4118),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(4118),
    [anon_sym_LT_AT] = ACTIONS(4118),
    [anon_sym_LT_AT_AT] = ACTIONS(4118),
    [anon_sym_DOT] = ACTIONS(4118),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4116),
    [anon_sym_new] = ACTIONS(4118),
    [anon_sym_with] = ACTIONS(4118),
    [anon_sym_return_BANG] = ACTIONS(4116),
    [anon_sym_yield] = ACTIONS(4118),
    [anon_sym_yield_BANG] = ACTIONS(4116),
    [anon_sym_lazy] = ACTIONS(4118),
    [anon_sym_assert] = ACTIONS(4118),
    [anon_sym_upcast] = ACTIONS(4118),
    [anon_sym_downcast] = ACTIONS(4118),
    [anon_sym_COLON_GT] = ACTIONS(4116),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4116),
    [anon_sym_for] = ACTIONS(4118),
    [anon_sym_while] = ACTIONS(4118),
    [anon_sym_if] = ACTIONS(4118),
    [anon_sym_fun] = ACTIONS(4118),
    [anon_sym_try] = ACTIONS(4118),
    [anon_sym_match] = ACTIONS(4118),
    [anon_sym_match_BANG] = ACTIONS(4116),
    [anon_sym_function] = ACTIONS(4118),
    [anon_sym_LT_DASH] = ACTIONS(4118),
    [anon_sym_DOT_LBRACK] = ACTIONS(4116),
    [anon_sym_LT] = ACTIONS(4116),
    [anon_sym_use] = ACTIONS(4118),
    [anon_sym_use_BANG] = ACTIONS(4116),
    [anon_sym_do_BANG] = ACTIONS(4116),
    [anon_sym_begin] = ACTIONS(4118),
    [anon_sym_LPAREN2] = ACTIONS(4118),
    [anon_sym_default] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [anon_sym_static] = ACTIONS(4118),
    [anon_sym_member] = ACTIONS(4118),
    [anon_sym_interface] = ACTIONS(4118),
    [anon_sym_exception] = ACTIONS(4118),
    [anon_sym_abstract] = ACTIONS(4118),
    [anon_sym_val] = ACTIONS(4118),
    [anon_sym_override] = ACTIONS(4118),
    [aux_sym_char_token1] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4118),
    [anon_sym_DQUOTE] = ACTIONS(4118),
    [anon_sym_AT_DQUOTE] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [sym_bool] = ACTIONS(4118),
    [sym_unit] = ACTIONS(4116),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4118),
    [sym_op_identifier] = ACTIONS(4118),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_PLUS_DOT] = ACTIONS(4118),
    [anon_sym_DASH_DOT] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_AMP_AMP] = ACTIONS(4118),
    [anon_sym_TILDE] = ACTIONS(4116),
    [aux_sym_prefix_op_token1] = ACTIONS(4118),
    [aux_sym_infix_op_token1] = ACTIONS(4116),
    [aux_sym_infix_op_token2] = ACTIONS(4118),
    [anon_sym_PIPE_PIPE] = ACTIONS(4118),
    [anon_sym_BANG_EQ] = ACTIONS(4118),
    [anon_sym_COLON_EQ] = ACTIONS(4116),
    [anon_sym_DOLLAR] = ACTIONS(4118),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4118),
    [sym_int] = ACTIONS(4118),
    [sym_xint] = ACTIONS(4116),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4116),
    [anon_sym_POUNDload] = ACTIONS(4116),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4116),
    [sym__newline] = ACTIONS(4116),
  },
  [1408] = {
    [sym_block_comment] = STATE(1408),
    [sym_compiler_directive_decl] = STATE(1408),
    [sym_fsi_directive_decl] = STATE(1408),
    [sym_preproc_line] = STATE(1408),
    [ts_builtin_sym_end] = ACTIONS(4120),
    [sym_identifier] = ACTIONS(4122),
    [anon_sym_namespace] = ACTIONS(4122),
    [anon_sym_module] = ACTIONS(4122),
    [anon_sym_EQ] = ACTIONS(4120),
    [anon_sym_open] = ACTIONS(4122),
    [anon_sym_LBRACK_LT] = ACTIONS(4120),
    [anon_sym_COLON] = ACTIONS(4122),
    [anon_sym_return] = ACTIONS(4122),
    [anon_sym_type] = ACTIONS(4122),
    [anon_sym_do] = ACTIONS(4122),
    [anon_sym_and] = ACTIONS(4122),
    [anon_sym_let] = ACTIONS(4122),
    [anon_sym_let_BANG] = ACTIONS(4120),
    [aux_sym_access_modifier_token1] = ACTIONS(4120),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_COMMA] = ACTIONS(4120),
    [anon_sym_null] = ACTIONS(4122),
    [anon_sym_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_COLON] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_LT_AT] = ACTIONS(4122),
    [anon_sym_LT_AT_AT] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4122),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4120),
    [anon_sym_new] = ACTIONS(4122),
    [anon_sym_with] = ACTIONS(4122),
    [anon_sym_return_BANG] = ACTIONS(4120),
    [anon_sym_yield] = ACTIONS(4122),
    [anon_sym_yield_BANG] = ACTIONS(4120),
    [anon_sym_lazy] = ACTIONS(4122),
    [anon_sym_assert] = ACTIONS(4122),
    [anon_sym_upcast] = ACTIONS(4122),
    [anon_sym_downcast] = ACTIONS(4122),
    [anon_sym_COLON_GT] = ACTIONS(4120),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4120),
    [anon_sym_for] = ACTIONS(4122),
    [anon_sym_while] = ACTIONS(4122),
    [anon_sym_if] = ACTIONS(4122),
    [anon_sym_fun] = ACTIONS(4122),
    [anon_sym_try] = ACTIONS(4122),
    [anon_sym_match] = ACTIONS(4122),
    [anon_sym_match_BANG] = ACTIONS(4120),
    [anon_sym_function] = ACTIONS(4122),
    [anon_sym_LT_DASH] = ACTIONS(4122),
    [anon_sym_DOT_LBRACK] = ACTIONS(4120),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_use] = ACTIONS(4122),
    [anon_sym_use_BANG] = ACTIONS(4120),
    [anon_sym_do_BANG] = ACTIONS(4120),
    [anon_sym_begin] = ACTIONS(4122),
    [anon_sym_LPAREN2] = ACTIONS(4122),
    [anon_sym_default] = ACTIONS(4122),
    [anon_sym_or] = ACTIONS(4122),
    [anon_sym_static] = ACTIONS(4122),
    [anon_sym_member] = ACTIONS(4122),
    [anon_sym_interface] = ACTIONS(4122),
    [anon_sym_exception] = ACTIONS(4122),
    [anon_sym_abstract] = ACTIONS(4122),
    [anon_sym_val] = ACTIONS(4122),
    [anon_sym_override] = ACTIONS(4122),
    [aux_sym_char_token1] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4122),
    [anon_sym_DQUOTE] = ACTIONS(4122),
    [anon_sym_AT_DQUOTE] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [sym_bool] = ACTIONS(4122),
    [sym_unit] = ACTIONS(4120),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4122),
    [sym_op_identifier] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4122),
    [anon_sym_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_DOT] = ACTIONS(4122),
    [anon_sym_DASH_DOT] = ACTIONS(4122),
    [anon_sym_PERCENT] = ACTIONS(4122),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_TILDE] = ACTIONS(4120),
    [aux_sym_prefix_op_token1] = ACTIONS(4122),
    [aux_sym_infix_op_token1] = ACTIONS(4120),
    [aux_sym_infix_op_token2] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_COLON_EQ] = ACTIONS(4120),
    [anon_sym_DOLLAR] = ACTIONS(4122),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4122),
    [sym_int] = ACTIONS(4122),
    [sym_xint] = ACTIONS(4120),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4120),
    [anon_sym_POUNDload] = ACTIONS(4120),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4120),
    [sym__newline] = ACTIONS(4120),
  },
  [1409] = {
    [sym_block_comment] = STATE(1409),
    [sym_compiler_directive_decl] = STATE(1409),
    [sym_fsi_directive_decl] = STATE(1409),
    [sym_preproc_line] = STATE(1409),
    [ts_builtin_sym_end] = ACTIONS(4124),
    [sym_identifier] = ACTIONS(4126),
    [anon_sym_namespace] = ACTIONS(4126),
    [anon_sym_module] = ACTIONS(4126),
    [anon_sym_EQ] = ACTIONS(4124),
    [anon_sym_open] = ACTIONS(4126),
    [anon_sym_LBRACK_LT] = ACTIONS(4124),
    [anon_sym_COLON] = ACTIONS(4126),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_type] = ACTIONS(4126),
    [anon_sym_do] = ACTIONS(4126),
    [anon_sym_and] = ACTIONS(4126),
    [anon_sym_let] = ACTIONS(4126),
    [anon_sym_let_BANG] = ACTIONS(4124),
    [aux_sym_access_modifier_token1] = ACTIONS(4124),
    [anon_sym_LPAREN] = ACTIONS(4126),
    [anon_sym_COMMA] = ACTIONS(4124),
    [anon_sym_null] = ACTIONS(4126),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_COLON] = ACTIONS(4124),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LBRACK] = ACTIONS(4126),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4126),
    [anon_sym_LT_AT] = ACTIONS(4126),
    [anon_sym_LT_AT_AT] = ACTIONS(4126),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4124),
    [anon_sym_new] = ACTIONS(4126),
    [anon_sym_with] = ACTIONS(4126),
    [anon_sym_return_BANG] = ACTIONS(4124),
    [anon_sym_yield] = ACTIONS(4126),
    [anon_sym_yield_BANG] = ACTIONS(4124),
    [anon_sym_lazy] = ACTIONS(4126),
    [anon_sym_assert] = ACTIONS(4126),
    [anon_sym_upcast] = ACTIONS(4126),
    [anon_sym_downcast] = ACTIONS(4126),
    [anon_sym_COLON_GT] = ACTIONS(4124),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4124),
    [anon_sym_for] = ACTIONS(4126),
    [anon_sym_while] = ACTIONS(4126),
    [anon_sym_if] = ACTIONS(4126),
    [anon_sym_fun] = ACTIONS(4126),
    [anon_sym_try] = ACTIONS(4126),
    [anon_sym_match] = ACTIONS(4126),
    [anon_sym_match_BANG] = ACTIONS(4124),
    [anon_sym_function] = ACTIONS(4126),
    [anon_sym_LT_DASH] = ACTIONS(4126),
    [anon_sym_DOT_LBRACK] = ACTIONS(4124),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_use] = ACTIONS(4126),
    [anon_sym_use_BANG] = ACTIONS(4124),
    [anon_sym_do_BANG] = ACTIONS(4124),
    [anon_sym_begin] = ACTIONS(4126),
    [anon_sym_LPAREN2] = ACTIONS(4126),
    [anon_sym_default] = ACTIONS(4126),
    [anon_sym_or] = ACTIONS(4126),
    [anon_sym_static] = ACTIONS(4126),
    [anon_sym_member] = ACTIONS(4126),
    [anon_sym_interface] = ACTIONS(4126),
    [anon_sym_exception] = ACTIONS(4126),
    [anon_sym_abstract] = ACTIONS(4126),
    [anon_sym_val] = ACTIONS(4126),
    [anon_sym_override] = ACTIONS(4126),
    [aux_sym_char_token1] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4126),
    [anon_sym_DQUOTE] = ACTIONS(4126),
    [anon_sym_AT_DQUOTE] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [sym_bool] = ACTIONS(4126),
    [sym_unit] = ACTIONS(4124),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4126),
    [sym_op_identifier] = ACTIONS(4126),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_PLUS_DOT] = ACTIONS(4126),
    [anon_sym_DASH_DOT] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_AMP_AMP] = ACTIONS(4126),
    [anon_sym_TILDE] = ACTIONS(4124),
    [aux_sym_prefix_op_token1] = ACTIONS(4126),
    [aux_sym_infix_op_token1] = ACTIONS(4124),
    [aux_sym_infix_op_token2] = ACTIONS(4126),
    [anon_sym_PIPE_PIPE] = ACTIONS(4126),
    [anon_sym_BANG_EQ] = ACTIONS(4126),
    [anon_sym_COLON_EQ] = ACTIONS(4124),
    [anon_sym_DOLLAR] = ACTIONS(4126),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4126),
    [sym_int] = ACTIONS(4126),
    [sym_xint] = ACTIONS(4124),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4124),
    [anon_sym_POUNDload] = ACTIONS(4124),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4124),
    [sym__newline] = ACTIONS(4124),
  },
  [1410] = {
    [sym_block_comment] = STATE(1410),
    [sym_compiler_directive_decl] = STATE(1410),
    [sym_fsi_directive_decl] = STATE(1410),
    [sym_preproc_line] = STATE(1410),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_LBRACK_LT] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [aux_sym_access_modifier_token1] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_with] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [anon_sym_DOT_LBRACK] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_default] = ACTIONS(3498),
    [anon_sym_or] = ACTIONS(3498),
    [anon_sym_static] = ACTIONS(3498),
    [anon_sym_member] = ACTIONS(3498),
    [anon_sym_interface] = ACTIONS(3498),
    [anon_sym_abstract] = ACTIONS(3498),
    [anon_sym_val] = ACTIONS(3498),
    [anon_sym_override] = ACTIONS(3498),
    [anon_sym_inherit] = ACTIONS(3498),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3498),
    [anon_sym_DASH_DOT] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3498),
    [aux_sym_infix_op_token1] = ACTIONS(3496),
    [aux_sym_infix_op_token2] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_COLON_EQ] = ACTIONS(3496),
    [anon_sym_DOLLAR] = ACTIONS(3498),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3498),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [anon_sym_POUNDendif] = ACTIONS(3496),
    [anon_sym_POUNDelse] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
  },
  [1411] = {
    [sym_block_comment] = STATE(1411),
    [sym_compiler_directive_decl] = STATE(1411),
    [sym_fsi_directive_decl] = STATE(1411),
    [sym_preproc_line] = STATE(1411),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_and] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [aux_sym_access_modifier_token1] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_member] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_val] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [anon_sym_POUNDendif] = ACTIONS(3485),
    [anon_sym_POUNDelse] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [1412] = {
    [sym_block_comment] = STATE(1412),
    [sym_compiler_directive_decl] = STATE(1412),
    [sym_fsi_directive_decl] = STATE(1412),
    [sym_preproc_line] = STATE(1412),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(3521),
    [anon_sym_LBRACK_LT] = ACTIONS(3521),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_and] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3521),
    [aux_sym_access_modifier_token1] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_COMMA] = ACTIONS(3521),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_COLON] = ACTIONS(3521),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_with] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3521),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3521),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_COLON_GT] = ACTIONS(3521),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_DASH_GT] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3521),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_LT_DASH] = ACTIONS(3523),
    [anon_sym_DOT_LBRACK] = ACTIONS(3521),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3521),
    [anon_sym_do_BANG] = ACTIONS(3521),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_LPAREN2] = ACTIONS(3523),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_LT2] = ACTIONS(3523),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3521),
    [anon_sym_default] = ACTIONS(3523),
    [anon_sym_or] = ACTIONS(3523),
    [anon_sym_static] = ACTIONS(3523),
    [anon_sym_member] = ACTIONS(3523),
    [anon_sym_interface] = ACTIONS(3523),
    [anon_sym_abstract] = ACTIONS(3523),
    [anon_sym_val] = ACTIONS(3523),
    [anon_sym_override] = ACTIONS(3523),
    [aux_sym_char_token1] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3521),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3523),
    [anon_sym_DASH_DOT] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3521),
    [aux_sym_prefix_op_token1] = ACTIONS(3523),
    [aux_sym_infix_op_token1] = ACTIONS(3521),
    [aux_sym_infix_op_token2] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3523),
    [anon_sym_COLON_EQ] = ACTIONS(3521),
    [anon_sym_DOLLAR] = ACTIONS(3523),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3523),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3521),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3521),
    [anon_sym_POUNDendif] = ACTIONS(3521),
    [anon_sym_POUNDelse] = ACTIONS(3521),
    [sym__newline] = ACTIONS(3521),
  },
  [1413] = {
    [sym_block_comment] = STATE(1413),
    [sym_compiler_directive_decl] = STATE(1413),
    [sym_fsi_directive_decl] = STATE(1413),
    [sym_preproc_line] = STATE(1413),
    [ts_builtin_sym_end] = ACTIONS(4128),
    [sym_identifier] = ACTIONS(4130),
    [anon_sym_namespace] = ACTIONS(4130),
    [anon_sym_module] = ACTIONS(4130),
    [anon_sym_EQ] = ACTIONS(4128),
    [anon_sym_open] = ACTIONS(4130),
    [anon_sym_LBRACK_LT] = ACTIONS(4128),
    [anon_sym_COLON] = ACTIONS(4130),
    [anon_sym_return] = ACTIONS(4130),
    [anon_sym_type] = ACTIONS(4130),
    [anon_sym_do] = ACTIONS(4130),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_let] = ACTIONS(4130),
    [anon_sym_let_BANG] = ACTIONS(4128),
    [aux_sym_access_modifier_token1] = ACTIONS(4128),
    [anon_sym_LPAREN] = ACTIONS(4130),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_null] = ACTIONS(4130),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_COLON] = ACTIONS(4128),
    [anon_sym_AMP] = ACTIONS(4130),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4128),
    [anon_sym_LBRACE] = ACTIONS(4130),
    [anon_sym_LT_AT] = ACTIONS(4130),
    [anon_sym_LT_AT_AT] = ACTIONS(4130),
    [anon_sym_DOT] = ACTIONS(4130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4128),
    [anon_sym_new] = ACTIONS(4130),
    [anon_sym_with] = ACTIONS(4130),
    [anon_sym_return_BANG] = ACTIONS(4128),
    [anon_sym_yield] = ACTIONS(4130),
    [anon_sym_yield_BANG] = ACTIONS(4128),
    [anon_sym_lazy] = ACTIONS(4130),
    [anon_sym_assert] = ACTIONS(4130),
    [anon_sym_upcast] = ACTIONS(4130),
    [anon_sym_downcast] = ACTIONS(4130),
    [anon_sym_COLON_GT] = ACTIONS(4128),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4128),
    [anon_sym_for] = ACTIONS(4130),
    [anon_sym_while] = ACTIONS(4130),
    [anon_sym_if] = ACTIONS(4130),
    [anon_sym_fun] = ACTIONS(4130),
    [anon_sym_try] = ACTIONS(4130),
    [anon_sym_match] = ACTIONS(4130),
    [anon_sym_match_BANG] = ACTIONS(4128),
    [anon_sym_function] = ACTIONS(4130),
    [anon_sym_LT_DASH] = ACTIONS(4130),
    [anon_sym_DOT_LBRACK] = ACTIONS(4128),
    [anon_sym_LT] = ACTIONS(4128),
    [anon_sym_use] = ACTIONS(4130),
    [anon_sym_use_BANG] = ACTIONS(4128),
    [anon_sym_do_BANG] = ACTIONS(4128),
    [anon_sym_begin] = ACTIONS(4130),
    [anon_sym_LPAREN2] = ACTIONS(4130),
    [anon_sym_default] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_static] = ACTIONS(4130),
    [anon_sym_member] = ACTIONS(4130),
    [anon_sym_interface] = ACTIONS(4130),
    [anon_sym_exception] = ACTIONS(4130),
    [anon_sym_abstract] = ACTIONS(4130),
    [anon_sym_val] = ACTIONS(4130),
    [anon_sym_override] = ACTIONS(4130),
    [aux_sym_char_token1] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4130),
    [anon_sym_DQUOTE] = ACTIONS(4130),
    [anon_sym_AT_DQUOTE] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [sym_bool] = ACTIONS(4130),
    [sym_unit] = ACTIONS(4128),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4130),
    [sym_op_identifier] = ACTIONS(4130),
    [anon_sym_PLUS] = ACTIONS(4130),
    [anon_sym_DASH] = ACTIONS(4130),
    [anon_sym_PLUS_DOT] = ACTIONS(4130),
    [anon_sym_DASH_DOT] = ACTIONS(4130),
    [anon_sym_PERCENT] = ACTIONS(4130),
    [anon_sym_AMP_AMP] = ACTIONS(4130),
    [anon_sym_TILDE] = ACTIONS(4128),
    [aux_sym_prefix_op_token1] = ACTIONS(4130),
    [aux_sym_infix_op_token1] = ACTIONS(4128),
    [aux_sym_infix_op_token2] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE] = ACTIONS(4130),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_COLON_EQ] = ACTIONS(4128),
    [anon_sym_DOLLAR] = ACTIONS(4130),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4130),
    [sym_int] = ACTIONS(4130),
    [sym_xint] = ACTIONS(4128),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4128),
    [anon_sym_POUNDload] = ACTIONS(4128),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4128),
    [sym__newline] = ACTIONS(4128),
  },
  [1414] = {
    [sym_block_comment] = STATE(1414),
    [sym_compiler_directive_decl] = STATE(1414),
    [sym_fsi_directive_decl] = STATE(1414),
    [sym_preproc_line] = STATE(1414),
    [aux_sym_type_argument_repeat1] = STATE(1319),
    [sym_identifier] = ACTIONS(3476),
    [anon_sym_EQ] = ACTIONS(3474),
    [anon_sym_LBRACK_LT] = ACTIONS(3474),
    [anon_sym_COLON] = ACTIONS(3476),
    [anon_sym_return] = ACTIONS(3476),
    [anon_sym_do] = ACTIONS(3476),
    [anon_sym_let] = ACTIONS(3476),
    [anon_sym_let_BANG] = ACTIONS(3474),
    [aux_sym_access_modifier_token1] = ACTIONS(3474),
    [anon_sym_LPAREN] = ACTIONS(3476),
    [anon_sym_COMMA] = ACTIONS(3474),
    [anon_sym_null] = ACTIONS(3476),
    [anon_sym_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_COLON] = ACTIONS(3474),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym_LBRACK] = ACTIONS(3476),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3474),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_LT_AT] = ACTIONS(3476),
    [anon_sym_LT_AT_AT] = ACTIONS(3476),
    [anon_sym_DOT] = ACTIONS(3476),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3474),
    [anon_sym_new] = ACTIONS(3476),
    [anon_sym_with] = ACTIONS(3476),
    [anon_sym_return_BANG] = ACTIONS(3474),
    [anon_sym_yield] = ACTIONS(3476),
    [anon_sym_yield_BANG] = ACTIONS(3474),
    [anon_sym_lazy] = ACTIONS(3476),
    [anon_sym_assert] = ACTIONS(3476),
    [anon_sym_upcast] = ACTIONS(3476),
    [anon_sym_downcast] = ACTIONS(3476),
    [anon_sym_COLON_GT] = ACTIONS(3474),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3474),
    [anon_sym_for] = ACTIONS(3476),
    [anon_sym_while] = ACTIONS(3476),
    [anon_sym_if] = ACTIONS(3476),
    [anon_sym_fun] = ACTIONS(3476),
    [anon_sym_DASH_GT] = ACTIONS(3476),
    [anon_sym_try] = ACTIONS(3476),
    [anon_sym_match] = ACTIONS(3476),
    [anon_sym_match_BANG] = ACTIONS(3474),
    [anon_sym_function] = ACTIONS(3476),
    [anon_sym_LT_DASH] = ACTIONS(3476),
    [anon_sym_DOT_LBRACK] = ACTIONS(3474),
    [anon_sym_LT] = ACTIONS(3474),
    [anon_sym_use] = ACTIONS(3476),
    [anon_sym_use_BANG] = ACTIONS(3474),
    [anon_sym_do_BANG] = ACTIONS(3474),
    [anon_sym_begin] = ACTIONS(3476),
    [anon_sym_LPAREN2] = ACTIONS(3476),
    [anon_sym_STAR] = ACTIONS(3476),
    [anon_sym_LT2] = ACTIONS(3476),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3474),
    [anon_sym_default] = ACTIONS(3476),
    [anon_sym_or] = ACTIONS(3476),
    [anon_sym_static] = ACTIONS(3476),
    [anon_sym_member] = ACTIONS(3476),
    [anon_sym_interface] = ACTIONS(3476),
    [anon_sym_abstract] = ACTIONS(3476),
    [anon_sym_val] = ACTIONS(3476),
    [anon_sym_override] = ACTIONS(3476),
    [anon_sym_inherit] = ACTIONS(3476),
    [aux_sym_char_token1] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3476),
    [anon_sym_DQUOTE] = ACTIONS(3476),
    [anon_sym_AT_DQUOTE] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [sym_bool] = ACTIONS(3476),
    [sym_unit] = ACTIONS(3474),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3476),
    [sym_op_identifier] = ACTIONS(3476),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3476),
    [anon_sym_PLUS_DOT] = ACTIONS(3476),
    [anon_sym_DASH_DOT] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [anon_sym_AMP_AMP] = ACTIONS(3476),
    [anon_sym_TILDE] = ACTIONS(3474),
    [aux_sym_prefix_op_token1] = ACTIONS(3476),
    [aux_sym_infix_op_token1] = ACTIONS(3474),
    [aux_sym_infix_op_token2] = ACTIONS(3476),
    [anon_sym_PIPE_PIPE] = ACTIONS(3476),
    [anon_sym_BANG_EQ] = ACTIONS(3476),
    [anon_sym_COLON_EQ] = ACTIONS(3474),
    [anon_sym_DOLLAR] = ACTIONS(3476),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3476),
    [sym_int] = ACTIONS(3476),
    [sym_xint] = ACTIONS(3474),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3474),
    [anon_sym_POUNDendif] = ACTIONS(3474),
    [sym__newline] = ACTIONS(3474),
  },
  [1415] = {
    [sym_block_comment] = STATE(1415),
    [sym_compiler_directive_decl] = STATE(1415),
    [sym_fsi_directive_decl] = STATE(1415),
    [sym_preproc_line] = STATE(1415),
    [aux_sym_compound_type_repeat1] = STATE(1341),
    [sym_identifier] = ACTIONS(3468),
    [anon_sym_EQ] = ACTIONS(3466),
    [anon_sym_LBRACK_LT] = ACTIONS(3466),
    [anon_sym_COLON] = ACTIONS(3468),
    [anon_sym_return] = ACTIONS(3468),
    [anon_sym_do] = ACTIONS(3468),
    [anon_sym_let] = ACTIONS(3468),
    [anon_sym_let_BANG] = ACTIONS(3466),
    [aux_sym_access_modifier_token1] = ACTIONS(3466),
    [anon_sym_LPAREN] = ACTIONS(3468),
    [anon_sym_COMMA] = ACTIONS(3466),
    [anon_sym_null] = ACTIONS(3468),
    [anon_sym_QMARK] = ACTIONS(3468),
    [anon_sym_COLON_QMARK] = ACTIONS(3468),
    [anon_sym_COLON_COLON] = ACTIONS(3466),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LBRACK] = ACTIONS(3468),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3466),
    [anon_sym_LBRACE] = ACTIONS(3468),
    [anon_sym_LT_AT] = ACTIONS(3468),
    [anon_sym_LT_AT_AT] = ACTIONS(3468),
    [anon_sym_DOT] = ACTIONS(3468),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3466),
    [anon_sym_new] = ACTIONS(3468),
    [anon_sym_with] = ACTIONS(3468),
    [anon_sym_return_BANG] = ACTIONS(3466),
    [anon_sym_yield] = ACTIONS(3468),
    [anon_sym_yield_BANG] = ACTIONS(3466),
    [anon_sym_lazy] = ACTIONS(3468),
    [anon_sym_assert] = ACTIONS(3468),
    [anon_sym_upcast] = ACTIONS(3468),
    [anon_sym_downcast] = ACTIONS(3468),
    [anon_sym_COLON_GT] = ACTIONS(3466),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3466),
    [anon_sym_for] = ACTIONS(3468),
    [anon_sym_while] = ACTIONS(3468),
    [anon_sym_if] = ACTIONS(3468),
    [anon_sym_fun] = ACTIONS(3468),
    [anon_sym_DASH_GT] = ACTIONS(3468),
    [anon_sym_try] = ACTIONS(3468),
    [anon_sym_match] = ACTIONS(3468),
    [anon_sym_match_BANG] = ACTIONS(3466),
    [anon_sym_function] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3468),
    [anon_sym_DOT_LBRACK] = ACTIONS(3466),
    [anon_sym_LT] = ACTIONS(3466),
    [anon_sym_use] = ACTIONS(3468),
    [anon_sym_use_BANG] = ACTIONS(3466),
    [anon_sym_do_BANG] = ACTIONS(3466),
    [anon_sym_begin] = ACTIONS(3468),
    [anon_sym_LPAREN2] = ACTIONS(3468),
    [anon_sym_STAR] = ACTIONS(3720),
    [anon_sym_LT2] = ACTIONS(3468),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3466),
    [anon_sym_default] = ACTIONS(3468),
    [anon_sym_or] = ACTIONS(3468),
    [anon_sym_static] = ACTIONS(3468),
    [anon_sym_member] = ACTIONS(3468),
    [anon_sym_interface] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(3468),
    [anon_sym_val] = ACTIONS(3468),
    [anon_sym_override] = ACTIONS(3468),
    [anon_sym_inherit] = ACTIONS(3468),
    [aux_sym_char_token1] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3468),
    [anon_sym_DQUOTE] = ACTIONS(3468),
    [anon_sym_AT_DQUOTE] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [sym_bool] = ACTIONS(3468),
    [sym_unit] = ACTIONS(3466),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3468),
    [sym_op_identifier] = ACTIONS(3468),
    [anon_sym_PLUS] = ACTIONS(3468),
    [anon_sym_DASH] = ACTIONS(3468),
    [anon_sym_PLUS_DOT] = ACTIONS(3468),
    [anon_sym_DASH_DOT] = ACTIONS(3468),
    [anon_sym_PERCENT] = ACTIONS(3468),
    [anon_sym_AMP_AMP] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3466),
    [aux_sym_prefix_op_token1] = ACTIONS(3468),
    [aux_sym_infix_op_token1] = ACTIONS(3466),
    [aux_sym_infix_op_token2] = ACTIONS(3468),
    [anon_sym_PIPE_PIPE] = ACTIONS(3468),
    [anon_sym_BANG_EQ] = ACTIONS(3468),
    [anon_sym_COLON_EQ] = ACTIONS(3466),
    [anon_sym_DOLLAR] = ACTIONS(3468),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3468),
    [sym_int] = ACTIONS(3468),
    [sym_xint] = ACTIONS(3466),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3466),
    [anon_sym_POUNDendif] = ACTIONS(3466),
    [sym__newline] = ACTIONS(3466),
  },
  [1416] = {
    [sym_block_comment] = STATE(1416),
    [sym_compiler_directive_decl] = STATE(1416),
    [sym_fsi_directive_decl] = STATE(1416),
    [sym_preproc_line] = STATE(1416),
    [aux_sym_long_identifier_repeat1] = STATE(1416),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_and] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [aux_sym_access_modifier_token1] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_member] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_val] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
    [sym__dedent] = ACTIONS(3485),
  },
  [1417] = {
    [sym_block_comment] = STATE(1417),
    [sym_compiler_directive_decl] = STATE(1417),
    [sym_fsi_directive_decl] = STATE(1417),
    [sym_preproc_line] = STATE(1417),
    [sym_identifier] = ACTIONS(3519),
    [anon_sym_EQ] = ACTIONS(3517),
    [anon_sym_LBRACK_LT] = ACTIONS(3517),
    [anon_sym_COLON] = ACTIONS(3519),
    [anon_sym_return] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(3519),
    [anon_sym_and] = ACTIONS(3519),
    [anon_sym_let] = ACTIONS(3519),
    [anon_sym_let_BANG] = ACTIONS(3517),
    [aux_sym_access_modifier_token1] = ACTIONS(3517),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [anon_sym_COMMA] = ACTIONS(3517),
    [anon_sym_null] = ACTIONS(3519),
    [anon_sym_QMARK] = ACTIONS(3519),
    [anon_sym_COLON_QMARK] = ACTIONS(3519),
    [anon_sym_COLON_COLON] = ACTIONS(3517),
    [anon_sym_AMP] = ACTIONS(3519),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_LT_AT] = ACTIONS(3519),
    [anon_sym_LT_AT_AT] = ACTIONS(3519),
    [anon_sym_DOT] = ACTIONS(3519),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3519),
    [anon_sym_with] = ACTIONS(3519),
    [anon_sym_return_BANG] = ACTIONS(3517),
    [anon_sym_yield] = ACTIONS(3519),
    [anon_sym_yield_BANG] = ACTIONS(3517),
    [anon_sym_lazy] = ACTIONS(3519),
    [anon_sym_assert] = ACTIONS(3519),
    [anon_sym_upcast] = ACTIONS(3519),
    [anon_sym_downcast] = ACTIONS(3519),
    [anon_sym_COLON_GT] = ACTIONS(3517),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3517),
    [anon_sym_for] = ACTIONS(3519),
    [anon_sym_while] = ACTIONS(3519),
    [anon_sym_if] = ACTIONS(3519),
    [anon_sym_fun] = ACTIONS(3519),
    [anon_sym_DASH_GT] = ACTIONS(3519),
    [anon_sym_try] = ACTIONS(3519),
    [anon_sym_match] = ACTIONS(3519),
    [anon_sym_match_BANG] = ACTIONS(3517),
    [anon_sym_function] = ACTIONS(3519),
    [anon_sym_LT_DASH] = ACTIONS(3519),
    [anon_sym_DOT_LBRACK] = ACTIONS(3517),
    [anon_sym_LT] = ACTIONS(3517),
    [anon_sym_use] = ACTIONS(3519),
    [anon_sym_use_BANG] = ACTIONS(3517),
    [anon_sym_do_BANG] = ACTIONS(3517),
    [anon_sym_begin] = ACTIONS(3519),
    [anon_sym_LPAREN2] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_LT2] = ACTIONS(3519),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3517),
    [anon_sym_default] = ACTIONS(3519),
    [anon_sym_or] = ACTIONS(3519),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_member] = ACTIONS(3519),
    [anon_sym_interface] = ACTIONS(3519),
    [anon_sym_abstract] = ACTIONS(3519),
    [anon_sym_val] = ACTIONS(3519),
    [anon_sym_override] = ACTIONS(3519),
    [aux_sym_char_token1] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [anon_sym_AT_DQUOTE] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [sym_bool] = ACTIONS(3519),
    [sym_unit] = ACTIONS(3517),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3519),
    [sym_op_identifier] = ACTIONS(3519),
    [anon_sym_PLUS] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_DOT] = ACTIONS(3519),
    [anon_sym_DASH_DOT] = ACTIONS(3519),
    [anon_sym_PERCENT] = ACTIONS(3519),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3517),
    [aux_sym_prefix_op_token1] = ACTIONS(3519),
    [aux_sym_infix_op_token1] = ACTIONS(3517),
    [aux_sym_infix_op_token2] = ACTIONS(3519),
    [anon_sym_PIPE_PIPE] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_COLON_EQ] = ACTIONS(3517),
    [anon_sym_DOLLAR] = ACTIONS(3519),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3519),
    [sym_int] = ACTIONS(3519),
    [sym_xint] = ACTIONS(3517),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3517),
    [anon_sym_POUNDendif] = ACTIONS(3517),
    [anon_sym_POUNDelse] = ACTIONS(3517),
    [sym__newline] = ACTIONS(3517),
  },
  [1418] = {
    [sym_block_comment] = STATE(1418),
    [sym_compiler_directive_decl] = STATE(1418),
    [sym_fsi_directive_decl] = STATE(1418),
    [sym_preproc_line] = STATE(1418),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3525),
    [anon_sym_LBRACK_LT] = ACTIONS(3525),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_and] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [aux_sym_access_modifier_token1] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_COLON] = ACTIONS(3525),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_with] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_COLON_GT] = ACTIONS(3525),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_DASH_GT] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_LT_DASH] = ACTIONS(3527),
    [anon_sym_DOT_LBRACK] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_LPAREN2] = ACTIONS(3527),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_LT2] = ACTIONS(3527),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_default] = ACTIONS(3527),
    [anon_sym_or] = ACTIONS(3527),
    [anon_sym_static] = ACTIONS(3527),
    [anon_sym_member] = ACTIONS(3527),
    [anon_sym_interface] = ACTIONS(3527),
    [anon_sym_abstract] = ACTIONS(3527),
    [anon_sym_val] = ACTIONS(3527),
    [anon_sym_override] = ACTIONS(3527),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3525),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3527),
    [anon_sym_DASH_DOT] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3527),
    [aux_sym_infix_op_token1] = ACTIONS(3525),
    [aux_sym_infix_op_token2] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_COLON_EQ] = ACTIONS(3525),
    [anon_sym_DOLLAR] = ACTIONS(3527),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3527),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3525),
    [anon_sym_POUNDendif] = ACTIONS(3525),
    [anon_sym_POUNDelse] = ACTIONS(3525),
    [sym__newline] = ACTIONS(3525),
  },
  [1419] = {
    [sym_block_comment] = STATE(1419),
    [sym_compiler_directive_decl] = STATE(1419),
    [sym_fsi_directive_decl] = STATE(1419),
    [sym_preproc_line] = STATE(1419),
    [ts_builtin_sym_end] = ACTIONS(4135),
    [sym_identifier] = ACTIONS(4137),
    [anon_sym_namespace] = ACTIONS(4137),
    [anon_sym_module] = ACTIONS(4137),
    [anon_sym_EQ] = ACTIONS(4135),
    [anon_sym_open] = ACTIONS(4137),
    [anon_sym_LBRACK_LT] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4137),
    [anon_sym_return] = ACTIONS(4137),
    [anon_sym_type] = ACTIONS(4137),
    [anon_sym_do] = ACTIONS(4137),
    [anon_sym_and] = ACTIONS(4137),
    [anon_sym_let] = ACTIONS(4137),
    [anon_sym_let_BANG] = ACTIONS(4135),
    [aux_sym_access_modifier_token1] = ACTIONS(4135),
    [anon_sym_LPAREN] = ACTIONS(4137),
    [anon_sym_COMMA] = ACTIONS(4135),
    [anon_sym_null] = ACTIONS(4137),
    [anon_sym_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_COLON] = ACTIONS(4135),
    [anon_sym_AMP] = ACTIONS(4137),
    [anon_sym_LBRACK] = ACTIONS(4137),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4135),
    [anon_sym_LBRACE] = ACTIONS(4137),
    [anon_sym_LT_AT] = ACTIONS(4137),
    [anon_sym_LT_AT_AT] = ACTIONS(4137),
    [anon_sym_DOT] = ACTIONS(4137),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4135),
    [anon_sym_new] = ACTIONS(4137),
    [anon_sym_with] = ACTIONS(4137),
    [anon_sym_return_BANG] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_yield_BANG] = ACTIONS(4135),
    [anon_sym_lazy] = ACTIONS(4137),
    [anon_sym_assert] = ACTIONS(4137),
    [anon_sym_upcast] = ACTIONS(4137),
    [anon_sym_downcast] = ACTIONS(4137),
    [anon_sym_COLON_GT] = ACTIONS(4135),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4135),
    [anon_sym_for] = ACTIONS(4137),
    [anon_sym_while] = ACTIONS(4137),
    [anon_sym_if] = ACTIONS(4137),
    [anon_sym_fun] = ACTIONS(4137),
    [anon_sym_try] = ACTIONS(4137),
    [anon_sym_match] = ACTIONS(4137),
    [anon_sym_match_BANG] = ACTIONS(4135),
    [anon_sym_function] = ACTIONS(4137),
    [anon_sym_LT_DASH] = ACTIONS(4137),
    [anon_sym_DOT_LBRACK] = ACTIONS(4135),
    [anon_sym_LT] = ACTIONS(4135),
    [anon_sym_use] = ACTIONS(4137),
    [anon_sym_use_BANG] = ACTIONS(4135),
    [anon_sym_do_BANG] = ACTIONS(4135),
    [anon_sym_begin] = ACTIONS(4137),
    [anon_sym_LPAREN2] = ACTIONS(4137),
    [anon_sym_default] = ACTIONS(4137),
    [anon_sym_or] = ACTIONS(4137),
    [anon_sym_static] = ACTIONS(4137),
    [anon_sym_member] = ACTIONS(4137),
    [anon_sym_interface] = ACTIONS(4137),
    [anon_sym_exception] = ACTIONS(4137),
    [anon_sym_abstract] = ACTIONS(4137),
    [anon_sym_val] = ACTIONS(4137),
    [anon_sym_override] = ACTIONS(4137),
    [aux_sym_char_token1] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4137),
    [anon_sym_DQUOTE] = ACTIONS(4137),
    [anon_sym_AT_DQUOTE] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [sym_bool] = ACTIONS(4137),
    [sym_unit] = ACTIONS(4135),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4137),
    [sym_op_identifier] = ACTIONS(4137),
    [anon_sym_PLUS] = ACTIONS(4137),
    [anon_sym_DASH] = ACTIONS(4137),
    [anon_sym_PLUS_DOT] = ACTIONS(4137),
    [anon_sym_DASH_DOT] = ACTIONS(4137),
    [anon_sym_PERCENT] = ACTIONS(4137),
    [anon_sym_AMP_AMP] = ACTIONS(4137),
    [anon_sym_TILDE] = ACTIONS(4135),
    [aux_sym_prefix_op_token1] = ACTIONS(4137),
    [aux_sym_infix_op_token1] = ACTIONS(4135),
    [aux_sym_infix_op_token2] = ACTIONS(4137),
    [anon_sym_PIPE_PIPE] = ACTIONS(4137),
    [anon_sym_BANG_EQ] = ACTIONS(4137),
    [anon_sym_COLON_EQ] = ACTIONS(4135),
    [anon_sym_DOLLAR] = ACTIONS(4137),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4137),
    [sym_int] = ACTIONS(4137),
    [sym_xint] = ACTIONS(4135),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4135),
    [anon_sym_POUNDload] = ACTIONS(4135),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4135),
    [sym__newline] = ACTIONS(4135),
  },
  [1420] = {
    [sym_block_comment] = STATE(1420),
    [sym_compiler_directive_decl] = STATE(1420),
    [sym_fsi_directive_decl] = STATE(1420),
    [sym_preproc_line] = STATE(1420),
    [aux_sym_type_argument_repeat1] = STATE(1414),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_LBRACK_LT] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [aux_sym_access_modifier_token1] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_with] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [anon_sym_DOT_LBRACK] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_default] = ACTIONS(3498),
    [anon_sym_or] = ACTIONS(4139),
    [anon_sym_static] = ACTIONS(3498),
    [anon_sym_member] = ACTIONS(3498),
    [anon_sym_interface] = ACTIONS(3498),
    [anon_sym_abstract] = ACTIONS(3498),
    [anon_sym_val] = ACTIONS(3498),
    [anon_sym_override] = ACTIONS(3498),
    [anon_sym_inherit] = ACTIONS(3498),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3498),
    [anon_sym_DASH_DOT] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3498),
    [aux_sym_infix_op_token1] = ACTIONS(3496),
    [aux_sym_infix_op_token2] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_COLON_EQ] = ACTIONS(3496),
    [anon_sym_DOLLAR] = ACTIONS(3498),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3498),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [anon_sym_POUNDendif] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
  },
  [1421] = {
    [sym_block_comment] = STATE(1421),
    [sym_compiler_directive_decl] = STATE(1421),
    [sym_fsi_directive_decl] = STATE(1421),
    [sym_preproc_line] = STATE(1421),
    [aux_sym_type_argument_repeat1] = STATE(1370),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_LBRACK_LT] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [aux_sym_access_modifier_token1] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_with] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [anon_sym_DOT_LBRACK] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_DOT_DOT2] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_default] = ACTIONS(3498),
    [anon_sym_or] = ACTIONS(4142),
    [anon_sym_static] = ACTIONS(3498),
    [anon_sym_member] = ACTIONS(3498),
    [anon_sym_interface] = ACTIONS(3498),
    [anon_sym_abstract] = ACTIONS(3498),
    [anon_sym_val] = ACTIONS(3498),
    [anon_sym_override] = ACTIONS(3498),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3498),
    [anon_sym_DASH_DOT] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3498),
    [aux_sym_infix_op_token1] = ACTIONS(3496),
    [aux_sym_infix_op_token2] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_COLON_EQ] = ACTIONS(3496),
    [anon_sym_DOLLAR] = ACTIONS(3498),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3498),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
    [sym__dedent] = ACTIONS(3496),
  },
  [1422] = {
    [sym_block_comment] = STATE(1422),
    [sym_compiler_directive_decl] = STATE(1422),
    [sym_fsi_directive_decl] = STATE(1422),
    [sym_preproc_line] = STATE(1422),
    [aux_sym_long_identifier_repeat1] = STATE(1416),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_LBRACK_LT] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_and] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [aux_sym_access_modifier_token1] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_DASH_GT] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_STAR] = ACTIONS(3451),
    [anon_sym_LT2] = ACTIONS(3451),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3449),
    [anon_sym_default] = ACTIONS(3451),
    [anon_sym_or] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_member] = ACTIONS(3451),
    [anon_sym_interface] = ACTIONS(3451),
    [anon_sym_abstract] = ACTIONS(3451),
    [anon_sym_val] = ACTIONS(3451),
    [anon_sym_override] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
    [sym__dedent] = ACTIONS(3449),
  },
  [1423] = {
    [sym_block_comment] = STATE(1423),
    [sym_compiler_directive_decl] = STATE(1423),
    [sym_fsi_directive_decl] = STATE(1423),
    [sym_preproc_line] = STATE(1423),
    [ts_builtin_sym_end] = ACTIONS(4145),
    [sym_identifier] = ACTIONS(4147),
    [anon_sym_namespace] = ACTIONS(4147),
    [anon_sym_module] = ACTIONS(4147),
    [anon_sym_EQ] = ACTIONS(4145),
    [anon_sym_open] = ACTIONS(4147),
    [anon_sym_LBRACK_LT] = ACTIONS(4145),
    [anon_sym_COLON] = ACTIONS(4147),
    [anon_sym_return] = ACTIONS(4147),
    [anon_sym_type] = ACTIONS(4147),
    [anon_sym_do] = ACTIONS(4147),
    [anon_sym_and] = ACTIONS(4147),
    [anon_sym_let] = ACTIONS(4147),
    [anon_sym_let_BANG] = ACTIONS(4145),
    [aux_sym_access_modifier_token1] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(4147),
    [anon_sym_COMMA] = ACTIONS(4145),
    [anon_sym_null] = ACTIONS(4147),
    [anon_sym_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_COLON] = ACTIONS(4145),
    [anon_sym_AMP] = ACTIONS(4147),
    [anon_sym_LBRACK] = ACTIONS(4147),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4145),
    [anon_sym_LBRACE] = ACTIONS(4147),
    [anon_sym_LT_AT] = ACTIONS(4147),
    [anon_sym_LT_AT_AT] = ACTIONS(4147),
    [anon_sym_DOT] = ACTIONS(4147),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4145),
    [anon_sym_new] = ACTIONS(4147),
    [anon_sym_with] = ACTIONS(4147),
    [anon_sym_return_BANG] = ACTIONS(4145),
    [anon_sym_yield] = ACTIONS(4147),
    [anon_sym_yield_BANG] = ACTIONS(4145),
    [anon_sym_lazy] = ACTIONS(4147),
    [anon_sym_assert] = ACTIONS(4147),
    [anon_sym_upcast] = ACTIONS(4147),
    [anon_sym_downcast] = ACTIONS(4147),
    [anon_sym_COLON_GT] = ACTIONS(4145),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4145),
    [anon_sym_for] = ACTIONS(4147),
    [anon_sym_while] = ACTIONS(4147),
    [anon_sym_if] = ACTIONS(4147),
    [anon_sym_fun] = ACTIONS(4147),
    [anon_sym_try] = ACTIONS(4147),
    [anon_sym_match] = ACTIONS(4147),
    [anon_sym_match_BANG] = ACTIONS(4145),
    [anon_sym_function] = ACTIONS(4147),
    [anon_sym_LT_DASH] = ACTIONS(4147),
    [anon_sym_DOT_LBRACK] = ACTIONS(4145),
    [anon_sym_LT] = ACTIONS(4145),
    [anon_sym_use] = ACTIONS(4147),
    [anon_sym_use_BANG] = ACTIONS(4145),
    [anon_sym_do_BANG] = ACTIONS(4145),
    [anon_sym_begin] = ACTIONS(4147),
    [anon_sym_LPAREN2] = ACTIONS(4147),
    [anon_sym_default] = ACTIONS(4147),
    [anon_sym_or] = ACTIONS(4147),
    [anon_sym_static] = ACTIONS(4147),
    [anon_sym_member] = ACTIONS(4147),
    [anon_sym_interface] = ACTIONS(4147),
    [anon_sym_exception] = ACTIONS(4147),
    [anon_sym_abstract] = ACTIONS(4147),
    [anon_sym_val] = ACTIONS(4147),
    [anon_sym_override] = ACTIONS(4147),
    [aux_sym_char_token1] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4147),
    [anon_sym_DQUOTE] = ACTIONS(4147),
    [anon_sym_AT_DQUOTE] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [sym_bool] = ACTIONS(4147),
    [sym_unit] = ACTIONS(4145),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4147),
    [sym_op_identifier] = ACTIONS(4147),
    [anon_sym_PLUS] = ACTIONS(4147),
    [anon_sym_DASH] = ACTIONS(4147),
    [anon_sym_PLUS_DOT] = ACTIONS(4147),
    [anon_sym_DASH_DOT] = ACTIONS(4147),
    [anon_sym_PERCENT] = ACTIONS(4147),
    [anon_sym_AMP_AMP] = ACTIONS(4147),
    [anon_sym_TILDE] = ACTIONS(4145),
    [aux_sym_prefix_op_token1] = ACTIONS(4147),
    [aux_sym_infix_op_token1] = ACTIONS(4145),
    [aux_sym_infix_op_token2] = ACTIONS(4147),
    [anon_sym_PIPE_PIPE] = ACTIONS(4147),
    [anon_sym_BANG_EQ] = ACTIONS(4147),
    [anon_sym_COLON_EQ] = ACTIONS(4145),
    [anon_sym_DOLLAR] = ACTIONS(4147),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4147),
    [sym_int] = ACTIONS(4147),
    [sym_xint] = ACTIONS(4145),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4145),
    [anon_sym_POUNDload] = ACTIONS(4145),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4145),
    [sym__newline] = ACTIONS(4145),
  },
  [1424] = {
    [sym_block_comment] = STATE(1424),
    [sym_compiler_directive_decl] = STATE(1424),
    [sym_fsi_directive_decl] = STATE(1424),
    [sym_preproc_line] = STATE(1424),
    [ts_builtin_sym_end] = ACTIONS(4149),
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_namespace] = ACTIONS(4151),
    [anon_sym_module] = ACTIONS(4151),
    [anon_sym_EQ] = ACTIONS(4149),
    [anon_sym_open] = ACTIONS(4151),
    [anon_sym_LBRACK_LT] = ACTIONS(4149),
    [anon_sym_COLON] = ACTIONS(4151),
    [anon_sym_return] = ACTIONS(4151),
    [anon_sym_type] = ACTIONS(4151),
    [anon_sym_do] = ACTIONS(4151),
    [anon_sym_and] = ACTIONS(4151),
    [anon_sym_let] = ACTIONS(4151),
    [anon_sym_let_BANG] = ACTIONS(4149),
    [aux_sym_access_modifier_token1] = ACTIONS(4149),
    [anon_sym_LPAREN] = ACTIONS(4151),
    [anon_sym_COMMA] = ACTIONS(4149),
    [anon_sym_null] = ACTIONS(4151),
    [anon_sym_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_AMP] = ACTIONS(4151),
    [anon_sym_LBRACK] = ACTIONS(4151),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4149),
    [anon_sym_LBRACE] = ACTIONS(4151),
    [anon_sym_LT_AT] = ACTIONS(4151),
    [anon_sym_LT_AT_AT] = ACTIONS(4151),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4149),
    [anon_sym_new] = ACTIONS(4151),
    [anon_sym_with] = ACTIONS(4151),
    [anon_sym_return_BANG] = ACTIONS(4149),
    [anon_sym_yield] = ACTIONS(4151),
    [anon_sym_yield_BANG] = ACTIONS(4149),
    [anon_sym_lazy] = ACTIONS(4151),
    [anon_sym_assert] = ACTIONS(4151),
    [anon_sym_upcast] = ACTIONS(4151),
    [anon_sym_downcast] = ACTIONS(4151),
    [anon_sym_COLON_GT] = ACTIONS(4149),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4149),
    [anon_sym_for] = ACTIONS(4151),
    [anon_sym_while] = ACTIONS(4151),
    [anon_sym_if] = ACTIONS(4151),
    [anon_sym_fun] = ACTIONS(4151),
    [anon_sym_try] = ACTIONS(4151),
    [anon_sym_match] = ACTIONS(4151),
    [anon_sym_match_BANG] = ACTIONS(4149),
    [anon_sym_function] = ACTIONS(4151),
    [anon_sym_LT_DASH] = ACTIONS(4151),
    [anon_sym_DOT_LBRACK] = ACTIONS(4149),
    [anon_sym_LT] = ACTIONS(4149),
    [anon_sym_use] = ACTIONS(4151),
    [anon_sym_use_BANG] = ACTIONS(4149),
    [anon_sym_do_BANG] = ACTIONS(4149),
    [anon_sym_begin] = ACTIONS(4151),
    [anon_sym_LPAREN2] = ACTIONS(4151),
    [anon_sym_default] = ACTIONS(4151),
    [anon_sym_or] = ACTIONS(4151),
    [anon_sym_static] = ACTIONS(4151),
    [anon_sym_member] = ACTIONS(4151),
    [anon_sym_interface] = ACTIONS(4151),
    [anon_sym_exception] = ACTIONS(4151),
    [anon_sym_abstract] = ACTIONS(4151),
    [anon_sym_val] = ACTIONS(4151),
    [anon_sym_override] = ACTIONS(4151),
    [aux_sym_char_token1] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4151),
    [anon_sym_DQUOTE] = ACTIONS(4151),
    [anon_sym_AT_DQUOTE] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [sym_bool] = ACTIONS(4151),
    [sym_unit] = ACTIONS(4149),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4151),
    [sym_op_identifier] = ACTIONS(4151),
    [anon_sym_PLUS] = ACTIONS(4151),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_PLUS_DOT] = ACTIONS(4151),
    [anon_sym_DASH_DOT] = ACTIONS(4151),
    [anon_sym_PERCENT] = ACTIONS(4151),
    [anon_sym_AMP_AMP] = ACTIONS(4151),
    [anon_sym_TILDE] = ACTIONS(4149),
    [aux_sym_prefix_op_token1] = ACTIONS(4151),
    [aux_sym_infix_op_token1] = ACTIONS(4149),
    [aux_sym_infix_op_token2] = ACTIONS(4151),
    [anon_sym_PIPE_PIPE] = ACTIONS(4151),
    [anon_sym_BANG_EQ] = ACTIONS(4151),
    [anon_sym_COLON_EQ] = ACTIONS(4149),
    [anon_sym_DOLLAR] = ACTIONS(4151),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4151),
    [sym_int] = ACTIONS(4151),
    [sym_xint] = ACTIONS(4149),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4149),
    [anon_sym_POUNDload] = ACTIONS(4149),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4149),
    [sym__newline] = ACTIONS(4149),
  },
  [1425] = {
    [sym_block_comment] = STATE(1425),
    [sym_compiler_directive_decl] = STATE(1425),
    [sym_fsi_directive_decl] = STATE(1425),
    [sym_preproc_line] = STATE(1425),
    [sym_identifier] = ACTIONS(3531),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_LBRACK_LT] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(3531),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_do] = ACTIONS(3531),
    [anon_sym_and] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [aux_sym_access_modifier_token1] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_null] = ACTIONS(3531),
    [anon_sym_QMARK] = ACTIONS(3531),
    [anon_sym_COLON_QMARK] = ACTIONS(3531),
    [anon_sym_COLON_COLON] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3531),
    [anon_sym_LT_AT] = ACTIONS(3531),
    [anon_sym_LT_AT_AT] = ACTIONS(3531),
    [anon_sym_DOT] = ACTIONS(3531),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3531),
    [anon_sym_with] = ACTIONS(3531),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3531),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3531),
    [anon_sym_assert] = ACTIONS(3531),
    [anon_sym_upcast] = ACTIONS(3531),
    [anon_sym_downcast] = ACTIONS(3531),
    [anon_sym_COLON_GT] = ACTIONS(3529),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3531),
    [anon_sym_while] = ACTIONS(3531),
    [anon_sym_if] = ACTIONS(3531),
    [anon_sym_fun] = ACTIONS(3531),
    [anon_sym_DASH_GT] = ACTIONS(3531),
    [anon_sym_try] = ACTIONS(3531),
    [anon_sym_match] = ACTIONS(3531),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3531),
    [anon_sym_LT_DASH] = ACTIONS(3531),
    [anon_sym_DOT_LBRACK] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_use] = ACTIONS(3531),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3531),
    [anon_sym_LPAREN2] = ACTIONS(3531),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LT2] = ACTIONS(3531),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_default] = ACTIONS(3531),
    [anon_sym_or] = ACTIONS(3531),
    [anon_sym_static] = ACTIONS(3531),
    [anon_sym_member] = ACTIONS(3531),
    [anon_sym_interface] = ACTIONS(3531),
    [anon_sym_abstract] = ACTIONS(3531),
    [anon_sym_val] = ACTIONS(3531),
    [anon_sym_override] = ACTIONS(3531),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3531),
    [anon_sym_DQUOTE] = ACTIONS(3531),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3531),
    [sym_unit] = ACTIONS(3529),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3531),
    [sym_op_identifier] = ACTIONS(3531),
    [anon_sym_PLUS] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(3531),
    [anon_sym_PLUS_DOT] = ACTIONS(3531),
    [anon_sym_DASH_DOT] = ACTIONS(3531),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_AMP_AMP] = ACTIONS(3531),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3531),
    [aux_sym_infix_op_token1] = ACTIONS(3529),
    [aux_sym_infix_op_token2] = ACTIONS(3531),
    [anon_sym_PIPE_PIPE] = ACTIONS(3531),
    [anon_sym_BANG_EQ] = ACTIONS(3531),
    [anon_sym_COLON_EQ] = ACTIONS(3529),
    [anon_sym_DOLLAR] = ACTIONS(3531),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3531),
    [sym_int] = ACTIONS(3531),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [anon_sym_POUNDendif] = ACTIONS(3529),
    [anon_sym_POUNDelse] = ACTIONS(3529),
    [sym__newline] = ACTIONS(3529),
  },
  [1426] = {
    [sym_block_comment] = STATE(1426),
    [sym_compiler_directive_decl] = STATE(1426),
    [sym_fsi_directive_decl] = STATE(1426),
    [sym_preproc_line] = STATE(1426),
    [sym_identifier] = ACTIONS(3535),
    [anon_sym_EQ] = ACTIONS(3533),
    [anon_sym_LBRACK_LT] = ACTIONS(3533),
    [anon_sym_COLON] = ACTIONS(3535),
    [anon_sym_return] = ACTIONS(3535),
    [anon_sym_do] = ACTIONS(3535),
    [anon_sym_and] = ACTIONS(3535),
    [anon_sym_let] = ACTIONS(3535),
    [anon_sym_let_BANG] = ACTIONS(3533),
    [aux_sym_access_modifier_token1] = ACTIONS(3533),
    [anon_sym_LPAREN] = ACTIONS(3535),
    [anon_sym_COMMA] = ACTIONS(3533),
    [anon_sym_null] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(3535),
    [anon_sym_COLON_QMARK] = ACTIONS(3535),
    [anon_sym_COLON_COLON] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3533),
    [anon_sym_LBRACE] = ACTIONS(3535),
    [anon_sym_LT_AT] = ACTIONS(3535),
    [anon_sym_LT_AT_AT] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(3535),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3533),
    [anon_sym_new] = ACTIONS(3535),
    [anon_sym_with] = ACTIONS(3535),
    [anon_sym_return_BANG] = ACTIONS(3533),
    [anon_sym_yield] = ACTIONS(3535),
    [anon_sym_yield_BANG] = ACTIONS(3533),
    [anon_sym_lazy] = ACTIONS(3535),
    [anon_sym_assert] = ACTIONS(3535),
    [anon_sym_upcast] = ACTIONS(3535),
    [anon_sym_downcast] = ACTIONS(3535),
    [anon_sym_COLON_GT] = ACTIONS(3533),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3533),
    [anon_sym_for] = ACTIONS(3535),
    [anon_sym_while] = ACTIONS(3535),
    [anon_sym_if] = ACTIONS(3535),
    [anon_sym_fun] = ACTIONS(3535),
    [anon_sym_DASH_GT] = ACTIONS(3535),
    [anon_sym_try] = ACTIONS(3535),
    [anon_sym_match] = ACTIONS(3535),
    [anon_sym_match_BANG] = ACTIONS(3533),
    [anon_sym_function] = ACTIONS(3535),
    [anon_sym_LT_DASH] = ACTIONS(3535),
    [anon_sym_DOT_LBRACK] = ACTIONS(3533),
    [anon_sym_LT] = ACTIONS(3533),
    [anon_sym_use] = ACTIONS(3535),
    [anon_sym_use_BANG] = ACTIONS(3533),
    [anon_sym_do_BANG] = ACTIONS(3533),
    [anon_sym_begin] = ACTIONS(3535),
    [anon_sym_LPAREN2] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(3535),
    [anon_sym_LT2] = ACTIONS(3535),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3533),
    [anon_sym_default] = ACTIONS(3535),
    [anon_sym_or] = ACTIONS(3535),
    [anon_sym_static] = ACTIONS(3535),
    [anon_sym_member] = ACTIONS(3535),
    [anon_sym_interface] = ACTIONS(3535),
    [anon_sym_abstract] = ACTIONS(3535),
    [anon_sym_val] = ACTIONS(3535),
    [anon_sym_override] = ACTIONS(3535),
    [aux_sym_char_token1] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE] = ACTIONS(3535),
    [anon_sym_AT_DQUOTE] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [sym_bool] = ACTIONS(3535),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3535),
    [sym_op_identifier] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS_DOT] = ACTIONS(3535),
    [anon_sym_DASH_DOT] = ACTIONS(3535),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(3535),
    [anon_sym_TILDE] = ACTIONS(3533),
    [aux_sym_prefix_op_token1] = ACTIONS(3535),
    [aux_sym_infix_op_token1] = ACTIONS(3533),
    [aux_sym_infix_op_token2] = ACTIONS(3535),
    [anon_sym_PIPE_PIPE] = ACTIONS(3535),
    [anon_sym_BANG_EQ] = ACTIONS(3535),
    [anon_sym_COLON_EQ] = ACTIONS(3533),
    [anon_sym_DOLLAR] = ACTIONS(3535),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3535),
    [sym_int] = ACTIONS(3535),
    [sym_xint] = ACTIONS(3533),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3533),
    [anon_sym_POUNDendif] = ACTIONS(3533),
    [anon_sym_POUNDelse] = ACTIONS(3533),
    [sym__newline] = ACTIONS(3533),
  },
  [1427] = {
    [sym_block_comment] = STATE(1427),
    [sym_compiler_directive_decl] = STATE(1427),
    [sym_fsi_directive_decl] = STATE(1427),
    [sym_preproc_line] = STATE(1427),
    [sym_identifier] = ACTIONS(3511),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_LBRACK_LT] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3511),
    [anon_sym_return] = ACTIONS(3511),
    [anon_sym_do] = ACTIONS(3511),
    [anon_sym_let] = ACTIONS(3511),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [aux_sym_access_modifier_token1] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3511),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3511),
    [anon_sym_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(3511),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_LT_AT] = ACTIONS(3511),
    [anon_sym_LT_AT_AT] = ACTIONS(3511),
    [anon_sym_DOT] = ACTIONS(3511),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3511),
    [anon_sym_with] = ACTIONS(3511),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3511),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3511),
    [anon_sym_assert] = ACTIONS(3511),
    [anon_sym_upcast] = ACTIONS(3511),
    [anon_sym_downcast] = ACTIONS(3511),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3511),
    [anon_sym_while] = ACTIONS(3511),
    [anon_sym_if] = ACTIONS(3511),
    [anon_sym_fun] = ACTIONS(3511),
    [anon_sym_DASH_GT] = ACTIONS(3511),
    [anon_sym_try] = ACTIONS(3511),
    [anon_sym_match] = ACTIONS(3511),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3511),
    [anon_sym_LT_DASH] = ACTIONS(3511),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3511),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3511),
    [anon_sym_LPAREN2] = ACTIONS(3511),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_LT2] = ACTIONS(3511),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3509),
    [anon_sym_default] = ACTIONS(3511),
    [anon_sym_or] = ACTIONS(3511),
    [anon_sym_static] = ACTIONS(3511),
    [anon_sym_member] = ACTIONS(3511),
    [anon_sym_interface] = ACTIONS(3511),
    [anon_sym_abstract] = ACTIONS(3511),
    [anon_sym_val] = ACTIONS(3511),
    [anon_sym_override] = ACTIONS(3511),
    [anon_sym_inherit] = ACTIONS(3511),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3511),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3511),
    [sym_unit] = ACTIONS(3509),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3511),
    [sym_op_identifier] = ACTIONS(3511),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3511),
    [anon_sym_PLUS_DOT] = ACTIONS(3511),
    [anon_sym_DASH_DOT] = ACTIONS(3511),
    [anon_sym_PERCENT] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3511),
    [aux_sym_infix_op_token1] = ACTIONS(3509),
    [aux_sym_infix_op_token2] = ACTIONS(3511),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_BANG_EQ] = ACTIONS(3511),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3511),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3511),
    [sym_int] = ACTIONS(3511),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [anon_sym_POUNDendif] = ACTIONS(3509),
    [anon_sym_POUNDelse] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [1428] = {
    [sym_block_comment] = STATE(1428),
    [sym_compiler_directive_decl] = STATE(1428),
    [sym_fsi_directive_decl] = STATE(1428),
    [sym_preproc_line] = STATE(1428),
    [aux_sym_long_identifier_repeat1] = STATE(1428),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [aux_sym_access_modifier_token1] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(4153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_DOT_DOT2] = ACTIONS(3485),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_member] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_val] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
    [sym__dedent] = ACTIONS(3485),
  },
  [1429] = {
    [sym_block_comment] = STATE(1429),
    [sym_compiler_directive_decl] = STATE(1429),
    [sym_fsi_directive_decl] = STATE(1429),
    [sym_preproc_line] = STATE(1429),
    [ts_builtin_sym_end] = ACTIONS(4156),
    [sym_identifier] = ACTIONS(4158),
    [anon_sym_namespace] = ACTIONS(4158),
    [anon_sym_module] = ACTIONS(4158),
    [anon_sym_EQ] = ACTIONS(4156),
    [anon_sym_open] = ACTIONS(4158),
    [anon_sym_LBRACK_LT] = ACTIONS(4156),
    [anon_sym_COLON] = ACTIONS(4158),
    [anon_sym_return] = ACTIONS(4158),
    [anon_sym_type] = ACTIONS(4158),
    [anon_sym_do] = ACTIONS(4158),
    [anon_sym_and] = ACTIONS(4158),
    [anon_sym_let] = ACTIONS(4158),
    [anon_sym_let_BANG] = ACTIONS(4156),
    [aux_sym_access_modifier_token1] = ACTIONS(4156),
    [anon_sym_LPAREN] = ACTIONS(4158),
    [anon_sym_COMMA] = ACTIONS(4156),
    [anon_sym_null] = ACTIONS(4158),
    [anon_sym_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_COLON] = ACTIONS(4156),
    [anon_sym_AMP] = ACTIONS(4158),
    [anon_sym_LBRACK] = ACTIONS(4158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(4158),
    [anon_sym_LT_AT] = ACTIONS(4158),
    [anon_sym_LT_AT_AT] = ACTIONS(4158),
    [anon_sym_DOT] = ACTIONS(4158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4156),
    [anon_sym_new] = ACTIONS(4158),
    [anon_sym_with] = ACTIONS(4158),
    [anon_sym_return_BANG] = ACTIONS(4156),
    [anon_sym_yield] = ACTIONS(4158),
    [anon_sym_yield_BANG] = ACTIONS(4156),
    [anon_sym_lazy] = ACTIONS(4158),
    [anon_sym_assert] = ACTIONS(4158),
    [anon_sym_upcast] = ACTIONS(4158),
    [anon_sym_downcast] = ACTIONS(4158),
    [anon_sym_COLON_GT] = ACTIONS(4156),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4156),
    [anon_sym_for] = ACTIONS(4158),
    [anon_sym_while] = ACTIONS(4158),
    [anon_sym_if] = ACTIONS(4158),
    [anon_sym_fun] = ACTIONS(4158),
    [anon_sym_try] = ACTIONS(4158),
    [anon_sym_match] = ACTIONS(4158),
    [anon_sym_match_BANG] = ACTIONS(4156),
    [anon_sym_function] = ACTIONS(4158),
    [anon_sym_LT_DASH] = ACTIONS(4158),
    [anon_sym_DOT_LBRACK] = ACTIONS(4156),
    [anon_sym_LT] = ACTIONS(4156),
    [anon_sym_use] = ACTIONS(4158),
    [anon_sym_use_BANG] = ACTIONS(4156),
    [anon_sym_do_BANG] = ACTIONS(4156),
    [anon_sym_begin] = ACTIONS(4158),
    [anon_sym_LPAREN2] = ACTIONS(4158),
    [anon_sym_default] = ACTIONS(4158),
    [anon_sym_or] = ACTIONS(4158),
    [anon_sym_static] = ACTIONS(4158),
    [anon_sym_member] = ACTIONS(4158),
    [anon_sym_interface] = ACTIONS(4158),
    [anon_sym_exception] = ACTIONS(4158),
    [anon_sym_abstract] = ACTIONS(4158),
    [anon_sym_val] = ACTIONS(4158),
    [anon_sym_override] = ACTIONS(4158),
    [aux_sym_char_token1] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4158),
    [anon_sym_DQUOTE] = ACTIONS(4158),
    [anon_sym_AT_DQUOTE] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [sym_bool] = ACTIONS(4158),
    [sym_unit] = ACTIONS(4156),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4158),
    [sym_op_identifier] = ACTIONS(4158),
    [anon_sym_PLUS] = ACTIONS(4158),
    [anon_sym_DASH] = ACTIONS(4158),
    [anon_sym_PLUS_DOT] = ACTIONS(4158),
    [anon_sym_DASH_DOT] = ACTIONS(4158),
    [anon_sym_PERCENT] = ACTIONS(4158),
    [anon_sym_AMP_AMP] = ACTIONS(4158),
    [anon_sym_TILDE] = ACTIONS(4156),
    [aux_sym_prefix_op_token1] = ACTIONS(4158),
    [aux_sym_infix_op_token1] = ACTIONS(4156),
    [aux_sym_infix_op_token2] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE] = ACTIONS(4158),
    [anon_sym_BANG_EQ] = ACTIONS(4158),
    [anon_sym_COLON_EQ] = ACTIONS(4156),
    [anon_sym_DOLLAR] = ACTIONS(4158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4158),
    [sym_int] = ACTIONS(4158),
    [sym_xint] = ACTIONS(4156),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4156),
    [anon_sym_POUNDload] = ACTIONS(4156),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4156),
    [sym__newline] = ACTIONS(4156),
  },
  [1430] = {
    [sym_block_comment] = STATE(1430),
    [sym_compiler_directive_decl] = STATE(1430),
    [sym_fsi_directive_decl] = STATE(1430),
    [sym_preproc_line] = STATE(1430),
    [aux_sym_long_identifier_repeat1] = STATE(1328),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_EQ] = ACTIONS(3492),
    [anon_sym_LBRACK_LT] = ACTIONS(3492),
    [anon_sym_COLON] = ACTIONS(3494),
    [anon_sym_return] = ACTIONS(3494),
    [anon_sym_do] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_let_BANG] = ACTIONS(3492),
    [aux_sym_access_modifier_token1] = ACTIONS(3492),
    [anon_sym_LPAREN] = ACTIONS(3494),
    [anon_sym_COMMA] = ACTIONS(3492),
    [anon_sym_null] = ACTIONS(3494),
    [anon_sym_QMARK] = ACTIONS(3494),
    [anon_sym_COLON_QMARK] = ACTIONS(3494),
    [anon_sym_COLON_COLON] = ACTIONS(3492),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3492),
    [anon_sym_LBRACE] = ACTIONS(3494),
    [anon_sym_LT_AT] = ACTIONS(3494),
    [anon_sym_LT_AT_AT] = ACTIONS(3494),
    [anon_sym_DOT] = ACTIONS(3877),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3492),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_with] = ACTIONS(3494),
    [anon_sym_return_BANG] = ACTIONS(3492),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_yield_BANG] = ACTIONS(3492),
    [anon_sym_lazy] = ACTIONS(3494),
    [anon_sym_assert] = ACTIONS(3494),
    [anon_sym_upcast] = ACTIONS(3494),
    [anon_sym_downcast] = ACTIONS(3494),
    [anon_sym_COLON_GT] = ACTIONS(3492),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3492),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_while] = ACTIONS(3494),
    [anon_sym_if] = ACTIONS(3494),
    [anon_sym_fun] = ACTIONS(3494),
    [anon_sym_DASH_GT] = ACTIONS(3494),
    [anon_sym_try] = ACTIONS(3494),
    [anon_sym_match] = ACTIONS(3494),
    [anon_sym_match_BANG] = ACTIONS(3492),
    [anon_sym_function] = ACTIONS(3494),
    [anon_sym_LT_DASH] = ACTIONS(3494),
    [anon_sym_DOT_LBRACK] = ACTIONS(3492),
    [anon_sym_LT] = ACTIONS(3492),
    [anon_sym_use] = ACTIONS(3494),
    [anon_sym_use_BANG] = ACTIONS(3492),
    [anon_sym_do_BANG] = ACTIONS(3492),
    [anon_sym_begin] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(3494),
    [anon_sym_DOT_DOT2] = ACTIONS(3492),
    [anon_sym_STAR] = ACTIONS(3494),
    [anon_sym_LT2] = ACTIONS(3494),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3492),
    [anon_sym_default] = ACTIONS(3494),
    [anon_sym_or] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_member] = ACTIONS(3494),
    [anon_sym_interface] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_val] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [aux_sym_char_token1] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3494),
    [anon_sym_DQUOTE] = ACTIONS(3494),
    [anon_sym_AT_DQUOTE] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [sym_bool] = ACTIONS(3494),
    [sym_unit] = ACTIONS(3492),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3494),
    [sym_op_identifier] = ACTIONS(3494),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_PLUS_DOT] = ACTIONS(3494),
    [anon_sym_DASH_DOT] = ACTIONS(3494),
    [anon_sym_PERCENT] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_TILDE] = ACTIONS(3492),
    [aux_sym_prefix_op_token1] = ACTIONS(3494),
    [aux_sym_infix_op_token1] = ACTIONS(3492),
    [aux_sym_infix_op_token2] = ACTIONS(3494),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_COLON_EQ] = ACTIONS(3492),
    [anon_sym_DOLLAR] = ACTIONS(3494),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3494),
    [sym_int] = ACTIONS(3494),
    [sym_xint] = ACTIONS(3492),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3492),
    [sym__newline] = ACTIONS(3492),
    [sym__dedent] = ACTIONS(3492),
  },
  [1431] = {
    [sym_block_comment] = STATE(1431),
    [sym_compiler_directive_decl] = STATE(1431),
    [sym_fsi_directive_decl] = STATE(1431),
    [sym_preproc_line] = STATE(1431),
    [ts_builtin_sym_end] = ACTIONS(4160),
    [sym_identifier] = ACTIONS(4162),
    [anon_sym_namespace] = ACTIONS(4162),
    [anon_sym_module] = ACTIONS(4162),
    [anon_sym_EQ] = ACTIONS(4160),
    [anon_sym_open] = ACTIONS(4162),
    [anon_sym_LBRACK_LT] = ACTIONS(4160),
    [anon_sym_COLON] = ACTIONS(4162),
    [anon_sym_return] = ACTIONS(4162),
    [anon_sym_type] = ACTIONS(4162),
    [anon_sym_do] = ACTIONS(4162),
    [anon_sym_and] = ACTIONS(4162),
    [anon_sym_let] = ACTIONS(4162),
    [anon_sym_let_BANG] = ACTIONS(4160),
    [aux_sym_access_modifier_token1] = ACTIONS(4160),
    [anon_sym_LPAREN] = ACTIONS(4162),
    [anon_sym_COMMA] = ACTIONS(4160),
    [anon_sym_null] = ACTIONS(4162),
    [anon_sym_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4160),
    [anon_sym_AMP] = ACTIONS(4162),
    [anon_sym_LBRACK] = ACTIONS(4162),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4160),
    [anon_sym_LBRACE] = ACTIONS(4162),
    [anon_sym_LT_AT] = ACTIONS(4162),
    [anon_sym_LT_AT_AT] = ACTIONS(4162),
    [anon_sym_DOT] = ACTIONS(4162),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4160),
    [anon_sym_new] = ACTIONS(4162),
    [anon_sym_with] = ACTIONS(4162),
    [anon_sym_return_BANG] = ACTIONS(4160),
    [anon_sym_yield] = ACTIONS(4162),
    [anon_sym_yield_BANG] = ACTIONS(4160),
    [anon_sym_lazy] = ACTIONS(4162),
    [anon_sym_assert] = ACTIONS(4162),
    [anon_sym_upcast] = ACTIONS(4162),
    [anon_sym_downcast] = ACTIONS(4162),
    [anon_sym_COLON_GT] = ACTIONS(4160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4160),
    [anon_sym_for] = ACTIONS(4162),
    [anon_sym_while] = ACTIONS(4162),
    [anon_sym_if] = ACTIONS(4162),
    [anon_sym_fun] = ACTIONS(4162),
    [anon_sym_try] = ACTIONS(4162),
    [anon_sym_match] = ACTIONS(4162),
    [anon_sym_match_BANG] = ACTIONS(4160),
    [anon_sym_function] = ACTIONS(4162),
    [anon_sym_LT_DASH] = ACTIONS(4162),
    [anon_sym_DOT_LBRACK] = ACTIONS(4160),
    [anon_sym_LT] = ACTIONS(4160),
    [anon_sym_use] = ACTIONS(4162),
    [anon_sym_use_BANG] = ACTIONS(4160),
    [anon_sym_do_BANG] = ACTIONS(4160),
    [anon_sym_begin] = ACTIONS(4162),
    [anon_sym_LPAREN2] = ACTIONS(4162),
    [anon_sym_default] = ACTIONS(4162),
    [anon_sym_or] = ACTIONS(4162),
    [anon_sym_static] = ACTIONS(4162),
    [anon_sym_member] = ACTIONS(4162),
    [anon_sym_interface] = ACTIONS(4162),
    [anon_sym_exception] = ACTIONS(4162),
    [anon_sym_abstract] = ACTIONS(4162),
    [anon_sym_val] = ACTIONS(4162),
    [anon_sym_override] = ACTIONS(4162),
    [aux_sym_char_token1] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4162),
    [anon_sym_DQUOTE] = ACTIONS(4162),
    [anon_sym_AT_DQUOTE] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [sym_bool] = ACTIONS(4162),
    [sym_unit] = ACTIONS(4160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4162),
    [sym_op_identifier] = ACTIONS(4162),
    [anon_sym_PLUS] = ACTIONS(4162),
    [anon_sym_DASH] = ACTIONS(4162),
    [anon_sym_PLUS_DOT] = ACTIONS(4162),
    [anon_sym_DASH_DOT] = ACTIONS(4162),
    [anon_sym_PERCENT] = ACTIONS(4162),
    [anon_sym_AMP_AMP] = ACTIONS(4162),
    [anon_sym_TILDE] = ACTIONS(4160),
    [aux_sym_prefix_op_token1] = ACTIONS(4162),
    [aux_sym_infix_op_token1] = ACTIONS(4160),
    [aux_sym_infix_op_token2] = ACTIONS(4162),
    [anon_sym_PIPE_PIPE] = ACTIONS(4162),
    [anon_sym_BANG_EQ] = ACTIONS(4162),
    [anon_sym_COLON_EQ] = ACTIONS(4160),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4162),
    [sym_int] = ACTIONS(4162),
    [sym_xint] = ACTIONS(4160),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4160),
    [anon_sym_POUNDload] = ACTIONS(4160),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4160),
    [sym__newline] = ACTIONS(4160),
  },
  [1432] = {
    [sym_block_comment] = STATE(1432),
    [sym_compiler_directive_decl] = STATE(1432),
    [sym_fsi_directive_decl] = STATE(1432),
    [sym_preproc_line] = STATE(1432),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [aux_sym_access_modifier_token1] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_member] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_val] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [anon_sym_inherit] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [anon_sym_POUNDendif] = ACTIONS(3485),
    [anon_sym_POUNDelse] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [1433] = {
    [sym_block_comment] = STATE(1433),
    [sym_compiler_directive_decl] = STATE(1433),
    [sym_fsi_directive_decl] = STATE(1433),
    [sym_preproc_line] = STATE(1433),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(3521),
    [anon_sym_LBRACK_LT] = ACTIONS(3521),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3521),
    [aux_sym_access_modifier_token1] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_COMMA] = ACTIONS(3521),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_COLON] = ACTIONS(3521),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_with] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3521),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3521),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_COLON_GT] = ACTIONS(3521),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_DASH_GT] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3521),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_LT_DASH] = ACTIONS(3523),
    [anon_sym_DOT_LBRACK] = ACTIONS(3521),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3521),
    [anon_sym_do_BANG] = ACTIONS(3521),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_LPAREN2] = ACTIONS(3523),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_LT2] = ACTIONS(3523),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3521),
    [anon_sym_default] = ACTIONS(3523),
    [anon_sym_or] = ACTIONS(3523),
    [anon_sym_static] = ACTIONS(3523),
    [anon_sym_member] = ACTIONS(3523),
    [anon_sym_interface] = ACTIONS(3523),
    [anon_sym_abstract] = ACTIONS(3523),
    [anon_sym_val] = ACTIONS(3523),
    [anon_sym_override] = ACTIONS(3523),
    [anon_sym_inherit] = ACTIONS(3523),
    [aux_sym_char_token1] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3521),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3523),
    [anon_sym_DASH_DOT] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3521),
    [aux_sym_prefix_op_token1] = ACTIONS(3523),
    [aux_sym_infix_op_token1] = ACTIONS(3521),
    [aux_sym_infix_op_token2] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3523),
    [anon_sym_COLON_EQ] = ACTIONS(3521),
    [anon_sym_DOLLAR] = ACTIONS(3523),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3523),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3521),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3521),
    [anon_sym_POUNDendif] = ACTIONS(3521),
    [anon_sym_POUNDelse] = ACTIONS(3521),
    [sym__newline] = ACTIONS(3521),
  },
  [1434] = {
    [sym_block_comment] = STATE(1434),
    [sym_compiler_directive_decl] = STATE(1434),
    [sym_fsi_directive_decl] = STATE(1434),
    [sym_preproc_line] = STATE(1434),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_EQ] = ACTIONS(3560),
    [anon_sym_LBRACK_LT] = ACTIONS(3560),
    [anon_sym_COLON] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_and] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_let_BANG] = ACTIONS(3560),
    [aux_sym_access_modifier_token1] = ACTIONS(3560),
    [anon_sym_LPAREN] = ACTIONS(3562),
    [anon_sym_COMMA] = ACTIONS(3560),
    [anon_sym_null] = ACTIONS(3562),
    [anon_sym_QMARK] = ACTIONS(3562),
    [anon_sym_COLON_QMARK] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3560),
    [anon_sym_LBRACE] = ACTIONS(3562),
    [anon_sym_LT_AT] = ACTIONS(3562),
    [anon_sym_LT_AT_AT] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(3562),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3560),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_with] = ACTIONS(3562),
    [anon_sym_return_BANG] = ACTIONS(3560),
    [anon_sym_yield] = ACTIONS(3562),
    [anon_sym_yield_BANG] = ACTIONS(3560),
    [anon_sym_lazy] = ACTIONS(3562),
    [anon_sym_assert] = ACTIONS(3562),
    [anon_sym_upcast] = ACTIONS(3562),
    [anon_sym_downcast] = ACTIONS(3562),
    [anon_sym_COLON_GT] = ACTIONS(3560),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3560),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_fun] = ACTIONS(3562),
    [anon_sym_DASH_GT] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_match] = ACTIONS(3562),
    [anon_sym_match_BANG] = ACTIONS(3560),
    [anon_sym_function] = ACTIONS(3562),
    [anon_sym_LT_DASH] = ACTIONS(3562),
    [anon_sym_DOT_LBRACK] = ACTIONS(3560),
    [anon_sym_LT] = ACTIONS(3560),
    [anon_sym_use] = ACTIONS(3562),
    [anon_sym_use_BANG] = ACTIONS(3560),
    [anon_sym_do_BANG] = ACTIONS(3560),
    [anon_sym_begin] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3562),
    [anon_sym_LT2] = ACTIONS(3562),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3560),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_or] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_member] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_abstract] = ACTIONS(3562),
    [anon_sym_val] = ACTIONS(3562),
    [anon_sym_override] = ACTIONS(3562),
    [aux_sym_char_token1] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(3562),
    [anon_sym_AT_DQUOTE] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [sym_bool] = ACTIONS(3562),
    [sym_unit] = ACTIONS(3560),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3562),
    [sym_op_identifier] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS_DOT] = ACTIONS(3562),
    [anon_sym_DASH_DOT] = ACTIONS(3562),
    [anon_sym_PERCENT] = ACTIONS(3562),
    [anon_sym_AMP_AMP] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3560),
    [aux_sym_prefix_op_token1] = ACTIONS(3562),
    [aux_sym_infix_op_token1] = ACTIONS(3560),
    [aux_sym_infix_op_token2] = ACTIONS(3562),
    [anon_sym_PIPE_PIPE] = ACTIONS(3562),
    [anon_sym_BANG_EQ] = ACTIONS(3562),
    [anon_sym_COLON_EQ] = ACTIONS(3560),
    [anon_sym_DOLLAR] = ACTIONS(3562),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3562),
    [sym_int] = ACTIONS(3562),
    [sym_xint] = ACTIONS(3560),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3560),
    [anon_sym_POUNDendif] = ACTIONS(3560),
    [anon_sym_POUNDelse] = ACTIONS(3560),
    [sym__newline] = ACTIONS(3560),
  },
  [1435] = {
    [sym_block_comment] = STATE(1435),
    [sym_compiler_directive_decl] = STATE(1435),
    [sym_fsi_directive_decl] = STATE(1435),
    [sym_preproc_line] = STATE(1435),
    [aux_sym_type_argument_repeat1] = STATE(1453),
    [sym_identifier] = ACTIONS(3476),
    [anon_sym_EQ] = ACTIONS(3474),
    [anon_sym_LBRACK_LT] = ACTIONS(3474),
    [anon_sym_COLON] = ACTIONS(3476),
    [anon_sym_return] = ACTIONS(3476),
    [anon_sym_do] = ACTIONS(3476),
    [anon_sym_and] = ACTIONS(3476),
    [anon_sym_let] = ACTIONS(3476),
    [anon_sym_let_BANG] = ACTIONS(3474),
    [aux_sym_access_modifier_token1] = ACTIONS(3474),
    [anon_sym_LPAREN] = ACTIONS(3476),
    [anon_sym_COMMA] = ACTIONS(3474),
    [anon_sym_null] = ACTIONS(3476),
    [anon_sym_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_COLON] = ACTIONS(3474),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym_LBRACK] = ACTIONS(3476),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3474),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_LT_AT] = ACTIONS(3476),
    [anon_sym_LT_AT_AT] = ACTIONS(3476),
    [anon_sym_DOT] = ACTIONS(3476),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3474),
    [anon_sym_new] = ACTIONS(3476),
    [anon_sym_with] = ACTIONS(3476),
    [anon_sym_return_BANG] = ACTIONS(3474),
    [anon_sym_yield] = ACTIONS(3476),
    [anon_sym_yield_BANG] = ACTIONS(3474),
    [anon_sym_lazy] = ACTIONS(3476),
    [anon_sym_assert] = ACTIONS(3476),
    [anon_sym_upcast] = ACTIONS(3476),
    [anon_sym_downcast] = ACTIONS(3476),
    [anon_sym_COLON_GT] = ACTIONS(3474),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3474),
    [anon_sym_for] = ACTIONS(3476),
    [anon_sym_while] = ACTIONS(3476),
    [anon_sym_if] = ACTIONS(3476),
    [anon_sym_fun] = ACTIONS(3476),
    [anon_sym_DASH_GT] = ACTIONS(3476),
    [anon_sym_try] = ACTIONS(3476),
    [anon_sym_match] = ACTIONS(3476),
    [anon_sym_match_BANG] = ACTIONS(3474),
    [anon_sym_function] = ACTIONS(3476),
    [anon_sym_LT_DASH] = ACTIONS(3476),
    [anon_sym_DOT_LBRACK] = ACTIONS(3474),
    [anon_sym_LT] = ACTIONS(3474),
    [anon_sym_use] = ACTIONS(3476),
    [anon_sym_use_BANG] = ACTIONS(3474),
    [anon_sym_do_BANG] = ACTIONS(3474),
    [anon_sym_begin] = ACTIONS(3476),
    [anon_sym_LPAREN2] = ACTIONS(3476),
    [anon_sym_STAR] = ACTIONS(3476),
    [anon_sym_LT2] = ACTIONS(3476),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3474),
    [anon_sym_default] = ACTIONS(3476),
    [anon_sym_or] = ACTIONS(3476),
    [anon_sym_static] = ACTIONS(3476),
    [anon_sym_member] = ACTIONS(3476),
    [anon_sym_interface] = ACTIONS(3476),
    [anon_sym_abstract] = ACTIONS(3476),
    [anon_sym_val] = ACTIONS(3476),
    [anon_sym_override] = ACTIONS(3476),
    [aux_sym_char_token1] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3476),
    [anon_sym_DQUOTE] = ACTIONS(3476),
    [anon_sym_AT_DQUOTE] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [sym_bool] = ACTIONS(3476),
    [sym_unit] = ACTIONS(3474),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3476),
    [sym_op_identifier] = ACTIONS(3476),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3476),
    [anon_sym_PLUS_DOT] = ACTIONS(3476),
    [anon_sym_DASH_DOT] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [anon_sym_AMP_AMP] = ACTIONS(3476),
    [anon_sym_TILDE] = ACTIONS(3474),
    [aux_sym_prefix_op_token1] = ACTIONS(3476),
    [aux_sym_infix_op_token1] = ACTIONS(3474),
    [aux_sym_infix_op_token2] = ACTIONS(3476),
    [anon_sym_PIPE_PIPE] = ACTIONS(3476),
    [anon_sym_BANG_EQ] = ACTIONS(3476),
    [anon_sym_COLON_EQ] = ACTIONS(3474),
    [anon_sym_DOLLAR] = ACTIONS(3476),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3476),
    [sym_int] = ACTIONS(3476),
    [sym_xint] = ACTIONS(3474),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3474),
    [anon_sym_POUNDendif] = ACTIONS(3474),
    [sym__newline] = ACTIONS(3474),
  },
  [1436] = {
    [sym_block_comment] = STATE(1436),
    [sym_compiler_directive_decl] = STATE(1436),
    [sym_fsi_directive_decl] = STATE(1436),
    [sym_preproc_line] = STATE(1436),
    [sym_identifier] = ACTIONS(3551),
    [anon_sym_EQ] = ACTIONS(3549),
    [anon_sym_LBRACK_LT] = ACTIONS(3549),
    [anon_sym_COLON] = ACTIONS(3551),
    [anon_sym_return] = ACTIONS(3551),
    [anon_sym_do] = ACTIONS(3551),
    [anon_sym_and] = ACTIONS(3551),
    [anon_sym_let] = ACTIONS(3551),
    [anon_sym_let_BANG] = ACTIONS(3549),
    [aux_sym_access_modifier_token1] = ACTIONS(3549),
    [anon_sym_LPAREN] = ACTIONS(3551),
    [anon_sym_COMMA] = ACTIONS(3549),
    [anon_sym_null] = ACTIONS(3551),
    [anon_sym_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_COLON] = ACTIONS(3549),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(3551),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3549),
    [anon_sym_LBRACE] = ACTIONS(3551),
    [anon_sym_LT_AT] = ACTIONS(3551),
    [anon_sym_LT_AT_AT] = ACTIONS(3551),
    [anon_sym_DOT] = ACTIONS(3551),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3549),
    [anon_sym_new] = ACTIONS(3551),
    [anon_sym_with] = ACTIONS(3551),
    [anon_sym_return_BANG] = ACTIONS(3549),
    [anon_sym_yield] = ACTIONS(3551),
    [anon_sym_yield_BANG] = ACTIONS(3549),
    [anon_sym_lazy] = ACTIONS(3551),
    [anon_sym_assert] = ACTIONS(3551),
    [anon_sym_upcast] = ACTIONS(3551),
    [anon_sym_downcast] = ACTIONS(3551),
    [anon_sym_COLON_GT] = ACTIONS(3549),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3549),
    [anon_sym_for] = ACTIONS(3551),
    [anon_sym_while] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(3551),
    [anon_sym_fun] = ACTIONS(3551),
    [anon_sym_DASH_GT] = ACTIONS(3551),
    [anon_sym_try] = ACTIONS(3551),
    [anon_sym_match] = ACTIONS(3551),
    [anon_sym_match_BANG] = ACTIONS(3549),
    [anon_sym_function] = ACTIONS(3551),
    [anon_sym_LT_DASH] = ACTIONS(3551),
    [anon_sym_DOT_LBRACK] = ACTIONS(3549),
    [anon_sym_LT] = ACTIONS(3549),
    [anon_sym_use] = ACTIONS(3551),
    [anon_sym_use_BANG] = ACTIONS(3549),
    [anon_sym_do_BANG] = ACTIONS(3549),
    [anon_sym_begin] = ACTIONS(3551),
    [anon_sym_LPAREN2] = ACTIONS(3551),
    [anon_sym_STAR] = ACTIONS(3551),
    [anon_sym_LT2] = ACTIONS(3551),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3549),
    [anon_sym_default] = ACTIONS(3551),
    [anon_sym_or] = ACTIONS(3551),
    [anon_sym_static] = ACTIONS(3551),
    [anon_sym_member] = ACTIONS(3551),
    [anon_sym_interface] = ACTIONS(3551),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_val] = ACTIONS(3551),
    [anon_sym_override] = ACTIONS(3551),
    [aux_sym_char_token1] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [anon_sym_AT_DQUOTE] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [sym_bool] = ACTIONS(3551),
    [sym_unit] = ACTIONS(3549),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3551),
    [sym_op_identifier] = ACTIONS(3551),
    [anon_sym_PLUS] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(3551),
    [anon_sym_PLUS_DOT] = ACTIONS(3551),
    [anon_sym_DASH_DOT] = ACTIONS(3551),
    [anon_sym_PERCENT] = ACTIONS(3551),
    [anon_sym_AMP_AMP] = ACTIONS(3551),
    [anon_sym_TILDE] = ACTIONS(3549),
    [aux_sym_prefix_op_token1] = ACTIONS(3551),
    [aux_sym_infix_op_token1] = ACTIONS(3549),
    [aux_sym_infix_op_token2] = ACTIONS(3551),
    [anon_sym_PIPE_PIPE] = ACTIONS(3551),
    [anon_sym_BANG_EQ] = ACTIONS(3551),
    [anon_sym_COLON_EQ] = ACTIONS(3549),
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3551),
    [sym_int] = ACTIONS(3551),
    [sym_xint] = ACTIONS(3549),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3549),
    [anon_sym_POUNDendif] = ACTIONS(3549),
    [anon_sym_POUNDelse] = ACTIONS(3549),
    [sym__newline] = ACTIONS(3549),
  },
  [1437] = {
    [sym__else_expression] = STATE(1985),
    [sym_elif_expression] = STATE(1651),
    [sym_block_comment] = STATE(1437),
    [sym_compiler_directive_decl] = STATE(1437),
    [sym_fsi_directive_decl] = STATE(1437),
    [sym_preproc_line] = STATE(1437),
    [aux_sym_if_expression_repeat1] = STATE(1544),
    [sym_identifier] = ACTIONS(3457),
    [anon_sym_EQ] = ACTIONS(3455),
    [anon_sym_LBRACK_LT] = ACTIONS(3455),
    [anon_sym_COLON] = ACTIONS(3457),
    [anon_sym_return] = ACTIONS(3457),
    [anon_sym_do] = ACTIONS(3457),
    [anon_sym_and] = ACTIONS(3457),
    [anon_sym_let] = ACTIONS(3457),
    [anon_sym_let_BANG] = ACTIONS(3455),
    [aux_sym_access_modifier_token1] = ACTIONS(3455),
    [anon_sym_LPAREN] = ACTIONS(3457),
    [anon_sym_COMMA] = ACTIONS(3455),
    [anon_sym_null] = ACTIONS(3457),
    [anon_sym_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_COLON] = ACTIONS(3455),
    [anon_sym_AMP] = ACTIONS(3457),
    [anon_sym_LBRACK] = ACTIONS(3457),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3457),
    [anon_sym_LT_AT] = ACTIONS(3457),
    [anon_sym_LT_AT_AT] = ACTIONS(3457),
    [anon_sym_DOT] = ACTIONS(3457),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3457),
    [anon_sym_with] = ACTIONS(3457),
    [anon_sym_return_BANG] = ACTIONS(3455),
    [anon_sym_yield] = ACTIONS(3457),
    [anon_sym_yield_BANG] = ACTIONS(3455),
    [anon_sym_lazy] = ACTIONS(3457),
    [anon_sym_assert] = ACTIONS(3457),
    [anon_sym_upcast] = ACTIONS(3457),
    [anon_sym_downcast] = ACTIONS(3457),
    [anon_sym_COLON_GT] = ACTIONS(3455),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3457),
    [anon_sym_while] = ACTIONS(3457),
    [anon_sym_else] = ACTIONS(4164),
    [anon_sym_elif] = ACTIONS(4166),
    [anon_sym_if] = ACTIONS(3457),
    [anon_sym_fun] = ACTIONS(3457),
    [anon_sym_try] = ACTIONS(3457),
    [anon_sym_match] = ACTIONS(3457),
    [anon_sym_match_BANG] = ACTIONS(3455),
    [anon_sym_function] = ACTIONS(3457),
    [anon_sym_LT_DASH] = ACTIONS(3457),
    [anon_sym_DOT_LBRACK] = ACTIONS(3455),
    [anon_sym_LT] = ACTIONS(3455),
    [anon_sym_use] = ACTIONS(3457),
    [anon_sym_use_BANG] = ACTIONS(3455),
    [anon_sym_do_BANG] = ACTIONS(3455),
    [anon_sym_begin] = ACTIONS(3457),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_default] = ACTIONS(3457),
    [anon_sym_or] = ACTIONS(3457),
    [anon_sym_static] = ACTIONS(3457),
    [anon_sym_member] = ACTIONS(3457),
    [anon_sym_interface] = ACTIONS(3457),
    [anon_sym_abstract] = ACTIONS(3457),
    [anon_sym_val] = ACTIONS(3457),
    [anon_sym_override] = ACTIONS(3457),
    [aux_sym_char_token1] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [anon_sym_AT_DQUOTE] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [sym_bool] = ACTIONS(3457),
    [sym_unit] = ACTIONS(3455),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3457),
    [sym_op_identifier] = ACTIONS(3457),
    [anon_sym_PLUS] = ACTIONS(3457),
    [anon_sym_DASH] = ACTIONS(3457),
    [anon_sym_PLUS_DOT] = ACTIONS(3457),
    [anon_sym_DASH_DOT] = ACTIONS(3457),
    [anon_sym_PERCENT] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3455),
    [aux_sym_prefix_op_token1] = ACTIONS(3457),
    [aux_sym_infix_op_token1] = ACTIONS(3455),
    [aux_sym_infix_op_token2] = ACTIONS(3457),
    [anon_sym_PIPE_PIPE] = ACTIONS(3457),
    [anon_sym_BANG_EQ] = ACTIONS(3457),
    [anon_sym_COLON_EQ] = ACTIONS(3455),
    [anon_sym_DOLLAR] = ACTIONS(3457),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3457),
    [sym_int] = ACTIONS(3457),
    [sym_xint] = ACTIONS(3455),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3455),
    [anon_sym_POUNDendif] = ACTIONS(3455),
    [sym__newline] = ACTIONS(3455),
  },
  [1438] = {
    [sym_block_comment] = STATE(1438),
    [sym_compiler_directive_decl] = STATE(1438),
    [sym_fsi_directive_decl] = STATE(1438),
    [sym_preproc_line] = STATE(1438),
    [ts_builtin_sym_end] = ACTIONS(4168),
    [sym_identifier] = ACTIONS(4170),
    [anon_sym_namespace] = ACTIONS(4170),
    [anon_sym_module] = ACTIONS(4170),
    [anon_sym_EQ] = ACTIONS(4168),
    [anon_sym_open] = ACTIONS(4170),
    [anon_sym_LBRACK_LT] = ACTIONS(4168),
    [anon_sym_COLON] = ACTIONS(4170),
    [anon_sym_return] = ACTIONS(4170),
    [anon_sym_type] = ACTIONS(4170),
    [anon_sym_do] = ACTIONS(4170),
    [anon_sym_and] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_let_BANG] = ACTIONS(4168),
    [aux_sym_access_modifier_token1] = ACTIONS(4168),
    [anon_sym_LPAREN] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4168),
    [anon_sym_null] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_COLON] = ACTIONS(4168),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4170),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4168),
    [anon_sym_LBRACE] = ACTIONS(4170),
    [anon_sym_LT_AT] = ACTIONS(4170),
    [anon_sym_LT_AT_AT] = ACTIONS(4170),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4168),
    [anon_sym_new] = ACTIONS(4170),
    [anon_sym_with] = ACTIONS(4170),
    [anon_sym_return_BANG] = ACTIONS(4168),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_yield_BANG] = ACTIONS(4168),
    [anon_sym_lazy] = ACTIONS(4170),
    [anon_sym_assert] = ACTIONS(4170),
    [anon_sym_upcast] = ACTIONS(4170),
    [anon_sym_downcast] = ACTIONS(4170),
    [anon_sym_COLON_GT] = ACTIONS(4168),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4168),
    [anon_sym_for] = ACTIONS(4170),
    [anon_sym_while] = ACTIONS(4170),
    [anon_sym_if] = ACTIONS(4170),
    [anon_sym_fun] = ACTIONS(4170),
    [anon_sym_try] = ACTIONS(4170),
    [anon_sym_match] = ACTIONS(4170),
    [anon_sym_match_BANG] = ACTIONS(4168),
    [anon_sym_function] = ACTIONS(4170),
    [anon_sym_LT_DASH] = ACTIONS(4170),
    [anon_sym_DOT_LBRACK] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4168),
    [anon_sym_use] = ACTIONS(4170),
    [anon_sym_use_BANG] = ACTIONS(4168),
    [anon_sym_do_BANG] = ACTIONS(4168),
    [anon_sym_begin] = ACTIONS(4170),
    [anon_sym_LPAREN2] = ACTIONS(4170),
    [anon_sym_default] = ACTIONS(4170),
    [anon_sym_or] = ACTIONS(4170),
    [anon_sym_static] = ACTIONS(4170),
    [anon_sym_member] = ACTIONS(4170),
    [anon_sym_interface] = ACTIONS(4170),
    [anon_sym_exception] = ACTIONS(4170),
    [anon_sym_abstract] = ACTIONS(4170),
    [anon_sym_val] = ACTIONS(4170),
    [anon_sym_override] = ACTIONS(4170),
    [aux_sym_char_token1] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4170),
    [anon_sym_DQUOTE] = ACTIONS(4170),
    [anon_sym_AT_DQUOTE] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [sym_bool] = ACTIONS(4170),
    [sym_unit] = ACTIONS(4168),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4170),
    [sym_op_identifier] = ACTIONS(4170),
    [anon_sym_PLUS] = ACTIONS(4170),
    [anon_sym_DASH] = ACTIONS(4170),
    [anon_sym_PLUS_DOT] = ACTIONS(4170),
    [anon_sym_DASH_DOT] = ACTIONS(4170),
    [anon_sym_PERCENT] = ACTIONS(4170),
    [anon_sym_AMP_AMP] = ACTIONS(4170),
    [anon_sym_TILDE] = ACTIONS(4168),
    [aux_sym_prefix_op_token1] = ACTIONS(4170),
    [aux_sym_infix_op_token1] = ACTIONS(4168),
    [aux_sym_infix_op_token2] = ACTIONS(4170),
    [anon_sym_PIPE_PIPE] = ACTIONS(4170),
    [anon_sym_BANG_EQ] = ACTIONS(4170),
    [anon_sym_COLON_EQ] = ACTIONS(4168),
    [anon_sym_DOLLAR] = ACTIONS(4170),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4170),
    [sym_int] = ACTIONS(4170),
    [sym_xint] = ACTIONS(4168),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4168),
    [anon_sym_POUNDload] = ACTIONS(4168),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4168),
    [sym__newline] = ACTIONS(4168),
  },
  [1439] = {
    [sym_block_comment] = STATE(1439),
    [sym_compiler_directive_decl] = STATE(1439),
    [sym_fsi_directive_decl] = STATE(1439),
    [sym_preproc_line] = STATE(1439),
    [ts_builtin_sym_end] = ACTIONS(4172),
    [sym_identifier] = ACTIONS(4174),
    [anon_sym_namespace] = ACTIONS(4174),
    [anon_sym_module] = ACTIONS(4174),
    [anon_sym_EQ] = ACTIONS(4172),
    [anon_sym_open] = ACTIONS(4174),
    [anon_sym_LBRACK_LT] = ACTIONS(4172),
    [anon_sym_COLON] = ACTIONS(4174),
    [anon_sym_return] = ACTIONS(4174),
    [anon_sym_type] = ACTIONS(4174),
    [anon_sym_do] = ACTIONS(4174),
    [anon_sym_and] = ACTIONS(4174),
    [anon_sym_let] = ACTIONS(4174),
    [anon_sym_let_BANG] = ACTIONS(4172),
    [aux_sym_access_modifier_token1] = ACTIONS(4172),
    [anon_sym_LPAREN] = ACTIONS(4174),
    [anon_sym_COMMA] = ACTIONS(4172),
    [anon_sym_null] = ACTIONS(4174),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_COLON] = ACTIONS(4172),
    [anon_sym_AMP] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4174),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4172),
    [anon_sym_LBRACE] = ACTIONS(4174),
    [anon_sym_LT_AT] = ACTIONS(4174),
    [anon_sym_LT_AT_AT] = ACTIONS(4174),
    [anon_sym_DOT] = ACTIONS(4174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4172),
    [anon_sym_new] = ACTIONS(4174),
    [anon_sym_with] = ACTIONS(4174),
    [anon_sym_return_BANG] = ACTIONS(4172),
    [anon_sym_yield] = ACTIONS(4174),
    [anon_sym_yield_BANG] = ACTIONS(4172),
    [anon_sym_lazy] = ACTIONS(4174),
    [anon_sym_assert] = ACTIONS(4174),
    [anon_sym_upcast] = ACTIONS(4174),
    [anon_sym_downcast] = ACTIONS(4174),
    [anon_sym_COLON_GT] = ACTIONS(4172),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4172),
    [anon_sym_for] = ACTIONS(4174),
    [anon_sym_while] = ACTIONS(4174),
    [anon_sym_if] = ACTIONS(4174),
    [anon_sym_fun] = ACTIONS(4174),
    [anon_sym_try] = ACTIONS(4174),
    [anon_sym_match] = ACTIONS(4174),
    [anon_sym_match_BANG] = ACTIONS(4172),
    [anon_sym_function] = ACTIONS(4174),
    [anon_sym_LT_DASH] = ACTIONS(4174),
    [anon_sym_DOT_LBRACK] = ACTIONS(4172),
    [anon_sym_LT] = ACTIONS(4172),
    [anon_sym_use] = ACTIONS(4174),
    [anon_sym_use_BANG] = ACTIONS(4172),
    [anon_sym_do_BANG] = ACTIONS(4172),
    [anon_sym_begin] = ACTIONS(4174),
    [anon_sym_LPAREN2] = ACTIONS(4174),
    [anon_sym_default] = ACTIONS(4174),
    [anon_sym_or] = ACTIONS(4174),
    [anon_sym_static] = ACTIONS(4174),
    [anon_sym_member] = ACTIONS(4174),
    [anon_sym_interface] = ACTIONS(4174),
    [anon_sym_exception] = ACTIONS(4174),
    [anon_sym_abstract] = ACTIONS(4174),
    [anon_sym_val] = ACTIONS(4174),
    [anon_sym_override] = ACTIONS(4174),
    [aux_sym_char_token1] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4174),
    [anon_sym_DQUOTE] = ACTIONS(4174),
    [anon_sym_AT_DQUOTE] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [sym_bool] = ACTIONS(4174),
    [sym_unit] = ACTIONS(4172),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4174),
    [sym_op_identifier] = ACTIONS(4174),
    [anon_sym_PLUS] = ACTIONS(4174),
    [anon_sym_DASH] = ACTIONS(4174),
    [anon_sym_PLUS_DOT] = ACTIONS(4174),
    [anon_sym_DASH_DOT] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [anon_sym_AMP_AMP] = ACTIONS(4174),
    [anon_sym_TILDE] = ACTIONS(4172),
    [aux_sym_prefix_op_token1] = ACTIONS(4174),
    [aux_sym_infix_op_token1] = ACTIONS(4172),
    [aux_sym_infix_op_token2] = ACTIONS(4174),
    [anon_sym_PIPE_PIPE] = ACTIONS(4174),
    [anon_sym_BANG_EQ] = ACTIONS(4174),
    [anon_sym_COLON_EQ] = ACTIONS(4172),
    [anon_sym_DOLLAR] = ACTIONS(4174),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4174),
    [sym_int] = ACTIONS(4174),
    [sym_xint] = ACTIONS(4172),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4172),
    [anon_sym_POUNDload] = ACTIONS(4172),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4172),
    [sym__newline] = ACTIONS(4172),
  },
  [1440] = {
    [sym_block_comment] = STATE(1440),
    [sym_compiler_directive_decl] = STATE(1440),
    [sym_fsi_directive_decl] = STATE(1440),
    [sym_preproc_line] = STATE(1440),
    [sym_identifier] = ACTIONS(3505),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_LBRACK_LT] = ACTIONS(3503),
    [anon_sym_COLON] = ACTIONS(3505),
    [anon_sym_return] = ACTIONS(3505),
    [anon_sym_do] = ACTIONS(3505),
    [anon_sym_and] = ACTIONS(3505),
    [anon_sym_let] = ACTIONS(3505),
    [anon_sym_let_BANG] = ACTIONS(3503),
    [aux_sym_access_modifier_token1] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3505),
    [anon_sym_COMMA] = ACTIONS(3503),
    [anon_sym_null] = ACTIONS(3505),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_COLON_QMARK] = ACTIONS(3505),
    [anon_sym_COLON_COLON] = ACTIONS(3503),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3503),
    [anon_sym_LBRACE] = ACTIONS(3505),
    [anon_sym_LT_AT] = ACTIONS(3505),
    [anon_sym_LT_AT_AT] = ACTIONS(3505),
    [anon_sym_DOT] = ACTIONS(3505),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3503),
    [anon_sym_new] = ACTIONS(3505),
    [anon_sym_with] = ACTIONS(3505),
    [anon_sym_return_BANG] = ACTIONS(3503),
    [anon_sym_yield] = ACTIONS(3505),
    [anon_sym_yield_BANG] = ACTIONS(3503),
    [anon_sym_lazy] = ACTIONS(3505),
    [anon_sym_assert] = ACTIONS(3505),
    [anon_sym_upcast] = ACTIONS(3505),
    [anon_sym_downcast] = ACTIONS(3505),
    [anon_sym_COLON_GT] = ACTIONS(3503),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3503),
    [anon_sym_for] = ACTIONS(3505),
    [anon_sym_while] = ACTIONS(3505),
    [anon_sym_if] = ACTIONS(3505),
    [anon_sym_fun] = ACTIONS(3505),
    [anon_sym_DASH_GT] = ACTIONS(3505),
    [anon_sym_try] = ACTIONS(3505),
    [anon_sym_match] = ACTIONS(3505),
    [anon_sym_match_BANG] = ACTIONS(3503),
    [anon_sym_function] = ACTIONS(3505),
    [anon_sym_LT_DASH] = ACTIONS(3505),
    [anon_sym_DOT_LBRACK] = ACTIONS(3503),
    [anon_sym_LT] = ACTIONS(3503),
    [anon_sym_use] = ACTIONS(3505),
    [anon_sym_use_BANG] = ACTIONS(3503),
    [anon_sym_do_BANG] = ACTIONS(3503),
    [anon_sym_begin] = ACTIONS(3505),
    [anon_sym_LPAREN2] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3505),
    [anon_sym_LT2] = ACTIONS(4176),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_default] = ACTIONS(3505),
    [anon_sym_or] = ACTIONS(3505),
    [anon_sym_static] = ACTIONS(3505),
    [anon_sym_member] = ACTIONS(3505),
    [anon_sym_interface] = ACTIONS(3505),
    [anon_sym_abstract] = ACTIONS(3505),
    [anon_sym_val] = ACTIONS(3505),
    [anon_sym_override] = ACTIONS(3505),
    [aux_sym_char_token1] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3505),
    [anon_sym_DQUOTE] = ACTIONS(3505),
    [anon_sym_AT_DQUOTE] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [sym_bool] = ACTIONS(3505),
    [sym_unit] = ACTIONS(3503),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3505),
    [sym_op_identifier] = ACTIONS(3505),
    [anon_sym_PLUS] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3505),
    [anon_sym_PLUS_DOT] = ACTIONS(3505),
    [anon_sym_DASH_DOT] = ACTIONS(3505),
    [anon_sym_PERCENT] = ACTIONS(3505),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3503),
    [aux_sym_prefix_op_token1] = ACTIONS(3505),
    [aux_sym_infix_op_token1] = ACTIONS(3503),
    [aux_sym_infix_op_token2] = ACTIONS(3505),
    [anon_sym_PIPE_PIPE] = ACTIONS(3505),
    [anon_sym_BANG_EQ] = ACTIONS(3505),
    [anon_sym_COLON_EQ] = ACTIONS(3503),
    [anon_sym_DOLLAR] = ACTIONS(3505),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3505),
    [sym_int] = ACTIONS(3505),
    [sym_xint] = ACTIONS(3503),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3503),
    [anon_sym_POUNDendif] = ACTIONS(3503),
    [anon_sym_POUNDelse] = ACTIONS(3503),
    [sym__newline] = ACTIONS(3503),
  },
  [1441] = {
    [sym_block_comment] = STATE(1441),
    [sym_compiler_directive_decl] = STATE(1441),
    [sym_fsi_directive_decl] = STATE(1441),
    [sym_preproc_line] = STATE(1441),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_LBRACK_LT] = ACTIONS(3513),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_and] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [aux_sym_access_modifier_token1] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_COLON] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_with] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(3513),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_LT_DASH] = ACTIONS(3515),
    [anon_sym_DOT_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3515),
    [anon_sym_or] = ACTIONS(3515),
    [anon_sym_static] = ACTIONS(3515),
    [anon_sym_member] = ACTIONS(3515),
    [anon_sym_interface] = ACTIONS(3515),
    [anon_sym_abstract] = ACTIONS(3515),
    [anon_sym_val] = ACTIONS(3515),
    [anon_sym_override] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3515),
    [anon_sym_DASH_DOT] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3515),
    [aux_sym_infix_op_token1] = ACTIONS(3513),
    [aux_sym_infix_op_token2] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3515),
    [anon_sym_COLON_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(3515),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3515),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [anon_sym_POUNDendif] = ACTIONS(3513),
    [anon_sym_POUNDelse] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
  },
  [1442] = {
    [sym_block_comment] = STATE(1442),
    [sym_compiler_directive_decl] = STATE(1442),
    [sym_fsi_directive_decl] = STATE(1442),
    [sym_preproc_line] = STATE(1442),
    [ts_builtin_sym_end] = ACTIONS(4178),
    [sym_identifier] = ACTIONS(4180),
    [anon_sym_namespace] = ACTIONS(4180),
    [anon_sym_module] = ACTIONS(4180),
    [anon_sym_EQ] = ACTIONS(4178),
    [anon_sym_open] = ACTIONS(4180),
    [anon_sym_LBRACK_LT] = ACTIONS(4178),
    [anon_sym_COLON] = ACTIONS(4180),
    [anon_sym_return] = ACTIONS(4180),
    [anon_sym_type] = ACTIONS(4180),
    [anon_sym_do] = ACTIONS(4180),
    [anon_sym_and] = ACTIONS(4180),
    [anon_sym_let] = ACTIONS(4180),
    [anon_sym_let_BANG] = ACTIONS(4178),
    [aux_sym_access_modifier_token1] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(4180),
    [anon_sym_COMMA] = ACTIONS(4178),
    [anon_sym_null] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_COLON] = ACTIONS(4178),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4180),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4180),
    [anon_sym_LT_AT] = ACTIONS(4180),
    [anon_sym_LT_AT_AT] = ACTIONS(4180),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4178),
    [anon_sym_new] = ACTIONS(4180),
    [anon_sym_with] = ACTIONS(4180),
    [anon_sym_return_BANG] = ACTIONS(4178),
    [anon_sym_yield] = ACTIONS(4180),
    [anon_sym_yield_BANG] = ACTIONS(4178),
    [anon_sym_lazy] = ACTIONS(4180),
    [anon_sym_assert] = ACTIONS(4180),
    [anon_sym_upcast] = ACTIONS(4180),
    [anon_sym_downcast] = ACTIONS(4180),
    [anon_sym_COLON_GT] = ACTIONS(4178),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4178),
    [anon_sym_for] = ACTIONS(4180),
    [anon_sym_while] = ACTIONS(4180),
    [anon_sym_if] = ACTIONS(4180),
    [anon_sym_fun] = ACTIONS(4180),
    [anon_sym_try] = ACTIONS(4180),
    [anon_sym_match] = ACTIONS(4180),
    [anon_sym_match_BANG] = ACTIONS(4178),
    [anon_sym_function] = ACTIONS(4180),
    [anon_sym_LT_DASH] = ACTIONS(4180),
    [anon_sym_DOT_LBRACK] = ACTIONS(4178),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_use] = ACTIONS(4180),
    [anon_sym_use_BANG] = ACTIONS(4178),
    [anon_sym_do_BANG] = ACTIONS(4178),
    [anon_sym_begin] = ACTIONS(4180),
    [anon_sym_LPAREN2] = ACTIONS(4180),
    [anon_sym_default] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [anon_sym_static] = ACTIONS(4180),
    [anon_sym_member] = ACTIONS(4180),
    [anon_sym_interface] = ACTIONS(4180),
    [anon_sym_exception] = ACTIONS(4180),
    [anon_sym_abstract] = ACTIONS(4180),
    [anon_sym_val] = ACTIONS(4180),
    [anon_sym_override] = ACTIONS(4180),
    [aux_sym_char_token1] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4180),
    [anon_sym_DQUOTE] = ACTIONS(4180),
    [anon_sym_AT_DQUOTE] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [sym_bool] = ACTIONS(4180),
    [sym_unit] = ACTIONS(4178),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4180),
    [sym_op_identifier] = ACTIONS(4180),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_PLUS_DOT] = ACTIONS(4180),
    [anon_sym_DASH_DOT] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_TILDE] = ACTIONS(4178),
    [aux_sym_prefix_op_token1] = ACTIONS(4180),
    [aux_sym_infix_op_token1] = ACTIONS(4178),
    [aux_sym_infix_op_token2] = ACTIONS(4180),
    [anon_sym_PIPE_PIPE] = ACTIONS(4180),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_COLON_EQ] = ACTIONS(4178),
    [anon_sym_DOLLAR] = ACTIONS(4180),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4180),
    [sym_int] = ACTIONS(4180),
    [sym_xint] = ACTIONS(4178),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4178),
    [anon_sym_POUNDload] = ACTIONS(4178),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4178),
    [sym__newline] = ACTIONS(4178),
  },
  [1443] = {
    [sym_block_comment] = STATE(1443),
    [sym_compiler_directive_decl] = STATE(1443),
    [sym_fsi_directive_decl] = STATE(1443),
    [sym_preproc_line] = STATE(1443),
    [ts_builtin_sym_end] = ACTIONS(3689),
    [sym_identifier] = ACTIONS(4182),
    [anon_sym_namespace] = ACTIONS(4182),
    [anon_sym_module] = ACTIONS(4182),
    [anon_sym_EQ] = ACTIONS(3689),
    [anon_sym_open] = ACTIONS(4182),
    [anon_sym_LBRACK_LT] = ACTIONS(3689),
    [anon_sym_COLON] = ACTIONS(4182),
    [anon_sym_return] = ACTIONS(4182),
    [anon_sym_type] = ACTIONS(4182),
    [anon_sym_do] = ACTIONS(4182),
    [anon_sym_and] = ACTIONS(4182),
    [anon_sym_let] = ACTIONS(4182),
    [anon_sym_let_BANG] = ACTIONS(3689),
    [aux_sym_access_modifier_token1] = ACTIONS(3689),
    [anon_sym_LPAREN] = ACTIONS(4182),
    [anon_sym_COMMA] = ACTIONS(3689),
    [anon_sym_null] = ACTIONS(4182),
    [anon_sym_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3689),
    [anon_sym_LBRACE] = ACTIONS(4182),
    [anon_sym_LT_AT] = ACTIONS(4182),
    [anon_sym_LT_AT_AT] = ACTIONS(4182),
    [anon_sym_DOT] = ACTIONS(4182),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3689),
    [anon_sym_new] = ACTIONS(4182),
    [anon_sym_with] = ACTIONS(4182),
    [anon_sym_return_BANG] = ACTIONS(3689),
    [anon_sym_yield] = ACTIONS(4182),
    [anon_sym_yield_BANG] = ACTIONS(3689),
    [anon_sym_lazy] = ACTIONS(4182),
    [anon_sym_assert] = ACTIONS(4182),
    [anon_sym_upcast] = ACTIONS(4182),
    [anon_sym_downcast] = ACTIONS(4182),
    [anon_sym_COLON_GT] = ACTIONS(3689),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3689),
    [anon_sym_for] = ACTIONS(4182),
    [anon_sym_while] = ACTIONS(4182),
    [anon_sym_if] = ACTIONS(4182),
    [anon_sym_fun] = ACTIONS(4182),
    [anon_sym_try] = ACTIONS(4182),
    [anon_sym_match] = ACTIONS(4182),
    [anon_sym_match_BANG] = ACTIONS(3689),
    [anon_sym_function] = ACTIONS(4182),
    [anon_sym_LT_DASH] = ACTIONS(4182),
    [anon_sym_DOT_LBRACK] = ACTIONS(3689),
    [anon_sym_LT] = ACTIONS(3689),
    [anon_sym_use] = ACTIONS(4182),
    [anon_sym_use_BANG] = ACTIONS(3689),
    [anon_sym_do_BANG] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(4182),
    [anon_sym_LPAREN2] = ACTIONS(4182),
    [anon_sym_default] = ACTIONS(4182),
    [anon_sym_or] = ACTIONS(4182),
    [anon_sym_static] = ACTIONS(4182),
    [anon_sym_member] = ACTIONS(4182),
    [anon_sym_interface] = ACTIONS(4182),
    [anon_sym_exception] = ACTIONS(4182),
    [anon_sym_abstract] = ACTIONS(4182),
    [anon_sym_val] = ACTIONS(4182),
    [anon_sym_override] = ACTIONS(4182),
    [aux_sym_char_token1] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4182),
    [anon_sym_DQUOTE] = ACTIONS(4182),
    [anon_sym_AT_DQUOTE] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [sym_bool] = ACTIONS(4182),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4182),
    [sym_op_identifier] = ACTIONS(4182),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_PLUS_DOT] = ACTIONS(4182),
    [anon_sym_DASH_DOT] = ACTIONS(4182),
    [anon_sym_PERCENT] = ACTIONS(4182),
    [anon_sym_AMP_AMP] = ACTIONS(4182),
    [anon_sym_TILDE] = ACTIONS(3689),
    [aux_sym_prefix_op_token1] = ACTIONS(4182),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token2] = ACTIONS(4182),
    [anon_sym_PIPE_PIPE] = ACTIONS(4182),
    [anon_sym_BANG_EQ] = ACTIONS(4182),
    [anon_sym_COLON_EQ] = ACTIONS(3689),
    [anon_sym_DOLLAR] = ACTIONS(4182),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4182),
    [sym_int] = ACTIONS(4182),
    [sym_xint] = ACTIONS(3689),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3689),
    [anon_sym_POUNDload] = ACTIONS(3689),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3689),
    [sym__newline] = ACTIONS(3689),
  },
  [1444] = {
    [sym_block_comment] = STATE(1444),
    [sym_compiler_directive_decl] = STATE(1444),
    [sym_fsi_directive_decl] = STATE(1444),
    [sym_preproc_line] = STATE(1444),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_LBRACK_LT] = ACTIONS(3513),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_and] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [aux_sym_access_modifier_token1] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_COLON] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_with] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(3513),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_LT_DASH] = ACTIONS(3515),
    [anon_sym_DOT_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3515),
    [anon_sym_or] = ACTIONS(3515),
    [anon_sym_static] = ACTIONS(3515),
    [anon_sym_member] = ACTIONS(3515),
    [anon_sym_interface] = ACTIONS(3515),
    [anon_sym_abstract] = ACTIONS(3515),
    [anon_sym_val] = ACTIONS(3515),
    [anon_sym_override] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3515),
    [anon_sym_DASH_DOT] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3515),
    [aux_sym_infix_op_token1] = ACTIONS(3513),
    [aux_sym_infix_op_token2] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3515),
    [anon_sym_COLON_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(3515),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3515),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [anon_sym_POUNDendif] = ACTIONS(3513),
    [anon_sym_POUNDelse] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
  },
  [1445] = {
    [sym_block_comment] = STATE(1445),
    [sym_compiler_directive_decl] = STATE(1445),
    [sym_fsi_directive_decl] = STATE(1445),
    [sym_preproc_line] = STATE(1445),
    [sym_identifier] = ACTIONS(3539),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_LBRACK_LT] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3539),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_do] = ACTIONS(3539),
    [anon_sym_and] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3539),
    [anon_sym_let_BANG] = ACTIONS(3537),
    [aux_sym_access_modifier_token1] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_null] = ACTIONS(3539),
    [anon_sym_QMARK] = ACTIONS(3539),
    [anon_sym_COLON_QMARK] = ACTIONS(3539),
    [anon_sym_COLON_COLON] = ACTIONS(3537),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3537),
    [anon_sym_LBRACE] = ACTIONS(3539),
    [anon_sym_LT_AT] = ACTIONS(3539),
    [anon_sym_LT_AT_AT] = ACTIONS(3539),
    [anon_sym_DOT] = ACTIONS(3539),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3537),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_with] = ACTIONS(3539),
    [anon_sym_return_BANG] = ACTIONS(3537),
    [anon_sym_yield] = ACTIONS(3539),
    [anon_sym_yield_BANG] = ACTIONS(3537),
    [anon_sym_lazy] = ACTIONS(3539),
    [anon_sym_assert] = ACTIONS(3539),
    [anon_sym_upcast] = ACTIONS(3539),
    [anon_sym_downcast] = ACTIONS(3539),
    [anon_sym_COLON_GT] = ACTIONS(3537),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3537),
    [anon_sym_for] = ACTIONS(3539),
    [anon_sym_while] = ACTIONS(3539),
    [anon_sym_if] = ACTIONS(3539),
    [anon_sym_fun] = ACTIONS(3539),
    [anon_sym_DASH_GT] = ACTIONS(3539),
    [anon_sym_try] = ACTIONS(3539),
    [anon_sym_match] = ACTIONS(3539),
    [anon_sym_match_BANG] = ACTIONS(3537),
    [anon_sym_function] = ACTIONS(3539),
    [anon_sym_LT_DASH] = ACTIONS(3539),
    [anon_sym_DOT_LBRACK] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_use] = ACTIONS(3539),
    [anon_sym_use_BANG] = ACTIONS(3537),
    [anon_sym_do_BANG] = ACTIONS(3537),
    [anon_sym_begin] = ACTIONS(3539),
    [anon_sym_LPAREN2] = ACTIONS(3539),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_LT2] = ACTIONS(3539),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_default] = ACTIONS(3539),
    [anon_sym_or] = ACTIONS(3539),
    [anon_sym_static] = ACTIONS(3539),
    [anon_sym_member] = ACTIONS(3539),
    [anon_sym_interface] = ACTIONS(3539),
    [anon_sym_abstract] = ACTIONS(3539),
    [anon_sym_val] = ACTIONS(3539),
    [anon_sym_override] = ACTIONS(3539),
    [aux_sym_char_token1] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3539),
    [anon_sym_DQUOTE] = ACTIONS(3539),
    [anon_sym_AT_DQUOTE] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [sym_bool] = ACTIONS(3539),
    [sym_unit] = ACTIONS(3537),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3539),
    [sym_op_identifier] = ACTIONS(3539),
    [anon_sym_PLUS] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(3539),
    [anon_sym_PLUS_DOT] = ACTIONS(3539),
    [anon_sym_DASH_DOT] = ACTIONS(3539),
    [anon_sym_PERCENT] = ACTIONS(3539),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_TILDE] = ACTIONS(3537),
    [aux_sym_prefix_op_token1] = ACTIONS(3539),
    [aux_sym_infix_op_token1] = ACTIONS(3537),
    [aux_sym_infix_op_token2] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3539),
    [anon_sym_BANG_EQ] = ACTIONS(3539),
    [anon_sym_COLON_EQ] = ACTIONS(3537),
    [anon_sym_DOLLAR] = ACTIONS(3539),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3539),
    [sym_int] = ACTIONS(3539),
    [sym_xint] = ACTIONS(3537),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3537),
    [anon_sym_POUNDendif] = ACTIONS(3537),
    [anon_sym_POUNDelse] = ACTIONS(3537),
    [sym__newline] = ACTIONS(3537),
  },
  [1446] = {
    [sym_block_comment] = STATE(1446),
    [sym_compiler_directive_decl] = STATE(1446),
    [sym_fsi_directive_decl] = STATE(1446),
    [sym_preproc_line] = STATE(1446),
    [sym_identifier] = ACTIONS(3543),
    [anon_sym_EQ] = ACTIONS(3541),
    [anon_sym_LBRACK_LT] = ACTIONS(3541),
    [anon_sym_COLON] = ACTIONS(3543),
    [anon_sym_return] = ACTIONS(3543),
    [anon_sym_do] = ACTIONS(3543),
    [anon_sym_and] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3543),
    [anon_sym_let_BANG] = ACTIONS(3541),
    [aux_sym_access_modifier_token1] = ACTIONS(3541),
    [anon_sym_LPAREN] = ACTIONS(3543),
    [anon_sym_COMMA] = ACTIONS(3541),
    [anon_sym_null] = ACTIONS(3543),
    [anon_sym_QMARK] = ACTIONS(3543),
    [anon_sym_COLON_QMARK] = ACTIONS(3543),
    [anon_sym_COLON_COLON] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3543),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3541),
    [anon_sym_LBRACE] = ACTIONS(3543),
    [anon_sym_LT_AT] = ACTIONS(3543),
    [anon_sym_LT_AT_AT] = ACTIONS(3543),
    [anon_sym_DOT] = ACTIONS(3543),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3541),
    [anon_sym_new] = ACTIONS(3543),
    [anon_sym_with] = ACTIONS(3543),
    [anon_sym_return_BANG] = ACTIONS(3541),
    [anon_sym_yield] = ACTIONS(3543),
    [anon_sym_yield_BANG] = ACTIONS(3541),
    [anon_sym_lazy] = ACTIONS(3543),
    [anon_sym_assert] = ACTIONS(3543),
    [anon_sym_upcast] = ACTIONS(3543),
    [anon_sym_downcast] = ACTIONS(3543),
    [anon_sym_COLON_GT] = ACTIONS(3541),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3541),
    [anon_sym_for] = ACTIONS(3543),
    [anon_sym_while] = ACTIONS(3543),
    [anon_sym_if] = ACTIONS(3543),
    [anon_sym_fun] = ACTIONS(3543),
    [anon_sym_DASH_GT] = ACTIONS(3543),
    [anon_sym_try] = ACTIONS(3543),
    [anon_sym_match] = ACTIONS(3543),
    [anon_sym_match_BANG] = ACTIONS(3541),
    [anon_sym_function] = ACTIONS(3543),
    [anon_sym_LT_DASH] = ACTIONS(3543),
    [anon_sym_DOT_LBRACK] = ACTIONS(3541),
    [anon_sym_LT] = ACTIONS(3541),
    [anon_sym_use] = ACTIONS(3543),
    [anon_sym_use_BANG] = ACTIONS(3541),
    [anon_sym_do_BANG] = ACTIONS(3541),
    [anon_sym_begin] = ACTIONS(3543),
    [anon_sym_LPAREN2] = ACTIONS(3543),
    [anon_sym_STAR] = ACTIONS(3543),
    [anon_sym_LT2] = ACTIONS(3543),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_default] = ACTIONS(3543),
    [anon_sym_or] = ACTIONS(3543),
    [anon_sym_static] = ACTIONS(3543),
    [anon_sym_member] = ACTIONS(3543),
    [anon_sym_interface] = ACTIONS(3543),
    [anon_sym_abstract] = ACTIONS(3543),
    [anon_sym_val] = ACTIONS(3543),
    [anon_sym_override] = ACTIONS(3543),
    [aux_sym_char_token1] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3543),
    [anon_sym_DQUOTE] = ACTIONS(3543),
    [anon_sym_AT_DQUOTE] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [sym_bool] = ACTIONS(3543),
    [sym_unit] = ACTIONS(3541),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3543),
    [sym_op_identifier] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(3543),
    [anon_sym_DASH] = ACTIONS(3543),
    [anon_sym_PLUS_DOT] = ACTIONS(3543),
    [anon_sym_DASH_DOT] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3543),
    [anon_sym_AMP_AMP] = ACTIONS(3543),
    [anon_sym_TILDE] = ACTIONS(3541),
    [aux_sym_prefix_op_token1] = ACTIONS(3543),
    [aux_sym_infix_op_token1] = ACTIONS(3541),
    [aux_sym_infix_op_token2] = ACTIONS(3543),
    [anon_sym_PIPE_PIPE] = ACTIONS(3543),
    [anon_sym_BANG_EQ] = ACTIONS(3543),
    [anon_sym_COLON_EQ] = ACTIONS(3541),
    [anon_sym_DOLLAR] = ACTIONS(3543),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3543),
    [sym_int] = ACTIONS(3543),
    [sym_xint] = ACTIONS(3541),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3541),
    [anon_sym_POUNDendif] = ACTIONS(3541),
    [anon_sym_POUNDelse] = ACTIONS(3541),
    [sym__newline] = ACTIONS(3541),
  },
  [1447] = {
    [sym_block_comment] = STATE(1447),
    [sym_compiler_directive_decl] = STATE(1447),
    [sym_fsi_directive_decl] = STATE(1447),
    [sym_preproc_line] = STATE(1447),
    [ts_builtin_sym_end] = ACTIONS(4184),
    [sym_identifier] = ACTIONS(4186),
    [anon_sym_namespace] = ACTIONS(4186),
    [anon_sym_module] = ACTIONS(4186),
    [anon_sym_EQ] = ACTIONS(4184),
    [anon_sym_open] = ACTIONS(4186),
    [anon_sym_LBRACK_LT] = ACTIONS(4184),
    [anon_sym_COLON] = ACTIONS(4186),
    [anon_sym_return] = ACTIONS(4186),
    [anon_sym_type] = ACTIONS(4186),
    [anon_sym_do] = ACTIONS(4186),
    [anon_sym_and] = ACTIONS(4186),
    [anon_sym_let] = ACTIONS(4186),
    [anon_sym_let_BANG] = ACTIONS(4184),
    [aux_sym_access_modifier_token1] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_COMMA] = ACTIONS(4184),
    [anon_sym_null] = ACTIONS(4186),
    [anon_sym_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_COLON] = ACTIONS(4184),
    [anon_sym_AMP] = ACTIONS(4186),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4184),
    [anon_sym_LBRACE] = ACTIONS(4186),
    [anon_sym_LT_AT] = ACTIONS(4186),
    [anon_sym_LT_AT_AT] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4186),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4184),
    [anon_sym_new] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4186),
    [anon_sym_return_BANG] = ACTIONS(4184),
    [anon_sym_yield] = ACTIONS(4186),
    [anon_sym_yield_BANG] = ACTIONS(4184),
    [anon_sym_lazy] = ACTIONS(4186),
    [anon_sym_assert] = ACTIONS(4186),
    [anon_sym_upcast] = ACTIONS(4186),
    [anon_sym_downcast] = ACTIONS(4186),
    [anon_sym_COLON_GT] = ACTIONS(4184),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4184),
    [anon_sym_for] = ACTIONS(4186),
    [anon_sym_while] = ACTIONS(4186),
    [anon_sym_if] = ACTIONS(4186),
    [anon_sym_fun] = ACTIONS(4186),
    [anon_sym_try] = ACTIONS(4186),
    [anon_sym_match] = ACTIONS(4186),
    [anon_sym_match_BANG] = ACTIONS(4184),
    [anon_sym_function] = ACTIONS(4186),
    [anon_sym_LT_DASH] = ACTIONS(4186),
    [anon_sym_DOT_LBRACK] = ACTIONS(4184),
    [anon_sym_LT] = ACTIONS(4184),
    [anon_sym_use] = ACTIONS(4186),
    [anon_sym_use_BANG] = ACTIONS(4184),
    [anon_sym_do_BANG] = ACTIONS(4184),
    [anon_sym_begin] = ACTIONS(4186),
    [anon_sym_LPAREN2] = ACTIONS(4186),
    [anon_sym_default] = ACTIONS(4186),
    [anon_sym_or] = ACTIONS(4186),
    [anon_sym_static] = ACTIONS(4186),
    [anon_sym_member] = ACTIONS(4186),
    [anon_sym_interface] = ACTIONS(4186),
    [anon_sym_exception] = ACTIONS(4186),
    [anon_sym_abstract] = ACTIONS(4186),
    [anon_sym_val] = ACTIONS(4186),
    [anon_sym_override] = ACTIONS(4186),
    [aux_sym_char_token1] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4186),
    [anon_sym_DQUOTE] = ACTIONS(4186),
    [anon_sym_AT_DQUOTE] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [sym_bool] = ACTIONS(4186),
    [sym_unit] = ACTIONS(4184),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4186),
    [sym_op_identifier] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4186),
    [anon_sym_DASH] = ACTIONS(4186),
    [anon_sym_PLUS_DOT] = ACTIONS(4186),
    [anon_sym_DASH_DOT] = ACTIONS(4186),
    [anon_sym_PERCENT] = ACTIONS(4186),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_TILDE] = ACTIONS(4184),
    [aux_sym_prefix_op_token1] = ACTIONS(4186),
    [aux_sym_infix_op_token1] = ACTIONS(4184),
    [aux_sym_infix_op_token2] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_COLON_EQ] = ACTIONS(4184),
    [anon_sym_DOLLAR] = ACTIONS(4186),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4186),
    [sym_int] = ACTIONS(4186),
    [sym_xint] = ACTIONS(4184),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4184),
    [anon_sym_POUNDload] = ACTIONS(4184),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4184),
    [sym__newline] = ACTIONS(4184),
  },
  [1448] = {
    [sym_block_comment] = STATE(1448),
    [sym_compiler_directive_decl] = STATE(1448),
    [sym_fsi_directive_decl] = STATE(1448),
    [sym_preproc_line] = STATE(1448),
    [sym_identifier] = ACTIONS(3547),
    [anon_sym_EQ] = ACTIONS(3545),
    [anon_sym_LBRACK_LT] = ACTIONS(3545),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_return] = ACTIONS(3547),
    [anon_sym_do] = ACTIONS(3547),
    [anon_sym_and] = ACTIONS(3547),
    [anon_sym_let] = ACTIONS(3547),
    [anon_sym_let_BANG] = ACTIONS(3545),
    [aux_sym_access_modifier_token1] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(3547),
    [anon_sym_COMMA] = ACTIONS(3545),
    [anon_sym_null] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3547),
    [anon_sym_COLON_QMARK] = ACTIONS(3547),
    [anon_sym_COLON_COLON] = ACTIONS(3545),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3545),
    [anon_sym_LBRACE] = ACTIONS(3547),
    [anon_sym_LT_AT] = ACTIONS(3547),
    [anon_sym_LT_AT_AT] = ACTIONS(3547),
    [anon_sym_DOT] = ACTIONS(3547),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3545),
    [anon_sym_new] = ACTIONS(3547),
    [anon_sym_with] = ACTIONS(3547),
    [anon_sym_return_BANG] = ACTIONS(3545),
    [anon_sym_yield] = ACTIONS(3547),
    [anon_sym_yield_BANG] = ACTIONS(3545),
    [anon_sym_lazy] = ACTIONS(3547),
    [anon_sym_assert] = ACTIONS(3547),
    [anon_sym_upcast] = ACTIONS(3547),
    [anon_sym_downcast] = ACTIONS(3547),
    [anon_sym_COLON_GT] = ACTIONS(3545),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3545),
    [anon_sym_for] = ACTIONS(3547),
    [anon_sym_while] = ACTIONS(3547),
    [anon_sym_if] = ACTIONS(3547),
    [anon_sym_fun] = ACTIONS(3547),
    [anon_sym_DASH_GT] = ACTIONS(3547),
    [anon_sym_try] = ACTIONS(3547),
    [anon_sym_match] = ACTIONS(3547),
    [anon_sym_match_BANG] = ACTIONS(3545),
    [anon_sym_function] = ACTIONS(3547),
    [anon_sym_LT_DASH] = ACTIONS(3547),
    [anon_sym_DOT_LBRACK] = ACTIONS(3545),
    [anon_sym_LT] = ACTIONS(3545),
    [anon_sym_use] = ACTIONS(3547),
    [anon_sym_use_BANG] = ACTIONS(3545),
    [anon_sym_do_BANG] = ACTIONS(3545),
    [anon_sym_begin] = ACTIONS(3547),
    [anon_sym_LPAREN2] = ACTIONS(3547),
    [anon_sym_STAR] = ACTIONS(3547),
    [anon_sym_LT2] = ACTIONS(3547),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_default] = ACTIONS(3547),
    [anon_sym_or] = ACTIONS(3547),
    [anon_sym_static] = ACTIONS(3547),
    [anon_sym_member] = ACTIONS(3547),
    [anon_sym_interface] = ACTIONS(3547),
    [anon_sym_abstract] = ACTIONS(3547),
    [anon_sym_val] = ACTIONS(3547),
    [anon_sym_override] = ACTIONS(3547),
    [aux_sym_char_token1] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3547),
    [anon_sym_DQUOTE] = ACTIONS(3547),
    [anon_sym_AT_DQUOTE] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [sym_bool] = ACTIONS(3547),
    [sym_unit] = ACTIONS(3545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3547),
    [sym_op_identifier] = ACTIONS(3547),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PLUS_DOT] = ACTIONS(3547),
    [anon_sym_DASH_DOT] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3547),
    [anon_sym_AMP_AMP] = ACTIONS(3547),
    [anon_sym_TILDE] = ACTIONS(3545),
    [aux_sym_prefix_op_token1] = ACTIONS(3547),
    [aux_sym_infix_op_token1] = ACTIONS(3545),
    [aux_sym_infix_op_token2] = ACTIONS(3547),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_BANG_EQ] = ACTIONS(3547),
    [anon_sym_COLON_EQ] = ACTIONS(3545),
    [anon_sym_DOLLAR] = ACTIONS(3547),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3547),
    [sym_int] = ACTIONS(3547),
    [sym_xint] = ACTIONS(3545),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3545),
    [anon_sym_POUNDendif] = ACTIONS(3545),
    [anon_sym_POUNDelse] = ACTIONS(3545),
    [sym__newline] = ACTIONS(3545),
  },
  [1449] = {
    [sym_block_comment] = STATE(1449),
    [sym_compiler_directive_decl] = STATE(1449),
    [sym_fsi_directive_decl] = STATE(1449),
    [sym_preproc_line] = STATE(1449),
    [aux_sym_type_argument_repeat1] = STATE(1377),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_LBRACK_LT] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_and] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [aux_sym_access_modifier_token1] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_with] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [anon_sym_DOT_LBRACK] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_default] = ACTIONS(3498),
    [anon_sym_or] = ACTIONS(4188),
    [anon_sym_static] = ACTIONS(3498),
    [anon_sym_member] = ACTIONS(3498),
    [anon_sym_interface] = ACTIONS(3498),
    [anon_sym_abstract] = ACTIONS(3498),
    [anon_sym_val] = ACTIONS(3498),
    [anon_sym_override] = ACTIONS(3498),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3498),
    [anon_sym_DASH_DOT] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3498),
    [aux_sym_infix_op_token1] = ACTIONS(3496),
    [aux_sym_infix_op_token2] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_COLON_EQ] = ACTIONS(3496),
    [anon_sym_DOLLAR] = ACTIONS(3498),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3498),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
    [sym__dedent] = ACTIONS(3496),
  },
  [1450] = {
    [sym_block_comment] = STATE(1450),
    [sym_compiler_directive_decl] = STATE(1450),
    [sym_fsi_directive_decl] = STATE(1450),
    [sym_preproc_line] = STATE(1450),
    [ts_builtin_sym_end] = ACTIONS(4191),
    [sym_identifier] = ACTIONS(4193),
    [anon_sym_namespace] = ACTIONS(4193),
    [anon_sym_module] = ACTIONS(4193),
    [anon_sym_EQ] = ACTIONS(4191),
    [anon_sym_open] = ACTIONS(4193),
    [anon_sym_LBRACK_LT] = ACTIONS(4191),
    [anon_sym_COLON] = ACTIONS(4193),
    [anon_sym_return] = ACTIONS(4193),
    [anon_sym_type] = ACTIONS(4193),
    [anon_sym_do] = ACTIONS(4193),
    [anon_sym_and] = ACTIONS(4193),
    [anon_sym_let] = ACTIONS(4193),
    [anon_sym_let_BANG] = ACTIONS(4191),
    [aux_sym_access_modifier_token1] = ACTIONS(4191),
    [anon_sym_LPAREN] = ACTIONS(4193),
    [anon_sym_COMMA] = ACTIONS(4191),
    [anon_sym_null] = ACTIONS(4193),
    [anon_sym_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_COLON] = ACTIONS(4191),
    [anon_sym_AMP] = ACTIONS(4193),
    [anon_sym_LBRACK] = ACTIONS(4193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4191),
    [anon_sym_LBRACE] = ACTIONS(4193),
    [anon_sym_LT_AT] = ACTIONS(4193),
    [anon_sym_LT_AT_AT] = ACTIONS(4193),
    [anon_sym_DOT] = ACTIONS(4193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4191),
    [anon_sym_new] = ACTIONS(4193),
    [anon_sym_with] = ACTIONS(4193),
    [anon_sym_return_BANG] = ACTIONS(4191),
    [anon_sym_yield] = ACTIONS(4193),
    [anon_sym_yield_BANG] = ACTIONS(4191),
    [anon_sym_lazy] = ACTIONS(4193),
    [anon_sym_assert] = ACTIONS(4193),
    [anon_sym_upcast] = ACTIONS(4193),
    [anon_sym_downcast] = ACTIONS(4193),
    [anon_sym_COLON_GT] = ACTIONS(4191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4191),
    [anon_sym_for] = ACTIONS(4193),
    [anon_sym_while] = ACTIONS(4193),
    [anon_sym_if] = ACTIONS(4193),
    [anon_sym_fun] = ACTIONS(4193),
    [anon_sym_try] = ACTIONS(4193),
    [anon_sym_match] = ACTIONS(4193),
    [anon_sym_match_BANG] = ACTIONS(4191),
    [anon_sym_function] = ACTIONS(4193),
    [anon_sym_LT_DASH] = ACTIONS(4193),
    [anon_sym_DOT_LBRACK] = ACTIONS(4191),
    [anon_sym_LT] = ACTIONS(4191),
    [anon_sym_use] = ACTIONS(4193),
    [anon_sym_use_BANG] = ACTIONS(4191),
    [anon_sym_do_BANG] = ACTIONS(4191),
    [anon_sym_begin] = ACTIONS(4193),
    [anon_sym_LPAREN2] = ACTIONS(4193),
    [anon_sym_default] = ACTIONS(4193),
    [anon_sym_or] = ACTIONS(4193),
    [anon_sym_static] = ACTIONS(4193),
    [anon_sym_member] = ACTIONS(4193),
    [anon_sym_interface] = ACTIONS(4193),
    [anon_sym_exception] = ACTIONS(4193),
    [anon_sym_abstract] = ACTIONS(4193),
    [anon_sym_val] = ACTIONS(4193),
    [anon_sym_override] = ACTIONS(4193),
    [aux_sym_char_token1] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4193),
    [anon_sym_DQUOTE] = ACTIONS(4193),
    [anon_sym_AT_DQUOTE] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [sym_bool] = ACTIONS(4193),
    [sym_unit] = ACTIONS(4191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4193),
    [sym_op_identifier] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4193),
    [anon_sym_DASH] = ACTIONS(4193),
    [anon_sym_PLUS_DOT] = ACTIONS(4193),
    [anon_sym_DASH_DOT] = ACTIONS(4193),
    [anon_sym_PERCENT] = ACTIONS(4193),
    [anon_sym_AMP_AMP] = ACTIONS(4193),
    [anon_sym_TILDE] = ACTIONS(4191),
    [aux_sym_prefix_op_token1] = ACTIONS(4193),
    [aux_sym_infix_op_token1] = ACTIONS(4191),
    [aux_sym_infix_op_token2] = ACTIONS(4193),
    [anon_sym_PIPE_PIPE] = ACTIONS(4193),
    [anon_sym_BANG_EQ] = ACTIONS(4193),
    [anon_sym_COLON_EQ] = ACTIONS(4191),
    [anon_sym_DOLLAR] = ACTIONS(4193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4193),
    [sym_int] = ACTIONS(4193),
    [sym_xint] = ACTIONS(4191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4191),
    [anon_sym_POUNDload] = ACTIONS(4191),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4191),
    [sym__newline] = ACTIONS(4191),
  },
  [1451] = {
    [sym_block_comment] = STATE(1451),
    [sym_compiler_directive_decl] = STATE(1451),
    [sym_fsi_directive_decl] = STATE(1451),
    [sym_preproc_line] = STATE(1451),
    [ts_builtin_sym_end] = ACTIONS(4195),
    [sym_identifier] = ACTIONS(4197),
    [anon_sym_namespace] = ACTIONS(4197),
    [anon_sym_module] = ACTIONS(4197),
    [anon_sym_EQ] = ACTIONS(4195),
    [anon_sym_open] = ACTIONS(4197),
    [anon_sym_LBRACK_LT] = ACTIONS(4195),
    [anon_sym_COLON] = ACTIONS(4197),
    [anon_sym_return] = ACTIONS(4197),
    [anon_sym_type] = ACTIONS(4197),
    [anon_sym_do] = ACTIONS(4197),
    [anon_sym_and] = ACTIONS(4197),
    [anon_sym_let] = ACTIONS(4197),
    [anon_sym_let_BANG] = ACTIONS(4195),
    [aux_sym_access_modifier_token1] = ACTIONS(4195),
    [anon_sym_LPAREN] = ACTIONS(4197),
    [anon_sym_COMMA] = ACTIONS(4195),
    [anon_sym_null] = ACTIONS(4197),
    [anon_sym_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_COLON] = ACTIONS(4195),
    [anon_sym_AMP] = ACTIONS(4197),
    [anon_sym_LBRACK] = ACTIONS(4197),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4195),
    [anon_sym_LBRACE] = ACTIONS(4197),
    [anon_sym_LT_AT] = ACTIONS(4197),
    [anon_sym_LT_AT_AT] = ACTIONS(4197),
    [anon_sym_DOT] = ACTIONS(4197),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4195),
    [anon_sym_new] = ACTIONS(4197),
    [anon_sym_with] = ACTIONS(4197),
    [anon_sym_return_BANG] = ACTIONS(4195),
    [anon_sym_yield] = ACTIONS(4197),
    [anon_sym_yield_BANG] = ACTIONS(4195),
    [anon_sym_lazy] = ACTIONS(4197),
    [anon_sym_assert] = ACTIONS(4197),
    [anon_sym_upcast] = ACTIONS(4197),
    [anon_sym_downcast] = ACTIONS(4197),
    [anon_sym_COLON_GT] = ACTIONS(4195),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4195),
    [anon_sym_for] = ACTIONS(4197),
    [anon_sym_while] = ACTIONS(4197),
    [anon_sym_if] = ACTIONS(4197),
    [anon_sym_fun] = ACTIONS(4197),
    [anon_sym_try] = ACTIONS(4197),
    [anon_sym_match] = ACTIONS(4197),
    [anon_sym_match_BANG] = ACTIONS(4195),
    [anon_sym_function] = ACTIONS(4197),
    [anon_sym_LT_DASH] = ACTIONS(4197),
    [anon_sym_DOT_LBRACK] = ACTIONS(4195),
    [anon_sym_LT] = ACTIONS(4195),
    [anon_sym_use] = ACTIONS(4197),
    [anon_sym_use_BANG] = ACTIONS(4195),
    [anon_sym_do_BANG] = ACTIONS(4195),
    [anon_sym_begin] = ACTIONS(4197),
    [anon_sym_LPAREN2] = ACTIONS(4197),
    [anon_sym_default] = ACTIONS(4197),
    [anon_sym_or] = ACTIONS(4197),
    [anon_sym_static] = ACTIONS(4197),
    [anon_sym_member] = ACTIONS(4197),
    [anon_sym_interface] = ACTIONS(4197),
    [anon_sym_exception] = ACTIONS(4197),
    [anon_sym_abstract] = ACTIONS(4197),
    [anon_sym_val] = ACTIONS(4197),
    [anon_sym_override] = ACTIONS(4197),
    [aux_sym_char_token1] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4197),
    [anon_sym_DQUOTE] = ACTIONS(4197),
    [anon_sym_AT_DQUOTE] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [sym_bool] = ACTIONS(4197),
    [sym_unit] = ACTIONS(4195),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4197),
    [sym_op_identifier] = ACTIONS(4197),
    [anon_sym_PLUS] = ACTIONS(4197),
    [anon_sym_DASH] = ACTIONS(4197),
    [anon_sym_PLUS_DOT] = ACTIONS(4197),
    [anon_sym_DASH_DOT] = ACTIONS(4197),
    [anon_sym_PERCENT] = ACTIONS(4197),
    [anon_sym_AMP_AMP] = ACTIONS(4197),
    [anon_sym_TILDE] = ACTIONS(4195),
    [aux_sym_prefix_op_token1] = ACTIONS(4197),
    [aux_sym_infix_op_token1] = ACTIONS(4195),
    [aux_sym_infix_op_token2] = ACTIONS(4197),
    [anon_sym_PIPE_PIPE] = ACTIONS(4197),
    [anon_sym_BANG_EQ] = ACTIONS(4197),
    [anon_sym_COLON_EQ] = ACTIONS(4195),
    [anon_sym_DOLLAR] = ACTIONS(4197),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4197),
    [sym_int] = ACTIONS(4197),
    [sym_xint] = ACTIONS(4195),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4195),
    [anon_sym_POUNDload] = ACTIONS(4195),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4195),
    [sym__newline] = ACTIONS(4195),
  },
  [1452] = {
    [sym_block_comment] = STATE(1452),
    [sym_compiler_directive_decl] = STATE(1452),
    [sym_fsi_directive_decl] = STATE(1452),
    [sym_preproc_line] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(4199),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_namespace] = ACTIONS(4201),
    [anon_sym_module] = ACTIONS(4201),
    [anon_sym_EQ] = ACTIONS(4199),
    [anon_sym_open] = ACTIONS(4201),
    [anon_sym_LBRACK_LT] = ACTIONS(4199),
    [anon_sym_COLON] = ACTIONS(4201),
    [anon_sym_return] = ACTIONS(4201),
    [anon_sym_type] = ACTIONS(4201),
    [anon_sym_do] = ACTIONS(4201),
    [anon_sym_and] = ACTIONS(4201),
    [anon_sym_let] = ACTIONS(4201),
    [anon_sym_let_BANG] = ACTIONS(4199),
    [aux_sym_access_modifier_token1] = ACTIONS(4199),
    [anon_sym_LPAREN] = ACTIONS(4201),
    [anon_sym_COMMA] = ACTIONS(4199),
    [anon_sym_null] = ACTIONS(4201),
    [anon_sym_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(4199),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_LBRACK] = ACTIONS(4201),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4199),
    [anon_sym_LBRACE] = ACTIONS(4201),
    [anon_sym_LT_AT] = ACTIONS(4201),
    [anon_sym_LT_AT_AT] = ACTIONS(4201),
    [anon_sym_DOT] = ACTIONS(4201),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4199),
    [anon_sym_new] = ACTIONS(4201),
    [anon_sym_with] = ACTIONS(4201),
    [anon_sym_return_BANG] = ACTIONS(4199),
    [anon_sym_yield] = ACTIONS(4201),
    [anon_sym_yield_BANG] = ACTIONS(4199),
    [anon_sym_lazy] = ACTIONS(4201),
    [anon_sym_assert] = ACTIONS(4201),
    [anon_sym_upcast] = ACTIONS(4201),
    [anon_sym_downcast] = ACTIONS(4201),
    [anon_sym_COLON_GT] = ACTIONS(4199),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4199),
    [anon_sym_for] = ACTIONS(4201),
    [anon_sym_while] = ACTIONS(4201),
    [anon_sym_if] = ACTIONS(4201),
    [anon_sym_fun] = ACTIONS(4201),
    [anon_sym_try] = ACTIONS(4201),
    [anon_sym_match] = ACTIONS(4201),
    [anon_sym_match_BANG] = ACTIONS(4199),
    [anon_sym_function] = ACTIONS(4201),
    [anon_sym_LT_DASH] = ACTIONS(4201),
    [anon_sym_DOT_LBRACK] = ACTIONS(4199),
    [anon_sym_LT] = ACTIONS(4199),
    [anon_sym_use] = ACTIONS(4201),
    [anon_sym_use_BANG] = ACTIONS(4199),
    [anon_sym_do_BANG] = ACTIONS(4199),
    [anon_sym_begin] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(4201),
    [anon_sym_default] = ACTIONS(4201),
    [anon_sym_or] = ACTIONS(4201),
    [anon_sym_static] = ACTIONS(4201),
    [anon_sym_member] = ACTIONS(4201),
    [anon_sym_interface] = ACTIONS(4201),
    [anon_sym_exception] = ACTIONS(4201),
    [anon_sym_abstract] = ACTIONS(4201),
    [anon_sym_val] = ACTIONS(4201),
    [anon_sym_override] = ACTIONS(4201),
    [aux_sym_char_token1] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4201),
    [anon_sym_DQUOTE] = ACTIONS(4201),
    [anon_sym_AT_DQUOTE] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [sym_bool] = ACTIONS(4201),
    [sym_unit] = ACTIONS(4199),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4201),
    [sym_op_identifier] = ACTIONS(4201),
    [anon_sym_PLUS] = ACTIONS(4201),
    [anon_sym_DASH] = ACTIONS(4201),
    [anon_sym_PLUS_DOT] = ACTIONS(4201),
    [anon_sym_DASH_DOT] = ACTIONS(4201),
    [anon_sym_PERCENT] = ACTIONS(4201),
    [anon_sym_AMP_AMP] = ACTIONS(4201),
    [anon_sym_TILDE] = ACTIONS(4199),
    [aux_sym_prefix_op_token1] = ACTIONS(4201),
    [aux_sym_infix_op_token1] = ACTIONS(4199),
    [aux_sym_infix_op_token2] = ACTIONS(4201),
    [anon_sym_PIPE_PIPE] = ACTIONS(4201),
    [anon_sym_BANG_EQ] = ACTIONS(4201),
    [anon_sym_COLON_EQ] = ACTIONS(4199),
    [anon_sym_DOLLAR] = ACTIONS(4201),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4201),
    [sym_int] = ACTIONS(4201),
    [sym_xint] = ACTIONS(4199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4199),
    [anon_sym_POUNDload] = ACTIONS(4199),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4199),
    [sym__newline] = ACTIONS(4199),
  },
  [1453] = {
    [sym_block_comment] = STATE(1453),
    [sym_compiler_directive_decl] = STATE(1453),
    [sym_fsi_directive_decl] = STATE(1453),
    [sym_preproc_line] = STATE(1453),
    [aux_sym_type_argument_repeat1] = STATE(1453),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_LBRACK_LT] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_and] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [aux_sym_access_modifier_token1] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_COLON] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_with] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_LT_DASH] = ACTIONS(3480),
    [anon_sym_DOT_LBRACK] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_default] = ACTIONS(3480),
    [anon_sym_or] = ACTIONS(4203),
    [anon_sym_static] = ACTIONS(3480),
    [anon_sym_member] = ACTIONS(3480),
    [anon_sym_interface] = ACTIONS(3480),
    [anon_sym_abstract] = ACTIONS(3480),
    [anon_sym_val] = ACTIONS(3480),
    [anon_sym_override] = ACTIONS(3480),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3480),
    [anon_sym_DASH_DOT] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3480),
    [aux_sym_infix_op_token1] = ACTIONS(3478),
    [aux_sym_infix_op_token2] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3480),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [anon_sym_POUNDendif] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
  },
  [1454] = {
    [sym_block_comment] = STATE(1454),
    [sym_compiler_directive_decl] = STATE(1454),
    [sym_fsi_directive_decl] = STATE(1454),
    [sym_preproc_line] = STATE(1454),
    [ts_builtin_sym_end] = ACTIONS(4206),
    [sym_identifier] = ACTIONS(4208),
    [anon_sym_namespace] = ACTIONS(4208),
    [anon_sym_module] = ACTIONS(4208),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_open] = ACTIONS(4208),
    [anon_sym_LBRACK_LT] = ACTIONS(4206),
    [anon_sym_COLON] = ACTIONS(4208),
    [anon_sym_return] = ACTIONS(4208),
    [anon_sym_type] = ACTIONS(4208),
    [anon_sym_do] = ACTIONS(4208),
    [anon_sym_and] = ACTIONS(4208),
    [anon_sym_let] = ACTIONS(4208),
    [anon_sym_let_BANG] = ACTIONS(4206),
    [aux_sym_access_modifier_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(4206),
    [anon_sym_null] = ACTIONS(4208),
    [anon_sym_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_COLON] = ACTIONS(4206),
    [anon_sym_AMP] = ACTIONS(4208),
    [anon_sym_LBRACK] = ACTIONS(4208),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4206),
    [anon_sym_LBRACE] = ACTIONS(4208),
    [anon_sym_LT_AT] = ACTIONS(4208),
    [anon_sym_LT_AT_AT] = ACTIONS(4208),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4206),
    [anon_sym_new] = ACTIONS(4208),
    [anon_sym_with] = ACTIONS(4208),
    [anon_sym_return_BANG] = ACTIONS(4206),
    [anon_sym_yield] = ACTIONS(4208),
    [anon_sym_yield_BANG] = ACTIONS(4206),
    [anon_sym_lazy] = ACTIONS(4208),
    [anon_sym_assert] = ACTIONS(4208),
    [anon_sym_upcast] = ACTIONS(4208),
    [anon_sym_downcast] = ACTIONS(4208),
    [anon_sym_COLON_GT] = ACTIONS(4206),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4206),
    [anon_sym_for] = ACTIONS(4208),
    [anon_sym_while] = ACTIONS(4208),
    [anon_sym_if] = ACTIONS(4208),
    [anon_sym_fun] = ACTIONS(4208),
    [anon_sym_try] = ACTIONS(4208),
    [anon_sym_match] = ACTIONS(4208),
    [anon_sym_match_BANG] = ACTIONS(4206),
    [anon_sym_function] = ACTIONS(4208),
    [anon_sym_LT_DASH] = ACTIONS(4208),
    [anon_sym_DOT_LBRACK] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(4206),
    [anon_sym_use] = ACTIONS(4208),
    [anon_sym_use_BANG] = ACTIONS(4206),
    [anon_sym_do_BANG] = ACTIONS(4206),
    [anon_sym_begin] = ACTIONS(4208),
    [anon_sym_LPAREN2] = ACTIONS(4208),
    [anon_sym_default] = ACTIONS(4208),
    [anon_sym_or] = ACTIONS(4208),
    [anon_sym_static] = ACTIONS(4208),
    [anon_sym_member] = ACTIONS(4208),
    [anon_sym_interface] = ACTIONS(4208),
    [anon_sym_exception] = ACTIONS(4208),
    [anon_sym_abstract] = ACTIONS(4208),
    [anon_sym_val] = ACTIONS(4208),
    [anon_sym_override] = ACTIONS(4208),
    [aux_sym_char_token1] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4208),
    [anon_sym_DQUOTE] = ACTIONS(4208),
    [anon_sym_AT_DQUOTE] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [sym_bool] = ACTIONS(4208),
    [sym_unit] = ACTIONS(4206),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4208),
    [sym_op_identifier] = ACTIONS(4208),
    [anon_sym_PLUS] = ACTIONS(4208),
    [anon_sym_DASH] = ACTIONS(4208),
    [anon_sym_PLUS_DOT] = ACTIONS(4208),
    [anon_sym_DASH_DOT] = ACTIONS(4208),
    [anon_sym_PERCENT] = ACTIONS(4208),
    [anon_sym_AMP_AMP] = ACTIONS(4208),
    [anon_sym_TILDE] = ACTIONS(4206),
    [aux_sym_prefix_op_token1] = ACTIONS(4208),
    [aux_sym_infix_op_token1] = ACTIONS(4206),
    [aux_sym_infix_op_token2] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(4208),
    [anon_sym_BANG_EQ] = ACTIONS(4208),
    [anon_sym_COLON_EQ] = ACTIONS(4206),
    [anon_sym_DOLLAR] = ACTIONS(4208),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4208),
    [sym_int] = ACTIONS(4208),
    [sym_xint] = ACTIONS(4206),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4206),
    [anon_sym_POUNDload] = ACTIONS(4206),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4206),
    [sym__newline] = ACTIONS(4206),
  },
  [1455] = {
    [sym_block_comment] = STATE(1455),
    [sym_compiler_directive_decl] = STATE(1455),
    [sym_fsi_directive_decl] = STATE(1455),
    [sym_preproc_line] = STATE(1455),
    [ts_builtin_sym_end] = ACTIONS(4210),
    [sym_identifier] = ACTIONS(4212),
    [anon_sym_namespace] = ACTIONS(4212),
    [anon_sym_module] = ACTIONS(4212),
    [anon_sym_EQ] = ACTIONS(4210),
    [anon_sym_open] = ACTIONS(4212),
    [anon_sym_LBRACK_LT] = ACTIONS(4210),
    [anon_sym_COLON] = ACTIONS(4212),
    [anon_sym_return] = ACTIONS(4212),
    [anon_sym_type] = ACTIONS(4212),
    [anon_sym_do] = ACTIONS(4212),
    [anon_sym_and] = ACTIONS(4212),
    [anon_sym_let] = ACTIONS(4212),
    [anon_sym_let_BANG] = ACTIONS(4210),
    [aux_sym_access_modifier_token1] = ACTIONS(4210),
    [anon_sym_LPAREN] = ACTIONS(4212),
    [anon_sym_COMMA] = ACTIONS(4210),
    [anon_sym_null] = ACTIONS(4212),
    [anon_sym_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_COLON] = ACTIONS(4210),
    [anon_sym_AMP] = ACTIONS(4212),
    [anon_sym_LBRACK] = ACTIONS(4212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4210),
    [anon_sym_LBRACE] = ACTIONS(4212),
    [anon_sym_LT_AT] = ACTIONS(4212),
    [anon_sym_LT_AT_AT] = ACTIONS(4212),
    [anon_sym_DOT] = ACTIONS(4212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4210),
    [anon_sym_new] = ACTIONS(4212),
    [anon_sym_with] = ACTIONS(4212),
    [anon_sym_return_BANG] = ACTIONS(4210),
    [anon_sym_yield] = ACTIONS(4212),
    [anon_sym_yield_BANG] = ACTIONS(4210),
    [anon_sym_lazy] = ACTIONS(4212),
    [anon_sym_assert] = ACTIONS(4212),
    [anon_sym_upcast] = ACTIONS(4212),
    [anon_sym_downcast] = ACTIONS(4212),
    [anon_sym_COLON_GT] = ACTIONS(4210),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4210),
    [anon_sym_for] = ACTIONS(4212),
    [anon_sym_while] = ACTIONS(4212),
    [anon_sym_if] = ACTIONS(4212),
    [anon_sym_fun] = ACTIONS(4212),
    [anon_sym_try] = ACTIONS(4212),
    [anon_sym_match] = ACTIONS(4212),
    [anon_sym_match_BANG] = ACTIONS(4210),
    [anon_sym_function] = ACTIONS(4212),
    [anon_sym_LT_DASH] = ACTIONS(4212),
    [anon_sym_DOT_LBRACK] = ACTIONS(4210),
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_use] = ACTIONS(4212),
    [anon_sym_use_BANG] = ACTIONS(4210),
    [anon_sym_do_BANG] = ACTIONS(4210),
    [anon_sym_begin] = ACTIONS(4212),
    [anon_sym_LPAREN2] = ACTIONS(4212),
    [anon_sym_default] = ACTIONS(4212),
    [anon_sym_or] = ACTIONS(4212),
    [anon_sym_static] = ACTIONS(4212),
    [anon_sym_member] = ACTIONS(4212),
    [anon_sym_interface] = ACTIONS(4212),
    [anon_sym_exception] = ACTIONS(4212),
    [anon_sym_abstract] = ACTIONS(4212),
    [anon_sym_val] = ACTIONS(4212),
    [anon_sym_override] = ACTIONS(4212),
    [aux_sym_char_token1] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4212),
    [anon_sym_DQUOTE] = ACTIONS(4212),
    [anon_sym_AT_DQUOTE] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [sym_bool] = ACTIONS(4212),
    [sym_unit] = ACTIONS(4210),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4212),
    [anon_sym_DASH] = ACTIONS(4212),
    [anon_sym_PLUS_DOT] = ACTIONS(4212),
    [anon_sym_DASH_DOT] = ACTIONS(4212),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_AMP_AMP] = ACTIONS(4212),
    [anon_sym_TILDE] = ACTIONS(4210),
    [aux_sym_prefix_op_token1] = ACTIONS(4212),
    [aux_sym_infix_op_token1] = ACTIONS(4210),
    [aux_sym_infix_op_token2] = ACTIONS(4212),
    [anon_sym_PIPE_PIPE] = ACTIONS(4212),
    [anon_sym_BANG_EQ] = ACTIONS(4212),
    [anon_sym_COLON_EQ] = ACTIONS(4210),
    [anon_sym_DOLLAR] = ACTIONS(4212),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4212),
    [sym_int] = ACTIONS(4212),
    [sym_xint] = ACTIONS(4210),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4210),
    [anon_sym_POUNDload] = ACTIONS(4210),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4210),
    [sym__newline] = ACTIONS(4210),
  },
  [1456] = {
    [sym_block_comment] = STATE(1456),
    [sym_compiler_directive_decl] = STATE(1456),
    [sym_fsi_directive_decl] = STATE(1456),
    [sym_preproc_line] = STATE(1456),
    [ts_builtin_sym_end] = ACTIONS(4214),
    [sym_identifier] = ACTIONS(4216),
    [anon_sym_namespace] = ACTIONS(4216),
    [anon_sym_module] = ACTIONS(4216),
    [anon_sym_EQ] = ACTIONS(4214),
    [anon_sym_open] = ACTIONS(4216),
    [anon_sym_LBRACK_LT] = ACTIONS(4214),
    [anon_sym_COLON] = ACTIONS(4216),
    [anon_sym_return] = ACTIONS(4216),
    [anon_sym_type] = ACTIONS(4216),
    [anon_sym_do] = ACTIONS(4216),
    [anon_sym_and] = ACTIONS(4216),
    [anon_sym_let] = ACTIONS(4216),
    [anon_sym_let_BANG] = ACTIONS(4214),
    [aux_sym_access_modifier_token1] = ACTIONS(4214),
    [anon_sym_LPAREN] = ACTIONS(4216),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_null] = ACTIONS(4216),
    [anon_sym_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_COLON] = ACTIONS(4214),
    [anon_sym_AMP] = ACTIONS(4216),
    [anon_sym_LBRACK] = ACTIONS(4216),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4214),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_LT_AT] = ACTIONS(4216),
    [anon_sym_LT_AT_AT] = ACTIONS(4216),
    [anon_sym_DOT] = ACTIONS(4216),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4214),
    [anon_sym_new] = ACTIONS(4216),
    [anon_sym_with] = ACTIONS(4216),
    [anon_sym_return_BANG] = ACTIONS(4214),
    [anon_sym_yield] = ACTIONS(4216),
    [anon_sym_yield_BANG] = ACTIONS(4214),
    [anon_sym_lazy] = ACTIONS(4216),
    [anon_sym_assert] = ACTIONS(4216),
    [anon_sym_upcast] = ACTIONS(4216),
    [anon_sym_downcast] = ACTIONS(4216),
    [anon_sym_COLON_GT] = ACTIONS(4214),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4214),
    [anon_sym_for] = ACTIONS(4216),
    [anon_sym_while] = ACTIONS(4216),
    [anon_sym_if] = ACTIONS(4216),
    [anon_sym_fun] = ACTIONS(4216),
    [anon_sym_try] = ACTIONS(4216),
    [anon_sym_match] = ACTIONS(4216),
    [anon_sym_match_BANG] = ACTIONS(4214),
    [anon_sym_function] = ACTIONS(4216),
    [anon_sym_LT_DASH] = ACTIONS(4216),
    [anon_sym_DOT_LBRACK] = ACTIONS(4214),
    [anon_sym_LT] = ACTIONS(4214),
    [anon_sym_use] = ACTIONS(4216),
    [anon_sym_use_BANG] = ACTIONS(4214),
    [anon_sym_do_BANG] = ACTIONS(4214),
    [anon_sym_begin] = ACTIONS(4216),
    [anon_sym_LPAREN2] = ACTIONS(4216),
    [anon_sym_default] = ACTIONS(4216),
    [anon_sym_or] = ACTIONS(4216),
    [anon_sym_static] = ACTIONS(4216),
    [anon_sym_member] = ACTIONS(4216),
    [anon_sym_interface] = ACTIONS(4216),
    [anon_sym_exception] = ACTIONS(4216),
    [anon_sym_abstract] = ACTIONS(4216),
    [anon_sym_val] = ACTIONS(4216),
    [anon_sym_override] = ACTIONS(4216),
    [aux_sym_char_token1] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4216),
    [anon_sym_DQUOTE] = ACTIONS(4216),
    [anon_sym_AT_DQUOTE] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [sym_bool] = ACTIONS(4216),
    [sym_unit] = ACTIONS(4214),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4216),
    [sym_op_identifier] = ACTIONS(4216),
    [anon_sym_PLUS] = ACTIONS(4216),
    [anon_sym_DASH] = ACTIONS(4216),
    [anon_sym_PLUS_DOT] = ACTIONS(4216),
    [anon_sym_DASH_DOT] = ACTIONS(4216),
    [anon_sym_PERCENT] = ACTIONS(4216),
    [anon_sym_AMP_AMP] = ACTIONS(4216),
    [anon_sym_TILDE] = ACTIONS(4214),
    [aux_sym_prefix_op_token1] = ACTIONS(4216),
    [aux_sym_infix_op_token1] = ACTIONS(4214),
    [aux_sym_infix_op_token2] = ACTIONS(4216),
    [anon_sym_PIPE_PIPE] = ACTIONS(4216),
    [anon_sym_BANG_EQ] = ACTIONS(4216),
    [anon_sym_COLON_EQ] = ACTIONS(4214),
    [anon_sym_DOLLAR] = ACTIONS(4216),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4216),
    [sym_int] = ACTIONS(4216),
    [sym_xint] = ACTIONS(4214),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4214),
    [anon_sym_POUNDload] = ACTIONS(4214),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4214),
    [sym__newline] = ACTIONS(4214),
  },
  [1457] = {
    [sym_block_comment] = STATE(1457),
    [sym_compiler_directive_decl] = STATE(1457),
    [sym_fsi_directive_decl] = STATE(1457),
    [sym_preproc_line] = STATE(1457),
    [ts_builtin_sym_end] = ACTIONS(4218),
    [sym_identifier] = ACTIONS(4220),
    [anon_sym_namespace] = ACTIONS(4220),
    [anon_sym_module] = ACTIONS(4220),
    [anon_sym_EQ] = ACTIONS(4218),
    [anon_sym_open] = ACTIONS(4220),
    [anon_sym_LBRACK_LT] = ACTIONS(4218),
    [anon_sym_COLON] = ACTIONS(4220),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_type] = ACTIONS(4220),
    [anon_sym_do] = ACTIONS(4220),
    [anon_sym_and] = ACTIONS(4220),
    [anon_sym_let] = ACTIONS(4220),
    [anon_sym_let_BANG] = ACTIONS(4218),
    [aux_sym_access_modifier_token1] = ACTIONS(4218),
    [anon_sym_LPAREN] = ACTIONS(4220),
    [anon_sym_COMMA] = ACTIONS(4218),
    [anon_sym_null] = ACTIONS(4220),
    [anon_sym_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_COLON] = ACTIONS(4218),
    [anon_sym_AMP] = ACTIONS(4220),
    [anon_sym_LBRACK] = ACTIONS(4220),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(4220),
    [anon_sym_LT_AT] = ACTIONS(4220),
    [anon_sym_LT_AT_AT] = ACTIONS(4220),
    [anon_sym_DOT] = ACTIONS(4220),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4218),
    [anon_sym_new] = ACTIONS(4220),
    [anon_sym_with] = ACTIONS(4220),
    [anon_sym_return_BANG] = ACTIONS(4218),
    [anon_sym_yield] = ACTIONS(4220),
    [anon_sym_yield_BANG] = ACTIONS(4218),
    [anon_sym_lazy] = ACTIONS(4220),
    [anon_sym_assert] = ACTIONS(4220),
    [anon_sym_upcast] = ACTIONS(4220),
    [anon_sym_downcast] = ACTIONS(4220),
    [anon_sym_COLON_GT] = ACTIONS(4218),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4218),
    [anon_sym_for] = ACTIONS(4220),
    [anon_sym_while] = ACTIONS(4220),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_fun] = ACTIONS(4220),
    [anon_sym_try] = ACTIONS(4220),
    [anon_sym_match] = ACTIONS(4220),
    [anon_sym_match_BANG] = ACTIONS(4218),
    [anon_sym_function] = ACTIONS(4220),
    [anon_sym_LT_DASH] = ACTIONS(4220),
    [anon_sym_DOT_LBRACK] = ACTIONS(4218),
    [anon_sym_LT] = ACTIONS(4218),
    [anon_sym_use] = ACTIONS(4220),
    [anon_sym_use_BANG] = ACTIONS(4218),
    [anon_sym_do_BANG] = ACTIONS(4218),
    [anon_sym_begin] = ACTIONS(4220),
    [anon_sym_LPAREN2] = ACTIONS(4220),
    [anon_sym_default] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(4220),
    [anon_sym_static] = ACTIONS(4220),
    [anon_sym_member] = ACTIONS(4220),
    [anon_sym_interface] = ACTIONS(4220),
    [anon_sym_exception] = ACTIONS(4220),
    [anon_sym_abstract] = ACTIONS(4220),
    [anon_sym_val] = ACTIONS(4220),
    [anon_sym_override] = ACTIONS(4220),
    [aux_sym_char_token1] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4220),
    [anon_sym_DQUOTE] = ACTIONS(4220),
    [anon_sym_AT_DQUOTE] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [sym_bool] = ACTIONS(4220),
    [sym_unit] = ACTIONS(4218),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4220),
    [sym_op_identifier] = ACTIONS(4220),
    [anon_sym_PLUS] = ACTIONS(4220),
    [anon_sym_DASH] = ACTIONS(4220),
    [anon_sym_PLUS_DOT] = ACTIONS(4220),
    [anon_sym_DASH_DOT] = ACTIONS(4220),
    [anon_sym_PERCENT] = ACTIONS(4220),
    [anon_sym_AMP_AMP] = ACTIONS(4220),
    [anon_sym_TILDE] = ACTIONS(4218),
    [aux_sym_prefix_op_token1] = ACTIONS(4220),
    [aux_sym_infix_op_token1] = ACTIONS(4218),
    [aux_sym_infix_op_token2] = ACTIONS(4220),
    [anon_sym_PIPE_PIPE] = ACTIONS(4220),
    [anon_sym_BANG_EQ] = ACTIONS(4220),
    [anon_sym_COLON_EQ] = ACTIONS(4218),
    [anon_sym_DOLLAR] = ACTIONS(4220),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4220),
    [sym_int] = ACTIONS(4220),
    [sym_xint] = ACTIONS(4218),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4218),
    [anon_sym_POUNDload] = ACTIONS(4218),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4218),
    [sym__newline] = ACTIONS(4218),
  },
  [1458] = {
    [sym_block_comment] = STATE(1458),
    [sym_compiler_directive_decl] = STATE(1458),
    [sym_fsi_directive_decl] = STATE(1458),
    [sym_preproc_line] = STATE(1458),
    [ts_builtin_sym_end] = ACTIONS(4222),
    [sym_identifier] = ACTIONS(4224),
    [anon_sym_namespace] = ACTIONS(4224),
    [anon_sym_module] = ACTIONS(4224),
    [anon_sym_EQ] = ACTIONS(4222),
    [anon_sym_open] = ACTIONS(4224),
    [anon_sym_LBRACK_LT] = ACTIONS(4222),
    [anon_sym_COLON] = ACTIONS(4224),
    [anon_sym_return] = ACTIONS(4224),
    [anon_sym_type] = ACTIONS(4224),
    [anon_sym_do] = ACTIONS(4224),
    [anon_sym_and] = ACTIONS(4224),
    [anon_sym_let] = ACTIONS(4224),
    [anon_sym_let_BANG] = ACTIONS(4222),
    [aux_sym_access_modifier_token1] = ACTIONS(4222),
    [anon_sym_LPAREN] = ACTIONS(4224),
    [anon_sym_COMMA] = ACTIONS(4222),
    [anon_sym_null] = ACTIONS(4224),
    [anon_sym_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_COLON] = ACTIONS(4222),
    [anon_sym_AMP] = ACTIONS(4224),
    [anon_sym_LBRACK] = ACTIONS(4224),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4222),
    [anon_sym_LBRACE] = ACTIONS(4224),
    [anon_sym_LT_AT] = ACTIONS(4224),
    [anon_sym_LT_AT_AT] = ACTIONS(4224),
    [anon_sym_DOT] = ACTIONS(4224),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4222),
    [anon_sym_new] = ACTIONS(4224),
    [anon_sym_with] = ACTIONS(4224),
    [anon_sym_return_BANG] = ACTIONS(4222),
    [anon_sym_yield] = ACTIONS(4224),
    [anon_sym_yield_BANG] = ACTIONS(4222),
    [anon_sym_lazy] = ACTIONS(4224),
    [anon_sym_assert] = ACTIONS(4224),
    [anon_sym_upcast] = ACTIONS(4224),
    [anon_sym_downcast] = ACTIONS(4224),
    [anon_sym_COLON_GT] = ACTIONS(4222),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4222),
    [anon_sym_for] = ACTIONS(4224),
    [anon_sym_while] = ACTIONS(4224),
    [anon_sym_if] = ACTIONS(4224),
    [anon_sym_fun] = ACTIONS(4224),
    [anon_sym_try] = ACTIONS(4224),
    [anon_sym_match] = ACTIONS(4224),
    [anon_sym_match_BANG] = ACTIONS(4222),
    [anon_sym_function] = ACTIONS(4224),
    [anon_sym_LT_DASH] = ACTIONS(4224),
    [anon_sym_DOT_LBRACK] = ACTIONS(4222),
    [anon_sym_LT] = ACTIONS(4222),
    [anon_sym_use] = ACTIONS(4224),
    [anon_sym_use_BANG] = ACTIONS(4222),
    [anon_sym_do_BANG] = ACTIONS(4222),
    [anon_sym_begin] = ACTIONS(4224),
    [anon_sym_LPAREN2] = ACTIONS(4224),
    [anon_sym_default] = ACTIONS(4224),
    [anon_sym_or] = ACTIONS(4224),
    [anon_sym_static] = ACTIONS(4224),
    [anon_sym_member] = ACTIONS(4224),
    [anon_sym_interface] = ACTIONS(4224),
    [anon_sym_exception] = ACTIONS(4224),
    [anon_sym_abstract] = ACTIONS(4224),
    [anon_sym_val] = ACTIONS(4224),
    [anon_sym_override] = ACTIONS(4224),
    [aux_sym_char_token1] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4224),
    [anon_sym_DQUOTE] = ACTIONS(4224),
    [anon_sym_AT_DQUOTE] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [sym_bool] = ACTIONS(4224),
    [sym_unit] = ACTIONS(4222),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4224),
    [sym_op_identifier] = ACTIONS(4224),
    [anon_sym_PLUS] = ACTIONS(4224),
    [anon_sym_DASH] = ACTIONS(4224),
    [anon_sym_PLUS_DOT] = ACTIONS(4224),
    [anon_sym_DASH_DOT] = ACTIONS(4224),
    [anon_sym_PERCENT] = ACTIONS(4224),
    [anon_sym_AMP_AMP] = ACTIONS(4224),
    [anon_sym_TILDE] = ACTIONS(4222),
    [aux_sym_prefix_op_token1] = ACTIONS(4224),
    [aux_sym_infix_op_token1] = ACTIONS(4222),
    [aux_sym_infix_op_token2] = ACTIONS(4224),
    [anon_sym_PIPE_PIPE] = ACTIONS(4224),
    [anon_sym_BANG_EQ] = ACTIONS(4224),
    [anon_sym_COLON_EQ] = ACTIONS(4222),
    [anon_sym_DOLLAR] = ACTIONS(4224),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4224),
    [sym_int] = ACTIONS(4224),
    [sym_xint] = ACTIONS(4222),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4222),
    [anon_sym_POUNDload] = ACTIONS(4222),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4222),
    [sym__newline] = ACTIONS(4222),
  },
  [1459] = {
    [sym_block_comment] = STATE(1459),
    [sym_compiler_directive_decl] = STATE(1459),
    [sym_fsi_directive_decl] = STATE(1459),
    [sym_preproc_line] = STATE(1459),
    [ts_builtin_sym_end] = ACTIONS(4226),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_namespace] = ACTIONS(4228),
    [anon_sym_module] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_open] = ACTIONS(4228),
    [anon_sym_LBRACK_LT] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_type] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_and] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [aux_sym_access_modifier_token1] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_with] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_default] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [anon_sym_static] = ACTIONS(4228),
    [anon_sym_member] = ACTIONS(4228),
    [anon_sym_interface] = ACTIONS(4228),
    [anon_sym_exception] = ACTIONS(4228),
    [anon_sym_abstract] = ACTIONS(4228),
    [anon_sym_val] = ACTIONS(4228),
    [anon_sym_override] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4226),
    [anon_sym_POUNDload] = ACTIONS(4226),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
  },
  [1460] = {
    [sym_block_comment] = STATE(1460),
    [sym_compiler_directive_decl] = STATE(1460),
    [sym_fsi_directive_decl] = STATE(1460),
    [sym_preproc_line] = STATE(1460),
    [aux_sym_compound_type_repeat1] = STATE(1381),
    [sym_identifier] = ACTIONS(3468),
    [anon_sym_EQ] = ACTIONS(3466),
    [anon_sym_LBRACK_LT] = ACTIONS(3466),
    [anon_sym_COLON] = ACTIONS(3468),
    [anon_sym_return] = ACTIONS(3468),
    [anon_sym_do] = ACTIONS(3468),
    [anon_sym_and] = ACTIONS(3468),
    [anon_sym_let] = ACTIONS(3468),
    [anon_sym_let_BANG] = ACTIONS(3466),
    [aux_sym_access_modifier_token1] = ACTIONS(3466),
    [anon_sym_LPAREN] = ACTIONS(3468),
    [anon_sym_COMMA] = ACTIONS(3466),
    [anon_sym_null] = ACTIONS(3468),
    [anon_sym_QMARK] = ACTIONS(3468),
    [anon_sym_COLON_QMARK] = ACTIONS(3468),
    [anon_sym_COLON_COLON] = ACTIONS(3466),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LBRACK] = ACTIONS(3468),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3466),
    [anon_sym_LBRACE] = ACTIONS(3468),
    [anon_sym_LT_AT] = ACTIONS(3468),
    [anon_sym_LT_AT_AT] = ACTIONS(3468),
    [anon_sym_DOT] = ACTIONS(3468),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3466),
    [anon_sym_new] = ACTIONS(3468),
    [anon_sym_with] = ACTIONS(3468),
    [anon_sym_return_BANG] = ACTIONS(3466),
    [anon_sym_yield] = ACTIONS(3468),
    [anon_sym_yield_BANG] = ACTIONS(3466),
    [anon_sym_lazy] = ACTIONS(3468),
    [anon_sym_assert] = ACTIONS(3468),
    [anon_sym_upcast] = ACTIONS(3468),
    [anon_sym_downcast] = ACTIONS(3468),
    [anon_sym_COLON_GT] = ACTIONS(3466),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3466),
    [anon_sym_for] = ACTIONS(3468),
    [anon_sym_while] = ACTIONS(3468),
    [anon_sym_if] = ACTIONS(3468),
    [anon_sym_fun] = ACTIONS(3468),
    [anon_sym_DASH_GT] = ACTIONS(3468),
    [anon_sym_try] = ACTIONS(3468),
    [anon_sym_match] = ACTIONS(3468),
    [anon_sym_match_BANG] = ACTIONS(3466),
    [anon_sym_function] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3468),
    [anon_sym_DOT_LBRACK] = ACTIONS(3466),
    [anon_sym_LT] = ACTIONS(3466),
    [anon_sym_use] = ACTIONS(3468),
    [anon_sym_use_BANG] = ACTIONS(3466),
    [anon_sym_do_BANG] = ACTIONS(3466),
    [anon_sym_begin] = ACTIONS(3468),
    [anon_sym_LPAREN2] = ACTIONS(3468),
    [anon_sym_STAR] = ACTIONS(3668),
    [anon_sym_LT2] = ACTIONS(3468),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3466),
    [anon_sym_default] = ACTIONS(3468),
    [anon_sym_or] = ACTIONS(3468),
    [anon_sym_static] = ACTIONS(3468),
    [anon_sym_member] = ACTIONS(3468),
    [anon_sym_interface] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(3468),
    [anon_sym_val] = ACTIONS(3468),
    [anon_sym_override] = ACTIONS(3468),
    [aux_sym_char_token1] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3468),
    [anon_sym_DQUOTE] = ACTIONS(3468),
    [anon_sym_AT_DQUOTE] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [sym_bool] = ACTIONS(3468),
    [sym_unit] = ACTIONS(3466),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3468),
    [sym_op_identifier] = ACTIONS(3468),
    [anon_sym_PLUS] = ACTIONS(3468),
    [anon_sym_DASH] = ACTIONS(3468),
    [anon_sym_PLUS_DOT] = ACTIONS(3468),
    [anon_sym_DASH_DOT] = ACTIONS(3468),
    [anon_sym_PERCENT] = ACTIONS(3468),
    [anon_sym_AMP_AMP] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3466),
    [aux_sym_prefix_op_token1] = ACTIONS(3468),
    [aux_sym_infix_op_token1] = ACTIONS(3466),
    [aux_sym_infix_op_token2] = ACTIONS(3468),
    [anon_sym_PIPE_PIPE] = ACTIONS(3468),
    [anon_sym_BANG_EQ] = ACTIONS(3468),
    [anon_sym_COLON_EQ] = ACTIONS(3466),
    [anon_sym_DOLLAR] = ACTIONS(3468),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3468),
    [sym_int] = ACTIONS(3468),
    [sym_xint] = ACTIONS(3466),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3466),
    [sym__newline] = ACTIONS(3466),
    [sym__dedent] = ACTIONS(3466),
  },
  [1461] = {
    [sym__else_expression] = STATE(2021),
    [sym_elif_expression] = STATE(1661),
    [sym_block_comment] = STATE(1461),
    [sym_compiler_directive_decl] = STATE(1461),
    [sym_fsi_directive_decl] = STATE(1461),
    [sym_preproc_line] = STATE(1461),
    [aux_sym_if_expression_repeat1] = STATE(1516),
    [sym_identifier] = ACTIONS(3457),
    [anon_sym_EQ] = ACTIONS(3455),
    [anon_sym_LBRACK_LT] = ACTIONS(3455),
    [anon_sym_COLON] = ACTIONS(3457),
    [anon_sym_return] = ACTIONS(3457),
    [anon_sym_do] = ACTIONS(3457),
    [anon_sym_let] = ACTIONS(3457),
    [anon_sym_let_BANG] = ACTIONS(3455),
    [aux_sym_access_modifier_token1] = ACTIONS(3455),
    [anon_sym_LPAREN] = ACTIONS(3457),
    [anon_sym_COMMA] = ACTIONS(3455),
    [anon_sym_null] = ACTIONS(3457),
    [anon_sym_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_COLON] = ACTIONS(3455),
    [anon_sym_AMP] = ACTIONS(3457),
    [anon_sym_LBRACK] = ACTIONS(3457),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3457),
    [anon_sym_LT_AT] = ACTIONS(3457),
    [anon_sym_LT_AT_AT] = ACTIONS(3457),
    [anon_sym_DOT] = ACTIONS(3457),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3457),
    [anon_sym_with] = ACTIONS(3457),
    [anon_sym_return_BANG] = ACTIONS(3455),
    [anon_sym_yield] = ACTIONS(3457),
    [anon_sym_yield_BANG] = ACTIONS(3455),
    [anon_sym_lazy] = ACTIONS(3457),
    [anon_sym_assert] = ACTIONS(3457),
    [anon_sym_upcast] = ACTIONS(3457),
    [anon_sym_downcast] = ACTIONS(3457),
    [anon_sym_COLON_GT] = ACTIONS(3455),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3457),
    [anon_sym_while] = ACTIONS(3457),
    [anon_sym_else] = ACTIONS(4068),
    [anon_sym_elif] = ACTIONS(4070),
    [anon_sym_if] = ACTIONS(3457),
    [anon_sym_fun] = ACTIONS(3457),
    [anon_sym_try] = ACTIONS(3457),
    [anon_sym_match] = ACTIONS(3457),
    [anon_sym_match_BANG] = ACTIONS(3455),
    [anon_sym_function] = ACTIONS(3457),
    [anon_sym_LT_DASH] = ACTIONS(3457),
    [anon_sym_DOT_LBRACK] = ACTIONS(3455),
    [anon_sym_LT] = ACTIONS(3455),
    [anon_sym_use] = ACTIONS(3457),
    [anon_sym_use_BANG] = ACTIONS(3455),
    [anon_sym_do_BANG] = ACTIONS(3455),
    [anon_sym_begin] = ACTIONS(3457),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_DOT_DOT2] = ACTIONS(3455),
    [anon_sym_default] = ACTIONS(3457),
    [anon_sym_or] = ACTIONS(3457),
    [anon_sym_static] = ACTIONS(3457),
    [anon_sym_member] = ACTIONS(3457),
    [anon_sym_interface] = ACTIONS(3457),
    [anon_sym_abstract] = ACTIONS(3457),
    [anon_sym_val] = ACTIONS(3457),
    [anon_sym_override] = ACTIONS(3457),
    [aux_sym_char_token1] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [anon_sym_AT_DQUOTE] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [sym_bool] = ACTIONS(3457),
    [sym_unit] = ACTIONS(3455),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3457),
    [sym_op_identifier] = ACTIONS(3457),
    [anon_sym_PLUS] = ACTIONS(3457),
    [anon_sym_DASH] = ACTIONS(3457),
    [anon_sym_PLUS_DOT] = ACTIONS(3457),
    [anon_sym_DASH_DOT] = ACTIONS(3457),
    [anon_sym_PERCENT] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3455),
    [aux_sym_prefix_op_token1] = ACTIONS(3457),
    [aux_sym_infix_op_token1] = ACTIONS(3455),
    [aux_sym_infix_op_token2] = ACTIONS(3457),
    [anon_sym_PIPE_PIPE] = ACTIONS(3457),
    [anon_sym_BANG_EQ] = ACTIONS(3457),
    [anon_sym_COLON_EQ] = ACTIONS(3455),
    [anon_sym_DOLLAR] = ACTIONS(3457),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3457),
    [sym_int] = ACTIONS(3457),
    [sym_xint] = ACTIONS(3455),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3455),
    [sym__newline] = ACTIONS(3455),
    [sym__dedent] = ACTIONS(3455),
  },
  [1462] = {
    [sym_block_comment] = STATE(1462),
    [sym_compiler_directive_decl] = STATE(1462),
    [sym_fsi_directive_decl] = STATE(1462),
    [sym_preproc_line] = STATE(1462),
    [ts_builtin_sym_end] = ACTIONS(4230),
    [sym_identifier] = ACTIONS(4232),
    [anon_sym_namespace] = ACTIONS(4232),
    [anon_sym_module] = ACTIONS(4232),
    [anon_sym_EQ] = ACTIONS(4230),
    [anon_sym_open] = ACTIONS(4232),
    [anon_sym_LBRACK_LT] = ACTIONS(4230),
    [anon_sym_COLON] = ACTIONS(4232),
    [anon_sym_return] = ACTIONS(4232),
    [anon_sym_type] = ACTIONS(4232),
    [anon_sym_do] = ACTIONS(4232),
    [anon_sym_and] = ACTIONS(4232),
    [anon_sym_let] = ACTIONS(4232),
    [anon_sym_let_BANG] = ACTIONS(4230),
    [aux_sym_access_modifier_token1] = ACTIONS(4230),
    [anon_sym_LPAREN] = ACTIONS(4232),
    [anon_sym_COMMA] = ACTIONS(4230),
    [anon_sym_null] = ACTIONS(4232),
    [anon_sym_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_COLON] = ACTIONS(4230),
    [anon_sym_AMP] = ACTIONS(4232),
    [anon_sym_LBRACK] = ACTIONS(4232),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4230),
    [anon_sym_LBRACE] = ACTIONS(4232),
    [anon_sym_LT_AT] = ACTIONS(4232),
    [anon_sym_LT_AT_AT] = ACTIONS(4232),
    [anon_sym_DOT] = ACTIONS(4232),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4230),
    [anon_sym_new] = ACTIONS(4232),
    [anon_sym_with] = ACTIONS(4232),
    [anon_sym_return_BANG] = ACTIONS(4230),
    [anon_sym_yield] = ACTIONS(4232),
    [anon_sym_yield_BANG] = ACTIONS(4230),
    [anon_sym_lazy] = ACTIONS(4232),
    [anon_sym_assert] = ACTIONS(4232),
    [anon_sym_upcast] = ACTIONS(4232),
    [anon_sym_downcast] = ACTIONS(4232),
    [anon_sym_COLON_GT] = ACTIONS(4230),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4230),
    [anon_sym_for] = ACTIONS(4232),
    [anon_sym_while] = ACTIONS(4232),
    [anon_sym_if] = ACTIONS(4232),
    [anon_sym_fun] = ACTIONS(4232),
    [anon_sym_try] = ACTIONS(4232),
    [anon_sym_match] = ACTIONS(4232),
    [anon_sym_match_BANG] = ACTIONS(4230),
    [anon_sym_function] = ACTIONS(4232),
    [anon_sym_LT_DASH] = ACTIONS(4232),
    [anon_sym_DOT_LBRACK] = ACTIONS(4230),
    [anon_sym_LT] = ACTIONS(4230),
    [anon_sym_use] = ACTIONS(4232),
    [anon_sym_use_BANG] = ACTIONS(4230),
    [anon_sym_do_BANG] = ACTIONS(4230),
    [anon_sym_begin] = ACTIONS(4232),
    [anon_sym_LPAREN2] = ACTIONS(4232),
    [anon_sym_default] = ACTIONS(4232),
    [anon_sym_or] = ACTIONS(4232),
    [anon_sym_static] = ACTIONS(4232),
    [anon_sym_member] = ACTIONS(4232),
    [anon_sym_interface] = ACTIONS(4232),
    [anon_sym_exception] = ACTIONS(4232),
    [anon_sym_abstract] = ACTIONS(4232),
    [anon_sym_val] = ACTIONS(4232),
    [anon_sym_override] = ACTIONS(4232),
    [aux_sym_char_token1] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4232),
    [anon_sym_DQUOTE] = ACTIONS(4232),
    [anon_sym_AT_DQUOTE] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [sym_bool] = ACTIONS(4232),
    [sym_unit] = ACTIONS(4230),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4232),
    [sym_op_identifier] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4232),
    [anon_sym_DASH] = ACTIONS(4232),
    [anon_sym_PLUS_DOT] = ACTIONS(4232),
    [anon_sym_DASH_DOT] = ACTIONS(4232),
    [anon_sym_PERCENT] = ACTIONS(4232),
    [anon_sym_AMP_AMP] = ACTIONS(4232),
    [anon_sym_TILDE] = ACTIONS(4230),
    [aux_sym_prefix_op_token1] = ACTIONS(4232),
    [aux_sym_infix_op_token1] = ACTIONS(4230),
    [aux_sym_infix_op_token2] = ACTIONS(4232),
    [anon_sym_PIPE_PIPE] = ACTIONS(4232),
    [anon_sym_BANG_EQ] = ACTIONS(4232),
    [anon_sym_COLON_EQ] = ACTIONS(4230),
    [anon_sym_DOLLAR] = ACTIONS(4232),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4232),
    [sym_int] = ACTIONS(4232),
    [sym_xint] = ACTIONS(4230),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4230),
    [anon_sym_POUNDload] = ACTIONS(4230),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4230),
    [sym__newline] = ACTIONS(4230),
  },
  [1463] = {
    [sym_block_comment] = STATE(1463),
    [sym_compiler_directive_decl] = STATE(1463),
    [sym_fsi_directive_decl] = STATE(1463),
    [sym_preproc_line] = STATE(1463),
    [ts_builtin_sym_end] = ACTIONS(4234),
    [sym_identifier] = ACTIONS(4236),
    [anon_sym_namespace] = ACTIONS(4236),
    [anon_sym_module] = ACTIONS(4236),
    [anon_sym_EQ] = ACTIONS(4234),
    [anon_sym_open] = ACTIONS(4236),
    [anon_sym_LBRACK_LT] = ACTIONS(4234),
    [anon_sym_COLON] = ACTIONS(4236),
    [anon_sym_return] = ACTIONS(4236),
    [anon_sym_type] = ACTIONS(4236),
    [anon_sym_do] = ACTIONS(4236),
    [anon_sym_and] = ACTIONS(4236),
    [anon_sym_let] = ACTIONS(4236),
    [anon_sym_let_BANG] = ACTIONS(4234),
    [aux_sym_access_modifier_token1] = ACTIONS(4234),
    [anon_sym_LPAREN] = ACTIONS(4236),
    [anon_sym_COMMA] = ACTIONS(4234),
    [anon_sym_null] = ACTIONS(4236),
    [anon_sym_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_COLON] = ACTIONS(4234),
    [anon_sym_AMP] = ACTIONS(4236),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4234),
    [anon_sym_LBRACE] = ACTIONS(4236),
    [anon_sym_LT_AT] = ACTIONS(4236),
    [anon_sym_LT_AT_AT] = ACTIONS(4236),
    [anon_sym_DOT] = ACTIONS(4236),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4234),
    [anon_sym_new] = ACTIONS(4236),
    [anon_sym_with] = ACTIONS(4236),
    [anon_sym_return_BANG] = ACTIONS(4234),
    [anon_sym_yield] = ACTIONS(4236),
    [anon_sym_yield_BANG] = ACTIONS(4234),
    [anon_sym_lazy] = ACTIONS(4236),
    [anon_sym_assert] = ACTIONS(4236),
    [anon_sym_upcast] = ACTIONS(4236),
    [anon_sym_downcast] = ACTIONS(4236),
    [anon_sym_COLON_GT] = ACTIONS(4234),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4234),
    [anon_sym_for] = ACTIONS(4236),
    [anon_sym_while] = ACTIONS(4236),
    [anon_sym_if] = ACTIONS(4236),
    [anon_sym_fun] = ACTIONS(4236),
    [anon_sym_try] = ACTIONS(4236),
    [anon_sym_match] = ACTIONS(4236),
    [anon_sym_match_BANG] = ACTIONS(4234),
    [anon_sym_function] = ACTIONS(4236),
    [anon_sym_LT_DASH] = ACTIONS(4236),
    [anon_sym_DOT_LBRACK] = ACTIONS(4234),
    [anon_sym_LT] = ACTIONS(4234),
    [anon_sym_use] = ACTIONS(4236),
    [anon_sym_use_BANG] = ACTIONS(4234),
    [anon_sym_do_BANG] = ACTIONS(4234),
    [anon_sym_begin] = ACTIONS(4236),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_default] = ACTIONS(4236),
    [anon_sym_or] = ACTIONS(4236),
    [anon_sym_static] = ACTIONS(4236),
    [anon_sym_member] = ACTIONS(4236),
    [anon_sym_interface] = ACTIONS(4236),
    [anon_sym_exception] = ACTIONS(4236),
    [anon_sym_abstract] = ACTIONS(4236),
    [anon_sym_val] = ACTIONS(4236),
    [anon_sym_override] = ACTIONS(4236),
    [aux_sym_char_token1] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4236),
    [anon_sym_DQUOTE] = ACTIONS(4236),
    [anon_sym_AT_DQUOTE] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [sym_bool] = ACTIONS(4236),
    [sym_unit] = ACTIONS(4234),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4236),
    [sym_op_identifier] = ACTIONS(4236),
    [anon_sym_PLUS] = ACTIONS(4236),
    [anon_sym_DASH] = ACTIONS(4236),
    [anon_sym_PLUS_DOT] = ACTIONS(4236),
    [anon_sym_DASH_DOT] = ACTIONS(4236),
    [anon_sym_PERCENT] = ACTIONS(4236),
    [anon_sym_AMP_AMP] = ACTIONS(4236),
    [anon_sym_TILDE] = ACTIONS(4234),
    [aux_sym_prefix_op_token1] = ACTIONS(4236),
    [aux_sym_infix_op_token1] = ACTIONS(4234),
    [aux_sym_infix_op_token2] = ACTIONS(4236),
    [anon_sym_PIPE_PIPE] = ACTIONS(4236),
    [anon_sym_BANG_EQ] = ACTIONS(4236),
    [anon_sym_COLON_EQ] = ACTIONS(4234),
    [anon_sym_DOLLAR] = ACTIONS(4236),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4236),
    [sym_int] = ACTIONS(4236),
    [sym_xint] = ACTIONS(4234),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4234),
    [anon_sym_POUNDload] = ACTIONS(4234),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4234),
    [sym__newline] = ACTIONS(4234),
  },
  [1464] = {
    [sym_block_comment] = STATE(1464),
    [sym_compiler_directive_decl] = STATE(1464),
    [sym_fsi_directive_decl] = STATE(1464),
    [sym_preproc_line] = STATE(1464),
    [ts_builtin_sym_end] = ACTIONS(4238),
    [sym_identifier] = ACTIONS(4240),
    [anon_sym_namespace] = ACTIONS(4240),
    [anon_sym_module] = ACTIONS(4240),
    [anon_sym_EQ] = ACTIONS(4238),
    [anon_sym_open] = ACTIONS(4240),
    [anon_sym_LBRACK_LT] = ACTIONS(4238),
    [anon_sym_COLON] = ACTIONS(4240),
    [anon_sym_return] = ACTIONS(4240),
    [anon_sym_type] = ACTIONS(4240),
    [anon_sym_do] = ACTIONS(4240),
    [anon_sym_and] = ACTIONS(4240),
    [anon_sym_let] = ACTIONS(4240),
    [anon_sym_let_BANG] = ACTIONS(4238),
    [aux_sym_access_modifier_token1] = ACTIONS(4238),
    [anon_sym_LPAREN] = ACTIONS(4240),
    [anon_sym_COMMA] = ACTIONS(4238),
    [anon_sym_null] = ACTIONS(4240),
    [anon_sym_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_COLON] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4240),
    [anon_sym_LBRACK] = ACTIONS(4240),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4238),
    [anon_sym_LBRACE] = ACTIONS(4240),
    [anon_sym_LT_AT] = ACTIONS(4240),
    [anon_sym_LT_AT_AT] = ACTIONS(4240),
    [anon_sym_DOT] = ACTIONS(4240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4238),
    [anon_sym_new] = ACTIONS(4240),
    [anon_sym_with] = ACTIONS(4240),
    [anon_sym_return_BANG] = ACTIONS(4238),
    [anon_sym_yield] = ACTIONS(4240),
    [anon_sym_yield_BANG] = ACTIONS(4238),
    [anon_sym_lazy] = ACTIONS(4240),
    [anon_sym_assert] = ACTIONS(4240),
    [anon_sym_upcast] = ACTIONS(4240),
    [anon_sym_downcast] = ACTIONS(4240),
    [anon_sym_COLON_GT] = ACTIONS(4238),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4238),
    [anon_sym_for] = ACTIONS(4240),
    [anon_sym_while] = ACTIONS(4240),
    [anon_sym_if] = ACTIONS(4240),
    [anon_sym_fun] = ACTIONS(4240),
    [anon_sym_try] = ACTIONS(4240),
    [anon_sym_match] = ACTIONS(4240),
    [anon_sym_match_BANG] = ACTIONS(4238),
    [anon_sym_function] = ACTIONS(4240),
    [anon_sym_LT_DASH] = ACTIONS(4240),
    [anon_sym_DOT_LBRACK] = ACTIONS(4238),
    [anon_sym_LT] = ACTIONS(4238),
    [anon_sym_use] = ACTIONS(4240),
    [anon_sym_use_BANG] = ACTIONS(4238),
    [anon_sym_do_BANG] = ACTIONS(4238),
    [anon_sym_begin] = ACTIONS(4240),
    [anon_sym_LPAREN2] = ACTIONS(4240),
    [anon_sym_default] = ACTIONS(4240),
    [anon_sym_or] = ACTIONS(4240),
    [anon_sym_static] = ACTIONS(4240),
    [anon_sym_member] = ACTIONS(4240),
    [anon_sym_interface] = ACTIONS(4240),
    [anon_sym_exception] = ACTIONS(4240),
    [anon_sym_abstract] = ACTIONS(4240),
    [anon_sym_val] = ACTIONS(4240),
    [anon_sym_override] = ACTIONS(4240),
    [aux_sym_char_token1] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4240),
    [anon_sym_DQUOTE] = ACTIONS(4240),
    [anon_sym_AT_DQUOTE] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [sym_bool] = ACTIONS(4240),
    [sym_unit] = ACTIONS(4238),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4240),
    [sym_op_identifier] = ACTIONS(4240),
    [anon_sym_PLUS] = ACTIONS(4240),
    [anon_sym_DASH] = ACTIONS(4240),
    [anon_sym_PLUS_DOT] = ACTIONS(4240),
    [anon_sym_DASH_DOT] = ACTIONS(4240),
    [anon_sym_PERCENT] = ACTIONS(4240),
    [anon_sym_AMP_AMP] = ACTIONS(4240),
    [anon_sym_TILDE] = ACTIONS(4238),
    [aux_sym_prefix_op_token1] = ACTIONS(4240),
    [aux_sym_infix_op_token1] = ACTIONS(4238),
    [aux_sym_infix_op_token2] = ACTIONS(4240),
    [anon_sym_PIPE_PIPE] = ACTIONS(4240),
    [anon_sym_BANG_EQ] = ACTIONS(4240),
    [anon_sym_COLON_EQ] = ACTIONS(4238),
    [anon_sym_DOLLAR] = ACTIONS(4240),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4240),
    [sym_int] = ACTIONS(4240),
    [sym_xint] = ACTIONS(4238),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4238),
    [anon_sym_POUNDload] = ACTIONS(4238),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4238),
    [sym__newline] = ACTIONS(4238),
  },
  [1465] = {
    [sym_block_comment] = STATE(1465),
    [sym_compiler_directive_decl] = STATE(1465),
    [sym_fsi_directive_decl] = STATE(1465),
    [sym_preproc_line] = STATE(1465),
    [ts_builtin_sym_end] = ACTIONS(4242),
    [sym_identifier] = ACTIONS(4244),
    [anon_sym_namespace] = ACTIONS(4244),
    [anon_sym_module] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4242),
    [anon_sym_open] = ACTIONS(4244),
    [anon_sym_LBRACK_LT] = ACTIONS(4242),
    [anon_sym_COLON] = ACTIONS(4244),
    [anon_sym_return] = ACTIONS(4244),
    [anon_sym_type] = ACTIONS(4244),
    [anon_sym_do] = ACTIONS(4244),
    [anon_sym_and] = ACTIONS(4244),
    [anon_sym_let] = ACTIONS(4244),
    [anon_sym_let_BANG] = ACTIONS(4242),
    [aux_sym_access_modifier_token1] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_null] = ACTIONS(4244),
    [anon_sym_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_COLON] = ACTIONS(4242),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4244),
    [anon_sym_LT_AT] = ACTIONS(4244),
    [anon_sym_LT_AT_AT] = ACTIONS(4244),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4242),
    [anon_sym_new] = ACTIONS(4244),
    [anon_sym_with] = ACTIONS(4244),
    [anon_sym_return_BANG] = ACTIONS(4242),
    [anon_sym_yield] = ACTIONS(4244),
    [anon_sym_yield_BANG] = ACTIONS(4242),
    [anon_sym_lazy] = ACTIONS(4244),
    [anon_sym_assert] = ACTIONS(4244),
    [anon_sym_upcast] = ACTIONS(4244),
    [anon_sym_downcast] = ACTIONS(4244),
    [anon_sym_COLON_GT] = ACTIONS(4242),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4242),
    [anon_sym_for] = ACTIONS(4244),
    [anon_sym_while] = ACTIONS(4244),
    [anon_sym_if] = ACTIONS(4244),
    [anon_sym_fun] = ACTIONS(4244),
    [anon_sym_try] = ACTIONS(4244),
    [anon_sym_match] = ACTIONS(4244),
    [anon_sym_match_BANG] = ACTIONS(4242),
    [anon_sym_function] = ACTIONS(4244),
    [anon_sym_LT_DASH] = ACTIONS(4244),
    [anon_sym_DOT_LBRACK] = ACTIONS(4242),
    [anon_sym_LT] = ACTIONS(4242),
    [anon_sym_use] = ACTIONS(4244),
    [anon_sym_use_BANG] = ACTIONS(4242),
    [anon_sym_do_BANG] = ACTIONS(4242),
    [anon_sym_begin] = ACTIONS(4244),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_default] = ACTIONS(4244),
    [anon_sym_or] = ACTIONS(4244),
    [anon_sym_static] = ACTIONS(4244),
    [anon_sym_member] = ACTIONS(4244),
    [anon_sym_interface] = ACTIONS(4244),
    [anon_sym_exception] = ACTIONS(4244),
    [anon_sym_abstract] = ACTIONS(4244),
    [anon_sym_val] = ACTIONS(4244),
    [anon_sym_override] = ACTIONS(4244),
    [aux_sym_char_token1] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4244),
    [anon_sym_DQUOTE] = ACTIONS(4244),
    [anon_sym_AT_DQUOTE] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [sym_bool] = ACTIONS(4244),
    [sym_unit] = ACTIONS(4242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4244),
    [sym_op_identifier] = ACTIONS(4244),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_DASH] = ACTIONS(4244),
    [anon_sym_PLUS_DOT] = ACTIONS(4244),
    [anon_sym_DASH_DOT] = ACTIONS(4244),
    [anon_sym_PERCENT] = ACTIONS(4244),
    [anon_sym_AMP_AMP] = ACTIONS(4244),
    [anon_sym_TILDE] = ACTIONS(4242),
    [aux_sym_prefix_op_token1] = ACTIONS(4244),
    [aux_sym_infix_op_token1] = ACTIONS(4242),
    [aux_sym_infix_op_token2] = ACTIONS(4244),
    [anon_sym_PIPE_PIPE] = ACTIONS(4244),
    [anon_sym_BANG_EQ] = ACTIONS(4244),
    [anon_sym_COLON_EQ] = ACTIONS(4242),
    [anon_sym_DOLLAR] = ACTIONS(4244),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4244),
    [sym_int] = ACTIONS(4244),
    [sym_xint] = ACTIONS(4242),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4242),
    [anon_sym_POUNDload] = ACTIONS(4242),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4242),
    [sym__newline] = ACTIONS(4242),
  },
  [1466] = {
    [sym_block_comment] = STATE(1466),
    [sym_compiler_directive_decl] = STATE(1466),
    [sym_fsi_directive_decl] = STATE(1466),
    [sym_preproc_line] = STATE(1466),
    [aux_sym_long_identifier_repeat1] = STATE(1391),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_EQ] = ACTIONS(3492),
    [anon_sym_LBRACK_LT] = ACTIONS(3492),
    [anon_sym_COLON] = ACTIONS(3494),
    [anon_sym_return] = ACTIONS(3494),
    [anon_sym_do] = ACTIONS(3494),
    [anon_sym_and] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_let_BANG] = ACTIONS(3492),
    [aux_sym_access_modifier_token1] = ACTIONS(3492),
    [anon_sym_LPAREN] = ACTIONS(3494),
    [anon_sym_COMMA] = ACTIONS(3492),
    [anon_sym_null] = ACTIONS(3494),
    [anon_sym_QMARK] = ACTIONS(3494),
    [anon_sym_COLON_QMARK] = ACTIONS(3494),
    [anon_sym_COLON_COLON] = ACTIONS(3492),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3492),
    [anon_sym_LBRACE] = ACTIONS(3494),
    [anon_sym_LT_AT] = ACTIONS(3494),
    [anon_sym_LT_AT_AT] = ACTIONS(3494),
    [anon_sym_DOT] = ACTIONS(4066),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3492),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_with] = ACTIONS(3494),
    [anon_sym_return_BANG] = ACTIONS(3492),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_yield_BANG] = ACTIONS(3492),
    [anon_sym_lazy] = ACTIONS(3494),
    [anon_sym_assert] = ACTIONS(3494),
    [anon_sym_upcast] = ACTIONS(3494),
    [anon_sym_downcast] = ACTIONS(3494),
    [anon_sym_COLON_GT] = ACTIONS(3492),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3492),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_while] = ACTIONS(3494),
    [anon_sym_if] = ACTIONS(3494),
    [anon_sym_fun] = ACTIONS(3494),
    [anon_sym_DASH_GT] = ACTIONS(3494),
    [anon_sym_try] = ACTIONS(3494),
    [anon_sym_match] = ACTIONS(3494),
    [anon_sym_match_BANG] = ACTIONS(3492),
    [anon_sym_function] = ACTIONS(3494),
    [anon_sym_LT_DASH] = ACTIONS(3494),
    [anon_sym_DOT_LBRACK] = ACTIONS(3492),
    [anon_sym_LT] = ACTIONS(3492),
    [anon_sym_use] = ACTIONS(3494),
    [anon_sym_use_BANG] = ACTIONS(3492),
    [anon_sym_do_BANG] = ACTIONS(3492),
    [anon_sym_begin] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(3494),
    [anon_sym_STAR] = ACTIONS(3494),
    [anon_sym_LT2] = ACTIONS(3494),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3492),
    [anon_sym_default] = ACTIONS(3494),
    [anon_sym_or] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_member] = ACTIONS(3494),
    [anon_sym_interface] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_val] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [aux_sym_char_token1] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3494),
    [anon_sym_DQUOTE] = ACTIONS(3494),
    [anon_sym_AT_DQUOTE] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [sym_bool] = ACTIONS(3494),
    [sym_unit] = ACTIONS(3492),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3494),
    [sym_op_identifier] = ACTIONS(3494),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_PLUS_DOT] = ACTIONS(3494),
    [anon_sym_DASH_DOT] = ACTIONS(3494),
    [anon_sym_PERCENT] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_TILDE] = ACTIONS(3492),
    [aux_sym_prefix_op_token1] = ACTIONS(3494),
    [aux_sym_infix_op_token1] = ACTIONS(3492),
    [aux_sym_infix_op_token2] = ACTIONS(3494),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_COLON_EQ] = ACTIONS(3492),
    [anon_sym_DOLLAR] = ACTIONS(3494),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3494),
    [sym_int] = ACTIONS(3494),
    [sym_xint] = ACTIONS(3492),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3492),
    [anon_sym_POUNDendif] = ACTIONS(3492),
    [sym__newline] = ACTIONS(3492),
  },
  [1467] = {
    [sym__else_expression] = STATE(1997),
    [sym_elif_expression] = STATE(1651),
    [sym_block_comment] = STATE(1467),
    [sym_compiler_directive_decl] = STATE(1467),
    [sym_fsi_directive_decl] = STATE(1467),
    [sym_preproc_line] = STATE(1467),
    [aux_sym_if_expression_repeat1] = STATE(1437),
    [sym_identifier] = ACTIONS(3472),
    [anon_sym_EQ] = ACTIONS(3470),
    [anon_sym_LBRACK_LT] = ACTIONS(3470),
    [anon_sym_COLON] = ACTIONS(3472),
    [anon_sym_return] = ACTIONS(3472),
    [anon_sym_do] = ACTIONS(3472),
    [anon_sym_and] = ACTIONS(3472),
    [anon_sym_let] = ACTIONS(3472),
    [anon_sym_let_BANG] = ACTIONS(3470),
    [aux_sym_access_modifier_token1] = ACTIONS(3470),
    [anon_sym_LPAREN] = ACTIONS(3472),
    [anon_sym_COMMA] = ACTIONS(3470),
    [anon_sym_null] = ACTIONS(3472),
    [anon_sym_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_COLON] = ACTIONS(3470),
    [anon_sym_AMP] = ACTIONS(3472),
    [anon_sym_LBRACK] = ACTIONS(3472),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3470),
    [anon_sym_LBRACE] = ACTIONS(3472),
    [anon_sym_LT_AT] = ACTIONS(3472),
    [anon_sym_LT_AT_AT] = ACTIONS(3472),
    [anon_sym_DOT] = ACTIONS(3472),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3470),
    [anon_sym_new] = ACTIONS(3472),
    [anon_sym_with] = ACTIONS(3472),
    [anon_sym_return_BANG] = ACTIONS(3470),
    [anon_sym_yield] = ACTIONS(3472),
    [anon_sym_yield_BANG] = ACTIONS(3470),
    [anon_sym_lazy] = ACTIONS(3472),
    [anon_sym_assert] = ACTIONS(3472),
    [anon_sym_upcast] = ACTIONS(3472),
    [anon_sym_downcast] = ACTIONS(3472),
    [anon_sym_COLON_GT] = ACTIONS(3470),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3470),
    [anon_sym_for] = ACTIONS(3472),
    [anon_sym_while] = ACTIONS(3472),
    [anon_sym_else] = ACTIONS(4164),
    [anon_sym_elif] = ACTIONS(4166),
    [anon_sym_if] = ACTIONS(3472),
    [anon_sym_fun] = ACTIONS(3472),
    [anon_sym_try] = ACTIONS(3472),
    [anon_sym_match] = ACTIONS(3472),
    [anon_sym_match_BANG] = ACTIONS(3470),
    [anon_sym_function] = ACTIONS(3472),
    [anon_sym_LT_DASH] = ACTIONS(3472),
    [anon_sym_DOT_LBRACK] = ACTIONS(3470),
    [anon_sym_LT] = ACTIONS(3470),
    [anon_sym_use] = ACTIONS(3472),
    [anon_sym_use_BANG] = ACTIONS(3470),
    [anon_sym_do_BANG] = ACTIONS(3470),
    [anon_sym_begin] = ACTIONS(3472),
    [anon_sym_LPAREN2] = ACTIONS(3472),
    [anon_sym_default] = ACTIONS(3472),
    [anon_sym_or] = ACTIONS(3472),
    [anon_sym_static] = ACTIONS(3472),
    [anon_sym_member] = ACTIONS(3472),
    [anon_sym_interface] = ACTIONS(3472),
    [anon_sym_abstract] = ACTIONS(3472),
    [anon_sym_val] = ACTIONS(3472),
    [anon_sym_override] = ACTIONS(3472),
    [aux_sym_char_token1] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3472),
    [anon_sym_DQUOTE] = ACTIONS(3472),
    [anon_sym_AT_DQUOTE] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [sym_bool] = ACTIONS(3472),
    [sym_unit] = ACTIONS(3470),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3472),
    [sym_op_identifier] = ACTIONS(3472),
    [anon_sym_PLUS] = ACTIONS(3472),
    [anon_sym_DASH] = ACTIONS(3472),
    [anon_sym_PLUS_DOT] = ACTIONS(3472),
    [anon_sym_DASH_DOT] = ACTIONS(3472),
    [anon_sym_PERCENT] = ACTIONS(3472),
    [anon_sym_AMP_AMP] = ACTIONS(3472),
    [anon_sym_TILDE] = ACTIONS(3470),
    [aux_sym_prefix_op_token1] = ACTIONS(3472),
    [aux_sym_infix_op_token1] = ACTIONS(3470),
    [aux_sym_infix_op_token2] = ACTIONS(3472),
    [anon_sym_PIPE_PIPE] = ACTIONS(3472),
    [anon_sym_BANG_EQ] = ACTIONS(3472),
    [anon_sym_COLON_EQ] = ACTIONS(3470),
    [anon_sym_DOLLAR] = ACTIONS(3472),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3472),
    [sym_int] = ACTIONS(3472),
    [sym_xint] = ACTIONS(3470),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3470),
    [anon_sym_POUNDendif] = ACTIONS(3470),
    [sym__newline] = ACTIONS(3470),
  },
  [1468] = {
    [sym_block_comment] = STATE(1468),
    [sym_compiler_directive_decl] = STATE(1468),
    [sym_fsi_directive_decl] = STATE(1468),
    [sym_preproc_line] = STATE(1468),
    [ts_builtin_sym_end] = ACTIONS(4246),
    [sym_identifier] = ACTIONS(4248),
    [anon_sym_namespace] = ACTIONS(4248),
    [anon_sym_module] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4246),
    [anon_sym_open] = ACTIONS(4248),
    [anon_sym_LBRACK_LT] = ACTIONS(4246),
    [anon_sym_COLON] = ACTIONS(4248),
    [anon_sym_return] = ACTIONS(4248),
    [anon_sym_type] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4248),
    [anon_sym_and] = ACTIONS(4248),
    [anon_sym_let] = ACTIONS(4248),
    [anon_sym_let_BANG] = ACTIONS(4246),
    [aux_sym_access_modifier_token1] = ACTIONS(4246),
    [anon_sym_LPAREN] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_null] = ACTIONS(4248),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4248),
    [anon_sym_LT_AT] = ACTIONS(4248),
    [anon_sym_LT_AT_AT] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4246),
    [anon_sym_new] = ACTIONS(4248),
    [anon_sym_with] = ACTIONS(4248),
    [anon_sym_return_BANG] = ACTIONS(4246),
    [anon_sym_yield] = ACTIONS(4248),
    [anon_sym_yield_BANG] = ACTIONS(4246),
    [anon_sym_lazy] = ACTIONS(4248),
    [anon_sym_assert] = ACTIONS(4248),
    [anon_sym_upcast] = ACTIONS(4248),
    [anon_sym_downcast] = ACTIONS(4248),
    [anon_sym_COLON_GT] = ACTIONS(4246),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4246),
    [anon_sym_for] = ACTIONS(4248),
    [anon_sym_while] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4248),
    [anon_sym_fun] = ACTIONS(4248),
    [anon_sym_try] = ACTIONS(4248),
    [anon_sym_match] = ACTIONS(4248),
    [anon_sym_match_BANG] = ACTIONS(4246),
    [anon_sym_function] = ACTIONS(4248),
    [anon_sym_LT_DASH] = ACTIONS(4248),
    [anon_sym_DOT_LBRACK] = ACTIONS(4246),
    [anon_sym_LT] = ACTIONS(4246),
    [anon_sym_use] = ACTIONS(4248),
    [anon_sym_use_BANG] = ACTIONS(4246),
    [anon_sym_do_BANG] = ACTIONS(4246),
    [anon_sym_begin] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_default] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4248),
    [anon_sym_static] = ACTIONS(4248),
    [anon_sym_member] = ACTIONS(4248),
    [anon_sym_interface] = ACTIONS(4248),
    [anon_sym_exception] = ACTIONS(4248),
    [anon_sym_abstract] = ACTIONS(4248),
    [anon_sym_val] = ACTIONS(4248),
    [anon_sym_override] = ACTIONS(4248),
    [aux_sym_char_token1] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4248),
    [anon_sym_DQUOTE] = ACTIONS(4248),
    [anon_sym_AT_DQUOTE] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [sym_bool] = ACTIONS(4248),
    [sym_unit] = ACTIONS(4246),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4248),
    [sym_op_identifier] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_DOT] = ACTIONS(4248),
    [anon_sym_DASH_DOT] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_TILDE] = ACTIONS(4246),
    [aux_sym_prefix_op_token1] = ACTIONS(4248),
    [aux_sym_infix_op_token1] = ACTIONS(4246),
    [aux_sym_infix_op_token2] = ACTIONS(4248),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_COLON_EQ] = ACTIONS(4246),
    [anon_sym_DOLLAR] = ACTIONS(4248),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4248),
    [sym_int] = ACTIONS(4248),
    [sym_xint] = ACTIONS(4246),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4246),
    [anon_sym_POUNDload] = ACTIONS(4246),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4246),
    [sym__newline] = ACTIONS(4246),
  },
  [1469] = {
    [sym_block_comment] = STATE(1469),
    [sym_compiler_directive_decl] = STATE(1469),
    [sym_fsi_directive_decl] = STATE(1469),
    [sym_preproc_line] = STATE(1469),
    [ts_builtin_sym_end] = ACTIONS(4226),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_namespace] = ACTIONS(4228),
    [anon_sym_module] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_open] = ACTIONS(4228),
    [anon_sym_LBRACK_LT] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_type] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_and] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [aux_sym_access_modifier_token1] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4250),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_with] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_default] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [anon_sym_static] = ACTIONS(4228),
    [anon_sym_member] = ACTIONS(4228),
    [anon_sym_interface] = ACTIONS(4228),
    [anon_sym_exception] = ACTIONS(4228),
    [anon_sym_abstract] = ACTIONS(4228),
    [anon_sym_val] = ACTIONS(4228),
    [anon_sym_override] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4226),
    [anon_sym_POUNDload] = ACTIONS(4226),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
  },
  [1470] = {
    [sym__else_expression] = STATE(2158),
    [sym_elif_expression] = STATE(1675),
    [sym_block_comment] = STATE(1470),
    [sym_compiler_directive_decl] = STATE(1470),
    [sym_fsi_directive_decl] = STATE(1470),
    [sym_preproc_line] = STATE(1470),
    [aux_sym_if_expression_repeat1] = STATE(1480),
    [sym_identifier] = ACTIONS(3457),
    [anon_sym_EQ] = ACTIONS(3455),
    [anon_sym_LBRACK_LT] = ACTIONS(3455),
    [anon_sym_COLON] = ACTIONS(3457),
    [anon_sym_return] = ACTIONS(3457),
    [anon_sym_do] = ACTIONS(3457),
    [anon_sym_let] = ACTIONS(3457),
    [anon_sym_let_BANG] = ACTIONS(3455),
    [aux_sym_access_modifier_token1] = ACTIONS(3455),
    [anon_sym_LPAREN] = ACTIONS(3457),
    [anon_sym_COMMA] = ACTIONS(3455),
    [anon_sym_null] = ACTIONS(3457),
    [anon_sym_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_COLON] = ACTIONS(3455),
    [anon_sym_AMP] = ACTIONS(3457),
    [anon_sym_LBRACK] = ACTIONS(3457),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3457),
    [anon_sym_LT_AT] = ACTIONS(3457),
    [anon_sym_LT_AT_AT] = ACTIONS(3457),
    [anon_sym_DOT] = ACTIONS(3457),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3457),
    [anon_sym_with] = ACTIONS(3457),
    [anon_sym_return_BANG] = ACTIONS(3455),
    [anon_sym_yield] = ACTIONS(3457),
    [anon_sym_yield_BANG] = ACTIONS(3455),
    [anon_sym_lazy] = ACTIONS(3457),
    [anon_sym_assert] = ACTIONS(3457),
    [anon_sym_upcast] = ACTIONS(3457),
    [anon_sym_downcast] = ACTIONS(3457),
    [anon_sym_COLON_GT] = ACTIONS(3455),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3457),
    [anon_sym_while] = ACTIONS(3457),
    [anon_sym_else] = ACTIONS(3869),
    [anon_sym_elif] = ACTIONS(3871),
    [anon_sym_if] = ACTIONS(3457),
    [anon_sym_fun] = ACTIONS(3457),
    [anon_sym_try] = ACTIONS(3457),
    [anon_sym_match] = ACTIONS(3457),
    [anon_sym_match_BANG] = ACTIONS(3455),
    [anon_sym_function] = ACTIONS(3457),
    [anon_sym_LT_DASH] = ACTIONS(3457),
    [anon_sym_DOT_LBRACK] = ACTIONS(3455),
    [anon_sym_LT] = ACTIONS(3455),
    [anon_sym_use] = ACTIONS(3457),
    [anon_sym_use_BANG] = ACTIONS(3455),
    [anon_sym_do_BANG] = ACTIONS(3455),
    [anon_sym_begin] = ACTIONS(3457),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_default] = ACTIONS(3457),
    [anon_sym_or] = ACTIONS(3457),
    [anon_sym_static] = ACTIONS(3457),
    [anon_sym_member] = ACTIONS(3457),
    [anon_sym_interface] = ACTIONS(3457),
    [anon_sym_abstract] = ACTIONS(3457),
    [anon_sym_val] = ACTIONS(3457),
    [anon_sym_override] = ACTIONS(3457),
    [anon_sym_inherit] = ACTIONS(3457),
    [aux_sym_char_token1] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [anon_sym_AT_DQUOTE] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [sym_bool] = ACTIONS(3457),
    [sym_unit] = ACTIONS(3455),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3457),
    [sym_op_identifier] = ACTIONS(3457),
    [anon_sym_PLUS] = ACTIONS(3457),
    [anon_sym_DASH] = ACTIONS(3457),
    [anon_sym_PLUS_DOT] = ACTIONS(3457),
    [anon_sym_DASH_DOT] = ACTIONS(3457),
    [anon_sym_PERCENT] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3455),
    [aux_sym_prefix_op_token1] = ACTIONS(3457),
    [aux_sym_infix_op_token1] = ACTIONS(3455),
    [aux_sym_infix_op_token2] = ACTIONS(3457),
    [anon_sym_PIPE_PIPE] = ACTIONS(3457),
    [anon_sym_BANG_EQ] = ACTIONS(3457),
    [anon_sym_COLON_EQ] = ACTIONS(3455),
    [anon_sym_DOLLAR] = ACTIONS(3457),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3457),
    [sym_int] = ACTIONS(3457),
    [sym_xint] = ACTIONS(3455),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3455),
    [anon_sym_POUNDendif] = ACTIONS(3455),
    [sym__newline] = ACTIONS(3455),
  },
  [1471] = {
    [sym_block_comment] = STATE(1471),
    [sym_compiler_directive_decl] = STATE(1471),
    [sym_fsi_directive_decl] = STATE(1471),
    [sym_preproc_line] = STATE(1471),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_EQ] = ACTIONS(3560),
    [anon_sym_LBRACK_LT] = ACTIONS(3560),
    [anon_sym_COLON] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_let_BANG] = ACTIONS(3560),
    [aux_sym_access_modifier_token1] = ACTIONS(3560),
    [anon_sym_LPAREN] = ACTIONS(3562),
    [anon_sym_COMMA] = ACTIONS(3560),
    [anon_sym_null] = ACTIONS(3562),
    [anon_sym_QMARK] = ACTIONS(3562),
    [anon_sym_COLON_QMARK] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3560),
    [anon_sym_LBRACE] = ACTIONS(3562),
    [anon_sym_LT_AT] = ACTIONS(3562),
    [anon_sym_LT_AT_AT] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(3562),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3560),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_with] = ACTIONS(3562),
    [anon_sym_return_BANG] = ACTIONS(3560),
    [anon_sym_yield] = ACTIONS(3562),
    [anon_sym_yield_BANG] = ACTIONS(3560),
    [anon_sym_lazy] = ACTIONS(3562),
    [anon_sym_assert] = ACTIONS(3562),
    [anon_sym_upcast] = ACTIONS(3562),
    [anon_sym_downcast] = ACTIONS(3562),
    [anon_sym_COLON_GT] = ACTIONS(3560),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3560),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_fun] = ACTIONS(3562),
    [anon_sym_DASH_GT] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_match] = ACTIONS(3562),
    [anon_sym_match_BANG] = ACTIONS(3560),
    [anon_sym_function] = ACTIONS(3562),
    [anon_sym_LT_DASH] = ACTIONS(3562),
    [anon_sym_DOT_LBRACK] = ACTIONS(3560),
    [anon_sym_LT] = ACTIONS(3560),
    [anon_sym_use] = ACTIONS(3562),
    [anon_sym_use_BANG] = ACTIONS(3560),
    [anon_sym_do_BANG] = ACTIONS(3560),
    [anon_sym_begin] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3562),
    [anon_sym_DOT_DOT2] = ACTIONS(3560),
    [anon_sym_STAR] = ACTIONS(3562),
    [anon_sym_LT2] = ACTIONS(3562),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3560),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_or] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_member] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_abstract] = ACTIONS(3562),
    [anon_sym_val] = ACTIONS(3562),
    [anon_sym_override] = ACTIONS(3562),
    [aux_sym_char_token1] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(3562),
    [anon_sym_AT_DQUOTE] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [sym_bool] = ACTIONS(3562),
    [sym_unit] = ACTIONS(3560),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3562),
    [sym_op_identifier] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS_DOT] = ACTIONS(3562),
    [anon_sym_DASH_DOT] = ACTIONS(3562),
    [anon_sym_PERCENT] = ACTIONS(3562),
    [anon_sym_AMP_AMP] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3560),
    [aux_sym_prefix_op_token1] = ACTIONS(3562),
    [aux_sym_infix_op_token1] = ACTIONS(3560),
    [aux_sym_infix_op_token2] = ACTIONS(3562),
    [anon_sym_PIPE_PIPE] = ACTIONS(3562),
    [anon_sym_BANG_EQ] = ACTIONS(3562),
    [anon_sym_COLON_EQ] = ACTIONS(3560),
    [anon_sym_DOLLAR] = ACTIONS(3562),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3562),
    [sym_int] = ACTIONS(3562),
    [sym_xint] = ACTIONS(3560),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3560),
    [sym__newline] = ACTIONS(3560),
    [sym__dedent] = ACTIONS(3560),
  },
  [1472] = {
    [sym_block_comment] = STATE(1472),
    [sym_compiler_directive_decl] = STATE(1472),
    [sym_fsi_directive_decl] = STATE(1472),
    [sym_preproc_line] = STATE(1472),
    [sym_identifier] = ACTIONS(3551),
    [anon_sym_EQ] = ACTIONS(3549),
    [anon_sym_LBRACK_LT] = ACTIONS(3549),
    [anon_sym_COLON] = ACTIONS(3551),
    [anon_sym_return] = ACTIONS(3551),
    [anon_sym_do] = ACTIONS(3551),
    [anon_sym_let] = ACTIONS(3551),
    [anon_sym_let_BANG] = ACTIONS(3549),
    [aux_sym_access_modifier_token1] = ACTIONS(3549),
    [anon_sym_LPAREN] = ACTIONS(3551),
    [anon_sym_COMMA] = ACTIONS(3549),
    [anon_sym_null] = ACTIONS(3551),
    [anon_sym_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_COLON] = ACTIONS(3549),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(3551),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3549),
    [anon_sym_LBRACE] = ACTIONS(3551),
    [anon_sym_LT_AT] = ACTIONS(3551),
    [anon_sym_LT_AT_AT] = ACTIONS(3551),
    [anon_sym_DOT] = ACTIONS(3551),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3549),
    [anon_sym_new] = ACTIONS(3551),
    [anon_sym_with] = ACTIONS(3551),
    [anon_sym_return_BANG] = ACTIONS(3549),
    [anon_sym_yield] = ACTIONS(3551),
    [anon_sym_yield_BANG] = ACTIONS(3549),
    [anon_sym_lazy] = ACTIONS(3551),
    [anon_sym_assert] = ACTIONS(3551),
    [anon_sym_upcast] = ACTIONS(3551),
    [anon_sym_downcast] = ACTIONS(3551),
    [anon_sym_COLON_GT] = ACTIONS(3549),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3549),
    [anon_sym_for] = ACTIONS(3551),
    [anon_sym_while] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(3551),
    [anon_sym_fun] = ACTIONS(3551),
    [anon_sym_DASH_GT] = ACTIONS(3551),
    [anon_sym_try] = ACTIONS(3551),
    [anon_sym_match] = ACTIONS(3551),
    [anon_sym_match_BANG] = ACTIONS(3549),
    [anon_sym_function] = ACTIONS(3551),
    [anon_sym_LT_DASH] = ACTIONS(3551),
    [anon_sym_DOT_LBRACK] = ACTIONS(3549),
    [anon_sym_LT] = ACTIONS(3549),
    [anon_sym_use] = ACTIONS(3551),
    [anon_sym_use_BANG] = ACTIONS(3549),
    [anon_sym_do_BANG] = ACTIONS(3549),
    [anon_sym_begin] = ACTIONS(3551),
    [anon_sym_LPAREN2] = ACTIONS(3551),
    [anon_sym_STAR] = ACTIONS(3551),
    [anon_sym_LT2] = ACTIONS(3551),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3549),
    [anon_sym_default] = ACTIONS(3551),
    [anon_sym_or] = ACTIONS(3551),
    [anon_sym_static] = ACTIONS(3551),
    [anon_sym_member] = ACTIONS(3551),
    [anon_sym_interface] = ACTIONS(3551),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_val] = ACTIONS(3551),
    [anon_sym_override] = ACTIONS(3551),
    [anon_sym_inherit] = ACTIONS(3551),
    [aux_sym_char_token1] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [anon_sym_AT_DQUOTE] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [sym_bool] = ACTIONS(3551),
    [sym_unit] = ACTIONS(3549),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3551),
    [sym_op_identifier] = ACTIONS(3551),
    [anon_sym_PLUS] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(3551),
    [anon_sym_PLUS_DOT] = ACTIONS(3551),
    [anon_sym_DASH_DOT] = ACTIONS(3551),
    [anon_sym_PERCENT] = ACTIONS(3551),
    [anon_sym_AMP_AMP] = ACTIONS(3551),
    [anon_sym_TILDE] = ACTIONS(3549),
    [aux_sym_prefix_op_token1] = ACTIONS(3551),
    [aux_sym_infix_op_token1] = ACTIONS(3549),
    [aux_sym_infix_op_token2] = ACTIONS(3551),
    [anon_sym_PIPE_PIPE] = ACTIONS(3551),
    [anon_sym_BANG_EQ] = ACTIONS(3551),
    [anon_sym_COLON_EQ] = ACTIONS(3549),
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3551),
    [sym_int] = ACTIONS(3551),
    [sym_xint] = ACTIONS(3549),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3549),
    [anon_sym_POUNDendif] = ACTIONS(3549),
    [sym__newline] = ACTIONS(3549),
  },
  [1473] = {
    [sym_block_comment] = STATE(1473),
    [sym_compiler_directive_decl] = STATE(1473),
    [sym_fsi_directive_decl] = STATE(1473),
    [sym_preproc_line] = STATE(1473),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_RBRACK] = ACTIONS(3191),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_DOT_DOT2] = ACTIONS(3191),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3618),
    [anon_sym_uy] = ACTIONS(3620),
    [anon_sym_s] = ACTIONS(3622),
    [anon_sym_us] = ACTIONS(3624),
    [anon_sym_l] = ACTIONS(3626),
    [aux_sym_uint32_token1] = ACTIONS(3628),
    [anon_sym_n] = ACTIONS(3630),
    [anon_sym_un] = ACTIONS(3632),
    [anon_sym_L] = ACTIONS(3634),
    [aux_sym_uint64_token1] = ACTIONS(3636),
    [aux_sym_bignum_token1] = ACTIONS(3638),
    [aux_sym_decimal_token1] = ACTIONS(3640),
    [anon_sym_DOT2] = ACTIONS(3642),
    [aux_sym_float_token1] = ACTIONS(3644),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1474] = {
    [sym_block_comment] = STATE(1474),
    [sym_compiler_directive_decl] = STATE(1474),
    [sym_fsi_directive_decl] = STATE(1474),
    [sym_preproc_line] = STATE(1474),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_LBRACK_LT] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [aux_sym_access_modifier_token1] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_with] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_default] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [anon_sym_static] = ACTIONS(3604),
    [anon_sym_member] = ACTIONS(3604),
    [anon_sym_interface] = ACTIONS(3604),
    [anon_sym_abstract] = ACTIONS(3604),
    [anon_sym_val] = ACTIONS(3604),
    [anon_sym_override] = ACTIONS(3604),
    [anon_sym_inherit] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [aux_sym_float_token1] = ACTIONS(4252),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [anon_sym_POUNDendif] = ACTIONS(3602),
    [anon_sym_POUNDelse] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
  },
  [1475] = {
    [sym_block_comment] = STATE(1475),
    [sym_compiler_directive_decl] = STATE(1475),
    [sym_fsi_directive_decl] = STATE(1475),
    [sym_preproc_line] = STATE(1475),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3525),
    [anon_sym_LBRACK_LT] = ACTIONS(3525),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_and] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [aux_sym_access_modifier_token1] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_COLON] = ACTIONS(3525),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_with] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_COLON_GT] = ACTIONS(3525),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_DASH_GT] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_LT_DASH] = ACTIONS(3527),
    [anon_sym_DOT_LBRACK] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_LPAREN2] = ACTIONS(3527),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_LT2] = ACTIONS(3527),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_default] = ACTIONS(3527),
    [anon_sym_or] = ACTIONS(3527),
    [anon_sym_static] = ACTIONS(3527),
    [anon_sym_member] = ACTIONS(3527),
    [anon_sym_interface] = ACTIONS(3527),
    [anon_sym_abstract] = ACTIONS(3527),
    [anon_sym_val] = ACTIONS(3527),
    [anon_sym_override] = ACTIONS(3527),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3525),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3527),
    [anon_sym_DASH_DOT] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3527),
    [aux_sym_infix_op_token1] = ACTIONS(3525),
    [aux_sym_infix_op_token2] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_COLON_EQ] = ACTIONS(3525),
    [anon_sym_DOLLAR] = ACTIONS(3527),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3527),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3525),
    [sym__newline] = ACTIONS(3525),
    [sym__dedent] = ACTIONS(3525),
  },
  [1476] = {
    [sym_block_comment] = STATE(1476),
    [sym_compiler_directive_decl] = STATE(1476),
    [sym_fsi_directive_decl] = STATE(1476),
    [sym_preproc_line] = STATE(1476),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3525),
    [anon_sym_LBRACK_LT] = ACTIONS(3525),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_and] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [aux_sym_access_modifier_token1] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_COLON] = ACTIONS(3525),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_with] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_COLON_GT] = ACTIONS(3525),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_DASH_GT] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_LT_DASH] = ACTIONS(3527),
    [anon_sym_DOT_LBRACK] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_LPAREN2] = ACTIONS(3527),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_LT2] = ACTIONS(3527),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_default] = ACTIONS(3527),
    [anon_sym_or] = ACTIONS(3527),
    [anon_sym_static] = ACTIONS(3527),
    [anon_sym_member] = ACTIONS(3527),
    [anon_sym_interface] = ACTIONS(3527),
    [anon_sym_abstract] = ACTIONS(3527),
    [anon_sym_val] = ACTIONS(3527),
    [anon_sym_override] = ACTIONS(3527),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3525),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3527),
    [anon_sym_DASH_DOT] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3527),
    [aux_sym_infix_op_token1] = ACTIONS(3525),
    [aux_sym_infix_op_token2] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_COLON_EQ] = ACTIONS(3525),
    [anon_sym_DOLLAR] = ACTIONS(3527),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3527),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3525),
    [anon_sym_POUNDendif] = ACTIONS(3525),
    [sym__newline] = ACTIONS(3525),
  },
  [1477] = {
    [sym_block_comment] = STATE(1477),
    [sym_compiler_directive_decl] = STATE(1477),
    [sym_fsi_directive_decl] = STATE(1477),
    [sym_preproc_line] = STATE(1477),
    [sym_identifier] = ACTIONS(3531),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_LBRACK_LT] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(3531),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_do] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [aux_sym_access_modifier_token1] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_null] = ACTIONS(3531),
    [anon_sym_QMARK] = ACTIONS(3531),
    [anon_sym_COLON_QMARK] = ACTIONS(3531),
    [anon_sym_COLON_COLON] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3531),
    [anon_sym_LT_AT] = ACTIONS(3531),
    [anon_sym_LT_AT_AT] = ACTIONS(3531),
    [anon_sym_DOT] = ACTIONS(3531),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3531),
    [anon_sym_with] = ACTIONS(3531),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3531),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3531),
    [anon_sym_assert] = ACTIONS(3531),
    [anon_sym_upcast] = ACTIONS(3531),
    [anon_sym_downcast] = ACTIONS(3531),
    [anon_sym_COLON_GT] = ACTIONS(3529),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3531),
    [anon_sym_while] = ACTIONS(3531),
    [anon_sym_if] = ACTIONS(3531),
    [anon_sym_fun] = ACTIONS(3531),
    [anon_sym_DASH_GT] = ACTIONS(3531),
    [anon_sym_try] = ACTIONS(3531),
    [anon_sym_match] = ACTIONS(3531),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3531),
    [anon_sym_LT_DASH] = ACTIONS(3531),
    [anon_sym_DOT_LBRACK] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_use] = ACTIONS(3531),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3531),
    [anon_sym_LPAREN2] = ACTIONS(3531),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LT2] = ACTIONS(3531),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_default] = ACTIONS(3531),
    [anon_sym_or] = ACTIONS(3531),
    [anon_sym_static] = ACTIONS(3531),
    [anon_sym_member] = ACTIONS(3531),
    [anon_sym_interface] = ACTIONS(3531),
    [anon_sym_abstract] = ACTIONS(3531),
    [anon_sym_val] = ACTIONS(3531),
    [anon_sym_override] = ACTIONS(3531),
    [anon_sym_inherit] = ACTIONS(3531),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3531),
    [anon_sym_DQUOTE] = ACTIONS(3531),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3531),
    [sym_unit] = ACTIONS(3529),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3531),
    [sym_op_identifier] = ACTIONS(3531),
    [anon_sym_PLUS] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(3531),
    [anon_sym_PLUS_DOT] = ACTIONS(3531),
    [anon_sym_DASH_DOT] = ACTIONS(3531),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_AMP_AMP] = ACTIONS(3531),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3531),
    [aux_sym_infix_op_token1] = ACTIONS(3529),
    [aux_sym_infix_op_token2] = ACTIONS(3531),
    [anon_sym_PIPE_PIPE] = ACTIONS(3531),
    [anon_sym_BANG_EQ] = ACTIONS(3531),
    [anon_sym_COLON_EQ] = ACTIONS(3529),
    [anon_sym_DOLLAR] = ACTIONS(3531),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3531),
    [sym_int] = ACTIONS(3531),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [anon_sym_POUNDendif] = ACTIONS(3529),
    [sym__newline] = ACTIONS(3529),
  },
  [1478] = {
    [sym_block_comment] = STATE(1478),
    [sym_compiler_directive_decl] = STATE(1478),
    [sym_fsi_directive_decl] = STATE(1478),
    [sym_preproc_line] = STATE(1478),
    [sym_identifier] = ACTIONS(3531),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_LBRACK_LT] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(3531),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_do] = ACTIONS(3531),
    [anon_sym_and] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [aux_sym_access_modifier_token1] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_null] = ACTIONS(3531),
    [anon_sym_QMARK] = ACTIONS(3531),
    [anon_sym_COLON_QMARK] = ACTIONS(3531),
    [anon_sym_COLON_COLON] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3531),
    [anon_sym_LT_AT] = ACTIONS(3531),
    [anon_sym_LT_AT_AT] = ACTIONS(3531),
    [anon_sym_DOT] = ACTIONS(3531),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3531),
    [anon_sym_with] = ACTIONS(3531),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3531),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3531),
    [anon_sym_assert] = ACTIONS(3531),
    [anon_sym_upcast] = ACTIONS(3531),
    [anon_sym_downcast] = ACTIONS(3531),
    [anon_sym_COLON_GT] = ACTIONS(3529),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3531),
    [anon_sym_while] = ACTIONS(3531),
    [anon_sym_if] = ACTIONS(3531),
    [anon_sym_fun] = ACTIONS(3531),
    [anon_sym_DASH_GT] = ACTIONS(3531),
    [anon_sym_try] = ACTIONS(3531),
    [anon_sym_match] = ACTIONS(3531),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3531),
    [anon_sym_LT_DASH] = ACTIONS(3531),
    [anon_sym_DOT_LBRACK] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_use] = ACTIONS(3531),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3531),
    [anon_sym_LPAREN2] = ACTIONS(3531),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LT2] = ACTIONS(3531),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_default] = ACTIONS(3531),
    [anon_sym_or] = ACTIONS(3531),
    [anon_sym_static] = ACTIONS(3531),
    [anon_sym_member] = ACTIONS(3531),
    [anon_sym_interface] = ACTIONS(3531),
    [anon_sym_abstract] = ACTIONS(3531),
    [anon_sym_val] = ACTIONS(3531),
    [anon_sym_override] = ACTIONS(3531),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3531),
    [anon_sym_DQUOTE] = ACTIONS(3531),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3531),
    [sym_unit] = ACTIONS(3529),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3531),
    [sym_op_identifier] = ACTIONS(3531),
    [anon_sym_PLUS] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(3531),
    [anon_sym_PLUS_DOT] = ACTIONS(3531),
    [anon_sym_DASH_DOT] = ACTIONS(3531),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_AMP_AMP] = ACTIONS(3531),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3531),
    [aux_sym_infix_op_token1] = ACTIONS(3529),
    [aux_sym_infix_op_token2] = ACTIONS(3531),
    [anon_sym_PIPE_PIPE] = ACTIONS(3531),
    [anon_sym_BANG_EQ] = ACTIONS(3531),
    [anon_sym_COLON_EQ] = ACTIONS(3529),
    [anon_sym_DOLLAR] = ACTIONS(3531),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3531),
    [sym_int] = ACTIONS(3531),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [sym__newline] = ACTIONS(3529),
    [sym__dedent] = ACTIONS(3529),
  },
  [1479] = {
    [sym_block_comment] = STATE(1479),
    [sym_compiler_directive_decl] = STATE(1479),
    [sym_fsi_directive_decl] = STATE(1479),
    [sym_preproc_line] = STATE(1479),
    [sym_identifier] = ACTIONS(3535),
    [anon_sym_EQ] = ACTIONS(3533),
    [anon_sym_LBRACK_LT] = ACTIONS(3533),
    [anon_sym_COLON] = ACTIONS(3535),
    [anon_sym_return] = ACTIONS(3535),
    [anon_sym_do] = ACTIONS(3535),
    [anon_sym_and] = ACTIONS(3535),
    [anon_sym_let] = ACTIONS(3535),
    [anon_sym_let_BANG] = ACTIONS(3533),
    [aux_sym_access_modifier_token1] = ACTIONS(3533),
    [anon_sym_LPAREN] = ACTIONS(3535),
    [anon_sym_COMMA] = ACTIONS(3533),
    [anon_sym_null] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(3535),
    [anon_sym_COLON_QMARK] = ACTIONS(3535),
    [anon_sym_COLON_COLON] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3533),
    [anon_sym_LBRACE] = ACTIONS(3535),
    [anon_sym_LT_AT] = ACTIONS(3535),
    [anon_sym_LT_AT_AT] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(3535),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3533),
    [anon_sym_new] = ACTIONS(3535),
    [anon_sym_with] = ACTIONS(3535),
    [anon_sym_return_BANG] = ACTIONS(3533),
    [anon_sym_yield] = ACTIONS(3535),
    [anon_sym_yield_BANG] = ACTIONS(3533),
    [anon_sym_lazy] = ACTIONS(3535),
    [anon_sym_assert] = ACTIONS(3535),
    [anon_sym_upcast] = ACTIONS(3535),
    [anon_sym_downcast] = ACTIONS(3535),
    [anon_sym_COLON_GT] = ACTIONS(3533),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3533),
    [anon_sym_for] = ACTIONS(3535),
    [anon_sym_while] = ACTIONS(3535),
    [anon_sym_if] = ACTIONS(3535),
    [anon_sym_fun] = ACTIONS(3535),
    [anon_sym_DASH_GT] = ACTIONS(3535),
    [anon_sym_try] = ACTIONS(3535),
    [anon_sym_match] = ACTIONS(3535),
    [anon_sym_match_BANG] = ACTIONS(3533),
    [anon_sym_function] = ACTIONS(3535),
    [anon_sym_LT_DASH] = ACTIONS(3535),
    [anon_sym_DOT_LBRACK] = ACTIONS(3533),
    [anon_sym_LT] = ACTIONS(3533),
    [anon_sym_use] = ACTIONS(3535),
    [anon_sym_use_BANG] = ACTIONS(3533),
    [anon_sym_do_BANG] = ACTIONS(3533),
    [anon_sym_begin] = ACTIONS(3535),
    [anon_sym_LPAREN2] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(3535),
    [anon_sym_LT2] = ACTIONS(3535),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3533),
    [anon_sym_default] = ACTIONS(3535),
    [anon_sym_or] = ACTIONS(3535),
    [anon_sym_static] = ACTIONS(3535),
    [anon_sym_member] = ACTIONS(3535),
    [anon_sym_interface] = ACTIONS(3535),
    [anon_sym_abstract] = ACTIONS(3535),
    [anon_sym_val] = ACTIONS(3535),
    [anon_sym_override] = ACTIONS(3535),
    [aux_sym_char_token1] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE] = ACTIONS(3535),
    [anon_sym_AT_DQUOTE] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [sym_bool] = ACTIONS(3535),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3535),
    [sym_op_identifier] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS_DOT] = ACTIONS(3535),
    [anon_sym_DASH_DOT] = ACTIONS(3535),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(3535),
    [anon_sym_TILDE] = ACTIONS(3533),
    [aux_sym_prefix_op_token1] = ACTIONS(3535),
    [aux_sym_infix_op_token1] = ACTIONS(3533),
    [aux_sym_infix_op_token2] = ACTIONS(3535),
    [anon_sym_PIPE_PIPE] = ACTIONS(3535),
    [anon_sym_BANG_EQ] = ACTIONS(3535),
    [anon_sym_COLON_EQ] = ACTIONS(3533),
    [anon_sym_DOLLAR] = ACTIONS(3535),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3535),
    [sym_int] = ACTIONS(3535),
    [sym_xint] = ACTIONS(3533),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3533),
    [sym__newline] = ACTIONS(3533),
    [sym__dedent] = ACTIONS(3533),
  },
  [1480] = {
    [sym_elif_expression] = STATE(1675),
    [sym_block_comment] = STATE(1480),
    [sym_compiler_directive_decl] = STATE(1480),
    [sym_fsi_directive_decl] = STATE(1480),
    [sym_preproc_line] = STATE(1480),
    [aux_sym_if_expression_repeat1] = STATE(1480),
    [sym_identifier] = ACTIONS(3555),
    [anon_sym_EQ] = ACTIONS(3553),
    [anon_sym_LBRACK_LT] = ACTIONS(3553),
    [anon_sym_COLON] = ACTIONS(3555),
    [anon_sym_return] = ACTIONS(3555),
    [anon_sym_do] = ACTIONS(3555),
    [anon_sym_let] = ACTIONS(3555),
    [anon_sym_let_BANG] = ACTIONS(3553),
    [aux_sym_access_modifier_token1] = ACTIONS(3553),
    [anon_sym_LPAREN] = ACTIONS(3555),
    [anon_sym_COMMA] = ACTIONS(3553),
    [anon_sym_null] = ACTIONS(3555),
    [anon_sym_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_COLON] = ACTIONS(3553),
    [anon_sym_AMP] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(3555),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3553),
    [anon_sym_LBRACE] = ACTIONS(3555),
    [anon_sym_LT_AT] = ACTIONS(3555),
    [anon_sym_LT_AT_AT] = ACTIONS(3555),
    [anon_sym_DOT] = ACTIONS(3555),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3553),
    [anon_sym_new] = ACTIONS(3555),
    [anon_sym_with] = ACTIONS(3555),
    [anon_sym_return_BANG] = ACTIONS(3553),
    [anon_sym_yield] = ACTIONS(3555),
    [anon_sym_yield_BANG] = ACTIONS(3553),
    [anon_sym_lazy] = ACTIONS(3555),
    [anon_sym_assert] = ACTIONS(3555),
    [anon_sym_upcast] = ACTIONS(3555),
    [anon_sym_downcast] = ACTIONS(3555),
    [anon_sym_COLON_GT] = ACTIONS(3553),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3553),
    [anon_sym_for] = ACTIONS(3555),
    [anon_sym_while] = ACTIONS(3555),
    [anon_sym_else] = ACTIONS(3555),
    [anon_sym_elif] = ACTIONS(4254),
    [anon_sym_if] = ACTIONS(3555),
    [anon_sym_fun] = ACTIONS(3555),
    [anon_sym_try] = ACTIONS(3555),
    [anon_sym_match] = ACTIONS(3555),
    [anon_sym_match_BANG] = ACTIONS(3553),
    [anon_sym_function] = ACTIONS(3555),
    [anon_sym_LT_DASH] = ACTIONS(3555),
    [anon_sym_DOT_LBRACK] = ACTIONS(3553),
    [anon_sym_LT] = ACTIONS(3553),
    [anon_sym_use] = ACTIONS(3555),
    [anon_sym_use_BANG] = ACTIONS(3553),
    [anon_sym_do_BANG] = ACTIONS(3553),
    [anon_sym_begin] = ACTIONS(3555),
    [anon_sym_LPAREN2] = ACTIONS(3555),
    [anon_sym_default] = ACTIONS(3555),
    [anon_sym_or] = ACTIONS(3555),
    [anon_sym_static] = ACTIONS(3555),
    [anon_sym_member] = ACTIONS(3555),
    [anon_sym_interface] = ACTIONS(3555),
    [anon_sym_abstract] = ACTIONS(3555),
    [anon_sym_val] = ACTIONS(3555),
    [anon_sym_override] = ACTIONS(3555),
    [anon_sym_inherit] = ACTIONS(3555),
    [aux_sym_char_token1] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3555),
    [anon_sym_DQUOTE] = ACTIONS(3555),
    [anon_sym_AT_DQUOTE] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [sym_bool] = ACTIONS(3555),
    [sym_unit] = ACTIONS(3553),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3555),
    [sym_op_identifier] = ACTIONS(3555),
    [anon_sym_PLUS] = ACTIONS(3555),
    [anon_sym_DASH] = ACTIONS(3555),
    [anon_sym_PLUS_DOT] = ACTIONS(3555),
    [anon_sym_DASH_DOT] = ACTIONS(3555),
    [anon_sym_PERCENT] = ACTIONS(3555),
    [anon_sym_AMP_AMP] = ACTIONS(3555),
    [anon_sym_TILDE] = ACTIONS(3553),
    [aux_sym_prefix_op_token1] = ACTIONS(3555),
    [aux_sym_infix_op_token1] = ACTIONS(3553),
    [aux_sym_infix_op_token2] = ACTIONS(3555),
    [anon_sym_PIPE_PIPE] = ACTIONS(3555),
    [anon_sym_BANG_EQ] = ACTIONS(3555),
    [anon_sym_COLON_EQ] = ACTIONS(3553),
    [anon_sym_DOLLAR] = ACTIONS(3555),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3555),
    [sym_int] = ACTIONS(3555),
    [sym_xint] = ACTIONS(3553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3553),
    [anon_sym_POUNDendif] = ACTIONS(3553),
    [sym__newline] = ACTIONS(3553),
  },
  [1481] = {
    [sym_block_comment] = STATE(1481),
    [sym_compiler_directive_decl] = STATE(1481),
    [sym_fsi_directive_decl] = STATE(1481),
    [sym_preproc_line] = STATE(1481),
    [sym_identifier] = ACTIONS(3539),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_LBRACK_LT] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3539),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_do] = ACTIONS(3539),
    [anon_sym_and] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3539),
    [anon_sym_let_BANG] = ACTIONS(3537),
    [aux_sym_access_modifier_token1] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_null] = ACTIONS(3539),
    [anon_sym_QMARK] = ACTIONS(3539),
    [anon_sym_COLON_QMARK] = ACTIONS(3539),
    [anon_sym_COLON_COLON] = ACTIONS(3537),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3537),
    [anon_sym_LBRACE] = ACTIONS(3539),
    [anon_sym_LT_AT] = ACTIONS(3539),
    [anon_sym_LT_AT_AT] = ACTIONS(3539),
    [anon_sym_DOT] = ACTIONS(3539),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3537),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_with] = ACTIONS(3539),
    [anon_sym_return_BANG] = ACTIONS(3537),
    [anon_sym_yield] = ACTIONS(3539),
    [anon_sym_yield_BANG] = ACTIONS(3537),
    [anon_sym_lazy] = ACTIONS(3539),
    [anon_sym_assert] = ACTIONS(3539),
    [anon_sym_upcast] = ACTIONS(3539),
    [anon_sym_downcast] = ACTIONS(3539),
    [anon_sym_COLON_GT] = ACTIONS(3537),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3537),
    [anon_sym_for] = ACTIONS(3539),
    [anon_sym_while] = ACTIONS(3539),
    [anon_sym_if] = ACTIONS(3539),
    [anon_sym_fun] = ACTIONS(3539),
    [anon_sym_DASH_GT] = ACTIONS(3539),
    [anon_sym_try] = ACTIONS(3539),
    [anon_sym_match] = ACTIONS(3539),
    [anon_sym_match_BANG] = ACTIONS(3537),
    [anon_sym_function] = ACTIONS(3539),
    [anon_sym_LT_DASH] = ACTIONS(3539),
    [anon_sym_DOT_LBRACK] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_use] = ACTIONS(3539),
    [anon_sym_use_BANG] = ACTIONS(3537),
    [anon_sym_do_BANG] = ACTIONS(3537),
    [anon_sym_begin] = ACTIONS(3539),
    [anon_sym_LPAREN2] = ACTIONS(3539),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_LT2] = ACTIONS(3539),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_default] = ACTIONS(3539),
    [anon_sym_or] = ACTIONS(3539),
    [anon_sym_static] = ACTIONS(3539),
    [anon_sym_member] = ACTIONS(3539),
    [anon_sym_interface] = ACTIONS(3539),
    [anon_sym_abstract] = ACTIONS(3539),
    [anon_sym_val] = ACTIONS(3539),
    [anon_sym_override] = ACTIONS(3539),
    [aux_sym_char_token1] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3539),
    [anon_sym_DQUOTE] = ACTIONS(3539),
    [anon_sym_AT_DQUOTE] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [sym_bool] = ACTIONS(3539),
    [sym_unit] = ACTIONS(3537),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3539),
    [sym_op_identifier] = ACTIONS(3539),
    [anon_sym_PLUS] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(3539),
    [anon_sym_PLUS_DOT] = ACTIONS(3539),
    [anon_sym_DASH_DOT] = ACTIONS(3539),
    [anon_sym_PERCENT] = ACTIONS(3539),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_TILDE] = ACTIONS(3537),
    [aux_sym_prefix_op_token1] = ACTIONS(3539),
    [aux_sym_infix_op_token1] = ACTIONS(3537),
    [aux_sym_infix_op_token2] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3539),
    [anon_sym_BANG_EQ] = ACTIONS(3539),
    [anon_sym_COLON_EQ] = ACTIONS(3537),
    [anon_sym_DOLLAR] = ACTIONS(3539),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3539),
    [sym_int] = ACTIONS(3539),
    [sym_xint] = ACTIONS(3537),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3537),
    [sym__newline] = ACTIONS(3537),
    [sym__dedent] = ACTIONS(3537),
  },
  [1482] = {
    [sym_block_comment] = STATE(1482),
    [sym_compiler_directive_decl] = STATE(1482),
    [sym_fsi_directive_decl] = STATE(1482),
    [sym_preproc_line] = STATE(1482),
    [sym_identifier] = ACTIONS(3531),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_LBRACK_LT] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(3531),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_do] = ACTIONS(3531),
    [anon_sym_and] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [aux_sym_access_modifier_token1] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_null] = ACTIONS(3531),
    [anon_sym_QMARK] = ACTIONS(3531),
    [anon_sym_COLON_QMARK] = ACTIONS(3531),
    [anon_sym_COLON_COLON] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3531),
    [anon_sym_LT_AT] = ACTIONS(3531),
    [anon_sym_LT_AT_AT] = ACTIONS(3531),
    [anon_sym_DOT] = ACTIONS(3531),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3531),
    [anon_sym_with] = ACTIONS(3531),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3531),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3531),
    [anon_sym_assert] = ACTIONS(3531),
    [anon_sym_upcast] = ACTIONS(3531),
    [anon_sym_downcast] = ACTIONS(3531),
    [anon_sym_COLON_GT] = ACTIONS(3529),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3531),
    [anon_sym_while] = ACTIONS(3531),
    [anon_sym_if] = ACTIONS(3531),
    [anon_sym_fun] = ACTIONS(3531),
    [anon_sym_DASH_GT] = ACTIONS(3531),
    [anon_sym_try] = ACTIONS(3531),
    [anon_sym_match] = ACTIONS(3531),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3531),
    [anon_sym_LT_DASH] = ACTIONS(3531),
    [anon_sym_DOT_LBRACK] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_use] = ACTIONS(3531),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3531),
    [anon_sym_LPAREN2] = ACTIONS(3531),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LT2] = ACTIONS(3531),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_default] = ACTIONS(3531),
    [anon_sym_or] = ACTIONS(3531),
    [anon_sym_static] = ACTIONS(3531),
    [anon_sym_member] = ACTIONS(3531),
    [anon_sym_interface] = ACTIONS(3531),
    [anon_sym_abstract] = ACTIONS(3531),
    [anon_sym_val] = ACTIONS(3531),
    [anon_sym_override] = ACTIONS(3531),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3531),
    [anon_sym_DQUOTE] = ACTIONS(3531),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3531),
    [sym_unit] = ACTIONS(3529),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3531),
    [sym_op_identifier] = ACTIONS(3531),
    [anon_sym_PLUS] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(3531),
    [anon_sym_PLUS_DOT] = ACTIONS(3531),
    [anon_sym_DASH_DOT] = ACTIONS(3531),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_AMP_AMP] = ACTIONS(3531),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3531),
    [aux_sym_infix_op_token1] = ACTIONS(3529),
    [aux_sym_infix_op_token2] = ACTIONS(3531),
    [anon_sym_PIPE_PIPE] = ACTIONS(3531),
    [anon_sym_BANG_EQ] = ACTIONS(3531),
    [anon_sym_COLON_EQ] = ACTIONS(3529),
    [anon_sym_DOLLAR] = ACTIONS(3531),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3531),
    [sym_int] = ACTIONS(3531),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [anon_sym_POUNDendif] = ACTIONS(3529),
    [sym__newline] = ACTIONS(3529),
  },
  [1483] = {
    [sym_block_comment] = STATE(1483),
    [sym_compiler_directive_decl] = STATE(1483),
    [sym_fsi_directive_decl] = STATE(1483),
    [sym_preproc_line] = STATE(1483),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_LBRACK_LT] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [aux_sym_access_modifier_token1] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_with] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [anon_sym_DOT_LBRACK] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_DOT_DOT2] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_default] = ACTIONS(3498),
    [anon_sym_or] = ACTIONS(3498),
    [anon_sym_static] = ACTIONS(3498),
    [anon_sym_member] = ACTIONS(3498),
    [anon_sym_interface] = ACTIONS(3498),
    [anon_sym_abstract] = ACTIONS(3498),
    [anon_sym_val] = ACTIONS(3498),
    [anon_sym_override] = ACTIONS(3498),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3498),
    [anon_sym_DASH_DOT] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3498),
    [aux_sym_infix_op_token1] = ACTIONS(3496),
    [aux_sym_infix_op_token2] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_COLON_EQ] = ACTIONS(3496),
    [anon_sym_DOLLAR] = ACTIONS(3498),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3498),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
    [sym__dedent] = ACTIONS(3496),
  },
  [1484] = {
    [sym_block_comment] = STATE(1484),
    [sym_compiler_directive_decl] = STATE(1484),
    [sym_fsi_directive_decl] = STATE(1484),
    [sym_preproc_line] = STATE(1484),
    [sym_identifier] = ACTIONS(3539),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_LBRACK_LT] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3539),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_do] = ACTIONS(3539),
    [anon_sym_and] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3539),
    [anon_sym_let_BANG] = ACTIONS(3537),
    [aux_sym_access_modifier_token1] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_null] = ACTIONS(3539),
    [anon_sym_QMARK] = ACTIONS(3539),
    [anon_sym_COLON_QMARK] = ACTIONS(3539),
    [anon_sym_COLON_COLON] = ACTIONS(3537),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3537),
    [anon_sym_LBRACE] = ACTIONS(3539),
    [anon_sym_LT_AT] = ACTIONS(3539),
    [anon_sym_LT_AT_AT] = ACTIONS(3539),
    [anon_sym_DOT] = ACTIONS(3539),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3537),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_with] = ACTIONS(3539),
    [anon_sym_return_BANG] = ACTIONS(3537),
    [anon_sym_yield] = ACTIONS(3539),
    [anon_sym_yield_BANG] = ACTIONS(3537),
    [anon_sym_lazy] = ACTIONS(3539),
    [anon_sym_assert] = ACTIONS(3539),
    [anon_sym_upcast] = ACTIONS(3539),
    [anon_sym_downcast] = ACTIONS(3539),
    [anon_sym_COLON_GT] = ACTIONS(3537),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3537),
    [anon_sym_for] = ACTIONS(3539),
    [anon_sym_while] = ACTIONS(3539),
    [anon_sym_if] = ACTIONS(3539),
    [anon_sym_fun] = ACTIONS(3539),
    [anon_sym_DASH_GT] = ACTIONS(3539),
    [anon_sym_try] = ACTIONS(3539),
    [anon_sym_match] = ACTIONS(3539),
    [anon_sym_match_BANG] = ACTIONS(3537),
    [anon_sym_function] = ACTIONS(3539),
    [anon_sym_LT_DASH] = ACTIONS(3539),
    [anon_sym_DOT_LBRACK] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_use] = ACTIONS(3539),
    [anon_sym_use_BANG] = ACTIONS(3537),
    [anon_sym_do_BANG] = ACTIONS(3537),
    [anon_sym_begin] = ACTIONS(3539),
    [anon_sym_LPAREN2] = ACTIONS(3539),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_LT2] = ACTIONS(3539),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_default] = ACTIONS(3539),
    [anon_sym_or] = ACTIONS(3539),
    [anon_sym_static] = ACTIONS(3539),
    [anon_sym_member] = ACTIONS(3539),
    [anon_sym_interface] = ACTIONS(3539),
    [anon_sym_abstract] = ACTIONS(3539),
    [anon_sym_val] = ACTIONS(3539),
    [anon_sym_override] = ACTIONS(3539),
    [aux_sym_char_token1] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3539),
    [anon_sym_DQUOTE] = ACTIONS(3539),
    [anon_sym_AT_DQUOTE] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [sym_bool] = ACTIONS(3539),
    [sym_unit] = ACTIONS(3537),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3539),
    [sym_op_identifier] = ACTIONS(3539),
    [anon_sym_PLUS] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(3539),
    [anon_sym_PLUS_DOT] = ACTIONS(3539),
    [anon_sym_DASH_DOT] = ACTIONS(3539),
    [anon_sym_PERCENT] = ACTIONS(3539),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_TILDE] = ACTIONS(3537),
    [aux_sym_prefix_op_token1] = ACTIONS(3539),
    [aux_sym_infix_op_token1] = ACTIONS(3537),
    [aux_sym_infix_op_token2] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3539),
    [anon_sym_BANG_EQ] = ACTIONS(3539),
    [anon_sym_COLON_EQ] = ACTIONS(3537),
    [anon_sym_DOLLAR] = ACTIONS(3539),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3539),
    [sym_int] = ACTIONS(3539),
    [sym_xint] = ACTIONS(3537),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3537),
    [anon_sym_POUNDendif] = ACTIONS(3537),
    [sym__newline] = ACTIONS(3537),
  },
  [1485] = {
    [sym_block_comment] = STATE(1485),
    [sym_compiler_directive_decl] = STATE(1485),
    [sym_fsi_directive_decl] = STATE(1485),
    [sym_preproc_line] = STATE(1485),
    [sym_identifier] = ACTIONS(3535),
    [anon_sym_EQ] = ACTIONS(3533),
    [anon_sym_LBRACK_LT] = ACTIONS(3533),
    [anon_sym_COLON] = ACTIONS(3535),
    [anon_sym_return] = ACTIONS(3535),
    [anon_sym_do] = ACTIONS(3535),
    [anon_sym_and] = ACTIONS(3535),
    [anon_sym_let] = ACTIONS(3535),
    [anon_sym_let_BANG] = ACTIONS(3533),
    [aux_sym_access_modifier_token1] = ACTIONS(3533),
    [anon_sym_LPAREN] = ACTIONS(3535),
    [anon_sym_COMMA] = ACTIONS(3533),
    [anon_sym_null] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(3535),
    [anon_sym_COLON_QMARK] = ACTIONS(3535),
    [anon_sym_COLON_COLON] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3533),
    [anon_sym_LBRACE] = ACTIONS(3535),
    [anon_sym_LT_AT] = ACTIONS(3535),
    [anon_sym_LT_AT_AT] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(3535),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3533),
    [anon_sym_new] = ACTIONS(3535),
    [anon_sym_with] = ACTIONS(3535),
    [anon_sym_return_BANG] = ACTIONS(3533),
    [anon_sym_yield] = ACTIONS(3535),
    [anon_sym_yield_BANG] = ACTIONS(3533),
    [anon_sym_lazy] = ACTIONS(3535),
    [anon_sym_assert] = ACTIONS(3535),
    [anon_sym_upcast] = ACTIONS(3535),
    [anon_sym_downcast] = ACTIONS(3535),
    [anon_sym_COLON_GT] = ACTIONS(3533),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3533),
    [anon_sym_for] = ACTIONS(3535),
    [anon_sym_while] = ACTIONS(3535),
    [anon_sym_if] = ACTIONS(3535),
    [anon_sym_fun] = ACTIONS(3535),
    [anon_sym_DASH_GT] = ACTIONS(3535),
    [anon_sym_try] = ACTIONS(3535),
    [anon_sym_match] = ACTIONS(3535),
    [anon_sym_match_BANG] = ACTIONS(3533),
    [anon_sym_function] = ACTIONS(3535),
    [anon_sym_LT_DASH] = ACTIONS(3535),
    [anon_sym_DOT_LBRACK] = ACTIONS(3533),
    [anon_sym_LT] = ACTIONS(3533),
    [anon_sym_use] = ACTIONS(3535),
    [anon_sym_use_BANG] = ACTIONS(3533),
    [anon_sym_do_BANG] = ACTIONS(3533),
    [anon_sym_begin] = ACTIONS(3535),
    [anon_sym_LPAREN2] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(3535),
    [anon_sym_LT2] = ACTIONS(3535),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3533),
    [anon_sym_default] = ACTIONS(3535),
    [anon_sym_or] = ACTIONS(3535),
    [anon_sym_static] = ACTIONS(3535),
    [anon_sym_member] = ACTIONS(3535),
    [anon_sym_interface] = ACTIONS(3535),
    [anon_sym_abstract] = ACTIONS(3535),
    [anon_sym_val] = ACTIONS(3535),
    [anon_sym_override] = ACTIONS(3535),
    [aux_sym_char_token1] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE] = ACTIONS(3535),
    [anon_sym_AT_DQUOTE] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [sym_bool] = ACTIONS(3535),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3535),
    [sym_op_identifier] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS_DOT] = ACTIONS(3535),
    [anon_sym_DASH_DOT] = ACTIONS(3535),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(3535),
    [anon_sym_TILDE] = ACTIONS(3533),
    [aux_sym_prefix_op_token1] = ACTIONS(3535),
    [aux_sym_infix_op_token1] = ACTIONS(3533),
    [aux_sym_infix_op_token2] = ACTIONS(3535),
    [anon_sym_PIPE_PIPE] = ACTIONS(3535),
    [anon_sym_BANG_EQ] = ACTIONS(3535),
    [anon_sym_COLON_EQ] = ACTIONS(3533),
    [anon_sym_DOLLAR] = ACTIONS(3535),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3535),
    [sym_int] = ACTIONS(3535),
    [sym_xint] = ACTIONS(3533),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3533),
    [anon_sym_POUNDendif] = ACTIONS(3533),
    [sym__newline] = ACTIONS(3533),
  },
  [1486] = {
    [sym_block_comment] = STATE(1486),
    [sym_compiler_directive_decl] = STATE(1486),
    [sym_fsi_directive_decl] = STATE(1486),
    [sym_preproc_line] = STATE(1486),
    [sym_identifier] = ACTIONS(3519),
    [anon_sym_EQ] = ACTIONS(3517),
    [anon_sym_LBRACK_LT] = ACTIONS(3517),
    [anon_sym_COLON] = ACTIONS(3519),
    [anon_sym_return] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(3519),
    [anon_sym_let] = ACTIONS(3519),
    [anon_sym_let_BANG] = ACTIONS(3517),
    [aux_sym_access_modifier_token1] = ACTIONS(3517),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [anon_sym_COMMA] = ACTIONS(3517),
    [anon_sym_null] = ACTIONS(3519),
    [anon_sym_QMARK] = ACTIONS(3519),
    [anon_sym_COLON_QMARK] = ACTIONS(3519),
    [anon_sym_COLON_COLON] = ACTIONS(3517),
    [anon_sym_AMP] = ACTIONS(3519),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_LT_AT] = ACTIONS(3519),
    [anon_sym_LT_AT_AT] = ACTIONS(3519),
    [anon_sym_DOT] = ACTIONS(3519),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3519),
    [anon_sym_with] = ACTIONS(3519),
    [anon_sym_return_BANG] = ACTIONS(3517),
    [anon_sym_yield] = ACTIONS(3519),
    [anon_sym_yield_BANG] = ACTIONS(3517),
    [anon_sym_lazy] = ACTIONS(3519),
    [anon_sym_assert] = ACTIONS(3519),
    [anon_sym_upcast] = ACTIONS(3519),
    [anon_sym_downcast] = ACTIONS(3519),
    [anon_sym_COLON_GT] = ACTIONS(3517),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3517),
    [anon_sym_for] = ACTIONS(3519),
    [anon_sym_while] = ACTIONS(3519),
    [anon_sym_if] = ACTIONS(3519),
    [anon_sym_fun] = ACTIONS(3519),
    [anon_sym_DASH_GT] = ACTIONS(3519),
    [anon_sym_try] = ACTIONS(3519),
    [anon_sym_match] = ACTIONS(3519),
    [anon_sym_match_BANG] = ACTIONS(3517),
    [anon_sym_function] = ACTIONS(3519),
    [anon_sym_LT_DASH] = ACTIONS(3519),
    [anon_sym_DOT_LBRACK] = ACTIONS(3517),
    [anon_sym_LT] = ACTIONS(3517),
    [anon_sym_use] = ACTIONS(3519),
    [anon_sym_use_BANG] = ACTIONS(3517),
    [anon_sym_do_BANG] = ACTIONS(3517),
    [anon_sym_begin] = ACTIONS(3519),
    [anon_sym_LPAREN2] = ACTIONS(3519),
    [anon_sym_DOT_DOT2] = ACTIONS(3517),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_LT2] = ACTIONS(3519),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3517),
    [anon_sym_default] = ACTIONS(3519),
    [anon_sym_or] = ACTIONS(3519),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_member] = ACTIONS(3519),
    [anon_sym_interface] = ACTIONS(3519),
    [anon_sym_abstract] = ACTIONS(3519),
    [anon_sym_val] = ACTIONS(3519),
    [anon_sym_override] = ACTIONS(3519),
    [aux_sym_char_token1] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [anon_sym_AT_DQUOTE] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [sym_bool] = ACTIONS(3519),
    [sym_unit] = ACTIONS(3517),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3519),
    [sym_op_identifier] = ACTIONS(3519),
    [anon_sym_PLUS] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_DOT] = ACTIONS(3519),
    [anon_sym_DASH_DOT] = ACTIONS(3519),
    [anon_sym_PERCENT] = ACTIONS(3519),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3517),
    [aux_sym_prefix_op_token1] = ACTIONS(3519),
    [aux_sym_infix_op_token1] = ACTIONS(3517),
    [aux_sym_infix_op_token2] = ACTIONS(3519),
    [anon_sym_PIPE_PIPE] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_COLON_EQ] = ACTIONS(3517),
    [anon_sym_DOLLAR] = ACTIONS(3519),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3519),
    [sym_int] = ACTIONS(3519),
    [sym_xint] = ACTIONS(3517),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3517),
    [sym__newline] = ACTIONS(3517),
    [sym__dedent] = ACTIONS(3517),
  },
  [1487] = {
    [sym_block_comment] = STATE(1487),
    [sym_compiler_directive_decl] = STATE(1487),
    [sym_fsi_directive_decl] = STATE(1487),
    [sym_preproc_line] = STATE(1487),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_EQ] = ACTIONS(3560),
    [anon_sym_LBRACK_LT] = ACTIONS(3560),
    [anon_sym_COLON] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_and] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_let_BANG] = ACTIONS(3560),
    [aux_sym_access_modifier_token1] = ACTIONS(3560),
    [anon_sym_LPAREN] = ACTIONS(3562),
    [anon_sym_COMMA] = ACTIONS(3560),
    [anon_sym_null] = ACTIONS(3562),
    [anon_sym_QMARK] = ACTIONS(3562),
    [anon_sym_COLON_QMARK] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3560),
    [anon_sym_LBRACE] = ACTIONS(3562),
    [anon_sym_LT_AT] = ACTIONS(3562),
    [anon_sym_LT_AT_AT] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(3562),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3560),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_with] = ACTIONS(3562),
    [anon_sym_return_BANG] = ACTIONS(3560),
    [anon_sym_yield] = ACTIONS(3562),
    [anon_sym_yield_BANG] = ACTIONS(3560),
    [anon_sym_lazy] = ACTIONS(3562),
    [anon_sym_assert] = ACTIONS(3562),
    [anon_sym_upcast] = ACTIONS(3562),
    [anon_sym_downcast] = ACTIONS(3562),
    [anon_sym_COLON_GT] = ACTIONS(3560),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3560),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_fun] = ACTIONS(3562),
    [anon_sym_DASH_GT] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_match] = ACTIONS(3562),
    [anon_sym_match_BANG] = ACTIONS(3560),
    [anon_sym_function] = ACTIONS(3562),
    [anon_sym_LT_DASH] = ACTIONS(3562),
    [anon_sym_DOT_LBRACK] = ACTIONS(3560),
    [anon_sym_LT] = ACTIONS(3560),
    [anon_sym_use] = ACTIONS(3562),
    [anon_sym_use_BANG] = ACTIONS(3560),
    [anon_sym_do_BANG] = ACTIONS(3560),
    [anon_sym_begin] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3562),
    [anon_sym_LT2] = ACTIONS(3562),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3560),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_or] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_member] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_abstract] = ACTIONS(3562),
    [anon_sym_val] = ACTIONS(3562),
    [anon_sym_override] = ACTIONS(3562),
    [aux_sym_char_token1] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(3562),
    [anon_sym_AT_DQUOTE] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [sym_bool] = ACTIONS(3562),
    [sym_unit] = ACTIONS(3560),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3562),
    [sym_op_identifier] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS_DOT] = ACTIONS(3562),
    [anon_sym_DASH_DOT] = ACTIONS(3562),
    [anon_sym_PERCENT] = ACTIONS(3562),
    [anon_sym_AMP_AMP] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3560),
    [aux_sym_prefix_op_token1] = ACTIONS(3562),
    [aux_sym_infix_op_token1] = ACTIONS(3560),
    [aux_sym_infix_op_token2] = ACTIONS(3562),
    [anon_sym_PIPE_PIPE] = ACTIONS(3562),
    [anon_sym_BANG_EQ] = ACTIONS(3562),
    [anon_sym_COLON_EQ] = ACTIONS(3560),
    [anon_sym_DOLLAR] = ACTIONS(3562),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3562),
    [sym_int] = ACTIONS(3562),
    [sym_xint] = ACTIONS(3560),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3560),
    [anon_sym_POUNDendif] = ACTIONS(3560),
    [sym__newline] = ACTIONS(3560),
  },
  [1488] = {
    [sym_block_comment] = STATE(1488),
    [sym_compiler_directive_decl] = STATE(1488),
    [sym_fsi_directive_decl] = STATE(1488),
    [sym_preproc_line] = STATE(1488),
    [sym_identifier] = ACTIONS(3551),
    [anon_sym_EQ] = ACTIONS(3549),
    [anon_sym_LBRACK_LT] = ACTIONS(3549),
    [anon_sym_COLON] = ACTIONS(3551),
    [anon_sym_return] = ACTIONS(3551),
    [anon_sym_do] = ACTIONS(3551),
    [anon_sym_and] = ACTIONS(3551),
    [anon_sym_let] = ACTIONS(3551),
    [anon_sym_let_BANG] = ACTIONS(3549),
    [aux_sym_access_modifier_token1] = ACTIONS(3549),
    [anon_sym_LPAREN] = ACTIONS(3551),
    [anon_sym_COMMA] = ACTIONS(3549),
    [anon_sym_null] = ACTIONS(3551),
    [anon_sym_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_COLON] = ACTIONS(3549),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(3551),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3549),
    [anon_sym_LBRACE] = ACTIONS(3551),
    [anon_sym_LT_AT] = ACTIONS(3551),
    [anon_sym_LT_AT_AT] = ACTIONS(3551),
    [anon_sym_DOT] = ACTIONS(3551),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3549),
    [anon_sym_new] = ACTIONS(3551),
    [anon_sym_with] = ACTIONS(3551),
    [anon_sym_return_BANG] = ACTIONS(3549),
    [anon_sym_yield] = ACTIONS(3551),
    [anon_sym_yield_BANG] = ACTIONS(3549),
    [anon_sym_lazy] = ACTIONS(3551),
    [anon_sym_assert] = ACTIONS(3551),
    [anon_sym_upcast] = ACTIONS(3551),
    [anon_sym_downcast] = ACTIONS(3551),
    [anon_sym_COLON_GT] = ACTIONS(3549),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3549),
    [anon_sym_for] = ACTIONS(3551),
    [anon_sym_while] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(3551),
    [anon_sym_fun] = ACTIONS(3551),
    [anon_sym_DASH_GT] = ACTIONS(3551),
    [anon_sym_try] = ACTIONS(3551),
    [anon_sym_match] = ACTIONS(3551),
    [anon_sym_match_BANG] = ACTIONS(3549),
    [anon_sym_function] = ACTIONS(3551),
    [anon_sym_LT_DASH] = ACTIONS(3551),
    [anon_sym_DOT_LBRACK] = ACTIONS(3549),
    [anon_sym_LT] = ACTIONS(3549),
    [anon_sym_use] = ACTIONS(3551),
    [anon_sym_use_BANG] = ACTIONS(3549),
    [anon_sym_do_BANG] = ACTIONS(3549),
    [anon_sym_begin] = ACTIONS(3551),
    [anon_sym_LPAREN2] = ACTIONS(3551),
    [anon_sym_STAR] = ACTIONS(3551),
    [anon_sym_LT2] = ACTIONS(3551),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3549),
    [anon_sym_default] = ACTIONS(3551),
    [anon_sym_or] = ACTIONS(3551),
    [anon_sym_static] = ACTIONS(3551),
    [anon_sym_member] = ACTIONS(3551),
    [anon_sym_interface] = ACTIONS(3551),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_val] = ACTIONS(3551),
    [anon_sym_override] = ACTIONS(3551),
    [aux_sym_char_token1] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [anon_sym_AT_DQUOTE] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [sym_bool] = ACTIONS(3551),
    [sym_unit] = ACTIONS(3549),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3551),
    [sym_op_identifier] = ACTIONS(3551),
    [anon_sym_PLUS] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(3551),
    [anon_sym_PLUS_DOT] = ACTIONS(3551),
    [anon_sym_DASH_DOT] = ACTIONS(3551),
    [anon_sym_PERCENT] = ACTIONS(3551),
    [anon_sym_AMP_AMP] = ACTIONS(3551),
    [anon_sym_TILDE] = ACTIONS(3549),
    [aux_sym_prefix_op_token1] = ACTIONS(3551),
    [aux_sym_infix_op_token1] = ACTIONS(3549),
    [aux_sym_infix_op_token2] = ACTIONS(3551),
    [anon_sym_PIPE_PIPE] = ACTIONS(3551),
    [anon_sym_BANG_EQ] = ACTIONS(3551),
    [anon_sym_COLON_EQ] = ACTIONS(3549),
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3551),
    [sym_int] = ACTIONS(3551),
    [sym_xint] = ACTIONS(3549),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3549),
    [anon_sym_POUNDendif] = ACTIONS(3549),
    [sym__newline] = ACTIONS(3549),
  },
  [1489] = {
    [sym_block_comment] = STATE(1489),
    [sym_compiler_directive_decl] = STATE(1489),
    [sym_fsi_directive_decl] = STATE(1489),
    [sym_preproc_line] = STATE(1489),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_as] = ACTIONS(3193),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(4257),
    [anon_sym_uy] = ACTIONS(4259),
    [anon_sym_s] = ACTIONS(4261),
    [anon_sym_us] = ACTIONS(4263),
    [anon_sym_l] = ACTIONS(4265),
    [aux_sym_uint32_token1] = ACTIONS(4267),
    [anon_sym_n] = ACTIONS(4269),
    [anon_sym_un] = ACTIONS(4271),
    [anon_sym_L] = ACTIONS(4273),
    [aux_sym_uint64_token1] = ACTIONS(4275),
    [aux_sym_bignum_token1] = ACTIONS(4277),
    [aux_sym_decimal_token1] = ACTIONS(4279),
    [anon_sym_DOT2] = ACTIONS(4281),
    [aux_sym_float_token1] = ACTIONS(4283),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1490] = {
    [sym_block_comment] = STATE(1490),
    [sym_compiler_directive_decl] = STATE(1490),
    [sym_fsi_directive_decl] = STATE(1490),
    [sym_preproc_line] = STATE(1490),
    [sym_identifier] = ACTIONS(3511),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_LBRACK_LT] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3511),
    [anon_sym_return] = ACTIONS(3511),
    [anon_sym_do] = ACTIONS(3511),
    [anon_sym_let] = ACTIONS(3511),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [aux_sym_access_modifier_token1] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3511),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3511),
    [anon_sym_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(3511),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_LT_AT] = ACTIONS(3511),
    [anon_sym_LT_AT_AT] = ACTIONS(3511),
    [anon_sym_DOT] = ACTIONS(3511),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3511),
    [anon_sym_with] = ACTIONS(3511),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3511),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3511),
    [anon_sym_assert] = ACTIONS(3511),
    [anon_sym_upcast] = ACTIONS(3511),
    [anon_sym_downcast] = ACTIONS(3511),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3511),
    [anon_sym_while] = ACTIONS(3511),
    [anon_sym_if] = ACTIONS(3511),
    [anon_sym_fun] = ACTIONS(3511),
    [anon_sym_DASH_GT] = ACTIONS(3511),
    [anon_sym_try] = ACTIONS(3511),
    [anon_sym_match] = ACTIONS(3511),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3511),
    [anon_sym_LT_DASH] = ACTIONS(3511),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3511),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3511),
    [anon_sym_LPAREN2] = ACTIONS(3511),
    [anon_sym_DOT_DOT2] = ACTIONS(3509),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_LT2] = ACTIONS(3511),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3509),
    [anon_sym_default] = ACTIONS(3511),
    [anon_sym_or] = ACTIONS(3511),
    [anon_sym_static] = ACTIONS(3511),
    [anon_sym_member] = ACTIONS(3511),
    [anon_sym_interface] = ACTIONS(3511),
    [anon_sym_abstract] = ACTIONS(3511),
    [anon_sym_val] = ACTIONS(3511),
    [anon_sym_override] = ACTIONS(3511),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3511),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3511),
    [sym_unit] = ACTIONS(3509),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3511),
    [sym_op_identifier] = ACTIONS(3511),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3511),
    [anon_sym_PLUS_DOT] = ACTIONS(3511),
    [anon_sym_DASH_DOT] = ACTIONS(3511),
    [anon_sym_PERCENT] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3511),
    [aux_sym_infix_op_token1] = ACTIONS(3509),
    [aux_sym_infix_op_token2] = ACTIONS(3511),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_BANG_EQ] = ACTIONS(3511),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3511),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3511),
    [sym_int] = ACTIONS(3511),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
    [sym__dedent] = ACTIONS(3509),
  },
  [1491] = {
    [sym_block_comment] = STATE(1491),
    [sym_compiler_directive_decl] = STATE(1491),
    [sym_fsi_directive_decl] = STATE(1491),
    [sym_preproc_line] = STATE(1491),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_EQ] = ACTIONS(3560),
    [anon_sym_LBRACK_LT] = ACTIONS(3560),
    [anon_sym_COLON] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_and] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_let_BANG] = ACTIONS(3560),
    [aux_sym_access_modifier_token1] = ACTIONS(3560),
    [anon_sym_LPAREN] = ACTIONS(3562),
    [anon_sym_COMMA] = ACTIONS(3560),
    [anon_sym_null] = ACTIONS(3562),
    [anon_sym_QMARK] = ACTIONS(3562),
    [anon_sym_COLON_QMARK] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3560),
    [anon_sym_LBRACE] = ACTIONS(3562),
    [anon_sym_LT_AT] = ACTIONS(3562),
    [anon_sym_LT_AT_AT] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(3562),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3560),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_with] = ACTIONS(3562),
    [anon_sym_return_BANG] = ACTIONS(3560),
    [anon_sym_yield] = ACTIONS(3562),
    [anon_sym_yield_BANG] = ACTIONS(3560),
    [anon_sym_lazy] = ACTIONS(3562),
    [anon_sym_assert] = ACTIONS(3562),
    [anon_sym_upcast] = ACTIONS(3562),
    [anon_sym_downcast] = ACTIONS(3562),
    [anon_sym_COLON_GT] = ACTIONS(3560),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3560),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_fun] = ACTIONS(3562),
    [anon_sym_DASH_GT] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_match] = ACTIONS(3562),
    [anon_sym_match_BANG] = ACTIONS(3560),
    [anon_sym_function] = ACTIONS(3562),
    [anon_sym_LT_DASH] = ACTIONS(3562),
    [anon_sym_DOT_LBRACK] = ACTIONS(3560),
    [anon_sym_LT] = ACTIONS(3560),
    [anon_sym_use] = ACTIONS(3562),
    [anon_sym_use_BANG] = ACTIONS(3560),
    [anon_sym_do_BANG] = ACTIONS(3560),
    [anon_sym_begin] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3562),
    [anon_sym_LT2] = ACTIONS(3562),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3560),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_or] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_member] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_abstract] = ACTIONS(3562),
    [anon_sym_val] = ACTIONS(3562),
    [anon_sym_override] = ACTIONS(3562),
    [aux_sym_char_token1] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(3562),
    [anon_sym_AT_DQUOTE] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [sym_bool] = ACTIONS(3562),
    [sym_unit] = ACTIONS(3560),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3562),
    [sym_op_identifier] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS_DOT] = ACTIONS(3562),
    [anon_sym_DASH_DOT] = ACTIONS(3562),
    [anon_sym_PERCENT] = ACTIONS(3562),
    [anon_sym_AMP_AMP] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3560),
    [aux_sym_prefix_op_token1] = ACTIONS(3562),
    [aux_sym_infix_op_token1] = ACTIONS(3560),
    [aux_sym_infix_op_token2] = ACTIONS(3562),
    [anon_sym_PIPE_PIPE] = ACTIONS(3562),
    [anon_sym_BANG_EQ] = ACTIONS(3562),
    [anon_sym_COLON_EQ] = ACTIONS(3560),
    [anon_sym_DOLLAR] = ACTIONS(3562),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3562),
    [sym_int] = ACTIONS(3562),
    [sym_xint] = ACTIONS(3560),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3560),
    [sym__newline] = ACTIONS(3560),
    [sym__dedent] = ACTIONS(3560),
  },
  [1492] = {
    [sym_block_comment] = STATE(1492),
    [sym_compiler_directive_decl] = STATE(1492),
    [sym_fsi_directive_decl] = STATE(1492),
    [sym_preproc_line] = STATE(1492),
    [sym_identifier] = ACTIONS(3551),
    [anon_sym_EQ] = ACTIONS(3549),
    [anon_sym_LBRACK_LT] = ACTIONS(3549),
    [anon_sym_COLON] = ACTIONS(3551),
    [anon_sym_return] = ACTIONS(3551),
    [anon_sym_do] = ACTIONS(3551),
    [anon_sym_and] = ACTIONS(3551),
    [anon_sym_let] = ACTIONS(3551),
    [anon_sym_let_BANG] = ACTIONS(3549),
    [aux_sym_access_modifier_token1] = ACTIONS(3549),
    [anon_sym_LPAREN] = ACTIONS(3551),
    [anon_sym_COMMA] = ACTIONS(3549),
    [anon_sym_null] = ACTIONS(3551),
    [anon_sym_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_COLON] = ACTIONS(3549),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(3551),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3549),
    [anon_sym_LBRACE] = ACTIONS(3551),
    [anon_sym_LT_AT] = ACTIONS(3551),
    [anon_sym_LT_AT_AT] = ACTIONS(3551),
    [anon_sym_DOT] = ACTIONS(3551),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3549),
    [anon_sym_new] = ACTIONS(3551),
    [anon_sym_with] = ACTIONS(3551),
    [anon_sym_return_BANG] = ACTIONS(3549),
    [anon_sym_yield] = ACTIONS(3551),
    [anon_sym_yield_BANG] = ACTIONS(3549),
    [anon_sym_lazy] = ACTIONS(3551),
    [anon_sym_assert] = ACTIONS(3551),
    [anon_sym_upcast] = ACTIONS(3551),
    [anon_sym_downcast] = ACTIONS(3551),
    [anon_sym_COLON_GT] = ACTIONS(3549),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3549),
    [anon_sym_for] = ACTIONS(3551),
    [anon_sym_while] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(3551),
    [anon_sym_fun] = ACTIONS(3551),
    [anon_sym_DASH_GT] = ACTIONS(3551),
    [anon_sym_try] = ACTIONS(3551),
    [anon_sym_match] = ACTIONS(3551),
    [anon_sym_match_BANG] = ACTIONS(3549),
    [anon_sym_function] = ACTIONS(3551),
    [anon_sym_LT_DASH] = ACTIONS(3551),
    [anon_sym_DOT_LBRACK] = ACTIONS(3549),
    [anon_sym_LT] = ACTIONS(3549),
    [anon_sym_use] = ACTIONS(3551),
    [anon_sym_use_BANG] = ACTIONS(3549),
    [anon_sym_do_BANG] = ACTIONS(3549),
    [anon_sym_begin] = ACTIONS(3551),
    [anon_sym_LPAREN2] = ACTIONS(3551),
    [anon_sym_STAR] = ACTIONS(3551),
    [anon_sym_LT2] = ACTIONS(3551),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3549),
    [anon_sym_default] = ACTIONS(3551),
    [anon_sym_or] = ACTIONS(3551),
    [anon_sym_static] = ACTIONS(3551),
    [anon_sym_member] = ACTIONS(3551),
    [anon_sym_interface] = ACTIONS(3551),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_val] = ACTIONS(3551),
    [anon_sym_override] = ACTIONS(3551),
    [aux_sym_char_token1] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [anon_sym_AT_DQUOTE] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [sym_bool] = ACTIONS(3551),
    [sym_unit] = ACTIONS(3549),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3551),
    [sym_op_identifier] = ACTIONS(3551),
    [anon_sym_PLUS] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(3551),
    [anon_sym_PLUS_DOT] = ACTIONS(3551),
    [anon_sym_DASH_DOT] = ACTIONS(3551),
    [anon_sym_PERCENT] = ACTIONS(3551),
    [anon_sym_AMP_AMP] = ACTIONS(3551),
    [anon_sym_TILDE] = ACTIONS(3549),
    [aux_sym_prefix_op_token1] = ACTIONS(3551),
    [aux_sym_infix_op_token1] = ACTIONS(3549),
    [aux_sym_infix_op_token2] = ACTIONS(3551),
    [anon_sym_PIPE_PIPE] = ACTIONS(3551),
    [anon_sym_BANG_EQ] = ACTIONS(3551),
    [anon_sym_COLON_EQ] = ACTIONS(3549),
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3551),
    [sym_int] = ACTIONS(3551),
    [sym_xint] = ACTIONS(3549),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3549),
    [sym__newline] = ACTIONS(3549),
    [sym__dedent] = ACTIONS(3549),
  },
  [1493] = {
    [sym_block_comment] = STATE(1493),
    [sym_compiler_directive_decl] = STATE(1493),
    [sym_fsi_directive_decl] = STATE(1493),
    [sym_preproc_line] = STATE(1493),
    [sym_identifier] = ACTIONS(3519),
    [anon_sym_EQ] = ACTIONS(3517),
    [anon_sym_LBRACK_LT] = ACTIONS(3517),
    [anon_sym_COLON] = ACTIONS(3519),
    [anon_sym_return] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(3519),
    [anon_sym_and] = ACTIONS(3519),
    [anon_sym_let] = ACTIONS(3519),
    [anon_sym_let_BANG] = ACTIONS(3517),
    [aux_sym_access_modifier_token1] = ACTIONS(3517),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [anon_sym_COMMA] = ACTIONS(3517),
    [anon_sym_null] = ACTIONS(3519),
    [anon_sym_QMARK] = ACTIONS(3519),
    [anon_sym_COLON_QMARK] = ACTIONS(3519),
    [anon_sym_COLON_COLON] = ACTIONS(3517),
    [anon_sym_AMP] = ACTIONS(3519),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_LT_AT] = ACTIONS(3519),
    [anon_sym_LT_AT_AT] = ACTIONS(3519),
    [anon_sym_DOT] = ACTIONS(3519),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3519),
    [anon_sym_with] = ACTIONS(3519),
    [anon_sym_return_BANG] = ACTIONS(3517),
    [anon_sym_yield] = ACTIONS(3519),
    [anon_sym_yield_BANG] = ACTIONS(3517),
    [anon_sym_lazy] = ACTIONS(3519),
    [anon_sym_assert] = ACTIONS(3519),
    [anon_sym_upcast] = ACTIONS(3519),
    [anon_sym_downcast] = ACTIONS(3519),
    [anon_sym_COLON_GT] = ACTIONS(3517),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3517),
    [anon_sym_for] = ACTIONS(3519),
    [anon_sym_while] = ACTIONS(3519),
    [anon_sym_if] = ACTIONS(3519),
    [anon_sym_fun] = ACTIONS(3519),
    [anon_sym_DASH_GT] = ACTIONS(3519),
    [anon_sym_try] = ACTIONS(3519),
    [anon_sym_match] = ACTIONS(3519),
    [anon_sym_match_BANG] = ACTIONS(3517),
    [anon_sym_function] = ACTIONS(3519),
    [anon_sym_LT_DASH] = ACTIONS(3519),
    [anon_sym_DOT_LBRACK] = ACTIONS(3517),
    [anon_sym_LT] = ACTIONS(3517),
    [anon_sym_use] = ACTIONS(3519),
    [anon_sym_use_BANG] = ACTIONS(3517),
    [anon_sym_do_BANG] = ACTIONS(3517),
    [anon_sym_begin] = ACTIONS(3519),
    [anon_sym_LPAREN2] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_LT2] = ACTIONS(3519),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3517),
    [anon_sym_default] = ACTIONS(3519),
    [anon_sym_or] = ACTIONS(3519),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_member] = ACTIONS(3519),
    [anon_sym_interface] = ACTIONS(3519),
    [anon_sym_abstract] = ACTIONS(3519),
    [anon_sym_val] = ACTIONS(3519),
    [anon_sym_override] = ACTIONS(3519),
    [aux_sym_char_token1] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [anon_sym_AT_DQUOTE] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [sym_bool] = ACTIONS(3519),
    [sym_unit] = ACTIONS(3517),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3519),
    [sym_op_identifier] = ACTIONS(3519),
    [anon_sym_PLUS] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_DOT] = ACTIONS(3519),
    [anon_sym_DASH_DOT] = ACTIONS(3519),
    [anon_sym_PERCENT] = ACTIONS(3519),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3517),
    [aux_sym_prefix_op_token1] = ACTIONS(3519),
    [aux_sym_infix_op_token1] = ACTIONS(3517),
    [aux_sym_infix_op_token2] = ACTIONS(3519),
    [anon_sym_PIPE_PIPE] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_COLON_EQ] = ACTIONS(3517),
    [anon_sym_DOLLAR] = ACTIONS(3519),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3519),
    [sym_int] = ACTIONS(3519),
    [sym_xint] = ACTIONS(3517),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3517),
    [sym__newline] = ACTIONS(3517),
    [sym__dedent] = ACTIONS(3517),
  },
  [1494] = {
    [sym_block_comment] = STATE(1494),
    [sym_compiler_directive_decl] = STATE(1494),
    [sym_fsi_directive_decl] = STATE(1494),
    [sym_preproc_line] = STATE(1494),
    [sym_identifier] = ACTIONS(3551),
    [anon_sym_EQ] = ACTIONS(3549),
    [anon_sym_LBRACK_LT] = ACTIONS(3549),
    [anon_sym_COLON] = ACTIONS(3551),
    [anon_sym_return] = ACTIONS(3551),
    [anon_sym_do] = ACTIONS(3551),
    [anon_sym_let] = ACTIONS(3551),
    [anon_sym_let_BANG] = ACTIONS(3549),
    [aux_sym_access_modifier_token1] = ACTIONS(3549),
    [anon_sym_LPAREN] = ACTIONS(3551),
    [anon_sym_COMMA] = ACTIONS(3549),
    [anon_sym_null] = ACTIONS(3551),
    [anon_sym_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_COLON] = ACTIONS(3549),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(3551),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3549),
    [anon_sym_LBRACE] = ACTIONS(3551),
    [anon_sym_LT_AT] = ACTIONS(3551),
    [anon_sym_LT_AT_AT] = ACTIONS(3551),
    [anon_sym_DOT] = ACTIONS(3551),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3549),
    [anon_sym_new] = ACTIONS(3551),
    [anon_sym_with] = ACTIONS(3551),
    [anon_sym_return_BANG] = ACTIONS(3549),
    [anon_sym_yield] = ACTIONS(3551),
    [anon_sym_yield_BANG] = ACTIONS(3549),
    [anon_sym_lazy] = ACTIONS(3551),
    [anon_sym_assert] = ACTIONS(3551),
    [anon_sym_upcast] = ACTIONS(3551),
    [anon_sym_downcast] = ACTIONS(3551),
    [anon_sym_COLON_GT] = ACTIONS(3549),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3549),
    [anon_sym_for] = ACTIONS(3551),
    [anon_sym_while] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(3551),
    [anon_sym_fun] = ACTIONS(3551),
    [anon_sym_DASH_GT] = ACTIONS(3551),
    [anon_sym_try] = ACTIONS(3551),
    [anon_sym_match] = ACTIONS(3551),
    [anon_sym_match_BANG] = ACTIONS(3549),
    [anon_sym_function] = ACTIONS(3551),
    [anon_sym_LT_DASH] = ACTIONS(3551),
    [anon_sym_DOT_LBRACK] = ACTIONS(3549),
    [anon_sym_LT] = ACTIONS(3549),
    [anon_sym_use] = ACTIONS(3551),
    [anon_sym_use_BANG] = ACTIONS(3549),
    [anon_sym_do_BANG] = ACTIONS(3549),
    [anon_sym_begin] = ACTIONS(3551),
    [anon_sym_LPAREN2] = ACTIONS(3551),
    [anon_sym_DOT_DOT2] = ACTIONS(3549),
    [anon_sym_STAR] = ACTIONS(3551),
    [anon_sym_LT2] = ACTIONS(3551),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3549),
    [anon_sym_default] = ACTIONS(3551),
    [anon_sym_or] = ACTIONS(3551),
    [anon_sym_static] = ACTIONS(3551),
    [anon_sym_member] = ACTIONS(3551),
    [anon_sym_interface] = ACTIONS(3551),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_val] = ACTIONS(3551),
    [anon_sym_override] = ACTIONS(3551),
    [aux_sym_char_token1] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [anon_sym_AT_DQUOTE] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [sym_bool] = ACTIONS(3551),
    [sym_unit] = ACTIONS(3549),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3551),
    [sym_op_identifier] = ACTIONS(3551),
    [anon_sym_PLUS] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(3551),
    [anon_sym_PLUS_DOT] = ACTIONS(3551),
    [anon_sym_DASH_DOT] = ACTIONS(3551),
    [anon_sym_PERCENT] = ACTIONS(3551),
    [anon_sym_AMP_AMP] = ACTIONS(3551),
    [anon_sym_TILDE] = ACTIONS(3549),
    [aux_sym_prefix_op_token1] = ACTIONS(3551),
    [aux_sym_infix_op_token1] = ACTIONS(3549),
    [aux_sym_infix_op_token2] = ACTIONS(3551),
    [anon_sym_PIPE_PIPE] = ACTIONS(3551),
    [anon_sym_BANG_EQ] = ACTIONS(3551),
    [anon_sym_COLON_EQ] = ACTIONS(3549),
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3551),
    [sym_int] = ACTIONS(3551),
    [sym_xint] = ACTIONS(3549),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3549),
    [sym__newline] = ACTIONS(3549),
    [sym__dedent] = ACTIONS(3549),
  },
  [1495] = {
    [sym_block_comment] = STATE(1495),
    [sym_compiler_directive_decl] = STATE(1495),
    [sym_fsi_directive_decl] = STATE(1495),
    [sym_preproc_line] = STATE(1495),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_LBRACK_LT] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [aux_sym_access_modifier_token1] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_with] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [anon_sym_DOT_LBRACK] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_default] = ACTIONS(3498),
    [anon_sym_or] = ACTIONS(3498),
    [anon_sym_static] = ACTIONS(3498),
    [anon_sym_member] = ACTIONS(3498),
    [anon_sym_interface] = ACTIONS(3498),
    [anon_sym_abstract] = ACTIONS(3498),
    [anon_sym_val] = ACTIONS(3498),
    [anon_sym_override] = ACTIONS(3498),
    [anon_sym_inherit] = ACTIONS(3498),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3498),
    [anon_sym_DASH_DOT] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3498),
    [aux_sym_infix_op_token1] = ACTIONS(3496),
    [aux_sym_infix_op_token2] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_COLON_EQ] = ACTIONS(3496),
    [anon_sym_DOLLAR] = ACTIONS(3498),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3498),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [anon_sym_POUNDendif] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
  },
  [1496] = {
    [sym_block_comment] = STATE(1496),
    [sym_compiler_directive_decl] = STATE(1496),
    [sym_fsi_directive_decl] = STATE(1496),
    [sym_preproc_line] = STATE(1496),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3375),
    [anon_sym_uy] = ACTIONS(3377),
    [anon_sym_s] = ACTIONS(3379),
    [anon_sym_us] = ACTIONS(3381),
    [anon_sym_l] = ACTIONS(3383),
    [aux_sym_uint32_token1] = ACTIONS(3385),
    [anon_sym_n] = ACTIONS(3387),
    [anon_sym_un] = ACTIONS(3389),
    [anon_sym_L] = ACTIONS(3391),
    [aux_sym_uint64_token1] = ACTIONS(3393),
    [aux_sym_bignum_token1] = ACTIONS(3395),
    [aux_sym_decimal_token1] = ACTIONS(3397),
    [anon_sym_DOT2] = ACTIONS(4285),
    [aux_sym_float_token1] = ACTIONS(4287),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
    [sym__dedent] = ACTIONS(3191),
  },
  [1497] = {
    [sym_block_comment] = STATE(1497),
    [sym_compiler_directive_decl] = STATE(1497),
    [sym_fsi_directive_decl] = STATE(1497),
    [sym_preproc_line] = STATE(1497),
    [sym_identifier] = ACTIONS(3505),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_LBRACK_LT] = ACTIONS(3503),
    [anon_sym_COLON] = ACTIONS(3505),
    [anon_sym_return] = ACTIONS(3505),
    [anon_sym_do] = ACTIONS(3505),
    [anon_sym_and] = ACTIONS(3505),
    [anon_sym_let] = ACTIONS(3505),
    [anon_sym_let_BANG] = ACTIONS(3503),
    [aux_sym_access_modifier_token1] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3505),
    [anon_sym_COMMA] = ACTIONS(3503),
    [anon_sym_null] = ACTIONS(3505),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_COLON_QMARK] = ACTIONS(3505),
    [anon_sym_COLON_COLON] = ACTIONS(3503),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3503),
    [anon_sym_LBRACE] = ACTIONS(3505),
    [anon_sym_LT_AT] = ACTIONS(3505),
    [anon_sym_LT_AT_AT] = ACTIONS(3505),
    [anon_sym_DOT] = ACTIONS(3505),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3503),
    [anon_sym_new] = ACTIONS(3505),
    [anon_sym_with] = ACTIONS(3505),
    [anon_sym_return_BANG] = ACTIONS(3503),
    [anon_sym_yield] = ACTIONS(3505),
    [anon_sym_yield_BANG] = ACTIONS(3503),
    [anon_sym_lazy] = ACTIONS(3505),
    [anon_sym_assert] = ACTIONS(3505),
    [anon_sym_upcast] = ACTIONS(3505),
    [anon_sym_downcast] = ACTIONS(3505),
    [anon_sym_COLON_GT] = ACTIONS(3503),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3503),
    [anon_sym_for] = ACTIONS(3505),
    [anon_sym_while] = ACTIONS(3505),
    [anon_sym_if] = ACTIONS(3505),
    [anon_sym_fun] = ACTIONS(3505),
    [anon_sym_DASH_GT] = ACTIONS(3505),
    [anon_sym_try] = ACTIONS(3505),
    [anon_sym_match] = ACTIONS(3505),
    [anon_sym_match_BANG] = ACTIONS(3503),
    [anon_sym_function] = ACTIONS(3505),
    [anon_sym_LT_DASH] = ACTIONS(3505),
    [anon_sym_DOT_LBRACK] = ACTIONS(3503),
    [anon_sym_LT] = ACTIONS(3503),
    [anon_sym_use] = ACTIONS(3505),
    [anon_sym_use_BANG] = ACTIONS(3503),
    [anon_sym_do_BANG] = ACTIONS(3503),
    [anon_sym_begin] = ACTIONS(3505),
    [anon_sym_LPAREN2] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3505),
    [anon_sym_LT2] = ACTIONS(4289),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_default] = ACTIONS(3505),
    [anon_sym_or] = ACTIONS(3505),
    [anon_sym_static] = ACTIONS(3505),
    [anon_sym_member] = ACTIONS(3505),
    [anon_sym_interface] = ACTIONS(3505),
    [anon_sym_abstract] = ACTIONS(3505),
    [anon_sym_val] = ACTIONS(3505),
    [anon_sym_override] = ACTIONS(3505),
    [aux_sym_char_token1] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3505),
    [anon_sym_DQUOTE] = ACTIONS(3505),
    [anon_sym_AT_DQUOTE] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [sym_bool] = ACTIONS(3505),
    [sym_unit] = ACTIONS(3503),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3505),
    [sym_op_identifier] = ACTIONS(3505),
    [anon_sym_PLUS] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3505),
    [anon_sym_PLUS_DOT] = ACTIONS(3505),
    [anon_sym_DASH_DOT] = ACTIONS(3505),
    [anon_sym_PERCENT] = ACTIONS(3505),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3503),
    [aux_sym_prefix_op_token1] = ACTIONS(3505),
    [aux_sym_infix_op_token1] = ACTIONS(3503),
    [aux_sym_infix_op_token2] = ACTIONS(3505),
    [anon_sym_PIPE_PIPE] = ACTIONS(3505),
    [anon_sym_BANG_EQ] = ACTIONS(3505),
    [anon_sym_COLON_EQ] = ACTIONS(3503),
    [anon_sym_DOLLAR] = ACTIONS(3505),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3505),
    [sym_int] = ACTIONS(3505),
    [sym_xint] = ACTIONS(3503),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3503),
    [sym__newline] = ACTIONS(3503),
    [sym__dedent] = ACTIONS(3503),
  },
  [1498] = {
    [sym_block_comment] = STATE(1498),
    [sym_compiler_directive_decl] = STATE(1498),
    [sym_fsi_directive_decl] = STATE(1498),
    [sym_preproc_line] = STATE(1498),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [aux_sym_access_modifier_token1] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_member] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_val] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [anon_sym_inherit] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [anon_sym_POUNDendif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [1499] = {
    [sym_block_comment] = STATE(1499),
    [sym_compiler_directive_decl] = STATE(1499),
    [sym_fsi_directive_decl] = STATE(1499),
    [sym_preproc_line] = STATE(1499),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_LBRACK_LT] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_and] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [aux_sym_access_modifier_token1] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_with] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [anon_sym_DOT_LBRACK] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_default] = ACTIONS(3498),
    [anon_sym_or] = ACTIONS(3498),
    [anon_sym_static] = ACTIONS(3498),
    [anon_sym_member] = ACTIONS(3498),
    [anon_sym_interface] = ACTIONS(3498),
    [anon_sym_abstract] = ACTIONS(3498),
    [anon_sym_val] = ACTIONS(3498),
    [anon_sym_override] = ACTIONS(3498),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3498),
    [anon_sym_DASH_DOT] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3498),
    [aux_sym_infix_op_token1] = ACTIONS(3496),
    [aux_sym_infix_op_token2] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_COLON_EQ] = ACTIONS(3496),
    [anon_sym_DOLLAR] = ACTIONS(3498),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3498),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
    [sym__dedent] = ACTIONS(3496),
  },
  [1500] = {
    [sym_block_comment] = STATE(1500),
    [sym_compiler_directive_decl] = STATE(1500),
    [sym_fsi_directive_decl] = STATE(1500),
    [sym_preproc_line] = STATE(1500),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_LBRACK_LT] = ACTIONS(3513),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_and] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [aux_sym_access_modifier_token1] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_COLON] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_with] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(3513),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_LT_DASH] = ACTIONS(3515),
    [anon_sym_DOT_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3515),
    [anon_sym_or] = ACTIONS(3515),
    [anon_sym_static] = ACTIONS(3515),
    [anon_sym_member] = ACTIONS(3515),
    [anon_sym_interface] = ACTIONS(3515),
    [anon_sym_abstract] = ACTIONS(3515),
    [anon_sym_val] = ACTIONS(3515),
    [anon_sym_override] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3515),
    [anon_sym_DASH_DOT] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3515),
    [aux_sym_infix_op_token1] = ACTIONS(3513),
    [aux_sym_infix_op_token2] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3515),
    [anon_sym_COLON_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(3515),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3515),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
    [sym__dedent] = ACTIONS(3513),
  },
  [1501] = {
    [sym_block_comment] = STATE(1501),
    [sym_compiler_directive_decl] = STATE(1501),
    [sym_fsi_directive_decl] = STATE(1501),
    [sym_preproc_line] = STATE(1501),
    [sym_identifier] = ACTIONS(3505),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_LBRACK_LT] = ACTIONS(3503),
    [anon_sym_COLON] = ACTIONS(3505),
    [anon_sym_return] = ACTIONS(3505),
    [anon_sym_do] = ACTIONS(3505),
    [anon_sym_let] = ACTIONS(3505),
    [anon_sym_let_BANG] = ACTIONS(3503),
    [aux_sym_access_modifier_token1] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3505),
    [anon_sym_COMMA] = ACTIONS(3503),
    [anon_sym_null] = ACTIONS(3505),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_COLON_QMARK] = ACTIONS(3505),
    [anon_sym_COLON_COLON] = ACTIONS(3503),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3503),
    [anon_sym_LBRACE] = ACTIONS(3505),
    [anon_sym_LT_AT] = ACTIONS(3505),
    [anon_sym_LT_AT_AT] = ACTIONS(3505),
    [anon_sym_DOT] = ACTIONS(3505),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3503),
    [anon_sym_new] = ACTIONS(3505),
    [anon_sym_with] = ACTIONS(3505),
    [anon_sym_return_BANG] = ACTIONS(3503),
    [anon_sym_yield] = ACTIONS(3505),
    [anon_sym_yield_BANG] = ACTIONS(3503),
    [anon_sym_lazy] = ACTIONS(3505),
    [anon_sym_assert] = ACTIONS(3505),
    [anon_sym_upcast] = ACTIONS(3505),
    [anon_sym_downcast] = ACTIONS(3505),
    [anon_sym_COLON_GT] = ACTIONS(3503),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3503),
    [anon_sym_for] = ACTIONS(3505),
    [anon_sym_while] = ACTIONS(3505),
    [anon_sym_if] = ACTIONS(3505),
    [anon_sym_fun] = ACTIONS(3505),
    [anon_sym_DASH_GT] = ACTIONS(3505),
    [anon_sym_try] = ACTIONS(3505),
    [anon_sym_match] = ACTIONS(3505),
    [anon_sym_match_BANG] = ACTIONS(3503),
    [anon_sym_function] = ACTIONS(3505),
    [anon_sym_LT_DASH] = ACTIONS(3505),
    [anon_sym_DOT_LBRACK] = ACTIONS(3503),
    [anon_sym_LT] = ACTIONS(3503),
    [anon_sym_use] = ACTIONS(3505),
    [anon_sym_use_BANG] = ACTIONS(3503),
    [anon_sym_do_BANG] = ACTIONS(3503),
    [anon_sym_begin] = ACTIONS(3505),
    [anon_sym_LPAREN2] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3505),
    [anon_sym_LT2] = ACTIONS(4291),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_default] = ACTIONS(3505),
    [anon_sym_or] = ACTIONS(3505),
    [anon_sym_static] = ACTIONS(3505),
    [anon_sym_member] = ACTIONS(3505),
    [anon_sym_interface] = ACTIONS(3505),
    [anon_sym_abstract] = ACTIONS(3505),
    [anon_sym_val] = ACTIONS(3505),
    [anon_sym_override] = ACTIONS(3505),
    [anon_sym_inherit] = ACTIONS(3505),
    [aux_sym_char_token1] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3505),
    [anon_sym_DQUOTE] = ACTIONS(3505),
    [anon_sym_AT_DQUOTE] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [sym_bool] = ACTIONS(3505),
    [sym_unit] = ACTIONS(3503),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3505),
    [sym_op_identifier] = ACTIONS(3505),
    [anon_sym_PLUS] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3505),
    [anon_sym_PLUS_DOT] = ACTIONS(3505),
    [anon_sym_DASH_DOT] = ACTIONS(3505),
    [anon_sym_PERCENT] = ACTIONS(3505),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3503),
    [aux_sym_prefix_op_token1] = ACTIONS(3505),
    [aux_sym_infix_op_token1] = ACTIONS(3503),
    [aux_sym_infix_op_token2] = ACTIONS(3505),
    [anon_sym_PIPE_PIPE] = ACTIONS(3505),
    [anon_sym_BANG_EQ] = ACTIONS(3505),
    [anon_sym_COLON_EQ] = ACTIONS(3503),
    [anon_sym_DOLLAR] = ACTIONS(3505),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3505),
    [sym_int] = ACTIONS(3505),
    [sym_xint] = ACTIONS(3503),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3503),
    [anon_sym_POUNDendif] = ACTIONS(3503),
    [sym__newline] = ACTIONS(3503),
  },
  [1502] = {
    [sym_block_comment] = STATE(1502),
    [sym_compiler_directive_decl] = STATE(1502),
    [sym_fsi_directive_decl] = STATE(1502),
    [sym_preproc_line] = STATE(1502),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(3521),
    [anon_sym_LBRACK_LT] = ACTIONS(3521),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_and] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3521),
    [aux_sym_access_modifier_token1] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_COMMA] = ACTIONS(3521),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_COLON] = ACTIONS(3521),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_with] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3521),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3521),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_COLON_GT] = ACTIONS(3521),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_DASH_GT] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3521),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_LT_DASH] = ACTIONS(3523),
    [anon_sym_DOT_LBRACK] = ACTIONS(3521),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3521),
    [anon_sym_do_BANG] = ACTIONS(3521),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_LPAREN2] = ACTIONS(3523),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_LT2] = ACTIONS(3523),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3521),
    [anon_sym_default] = ACTIONS(3523),
    [anon_sym_or] = ACTIONS(3523),
    [anon_sym_static] = ACTIONS(3523),
    [anon_sym_member] = ACTIONS(3523),
    [anon_sym_interface] = ACTIONS(3523),
    [anon_sym_abstract] = ACTIONS(3523),
    [anon_sym_val] = ACTIONS(3523),
    [anon_sym_override] = ACTIONS(3523),
    [aux_sym_char_token1] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3521),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3523),
    [anon_sym_DASH_DOT] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3521),
    [aux_sym_prefix_op_token1] = ACTIONS(3523),
    [aux_sym_infix_op_token1] = ACTIONS(3521),
    [aux_sym_infix_op_token2] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3523),
    [anon_sym_COLON_EQ] = ACTIONS(3521),
    [anon_sym_DOLLAR] = ACTIONS(3523),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3523),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3521),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3521),
    [sym__newline] = ACTIONS(3521),
    [sym__dedent] = ACTIONS(3521),
  },
  [1503] = {
    [sym_block_comment] = STATE(1503),
    [sym_compiler_directive_decl] = STATE(1503),
    [sym_fsi_directive_decl] = STATE(1503),
    [sym_preproc_line] = STATE(1503),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_LBRACK_LT] = ACTIONS(3513),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_and] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [aux_sym_access_modifier_token1] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_COLON] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_with] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(3513),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_LT_DASH] = ACTIONS(3515),
    [anon_sym_DOT_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3515),
    [anon_sym_or] = ACTIONS(3515),
    [anon_sym_static] = ACTIONS(3515),
    [anon_sym_member] = ACTIONS(3515),
    [anon_sym_interface] = ACTIONS(3515),
    [anon_sym_abstract] = ACTIONS(3515),
    [anon_sym_val] = ACTIONS(3515),
    [anon_sym_override] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3515),
    [anon_sym_DASH_DOT] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3515),
    [aux_sym_infix_op_token1] = ACTIONS(3513),
    [aux_sym_infix_op_token2] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3515),
    [anon_sym_COLON_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(3515),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3515),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
    [sym__dedent] = ACTIONS(3513),
  },
  [1504] = {
    [sym_block_comment] = STATE(1504),
    [sym_compiler_directive_decl] = STATE(1504),
    [sym_fsi_directive_decl] = STATE(1504),
    [sym_preproc_line] = STATE(1504),
    [sym_identifier] = ACTIONS(3511),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_LBRACK_LT] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3511),
    [anon_sym_return] = ACTIONS(3511),
    [anon_sym_do] = ACTIONS(3511),
    [anon_sym_let] = ACTIONS(3511),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [aux_sym_access_modifier_token1] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3511),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3511),
    [anon_sym_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(3511),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_LT_AT] = ACTIONS(3511),
    [anon_sym_LT_AT_AT] = ACTIONS(3511),
    [anon_sym_DOT] = ACTIONS(3511),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3511),
    [anon_sym_with] = ACTIONS(3511),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3511),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3511),
    [anon_sym_assert] = ACTIONS(3511),
    [anon_sym_upcast] = ACTIONS(3511),
    [anon_sym_downcast] = ACTIONS(3511),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3511),
    [anon_sym_while] = ACTIONS(3511),
    [anon_sym_if] = ACTIONS(3511),
    [anon_sym_fun] = ACTIONS(3511),
    [anon_sym_DASH_GT] = ACTIONS(3511),
    [anon_sym_try] = ACTIONS(3511),
    [anon_sym_match] = ACTIONS(3511),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3511),
    [anon_sym_LT_DASH] = ACTIONS(3511),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3511),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3511),
    [anon_sym_LPAREN2] = ACTIONS(3511),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_LT2] = ACTIONS(3511),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3509),
    [anon_sym_default] = ACTIONS(3511),
    [anon_sym_or] = ACTIONS(3511),
    [anon_sym_static] = ACTIONS(3511),
    [anon_sym_member] = ACTIONS(3511),
    [anon_sym_interface] = ACTIONS(3511),
    [anon_sym_abstract] = ACTIONS(3511),
    [anon_sym_val] = ACTIONS(3511),
    [anon_sym_override] = ACTIONS(3511),
    [anon_sym_inherit] = ACTIONS(3511),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3511),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3511),
    [sym_unit] = ACTIONS(3509),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3511),
    [sym_op_identifier] = ACTIONS(3511),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3511),
    [anon_sym_PLUS_DOT] = ACTIONS(3511),
    [anon_sym_DASH_DOT] = ACTIONS(3511),
    [anon_sym_PERCENT] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3511),
    [aux_sym_infix_op_token1] = ACTIONS(3509),
    [aux_sym_infix_op_token2] = ACTIONS(3511),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_BANG_EQ] = ACTIONS(3511),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3511),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3511),
    [sym_int] = ACTIONS(3511),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [anon_sym_POUNDendif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [1505] = {
    [sym_block_comment] = STATE(1505),
    [sym_compiler_directive_decl] = STATE(1505),
    [sym_fsi_directive_decl] = STATE(1505),
    [sym_preproc_line] = STATE(1505),
    [sym_identifier] = ACTIONS(3539),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_LBRACK_LT] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3539),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_do] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3539),
    [anon_sym_let_BANG] = ACTIONS(3537),
    [aux_sym_access_modifier_token1] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_null] = ACTIONS(3539),
    [anon_sym_QMARK] = ACTIONS(3539),
    [anon_sym_COLON_QMARK] = ACTIONS(3539),
    [anon_sym_COLON_COLON] = ACTIONS(3537),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3537),
    [anon_sym_LBRACE] = ACTIONS(3539),
    [anon_sym_LT_AT] = ACTIONS(3539),
    [anon_sym_LT_AT_AT] = ACTIONS(3539),
    [anon_sym_DOT] = ACTIONS(3539),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3537),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_with] = ACTIONS(3539),
    [anon_sym_return_BANG] = ACTIONS(3537),
    [anon_sym_yield] = ACTIONS(3539),
    [anon_sym_yield_BANG] = ACTIONS(3537),
    [anon_sym_lazy] = ACTIONS(3539),
    [anon_sym_assert] = ACTIONS(3539),
    [anon_sym_upcast] = ACTIONS(3539),
    [anon_sym_downcast] = ACTIONS(3539),
    [anon_sym_COLON_GT] = ACTIONS(3537),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3537),
    [anon_sym_for] = ACTIONS(3539),
    [anon_sym_while] = ACTIONS(3539),
    [anon_sym_if] = ACTIONS(3539),
    [anon_sym_fun] = ACTIONS(3539),
    [anon_sym_DASH_GT] = ACTIONS(3539),
    [anon_sym_try] = ACTIONS(3539),
    [anon_sym_match] = ACTIONS(3539),
    [anon_sym_match_BANG] = ACTIONS(3537),
    [anon_sym_function] = ACTIONS(3539),
    [anon_sym_LT_DASH] = ACTIONS(3539),
    [anon_sym_DOT_LBRACK] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_use] = ACTIONS(3539),
    [anon_sym_use_BANG] = ACTIONS(3537),
    [anon_sym_do_BANG] = ACTIONS(3537),
    [anon_sym_begin] = ACTIONS(3539),
    [anon_sym_LPAREN2] = ACTIONS(3539),
    [anon_sym_DOT_DOT2] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_LT2] = ACTIONS(3539),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_default] = ACTIONS(3539),
    [anon_sym_or] = ACTIONS(3539),
    [anon_sym_static] = ACTIONS(3539),
    [anon_sym_member] = ACTIONS(3539),
    [anon_sym_interface] = ACTIONS(3539),
    [anon_sym_abstract] = ACTIONS(3539),
    [anon_sym_val] = ACTIONS(3539),
    [anon_sym_override] = ACTIONS(3539),
    [aux_sym_char_token1] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3539),
    [anon_sym_DQUOTE] = ACTIONS(3539),
    [anon_sym_AT_DQUOTE] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [sym_bool] = ACTIONS(3539),
    [sym_unit] = ACTIONS(3537),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3539),
    [sym_op_identifier] = ACTIONS(3539),
    [anon_sym_PLUS] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(3539),
    [anon_sym_PLUS_DOT] = ACTIONS(3539),
    [anon_sym_DASH_DOT] = ACTIONS(3539),
    [anon_sym_PERCENT] = ACTIONS(3539),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_TILDE] = ACTIONS(3537),
    [aux_sym_prefix_op_token1] = ACTIONS(3539),
    [aux_sym_infix_op_token1] = ACTIONS(3537),
    [aux_sym_infix_op_token2] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3539),
    [anon_sym_BANG_EQ] = ACTIONS(3539),
    [anon_sym_COLON_EQ] = ACTIONS(3537),
    [anon_sym_DOLLAR] = ACTIONS(3539),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3539),
    [sym_int] = ACTIONS(3539),
    [sym_xint] = ACTIONS(3537),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3537),
    [sym__newline] = ACTIONS(3537),
    [sym__dedent] = ACTIONS(3537),
  },
  [1506] = {
    [sym_block_comment] = STATE(1506),
    [sym_compiler_directive_decl] = STATE(1506),
    [sym_fsi_directive_decl] = STATE(1506),
    [sym_preproc_line] = STATE(1506),
    [sym_identifier] = ACTIONS(3543),
    [anon_sym_EQ] = ACTIONS(3541),
    [anon_sym_LBRACK_LT] = ACTIONS(3541),
    [anon_sym_COLON] = ACTIONS(3543),
    [anon_sym_return] = ACTIONS(3543),
    [anon_sym_do] = ACTIONS(3543),
    [anon_sym_and] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3543),
    [anon_sym_let_BANG] = ACTIONS(3541),
    [aux_sym_access_modifier_token1] = ACTIONS(3541),
    [anon_sym_LPAREN] = ACTIONS(3543),
    [anon_sym_COMMA] = ACTIONS(3541),
    [anon_sym_null] = ACTIONS(3543),
    [anon_sym_QMARK] = ACTIONS(3543),
    [anon_sym_COLON_QMARK] = ACTIONS(3543),
    [anon_sym_COLON_COLON] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3543),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3541),
    [anon_sym_LBRACE] = ACTIONS(3543),
    [anon_sym_LT_AT] = ACTIONS(3543),
    [anon_sym_LT_AT_AT] = ACTIONS(3543),
    [anon_sym_DOT] = ACTIONS(3543),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3541),
    [anon_sym_new] = ACTIONS(3543),
    [anon_sym_with] = ACTIONS(3543),
    [anon_sym_return_BANG] = ACTIONS(3541),
    [anon_sym_yield] = ACTIONS(3543),
    [anon_sym_yield_BANG] = ACTIONS(3541),
    [anon_sym_lazy] = ACTIONS(3543),
    [anon_sym_assert] = ACTIONS(3543),
    [anon_sym_upcast] = ACTIONS(3543),
    [anon_sym_downcast] = ACTIONS(3543),
    [anon_sym_COLON_GT] = ACTIONS(3541),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3541),
    [anon_sym_for] = ACTIONS(3543),
    [anon_sym_while] = ACTIONS(3543),
    [anon_sym_if] = ACTIONS(3543),
    [anon_sym_fun] = ACTIONS(3543),
    [anon_sym_DASH_GT] = ACTIONS(3543),
    [anon_sym_try] = ACTIONS(3543),
    [anon_sym_match] = ACTIONS(3543),
    [anon_sym_match_BANG] = ACTIONS(3541),
    [anon_sym_function] = ACTIONS(3543),
    [anon_sym_LT_DASH] = ACTIONS(3543),
    [anon_sym_DOT_LBRACK] = ACTIONS(3541),
    [anon_sym_LT] = ACTIONS(3541),
    [anon_sym_use] = ACTIONS(3543),
    [anon_sym_use_BANG] = ACTIONS(3541),
    [anon_sym_do_BANG] = ACTIONS(3541),
    [anon_sym_begin] = ACTIONS(3543),
    [anon_sym_LPAREN2] = ACTIONS(3543),
    [anon_sym_STAR] = ACTIONS(3543),
    [anon_sym_LT2] = ACTIONS(3543),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_default] = ACTIONS(3543),
    [anon_sym_or] = ACTIONS(3543),
    [anon_sym_static] = ACTIONS(3543),
    [anon_sym_member] = ACTIONS(3543),
    [anon_sym_interface] = ACTIONS(3543),
    [anon_sym_abstract] = ACTIONS(3543),
    [anon_sym_val] = ACTIONS(3543),
    [anon_sym_override] = ACTIONS(3543),
    [aux_sym_char_token1] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3543),
    [anon_sym_DQUOTE] = ACTIONS(3543),
    [anon_sym_AT_DQUOTE] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [sym_bool] = ACTIONS(3543),
    [sym_unit] = ACTIONS(3541),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3543),
    [sym_op_identifier] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(3543),
    [anon_sym_DASH] = ACTIONS(3543),
    [anon_sym_PLUS_DOT] = ACTIONS(3543),
    [anon_sym_DASH_DOT] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3543),
    [anon_sym_AMP_AMP] = ACTIONS(3543),
    [anon_sym_TILDE] = ACTIONS(3541),
    [aux_sym_prefix_op_token1] = ACTIONS(3543),
    [aux_sym_infix_op_token1] = ACTIONS(3541),
    [aux_sym_infix_op_token2] = ACTIONS(3543),
    [anon_sym_PIPE_PIPE] = ACTIONS(3543),
    [anon_sym_BANG_EQ] = ACTIONS(3543),
    [anon_sym_COLON_EQ] = ACTIONS(3541),
    [anon_sym_DOLLAR] = ACTIONS(3543),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3543),
    [sym_int] = ACTIONS(3543),
    [sym_xint] = ACTIONS(3541),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3541),
    [anon_sym_POUNDendif] = ACTIONS(3541),
    [sym__newline] = ACTIONS(3541),
  },
  [1507] = {
    [sym_block_comment] = STATE(1507),
    [sym_compiler_directive_decl] = STATE(1507),
    [sym_fsi_directive_decl] = STATE(1507),
    [sym_preproc_line] = STATE(1507),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_LBRACK_LT] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_and] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [aux_sym_access_modifier_token1] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_COLON] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_with] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_LT_DASH] = ACTIONS(3480),
    [anon_sym_DOT_LBRACK] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_default] = ACTIONS(3480),
    [anon_sym_or] = ACTIONS(3480),
    [anon_sym_static] = ACTIONS(3480),
    [anon_sym_member] = ACTIONS(3480),
    [anon_sym_interface] = ACTIONS(3480),
    [anon_sym_abstract] = ACTIONS(3480),
    [anon_sym_val] = ACTIONS(3480),
    [anon_sym_override] = ACTIONS(3480),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3480),
    [anon_sym_DASH_DOT] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3480),
    [aux_sym_infix_op_token1] = ACTIONS(3478),
    [aux_sym_infix_op_token2] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3480),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [anon_sym_POUNDendif] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
  },
  [1508] = {
    [sym_block_comment] = STATE(1508),
    [sym_compiler_directive_decl] = STATE(1508),
    [sym_fsi_directive_decl] = STATE(1508),
    [sym_preproc_line] = STATE(1508),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [aux_sym_access_modifier_token1] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_DOT_DOT2] = ACTIONS(3485),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_member] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_val] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
    [sym__dedent] = ACTIONS(3485),
  },
  [1509] = {
    [sym_block_comment] = STATE(1509),
    [sym_compiler_directive_decl] = STATE(1509),
    [sym_fsi_directive_decl] = STATE(1509),
    [sym_preproc_line] = STATE(1509),
    [sym_identifier] = ACTIONS(3547),
    [anon_sym_EQ] = ACTIONS(3545),
    [anon_sym_LBRACK_LT] = ACTIONS(3545),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_return] = ACTIONS(3547),
    [anon_sym_do] = ACTIONS(3547),
    [anon_sym_and] = ACTIONS(3547),
    [anon_sym_let] = ACTIONS(3547),
    [anon_sym_let_BANG] = ACTIONS(3545),
    [aux_sym_access_modifier_token1] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(3547),
    [anon_sym_COMMA] = ACTIONS(3545),
    [anon_sym_null] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3547),
    [anon_sym_COLON_QMARK] = ACTIONS(3547),
    [anon_sym_COLON_COLON] = ACTIONS(3545),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3545),
    [anon_sym_LBRACE] = ACTIONS(3547),
    [anon_sym_LT_AT] = ACTIONS(3547),
    [anon_sym_LT_AT_AT] = ACTIONS(3547),
    [anon_sym_DOT] = ACTIONS(3547),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3545),
    [anon_sym_new] = ACTIONS(3547),
    [anon_sym_with] = ACTIONS(3547),
    [anon_sym_return_BANG] = ACTIONS(3545),
    [anon_sym_yield] = ACTIONS(3547),
    [anon_sym_yield_BANG] = ACTIONS(3545),
    [anon_sym_lazy] = ACTIONS(3547),
    [anon_sym_assert] = ACTIONS(3547),
    [anon_sym_upcast] = ACTIONS(3547),
    [anon_sym_downcast] = ACTIONS(3547),
    [anon_sym_COLON_GT] = ACTIONS(3545),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3545),
    [anon_sym_for] = ACTIONS(3547),
    [anon_sym_while] = ACTIONS(3547),
    [anon_sym_if] = ACTIONS(3547),
    [anon_sym_fun] = ACTIONS(3547),
    [anon_sym_DASH_GT] = ACTIONS(3547),
    [anon_sym_try] = ACTIONS(3547),
    [anon_sym_match] = ACTIONS(3547),
    [anon_sym_match_BANG] = ACTIONS(3545),
    [anon_sym_function] = ACTIONS(3547),
    [anon_sym_LT_DASH] = ACTIONS(3547),
    [anon_sym_DOT_LBRACK] = ACTIONS(3545),
    [anon_sym_LT] = ACTIONS(3545),
    [anon_sym_use] = ACTIONS(3547),
    [anon_sym_use_BANG] = ACTIONS(3545),
    [anon_sym_do_BANG] = ACTIONS(3545),
    [anon_sym_begin] = ACTIONS(3547),
    [anon_sym_LPAREN2] = ACTIONS(3547),
    [anon_sym_STAR] = ACTIONS(3547),
    [anon_sym_LT2] = ACTIONS(3547),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_default] = ACTIONS(3547),
    [anon_sym_or] = ACTIONS(3547),
    [anon_sym_static] = ACTIONS(3547),
    [anon_sym_member] = ACTIONS(3547),
    [anon_sym_interface] = ACTIONS(3547),
    [anon_sym_abstract] = ACTIONS(3547),
    [anon_sym_val] = ACTIONS(3547),
    [anon_sym_override] = ACTIONS(3547),
    [aux_sym_char_token1] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3547),
    [anon_sym_DQUOTE] = ACTIONS(3547),
    [anon_sym_AT_DQUOTE] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [sym_bool] = ACTIONS(3547),
    [sym_unit] = ACTIONS(3545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3547),
    [sym_op_identifier] = ACTIONS(3547),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PLUS_DOT] = ACTIONS(3547),
    [anon_sym_DASH_DOT] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3547),
    [anon_sym_AMP_AMP] = ACTIONS(3547),
    [anon_sym_TILDE] = ACTIONS(3545),
    [aux_sym_prefix_op_token1] = ACTIONS(3547),
    [aux_sym_infix_op_token1] = ACTIONS(3545),
    [aux_sym_infix_op_token2] = ACTIONS(3547),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_BANG_EQ] = ACTIONS(3547),
    [anon_sym_COLON_EQ] = ACTIONS(3545),
    [anon_sym_DOLLAR] = ACTIONS(3547),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3547),
    [sym_int] = ACTIONS(3547),
    [sym_xint] = ACTIONS(3545),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3545),
    [anon_sym_POUNDendif] = ACTIONS(3545),
    [sym__newline] = ACTIONS(3545),
  },
  [1510] = {
    [sym_block_comment] = STATE(1510),
    [sym_compiler_directive_decl] = STATE(1510),
    [sym_fsi_directive_decl] = STATE(1510),
    [sym_preproc_line] = STATE(1510),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_DASH_GT] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_DOT_DOT] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(4293),
    [anon_sym_uy] = ACTIONS(4295),
    [anon_sym_s] = ACTIONS(4297),
    [anon_sym_us] = ACTIONS(4299),
    [anon_sym_l] = ACTIONS(4301),
    [aux_sym_uint32_token1] = ACTIONS(4303),
    [anon_sym_n] = ACTIONS(4305),
    [anon_sym_un] = ACTIONS(4307),
    [anon_sym_L] = ACTIONS(4309),
    [aux_sym_uint64_token1] = ACTIONS(4311),
    [aux_sym_bignum_token1] = ACTIONS(4313),
    [aux_sym_decimal_token1] = ACTIONS(4315),
    [anon_sym_DOT2] = ACTIONS(4317),
    [aux_sym_float_token1] = ACTIONS(4319),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1511] = {
    [sym_block_comment] = STATE(1511),
    [sym_compiler_directive_decl] = STATE(1511),
    [sym_fsi_directive_decl] = STATE(1511),
    [sym_preproc_line] = STATE(1511),
    [sym_identifier] = ACTIONS(3511),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_LBRACK_LT] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3511),
    [anon_sym_return] = ACTIONS(3511),
    [anon_sym_do] = ACTIONS(3511),
    [anon_sym_and] = ACTIONS(3511),
    [anon_sym_let] = ACTIONS(3511),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [aux_sym_access_modifier_token1] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3511),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3511),
    [anon_sym_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(3511),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_LT_AT] = ACTIONS(3511),
    [anon_sym_LT_AT_AT] = ACTIONS(3511),
    [anon_sym_DOT] = ACTIONS(3511),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3511),
    [anon_sym_with] = ACTIONS(3511),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3511),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3511),
    [anon_sym_assert] = ACTIONS(3511),
    [anon_sym_upcast] = ACTIONS(3511),
    [anon_sym_downcast] = ACTIONS(3511),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3511),
    [anon_sym_while] = ACTIONS(3511),
    [anon_sym_if] = ACTIONS(3511),
    [anon_sym_fun] = ACTIONS(3511),
    [anon_sym_DASH_GT] = ACTIONS(3511),
    [anon_sym_try] = ACTIONS(3511),
    [anon_sym_match] = ACTIONS(3511),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3511),
    [anon_sym_LT_DASH] = ACTIONS(3511),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3511),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3511),
    [anon_sym_LPAREN2] = ACTIONS(3511),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_LT2] = ACTIONS(3511),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3509),
    [anon_sym_default] = ACTIONS(3511),
    [anon_sym_or] = ACTIONS(3511),
    [anon_sym_static] = ACTIONS(3511),
    [anon_sym_member] = ACTIONS(3511),
    [anon_sym_interface] = ACTIONS(3511),
    [anon_sym_abstract] = ACTIONS(3511),
    [anon_sym_val] = ACTIONS(3511),
    [anon_sym_override] = ACTIONS(3511),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3511),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3511),
    [sym_unit] = ACTIONS(3509),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3511),
    [sym_op_identifier] = ACTIONS(3511),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3511),
    [anon_sym_PLUS_DOT] = ACTIONS(3511),
    [anon_sym_DASH_DOT] = ACTIONS(3511),
    [anon_sym_PERCENT] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3511),
    [aux_sym_infix_op_token1] = ACTIONS(3509),
    [aux_sym_infix_op_token2] = ACTIONS(3511),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_BANG_EQ] = ACTIONS(3511),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3511),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3511),
    [sym_int] = ACTIONS(3511),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
    [sym__dedent] = ACTIONS(3509),
  },
  [1512] = {
    [sym_block_comment] = STATE(1512),
    [sym_compiler_directive_decl] = STATE(1512),
    [sym_fsi_directive_decl] = STATE(1512),
    [sym_preproc_line] = STATE(1512),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_LBRACK_LT] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_and] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [aux_sym_access_modifier_token1] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_COLON] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_with] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_LT_DASH] = ACTIONS(3480),
    [anon_sym_DOT_LBRACK] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_default] = ACTIONS(3480),
    [anon_sym_or] = ACTIONS(3480),
    [anon_sym_static] = ACTIONS(3480),
    [anon_sym_member] = ACTIONS(3480),
    [anon_sym_interface] = ACTIONS(3480),
    [anon_sym_abstract] = ACTIONS(3480),
    [anon_sym_val] = ACTIONS(3480),
    [anon_sym_override] = ACTIONS(3480),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3480),
    [anon_sym_DASH_DOT] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3480),
    [aux_sym_infix_op_token1] = ACTIONS(3478),
    [aux_sym_infix_op_token2] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3480),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
    [sym__dedent] = ACTIONS(3478),
  },
  [1513] = {
    [sym_block_comment] = STATE(1513),
    [sym_compiler_directive_decl] = STATE(1513),
    [sym_fsi_directive_decl] = STATE(1513),
    [sym_preproc_line] = STATE(1513),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_LBRACK_LT] = ACTIONS(3513),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [aux_sym_access_modifier_token1] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_COLON] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_with] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(3513),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_LT_DASH] = ACTIONS(3515),
    [anon_sym_DOT_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3515),
    [anon_sym_or] = ACTIONS(3515),
    [anon_sym_static] = ACTIONS(3515),
    [anon_sym_member] = ACTIONS(3515),
    [anon_sym_interface] = ACTIONS(3515),
    [anon_sym_abstract] = ACTIONS(3515),
    [anon_sym_val] = ACTIONS(3515),
    [anon_sym_override] = ACTIONS(3515),
    [anon_sym_inherit] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3515),
    [anon_sym_DASH_DOT] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3515),
    [aux_sym_infix_op_token1] = ACTIONS(3513),
    [aux_sym_infix_op_token2] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3515),
    [anon_sym_COLON_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(3515),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3515),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [anon_sym_POUNDendif] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
  },
  [1514] = {
    [sym_block_comment] = STATE(1514),
    [sym_compiler_directive_decl] = STATE(1514),
    [sym_fsi_directive_decl] = STATE(1514),
    [sym_preproc_line] = STATE(1514),
    [sym_identifier] = ACTIONS(3511),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_LBRACK_LT] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3511),
    [anon_sym_return] = ACTIONS(3511),
    [anon_sym_do] = ACTIONS(3511),
    [anon_sym_and] = ACTIONS(3511),
    [anon_sym_let] = ACTIONS(3511),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [aux_sym_access_modifier_token1] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3511),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3511),
    [anon_sym_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(3511),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_LT_AT] = ACTIONS(3511),
    [anon_sym_LT_AT_AT] = ACTIONS(3511),
    [anon_sym_DOT] = ACTIONS(3511),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3511),
    [anon_sym_with] = ACTIONS(3511),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3511),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3511),
    [anon_sym_assert] = ACTIONS(3511),
    [anon_sym_upcast] = ACTIONS(3511),
    [anon_sym_downcast] = ACTIONS(3511),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3511),
    [anon_sym_while] = ACTIONS(3511),
    [anon_sym_if] = ACTIONS(3511),
    [anon_sym_fun] = ACTIONS(3511),
    [anon_sym_DASH_GT] = ACTIONS(3511),
    [anon_sym_try] = ACTIONS(3511),
    [anon_sym_match] = ACTIONS(3511),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3511),
    [anon_sym_LT_DASH] = ACTIONS(3511),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3511),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3511),
    [anon_sym_LPAREN2] = ACTIONS(3511),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_LT2] = ACTIONS(3511),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3509),
    [anon_sym_default] = ACTIONS(3511),
    [anon_sym_or] = ACTIONS(3511),
    [anon_sym_static] = ACTIONS(3511),
    [anon_sym_member] = ACTIONS(3511),
    [anon_sym_interface] = ACTIONS(3511),
    [anon_sym_abstract] = ACTIONS(3511),
    [anon_sym_val] = ACTIONS(3511),
    [anon_sym_override] = ACTIONS(3511),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3511),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3511),
    [sym_unit] = ACTIONS(3509),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3511),
    [sym_op_identifier] = ACTIONS(3511),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3511),
    [anon_sym_PLUS_DOT] = ACTIONS(3511),
    [anon_sym_DASH_DOT] = ACTIONS(3511),
    [anon_sym_PERCENT] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3511),
    [aux_sym_infix_op_token1] = ACTIONS(3509),
    [aux_sym_infix_op_token2] = ACTIONS(3511),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_BANG_EQ] = ACTIONS(3511),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3511),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3511),
    [sym_int] = ACTIONS(3511),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [anon_sym_POUNDendif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [1515] = {
    [sym_block_comment] = STATE(1515),
    [sym_compiler_directive_decl] = STATE(1515),
    [sym_fsi_directive_decl] = STATE(1515),
    [sym_preproc_line] = STATE(1515),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_LBRACK_LT] = ACTIONS(3513),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [aux_sym_access_modifier_token1] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_COLON] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_with] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(3513),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_LT_DASH] = ACTIONS(3515),
    [anon_sym_DOT_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3515),
    [anon_sym_or] = ACTIONS(3515),
    [anon_sym_static] = ACTIONS(3515),
    [anon_sym_member] = ACTIONS(3515),
    [anon_sym_interface] = ACTIONS(3515),
    [anon_sym_abstract] = ACTIONS(3515),
    [anon_sym_val] = ACTIONS(3515),
    [anon_sym_override] = ACTIONS(3515),
    [anon_sym_inherit] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3515),
    [anon_sym_DASH_DOT] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3515),
    [aux_sym_infix_op_token1] = ACTIONS(3513),
    [aux_sym_infix_op_token2] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3515),
    [anon_sym_COLON_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(3515),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3515),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [anon_sym_POUNDendif] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
  },
  [1516] = {
    [sym_elif_expression] = STATE(1661),
    [sym_block_comment] = STATE(1516),
    [sym_compiler_directive_decl] = STATE(1516),
    [sym_fsi_directive_decl] = STATE(1516),
    [sym_preproc_line] = STATE(1516),
    [aux_sym_if_expression_repeat1] = STATE(1516),
    [sym_identifier] = ACTIONS(3555),
    [anon_sym_EQ] = ACTIONS(3553),
    [anon_sym_LBRACK_LT] = ACTIONS(3553),
    [anon_sym_COLON] = ACTIONS(3555),
    [anon_sym_return] = ACTIONS(3555),
    [anon_sym_do] = ACTIONS(3555),
    [anon_sym_let] = ACTIONS(3555),
    [anon_sym_let_BANG] = ACTIONS(3553),
    [aux_sym_access_modifier_token1] = ACTIONS(3553),
    [anon_sym_LPAREN] = ACTIONS(3555),
    [anon_sym_COMMA] = ACTIONS(3553),
    [anon_sym_null] = ACTIONS(3555),
    [anon_sym_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_COLON] = ACTIONS(3553),
    [anon_sym_AMP] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(3555),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3553),
    [anon_sym_LBRACE] = ACTIONS(3555),
    [anon_sym_LT_AT] = ACTIONS(3555),
    [anon_sym_LT_AT_AT] = ACTIONS(3555),
    [anon_sym_DOT] = ACTIONS(3555),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3553),
    [anon_sym_new] = ACTIONS(3555),
    [anon_sym_with] = ACTIONS(3555),
    [anon_sym_return_BANG] = ACTIONS(3553),
    [anon_sym_yield] = ACTIONS(3555),
    [anon_sym_yield_BANG] = ACTIONS(3553),
    [anon_sym_lazy] = ACTIONS(3555),
    [anon_sym_assert] = ACTIONS(3555),
    [anon_sym_upcast] = ACTIONS(3555),
    [anon_sym_downcast] = ACTIONS(3555),
    [anon_sym_COLON_GT] = ACTIONS(3553),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3553),
    [anon_sym_for] = ACTIONS(3555),
    [anon_sym_while] = ACTIONS(3555),
    [anon_sym_else] = ACTIONS(3555),
    [anon_sym_elif] = ACTIONS(4321),
    [anon_sym_if] = ACTIONS(3555),
    [anon_sym_fun] = ACTIONS(3555),
    [anon_sym_try] = ACTIONS(3555),
    [anon_sym_match] = ACTIONS(3555),
    [anon_sym_match_BANG] = ACTIONS(3553),
    [anon_sym_function] = ACTIONS(3555),
    [anon_sym_LT_DASH] = ACTIONS(3555),
    [anon_sym_DOT_LBRACK] = ACTIONS(3553),
    [anon_sym_LT] = ACTIONS(3553),
    [anon_sym_use] = ACTIONS(3555),
    [anon_sym_use_BANG] = ACTIONS(3553),
    [anon_sym_do_BANG] = ACTIONS(3553),
    [anon_sym_begin] = ACTIONS(3555),
    [anon_sym_LPAREN2] = ACTIONS(3555),
    [anon_sym_DOT_DOT2] = ACTIONS(3553),
    [anon_sym_default] = ACTIONS(3555),
    [anon_sym_or] = ACTIONS(3555),
    [anon_sym_static] = ACTIONS(3555),
    [anon_sym_member] = ACTIONS(3555),
    [anon_sym_interface] = ACTIONS(3555),
    [anon_sym_abstract] = ACTIONS(3555),
    [anon_sym_val] = ACTIONS(3555),
    [anon_sym_override] = ACTIONS(3555),
    [aux_sym_char_token1] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3555),
    [anon_sym_DQUOTE] = ACTIONS(3555),
    [anon_sym_AT_DQUOTE] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [sym_bool] = ACTIONS(3555),
    [sym_unit] = ACTIONS(3553),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3555),
    [sym_op_identifier] = ACTIONS(3555),
    [anon_sym_PLUS] = ACTIONS(3555),
    [anon_sym_DASH] = ACTIONS(3555),
    [anon_sym_PLUS_DOT] = ACTIONS(3555),
    [anon_sym_DASH_DOT] = ACTIONS(3555),
    [anon_sym_PERCENT] = ACTIONS(3555),
    [anon_sym_AMP_AMP] = ACTIONS(3555),
    [anon_sym_TILDE] = ACTIONS(3553),
    [aux_sym_prefix_op_token1] = ACTIONS(3555),
    [aux_sym_infix_op_token1] = ACTIONS(3553),
    [aux_sym_infix_op_token2] = ACTIONS(3555),
    [anon_sym_PIPE_PIPE] = ACTIONS(3555),
    [anon_sym_BANG_EQ] = ACTIONS(3555),
    [anon_sym_COLON_EQ] = ACTIONS(3553),
    [anon_sym_DOLLAR] = ACTIONS(3555),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3555),
    [sym_int] = ACTIONS(3555),
    [sym_xint] = ACTIONS(3553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3553),
    [sym__newline] = ACTIONS(3553),
    [sym__dedent] = ACTIONS(3553),
  },
  [1517] = {
    [sym_block_comment] = STATE(1517),
    [sym_compiler_directive_decl] = STATE(1517),
    [sym_fsi_directive_decl] = STATE(1517),
    [sym_preproc_line] = STATE(1517),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_and] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [aux_sym_access_modifier_token1] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_member] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_val] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [anon_sym_POUNDendif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [1518] = {
    [sym_block_comment] = STATE(1518),
    [sym_compiler_directive_decl] = STATE(1518),
    [sym_fsi_directive_decl] = STATE(1518),
    [sym_preproc_line] = STATE(1518),
    [sym_identifier] = ACTIONS(3505),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_LBRACK_LT] = ACTIONS(3503),
    [anon_sym_COLON] = ACTIONS(3505),
    [anon_sym_return] = ACTIONS(3505),
    [anon_sym_do] = ACTIONS(3505),
    [anon_sym_and] = ACTIONS(3505),
    [anon_sym_let] = ACTIONS(3505),
    [anon_sym_let_BANG] = ACTIONS(3503),
    [aux_sym_access_modifier_token1] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3505),
    [anon_sym_COMMA] = ACTIONS(3503),
    [anon_sym_null] = ACTIONS(3505),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_COLON_QMARK] = ACTIONS(3505),
    [anon_sym_COLON_COLON] = ACTIONS(3503),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3503),
    [anon_sym_LBRACE] = ACTIONS(3505),
    [anon_sym_LT_AT] = ACTIONS(3505),
    [anon_sym_LT_AT_AT] = ACTIONS(3505),
    [anon_sym_DOT] = ACTIONS(3505),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3503),
    [anon_sym_new] = ACTIONS(3505),
    [anon_sym_with] = ACTIONS(3505),
    [anon_sym_return_BANG] = ACTIONS(3503),
    [anon_sym_yield] = ACTIONS(3505),
    [anon_sym_yield_BANG] = ACTIONS(3503),
    [anon_sym_lazy] = ACTIONS(3505),
    [anon_sym_assert] = ACTIONS(3505),
    [anon_sym_upcast] = ACTIONS(3505),
    [anon_sym_downcast] = ACTIONS(3505),
    [anon_sym_COLON_GT] = ACTIONS(3503),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3503),
    [anon_sym_for] = ACTIONS(3505),
    [anon_sym_while] = ACTIONS(3505),
    [anon_sym_if] = ACTIONS(3505),
    [anon_sym_fun] = ACTIONS(3505),
    [anon_sym_DASH_GT] = ACTIONS(3505),
    [anon_sym_try] = ACTIONS(3505),
    [anon_sym_match] = ACTIONS(3505),
    [anon_sym_match_BANG] = ACTIONS(3503),
    [anon_sym_function] = ACTIONS(3505),
    [anon_sym_LT_DASH] = ACTIONS(3505),
    [anon_sym_DOT_LBRACK] = ACTIONS(3503),
    [anon_sym_LT] = ACTIONS(3503),
    [anon_sym_use] = ACTIONS(3505),
    [anon_sym_use_BANG] = ACTIONS(3503),
    [anon_sym_do_BANG] = ACTIONS(3503),
    [anon_sym_begin] = ACTIONS(3505),
    [anon_sym_LPAREN2] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3505),
    [anon_sym_LT2] = ACTIONS(4324),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_default] = ACTIONS(3505),
    [anon_sym_or] = ACTIONS(3505),
    [anon_sym_static] = ACTIONS(3505),
    [anon_sym_member] = ACTIONS(3505),
    [anon_sym_interface] = ACTIONS(3505),
    [anon_sym_abstract] = ACTIONS(3505),
    [anon_sym_val] = ACTIONS(3505),
    [anon_sym_override] = ACTIONS(3505),
    [aux_sym_char_token1] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3505),
    [anon_sym_DQUOTE] = ACTIONS(3505),
    [anon_sym_AT_DQUOTE] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [sym_bool] = ACTIONS(3505),
    [sym_unit] = ACTIONS(3503),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3505),
    [sym_op_identifier] = ACTIONS(3505),
    [anon_sym_PLUS] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3505),
    [anon_sym_PLUS_DOT] = ACTIONS(3505),
    [anon_sym_DASH_DOT] = ACTIONS(3505),
    [anon_sym_PERCENT] = ACTIONS(3505),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3503),
    [aux_sym_prefix_op_token1] = ACTIONS(3505),
    [aux_sym_infix_op_token1] = ACTIONS(3503),
    [aux_sym_infix_op_token2] = ACTIONS(3505),
    [anon_sym_PIPE_PIPE] = ACTIONS(3505),
    [anon_sym_BANG_EQ] = ACTIONS(3505),
    [anon_sym_COLON_EQ] = ACTIONS(3503),
    [anon_sym_DOLLAR] = ACTIONS(3505),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3505),
    [sym_int] = ACTIONS(3505),
    [sym_xint] = ACTIONS(3503),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3503),
    [anon_sym_POUNDendif] = ACTIONS(3503),
    [sym__newline] = ACTIONS(3503),
  },
  [1519] = {
    [sym_block_comment] = STATE(1519),
    [sym_compiler_directive_decl] = STATE(1519),
    [sym_fsi_directive_decl] = STATE(1519),
    [sym_preproc_line] = STATE(1519),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_LBRACK_LT] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [aux_sym_access_modifier_token1] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_COLON] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_with] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_LT_DASH] = ACTIONS(3480),
    [anon_sym_DOT_LBRACK] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_DOT_DOT2] = ACTIONS(3478),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_default] = ACTIONS(3480),
    [anon_sym_or] = ACTIONS(3480),
    [anon_sym_static] = ACTIONS(3480),
    [anon_sym_member] = ACTIONS(3480),
    [anon_sym_interface] = ACTIONS(3480),
    [anon_sym_abstract] = ACTIONS(3480),
    [anon_sym_val] = ACTIONS(3480),
    [anon_sym_override] = ACTIONS(3480),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3480),
    [anon_sym_DASH_DOT] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3480),
    [aux_sym_infix_op_token1] = ACTIONS(3478),
    [aux_sym_infix_op_token2] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3480),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
    [sym__dedent] = ACTIONS(3478),
  },
  [1520] = {
    [sym_block_comment] = STATE(1520),
    [sym_compiler_directive_decl] = STATE(1520),
    [sym_fsi_directive_decl] = STATE(1520),
    [sym_preproc_line] = STATE(1520),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(3521),
    [anon_sym_LBRACK_LT] = ACTIONS(3521),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3521),
    [aux_sym_access_modifier_token1] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_COMMA] = ACTIONS(3521),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_COLON] = ACTIONS(3521),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_with] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3521),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3521),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_COLON_GT] = ACTIONS(3521),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_DASH_GT] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3521),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_LT_DASH] = ACTIONS(3523),
    [anon_sym_DOT_LBRACK] = ACTIONS(3521),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3521),
    [anon_sym_do_BANG] = ACTIONS(3521),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_LPAREN2] = ACTIONS(3523),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_LT2] = ACTIONS(3523),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3521),
    [anon_sym_default] = ACTIONS(3523),
    [anon_sym_or] = ACTIONS(3523),
    [anon_sym_static] = ACTIONS(3523),
    [anon_sym_member] = ACTIONS(3523),
    [anon_sym_interface] = ACTIONS(3523),
    [anon_sym_abstract] = ACTIONS(3523),
    [anon_sym_val] = ACTIONS(3523),
    [anon_sym_override] = ACTIONS(3523),
    [anon_sym_inherit] = ACTIONS(3523),
    [aux_sym_char_token1] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3521),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3523),
    [anon_sym_DASH_DOT] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3521),
    [aux_sym_prefix_op_token1] = ACTIONS(3523),
    [aux_sym_infix_op_token1] = ACTIONS(3521),
    [aux_sym_infix_op_token2] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3523),
    [anon_sym_COLON_EQ] = ACTIONS(3521),
    [anon_sym_DOLLAR] = ACTIONS(3523),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3523),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3521),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3521),
    [anon_sym_POUNDendif] = ACTIONS(3521),
    [sym__newline] = ACTIONS(3521),
  },
  [1521] = {
    [sym_block_comment] = STATE(1521),
    [sym_compiler_directive_decl] = STATE(1521),
    [sym_fsi_directive_decl] = STATE(1521),
    [sym_preproc_line] = STATE(1521),
    [sym_identifier] = ACTIONS(3547),
    [anon_sym_EQ] = ACTIONS(3545),
    [anon_sym_LBRACK_LT] = ACTIONS(3545),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_return] = ACTIONS(3547),
    [anon_sym_do] = ACTIONS(3547),
    [anon_sym_and] = ACTIONS(3547),
    [anon_sym_let] = ACTIONS(3547),
    [anon_sym_let_BANG] = ACTIONS(3545),
    [aux_sym_access_modifier_token1] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(3547),
    [anon_sym_COMMA] = ACTIONS(3545),
    [anon_sym_null] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3547),
    [anon_sym_COLON_QMARK] = ACTIONS(3547),
    [anon_sym_COLON_COLON] = ACTIONS(3545),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3545),
    [anon_sym_LBRACE] = ACTIONS(3547),
    [anon_sym_LT_AT] = ACTIONS(3547),
    [anon_sym_LT_AT_AT] = ACTIONS(3547),
    [anon_sym_DOT] = ACTIONS(3547),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3545),
    [anon_sym_new] = ACTIONS(3547),
    [anon_sym_with] = ACTIONS(3547),
    [anon_sym_return_BANG] = ACTIONS(3545),
    [anon_sym_yield] = ACTIONS(3547),
    [anon_sym_yield_BANG] = ACTIONS(3545),
    [anon_sym_lazy] = ACTIONS(3547),
    [anon_sym_assert] = ACTIONS(3547),
    [anon_sym_upcast] = ACTIONS(3547),
    [anon_sym_downcast] = ACTIONS(3547),
    [anon_sym_COLON_GT] = ACTIONS(3545),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3545),
    [anon_sym_for] = ACTIONS(3547),
    [anon_sym_while] = ACTIONS(3547),
    [anon_sym_if] = ACTIONS(3547),
    [anon_sym_fun] = ACTIONS(3547),
    [anon_sym_DASH_GT] = ACTIONS(3547),
    [anon_sym_try] = ACTIONS(3547),
    [anon_sym_match] = ACTIONS(3547),
    [anon_sym_match_BANG] = ACTIONS(3545),
    [anon_sym_function] = ACTIONS(3547),
    [anon_sym_LT_DASH] = ACTIONS(3547),
    [anon_sym_DOT_LBRACK] = ACTIONS(3545),
    [anon_sym_LT] = ACTIONS(3545),
    [anon_sym_use] = ACTIONS(3547),
    [anon_sym_use_BANG] = ACTIONS(3545),
    [anon_sym_do_BANG] = ACTIONS(3545),
    [anon_sym_begin] = ACTIONS(3547),
    [anon_sym_LPAREN2] = ACTIONS(3547),
    [anon_sym_STAR] = ACTIONS(3547),
    [anon_sym_LT2] = ACTIONS(3547),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_default] = ACTIONS(3547),
    [anon_sym_or] = ACTIONS(3547),
    [anon_sym_static] = ACTIONS(3547),
    [anon_sym_member] = ACTIONS(3547),
    [anon_sym_interface] = ACTIONS(3547),
    [anon_sym_abstract] = ACTIONS(3547),
    [anon_sym_val] = ACTIONS(3547),
    [anon_sym_override] = ACTIONS(3547),
    [aux_sym_char_token1] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3547),
    [anon_sym_DQUOTE] = ACTIONS(3547),
    [anon_sym_AT_DQUOTE] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [sym_bool] = ACTIONS(3547),
    [sym_unit] = ACTIONS(3545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3547),
    [sym_op_identifier] = ACTIONS(3547),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PLUS_DOT] = ACTIONS(3547),
    [anon_sym_DASH_DOT] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3547),
    [anon_sym_AMP_AMP] = ACTIONS(3547),
    [anon_sym_TILDE] = ACTIONS(3545),
    [aux_sym_prefix_op_token1] = ACTIONS(3547),
    [aux_sym_infix_op_token1] = ACTIONS(3545),
    [aux_sym_infix_op_token2] = ACTIONS(3547),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_BANG_EQ] = ACTIONS(3547),
    [anon_sym_COLON_EQ] = ACTIONS(3545),
    [anon_sym_DOLLAR] = ACTIONS(3547),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3547),
    [sym_int] = ACTIONS(3547),
    [sym_xint] = ACTIONS(3545),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3545),
    [sym__newline] = ACTIONS(3545),
    [sym__dedent] = ACTIONS(3545),
  },
  [1522] = {
    [sym_block_comment] = STATE(1522),
    [sym_compiler_directive_decl] = STATE(1522),
    [sym_fsi_directive_decl] = STATE(1522),
    [sym_preproc_line] = STATE(1522),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_LBRACK_LT] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [aux_sym_access_modifier_token1] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_COLON] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_with] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_LT_DASH] = ACTIONS(3480),
    [anon_sym_DOT_LBRACK] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_default] = ACTIONS(3480),
    [anon_sym_or] = ACTIONS(3480),
    [anon_sym_static] = ACTIONS(3480),
    [anon_sym_member] = ACTIONS(3480),
    [anon_sym_interface] = ACTIONS(3480),
    [anon_sym_abstract] = ACTIONS(3480),
    [anon_sym_val] = ACTIONS(3480),
    [anon_sym_override] = ACTIONS(3480),
    [anon_sym_inherit] = ACTIONS(3480),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3480),
    [anon_sym_DASH_DOT] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3480),
    [aux_sym_infix_op_token1] = ACTIONS(3478),
    [aux_sym_infix_op_token2] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3480),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [anon_sym_POUNDendif] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
  },
  [1523] = {
    [sym_block_comment] = STATE(1523),
    [sym_compiler_directive_decl] = STATE(1523),
    [sym_fsi_directive_decl] = STATE(1523),
    [sym_preproc_line] = STATE(1523),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3227),
    [anon_sym_uy] = ACTIONS(3229),
    [anon_sym_s] = ACTIONS(3231),
    [anon_sym_us] = ACTIONS(3233),
    [anon_sym_l] = ACTIONS(3235),
    [aux_sym_uint32_token1] = ACTIONS(3237),
    [anon_sym_n] = ACTIONS(3239),
    [anon_sym_un] = ACTIONS(3241),
    [anon_sym_L] = ACTIONS(3243),
    [aux_sym_uint64_token1] = ACTIONS(3245),
    [aux_sym_bignum_token1] = ACTIONS(3247),
    [aux_sym_decimal_token1] = ACTIONS(3249),
    [anon_sym_DOT2] = ACTIONS(4326),
    [aux_sym_float_token1] = ACTIONS(4328),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [anon_sym_POUNDendif] = ACTIONS(3191),
    [anon_sym_POUNDelse] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1524] = {
    [sym_block_comment] = STATE(1524),
    [sym_compiler_directive_decl] = STATE(1524),
    [sym_fsi_directive_decl] = STATE(1524),
    [sym_preproc_line] = STATE(1524),
    [sym_identifier] = ACTIONS(3543),
    [anon_sym_EQ] = ACTIONS(3541),
    [anon_sym_LBRACK_LT] = ACTIONS(3541),
    [anon_sym_COLON] = ACTIONS(3543),
    [anon_sym_return] = ACTIONS(3543),
    [anon_sym_do] = ACTIONS(3543),
    [anon_sym_and] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3543),
    [anon_sym_let_BANG] = ACTIONS(3541),
    [aux_sym_access_modifier_token1] = ACTIONS(3541),
    [anon_sym_LPAREN] = ACTIONS(3543),
    [anon_sym_COMMA] = ACTIONS(3541),
    [anon_sym_null] = ACTIONS(3543),
    [anon_sym_QMARK] = ACTIONS(3543),
    [anon_sym_COLON_QMARK] = ACTIONS(3543),
    [anon_sym_COLON_COLON] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3543),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3541),
    [anon_sym_LBRACE] = ACTIONS(3543),
    [anon_sym_LT_AT] = ACTIONS(3543),
    [anon_sym_LT_AT_AT] = ACTIONS(3543),
    [anon_sym_DOT] = ACTIONS(3543),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3541),
    [anon_sym_new] = ACTIONS(3543),
    [anon_sym_with] = ACTIONS(3543),
    [anon_sym_return_BANG] = ACTIONS(3541),
    [anon_sym_yield] = ACTIONS(3543),
    [anon_sym_yield_BANG] = ACTIONS(3541),
    [anon_sym_lazy] = ACTIONS(3543),
    [anon_sym_assert] = ACTIONS(3543),
    [anon_sym_upcast] = ACTIONS(3543),
    [anon_sym_downcast] = ACTIONS(3543),
    [anon_sym_COLON_GT] = ACTIONS(3541),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3541),
    [anon_sym_for] = ACTIONS(3543),
    [anon_sym_while] = ACTIONS(3543),
    [anon_sym_if] = ACTIONS(3543),
    [anon_sym_fun] = ACTIONS(3543),
    [anon_sym_DASH_GT] = ACTIONS(3543),
    [anon_sym_try] = ACTIONS(3543),
    [anon_sym_match] = ACTIONS(3543),
    [anon_sym_match_BANG] = ACTIONS(3541),
    [anon_sym_function] = ACTIONS(3543),
    [anon_sym_LT_DASH] = ACTIONS(3543),
    [anon_sym_DOT_LBRACK] = ACTIONS(3541),
    [anon_sym_LT] = ACTIONS(3541),
    [anon_sym_use] = ACTIONS(3543),
    [anon_sym_use_BANG] = ACTIONS(3541),
    [anon_sym_do_BANG] = ACTIONS(3541),
    [anon_sym_begin] = ACTIONS(3543),
    [anon_sym_LPAREN2] = ACTIONS(3543),
    [anon_sym_STAR] = ACTIONS(3543),
    [anon_sym_LT2] = ACTIONS(3543),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_default] = ACTIONS(3543),
    [anon_sym_or] = ACTIONS(3543),
    [anon_sym_static] = ACTIONS(3543),
    [anon_sym_member] = ACTIONS(3543),
    [anon_sym_interface] = ACTIONS(3543),
    [anon_sym_abstract] = ACTIONS(3543),
    [anon_sym_val] = ACTIONS(3543),
    [anon_sym_override] = ACTIONS(3543),
    [aux_sym_char_token1] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3543),
    [anon_sym_DQUOTE] = ACTIONS(3543),
    [anon_sym_AT_DQUOTE] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [sym_bool] = ACTIONS(3543),
    [sym_unit] = ACTIONS(3541),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3543),
    [sym_op_identifier] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(3543),
    [anon_sym_DASH] = ACTIONS(3543),
    [anon_sym_PLUS_DOT] = ACTIONS(3543),
    [anon_sym_DASH_DOT] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3543),
    [anon_sym_AMP_AMP] = ACTIONS(3543),
    [anon_sym_TILDE] = ACTIONS(3541),
    [aux_sym_prefix_op_token1] = ACTIONS(3543),
    [aux_sym_infix_op_token1] = ACTIONS(3541),
    [aux_sym_infix_op_token2] = ACTIONS(3543),
    [anon_sym_PIPE_PIPE] = ACTIONS(3543),
    [anon_sym_BANG_EQ] = ACTIONS(3543),
    [anon_sym_COLON_EQ] = ACTIONS(3541),
    [anon_sym_DOLLAR] = ACTIONS(3543),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3543),
    [sym_int] = ACTIONS(3543),
    [sym_xint] = ACTIONS(3541),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3541),
    [sym__newline] = ACTIONS(3541),
    [sym__dedent] = ACTIONS(3541),
  },
  [1525] = {
    [sym_block_comment] = STATE(1525),
    [sym_compiler_directive_decl] = STATE(1525),
    [sym_fsi_directive_decl] = STATE(1525),
    [sym_preproc_line] = STATE(1525),
    [sym_identifier] = ACTIONS(3519),
    [anon_sym_EQ] = ACTIONS(3517),
    [anon_sym_LBRACK_LT] = ACTIONS(3517),
    [anon_sym_COLON] = ACTIONS(3519),
    [anon_sym_return] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(3519),
    [anon_sym_let] = ACTIONS(3519),
    [anon_sym_let_BANG] = ACTIONS(3517),
    [aux_sym_access_modifier_token1] = ACTIONS(3517),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [anon_sym_COMMA] = ACTIONS(3517),
    [anon_sym_null] = ACTIONS(3519),
    [anon_sym_QMARK] = ACTIONS(3519),
    [anon_sym_COLON_QMARK] = ACTIONS(3519),
    [anon_sym_COLON_COLON] = ACTIONS(3517),
    [anon_sym_AMP] = ACTIONS(3519),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_LT_AT] = ACTIONS(3519),
    [anon_sym_LT_AT_AT] = ACTIONS(3519),
    [anon_sym_DOT] = ACTIONS(3519),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3519),
    [anon_sym_with] = ACTIONS(3519),
    [anon_sym_return_BANG] = ACTIONS(3517),
    [anon_sym_yield] = ACTIONS(3519),
    [anon_sym_yield_BANG] = ACTIONS(3517),
    [anon_sym_lazy] = ACTIONS(3519),
    [anon_sym_assert] = ACTIONS(3519),
    [anon_sym_upcast] = ACTIONS(3519),
    [anon_sym_downcast] = ACTIONS(3519),
    [anon_sym_COLON_GT] = ACTIONS(3517),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3517),
    [anon_sym_for] = ACTIONS(3519),
    [anon_sym_while] = ACTIONS(3519),
    [anon_sym_if] = ACTIONS(3519),
    [anon_sym_fun] = ACTIONS(3519),
    [anon_sym_DASH_GT] = ACTIONS(3519),
    [anon_sym_try] = ACTIONS(3519),
    [anon_sym_match] = ACTIONS(3519),
    [anon_sym_match_BANG] = ACTIONS(3517),
    [anon_sym_function] = ACTIONS(3519),
    [anon_sym_LT_DASH] = ACTIONS(3519),
    [anon_sym_DOT_LBRACK] = ACTIONS(3517),
    [anon_sym_LT] = ACTIONS(3517),
    [anon_sym_use] = ACTIONS(3519),
    [anon_sym_use_BANG] = ACTIONS(3517),
    [anon_sym_do_BANG] = ACTIONS(3517),
    [anon_sym_begin] = ACTIONS(3519),
    [anon_sym_LPAREN2] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_LT2] = ACTIONS(3519),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3517),
    [anon_sym_default] = ACTIONS(3519),
    [anon_sym_or] = ACTIONS(3519),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_member] = ACTIONS(3519),
    [anon_sym_interface] = ACTIONS(3519),
    [anon_sym_abstract] = ACTIONS(3519),
    [anon_sym_val] = ACTIONS(3519),
    [anon_sym_override] = ACTIONS(3519),
    [anon_sym_inherit] = ACTIONS(3519),
    [aux_sym_char_token1] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [anon_sym_AT_DQUOTE] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [sym_bool] = ACTIONS(3519),
    [sym_unit] = ACTIONS(3517),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3519),
    [sym_op_identifier] = ACTIONS(3519),
    [anon_sym_PLUS] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_DOT] = ACTIONS(3519),
    [anon_sym_DASH_DOT] = ACTIONS(3519),
    [anon_sym_PERCENT] = ACTIONS(3519),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3517),
    [aux_sym_prefix_op_token1] = ACTIONS(3519),
    [aux_sym_infix_op_token1] = ACTIONS(3517),
    [aux_sym_infix_op_token2] = ACTIONS(3519),
    [anon_sym_PIPE_PIPE] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_COLON_EQ] = ACTIONS(3517),
    [anon_sym_DOLLAR] = ACTIONS(3519),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3519),
    [sym_int] = ACTIONS(3519),
    [sym_xint] = ACTIONS(3517),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3517),
    [anon_sym_POUNDendif] = ACTIONS(3517),
    [sym__newline] = ACTIONS(3517),
  },
  [1526] = {
    [sym_block_comment] = STATE(1526),
    [sym_compiler_directive_decl] = STATE(1526),
    [sym_fsi_directive_decl] = STATE(1526),
    [sym_preproc_line] = STATE(1526),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_LBRACK_LT] = ACTIONS(3513),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_and] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [aux_sym_access_modifier_token1] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_COLON] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_with] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(3513),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_LT_DASH] = ACTIONS(3515),
    [anon_sym_DOT_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3515),
    [anon_sym_or] = ACTIONS(3515),
    [anon_sym_static] = ACTIONS(3515),
    [anon_sym_member] = ACTIONS(3515),
    [anon_sym_interface] = ACTIONS(3515),
    [anon_sym_abstract] = ACTIONS(3515),
    [anon_sym_val] = ACTIONS(3515),
    [anon_sym_override] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3515),
    [anon_sym_DASH_DOT] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3515),
    [aux_sym_infix_op_token1] = ACTIONS(3513),
    [aux_sym_infix_op_token2] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3515),
    [anon_sym_COLON_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(3515),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3515),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [anon_sym_POUNDendif] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
  },
  [1527] = {
    [sym_block_comment] = STATE(1527),
    [sym_compiler_directive_decl] = STATE(1527),
    [sym_fsi_directive_decl] = STATE(1527),
    [sym_preproc_line] = STATE(1527),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_LBRACK_LT] = ACTIONS(3513),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_and] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [aux_sym_access_modifier_token1] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_COLON] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_with] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(3513),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_LT_DASH] = ACTIONS(3515),
    [anon_sym_DOT_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3515),
    [anon_sym_or] = ACTIONS(3515),
    [anon_sym_static] = ACTIONS(3515),
    [anon_sym_member] = ACTIONS(3515),
    [anon_sym_interface] = ACTIONS(3515),
    [anon_sym_abstract] = ACTIONS(3515),
    [anon_sym_val] = ACTIONS(3515),
    [anon_sym_override] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3515),
    [anon_sym_DASH_DOT] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3515),
    [aux_sym_infix_op_token1] = ACTIONS(3513),
    [aux_sym_infix_op_token2] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3515),
    [anon_sym_COLON_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(3515),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3515),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [anon_sym_POUNDendif] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
  },
  [1528] = {
    [sym_block_comment] = STATE(1528),
    [sym_compiler_directive_decl] = STATE(1528),
    [sym_fsi_directive_decl] = STATE(1528),
    [sym_preproc_line] = STATE(1528),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(3521),
    [anon_sym_LBRACK_LT] = ACTIONS(3521),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3521),
    [aux_sym_access_modifier_token1] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_COMMA] = ACTIONS(3521),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_COLON] = ACTIONS(3521),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_with] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3521),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3521),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_COLON_GT] = ACTIONS(3521),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_DASH_GT] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3521),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_LT_DASH] = ACTIONS(3523),
    [anon_sym_DOT_LBRACK] = ACTIONS(3521),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3521),
    [anon_sym_do_BANG] = ACTIONS(3521),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_LPAREN2] = ACTIONS(3523),
    [anon_sym_DOT_DOT2] = ACTIONS(3521),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_LT2] = ACTIONS(3523),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3521),
    [anon_sym_default] = ACTIONS(3523),
    [anon_sym_or] = ACTIONS(3523),
    [anon_sym_static] = ACTIONS(3523),
    [anon_sym_member] = ACTIONS(3523),
    [anon_sym_interface] = ACTIONS(3523),
    [anon_sym_abstract] = ACTIONS(3523),
    [anon_sym_val] = ACTIONS(3523),
    [anon_sym_override] = ACTIONS(3523),
    [aux_sym_char_token1] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3521),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3523),
    [anon_sym_DASH_DOT] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3521),
    [aux_sym_prefix_op_token1] = ACTIONS(3523),
    [aux_sym_infix_op_token1] = ACTIONS(3521),
    [aux_sym_infix_op_token2] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3523),
    [anon_sym_COLON_EQ] = ACTIONS(3521),
    [anon_sym_DOLLAR] = ACTIONS(3523),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3523),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3521),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3521),
    [sym__newline] = ACTIONS(3521),
    [sym__dedent] = ACTIONS(3521),
  },
  [1529] = {
    [sym_elif_expression] = STATE(1633),
    [sym_block_comment] = STATE(1529),
    [sym_compiler_directive_decl] = STATE(1529),
    [sym_fsi_directive_decl] = STATE(1529),
    [sym_preproc_line] = STATE(1529),
    [aux_sym_if_expression_repeat1] = STATE(1529),
    [sym_identifier] = ACTIONS(3555),
    [anon_sym_EQ] = ACTIONS(3553),
    [anon_sym_LBRACK_LT] = ACTIONS(3553),
    [anon_sym_COLON] = ACTIONS(3555),
    [anon_sym_return] = ACTIONS(3555),
    [anon_sym_do] = ACTIONS(3555),
    [anon_sym_and] = ACTIONS(3555),
    [anon_sym_let] = ACTIONS(3555),
    [anon_sym_let_BANG] = ACTIONS(3553),
    [aux_sym_access_modifier_token1] = ACTIONS(3553),
    [anon_sym_LPAREN] = ACTIONS(3555),
    [anon_sym_COMMA] = ACTIONS(3553),
    [anon_sym_null] = ACTIONS(3555),
    [anon_sym_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_COLON] = ACTIONS(3553),
    [anon_sym_AMP] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(3555),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3553),
    [anon_sym_LBRACE] = ACTIONS(3555),
    [anon_sym_LT_AT] = ACTIONS(3555),
    [anon_sym_LT_AT_AT] = ACTIONS(3555),
    [anon_sym_DOT] = ACTIONS(3555),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3553),
    [anon_sym_new] = ACTIONS(3555),
    [anon_sym_with] = ACTIONS(3555),
    [anon_sym_return_BANG] = ACTIONS(3553),
    [anon_sym_yield] = ACTIONS(3555),
    [anon_sym_yield_BANG] = ACTIONS(3553),
    [anon_sym_lazy] = ACTIONS(3555),
    [anon_sym_assert] = ACTIONS(3555),
    [anon_sym_upcast] = ACTIONS(3555),
    [anon_sym_downcast] = ACTIONS(3555),
    [anon_sym_COLON_GT] = ACTIONS(3553),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3553),
    [anon_sym_for] = ACTIONS(3555),
    [anon_sym_while] = ACTIONS(3555),
    [anon_sym_else] = ACTIONS(3555),
    [anon_sym_elif] = ACTIONS(4330),
    [anon_sym_if] = ACTIONS(3555),
    [anon_sym_fun] = ACTIONS(3555),
    [anon_sym_try] = ACTIONS(3555),
    [anon_sym_match] = ACTIONS(3555),
    [anon_sym_match_BANG] = ACTIONS(3553),
    [anon_sym_function] = ACTIONS(3555),
    [anon_sym_LT_DASH] = ACTIONS(3555),
    [anon_sym_DOT_LBRACK] = ACTIONS(3553),
    [anon_sym_LT] = ACTIONS(3553),
    [anon_sym_use] = ACTIONS(3555),
    [anon_sym_use_BANG] = ACTIONS(3553),
    [anon_sym_do_BANG] = ACTIONS(3553),
    [anon_sym_begin] = ACTIONS(3555),
    [anon_sym_LPAREN2] = ACTIONS(3555),
    [anon_sym_default] = ACTIONS(3555),
    [anon_sym_or] = ACTIONS(3555),
    [anon_sym_static] = ACTIONS(3555),
    [anon_sym_member] = ACTIONS(3555),
    [anon_sym_interface] = ACTIONS(3555),
    [anon_sym_abstract] = ACTIONS(3555),
    [anon_sym_val] = ACTIONS(3555),
    [anon_sym_override] = ACTIONS(3555),
    [aux_sym_char_token1] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3555),
    [anon_sym_DQUOTE] = ACTIONS(3555),
    [anon_sym_AT_DQUOTE] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [sym_bool] = ACTIONS(3555),
    [sym_unit] = ACTIONS(3553),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3555),
    [sym_op_identifier] = ACTIONS(3555),
    [anon_sym_PLUS] = ACTIONS(3555),
    [anon_sym_DASH] = ACTIONS(3555),
    [anon_sym_PLUS_DOT] = ACTIONS(3555),
    [anon_sym_DASH_DOT] = ACTIONS(3555),
    [anon_sym_PERCENT] = ACTIONS(3555),
    [anon_sym_AMP_AMP] = ACTIONS(3555),
    [anon_sym_TILDE] = ACTIONS(3553),
    [aux_sym_prefix_op_token1] = ACTIONS(3555),
    [aux_sym_infix_op_token1] = ACTIONS(3553),
    [aux_sym_infix_op_token2] = ACTIONS(3555),
    [anon_sym_PIPE_PIPE] = ACTIONS(3555),
    [anon_sym_BANG_EQ] = ACTIONS(3555),
    [anon_sym_COLON_EQ] = ACTIONS(3553),
    [anon_sym_DOLLAR] = ACTIONS(3555),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3555),
    [sym_int] = ACTIONS(3555),
    [sym_xint] = ACTIONS(3553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3553),
    [sym__newline] = ACTIONS(3553),
    [sym__dedent] = ACTIONS(3553),
  },
  [1530] = {
    [sym_block_comment] = STATE(1530),
    [sym_compiler_directive_decl] = STATE(1530),
    [sym_fsi_directive_decl] = STATE(1530),
    [sym_preproc_line] = STATE(1530),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_LBRACK_LT] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_and] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [aux_sym_access_modifier_token1] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_with] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_default] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [anon_sym_static] = ACTIONS(3604),
    [anon_sym_member] = ACTIONS(3604),
    [anon_sym_interface] = ACTIONS(3604),
    [anon_sym_abstract] = ACTIONS(3604),
    [anon_sym_val] = ACTIONS(3604),
    [anon_sym_override] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [aux_sym_float_token1] = ACTIONS(4333),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [anon_sym_POUNDendif] = ACTIONS(3602),
    [anon_sym_POUNDelse] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
  },
  [1531] = {
    [sym_block_comment] = STATE(1531),
    [sym_compiler_directive_decl] = STATE(1531),
    [sym_fsi_directive_decl] = STATE(1531),
    [sym_preproc_line] = STATE(1531),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_DOT_DOT2] = ACTIONS(3191),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3375),
    [anon_sym_uy] = ACTIONS(3377),
    [anon_sym_s] = ACTIONS(3379),
    [anon_sym_us] = ACTIONS(3381),
    [anon_sym_l] = ACTIONS(3383),
    [aux_sym_uint32_token1] = ACTIONS(3385),
    [anon_sym_n] = ACTIONS(3387),
    [anon_sym_un] = ACTIONS(3389),
    [anon_sym_L] = ACTIONS(3391),
    [aux_sym_uint64_token1] = ACTIONS(3393),
    [aux_sym_bignum_token1] = ACTIONS(3395),
    [aux_sym_decimal_token1] = ACTIONS(3397),
    [anon_sym_DOT2] = ACTIONS(4285),
    [aux_sym_float_token1] = ACTIONS(4287),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
    [sym__dedent] = ACTIONS(3191),
  },
  [1532] = {
    [sym_block_comment] = STATE(1532),
    [sym_compiler_directive_decl] = STATE(1532),
    [sym_fsi_directive_decl] = STATE(1532),
    [sym_preproc_line] = STATE(1532),
    [sym_identifier] = ACTIONS(3547),
    [anon_sym_EQ] = ACTIONS(3545),
    [anon_sym_LBRACK_LT] = ACTIONS(3545),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_return] = ACTIONS(3547),
    [anon_sym_do] = ACTIONS(3547),
    [anon_sym_let] = ACTIONS(3547),
    [anon_sym_let_BANG] = ACTIONS(3545),
    [aux_sym_access_modifier_token1] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(3547),
    [anon_sym_COMMA] = ACTIONS(3545),
    [anon_sym_null] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3547),
    [anon_sym_COLON_QMARK] = ACTIONS(3547),
    [anon_sym_COLON_COLON] = ACTIONS(3545),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3545),
    [anon_sym_LBRACE] = ACTIONS(3547),
    [anon_sym_LT_AT] = ACTIONS(3547),
    [anon_sym_LT_AT_AT] = ACTIONS(3547),
    [anon_sym_DOT] = ACTIONS(3547),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3545),
    [anon_sym_new] = ACTIONS(3547),
    [anon_sym_with] = ACTIONS(3547),
    [anon_sym_return_BANG] = ACTIONS(3545),
    [anon_sym_yield] = ACTIONS(3547),
    [anon_sym_yield_BANG] = ACTIONS(3545),
    [anon_sym_lazy] = ACTIONS(3547),
    [anon_sym_assert] = ACTIONS(3547),
    [anon_sym_upcast] = ACTIONS(3547),
    [anon_sym_downcast] = ACTIONS(3547),
    [anon_sym_COLON_GT] = ACTIONS(3545),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3545),
    [anon_sym_for] = ACTIONS(3547),
    [anon_sym_while] = ACTIONS(3547),
    [anon_sym_if] = ACTIONS(3547),
    [anon_sym_fun] = ACTIONS(3547),
    [anon_sym_DASH_GT] = ACTIONS(3547),
    [anon_sym_try] = ACTIONS(3547),
    [anon_sym_match] = ACTIONS(3547),
    [anon_sym_match_BANG] = ACTIONS(3545),
    [anon_sym_function] = ACTIONS(3547),
    [anon_sym_LT_DASH] = ACTIONS(3547),
    [anon_sym_DOT_LBRACK] = ACTIONS(3545),
    [anon_sym_LT] = ACTIONS(3545),
    [anon_sym_use] = ACTIONS(3547),
    [anon_sym_use_BANG] = ACTIONS(3545),
    [anon_sym_do_BANG] = ACTIONS(3545),
    [anon_sym_begin] = ACTIONS(3547),
    [anon_sym_LPAREN2] = ACTIONS(3547),
    [anon_sym_DOT_DOT2] = ACTIONS(3545),
    [anon_sym_STAR] = ACTIONS(3547),
    [anon_sym_LT2] = ACTIONS(3547),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_default] = ACTIONS(3547),
    [anon_sym_or] = ACTIONS(3547),
    [anon_sym_static] = ACTIONS(3547),
    [anon_sym_member] = ACTIONS(3547),
    [anon_sym_interface] = ACTIONS(3547),
    [anon_sym_abstract] = ACTIONS(3547),
    [anon_sym_val] = ACTIONS(3547),
    [anon_sym_override] = ACTIONS(3547),
    [aux_sym_char_token1] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3547),
    [anon_sym_DQUOTE] = ACTIONS(3547),
    [anon_sym_AT_DQUOTE] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [sym_bool] = ACTIONS(3547),
    [sym_unit] = ACTIONS(3545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3547),
    [sym_op_identifier] = ACTIONS(3547),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PLUS_DOT] = ACTIONS(3547),
    [anon_sym_DASH_DOT] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3547),
    [anon_sym_AMP_AMP] = ACTIONS(3547),
    [anon_sym_TILDE] = ACTIONS(3545),
    [aux_sym_prefix_op_token1] = ACTIONS(3547),
    [aux_sym_infix_op_token1] = ACTIONS(3545),
    [aux_sym_infix_op_token2] = ACTIONS(3547),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_BANG_EQ] = ACTIONS(3547),
    [anon_sym_COLON_EQ] = ACTIONS(3545),
    [anon_sym_DOLLAR] = ACTIONS(3547),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3547),
    [sym_int] = ACTIONS(3547),
    [sym_xint] = ACTIONS(3545),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3545),
    [sym__newline] = ACTIONS(3545),
    [sym__dedent] = ACTIONS(3545),
  },
  [1533] = {
    [sym_block_comment] = STATE(1533),
    [sym_compiler_directive_decl] = STATE(1533),
    [sym_fsi_directive_decl] = STATE(1533),
    [sym_preproc_line] = STATE(1533),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3525),
    [anon_sym_LBRACK_LT] = ACTIONS(3525),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [aux_sym_access_modifier_token1] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_COLON] = ACTIONS(3525),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_with] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_COLON_GT] = ACTIONS(3525),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_DASH_GT] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_LT_DASH] = ACTIONS(3527),
    [anon_sym_DOT_LBRACK] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_LPAREN2] = ACTIONS(3527),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_LT2] = ACTIONS(3527),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_default] = ACTIONS(3527),
    [anon_sym_or] = ACTIONS(3527),
    [anon_sym_static] = ACTIONS(3527),
    [anon_sym_member] = ACTIONS(3527),
    [anon_sym_interface] = ACTIONS(3527),
    [anon_sym_abstract] = ACTIONS(3527),
    [anon_sym_val] = ACTIONS(3527),
    [anon_sym_override] = ACTIONS(3527),
    [anon_sym_inherit] = ACTIONS(3527),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3525),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3527),
    [anon_sym_DASH_DOT] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3527),
    [aux_sym_infix_op_token1] = ACTIONS(3525),
    [aux_sym_infix_op_token2] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_COLON_EQ] = ACTIONS(3525),
    [anon_sym_DOLLAR] = ACTIONS(3527),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3527),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3525),
    [anon_sym_POUNDendif] = ACTIONS(3525),
    [sym__newline] = ACTIONS(3525),
  },
  [1534] = {
    [sym_block_comment] = STATE(1534),
    [sym_compiler_directive_decl] = STATE(1534),
    [sym_fsi_directive_decl] = STATE(1534),
    [sym_preproc_line] = STATE(1534),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_LBRACK_LT] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_and] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [aux_sym_access_modifier_token1] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_with] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [anon_sym_DOT_LBRACK] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_default] = ACTIONS(3498),
    [anon_sym_or] = ACTIONS(3498),
    [anon_sym_static] = ACTIONS(3498),
    [anon_sym_member] = ACTIONS(3498),
    [anon_sym_interface] = ACTIONS(3498),
    [anon_sym_abstract] = ACTIONS(3498),
    [anon_sym_val] = ACTIONS(3498),
    [anon_sym_override] = ACTIONS(3498),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3498),
    [anon_sym_DASH_DOT] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3498),
    [aux_sym_infix_op_token1] = ACTIONS(3496),
    [aux_sym_infix_op_token2] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_COLON_EQ] = ACTIONS(3496),
    [anon_sym_DOLLAR] = ACTIONS(3498),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3498),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [anon_sym_POUNDendif] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
  },
  [1535] = {
    [sym_block_comment] = STATE(1535),
    [sym_compiler_directive_decl] = STATE(1535),
    [sym_fsi_directive_decl] = STATE(1535),
    [sym_preproc_line] = STATE(1535),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_EQ] = ACTIONS(3560),
    [anon_sym_LBRACK_LT] = ACTIONS(3560),
    [anon_sym_COLON] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_let_BANG] = ACTIONS(3560),
    [aux_sym_access_modifier_token1] = ACTIONS(3560),
    [anon_sym_LPAREN] = ACTIONS(3562),
    [anon_sym_COMMA] = ACTIONS(3560),
    [anon_sym_null] = ACTIONS(3562),
    [anon_sym_QMARK] = ACTIONS(3562),
    [anon_sym_COLON_QMARK] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3560),
    [anon_sym_LBRACE] = ACTIONS(3562),
    [anon_sym_LT_AT] = ACTIONS(3562),
    [anon_sym_LT_AT_AT] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(3562),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3560),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_with] = ACTIONS(3562),
    [anon_sym_return_BANG] = ACTIONS(3560),
    [anon_sym_yield] = ACTIONS(3562),
    [anon_sym_yield_BANG] = ACTIONS(3560),
    [anon_sym_lazy] = ACTIONS(3562),
    [anon_sym_assert] = ACTIONS(3562),
    [anon_sym_upcast] = ACTIONS(3562),
    [anon_sym_downcast] = ACTIONS(3562),
    [anon_sym_COLON_GT] = ACTIONS(3560),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3560),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_fun] = ACTIONS(3562),
    [anon_sym_DASH_GT] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_match] = ACTIONS(3562),
    [anon_sym_match_BANG] = ACTIONS(3560),
    [anon_sym_function] = ACTIONS(3562),
    [anon_sym_LT_DASH] = ACTIONS(3562),
    [anon_sym_DOT_LBRACK] = ACTIONS(3560),
    [anon_sym_LT] = ACTIONS(3560),
    [anon_sym_use] = ACTIONS(3562),
    [anon_sym_use_BANG] = ACTIONS(3560),
    [anon_sym_do_BANG] = ACTIONS(3560),
    [anon_sym_begin] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3562),
    [anon_sym_LT2] = ACTIONS(3562),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3560),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_or] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_member] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_abstract] = ACTIONS(3562),
    [anon_sym_val] = ACTIONS(3562),
    [anon_sym_override] = ACTIONS(3562),
    [anon_sym_inherit] = ACTIONS(3562),
    [aux_sym_char_token1] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(3562),
    [anon_sym_AT_DQUOTE] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [sym_bool] = ACTIONS(3562),
    [sym_unit] = ACTIONS(3560),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3562),
    [sym_op_identifier] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS_DOT] = ACTIONS(3562),
    [anon_sym_DASH_DOT] = ACTIONS(3562),
    [anon_sym_PERCENT] = ACTIONS(3562),
    [anon_sym_AMP_AMP] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3560),
    [aux_sym_prefix_op_token1] = ACTIONS(3562),
    [aux_sym_infix_op_token1] = ACTIONS(3560),
    [aux_sym_infix_op_token2] = ACTIONS(3562),
    [anon_sym_PIPE_PIPE] = ACTIONS(3562),
    [anon_sym_BANG_EQ] = ACTIONS(3562),
    [anon_sym_COLON_EQ] = ACTIONS(3560),
    [anon_sym_DOLLAR] = ACTIONS(3562),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3562),
    [sym_int] = ACTIONS(3562),
    [sym_xint] = ACTIONS(3560),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3560),
    [anon_sym_POUNDendif] = ACTIONS(3560),
    [sym__newline] = ACTIONS(3560),
  },
  [1536] = {
    [sym_block_comment] = STATE(1536),
    [sym_compiler_directive_decl] = STATE(1536),
    [sym_fsi_directive_decl] = STATE(1536),
    [sym_preproc_line] = STATE(1536),
    [sym_identifier] = ACTIONS(3543),
    [anon_sym_EQ] = ACTIONS(3541),
    [anon_sym_LBRACK_LT] = ACTIONS(3541),
    [anon_sym_COLON] = ACTIONS(3543),
    [anon_sym_return] = ACTIONS(3543),
    [anon_sym_do] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3543),
    [anon_sym_let_BANG] = ACTIONS(3541),
    [aux_sym_access_modifier_token1] = ACTIONS(3541),
    [anon_sym_LPAREN] = ACTIONS(3543),
    [anon_sym_COMMA] = ACTIONS(3541),
    [anon_sym_null] = ACTIONS(3543),
    [anon_sym_QMARK] = ACTIONS(3543),
    [anon_sym_COLON_QMARK] = ACTIONS(3543),
    [anon_sym_COLON_COLON] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3543),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3541),
    [anon_sym_LBRACE] = ACTIONS(3543),
    [anon_sym_LT_AT] = ACTIONS(3543),
    [anon_sym_LT_AT_AT] = ACTIONS(3543),
    [anon_sym_DOT] = ACTIONS(3543),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3541),
    [anon_sym_new] = ACTIONS(3543),
    [anon_sym_with] = ACTIONS(3543),
    [anon_sym_return_BANG] = ACTIONS(3541),
    [anon_sym_yield] = ACTIONS(3543),
    [anon_sym_yield_BANG] = ACTIONS(3541),
    [anon_sym_lazy] = ACTIONS(3543),
    [anon_sym_assert] = ACTIONS(3543),
    [anon_sym_upcast] = ACTIONS(3543),
    [anon_sym_downcast] = ACTIONS(3543),
    [anon_sym_COLON_GT] = ACTIONS(3541),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3541),
    [anon_sym_for] = ACTIONS(3543),
    [anon_sym_while] = ACTIONS(3543),
    [anon_sym_if] = ACTIONS(3543),
    [anon_sym_fun] = ACTIONS(3543),
    [anon_sym_DASH_GT] = ACTIONS(3543),
    [anon_sym_try] = ACTIONS(3543),
    [anon_sym_match] = ACTIONS(3543),
    [anon_sym_match_BANG] = ACTIONS(3541),
    [anon_sym_function] = ACTIONS(3543),
    [anon_sym_LT_DASH] = ACTIONS(3543),
    [anon_sym_DOT_LBRACK] = ACTIONS(3541),
    [anon_sym_LT] = ACTIONS(3541),
    [anon_sym_use] = ACTIONS(3543),
    [anon_sym_use_BANG] = ACTIONS(3541),
    [anon_sym_do_BANG] = ACTIONS(3541),
    [anon_sym_begin] = ACTIONS(3543),
    [anon_sym_LPAREN2] = ACTIONS(3543),
    [anon_sym_DOT_DOT2] = ACTIONS(3541),
    [anon_sym_STAR] = ACTIONS(3543),
    [anon_sym_LT2] = ACTIONS(3543),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_default] = ACTIONS(3543),
    [anon_sym_or] = ACTIONS(3543),
    [anon_sym_static] = ACTIONS(3543),
    [anon_sym_member] = ACTIONS(3543),
    [anon_sym_interface] = ACTIONS(3543),
    [anon_sym_abstract] = ACTIONS(3543),
    [anon_sym_val] = ACTIONS(3543),
    [anon_sym_override] = ACTIONS(3543),
    [aux_sym_char_token1] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3543),
    [anon_sym_DQUOTE] = ACTIONS(3543),
    [anon_sym_AT_DQUOTE] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [sym_bool] = ACTIONS(3543),
    [sym_unit] = ACTIONS(3541),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3543),
    [sym_op_identifier] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(3543),
    [anon_sym_DASH] = ACTIONS(3543),
    [anon_sym_PLUS_DOT] = ACTIONS(3543),
    [anon_sym_DASH_DOT] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3543),
    [anon_sym_AMP_AMP] = ACTIONS(3543),
    [anon_sym_TILDE] = ACTIONS(3541),
    [aux_sym_prefix_op_token1] = ACTIONS(3543),
    [aux_sym_infix_op_token1] = ACTIONS(3541),
    [aux_sym_infix_op_token2] = ACTIONS(3543),
    [anon_sym_PIPE_PIPE] = ACTIONS(3543),
    [anon_sym_BANG_EQ] = ACTIONS(3543),
    [anon_sym_COLON_EQ] = ACTIONS(3541),
    [anon_sym_DOLLAR] = ACTIONS(3543),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3543),
    [sym_int] = ACTIONS(3543),
    [sym_xint] = ACTIONS(3541),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3541),
    [sym__newline] = ACTIONS(3541),
    [sym__dedent] = ACTIONS(3541),
  },
  [1537] = {
    [sym_block_comment] = STATE(1537),
    [sym_compiler_directive_decl] = STATE(1537),
    [sym_fsi_directive_decl] = STATE(1537),
    [sym_preproc_line] = STATE(1537),
    [sym_identifier] = ACTIONS(3539),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_LBRACK_LT] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3539),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_do] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3539),
    [anon_sym_let_BANG] = ACTIONS(3537),
    [aux_sym_access_modifier_token1] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_null] = ACTIONS(3539),
    [anon_sym_QMARK] = ACTIONS(3539),
    [anon_sym_COLON_QMARK] = ACTIONS(3539),
    [anon_sym_COLON_COLON] = ACTIONS(3537),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3537),
    [anon_sym_LBRACE] = ACTIONS(3539),
    [anon_sym_LT_AT] = ACTIONS(3539),
    [anon_sym_LT_AT_AT] = ACTIONS(3539),
    [anon_sym_DOT] = ACTIONS(3539),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3537),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_with] = ACTIONS(3539),
    [anon_sym_return_BANG] = ACTIONS(3537),
    [anon_sym_yield] = ACTIONS(3539),
    [anon_sym_yield_BANG] = ACTIONS(3537),
    [anon_sym_lazy] = ACTIONS(3539),
    [anon_sym_assert] = ACTIONS(3539),
    [anon_sym_upcast] = ACTIONS(3539),
    [anon_sym_downcast] = ACTIONS(3539),
    [anon_sym_COLON_GT] = ACTIONS(3537),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3537),
    [anon_sym_for] = ACTIONS(3539),
    [anon_sym_while] = ACTIONS(3539),
    [anon_sym_if] = ACTIONS(3539),
    [anon_sym_fun] = ACTIONS(3539),
    [anon_sym_DASH_GT] = ACTIONS(3539),
    [anon_sym_try] = ACTIONS(3539),
    [anon_sym_match] = ACTIONS(3539),
    [anon_sym_match_BANG] = ACTIONS(3537),
    [anon_sym_function] = ACTIONS(3539),
    [anon_sym_LT_DASH] = ACTIONS(3539),
    [anon_sym_DOT_LBRACK] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_use] = ACTIONS(3539),
    [anon_sym_use_BANG] = ACTIONS(3537),
    [anon_sym_do_BANG] = ACTIONS(3537),
    [anon_sym_begin] = ACTIONS(3539),
    [anon_sym_LPAREN2] = ACTIONS(3539),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_LT2] = ACTIONS(3539),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_default] = ACTIONS(3539),
    [anon_sym_or] = ACTIONS(3539),
    [anon_sym_static] = ACTIONS(3539),
    [anon_sym_member] = ACTIONS(3539),
    [anon_sym_interface] = ACTIONS(3539),
    [anon_sym_abstract] = ACTIONS(3539),
    [anon_sym_val] = ACTIONS(3539),
    [anon_sym_override] = ACTIONS(3539),
    [anon_sym_inherit] = ACTIONS(3539),
    [aux_sym_char_token1] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3539),
    [anon_sym_DQUOTE] = ACTIONS(3539),
    [anon_sym_AT_DQUOTE] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [sym_bool] = ACTIONS(3539),
    [sym_unit] = ACTIONS(3537),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3539),
    [sym_op_identifier] = ACTIONS(3539),
    [anon_sym_PLUS] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(3539),
    [anon_sym_PLUS_DOT] = ACTIONS(3539),
    [anon_sym_DASH_DOT] = ACTIONS(3539),
    [anon_sym_PERCENT] = ACTIONS(3539),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_TILDE] = ACTIONS(3537),
    [aux_sym_prefix_op_token1] = ACTIONS(3539),
    [aux_sym_infix_op_token1] = ACTIONS(3537),
    [aux_sym_infix_op_token2] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3539),
    [anon_sym_BANG_EQ] = ACTIONS(3539),
    [anon_sym_COLON_EQ] = ACTIONS(3537),
    [anon_sym_DOLLAR] = ACTIONS(3539),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3539),
    [sym_int] = ACTIONS(3539),
    [sym_xint] = ACTIONS(3537),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3537),
    [anon_sym_POUNDendif] = ACTIONS(3537),
    [sym__newline] = ACTIONS(3537),
  },
  [1538] = {
    [sym_block_comment] = STATE(1538),
    [sym_compiler_directive_decl] = STATE(1538),
    [sym_fsi_directive_decl] = STATE(1538),
    [sym_preproc_line] = STATE(1538),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_LBRACK_LT] = ACTIONS(3513),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [aux_sym_access_modifier_token1] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_COLON] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_with] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(3513),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_LT_DASH] = ACTIONS(3515),
    [anon_sym_DOT_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_DOT_DOT2] = ACTIONS(3513),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3515),
    [anon_sym_or] = ACTIONS(3515),
    [anon_sym_static] = ACTIONS(3515),
    [anon_sym_member] = ACTIONS(3515),
    [anon_sym_interface] = ACTIONS(3515),
    [anon_sym_abstract] = ACTIONS(3515),
    [anon_sym_val] = ACTIONS(3515),
    [anon_sym_override] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3515),
    [anon_sym_DASH_DOT] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3515),
    [aux_sym_infix_op_token1] = ACTIONS(3513),
    [aux_sym_infix_op_token2] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3515),
    [anon_sym_COLON_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(3515),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3515),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
    [sym__dedent] = ACTIONS(3513),
  },
  [1539] = {
    [sym_block_comment] = STATE(1539),
    [sym_compiler_directive_decl] = STATE(1539),
    [sym_fsi_directive_decl] = STATE(1539),
    [sym_preproc_line] = STATE(1539),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3525),
    [anon_sym_LBRACK_LT] = ACTIONS(3525),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [aux_sym_access_modifier_token1] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_COLON] = ACTIONS(3525),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_with] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_COLON_GT] = ACTIONS(3525),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_DASH_GT] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_LT_DASH] = ACTIONS(3527),
    [anon_sym_DOT_LBRACK] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_LPAREN2] = ACTIONS(3527),
    [anon_sym_DOT_DOT2] = ACTIONS(3525),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_LT2] = ACTIONS(3527),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_default] = ACTIONS(3527),
    [anon_sym_or] = ACTIONS(3527),
    [anon_sym_static] = ACTIONS(3527),
    [anon_sym_member] = ACTIONS(3527),
    [anon_sym_interface] = ACTIONS(3527),
    [anon_sym_abstract] = ACTIONS(3527),
    [anon_sym_val] = ACTIONS(3527),
    [anon_sym_override] = ACTIONS(3527),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3525),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3527),
    [anon_sym_DASH_DOT] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3527),
    [aux_sym_infix_op_token1] = ACTIONS(3525),
    [aux_sym_infix_op_token2] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_COLON_EQ] = ACTIONS(3525),
    [anon_sym_DOLLAR] = ACTIONS(3527),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3527),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3525),
    [sym__newline] = ACTIONS(3525),
    [sym__dedent] = ACTIONS(3525),
  },
  [1540] = {
    [sym_block_comment] = STATE(1540),
    [sym_compiler_directive_decl] = STATE(1540),
    [sym_fsi_directive_decl] = STATE(1540),
    [sym_preproc_line] = STATE(1540),
    [sym_identifier] = ACTIONS(3505),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_LBRACK_LT] = ACTIONS(3503),
    [anon_sym_COLON] = ACTIONS(3505),
    [anon_sym_return] = ACTIONS(3505),
    [anon_sym_do] = ACTIONS(3505),
    [anon_sym_let] = ACTIONS(3505),
    [anon_sym_let_BANG] = ACTIONS(3503),
    [aux_sym_access_modifier_token1] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3505),
    [anon_sym_COMMA] = ACTIONS(3503),
    [anon_sym_null] = ACTIONS(3505),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_COLON_QMARK] = ACTIONS(3505),
    [anon_sym_COLON_COLON] = ACTIONS(3503),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3503),
    [anon_sym_LBRACE] = ACTIONS(3505),
    [anon_sym_LT_AT] = ACTIONS(3505),
    [anon_sym_LT_AT_AT] = ACTIONS(3505),
    [anon_sym_DOT] = ACTIONS(3505),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3503),
    [anon_sym_new] = ACTIONS(3505),
    [anon_sym_with] = ACTIONS(3505),
    [anon_sym_return_BANG] = ACTIONS(3503),
    [anon_sym_yield] = ACTIONS(3505),
    [anon_sym_yield_BANG] = ACTIONS(3503),
    [anon_sym_lazy] = ACTIONS(3505),
    [anon_sym_assert] = ACTIONS(3505),
    [anon_sym_upcast] = ACTIONS(3505),
    [anon_sym_downcast] = ACTIONS(3505),
    [anon_sym_COLON_GT] = ACTIONS(3503),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3503),
    [anon_sym_for] = ACTIONS(3505),
    [anon_sym_while] = ACTIONS(3505),
    [anon_sym_if] = ACTIONS(3505),
    [anon_sym_fun] = ACTIONS(3505),
    [anon_sym_DASH_GT] = ACTIONS(3505),
    [anon_sym_try] = ACTIONS(3505),
    [anon_sym_match] = ACTIONS(3505),
    [anon_sym_match_BANG] = ACTIONS(3503),
    [anon_sym_function] = ACTIONS(3505),
    [anon_sym_LT_DASH] = ACTIONS(3505),
    [anon_sym_DOT_LBRACK] = ACTIONS(3503),
    [anon_sym_LT] = ACTIONS(3503),
    [anon_sym_use] = ACTIONS(3505),
    [anon_sym_use_BANG] = ACTIONS(3503),
    [anon_sym_do_BANG] = ACTIONS(3503),
    [anon_sym_begin] = ACTIONS(3505),
    [anon_sym_LPAREN2] = ACTIONS(3505),
    [anon_sym_DOT_DOT2] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(3505),
    [anon_sym_LT2] = ACTIONS(4335),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_default] = ACTIONS(3505),
    [anon_sym_or] = ACTIONS(3505),
    [anon_sym_static] = ACTIONS(3505),
    [anon_sym_member] = ACTIONS(3505),
    [anon_sym_interface] = ACTIONS(3505),
    [anon_sym_abstract] = ACTIONS(3505),
    [anon_sym_val] = ACTIONS(3505),
    [anon_sym_override] = ACTIONS(3505),
    [aux_sym_char_token1] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3505),
    [anon_sym_DQUOTE] = ACTIONS(3505),
    [anon_sym_AT_DQUOTE] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [sym_bool] = ACTIONS(3505),
    [sym_unit] = ACTIONS(3503),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3505),
    [sym_op_identifier] = ACTIONS(3505),
    [anon_sym_PLUS] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3505),
    [anon_sym_PLUS_DOT] = ACTIONS(3505),
    [anon_sym_DASH_DOT] = ACTIONS(3505),
    [anon_sym_PERCENT] = ACTIONS(3505),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3503),
    [aux_sym_prefix_op_token1] = ACTIONS(3505),
    [aux_sym_infix_op_token1] = ACTIONS(3503),
    [aux_sym_infix_op_token2] = ACTIONS(3505),
    [anon_sym_PIPE_PIPE] = ACTIONS(3505),
    [anon_sym_BANG_EQ] = ACTIONS(3505),
    [anon_sym_COLON_EQ] = ACTIONS(3503),
    [anon_sym_DOLLAR] = ACTIONS(3505),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3505),
    [sym_int] = ACTIONS(3505),
    [sym_xint] = ACTIONS(3503),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3503),
    [sym__newline] = ACTIONS(3503),
    [sym__dedent] = ACTIONS(3503),
  },
  [1541] = {
    [sym_block_comment] = STATE(1541),
    [sym_compiler_directive_decl] = STATE(1541),
    [sym_fsi_directive_decl] = STATE(1541),
    [sym_preproc_line] = STATE(1541),
    [sym_identifier] = ACTIONS(3535),
    [anon_sym_EQ] = ACTIONS(3533),
    [anon_sym_LBRACK_LT] = ACTIONS(3533),
    [anon_sym_COLON] = ACTIONS(3535),
    [anon_sym_return] = ACTIONS(3535),
    [anon_sym_do] = ACTIONS(3535),
    [anon_sym_let] = ACTIONS(3535),
    [anon_sym_let_BANG] = ACTIONS(3533),
    [aux_sym_access_modifier_token1] = ACTIONS(3533),
    [anon_sym_LPAREN] = ACTIONS(3535),
    [anon_sym_COMMA] = ACTIONS(3533),
    [anon_sym_null] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(3535),
    [anon_sym_COLON_QMARK] = ACTIONS(3535),
    [anon_sym_COLON_COLON] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3533),
    [anon_sym_LBRACE] = ACTIONS(3535),
    [anon_sym_LT_AT] = ACTIONS(3535),
    [anon_sym_LT_AT_AT] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(3535),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3533),
    [anon_sym_new] = ACTIONS(3535),
    [anon_sym_with] = ACTIONS(3535),
    [anon_sym_return_BANG] = ACTIONS(3533),
    [anon_sym_yield] = ACTIONS(3535),
    [anon_sym_yield_BANG] = ACTIONS(3533),
    [anon_sym_lazy] = ACTIONS(3535),
    [anon_sym_assert] = ACTIONS(3535),
    [anon_sym_upcast] = ACTIONS(3535),
    [anon_sym_downcast] = ACTIONS(3535),
    [anon_sym_COLON_GT] = ACTIONS(3533),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3533),
    [anon_sym_for] = ACTIONS(3535),
    [anon_sym_while] = ACTIONS(3535),
    [anon_sym_if] = ACTIONS(3535),
    [anon_sym_fun] = ACTIONS(3535),
    [anon_sym_DASH_GT] = ACTIONS(3535),
    [anon_sym_try] = ACTIONS(3535),
    [anon_sym_match] = ACTIONS(3535),
    [anon_sym_match_BANG] = ACTIONS(3533),
    [anon_sym_function] = ACTIONS(3535),
    [anon_sym_LT_DASH] = ACTIONS(3535),
    [anon_sym_DOT_LBRACK] = ACTIONS(3533),
    [anon_sym_LT] = ACTIONS(3533),
    [anon_sym_use] = ACTIONS(3535),
    [anon_sym_use_BANG] = ACTIONS(3533),
    [anon_sym_do_BANG] = ACTIONS(3533),
    [anon_sym_begin] = ACTIONS(3535),
    [anon_sym_LPAREN2] = ACTIONS(3535),
    [anon_sym_DOT_DOT2] = ACTIONS(3533),
    [anon_sym_STAR] = ACTIONS(3535),
    [anon_sym_LT2] = ACTIONS(3535),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3533),
    [anon_sym_default] = ACTIONS(3535),
    [anon_sym_or] = ACTIONS(3535),
    [anon_sym_static] = ACTIONS(3535),
    [anon_sym_member] = ACTIONS(3535),
    [anon_sym_interface] = ACTIONS(3535),
    [anon_sym_abstract] = ACTIONS(3535),
    [anon_sym_val] = ACTIONS(3535),
    [anon_sym_override] = ACTIONS(3535),
    [aux_sym_char_token1] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE] = ACTIONS(3535),
    [anon_sym_AT_DQUOTE] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [sym_bool] = ACTIONS(3535),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3535),
    [sym_op_identifier] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS_DOT] = ACTIONS(3535),
    [anon_sym_DASH_DOT] = ACTIONS(3535),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(3535),
    [anon_sym_TILDE] = ACTIONS(3533),
    [aux_sym_prefix_op_token1] = ACTIONS(3535),
    [aux_sym_infix_op_token1] = ACTIONS(3533),
    [aux_sym_infix_op_token2] = ACTIONS(3535),
    [anon_sym_PIPE_PIPE] = ACTIONS(3535),
    [anon_sym_BANG_EQ] = ACTIONS(3535),
    [anon_sym_COLON_EQ] = ACTIONS(3533),
    [anon_sym_DOLLAR] = ACTIONS(3535),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3535),
    [sym_int] = ACTIONS(3535),
    [sym_xint] = ACTIONS(3533),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3533),
    [sym__newline] = ACTIONS(3533),
    [sym__dedent] = ACTIONS(3533),
  },
  [1542] = {
    [sym_block_comment] = STATE(1542),
    [sym_compiler_directive_decl] = STATE(1542),
    [sym_fsi_directive_decl] = STATE(1542),
    [sym_preproc_line] = STATE(1542),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_and] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [aux_sym_access_modifier_token1] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_member] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_val] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
    [sym__dedent] = ACTIONS(3485),
  },
  [1543] = {
    [sym_block_comment] = STATE(1543),
    [sym_compiler_directive_decl] = STATE(1543),
    [sym_fsi_directive_decl] = STATE(1543),
    [sym_preproc_line] = STATE(1543),
    [sym_identifier] = ACTIONS(3547),
    [anon_sym_EQ] = ACTIONS(3545),
    [anon_sym_LBRACK_LT] = ACTIONS(3545),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_return] = ACTIONS(3547),
    [anon_sym_do] = ACTIONS(3547),
    [anon_sym_let] = ACTIONS(3547),
    [anon_sym_let_BANG] = ACTIONS(3545),
    [aux_sym_access_modifier_token1] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(3547),
    [anon_sym_COMMA] = ACTIONS(3545),
    [anon_sym_null] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3547),
    [anon_sym_COLON_QMARK] = ACTIONS(3547),
    [anon_sym_COLON_COLON] = ACTIONS(3545),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3545),
    [anon_sym_LBRACE] = ACTIONS(3547),
    [anon_sym_LT_AT] = ACTIONS(3547),
    [anon_sym_LT_AT_AT] = ACTIONS(3547),
    [anon_sym_DOT] = ACTIONS(3547),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3545),
    [anon_sym_new] = ACTIONS(3547),
    [anon_sym_with] = ACTIONS(3547),
    [anon_sym_return_BANG] = ACTIONS(3545),
    [anon_sym_yield] = ACTIONS(3547),
    [anon_sym_yield_BANG] = ACTIONS(3545),
    [anon_sym_lazy] = ACTIONS(3547),
    [anon_sym_assert] = ACTIONS(3547),
    [anon_sym_upcast] = ACTIONS(3547),
    [anon_sym_downcast] = ACTIONS(3547),
    [anon_sym_COLON_GT] = ACTIONS(3545),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3545),
    [anon_sym_for] = ACTIONS(3547),
    [anon_sym_while] = ACTIONS(3547),
    [anon_sym_if] = ACTIONS(3547),
    [anon_sym_fun] = ACTIONS(3547),
    [anon_sym_DASH_GT] = ACTIONS(3547),
    [anon_sym_try] = ACTIONS(3547),
    [anon_sym_match] = ACTIONS(3547),
    [anon_sym_match_BANG] = ACTIONS(3545),
    [anon_sym_function] = ACTIONS(3547),
    [anon_sym_LT_DASH] = ACTIONS(3547),
    [anon_sym_DOT_LBRACK] = ACTIONS(3545),
    [anon_sym_LT] = ACTIONS(3545),
    [anon_sym_use] = ACTIONS(3547),
    [anon_sym_use_BANG] = ACTIONS(3545),
    [anon_sym_do_BANG] = ACTIONS(3545),
    [anon_sym_begin] = ACTIONS(3547),
    [anon_sym_LPAREN2] = ACTIONS(3547),
    [anon_sym_STAR] = ACTIONS(3547),
    [anon_sym_LT2] = ACTIONS(3547),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_default] = ACTIONS(3547),
    [anon_sym_or] = ACTIONS(3547),
    [anon_sym_static] = ACTIONS(3547),
    [anon_sym_member] = ACTIONS(3547),
    [anon_sym_interface] = ACTIONS(3547),
    [anon_sym_abstract] = ACTIONS(3547),
    [anon_sym_val] = ACTIONS(3547),
    [anon_sym_override] = ACTIONS(3547),
    [anon_sym_inherit] = ACTIONS(3547),
    [aux_sym_char_token1] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3547),
    [anon_sym_DQUOTE] = ACTIONS(3547),
    [anon_sym_AT_DQUOTE] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [sym_bool] = ACTIONS(3547),
    [sym_unit] = ACTIONS(3545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3547),
    [sym_op_identifier] = ACTIONS(3547),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PLUS_DOT] = ACTIONS(3547),
    [anon_sym_DASH_DOT] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3547),
    [anon_sym_AMP_AMP] = ACTIONS(3547),
    [anon_sym_TILDE] = ACTIONS(3545),
    [aux_sym_prefix_op_token1] = ACTIONS(3547),
    [aux_sym_infix_op_token1] = ACTIONS(3545),
    [aux_sym_infix_op_token2] = ACTIONS(3547),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_BANG_EQ] = ACTIONS(3547),
    [anon_sym_COLON_EQ] = ACTIONS(3545),
    [anon_sym_DOLLAR] = ACTIONS(3547),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3547),
    [sym_int] = ACTIONS(3547),
    [sym_xint] = ACTIONS(3545),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3545),
    [anon_sym_POUNDendif] = ACTIONS(3545),
    [sym__newline] = ACTIONS(3545),
  },
  [1544] = {
    [sym_elif_expression] = STATE(1651),
    [sym_block_comment] = STATE(1544),
    [sym_compiler_directive_decl] = STATE(1544),
    [sym_fsi_directive_decl] = STATE(1544),
    [sym_preproc_line] = STATE(1544),
    [aux_sym_if_expression_repeat1] = STATE(1544),
    [sym_identifier] = ACTIONS(3555),
    [anon_sym_EQ] = ACTIONS(3553),
    [anon_sym_LBRACK_LT] = ACTIONS(3553),
    [anon_sym_COLON] = ACTIONS(3555),
    [anon_sym_return] = ACTIONS(3555),
    [anon_sym_do] = ACTIONS(3555),
    [anon_sym_and] = ACTIONS(3555),
    [anon_sym_let] = ACTIONS(3555),
    [anon_sym_let_BANG] = ACTIONS(3553),
    [aux_sym_access_modifier_token1] = ACTIONS(3553),
    [anon_sym_LPAREN] = ACTIONS(3555),
    [anon_sym_COMMA] = ACTIONS(3553),
    [anon_sym_null] = ACTIONS(3555),
    [anon_sym_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_COLON] = ACTIONS(3553),
    [anon_sym_AMP] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(3555),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3553),
    [anon_sym_LBRACE] = ACTIONS(3555),
    [anon_sym_LT_AT] = ACTIONS(3555),
    [anon_sym_LT_AT_AT] = ACTIONS(3555),
    [anon_sym_DOT] = ACTIONS(3555),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3553),
    [anon_sym_new] = ACTIONS(3555),
    [anon_sym_with] = ACTIONS(3555),
    [anon_sym_return_BANG] = ACTIONS(3553),
    [anon_sym_yield] = ACTIONS(3555),
    [anon_sym_yield_BANG] = ACTIONS(3553),
    [anon_sym_lazy] = ACTIONS(3555),
    [anon_sym_assert] = ACTIONS(3555),
    [anon_sym_upcast] = ACTIONS(3555),
    [anon_sym_downcast] = ACTIONS(3555),
    [anon_sym_COLON_GT] = ACTIONS(3553),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3553),
    [anon_sym_for] = ACTIONS(3555),
    [anon_sym_while] = ACTIONS(3555),
    [anon_sym_else] = ACTIONS(3555),
    [anon_sym_elif] = ACTIONS(4337),
    [anon_sym_if] = ACTIONS(3555),
    [anon_sym_fun] = ACTIONS(3555),
    [anon_sym_try] = ACTIONS(3555),
    [anon_sym_match] = ACTIONS(3555),
    [anon_sym_match_BANG] = ACTIONS(3553),
    [anon_sym_function] = ACTIONS(3555),
    [anon_sym_LT_DASH] = ACTIONS(3555),
    [anon_sym_DOT_LBRACK] = ACTIONS(3553),
    [anon_sym_LT] = ACTIONS(3553),
    [anon_sym_use] = ACTIONS(3555),
    [anon_sym_use_BANG] = ACTIONS(3553),
    [anon_sym_do_BANG] = ACTIONS(3553),
    [anon_sym_begin] = ACTIONS(3555),
    [anon_sym_LPAREN2] = ACTIONS(3555),
    [anon_sym_default] = ACTIONS(3555),
    [anon_sym_or] = ACTIONS(3555),
    [anon_sym_static] = ACTIONS(3555),
    [anon_sym_member] = ACTIONS(3555),
    [anon_sym_interface] = ACTIONS(3555),
    [anon_sym_abstract] = ACTIONS(3555),
    [anon_sym_val] = ACTIONS(3555),
    [anon_sym_override] = ACTIONS(3555),
    [aux_sym_char_token1] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3555),
    [anon_sym_DQUOTE] = ACTIONS(3555),
    [anon_sym_AT_DQUOTE] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [sym_bool] = ACTIONS(3555),
    [sym_unit] = ACTIONS(3553),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3555),
    [sym_op_identifier] = ACTIONS(3555),
    [anon_sym_PLUS] = ACTIONS(3555),
    [anon_sym_DASH] = ACTIONS(3555),
    [anon_sym_PLUS_DOT] = ACTIONS(3555),
    [anon_sym_DASH_DOT] = ACTIONS(3555),
    [anon_sym_PERCENT] = ACTIONS(3555),
    [anon_sym_AMP_AMP] = ACTIONS(3555),
    [anon_sym_TILDE] = ACTIONS(3553),
    [aux_sym_prefix_op_token1] = ACTIONS(3555),
    [aux_sym_infix_op_token1] = ACTIONS(3553),
    [aux_sym_infix_op_token2] = ACTIONS(3555),
    [anon_sym_PIPE_PIPE] = ACTIONS(3555),
    [anon_sym_BANG_EQ] = ACTIONS(3555),
    [anon_sym_COLON_EQ] = ACTIONS(3553),
    [anon_sym_DOLLAR] = ACTIONS(3555),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3555),
    [sym_int] = ACTIONS(3555),
    [sym_xint] = ACTIONS(3553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3553),
    [anon_sym_POUNDendif] = ACTIONS(3553),
    [sym__newline] = ACTIONS(3553),
  },
  [1545] = {
    [sym_block_comment] = STATE(1545),
    [sym_compiler_directive_decl] = STATE(1545),
    [sym_fsi_directive_decl] = STATE(1545),
    [sym_preproc_line] = STATE(1545),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(3521),
    [anon_sym_LBRACK_LT] = ACTIONS(3521),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_and] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3521),
    [aux_sym_access_modifier_token1] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_COMMA] = ACTIONS(3521),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_COLON] = ACTIONS(3521),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_with] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3521),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3521),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_COLON_GT] = ACTIONS(3521),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_DASH_GT] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3521),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_LT_DASH] = ACTIONS(3523),
    [anon_sym_DOT_LBRACK] = ACTIONS(3521),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3521),
    [anon_sym_do_BANG] = ACTIONS(3521),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_LPAREN2] = ACTIONS(3523),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_LT2] = ACTIONS(3523),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3521),
    [anon_sym_default] = ACTIONS(3523),
    [anon_sym_or] = ACTIONS(3523),
    [anon_sym_static] = ACTIONS(3523),
    [anon_sym_member] = ACTIONS(3523),
    [anon_sym_interface] = ACTIONS(3523),
    [anon_sym_abstract] = ACTIONS(3523),
    [anon_sym_val] = ACTIONS(3523),
    [anon_sym_override] = ACTIONS(3523),
    [aux_sym_char_token1] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3521),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3523),
    [anon_sym_DASH_DOT] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3521),
    [aux_sym_prefix_op_token1] = ACTIONS(3523),
    [aux_sym_infix_op_token1] = ACTIONS(3521),
    [aux_sym_infix_op_token2] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3523),
    [anon_sym_COLON_EQ] = ACTIONS(3521),
    [anon_sym_DOLLAR] = ACTIONS(3523),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3523),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3521),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3521),
    [anon_sym_POUNDendif] = ACTIONS(3521),
    [sym__newline] = ACTIONS(3521),
  },
  [1546] = {
    [sym_block_comment] = STATE(1546),
    [sym_compiler_directive_decl] = STATE(1546),
    [sym_fsi_directive_decl] = STATE(1546),
    [sym_preproc_line] = STATE(1546),
    [sym_identifier] = ACTIONS(3535),
    [anon_sym_EQ] = ACTIONS(3533),
    [anon_sym_LBRACK_LT] = ACTIONS(3533),
    [anon_sym_COLON] = ACTIONS(3535),
    [anon_sym_return] = ACTIONS(3535),
    [anon_sym_do] = ACTIONS(3535),
    [anon_sym_let] = ACTIONS(3535),
    [anon_sym_let_BANG] = ACTIONS(3533),
    [aux_sym_access_modifier_token1] = ACTIONS(3533),
    [anon_sym_LPAREN] = ACTIONS(3535),
    [anon_sym_COMMA] = ACTIONS(3533),
    [anon_sym_null] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(3535),
    [anon_sym_COLON_QMARK] = ACTIONS(3535),
    [anon_sym_COLON_COLON] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3533),
    [anon_sym_LBRACE] = ACTIONS(3535),
    [anon_sym_LT_AT] = ACTIONS(3535),
    [anon_sym_LT_AT_AT] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(3535),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3533),
    [anon_sym_new] = ACTIONS(3535),
    [anon_sym_with] = ACTIONS(3535),
    [anon_sym_return_BANG] = ACTIONS(3533),
    [anon_sym_yield] = ACTIONS(3535),
    [anon_sym_yield_BANG] = ACTIONS(3533),
    [anon_sym_lazy] = ACTIONS(3535),
    [anon_sym_assert] = ACTIONS(3535),
    [anon_sym_upcast] = ACTIONS(3535),
    [anon_sym_downcast] = ACTIONS(3535),
    [anon_sym_COLON_GT] = ACTIONS(3533),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3533),
    [anon_sym_for] = ACTIONS(3535),
    [anon_sym_while] = ACTIONS(3535),
    [anon_sym_if] = ACTIONS(3535),
    [anon_sym_fun] = ACTIONS(3535),
    [anon_sym_DASH_GT] = ACTIONS(3535),
    [anon_sym_try] = ACTIONS(3535),
    [anon_sym_match] = ACTIONS(3535),
    [anon_sym_match_BANG] = ACTIONS(3533),
    [anon_sym_function] = ACTIONS(3535),
    [anon_sym_LT_DASH] = ACTIONS(3535),
    [anon_sym_DOT_LBRACK] = ACTIONS(3533),
    [anon_sym_LT] = ACTIONS(3533),
    [anon_sym_use] = ACTIONS(3535),
    [anon_sym_use_BANG] = ACTIONS(3533),
    [anon_sym_do_BANG] = ACTIONS(3533),
    [anon_sym_begin] = ACTIONS(3535),
    [anon_sym_LPAREN2] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(3535),
    [anon_sym_LT2] = ACTIONS(3535),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3533),
    [anon_sym_default] = ACTIONS(3535),
    [anon_sym_or] = ACTIONS(3535),
    [anon_sym_static] = ACTIONS(3535),
    [anon_sym_member] = ACTIONS(3535),
    [anon_sym_interface] = ACTIONS(3535),
    [anon_sym_abstract] = ACTIONS(3535),
    [anon_sym_val] = ACTIONS(3535),
    [anon_sym_override] = ACTIONS(3535),
    [anon_sym_inherit] = ACTIONS(3535),
    [aux_sym_char_token1] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE] = ACTIONS(3535),
    [anon_sym_AT_DQUOTE] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [sym_bool] = ACTIONS(3535),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3535),
    [sym_op_identifier] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS_DOT] = ACTIONS(3535),
    [anon_sym_DASH_DOT] = ACTIONS(3535),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(3535),
    [anon_sym_TILDE] = ACTIONS(3533),
    [aux_sym_prefix_op_token1] = ACTIONS(3535),
    [aux_sym_infix_op_token1] = ACTIONS(3533),
    [aux_sym_infix_op_token2] = ACTIONS(3535),
    [anon_sym_PIPE_PIPE] = ACTIONS(3535),
    [anon_sym_BANG_EQ] = ACTIONS(3535),
    [anon_sym_COLON_EQ] = ACTIONS(3533),
    [anon_sym_DOLLAR] = ACTIONS(3535),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3535),
    [sym_int] = ACTIONS(3535),
    [sym_xint] = ACTIONS(3533),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3533),
    [anon_sym_POUNDendif] = ACTIONS(3533),
    [sym__newline] = ACTIONS(3533),
  },
  [1547] = {
    [sym_block_comment] = STATE(1547),
    [sym_compiler_directive_decl] = STATE(1547),
    [sym_fsi_directive_decl] = STATE(1547),
    [sym_preproc_line] = STATE(1547),
    [sym_identifier] = ACTIONS(3519),
    [anon_sym_EQ] = ACTIONS(3517),
    [anon_sym_LBRACK_LT] = ACTIONS(3517),
    [anon_sym_COLON] = ACTIONS(3519),
    [anon_sym_return] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(3519),
    [anon_sym_and] = ACTIONS(3519),
    [anon_sym_let] = ACTIONS(3519),
    [anon_sym_let_BANG] = ACTIONS(3517),
    [aux_sym_access_modifier_token1] = ACTIONS(3517),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [anon_sym_COMMA] = ACTIONS(3517),
    [anon_sym_null] = ACTIONS(3519),
    [anon_sym_QMARK] = ACTIONS(3519),
    [anon_sym_COLON_QMARK] = ACTIONS(3519),
    [anon_sym_COLON_COLON] = ACTIONS(3517),
    [anon_sym_AMP] = ACTIONS(3519),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_LT_AT] = ACTIONS(3519),
    [anon_sym_LT_AT_AT] = ACTIONS(3519),
    [anon_sym_DOT] = ACTIONS(3519),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3519),
    [anon_sym_with] = ACTIONS(3519),
    [anon_sym_return_BANG] = ACTIONS(3517),
    [anon_sym_yield] = ACTIONS(3519),
    [anon_sym_yield_BANG] = ACTIONS(3517),
    [anon_sym_lazy] = ACTIONS(3519),
    [anon_sym_assert] = ACTIONS(3519),
    [anon_sym_upcast] = ACTIONS(3519),
    [anon_sym_downcast] = ACTIONS(3519),
    [anon_sym_COLON_GT] = ACTIONS(3517),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3517),
    [anon_sym_for] = ACTIONS(3519),
    [anon_sym_while] = ACTIONS(3519),
    [anon_sym_if] = ACTIONS(3519),
    [anon_sym_fun] = ACTIONS(3519),
    [anon_sym_DASH_GT] = ACTIONS(3519),
    [anon_sym_try] = ACTIONS(3519),
    [anon_sym_match] = ACTIONS(3519),
    [anon_sym_match_BANG] = ACTIONS(3517),
    [anon_sym_function] = ACTIONS(3519),
    [anon_sym_LT_DASH] = ACTIONS(3519),
    [anon_sym_DOT_LBRACK] = ACTIONS(3517),
    [anon_sym_LT] = ACTIONS(3517),
    [anon_sym_use] = ACTIONS(3519),
    [anon_sym_use_BANG] = ACTIONS(3517),
    [anon_sym_do_BANG] = ACTIONS(3517),
    [anon_sym_begin] = ACTIONS(3519),
    [anon_sym_LPAREN2] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_LT2] = ACTIONS(3519),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3517),
    [anon_sym_default] = ACTIONS(3519),
    [anon_sym_or] = ACTIONS(3519),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_member] = ACTIONS(3519),
    [anon_sym_interface] = ACTIONS(3519),
    [anon_sym_abstract] = ACTIONS(3519),
    [anon_sym_val] = ACTIONS(3519),
    [anon_sym_override] = ACTIONS(3519),
    [aux_sym_char_token1] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [anon_sym_AT_DQUOTE] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [sym_bool] = ACTIONS(3519),
    [sym_unit] = ACTIONS(3517),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3519),
    [sym_op_identifier] = ACTIONS(3519),
    [anon_sym_PLUS] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_DOT] = ACTIONS(3519),
    [anon_sym_DASH_DOT] = ACTIONS(3519),
    [anon_sym_PERCENT] = ACTIONS(3519),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3517),
    [aux_sym_prefix_op_token1] = ACTIONS(3519),
    [aux_sym_infix_op_token1] = ACTIONS(3517),
    [aux_sym_infix_op_token2] = ACTIONS(3519),
    [anon_sym_PIPE_PIPE] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_COLON_EQ] = ACTIONS(3517),
    [anon_sym_DOLLAR] = ACTIONS(3519),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3519),
    [sym_int] = ACTIONS(3519),
    [sym_xint] = ACTIONS(3517),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3517),
    [anon_sym_POUNDendif] = ACTIONS(3517),
    [sym__newline] = ACTIONS(3517),
  },
  [1548] = {
    [sym_block_comment] = STATE(1548),
    [sym_compiler_directive_decl] = STATE(1548),
    [sym_fsi_directive_decl] = STATE(1548),
    [sym_preproc_line] = STATE(1548),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_and] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3339),
    [anon_sym_uy] = ACTIONS(3341),
    [anon_sym_s] = ACTIONS(3343),
    [anon_sym_us] = ACTIONS(3345),
    [anon_sym_l] = ACTIONS(3347),
    [aux_sym_uint32_token1] = ACTIONS(3349),
    [anon_sym_n] = ACTIONS(3351),
    [anon_sym_un] = ACTIONS(3353),
    [anon_sym_L] = ACTIONS(3355),
    [aux_sym_uint64_token1] = ACTIONS(3357),
    [aux_sym_bignum_token1] = ACTIONS(3359),
    [aux_sym_decimal_token1] = ACTIONS(3361),
    [anon_sym_DOT2] = ACTIONS(4340),
    [aux_sym_float_token1] = ACTIONS(4342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
    [sym__dedent] = ACTIONS(3191),
  },
  [1549] = {
    [sym_block_comment] = STATE(1549),
    [sym_compiler_directive_decl] = STATE(1549),
    [sym_fsi_directive_decl] = STATE(1549),
    [sym_preproc_line] = STATE(1549),
    [sym_identifier] = ACTIONS(3543),
    [anon_sym_EQ] = ACTIONS(3541),
    [anon_sym_LBRACK_LT] = ACTIONS(3541),
    [anon_sym_COLON] = ACTIONS(3543),
    [anon_sym_return] = ACTIONS(3543),
    [anon_sym_do] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3543),
    [anon_sym_let_BANG] = ACTIONS(3541),
    [aux_sym_access_modifier_token1] = ACTIONS(3541),
    [anon_sym_LPAREN] = ACTIONS(3543),
    [anon_sym_COMMA] = ACTIONS(3541),
    [anon_sym_null] = ACTIONS(3543),
    [anon_sym_QMARK] = ACTIONS(3543),
    [anon_sym_COLON_QMARK] = ACTIONS(3543),
    [anon_sym_COLON_COLON] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3543),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3541),
    [anon_sym_LBRACE] = ACTIONS(3543),
    [anon_sym_LT_AT] = ACTIONS(3543),
    [anon_sym_LT_AT_AT] = ACTIONS(3543),
    [anon_sym_DOT] = ACTIONS(3543),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3541),
    [anon_sym_new] = ACTIONS(3543),
    [anon_sym_with] = ACTIONS(3543),
    [anon_sym_return_BANG] = ACTIONS(3541),
    [anon_sym_yield] = ACTIONS(3543),
    [anon_sym_yield_BANG] = ACTIONS(3541),
    [anon_sym_lazy] = ACTIONS(3543),
    [anon_sym_assert] = ACTIONS(3543),
    [anon_sym_upcast] = ACTIONS(3543),
    [anon_sym_downcast] = ACTIONS(3543),
    [anon_sym_COLON_GT] = ACTIONS(3541),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3541),
    [anon_sym_for] = ACTIONS(3543),
    [anon_sym_while] = ACTIONS(3543),
    [anon_sym_if] = ACTIONS(3543),
    [anon_sym_fun] = ACTIONS(3543),
    [anon_sym_DASH_GT] = ACTIONS(3543),
    [anon_sym_try] = ACTIONS(3543),
    [anon_sym_match] = ACTIONS(3543),
    [anon_sym_match_BANG] = ACTIONS(3541),
    [anon_sym_function] = ACTIONS(3543),
    [anon_sym_LT_DASH] = ACTIONS(3543),
    [anon_sym_DOT_LBRACK] = ACTIONS(3541),
    [anon_sym_LT] = ACTIONS(3541),
    [anon_sym_use] = ACTIONS(3543),
    [anon_sym_use_BANG] = ACTIONS(3541),
    [anon_sym_do_BANG] = ACTIONS(3541),
    [anon_sym_begin] = ACTIONS(3543),
    [anon_sym_LPAREN2] = ACTIONS(3543),
    [anon_sym_STAR] = ACTIONS(3543),
    [anon_sym_LT2] = ACTIONS(3543),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_default] = ACTIONS(3543),
    [anon_sym_or] = ACTIONS(3543),
    [anon_sym_static] = ACTIONS(3543),
    [anon_sym_member] = ACTIONS(3543),
    [anon_sym_interface] = ACTIONS(3543),
    [anon_sym_abstract] = ACTIONS(3543),
    [anon_sym_val] = ACTIONS(3543),
    [anon_sym_override] = ACTIONS(3543),
    [anon_sym_inherit] = ACTIONS(3543),
    [aux_sym_char_token1] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3543),
    [anon_sym_DQUOTE] = ACTIONS(3543),
    [anon_sym_AT_DQUOTE] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [sym_bool] = ACTIONS(3543),
    [sym_unit] = ACTIONS(3541),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3543),
    [sym_op_identifier] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(3543),
    [anon_sym_DASH] = ACTIONS(3543),
    [anon_sym_PLUS_DOT] = ACTIONS(3543),
    [anon_sym_DASH_DOT] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3543),
    [anon_sym_AMP_AMP] = ACTIONS(3543),
    [anon_sym_TILDE] = ACTIONS(3541),
    [aux_sym_prefix_op_token1] = ACTIONS(3543),
    [aux_sym_infix_op_token1] = ACTIONS(3541),
    [aux_sym_infix_op_token2] = ACTIONS(3543),
    [anon_sym_PIPE_PIPE] = ACTIONS(3543),
    [anon_sym_BANG_EQ] = ACTIONS(3543),
    [anon_sym_COLON_EQ] = ACTIONS(3541),
    [anon_sym_DOLLAR] = ACTIONS(3543),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3543),
    [sym_int] = ACTIONS(3543),
    [sym_xint] = ACTIONS(3541),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3541),
    [anon_sym_POUNDendif] = ACTIONS(3541),
    [sym__newline] = ACTIONS(3541),
  },
  [1550] = {
    [sym_block_comment] = STATE(1550),
    [sym_compiler_directive_decl] = STATE(1550),
    [sym_fsi_directive_decl] = STATE(1550),
    [sym_preproc_line] = STATE(1550),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_LBRACK_LT] = ACTIONS(3513),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [aux_sym_access_modifier_token1] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_COLON] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_with] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(3513),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_LT_DASH] = ACTIONS(3515),
    [anon_sym_DOT_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_DOT_DOT2] = ACTIONS(3513),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3515),
    [anon_sym_or] = ACTIONS(3515),
    [anon_sym_static] = ACTIONS(3515),
    [anon_sym_member] = ACTIONS(3515),
    [anon_sym_interface] = ACTIONS(3515),
    [anon_sym_abstract] = ACTIONS(3515),
    [anon_sym_val] = ACTIONS(3515),
    [anon_sym_override] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3515),
    [anon_sym_DASH_DOT] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3515),
    [aux_sym_infix_op_token1] = ACTIONS(3513),
    [aux_sym_infix_op_token2] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3515),
    [anon_sym_COLON_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(3515),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3515),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
    [sym__dedent] = ACTIONS(3513),
  },
  [1551] = {
    [sym_block_comment] = STATE(1551),
    [sym_compiler_directive_decl] = STATE(1551),
    [sym_fsi_directive_decl] = STATE(1551),
    [sym_preproc_line] = STATE(1551),
    [sym_identifier] = ACTIONS(3531),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_LBRACK_LT] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(3531),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_do] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [aux_sym_access_modifier_token1] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_null] = ACTIONS(3531),
    [anon_sym_QMARK] = ACTIONS(3531),
    [anon_sym_COLON_QMARK] = ACTIONS(3531),
    [anon_sym_COLON_COLON] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3531),
    [anon_sym_LT_AT] = ACTIONS(3531),
    [anon_sym_LT_AT_AT] = ACTIONS(3531),
    [anon_sym_DOT] = ACTIONS(3531),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3531),
    [anon_sym_with] = ACTIONS(3531),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3531),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3531),
    [anon_sym_assert] = ACTIONS(3531),
    [anon_sym_upcast] = ACTIONS(3531),
    [anon_sym_downcast] = ACTIONS(3531),
    [anon_sym_COLON_GT] = ACTIONS(3529),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3531),
    [anon_sym_while] = ACTIONS(3531),
    [anon_sym_if] = ACTIONS(3531),
    [anon_sym_fun] = ACTIONS(3531),
    [anon_sym_DASH_GT] = ACTIONS(3531),
    [anon_sym_try] = ACTIONS(3531),
    [anon_sym_match] = ACTIONS(3531),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3531),
    [anon_sym_LT_DASH] = ACTIONS(3531),
    [anon_sym_DOT_LBRACK] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_use] = ACTIONS(3531),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3531),
    [anon_sym_LPAREN2] = ACTIONS(3531),
    [anon_sym_DOT_DOT2] = ACTIONS(3529),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LT2] = ACTIONS(3531),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_default] = ACTIONS(3531),
    [anon_sym_or] = ACTIONS(3531),
    [anon_sym_static] = ACTIONS(3531),
    [anon_sym_member] = ACTIONS(3531),
    [anon_sym_interface] = ACTIONS(3531),
    [anon_sym_abstract] = ACTIONS(3531),
    [anon_sym_val] = ACTIONS(3531),
    [anon_sym_override] = ACTIONS(3531),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3531),
    [anon_sym_DQUOTE] = ACTIONS(3531),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3531),
    [sym_unit] = ACTIONS(3529),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3531),
    [sym_op_identifier] = ACTIONS(3531),
    [anon_sym_PLUS] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(3531),
    [anon_sym_PLUS_DOT] = ACTIONS(3531),
    [anon_sym_DASH_DOT] = ACTIONS(3531),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_AMP_AMP] = ACTIONS(3531),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3531),
    [aux_sym_infix_op_token1] = ACTIONS(3529),
    [aux_sym_infix_op_token2] = ACTIONS(3531),
    [anon_sym_PIPE_PIPE] = ACTIONS(3531),
    [anon_sym_BANG_EQ] = ACTIONS(3531),
    [anon_sym_COLON_EQ] = ACTIONS(3529),
    [anon_sym_DOLLAR] = ACTIONS(3531),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3531),
    [sym_int] = ACTIONS(3531),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [sym__newline] = ACTIONS(3529),
    [sym__dedent] = ACTIONS(3529),
  },
  [1552] = {
    [sym_block_comment] = STATE(1552),
    [sym_compiler_directive_decl] = STATE(1552),
    [sym_fsi_directive_decl] = STATE(1552),
    [sym_preproc_line] = STATE(1552),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_and] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [aux_sym_access_modifier_token1] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_member] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_val] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_f] = ACTIONS(3367),
    [aux_sym_decimal_token1] = ACTIONS(3277),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [anon_sym_POUNDendif] = ACTIONS(3191),
    [anon_sym_POUNDelse] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1553] = {
    [sym_block_comment] = STATE(1553),
    [sym_compiler_directive_decl] = STATE(1553),
    [sym_fsi_directive_decl] = STATE(1553),
    [sym_preproc_line] = STATE(1553),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_EQ] = ACTIONS(3646),
    [anon_sym_LBRACK_LT] = ACTIONS(3646),
    [anon_sym_COLON] = ACTIONS(3648),
    [anon_sym_return] = ACTIONS(3648),
    [anon_sym_do] = ACTIONS(3648),
    [anon_sym_let] = ACTIONS(3648),
    [anon_sym_let_BANG] = ACTIONS(3646),
    [aux_sym_access_modifier_token1] = ACTIONS(3646),
    [anon_sym_LPAREN] = ACTIONS(3648),
    [anon_sym_COMMA] = ACTIONS(3646),
    [anon_sym_null] = ACTIONS(3648),
    [anon_sym_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_COLON] = ACTIONS(3646),
    [anon_sym_AMP] = ACTIONS(3648),
    [anon_sym_LBRACK] = ACTIONS(3648),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3646),
    [anon_sym_LBRACE] = ACTIONS(3648),
    [anon_sym_LT_AT] = ACTIONS(3648),
    [anon_sym_LT_AT_AT] = ACTIONS(3648),
    [anon_sym_DOT] = ACTIONS(3648),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3646),
    [anon_sym_new] = ACTIONS(3648),
    [anon_sym_with] = ACTIONS(3648),
    [anon_sym_return_BANG] = ACTIONS(3646),
    [anon_sym_yield] = ACTIONS(3648),
    [anon_sym_yield_BANG] = ACTIONS(3646),
    [anon_sym_lazy] = ACTIONS(3648),
    [anon_sym_assert] = ACTIONS(3648),
    [anon_sym_upcast] = ACTIONS(3648),
    [anon_sym_downcast] = ACTIONS(3648),
    [anon_sym_COLON_GT] = ACTIONS(3646),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3646),
    [anon_sym_for] = ACTIONS(3648),
    [anon_sym_while] = ACTIONS(3648),
    [anon_sym_else] = ACTIONS(3648),
    [anon_sym_elif] = ACTIONS(3648),
    [anon_sym_if] = ACTIONS(3648),
    [anon_sym_fun] = ACTIONS(3648),
    [anon_sym_try] = ACTIONS(3648),
    [anon_sym_match] = ACTIONS(3648),
    [anon_sym_match_BANG] = ACTIONS(3646),
    [anon_sym_function] = ACTIONS(3648),
    [anon_sym_LT_DASH] = ACTIONS(3648),
    [anon_sym_DOT_LBRACK] = ACTIONS(3646),
    [anon_sym_LT] = ACTIONS(3646),
    [anon_sym_use] = ACTIONS(3648),
    [anon_sym_use_BANG] = ACTIONS(3646),
    [anon_sym_do_BANG] = ACTIONS(3646),
    [anon_sym_begin] = ACTIONS(3648),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_default] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3648),
    [anon_sym_static] = ACTIONS(3648),
    [anon_sym_member] = ACTIONS(3648),
    [anon_sym_interface] = ACTIONS(3648),
    [anon_sym_abstract] = ACTIONS(3648),
    [anon_sym_val] = ACTIONS(3648),
    [anon_sym_override] = ACTIONS(3648),
    [anon_sym_inherit] = ACTIONS(3648),
    [aux_sym_char_token1] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3648),
    [anon_sym_AT_DQUOTE] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [sym_bool] = ACTIONS(3648),
    [sym_unit] = ACTIONS(3646),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3648),
    [sym_op_identifier] = ACTIONS(3648),
    [anon_sym_PLUS] = ACTIONS(3648),
    [anon_sym_DASH] = ACTIONS(3648),
    [anon_sym_PLUS_DOT] = ACTIONS(3648),
    [anon_sym_DASH_DOT] = ACTIONS(3648),
    [anon_sym_PERCENT] = ACTIONS(3648),
    [anon_sym_AMP_AMP] = ACTIONS(3648),
    [anon_sym_TILDE] = ACTIONS(3646),
    [aux_sym_prefix_op_token1] = ACTIONS(3648),
    [aux_sym_infix_op_token1] = ACTIONS(3646),
    [aux_sym_infix_op_token2] = ACTIONS(3648),
    [anon_sym_PIPE_PIPE] = ACTIONS(3648),
    [anon_sym_BANG_EQ] = ACTIONS(3648),
    [anon_sym_COLON_EQ] = ACTIONS(3646),
    [anon_sym_DOLLAR] = ACTIONS(3648),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3648),
    [sym_int] = ACTIONS(3648),
    [sym_xint] = ACTIONS(3646),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3646),
    [anon_sym_POUNDendif] = ACTIONS(3646),
    [anon_sym_POUNDelse] = ACTIONS(3646),
    [sym__newline] = ACTIONS(3646),
  },
  [1554] = {
    [sym_block_comment] = STATE(1554),
    [sym_compiler_directive_decl] = STATE(1554),
    [sym_fsi_directive_decl] = STATE(1554),
    [sym_preproc_line] = STATE(1554),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_DASH_GT] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(4293),
    [anon_sym_uy] = ACTIONS(4295),
    [anon_sym_s] = ACTIONS(4297),
    [anon_sym_us] = ACTIONS(4299),
    [anon_sym_l] = ACTIONS(4301),
    [aux_sym_uint32_token1] = ACTIONS(4303),
    [anon_sym_n] = ACTIONS(4305),
    [anon_sym_un] = ACTIONS(4307),
    [anon_sym_L] = ACTIONS(4309),
    [aux_sym_uint64_token1] = ACTIONS(4311),
    [aux_sym_bignum_token1] = ACTIONS(4313),
    [aux_sym_decimal_token1] = ACTIONS(4315),
    [anon_sym_DOT2] = ACTIONS(4317),
    [aux_sym_float_token1] = ACTIONS(4319),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1555] = {
    [sym_block_comment] = STATE(1555),
    [sym_compiler_directive_decl] = STATE(1555),
    [sym_fsi_directive_decl] = STATE(1555),
    [sym_preproc_line] = STATE(1555),
    [aux_sym_rules_repeat1] = STATE(1571),
    [sym_identifier] = ACTIONS(3676),
    [anon_sym_EQ] = ACTIONS(3674),
    [anon_sym_LBRACK_LT] = ACTIONS(3674),
    [anon_sym_COLON] = ACTIONS(3676),
    [anon_sym_return] = ACTIONS(3676),
    [anon_sym_do] = ACTIONS(3676),
    [anon_sym_and] = ACTIONS(3676),
    [anon_sym_let] = ACTIONS(3676),
    [anon_sym_let_BANG] = ACTIONS(3674),
    [aux_sym_access_modifier_token1] = ACTIONS(3674),
    [anon_sym_LPAREN] = ACTIONS(3676),
    [anon_sym_COMMA] = ACTIONS(3674),
    [anon_sym_null] = ACTIONS(3676),
    [anon_sym_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_COLON] = ACTIONS(3674),
    [anon_sym_PIPE] = ACTIONS(4344),
    [anon_sym_AMP] = ACTIONS(3676),
    [anon_sym_LBRACK] = ACTIONS(3676),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3674),
    [anon_sym_LBRACE] = ACTIONS(3676),
    [anon_sym_LT_AT] = ACTIONS(3676),
    [anon_sym_LT_AT_AT] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3674),
    [anon_sym_new] = ACTIONS(3676),
    [anon_sym_with] = ACTIONS(3676),
    [anon_sym_return_BANG] = ACTIONS(3674),
    [anon_sym_yield] = ACTIONS(3676),
    [anon_sym_yield_BANG] = ACTIONS(3674),
    [anon_sym_lazy] = ACTIONS(3676),
    [anon_sym_assert] = ACTIONS(3676),
    [anon_sym_upcast] = ACTIONS(3676),
    [anon_sym_downcast] = ACTIONS(3676),
    [anon_sym_COLON_GT] = ACTIONS(3674),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3674),
    [anon_sym_for] = ACTIONS(3676),
    [anon_sym_while] = ACTIONS(3676),
    [anon_sym_if] = ACTIONS(3676),
    [anon_sym_fun] = ACTIONS(3676),
    [anon_sym_try] = ACTIONS(3676),
    [anon_sym_match] = ACTIONS(3676),
    [anon_sym_match_BANG] = ACTIONS(3674),
    [anon_sym_function] = ACTIONS(3676),
    [anon_sym_LT_DASH] = ACTIONS(3676),
    [anon_sym_DOT_LBRACK] = ACTIONS(3674),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_use] = ACTIONS(3676),
    [anon_sym_use_BANG] = ACTIONS(3674),
    [anon_sym_do_BANG] = ACTIONS(3674),
    [anon_sym_begin] = ACTIONS(3676),
    [anon_sym_LPAREN2] = ACTIONS(3676),
    [anon_sym_default] = ACTIONS(3676),
    [anon_sym_or] = ACTIONS(3676),
    [anon_sym_static] = ACTIONS(3676),
    [anon_sym_member] = ACTIONS(3676),
    [anon_sym_interface] = ACTIONS(3676),
    [anon_sym_abstract] = ACTIONS(3676),
    [anon_sym_val] = ACTIONS(3676),
    [anon_sym_override] = ACTIONS(3676),
    [aux_sym_char_token1] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3676),
    [anon_sym_DQUOTE] = ACTIONS(3676),
    [anon_sym_AT_DQUOTE] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [sym_bool] = ACTIONS(3676),
    [sym_unit] = ACTIONS(3674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3676),
    [sym_op_identifier] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_PLUS_DOT] = ACTIONS(3676),
    [anon_sym_DASH_DOT] = ACTIONS(3676),
    [anon_sym_PERCENT] = ACTIONS(3676),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_TILDE] = ACTIONS(3674),
    [aux_sym_prefix_op_token1] = ACTIONS(3676),
    [aux_sym_infix_op_token1] = ACTIONS(3674),
    [aux_sym_infix_op_token2] = ACTIONS(3676),
    [anon_sym_PIPE_PIPE] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3676),
    [anon_sym_COLON_EQ] = ACTIONS(3674),
    [anon_sym_DOLLAR] = ACTIONS(3676),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3676),
    [sym_int] = ACTIONS(3676),
    [sym_xint] = ACTIONS(3674),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3674),
    [anon_sym_POUNDendif] = ACTIONS(3674),
    [anon_sym_POUNDelse] = ACTIONS(3674),
    [sym__newline] = ACTIONS(4346),
  },
  [1556] = {
    [sym_block_comment] = STATE(1556),
    [sym_compiler_directive_decl] = STATE(1556),
    [sym_fsi_directive_decl] = STATE(1556),
    [sym_preproc_line] = STATE(1556),
    [aux_sym_rules_repeat1] = STATE(1567),
    [sym_identifier] = ACTIONS(3676),
    [anon_sym_EQ] = ACTIONS(3674),
    [anon_sym_LBRACK_LT] = ACTIONS(3674),
    [anon_sym_COLON] = ACTIONS(3676),
    [anon_sym_return] = ACTIONS(3676),
    [anon_sym_do] = ACTIONS(3676),
    [anon_sym_let] = ACTIONS(3676),
    [anon_sym_let_BANG] = ACTIONS(3674),
    [aux_sym_access_modifier_token1] = ACTIONS(3674),
    [anon_sym_LPAREN] = ACTIONS(3676),
    [anon_sym_COMMA] = ACTIONS(3674),
    [anon_sym_null] = ACTIONS(3676),
    [anon_sym_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_COLON] = ACTIONS(3674),
    [anon_sym_PIPE] = ACTIONS(4349),
    [anon_sym_AMP] = ACTIONS(3676),
    [anon_sym_LBRACK] = ACTIONS(3676),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3674),
    [anon_sym_LBRACE] = ACTIONS(3676),
    [anon_sym_LT_AT] = ACTIONS(3676),
    [anon_sym_LT_AT_AT] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3674),
    [anon_sym_new] = ACTIONS(3676),
    [anon_sym_with] = ACTIONS(3676),
    [anon_sym_return_BANG] = ACTIONS(3674),
    [anon_sym_yield] = ACTIONS(3676),
    [anon_sym_yield_BANG] = ACTIONS(3674),
    [anon_sym_lazy] = ACTIONS(3676),
    [anon_sym_assert] = ACTIONS(3676),
    [anon_sym_upcast] = ACTIONS(3676),
    [anon_sym_downcast] = ACTIONS(3676),
    [anon_sym_COLON_GT] = ACTIONS(3674),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3674),
    [anon_sym_for] = ACTIONS(3676),
    [anon_sym_while] = ACTIONS(3676),
    [anon_sym_if] = ACTIONS(3676),
    [anon_sym_fun] = ACTIONS(3676),
    [anon_sym_try] = ACTIONS(3676),
    [anon_sym_match] = ACTIONS(3676),
    [anon_sym_match_BANG] = ACTIONS(3674),
    [anon_sym_function] = ACTIONS(3676),
    [anon_sym_LT_DASH] = ACTIONS(3676),
    [anon_sym_DOT_LBRACK] = ACTIONS(3674),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_use] = ACTIONS(3676),
    [anon_sym_use_BANG] = ACTIONS(3674),
    [anon_sym_do_BANG] = ACTIONS(3674),
    [anon_sym_begin] = ACTIONS(3676),
    [anon_sym_LPAREN2] = ACTIONS(3676),
    [anon_sym_default] = ACTIONS(3676),
    [anon_sym_or] = ACTIONS(3676),
    [anon_sym_static] = ACTIONS(3676),
    [anon_sym_member] = ACTIONS(3676),
    [anon_sym_interface] = ACTIONS(3676),
    [anon_sym_abstract] = ACTIONS(3676),
    [anon_sym_val] = ACTIONS(3676),
    [anon_sym_override] = ACTIONS(3676),
    [anon_sym_inherit] = ACTIONS(3676),
    [aux_sym_char_token1] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3676),
    [anon_sym_DQUOTE] = ACTIONS(3676),
    [anon_sym_AT_DQUOTE] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [sym_bool] = ACTIONS(3676),
    [sym_unit] = ACTIONS(3674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3676),
    [sym_op_identifier] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_PLUS_DOT] = ACTIONS(3676),
    [anon_sym_DASH_DOT] = ACTIONS(3676),
    [anon_sym_PERCENT] = ACTIONS(3676),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_TILDE] = ACTIONS(3674),
    [aux_sym_prefix_op_token1] = ACTIONS(3676),
    [aux_sym_infix_op_token1] = ACTIONS(3674),
    [aux_sym_infix_op_token2] = ACTIONS(3676),
    [anon_sym_PIPE_PIPE] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3676),
    [anon_sym_COLON_EQ] = ACTIONS(3674),
    [anon_sym_DOLLAR] = ACTIONS(3676),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3676),
    [sym_int] = ACTIONS(3676),
    [sym_xint] = ACTIONS(3674),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3674),
    [anon_sym_POUNDendif] = ACTIONS(3674),
    [anon_sym_POUNDelse] = ACTIONS(3674),
    [sym__newline] = ACTIONS(4351),
  },
  [1557] = {
    [sym_block_comment] = STATE(1557),
    [sym_compiler_directive_decl] = STATE(1557),
    [sym_fsi_directive_decl] = STATE(1557),
    [sym_preproc_line] = STATE(1557),
    [sym_identifier] = ACTIONS(3732),
    [anon_sym_EQ] = ACTIONS(3730),
    [anon_sym_LBRACK_LT] = ACTIONS(3730),
    [anon_sym_COLON] = ACTIONS(3732),
    [anon_sym_return] = ACTIONS(3732),
    [anon_sym_do] = ACTIONS(3732),
    [anon_sym_let] = ACTIONS(3732),
    [anon_sym_let_BANG] = ACTIONS(3730),
    [aux_sym_access_modifier_token1] = ACTIONS(3730),
    [anon_sym_LPAREN] = ACTIONS(3732),
    [anon_sym_COMMA] = ACTIONS(3730),
    [anon_sym_null] = ACTIONS(3732),
    [anon_sym_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_LBRACK] = ACTIONS(3732),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3730),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_LT_AT] = ACTIONS(3732),
    [anon_sym_LT_AT_AT] = ACTIONS(3732),
    [anon_sym_DOT] = ACTIONS(3732),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3730),
    [anon_sym_new] = ACTIONS(3732),
    [anon_sym_with] = ACTIONS(3732),
    [anon_sym_return_BANG] = ACTIONS(3730),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_yield_BANG] = ACTIONS(3730),
    [anon_sym_lazy] = ACTIONS(3732),
    [anon_sym_assert] = ACTIONS(3732),
    [anon_sym_upcast] = ACTIONS(3732),
    [anon_sym_downcast] = ACTIONS(3732),
    [anon_sym_COLON_GT] = ACTIONS(3730),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3730),
    [anon_sym_for] = ACTIONS(3732),
    [anon_sym_while] = ACTIONS(3732),
    [anon_sym_else] = ACTIONS(3732),
    [anon_sym_elif] = ACTIONS(3732),
    [anon_sym_if] = ACTIONS(3732),
    [anon_sym_fun] = ACTIONS(3732),
    [anon_sym_try] = ACTIONS(3732),
    [anon_sym_match] = ACTIONS(3732),
    [anon_sym_match_BANG] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3732),
    [anon_sym_LT_DASH] = ACTIONS(3732),
    [anon_sym_DOT_LBRACK] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3730),
    [anon_sym_use] = ACTIONS(3732),
    [anon_sym_use_BANG] = ACTIONS(3730),
    [anon_sym_do_BANG] = ACTIONS(3730),
    [anon_sym_begin] = ACTIONS(3732),
    [anon_sym_LPAREN2] = ACTIONS(3732),
    [anon_sym_default] = ACTIONS(3732),
    [anon_sym_or] = ACTIONS(3732),
    [anon_sym_static] = ACTIONS(3732),
    [anon_sym_member] = ACTIONS(3732),
    [anon_sym_interface] = ACTIONS(3732),
    [anon_sym_abstract] = ACTIONS(3732),
    [anon_sym_val] = ACTIONS(3732),
    [anon_sym_override] = ACTIONS(3732),
    [anon_sym_inherit] = ACTIONS(3732),
    [aux_sym_char_token1] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3732),
    [anon_sym_DQUOTE] = ACTIONS(3732),
    [anon_sym_AT_DQUOTE] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [sym_bool] = ACTIONS(3732),
    [sym_unit] = ACTIONS(3730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3732),
    [sym_op_identifier] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PLUS_DOT] = ACTIONS(3732),
    [anon_sym_DASH_DOT] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3732),
    [anon_sym_AMP_AMP] = ACTIONS(3732),
    [anon_sym_TILDE] = ACTIONS(3730),
    [aux_sym_prefix_op_token1] = ACTIONS(3732),
    [aux_sym_infix_op_token1] = ACTIONS(3730),
    [aux_sym_infix_op_token2] = ACTIONS(3732),
    [anon_sym_PIPE_PIPE] = ACTIONS(3732),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_COLON_EQ] = ACTIONS(3730),
    [anon_sym_DOLLAR] = ACTIONS(3732),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3732),
    [sym_int] = ACTIONS(3732),
    [sym_xint] = ACTIONS(3730),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3730),
    [anon_sym_POUNDendif] = ACTIONS(3730),
    [anon_sym_POUNDelse] = ACTIONS(3730),
    [sym__newline] = ACTIONS(3730),
  },
  [1558] = {
    [sym_block_comment] = STATE(1558),
    [sym_compiler_directive_decl] = STATE(1558),
    [sym_fsi_directive_decl] = STATE(1558),
    [sym_preproc_line] = STATE(1558),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_EQ] = ACTIONS(3646),
    [anon_sym_LBRACK_LT] = ACTIONS(3646),
    [anon_sym_COLON] = ACTIONS(3648),
    [anon_sym_return] = ACTIONS(3648),
    [anon_sym_do] = ACTIONS(3648),
    [anon_sym_and] = ACTIONS(3648),
    [anon_sym_let] = ACTIONS(3648),
    [anon_sym_let_BANG] = ACTIONS(3646),
    [aux_sym_access_modifier_token1] = ACTIONS(3646),
    [anon_sym_LPAREN] = ACTIONS(3648),
    [anon_sym_COMMA] = ACTIONS(3646),
    [anon_sym_null] = ACTIONS(3648),
    [anon_sym_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_COLON] = ACTIONS(3646),
    [anon_sym_AMP] = ACTIONS(3648),
    [anon_sym_LBRACK] = ACTIONS(3648),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3646),
    [anon_sym_LBRACE] = ACTIONS(3648),
    [anon_sym_LT_AT] = ACTIONS(3648),
    [anon_sym_LT_AT_AT] = ACTIONS(3648),
    [anon_sym_DOT] = ACTIONS(3648),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3646),
    [anon_sym_new] = ACTIONS(3648),
    [anon_sym_with] = ACTIONS(3648),
    [anon_sym_return_BANG] = ACTIONS(3646),
    [anon_sym_yield] = ACTIONS(3648),
    [anon_sym_yield_BANG] = ACTIONS(3646),
    [anon_sym_lazy] = ACTIONS(3648),
    [anon_sym_assert] = ACTIONS(3648),
    [anon_sym_upcast] = ACTIONS(3648),
    [anon_sym_downcast] = ACTIONS(3648),
    [anon_sym_COLON_GT] = ACTIONS(3646),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3646),
    [anon_sym_for] = ACTIONS(3648),
    [anon_sym_while] = ACTIONS(3648),
    [anon_sym_else] = ACTIONS(3648),
    [anon_sym_elif] = ACTIONS(3648),
    [anon_sym_if] = ACTIONS(3648),
    [anon_sym_fun] = ACTIONS(3648),
    [anon_sym_try] = ACTIONS(3648),
    [anon_sym_match] = ACTIONS(3648),
    [anon_sym_match_BANG] = ACTIONS(3646),
    [anon_sym_function] = ACTIONS(3648),
    [anon_sym_LT_DASH] = ACTIONS(3648),
    [anon_sym_DOT_LBRACK] = ACTIONS(3646),
    [anon_sym_LT] = ACTIONS(3646),
    [anon_sym_use] = ACTIONS(3648),
    [anon_sym_use_BANG] = ACTIONS(3646),
    [anon_sym_do_BANG] = ACTIONS(3646),
    [anon_sym_begin] = ACTIONS(3648),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_default] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3648),
    [anon_sym_static] = ACTIONS(3648),
    [anon_sym_member] = ACTIONS(3648),
    [anon_sym_interface] = ACTIONS(3648),
    [anon_sym_abstract] = ACTIONS(3648),
    [anon_sym_val] = ACTIONS(3648),
    [anon_sym_override] = ACTIONS(3648),
    [aux_sym_char_token1] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3648),
    [anon_sym_AT_DQUOTE] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [sym_bool] = ACTIONS(3648),
    [sym_unit] = ACTIONS(3646),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3648),
    [sym_op_identifier] = ACTIONS(3648),
    [anon_sym_PLUS] = ACTIONS(3648),
    [anon_sym_DASH] = ACTIONS(3648),
    [anon_sym_PLUS_DOT] = ACTIONS(3648),
    [anon_sym_DASH_DOT] = ACTIONS(3648),
    [anon_sym_PERCENT] = ACTIONS(3648),
    [anon_sym_AMP_AMP] = ACTIONS(3648),
    [anon_sym_TILDE] = ACTIONS(3646),
    [aux_sym_prefix_op_token1] = ACTIONS(3648),
    [aux_sym_infix_op_token1] = ACTIONS(3646),
    [aux_sym_infix_op_token2] = ACTIONS(3648),
    [anon_sym_PIPE_PIPE] = ACTIONS(3648),
    [anon_sym_BANG_EQ] = ACTIONS(3648),
    [anon_sym_COLON_EQ] = ACTIONS(3646),
    [anon_sym_DOLLAR] = ACTIONS(3648),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3648),
    [sym_int] = ACTIONS(3648),
    [sym_xint] = ACTIONS(3646),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3646),
    [anon_sym_POUNDendif] = ACTIONS(3646),
    [anon_sym_POUNDelse] = ACTIONS(3646),
    [sym__newline] = ACTIONS(3646),
  },
  [1559] = {
    [sym_block_comment] = STATE(1559),
    [sym_compiler_directive_decl] = STATE(1559),
    [sym_fsi_directive_decl] = STATE(1559),
    [sym_preproc_line] = STATE(1559),
    [aux_sym_rules_repeat1] = STATE(1567),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_LBRACK_LT] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [aux_sym_access_modifier_token1] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(4349),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_with] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_default] = ACTIONS(3693),
    [anon_sym_or] = ACTIONS(3693),
    [anon_sym_static] = ACTIONS(3693),
    [anon_sym_member] = ACTIONS(3693),
    [anon_sym_interface] = ACTIONS(3693),
    [anon_sym_abstract] = ACTIONS(3693),
    [anon_sym_val] = ACTIONS(3693),
    [anon_sym_override] = ACTIONS(3693),
    [anon_sym_inherit] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [anon_sym_POUNDendif] = ACTIONS(3691),
    [anon_sym_POUNDelse] = ACTIONS(3691),
    [sym__newline] = ACTIONS(4354),
  },
  [1560] = {
    [sym_block_comment] = STATE(1560),
    [sym_compiler_directive_decl] = STATE(1560),
    [sym_fsi_directive_decl] = STATE(1560),
    [sym_preproc_line] = STATE(1560),
    [aux_sym_rules_repeat1] = STATE(1559),
    [sym_identifier] = ACTIONS(3736),
    [anon_sym_EQ] = ACTIONS(3734),
    [anon_sym_LBRACK_LT] = ACTIONS(3734),
    [anon_sym_COLON] = ACTIONS(3736),
    [anon_sym_return] = ACTIONS(3736),
    [anon_sym_do] = ACTIONS(3736),
    [anon_sym_let] = ACTIONS(3736),
    [anon_sym_let_BANG] = ACTIONS(3734),
    [aux_sym_access_modifier_token1] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3736),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_null] = ACTIONS(3736),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_COLON] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(4349),
    [anon_sym_AMP] = ACTIONS(3736),
    [anon_sym_LBRACK] = ACTIONS(3736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3734),
    [anon_sym_LBRACE] = ACTIONS(3736),
    [anon_sym_LT_AT] = ACTIONS(3736),
    [anon_sym_LT_AT_AT] = ACTIONS(3736),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3734),
    [anon_sym_new] = ACTIONS(3736),
    [anon_sym_with] = ACTIONS(3736),
    [anon_sym_return_BANG] = ACTIONS(3734),
    [anon_sym_yield] = ACTIONS(3736),
    [anon_sym_yield_BANG] = ACTIONS(3734),
    [anon_sym_lazy] = ACTIONS(3736),
    [anon_sym_assert] = ACTIONS(3736),
    [anon_sym_upcast] = ACTIONS(3736),
    [anon_sym_downcast] = ACTIONS(3736),
    [anon_sym_COLON_GT] = ACTIONS(3734),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3734),
    [anon_sym_for] = ACTIONS(3736),
    [anon_sym_while] = ACTIONS(3736),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_fun] = ACTIONS(3736),
    [anon_sym_try] = ACTIONS(3736),
    [anon_sym_match] = ACTIONS(3736),
    [anon_sym_match_BANG] = ACTIONS(3734),
    [anon_sym_function] = ACTIONS(3736),
    [anon_sym_LT_DASH] = ACTIONS(3736),
    [anon_sym_DOT_LBRACK] = ACTIONS(3734),
    [anon_sym_LT] = ACTIONS(3734),
    [anon_sym_use] = ACTIONS(3736),
    [anon_sym_use_BANG] = ACTIONS(3734),
    [anon_sym_do_BANG] = ACTIONS(3734),
    [anon_sym_begin] = ACTIONS(3736),
    [anon_sym_LPAREN2] = ACTIONS(3736),
    [anon_sym_default] = ACTIONS(3736),
    [anon_sym_or] = ACTIONS(3736),
    [anon_sym_static] = ACTIONS(3736),
    [anon_sym_member] = ACTIONS(3736),
    [anon_sym_interface] = ACTIONS(3736),
    [anon_sym_abstract] = ACTIONS(3736),
    [anon_sym_val] = ACTIONS(3736),
    [anon_sym_override] = ACTIONS(3736),
    [anon_sym_inherit] = ACTIONS(3736),
    [aux_sym_char_token1] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3736),
    [anon_sym_DQUOTE] = ACTIONS(3736),
    [anon_sym_AT_DQUOTE] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [sym_bool] = ACTIONS(3736),
    [sym_unit] = ACTIONS(3734),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3736),
    [sym_op_identifier] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS_DOT] = ACTIONS(3736),
    [anon_sym_DASH_DOT] = ACTIONS(3736),
    [anon_sym_PERCENT] = ACTIONS(3736),
    [anon_sym_AMP_AMP] = ACTIONS(3736),
    [anon_sym_TILDE] = ACTIONS(3734),
    [aux_sym_prefix_op_token1] = ACTIONS(3736),
    [aux_sym_infix_op_token1] = ACTIONS(3734),
    [aux_sym_infix_op_token2] = ACTIONS(3736),
    [anon_sym_PIPE_PIPE] = ACTIONS(3736),
    [anon_sym_BANG_EQ] = ACTIONS(3736),
    [anon_sym_COLON_EQ] = ACTIONS(3734),
    [anon_sym_DOLLAR] = ACTIONS(3736),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3736),
    [sym_int] = ACTIONS(3736),
    [sym_xint] = ACTIONS(3734),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3734),
    [anon_sym_POUNDendif] = ACTIONS(3734),
    [anon_sym_POUNDelse] = ACTIONS(3734),
    [sym__newline] = ACTIONS(4357),
  },
  [1561] = {
    [sym_block_comment] = STATE(1561),
    [sym_compiler_directive_decl] = STATE(1561),
    [sym_fsi_directive_decl] = STATE(1561),
    [sym_preproc_line] = STATE(1561),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_LBRACK_LT] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [aux_sym_access_modifier_token1] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_with] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_default] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [anon_sym_static] = ACTIONS(3604),
    [anon_sym_member] = ACTIONS(3604),
    [anon_sym_interface] = ACTIONS(3604),
    [anon_sym_abstract] = ACTIONS(3604),
    [anon_sym_val] = ACTIONS(3604),
    [anon_sym_override] = ACTIONS(3604),
    [anon_sym_inherit] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [aux_sym_float_token1] = ACTIONS(4360),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [anon_sym_POUNDendif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
  },
  [1562] = {
    [sym_block_comment] = STATE(1562),
    [sym_compiler_directive_decl] = STATE(1562),
    [sym_fsi_directive_decl] = STATE(1562),
    [sym_preproc_line] = STATE(1562),
    [sym_identifier] = ACTIONS(3753),
    [anon_sym_EQ] = ACTIONS(3751),
    [anon_sym_LBRACK_LT] = ACTIONS(3751),
    [anon_sym_COLON] = ACTIONS(3753),
    [anon_sym_return] = ACTIONS(3753),
    [anon_sym_do] = ACTIONS(3753),
    [anon_sym_and] = ACTIONS(3753),
    [anon_sym_let] = ACTIONS(3753),
    [anon_sym_let_BANG] = ACTIONS(3751),
    [aux_sym_access_modifier_token1] = ACTIONS(3751),
    [anon_sym_LPAREN] = ACTIONS(3753),
    [anon_sym_COMMA] = ACTIONS(3751),
    [anon_sym_null] = ACTIONS(3753),
    [anon_sym_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_COLON] = ACTIONS(3751),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3751),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_LT_AT] = ACTIONS(3753),
    [anon_sym_LT_AT_AT] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3753),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3751),
    [anon_sym_new] = ACTIONS(3753),
    [anon_sym_with] = ACTIONS(3753),
    [anon_sym_return_BANG] = ACTIONS(3751),
    [anon_sym_yield] = ACTIONS(3753),
    [anon_sym_yield_BANG] = ACTIONS(3751),
    [anon_sym_lazy] = ACTIONS(3753),
    [anon_sym_assert] = ACTIONS(3753),
    [anon_sym_upcast] = ACTIONS(3753),
    [anon_sym_downcast] = ACTIONS(3753),
    [anon_sym_COLON_GT] = ACTIONS(3751),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3751),
    [anon_sym_for] = ACTIONS(3753),
    [anon_sym_while] = ACTIONS(3753),
    [anon_sym_if] = ACTIONS(3753),
    [anon_sym_fun] = ACTIONS(3753),
    [anon_sym_try] = ACTIONS(3753),
    [anon_sym_match] = ACTIONS(3753),
    [anon_sym_match_BANG] = ACTIONS(3751),
    [anon_sym_function] = ACTIONS(3753),
    [anon_sym_LT_DASH] = ACTIONS(3753),
    [anon_sym_DOT_LBRACK] = ACTIONS(3751),
    [anon_sym_LT] = ACTIONS(3751),
    [anon_sym_use] = ACTIONS(3753),
    [anon_sym_use_BANG] = ACTIONS(3751),
    [anon_sym_do_BANG] = ACTIONS(3751),
    [anon_sym_begin] = ACTIONS(3753),
    [anon_sym_LPAREN2] = ACTIONS(3753),
    [anon_sym_default] = ACTIONS(3753),
    [anon_sym_or] = ACTIONS(3753),
    [anon_sym_static] = ACTIONS(3753),
    [anon_sym_member] = ACTIONS(3753),
    [anon_sym_interface] = ACTIONS(3753),
    [anon_sym_abstract] = ACTIONS(3753),
    [anon_sym_val] = ACTIONS(3753),
    [anon_sym_override] = ACTIONS(3753),
    [aux_sym_char_token1] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3753),
    [anon_sym_AT_DQUOTE] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [sym_bool] = ACTIONS(3753),
    [sym_unit] = ACTIONS(3751),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3753),
    [sym_op_identifier] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PLUS_DOT] = ACTIONS(3753),
    [anon_sym_DASH_DOT] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3753),
    [anon_sym_AMP_AMP] = ACTIONS(3753),
    [anon_sym_TILDE] = ACTIONS(3751),
    [aux_sym_prefix_op_token1] = ACTIONS(3753),
    [aux_sym_infix_op_token1] = ACTIONS(3751),
    [aux_sym_infix_op_token2] = ACTIONS(3753),
    [anon_sym_PIPE_PIPE] = ACTIONS(3753),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_COLON_EQ] = ACTIONS(3751),
    [anon_sym_DOLLAR] = ACTIONS(3753),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3753),
    [sym_int] = ACTIONS(4362),
    [sym_xint] = ACTIONS(3751),
    [anon_sym_f] = ACTIONS(3753),
    [aux_sym_decimal_token1] = ACTIONS(3753),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3751),
    [anon_sym_POUNDendif] = ACTIONS(3751),
    [anon_sym_POUNDelse] = ACTIONS(3751),
    [sym__newline] = ACTIONS(3751),
  },
  [1563] = {
    [sym_block_comment] = STATE(1563),
    [sym_compiler_directive_decl] = STATE(1563),
    [sym_fsi_directive_decl] = STATE(1563),
    [sym_preproc_line] = STATE(1563),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_LBRACK_LT] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_and] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [aux_sym_access_modifier_token1] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_else] = ACTIONS(3700),
    [anon_sym_elif] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_default] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [anon_sym_static] = ACTIONS(3700),
    [anon_sym_member] = ACTIONS(3700),
    [anon_sym_interface] = ACTIONS(3700),
    [anon_sym_abstract] = ACTIONS(3700),
    [anon_sym_val] = ACTIONS(3700),
    [anon_sym_override] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [anon_sym_POUNDendif] = ACTIONS(3698),
    [anon_sym_POUNDelse] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [1564] = {
    [sym_block_comment] = STATE(1564),
    [sym_compiler_directive_decl] = STATE(1564),
    [sym_fsi_directive_decl] = STATE(1564),
    [sym_preproc_line] = STATE(1564),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_AT_GT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(4364),
    [anon_sym_uy] = ACTIONS(4366),
    [anon_sym_s] = ACTIONS(4368),
    [anon_sym_us] = ACTIONS(4370),
    [anon_sym_l] = ACTIONS(4372),
    [aux_sym_uint32_token1] = ACTIONS(4374),
    [anon_sym_n] = ACTIONS(4376),
    [anon_sym_un] = ACTIONS(4378),
    [anon_sym_L] = ACTIONS(4380),
    [aux_sym_uint64_token1] = ACTIONS(4382),
    [aux_sym_bignum_token1] = ACTIONS(4384),
    [aux_sym_decimal_token1] = ACTIONS(4386),
    [anon_sym_DOT2] = ACTIONS(4388),
    [aux_sym_float_token1] = ACTIONS(4390),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1565] = {
    [sym_block_comment] = STATE(1565),
    [sym_compiler_directive_decl] = STATE(1565),
    [sym_fsi_directive_decl] = STATE(1565),
    [sym_preproc_line] = STATE(1565),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_LBRACK_LT] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_and] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [aux_sym_access_modifier_token1] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_with] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_default] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [anon_sym_static] = ACTIONS(3604),
    [anon_sym_member] = ACTIONS(3604),
    [anon_sym_interface] = ACTIONS(3604),
    [anon_sym_abstract] = ACTIONS(3604),
    [anon_sym_val] = ACTIONS(3604),
    [anon_sym_override] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [aux_sym_float_token1] = ACTIONS(4392),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [anon_sym_POUNDendif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
  },
  [1566] = {
    [sym_block_comment] = STATE(1566),
    [sym_compiler_directive_decl] = STATE(1566),
    [sym_fsi_directive_decl] = STATE(1566),
    [sym_preproc_line] = STATE(1566),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_LBRACK_LT] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_and] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [aux_sym_access_modifier_token1] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_with] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(4394),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_DOT_DOT] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_default] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [anon_sym_static] = ACTIONS(3685),
    [anon_sym_member] = ACTIONS(3685),
    [anon_sym_interface] = ACTIONS(3685),
    [anon_sym_abstract] = ACTIONS(3685),
    [anon_sym_val] = ACTIONS(3685),
    [anon_sym_override] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [anon_sym_POUNDendif] = ACTIONS(3683),
    [anon_sym_POUNDelse] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
  },
  [1567] = {
    [sym_block_comment] = STATE(1567),
    [sym_compiler_directive_decl] = STATE(1567),
    [sym_fsi_directive_decl] = STATE(1567),
    [sym_preproc_line] = STATE(1567),
    [aux_sym_rules_repeat1] = STATE(1567),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_LBRACK_LT] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [aux_sym_access_modifier_token1] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(4396),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_with] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_default] = ACTIONS(3743),
    [anon_sym_or] = ACTIONS(3743),
    [anon_sym_static] = ACTIONS(3743),
    [anon_sym_member] = ACTIONS(3743),
    [anon_sym_interface] = ACTIONS(3743),
    [anon_sym_abstract] = ACTIONS(3743),
    [anon_sym_val] = ACTIONS(3743),
    [anon_sym_override] = ACTIONS(3743),
    [anon_sym_inherit] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [anon_sym_POUNDendif] = ACTIONS(3741),
    [anon_sym_POUNDelse] = ACTIONS(3741),
    [sym__newline] = ACTIONS(4399),
  },
  [1568] = {
    [sym_block_comment] = STATE(1568),
    [sym_compiler_directive_decl] = STATE(1568),
    [sym_fsi_directive_decl] = STATE(1568),
    [sym_preproc_line] = STATE(1568),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [aux_sym_access_modifier_token1] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_member] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_val] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [anon_sym_inherit] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_f] = ACTIONS(3371),
    [aux_sym_decimal_token1] = ACTIONS(3249),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [anon_sym_POUNDendif] = ACTIONS(3191),
    [anon_sym_POUNDelse] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1569] = {
    [sym_block_comment] = STATE(1569),
    [sym_compiler_directive_decl] = STATE(1569),
    [sym_fsi_directive_decl] = STATE(1569),
    [sym_preproc_line] = STATE(1569),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_LBRACK_LT] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_and] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [aux_sym_access_modifier_token1] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_with] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_default] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [anon_sym_static] = ACTIONS(3604),
    [anon_sym_member] = ACTIONS(3604),
    [anon_sym_interface] = ACTIONS(3604),
    [anon_sym_abstract] = ACTIONS(3604),
    [anon_sym_val] = ACTIONS(3604),
    [anon_sym_override] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [anon_sym_POUNDendif] = ACTIONS(3602),
    [anon_sym_POUNDelse] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
  },
  [1570] = {
    [sym_block_comment] = STATE(1570),
    [sym_compiler_directive_decl] = STATE(1570),
    [sym_fsi_directive_decl] = STATE(1570),
    [sym_preproc_line] = STATE(1570),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_LBRACK_LT] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [aux_sym_access_modifier_token1] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_with] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(4402),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_DOT_DOT] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_default] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [anon_sym_static] = ACTIONS(3685),
    [anon_sym_member] = ACTIONS(3685),
    [anon_sym_interface] = ACTIONS(3685),
    [anon_sym_abstract] = ACTIONS(3685),
    [anon_sym_val] = ACTIONS(3685),
    [anon_sym_override] = ACTIONS(3685),
    [anon_sym_inherit] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [anon_sym_POUNDendif] = ACTIONS(3683),
    [anon_sym_POUNDelse] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
  },
  [1571] = {
    [sym_block_comment] = STATE(1571),
    [sym_compiler_directive_decl] = STATE(1571),
    [sym_fsi_directive_decl] = STATE(1571),
    [sym_preproc_line] = STATE(1571),
    [aux_sym_rules_repeat1] = STATE(1571),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_LBRACK_LT] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_and] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [aux_sym_access_modifier_token1] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(4404),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_with] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_default] = ACTIONS(3743),
    [anon_sym_or] = ACTIONS(3743),
    [anon_sym_static] = ACTIONS(3743),
    [anon_sym_member] = ACTIONS(3743),
    [anon_sym_interface] = ACTIONS(3743),
    [anon_sym_abstract] = ACTIONS(3743),
    [anon_sym_val] = ACTIONS(3743),
    [anon_sym_override] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [anon_sym_POUNDendif] = ACTIONS(3741),
    [anon_sym_POUNDelse] = ACTIONS(3741),
    [sym__newline] = ACTIONS(4407),
  },
  [1572] = {
    [sym_block_comment] = STATE(1572),
    [sym_compiler_directive_decl] = STATE(1572),
    [sym_fsi_directive_decl] = STATE(1572),
    [sym_preproc_line] = STATE(1572),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_AT_AT_GT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(4410),
    [anon_sym_uy] = ACTIONS(4412),
    [anon_sym_s] = ACTIONS(4414),
    [anon_sym_us] = ACTIONS(4416),
    [anon_sym_l] = ACTIONS(4418),
    [aux_sym_uint32_token1] = ACTIONS(4420),
    [anon_sym_n] = ACTIONS(4422),
    [anon_sym_un] = ACTIONS(4424),
    [anon_sym_L] = ACTIONS(4426),
    [aux_sym_uint64_token1] = ACTIONS(4428),
    [aux_sym_bignum_token1] = ACTIONS(4430),
    [aux_sym_decimal_token1] = ACTIONS(4432),
    [anon_sym_DOT2] = ACTIONS(4434),
    [aux_sym_float_token1] = ACTIONS(4436),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1573] = {
    [sym_block_comment] = STATE(1573),
    [sym_compiler_directive_decl] = STATE(1573),
    [sym_fsi_directive_decl] = STATE(1573),
    [sym_preproc_line] = STATE(1573),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_as] = ACTIONS(3193),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(4024),
    [anon_sym_uy] = ACTIONS(4026),
    [anon_sym_s] = ACTIONS(4028),
    [anon_sym_us] = ACTIONS(4030),
    [anon_sym_l] = ACTIONS(4032),
    [aux_sym_uint32_token1] = ACTIONS(4034),
    [anon_sym_n] = ACTIONS(4036),
    [anon_sym_un] = ACTIONS(4038),
    [anon_sym_L] = ACTIONS(4040),
    [aux_sym_uint64_token1] = ACTIONS(4042),
    [anon_sym_lf] = ACTIONS(4438),
    [anon_sym_LF] = ACTIONS(4440),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
    [sym__dedent] = ACTIONS(3191),
  },
  [1574] = {
    [sym_block_comment] = STATE(1574),
    [sym_compiler_directive_decl] = STATE(1574),
    [sym_fsi_directive_decl] = STATE(1574),
    [sym_preproc_line] = STATE(1574),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_LBRACK_LT] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [aux_sym_access_modifier_token1] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_done] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_DOT_DOT] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_default] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [anon_sym_static] = ACTIONS(3700),
    [anon_sym_member] = ACTIONS(3700),
    [anon_sym_interface] = ACTIONS(3700),
    [anon_sym_abstract] = ACTIONS(3700),
    [anon_sym_val] = ACTIONS(3700),
    [anon_sym_override] = ACTIONS(3700),
    [anon_sym_inherit] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [anon_sym_POUNDendif] = ACTIONS(3698),
    [anon_sym_POUNDelse] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [1575] = {
    [sym_block_comment] = STATE(1575),
    [sym_compiler_directive_decl] = STATE(1575),
    [sym_fsi_directive_decl] = STATE(1575),
    [sym_preproc_line] = STATE(1575),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_GT] = ACTIONS(3193),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(4442),
    [anon_sym_uy] = ACTIONS(4444),
    [anon_sym_s] = ACTIONS(4446),
    [anon_sym_us] = ACTIONS(4448),
    [anon_sym_l] = ACTIONS(4450),
    [aux_sym_uint32_token1] = ACTIONS(4452),
    [anon_sym_n] = ACTIONS(4454),
    [anon_sym_un] = ACTIONS(4456),
    [anon_sym_L] = ACTIONS(4458),
    [aux_sym_uint64_token1] = ACTIONS(4460),
    [aux_sym_bignum_token1] = ACTIONS(4462),
    [aux_sym_decimal_token1] = ACTIONS(4464),
    [anon_sym_DOT2] = ACTIONS(4466),
    [aux_sym_float_token1] = ACTIONS(4468),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1576] = {
    [sym_block_comment] = STATE(1576),
    [sym_compiler_directive_decl] = STATE(1576),
    [sym_fsi_directive_decl] = STATE(1576),
    [sym_preproc_line] = STATE(1576),
    [sym_identifier] = ACTIONS(3732),
    [anon_sym_EQ] = ACTIONS(3730),
    [anon_sym_LBRACK_LT] = ACTIONS(3730),
    [anon_sym_COLON] = ACTIONS(3732),
    [anon_sym_return] = ACTIONS(3732),
    [anon_sym_do] = ACTIONS(3732),
    [anon_sym_and] = ACTIONS(3732),
    [anon_sym_let] = ACTIONS(3732),
    [anon_sym_let_BANG] = ACTIONS(3730),
    [aux_sym_access_modifier_token1] = ACTIONS(3730),
    [anon_sym_LPAREN] = ACTIONS(3732),
    [anon_sym_COMMA] = ACTIONS(3730),
    [anon_sym_null] = ACTIONS(3732),
    [anon_sym_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_LBRACK] = ACTIONS(3732),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3730),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_LT_AT] = ACTIONS(3732),
    [anon_sym_LT_AT_AT] = ACTIONS(3732),
    [anon_sym_DOT] = ACTIONS(3732),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3730),
    [anon_sym_new] = ACTIONS(3732),
    [anon_sym_with] = ACTIONS(3732),
    [anon_sym_return_BANG] = ACTIONS(3730),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_yield_BANG] = ACTIONS(3730),
    [anon_sym_lazy] = ACTIONS(3732),
    [anon_sym_assert] = ACTIONS(3732),
    [anon_sym_upcast] = ACTIONS(3732),
    [anon_sym_downcast] = ACTIONS(3732),
    [anon_sym_COLON_GT] = ACTIONS(3730),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3730),
    [anon_sym_for] = ACTIONS(3732),
    [anon_sym_while] = ACTIONS(3732),
    [anon_sym_else] = ACTIONS(3732),
    [anon_sym_elif] = ACTIONS(3732),
    [anon_sym_if] = ACTIONS(3732),
    [anon_sym_fun] = ACTIONS(3732),
    [anon_sym_try] = ACTIONS(3732),
    [anon_sym_match] = ACTIONS(3732),
    [anon_sym_match_BANG] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3732),
    [anon_sym_LT_DASH] = ACTIONS(3732),
    [anon_sym_DOT_LBRACK] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3730),
    [anon_sym_use] = ACTIONS(3732),
    [anon_sym_use_BANG] = ACTIONS(3730),
    [anon_sym_do_BANG] = ACTIONS(3730),
    [anon_sym_begin] = ACTIONS(3732),
    [anon_sym_LPAREN2] = ACTIONS(3732),
    [anon_sym_default] = ACTIONS(3732),
    [anon_sym_or] = ACTIONS(3732),
    [anon_sym_static] = ACTIONS(3732),
    [anon_sym_member] = ACTIONS(3732),
    [anon_sym_interface] = ACTIONS(3732),
    [anon_sym_abstract] = ACTIONS(3732),
    [anon_sym_val] = ACTIONS(3732),
    [anon_sym_override] = ACTIONS(3732),
    [aux_sym_char_token1] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3732),
    [anon_sym_DQUOTE] = ACTIONS(3732),
    [anon_sym_AT_DQUOTE] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [sym_bool] = ACTIONS(3732),
    [sym_unit] = ACTIONS(3730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3732),
    [sym_op_identifier] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PLUS_DOT] = ACTIONS(3732),
    [anon_sym_DASH_DOT] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3732),
    [anon_sym_AMP_AMP] = ACTIONS(3732),
    [anon_sym_TILDE] = ACTIONS(3730),
    [aux_sym_prefix_op_token1] = ACTIONS(3732),
    [aux_sym_infix_op_token1] = ACTIONS(3730),
    [aux_sym_infix_op_token2] = ACTIONS(3732),
    [anon_sym_PIPE_PIPE] = ACTIONS(3732),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_COLON_EQ] = ACTIONS(3730),
    [anon_sym_DOLLAR] = ACTIONS(3732),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3732),
    [sym_int] = ACTIONS(3732),
    [sym_xint] = ACTIONS(3730),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3730),
    [anon_sym_POUNDendif] = ACTIONS(3730),
    [anon_sym_POUNDelse] = ACTIONS(3730),
    [sym__newline] = ACTIONS(3730),
  },
  [1577] = {
    [sym_block_comment] = STATE(1577),
    [sym_compiler_directive_decl] = STATE(1577),
    [sym_fsi_directive_decl] = STATE(1577),
    [sym_preproc_line] = STATE(1577),
    [aux_sym_rules_repeat1] = STATE(1571),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_LBRACK_LT] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_and] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [aux_sym_access_modifier_token1] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(4344),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_with] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_default] = ACTIONS(3693),
    [anon_sym_or] = ACTIONS(3693),
    [anon_sym_static] = ACTIONS(3693),
    [anon_sym_member] = ACTIONS(3693),
    [anon_sym_interface] = ACTIONS(3693),
    [anon_sym_abstract] = ACTIONS(3693),
    [anon_sym_val] = ACTIONS(3693),
    [anon_sym_override] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [anon_sym_POUNDendif] = ACTIONS(3691),
    [anon_sym_POUNDelse] = ACTIONS(3691),
    [sym__newline] = ACTIONS(4470),
  },
  [1578] = {
    [sym_block_comment] = STATE(1578),
    [sym_compiler_directive_decl] = STATE(1578),
    [sym_fsi_directive_decl] = STATE(1578),
    [sym_preproc_line] = STATE(1578),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_LBRACK_LT] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [aux_sym_access_modifier_token1] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_else] = ACTIONS(3700),
    [anon_sym_elif] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_default] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [anon_sym_static] = ACTIONS(3700),
    [anon_sym_member] = ACTIONS(3700),
    [anon_sym_interface] = ACTIONS(3700),
    [anon_sym_abstract] = ACTIONS(3700),
    [anon_sym_val] = ACTIONS(3700),
    [anon_sym_override] = ACTIONS(3700),
    [anon_sym_inherit] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [anon_sym_POUNDendif] = ACTIONS(3698),
    [anon_sym_POUNDelse] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [1579] = {
    [sym_block_comment] = STATE(1579),
    [sym_compiler_directive_decl] = STATE(1579),
    [sym_fsi_directive_decl] = STATE(1579),
    [sym_preproc_line] = STATE(1579),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_LBRACK_LT] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_and] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [aux_sym_access_modifier_token1] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_with] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_default] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [anon_sym_static] = ACTIONS(3604),
    [anon_sym_member] = ACTIONS(3604),
    [anon_sym_interface] = ACTIONS(3604),
    [anon_sym_abstract] = ACTIONS(3604),
    [anon_sym_val] = ACTIONS(3604),
    [anon_sym_override] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [aux_sym_float_token1] = ACTIONS(4473),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
    [sym__dedent] = ACTIONS(3602),
  },
  [1580] = {
    [sym_block_comment] = STATE(1580),
    [sym_compiler_directive_decl] = STATE(1580),
    [sym_fsi_directive_decl] = STATE(1580),
    [sym_preproc_line] = STATE(1580),
    [aux_sym_rules_repeat1] = STATE(1555),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_LBRACK_LT] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_and] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [aux_sym_access_modifier_token1] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(4344),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_with] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_default] = ACTIONS(3693),
    [anon_sym_or] = ACTIONS(3693),
    [anon_sym_static] = ACTIONS(3693),
    [anon_sym_member] = ACTIONS(3693),
    [anon_sym_interface] = ACTIONS(3693),
    [anon_sym_abstract] = ACTIONS(3693),
    [anon_sym_val] = ACTIONS(3693),
    [anon_sym_override] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [anon_sym_POUNDendif] = ACTIONS(3691),
    [anon_sym_POUNDelse] = ACTIONS(3691),
    [sym__newline] = ACTIONS(4470),
  },
  [1581] = {
    [sym_block_comment] = STATE(1581),
    [sym_compiler_directive_decl] = STATE(1581),
    [sym_fsi_directive_decl] = STATE(1581),
    [sym_preproc_line] = STATE(1581),
    [aux_sym_rules_repeat1] = STATE(1577),
    [sym_identifier] = ACTIONS(3736),
    [anon_sym_EQ] = ACTIONS(3734),
    [anon_sym_LBRACK_LT] = ACTIONS(3734),
    [anon_sym_COLON] = ACTIONS(3736),
    [anon_sym_return] = ACTIONS(3736),
    [anon_sym_do] = ACTIONS(3736),
    [anon_sym_and] = ACTIONS(3736),
    [anon_sym_let] = ACTIONS(3736),
    [anon_sym_let_BANG] = ACTIONS(3734),
    [aux_sym_access_modifier_token1] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3736),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_null] = ACTIONS(3736),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_COLON] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(4344),
    [anon_sym_AMP] = ACTIONS(3736),
    [anon_sym_LBRACK] = ACTIONS(3736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3734),
    [anon_sym_LBRACE] = ACTIONS(3736),
    [anon_sym_LT_AT] = ACTIONS(3736),
    [anon_sym_LT_AT_AT] = ACTIONS(3736),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3734),
    [anon_sym_new] = ACTIONS(3736),
    [anon_sym_with] = ACTIONS(3736),
    [anon_sym_return_BANG] = ACTIONS(3734),
    [anon_sym_yield] = ACTIONS(3736),
    [anon_sym_yield_BANG] = ACTIONS(3734),
    [anon_sym_lazy] = ACTIONS(3736),
    [anon_sym_assert] = ACTIONS(3736),
    [anon_sym_upcast] = ACTIONS(3736),
    [anon_sym_downcast] = ACTIONS(3736),
    [anon_sym_COLON_GT] = ACTIONS(3734),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3734),
    [anon_sym_for] = ACTIONS(3736),
    [anon_sym_while] = ACTIONS(3736),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_fun] = ACTIONS(3736),
    [anon_sym_try] = ACTIONS(3736),
    [anon_sym_match] = ACTIONS(3736),
    [anon_sym_match_BANG] = ACTIONS(3734),
    [anon_sym_function] = ACTIONS(3736),
    [anon_sym_LT_DASH] = ACTIONS(3736),
    [anon_sym_DOT_LBRACK] = ACTIONS(3734),
    [anon_sym_LT] = ACTIONS(3734),
    [anon_sym_use] = ACTIONS(3736),
    [anon_sym_use_BANG] = ACTIONS(3734),
    [anon_sym_do_BANG] = ACTIONS(3734),
    [anon_sym_begin] = ACTIONS(3736),
    [anon_sym_LPAREN2] = ACTIONS(3736),
    [anon_sym_default] = ACTIONS(3736),
    [anon_sym_or] = ACTIONS(3736),
    [anon_sym_static] = ACTIONS(3736),
    [anon_sym_member] = ACTIONS(3736),
    [anon_sym_interface] = ACTIONS(3736),
    [anon_sym_abstract] = ACTIONS(3736),
    [anon_sym_val] = ACTIONS(3736),
    [anon_sym_override] = ACTIONS(3736),
    [aux_sym_char_token1] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3736),
    [anon_sym_DQUOTE] = ACTIONS(3736),
    [anon_sym_AT_DQUOTE] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [sym_bool] = ACTIONS(3736),
    [sym_unit] = ACTIONS(3734),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3736),
    [sym_op_identifier] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS_DOT] = ACTIONS(3736),
    [anon_sym_DASH_DOT] = ACTIONS(3736),
    [anon_sym_PERCENT] = ACTIONS(3736),
    [anon_sym_AMP_AMP] = ACTIONS(3736),
    [anon_sym_TILDE] = ACTIONS(3734),
    [aux_sym_prefix_op_token1] = ACTIONS(3736),
    [aux_sym_infix_op_token1] = ACTIONS(3734),
    [aux_sym_infix_op_token2] = ACTIONS(3736),
    [anon_sym_PIPE_PIPE] = ACTIONS(3736),
    [anon_sym_BANG_EQ] = ACTIONS(3736),
    [anon_sym_COLON_EQ] = ACTIONS(3734),
    [anon_sym_DOLLAR] = ACTIONS(3736),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3736),
    [sym_int] = ACTIONS(3736),
    [sym_xint] = ACTIONS(3734),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3734),
    [anon_sym_POUNDendif] = ACTIONS(3734),
    [anon_sym_POUNDelse] = ACTIONS(3734),
    [sym__newline] = ACTIONS(4475),
  },
  [1582] = {
    [sym_block_comment] = STATE(1582),
    [sym_compiler_directive_decl] = STATE(1582),
    [sym_fsi_directive_decl] = STATE(1582),
    [sym_preproc_line] = STATE(1582),
    [sym_identifier] = ACTIONS(3728),
    [anon_sym_EQ] = ACTIONS(3726),
    [anon_sym_LBRACK_LT] = ACTIONS(3726),
    [anon_sym_COLON] = ACTIONS(3728),
    [anon_sym_return] = ACTIONS(3728),
    [anon_sym_do] = ACTIONS(3728),
    [anon_sym_let] = ACTIONS(3728),
    [anon_sym_let_BANG] = ACTIONS(3726),
    [aux_sym_access_modifier_token1] = ACTIONS(3726),
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_COMMA] = ACTIONS(3726),
    [anon_sym_null] = ACTIONS(3728),
    [anon_sym_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(3726),
    [anon_sym_AMP] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3726),
    [anon_sym_LBRACE] = ACTIONS(3728),
    [anon_sym_LT_AT] = ACTIONS(3728),
    [anon_sym_LT_AT_AT] = ACTIONS(3728),
    [anon_sym_DOT] = ACTIONS(3728),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3726),
    [anon_sym_new] = ACTIONS(3728),
    [anon_sym_with] = ACTIONS(3728),
    [anon_sym_return_BANG] = ACTIONS(3726),
    [anon_sym_yield] = ACTIONS(3728),
    [anon_sym_yield_BANG] = ACTIONS(3726),
    [anon_sym_lazy] = ACTIONS(3728),
    [anon_sym_assert] = ACTIONS(3728),
    [anon_sym_upcast] = ACTIONS(3728),
    [anon_sym_downcast] = ACTIONS(3728),
    [anon_sym_COLON_GT] = ACTIONS(3726),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3726),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_fun] = ACTIONS(3728),
    [anon_sym_try] = ACTIONS(3728),
    [anon_sym_match] = ACTIONS(3728),
    [anon_sym_match_BANG] = ACTIONS(3726),
    [anon_sym_function] = ACTIONS(3728),
    [anon_sym_LT_DASH] = ACTIONS(3728),
    [anon_sym_DOT_LBRACK] = ACTIONS(3726),
    [anon_sym_LT] = ACTIONS(3726),
    [anon_sym_use] = ACTIONS(3728),
    [anon_sym_use_BANG] = ACTIONS(3726),
    [anon_sym_do_BANG] = ACTIONS(3726),
    [anon_sym_begin] = ACTIONS(3728),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_default] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [anon_sym_static] = ACTIONS(3728),
    [anon_sym_member] = ACTIONS(3728),
    [anon_sym_interface] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(3728),
    [anon_sym_val] = ACTIONS(3728),
    [anon_sym_override] = ACTIONS(3728),
    [anon_sym_inherit] = ACTIONS(3728),
    [aux_sym_char_token1] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3728),
    [anon_sym_AT_DQUOTE] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [sym_bool] = ACTIONS(3728),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3728),
    [sym_op_identifier] = ACTIONS(3728),
    [anon_sym_PLUS] = ACTIONS(3728),
    [anon_sym_DASH] = ACTIONS(3728),
    [anon_sym_PLUS_DOT] = ACTIONS(3728),
    [anon_sym_DASH_DOT] = ACTIONS(3728),
    [anon_sym_PERCENT] = ACTIONS(3728),
    [anon_sym_AMP_AMP] = ACTIONS(3728),
    [anon_sym_TILDE] = ACTIONS(3726),
    [aux_sym_prefix_op_token1] = ACTIONS(3728),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token2] = ACTIONS(3728),
    [anon_sym_PIPE_PIPE] = ACTIONS(3728),
    [anon_sym_BANG_EQ] = ACTIONS(3728),
    [anon_sym_COLON_EQ] = ACTIONS(3726),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3728),
    [sym_int] = ACTIONS(3728),
    [sym_xint] = ACTIONS(3726),
    [anon_sym_f] = ACTIONS(3728),
    [aux_sym_decimal_token1] = ACTIONS(3728),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3726),
    [anon_sym_POUNDendif] = ACTIONS(3726),
    [anon_sym_POUNDelse] = ACTIONS(3726),
    [sym__newline] = ACTIONS(3726),
  },
  [1583] = {
    [sym_block_comment] = STATE(1583),
    [sym_compiler_directive_decl] = STATE(1583),
    [sym_fsi_directive_decl] = STATE(1583),
    [sym_preproc_line] = STATE(1583),
    [sym_identifier] = ACTIONS(3753),
    [anon_sym_EQ] = ACTIONS(3751),
    [anon_sym_LBRACK_LT] = ACTIONS(3751),
    [anon_sym_COLON] = ACTIONS(3753),
    [anon_sym_return] = ACTIONS(3753),
    [anon_sym_do] = ACTIONS(3753),
    [anon_sym_let] = ACTIONS(3753),
    [anon_sym_let_BANG] = ACTIONS(3751),
    [aux_sym_access_modifier_token1] = ACTIONS(3751),
    [anon_sym_LPAREN] = ACTIONS(3753),
    [anon_sym_COMMA] = ACTIONS(3751),
    [anon_sym_null] = ACTIONS(3753),
    [anon_sym_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_COLON] = ACTIONS(3751),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3751),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_LT_AT] = ACTIONS(3753),
    [anon_sym_LT_AT_AT] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3753),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3751),
    [anon_sym_new] = ACTIONS(3753),
    [anon_sym_with] = ACTIONS(3753),
    [anon_sym_return_BANG] = ACTIONS(3751),
    [anon_sym_yield] = ACTIONS(3753),
    [anon_sym_yield_BANG] = ACTIONS(3751),
    [anon_sym_lazy] = ACTIONS(3753),
    [anon_sym_assert] = ACTIONS(3753),
    [anon_sym_upcast] = ACTIONS(3753),
    [anon_sym_downcast] = ACTIONS(3753),
    [anon_sym_COLON_GT] = ACTIONS(3751),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3751),
    [anon_sym_for] = ACTIONS(3753),
    [anon_sym_while] = ACTIONS(3753),
    [anon_sym_if] = ACTIONS(3753),
    [anon_sym_fun] = ACTIONS(3753),
    [anon_sym_try] = ACTIONS(3753),
    [anon_sym_match] = ACTIONS(3753),
    [anon_sym_match_BANG] = ACTIONS(3751),
    [anon_sym_function] = ACTIONS(3753),
    [anon_sym_LT_DASH] = ACTIONS(3753),
    [anon_sym_DOT_LBRACK] = ACTIONS(3751),
    [anon_sym_LT] = ACTIONS(3751),
    [anon_sym_use] = ACTIONS(3753),
    [anon_sym_use_BANG] = ACTIONS(3751),
    [anon_sym_do_BANG] = ACTIONS(3751),
    [anon_sym_begin] = ACTIONS(3753),
    [anon_sym_LPAREN2] = ACTIONS(3753),
    [anon_sym_default] = ACTIONS(3753),
    [anon_sym_or] = ACTIONS(3753),
    [anon_sym_static] = ACTIONS(3753),
    [anon_sym_member] = ACTIONS(3753),
    [anon_sym_interface] = ACTIONS(3753),
    [anon_sym_abstract] = ACTIONS(3753),
    [anon_sym_val] = ACTIONS(3753),
    [anon_sym_override] = ACTIONS(3753),
    [anon_sym_inherit] = ACTIONS(3753),
    [aux_sym_char_token1] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3753),
    [anon_sym_AT_DQUOTE] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [sym_bool] = ACTIONS(3753),
    [sym_unit] = ACTIONS(3751),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3753),
    [sym_op_identifier] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PLUS_DOT] = ACTIONS(3753),
    [anon_sym_DASH_DOT] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3753),
    [anon_sym_AMP_AMP] = ACTIONS(3753),
    [anon_sym_TILDE] = ACTIONS(3751),
    [aux_sym_prefix_op_token1] = ACTIONS(3753),
    [aux_sym_infix_op_token1] = ACTIONS(3751),
    [aux_sym_infix_op_token2] = ACTIONS(3753),
    [anon_sym_PIPE_PIPE] = ACTIONS(3753),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_COLON_EQ] = ACTIONS(3751),
    [anon_sym_DOLLAR] = ACTIONS(3753),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3753),
    [sym_int] = ACTIONS(4478),
    [sym_xint] = ACTIONS(3751),
    [anon_sym_f] = ACTIONS(3753),
    [aux_sym_decimal_token1] = ACTIONS(3753),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3751),
    [anon_sym_POUNDendif] = ACTIONS(3751),
    [anon_sym_POUNDelse] = ACTIONS(3751),
    [sym__newline] = ACTIONS(3751),
  },
  [1584] = {
    [sym_block_comment] = STATE(1584),
    [sym_compiler_directive_decl] = STATE(1584),
    [sym_fsi_directive_decl] = STATE(1584),
    [sym_preproc_line] = STATE(1584),
    [sym_identifier] = ACTIONS(3728),
    [anon_sym_EQ] = ACTIONS(3726),
    [anon_sym_LBRACK_LT] = ACTIONS(3726),
    [anon_sym_COLON] = ACTIONS(3728),
    [anon_sym_return] = ACTIONS(3728),
    [anon_sym_do] = ACTIONS(3728),
    [anon_sym_and] = ACTIONS(3728),
    [anon_sym_let] = ACTIONS(3728),
    [anon_sym_let_BANG] = ACTIONS(3726),
    [aux_sym_access_modifier_token1] = ACTIONS(3726),
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_COMMA] = ACTIONS(3726),
    [anon_sym_null] = ACTIONS(3728),
    [anon_sym_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(3726),
    [anon_sym_AMP] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3726),
    [anon_sym_LBRACE] = ACTIONS(3728),
    [anon_sym_LT_AT] = ACTIONS(3728),
    [anon_sym_LT_AT_AT] = ACTIONS(3728),
    [anon_sym_DOT] = ACTIONS(3728),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3726),
    [anon_sym_new] = ACTIONS(3728),
    [anon_sym_with] = ACTIONS(3728),
    [anon_sym_return_BANG] = ACTIONS(3726),
    [anon_sym_yield] = ACTIONS(3728),
    [anon_sym_yield_BANG] = ACTIONS(3726),
    [anon_sym_lazy] = ACTIONS(3728),
    [anon_sym_assert] = ACTIONS(3728),
    [anon_sym_upcast] = ACTIONS(3728),
    [anon_sym_downcast] = ACTIONS(3728),
    [anon_sym_COLON_GT] = ACTIONS(3726),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3726),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_fun] = ACTIONS(3728),
    [anon_sym_try] = ACTIONS(3728),
    [anon_sym_match] = ACTIONS(3728),
    [anon_sym_match_BANG] = ACTIONS(3726),
    [anon_sym_function] = ACTIONS(3728),
    [anon_sym_LT_DASH] = ACTIONS(3728),
    [anon_sym_DOT_LBRACK] = ACTIONS(3726),
    [anon_sym_LT] = ACTIONS(3726),
    [anon_sym_use] = ACTIONS(3728),
    [anon_sym_use_BANG] = ACTIONS(3726),
    [anon_sym_do_BANG] = ACTIONS(3726),
    [anon_sym_begin] = ACTIONS(3728),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_default] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [anon_sym_static] = ACTIONS(3728),
    [anon_sym_member] = ACTIONS(3728),
    [anon_sym_interface] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(3728),
    [anon_sym_val] = ACTIONS(3728),
    [anon_sym_override] = ACTIONS(3728),
    [aux_sym_char_token1] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3728),
    [anon_sym_AT_DQUOTE] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [sym_bool] = ACTIONS(3728),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3728),
    [sym_op_identifier] = ACTIONS(3728),
    [anon_sym_PLUS] = ACTIONS(3728),
    [anon_sym_DASH] = ACTIONS(3728),
    [anon_sym_PLUS_DOT] = ACTIONS(3728),
    [anon_sym_DASH_DOT] = ACTIONS(3728),
    [anon_sym_PERCENT] = ACTIONS(3728),
    [anon_sym_AMP_AMP] = ACTIONS(3728),
    [anon_sym_TILDE] = ACTIONS(3726),
    [aux_sym_prefix_op_token1] = ACTIONS(3728),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token2] = ACTIONS(3728),
    [anon_sym_PIPE_PIPE] = ACTIONS(3728),
    [anon_sym_BANG_EQ] = ACTIONS(3728),
    [anon_sym_COLON_EQ] = ACTIONS(3726),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3728),
    [sym_int] = ACTIONS(3728),
    [sym_xint] = ACTIONS(3726),
    [anon_sym_f] = ACTIONS(3728),
    [aux_sym_decimal_token1] = ACTIONS(3728),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3726),
    [anon_sym_POUNDendif] = ACTIONS(3726),
    [anon_sym_POUNDelse] = ACTIONS(3726),
    [sym__newline] = ACTIONS(3726),
  },
  [1585] = {
    [sym_block_comment] = STATE(1585),
    [sym_compiler_directive_decl] = STATE(1585),
    [sym_fsi_directive_decl] = STATE(1585),
    [sym_preproc_line] = STATE(1585),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_LBRACK_LT] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [aux_sym_access_modifier_token1] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_with] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_default] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [anon_sym_static] = ACTIONS(3604),
    [anon_sym_member] = ACTIONS(3604),
    [anon_sym_interface] = ACTIONS(3604),
    [anon_sym_abstract] = ACTIONS(3604),
    [anon_sym_val] = ACTIONS(3604),
    [anon_sym_override] = ACTIONS(3604),
    [anon_sym_inherit] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [anon_sym_POUNDendif] = ACTIONS(3602),
    [anon_sym_POUNDelse] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
  },
  [1586] = {
    [sym_block_comment] = STATE(1586),
    [sym_compiler_directive_decl] = STATE(1586),
    [sym_fsi_directive_decl] = STATE(1586),
    [sym_preproc_line] = STATE(1586),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_DOT_DOT] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(4480),
    [anon_sym_uy] = ACTIONS(4482),
    [anon_sym_s] = ACTIONS(4484),
    [anon_sym_us] = ACTIONS(4486),
    [anon_sym_l] = ACTIONS(4488),
    [aux_sym_uint32_token1] = ACTIONS(4490),
    [anon_sym_n] = ACTIONS(4492),
    [anon_sym_un] = ACTIONS(4494),
    [anon_sym_L] = ACTIONS(4496),
    [aux_sym_uint64_token1] = ACTIONS(4498),
    [aux_sym_bignum_token1] = ACTIONS(4500),
    [aux_sym_decimal_token1] = ACTIONS(4502),
    [anon_sym_DOT2] = ACTIONS(4504),
    [aux_sym_float_token1] = ACTIONS(4506),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1587] = {
    [sym_block_comment] = STATE(1587),
    [sym_compiler_directive_decl] = STATE(1587),
    [sym_fsi_directive_decl] = STATE(1587),
    [sym_preproc_line] = STATE(1587),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_DOT_DOT2] = ACTIONS(3191),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3375),
    [anon_sym_uy] = ACTIONS(3377),
    [anon_sym_s] = ACTIONS(3379),
    [anon_sym_us] = ACTIONS(3381),
    [anon_sym_l] = ACTIONS(3383),
    [aux_sym_uint32_token1] = ACTIONS(3385),
    [anon_sym_n] = ACTIONS(3387),
    [anon_sym_un] = ACTIONS(3389),
    [anon_sym_L] = ACTIONS(3391),
    [aux_sym_uint64_token1] = ACTIONS(3393),
    [anon_sym_lf] = ACTIONS(3445),
    [anon_sym_LF] = ACTIONS(3447),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
    [sym__dedent] = ACTIONS(3191),
  },
  [1588] = {
    [sym_block_comment] = STATE(1588),
    [sym_compiler_directive_decl] = STATE(1588),
    [sym_fsi_directive_decl] = STATE(1588),
    [sym_preproc_line] = STATE(1588),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_LBRACK_LT] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_and] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [aux_sym_access_modifier_token1] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_done] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_DOT_DOT] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_default] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [anon_sym_static] = ACTIONS(3700),
    [anon_sym_member] = ACTIONS(3700),
    [anon_sym_interface] = ACTIONS(3700),
    [anon_sym_abstract] = ACTIONS(3700),
    [anon_sym_val] = ACTIONS(3700),
    [anon_sym_override] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [anon_sym_POUNDendif] = ACTIONS(3698),
    [anon_sym_POUNDelse] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [1589] = {
    [sym_block_comment] = STATE(1589),
    [sym_compiler_directive_decl] = STATE(1589),
    [sym_fsi_directive_decl] = STATE(1589),
    [sym_preproc_line] = STATE(1589),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3283),
    [anon_sym_uy] = ACTIONS(3285),
    [anon_sym_s] = ACTIONS(3287),
    [anon_sym_us] = ACTIONS(3289),
    [anon_sym_l] = ACTIONS(3291),
    [aux_sym_uint32_token1] = ACTIONS(3293),
    [anon_sym_n] = ACTIONS(3295),
    [anon_sym_un] = ACTIONS(3297),
    [anon_sym_L] = ACTIONS(3299),
    [aux_sym_uint64_token1] = ACTIONS(3301),
    [aux_sym_bignum_token1] = ACTIONS(3303),
    [aux_sym_decimal_token1] = ACTIONS(3305),
    [anon_sym_DOT2] = ACTIONS(4508),
    [aux_sym_float_token1] = ACTIONS(4510),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [anon_sym_POUNDendif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1590] = {
    [sym_block_comment] = STATE(1590),
    [sym_compiler_directive_decl] = STATE(1590),
    [sym_fsi_directive_decl] = STATE(1590),
    [sym_preproc_line] = STATE(1590),
    [aux_sym_rules_repeat1] = STATE(1556),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_LBRACK_LT] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [aux_sym_access_modifier_token1] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(4349),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_with] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_default] = ACTIONS(3693),
    [anon_sym_or] = ACTIONS(3693),
    [anon_sym_static] = ACTIONS(3693),
    [anon_sym_member] = ACTIONS(3693),
    [anon_sym_interface] = ACTIONS(3693),
    [anon_sym_abstract] = ACTIONS(3693),
    [anon_sym_val] = ACTIONS(3693),
    [anon_sym_override] = ACTIONS(3693),
    [anon_sym_inherit] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [anon_sym_POUNDendif] = ACTIONS(3691),
    [anon_sym_POUNDelse] = ACTIONS(3691),
    [sym__newline] = ACTIONS(4354),
  },
  [1591] = {
    [sym_block_comment] = STATE(1591),
    [sym_compiler_directive_decl] = STATE(1591),
    [sym_fsi_directive_decl] = STATE(1591),
    [sym_preproc_line] = STATE(1591),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_LBRACK_LT] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_and] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [aux_sym_access_modifier_token1] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_else] = ACTIONS(3700),
    [anon_sym_elif] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_default] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [anon_sym_static] = ACTIONS(3700),
    [anon_sym_member] = ACTIONS(3700),
    [anon_sym_interface] = ACTIONS(3700),
    [anon_sym_abstract] = ACTIONS(3700),
    [anon_sym_val] = ACTIONS(3700),
    [anon_sym_override] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [anon_sym_POUNDendif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [1592] = {
    [sym_block_comment] = STATE(1592),
    [sym_compiler_directive_decl] = STATE(1592),
    [sym_fsi_directive_decl] = STATE(1592),
    [sym_preproc_line] = STATE(1592),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [aux_sym_access_modifier_token1] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_member] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_val] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [anon_sym_inherit] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_f] = ACTIONS(3421),
    [aux_sym_decimal_token1] = ACTIONS(3305),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [anon_sym_POUNDendif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1593] = {
    [sym_block_comment] = STATE(1593),
    [sym_compiler_directive_decl] = STATE(1593),
    [sym_fsi_directive_decl] = STATE(1593),
    [sym_preproc_line] = STATE(1593),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_LBRACK_LT] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [aux_sym_access_modifier_token1] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_with] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_default] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [anon_sym_static] = ACTIONS(3604),
    [anon_sym_member] = ACTIONS(3604),
    [anon_sym_interface] = ACTIONS(3604),
    [anon_sym_abstract] = ACTIONS(3604),
    [anon_sym_val] = ACTIONS(3604),
    [anon_sym_override] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [aux_sym_float_token1] = ACTIONS(4512),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
    [sym__dedent] = ACTIONS(3602),
  },
  [1594] = {
    [sym_block_comment] = STATE(1594),
    [sym_compiler_directive_decl] = STATE(1594),
    [sym_fsi_directive_decl] = STATE(1594),
    [sym_preproc_line] = STATE(1594),
    [aux_sym_sequential_expression_repeat1] = STATE(1652),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_LBRACK_LT] = ACTIONS(3757),
    [anon_sym_COLON] = ACTIONS(3759),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_and] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_let_BANG] = ACTIONS(3757),
    [aux_sym_access_modifier_token1] = ACTIONS(3757),
    [anon_sym_LPAREN] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3757),
    [anon_sym_null] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3757),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_LT_AT] = ACTIONS(3759),
    [anon_sym_LT_AT_AT] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(3759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_with] = ACTIONS(3759),
    [anon_sym_return_BANG] = ACTIONS(3757),
    [anon_sym_yield] = ACTIONS(3759),
    [anon_sym_yield_BANG] = ACTIONS(3757),
    [anon_sym_lazy] = ACTIONS(3759),
    [anon_sym_assert] = ACTIONS(3759),
    [anon_sym_upcast] = ACTIONS(3759),
    [anon_sym_downcast] = ACTIONS(3759),
    [anon_sym_COLON_GT] = ACTIONS(3757),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3757),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_fun] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_match] = ACTIONS(3759),
    [anon_sym_match_BANG] = ACTIONS(3757),
    [anon_sym_function] = ACTIONS(3759),
    [anon_sym_LT_DASH] = ACTIONS(3759),
    [anon_sym_DOT_LBRACK] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_use] = ACTIONS(3759),
    [anon_sym_use_BANG] = ACTIONS(3757),
    [anon_sym_do_BANG] = ACTIONS(3757),
    [anon_sym_begin] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_default] = ACTIONS(3759),
    [anon_sym_or] = ACTIONS(3759),
    [anon_sym_static] = ACTIONS(3759),
    [anon_sym_member] = ACTIONS(3759),
    [anon_sym_interface] = ACTIONS(3759),
    [anon_sym_abstract] = ACTIONS(3759),
    [anon_sym_val] = ACTIONS(3759),
    [anon_sym_override] = ACTIONS(3759),
    [aux_sym_char_token1] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3759),
    [anon_sym_DQUOTE] = ACTIONS(3759),
    [anon_sym_AT_DQUOTE] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [sym_bool] = ACTIONS(3759),
    [sym_unit] = ACTIONS(3757),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3759),
    [sym_op_identifier] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS_DOT] = ACTIONS(3759),
    [anon_sym_DASH_DOT] = ACTIONS(3759),
    [anon_sym_PERCENT] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_TILDE] = ACTIONS(3757),
    [aux_sym_prefix_op_token1] = ACTIONS(3759),
    [aux_sym_infix_op_token1] = ACTIONS(3757),
    [aux_sym_infix_op_token2] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_COLON_EQ] = ACTIONS(3757),
    [anon_sym_DOLLAR] = ACTIONS(3759),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3759),
    [sym_int] = ACTIONS(3759),
    [sym_xint] = ACTIONS(3757),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3757),
    [anon_sym_POUNDendif] = ACTIONS(3757),
    [anon_sym_POUNDelse] = ACTIONS(3757),
    [sym__newline] = ACTIONS(3757),
  },
  [1595] = {
    [sym_block_comment] = STATE(1595),
    [sym_compiler_directive_decl] = STATE(1595),
    [sym_fsi_directive_decl] = STATE(1595),
    [sym_preproc_line] = STATE(1595),
    [sym_identifier] = ACTIONS(3753),
    [anon_sym_EQ] = ACTIONS(3751),
    [anon_sym_LBRACK_LT] = ACTIONS(3751),
    [anon_sym_COLON] = ACTIONS(3753),
    [anon_sym_return] = ACTIONS(3753),
    [anon_sym_do] = ACTIONS(3753),
    [anon_sym_and] = ACTIONS(3753),
    [anon_sym_let] = ACTIONS(3753),
    [anon_sym_let_BANG] = ACTIONS(3751),
    [aux_sym_access_modifier_token1] = ACTIONS(3751),
    [anon_sym_LPAREN] = ACTIONS(3753),
    [anon_sym_COMMA] = ACTIONS(3751),
    [anon_sym_null] = ACTIONS(3753),
    [anon_sym_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_COLON] = ACTIONS(3751),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3751),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_LT_AT] = ACTIONS(3753),
    [anon_sym_LT_AT_AT] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3753),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3751),
    [anon_sym_new] = ACTIONS(3753),
    [anon_sym_with] = ACTIONS(3753),
    [anon_sym_return_BANG] = ACTIONS(3751),
    [anon_sym_yield] = ACTIONS(3753),
    [anon_sym_yield_BANG] = ACTIONS(3751),
    [anon_sym_lazy] = ACTIONS(3753),
    [anon_sym_assert] = ACTIONS(3753),
    [anon_sym_upcast] = ACTIONS(3753),
    [anon_sym_downcast] = ACTIONS(3753),
    [anon_sym_COLON_GT] = ACTIONS(3751),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3751),
    [anon_sym_for] = ACTIONS(3753),
    [anon_sym_while] = ACTIONS(3753),
    [anon_sym_if] = ACTIONS(3753),
    [anon_sym_fun] = ACTIONS(3753),
    [anon_sym_try] = ACTIONS(3753),
    [anon_sym_match] = ACTIONS(3753),
    [anon_sym_match_BANG] = ACTIONS(3751),
    [anon_sym_function] = ACTIONS(3753),
    [anon_sym_LT_DASH] = ACTIONS(3753),
    [anon_sym_DOT_LBRACK] = ACTIONS(3751),
    [anon_sym_LT] = ACTIONS(3751),
    [anon_sym_use] = ACTIONS(3753),
    [anon_sym_use_BANG] = ACTIONS(3751),
    [anon_sym_do_BANG] = ACTIONS(3751),
    [anon_sym_begin] = ACTIONS(3753),
    [anon_sym_LPAREN2] = ACTIONS(3753),
    [anon_sym_default] = ACTIONS(3753),
    [anon_sym_or] = ACTIONS(3753),
    [anon_sym_static] = ACTIONS(3753),
    [anon_sym_member] = ACTIONS(3753),
    [anon_sym_interface] = ACTIONS(3753),
    [anon_sym_abstract] = ACTIONS(3753),
    [anon_sym_val] = ACTIONS(3753),
    [anon_sym_override] = ACTIONS(3753),
    [aux_sym_char_token1] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3753),
    [anon_sym_AT_DQUOTE] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [sym_bool] = ACTIONS(3753),
    [sym_unit] = ACTIONS(3751),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3753),
    [sym_op_identifier] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PLUS_DOT] = ACTIONS(3753),
    [anon_sym_DASH_DOT] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3753),
    [anon_sym_AMP_AMP] = ACTIONS(3753),
    [anon_sym_TILDE] = ACTIONS(3751),
    [aux_sym_prefix_op_token1] = ACTIONS(3753),
    [aux_sym_infix_op_token1] = ACTIONS(3751),
    [aux_sym_infix_op_token2] = ACTIONS(3753),
    [anon_sym_PIPE_PIPE] = ACTIONS(3753),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_COLON_EQ] = ACTIONS(3751),
    [anon_sym_DOLLAR] = ACTIONS(3753),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3753),
    [sym_int] = ACTIONS(4514),
    [sym_xint] = ACTIONS(3751),
    [anon_sym_f] = ACTIONS(3753),
    [aux_sym_decimal_token1] = ACTIONS(3753),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3751),
    [sym__newline] = ACTIONS(3751),
    [sym__dedent] = ACTIONS(3751),
  },
  [1596] = {
    [sym_block_comment] = STATE(1596),
    [sym_compiler_directive_decl] = STATE(1596),
    [sym_fsi_directive_decl] = STATE(1596),
    [sym_preproc_line] = STATE(1596),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_and] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [aux_sym_access_modifier_token1] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_member] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_val] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_f] = ACTIONS(3433),
    [aux_sym_decimal_token1] = ACTIONS(3333),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [anon_sym_POUNDendif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1597] = {
    [sym_block_comment] = STATE(1597),
    [sym_compiler_directive_decl] = STATE(1597),
    [sym_fsi_directive_decl] = STATE(1597),
    [sym_preproc_line] = STATE(1597),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_LBRACK_LT] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [aux_sym_access_modifier_token1] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_done] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_DOT_DOT] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_default] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [anon_sym_static] = ACTIONS(3700),
    [anon_sym_member] = ACTIONS(3700),
    [anon_sym_interface] = ACTIONS(3700),
    [anon_sym_abstract] = ACTIONS(3700),
    [anon_sym_val] = ACTIONS(3700),
    [anon_sym_override] = ACTIONS(3700),
    [anon_sym_inherit] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [anon_sym_POUNDendif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [1598] = {
    [sym_block_comment] = STATE(1598),
    [sym_compiler_directive_decl] = STATE(1598),
    [sym_fsi_directive_decl] = STATE(1598),
    [sym_preproc_line] = STATE(1598),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_and] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [aux_sym_access_modifier_token1] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_member] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_val] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_f] = ACTIONS(3437),
    [aux_sym_decimal_token1] = ACTIONS(3361),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
    [sym__dedent] = ACTIONS(3191),
  },
  [1599] = {
    [sym_block_comment] = STATE(1599),
    [sym_compiler_directive_decl] = STATE(1599),
    [sym_fsi_directive_decl] = STATE(1599),
    [sym_preproc_line] = STATE(1599),
    [aux_sym_rules_repeat1] = STATE(1604),
    [sym_identifier] = ACTIONS(3676),
    [anon_sym_EQ] = ACTIONS(3674),
    [anon_sym_LBRACK_LT] = ACTIONS(3674),
    [anon_sym_COLON] = ACTIONS(3676),
    [anon_sym_return] = ACTIONS(3676),
    [anon_sym_do] = ACTIONS(3676),
    [anon_sym_let] = ACTIONS(3676),
    [anon_sym_let_BANG] = ACTIONS(3674),
    [aux_sym_access_modifier_token1] = ACTIONS(3674),
    [anon_sym_LPAREN] = ACTIONS(3676),
    [anon_sym_COMMA] = ACTIONS(3674),
    [anon_sym_null] = ACTIONS(3676),
    [anon_sym_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_COLON] = ACTIONS(3674),
    [anon_sym_PIPE] = ACTIONS(4516),
    [anon_sym_AMP] = ACTIONS(3676),
    [anon_sym_LBRACK] = ACTIONS(3676),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3674),
    [anon_sym_LBRACE] = ACTIONS(3676),
    [anon_sym_LT_AT] = ACTIONS(3676),
    [anon_sym_LT_AT_AT] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3674),
    [anon_sym_new] = ACTIONS(3676),
    [anon_sym_with] = ACTIONS(3676),
    [anon_sym_return_BANG] = ACTIONS(3674),
    [anon_sym_yield] = ACTIONS(3676),
    [anon_sym_yield_BANG] = ACTIONS(3674),
    [anon_sym_lazy] = ACTIONS(3676),
    [anon_sym_assert] = ACTIONS(3676),
    [anon_sym_upcast] = ACTIONS(3676),
    [anon_sym_downcast] = ACTIONS(3676),
    [anon_sym_COLON_GT] = ACTIONS(3674),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3674),
    [anon_sym_for] = ACTIONS(3676),
    [anon_sym_while] = ACTIONS(3676),
    [anon_sym_if] = ACTIONS(3676),
    [anon_sym_fun] = ACTIONS(3676),
    [anon_sym_try] = ACTIONS(3676),
    [anon_sym_match] = ACTIONS(3676),
    [anon_sym_match_BANG] = ACTIONS(3674),
    [anon_sym_function] = ACTIONS(3676),
    [anon_sym_LT_DASH] = ACTIONS(3676),
    [anon_sym_DOT_LBRACK] = ACTIONS(3674),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_use] = ACTIONS(3676),
    [anon_sym_use_BANG] = ACTIONS(3674),
    [anon_sym_do_BANG] = ACTIONS(3674),
    [anon_sym_begin] = ACTIONS(3676),
    [anon_sym_LPAREN2] = ACTIONS(3676),
    [anon_sym_default] = ACTIONS(3676),
    [anon_sym_or] = ACTIONS(3676),
    [anon_sym_static] = ACTIONS(3676),
    [anon_sym_member] = ACTIONS(3676),
    [anon_sym_interface] = ACTIONS(3676),
    [anon_sym_abstract] = ACTIONS(3676),
    [anon_sym_val] = ACTIONS(3676),
    [anon_sym_override] = ACTIONS(3676),
    [anon_sym_inherit] = ACTIONS(3676),
    [aux_sym_char_token1] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3676),
    [anon_sym_DQUOTE] = ACTIONS(3676),
    [anon_sym_AT_DQUOTE] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [sym_bool] = ACTIONS(3676),
    [sym_unit] = ACTIONS(3674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3676),
    [sym_op_identifier] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_PLUS_DOT] = ACTIONS(3676),
    [anon_sym_DASH_DOT] = ACTIONS(3676),
    [anon_sym_PERCENT] = ACTIONS(3676),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_TILDE] = ACTIONS(3674),
    [aux_sym_prefix_op_token1] = ACTIONS(3676),
    [aux_sym_infix_op_token1] = ACTIONS(3674),
    [aux_sym_infix_op_token2] = ACTIONS(3676),
    [anon_sym_PIPE_PIPE] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3676),
    [anon_sym_COLON_EQ] = ACTIONS(3674),
    [anon_sym_DOLLAR] = ACTIONS(3676),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3676),
    [sym_int] = ACTIONS(3676),
    [sym_xint] = ACTIONS(3674),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3674),
    [anon_sym_POUNDendif] = ACTIONS(3674),
    [sym__newline] = ACTIONS(4518),
  },
  [1600] = {
    [sym_block_comment] = STATE(1600),
    [sym_compiler_directive_decl] = STATE(1600),
    [sym_fsi_directive_decl] = STATE(1600),
    [sym_preproc_line] = STATE(1600),
    [aux_sym_rules_repeat1] = STATE(1642),
    [sym_identifier] = ACTIONS(3736),
    [anon_sym_EQ] = ACTIONS(3734),
    [anon_sym_LBRACK_LT] = ACTIONS(3734),
    [anon_sym_COLON] = ACTIONS(3736),
    [anon_sym_return] = ACTIONS(3736),
    [anon_sym_do] = ACTIONS(3736),
    [anon_sym_and] = ACTIONS(3736),
    [anon_sym_let] = ACTIONS(3736),
    [anon_sym_let_BANG] = ACTIONS(3734),
    [aux_sym_access_modifier_token1] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3736),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_null] = ACTIONS(3736),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_COLON] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(4521),
    [anon_sym_AMP] = ACTIONS(3736),
    [anon_sym_LBRACK] = ACTIONS(3736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3734),
    [anon_sym_LBRACE] = ACTIONS(3736),
    [anon_sym_LT_AT] = ACTIONS(3736),
    [anon_sym_LT_AT_AT] = ACTIONS(3736),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3734),
    [anon_sym_new] = ACTIONS(3736),
    [anon_sym_with] = ACTIONS(3736),
    [anon_sym_return_BANG] = ACTIONS(3734),
    [anon_sym_yield] = ACTIONS(3736),
    [anon_sym_yield_BANG] = ACTIONS(3734),
    [anon_sym_lazy] = ACTIONS(3736),
    [anon_sym_assert] = ACTIONS(3736),
    [anon_sym_upcast] = ACTIONS(3736),
    [anon_sym_downcast] = ACTIONS(3736),
    [anon_sym_COLON_GT] = ACTIONS(3734),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3734),
    [anon_sym_for] = ACTIONS(3736),
    [anon_sym_while] = ACTIONS(3736),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_fun] = ACTIONS(3736),
    [anon_sym_try] = ACTIONS(3736),
    [anon_sym_match] = ACTIONS(3736),
    [anon_sym_match_BANG] = ACTIONS(3734),
    [anon_sym_function] = ACTIONS(3736),
    [anon_sym_LT_DASH] = ACTIONS(3736),
    [anon_sym_DOT_LBRACK] = ACTIONS(3734),
    [anon_sym_LT] = ACTIONS(3734),
    [anon_sym_use] = ACTIONS(3736),
    [anon_sym_use_BANG] = ACTIONS(3734),
    [anon_sym_do_BANG] = ACTIONS(3734),
    [anon_sym_begin] = ACTIONS(3736),
    [anon_sym_LPAREN2] = ACTIONS(3736),
    [anon_sym_default] = ACTIONS(3736),
    [anon_sym_or] = ACTIONS(3736),
    [anon_sym_static] = ACTIONS(3736),
    [anon_sym_member] = ACTIONS(3736),
    [anon_sym_interface] = ACTIONS(3736),
    [anon_sym_abstract] = ACTIONS(3736),
    [anon_sym_val] = ACTIONS(3736),
    [anon_sym_override] = ACTIONS(3736),
    [aux_sym_char_token1] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3736),
    [anon_sym_DQUOTE] = ACTIONS(3736),
    [anon_sym_AT_DQUOTE] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [sym_bool] = ACTIONS(3736),
    [sym_unit] = ACTIONS(3734),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3736),
    [sym_op_identifier] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS_DOT] = ACTIONS(3736),
    [anon_sym_DASH_DOT] = ACTIONS(3736),
    [anon_sym_PERCENT] = ACTIONS(3736),
    [anon_sym_AMP_AMP] = ACTIONS(3736),
    [anon_sym_TILDE] = ACTIONS(3734),
    [aux_sym_prefix_op_token1] = ACTIONS(3736),
    [aux_sym_infix_op_token1] = ACTIONS(3734),
    [aux_sym_infix_op_token2] = ACTIONS(3736),
    [anon_sym_PIPE_PIPE] = ACTIONS(3736),
    [anon_sym_BANG_EQ] = ACTIONS(3736),
    [anon_sym_COLON_EQ] = ACTIONS(3734),
    [anon_sym_DOLLAR] = ACTIONS(3736),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3736),
    [sym_int] = ACTIONS(3736),
    [sym_xint] = ACTIONS(3734),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3734),
    [sym__newline] = ACTIONS(4523),
    [sym__dedent] = ACTIONS(3734),
  },
  [1601] = {
    [sym_type_arguments] = STATE(2257),
    [sym_long_identifier] = STATE(2259),
    [sym_block_comment] = STATE(1601),
    [sym_compiler_directive_decl] = STATE(1601),
    [sym_fsi_directive_decl] = STATE(1601),
    [sym_preproc_line] = STATE(1601),
    [aux_sym_compound_type_repeat1] = STATE(2191),
    [ts_builtin_sym_end] = ACTIONS(3417),
    [sym_identifier] = ACTIONS(4526),
    [anon_sym_namespace] = ACTIONS(3419),
    [anon_sym_module] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(3417),
    [anon_sym_open] = ACTIONS(3419),
    [anon_sym_LBRACK_LT] = ACTIONS(3417),
    [anon_sym_COLON] = ACTIONS(3419),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_type] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_let] = ACTIONS(3419),
    [anon_sym_let_BANG] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(3419),
    [anon_sym_COMMA] = ACTIONS(3417),
    [anon_sym_null] = ACTIONS(3419),
    [anon_sym_QMARK] = ACTIONS(3419),
    [anon_sym_COLON_QMARK] = ACTIONS(3419),
    [anon_sym_COLON_COLON] = ACTIONS(3417),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_LT_AT] = ACTIONS(3419),
    [anon_sym_LT_AT_AT] = ACTIONS(3419),
    [anon_sym_DOT] = ACTIONS(3419),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_return_BANG] = ACTIONS(3417),
    [anon_sym_yield] = ACTIONS(3419),
    [anon_sym_yield_BANG] = ACTIONS(3417),
    [anon_sym_lazy] = ACTIONS(3419),
    [anon_sym_assert] = ACTIONS(3419),
    [anon_sym_upcast] = ACTIONS(3419),
    [anon_sym_downcast] = ACTIONS(3419),
    [anon_sym_COLON_GT] = ACTIONS(3417),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3417),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_fun] = ACTIONS(3419),
    [anon_sym_DASH_GT] = ACTIONS(4528),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_match] = ACTIONS(3419),
    [anon_sym_match_BANG] = ACTIONS(3417),
    [anon_sym_function] = ACTIONS(3419),
    [anon_sym_LT_DASH] = ACTIONS(3419),
    [anon_sym_DOT_LBRACK] = ACTIONS(3417),
    [anon_sym_LT] = ACTIONS(3417),
    [anon_sym_use] = ACTIONS(3419),
    [anon_sym_use_BANG] = ACTIONS(3417),
    [anon_sym_do_BANG] = ACTIONS(3417),
    [anon_sym_begin] = ACTIONS(3419),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(4530),
    [anon_sym_LT2] = ACTIONS(4532),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4534),
    [anon_sym_or] = ACTIONS(3419),
    [anon_sym_exception] = ACTIONS(3419),
    [aux_sym_char_token1] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3419),
    [anon_sym_AT_DQUOTE] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [sym_bool] = ACTIONS(3419),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3419),
    [sym_op_identifier] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_PLUS_DOT] = ACTIONS(3419),
    [anon_sym_DASH_DOT] = ACTIONS(3419),
    [anon_sym_PERCENT] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3419),
    [anon_sym_TILDE] = ACTIONS(3417),
    [aux_sym_prefix_op_token1] = ACTIONS(3419),
    [aux_sym_infix_op_token1] = ACTIONS(3417),
    [aux_sym_infix_op_token2] = ACTIONS(3419),
    [anon_sym_PIPE_PIPE] = ACTIONS(3419),
    [anon_sym_BANG_EQ] = ACTIONS(3419),
    [anon_sym_COLON_EQ] = ACTIONS(3417),
    [anon_sym_DOLLAR] = ACTIONS(3419),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3419),
    [sym_int] = ACTIONS(3419),
    [sym_xint] = ACTIONS(3417),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3417),
    [anon_sym_POUNDload] = ACTIONS(3417),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3417),
    [sym__newline] = ACTIONS(3417),
  },
  [1602] = {
    [sym_block_comment] = STATE(1602),
    [sym_compiler_directive_decl] = STATE(1602),
    [sym_fsi_directive_decl] = STATE(1602),
    [sym_preproc_line] = STATE(1602),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_LBRACK_LT] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_and] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [aux_sym_access_modifier_token1] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_with] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_default] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [anon_sym_static] = ACTIONS(3604),
    [anon_sym_member] = ACTIONS(3604),
    [anon_sym_interface] = ACTIONS(3604),
    [anon_sym_abstract] = ACTIONS(3604),
    [anon_sym_val] = ACTIONS(3604),
    [anon_sym_override] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [anon_sym_POUNDendif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
  },
  [1603] = {
    [sym_block_comment] = STATE(1603),
    [sym_compiler_directive_decl] = STATE(1603),
    [sym_fsi_directive_decl] = STATE(1603),
    [sym_preproc_line] = STATE(1603),
    [aux_sym_long_identifier_repeat1] = STATE(1603),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [aux_sym_access_modifier_token1] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(4536),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_member] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_val] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [anon_sym_inherit] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [anon_sym_POUNDendif] = ACTIONS(3485),
    [anon_sym_POUNDelse] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [1604] = {
    [sym_block_comment] = STATE(1604),
    [sym_compiler_directive_decl] = STATE(1604),
    [sym_fsi_directive_decl] = STATE(1604),
    [sym_preproc_line] = STATE(1604),
    [aux_sym_rules_repeat1] = STATE(1604),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_LBRACK_LT] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [aux_sym_access_modifier_token1] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(4539),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_with] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_default] = ACTIONS(3743),
    [anon_sym_or] = ACTIONS(3743),
    [anon_sym_static] = ACTIONS(3743),
    [anon_sym_member] = ACTIONS(3743),
    [anon_sym_interface] = ACTIONS(3743),
    [anon_sym_abstract] = ACTIONS(3743),
    [anon_sym_val] = ACTIONS(3743),
    [anon_sym_override] = ACTIONS(3743),
    [anon_sym_inherit] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [anon_sym_POUNDendif] = ACTIONS(3741),
    [sym__newline] = ACTIONS(4542),
  },
  [1605] = {
    [sym_block_comment] = STATE(1605),
    [sym_compiler_directive_decl] = STATE(1605),
    [sym_fsi_directive_decl] = STATE(1605),
    [sym_preproc_line] = STATE(1605),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_DASH_GT] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_DOT_DOT] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(4293),
    [anon_sym_uy] = ACTIONS(4295),
    [anon_sym_s] = ACTIONS(4297),
    [anon_sym_us] = ACTIONS(4299),
    [anon_sym_l] = ACTIONS(4301),
    [aux_sym_uint32_token1] = ACTIONS(4303),
    [anon_sym_n] = ACTIONS(4305),
    [anon_sym_un] = ACTIONS(4307),
    [anon_sym_L] = ACTIONS(4309),
    [aux_sym_uint64_token1] = ACTIONS(4311),
    [anon_sym_lf] = ACTIONS(4545),
    [anon_sym_LF] = ACTIONS(4547),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1606] = {
    [sym_block_comment] = STATE(1606),
    [sym_compiler_directive_decl] = STATE(1606),
    [sym_fsi_directive_decl] = STATE(1606),
    [sym_preproc_line] = STATE(1606),
    [sym_identifier] = ACTIONS(3728),
    [anon_sym_EQ] = ACTIONS(3726),
    [anon_sym_LBRACK_LT] = ACTIONS(3726),
    [anon_sym_COLON] = ACTIONS(3728),
    [anon_sym_return] = ACTIONS(3728),
    [anon_sym_do] = ACTIONS(3728),
    [anon_sym_and] = ACTIONS(3728),
    [anon_sym_let] = ACTIONS(3728),
    [anon_sym_let_BANG] = ACTIONS(3726),
    [aux_sym_access_modifier_token1] = ACTIONS(3726),
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_COMMA] = ACTIONS(3726),
    [anon_sym_null] = ACTIONS(3728),
    [anon_sym_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(3726),
    [anon_sym_AMP] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3726),
    [anon_sym_LBRACE] = ACTIONS(3728),
    [anon_sym_LT_AT] = ACTIONS(3728),
    [anon_sym_LT_AT_AT] = ACTIONS(3728),
    [anon_sym_DOT] = ACTIONS(3728),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3726),
    [anon_sym_new] = ACTIONS(3728),
    [anon_sym_with] = ACTIONS(3728),
    [anon_sym_return_BANG] = ACTIONS(3726),
    [anon_sym_yield] = ACTIONS(3728),
    [anon_sym_yield_BANG] = ACTIONS(3726),
    [anon_sym_lazy] = ACTIONS(3728),
    [anon_sym_assert] = ACTIONS(3728),
    [anon_sym_upcast] = ACTIONS(3728),
    [anon_sym_downcast] = ACTIONS(3728),
    [anon_sym_COLON_GT] = ACTIONS(3726),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3726),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_fun] = ACTIONS(3728),
    [anon_sym_try] = ACTIONS(3728),
    [anon_sym_match] = ACTIONS(3728),
    [anon_sym_match_BANG] = ACTIONS(3726),
    [anon_sym_function] = ACTIONS(3728),
    [anon_sym_LT_DASH] = ACTIONS(3728),
    [anon_sym_DOT_LBRACK] = ACTIONS(3726),
    [anon_sym_LT] = ACTIONS(3726),
    [anon_sym_use] = ACTIONS(3728),
    [anon_sym_use_BANG] = ACTIONS(3726),
    [anon_sym_do_BANG] = ACTIONS(3726),
    [anon_sym_begin] = ACTIONS(3728),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_default] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [anon_sym_static] = ACTIONS(3728),
    [anon_sym_member] = ACTIONS(3728),
    [anon_sym_interface] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(3728),
    [anon_sym_val] = ACTIONS(3728),
    [anon_sym_override] = ACTIONS(3728),
    [aux_sym_char_token1] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3728),
    [anon_sym_AT_DQUOTE] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [sym_bool] = ACTIONS(3728),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3728),
    [sym_op_identifier] = ACTIONS(3728),
    [anon_sym_PLUS] = ACTIONS(3728),
    [anon_sym_DASH] = ACTIONS(3728),
    [anon_sym_PLUS_DOT] = ACTIONS(3728),
    [anon_sym_DASH_DOT] = ACTIONS(3728),
    [anon_sym_PERCENT] = ACTIONS(3728),
    [anon_sym_AMP_AMP] = ACTIONS(3728),
    [anon_sym_TILDE] = ACTIONS(3726),
    [aux_sym_prefix_op_token1] = ACTIONS(3728),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token2] = ACTIONS(3728),
    [anon_sym_PIPE_PIPE] = ACTIONS(3728),
    [anon_sym_BANG_EQ] = ACTIONS(3728),
    [anon_sym_COLON_EQ] = ACTIONS(3726),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3728),
    [sym_int] = ACTIONS(3728),
    [sym_xint] = ACTIONS(3726),
    [anon_sym_f] = ACTIONS(3728),
    [aux_sym_decimal_token1] = ACTIONS(3728),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3726),
    [sym__newline] = ACTIONS(3726),
    [sym__dedent] = ACTIONS(3726),
  },
  [1607] = {
    [sym_block_comment] = STATE(1607),
    [sym_compiler_directive_decl] = STATE(1607),
    [sym_fsi_directive_decl] = STATE(1607),
    [sym_preproc_line] = STATE(1607),
    [sym_identifier] = ACTIONS(3813),
    [anon_sym_EQ] = ACTIONS(3811),
    [anon_sym_LBRACK_LT] = ACTIONS(3811),
    [anon_sym_COLON] = ACTIONS(3813),
    [anon_sym_return] = ACTIONS(3813),
    [anon_sym_do] = ACTIONS(3813),
    [anon_sym_let] = ACTIONS(3813),
    [anon_sym_let_BANG] = ACTIONS(3811),
    [aux_sym_access_modifier_token1] = ACTIONS(3811),
    [anon_sym_LPAREN] = ACTIONS(3813),
    [anon_sym_COMMA] = ACTIONS(3811),
    [anon_sym_null] = ACTIONS(3813),
    [anon_sym_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_COLON] = ACTIONS(3811),
    [anon_sym_AMP] = ACTIONS(3813),
    [anon_sym_LBRACK] = ACTIONS(3813),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3811),
    [anon_sym_LBRACE] = ACTIONS(3813),
    [anon_sym_LT_AT] = ACTIONS(3813),
    [anon_sym_LT_AT_AT] = ACTIONS(3813),
    [anon_sym_DOT] = ACTIONS(3813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3811),
    [anon_sym_new] = ACTIONS(3813),
    [anon_sym_with] = ACTIONS(3813),
    [anon_sym_return_BANG] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_yield_BANG] = ACTIONS(3811),
    [anon_sym_lazy] = ACTIONS(3813),
    [anon_sym_assert] = ACTIONS(3813),
    [anon_sym_upcast] = ACTIONS(3813),
    [anon_sym_downcast] = ACTIONS(3813),
    [anon_sym_COLON_GT] = ACTIONS(3811),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3811),
    [anon_sym_for] = ACTIONS(3813),
    [anon_sym_done] = ACTIONS(4549),
    [anon_sym_while] = ACTIONS(3813),
    [anon_sym_if] = ACTIONS(3813),
    [anon_sym_fun] = ACTIONS(3813),
    [anon_sym_try] = ACTIONS(3813),
    [anon_sym_match] = ACTIONS(3813),
    [anon_sym_match_BANG] = ACTIONS(3811),
    [anon_sym_function] = ACTIONS(3813),
    [anon_sym_LT_DASH] = ACTIONS(3813),
    [anon_sym_DOT_LBRACK] = ACTIONS(3811),
    [anon_sym_LT] = ACTIONS(3811),
    [anon_sym_use] = ACTIONS(3813),
    [anon_sym_use_BANG] = ACTIONS(3811),
    [anon_sym_do_BANG] = ACTIONS(3811),
    [anon_sym_begin] = ACTIONS(3813),
    [anon_sym_LPAREN2] = ACTIONS(3813),
    [anon_sym_default] = ACTIONS(3813),
    [anon_sym_or] = ACTIONS(3813),
    [anon_sym_static] = ACTIONS(3813),
    [anon_sym_member] = ACTIONS(3813),
    [anon_sym_interface] = ACTIONS(3813),
    [anon_sym_abstract] = ACTIONS(3813),
    [anon_sym_val] = ACTIONS(3813),
    [anon_sym_override] = ACTIONS(3813),
    [anon_sym_inherit] = ACTIONS(3813),
    [aux_sym_char_token1] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3813),
    [anon_sym_DQUOTE] = ACTIONS(3813),
    [anon_sym_AT_DQUOTE] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [sym_bool] = ACTIONS(3813),
    [sym_unit] = ACTIONS(3811),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3813),
    [sym_op_identifier] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PLUS_DOT] = ACTIONS(3813),
    [anon_sym_DASH_DOT] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3813),
    [anon_sym_AMP_AMP] = ACTIONS(3813),
    [anon_sym_TILDE] = ACTIONS(3811),
    [aux_sym_prefix_op_token1] = ACTIONS(3813),
    [aux_sym_infix_op_token1] = ACTIONS(3811),
    [aux_sym_infix_op_token2] = ACTIONS(3813),
    [anon_sym_PIPE_PIPE] = ACTIONS(3813),
    [anon_sym_BANG_EQ] = ACTIONS(3813),
    [anon_sym_COLON_EQ] = ACTIONS(3811),
    [anon_sym_DOLLAR] = ACTIONS(3813),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3813),
    [sym_int] = ACTIONS(3813),
    [sym_xint] = ACTIONS(3811),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3811),
    [anon_sym_POUNDendif] = ACTIONS(3811),
    [anon_sym_POUNDelse] = ACTIONS(3811),
    [sym__newline] = ACTIONS(3811),
  },
  [1608] = {
    [sym_block_comment] = STATE(1608),
    [sym_compiler_directive_decl] = STATE(1608),
    [sym_fsi_directive_decl] = STATE(1608),
    [sym_preproc_line] = STATE(1608),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_EQ] = ACTIONS(3646),
    [anon_sym_LBRACK_LT] = ACTIONS(3646),
    [anon_sym_COLON] = ACTIONS(3648),
    [anon_sym_return] = ACTIONS(3648),
    [anon_sym_do] = ACTIONS(3648),
    [anon_sym_and] = ACTIONS(3648),
    [anon_sym_let] = ACTIONS(3648),
    [anon_sym_let_BANG] = ACTIONS(3646),
    [aux_sym_access_modifier_token1] = ACTIONS(3646),
    [anon_sym_LPAREN] = ACTIONS(3648),
    [anon_sym_COMMA] = ACTIONS(3646),
    [anon_sym_null] = ACTIONS(3648),
    [anon_sym_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_COLON] = ACTIONS(3646),
    [anon_sym_AMP] = ACTIONS(3648),
    [anon_sym_LBRACK] = ACTIONS(3648),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3646),
    [anon_sym_LBRACE] = ACTIONS(3648),
    [anon_sym_LT_AT] = ACTIONS(3648),
    [anon_sym_LT_AT_AT] = ACTIONS(3648),
    [anon_sym_DOT] = ACTIONS(3648),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3646),
    [anon_sym_new] = ACTIONS(3648),
    [anon_sym_with] = ACTIONS(3648),
    [anon_sym_return_BANG] = ACTIONS(3646),
    [anon_sym_yield] = ACTIONS(3648),
    [anon_sym_yield_BANG] = ACTIONS(3646),
    [anon_sym_lazy] = ACTIONS(3648),
    [anon_sym_assert] = ACTIONS(3648),
    [anon_sym_upcast] = ACTIONS(3648),
    [anon_sym_downcast] = ACTIONS(3648),
    [anon_sym_COLON_GT] = ACTIONS(3646),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3646),
    [anon_sym_for] = ACTIONS(3648),
    [anon_sym_while] = ACTIONS(3648),
    [anon_sym_else] = ACTIONS(3648),
    [anon_sym_elif] = ACTIONS(3648),
    [anon_sym_if] = ACTIONS(3648),
    [anon_sym_fun] = ACTIONS(3648),
    [anon_sym_try] = ACTIONS(3648),
    [anon_sym_match] = ACTIONS(3648),
    [anon_sym_match_BANG] = ACTIONS(3646),
    [anon_sym_function] = ACTIONS(3648),
    [anon_sym_LT_DASH] = ACTIONS(3648),
    [anon_sym_DOT_LBRACK] = ACTIONS(3646),
    [anon_sym_LT] = ACTIONS(3646),
    [anon_sym_use] = ACTIONS(3648),
    [anon_sym_use_BANG] = ACTIONS(3646),
    [anon_sym_do_BANG] = ACTIONS(3646),
    [anon_sym_begin] = ACTIONS(3648),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_default] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3648),
    [anon_sym_static] = ACTIONS(3648),
    [anon_sym_member] = ACTIONS(3648),
    [anon_sym_interface] = ACTIONS(3648),
    [anon_sym_abstract] = ACTIONS(3648),
    [anon_sym_val] = ACTIONS(3648),
    [anon_sym_override] = ACTIONS(3648),
    [aux_sym_char_token1] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3648),
    [anon_sym_AT_DQUOTE] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [sym_bool] = ACTIONS(3648),
    [sym_unit] = ACTIONS(3646),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3648),
    [sym_op_identifier] = ACTIONS(3648),
    [anon_sym_PLUS] = ACTIONS(3648),
    [anon_sym_DASH] = ACTIONS(3648),
    [anon_sym_PLUS_DOT] = ACTIONS(3648),
    [anon_sym_DASH_DOT] = ACTIONS(3648),
    [anon_sym_PERCENT] = ACTIONS(3648),
    [anon_sym_AMP_AMP] = ACTIONS(3648),
    [anon_sym_TILDE] = ACTIONS(3646),
    [aux_sym_prefix_op_token1] = ACTIONS(3648),
    [aux_sym_infix_op_token1] = ACTIONS(3646),
    [aux_sym_infix_op_token2] = ACTIONS(3648),
    [anon_sym_PIPE_PIPE] = ACTIONS(3648),
    [anon_sym_BANG_EQ] = ACTIONS(3648),
    [anon_sym_COLON_EQ] = ACTIONS(3646),
    [anon_sym_DOLLAR] = ACTIONS(3648),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3648),
    [sym_int] = ACTIONS(3648),
    [sym_xint] = ACTIONS(3646),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3646),
    [sym__newline] = ACTIONS(3646),
    [sym__dedent] = ACTIONS(3646),
  },
  [1609] = {
    [sym_block_comment] = STATE(1609),
    [sym_compiler_directive_decl] = STATE(1609),
    [sym_fsi_directive_decl] = STATE(1609),
    [sym_preproc_line] = STATE(1609),
    [sym_identifier] = ACTIONS(3753),
    [anon_sym_EQ] = ACTIONS(3751),
    [anon_sym_LBRACK_LT] = ACTIONS(3751),
    [anon_sym_COLON] = ACTIONS(3753),
    [anon_sym_return] = ACTIONS(3753),
    [anon_sym_do] = ACTIONS(3753),
    [anon_sym_let] = ACTIONS(3753),
    [anon_sym_let_BANG] = ACTIONS(3751),
    [aux_sym_access_modifier_token1] = ACTIONS(3751),
    [anon_sym_LPAREN] = ACTIONS(3753),
    [anon_sym_COMMA] = ACTIONS(3751),
    [anon_sym_null] = ACTIONS(3753),
    [anon_sym_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_COLON] = ACTIONS(3751),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3751),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_LT_AT] = ACTIONS(3753),
    [anon_sym_LT_AT_AT] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3753),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3751),
    [anon_sym_new] = ACTIONS(3753),
    [anon_sym_with] = ACTIONS(3753),
    [anon_sym_return_BANG] = ACTIONS(3751),
    [anon_sym_yield] = ACTIONS(3753),
    [anon_sym_yield_BANG] = ACTIONS(3751),
    [anon_sym_lazy] = ACTIONS(3753),
    [anon_sym_assert] = ACTIONS(3753),
    [anon_sym_upcast] = ACTIONS(3753),
    [anon_sym_downcast] = ACTIONS(3753),
    [anon_sym_COLON_GT] = ACTIONS(3751),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3751),
    [anon_sym_for] = ACTIONS(3753),
    [anon_sym_while] = ACTIONS(3753),
    [anon_sym_if] = ACTIONS(3753),
    [anon_sym_fun] = ACTIONS(3753),
    [anon_sym_try] = ACTIONS(3753),
    [anon_sym_match] = ACTIONS(3753),
    [anon_sym_match_BANG] = ACTIONS(3751),
    [anon_sym_function] = ACTIONS(3753),
    [anon_sym_LT_DASH] = ACTIONS(3753),
    [anon_sym_DOT_LBRACK] = ACTIONS(3751),
    [anon_sym_LT] = ACTIONS(3751),
    [anon_sym_use] = ACTIONS(3753),
    [anon_sym_use_BANG] = ACTIONS(3751),
    [anon_sym_do_BANG] = ACTIONS(3751),
    [anon_sym_begin] = ACTIONS(3753),
    [anon_sym_LPAREN2] = ACTIONS(3753),
    [anon_sym_default] = ACTIONS(3753),
    [anon_sym_or] = ACTIONS(3753),
    [anon_sym_static] = ACTIONS(3753),
    [anon_sym_member] = ACTIONS(3753),
    [anon_sym_interface] = ACTIONS(3753),
    [anon_sym_abstract] = ACTIONS(3753),
    [anon_sym_val] = ACTIONS(3753),
    [anon_sym_override] = ACTIONS(3753),
    [anon_sym_inherit] = ACTIONS(3753),
    [aux_sym_char_token1] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3753),
    [anon_sym_AT_DQUOTE] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [sym_bool] = ACTIONS(3753),
    [sym_unit] = ACTIONS(3751),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3753),
    [sym_op_identifier] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PLUS_DOT] = ACTIONS(3753),
    [anon_sym_DASH_DOT] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3753),
    [anon_sym_AMP_AMP] = ACTIONS(3753),
    [anon_sym_TILDE] = ACTIONS(3751),
    [aux_sym_prefix_op_token1] = ACTIONS(3753),
    [aux_sym_infix_op_token1] = ACTIONS(3751),
    [aux_sym_infix_op_token2] = ACTIONS(3753),
    [anon_sym_PIPE_PIPE] = ACTIONS(3753),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_COLON_EQ] = ACTIONS(3751),
    [anon_sym_DOLLAR] = ACTIONS(3753),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3753),
    [sym_int] = ACTIONS(4551),
    [sym_xint] = ACTIONS(3751),
    [anon_sym_f] = ACTIONS(3753),
    [aux_sym_decimal_token1] = ACTIONS(3753),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3751),
    [anon_sym_POUNDendif] = ACTIONS(3751),
    [sym__newline] = ACTIONS(3751),
  },
  [1610] = {
    [sym_type_arguments] = STATE(2244),
    [sym_long_identifier] = STATE(2231),
    [sym_block_comment] = STATE(1610),
    [sym_compiler_directive_decl] = STATE(1610),
    [sym_fsi_directive_decl] = STATE(1610),
    [sym_preproc_line] = STATE(1610),
    [aux_sym_compound_type_repeat1] = STATE(2219),
    [sym_identifier] = ACTIONS(4553),
    [anon_sym_EQ] = ACTIONS(3417),
    [anon_sym_GT_RBRACK] = ACTIONS(3417),
    [anon_sym_COLON] = ACTIONS(3419),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_let] = ACTIONS(3419),
    [anon_sym_let_BANG] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(3419),
    [anon_sym_COMMA] = ACTIONS(3417),
    [anon_sym_null] = ACTIONS(3419),
    [anon_sym_QMARK] = ACTIONS(3419),
    [anon_sym_COLON_QMARK] = ACTIONS(3419),
    [anon_sym_COLON_COLON] = ACTIONS(3417),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_RBRACK] = ACTIONS(3417),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_RBRACE] = ACTIONS(3417),
    [anon_sym_LT_AT] = ACTIONS(3419),
    [anon_sym_LT_AT_AT] = ACTIONS(3419),
    [anon_sym_DOT] = ACTIONS(3419),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_with] = ACTIONS(3419),
    [anon_sym_return_BANG] = ACTIONS(3417),
    [anon_sym_yield] = ACTIONS(3419),
    [anon_sym_yield_BANG] = ACTIONS(3417),
    [anon_sym_lazy] = ACTIONS(3419),
    [anon_sym_assert] = ACTIONS(3419),
    [anon_sym_upcast] = ACTIONS(3419),
    [anon_sym_downcast] = ACTIONS(3419),
    [anon_sym_COLON_GT] = ACTIONS(3417),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3417),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_to] = ACTIONS(3419),
    [anon_sym_downto] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_fun] = ACTIONS(3419),
    [anon_sym_DASH_GT] = ACTIONS(4555),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_match] = ACTIONS(3419),
    [anon_sym_match_BANG] = ACTIONS(3417),
    [anon_sym_function] = ACTIONS(3419),
    [anon_sym_LT_DASH] = ACTIONS(3419),
    [anon_sym_DOT_LBRACK] = ACTIONS(3417),
    [anon_sym_LT] = ACTIONS(3417),
    [anon_sym_use] = ACTIONS(3419),
    [anon_sym_use_BANG] = ACTIONS(3417),
    [anon_sym_do_BANG] = ACTIONS(3417),
    [anon_sym_begin] = ACTIONS(3419),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_DOT_DOT2] = ACTIONS(3417),
    [anon_sym_STAR] = ACTIONS(4557),
    [anon_sym_LT2] = ACTIONS(4559),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4561),
    [anon_sym_or] = ACTIONS(3419),
    [aux_sym_char_token1] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3419),
    [anon_sym_AT_DQUOTE] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [sym_bool] = ACTIONS(3419),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3419),
    [sym_op_identifier] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_PLUS_DOT] = ACTIONS(3419),
    [anon_sym_DASH_DOT] = ACTIONS(3419),
    [anon_sym_PERCENT] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3419),
    [anon_sym_TILDE] = ACTIONS(3417),
    [aux_sym_prefix_op_token1] = ACTIONS(3419),
    [aux_sym_infix_op_token1] = ACTIONS(3417),
    [aux_sym_infix_op_token2] = ACTIONS(3419),
    [anon_sym_PIPE_PIPE] = ACTIONS(3419),
    [anon_sym_BANG_EQ] = ACTIONS(3419),
    [anon_sym_COLON_EQ] = ACTIONS(3417),
    [anon_sym_DOLLAR] = ACTIONS(3419),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3419),
    [sym_int] = ACTIONS(3419),
    [sym_xint] = ACTIONS(3417),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3417),
    [sym__newline] = ACTIONS(3417),
  },
  [1611] = {
    [sym_type_arguments] = STATE(2244),
    [sym_long_identifier] = STATE(2231),
    [sym_block_comment] = STATE(1611),
    [sym_compiler_directive_decl] = STATE(1611),
    [sym_fsi_directive_decl] = STATE(1611),
    [sym_preproc_line] = STATE(1611),
    [aux_sym_compound_type_repeat1] = STATE(2219),
    [sym_identifier] = ACTIONS(3443),
    [anon_sym_EQ] = ACTIONS(3441),
    [anon_sym_GT_RBRACK] = ACTIONS(3441),
    [anon_sym_COLON] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_let] = ACTIONS(3443),
    [anon_sym_let_BANG] = ACTIONS(3441),
    [anon_sym_LPAREN] = ACTIONS(3443),
    [anon_sym_COMMA] = ACTIONS(3441),
    [anon_sym_null] = ACTIONS(3443),
    [anon_sym_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_RBRACK] = ACTIONS(3441),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_RBRACE] = ACTIONS(3441),
    [anon_sym_LT_AT] = ACTIONS(3443),
    [anon_sym_LT_AT_AT] = ACTIONS(3443),
    [anon_sym_DOT] = ACTIONS(3443),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_with] = ACTIONS(3443),
    [anon_sym_return_BANG] = ACTIONS(3441),
    [anon_sym_yield] = ACTIONS(3443),
    [anon_sym_yield_BANG] = ACTIONS(3441),
    [anon_sym_lazy] = ACTIONS(3443),
    [anon_sym_assert] = ACTIONS(3443),
    [anon_sym_upcast] = ACTIONS(3443),
    [anon_sym_downcast] = ACTIONS(3443),
    [anon_sym_COLON_GT] = ACTIONS(3441),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3441),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_to] = ACTIONS(3443),
    [anon_sym_downto] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_fun] = ACTIONS(3443),
    [anon_sym_DASH_GT] = ACTIONS(4555),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_match] = ACTIONS(3443),
    [anon_sym_match_BANG] = ACTIONS(3441),
    [anon_sym_function] = ACTIONS(3443),
    [anon_sym_LT_DASH] = ACTIONS(3443),
    [anon_sym_DOT_LBRACK] = ACTIONS(3441),
    [anon_sym_LT] = ACTIONS(3441),
    [anon_sym_use] = ACTIONS(3443),
    [anon_sym_use_BANG] = ACTIONS(3441),
    [anon_sym_do_BANG] = ACTIONS(3441),
    [anon_sym_begin] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3443),
    [anon_sym_DOT_DOT2] = ACTIONS(3441),
    [anon_sym_STAR] = ACTIONS(4557),
    [anon_sym_LT2] = ACTIONS(4559),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4561),
    [anon_sym_or] = ACTIONS(3443),
    [aux_sym_char_token1] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3443),
    [anon_sym_AT_DQUOTE] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [sym_bool] = ACTIONS(3443),
    [sym_unit] = ACTIONS(3441),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3443),
    [sym_op_identifier] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_PLUS_DOT] = ACTIONS(3443),
    [anon_sym_DASH_DOT] = ACTIONS(3443),
    [anon_sym_PERCENT] = ACTIONS(3443),
    [anon_sym_AMP_AMP] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3441),
    [aux_sym_prefix_op_token1] = ACTIONS(3443),
    [aux_sym_infix_op_token1] = ACTIONS(3441),
    [aux_sym_infix_op_token2] = ACTIONS(3443),
    [anon_sym_PIPE_PIPE] = ACTIONS(3443),
    [anon_sym_BANG_EQ] = ACTIONS(3443),
    [anon_sym_COLON_EQ] = ACTIONS(3441),
    [anon_sym_DOLLAR] = ACTIONS(3443),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3443),
    [sym_int] = ACTIONS(3443),
    [sym_xint] = ACTIONS(3441),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3441),
    [sym__newline] = ACTIONS(3441),
  },
  [1612] = {
    [sym_block_comment] = STATE(1612),
    [sym_compiler_directive_decl] = STATE(1612),
    [sym_fsi_directive_decl] = STATE(1612),
    [sym_preproc_line] = STATE(1612),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_EQ] = ACTIONS(3646),
    [anon_sym_LBRACK_LT] = ACTIONS(3646),
    [anon_sym_COLON] = ACTIONS(3648),
    [anon_sym_return] = ACTIONS(3648),
    [anon_sym_do] = ACTIONS(3648),
    [anon_sym_and] = ACTIONS(3648),
    [anon_sym_let] = ACTIONS(3648),
    [anon_sym_let_BANG] = ACTIONS(3646),
    [aux_sym_access_modifier_token1] = ACTIONS(3646),
    [anon_sym_LPAREN] = ACTIONS(3648),
    [anon_sym_COMMA] = ACTIONS(3646),
    [anon_sym_null] = ACTIONS(3648),
    [anon_sym_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_COLON] = ACTIONS(3646),
    [anon_sym_AMP] = ACTIONS(3648),
    [anon_sym_LBRACK] = ACTIONS(3648),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3646),
    [anon_sym_LBRACE] = ACTIONS(3648),
    [anon_sym_LT_AT] = ACTIONS(3648),
    [anon_sym_LT_AT_AT] = ACTIONS(3648),
    [anon_sym_DOT] = ACTIONS(3648),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3646),
    [anon_sym_new] = ACTIONS(3648),
    [anon_sym_with] = ACTIONS(3648),
    [anon_sym_return_BANG] = ACTIONS(3646),
    [anon_sym_yield] = ACTIONS(3648),
    [anon_sym_yield_BANG] = ACTIONS(3646),
    [anon_sym_lazy] = ACTIONS(3648),
    [anon_sym_assert] = ACTIONS(3648),
    [anon_sym_upcast] = ACTIONS(3648),
    [anon_sym_downcast] = ACTIONS(3648),
    [anon_sym_COLON_GT] = ACTIONS(3646),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3646),
    [anon_sym_for] = ACTIONS(3648),
    [anon_sym_while] = ACTIONS(3648),
    [anon_sym_else] = ACTIONS(3648),
    [anon_sym_elif] = ACTIONS(3648),
    [anon_sym_if] = ACTIONS(3648),
    [anon_sym_fun] = ACTIONS(3648),
    [anon_sym_try] = ACTIONS(3648),
    [anon_sym_match] = ACTIONS(3648),
    [anon_sym_match_BANG] = ACTIONS(3646),
    [anon_sym_function] = ACTIONS(3648),
    [anon_sym_LT_DASH] = ACTIONS(3648),
    [anon_sym_DOT_LBRACK] = ACTIONS(3646),
    [anon_sym_LT] = ACTIONS(3646),
    [anon_sym_use] = ACTIONS(3648),
    [anon_sym_use_BANG] = ACTIONS(3646),
    [anon_sym_do_BANG] = ACTIONS(3646),
    [anon_sym_begin] = ACTIONS(3648),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_default] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3648),
    [anon_sym_static] = ACTIONS(3648),
    [anon_sym_member] = ACTIONS(3648),
    [anon_sym_interface] = ACTIONS(3648),
    [anon_sym_abstract] = ACTIONS(3648),
    [anon_sym_val] = ACTIONS(3648),
    [anon_sym_override] = ACTIONS(3648),
    [aux_sym_char_token1] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3648),
    [anon_sym_AT_DQUOTE] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [sym_bool] = ACTIONS(3648),
    [sym_unit] = ACTIONS(3646),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3648),
    [sym_op_identifier] = ACTIONS(3648),
    [anon_sym_PLUS] = ACTIONS(3648),
    [anon_sym_DASH] = ACTIONS(3648),
    [anon_sym_PLUS_DOT] = ACTIONS(3648),
    [anon_sym_DASH_DOT] = ACTIONS(3648),
    [anon_sym_PERCENT] = ACTIONS(3648),
    [anon_sym_AMP_AMP] = ACTIONS(3648),
    [anon_sym_TILDE] = ACTIONS(3646),
    [aux_sym_prefix_op_token1] = ACTIONS(3648),
    [aux_sym_infix_op_token1] = ACTIONS(3646),
    [aux_sym_infix_op_token2] = ACTIONS(3648),
    [anon_sym_PIPE_PIPE] = ACTIONS(3648),
    [anon_sym_BANG_EQ] = ACTIONS(3648),
    [anon_sym_COLON_EQ] = ACTIONS(3646),
    [anon_sym_DOLLAR] = ACTIONS(3648),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3648),
    [sym_int] = ACTIONS(3648),
    [sym_xint] = ACTIONS(3646),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3646),
    [anon_sym_POUNDendif] = ACTIONS(3646),
    [sym__newline] = ACTIONS(3646),
  },
  [1613] = {
    [sym_block_comment] = STATE(1613),
    [sym_compiler_directive_decl] = STATE(1613),
    [sym_fsi_directive_decl] = STATE(1613),
    [sym_preproc_line] = STATE(1613),
    [sym_identifier] = ACTIONS(3728),
    [anon_sym_EQ] = ACTIONS(3726),
    [anon_sym_LBRACK_LT] = ACTIONS(3726),
    [anon_sym_COLON] = ACTIONS(3728),
    [anon_sym_return] = ACTIONS(3728),
    [anon_sym_do] = ACTIONS(3728),
    [anon_sym_let] = ACTIONS(3728),
    [anon_sym_let_BANG] = ACTIONS(3726),
    [aux_sym_access_modifier_token1] = ACTIONS(3726),
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_COMMA] = ACTIONS(3726),
    [anon_sym_null] = ACTIONS(3728),
    [anon_sym_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(3726),
    [anon_sym_AMP] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3726),
    [anon_sym_LBRACE] = ACTIONS(3728),
    [anon_sym_LT_AT] = ACTIONS(3728),
    [anon_sym_LT_AT_AT] = ACTIONS(3728),
    [anon_sym_DOT] = ACTIONS(3728),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3726),
    [anon_sym_new] = ACTIONS(3728),
    [anon_sym_with] = ACTIONS(3728),
    [anon_sym_return_BANG] = ACTIONS(3726),
    [anon_sym_yield] = ACTIONS(3728),
    [anon_sym_yield_BANG] = ACTIONS(3726),
    [anon_sym_lazy] = ACTIONS(3728),
    [anon_sym_assert] = ACTIONS(3728),
    [anon_sym_upcast] = ACTIONS(3728),
    [anon_sym_downcast] = ACTIONS(3728),
    [anon_sym_COLON_GT] = ACTIONS(3726),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3726),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_fun] = ACTIONS(3728),
    [anon_sym_try] = ACTIONS(3728),
    [anon_sym_match] = ACTIONS(3728),
    [anon_sym_match_BANG] = ACTIONS(3726),
    [anon_sym_function] = ACTIONS(3728),
    [anon_sym_LT_DASH] = ACTIONS(3728),
    [anon_sym_DOT_LBRACK] = ACTIONS(3726),
    [anon_sym_LT] = ACTIONS(3726),
    [anon_sym_use] = ACTIONS(3728),
    [anon_sym_use_BANG] = ACTIONS(3726),
    [anon_sym_do_BANG] = ACTIONS(3726),
    [anon_sym_begin] = ACTIONS(3728),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_default] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [anon_sym_static] = ACTIONS(3728),
    [anon_sym_member] = ACTIONS(3728),
    [anon_sym_interface] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(3728),
    [anon_sym_val] = ACTIONS(3728),
    [anon_sym_override] = ACTIONS(3728),
    [anon_sym_inherit] = ACTIONS(3728),
    [aux_sym_char_token1] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3728),
    [anon_sym_AT_DQUOTE] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [sym_bool] = ACTIONS(3728),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3728),
    [sym_op_identifier] = ACTIONS(3728),
    [anon_sym_PLUS] = ACTIONS(3728),
    [anon_sym_DASH] = ACTIONS(3728),
    [anon_sym_PLUS_DOT] = ACTIONS(3728),
    [anon_sym_DASH_DOT] = ACTIONS(3728),
    [anon_sym_PERCENT] = ACTIONS(3728),
    [anon_sym_AMP_AMP] = ACTIONS(3728),
    [anon_sym_TILDE] = ACTIONS(3726),
    [aux_sym_prefix_op_token1] = ACTIONS(3728),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token2] = ACTIONS(3728),
    [anon_sym_PIPE_PIPE] = ACTIONS(3728),
    [anon_sym_BANG_EQ] = ACTIONS(3728),
    [anon_sym_COLON_EQ] = ACTIONS(3726),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3728),
    [sym_int] = ACTIONS(3728),
    [sym_xint] = ACTIONS(3726),
    [anon_sym_f] = ACTIONS(3728),
    [aux_sym_decimal_token1] = ACTIONS(3728),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3726),
    [anon_sym_POUNDendif] = ACTIONS(3726),
    [sym__newline] = ACTIONS(3726),
  },
  [1614] = {
    [sym_block_comment] = STATE(1614),
    [sym_compiler_directive_decl] = STATE(1614),
    [sym_fsi_directive_decl] = STATE(1614),
    [sym_preproc_line] = STATE(1614),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_LBRACK_LT] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_and] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [aux_sym_access_modifier_token1] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_with] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_default] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [anon_sym_static] = ACTIONS(3604),
    [anon_sym_member] = ACTIONS(3604),
    [anon_sym_interface] = ACTIONS(3604),
    [anon_sym_abstract] = ACTIONS(3604),
    [anon_sym_val] = ACTIONS(3604),
    [anon_sym_override] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
    [sym__dedent] = ACTIONS(3602),
  },
  [1615] = {
    [sym_block_comment] = STATE(1615),
    [sym_compiler_directive_decl] = STATE(1615),
    [sym_fsi_directive_decl] = STATE(1615),
    [sym_preproc_line] = STATE(1615),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_LBRACK_LT] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [aux_sym_access_modifier_token1] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_with] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(4402),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_default] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [anon_sym_static] = ACTIONS(3685),
    [anon_sym_member] = ACTIONS(3685),
    [anon_sym_interface] = ACTIONS(3685),
    [anon_sym_abstract] = ACTIONS(3685),
    [anon_sym_val] = ACTIONS(3685),
    [anon_sym_override] = ACTIONS(3685),
    [anon_sym_inherit] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [anon_sym_POUNDendif] = ACTIONS(3683),
    [anon_sym_POUNDelse] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
  },
  [1616] = {
    [sym_block_comment] = STATE(1616),
    [sym_compiler_directive_decl] = STATE(1616),
    [sym_fsi_directive_decl] = STATE(1616),
    [sym_preproc_line] = STATE(1616),
    [sym_identifier] = ACTIONS(3841),
    [anon_sym_EQ] = ACTIONS(3839),
    [anon_sym_LBRACK_LT] = ACTIONS(3839),
    [anon_sym_COLON] = ACTIONS(3841),
    [anon_sym_return] = ACTIONS(3841),
    [anon_sym_do] = ACTIONS(3841),
    [anon_sym_and] = ACTIONS(3841),
    [anon_sym_let] = ACTIONS(3841),
    [anon_sym_let_BANG] = ACTIONS(3839),
    [aux_sym_access_modifier_token1] = ACTIONS(3839),
    [anon_sym_LPAREN] = ACTIONS(3841),
    [anon_sym_COMMA] = ACTIONS(3839),
    [anon_sym_null] = ACTIONS(3841),
    [anon_sym_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_COLON] = ACTIONS(3839),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_AMP] = ACTIONS(3841),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(3841),
    [anon_sym_LT_AT] = ACTIONS(3841),
    [anon_sym_LT_AT_AT] = ACTIONS(3841),
    [anon_sym_DOT] = ACTIONS(3841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3839),
    [anon_sym_new] = ACTIONS(3841),
    [anon_sym_with] = ACTIONS(3841),
    [anon_sym_return_BANG] = ACTIONS(3839),
    [anon_sym_yield] = ACTIONS(3841),
    [anon_sym_yield_BANG] = ACTIONS(3839),
    [anon_sym_lazy] = ACTIONS(3841),
    [anon_sym_assert] = ACTIONS(3841),
    [anon_sym_upcast] = ACTIONS(3841),
    [anon_sym_downcast] = ACTIONS(3841),
    [anon_sym_COLON_GT] = ACTIONS(3839),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3839),
    [anon_sym_for] = ACTIONS(3841),
    [anon_sym_while] = ACTIONS(3841),
    [anon_sym_if] = ACTIONS(3841),
    [anon_sym_fun] = ACTIONS(3841),
    [anon_sym_try] = ACTIONS(3841),
    [anon_sym_match] = ACTIONS(3841),
    [anon_sym_match_BANG] = ACTIONS(3839),
    [anon_sym_function] = ACTIONS(3841),
    [anon_sym_LT_DASH] = ACTIONS(3841),
    [anon_sym_DOT_LBRACK] = ACTIONS(3839),
    [anon_sym_LT] = ACTIONS(3839),
    [anon_sym_use] = ACTIONS(3841),
    [anon_sym_use_BANG] = ACTIONS(3839),
    [anon_sym_do_BANG] = ACTIONS(3839),
    [anon_sym_begin] = ACTIONS(3841),
    [anon_sym_LPAREN2] = ACTIONS(3841),
    [anon_sym_default] = ACTIONS(3841),
    [anon_sym_or] = ACTIONS(3841),
    [anon_sym_static] = ACTIONS(3841),
    [anon_sym_member] = ACTIONS(3841),
    [anon_sym_interface] = ACTIONS(3841),
    [anon_sym_abstract] = ACTIONS(3841),
    [anon_sym_val] = ACTIONS(3841),
    [anon_sym_override] = ACTIONS(3841),
    [aux_sym_char_token1] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3841),
    [anon_sym_DQUOTE] = ACTIONS(3841),
    [anon_sym_AT_DQUOTE] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [sym_bool] = ACTIONS(3841),
    [sym_unit] = ACTIONS(3839),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3841),
    [sym_op_identifier] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_PLUS_DOT] = ACTIONS(3841),
    [anon_sym_DASH_DOT] = ACTIONS(3841),
    [anon_sym_PERCENT] = ACTIONS(3841),
    [anon_sym_AMP_AMP] = ACTIONS(3841),
    [anon_sym_TILDE] = ACTIONS(3839),
    [aux_sym_prefix_op_token1] = ACTIONS(3841),
    [aux_sym_infix_op_token1] = ACTIONS(3839),
    [aux_sym_infix_op_token2] = ACTIONS(3841),
    [anon_sym_PIPE_PIPE] = ACTIONS(3841),
    [anon_sym_BANG_EQ] = ACTIONS(3841),
    [anon_sym_COLON_EQ] = ACTIONS(3839),
    [anon_sym_DOLLAR] = ACTIONS(3841),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3841),
    [sym_int] = ACTIONS(3841),
    [sym_xint] = ACTIONS(3839),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3839),
    [anon_sym_POUNDendif] = ACTIONS(3839),
    [anon_sym_POUNDelse] = ACTIONS(3839),
    [sym__newline] = ACTIONS(3839),
  },
  [1617] = {
    [sym_block_comment] = STATE(1617),
    [sym_compiler_directive_decl] = STATE(1617),
    [sym_fsi_directive_decl] = STATE(1617),
    [sym_preproc_line] = STATE(1617),
    [sym_identifier] = ACTIONS(3828),
    [anon_sym_EQ] = ACTIONS(3826),
    [anon_sym_LBRACK_LT] = ACTIONS(3826),
    [anon_sym_COLON] = ACTIONS(3828),
    [anon_sym_return] = ACTIONS(3828),
    [anon_sym_do] = ACTIONS(3828),
    [anon_sym_and] = ACTIONS(3828),
    [anon_sym_let] = ACTIONS(3828),
    [anon_sym_let_BANG] = ACTIONS(3826),
    [aux_sym_access_modifier_token1] = ACTIONS(3826),
    [anon_sym_LPAREN] = ACTIONS(3828),
    [anon_sym_COMMA] = ACTIONS(3826),
    [anon_sym_null] = ACTIONS(3828),
    [anon_sym_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_COLON] = ACTIONS(3826),
    [anon_sym_PIPE] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3828),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3826),
    [anon_sym_LBRACE] = ACTIONS(3828),
    [anon_sym_LT_AT] = ACTIONS(3828),
    [anon_sym_LT_AT_AT] = ACTIONS(3828),
    [anon_sym_DOT] = ACTIONS(3828),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3826),
    [anon_sym_new] = ACTIONS(3828),
    [anon_sym_with] = ACTIONS(3828),
    [anon_sym_return_BANG] = ACTIONS(3826),
    [anon_sym_yield] = ACTIONS(3828),
    [anon_sym_yield_BANG] = ACTIONS(3826),
    [anon_sym_lazy] = ACTIONS(3828),
    [anon_sym_assert] = ACTIONS(3828),
    [anon_sym_upcast] = ACTIONS(3828),
    [anon_sym_downcast] = ACTIONS(3828),
    [anon_sym_COLON_GT] = ACTIONS(3826),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3826),
    [anon_sym_for] = ACTIONS(3828),
    [anon_sym_while] = ACTIONS(3828),
    [anon_sym_if] = ACTIONS(3828),
    [anon_sym_fun] = ACTIONS(3828),
    [anon_sym_try] = ACTIONS(3828),
    [anon_sym_match] = ACTIONS(3828),
    [anon_sym_match_BANG] = ACTIONS(3826),
    [anon_sym_function] = ACTIONS(3828),
    [anon_sym_LT_DASH] = ACTIONS(3828),
    [anon_sym_DOT_LBRACK] = ACTIONS(3826),
    [anon_sym_LT] = ACTIONS(3826),
    [anon_sym_use] = ACTIONS(3828),
    [anon_sym_use_BANG] = ACTIONS(3826),
    [anon_sym_do_BANG] = ACTIONS(3826),
    [anon_sym_begin] = ACTIONS(3828),
    [anon_sym_LPAREN2] = ACTIONS(3828),
    [anon_sym_default] = ACTIONS(3828),
    [anon_sym_or] = ACTIONS(3828),
    [anon_sym_static] = ACTIONS(3828),
    [anon_sym_member] = ACTIONS(3828),
    [anon_sym_interface] = ACTIONS(3828),
    [anon_sym_abstract] = ACTIONS(3828),
    [anon_sym_val] = ACTIONS(3828),
    [anon_sym_override] = ACTIONS(3828),
    [aux_sym_char_token1] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3828),
    [anon_sym_DQUOTE] = ACTIONS(3828),
    [anon_sym_AT_DQUOTE] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [sym_bool] = ACTIONS(3828),
    [sym_unit] = ACTIONS(3826),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3828),
    [sym_op_identifier] = ACTIONS(3828),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_DASH] = ACTIONS(3828),
    [anon_sym_PLUS_DOT] = ACTIONS(3828),
    [anon_sym_DASH_DOT] = ACTIONS(3828),
    [anon_sym_PERCENT] = ACTIONS(3828),
    [anon_sym_AMP_AMP] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3826),
    [aux_sym_prefix_op_token1] = ACTIONS(3828),
    [aux_sym_infix_op_token1] = ACTIONS(3826),
    [aux_sym_infix_op_token2] = ACTIONS(3828),
    [anon_sym_PIPE_PIPE] = ACTIONS(3828),
    [anon_sym_BANG_EQ] = ACTIONS(3828),
    [anon_sym_COLON_EQ] = ACTIONS(3826),
    [anon_sym_DOLLAR] = ACTIONS(3828),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3828),
    [sym_int] = ACTIONS(3828),
    [sym_xint] = ACTIONS(3826),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3826),
    [anon_sym_POUNDendif] = ACTIONS(3826),
    [anon_sym_POUNDelse] = ACTIONS(3826),
    [sym__newline] = ACTIONS(3826),
  },
  [1618] = {
    [sym_block_comment] = STATE(1618),
    [sym_compiler_directive_decl] = STATE(1618),
    [sym_fsi_directive_decl] = STATE(1618),
    [sym_preproc_line] = STATE(1618),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3227),
    [anon_sym_uy] = ACTIONS(3229),
    [anon_sym_s] = ACTIONS(3231),
    [anon_sym_us] = ACTIONS(3233),
    [anon_sym_l] = ACTIONS(3235),
    [aux_sym_uint32_token1] = ACTIONS(3237),
    [anon_sym_n] = ACTIONS(3239),
    [anon_sym_un] = ACTIONS(3241),
    [anon_sym_L] = ACTIONS(3243),
    [aux_sym_uint64_token1] = ACTIONS(3245),
    [anon_sym_lf] = ACTIONS(3371),
    [anon_sym_LF] = ACTIONS(3373),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [anon_sym_POUNDendif] = ACTIONS(3191),
    [anon_sym_POUNDelse] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1619] = {
    [sym_block_comment] = STATE(1619),
    [sym_compiler_directive_decl] = STATE(1619),
    [sym_fsi_directive_decl] = STATE(1619),
    [sym_preproc_line] = STATE(1619),
    [aux_sym_rules_repeat1] = STATE(1656),
    [sym_identifier] = ACTIONS(3736),
    [anon_sym_EQ] = ACTIONS(3734),
    [anon_sym_LBRACK_LT] = ACTIONS(3734),
    [anon_sym_COLON] = ACTIONS(3736),
    [anon_sym_return] = ACTIONS(3736),
    [anon_sym_do] = ACTIONS(3736),
    [anon_sym_and] = ACTIONS(3736),
    [anon_sym_let] = ACTIONS(3736),
    [anon_sym_let_BANG] = ACTIONS(3734),
    [aux_sym_access_modifier_token1] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3736),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_null] = ACTIONS(3736),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_COLON] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(4563),
    [anon_sym_AMP] = ACTIONS(3736),
    [anon_sym_LBRACK] = ACTIONS(3736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3734),
    [anon_sym_LBRACE] = ACTIONS(3736),
    [anon_sym_LT_AT] = ACTIONS(3736),
    [anon_sym_LT_AT_AT] = ACTIONS(3736),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3734),
    [anon_sym_new] = ACTIONS(3736),
    [anon_sym_with] = ACTIONS(3736),
    [anon_sym_return_BANG] = ACTIONS(3734),
    [anon_sym_yield] = ACTIONS(3736),
    [anon_sym_yield_BANG] = ACTIONS(3734),
    [anon_sym_lazy] = ACTIONS(3736),
    [anon_sym_assert] = ACTIONS(3736),
    [anon_sym_upcast] = ACTIONS(3736),
    [anon_sym_downcast] = ACTIONS(3736),
    [anon_sym_COLON_GT] = ACTIONS(3734),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3734),
    [anon_sym_for] = ACTIONS(3736),
    [anon_sym_while] = ACTIONS(3736),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_fun] = ACTIONS(3736),
    [anon_sym_try] = ACTIONS(3736),
    [anon_sym_match] = ACTIONS(3736),
    [anon_sym_match_BANG] = ACTIONS(3734),
    [anon_sym_function] = ACTIONS(3736),
    [anon_sym_LT_DASH] = ACTIONS(3736),
    [anon_sym_DOT_LBRACK] = ACTIONS(3734),
    [anon_sym_LT] = ACTIONS(3734),
    [anon_sym_use] = ACTIONS(3736),
    [anon_sym_use_BANG] = ACTIONS(3734),
    [anon_sym_do_BANG] = ACTIONS(3734),
    [anon_sym_begin] = ACTIONS(3736),
    [anon_sym_LPAREN2] = ACTIONS(3736),
    [anon_sym_default] = ACTIONS(3736),
    [anon_sym_or] = ACTIONS(3736),
    [anon_sym_static] = ACTIONS(3736),
    [anon_sym_member] = ACTIONS(3736),
    [anon_sym_interface] = ACTIONS(3736),
    [anon_sym_abstract] = ACTIONS(3736),
    [anon_sym_val] = ACTIONS(3736),
    [anon_sym_override] = ACTIONS(3736),
    [aux_sym_char_token1] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3736),
    [anon_sym_DQUOTE] = ACTIONS(3736),
    [anon_sym_AT_DQUOTE] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [sym_bool] = ACTIONS(3736),
    [sym_unit] = ACTIONS(3734),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3736),
    [sym_op_identifier] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS_DOT] = ACTIONS(3736),
    [anon_sym_DASH_DOT] = ACTIONS(3736),
    [anon_sym_PERCENT] = ACTIONS(3736),
    [anon_sym_AMP_AMP] = ACTIONS(3736),
    [anon_sym_TILDE] = ACTIONS(3734),
    [aux_sym_prefix_op_token1] = ACTIONS(3736),
    [aux_sym_infix_op_token1] = ACTIONS(3734),
    [aux_sym_infix_op_token2] = ACTIONS(3736),
    [anon_sym_PIPE_PIPE] = ACTIONS(3736),
    [anon_sym_BANG_EQ] = ACTIONS(3736),
    [anon_sym_COLON_EQ] = ACTIONS(3734),
    [anon_sym_DOLLAR] = ACTIONS(3736),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3736),
    [sym_int] = ACTIONS(3736),
    [sym_xint] = ACTIONS(3734),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3734),
    [anon_sym_POUNDendif] = ACTIONS(3734),
    [sym__newline] = ACTIONS(4565),
  },
  [1620] = {
    [sym_block_comment] = STATE(1620),
    [sym_compiler_directive_decl] = STATE(1620),
    [sym_fsi_directive_decl] = STATE(1620),
    [sym_preproc_line] = STATE(1620),
    [aux_sym_long_identifier_repeat1] = STATE(1639),
    [sym_identifier] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3778),
    [anon_sym_LBRACK_LT] = ACTIONS(3778),
    [anon_sym_COLON] = ACTIONS(3781),
    [anon_sym_return] = ACTIONS(3781),
    [anon_sym_do] = ACTIONS(3781),
    [anon_sym_and] = ACTIONS(3781),
    [anon_sym_let] = ACTIONS(3781),
    [anon_sym_let_BANG] = ACTIONS(3778),
    [aux_sym_access_modifier_token1] = ACTIONS(3778),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3778),
    [anon_sym_null] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3781),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_LT_AT] = ACTIONS(3781),
    [anon_sym_LT_AT_AT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(4568),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3778),
    [anon_sym_new] = ACTIONS(3781),
    [anon_sym_with] = ACTIONS(3781),
    [anon_sym_return_BANG] = ACTIONS(3778),
    [anon_sym_yield] = ACTIONS(3781),
    [anon_sym_yield_BANG] = ACTIONS(3778),
    [anon_sym_lazy] = ACTIONS(3781),
    [anon_sym_assert] = ACTIONS(3781),
    [anon_sym_upcast] = ACTIONS(3781),
    [anon_sym_downcast] = ACTIONS(3781),
    [anon_sym_COLON_GT] = ACTIONS(3778),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3778),
    [anon_sym_for] = ACTIONS(3781),
    [anon_sym_while] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_fun] = ACTIONS(3781),
    [anon_sym_try] = ACTIONS(3781),
    [anon_sym_match] = ACTIONS(3781),
    [anon_sym_match_BANG] = ACTIONS(3778),
    [anon_sym_function] = ACTIONS(3781),
    [anon_sym_LT_DASH] = ACTIONS(3781),
    [anon_sym_DOT_LBRACK] = ACTIONS(3778),
    [anon_sym_LT] = ACTIONS(3778),
    [anon_sym_use] = ACTIONS(3781),
    [anon_sym_use_BANG] = ACTIONS(3778),
    [anon_sym_do_BANG] = ACTIONS(3778),
    [anon_sym_begin] = ACTIONS(3781),
    [anon_sym_LPAREN2] = ACTIONS(3781),
    [anon_sym_default] = ACTIONS(3781),
    [anon_sym_or] = ACTIONS(3781),
    [anon_sym_static] = ACTIONS(3781),
    [anon_sym_member] = ACTIONS(3781),
    [anon_sym_interface] = ACTIONS(3781),
    [anon_sym_abstract] = ACTIONS(3781),
    [anon_sym_val] = ACTIONS(3781),
    [anon_sym_override] = ACTIONS(3781),
    [aux_sym_char_token1] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3781),
    [anon_sym_DQUOTE] = ACTIONS(3781),
    [anon_sym_AT_DQUOTE] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [sym_bool] = ACTIONS(3781),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3781),
    [sym_op_identifier] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3781),
    [anon_sym_DASH] = ACTIONS(3781),
    [anon_sym_PLUS_DOT] = ACTIONS(3781),
    [anon_sym_DASH_DOT] = ACTIONS(3781),
    [anon_sym_PERCENT] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3781),
    [anon_sym_TILDE] = ACTIONS(3778),
    [aux_sym_prefix_op_token1] = ACTIONS(3781),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token2] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_COLON_EQ] = ACTIONS(3778),
    [anon_sym_DOLLAR] = ACTIONS(3781),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3781),
    [sym_int] = ACTIONS(3781),
    [sym_xint] = ACTIONS(3778),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3778),
    [anon_sym_POUNDendif] = ACTIONS(3778),
    [anon_sym_POUNDelse] = ACTIONS(3778),
    [sym__newline] = ACTIONS(3778),
  },
  [1621] = {
    [sym_block_comment] = STATE(1621),
    [sym_compiler_directive_decl] = STATE(1621),
    [sym_fsi_directive_decl] = STATE(1621),
    [sym_preproc_line] = STATE(1621),
    [aux_sym_rules_repeat1] = STATE(1670),
    [sym_identifier] = ACTIONS(3676),
    [anon_sym_EQ] = ACTIONS(3674),
    [anon_sym_LBRACK_LT] = ACTIONS(3674),
    [anon_sym_COLON] = ACTIONS(3676),
    [anon_sym_return] = ACTIONS(3676),
    [anon_sym_do] = ACTIONS(3676),
    [anon_sym_let] = ACTIONS(3676),
    [anon_sym_let_BANG] = ACTIONS(3674),
    [aux_sym_access_modifier_token1] = ACTIONS(3674),
    [anon_sym_LPAREN] = ACTIONS(3676),
    [anon_sym_COMMA] = ACTIONS(3674),
    [anon_sym_null] = ACTIONS(3676),
    [anon_sym_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_COLON] = ACTIONS(3674),
    [anon_sym_PIPE] = ACTIONS(4572),
    [anon_sym_AMP] = ACTIONS(3676),
    [anon_sym_LBRACK] = ACTIONS(3676),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3674),
    [anon_sym_LBRACE] = ACTIONS(3676),
    [anon_sym_LT_AT] = ACTIONS(3676),
    [anon_sym_LT_AT_AT] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3674),
    [anon_sym_new] = ACTIONS(3676),
    [anon_sym_with] = ACTIONS(3676),
    [anon_sym_return_BANG] = ACTIONS(3674),
    [anon_sym_yield] = ACTIONS(3676),
    [anon_sym_yield_BANG] = ACTIONS(3674),
    [anon_sym_lazy] = ACTIONS(3676),
    [anon_sym_assert] = ACTIONS(3676),
    [anon_sym_upcast] = ACTIONS(3676),
    [anon_sym_downcast] = ACTIONS(3676),
    [anon_sym_COLON_GT] = ACTIONS(3674),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3674),
    [anon_sym_for] = ACTIONS(3676),
    [anon_sym_while] = ACTIONS(3676),
    [anon_sym_if] = ACTIONS(3676),
    [anon_sym_fun] = ACTIONS(3676),
    [anon_sym_try] = ACTIONS(3676),
    [anon_sym_match] = ACTIONS(3676),
    [anon_sym_match_BANG] = ACTIONS(3674),
    [anon_sym_function] = ACTIONS(3676),
    [anon_sym_LT_DASH] = ACTIONS(3676),
    [anon_sym_DOT_LBRACK] = ACTIONS(3674),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_use] = ACTIONS(3676),
    [anon_sym_use_BANG] = ACTIONS(3674),
    [anon_sym_do_BANG] = ACTIONS(3674),
    [anon_sym_begin] = ACTIONS(3676),
    [anon_sym_LPAREN2] = ACTIONS(3676),
    [anon_sym_DOT_DOT2] = ACTIONS(3674),
    [anon_sym_default] = ACTIONS(3676),
    [anon_sym_or] = ACTIONS(3676),
    [anon_sym_static] = ACTIONS(3676),
    [anon_sym_member] = ACTIONS(3676),
    [anon_sym_interface] = ACTIONS(3676),
    [anon_sym_abstract] = ACTIONS(3676),
    [anon_sym_val] = ACTIONS(3676),
    [anon_sym_override] = ACTIONS(3676),
    [aux_sym_char_token1] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3676),
    [anon_sym_DQUOTE] = ACTIONS(3676),
    [anon_sym_AT_DQUOTE] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [sym_bool] = ACTIONS(3676),
    [sym_unit] = ACTIONS(3674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3676),
    [sym_op_identifier] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_PLUS_DOT] = ACTIONS(3676),
    [anon_sym_DASH_DOT] = ACTIONS(3676),
    [anon_sym_PERCENT] = ACTIONS(3676),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_TILDE] = ACTIONS(3674),
    [aux_sym_prefix_op_token1] = ACTIONS(3676),
    [aux_sym_infix_op_token1] = ACTIONS(3674),
    [aux_sym_infix_op_token2] = ACTIONS(3676),
    [anon_sym_PIPE_PIPE] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3676),
    [anon_sym_COLON_EQ] = ACTIONS(3674),
    [anon_sym_DOLLAR] = ACTIONS(3676),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3676),
    [sym_int] = ACTIONS(3676),
    [sym_xint] = ACTIONS(3674),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3674),
    [sym__newline] = ACTIONS(4574),
    [sym__dedent] = ACTIONS(3674),
  },
  [1622] = {
    [sym_block_comment] = STATE(1622),
    [sym_compiler_directive_decl] = STATE(1622),
    [sym_fsi_directive_decl] = STATE(1622),
    [sym_preproc_line] = STATE(1622),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_LBRACK_LT] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [aux_sym_access_modifier_token1] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_with] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(4577),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_DOT_DOT] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_default] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [anon_sym_static] = ACTIONS(3685),
    [anon_sym_member] = ACTIONS(3685),
    [anon_sym_interface] = ACTIONS(3685),
    [anon_sym_abstract] = ACTIONS(3685),
    [anon_sym_val] = ACTIONS(3685),
    [anon_sym_override] = ACTIONS(3685),
    [anon_sym_inherit] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [anon_sym_POUNDendif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
  },
  [1623] = {
    [sym_block_comment] = STATE(1623),
    [sym_compiler_directive_decl] = STATE(1623),
    [sym_fsi_directive_decl] = STATE(1623),
    [sym_preproc_line] = STATE(1623),
    [aux_sym_rules_repeat1] = STATE(1649),
    [sym_identifier] = ACTIONS(3736),
    [anon_sym_EQ] = ACTIONS(3734),
    [anon_sym_LBRACK_LT] = ACTIONS(3734),
    [anon_sym_COLON] = ACTIONS(3736),
    [anon_sym_return] = ACTIONS(3736),
    [anon_sym_do] = ACTIONS(3736),
    [anon_sym_let] = ACTIONS(3736),
    [anon_sym_let_BANG] = ACTIONS(3734),
    [aux_sym_access_modifier_token1] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3736),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_null] = ACTIONS(3736),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_COLON] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(4516),
    [anon_sym_AMP] = ACTIONS(3736),
    [anon_sym_LBRACK] = ACTIONS(3736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3734),
    [anon_sym_LBRACE] = ACTIONS(3736),
    [anon_sym_LT_AT] = ACTIONS(3736),
    [anon_sym_LT_AT_AT] = ACTIONS(3736),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3734),
    [anon_sym_new] = ACTIONS(3736),
    [anon_sym_with] = ACTIONS(3736),
    [anon_sym_return_BANG] = ACTIONS(3734),
    [anon_sym_yield] = ACTIONS(3736),
    [anon_sym_yield_BANG] = ACTIONS(3734),
    [anon_sym_lazy] = ACTIONS(3736),
    [anon_sym_assert] = ACTIONS(3736),
    [anon_sym_upcast] = ACTIONS(3736),
    [anon_sym_downcast] = ACTIONS(3736),
    [anon_sym_COLON_GT] = ACTIONS(3734),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3734),
    [anon_sym_for] = ACTIONS(3736),
    [anon_sym_while] = ACTIONS(3736),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_fun] = ACTIONS(3736),
    [anon_sym_try] = ACTIONS(3736),
    [anon_sym_match] = ACTIONS(3736),
    [anon_sym_match_BANG] = ACTIONS(3734),
    [anon_sym_function] = ACTIONS(3736),
    [anon_sym_LT_DASH] = ACTIONS(3736),
    [anon_sym_DOT_LBRACK] = ACTIONS(3734),
    [anon_sym_LT] = ACTIONS(3734),
    [anon_sym_use] = ACTIONS(3736),
    [anon_sym_use_BANG] = ACTIONS(3734),
    [anon_sym_do_BANG] = ACTIONS(3734),
    [anon_sym_begin] = ACTIONS(3736),
    [anon_sym_LPAREN2] = ACTIONS(3736),
    [anon_sym_default] = ACTIONS(3736),
    [anon_sym_or] = ACTIONS(3736),
    [anon_sym_static] = ACTIONS(3736),
    [anon_sym_member] = ACTIONS(3736),
    [anon_sym_interface] = ACTIONS(3736),
    [anon_sym_abstract] = ACTIONS(3736),
    [anon_sym_val] = ACTIONS(3736),
    [anon_sym_override] = ACTIONS(3736),
    [anon_sym_inherit] = ACTIONS(3736),
    [aux_sym_char_token1] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3736),
    [anon_sym_DQUOTE] = ACTIONS(3736),
    [anon_sym_AT_DQUOTE] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [sym_bool] = ACTIONS(3736),
    [sym_unit] = ACTIONS(3734),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3736),
    [sym_op_identifier] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS_DOT] = ACTIONS(3736),
    [anon_sym_DASH_DOT] = ACTIONS(3736),
    [anon_sym_PERCENT] = ACTIONS(3736),
    [anon_sym_AMP_AMP] = ACTIONS(3736),
    [anon_sym_TILDE] = ACTIONS(3734),
    [aux_sym_prefix_op_token1] = ACTIONS(3736),
    [aux_sym_infix_op_token1] = ACTIONS(3734),
    [aux_sym_infix_op_token2] = ACTIONS(3736),
    [anon_sym_PIPE_PIPE] = ACTIONS(3736),
    [anon_sym_BANG_EQ] = ACTIONS(3736),
    [anon_sym_COLON_EQ] = ACTIONS(3734),
    [anon_sym_DOLLAR] = ACTIONS(3736),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3736),
    [sym_int] = ACTIONS(3736),
    [sym_xint] = ACTIONS(3734),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3734),
    [anon_sym_POUNDendif] = ACTIONS(3734),
    [sym__newline] = ACTIONS(4579),
  },
  [1624] = {
    [sym_block_comment] = STATE(1624),
    [sym_compiler_directive_decl] = STATE(1624),
    [sym_fsi_directive_decl] = STATE(1624),
    [sym_preproc_line] = STATE(1624),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_EQ] = ACTIONS(3646),
    [anon_sym_LBRACK_LT] = ACTIONS(3646),
    [anon_sym_COLON] = ACTIONS(3648),
    [anon_sym_return] = ACTIONS(3648),
    [anon_sym_do] = ACTIONS(3648),
    [anon_sym_let] = ACTIONS(3648),
    [anon_sym_let_BANG] = ACTIONS(3646),
    [aux_sym_access_modifier_token1] = ACTIONS(3646),
    [anon_sym_LPAREN] = ACTIONS(3648),
    [anon_sym_COMMA] = ACTIONS(3646),
    [anon_sym_null] = ACTIONS(3648),
    [anon_sym_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_COLON] = ACTIONS(3646),
    [anon_sym_AMP] = ACTIONS(3648),
    [anon_sym_LBRACK] = ACTIONS(3648),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3646),
    [anon_sym_LBRACE] = ACTIONS(3648),
    [anon_sym_LT_AT] = ACTIONS(3648),
    [anon_sym_LT_AT_AT] = ACTIONS(3648),
    [anon_sym_DOT] = ACTIONS(3648),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3646),
    [anon_sym_new] = ACTIONS(3648),
    [anon_sym_with] = ACTIONS(3648),
    [anon_sym_return_BANG] = ACTIONS(3646),
    [anon_sym_yield] = ACTIONS(3648),
    [anon_sym_yield_BANG] = ACTIONS(3646),
    [anon_sym_lazy] = ACTIONS(3648),
    [anon_sym_assert] = ACTIONS(3648),
    [anon_sym_upcast] = ACTIONS(3648),
    [anon_sym_downcast] = ACTIONS(3648),
    [anon_sym_COLON_GT] = ACTIONS(3646),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3646),
    [anon_sym_for] = ACTIONS(3648),
    [anon_sym_while] = ACTIONS(3648),
    [anon_sym_else] = ACTIONS(3648),
    [anon_sym_elif] = ACTIONS(3648),
    [anon_sym_if] = ACTIONS(3648),
    [anon_sym_fun] = ACTIONS(3648),
    [anon_sym_try] = ACTIONS(3648),
    [anon_sym_match] = ACTIONS(3648),
    [anon_sym_match_BANG] = ACTIONS(3646),
    [anon_sym_function] = ACTIONS(3648),
    [anon_sym_LT_DASH] = ACTIONS(3648),
    [anon_sym_DOT_LBRACK] = ACTIONS(3646),
    [anon_sym_LT] = ACTIONS(3646),
    [anon_sym_use] = ACTIONS(3648),
    [anon_sym_use_BANG] = ACTIONS(3646),
    [anon_sym_do_BANG] = ACTIONS(3646),
    [anon_sym_begin] = ACTIONS(3648),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_DOT_DOT2] = ACTIONS(3646),
    [anon_sym_default] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3648),
    [anon_sym_static] = ACTIONS(3648),
    [anon_sym_member] = ACTIONS(3648),
    [anon_sym_interface] = ACTIONS(3648),
    [anon_sym_abstract] = ACTIONS(3648),
    [anon_sym_val] = ACTIONS(3648),
    [anon_sym_override] = ACTIONS(3648),
    [aux_sym_char_token1] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3648),
    [anon_sym_AT_DQUOTE] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [sym_bool] = ACTIONS(3648),
    [sym_unit] = ACTIONS(3646),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3648),
    [sym_op_identifier] = ACTIONS(3648),
    [anon_sym_PLUS] = ACTIONS(3648),
    [anon_sym_DASH] = ACTIONS(3648),
    [anon_sym_PLUS_DOT] = ACTIONS(3648),
    [anon_sym_DASH_DOT] = ACTIONS(3648),
    [anon_sym_PERCENT] = ACTIONS(3648),
    [anon_sym_AMP_AMP] = ACTIONS(3648),
    [anon_sym_TILDE] = ACTIONS(3646),
    [aux_sym_prefix_op_token1] = ACTIONS(3648),
    [aux_sym_infix_op_token1] = ACTIONS(3646),
    [aux_sym_infix_op_token2] = ACTIONS(3648),
    [anon_sym_PIPE_PIPE] = ACTIONS(3648),
    [anon_sym_BANG_EQ] = ACTIONS(3648),
    [anon_sym_COLON_EQ] = ACTIONS(3646),
    [anon_sym_DOLLAR] = ACTIONS(3648),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3648),
    [sym_int] = ACTIONS(3648),
    [sym_xint] = ACTIONS(3646),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3646),
    [sym__newline] = ACTIONS(3646),
    [sym__dedent] = ACTIONS(3646),
  },
  [1625] = {
    [sym_block_comment] = STATE(1625),
    [sym_compiler_directive_decl] = STATE(1625),
    [sym_fsi_directive_decl] = STATE(1625),
    [sym_preproc_line] = STATE(1625),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_LBRACK_LT] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_and] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [aux_sym_access_modifier_token1] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_with] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_default] = ACTIONS(3743),
    [anon_sym_or] = ACTIONS(3743),
    [anon_sym_static] = ACTIONS(3743),
    [anon_sym_member] = ACTIONS(3743),
    [anon_sym_interface] = ACTIONS(3743),
    [anon_sym_abstract] = ACTIONS(3743),
    [anon_sym_val] = ACTIONS(3743),
    [anon_sym_override] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [anon_sym_POUNDendif] = ACTIONS(3741),
    [anon_sym_POUNDelse] = ACTIONS(3741),
    [sym__newline] = ACTIONS(3741),
  },
  [1626] = {
    [sym_block_comment] = STATE(1626),
    [sym_compiler_directive_decl] = STATE(1626),
    [sym_fsi_directive_decl] = STATE(1626),
    [sym_preproc_line] = STATE(1626),
    [sym_identifier] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3772),
    [anon_sym_LBRACK_LT] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3774),
    [anon_sym_do] = ACTIONS(3774),
    [anon_sym_and] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3774),
    [anon_sym_let_BANG] = ACTIONS(3772),
    [aux_sym_access_modifier_token1] = ACTIONS(3772),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3772),
    [anon_sym_null] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_COLON] = ACTIONS(3772),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_LT_AT] = ACTIONS(3774),
    [anon_sym_LT_AT_AT] = ACTIONS(3774),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3772),
    [anon_sym_new] = ACTIONS(3774),
    [anon_sym_with] = ACTIONS(3774),
    [anon_sym_return_BANG] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3774),
    [anon_sym_yield_BANG] = ACTIONS(3772),
    [anon_sym_lazy] = ACTIONS(3774),
    [anon_sym_assert] = ACTIONS(3774),
    [anon_sym_upcast] = ACTIONS(3774),
    [anon_sym_downcast] = ACTIONS(3774),
    [anon_sym_COLON_GT] = ACTIONS(3772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3774),
    [anon_sym_done] = ACTIONS(4582),
    [anon_sym_while] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3774),
    [anon_sym_fun] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3774),
    [anon_sym_match] = ACTIONS(3774),
    [anon_sym_match_BANG] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3774),
    [anon_sym_LT_DASH] = ACTIONS(3774),
    [anon_sym_DOT_LBRACK] = ACTIONS(3772),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_use] = ACTIONS(3774),
    [anon_sym_use_BANG] = ACTIONS(3772),
    [anon_sym_do_BANG] = ACTIONS(3772),
    [anon_sym_begin] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3774),
    [anon_sym_default] = ACTIONS(3774),
    [anon_sym_or] = ACTIONS(3774),
    [anon_sym_static] = ACTIONS(3774),
    [anon_sym_member] = ACTIONS(3774),
    [anon_sym_interface] = ACTIONS(3774),
    [anon_sym_abstract] = ACTIONS(3774),
    [anon_sym_val] = ACTIONS(3774),
    [anon_sym_override] = ACTIONS(3774),
    [aux_sym_char_token1] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_AT_DQUOTE] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [sym_bool] = ACTIONS(3774),
    [sym_unit] = ACTIONS(3772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3774),
    [sym_op_identifier] = ACTIONS(3774),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_DOT] = ACTIONS(3774),
    [anon_sym_DASH_DOT] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3772),
    [aux_sym_prefix_op_token1] = ACTIONS(3774),
    [aux_sym_infix_op_token1] = ACTIONS(3772),
    [aux_sym_infix_op_token2] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3774),
    [anon_sym_COLON_EQ] = ACTIONS(3772),
    [anon_sym_DOLLAR] = ACTIONS(3774),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3774),
    [sym_int] = ACTIONS(3774),
    [sym_xint] = ACTIONS(3772),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3772),
    [anon_sym_POUNDendif] = ACTIONS(3772),
    [anon_sym_POUNDelse] = ACTIONS(3772),
    [sym__newline] = ACTIONS(3772),
  },
  [1627] = {
    [sym_block_comment] = STATE(1627),
    [sym_compiler_directive_decl] = STATE(1627),
    [sym_fsi_directive_decl] = STATE(1627),
    [sym_preproc_line] = STATE(1627),
    [sym_identifier] = ACTIONS(3800),
    [anon_sym_EQ] = ACTIONS(3798),
    [anon_sym_LBRACK_LT] = ACTIONS(3798),
    [anon_sym_COLON] = ACTIONS(3800),
    [anon_sym_return] = ACTIONS(3800),
    [anon_sym_do] = ACTIONS(3800),
    [anon_sym_and] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_let_BANG] = ACTIONS(3798),
    [aux_sym_access_modifier_token1] = ACTIONS(3798),
    [anon_sym_LPAREN] = ACTIONS(3800),
    [anon_sym_COMMA] = ACTIONS(3798),
    [anon_sym_null] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_COLON] = ACTIONS(3798),
    [anon_sym_PIPE] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3800),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3798),
    [anon_sym_LBRACE] = ACTIONS(3800),
    [anon_sym_LT_AT] = ACTIONS(3800),
    [anon_sym_LT_AT_AT] = ACTIONS(3800),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3798),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_with] = ACTIONS(3800),
    [anon_sym_return_BANG] = ACTIONS(3798),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_yield_BANG] = ACTIONS(3798),
    [anon_sym_lazy] = ACTIONS(3800),
    [anon_sym_assert] = ACTIONS(3800),
    [anon_sym_upcast] = ACTIONS(3800),
    [anon_sym_downcast] = ACTIONS(3800),
    [anon_sym_COLON_GT] = ACTIONS(3798),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3798),
    [anon_sym_for] = ACTIONS(3800),
    [anon_sym_while] = ACTIONS(3800),
    [anon_sym_if] = ACTIONS(3800),
    [anon_sym_fun] = ACTIONS(3800),
    [anon_sym_try] = ACTIONS(3800),
    [anon_sym_match] = ACTIONS(3800),
    [anon_sym_match_BANG] = ACTIONS(3798),
    [anon_sym_function] = ACTIONS(3800),
    [anon_sym_LT_DASH] = ACTIONS(3800),
    [anon_sym_DOT_LBRACK] = ACTIONS(3798),
    [anon_sym_LT] = ACTIONS(3798),
    [anon_sym_use] = ACTIONS(3800),
    [anon_sym_use_BANG] = ACTIONS(3798),
    [anon_sym_do_BANG] = ACTIONS(3798),
    [anon_sym_begin] = ACTIONS(3800),
    [anon_sym_LPAREN2] = ACTIONS(3800),
    [anon_sym_default] = ACTIONS(3800),
    [anon_sym_or] = ACTIONS(3800),
    [anon_sym_static] = ACTIONS(3800),
    [anon_sym_member] = ACTIONS(3800),
    [anon_sym_interface] = ACTIONS(3800),
    [anon_sym_abstract] = ACTIONS(3800),
    [anon_sym_val] = ACTIONS(3800),
    [anon_sym_override] = ACTIONS(3800),
    [aux_sym_char_token1] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3800),
    [anon_sym_DQUOTE] = ACTIONS(3800),
    [anon_sym_AT_DQUOTE] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [sym_bool] = ACTIONS(3800),
    [sym_unit] = ACTIONS(3798),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3800),
    [sym_op_identifier] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS_DOT] = ACTIONS(3800),
    [anon_sym_DASH_DOT] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3800),
    [anon_sym_AMP_AMP] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3798),
    [aux_sym_prefix_op_token1] = ACTIONS(3800),
    [aux_sym_infix_op_token1] = ACTIONS(3798),
    [aux_sym_infix_op_token2] = ACTIONS(3800),
    [anon_sym_PIPE_PIPE] = ACTIONS(3800),
    [anon_sym_BANG_EQ] = ACTIONS(3800),
    [anon_sym_COLON_EQ] = ACTIONS(3798),
    [anon_sym_DOLLAR] = ACTIONS(3800),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3800),
    [sym_int] = ACTIONS(3800),
    [sym_xint] = ACTIONS(3798),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3798),
    [anon_sym_POUNDendif] = ACTIONS(3798),
    [anon_sym_POUNDelse] = ACTIONS(3798),
    [sym__newline] = ACTIONS(3798),
  },
  [1628] = {
    [sym_block_comment] = STATE(1628),
    [sym_compiler_directive_decl] = STATE(1628),
    [sym_fsi_directive_decl] = STATE(1628),
    [sym_preproc_line] = STATE(1628),
    [aux_sym_long_identifier_repeat1] = STATE(1628),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_and] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [aux_sym_access_modifier_token1] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(4584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_member] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_val] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [anon_sym_POUNDendif] = ACTIONS(3485),
    [anon_sym_POUNDelse] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [1629] = {
    [sym_block_comment] = STATE(1629),
    [sym_compiler_directive_decl] = STATE(1629),
    [sym_fsi_directive_decl] = STATE(1629),
    [sym_preproc_line] = STATE(1629),
    [aux_sym_rules_repeat1] = STATE(1599),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_LBRACK_LT] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [aux_sym_access_modifier_token1] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(4516),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_with] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_default] = ACTIONS(3693),
    [anon_sym_or] = ACTIONS(3693),
    [anon_sym_static] = ACTIONS(3693),
    [anon_sym_member] = ACTIONS(3693),
    [anon_sym_interface] = ACTIONS(3693),
    [anon_sym_abstract] = ACTIONS(3693),
    [anon_sym_val] = ACTIONS(3693),
    [anon_sym_override] = ACTIONS(3693),
    [anon_sym_inherit] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [anon_sym_POUNDendif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(4587),
  },
  [1630] = {
    [sym_block_comment] = STATE(1630),
    [sym_compiler_directive_decl] = STATE(1630),
    [sym_fsi_directive_decl] = STATE(1630),
    [sym_preproc_line] = STATE(1630),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_EQ] = ACTIONS(3646),
    [anon_sym_LBRACK_LT] = ACTIONS(3646),
    [anon_sym_COLON] = ACTIONS(3648),
    [anon_sym_return] = ACTIONS(3648),
    [anon_sym_do] = ACTIONS(3648),
    [anon_sym_let] = ACTIONS(3648),
    [anon_sym_let_BANG] = ACTIONS(3646),
    [aux_sym_access_modifier_token1] = ACTIONS(3646),
    [anon_sym_LPAREN] = ACTIONS(3648),
    [anon_sym_COMMA] = ACTIONS(3646),
    [anon_sym_null] = ACTIONS(3648),
    [anon_sym_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_COLON] = ACTIONS(3646),
    [anon_sym_AMP] = ACTIONS(3648),
    [anon_sym_LBRACK] = ACTIONS(3648),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3646),
    [anon_sym_LBRACE] = ACTIONS(3648),
    [anon_sym_LT_AT] = ACTIONS(3648),
    [anon_sym_LT_AT_AT] = ACTIONS(3648),
    [anon_sym_DOT] = ACTIONS(3648),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3646),
    [anon_sym_new] = ACTIONS(3648),
    [anon_sym_with] = ACTIONS(3648),
    [anon_sym_return_BANG] = ACTIONS(3646),
    [anon_sym_yield] = ACTIONS(3648),
    [anon_sym_yield_BANG] = ACTIONS(3646),
    [anon_sym_lazy] = ACTIONS(3648),
    [anon_sym_assert] = ACTIONS(3648),
    [anon_sym_upcast] = ACTIONS(3648),
    [anon_sym_downcast] = ACTIONS(3648),
    [anon_sym_COLON_GT] = ACTIONS(3646),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3646),
    [anon_sym_for] = ACTIONS(3648),
    [anon_sym_while] = ACTIONS(3648),
    [anon_sym_else] = ACTIONS(3648),
    [anon_sym_elif] = ACTIONS(3648),
    [anon_sym_if] = ACTIONS(3648),
    [anon_sym_fun] = ACTIONS(3648),
    [anon_sym_try] = ACTIONS(3648),
    [anon_sym_match] = ACTIONS(3648),
    [anon_sym_match_BANG] = ACTIONS(3646),
    [anon_sym_function] = ACTIONS(3648),
    [anon_sym_LT_DASH] = ACTIONS(3648),
    [anon_sym_DOT_LBRACK] = ACTIONS(3646),
    [anon_sym_LT] = ACTIONS(3646),
    [anon_sym_use] = ACTIONS(3648),
    [anon_sym_use_BANG] = ACTIONS(3646),
    [anon_sym_do_BANG] = ACTIONS(3646),
    [anon_sym_begin] = ACTIONS(3648),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_default] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3648),
    [anon_sym_static] = ACTIONS(3648),
    [anon_sym_member] = ACTIONS(3648),
    [anon_sym_interface] = ACTIONS(3648),
    [anon_sym_abstract] = ACTIONS(3648),
    [anon_sym_val] = ACTIONS(3648),
    [anon_sym_override] = ACTIONS(3648),
    [anon_sym_inherit] = ACTIONS(3648),
    [aux_sym_char_token1] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3648),
    [anon_sym_AT_DQUOTE] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [sym_bool] = ACTIONS(3648),
    [sym_unit] = ACTIONS(3646),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3648),
    [sym_op_identifier] = ACTIONS(3648),
    [anon_sym_PLUS] = ACTIONS(3648),
    [anon_sym_DASH] = ACTIONS(3648),
    [anon_sym_PLUS_DOT] = ACTIONS(3648),
    [anon_sym_DASH_DOT] = ACTIONS(3648),
    [anon_sym_PERCENT] = ACTIONS(3648),
    [anon_sym_AMP_AMP] = ACTIONS(3648),
    [anon_sym_TILDE] = ACTIONS(3646),
    [aux_sym_prefix_op_token1] = ACTIONS(3648),
    [aux_sym_infix_op_token1] = ACTIONS(3646),
    [aux_sym_infix_op_token2] = ACTIONS(3648),
    [anon_sym_PIPE_PIPE] = ACTIONS(3648),
    [anon_sym_BANG_EQ] = ACTIONS(3648),
    [anon_sym_COLON_EQ] = ACTIONS(3646),
    [anon_sym_DOLLAR] = ACTIONS(3648),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3648),
    [sym_int] = ACTIONS(3648),
    [sym_xint] = ACTIONS(3646),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3646),
    [anon_sym_POUNDendif] = ACTIONS(3646),
    [sym__newline] = ACTIONS(3646),
  },
  [1631] = {
    [sym_block_comment] = STATE(1631),
    [sym_compiler_directive_decl] = STATE(1631),
    [sym_fsi_directive_decl] = STATE(1631),
    [sym_preproc_line] = STATE(1631),
    [sym_identifier] = ACTIONS(3800),
    [anon_sym_EQ] = ACTIONS(3798),
    [anon_sym_LBRACK_LT] = ACTIONS(3798),
    [anon_sym_COLON] = ACTIONS(3800),
    [anon_sym_return] = ACTIONS(3800),
    [anon_sym_do] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_let_BANG] = ACTIONS(3798),
    [aux_sym_access_modifier_token1] = ACTIONS(3798),
    [anon_sym_LPAREN] = ACTIONS(3800),
    [anon_sym_COMMA] = ACTIONS(3798),
    [anon_sym_null] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_COLON] = ACTIONS(3798),
    [anon_sym_PIPE] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3800),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3798),
    [anon_sym_LBRACE] = ACTIONS(3800),
    [anon_sym_LT_AT] = ACTIONS(3800),
    [anon_sym_LT_AT_AT] = ACTIONS(3800),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3798),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_with] = ACTIONS(3800),
    [anon_sym_return_BANG] = ACTIONS(3798),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_yield_BANG] = ACTIONS(3798),
    [anon_sym_lazy] = ACTIONS(3800),
    [anon_sym_assert] = ACTIONS(3800),
    [anon_sym_upcast] = ACTIONS(3800),
    [anon_sym_downcast] = ACTIONS(3800),
    [anon_sym_COLON_GT] = ACTIONS(3798),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3798),
    [anon_sym_for] = ACTIONS(3800),
    [anon_sym_while] = ACTIONS(3800),
    [anon_sym_if] = ACTIONS(3800),
    [anon_sym_fun] = ACTIONS(3800),
    [anon_sym_try] = ACTIONS(3800),
    [anon_sym_match] = ACTIONS(3800),
    [anon_sym_match_BANG] = ACTIONS(3798),
    [anon_sym_function] = ACTIONS(3800),
    [anon_sym_LT_DASH] = ACTIONS(3800),
    [anon_sym_DOT_LBRACK] = ACTIONS(3798),
    [anon_sym_LT] = ACTIONS(3798),
    [anon_sym_use] = ACTIONS(3800),
    [anon_sym_use_BANG] = ACTIONS(3798),
    [anon_sym_do_BANG] = ACTIONS(3798),
    [anon_sym_begin] = ACTIONS(3800),
    [anon_sym_LPAREN2] = ACTIONS(3800),
    [anon_sym_default] = ACTIONS(3800),
    [anon_sym_or] = ACTIONS(3800),
    [anon_sym_static] = ACTIONS(3800),
    [anon_sym_member] = ACTIONS(3800),
    [anon_sym_interface] = ACTIONS(3800),
    [anon_sym_abstract] = ACTIONS(3800),
    [anon_sym_val] = ACTIONS(3800),
    [anon_sym_override] = ACTIONS(3800),
    [anon_sym_inherit] = ACTIONS(3800),
    [aux_sym_char_token1] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3800),
    [anon_sym_DQUOTE] = ACTIONS(3800),
    [anon_sym_AT_DQUOTE] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [sym_bool] = ACTIONS(3800),
    [sym_unit] = ACTIONS(3798),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3800),
    [sym_op_identifier] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS_DOT] = ACTIONS(3800),
    [anon_sym_DASH_DOT] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3800),
    [anon_sym_AMP_AMP] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3798),
    [aux_sym_prefix_op_token1] = ACTIONS(3800),
    [aux_sym_infix_op_token1] = ACTIONS(3798),
    [aux_sym_infix_op_token2] = ACTIONS(3800),
    [anon_sym_PIPE_PIPE] = ACTIONS(3800),
    [anon_sym_BANG_EQ] = ACTIONS(3800),
    [anon_sym_COLON_EQ] = ACTIONS(3798),
    [anon_sym_DOLLAR] = ACTIONS(3800),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3800),
    [sym_int] = ACTIONS(3800),
    [sym_xint] = ACTIONS(3798),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3798),
    [anon_sym_POUNDendif] = ACTIONS(3798),
    [anon_sym_POUNDelse] = ACTIONS(3798),
    [sym__newline] = ACTIONS(3798),
  },
  [1632] = {
    [sym_block_comment] = STATE(1632),
    [sym_compiler_directive_decl] = STATE(1632),
    [sym_fsi_directive_decl] = STATE(1632),
    [sym_preproc_line] = STATE(1632),
    [aux_sym_rules_repeat1] = STATE(1667),
    [sym_identifier] = ACTIONS(3736),
    [anon_sym_EQ] = ACTIONS(3734),
    [anon_sym_LBRACK_LT] = ACTIONS(3734),
    [anon_sym_COLON] = ACTIONS(3736),
    [anon_sym_return] = ACTIONS(3736),
    [anon_sym_do] = ACTIONS(3736),
    [anon_sym_let] = ACTIONS(3736),
    [anon_sym_let_BANG] = ACTIONS(3734),
    [aux_sym_access_modifier_token1] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3736),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_null] = ACTIONS(3736),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_COLON] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(4572),
    [anon_sym_AMP] = ACTIONS(3736),
    [anon_sym_LBRACK] = ACTIONS(3736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3734),
    [anon_sym_LBRACE] = ACTIONS(3736),
    [anon_sym_LT_AT] = ACTIONS(3736),
    [anon_sym_LT_AT_AT] = ACTIONS(3736),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3734),
    [anon_sym_new] = ACTIONS(3736),
    [anon_sym_with] = ACTIONS(3736),
    [anon_sym_return_BANG] = ACTIONS(3734),
    [anon_sym_yield] = ACTIONS(3736),
    [anon_sym_yield_BANG] = ACTIONS(3734),
    [anon_sym_lazy] = ACTIONS(3736),
    [anon_sym_assert] = ACTIONS(3736),
    [anon_sym_upcast] = ACTIONS(3736),
    [anon_sym_downcast] = ACTIONS(3736),
    [anon_sym_COLON_GT] = ACTIONS(3734),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3734),
    [anon_sym_for] = ACTIONS(3736),
    [anon_sym_while] = ACTIONS(3736),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_fun] = ACTIONS(3736),
    [anon_sym_try] = ACTIONS(3736),
    [anon_sym_match] = ACTIONS(3736),
    [anon_sym_match_BANG] = ACTIONS(3734),
    [anon_sym_function] = ACTIONS(3736),
    [anon_sym_LT_DASH] = ACTIONS(3736),
    [anon_sym_DOT_LBRACK] = ACTIONS(3734),
    [anon_sym_LT] = ACTIONS(3734),
    [anon_sym_use] = ACTIONS(3736),
    [anon_sym_use_BANG] = ACTIONS(3734),
    [anon_sym_do_BANG] = ACTIONS(3734),
    [anon_sym_begin] = ACTIONS(3736),
    [anon_sym_LPAREN2] = ACTIONS(3736),
    [anon_sym_DOT_DOT2] = ACTIONS(3734),
    [anon_sym_default] = ACTIONS(3736),
    [anon_sym_or] = ACTIONS(3736),
    [anon_sym_static] = ACTIONS(3736),
    [anon_sym_member] = ACTIONS(3736),
    [anon_sym_interface] = ACTIONS(3736),
    [anon_sym_abstract] = ACTIONS(3736),
    [anon_sym_val] = ACTIONS(3736),
    [anon_sym_override] = ACTIONS(3736),
    [aux_sym_char_token1] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3736),
    [anon_sym_DQUOTE] = ACTIONS(3736),
    [anon_sym_AT_DQUOTE] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [sym_bool] = ACTIONS(3736),
    [sym_unit] = ACTIONS(3734),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3736),
    [sym_op_identifier] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS_DOT] = ACTIONS(3736),
    [anon_sym_DASH_DOT] = ACTIONS(3736),
    [anon_sym_PERCENT] = ACTIONS(3736),
    [anon_sym_AMP_AMP] = ACTIONS(3736),
    [anon_sym_TILDE] = ACTIONS(3734),
    [aux_sym_prefix_op_token1] = ACTIONS(3736),
    [aux_sym_infix_op_token1] = ACTIONS(3734),
    [aux_sym_infix_op_token2] = ACTIONS(3736),
    [anon_sym_PIPE_PIPE] = ACTIONS(3736),
    [anon_sym_BANG_EQ] = ACTIONS(3736),
    [anon_sym_COLON_EQ] = ACTIONS(3734),
    [anon_sym_DOLLAR] = ACTIONS(3736),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3736),
    [sym_int] = ACTIONS(3736),
    [sym_xint] = ACTIONS(3734),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3734),
    [sym__newline] = ACTIONS(4590),
    [sym__dedent] = ACTIONS(3734),
  },
  [1633] = {
    [sym_block_comment] = STATE(1633),
    [sym_compiler_directive_decl] = STATE(1633),
    [sym_fsi_directive_decl] = STATE(1633),
    [sym_preproc_line] = STATE(1633),
    [sym_identifier] = ACTIONS(3732),
    [anon_sym_EQ] = ACTIONS(3730),
    [anon_sym_LBRACK_LT] = ACTIONS(3730),
    [anon_sym_COLON] = ACTIONS(3732),
    [anon_sym_return] = ACTIONS(3732),
    [anon_sym_do] = ACTIONS(3732),
    [anon_sym_and] = ACTIONS(3732),
    [anon_sym_let] = ACTIONS(3732),
    [anon_sym_let_BANG] = ACTIONS(3730),
    [aux_sym_access_modifier_token1] = ACTIONS(3730),
    [anon_sym_LPAREN] = ACTIONS(3732),
    [anon_sym_COMMA] = ACTIONS(3730),
    [anon_sym_null] = ACTIONS(3732),
    [anon_sym_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_LBRACK] = ACTIONS(3732),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3730),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_LT_AT] = ACTIONS(3732),
    [anon_sym_LT_AT_AT] = ACTIONS(3732),
    [anon_sym_DOT] = ACTIONS(3732),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3730),
    [anon_sym_new] = ACTIONS(3732),
    [anon_sym_with] = ACTIONS(3732),
    [anon_sym_return_BANG] = ACTIONS(3730),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_yield_BANG] = ACTIONS(3730),
    [anon_sym_lazy] = ACTIONS(3732),
    [anon_sym_assert] = ACTIONS(3732),
    [anon_sym_upcast] = ACTIONS(3732),
    [anon_sym_downcast] = ACTIONS(3732),
    [anon_sym_COLON_GT] = ACTIONS(3730),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3730),
    [anon_sym_for] = ACTIONS(3732),
    [anon_sym_while] = ACTIONS(3732),
    [anon_sym_else] = ACTIONS(3732),
    [anon_sym_elif] = ACTIONS(3732),
    [anon_sym_if] = ACTIONS(3732),
    [anon_sym_fun] = ACTIONS(3732),
    [anon_sym_try] = ACTIONS(3732),
    [anon_sym_match] = ACTIONS(3732),
    [anon_sym_match_BANG] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3732),
    [anon_sym_LT_DASH] = ACTIONS(3732),
    [anon_sym_DOT_LBRACK] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3730),
    [anon_sym_use] = ACTIONS(3732),
    [anon_sym_use_BANG] = ACTIONS(3730),
    [anon_sym_do_BANG] = ACTIONS(3730),
    [anon_sym_begin] = ACTIONS(3732),
    [anon_sym_LPAREN2] = ACTIONS(3732),
    [anon_sym_default] = ACTIONS(3732),
    [anon_sym_or] = ACTIONS(3732),
    [anon_sym_static] = ACTIONS(3732),
    [anon_sym_member] = ACTIONS(3732),
    [anon_sym_interface] = ACTIONS(3732),
    [anon_sym_abstract] = ACTIONS(3732),
    [anon_sym_val] = ACTIONS(3732),
    [anon_sym_override] = ACTIONS(3732),
    [aux_sym_char_token1] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3732),
    [anon_sym_DQUOTE] = ACTIONS(3732),
    [anon_sym_AT_DQUOTE] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [sym_bool] = ACTIONS(3732),
    [sym_unit] = ACTIONS(3730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3732),
    [sym_op_identifier] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PLUS_DOT] = ACTIONS(3732),
    [anon_sym_DASH_DOT] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3732),
    [anon_sym_AMP_AMP] = ACTIONS(3732),
    [anon_sym_TILDE] = ACTIONS(3730),
    [aux_sym_prefix_op_token1] = ACTIONS(3732),
    [aux_sym_infix_op_token1] = ACTIONS(3730),
    [aux_sym_infix_op_token2] = ACTIONS(3732),
    [anon_sym_PIPE_PIPE] = ACTIONS(3732),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_COLON_EQ] = ACTIONS(3730),
    [anon_sym_DOLLAR] = ACTIONS(3732),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3732),
    [sym_int] = ACTIONS(3732),
    [sym_xint] = ACTIONS(3730),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3730),
    [sym__newline] = ACTIONS(3730),
    [sym__dedent] = ACTIONS(3730),
  },
  [1634] = {
    [sym_block_comment] = STATE(1634),
    [sym_compiler_directive_decl] = STATE(1634),
    [sym_fsi_directive_decl] = STATE(1634),
    [sym_preproc_line] = STATE(1634),
    [aux_sym_sequential_expression_repeat1] = STATE(1634),
    [sym_identifier] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3765),
    [anon_sym_LBRACK_LT] = ACTIONS(3765),
    [anon_sym_COLON] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_let_BANG] = ACTIONS(3765),
    [aux_sym_access_modifier_token1] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(3767),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_null] = ACTIONS(3767),
    [anon_sym_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3765),
    [anon_sym_LBRACE] = ACTIONS(3767),
    [anon_sym_LT_AT] = ACTIONS(3767),
    [anon_sym_LT_AT_AT] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3765),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_with] = ACTIONS(3767),
    [anon_sym_return_BANG] = ACTIONS(3765),
    [anon_sym_yield] = ACTIONS(3767),
    [anon_sym_yield_BANG] = ACTIONS(3765),
    [anon_sym_lazy] = ACTIONS(3767),
    [anon_sym_assert] = ACTIONS(3767),
    [anon_sym_upcast] = ACTIONS(3767),
    [anon_sym_downcast] = ACTIONS(3767),
    [anon_sym_COLON_GT] = ACTIONS(3765),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3765),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_fun] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_match] = ACTIONS(3767),
    [anon_sym_match_BANG] = ACTIONS(3765),
    [anon_sym_function] = ACTIONS(3767),
    [anon_sym_LT_DASH] = ACTIONS(3767),
    [anon_sym_DOT_LBRACK] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(3765),
    [anon_sym_use] = ACTIONS(3767),
    [anon_sym_use_BANG] = ACTIONS(3765),
    [anon_sym_do_BANG] = ACTIONS(3765),
    [anon_sym_begin] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3767),
    [anon_sym_default] = ACTIONS(3767),
    [anon_sym_or] = ACTIONS(3767),
    [anon_sym_static] = ACTIONS(3767),
    [anon_sym_member] = ACTIONS(3767),
    [anon_sym_interface] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(3767),
    [anon_sym_val] = ACTIONS(3767),
    [anon_sym_override] = ACTIONS(3767),
    [anon_sym_inherit] = ACTIONS(3767),
    [aux_sym_char_token1] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3767),
    [anon_sym_DQUOTE] = ACTIONS(3767),
    [anon_sym_AT_DQUOTE] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [sym_bool] = ACTIONS(3767),
    [sym_unit] = ACTIONS(3765),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3767),
    [sym_op_identifier] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_PLUS_DOT] = ACTIONS(3767),
    [anon_sym_DASH_DOT] = ACTIONS(3767),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_AMP_AMP] = ACTIONS(3767),
    [anon_sym_TILDE] = ACTIONS(3765),
    [aux_sym_prefix_op_token1] = ACTIONS(3767),
    [aux_sym_infix_op_token1] = ACTIONS(3765),
    [aux_sym_infix_op_token2] = ACTIONS(3767),
    [anon_sym_PIPE_PIPE] = ACTIONS(3767),
    [anon_sym_BANG_EQ] = ACTIONS(3767),
    [anon_sym_COLON_EQ] = ACTIONS(3765),
    [anon_sym_DOLLAR] = ACTIONS(3767),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3767),
    [sym_int] = ACTIONS(3767),
    [sym_xint] = ACTIONS(3765),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3765),
    [anon_sym_POUNDendif] = ACTIONS(3765),
    [anon_sym_POUNDelse] = ACTIONS(3765),
    [sym__newline] = ACTIONS(4593),
  },
  [1635] = {
    [sym_block_comment] = STATE(1635),
    [sym_compiler_directive_decl] = STATE(1635),
    [sym_fsi_directive_decl] = STATE(1635),
    [sym_preproc_line] = STATE(1635),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_LBRACK_LT] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_and] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [aux_sym_access_modifier_token1] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_with] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(4394),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_default] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [anon_sym_static] = ACTIONS(3685),
    [anon_sym_member] = ACTIONS(3685),
    [anon_sym_interface] = ACTIONS(3685),
    [anon_sym_abstract] = ACTIONS(3685),
    [anon_sym_val] = ACTIONS(3685),
    [anon_sym_override] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [anon_sym_POUNDendif] = ACTIONS(3683),
    [anon_sym_POUNDelse] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
  },
  [1636] = {
    [sym_block_comment] = STATE(1636),
    [sym_compiler_directive_decl] = STATE(1636),
    [sym_fsi_directive_decl] = STATE(1636),
    [sym_preproc_line] = STATE(1636),
    [sym_identifier] = ACTIONS(3728),
    [anon_sym_EQ] = ACTIONS(3726),
    [anon_sym_LBRACK_LT] = ACTIONS(3726),
    [anon_sym_COLON] = ACTIONS(3728),
    [anon_sym_return] = ACTIONS(3728),
    [anon_sym_do] = ACTIONS(3728),
    [anon_sym_and] = ACTIONS(3728),
    [anon_sym_let] = ACTIONS(3728),
    [anon_sym_let_BANG] = ACTIONS(3726),
    [aux_sym_access_modifier_token1] = ACTIONS(3726),
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_COMMA] = ACTIONS(3726),
    [anon_sym_null] = ACTIONS(3728),
    [anon_sym_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(3726),
    [anon_sym_AMP] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3726),
    [anon_sym_LBRACE] = ACTIONS(3728),
    [anon_sym_LT_AT] = ACTIONS(3728),
    [anon_sym_LT_AT_AT] = ACTIONS(3728),
    [anon_sym_DOT] = ACTIONS(3728),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3726),
    [anon_sym_new] = ACTIONS(3728),
    [anon_sym_with] = ACTIONS(3728),
    [anon_sym_return_BANG] = ACTIONS(3726),
    [anon_sym_yield] = ACTIONS(3728),
    [anon_sym_yield_BANG] = ACTIONS(3726),
    [anon_sym_lazy] = ACTIONS(3728),
    [anon_sym_assert] = ACTIONS(3728),
    [anon_sym_upcast] = ACTIONS(3728),
    [anon_sym_downcast] = ACTIONS(3728),
    [anon_sym_COLON_GT] = ACTIONS(3726),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3726),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_fun] = ACTIONS(3728),
    [anon_sym_try] = ACTIONS(3728),
    [anon_sym_match] = ACTIONS(3728),
    [anon_sym_match_BANG] = ACTIONS(3726),
    [anon_sym_function] = ACTIONS(3728),
    [anon_sym_LT_DASH] = ACTIONS(3728),
    [anon_sym_DOT_LBRACK] = ACTIONS(3726),
    [anon_sym_LT] = ACTIONS(3726),
    [anon_sym_use] = ACTIONS(3728),
    [anon_sym_use_BANG] = ACTIONS(3726),
    [anon_sym_do_BANG] = ACTIONS(3726),
    [anon_sym_begin] = ACTIONS(3728),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_default] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [anon_sym_static] = ACTIONS(3728),
    [anon_sym_member] = ACTIONS(3728),
    [anon_sym_interface] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(3728),
    [anon_sym_val] = ACTIONS(3728),
    [anon_sym_override] = ACTIONS(3728),
    [aux_sym_char_token1] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3728),
    [anon_sym_AT_DQUOTE] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [sym_bool] = ACTIONS(3728),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3728),
    [sym_op_identifier] = ACTIONS(3728),
    [anon_sym_PLUS] = ACTIONS(3728),
    [anon_sym_DASH] = ACTIONS(3728),
    [anon_sym_PLUS_DOT] = ACTIONS(3728),
    [anon_sym_DASH_DOT] = ACTIONS(3728),
    [anon_sym_PERCENT] = ACTIONS(3728),
    [anon_sym_AMP_AMP] = ACTIONS(3728),
    [anon_sym_TILDE] = ACTIONS(3726),
    [aux_sym_prefix_op_token1] = ACTIONS(3728),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token2] = ACTIONS(3728),
    [anon_sym_PIPE_PIPE] = ACTIONS(3728),
    [anon_sym_BANG_EQ] = ACTIONS(3728),
    [anon_sym_COLON_EQ] = ACTIONS(3726),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3728),
    [sym_int] = ACTIONS(3728),
    [sym_xint] = ACTIONS(3726),
    [anon_sym_f] = ACTIONS(3728),
    [aux_sym_decimal_token1] = ACTIONS(3728),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3726),
    [anon_sym_POUNDendif] = ACTIONS(3726),
    [sym__newline] = ACTIONS(3726),
  },
  [1637] = {
    [sym_type_arguments] = STATE(2244),
    [sym_long_identifier] = STATE(2231),
    [sym_block_comment] = STATE(1637),
    [sym_compiler_directive_decl] = STATE(1637),
    [sym_fsi_directive_decl] = STATE(1637),
    [sym_preproc_line] = STATE(1637),
    [aux_sym_compound_type_repeat1] = STATE(2219),
    [sym_identifier] = ACTIONS(4553),
    [anon_sym_EQ] = ACTIONS(3403),
    [anon_sym_GT_RBRACK] = ACTIONS(3403),
    [anon_sym_COLON] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_let_BANG] = ACTIONS(3403),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_COMMA] = ACTIONS(3403),
    [anon_sym_null] = ACTIONS(3407),
    [anon_sym_QMARK] = ACTIONS(3407),
    [anon_sym_COLON_QMARK] = ACTIONS(3407),
    [anon_sym_COLON_COLON] = ACTIONS(3403),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_RBRACK] = ACTIONS(3403),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3407),
    [anon_sym_RBRACE] = ACTIONS(3403),
    [anon_sym_LT_AT] = ACTIONS(3407),
    [anon_sym_LT_AT_AT] = ACTIONS(3407),
    [anon_sym_DOT] = ACTIONS(3407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_with] = ACTIONS(3407),
    [anon_sym_return_BANG] = ACTIONS(3403),
    [anon_sym_yield] = ACTIONS(3407),
    [anon_sym_yield_BANG] = ACTIONS(3403),
    [anon_sym_lazy] = ACTIONS(3407),
    [anon_sym_assert] = ACTIONS(3407),
    [anon_sym_upcast] = ACTIONS(3407),
    [anon_sym_downcast] = ACTIONS(3407),
    [anon_sym_COLON_GT] = ACTIONS(3403),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_to] = ACTIONS(3407),
    [anon_sym_downto] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_fun] = ACTIONS(3407),
    [anon_sym_DASH_GT] = ACTIONS(4555),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_match] = ACTIONS(3407),
    [anon_sym_match_BANG] = ACTIONS(3403),
    [anon_sym_function] = ACTIONS(3407),
    [anon_sym_LT_DASH] = ACTIONS(3407),
    [anon_sym_DOT_LBRACK] = ACTIONS(3403),
    [anon_sym_LT] = ACTIONS(3403),
    [anon_sym_use] = ACTIONS(3407),
    [anon_sym_use_BANG] = ACTIONS(3403),
    [anon_sym_do_BANG] = ACTIONS(3403),
    [anon_sym_begin] = ACTIONS(3407),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_DOT_DOT2] = ACTIONS(3403),
    [anon_sym_STAR] = ACTIONS(4557),
    [anon_sym_LT2] = ACTIONS(4559),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4561),
    [anon_sym_or] = ACTIONS(3407),
    [aux_sym_char_token1] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3407),
    [anon_sym_DQUOTE] = ACTIONS(3407),
    [anon_sym_AT_DQUOTE] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [sym_bool] = ACTIONS(3407),
    [sym_unit] = ACTIONS(3403),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3407),
    [sym_op_identifier] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_PLUS_DOT] = ACTIONS(3407),
    [anon_sym_DASH_DOT] = ACTIONS(3407),
    [anon_sym_PERCENT] = ACTIONS(3407),
    [anon_sym_AMP_AMP] = ACTIONS(3407),
    [anon_sym_TILDE] = ACTIONS(3403),
    [aux_sym_prefix_op_token1] = ACTIONS(3407),
    [aux_sym_infix_op_token1] = ACTIONS(3403),
    [aux_sym_infix_op_token2] = ACTIONS(3407),
    [anon_sym_PIPE_PIPE] = ACTIONS(3407),
    [anon_sym_BANG_EQ] = ACTIONS(3407),
    [anon_sym_COLON_EQ] = ACTIONS(3403),
    [anon_sym_DOLLAR] = ACTIONS(3407),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3407),
    [sym_int] = ACTIONS(3407),
    [sym_xint] = ACTIONS(3403),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3403),
    [sym__newline] = ACTIONS(3403),
  },
  [1638] = {
    [sym_block_comment] = STATE(1638),
    [sym_compiler_directive_decl] = STATE(1638),
    [sym_fsi_directive_decl] = STATE(1638),
    [sym_preproc_line] = STATE(1638),
    [aux_sym_rules_repeat1] = STATE(1682),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_LBRACK_LT] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_and] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [aux_sym_access_modifier_token1] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(4521),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_with] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_default] = ACTIONS(3693),
    [anon_sym_or] = ACTIONS(3693),
    [anon_sym_static] = ACTIONS(3693),
    [anon_sym_member] = ACTIONS(3693),
    [anon_sym_interface] = ACTIONS(3693),
    [anon_sym_abstract] = ACTIONS(3693),
    [anon_sym_val] = ACTIONS(3693),
    [anon_sym_override] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(4596),
    [sym__dedent] = ACTIONS(3691),
  },
  [1639] = {
    [sym_block_comment] = STATE(1639),
    [sym_compiler_directive_decl] = STATE(1639),
    [sym_fsi_directive_decl] = STATE(1639),
    [sym_preproc_line] = STATE(1639),
    [aux_sym_long_identifier_repeat1] = STATE(1628),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_LBRACK_LT] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_and] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [aux_sym_access_modifier_token1] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(4599),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_default] = ACTIONS(3451),
    [anon_sym_or] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_member] = ACTIONS(3451),
    [anon_sym_interface] = ACTIONS(3451),
    [anon_sym_abstract] = ACTIONS(3451),
    [anon_sym_val] = ACTIONS(3451),
    [anon_sym_override] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [anon_sym_POUNDendif] = ACTIONS(3449),
    [anon_sym_POUNDelse] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
  },
  [1640] = {
    [sym_block_comment] = STATE(1640),
    [sym_compiler_directive_decl] = STATE(1640),
    [sym_fsi_directive_decl] = STATE(1640),
    [sym_preproc_line] = STATE(1640),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_LBRACK_LT] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [aux_sym_access_modifier_token1] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_with] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_default] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [anon_sym_static] = ACTIONS(3604),
    [anon_sym_member] = ACTIONS(3604),
    [anon_sym_interface] = ACTIONS(3604),
    [anon_sym_abstract] = ACTIONS(3604),
    [anon_sym_val] = ACTIONS(3604),
    [anon_sym_override] = ACTIONS(3604),
    [anon_sym_inherit] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [anon_sym_POUNDendif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
  },
  [1641] = {
    [sym_block_comment] = STATE(1641),
    [sym_compiler_directive_decl] = STATE(1641),
    [sym_fsi_directive_decl] = STATE(1641),
    [sym_preproc_line] = STATE(1641),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_LBRACK_LT] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [aux_sym_access_modifier_token1] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_with] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_default] = ACTIONS(3743),
    [anon_sym_or] = ACTIONS(3743),
    [anon_sym_static] = ACTIONS(3743),
    [anon_sym_member] = ACTIONS(3743),
    [anon_sym_interface] = ACTIONS(3743),
    [anon_sym_abstract] = ACTIONS(3743),
    [anon_sym_val] = ACTIONS(3743),
    [anon_sym_override] = ACTIONS(3743),
    [anon_sym_inherit] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [anon_sym_POUNDendif] = ACTIONS(3741),
    [anon_sym_POUNDelse] = ACTIONS(3741),
    [sym__newline] = ACTIONS(3741),
  },
  [1642] = {
    [sym_block_comment] = STATE(1642),
    [sym_compiler_directive_decl] = STATE(1642),
    [sym_fsi_directive_decl] = STATE(1642),
    [sym_preproc_line] = STATE(1642),
    [aux_sym_rules_repeat1] = STATE(1677),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_LBRACK_LT] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_and] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [aux_sym_access_modifier_token1] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(4521),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_with] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_default] = ACTIONS(3693),
    [anon_sym_or] = ACTIONS(3693),
    [anon_sym_static] = ACTIONS(3693),
    [anon_sym_member] = ACTIONS(3693),
    [anon_sym_interface] = ACTIONS(3693),
    [anon_sym_abstract] = ACTIONS(3693),
    [anon_sym_val] = ACTIONS(3693),
    [anon_sym_override] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(4596),
    [sym__dedent] = ACTIONS(3691),
  },
  [1643] = {
    [sym_block_comment] = STATE(1643),
    [sym_compiler_directive_decl] = STATE(1643),
    [sym_fsi_directive_decl] = STATE(1643),
    [sym_preproc_line] = STATE(1643),
    [sym_identifier] = ACTIONS(3813),
    [anon_sym_EQ] = ACTIONS(3811),
    [anon_sym_LBRACK_LT] = ACTIONS(3811),
    [anon_sym_COLON] = ACTIONS(3813),
    [anon_sym_return] = ACTIONS(3813),
    [anon_sym_do] = ACTIONS(3813),
    [anon_sym_and] = ACTIONS(3813),
    [anon_sym_let] = ACTIONS(3813),
    [anon_sym_let_BANG] = ACTIONS(3811),
    [aux_sym_access_modifier_token1] = ACTIONS(3811),
    [anon_sym_LPAREN] = ACTIONS(3813),
    [anon_sym_COMMA] = ACTIONS(3811),
    [anon_sym_null] = ACTIONS(3813),
    [anon_sym_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_COLON] = ACTIONS(3811),
    [anon_sym_AMP] = ACTIONS(3813),
    [anon_sym_LBRACK] = ACTIONS(3813),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3811),
    [anon_sym_LBRACE] = ACTIONS(3813),
    [anon_sym_LT_AT] = ACTIONS(3813),
    [anon_sym_LT_AT_AT] = ACTIONS(3813),
    [anon_sym_DOT] = ACTIONS(3813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3811),
    [anon_sym_new] = ACTIONS(3813),
    [anon_sym_with] = ACTIONS(3813),
    [anon_sym_return_BANG] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_yield_BANG] = ACTIONS(3811),
    [anon_sym_lazy] = ACTIONS(3813),
    [anon_sym_assert] = ACTIONS(3813),
    [anon_sym_upcast] = ACTIONS(3813),
    [anon_sym_downcast] = ACTIONS(3813),
    [anon_sym_COLON_GT] = ACTIONS(3811),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3811),
    [anon_sym_for] = ACTIONS(3813),
    [anon_sym_done] = ACTIONS(4601),
    [anon_sym_while] = ACTIONS(3813),
    [anon_sym_if] = ACTIONS(3813),
    [anon_sym_fun] = ACTIONS(3813),
    [anon_sym_try] = ACTIONS(3813),
    [anon_sym_match] = ACTIONS(3813),
    [anon_sym_match_BANG] = ACTIONS(3811),
    [anon_sym_function] = ACTIONS(3813),
    [anon_sym_LT_DASH] = ACTIONS(3813),
    [anon_sym_DOT_LBRACK] = ACTIONS(3811),
    [anon_sym_LT] = ACTIONS(3811),
    [anon_sym_use] = ACTIONS(3813),
    [anon_sym_use_BANG] = ACTIONS(3811),
    [anon_sym_do_BANG] = ACTIONS(3811),
    [anon_sym_begin] = ACTIONS(3813),
    [anon_sym_LPAREN2] = ACTIONS(3813),
    [anon_sym_default] = ACTIONS(3813),
    [anon_sym_or] = ACTIONS(3813),
    [anon_sym_static] = ACTIONS(3813),
    [anon_sym_member] = ACTIONS(3813),
    [anon_sym_interface] = ACTIONS(3813),
    [anon_sym_abstract] = ACTIONS(3813),
    [anon_sym_val] = ACTIONS(3813),
    [anon_sym_override] = ACTIONS(3813),
    [aux_sym_char_token1] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3813),
    [anon_sym_DQUOTE] = ACTIONS(3813),
    [anon_sym_AT_DQUOTE] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [sym_bool] = ACTIONS(3813),
    [sym_unit] = ACTIONS(3811),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3813),
    [sym_op_identifier] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PLUS_DOT] = ACTIONS(3813),
    [anon_sym_DASH_DOT] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3813),
    [anon_sym_AMP_AMP] = ACTIONS(3813),
    [anon_sym_TILDE] = ACTIONS(3811),
    [aux_sym_prefix_op_token1] = ACTIONS(3813),
    [aux_sym_infix_op_token1] = ACTIONS(3811),
    [aux_sym_infix_op_token2] = ACTIONS(3813),
    [anon_sym_PIPE_PIPE] = ACTIONS(3813),
    [anon_sym_BANG_EQ] = ACTIONS(3813),
    [anon_sym_COLON_EQ] = ACTIONS(3811),
    [anon_sym_DOLLAR] = ACTIONS(3813),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3813),
    [sym_int] = ACTIONS(3813),
    [sym_xint] = ACTIONS(3811),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3811),
    [anon_sym_POUNDendif] = ACTIONS(3811),
    [anon_sym_POUNDelse] = ACTIONS(3811),
    [sym__newline] = ACTIONS(3811),
  },
  [1644] = {
    [sym_block_comment] = STATE(1644),
    [sym_compiler_directive_decl] = STATE(1644),
    [sym_fsi_directive_decl] = STATE(1644),
    [sym_preproc_line] = STATE(1644),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_LBRACK_LT] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_and] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [aux_sym_access_modifier_token1] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_default] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [anon_sym_static] = ACTIONS(3700),
    [anon_sym_member] = ACTIONS(3700),
    [anon_sym_interface] = ACTIONS(3700),
    [anon_sym_abstract] = ACTIONS(3700),
    [anon_sym_val] = ACTIONS(3700),
    [anon_sym_override] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [anon_sym_POUNDendif] = ACTIONS(3698),
    [anon_sym_POUNDelse] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [1645] = {
    [sym_type_arguments] = STATE(2244),
    [sym_long_identifier] = STATE(2231),
    [sym_block_comment] = STATE(1645),
    [sym_compiler_directive_decl] = STATE(1645),
    [sym_fsi_directive_decl] = STATE(1645),
    [sym_preproc_line] = STATE(1645),
    [aux_sym_compound_type_repeat1] = STATE(2219),
    [sym_identifier] = ACTIONS(4553),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_GT_RBRACK] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_RBRACK] = ACTIONS(3425),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_RBRACE] = ACTIONS(3425),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3427),
    [anon_sym_DOT] = ACTIONS(3427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_with] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_COLON_GT] = ACTIONS(3425),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_to] = ACTIONS(3427),
    [anon_sym_downto] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(4555),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_LT_DASH] = ACTIONS(3427),
    [anon_sym_DOT_LBRACK] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_DOT_DOT2] = ACTIONS(3425),
    [anon_sym_STAR] = ACTIONS(4557),
    [anon_sym_LT2] = ACTIONS(4559),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4561),
    [anon_sym_or] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3427),
    [anon_sym_DASH_DOT] = ACTIONS(3427),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3427),
    [aux_sym_infix_op_token1] = ACTIONS(3425),
    [aux_sym_infix_op_token2] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3427),
    [anon_sym_COLON_EQ] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3427),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
  },
  [1646] = {
    [sym_block_comment] = STATE(1646),
    [sym_compiler_directive_decl] = STATE(1646),
    [sym_fsi_directive_decl] = STATE(1646),
    [sym_preproc_line] = STATE(1646),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_as] = ACTIONS(3193),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(4257),
    [anon_sym_uy] = ACTIONS(4259),
    [anon_sym_s] = ACTIONS(4261),
    [anon_sym_us] = ACTIONS(4263),
    [anon_sym_l] = ACTIONS(4265),
    [aux_sym_uint32_token1] = ACTIONS(4267),
    [anon_sym_n] = ACTIONS(4269),
    [anon_sym_un] = ACTIONS(4271),
    [anon_sym_L] = ACTIONS(4273),
    [aux_sym_uint64_token1] = ACTIONS(4275),
    [anon_sym_lf] = ACTIONS(4603),
    [anon_sym_LF] = ACTIONS(4605),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1647] = {
    [sym_block_comment] = STATE(1647),
    [sym_compiler_directive_decl] = STATE(1647),
    [sym_fsi_directive_decl] = STATE(1647),
    [sym_preproc_line] = STATE(1647),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_LBRACK_LT] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_and] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [aux_sym_access_modifier_token1] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_done] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_DOT_DOT] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_default] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [anon_sym_static] = ACTIONS(3700),
    [anon_sym_member] = ACTIONS(3700),
    [anon_sym_interface] = ACTIONS(3700),
    [anon_sym_abstract] = ACTIONS(3700),
    [anon_sym_val] = ACTIONS(3700),
    [anon_sym_override] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [anon_sym_POUNDendif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [1648] = {
    [sym_block_comment] = STATE(1648),
    [sym_compiler_directive_decl] = STATE(1648),
    [sym_fsi_directive_decl] = STATE(1648),
    [sym_preproc_line] = STATE(1648),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_LBRACK_LT] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_and] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [aux_sym_access_modifier_token1] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_else] = ACTIONS(3700),
    [anon_sym_elif] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_default] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [anon_sym_static] = ACTIONS(3700),
    [anon_sym_member] = ACTIONS(3700),
    [anon_sym_interface] = ACTIONS(3700),
    [anon_sym_abstract] = ACTIONS(3700),
    [anon_sym_val] = ACTIONS(3700),
    [anon_sym_override] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
    [sym__dedent] = ACTIONS(3698),
  },
  [1649] = {
    [sym_block_comment] = STATE(1649),
    [sym_compiler_directive_decl] = STATE(1649),
    [sym_fsi_directive_decl] = STATE(1649),
    [sym_preproc_line] = STATE(1649),
    [aux_sym_rules_repeat1] = STATE(1604),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_LBRACK_LT] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [aux_sym_access_modifier_token1] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(4516),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_with] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_default] = ACTIONS(3693),
    [anon_sym_or] = ACTIONS(3693),
    [anon_sym_static] = ACTIONS(3693),
    [anon_sym_member] = ACTIONS(3693),
    [anon_sym_interface] = ACTIONS(3693),
    [anon_sym_abstract] = ACTIONS(3693),
    [anon_sym_val] = ACTIONS(3693),
    [anon_sym_override] = ACTIONS(3693),
    [anon_sym_inherit] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [anon_sym_POUNDendif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(4587),
  },
  [1650] = {
    [sym_block_comment] = STATE(1650),
    [sym_compiler_directive_decl] = STATE(1650),
    [sym_fsi_directive_decl] = STATE(1650),
    [sym_preproc_line] = STATE(1650),
    [aux_sym_sequential_expression_repeat1] = STATE(1634),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_LBRACK_LT] = ACTIONS(3757),
    [anon_sym_COLON] = ACTIONS(3759),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_let_BANG] = ACTIONS(3757),
    [aux_sym_access_modifier_token1] = ACTIONS(3757),
    [anon_sym_LPAREN] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3757),
    [anon_sym_null] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3757),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_LT_AT] = ACTIONS(3759),
    [anon_sym_LT_AT_AT] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(3759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_with] = ACTIONS(3759),
    [anon_sym_return_BANG] = ACTIONS(3757),
    [anon_sym_yield] = ACTIONS(3759),
    [anon_sym_yield_BANG] = ACTIONS(3757),
    [anon_sym_lazy] = ACTIONS(3759),
    [anon_sym_assert] = ACTIONS(3759),
    [anon_sym_upcast] = ACTIONS(3759),
    [anon_sym_downcast] = ACTIONS(3759),
    [anon_sym_COLON_GT] = ACTIONS(3757),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3757),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_fun] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_match] = ACTIONS(3759),
    [anon_sym_match_BANG] = ACTIONS(3757),
    [anon_sym_function] = ACTIONS(3759),
    [anon_sym_LT_DASH] = ACTIONS(3759),
    [anon_sym_DOT_LBRACK] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_use] = ACTIONS(3759),
    [anon_sym_use_BANG] = ACTIONS(3757),
    [anon_sym_do_BANG] = ACTIONS(3757),
    [anon_sym_begin] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_default] = ACTIONS(3759),
    [anon_sym_or] = ACTIONS(3759),
    [anon_sym_static] = ACTIONS(3759),
    [anon_sym_member] = ACTIONS(3759),
    [anon_sym_interface] = ACTIONS(3759),
    [anon_sym_abstract] = ACTIONS(3759),
    [anon_sym_val] = ACTIONS(3759),
    [anon_sym_override] = ACTIONS(3759),
    [anon_sym_inherit] = ACTIONS(3759),
    [aux_sym_char_token1] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3759),
    [anon_sym_DQUOTE] = ACTIONS(3759),
    [anon_sym_AT_DQUOTE] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [sym_bool] = ACTIONS(3759),
    [sym_unit] = ACTIONS(3757),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3759),
    [sym_op_identifier] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS_DOT] = ACTIONS(3759),
    [anon_sym_DASH_DOT] = ACTIONS(3759),
    [anon_sym_PERCENT] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_TILDE] = ACTIONS(3757),
    [aux_sym_prefix_op_token1] = ACTIONS(3759),
    [aux_sym_infix_op_token1] = ACTIONS(3757),
    [aux_sym_infix_op_token2] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_COLON_EQ] = ACTIONS(3757),
    [anon_sym_DOLLAR] = ACTIONS(3759),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3759),
    [sym_int] = ACTIONS(3759),
    [sym_xint] = ACTIONS(3757),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3757),
    [anon_sym_POUNDendif] = ACTIONS(3757),
    [anon_sym_POUNDelse] = ACTIONS(3757),
    [sym__newline] = ACTIONS(3757),
  },
  [1651] = {
    [sym_block_comment] = STATE(1651),
    [sym_compiler_directive_decl] = STATE(1651),
    [sym_fsi_directive_decl] = STATE(1651),
    [sym_preproc_line] = STATE(1651),
    [sym_identifier] = ACTIONS(3732),
    [anon_sym_EQ] = ACTIONS(3730),
    [anon_sym_LBRACK_LT] = ACTIONS(3730),
    [anon_sym_COLON] = ACTIONS(3732),
    [anon_sym_return] = ACTIONS(3732),
    [anon_sym_do] = ACTIONS(3732),
    [anon_sym_and] = ACTIONS(3732),
    [anon_sym_let] = ACTIONS(3732),
    [anon_sym_let_BANG] = ACTIONS(3730),
    [aux_sym_access_modifier_token1] = ACTIONS(3730),
    [anon_sym_LPAREN] = ACTIONS(3732),
    [anon_sym_COMMA] = ACTIONS(3730),
    [anon_sym_null] = ACTIONS(3732),
    [anon_sym_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_LBRACK] = ACTIONS(3732),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3730),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_LT_AT] = ACTIONS(3732),
    [anon_sym_LT_AT_AT] = ACTIONS(3732),
    [anon_sym_DOT] = ACTIONS(3732),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3730),
    [anon_sym_new] = ACTIONS(3732),
    [anon_sym_with] = ACTIONS(3732),
    [anon_sym_return_BANG] = ACTIONS(3730),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_yield_BANG] = ACTIONS(3730),
    [anon_sym_lazy] = ACTIONS(3732),
    [anon_sym_assert] = ACTIONS(3732),
    [anon_sym_upcast] = ACTIONS(3732),
    [anon_sym_downcast] = ACTIONS(3732),
    [anon_sym_COLON_GT] = ACTIONS(3730),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3730),
    [anon_sym_for] = ACTIONS(3732),
    [anon_sym_while] = ACTIONS(3732),
    [anon_sym_else] = ACTIONS(3732),
    [anon_sym_elif] = ACTIONS(3732),
    [anon_sym_if] = ACTIONS(3732),
    [anon_sym_fun] = ACTIONS(3732),
    [anon_sym_try] = ACTIONS(3732),
    [anon_sym_match] = ACTIONS(3732),
    [anon_sym_match_BANG] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3732),
    [anon_sym_LT_DASH] = ACTIONS(3732),
    [anon_sym_DOT_LBRACK] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3730),
    [anon_sym_use] = ACTIONS(3732),
    [anon_sym_use_BANG] = ACTIONS(3730),
    [anon_sym_do_BANG] = ACTIONS(3730),
    [anon_sym_begin] = ACTIONS(3732),
    [anon_sym_LPAREN2] = ACTIONS(3732),
    [anon_sym_default] = ACTIONS(3732),
    [anon_sym_or] = ACTIONS(3732),
    [anon_sym_static] = ACTIONS(3732),
    [anon_sym_member] = ACTIONS(3732),
    [anon_sym_interface] = ACTIONS(3732),
    [anon_sym_abstract] = ACTIONS(3732),
    [anon_sym_val] = ACTIONS(3732),
    [anon_sym_override] = ACTIONS(3732),
    [aux_sym_char_token1] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3732),
    [anon_sym_DQUOTE] = ACTIONS(3732),
    [anon_sym_AT_DQUOTE] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [sym_bool] = ACTIONS(3732),
    [sym_unit] = ACTIONS(3730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3732),
    [sym_op_identifier] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PLUS_DOT] = ACTIONS(3732),
    [anon_sym_DASH_DOT] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3732),
    [anon_sym_AMP_AMP] = ACTIONS(3732),
    [anon_sym_TILDE] = ACTIONS(3730),
    [aux_sym_prefix_op_token1] = ACTIONS(3732),
    [aux_sym_infix_op_token1] = ACTIONS(3730),
    [aux_sym_infix_op_token2] = ACTIONS(3732),
    [anon_sym_PIPE_PIPE] = ACTIONS(3732),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_COLON_EQ] = ACTIONS(3730),
    [anon_sym_DOLLAR] = ACTIONS(3732),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3732),
    [sym_int] = ACTIONS(3732),
    [sym_xint] = ACTIONS(3730),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3730),
    [anon_sym_POUNDendif] = ACTIONS(3730),
    [sym__newline] = ACTIONS(3730),
  },
  [1652] = {
    [sym_block_comment] = STATE(1652),
    [sym_compiler_directive_decl] = STATE(1652),
    [sym_fsi_directive_decl] = STATE(1652),
    [sym_preproc_line] = STATE(1652),
    [aux_sym_sequential_expression_repeat1] = STATE(1652),
    [sym_identifier] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3765),
    [anon_sym_LBRACK_LT] = ACTIONS(3765),
    [anon_sym_COLON] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_and] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_let_BANG] = ACTIONS(3765),
    [aux_sym_access_modifier_token1] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(3767),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_null] = ACTIONS(3767),
    [anon_sym_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3765),
    [anon_sym_LBRACE] = ACTIONS(3767),
    [anon_sym_LT_AT] = ACTIONS(3767),
    [anon_sym_LT_AT_AT] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3765),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_with] = ACTIONS(3767),
    [anon_sym_return_BANG] = ACTIONS(3765),
    [anon_sym_yield] = ACTIONS(3767),
    [anon_sym_yield_BANG] = ACTIONS(3765),
    [anon_sym_lazy] = ACTIONS(3767),
    [anon_sym_assert] = ACTIONS(3767),
    [anon_sym_upcast] = ACTIONS(3767),
    [anon_sym_downcast] = ACTIONS(3767),
    [anon_sym_COLON_GT] = ACTIONS(3765),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3765),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_fun] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_match] = ACTIONS(3767),
    [anon_sym_match_BANG] = ACTIONS(3765),
    [anon_sym_function] = ACTIONS(3767),
    [anon_sym_LT_DASH] = ACTIONS(3767),
    [anon_sym_DOT_LBRACK] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(3765),
    [anon_sym_use] = ACTIONS(3767),
    [anon_sym_use_BANG] = ACTIONS(3765),
    [anon_sym_do_BANG] = ACTIONS(3765),
    [anon_sym_begin] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3767),
    [anon_sym_default] = ACTIONS(3767),
    [anon_sym_or] = ACTIONS(3767),
    [anon_sym_static] = ACTIONS(3767),
    [anon_sym_member] = ACTIONS(3767),
    [anon_sym_interface] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(3767),
    [anon_sym_val] = ACTIONS(3767),
    [anon_sym_override] = ACTIONS(3767),
    [aux_sym_char_token1] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3767),
    [anon_sym_DQUOTE] = ACTIONS(3767),
    [anon_sym_AT_DQUOTE] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [sym_bool] = ACTIONS(3767),
    [sym_unit] = ACTIONS(3765),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3767),
    [sym_op_identifier] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_PLUS_DOT] = ACTIONS(3767),
    [anon_sym_DASH_DOT] = ACTIONS(3767),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_AMP_AMP] = ACTIONS(3767),
    [anon_sym_TILDE] = ACTIONS(3765),
    [aux_sym_prefix_op_token1] = ACTIONS(3767),
    [aux_sym_infix_op_token1] = ACTIONS(3765),
    [aux_sym_infix_op_token2] = ACTIONS(3767),
    [anon_sym_PIPE_PIPE] = ACTIONS(3767),
    [anon_sym_BANG_EQ] = ACTIONS(3767),
    [anon_sym_COLON_EQ] = ACTIONS(3765),
    [anon_sym_DOLLAR] = ACTIONS(3767),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3767),
    [sym_int] = ACTIONS(3767),
    [sym_xint] = ACTIONS(3765),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3765),
    [anon_sym_POUNDendif] = ACTIONS(3765),
    [anon_sym_POUNDelse] = ACTIONS(3765),
    [sym__newline] = ACTIONS(4607),
  },
  [1653] = {
    [sym_type_arguments] = STATE(2257),
    [sym_long_identifier] = STATE(2259),
    [sym_block_comment] = STATE(1653),
    [sym_compiler_directive_decl] = STATE(1653),
    [sym_fsi_directive_decl] = STATE(1653),
    [sym_preproc_line] = STATE(1653),
    [aux_sym_compound_type_repeat1] = STATE(2191),
    [ts_builtin_sym_end] = ACTIONS(3403),
    [sym_identifier] = ACTIONS(4526),
    [anon_sym_namespace] = ACTIONS(3407),
    [anon_sym_module] = ACTIONS(3407),
    [anon_sym_EQ] = ACTIONS(3403),
    [anon_sym_open] = ACTIONS(3407),
    [anon_sym_LBRACK_LT] = ACTIONS(3403),
    [anon_sym_COLON] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_type] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_let_BANG] = ACTIONS(3403),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_COMMA] = ACTIONS(3403),
    [anon_sym_null] = ACTIONS(3407),
    [anon_sym_QMARK] = ACTIONS(3407),
    [anon_sym_COLON_QMARK] = ACTIONS(3407),
    [anon_sym_COLON_COLON] = ACTIONS(3403),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3407),
    [anon_sym_LT_AT] = ACTIONS(3407),
    [anon_sym_LT_AT_AT] = ACTIONS(3407),
    [anon_sym_DOT] = ACTIONS(3407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_return_BANG] = ACTIONS(3403),
    [anon_sym_yield] = ACTIONS(3407),
    [anon_sym_yield_BANG] = ACTIONS(3403),
    [anon_sym_lazy] = ACTIONS(3407),
    [anon_sym_assert] = ACTIONS(3407),
    [anon_sym_upcast] = ACTIONS(3407),
    [anon_sym_downcast] = ACTIONS(3407),
    [anon_sym_COLON_GT] = ACTIONS(3403),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_fun] = ACTIONS(3407),
    [anon_sym_DASH_GT] = ACTIONS(4528),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_match] = ACTIONS(3407),
    [anon_sym_match_BANG] = ACTIONS(3403),
    [anon_sym_function] = ACTIONS(3407),
    [anon_sym_LT_DASH] = ACTIONS(3407),
    [anon_sym_DOT_LBRACK] = ACTIONS(3403),
    [anon_sym_LT] = ACTIONS(3403),
    [anon_sym_use] = ACTIONS(3407),
    [anon_sym_use_BANG] = ACTIONS(3403),
    [anon_sym_do_BANG] = ACTIONS(3403),
    [anon_sym_begin] = ACTIONS(3407),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(4530),
    [anon_sym_LT2] = ACTIONS(4532),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4534),
    [anon_sym_or] = ACTIONS(3407),
    [anon_sym_exception] = ACTIONS(3407),
    [aux_sym_char_token1] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3407),
    [anon_sym_DQUOTE] = ACTIONS(3407),
    [anon_sym_AT_DQUOTE] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [sym_bool] = ACTIONS(3407),
    [sym_unit] = ACTIONS(3403),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3407),
    [sym_op_identifier] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_PLUS_DOT] = ACTIONS(3407),
    [anon_sym_DASH_DOT] = ACTIONS(3407),
    [anon_sym_PERCENT] = ACTIONS(3407),
    [anon_sym_AMP_AMP] = ACTIONS(3407),
    [anon_sym_TILDE] = ACTIONS(3403),
    [aux_sym_prefix_op_token1] = ACTIONS(3407),
    [aux_sym_infix_op_token1] = ACTIONS(3403),
    [aux_sym_infix_op_token2] = ACTIONS(3407),
    [anon_sym_PIPE_PIPE] = ACTIONS(3407),
    [anon_sym_BANG_EQ] = ACTIONS(3407),
    [anon_sym_COLON_EQ] = ACTIONS(3403),
    [anon_sym_DOLLAR] = ACTIONS(3407),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3407),
    [sym_int] = ACTIONS(3407),
    [sym_xint] = ACTIONS(3403),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3403),
    [anon_sym_POUNDload] = ACTIONS(3403),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3403),
    [sym__newline] = ACTIONS(3403),
  },
  [1654] = {
    [sym_type_arguments] = STATE(2257),
    [sym_long_identifier] = STATE(2259),
    [sym_block_comment] = STATE(1654),
    [sym_compiler_directive_decl] = STATE(1654),
    [sym_fsi_directive_decl] = STATE(1654),
    [sym_preproc_line] = STATE(1654),
    [aux_sym_compound_type_repeat1] = STATE(2191),
    [ts_builtin_sym_end] = ACTIONS(3425),
    [sym_identifier] = ACTIONS(4526),
    [anon_sym_namespace] = ACTIONS(3427),
    [anon_sym_module] = ACTIONS(3427),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_open] = ACTIONS(3427),
    [anon_sym_LBRACK_LT] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_type] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3427),
    [anon_sym_DOT] = ACTIONS(3427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_COLON_GT] = ACTIONS(3425),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(4528),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_LT_DASH] = ACTIONS(3427),
    [anon_sym_DOT_LBRACK] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(4530),
    [anon_sym_LT2] = ACTIONS(4532),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4534),
    [anon_sym_or] = ACTIONS(3427),
    [anon_sym_exception] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3427),
    [anon_sym_DASH_DOT] = ACTIONS(3427),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3427),
    [aux_sym_infix_op_token1] = ACTIONS(3425),
    [aux_sym_infix_op_token2] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3427),
    [anon_sym_COLON_EQ] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3427),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3425),
    [anon_sym_POUNDload] = ACTIONS(3425),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
  },
  [1655] = {
    [sym_block_comment] = STATE(1655),
    [sym_compiler_directive_decl] = STATE(1655),
    [sym_fsi_directive_decl] = STATE(1655),
    [sym_preproc_line] = STATE(1655),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_LBRACK_LT] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [aux_sym_access_modifier_token1] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_else] = ACTIONS(3700),
    [anon_sym_elif] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_DOT_DOT2] = ACTIONS(3698),
    [anon_sym_default] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [anon_sym_static] = ACTIONS(3700),
    [anon_sym_member] = ACTIONS(3700),
    [anon_sym_interface] = ACTIONS(3700),
    [anon_sym_abstract] = ACTIONS(3700),
    [anon_sym_val] = ACTIONS(3700),
    [anon_sym_override] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
    [sym__dedent] = ACTIONS(3698),
  },
  [1656] = {
    [sym_block_comment] = STATE(1656),
    [sym_compiler_directive_decl] = STATE(1656),
    [sym_fsi_directive_decl] = STATE(1656),
    [sym_preproc_line] = STATE(1656),
    [aux_sym_rules_repeat1] = STATE(1674),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_LBRACK_LT] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_and] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [aux_sym_access_modifier_token1] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(4563),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_with] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_default] = ACTIONS(3693),
    [anon_sym_or] = ACTIONS(3693),
    [anon_sym_static] = ACTIONS(3693),
    [anon_sym_member] = ACTIONS(3693),
    [anon_sym_interface] = ACTIONS(3693),
    [anon_sym_abstract] = ACTIONS(3693),
    [anon_sym_val] = ACTIONS(3693),
    [anon_sym_override] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [anon_sym_POUNDendif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(4610),
  },
  [1657] = {
    [sym_type_arguments] = STATE(2257),
    [sym_long_identifier] = STATE(2259),
    [sym_block_comment] = STATE(1657),
    [sym_compiler_directive_decl] = STATE(1657),
    [sym_fsi_directive_decl] = STATE(1657),
    [sym_preproc_line] = STATE(1657),
    [aux_sym_compound_type_repeat1] = STATE(2191),
    [ts_builtin_sym_end] = ACTIONS(3441),
    [sym_identifier] = ACTIONS(3443),
    [anon_sym_namespace] = ACTIONS(3443),
    [anon_sym_module] = ACTIONS(3443),
    [anon_sym_EQ] = ACTIONS(3441),
    [anon_sym_open] = ACTIONS(3443),
    [anon_sym_LBRACK_LT] = ACTIONS(3441),
    [anon_sym_COLON] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_type] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_let] = ACTIONS(3443),
    [anon_sym_let_BANG] = ACTIONS(3441),
    [anon_sym_LPAREN] = ACTIONS(3443),
    [anon_sym_COMMA] = ACTIONS(3441),
    [anon_sym_null] = ACTIONS(3443),
    [anon_sym_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_LT_AT] = ACTIONS(3443),
    [anon_sym_LT_AT_AT] = ACTIONS(3443),
    [anon_sym_DOT] = ACTIONS(3443),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_return_BANG] = ACTIONS(3441),
    [anon_sym_yield] = ACTIONS(3443),
    [anon_sym_yield_BANG] = ACTIONS(3441),
    [anon_sym_lazy] = ACTIONS(3443),
    [anon_sym_assert] = ACTIONS(3443),
    [anon_sym_upcast] = ACTIONS(3443),
    [anon_sym_downcast] = ACTIONS(3443),
    [anon_sym_COLON_GT] = ACTIONS(3441),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3441),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_fun] = ACTIONS(3443),
    [anon_sym_DASH_GT] = ACTIONS(4528),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_match] = ACTIONS(3443),
    [anon_sym_match_BANG] = ACTIONS(3441),
    [anon_sym_function] = ACTIONS(3443),
    [anon_sym_LT_DASH] = ACTIONS(3443),
    [anon_sym_DOT_LBRACK] = ACTIONS(3441),
    [anon_sym_LT] = ACTIONS(3441),
    [anon_sym_use] = ACTIONS(3443),
    [anon_sym_use_BANG] = ACTIONS(3441),
    [anon_sym_do_BANG] = ACTIONS(3441),
    [anon_sym_begin] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(4530),
    [anon_sym_LT2] = ACTIONS(4532),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4534),
    [anon_sym_or] = ACTIONS(3443),
    [anon_sym_exception] = ACTIONS(3443),
    [aux_sym_char_token1] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3443),
    [anon_sym_AT_DQUOTE] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [sym_bool] = ACTIONS(3443),
    [sym_unit] = ACTIONS(3441),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3443),
    [sym_op_identifier] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_PLUS_DOT] = ACTIONS(3443),
    [anon_sym_DASH_DOT] = ACTIONS(3443),
    [anon_sym_PERCENT] = ACTIONS(3443),
    [anon_sym_AMP_AMP] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3441),
    [aux_sym_prefix_op_token1] = ACTIONS(3443),
    [aux_sym_infix_op_token1] = ACTIONS(3441),
    [aux_sym_infix_op_token2] = ACTIONS(3443),
    [anon_sym_PIPE_PIPE] = ACTIONS(3443),
    [anon_sym_BANG_EQ] = ACTIONS(3443),
    [anon_sym_COLON_EQ] = ACTIONS(3441),
    [anon_sym_DOLLAR] = ACTIONS(3443),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3443),
    [sym_int] = ACTIONS(3443),
    [sym_xint] = ACTIONS(3441),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3441),
    [anon_sym_POUNDload] = ACTIONS(3441),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3441),
    [sym__newline] = ACTIONS(3441),
  },
  [1658] = {
    [sym_type_arguments] = STATE(2257),
    [sym_long_identifier] = STATE(2259),
    [sym_block_comment] = STATE(1658),
    [sym_compiler_directive_decl] = STATE(1658),
    [sym_fsi_directive_decl] = STATE(1658),
    [sym_preproc_line] = STATE(1658),
    [aux_sym_compound_type_repeat1] = STATE(2191),
    [ts_builtin_sym_end] = ACTIONS(3429),
    [sym_identifier] = ACTIONS(4526),
    [anon_sym_namespace] = ACTIONS(3431),
    [anon_sym_module] = ACTIONS(3431),
    [anon_sym_EQ] = ACTIONS(3429),
    [anon_sym_open] = ACTIONS(3431),
    [anon_sym_LBRACK_LT] = ACTIONS(3429),
    [anon_sym_COLON] = ACTIONS(3431),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_type] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_let] = ACTIONS(3431),
    [anon_sym_let_BANG] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(3431),
    [anon_sym_COMMA] = ACTIONS(3429),
    [anon_sym_null] = ACTIONS(3431),
    [anon_sym_QMARK] = ACTIONS(3431),
    [anon_sym_COLON_QMARK] = ACTIONS(3431),
    [anon_sym_COLON_COLON] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_LT_AT] = ACTIONS(3431),
    [anon_sym_LT_AT_AT] = ACTIONS(3431),
    [anon_sym_DOT] = ACTIONS(3431),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_return_BANG] = ACTIONS(3429),
    [anon_sym_yield] = ACTIONS(3431),
    [anon_sym_yield_BANG] = ACTIONS(3429),
    [anon_sym_lazy] = ACTIONS(3431),
    [anon_sym_assert] = ACTIONS(3431),
    [anon_sym_upcast] = ACTIONS(3431),
    [anon_sym_downcast] = ACTIONS(3431),
    [anon_sym_COLON_GT] = ACTIONS(3429),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_fun] = ACTIONS(3431),
    [anon_sym_DASH_GT] = ACTIONS(4528),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_match] = ACTIONS(3431),
    [anon_sym_match_BANG] = ACTIONS(3429),
    [anon_sym_function] = ACTIONS(3431),
    [anon_sym_LT_DASH] = ACTIONS(3431),
    [anon_sym_DOT_LBRACK] = ACTIONS(3429),
    [anon_sym_LT] = ACTIONS(3429),
    [anon_sym_use] = ACTIONS(3431),
    [anon_sym_use_BANG] = ACTIONS(3429),
    [anon_sym_do_BANG] = ACTIONS(3429),
    [anon_sym_begin] = ACTIONS(3431),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(4530),
    [anon_sym_LT2] = ACTIONS(4532),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4534),
    [anon_sym_or] = ACTIONS(3431),
    [anon_sym_exception] = ACTIONS(3431),
    [aux_sym_char_token1] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [anon_sym_AT_DQUOTE] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [sym_bool] = ACTIONS(3431),
    [sym_unit] = ACTIONS(3429),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3431),
    [sym_op_identifier] = ACTIONS(3431),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_DOT] = ACTIONS(3431),
    [anon_sym_DASH_DOT] = ACTIONS(3431),
    [anon_sym_PERCENT] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3429),
    [aux_sym_prefix_op_token1] = ACTIONS(3431),
    [aux_sym_infix_op_token1] = ACTIONS(3429),
    [aux_sym_infix_op_token2] = ACTIONS(3431),
    [anon_sym_PIPE_PIPE] = ACTIONS(3431),
    [anon_sym_BANG_EQ] = ACTIONS(3431),
    [anon_sym_COLON_EQ] = ACTIONS(3429),
    [anon_sym_DOLLAR] = ACTIONS(3431),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3431),
    [sym_int] = ACTIONS(3431),
    [sym_xint] = ACTIONS(3429),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3429),
    [anon_sym_POUNDload] = ACTIONS(3429),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3429),
    [sym__newline] = ACTIONS(3429),
  },
  [1659] = {
    [sym_type_arguments] = STATE(2244),
    [sym_long_identifier] = STATE(2231),
    [sym_block_comment] = STATE(1659),
    [sym_compiler_directive_decl] = STATE(1659),
    [sym_fsi_directive_decl] = STATE(1659),
    [sym_preproc_line] = STATE(1659),
    [aux_sym_compound_type_repeat1] = STATE(2219),
    [sym_identifier] = ACTIONS(4553),
    [anon_sym_EQ] = ACTIONS(3429),
    [anon_sym_GT_RBRACK] = ACTIONS(3429),
    [anon_sym_COLON] = ACTIONS(3431),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_let] = ACTIONS(3431),
    [anon_sym_let_BANG] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(3431),
    [anon_sym_COMMA] = ACTIONS(3429),
    [anon_sym_null] = ACTIONS(3431),
    [anon_sym_QMARK] = ACTIONS(3431),
    [anon_sym_COLON_QMARK] = ACTIONS(3431),
    [anon_sym_COLON_COLON] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_RBRACK] = ACTIONS(3429),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_RBRACE] = ACTIONS(3429),
    [anon_sym_LT_AT] = ACTIONS(3431),
    [anon_sym_LT_AT_AT] = ACTIONS(3431),
    [anon_sym_DOT] = ACTIONS(3431),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_with] = ACTIONS(3431),
    [anon_sym_return_BANG] = ACTIONS(3429),
    [anon_sym_yield] = ACTIONS(3431),
    [anon_sym_yield_BANG] = ACTIONS(3429),
    [anon_sym_lazy] = ACTIONS(3431),
    [anon_sym_assert] = ACTIONS(3431),
    [anon_sym_upcast] = ACTIONS(3431),
    [anon_sym_downcast] = ACTIONS(3431),
    [anon_sym_COLON_GT] = ACTIONS(3429),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_to] = ACTIONS(3431),
    [anon_sym_downto] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_fun] = ACTIONS(3431),
    [anon_sym_DASH_GT] = ACTIONS(4555),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_match] = ACTIONS(3431),
    [anon_sym_match_BANG] = ACTIONS(3429),
    [anon_sym_function] = ACTIONS(3431),
    [anon_sym_LT_DASH] = ACTIONS(3431),
    [anon_sym_DOT_LBRACK] = ACTIONS(3429),
    [anon_sym_LT] = ACTIONS(3429),
    [anon_sym_use] = ACTIONS(3431),
    [anon_sym_use_BANG] = ACTIONS(3429),
    [anon_sym_do_BANG] = ACTIONS(3429),
    [anon_sym_begin] = ACTIONS(3431),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_DOT_DOT2] = ACTIONS(3429),
    [anon_sym_STAR] = ACTIONS(4557),
    [anon_sym_LT2] = ACTIONS(4559),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4561),
    [anon_sym_or] = ACTIONS(3431),
    [aux_sym_char_token1] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [anon_sym_AT_DQUOTE] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [sym_bool] = ACTIONS(3431),
    [sym_unit] = ACTIONS(3429),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3431),
    [sym_op_identifier] = ACTIONS(3431),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_DOT] = ACTIONS(3431),
    [anon_sym_DASH_DOT] = ACTIONS(3431),
    [anon_sym_PERCENT] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3429),
    [aux_sym_prefix_op_token1] = ACTIONS(3431),
    [aux_sym_infix_op_token1] = ACTIONS(3429),
    [aux_sym_infix_op_token2] = ACTIONS(3431),
    [anon_sym_PIPE_PIPE] = ACTIONS(3431),
    [anon_sym_BANG_EQ] = ACTIONS(3431),
    [anon_sym_COLON_EQ] = ACTIONS(3429),
    [anon_sym_DOLLAR] = ACTIONS(3431),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3431),
    [sym_int] = ACTIONS(3431),
    [sym_xint] = ACTIONS(3429),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3429),
    [sym__newline] = ACTIONS(3429),
  },
  [1660] = {
    [sym_block_comment] = STATE(1660),
    [sym_compiler_directive_decl] = STATE(1660),
    [sym_fsi_directive_decl] = STATE(1660),
    [sym_preproc_line] = STATE(1660),
    [sym_identifier] = ACTIONS(3828),
    [anon_sym_EQ] = ACTIONS(3826),
    [anon_sym_LBRACK_LT] = ACTIONS(3826),
    [anon_sym_COLON] = ACTIONS(3828),
    [anon_sym_return] = ACTIONS(3828),
    [anon_sym_do] = ACTIONS(3828),
    [anon_sym_let] = ACTIONS(3828),
    [anon_sym_let_BANG] = ACTIONS(3826),
    [aux_sym_access_modifier_token1] = ACTIONS(3826),
    [anon_sym_LPAREN] = ACTIONS(3828),
    [anon_sym_COMMA] = ACTIONS(3826),
    [anon_sym_null] = ACTIONS(3828),
    [anon_sym_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_COLON] = ACTIONS(3826),
    [anon_sym_PIPE] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3828),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3826),
    [anon_sym_LBRACE] = ACTIONS(3828),
    [anon_sym_LT_AT] = ACTIONS(3828),
    [anon_sym_LT_AT_AT] = ACTIONS(3828),
    [anon_sym_DOT] = ACTIONS(3828),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3826),
    [anon_sym_new] = ACTIONS(3828),
    [anon_sym_with] = ACTIONS(3828),
    [anon_sym_return_BANG] = ACTIONS(3826),
    [anon_sym_yield] = ACTIONS(3828),
    [anon_sym_yield_BANG] = ACTIONS(3826),
    [anon_sym_lazy] = ACTIONS(3828),
    [anon_sym_assert] = ACTIONS(3828),
    [anon_sym_upcast] = ACTIONS(3828),
    [anon_sym_downcast] = ACTIONS(3828),
    [anon_sym_COLON_GT] = ACTIONS(3826),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3826),
    [anon_sym_for] = ACTIONS(3828),
    [anon_sym_while] = ACTIONS(3828),
    [anon_sym_if] = ACTIONS(3828),
    [anon_sym_fun] = ACTIONS(3828),
    [anon_sym_try] = ACTIONS(3828),
    [anon_sym_match] = ACTIONS(3828),
    [anon_sym_match_BANG] = ACTIONS(3826),
    [anon_sym_function] = ACTIONS(3828),
    [anon_sym_LT_DASH] = ACTIONS(3828),
    [anon_sym_DOT_LBRACK] = ACTIONS(3826),
    [anon_sym_LT] = ACTIONS(3826),
    [anon_sym_use] = ACTIONS(3828),
    [anon_sym_use_BANG] = ACTIONS(3826),
    [anon_sym_do_BANG] = ACTIONS(3826),
    [anon_sym_begin] = ACTIONS(3828),
    [anon_sym_LPAREN2] = ACTIONS(3828),
    [anon_sym_default] = ACTIONS(3828),
    [anon_sym_or] = ACTIONS(3828),
    [anon_sym_static] = ACTIONS(3828),
    [anon_sym_member] = ACTIONS(3828),
    [anon_sym_interface] = ACTIONS(3828),
    [anon_sym_abstract] = ACTIONS(3828),
    [anon_sym_val] = ACTIONS(3828),
    [anon_sym_override] = ACTIONS(3828),
    [anon_sym_inherit] = ACTIONS(3828),
    [aux_sym_char_token1] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3828),
    [anon_sym_DQUOTE] = ACTIONS(3828),
    [anon_sym_AT_DQUOTE] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [sym_bool] = ACTIONS(3828),
    [sym_unit] = ACTIONS(3826),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3828),
    [sym_op_identifier] = ACTIONS(3828),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_DASH] = ACTIONS(3828),
    [anon_sym_PLUS_DOT] = ACTIONS(3828),
    [anon_sym_DASH_DOT] = ACTIONS(3828),
    [anon_sym_PERCENT] = ACTIONS(3828),
    [anon_sym_AMP_AMP] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3826),
    [aux_sym_prefix_op_token1] = ACTIONS(3828),
    [aux_sym_infix_op_token1] = ACTIONS(3826),
    [aux_sym_infix_op_token2] = ACTIONS(3828),
    [anon_sym_PIPE_PIPE] = ACTIONS(3828),
    [anon_sym_BANG_EQ] = ACTIONS(3828),
    [anon_sym_COLON_EQ] = ACTIONS(3826),
    [anon_sym_DOLLAR] = ACTIONS(3828),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3828),
    [sym_int] = ACTIONS(3828),
    [sym_xint] = ACTIONS(3826),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3826),
    [anon_sym_POUNDendif] = ACTIONS(3826),
    [anon_sym_POUNDelse] = ACTIONS(3826),
    [sym__newline] = ACTIONS(3826),
  },
  [1661] = {
    [sym_block_comment] = STATE(1661),
    [sym_compiler_directive_decl] = STATE(1661),
    [sym_fsi_directive_decl] = STATE(1661),
    [sym_preproc_line] = STATE(1661),
    [sym_identifier] = ACTIONS(3732),
    [anon_sym_EQ] = ACTIONS(3730),
    [anon_sym_LBRACK_LT] = ACTIONS(3730),
    [anon_sym_COLON] = ACTIONS(3732),
    [anon_sym_return] = ACTIONS(3732),
    [anon_sym_do] = ACTIONS(3732),
    [anon_sym_let] = ACTIONS(3732),
    [anon_sym_let_BANG] = ACTIONS(3730),
    [aux_sym_access_modifier_token1] = ACTIONS(3730),
    [anon_sym_LPAREN] = ACTIONS(3732),
    [anon_sym_COMMA] = ACTIONS(3730),
    [anon_sym_null] = ACTIONS(3732),
    [anon_sym_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_LBRACK] = ACTIONS(3732),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3730),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_LT_AT] = ACTIONS(3732),
    [anon_sym_LT_AT_AT] = ACTIONS(3732),
    [anon_sym_DOT] = ACTIONS(3732),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3730),
    [anon_sym_new] = ACTIONS(3732),
    [anon_sym_with] = ACTIONS(3732),
    [anon_sym_return_BANG] = ACTIONS(3730),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_yield_BANG] = ACTIONS(3730),
    [anon_sym_lazy] = ACTIONS(3732),
    [anon_sym_assert] = ACTIONS(3732),
    [anon_sym_upcast] = ACTIONS(3732),
    [anon_sym_downcast] = ACTIONS(3732),
    [anon_sym_COLON_GT] = ACTIONS(3730),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3730),
    [anon_sym_for] = ACTIONS(3732),
    [anon_sym_while] = ACTIONS(3732),
    [anon_sym_else] = ACTIONS(3732),
    [anon_sym_elif] = ACTIONS(3732),
    [anon_sym_if] = ACTIONS(3732),
    [anon_sym_fun] = ACTIONS(3732),
    [anon_sym_try] = ACTIONS(3732),
    [anon_sym_match] = ACTIONS(3732),
    [anon_sym_match_BANG] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3732),
    [anon_sym_LT_DASH] = ACTIONS(3732),
    [anon_sym_DOT_LBRACK] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3730),
    [anon_sym_use] = ACTIONS(3732),
    [anon_sym_use_BANG] = ACTIONS(3730),
    [anon_sym_do_BANG] = ACTIONS(3730),
    [anon_sym_begin] = ACTIONS(3732),
    [anon_sym_LPAREN2] = ACTIONS(3732),
    [anon_sym_DOT_DOT2] = ACTIONS(3730),
    [anon_sym_default] = ACTIONS(3732),
    [anon_sym_or] = ACTIONS(3732),
    [anon_sym_static] = ACTIONS(3732),
    [anon_sym_member] = ACTIONS(3732),
    [anon_sym_interface] = ACTIONS(3732),
    [anon_sym_abstract] = ACTIONS(3732),
    [anon_sym_val] = ACTIONS(3732),
    [anon_sym_override] = ACTIONS(3732),
    [aux_sym_char_token1] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3732),
    [anon_sym_DQUOTE] = ACTIONS(3732),
    [anon_sym_AT_DQUOTE] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [sym_bool] = ACTIONS(3732),
    [sym_unit] = ACTIONS(3730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3732),
    [sym_op_identifier] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PLUS_DOT] = ACTIONS(3732),
    [anon_sym_DASH_DOT] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3732),
    [anon_sym_AMP_AMP] = ACTIONS(3732),
    [anon_sym_TILDE] = ACTIONS(3730),
    [aux_sym_prefix_op_token1] = ACTIONS(3732),
    [aux_sym_infix_op_token1] = ACTIONS(3730),
    [aux_sym_infix_op_token2] = ACTIONS(3732),
    [anon_sym_PIPE_PIPE] = ACTIONS(3732),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_COLON_EQ] = ACTIONS(3730),
    [anon_sym_DOLLAR] = ACTIONS(3732),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3732),
    [sym_int] = ACTIONS(3732),
    [sym_xint] = ACTIONS(3730),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3730),
    [sym__newline] = ACTIONS(3730),
    [sym__dedent] = ACTIONS(3730),
  },
  [1662] = {
    [sym_block_comment] = STATE(1662),
    [sym_compiler_directive_decl] = STATE(1662),
    [sym_fsi_directive_decl] = STATE(1662),
    [sym_preproc_line] = STATE(1662),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_and] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3339),
    [anon_sym_uy] = ACTIONS(3341),
    [anon_sym_s] = ACTIONS(3343),
    [anon_sym_us] = ACTIONS(3345),
    [anon_sym_l] = ACTIONS(3347),
    [aux_sym_uint32_token1] = ACTIONS(3349),
    [anon_sym_n] = ACTIONS(3351),
    [anon_sym_un] = ACTIONS(3353),
    [anon_sym_L] = ACTIONS(3355),
    [aux_sym_uint64_token1] = ACTIONS(3357),
    [anon_sym_lf] = ACTIONS(3437),
    [anon_sym_LF] = ACTIONS(3439),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
    [sym__dedent] = ACTIONS(3191),
  },
  [1663] = {
    [sym_block_comment] = STATE(1663),
    [sym_compiler_directive_decl] = STATE(1663),
    [sym_fsi_directive_decl] = STATE(1663),
    [sym_preproc_line] = STATE(1663),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_LBRACK_LT] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_and] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [aux_sym_access_modifier_token1] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_with] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(4613),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_DOT_DOT] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_default] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [anon_sym_static] = ACTIONS(3685),
    [anon_sym_member] = ACTIONS(3685),
    [anon_sym_interface] = ACTIONS(3685),
    [anon_sym_abstract] = ACTIONS(3685),
    [anon_sym_val] = ACTIONS(3685),
    [anon_sym_override] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
    [sym__dedent] = ACTIONS(3683),
  },
  [1664] = {
    [sym_block_comment] = STATE(1664),
    [sym_compiler_directive_decl] = STATE(1664),
    [sym_fsi_directive_decl] = STATE(1664),
    [sym_preproc_line] = STATE(1664),
    [sym_identifier] = ACTIONS(3841),
    [anon_sym_EQ] = ACTIONS(3839),
    [anon_sym_LBRACK_LT] = ACTIONS(3839),
    [anon_sym_COLON] = ACTIONS(3841),
    [anon_sym_return] = ACTIONS(3841),
    [anon_sym_do] = ACTIONS(3841),
    [anon_sym_let] = ACTIONS(3841),
    [anon_sym_let_BANG] = ACTIONS(3839),
    [aux_sym_access_modifier_token1] = ACTIONS(3839),
    [anon_sym_LPAREN] = ACTIONS(3841),
    [anon_sym_COMMA] = ACTIONS(3839),
    [anon_sym_null] = ACTIONS(3841),
    [anon_sym_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_COLON] = ACTIONS(3839),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_AMP] = ACTIONS(3841),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(3841),
    [anon_sym_LT_AT] = ACTIONS(3841),
    [anon_sym_LT_AT_AT] = ACTIONS(3841),
    [anon_sym_DOT] = ACTIONS(3841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3839),
    [anon_sym_new] = ACTIONS(3841),
    [anon_sym_with] = ACTIONS(3841),
    [anon_sym_return_BANG] = ACTIONS(3839),
    [anon_sym_yield] = ACTIONS(3841),
    [anon_sym_yield_BANG] = ACTIONS(3839),
    [anon_sym_lazy] = ACTIONS(3841),
    [anon_sym_assert] = ACTIONS(3841),
    [anon_sym_upcast] = ACTIONS(3841),
    [anon_sym_downcast] = ACTIONS(3841),
    [anon_sym_COLON_GT] = ACTIONS(3839),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3839),
    [anon_sym_for] = ACTIONS(3841),
    [anon_sym_while] = ACTIONS(3841),
    [anon_sym_if] = ACTIONS(3841),
    [anon_sym_fun] = ACTIONS(3841),
    [anon_sym_try] = ACTIONS(3841),
    [anon_sym_match] = ACTIONS(3841),
    [anon_sym_match_BANG] = ACTIONS(3839),
    [anon_sym_function] = ACTIONS(3841),
    [anon_sym_LT_DASH] = ACTIONS(3841),
    [anon_sym_DOT_LBRACK] = ACTIONS(3839),
    [anon_sym_LT] = ACTIONS(3839),
    [anon_sym_use] = ACTIONS(3841),
    [anon_sym_use_BANG] = ACTIONS(3839),
    [anon_sym_do_BANG] = ACTIONS(3839),
    [anon_sym_begin] = ACTIONS(3841),
    [anon_sym_LPAREN2] = ACTIONS(3841),
    [anon_sym_default] = ACTIONS(3841),
    [anon_sym_or] = ACTIONS(3841),
    [anon_sym_static] = ACTIONS(3841),
    [anon_sym_member] = ACTIONS(3841),
    [anon_sym_interface] = ACTIONS(3841),
    [anon_sym_abstract] = ACTIONS(3841),
    [anon_sym_val] = ACTIONS(3841),
    [anon_sym_override] = ACTIONS(3841),
    [anon_sym_inherit] = ACTIONS(3841),
    [aux_sym_char_token1] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3841),
    [anon_sym_DQUOTE] = ACTIONS(3841),
    [anon_sym_AT_DQUOTE] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [sym_bool] = ACTIONS(3841),
    [sym_unit] = ACTIONS(3839),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3841),
    [sym_op_identifier] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_PLUS_DOT] = ACTIONS(3841),
    [anon_sym_DASH_DOT] = ACTIONS(3841),
    [anon_sym_PERCENT] = ACTIONS(3841),
    [anon_sym_AMP_AMP] = ACTIONS(3841),
    [anon_sym_TILDE] = ACTIONS(3839),
    [aux_sym_prefix_op_token1] = ACTIONS(3841),
    [aux_sym_infix_op_token1] = ACTIONS(3839),
    [aux_sym_infix_op_token2] = ACTIONS(3841),
    [anon_sym_PIPE_PIPE] = ACTIONS(3841),
    [anon_sym_BANG_EQ] = ACTIONS(3841),
    [anon_sym_COLON_EQ] = ACTIONS(3839),
    [anon_sym_DOLLAR] = ACTIONS(3841),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3841),
    [sym_int] = ACTIONS(3841),
    [sym_xint] = ACTIONS(3839),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3839),
    [anon_sym_POUNDendif] = ACTIONS(3839),
    [anon_sym_POUNDelse] = ACTIONS(3839),
    [sym__newline] = ACTIONS(3839),
  },
  [1665] = {
    [sym_block_comment] = STATE(1665),
    [sym_compiler_directive_decl] = STATE(1665),
    [sym_fsi_directive_decl] = STATE(1665),
    [sym_preproc_line] = STATE(1665),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_LBRACK_LT] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [aux_sym_access_modifier_token1] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_done] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_DOT_DOT] = ACTIONS(3700),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_DOT_DOT2] = ACTIONS(3698),
    [anon_sym_default] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [anon_sym_static] = ACTIONS(3700),
    [anon_sym_member] = ACTIONS(3700),
    [anon_sym_interface] = ACTIONS(3700),
    [anon_sym_abstract] = ACTIONS(3700),
    [anon_sym_val] = ACTIONS(3700),
    [anon_sym_override] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
    [sym__dedent] = ACTIONS(3698),
  },
  [1666] = {
    [sym_block_comment] = STATE(1666),
    [sym_compiler_directive_decl] = STATE(1666),
    [sym_fsi_directive_decl] = STATE(1666),
    [sym_preproc_line] = STATE(1666),
    [aux_sym_rules_repeat1] = STATE(1621),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_LBRACK_LT] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [aux_sym_access_modifier_token1] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(4572),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_with] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_DOT_DOT2] = ACTIONS(3691),
    [anon_sym_default] = ACTIONS(3693),
    [anon_sym_or] = ACTIONS(3693),
    [anon_sym_static] = ACTIONS(3693),
    [anon_sym_member] = ACTIONS(3693),
    [anon_sym_interface] = ACTIONS(3693),
    [anon_sym_abstract] = ACTIONS(3693),
    [anon_sym_val] = ACTIONS(3693),
    [anon_sym_override] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(4615),
    [sym__dedent] = ACTIONS(3691),
  },
  [1667] = {
    [sym_block_comment] = STATE(1667),
    [sym_compiler_directive_decl] = STATE(1667),
    [sym_fsi_directive_decl] = STATE(1667),
    [sym_preproc_line] = STATE(1667),
    [aux_sym_rules_repeat1] = STATE(1670),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_LBRACK_LT] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [aux_sym_access_modifier_token1] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(4572),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_with] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_DOT_DOT2] = ACTIONS(3691),
    [anon_sym_default] = ACTIONS(3693),
    [anon_sym_or] = ACTIONS(3693),
    [anon_sym_static] = ACTIONS(3693),
    [anon_sym_member] = ACTIONS(3693),
    [anon_sym_interface] = ACTIONS(3693),
    [anon_sym_abstract] = ACTIONS(3693),
    [anon_sym_val] = ACTIONS(3693),
    [anon_sym_override] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(4615),
    [sym__dedent] = ACTIONS(3691),
  },
  [1668] = {
    [sym_block_comment] = STATE(1668),
    [sym_compiler_directive_decl] = STATE(1668),
    [sym_fsi_directive_decl] = STATE(1668),
    [sym_preproc_line] = STATE(1668),
    [aux_sym_rules_repeat1] = STATE(1674),
    [sym_identifier] = ACTIONS(3676),
    [anon_sym_EQ] = ACTIONS(3674),
    [anon_sym_LBRACK_LT] = ACTIONS(3674),
    [anon_sym_COLON] = ACTIONS(3676),
    [anon_sym_return] = ACTIONS(3676),
    [anon_sym_do] = ACTIONS(3676),
    [anon_sym_and] = ACTIONS(3676),
    [anon_sym_let] = ACTIONS(3676),
    [anon_sym_let_BANG] = ACTIONS(3674),
    [aux_sym_access_modifier_token1] = ACTIONS(3674),
    [anon_sym_LPAREN] = ACTIONS(3676),
    [anon_sym_COMMA] = ACTIONS(3674),
    [anon_sym_null] = ACTIONS(3676),
    [anon_sym_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_COLON] = ACTIONS(3674),
    [anon_sym_PIPE] = ACTIONS(4563),
    [anon_sym_AMP] = ACTIONS(3676),
    [anon_sym_LBRACK] = ACTIONS(3676),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3674),
    [anon_sym_LBRACE] = ACTIONS(3676),
    [anon_sym_LT_AT] = ACTIONS(3676),
    [anon_sym_LT_AT_AT] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3674),
    [anon_sym_new] = ACTIONS(3676),
    [anon_sym_with] = ACTIONS(3676),
    [anon_sym_return_BANG] = ACTIONS(3674),
    [anon_sym_yield] = ACTIONS(3676),
    [anon_sym_yield_BANG] = ACTIONS(3674),
    [anon_sym_lazy] = ACTIONS(3676),
    [anon_sym_assert] = ACTIONS(3676),
    [anon_sym_upcast] = ACTIONS(3676),
    [anon_sym_downcast] = ACTIONS(3676),
    [anon_sym_COLON_GT] = ACTIONS(3674),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3674),
    [anon_sym_for] = ACTIONS(3676),
    [anon_sym_while] = ACTIONS(3676),
    [anon_sym_if] = ACTIONS(3676),
    [anon_sym_fun] = ACTIONS(3676),
    [anon_sym_try] = ACTIONS(3676),
    [anon_sym_match] = ACTIONS(3676),
    [anon_sym_match_BANG] = ACTIONS(3674),
    [anon_sym_function] = ACTIONS(3676),
    [anon_sym_LT_DASH] = ACTIONS(3676),
    [anon_sym_DOT_LBRACK] = ACTIONS(3674),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_use] = ACTIONS(3676),
    [anon_sym_use_BANG] = ACTIONS(3674),
    [anon_sym_do_BANG] = ACTIONS(3674),
    [anon_sym_begin] = ACTIONS(3676),
    [anon_sym_LPAREN2] = ACTIONS(3676),
    [anon_sym_default] = ACTIONS(3676),
    [anon_sym_or] = ACTIONS(3676),
    [anon_sym_static] = ACTIONS(3676),
    [anon_sym_member] = ACTIONS(3676),
    [anon_sym_interface] = ACTIONS(3676),
    [anon_sym_abstract] = ACTIONS(3676),
    [anon_sym_val] = ACTIONS(3676),
    [anon_sym_override] = ACTIONS(3676),
    [aux_sym_char_token1] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3676),
    [anon_sym_DQUOTE] = ACTIONS(3676),
    [anon_sym_AT_DQUOTE] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [sym_bool] = ACTIONS(3676),
    [sym_unit] = ACTIONS(3674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3676),
    [sym_op_identifier] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_PLUS_DOT] = ACTIONS(3676),
    [anon_sym_DASH_DOT] = ACTIONS(3676),
    [anon_sym_PERCENT] = ACTIONS(3676),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_TILDE] = ACTIONS(3674),
    [aux_sym_prefix_op_token1] = ACTIONS(3676),
    [aux_sym_infix_op_token1] = ACTIONS(3674),
    [aux_sym_infix_op_token2] = ACTIONS(3676),
    [anon_sym_PIPE_PIPE] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3676),
    [anon_sym_COLON_EQ] = ACTIONS(3674),
    [anon_sym_DOLLAR] = ACTIONS(3676),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3676),
    [sym_int] = ACTIONS(3676),
    [sym_xint] = ACTIONS(3674),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3674),
    [anon_sym_POUNDendif] = ACTIONS(3674),
    [sym__newline] = ACTIONS(4618),
  },
  [1669] = {
    [sym_block_comment] = STATE(1669),
    [sym_compiler_directive_decl] = STATE(1669),
    [sym_fsi_directive_decl] = STATE(1669),
    [sym_preproc_line] = STATE(1669),
    [aux_sym_long_identifier_repeat1] = STATE(1678),
    [sym_identifier] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3778),
    [anon_sym_LBRACK_LT] = ACTIONS(3778),
    [anon_sym_COLON] = ACTIONS(3781),
    [anon_sym_return] = ACTIONS(3781),
    [anon_sym_do] = ACTIONS(3781),
    [anon_sym_let] = ACTIONS(3781),
    [anon_sym_let_BANG] = ACTIONS(3778),
    [aux_sym_access_modifier_token1] = ACTIONS(3778),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3778),
    [anon_sym_null] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3781),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_LT_AT] = ACTIONS(3781),
    [anon_sym_LT_AT_AT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(4621),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3778),
    [anon_sym_new] = ACTIONS(3781),
    [anon_sym_with] = ACTIONS(3781),
    [anon_sym_return_BANG] = ACTIONS(3778),
    [anon_sym_yield] = ACTIONS(3781),
    [anon_sym_yield_BANG] = ACTIONS(3778),
    [anon_sym_lazy] = ACTIONS(3781),
    [anon_sym_assert] = ACTIONS(3781),
    [anon_sym_upcast] = ACTIONS(3781),
    [anon_sym_downcast] = ACTIONS(3781),
    [anon_sym_COLON_GT] = ACTIONS(3778),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3778),
    [anon_sym_for] = ACTIONS(3781),
    [anon_sym_while] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_fun] = ACTIONS(3781),
    [anon_sym_try] = ACTIONS(3781),
    [anon_sym_match] = ACTIONS(3781),
    [anon_sym_match_BANG] = ACTIONS(3778),
    [anon_sym_function] = ACTIONS(3781),
    [anon_sym_LT_DASH] = ACTIONS(3781),
    [anon_sym_DOT_LBRACK] = ACTIONS(3778),
    [anon_sym_LT] = ACTIONS(3778),
    [anon_sym_use] = ACTIONS(3781),
    [anon_sym_use_BANG] = ACTIONS(3778),
    [anon_sym_do_BANG] = ACTIONS(3778),
    [anon_sym_begin] = ACTIONS(3781),
    [anon_sym_LPAREN2] = ACTIONS(3781),
    [anon_sym_default] = ACTIONS(3781),
    [anon_sym_or] = ACTIONS(3781),
    [anon_sym_static] = ACTIONS(3781),
    [anon_sym_member] = ACTIONS(3781),
    [anon_sym_interface] = ACTIONS(3781),
    [anon_sym_abstract] = ACTIONS(3781),
    [anon_sym_val] = ACTIONS(3781),
    [anon_sym_override] = ACTIONS(3781),
    [anon_sym_inherit] = ACTIONS(3781),
    [aux_sym_char_token1] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3781),
    [anon_sym_DQUOTE] = ACTIONS(3781),
    [anon_sym_AT_DQUOTE] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [sym_bool] = ACTIONS(3781),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3781),
    [sym_op_identifier] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3781),
    [anon_sym_DASH] = ACTIONS(3781),
    [anon_sym_PLUS_DOT] = ACTIONS(3781),
    [anon_sym_DASH_DOT] = ACTIONS(3781),
    [anon_sym_PERCENT] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3781),
    [anon_sym_TILDE] = ACTIONS(3778),
    [aux_sym_prefix_op_token1] = ACTIONS(3781),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token2] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_COLON_EQ] = ACTIONS(3778),
    [anon_sym_DOLLAR] = ACTIONS(3781),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3781),
    [sym_int] = ACTIONS(3781),
    [sym_xint] = ACTIONS(3778),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3778),
    [anon_sym_POUNDendif] = ACTIONS(3778),
    [anon_sym_POUNDelse] = ACTIONS(3778),
    [sym__newline] = ACTIONS(3778),
  },
  [1670] = {
    [sym_block_comment] = STATE(1670),
    [sym_compiler_directive_decl] = STATE(1670),
    [sym_fsi_directive_decl] = STATE(1670),
    [sym_preproc_line] = STATE(1670),
    [aux_sym_rules_repeat1] = STATE(1670),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_LBRACK_LT] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [aux_sym_access_modifier_token1] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(4625),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_with] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_DOT_DOT2] = ACTIONS(3741),
    [anon_sym_default] = ACTIONS(3743),
    [anon_sym_or] = ACTIONS(3743),
    [anon_sym_static] = ACTIONS(3743),
    [anon_sym_member] = ACTIONS(3743),
    [anon_sym_interface] = ACTIONS(3743),
    [anon_sym_abstract] = ACTIONS(3743),
    [anon_sym_val] = ACTIONS(3743),
    [anon_sym_override] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [sym__newline] = ACTIONS(4628),
    [sym__dedent] = ACTIONS(3741),
  },
  [1671] = {
    [sym_block_comment] = STATE(1671),
    [sym_compiler_directive_decl] = STATE(1671),
    [sym_fsi_directive_decl] = STATE(1671),
    [sym_preproc_line] = STATE(1671),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_LBRACK_LT] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_and] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [aux_sym_access_modifier_token1] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_done] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_DOT_DOT] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_default] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [anon_sym_static] = ACTIONS(3700),
    [anon_sym_member] = ACTIONS(3700),
    [anon_sym_interface] = ACTIONS(3700),
    [anon_sym_abstract] = ACTIONS(3700),
    [anon_sym_val] = ACTIONS(3700),
    [anon_sym_override] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
    [sym__dedent] = ACTIONS(3698),
  },
  [1672] = {
    [sym_block_comment] = STATE(1672),
    [sym_compiler_directive_decl] = STATE(1672),
    [sym_fsi_directive_decl] = STATE(1672),
    [sym_preproc_line] = STATE(1672),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_LBRACK_LT] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [aux_sym_access_modifier_token1] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_else] = ACTIONS(3700),
    [anon_sym_elif] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_default] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [anon_sym_static] = ACTIONS(3700),
    [anon_sym_member] = ACTIONS(3700),
    [anon_sym_interface] = ACTIONS(3700),
    [anon_sym_abstract] = ACTIONS(3700),
    [anon_sym_val] = ACTIONS(3700),
    [anon_sym_override] = ACTIONS(3700),
    [anon_sym_inherit] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [anon_sym_POUNDendif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [1673] = {
    [sym_block_comment] = STATE(1673),
    [sym_compiler_directive_decl] = STATE(1673),
    [sym_fsi_directive_decl] = STATE(1673),
    [sym_preproc_line] = STATE(1673),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_LBRACK_LT] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [aux_sym_access_modifier_token1] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_default] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [anon_sym_static] = ACTIONS(3700),
    [anon_sym_member] = ACTIONS(3700),
    [anon_sym_interface] = ACTIONS(3700),
    [anon_sym_abstract] = ACTIONS(3700),
    [anon_sym_val] = ACTIONS(3700),
    [anon_sym_override] = ACTIONS(3700),
    [anon_sym_inherit] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [anon_sym_POUNDendif] = ACTIONS(3698),
    [anon_sym_POUNDelse] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [1674] = {
    [sym_block_comment] = STATE(1674),
    [sym_compiler_directive_decl] = STATE(1674),
    [sym_fsi_directive_decl] = STATE(1674),
    [sym_preproc_line] = STATE(1674),
    [aux_sym_rules_repeat1] = STATE(1674),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_LBRACK_LT] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_and] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [aux_sym_access_modifier_token1] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(4631),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_with] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_default] = ACTIONS(3743),
    [anon_sym_or] = ACTIONS(3743),
    [anon_sym_static] = ACTIONS(3743),
    [anon_sym_member] = ACTIONS(3743),
    [anon_sym_interface] = ACTIONS(3743),
    [anon_sym_abstract] = ACTIONS(3743),
    [anon_sym_val] = ACTIONS(3743),
    [anon_sym_override] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [anon_sym_POUNDendif] = ACTIONS(3741),
    [sym__newline] = ACTIONS(4634),
  },
  [1675] = {
    [sym_block_comment] = STATE(1675),
    [sym_compiler_directive_decl] = STATE(1675),
    [sym_fsi_directive_decl] = STATE(1675),
    [sym_preproc_line] = STATE(1675),
    [sym_identifier] = ACTIONS(3732),
    [anon_sym_EQ] = ACTIONS(3730),
    [anon_sym_LBRACK_LT] = ACTIONS(3730),
    [anon_sym_COLON] = ACTIONS(3732),
    [anon_sym_return] = ACTIONS(3732),
    [anon_sym_do] = ACTIONS(3732),
    [anon_sym_let] = ACTIONS(3732),
    [anon_sym_let_BANG] = ACTIONS(3730),
    [aux_sym_access_modifier_token1] = ACTIONS(3730),
    [anon_sym_LPAREN] = ACTIONS(3732),
    [anon_sym_COMMA] = ACTIONS(3730),
    [anon_sym_null] = ACTIONS(3732),
    [anon_sym_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_LBRACK] = ACTIONS(3732),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3730),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_LT_AT] = ACTIONS(3732),
    [anon_sym_LT_AT_AT] = ACTIONS(3732),
    [anon_sym_DOT] = ACTIONS(3732),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3730),
    [anon_sym_new] = ACTIONS(3732),
    [anon_sym_with] = ACTIONS(3732),
    [anon_sym_return_BANG] = ACTIONS(3730),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_yield_BANG] = ACTIONS(3730),
    [anon_sym_lazy] = ACTIONS(3732),
    [anon_sym_assert] = ACTIONS(3732),
    [anon_sym_upcast] = ACTIONS(3732),
    [anon_sym_downcast] = ACTIONS(3732),
    [anon_sym_COLON_GT] = ACTIONS(3730),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3730),
    [anon_sym_for] = ACTIONS(3732),
    [anon_sym_while] = ACTIONS(3732),
    [anon_sym_else] = ACTIONS(3732),
    [anon_sym_elif] = ACTIONS(3732),
    [anon_sym_if] = ACTIONS(3732),
    [anon_sym_fun] = ACTIONS(3732),
    [anon_sym_try] = ACTIONS(3732),
    [anon_sym_match] = ACTIONS(3732),
    [anon_sym_match_BANG] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3732),
    [anon_sym_LT_DASH] = ACTIONS(3732),
    [anon_sym_DOT_LBRACK] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3730),
    [anon_sym_use] = ACTIONS(3732),
    [anon_sym_use_BANG] = ACTIONS(3730),
    [anon_sym_do_BANG] = ACTIONS(3730),
    [anon_sym_begin] = ACTIONS(3732),
    [anon_sym_LPAREN2] = ACTIONS(3732),
    [anon_sym_default] = ACTIONS(3732),
    [anon_sym_or] = ACTIONS(3732),
    [anon_sym_static] = ACTIONS(3732),
    [anon_sym_member] = ACTIONS(3732),
    [anon_sym_interface] = ACTIONS(3732),
    [anon_sym_abstract] = ACTIONS(3732),
    [anon_sym_val] = ACTIONS(3732),
    [anon_sym_override] = ACTIONS(3732),
    [anon_sym_inherit] = ACTIONS(3732),
    [aux_sym_char_token1] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3732),
    [anon_sym_DQUOTE] = ACTIONS(3732),
    [anon_sym_AT_DQUOTE] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [sym_bool] = ACTIONS(3732),
    [sym_unit] = ACTIONS(3730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3732),
    [sym_op_identifier] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PLUS_DOT] = ACTIONS(3732),
    [anon_sym_DASH_DOT] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3732),
    [anon_sym_AMP_AMP] = ACTIONS(3732),
    [anon_sym_TILDE] = ACTIONS(3730),
    [aux_sym_prefix_op_token1] = ACTIONS(3732),
    [aux_sym_infix_op_token1] = ACTIONS(3730),
    [aux_sym_infix_op_token2] = ACTIONS(3732),
    [anon_sym_PIPE_PIPE] = ACTIONS(3732),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_COLON_EQ] = ACTIONS(3730),
    [anon_sym_DOLLAR] = ACTIONS(3732),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3732),
    [sym_int] = ACTIONS(3732),
    [sym_xint] = ACTIONS(3730),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3730),
    [anon_sym_POUNDendif] = ACTIONS(3730),
    [sym__newline] = ACTIONS(3730),
  },
  [1676] = {
    [sym_block_comment] = STATE(1676),
    [sym_compiler_directive_decl] = STATE(1676),
    [sym_fsi_directive_decl] = STATE(1676),
    [sym_preproc_line] = STATE(1676),
    [aux_sym_rules_repeat1] = STATE(1668),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_LBRACK_LT] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_and] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [aux_sym_access_modifier_token1] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(4563),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_with] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_default] = ACTIONS(3693),
    [anon_sym_or] = ACTIONS(3693),
    [anon_sym_static] = ACTIONS(3693),
    [anon_sym_member] = ACTIONS(3693),
    [anon_sym_interface] = ACTIONS(3693),
    [anon_sym_abstract] = ACTIONS(3693),
    [anon_sym_val] = ACTIONS(3693),
    [anon_sym_override] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [anon_sym_POUNDendif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(4610),
  },
  [1677] = {
    [sym_block_comment] = STATE(1677),
    [sym_compiler_directive_decl] = STATE(1677),
    [sym_fsi_directive_decl] = STATE(1677),
    [sym_preproc_line] = STATE(1677),
    [aux_sym_rules_repeat1] = STATE(1677),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_LBRACK_LT] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_and] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [aux_sym_access_modifier_token1] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(4637),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_with] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_default] = ACTIONS(3743),
    [anon_sym_or] = ACTIONS(3743),
    [anon_sym_static] = ACTIONS(3743),
    [anon_sym_member] = ACTIONS(3743),
    [anon_sym_interface] = ACTIONS(3743),
    [anon_sym_abstract] = ACTIONS(3743),
    [anon_sym_val] = ACTIONS(3743),
    [anon_sym_override] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [sym__newline] = ACTIONS(4640),
    [sym__dedent] = ACTIONS(3741),
  },
  [1678] = {
    [sym_block_comment] = STATE(1678),
    [sym_compiler_directive_decl] = STATE(1678),
    [sym_fsi_directive_decl] = STATE(1678),
    [sym_preproc_line] = STATE(1678),
    [aux_sym_long_identifier_repeat1] = STATE(1603),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_LBRACK_LT] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [aux_sym_access_modifier_token1] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(4643),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_default] = ACTIONS(3451),
    [anon_sym_or] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_member] = ACTIONS(3451),
    [anon_sym_interface] = ACTIONS(3451),
    [anon_sym_abstract] = ACTIONS(3451),
    [anon_sym_val] = ACTIONS(3451),
    [anon_sym_override] = ACTIONS(3451),
    [anon_sym_inherit] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [anon_sym_POUNDendif] = ACTIONS(3449),
    [anon_sym_POUNDelse] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
  },
  [1679] = {
    [sym_block_comment] = STATE(1679),
    [sym_compiler_directive_decl] = STATE(1679),
    [sym_fsi_directive_decl] = STATE(1679),
    [sym_preproc_line] = STATE(1679),
    [sym_identifier] = ACTIONS(3753),
    [anon_sym_EQ] = ACTIONS(3751),
    [anon_sym_LBRACK_LT] = ACTIONS(3751),
    [anon_sym_COLON] = ACTIONS(3753),
    [anon_sym_return] = ACTIONS(3753),
    [anon_sym_do] = ACTIONS(3753),
    [anon_sym_and] = ACTIONS(3753),
    [anon_sym_let] = ACTIONS(3753),
    [anon_sym_let_BANG] = ACTIONS(3751),
    [aux_sym_access_modifier_token1] = ACTIONS(3751),
    [anon_sym_LPAREN] = ACTIONS(3753),
    [anon_sym_COMMA] = ACTIONS(3751),
    [anon_sym_null] = ACTIONS(3753),
    [anon_sym_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_COLON] = ACTIONS(3751),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3751),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_LT_AT] = ACTIONS(3753),
    [anon_sym_LT_AT_AT] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3753),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3751),
    [anon_sym_new] = ACTIONS(3753),
    [anon_sym_with] = ACTIONS(3753),
    [anon_sym_return_BANG] = ACTIONS(3751),
    [anon_sym_yield] = ACTIONS(3753),
    [anon_sym_yield_BANG] = ACTIONS(3751),
    [anon_sym_lazy] = ACTIONS(3753),
    [anon_sym_assert] = ACTIONS(3753),
    [anon_sym_upcast] = ACTIONS(3753),
    [anon_sym_downcast] = ACTIONS(3753),
    [anon_sym_COLON_GT] = ACTIONS(3751),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3751),
    [anon_sym_for] = ACTIONS(3753),
    [anon_sym_while] = ACTIONS(3753),
    [anon_sym_if] = ACTIONS(3753),
    [anon_sym_fun] = ACTIONS(3753),
    [anon_sym_try] = ACTIONS(3753),
    [anon_sym_match] = ACTIONS(3753),
    [anon_sym_match_BANG] = ACTIONS(3751),
    [anon_sym_function] = ACTIONS(3753),
    [anon_sym_LT_DASH] = ACTIONS(3753),
    [anon_sym_DOT_LBRACK] = ACTIONS(3751),
    [anon_sym_LT] = ACTIONS(3751),
    [anon_sym_use] = ACTIONS(3753),
    [anon_sym_use_BANG] = ACTIONS(3751),
    [anon_sym_do_BANG] = ACTIONS(3751),
    [anon_sym_begin] = ACTIONS(3753),
    [anon_sym_LPAREN2] = ACTIONS(3753),
    [anon_sym_default] = ACTIONS(3753),
    [anon_sym_or] = ACTIONS(3753),
    [anon_sym_static] = ACTIONS(3753),
    [anon_sym_member] = ACTIONS(3753),
    [anon_sym_interface] = ACTIONS(3753),
    [anon_sym_abstract] = ACTIONS(3753),
    [anon_sym_val] = ACTIONS(3753),
    [anon_sym_override] = ACTIONS(3753),
    [aux_sym_char_token1] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3753),
    [anon_sym_AT_DQUOTE] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [sym_bool] = ACTIONS(3753),
    [sym_unit] = ACTIONS(3751),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3753),
    [sym_op_identifier] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PLUS_DOT] = ACTIONS(3753),
    [anon_sym_DASH_DOT] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3753),
    [anon_sym_AMP_AMP] = ACTIONS(3753),
    [anon_sym_TILDE] = ACTIONS(3751),
    [aux_sym_prefix_op_token1] = ACTIONS(3753),
    [aux_sym_infix_op_token1] = ACTIONS(3751),
    [aux_sym_infix_op_token2] = ACTIONS(3753),
    [anon_sym_PIPE_PIPE] = ACTIONS(3753),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_COLON_EQ] = ACTIONS(3751),
    [anon_sym_DOLLAR] = ACTIONS(3753),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3753),
    [sym_int] = ACTIONS(4645),
    [sym_xint] = ACTIONS(3751),
    [anon_sym_f] = ACTIONS(3753),
    [aux_sym_decimal_token1] = ACTIONS(3753),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3751),
    [anon_sym_POUNDendif] = ACTIONS(3751),
    [sym__newline] = ACTIONS(3751),
  },
  [1680] = {
    [sym_block_comment] = STATE(1680),
    [sym_compiler_directive_decl] = STATE(1680),
    [sym_fsi_directive_decl] = STATE(1680),
    [sym_preproc_line] = STATE(1680),
    [sym_identifier] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3772),
    [anon_sym_LBRACK_LT] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3774),
    [anon_sym_do] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3774),
    [anon_sym_let_BANG] = ACTIONS(3772),
    [aux_sym_access_modifier_token1] = ACTIONS(3772),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3772),
    [anon_sym_null] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_COLON] = ACTIONS(3772),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_LT_AT] = ACTIONS(3774),
    [anon_sym_LT_AT_AT] = ACTIONS(3774),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3772),
    [anon_sym_new] = ACTIONS(3774),
    [anon_sym_with] = ACTIONS(3774),
    [anon_sym_return_BANG] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3774),
    [anon_sym_yield_BANG] = ACTIONS(3772),
    [anon_sym_lazy] = ACTIONS(3774),
    [anon_sym_assert] = ACTIONS(3774),
    [anon_sym_upcast] = ACTIONS(3774),
    [anon_sym_downcast] = ACTIONS(3774),
    [anon_sym_COLON_GT] = ACTIONS(3772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3774),
    [anon_sym_done] = ACTIONS(4647),
    [anon_sym_while] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3774),
    [anon_sym_fun] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3774),
    [anon_sym_match] = ACTIONS(3774),
    [anon_sym_match_BANG] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3774),
    [anon_sym_LT_DASH] = ACTIONS(3774),
    [anon_sym_DOT_LBRACK] = ACTIONS(3772),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_use] = ACTIONS(3774),
    [anon_sym_use_BANG] = ACTIONS(3772),
    [anon_sym_do_BANG] = ACTIONS(3772),
    [anon_sym_begin] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3774),
    [anon_sym_default] = ACTIONS(3774),
    [anon_sym_or] = ACTIONS(3774),
    [anon_sym_static] = ACTIONS(3774),
    [anon_sym_member] = ACTIONS(3774),
    [anon_sym_interface] = ACTIONS(3774),
    [anon_sym_abstract] = ACTIONS(3774),
    [anon_sym_val] = ACTIONS(3774),
    [anon_sym_override] = ACTIONS(3774),
    [anon_sym_inherit] = ACTIONS(3774),
    [aux_sym_char_token1] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_AT_DQUOTE] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [sym_bool] = ACTIONS(3774),
    [sym_unit] = ACTIONS(3772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3774),
    [sym_op_identifier] = ACTIONS(3774),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_DOT] = ACTIONS(3774),
    [anon_sym_DASH_DOT] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3772),
    [aux_sym_prefix_op_token1] = ACTIONS(3774),
    [aux_sym_infix_op_token1] = ACTIONS(3772),
    [aux_sym_infix_op_token2] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3774),
    [anon_sym_COLON_EQ] = ACTIONS(3772),
    [anon_sym_DOLLAR] = ACTIONS(3774),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3774),
    [sym_int] = ACTIONS(3774),
    [sym_xint] = ACTIONS(3772),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3772),
    [anon_sym_POUNDendif] = ACTIONS(3772),
    [anon_sym_POUNDelse] = ACTIONS(3772),
    [sym__newline] = ACTIONS(3772),
  },
  [1681] = {
    [sym_block_comment] = STATE(1681),
    [sym_compiler_directive_decl] = STATE(1681),
    [sym_fsi_directive_decl] = STATE(1681),
    [sym_preproc_line] = STATE(1681),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_LBRACK_LT] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_and] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [aux_sym_access_modifier_token1] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_with] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(4649),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_DOT_DOT] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_default] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [anon_sym_static] = ACTIONS(3685),
    [anon_sym_member] = ACTIONS(3685),
    [anon_sym_interface] = ACTIONS(3685),
    [anon_sym_abstract] = ACTIONS(3685),
    [anon_sym_val] = ACTIONS(3685),
    [anon_sym_override] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [anon_sym_POUNDendif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
  },
  [1682] = {
    [sym_block_comment] = STATE(1682),
    [sym_compiler_directive_decl] = STATE(1682),
    [sym_fsi_directive_decl] = STATE(1682),
    [sym_preproc_line] = STATE(1682),
    [aux_sym_rules_repeat1] = STATE(1677),
    [sym_identifier] = ACTIONS(3676),
    [anon_sym_EQ] = ACTIONS(3674),
    [anon_sym_LBRACK_LT] = ACTIONS(3674),
    [anon_sym_COLON] = ACTIONS(3676),
    [anon_sym_return] = ACTIONS(3676),
    [anon_sym_do] = ACTIONS(3676),
    [anon_sym_and] = ACTIONS(3676),
    [anon_sym_let] = ACTIONS(3676),
    [anon_sym_let_BANG] = ACTIONS(3674),
    [aux_sym_access_modifier_token1] = ACTIONS(3674),
    [anon_sym_LPAREN] = ACTIONS(3676),
    [anon_sym_COMMA] = ACTIONS(3674),
    [anon_sym_null] = ACTIONS(3676),
    [anon_sym_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_COLON] = ACTIONS(3674),
    [anon_sym_PIPE] = ACTIONS(4521),
    [anon_sym_AMP] = ACTIONS(3676),
    [anon_sym_LBRACK] = ACTIONS(3676),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3674),
    [anon_sym_LBRACE] = ACTIONS(3676),
    [anon_sym_LT_AT] = ACTIONS(3676),
    [anon_sym_LT_AT_AT] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3674),
    [anon_sym_new] = ACTIONS(3676),
    [anon_sym_with] = ACTIONS(3676),
    [anon_sym_return_BANG] = ACTIONS(3674),
    [anon_sym_yield] = ACTIONS(3676),
    [anon_sym_yield_BANG] = ACTIONS(3674),
    [anon_sym_lazy] = ACTIONS(3676),
    [anon_sym_assert] = ACTIONS(3676),
    [anon_sym_upcast] = ACTIONS(3676),
    [anon_sym_downcast] = ACTIONS(3676),
    [anon_sym_COLON_GT] = ACTIONS(3674),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3674),
    [anon_sym_for] = ACTIONS(3676),
    [anon_sym_while] = ACTIONS(3676),
    [anon_sym_if] = ACTIONS(3676),
    [anon_sym_fun] = ACTIONS(3676),
    [anon_sym_try] = ACTIONS(3676),
    [anon_sym_match] = ACTIONS(3676),
    [anon_sym_match_BANG] = ACTIONS(3674),
    [anon_sym_function] = ACTIONS(3676),
    [anon_sym_LT_DASH] = ACTIONS(3676),
    [anon_sym_DOT_LBRACK] = ACTIONS(3674),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_use] = ACTIONS(3676),
    [anon_sym_use_BANG] = ACTIONS(3674),
    [anon_sym_do_BANG] = ACTIONS(3674),
    [anon_sym_begin] = ACTIONS(3676),
    [anon_sym_LPAREN2] = ACTIONS(3676),
    [anon_sym_default] = ACTIONS(3676),
    [anon_sym_or] = ACTIONS(3676),
    [anon_sym_static] = ACTIONS(3676),
    [anon_sym_member] = ACTIONS(3676),
    [anon_sym_interface] = ACTIONS(3676),
    [anon_sym_abstract] = ACTIONS(3676),
    [anon_sym_val] = ACTIONS(3676),
    [anon_sym_override] = ACTIONS(3676),
    [aux_sym_char_token1] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3676),
    [anon_sym_DQUOTE] = ACTIONS(3676),
    [anon_sym_AT_DQUOTE] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [sym_bool] = ACTIONS(3676),
    [sym_unit] = ACTIONS(3674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3676),
    [sym_op_identifier] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_PLUS_DOT] = ACTIONS(3676),
    [anon_sym_DASH_DOT] = ACTIONS(3676),
    [anon_sym_PERCENT] = ACTIONS(3676),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_TILDE] = ACTIONS(3674),
    [aux_sym_prefix_op_token1] = ACTIONS(3676),
    [aux_sym_infix_op_token1] = ACTIONS(3674),
    [aux_sym_infix_op_token2] = ACTIONS(3676),
    [anon_sym_PIPE_PIPE] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3676),
    [anon_sym_COLON_EQ] = ACTIONS(3674),
    [anon_sym_DOLLAR] = ACTIONS(3676),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3676),
    [sym_int] = ACTIONS(3676),
    [sym_xint] = ACTIONS(3674),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3674),
    [sym__newline] = ACTIONS(4651),
    [sym__dedent] = ACTIONS(3674),
  },
  [1683] = {
    [sym_block_comment] = STATE(1683),
    [sym_compiler_directive_decl] = STATE(1683),
    [sym_fsi_directive_decl] = STATE(1683),
    [sym_preproc_line] = STATE(1683),
    [sym_identifier] = ACTIONS(4122),
    [anon_sym_EQ] = ACTIONS(4120),
    [anon_sym_LBRACK_LT] = ACTIONS(4120),
    [anon_sym_COLON] = ACTIONS(4122),
    [anon_sym_return] = ACTIONS(4122),
    [anon_sym_do] = ACTIONS(4122),
    [anon_sym_let] = ACTIONS(4122),
    [anon_sym_let_BANG] = ACTIONS(4120),
    [aux_sym_access_modifier_token1] = ACTIONS(4120),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_COMMA] = ACTIONS(4120),
    [anon_sym_null] = ACTIONS(4122),
    [anon_sym_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_COLON] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_LT_AT] = ACTIONS(4122),
    [anon_sym_LT_AT_AT] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4122),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4120),
    [anon_sym_new] = ACTIONS(4122),
    [anon_sym_with] = ACTIONS(4122),
    [anon_sym_return_BANG] = ACTIONS(4120),
    [anon_sym_yield] = ACTIONS(4122),
    [anon_sym_yield_BANG] = ACTIONS(4120),
    [anon_sym_lazy] = ACTIONS(4122),
    [anon_sym_assert] = ACTIONS(4122),
    [anon_sym_upcast] = ACTIONS(4122),
    [anon_sym_downcast] = ACTIONS(4122),
    [anon_sym_COLON_GT] = ACTIONS(4120),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4120),
    [anon_sym_for] = ACTIONS(4122),
    [anon_sym_while] = ACTIONS(4122),
    [anon_sym_if] = ACTIONS(4122),
    [anon_sym_fun] = ACTIONS(4122),
    [anon_sym_try] = ACTIONS(4122),
    [anon_sym_match] = ACTIONS(4122),
    [anon_sym_match_BANG] = ACTIONS(4120),
    [anon_sym_function] = ACTIONS(4122),
    [anon_sym_LT_DASH] = ACTIONS(4122),
    [anon_sym_DOT_LBRACK] = ACTIONS(4120),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_use] = ACTIONS(4122),
    [anon_sym_use_BANG] = ACTIONS(4120),
    [anon_sym_do_BANG] = ACTIONS(4120),
    [anon_sym_begin] = ACTIONS(4122),
    [anon_sym_LPAREN2] = ACTIONS(4122),
    [anon_sym_default] = ACTIONS(4122),
    [anon_sym_or] = ACTIONS(4122),
    [anon_sym_static] = ACTIONS(4122),
    [anon_sym_member] = ACTIONS(4122),
    [anon_sym_interface] = ACTIONS(4122),
    [anon_sym_abstract] = ACTIONS(4122),
    [anon_sym_val] = ACTIONS(4122),
    [anon_sym_override] = ACTIONS(4122),
    [anon_sym_inherit] = ACTIONS(4122),
    [aux_sym_char_token1] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4122),
    [anon_sym_DQUOTE] = ACTIONS(4122),
    [anon_sym_AT_DQUOTE] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [sym_bool] = ACTIONS(4122),
    [sym_unit] = ACTIONS(4120),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4122),
    [sym_op_identifier] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4122),
    [anon_sym_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_DOT] = ACTIONS(4122),
    [anon_sym_DASH_DOT] = ACTIONS(4122),
    [anon_sym_PERCENT] = ACTIONS(4122),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_TILDE] = ACTIONS(4120),
    [aux_sym_prefix_op_token1] = ACTIONS(4122),
    [aux_sym_infix_op_token1] = ACTIONS(4120),
    [aux_sym_infix_op_token2] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_COLON_EQ] = ACTIONS(4120),
    [anon_sym_DOLLAR] = ACTIONS(4122),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4122),
    [sym_int] = ACTIONS(4122),
    [sym_xint] = ACTIONS(4120),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4120),
    [anon_sym_POUNDendif] = ACTIONS(4120),
    [anon_sym_POUNDelse] = ACTIONS(4120),
    [sym__newline] = ACTIONS(4120),
  },
  [1684] = {
    [sym_block_comment] = STATE(1684),
    [sym_compiler_directive_decl] = STATE(1684),
    [sym_fsi_directive_decl] = STATE(1684),
    [sym_preproc_line] = STATE(1684),
    [sym_identifier] = ACTIONS(4180),
    [anon_sym_EQ] = ACTIONS(4178),
    [anon_sym_LBRACK_LT] = ACTIONS(4178),
    [anon_sym_COLON] = ACTIONS(4180),
    [anon_sym_return] = ACTIONS(4180),
    [anon_sym_do] = ACTIONS(4180),
    [anon_sym_and] = ACTIONS(4180),
    [anon_sym_let] = ACTIONS(4180),
    [anon_sym_let_BANG] = ACTIONS(4178),
    [aux_sym_access_modifier_token1] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(4180),
    [anon_sym_COMMA] = ACTIONS(4178),
    [anon_sym_null] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_COLON] = ACTIONS(4178),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4180),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4180),
    [anon_sym_LT_AT] = ACTIONS(4180),
    [anon_sym_LT_AT_AT] = ACTIONS(4180),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4178),
    [anon_sym_new] = ACTIONS(4180),
    [anon_sym_with] = ACTIONS(4180),
    [anon_sym_return_BANG] = ACTIONS(4178),
    [anon_sym_yield] = ACTIONS(4180),
    [anon_sym_yield_BANG] = ACTIONS(4178),
    [anon_sym_lazy] = ACTIONS(4180),
    [anon_sym_assert] = ACTIONS(4180),
    [anon_sym_upcast] = ACTIONS(4180),
    [anon_sym_downcast] = ACTIONS(4180),
    [anon_sym_COLON_GT] = ACTIONS(4178),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4178),
    [anon_sym_for] = ACTIONS(4180),
    [anon_sym_while] = ACTIONS(4180),
    [anon_sym_if] = ACTIONS(4180),
    [anon_sym_fun] = ACTIONS(4180),
    [anon_sym_try] = ACTIONS(4180),
    [anon_sym_match] = ACTIONS(4180),
    [anon_sym_match_BANG] = ACTIONS(4178),
    [anon_sym_function] = ACTIONS(4180),
    [anon_sym_LT_DASH] = ACTIONS(4180),
    [anon_sym_DOT_LBRACK] = ACTIONS(4178),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_use] = ACTIONS(4180),
    [anon_sym_use_BANG] = ACTIONS(4178),
    [anon_sym_do_BANG] = ACTIONS(4178),
    [anon_sym_begin] = ACTIONS(4180),
    [anon_sym_LPAREN2] = ACTIONS(4180),
    [anon_sym_default] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [anon_sym_static] = ACTIONS(4180),
    [anon_sym_member] = ACTIONS(4180),
    [anon_sym_interface] = ACTIONS(4180),
    [anon_sym_abstract] = ACTIONS(4180),
    [anon_sym_val] = ACTIONS(4180),
    [anon_sym_override] = ACTIONS(4180),
    [aux_sym_char_token1] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4180),
    [anon_sym_DQUOTE] = ACTIONS(4180),
    [anon_sym_AT_DQUOTE] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [sym_bool] = ACTIONS(4180),
    [sym_unit] = ACTIONS(4178),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4180),
    [sym_op_identifier] = ACTIONS(4180),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_PLUS_DOT] = ACTIONS(4180),
    [anon_sym_DASH_DOT] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_TILDE] = ACTIONS(4178),
    [aux_sym_prefix_op_token1] = ACTIONS(4180),
    [aux_sym_infix_op_token1] = ACTIONS(4178),
    [aux_sym_infix_op_token2] = ACTIONS(4180),
    [anon_sym_PIPE_PIPE] = ACTIONS(4180),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_COLON_EQ] = ACTIONS(4178),
    [anon_sym_DOLLAR] = ACTIONS(4180),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4180),
    [sym_int] = ACTIONS(4180),
    [sym_xint] = ACTIONS(4178),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4178),
    [anon_sym_POUNDendif] = ACTIONS(4178),
    [anon_sym_POUNDelse] = ACTIONS(4178),
    [sym__newline] = ACTIONS(4178),
  },
  [1685] = {
    [sym_block_comment] = STATE(1685),
    [sym_compiler_directive_decl] = STATE(1685),
    [sym_fsi_directive_decl] = STATE(1685),
    [sym_preproc_line] = STATE(1685),
    [aux_sym_long_identifier_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_LBRACK_LT] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [aux_sym_access_modifier_token1] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(4654),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_DOT_DOT2] = ACTIONS(3449),
    [anon_sym_default] = ACTIONS(3451),
    [anon_sym_or] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_member] = ACTIONS(3451),
    [anon_sym_interface] = ACTIONS(3451),
    [anon_sym_abstract] = ACTIONS(3451),
    [anon_sym_val] = ACTIONS(3451),
    [anon_sym_override] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
    [sym__dedent] = ACTIONS(3449),
  },
  [1686] = {
    [sym_block_comment] = STATE(1686),
    [sym_compiler_directive_decl] = STATE(1686),
    [sym_fsi_directive_decl] = STATE(1686),
    [sym_preproc_line] = STATE(1686),
    [sym_identifier] = ACTIONS(4186),
    [anon_sym_EQ] = ACTIONS(4184),
    [anon_sym_LBRACK_LT] = ACTIONS(4184),
    [anon_sym_COLON] = ACTIONS(4186),
    [anon_sym_return] = ACTIONS(4186),
    [anon_sym_do] = ACTIONS(4186),
    [anon_sym_and] = ACTIONS(4186),
    [anon_sym_let] = ACTIONS(4186),
    [anon_sym_let_BANG] = ACTIONS(4184),
    [aux_sym_access_modifier_token1] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_COMMA] = ACTIONS(4184),
    [anon_sym_null] = ACTIONS(4186),
    [anon_sym_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_COLON] = ACTIONS(4184),
    [anon_sym_AMP] = ACTIONS(4186),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4184),
    [anon_sym_LBRACE] = ACTIONS(4186),
    [anon_sym_LT_AT] = ACTIONS(4186),
    [anon_sym_LT_AT_AT] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4186),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4184),
    [anon_sym_new] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4186),
    [anon_sym_return_BANG] = ACTIONS(4184),
    [anon_sym_yield] = ACTIONS(4186),
    [anon_sym_yield_BANG] = ACTIONS(4184),
    [anon_sym_lazy] = ACTIONS(4186),
    [anon_sym_assert] = ACTIONS(4186),
    [anon_sym_upcast] = ACTIONS(4186),
    [anon_sym_downcast] = ACTIONS(4186),
    [anon_sym_COLON_GT] = ACTIONS(4184),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4184),
    [anon_sym_for] = ACTIONS(4186),
    [anon_sym_while] = ACTIONS(4186),
    [anon_sym_if] = ACTIONS(4186),
    [anon_sym_fun] = ACTIONS(4186),
    [anon_sym_try] = ACTIONS(4186),
    [anon_sym_match] = ACTIONS(4186),
    [anon_sym_match_BANG] = ACTIONS(4184),
    [anon_sym_function] = ACTIONS(4186),
    [anon_sym_LT_DASH] = ACTIONS(4186),
    [anon_sym_DOT_LBRACK] = ACTIONS(4184),
    [anon_sym_LT] = ACTIONS(4184),
    [anon_sym_use] = ACTIONS(4186),
    [anon_sym_use_BANG] = ACTIONS(4184),
    [anon_sym_do_BANG] = ACTIONS(4184),
    [anon_sym_begin] = ACTIONS(4186),
    [anon_sym_LPAREN2] = ACTIONS(4186),
    [anon_sym_default] = ACTIONS(4186),
    [anon_sym_or] = ACTIONS(4186),
    [anon_sym_static] = ACTIONS(4186),
    [anon_sym_member] = ACTIONS(4186),
    [anon_sym_interface] = ACTIONS(4186),
    [anon_sym_abstract] = ACTIONS(4186),
    [anon_sym_val] = ACTIONS(4186),
    [anon_sym_override] = ACTIONS(4186),
    [aux_sym_char_token1] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4186),
    [anon_sym_DQUOTE] = ACTIONS(4186),
    [anon_sym_AT_DQUOTE] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [sym_bool] = ACTIONS(4186),
    [sym_unit] = ACTIONS(4184),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4186),
    [sym_op_identifier] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4186),
    [anon_sym_DASH] = ACTIONS(4186),
    [anon_sym_PLUS_DOT] = ACTIONS(4186),
    [anon_sym_DASH_DOT] = ACTIONS(4186),
    [anon_sym_PERCENT] = ACTIONS(4186),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_TILDE] = ACTIONS(4184),
    [aux_sym_prefix_op_token1] = ACTIONS(4186),
    [aux_sym_infix_op_token1] = ACTIONS(4184),
    [aux_sym_infix_op_token2] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_COLON_EQ] = ACTIONS(4184),
    [anon_sym_DOLLAR] = ACTIONS(4186),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4186),
    [sym_int] = ACTIONS(4186),
    [sym_xint] = ACTIONS(4184),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4184),
    [anon_sym_POUNDendif] = ACTIONS(4184),
    [anon_sym_POUNDelse] = ACTIONS(4184),
    [sym__newline] = ACTIONS(4184),
  },
  [1687] = {
    [sym_block_comment] = STATE(1687),
    [sym_compiler_directive_decl] = STATE(1687),
    [sym_fsi_directive_decl] = STATE(1687),
    [sym_preproc_line] = STATE(1687),
    [sym_identifier] = ACTIONS(4208),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LBRACK_LT] = ACTIONS(4206),
    [anon_sym_COLON] = ACTIONS(4208),
    [anon_sym_return] = ACTIONS(4208),
    [anon_sym_do] = ACTIONS(4208),
    [anon_sym_and] = ACTIONS(4208),
    [anon_sym_let] = ACTIONS(4208),
    [anon_sym_let_BANG] = ACTIONS(4206),
    [aux_sym_access_modifier_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(4206),
    [anon_sym_null] = ACTIONS(4208),
    [anon_sym_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_COLON] = ACTIONS(4206),
    [anon_sym_AMP] = ACTIONS(4208),
    [anon_sym_LBRACK] = ACTIONS(4208),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4206),
    [anon_sym_LBRACE] = ACTIONS(4208),
    [anon_sym_LT_AT] = ACTIONS(4208),
    [anon_sym_LT_AT_AT] = ACTIONS(4208),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4206),
    [anon_sym_new] = ACTIONS(4208),
    [anon_sym_with] = ACTIONS(4208),
    [anon_sym_return_BANG] = ACTIONS(4206),
    [anon_sym_yield] = ACTIONS(4208),
    [anon_sym_yield_BANG] = ACTIONS(4206),
    [anon_sym_lazy] = ACTIONS(4208),
    [anon_sym_assert] = ACTIONS(4208),
    [anon_sym_upcast] = ACTIONS(4208),
    [anon_sym_downcast] = ACTIONS(4208),
    [anon_sym_COLON_GT] = ACTIONS(4206),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4206),
    [anon_sym_for] = ACTIONS(4208),
    [anon_sym_while] = ACTIONS(4208),
    [anon_sym_if] = ACTIONS(4208),
    [anon_sym_fun] = ACTIONS(4208),
    [anon_sym_try] = ACTIONS(4208),
    [anon_sym_match] = ACTIONS(4208),
    [anon_sym_match_BANG] = ACTIONS(4206),
    [anon_sym_function] = ACTIONS(4208),
    [anon_sym_LT_DASH] = ACTIONS(4208),
    [anon_sym_DOT_LBRACK] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(4206),
    [anon_sym_use] = ACTIONS(4208),
    [anon_sym_use_BANG] = ACTIONS(4206),
    [anon_sym_do_BANG] = ACTIONS(4206),
    [anon_sym_begin] = ACTIONS(4208),
    [anon_sym_LPAREN2] = ACTIONS(4208),
    [anon_sym_default] = ACTIONS(4208),
    [anon_sym_or] = ACTIONS(4208),
    [anon_sym_static] = ACTIONS(4208),
    [anon_sym_member] = ACTIONS(4208),
    [anon_sym_interface] = ACTIONS(4208),
    [anon_sym_abstract] = ACTIONS(4208),
    [anon_sym_val] = ACTIONS(4208),
    [anon_sym_override] = ACTIONS(4208),
    [aux_sym_char_token1] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4208),
    [anon_sym_DQUOTE] = ACTIONS(4208),
    [anon_sym_AT_DQUOTE] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [sym_bool] = ACTIONS(4208),
    [sym_unit] = ACTIONS(4206),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4208),
    [sym_op_identifier] = ACTIONS(4208),
    [anon_sym_PLUS] = ACTIONS(4208),
    [anon_sym_DASH] = ACTIONS(4208),
    [anon_sym_PLUS_DOT] = ACTIONS(4208),
    [anon_sym_DASH_DOT] = ACTIONS(4208),
    [anon_sym_PERCENT] = ACTIONS(4208),
    [anon_sym_AMP_AMP] = ACTIONS(4208),
    [anon_sym_TILDE] = ACTIONS(4206),
    [aux_sym_prefix_op_token1] = ACTIONS(4208),
    [aux_sym_infix_op_token1] = ACTIONS(4206),
    [aux_sym_infix_op_token2] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(4208),
    [anon_sym_BANG_EQ] = ACTIONS(4208),
    [anon_sym_COLON_EQ] = ACTIONS(4206),
    [anon_sym_DOLLAR] = ACTIONS(4208),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4208),
    [sym_int] = ACTIONS(4208),
    [sym_xint] = ACTIONS(4206),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4206),
    [anon_sym_POUNDendif] = ACTIONS(4206),
    [anon_sym_POUNDelse] = ACTIONS(4206),
    [sym__newline] = ACTIONS(4206),
  },
  [1688] = {
    [sym_block_comment] = STATE(1688),
    [sym_compiler_directive_decl] = STATE(1688),
    [sym_fsi_directive_decl] = STATE(1688),
    [sym_preproc_line] = STATE(1688),
    [sym_identifier] = ACTIONS(4212),
    [anon_sym_EQ] = ACTIONS(4210),
    [anon_sym_LBRACK_LT] = ACTIONS(4210),
    [anon_sym_COLON] = ACTIONS(4212),
    [anon_sym_return] = ACTIONS(4212),
    [anon_sym_do] = ACTIONS(4212),
    [anon_sym_and] = ACTIONS(4212),
    [anon_sym_let] = ACTIONS(4212),
    [anon_sym_let_BANG] = ACTIONS(4210),
    [aux_sym_access_modifier_token1] = ACTIONS(4210),
    [anon_sym_LPAREN] = ACTIONS(4212),
    [anon_sym_COMMA] = ACTIONS(4210),
    [anon_sym_null] = ACTIONS(4212),
    [anon_sym_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_COLON] = ACTIONS(4210),
    [anon_sym_AMP] = ACTIONS(4212),
    [anon_sym_LBRACK] = ACTIONS(4212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4210),
    [anon_sym_LBRACE] = ACTIONS(4212),
    [anon_sym_LT_AT] = ACTIONS(4212),
    [anon_sym_LT_AT_AT] = ACTIONS(4212),
    [anon_sym_DOT] = ACTIONS(4212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4210),
    [anon_sym_new] = ACTIONS(4212),
    [anon_sym_with] = ACTIONS(4212),
    [anon_sym_return_BANG] = ACTIONS(4210),
    [anon_sym_yield] = ACTIONS(4212),
    [anon_sym_yield_BANG] = ACTIONS(4210),
    [anon_sym_lazy] = ACTIONS(4212),
    [anon_sym_assert] = ACTIONS(4212),
    [anon_sym_upcast] = ACTIONS(4212),
    [anon_sym_downcast] = ACTIONS(4212),
    [anon_sym_COLON_GT] = ACTIONS(4210),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4210),
    [anon_sym_for] = ACTIONS(4212),
    [anon_sym_while] = ACTIONS(4212),
    [anon_sym_if] = ACTIONS(4212),
    [anon_sym_fun] = ACTIONS(4212),
    [anon_sym_try] = ACTIONS(4212),
    [anon_sym_match] = ACTIONS(4212),
    [anon_sym_match_BANG] = ACTIONS(4210),
    [anon_sym_function] = ACTIONS(4212),
    [anon_sym_LT_DASH] = ACTIONS(4212),
    [anon_sym_DOT_LBRACK] = ACTIONS(4210),
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_use] = ACTIONS(4212),
    [anon_sym_use_BANG] = ACTIONS(4210),
    [anon_sym_do_BANG] = ACTIONS(4210),
    [anon_sym_begin] = ACTIONS(4212),
    [anon_sym_LPAREN2] = ACTIONS(4212),
    [anon_sym_default] = ACTIONS(4212),
    [anon_sym_or] = ACTIONS(4212),
    [anon_sym_static] = ACTIONS(4212),
    [anon_sym_member] = ACTIONS(4212),
    [anon_sym_interface] = ACTIONS(4212),
    [anon_sym_abstract] = ACTIONS(4212),
    [anon_sym_val] = ACTIONS(4212),
    [anon_sym_override] = ACTIONS(4212),
    [aux_sym_char_token1] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4212),
    [anon_sym_DQUOTE] = ACTIONS(4212),
    [anon_sym_AT_DQUOTE] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [sym_bool] = ACTIONS(4212),
    [sym_unit] = ACTIONS(4210),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4212),
    [anon_sym_DASH] = ACTIONS(4212),
    [anon_sym_PLUS_DOT] = ACTIONS(4212),
    [anon_sym_DASH_DOT] = ACTIONS(4212),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_AMP_AMP] = ACTIONS(4212),
    [anon_sym_TILDE] = ACTIONS(4210),
    [aux_sym_prefix_op_token1] = ACTIONS(4212),
    [aux_sym_infix_op_token1] = ACTIONS(4210),
    [aux_sym_infix_op_token2] = ACTIONS(4212),
    [anon_sym_PIPE_PIPE] = ACTIONS(4212),
    [anon_sym_BANG_EQ] = ACTIONS(4212),
    [anon_sym_COLON_EQ] = ACTIONS(4210),
    [anon_sym_DOLLAR] = ACTIONS(4212),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4212),
    [sym_int] = ACTIONS(4212),
    [sym_xint] = ACTIONS(4210),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4210),
    [anon_sym_POUNDendif] = ACTIONS(4210),
    [anon_sym_POUNDelse] = ACTIONS(4210),
    [sym__newline] = ACTIONS(4210),
  },
  [1689] = {
    [sym_block_comment] = STATE(1689),
    [sym_compiler_directive_decl] = STATE(1689),
    [sym_fsi_directive_decl] = STATE(1689),
    [sym_preproc_line] = STATE(1689),
    [sym_identifier] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4242),
    [anon_sym_LBRACK_LT] = ACTIONS(4242),
    [anon_sym_COLON] = ACTIONS(4244),
    [anon_sym_return] = ACTIONS(4244),
    [anon_sym_do] = ACTIONS(4244),
    [anon_sym_let] = ACTIONS(4244),
    [anon_sym_let_BANG] = ACTIONS(4242),
    [aux_sym_access_modifier_token1] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_null] = ACTIONS(4244),
    [anon_sym_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_COLON] = ACTIONS(4242),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4244),
    [anon_sym_LT_AT] = ACTIONS(4244),
    [anon_sym_LT_AT_AT] = ACTIONS(4244),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4242),
    [anon_sym_new] = ACTIONS(4244),
    [anon_sym_with] = ACTIONS(4244),
    [anon_sym_return_BANG] = ACTIONS(4242),
    [anon_sym_yield] = ACTIONS(4244),
    [anon_sym_yield_BANG] = ACTIONS(4242),
    [anon_sym_lazy] = ACTIONS(4244),
    [anon_sym_assert] = ACTIONS(4244),
    [anon_sym_upcast] = ACTIONS(4244),
    [anon_sym_downcast] = ACTIONS(4244),
    [anon_sym_COLON_GT] = ACTIONS(4242),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4242),
    [anon_sym_for] = ACTIONS(4244),
    [anon_sym_while] = ACTIONS(4244),
    [anon_sym_if] = ACTIONS(4244),
    [anon_sym_fun] = ACTIONS(4244),
    [anon_sym_try] = ACTIONS(4244),
    [anon_sym_match] = ACTIONS(4244),
    [anon_sym_match_BANG] = ACTIONS(4242),
    [anon_sym_function] = ACTIONS(4244),
    [anon_sym_LT_DASH] = ACTIONS(4244),
    [anon_sym_DOT_LBRACK] = ACTIONS(4242),
    [anon_sym_LT] = ACTIONS(4242),
    [anon_sym_use] = ACTIONS(4244),
    [anon_sym_use_BANG] = ACTIONS(4242),
    [anon_sym_do_BANG] = ACTIONS(4242),
    [anon_sym_begin] = ACTIONS(4244),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_default] = ACTIONS(4244),
    [anon_sym_or] = ACTIONS(4244),
    [anon_sym_static] = ACTIONS(4244),
    [anon_sym_member] = ACTIONS(4244),
    [anon_sym_interface] = ACTIONS(4244),
    [anon_sym_abstract] = ACTIONS(4244),
    [anon_sym_val] = ACTIONS(4244),
    [anon_sym_override] = ACTIONS(4244),
    [anon_sym_inherit] = ACTIONS(4244),
    [aux_sym_char_token1] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4244),
    [anon_sym_DQUOTE] = ACTIONS(4244),
    [anon_sym_AT_DQUOTE] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [sym_bool] = ACTIONS(4244),
    [sym_unit] = ACTIONS(4242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4244),
    [sym_op_identifier] = ACTIONS(4244),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_DASH] = ACTIONS(4244),
    [anon_sym_PLUS_DOT] = ACTIONS(4244),
    [anon_sym_DASH_DOT] = ACTIONS(4244),
    [anon_sym_PERCENT] = ACTIONS(4244),
    [anon_sym_AMP_AMP] = ACTIONS(4244),
    [anon_sym_TILDE] = ACTIONS(4242),
    [aux_sym_prefix_op_token1] = ACTIONS(4244),
    [aux_sym_infix_op_token1] = ACTIONS(4242),
    [aux_sym_infix_op_token2] = ACTIONS(4244),
    [anon_sym_PIPE_PIPE] = ACTIONS(4244),
    [anon_sym_BANG_EQ] = ACTIONS(4244),
    [anon_sym_COLON_EQ] = ACTIONS(4242),
    [anon_sym_DOLLAR] = ACTIONS(4244),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4244),
    [sym_int] = ACTIONS(4244),
    [sym_xint] = ACTIONS(4242),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4242),
    [anon_sym_POUNDendif] = ACTIONS(4242),
    [anon_sym_POUNDelse] = ACTIONS(4242),
    [sym__newline] = ACTIONS(4242),
  },
  [1690] = {
    [sym_block_comment] = STATE(1690),
    [sym_compiler_directive_decl] = STATE(1690),
    [sym_fsi_directive_decl] = STATE(1690),
    [sym_preproc_line] = STATE(1690),
    [sym_identifier] = ACTIONS(4240),
    [anon_sym_EQ] = ACTIONS(4238),
    [anon_sym_LBRACK_LT] = ACTIONS(4238),
    [anon_sym_COLON] = ACTIONS(4240),
    [anon_sym_return] = ACTIONS(4240),
    [anon_sym_do] = ACTIONS(4240),
    [anon_sym_let] = ACTIONS(4240),
    [anon_sym_let_BANG] = ACTIONS(4238),
    [aux_sym_access_modifier_token1] = ACTIONS(4238),
    [anon_sym_LPAREN] = ACTIONS(4240),
    [anon_sym_COMMA] = ACTIONS(4238),
    [anon_sym_null] = ACTIONS(4240),
    [anon_sym_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_COLON] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4240),
    [anon_sym_LBRACK] = ACTIONS(4240),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4238),
    [anon_sym_LBRACE] = ACTIONS(4240),
    [anon_sym_LT_AT] = ACTIONS(4240),
    [anon_sym_LT_AT_AT] = ACTIONS(4240),
    [anon_sym_DOT] = ACTIONS(4240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4238),
    [anon_sym_new] = ACTIONS(4240),
    [anon_sym_with] = ACTIONS(4240),
    [anon_sym_return_BANG] = ACTIONS(4238),
    [anon_sym_yield] = ACTIONS(4240),
    [anon_sym_yield_BANG] = ACTIONS(4238),
    [anon_sym_lazy] = ACTIONS(4240),
    [anon_sym_assert] = ACTIONS(4240),
    [anon_sym_upcast] = ACTIONS(4240),
    [anon_sym_downcast] = ACTIONS(4240),
    [anon_sym_COLON_GT] = ACTIONS(4238),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4238),
    [anon_sym_for] = ACTIONS(4240),
    [anon_sym_while] = ACTIONS(4240),
    [anon_sym_if] = ACTIONS(4240),
    [anon_sym_fun] = ACTIONS(4240),
    [anon_sym_try] = ACTIONS(4240),
    [anon_sym_match] = ACTIONS(4240),
    [anon_sym_match_BANG] = ACTIONS(4238),
    [anon_sym_function] = ACTIONS(4240),
    [anon_sym_LT_DASH] = ACTIONS(4240),
    [anon_sym_DOT_LBRACK] = ACTIONS(4238),
    [anon_sym_LT] = ACTIONS(4238),
    [anon_sym_use] = ACTIONS(4240),
    [anon_sym_use_BANG] = ACTIONS(4238),
    [anon_sym_do_BANG] = ACTIONS(4238),
    [anon_sym_begin] = ACTIONS(4240),
    [anon_sym_LPAREN2] = ACTIONS(4240),
    [anon_sym_default] = ACTIONS(4240),
    [anon_sym_or] = ACTIONS(4240),
    [anon_sym_static] = ACTIONS(4240),
    [anon_sym_member] = ACTIONS(4240),
    [anon_sym_interface] = ACTIONS(4240),
    [anon_sym_abstract] = ACTIONS(4240),
    [anon_sym_val] = ACTIONS(4240),
    [anon_sym_override] = ACTIONS(4240),
    [anon_sym_inherit] = ACTIONS(4240),
    [aux_sym_char_token1] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4240),
    [anon_sym_DQUOTE] = ACTIONS(4240),
    [anon_sym_AT_DQUOTE] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [sym_bool] = ACTIONS(4240),
    [sym_unit] = ACTIONS(4238),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4240),
    [sym_op_identifier] = ACTIONS(4240),
    [anon_sym_PLUS] = ACTIONS(4240),
    [anon_sym_DASH] = ACTIONS(4240),
    [anon_sym_PLUS_DOT] = ACTIONS(4240),
    [anon_sym_DASH_DOT] = ACTIONS(4240),
    [anon_sym_PERCENT] = ACTIONS(4240),
    [anon_sym_AMP_AMP] = ACTIONS(4240),
    [anon_sym_TILDE] = ACTIONS(4238),
    [aux_sym_prefix_op_token1] = ACTIONS(4240),
    [aux_sym_infix_op_token1] = ACTIONS(4238),
    [aux_sym_infix_op_token2] = ACTIONS(4240),
    [anon_sym_PIPE_PIPE] = ACTIONS(4240),
    [anon_sym_BANG_EQ] = ACTIONS(4240),
    [anon_sym_COLON_EQ] = ACTIONS(4238),
    [anon_sym_DOLLAR] = ACTIONS(4240),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4240),
    [sym_int] = ACTIONS(4240),
    [sym_xint] = ACTIONS(4238),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4238),
    [anon_sym_POUNDendif] = ACTIONS(4238),
    [anon_sym_POUNDelse] = ACTIONS(4238),
    [sym__newline] = ACTIONS(4238),
  },
  [1691] = {
    [sym_block_comment] = STATE(1691),
    [sym_compiler_directive_decl] = STATE(1691),
    [sym_fsi_directive_decl] = STATE(1691),
    [sym_preproc_line] = STATE(1691),
    [sym_identifier] = ACTIONS(4236),
    [anon_sym_EQ] = ACTIONS(4234),
    [anon_sym_LBRACK_LT] = ACTIONS(4234),
    [anon_sym_COLON] = ACTIONS(4236),
    [anon_sym_return] = ACTIONS(4236),
    [anon_sym_do] = ACTIONS(4236),
    [anon_sym_let] = ACTIONS(4236),
    [anon_sym_let_BANG] = ACTIONS(4234),
    [aux_sym_access_modifier_token1] = ACTIONS(4234),
    [anon_sym_LPAREN] = ACTIONS(4236),
    [anon_sym_COMMA] = ACTIONS(4234),
    [anon_sym_null] = ACTIONS(4236),
    [anon_sym_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_COLON] = ACTIONS(4234),
    [anon_sym_AMP] = ACTIONS(4236),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4234),
    [anon_sym_LBRACE] = ACTIONS(4236),
    [anon_sym_LT_AT] = ACTIONS(4236),
    [anon_sym_LT_AT_AT] = ACTIONS(4236),
    [anon_sym_DOT] = ACTIONS(4236),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4234),
    [anon_sym_new] = ACTIONS(4236),
    [anon_sym_with] = ACTIONS(4236),
    [anon_sym_return_BANG] = ACTIONS(4234),
    [anon_sym_yield] = ACTIONS(4236),
    [anon_sym_yield_BANG] = ACTIONS(4234),
    [anon_sym_lazy] = ACTIONS(4236),
    [anon_sym_assert] = ACTIONS(4236),
    [anon_sym_upcast] = ACTIONS(4236),
    [anon_sym_downcast] = ACTIONS(4236),
    [anon_sym_COLON_GT] = ACTIONS(4234),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4234),
    [anon_sym_for] = ACTIONS(4236),
    [anon_sym_while] = ACTIONS(4236),
    [anon_sym_if] = ACTIONS(4236),
    [anon_sym_fun] = ACTIONS(4236),
    [anon_sym_try] = ACTIONS(4236),
    [anon_sym_match] = ACTIONS(4236),
    [anon_sym_match_BANG] = ACTIONS(4234),
    [anon_sym_function] = ACTIONS(4236),
    [anon_sym_LT_DASH] = ACTIONS(4236),
    [anon_sym_DOT_LBRACK] = ACTIONS(4234),
    [anon_sym_LT] = ACTIONS(4234),
    [anon_sym_use] = ACTIONS(4236),
    [anon_sym_use_BANG] = ACTIONS(4234),
    [anon_sym_do_BANG] = ACTIONS(4234),
    [anon_sym_begin] = ACTIONS(4236),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_default] = ACTIONS(4236),
    [anon_sym_or] = ACTIONS(4236),
    [anon_sym_static] = ACTIONS(4236),
    [anon_sym_member] = ACTIONS(4236),
    [anon_sym_interface] = ACTIONS(4236),
    [anon_sym_abstract] = ACTIONS(4236),
    [anon_sym_val] = ACTIONS(4236),
    [anon_sym_override] = ACTIONS(4236),
    [anon_sym_inherit] = ACTIONS(4236),
    [aux_sym_char_token1] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4236),
    [anon_sym_DQUOTE] = ACTIONS(4236),
    [anon_sym_AT_DQUOTE] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [sym_bool] = ACTIONS(4236),
    [sym_unit] = ACTIONS(4234),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4236),
    [sym_op_identifier] = ACTIONS(4236),
    [anon_sym_PLUS] = ACTIONS(4236),
    [anon_sym_DASH] = ACTIONS(4236),
    [anon_sym_PLUS_DOT] = ACTIONS(4236),
    [anon_sym_DASH_DOT] = ACTIONS(4236),
    [anon_sym_PERCENT] = ACTIONS(4236),
    [anon_sym_AMP_AMP] = ACTIONS(4236),
    [anon_sym_TILDE] = ACTIONS(4234),
    [aux_sym_prefix_op_token1] = ACTIONS(4236),
    [aux_sym_infix_op_token1] = ACTIONS(4234),
    [aux_sym_infix_op_token2] = ACTIONS(4236),
    [anon_sym_PIPE_PIPE] = ACTIONS(4236),
    [anon_sym_BANG_EQ] = ACTIONS(4236),
    [anon_sym_COLON_EQ] = ACTIONS(4234),
    [anon_sym_DOLLAR] = ACTIONS(4236),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4236),
    [sym_int] = ACTIONS(4236),
    [sym_xint] = ACTIONS(4234),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4234),
    [anon_sym_POUNDendif] = ACTIONS(4234),
    [anon_sym_POUNDelse] = ACTIONS(4234),
    [sym__newline] = ACTIONS(4234),
  },
  [1692] = {
    [sym_block_comment] = STATE(1692),
    [sym_compiler_directive_decl] = STATE(1692),
    [sym_fsi_directive_decl] = STATE(1692),
    [sym_preproc_line] = STATE(1692),
    [sym_identifier] = ACTIONS(4224),
    [anon_sym_EQ] = ACTIONS(4222),
    [anon_sym_LBRACK_LT] = ACTIONS(4222),
    [anon_sym_COLON] = ACTIONS(4224),
    [anon_sym_return] = ACTIONS(4224),
    [anon_sym_do] = ACTIONS(4224),
    [anon_sym_and] = ACTIONS(4224),
    [anon_sym_let] = ACTIONS(4224),
    [anon_sym_let_BANG] = ACTIONS(4222),
    [aux_sym_access_modifier_token1] = ACTIONS(4222),
    [anon_sym_LPAREN] = ACTIONS(4224),
    [anon_sym_COMMA] = ACTIONS(4222),
    [anon_sym_null] = ACTIONS(4224),
    [anon_sym_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_COLON] = ACTIONS(4222),
    [anon_sym_AMP] = ACTIONS(4224),
    [anon_sym_LBRACK] = ACTIONS(4224),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4222),
    [anon_sym_LBRACE] = ACTIONS(4224),
    [anon_sym_LT_AT] = ACTIONS(4224),
    [anon_sym_LT_AT_AT] = ACTIONS(4224),
    [anon_sym_DOT] = ACTIONS(4224),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4222),
    [anon_sym_new] = ACTIONS(4224),
    [anon_sym_with] = ACTIONS(4224),
    [anon_sym_return_BANG] = ACTIONS(4222),
    [anon_sym_yield] = ACTIONS(4224),
    [anon_sym_yield_BANG] = ACTIONS(4222),
    [anon_sym_lazy] = ACTIONS(4224),
    [anon_sym_assert] = ACTIONS(4224),
    [anon_sym_upcast] = ACTIONS(4224),
    [anon_sym_downcast] = ACTIONS(4224),
    [anon_sym_COLON_GT] = ACTIONS(4222),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4222),
    [anon_sym_for] = ACTIONS(4224),
    [anon_sym_while] = ACTIONS(4224),
    [anon_sym_if] = ACTIONS(4224),
    [anon_sym_fun] = ACTIONS(4224),
    [anon_sym_try] = ACTIONS(4224),
    [anon_sym_match] = ACTIONS(4224),
    [anon_sym_match_BANG] = ACTIONS(4222),
    [anon_sym_function] = ACTIONS(4224),
    [anon_sym_LT_DASH] = ACTIONS(4224),
    [anon_sym_DOT_LBRACK] = ACTIONS(4222),
    [anon_sym_LT] = ACTIONS(4222),
    [anon_sym_use] = ACTIONS(4224),
    [anon_sym_use_BANG] = ACTIONS(4222),
    [anon_sym_do_BANG] = ACTIONS(4222),
    [anon_sym_begin] = ACTIONS(4224),
    [anon_sym_LPAREN2] = ACTIONS(4224),
    [anon_sym_default] = ACTIONS(4224),
    [anon_sym_or] = ACTIONS(4224),
    [anon_sym_static] = ACTIONS(4224),
    [anon_sym_member] = ACTIONS(4224),
    [anon_sym_interface] = ACTIONS(4224),
    [anon_sym_abstract] = ACTIONS(4224),
    [anon_sym_val] = ACTIONS(4224),
    [anon_sym_override] = ACTIONS(4224),
    [aux_sym_char_token1] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4224),
    [anon_sym_DQUOTE] = ACTIONS(4224),
    [anon_sym_AT_DQUOTE] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [sym_bool] = ACTIONS(4224),
    [sym_unit] = ACTIONS(4222),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4224),
    [sym_op_identifier] = ACTIONS(4224),
    [anon_sym_PLUS] = ACTIONS(4224),
    [anon_sym_DASH] = ACTIONS(4224),
    [anon_sym_PLUS_DOT] = ACTIONS(4224),
    [anon_sym_DASH_DOT] = ACTIONS(4224),
    [anon_sym_PERCENT] = ACTIONS(4224),
    [anon_sym_AMP_AMP] = ACTIONS(4224),
    [anon_sym_TILDE] = ACTIONS(4222),
    [aux_sym_prefix_op_token1] = ACTIONS(4224),
    [aux_sym_infix_op_token1] = ACTIONS(4222),
    [aux_sym_infix_op_token2] = ACTIONS(4224),
    [anon_sym_PIPE_PIPE] = ACTIONS(4224),
    [anon_sym_BANG_EQ] = ACTIONS(4224),
    [anon_sym_COLON_EQ] = ACTIONS(4222),
    [anon_sym_DOLLAR] = ACTIONS(4224),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4224),
    [sym_int] = ACTIONS(4224),
    [sym_xint] = ACTIONS(4222),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4222),
    [anon_sym_POUNDendif] = ACTIONS(4222),
    [anon_sym_POUNDelse] = ACTIONS(4222),
    [sym__newline] = ACTIONS(4222),
  },
  [1693] = {
    [sym_block_comment] = STATE(1693),
    [sym_compiler_directive_decl] = STATE(1693),
    [sym_fsi_directive_decl] = STATE(1693),
    [sym_preproc_line] = STATE(1693),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [aux_sym_access_modifier_token1] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_member] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_val] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [anon_sym_inherit] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [anon_sym_POUNDendif] = ACTIONS(3485),
    [anon_sym_POUNDelse] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [1694] = {
    [sym_block_comment] = STATE(1694),
    [sym_compiler_directive_decl] = STATE(1694),
    [sym_fsi_directive_decl] = STATE(1694),
    [sym_preproc_line] = STATE(1694),
    [sym_identifier] = ACTIONS(4197),
    [anon_sym_EQ] = ACTIONS(4195),
    [anon_sym_LBRACK_LT] = ACTIONS(4195),
    [anon_sym_COLON] = ACTIONS(4197),
    [anon_sym_return] = ACTIONS(4197),
    [anon_sym_do] = ACTIONS(4197),
    [anon_sym_let] = ACTIONS(4197),
    [anon_sym_let_BANG] = ACTIONS(4195),
    [aux_sym_access_modifier_token1] = ACTIONS(4195),
    [anon_sym_LPAREN] = ACTIONS(4197),
    [anon_sym_COMMA] = ACTIONS(4195),
    [anon_sym_null] = ACTIONS(4197),
    [anon_sym_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_COLON] = ACTIONS(4195),
    [anon_sym_AMP] = ACTIONS(4197),
    [anon_sym_LBRACK] = ACTIONS(4197),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4195),
    [anon_sym_LBRACE] = ACTIONS(4197),
    [anon_sym_LT_AT] = ACTIONS(4197),
    [anon_sym_LT_AT_AT] = ACTIONS(4197),
    [anon_sym_DOT] = ACTIONS(4197),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4195),
    [anon_sym_new] = ACTIONS(4197),
    [anon_sym_with] = ACTIONS(4197),
    [anon_sym_return_BANG] = ACTIONS(4195),
    [anon_sym_yield] = ACTIONS(4197),
    [anon_sym_yield_BANG] = ACTIONS(4195),
    [anon_sym_lazy] = ACTIONS(4197),
    [anon_sym_assert] = ACTIONS(4197),
    [anon_sym_upcast] = ACTIONS(4197),
    [anon_sym_downcast] = ACTIONS(4197),
    [anon_sym_COLON_GT] = ACTIONS(4195),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4195),
    [anon_sym_for] = ACTIONS(4197),
    [anon_sym_while] = ACTIONS(4197),
    [anon_sym_if] = ACTIONS(4197),
    [anon_sym_fun] = ACTIONS(4197),
    [anon_sym_try] = ACTIONS(4197),
    [anon_sym_match] = ACTIONS(4197),
    [anon_sym_match_BANG] = ACTIONS(4195),
    [anon_sym_function] = ACTIONS(4197),
    [anon_sym_LT_DASH] = ACTIONS(4197),
    [anon_sym_DOT_LBRACK] = ACTIONS(4195),
    [anon_sym_LT] = ACTIONS(4195),
    [anon_sym_use] = ACTIONS(4197),
    [anon_sym_use_BANG] = ACTIONS(4195),
    [anon_sym_do_BANG] = ACTIONS(4195),
    [anon_sym_begin] = ACTIONS(4197),
    [anon_sym_LPAREN2] = ACTIONS(4197),
    [anon_sym_default] = ACTIONS(4197),
    [anon_sym_or] = ACTIONS(4197),
    [anon_sym_static] = ACTIONS(4197),
    [anon_sym_member] = ACTIONS(4197),
    [anon_sym_interface] = ACTIONS(4197),
    [anon_sym_abstract] = ACTIONS(4197),
    [anon_sym_val] = ACTIONS(4197),
    [anon_sym_override] = ACTIONS(4197),
    [anon_sym_inherit] = ACTIONS(4197),
    [aux_sym_char_token1] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4197),
    [anon_sym_DQUOTE] = ACTIONS(4197),
    [anon_sym_AT_DQUOTE] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [sym_bool] = ACTIONS(4197),
    [sym_unit] = ACTIONS(4195),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4197),
    [sym_op_identifier] = ACTIONS(4197),
    [anon_sym_PLUS] = ACTIONS(4197),
    [anon_sym_DASH] = ACTIONS(4197),
    [anon_sym_PLUS_DOT] = ACTIONS(4197),
    [anon_sym_DASH_DOT] = ACTIONS(4197),
    [anon_sym_PERCENT] = ACTIONS(4197),
    [anon_sym_AMP_AMP] = ACTIONS(4197),
    [anon_sym_TILDE] = ACTIONS(4195),
    [aux_sym_prefix_op_token1] = ACTIONS(4197),
    [aux_sym_infix_op_token1] = ACTIONS(4195),
    [aux_sym_infix_op_token2] = ACTIONS(4197),
    [anon_sym_PIPE_PIPE] = ACTIONS(4197),
    [anon_sym_BANG_EQ] = ACTIONS(4197),
    [anon_sym_COLON_EQ] = ACTIONS(4195),
    [anon_sym_DOLLAR] = ACTIONS(4197),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4197),
    [sym_int] = ACTIONS(4197),
    [sym_xint] = ACTIONS(4195),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4195),
    [anon_sym_POUNDendif] = ACTIONS(4195),
    [anon_sym_POUNDelse] = ACTIONS(4195),
    [sym__newline] = ACTIONS(4195),
  },
  [1695] = {
    [sym_block_comment] = STATE(1695),
    [sym_compiler_directive_decl] = STATE(1695),
    [sym_fsi_directive_decl] = STATE(1695),
    [sym_preproc_line] = STATE(1695),
    [aux_sym_long_identifier_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [aux_sym_access_modifier_token1] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(4656),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_DOT_DOT2] = ACTIONS(3485),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_member] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_val] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
    [sym__dedent] = ACTIONS(3485),
  },
  [1696] = {
    [sym_block_comment] = STATE(1696),
    [sym_compiler_directive_decl] = STATE(1696),
    [sym_fsi_directive_decl] = STATE(1696),
    [sym_preproc_line] = STATE(1696),
    [aux_sym_long_identifier_repeat1] = STATE(1795),
    [sym_identifier] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3778),
    [anon_sym_LBRACK_LT] = ACTIONS(3778),
    [anon_sym_COLON] = ACTIONS(3781),
    [anon_sym_return] = ACTIONS(3781),
    [anon_sym_do] = ACTIONS(3781),
    [anon_sym_and] = ACTIONS(3781),
    [anon_sym_let] = ACTIONS(3781),
    [anon_sym_let_BANG] = ACTIONS(3778),
    [aux_sym_access_modifier_token1] = ACTIONS(3778),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3778),
    [anon_sym_null] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3781),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_LT_AT] = ACTIONS(3781),
    [anon_sym_LT_AT_AT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(4659),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3778),
    [anon_sym_new] = ACTIONS(3781),
    [anon_sym_with] = ACTIONS(3781),
    [anon_sym_return_BANG] = ACTIONS(3778),
    [anon_sym_yield] = ACTIONS(3781),
    [anon_sym_yield_BANG] = ACTIONS(3778),
    [anon_sym_lazy] = ACTIONS(3781),
    [anon_sym_assert] = ACTIONS(3781),
    [anon_sym_upcast] = ACTIONS(3781),
    [anon_sym_downcast] = ACTIONS(3781),
    [anon_sym_COLON_GT] = ACTIONS(3778),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3778),
    [anon_sym_for] = ACTIONS(3781),
    [anon_sym_while] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_fun] = ACTIONS(3781),
    [anon_sym_try] = ACTIONS(3781),
    [anon_sym_match] = ACTIONS(3781),
    [anon_sym_match_BANG] = ACTIONS(3778),
    [anon_sym_function] = ACTIONS(3781),
    [anon_sym_LT_DASH] = ACTIONS(3781),
    [anon_sym_DOT_LBRACK] = ACTIONS(3778),
    [anon_sym_LT] = ACTIONS(3778),
    [anon_sym_use] = ACTIONS(3781),
    [anon_sym_use_BANG] = ACTIONS(3778),
    [anon_sym_do_BANG] = ACTIONS(3778),
    [anon_sym_begin] = ACTIONS(3781),
    [anon_sym_LPAREN2] = ACTIONS(3781),
    [anon_sym_default] = ACTIONS(3781),
    [anon_sym_or] = ACTIONS(3781),
    [anon_sym_static] = ACTIONS(3781),
    [anon_sym_member] = ACTIONS(3781),
    [anon_sym_interface] = ACTIONS(3781),
    [anon_sym_abstract] = ACTIONS(3781),
    [anon_sym_val] = ACTIONS(3781),
    [anon_sym_override] = ACTIONS(3781),
    [aux_sym_char_token1] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3781),
    [anon_sym_DQUOTE] = ACTIONS(3781),
    [anon_sym_AT_DQUOTE] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [sym_bool] = ACTIONS(3781),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3781),
    [sym_op_identifier] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3781),
    [anon_sym_DASH] = ACTIONS(3781),
    [anon_sym_PLUS_DOT] = ACTIONS(3781),
    [anon_sym_DASH_DOT] = ACTIONS(3781),
    [anon_sym_PERCENT] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3781),
    [anon_sym_TILDE] = ACTIONS(3778),
    [aux_sym_prefix_op_token1] = ACTIONS(3781),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token2] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_COLON_EQ] = ACTIONS(3778),
    [anon_sym_DOLLAR] = ACTIONS(3781),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3781),
    [sym_int] = ACTIONS(3781),
    [sym_xint] = ACTIONS(3778),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3778),
    [sym__newline] = ACTIONS(3778),
    [sym__dedent] = ACTIONS(3778),
  },
  [1697] = {
    [sym_block_comment] = STATE(1697),
    [sym_compiler_directive_decl] = STATE(1697),
    [sym_fsi_directive_decl] = STATE(1697),
    [sym_preproc_line] = STATE(1697),
    [sym_identifier] = ACTIONS(3889),
    [anon_sym_EQ] = ACTIONS(3887),
    [anon_sym_LBRACK_LT] = ACTIONS(3887),
    [anon_sym_COLON] = ACTIONS(3889),
    [anon_sym_return] = ACTIONS(3889),
    [anon_sym_do] = ACTIONS(3889),
    [anon_sym_let] = ACTIONS(3889),
    [anon_sym_let_BANG] = ACTIONS(3887),
    [aux_sym_access_modifier_token1] = ACTIONS(3887),
    [anon_sym_LPAREN] = ACTIONS(3889),
    [anon_sym_COMMA] = ACTIONS(3887),
    [anon_sym_null] = ACTIONS(3889),
    [anon_sym_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_COLON] = ACTIONS(3887),
    [anon_sym_AMP] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3887),
    [anon_sym_LBRACE] = ACTIONS(3889),
    [anon_sym_LT_AT] = ACTIONS(3889),
    [anon_sym_LT_AT_AT] = ACTIONS(3889),
    [anon_sym_DOT] = ACTIONS(3889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [anon_sym_new] = ACTIONS(3889),
    [anon_sym_with] = ACTIONS(3889),
    [anon_sym_return_BANG] = ACTIONS(3887),
    [anon_sym_yield] = ACTIONS(3889),
    [anon_sym_yield_BANG] = ACTIONS(3887),
    [anon_sym_lazy] = ACTIONS(3889),
    [anon_sym_assert] = ACTIONS(3889),
    [anon_sym_upcast] = ACTIONS(3889),
    [anon_sym_downcast] = ACTIONS(3889),
    [anon_sym_COLON_GT] = ACTIONS(3887),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3887),
    [anon_sym_for] = ACTIONS(3889),
    [anon_sym_while] = ACTIONS(3889),
    [anon_sym_if] = ACTIONS(3889),
    [anon_sym_fun] = ACTIONS(3889),
    [anon_sym_try] = ACTIONS(3889),
    [anon_sym_match] = ACTIONS(3889),
    [anon_sym_match_BANG] = ACTIONS(3887),
    [anon_sym_function] = ACTIONS(3889),
    [anon_sym_LT_DASH] = ACTIONS(3889),
    [anon_sym_DOT_LBRACK] = ACTIONS(3887),
    [anon_sym_LT] = ACTIONS(3887),
    [anon_sym_use] = ACTIONS(3889),
    [anon_sym_use_BANG] = ACTIONS(3887),
    [anon_sym_do_BANG] = ACTIONS(3887),
    [anon_sym_begin] = ACTIONS(3889),
    [anon_sym_LPAREN2] = ACTIONS(3889),
    [anon_sym_default] = ACTIONS(3889),
    [anon_sym_or] = ACTIONS(3889),
    [anon_sym_static] = ACTIONS(3889),
    [anon_sym_member] = ACTIONS(3889),
    [anon_sym_interface] = ACTIONS(3889),
    [anon_sym_abstract] = ACTIONS(3889),
    [anon_sym_val] = ACTIONS(3889),
    [anon_sym_override] = ACTIONS(3889),
    [anon_sym_inherit] = ACTIONS(3889),
    [aux_sym_char_token1] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3889),
    [anon_sym_DQUOTE] = ACTIONS(3889),
    [anon_sym_AT_DQUOTE] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [sym_bool] = ACTIONS(3889),
    [sym_unit] = ACTIONS(3887),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3889),
    [sym_op_identifier] = ACTIONS(3889),
    [anon_sym_PLUS] = ACTIONS(3889),
    [anon_sym_DASH] = ACTIONS(3889),
    [anon_sym_PLUS_DOT] = ACTIONS(3889),
    [anon_sym_DASH_DOT] = ACTIONS(3889),
    [anon_sym_PERCENT] = ACTIONS(3889),
    [anon_sym_AMP_AMP] = ACTIONS(3889),
    [anon_sym_TILDE] = ACTIONS(3887),
    [aux_sym_prefix_op_token1] = ACTIONS(3889),
    [aux_sym_infix_op_token1] = ACTIONS(3887),
    [aux_sym_infix_op_token2] = ACTIONS(3889),
    [anon_sym_PIPE_PIPE] = ACTIONS(3889),
    [anon_sym_BANG_EQ] = ACTIONS(3889),
    [anon_sym_COLON_EQ] = ACTIONS(3887),
    [anon_sym_DOLLAR] = ACTIONS(3889),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3889),
    [sym_int] = ACTIONS(3889),
    [sym_xint] = ACTIONS(3887),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3887),
    [anon_sym_POUNDendif] = ACTIONS(3887),
    [anon_sym_POUNDelse] = ACTIONS(3887),
    [sym__newline] = ACTIONS(3887),
  },
  [1698] = {
    [sym_block_comment] = STATE(1698),
    [sym_compiler_directive_decl] = STATE(1698),
    [sym_fsi_directive_decl] = STATE(1698),
    [sym_preproc_line] = STATE(1698),
    [sym_identifier] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3772),
    [anon_sym_LBRACK_LT] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3774),
    [anon_sym_do] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3774),
    [anon_sym_let_BANG] = ACTIONS(3772),
    [aux_sym_access_modifier_token1] = ACTIONS(3772),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3772),
    [anon_sym_null] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_COLON] = ACTIONS(3772),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_LT_AT] = ACTIONS(3774),
    [anon_sym_LT_AT_AT] = ACTIONS(3774),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3772),
    [anon_sym_new] = ACTIONS(3774),
    [anon_sym_with] = ACTIONS(3774),
    [anon_sym_return_BANG] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3774),
    [anon_sym_yield_BANG] = ACTIONS(3772),
    [anon_sym_lazy] = ACTIONS(3774),
    [anon_sym_assert] = ACTIONS(3774),
    [anon_sym_upcast] = ACTIONS(3774),
    [anon_sym_downcast] = ACTIONS(3774),
    [anon_sym_COLON_GT] = ACTIONS(3772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3774),
    [anon_sym_done] = ACTIONS(4663),
    [anon_sym_while] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3774),
    [anon_sym_fun] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3774),
    [anon_sym_match] = ACTIONS(3774),
    [anon_sym_match_BANG] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3774),
    [anon_sym_LT_DASH] = ACTIONS(3774),
    [anon_sym_DOT_LBRACK] = ACTIONS(3772),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_use] = ACTIONS(3774),
    [anon_sym_use_BANG] = ACTIONS(3772),
    [anon_sym_do_BANG] = ACTIONS(3772),
    [anon_sym_begin] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3774),
    [anon_sym_DOT_DOT2] = ACTIONS(3772),
    [anon_sym_default] = ACTIONS(3774),
    [anon_sym_or] = ACTIONS(3774),
    [anon_sym_static] = ACTIONS(3774),
    [anon_sym_member] = ACTIONS(3774),
    [anon_sym_interface] = ACTIONS(3774),
    [anon_sym_abstract] = ACTIONS(3774),
    [anon_sym_val] = ACTIONS(3774),
    [anon_sym_override] = ACTIONS(3774),
    [aux_sym_char_token1] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_AT_DQUOTE] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [sym_bool] = ACTIONS(3774),
    [sym_unit] = ACTIONS(3772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3774),
    [sym_op_identifier] = ACTIONS(3774),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_DOT] = ACTIONS(3774),
    [anon_sym_DASH_DOT] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3772),
    [aux_sym_prefix_op_token1] = ACTIONS(3774),
    [aux_sym_infix_op_token1] = ACTIONS(3772),
    [aux_sym_infix_op_token2] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3774),
    [anon_sym_COLON_EQ] = ACTIONS(3772),
    [anon_sym_DOLLAR] = ACTIONS(3774),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3774),
    [sym_int] = ACTIONS(3774),
    [sym_xint] = ACTIONS(3772),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3772),
    [sym__newline] = ACTIONS(3772),
    [sym__dedent] = ACTIONS(3772),
  },
  [1699] = {
    [sym_block_comment] = STATE(1699),
    [sym_compiler_directive_decl] = STATE(1699),
    [sym_fsi_directive_decl] = STATE(1699),
    [sym_preproc_line] = STATE(1699),
    [sym_identifier] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3772),
    [anon_sym_LBRACK_LT] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3774),
    [anon_sym_do] = ACTIONS(3774),
    [anon_sym_and] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3774),
    [anon_sym_let_BANG] = ACTIONS(3772),
    [aux_sym_access_modifier_token1] = ACTIONS(3772),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3772),
    [anon_sym_null] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_COLON] = ACTIONS(3772),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_LT_AT] = ACTIONS(3774),
    [anon_sym_LT_AT_AT] = ACTIONS(3774),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3772),
    [anon_sym_new] = ACTIONS(3774),
    [anon_sym_with] = ACTIONS(3774),
    [anon_sym_return_BANG] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3774),
    [anon_sym_yield_BANG] = ACTIONS(3772),
    [anon_sym_lazy] = ACTIONS(3774),
    [anon_sym_assert] = ACTIONS(3774),
    [anon_sym_upcast] = ACTIONS(3774),
    [anon_sym_downcast] = ACTIONS(3774),
    [anon_sym_COLON_GT] = ACTIONS(3772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3774),
    [anon_sym_done] = ACTIONS(4665),
    [anon_sym_while] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3774),
    [anon_sym_fun] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3774),
    [anon_sym_match] = ACTIONS(3774),
    [anon_sym_match_BANG] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3774),
    [anon_sym_LT_DASH] = ACTIONS(3774),
    [anon_sym_DOT_LBRACK] = ACTIONS(3772),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_use] = ACTIONS(3774),
    [anon_sym_use_BANG] = ACTIONS(3772),
    [anon_sym_do_BANG] = ACTIONS(3772),
    [anon_sym_begin] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3774),
    [anon_sym_default] = ACTIONS(3774),
    [anon_sym_or] = ACTIONS(3774),
    [anon_sym_static] = ACTIONS(3774),
    [anon_sym_member] = ACTIONS(3774),
    [anon_sym_interface] = ACTIONS(3774),
    [anon_sym_abstract] = ACTIONS(3774),
    [anon_sym_val] = ACTIONS(3774),
    [anon_sym_override] = ACTIONS(3774),
    [aux_sym_char_token1] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_AT_DQUOTE] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [sym_bool] = ACTIONS(3774),
    [sym_unit] = ACTIONS(3772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3774),
    [sym_op_identifier] = ACTIONS(3774),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_DOT] = ACTIONS(3774),
    [anon_sym_DASH_DOT] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3772),
    [aux_sym_prefix_op_token1] = ACTIONS(3774),
    [aux_sym_infix_op_token1] = ACTIONS(3772),
    [aux_sym_infix_op_token2] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3774),
    [anon_sym_COLON_EQ] = ACTIONS(3772),
    [anon_sym_DOLLAR] = ACTIONS(3774),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3774),
    [sym_int] = ACTIONS(3774),
    [sym_xint] = ACTIONS(3772),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3772),
    [sym__newline] = ACTIONS(3772),
    [sym__dedent] = ACTIONS(3772),
  },
  [1700] = {
    [sym_block_comment] = STATE(1700),
    [sym_compiler_directive_decl] = STATE(1700),
    [sym_fsi_directive_decl] = STATE(1700),
    [sym_preproc_line] = STATE(1700),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_LBRACK_LT] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [aux_sym_access_modifier_token1] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_with] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(4667),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_DOT_DOT] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_default] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [anon_sym_static] = ACTIONS(3685),
    [anon_sym_member] = ACTIONS(3685),
    [anon_sym_interface] = ACTIONS(3685),
    [anon_sym_abstract] = ACTIONS(3685),
    [anon_sym_val] = ACTIONS(3685),
    [anon_sym_override] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
    [sym__dedent] = ACTIONS(3683),
  },
  [1701] = {
    [sym_block_comment] = STATE(1701),
    [sym_compiler_directive_decl] = STATE(1701),
    [sym_fsi_directive_decl] = STATE(1701),
    [sym_preproc_line] = STATE(1701),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_LBRACK_LT] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [aux_sym_access_modifier_token1] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_with] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(4667),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_DOT_DOT2] = ACTIONS(3683),
    [anon_sym_default] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [anon_sym_static] = ACTIONS(3685),
    [anon_sym_member] = ACTIONS(3685),
    [anon_sym_interface] = ACTIONS(3685),
    [anon_sym_abstract] = ACTIONS(3685),
    [anon_sym_val] = ACTIONS(3685),
    [anon_sym_override] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
    [sym__dedent] = ACTIONS(3683),
  },
  [1702] = {
    [sym_block_comment] = STATE(1702),
    [sym_compiler_directive_decl] = STATE(1702),
    [sym_fsi_directive_decl] = STATE(1702),
    [sym_preproc_line] = STATE(1702),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_DOT_DOT] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(4480),
    [anon_sym_uy] = ACTIONS(4482),
    [anon_sym_s] = ACTIONS(4484),
    [anon_sym_us] = ACTIONS(4486),
    [anon_sym_l] = ACTIONS(4488),
    [aux_sym_uint32_token1] = ACTIONS(4490),
    [anon_sym_n] = ACTIONS(4492),
    [anon_sym_un] = ACTIONS(4494),
    [anon_sym_L] = ACTIONS(4496),
    [aux_sym_uint64_token1] = ACTIONS(4498),
    [anon_sym_lf] = ACTIONS(4669),
    [anon_sym_LF] = ACTIONS(4671),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1703] = {
    [sym_block_comment] = STATE(1703),
    [sym_compiler_directive_decl] = STATE(1703),
    [sym_fsi_directive_decl] = STATE(1703),
    [sym_preproc_line] = STATE(1703),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_LBRACK_LT] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [aux_sym_access_modifier_token1] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_with] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_default] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [anon_sym_static] = ACTIONS(4228),
    [anon_sym_member] = ACTIONS(4228),
    [anon_sym_interface] = ACTIONS(4228),
    [anon_sym_abstract] = ACTIONS(4228),
    [anon_sym_val] = ACTIONS(4228),
    [anon_sym_override] = ACTIONS(4228),
    [anon_sym_inherit] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [anon_sym_POUNDendif] = ACTIONS(4226),
    [anon_sym_POUNDelse] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
  },
  [1704] = {
    [sym_block_comment] = STATE(1704),
    [sym_compiler_directive_decl] = STATE(1704),
    [sym_fsi_directive_decl] = STATE(1704),
    [sym_preproc_line] = STATE(1704),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_LBRACK_LT] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [aux_sym_access_modifier_token1] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4673),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_with] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_default] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [anon_sym_static] = ACTIONS(4228),
    [anon_sym_member] = ACTIONS(4228),
    [anon_sym_interface] = ACTIONS(4228),
    [anon_sym_abstract] = ACTIONS(4228),
    [anon_sym_val] = ACTIONS(4228),
    [anon_sym_override] = ACTIONS(4228),
    [anon_sym_inherit] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [anon_sym_POUNDendif] = ACTIONS(4226),
    [anon_sym_POUNDelse] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
  },
  [1705] = {
    [sym_block_comment] = STATE(1705),
    [sym_compiler_directive_decl] = STATE(1705),
    [sym_fsi_directive_decl] = STATE(1705),
    [sym_preproc_line] = STATE(1705),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_LBRACK_LT] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_and] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [aux_sym_access_modifier_token1] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_with] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(4613),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_default] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [anon_sym_static] = ACTIONS(3685),
    [anon_sym_member] = ACTIONS(3685),
    [anon_sym_interface] = ACTIONS(3685),
    [anon_sym_abstract] = ACTIONS(3685),
    [anon_sym_val] = ACTIONS(3685),
    [anon_sym_override] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
    [sym__dedent] = ACTIONS(3683),
  },
  [1706] = {
    [sym_block_comment] = STATE(1706),
    [sym_compiler_directive_decl] = STATE(1706),
    [sym_fsi_directive_decl] = STATE(1706),
    [sym_preproc_line] = STATE(1706),
    [aux_sym_sequential_expression_repeat1] = STATE(1788),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_LBRACK_LT] = ACTIONS(3757),
    [anon_sym_COLON] = ACTIONS(3759),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_and] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_let_BANG] = ACTIONS(3757),
    [aux_sym_access_modifier_token1] = ACTIONS(3757),
    [anon_sym_LPAREN] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3757),
    [anon_sym_null] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3757),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_LT_AT] = ACTIONS(3759),
    [anon_sym_LT_AT_AT] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(3759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_with] = ACTIONS(3759),
    [anon_sym_return_BANG] = ACTIONS(3757),
    [anon_sym_yield] = ACTIONS(3759),
    [anon_sym_yield_BANG] = ACTIONS(3757),
    [anon_sym_lazy] = ACTIONS(3759),
    [anon_sym_assert] = ACTIONS(3759),
    [anon_sym_upcast] = ACTIONS(3759),
    [anon_sym_downcast] = ACTIONS(3759),
    [anon_sym_COLON_GT] = ACTIONS(3757),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3757),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_fun] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_match] = ACTIONS(3759),
    [anon_sym_match_BANG] = ACTIONS(3757),
    [anon_sym_function] = ACTIONS(3759),
    [anon_sym_LT_DASH] = ACTIONS(3759),
    [anon_sym_DOT_LBRACK] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_use] = ACTIONS(3759),
    [anon_sym_use_BANG] = ACTIONS(3757),
    [anon_sym_do_BANG] = ACTIONS(3757),
    [anon_sym_begin] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_default] = ACTIONS(3759),
    [anon_sym_or] = ACTIONS(3759),
    [anon_sym_static] = ACTIONS(3759),
    [anon_sym_member] = ACTIONS(3759),
    [anon_sym_interface] = ACTIONS(3759),
    [anon_sym_abstract] = ACTIONS(3759),
    [anon_sym_val] = ACTIONS(3759),
    [anon_sym_override] = ACTIONS(3759),
    [aux_sym_char_token1] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3759),
    [anon_sym_DQUOTE] = ACTIONS(3759),
    [anon_sym_AT_DQUOTE] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [sym_bool] = ACTIONS(3759),
    [sym_unit] = ACTIONS(3757),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3759),
    [sym_op_identifier] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS_DOT] = ACTIONS(3759),
    [anon_sym_DASH_DOT] = ACTIONS(3759),
    [anon_sym_PERCENT] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_TILDE] = ACTIONS(3757),
    [aux_sym_prefix_op_token1] = ACTIONS(3759),
    [aux_sym_infix_op_token1] = ACTIONS(3757),
    [aux_sym_infix_op_token2] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_COLON_EQ] = ACTIONS(3757),
    [anon_sym_DOLLAR] = ACTIONS(3759),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3759),
    [sym_int] = ACTIONS(3759),
    [sym_xint] = ACTIONS(3757),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3757),
    [sym__newline] = ACTIONS(3757),
    [sym__dedent] = ACTIONS(3757),
  },
  [1707] = {
    [sym_block_comment] = STATE(1707),
    [sym_compiler_directive_decl] = STATE(1707),
    [sym_fsi_directive_decl] = STATE(1707),
    [sym_preproc_line] = STATE(1707),
    [aux_sym_sequential_expression_repeat1] = STATE(1789),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_LBRACK_LT] = ACTIONS(3757),
    [anon_sym_COLON] = ACTIONS(3759),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_let_BANG] = ACTIONS(3757),
    [aux_sym_access_modifier_token1] = ACTIONS(3757),
    [anon_sym_LPAREN] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3757),
    [anon_sym_null] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3757),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_LT_AT] = ACTIONS(3759),
    [anon_sym_LT_AT_AT] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(3759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_with] = ACTIONS(3759),
    [anon_sym_return_BANG] = ACTIONS(3757),
    [anon_sym_yield] = ACTIONS(3759),
    [anon_sym_yield_BANG] = ACTIONS(3757),
    [anon_sym_lazy] = ACTIONS(3759),
    [anon_sym_assert] = ACTIONS(3759),
    [anon_sym_upcast] = ACTIONS(3759),
    [anon_sym_downcast] = ACTIONS(3759),
    [anon_sym_COLON_GT] = ACTIONS(3757),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3757),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_fun] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_match] = ACTIONS(3759),
    [anon_sym_match_BANG] = ACTIONS(3757),
    [anon_sym_function] = ACTIONS(3759),
    [anon_sym_LT_DASH] = ACTIONS(3759),
    [anon_sym_DOT_LBRACK] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_use] = ACTIONS(3759),
    [anon_sym_use_BANG] = ACTIONS(3757),
    [anon_sym_do_BANG] = ACTIONS(3757),
    [anon_sym_begin] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_default] = ACTIONS(3759),
    [anon_sym_or] = ACTIONS(3759),
    [anon_sym_static] = ACTIONS(3759),
    [anon_sym_member] = ACTIONS(3759),
    [anon_sym_interface] = ACTIONS(3759),
    [anon_sym_abstract] = ACTIONS(3759),
    [anon_sym_val] = ACTIONS(3759),
    [anon_sym_override] = ACTIONS(3759),
    [anon_sym_inherit] = ACTIONS(3759),
    [aux_sym_char_token1] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3759),
    [anon_sym_DQUOTE] = ACTIONS(3759),
    [anon_sym_AT_DQUOTE] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [sym_bool] = ACTIONS(3759),
    [sym_unit] = ACTIONS(3757),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3759),
    [sym_op_identifier] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS_DOT] = ACTIONS(3759),
    [anon_sym_DASH_DOT] = ACTIONS(3759),
    [anon_sym_PERCENT] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_TILDE] = ACTIONS(3757),
    [aux_sym_prefix_op_token1] = ACTIONS(3759),
    [aux_sym_infix_op_token1] = ACTIONS(3757),
    [aux_sym_infix_op_token2] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_COLON_EQ] = ACTIONS(3757),
    [anon_sym_DOLLAR] = ACTIONS(3759),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3759),
    [sym_int] = ACTIONS(3759),
    [sym_xint] = ACTIONS(3757),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3757),
    [anon_sym_POUNDendif] = ACTIONS(3757),
    [sym__newline] = ACTIONS(3757),
  },
  [1708] = {
    [sym_block_comment] = STATE(1708),
    [sym_compiler_directive_decl] = STATE(1708),
    [sym_fsi_directive_decl] = STATE(1708),
    [sym_preproc_line] = STATE(1708),
    [sym_identifier] = ACTIONS(3841),
    [anon_sym_EQ] = ACTIONS(3839),
    [anon_sym_LBRACK_LT] = ACTIONS(3839),
    [anon_sym_COLON] = ACTIONS(3841),
    [anon_sym_return] = ACTIONS(3841),
    [anon_sym_do] = ACTIONS(3841),
    [anon_sym_let] = ACTIONS(3841),
    [anon_sym_let_BANG] = ACTIONS(3839),
    [aux_sym_access_modifier_token1] = ACTIONS(3839),
    [anon_sym_LPAREN] = ACTIONS(3841),
    [anon_sym_COMMA] = ACTIONS(3839),
    [anon_sym_null] = ACTIONS(3841),
    [anon_sym_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_COLON] = ACTIONS(3839),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_AMP] = ACTIONS(3841),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(3841),
    [anon_sym_LT_AT] = ACTIONS(3841),
    [anon_sym_LT_AT_AT] = ACTIONS(3841),
    [anon_sym_DOT] = ACTIONS(3841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3839),
    [anon_sym_new] = ACTIONS(3841),
    [anon_sym_with] = ACTIONS(3841),
    [anon_sym_return_BANG] = ACTIONS(3839),
    [anon_sym_yield] = ACTIONS(3841),
    [anon_sym_yield_BANG] = ACTIONS(3839),
    [anon_sym_lazy] = ACTIONS(3841),
    [anon_sym_assert] = ACTIONS(3841),
    [anon_sym_upcast] = ACTIONS(3841),
    [anon_sym_downcast] = ACTIONS(3841),
    [anon_sym_COLON_GT] = ACTIONS(3839),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3839),
    [anon_sym_for] = ACTIONS(3841),
    [anon_sym_while] = ACTIONS(3841),
    [anon_sym_if] = ACTIONS(3841),
    [anon_sym_fun] = ACTIONS(3841),
    [anon_sym_try] = ACTIONS(3841),
    [anon_sym_match] = ACTIONS(3841),
    [anon_sym_match_BANG] = ACTIONS(3839),
    [anon_sym_function] = ACTIONS(3841),
    [anon_sym_LT_DASH] = ACTIONS(3841),
    [anon_sym_DOT_LBRACK] = ACTIONS(3839),
    [anon_sym_LT] = ACTIONS(3839),
    [anon_sym_use] = ACTIONS(3841),
    [anon_sym_use_BANG] = ACTIONS(3839),
    [anon_sym_do_BANG] = ACTIONS(3839),
    [anon_sym_begin] = ACTIONS(3841),
    [anon_sym_LPAREN2] = ACTIONS(3841),
    [anon_sym_default] = ACTIONS(3841),
    [anon_sym_or] = ACTIONS(3841),
    [anon_sym_static] = ACTIONS(3841),
    [anon_sym_member] = ACTIONS(3841),
    [anon_sym_interface] = ACTIONS(3841),
    [anon_sym_abstract] = ACTIONS(3841),
    [anon_sym_val] = ACTIONS(3841),
    [anon_sym_override] = ACTIONS(3841),
    [anon_sym_inherit] = ACTIONS(3841),
    [aux_sym_char_token1] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3841),
    [anon_sym_DQUOTE] = ACTIONS(3841),
    [anon_sym_AT_DQUOTE] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [sym_bool] = ACTIONS(3841),
    [sym_unit] = ACTIONS(3839),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3841),
    [sym_op_identifier] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_PLUS_DOT] = ACTIONS(3841),
    [anon_sym_DASH_DOT] = ACTIONS(3841),
    [anon_sym_PERCENT] = ACTIONS(3841),
    [anon_sym_AMP_AMP] = ACTIONS(3841),
    [anon_sym_TILDE] = ACTIONS(3839),
    [aux_sym_prefix_op_token1] = ACTIONS(3841),
    [aux_sym_infix_op_token1] = ACTIONS(3839),
    [aux_sym_infix_op_token2] = ACTIONS(3841),
    [anon_sym_PIPE_PIPE] = ACTIONS(3841),
    [anon_sym_BANG_EQ] = ACTIONS(3841),
    [anon_sym_COLON_EQ] = ACTIONS(3839),
    [anon_sym_DOLLAR] = ACTIONS(3841),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3841),
    [sym_int] = ACTIONS(3841),
    [sym_xint] = ACTIONS(3839),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3839),
    [anon_sym_POUNDendif] = ACTIONS(3839),
    [sym__newline] = ACTIONS(3839),
  },
  [1709] = {
    [sym_block_comment] = STATE(1709),
    [sym_compiler_directive_decl] = STATE(1709),
    [sym_fsi_directive_decl] = STATE(1709),
    [sym_preproc_line] = STATE(1709),
    [sym_identifier] = ACTIONS(4220),
    [anon_sym_EQ] = ACTIONS(4218),
    [anon_sym_LBRACK_LT] = ACTIONS(4218),
    [anon_sym_COLON] = ACTIONS(4220),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_do] = ACTIONS(4220),
    [anon_sym_let] = ACTIONS(4220),
    [anon_sym_let_BANG] = ACTIONS(4218),
    [aux_sym_access_modifier_token1] = ACTIONS(4218),
    [anon_sym_LPAREN] = ACTIONS(4220),
    [anon_sym_COMMA] = ACTIONS(4218),
    [anon_sym_null] = ACTIONS(4220),
    [anon_sym_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_COLON] = ACTIONS(4218),
    [anon_sym_AMP] = ACTIONS(4220),
    [anon_sym_LBRACK] = ACTIONS(4220),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(4220),
    [anon_sym_LT_AT] = ACTIONS(4220),
    [anon_sym_LT_AT_AT] = ACTIONS(4220),
    [anon_sym_DOT] = ACTIONS(4220),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4218),
    [anon_sym_new] = ACTIONS(4220),
    [anon_sym_with] = ACTIONS(4220),
    [anon_sym_return_BANG] = ACTIONS(4218),
    [anon_sym_yield] = ACTIONS(4220),
    [anon_sym_yield_BANG] = ACTIONS(4218),
    [anon_sym_lazy] = ACTIONS(4220),
    [anon_sym_assert] = ACTIONS(4220),
    [anon_sym_upcast] = ACTIONS(4220),
    [anon_sym_downcast] = ACTIONS(4220),
    [anon_sym_COLON_GT] = ACTIONS(4218),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4218),
    [anon_sym_for] = ACTIONS(4220),
    [anon_sym_while] = ACTIONS(4220),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_fun] = ACTIONS(4220),
    [anon_sym_try] = ACTIONS(4220),
    [anon_sym_match] = ACTIONS(4220),
    [anon_sym_match_BANG] = ACTIONS(4218),
    [anon_sym_function] = ACTIONS(4220),
    [anon_sym_LT_DASH] = ACTIONS(4220),
    [anon_sym_DOT_LBRACK] = ACTIONS(4218),
    [anon_sym_LT] = ACTIONS(4218),
    [anon_sym_use] = ACTIONS(4220),
    [anon_sym_use_BANG] = ACTIONS(4218),
    [anon_sym_do_BANG] = ACTIONS(4218),
    [anon_sym_begin] = ACTIONS(4220),
    [anon_sym_LPAREN2] = ACTIONS(4220),
    [anon_sym_default] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(4220),
    [anon_sym_static] = ACTIONS(4220),
    [anon_sym_member] = ACTIONS(4220),
    [anon_sym_interface] = ACTIONS(4220),
    [anon_sym_abstract] = ACTIONS(4220),
    [anon_sym_val] = ACTIONS(4220),
    [anon_sym_override] = ACTIONS(4220),
    [anon_sym_inherit] = ACTIONS(4220),
    [aux_sym_char_token1] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4220),
    [anon_sym_DQUOTE] = ACTIONS(4220),
    [anon_sym_AT_DQUOTE] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [sym_bool] = ACTIONS(4220),
    [sym_unit] = ACTIONS(4218),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4220),
    [sym_op_identifier] = ACTIONS(4220),
    [anon_sym_PLUS] = ACTIONS(4220),
    [anon_sym_DASH] = ACTIONS(4220),
    [anon_sym_PLUS_DOT] = ACTIONS(4220),
    [anon_sym_DASH_DOT] = ACTIONS(4220),
    [anon_sym_PERCENT] = ACTIONS(4220),
    [anon_sym_AMP_AMP] = ACTIONS(4220),
    [anon_sym_TILDE] = ACTIONS(4218),
    [aux_sym_prefix_op_token1] = ACTIONS(4220),
    [aux_sym_infix_op_token1] = ACTIONS(4218),
    [aux_sym_infix_op_token2] = ACTIONS(4220),
    [anon_sym_PIPE_PIPE] = ACTIONS(4220),
    [anon_sym_BANG_EQ] = ACTIONS(4220),
    [anon_sym_COLON_EQ] = ACTIONS(4218),
    [anon_sym_DOLLAR] = ACTIONS(4220),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4220),
    [sym_int] = ACTIONS(4220),
    [sym_xint] = ACTIONS(4218),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4218),
    [anon_sym_POUNDendif] = ACTIONS(4218),
    [anon_sym_POUNDelse] = ACTIONS(4218),
    [sym__newline] = ACTIONS(4218),
  },
  [1710] = {
    [sym_block_comment] = STATE(1710),
    [sym_compiler_directive_decl] = STATE(1710),
    [sym_fsi_directive_decl] = STATE(1710),
    [sym_preproc_line] = STATE(1710),
    [sym_identifier] = ACTIONS(4216),
    [anon_sym_EQ] = ACTIONS(4214),
    [anon_sym_LBRACK_LT] = ACTIONS(4214),
    [anon_sym_COLON] = ACTIONS(4216),
    [anon_sym_return] = ACTIONS(4216),
    [anon_sym_do] = ACTIONS(4216),
    [anon_sym_let] = ACTIONS(4216),
    [anon_sym_let_BANG] = ACTIONS(4214),
    [aux_sym_access_modifier_token1] = ACTIONS(4214),
    [anon_sym_LPAREN] = ACTIONS(4216),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_null] = ACTIONS(4216),
    [anon_sym_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_COLON] = ACTIONS(4214),
    [anon_sym_AMP] = ACTIONS(4216),
    [anon_sym_LBRACK] = ACTIONS(4216),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4214),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_LT_AT] = ACTIONS(4216),
    [anon_sym_LT_AT_AT] = ACTIONS(4216),
    [anon_sym_DOT] = ACTIONS(4216),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4214),
    [anon_sym_new] = ACTIONS(4216),
    [anon_sym_with] = ACTIONS(4216),
    [anon_sym_return_BANG] = ACTIONS(4214),
    [anon_sym_yield] = ACTIONS(4216),
    [anon_sym_yield_BANG] = ACTIONS(4214),
    [anon_sym_lazy] = ACTIONS(4216),
    [anon_sym_assert] = ACTIONS(4216),
    [anon_sym_upcast] = ACTIONS(4216),
    [anon_sym_downcast] = ACTIONS(4216),
    [anon_sym_COLON_GT] = ACTIONS(4214),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4214),
    [anon_sym_for] = ACTIONS(4216),
    [anon_sym_while] = ACTIONS(4216),
    [anon_sym_if] = ACTIONS(4216),
    [anon_sym_fun] = ACTIONS(4216),
    [anon_sym_try] = ACTIONS(4216),
    [anon_sym_match] = ACTIONS(4216),
    [anon_sym_match_BANG] = ACTIONS(4214),
    [anon_sym_function] = ACTIONS(4216),
    [anon_sym_LT_DASH] = ACTIONS(4216),
    [anon_sym_DOT_LBRACK] = ACTIONS(4214),
    [anon_sym_LT] = ACTIONS(4214),
    [anon_sym_use] = ACTIONS(4216),
    [anon_sym_use_BANG] = ACTIONS(4214),
    [anon_sym_do_BANG] = ACTIONS(4214),
    [anon_sym_begin] = ACTIONS(4216),
    [anon_sym_LPAREN2] = ACTIONS(4216),
    [anon_sym_default] = ACTIONS(4216),
    [anon_sym_or] = ACTIONS(4216),
    [anon_sym_static] = ACTIONS(4216),
    [anon_sym_member] = ACTIONS(4216),
    [anon_sym_interface] = ACTIONS(4216),
    [anon_sym_abstract] = ACTIONS(4216),
    [anon_sym_val] = ACTIONS(4216),
    [anon_sym_override] = ACTIONS(4216),
    [anon_sym_inherit] = ACTIONS(4216),
    [aux_sym_char_token1] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4216),
    [anon_sym_DQUOTE] = ACTIONS(4216),
    [anon_sym_AT_DQUOTE] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [sym_bool] = ACTIONS(4216),
    [sym_unit] = ACTIONS(4214),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4216),
    [sym_op_identifier] = ACTIONS(4216),
    [anon_sym_PLUS] = ACTIONS(4216),
    [anon_sym_DASH] = ACTIONS(4216),
    [anon_sym_PLUS_DOT] = ACTIONS(4216),
    [anon_sym_DASH_DOT] = ACTIONS(4216),
    [anon_sym_PERCENT] = ACTIONS(4216),
    [anon_sym_AMP_AMP] = ACTIONS(4216),
    [anon_sym_TILDE] = ACTIONS(4214),
    [aux_sym_prefix_op_token1] = ACTIONS(4216),
    [aux_sym_infix_op_token1] = ACTIONS(4214),
    [aux_sym_infix_op_token2] = ACTIONS(4216),
    [anon_sym_PIPE_PIPE] = ACTIONS(4216),
    [anon_sym_BANG_EQ] = ACTIONS(4216),
    [anon_sym_COLON_EQ] = ACTIONS(4214),
    [anon_sym_DOLLAR] = ACTIONS(4216),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4216),
    [sym_int] = ACTIONS(4216),
    [sym_xint] = ACTIONS(4214),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4214),
    [anon_sym_POUNDendif] = ACTIONS(4214),
    [anon_sym_POUNDelse] = ACTIONS(4214),
    [sym__newline] = ACTIONS(4214),
  },
  [1711] = {
    [sym_block_comment] = STATE(1711),
    [sym_compiler_directive_decl] = STATE(1711),
    [sym_fsi_directive_decl] = STATE(1711),
    [sym_preproc_line] = STATE(1711),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_EQ] = ACTIONS(4199),
    [anon_sym_LBRACK_LT] = ACTIONS(4199),
    [anon_sym_COLON] = ACTIONS(4201),
    [anon_sym_return] = ACTIONS(4201),
    [anon_sym_do] = ACTIONS(4201),
    [anon_sym_let] = ACTIONS(4201),
    [anon_sym_let_BANG] = ACTIONS(4199),
    [aux_sym_access_modifier_token1] = ACTIONS(4199),
    [anon_sym_LPAREN] = ACTIONS(4201),
    [anon_sym_COMMA] = ACTIONS(4199),
    [anon_sym_null] = ACTIONS(4201),
    [anon_sym_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(4199),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_LBRACK] = ACTIONS(4201),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4199),
    [anon_sym_LBRACE] = ACTIONS(4201),
    [anon_sym_LT_AT] = ACTIONS(4201),
    [anon_sym_LT_AT_AT] = ACTIONS(4201),
    [anon_sym_DOT] = ACTIONS(4201),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4199),
    [anon_sym_new] = ACTIONS(4201),
    [anon_sym_with] = ACTIONS(4201),
    [anon_sym_return_BANG] = ACTIONS(4199),
    [anon_sym_yield] = ACTIONS(4201),
    [anon_sym_yield_BANG] = ACTIONS(4199),
    [anon_sym_lazy] = ACTIONS(4201),
    [anon_sym_assert] = ACTIONS(4201),
    [anon_sym_upcast] = ACTIONS(4201),
    [anon_sym_downcast] = ACTIONS(4201),
    [anon_sym_COLON_GT] = ACTIONS(4199),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4199),
    [anon_sym_for] = ACTIONS(4201),
    [anon_sym_while] = ACTIONS(4201),
    [anon_sym_if] = ACTIONS(4201),
    [anon_sym_fun] = ACTIONS(4201),
    [anon_sym_try] = ACTIONS(4201),
    [anon_sym_match] = ACTIONS(4201),
    [anon_sym_match_BANG] = ACTIONS(4199),
    [anon_sym_function] = ACTIONS(4201),
    [anon_sym_LT_DASH] = ACTIONS(4201),
    [anon_sym_DOT_LBRACK] = ACTIONS(4199),
    [anon_sym_LT] = ACTIONS(4199),
    [anon_sym_use] = ACTIONS(4201),
    [anon_sym_use_BANG] = ACTIONS(4199),
    [anon_sym_do_BANG] = ACTIONS(4199),
    [anon_sym_begin] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(4201),
    [anon_sym_default] = ACTIONS(4201),
    [anon_sym_or] = ACTIONS(4201),
    [anon_sym_static] = ACTIONS(4201),
    [anon_sym_member] = ACTIONS(4201),
    [anon_sym_interface] = ACTIONS(4201),
    [anon_sym_abstract] = ACTIONS(4201),
    [anon_sym_val] = ACTIONS(4201),
    [anon_sym_override] = ACTIONS(4201),
    [anon_sym_inherit] = ACTIONS(4201),
    [aux_sym_char_token1] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4201),
    [anon_sym_DQUOTE] = ACTIONS(4201),
    [anon_sym_AT_DQUOTE] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [sym_bool] = ACTIONS(4201),
    [sym_unit] = ACTIONS(4199),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4201),
    [sym_op_identifier] = ACTIONS(4201),
    [anon_sym_PLUS] = ACTIONS(4201),
    [anon_sym_DASH] = ACTIONS(4201),
    [anon_sym_PLUS_DOT] = ACTIONS(4201),
    [anon_sym_DASH_DOT] = ACTIONS(4201),
    [anon_sym_PERCENT] = ACTIONS(4201),
    [anon_sym_AMP_AMP] = ACTIONS(4201),
    [anon_sym_TILDE] = ACTIONS(4199),
    [aux_sym_prefix_op_token1] = ACTIONS(4201),
    [aux_sym_infix_op_token1] = ACTIONS(4199),
    [aux_sym_infix_op_token2] = ACTIONS(4201),
    [anon_sym_PIPE_PIPE] = ACTIONS(4201),
    [anon_sym_BANG_EQ] = ACTIONS(4201),
    [anon_sym_COLON_EQ] = ACTIONS(4199),
    [anon_sym_DOLLAR] = ACTIONS(4201),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4201),
    [sym_int] = ACTIONS(4201),
    [sym_xint] = ACTIONS(4199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4199),
    [anon_sym_POUNDendif] = ACTIONS(4199),
    [anon_sym_POUNDelse] = ACTIONS(4199),
    [sym__newline] = ACTIONS(4199),
  },
  [1712] = {
    [sym_block_comment] = STATE(1712),
    [sym_compiler_directive_decl] = STATE(1712),
    [sym_fsi_directive_decl] = STATE(1712),
    [sym_preproc_line] = STATE(1712),
    [sym_identifier] = ACTIONS(3828),
    [anon_sym_EQ] = ACTIONS(3826),
    [anon_sym_LBRACK_LT] = ACTIONS(3826),
    [anon_sym_COLON] = ACTIONS(3828),
    [anon_sym_return] = ACTIONS(3828),
    [anon_sym_do] = ACTIONS(3828),
    [anon_sym_let] = ACTIONS(3828),
    [anon_sym_let_BANG] = ACTIONS(3826),
    [aux_sym_access_modifier_token1] = ACTIONS(3826),
    [anon_sym_LPAREN] = ACTIONS(3828),
    [anon_sym_COMMA] = ACTIONS(3826),
    [anon_sym_null] = ACTIONS(3828),
    [anon_sym_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_COLON] = ACTIONS(3826),
    [anon_sym_PIPE] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3828),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3826),
    [anon_sym_LBRACE] = ACTIONS(3828),
    [anon_sym_LT_AT] = ACTIONS(3828),
    [anon_sym_LT_AT_AT] = ACTIONS(3828),
    [anon_sym_DOT] = ACTIONS(3828),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3826),
    [anon_sym_new] = ACTIONS(3828),
    [anon_sym_with] = ACTIONS(3828),
    [anon_sym_return_BANG] = ACTIONS(3826),
    [anon_sym_yield] = ACTIONS(3828),
    [anon_sym_yield_BANG] = ACTIONS(3826),
    [anon_sym_lazy] = ACTIONS(3828),
    [anon_sym_assert] = ACTIONS(3828),
    [anon_sym_upcast] = ACTIONS(3828),
    [anon_sym_downcast] = ACTIONS(3828),
    [anon_sym_COLON_GT] = ACTIONS(3826),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3826),
    [anon_sym_for] = ACTIONS(3828),
    [anon_sym_while] = ACTIONS(3828),
    [anon_sym_if] = ACTIONS(3828),
    [anon_sym_fun] = ACTIONS(3828),
    [anon_sym_try] = ACTIONS(3828),
    [anon_sym_match] = ACTIONS(3828),
    [anon_sym_match_BANG] = ACTIONS(3826),
    [anon_sym_function] = ACTIONS(3828),
    [anon_sym_LT_DASH] = ACTIONS(3828),
    [anon_sym_DOT_LBRACK] = ACTIONS(3826),
    [anon_sym_LT] = ACTIONS(3826),
    [anon_sym_use] = ACTIONS(3828),
    [anon_sym_use_BANG] = ACTIONS(3826),
    [anon_sym_do_BANG] = ACTIONS(3826),
    [anon_sym_begin] = ACTIONS(3828),
    [anon_sym_LPAREN2] = ACTIONS(3828),
    [anon_sym_default] = ACTIONS(3828),
    [anon_sym_or] = ACTIONS(3828),
    [anon_sym_static] = ACTIONS(3828),
    [anon_sym_member] = ACTIONS(3828),
    [anon_sym_interface] = ACTIONS(3828),
    [anon_sym_abstract] = ACTIONS(3828),
    [anon_sym_val] = ACTIONS(3828),
    [anon_sym_override] = ACTIONS(3828),
    [anon_sym_inherit] = ACTIONS(3828),
    [aux_sym_char_token1] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3828),
    [anon_sym_DQUOTE] = ACTIONS(3828),
    [anon_sym_AT_DQUOTE] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [sym_bool] = ACTIONS(3828),
    [sym_unit] = ACTIONS(3826),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3828),
    [sym_op_identifier] = ACTIONS(3828),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_DASH] = ACTIONS(3828),
    [anon_sym_PLUS_DOT] = ACTIONS(3828),
    [anon_sym_DASH_DOT] = ACTIONS(3828),
    [anon_sym_PERCENT] = ACTIONS(3828),
    [anon_sym_AMP_AMP] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3826),
    [aux_sym_prefix_op_token1] = ACTIONS(3828),
    [aux_sym_infix_op_token1] = ACTIONS(3826),
    [aux_sym_infix_op_token2] = ACTIONS(3828),
    [anon_sym_PIPE_PIPE] = ACTIONS(3828),
    [anon_sym_BANG_EQ] = ACTIONS(3828),
    [anon_sym_COLON_EQ] = ACTIONS(3826),
    [anon_sym_DOLLAR] = ACTIONS(3828),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3828),
    [sym_int] = ACTIONS(3828),
    [sym_xint] = ACTIONS(3826),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3826),
    [anon_sym_POUNDendif] = ACTIONS(3826),
    [sym__newline] = ACTIONS(3826),
  },
  [1713] = {
    [sym_block_comment] = STATE(1713),
    [sym_compiler_directive_decl] = STATE(1713),
    [sym_fsi_directive_decl] = STATE(1713),
    [sym_preproc_line] = STATE(1713),
    [sym_identifier] = ACTIONS(3813),
    [anon_sym_EQ] = ACTIONS(3811),
    [anon_sym_LBRACK_LT] = ACTIONS(3811),
    [anon_sym_COLON] = ACTIONS(3813),
    [anon_sym_return] = ACTIONS(3813),
    [anon_sym_do] = ACTIONS(3813),
    [anon_sym_and] = ACTIONS(3813),
    [anon_sym_let] = ACTIONS(3813),
    [anon_sym_let_BANG] = ACTIONS(3811),
    [aux_sym_access_modifier_token1] = ACTIONS(3811),
    [anon_sym_LPAREN] = ACTIONS(3813),
    [anon_sym_COMMA] = ACTIONS(3811),
    [anon_sym_null] = ACTIONS(3813),
    [anon_sym_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_COLON] = ACTIONS(3811),
    [anon_sym_AMP] = ACTIONS(3813),
    [anon_sym_LBRACK] = ACTIONS(3813),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3811),
    [anon_sym_LBRACE] = ACTIONS(3813),
    [anon_sym_LT_AT] = ACTIONS(3813),
    [anon_sym_LT_AT_AT] = ACTIONS(3813),
    [anon_sym_DOT] = ACTIONS(3813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3811),
    [anon_sym_new] = ACTIONS(3813),
    [anon_sym_with] = ACTIONS(3813),
    [anon_sym_return_BANG] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_yield_BANG] = ACTIONS(3811),
    [anon_sym_lazy] = ACTIONS(3813),
    [anon_sym_assert] = ACTIONS(3813),
    [anon_sym_upcast] = ACTIONS(3813),
    [anon_sym_downcast] = ACTIONS(3813),
    [anon_sym_COLON_GT] = ACTIONS(3811),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3811),
    [anon_sym_for] = ACTIONS(3813),
    [anon_sym_done] = ACTIONS(4675),
    [anon_sym_while] = ACTIONS(3813),
    [anon_sym_if] = ACTIONS(3813),
    [anon_sym_fun] = ACTIONS(3813),
    [anon_sym_try] = ACTIONS(3813),
    [anon_sym_match] = ACTIONS(3813),
    [anon_sym_match_BANG] = ACTIONS(3811),
    [anon_sym_function] = ACTIONS(3813),
    [anon_sym_LT_DASH] = ACTIONS(3813),
    [anon_sym_DOT_LBRACK] = ACTIONS(3811),
    [anon_sym_LT] = ACTIONS(3811),
    [anon_sym_use] = ACTIONS(3813),
    [anon_sym_use_BANG] = ACTIONS(3811),
    [anon_sym_do_BANG] = ACTIONS(3811),
    [anon_sym_begin] = ACTIONS(3813),
    [anon_sym_LPAREN2] = ACTIONS(3813),
    [anon_sym_default] = ACTIONS(3813),
    [anon_sym_or] = ACTIONS(3813),
    [anon_sym_static] = ACTIONS(3813),
    [anon_sym_member] = ACTIONS(3813),
    [anon_sym_interface] = ACTIONS(3813),
    [anon_sym_abstract] = ACTIONS(3813),
    [anon_sym_val] = ACTIONS(3813),
    [anon_sym_override] = ACTIONS(3813),
    [aux_sym_char_token1] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3813),
    [anon_sym_DQUOTE] = ACTIONS(3813),
    [anon_sym_AT_DQUOTE] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [sym_bool] = ACTIONS(3813),
    [sym_unit] = ACTIONS(3811),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3813),
    [sym_op_identifier] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PLUS_DOT] = ACTIONS(3813),
    [anon_sym_DASH_DOT] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3813),
    [anon_sym_AMP_AMP] = ACTIONS(3813),
    [anon_sym_TILDE] = ACTIONS(3811),
    [aux_sym_prefix_op_token1] = ACTIONS(3813),
    [aux_sym_infix_op_token1] = ACTIONS(3811),
    [aux_sym_infix_op_token2] = ACTIONS(3813),
    [anon_sym_PIPE_PIPE] = ACTIONS(3813),
    [anon_sym_BANG_EQ] = ACTIONS(3813),
    [anon_sym_COLON_EQ] = ACTIONS(3811),
    [anon_sym_DOLLAR] = ACTIONS(3813),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3813),
    [sym_int] = ACTIONS(3813),
    [sym_xint] = ACTIONS(3811),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3811),
    [sym__newline] = ACTIONS(3811),
    [sym__dedent] = ACTIONS(3811),
  },
  [1714] = {
    [sym_block_comment] = STATE(1714),
    [sym_compiler_directive_decl] = STATE(1714),
    [sym_fsi_directive_decl] = STATE(1714),
    [sym_preproc_line] = STATE(1714),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_LBRACK_LT] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [aux_sym_access_modifier_token1] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_with] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_default] = ACTIONS(3743),
    [anon_sym_or] = ACTIONS(3743),
    [anon_sym_static] = ACTIONS(3743),
    [anon_sym_member] = ACTIONS(3743),
    [anon_sym_interface] = ACTIONS(3743),
    [anon_sym_abstract] = ACTIONS(3743),
    [anon_sym_val] = ACTIONS(3743),
    [anon_sym_override] = ACTIONS(3743),
    [anon_sym_inherit] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [anon_sym_POUNDendif] = ACTIONS(3741),
    [sym__newline] = ACTIONS(3741),
  },
  [1715] = {
    [sym_block_comment] = STATE(1715),
    [sym_compiler_directive_decl] = STATE(1715),
    [sym_fsi_directive_decl] = STATE(1715),
    [sym_preproc_line] = STATE(1715),
    [sym_identifier] = ACTIONS(3881),
    [anon_sym_EQ] = ACTIONS(3879),
    [anon_sym_LBRACK_LT] = ACTIONS(3879),
    [anon_sym_COLON] = ACTIONS(3881),
    [anon_sym_return] = ACTIONS(3881),
    [anon_sym_do] = ACTIONS(3881),
    [anon_sym_and] = ACTIONS(3881),
    [anon_sym_let] = ACTIONS(3881),
    [anon_sym_let_BANG] = ACTIONS(3879),
    [aux_sym_access_modifier_token1] = ACTIONS(3879),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3879),
    [anon_sym_null] = ACTIONS(3881),
    [anon_sym_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3879),
    [anon_sym_LBRACE] = ACTIONS(3881),
    [anon_sym_LT_AT] = ACTIONS(3881),
    [anon_sym_LT_AT_AT] = ACTIONS(3881),
    [anon_sym_DOT] = ACTIONS(3881),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3879),
    [anon_sym_new] = ACTIONS(3881),
    [anon_sym_with] = ACTIONS(3881),
    [anon_sym_return_BANG] = ACTIONS(3879),
    [anon_sym_yield] = ACTIONS(3881),
    [anon_sym_yield_BANG] = ACTIONS(3879),
    [anon_sym_lazy] = ACTIONS(3881),
    [anon_sym_assert] = ACTIONS(3881),
    [anon_sym_upcast] = ACTIONS(3881),
    [anon_sym_downcast] = ACTIONS(3881),
    [anon_sym_COLON_GT] = ACTIONS(3879),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3879),
    [anon_sym_for] = ACTIONS(3881),
    [anon_sym_while] = ACTIONS(3881),
    [anon_sym_if] = ACTIONS(3881),
    [anon_sym_fun] = ACTIONS(3881),
    [anon_sym_try] = ACTIONS(3881),
    [anon_sym_match] = ACTIONS(3881),
    [anon_sym_match_BANG] = ACTIONS(3879),
    [anon_sym_function] = ACTIONS(3881),
    [anon_sym_LT_DASH] = ACTIONS(3881),
    [anon_sym_DOT_LBRACK] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_use] = ACTIONS(3881),
    [anon_sym_use_BANG] = ACTIONS(3879),
    [anon_sym_do_BANG] = ACTIONS(3879),
    [anon_sym_begin] = ACTIONS(3881),
    [anon_sym_LPAREN2] = ACTIONS(3881),
    [anon_sym_default] = ACTIONS(3881),
    [anon_sym_or] = ACTIONS(3881),
    [anon_sym_static] = ACTIONS(3881),
    [anon_sym_member] = ACTIONS(3881),
    [anon_sym_interface] = ACTIONS(3881),
    [anon_sym_abstract] = ACTIONS(3881),
    [anon_sym_val] = ACTIONS(3881),
    [anon_sym_override] = ACTIONS(3881),
    [aux_sym_char_token1] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3881),
    [anon_sym_DQUOTE] = ACTIONS(3881),
    [anon_sym_AT_DQUOTE] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [sym_bool] = ACTIONS(3881),
    [sym_unit] = ACTIONS(3879),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3881),
    [sym_op_identifier] = ACTIONS(3881),
    [anon_sym_PLUS] = ACTIONS(3881),
    [anon_sym_DASH] = ACTIONS(3881),
    [anon_sym_PLUS_DOT] = ACTIONS(3881),
    [anon_sym_DASH_DOT] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(3881),
    [anon_sym_AMP_AMP] = ACTIONS(3881),
    [anon_sym_TILDE] = ACTIONS(3879),
    [aux_sym_prefix_op_token1] = ACTIONS(3881),
    [aux_sym_infix_op_token1] = ACTIONS(3879),
    [aux_sym_infix_op_token2] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE] = ACTIONS(3881),
    [anon_sym_BANG_EQ] = ACTIONS(3881),
    [anon_sym_COLON_EQ] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3881),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3881),
    [sym_int] = ACTIONS(3881),
    [sym_xint] = ACTIONS(3879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3879),
    [anon_sym_POUNDendif] = ACTIONS(3879),
    [anon_sym_POUNDelse] = ACTIONS(3879),
    [sym__newline] = ACTIONS(3879),
  },
  [1716] = {
    [sym_block_comment] = STATE(1716),
    [sym_compiler_directive_decl] = STATE(1716),
    [sym_fsi_directive_decl] = STATE(1716),
    [sym_preproc_line] = STATE(1716),
    [sym_identifier] = ACTIONS(4193),
    [anon_sym_EQ] = ACTIONS(4191),
    [anon_sym_LBRACK_LT] = ACTIONS(4191),
    [anon_sym_COLON] = ACTIONS(4193),
    [anon_sym_return] = ACTIONS(4193),
    [anon_sym_do] = ACTIONS(4193),
    [anon_sym_let] = ACTIONS(4193),
    [anon_sym_let_BANG] = ACTIONS(4191),
    [aux_sym_access_modifier_token1] = ACTIONS(4191),
    [anon_sym_LPAREN] = ACTIONS(4193),
    [anon_sym_COMMA] = ACTIONS(4191),
    [anon_sym_null] = ACTIONS(4193),
    [anon_sym_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_COLON] = ACTIONS(4191),
    [anon_sym_AMP] = ACTIONS(4193),
    [anon_sym_LBRACK] = ACTIONS(4193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4191),
    [anon_sym_LBRACE] = ACTIONS(4193),
    [anon_sym_LT_AT] = ACTIONS(4193),
    [anon_sym_LT_AT_AT] = ACTIONS(4193),
    [anon_sym_DOT] = ACTIONS(4193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4191),
    [anon_sym_new] = ACTIONS(4193),
    [anon_sym_with] = ACTIONS(4193),
    [anon_sym_return_BANG] = ACTIONS(4191),
    [anon_sym_yield] = ACTIONS(4193),
    [anon_sym_yield_BANG] = ACTIONS(4191),
    [anon_sym_lazy] = ACTIONS(4193),
    [anon_sym_assert] = ACTIONS(4193),
    [anon_sym_upcast] = ACTIONS(4193),
    [anon_sym_downcast] = ACTIONS(4193),
    [anon_sym_COLON_GT] = ACTIONS(4191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4191),
    [anon_sym_for] = ACTIONS(4193),
    [anon_sym_while] = ACTIONS(4193),
    [anon_sym_if] = ACTIONS(4193),
    [anon_sym_fun] = ACTIONS(4193),
    [anon_sym_try] = ACTIONS(4193),
    [anon_sym_match] = ACTIONS(4193),
    [anon_sym_match_BANG] = ACTIONS(4191),
    [anon_sym_function] = ACTIONS(4193),
    [anon_sym_LT_DASH] = ACTIONS(4193),
    [anon_sym_DOT_LBRACK] = ACTIONS(4191),
    [anon_sym_LT] = ACTIONS(4191),
    [anon_sym_use] = ACTIONS(4193),
    [anon_sym_use_BANG] = ACTIONS(4191),
    [anon_sym_do_BANG] = ACTIONS(4191),
    [anon_sym_begin] = ACTIONS(4193),
    [anon_sym_LPAREN2] = ACTIONS(4193),
    [anon_sym_default] = ACTIONS(4193),
    [anon_sym_or] = ACTIONS(4193),
    [anon_sym_static] = ACTIONS(4193),
    [anon_sym_member] = ACTIONS(4193),
    [anon_sym_interface] = ACTIONS(4193),
    [anon_sym_abstract] = ACTIONS(4193),
    [anon_sym_val] = ACTIONS(4193),
    [anon_sym_override] = ACTIONS(4193),
    [anon_sym_inherit] = ACTIONS(4193),
    [aux_sym_char_token1] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4193),
    [anon_sym_DQUOTE] = ACTIONS(4193),
    [anon_sym_AT_DQUOTE] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [sym_bool] = ACTIONS(4193),
    [sym_unit] = ACTIONS(4191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4193),
    [sym_op_identifier] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4193),
    [anon_sym_DASH] = ACTIONS(4193),
    [anon_sym_PLUS_DOT] = ACTIONS(4193),
    [anon_sym_DASH_DOT] = ACTIONS(4193),
    [anon_sym_PERCENT] = ACTIONS(4193),
    [anon_sym_AMP_AMP] = ACTIONS(4193),
    [anon_sym_TILDE] = ACTIONS(4191),
    [aux_sym_prefix_op_token1] = ACTIONS(4193),
    [aux_sym_infix_op_token1] = ACTIONS(4191),
    [aux_sym_infix_op_token2] = ACTIONS(4193),
    [anon_sym_PIPE_PIPE] = ACTIONS(4193),
    [anon_sym_BANG_EQ] = ACTIONS(4193),
    [anon_sym_COLON_EQ] = ACTIONS(4191),
    [anon_sym_DOLLAR] = ACTIONS(4193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4193),
    [sym_int] = ACTIONS(4193),
    [sym_xint] = ACTIONS(4191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4191),
    [anon_sym_POUNDendif] = ACTIONS(4191),
    [anon_sym_POUNDelse] = ACTIONS(4191),
    [sym__newline] = ACTIONS(4191),
  },
  [1717] = {
    [sym_block_comment] = STATE(1717),
    [sym_compiler_directive_decl] = STATE(1717),
    [sym_fsi_directive_decl] = STATE(1717),
    [sym_preproc_line] = STATE(1717),
    [sym_identifier] = ACTIONS(3813),
    [anon_sym_EQ] = ACTIONS(3811),
    [anon_sym_LBRACK_LT] = ACTIONS(3811),
    [anon_sym_COLON] = ACTIONS(3813),
    [anon_sym_return] = ACTIONS(3813),
    [anon_sym_do] = ACTIONS(3813),
    [anon_sym_let] = ACTIONS(3813),
    [anon_sym_let_BANG] = ACTIONS(3811),
    [aux_sym_access_modifier_token1] = ACTIONS(3811),
    [anon_sym_LPAREN] = ACTIONS(3813),
    [anon_sym_COMMA] = ACTIONS(3811),
    [anon_sym_null] = ACTIONS(3813),
    [anon_sym_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_COLON] = ACTIONS(3811),
    [anon_sym_AMP] = ACTIONS(3813),
    [anon_sym_LBRACK] = ACTIONS(3813),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3811),
    [anon_sym_LBRACE] = ACTIONS(3813),
    [anon_sym_LT_AT] = ACTIONS(3813),
    [anon_sym_LT_AT_AT] = ACTIONS(3813),
    [anon_sym_DOT] = ACTIONS(3813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3811),
    [anon_sym_new] = ACTIONS(3813),
    [anon_sym_with] = ACTIONS(3813),
    [anon_sym_return_BANG] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_yield_BANG] = ACTIONS(3811),
    [anon_sym_lazy] = ACTIONS(3813),
    [anon_sym_assert] = ACTIONS(3813),
    [anon_sym_upcast] = ACTIONS(3813),
    [anon_sym_downcast] = ACTIONS(3813),
    [anon_sym_COLON_GT] = ACTIONS(3811),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3811),
    [anon_sym_for] = ACTIONS(3813),
    [anon_sym_done] = ACTIONS(4677),
    [anon_sym_while] = ACTIONS(3813),
    [anon_sym_if] = ACTIONS(3813),
    [anon_sym_fun] = ACTIONS(3813),
    [anon_sym_try] = ACTIONS(3813),
    [anon_sym_match] = ACTIONS(3813),
    [anon_sym_match_BANG] = ACTIONS(3811),
    [anon_sym_function] = ACTIONS(3813),
    [anon_sym_LT_DASH] = ACTIONS(3813),
    [anon_sym_DOT_LBRACK] = ACTIONS(3811),
    [anon_sym_LT] = ACTIONS(3811),
    [anon_sym_use] = ACTIONS(3813),
    [anon_sym_use_BANG] = ACTIONS(3811),
    [anon_sym_do_BANG] = ACTIONS(3811),
    [anon_sym_begin] = ACTIONS(3813),
    [anon_sym_LPAREN2] = ACTIONS(3813),
    [anon_sym_DOT_DOT2] = ACTIONS(3811),
    [anon_sym_default] = ACTIONS(3813),
    [anon_sym_or] = ACTIONS(3813),
    [anon_sym_static] = ACTIONS(3813),
    [anon_sym_member] = ACTIONS(3813),
    [anon_sym_interface] = ACTIONS(3813),
    [anon_sym_abstract] = ACTIONS(3813),
    [anon_sym_val] = ACTIONS(3813),
    [anon_sym_override] = ACTIONS(3813),
    [aux_sym_char_token1] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3813),
    [anon_sym_DQUOTE] = ACTIONS(3813),
    [anon_sym_AT_DQUOTE] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [sym_bool] = ACTIONS(3813),
    [sym_unit] = ACTIONS(3811),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3813),
    [sym_op_identifier] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PLUS_DOT] = ACTIONS(3813),
    [anon_sym_DASH_DOT] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3813),
    [anon_sym_AMP_AMP] = ACTIONS(3813),
    [anon_sym_TILDE] = ACTIONS(3811),
    [aux_sym_prefix_op_token1] = ACTIONS(3813),
    [aux_sym_infix_op_token1] = ACTIONS(3811),
    [aux_sym_infix_op_token2] = ACTIONS(3813),
    [anon_sym_PIPE_PIPE] = ACTIONS(3813),
    [anon_sym_BANG_EQ] = ACTIONS(3813),
    [anon_sym_COLON_EQ] = ACTIONS(3811),
    [anon_sym_DOLLAR] = ACTIONS(3813),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3813),
    [sym_int] = ACTIONS(3813),
    [sym_xint] = ACTIONS(3811),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3811),
    [sym__newline] = ACTIONS(3811),
    [sym__dedent] = ACTIONS(3811),
  },
  [1718] = {
    [sym_block_comment] = STATE(1718),
    [sym_compiler_directive_decl] = STATE(1718),
    [sym_fsi_directive_decl] = STATE(1718),
    [sym_preproc_line] = STATE(1718),
    [sym_identifier] = ACTIONS(4100),
    [anon_sym_EQ] = ACTIONS(4098),
    [anon_sym_LBRACK_LT] = ACTIONS(4098),
    [anon_sym_COLON] = ACTIONS(4100),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_do] = ACTIONS(4100),
    [anon_sym_let] = ACTIONS(4100),
    [anon_sym_let_BANG] = ACTIONS(4098),
    [aux_sym_access_modifier_token1] = ACTIONS(4098),
    [anon_sym_LPAREN] = ACTIONS(4100),
    [anon_sym_COMMA] = ACTIONS(4098),
    [anon_sym_null] = ACTIONS(4100),
    [anon_sym_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_COLON] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4100),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4098),
    [anon_sym_LBRACE] = ACTIONS(4100),
    [anon_sym_LT_AT] = ACTIONS(4100),
    [anon_sym_LT_AT_AT] = ACTIONS(4100),
    [anon_sym_DOT] = ACTIONS(4100),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4098),
    [anon_sym_new] = ACTIONS(4100),
    [anon_sym_with] = ACTIONS(4100),
    [anon_sym_return_BANG] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4100),
    [anon_sym_yield_BANG] = ACTIONS(4098),
    [anon_sym_lazy] = ACTIONS(4100),
    [anon_sym_assert] = ACTIONS(4100),
    [anon_sym_upcast] = ACTIONS(4100),
    [anon_sym_downcast] = ACTIONS(4100),
    [anon_sym_COLON_GT] = ACTIONS(4098),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4098),
    [anon_sym_for] = ACTIONS(4100),
    [anon_sym_while] = ACTIONS(4100),
    [anon_sym_if] = ACTIONS(4100),
    [anon_sym_fun] = ACTIONS(4100),
    [anon_sym_try] = ACTIONS(4100),
    [anon_sym_match] = ACTIONS(4100),
    [anon_sym_match_BANG] = ACTIONS(4098),
    [anon_sym_function] = ACTIONS(4100),
    [anon_sym_LT_DASH] = ACTIONS(4100),
    [anon_sym_DOT_LBRACK] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(4098),
    [anon_sym_use] = ACTIONS(4100),
    [anon_sym_use_BANG] = ACTIONS(4098),
    [anon_sym_do_BANG] = ACTIONS(4098),
    [anon_sym_begin] = ACTIONS(4100),
    [anon_sym_LPAREN2] = ACTIONS(4100),
    [anon_sym_default] = ACTIONS(4100),
    [anon_sym_or] = ACTIONS(4100),
    [anon_sym_static] = ACTIONS(4100),
    [anon_sym_member] = ACTIONS(4100),
    [anon_sym_interface] = ACTIONS(4100),
    [anon_sym_abstract] = ACTIONS(4100),
    [anon_sym_val] = ACTIONS(4100),
    [anon_sym_override] = ACTIONS(4100),
    [anon_sym_inherit] = ACTIONS(4100),
    [aux_sym_char_token1] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4100),
    [anon_sym_DQUOTE] = ACTIONS(4100),
    [anon_sym_AT_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [sym_bool] = ACTIONS(4100),
    [sym_unit] = ACTIONS(4098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4100),
    [sym_op_identifier] = ACTIONS(4100),
    [anon_sym_PLUS] = ACTIONS(4100),
    [anon_sym_DASH] = ACTIONS(4100),
    [anon_sym_PLUS_DOT] = ACTIONS(4100),
    [anon_sym_DASH_DOT] = ACTIONS(4100),
    [anon_sym_PERCENT] = ACTIONS(4100),
    [anon_sym_AMP_AMP] = ACTIONS(4100),
    [anon_sym_TILDE] = ACTIONS(4098),
    [aux_sym_prefix_op_token1] = ACTIONS(4100),
    [aux_sym_infix_op_token1] = ACTIONS(4098),
    [aux_sym_infix_op_token2] = ACTIONS(4100),
    [anon_sym_PIPE_PIPE] = ACTIONS(4100),
    [anon_sym_BANG_EQ] = ACTIONS(4100),
    [anon_sym_COLON_EQ] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4100),
    [sym_int] = ACTIONS(4100),
    [sym_xint] = ACTIONS(4098),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4098),
    [anon_sym_POUNDendif] = ACTIONS(4098),
    [anon_sym_POUNDelse] = ACTIONS(4098),
    [sym__newline] = ACTIONS(4098),
  },
  [1719] = {
    [sym_block_comment] = STATE(1719),
    [sym_compiler_directive_decl] = STATE(1719),
    [sym_fsi_directive_decl] = STATE(1719),
    [sym_preproc_line] = STATE(1719),
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_EQ] = ACTIONS(4149),
    [anon_sym_LBRACK_LT] = ACTIONS(4149),
    [anon_sym_COLON] = ACTIONS(4151),
    [anon_sym_return] = ACTIONS(4151),
    [anon_sym_do] = ACTIONS(4151),
    [anon_sym_let] = ACTIONS(4151),
    [anon_sym_let_BANG] = ACTIONS(4149),
    [aux_sym_access_modifier_token1] = ACTIONS(4149),
    [anon_sym_LPAREN] = ACTIONS(4151),
    [anon_sym_COMMA] = ACTIONS(4149),
    [anon_sym_null] = ACTIONS(4151),
    [anon_sym_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_AMP] = ACTIONS(4151),
    [anon_sym_LBRACK] = ACTIONS(4151),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4149),
    [anon_sym_LBRACE] = ACTIONS(4151),
    [anon_sym_LT_AT] = ACTIONS(4151),
    [anon_sym_LT_AT_AT] = ACTIONS(4151),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4149),
    [anon_sym_new] = ACTIONS(4151),
    [anon_sym_with] = ACTIONS(4151),
    [anon_sym_return_BANG] = ACTIONS(4149),
    [anon_sym_yield] = ACTIONS(4151),
    [anon_sym_yield_BANG] = ACTIONS(4149),
    [anon_sym_lazy] = ACTIONS(4151),
    [anon_sym_assert] = ACTIONS(4151),
    [anon_sym_upcast] = ACTIONS(4151),
    [anon_sym_downcast] = ACTIONS(4151),
    [anon_sym_COLON_GT] = ACTIONS(4149),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4149),
    [anon_sym_for] = ACTIONS(4151),
    [anon_sym_while] = ACTIONS(4151),
    [anon_sym_if] = ACTIONS(4151),
    [anon_sym_fun] = ACTIONS(4151),
    [anon_sym_try] = ACTIONS(4151),
    [anon_sym_match] = ACTIONS(4151),
    [anon_sym_match_BANG] = ACTIONS(4149),
    [anon_sym_function] = ACTIONS(4151),
    [anon_sym_LT_DASH] = ACTIONS(4151),
    [anon_sym_DOT_LBRACK] = ACTIONS(4149),
    [anon_sym_LT] = ACTIONS(4149),
    [anon_sym_use] = ACTIONS(4151),
    [anon_sym_use_BANG] = ACTIONS(4149),
    [anon_sym_do_BANG] = ACTIONS(4149),
    [anon_sym_begin] = ACTIONS(4151),
    [anon_sym_LPAREN2] = ACTIONS(4151),
    [anon_sym_default] = ACTIONS(4151),
    [anon_sym_or] = ACTIONS(4151),
    [anon_sym_static] = ACTIONS(4151),
    [anon_sym_member] = ACTIONS(4151),
    [anon_sym_interface] = ACTIONS(4151),
    [anon_sym_abstract] = ACTIONS(4151),
    [anon_sym_val] = ACTIONS(4151),
    [anon_sym_override] = ACTIONS(4151),
    [anon_sym_inherit] = ACTIONS(4151),
    [aux_sym_char_token1] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4151),
    [anon_sym_DQUOTE] = ACTIONS(4151),
    [anon_sym_AT_DQUOTE] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [sym_bool] = ACTIONS(4151),
    [sym_unit] = ACTIONS(4149),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4151),
    [sym_op_identifier] = ACTIONS(4151),
    [anon_sym_PLUS] = ACTIONS(4151),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_PLUS_DOT] = ACTIONS(4151),
    [anon_sym_DASH_DOT] = ACTIONS(4151),
    [anon_sym_PERCENT] = ACTIONS(4151),
    [anon_sym_AMP_AMP] = ACTIONS(4151),
    [anon_sym_TILDE] = ACTIONS(4149),
    [aux_sym_prefix_op_token1] = ACTIONS(4151),
    [aux_sym_infix_op_token1] = ACTIONS(4149),
    [aux_sym_infix_op_token2] = ACTIONS(4151),
    [anon_sym_PIPE_PIPE] = ACTIONS(4151),
    [anon_sym_BANG_EQ] = ACTIONS(4151),
    [anon_sym_COLON_EQ] = ACTIONS(4149),
    [anon_sym_DOLLAR] = ACTIONS(4151),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4151),
    [sym_int] = ACTIONS(4151),
    [sym_xint] = ACTIONS(4149),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4149),
    [anon_sym_POUNDendif] = ACTIONS(4149),
    [anon_sym_POUNDelse] = ACTIONS(4149),
    [sym__newline] = ACTIONS(4149),
  },
  [1720] = {
    [sym_block_comment] = STATE(1720),
    [sym_compiler_directive_decl] = STATE(1720),
    [sym_fsi_directive_decl] = STATE(1720),
    [sym_preproc_line] = STATE(1720),
    [sym_identifier] = ACTIONS(4180),
    [anon_sym_EQ] = ACTIONS(4178),
    [anon_sym_LBRACK_LT] = ACTIONS(4178),
    [anon_sym_COLON] = ACTIONS(4180),
    [anon_sym_return] = ACTIONS(4180),
    [anon_sym_do] = ACTIONS(4180),
    [anon_sym_let] = ACTIONS(4180),
    [anon_sym_let_BANG] = ACTIONS(4178),
    [aux_sym_access_modifier_token1] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(4180),
    [anon_sym_COMMA] = ACTIONS(4178),
    [anon_sym_null] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_COLON] = ACTIONS(4178),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4180),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4180),
    [anon_sym_LT_AT] = ACTIONS(4180),
    [anon_sym_LT_AT_AT] = ACTIONS(4180),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4178),
    [anon_sym_new] = ACTIONS(4180),
    [anon_sym_with] = ACTIONS(4180),
    [anon_sym_return_BANG] = ACTIONS(4178),
    [anon_sym_yield] = ACTIONS(4180),
    [anon_sym_yield_BANG] = ACTIONS(4178),
    [anon_sym_lazy] = ACTIONS(4180),
    [anon_sym_assert] = ACTIONS(4180),
    [anon_sym_upcast] = ACTIONS(4180),
    [anon_sym_downcast] = ACTIONS(4180),
    [anon_sym_COLON_GT] = ACTIONS(4178),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4178),
    [anon_sym_for] = ACTIONS(4180),
    [anon_sym_while] = ACTIONS(4180),
    [anon_sym_if] = ACTIONS(4180),
    [anon_sym_fun] = ACTIONS(4180),
    [anon_sym_try] = ACTIONS(4180),
    [anon_sym_match] = ACTIONS(4180),
    [anon_sym_match_BANG] = ACTIONS(4178),
    [anon_sym_function] = ACTIONS(4180),
    [anon_sym_LT_DASH] = ACTIONS(4180),
    [anon_sym_DOT_LBRACK] = ACTIONS(4178),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_use] = ACTIONS(4180),
    [anon_sym_use_BANG] = ACTIONS(4178),
    [anon_sym_do_BANG] = ACTIONS(4178),
    [anon_sym_begin] = ACTIONS(4180),
    [anon_sym_LPAREN2] = ACTIONS(4180),
    [anon_sym_default] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [anon_sym_static] = ACTIONS(4180),
    [anon_sym_member] = ACTIONS(4180),
    [anon_sym_interface] = ACTIONS(4180),
    [anon_sym_abstract] = ACTIONS(4180),
    [anon_sym_val] = ACTIONS(4180),
    [anon_sym_override] = ACTIONS(4180),
    [anon_sym_inherit] = ACTIONS(4180),
    [aux_sym_char_token1] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4180),
    [anon_sym_DQUOTE] = ACTIONS(4180),
    [anon_sym_AT_DQUOTE] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [sym_bool] = ACTIONS(4180),
    [sym_unit] = ACTIONS(4178),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4180),
    [sym_op_identifier] = ACTIONS(4180),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_PLUS_DOT] = ACTIONS(4180),
    [anon_sym_DASH_DOT] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_TILDE] = ACTIONS(4178),
    [aux_sym_prefix_op_token1] = ACTIONS(4180),
    [aux_sym_infix_op_token1] = ACTIONS(4178),
    [aux_sym_infix_op_token2] = ACTIONS(4180),
    [anon_sym_PIPE_PIPE] = ACTIONS(4180),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_COLON_EQ] = ACTIONS(4178),
    [anon_sym_DOLLAR] = ACTIONS(4180),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4180),
    [sym_int] = ACTIONS(4180),
    [sym_xint] = ACTIONS(4178),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4178),
    [anon_sym_POUNDendif] = ACTIONS(4178),
    [anon_sym_POUNDelse] = ACTIONS(4178),
    [sym__newline] = ACTIONS(4178),
  },
  [1721] = {
    [sym_block_comment] = STATE(1721),
    [sym_compiler_directive_decl] = STATE(1721),
    [sym_fsi_directive_decl] = STATE(1721),
    [sym_preproc_line] = STATE(1721),
    [sym_identifier] = ACTIONS(4147),
    [anon_sym_EQ] = ACTIONS(4145),
    [anon_sym_LBRACK_LT] = ACTIONS(4145),
    [anon_sym_COLON] = ACTIONS(4147),
    [anon_sym_return] = ACTIONS(4147),
    [anon_sym_do] = ACTIONS(4147),
    [anon_sym_let] = ACTIONS(4147),
    [anon_sym_let_BANG] = ACTIONS(4145),
    [aux_sym_access_modifier_token1] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(4147),
    [anon_sym_COMMA] = ACTIONS(4145),
    [anon_sym_null] = ACTIONS(4147),
    [anon_sym_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_COLON] = ACTIONS(4145),
    [anon_sym_AMP] = ACTIONS(4147),
    [anon_sym_LBRACK] = ACTIONS(4147),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4145),
    [anon_sym_LBRACE] = ACTIONS(4147),
    [anon_sym_LT_AT] = ACTIONS(4147),
    [anon_sym_LT_AT_AT] = ACTIONS(4147),
    [anon_sym_DOT] = ACTIONS(4147),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4145),
    [anon_sym_new] = ACTIONS(4147),
    [anon_sym_with] = ACTIONS(4147),
    [anon_sym_return_BANG] = ACTIONS(4145),
    [anon_sym_yield] = ACTIONS(4147),
    [anon_sym_yield_BANG] = ACTIONS(4145),
    [anon_sym_lazy] = ACTIONS(4147),
    [anon_sym_assert] = ACTIONS(4147),
    [anon_sym_upcast] = ACTIONS(4147),
    [anon_sym_downcast] = ACTIONS(4147),
    [anon_sym_COLON_GT] = ACTIONS(4145),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4145),
    [anon_sym_for] = ACTIONS(4147),
    [anon_sym_while] = ACTIONS(4147),
    [anon_sym_if] = ACTIONS(4147),
    [anon_sym_fun] = ACTIONS(4147),
    [anon_sym_try] = ACTIONS(4147),
    [anon_sym_match] = ACTIONS(4147),
    [anon_sym_match_BANG] = ACTIONS(4145),
    [anon_sym_function] = ACTIONS(4147),
    [anon_sym_LT_DASH] = ACTIONS(4147),
    [anon_sym_DOT_LBRACK] = ACTIONS(4145),
    [anon_sym_LT] = ACTIONS(4145),
    [anon_sym_use] = ACTIONS(4147),
    [anon_sym_use_BANG] = ACTIONS(4145),
    [anon_sym_do_BANG] = ACTIONS(4145),
    [anon_sym_begin] = ACTIONS(4147),
    [anon_sym_LPAREN2] = ACTIONS(4147),
    [anon_sym_default] = ACTIONS(4147),
    [anon_sym_or] = ACTIONS(4147),
    [anon_sym_static] = ACTIONS(4147),
    [anon_sym_member] = ACTIONS(4147),
    [anon_sym_interface] = ACTIONS(4147),
    [anon_sym_abstract] = ACTIONS(4147),
    [anon_sym_val] = ACTIONS(4147),
    [anon_sym_override] = ACTIONS(4147),
    [anon_sym_inherit] = ACTIONS(4147),
    [aux_sym_char_token1] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4147),
    [anon_sym_DQUOTE] = ACTIONS(4147),
    [anon_sym_AT_DQUOTE] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [sym_bool] = ACTIONS(4147),
    [sym_unit] = ACTIONS(4145),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4147),
    [sym_op_identifier] = ACTIONS(4147),
    [anon_sym_PLUS] = ACTIONS(4147),
    [anon_sym_DASH] = ACTIONS(4147),
    [anon_sym_PLUS_DOT] = ACTIONS(4147),
    [anon_sym_DASH_DOT] = ACTIONS(4147),
    [anon_sym_PERCENT] = ACTIONS(4147),
    [anon_sym_AMP_AMP] = ACTIONS(4147),
    [anon_sym_TILDE] = ACTIONS(4145),
    [aux_sym_prefix_op_token1] = ACTIONS(4147),
    [aux_sym_infix_op_token1] = ACTIONS(4145),
    [aux_sym_infix_op_token2] = ACTIONS(4147),
    [anon_sym_PIPE_PIPE] = ACTIONS(4147),
    [anon_sym_BANG_EQ] = ACTIONS(4147),
    [anon_sym_COLON_EQ] = ACTIONS(4145),
    [anon_sym_DOLLAR] = ACTIONS(4147),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4147),
    [sym_int] = ACTIONS(4147),
    [sym_xint] = ACTIONS(4145),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4145),
    [anon_sym_POUNDendif] = ACTIONS(4145),
    [anon_sym_POUNDelse] = ACTIONS(4145),
    [sym__newline] = ACTIONS(4145),
  },
  [1722] = {
    [sym_block_comment] = STATE(1722),
    [sym_compiler_directive_decl] = STATE(1722),
    [sym_fsi_directive_decl] = STATE(1722),
    [sym_preproc_line] = STATE(1722),
    [sym_identifier] = ACTIONS(4174),
    [anon_sym_EQ] = ACTIONS(4172),
    [anon_sym_LBRACK_LT] = ACTIONS(4172),
    [anon_sym_COLON] = ACTIONS(4174),
    [anon_sym_return] = ACTIONS(4174),
    [anon_sym_do] = ACTIONS(4174),
    [anon_sym_let] = ACTIONS(4174),
    [anon_sym_let_BANG] = ACTIONS(4172),
    [aux_sym_access_modifier_token1] = ACTIONS(4172),
    [anon_sym_LPAREN] = ACTIONS(4174),
    [anon_sym_COMMA] = ACTIONS(4172),
    [anon_sym_null] = ACTIONS(4174),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_COLON] = ACTIONS(4172),
    [anon_sym_AMP] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4174),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4172),
    [anon_sym_LBRACE] = ACTIONS(4174),
    [anon_sym_LT_AT] = ACTIONS(4174),
    [anon_sym_LT_AT_AT] = ACTIONS(4174),
    [anon_sym_DOT] = ACTIONS(4174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4172),
    [anon_sym_new] = ACTIONS(4174),
    [anon_sym_with] = ACTIONS(4174),
    [anon_sym_return_BANG] = ACTIONS(4172),
    [anon_sym_yield] = ACTIONS(4174),
    [anon_sym_yield_BANG] = ACTIONS(4172),
    [anon_sym_lazy] = ACTIONS(4174),
    [anon_sym_assert] = ACTIONS(4174),
    [anon_sym_upcast] = ACTIONS(4174),
    [anon_sym_downcast] = ACTIONS(4174),
    [anon_sym_COLON_GT] = ACTIONS(4172),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4172),
    [anon_sym_for] = ACTIONS(4174),
    [anon_sym_while] = ACTIONS(4174),
    [anon_sym_if] = ACTIONS(4174),
    [anon_sym_fun] = ACTIONS(4174),
    [anon_sym_try] = ACTIONS(4174),
    [anon_sym_match] = ACTIONS(4174),
    [anon_sym_match_BANG] = ACTIONS(4172),
    [anon_sym_function] = ACTIONS(4174),
    [anon_sym_LT_DASH] = ACTIONS(4174),
    [anon_sym_DOT_LBRACK] = ACTIONS(4172),
    [anon_sym_LT] = ACTIONS(4172),
    [anon_sym_use] = ACTIONS(4174),
    [anon_sym_use_BANG] = ACTIONS(4172),
    [anon_sym_do_BANG] = ACTIONS(4172),
    [anon_sym_begin] = ACTIONS(4174),
    [anon_sym_LPAREN2] = ACTIONS(4174),
    [anon_sym_default] = ACTIONS(4174),
    [anon_sym_or] = ACTIONS(4174),
    [anon_sym_static] = ACTIONS(4174),
    [anon_sym_member] = ACTIONS(4174),
    [anon_sym_interface] = ACTIONS(4174),
    [anon_sym_abstract] = ACTIONS(4174),
    [anon_sym_val] = ACTIONS(4174),
    [anon_sym_override] = ACTIONS(4174),
    [anon_sym_inherit] = ACTIONS(4174),
    [aux_sym_char_token1] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4174),
    [anon_sym_DQUOTE] = ACTIONS(4174),
    [anon_sym_AT_DQUOTE] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [sym_bool] = ACTIONS(4174),
    [sym_unit] = ACTIONS(4172),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4174),
    [sym_op_identifier] = ACTIONS(4174),
    [anon_sym_PLUS] = ACTIONS(4174),
    [anon_sym_DASH] = ACTIONS(4174),
    [anon_sym_PLUS_DOT] = ACTIONS(4174),
    [anon_sym_DASH_DOT] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [anon_sym_AMP_AMP] = ACTIONS(4174),
    [anon_sym_TILDE] = ACTIONS(4172),
    [aux_sym_prefix_op_token1] = ACTIONS(4174),
    [aux_sym_infix_op_token1] = ACTIONS(4172),
    [aux_sym_infix_op_token2] = ACTIONS(4174),
    [anon_sym_PIPE_PIPE] = ACTIONS(4174),
    [anon_sym_BANG_EQ] = ACTIONS(4174),
    [anon_sym_COLON_EQ] = ACTIONS(4172),
    [anon_sym_DOLLAR] = ACTIONS(4174),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4174),
    [sym_int] = ACTIONS(4174),
    [sym_xint] = ACTIONS(4172),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4172),
    [anon_sym_POUNDendif] = ACTIONS(4172),
    [anon_sym_POUNDelse] = ACTIONS(4172),
    [sym__newline] = ACTIONS(4172),
  },
  [1723] = {
    [sym_block_comment] = STATE(1723),
    [sym_compiler_directive_decl] = STATE(1723),
    [sym_fsi_directive_decl] = STATE(1723),
    [sym_preproc_line] = STATE(1723),
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_EQ] = ACTIONS(3990),
    [anon_sym_LBRACK_LT] = ACTIONS(3990),
    [anon_sym_COLON] = ACTIONS(3992),
    [anon_sym_return] = ACTIONS(3992),
    [anon_sym_do] = ACTIONS(3992),
    [anon_sym_let] = ACTIONS(3992),
    [anon_sym_let_BANG] = ACTIONS(3990),
    [aux_sym_access_modifier_token1] = ACTIONS(3990),
    [anon_sym_LPAREN] = ACTIONS(3992),
    [anon_sym_COMMA] = ACTIONS(3990),
    [anon_sym_null] = ACTIONS(3992),
    [anon_sym_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [anon_sym_AMP] = ACTIONS(3992),
    [anon_sym_LBRACK] = ACTIONS(3992),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3990),
    [anon_sym_LBRACE] = ACTIONS(3992),
    [anon_sym_LT_AT] = ACTIONS(3992),
    [anon_sym_LT_AT_AT] = ACTIONS(3992),
    [anon_sym_DOT] = ACTIONS(3992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3990),
    [anon_sym_new] = ACTIONS(3992),
    [anon_sym_with] = ACTIONS(3992),
    [anon_sym_return_BANG] = ACTIONS(3990),
    [anon_sym_yield] = ACTIONS(3992),
    [anon_sym_yield_BANG] = ACTIONS(3990),
    [anon_sym_lazy] = ACTIONS(3992),
    [anon_sym_assert] = ACTIONS(3992),
    [anon_sym_upcast] = ACTIONS(3992),
    [anon_sym_downcast] = ACTIONS(3992),
    [anon_sym_COLON_GT] = ACTIONS(3990),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3990),
    [anon_sym_for] = ACTIONS(3992),
    [anon_sym_while] = ACTIONS(3992),
    [anon_sym_if] = ACTIONS(3992),
    [anon_sym_fun] = ACTIONS(3992),
    [anon_sym_try] = ACTIONS(3992),
    [anon_sym_match] = ACTIONS(3992),
    [anon_sym_match_BANG] = ACTIONS(3990),
    [anon_sym_function] = ACTIONS(3992),
    [anon_sym_LT_DASH] = ACTIONS(3992),
    [anon_sym_DOT_LBRACK] = ACTIONS(3990),
    [anon_sym_LT] = ACTIONS(3990),
    [anon_sym_use] = ACTIONS(3992),
    [anon_sym_use_BANG] = ACTIONS(3990),
    [anon_sym_do_BANG] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_LPAREN2] = ACTIONS(3992),
    [anon_sym_default] = ACTIONS(3992),
    [anon_sym_or] = ACTIONS(3992),
    [anon_sym_static] = ACTIONS(3992),
    [anon_sym_member] = ACTIONS(3992),
    [anon_sym_interface] = ACTIONS(3992),
    [anon_sym_abstract] = ACTIONS(3992),
    [anon_sym_val] = ACTIONS(3992),
    [anon_sym_override] = ACTIONS(3992),
    [anon_sym_inherit] = ACTIONS(3992),
    [aux_sym_char_token1] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3992),
    [anon_sym_DQUOTE] = ACTIONS(3992),
    [anon_sym_AT_DQUOTE] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [sym_bool] = ACTIONS(3992),
    [sym_unit] = ACTIONS(3990),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3992),
    [sym_op_identifier] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3992),
    [anon_sym_DASH] = ACTIONS(3992),
    [anon_sym_PLUS_DOT] = ACTIONS(3992),
    [anon_sym_DASH_DOT] = ACTIONS(3992),
    [anon_sym_PERCENT] = ACTIONS(3992),
    [anon_sym_AMP_AMP] = ACTIONS(3992),
    [anon_sym_TILDE] = ACTIONS(3990),
    [aux_sym_prefix_op_token1] = ACTIONS(3992),
    [aux_sym_infix_op_token1] = ACTIONS(3990),
    [aux_sym_infix_op_token2] = ACTIONS(3992),
    [anon_sym_PIPE_PIPE] = ACTIONS(3992),
    [anon_sym_BANG_EQ] = ACTIONS(3992),
    [anon_sym_COLON_EQ] = ACTIONS(3990),
    [anon_sym_DOLLAR] = ACTIONS(3992),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3992),
    [sym_int] = ACTIONS(3992),
    [sym_xint] = ACTIONS(3990),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3990),
    [anon_sym_POUNDendif] = ACTIONS(3990),
    [anon_sym_POUNDelse] = ACTIONS(3990),
    [sym__newline] = ACTIONS(3990),
  },
  [1724] = {
    [sym_block_comment] = STATE(1724),
    [sym_compiler_directive_decl] = STATE(1724),
    [sym_fsi_directive_decl] = STATE(1724),
    [sym_preproc_line] = STATE(1724),
    [sym_identifier] = ACTIONS(3988),
    [anon_sym_EQ] = ACTIONS(3986),
    [anon_sym_LBRACK_LT] = ACTIONS(3986),
    [anon_sym_COLON] = ACTIONS(3988),
    [anon_sym_return] = ACTIONS(3988),
    [anon_sym_do] = ACTIONS(3988),
    [anon_sym_let] = ACTIONS(3988),
    [anon_sym_let_BANG] = ACTIONS(3986),
    [aux_sym_access_modifier_token1] = ACTIONS(3986),
    [anon_sym_LPAREN] = ACTIONS(3988),
    [anon_sym_COMMA] = ACTIONS(3986),
    [anon_sym_null] = ACTIONS(3988),
    [anon_sym_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_COLON] = ACTIONS(3986),
    [anon_sym_AMP] = ACTIONS(3988),
    [anon_sym_LBRACK] = ACTIONS(3988),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3986),
    [anon_sym_LBRACE] = ACTIONS(3988),
    [anon_sym_LT_AT] = ACTIONS(3988),
    [anon_sym_LT_AT_AT] = ACTIONS(3988),
    [anon_sym_DOT] = ACTIONS(3988),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3986),
    [anon_sym_new] = ACTIONS(3988),
    [anon_sym_with] = ACTIONS(3988),
    [anon_sym_return_BANG] = ACTIONS(3986),
    [anon_sym_yield] = ACTIONS(3988),
    [anon_sym_yield_BANG] = ACTIONS(3986),
    [anon_sym_lazy] = ACTIONS(3988),
    [anon_sym_assert] = ACTIONS(3988),
    [anon_sym_upcast] = ACTIONS(3988),
    [anon_sym_downcast] = ACTIONS(3988),
    [anon_sym_COLON_GT] = ACTIONS(3986),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_while] = ACTIONS(3988),
    [anon_sym_if] = ACTIONS(3988),
    [anon_sym_fun] = ACTIONS(3988),
    [anon_sym_try] = ACTIONS(3988),
    [anon_sym_match] = ACTIONS(3988),
    [anon_sym_match_BANG] = ACTIONS(3986),
    [anon_sym_function] = ACTIONS(3988),
    [anon_sym_LT_DASH] = ACTIONS(3988),
    [anon_sym_DOT_LBRACK] = ACTIONS(3986),
    [anon_sym_LT] = ACTIONS(3986),
    [anon_sym_use] = ACTIONS(3988),
    [anon_sym_use_BANG] = ACTIONS(3986),
    [anon_sym_do_BANG] = ACTIONS(3986),
    [anon_sym_begin] = ACTIONS(3988),
    [anon_sym_LPAREN2] = ACTIONS(3988),
    [anon_sym_default] = ACTIONS(3988),
    [anon_sym_or] = ACTIONS(3988),
    [anon_sym_static] = ACTIONS(3988),
    [anon_sym_member] = ACTIONS(3988),
    [anon_sym_interface] = ACTIONS(3988),
    [anon_sym_abstract] = ACTIONS(3988),
    [anon_sym_val] = ACTIONS(3988),
    [anon_sym_override] = ACTIONS(3988),
    [anon_sym_inherit] = ACTIONS(3988),
    [aux_sym_char_token1] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3988),
    [anon_sym_DQUOTE] = ACTIONS(3988),
    [anon_sym_AT_DQUOTE] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [sym_bool] = ACTIONS(3988),
    [sym_unit] = ACTIONS(3986),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3988),
    [sym_op_identifier] = ACTIONS(3988),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_PLUS_DOT] = ACTIONS(3988),
    [anon_sym_DASH_DOT] = ACTIONS(3988),
    [anon_sym_PERCENT] = ACTIONS(3988),
    [anon_sym_AMP_AMP] = ACTIONS(3988),
    [anon_sym_TILDE] = ACTIONS(3986),
    [aux_sym_prefix_op_token1] = ACTIONS(3988),
    [aux_sym_infix_op_token1] = ACTIONS(3986),
    [aux_sym_infix_op_token2] = ACTIONS(3988),
    [anon_sym_PIPE_PIPE] = ACTIONS(3988),
    [anon_sym_BANG_EQ] = ACTIONS(3988),
    [anon_sym_COLON_EQ] = ACTIONS(3986),
    [anon_sym_DOLLAR] = ACTIONS(3988),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3988),
    [sym_int] = ACTIONS(3988),
    [sym_xint] = ACTIONS(3986),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3986),
    [anon_sym_POUNDendif] = ACTIONS(3986),
    [anon_sym_POUNDelse] = ACTIONS(3986),
    [sym__newline] = ACTIONS(3986),
  },
  [1725] = {
    [sym_block_comment] = STATE(1725),
    [sym_compiler_directive_decl] = STATE(1725),
    [sym_fsi_directive_decl] = STATE(1725),
    [sym_preproc_line] = STATE(1725),
    [sym_identifier] = ACTIONS(3984),
    [anon_sym_EQ] = ACTIONS(3982),
    [anon_sym_LBRACK_LT] = ACTIONS(3982),
    [anon_sym_COLON] = ACTIONS(3984),
    [anon_sym_return] = ACTIONS(3984),
    [anon_sym_do] = ACTIONS(3984),
    [anon_sym_let] = ACTIONS(3984),
    [anon_sym_let_BANG] = ACTIONS(3982),
    [aux_sym_access_modifier_token1] = ACTIONS(3982),
    [anon_sym_LPAREN] = ACTIONS(3984),
    [anon_sym_COMMA] = ACTIONS(3982),
    [anon_sym_null] = ACTIONS(3984),
    [anon_sym_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AMP] = ACTIONS(3984),
    [anon_sym_LBRACK] = ACTIONS(3984),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(3984),
    [anon_sym_LT_AT] = ACTIONS(3984),
    [anon_sym_LT_AT_AT] = ACTIONS(3984),
    [anon_sym_DOT] = ACTIONS(3984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3982),
    [anon_sym_new] = ACTIONS(3984),
    [anon_sym_with] = ACTIONS(3984),
    [anon_sym_return_BANG] = ACTIONS(3982),
    [anon_sym_yield] = ACTIONS(3984),
    [anon_sym_yield_BANG] = ACTIONS(3982),
    [anon_sym_lazy] = ACTIONS(3984),
    [anon_sym_assert] = ACTIONS(3984),
    [anon_sym_upcast] = ACTIONS(3984),
    [anon_sym_downcast] = ACTIONS(3984),
    [anon_sym_COLON_GT] = ACTIONS(3982),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3982),
    [anon_sym_for] = ACTIONS(3984),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_if] = ACTIONS(3984),
    [anon_sym_fun] = ACTIONS(3984),
    [anon_sym_try] = ACTIONS(3984),
    [anon_sym_match] = ACTIONS(3984),
    [anon_sym_match_BANG] = ACTIONS(3982),
    [anon_sym_function] = ACTIONS(3984),
    [anon_sym_LT_DASH] = ACTIONS(3984),
    [anon_sym_DOT_LBRACK] = ACTIONS(3982),
    [anon_sym_LT] = ACTIONS(3982),
    [anon_sym_use] = ACTIONS(3984),
    [anon_sym_use_BANG] = ACTIONS(3982),
    [anon_sym_do_BANG] = ACTIONS(3982),
    [anon_sym_begin] = ACTIONS(3984),
    [anon_sym_LPAREN2] = ACTIONS(3984),
    [anon_sym_default] = ACTIONS(3984),
    [anon_sym_or] = ACTIONS(3984),
    [anon_sym_static] = ACTIONS(3984),
    [anon_sym_member] = ACTIONS(3984),
    [anon_sym_interface] = ACTIONS(3984),
    [anon_sym_abstract] = ACTIONS(3984),
    [anon_sym_val] = ACTIONS(3984),
    [anon_sym_override] = ACTIONS(3984),
    [anon_sym_inherit] = ACTIONS(3984),
    [aux_sym_char_token1] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3984),
    [anon_sym_DQUOTE] = ACTIONS(3984),
    [anon_sym_AT_DQUOTE] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [sym_bool] = ACTIONS(3984),
    [sym_unit] = ACTIONS(3982),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3984),
    [sym_op_identifier] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3984),
    [anon_sym_DASH] = ACTIONS(3984),
    [anon_sym_PLUS_DOT] = ACTIONS(3984),
    [anon_sym_DASH_DOT] = ACTIONS(3984),
    [anon_sym_PERCENT] = ACTIONS(3984),
    [anon_sym_AMP_AMP] = ACTIONS(3984),
    [anon_sym_TILDE] = ACTIONS(3982),
    [aux_sym_prefix_op_token1] = ACTIONS(3984),
    [aux_sym_infix_op_token1] = ACTIONS(3982),
    [aux_sym_infix_op_token2] = ACTIONS(3984),
    [anon_sym_PIPE_PIPE] = ACTIONS(3984),
    [anon_sym_BANG_EQ] = ACTIONS(3984),
    [anon_sym_COLON_EQ] = ACTIONS(3982),
    [anon_sym_DOLLAR] = ACTIONS(3984),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3984),
    [sym_int] = ACTIONS(3984),
    [sym_xint] = ACTIONS(3982),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3982),
    [anon_sym_POUNDendif] = ACTIONS(3982),
    [anon_sym_POUNDelse] = ACTIONS(3982),
    [sym__newline] = ACTIONS(3982),
  },
  [1726] = {
    [sym_block_comment] = STATE(1726),
    [sym_compiler_directive_decl] = STATE(1726),
    [sym_fsi_directive_decl] = STATE(1726),
    [sym_preproc_line] = STATE(1726),
    [sym_identifier] = ACTIONS(3980),
    [anon_sym_EQ] = ACTIONS(3978),
    [anon_sym_LBRACK_LT] = ACTIONS(3978),
    [anon_sym_COLON] = ACTIONS(3980),
    [anon_sym_return] = ACTIONS(3980),
    [anon_sym_do] = ACTIONS(3980),
    [anon_sym_let] = ACTIONS(3980),
    [anon_sym_let_BANG] = ACTIONS(3978),
    [aux_sym_access_modifier_token1] = ACTIONS(3978),
    [anon_sym_LPAREN] = ACTIONS(3980),
    [anon_sym_COMMA] = ACTIONS(3978),
    [anon_sym_null] = ACTIONS(3980),
    [anon_sym_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3978),
    [anon_sym_AMP] = ACTIONS(3980),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3978),
    [anon_sym_LBRACE] = ACTIONS(3980),
    [anon_sym_LT_AT] = ACTIONS(3980),
    [anon_sym_LT_AT_AT] = ACTIONS(3980),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3978),
    [anon_sym_new] = ACTIONS(3980),
    [anon_sym_with] = ACTIONS(3980),
    [anon_sym_return_BANG] = ACTIONS(3978),
    [anon_sym_yield] = ACTIONS(3980),
    [anon_sym_yield_BANG] = ACTIONS(3978),
    [anon_sym_lazy] = ACTIONS(3980),
    [anon_sym_assert] = ACTIONS(3980),
    [anon_sym_upcast] = ACTIONS(3980),
    [anon_sym_downcast] = ACTIONS(3980),
    [anon_sym_COLON_GT] = ACTIONS(3978),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3978),
    [anon_sym_for] = ACTIONS(3980),
    [anon_sym_while] = ACTIONS(3980),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_fun] = ACTIONS(3980),
    [anon_sym_try] = ACTIONS(3980),
    [anon_sym_match] = ACTIONS(3980),
    [anon_sym_match_BANG] = ACTIONS(3978),
    [anon_sym_function] = ACTIONS(3980),
    [anon_sym_LT_DASH] = ACTIONS(3980),
    [anon_sym_DOT_LBRACK] = ACTIONS(3978),
    [anon_sym_LT] = ACTIONS(3978),
    [anon_sym_use] = ACTIONS(3980),
    [anon_sym_use_BANG] = ACTIONS(3978),
    [anon_sym_do_BANG] = ACTIONS(3978),
    [anon_sym_begin] = ACTIONS(3980),
    [anon_sym_LPAREN2] = ACTIONS(3980),
    [anon_sym_default] = ACTIONS(3980),
    [anon_sym_or] = ACTIONS(3980),
    [anon_sym_static] = ACTIONS(3980),
    [anon_sym_member] = ACTIONS(3980),
    [anon_sym_interface] = ACTIONS(3980),
    [anon_sym_abstract] = ACTIONS(3980),
    [anon_sym_val] = ACTIONS(3980),
    [anon_sym_override] = ACTIONS(3980),
    [anon_sym_inherit] = ACTIONS(3980),
    [aux_sym_char_token1] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3980),
    [anon_sym_DQUOTE] = ACTIONS(3980),
    [anon_sym_AT_DQUOTE] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [sym_bool] = ACTIONS(3980),
    [sym_unit] = ACTIONS(3978),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3980),
    [sym_op_identifier] = ACTIONS(3980),
    [anon_sym_PLUS] = ACTIONS(3980),
    [anon_sym_DASH] = ACTIONS(3980),
    [anon_sym_PLUS_DOT] = ACTIONS(3980),
    [anon_sym_DASH_DOT] = ACTIONS(3980),
    [anon_sym_PERCENT] = ACTIONS(3980),
    [anon_sym_AMP_AMP] = ACTIONS(3980),
    [anon_sym_TILDE] = ACTIONS(3978),
    [aux_sym_prefix_op_token1] = ACTIONS(3980),
    [aux_sym_infix_op_token1] = ACTIONS(3978),
    [aux_sym_infix_op_token2] = ACTIONS(3980),
    [anon_sym_PIPE_PIPE] = ACTIONS(3980),
    [anon_sym_BANG_EQ] = ACTIONS(3980),
    [anon_sym_COLON_EQ] = ACTIONS(3978),
    [anon_sym_DOLLAR] = ACTIONS(3980),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3980),
    [sym_int] = ACTIONS(3980),
    [sym_xint] = ACTIONS(3978),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3978),
    [anon_sym_POUNDendif] = ACTIONS(3978),
    [anon_sym_POUNDelse] = ACTIONS(3978),
    [sym__newline] = ACTIONS(3978),
  },
  [1727] = {
    [sym_block_comment] = STATE(1727),
    [sym_compiler_directive_decl] = STATE(1727),
    [sym_fsi_directive_decl] = STATE(1727),
    [sym_preproc_line] = STATE(1727),
    [sym_identifier] = ACTIONS(3800),
    [anon_sym_EQ] = ACTIONS(3798),
    [anon_sym_LBRACK_LT] = ACTIONS(3798),
    [anon_sym_COLON] = ACTIONS(3800),
    [anon_sym_return] = ACTIONS(3800),
    [anon_sym_do] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_let_BANG] = ACTIONS(3798),
    [aux_sym_access_modifier_token1] = ACTIONS(3798),
    [anon_sym_LPAREN] = ACTIONS(3800),
    [anon_sym_COMMA] = ACTIONS(3798),
    [anon_sym_null] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_COLON] = ACTIONS(3798),
    [anon_sym_PIPE] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3800),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3798),
    [anon_sym_LBRACE] = ACTIONS(3800),
    [anon_sym_LT_AT] = ACTIONS(3800),
    [anon_sym_LT_AT_AT] = ACTIONS(3800),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3798),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_with] = ACTIONS(3800),
    [anon_sym_return_BANG] = ACTIONS(3798),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_yield_BANG] = ACTIONS(3798),
    [anon_sym_lazy] = ACTIONS(3800),
    [anon_sym_assert] = ACTIONS(3800),
    [anon_sym_upcast] = ACTIONS(3800),
    [anon_sym_downcast] = ACTIONS(3800),
    [anon_sym_COLON_GT] = ACTIONS(3798),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3798),
    [anon_sym_for] = ACTIONS(3800),
    [anon_sym_while] = ACTIONS(3800),
    [anon_sym_if] = ACTIONS(3800),
    [anon_sym_fun] = ACTIONS(3800),
    [anon_sym_try] = ACTIONS(3800),
    [anon_sym_match] = ACTIONS(3800),
    [anon_sym_match_BANG] = ACTIONS(3798),
    [anon_sym_function] = ACTIONS(3800),
    [anon_sym_LT_DASH] = ACTIONS(3800),
    [anon_sym_DOT_LBRACK] = ACTIONS(3798),
    [anon_sym_LT] = ACTIONS(3798),
    [anon_sym_use] = ACTIONS(3800),
    [anon_sym_use_BANG] = ACTIONS(3798),
    [anon_sym_do_BANG] = ACTIONS(3798),
    [anon_sym_begin] = ACTIONS(3800),
    [anon_sym_LPAREN2] = ACTIONS(3800),
    [anon_sym_default] = ACTIONS(3800),
    [anon_sym_or] = ACTIONS(3800),
    [anon_sym_static] = ACTIONS(3800),
    [anon_sym_member] = ACTIONS(3800),
    [anon_sym_interface] = ACTIONS(3800),
    [anon_sym_abstract] = ACTIONS(3800),
    [anon_sym_val] = ACTIONS(3800),
    [anon_sym_override] = ACTIONS(3800),
    [anon_sym_inherit] = ACTIONS(3800),
    [aux_sym_char_token1] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3800),
    [anon_sym_DQUOTE] = ACTIONS(3800),
    [anon_sym_AT_DQUOTE] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [sym_bool] = ACTIONS(3800),
    [sym_unit] = ACTIONS(3798),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3800),
    [sym_op_identifier] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS_DOT] = ACTIONS(3800),
    [anon_sym_DASH_DOT] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3800),
    [anon_sym_AMP_AMP] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3798),
    [aux_sym_prefix_op_token1] = ACTIONS(3800),
    [aux_sym_infix_op_token1] = ACTIONS(3798),
    [aux_sym_infix_op_token2] = ACTIONS(3800),
    [anon_sym_PIPE_PIPE] = ACTIONS(3800),
    [anon_sym_BANG_EQ] = ACTIONS(3800),
    [anon_sym_COLON_EQ] = ACTIONS(3798),
    [anon_sym_DOLLAR] = ACTIONS(3800),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3800),
    [sym_int] = ACTIONS(3800),
    [sym_xint] = ACTIONS(3798),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3798),
    [anon_sym_POUNDendif] = ACTIONS(3798),
    [sym__newline] = ACTIONS(3798),
  },
  [1728] = {
    [sym_block_comment] = STATE(1728),
    [sym_compiler_directive_decl] = STATE(1728),
    [sym_fsi_directive_decl] = STATE(1728),
    [sym_preproc_line] = STATE(1728),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_LBRACK_LT] = ACTIONS(3865),
    [anon_sym_COLON] = ACTIONS(3867),
    [anon_sym_return] = ACTIONS(3867),
    [anon_sym_do] = ACTIONS(3867),
    [anon_sym_and] = ACTIONS(3867),
    [anon_sym_let] = ACTIONS(3867),
    [anon_sym_let_BANG] = ACTIONS(3865),
    [aux_sym_access_modifier_token1] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(3867),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_null] = ACTIONS(3867),
    [anon_sym_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_COLON] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3867),
    [anon_sym_LBRACK] = ACTIONS(3867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3867),
    [anon_sym_LT_AT] = ACTIONS(3867),
    [anon_sym_LT_AT_AT] = ACTIONS(3867),
    [anon_sym_DOT] = ACTIONS(3867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3867),
    [anon_sym_with] = ACTIONS(3867),
    [anon_sym_return_BANG] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3867),
    [anon_sym_yield_BANG] = ACTIONS(3865),
    [anon_sym_lazy] = ACTIONS(3867),
    [anon_sym_assert] = ACTIONS(3867),
    [anon_sym_upcast] = ACTIONS(3867),
    [anon_sym_downcast] = ACTIONS(3867),
    [anon_sym_COLON_GT] = ACTIONS(3865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3867),
    [anon_sym_while] = ACTIONS(3867),
    [anon_sym_if] = ACTIONS(3867),
    [anon_sym_fun] = ACTIONS(3867),
    [anon_sym_try] = ACTIONS(3867),
    [anon_sym_match] = ACTIONS(3867),
    [anon_sym_match_BANG] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(3867),
    [anon_sym_DOT_LBRACK] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_use] = ACTIONS(3867),
    [anon_sym_use_BANG] = ACTIONS(3865),
    [anon_sym_do_BANG] = ACTIONS(3865),
    [anon_sym_begin] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(3867),
    [anon_sym_default] = ACTIONS(3867),
    [anon_sym_or] = ACTIONS(3867),
    [anon_sym_static] = ACTIONS(3867),
    [anon_sym_member] = ACTIONS(3867),
    [anon_sym_interface] = ACTIONS(3867),
    [anon_sym_abstract] = ACTIONS(3867),
    [anon_sym_val] = ACTIONS(3867),
    [anon_sym_override] = ACTIONS(3867),
    [aux_sym_char_token1] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3867),
    [anon_sym_DQUOTE] = ACTIONS(3867),
    [anon_sym_AT_DQUOTE] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [sym_bool] = ACTIONS(3867),
    [sym_unit] = ACTIONS(3865),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3867),
    [sym_op_identifier] = ACTIONS(3867),
    [anon_sym_PLUS] = ACTIONS(3867),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_PLUS_DOT] = ACTIONS(3867),
    [anon_sym_DASH_DOT] = ACTIONS(3867),
    [anon_sym_PERCENT] = ACTIONS(3867),
    [anon_sym_AMP_AMP] = ACTIONS(3867),
    [anon_sym_TILDE] = ACTIONS(3865),
    [aux_sym_prefix_op_token1] = ACTIONS(3867),
    [aux_sym_infix_op_token1] = ACTIONS(3865),
    [aux_sym_infix_op_token2] = ACTIONS(3867),
    [anon_sym_PIPE_PIPE] = ACTIONS(3867),
    [anon_sym_BANG_EQ] = ACTIONS(3867),
    [anon_sym_COLON_EQ] = ACTIONS(3865),
    [anon_sym_DOLLAR] = ACTIONS(3867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3867),
    [sym_int] = ACTIONS(3867),
    [sym_xint] = ACTIONS(3865),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3865),
    [anon_sym_POUNDendif] = ACTIONS(3865),
    [anon_sym_POUNDelse] = ACTIONS(3865),
    [sym__newline] = ACTIONS(3865),
  },
  [1729] = {
    [sym_block_comment] = STATE(1729),
    [sym_compiler_directive_decl] = STATE(1729),
    [sym_fsi_directive_decl] = STATE(1729),
    [sym_preproc_line] = STATE(1729),
    [sym_identifier] = ACTIONS(4162),
    [anon_sym_EQ] = ACTIONS(4160),
    [anon_sym_LBRACK_LT] = ACTIONS(4160),
    [anon_sym_COLON] = ACTIONS(4162),
    [anon_sym_return] = ACTIONS(4162),
    [anon_sym_do] = ACTIONS(4162),
    [anon_sym_and] = ACTIONS(4162),
    [anon_sym_let] = ACTIONS(4162),
    [anon_sym_let_BANG] = ACTIONS(4160),
    [aux_sym_access_modifier_token1] = ACTIONS(4160),
    [anon_sym_LPAREN] = ACTIONS(4162),
    [anon_sym_COMMA] = ACTIONS(4160),
    [anon_sym_null] = ACTIONS(4162),
    [anon_sym_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4160),
    [anon_sym_AMP] = ACTIONS(4162),
    [anon_sym_LBRACK] = ACTIONS(4162),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4160),
    [anon_sym_LBRACE] = ACTIONS(4162),
    [anon_sym_LT_AT] = ACTIONS(4162),
    [anon_sym_LT_AT_AT] = ACTIONS(4162),
    [anon_sym_DOT] = ACTIONS(4162),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4160),
    [anon_sym_new] = ACTIONS(4162),
    [anon_sym_with] = ACTIONS(4162),
    [anon_sym_return_BANG] = ACTIONS(4160),
    [anon_sym_yield] = ACTIONS(4162),
    [anon_sym_yield_BANG] = ACTIONS(4160),
    [anon_sym_lazy] = ACTIONS(4162),
    [anon_sym_assert] = ACTIONS(4162),
    [anon_sym_upcast] = ACTIONS(4162),
    [anon_sym_downcast] = ACTIONS(4162),
    [anon_sym_COLON_GT] = ACTIONS(4160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4160),
    [anon_sym_for] = ACTIONS(4162),
    [anon_sym_while] = ACTIONS(4162),
    [anon_sym_if] = ACTIONS(4162),
    [anon_sym_fun] = ACTIONS(4162),
    [anon_sym_try] = ACTIONS(4162),
    [anon_sym_match] = ACTIONS(4162),
    [anon_sym_match_BANG] = ACTIONS(4160),
    [anon_sym_function] = ACTIONS(4162),
    [anon_sym_LT_DASH] = ACTIONS(4162),
    [anon_sym_DOT_LBRACK] = ACTIONS(4160),
    [anon_sym_LT] = ACTIONS(4160),
    [anon_sym_use] = ACTIONS(4162),
    [anon_sym_use_BANG] = ACTIONS(4160),
    [anon_sym_do_BANG] = ACTIONS(4160),
    [anon_sym_begin] = ACTIONS(4162),
    [anon_sym_LPAREN2] = ACTIONS(4162),
    [anon_sym_default] = ACTIONS(4162),
    [anon_sym_or] = ACTIONS(4162),
    [anon_sym_static] = ACTIONS(4162),
    [anon_sym_member] = ACTIONS(4162),
    [anon_sym_interface] = ACTIONS(4162),
    [anon_sym_abstract] = ACTIONS(4162),
    [anon_sym_val] = ACTIONS(4162),
    [anon_sym_override] = ACTIONS(4162),
    [aux_sym_char_token1] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4162),
    [anon_sym_DQUOTE] = ACTIONS(4162),
    [anon_sym_AT_DQUOTE] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [sym_bool] = ACTIONS(4162),
    [sym_unit] = ACTIONS(4160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4162),
    [sym_op_identifier] = ACTIONS(4162),
    [anon_sym_PLUS] = ACTIONS(4162),
    [anon_sym_DASH] = ACTIONS(4162),
    [anon_sym_PLUS_DOT] = ACTIONS(4162),
    [anon_sym_DASH_DOT] = ACTIONS(4162),
    [anon_sym_PERCENT] = ACTIONS(4162),
    [anon_sym_AMP_AMP] = ACTIONS(4162),
    [anon_sym_TILDE] = ACTIONS(4160),
    [aux_sym_prefix_op_token1] = ACTIONS(4162),
    [aux_sym_infix_op_token1] = ACTIONS(4160),
    [aux_sym_infix_op_token2] = ACTIONS(4162),
    [anon_sym_PIPE_PIPE] = ACTIONS(4162),
    [anon_sym_BANG_EQ] = ACTIONS(4162),
    [anon_sym_COLON_EQ] = ACTIONS(4160),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4162),
    [sym_int] = ACTIONS(4162),
    [sym_xint] = ACTIONS(4160),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4160),
    [anon_sym_POUNDendif] = ACTIONS(4160),
    [anon_sym_POUNDelse] = ACTIONS(4160),
    [sym__newline] = ACTIONS(4160),
  },
  [1730] = {
    [sym_block_comment] = STATE(1730),
    [sym_compiler_directive_decl] = STATE(1730),
    [sym_fsi_directive_decl] = STATE(1730),
    [sym_preproc_line] = STATE(1730),
    [sym_identifier] = ACTIONS(3966),
    [anon_sym_EQ] = ACTIONS(3964),
    [anon_sym_LBRACK_LT] = ACTIONS(3964),
    [anon_sym_COLON] = ACTIONS(3966),
    [anon_sym_return] = ACTIONS(3966),
    [anon_sym_do] = ACTIONS(3966),
    [anon_sym_let] = ACTIONS(3966),
    [anon_sym_let_BANG] = ACTIONS(3964),
    [aux_sym_access_modifier_token1] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COMMA] = ACTIONS(3964),
    [anon_sym_null] = ACTIONS(3966),
    [anon_sym_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(3964),
    [anon_sym_AMP] = ACTIONS(3966),
    [anon_sym_LBRACK] = ACTIONS(3966),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3964),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_LT_AT] = ACTIONS(3966),
    [anon_sym_LT_AT_AT] = ACTIONS(3966),
    [anon_sym_DOT] = ACTIONS(3966),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3964),
    [anon_sym_new] = ACTIONS(3966),
    [anon_sym_with] = ACTIONS(3966),
    [anon_sym_return_BANG] = ACTIONS(3964),
    [anon_sym_yield] = ACTIONS(3966),
    [anon_sym_yield_BANG] = ACTIONS(3964),
    [anon_sym_lazy] = ACTIONS(3966),
    [anon_sym_assert] = ACTIONS(3966),
    [anon_sym_upcast] = ACTIONS(3966),
    [anon_sym_downcast] = ACTIONS(3966),
    [anon_sym_COLON_GT] = ACTIONS(3964),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3964),
    [anon_sym_for] = ACTIONS(3966),
    [anon_sym_while] = ACTIONS(3966),
    [anon_sym_if] = ACTIONS(3966),
    [anon_sym_fun] = ACTIONS(3966),
    [anon_sym_try] = ACTIONS(3966),
    [anon_sym_match] = ACTIONS(3966),
    [anon_sym_match_BANG] = ACTIONS(3964),
    [anon_sym_function] = ACTIONS(3966),
    [anon_sym_LT_DASH] = ACTIONS(3966),
    [anon_sym_DOT_LBRACK] = ACTIONS(3964),
    [anon_sym_LT] = ACTIONS(3964),
    [anon_sym_use] = ACTIONS(3966),
    [anon_sym_use_BANG] = ACTIONS(3964),
    [anon_sym_do_BANG] = ACTIONS(3964),
    [anon_sym_begin] = ACTIONS(3966),
    [anon_sym_LPAREN2] = ACTIONS(3966),
    [anon_sym_default] = ACTIONS(3966),
    [anon_sym_or] = ACTIONS(3966),
    [anon_sym_static] = ACTIONS(3966),
    [anon_sym_member] = ACTIONS(3966),
    [anon_sym_interface] = ACTIONS(3966),
    [anon_sym_abstract] = ACTIONS(3966),
    [anon_sym_val] = ACTIONS(3966),
    [anon_sym_override] = ACTIONS(3966),
    [anon_sym_inherit] = ACTIONS(3966),
    [aux_sym_char_token1] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3966),
    [anon_sym_DQUOTE] = ACTIONS(3966),
    [anon_sym_AT_DQUOTE] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [sym_bool] = ACTIONS(3966),
    [sym_unit] = ACTIONS(3964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3966),
    [sym_op_identifier] = ACTIONS(3966),
    [anon_sym_PLUS] = ACTIONS(3966),
    [anon_sym_DASH] = ACTIONS(3966),
    [anon_sym_PLUS_DOT] = ACTIONS(3966),
    [anon_sym_DASH_DOT] = ACTIONS(3966),
    [anon_sym_PERCENT] = ACTIONS(3966),
    [anon_sym_AMP_AMP] = ACTIONS(3966),
    [anon_sym_TILDE] = ACTIONS(3964),
    [aux_sym_prefix_op_token1] = ACTIONS(3966),
    [aux_sym_infix_op_token1] = ACTIONS(3964),
    [aux_sym_infix_op_token2] = ACTIONS(3966),
    [anon_sym_PIPE_PIPE] = ACTIONS(3966),
    [anon_sym_BANG_EQ] = ACTIONS(3966),
    [anon_sym_COLON_EQ] = ACTIONS(3964),
    [anon_sym_DOLLAR] = ACTIONS(3966),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3966),
    [sym_int] = ACTIONS(3966),
    [sym_xint] = ACTIONS(3964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3964),
    [anon_sym_POUNDendif] = ACTIONS(3964),
    [anon_sym_POUNDelse] = ACTIONS(3964),
    [sym__newline] = ACTIONS(3964),
  },
  [1731] = {
    [sym_block_comment] = STATE(1731),
    [sym_compiler_directive_decl] = STATE(1731),
    [sym_fsi_directive_decl] = STATE(1731),
    [sym_preproc_line] = STATE(1731),
    [sym_identifier] = ACTIONS(4182),
    [anon_sym_EQ] = ACTIONS(3689),
    [anon_sym_LBRACK_LT] = ACTIONS(3689),
    [anon_sym_COLON] = ACTIONS(4182),
    [anon_sym_return] = ACTIONS(4182),
    [anon_sym_do] = ACTIONS(4182),
    [anon_sym_and] = ACTIONS(4182),
    [anon_sym_let] = ACTIONS(4182),
    [anon_sym_let_BANG] = ACTIONS(3689),
    [aux_sym_access_modifier_token1] = ACTIONS(3689),
    [anon_sym_LPAREN] = ACTIONS(4182),
    [anon_sym_COMMA] = ACTIONS(3689),
    [anon_sym_null] = ACTIONS(4182),
    [anon_sym_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3689),
    [anon_sym_LBRACE] = ACTIONS(4182),
    [anon_sym_LT_AT] = ACTIONS(4182),
    [anon_sym_LT_AT_AT] = ACTIONS(4182),
    [anon_sym_DOT] = ACTIONS(4182),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3689),
    [anon_sym_new] = ACTIONS(4182),
    [anon_sym_with] = ACTIONS(4182),
    [anon_sym_return_BANG] = ACTIONS(3689),
    [anon_sym_yield] = ACTIONS(4182),
    [anon_sym_yield_BANG] = ACTIONS(3689),
    [anon_sym_lazy] = ACTIONS(4182),
    [anon_sym_assert] = ACTIONS(4182),
    [anon_sym_upcast] = ACTIONS(4182),
    [anon_sym_downcast] = ACTIONS(4182),
    [anon_sym_COLON_GT] = ACTIONS(3689),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3689),
    [anon_sym_for] = ACTIONS(4182),
    [anon_sym_while] = ACTIONS(4182),
    [anon_sym_if] = ACTIONS(4182),
    [anon_sym_fun] = ACTIONS(4182),
    [anon_sym_try] = ACTIONS(4182),
    [anon_sym_match] = ACTIONS(4182),
    [anon_sym_match_BANG] = ACTIONS(3689),
    [anon_sym_function] = ACTIONS(4182),
    [anon_sym_LT_DASH] = ACTIONS(4182),
    [anon_sym_DOT_LBRACK] = ACTIONS(3689),
    [anon_sym_LT] = ACTIONS(3689),
    [anon_sym_use] = ACTIONS(4182),
    [anon_sym_use_BANG] = ACTIONS(3689),
    [anon_sym_do_BANG] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(4182),
    [anon_sym_LPAREN2] = ACTIONS(4182),
    [anon_sym_default] = ACTIONS(4182),
    [anon_sym_or] = ACTIONS(4182),
    [anon_sym_static] = ACTIONS(4182),
    [anon_sym_member] = ACTIONS(4182),
    [anon_sym_interface] = ACTIONS(4182),
    [anon_sym_abstract] = ACTIONS(4182),
    [anon_sym_val] = ACTIONS(4182),
    [anon_sym_override] = ACTIONS(4182),
    [aux_sym_char_token1] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4182),
    [anon_sym_DQUOTE] = ACTIONS(4182),
    [anon_sym_AT_DQUOTE] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [sym_bool] = ACTIONS(4182),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4182),
    [sym_op_identifier] = ACTIONS(4182),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_PLUS_DOT] = ACTIONS(4182),
    [anon_sym_DASH_DOT] = ACTIONS(4182),
    [anon_sym_PERCENT] = ACTIONS(4182),
    [anon_sym_AMP_AMP] = ACTIONS(4182),
    [anon_sym_TILDE] = ACTIONS(3689),
    [aux_sym_prefix_op_token1] = ACTIONS(4182),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token2] = ACTIONS(4182),
    [anon_sym_PIPE_PIPE] = ACTIONS(4182),
    [anon_sym_BANG_EQ] = ACTIONS(4182),
    [anon_sym_COLON_EQ] = ACTIONS(3689),
    [anon_sym_DOLLAR] = ACTIONS(4182),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4182),
    [sym_int] = ACTIONS(4182),
    [sym_xint] = ACTIONS(3689),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3689),
    [anon_sym_POUNDendif] = ACTIONS(3689),
    [anon_sym_POUNDelse] = ACTIONS(3689),
    [sym__newline] = ACTIONS(3689),
  },
  [1732] = {
    [sym_block_comment] = STATE(1732),
    [sym_compiler_directive_decl] = STATE(1732),
    [sym_fsi_directive_decl] = STATE(1732),
    [sym_preproc_line] = STATE(1732),
    [sym_identifier] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3919),
    [anon_sym_LBRACK_LT] = ACTIONS(3919),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_return] = ACTIONS(3921),
    [anon_sym_do] = ACTIONS(3921),
    [anon_sym_and] = ACTIONS(3921),
    [anon_sym_let] = ACTIONS(3921),
    [anon_sym_let_BANG] = ACTIONS(3919),
    [aux_sym_access_modifier_token1] = ACTIONS(3919),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3919),
    [anon_sym_null] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_COLON] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3919),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_LT_AT] = ACTIONS(3921),
    [anon_sym_LT_AT_AT] = ACTIONS(3921),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3919),
    [anon_sym_new] = ACTIONS(3921),
    [anon_sym_with] = ACTIONS(3921),
    [anon_sym_return_BANG] = ACTIONS(3919),
    [anon_sym_yield] = ACTIONS(3921),
    [anon_sym_yield_BANG] = ACTIONS(3919),
    [anon_sym_lazy] = ACTIONS(3921),
    [anon_sym_assert] = ACTIONS(3921),
    [anon_sym_upcast] = ACTIONS(3921),
    [anon_sym_downcast] = ACTIONS(3921),
    [anon_sym_COLON_GT] = ACTIONS(3919),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3919),
    [anon_sym_for] = ACTIONS(3921),
    [anon_sym_while] = ACTIONS(3921),
    [anon_sym_if] = ACTIONS(3921),
    [anon_sym_fun] = ACTIONS(3921),
    [anon_sym_try] = ACTIONS(3921),
    [anon_sym_match] = ACTIONS(3921),
    [anon_sym_match_BANG] = ACTIONS(3919),
    [anon_sym_function] = ACTIONS(3921),
    [anon_sym_LT_DASH] = ACTIONS(3921),
    [anon_sym_DOT_LBRACK] = ACTIONS(3919),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_use] = ACTIONS(3921),
    [anon_sym_use_BANG] = ACTIONS(3919),
    [anon_sym_do_BANG] = ACTIONS(3919),
    [anon_sym_begin] = ACTIONS(3921),
    [anon_sym_LPAREN2] = ACTIONS(3921),
    [anon_sym_default] = ACTIONS(3921),
    [anon_sym_or] = ACTIONS(3921),
    [anon_sym_static] = ACTIONS(3921),
    [anon_sym_member] = ACTIONS(3921),
    [anon_sym_interface] = ACTIONS(3921),
    [anon_sym_abstract] = ACTIONS(3921),
    [anon_sym_val] = ACTIONS(3921),
    [anon_sym_override] = ACTIONS(3921),
    [aux_sym_char_token1] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_AT_DQUOTE] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [sym_bool] = ACTIONS(3921),
    [sym_unit] = ACTIONS(3919),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3921),
    [sym_op_identifier] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_DOT] = ACTIONS(3921),
    [anon_sym_DASH_DOT] = ACTIONS(3921),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3919),
    [aux_sym_prefix_op_token1] = ACTIONS(3921),
    [aux_sym_infix_op_token1] = ACTIONS(3919),
    [aux_sym_infix_op_token2] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_COLON_EQ] = ACTIONS(3919),
    [anon_sym_DOLLAR] = ACTIONS(3921),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3921),
    [sym_int] = ACTIONS(3921),
    [sym_xint] = ACTIONS(3919),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3919),
    [anon_sym_POUNDendif] = ACTIONS(3919),
    [anon_sym_POUNDelse] = ACTIONS(3919),
    [sym__newline] = ACTIONS(3919),
  },
  [1733] = {
    [sym_block_comment] = STATE(1733),
    [sym_compiler_directive_decl] = STATE(1733),
    [sym_fsi_directive_decl] = STATE(1733),
    [sym_preproc_line] = STATE(1733),
    [sym_identifier] = ACTIONS(3942),
    [anon_sym_EQ] = ACTIONS(3940),
    [anon_sym_LBRACK_LT] = ACTIONS(3940),
    [anon_sym_COLON] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_let_BANG] = ACTIONS(3940),
    [aux_sym_access_modifier_token1] = ACTIONS(3940),
    [anon_sym_LPAREN] = ACTIONS(3942),
    [anon_sym_COMMA] = ACTIONS(3940),
    [anon_sym_null] = ACTIONS(3942),
    [anon_sym_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3940),
    [anon_sym_LBRACE] = ACTIONS(3942),
    [anon_sym_LT_AT] = ACTIONS(3942),
    [anon_sym_LT_AT_AT] = ACTIONS(3942),
    [anon_sym_DOT] = ACTIONS(3942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3940),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_with] = ACTIONS(3942),
    [anon_sym_return_BANG] = ACTIONS(3940),
    [anon_sym_yield] = ACTIONS(3942),
    [anon_sym_yield_BANG] = ACTIONS(3940),
    [anon_sym_lazy] = ACTIONS(3942),
    [anon_sym_assert] = ACTIONS(3942),
    [anon_sym_upcast] = ACTIONS(3942),
    [anon_sym_downcast] = ACTIONS(3942),
    [anon_sym_COLON_GT] = ACTIONS(3940),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3940),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_fun] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_match] = ACTIONS(3942),
    [anon_sym_match_BANG] = ACTIONS(3940),
    [anon_sym_function] = ACTIONS(3942),
    [anon_sym_LT_DASH] = ACTIONS(3942),
    [anon_sym_DOT_LBRACK] = ACTIONS(3940),
    [anon_sym_LT] = ACTIONS(3940),
    [anon_sym_use] = ACTIONS(3942),
    [anon_sym_use_BANG] = ACTIONS(3940),
    [anon_sym_do_BANG] = ACTIONS(3940),
    [anon_sym_begin] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3942),
    [anon_sym_default] = ACTIONS(3942),
    [anon_sym_or] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_member] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_abstract] = ACTIONS(3942),
    [anon_sym_val] = ACTIONS(3942),
    [anon_sym_override] = ACTIONS(3942),
    [anon_sym_inherit] = ACTIONS(3942),
    [aux_sym_char_token1] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3942),
    [anon_sym_DQUOTE] = ACTIONS(3942),
    [anon_sym_AT_DQUOTE] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [sym_bool] = ACTIONS(3942),
    [sym_unit] = ACTIONS(3940),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3942),
    [sym_op_identifier] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS_DOT] = ACTIONS(3942),
    [anon_sym_DASH_DOT] = ACTIONS(3942),
    [anon_sym_PERCENT] = ACTIONS(3942),
    [anon_sym_AMP_AMP] = ACTIONS(3942),
    [anon_sym_TILDE] = ACTIONS(3940),
    [aux_sym_prefix_op_token1] = ACTIONS(3942),
    [aux_sym_infix_op_token1] = ACTIONS(3940),
    [aux_sym_infix_op_token2] = ACTIONS(3942),
    [anon_sym_PIPE_PIPE] = ACTIONS(3942),
    [anon_sym_BANG_EQ] = ACTIONS(3942),
    [anon_sym_COLON_EQ] = ACTIONS(3940),
    [anon_sym_DOLLAR] = ACTIONS(3942),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3942),
    [sym_int] = ACTIONS(3942),
    [sym_xint] = ACTIONS(3940),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3940),
    [anon_sym_POUNDendif] = ACTIONS(3940),
    [anon_sym_POUNDelse] = ACTIONS(3940),
    [sym__newline] = ACTIONS(3940),
  },
  [1734] = {
    [sym_block_comment] = STATE(1734),
    [sym_compiler_directive_decl] = STATE(1734),
    [sym_fsi_directive_decl] = STATE(1734),
    [sym_preproc_line] = STATE(1734),
    [sym_identifier] = ACTIONS(3931),
    [anon_sym_EQ] = ACTIONS(3929),
    [anon_sym_LBRACK_LT] = ACTIONS(3929),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_do] = ACTIONS(3931),
    [anon_sym_let] = ACTIONS(3931),
    [anon_sym_let_BANG] = ACTIONS(3929),
    [aux_sym_access_modifier_token1] = ACTIONS(3929),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_COMMA] = ACTIONS(3929),
    [anon_sym_null] = ACTIONS(3931),
    [anon_sym_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_COLON] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3931),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_LT_AT] = ACTIONS(3931),
    [anon_sym_LT_AT_AT] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3931),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3929),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3931),
    [anon_sym_return_BANG] = ACTIONS(3929),
    [anon_sym_yield] = ACTIONS(3931),
    [anon_sym_yield_BANG] = ACTIONS(3929),
    [anon_sym_lazy] = ACTIONS(3931),
    [anon_sym_assert] = ACTIONS(3931),
    [anon_sym_upcast] = ACTIONS(3931),
    [anon_sym_downcast] = ACTIONS(3931),
    [anon_sym_COLON_GT] = ACTIONS(3929),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3929),
    [anon_sym_for] = ACTIONS(3931),
    [anon_sym_while] = ACTIONS(3931),
    [anon_sym_if] = ACTIONS(3931),
    [anon_sym_fun] = ACTIONS(3931),
    [anon_sym_try] = ACTIONS(3931),
    [anon_sym_match] = ACTIONS(3931),
    [anon_sym_match_BANG] = ACTIONS(3929),
    [anon_sym_function] = ACTIONS(3931),
    [anon_sym_LT_DASH] = ACTIONS(3931),
    [anon_sym_DOT_LBRACK] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_use] = ACTIONS(3931),
    [anon_sym_use_BANG] = ACTIONS(3929),
    [anon_sym_do_BANG] = ACTIONS(3929),
    [anon_sym_begin] = ACTIONS(3931),
    [anon_sym_LPAREN2] = ACTIONS(3931),
    [anon_sym_default] = ACTIONS(3931),
    [anon_sym_or] = ACTIONS(3931),
    [anon_sym_static] = ACTIONS(3931),
    [anon_sym_member] = ACTIONS(3931),
    [anon_sym_interface] = ACTIONS(3931),
    [anon_sym_abstract] = ACTIONS(3931),
    [anon_sym_val] = ACTIONS(3931),
    [anon_sym_override] = ACTIONS(3931),
    [anon_sym_inherit] = ACTIONS(3931),
    [aux_sym_char_token1] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3931),
    [anon_sym_DQUOTE] = ACTIONS(3931),
    [anon_sym_AT_DQUOTE] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [sym_bool] = ACTIONS(3931),
    [sym_unit] = ACTIONS(3929),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3931),
    [sym_op_identifier] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3931),
    [anon_sym_DASH] = ACTIONS(3931),
    [anon_sym_PLUS_DOT] = ACTIONS(3931),
    [anon_sym_DASH_DOT] = ACTIONS(3931),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_TILDE] = ACTIONS(3929),
    [aux_sym_prefix_op_token1] = ACTIONS(3931),
    [aux_sym_infix_op_token1] = ACTIONS(3929),
    [aux_sym_infix_op_token2] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_COLON_EQ] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3931),
    [sym_int] = ACTIONS(3931),
    [sym_xint] = ACTIONS(3929),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3929),
    [anon_sym_POUNDendif] = ACTIONS(3929),
    [anon_sym_POUNDelse] = ACTIONS(3929),
    [sym__newline] = ACTIONS(3929),
  },
  [1735] = {
    [sym_block_comment] = STATE(1735),
    [sym_compiler_directive_decl] = STATE(1735),
    [sym_fsi_directive_decl] = STATE(1735),
    [sym_preproc_line] = STATE(1735),
    [sym_identifier] = ACTIONS(4007),
    [anon_sym_EQ] = ACTIONS(4005),
    [anon_sym_LBRACK_LT] = ACTIONS(4005),
    [anon_sym_COLON] = ACTIONS(4007),
    [anon_sym_return] = ACTIONS(4007),
    [anon_sym_do] = ACTIONS(4007),
    [anon_sym_and] = ACTIONS(4007),
    [anon_sym_let] = ACTIONS(4007),
    [anon_sym_let_BANG] = ACTIONS(4005),
    [aux_sym_access_modifier_token1] = ACTIONS(4005),
    [anon_sym_LPAREN] = ACTIONS(4007),
    [anon_sym_COMMA] = ACTIONS(4005),
    [anon_sym_null] = ACTIONS(4007),
    [anon_sym_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_COLON] = ACTIONS(4005),
    [anon_sym_AMP] = ACTIONS(4007),
    [anon_sym_LBRACK] = ACTIONS(4007),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4005),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_LT_AT] = ACTIONS(4007),
    [anon_sym_LT_AT_AT] = ACTIONS(4007),
    [anon_sym_DOT] = ACTIONS(4007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4005),
    [anon_sym_new] = ACTIONS(4007),
    [anon_sym_with] = ACTIONS(4007),
    [anon_sym_return_BANG] = ACTIONS(4005),
    [anon_sym_yield] = ACTIONS(4007),
    [anon_sym_yield_BANG] = ACTIONS(4005),
    [anon_sym_lazy] = ACTIONS(4007),
    [anon_sym_assert] = ACTIONS(4007),
    [anon_sym_upcast] = ACTIONS(4007),
    [anon_sym_downcast] = ACTIONS(4007),
    [anon_sym_COLON_GT] = ACTIONS(4005),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4005),
    [anon_sym_for] = ACTIONS(4007),
    [anon_sym_while] = ACTIONS(4007),
    [anon_sym_if] = ACTIONS(4007),
    [anon_sym_fun] = ACTIONS(4007),
    [anon_sym_try] = ACTIONS(4007),
    [anon_sym_match] = ACTIONS(4007),
    [anon_sym_match_BANG] = ACTIONS(4005),
    [anon_sym_function] = ACTIONS(4007),
    [anon_sym_LT_DASH] = ACTIONS(4007),
    [anon_sym_DOT_LBRACK] = ACTIONS(4005),
    [anon_sym_LT] = ACTIONS(4005),
    [anon_sym_use] = ACTIONS(4007),
    [anon_sym_use_BANG] = ACTIONS(4005),
    [anon_sym_do_BANG] = ACTIONS(4005),
    [anon_sym_begin] = ACTIONS(4007),
    [anon_sym_LPAREN2] = ACTIONS(4007),
    [anon_sym_default] = ACTIONS(4007),
    [anon_sym_or] = ACTIONS(4007),
    [anon_sym_static] = ACTIONS(4007),
    [anon_sym_member] = ACTIONS(4007),
    [anon_sym_interface] = ACTIONS(4007),
    [anon_sym_abstract] = ACTIONS(4007),
    [anon_sym_val] = ACTIONS(4007),
    [anon_sym_override] = ACTIONS(4007),
    [aux_sym_char_token1] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4007),
    [anon_sym_DQUOTE] = ACTIONS(4007),
    [anon_sym_AT_DQUOTE] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [sym_bool] = ACTIONS(4007),
    [sym_unit] = ACTIONS(4005),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4007),
    [sym_op_identifier] = ACTIONS(4007),
    [anon_sym_PLUS] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4007),
    [anon_sym_PLUS_DOT] = ACTIONS(4007),
    [anon_sym_DASH_DOT] = ACTIONS(4007),
    [anon_sym_PERCENT] = ACTIONS(4007),
    [anon_sym_AMP_AMP] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4005),
    [aux_sym_prefix_op_token1] = ACTIONS(4007),
    [aux_sym_infix_op_token1] = ACTIONS(4005),
    [aux_sym_infix_op_token2] = ACTIONS(4007),
    [anon_sym_PIPE_PIPE] = ACTIONS(4007),
    [anon_sym_BANG_EQ] = ACTIONS(4007),
    [anon_sym_COLON_EQ] = ACTIONS(4005),
    [anon_sym_DOLLAR] = ACTIONS(4007),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4007),
    [sym_int] = ACTIONS(4007),
    [sym_xint] = ACTIONS(4005),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4005),
    [anon_sym_POUNDendif] = ACTIONS(4005),
    [anon_sym_POUNDelse] = ACTIONS(4005),
    [sym__newline] = ACTIONS(4005),
  },
  [1736] = {
    [sym_block_comment] = STATE(1736),
    [sym_compiler_directive_decl] = STATE(1736),
    [sym_fsi_directive_decl] = STATE(1736),
    [sym_preproc_line] = STATE(1736),
    [sym_identifier] = ACTIONS(4011),
    [anon_sym_EQ] = ACTIONS(4009),
    [anon_sym_LBRACK_LT] = ACTIONS(4009),
    [anon_sym_COLON] = ACTIONS(4011),
    [anon_sym_return] = ACTIONS(4011),
    [anon_sym_do] = ACTIONS(4011),
    [anon_sym_and] = ACTIONS(4011),
    [anon_sym_let] = ACTIONS(4011),
    [anon_sym_let_BANG] = ACTIONS(4009),
    [aux_sym_access_modifier_token1] = ACTIONS(4009),
    [anon_sym_LPAREN] = ACTIONS(4011),
    [anon_sym_COMMA] = ACTIONS(4009),
    [anon_sym_null] = ACTIONS(4011),
    [anon_sym_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(4011),
    [anon_sym_LBRACK] = ACTIONS(4011),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4009),
    [anon_sym_LBRACE] = ACTIONS(4011),
    [anon_sym_LT_AT] = ACTIONS(4011),
    [anon_sym_LT_AT_AT] = ACTIONS(4011),
    [anon_sym_DOT] = ACTIONS(4011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4009),
    [anon_sym_new] = ACTIONS(4011),
    [anon_sym_with] = ACTIONS(4011),
    [anon_sym_return_BANG] = ACTIONS(4009),
    [anon_sym_yield] = ACTIONS(4011),
    [anon_sym_yield_BANG] = ACTIONS(4009),
    [anon_sym_lazy] = ACTIONS(4011),
    [anon_sym_assert] = ACTIONS(4011),
    [anon_sym_upcast] = ACTIONS(4011),
    [anon_sym_downcast] = ACTIONS(4011),
    [anon_sym_COLON_GT] = ACTIONS(4009),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4009),
    [anon_sym_for] = ACTIONS(4011),
    [anon_sym_while] = ACTIONS(4011),
    [anon_sym_if] = ACTIONS(4011),
    [anon_sym_fun] = ACTIONS(4011),
    [anon_sym_try] = ACTIONS(4011),
    [anon_sym_match] = ACTIONS(4011),
    [anon_sym_match_BANG] = ACTIONS(4009),
    [anon_sym_function] = ACTIONS(4011),
    [anon_sym_LT_DASH] = ACTIONS(4011),
    [anon_sym_DOT_LBRACK] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(4009),
    [anon_sym_use] = ACTIONS(4011),
    [anon_sym_use_BANG] = ACTIONS(4009),
    [anon_sym_do_BANG] = ACTIONS(4009),
    [anon_sym_begin] = ACTIONS(4011),
    [anon_sym_LPAREN2] = ACTIONS(4011),
    [anon_sym_default] = ACTIONS(4011),
    [anon_sym_or] = ACTIONS(4011),
    [anon_sym_static] = ACTIONS(4011),
    [anon_sym_member] = ACTIONS(4011),
    [anon_sym_interface] = ACTIONS(4011),
    [anon_sym_abstract] = ACTIONS(4011),
    [anon_sym_val] = ACTIONS(4011),
    [anon_sym_override] = ACTIONS(4011),
    [aux_sym_char_token1] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4011),
    [anon_sym_DQUOTE] = ACTIONS(4011),
    [anon_sym_AT_DQUOTE] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [sym_bool] = ACTIONS(4011),
    [sym_unit] = ACTIONS(4009),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4011),
    [sym_op_identifier] = ACTIONS(4011),
    [anon_sym_PLUS] = ACTIONS(4011),
    [anon_sym_DASH] = ACTIONS(4011),
    [anon_sym_PLUS_DOT] = ACTIONS(4011),
    [anon_sym_DASH_DOT] = ACTIONS(4011),
    [anon_sym_PERCENT] = ACTIONS(4011),
    [anon_sym_AMP_AMP] = ACTIONS(4011),
    [anon_sym_TILDE] = ACTIONS(4009),
    [aux_sym_prefix_op_token1] = ACTIONS(4011),
    [aux_sym_infix_op_token1] = ACTIONS(4009),
    [aux_sym_infix_op_token2] = ACTIONS(4011),
    [anon_sym_PIPE_PIPE] = ACTIONS(4011),
    [anon_sym_BANG_EQ] = ACTIONS(4011),
    [anon_sym_COLON_EQ] = ACTIONS(4009),
    [anon_sym_DOLLAR] = ACTIONS(4011),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4011),
    [sym_int] = ACTIONS(4011),
    [sym_xint] = ACTIONS(4009),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4009),
    [anon_sym_POUNDendif] = ACTIONS(4009),
    [anon_sym_POUNDelse] = ACTIONS(4009),
    [sym__newline] = ACTIONS(4009),
  },
  [1737] = {
    [sym_block_comment] = STATE(1737),
    [sym_compiler_directive_decl] = STATE(1737),
    [sym_fsi_directive_decl] = STATE(1737),
    [sym_preproc_line] = STATE(1737),
    [sym_identifier] = ACTIONS(4022),
    [anon_sym_EQ] = ACTIONS(4020),
    [anon_sym_LBRACK_LT] = ACTIONS(4020),
    [anon_sym_COLON] = ACTIONS(4022),
    [anon_sym_return] = ACTIONS(4022),
    [anon_sym_do] = ACTIONS(4022),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_let_BANG] = ACTIONS(4020),
    [aux_sym_access_modifier_token1] = ACTIONS(4020),
    [anon_sym_LPAREN] = ACTIONS(4022),
    [anon_sym_COMMA] = ACTIONS(4020),
    [anon_sym_null] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_COLON] = ACTIONS(4020),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4022),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(4022),
    [anon_sym_LT_AT] = ACTIONS(4022),
    [anon_sym_LT_AT_AT] = ACTIONS(4022),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4020),
    [anon_sym_new] = ACTIONS(4022),
    [anon_sym_with] = ACTIONS(4022),
    [anon_sym_return_BANG] = ACTIONS(4020),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_yield_BANG] = ACTIONS(4020),
    [anon_sym_lazy] = ACTIONS(4022),
    [anon_sym_assert] = ACTIONS(4022),
    [anon_sym_upcast] = ACTIONS(4022),
    [anon_sym_downcast] = ACTIONS(4022),
    [anon_sym_COLON_GT] = ACTIONS(4020),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4020),
    [anon_sym_for] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4022),
    [anon_sym_if] = ACTIONS(4022),
    [anon_sym_fun] = ACTIONS(4022),
    [anon_sym_try] = ACTIONS(4022),
    [anon_sym_match] = ACTIONS(4022),
    [anon_sym_match_BANG] = ACTIONS(4020),
    [anon_sym_function] = ACTIONS(4022),
    [anon_sym_LT_DASH] = ACTIONS(4022),
    [anon_sym_DOT_LBRACK] = ACTIONS(4020),
    [anon_sym_LT] = ACTIONS(4020),
    [anon_sym_use] = ACTIONS(4022),
    [anon_sym_use_BANG] = ACTIONS(4020),
    [anon_sym_do_BANG] = ACTIONS(4020),
    [anon_sym_begin] = ACTIONS(4022),
    [anon_sym_LPAREN2] = ACTIONS(4022),
    [anon_sym_default] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_static] = ACTIONS(4022),
    [anon_sym_member] = ACTIONS(4022),
    [anon_sym_interface] = ACTIONS(4022),
    [anon_sym_abstract] = ACTIONS(4022),
    [anon_sym_val] = ACTIONS(4022),
    [anon_sym_override] = ACTIONS(4022),
    [aux_sym_char_token1] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4022),
    [anon_sym_DQUOTE] = ACTIONS(4022),
    [anon_sym_AT_DQUOTE] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [sym_bool] = ACTIONS(4022),
    [sym_unit] = ACTIONS(4020),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4022),
    [sym_op_identifier] = ACTIONS(4022),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_PLUS_DOT] = ACTIONS(4022),
    [anon_sym_DASH_DOT] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4022),
    [anon_sym_TILDE] = ACTIONS(4020),
    [aux_sym_prefix_op_token1] = ACTIONS(4022),
    [aux_sym_infix_op_token1] = ACTIONS(4020),
    [aux_sym_infix_op_token2] = ACTIONS(4022),
    [anon_sym_PIPE_PIPE] = ACTIONS(4022),
    [anon_sym_BANG_EQ] = ACTIONS(4022),
    [anon_sym_COLON_EQ] = ACTIONS(4020),
    [anon_sym_DOLLAR] = ACTIONS(4022),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4022),
    [sym_int] = ACTIONS(4022),
    [sym_xint] = ACTIONS(4020),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4020),
    [anon_sym_POUNDendif] = ACTIONS(4020),
    [anon_sym_POUNDelse] = ACTIONS(4020),
    [sym__newline] = ACTIONS(4020),
  },
  [1738] = {
    [sym_block_comment] = STATE(1738),
    [sym_compiler_directive_decl] = STATE(1738),
    [sym_fsi_directive_decl] = STATE(1738),
    [sym_preproc_line] = STATE(1738),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4072),
    [anon_sym_LBRACK_LT] = ACTIONS(4072),
    [anon_sym_COLON] = ACTIONS(4074),
    [anon_sym_return] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_let_BANG] = ACTIONS(4072),
    [aux_sym_access_modifier_token1] = ACTIONS(4072),
    [anon_sym_LPAREN] = ACTIONS(4074),
    [anon_sym_COMMA] = ACTIONS(4072),
    [anon_sym_null] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_COLON] = ACTIONS(4072),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_LT_AT] = ACTIONS(4074),
    [anon_sym_LT_AT_AT] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4072),
    [anon_sym_new] = ACTIONS(4074),
    [anon_sym_with] = ACTIONS(4074),
    [anon_sym_return_BANG] = ACTIONS(4072),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_yield_BANG] = ACTIONS(4072),
    [anon_sym_lazy] = ACTIONS(4074),
    [anon_sym_assert] = ACTIONS(4074),
    [anon_sym_upcast] = ACTIONS(4074),
    [anon_sym_downcast] = ACTIONS(4074),
    [anon_sym_COLON_GT] = ACTIONS(4072),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4072),
    [anon_sym_for] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_fun] = ACTIONS(4074),
    [anon_sym_try] = ACTIONS(4074),
    [anon_sym_match] = ACTIONS(4074),
    [anon_sym_match_BANG] = ACTIONS(4072),
    [anon_sym_function] = ACTIONS(4074),
    [anon_sym_LT_DASH] = ACTIONS(4074),
    [anon_sym_DOT_LBRACK] = ACTIONS(4072),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_use] = ACTIONS(4074),
    [anon_sym_use_BANG] = ACTIONS(4072),
    [anon_sym_do_BANG] = ACTIONS(4072),
    [anon_sym_begin] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(4074),
    [anon_sym_default] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_static] = ACTIONS(4074),
    [anon_sym_member] = ACTIONS(4074),
    [anon_sym_interface] = ACTIONS(4074),
    [anon_sym_abstract] = ACTIONS(4074),
    [anon_sym_val] = ACTIONS(4074),
    [anon_sym_override] = ACTIONS(4074),
    [anon_sym_inherit] = ACTIONS(4074),
    [aux_sym_char_token1] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4074),
    [anon_sym_DQUOTE] = ACTIONS(4074),
    [anon_sym_AT_DQUOTE] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [sym_bool] = ACTIONS(4074),
    [sym_unit] = ACTIONS(4072),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4074),
    [sym_op_identifier] = ACTIONS(4074),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_PLUS_DOT] = ACTIONS(4074),
    [anon_sym_DASH_DOT] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_TILDE] = ACTIONS(4072),
    [aux_sym_prefix_op_token1] = ACTIONS(4074),
    [aux_sym_infix_op_token1] = ACTIONS(4072),
    [aux_sym_infix_op_token2] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [anon_sym_BANG_EQ] = ACTIONS(4074),
    [anon_sym_COLON_EQ] = ACTIONS(4072),
    [anon_sym_DOLLAR] = ACTIONS(4074),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4074),
    [sym_int] = ACTIONS(4074),
    [sym_xint] = ACTIONS(4072),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4072),
    [anon_sym_POUNDendif] = ACTIONS(4072),
    [anon_sym_POUNDelse] = ACTIONS(4072),
    [sym__newline] = ACTIONS(4072),
  },
  [1739] = {
    [sym_block_comment] = STATE(1739),
    [sym_compiler_directive_decl] = STATE(1739),
    [sym_fsi_directive_decl] = STATE(1739),
    [sym_preproc_line] = STATE(1739),
    [sym_identifier] = ACTIONS(4022),
    [anon_sym_EQ] = ACTIONS(4020),
    [anon_sym_LBRACK_LT] = ACTIONS(4020),
    [anon_sym_COLON] = ACTIONS(4022),
    [anon_sym_return] = ACTIONS(4022),
    [anon_sym_do] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_let_BANG] = ACTIONS(4020),
    [aux_sym_access_modifier_token1] = ACTIONS(4020),
    [anon_sym_LPAREN] = ACTIONS(4022),
    [anon_sym_COMMA] = ACTIONS(4020),
    [anon_sym_null] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_COLON] = ACTIONS(4020),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4022),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(4022),
    [anon_sym_LT_AT] = ACTIONS(4022),
    [anon_sym_LT_AT_AT] = ACTIONS(4022),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4020),
    [anon_sym_new] = ACTIONS(4022),
    [anon_sym_with] = ACTIONS(4022),
    [anon_sym_return_BANG] = ACTIONS(4020),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_yield_BANG] = ACTIONS(4020),
    [anon_sym_lazy] = ACTIONS(4022),
    [anon_sym_assert] = ACTIONS(4022),
    [anon_sym_upcast] = ACTIONS(4022),
    [anon_sym_downcast] = ACTIONS(4022),
    [anon_sym_COLON_GT] = ACTIONS(4020),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4020),
    [anon_sym_for] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4022),
    [anon_sym_if] = ACTIONS(4022),
    [anon_sym_fun] = ACTIONS(4022),
    [anon_sym_try] = ACTIONS(4022),
    [anon_sym_match] = ACTIONS(4022),
    [anon_sym_match_BANG] = ACTIONS(4020),
    [anon_sym_function] = ACTIONS(4022),
    [anon_sym_LT_DASH] = ACTIONS(4022),
    [anon_sym_DOT_LBRACK] = ACTIONS(4020),
    [anon_sym_LT] = ACTIONS(4020),
    [anon_sym_use] = ACTIONS(4022),
    [anon_sym_use_BANG] = ACTIONS(4020),
    [anon_sym_do_BANG] = ACTIONS(4020),
    [anon_sym_begin] = ACTIONS(4022),
    [anon_sym_LPAREN2] = ACTIONS(4022),
    [anon_sym_default] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_static] = ACTIONS(4022),
    [anon_sym_member] = ACTIONS(4022),
    [anon_sym_interface] = ACTIONS(4022),
    [anon_sym_abstract] = ACTIONS(4022),
    [anon_sym_val] = ACTIONS(4022),
    [anon_sym_override] = ACTIONS(4022),
    [anon_sym_inherit] = ACTIONS(4022),
    [aux_sym_char_token1] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4022),
    [anon_sym_DQUOTE] = ACTIONS(4022),
    [anon_sym_AT_DQUOTE] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [sym_bool] = ACTIONS(4022),
    [sym_unit] = ACTIONS(4020),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4022),
    [sym_op_identifier] = ACTIONS(4022),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_PLUS_DOT] = ACTIONS(4022),
    [anon_sym_DASH_DOT] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4022),
    [anon_sym_TILDE] = ACTIONS(4020),
    [aux_sym_prefix_op_token1] = ACTIONS(4022),
    [aux_sym_infix_op_token1] = ACTIONS(4020),
    [aux_sym_infix_op_token2] = ACTIONS(4022),
    [anon_sym_PIPE_PIPE] = ACTIONS(4022),
    [anon_sym_BANG_EQ] = ACTIONS(4022),
    [anon_sym_COLON_EQ] = ACTIONS(4020),
    [anon_sym_DOLLAR] = ACTIONS(4022),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4022),
    [sym_int] = ACTIONS(4022),
    [sym_xint] = ACTIONS(4020),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4020),
    [anon_sym_POUNDendif] = ACTIONS(4020),
    [anon_sym_POUNDelse] = ACTIONS(4020),
    [sym__newline] = ACTIONS(4020),
  },
  [1740] = {
    [sym_block_comment] = STATE(1740),
    [sym_compiler_directive_decl] = STATE(1740),
    [sym_fsi_directive_decl] = STATE(1740),
    [sym_preproc_line] = STATE(1740),
    [sym_identifier] = ACTIONS(4011),
    [anon_sym_EQ] = ACTIONS(4009),
    [anon_sym_LBRACK_LT] = ACTIONS(4009),
    [anon_sym_COLON] = ACTIONS(4011),
    [anon_sym_return] = ACTIONS(4011),
    [anon_sym_do] = ACTIONS(4011),
    [anon_sym_let] = ACTIONS(4011),
    [anon_sym_let_BANG] = ACTIONS(4009),
    [aux_sym_access_modifier_token1] = ACTIONS(4009),
    [anon_sym_LPAREN] = ACTIONS(4011),
    [anon_sym_COMMA] = ACTIONS(4009),
    [anon_sym_null] = ACTIONS(4011),
    [anon_sym_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(4011),
    [anon_sym_LBRACK] = ACTIONS(4011),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4009),
    [anon_sym_LBRACE] = ACTIONS(4011),
    [anon_sym_LT_AT] = ACTIONS(4011),
    [anon_sym_LT_AT_AT] = ACTIONS(4011),
    [anon_sym_DOT] = ACTIONS(4011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4009),
    [anon_sym_new] = ACTIONS(4011),
    [anon_sym_with] = ACTIONS(4011),
    [anon_sym_return_BANG] = ACTIONS(4009),
    [anon_sym_yield] = ACTIONS(4011),
    [anon_sym_yield_BANG] = ACTIONS(4009),
    [anon_sym_lazy] = ACTIONS(4011),
    [anon_sym_assert] = ACTIONS(4011),
    [anon_sym_upcast] = ACTIONS(4011),
    [anon_sym_downcast] = ACTIONS(4011),
    [anon_sym_COLON_GT] = ACTIONS(4009),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4009),
    [anon_sym_for] = ACTIONS(4011),
    [anon_sym_while] = ACTIONS(4011),
    [anon_sym_if] = ACTIONS(4011),
    [anon_sym_fun] = ACTIONS(4011),
    [anon_sym_try] = ACTIONS(4011),
    [anon_sym_match] = ACTIONS(4011),
    [anon_sym_match_BANG] = ACTIONS(4009),
    [anon_sym_function] = ACTIONS(4011),
    [anon_sym_LT_DASH] = ACTIONS(4011),
    [anon_sym_DOT_LBRACK] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(4009),
    [anon_sym_use] = ACTIONS(4011),
    [anon_sym_use_BANG] = ACTIONS(4009),
    [anon_sym_do_BANG] = ACTIONS(4009),
    [anon_sym_begin] = ACTIONS(4011),
    [anon_sym_LPAREN2] = ACTIONS(4011),
    [anon_sym_default] = ACTIONS(4011),
    [anon_sym_or] = ACTIONS(4011),
    [anon_sym_static] = ACTIONS(4011),
    [anon_sym_member] = ACTIONS(4011),
    [anon_sym_interface] = ACTIONS(4011),
    [anon_sym_abstract] = ACTIONS(4011),
    [anon_sym_val] = ACTIONS(4011),
    [anon_sym_override] = ACTIONS(4011),
    [anon_sym_inherit] = ACTIONS(4011),
    [aux_sym_char_token1] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4011),
    [anon_sym_DQUOTE] = ACTIONS(4011),
    [anon_sym_AT_DQUOTE] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [sym_bool] = ACTIONS(4011),
    [sym_unit] = ACTIONS(4009),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4011),
    [sym_op_identifier] = ACTIONS(4011),
    [anon_sym_PLUS] = ACTIONS(4011),
    [anon_sym_DASH] = ACTIONS(4011),
    [anon_sym_PLUS_DOT] = ACTIONS(4011),
    [anon_sym_DASH_DOT] = ACTIONS(4011),
    [anon_sym_PERCENT] = ACTIONS(4011),
    [anon_sym_AMP_AMP] = ACTIONS(4011),
    [anon_sym_TILDE] = ACTIONS(4009),
    [aux_sym_prefix_op_token1] = ACTIONS(4011),
    [aux_sym_infix_op_token1] = ACTIONS(4009),
    [aux_sym_infix_op_token2] = ACTIONS(4011),
    [anon_sym_PIPE_PIPE] = ACTIONS(4011),
    [anon_sym_BANG_EQ] = ACTIONS(4011),
    [anon_sym_COLON_EQ] = ACTIONS(4009),
    [anon_sym_DOLLAR] = ACTIONS(4011),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4011),
    [sym_int] = ACTIONS(4011),
    [sym_xint] = ACTIONS(4009),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4009),
    [anon_sym_POUNDendif] = ACTIONS(4009),
    [anon_sym_POUNDelse] = ACTIONS(4009),
    [sym__newline] = ACTIONS(4009),
  },
  [1741] = {
    [sym_block_comment] = STATE(1741),
    [sym_compiler_directive_decl] = STATE(1741),
    [sym_fsi_directive_decl] = STATE(1741),
    [sym_preproc_line] = STATE(1741),
    [sym_identifier] = ACTIONS(3917),
    [anon_sym_EQ] = ACTIONS(3915),
    [anon_sym_LBRACK_LT] = ACTIONS(3915),
    [anon_sym_COLON] = ACTIONS(3917),
    [anon_sym_return] = ACTIONS(3917),
    [anon_sym_do] = ACTIONS(3917),
    [anon_sym_let] = ACTIONS(3917),
    [anon_sym_let_BANG] = ACTIONS(3915),
    [aux_sym_access_modifier_token1] = ACTIONS(3915),
    [anon_sym_LPAREN] = ACTIONS(3917),
    [anon_sym_COMMA] = ACTIONS(3915),
    [anon_sym_null] = ACTIONS(3917),
    [anon_sym_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_COLON] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(3917),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3915),
    [anon_sym_LBRACE] = ACTIONS(3917),
    [anon_sym_LT_AT] = ACTIONS(3917),
    [anon_sym_LT_AT_AT] = ACTIONS(3917),
    [anon_sym_DOT] = ACTIONS(3917),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3915),
    [anon_sym_new] = ACTIONS(3917),
    [anon_sym_with] = ACTIONS(3917),
    [anon_sym_return_BANG] = ACTIONS(3915),
    [anon_sym_yield] = ACTIONS(3917),
    [anon_sym_yield_BANG] = ACTIONS(3915),
    [anon_sym_lazy] = ACTIONS(3917),
    [anon_sym_assert] = ACTIONS(3917),
    [anon_sym_upcast] = ACTIONS(3917),
    [anon_sym_downcast] = ACTIONS(3917),
    [anon_sym_COLON_GT] = ACTIONS(3915),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3915),
    [anon_sym_for] = ACTIONS(3917),
    [anon_sym_while] = ACTIONS(3917),
    [anon_sym_if] = ACTIONS(3917),
    [anon_sym_fun] = ACTIONS(3917),
    [anon_sym_try] = ACTIONS(3917),
    [anon_sym_match] = ACTIONS(3917),
    [anon_sym_match_BANG] = ACTIONS(3915),
    [anon_sym_function] = ACTIONS(3917),
    [anon_sym_LT_DASH] = ACTIONS(3917),
    [anon_sym_DOT_LBRACK] = ACTIONS(3915),
    [anon_sym_LT] = ACTIONS(3915),
    [anon_sym_use] = ACTIONS(3917),
    [anon_sym_use_BANG] = ACTIONS(3915),
    [anon_sym_do_BANG] = ACTIONS(3915),
    [anon_sym_begin] = ACTIONS(3917),
    [anon_sym_LPAREN2] = ACTIONS(3917),
    [anon_sym_default] = ACTIONS(3917),
    [anon_sym_or] = ACTIONS(3917),
    [anon_sym_static] = ACTIONS(3917),
    [anon_sym_member] = ACTIONS(3917),
    [anon_sym_interface] = ACTIONS(3917),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_val] = ACTIONS(3917),
    [anon_sym_override] = ACTIONS(3917),
    [anon_sym_inherit] = ACTIONS(3917),
    [aux_sym_char_token1] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_AT_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [sym_bool] = ACTIONS(3917),
    [sym_unit] = ACTIONS(3915),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3917),
    [sym_op_identifier] = ACTIONS(3917),
    [anon_sym_PLUS] = ACTIONS(3917),
    [anon_sym_DASH] = ACTIONS(3917),
    [anon_sym_PLUS_DOT] = ACTIONS(3917),
    [anon_sym_DASH_DOT] = ACTIONS(3917),
    [anon_sym_PERCENT] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_TILDE] = ACTIONS(3915),
    [aux_sym_prefix_op_token1] = ACTIONS(3917),
    [aux_sym_infix_op_token1] = ACTIONS(3915),
    [aux_sym_infix_op_token2] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_BANG_EQ] = ACTIONS(3917),
    [anon_sym_COLON_EQ] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3917),
    [sym_int] = ACTIONS(3917),
    [sym_xint] = ACTIONS(3915),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3915),
    [anon_sym_POUNDendif] = ACTIONS(3915),
    [anon_sym_POUNDelse] = ACTIONS(3915),
    [sym__newline] = ACTIONS(3915),
  },
  [1742] = {
    [sym_block_comment] = STATE(1742),
    [sym_compiler_directive_decl] = STATE(1742),
    [sym_fsi_directive_decl] = STATE(1742),
    [sym_preproc_line] = STATE(1742),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4072),
    [anon_sym_LBRACK_LT] = ACTIONS(4072),
    [anon_sym_COLON] = ACTIONS(4074),
    [anon_sym_return] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_let_BANG] = ACTIONS(4072),
    [aux_sym_access_modifier_token1] = ACTIONS(4072),
    [anon_sym_LPAREN] = ACTIONS(4074),
    [anon_sym_COMMA] = ACTIONS(4072),
    [anon_sym_null] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_COLON] = ACTIONS(4072),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_LT_AT] = ACTIONS(4074),
    [anon_sym_LT_AT_AT] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4072),
    [anon_sym_new] = ACTIONS(4074),
    [anon_sym_with] = ACTIONS(4074),
    [anon_sym_return_BANG] = ACTIONS(4072),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_yield_BANG] = ACTIONS(4072),
    [anon_sym_lazy] = ACTIONS(4074),
    [anon_sym_assert] = ACTIONS(4074),
    [anon_sym_upcast] = ACTIONS(4074),
    [anon_sym_downcast] = ACTIONS(4074),
    [anon_sym_COLON_GT] = ACTIONS(4072),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4072),
    [anon_sym_for] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_fun] = ACTIONS(4074),
    [anon_sym_try] = ACTIONS(4074),
    [anon_sym_match] = ACTIONS(4074),
    [anon_sym_match_BANG] = ACTIONS(4072),
    [anon_sym_function] = ACTIONS(4074),
    [anon_sym_LT_DASH] = ACTIONS(4074),
    [anon_sym_DOT_LBRACK] = ACTIONS(4072),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_use] = ACTIONS(4074),
    [anon_sym_use_BANG] = ACTIONS(4072),
    [anon_sym_do_BANG] = ACTIONS(4072),
    [anon_sym_begin] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(4074),
    [anon_sym_default] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_static] = ACTIONS(4074),
    [anon_sym_member] = ACTIONS(4074),
    [anon_sym_interface] = ACTIONS(4074),
    [anon_sym_abstract] = ACTIONS(4074),
    [anon_sym_val] = ACTIONS(4074),
    [anon_sym_override] = ACTIONS(4074),
    [aux_sym_char_token1] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4074),
    [anon_sym_DQUOTE] = ACTIONS(4074),
    [anon_sym_AT_DQUOTE] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [sym_bool] = ACTIONS(4074),
    [sym_unit] = ACTIONS(4072),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4074),
    [sym_op_identifier] = ACTIONS(4074),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_PLUS_DOT] = ACTIONS(4074),
    [anon_sym_DASH_DOT] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_TILDE] = ACTIONS(4072),
    [aux_sym_prefix_op_token1] = ACTIONS(4074),
    [aux_sym_infix_op_token1] = ACTIONS(4072),
    [aux_sym_infix_op_token2] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [anon_sym_BANG_EQ] = ACTIONS(4074),
    [anon_sym_COLON_EQ] = ACTIONS(4072),
    [anon_sym_DOLLAR] = ACTIONS(4074),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4074),
    [sym_int] = ACTIONS(4074),
    [sym_xint] = ACTIONS(4072),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4072),
    [anon_sym_POUNDendif] = ACTIONS(4072),
    [anon_sym_POUNDelse] = ACTIONS(4072),
    [sym__newline] = ACTIONS(4072),
  },
  [1743] = {
    [sym_block_comment] = STATE(1743),
    [sym_compiler_directive_decl] = STATE(1743),
    [sym_fsi_directive_decl] = STATE(1743),
    [sym_preproc_line] = STATE(1743),
    [sym_identifier] = ACTIONS(4186),
    [anon_sym_EQ] = ACTIONS(4184),
    [anon_sym_LBRACK_LT] = ACTIONS(4184),
    [anon_sym_COLON] = ACTIONS(4186),
    [anon_sym_return] = ACTIONS(4186),
    [anon_sym_do] = ACTIONS(4186),
    [anon_sym_let] = ACTIONS(4186),
    [anon_sym_let_BANG] = ACTIONS(4184),
    [aux_sym_access_modifier_token1] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_COMMA] = ACTIONS(4184),
    [anon_sym_null] = ACTIONS(4186),
    [anon_sym_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_COLON] = ACTIONS(4184),
    [anon_sym_AMP] = ACTIONS(4186),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4184),
    [anon_sym_LBRACE] = ACTIONS(4186),
    [anon_sym_LT_AT] = ACTIONS(4186),
    [anon_sym_LT_AT_AT] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4186),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4184),
    [anon_sym_new] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4186),
    [anon_sym_return_BANG] = ACTIONS(4184),
    [anon_sym_yield] = ACTIONS(4186),
    [anon_sym_yield_BANG] = ACTIONS(4184),
    [anon_sym_lazy] = ACTIONS(4186),
    [anon_sym_assert] = ACTIONS(4186),
    [anon_sym_upcast] = ACTIONS(4186),
    [anon_sym_downcast] = ACTIONS(4186),
    [anon_sym_COLON_GT] = ACTIONS(4184),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4184),
    [anon_sym_for] = ACTIONS(4186),
    [anon_sym_while] = ACTIONS(4186),
    [anon_sym_if] = ACTIONS(4186),
    [anon_sym_fun] = ACTIONS(4186),
    [anon_sym_try] = ACTIONS(4186),
    [anon_sym_match] = ACTIONS(4186),
    [anon_sym_match_BANG] = ACTIONS(4184),
    [anon_sym_function] = ACTIONS(4186),
    [anon_sym_LT_DASH] = ACTIONS(4186),
    [anon_sym_DOT_LBRACK] = ACTIONS(4184),
    [anon_sym_LT] = ACTIONS(4184),
    [anon_sym_use] = ACTIONS(4186),
    [anon_sym_use_BANG] = ACTIONS(4184),
    [anon_sym_do_BANG] = ACTIONS(4184),
    [anon_sym_begin] = ACTIONS(4186),
    [anon_sym_LPAREN2] = ACTIONS(4186),
    [anon_sym_default] = ACTIONS(4186),
    [anon_sym_or] = ACTIONS(4186),
    [anon_sym_static] = ACTIONS(4186),
    [anon_sym_member] = ACTIONS(4186),
    [anon_sym_interface] = ACTIONS(4186),
    [anon_sym_abstract] = ACTIONS(4186),
    [anon_sym_val] = ACTIONS(4186),
    [anon_sym_override] = ACTIONS(4186),
    [anon_sym_inherit] = ACTIONS(4186),
    [aux_sym_char_token1] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4186),
    [anon_sym_DQUOTE] = ACTIONS(4186),
    [anon_sym_AT_DQUOTE] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [sym_bool] = ACTIONS(4186),
    [sym_unit] = ACTIONS(4184),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4186),
    [sym_op_identifier] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4186),
    [anon_sym_DASH] = ACTIONS(4186),
    [anon_sym_PLUS_DOT] = ACTIONS(4186),
    [anon_sym_DASH_DOT] = ACTIONS(4186),
    [anon_sym_PERCENT] = ACTIONS(4186),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_TILDE] = ACTIONS(4184),
    [aux_sym_prefix_op_token1] = ACTIONS(4186),
    [aux_sym_infix_op_token1] = ACTIONS(4184),
    [aux_sym_infix_op_token2] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_COLON_EQ] = ACTIONS(4184),
    [anon_sym_DOLLAR] = ACTIONS(4186),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4186),
    [sym_int] = ACTIONS(4186),
    [sym_xint] = ACTIONS(4184),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4184),
    [anon_sym_POUNDendif] = ACTIONS(4184),
    [anon_sym_POUNDelse] = ACTIONS(4184),
    [sym__newline] = ACTIONS(4184),
  },
  [1744] = {
    [sym_block_comment] = STATE(1744),
    [sym_compiler_directive_decl] = STATE(1744),
    [sym_fsi_directive_decl] = STATE(1744),
    [sym_preproc_line] = STATE(1744),
    [sym_identifier] = ACTIONS(3907),
    [anon_sym_EQ] = ACTIONS(3905),
    [anon_sym_LBRACK_LT] = ACTIONS(3905),
    [anon_sym_COLON] = ACTIONS(3907),
    [anon_sym_return] = ACTIONS(3907),
    [anon_sym_do] = ACTIONS(3907),
    [anon_sym_let] = ACTIONS(3907),
    [anon_sym_let_BANG] = ACTIONS(3905),
    [aux_sym_access_modifier_token1] = ACTIONS(3905),
    [anon_sym_LPAREN] = ACTIONS(3907),
    [anon_sym_COMMA] = ACTIONS(3905),
    [anon_sym_null] = ACTIONS(3907),
    [anon_sym_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_COLON] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3907),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3905),
    [anon_sym_LBRACE] = ACTIONS(3907),
    [anon_sym_LT_AT] = ACTIONS(3907),
    [anon_sym_LT_AT_AT] = ACTIONS(3907),
    [anon_sym_DOT] = ACTIONS(3907),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3905),
    [anon_sym_new] = ACTIONS(3907),
    [anon_sym_with] = ACTIONS(3907),
    [anon_sym_return_BANG] = ACTIONS(3905),
    [anon_sym_yield] = ACTIONS(3907),
    [anon_sym_yield_BANG] = ACTIONS(3905),
    [anon_sym_lazy] = ACTIONS(3907),
    [anon_sym_assert] = ACTIONS(3907),
    [anon_sym_upcast] = ACTIONS(3907),
    [anon_sym_downcast] = ACTIONS(3907),
    [anon_sym_COLON_GT] = ACTIONS(3905),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3905),
    [anon_sym_for] = ACTIONS(3907),
    [anon_sym_while] = ACTIONS(3907),
    [anon_sym_if] = ACTIONS(3907),
    [anon_sym_fun] = ACTIONS(3907),
    [anon_sym_try] = ACTIONS(3907),
    [anon_sym_match] = ACTIONS(3907),
    [anon_sym_match_BANG] = ACTIONS(3905),
    [anon_sym_function] = ACTIONS(3907),
    [anon_sym_LT_DASH] = ACTIONS(3907),
    [anon_sym_DOT_LBRACK] = ACTIONS(3905),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_use] = ACTIONS(3907),
    [anon_sym_use_BANG] = ACTIONS(3905),
    [anon_sym_do_BANG] = ACTIONS(3905),
    [anon_sym_begin] = ACTIONS(3907),
    [anon_sym_LPAREN2] = ACTIONS(3907),
    [anon_sym_default] = ACTIONS(3907),
    [anon_sym_or] = ACTIONS(3907),
    [anon_sym_static] = ACTIONS(3907),
    [anon_sym_member] = ACTIONS(3907),
    [anon_sym_interface] = ACTIONS(3907),
    [anon_sym_abstract] = ACTIONS(3907),
    [anon_sym_val] = ACTIONS(3907),
    [anon_sym_override] = ACTIONS(3907),
    [anon_sym_inherit] = ACTIONS(3907),
    [aux_sym_char_token1] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3907),
    [anon_sym_DQUOTE] = ACTIONS(3907),
    [anon_sym_AT_DQUOTE] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [sym_bool] = ACTIONS(3907),
    [sym_unit] = ACTIONS(3905),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3907),
    [sym_op_identifier] = ACTIONS(3907),
    [anon_sym_PLUS] = ACTIONS(3907),
    [anon_sym_DASH] = ACTIONS(3907),
    [anon_sym_PLUS_DOT] = ACTIONS(3907),
    [anon_sym_DASH_DOT] = ACTIONS(3907),
    [anon_sym_PERCENT] = ACTIONS(3907),
    [anon_sym_AMP_AMP] = ACTIONS(3907),
    [anon_sym_TILDE] = ACTIONS(3905),
    [aux_sym_prefix_op_token1] = ACTIONS(3907),
    [aux_sym_infix_op_token1] = ACTIONS(3905),
    [aux_sym_infix_op_token2] = ACTIONS(3907),
    [anon_sym_PIPE_PIPE] = ACTIONS(3907),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_COLON_EQ] = ACTIONS(3905),
    [anon_sym_DOLLAR] = ACTIONS(3907),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3907),
    [sym_int] = ACTIONS(3907),
    [sym_xint] = ACTIONS(3905),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3905),
    [anon_sym_POUNDendif] = ACTIONS(3905),
    [anon_sym_POUNDelse] = ACTIONS(3905),
    [sym__newline] = ACTIONS(3905),
  },
  [1745] = {
    [sym_block_comment] = STATE(1745),
    [sym_compiler_directive_decl] = STATE(1745),
    [sym_fsi_directive_decl] = STATE(1745),
    [sym_preproc_line] = STATE(1745),
    [sym_identifier] = ACTIONS(4007),
    [anon_sym_EQ] = ACTIONS(4005),
    [anon_sym_LBRACK_LT] = ACTIONS(4005),
    [anon_sym_COLON] = ACTIONS(4007),
    [anon_sym_return] = ACTIONS(4007),
    [anon_sym_do] = ACTIONS(4007),
    [anon_sym_let] = ACTIONS(4007),
    [anon_sym_let_BANG] = ACTIONS(4005),
    [aux_sym_access_modifier_token1] = ACTIONS(4005),
    [anon_sym_LPAREN] = ACTIONS(4007),
    [anon_sym_COMMA] = ACTIONS(4005),
    [anon_sym_null] = ACTIONS(4007),
    [anon_sym_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_COLON] = ACTIONS(4005),
    [anon_sym_AMP] = ACTIONS(4007),
    [anon_sym_LBRACK] = ACTIONS(4007),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4005),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_LT_AT] = ACTIONS(4007),
    [anon_sym_LT_AT_AT] = ACTIONS(4007),
    [anon_sym_DOT] = ACTIONS(4007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4005),
    [anon_sym_new] = ACTIONS(4007),
    [anon_sym_with] = ACTIONS(4007),
    [anon_sym_return_BANG] = ACTIONS(4005),
    [anon_sym_yield] = ACTIONS(4007),
    [anon_sym_yield_BANG] = ACTIONS(4005),
    [anon_sym_lazy] = ACTIONS(4007),
    [anon_sym_assert] = ACTIONS(4007),
    [anon_sym_upcast] = ACTIONS(4007),
    [anon_sym_downcast] = ACTIONS(4007),
    [anon_sym_COLON_GT] = ACTIONS(4005),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4005),
    [anon_sym_for] = ACTIONS(4007),
    [anon_sym_while] = ACTIONS(4007),
    [anon_sym_if] = ACTIONS(4007),
    [anon_sym_fun] = ACTIONS(4007),
    [anon_sym_try] = ACTIONS(4007),
    [anon_sym_match] = ACTIONS(4007),
    [anon_sym_match_BANG] = ACTIONS(4005),
    [anon_sym_function] = ACTIONS(4007),
    [anon_sym_LT_DASH] = ACTIONS(4007),
    [anon_sym_DOT_LBRACK] = ACTIONS(4005),
    [anon_sym_LT] = ACTIONS(4005),
    [anon_sym_use] = ACTIONS(4007),
    [anon_sym_use_BANG] = ACTIONS(4005),
    [anon_sym_do_BANG] = ACTIONS(4005),
    [anon_sym_begin] = ACTIONS(4007),
    [anon_sym_LPAREN2] = ACTIONS(4007),
    [anon_sym_default] = ACTIONS(4007),
    [anon_sym_or] = ACTIONS(4007),
    [anon_sym_static] = ACTIONS(4007),
    [anon_sym_member] = ACTIONS(4007),
    [anon_sym_interface] = ACTIONS(4007),
    [anon_sym_abstract] = ACTIONS(4007),
    [anon_sym_val] = ACTIONS(4007),
    [anon_sym_override] = ACTIONS(4007),
    [anon_sym_inherit] = ACTIONS(4007),
    [aux_sym_char_token1] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4007),
    [anon_sym_DQUOTE] = ACTIONS(4007),
    [anon_sym_AT_DQUOTE] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [sym_bool] = ACTIONS(4007),
    [sym_unit] = ACTIONS(4005),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4007),
    [sym_op_identifier] = ACTIONS(4007),
    [anon_sym_PLUS] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4007),
    [anon_sym_PLUS_DOT] = ACTIONS(4007),
    [anon_sym_DASH_DOT] = ACTIONS(4007),
    [anon_sym_PERCENT] = ACTIONS(4007),
    [anon_sym_AMP_AMP] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4005),
    [aux_sym_prefix_op_token1] = ACTIONS(4007),
    [aux_sym_infix_op_token1] = ACTIONS(4005),
    [aux_sym_infix_op_token2] = ACTIONS(4007),
    [anon_sym_PIPE_PIPE] = ACTIONS(4007),
    [anon_sym_BANG_EQ] = ACTIONS(4007),
    [anon_sym_COLON_EQ] = ACTIONS(4005),
    [anon_sym_DOLLAR] = ACTIONS(4007),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4007),
    [sym_int] = ACTIONS(4007),
    [sym_xint] = ACTIONS(4005),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4005),
    [anon_sym_POUNDendif] = ACTIONS(4005),
    [anon_sym_POUNDelse] = ACTIONS(4005),
    [sym__newline] = ACTIONS(4005),
  },
  [1746] = {
    [sym_block_comment] = STATE(1746),
    [sym_compiler_directive_decl] = STATE(1746),
    [sym_fsi_directive_decl] = STATE(1746),
    [sym_preproc_line] = STATE(1746),
    [sym_identifier] = ACTIONS(3900),
    [anon_sym_EQ] = ACTIONS(3898),
    [anon_sym_LBRACK_LT] = ACTIONS(3898),
    [anon_sym_COLON] = ACTIONS(3900),
    [anon_sym_return] = ACTIONS(3900),
    [anon_sym_do] = ACTIONS(3900),
    [anon_sym_let] = ACTIONS(3900),
    [anon_sym_let_BANG] = ACTIONS(3898),
    [aux_sym_access_modifier_token1] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3898),
    [anon_sym_null] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_COLON] = ACTIONS(3898),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_LBRACK] = ACTIONS(3900),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3898),
    [anon_sym_LBRACE] = ACTIONS(3900),
    [anon_sym_LT_AT] = ACTIONS(3900),
    [anon_sym_LT_AT_AT] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(3900),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3898),
    [anon_sym_new] = ACTIONS(3900),
    [anon_sym_with] = ACTIONS(3900),
    [anon_sym_return_BANG] = ACTIONS(3898),
    [anon_sym_yield] = ACTIONS(3900),
    [anon_sym_yield_BANG] = ACTIONS(3898),
    [anon_sym_lazy] = ACTIONS(3900),
    [anon_sym_assert] = ACTIONS(3900),
    [anon_sym_upcast] = ACTIONS(3900),
    [anon_sym_downcast] = ACTIONS(3900),
    [anon_sym_COLON_GT] = ACTIONS(3898),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3898),
    [anon_sym_for] = ACTIONS(3900),
    [anon_sym_while] = ACTIONS(3900),
    [anon_sym_if] = ACTIONS(3900),
    [anon_sym_fun] = ACTIONS(3900),
    [anon_sym_try] = ACTIONS(3900),
    [anon_sym_match] = ACTIONS(3900),
    [anon_sym_match_BANG] = ACTIONS(3898),
    [anon_sym_function] = ACTIONS(3900),
    [anon_sym_LT_DASH] = ACTIONS(3900),
    [anon_sym_DOT_LBRACK] = ACTIONS(3898),
    [anon_sym_LT] = ACTIONS(3898),
    [anon_sym_use] = ACTIONS(3900),
    [anon_sym_use_BANG] = ACTIONS(3898),
    [anon_sym_do_BANG] = ACTIONS(3898),
    [anon_sym_begin] = ACTIONS(3900),
    [anon_sym_LPAREN2] = ACTIONS(3900),
    [anon_sym_default] = ACTIONS(3900),
    [anon_sym_or] = ACTIONS(3900),
    [anon_sym_static] = ACTIONS(3900),
    [anon_sym_member] = ACTIONS(3900),
    [anon_sym_interface] = ACTIONS(3900),
    [anon_sym_abstract] = ACTIONS(3900),
    [anon_sym_val] = ACTIONS(3900),
    [anon_sym_override] = ACTIONS(3900),
    [anon_sym_inherit] = ACTIONS(3900),
    [aux_sym_char_token1] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3900),
    [anon_sym_DQUOTE] = ACTIONS(3900),
    [anon_sym_AT_DQUOTE] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3898),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3900),
    [sym_op_identifier] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(3900),
    [anon_sym_DASH] = ACTIONS(3900),
    [anon_sym_PLUS_DOT] = ACTIONS(3900),
    [anon_sym_DASH_DOT] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(3900),
    [anon_sym_AMP_AMP] = ACTIONS(3900),
    [anon_sym_TILDE] = ACTIONS(3898),
    [aux_sym_prefix_op_token1] = ACTIONS(3900),
    [aux_sym_infix_op_token1] = ACTIONS(3898),
    [aux_sym_infix_op_token2] = ACTIONS(3900),
    [anon_sym_PIPE_PIPE] = ACTIONS(3900),
    [anon_sym_BANG_EQ] = ACTIONS(3900),
    [anon_sym_COLON_EQ] = ACTIONS(3898),
    [anon_sym_DOLLAR] = ACTIONS(3900),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3900),
    [sym_int] = ACTIONS(3900),
    [sym_xint] = ACTIONS(3898),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3898),
    [anon_sym_POUNDendif] = ACTIONS(3898),
    [anon_sym_POUNDelse] = ACTIONS(3898),
    [sym__newline] = ACTIONS(3898),
  },
  [1747] = {
    [sym_block_comment] = STATE(1747),
    [sym_compiler_directive_decl] = STATE(1747),
    [sym_fsi_directive_decl] = STATE(1747),
    [sym_preproc_line] = STATE(1747),
    [sym_identifier] = ACTIONS(4174),
    [anon_sym_EQ] = ACTIONS(4172),
    [anon_sym_LBRACK_LT] = ACTIONS(4172),
    [anon_sym_COLON] = ACTIONS(4174),
    [anon_sym_return] = ACTIONS(4174),
    [anon_sym_do] = ACTIONS(4174),
    [anon_sym_and] = ACTIONS(4174),
    [anon_sym_let] = ACTIONS(4174),
    [anon_sym_let_BANG] = ACTIONS(4172),
    [aux_sym_access_modifier_token1] = ACTIONS(4172),
    [anon_sym_LPAREN] = ACTIONS(4174),
    [anon_sym_COMMA] = ACTIONS(4172),
    [anon_sym_null] = ACTIONS(4174),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_COLON] = ACTIONS(4172),
    [anon_sym_AMP] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4174),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4172),
    [anon_sym_LBRACE] = ACTIONS(4174),
    [anon_sym_LT_AT] = ACTIONS(4174),
    [anon_sym_LT_AT_AT] = ACTIONS(4174),
    [anon_sym_DOT] = ACTIONS(4174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4172),
    [anon_sym_new] = ACTIONS(4174),
    [anon_sym_with] = ACTIONS(4174),
    [anon_sym_return_BANG] = ACTIONS(4172),
    [anon_sym_yield] = ACTIONS(4174),
    [anon_sym_yield_BANG] = ACTIONS(4172),
    [anon_sym_lazy] = ACTIONS(4174),
    [anon_sym_assert] = ACTIONS(4174),
    [anon_sym_upcast] = ACTIONS(4174),
    [anon_sym_downcast] = ACTIONS(4174),
    [anon_sym_COLON_GT] = ACTIONS(4172),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4172),
    [anon_sym_for] = ACTIONS(4174),
    [anon_sym_while] = ACTIONS(4174),
    [anon_sym_if] = ACTIONS(4174),
    [anon_sym_fun] = ACTIONS(4174),
    [anon_sym_try] = ACTIONS(4174),
    [anon_sym_match] = ACTIONS(4174),
    [anon_sym_match_BANG] = ACTIONS(4172),
    [anon_sym_function] = ACTIONS(4174),
    [anon_sym_LT_DASH] = ACTIONS(4174),
    [anon_sym_DOT_LBRACK] = ACTIONS(4172),
    [anon_sym_LT] = ACTIONS(4172),
    [anon_sym_use] = ACTIONS(4174),
    [anon_sym_use_BANG] = ACTIONS(4172),
    [anon_sym_do_BANG] = ACTIONS(4172),
    [anon_sym_begin] = ACTIONS(4174),
    [anon_sym_LPAREN2] = ACTIONS(4174),
    [anon_sym_default] = ACTIONS(4174),
    [anon_sym_or] = ACTIONS(4174),
    [anon_sym_static] = ACTIONS(4174),
    [anon_sym_member] = ACTIONS(4174),
    [anon_sym_interface] = ACTIONS(4174),
    [anon_sym_abstract] = ACTIONS(4174),
    [anon_sym_val] = ACTIONS(4174),
    [anon_sym_override] = ACTIONS(4174),
    [aux_sym_char_token1] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4174),
    [anon_sym_DQUOTE] = ACTIONS(4174),
    [anon_sym_AT_DQUOTE] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [sym_bool] = ACTIONS(4174),
    [sym_unit] = ACTIONS(4172),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4174),
    [sym_op_identifier] = ACTIONS(4174),
    [anon_sym_PLUS] = ACTIONS(4174),
    [anon_sym_DASH] = ACTIONS(4174),
    [anon_sym_PLUS_DOT] = ACTIONS(4174),
    [anon_sym_DASH_DOT] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [anon_sym_AMP_AMP] = ACTIONS(4174),
    [anon_sym_TILDE] = ACTIONS(4172),
    [aux_sym_prefix_op_token1] = ACTIONS(4174),
    [aux_sym_infix_op_token1] = ACTIONS(4172),
    [aux_sym_infix_op_token2] = ACTIONS(4174),
    [anon_sym_PIPE_PIPE] = ACTIONS(4174),
    [anon_sym_BANG_EQ] = ACTIONS(4174),
    [anon_sym_COLON_EQ] = ACTIONS(4172),
    [anon_sym_DOLLAR] = ACTIONS(4174),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4174),
    [sym_int] = ACTIONS(4174),
    [sym_xint] = ACTIONS(4172),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4172),
    [anon_sym_POUNDendif] = ACTIONS(4172),
    [anon_sym_POUNDelse] = ACTIONS(4172),
    [sym__newline] = ACTIONS(4172),
  },
  [1748] = {
    [sym_block_comment] = STATE(1748),
    [sym_compiler_directive_decl] = STATE(1748),
    [sym_fsi_directive_decl] = STATE(1748),
    [sym_preproc_line] = STATE(1748),
    [sym_identifier] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4246),
    [anon_sym_LBRACK_LT] = ACTIONS(4246),
    [anon_sym_COLON] = ACTIONS(4248),
    [anon_sym_return] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4248),
    [anon_sym_let] = ACTIONS(4248),
    [anon_sym_let_BANG] = ACTIONS(4246),
    [aux_sym_access_modifier_token1] = ACTIONS(4246),
    [anon_sym_LPAREN] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_null] = ACTIONS(4248),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4248),
    [anon_sym_LT_AT] = ACTIONS(4248),
    [anon_sym_LT_AT_AT] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4246),
    [anon_sym_new] = ACTIONS(4248),
    [anon_sym_with] = ACTIONS(4248),
    [anon_sym_return_BANG] = ACTIONS(4246),
    [anon_sym_yield] = ACTIONS(4248),
    [anon_sym_yield_BANG] = ACTIONS(4246),
    [anon_sym_lazy] = ACTIONS(4248),
    [anon_sym_assert] = ACTIONS(4248),
    [anon_sym_upcast] = ACTIONS(4248),
    [anon_sym_downcast] = ACTIONS(4248),
    [anon_sym_COLON_GT] = ACTIONS(4246),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4246),
    [anon_sym_for] = ACTIONS(4248),
    [anon_sym_while] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4248),
    [anon_sym_fun] = ACTIONS(4248),
    [anon_sym_try] = ACTIONS(4248),
    [anon_sym_match] = ACTIONS(4248),
    [anon_sym_match_BANG] = ACTIONS(4246),
    [anon_sym_function] = ACTIONS(4248),
    [anon_sym_LT_DASH] = ACTIONS(4248),
    [anon_sym_DOT_LBRACK] = ACTIONS(4246),
    [anon_sym_LT] = ACTIONS(4246),
    [anon_sym_use] = ACTIONS(4248),
    [anon_sym_use_BANG] = ACTIONS(4246),
    [anon_sym_do_BANG] = ACTIONS(4246),
    [anon_sym_begin] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_default] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4248),
    [anon_sym_static] = ACTIONS(4248),
    [anon_sym_member] = ACTIONS(4248),
    [anon_sym_interface] = ACTIONS(4248),
    [anon_sym_abstract] = ACTIONS(4248),
    [anon_sym_val] = ACTIONS(4248),
    [anon_sym_override] = ACTIONS(4248),
    [anon_sym_inherit] = ACTIONS(4248),
    [aux_sym_char_token1] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4248),
    [anon_sym_DQUOTE] = ACTIONS(4248),
    [anon_sym_AT_DQUOTE] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [sym_bool] = ACTIONS(4248),
    [sym_unit] = ACTIONS(4246),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4248),
    [sym_op_identifier] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_DOT] = ACTIONS(4248),
    [anon_sym_DASH_DOT] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_TILDE] = ACTIONS(4246),
    [aux_sym_prefix_op_token1] = ACTIONS(4248),
    [aux_sym_infix_op_token1] = ACTIONS(4246),
    [aux_sym_infix_op_token2] = ACTIONS(4248),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_COLON_EQ] = ACTIONS(4246),
    [anon_sym_DOLLAR] = ACTIONS(4248),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4248),
    [sym_int] = ACTIONS(4248),
    [sym_xint] = ACTIONS(4246),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4246),
    [anon_sym_POUNDendif] = ACTIONS(4246),
    [anon_sym_POUNDelse] = ACTIONS(4246),
    [sym__newline] = ACTIONS(4246),
  },
  [1749] = {
    [sym_block_comment] = STATE(1749),
    [sym_compiler_directive_decl] = STATE(1749),
    [sym_fsi_directive_decl] = STATE(1749),
    [sym_preproc_line] = STATE(1749),
    [sym_identifier] = ACTIONS(4158),
    [anon_sym_EQ] = ACTIONS(4156),
    [anon_sym_LBRACK_LT] = ACTIONS(4156),
    [anon_sym_COLON] = ACTIONS(4158),
    [anon_sym_return] = ACTIONS(4158),
    [anon_sym_do] = ACTIONS(4158),
    [anon_sym_and] = ACTIONS(4158),
    [anon_sym_let] = ACTIONS(4158),
    [anon_sym_let_BANG] = ACTIONS(4156),
    [aux_sym_access_modifier_token1] = ACTIONS(4156),
    [anon_sym_LPAREN] = ACTIONS(4158),
    [anon_sym_COMMA] = ACTIONS(4156),
    [anon_sym_null] = ACTIONS(4158),
    [anon_sym_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_COLON] = ACTIONS(4156),
    [anon_sym_AMP] = ACTIONS(4158),
    [anon_sym_LBRACK] = ACTIONS(4158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(4158),
    [anon_sym_LT_AT] = ACTIONS(4158),
    [anon_sym_LT_AT_AT] = ACTIONS(4158),
    [anon_sym_DOT] = ACTIONS(4158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4156),
    [anon_sym_new] = ACTIONS(4158),
    [anon_sym_with] = ACTIONS(4158),
    [anon_sym_return_BANG] = ACTIONS(4156),
    [anon_sym_yield] = ACTIONS(4158),
    [anon_sym_yield_BANG] = ACTIONS(4156),
    [anon_sym_lazy] = ACTIONS(4158),
    [anon_sym_assert] = ACTIONS(4158),
    [anon_sym_upcast] = ACTIONS(4158),
    [anon_sym_downcast] = ACTIONS(4158),
    [anon_sym_COLON_GT] = ACTIONS(4156),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4156),
    [anon_sym_for] = ACTIONS(4158),
    [anon_sym_while] = ACTIONS(4158),
    [anon_sym_if] = ACTIONS(4158),
    [anon_sym_fun] = ACTIONS(4158),
    [anon_sym_try] = ACTIONS(4158),
    [anon_sym_match] = ACTIONS(4158),
    [anon_sym_match_BANG] = ACTIONS(4156),
    [anon_sym_function] = ACTIONS(4158),
    [anon_sym_LT_DASH] = ACTIONS(4158),
    [anon_sym_DOT_LBRACK] = ACTIONS(4156),
    [anon_sym_LT] = ACTIONS(4156),
    [anon_sym_use] = ACTIONS(4158),
    [anon_sym_use_BANG] = ACTIONS(4156),
    [anon_sym_do_BANG] = ACTIONS(4156),
    [anon_sym_begin] = ACTIONS(4158),
    [anon_sym_LPAREN2] = ACTIONS(4158),
    [anon_sym_default] = ACTIONS(4158),
    [anon_sym_or] = ACTIONS(4158),
    [anon_sym_static] = ACTIONS(4158),
    [anon_sym_member] = ACTIONS(4158),
    [anon_sym_interface] = ACTIONS(4158),
    [anon_sym_abstract] = ACTIONS(4158),
    [anon_sym_val] = ACTIONS(4158),
    [anon_sym_override] = ACTIONS(4158),
    [aux_sym_char_token1] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4158),
    [anon_sym_DQUOTE] = ACTIONS(4158),
    [anon_sym_AT_DQUOTE] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [sym_bool] = ACTIONS(4158),
    [sym_unit] = ACTIONS(4156),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4158),
    [sym_op_identifier] = ACTIONS(4158),
    [anon_sym_PLUS] = ACTIONS(4158),
    [anon_sym_DASH] = ACTIONS(4158),
    [anon_sym_PLUS_DOT] = ACTIONS(4158),
    [anon_sym_DASH_DOT] = ACTIONS(4158),
    [anon_sym_PERCENT] = ACTIONS(4158),
    [anon_sym_AMP_AMP] = ACTIONS(4158),
    [anon_sym_TILDE] = ACTIONS(4156),
    [aux_sym_prefix_op_token1] = ACTIONS(4158),
    [aux_sym_infix_op_token1] = ACTIONS(4156),
    [aux_sym_infix_op_token2] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE] = ACTIONS(4158),
    [anon_sym_BANG_EQ] = ACTIONS(4158),
    [anon_sym_COLON_EQ] = ACTIONS(4156),
    [anon_sym_DOLLAR] = ACTIONS(4158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4158),
    [sym_int] = ACTIONS(4158),
    [sym_xint] = ACTIONS(4156),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4156),
    [anon_sym_POUNDendif] = ACTIONS(4156),
    [anon_sym_POUNDelse] = ACTIONS(4156),
    [sym__newline] = ACTIONS(4156),
  },
  [1750] = {
    [sym_block_comment] = STATE(1750),
    [sym_compiler_directive_decl] = STATE(1750),
    [sym_fsi_directive_decl] = STATE(1750),
    [sym_preproc_line] = STATE(1750),
    [sym_identifier] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4246),
    [anon_sym_LBRACK_LT] = ACTIONS(4246),
    [anon_sym_COLON] = ACTIONS(4248),
    [anon_sym_return] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4248),
    [anon_sym_and] = ACTIONS(4248),
    [anon_sym_let] = ACTIONS(4248),
    [anon_sym_let_BANG] = ACTIONS(4246),
    [aux_sym_access_modifier_token1] = ACTIONS(4246),
    [anon_sym_LPAREN] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_null] = ACTIONS(4248),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4248),
    [anon_sym_LT_AT] = ACTIONS(4248),
    [anon_sym_LT_AT_AT] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4246),
    [anon_sym_new] = ACTIONS(4248),
    [anon_sym_with] = ACTIONS(4248),
    [anon_sym_return_BANG] = ACTIONS(4246),
    [anon_sym_yield] = ACTIONS(4248),
    [anon_sym_yield_BANG] = ACTIONS(4246),
    [anon_sym_lazy] = ACTIONS(4248),
    [anon_sym_assert] = ACTIONS(4248),
    [anon_sym_upcast] = ACTIONS(4248),
    [anon_sym_downcast] = ACTIONS(4248),
    [anon_sym_COLON_GT] = ACTIONS(4246),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4246),
    [anon_sym_for] = ACTIONS(4248),
    [anon_sym_while] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4248),
    [anon_sym_fun] = ACTIONS(4248),
    [anon_sym_try] = ACTIONS(4248),
    [anon_sym_match] = ACTIONS(4248),
    [anon_sym_match_BANG] = ACTIONS(4246),
    [anon_sym_function] = ACTIONS(4248),
    [anon_sym_LT_DASH] = ACTIONS(4248),
    [anon_sym_DOT_LBRACK] = ACTIONS(4246),
    [anon_sym_LT] = ACTIONS(4246),
    [anon_sym_use] = ACTIONS(4248),
    [anon_sym_use_BANG] = ACTIONS(4246),
    [anon_sym_do_BANG] = ACTIONS(4246),
    [anon_sym_begin] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_default] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4248),
    [anon_sym_static] = ACTIONS(4248),
    [anon_sym_member] = ACTIONS(4248),
    [anon_sym_interface] = ACTIONS(4248),
    [anon_sym_abstract] = ACTIONS(4248),
    [anon_sym_val] = ACTIONS(4248),
    [anon_sym_override] = ACTIONS(4248),
    [aux_sym_char_token1] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4248),
    [anon_sym_DQUOTE] = ACTIONS(4248),
    [anon_sym_AT_DQUOTE] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [sym_bool] = ACTIONS(4248),
    [sym_unit] = ACTIONS(4246),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4248),
    [sym_op_identifier] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_DOT] = ACTIONS(4248),
    [anon_sym_DASH_DOT] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_TILDE] = ACTIONS(4246),
    [aux_sym_prefix_op_token1] = ACTIONS(4248),
    [aux_sym_infix_op_token1] = ACTIONS(4246),
    [aux_sym_infix_op_token2] = ACTIONS(4248),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_COLON_EQ] = ACTIONS(4246),
    [anon_sym_DOLLAR] = ACTIONS(4248),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4248),
    [sym_int] = ACTIONS(4248),
    [sym_xint] = ACTIONS(4246),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4246),
    [anon_sym_POUNDendif] = ACTIONS(4246),
    [anon_sym_POUNDelse] = ACTIONS(4246),
    [sym__newline] = ACTIONS(4246),
  },
  [1751] = {
    [sym_block_comment] = STATE(1751),
    [sym_compiler_directive_decl] = STATE(1751),
    [sym_fsi_directive_decl] = STATE(1751),
    [sym_preproc_line] = STATE(1751),
    [sym_identifier] = ACTIONS(3893),
    [anon_sym_EQ] = ACTIONS(3891),
    [anon_sym_LBRACK_LT] = ACTIONS(3891),
    [anon_sym_COLON] = ACTIONS(3893),
    [anon_sym_return] = ACTIONS(3893),
    [anon_sym_do] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_let_BANG] = ACTIONS(3891),
    [aux_sym_access_modifier_token1] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_COMMA] = ACTIONS(3891),
    [anon_sym_null] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_COLON] = ACTIONS(3891),
    [anon_sym_AMP] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3891),
    [anon_sym_LBRACE] = ACTIONS(3893),
    [anon_sym_LT_AT] = ACTIONS(3893),
    [anon_sym_LT_AT_AT] = ACTIONS(3893),
    [anon_sym_DOT] = ACTIONS(3893),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3891),
    [anon_sym_new] = ACTIONS(3893),
    [anon_sym_with] = ACTIONS(3893),
    [anon_sym_return_BANG] = ACTIONS(3891),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_yield_BANG] = ACTIONS(3891),
    [anon_sym_lazy] = ACTIONS(3893),
    [anon_sym_assert] = ACTIONS(3893),
    [anon_sym_upcast] = ACTIONS(3893),
    [anon_sym_downcast] = ACTIONS(3893),
    [anon_sym_COLON_GT] = ACTIONS(3891),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3891),
    [anon_sym_for] = ACTIONS(3893),
    [anon_sym_while] = ACTIONS(3893),
    [anon_sym_if] = ACTIONS(3893),
    [anon_sym_fun] = ACTIONS(3893),
    [anon_sym_try] = ACTIONS(3893),
    [anon_sym_match] = ACTIONS(3893),
    [anon_sym_match_BANG] = ACTIONS(3891),
    [anon_sym_function] = ACTIONS(3893),
    [anon_sym_LT_DASH] = ACTIONS(3893),
    [anon_sym_DOT_LBRACK] = ACTIONS(3891),
    [anon_sym_LT] = ACTIONS(3891),
    [anon_sym_use] = ACTIONS(3893),
    [anon_sym_use_BANG] = ACTIONS(3891),
    [anon_sym_do_BANG] = ACTIONS(3891),
    [anon_sym_begin] = ACTIONS(3893),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_default] = ACTIONS(3893),
    [anon_sym_or] = ACTIONS(3893),
    [anon_sym_static] = ACTIONS(3893),
    [anon_sym_member] = ACTIONS(3893),
    [anon_sym_interface] = ACTIONS(3893),
    [anon_sym_abstract] = ACTIONS(3893),
    [anon_sym_val] = ACTIONS(3893),
    [anon_sym_override] = ACTIONS(3893),
    [anon_sym_inherit] = ACTIONS(3893),
    [aux_sym_char_token1] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3893),
    [anon_sym_DQUOTE] = ACTIONS(3893),
    [anon_sym_AT_DQUOTE] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [sym_bool] = ACTIONS(3893),
    [sym_unit] = ACTIONS(3891),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3893),
    [sym_op_identifier] = ACTIONS(3893),
    [anon_sym_PLUS] = ACTIONS(3893),
    [anon_sym_DASH] = ACTIONS(3893),
    [anon_sym_PLUS_DOT] = ACTIONS(3893),
    [anon_sym_DASH_DOT] = ACTIONS(3893),
    [anon_sym_PERCENT] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_TILDE] = ACTIONS(3891),
    [aux_sym_prefix_op_token1] = ACTIONS(3893),
    [aux_sym_infix_op_token1] = ACTIONS(3891),
    [aux_sym_infix_op_token2] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [anon_sym_BANG_EQ] = ACTIONS(3893),
    [anon_sym_COLON_EQ] = ACTIONS(3891),
    [anon_sym_DOLLAR] = ACTIONS(3893),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3893),
    [sym_int] = ACTIONS(3893),
    [sym_xint] = ACTIONS(3891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3891),
    [anon_sym_POUNDendif] = ACTIONS(3891),
    [anon_sym_POUNDelse] = ACTIONS(3891),
    [sym__newline] = ACTIONS(3891),
  },
  [1752] = {
    [sym_block_comment] = STATE(1752),
    [sym_compiler_directive_decl] = STATE(1752),
    [sym_fsi_directive_decl] = STATE(1752),
    [sym_preproc_line] = STATE(1752),
    [sym_identifier] = ACTIONS(3875),
    [anon_sym_EQ] = ACTIONS(3873),
    [anon_sym_LBRACK_LT] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(3875),
    [anon_sym_return] = ACTIONS(3875),
    [anon_sym_do] = ACTIONS(3875),
    [anon_sym_let] = ACTIONS(3875),
    [anon_sym_let_BANG] = ACTIONS(3873),
    [aux_sym_access_modifier_token1] = ACTIONS(3873),
    [anon_sym_LPAREN] = ACTIONS(3875),
    [anon_sym_COMMA] = ACTIONS(3873),
    [anon_sym_null] = ACTIONS(3875),
    [anon_sym_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_COLON] = ACTIONS(3873),
    [anon_sym_AMP] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(3875),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3873),
    [anon_sym_LBRACE] = ACTIONS(3875),
    [anon_sym_LT_AT] = ACTIONS(3875),
    [anon_sym_LT_AT_AT] = ACTIONS(3875),
    [anon_sym_DOT] = ACTIONS(3875),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3873),
    [anon_sym_new] = ACTIONS(3875),
    [anon_sym_with] = ACTIONS(3875),
    [anon_sym_return_BANG] = ACTIONS(3873),
    [anon_sym_yield] = ACTIONS(3875),
    [anon_sym_yield_BANG] = ACTIONS(3873),
    [anon_sym_lazy] = ACTIONS(3875),
    [anon_sym_assert] = ACTIONS(3875),
    [anon_sym_upcast] = ACTIONS(3875),
    [anon_sym_downcast] = ACTIONS(3875),
    [anon_sym_COLON_GT] = ACTIONS(3873),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3873),
    [anon_sym_for] = ACTIONS(3875),
    [anon_sym_while] = ACTIONS(3875),
    [anon_sym_if] = ACTIONS(3875),
    [anon_sym_fun] = ACTIONS(3875),
    [anon_sym_try] = ACTIONS(3875),
    [anon_sym_match] = ACTIONS(3875),
    [anon_sym_match_BANG] = ACTIONS(3873),
    [anon_sym_function] = ACTIONS(3875),
    [anon_sym_LT_DASH] = ACTIONS(3875),
    [anon_sym_DOT_LBRACK] = ACTIONS(3873),
    [anon_sym_LT] = ACTIONS(3873),
    [anon_sym_use] = ACTIONS(3875),
    [anon_sym_use_BANG] = ACTIONS(3873),
    [anon_sym_do_BANG] = ACTIONS(3873),
    [anon_sym_begin] = ACTIONS(3875),
    [anon_sym_LPAREN2] = ACTIONS(3875),
    [anon_sym_default] = ACTIONS(3875),
    [anon_sym_or] = ACTIONS(3875),
    [anon_sym_static] = ACTIONS(3875),
    [anon_sym_member] = ACTIONS(3875),
    [anon_sym_interface] = ACTIONS(3875),
    [anon_sym_abstract] = ACTIONS(3875),
    [anon_sym_val] = ACTIONS(3875),
    [anon_sym_override] = ACTIONS(3875),
    [anon_sym_inherit] = ACTIONS(3875),
    [aux_sym_char_token1] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3875),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [anon_sym_AT_DQUOTE] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [sym_bool] = ACTIONS(3875),
    [sym_unit] = ACTIONS(3873),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3875),
    [sym_op_identifier] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS_DOT] = ACTIONS(3875),
    [anon_sym_DASH_DOT] = ACTIONS(3875),
    [anon_sym_PERCENT] = ACTIONS(3875),
    [anon_sym_AMP_AMP] = ACTIONS(3875),
    [anon_sym_TILDE] = ACTIONS(3873),
    [aux_sym_prefix_op_token1] = ACTIONS(3875),
    [aux_sym_infix_op_token1] = ACTIONS(3873),
    [aux_sym_infix_op_token2] = ACTIONS(3875),
    [anon_sym_PIPE_PIPE] = ACTIONS(3875),
    [anon_sym_BANG_EQ] = ACTIONS(3875),
    [anon_sym_COLON_EQ] = ACTIONS(3873),
    [anon_sym_DOLLAR] = ACTIONS(3875),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3875),
    [sym_int] = ACTIONS(3875),
    [sym_xint] = ACTIONS(3873),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3873),
    [anon_sym_POUNDendif] = ACTIONS(3873),
    [anon_sym_POUNDelse] = ACTIONS(3873),
    [sym__newline] = ACTIONS(3873),
  },
  [1753] = {
    [sym_block_comment] = STATE(1753),
    [sym_compiler_directive_decl] = STATE(1753),
    [sym_fsi_directive_decl] = STATE(1753),
    [sym_preproc_line] = STATE(1753),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(3283),
    [anon_sym_uy] = ACTIONS(3285),
    [anon_sym_s] = ACTIONS(3287),
    [anon_sym_us] = ACTIONS(3289),
    [anon_sym_l] = ACTIONS(3291),
    [aux_sym_uint32_token1] = ACTIONS(3293),
    [anon_sym_n] = ACTIONS(3295),
    [anon_sym_un] = ACTIONS(3297),
    [anon_sym_L] = ACTIONS(3299),
    [aux_sym_uint64_token1] = ACTIONS(3301),
    [anon_sym_lf] = ACTIONS(3421),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [anon_sym_POUNDendif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1754] = {
    [sym_block_comment] = STATE(1754),
    [sym_compiler_directive_decl] = STATE(1754),
    [sym_fsi_directive_decl] = STATE(1754),
    [sym_preproc_line] = STATE(1754),
    [sym_identifier] = ACTIONS(4100),
    [anon_sym_EQ] = ACTIONS(4098),
    [anon_sym_LBRACK_LT] = ACTIONS(4098),
    [anon_sym_COLON] = ACTIONS(4100),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_do] = ACTIONS(4100),
    [anon_sym_and] = ACTIONS(4100),
    [anon_sym_let] = ACTIONS(4100),
    [anon_sym_let_BANG] = ACTIONS(4098),
    [aux_sym_access_modifier_token1] = ACTIONS(4098),
    [anon_sym_LPAREN] = ACTIONS(4100),
    [anon_sym_COMMA] = ACTIONS(4098),
    [anon_sym_null] = ACTIONS(4100),
    [anon_sym_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_COLON] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4100),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4098),
    [anon_sym_LBRACE] = ACTIONS(4100),
    [anon_sym_LT_AT] = ACTIONS(4100),
    [anon_sym_LT_AT_AT] = ACTIONS(4100),
    [anon_sym_DOT] = ACTIONS(4100),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4098),
    [anon_sym_new] = ACTIONS(4100),
    [anon_sym_with] = ACTIONS(4100),
    [anon_sym_return_BANG] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4100),
    [anon_sym_yield_BANG] = ACTIONS(4098),
    [anon_sym_lazy] = ACTIONS(4100),
    [anon_sym_assert] = ACTIONS(4100),
    [anon_sym_upcast] = ACTIONS(4100),
    [anon_sym_downcast] = ACTIONS(4100),
    [anon_sym_COLON_GT] = ACTIONS(4098),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4098),
    [anon_sym_for] = ACTIONS(4100),
    [anon_sym_while] = ACTIONS(4100),
    [anon_sym_if] = ACTIONS(4100),
    [anon_sym_fun] = ACTIONS(4100),
    [anon_sym_try] = ACTIONS(4100),
    [anon_sym_match] = ACTIONS(4100),
    [anon_sym_match_BANG] = ACTIONS(4098),
    [anon_sym_function] = ACTIONS(4100),
    [anon_sym_LT_DASH] = ACTIONS(4100),
    [anon_sym_DOT_LBRACK] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(4098),
    [anon_sym_use] = ACTIONS(4100),
    [anon_sym_use_BANG] = ACTIONS(4098),
    [anon_sym_do_BANG] = ACTIONS(4098),
    [anon_sym_begin] = ACTIONS(4100),
    [anon_sym_LPAREN2] = ACTIONS(4100),
    [anon_sym_default] = ACTIONS(4100),
    [anon_sym_or] = ACTIONS(4100),
    [anon_sym_static] = ACTIONS(4100),
    [anon_sym_member] = ACTIONS(4100),
    [anon_sym_interface] = ACTIONS(4100),
    [anon_sym_abstract] = ACTIONS(4100),
    [anon_sym_val] = ACTIONS(4100),
    [anon_sym_override] = ACTIONS(4100),
    [aux_sym_char_token1] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4100),
    [anon_sym_DQUOTE] = ACTIONS(4100),
    [anon_sym_AT_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [sym_bool] = ACTIONS(4100),
    [sym_unit] = ACTIONS(4098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4100),
    [sym_op_identifier] = ACTIONS(4100),
    [anon_sym_PLUS] = ACTIONS(4100),
    [anon_sym_DASH] = ACTIONS(4100),
    [anon_sym_PLUS_DOT] = ACTIONS(4100),
    [anon_sym_DASH_DOT] = ACTIONS(4100),
    [anon_sym_PERCENT] = ACTIONS(4100),
    [anon_sym_AMP_AMP] = ACTIONS(4100),
    [anon_sym_TILDE] = ACTIONS(4098),
    [aux_sym_prefix_op_token1] = ACTIONS(4100),
    [aux_sym_infix_op_token1] = ACTIONS(4098),
    [aux_sym_infix_op_token2] = ACTIONS(4100),
    [anon_sym_PIPE_PIPE] = ACTIONS(4100),
    [anon_sym_BANG_EQ] = ACTIONS(4100),
    [anon_sym_COLON_EQ] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4100),
    [sym_int] = ACTIONS(4100),
    [sym_xint] = ACTIONS(4098),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4098),
    [anon_sym_POUNDendif] = ACTIONS(4098),
    [anon_sym_POUNDelse] = ACTIONS(4098),
    [sym__newline] = ACTIONS(4098),
  },
  [1755] = {
    [sym_block_comment] = STATE(1755),
    [sym_compiler_directive_decl] = STATE(1755),
    [sym_fsi_directive_decl] = STATE(1755),
    [sym_preproc_line] = STATE(1755),
    [sym_identifier] = ACTIONS(3863),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_LBRACK_LT] = ACTIONS(3861),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_let] = ACTIONS(3863),
    [anon_sym_let_BANG] = ACTIONS(3861),
    [aux_sym_access_modifier_token1] = ACTIONS(3861),
    [anon_sym_LPAREN] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3861),
    [anon_sym_null] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_COLON] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_LT_AT] = ACTIONS(3863),
    [anon_sym_LT_AT_AT] = ACTIONS(3863),
    [anon_sym_DOT] = ACTIONS(3863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3861),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_with] = ACTIONS(3863),
    [anon_sym_return_BANG] = ACTIONS(3861),
    [anon_sym_yield] = ACTIONS(3863),
    [anon_sym_yield_BANG] = ACTIONS(3861),
    [anon_sym_lazy] = ACTIONS(3863),
    [anon_sym_assert] = ACTIONS(3863),
    [anon_sym_upcast] = ACTIONS(3863),
    [anon_sym_downcast] = ACTIONS(3863),
    [anon_sym_COLON_GT] = ACTIONS(3861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_fun] = ACTIONS(3863),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_match] = ACTIONS(3863),
    [anon_sym_match_BANG] = ACTIONS(3861),
    [anon_sym_function] = ACTIONS(3863),
    [anon_sym_LT_DASH] = ACTIONS(3863),
    [anon_sym_DOT_LBRACK] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_use] = ACTIONS(3863),
    [anon_sym_use_BANG] = ACTIONS(3861),
    [anon_sym_do_BANG] = ACTIONS(3861),
    [anon_sym_begin] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(3863),
    [anon_sym_default] = ACTIONS(3863),
    [anon_sym_or] = ACTIONS(3863),
    [anon_sym_static] = ACTIONS(3863),
    [anon_sym_member] = ACTIONS(3863),
    [anon_sym_interface] = ACTIONS(3863),
    [anon_sym_abstract] = ACTIONS(3863),
    [anon_sym_val] = ACTIONS(3863),
    [anon_sym_override] = ACTIONS(3863),
    [anon_sym_inherit] = ACTIONS(3863),
    [aux_sym_char_token1] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [anon_sym_AT_DQUOTE] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [sym_bool] = ACTIONS(3863),
    [sym_unit] = ACTIONS(3861),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3863),
    [sym_op_identifier] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_DOT] = ACTIONS(3863),
    [anon_sym_DASH_DOT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3861),
    [aux_sym_prefix_op_token1] = ACTIONS(3863),
    [aux_sym_infix_op_token1] = ACTIONS(3861),
    [aux_sym_infix_op_token2] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_COLON_EQ] = ACTIONS(3861),
    [anon_sym_DOLLAR] = ACTIONS(3863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3863),
    [sym_int] = ACTIONS(3863),
    [sym_xint] = ACTIONS(3861),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3861),
    [anon_sym_POUNDendif] = ACTIONS(3861),
    [anon_sym_POUNDelse] = ACTIONS(3861),
    [sym__newline] = ACTIONS(3861),
  },
  [1756] = {
    [sym_block_comment] = STATE(1756),
    [sym_compiler_directive_decl] = STATE(1756),
    [sym_fsi_directive_decl] = STATE(1756),
    [sym_preproc_line] = STATE(1756),
    [sym_identifier] = ACTIONS(3856),
    [anon_sym_EQ] = ACTIONS(3854),
    [anon_sym_LBRACK_LT] = ACTIONS(3854),
    [anon_sym_COLON] = ACTIONS(3856),
    [anon_sym_return] = ACTIONS(3856),
    [anon_sym_do] = ACTIONS(3856),
    [anon_sym_let] = ACTIONS(3856),
    [anon_sym_let_BANG] = ACTIONS(3854),
    [aux_sym_access_modifier_token1] = ACTIONS(3854),
    [anon_sym_LPAREN] = ACTIONS(3856),
    [anon_sym_COMMA] = ACTIONS(3854),
    [anon_sym_null] = ACTIONS(3856),
    [anon_sym_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_AMP] = ACTIONS(3856),
    [anon_sym_LBRACK] = ACTIONS(3856),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3854),
    [anon_sym_LBRACE] = ACTIONS(3856),
    [anon_sym_LT_AT] = ACTIONS(3856),
    [anon_sym_LT_AT_AT] = ACTIONS(3856),
    [anon_sym_DOT] = ACTIONS(3856),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3854),
    [anon_sym_new] = ACTIONS(3856),
    [anon_sym_with] = ACTIONS(3856),
    [anon_sym_return_BANG] = ACTIONS(3854),
    [anon_sym_yield] = ACTIONS(3856),
    [anon_sym_yield_BANG] = ACTIONS(3854),
    [anon_sym_lazy] = ACTIONS(3856),
    [anon_sym_assert] = ACTIONS(3856),
    [anon_sym_upcast] = ACTIONS(3856),
    [anon_sym_downcast] = ACTIONS(3856),
    [anon_sym_COLON_GT] = ACTIONS(3854),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3854),
    [anon_sym_for] = ACTIONS(3856),
    [anon_sym_while] = ACTIONS(3856),
    [anon_sym_if] = ACTIONS(3856),
    [anon_sym_fun] = ACTIONS(3856),
    [anon_sym_try] = ACTIONS(3856),
    [anon_sym_match] = ACTIONS(3856),
    [anon_sym_match_BANG] = ACTIONS(3854),
    [anon_sym_function] = ACTIONS(3856),
    [anon_sym_LT_DASH] = ACTIONS(3856),
    [anon_sym_DOT_LBRACK] = ACTIONS(3854),
    [anon_sym_LT] = ACTIONS(3854),
    [anon_sym_use] = ACTIONS(3856),
    [anon_sym_use_BANG] = ACTIONS(3854),
    [anon_sym_do_BANG] = ACTIONS(3854),
    [anon_sym_begin] = ACTIONS(3856),
    [anon_sym_LPAREN2] = ACTIONS(3856),
    [anon_sym_default] = ACTIONS(3856),
    [anon_sym_or] = ACTIONS(3856),
    [anon_sym_static] = ACTIONS(3856),
    [anon_sym_member] = ACTIONS(3856),
    [anon_sym_interface] = ACTIONS(3856),
    [anon_sym_abstract] = ACTIONS(3856),
    [anon_sym_val] = ACTIONS(3856),
    [anon_sym_override] = ACTIONS(3856),
    [anon_sym_inherit] = ACTIONS(3856),
    [aux_sym_char_token1] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3856),
    [anon_sym_DQUOTE] = ACTIONS(3856),
    [anon_sym_AT_DQUOTE] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [sym_bool] = ACTIONS(3856),
    [sym_unit] = ACTIONS(3854),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3856),
    [sym_op_identifier] = ACTIONS(3856),
    [anon_sym_PLUS] = ACTIONS(3856),
    [anon_sym_DASH] = ACTIONS(3856),
    [anon_sym_PLUS_DOT] = ACTIONS(3856),
    [anon_sym_DASH_DOT] = ACTIONS(3856),
    [anon_sym_PERCENT] = ACTIONS(3856),
    [anon_sym_AMP_AMP] = ACTIONS(3856),
    [anon_sym_TILDE] = ACTIONS(3854),
    [aux_sym_prefix_op_token1] = ACTIONS(3856),
    [aux_sym_infix_op_token1] = ACTIONS(3854),
    [aux_sym_infix_op_token2] = ACTIONS(3856),
    [anon_sym_PIPE_PIPE] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3856),
    [anon_sym_COLON_EQ] = ACTIONS(3854),
    [anon_sym_DOLLAR] = ACTIONS(3856),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3856),
    [sym_int] = ACTIONS(3856),
    [sym_xint] = ACTIONS(3854),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3854),
    [anon_sym_POUNDendif] = ACTIONS(3854),
    [anon_sym_POUNDelse] = ACTIONS(3854),
    [sym__newline] = ACTIONS(3854),
  },
  [1757] = {
    [sym_block_comment] = STATE(1757),
    [sym_compiler_directive_decl] = STATE(1757),
    [sym_fsi_directive_decl] = STATE(1757),
    [sym_preproc_line] = STATE(1757),
    [sym_identifier] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4242),
    [anon_sym_LBRACK_LT] = ACTIONS(4242),
    [anon_sym_COLON] = ACTIONS(4244),
    [anon_sym_return] = ACTIONS(4244),
    [anon_sym_do] = ACTIONS(4244),
    [anon_sym_and] = ACTIONS(4244),
    [anon_sym_let] = ACTIONS(4244),
    [anon_sym_let_BANG] = ACTIONS(4242),
    [aux_sym_access_modifier_token1] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_null] = ACTIONS(4244),
    [anon_sym_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_COLON] = ACTIONS(4242),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4244),
    [anon_sym_LT_AT] = ACTIONS(4244),
    [anon_sym_LT_AT_AT] = ACTIONS(4244),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4242),
    [anon_sym_new] = ACTIONS(4244),
    [anon_sym_with] = ACTIONS(4244),
    [anon_sym_return_BANG] = ACTIONS(4242),
    [anon_sym_yield] = ACTIONS(4244),
    [anon_sym_yield_BANG] = ACTIONS(4242),
    [anon_sym_lazy] = ACTIONS(4244),
    [anon_sym_assert] = ACTIONS(4244),
    [anon_sym_upcast] = ACTIONS(4244),
    [anon_sym_downcast] = ACTIONS(4244),
    [anon_sym_COLON_GT] = ACTIONS(4242),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4242),
    [anon_sym_for] = ACTIONS(4244),
    [anon_sym_while] = ACTIONS(4244),
    [anon_sym_if] = ACTIONS(4244),
    [anon_sym_fun] = ACTIONS(4244),
    [anon_sym_try] = ACTIONS(4244),
    [anon_sym_match] = ACTIONS(4244),
    [anon_sym_match_BANG] = ACTIONS(4242),
    [anon_sym_function] = ACTIONS(4244),
    [anon_sym_LT_DASH] = ACTIONS(4244),
    [anon_sym_DOT_LBRACK] = ACTIONS(4242),
    [anon_sym_LT] = ACTIONS(4242),
    [anon_sym_use] = ACTIONS(4244),
    [anon_sym_use_BANG] = ACTIONS(4242),
    [anon_sym_do_BANG] = ACTIONS(4242),
    [anon_sym_begin] = ACTIONS(4244),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_default] = ACTIONS(4244),
    [anon_sym_or] = ACTIONS(4244),
    [anon_sym_static] = ACTIONS(4244),
    [anon_sym_member] = ACTIONS(4244),
    [anon_sym_interface] = ACTIONS(4244),
    [anon_sym_abstract] = ACTIONS(4244),
    [anon_sym_val] = ACTIONS(4244),
    [anon_sym_override] = ACTIONS(4244),
    [aux_sym_char_token1] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4244),
    [anon_sym_DQUOTE] = ACTIONS(4244),
    [anon_sym_AT_DQUOTE] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [sym_bool] = ACTIONS(4244),
    [sym_unit] = ACTIONS(4242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4244),
    [sym_op_identifier] = ACTIONS(4244),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_DASH] = ACTIONS(4244),
    [anon_sym_PLUS_DOT] = ACTIONS(4244),
    [anon_sym_DASH_DOT] = ACTIONS(4244),
    [anon_sym_PERCENT] = ACTIONS(4244),
    [anon_sym_AMP_AMP] = ACTIONS(4244),
    [anon_sym_TILDE] = ACTIONS(4242),
    [aux_sym_prefix_op_token1] = ACTIONS(4244),
    [aux_sym_infix_op_token1] = ACTIONS(4242),
    [aux_sym_infix_op_token2] = ACTIONS(4244),
    [anon_sym_PIPE_PIPE] = ACTIONS(4244),
    [anon_sym_BANG_EQ] = ACTIONS(4244),
    [anon_sym_COLON_EQ] = ACTIONS(4242),
    [anon_sym_DOLLAR] = ACTIONS(4244),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4244),
    [sym_int] = ACTIONS(4244),
    [sym_xint] = ACTIONS(4242),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4242),
    [anon_sym_POUNDendif] = ACTIONS(4242),
    [anon_sym_POUNDelse] = ACTIONS(4242),
    [sym__newline] = ACTIONS(4242),
  },
  [1758] = {
    [sym_block_comment] = STATE(1758),
    [sym_compiler_directive_decl] = STATE(1758),
    [sym_fsi_directive_decl] = STATE(1758),
    [sym_preproc_line] = STATE(1758),
    [sym_identifier] = ACTIONS(4240),
    [anon_sym_EQ] = ACTIONS(4238),
    [anon_sym_LBRACK_LT] = ACTIONS(4238),
    [anon_sym_COLON] = ACTIONS(4240),
    [anon_sym_return] = ACTIONS(4240),
    [anon_sym_do] = ACTIONS(4240),
    [anon_sym_and] = ACTIONS(4240),
    [anon_sym_let] = ACTIONS(4240),
    [anon_sym_let_BANG] = ACTIONS(4238),
    [aux_sym_access_modifier_token1] = ACTIONS(4238),
    [anon_sym_LPAREN] = ACTIONS(4240),
    [anon_sym_COMMA] = ACTIONS(4238),
    [anon_sym_null] = ACTIONS(4240),
    [anon_sym_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_COLON] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4240),
    [anon_sym_LBRACK] = ACTIONS(4240),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4238),
    [anon_sym_LBRACE] = ACTIONS(4240),
    [anon_sym_LT_AT] = ACTIONS(4240),
    [anon_sym_LT_AT_AT] = ACTIONS(4240),
    [anon_sym_DOT] = ACTIONS(4240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4238),
    [anon_sym_new] = ACTIONS(4240),
    [anon_sym_with] = ACTIONS(4240),
    [anon_sym_return_BANG] = ACTIONS(4238),
    [anon_sym_yield] = ACTIONS(4240),
    [anon_sym_yield_BANG] = ACTIONS(4238),
    [anon_sym_lazy] = ACTIONS(4240),
    [anon_sym_assert] = ACTIONS(4240),
    [anon_sym_upcast] = ACTIONS(4240),
    [anon_sym_downcast] = ACTIONS(4240),
    [anon_sym_COLON_GT] = ACTIONS(4238),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4238),
    [anon_sym_for] = ACTIONS(4240),
    [anon_sym_while] = ACTIONS(4240),
    [anon_sym_if] = ACTIONS(4240),
    [anon_sym_fun] = ACTIONS(4240),
    [anon_sym_try] = ACTIONS(4240),
    [anon_sym_match] = ACTIONS(4240),
    [anon_sym_match_BANG] = ACTIONS(4238),
    [anon_sym_function] = ACTIONS(4240),
    [anon_sym_LT_DASH] = ACTIONS(4240),
    [anon_sym_DOT_LBRACK] = ACTIONS(4238),
    [anon_sym_LT] = ACTIONS(4238),
    [anon_sym_use] = ACTIONS(4240),
    [anon_sym_use_BANG] = ACTIONS(4238),
    [anon_sym_do_BANG] = ACTIONS(4238),
    [anon_sym_begin] = ACTIONS(4240),
    [anon_sym_LPAREN2] = ACTIONS(4240),
    [anon_sym_default] = ACTIONS(4240),
    [anon_sym_or] = ACTIONS(4240),
    [anon_sym_static] = ACTIONS(4240),
    [anon_sym_member] = ACTIONS(4240),
    [anon_sym_interface] = ACTIONS(4240),
    [anon_sym_abstract] = ACTIONS(4240),
    [anon_sym_val] = ACTIONS(4240),
    [anon_sym_override] = ACTIONS(4240),
    [aux_sym_char_token1] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4240),
    [anon_sym_DQUOTE] = ACTIONS(4240),
    [anon_sym_AT_DQUOTE] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [sym_bool] = ACTIONS(4240),
    [sym_unit] = ACTIONS(4238),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4240),
    [sym_op_identifier] = ACTIONS(4240),
    [anon_sym_PLUS] = ACTIONS(4240),
    [anon_sym_DASH] = ACTIONS(4240),
    [anon_sym_PLUS_DOT] = ACTIONS(4240),
    [anon_sym_DASH_DOT] = ACTIONS(4240),
    [anon_sym_PERCENT] = ACTIONS(4240),
    [anon_sym_AMP_AMP] = ACTIONS(4240),
    [anon_sym_TILDE] = ACTIONS(4238),
    [aux_sym_prefix_op_token1] = ACTIONS(4240),
    [aux_sym_infix_op_token1] = ACTIONS(4238),
    [aux_sym_infix_op_token2] = ACTIONS(4240),
    [anon_sym_PIPE_PIPE] = ACTIONS(4240),
    [anon_sym_BANG_EQ] = ACTIONS(4240),
    [anon_sym_COLON_EQ] = ACTIONS(4238),
    [anon_sym_DOLLAR] = ACTIONS(4240),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4240),
    [sym_int] = ACTIONS(4240),
    [sym_xint] = ACTIONS(4238),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4238),
    [anon_sym_POUNDendif] = ACTIONS(4238),
    [anon_sym_POUNDelse] = ACTIONS(4238),
    [sym__newline] = ACTIONS(4238),
  },
  [1759] = {
    [sym_block_comment] = STATE(1759),
    [sym_compiler_directive_decl] = STATE(1759),
    [sym_fsi_directive_decl] = STATE(1759),
    [sym_preproc_line] = STATE(1759),
    [sym_identifier] = ACTIONS(4208),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LBRACK_LT] = ACTIONS(4206),
    [anon_sym_COLON] = ACTIONS(4208),
    [anon_sym_return] = ACTIONS(4208),
    [anon_sym_do] = ACTIONS(4208),
    [anon_sym_let] = ACTIONS(4208),
    [anon_sym_let_BANG] = ACTIONS(4206),
    [aux_sym_access_modifier_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(4206),
    [anon_sym_null] = ACTIONS(4208),
    [anon_sym_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_COLON] = ACTIONS(4206),
    [anon_sym_AMP] = ACTIONS(4208),
    [anon_sym_LBRACK] = ACTIONS(4208),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4206),
    [anon_sym_LBRACE] = ACTIONS(4208),
    [anon_sym_LT_AT] = ACTIONS(4208),
    [anon_sym_LT_AT_AT] = ACTIONS(4208),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4206),
    [anon_sym_new] = ACTIONS(4208),
    [anon_sym_with] = ACTIONS(4208),
    [anon_sym_return_BANG] = ACTIONS(4206),
    [anon_sym_yield] = ACTIONS(4208),
    [anon_sym_yield_BANG] = ACTIONS(4206),
    [anon_sym_lazy] = ACTIONS(4208),
    [anon_sym_assert] = ACTIONS(4208),
    [anon_sym_upcast] = ACTIONS(4208),
    [anon_sym_downcast] = ACTIONS(4208),
    [anon_sym_COLON_GT] = ACTIONS(4206),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4206),
    [anon_sym_for] = ACTIONS(4208),
    [anon_sym_while] = ACTIONS(4208),
    [anon_sym_if] = ACTIONS(4208),
    [anon_sym_fun] = ACTIONS(4208),
    [anon_sym_try] = ACTIONS(4208),
    [anon_sym_match] = ACTIONS(4208),
    [anon_sym_match_BANG] = ACTIONS(4206),
    [anon_sym_function] = ACTIONS(4208),
    [anon_sym_LT_DASH] = ACTIONS(4208),
    [anon_sym_DOT_LBRACK] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(4206),
    [anon_sym_use] = ACTIONS(4208),
    [anon_sym_use_BANG] = ACTIONS(4206),
    [anon_sym_do_BANG] = ACTIONS(4206),
    [anon_sym_begin] = ACTIONS(4208),
    [anon_sym_LPAREN2] = ACTIONS(4208),
    [anon_sym_default] = ACTIONS(4208),
    [anon_sym_or] = ACTIONS(4208),
    [anon_sym_static] = ACTIONS(4208),
    [anon_sym_member] = ACTIONS(4208),
    [anon_sym_interface] = ACTIONS(4208),
    [anon_sym_abstract] = ACTIONS(4208),
    [anon_sym_val] = ACTIONS(4208),
    [anon_sym_override] = ACTIONS(4208),
    [anon_sym_inherit] = ACTIONS(4208),
    [aux_sym_char_token1] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4208),
    [anon_sym_DQUOTE] = ACTIONS(4208),
    [anon_sym_AT_DQUOTE] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [sym_bool] = ACTIONS(4208),
    [sym_unit] = ACTIONS(4206),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4208),
    [sym_op_identifier] = ACTIONS(4208),
    [anon_sym_PLUS] = ACTIONS(4208),
    [anon_sym_DASH] = ACTIONS(4208),
    [anon_sym_PLUS_DOT] = ACTIONS(4208),
    [anon_sym_DASH_DOT] = ACTIONS(4208),
    [anon_sym_PERCENT] = ACTIONS(4208),
    [anon_sym_AMP_AMP] = ACTIONS(4208),
    [anon_sym_TILDE] = ACTIONS(4206),
    [aux_sym_prefix_op_token1] = ACTIONS(4208),
    [aux_sym_infix_op_token1] = ACTIONS(4206),
    [aux_sym_infix_op_token2] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(4208),
    [anon_sym_BANG_EQ] = ACTIONS(4208),
    [anon_sym_COLON_EQ] = ACTIONS(4206),
    [anon_sym_DOLLAR] = ACTIONS(4208),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4208),
    [sym_int] = ACTIONS(4208),
    [sym_xint] = ACTIONS(4206),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4206),
    [anon_sym_POUNDendif] = ACTIONS(4206),
    [anon_sym_POUNDelse] = ACTIONS(4206),
    [sym__newline] = ACTIONS(4206),
  },
  [1760] = {
    [sym_block_comment] = STATE(1760),
    [sym_compiler_directive_decl] = STATE(1760),
    [sym_fsi_directive_decl] = STATE(1760),
    [sym_preproc_line] = STATE(1760),
    [aux_sym_long_identifier_repeat1] = STATE(1760),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_and] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [aux_sym_access_modifier_token1] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(4679),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_member] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_val] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [anon_sym_POUNDendif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [1761] = {
    [sym_block_comment] = STATE(1761),
    [sym_compiler_directive_decl] = STATE(1761),
    [sym_fsi_directive_decl] = STATE(1761),
    [sym_preproc_line] = STATE(1761),
    [sym_identifier] = ACTIONS(4236),
    [anon_sym_EQ] = ACTIONS(4234),
    [anon_sym_LBRACK_LT] = ACTIONS(4234),
    [anon_sym_COLON] = ACTIONS(4236),
    [anon_sym_return] = ACTIONS(4236),
    [anon_sym_do] = ACTIONS(4236),
    [anon_sym_and] = ACTIONS(4236),
    [anon_sym_let] = ACTIONS(4236),
    [anon_sym_let_BANG] = ACTIONS(4234),
    [aux_sym_access_modifier_token1] = ACTIONS(4234),
    [anon_sym_LPAREN] = ACTIONS(4236),
    [anon_sym_COMMA] = ACTIONS(4234),
    [anon_sym_null] = ACTIONS(4236),
    [anon_sym_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_COLON] = ACTIONS(4234),
    [anon_sym_AMP] = ACTIONS(4236),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4234),
    [anon_sym_LBRACE] = ACTIONS(4236),
    [anon_sym_LT_AT] = ACTIONS(4236),
    [anon_sym_LT_AT_AT] = ACTIONS(4236),
    [anon_sym_DOT] = ACTIONS(4236),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4234),
    [anon_sym_new] = ACTIONS(4236),
    [anon_sym_with] = ACTIONS(4236),
    [anon_sym_return_BANG] = ACTIONS(4234),
    [anon_sym_yield] = ACTIONS(4236),
    [anon_sym_yield_BANG] = ACTIONS(4234),
    [anon_sym_lazy] = ACTIONS(4236),
    [anon_sym_assert] = ACTIONS(4236),
    [anon_sym_upcast] = ACTIONS(4236),
    [anon_sym_downcast] = ACTIONS(4236),
    [anon_sym_COLON_GT] = ACTIONS(4234),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4234),
    [anon_sym_for] = ACTIONS(4236),
    [anon_sym_while] = ACTIONS(4236),
    [anon_sym_if] = ACTIONS(4236),
    [anon_sym_fun] = ACTIONS(4236),
    [anon_sym_try] = ACTIONS(4236),
    [anon_sym_match] = ACTIONS(4236),
    [anon_sym_match_BANG] = ACTIONS(4234),
    [anon_sym_function] = ACTIONS(4236),
    [anon_sym_LT_DASH] = ACTIONS(4236),
    [anon_sym_DOT_LBRACK] = ACTIONS(4234),
    [anon_sym_LT] = ACTIONS(4234),
    [anon_sym_use] = ACTIONS(4236),
    [anon_sym_use_BANG] = ACTIONS(4234),
    [anon_sym_do_BANG] = ACTIONS(4234),
    [anon_sym_begin] = ACTIONS(4236),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_default] = ACTIONS(4236),
    [anon_sym_or] = ACTIONS(4236),
    [anon_sym_static] = ACTIONS(4236),
    [anon_sym_member] = ACTIONS(4236),
    [anon_sym_interface] = ACTIONS(4236),
    [anon_sym_abstract] = ACTIONS(4236),
    [anon_sym_val] = ACTIONS(4236),
    [anon_sym_override] = ACTIONS(4236),
    [aux_sym_char_token1] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4236),
    [anon_sym_DQUOTE] = ACTIONS(4236),
    [anon_sym_AT_DQUOTE] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [sym_bool] = ACTIONS(4236),
    [sym_unit] = ACTIONS(4234),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4236),
    [sym_op_identifier] = ACTIONS(4236),
    [anon_sym_PLUS] = ACTIONS(4236),
    [anon_sym_DASH] = ACTIONS(4236),
    [anon_sym_PLUS_DOT] = ACTIONS(4236),
    [anon_sym_DASH_DOT] = ACTIONS(4236),
    [anon_sym_PERCENT] = ACTIONS(4236),
    [anon_sym_AMP_AMP] = ACTIONS(4236),
    [anon_sym_TILDE] = ACTIONS(4234),
    [aux_sym_prefix_op_token1] = ACTIONS(4236),
    [aux_sym_infix_op_token1] = ACTIONS(4234),
    [aux_sym_infix_op_token2] = ACTIONS(4236),
    [anon_sym_PIPE_PIPE] = ACTIONS(4236),
    [anon_sym_BANG_EQ] = ACTIONS(4236),
    [anon_sym_COLON_EQ] = ACTIONS(4234),
    [anon_sym_DOLLAR] = ACTIONS(4236),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4236),
    [sym_int] = ACTIONS(4236),
    [sym_xint] = ACTIONS(4234),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4234),
    [anon_sym_POUNDendif] = ACTIONS(4234),
    [anon_sym_POUNDelse] = ACTIONS(4234),
    [sym__newline] = ACTIONS(4234),
  },
  [1762] = {
    [sym_block_comment] = STATE(1762),
    [sym_compiler_directive_decl] = STATE(1762),
    [sym_fsi_directive_decl] = STATE(1762),
    [sym_preproc_line] = STATE(1762),
    [sym_identifier] = ACTIONS(4170),
    [anon_sym_EQ] = ACTIONS(4168),
    [anon_sym_LBRACK_LT] = ACTIONS(4168),
    [anon_sym_COLON] = ACTIONS(4170),
    [anon_sym_return] = ACTIONS(4170),
    [anon_sym_do] = ACTIONS(4170),
    [anon_sym_and] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_let_BANG] = ACTIONS(4168),
    [aux_sym_access_modifier_token1] = ACTIONS(4168),
    [anon_sym_LPAREN] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4168),
    [anon_sym_null] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_COLON] = ACTIONS(4168),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4170),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4168),
    [anon_sym_LBRACE] = ACTIONS(4170),
    [anon_sym_LT_AT] = ACTIONS(4170),
    [anon_sym_LT_AT_AT] = ACTIONS(4170),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4168),
    [anon_sym_new] = ACTIONS(4170),
    [anon_sym_with] = ACTIONS(4170),
    [anon_sym_return_BANG] = ACTIONS(4168),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_yield_BANG] = ACTIONS(4168),
    [anon_sym_lazy] = ACTIONS(4170),
    [anon_sym_assert] = ACTIONS(4170),
    [anon_sym_upcast] = ACTIONS(4170),
    [anon_sym_downcast] = ACTIONS(4170),
    [anon_sym_COLON_GT] = ACTIONS(4168),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4168),
    [anon_sym_for] = ACTIONS(4170),
    [anon_sym_while] = ACTIONS(4170),
    [anon_sym_if] = ACTIONS(4170),
    [anon_sym_fun] = ACTIONS(4170),
    [anon_sym_try] = ACTIONS(4170),
    [anon_sym_match] = ACTIONS(4170),
    [anon_sym_match_BANG] = ACTIONS(4168),
    [anon_sym_function] = ACTIONS(4170),
    [anon_sym_LT_DASH] = ACTIONS(4170),
    [anon_sym_DOT_LBRACK] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4168),
    [anon_sym_use] = ACTIONS(4170),
    [anon_sym_use_BANG] = ACTIONS(4168),
    [anon_sym_do_BANG] = ACTIONS(4168),
    [anon_sym_begin] = ACTIONS(4170),
    [anon_sym_LPAREN2] = ACTIONS(4170),
    [anon_sym_default] = ACTIONS(4170),
    [anon_sym_or] = ACTIONS(4170),
    [anon_sym_static] = ACTIONS(4170),
    [anon_sym_member] = ACTIONS(4170),
    [anon_sym_interface] = ACTIONS(4170),
    [anon_sym_abstract] = ACTIONS(4170),
    [anon_sym_val] = ACTIONS(4170),
    [anon_sym_override] = ACTIONS(4170),
    [aux_sym_char_token1] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4170),
    [anon_sym_DQUOTE] = ACTIONS(4170),
    [anon_sym_AT_DQUOTE] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [sym_bool] = ACTIONS(4170),
    [sym_unit] = ACTIONS(4168),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4170),
    [sym_op_identifier] = ACTIONS(4170),
    [anon_sym_PLUS] = ACTIONS(4170),
    [anon_sym_DASH] = ACTIONS(4170),
    [anon_sym_PLUS_DOT] = ACTIONS(4170),
    [anon_sym_DASH_DOT] = ACTIONS(4170),
    [anon_sym_PERCENT] = ACTIONS(4170),
    [anon_sym_AMP_AMP] = ACTIONS(4170),
    [anon_sym_TILDE] = ACTIONS(4168),
    [aux_sym_prefix_op_token1] = ACTIONS(4170),
    [aux_sym_infix_op_token1] = ACTIONS(4168),
    [aux_sym_infix_op_token2] = ACTIONS(4170),
    [anon_sym_PIPE_PIPE] = ACTIONS(4170),
    [anon_sym_BANG_EQ] = ACTIONS(4170),
    [anon_sym_COLON_EQ] = ACTIONS(4168),
    [anon_sym_DOLLAR] = ACTIONS(4170),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4170),
    [sym_int] = ACTIONS(4170),
    [sym_xint] = ACTIONS(4168),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4168),
    [anon_sym_POUNDendif] = ACTIONS(4168),
    [anon_sym_POUNDelse] = ACTIONS(4168),
    [sym__newline] = ACTIONS(4168),
  },
  [1763] = {
    [sym_block_comment] = STATE(1763),
    [sym_compiler_directive_decl] = STATE(1763),
    [sym_fsi_directive_decl] = STATE(1763),
    [sym_preproc_line] = STATE(1763),
    [sym_identifier] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(4076),
    [anon_sym_LBRACK_LT] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4078),
    [anon_sym_return] = ACTIONS(4078),
    [anon_sym_do] = ACTIONS(4078),
    [anon_sym_and] = ACTIONS(4078),
    [anon_sym_let] = ACTIONS(4078),
    [anon_sym_let_BANG] = ACTIONS(4076),
    [aux_sym_access_modifier_token1] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_null] = ACTIONS(4078),
    [anon_sym_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(4076),
    [anon_sym_AMP] = ACTIONS(4078),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4078),
    [anon_sym_LT_AT] = ACTIONS(4078),
    [anon_sym_LT_AT_AT] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(4078),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4076),
    [anon_sym_new] = ACTIONS(4078),
    [anon_sym_with] = ACTIONS(4078),
    [anon_sym_return_BANG] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(4078),
    [anon_sym_yield_BANG] = ACTIONS(4076),
    [anon_sym_lazy] = ACTIONS(4078),
    [anon_sym_assert] = ACTIONS(4078),
    [anon_sym_upcast] = ACTIONS(4078),
    [anon_sym_downcast] = ACTIONS(4078),
    [anon_sym_COLON_GT] = ACTIONS(4076),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4076),
    [anon_sym_for] = ACTIONS(4078),
    [anon_sym_while] = ACTIONS(4078),
    [anon_sym_if] = ACTIONS(4078),
    [anon_sym_fun] = ACTIONS(4078),
    [anon_sym_try] = ACTIONS(4078),
    [anon_sym_match] = ACTIONS(4078),
    [anon_sym_match_BANG] = ACTIONS(4076),
    [anon_sym_function] = ACTIONS(4078),
    [anon_sym_LT_DASH] = ACTIONS(4078),
    [anon_sym_DOT_LBRACK] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4076),
    [anon_sym_use] = ACTIONS(4078),
    [anon_sym_use_BANG] = ACTIONS(4076),
    [anon_sym_do_BANG] = ACTIONS(4076),
    [anon_sym_begin] = ACTIONS(4078),
    [anon_sym_LPAREN2] = ACTIONS(4078),
    [anon_sym_default] = ACTIONS(4078),
    [anon_sym_or] = ACTIONS(4078),
    [anon_sym_static] = ACTIONS(4078),
    [anon_sym_member] = ACTIONS(4078),
    [anon_sym_interface] = ACTIONS(4078),
    [anon_sym_abstract] = ACTIONS(4078),
    [anon_sym_val] = ACTIONS(4078),
    [anon_sym_override] = ACTIONS(4078),
    [aux_sym_char_token1] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4078),
    [anon_sym_DQUOTE] = ACTIONS(4078),
    [anon_sym_AT_DQUOTE] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [sym_bool] = ACTIONS(4078),
    [sym_unit] = ACTIONS(4076),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4078),
    [sym_op_identifier] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(4078),
    [anon_sym_PLUS_DOT] = ACTIONS(4078),
    [anon_sym_DASH_DOT] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [anon_sym_AMP_AMP] = ACTIONS(4078),
    [anon_sym_TILDE] = ACTIONS(4076),
    [aux_sym_prefix_op_token1] = ACTIONS(4078),
    [aux_sym_infix_op_token1] = ACTIONS(4076),
    [aux_sym_infix_op_token2] = ACTIONS(4078),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_BANG_EQ] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4076),
    [anon_sym_DOLLAR] = ACTIONS(4078),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4078),
    [sym_int] = ACTIONS(4078),
    [sym_xint] = ACTIONS(4076),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4076),
    [anon_sym_POUNDendif] = ACTIONS(4076),
    [anon_sym_POUNDelse] = ACTIONS(4076),
    [sym__newline] = ACTIONS(4076),
  },
  [1764] = {
    [sym_block_comment] = STATE(1764),
    [sym_compiler_directive_decl] = STATE(1764),
    [sym_fsi_directive_decl] = STATE(1764),
    [sym_preproc_line] = STATE(1764),
    [sym_identifier] = ACTIONS(4220),
    [anon_sym_EQ] = ACTIONS(4218),
    [anon_sym_LBRACK_LT] = ACTIONS(4218),
    [anon_sym_COLON] = ACTIONS(4220),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_do] = ACTIONS(4220),
    [anon_sym_and] = ACTIONS(4220),
    [anon_sym_let] = ACTIONS(4220),
    [anon_sym_let_BANG] = ACTIONS(4218),
    [aux_sym_access_modifier_token1] = ACTIONS(4218),
    [anon_sym_LPAREN] = ACTIONS(4220),
    [anon_sym_COMMA] = ACTIONS(4218),
    [anon_sym_null] = ACTIONS(4220),
    [anon_sym_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_COLON] = ACTIONS(4218),
    [anon_sym_AMP] = ACTIONS(4220),
    [anon_sym_LBRACK] = ACTIONS(4220),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(4220),
    [anon_sym_LT_AT] = ACTIONS(4220),
    [anon_sym_LT_AT_AT] = ACTIONS(4220),
    [anon_sym_DOT] = ACTIONS(4220),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4218),
    [anon_sym_new] = ACTIONS(4220),
    [anon_sym_with] = ACTIONS(4220),
    [anon_sym_return_BANG] = ACTIONS(4218),
    [anon_sym_yield] = ACTIONS(4220),
    [anon_sym_yield_BANG] = ACTIONS(4218),
    [anon_sym_lazy] = ACTIONS(4220),
    [anon_sym_assert] = ACTIONS(4220),
    [anon_sym_upcast] = ACTIONS(4220),
    [anon_sym_downcast] = ACTIONS(4220),
    [anon_sym_COLON_GT] = ACTIONS(4218),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4218),
    [anon_sym_for] = ACTIONS(4220),
    [anon_sym_while] = ACTIONS(4220),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_fun] = ACTIONS(4220),
    [anon_sym_try] = ACTIONS(4220),
    [anon_sym_match] = ACTIONS(4220),
    [anon_sym_match_BANG] = ACTIONS(4218),
    [anon_sym_function] = ACTIONS(4220),
    [anon_sym_LT_DASH] = ACTIONS(4220),
    [anon_sym_DOT_LBRACK] = ACTIONS(4218),
    [anon_sym_LT] = ACTIONS(4218),
    [anon_sym_use] = ACTIONS(4220),
    [anon_sym_use_BANG] = ACTIONS(4218),
    [anon_sym_do_BANG] = ACTIONS(4218),
    [anon_sym_begin] = ACTIONS(4220),
    [anon_sym_LPAREN2] = ACTIONS(4220),
    [anon_sym_default] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(4220),
    [anon_sym_static] = ACTIONS(4220),
    [anon_sym_member] = ACTIONS(4220),
    [anon_sym_interface] = ACTIONS(4220),
    [anon_sym_abstract] = ACTIONS(4220),
    [anon_sym_val] = ACTIONS(4220),
    [anon_sym_override] = ACTIONS(4220),
    [aux_sym_char_token1] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4220),
    [anon_sym_DQUOTE] = ACTIONS(4220),
    [anon_sym_AT_DQUOTE] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [sym_bool] = ACTIONS(4220),
    [sym_unit] = ACTIONS(4218),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4220),
    [sym_op_identifier] = ACTIONS(4220),
    [anon_sym_PLUS] = ACTIONS(4220),
    [anon_sym_DASH] = ACTIONS(4220),
    [anon_sym_PLUS_DOT] = ACTIONS(4220),
    [anon_sym_DASH_DOT] = ACTIONS(4220),
    [anon_sym_PERCENT] = ACTIONS(4220),
    [anon_sym_AMP_AMP] = ACTIONS(4220),
    [anon_sym_TILDE] = ACTIONS(4218),
    [aux_sym_prefix_op_token1] = ACTIONS(4220),
    [aux_sym_infix_op_token1] = ACTIONS(4218),
    [aux_sym_infix_op_token2] = ACTIONS(4220),
    [anon_sym_PIPE_PIPE] = ACTIONS(4220),
    [anon_sym_BANG_EQ] = ACTIONS(4220),
    [anon_sym_COLON_EQ] = ACTIONS(4218),
    [anon_sym_DOLLAR] = ACTIONS(4220),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4220),
    [sym_int] = ACTIONS(4220),
    [sym_xint] = ACTIONS(4218),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4218),
    [anon_sym_POUNDendif] = ACTIONS(4218),
    [anon_sym_POUNDelse] = ACTIONS(4218),
    [sym__newline] = ACTIONS(4218),
  },
  [1765] = {
    [sym_block_comment] = STATE(1765),
    [sym_compiler_directive_decl] = STATE(1765),
    [sym_fsi_directive_decl] = STATE(1765),
    [sym_preproc_line] = STATE(1765),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_LBRACK_LT] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [aux_sym_access_modifier_token1] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_with] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(4577),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_default] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [anon_sym_static] = ACTIONS(3685),
    [anon_sym_member] = ACTIONS(3685),
    [anon_sym_interface] = ACTIONS(3685),
    [anon_sym_abstract] = ACTIONS(3685),
    [anon_sym_val] = ACTIONS(3685),
    [anon_sym_override] = ACTIONS(3685),
    [anon_sym_inherit] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [anon_sym_POUNDendif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
  },
  [1766] = {
    [sym_block_comment] = STATE(1766),
    [sym_compiler_directive_decl] = STATE(1766),
    [sym_fsi_directive_decl] = STATE(1766),
    [sym_preproc_line] = STATE(1766),
    [sym_identifier] = ACTIONS(4216),
    [anon_sym_EQ] = ACTIONS(4214),
    [anon_sym_LBRACK_LT] = ACTIONS(4214),
    [anon_sym_COLON] = ACTIONS(4216),
    [anon_sym_return] = ACTIONS(4216),
    [anon_sym_do] = ACTIONS(4216),
    [anon_sym_and] = ACTIONS(4216),
    [anon_sym_let] = ACTIONS(4216),
    [anon_sym_let_BANG] = ACTIONS(4214),
    [aux_sym_access_modifier_token1] = ACTIONS(4214),
    [anon_sym_LPAREN] = ACTIONS(4216),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_null] = ACTIONS(4216),
    [anon_sym_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_COLON] = ACTIONS(4214),
    [anon_sym_AMP] = ACTIONS(4216),
    [anon_sym_LBRACK] = ACTIONS(4216),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4214),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_LT_AT] = ACTIONS(4216),
    [anon_sym_LT_AT_AT] = ACTIONS(4216),
    [anon_sym_DOT] = ACTIONS(4216),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4214),
    [anon_sym_new] = ACTIONS(4216),
    [anon_sym_with] = ACTIONS(4216),
    [anon_sym_return_BANG] = ACTIONS(4214),
    [anon_sym_yield] = ACTIONS(4216),
    [anon_sym_yield_BANG] = ACTIONS(4214),
    [anon_sym_lazy] = ACTIONS(4216),
    [anon_sym_assert] = ACTIONS(4216),
    [anon_sym_upcast] = ACTIONS(4216),
    [anon_sym_downcast] = ACTIONS(4216),
    [anon_sym_COLON_GT] = ACTIONS(4214),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4214),
    [anon_sym_for] = ACTIONS(4216),
    [anon_sym_while] = ACTIONS(4216),
    [anon_sym_if] = ACTIONS(4216),
    [anon_sym_fun] = ACTIONS(4216),
    [anon_sym_try] = ACTIONS(4216),
    [anon_sym_match] = ACTIONS(4216),
    [anon_sym_match_BANG] = ACTIONS(4214),
    [anon_sym_function] = ACTIONS(4216),
    [anon_sym_LT_DASH] = ACTIONS(4216),
    [anon_sym_DOT_LBRACK] = ACTIONS(4214),
    [anon_sym_LT] = ACTIONS(4214),
    [anon_sym_use] = ACTIONS(4216),
    [anon_sym_use_BANG] = ACTIONS(4214),
    [anon_sym_do_BANG] = ACTIONS(4214),
    [anon_sym_begin] = ACTIONS(4216),
    [anon_sym_LPAREN2] = ACTIONS(4216),
    [anon_sym_default] = ACTIONS(4216),
    [anon_sym_or] = ACTIONS(4216),
    [anon_sym_static] = ACTIONS(4216),
    [anon_sym_member] = ACTIONS(4216),
    [anon_sym_interface] = ACTIONS(4216),
    [anon_sym_abstract] = ACTIONS(4216),
    [anon_sym_val] = ACTIONS(4216),
    [anon_sym_override] = ACTIONS(4216),
    [aux_sym_char_token1] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4216),
    [anon_sym_DQUOTE] = ACTIONS(4216),
    [anon_sym_AT_DQUOTE] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [sym_bool] = ACTIONS(4216),
    [sym_unit] = ACTIONS(4214),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4216),
    [sym_op_identifier] = ACTIONS(4216),
    [anon_sym_PLUS] = ACTIONS(4216),
    [anon_sym_DASH] = ACTIONS(4216),
    [anon_sym_PLUS_DOT] = ACTIONS(4216),
    [anon_sym_DASH_DOT] = ACTIONS(4216),
    [anon_sym_PERCENT] = ACTIONS(4216),
    [anon_sym_AMP_AMP] = ACTIONS(4216),
    [anon_sym_TILDE] = ACTIONS(4214),
    [aux_sym_prefix_op_token1] = ACTIONS(4216),
    [aux_sym_infix_op_token1] = ACTIONS(4214),
    [aux_sym_infix_op_token2] = ACTIONS(4216),
    [anon_sym_PIPE_PIPE] = ACTIONS(4216),
    [anon_sym_BANG_EQ] = ACTIONS(4216),
    [anon_sym_COLON_EQ] = ACTIONS(4214),
    [anon_sym_DOLLAR] = ACTIONS(4216),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4216),
    [sym_int] = ACTIONS(4216),
    [sym_xint] = ACTIONS(4214),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4214),
    [anon_sym_POUNDendif] = ACTIONS(4214),
    [anon_sym_POUNDelse] = ACTIONS(4214),
    [sym__newline] = ACTIONS(4214),
  },
  [1767] = {
    [sym_block_comment] = STATE(1767),
    [sym_compiler_directive_decl] = STATE(1767),
    [sym_fsi_directive_decl] = STATE(1767),
    [sym_preproc_line] = STATE(1767),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_EQ] = ACTIONS(4199),
    [anon_sym_LBRACK_LT] = ACTIONS(4199),
    [anon_sym_COLON] = ACTIONS(4201),
    [anon_sym_return] = ACTIONS(4201),
    [anon_sym_do] = ACTIONS(4201),
    [anon_sym_and] = ACTIONS(4201),
    [anon_sym_let] = ACTIONS(4201),
    [anon_sym_let_BANG] = ACTIONS(4199),
    [aux_sym_access_modifier_token1] = ACTIONS(4199),
    [anon_sym_LPAREN] = ACTIONS(4201),
    [anon_sym_COMMA] = ACTIONS(4199),
    [anon_sym_null] = ACTIONS(4201),
    [anon_sym_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(4199),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_LBRACK] = ACTIONS(4201),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4199),
    [anon_sym_LBRACE] = ACTIONS(4201),
    [anon_sym_LT_AT] = ACTIONS(4201),
    [anon_sym_LT_AT_AT] = ACTIONS(4201),
    [anon_sym_DOT] = ACTIONS(4201),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4199),
    [anon_sym_new] = ACTIONS(4201),
    [anon_sym_with] = ACTIONS(4201),
    [anon_sym_return_BANG] = ACTIONS(4199),
    [anon_sym_yield] = ACTIONS(4201),
    [anon_sym_yield_BANG] = ACTIONS(4199),
    [anon_sym_lazy] = ACTIONS(4201),
    [anon_sym_assert] = ACTIONS(4201),
    [anon_sym_upcast] = ACTIONS(4201),
    [anon_sym_downcast] = ACTIONS(4201),
    [anon_sym_COLON_GT] = ACTIONS(4199),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4199),
    [anon_sym_for] = ACTIONS(4201),
    [anon_sym_while] = ACTIONS(4201),
    [anon_sym_if] = ACTIONS(4201),
    [anon_sym_fun] = ACTIONS(4201),
    [anon_sym_try] = ACTIONS(4201),
    [anon_sym_match] = ACTIONS(4201),
    [anon_sym_match_BANG] = ACTIONS(4199),
    [anon_sym_function] = ACTIONS(4201),
    [anon_sym_LT_DASH] = ACTIONS(4201),
    [anon_sym_DOT_LBRACK] = ACTIONS(4199),
    [anon_sym_LT] = ACTIONS(4199),
    [anon_sym_use] = ACTIONS(4201),
    [anon_sym_use_BANG] = ACTIONS(4199),
    [anon_sym_do_BANG] = ACTIONS(4199),
    [anon_sym_begin] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(4201),
    [anon_sym_default] = ACTIONS(4201),
    [anon_sym_or] = ACTIONS(4201),
    [anon_sym_static] = ACTIONS(4201),
    [anon_sym_member] = ACTIONS(4201),
    [anon_sym_interface] = ACTIONS(4201),
    [anon_sym_abstract] = ACTIONS(4201),
    [anon_sym_val] = ACTIONS(4201),
    [anon_sym_override] = ACTIONS(4201),
    [aux_sym_char_token1] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4201),
    [anon_sym_DQUOTE] = ACTIONS(4201),
    [anon_sym_AT_DQUOTE] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [sym_bool] = ACTIONS(4201),
    [sym_unit] = ACTIONS(4199),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4201),
    [sym_op_identifier] = ACTIONS(4201),
    [anon_sym_PLUS] = ACTIONS(4201),
    [anon_sym_DASH] = ACTIONS(4201),
    [anon_sym_PLUS_DOT] = ACTIONS(4201),
    [anon_sym_DASH_DOT] = ACTIONS(4201),
    [anon_sym_PERCENT] = ACTIONS(4201),
    [anon_sym_AMP_AMP] = ACTIONS(4201),
    [anon_sym_TILDE] = ACTIONS(4199),
    [aux_sym_prefix_op_token1] = ACTIONS(4201),
    [aux_sym_infix_op_token1] = ACTIONS(4199),
    [aux_sym_infix_op_token2] = ACTIONS(4201),
    [anon_sym_PIPE_PIPE] = ACTIONS(4201),
    [anon_sym_BANG_EQ] = ACTIONS(4201),
    [anon_sym_COLON_EQ] = ACTIONS(4199),
    [anon_sym_DOLLAR] = ACTIONS(4201),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4201),
    [sym_int] = ACTIONS(4201),
    [sym_xint] = ACTIONS(4199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4199),
    [anon_sym_POUNDendif] = ACTIONS(4199),
    [anon_sym_POUNDelse] = ACTIONS(4199),
    [sym__newline] = ACTIONS(4199),
  },
  [1768] = {
    [sym_block_comment] = STATE(1768),
    [sym_compiler_directive_decl] = STATE(1768),
    [sym_fsi_directive_decl] = STATE(1768),
    [sym_preproc_line] = STATE(1768),
    [sym_identifier] = ACTIONS(4197),
    [anon_sym_EQ] = ACTIONS(4195),
    [anon_sym_LBRACK_LT] = ACTIONS(4195),
    [anon_sym_COLON] = ACTIONS(4197),
    [anon_sym_return] = ACTIONS(4197),
    [anon_sym_do] = ACTIONS(4197),
    [anon_sym_and] = ACTIONS(4197),
    [anon_sym_let] = ACTIONS(4197),
    [anon_sym_let_BANG] = ACTIONS(4195),
    [aux_sym_access_modifier_token1] = ACTIONS(4195),
    [anon_sym_LPAREN] = ACTIONS(4197),
    [anon_sym_COMMA] = ACTIONS(4195),
    [anon_sym_null] = ACTIONS(4197),
    [anon_sym_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_COLON] = ACTIONS(4195),
    [anon_sym_AMP] = ACTIONS(4197),
    [anon_sym_LBRACK] = ACTIONS(4197),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4195),
    [anon_sym_LBRACE] = ACTIONS(4197),
    [anon_sym_LT_AT] = ACTIONS(4197),
    [anon_sym_LT_AT_AT] = ACTIONS(4197),
    [anon_sym_DOT] = ACTIONS(4197),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4195),
    [anon_sym_new] = ACTIONS(4197),
    [anon_sym_with] = ACTIONS(4197),
    [anon_sym_return_BANG] = ACTIONS(4195),
    [anon_sym_yield] = ACTIONS(4197),
    [anon_sym_yield_BANG] = ACTIONS(4195),
    [anon_sym_lazy] = ACTIONS(4197),
    [anon_sym_assert] = ACTIONS(4197),
    [anon_sym_upcast] = ACTIONS(4197),
    [anon_sym_downcast] = ACTIONS(4197),
    [anon_sym_COLON_GT] = ACTIONS(4195),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4195),
    [anon_sym_for] = ACTIONS(4197),
    [anon_sym_while] = ACTIONS(4197),
    [anon_sym_if] = ACTIONS(4197),
    [anon_sym_fun] = ACTIONS(4197),
    [anon_sym_try] = ACTIONS(4197),
    [anon_sym_match] = ACTIONS(4197),
    [anon_sym_match_BANG] = ACTIONS(4195),
    [anon_sym_function] = ACTIONS(4197),
    [anon_sym_LT_DASH] = ACTIONS(4197),
    [anon_sym_DOT_LBRACK] = ACTIONS(4195),
    [anon_sym_LT] = ACTIONS(4195),
    [anon_sym_use] = ACTIONS(4197),
    [anon_sym_use_BANG] = ACTIONS(4195),
    [anon_sym_do_BANG] = ACTIONS(4195),
    [anon_sym_begin] = ACTIONS(4197),
    [anon_sym_LPAREN2] = ACTIONS(4197),
    [anon_sym_default] = ACTIONS(4197),
    [anon_sym_or] = ACTIONS(4197),
    [anon_sym_static] = ACTIONS(4197),
    [anon_sym_member] = ACTIONS(4197),
    [anon_sym_interface] = ACTIONS(4197),
    [anon_sym_abstract] = ACTIONS(4197),
    [anon_sym_val] = ACTIONS(4197),
    [anon_sym_override] = ACTIONS(4197),
    [aux_sym_char_token1] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4197),
    [anon_sym_DQUOTE] = ACTIONS(4197),
    [anon_sym_AT_DQUOTE] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [sym_bool] = ACTIONS(4197),
    [sym_unit] = ACTIONS(4195),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4197),
    [sym_op_identifier] = ACTIONS(4197),
    [anon_sym_PLUS] = ACTIONS(4197),
    [anon_sym_DASH] = ACTIONS(4197),
    [anon_sym_PLUS_DOT] = ACTIONS(4197),
    [anon_sym_DASH_DOT] = ACTIONS(4197),
    [anon_sym_PERCENT] = ACTIONS(4197),
    [anon_sym_AMP_AMP] = ACTIONS(4197),
    [anon_sym_TILDE] = ACTIONS(4195),
    [aux_sym_prefix_op_token1] = ACTIONS(4197),
    [aux_sym_infix_op_token1] = ACTIONS(4195),
    [aux_sym_infix_op_token2] = ACTIONS(4197),
    [anon_sym_PIPE_PIPE] = ACTIONS(4197),
    [anon_sym_BANG_EQ] = ACTIONS(4197),
    [anon_sym_COLON_EQ] = ACTIONS(4195),
    [anon_sym_DOLLAR] = ACTIONS(4197),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4197),
    [sym_int] = ACTIONS(4197),
    [sym_xint] = ACTIONS(4195),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4195),
    [anon_sym_POUNDendif] = ACTIONS(4195),
    [anon_sym_POUNDelse] = ACTIONS(4195),
    [sym__newline] = ACTIONS(4195),
  },
  [1769] = {
    [sym_block_comment] = STATE(1769),
    [sym_compiler_directive_decl] = STATE(1769),
    [sym_fsi_directive_decl] = STATE(1769),
    [sym_preproc_line] = STATE(1769),
    [aux_sym_long_identifier_repeat1] = STATE(1760),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_LBRACK_LT] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_and] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [aux_sym_access_modifier_token1] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(4682),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_default] = ACTIONS(3451),
    [anon_sym_or] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_member] = ACTIONS(3451),
    [anon_sym_interface] = ACTIONS(3451),
    [anon_sym_abstract] = ACTIONS(3451),
    [anon_sym_val] = ACTIONS(3451),
    [anon_sym_override] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [anon_sym_POUNDendif] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
  },
  [1770] = {
    [sym_block_comment] = STATE(1770),
    [sym_compiler_directive_decl] = STATE(1770),
    [sym_fsi_directive_decl] = STATE(1770),
    [sym_preproc_line] = STATE(1770),
    [sym_identifier] = ACTIONS(4193),
    [anon_sym_EQ] = ACTIONS(4191),
    [anon_sym_LBRACK_LT] = ACTIONS(4191),
    [anon_sym_COLON] = ACTIONS(4193),
    [anon_sym_return] = ACTIONS(4193),
    [anon_sym_do] = ACTIONS(4193),
    [anon_sym_and] = ACTIONS(4193),
    [anon_sym_let] = ACTIONS(4193),
    [anon_sym_let_BANG] = ACTIONS(4191),
    [aux_sym_access_modifier_token1] = ACTIONS(4191),
    [anon_sym_LPAREN] = ACTIONS(4193),
    [anon_sym_COMMA] = ACTIONS(4191),
    [anon_sym_null] = ACTIONS(4193),
    [anon_sym_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_COLON] = ACTIONS(4191),
    [anon_sym_AMP] = ACTIONS(4193),
    [anon_sym_LBRACK] = ACTIONS(4193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4191),
    [anon_sym_LBRACE] = ACTIONS(4193),
    [anon_sym_LT_AT] = ACTIONS(4193),
    [anon_sym_LT_AT_AT] = ACTIONS(4193),
    [anon_sym_DOT] = ACTIONS(4193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4191),
    [anon_sym_new] = ACTIONS(4193),
    [anon_sym_with] = ACTIONS(4193),
    [anon_sym_return_BANG] = ACTIONS(4191),
    [anon_sym_yield] = ACTIONS(4193),
    [anon_sym_yield_BANG] = ACTIONS(4191),
    [anon_sym_lazy] = ACTIONS(4193),
    [anon_sym_assert] = ACTIONS(4193),
    [anon_sym_upcast] = ACTIONS(4193),
    [anon_sym_downcast] = ACTIONS(4193),
    [anon_sym_COLON_GT] = ACTIONS(4191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4191),
    [anon_sym_for] = ACTIONS(4193),
    [anon_sym_while] = ACTIONS(4193),
    [anon_sym_if] = ACTIONS(4193),
    [anon_sym_fun] = ACTIONS(4193),
    [anon_sym_try] = ACTIONS(4193),
    [anon_sym_match] = ACTIONS(4193),
    [anon_sym_match_BANG] = ACTIONS(4191),
    [anon_sym_function] = ACTIONS(4193),
    [anon_sym_LT_DASH] = ACTIONS(4193),
    [anon_sym_DOT_LBRACK] = ACTIONS(4191),
    [anon_sym_LT] = ACTIONS(4191),
    [anon_sym_use] = ACTIONS(4193),
    [anon_sym_use_BANG] = ACTIONS(4191),
    [anon_sym_do_BANG] = ACTIONS(4191),
    [anon_sym_begin] = ACTIONS(4193),
    [anon_sym_LPAREN2] = ACTIONS(4193),
    [anon_sym_default] = ACTIONS(4193),
    [anon_sym_or] = ACTIONS(4193),
    [anon_sym_static] = ACTIONS(4193),
    [anon_sym_member] = ACTIONS(4193),
    [anon_sym_interface] = ACTIONS(4193),
    [anon_sym_abstract] = ACTIONS(4193),
    [anon_sym_val] = ACTIONS(4193),
    [anon_sym_override] = ACTIONS(4193),
    [aux_sym_char_token1] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4193),
    [anon_sym_DQUOTE] = ACTIONS(4193),
    [anon_sym_AT_DQUOTE] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [sym_bool] = ACTIONS(4193),
    [sym_unit] = ACTIONS(4191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4193),
    [sym_op_identifier] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4193),
    [anon_sym_DASH] = ACTIONS(4193),
    [anon_sym_PLUS_DOT] = ACTIONS(4193),
    [anon_sym_DASH_DOT] = ACTIONS(4193),
    [anon_sym_PERCENT] = ACTIONS(4193),
    [anon_sym_AMP_AMP] = ACTIONS(4193),
    [anon_sym_TILDE] = ACTIONS(4191),
    [aux_sym_prefix_op_token1] = ACTIONS(4193),
    [aux_sym_infix_op_token1] = ACTIONS(4191),
    [aux_sym_infix_op_token2] = ACTIONS(4193),
    [anon_sym_PIPE_PIPE] = ACTIONS(4193),
    [anon_sym_BANG_EQ] = ACTIONS(4193),
    [anon_sym_COLON_EQ] = ACTIONS(4191),
    [anon_sym_DOLLAR] = ACTIONS(4193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4193),
    [sym_int] = ACTIONS(4193),
    [sym_xint] = ACTIONS(4191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4191),
    [anon_sym_POUNDendif] = ACTIONS(4191),
    [anon_sym_POUNDelse] = ACTIONS(4191),
    [sym__newline] = ACTIONS(4191),
  },
  [1771] = {
    [sym_block_comment] = STATE(1771),
    [sym_compiler_directive_decl] = STATE(1771),
    [sym_fsi_directive_decl] = STATE(1771),
    [sym_preproc_line] = STATE(1771),
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_EQ] = ACTIONS(4149),
    [anon_sym_LBRACK_LT] = ACTIONS(4149),
    [anon_sym_COLON] = ACTIONS(4151),
    [anon_sym_return] = ACTIONS(4151),
    [anon_sym_do] = ACTIONS(4151),
    [anon_sym_and] = ACTIONS(4151),
    [anon_sym_let] = ACTIONS(4151),
    [anon_sym_let_BANG] = ACTIONS(4149),
    [aux_sym_access_modifier_token1] = ACTIONS(4149),
    [anon_sym_LPAREN] = ACTIONS(4151),
    [anon_sym_COMMA] = ACTIONS(4149),
    [anon_sym_null] = ACTIONS(4151),
    [anon_sym_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_AMP] = ACTIONS(4151),
    [anon_sym_LBRACK] = ACTIONS(4151),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4149),
    [anon_sym_LBRACE] = ACTIONS(4151),
    [anon_sym_LT_AT] = ACTIONS(4151),
    [anon_sym_LT_AT_AT] = ACTIONS(4151),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4149),
    [anon_sym_new] = ACTIONS(4151),
    [anon_sym_with] = ACTIONS(4151),
    [anon_sym_return_BANG] = ACTIONS(4149),
    [anon_sym_yield] = ACTIONS(4151),
    [anon_sym_yield_BANG] = ACTIONS(4149),
    [anon_sym_lazy] = ACTIONS(4151),
    [anon_sym_assert] = ACTIONS(4151),
    [anon_sym_upcast] = ACTIONS(4151),
    [anon_sym_downcast] = ACTIONS(4151),
    [anon_sym_COLON_GT] = ACTIONS(4149),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4149),
    [anon_sym_for] = ACTIONS(4151),
    [anon_sym_while] = ACTIONS(4151),
    [anon_sym_if] = ACTIONS(4151),
    [anon_sym_fun] = ACTIONS(4151),
    [anon_sym_try] = ACTIONS(4151),
    [anon_sym_match] = ACTIONS(4151),
    [anon_sym_match_BANG] = ACTIONS(4149),
    [anon_sym_function] = ACTIONS(4151),
    [anon_sym_LT_DASH] = ACTIONS(4151),
    [anon_sym_DOT_LBRACK] = ACTIONS(4149),
    [anon_sym_LT] = ACTIONS(4149),
    [anon_sym_use] = ACTIONS(4151),
    [anon_sym_use_BANG] = ACTIONS(4149),
    [anon_sym_do_BANG] = ACTIONS(4149),
    [anon_sym_begin] = ACTIONS(4151),
    [anon_sym_LPAREN2] = ACTIONS(4151),
    [anon_sym_default] = ACTIONS(4151),
    [anon_sym_or] = ACTIONS(4151),
    [anon_sym_static] = ACTIONS(4151),
    [anon_sym_member] = ACTIONS(4151),
    [anon_sym_interface] = ACTIONS(4151),
    [anon_sym_abstract] = ACTIONS(4151),
    [anon_sym_val] = ACTIONS(4151),
    [anon_sym_override] = ACTIONS(4151),
    [aux_sym_char_token1] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4151),
    [anon_sym_DQUOTE] = ACTIONS(4151),
    [anon_sym_AT_DQUOTE] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [sym_bool] = ACTIONS(4151),
    [sym_unit] = ACTIONS(4149),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4151),
    [sym_op_identifier] = ACTIONS(4151),
    [anon_sym_PLUS] = ACTIONS(4151),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_PLUS_DOT] = ACTIONS(4151),
    [anon_sym_DASH_DOT] = ACTIONS(4151),
    [anon_sym_PERCENT] = ACTIONS(4151),
    [anon_sym_AMP_AMP] = ACTIONS(4151),
    [anon_sym_TILDE] = ACTIONS(4149),
    [aux_sym_prefix_op_token1] = ACTIONS(4151),
    [aux_sym_infix_op_token1] = ACTIONS(4149),
    [aux_sym_infix_op_token2] = ACTIONS(4151),
    [anon_sym_PIPE_PIPE] = ACTIONS(4151),
    [anon_sym_BANG_EQ] = ACTIONS(4151),
    [anon_sym_COLON_EQ] = ACTIONS(4149),
    [anon_sym_DOLLAR] = ACTIONS(4151),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4151),
    [sym_int] = ACTIONS(4151),
    [sym_xint] = ACTIONS(4149),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4149),
    [anon_sym_POUNDendif] = ACTIONS(4149),
    [anon_sym_POUNDelse] = ACTIONS(4149),
    [sym__newline] = ACTIONS(4149),
  },
  [1772] = {
    [sym_block_comment] = STATE(1772),
    [sym_compiler_directive_decl] = STATE(1772),
    [sym_fsi_directive_decl] = STATE(1772),
    [sym_preproc_line] = STATE(1772),
    [sym_identifier] = ACTIONS(4147),
    [anon_sym_EQ] = ACTIONS(4145),
    [anon_sym_LBRACK_LT] = ACTIONS(4145),
    [anon_sym_COLON] = ACTIONS(4147),
    [anon_sym_return] = ACTIONS(4147),
    [anon_sym_do] = ACTIONS(4147),
    [anon_sym_and] = ACTIONS(4147),
    [anon_sym_let] = ACTIONS(4147),
    [anon_sym_let_BANG] = ACTIONS(4145),
    [aux_sym_access_modifier_token1] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(4147),
    [anon_sym_COMMA] = ACTIONS(4145),
    [anon_sym_null] = ACTIONS(4147),
    [anon_sym_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_COLON] = ACTIONS(4145),
    [anon_sym_AMP] = ACTIONS(4147),
    [anon_sym_LBRACK] = ACTIONS(4147),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4145),
    [anon_sym_LBRACE] = ACTIONS(4147),
    [anon_sym_LT_AT] = ACTIONS(4147),
    [anon_sym_LT_AT_AT] = ACTIONS(4147),
    [anon_sym_DOT] = ACTIONS(4147),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4145),
    [anon_sym_new] = ACTIONS(4147),
    [anon_sym_with] = ACTIONS(4147),
    [anon_sym_return_BANG] = ACTIONS(4145),
    [anon_sym_yield] = ACTIONS(4147),
    [anon_sym_yield_BANG] = ACTIONS(4145),
    [anon_sym_lazy] = ACTIONS(4147),
    [anon_sym_assert] = ACTIONS(4147),
    [anon_sym_upcast] = ACTIONS(4147),
    [anon_sym_downcast] = ACTIONS(4147),
    [anon_sym_COLON_GT] = ACTIONS(4145),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4145),
    [anon_sym_for] = ACTIONS(4147),
    [anon_sym_while] = ACTIONS(4147),
    [anon_sym_if] = ACTIONS(4147),
    [anon_sym_fun] = ACTIONS(4147),
    [anon_sym_try] = ACTIONS(4147),
    [anon_sym_match] = ACTIONS(4147),
    [anon_sym_match_BANG] = ACTIONS(4145),
    [anon_sym_function] = ACTIONS(4147),
    [anon_sym_LT_DASH] = ACTIONS(4147),
    [anon_sym_DOT_LBRACK] = ACTIONS(4145),
    [anon_sym_LT] = ACTIONS(4145),
    [anon_sym_use] = ACTIONS(4147),
    [anon_sym_use_BANG] = ACTIONS(4145),
    [anon_sym_do_BANG] = ACTIONS(4145),
    [anon_sym_begin] = ACTIONS(4147),
    [anon_sym_LPAREN2] = ACTIONS(4147),
    [anon_sym_default] = ACTIONS(4147),
    [anon_sym_or] = ACTIONS(4147),
    [anon_sym_static] = ACTIONS(4147),
    [anon_sym_member] = ACTIONS(4147),
    [anon_sym_interface] = ACTIONS(4147),
    [anon_sym_abstract] = ACTIONS(4147),
    [anon_sym_val] = ACTIONS(4147),
    [anon_sym_override] = ACTIONS(4147),
    [aux_sym_char_token1] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4147),
    [anon_sym_DQUOTE] = ACTIONS(4147),
    [anon_sym_AT_DQUOTE] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [sym_bool] = ACTIONS(4147),
    [sym_unit] = ACTIONS(4145),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4147),
    [sym_op_identifier] = ACTIONS(4147),
    [anon_sym_PLUS] = ACTIONS(4147),
    [anon_sym_DASH] = ACTIONS(4147),
    [anon_sym_PLUS_DOT] = ACTIONS(4147),
    [anon_sym_DASH_DOT] = ACTIONS(4147),
    [anon_sym_PERCENT] = ACTIONS(4147),
    [anon_sym_AMP_AMP] = ACTIONS(4147),
    [anon_sym_TILDE] = ACTIONS(4145),
    [aux_sym_prefix_op_token1] = ACTIONS(4147),
    [aux_sym_infix_op_token1] = ACTIONS(4145),
    [aux_sym_infix_op_token2] = ACTIONS(4147),
    [anon_sym_PIPE_PIPE] = ACTIONS(4147),
    [anon_sym_BANG_EQ] = ACTIONS(4147),
    [anon_sym_COLON_EQ] = ACTIONS(4145),
    [anon_sym_DOLLAR] = ACTIONS(4147),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4147),
    [sym_int] = ACTIONS(4147),
    [sym_xint] = ACTIONS(4145),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4145),
    [anon_sym_POUNDendif] = ACTIONS(4145),
    [anon_sym_POUNDelse] = ACTIONS(4145),
    [sym__newline] = ACTIONS(4145),
  },
  [1773] = {
    [sym_block_comment] = STATE(1773),
    [sym_compiler_directive_decl] = STATE(1773),
    [sym_fsi_directive_decl] = STATE(1773),
    [sym_preproc_line] = STATE(1773),
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_EQ] = ACTIONS(3990),
    [anon_sym_LBRACK_LT] = ACTIONS(3990),
    [anon_sym_COLON] = ACTIONS(3992),
    [anon_sym_return] = ACTIONS(3992),
    [anon_sym_do] = ACTIONS(3992),
    [anon_sym_and] = ACTIONS(3992),
    [anon_sym_let] = ACTIONS(3992),
    [anon_sym_let_BANG] = ACTIONS(3990),
    [aux_sym_access_modifier_token1] = ACTIONS(3990),
    [anon_sym_LPAREN] = ACTIONS(3992),
    [anon_sym_COMMA] = ACTIONS(3990),
    [anon_sym_null] = ACTIONS(3992),
    [anon_sym_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [anon_sym_AMP] = ACTIONS(3992),
    [anon_sym_LBRACK] = ACTIONS(3992),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3990),
    [anon_sym_LBRACE] = ACTIONS(3992),
    [anon_sym_LT_AT] = ACTIONS(3992),
    [anon_sym_LT_AT_AT] = ACTIONS(3992),
    [anon_sym_DOT] = ACTIONS(3992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3990),
    [anon_sym_new] = ACTIONS(3992),
    [anon_sym_with] = ACTIONS(3992),
    [anon_sym_return_BANG] = ACTIONS(3990),
    [anon_sym_yield] = ACTIONS(3992),
    [anon_sym_yield_BANG] = ACTIONS(3990),
    [anon_sym_lazy] = ACTIONS(3992),
    [anon_sym_assert] = ACTIONS(3992),
    [anon_sym_upcast] = ACTIONS(3992),
    [anon_sym_downcast] = ACTIONS(3992),
    [anon_sym_COLON_GT] = ACTIONS(3990),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3990),
    [anon_sym_for] = ACTIONS(3992),
    [anon_sym_while] = ACTIONS(3992),
    [anon_sym_if] = ACTIONS(3992),
    [anon_sym_fun] = ACTIONS(3992),
    [anon_sym_try] = ACTIONS(3992),
    [anon_sym_match] = ACTIONS(3992),
    [anon_sym_match_BANG] = ACTIONS(3990),
    [anon_sym_function] = ACTIONS(3992),
    [anon_sym_LT_DASH] = ACTIONS(3992),
    [anon_sym_DOT_LBRACK] = ACTIONS(3990),
    [anon_sym_LT] = ACTIONS(3990),
    [anon_sym_use] = ACTIONS(3992),
    [anon_sym_use_BANG] = ACTIONS(3990),
    [anon_sym_do_BANG] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_LPAREN2] = ACTIONS(3992),
    [anon_sym_default] = ACTIONS(3992),
    [anon_sym_or] = ACTIONS(3992),
    [anon_sym_static] = ACTIONS(3992),
    [anon_sym_member] = ACTIONS(3992),
    [anon_sym_interface] = ACTIONS(3992),
    [anon_sym_abstract] = ACTIONS(3992),
    [anon_sym_val] = ACTIONS(3992),
    [anon_sym_override] = ACTIONS(3992),
    [aux_sym_char_token1] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3992),
    [anon_sym_DQUOTE] = ACTIONS(3992),
    [anon_sym_AT_DQUOTE] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [sym_bool] = ACTIONS(3992),
    [sym_unit] = ACTIONS(3990),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3992),
    [sym_op_identifier] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3992),
    [anon_sym_DASH] = ACTIONS(3992),
    [anon_sym_PLUS_DOT] = ACTIONS(3992),
    [anon_sym_DASH_DOT] = ACTIONS(3992),
    [anon_sym_PERCENT] = ACTIONS(3992),
    [anon_sym_AMP_AMP] = ACTIONS(3992),
    [anon_sym_TILDE] = ACTIONS(3990),
    [aux_sym_prefix_op_token1] = ACTIONS(3992),
    [aux_sym_infix_op_token1] = ACTIONS(3990),
    [aux_sym_infix_op_token2] = ACTIONS(3992),
    [anon_sym_PIPE_PIPE] = ACTIONS(3992),
    [anon_sym_BANG_EQ] = ACTIONS(3992),
    [anon_sym_COLON_EQ] = ACTIONS(3990),
    [anon_sym_DOLLAR] = ACTIONS(3992),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3992),
    [sym_int] = ACTIONS(3992),
    [sym_xint] = ACTIONS(3990),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3990),
    [anon_sym_POUNDendif] = ACTIONS(3990),
    [anon_sym_POUNDelse] = ACTIONS(3990),
    [sym__newline] = ACTIONS(3990),
  },
  [1774] = {
    [sym_block_comment] = STATE(1774),
    [sym_compiler_directive_decl] = STATE(1774),
    [sym_fsi_directive_decl] = STATE(1774),
    [sym_preproc_line] = STATE(1774),
    [sym_identifier] = ACTIONS(4137),
    [anon_sym_EQ] = ACTIONS(4135),
    [anon_sym_LBRACK_LT] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4137),
    [anon_sym_return] = ACTIONS(4137),
    [anon_sym_do] = ACTIONS(4137),
    [anon_sym_let] = ACTIONS(4137),
    [anon_sym_let_BANG] = ACTIONS(4135),
    [aux_sym_access_modifier_token1] = ACTIONS(4135),
    [anon_sym_LPAREN] = ACTIONS(4137),
    [anon_sym_COMMA] = ACTIONS(4135),
    [anon_sym_null] = ACTIONS(4137),
    [anon_sym_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_COLON] = ACTIONS(4135),
    [anon_sym_AMP] = ACTIONS(4137),
    [anon_sym_LBRACK] = ACTIONS(4137),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4135),
    [anon_sym_LBRACE] = ACTIONS(4137),
    [anon_sym_LT_AT] = ACTIONS(4137),
    [anon_sym_LT_AT_AT] = ACTIONS(4137),
    [anon_sym_DOT] = ACTIONS(4137),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4135),
    [anon_sym_new] = ACTIONS(4137),
    [anon_sym_with] = ACTIONS(4137),
    [anon_sym_return_BANG] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_yield_BANG] = ACTIONS(4135),
    [anon_sym_lazy] = ACTIONS(4137),
    [anon_sym_assert] = ACTIONS(4137),
    [anon_sym_upcast] = ACTIONS(4137),
    [anon_sym_downcast] = ACTIONS(4137),
    [anon_sym_COLON_GT] = ACTIONS(4135),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4135),
    [anon_sym_for] = ACTIONS(4137),
    [anon_sym_while] = ACTIONS(4137),
    [anon_sym_if] = ACTIONS(4137),
    [anon_sym_fun] = ACTIONS(4137),
    [anon_sym_try] = ACTIONS(4137),
    [anon_sym_match] = ACTIONS(4137),
    [anon_sym_match_BANG] = ACTIONS(4135),
    [anon_sym_function] = ACTIONS(4137),
    [anon_sym_LT_DASH] = ACTIONS(4137),
    [anon_sym_DOT_LBRACK] = ACTIONS(4135),
    [anon_sym_LT] = ACTIONS(4135),
    [anon_sym_use] = ACTIONS(4137),
    [anon_sym_use_BANG] = ACTIONS(4135),
    [anon_sym_do_BANG] = ACTIONS(4135),
    [anon_sym_begin] = ACTIONS(4137),
    [anon_sym_LPAREN2] = ACTIONS(4137),
    [anon_sym_default] = ACTIONS(4137),
    [anon_sym_or] = ACTIONS(4137),
    [anon_sym_static] = ACTIONS(4137),
    [anon_sym_member] = ACTIONS(4137),
    [anon_sym_interface] = ACTIONS(4137),
    [anon_sym_abstract] = ACTIONS(4137),
    [anon_sym_val] = ACTIONS(4137),
    [anon_sym_override] = ACTIONS(4137),
    [anon_sym_inherit] = ACTIONS(4137),
    [aux_sym_char_token1] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4137),
    [anon_sym_DQUOTE] = ACTIONS(4137),
    [anon_sym_AT_DQUOTE] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [sym_bool] = ACTIONS(4137),
    [sym_unit] = ACTIONS(4135),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4137),
    [sym_op_identifier] = ACTIONS(4137),
    [anon_sym_PLUS] = ACTIONS(4137),
    [anon_sym_DASH] = ACTIONS(4137),
    [anon_sym_PLUS_DOT] = ACTIONS(4137),
    [anon_sym_DASH_DOT] = ACTIONS(4137),
    [anon_sym_PERCENT] = ACTIONS(4137),
    [anon_sym_AMP_AMP] = ACTIONS(4137),
    [anon_sym_TILDE] = ACTIONS(4135),
    [aux_sym_prefix_op_token1] = ACTIONS(4137),
    [aux_sym_infix_op_token1] = ACTIONS(4135),
    [aux_sym_infix_op_token2] = ACTIONS(4137),
    [anon_sym_PIPE_PIPE] = ACTIONS(4137),
    [anon_sym_BANG_EQ] = ACTIONS(4137),
    [anon_sym_COLON_EQ] = ACTIONS(4135),
    [anon_sym_DOLLAR] = ACTIONS(4137),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4137),
    [sym_int] = ACTIONS(4137),
    [sym_xint] = ACTIONS(4135),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4135),
    [anon_sym_POUNDendif] = ACTIONS(4135),
    [anon_sym_POUNDelse] = ACTIONS(4135),
    [sym__newline] = ACTIONS(4135),
  },
  [1775] = {
    [sym_block_comment] = STATE(1775),
    [sym_compiler_directive_decl] = STATE(1775),
    [sym_fsi_directive_decl] = STATE(1775),
    [sym_preproc_line] = STATE(1775),
    [sym_identifier] = ACTIONS(3976),
    [anon_sym_EQ] = ACTIONS(3974),
    [anon_sym_LBRACK_LT] = ACTIONS(3974),
    [anon_sym_COLON] = ACTIONS(3976),
    [anon_sym_return] = ACTIONS(3976),
    [anon_sym_do] = ACTIONS(3976),
    [anon_sym_and] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_let_BANG] = ACTIONS(3974),
    [aux_sym_access_modifier_token1] = ACTIONS(3974),
    [anon_sym_LPAREN] = ACTIONS(3976),
    [anon_sym_COMMA] = ACTIONS(3974),
    [anon_sym_null] = ACTIONS(3976),
    [anon_sym_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_COLON] = ACTIONS(3974),
    [anon_sym_AMP] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(3976),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3974),
    [anon_sym_LBRACE] = ACTIONS(3976),
    [anon_sym_LT_AT] = ACTIONS(3976),
    [anon_sym_LT_AT_AT] = ACTIONS(3976),
    [anon_sym_DOT] = ACTIONS(3976),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3974),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_with] = ACTIONS(3976),
    [anon_sym_return_BANG] = ACTIONS(3974),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_yield_BANG] = ACTIONS(3974),
    [anon_sym_lazy] = ACTIONS(3976),
    [anon_sym_assert] = ACTIONS(3976),
    [anon_sym_upcast] = ACTIONS(3976),
    [anon_sym_downcast] = ACTIONS(3976),
    [anon_sym_COLON_GT] = ACTIONS(3974),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3974),
    [anon_sym_for] = ACTIONS(3976),
    [anon_sym_while] = ACTIONS(3976),
    [anon_sym_if] = ACTIONS(3976),
    [anon_sym_fun] = ACTIONS(3976),
    [anon_sym_try] = ACTIONS(3976),
    [anon_sym_match] = ACTIONS(3976),
    [anon_sym_match_BANG] = ACTIONS(3974),
    [anon_sym_function] = ACTIONS(3976),
    [anon_sym_LT_DASH] = ACTIONS(3976),
    [anon_sym_DOT_LBRACK] = ACTIONS(3974),
    [anon_sym_LT] = ACTIONS(3974),
    [anon_sym_use] = ACTIONS(3976),
    [anon_sym_use_BANG] = ACTIONS(3974),
    [anon_sym_do_BANG] = ACTIONS(3974),
    [anon_sym_begin] = ACTIONS(3976),
    [anon_sym_LPAREN2] = ACTIONS(3976),
    [anon_sym_default] = ACTIONS(3976),
    [anon_sym_or] = ACTIONS(3976),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_member] = ACTIONS(3976),
    [anon_sym_interface] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_val] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [aux_sym_char_token1] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3976),
    [anon_sym_DQUOTE] = ACTIONS(3976),
    [anon_sym_AT_DQUOTE] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [sym_bool] = ACTIONS(3976),
    [sym_unit] = ACTIONS(3974),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3976),
    [sym_op_identifier] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3976),
    [anon_sym_DASH] = ACTIONS(3976),
    [anon_sym_PLUS_DOT] = ACTIONS(3976),
    [anon_sym_DASH_DOT] = ACTIONS(3976),
    [anon_sym_PERCENT] = ACTIONS(3976),
    [anon_sym_AMP_AMP] = ACTIONS(3976),
    [anon_sym_TILDE] = ACTIONS(3974),
    [aux_sym_prefix_op_token1] = ACTIONS(3976),
    [aux_sym_infix_op_token1] = ACTIONS(3974),
    [aux_sym_infix_op_token2] = ACTIONS(3976),
    [anon_sym_PIPE_PIPE] = ACTIONS(3976),
    [anon_sym_BANG_EQ] = ACTIONS(3976),
    [anon_sym_COLON_EQ] = ACTIONS(3974),
    [anon_sym_DOLLAR] = ACTIONS(3976),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3976),
    [sym_int] = ACTIONS(3976),
    [sym_xint] = ACTIONS(3974),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3974),
    [anon_sym_POUNDendif] = ACTIONS(3974),
    [anon_sym_POUNDelse] = ACTIONS(3974),
    [sym__newline] = ACTIONS(3974),
  },
  [1776] = {
    [sym_block_comment] = STATE(1776),
    [sym_compiler_directive_decl] = STATE(1776),
    [sym_fsi_directive_decl] = STATE(1776),
    [sym_preproc_line] = STATE(1776),
    [sym_identifier] = ACTIONS(3988),
    [anon_sym_EQ] = ACTIONS(3986),
    [anon_sym_LBRACK_LT] = ACTIONS(3986),
    [anon_sym_COLON] = ACTIONS(3988),
    [anon_sym_return] = ACTIONS(3988),
    [anon_sym_do] = ACTIONS(3988),
    [anon_sym_and] = ACTIONS(3988),
    [anon_sym_let] = ACTIONS(3988),
    [anon_sym_let_BANG] = ACTIONS(3986),
    [aux_sym_access_modifier_token1] = ACTIONS(3986),
    [anon_sym_LPAREN] = ACTIONS(3988),
    [anon_sym_COMMA] = ACTIONS(3986),
    [anon_sym_null] = ACTIONS(3988),
    [anon_sym_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_COLON] = ACTIONS(3986),
    [anon_sym_AMP] = ACTIONS(3988),
    [anon_sym_LBRACK] = ACTIONS(3988),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3986),
    [anon_sym_LBRACE] = ACTIONS(3988),
    [anon_sym_LT_AT] = ACTIONS(3988),
    [anon_sym_LT_AT_AT] = ACTIONS(3988),
    [anon_sym_DOT] = ACTIONS(3988),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3986),
    [anon_sym_new] = ACTIONS(3988),
    [anon_sym_with] = ACTIONS(3988),
    [anon_sym_return_BANG] = ACTIONS(3986),
    [anon_sym_yield] = ACTIONS(3988),
    [anon_sym_yield_BANG] = ACTIONS(3986),
    [anon_sym_lazy] = ACTIONS(3988),
    [anon_sym_assert] = ACTIONS(3988),
    [anon_sym_upcast] = ACTIONS(3988),
    [anon_sym_downcast] = ACTIONS(3988),
    [anon_sym_COLON_GT] = ACTIONS(3986),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_while] = ACTIONS(3988),
    [anon_sym_if] = ACTIONS(3988),
    [anon_sym_fun] = ACTIONS(3988),
    [anon_sym_try] = ACTIONS(3988),
    [anon_sym_match] = ACTIONS(3988),
    [anon_sym_match_BANG] = ACTIONS(3986),
    [anon_sym_function] = ACTIONS(3988),
    [anon_sym_LT_DASH] = ACTIONS(3988),
    [anon_sym_DOT_LBRACK] = ACTIONS(3986),
    [anon_sym_LT] = ACTIONS(3986),
    [anon_sym_use] = ACTIONS(3988),
    [anon_sym_use_BANG] = ACTIONS(3986),
    [anon_sym_do_BANG] = ACTIONS(3986),
    [anon_sym_begin] = ACTIONS(3988),
    [anon_sym_LPAREN2] = ACTIONS(3988),
    [anon_sym_default] = ACTIONS(3988),
    [anon_sym_or] = ACTIONS(3988),
    [anon_sym_static] = ACTIONS(3988),
    [anon_sym_member] = ACTIONS(3988),
    [anon_sym_interface] = ACTIONS(3988),
    [anon_sym_abstract] = ACTIONS(3988),
    [anon_sym_val] = ACTIONS(3988),
    [anon_sym_override] = ACTIONS(3988),
    [aux_sym_char_token1] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3988),
    [anon_sym_DQUOTE] = ACTIONS(3988),
    [anon_sym_AT_DQUOTE] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [sym_bool] = ACTIONS(3988),
    [sym_unit] = ACTIONS(3986),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3988),
    [sym_op_identifier] = ACTIONS(3988),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_PLUS_DOT] = ACTIONS(3988),
    [anon_sym_DASH_DOT] = ACTIONS(3988),
    [anon_sym_PERCENT] = ACTIONS(3988),
    [anon_sym_AMP_AMP] = ACTIONS(3988),
    [anon_sym_TILDE] = ACTIONS(3986),
    [aux_sym_prefix_op_token1] = ACTIONS(3988),
    [aux_sym_infix_op_token1] = ACTIONS(3986),
    [aux_sym_infix_op_token2] = ACTIONS(3988),
    [anon_sym_PIPE_PIPE] = ACTIONS(3988),
    [anon_sym_BANG_EQ] = ACTIONS(3988),
    [anon_sym_COLON_EQ] = ACTIONS(3986),
    [anon_sym_DOLLAR] = ACTIONS(3988),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3988),
    [sym_int] = ACTIONS(3988),
    [sym_xint] = ACTIONS(3986),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3986),
    [anon_sym_POUNDendif] = ACTIONS(3986),
    [anon_sym_POUNDelse] = ACTIONS(3986),
    [sym__newline] = ACTIONS(3986),
  },
  [1777] = {
    [sym_block_comment] = STATE(1777),
    [sym_compiler_directive_decl] = STATE(1777),
    [sym_fsi_directive_decl] = STATE(1777),
    [sym_preproc_line] = STATE(1777),
    [sym_identifier] = ACTIONS(3984),
    [anon_sym_EQ] = ACTIONS(3982),
    [anon_sym_LBRACK_LT] = ACTIONS(3982),
    [anon_sym_COLON] = ACTIONS(3984),
    [anon_sym_return] = ACTIONS(3984),
    [anon_sym_do] = ACTIONS(3984),
    [anon_sym_and] = ACTIONS(3984),
    [anon_sym_let] = ACTIONS(3984),
    [anon_sym_let_BANG] = ACTIONS(3982),
    [aux_sym_access_modifier_token1] = ACTIONS(3982),
    [anon_sym_LPAREN] = ACTIONS(3984),
    [anon_sym_COMMA] = ACTIONS(3982),
    [anon_sym_null] = ACTIONS(3984),
    [anon_sym_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AMP] = ACTIONS(3984),
    [anon_sym_LBRACK] = ACTIONS(3984),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(3984),
    [anon_sym_LT_AT] = ACTIONS(3984),
    [anon_sym_LT_AT_AT] = ACTIONS(3984),
    [anon_sym_DOT] = ACTIONS(3984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3982),
    [anon_sym_new] = ACTIONS(3984),
    [anon_sym_with] = ACTIONS(3984),
    [anon_sym_return_BANG] = ACTIONS(3982),
    [anon_sym_yield] = ACTIONS(3984),
    [anon_sym_yield_BANG] = ACTIONS(3982),
    [anon_sym_lazy] = ACTIONS(3984),
    [anon_sym_assert] = ACTIONS(3984),
    [anon_sym_upcast] = ACTIONS(3984),
    [anon_sym_downcast] = ACTIONS(3984),
    [anon_sym_COLON_GT] = ACTIONS(3982),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3982),
    [anon_sym_for] = ACTIONS(3984),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_if] = ACTIONS(3984),
    [anon_sym_fun] = ACTIONS(3984),
    [anon_sym_try] = ACTIONS(3984),
    [anon_sym_match] = ACTIONS(3984),
    [anon_sym_match_BANG] = ACTIONS(3982),
    [anon_sym_function] = ACTIONS(3984),
    [anon_sym_LT_DASH] = ACTIONS(3984),
    [anon_sym_DOT_LBRACK] = ACTIONS(3982),
    [anon_sym_LT] = ACTIONS(3982),
    [anon_sym_use] = ACTIONS(3984),
    [anon_sym_use_BANG] = ACTIONS(3982),
    [anon_sym_do_BANG] = ACTIONS(3982),
    [anon_sym_begin] = ACTIONS(3984),
    [anon_sym_LPAREN2] = ACTIONS(3984),
    [anon_sym_default] = ACTIONS(3984),
    [anon_sym_or] = ACTIONS(3984),
    [anon_sym_static] = ACTIONS(3984),
    [anon_sym_member] = ACTIONS(3984),
    [anon_sym_interface] = ACTIONS(3984),
    [anon_sym_abstract] = ACTIONS(3984),
    [anon_sym_val] = ACTIONS(3984),
    [anon_sym_override] = ACTIONS(3984),
    [aux_sym_char_token1] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3984),
    [anon_sym_DQUOTE] = ACTIONS(3984),
    [anon_sym_AT_DQUOTE] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [sym_bool] = ACTIONS(3984),
    [sym_unit] = ACTIONS(3982),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3984),
    [sym_op_identifier] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3984),
    [anon_sym_DASH] = ACTIONS(3984),
    [anon_sym_PLUS_DOT] = ACTIONS(3984),
    [anon_sym_DASH_DOT] = ACTIONS(3984),
    [anon_sym_PERCENT] = ACTIONS(3984),
    [anon_sym_AMP_AMP] = ACTIONS(3984),
    [anon_sym_TILDE] = ACTIONS(3982),
    [aux_sym_prefix_op_token1] = ACTIONS(3984),
    [aux_sym_infix_op_token1] = ACTIONS(3982),
    [aux_sym_infix_op_token2] = ACTIONS(3984),
    [anon_sym_PIPE_PIPE] = ACTIONS(3984),
    [anon_sym_BANG_EQ] = ACTIONS(3984),
    [anon_sym_COLON_EQ] = ACTIONS(3982),
    [anon_sym_DOLLAR] = ACTIONS(3984),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3984),
    [sym_int] = ACTIONS(3984),
    [sym_xint] = ACTIONS(3982),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3982),
    [anon_sym_POUNDendif] = ACTIONS(3982),
    [anon_sym_POUNDelse] = ACTIONS(3982),
    [sym__newline] = ACTIONS(3982),
  },
  [1778] = {
    [sym_block_comment] = STATE(1778),
    [sym_compiler_directive_decl] = STATE(1778),
    [sym_fsi_directive_decl] = STATE(1778),
    [sym_preproc_line] = STATE(1778),
    [sym_identifier] = ACTIONS(3800),
    [anon_sym_EQ] = ACTIONS(3798),
    [anon_sym_LBRACK_LT] = ACTIONS(3798),
    [anon_sym_COLON] = ACTIONS(3800),
    [anon_sym_return] = ACTIONS(3800),
    [anon_sym_do] = ACTIONS(3800),
    [anon_sym_and] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_let_BANG] = ACTIONS(3798),
    [aux_sym_access_modifier_token1] = ACTIONS(3798),
    [anon_sym_LPAREN] = ACTIONS(3800),
    [anon_sym_COMMA] = ACTIONS(3798),
    [anon_sym_null] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_COLON] = ACTIONS(3798),
    [anon_sym_PIPE] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3800),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3798),
    [anon_sym_LBRACE] = ACTIONS(3800),
    [anon_sym_LT_AT] = ACTIONS(3800),
    [anon_sym_LT_AT_AT] = ACTIONS(3800),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3798),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_with] = ACTIONS(3800),
    [anon_sym_return_BANG] = ACTIONS(3798),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_yield_BANG] = ACTIONS(3798),
    [anon_sym_lazy] = ACTIONS(3800),
    [anon_sym_assert] = ACTIONS(3800),
    [anon_sym_upcast] = ACTIONS(3800),
    [anon_sym_downcast] = ACTIONS(3800),
    [anon_sym_COLON_GT] = ACTIONS(3798),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3798),
    [anon_sym_for] = ACTIONS(3800),
    [anon_sym_while] = ACTIONS(3800),
    [anon_sym_if] = ACTIONS(3800),
    [anon_sym_fun] = ACTIONS(3800),
    [anon_sym_try] = ACTIONS(3800),
    [anon_sym_match] = ACTIONS(3800),
    [anon_sym_match_BANG] = ACTIONS(3798),
    [anon_sym_function] = ACTIONS(3800),
    [anon_sym_LT_DASH] = ACTIONS(3800),
    [anon_sym_DOT_LBRACK] = ACTIONS(3798),
    [anon_sym_LT] = ACTIONS(3798),
    [anon_sym_use] = ACTIONS(3800),
    [anon_sym_use_BANG] = ACTIONS(3798),
    [anon_sym_do_BANG] = ACTIONS(3798),
    [anon_sym_begin] = ACTIONS(3800),
    [anon_sym_LPAREN2] = ACTIONS(3800),
    [anon_sym_default] = ACTIONS(3800),
    [anon_sym_or] = ACTIONS(3800),
    [anon_sym_static] = ACTIONS(3800),
    [anon_sym_member] = ACTIONS(3800),
    [anon_sym_interface] = ACTIONS(3800),
    [anon_sym_abstract] = ACTIONS(3800),
    [anon_sym_val] = ACTIONS(3800),
    [anon_sym_override] = ACTIONS(3800),
    [aux_sym_char_token1] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3800),
    [anon_sym_DQUOTE] = ACTIONS(3800),
    [anon_sym_AT_DQUOTE] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [sym_bool] = ACTIONS(3800),
    [sym_unit] = ACTIONS(3798),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3800),
    [sym_op_identifier] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS_DOT] = ACTIONS(3800),
    [anon_sym_DASH_DOT] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3800),
    [anon_sym_AMP_AMP] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3798),
    [aux_sym_prefix_op_token1] = ACTIONS(3800),
    [aux_sym_infix_op_token1] = ACTIONS(3798),
    [aux_sym_infix_op_token2] = ACTIONS(3800),
    [anon_sym_PIPE_PIPE] = ACTIONS(3800),
    [anon_sym_BANG_EQ] = ACTIONS(3800),
    [anon_sym_COLON_EQ] = ACTIONS(3798),
    [anon_sym_DOLLAR] = ACTIONS(3800),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3800),
    [sym_int] = ACTIONS(3800),
    [sym_xint] = ACTIONS(3798),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3798),
    [sym__newline] = ACTIONS(3798),
    [sym__dedent] = ACTIONS(3798),
  },
  [1779] = {
    [sym_block_comment] = STATE(1779),
    [sym_compiler_directive_decl] = STATE(1779),
    [sym_fsi_directive_decl] = STATE(1779),
    [sym_preproc_line] = STATE(1779),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_LBRACK_LT] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_and] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [aux_sym_access_modifier_token1] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_with] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_default] = ACTIONS(3743),
    [anon_sym_or] = ACTIONS(3743),
    [anon_sym_static] = ACTIONS(3743),
    [anon_sym_member] = ACTIONS(3743),
    [anon_sym_interface] = ACTIONS(3743),
    [anon_sym_abstract] = ACTIONS(3743),
    [anon_sym_val] = ACTIONS(3743),
    [anon_sym_override] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [sym__newline] = ACTIONS(3741),
    [sym__dedent] = ACTIONS(3741),
  },
  [1780] = {
    [sym_block_comment] = STATE(1780),
    [sym_compiler_directive_decl] = STATE(1780),
    [sym_fsi_directive_decl] = STATE(1780),
    [sym_preproc_line] = STATE(1780),
    [sym_identifier] = ACTIONS(3813),
    [anon_sym_EQ] = ACTIONS(3811),
    [anon_sym_LBRACK_LT] = ACTIONS(3811),
    [anon_sym_COLON] = ACTIONS(3813),
    [anon_sym_return] = ACTIONS(3813),
    [anon_sym_do] = ACTIONS(3813),
    [anon_sym_let] = ACTIONS(3813),
    [anon_sym_let_BANG] = ACTIONS(3811),
    [aux_sym_access_modifier_token1] = ACTIONS(3811),
    [anon_sym_LPAREN] = ACTIONS(3813),
    [anon_sym_COMMA] = ACTIONS(3811),
    [anon_sym_null] = ACTIONS(3813),
    [anon_sym_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_COLON] = ACTIONS(3811),
    [anon_sym_AMP] = ACTIONS(3813),
    [anon_sym_LBRACK] = ACTIONS(3813),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3811),
    [anon_sym_LBRACE] = ACTIONS(3813),
    [anon_sym_LT_AT] = ACTIONS(3813),
    [anon_sym_LT_AT_AT] = ACTIONS(3813),
    [anon_sym_DOT] = ACTIONS(3813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3811),
    [anon_sym_new] = ACTIONS(3813),
    [anon_sym_with] = ACTIONS(3813),
    [anon_sym_return_BANG] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_yield_BANG] = ACTIONS(3811),
    [anon_sym_lazy] = ACTIONS(3813),
    [anon_sym_assert] = ACTIONS(3813),
    [anon_sym_upcast] = ACTIONS(3813),
    [anon_sym_downcast] = ACTIONS(3813),
    [anon_sym_COLON_GT] = ACTIONS(3811),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3811),
    [anon_sym_for] = ACTIONS(3813),
    [anon_sym_done] = ACTIONS(4684),
    [anon_sym_while] = ACTIONS(3813),
    [anon_sym_if] = ACTIONS(3813),
    [anon_sym_fun] = ACTIONS(3813),
    [anon_sym_try] = ACTIONS(3813),
    [anon_sym_match] = ACTIONS(3813),
    [anon_sym_match_BANG] = ACTIONS(3811),
    [anon_sym_function] = ACTIONS(3813),
    [anon_sym_LT_DASH] = ACTIONS(3813),
    [anon_sym_DOT_LBRACK] = ACTIONS(3811),
    [anon_sym_LT] = ACTIONS(3811),
    [anon_sym_use] = ACTIONS(3813),
    [anon_sym_use_BANG] = ACTIONS(3811),
    [anon_sym_do_BANG] = ACTIONS(3811),
    [anon_sym_begin] = ACTIONS(3813),
    [anon_sym_LPAREN2] = ACTIONS(3813),
    [anon_sym_default] = ACTIONS(3813),
    [anon_sym_or] = ACTIONS(3813),
    [anon_sym_static] = ACTIONS(3813),
    [anon_sym_member] = ACTIONS(3813),
    [anon_sym_interface] = ACTIONS(3813),
    [anon_sym_abstract] = ACTIONS(3813),
    [anon_sym_val] = ACTIONS(3813),
    [anon_sym_override] = ACTIONS(3813),
    [anon_sym_inherit] = ACTIONS(3813),
    [aux_sym_char_token1] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3813),
    [anon_sym_DQUOTE] = ACTIONS(3813),
    [anon_sym_AT_DQUOTE] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [sym_bool] = ACTIONS(3813),
    [sym_unit] = ACTIONS(3811),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3813),
    [sym_op_identifier] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PLUS_DOT] = ACTIONS(3813),
    [anon_sym_DASH_DOT] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3813),
    [anon_sym_AMP_AMP] = ACTIONS(3813),
    [anon_sym_TILDE] = ACTIONS(3811),
    [aux_sym_prefix_op_token1] = ACTIONS(3813),
    [aux_sym_infix_op_token1] = ACTIONS(3811),
    [aux_sym_infix_op_token2] = ACTIONS(3813),
    [anon_sym_PIPE_PIPE] = ACTIONS(3813),
    [anon_sym_BANG_EQ] = ACTIONS(3813),
    [anon_sym_COLON_EQ] = ACTIONS(3811),
    [anon_sym_DOLLAR] = ACTIONS(3813),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3813),
    [sym_int] = ACTIONS(3813),
    [sym_xint] = ACTIONS(3811),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3811),
    [anon_sym_POUNDendif] = ACTIONS(3811),
    [sym__newline] = ACTIONS(3811),
  },
  [1781] = {
    [sym_block_comment] = STATE(1781),
    [sym_compiler_directive_decl] = STATE(1781),
    [sym_fsi_directive_decl] = STATE(1781),
    [sym_preproc_line] = STATE(1781),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_LBRACK_LT] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [aux_sym_access_modifier_token1] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_done] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_DOT_DOT] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_default] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [anon_sym_static] = ACTIONS(3700),
    [anon_sym_member] = ACTIONS(3700),
    [anon_sym_interface] = ACTIONS(3700),
    [anon_sym_abstract] = ACTIONS(3700),
    [anon_sym_val] = ACTIONS(3700),
    [anon_sym_override] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
    [sym__dedent] = ACTIONS(3698),
  },
  [1782] = {
    [sym_block_comment] = STATE(1782),
    [sym_compiler_directive_decl] = STATE(1782),
    [sym_fsi_directive_decl] = STATE(1782),
    [sym_preproc_line] = STATE(1782),
    [aux_sym_long_identifier_repeat1] = STATE(1784),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_LBRACK_LT] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [aux_sym_access_modifier_token1] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(4686),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_default] = ACTIONS(3451),
    [anon_sym_or] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_member] = ACTIONS(3451),
    [anon_sym_interface] = ACTIONS(3451),
    [anon_sym_abstract] = ACTIONS(3451),
    [anon_sym_val] = ACTIONS(3451),
    [anon_sym_override] = ACTIONS(3451),
    [anon_sym_inherit] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [anon_sym_POUNDendif] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
  },
  [1783] = {
    [sym_block_comment] = STATE(1783),
    [sym_compiler_directive_decl] = STATE(1783),
    [sym_fsi_directive_decl] = STATE(1783),
    [sym_preproc_line] = STATE(1783),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_and] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [aux_sym_access_modifier_token1] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_member] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_val] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [anon_sym_POUNDendif] = ACTIONS(3485),
    [anon_sym_POUNDelse] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [1784] = {
    [sym_block_comment] = STATE(1784),
    [sym_compiler_directive_decl] = STATE(1784),
    [sym_fsi_directive_decl] = STATE(1784),
    [sym_preproc_line] = STATE(1784),
    [aux_sym_long_identifier_repeat1] = STATE(1784),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [aux_sym_access_modifier_token1] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(4688),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_member] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_val] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [anon_sym_inherit] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [anon_sym_POUNDendif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [1785] = {
    [sym_block_comment] = STATE(1785),
    [sym_compiler_directive_decl] = STATE(1785),
    [sym_fsi_directive_decl] = STATE(1785),
    [sym_preproc_line] = STATE(1785),
    [sym_identifier] = ACTIONS(3980),
    [anon_sym_EQ] = ACTIONS(3978),
    [anon_sym_LBRACK_LT] = ACTIONS(3978),
    [anon_sym_COLON] = ACTIONS(3980),
    [anon_sym_return] = ACTIONS(3980),
    [anon_sym_do] = ACTIONS(3980),
    [anon_sym_and] = ACTIONS(3980),
    [anon_sym_let] = ACTIONS(3980),
    [anon_sym_let_BANG] = ACTIONS(3978),
    [aux_sym_access_modifier_token1] = ACTIONS(3978),
    [anon_sym_LPAREN] = ACTIONS(3980),
    [anon_sym_COMMA] = ACTIONS(3978),
    [anon_sym_null] = ACTIONS(3980),
    [anon_sym_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3978),
    [anon_sym_AMP] = ACTIONS(3980),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3978),
    [anon_sym_LBRACE] = ACTIONS(3980),
    [anon_sym_LT_AT] = ACTIONS(3980),
    [anon_sym_LT_AT_AT] = ACTIONS(3980),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3978),
    [anon_sym_new] = ACTIONS(3980),
    [anon_sym_with] = ACTIONS(3980),
    [anon_sym_return_BANG] = ACTIONS(3978),
    [anon_sym_yield] = ACTIONS(3980),
    [anon_sym_yield_BANG] = ACTIONS(3978),
    [anon_sym_lazy] = ACTIONS(3980),
    [anon_sym_assert] = ACTIONS(3980),
    [anon_sym_upcast] = ACTIONS(3980),
    [anon_sym_downcast] = ACTIONS(3980),
    [anon_sym_COLON_GT] = ACTIONS(3978),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3978),
    [anon_sym_for] = ACTIONS(3980),
    [anon_sym_while] = ACTIONS(3980),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_fun] = ACTIONS(3980),
    [anon_sym_try] = ACTIONS(3980),
    [anon_sym_match] = ACTIONS(3980),
    [anon_sym_match_BANG] = ACTIONS(3978),
    [anon_sym_function] = ACTIONS(3980),
    [anon_sym_LT_DASH] = ACTIONS(3980),
    [anon_sym_DOT_LBRACK] = ACTIONS(3978),
    [anon_sym_LT] = ACTIONS(3978),
    [anon_sym_use] = ACTIONS(3980),
    [anon_sym_use_BANG] = ACTIONS(3978),
    [anon_sym_do_BANG] = ACTIONS(3978),
    [anon_sym_begin] = ACTIONS(3980),
    [anon_sym_LPAREN2] = ACTIONS(3980),
    [anon_sym_default] = ACTIONS(3980),
    [anon_sym_or] = ACTIONS(3980),
    [anon_sym_static] = ACTIONS(3980),
    [anon_sym_member] = ACTIONS(3980),
    [anon_sym_interface] = ACTIONS(3980),
    [anon_sym_abstract] = ACTIONS(3980),
    [anon_sym_val] = ACTIONS(3980),
    [anon_sym_override] = ACTIONS(3980),
    [aux_sym_char_token1] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3980),
    [anon_sym_DQUOTE] = ACTIONS(3980),
    [anon_sym_AT_DQUOTE] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [sym_bool] = ACTIONS(3980),
    [sym_unit] = ACTIONS(3978),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3980),
    [sym_op_identifier] = ACTIONS(3980),
    [anon_sym_PLUS] = ACTIONS(3980),
    [anon_sym_DASH] = ACTIONS(3980),
    [anon_sym_PLUS_DOT] = ACTIONS(3980),
    [anon_sym_DASH_DOT] = ACTIONS(3980),
    [anon_sym_PERCENT] = ACTIONS(3980),
    [anon_sym_AMP_AMP] = ACTIONS(3980),
    [anon_sym_TILDE] = ACTIONS(3978),
    [aux_sym_prefix_op_token1] = ACTIONS(3980),
    [aux_sym_infix_op_token1] = ACTIONS(3978),
    [aux_sym_infix_op_token2] = ACTIONS(3980),
    [anon_sym_PIPE_PIPE] = ACTIONS(3980),
    [anon_sym_BANG_EQ] = ACTIONS(3980),
    [anon_sym_COLON_EQ] = ACTIONS(3978),
    [anon_sym_DOLLAR] = ACTIONS(3980),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3980),
    [sym_int] = ACTIONS(3980),
    [sym_xint] = ACTIONS(3978),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3978),
    [anon_sym_POUNDendif] = ACTIONS(3978),
    [anon_sym_POUNDelse] = ACTIONS(3978),
    [sym__newline] = ACTIONS(3978),
  },
  [1786] = {
    [sym_block_comment] = STATE(1786),
    [sym_compiler_directive_decl] = STATE(1786),
    [sym_fsi_directive_decl] = STATE(1786),
    [sym_preproc_line] = STATE(1786),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_LBRACK_LT] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_and] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [aux_sym_access_modifier_token1] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_default] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [anon_sym_static] = ACTIONS(3700),
    [anon_sym_member] = ACTIONS(3700),
    [anon_sym_interface] = ACTIONS(3700),
    [anon_sym_abstract] = ACTIONS(3700),
    [anon_sym_val] = ACTIONS(3700),
    [anon_sym_override] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [anon_sym_POUNDendif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [1787] = {
    [sym_block_comment] = STATE(1787),
    [sym_compiler_directive_decl] = STATE(1787),
    [sym_fsi_directive_decl] = STATE(1787),
    [sym_preproc_line] = STATE(1787),
    [sym_identifier] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3919),
    [anon_sym_LBRACK_LT] = ACTIONS(3919),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_return] = ACTIONS(3921),
    [anon_sym_do] = ACTIONS(3921),
    [anon_sym_let] = ACTIONS(3921),
    [anon_sym_let_BANG] = ACTIONS(3919),
    [aux_sym_access_modifier_token1] = ACTIONS(3919),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3919),
    [anon_sym_null] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_COLON] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3919),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_LT_AT] = ACTIONS(3921),
    [anon_sym_LT_AT_AT] = ACTIONS(3921),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3919),
    [anon_sym_new] = ACTIONS(3921),
    [anon_sym_with] = ACTIONS(3921),
    [anon_sym_return_BANG] = ACTIONS(3919),
    [anon_sym_yield] = ACTIONS(3921),
    [anon_sym_yield_BANG] = ACTIONS(3919),
    [anon_sym_lazy] = ACTIONS(3921),
    [anon_sym_assert] = ACTIONS(3921),
    [anon_sym_upcast] = ACTIONS(3921),
    [anon_sym_downcast] = ACTIONS(3921),
    [anon_sym_COLON_GT] = ACTIONS(3919),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3919),
    [anon_sym_for] = ACTIONS(3921),
    [anon_sym_while] = ACTIONS(3921),
    [anon_sym_if] = ACTIONS(3921),
    [anon_sym_fun] = ACTIONS(3921),
    [anon_sym_try] = ACTIONS(3921),
    [anon_sym_match] = ACTIONS(3921),
    [anon_sym_match_BANG] = ACTIONS(3919),
    [anon_sym_function] = ACTIONS(3921),
    [anon_sym_LT_DASH] = ACTIONS(3921),
    [anon_sym_DOT_LBRACK] = ACTIONS(3919),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_use] = ACTIONS(3921),
    [anon_sym_use_BANG] = ACTIONS(3919),
    [anon_sym_do_BANG] = ACTIONS(3919),
    [anon_sym_begin] = ACTIONS(3921),
    [anon_sym_LPAREN2] = ACTIONS(3921),
    [anon_sym_default] = ACTIONS(3921),
    [anon_sym_or] = ACTIONS(3921),
    [anon_sym_static] = ACTIONS(3921),
    [anon_sym_member] = ACTIONS(3921),
    [anon_sym_interface] = ACTIONS(3921),
    [anon_sym_abstract] = ACTIONS(3921),
    [anon_sym_val] = ACTIONS(3921),
    [anon_sym_override] = ACTIONS(3921),
    [anon_sym_inherit] = ACTIONS(3921),
    [aux_sym_char_token1] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_AT_DQUOTE] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [sym_bool] = ACTIONS(3921),
    [sym_unit] = ACTIONS(3919),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3921),
    [sym_op_identifier] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_DOT] = ACTIONS(3921),
    [anon_sym_DASH_DOT] = ACTIONS(3921),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3919),
    [aux_sym_prefix_op_token1] = ACTIONS(3921),
    [aux_sym_infix_op_token1] = ACTIONS(3919),
    [aux_sym_infix_op_token2] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_COLON_EQ] = ACTIONS(3919),
    [anon_sym_DOLLAR] = ACTIONS(3921),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3921),
    [sym_int] = ACTIONS(3921),
    [sym_xint] = ACTIONS(3919),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3919),
    [anon_sym_POUNDendif] = ACTIONS(3919),
    [anon_sym_POUNDelse] = ACTIONS(3919),
    [sym__newline] = ACTIONS(3919),
  },
  [1788] = {
    [sym_block_comment] = STATE(1788),
    [sym_compiler_directive_decl] = STATE(1788),
    [sym_fsi_directive_decl] = STATE(1788),
    [sym_preproc_line] = STATE(1788),
    [aux_sym_sequential_expression_repeat1] = STATE(1788),
    [sym_identifier] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3765),
    [anon_sym_LBRACK_LT] = ACTIONS(3765),
    [anon_sym_COLON] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_and] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_let_BANG] = ACTIONS(3765),
    [aux_sym_access_modifier_token1] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(3767),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_null] = ACTIONS(3767),
    [anon_sym_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3765),
    [anon_sym_LBRACE] = ACTIONS(3767),
    [anon_sym_LT_AT] = ACTIONS(3767),
    [anon_sym_LT_AT_AT] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3765),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_with] = ACTIONS(3767),
    [anon_sym_return_BANG] = ACTIONS(3765),
    [anon_sym_yield] = ACTIONS(3767),
    [anon_sym_yield_BANG] = ACTIONS(3765),
    [anon_sym_lazy] = ACTIONS(3767),
    [anon_sym_assert] = ACTIONS(3767),
    [anon_sym_upcast] = ACTIONS(3767),
    [anon_sym_downcast] = ACTIONS(3767),
    [anon_sym_COLON_GT] = ACTIONS(3765),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3765),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_fun] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_match] = ACTIONS(3767),
    [anon_sym_match_BANG] = ACTIONS(3765),
    [anon_sym_function] = ACTIONS(3767),
    [anon_sym_LT_DASH] = ACTIONS(3767),
    [anon_sym_DOT_LBRACK] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(3765),
    [anon_sym_use] = ACTIONS(3767),
    [anon_sym_use_BANG] = ACTIONS(3765),
    [anon_sym_do_BANG] = ACTIONS(3765),
    [anon_sym_begin] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3767),
    [anon_sym_default] = ACTIONS(3767),
    [anon_sym_or] = ACTIONS(3767),
    [anon_sym_static] = ACTIONS(3767),
    [anon_sym_member] = ACTIONS(3767),
    [anon_sym_interface] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(3767),
    [anon_sym_val] = ACTIONS(3767),
    [anon_sym_override] = ACTIONS(3767),
    [aux_sym_char_token1] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3767),
    [anon_sym_DQUOTE] = ACTIONS(3767),
    [anon_sym_AT_DQUOTE] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [sym_bool] = ACTIONS(3767),
    [sym_unit] = ACTIONS(3765),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3767),
    [sym_op_identifier] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_PLUS_DOT] = ACTIONS(3767),
    [anon_sym_DASH_DOT] = ACTIONS(3767),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_AMP_AMP] = ACTIONS(3767),
    [anon_sym_TILDE] = ACTIONS(3765),
    [aux_sym_prefix_op_token1] = ACTIONS(3767),
    [aux_sym_infix_op_token1] = ACTIONS(3765),
    [aux_sym_infix_op_token2] = ACTIONS(3767),
    [anon_sym_PIPE_PIPE] = ACTIONS(3767),
    [anon_sym_BANG_EQ] = ACTIONS(3767),
    [anon_sym_COLON_EQ] = ACTIONS(3765),
    [anon_sym_DOLLAR] = ACTIONS(3767),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3767),
    [sym_int] = ACTIONS(3767),
    [sym_xint] = ACTIONS(3765),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3765),
    [sym__newline] = ACTIONS(4691),
    [sym__dedent] = ACTIONS(3765),
  },
  [1789] = {
    [sym_block_comment] = STATE(1789),
    [sym_compiler_directive_decl] = STATE(1789),
    [sym_fsi_directive_decl] = STATE(1789),
    [sym_preproc_line] = STATE(1789),
    [aux_sym_sequential_expression_repeat1] = STATE(1789),
    [sym_identifier] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3765),
    [anon_sym_LBRACK_LT] = ACTIONS(3765),
    [anon_sym_COLON] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_let_BANG] = ACTIONS(3765),
    [aux_sym_access_modifier_token1] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(3767),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_null] = ACTIONS(3767),
    [anon_sym_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3765),
    [anon_sym_LBRACE] = ACTIONS(3767),
    [anon_sym_LT_AT] = ACTIONS(3767),
    [anon_sym_LT_AT_AT] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3765),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_with] = ACTIONS(3767),
    [anon_sym_return_BANG] = ACTIONS(3765),
    [anon_sym_yield] = ACTIONS(3767),
    [anon_sym_yield_BANG] = ACTIONS(3765),
    [anon_sym_lazy] = ACTIONS(3767),
    [anon_sym_assert] = ACTIONS(3767),
    [anon_sym_upcast] = ACTIONS(3767),
    [anon_sym_downcast] = ACTIONS(3767),
    [anon_sym_COLON_GT] = ACTIONS(3765),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3765),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_fun] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_match] = ACTIONS(3767),
    [anon_sym_match_BANG] = ACTIONS(3765),
    [anon_sym_function] = ACTIONS(3767),
    [anon_sym_LT_DASH] = ACTIONS(3767),
    [anon_sym_DOT_LBRACK] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(3765),
    [anon_sym_use] = ACTIONS(3767),
    [anon_sym_use_BANG] = ACTIONS(3765),
    [anon_sym_do_BANG] = ACTIONS(3765),
    [anon_sym_begin] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3767),
    [anon_sym_default] = ACTIONS(3767),
    [anon_sym_or] = ACTIONS(3767),
    [anon_sym_static] = ACTIONS(3767),
    [anon_sym_member] = ACTIONS(3767),
    [anon_sym_interface] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(3767),
    [anon_sym_val] = ACTIONS(3767),
    [anon_sym_override] = ACTIONS(3767),
    [anon_sym_inherit] = ACTIONS(3767),
    [aux_sym_char_token1] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3767),
    [anon_sym_DQUOTE] = ACTIONS(3767),
    [anon_sym_AT_DQUOTE] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [sym_bool] = ACTIONS(3767),
    [sym_unit] = ACTIONS(3765),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3767),
    [sym_op_identifier] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_PLUS_DOT] = ACTIONS(3767),
    [anon_sym_DASH_DOT] = ACTIONS(3767),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_AMP_AMP] = ACTIONS(3767),
    [anon_sym_TILDE] = ACTIONS(3765),
    [aux_sym_prefix_op_token1] = ACTIONS(3767),
    [aux_sym_infix_op_token1] = ACTIONS(3765),
    [aux_sym_infix_op_token2] = ACTIONS(3767),
    [anon_sym_PIPE_PIPE] = ACTIONS(3767),
    [anon_sym_BANG_EQ] = ACTIONS(3767),
    [anon_sym_COLON_EQ] = ACTIONS(3765),
    [anon_sym_DOLLAR] = ACTIONS(3767),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3767),
    [sym_int] = ACTIONS(3767),
    [sym_xint] = ACTIONS(3765),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3765),
    [anon_sym_POUNDendif] = ACTIONS(3765),
    [sym__newline] = ACTIONS(4694),
  },
  [1790] = {
    [sym_block_comment] = STATE(1790),
    [sym_compiler_directive_decl] = STATE(1790),
    [sym_fsi_directive_decl] = STATE(1790),
    [sym_preproc_line] = STATE(1790),
    [sym_identifier] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3772),
    [anon_sym_LBRACK_LT] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3774),
    [anon_sym_do] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3774),
    [anon_sym_let_BANG] = ACTIONS(3772),
    [aux_sym_access_modifier_token1] = ACTIONS(3772),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3772),
    [anon_sym_null] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_COLON] = ACTIONS(3772),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_LT_AT] = ACTIONS(3774),
    [anon_sym_LT_AT_AT] = ACTIONS(3774),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3772),
    [anon_sym_new] = ACTIONS(3774),
    [anon_sym_with] = ACTIONS(3774),
    [anon_sym_return_BANG] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3774),
    [anon_sym_yield_BANG] = ACTIONS(3772),
    [anon_sym_lazy] = ACTIONS(3774),
    [anon_sym_assert] = ACTIONS(3774),
    [anon_sym_upcast] = ACTIONS(3774),
    [anon_sym_downcast] = ACTIONS(3774),
    [anon_sym_COLON_GT] = ACTIONS(3772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3774),
    [anon_sym_done] = ACTIONS(4697),
    [anon_sym_while] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3774),
    [anon_sym_fun] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3774),
    [anon_sym_match] = ACTIONS(3774),
    [anon_sym_match_BANG] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3774),
    [anon_sym_LT_DASH] = ACTIONS(3774),
    [anon_sym_DOT_LBRACK] = ACTIONS(3772),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_use] = ACTIONS(3774),
    [anon_sym_use_BANG] = ACTIONS(3772),
    [anon_sym_do_BANG] = ACTIONS(3772),
    [anon_sym_begin] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3774),
    [anon_sym_default] = ACTIONS(3774),
    [anon_sym_or] = ACTIONS(3774),
    [anon_sym_static] = ACTIONS(3774),
    [anon_sym_member] = ACTIONS(3774),
    [anon_sym_interface] = ACTIONS(3774),
    [anon_sym_abstract] = ACTIONS(3774),
    [anon_sym_val] = ACTIONS(3774),
    [anon_sym_override] = ACTIONS(3774),
    [anon_sym_inherit] = ACTIONS(3774),
    [aux_sym_char_token1] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_AT_DQUOTE] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [sym_bool] = ACTIONS(3774),
    [sym_unit] = ACTIONS(3772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3774),
    [sym_op_identifier] = ACTIONS(3774),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_DOT] = ACTIONS(3774),
    [anon_sym_DASH_DOT] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3772),
    [aux_sym_prefix_op_token1] = ACTIONS(3774),
    [aux_sym_infix_op_token1] = ACTIONS(3772),
    [aux_sym_infix_op_token2] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3774),
    [anon_sym_COLON_EQ] = ACTIONS(3772),
    [anon_sym_DOLLAR] = ACTIONS(3774),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3774),
    [sym_int] = ACTIONS(3774),
    [sym_xint] = ACTIONS(3772),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3772),
    [anon_sym_POUNDendif] = ACTIONS(3772),
    [sym__newline] = ACTIONS(3772),
  },
  [1791] = {
    [sym_block_comment] = STATE(1791),
    [sym_compiler_directive_decl] = STATE(1791),
    [sym_fsi_directive_decl] = STATE(1791),
    [sym_preproc_line] = STATE(1791),
    [sym_identifier] = ACTIONS(4212),
    [anon_sym_EQ] = ACTIONS(4210),
    [anon_sym_LBRACK_LT] = ACTIONS(4210),
    [anon_sym_COLON] = ACTIONS(4212),
    [anon_sym_return] = ACTIONS(4212),
    [anon_sym_do] = ACTIONS(4212),
    [anon_sym_let] = ACTIONS(4212),
    [anon_sym_let_BANG] = ACTIONS(4210),
    [aux_sym_access_modifier_token1] = ACTIONS(4210),
    [anon_sym_LPAREN] = ACTIONS(4212),
    [anon_sym_COMMA] = ACTIONS(4210),
    [anon_sym_null] = ACTIONS(4212),
    [anon_sym_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_COLON] = ACTIONS(4210),
    [anon_sym_AMP] = ACTIONS(4212),
    [anon_sym_LBRACK] = ACTIONS(4212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4210),
    [anon_sym_LBRACE] = ACTIONS(4212),
    [anon_sym_LT_AT] = ACTIONS(4212),
    [anon_sym_LT_AT_AT] = ACTIONS(4212),
    [anon_sym_DOT] = ACTIONS(4212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4210),
    [anon_sym_new] = ACTIONS(4212),
    [anon_sym_with] = ACTIONS(4212),
    [anon_sym_return_BANG] = ACTIONS(4210),
    [anon_sym_yield] = ACTIONS(4212),
    [anon_sym_yield_BANG] = ACTIONS(4210),
    [anon_sym_lazy] = ACTIONS(4212),
    [anon_sym_assert] = ACTIONS(4212),
    [anon_sym_upcast] = ACTIONS(4212),
    [anon_sym_downcast] = ACTIONS(4212),
    [anon_sym_COLON_GT] = ACTIONS(4210),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4210),
    [anon_sym_for] = ACTIONS(4212),
    [anon_sym_while] = ACTIONS(4212),
    [anon_sym_if] = ACTIONS(4212),
    [anon_sym_fun] = ACTIONS(4212),
    [anon_sym_try] = ACTIONS(4212),
    [anon_sym_match] = ACTIONS(4212),
    [anon_sym_match_BANG] = ACTIONS(4210),
    [anon_sym_function] = ACTIONS(4212),
    [anon_sym_LT_DASH] = ACTIONS(4212),
    [anon_sym_DOT_LBRACK] = ACTIONS(4210),
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_use] = ACTIONS(4212),
    [anon_sym_use_BANG] = ACTIONS(4210),
    [anon_sym_do_BANG] = ACTIONS(4210),
    [anon_sym_begin] = ACTIONS(4212),
    [anon_sym_LPAREN2] = ACTIONS(4212),
    [anon_sym_default] = ACTIONS(4212),
    [anon_sym_or] = ACTIONS(4212),
    [anon_sym_static] = ACTIONS(4212),
    [anon_sym_member] = ACTIONS(4212),
    [anon_sym_interface] = ACTIONS(4212),
    [anon_sym_abstract] = ACTIONS(4212),
    [anon_sym_val] = ACTIONS(4212),
    [anon_sym_override] = ACTIONS(4212),
    [anon_sym_inherit] = ACTIONS(4212),
    [aux_sym_char_token1] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4212),
    [anon_sym_DQUOTE] = ACTIONS(4212),
    [anon_sym_AT_DQUOTE] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [sym_bool] = ACTIONS(4212),
    [sym_unit] = ACTIONS(4210),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4212),
    [anon_sym_DASH] = ACTIONS(4212),
    [anon_sym_PLUS_DOT] = ACTIONS(4212),
    [anon_sym_DASH_DOT] = ACTIONS(4212),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_AMP_AMP] = ACTIONS(4212),
    [anon_sym_TILDE] = ACTIONS(4210),
    [aux_sym_prefix_op_token1] = ACTIONS(4212),
    [aux_sym_infix_op_token1] = ACTIONS(4210),
    [aux_sym_infix_op_token2] = ACTIONS(4212),
    [anon_sym_PIPE_PIPE] = ACTIONS(4212),
    [anon_sym_BANG_EQ] = ACTIONS(4212),
    [anon_sym_COLON_EQ] = ACTIONS(4210),
    [anon_sym_DOLLAR] = ACTIONS(4212),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4212),
    [sym_int] = ACTIONS(4212),
    [sym_xint] = ACTIONS(4210),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4210),
    [anon_sym_POUNDendif] = ACTIONS(4210),
    [anon_sym_POUNDelse] = ACTIONS(4210),
    [sym__newline] = ACTIONS(4210),
  },
  [1792] = {
    [sym_block_comment] = STATE(1792),
    [sym_compiler_directive_decl] = STATE(1792),
    [sym_fsi_directive_decl] = STATE(1792),
    [sym_preproc_line] = STATE(1792),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_LBRACK_LT] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_and] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [aux_sym_access_modifier_token1] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_default] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [anon_sym_static] = ACTIONS(3700),
    [anon_sym_member] = ACTIONS(3700),
    [anon_sym_interface] = ACTIONS(3700),
    [anon_sym_abstract] = ACTIONS(3700),
    [anon_sym_val] = ACTIONS(3700),
    [anon_sym_override] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
    [sym__dedent] = ACTIONS(3698),
  },
  [1793] = {
    [sym_block_comment] = STATE(1793),
    [sym_compiler_directive_decl] = STATE(1793),
    [sym_fsi_directive_decl] = STATE(1793),
    [sym_preproc_line] = STATE(1793),
    [aux_sym_long_identifier_repeat1] = STATE(1793),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_and] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [aux_sym_access_modifier_token1] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(4699),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_member] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_val] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
    [sym__dedent] = ACTIONS(3485),
  },
  [1794] = {
    [sym_block_comment] = STATE(1794),
    [sym_compiler_directive_decl] = STATE(1794),
    [sym_fsi_directive_decl] = STATE(1794),
    [sym_preproc_line] = STATE(1794),
    [sym_identifier] = ACTIONS(3966),
    [anon_sym_EQ] = ACTIONS(3964),
    [anon_sym_LBRACK_LT] = ACTIONS(3964),
    [anon_sym_COLON] = ACTIONS(3966),
    [anon_sym_return] = ACTIONS(3966),
    [anon_sym_do] = ACTIONS(3966),
    [anon_sym_and] = ACTIONS(3966),
    [anon_sym_let] = ACTIONS(3966),
    [anon_sym_let_BANG] = ACTIONS(3964),
    [aux_sym_access_modifier_token1] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COMMA] = ACTIONS(3964),
    [anon_sym_null] = ACTIONS(3966),
    [anon_sym_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(3964),
    [anon_sym_AMP] = ACTIONS(3966),
    [anon_sym_LBRACK] = ACTIONS(3966),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3964),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_LT_AT] = ACTIONS(3966),
    [anon_sym_LT_AT_AT] = ACTIONS(3966),
    [anon_sym_DOT] = ACTIONS(3966),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3964),
    [anon_sym_new] = ACTIONS(3966),
    [anon_sym_with] = ACTIONS(3966),
    [anon_sym_return_BANG] = ACTIONS(3964),
    [anon_sym_yield] = ACTIONS(3966),
    [anon_sym_yield_BANG] = ACTIONS(3964),
    [anon_sym_lazy] = ACTIONS(3966),
    [anon_sym_assert] = ACTIONS(3966),
    [anon_sym_upcast] = ACTIONS(3966),
    [anon_sym_downcast] = ACTIONS(3966),
    [anon_sym_COLON_GT] = ACTIONS(3964),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3964),
    [anon_sym_for] = ACTIONS(3966),
    [anon_sym_while] = ACTIONS(3966),
    [anon_sym_if] = ACTIONS(3966),
    [anon_sym_fun] = ACTIONS(3966),
    [anon_sym_try] = ACTIONS(3966),
    [anon_sym_match] = ACTIONS(3966),
    [anon_sym_match_BANG] = ACTIONS(3964),
    [anon_sym_function] = ACTIONS(3966),
    [anon_sym_LT_DASH] = ACTIONS(3966),
    [anon_sym_DOT_LBRACK] = ACTIONS(3964),
    [anon_sym_LT] = ACTIONS(3964),
    [anon_sym_use] = ACTIONS(3966),
    [anon_sym_use_BANG] = ACTIONS(3964),
    [anon_sym_do_BANG] = ACTIONS(3964),
    [anon_sym_begin] = ACTIONS(3966),
    [anon_sym_LPAREN2] = ACTIONS(3966),
    [anon_sym_default] = ACTIONS(3966),
    [anon_sym_or] = ACTIONS(3966),
    [anon_sym_static] = ACTIONS(3966),
    [anon_sym_member] = ACTIONS(3966),
    [anon_sym_interface] = ACTIONS(3966),
    [anon_sym_abstract] = ACTIONS(3966),
    [anon_sym_val] = ACTIONS(3966),
    [anon_sym_override] = ACTIONS(3966),
    [aux_sym_char_token1] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3966),
    [anon_sym_DQUOTE] = ACTIONS(3966),
    [anon_sym_AT_DQUOTE] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [sym_bool] = ACTIONS(3966),
    [sym_unit] = ACTIONS(3964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3966),
    [sym_op_identifier] = ACTIONS(3966),
    [anon_sym_PLUS] = ACTIONS(3966),
    [anon_sym_DASH] = ACTIONS(3966),
    [anon_sym_PLUS_DOT] = ACTIONS(3966),
    [anon_sym_DASH_DOT] = ACTIONS(3966),
    [anon_sym_PERCENT] = ACTIONS(3966),
    [anon_sym_AMP_AMP] = ACTIONS(3966),
    [anon_sym_TILDE] = ACTIONS(3964),
    [aux_sym_prefix_op_token1] = ACTIONS(3966),
    [aux_sym_infix_op_token1] = ACTIONS(3964),
    [aux_sym_infix_op_token2] = ACTIONS(3966),
    [anon_sym_PIPE_PIPE] = ACTIONS(3966),
    [anon_sym_BANG_EQ] = ACTIONS(3966),
    [anon_sym_COLON_EQ] = ACTIONS(3964),
    [anon_sym_DOLLAR] = ACTIONS(3966),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3966),
    [sym_int] = ACTIONS(3966),
    [sym_xint] = ACTIONS(3964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3964),
    [anon_sym_POUNDendif] = ACTIONS(3964),
    [anon_sym_POUNDelse] = ACTIONS(3964),
    [sym__newline] = ACTIONS(3964),
  },
  [1795] = {
    [sym_block_comment] = STATE(1795),
    [sym_compiler_directive_decl] = STATE(1795),
    [sym_fsi_directive_decl] = STATE(1795),
    [sym_preproc_line] = STATE(1795),
    [aux_sym_long_identifier_repeat1] = STATE(1793),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_LBRACK_LT] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_and] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [aux_sym_access_modifier_token1] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(4702),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_default] = ACTIONS(3451),
    [anon_sym_or] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_member] = ACTIONS(3451),
    [anon_sym_interface] = ACTIONS(3451),
    [anon_sym_abstract] = ACTIONS(3451),
    [anon_sym_val] = ACTIONS(3451),
    [anon_sym_override] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
    [sym__dedent] = ACTIONS(3449),
  },
  [1796] = {
    [sym_block_comment] = STATE(1796),
    [sym_compiler_directive_decl] = STATE(1796),
    [sym_fsi_directive_decl] = STATE(1796),
    [sym_preproc_line] = STATE(1796),
    [sym_identifier] = ACTIONS(3942),
    [anon_sym_EQ] = ACTIONS(3940),
    [anon_sym_LBRACK_LT] = ACTIONS(3940),
    [anon_sym_COLON] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_and] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_let_BANG] = ACTIONS(3940),
    [aux_sym_access_modifier_token1] = ACTIONS(3940),
    [anon_sym_LPAREN] = ACTIONS(3942),
    [anon_sym_COMMA] = ACTIONS(3940),
    [anon_sym_null] = ACTIONS(3942),
    [anon_sym_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3940),
    [anon_sym_LBRACE] = ACTIONS(3942),
    [anon_sym_LT_AT] = ACTIONS(3942),
    [anon_sym_LT_AT_AT] = ACTIONS(3942),
    [anon_sym_DOT] = ACTIONS(3942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3940),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_with] = ACTIONS(3942),
    [anon_sym_return_BANG] = ACTIONS(3940),
    [anon_sym_yield] = ACTIONS(3942),
    [anon_sym_yield_BANG] = ACTIONS(3940),
    [anon_sym_lazy] = ACTIONS(3942),
    [anon_sym_assert] = ACTIONS(3942),
    [anon_sym_upcast] = ACTIONS(3942),
    [anon_sym_downcast] = ACTIONS(3942),
    [anon_sym_COLON_GT] = ACTIONS(3940),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3940),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_fun] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_match] = ACTIONS(3942),
    [anon_sym_match_BANG] = ACTIONS(3940),
    [anon_sym_function] = ACTIONS(3942),
    [anon_sym_LT_DASH] = ACTIONS(3942),
    [anon_sym_DOT_LBRACK] = ACTIONS(3940),
    [anon_sym_LT] = ACTIONS(3940),
    [anon_sym_use] = ACTIONS(3942),
    [anon_sym_use_BANG] = ACTIONS(3940),
    [anon_sym_do_BANG] = ACTIONS(3940),
    [anon_sym_begin] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3942),
    [anon_sym_default] = ACTIONS(3942),
    [anon_sym_or] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_member] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_abstract] = ACTIONS(3942),
    [anon_sym_val] = ACTIONS(3942),
    [anon_sym_override] = ACTIONS(3942),
    [aux_sym_char_token1] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3942),
    [anon_sym_DQUOTE] = ACTIONS(3942),
    [anon_sym_AT_DQUOTE] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [sym_bool] = ACTIONS(3942),
    [sym_unit] = ACTIONS(3940),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3942),
    [sym_op_identifier] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS_DOT] = ACTIONS(3942),
    [anon_sym_DASH_DOT] = ACTIONS(3942),
    [anon_sym_PERCENT] = ACTIONS(3942),
    [anon_sym_AMP_AMP] = ACTIONS(3942),
    [anon_sym_TILDE] = ACTIONS(3940),
    [aux_sym_prefix_op_token1] = ACTIONS(3942),
    [aux_sym_infix_op_token1] = ACTIONS(3940),
    [aux_sym_infix_op_token2] = ACTIONS(3942),
    [anon_sym_PIPE_PIPE] = ACTIONS(3942),
    [anon_sym_BANG_EQ] = ACTIONS(3942),
    [anon_sym_COLON_EQ] = ACTIONS(3940),
    [anon_sym_DOLLAR] = ACTIONS(3942),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3942),
    [sym_int] = ACTIONS(3942),
    [sym_xint] = ACTIONS(3940),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3940),
    [anon_sym_POUNDendif] = ACTIONS(3940),
    [anon_sym_POUNDelse] = ACTIONS(3940),
    [sym__newline] = ACTIONS(3940),
  },
  [1797] = {
    [sym_block_comment] = STATE(1797),
    [sym_compiler_directive_decl] = STATE(1797),
    [sym_fsi_directive_decl] = STATE(1797),
    [sym_preproc_line] = STATE(1797),
    [sym_identifier] = ACTIONS(3931),
    [anon_sym_EQ] = ACTIONS(3929),
    [anon_sym_LBRACK_LT] = ACTIONS(3929),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_do] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3931),
    [anon_sym_let] = ACTIONS(3931),
    [anon_sym_let_BANG] = ACTIONS(3929),
    [aux_sym_access_modifier_token1] = ACTIONS(3929),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_COMMA] = ACTIONS(3929),
    [anon_sym_null] = ACTIONS(3931),
    [anon_sym_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_COLON] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3931),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_LT_AT] = ACTIONS(3931),
    [anon_sym_LT_AT_AT] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3931),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3929),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3931),
    [anon_sym_return_BANG] = ACTIONS(3929),
    [anon_sym_yield] = ACTIONS(3931),
    [anon_sym_yield_BANG] = ACTIONS(3929),
    [anon_sym_lazy] = ACTIONS(3931),
    [anon_sym_assert] = ACTIONS(3931),
    [anon_sym_upcast] = ACTIONS(3931),
    [anon_sym_downcast] = ACTIONS(3931),
    [anon_sym_COLON_GT] = ACTIONS(3929),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3929),
    [anon_sym_for] = ACTIONS(3931),
    [anon_sym_while] = ACTIONS(3931),
    [anon_sym_if] = ACTIONS(3931),
    [anon_sym_fun] = ACTIONS(3931),
    [anon_sym_try] = ACTIONS(3931),
    [anon_sym_match] = ACTIONS(3931),
    [anon_sym_match_BANG] = ACTIONS(3929),
    [anon_sym_function] = ACTIONS(3931),
    [anon_sym_LT_DASH] = ACTIONS(3931),
    [anon_sym_DOT_LBRACK] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_use] = ACTIONS(3931),
    [anon_sym_use_BANG] = ACTIONS(3929),
    [anon_sym_do_BANG] = ACTIONS(3929),
    [anon_sym_begin] = ACTIONS(3931),
    [anon_sym_LPAREN2] = ACTIONS(3931),
    [anon_sym_default] = ACTIONS(3931),
    [anon_sym_or] = ACTIONS(3931),
    [anon_sym_static] = ACTIONS(3931),
    [anon_sym_member] = ACTIONS(3931),
    [anon_sym_interface] = ACTIONS(3931),
    [anon_sym_abstract] = ACTIONS(3931),
    [anon_sym_val] = ACTIONS(3931),
    [anon_sym_override] = ACTIONS(3931),
    [aux_sym_char_token1] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3931),
    [anon_sym_DQUOTE] = ACTIONS(3931),
    [anon_sym_AT_DQUOTE] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [sym_bool] = ACTIONS(3931),
    [sym_unit] = ACTIONS(3929),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3931),
    [sym_op_identifier] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3931),
    [anon_sym_DASH] = ACTIONS(3931),
    [anon_sym_PLUS_DOT] = ACTIONS(3931),
    [anon_sym_DASH_DOT] = ACTIONS(3931),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_TILDE] = ACTIONS(3929),
    [aux_sym_prefix_op_token1] = ACTIONS(3931),
    [aux_sym_infix_op_token1] = ACTIONS(3929),
    [aux_sym_infix_op_token2] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_COLON_EQ] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3931),
    [sym_int] = ACTIONS(3931),
    [sym_xint] = ACTIONS(3929),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3929),
    [anon_sym_POUNDendif] = ACTIONS(3929),
    [anon_sym_POUNDelse] = ACTIONS(3929),
    [sym__newline] = ACTIONS(3929),
  },
  [1798] = {
    [sym_block_comment] = STATE(1798),
    [sym_compiler_directive_decl] = STATE(1798),
    [sym_fsi_directive_decl] = STATE(1798),
    [sym_preproc_line] = STATE(1798),
    [sym_identifier] = ACTIONS(3917),
    [anon_sym_EQ] = ACTIONS(3915),
    [anon_sym_LBRACK_LT] = ACTIONS(3915),
    [anon_sym_COLON] = ACTIONS(3917),
    [anon_sym_return] = ACTIONS(3917),
    [anon_sym_do] = ACTIONS(3917),
    [anon_sym_and] = ACTIONS(3917),
    [anon_sym_let] = ACTIONS(3917),
    [anon_sym_let_BANG] = ACTIONS(3915),
    [aux_sym_access_modifier_token1] = ACTIONS(3915),
    [anon_sym_LPAREN] = ACTIONS(3917),
    [anon_sym_COMMA] = ACTIONS(3915),
    [anon_sym_null] = ACTIONS(3917),
    [anon_sym_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_COLON] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(3917),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3915),
    [anon_sym_LBRACE] = ACTIONS(3917),
    [anon_sym_LT_AT] = ACTIONS(3917),
    [anon_sym_LT_AT_AT] = ACTIONS(3917),
    [anon_sym_DOT] = ACTIONS(3917),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3915),
    [anon_sym_new] = ACTIONS(3917),
    [anon_sym_with] = ACTIONS(3917),
    [anon_sym_return_BANG] = ACTIONS(3915),
    [anon_sym_yield] = ACTIONS(3917),
    [anon_sym_yield_BANG] = ACTIONS(3915),
    [anon_sym_lazy] = ACTIONS(3917),
    [anon_sym_assert] = ACTIONS(3917),
    [anon_sym_upcast] = ACTIONS(3917),
    [anon_sym_downcast] = ACTIONS(3917),
    [anon_sym_COLON_GT] = ACTIONS(3915),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3915),
    [anon_sym_for] = ACTIONS(3917),
    [anon_sym_while] = ACTIONS(3917),
    [anon_sym_if] = ACTIONS(3917),
    [anon_sym_fun] = ACTIONS(3917),
    [anon_sym_try] = ACTIONS(3917),
    [anon_sym_match] = ACTIONS(3917),
    [anon_sym_match_BANG] = ACTIONS(3915),
    [anon_sym_function] = ACTIONS(3917),
    [anon_sym_LT_DASH] = ACTIONS(3917),
    [anon_sym_DOT_LBRACK] = ACTIONS(3915),
    [anon_sym_LT] = ACTIONS(3915),
    [anon_sym_use] = ACTIONS(3917),
    [anon_sym_use_BANG] = ACTIONS(3915),
    [anon_sym_do_BANG] = ACTIONS(3915),
    [anon_sym_begin] = ACTIONS(3917),
    [anon_sym_LPAREN2] = ACTIONS(3917),
    [anon_sym_default] = ACTIONS(3917),
    [anon_sym_or] = ACTIONS(3917),
    [anon_sym_static] = ACTIONS(3917),
    [anon_sym_member] = ACTIONS(3917),
    [anon_sym_interface] = ACTIONS(3917),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_val] = ACTIONS(3917),
    [anon_sym_override] = ACTIONS(3917),
    [aux_sym_char_token1] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_AT_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [sym_bool] = ACTIONS(3917),
    [sym_unit] = ACTIONS(3915),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3917),
    [sym_op_identifier] = ACTIONS(3917),
    [anon_sym_PLUS] = ACTIONS(3917),
    [anon_sym_DASH] = ACTIONS(3917),
    [anon_sym_PLUS_DOT] = ACTIONS(3917),
    [anon_sym_DASH_DOT] = ACTIONS(3917),
    [anon_sym_PERCENT] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_TILDE] = ACTIONS(3915),
    [aux_sym_prefix_op_token1] = ACTIONS(3917),
    [aux_sym_infix_op_token1] = ACTIONS(3915),
    [aux_sym_infix_op_token2] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_BANG_EQ] = ACTIONS(3917),
    [anon_sym_COLON_EQ] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3917),
    [sym_int] = ACTIONS(3917),
    [sym_xint] = ACTIONS(3915),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3915),
    [anon_sym_POUNDendif] = ACTIONS(3915),
    [anon_sym_POUNDelse] = ACTIONS(3915),
    [sym__newline] = ACTIONS(3915),
  },
  [1799] = {
    [sym_block_comment] = STATE(1799),
    [sym_compiler_directive_decl] = STATE(1799),
    [sym_fsi_directive_decl] = STATE(1799),
    [sym_preproc_line] = STATE(1799),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_AT_GT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(4364),
    [anon_sym_uy] = ACTIONS(4366),
    [anon_sym_s] = ACTIONS(4368),
    [anon_sym_us] = ACTIONS(4370),
    [anon_sym_l] = ACTIONS(4372),
    [aux_sym_uint32_token1] = ACTIONS(4374),
    [anon_sym_n] = ACTIONS(4376),
    [anon_sym_un] = ACTIONS(4378),
    [anon_sym_L] = ACTIONS(4380),
    [aux_sym_uint64_token1] = ACTIONS(4382),
    [anon_sym_lf] = ACTIONS(4704),
    [anon_sym_LF] = ACTIONS(4706),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1800] = {
    [sym_block_comment] = STATE(1800),
    [sym_compiler_directive_decl] = STATE(1800),
    [sym_fsi_directive_decl] = STATE(1800),
    [sym_preproc_line] = STATE(1800),
    [sym_identifier] = ACTIONS(3900),
    [anon_sym_EQ] = ACTIONS(3898),
    [anon_sym_LBRACK_LT] = ACTIONS(3898),
    [anon_sym_COLON] = ACTIONS(3900),
    [anon_sym_return] = ACTIONS(3900),
    [anon_sym_do] = ACTIONS(3900),
    [anon_sym_and] = ACTIONS(3900),
    [anon_sym_let] = ACTIONS(3900),
    [anon_sym_let_BANG] = ACTIONS(3898),
    [aux_sym_access_modifier_token1] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3898),
    [anon_sym_null] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_COLON] = ACTIONS(3898),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_LBRACK] = ACTIONS(3900),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3898),
    [anon_sym_LBRACE] = ACTIONS(3900),
    [anon_sym_LT_AT] = ACTIONS(3900),
    [anon_sym_LT_AT_AT] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(3900),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3898),
    [anon_sym_new] = ACTIONS(3900),
    [anon_sym_with] = ACTIONS(3900),
    [anon_sym_return_BANG] = ACTIONS(3898),
    [anon_sym_yield] = ACTIONS(3900),
    [anon_sym_yield_BANG] = ACTIONS(3898),
    [anon_sym_lazy] = ACTIONS(3900),
    [anon_sym_assert] = ACTIONS(3900),
    [anon_sym_upcast] = ACTIONS(3900),
    [anon_sym_downcast] = ACTIONS(3900),
    [anon_sym_COLON_GT] = ACTIONS(3898),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3898),
    [anon_sym_for] = ACTIONS(3900),
    [anon_sym_while] = ACTIONS(3900),
    [anon_sym_if] = ACTIONS(3900),
    [anon_sym_fun] = ACTIONS(3900),
    [anon_sym_try] = ACTIONS(3900),
    [anon_sym_match] = ACTIONS(3900),
    [anon_sym_match_BANG] = ACTIONS(3898),
    [anon_sym_function] = ACTIONS(3900),
    [anon_sym_LT_DASH] = ACTIONS(3900),
    [anon_sym_DOT_LBRACK] = ACTIONS(3898),
    [anon_sym_LT] = ACTIONS(3898),
    [anon_sym_use] = ACTIONS(3900),
    [anon_sym_use_BANG] = ACTIONS(3898),
    [anon_sym_do_BANG] = ACTIONS(3898),
    [anon_sym_begin] = ACTIONS(3900),
    [anon_sym_LPAREN2] = ACTIONS(3900),
    [anon_sym_default] = ACTIONS(3900),
    [anon_sym_or] = ACTIONS(3900),
    [anon_sym_static] = ACTIONS(3900),
    [anon_sym_member] = ACTIONS(3900),
    [anon_sym_interface] = ACTIONS(3900),
    [anon_sym_abstract] = ACTIONS(3900),
    [anon_sym_val] = ACTIONS(3900),
    [anon_sym_override] = ACTIONS(3900),
    [aux_sym_char_token1] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3900),
    [anon_sym_DQUOTE] = ACTIONS(3900),
    [anon_sym_AT_DQUOTE] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3898),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3900),
    [sym_op_identifier] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(3900),
    [anon_sym_DASH] = ACTIONS(3900),
    [anon_sym_PLUS_DOT] = ACTIONS(3900),
    [anon_sym_DASH_DOT] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(3900),
    [anon_sym_AMP_AMP] = ACTIONS(3900),
    [anon_sym_TILDE] = ACTIONS(3898),
    [aux_sym_prefix_op_token1] = ACTIONS(3900),
    [aux_sym_infix_op_token1] = ACTIONS(3898),
    [aux_sym_infix_op_token2] = ACTIONS(3900),
    [anon_sym_PIPE_PIPE] = ACTIONS(3900),
    [anon_sym_BANG_EQ] = ACTIONS(3900),
    [anon_sym_COLON_EQ] = ACTIONS(3898),
    [anon_sym_DOLLAR] = ACTIONS(3900),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3900),
    [sym_int] = ACTIONS(3900),
    [sym_xint] = ACTIONS(3898),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3898),
    [anon_sym_POUNDendif] = ACTIONS(3898),
    [anon_sym_POUNDelse] = ACTIONS(3898),
    [sym__newline] = ACTIONS(3898),
  },
  [1801] = {
    [sym_block_comment] = STATE(1801),
    [sym_compiler_directive_decl] = STATE(1801),
    [sym_fsi_directive_decl] = STATE(1801),
    [sym_preproc_line] = STATE(1801),
    [sym_identifier] = ACTIONS(3828),
    [anon_sym_EQ] = ACTIONS(3826),
    [anon_sym_LBRACK_LT] = ACTIONS(3826),
    [anon_sym_COLON] = ACTIONS(3828),
    [anon_sym_return] = ACTIONS(3828),
    [anon_sym_do] = ACTIONS(3828),
    [anon_sym_and] = ACTIONS(3828),
    [anon_sym_let] = ACTIONS(3828),
    [anon_sym_let_BANG] = ACTIONS(3826),
    [aux_sym_access_modifier_token1] = ACTIONS(3826),
    [anon_sym_LPAREN] = ACTIONS(3828),
    [anon_sym_COMMA] = ACTIONS(3826),
    [anon_sym_null] = ACTIONS(3828),
    [anon_sym_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_COLON] = ACTIONS(3826),
    [anon_sym_PIPE] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3828),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3826),
    [anon_sym_LBRACE] = ACTIONS(3828),
    [anon_sym_LT_AT] = ACTIONS(3828),
    [anon_sym_LT_AT_AT] = ACTIONS(3828),
    [anon_sym_DOT] = ACTIONS(3828),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3826),
    [anon_sym_new] = ACTIONS(3828),
    [anon_sym_with] = ACTIONS(3828),
    [anon_sym_return_BANG] = ACTIONS(3826),
    [anon_sym_yield] = ACTIONS(3828),
    [anon_sym_yield_BANG] = ACTIONS(3826),
    [anon_sym_lazy] = ACTIONS(3828),
    [anon_sym_assert] = ACTIONS(3828),
    [anon_sym_upcast] = ACTIONS(3828),
    [anon_sym_downcast] = ACTIONS(3828),
    [anon_sym_COLON_GT] = ACTIONS(3826),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3826),
    [anon_sym_for] = ACTIONS(3828),
    [anon_sym_while] = ACTIONS(3828),
    [anon_sym_if] = ACTIONS(3828),
    [anon_sym_fun] = ACTIONS(3828),
    [anon_sym_try] = ACTIONS(3828),
    [anon_sym_match] = ACTIONS(3828),
    [anon_sym_match_BANG] = ACTIONS(3826),
    [anon_sym_function] = ACTIONS(3828),
    [anon_sym_LT_DASH] = ACTIONS(3828),
    [anon_sym_DOT_LBRACK] = ACTIONS(3826),
    [anon_sym_LT] = ACTIONS(3826),
    [anon_sym_use] = ACTIONS(3828),
    [anon_sym_use_BANG] = ACTIONS(3826),
    [anon_sym_do_BANG] = ACTIONS(3826),
    [anon_sym_begin] = ACTIONS(3828),
    [anon_sym_LPAREN2] = ACTIONS(3828),
    [anon_sym_default] = ACTIONS(3828),
    [anon_sym_or] = ACTIONS(3828),
    [anon_sym_static] = ACTIONS(3828),
    [anon_sym_member] = ACTIONS(3828),
    [anon_sym_interface] = ACTIONS(3828),
    [anon_sym_abstract] = ACTIONS(3828),
    [anon_sym_val] = ACTIONS(3828),
    [anon_sym_override] = ACTIONS(3828),
    [aux_sym_char_token1] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3828),
    [anon_sym_DQUOTE] = ACTIONS(3828),
    [anon_sym_AT_DQUOTE] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [sym_bool] = ACTIONS(3828),
    [sym_unit] = ACTIONS(3826),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3828),
    [sym_op_identifier] = ACTIONS(3828),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_DASH] = ACTIONS(3828),
    [anon_sym_PLUS_DOT] = ACTIONS(3828),
    [anon_sym_DASH_DOT] = ACTIONS(3828),
    [anon_sym_PERCENT] = ACTIONS(3828),
    [anon_sym_AMP_AMP] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3826),
    [aux_sym_prefix_op_token1] = ACTIONS(3828),
    [aux_sym_infix_op_token1] = ACTIONS(3826),
    [aux_sym_infix_op_token2] = ACTIONS(3828),
    [anon_sym_PIPE_PIPE] = ACTIONS(3828),
    [anon_sym_BANG_EQ] = ACTIONS(3828),
    [anon_sym_COLON_EQ] = ACTIONS(3826),
    [anon_sym_DOLLAR] = ACTIONS(3828),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3828),
    [sym_int] = ACTIONS(3828),
    [sym_xint] = ACTIONS(3826),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3826),
    [sym__newline] = ACTIONS(3826),
    [sym__dedent] = ACTIONS(3826),
  },
  [1802] = {
    [sym_block_comment] = STATE(1802),
    [sym_compiler_directive_decl] = STATE(1802),
    [sym_fsi_directive_decl] = STATE(1802),
    [sym_preproc_line] = STATE(1802),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_LBRACK_LT] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [aux_sym_access_modifier_token1] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_DOT_DOT2] = ACTIONS(3698),
    [anon_sym_default] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [anon_sym_static] = ACTIONS(3700),
    [anon_sym_member] = ACTIONS(3700),
    [anon_sym_interface] = ACTIONS(3700),
    [anon_sym_abstract] = ACTIONS(3700),
    [anon_sym_val] = ACTIONS(3700),
    [anon_sym_override] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
    [sym__dedent] = ACTIONS(3698),
  },
  [1803] = {
    [sym_block_comment] = STATE(1803),
    [sym_compiler_directive_decl] = STATE(1803),
    [sym_fsi_directive_decl] = STATE(1803),
    [sym_preproc_line] = STATE(1803),
    [sym_identifier] = ACTIONS(4224),
    [anon_sym_EQ] = ACTIONS(4222),
    [anon_sym_LBRACK_LT] = ACTIONS(4222),
    [anon_sym_COLON] = ACTIONS(4224),
    [anon_sym_return] = ACTIONS(4224),
    [anon_sym_do] = ACTIONS(4224),
    [anon_sym_let] = ACTIONS(4224),
    [anon_sym_let_BANG] = ACTIONS(4222),
    [aux_sym_access_modifier_token1] = ACTIONS(4222),
    [anon_sym_LPAREN] = ACTIONS(4224),
    [anon_sym_COMMA] = ACTIONS(4222),
    [anon_sym_null] = ACTIONS(4224),
    [anon_sym_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_COLON] = ACTIONS(4222),
    [anon_sym_AMP] = ACTIONS(4224),
    [anon_sym_LBRACK] = ACTIONS(4224),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4222),
    [anon_sym_LBRACE] = ACTIONS(4224),
    [anon_sym_LT_AT] = ACTIONS(4224),
    [anon_sym_LT_AT_AT] = ACTIONS(4224),
    [anon_sym_DOT] = ACTIONS(4224),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4222),
    [anon_sym_new] = ACTIONS(4224),
    [anon_sym_with] = ACTIONS(4224),
    [anon_sym_return_BANG] = ACTIONS(4222),
    [anon_sym_yield] = ACTIONS(4224),
    [anon_sym_yield_BANG] = ACTIONS(4222),
    [anon_sym_lazy] = ACTIONS(4224),
    [anon_sym_assert] = ACTIONS(4224),
    [anon_sym_upcast] = ACTIONS(4224),
    [anon_sym_downcast] = ACTIONS(4224),
    [anon_sym_COLON_GT] = ACTIONS(4222),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4222),
    [anon_sym_for] = ACTIONS(4224),
    [anon_sym_while] = ACTIONS(4224),
    [anon_sym_if] = ACTIONS(4224),
    [anon_sym_fun] = ACTIONS(4224),
    [anon_sym_try] = ACTIONS(4224),
    [anon_sym_match] = ACTIONS(4224),
    [anon_sym_match_BANG] = ACTIONS(4222),
    [anon_sym_function] = ACTIONS(4224),
    [anon_sym_LT_DASH] = ACTIONS(4224),
    [anon_sym_DOT_LBRACK] = ACTIONS(4222),
    [anon_sym_LT] = ACTIONS(4222),
    [anon_sym_use] = ACTIONS(4224),
    [anon_sym_use_BANG] = ACTIONS(4222),
    [anon_sym_do_BANG] = ACTIONS(4222),
    [anon_sym_begin] = ACTIONS(4224),
    [anon_sym_LPAREN2] = ACTIONS(4224),
    [anon_sym_default] = ACTIONS(4224),
    [anon_sym_or] = ACTIONS(4224),
    [anon_sym_static] = ACTIONS(4224),
    [anon_sym_member] = ACTIONS(4224),
    [anon_sym_interface] = ACTIONS(4224),
    [anon_sym_abstract] = ACTIONS(4224),
    [anon_sym_val] = ACTIONS(4224),
    [anon_sym_override] = ACTIONS(4224),
    [anon_sym_inherit] = ACTIONS(4224),
    [aux_sym_char_token1] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4224),
    [anon_sym_DQUOTE] = ACTIONS(4224),
    [anon_sym_AT_DQUOTE] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [sym_bool] = ACTIONS(4224),
    [sym_unit] = ACTIONS(4222),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4224),
    [sym_op_identifier] = ACTIONS(4224),
    [anon_sym_PLUS] = ACTIONS(4224),
    [anon_sym_DASH] = ACTIONS(4224),
    [anon_sym_PLUS_DOT] = ACTIONS(4224),
    [anon_sym_DASH_DOT] = ACTIONS(4224),
    [anon_sym_PERCENT] = ACTIONS(4224),
    [anon_sym_AMP_AMP] = ACTIONS(4224),
    [anon_sym_TILDE] = ACTIONS(4222),
    [aux_sym_prefix_op_token1] = ACTIONS(4224),
    [aux_sym_infix_op_token1] = ACTIONS(4222),
    [aux_sym_infix_op_token2] = ACTIONS(4224),
    [anon_sym_PIPE_PIPE] = ACTIONS(4224),
    [anon_sym_BANG_EQ] = ACTIONS(4224),
    [anon_sym_COLON_EQ] = ACTIONS(4222),
    [anon_sym_DOLLAR] = ACTIONS(4224),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4224),
    [sym_int] = ACTIONS(4224),
    [sym_xint] = ACTIONS(4222),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4222),
    [anon_sym_POUNDendif] = ACTIONS(4222),
    [anon_sym_POUNDelse] = ACTIONS(4222),
    [sym__newline] = ACTIONS(4222),
  },
  [1804] = {
    [sym_block_comment] = STATE(1804),
    [sym_compiler_directive_decl] = STATE(1804),
    [sym_fsi_directive_decl] = STATE(1804),
    [sym_preproc_line] = STATE(1804),
    [sym_identifier] = ACTIONS(3893),
    [anon_sym_EQ] = ACTIONS(3891),
    [anon_sym_LBRACK_LT] = ACTIONS(3891),
    [anon_sym_COLON] = ACTIONS(3893),
    [anon_sym_return] = ACTIONS(3893),
    [anon_sym_do] = ACTIONS(3893),
    [anon_sym_and] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_let_BANG] = ACTIONS(3891),
    [aux_sym_access_modifier_token1] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_COMMA] = ACTIONS(3891),
    [anon_sym_null] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_COLON] = ACTIONS(3891),
    [anon_sym_AMP] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3891),
    [anon_sym_LBRACE] = ACTIONS(3893),
    [anon_sym_LT_AT] = ACTIONS(3893),
    [anon_sym_LT_AT_AT] = ACTIONS(3893),
    [anon_sym_DOT] = ACTIONS(3893),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3891),
    [anon_sym_new] = ACTIONS(3893),
    [anon_sym_with] = ACTIONS(3893),
    [anon_sym_return_BANG] = ACTIONS(3891),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_yield_BANG] = ACTIONS(3891),
    [anon_sym_lazy] = ACTIONS(3893),
    [anon_sym_assert] = ACTIONS(3893),
    [anon_sym_upcast] = ACTIONS(3893),
    [anon_sym_downcast] = ACTIONS(3893),
    [anon_sym_COLON_GT] = ACTIONS(3891),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3891),
    [anon_sym_for] = ACTIONS(3893),
    [anon_sym_while] = ACTIONS(3893),
    [anon_sym_if] = ACTIONS(3893),
    [anon_sym_fun] = ACTIONS(3893),
    [anon_sym_try] = ACTIONS(3893),
    [anon_sym_match] = ACTIONS(3893),
    [anon_sym_match_BANG] = ACTIONS(3891),
    [anon_sym_function] = ACTIONS(3893),
    [anon_sym_LT_DASH] = ACTIONS(3893),
    [anon_sym_DOT_LBRACK] = ACTIONS(3891),
    [anon_sym_LT] = ACTIONS(3891),
    [anon_sym_use] = ACTIONS(3893),
    [anon_sym_use_BANG] = ACTIONS(3891),
    [anon_sym_do_BANG] = ACTIONS(3891),
    [anon_sym_begin] = ACTIONS(3893),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_default] = ACTIONS(3893),
    [anon_sym_or] = ACTIONS(3893),
    [anon_sym_static] = ACTIONS(3893),
    [anon_sym_member] = ACTIONS(3893),
    [anon_sym_interface] = ACTIONS(3893),
    [anon_sym_abstract] = ACTIONS(3893),
    [anon_sym_val] = ACTIONS(3893),
    [anon_sym_override] = ACTIONS(3893),
    [aux_sym_char_token1] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3893),
    [anon_sym_DQUOTE] = ACTIONS(3893),
    [anon_sym_AT_DQUOTE] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [sym_bool] = ACTIONS(3893),
    [sym_unit] = ACTIONS(3891),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3893),
    [sym_op_identifier] = ACTIONS(3893),
    [anon_sym_PLUS] = ACTIONS(3893),
    [anon_sym_DASH] = ACTIONS(3893),
    [anon_sym_PLUS_DOT] = ACTIONS(3893),
    [anon_sym_DASH_DOT] = ACTIONS(3893),
    [anon_sym_PERCENT] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_TILDE] = ACTIONS(3891),
    [aux_sym_prefix_op_token1] = ACTIONS(3893),
    [aux_sym_infix_op_token1] = ACTIONS(3891),
    [aux_sym_infix_op_token2] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [anon_sym_BANG_EQ] = ACTIONS(3893),
    [anon_sym_COLON_EQ] = ACTIONS(3891),
    [anon_sym_DOLLAR] = ACTIONS(3893),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3893),
    [sym_int] = ACTIONS(3893),
    [sym_xint] = ACTIONS(3891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3891),
    [anon_sym_POUNDendif] = ACTIONS(3891),
    [anon_sym_POUNDelse] = ACTIONS(3891),
    [sym__newline] = ACTIONS(3891),
  },
  [1805] = {
    [sym_block_comment] = STATE(1805),
    [sym_compiler_directive_decl] = STATE(1805),
    [sym_fsi_directive_decl] = STATE(1805),
    [sym_preproc_line] = STATE(1805),
    [sym_identifier] = ACTIONS(3907),
    [anon_sym_EQ] = ACTIONS(3905),
    [anon_sym_LBRACK_LT] = ACTIONS(3905),
    [anon_sym_COLON] = ACTIONS(3907),
    [anon_sym_return] = ACTIONS(3907),
    [anon_sym_do] = ACTIONS(3907),
    [anon_sym_and] = ACTIONS(3907),
    [anon_sym_let] = ACTIONS(3907),
    [anon_sym_let_BANG] = ACTIONS(3905),
    [aux_sym_access_modifier_token1] = ACTIONS(3905),
    [anon_sym_LPAREN] = ACTIONS(3907),
    [anon_sym_COMMA] = ACTIONS(3905),
    [anon_sym_null] = ACTIONS(3907),
    [anon_sym_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_COLON] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3907),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3905),
    [anon_sym_LBRACE] = ACTIONS(3907),
    [anon_sym_LT_AT] = ACTIONS(3907),
    [anon_sym_LT_AT_AT] = ACTIONS(3907),
    [anon_sym_DOT] = ACTIONS(3907),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3905),
    [anon_sym_new] = ACTIONS(3907),
    [anon_sym_with] = ACTIONS(3907),
    [anon_sym_return_BANG] = ACTIONS(3905),
    [anon_sym_yield] = ACTIONS(3907),
    [anon_sym_yield_BANG] = ACTIONS(3905),
    [anon_sym_lazy] = ACTIONS(3907),
    [anon_sym_assert] = ACTIONS(3907),
    [anon_sym_upcast] = ACTIONS(3907),
    [anon_sym_downcast] = ACTIONS(3907),
    [anon_sym_COLON_GT] = ACTIONS(3905),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3905),
    [anon_sym_for] = ACTIONS(3907),
    [anon_sym_while] = ACTIONS(3907),
    [anon_sym_if] = ACTIONS(3907),
    [anon_sym_fun] = ACTIONS(3907),
    [anon_sym_try] = ACTIONS(3907),
    [anon_sym_match] = ACTIONS(3907),
    [anon_sym_match_BANG] = ACTIONS(3905),
    [anon_sym_function] = ACTIONS(3907),
    [anon_sym_LT_DASH] = ACTIONS(3907),
    [anon_sym_DOT_LBRACK] = ACTIONS(3905),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_use] = ACTIONS(3907),
    [anon_sym_use_BANG] = ACTIONS(3905),
    [anon_sym_do_BANG] = ACTIONS(3905),
    [anon_sym_begin] = ACTIONS(3907),
    [anon_sym_LPAREN2] = ACTIONS(3907),
    [anon_sym_default] = ACTIONS(3907),
    [anon_sym_or] = ACTIONS(3907),
    [anon_sym_static] = ACTIONS(3907),
    [anon_sym_member] = ACTIONS(3907),
    [anon_sym_interface] = ACTIONS(3907),
    [anon_sym_abstract] = ACTIONS(3907),
    [anon_sym_val] = ACTIONS(3907),
    [anon_sym_override] = ACTIONS(3907),
    [aux_sym_char_token1] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3907),
    [anon_sym_DQUOTE] = ACTIONS(3907),
    [anon_sym_AT_DQUOTE] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [sym_bool] = ACTIONS(3907),
    [sym_unit] = ACTIONS(3905),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3907),
    [sym_op_identifier] = ACTIONS(3907),
    [anon_sym_PLUS] = ACTIONS(3907),
    [anon_sym_DASH] = ACTIONS(3907),
    [anon_sym_PLUS_DOT] = ACTIONS(3907),
    [anon_sym_DASH_DOT] = ACTIONS(3907),
    [anon_sym_PERCENT] = ACTIONS(3907),
    [anon_sym_AMP_AMP] = ACTIONS(3907),
    [anon_sym_TILDE] = ACTIONS(3905),
    [aux_sym_prefix_op_token1] = ACTIONS(3907),
    [aux_sym_infix_op_token1] = ACTIONS(3905),
    [aux_sym_infix_op_token2] = ACTIONS(3907),
    [anon_sym_PIPE_PIPE] = ACTIONS(3907),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_COLON_EQ] = ACTIONS(3905),
    [anon_sym_DOLLAR] = ACTIONS(3907),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3907),
    [sym_int] = ACTIONS(3907),
    [sym_xint] = ACTIONS(3905),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3905),
    [anon_sym_POUNDendif] = ACTIONS(3905),
    [anon_sym_POUNDelse] = ACTIONS(3905),
    [sym__newline] = ACTIONS(3905),
  },
  [1806] = {
    [sym_block_comment] = STATE(1806),
    [sym_compiler_directive_decl] = STATE(1806),
    [sym_fsi_directive_decl] = STATE(1806),
    [sym_preproc_line] = STATE(1806),
    [sym_identifier] = ACTIONS(3863),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_LBRACK_LT] = ACTIONS(3861),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_and] = ACTIONS(3863),
    [anon_sym_let] = ACTIONS(3863),
    [anon_sym_let_BANG] = ACTIONS(3861),
    [aux_sym_access_modifier_token1] = ACTIONS(3861),
    [anon_sym_LPAREN] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3861),
    [anon_sym_null] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_COLON] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_LT_AT] = ACTIONS(3863),
    [anon_sym_LT_AT_AT] = ACTIONS(3863),
    [anon_sym_DOT] = ACTIONS(3863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3861),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_with] = ACTIONS(3863),
    [anon_sym_return_BANG] = ACTIONS(3861),
    [anon_sym_yield] = ACTIONS(3863),
    [anon_sym_yield_BANG] = ACTIONS(3861),
    [anon_sym_lazy] = ACTIONS(3863),
    [anon_sym_assert] = ACTIONS(3863),
    [anon_sym_upcast] = ACTIONS(3863),
    [anon_sym_downcast] = ACTIONS(3863),
    [anon_sym_COLON_GT] = ACTIONS(3861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_fun] = ACTIONS(3863),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_match] = ACTIONS(3863),
    [anon_sym_match_BANG] = ACTIONS(3861),
    [anon_sym_function] = ACTIONS(3863),
    [anon_sym_LT_DASH] = ACTIONS(3863),
    [anon_sym_DOT_LBRACK] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_use] = ACTIONS(3863),
    [anon_sym_use_BANG] = ACTIONS(3861),
    [anon_sym_do_BANG] = ACTIONS(3861),
    [anon_sym_begin] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(3863),
    [anon_sym_default] = ACTIONS(3863),
    [anon_sym_or] = ACTIONS(3863),
    [anon_sym_static] = ACTIONS(3863),
    [anon_sym_member] = ACTIONS(3863),
    [anon_sym_interface] = ACTIONS(3863),
    [anon_sym_abstract] = ACTIONS(3863),
    [anon_sym_val] = ACTIONS(3863),
    [anon_sym_override] = ACTIONS(3863),
    [aux_sym_char_token1] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [anon_sym_AT_DQUOTE] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [sym_bool] = ACTIONS(3863),
    [sym_unit] = ACTIONS(3861),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3863),
    [sym_op_identifier] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_DOT] = ACTIONS(3863),
    [anon_sym_DASH_DOT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3861),
    [aux_sym_prefix_op_token1] = ACTIONS(3863),
    [aux_sym_infix_op_token1] = ACTIONS(3861),
    [aux_sym_infix_op_token2] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_COLON_EQ] = ACTIONS(3861),
    [anon_sym_DOLLAR] = ACTIONS(3863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3863),
    [sym_int] = ACTIONS(3863),
    [sym_xint] = ACTIONS(3861),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3861),
    [anon_sym_POUNDendif] = ACTIONS(3861),
    [anon_sym_POUNDelse] = ACTIONS(3861),
    [sym__newline] = ACTIONS(3861),
  },
  [1807] = {
    [sym_block_comment] = STATE(1807),
    [sym_compiler_directive_decl] = STATE(1807),
    [sym_fsi_directive_decl] = STATE(1807),
    [sym_preproc_line] = STATE(1807),
    [sym_identifier] = ACTIONS(3856),
    [anon_sym_EQ] = ACTIONS(3854),
    [anon_sym_LBRACK_LT] = ACTIONS(3854),
    [anon_sym_COLON] = ACTIONS(3856),
    [anon_sym_return] = ACTIONS(3856),
    [anon_sym_do] = ACTIONS(3856),
    [anon_sym_and] = ACTIONS(3856),
    [anon_sym_let] = ACTIONS(3856),
    [anon_sym_let_BANG] = ACTIONS(3854),
    [aux_sym_access_modifier_token1] = ACTIONS(3854),
    [anon_sym_LPAREN] = ACTIONS(3856),
    [anon_sym_COMMA] = ACTIONS(3854),
    [anon_sym_null] = ACTIONS(3856),
    [anon_sym_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_AMP] = ACTIONS(3856),
    [anon_sym_LBRACK] = ACTIONS(3856),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3854),
    [anon_sym_LBRACE] = ACTIONS(3856),
    [anon_sym_LT_AT] = ACTIONS(3856),
    [anon_sym_LT_AT_AT] = ACTIONS(3856),
    [anon_sym_DOT] = ACTIONS(3856),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3854),
    [anon_sym_new] = ACTIONS(3856),
    [anon_sym_with] = ACTIONS(3856),
    [anon_sym_return_BANG] = ACTIONS(3854),
    [anon_sym_yield] = ACTIONS(3856),
    [anon_sym_yield_BANG] = ACTIONS(3854),
    [anon_sym_lazy] = ACTIONS(3856),
    [anon_sym_assert] = ACTIONS(3856),
    [anon_sym_upcast] = ACTIONS(3856),
    [anon_sym_downcast] = ACTIONS(3856),
    [anon_sym_COLON_GT] = ACTIONS(3854),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3854),
    [anon_sym_for] = ACTIONS(3856),
    [anon_sym_while] = ACTIONS(3856),
    [anon_sym_if] = ACTIONS(3856),
    [anon_sym_fun] = ACTIONS(3856),
    [anon_sym_try] = ACTIONS(3856),
    [anon_sym_match] = ACTIONS(3856),
    [anon_sym_match_BANG] = ACTIONS(3854),
    [anon_sym_function] = ACTIONS(3856),
    [anon_sym_LT_DASH] = ACTIONS(3856),
    [anon_sym_DOT_LBRACK] = ACTIONS(3854),
    [anon_sym_LT] = ACTIONS(3854),
    [anon_sym_use] = ACTIONS(3856),
    [anon_sym_use_BANG] = ACTIONS(3854),
    [anon_sym_do_BANG] = ACTIONS(3854),
    [anon_sym_begin] = ACTIONS(3856),
    [anon_sym_LPAREN2] = ACTIONS(3856),
    [anon_sym_default] = ACTIONS(3856),
    [anon_sym_or] = ACTIONS(3856),
    [anon_sym_static] = ACTIONS(3856),
    [anon_sym_member] = ACTIONS(3856),
    [anon_sym_interface] = ACTIONS(3856),
    [anon_sym_abstract] = ACTIONS(3856),
    [anon_sym_val] = ACTIONS(3856),
    [anon_sym_override] = ACTIONS(3856),
    [aux_sym_char_token1] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3856),
    [anon_sym_DQUOTE] = ACTIONS(3856),
    [anon_sym_AT_DQUOTE] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [sym_bool] = ACTIONS(3856),
    [sym_unit] = ACTIONS(3854),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3856),
    [sym_op_identifier] = ACTIONS(3856),
    [anon_sym_PLUS] = ACTIONS(3856),
    [anon_sym_DASH] = ACTIONS(3856),
    [anon_sym_PLUS_DOT] = ACTIONS(3856),
    [anon_sym_DASH_DOT] = ACTIONS(3856),
    [anon_sym_PERCENT] = ACTIONS(3856),
    [anon_sym_AMP_AMP] = ACTIONS(3856),
    [anon_sym_TILDE] = ACTIONS(3854),
    [aux_sym_prefix_op_token1] = ACTIONS(3856),
    [aux_sym_infix_op_token1] = ACTIONS(3854),
    [aux_sym_infix_op_token2] = ACTIONS(3856),
    [anon_sym_PIPE_PIPE] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3856),
    [anon_sym_COLON_EQ] = ACTIONS(3854),
    [anon_sym_DOLLAR] = ACTIONS(3856),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3856),
    [sym_int] = ACTIONS(3856),
    [sym_xint] = ACTIONS(3854),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3854),
    [anon_sym_POUNDendif] = ACTIONS(3854),
    [anon_sym_POUNDelse] = ACTIONS(3854),
    [sym__newline] = ACTIONS(3854),
  },
  [1808] = {
    [sym_block_comment] = STATE(1808),
    [sym_compiler_directive_decl] = STATE(1808),
    [sym_fsi_directive_decl] = STATE(1808),
    [sym_preproc_line] = STATE(1808),
    [sym_identifier] = ACTIONS(3841),
    [anon_sym_EQ] = ACTIONS(3839),
    [anon_sym_LBRACK_LT] = ACTIONS(3839),
    [anon_sym_COLON] = ACTIONS(3841),
    [anon_sym_return] = ACTIONS(3841),
    [anon_sym_do] = ACTIONS(3841),
    [anon_sym_and] = ACTIONS(3841),
    [anon_sym_let] = ACTIONS(3841),
    [anon_sym_let_BANG] = ACTIONS(3839),
    [aux_sym_access_modifier_token1] = ACTIONS(3839),
    [anon_sym_LPAREN] = ACTIONS(3841),
    [anon_sym_COMMA] = ACTIONS(3839),
    [anon_sym_null] = ACTIONS(3841),
    [anon_sym_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_COLON] = ACTIONS(3839),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_AMP] = ACTIONS(3841),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(3841),
    [anon_sym_LT_AT] = ACTIONS(3841),
    [anon_sym_LT_AT_AT] = ACTIONS(3841),
    [anon_sym_DOT] = ACTIONS(3841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3839),
    [anon_sym_new] = ACTIONS(3841),
    [anon_sym_with] = ACTIONS(3841),
    [anon_sym_return_BANG] = ACTIONS(3839),
    [anon_sym_yield] = ACTIONS(3841),
    [anon_sym_yield_BANG] = ACTIONS(3839),
    [anon_sym_lazy] = ACTIONS(3841),
    [anon_sym_assert] = ACTIONS(3841),
    [anon_sym_upcast] = ACTIONS(3841),
    [anon_sym_downcast] = ACTIONS(3841),
    [anon_sym_COLON_GT] = ACTIONS(3839),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3839),
    [anon_sym_for] = ACTIONS(3841),
    [anon_sym_while] = ACTIONS(3841),
    [anon_sym_if] = ACTIONS(3841),
    [anon_sym_fun] = ACTIONS(3841),
    [anon_sym_try] = ACTIONS(3841),
    [anon_sym_match] = ACTIONS(3841),
    [anon_sym_match_BANG] = ACTIONS(3839),
    [anon_sym_function] = ACTIONS(3841),
    [anon_sym_LT_DASH] = ACTIONS(3841),
    [anon_sym_DOT_LBRACK] = ACTIONS(3839),
    [anon_sym_LT] = ACTIONS(3839),
    [anon_sym_use] = ACTIONS(3841),
    [anon_sym_use_BANG] = ACTIONS(3839),
    [anon_sym_do_BANG] = ACTIONS(3839),
    [anon_sym_begin] = ACTIONS(3841),
    [anon_sym_LPAREN2] = ACTIONS(3841),
    [anon_sym_default] = ACTIONS(3841),
    [anon_sym_or] = ACTIONS(3841),
    [anon_sym_static] = ACTIONS(3841),
    [anon_sym_member] = ACTIONS(3841),
    [anon_sym_interface] = ACTIONS(3841),
    [anon_sym_abstract] = ACTIONS(3841),
    [anon_sym_val] = ACTIONS(3841),
    [anon_sym_override] = ACTIONS(3841),
    [aux_sym_char_token1] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3841),
    [anon_sym_DQUOTE] = ACTIONS(3841),
    [anon_sym_AT_DQUOTE] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [sym_bool] = ACTIONS(3841),
    [sym_unit] = ACTIONS(3839),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3841),
    [sym_op_identifier] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_PLUS_DOT] = ACTIONS(3841),
    [anon_sym_DASH_DOT] = ACTIONS(3841),
    [anon_sym_PERCENT] = ACTIONS(3841),
    [anon_sym_AMP_AMP] = ACTIONS(3841),
    [anon_sym_TILDE] = ACTIONS(3839),
    [aux_sym_prefix_op_token1] = ACTIONS(3841),
    [aux_sym_infix_op_token1] = ACTIONS(3839),
    [aux_sym_infix_op_token2] = ACTIONS(3841),
    [anon_sym_PIPE_PIPE] = ACTIONS(3841),
    [anon_sym_BANG_EQ] = ACTIONS(3841),
    [anon_sym_COLON_EQ] = ACTIONS(3839),
    [anon_sym_DOLLAR] = ACTIONS(3841),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3841),
    [sym_int] = ACTIONS(3841),
    [sym_xint] = ACTIONS(3839),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3839),
    [sym__newline] = ACTIONS(3839),
    [sym__dedent] = ACTIONS(3839),
  },
  [1809] = {
    [sym_block_comment] = STATE(1809),
    [sym_compiler_directive_decl] = STATE(1809),
    [sym_fsi_directive_decl] = STATE(1809),
    [sym_preproc_line] = STATE(1809),
    [sym_identifier] = ACTIONS(4137),
    [anon_sym_EQ] = ACTIONS(4135),
    [anon_sym_LBRACK_LT] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4137),
    [anon_sym_return] = ACTIONS(4137),
    [anon_sym_do] = ACTIONS(4137),
    [anon_sym_and] = ACTIONS(4137),
    [anon_sym_let] = ACTIONS(4137),
    [anon_sym_let_BANG] = ACTIONS(4135),
    [aux_sym_access_modifier_token1] = ACTIONS(4135),
    [anon_sym_LPAREN] = ACTIONS(4137),
    [anon_sym_COMMA] = ACTIONS(4135),
    [anon_sym_null] = ACTIONS(4137),
    [anon_sym_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_COLON] = ACTIONS(4135),
    [anon_sym_AMP] = ACTIONS(4137),
    [anon_sym_LBRACK] = ACTIONS(4137),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4135),
    [anon_sym_LBRACE] = ACTIONS(4137),
    [anon_sym_LT_AT] = ACTIONS(4137),
    [anon_sym_LT_AT_AT] = ACTIONS(4137),
    [anon_sym_DOT] = ACTIONS(4137),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4135),
    [anon_sym_new] = ACTIONS(4137),
    [anon_sym_with] = ACTIONS(4137),
    [anon_sym_return_BANG] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_yield_BANG] = ACTIONS(4135),
    [anon_sym_lazy] = ACTIONS(4137),
    [anon_sym_assert] = ACTIONS(4137),
    [anon_sym_upcast] = ACTIONS(4137),
    [anon_sym_downcast] = ACTIONS(4137),
    [anon_sym_COLON_GT] = ACTIONS(4135),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4135),
    [anon_sym_for] = ACTIONS(4137),
    [anon_sym_while] = ACTIONS(4137),
    [anon_sym_if] = ACTIONS(4137),
    [anon_sym_fun] = ACTIONS(4137),
    [anon_sym_try] = ACTIONS(4137),
    [anon_sym_match] = ACTIONS(4137),
    [anon_sym_match_BANG] = ACTIONS(4135),
    [anon_sym_function] = ACTIONS(4137),
    [anon_sym_LT_DASH] = ACTIONS(4137),
    [anon_sym_DOT_LBRACK] = ACTIONS(4135),
    [anon_sym_LT] = ACTIONS(4135),
    [anon_sym_use] = ACTIONS(4137),
    [anon_sym_use_BANG] = ACTIONS(4135),
    [anon_sym_do_BANG] = ACTIONS(4135),
    [anon_sym_begin] = ACTIONS(4137),
    [anon_sym_LPAREN2] = ACTIONS(4137),
    [anon_sym_default] = ACTIONS(4137),
    [anon_sym_or] = ACTIONS(4137),
    [anon_sym_static] = ACTIONS(4137),
    [anon_sym_member] = ACTIONS(4137),
    [anon_sym_interface] = ACTIONS(4137),
    [anon_sym_abstract] = ACTIONS(4137),
    [anon_sym_val] = ACTIONS(4137),
    [anon_sym_override] = ACTIONS(4137),
    [aux_sym_char_token1] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4137),
    [anon_sym_DQUOTE] = ACTIONS(4137),
    [anon_sym_AT_DQUOTE] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [sym_bool] = ACTIONS(4137),
    [sym_unit] = ACTIONS(4135),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4137),
    [sym_op_identifier] = ACTIONS(4137),
    [anon_sym_PLUS] = ACTIONS(4137),
    [anon_sym_DASH] = ACTIONS(4137),
    [anon_sym_PLUS_DOT] = ACTIONS(4137),
    [anon_sym_DASH_DOT] = ACTIONS(4137),
    [anon_sym_PERCENT] = ACTIONS(4137),
    [anon_sym_AMP_AMP] = ACTIONS(4137),
    [anon_sym_TILDE] = ACTIONS(4135),
    [aux_sym_prefix_op_token1] = ACTIONS(4137),
    [aux_sym_infix_op_token1] = ACTIONS(4135),
    [aux_sym_infix_op_token2] = ACTIONS(4137),
    [anon_sym_PIPE_PIPE] = ACTIONS(4137),
    [anon_sym_BANG_EQ] = ACTIONS(4137),
    [anon_sym_COLON_EQ] = ACTIONS(4135),
    [anon_sym_DOLLAR] = ACTIONS(4137),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4137),
    [sym_int] = ACTIONS(4137),
    [sym_xint] = ACTIONS(4135),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4135),
    [anon_sym_POUNDendif] = ACTIONS(4135),
    [anon_sym_POUNDelse] = ACTIONS(4135),
    [sym__newline] = ACTIONS(4135),
  },
  [1810] = {
    [sym_block_comment] = STATE(1810),
    [sym_compiler_directive_decl] = STATE(1810),
    [sym_fsi_directive_decl] = STATE(1810),
    [sym_preproc_line] = STATE(1810),
    [sym_identifier] = ACTIONS(4064),
    [anon_sym_EQ] = ACTIONS(4062),
    [anon_sym_LBRACK_LT] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4064),
    [anon_sym_return] = ACTIONS(4064),
    [anon_sym_do] = ACTIONS(4064),
    [anon_sym_and] = ACTIONS(4064),
    [anon_sym_let] = ACTIONS(4064),
    [anon_sym_let_BANG] = ACTIONS(4062),
    [aux_sym_access_modifier_token1] = ACTIONS(4062),
    [anon_sym_LPAREN] = ACTIONS(4064),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_null] = ACTIONS(4064),
    [anon_sym_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_COLON] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4062),
    [anon_sym_LBRACE] = ACTIONS(4064),
    [anon_sym_LT_AT] = ACTIONS(4064),
    [anon_sym_LT_AT_AT] = ACTIONS(4064),
    [anon_sym_DOT] = ACTIONS(4064),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4062),
    [anon_sym_new] = ACTIONS(4064),
    [anon_sym_with] = ACTIONS(4064),
    [anon_sym_return_BANG] = ACTIONS(4062),
    [anon_sym_yield] = ACTIONS(4064),
    [anon_sym_yield_BANG] = ACTIONS(4062),
    [anon_sym_lazy] = ACTIONS(4064),
    [anon_sym_assert] = ACTIONS(4064),
    [anon_sym_upcast] = ACTIONS(4064),
    [anon_sym_downcast] = ACTIONS(4064),
    [anon_sym_COLON_GT] = ACTIONS(4062),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4062),
    [anon_sym_for] = ACTIONS(4064),
    [anon_sym_while] = ACTIONS(4064),
    [anon_sym_if] = ACTIONS(4064),
    [anon_sym_fun] = ACTIONS(4064),
    [anon_sym_try] = ACTIONS(4064),
    [anon_sym_match] = ACTIONS(4064),
    [anon_sym_match_BANG] = ACTIONS(4062),
    [anon_sym_function] = ACTIONS(4064),
    [anon_sym_LT_DASH] = ACTIONS(4064),
    [anon_sym_DOT_LBRACK] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(4062),
    [anon_sym_use] = ACTIONS(4064),
    [anon_sym_use_BANG] = ACTIONS(4062),
    [anon_sym_do_BANG] = ACTIONS(4062),
    [anon_sym_begin] = ACTIONS(4064),
    [anon_sym_LPAREN2] = ACTIONS(4064),
    [anon_sym_default] = ACTIONS(4064),
    [anon_sym_or] = ACTIONS(4064),
    [anon_sym_static] = ACTIONS(4064),
    [anon_sym_member] = ACTIONS(4064),
    [anon_sym_interface] = ACTIONS(4064),
    [anon_sym_abstract] = ACTIONS(4064),
    [anon_sym_val] = ACTIONS(4064),
    [anon_sym_override] = ACTIONS(4064),
    [aux_sym_char_token1] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_AT_DQUOTE] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [sym_bool] = ACTIONS(4064),
    [sym_unit] = ACTIONS(4062),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4064),
    [sym_op_identifier] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4064),
    [anon_sym_DASH] = ACTIONS(4064),
    [anon_sym_PLUS_DOT] = ACTIONS(4064),
    [anon_sym_DASH_DOT] = ACTIONS(4064),
    [anon_sym_PERCENT] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_TILDE] = ACTIONS(4062),
    [aux_sym_prefix_op_token1] = ACTIONS(4064),
    [aux_sym_infix_op_token1] = ACTIONS(4062),
    [aux_sym_infix_op_token2] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_BANG_EQ] = ACTIONS(4064),
    [anon_sym_COLON_EQ] = ACTIONS(4062),
    [anon_sym_DOLLAR] = ACTIONS(4064),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4064),
    [sym_int] = ACTIONS(4064),
    [sym_xint] = ACTIONS(4062),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4062),
    [anon_sym_POUNDendif] = ACTIONS(4062),
    [anon_sym_POUNDelse] = ACTIONS(4062),
    [sym__newline] = ACTIONS(4062),
  },
  [1811] = {
    [sym_block_comment] = STATE(1811),
    [sym_compiler_directive_decl] = STATE(1811),
    [sym_fsi_directive_decl] = STATE(1811),
    [sym_preproc_line] = STATE(1811),
    [sym_identifier] = ACTIONS(4130),
    [anon_sym_EQ] = ACTIONS(4128),
    [anon_sym_LBRACK_LT] = ACTIONS(4128),
    [anon_sym_COLON] = ACTIONS(4130),
    [anon_sym_return] = ACTIONS(4130),
    [anon_sym_do] = ACTIONS(4130),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_let] = ACTIONS(4130),
    [anon_sym_let_BANG] = ACTIONS(4128),
    [aux_sym_access_modifier_token1] = ACTIONS(4128),
    [anon_sym_LPAREN] = ACTIONS(4130),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_null] = ACTIONS(4130),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_COLON] = ACTIONS(4128),
    [anon_sym_AMP] = ACTIONS(4130),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4128),
    [anon_sym_LBRACE] = ACTIONS(4130),
    [anon_sym_LT_AT] = ACTIONS(4130),
    [anon_sym_LT_AT_AT] = ACTIONS(4130),
    [anon_sym_DOT] = ACTIONS(4130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4128),
    [anon_sym_new] = ACTIONS(4130),
    [anon_sym_with] = ACTIONS(4130),
    [anon_sym_return_BANG] = ACTIONS(4128),
    [anon_sym_yield] = ACTIONS(4130),
    [anon_sym_yield_BANG] = ACTIONS(4128),
    [anon_sym_lazy] = ACTIONS(4130),
    [anon_sym_assert] = ACTIONS(4130),
    [anon_sym_upcast] = ACTIONS(4130),
    [anon_sym_downcast] = ACTIONS(4130),
    [anon_sym_COLON_GT] = ACTIONS(4128),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4128),
    [anon_sym_for] = ACTIONS(4130),
    [anon_sym_while] = ACTIONS(4130),
    [anon_sym_if] = ACTIONS(4130),
    [anon_sym_fun] = ACTIONS(4130),
    [anon_sym_try] = ACTIONS(4130),
    [anon_sym_match] = ACTIONS(4130),
    [anon_sym_match_BANG] = ACTIONS(4128),
    [anon_sym_function] = ACTIONS(4130),
    [anon_sym_LT_DASH] = ACTIONS(4130),
    [anon_sym_DOT_LBRACK] = ACTIONS(4128),
    [anon_sym_LT] = ACTIONS(4128),
    [anon_sym_use] = ACTIONS(4130),
    [anon_sym_use_BANG] = ACTIONS(4128),
    [anon_sym_do_BANG] = ACTIONS(4128),
    [anon_sym_begin] = ACTIONS(4130),
    [anon_sym_LPAREN2] = ACTIONS(4130),
    [anon_sym_default] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_static] = ACTIONS(4130),
    [anon_sym_member] = ACTIONS(4130),
    [anon_sym_interface] = ACTIONS(4130),
    [anon_sym_abstract] = ACTIONS(4130),
    [anon_sym_val] = ACTIONS(4130),
    [anon_sym_override] = ACTIONS(4130),
    [aux_sym_char_token1] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4130),
    [anon_sym_DQUOTE] = ACTIONS(4130),
    [anon_sym_AT_DQUOTE] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [sym_bool] = ACTIONS(4130),
    [sym_unit] = ACTIONS(4128),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4130),
    [sym_op_identifier] = ACTIONS(4130),
    [anon_sym_PLUS] = ACTIONS(4130),
    [anon_sym_DASH] = ACTIONS(4130),
    [anon_sym_PLUS_DOT] = ACTIONS(4130),
    [anon_sym_DASH_DOT] = ACTIONS(4130),
    [anon_sym_PERCENT] = ACTIONS(4130),
    [anon_sym_AMP_AMP] = ACTIONS(4130),
    [anon_sym_TILDE] = ACTIONS(4128),
    [aux_sym_prefix_op_token1] = ACTIONS(4130),
    [aux_sym_infix_op_token1] = ACTIONS(4128),
    [aux_sym_infix_op_token2] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE] = ACTIONS(4130),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_COLON_EQ] = ACTIONS(4128),
    [anon_sym_DOLLAR] = ACTIONS(4130),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4130),
    [sym_int] = ACTIONS(4130),
    [sym_xint] = ACTIONS(4128),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4128),
    [anon_sym_POUNDendif] = ACTIONS(4128),
    [anon_sym_POUNDelse] = ACTIONS(4128),
    [sym__newline] = ACTIONS(4128),
  },
  [1812] = {
    [sym_block_comment] = STATE(1812),
    [sym_compiler_directive_decl] = STATE(1812),
    [sym_fsi_directive_decl] = STATE(1812),
    [sym_preproc_line] = STATE(1812),
    [sym_identifier] = ACTIONS(3885),
    [anon_sym_EQ] = ACTIONS(3883),
    [anon_sym_LBRACK_LT] = ACTIONS(3883),
    [anon_sym_COLON] = ACTIONS(3885),
    [anon_sym_return] = ACTIONS(3885),
    [anon_sym_do] = ACTIONS(3885),
    [anon_sym_and] = ACTIONS(3885),
    [anon_sym_let] = ACTIONS(3885),
    [anon_sym_let_BANG] = ACTIONS(3883),
    [aux_sym_access_modifier_token1] = ACTIONS(3883),
    [anon_sym_LPAREN] = ACTIONS(3885),
    [anon_sym_COMMA] = ACTIONS(3883),
    [anon_sym_null] = ACTIONS(3885),
    [anon_sym_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3883),
    [anon_sym_AMP] = ACTIONS(3885),
    [anon_sym_LBRACK] = ACTIONS(3885),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3883),
    [anon_sym_LBRACE] = ACTIONS(3885),
    [anon_sym_LT_AT] = ACTIONS(3885),
    [anon_sym_LT_AT_AT] = ACTIONS(3885),
    [anon_sym_DOT] = ACTIONS(3885),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3883),
    [anon_sym_new] = ACTIONS(3885),
    [anon_sym_with] = ACTIONS(3885),
    [anon_sym_return_BANG] = ACTIONS(3883),
    [anon_sym_yield] = ACTIONS(3885),
    [anon_sym_yield_BANG] = ACTIONS(3883),
    [anon_sym_lazy] = ACTIONS(3885),
    [anon_sym_assert] = ACTIONS(3885),
    [anon_sym_upcast] = ACTIONS(3885),
    [anon_sym_downcast] = ACTIONS(3885),
    [anon_sym_COLON_GT] = ACTIONS(3883),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3883),
    [anon_sym_for] = ACTIONS(3885),
    [anon_sym_while] = ACTIONS(3885),
    [anon_sym_if] = ACTIONS(3885),
    [anon_sym_fun] = ACTIONS(3885),
    [anon_sym_try] = ACTIONS(3885),
    [anon_sym_match] = ACTIONS(3885),
    [anon_sym_match_BANG] = ACTIONS(3883),
    [anon_sym_function] = ACTIONS(3885),
    [anon_sym_LT_DASH] = ACTIONS(3885),
    [anon_sym_DOT_LBRACK] = ACTIONS(3883),
    [anon_sym_LT] = ACTIONS(3883),
    [anon_sym_use] = ACTIONS(3885),
    [anon_sym_use_BANG] = ACTIONS(3883),
    [anon_sym_do_BANG] = ACTIONS(3883),
    [anon_sym_begin] = ACTIONS(3885),
    [anon_sym_LPAREN2] = ACTIONS(3885),
    [anon_sym_default] = ACTIONS(3885),
    [anon_sym_or] = ACTIONS(3885),
    [anon_sym_static] = ACTIONS(3885),
    [anon_sym_member] = ACTIONS(3885),
    [anon_sym_interface] = ACTIONS(3885),
    [anon_sym_abstract] = ACTIONS(3885),
    [anon_sym_val] = ACTIONS(3885),
    [anon_sym_override] = ACTIONS(3885),
    [aux_sym_char_token1] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3885),
    [anon_sym_DQUOTE] = ACTIONS(3885),
    [anon_sym_AT_DQUOTE] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [sym_bool] = ACTIONS(3885),
    [sym_unit] = ACTIONS(3883),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3885),
    [sym_op_identifier] = ACTIONS(3885),
    [anon_sym_PLUS] = ACTIONS(3885),
    [anon_sym_DASH] = ACTIONS(3885),
    [anon_sym_PLUS_DOT] = ACTIONS(3885),
    [anon_sym_DASH_DOT] = ACTIONS(3885),
    [anon_sym_PERCENT] = ACTIONS(3885),
    [anon_sym_AMP_AMP] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3883),
    [aux_sym_prefix_op_token1] = ACTIONS(3885),
    [aux_sym_infix_op_token1] = ACTIONS(3883),
    [aux_sym_infix_op_token2] = ACTIONS(3885),
    [anon_sym_PIPE_PIPE] = ACTIONS(3885),
    [anon_sym_BANG_EQ] = ACTIONS(3885),
    [anon_sym_COLON_EQ] = ACTIONS(3883),
    [anon_sym_DOLLAR] = ACTIONS(3885),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3885),
    [sym_int] = ACTIONS(3885),
    [sym_xint] = ACTIONS(3883),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3883),
    [anon_sym_POUNDendif] = ACTIONS(3883),
    [anon_sym_POUNDelse] = ACTIONS(3883),
    [sym__newline] = ACTIONS(3883),
  },
  [1813] = {
    [sym_block_comment] = STATE(1813),
    [sym_compiler_directive_decl] = STATE(1813),
    [sym_fsi_directive_decl] = STATE(1813),
    [sym_preproc_line] = STATE(1813),
    [sym_identifier] = ACTIONS(3935),
    [anon_sym_EQ] = ACTIONS(3933),
    [anon_sym_LBRACK_LT] = ACTIONS(3933),
    [anon_sym_COLON] = ACTIONS(3935),
    [anon_sym_return] = ACTIONS(3935),
    [anon_sym_do] = ACTIONS(3935),
    [anon_sym_and] = ACTIONS(3935),
    [anon_sym_let] = ACTIONS(3935),
    [anon_sym_let_BANG] = ACTIONS(3933),
    [aux_sym_access_modifier_token1] = ACTIONS(3933),
    [anon_sym_LPAREN] = ACTIONS(3935),
    [anon_sym_COMMA] = ACTIONS(3933),
    [anon_sym_null] = ACTIONS(3935),
    [anon_sym_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3935),
    [anon_sym_LBRACK] = ACTIONS(3935),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3933),
    [anon_sym_LBRACE] = ACTIONS(3935),
    [anon_sym_LT_AT] = ACTIONS(3935),
    [anon_sym_LT_AT_AT] = ACTIONS(3935),
    [anon_sym_DOT] = ACTIONS(3935),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3933),
    [anon_sym_new] = ACTIONS(3935),
    [anon_sym_with] = ACTIONS(3935),
    [anon_sym_return_BANG] = ACTIONS(3933),
    [anon_sym_yield] = ACTIONS(3935),
    [anon_sym_yield_BANG] = ACTIONS(3933),
    [anon_sym_lazy] = ACTIONS(3935),
    [anon_sym_assert] = ACTIONS(3935),
    [anon_sym_upcast] = ACTIONS(3935),
    [anon_sym_downcast] = ACTIONS(3935),
    [anon_sym_COLON_GT] = ACTIONS(3933),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3933),
    [anon_sym_for] = ACTIONS(3935),
    [anon_sym_while] = ACTIONS(3935),
    [anon_sym_if] = ACTIONS(3935),
    [anon_sym_fun] = ACTIONS(3935),
    [anon_sym_try] = ACTIONS(3935),
    [anon_sym_match] = ACTIONS(3935),
    [anon_sym_match_BANG] = ACTIONS(3933),
    [anon_sym_function] = ACTIONS(3935),
    [anon_sym_LT_DASH] = ACTIONS(3935),
    [anon_sym_DOT_LBRACK] = ACTIONS(3933),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_use] = ACTIONS(3935),
    [anon_sym_use_BANG] = ACTIONS(3933),
    [anon_sym_do_BANG] = ACTIONS(3933),
    [anon_sym_begin] = ACTIONS(3935),
    [anon_sym_LPAREN2] = ACTIONS(3935),
    [anon_sym_default] = ACTIONS(3935),
    [anon_sym_or] = ACTIONS(3935),
    [anon_sym_static] = ACTIONS(3935),
    [anon_sym_member] = ACTIONS(3935),
    [anon_sym_interface] = ACTIONS(3935),
    [anon_sym_abstract] = ACTIONS(3935),
    [anon_sym_val] = ACTIONS(3935),
    [anon_sym_override] = ACTIONS(3935),
    [aux_sym_char_token1] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3935),
    [anon_sym_DQUOTE] = ACTIONS(3935),
    [anon_sym_AT_DQUOTE] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [sym_bool] = ACTIONS(3935),
    [sym_unit] = ACTIONS(3933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3935),
    [sym_op_identifier] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(3935),
    [anon_sym_DASH] = ACTIONS(3935),
    [anon_sym_PLUS_DOT] = ACTIONS(3935),
    [anon_sym_DASH_DOT] = ACTIONS(3935),
    [anon_sym_PERCENT] = ACTIONS(3935),
    [anon_sym_AMP_AMP] = ACTIONS(3935),
    [anon_sym_TILDE] = ACTIONS(3933),
    [aux_sym_prefix_op_token1] = ACTIONS(3935),
    [aux_sym_infix_op_token1] = ACTIONS(3933),
    [aux_sym_infix_op_token2] = ACTIONS(3935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3935),
    [anon_sym_BANG_EQ] = ACTIONS(3935),
    [anon_sym_COLON_EQ] = ACTIONS(3933),
    [anon_sym_DOLLAR] = ACTIONS(3935),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3935),
    [sym_int] = ACTIONS(3935),
    [sym_xint] = ACTIONS(3933),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3933),
    [anon_sym_POUNDendif] = ACTIONS(3933),
    [anon_sym_POUNDelse] = ACTIONS(3933),
    [sym__newline] = ACTIONS(3933),
  },
  [1814] = {
    [sym_block_comment] = STATE(1814),
    [sym_compiler_directive_decl] = STATE(1814),
    [sym_fsi_directive_decl] = STATE(1814),
    [sym_preproc_line] = STATE(1814),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_EQ] = ACTIONS(3948),
    [anon_sym_LBRACK_LT] = ACTIONS(3948),
    [anon_sym_COLON] = ACTIONS(3950),
    [anon_sym_return] = ACTIONS(3950),
    [anon_sym_do] = ACTIONS(3950),
    [anon_sym_and] = ACTIONS(3950),
    [anon_sym_let] = ACTIONS(3950),
    [anon_sym_let_BANG] = ACTIONS(3948),
    [aux_sym_access_modifier_token1] = ACTIONS(3948),
    [anon_sym_LPAREN] = ACTIONS(3950),
    [anon_sym_COMMA] = ACTIONS(3948),
    [anon_sym_null] = ACTIONS(3950),
    [anon_sym_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_COLON] = ACTIONS(3948),
    [anon_sym_AMP] = ACTIONS(3950),
    [anon_sym_LBRACK] = ACTIONS(3950),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3948),
    [anon_sym_LBRACE] = ACTIONS(3950),
    [anon_sym_LT_AT] = ACTIONS(3950),
    [anon_sym_LT_AT_AT] = ACTIONS(3950),
    [anon_sym_DOT] = ACTIONS(3950),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3948),
    [anon_sym_new] = ACTIONS(3950),
    [anon_sym_with] = ACTIONS(3950),
    [anon_sym_return_BANG] = ACTIONS(3948),
    [anon_sym_yield] = ACTIONS(3950),
    [anon_sym_yield_BANG] = ACTIONS(3948),
    [anon_sym_lazy] = ACTIONS(3950),
    [anon_sym_assert] = ACTIONS(3950),
    [anon_sym_upcast] = ACTIONS(3950),
    [anon_sym_downcast] = ACTIONS(3950),
    [anon_sym_COLON_GT] = ACTIONS(3948),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3948),
    [anon_sym_for] = ACTIONS(3950),
    [anon_sym_while] = ACTIONS(3950),
    [anon_sym_if] = ACTIONS(3950),
    [anon_sym_fun] = ACTIONS(3950),
    [anon_sym_try] = ACTIONS(3950),
    [anon_sym_match] = ACTIONS(3950),
    [anon_sym_match_BANG] = ACTIONS(3948),
    [anon_sym_function] = ACTIONS(3950),
    [anon_sym_LT_DASH] = ACTIONS(3950),
    [anon_sym_DOT_LBRACK] = ACTIONS(3948),
    [anon_sym_LT] = ACTIONS(3948),
    [anon_sym_use] = ACTIONS(3950),
    [anon_sym_use_BANG] = ACTIONS(3948),
    [anon_sym_do_BANG] = ACTIONS(3948),
    [anon_sym_begin] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3950),
    [anon_sym_default] = ACTIONS(3950),
    [anon_sym_or] = ACTIONS(3950),
    [anon_sym_static] = ACTIONS(3950),
    [anon_sym_member] = ACTIONS(3950),
    [anon_sym_interface] = ACTIONS(3950),
    [anon_sym_abstract] = ACTIONS(3950),
    [anon_sym_val] = ACTIONS(3950),
    [anon_sym_override] = ACTIONS(3950),
    [aux_sym_char_token1] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3950),
    [anon_sym_DQUOTE] = ACTIONS(3950),
    [anon_sym_AT_DQUOTE] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [sym_bool] = ACTIONS(3950),
    [sym_unit] = ACTIONS(3948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3950),
    [sym_op_identifier] = ACTIONS(3950),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_DASH] = ACTIONS(3950),
    [anon_sym_PLUS_DOT] = ACTIONS(3950),
    [anon_sym_DASH_DOT] = ACTIONS(3950),
    [anon_sym_PERCENT] = ACTIONS(3950),
    [anon_sym_AMP_AMP] = ACTIONS(3950),
    [anon_sym_TILDE] = ACTIONS(3948),
    [aux_sym_prefix_op_token1] = ACTIONS(3950),
    [aux_sym_infix_op_token1] = ACTIONS(3948),
    [aux_sym_infix_op_token2] = ACTIONS(3950),
    [anon_sym_PIPE_PIPE] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3950),
    [anon_sym_COLON_EQ] = ACTIONS(3948),
    [anon_sym_DOLLAR] = ACTIONS(3950),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3950),
    [sym_int] = ACTIONS(3950),
    [sym_xint] = ACTIONS(3948),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3948),
    [anon_sym_POUNDendif] = ACTIONS(3948),
    [anon_sym_POUNDelse] = ACTIONS(3948),
    [sym__newline] = ACTIONS(3948),
  },
  [1815] = {
    [sym_block_comment] = STATE(1815),
    [sym_compiler_directive_decl] = STATE(1815),
    [sym_fsi_directive_decl] = STATE(1815),
    [sym_preproc_line] = STATE(1815),
    [aux_sym_sequential_expression_repeat1] = STATE(1871),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_LBRACK_LT] = ACTIONS(3757),
    [anon_sym_COLON] = ACTIONS(3759),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_and] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_let_BANG] = ACTIONS(3757),
    [aux_sym_access_modifier_token1] = ACTIONS(3757),
    [anon_sym_LPAREN] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3757),
    [anon_sym_null] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3757),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_LT_AT] = ACTIONS(3759),
    [anon_sym_LT_AT_AT] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(3759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_with] = ACTIONS(3759),
    [anon_sym_return_BANG] = ACTIONS(3757),
    [anon_sym_yield] = ACTIONS(3759),
    [anon_sym_yield_BANG] = ACTIONS(3757),
    [anon_sym_lazy] = ACTIONS(3759),
    [anon_sym_assert] = ACTIONS(3759),
    [anon_sym_upcast] = ACTIONS(3759),
    [anon_sym_downcast] = ACTIONS(3759),
    [anon_sym_COLON_GT] = ACTIONS(3757),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3757),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_fun] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_match] = ACTIONS(3759),
    [anon_sym_match_BANG] = ACTIONS(3757),
    [anon_sym_function] = ACTIONS(3759),
    [anon_sym_LT_DASH] = ACTIONS(3759),
    [anon_sym_DOT_LBRACK] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_use] = ACTIONS(3759),
    [anon_sym_use_BANG] = ACTIONS(3757),
    [anon_sym_do_BANG] = ACTIONS(3757),
    [anon_sym_begin] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_default] = ACTIONS(3759),
    [anon_sym_or] = ACTIONS(3759),
    [anon_sym_static] = ACTIONS(3759),
    [anon_sym_member] = ACTIONS(3759),
    [anon_sym_interface] = ACTIONS(3759),
    [anon_sym_abstract] = ACTIONS(3759),
    [anon_sym_val] = ACTIONS(3759),
    [anon_sym_override] = ACTIONS(3759),
    [aux_sym_char_token1] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3759),
    [anon_sym_DQUOTE] = ACTIONS(3759),
    [anon_sym_AT_DQUOTE] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [sym_bool] = ACTIONS(3759),
    [sym_unit] = ACTIONS(3757),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3759),
    [sym_op_identifier] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS_DOT] = ACTIONS(3759),
    [anon_sym_DASH_DOT] = ACTIONS(3759),
    [anon_sym_PERCENT] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_TILDE] = ACTIONS(3757),
    [aux_sym_prefix_op_token1] = ACTIONS(3759),
    [aux_sym_infix_op_token1] = ACTIONS(3757),
    [aux_sym_infix_op_token2] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_COLON_EQ] = ACTIONS(3757),
    [anon_sym_DOLLAR] = ACTIONS(3759),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3759),
    [sym_int] = ACTIONS(3759),
    [sym_xint] = ACTIONS(3757),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3757),
    [anon_sym_POUNDendif] = ACTIONS(3757),
    [sym__newline] = ACTIONS(3757),
  },
  [1816] = {
    [sym_block_comment] = STATE(1816),
    [sym_compiler_directive_decl] = STATE(1816),
    [sym_fsi_directive_decl] = STATE(1816),
    [sym_preproc_line] = STATE(1816),
    [sym_identifier] = ACTIONS(3954),
    [anon_sym_EQ] = ACTIONS(3952),
    [anon_sym_LBRACK_LT] = ACTIONS(3952),
    [anon_sym_COLON] = ACTIONS(3954),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_do] = ACTIONS(3954),
    [anon_sym_and] = ACTIONS(3954),
    [anon_sym_let] = ACTIONS(3954),
    [anon_sym_let_BANG] = ACTIONS(3952),
    [aux_sym_access_modifier_token1] = ACTIONS(3952),
    [anon_sym_LPAREN] = ACTIONS(3954),
    [anon_sym_COMMA] = ACTIONS(3952),
    [anon_sym_null] = ACTIONS(3954),
    [anon_sym_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_COLON] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3954),
    [anon_sym_LBRACK] = ACTIONS(3954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(3954),
    [anon_sym_LT_AT] = ACTIONS(3954),
    [anon_sym_LT_AT_AT] = ACTIONS(3954),
    [anon_sym_DOT] = ACTIONS(3954),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3952),
    [anon_sym_new] = ACTIONS(3954),
    [anon_sym_with] = ACTIONS(3954),
    [anon_sym_return_BANG] = ACTIONS(3952),
    [anon_sym_yield] = ACTIONS(3954),
    [anon_sym_yield_BANG] = ACTIONS(3952),
    [anon_sym_lazy] = ACTIONS(3954),
    [anon_sym_assert] = ACTIONS(3954),
    [anon_sym_upcast] = ACTIONS(3954),
    [anon_sym_downcast] = ACTIONS(3954),
    [anon_sym_COLON_GT] = ACTIONS(3952),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3952),
    [anon_sym_for] = ACTIONS(3954),
    [anon_sym_while] = ACTIONS(3954),
    [anon_sym_if] = ACTIONS(3954),
    [anon_sym_fun] = ACTIONS(3954),
    [anon_sym_try] = ACTIONS(3954),
    [anon_sym_match] = ACTIONS(3954),
    [anon_sym_match_BANG] = ACTIONS(3952),
    [anon_sym_function] = ACTIONS(3954),
    [anon_sym_LT_DASH] = ACTIONS(3954),
    [anon_sym_DOT_LBRACK] = ACTIONS(3952),
    [anon_sym_LT] = ACTIONS(3952),
    [anon_sym_use] = ACTIONS(3954),
    [anon_sym_use_BANG] = ACTIONS(3952),
    [anon_sym_do_BANG] = ACTIONS(3952),
    [anon_sym_begin] = ACTIONS(3954),
    [anon_sym_LPAREN2] = ACTIONS(3954),
    [anon_sym_default] = ACTIONS(3954),
    [anon_sym_or] = ACTIONS(3954),
    [anon_sym_static] = ACTIONS(3954),
    [anon_sym_member] = ACTIONS(3954),
    [anon_sym_interface] = ACTIONS(3954),
    [anon_sym_abstract] = ACTIONS(3954),
    [anon_sym_val] = ACTIONS(3954),
    [anon_sym_override] = ACTIONS(3954),
    [aux_sym_char_token1] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3954),
    [anon_sym_DQUOTE] = ACTIONS(3954),
    [anon_sym_AT_DQUOTE] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [sym_bool] = ACTIONS(3954),
    [sym_unit] = ACTIONS(3952),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3954),
    [sym_op_identifier] = ACTIONS(3954),
    [anon_sym_PLUS] = ACTIONS(3954),
    [anon_sym_DASH] = ACTIONS(3954),
    [anon_sym_PLUS_DOT] = ACTIONS(3954),
    [anon_sym_DASH_DOT] = ACTIONS(3954),
    [anon_sym_PERCENT] = ACTIONS(3954),
    [anon_sym_AMP_AMP] = ACTIONS(3954),
    [anon_sym_TILDE] = ACTIONS(3952),
    [aux_sym_prefix_op_token1] = ACTIONS(3954),
    [aux_sym_infix_op_token1] = ACTIONS(3952),
    [aux_sym_infix_op_token2] = ACTIONS(3954),
    [anon_sym_PIPE_PIPE] = ACTIONS(3954),
    [anon_sym_BANG_EQ] = ACTIONS(3954),
    [anon_sym_COLON_EQ] = ACTIONS(3952),
    [anon_sym_DOLLAR] = ACTIONS(3954),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3954),
    [sym_int] = ACTIONS(3954),
    [sym_xint] = ACTIONS(3952),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3952),
    [anon_sym_POUNDendif] = ACTIONS(3952),
    [anon_sym_POUNDelse] = ACTIONS(3952),
    [sym__newline] = ACTIONS(3952),
  },
  [1817] = {
    [sym_block_comment] = STATE(1817),
    [sym_compiler_directive_decl] = STATE(1817),
    [sym_fsi_directive_decl] = STATE(1817),
    [sym_preproc_line] = STATE(1817),
    [sym_identifier] = ACTIONS(3958),
    [anon_sym_EQ] = ACTIONS(3956),
    [anon_sym_LBRACK_LT] = ACTIONS(3956),
    [anon_sym_COLON] = ACTIONS(3958),
    [anon_sym_return] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(3958),
    [anon_sym_and] = ACTIONS(3958),
    [anon_sym_let] = ACTIONS(3958),
    [anon_sym_let_BANG] = ACTIONS(3956),
    [aux_sym_access_modifier_token1] = ACTIONS(3956),
    [anon_sym_LPAREN] = ACTIONS(3958),
    [anon_sym_COMMA] = ACTIONS(3956),
    [anon_sym_null] = ACTIONS(3958),
    [anon_sym_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_COLON] = ACTIONS(3956),
    [anon_sym_AMP] = ACTIONS(3958),
    [anon_sym_LBRACK] = ACTIONS(3958),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3956),
    [anon_sym_LBRACE] = ACTIONS(3958),
    [anon_sym_LT_AT] = ACTIONS(3958),
    [anon_sym_LT_AT_AT] = ACTIONS(3958),
    [anon_sym_DOT] = ACTIONS(3958),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3956),
    [anon_sym_new] = ACTIONS(3958),
    [anon_sym_with] = ACTIONS(3958),
    [anon_sym_return_BANG] = ACTIONS(3956),
    [anon_sym_yield] = ACTIONS(3958),
    [anon_sym_yield_BANG] = ACTIONS(3956),
    [anon_sym_lazy] = ACTIONS(3958),
    [anon_sym_assert] = ACTIONS(3958),
    [anon_sym_upcast] = ACTIONS(3958),
    [anon_sym_downcast] = ACTIONS(3958),
    [anon_sym_COLON_GT] = ACTIONS(3956),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3956),
    [anon_sym_for] = ACTIONS(3958),
    [anon_sym_while] = ACTIONS(3958),
    [anon_sym_if] = ACTIONS(3958),
    [anon_sym_fun] = ACTIONS(3958),
    [anon_sym_try] = ACTIONS(3958),
    [anon_sym_match] = ACTIONS(3958),
    [anon_sym_match_BANG] = ACTIONS(3956),
    [anon_sym_function] = ACTIONS(3958),
    [anon_sym_LT_DASH] = ACTIONS(3958),
    [anon_sym_DOT_LBRACK] = ACTIONS(3956),
    [anon_sym_LT] = ACTIONS(3956),
    [anon_sym_use] = ACTIONS(3958),
    [anon_sym_use_BANG] = ACTIONS(3956),
    [anon_sym_do_BANG] = ACTIONS(3956),
    [anon_sym_begin] = ACTIONS(3958),
    [anon_sym_LPAREN2] = ACTIONS(3958),
    [anon_sym_default] = ACTIONS(3958),
    [anon_sym_or] = ACTIONS(3958),
    [anon_sym_static] = ACTIONS(3958),
    [anon_sym_member] = ACTIONS(3958),
    [anon_sym_interface] = ACTIONS(3958),
    [anon_sym_abstract] = ACTIONS(3958),
    [anon_sym_val] = ACTIONS(3958),
    [anon_sym_override] = ACTIONS(3958),
    [aux_sym_char_token1] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [anon_sym_AT_DQUOTE] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [sym_bool] = ACTIONS(3958),
    [sym_unit] = ACTIONS(3956),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3958),
    [sym_op_identifier] = ACTIONS(3958),
    [anon_sym_PLUS] = ACTIONS(3958),
    [anon_sym_DASH] = ACTIONS(3958),
    [anon_sym_PLUS_DOT] = ACTIONS(3958),
    [anon_sym_DASH_DOT] = ACTIONS(3958),
    [anon_sym_PERCENT] = ACTIONS(3958),
    [anon_sym_AMP_AMP] = ACTIONS(3958),
    [anon_sym_TILDE] = ACTIONS(3956),
    [aux_sym_prefix_op_token1] = ACTIONS(3958),
    [aux_sym_infix_op_token1] = ACTIONS(3956),
    [aux_sym_infix_op_token2] = ACTIONS(3958),
    [anon_sym_PIPE_PIPE] = ACTIONS(3958),
    [anon_sym_BANG_EQ] = ACTIONS(3958),
    [anon_sym_COLON_EQ] = ACTIONS(3956),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3958),
    [sym_int] = ACTIONS(3958),
    [sym_xint] = ACTIONS(3956),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3956),
    [anon_sym_POUNDendif] = ACTIONS(3956),
    [anon_sym_POUNDelse] = ACTIONS(3956),
    [sym__newline] = ACTIONS(3956),
  },
  [1818] = {
    [sym_block_comment] = STATE(1818),
    [sym_compiler_directive_decl] = STATE(1818),
    [sym_fsi_directive_decl] = STATE(1818),
    [sym_preproc_line] = STATE(1818),
    [sym_identifier] = ACTIONS(3889),
    [anon_sym_EQ] = ACTIONS(3887),
    [anon_sym_LBRACK_LT] = ACTIONS(3887),
    [anon_sym_COLON] = ACTIONS(3889),
    [anon_sym_return] = ACTIONS(3889),
    [anon_sym_do] = ACTIONS(3889),
    [anon_sym_and] = ACTIONS(3889),
    [anon_sym_let] = ACTIONS(3889),
    [anon_sym_let_BANG] = ACTIONS(3887),
    [aux_sym_access_modifier_token1] = ACTIONS(3887),
    [anon_sym_LPAREN] = ACTIONS(3889),
    [anon_sym_COMMA] = ACTIONS(3887),
    [anon_sym_null] = ACTIONS(3889),
    [anon_sym_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_COLON] = ACTIONS(3887),
    [anon_sym_AMP] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3887),
    [anon_sym_LBRACE] = ACTIONS(3889),
    [anon_sym_LT_AT] = ACTIONS(3889),
    [anon_sym_LT_AT_AT] = ACTIONS(3889),
    [anon_sym_DOT] = ACTIONS(3889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [anon_sym_new] = ACTIONS(3889),
    [anon_sym_with] = ACTIONS(3889),
    [anon_sym_return_BANG] = ACTIONS(3887),
    [anon_sym_yield] = ACTIONS(3889),
    [anon_sym_yield_BANG] = ACTIONS(3887),
    [anon_sym_lazy] = ACTIONS(3889),
    [anon_sym_assert] = ACTIONS(3889),
    [anon_sym_upcast] = ACTIONS(3889),
    [anon_sym_downcast] = ACTIONS(3889),
    [anon_sym_COLON_GT] = ACTIONS(3887),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3887),
    [anon_sym_for] = ACTIONS(3889),
    [anon_sym_while] = ACTIONS(3889),
    [anon_sym_if] = ACTIONS(3889),
    [anon_sym_fun] = ACTIONS(3889),
    [anon_sym_try] = ACTIONS(3889),
    [anon_sym_match] = ACTIONS(3889),
    [anon_sym_match_BANG] = ACTIONS(3887),
    [anon_sym_function] = ACTIONS(3889),
    [anon_sym_LT_DASH] = ACTIONS(3889),
    [anon_sym_DOT_LBRACK] = ACTIONS(3887),
    [anon_sym_LT] = ACTIONS(3887),
    [anon_sym_use] = ACTIONS(3889),
    [anon_sym_use_BANG] = ACTIONS(3887),
    [anon_sym_do_BANG] = ACTIONS(3887),
    [anon_sym_begin] = ACTIONS(3889),
    [anon_sym_LPAREN2] = ACTIONS(3889),
    [anon_sym_default] = ACTIONS(3889),
    [anon_sym_or] = ACTIONS(3889),
    [anon_sym_static] = ACTIONS(3889),
    [anon_sym_member] = ACTIONS(3889),
    [anon_sym_interface] = ACTIONS(3889),
    [anon_sym_abstract] = ACTIONS(3889),
    [anon_sym_val] = ACTIONS(3889),
    [anon_sym_override] = ACTIONS(3889),
    [aux_sym_char_token1] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3889),
    [anon_sym_DQUOTE] = ACTIONS(3889),
    [anon_sym_AT_DQUOTE] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [sym_bool] = ACTIONS(3889),
    [sym_unit] = ACTIONS(3887),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3889),
    [sym_op_identifier] = ACTIONS(3889),
    [anon_sym_PLUS] = ACTIONS(3889),
    [anon_sym_DASH] = ACTIONS(3889),
    [anon_sym_PLUS_DOT] = ACTIONS(3889),
    [anon_sym_DASH_DOT] = ACTIONS(3889),
    [anon_sym_PERCENT] = ACTIONS(3889),
    [anon_sym_AMP_AMP] = ACTIONS(3889),
    [anon_sym_TILDE] = ACTIONS(3887),
    [aux_sym_prefix_op_token1] = ACTIONS(3889),
    [aux_sym_infix_op_token1] = ACTIONS(3887),
    [aux_sym_infix_op_token2] = ACTIONS(3889),
    [anon_sym_PIPE_PIPE] = ACTIONS(3889),
    [anon_sym_BANG_EQ] = ACTIONS(3889),
    [anon_sym_COLON_EQ] = ACTIONS(3887),
    [anon_sym_DOLLAR] = ACTIONS(3889),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3889),
    [sym_int] = ACTIONS(3889),
    [sym_xint] = ACTIONS(3887),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3887),
    [anon_sym_POUNDendif] = ACTIONS(3887),
    [anon_sym_POUNDelse] = ACTIONS(3887),
    [sym__newline] = ACTIONS(3887),
  },
  [1819] = {
    [sym_block_comment] = STATE(1819),
    [sym_compiler_directive_decl] = STATE(1819),
    [sym_fsi_directive_decl] = STATE(1819),
    [sym_preproc_line] = STATE(1819),
    [sym_identifier] = ACTIONS(3962),
    [anon_sym_EQ] = ACTIONS(3960),
    [anon_sym_LBRACK_LT] = ACTIONS(3960),
    [anon_sym_COLON] = ACTIONS(3962),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_do] = ACTIONS(3962),
    [anon_sym_and] = ACTIONS(3962),
    [anon_sym_let] = ACTIONS(3962),
    [anon_sym_let_BANG] = ACTIONS(3960),
    [aux_sym_access_modifier_token1] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_COMMA] = ACTIONS(3960),
    [anon_sym_null] = ACTIONS(3962),
    [anon_sym_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_COLON] = ACTIONS(3960),
    [anon_sym_AMP] = ACTIONS(3962),
    [anon_sym_LBRACK] = ACTIONS(3962),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_LT_AT] = ACTIONS(3962),
    [anon_sym_LT_AT_AT] = ACTIONS(3962),
    [anon_sym_DOT] = ACTIONS(3962),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3960),
    [anon_sym_new] = ACTIONS(3962),
    [anon_sym_with] = ACTIONS(3962),
    [anon_sym_return_BANG] = ACTIONS(3960),
    [anon_sym_yield] = ACTIONS(3962),
    [anon_sym_yield_BANG] = ACTIONS(3960),
    [anon_sym_lazy] = ACTIONS(3962),
    [anon_sym_assert] = ACTIONS(3962),
    [anon_sym_upcast] = ACTIONS(3962),
    [anon_sym_downcast] = ACTIONS(3962),
    [anon_sym_COLON_GT] = ACTIONS(3960),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3960),
    [anon_sym_for] = ACTIONS(3962),
    [anon_sym_while] = ACTIONS(3962),
    [anon_sym_if] = ACTIONS(3962),
    [anon_sym_fun] = ACTIONS(3962),
    [anon_sym_try] = ACTIONS(3962),
    [anon_sym_match] = ACTIONS(3962),
    [anon_sym_match_BANG] = ACTIONS(3960),
    [anon_sym_function] = ACTIONS(3962),
    [anon_sym_LT_DASH] = ACTIONS(3962),
    [anon_sym_DOT_LBRACK] = ACTIONS(3960),
    [anon_sym_LT] = ACTIONS(3960),
    [anon_sym_use] = ACTIONS(3962),
    [anon_sym_use_BANG] = ACTIONS(3960),
    [anon_sym_do_BANG] = ACTIONS(3960),
    [anon_sym_begin] = ACTIONS(3962),
    [anon_sym_LPAREN2] = ACTIONS(3962),
    [anon_sym_default] = ACTIONS(3962),
    [anon_sym_or] = ACTIONS(3962),
    [anon_sym_static] = ACTIONS(3962),
    [anon_sym_member] = ACTIONS(3962),
    [anon_sym_interface] = ACTIONS(3962),
    [anon_sym_abstract] = ACTIONS(3962),
    [anon_sym_val] = ACTIONS(3962),
    [anon_sym_override] = ACTIONS(3962),
    [aux_sym_char_token1] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3962),
    [anon_sym_DQUOTE] = ACTIONS(3962),
    [anon_sym_AT_DQUOTE] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [sym_bool] = ACTIONS(3962),
    [sym_unit] = ACTIONS(3960),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3962),
    [sym_op_identifier] = ACTIONS(3962),
    [anon_sym_PLUS] = ACTIONS(3962),
    [anon_sym_DASH] = ACTIONS(3962),
    [anon_sym_PLUS_DOT] = ACTIONS(3962),
    [anon_sym_DASH_DOT] = ACTIONS(3962),
    [anon_sym_PERCENT] = ACTIONS(3962),
    [anon_sym_AMP_AMP] = ACTIONS(3962),
    [anon_sym_TILDE] = ACTIONS(3960),
    [aux_sym_prefix_op_token1] = ACTIONS(3962),
    [aux_sym_infix_op_token1] = ACTIONS(3960),
    [aux_sym_infix_op_token2] = ACTIONS(3962),
    [anon_sym_PIPE_PIPE] = ACTIONS(3962),
    [anon_sym_BANG_EQ] = ACTIONS(3962),
    [anon_sym_COLON_EQ] = ACTIONS(3960),
    [anon_sym_DOLLAR] = ACTIONS(3962),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3962),
    [sym_int] = ACTIONS(3962),
    [sym_xint] = ACTIONS(3960),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3960),
    [anon_sym_POUNDendif] = ACTIONS(3960),
    [anon_sym_POUNDelse] = ACTIONS(3960),
    [sym__newline] = ACTIONS(3960),
  },
  [1820] = {
    [sym_block_comment] = STATE(1820),
    [sym_compiler_directive_decl] = STATE(1820),
    [sym_fsi_directive_decl] = STATE(1820),
    [sym_preproc_line] = STATE(1820),
    [sym_identifier] = ACTIONS(4232),
    [anon_sym_EQ] = ACTIONS(4230),
    [anon_sym_LBRACK_LT] = ACTIONS(4230),
    [anon_sym_COLON] = ACTIONS(4232),
    [anon_sym_return] = ACTIONS(4232),
    [anon_sym_do] = ACTIONS(4232),
    [anon_sym_and] = ACTIONS(4232),
    [anon_sym_let] = ACTIONS(4232),
    [anon_sym_let_BANG] = ACTIONS(4230),
    [aux_sym_access_modifier_token1] = ACTIONS(4230),
    [anon_sym_LPAREN] = ACTIONS(4232),
    [anon_sym_COMMA] = ACTIONS(4230),
    [anon_sym_null] = ACTIONS(4232),
    [anon_sym_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_COLON] = ACTIONS(4230),
    [anon_sym_AMP] = ACTIONS(4232),
    [anon_sym_LBRACK] = ACTIONS(4232),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4230),
    [anon_sym_LBRACE] = ACTIONS(4232),
    [anon_sym_LT_AT] = ACTIONS(4232),
    [anon_sym_LT_AT_AT] = ACTIONS(4232),
    [anon_sym_DOT] = ACTIONS(4232),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4230),
    [anon_sym_new] = ACTIONS(4232),
    [anon_sym_with] = ACTIONS(4232),
    [anon_sym_return_BANG] = ACTIONS(4230),
    [anon_sym_yield] = ACTIONS(4232),
    [anon_sym_yield_BANG] = ACTIONS(4230),
    [anon_sym_lazy] = ACTIONS(4232),
    [anon_sym_assert] = ACTIONS(4232),
    [anon_sym_upcast] = ACTIONS(4232),
    [anon_sym_downcast] = ACTIONS(4232),
    [anon_sym_COLON_GT] = ACTIONS(4230),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4230),
    [anon_sym_for] = ACTIONS(4232),
    [anon_sym_while] = ACTIONS(4232),
    [anon_sym_if] = ACTIONS(4232),
    [anon_sym_fun] = ACTIONS(4232),
    [anon_sym_try] = ACTIONS(4232),
    [anon_sym_match] = ACTIONS(4232),
    [anon_sym_match_BANG] = ACTIONS(4230),
    [anon_sym_function] = ACTIONS(4232),
    [anon_sym_LT_DASH] = ACTIONS(4232),
    [anon_sym_DOT_LBRACK] = ACTIONS(4230),
    [anon_sym_LT] = ACTIONS(4230),
    [anon_sym_use] = ACTIONS(4232),
    [anon_sym_use_BANG] = ACTIONS(4230),
    [anon_sym_do_BANG] = ACTIONS(4230),
    [anon_sym_begin] = ACTIONS(4232),
    [anon_sym_LPAREN2] = ACTIONS(4232),
    [anon_sym_default] = ACTIONS(4232),
    [anon_sym_or] = ACTIONS(4232),
    [anon_sym_static] = ACTIONS(4232),
    [anon_sym_member] = ACTIONS(4232),
    [anon_sym_interface] = ACTIONS(4232),
    [anon_sym_abstract] = ACTIONS(4232),
    [anon_sym_val] = ACTIONS(4232),
    [anon_sym_override] = ACTIONS(4232),
    [aux_sym_char_token1] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4232),
    [anon_sym_DQUOTE] = ACTIONS(4232),
    [anon_sym_AT_DQUOTE] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [sym_bool] = ACTIONS(4232),
    [sym_unit] = ACTIONS(4230),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4232),
    [sym_op_identifier] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4232),
    [anon_sym_DASH] = ACTIONS(4232),
    [anon_sym_PLUS_DOT] = ACTIONS(4232),
    [anon_sym_DASH_DOT] = ACTIONS(4232),
    [anon_sym_PERCENT] = ACTIONS(4232),
    [anon_sym_AMP_AMP] = ACTIONS(4232),
    [anon_sym_TILDE] = ACTIONS(4230),
    [aux_sym_prefix_op_token1] = ACTIONS(4232),
    [aux_sym_infix_op_token1] = ACTIONS(4230),
    [aux_sym_infix_op_token2] = ACTIONS(4232),
    [anon_sym_PIPE_PIPE] = ACTIONS(4232),
    [anon_sym_BANG_EQ] = ACTIONS(4232),
    [anon_sym_COLON_EQ] = ACTIONS(4230),
    [anon_sym_DOLLAR] = ACTIONS(4232),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4232),
    [sym_int] = ACTIONS(4232),
    [sym_xint] = ACTIONS(4230),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4230),
    [anon_sym_POUNDendif] = ACTIONS(4230),
    [anon_sym_POUNDelse] = ACTIONS(4230),
    [sym__newline] = ACTIONS(4230),
  },
  [1821] = {
    [sym_block_comment] = STATE(1821),
    [sym_compiler_directive_decl] = STATE(1821),
    [sym_fsi_directive_decl] = STATE(1821),
    [sym_preproc_line] = STATE(1821),
    [sym_identifier] = ACTIONS(4126),
    [anon_sym_EQ] = ACTIONS(4124),
    [anon_sym_LBRACK_LT] = ACTIONS(4124),
    [anon_sym_COLON] = ACTIONS(4126),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_do] = ACTIONS(4126),
    [anon_sym_and] = ACTIONS(4126),
    [anon_sym_let] = ACTIONS(4126),
    [anon_sym_let_BANG] = ACTIONS(4124),
    [aux_sym_access_modifier_token1] = ACTIONS(4124),
    [anon_sym_LPAREN] = ACTIONS(4126),
    [anon_sym_COMMA] = ACTIONS(4124),
    [anon_sym_null] = ACTIONS(4126),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_COLON] = ACTIONS(4124),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LBRACK] = ACTIONS(4126),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4126),
    [anon_sym_LT_AT] = ACTIONS(4126),
    [anon_sym_LT_AT_AT] = ACTIONS(4126),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4124),
    [anon_sym_new] = ACTIONS(4126),
    [anon_sym_with] = ACTIONS(4126),
    [anon_sym_return_BANG] = ACTIONS(4124),
    [anon_sym_yield] = ACTIONS(4126),
    [anon_sym_yield_BANG] = ACTIONS(4124),
    [anon_sym_lazy] = ACTIONS(4126),
    [anon_sym_assert] = ACTIONS(4126),
    [anon_sym_upcast] = ACTIONS(4126),
    [anon_sym_downcast] = ACTIONS(4126),
    [anon_sym_COLON_GT] = ACTIONS(4124),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4124),
    [anon_sym_for] = ACTIONS(4126),
    [anon_sym_while] = ACTIONS(4126),
    [anon_sym_if] = ACTIONS(4126),
    [anon_sym_fun] = ACTIONS(4126),
    [anon_sym_try] = ACTIONS(4126),
    [anon_sym_match] = ACTIONS(4126),
    [anon_sym_match_BANG] = ACTIONS(4124),
    [anon_sym_function] = ACTIONS(4126),
    [anon_sym_LT_DASH] = ACTIONS(4126),
    [anon_sym_DOT_LBRACK] = ACTIONS(4124),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_use] = ACTIONS(4126),
    [anon_sym_use_BANG] = ACTIONS(4124),
    [anon_sym_do_BANG] = ACTIONS(4124),
    [anon_sym_begin] = ACTIONS(4126),
    [anon_sym_LPAREN2] = ACTIONS(4126),
    [anon_sym_default] = ACTIONS(4126),
    [anon_sym_or] = ACTIONS(4126),
    [anon_sym_static] = ACTIONS(4126),
    [anon_sym_member] = ACTIONS(4126),
    [anon_sym_interface] = ACTIONS(4126),
    [anon_sym_abstract] = ACTIONS(4126),
    [anon_sym_val] = ACTIONS(4126),
    [anon_sym_override] = ACTIONS(4126),
    [aux_sym_char_token1] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4126),
    [anon_sym_DQUOTE] = ACTIONS(4126),
    [anon_sym_AT_DQUOTE] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [sym_bool] = ACTIONS(4126),
    [sym_unit] = ACTIONS(4124),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4126),
    [sym_op_identifier] = ACTIONS(4126),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_PLUS_DOT] = ACTIONS(4126),
    [anon_sym_DASH_DOT] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_AMP_AMP] = ACTIONS(4126),
    [anon_sym_TILDE] = ACTIONS(4124),
    [aux_sym_prefix_op_token1] = ACTIONS(4126),
    [aux_sym_infix_op_token1] = ACTIONS(4124),
    [aux_sym_infix_op_token2] = ACTIONS(4126),
    [anon_sym_PIPE_PIPE] = ACTIONS(4126),
    [anon_sym_BANG_EQ] = ACTIONS(4126),
    [anon_sym_COLON_EQ] = ACTIONS(4124),
    [anon_sym_DOLLAR] = ACTIONS(4126),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4126),
    [sym_int] = ACTIONS(4126),
    [sym_xint] = ACTIONS(4124),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4124),
    [anon_sym_POUNDendif] = ACTIONS(4124),
    [anon_sym_POUNDelse] = ACTIONS(4124),
    [sym__newline] = ACTIONS(4124),
  },
  [1822] = {
    [sym_block_comment] = STATE(1822),
    [sym_compiler_directive_decl] = STATE(1822),
    [sym_fsi_directive_decl] = STATE(1822),
    [sym_preproc_line] = STATE(1822),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_LBRACK_LT] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_and] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [aux_sym_access_modifier_token1] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_with] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_default] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [anon_sym_static] = ACTIONS(4228),
    [anon_sym_member] = ACTIONS(4228),
    [anon_sym_interface] = ACTIONS(4228),
    [anon_sym_abstract] = ACTIONS(4228),
    [anon_sym_val] = ACTIONS(4228),
    [anon_sym_override] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [anon_sym_POUNDendif] = ACTIONS(4226),
    [anon_sym_POUNDelse] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
  },
  [1823] = {
    [sym_block_comment] = STATE(1823),
    [sym_compiler_directive_decl] = STATE(1823),
    [sym_fsi_directive_decl] = STATE(1823),
    [sym_preproc_line] = STATE(1823),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_LBRACK_LT] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [aux_sym_access_modifier_token1] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_default] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [anon_sym_static] = ACTIONS(3700),
    [anon_sym_member] = ACTIONS(3700),
    [anon_sym_interface] = ACTIONS(3700),
    [anon_sym_abstract] = ACTIONS(3700),
    [anon_sym_val] = ACTIONS(3700),
    [anon_sym_override] = ACTIONS(3700),
    [anon_sym_inherit] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [anon_sym_POUNDendif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [1824] = {
    [sym_block_comment] = STATE(1824),
    [sym_compiler_directive_decl] = STATE(1824),
    [sym_fsi_directive_decl] = STATE(1824),
    [sym_preproc_line] = STATE(1824),
    [sym_identifier] = ACTIONS(3875),
    [anon_sym_EQ] = ACTIONS(3873),
    [anon_sym_LBRACK_LT] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(3875),
    [anon_sym_return] = ACTIONS(3875),
    [anon_sym_do] = ACTIONS(3875),
    [anon_sym_and] = ACTIONS(3875),
    [anon_sym_let] = ACTIONS(3875),
    [anon_sym_let_BANG] = ACTIONS(3873),
    [aux_sym_access_modifier_token1] = ACTIONS(3873),
    [anon_sym_LPAREN] = ACTIONS(3875),
    [anon_sym_COMMA] = ACTIONS(3873),
    [anon_sym_null] = ACTIONS(3875),
    [anon_sym_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_COLON] = ACTIONS(3873),
    [anon_sym_AMP] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(3875),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3873),
    [anon_sym_LBRACE] = ACTIONS(3875),
    [anon_sym_LT_AT] = ACTIONS(3875),
    [anon_sym_LT_AT_AT] = ACTIONS(3875),
    [anon_sym_DOT] = ACTIONS(3875),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3873),
    [anon_sym_new] = ACTIONS(3875),
    [anon_sym_with] = ACTIONS(3875),
    [anon_sym_return_BANG] = ACTIONS(3873),
    [anon_sym_yield] = ACTIONS(3875),
    [anon_sym_yield_BANG] = ACTIONS(3873),
    [anon_sym_lazy] = ACTIONS(3875),
    [anon_sym_assert] = ACTIONS(3875),
    [anon_sym_upcast] = ACTIONS(3875),
    [anon_sym_downcast] = ACTIONS(3875),
    [anon_sym_COLON_GT] = ACTIONS(3873),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3873),
    [anon_sym_for] = ACTIONS(3875),
    [anon_sym_while] = ACTIONS(3875),
    [anon_sym_if] = ACTIONS(3875),
    [anon_sym_fun] = ACTIONS(3875),
    [anon_sym_try] = ACTIONS(3875),
    [anon_sym_match] = ACTIONS(3875),
    [anon_sym_match_BANG] = ACTIONS(3873),
    [anon_sym_function] = ACTIONS(3875),
    [anon_sym_LT_DASH] = ACTIONS(3875),
    [anon_sym_DOT_LBRACK] = ACTIONS(3873),
    [anon_sym_LT] = ACTIONS(3873),
    [anon_sym_use] = ACTIONS(3875),
    [anon_sym_use_BANG] = ACTIONS(3873),
    [anon_sym_do_BANG] = ACTIONS(3873),
    [anon_sym_begin] = ACTIONS(3875),
    [anon_sym_LPAREN2] = ACTIONS(3875),
    [anon_sym_default] = ACTIONS(3875),
    [anon_sym_or] = ACTIONS(3875),
    [anon_sym_static] = ACTIONS(3875),
    [anon_sym_member] = ACTIONS(3875),
    [anon_sym_interface] = ACTIONS(3875),
    [anon_sym_abstract] = ACTIONS(3875),
    [anon_sym_val] = ACTIONS(3875),
    [anon_sym_override] = ACTIONS(3875),
    [aux_sym_char_token1] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3875),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [anon_sym_AT_DQUOTE] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [sym_bool] = ACTIONS(3875),
    [sym_unit] = ACTIONS(3873),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3875),
    [sym_op_identifier] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS_DOT] = ACTIONS(3875),
    [anon_sym_DASH_DOT] = ACTIONS(3875),
    [anon_sym_PERCENT] = ACTIONS(3875),
    [anon_sym_AMP_AMP] = ACTIONS(3875),
    [anon_sym_TILDE] = ACTIONS(3873),
    [aux_sym_prefix_op_token1] = ACTIONS(3875),
    [aux_sym_infix_op_token1] = ACTIONS(3873),
    [aux_sym_infix_op_token2] = ACTIONS(3875),
    [anon_sym_PIPE_PIPE] = ACTIONS(3875),
    [anon_sym_BANG_EQ] = ACTIONS(3875),
    [anon_sym_COLON_EQ] = ACTIONS(3873),
    [anon_sym_DOLLAR] = ACTIONS(3875),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3875),
    [sym_int] = ACTIONS(3875),
    [sym_xint] = ACTIONS(3873),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3873),
    [anon_sym_POUNDendif] = ACTIONS(3873),
    [anon_sym_POUNDelse] = ACTIONS(3873),
    [sym__newline] = ACTIONS(3873),
  },
  [1825] = {
    [sym_block_comment] = STATE(1825),
    [sym_compiler_directive_decl] = STATE(1825),
    [sym_fsi_directive_decl] = STATE(1825),
    [sym_preproc_line] = STATE(1825),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_LBRACK_LT] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_and] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [aux_sym_access_modifier_token1] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4708),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_with] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_default] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [anon_sym_static] = ACTIONS(4228),
    [anon_sym_member] = ACTIONS(4228),
    [anon_sym_interface] = ACTIONS(4228),
    [anon_sym_abstract] = ACTIONS(4228),
    [anon_sym_val] = ACTIONS(4228),
    [anon_sym_override] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [anon_sym_POUNDendif] = ACTIONS(4226),
    [anon_sym_POUNDelse] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
  },
  [1826] = {
    [sym_block_comment] = STATE(1826),
    [sym_compiler_directive_decl] = STATE(1826),
    [sym_fsi_directive_decl] = STATE(1826),
    [sym_preproc_line] = STATE(1826),
    [sym_identifier] = ACTIONS(4122),
    [anon_sym_EQ] = ACTIONS(4120),
    [anon_sym_LBRACK_LT] = ACTIONS(4120),
    [anon_sym_COLON] = ACTIONS(4122),
    [anon_sym_return] = ACTIONS(4122),
    [anon_sym_do] = ACTIONS(4122),
    [anon_sym_and] = ACTIONS(4122),
    [anon_sym_let] = ACTIONS(4122),
    [anon_sym_let_BANG] = ACTIONS(4120),
    [aux_sym_access_modifier_token1] = ACTIONS(4120),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_COMMA] = ACTIONS(4120),
    [anon_sym_null] = ACTIONS(4122),
    [anon_sym_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_COLON] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_LT_AT] = ACTIONS(4122),
    [anon_sym_LT_AT_AT] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4122),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4120),
    [anon_sym_new] = ACTIONS(4122),
    [anon_sym_with] = ACTIONS(4122),
    [anon_sym_return_BANG] = ACTIONS(4120),
    [anon_sym_yield] = ACTIONS(4122),
    [anon_sym_yield_BANG] = ACTIONS(4120),
    [anon_sym_lazy] = ACTIONS(4122),
    [anon_sym_assert] = ACTIONS(4122),
    [anon_sym_upcast] = ACTIONS(4122),
    [anon_sym_downcast] = ACTIONS(4122),
    [anon_sym_COLON_GT] = ACTIONS(4120),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4120),
    [anon_sym_for] = ACTIONS(4122),
    [anon_sym_while] = ACTIONS(4122),
    [anon_sym_if] = ACTIONS(4122),
    [anon_sym_fun] = ACTIONS(4122),
    [anon_sym_try] = ACTIONS(4122),
    [anon_sym_match] = ACTIONS(4122),
    [anon_sym_match_BANG] = ACTIONS(4120),
    [anon_sym_function] = ACTIONS(4122),
    [anon_sym_LT_DASH] = ACTIONS(4122),
    [anon_sym_DOT_LBRACK] = ACTIONS(4120),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_use] = ACTIONS(4122),
    [anon_sym_use_BANG] = ACTIONS(4120),
    [anon_sym_do_BANG] = ACTIONS(4120),
    [anon_sym_begin] = ACTIONS(4122),
    [anon_sym_LPAREN2] = ACTIONS(4122),
    [anon_sym_default] = ACTIONS(4122),
    [anon_sym_or] = ACTIONS(4122),
    [anon_sym_static] = ACTIONS(4122),
    [anon_sym_member] = ACTIONS(4122),
    [anon_sym_interface] = ACTIONS(4122),
    [anon_sym_abstract] = ACTIONS(4122),
    [anon_sym_val] = ACTIONS(4122),
    [anon_sym_override] = ACTIONS(4122),
    [aux_sym_char_token1] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4122),
    [anon_sym_DQUOTE] = ACTIONS(4122),
    [anon_sym_AT_DQUOTE] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [sym_bool] = ACTIONS(4122),
    [sym_unit] = ACTIONS(4120),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4122),
    [sym_op_identifier] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4122),
    [anon_sym_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_DOT] = ACTIONS(4122),
    [anon_sym_DASH_DOT] = ACTIONS(4122),
    [anon_sym_PERCENT] = ACTIONS(4122),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_TILDE] = ACTIONS(4120),
    [aux_sym_prefix_op_token1] = ACTIONS(4122),
    [aux_sym_infix_op_token1] = ACTIONS(4120),
    [aux_sym_infix_op_token2] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_COLON_EQ] = ACTIONS(4120),
    [anon_sym_DOLLAR] = ACTIONS(4122),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4122),
    [sym_int] = ACTIONS(4122),
    [sym_xint] = ACTIONS(4120),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4120),
    [anon_sym_POUNDendif] = ACTIONS(4120),
    [anon_sym_POUNDelse] = ACTIONS(4120),
    [sym__newline] = ACTIONS(4120),
  },
  [1827] = {
    [sym_block_comment] = STATE(1827),
    [sym_compiler_directive_decl] = STATE(1827),
    [sym_fsi_directive_decl] = STATE(1827),
    [sym_preproc_line] = STATE(1827),
    [sym_identifier] = ACTIONS(4118),
    [anon_sym_EQ] = ACTIONS(4116),
    [anon_sym_LBRACK_LT] = ACTIONS(4116),
    [anon_sym_COLON] = ACTIONS(4118),
    [anon_sym_return] = ACTIONS(4118),
    [anon_sym_do] = ACTIONS(4118),
    [anon_sym_and] = ACTIONS(4118),
    [anon_sym_let] = ACTIONS(4118),
    [anon_sym_let_BANG] = ACTIONS(4116),
    [aux_sym_access_modifier_token1] = ACTIONS(4116),
    [anon_sym_LPAREN] = ACTIONS(4118),
    [anon_sym_COMMA] = ACTIONS(4116),
    [anon_sym_null] = ACTIONS(4118),
    [anon_sym_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_COLON] = ACTIONS(4116),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4118),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(4118),
    [anon_sym_LT_AT] = ACTIONS(4118),
    [anon_sym_LT_AT_AT] = ACTIONS(4118),
    [anon_sym_DOT] = ACTIONS(4118),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4116),
    [anon_sym_new] = ACTIONS(4118),
    [anon_sym_with] = ACTIONS(4118),
    [anon_sym_return_BANG] = ACTIONS(4116),
    [anon_sym_yield] = ACTIONS(4118),
    [anon_sym_yield_BANG] = ACTIONS(4116),
    [anon_sym_lazy] = ACTIONS(4118),
    [anon_sym_assert] = ACTIONS(4118),
    [anon_sym_upcast] = ACTIONS(4118),
    [anon_sym_downcast] = ACTIONS(4118),
    [anon_sym_COLON_GT] = ACTIONS(4116),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4116),
    [anon_sym_for] = ACTIONS(4118),
    [anon_sym_while] = ACTIONS(4118),
    [anon_sym_if] = ACTIONS(4118),
    [anon_sym_fun] = ACTIONS(4118),
    [anon_sym_try] = ACTIONS(4118),
    [anon_sym_match] = ACTIONS(4118),
    [anon_sym_match_BANG] = ACTIONS(4116),
    [anon_sym_function] = ACTIONS(4118),
    [anon_sym_LT_DASH] = ACTIONS(4118),
    [anon_sym_DOT_LBRACK] = ACTIONS(4116),
    [anon_sym_LT] = ACTIONS(4116),
    [anon_sym_use] = ACTIONS(4118),
    [anon_sym_use_BANG] = ACTIONS(4116),
    [anon_sym_do_BANG] = ACTIONS(4116),
    [anon_sym_begin] = ACTIONS(4118),
    [anon_sym_LPAREN2] = ACTIONS(4118),
    [anon_sym_default] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [anon_sym_static] = ACTIONS(4118),
    [anon_sym_member] = ACTIONS(4118),
    [anon_sym_interface] = ACTIONS(4118),
    [anon_sym_abstract] = ACTIONS(4118),
    [anon_sym_val] = ACTIONS(4118),
    [anon_sym_override] = ACTIONS(4118),
    [aux_sym_char_token1] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4118),
    [anon_sym_DQUOTE] = ACTIONS(4118),
    [anon_sym_AT_DQUOTE] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [sym_bool] = ACTIONS(4118),
    [sym_unit] = ACTIONS(4116),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4118),
    [sym_op_identifier] = ACTIONS(4118),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_PLUS_DOT] = ACTIONS(4118),
    [anon_sym_DASH_DOT] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_AMP_AMP] = ACTIONS(4118),
    [anon_sym_TILDE] = ACTIONS(4116),
    [aux_sym_prefix_op_token1] = ACTIONS(4118),
    [aux_sym_infix_op_token1] = ACTIONS(4116),
    [aux_sym_infix_op_token2] = ACTIONS(4118),
    [anon_sym_PIPE_PIPE] = ACTIONS(4118),
    [anon_sym_BANG_EQ] = ACTIONS(4118),
    [anon_sym_COLON_EQ] = ACTIONS(4116),
    [anon_sym_DOLLAR] = ACTIONS(4118),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4118),
    [sym_int] = ACTIONS(4118),
    [sym_xint] = ACTIONS(4116),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4116),
    [anon_sym_POUNDendif] = ACTIONS(4116),
    [anon_sym_POUNDelse] = ACTIONS(4116),
    [sym__newline] = ACTIONS(4116),
  },
  [1828] = {
    [sym_block_comment] = STATE(1828),
    [sym_compiler_directive_decl] = STATE(1828),
    [sym_fsi_directive_decl] = STATE(1828),
    [sym_preproc_line] = STATE(1828),
    [sym_identifier] = ACTIONS(4112),
    [anon_sym_EQ] = ACTIONS(4110),
    [anon_sym_LBRACK_LT] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4112),
    [anon_sym_return] = ACTIONS(4112),
    [anon_sym_do] = ACTIONS(4112),
    [anon_sym_and] = ACTIONS(4112),
    [anon_sym_let] = ACTIONS(4112),
    [anon_sym_let_BANG] = ACTIONS(4110),
    [aux_sym_access_modifier_token1] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_null] = ACTIONS(4112),
    [anon_sym_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_COLON] = ACTIONS(4110),
    [anon_sym_AMP] = ACTIONS(4112),
    [anon_sym_LBRACK] = ACTIONS(4112),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4110),
    [anon_sym_LBRACE] = ACTIONS(4112),
    [anon_sym_LT_AT] = ACTIONS(4112),
    [anon_sym_LT_AT_AT] = ACTIONS(4112),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4110),
    [anon_sym_new] = ACTIONS(4112),
    [anon_sym_with] = ACTIONS(4112),
    [anon_sym_return_BANG] = ACTIONS(4110),
    [anon_sym_yield] = ACTIONS(4112),
    [anon_sym_yield_BANG] = ACTIONS(4110),
    [anon_sym_lazy] = ACTIONS(4112),
    [anon_sym_assert] = ACTIONS(4112),
    [anon_sym_upcast] = ACTIONS(4112),
    [anon_sym_downcast] = ACTIONS(4112),
    [anon_sym_COLON_GT] = ACTIONS(4110),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4110),
    [anon_sym_for] = ACTIONS(4112),
    [anon_sym_while] = ACTIONS(4112),
    [anon_sym_if] = ACTIONS(4112),
    [anon_sym_fun] = ACTIONS(4112),
    [anon_sym_try] = ACTIONS(4112),
    [anon_sym_match] = ACTIONS(4112),
    [anon_sym_match_BANG] = ACTIONS(4110),
    [anon_sym_function] = ACTIONS(4112),
    [anon_sym_LT_DASH] = ACTIONS(4112),
    [anon_sym_DOT_LBRACK] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(4110),
    [anon_sym_use] = ACTIONS(4112),
    [anon_sym_use_BANG] = ACTIONS(4110),
    [anon_sym_do_BANG] = ACTIONS(4110),
    [anon_sym_begin] = ACTIONS(4112),
    [anon_sym_LPAREN2] = ACTIONS(4112),
    [anon_sym_default] = ACTIONS(4112),
    [anon_sym_or] = ACTIONS(4112),
    [anon_sym_static] = ACTIONS(4112),
    [anon_sym_member] = ACTIONS(4112),
    [anon_sym_interface] = ACTIONS(4112),
    [anon_sym_abstract] = ACTIONS(4112),
    [anon_sym_val] = ACTIONS(4112),
    [anon_sym_override] = ACTIONS(4112),
    [aux_sym_char_token1] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4112),
    [anon_sym_DQUOTE] = ACTIONS(4112),
    [anon_sym_AT_DQUOTE] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [sym_bool] = ACTIONS(4112),
    [sym_unit] = ACTIONS(4110),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4112),
    [sym_op_identifier] = ACTIONS(4112),
    [anon_sym_PLUS] = ACTIONS(4112),
    [anon_sym_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_DOT] = ACTIONS(4112),
    [anon_sym_DASH_DOT] = ACTIONS(4112),
    [anon_sym_PERCENT] = ACTIONS(4112),
    [anon_sym_AMP_AMP] = ACTIONS(4112),
    [anon_sym_TILDE] = ACTIONS(4110),
    [aux_sym_prefix_op_token1] = ACTIONS(4112),
    [aux_sym_infix_op_token1] = ACTIONS(4110),
    [aux_sym_infix_op_token2] = ACTIONS(4112),
    [anon_sym_PIPE_PIPE] = ACTIONS(4112),
    [anon_sym_BANG_EQ] = ACTIONS(4112),
    [anon_sym_COLON_EQ] = ACTIONS(4110),
    [anon_sym_DOLLAR] = ACTIONS(4112),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4112),
    [sym_int] = ACTIONS(4112),
    [sym_xint] = ACTIONS(4110),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4110),
    [anon_sym_POUNDendif] = ACTIONS(4110),
    [anon_sym_POUNDelse] = ACTIONS(4110),
    [sym__newline] = ACTIONS(4110),
  },
  [1829] = {
    [sym_block_comment] = STATE(1829),
    [sym_compiler_directive_decl] = STATE(1829),
    [sym_fsi_directive_decl] = STATE(1829),
    [sym_preproc_line] = STATE(1829),
    [sym_identifier] = ACTIONS(4108),
    [anon_sym_EQ] = ACTIONS(4106),
    [anon_sym_LBRACK_LT] = ACTIONS(4106),
    [anon_sym_COLON] = ACTIONS(4108),
    [anon_sym_return] = ACTIONS(4108),
    [anon_sym_do] = ACTIONS(4108),
    [anon_sym_and] = ACTIONS(4108),
    [anon_sym_let] = ACTIONS(4108),
    [anon_sym_let_BANG] = ACTIONS(4106),
    [aux_sym_access_modifier_token1] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(4108),
    [anon_sym_COMMA] = ACTIONS(4106),
    [anon_sym_null] = ACTIONS(4108),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_COLON] = ACTIONS(4106),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LBRACK] = ACTIONS(4108),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(4108),
    [anon_sym_LT_AT] = ACTIONS(4108),
    [anon_sym_LT_AT_AT] = ACTIONS(4108),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4106),
    [anon_sym_new] = ACTIONS(4108),
    [anon_sym_with] = ACTIONS(4108),
    [anon_sym_return_BANG] = ACTIONS(4106),
    [anon_sym_yield] = ACTIONS(4108),
    [anon_sym_yield_BANG] = ACTIONS(4106),
    [anon_sym_lazy] = ACTIONS(4108),
    [anon_sym_assert] = ACTIONS(4108),
    [anon_sym_upcast] = ACTIONS(4108),
    [anon_sym_downcast] = ACTIONS(4108),
    [anon_sym_COLON_GT] = ACTIONS(4106),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4106),
    [anon_sym_for] = ACTIONS(4108),
    [anon_sym_while] = ACTIONS(4108),
    [anon_sym_if] = ACTIONS(4108),
    [anon_sym_fun] = ACTIONS(4108),
    [anon_sym_try] = ACTIONS(4108),
    [anon_sym_match] = ACTIONS(4108),
    [anon_sym_match_BANG] = ACTIONS(4106),
    [anon_sym_function] = ACTIONS(4108),
    [anon_sym_LT_DASH] = ACTIONS(4108),
    [anon_sym_DOT_LBRACK] = ACTIONS(4106),
    [anon_sym_LT] = ACTIONS(4106),
    [anon_sym_use] = ACTIONS(4108),
    [anon_sym_use_BANG] = ACTIONS(4106),
    [anon_sym_do_BANG] = ACTIONS(4106),
    [anon_sym_begin] = ACTIONS(4108),
    [anon_sym_LPAREN2] = ACTIONS(4108),
    [anon_sym_default] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [anon_sym_static] = ACTIONS(4108),
    [anon_sym_member] = ACTIONS(4108),
    [anon_sym_interface] = ACTIONS(4108),
    [anon_sym_abstract] = ACTIONS(4108),
    [anon_sym_val] = ACTIONS(4108),
    [anon_sym_override] = ACTIONS(4108),
    [aux_sym_char_token1] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4108),
    [anon_sym_DQUOTE] = ACTIONS(4108),
    [anon_sym_AT_DQUOTE] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [sym_bool] = ACTIONS(4108),
    [sym_unit] = ACTIONS(4106),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4108),
    [sym_op_identifier] = ACTIONS(4108),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_PLUS_DOT] = ACTIONS(4108),
    [anon_sym_DASH_DOT] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_AMP_AMP] = ACTIONS(4108),
    [anon_sym_TILDE] = ACTIONS(4106),
    [aux_sym_prefix_op_token1] = ACTIONS(4108),
    [aux_sym_infix_op_token1] = ACTIONS(4106),
    [aux_sym_infix_op_token2] = ACTIONS(4108),
    [anon_sym_PIPE_PIPE] = ACTIONS(4108),
    [anon_sym_BANG_EQ] = ACTIONS(4108),
    [anon_sym_COLON_EQ] = ACTIONS(4106),
    [anon_sym_DOLLAR] = ACTIONS(4108),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4108),
    [sym_int] = ACTIONS(4108),
    [sym_xint] = ACTIONS(4106),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4106),
    [anon_sym_POUNDendif] = ACTIONS(4106),
    [anon_sym_POUNDelse] = ACTIONS(4106),
    [sym__newline] = ACTIONS(4106),
  },
  [1830] = {
    [sym_block_comment] = STATE(1830),
    [sym_compiler_directive_decl] = STATE(1830),
    [sym_fsi_directive_decl] = STATE(1830),
    [sym_preproc_line] = STATE(1830),
    [sym_identifier] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(4091),
    [anon_sym_LBRACK_LT] = ACTIONS(4091),
    [anon_sym_COLON] = ACTIONS(4093),
    [anon_sym_return] = ACTIONS(4093),
    [anon_sym_do] = ACTIONS(4093),
    [anon_sym_and] = ACTIONS(4093),
    [anon_sym_let] = ACTIONS(4093),
    [anon_sym_let_BANG] = ACTIONS(4091),
    [aux_sym_access_modifier_token1] = ACTIONS(4091),
    [anon_sym_LPAREN] = ACTIONS(4093),
    [anon_sym_COMMA] = ACTIONS(4091),
    [anon_sym_null] = ACTIONS(4093),
    [anon_sym_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_COLON] = ACTIONS(4091),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(4093),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4091),
    [anon_sym_LBRACE] = ACTIONS(4093),
    [anon_sym_LT_AT] = ACTIONS(4093),
    [anon_sym_LT_AT_AT] = ACTIONS(4093),
    [anon_sym_DOT] = ACTIONS(4093),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4091),
    [anon_sym_new] = ACTIONS(4093),
    [anon_sym_with] = ACTIONS(4093),
    [anon_sym_return_BANG] = ACTIONS(4091),
    [anon_sym_yield] = ACTIONS(4093),
    [anon_sym_yield_BANG] = ACTIONS(4091),
    [anon_sym_lazy] = ACTIONS(4093),
    [anon_sym_assert] = ACTIONS(4093),
    [anon_sym_upcast] = ACTIONS(4093),
    [anon_sym_downcast] = ACTIONS(4093),
    [anon_sym_COLON_GT] = ACTIONS(4091),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4091),
    [anon_sym_for] = ACTIONS(4093),
    [anon_sym_while] = ACTIONS(4093),
    [anon_sym_if] = ACTIONS(4093),
    [anon_sym_fun] = ACTIONS(4093),
    [anon_sym_try] = ACTIONS(4093),
    [anon_sym_match] = ACTIONS(4093),
    [anon_sym_match_BANG] = ACTIONS(4091),
    [anon_sym_function] = ACTIONS(4093),
    [anon_sym_LT_DASH] = ACTIONS(4093),
    [anon_sym_DOT_LBRACK] = ACTIONS(4091),
    [anon_sym_LT] = ACTIONS(4091),
    [anon_sym_use] = ACTIONS(4093),
    [anon_sym_use_BANG] = ACTIONS(4091),
    [anon_sym_do_BANG] = ACTIONS(4091),
    [anon_sym_begin] = ACTIONS(4093),
    [anon_sym_LPAREN2] = ACTIONS(4093),
    [anon_sym_default] = ACTIONS(4093),
    [anon_sym_or] = ACTIONS(4093),
    [anon_sym_static] = ACTIONS(4093),
    [anon_sym_member] = ACTIONS(4093),
    [anon_sym_interface] = ACTIONS(4093),
    [anon_sym_abstract] = ACTIONS(4093),
    [anon_sym_val] = ACTIONS(4093),
    [anon_sym_override] = ACTIONS(4093),
    [aux_sym_char_token1] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4093),
    [anon_sym_DQUOTE] = ACTIONS(4093),
    [anon_sym_AT_DQUOTE] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [sym_bool] = ACTIONS(4093),
    [sym_unit] = ACTIONS(4091),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4093),
    [sym_op_identifier] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS_DOT] = ACTIONS(4093),
    [anon_sym_DASH_DOT] = ACTIONS(4093),
    [anon_sym_PERCENT] = ACTIONS(4093),
    [anon_sym_AMP_AMP] = ACTIONS(4093),
    [anon_sym_TILDE] = ACTIONS(4091),
    [aux_sym_prefix_op_token1] = ACTIONS(4093),
    [aux_sym_infix_op_token1] = ACTIONS(4091),
    [aux_sym_infix_op_token2] = ACTIONS(4093),
    [anon_sym_PIPE_PIPE] = ACTIONS(4093),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_COLON_EQ] = ACTIONS(4091),
    [anon_sym_DOLLAR] = ACTIONS(4093),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4093),
    [sym_int] = ACTIONS(4093),
    [sym_xint] = ACTIONS(4091),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4091),
    [anon_sym_POUNDendif] = ACTIONS(4091),
    [anon_sym_POUNDelse] = ACTIONS(4091),
    [sym__newline] = ACTIONS(4091),
  },
  [1831] = {
    [sym_block_comment] = STATE(1831),
    [sym_compiler_directive_decl] = STATE(1831),
    [sym_fsi_directive_decl] = STATE(1831),
    [sym_preproc_line] = STATE(1831),
    [sym_identifier] = ACTIONS(4086),
    [anon_sym_EQ] = ACTIONS(4084),
    [anon_sym_LBRACK_LT] = ACTIONS(4084),
    [anon_sym_COLON] = ACTIONS(4086),
    [anon_sym_return] = ACTIONS(4086),
    [anon_sym_do] = ACTIONS(4086),
    [anon_sym_and] = ACTIONS(4086),
    [anon_sym_let] = ACTIONS(4086),
    [anon_sym_let_BANG] = ACTIONS(4084),
    [aux_sym_access_modifier_token1] = ACTIONS(4084),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_COMMA] = ACTIONS(4084),
    [anon_sym_null] = ACTIONS(4086),
    [anon_sym_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_COLON] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4084),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_LT_AT] = ACTIONS(4086),
    [anon_sym_LT_AT_AT] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4086),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4084),
    [anon_sym_new] = ACTIONS(4086),
    [anon_sym_with] = ACTIONS(4086),
    [anon_sym_return_BANG] = ACTIONS(4084),
    [anon_sym_yield] = ACTIONS(4086),
    [anon_sym_yield_BANG] = ACTIONS(4084),
    [anon_sym_lazy] = ACTIONS(4086),
    [anon_sym_assert] = ACTIONS(4086),
    [anon_sym_upcast] = ACTIONS(4086),
    [anon_sym_downcast] = ACTIONS(4086),
    [anon_sym_COLON_GT] = ACTIONS(4084),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4084),
    [anon_sym_for] = ACTIONS(4086),
    [anon_sym_while] = ACTIONS(4086),
    [anon_sym_if] = ACTIONS(4086),
    [anon_sym_fun] = ACTIONS(4086),
    [anon_sym_try] = ACTIONS(4086),
    [anon_sym_match] = ACTIONS(4086),
    [anon_sym_match_BANG] = ACTIONS(4084),
    [anon_sym_function] = ACTIONS(4086),
    [anon_sym_LT_DASH] = ACTIONS(4086),
    [anon_sym_DOT_LBRACK] = ACTIONS(4084),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_use] = ACTIONS(4086),
    [anon_sym_use_BANG] = ACTIONS(4084),
    [anon_sym_do_BANG] = ACTIONS(4084),
    [anon_sym_begin] = ACTIONS(4086),
    [anon_sym_LPAREN2] = ACTIONS(4086),
    [anon_sym_default] = ACTIONS(4086),
    [anon_sym_or] = ACTIONS(4086),
    [anon_sym_static] = ACTIONS(4086),
    [anon_sym_member] = ACTIONS(4086),
    [anon_sym_interface] = ACTIONS(4086),
    [anon_sym_abstract] = ACTIONS(4086),
    [anon_sym_val] = ACTIONS(4086),
    [anon_sym_override] = ACTIONS(4086),
    [aux_sym_char_token1] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4086),
    [anon_sym_DQUOTE] = ACTIONS(4086),
    [anon_sym_AT_DQUOTE] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [sym_bool] = ACTIONS(4086),
    [sym_unit] = ACTIONS(4084),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4086),
    [sym_op_identifier] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4086),
    [anon_sym_DASH] = ACTIONS(4086),
    [anon_sym_PLUS_DOT] = ACTIONS(4086),
    [anon_sym_DASH_DOT] = ACTIONS(4086),
    [anon_sym_PERCENT] = ACTIONS(4086),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_TILDE] = ACTIONS(4084),
    [aux_sym_prefix_op_token1] = ACTIONS(4086),
    [aux_sym_infix_op_token1] = ACTIONS(4084),
    [aux_sym_infix_op_token2] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_COLON_EQ] = ACTIONS(4084),
    [anon_sym_DOLLAR] = ACTIONS(4086),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4086),
    [sym_int] = ACTIONS(4086),
    [sym_xint] = ACTIONS(4084),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4084),
    [anon_sym_POUNDendif] = ACTIONS(4084),
    [anon_sym_POUNDelse] = ACTIONS(4084),
    [sym__newline] = ACTIONS(4084),
  },
  [1832] = {
    [sym_block_comment] = STATE(1832),
    [sym_compiler_directive_decl] = STATE(1832),
    [sym_fsi_directive_decl] = STATE(1832),
    [sym_preproc_line] = STATE(1832),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LBRACK_LT] = ACTIONS(4080),
    [anon_sym_COLON] = ACTIONS(4082),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_do] = ACTIONS(4082),
    [anon_sym_and] = ACTIONS(4082),
    [anon_sym_let] = ACTIONS(4082),
    [anon_sym_let_BANG] = ACTIONS(4080),
    [aux_sym_access_modifier_token1] = ACTIONS(4080),
    [anon_sym_LPAREN] = ACTIONS(4082),
    [anon_sym_COMMA] = ACTIONS(4080),
    [anon_sym_null] = ACTIONS(4082),
    [anon_sym_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_COLON] = ACTIONS(4080),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_LBRACK] = ACTIONS(4082),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(4082),
    [anon_sym_LT_AT] = ACTIONS(4082),
    [anon_sym_LT_AT_AT] = ACTIONS(4082),
    [anon_sym_DOT] = ACTIONS(4082),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4080),
    [anon_sym_new] = ACTIONS(4082),
    [anon_sym_with] = ACTIONS(4082),
    [anon_sym_return_BANG] = ACTIONS(4080),
    [anon_sym_yield] = ACTIONS(4082),
    [anon_sym_yield_BANG] = ACTIONS(4080),
    [anon_sym_lazy] = ACTIONS(4082),
    [anon_sym_assert] = ACTIONS(4082),
    [anon_sym_upcast] = ACTIONS(4082),
    [anon_sym_downcast] = ACTIONS(4082),
    [anon_sym_COLON_GT] = ACTIONS(4080),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4080),
    [anon_sym_for] = ACTIONS(4082),
    [anon_sym_while] = ACTIONS(4082),
    [anon_sym_if] = ACTIONS(4082),
    [anon_sym_fun] = ACTIONS(4082),
    [anon_sym_try] = ACTIONS(4082),
    [anon_sym_match] = ACTIONS(4082),
    [anon_sym_match_BANG] = ACTIONS(4080),
    [anon_sym_function] = ACTIONS(4082),
    [anon_sym_LT_DASH] = ACTIONS(4082),
    [anon_sym_DOT_LBRACK] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(4080),
    [anon_sym_use] = ACTIONS(4082),
    [anon_sym_use_BANG] = ACTIONS(4080),
    [anon_sym_do_BANG] = ACTIONS(4080),
    [anon_sym_begin] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4082),
    [anon_sym_default] = ACTIONS(4082),
    [anon_sym_or] = ACTIONS(4082),
    [anon_sym_static] = ACTIONS(4082),
    [anon_sym_member] = ACTIONS(4082),
    [anon_sym_interface] = ACTIONS(4082),
    [anon_sym_abstract] = ACTIONS(4082),
    [anon_sym_val] = ACTIONS(4082),
    [anon_sym_override] = ACTIONS(4082),
    [aux_sym_char_token1] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4082),
    [anon_sym_DQUOTE] = ACTIONS(4082),
    [anon_sym_AT_DQUOTE] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [sym_bool] = ACTIONS(4082),
    [sym_unit] = ACTIONS(4080),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4082),
    [sym_op_identifier] = ACTIONS(4082),
    [anon_sym_PLUS] = ACTIONS(4082),
    [anon_sym_DASH] = ACTIONS(4082),
    [anon_sym_PLUS_DOT] = ACTIONS(4082),
    [anon_sym_DASH_DOT] = ACTIONS(4082),
    [anon_sym_PERCENT] = ACTIONS(4082),
    [anon_sym_AMP_AMP] = ACTIONS(4082),
    [anon_sym_TILDE] = ACTIONS(4080),
    [aux_sym_prefix_op_token1] = ACTIONS(4082),
    [aux_sym_infix_op_token1] = ACTIONS(4080),
    [aux_sym_infix_op_token2] = ACTIONS(4082),
    [anon_sym_PIPE_PIPE] = ACTIONS(4082),
    [anon_sym_BANG_EQ] = ACTIONS(4082),
    [anon_sym_COLON_EQ] = ACTIONS(4080),
    [anon_sym_DOLLAR] = ACTIONS(4082),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4082),
    [sym_int] = ACTIONS(4082),
    [sym_xint] = ACTIONS(4080),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4080),
    [anon_sym_POUNDendif] = ACTIONS(4080),
    [anon_sym_POUNDelse] = ACTIONS(4080),
    [sym__newline] = ACTIONS(4080),
  },
  [1833] = {
    [sym_block_comment] = STATE(1833),
    [sym_compiler_directive_decl] = STATE(1833),
    [sym_fsi_directive_decl] = STATE(1833),
    [sym_preproc_line] = STATE(1833),
    [sym_identifier] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3772),
    [anon_sym_LBRACK_LT] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3774),
    [anon_sym_do] = ACTIONS(3774),
    [anon_sym_and] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3774),
    [anon_sym_let_BANG] = ACTIONS(3772),
    [aux_sym_access_modifier_token1] = ACTIONS(3772),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3772),
    [anon_sym_null] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_COLON] = ACTIONS(3772),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_LT_AT] = ACTIONS(3774),
    [anon_sym_LT_AT_AT] = ACTIONS(3774),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3772),
    [anon_sym_new] = ACTIONS(3774),
    [anon_sym_with] = ACTIONS(3774),
    [anon_sym_return_BANG] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3774),
    [anon_sym_yield_BANG] = ACTIONS(3772),
    [anon_sym_lazy] = ACTIONS(3774),
    [anon_sym_assert] = ACTIONS(3774),
    [anon_sym_upcast] = ACTIONS(3774),
    [anon_sym_downcast] = ACTIONS(3774),
    [anon_sym_COLON_GT] = ACTIONS(3772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3774),
    [anon_sym_done] = ACTIONS(4710),
    [anon_sym_while] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3774),
    [anon_sym_fun] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3774),
    [anon_sym_match] = ACTIONS(3774),
    [anon_sym_match_BANG] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3774),
    [anon_sym_LT_DASH] = ACTIONS(3774),
    [anon_sym_DOT_LBRACK] = ACTIONS(3772),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_use] = ACTIONS(3774),
    [anon_sym_use_BANG] = ACTIONS(3772),
    [anon_sym_do_BANG] = ACTIONS(3772),
    [anon_sym_begin] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3774),
    [anon_sym_default] = ACTIONS(3774),
    [anon_sym_or] = ACTIONS(3774),
    [anon_sym_static] = ACTIONS(3774),
    [anon_sym_member] = ACTIONS(3774),
    [anon_sym_interface] = ACTIONS(3774),
    [anon_sym_abstract] = ACTIONS(3774),
    [anon_sym_val] = ACTIONS(3774),
    [anon_sym_override] = ACTIONS(3774),
    [aux_sym_char_token1] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_AT_DQUOTE] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [sym_bool] = ACTIONS(3774),
    [sym_unit] = ACTIONS(3772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3774),
    [sym_op_identifier] = ACTIONS(3774),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_DOT] = ACTIONS(3774),
    [anon_sym_DASH_DOT] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3772),
    [aux_sym_prefix_op_token1] = ACTIONS(3774),
    [aux_sym_infix_op_token1] = ACTIONS(3772),
    [aux_sym_infix_op_token2] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3774),
    [anon_sym_COLON_EQ] = ACTIONS(3772),
    [anon_sym_DOLLAR] = ACTIONS(3774),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3774),
    [sym_int] = ACTIONS(3774),
    [sym_xint] = ACTIONS(3772),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3772),
    [anon_sym_POUNDendif] = ACTIONS(3772),
    [sym__newline] = ACTIONS(3772),
  },
  [1834] = {
    [sym_block_comment] = STATE(1834),
    [sym_compiler_directive_decl] = STATE(1834),
    [sym_fsi_directive_decl] = STATE(1834),
    [sym_preproc_line] = STATE(1834),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_LBRACK_LT] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_and] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [aux_sym_access_modifier_token1] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_with] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(4649),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_default] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [anon_sym_static] = ACTIONS(3685),
    [anon_sym_member] = ACTIONS(3685),
    [anon_sym_interface] = ACTIONS(3685),
    [anon_sym_abstract] = ACTIONS(3685),
    [anon_sym_val] = ACTIONS(3685),
    [anon_sym_override] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [anon_sym_POUNDendif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
  },
  [1835] = {
    [sym_block_comment] = STATE(1835),
    [sym_compiler_directive_decl] = STATE(1835),
    [sym_fsi_directive_decl] = STATE(1835),
    [sym_preproc_line] = STATE(1835),
    [sym_identifier] = ACTIONS(4054),
    [anon_sym_EQ] = ACTIONS(4052),
    [anon_sym_LBRACK_LT] = ACTIONS(4052),
    [anon_sym_COLON] = ACTIONS(4054),
    [anon_sym_return] = ACTIONS(4054),
    [anon_sym_do] = ACTIONS(4054),
    [anon_sym_and] = ACTIONS(4054),
    [anon_sym_let] = ACTIONS(4054),
    [anon_sym_let_BANG] = ACTIONS(4052),
    [aux_sym_access_modifier_token1] = ACTIONS(4052),
    [anon_sym_LPAREN] = ACTIONS(4054),
    [anon_sym_COMMA] = ACTIONS(4052),
    [anon_sym_null] = ACTIONS(4054),
    [anon_sym_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_COLON] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(4054),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4052),
    [anon_sym_LBRACE] = ACTIONS(4054),
    [anon_sym_LT_AT] = ACTIONS(4054),
    [anon_sym_LT_AT_AT] = ACTIONS(4054),
    [anon_sym_DOT] = ACTIONS(4054),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_with] = ACTIONS(4054),
    [anon_sym_return_BANG] = ACTIONS(4052),
    [anon_sym_yield] = ACTIONS(4054),
    [anon_sym_yield_BANG] = ACTIONS(4052),
    [anon_sym_lazy] = ACTIONS(4054),
    [anon_sym_assert] = ACTIONS(4054),
    [anon_sym_upcast] = ACTIONS(4054),
    [anon_sym_downcast] = ACTIONS(4054),
    [anon_sym_COLON_GT] = ACTIONS(4052),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4052),
    [anon_sym_for] = ACTIONS(4054),
    [anon_sym_while] = ACTIONS(4054),
    [anon_sym_if] = ACTIONS(4054),
    [anon_sym_fun] = ACTIONS(4054),
    [anon_sym_try] = ACTIONS(4054),
    [anon_sym_match] = ACTIONS(4054),
    [anon_sym_match_BANG] = ACTIONS(4052),
    [anon_sym_function] = ACTIONS(4054),
    [anon_sym_LT_DASH] = ACTIONS(4054),
    [anon_sym_DOT_LBRACK] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_use] = ACTIONS(4054),
    [anon_sym_use_BANG] = ACTIONS(4052),
    [anon_sym_do_BANG] = ACTIONS(4052),
    [anon_sym_begin] = ACTIONS(4054),
    [anon_sym_LPAREN2] = ACTIONS(4054),
    [anon_sym_default] = ACTIONS(4054),
    [anon_sym_or] = ACTIONS(4054),
    [anon_sym_static] = ACTIONS(4054),
    [anon_sym_member] = ACTIONS(4054),
    [anon_sym_interface] = ACTIONS(4054),
    [anon_sym_abstract] = ACTIONS(4054),
    [anon_sym_val] = ACTIONS(4054),
    [anon_sym_override] = ACTIONS(4054),
    [aux_sym_char_token1] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4054),
    [anon_sym_DQUOTE] = ACTIONS(4054),
    [anon_sym_AT_DQUOTE] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [sym_bool] = ACTIONS(4054),
    [sym_unit] = ACTIONS(4052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4054),
    [sym_op_identifier] = ACTIONS(4054),
    [anon_sym_PLUS] = ACTIONS(4054),
    [anon_sym_DASH] = ACTIONS(4054),
    [anon_sym_PLUS_DOT] = ACTIONS(4054),
    [anon_sym_DASH_DOT] = ACTIONS(4054),
    [anon_sym_PERCENT] = ACTIONS(4054),
    [anon_sym_AMP_AMP] = ACTIONS(4054),
    [anon_sym_TILDE] = ACTIONS(4052),
    [aux_sym_prefix_op_token1] = ACTIONS(4054),
    [aux_sym_infix_op_token1] = ACTIONS(4052),
    [aux_sym_infix_op_token2] = ACTIONS(4054),
    [anon_sym_PIPE_PIPE] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4054),
    [anon_sym_COLON_EQ] = ACTIONS(4052),
    [anon_sym_DOLLAR] = ACTIONS(4054),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4054),
    [sym_int] = ACTIONS(4054),
    [sym_xint] = ACTIONS(4052),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4052),
    [anon_sym_POUNDendif] = ACTIONS(4052),
    [anon_sym_POUNDelse] = ACTIONS(4052),
    [sym__newline] = ACTIONS(4052),
  },
  [1836] = {
    [sym_block_comment] = STATE(1836),
    [sym_compiler_directive_decl] = STATE(1836),
    [sym_fsi_directive_decl] = STATE(1836),
    [sym_preproc_line] = STATE(1836),
    [sym_identifier] = ACTIONS(4018),
    [anon_sym_EQ] = ACTIONS(4016),
    [anon_sym_LBRACK_LT] = ACTIONS(4016),
    [anon_sym_COLON] = ACTIONS(4018),
    [anon_sym_return] = ACTIONS(4018),
    [anon_sym_do] = ACTIONS(4018),
    [anon_sym_and] = ACTIONS(4018),
    [anon_sym_let] = ACTIONS(4018),
    [anon_sym_let_BANG] = ACTIONS(4016),
    [aux_sym_access_modifier_token1] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(4018),
    [anon_sym_COMMA] = ACTIONS(4016),
    [anon_sym_null] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_COLON] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4018),
    [anon_sym_LBRACK] = ACTIONS(4018),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4016),
    [anon_sym_LBRACE] = ACTIONS(4018),
    [anon_sym_LT_AT] = ACTIONS(4018),
    [anon_sym_LT_AT_AT] = ACTIONS(4018),
    [anon_sym_DOT] = ACTIONS(4018),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4016),
    [anon_sym_new] = ACTIONS(4018),
    [anon_sym_with] = ACTIONS(4018),
    [anon_sym_return_BANG] = ACTIONS(4016),
    [anon_sym_yield] = ACTIONS(4018),
    [anon_sym_yield_BANG] = ACTIONS(4016),
    [anon_sym_lazy] = ACTIONS(4018),
    [anon_sym_assert] = ACTIONS(4018),
    [anon_sym_upcast] = ACTIONS(4018),
    [anon_sym_downcast] = ACTIONS(4018),
    [anon_sym_COLON_GT] = ACTIONS(4016),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4016),
    [anon_sym_for] = ACTIONS(4018),
    [anon_sym_while] = ACTIONS(4018),
    [anon_sym_if] = ACTIONS(4018),
    [anon_sym_fun] = ACTIONS(4018),
    [anon_sym_try] = ACTIONS(4018),
    [anon_sym_match] = ACTIONS(4018),
    [anon_sym_match_BANG] = ACTIONS(4016),
    [anon_sym_function] = ACTIONS(4018),
    [anon_sym_LT_DASH] = ACTIONS(4018),
    [anon_sym_DOT_LBRACK] = ACTIONS(4016),
    [anon_sym_LT] = ACTIONS(4016),
    [anon_sym_use] = ACTIONS(4018),
    [anon_sym_use_BANG] = ACTIONS(4016),
    [anon_sym_do_BANG] = ACTIONS(4016),
    [anon_sym_begin] = ACTIONS(4018),
    [anon_sym_LPAREN2] = ACTIONS(4018),
    [anon_sym_default] = ACTIONS(4018),
    [anon_sym_or] = ACTIONS(4018),
    [anon_sym_static] = ACTIONS(4018),
    [anon_sym_member] = ACTIONS(4018),
    [anon_sym_interface] = ACTIONS(4018),
    [anon_sym_abstract] = ACTIONS(4018),
    [anon_sym_val] = ACTIONS(4018),
    [anon_sym_override] = ACTIONS(4018),
    [aux_sym_char_token1] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(4018),
    [anon_sym_AT_DQUOTE] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [sym_bool] = ACTIONS(4018),
    [sym_unit] = ACTIONS(4016),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4018),
    [sym_op_identifier] = ACTIONS(4018),
    [anon_sym_PLUS] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_PLUS_DOT] = ACTIONS(4018),
    [anon_sym_DASH_DOT] = ACTIONS(4018),
    [anon_sym_PERCENT] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4016),
    [aux_sym_prefix_op_token1] = ACTIONS(4018),
    [aux_sym_infix_op_token1] = ACTIONS(4016),
    [aux_sym_infix_op_token2] = ACTIONS(4018),
    [anon_sym_PIPE_PIPE] = ACTIONS(4018),
    [anon_sym_BANG_EQ] = ACTIONS(4018),
    [anon_sym_COLON_EQ] = ACTIONS(4016),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4018),
    [sym_int] = ACTIONS(4018),
    [sym_xint] = ACTIONS(4016),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4016),
    [anon_sym_POUNDendif] = ACTIONS(4016),
    [anon_sym_POUNDelse] = ACTIONS(4016),
    [sym__newline] = ACTIONS(4016),
  },
  [1837] = {
    [sym_block_comment] = STATE(1837),
    [sym_compiler_directive_decl] = STATE(1837),
    [sym_fsi_directive_decl] = STATE(1837),
    [sym_preproc_line] = STATE(1837),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3843),
    [anon_sym_LBRACK_LT] = ACTIONS(3843),
    [anon_sym_COLON] = ACTIONS(3845),
    [anon_sym_return] = ACTIONS(3845),
    [anon_sym_do] = ACTIONS(3845),
    [anon_sym_and] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_let_BANG] = ACTIONS(3843),
    [aux_sym_access_modifier_token1] = ACTIONS(3843),
    [anon_sym_LPAREN] = ACTIONS(3845),
    [anon_sym_COMMA] = ACTIONS(3843),
    [anon_sym_null] = ACTIONS(3845),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3843),
    [anon_sym_LBRACE] = ACTIONS(3845),
    [anon_sym_LT_AT] = ACTIONS(3845),
    [anon_sym_LT_AT_AT] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3843),
    [anon_sym_new] = ACTIONS(3845),
    [anon_sym_with] = ACTIONS(3845),
    [anon_sym_return_BANG] = ACTIONS(3843),
    [anon_sym_yield] = ACTIONS(3845),
    [anon_sym_yield_BANG] = ACTIONS(3843),
    [anon_sym_lazy] = ACTIONS(3845),
    [anon_sym_assert] = ACTIONS(3845),
    [anon_sym_upcast] = ACTIONS(3845),
    [anon_sym_downcast] = ACTIONS(3845),
    [anon_sym_COLON_GT] = ACTIONS(3843),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3843),
    [anon_sym_for] = ACTIONS(3845),
    [anon_sym_while] = ACTIONS(3845),
    [anon_sym_if] = ACTIONS(3845),
    [anon_sym_fun] = ACTIONS(3845),
    [anon_sym_try] = ACTIONS(3845),
    [anon_sym_match] = ACTIONS(3845),
    [anon_sym_match_BANG] = ACTIONS(3843),
    [anon_sym_function] = ACTIONS(3845),
    [anon_sym_LT_DASH] = ACTIONS(3845),
    [anon_sym_DOT_LBRACK] = ACTIONS(3843),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_use] = ACTIONS(3845),
    [anon_sym_use_BANG] = ACTIONS(3843),
    [anon_sym_do_BANG] = ACTIONS(3843),
    [anon_sym_begin] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(3845),
    [anon_sym_default] = ACTIONS(3845),
    [anon_sym_or] = ACTIONS(3845),
    [anon_sym_static] = ACTIONS(3845),
    [anon_sym_member] = ACTIONS(3845),
    [anon_sym_interface] = ACTIONS(3845),
    [anon_sym_abstract] = ACTIONS(3845),
    [anon_sym_val] = ACTIONS(3845),
    [anon_sym_override] = ACTIONS(3845),
    [aux_sym_char_token1] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3845),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_AT_DQUOTE] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [sym_bool] = ACTIONS(3845),
    [sym_unit] = ACTIONS(3843),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3845),
    [sym_op_identifier] = ACTIONS(3845),
    [anon_sym_PLUS] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_PLUS_DOT] = ACTIONS(3845),
    [anon_sym_DASH_DOT] = ACTIONS(3845),
    [anon_sym_PERCENT] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3845),
    [anon_sym_TILDE] = ACTIONS(3843),
    [aux_sym_prefix_op_token1] = ACTIONS(3845),
    [aux_sym_infix_op_token1] = ACTIONS(3843),
    [aux_sym_infix_op_token2] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(3845),
    [anon_sym_BANG_EQ] = ACTIONS(3845),
    [anon_sym_COLON_EQ] = ACTIONS(3843),
    [anon_sym_DOLLAR] = ACTIONS(3845),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3845),
    [sym_int] = ACTIONS(3845),
    [sym_xint] = ACTIONS(3843),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3843),
    [anon_sym_POUNDendif] = ACTIONS(3843),
    [anon_sym_POUNDelse] = ACTIONS(3843),
    [sym__newline] = ACTIONS(3843),
  },
  [1838] = {
    [sym_block_comment] = STATE(1838),
    [sym_compiler_directive_decl] = STATE(1838),
    [sym_fsi_directive_decl] = STATE(1838),
    [sym_preproc_line] = STATE(1838),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_EQ] = ACTIONS(4001),
    [anon_sym_LBRACK_LT] = ACTIONS(4001),
    [anon_sym_COLON] = ACTIONS(4003),
    [anon_sym_return] = ACTIONS(4003),
    [anon_sym_do] = ACTIONS(4003),
    [anon_sym_and] = ACTIONS(4003),
    [anon_sym_let] = ACTIONS(4003),
    [anon_sym_let_BANG] = ACTIONS(4001),
    [aux_sym_access_modifier_token1] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4003),
    [anon_sym_COMMA] = ACTIONS(4001),
    [anon_sym_null] = ACTIONS(4003),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_COLON] = ACTIONS(4001),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LBRACK] = ACTIONS(4003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4001),
    [anon_sym_LBRACE] = ACTIONS(4003),
    [anon_sym_LT_AT] = ACTIONS(4003),
    [anon_sym_LT_AT_AT] = ACTIONS(4003),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4001),
    [anon_sym_new] = ACTIONS(4003),
    [anon_sym_with] = ACTIONS(4003),
    [anon_sym_return_BANG] = ACTIONS(4001),
    [anon_sym_yield] = ACTIONS(4003),
    [anon_sym_yield_BANG] = ACTIONS(4001),
    [anon_sym_lazy] = ACTIONS(4003),
    [anon_sym_assert] = ACTIONS(4003),
    [anon_sym_upcast] = ACTIONS(4003),
    [anon_sym_downcast] = ACTIONS(4003),
    [anon_sym_COLON_GT] = ACTIONS(4001),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4001),
    [anon_sym_for] = ACTIONS(4003),
    [anon_sym_while] = ACTIONS(4003),
    [anon_sym_if] = ACTIONS(4003),
    [anon_sym_fun] = ACTIONS(4003),
    [anon_sym_try] = ACTIONS(4003),
    [anon_sym_match] = ACTIONS(4003),
    [anon_sym_match_BANG] = ACTIONS(4001),
    [anon_sym_function] = ACTIONS(4003),
    [anon_sym_LT_DASH] = ACTIONS(4003),
    [anon_sym_DOT_LBRACK] = ACTIONS(4001),
    [anon_sym_LT] = ACTIONS(4001),
    [anon_sym_use] = ACTIONS(4003),
    [anon_sym_use_BANG] = ACTIONS(4001),
    [anon_sym_do_BANG] = ACTIONS(4001),
    [anon_sym_begin] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4003),
    [anon_sym_default] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [anon_sym_static] = ACTIONS(4003),
    [anon_sym_member] = ACTIONS(4003),
    [anon_sym_interface] = ACTIONS(4003),
    [anon_sym_abstract] = ACTIONS(4003),
    [anon_sym_val] = ACTIONS(4003),
    [anon_sym_override] = ACTIONS(4003),
    [aux_sym_char_token1] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4003),
    [anon_sym_DQUOTE] = ACTIONS(4003),
    [anon_sym_AT_DQUOTE] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [sym_bool] = ACTIONS(4003),
    [sym_unit] = ACTIONS(4001),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4003),
    [sym_op_identifier] = ACTIONS(4003),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_PLUS_DOT] = ACTIONS(4003),
    [anon_sym_DASH_DOT] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4003),
    [anon_sym_TILDE] = ACTIONS(4001),
    [aux_sym_prefix_op_token1] = ACTIONS(4003),
    [aux_sym_infix_op_token1] = ACTIONS(4001),
    [aux_sym_infix_op_token2] = ACTIONS(4003),
    [anon_sym_PIPE_PIPE] = ACTIONS(4003),
    [anon_sym_BANG_EQ] = ACTIONS(4003),
    [anon_sym_COLON_EQ] = ACTIONS(4001),
    [anon_sym_DOLLAR] = ACTIONS(4003),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4003),
    [sym_int] = ACTIONS(4003),
    [sym_xint] = ACTIONS(4001),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4001),
    [anon_sym_POUNDendif] = ACTIONS(4001),
    [anon_sym_POUNDelse] = ACTIONS(4001),
    [sym__newline] = ACTIONS(4001),
  },
  [1839] = {
    [sym_block_comment] = STATE(1839),
    [sym_compiler_directive_decl] = STATE(1839),
    [sym_fsi_directive_decl] = STATE(1839),
    [sym_preproc_line] = STATE(1839),
    [sym_identifier] = ACTIONS(3800),
    [anon_sym_EQ] = ACTIONS(3798),
    [anon_sym_LBRACK_LT] = ACTIONS(3798),
    [anon_sym_COLON] = ACTIONS(3800),
    [anon_sym_return] = ACTIONS(3800),
    [anon_sym_do] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_let_BANG] = ACTIONS(3798),
    [aux_sym_access_modifier_token1] = ACTIONS(3798),
    [anon_sym_LPAREN] = ACTIONS(3800),
    [anon_sym_COMMA] = ACTIONS(3798),
    [anon_sym_null] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_COLON] = ACTIONS(3798),
    [anon_sym_PIPE] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3800),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3798),
    [anon_sym_LBRACE] = ACTIONS(3800),
    [anon_sym_LT_AT] = ACTIONS(3800),
    [anon_sym_LT_AT_AT] = ACTIONS(3800),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3798),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_with] = ACTIONS(3800),
    [anon_sym_return_BANG] = ACTIONS(3798),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_yield_BANG] = ACTIONS(3798),
    [anon_sym_lazy] = ACTIONS(3800),
    [anon_sym_assert] = ACTIONS(3800),
    [anon_sym_upcast] = ACTIONS(3800),
    [anon_sym_downcast] = ACTIONS(3800),
    [anon_sym_COLON_GT] = ACTIONS(3798),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3798),
    [anon_sym_for] = ACTIONS(3800),
    [anon_sym_while] = ACTIONS(3800),
    [anon_sym_if] = ACTIONS(3800),
    [anon_sym_fun] = ACTIONS(3800),
    [anon_sym_try] = ACTIONS(3800),
    [anon_sym_match] = ACTIONS(3800),
    [anon_sym_match_BANG] = ACTIONS(3798),
    [anon_sym_function] = ACTIONS(3800),
    [anon_sym_LT_DASH] = ACTIONS(3800),
    [anon_sym_DOT_LBRACK] = ACTIONS(3798),
    [anon_sym_LT] = ACTIONS(3798),
    [anon_sym_use] = ACTIONS(3800),
    [anon_sym_use_BANG] = ACTIONS(3798),
    [anon_sym_do_BANG] = ACTIONS(3798),
    [anon_sym_begin] = ACTIONS(3800),
    [anon_sym_LPAREN2] = ACTIONS(3800),
    [anon_sym_DOT_DOT2] = ACTIONS(3798),
    [anon_sym_default] = ACTIONS(3800),
    [anon_sym_or] = ACTIONS(3800),
    [anon_sym_static] = ACTIONS(3800),
    [anon_sym_member] = ACTIONS(3800),
    [anon_sym_interface] = ACTIONS(3800),
    [anon_sym_abstract] = ACTIONS(3800),
    [anon_sym_val] = ACTIONS(3800),
    [anon_sym_override] = ACTIONS(3800),
    [aux_sym_char_token1] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3800),
    [anon_sym_DQUOTE] = ACTIONS(3800),
    [anon_sym_AT_DQUOTE] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [sym_bool] = ACTIONS(3800),
    [sym_unit] = ACTIONS(3798),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3800),
    [sym_op_identifier] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS_DOT] = ACTIONS(3800),
    [anon_sym_DASH_DOT] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3800),
    [anon_sym_AMP_AMP] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3798),
    [aux_sym_prefix_op_token1] = ACTIONS(3800),
    [aux_sym_infix_op_token1] = ACTIONS(3798),
    [aux_sym_infix_op_token2] = ACTIONS(3800),
    [anon_sym_PIPE_PIPE] = ACTIONS(3800),
    [anon_sym_BANG_EQ] = ACTIONS(3800),
    [anon_sym_COLON_EQ] = ACTIONS(3798),
    [anon_sym_DOLLAR] = ACTIONS(3800),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3800),
    [sym_int] = ACTIONS(3800),
    [sym_xint] = ACTIONS(3798),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3798),
    [sym__newline] = ACTIONS(3798),
    [sym__dedent] = ACTIONS(3798),
  },
  [1840] = {
    [sym_block_comment] = STATE(1840),
    [sym_compiler_directive_decl] = STATE(1840),
    [sym_fsi_directive_decl] = STATE(1840),
    [sym_preproc_line] = STATE(1840),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_LBRACK_LT] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [aux_sym_access_modifier_token1] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_with] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_DOT_DOT2] = ACTIONS(3741),
    [anon_sym_default] = ACTIONS(3743),
    [anon_sym_or] = ACTIONS(3743),
    [anon_sym_static] = ACTIONS(3743),
    [anon_sym_member] = ACTIONS(3743),
    [anon_sym_interface] = ACTIONS(3743),
    [anon_sym_abstract] = ACTIONS(3743),
    [anon_sym_val] = ACTIONS(3743),
    [anon_sym_override] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [sym__newline] = ACTIONS(3741),
    [sym__dedent] = ACTIONS(3741),
  },
  [1841] = {
    [sym_block_comment] = STATE(1841),
    [sym_compiler_directive_decl] = STATE(1841),
    [sym_fsi_directive_decl] = STATE(1841),
    [sym_preproc_line] = STATE(1841),
    [sym_identifier] = ACTIONS(3996),
    [anon_sym_EQ] = ACTIONS(3994),
    [anon_sym_LBRACK_LT] = ACTIONS(3994),
    [anon_sym_COLON] = ACTIONS(3996),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_do] = ACTIONS(3996),
    [anon_sym_and] = ACTIONS(3996),
    [anon_sym_let] = ACTIONS(3996),
    [anon_sym_let_BANG] = ACTIONS(3994),
    [aux_sym_access_modifier_token1] = ACTIONS(3994),
    [anon_sym_LPAREN] = ACTIONS(3996),
    [anon_sym_COMMA] = ACTIONS(3994),
    [anon_sym_null] = ACTIONS(3996),
    [anon_sym_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_COLON] = ACTIONS(3994),
    [anon_sym_AMP] = ACTIONS(3996),
    [anon_sym_LBRACK] = ACTIONS(3996),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3994),
    [anon_sym_LBRACE] = ACTIONS(3996),
    [anon_sym_LT_AT] = ACTIONS(3996),
    [anon_sym_LT_AT_AT] = ACTIONS(3996),
    [anon_sym_DOT] = ACTIONS(3996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3994),
    [anon_sym_new] = ACTIONS(3996),
    [anon_sym_with] = ACTIONS(3996),
    [anon_sym_return_BANG] = ACTIONS(3994),
    [anon_sym_yield] = ACTIONS(3996),
    [anon_sym_yield_BANG] = ACTIONS(3994),
    [anon_sym_lazy] = ACTIONS(3996),
    [anon_sym_assert] = ACTIONS(3996),
    [anon_sym_upcast] = ACTIONS(3996),
    [anon_sym_downcast] = ACTIONS(3996),
    [anon_sym_COLON_GT] = ACTIONS(3994),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3994),
    [anon_sym_for] = ACTIONS(3996),
    [anon_sym_while] = ACTIONS(3996),
    [anon_sym_if] = ACTIONS(3996),
    [anon_sym_fun] = ACTIONS(3996),
    [anon_sym_try] = ACTIONS(3996),
    [anon_sym_match] = ACTIONS(3996),
    [anon_sym_match_BANG] = ACTIONS(3994),
    [anon_sym_function] = ACTIONS(3996),
    [anon_sym_LT_DASH] = ACTIONS(3996),
    [anon_sym_DOT_LBRACK] = ACTIONS(3994),
    [anon_sym_LT] = ACTIONS(3994),
    [anon_sym_use] = ACTIONS(3996),
    [anon_sym_use_BANG] = ACTIONS(3994),
    [anon_sym_do_BANG] = ACTIONS(3994),
    [anon_sym_begin] = ACTIONS(3996),
    [anon_sym_LPAREN2] = ACTIONS(3996),
    [anon_sym_default] = ACTIONS(3996),
    [anon_sym_or] = ACTIONS(3996),
    [anon_sym_static] = ACTIONS(3996),
    [anon_sym_member] = ACTIONS(3996),
    [anon_sym_interface] = ACTIONS(3996),
    [anon_sym_abstract] = ACTIONS(3996),
    [anon_sym_val] = ACTIONS(3996),
    [anon_sym_override] = ACTIONS(3996),
    [aux_sym_char_token1] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3996),
    [anon_sym_DQUOTE] = ACTIONS(3996),
    [anon_sym_AT_DQUOTE] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [sym_bool] = ACTIONS(3996),
    [sym_unit] = ACTIONS(3994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3996),
    [sym_op_identifier] = ACTIONS(3996),
    [anon_sym_PLUS] = ACTIONS(3996),
    [anon_sym_DASH] = ACTIONS(3996),
    [anon_sym_PLUS_DOT] = ACTIONS(3996),
    [anon_sym_DASH_DOT] = ACTIONS(3996),
    [anon_sym_PERCENT] = ACTIONS(3996),
    [anon_sym_AMP_AMP] = ACTIONS(3996),
    [anon_sym_TILDE] = ACTIONS(3994),
    [aux_sym_prefix_op_token1] = ACTIONS(3996),
    [aux_sym_infix_op_token1] = ACTIONS(3994),
    [aux_sym_infix_op_token2] = ACTIONS(3996),
    [anon_sym_PIPE_PIPE] = ACTIONS(3996),
    [anon_sym_BANG_EQ] = ACTIONS(3996),
    [anon_sym_COLON_EQ] = ACTIONS(3994),
    [anon_sym_DOLLAR] = ACTIONS(3996),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3996),
    [sym_int] = ACTIONS(3996),
    [sym_xint] = ACTIONS(3994),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3994),
    [anon_sym_POUNDendif] = ACTIONS(3994),
    [anon_sym_POUNDelse] = ACTIONS(3994),
    [sym__newline] = ACTIONS(3994),
  },
  [1842] = {
    [sym_block_comment] = STATE(1842),
    [sym_compiler_directive_decl] = STATE(1842),
    [sym_fsi_directive_decl] = STATE(1842),
    [sym_preproc_line] = STATE(1842),
    [sym_identifier] = ACTIONS(3813),
    [anon_sym_EQ] = ACTIONS(3811),
    [anon_sym_LBRACK_LT] = ACTIONS(3811),
    [anon_sym_COLON] = ACTIONS(3813),
    [anon_sym_return] = ACTIONS(3813),
    [anon_sym_do] = ACTIONS(3813),
    [anon_sym_and] = ACTIONS(3813),
    [anon_sym_let] = ACTIONS(3813),
    [anon_sym_let_BANG] = ACTIONS(3811),
    [aux_sym_access_modifier_token1] = ACTIONS(3811),
    [anon_sym_LPAREN] = ACTIONS(3813),
    [anon_sym_COMMA] = ACTIONS(3811),
    [anon_sym_null] = ACTIONS(3813),
    [anon_sym_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_COLON] = ACTIONS(3811),
    [anon_sym_AMP] = ACTIONS(3813),
    [anon_sym_LBRACK] = ACTIONS(3813),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3811),
    [anon_sym_LBRACE] = ACTIONS(3813),
    [anon_sym_LT_AT] = ACTIONS(3813),
    [anon_sym_LT_AT_AT] = ACTIONS(3813),
    [anon_sym_DOT] = ACTIONS(3813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3811),
    [anon_sym_new] = ACTIONS(3813),
    [anon_sym_with] = ACTIONS(3813),
    [anon_sym_return_BANG] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_yield_BANG] = ACTIONS(3811),
    [anon_sym_lazy] = ACTIONS(3813),
    [anon_sym_assert] = ACTIONS(3813),
    [anon_sym_upcast] = ACTIONS(3813),
    [anon_sym_downcast] = ACTIONS(3813),
    [anon_sym_COLON_GT] = ACTIONS(3811),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3811),
    [anon_sym_for] = ACTIONS(3813),
    [anon_sym_done] = ACTIONS(4712),
    [anon_sym_while] = ACTIONS(3813),
    [anon_sym_if] = ACTIONS(3813),
    [anon_sym_fun] = ACTIONS(3813),
    [anon_sym_try] = ACTIONS(3813),
    [anon_sym_match] = ACTIONS(3813),
    [anon_sym_match_BANG] = ACTIONS(3811),
    [anon_sym_function] = ACTIONS(3813),
    [anon_sym_LT_DASH] = ACTIONS(3813),
    [anon_sym_DOT_LBRACK] = ACTIONS(3811),
    [anon_sym_LT] = ACTIONS(3811),
    [anon_sym_use] = ACTIONS(3813),
    [anon_sym_use_BANG] = ACTIONS(3811),
    [anon_sym_do_BANG] = ACTIONS(3811),
    [anon_sym_begin] = ACTIONS(3813),
    [anon_sym_LPAREN2] = ACTIONS(3813),
    [anon_sym_default] = ACTIONS(3813),
    [anon_sym_or] = ACTIONS(3813),
    [anon_sym_static] = ACTIONS(3813),
    [anon_sym_member] = ACTIONS(3813),
    [anon_sym_interface] = ACTIONS(3813),
    [anon_sym_abstract] = ACTIONS(3813),
    [anon_sym_val] = ACTIONS(3813),
    [anon_sym_override] = ACTIONS(3813),
    [aux_sym_char_token1] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3813),
    [anon_sym_DQUOTE] = ACTIONS(3813),
    [anon_sym_AT_DQUOTE] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [sym_bool] = ACTIONS(3813),
    [sym_unit] = ACTIONS(3811),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3813),
    [sym_op_identifier] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PLUS_DOT] = ACTIONS(3813),
    [anon_sym_DASH_DOT] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3813),
    [anon_sym_AMP_AMP] = ACTIONS(3813),
    [anon_sym_TILDE] = ACTIONS(3811),
    [aux_sym_prefix_op_token1] = ACTIONS(3813),
    [aux_sym_infix_op_token1] = ACTIONS(3811),
    [aux_sym_infix_op_token2] = ACTIONS(3813),
    [anon_sym_PIPE_PIPE] = ACTIONS(3813),
    [anon_sym_BANG_EQ] = ACTIONS(3813),
    [anon_sym_COLON_EQ] = ACTIONS(3811),
    [anon_sym_DOLLAR] = ACTIONS(3813),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3813),
    [sym_int] = ACTIONS(3813),
    [sym_xint] = ACTIONS(3811),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3811),
    [anon_sym_POUNDendif] = ACTIONS(3811),
    [sym__newline] = ACTIONS(3811),
  },
  [1843] = {
    [sym_block_comment] = STATE(1843),
    [sym_compiler_directive_decl] = STATE(1843),
    [sym_fsi_directive_decl] = STATE(1843),
    [sym_preproc_line] = STATE(1843),
    [sym_identifier] = ACTIONS(4104),
    [anon_sym_EQ] = ACTIONS(4102),
    [anon_sym_LBRACK_LT] = ACTIONS(4102),
    [anon_sym_COLON] = ACTIONS(4104),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_do] = ACTIONS(4104),
    [anon_sym_let] = ACTIONS(4104),
    [anon_sym_let_BANG] = ACTIONS(4102),
    [aux_sym_access_modifier_token1] = ACTIONS(4102),
    [anon_sym_LPAREN] = ACTIONS(4104),
    [anon_sym_COMMA] = ACTIONS(4102),
    [anon_sym_null] = ACTIONS(4104),
    [anon_sym_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_COLON] = ACTIONS(4102),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4104),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4102),
    [anon_sym_LBRACE] = ACTIONS(4104),
    [anon_sym_LT_AT] = ACTIONS(4104),
    [anon_sym_LT_AT_AT] = ACTIONS(4104),
    [anon_sym_DOT] = ACTIONS(4104),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4102),
    [anon_sym_new] = ACTIONS(4104),
    [anon_sym_with] = ACTIONS(4104),
    [anon_sym_return_BANG] = ACTIONS(4102),
    [anon_sym_yield] = ACTIONS(4104),
    [anon_sym_yield_BANG] = ACTIONS(4102),
    [anon_sym_lazy] = ACTIONS(4104),
    [anon_sym_assert] = ACTIONS(4104),
    [anon_sym_upcast] = ACTIONS(4104),
    [anon_sym_downcast] = ACTIONS(4104),
    [anon_sym_COLON_GT] = ACTIONS(4102),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4102),
    [anon_sym_for] = ACTIONS(4104),
    [anon_sym_while] = ACTIONS(4104),
    [anon_sym_if] = ACTIONS(4104),
    [anon_sym_fun] = ACTIONS(4104),
    [anon_sym_try] = ACTIONS(4104),
    [anon_sym_match] = ACTIONS(4104),
    [anon_sym_match_BANG] = ACTIONS(4102),
    [anon_sym_function] = ACTIONS(4104),
    [anon_sym_LT_DASH] = ACTIONS(4104),
    [anon_sym_DOT_LBRACK] = ACTIONS(4102),
    [anon_sym_LT] = ACTIONS(4102),
    [anon_sym_use] = ACTIONS(4104),
    [anon_sym_use_BANG] = ACTIONS(4102),
    [anon_sym_do_BANG] = ACTIONS(4102),
    [anon_sym_begin] = ACTIONS(4104),
    [anon_sym_LPAREN2] = ACTIONS(4104),
    [anon_sym_default] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [anon_sym_static] = ACTIONS(4104),
    [anon_sym_member] = ACTIONS(4104),
    [anon_sym_interface] = ACTIONS(4104),
    [anon_sym_abstract] = ACTIONS(4104),
    [anon_sym_val] = ACTIONS(4104),
    [anon_sym_override] = ACTIONS(4104),
    [anon_sym_inherit] = ACTIONS(4104),
    [aux_sym_char_token1] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4104),
    [anon_sym_DQUOTE] = ACTIONS(4104),
    [anon_sym_AT_DQUOTE] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [sym_bool] = ACTIONS(4104),
    [sym_unit] = ACTIONS(4102),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4104),
    [sym_op_identifier] = ACTIONS(4104),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_PLUS_DOT] = ACTIONS(4104),
    [anon_sym_DASH_DOT] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_AMP_AMP] = ACTIONS(4104),
    [anon_sym_TILDE] = ACTIONS(4102),
    [aux_sym_prefix_op_token1] = ACTIONS(4104),
    [aux_sym_infix_op_token1] = ACTIONS(4102),
    [aux_sym_infix_op_token2] = ACTIONS(4104),
    [anon_sym_PIPE_PIPE] = ACTIONS(4104),
    [anon_sym_BANG_EQ] = ACTIONS(4104),
    [anon_sym_COLON_EQ] = ACTIONS(4102),
    [anon_sym_DOLLAR] = ACTIONS(4104),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4104),
    [sym_int] = ACTIONS(4104),
    [sym_xint] = ACTIONS(4102),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4102),
    [anon_sym_POUNDendif] = ACTIONS(4102),
    [anon_sym_POUNDelse] = ACTIONS(4102),
    [sym__newline] = ACTIONS(4102),
  },
  [1844] = {
    [sym_block_comment] = STATE(1844),
    [sym_compiler_directive_decl] = STATE(1844),
    [sym_fsi_directive_decl] = STATE(1844),
    [sym_preproc_line] = STATE(1844),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [aux_sym_access_modifier_token1] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_member] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_val] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [anon_sym_inherit] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [anon_sym_POUNDendif] = ACTIONS(3191),
    [anon_sym_POUNDelse] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1845] = {
    [sym_block_comment] = STATE(1845),
    [sym_compiler_directive_decl] = STATE(1845),
    [sym_fsi_directive_decl] = STATE(1845),
    [sym_preproc_line] = STATE(1845),
    [sym_identifier] = ACTIONS(3927),
    [anon_sym_EQ] = ACTIONS(3925),
    [anon_sym_LBRACK_LT] = ACTIONS(3925),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_return] = ACTIONS(3927),
    [anon_sym_do] = ACTIONS(3927),
    [anon_sym_let] = ACTIONS(3927),
    [anon_sym_let_BANG] = ACTIONS(3925),
    [aux_sym_access_modifier_token1] = ACTIONS(3925),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_COMMA] = ACTIONS(3925),
    [anon_sym_null] = ACTIONS(3927),
    [anon_sym_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_COLON] = ACTIONS(3925),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3925),
    [anon_sym_LBRACE] = ACTIONS(3927),
    [anon_sym_LT_AT] = ACTIONS(3927),
    [anon_sym_LT_AT_AT] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3925),
    [anon_sym_new] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3927),
    [anon_sym_return_BANG] = ACTIONS(3925),
    [anon_sym_yield] = ACTIONS(3927),
    [anon_sym_yield_BANG] = ACTIONS(3925),
    [anon_sym_lazy] = ACTIONS(3927),
    [anon_sym_assert] = ACTIONS(3927),
    [anon_sym_upcast] = ACTIONS(3927),
    [anon_sym_downcast] = ACTIONS(3927),
    [anon_sym_COLON_GT] = ACTIONS(3925),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3925),
    [anon_sym_for] = ACTIONS(3927),
    [anon_sym_while] = ACTIONS(3927),
    [anon_sym_if] = ACTIONS(3927),
    [anon_sym_fun] = ACTIONS(3927),
    [anon_sym_try] = ACTIONS(3927),
    [anon_sym_match] = ACTIONS(3927),
    [anon_sym_match_BANG] = ACTIONS(3925),
    [anon_sym_function] = ACTIONS(3927),
    [anon_sym_LT_DASH] = ACTIONS(3927),
    [anon_sym_DOT_LBRACK] = ACTIONS(3925),
    [anon_sym_LT] = ACTIONS(3925),
    [anon_sym_use] = ACTIONS(3927),
    [anon_sym_use_BANG] = ACTIONS(3925),
    [anon_sym_do_BANG] = ACTIONS(3925),
    [anon_sym_begin] = ACTIONS(3927),
    [anon_sym_LPAREN2] = ACTIONS(3927),
    [anon_sym_default] = ACTIONS(3927),
    [anon_sym_or] = ACTIONS(3927),
    [anon_sym_static] = ACTIONS(3927),
    [anon_sym_member] = ACTIONS(3927),
    [anon_sym_interface] = ACTIONS(3927),
    [anon_sym_abstract] = ACTIONS(3927),
    [anon_sym_val] = ACTIONS(3927),
    [anon_sym_override] = ACTIONS(3927),
    [anon_sym_inherit] = ACTIONS(3927),
    [aux_sym_char_token1] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_AT_DQUOTE] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [sym_bool] = ACTIONS(3927),
    [sym_unit] = ACTIONS(3925),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3927),
    [sym_op_identifier] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3927),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_PLUS_DOT] = ACTIONS(3927),
    [anon_sym_DASH_DOT] = ACTIONS(3927),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_TILDE] = ACTIONS(3925),
    [aux_sym_prefix_op_token1] = ACTIONS(3927),
    [aux_sym_infix_op_token1] = ACTIONS(3925),
    [aux_sym_infix_op_token2] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_COLON_EQ] = ACTIONS(3925),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3927),
    [sym_int] = ACTIONS(3927),
    [sym_xint] = ACTIONS(3925),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3925),
    [anon_sym_POUNDendif] = ACTIONS(3925),
    [anon_sym_POUNDelse] = ACTIONS(3925),
    [sym__newline] = ACTIONS(3925),
  },
  [1846] = {
    [sym_block_comment] = STATE(1846),
    [sym_compiler_directive_decl] = STATE(1846),
    [sym_fsi_directive_decl] = STATE(1846),
    [sym_preproc_line] = STATE(1846),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_AT_AT_GT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(4410),
    [anon_sym_uy] = ACTIONS(4412),
    [anon_sym_s] = ACTIONS(4414),
    [anon_sym_us] = ACTIONS(4416),
    [anon_sym_l] = ACTIONS(4418),
    [aux_sym_uint32_token1] = ACTIONS(4420),
    [anon_sym_n] = ACTIONS(4422),
    [anon_sym_un] = ACTIONS(4424),
    [anon_sym_L] = ACTIONS(4426),
    [aux_sym_uint64_token1] = ACTIONS(4428),
    [anon_sym_lf] = ACTIONS(4714),
    [anon_sym_LF] = ACTIONS(4716),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1847] = {
    [sym_block_comment] = STATE(1847),
    [sym_compiler_directive_decl] = STATE(1847),
    [sym_fsi_directive_decl] = STATE(1847),
    [sym_preproc_line] = STATE(1847),
    [sym_identifier] = ACTIONS(3946),
    [anon_sym_EQ] = ACTIONS(3944),
    [anon_sym_LBRACK_LT] = ACTIONS(3944),
    [anon_sym_COLON] = ACTIONS(3946),
    [anon_sym_return] = ACTIONS(3946),
    [anon_sym_do] = ACTIONS(3946),
    [anon_sym_let] = ACTIONS(3946),
    [anon_sym_let_BANG] = ACTIONS(3944),
    [aux_sym_access_modifier_token1] = ACTIONS(3944),
    [anon_sym_LPAREN] = ACTIONS(3946),
    [anon_sym_COMMA] = ACTIONS(3944),
    [anon_sym_null] = ACTIONS(3946),
    [anon_sym_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LBRACK] = ACTIONS(3946),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3944),
    [anon_sym_LBRACE] = ACTIONS(3946),
    [anon_sym_LT_AT] = ACTIONS(3946),
    [anon_sym_LT_AT_AT] = ACTIONS(3946),
    [anon_sym_DOT] = ACTIONS(3946),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3944),
    [anon_sym_new] = ACTIONS(3946),
    [anon_sym_with] = ACTIONS(3946),
    [anon_sym_return_BANG] = ACTIONS(3944),
    [anon_sym_yield] = ACTIONS(3946),
    [anon_sym_yield_BANG] = ACTIONS(3944),
    [anon_sym_lazy] = ACTIONS(3946),
    [anon_sym_assert] = ACTIONS(3946),
    [anon_sym_upcast] = ACTIONS(3946),
    [anon_sym_downcast] = ACTIONS(3946),
    [anon_sym_COLON_GT] = ACTIONS(3944),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3944),
    [anon_sym_for] = ACTIONS(3946),
    [anon_sym_while] = ACTIONS(3946),
    [anon_sym_if] = ACTIONS(3946),
    [anon_sym_fun] = ACTIONS(3946),
    [anon_sym_try] = ACTIONS(3946),
    [anon_sym_match] = ACTIONS(3946),
    [anon_sym_match_BANG] = ACTIONS(3944),
    [anon_sym_function] = ACTIONS(3946),
    [anon_sym_LT_DASH] = ACTIONS(3946),
    [anon_sym_DOT_LBRACK] = ACTIONS(3944),
    [anon_sym_LT] = ACTIONS(3944),
    [anon_sym_use] = ACTIONS(3946),
    [anon_sym_use_BANG] = ACTIONS(3944),
    [anon_sym_do_BANG] = ACTIONS(3944),
    [anon_sym_begin] = ACTIONS(3946),
    [anon_sym_LPAREN2] = ACTIONS(3946),
    [anon_sym_default] = ACTIONS(3946),
    [anon_sym_or] = ACTIONS(3946),
    [anon_sym_static] = ACTIONS(3946),
    [anon_sym_member] = ACTIONS(3946),
    [anon_sym_interface] = ACTIONS(3946),
    [anon_sym_abstract] = ACTIONS(3946),
    [anon_sym_val] = ACTIONS(3946),
    [anon_sym_override] = ACTIONS(3946),
    [anon_sym_inherit] = ACTIONS(3946),
    [aux_sym_char_token1] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_AT_DQUOTE] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [sym_bool] = ACTIONS(3946),
    [sym_unit] = ACTIONS(3944),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3946),
    [sym_op_identifier] = ACTIONS(3946),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PLUS_DOT] = ACTIONS(3946),
    [anon_sym_DASH_DOT] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3946),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_TILDE] = ACTIONS(3944),
    [aux_sym_prefix_op_token1] = ACTIONS(3946),
    [aux_sym_infix_op_token1] = ACTIONS(3944),
    [aux_sym_infix_op_token2] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [anon_sym_BANG_EQ] = ACTIONS(3946),
    [anon_sym_COLON_EQ] = ACTIONS(3944),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3946),
    [sym_int] = ACTIONS(3946),
    [sym_xint] = ACTIONS(3944),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3944),
    [anon_sym_POUNDendif] = ACTIONS(3944),
    [anon_sym_POUNDelse] = ACTIONS(3944),
    [sym__newline] = ACTIONS(3944),
  },
  [1848] = {
    [sym_block_comment] = STATE(1848),
    [sym_compiler_directive_decl] = STATE(1848),
    [sym_fsi_directive_decl] = STATE(1848),
    [sym_preproc_line] = STATE(1848),
    [sym_identifier] = ACTIONS(4170),
    [anon_sym_EQ] = ACTIONS(4168),
    [anon_sym_LBRACK_LT] = ACTIONS(4168),
    [anon_sym_COLON] = ACTIONS(4170),
    [anon_sym_return] = ACTIONS(4170),
    [anon_sym_do] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_let_BANG] = ACTIONS(4168),
    [aux_sym_access_modifier_token1] = ACTIONS(4168),
    [anon_sym_LPAREN] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4168),
    [anon_sym_null] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_COLON] = ACTIONS(4168),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4170),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4168),
    [anon_sym_LBRACE] = ACTIONS(4170),
    [anon_sym_LT_AT] = ACTIONS(4170),
    [anon_sym_LT_AT_AT] = ACTIONS(4170),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4168),
    [anon_sym_new] = ACTIONS(4170),
    [anon_sym_with] = ACTIONS(4170),
    [anon_sym_return_BANG] = ACTIONS(4168),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_yield_BANG] = ACTIONS(4168),
    [anon_sym_lazy] = ACTIONS(4170),
    [anon_sym_assert] = ACTIONS(4170),
    [anon_sym_upcast] = ACTIONS(4170),
    [anon_sym_downcast] = ACTIONS(4170),
    [anon_sym_COLON_GT] = ACTIONS(4168),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4168),
    [anon_sym_for] = ACTIONS(4170),
    [anon_sym_while] = ACTIONS(4170),
    [anon_sym_if] = ACTIONS(4170),
    [anon_sym_fun] = ACTIONS(4170),
    [anon_sym_try] = ACTIONS(4170),
    [anon_sym_match] = ACTIONS(4170),
    [anon_sym_match_BANG] = ACTIONS(4168),
    [anon_sym_function] = ACTIONS(4170),
    [anon_sym_LT_DASH] = ACTIONS(4170),
    [anon_sym_DOT_LBRACK] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4168),
    [anon_sym_use] = ACTIONS(4170),
    [anon_sym_use_BANG] = ACTIONS(4168),
    [anon_sym_do_BANG] = ACTIONS(4168),
    [anon_sym_begin] = ACTIONS(4170),
    [anon_sym_LPAREN2] = ACTIONS(4170),
    [anon_sym_default] = ACTIONS(4170),
    [anon_sym_or] = ACTIONS(4170),
    [anon_sym_static] = ACTIONS(4170),
    [anon_sym_member] = ACTIONS(4170),
    [anon_sym_interface] = ACTIONS(4170),
    [anon_sym_abstract] = ACTIONS(4170),
    [anon_sym_val] = ACTIONS(4170),
    [anon_sym_override] = ACTIONS(4170),
    [anon_sym_inherit] = ACTIONS(4170),
    [aux_sym_char_token1] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4170),
    [anon_sym_DQUOTE] = ACTIONS(4170),
    [anon_sym_AT_DQUOTE] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [sym_bool] = ACTIONS(4170),
    [sym_unit] = ACTIONS(4168),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4170),
    [sym_op_identifier] = ACTIONS(4170),
    [anon_sym_PLUS] = ACTIONS(4170),
    [anon_sym_DASH] = ACTIONS(4170),
    [anon_sym_PLUS_DOT] = ACTIONS(4170),
    [anon_sym_DASH_DOT] = ACTIONS(4170),
    [anon_sym_PERCENT] = ACTIONS(4170),
    [anon_sym_AMP_AMP] = ACTIONS(4170),
    [anon_sym_TILDE] = ACTIONS(4168),
    [aux_sym_prefix_op_token1] = ACTIONS(4170),
    [aux_sym_infix_op_token1] = ACTIONS(4168),
    [aux_sym_infix_op_token2] = ACTIONS(4170),
    [anon_sym_PIPE_PIPE] = ACTIONS(4170),
    [anon_sym_BANG_EQ] = ACTIONS(4170),
    [anon_sym_COLON_EQ] = ACTIONS(4168),
    [anon_sym_DOLLAR] = ACTIONS(4170),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4170),
    [sym_int] = ACTIONS(4170),
    [sym_xint] = ACTIONS(4168),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4168),
    [anon_sym_POUNDendif] = ACTIONS(4168),
    [anon_sym_POUNDelse] = ACTIONS(4168),
    [sym__newline] = ACTIONS(4168),
  },
  [1849] = {
    [sym_block_comment] = STATE(1849),
    [sym_compiler_directive_decl] = STATE(1849),
    [sym_fsi_directive_decl] = STATE(1849),
    [sym_preproc_line] = STATE(1849),
    [sym_identifier] = ACTIONS(3972),
    [anon_sym_EQ] = ACTIONS(3970),
    [anon_sym_LBRACK_LT] = ACTIONS(3970),
    [anon_sym_COLON] = ACTIONS(3972),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_do] = ACTIONS(3972),
    [anon_sym_let] = ACTIONS(3972),
    [anon_sym_let_BANG] = ACTIONS(3970),
    [aux_sym_access_modifier_token1] = ACTIONS(3970),
    [anon_sym_LPAREN] = ACTIONS(3972),
    [anon_sym_COMMA] = ACTIONS(3970),
    [anon_sym_null] = ACTIONS(3972),
    [anon_sym_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_COLON] = ACTIONS(3970),
    [anon_sym_AMP] = ACTIONS(3972),
    [anon_sym_LBRACK] = ACTIONS(3972),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3970),
    [anon_sym_LBRACE] = ACTIONS(3972),
    [anon_sym_LT_AT] = ACTIONS(3972),
    [anon_sym_LT_AT_AT] = ACTIONS(3972),
    [anon_sym_DOT] = ACTIONS(3972),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3970),
    [anon_sym_new] = ACTIONS(3972),
    [anon_sym_with] = ACTIONS(3972),
    [anon_sym_return_BANG] = ACTIONS(3970),
    [anon_sym_yield] = ACTIONS(3972),
    [anon_sym_yield_BANG] = ACTIONS(3970),
    [anon_sym_lazy] = ACTIONS(3972),
    [anon_sym_assert] = ACTIONS(3972),
    [anon_sym_upcast] = ACTIONS(3972),
    [anon_sym_downcast] = ACTIONS(3972),
    [anon_sym_COLON_GT] = ACTIONS(3970),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3970),
    [anon_sym_for] = ACTIONS(3972),
    [anon_sym_while] = ACTIONS(3972),
    [anon_sym_if] = ACTIONS(3972),
    [anon_sym_fun] = ACTIONS(3972),
    [anon_sym_try] = ACTIONS(3972),
    [anon_sym_match] = ACTIONS(3972),
    [anon_sym_match_BANG] = ACTIONS(3970),
    [anon_sym_function] = ACTIONS(3972),
    [anon_sym_LT_DASH] = ACTIONS(3972),
    [anon_sym_DOT_LBRACK] = ACTIONS(3970),
    [anon_sym_LT] = ACTIONS(3970),
    [anon_sym_use] = ACTIONS(3972),
    [anon_sym_use_BANG] = ACTIONS(3970),
    [anon_sym_do_BANG] = ACTIONS(3970),
    [anon_sym_begin] = ACTIONS(3972),
    [anon_sym_LPAREN2] = ACTIONS(3972),
    [anon_sym_default] = ACTIONS(3972),
    [anon_sym_or] = ACTIONS(3972),
    [anon_sym_static] = ACTIONS(3972),
    [anon_sym_member] = ACTIONS(3972),
    [anon_sym_interface] = ACTIONS(3972),
    [anon_sym_abstract] = ACTIONS(3972),
    [anon_sym_val] = ACTIONS(3972),
    [anon_sym_override] = ACTIONS(3972),
    [anon_sym_inherit] = ACTIONS(3972),
    [aux_sym_char_token1] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3972),
    [anon_sym_DQUOTE] = ACTIONS(3972),
    [anon_sym_AT_DQUOTE] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [sym_bool] = ACTIONS(3972),
    [sym_unit] = ACTIONS(3970),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3972),
    [sym_op_identifier] = ACTIONS(3972),
    [anon_sym_PLUS] = ACTIONS(3972),
    [anon_sym_DASH] = ACTIONS(3972),
    [anon_sym_PLUS_DOT] = ACTIONS(3972),
    [anon_sym_DASH_DOT] = ACTIONS(3972),
    [anon_sym_PERCENT] = ACTIONS(3972),
    [anon_sym_AMP_AMP] = ACTIONS(3972),
    [anon_sym_TILDE] = ACTIONS(3970),
    [aux_sym_prefix_op_token1] = ACTIONS(3972),
    [aux_sym_infix_op_token1] = ACTIONS(3970),
    [aux_sym_infix_op_token2] = ACTIONS(3972),
    [anon_sym_PIPE_PIPE] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3972),
    [anon_sym_COLON_EQ] = ACTIONS(3970),
    [anon_sym_DOLLAR] = ACTIONS(3972),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3972),
    [sym_int] = ACTIONS(3972),
    [sym_xint] = ACTIONS(3970),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3970),
    [anon_sym_POUNDendif] = ACTIONS(3970),
    [anon_sym_POUNDelse] = ACTIONS(3970),
    [sym__newline] = ACTIONS(3970),
  },
  [1850] = {
    [sym_block_comment] = STATE(1850),
    [sym_compiler_directive_decl] = STATE(1850),
    [sym_fsi_directive_decl] = STATE(1850),
    [sym_preproc_line] = STATE(1850),
    [sym_identifier] = ACTIONS(3972),
    [anon_sym_EQ] = ACTIONS(3970),
    [anon_sym_LBRACK_LT] = ACTIONS(3970),
    [anon_sym_COLON] = ACTIONS(3972),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_do] = ACTIONS(3972),
    [anon_sym_and] = ACTIONS(3972),
    [anon_sym_let] = ACTIONS(3972),
    [anon_sym_let_BANG] = ACTIONS(3970),
    [aux_sym_access_modifier_token1] = ACTIONS(3970),
    [anon_sym_LPAREN] = ACTIONS(3972),
    [anon_sym_COMMA] = ACTIONS(3970),
    [anon_sym_null] = ACTIONS(3972),
    [anon_sym_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_COLON] = ACTIONS(3970),
    [anon_sym_AMP] = ACTIONS(3972),
    [anon_sym_LBRACK] = ACTIONS(3972),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3970),
    [anon_sym_LBRACE] = ACTIONS(3972),
    [anon_sym_LT_AT] = ACTIONS(3972),
    [anon_sym_LT_AT_AT] = ACTIONS(3972),
    [anon_sym_DOT] = ACTIONS(3972),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3970),
    [anon_sym_new] = ACTIONS(3972),
    [anon_sym_with] = ACTIONS(3972),
    [anon_sym_return_BANG] = ACTIONS(3970),
    [anon_sym_yield] = ACTIONS(3972),
    [anon_sym_yield_BANG] = ACTIONS(3970),
    [anon_sym_lazy] = ACTIONS(3972),
    [anon_sym_assert] = ACTIONS(3972),
    [anon_sym_upcast] = ACTIONS(3972),
    [anon_sym_downcast] = ACTIONS(3972),
    [anon_sym_COLON_GT] = ACTIONS(3970),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3970),
    [anon_sym_for] = ACTIONS(3972),
    [anon_sym_while] = ACTIONS(3972),
    [anon_sym_if] = ACTIONS(3972),
    [anon_sym_fun] = ACTIONS(3972),
    [anon_sym_try] = ACTIONS(3972),
    [anon_sym_match] = ACTIONS(3972),
    [anon_sym_match_BANG] = ACTIONS(3970),
    [anon_sym_function] = ACTIONS(3972),
    [anon_sym_LT_DASH] = ACTIONS(3972),
    [anon_sym_DOT_LBRACK] = ACTIONS(3970),
    [anon_sym_LT] = ACTIONS(3970),
    [anon_sym_use] = ACTIONS(3972),
    [anon_sym_use_BANG] = ACTIONS(3970),
    [anon_sym_do_BANG] = ACTIONS(3970),
    [anon_sym_begin] = ACTIONS(3972),
    [anon_sym_LPAREN2] = ACTIONS(3972),
    [anon_sym_default] = ACTIONS(3972),
    [anon_sym_or] = ACTIONS(3972),
    [anon_sym_static] = ACTIONS(3972),
    [anon_sym_member] = ACTIONS(3972),
    [anon_sym_interface] = ACTIONS(3972),
    [anon_sym_abstract] = ACTIONS(3972),
    [anon_sym_val] = ACTIONS(3972),
    [anon_sym_override] = ACTIONS(3972),
    [aux_sym_char_token1] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3972),
    [anon_sym_DQUOTE] = ACTIONS(3972),
    [anon_sym_AT_DQUOTE] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [sym_bool] = ACTIONS(3972),
    [sym_unit] = ACTIONS(3970),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3972),
    [sym_op_identifier] = ACTIONS(3972),
    [anon_sym_PLUS] = ACTIONS(3972),
    [anon_sym_DASH] = ACTIONS(3972),
    [anon_sym_PLUS_DOT] = ACTIONS(3972),
    [anon_sym_DASH_DOT] = ACTIONS(3972),
    [anon_sym_PERCENT] = ACTIONS(3972),
    [anon_sym_AMP_AMP] = ACTIONS(3972),
    [anon_sym_TILDE] = ACTIONS(3970),
    [aux_sym_prefix_op_token1] = ACTIONS(3972),
    [aux_sym_infix_op_token1] = ACTIONS(3970),
    [aux_sym_infix_op_token2] = ACTIONS(3972),
    [anon_sym_PIPE_PIPE] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3972),
    [anon_sym_COLON_EQ] = ACTIONS(3970),
    [anon_sym_DOLLAR] = ACTIONS(3972),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3972),
    [sym_int] = ACTIONS(3972),
    [sym_xint] = ACTIONS(3970),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3970),
    [anon_sym_POUNDendif] = ACTIONS(3970),
    [anon_sym_POUNDelse] = ACTIONS(3970),
    [sym__newline] = ACTIONS(3970),
  },
  [1851] = {
    [sym_block_comment] = STATE(1851),
    [sym_compiler_directive_decl] = STATE(1851),
    [sym_fsi_directive_decl] = STATE(1851),
    [sym_preproc_line] = STATE(1851),
    [sym_identifier] = ACTIONS(3946),
    [anon_sym_EQ] = ACTIONS(3944),
    [anon_sym_LBRACK_LT] = ACTIONS(3944),
    [anon_sym_COLON] = ACTIONS(3946),
    [anon_sym_return] = ACTIONS(3946),
    [anon_sym_do] = ACTIONS(3946),
    [anon_sym_and] = ACTIONS(3946),
    [anon_sym_let] = ACTIONS(3946),
    [anon_sym_let_BANG] = ACTIONS(3944),
    [aux_sym_access_modifier_token1] = ACTIONS(3944),
    [anon_sym_LPAREN] = ACTIONS(3946),
    [anon_sym_COMMA] = ACTIONS(3944),
    [anon_sym_null] = ACTIONS(3946),
    [anon_sym_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LBRACK] = ACTIONS(3946),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3944),
    [anon_sym_LBRACE] = ACTIONS(3946),
    [anon_sym_LT_AT] = ACTIONS(3946),
    [anon_sym_LT_AT_AT] = ACTIONS(3946),
    [anon_sym_DOT] = ACTIONS(3946),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3944),
    [anon_sym_new] = ACTIONS(3946),
    [anon_sym_with] = ACTIONS(3946),
    [anon_sym_return_BANG] = ACTIONS(3944),
    [anon_sym_yield] = ACTIONS(3946),
    [anon_sym_yield_BANG] = ACTIONS(3944),
    [anon_sym_lazy] = ACTIONS(3946),
    [anon_sym_assert] = ACTIONS(3946),
    [anon_sym_upcast] = ACTIONS(3946),
    [anon_sym_downcast] = ACTIONS(3946),
    [anon_sym_COLON_GT] = ACTIONS(3944),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3944),
    [anon_sym_for] = ACTIONS(3946),
    [anon_sym_while] = ACTIONS(3946),
    [anon_sym_if] = ACTIONS(3946),
    [anon_sym_fun] = ACTIONS(3946),
    [anon_sym_try] = ACTIONS(3946),
    [anon_sym_match] = ACTIONS(3946),
    [anon_sym_match_BANG] = ACTIONS(3944),
    [anon_sym_function] = ACTIONS(3946),
    [anon_sym_LT_DASH] = ACTIONS(3946),
    [anon_sym_DOT_LBRACK] = ACTIONS(3944),
    [anon_sym_LT] = ACTIONS(3944),
    [anon_sym_use] = ACTIONS(3946),
    [anon_sym_use_BANG] = ACTIONS(3944),
    [anon_sym_do_BANG] = ACTIONS(3944),
    [anon_sym_begin] = ACTIONS(3946),
    [anon_sym_LPAREN2] = ACTIONS(3946),
    [anon_sym_default] = ACTIONS(3946),
    [anon_sym_or] = ACTIONS(3946),
    [anon_sym_static] = ACTIONS(3946),
    [anon_sym_member] = ACTIONS(3946),
    [anon_sym_interface] = ACTIONS(3946),
    [anon_sym_abstract] = ACTIONS(3946),
    [anon_sym_val] = ACTIONS(3946),
    [anon_sym_override] = ACTIONS(3946),
    [aux_sym_char_token1] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_AT_DQUOTE] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [sym_bool] = ACTIONS(3946),
    [sym_unit] = ACTIONS(3944),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3946),
    [sym_op_identifier] = ACTIONS(3946),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PLUS_DOT] = ACTIONS(3946),
    [anon_sym_DASH_DOT] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3946),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_TILDE] = ACTIONS(3944),
    [aux_sym_prefix_op_token1] = ACTIONS(3946),
    [aux_sym_infix_op_token1] = ACTIONS(3944),
    [aux_sym_infix_op_token2] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [anon_sym_BANG_EQ] = ACTIONS(3946),
    [anon_sym_COLON_EQ] = ACTIONS(3944),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3946),
    [sym_int] = ACTIONS(3946),
    [sym_xint] = ACTIONS(3944),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3944),
    [anon_sym_POUNDendif] = ACTIONS(3944),
    [anon_sym_POUNDelse] = ACTIONS(3944),
    [sym__newline] = ACTIONS(3944),
  },
  [1852] = {
    [sym_block_comment] = STATE(1852),
    [sym_compiler_directive_decl] = STATE(1852),
    [sym_fsi_directive_decl] = STATE(1852),
    [sym_preproc_line] = STATE(1852),
    [sym_identifier] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(4076),
    [anon_sym_LBRACK_LT] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4078),
    [anon_sym_return] = ACTIONS(4078),
    [anon_sym_do] = ACTIONS(4078),
    [anon_sym_let] = ACTIONS(4078),
    [anon_sym_let_BANG] = ACTIONS(4076),
    [aux_sym_access_modifier_token1] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_null] = ACTIONS(4078),
    [anon_sym_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(4076),
    [anon_sym_AMP] = ACTIONS(4078),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4078),
    [anon_sym_LT_AT] = ACTIONS(4078),
    [anon_sym_LT_AT_AT] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(4078),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4076),
    [anon_sym_new] = ACTIONS(4078),
    [anon_sym_with] = ACTIONS(4078),
    [anon_sym_return_BANG] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(4078),
    [anon_sym_yield_BANG] = ACTIONS(4076),
    [anon_sym_lazy] = ACTIONS(4078),
    [anon_sym_assert] = ACTIONS(4078),
    [anon_sym_upcast] = ACTIONS(4078),
    [anon_sym_downcast] = ACTIONS(4078),
    [anon_sym_COLON_GT] = ACTIONS(4076),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4076),
    [anon_sym_for] = ACTIONS(4078),
    [anon_sym_while] = ACTIONS(4078),
    [anon_sym_if] = ACTIONS(4078),
    [anon_sym_fun] = ACTIONS(4078),
    [anon_sym_try] = ACTIONS(4078),
    [anon_sym_match] = ACTIONS(4078),
    [anon_sym_match_BANG] = ACTIONS(4076),
    [anon_sym_function] = ACTIONS(4078),
    [anon_sym_LT_DASH] = ACTIONS(4078),
    [anon_sym_DOT_LBRACK] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4076),
    [anon_sym_use] = ACTIONS(4078),
    [anon_sym_use_BANG] = ACTIONS(4076),
    [anon_sym_do_BANG] = ACTIONS(4076),
    [anon_sym_begin] = ACTIONS(4078),
    [anon_sym_LPAREN2] = ACTIONS(4078),
    [anon_sym_default] = ACTIONS(4078),
    [anon_sym_or] = ACTIONS(4078),
    [anon_sym_static] = ACTIONS(4078),
    [anon_sym_member] = ACTIONS(4078),
    [anon_sym_interface] = ACTIONS(4078),
    [anon_sym_abstract] = ACTIONS(4078),
    [anon_sym_val] = ACTIONS(4078),
    [anon_sym_override] = ACTIONS(4078),
    [anon_sym_inherit] = ACTIONS(4078),
    [aux_sym_char_token1] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4078),
    [anon_sym_DQUOTE] = ACTIONS(4078),
    [anon_sym_AT_DQUOTE] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [sym_bool] = ACTIONS(4078),
    [sym_unit] = ACTIONS(4076),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4078),
    [sym_op_identifier] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(4078),
    [anon_sym_PLUS_DOT] = ACTIONS(4078),
    [anon_sym_DASH_DOT] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [anon_sym_AMP_AMP] = ACTIONS(4078),
    [anon_sym_TILDE] = ACTIONS(4076),
    [aux_sym_prefix_op_token1] = ACTIONS(4078),
    [aux_sym_infix_op_token1] = ACTIONS(4076),
    [aux_sym_infix_op_token2] = ACTIONS(4078),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_BANG_EQ] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4076),
    [anon_sym_DOLLAR] = ACTIONS(4078),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4078),
    [sym_int] = ACTIONS(4078),
    [sym_xint] = ACTIONS(4076),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4076),
    [anon_sym_POUNDendif] = ACTIONS(4076),
    [anon_sym_POUNDelse] = ACTIONS(4076),
    [sym__newline] = ACTIONS(4076),
  },
  [1853] = {
    [sym_block_comment] = STATE(1853),
    [sym_compiler_directive_decl] = STATE(1853),
    [sym_fsi_directive_decl] = STATE(1853),
    [sym_preproc_line] = STATE(1853),
    [sym_identifier] = ACTIONS(3927),
    [anon_sym_EQ] = ACTIONS(3925),
    [anon_sym_LBRACK_LT] = ACTIONS(3925),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_return] = ACTIONS(3927),
    [anon_sym_do] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3927),
    [anon_sym_let] = ACTIONS(3927),
    [anon_sym_let_BANG] = ACTIONS(3925),
    [aux_sym_access_modifier_token1] = ACTIONS(3925),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_COMMA] = ACTIONS(3925),
    [anon_sym_null] = ACTIONS(3927),
    [anon_sym_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_COLON] = ACTIONS(3925),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3925),
    [anon_sym_LBRACE] = ACTIONS(3927),
    [anon_sym_LT_AT] = ACTIONS(3927),
    [anon_sym_LT_AT_AT] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3925),
    [anon_sym_new] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3927),
    [anon_sym_return_BANG] = ACTIONS(3925),
    [anon_sym_yield] = ACTIONS(3927),
    [anon_sym_yield_BANG] = ACTIONS(3925),
    [anon_sym_lazy] = ACTIONS(3927),
    [anon_sym_assert] = ACTIONS(3927),
    [anon_sym_upcast] = ACTIONS(3927),
    [anon_sym_downcast] = ACTIONS(3927),
    [anon_sym_COLON_GT] = ACTIONS(3925),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3925),
    [anon_sym_for] = ACTIONS(3927),
    [anon_sym_while] = ACTIONS(3927),
    [anon_sym_if] = ACTIONS(3927),
    [anon_sym_fun] = ACTIONS(3927),
    [anon_sym_try] = ACTIONS(3927),
    [anon_sym_match] = ACTIONS(3927),
    [anon_sym_match_BANG] = ACTIONS(3925),
    [anon_sym_function] = ACTIONS(3927),
    [anon_sym_LT_DASH] = ACTIONS(3927),
    [anon_sym_DOT_LBRACK] = ACTIONS(3925),
    [anon_sym_LT] = ACTIONS(3925),
    [anon_sym_use] = ACTIONS(3927),
    [anon_sym_use_BANG] = ACTIONS(3925),
    [anon_sym_do_BANG] = ACTIONS(3925),
    [anon_sym_begin] = ACTIONS(3927),
    [anon_sym_LPAREN2] = ACTIONS(3927),
    [anon_sym_default] = ACTIONS(3927),
    [anon_sym_or] = ACTIONS(3927),
    [anon_sym_static] = ACTIONS(3927),
    [anon_sym_member] = ACTIONS(3927),
    [anon_sym_interface] = ACTIONS(3927),
    [anon_sym_abstract] = ACTIONS(3927),
    [anon_sym_val] = ACTIONS(3927),
    [anon_sym_override] = ACTIONS(3927),
    [aux_sym_char_token1] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_AT_DQUOTE] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [sym_bool] = ACTIONS(3927),
    [sym_unit] = ACTIONS(3925),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3927),
    [sym_op_identifier] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3927),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_PLUS_DOT] = ACTIONS(3927),
    [anon_sym_DASH_DOT] = ACTIONS(3927),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_TILDE] = ACTIONS(3925),
    [aux_sym_prefix_op_token1] = ACTIONS(3927),
    [aux_sym_infix_op_token1] = ACTIONS(3925),
    [aux_sym_infix_op_token2] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_COLON_EQ] = ACTIONS(3925),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3927),
    [sym_int] = ACTIONS(3927),
    [sym_xint] = ACTIONS(3925),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3925),
    [anon_sym_POUNDendif] = ACTIONS(3925),
    [anon_sym_POUNDelse] = ACTIONS(3925),
    [sym__newline] = ACTIONS(3925),
  },
  [1854] = {
    [sym_block_comment] = STATE(1854),
    [sym_compiler_directive_decl] = STATE(1854),
    [sym_fsi_directive_decl] = STATE(1854),
    [sym_preproc_line] = STATE(1854),
    [sym_identifier] = ACTIONS(3996),
    [anon_sym_EQ] = ACTIONS(3994),
    [anon_sym_LBRACK_LT] = ACTIONS(3994),
    [anon_sym_COLON] = ACTIONS(3996),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_do] = ACTIONS(3996),
    [anon_sym_let] = ACTIONS(3996),
    [anon_sym_let_BANG] = ACTIONS(3994),
    [aux_sym_access_modifier_token1] = ACTIONS(3994),
    [anon_sym_LPAREN] = ACTIONS(3996),
    [anon_sym_COMMA] = ACTIONS(3994),
    [anon_sym_null] = ACTIONS(3996),
    [anon_sym_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_COLON] = ACTIONS(3994),
    [anon_sym_AMP] = ACTIONS(3996),
    [anon_sym_LBRACK] = ACTIONS(3996),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3994),
    [anon_sym_LBRACE] = ACTIONS(3996),
    [anon_sym_LT_AT] = ACTIONS(3996),
    [anon_sym_LT_AT_AT] = ACTIONS(3996),
    [anon_sym_DOT] = ACTIONS(3996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3994),
    [anon_sym_new] = ACTIONS(3996),
    [anon_sym_with] = ACTIONS(3996),
    [anon_sym_return_BANG] = ACTIONS(3994),
    [anon_sym_yield] = ACTIONS(3996),
    [anon_sym_yield_BANG] = ACTIONS(3994),
    [anon_sym_lazy] = ACTIONS(3996),
    [anon_sym_assert] = ACTIONS(3996),
    [anon_sym_upcast] = ACTIONS(3996),
    [anon_sym_downcast] = ACTIONS(3996),
    [anon_sym_COLON_GT] = ACTIONS(3994),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3994),
    [anon_sym_for] = ACTIONS(3996),
    [anon_sym_while] = ACTIONS(3996),
    [anon_sym_if] = ACTIONS(3996),
    [anon_sym_fun] = ACTIONS(3996),
    [anon_sym_try] = ACTIONS(3996),
    [anon_sym_match] = ACTIONS(3996),
    [anon_sym_match_BANG] = ACTIONS(3994),
    [anon_sym_function] = ACTIONS(3996),
    [anon_sym_LT_DASH] = ACTIONS(3996),
    [anon_sym_DOT_LBRACK] = ACTIONS(3994),
    [anon_sym_LT] = ACTIONS(3994),
    [anon_sym_use] = ACTIONS(3996),
    [anon_sym_use_BANG] = ACTIONS(3994),
    [anon_sym_do_BANG] = ACTIONS(3994),
    [anon_sym_begin] = ACTIONS(3996),
    [anon_sym_LPAREN2] = ACTIONS(3996),
    [anon_sym_default] = ACTIONS(3996),
    [anon_sym_or] = ACTIONS(3996),
    [anon_sym_static] = ACTIONS(3996),
    [anon_sym_member] = ACTIONS(3996),
    [anon_sym_interface] = ACTIONS(3996),
    [anon_sym_abstract] = ACTIONS(3996),
    [anon_sym_val] = ACTIONS(3996),
    [anon_sym_override] = ACTIONS(3996),
    [anon_sym_inherit] = ACTIONS(3996),
    [aux_sym_char_token1] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3996),
    [anon_sym_DQUOTE] = ACTIONS(3996),
    [anon_sym_AT_DQUOTE] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [sym_bool] = ACTIONS(3996),
    [sym_unit] = ACTIONS(3994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3996),
    [sym_op_identifier] = ACTIONS(3996),
    [anon_sym_PLUS] = ACTIONS(3996),
    [anon_sym_DASH] = ACTIONS(3996),
    [anon_sym_PLUS_DOT] = ACTIONS(3996),
    [anon_sym_DASH_DOT] = ACTIONS(3996),
    [anon_sym_PERCENT] = ACTIONS(3996),
    [anon_sym_AMP_AMP] = ACTIONS(3996),
    [anon_sym_TILDE] = ACTIONS(3994),
    [aux_sym_prefix_op_token1] = ACTIONS(3996),
    [aux_sym_infix_op_token1] = ACTIONS(3994),
    [aux_sym_infix_op_token2] = ACTIONS(3996),
    [anon_sym_PIPE_PIPE] = ACTIONS(3996),
    [anon_sym_BANG_EQ] = ACTIONS(3996),
    [anon_sym_COLON_EQ] = ACTIONS(3994),
    [anon_sym_DOLLAR] = ACTIONS(3996),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3996),
    [sym_int] = ACTIONS(3996),
    [sym_xint] = ACTIONS(3994),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3994),
    [anon_sym_POUNDendif] = ACTIONS(3994),
    [anon_sym_POUNDelse] = ACTIONS(3994),
    [sym__newline] = ACTIONS(3994),
  },
  [1855] = {
    [sym_block_comment] = STATE(1855),
    [sym_compiler_directive_decl] = STATE(1855),
    [sym_fsi_directive_decl] = STATE(1855),
    [sym_preproc_line] = STATE(1855),
    [sym_identifier] = ACTIONS(4182),
    [anon_sym_EQ] = ACTIONS(3689),
    [anon_sym_LBRACK_LT] = ACTIONS(3689),
    [anon_sym_COLON] = ACTIONS(4182),
    [anon_sym_return] = ACTIONS(4182),
    [anon_sym_do] = ACTIONS(4182),
    [anon_sym_let] = ACTIONS(4182),
    [anon_sym_let_BANG] = ACTIONS(3689),
    [aux_sym_access_modifier_token1] = ACTIONS(3689),
    [anon_sym_LPAREN] = ACTIONS(4182),
    [anon_sym_COMMA] = ACTIONS(3689),
    [anon_sym_null] = ACTIONS(4182),
    [anon_sym_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3689),
    [anon_sym_LBRACE] = ACTIONS(4182),
    [anon_sym_LT_AT] = ACTIONS(4182),
    [anon_sym_LT_AT_AT] = ACTIONS(4182),
    [anon_sym_DOT] = ACTIONS(4182),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3689),
    [anon_sym_new] = ACTIONS(4182),
    [anon_sym_with] = ACTIONS(4182),
    [anon_sym_return_BANG] = ACTIONS(3689),
    [anon_sym_yield] = ACTIONS(4182),
    [anon_sym_yield_BANG] = ACTIONS(3689),
    [anon_sym_lazy] = ACTIONS(4182),
    [anon_sym_assert] = ACTIONS(4182),
    [anon_sym_upcast] = ACTIONS(4182),
    [anon_sym_downcast] = ACTIONS(4182),
    [anon_sym_COLON_GT] = ACTIONS(3689),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3689),
    [anon_sym_for] = ACTIONS(4182),
    [anon_sym_while] = ACTIONS(4182),
    [anon_sym_if] = ACTIONS(4182),
    [anon_sym_fun] = ACTIONS(4182),
    [anon_sym_try] = ACTIONS(4182),
    [anon_sym_match] = ACTIONS(4182),
    [anon_sym_match_BANG] = ACTIONS(3689),
    [anon_sym_function] = ACTIONS(4182),
    [anon_sym_LT_DASH] = ACTIONS(4182),
    [anon_sym_DOT_LBRACK] = ACTIONS(3689),
    [anon_sym_LT] = ACTIONS(3689),
    [anon_sym_use] = ACTIONS(4182),
    [anon_sym_use_BANG] = ACTIONS(3689),
    [anon_sym_do_BANG] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(4182),
    [anon_sym_LPAREN2] = ACTIONS(4182),
    [anon_sym_default] = ACTIONS(4182),
    [anon_sym_or] = ACTIONS(4182),
    [anon_sym_static] = ACTIONS(4182),
    [anon_sym_member] = ACTIONS(4182),
    [anon_sym_interface] = ACTIONS(4182),
    [anon_sym_abstract] = ACTIONS(4182),
    [anon_sym_val] = ACTIONS(4182),
    [anon_sym_override] = ACTIONS(4182),
    [anon_sym_inherit] = ACTIONS(4182),
    [aux_sym_char_token1] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4182),
    [anon_sym_DQUOTE] = ACTIONS(4182),
    [anon_sym_AT_DQUOTE] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [sym_bool] = ACTIONS(4182),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4182),
    [sym_op_identifier] = ACTIONS(4182),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_PLUS_DOT] = ACTIONS(4182),
    [anon_sym_DASH_DOT] = ACTIONS(4182),
    [anon_sym_PERCENT] = ACTIONS(4182),
    [anon_sym_AMP_AMP] = ACTIONS(4182),
    [anon_sym_TILDE] = ACTIONS(3689),
    [aux_sym_prefix_op_token1] = ACTIONS(4182),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token2] = ACTIONS(4182),
    [anon_sym_PIPE_PIPE] = ACTIONS(4182),
    [anon_sym_BANG_EQ] = ACTIONS(4182),
    [anon_sym_COLON_EQ] = ACTIONS(3689),
    [anon_sym_DOLLAR] = ACTIONS(4182),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4182),
    [sym_int] = ACTIONS(4182),
    [sym_xint] = ACTIONS(3689),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3689),
    [anon_sym_POUNDendif] = ACTIONS(3689),
    [anon_sym_POUNDelse] = ACTIONS(3689),
    [sym__newline] = ACTIONS(3689),
  },
  [1856] = {
    [sym_block_comment] = STATE(1856),
    [sym_compiler_directive_decl] = STATE(1856),
    [sym_fsi_directive_decl] = STATE(1856),
    [sym_preproc_line] = STATE(1856),
    [sym_identifier] = ACTIONS(4162),
    [anon_sym_EQ] = ACTIONS(4160),
    [anon_sym_LBRACK_LT] = ACTIONS(4160),
    [anon_sym_COLON] = ACTIONS(4162),
    [anon_sym_return] = ACTIONS(4162),
    [anon_sym_do] = ACTIONS(4162),
    [anon_sym_let] = ACTIONS(4162),
    [anon_sym_let_BANG] = ACTIONS(4160),
    [aux_sym_access_modifier_token1] = ACTIONS(4160),
    [anon_sym_LPAREN] = ACTIONS(4162),
    [anon_sym_COMMA] = ACTIONS(4160),
    [anon_sym_null] = ACTIONS(4162),
    [anon_sym_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4160),
    [anon_sym_AMP] = ACTIONS(4162),
    [anon_sym_LBRACK] = ACTIONS(4162),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4160),
    [anon_sym_LBRACE] = ACTIONS(4162),
    [anon_sym_LT_AT] = ACTIONS(4162),
    [anon_sym_LT_AT_AT] = ACTIONS(4162),
    [anon_sym_DOT] = ACTIONS(4162),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4160),
    [anon_sym_new] = ACTIONS(4162),
    [anon_sym_with] = ACTIONS(4162),
    [anon_sym_return_BANG] = ACTIONS(4160),
    [anon_sym_yield] = ACTIONS(4162),
    [anon_sym_yield_BANG] = ACTIONS(4160),
    [anon_sym_lazy] = ACTIONS(4162),
    [anon_sym_assert] = ACTIONS(4162),
    [anon_sym_upcast] = ACTIONS(4162),
    [anon_sym_downcast] = ACTIONS(4162),
    [anon_sym_COLON_GT] = ACTIONS(4160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4160),
    [anon_sym_for] = ACTIONS(4162),
    [anon_sym_while] = ACTIONS(4162),
    [anon_sym_if] = ACTIONS(4162),
    [anon_sym_fun] = ACTIONS(4162),
    [anon_sym_try] = ACTIONS(4162),
    [anon_sym_match] = ACTIONS(4162),
    [anon_sym_match_BANG] = ACTIONS(4160),
    [anon_sym_function] = ACTIONS(4162),
    [anon_sym_LT_DASH] = ACTIONS(4162),
    [anon_sym_DOT_LBRACK] = ACTIONS(4160),
    [anon_sym_LT] = ACTIONS(4160),
    [anon_sym_use] = ACTIONS(4162),
    [anon_sym_use_BANG] = ACTIONS(4160),
    [anon_sym_do_BANG] = ACTIONS(4160),
    [anon_sym_begin] = ACTIONS(4162),
    [anon_sym_LPAREN2] = ACTIONS(4162),
    [anon_sym_default] = ACTIONS(4162),
    [anon_sym_or] = ACTIONS(4162),
    [anon_sym_static] = ACTIONS(4162),
    [anon_sym_member] = ACTIONS(4162),
    [anon_sym_interface] = ACTIONS(4162),
    [anon_sym_abstract] = ACTIONS(4162),
    [anon_sym_val] = ACTIONS(4162),
    [anon_sym_override] = ACTIONS(4162),
    [anon_sym_inherit] = ACTIONS(4162),
    [aux_sym_char_token1] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4162),
    [anon_sym_DQUOTE] = ACTIONS(4162),
    [anon_sym_AT_DQUOTE] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [sym_bool] = ACTIONS(4162),
    [sym_unit] = ACTIONS(4160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4162),
    [sym_op_identifier] = ACTIONS(4162),
    [anon_sym_PLUS] = ACTIONS(4162),
    [anon_sym_DASH] = ACTIONS(4162),
    [anon_sym_PLUS_DOT] = ACTIONS(4162),
    [anon_sym_DASH_DOT] = ACTIONS(4162),
    [anon_sym_PERCENT] = ACTIONS(4162),
    [anon_sym_AMP_AMP] = ACTIONS(4162),
    [anon_sym_TILDE] = ACTIONS(4160),
    [aux_sym_prefix_op_token1] = ACTIONS(4162),
    [aux_sym_infix_op_token1] = ACTIONS(4160),
    [aux_sym_infix_op_token2] = ACTIONS(4162),
    [anon_sym_PIPE_PIPE] = ACTIONS(4162),
    [anon_sym_BANG_EQ] = ACTIONS(4162),
    [anon_sym_COLON_EQ] = ACTIONS(4160),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4162),
    [sym_int] = ACTIONS(4162),
    [sym_xint] = ACTIONS(4160),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4160),
    [anon_sym_POUNDendif] = ACTIONS(4160),
    [anon_sym_POUNDelse] = ACTIONS(4160),
    [sym__newline] = ACTIONS(4160),
  },
  [1857] = {
    [sym_block_comment] = STATE(1857),
    [sym_compiler_directive_decl] = STATE(1857),
    [sym_fsi_directive_decl] = STATE(1857),
    [sym_preproc_line] = STATE(1857),
    [sym_identifier] = ACTIONS(4158),
    [anon_sym_EQ] = ACTIONS(4156),
    [anon_sym_LBRACK_LT] = ACTIONS(4156),
    [anon_sym_COLON] = ACTIONS(4158),
    [anon_sym_return] = ACTIONS(4158),
    [anon_sym_do] = ACTIONS(4158),
    [anon_sym_let] = ACTIONS(4158),
    [anon_sym_let_BANG] = ACTIONS(4156),
    [aux_sym_access_modifier_token1] = ACTIONS(4156),
    [anon_sym_LPAREN] = ACTIONS(4158),
    [anon_sym_COMMA] = ACTIONS(4156),
    [anon_sym_null] = ACTIONS(4158),
    [anon_sym_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_COLON] = ACTIONS(4156),
    [anon_sym_AMP] = ACTIONS(4158),
    [anon_sym_LBRACK] = ACTIONS(4158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(4158),
    [anon_sym_LT_AT] = ACTIONS(4158),
    [anon_sym_LT_AT_AT] = ACTIONS(4158),
    [anon_sym_DOT] = ACTIONS(4158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4156),
    [anon_sym_new] = ACTIONS(4158),
    [anon_sym_with] = ACTIONS(4158),
    [anon_sym_return_BANG] = ACTIONS(4156),
    [anon_sym_yield] = ACTIONS(4158),
    [anon_sym_yield_BANG] = ACTIONS(4156),
    [anon_sym_lazy] = ACTIONS(4158),
    [anon_sym_assert] = ACTIONS(4158),
    [anon_sym_upcast] = ACTIONS(4158),
    [anon_sym_downcast] = ACTIONS(4158),
    [anon_sym_COLON_GT] = ACTIONS(4156),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4156),
    [anon_sym_for] = ACTIONS(4158),
    [anon_sym_while] = ACTIONS(4158),
    [anon_sym_if] = ACTIONS(4158),
    [anon_sym_fun] = ACTIONS(4158),
    [anon_sym_try] = ACTIONS(4158),
    [anon_sym_match] = ACTIONS(4158),
    [anon_sym_match_BANG] = ACTIONS(4156),
    [anon_sym_function] = ACTIONS(4158),
    [anon_sym_LT_DASH] = ACTIONS(4158),
    [anon_sym_DOT_LBRACK] = ACTIONS(4156),
    [anon_sym_LT] = ACTIONS(4156),
    [anon_sym_use] = ACTIONS(4158),
    [anon_sym_use_BANG] = ACTIONS(4156),
    [anon_sym_do_BANG] = ACTIONS(4156),
    [anon_sym_begin] = ACTIONS(4158),
    [anon_sym_LPAREN2] = ACTIONS(4158),
    [anon_sym_default] = ACTIONS(4158),
    [anon_sym_or] = ACTIONS(4158),
    [anon_sym_static] = ACTIONS(4158),
    [anon_sym_member] = ACTIONS(4158),
    [anon_sym_interface] = ACTIONS(4158),
    [anon_sym_abstract] = ACTIONS(4158),
    [anon_sym_val] = ACTIONS(4158),
    [anon_sym_override] = ACTIONS(4158),
    [anon_sym_inherit] = ACTIONS(4158),
    [aux_sym_char_token1] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4158),
    [anon_sym_DQUOTE] = ACTIONS(4158),
    [anon_sym_AT_DQUOTE] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [sym_bool] = ACTIONS(4158),
    [sym_unit] = ACTIONS(4156),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4158),
    [sym_op_identifier] = ACTIONS(4158),
    [anon_sym_PLUS] = ACTIONS(4158),
    [anon_sym_DASH] = ACTIONS(4158),
    [anon_sym_PLUS_DOT] = ACTIONS(4158),
    [anon_sym_DASH_DOT] = ACTIONS(4158),
    [anon_sym_PERCENT] = ACTIONS(4158),
    [anon_sym_AMP_AMP] = ACTIONS(4158),
    [anon_sym_TILDE] = ACTIONS(4156),
    [aux_sym_prefix_op_token1] = ACTIONS(4158),
    [aux_sym_infix_op_token1] = ACTIONS(4156),
    [aux_sym_infix_op_token2] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE] = ACTIONS(4158),
    [anon_sym_BANG_EQ] = ACTIONS(4158),
    [anon_sym_COLON_EQ] = ACTIONS(4156),
    [anon_sym_DOLLAR] = ACTIONS(4158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4158),
    [sym_int] = ACTIONS(4158),
    [sym_xint] = ACTIONS(4156),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4156),
    [anon_sym_POUNDendif] = ACTIONS(4156),
    [anon_sym_POUNDelse] = ACTIONS(4156),
    [sym__newline] = ACTIONS(4156),
  },
  [1858] = {
    [sym_block_comment] = STATE(1858),
    [sym_compiler_directive_decl] = STATE(1858),
    [sym_fsi_directive_decl] = STATE(1858),
    [sym_preproc_line] = STATE(1858),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_and] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [aux_sym_access_modifier_token1] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_member] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_val] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [anon_sym_POUNDendif] = ACTIONS(3191),
    [anon_sym_POUNDelse] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1859] = {
    [sym_block_comment] = STATE(1859),
    [sym_compiler_directive_decl] = STATE(1859),
    [sym_fsi_directive_decl] = STATE(1859),
    [sym_preproc_line] = STATE(1859),
    [sym_identifier] = ACTIONS(4104),
    [anon_sym_EQ] = ACTIONS(4102),
    [anon_sym_LBRACK_LT] = ACTIONS(4102),
    [anon_sym_COLON] = ACTIONS(4104),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_do] = ACTIONS(4104),
    [anon_sym_and] = ACTIONS(4104),
    [anon_sym_let] = ACTIONS(4104),
    [anon_sym_let_BANG] = ACTIONS(4102),
    [aux_sym_access_modifier_token1] = ACTIONS(4102),
    [anon_sym_LPAREN] = ACTIONS(4104),
    [anon_sym_COMMA] = ACTIONS(4102),
    [anon_sym_null] = ACTIONS(4104),
    [anon_sym_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_COLON] = ACTIONS(4102),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4104),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4102),
    [anon_sym_LBRACE] = ACTIONS(4104),
    [anon_sym_LT_AT] = ACTIONS(4104),
    [anon_sym_LT_AT_AT] = ACTIONS(4104),
    [anon_sym_DOT] = ACTIONS(4104),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4102),
    [anon_sym_new] = ACTIONS(4104),
    [anon_sym_with] = ACTIONS(4104),
    [anon_sym_return_BANG] = ACTIONS(4102),
    [anon_sym_yield] = ACTIONS(4104),
    [anon_sym_yield_BANG] = ACTIONS(4102),
    [anon_sym_lazy] = ACTIONS(4104),
    [anon_sym_assert] = ACTIONS(4104),
    [anon_sym_upcast] = ACTIONS(4104),
    [anon_sym_downcast] = ACTIONS(4104),
    [anon_sym_COLON_GT] = ACTIONS(4102),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4102),
    [anon_sym_for] = ACTIONS(4104),
    [anon_sym_while] = ACTIONS(4104),
    [anon_sym_if] = ACTIONS(4104),
    [anon_sym_fun] = ACTIONS(4104),
    [anon_sym_try] = ACTIONS(4104),
    [anon_sym_match] = ACTIONS(4104),
    [anon_sym_match_BANG] = ACTIONS(4102),
    [anon_sym_function] = ACTIONS(4104),
    [anon_sym_LT_DASH] = ACTIONS(4104),
    [anon_sym_DOT_LBRACK] = ACTIONS(4102),
    [anon_sym_LT] = ACTIONS(4102),
    [anon_sym_use] = ACTIONS(4104),
    [anon_sym_use_BANG] = ACTIONS(4102),
    [anon_sym_do_BANG] = ACTIONS(4102),
    [anon_sym_begin] = ACTIONS(4104),
    [anon_sym_LPAREN2] = ACTIONS(4104),
    [anon_sym_default] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [anon_sym_static] = ACTIONS(4104),
    [anon_sym_member] = ACTIONS(4104),
    [anon_sym_interface] = ACTIONS(4104),
    [anon_sym_abstract] = ACTIONS(4104),
    [anon_sym_val] = ACTIONS(4104),
    [anon_sym_override] = ACTIONS(4104),
    [aux_sym_char_token1] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4104),
    [anon_sym_DQUOTE] = ACTIONS(4104),
    [anon_sym_AT_DQUOTE] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [sym_bool] = ACTIONS(4104),
    [sym_unit] = ACTIONS(4102),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4104),
    [sym_op_identifier] = ACTIONS(4104),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_PLUS_DOT] = ACTIONS(4104),
    [anon_sym_DASH_DOT] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_AMP_AMP] = ACTIONS(4104),
    [anon_sym_TILDE] = ACTIONS(4102),
    [aux_sym_prefix_op_token1] = ACTIONS(4104),
    [aux_sym_infix_op_token1] = ACTIONS(4102),
    [aux_sym_infix_op_token2] = ACTIONS(4104),
    [anon_sym_PIPE_PIPE] = ACTIONS(4104),
    [anon_sym_BANG_EQ] = ACTIONS(4104),
    [anon_sym_COLON_EQ] = ACTIONS(4102),
    [anon_sym_DOLLAR] = ACTIONS(4104),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4104),
    [sym_int] = ACTIONS(4104),
    [sym_xint] = ACTIONS(4102),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4102),
    [anon_sym_POUNDendif] = ACTIONS(4102),
    [anon_sym_POUNDelse] = ACTIONS(4102),
    [sym__newline] = ACTIONS(4102),
  },
  [1860] = {
    [sym_block_comment] = STATE(1860),
    [sym_compiler_directive_decl] = STATE(1860),
    [sym_fsi_directive_decl] = STATE(1860),
    [sym_preproc_line] = STATE(1860),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_EQ] = ACTIONS(4001),
    [anon_sym_LBRACK_LT] = ACTIONS(4001),
    [anon_sym_COLON] = ACTIONS(4003),
    [anon_sym_return] = ACTIONS(4003),
    [anon_sym_do] = ACTIONS(4003),
    [anon_sym_let] = ACTIONS(4003),
    [anon_sym_let_BANG] = ACTIONS(4001),
    [aux_sym_access_modifier_token1] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4003),
    [anon_sym_COMMA] = ACTIONS(4001),
    [anon_sym_null] = ACTIONS(4003),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_COLON] = ACTIONS(4001),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LBRACK] = ACTIONS(4003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4001),
    [anon_sym_LBRACE] = ACTIONS(4003),
    [anon_sym_LT_AT] = ACTIONS(4003),
    [anon_sym_LT_AT_AT] = ACTIONS(4003),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4001),
    [anon_sym_new] = ACTIONS(4003),
    [anon_sym_with] = ACTIONS(4003),
    [anon_sym_return_BANG] = ACTIONS(4001),
    [anon_sym_yield] = ACTIONS(4003),
    [anon_sym_yield_BANG] = ACTIONS(4001),
    [anon_sym_lazy] = ACTIONS(4003),
    [anon_sym_assert] = ACTIONS(4003),
    [anon_sym_upcast] = ACTIONS(4003),
    [anon_sym_downcast] = ACTIONS(4003),
    [anon_sym_COLON_GT] = ACTIONS(4001),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4001),
    [anon_sym_for] = ACTIONS(4003),
    [anon_sym_while] = ACTIONS(4003),
    [anon_sym_if] = ACTIONS(4003),
    [anon_sym_fun] = ACTIONS(4003),
    [anon_sym_try] = ACTIONS(4003),
    [anon_sym_match] = ACTIONS(4003),
    [anon_sym_match_BANG] = ACTIONS(4001),
    [anon_sym_function] = ACTIONS(4003),
    [anon_sym_LT_DASH] = ACTIONS(4003),
    [anon_sym_DOT_LBRACK] = ACTIONS(4001),
    [anon_sym_LT] = ACTIONS(4001),
    [anon_sym_use] = ACTIONS(4003),
    [anon_sym_use_BANG] = ACTIONS(4001),
    [anon_sym_do_BANG] = ACTIONS(4001),
    [anon_sym_begin] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4003),
    [anon_sym_default] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [anon_sym_static] = ACTIONS(4003),
    [anon_sym_member] = ACTIONS(4003),
    [anon_sym_interface] = ACTIONS(4003),
    [anon_sym_abstract] = ACTIONS(4003),
    [anon_sym_val] = ACTIONS(4003),
    [anon_sym_override] = ACTIONS(4003),
    [anon_sym_inherit] = ACTIONS(4003),
    [aux_sym_char_token1] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4003),
    [anon_sym_DQUOTE] = ACTIONS(4003),
    [anon_sym_AT_DQUOTE] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [sym_bool] = ACTIONS(4003),
    [sym_unit] = ACTIONS(4001),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4003),
    [sym_op_identifier] = ACTIONS(4003),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_PLUS_DOT] = ACTIONS(4003),
    [anon_sym_DASH_DOT] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4003),
    [anon_sym_TILDE] = ACTIONS(4001),
    [aux_sym_prefix_op_token1] = ACTIONS(4003),
    [aux_sym_infix_op_token1] = ACTIONS(4001),
    [aux_sym_infix_op_token2] = ACTIONS(4003),
    [anon_sym_PIPE_PIPE] = ACTIONS(4003),
    [anon_sym_BANG_EQ] = ACTIONS(4003),
    [anon_sym_COLON_EQ] = ACTIONS(4001),
    [anon_sym_DOLLAR] = ACTIONS(4003),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4003),
    [sym_int] = ACTIONS(4003),
    [sym_xint] = ACTIONS(4001),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4001),
    [anon_sym_POUNDendif] = ACTIONS(4001),
    [anon_sym_POUNDelse] = ACTIONS(4001),
    [sym__newline] = ACTIONS(4001),
  },
  [1861] = {
    [sym_block_comment] = STATE(1861),
    [sym_compiler_directive_decl] = STATE(1861),
    [sym_fsi_directive_decl] = STATE(1861),
    [sym_preproc_line] = STATE(1861),
    [aux_sym_long_identifier_repeat1] = STATE(1782),
    [sym_identifier] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3778),
    [anon_sym_LBRACK_LT] = ACTIONS(3778),
    [anon_sym_COLON] = ACTIONS(3781),
    [anon_sym_return] = ACTIONS(3781),
    [anon_sym_do] = ACTIONS(3781),
    [anon_sym_let] = ACTIONS(3781),
    [anon_sym_let_BANG] = ACTIONS(3778),
    [aux_sym_access_modifier_token1] = ACTIONS(3778),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3778),
    [anon_sym_null] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3781),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_LT_AT] = ACTIONS(3781),
    [anon_sym_LT_AT_AT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(4718),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3778),
    [anon_sym_new] = ACTIONS(3781),
    [anon_sym_with] = ACTIONS(3781),
    [anon_sym_return_BANG] = ACTIONS(3778),
    [anon_sym_yield] = ACTIONS(3781),
    [anon_sym_yield_BANG] = ACTIONS(3778),
    [anon_sym_lazy] = ACTIONS(3781),
    [anon_sym_assert] = ACTIONS(3781),
    [anon_sym_upcast] = ACTIONS(3781),
    [anon_sym_downcast] = ACTIONS(3781),
    [anon_sym_COLON_GT] = ACTIONS(3778),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3778),
    [anon_sym_for] = ACTIONS(3781),
    [anon_sym_while] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_fun] = ACTIONS(3781),
    [anon_sym_try] = ACTIONS(3781),
    [anon_sym_match] = ACTIONS(3781),
    [anon_sym_match_BANG] = ACTIONS(3778),
    [anon_sym_function] = ACTIONS(3781),
    [anon_sym_LT_DASH] = ACTIONS(3781),
    [anon_sym_DOT_LBRACK] = ACTIONS(3778),
    [anon_sym_LT] = ACTIONS(3778),
    [anon_sym_use] = ACTIONS(3781),
    [anon_sym_use_BANG] = ACTIONS(3778),
    [anon_sym_do_BANG] = ACTIONS(3778),
    [anon_sym_begin] = ACTIONS(3781),
    [anon_sym_LPAREN2] = ACTIONS(3781),
    [anon_sym_default] = ACTIONS(3781),
    [anon_sym_or] = ACTIONS(3781),
    [anon_sym_static] = ACTIONS(3781),
    [anon_sym_member] = ACTIONS(3781),
    [anon_sym_interface] = ACTIONS(3781),
    [anon_sym_abstract] = ACTIONS(3781),
    [anon_sym_val] = ACTIONS(3781),
    [anon_sym_override] = ACTIONS(3781),
    [anon_sym_inherit] = ACTIONS(3781),
    [aux_sym_char_token1] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3781),
    [anon_sym_DQUOTE] = ACTIONS(3781),
    [anon_sym_AT_DQUOTE] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [sym_bool] = ACTIONS(3781),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3781),
    [sym_op_identifier] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3781),
    [anon_sym_DASH] = ACTIONS(3781),
    [anon_sym_PLUS_DOT] = ACTIONS(3781),
    [anon_sym_DASH_DOT] = ACTIONS(3781),
    [anon_sym_PERCENT] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3781),
    [anon_sym_TILDE] = ACTIONS(3778),
    [aux_sym_prefix_op_token1] = ACTIONS(3781),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token2] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_COLON_EQ] = ACTIONS(3778),
    [anon_sym_DOLLAR] = ACTIONS(3781),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3781),
    [sym_int] = ACTIONS(3781),
    [sym_xint] = ACTIONS(3778),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3778),
    [anon_sym_POUNDendif] = ACTIONS(3778),
    [sym__newline] = ACTIONS(3778),
  },
  [1862] = {
    [sym_block_comment] = STATE(1862),
    [sym_compiler_directive_decl] = STATE(1862),
    [sym_fsi_directive_decl] = STATE(1862),
    [sym_preproc_line] = STATE(1862),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_GT] = ACTIONS(3193),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(4442),
    [anon_sym_uy] = ACTIONS(4444),
    [anon_sym_s] = ACTIONS(4446),
    [anon_sym_us] = ACTIONS(4448),
    [anon_sym_l] = ACTIONS(4450),
    [aux_sym_uint32_token1] = ACTIONS(4452),
    [anon_sym_n] = ACTIONS(4454),
    [anon_sym_un] = ACTIONS(4456),
    [anon_sym_L] = ACTIONS(4458),
    [aux_sym_uint64_token1] = ACTIONS(4460),
    [anon_sym_lf] = ACTIONS(4722),
    [anon_sym_LF] = ACTIONS(4724),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [1863] = {
    [sym_block_comment] = STATE(1863),
    [sym_compiler_directive_decl] = STATE(1863),
    [sym_fsi_directive_decl] = STATE(1863),
    [sym_preproc_line] = STATE(1863),
    [sym_identifier] = ACTIONS(3728),
    [anon_sym_EQ] = ACTIONS(3726),
    [anon_sym_LBRACK_LT] = ACTIONS(3726),
    [anon_sym_COLON] = ACTIONS(3728),
    [anon_sym_return] = ACTIONS(3728),
    [anon_sym_do] = ACTIONS(3728),
    [anon_sym_let] = ACTIONS(3728),
    [anon_sym_let_BANG] = ACTIONS(3726),
    [aux_sym_access_modifier_token1] = ACTIONS(3726),
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_COMMA] = ACTIONS(3726),
    [anon_sym_null] = ACTIONS(3728),
    [anon_sym_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(3726),
    [anon_sym_AMP] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3726),
    [anon_sym_LBRACE] = ACTIONS(3728),
    [anon_sym_LT_AT] = ACTIONS(3728),
    [anon_sym_LT_AT_AT] = ACTIONS(3728),
    [anon_sym_DOT] = ACTIONS(3728),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3726),
    [anon_sym_new] = ACTIONS(3728),
    [anon_sym_with] = ACTIONS(3728),
    [anon_sym_return_BANG] = ACTIONS(3726),
    [anon_sym_yield] = ACTIONS(3728),
    [anon_sym_yield_BANG] = ACTIONS(3726),
    [anon_sym_lazy] = ACTIONS(3728),
    [anon_sym_assert] = ACTIONS(3728),
    [anon_sym_upcast] = ACTIONS(3728),
    [anon_sym_downcast] = ACTIONS(3728),
    [anon_sym_COLON_GT] = ACTIONS(3726),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3726),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_fun] = ACTIONS(3728),
    [anon_sym_try] = ACTIONS(3728),
    [anon_sym_match] = ACTIONS(3728),
    [anon_sym_match_BANG] = ACTIONS(3726),
    [anon_sym_function] = ACTIONS(3728),
    [anon_sym_LT_DASH] = ACTIONS(3728),
    [anon_sym_DOT_LBRACK] = ACTIONS(3726),
    [anon_sym_LT] = ACTIONS(3726),
    [anon_sym_use] = ACTIONS(3728),
    [anon_sym_use_BANG] = ACTIONS(3726),
    [anon_sym_do_BANG] = ACTIONS(3726),
    [anon_sym_begin] = ACTIONS(3728),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_default] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [anon_sym_static] = ACTIONS(3728),
    [anon_sym_member] = ACTIONS(3728),
    [anon_sym_interface] = ACTIONS(3728),
    [anon_sym_abstract] = ACTIONS(3728),
    [anon_sym_val] = ACTIONS(3728),
    [anon_sym_override] = ACTIONS(3728),
    [aux_sym_char_token1] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3728),
    [anon_sym_AT_DQUOTE] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [sym_bool] = ACTIONS(3728),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3728),
    [sym_op_identifier] = ACTIONS(3728),
    [anon_sym_PLUS] = ACTIONS(3728),
    [anon_sym_DASH] = ACTIONS(3728),
    [anon_sym_PLUS_DOT] = ACTIONS(3728),
    [anon_sym_DASH_DOT] = ACTIONS(3728),
    [anon_sym_PERCENT] = ACTIONS(3728),
    [anon_sym_AMP_AMP] = ACTIONS(3728),
    [anon_sym_TILDE] = ACTIONS(3726),
    [aux_sym_prefix_op_token1] = ACTIONS(3728),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token2] = ACTIONS(3728),
    [anon_sym_PIPE_PIPE] = ACTIONS(3728),
    [anon_sym_BANG_EQ] = ACTIONS(3728),
    [anon_sym_COLON_EQ] = ACTIONS(3726),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3728),
    [sym_int] = ACTIONS(3728),
    [sym_xint] = ACTIONS(3726),
    [anon_sym_f] = ACTIONS(3728),
    [aux_sym_decimal_token1] = ACTIONS(3728),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3726),
    [sym__newline] = ACTIONS(3726),
    [sym__dedent] = ACTIONS(3726),
  },
  [1864] = {
    [sym_block_comment] = STATE(1864),
    [sym_compiler_directive_decl] = STATE(1864),
    [sym_fsi_directive_decl] = STATE(1864),
    [sym_preproc_line] = STATE(1864),
    [sym_identifier] = ACTIONS(3828),
    [anon_sym_EQ] = ACTIONS(3826),
    [anon_sym_LBRACK_LT] = ACTIONS(3826),
    [anon_sym_COLON] = ACTIONS(3828),
    [anon_sym_return] = ACTIONS(3828),
    [anon_sym_do] = ACTIONS(3828),
    [anon_sym_let] = ACTIONS(3828),
    [anon_sym_let_BANG] = ACTIONS(3826),
    [aux_sym_access_modifier_token1] = ACTIONS(3826),
    [anon_sym_LPAREN] = ACTIONS(3828),
    [anon_sym_COMMA] = ACTIONS(3826),
    [anon_sym_null] = ACTIONS(3828),
    [anon_sym_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_COLON] = ACTIONS(3826),
    [anon_sym_PIPE] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3828),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3826),
    [anon_sym_LBRACE] = ACTIONS(3828),
    [anon_sym_LT_AT] = ACTIONS(3828),
    [anon_sym_LT_AT_AT] = ACTIONS(3828),
    [anon_sym_DOT] = ACTIONS(3828),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3826),
    [anon_sym_new] = ACTIONS(3828),
    [anon_sym_with] = ACTIONS(3828),
    [anon_sym_return_BANG] = ACTIONS(3826),
    [anon_sym_yield] = ACTIONS(3828),
    [anon_sym_yield_BANG] = ACTIONS(3826),
    [anon_sym_lazy] = ACTIONS(3828),
    [anon_sym_assert] = ACTIONS(3828),
    [anon_sym_upcast] = ACTIONS(3828),
    [anon_sym_downcast] = ACTIONS(3828),
    [anon_sym_COLON_GT] = ACTIONS(3826),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3826),
    [anon_sym_for] = ACTIONS(3828),
    [anon_sym_while] = ACTIONS(3828),
    [anon_sym_if] = ACTIONS(3828),
    [anon_sym_fun] = ACTIONS(3828),
    [anon_sym_try] = ACTIONS(3828),
    [anon_sym_match] = ACTIONS(3828),
    [anon_sym_match_BANG] = ACTIONS(3826),
    [anon_sym_function] = ACTIONS(3828),
    [anon_sym_LT_DASH] = ACTIONS(3828),
    [anon_sym_DOT_LBRACK] = ACTIONS(3826),
    [anon_sym_LT] = ACTIONS(3826),
    [anon_sym_use] = ACTIONS(3828),
    [anon_sym_use_BANG] = ACTIONS(3826),
    [anon_sym_do_BANG] = ACTIONS(3826),
    [anon_sym_begin] = ACTIONS(3828),
    [anon_sym_LPAREN2] = ACTIONS(3828),
    [anon_sym_DOT_DOT2] = ACTIONS(3826),
    [anon_sym_default] = ACTIONS(3828),
    [anon_sym_or] = ACTIONS(3828),
    [anon_sym_static] = ACTIONS(3828),
    [anon_sym_member] = ACTIONS(3828),
    [anon_sym_interface] = ACTIONS(3828),
    [anon_sym_abstract] = ACTIONS(3828),
    [anon_sym_val] = ACTIONS(3828),
    [anon_sym_override] = ACTIONS(3828),
    [aux_sym_char_token1] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3828),
    [anon_sym_DQUOTE] = ACTIONS(3828),
    [anon_sym_AT_DQUOTE] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [sym_bool] = ACTIONS(3828),
    [sym_unit] = ACTIONS(3826),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3828),
    [sym_op_identifier] = ACTIONS(3828),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_DASH] = ACTIONS(3828),
    [anon_sym_PLUS_DOT] = ACTIONS(3828),
    [anon_sym_DASH_DOT] = ACTIONS(3828),
    [anon_sym_PERCENT] = ACTIONS(3828),
    [anon_sym_AMP_AMP] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3826),
    [aux_sym_prefix_op_token1] = ACTIONS(3828),
    [aux_sym_infix_op_token1] = ACTIONS(3826),
    [aux_sym_infix_op_token2] = ACTIONS(3828),
    [anon_sym_PIPE_PIPE] = ACTIONS(3828),
    [anon_sym_BANG_EQ] = ACTIONS(3828),
    [anon_sym_COLON_EQ] = ACTIONS(3826),
    [anon_sym_DOLLAR] = ACTIONS(3828),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3828),
    [sym_int] = ACTIONS(3828),
    [sym_xint] = ACTIONS(3826),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3826),
    [sym__newline] = ACTIONS(3826),
    [sym__dedent] = ACTIONS(3826),
  },
  [1865] = {
    [sym_block_comment] = STATE(1865),
    [sym_compiler_directive_decl] = STATE(1865),
    [sym_fsi_directive_decl] = STATE(1865),
    [sym_preproc_line] = STATE(1865),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_LBRACK_LT] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [aux_sym_access_modifier_token1] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_with] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_default] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [anon_sym_static] = ACTIONS(3604),
    [anon_sym_member] = ACTIONS(3604),
    [anon_sym_interface] = ACTIONS(3604),
    [anon_sym_abstract] = ACTIONS(3604),
    [anon_sym_val] = ACTIONS(3604),
    [anon_sym_override] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
    [sym__dedent] = ACTIONS(3602),
  },
  [1866] = {
    [sym_block_comment] = STATE(1866),
    [sym_compiler_directive_decl] = STATE(1866),
    [sym_fsi_directive_decl] = STATE(1866),
    [sym_preproc_line] = STATE(1866),
    [sym_identifier] = ACTIONS(4018),
    [anon_sym_EQ] = ACTIONS(4016),
    [anon_sym_LBRACK_LT] = ACTIONS(4016),
    [anon_sym_COLON] = ACTIONS(4018),
    [anon_sym_return] = ACTIONS(4018),
    [anon_sym_do] = ACTIONS(4018),
    [anon_sym_let] = ACTIONS(4018),
    [anon_sym_let_BANG] = ACTIONS(4016),
    [aux_sym_access_modifier_token1] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(4018),
    [anon_sym_COMMA] = ACTIONS(4016),
    [anon_sym_null] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_COLON] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4018),
    [anon_sym_LBRACK] = ACTIONS(4018),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4016),
    [anon_sym_LBRACE] = ACTIONS(4018),
    [anon_sym_LT_AT] = ACTIONS(4018),
    [anon_sym_LT_AT_AT] = ACTIONS(4018),
    [anon_sym_DOT] = ACTIONS(4018),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4016),
    [anon_sym_new] = ACTIONS(4018),
    [anon_sym_with] = ACTIONS(4018),
    [anon_sym_return_BANG] = ACTIONS(4016),
    [anon_sym_yield] = ACTIONS(4018),
    [anon_sym_yield_BANG] = ACTIONS(4016),
    [anon_sym_lazy] = ACTIONS(4018),
    [anon_sym_assert] = ACTIONS(4018),
    [anon_sym_upcast] = ACTIONS(4018),
    [anon_sym_downcast] = ACTIONS(4018),
    [anon_sym_COLON_GT] = ACTIONS(4016),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4016),
    [anon_sym_for] = ACTIONS(4018),
    [anon_sym_while] = ACTIONS(4018),
    [anon_sym_if] = ACTIONS(4018),
    [anon_sym_fun] = ACTIONS(4018),
    [anon_sym_try] = ACTIONS(4018),
    [anon_sym_match] = ACTIONS(4018),
    [anon_sym_match_BANG] = ACTIONS(4016),
    [anon_sym_function] = ACTIONS(4018),
    [anon_sym_LT_DASH] = ACTIONS(4018),
    [anon_sym_DOT_LBRACK] = ACTIONS(4016),
    [anon_sym_LT] = ACTIONS(4016),
    [anon_sym_use] = ACTIONS(4018),
    [anon_sym_use_BANG] = ACTIONS(4016),
    [anon_sym_do_BANG] = ACTIONS(4016),
    [anon_sym_begin] = ACTIONS(4018),
    [anon_sym_LPAREN2] = ACTIONS(4018),
    [anon_sym_default] = ACTIONS(4018),
    [anon_sym_or] = ACTIONS(4018),
    [anon_sym_static] = ACTIONS(4018),
    [anon_sym_member] = ACTIONS(4018),
    [anon_sym_interface] = ACTIONS(4018),
    [anon_sym_abstract] = ACTIONS(4018),
    [anon_sym_val] = ACTIONS(4018),
    [anon_sym_override] = ACTIONS(4018),
    [anon_sym_inherit] = ACTIONS(4018),
    [aux_sym_char_token1] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(4018),
    [anon_sym_AT_DQUOTE] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [sym_bool] = ACTIONS(4018),
    [sym_unit] = ACTIONS(4016),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4018),
    [sym_op_identifier] = ACTIONS(4018),
    [anon_sym_PLUS] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_PLUS_DOT] = ACTIONS(4018),
    [anon_sym_DASH_DOT] = ACTIONS(4018),
    [anon_sym_PERCENT] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4016),
    [aux_sym_prefix_op_token1] = ACTIONS(4018),
    [aux_sym_infix_op_token1] = ACTIONS(4016),
    [aux_sym_infix_op_token2] = ACTIONS(4018),
    [anon_sym_PIPE_PIPE] = ACTIONS(4018),
    [anon_sym_BANG_EQ] = ACTIONS(4018),
    [anon_sym_COLON_EQ] = ACTIONS(4016),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4018),
    [sym_int] = ACTIONS(4018),
    [sym_xint] = ACTIONS(4016),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4016),
    [anon_sym_POUNDendif] = ACTIONS(4016),
    [anon_sym_POUNDelse] = ACTIONS(4016),
    [sym__newline] = ACTIONS(4016),
  },
  [1867] = {
    [sym_block_comment] = STATE(1867),
    [sym_compiler_directive_decl] = STATE(1867),
    [sym_fsi_directive_decl] = STATE(1867),
    [sym_preproc_line] = STATE(1867),
    [sym_identifier] = ACTIONS(4054),
    [anon_sym_EQ] = ACTIONS(4052),
    [anon_sym_LBRACK_LT] = ACTIONS(4052),
    [anon_sym_COLON] = ACTIONS(4054),
    [anon_sym_return] = ACTIONS(4054),
    [anon_sym_do] = ACTIONS(4054),
    [anon_sym_let] = ACTIONS(4054),
    [anon_sym_let_BANG] = ACTIONS(4052),
    [aux_sym_access_modifier_token1] = ACTIONS(4052),
    [anon_sym_LPAREN] = ACTIONS(4054),
    [anon_sym_COMMA] = ACTIONS(4052),
    [anon_sym_null] = ACTIONS(4054),
    [anon_sym_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_COLON] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(4054),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4052),
    [anon_sym_LBRACE] = ACTIONS(4054),
    [anon_sym_LT_AT] = ACTIONS(4054),
    [anon_sym_LT_AT_AT] = ACTIONS(4054),
    [anon_sym_DOT] = ACTIONS(4054),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_with] = ACTIONS(4054),
    [anon_sym_return_BANG] = ACTIONS(4052),
    [anon_sym_yield] = ACTIONS(4054),
    [anon_sym_yield_BANG] = ACTIONS(4052),
    [anon_sym_lazy] = ACTIONS(4054),
    [anon_sym_assert] = ACTIONS(4054),
    [anon_sym_upcast] = ACTIONS(4054),
    [anon_sym_downcast] = ACTIONS(4054),
    [anon_sym_COLON_GT] = ACTIONS(4052),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4052),
    [anon_sym_for] = ACTIONS(4054),
    [anon_sym_while] = ACTIONS(4054),
    [anon_sym_if] = ACTIONS(4054),
    [anon_sym_fun] = ACTIONS(4054),
    [anon_sym_try] = ACTIONS(4054),
    [anon_sym_match] = ACTIONS(4054),
    [anon_sym_match_BANG] = ACTIONS(4052),
    [anon_sym_function] = ACTIONS(4054),
    [anon_sym_LT_DASH] = ACTIONS(4054),
    [anon_sym_DOT_LBRACK] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_use] = ACTIONS(4054),
    [anon_sym_use_BANG] = ACTIONS(4052),
    [anon_sym_do_BANG] = ACTIONS(4052),
    [anon_sym_begin] = ACTIONS(4054),
    [anon_sym_LPAREN2] = ACTIONS(4054),
    [anon_sym_default] = ACTIONS(4054),
    [anon_sym_or] = ACTIONS(4054),
    [anon_sym_static] = ACTIONS(4054),
    [anon_sym_member] = ACTIONS(4054),
    [anon_sym_interface] = ACTIONS(4054),
    [anon_sym_abstract] = ACTIONS(4054),
    [anon_sym_val] = ACTIONS(4054),
    [anon_sym_override] = ACTIONS(4054),
    [anon_sym_inherit] = ACTIONS(4054),
    [aux_sym_char_token1] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4054),
    [anon_sym_DQUOTE] = ACTIONS(4054),
    [anon_sym_AT_DQUOTE] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [sym_bool] = ACTIONS(4054),
    [sym_unit] = ACTIONS(4052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4054),
    [sym_op_identifier] = ACTIONS(4054),
    [anon_sym_PLUS] = ACTIONS(4054),
    [anon_sym_DASH] = ACTIONS(4054),
    [anon_sym_PLUS_DOT] = ACTIONS(4054),
    [anon_sym_DASH_DOT] = ACTIONS(4054),
    [anon_sym_PERCENT] = ACTIONS(4054),
    [anon_sym_AMP_AMP] = ACTIONS(4054),
    [anon_sym_TILDE] = ACTIONS(4052),
    [aux_sym_prefix_op_token1] = ACTIONS(4054),
    [aux_sym_infix_op_token1] = ACTIONS(4052),
    [aux_sym_infix_op_token2] = ACTIONS(4054),
    [anon_sym_PIPE_PIPE] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4054),
    [anon_sym_COLON_EQ] = ACTIONS(4052),
    [anon_sym_DOLLAR] = ACTIONS(4054),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4054),
    [sym_int] = ACTIONS(4054),
    [sym_xint] = ACTIONS(4052),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4052),
    [anon_sym_POUNDendif] = ACTIONS(4052),
    [anon_sym_POUNDelse] = ACTIONS(4052),
    [sym__newline] = ACTIONS(4052),
  },
  [1868] = {
    [sym_block_comment] = STATE(1868),
    [sym_compiler_directive_decl] = STATE(1868),
    [sym_fsi_directive_decl] = STATE(1868),
    [sym_preproc_line] = STATE(1868),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LBRACK_LT] = ACTIONS(4080),
    [anon_sym_COLON] = ACTIONS(4082),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_do] = ACTIONS(4082),
    [anon_sym_let] = ACTIONS(4082),
    [anon_sym_let_BANG] = ACTIONS(4080),
    [aux_sym_access_modifier_token1] = ACTIONS(4080),
    [anon_sym_LPAREN] = ACTIONS(4082),
    [anon_sym_COMMA] = ACTIONS(4080),
    [anon_sym_null] = ACTIONS(4082),
    [anon_sym_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_COLON] = ACTIONS(4080),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_LBRACK] = ACTIONS(4082),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(4082),
    [anon_sym_LT_AT] = ACTIONS(4082),
    [anon_sym_LT_AT_AT] = ACTIONS(4082),
    [anon_sym_DOT] = ACTIONS(4082),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4080),
    [anon_sym_new] = ACTIONS(4082),
    [anon_sym_with] = ACTIONS(4082),
    [anon_sym_return_BANG] = ACTIONS(4080),
    [anon_sym_yield] = ACTIONS(4082),
    [anon_sym_yield_BANG] = ACTIONS(4080),
    [anon_sym_lazy] = ACTIONS(4082),
    [anon_sym_assert] = ACTIONS(4082),
    [anon_sym_upcast] = ACTIONS(4082),
    [anon_sym_downcast] = ACTIONS(4082),
    [anon_sym_COLON_GT] = ACTIONS(4080),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4080),
    [anon_sym_for] = ACTIONS(4082),
    [anon_sym_while] = ACTIONS(4082),
    [anon_sym_if] = ACTIONS(4082),
    [anon_sym_fun] = ACTIONS(4082),
    [anon_sym_try] = ACTIONS(4082),
    [anon_sym_match] = ACTIONS(4082),
    [anon_sym_match_BANG] = ACTIONS(4080),
    [anon_sym_function] = ACTIONS(4082),
    [anon_sym_LT_DASH] = ACTIONS(4082),
    [anon_sym_DOT_LBRACK] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(4080),
    [anon_sym_use] = ACTIONS(4082),
    [anon_sym_use_BANG] = ACTIONS(4080),
    [anon_sym_do_BANG] = ACTIONS(4080),
    [anon_sym_begin] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4082),
    [anon_sym_default] = ACTIONS(4082),
    [anon_sym_or] = ACTIONS(4082),
    [anon_sym_static] = ACTIONS(4082),
    [anon_sym_member] = ACTIONS(4082),
    [anon_sym_interface] = ACTIONS(4082),
    [anon_sym_abstract] = ACTIONS(4082),
    [anon_sym_val] = ACTIONS(4082),
    [anon_sym_override] = ACTIONS(4082),
    [anon_sym_inherit] = ACTIONS(4082),
    [aux_sym_char_token1] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4082),
    [anon_sym_DQUOTE] = ACTIONS(4082),
    [anon_sym_AT_DQUOTE] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [sym_bool] = ACTIONS(4082),
    [sym_unit] = ACTIONS(4080),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4082),
    [sym_op_identifier] = ACTIONS(4082),
    [anon_sym_PLUS] = ACTIONS(4082),
    [anon_sym_DASH] = ACTIONS(4082),
    [anon_sym_PLUS_DOT] = ACTIONS(4082),
    [anon_sym_DASH_DOT] = ACTIONS(4082),
    [anon_sym_PERCENT] = ACTIONS(4082),
    [anon_sym_AMP_AMP] = ACTIONS(4082),
    [anon_sym_TILDE] = ACTIONS(4080),
    [aux_sym_prefix_op_token1] = ACTIONS(4082),
    [aux_sym_infix_op_token1] = ACTIONS(4080),
    [aux_sym_infix_op_token2] = ACTIONS(4082),
    [anon_sym_PIPE_PIPE] = ACTIONS(4082),
    [anon_sym_BANG_EQ] = ACTIONS(4082),
    [anon_sym_COLON_EQ] = ACTIONS(4080),
    [anon_sym_DOLLAR] = ACTIONS(4082),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4082),
    [sym_int] = ACTIONS(4082),
    [sym_xint] = ACTIONS(4080),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4080),
    [anon_sym_POUNDendif] = ACTIONS(4080),
    [anon_sym_POUNDelse] = ACTIONS(4080),
    [sym__newline] = ACTIONS(4080),
  },
  [1869] = {
    [sym_block_comment] = STATE(1869),
    [sym_compiler_directive_decl] = STATE(1869),
    [sym_fsi_directive_decl] = STATE(1869),
    [sym_preproc_line] = STATE(1869),
    [sym_identifier] = ACTIONS(4086),
    [anon_sym_EQ] = ACTIONS(4084),
    [anon_sym_LBRACK_LT] = ACTIONS(4084),
    [anon_sym_COLON] = ACTIONS(4086),
    [anon_sym_return] = ACTIONS(4086),
    [anon_sym_do] = ACTIONS(4086),
    [anon_sym_let] = ACTIONS(4086),
    [anon_sym_let_BANG] = ACTIONS(4084),
    [aux_sym_access_modifier_token1] = ACTIONS(4084),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_COMMA] = ACTIONS(4084),
    [anon_sym_null] = ACTIONS(4086),
    [anon_sym_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_COLON] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4084),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_LT_AT] = ACTIONS(4086),
    [anon_sym_LT_AT_AT] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4086),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4084),
    [anon_sym_new] = ACTIONS(4086),
    [anon_sym_with] = ACTIONS(4086),
    [anon_sym_return_BANG] = ACTIONS(4084),
    [anon_sym_yield] = ACTIONS(4086),
    [anon_sym_yield_BANG] = ACTIONS(4084),
    [anon_sym_lazy] = ACTIONS(4086),
    [anon_sym_assert] = ACTIONS(4086),
    [anon_sym_upcast] = ACTIONS(4086),
    [anon_sym_downcast] = ACTIONS(4086),
    [anon_sym_COLON_GT] = ACTIONS(4084),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4084),
    [anon_sym_for] = ACTIONS(4086),
    [anon_sym_while] = ACTIONS(4086),
    [anon_sym_if] = ACTIONS(4086),
    [anon_sym_fun] = ACTIONS(4086),
    [anon_sym_try] = ACTIONS(4086),
    [anon_sym_match] = ACTIONS(4086),
    [anon_sym_match_BANG] = ACTIONS(4084),
    [anon_sym_function] = ACTIONS(4086),
    [anon_sym_LT_DASH] = ACTIONS(4086),
    [anon_sym_DOT_LBRACK] = ACTIONS(4084),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_use] = ACTIONS(4086),
    [anon_sym_use_BANG] = ACTIONS(4084),
    [anon_sym_do_BANG] = ACTIONS(4084),
    [anon_sym_begin] = ACTIONS(4086),
    [anon_sym_LPAREN2] = ACTIONS(4086),
    [anon_sym_default] = ACTIONS(4086),
    [anon_sym_or] = ACTIONS(4086),
    [anon_sym_static] = ACTIONS(4086),
    [anon_sym_member] = ACTIONS(4086),
    [anon_sym_interface] = ACTIONS(4086),
    [anon_sym_abstract] = ACTIONS(4086),
    [anon_sym_val] = ACTIONS(4086),
    [anon_sym_override] = ACTIONS(4086),
    [anon_sym_inherit] = ACTIONS(4086),
    [aux_sym_char_token1] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4086),
    [anon_sym_DQUOTE] = ACTIONS(4086),
    [anon_sym_AT_DQUOTE] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [sym_bool] = ACTIONS(4086),
    [sym_unit] = ACTIONS(4084),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4086),
    [sym_op_identifier] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4086),
    [anon_sym_DASH] = ACTIONS(4086),
    [anon_sym_PLUS_DOT] = ACTIONS(4086),
    [anon_sym_DASH_DOT] = ACTIONS(4086),
    [anon_sym_PERCENT] = ACTIONS(4086),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_TILDE] = ACTIONS(4084),
    [aux_sym_prefix_op_token1] = ACTIONS(4086),
    [aux_sym_infix_op_token1] = ACTIONS(4084),
    [aux_sym_infix_op_token2] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_COLON_EQ] = ACTIONS(4084),
    [anon_sym_DOLLAR] = ACTIONS(4086),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4086),
    [sym_int] = ACTIONS(4086),
    [sym_xint] = ACTIONS(4084),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4084),
    [anon_sym_POUNDendif] = ACTIONS(4084),
    [anon_sym_POUNDelse] = ACTIONS(4084),
    [sym__newline] = ACTIONS(4084),
  },
  [1870] = {
    [sym_block_comment] = STATE(1870),
    [sym_compiler_directive_decl] = STATE(1870),
    [sym_fsi_directive_decl] = STATE(1870),
    [sym_preproc_line] = STATE(1870),
    [sym_identifier] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(4091),
    [anon_sym_LBRACK_LT] = ACTIONS(4091),
    [anon_sym_COLON] = ACTIONS(4093),
    [anon_sym_return] = ACTIONS(4093),
    [anon_sym_do] = ACTIONS(4093),
    [anon_sym_let] = ACTIONS(4093),
    [anon_sym_let_BANG] = ACTIONS(4091),
    [aux_sym_access_modifier_token1] = ACTIONS(4091),
    [anon_sym_LPAREN] = ACTIONS(4093),
    [anon_sym_COMMA] = ACTIONS(4091),
    [anon_sym_null] = ACTIONS(4093),
    [anon_sym_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_COLON] = ACTIONS(4091),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(4093),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4091),
    [anon_sym_LBRACE] = ACTIONS(4093),
    [anon_sym_LT_AT] = ACTIONS(4093),
    [anon_sym_LT_AT_AT] = ACTIONS(4093),
    [anon_sym_DOT] = ACTIONS(4093),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4091),
    [anon_sym_new] = ACTIONS(4093),
    [anon_sym_with] = ACTIONS(4093),
    [anon_sym_return_BANG] = ACTIONS(4091),
    [anon_sym_yield] = ACTIONS(4093),
    [anon_sym_yield_BANG] = ACTIONS(4091),
    [anon_sym_lazy] = ACTIONS(4093),
    [anon_sym_assert] = ACTIONS(4093),
    [anon_sym_upcast] = ACTIONS(4093),
    [anon_sym_downcast] = ACTIONS(4093),
    [anon_sym_COLON_GT] = ACTIONS(4091),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4091),
    [anon_sym_for] = ACTIONS(4093),
    [anon_sym_while] = ACTIONS(4093),
    [anon_sym_if] = ACTIONS(4093),
    [anon_sym_fun] = ACTIONS(4093),
    [anon_sym_try] = ACTIONS(4093),
    [anon_sym_match] = ACTIONS(4093),
    [anon_sym_match_BANG] = ACTIONS(4091),
    [anon_sym_function] = ACTIONS(4093),
    [anon_sym_LT_DASH] = ACTIONS(4093),
    [anon_sym_DOT_LBRACK] = ACTIONS(4091),
    [anon_sym_LT] = ACTIONS(4091),
    [anon_sym_use] = ACTIONS(4093),
    [anon_sym_use_BANG] = ACTIONS(4091),
    [anon_sym_do_BANG] = ACTIONS(4091),
    [anon_sym_begin] = ACTIONS(4093),
    [anon_sym_LPAREN2] = ACTIONS(4093),
    [anon_sym_default] = ACTIONS(4093),
    [anon_sym_or] = ACTIONS(4093),
    [anon_sym_static] = ACTIONS(4093),
    [anon_sym_member] = ACTIONS(4093),
    [anon_sym_interface] = ACTIONS(4093),
    [anon_sym_abstract] = ACTIONS(4093),
    [anon_sym_val] = ACTIONS(4093),
    [anon_sym_override] = ACTIONS(4093),
    [anon_sym_inherit] = ACTIONS(4093),
    [aux_sym_char_token1] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4093),
    [anon_sym_DQUOTE] = ACTIONS(4093),
    [anon_sym_AT_DQUOTE] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [sym_bool] = ACTIONS(4093),
    [sym_unit] = ACTIONS(4091),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4093),
    [sym_op_identifier] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS_DOT] = ACTIONS(4093),
    [anon_sym_DASH_DOT] = ACTIONS(4093),
    [anon_sym_PERCENT] = ACTIONS(4093),
    [anon_sym_AMP_AMP] = ACTIONS(4093),
    [anon_sym_TILDE] = ACTIONS(4091),
    [aux_sym_prefix_op_token1] = ACTIONS(4093),
    [aux_sym_infix_op_token1] = ACTIONS(4091),
    [aux_sym_infix_op_token2] = ACTIONS(4093),
    [anon_sym_PIPE_PIPE] = ACTIONS(4093),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_COLON_EQ] = ACTIONS(4091),
    [anon_sym_DOLLAR] = ACTIONS(4093),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4093),
    [sym_int] = ACTIONS(4093),
    [sym_xint] = ACTIONS(4091),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4091),
    [anon_sym_POUNDendif] = ACTIONS(4091),
    [anon_sym_POUNDelse] = ACTIONS(4091),
    [sym__newline] = ACTIONS(4091),
  },
  [1871] = {
    [sym_block_comment] = STATE(1871),
    [sym_compiler_directive_decl] = STATE(1871),
    [sym_fsi_directive_decl] = STATE(1871),
    [sym_preproc_line] = STATE(1871),
    [aux_sym_sequential_expression_repeat1] = STATE(1871),
    [sym_identifier] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3765),
    [anon_sym_LBRACK_LT] = ACTIONS(3765),
    [anon_sym_COLON] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_and] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_let_BANG] = ACTIONS(3765),
    [aux_sym_access_modifier_token1] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(3767),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_null] = ACTIONS(3767),
    [anon_sym_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3765),
    [anon_sym_LBRACE] = ACTIONS(3767),
    [anon_sym_LT_AT] = ACTIONS(3767),
    [anon_sym_LT_AT_AT] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3765),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_with] = ACTIONS(3767),
    [anon_sym_return_BANG] = ACTIONS(3765),
    [anon_sym_yield] = ACTIONS(3767),
    [anon_sym_yield_BANG] = ACTIONS(3765),
    [anon_sym_lazy] = ACTIONS(3767),
    [anon_sym_assert] = ACTIONS(3767),
    [anon_sym_upcast] = ACTIONS(3767),
    [anon_sym_downcast] = ACTIONS(3767),
    [anon_sym_COLON_GT] = ACTIONS(3765),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3765),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_fun] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_match] = ACTIONS(3767),
    [anon_sym_match_BANG] = ACTIONS(3765),
    [anon_sym_function] = ACTIONS(3767),
    [anon_sym_LT_DASH] = ACTIONS(3767),
    [anon_sym_DOT_LBRACK] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(3765),
    [anon_sym_use] = ACTIONS(3767),
    [anon_sym_use_BANG] = ACTIONS(3765),
    [anon_sym_do_BANG] = ACTIONS(3765),
    [anon_sym_begin] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3767),
    [anon_sym_default] = ACTIONS(3767),
    [anon_sym_or] = ACTIONS(3767),
    [anon_sym_static] = ACTIONS(3767),
    [anon_sym_member] = ACTIONS(3767),
    [anon_sym_interface] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(3767),
    [anon_sym_val] = ACTIONS(3767),
    [anon_sym_override] = ACTIONS(3767),
    [aux_sym_char_token1] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3767),
    [anon_sym_DQUOTE] = ACTIONS(3767),
    [anon_sym_AT_DQUOTE] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [sym_bool] = ACTIONS(3767),
    [sym_unit] = ACTIONS(3765),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3767),
    [sym_op_identifier] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_PLUS_DOT] = ACTIONS(3767),
    [anon_sym_DASH_DOT] = ACTIONS(3767),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_AMP_AMP] = ACTIONS(3767),
    [anon_sym_TILDE] = ACTIONS(3765),
    [aux_sym_prefix_op_token1] = ACTIONS(3767),
    [aux_sym_infix_op_token1] = ACTIONS(3765),
    [aux_sym_infix_op_token2] = ACTIONS(3767),
    [anon_sym_PIPE_PIPE] = ACTIONS(3767),
    [anon_sym_BANG_EQ] = ACTIONS(3767),
    [anon_sym_COLON_EQ] = ACTIONS(3765),
    [anon_sym_DOLLAR] = ACTIONS(3767),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3767),
    [sym_int] = ACTIONS(3767),
    [sym_xint] = ACTIONS(3765),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3765),
    [anon_sym_POUNDendif] = ACTIONS(3765),
    [sym__newline] = ACTIONS(4726),
  },
  [1872] = {
    [sym_block_comment] = STATE(1872),
    [sym_compiler_directive_decl] = STATE(1872),
    [sym_fsi_directive_decl] = STATE(1872),
    [sym_preproc_line] = STATE(1872),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_LBRACK_LT] = ACTIONS(3865),
    [anon_sym_COLON] = ACTIONS(3867),
    [anon_sym_return] = ACTIONS(3867),
    [anon_sym_do] = ACTIONS(3867),
    [anon_sym_let] = ACTIONS(3867),
    [anon_sym_let_BANG] = ACTIONS(3865),
    [aux_sym_access_modifier_token1] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(3867),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_null] = ACTIONS(3867),
    [anon_sym_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_COLON] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3867),
    [anon_sym_LBRACK] = ACTIONS(3867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3867),
    [anon_sym_LT_AT] = ACTIONS(3867),
    [anon_sym_LT_AT_AT] = ACTIONS(3867),
    [anon_sym_DOT] = ACTIONS(3867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3867),
    [anon_sym_with] = ACTIONS(3867),
    [anon_sym_return_BANG] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3867),
    [anon_sym_yield_BANG] = ACTIONS(3865),
    [anon_sym_lazy] = ACTIONS(3867),
    [anon_sym_assert] = ACTIONS(3867),
    [anon_sym_upcast] = ACTIONS(3867),
    [anon_sym_downcast] = ACTIONS(3867),
    [anon_sym_COLON_GT] = ACTIONS(3865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3867),
    [anon_sym_while] = ACTIONS(3867),
    [anon_sym_if] = ACTIONS(3867),
    [anon_sym_fun] = ACTIONS(3867),
    [anon_sym_try] = ACTIONS(3867),
    [anon_sym_match] = ACTIONS(3867),
    [anon_sym_match_BANG] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(3867),
    [anon_sym_DOT_LBRACK] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_use] = ACTIONS(3867),
    [anon_sym_use_BANG] = ACTIONS(3865),
    [anon_sym_do_BANG] = ACTIONS(3865),
    [anon_sym_begin] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(3867),
    [anon_sym_default] = ACTIONS(3867),
    [anon_sym_or] = ACTIONS(3867),
    [anon_sym_static] = ACTIONS(3867),
    [anon_sym_member] = ACTIONS(3867),
    [anon_sym_interface] = ACTIONS(3867),
    [anon_sym_abstract] = ACTIONS(3867),
    [anon_sym_val] = ACTIONS(3867),
    [anon_sym_override] = ACTIONS(3867),
    [anon_sym_inherit] = ACTIONS(3867),
    [aux_sym_char_token1] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3867),
    [anon_sym_DQUOTE] = ACTIONS(3867),
    [anon_sym_AT_DQUOTE] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [sym_bool] = ACTIONS(3867),
    [sym_unit] = ACTIONS(3865),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3867),
    [sym_op_identifier] = ACTIONS(3867),
    [anon_sym_PLUS] = ACTIONS(3867),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_PLUS_DOT] = ACTIONS(3867),
    [anon_sym_DASH_DOT] = ACTIONS(3867),
    [anon_sym_PERCENT] = ACTIONS(3867),
    [anon_sym_AMP_AMP] = ACTIONS(3867),
    [anon_sym_TILDE] = ACTIONS(3865),
    [aux_sym_prefix_op_token1] = ACTIONS(3867),
    [aux_sym_infix_op_token1] = ACTIONS(3865),
    [aux_sym_infix_op_token2] = ACTIONS(3867),
    [anon_sym_PIPE_PIPE] = ACTIONS(3867),
    [anon_sym_BANG_EQ] = ACTIONS(3867),
    [anon_sym_COLON_EQ] = ACTIONS(3865),
    [anon_sym_DOLLAR] = ACTIONS(3867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3867),
    [sym_int] = ACTIONS(3867),
    [sym_xint] = ACTIONS(3865),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3865),
    [anon_sym_POUNDendif] = ACTIONS(3865),
    [anon_sym_POUNDelse] = ACTIONS(3865),
    [sym__newline] = ACTIONS(3865),
  },
  [1873] = {
    [sym_block_comment] = STATE(1873),
    [sym_compiler_directive_decl] = STATE(1873),
    [sym_fsi_directive_decl] = STATE(1873),
    [sym_preproc_line] = STATE(1873),
    [sym_identifier] = ACTIONS(4108),
    [anon_sym_EQ] = ACTIONS(4106),
    [anon_sym_LBRACK_LT] = ACTIONS(4106),
    [anon_sym_COLON] = ACTIONS(4108),
    [anon_sym_return] = ACTIONS(4108),
    [anon_sym_do] = ACTIONS(4108),
    [anon_sym_let] = ACTIONS(4108),
    [anon_sym_let_BANG] = ACTIONS(4106),
    [aux_sym_access_modifier_token1] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(4108),
    [anon_sym_COMMA] = ACTIONS(4106),
    [anon_sym_null] = ACTIONS(4108),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_COLON] = ACTIONS(4106),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LBRACK] = ACTIONS(4108),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(4108),
    [anon_sym_LT_AT] = ACTIONS(4108),
    [anon_sym_LT_AT_AT] = ACTIONS(4108),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4106),
    [anon_sym_new] = ACTIONS(4108),
    [anon_sym_with] = ACTIONS(4108),
    [anon_sym_return_BANG] = ACTIONS(4106),
    [anon_sym_yield] = ACTIONS(4108),
    [anon_sym_yield_BANG] = ACTIONS(4106),
    [anon_sym_lazy] = ACTIONS(4108),
    [anon_sym_assert] = ACTIONS(4108),
    [anon_sym_upcast] = ACTIONS(4108),
    [anon_sym_downcast] = ACTIONS(4108),
    [anon_sym_COLON_GT] = ACTIONS(4106),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4106),
    [anon_sym_for] = ACTIONS(4108),
    [anon_sym_while] = ACTIONS(4108),
    [anon_sym_if] = ACTIONS(4108),
    [anon_sym_fun] = ACTIONS(4108),
    [anon_sym_try] = ACTIONS(4108),
    [anon_sym_match] = ACTIONS(4108),
    [anon_sym_match_BANG] = ACTIONS(4106),
    [anon_sym_function] = ACTIONS(4108),
    [anon_sym_LT_DASH] = ACTIONS(4108),
    [anon_sym_DOT_LBRACK] = ACTIONS(4106),
    [anon_sym_LT] = ACTIONS(4106),
    [anon_sym_use] = ACTIONS(4108),
    [anon_sym_use_BANG] = ACTIONS(4106),
    [anon_sym_do_BANG] = ACTIONS(4106),
    [anon_sym_begin] = ACTIONS(4108),
    [anon_sym_LPAREN2] = ACTIONS(4108),
    [anon_sym_default] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [anon_sym_static] = ACTIONS(4108),
    [anon_sym_member] = ACTIONS(4108),
    [anon_sym_interface] = ACTIONS(4108),
    [anon_sym_abstract] = ACTIONS(4108),
    [anon_sym_val] = ACTIONS(4108),
    [anon_sym_override] = ACTIONS(4108),
    [anon_sym_inherit] = ACTIONS(4108),
    [aux_sym_char_token1] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4108),
    [anon_sym_DQUOTE] = ACTIONS(4108),
    [anon_sym_AT_DQUOTE] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [sym_bool] = ACTIONS(4108),
    [sym_unit] = ACTIONS(4106),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4108),
    [sym_op_identifier] = ACTIONS(4108),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_PLUS_DOT] = ACTIONS(4108),
    [anon_sym_DASH_DOT] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_AMP_AMP] = ACTIONS(4108),
    [anon_sym_TILDE] = ACTIONS(4106),
    [aux_sym_prefix_op_token1] = ACTIONS(4108),
    [aux_sym_infix_op_token1] = ACTIONS(4106),
    [aux_sym_infix_op_token2] = ACTIONS(4108),
    [anon_sym_PIPE_PIPE] = ACTIONS(4108),
    [anon_sym_BANG_EQ] = ACTIONS(4108),
    [anon_sym_COLON_EQ] = ACTIONS(4106),
    [anon_sym_DOLLAR] = ACTIONS(4108),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4108),
    [sym_int] = ACTIONS(4108),
    [sym_xint] = ACTIONS(4106),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4106),
    [anon_sym_POUNDendif] = ACTIONS(4106),
    [anon_sym_POUNDelse] = ACTIONS(4106),
    [sym__newline] = ACTIONS(4106),
  },
  [1874] = {
    [sym_block_comment] = STATE(1874),
    [sym_compiler_directive_decl] = STATE(1874),
    [sym_fsi_directive_decl] = STATE(1874),
    [sym_preproc_line] = STATE(1874),
    [aux_sym_long_identifier_repeat1] = STATE(1685),
    [sym_identifier] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3778),
    [anon_sym_LBRACK_LT] = ACTIONS(3778),
    [anon_sym_COLON] = ACTIONS(3781),
    [anon_sym_return] = ACTIONS(3781),
    [anon_sym_do] = ACTIONS(3781),
    [anon_sym_let] = ACTIONS(3781),
    [anon_sym_let_BANG] = ACTIONS(3778),
    [aux_sym_access_modifier_token1] = ACTIONS(3778),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3778),
    [anon_sym_null] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3781),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_LT_AT] = ACTIONS(3781),
    [anon_sym_LT_AT_AT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(4729),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3778),
    [anon_sym_new] = ACTIONS(3781),
    [anon_sym_with] = ACTIONS(3781),
    [anon_sym_return_BANG] = ACTIONS(3778),
    [anon_sym_yield] = ACTIONS(3781),
    [anon_sym_yield_BANG] = ACTIONS(3778),
    [anon_sym_lazy] = ACTIONS(3781),
    [anon_sym_assert] = ACTIONS(3781),
    [anon_sym_upcast] = ACTIONS(3781),
    [anon_sym_downcast] = ACTIONS(3781),
    [anon_sym_COLON_GT] = ACTIONS(3778),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3778),
    [anon_sym_for] = ACTIONS(3781),
    [anon_sym_while] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_fun] = ACTIONS(3781),
    [anon_sym_try] = ACTIONS(3781),
    [anon_sym_match] = ACTIONS(3781),
    [anon_sym_match_BANG] = ACTIONS(3778),
    [anon_sym_function] = ACTIONS(3781),
    [anon_sym_LT_DASH] = ACTIONS(3781),
    [anon_sym_DOT_LBRACK] = ACTIONS(3778),
    [anon_sym_LT] = ACTIONS(3778),
    [anon_sym_use] = ACTIONS(3781),
    [anon_sym_use_BANG] = ACTIONS(3778),
    [anon_sym_do_BANG] = ACTIONS(3778),
    [anon_sym_begin] = ACTIONS(3781),
    [anon_sym_LPAREN2] = ACTIONS(3781),
    [anon_sym_DOT_DOT2] = ACTIONS(3778),
    [anon_sym_default] = ACTIONS(3781),
    [anon_sym_or] = ACTIONS(3781),
    [anon_sym_static] = ACTIONS(3781),
    [anon_sym_member] = ACTIONS(3781),
    [anon_sym_interface] = ACTIONS(3781),
    [anon_sym_abstract] = ACTIONS(3781),
    [anon_sym_val] = ACTIONS(3781),
    [anon_sym_override] = ACTIONS(3781),
    [aux_sym_char_token1] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3781),
    [anon_sym_DQUOTE] = ACTIONS(3781),
    [anon_sym_AT_DQUOTE] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [sym_bool] = ACTIONS(3781),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3781),
    [sym_op_identifier] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3781),
    [anon_sym_DASH] = ACTIONS(3781),
    [anon_sym_PLUS_DOT] = ACTIONS(3781),
    [anon_sym_DASH_DOT] = ACTIONS(3781),
    [anon_sym_PERCENT] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3781),
    [anon_sym_TILDE] = ACTIONS(3778),
    [aux_sym_prefix_op_token1] = ACTIONS(3781),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token2] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_COLON_EQ] = ACTIONS(3778),
    [anon_sym_DOLLAR] = ACTIONS(3781),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3781),
    [sym_int] = ACTIONS(3781),
    [sym_xint] = ACTIONS(3778),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3778),
    [sym__newline] = ACTIONS(3778),
    [sym__dedent] = ACTIONS(3778),
  },
  [1875] = {
    [sym_block_comment] = STATE(1875),
    [sym_compiler_directive_decl] = STATE(1875),
    [sym_fsi_directive_decl] = STATE(1875),
    [sym_preproc_line] = STATE(1875),
    [sym_identifier] = ACTIONS(3976),
    [anon_sym_EQ] = ACTIONS(3974),
    [anon_sym_LBRACK_LT] = ACTIONS(3974),
    [anon_sym_COLON] = ACTIONS(3976),
    [anon_sym_return] = ACTIONS(3976),
    [anon_sym_do] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_let_BANG] = ACTIONS(3974),
    [aux_sym_access_modifier_token1] = ACTIONS(3974),
    [anon_sym_LPAREN] = ACTIONS(3976),
    [anon_sym_COMMA] = ACTIONS(3974),
    [anon_sym_null] = ACTIONS(3976),
    [anon_sym_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_COLON] = ACTIONS(3974),
    [anon_sym_AMP] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(3976),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3974),
    [anon_sym_LBRACE] = ACTIONS(3976),
    [anon_sym_LT_AT] = ACTIONS(3976),
    [anon_sym_LT_AT_AT] = ACTIONS(3976),
    [anon_sym_DOT] = ACTIONS(3976),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3974),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_with] = ACTIONS(3976),
    [anon_sym_return_BANG] = ACTIONS(3974),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_yield_BANG] = ACTIONS(3974),
    [anon_sym_lazy] = ACTIONS(3976),
    [anon_sym_assert] = ACTIONS(3976),
    [anon_sym_upcast] = ACTIONS(3976),
    [anon_sym_downcast] = ACTIONS(3976),
    [anon_sym_COLON_GT] = ACTIONS(3974),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3974),
    [anon_sym_for] = ACTIONS(3976),
    [anon_sym_while] = ACTIONS(3976),
    [anon_sym_if] = ACTIONS(3976),
    [anon_sym_fun] = ACTIONS(3976),
    [anon_sym_try] = ACTIONS(3976),
    [anon_sym_match] = ACTIONS(3976),
    [anon_sym_match_BANG] = ACTIONS(3974),
    [anon_sym_function] = ACTIONS(3976),
    [anon_sym_LT_DASH] = ACTIONS(3976),
    [anon_sym_DOT_LBRACK] = ACTIONS(3974),
    [anon_sym_LT] = ACTIONS(3974),
    [anon_sym_use] = ACTIONS(3976),
    [anon_sym_use_BANG] = ACTIONS(3974),
    [anon_sym_do_BANG] = ACTIONS(3974),
    [anon_sym_begin] = ACTIONS(3976),
    [anon_sym_LPAREN2] = ACTIONS(3976),
    [anon_sym_default] = ACTIONS(3976),
    [anon_sym_or] = ACTIONS(3976),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_member] = ACTIONS(3976),
    [anon_sym_interface] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_val] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [anon_sym_inherit] = ACTIONS(3976),
    [aux_sym_char_token1] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3976),
    [anon_sym_DQUOTE] = ACTIONS(3976),
    [anon_sym_AT_DQUOTE] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [sym_bool] = ACTIONS(3976),
    [sym_unit] = ACTIONS(3974),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3976),
    [sym_op_identifier] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3976),
    [anon_sym_DASH] = ACTIONS(3976),
    [anon_sym_PLUS_DOT] = ACTIONS(3976),
    [anon_sym_DASH_DOT] = ACTIONS(3976),
    [anon_sym_PERCENT] = ACTIONS(3976),
    [anon_sym_AMP_AMP] = ACTIONS(3976),
    [anon_sym_TILDE] = ACTIONS(3974),
    [aux_sym_prefix_op_token1] = ACTIONS(3976),
    [aux_sym_infix_op_token1] = ACTIONS(3974),
    [aux_sym_infix_op_token2] = ACTIONS(3976),
    [anon_sym_PIPE_PIPE] = ACTIONS(3976),
    [anon_sym_BANG_EQ] = ACTIONS(3976),
    [anon_sym_COLON_EQ] = ACTIONS(3974),
    [anon_sym_DOLLAR] = ACTIONS(3976),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3976),
    [sym_int] = ACTIONS(3976),
    [sym_xint] = ACTIONS(3974),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3974),
    [anon_sym_POUNDendif] = ACTIONS(3974),
    [anon_sym_POUNDelse] = ACTIONS(3974),
    [sym__newline] = ACTIONS(3974),
  },
  [1876] = {
    [sym_block_comment] = STATE(1876),
    [sym_compiler_directive_decl] = STATE(1876),
    [sym_fsi_directive_decl] = STATE(1876),
    [sym_preproc_line] = STATE(1876),
    [sym_identifier] = ACTIONS(4064),
    [anon_sym_EQ] = ACTIONS(4062),
    [anon_sym_LBRACK_LT] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4064),
    [anon_sym_return] = ACTIONS(4064),
    [anon_sym_do] = ACTIONS(4064),
    [anon_sym_let] = ACTIONS(4064),
    [anon_sym_let_BANG] = ACTIONS(4062),
    [aux_sym_access_modifier_token1] = ACTIONS(4062),
    [anon_sym_LPAREN] = ACTIONS(4064),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_null] = ACTIONS(4064),
    [anon_sym_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_COLON] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4062),
    [anon_sym_LBRACE] = ACTIONS(4064),
    [anon_sym_LT_AT] = ACTIONS(4064),
    [anon_sym_LT_AT_AT] = ACTIONS(4064),
    [anon_sym_DOT] = ACTIONS(4064),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4062),
    [anon_sym_new] = ACTIONS(4064),
    [anon_sym_with] = ACTIONS(4064),
    [anon_sym_return_BANG] = ACTIONS(4062),
    [anon_sym_yield] = ACTIONS(4064),
    [anon_sym_yield_BANG] = ACTIONS(4062),
    [anon_sym_lazy] = ACTIONS(4064),
    [anon_sym_assert] = ACTIONS(4064),
    [anon_sym_upcast] = ACTIONS(4064),
    [anon_sym_downcast] = ACTIONS(4064),
    [anon_sym_COLON_GT] = ACTIONS(4062),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4062),
    [anon_sym_for] = ACTIONS(4064),
    [anon_sym_while] = ACTIONS(4064),
    [anon_sym_if] = ACTIONS(4064),
    [anon_sym_fun] = ACTIONS(4064),
    [anon_sym_try] = ACTIONS(4064),
    [anon_sym_match] = ACTIONS(4064),
    [anon_sym_match_BANG] = ACTIONS(4062),
    [anon_sym_function] = ACTIONS(4064),
    [anon_sym_LT_DASH] = ACTIONS(4064),
    [anon_sym_DOT_LBRACK] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(4062),
    [anon_sym_use] = ACTIONS(4064),
    [anon_sym_use_BANG] = ACTIONS(4062),
    [anon_sym_do_BANG] = ACTIONS(4062),
    [anon_sym_begin] = ACTIONS(4064),
    [anon_sym_LPAREN2] = ACTIONS(4064),
    [anon_sym_default] = ACTIONS(4064),
    [anon_sym_or] = ACTIONS(4064),
    [anon_sym_static] = ACTIONS(4064),
    [anon_sym_member] = ACTIONS(4064),
    [anon_sym_interface] = ACTIONS(4064),
    [anon_sym_abstract] = ACTIONS(4064),
    [anon_sym_val] = ACTIONS(4064),
    [anon_sym_override] = ACTIONS(4064),
    [anon_sym_inherit] = ACTIONS(4064),
    [aux_sym_char_token1] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_AT_DQUOTE] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [sym_bool] = ACTIONS(4064),
    [sym_unit] = ACTIONS(4062),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4064),
    [sym_op_identifier] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4064),
    [anon_sym_DASH] = ACTIONS(4064),
    [anon_sym_PLUS_DOT] = ACTIONS(4064),
    [anon_sym_DASH_DOT] = ACTIONS(4064),
    [anon_sym_PERCENT] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_TILDE] = ACTIONS(4062),
    [aux_sym_prefix_op_token1] = ACTIONS(4064),
    [aux_sym_infix_op_token1] = ACTIONS(4062),
    [aux_sym_infix_op_token2] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_BANG_EQ] = ACTIONS(4064),
    [anon_sym_COLON_EQ] = ACTIONS(4062),
    [anon_sym_DOLLAR] = ACTIONS(4064),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4064),
    [sym_int] = ACTIONS(4064),
    [sym_xint] = ACTIONS(4062),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4062),
    [anon_sym_POUNDendif] = ACTIONS(4062),
    [anon_sym_POUNDelse] = ACTIONS(4062),
    [sym__newline] = ACTIONS(4062),
  },
  [1877] = {
    [sym_block_comment] = STATE(1877),
    [sym_compiler_directive_decl] = STATE(1877),
    [sym_fsi_directive_decl] = STATE(1877),
    [sym_preproc_line] = STATE(1877),
    [sym_identifier] = ACTIONS(4112),
    [anon_sym_EQ] = ACTIONS(4110),
    [anon_sym_LBRACK_LT] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4112),
    [anon_sym_return] = ACTIONS(4112),
    [anon_sym_do] = ACTIONS(4112),
    [anon_sym_let] = ACTIONS(4112),
    [anon_sym_let_BANG] = ACTIONS(4110),
    [aux_sym_access_modifier_token1] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_null] = ACTIONS(4112),
    [anon_sym_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_COLON] = ACTIONS(4110),
    [anon_sym_AMP] = ACTIONS(4112),
    [anon_sym_LBRACK] = ACTIONS(4112),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4110),
    [anon_sym_LBRACE] = ACTIONS(4112),
    [anon_sym_LT_AT] = ACTIONS(4112),
    [anon_sym_LT_AT_AT] = ACTIONS(4112),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4110),
    [anon_sym_new] = ACTIONS(4112),
    [anon_sym_with] = ACTIONS(4112),
    [anon_sym_return_BANG] = ACTIONS(4110),
    [anon_sym_yield] = ACTIONS(4112),
    [anon_sym_yield_BANG] = ACTIONS(4110),
    [anon_sym_lazy] = ACTIONS(4112),
    [anon_sym_assert] = ACTIONS(4112),
    [anon_sym_upcast] = ACTIONS(4112),
    [anon_sym_downcast] = ACTIONS(4112),
    [anon_sym_COLON_GT] = ACTIONS(4110),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4110),
    [anon_sym_for] = ACTIONS(4112),
    [anon_sym_while] = ACTIONS(4112),
    [anon_sym_if] = ACTIONS(4112),
    [anon_sym_fun] = ACTIONS(4112),
    [anon_sym_try] = ACTIONS(4112),
    [anon_sym_match] = ACTIONS(4112),
    [anon_sym_match_BANG] = ACTIONS(4110),
    [anon_sym_function] = ACTIONS(4112),
    [anon_sym_LT_DASH] = ACTIONS(4112),
    [anon_sym_DOT_LBRACK] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(4110),
    [anon_sym_use] = ACTIONS(4112),
    [anon_sym_use_BANG] = ACTIONS(4110),
    [anon_sym_do_BANG] = ACTIONS(4110),
    [anon_sym_begin] = ACTIONS(4112),
    [anon_sym_LPAREN2] = ACTIONS(4112),
    [anon_sym_default] = ACTIONS(4112),
    [anon_sym_or] = ACTIONS(4112),
    [anon_sym_static] = ACTIONS(4112),
    [anon_sym_member] = ACTIONS(4112),
    [anon_sym_interface] = ACTIONS(4112),
    [anon_sym_abstract] = ACTIONS(4112),
    [anon_sym_val] = ACTIONS(4112),
    [anon_sym_override] = ACTIONS(4112),
    [anon_sym_inherit] = ACTIONS(4112),
    [aux_sym_char_token1] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4112),
    [anon_sym_DQUOTE] = ACTIONS(4112),
    [anon_sym_AT_DQUOTE] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [sym_bool] = ACTIONS(4112),
    [sym_unit] = ACTIONS(4110),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4112),
    [sym_op_identifier] = ACTIONS(4112),
    [anon_sym_PLUS] = ACTIONS(4112),
    [anon_sym_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_DOT] = ACTIONS(4112),
    [anon_sym_DASH_DOT] = ACTIONS(4112),
    [anon_sym_PERCENT] = ACTIONS(4112),
    [anon_sym_AMP_AMP] = ACTIONS(4112),
    [anon_sym_TILDE] = ACTIONS(4110),
    [aux_sym_prefix_op_token1] = ACTIONS(4112),
    [aux_sym_infix_op_token1] = ACTIONS(4110),
    [aux_sym_infix_op_token2] = ACTIONS(4112),
    [anon_sym_PIPE_PIPE] = ACTIONS(4112),
    [anon_sym_BANG_EQ] = ACTIONS(4112),
    [anon_sym_COLON_EQ] = ACTIONS(4110),
    [anon_sym_DOLLAR] = ACTIONS(4112),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4112),
    [sym_int] = ACTIONS(4112),
    [sym_xint] = ACTIONS(4110),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4110),
    [anon_sym_POUNDendif] = ACTIONS(4110),
    [anon_sym_POUNDelse] = ACTIONS(4110),
    [sym__newline] = ACTIONS(4110),
  },
  [1878] = {
    [sym_block_comment] = STATE(1878),
    [sym_compiler_directive_decl] = STATE(1878),
    [sym_fsi_directive_decl] = STATE(1878),
    [sym_preproc_line] = STATE(1878),
    [sym_identifier] = ACTIONS(4118),
    [anon_sym_EQ] = ACTIONS(4116),
    [anon_sym_LBRACK_LT] = ACTIONS(4116),
    [anon_sym_COLON] = ACTIONS(4118),
    [anon_sym_return] = ACTIONS(4118),
    [anon_sym_do] = ACTIONS(4118),
    [anon_sym_let] = ACTIONS(4118),
    [anon_sym_let_BANG] = ACTIONS(4116),
    [aux_sym_access_modifier_token1] = ACTIONS(4116),
    [anon_sym_LPAREN] = ACTIONS(4118),
    [anon_sym_COMMA] = ACTIONS(4116),
    [anon_sym_null] = ACTIONS(4118),
    [anon_sym_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_COLON] = ACTIONS(4116),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4118),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(4118),
    [anon_sym_LT_AT] = ACTIONS(4118),
    [anon_sym_LT_AT_AT] = ACTIONS(4118),
    [anon_sym_DOT] = ACTIONS(4118),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4116),
    [anon_sym_new] = ACTIONS(4118),
    [anon_sym_with] = ACTIONS(4118),
    [anon_sym_return_BANG] = ACTIONS(4116),
    [anon_sym_yield] = ACTIONS(4118),
    [anon_sym_yield_BANG] = ACTIONS(4116),
    [anon_sym_lazy] = ACTIONS(4118),
    [anon_sym_assert] = ACTIONS(4118),
    [anon_sym_upcast] = ACTIONS(4118),
    [anon_sym_downcast] = ACTIONS(4118),
    [anon_sym_COLON_GT] = ACTIONS(4116),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4116),
    [anon_sym_for] = ACTIONS(4118),
    [anon_sym_while] = ACTIONS(4118),
    [anon_sym_if] = ACTIONS(4118),
    [anon_sym_fun] = ACTIONS(4118),
    [anon_sym_try] = ACTIONS(4118),
    [anon_sym_match] = ACTIONS(4118),
    [anon_sym_match_BANG] = ACTIONS(4116),
    [anon_sym_function] = ACTIONS(4118),
    [anon_sym_LT_DASH] = ACTIONS(4118),
    [anon_sym_DOT_LBRACK] = ACTIONS(4116),
    [anon_sym_LT] = ACTIONS(4116),
    [anon_sym_use] = ACTIONS(4118),
    [anon_sym_use_BANG] = ACTIONS(4116),
    [anon_sym_do_BANG] = ACTIONS(4116),
    [anon_sym_begin] = ACTIONS(4118),
    [anon_sym_LPAREN2] = ACTIONS(4118),
    [anon_sym_default] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [anon_sym_static] = ACTIONS(4118),
    [anon_sym_member] = ACTIONS(4118),
    [anon_sym_interface] = ACTIONS(4118),
    [anon_sym_abstract] = ACTIONS(4118),
    [anon_sym_val] = ACTIONS(4118),
    [anon_sym_override] = ACTIONS(4118),
    [anon_sym_inherit] = ACTIONS(4118),
    [aux_sym_char_token1] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4118),
    [anon_sym_DQUOTE] = ACTIONS(4118),
    [anon_sym_AT_DQUOTE] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [sym_bool] = ACTIONS(4118),
    [sym_unit] = ACTIONS(4116),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4118),
    [sym_op_identifier] = ACTIONS(4118),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_PLUS_DOT] = ACTIONS(4118),
    [anon_sym_DASH_DOT] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_AMP_AMP] = ACTIONS(4118),
    [anon_sym_TILDE] = ACTIONS(4116),
    [aux_sym_prefix_op_token1] = ACTIONS(4118),
    [aux_sym_infix_op_token1] = ACTIONS(4116),
    [aux_sym_infix_op_token2] = ACTIONS(4118),
    [anon_sym_PIPE_PIPE] = ACTIONS(4118),
    [anon_sym_BANG_EQ] = ACTIONS(4118),
    [anon_sym_COLON_EQ] = ACTIONS(4116),
    [anon_sym_DOLLAR] = ACTIONS(4118),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4118),
    [sym_int] = ACTIONS(4118),
    [sym_xint] = ACTIONS(4116),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4116),
    [anon_sym_POUNDendif] = ACTIONS(4116),
    [anon_sym_POUNDelse] = ACTIONS(4116),
    [sym__newline] = ACTIONS(4116),
  },
  [1879] = {
    [sym_block_comment] = STATE(1879),
    [sym_compiler_directive_decl] = STATE(1879),
    [sym_fsi_directive_decl] = STATE(1879),
    [sym_preproc_line] = STATE(1879),
    [sym_identifier] = ACTIONS(4126),
    [anon_sym_EQ] = ACTIONS(4124),
    [anon_sym_LBRACK_LT] = ACTIONS(4124),
    [anon_sym_COLON] = ACTIONS(4126),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_do] = ACTIONS(4126),
    [anon_sym_let] = ACTIONS(4126),
    [anon_sym_let_BANG] = ACTIONS(4124),
    [aux_sym_access_modifier_token1] = ACTIONS(4124),
    [anon_sym_LPAREN] = ACTIONS(4126),
    [anon_sym_COMMA] = ACTIONS(4124),
    [anon_sym_null] = ACTIONS(4126),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_COLON] = ACTIONS(4124),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LBRACK] = ACTIONS(4126),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4126),
    [anon_sym_LT_AT] = ACTIONS(4126),
    [anon_sym_LT_AT_AT] = ACTIONS(4126),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4124),
    [anon_sym_new] = ACTIONS(4126),
    [anon_sym_with] = ACTIONS(4126),
    [anon_sym_return_BANG] = ACTIONS(4124),
    [anon_sym_yield] = ACTIONS(4126),
    [anon_sym_yield_BANG] = ACTIONS(4124),
    [anon_sym_lazy] = ACTIONS(4126),
    [anon_sym_assert] = ACTIONS(4126),
    [anon_sym_upcast] = ACTIONS(4126),
    [anon_sym_downcast] = ACTIONS(4126),
    [anon_sym_COLON_GT] = ACTIONS(4124),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4124),
    [anon_sym_for] = ACTIONS(4126),
    [anon_sym_while] = ACTIONS(4126),
    [anon_sym_if] = ACTIONS(4126),
    [anon_sym_fun] = ACTIONS(4126),
    [anon_sym_try] = ACTIONS(4126),
    [anon_sym_match] = ACTIONS(4126),
    [anon_sym_match_BANG] = ACTIONS(4124),
    [anon_sym_function] = ACTIONS(4126),
    [anon_sym_LT_DASH] = ACTIONS(4126),
    [anon_sym_DOT_LBRACK] = ACTIONS(4124),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_use] = ACTIONS(4126),
    [anon_sym_use_BANG] = ACTIONS(4124),
    [anon_sym_do_BANG] = ACTIONS(4124),
    [anon_sym_begin] = ACTIONS(4126),
    [anon_sym_LPAREN2] = ACTIONS(4126),
    [anon_sym_default] = ACTIONS(4126),
    [anon_sym_or] = ACTIONS(4126),
    [anon_sym_static] = ACTIONS(4126),
    [anon_sym_member] = ACTIONS(4126),
    [anon_sym_interface] = ACTIONS(4126),
    [anon_sym_abstract] = ACTIONS(4126),
    [anon_sym_val] = ACTIONS(4126),
    [anon_sym_override] = ACTIONS(4126),
    [anon_sym_inherit] = ACTIONS(4126),
    [aux_sym_char_token1] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4126),
    [anon_sym_DQUOTE] = ACTIONS(4126),
    [anon_sym_AT_DQUOTE] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [sym_bool] = ACTIONS(4126),
    [sym_unit] = ACTIONS(4124),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4126),
    [sym_op_identifier] = ACTIONS(4126),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_PLUS_DOT] = ACTIONS(4126),
    [anon_sym_DASH_DOT] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_AMP_AMP] = ACTIONS(4126),
    [anon_sym_TILDE] = ACTIONS(4124),
    [aux_sym_prefix_op_token1] = ACTIONS(4126),
    [aux_sym_infix_op_token1] = ACTIONS(4124),
    [aux_sym_infix_op_token2] = ACTIONS(4126),
    [anon_sym_PIPE_PIPE] = ACTIONS(4126),
    [anon_sym_BANG_EQ] = ACTIONS(4126),
    [anon_sym_COLON_EQ] = ACTIONS(4124),
    [anon_sym_DOLLAR] = ACTIONS(4126),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4126),
    [sym_int] = ACTIONS(4126),
    [sym_xint] = ACTIONS(4124),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4124),
    [anon_sym_POUNDendif] = ACTIONS(4124),
    [anon_sym_POUNDelse] = ACTIONS(4124),
    [sym__newline] = ACTIONS(4124),
  },
  [1880] = {
    [sym_block_comment] = STATE(1880),
    [sym_compiler_directive_decl] = STATE(1880),
    [sym_fsi_directive_decl] = STATE(1880),
    [sym_preproc_line] = STATE(1880),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3843),
    [anon_sym_LBRACK_LT] = ACTIONS(3843),
    [anon_sym_COLON] = ACTIONS(3845),
    [anon_sym_return] = ACTIONS(3845),
    [anon_sym_do] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_let_BANG] = ACTIONS(3843),
    [aux_sym_access_modifier_token1] = ACTIONS(3843),
    [anon_sym_LPAREN] = ACTIONS(3845),
    [anon_sym_COMMA] = ACTIONS(3843),
    [anon_sym_null] = ACTIONS(3845),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3843),
    [anon_sym_LBRACE] = ACTIONS(3845),
    [anon_sym_LT_AT] = ACTIONS(3845),
    [anon_sym_LT_AT_AT] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3843),
    [anon_sym_new] = ACTIONS(3845),
    [anon_sym_with] = ACTIONS(3845),
    [anon_sym_return_BANG] = ACTIONS(3843),
    [anon_sym_yield] = ACTIONS(3845),
    [anon_sym_yield_BANG] = ACTIONS(3843),
    [anon_sym_lazy] = ACTIONS(3845),
    [anon_sym_assert] = ACTIONS(3845),
    [anon_sym_upcast] = ACTIONS(3845),
    [anon_sym_downcast] = ACTIONS(3845),
    [anon_sym_COLON_GT] = ACTIONS(3843),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3843),
    [anon_sym_for] = ACTIONS(3845),
    [anon_sym_while] = ACTIONS(3845),
    [anon_sym_if] = ACTIONS(3845),
    [anon_sym_fun] = ACTIONS(3845),
    [anon_sym_try] = ACTIONS(3845),
    [anon_sym_match] = ACTIONS(3845),
    [anon_sym_match_BANG] = ACTIONS(3843),
    [anon_sym_function] = ACTIONS(3845),
    [anon_sym_LT_DASH] = ACTIONS(3845),
    [anon_sym_DOT_LBRACK] = ACTIONS(3843),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_use] = ACTIONS(3845),
    [anon_sym_use_BANG] = ACTIONS(3843),
    [anon_sym_do_BANG] = ACTIONS(3843),
    [anon_sym_begin] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(3845),
    [anon_sym_default] = ACTIONS(3845),
    [anon_sym_or] = ACTIONS(3845),
    [anon_sym_static] = ACTIONS(3845),
    [anon_sym_member] = ACTIONS(3845),
    [anon_sym_interface] = ACTIONS(3845),
    [anon_sym_abstract] = ACTIONS(3845),
    [anon_sym_val] = ACTIONS(3845),
    [anon_sym_override] = ACTIONS(3845),
    [anon_sym_inherit] = ACTIONS(3845),
    [aux_sym_char_token1] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3845),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_AT_DQUOTE] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [sym_bool] = ACTIONS(3845),
    [sym_unit] = ACTIONS(3843),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3845),
    [sym_op_identifier] = ACTIONS(3845),
    [anon_sym_PLUS] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_PLUS_DOT] = ACTIONS(3845),
    [anon_sym_DASH_DOT] = ACTIONS(3845),
    [anon_sym_PERCENT] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3845),
    [anon_sym_TILDE] = ACTIONS(3843),
    [aux_sym_prefix_op_token1] = ACTIONS(3845),
    [aux_sym_infix_op_token1] = ACTIONS(3843),
    [aux_sym_infix_op_token2] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(3845),
    [anon_sym_BANG_EQ] = ACTIONS(3845),
    [anon_sym_COLON_EQ] = ACTIONS(3843),
    [anon_sym_DOLLAR] = ACTIONS(3845),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3845),
    [sym_int] = ACTIONS(3845),
    [sym_xint] = ACTIONS(3843),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3843),
    [anon_sym_POUNDendif] = ACTIONS(3843),
    [anon_sym_POUNDelse] = ACTIONS(3843),
    [sym__newline] = ACTIONS(3843),
  },
  [1881] = {
    [sym_block_comment] = STATE(1881),
    [sym_compiler_directive_decl] = STATE(1881),
    [sym_fsi_directive_decl] = STATE(1881),
    [sym_preproc_line] = STATE(1881),
    [sym_identifier] = ACTIONS(4232),
    [anon_sym_EQ] = ACTIONS(4230),
    [anon_sym_LBRACK_LT] = ACTIONS(4230),
    [anon_sym_COLON] = ACTIONS(4232),
    [anon_sym_return] = ACTIONS(4232),
    [anon_sym_do] = ACTIONS(4232),
    [anon_sym_let] = ACTIONS(4232),
    [anon_sym_let_BANG] = ACTIONS(4230),
    [aux_sym_access_modifier_token1] = ACTIONS(4230),
    [anon_sym_LPAREN] = ACTIONS(4232),
    [anon_sym_COMMA] = ACTIONS(4230),
    [anon_sym_null] = ACTIONS(4232),
    [anon_sym_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_COLON] = ACTIONS(4230),
    [anon_sym_AMP] = ACTIONS(4232),
    [anon_sym_LBRACK] = ACTIONS(4232),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4230),
    [anon_sym_LBRACE] = ACTIONS(4232),
    [anon_sym_LT_AT] = ACTIONS(4232),
    [anon_sym_LT_AT_AT] = ACTIONS(4232),
    [anon_sym_DOT] = ACTIONS(4232),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4230),
    [anon_sym_new] = ACTIONS(4232),
    [anon_sym_with] = ACTIONS(4232),
    [anon_sym_return_BANG] = ACTIONS(4230),
    [anon_sym_yield] = ACTIONS(4232),
    [anon_sym_yield_BANG] = ACTIONS(4230),
    [anon_sym_lazy] = ACTIONS(4232),
    [anon_sym_assert] = ACTIONS(4232),
    [anon_sym_upcast] = ACTIONS(4232),
    [anon_sym_downcast] = ACTIONS(4232),
    [anon_sym_COLON_GT] = ACTIONS(4230),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4230),
    [anon_sym_for] = ACTIONS(4232),
    [anon_sym_while] = ACTIONS(4232),
    [anon_sym_if] = ACTIONS(4232),
    [anon_sym_fun] = ACTIONS(4232),
    [anon_sym_try] = ACTIONS(4232),
    [anon_sym_match] = ACTIONS(4232),
    [anon_sym_match_BANG] = ACTIONS(4230),
    [anon_sym_function] = ACTIONS(4232),
    [anon_sym_LT_DASH] = ACTIONS(4232),
    [anon_sym_DOT_LBRACK] = ACTIONS(4230),
    [anon_sym_LT] = ACTIONS(4230),
    [anon_sym_use] = ACTIONS(4232),
    [anon_sym_use_BANG] = ACTIONS(4230),
    [anon_sym_do_BANG] = ACTIONS(4230),
    [anon_sym_begin] = ACTIONS(4232),
    [anon_sym_LPAREN2] = ACTIONS(4232),
    [anon_sym_default] = ACTIONS(4232),
    [anon_sym_or] = ACTIONS(4232),
    [anon_sym_static] = ACTIONS(4232),
    [anon_sym_member] = ACTIONS(4232),
    [anon_sym_interface] = ACTIONS(4232),
    [anon_sym_abstract] = ACTIONS(4232),
    [anon_sym_val] = ACTIONS(4232),
    [anon_sym_override] = ACTIONS(4232),
    [anon_sym_inherit] = ACTIONS(4232),
    [aux_sym_char_token1] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4232),
    [anon_sym_DQUOTE] = ACTIONS(4232),
    [anon_sym_AT_DQUOTE] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [sym_bool] = ACTIONS(4232),
    [sym_unit] = ACTIONS(4230),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4232),
    [sym_op_identifier] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4232),
    [anon_sym_DASH] = ACTIONS(4232),
    [anon_sym_PLUS_DOT] = ACTIONS(4232),
    [anon_sym_DASH_DOT] = ACTIONS(4232),
    [anon_sym_PERCENT] = ACTIONS(4232),
    [anon_sym_AMP_AMP] = ACTIONS(4232),
    [anon_sym_TILDE] = ACTIONS(4230),
    [aux_sym_prefix_op_token1] = ACTIONS(4232),
    [aux_sym_infix_op_token1] = ACTIONS(4230),
    [aux_sym_infix_op_token2] = ACTIONS(4232),
    [anon_sym_PIPE_PIPE] = ACTIONS(4232),
    [anon_sym_BANG_EQ] = ACTIONS(4232),
    [anon_sym_COLON_EQ] = ACTIONS(4230),
    [anon_sym_DOLLAR] = ACTIONS(4232),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4232),
    [sym_int] = ACTIONS(4232),
    [sym_xint] = ACTIONS(4230),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4230),
    [anon_sym_POUNDendif] = ACTIONS(4230),
    [anon_sym_POUNDelse] = ACTIONS(4230),
    [sym__newline] = ACTIONS(4230),
  },
  [1882] = {
    [sym_block_comment] = STATE(1882),
    [sym_compiler_directive_decl] = STATE(1882),
    [sym_fsi_directive_decl] = STATE(1882),
    [sym_preproc_line] = STATE(1882),
    [sym_identifier] = ACTIONS(3881),
    [anon_sym_EQ] = ACTIONS(3879),
    [anon_sym_LBRACK_LT] = ACTIONS(3879),
    [anon_sym_COLON] = ACTIONS(3881),
    [anon_sym_return] = ACTIONS(3881),
    [anon_sym_do] = ACTIONS(3881),
    [anon_sym_let] = ACTIONS(3881),
    [anon_sym_let_BANG] = ACTIONS(3879),
    [aux_sym_access_modifier_token1] = ACTIONS(3879),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3879),
    [anon_sym_null] = ACTIONS(3881),
    [anon_sym_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3879),
    [anon_sym_LBRACE] = ACTIONS(3881),
    [anon_sym_LT_AT] = ACTIONS(3881),
    [anon_sym_LT_AT_AT] = ACTIONS(3881),
    [anon_sym_DOT] = ACTIONS(3881),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3879),
    [anon_sym_new] = ACTIONS(3881),
    [anon_sym_with] = ACTIONS(3881),
    [anon_sym_return_BANG] = ACTIONS(3879),
    [anon_sym_yield] = ACTIONS(3881),
    [anon_sym_yield_BANG] = ACTIONS(3879),
    [anon_sym_lazy] = ACTIONS(3881),
    [anon_sym_assert] = ACTIONS(3881),
    [anon_sym_upcast] = ACTIONS(3881),
    [anon_sym_downcast] = ACTIONS(3881),
    [anon_sym_COLON_GT] = ACTIONS(3879),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3879),
    [anon_sym_for] = ACTIONS(3881),
    [anon_sym_while] = ACTIONS(3881),
    [anon_sym_if] = ACTIONS(3881),
    [anon_sym_fun] = ACTIONS(3881),
    [anon_sym_try] = ACTIONS(3881),
    [anon_sym_match] = ACTIONS(3881),
    [anon_sym_match_BANG] = ACTIONS(3879),
    [anon_sym_function] = ACTIONS(3881),
    [anon_sym_LT_DASH] = ACTIONS(3881),
    [anon_sym_DOT_LBRACK] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_use] = ACTIONS(3881),
    [anon_sym_use_BANG] = ACTIONS(3879),
    [anon_sym_do_BANG] = ACTIONS(3879),
    [anon_sym_begin] = ACTIONS(3881),
    [anon_sym_LPAREN2] = ACTIONS(3881),
    [anon_sym_default] = ACTIONS(3881),
    [anon_sym_or] = ACTIONS(3881),
    [anon_sym_static] = ACTIONS(3881),
    [anon_sym_member] = ACTIONS(3881),
    [anon_sym_interface] = ACTIONS(3881),
    [anon_sym_abstract] = ACTIONS(3881),
    [anon_sym_val] = ACTIONS(3881),
    [anon_sym_override] = ACTIONS(3881),
    [anon_sym_inherit] = ACTIONS(3881),
    [aux_sym_char_token1] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3881),
    [anon_sym_DQUOTE] = ACTIONS(3881),
    [anon_sym_AT_DQUOTE] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [sym_bool] = ACTIONS(3881),
    [sym_unit] = ACTIONS(3879),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3881),
    [sym_op_identifier] = ACTIONS(3881),
    [anon_sym_PLUS] = ACTIONS(3881),
    [anon_sym_DASH] = ACTIONS(3881),
    [anon_sym_PLUS_DOT] = ACTIONS(3881),
    [anon_sym_DASH_DOT] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(3881),
    [anon_sym_AMP_AMP] = ACTIONS(3881),
    [anon_sym_TILDE] = ACTIONS(3879),
    [aux_sym_prefix_op_token1] = ACTIONS(3881),
    [aux_sym_infix_op_token1] = ACTIONS(3879),
    [aux_sym_infix_op_token2] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE] = ACTIONS(3881),
    [anon_sym_BANG_EQ] = ACTIONS(3881),
    [anon_sym_COLON_EQ] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3881),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3881),
    [sym_int] = ACTIONS(3881),
    [sym_xint] = ACTIONS(3879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3879),
    [anon_sym_POUNDendif] = ACTIONS(3879),
    [anon_sym_POUNDelse] = ACTIONS(3879),
    [sym__newline] = ACTIONS(3879),
  },
  [1883] = {
    [sym_block_comment] = STATE(1883),
    [sym_compiler_directive_decl] = STATE(1883),
    [sym_fsi_directive_decl] = STATE(1883),
    [sym_preproc_line] = STATE(1883),
    [sym_identifier] = ACTIONS(3962),
    [anon_sym_EQ] = ACTIONS(3960),
    [anon_sym_LBRACK_LT] = ACTIONS(3960),
    [anon_sym_COLON] = ACTIONS(3962),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_do] = ACTIONS(3962),
    [anon_sym_let] = ACTIONS(3962),
    [anon_sym_let_BANG] = ACTIONS(3960),
    [aux_sym_access_modifier_token1] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_COMMA] = ACTIONS(3960),
    [anon_sym_null] = ACTIONS(3962),
    [anon_sym_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_COLON] = ACTIONS(3960),
    [anon_sym_AMP] = ACTIONS(3962),
    [anon_sym_LBRACK] = ACTIONS(3962),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_LT_AT] = ACTIONS(3962),
    [anon_sym_LT_AT_AT] = ACTIONS(3962),
    [anon_sym_DOT] = ACTIONS(3962),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3960),
    [anon_sym_new] = ACTIONS(3962),
    [anon_sym_with] = ACTIONS(3962),
    [anon_sym_return_BANG] = ACTIONS(3960),
    [anon_sym_yield] = ACTIONS(3962),
    [anon_sym_yield_BANG] = ACTIONS(3960),
    [anon_sym_lazy] = ACTIONS(3962),
    [anon_sym_assert] = ACTIONS(3962),
    [anon_sym_upcast] = ACTIONS(3962),
    [anon_sym_downcast] = ACTIONS(3962),
    [anon_sym_COLON_GT] = ACTIONS(3960),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3960),
    [anon_sym_for] = ACTIONS(3962),
    [anon_sym_while] = ACTIONS(3962),
    [anon_sym_if] = ACTIONS(3962),
    [anon_sym_fun] = ACTIONS(3962),
    [anon_sym_try] = ACTIONS(3962),
    [anon_sym_match] = ACTIONS(3962),
    [anon_sym_match_BANG] = ACTIONS(3960),
    [anon_sym_function] = ACTIONS(3962),
    [anon_sym_LT_DASH] = ACTIONS(3962),
    [anon_sym_DOT_LBRACK] = ACTIONS(3960),
    [anon_sym_LT] = ACTIONS(3960),
    [anon_sym_use] = ACTIONS(3962),
    [anon_sym_use_BANG] = ACTIONS(3960),
    [anon_sym_do_BANG] = ACTIONS(3960),
    [anon_sym_begin] = ACTIONS(3962),
    [anon_sym_LPAREN2] = ACTIONS(3962),
    [anon_sym_default] = ACTIONS(3962),
    [anon_sym_or] = ACTIONS(3962),
    [anon_sym_static] = ACTIONS(3962),
    [anon_sym_member] = ACTIONS(3962),
    [anon_sym_interface] = ACTIONS(3962),
    [anon_sym_abstract] = ACTIONS(3962),
    [anon_sym_val] = ACTIONS(3962),
    [anon_sym_override] = ACTIONS(3962),
    [anon_sym_inherit] = ACTIONS(3962),
    [aux_sym_char_token1] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3962),
    [anon_sym_DQUOTE] = ACTIONS(3962),
    [anon_sym_AT_DQUOTE] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [sym_bool] = ACTIONS(3962),
    [sym_unit] = ACTIONS(3960),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3962),
    [sym_op_identifier] = ACTIONS(3962),
    [anon_sym_PLUS] = ACTIONS(3962),
    [anon_sym_DASH] = ACTIONS(3962),
    [anon_sym_PLUS_DOT] = ACTIONS(3962),
    [anon_sym_DASH_DOT] = ACTIONS(3962),
    [anon_sym_PERCENT] = ACTIONS(3962),
    [anon_sym_AMP_AMP] = ACTIONS(3962),
    [anon_sym_TILDE] = ACTIONS(3960),
    [aux_sym_prefix_op_token1] = ACTIONS(3962),
    [aux_sym_infix_op_token1] = ACTIONS(3960),
    [aux_sym_infix_op_token2] = ACTIONS(3962),
    [anon_sym_PIPE_PIPE] = ACTIONS(3962),
    [anon_sym_BANG_EQ] = ACTIONS(3962),
    [anon_sym_COLON_EQ] = ACTIONS(3960),
    [anon_sym_DOLLAR] = ACTIONS(3962),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3962),
    [sym_int] = ACTIONS(3962),
    [sym_xint] = ACTIONS(3960),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3960),
    [anon_sym_POUNDendif] = ACTIONS(3960),
    [anon_sym_POUNDelse] = ACTIONS(3960),
    [sym__newline] = ACTIONS(3960),
  },
  [1884] = {
    [sym_block_comment] = STATE(1884),
    [sym_compiler_directive_decl] = STATE(1884),
    [sym_fsi_directive_decl] = STATE(1884),
    [sym_preproc_line] = STATE(1884),
    [sym_identifier] = ACTIONS(3958),
    [anon_sym_EQ] = ACTIONS(3956),
    [anon_sym_LBRACK_LT] = ACTIONS(3956),
    [anon_sym_COLON] = ACTIONS(3958),
    [anon_sym_return] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(3958),
    [anon_sym_let] = ACTIONS(3958),
    [anon_sym_let_BANG] = ACTIONS(3956),
    [aux_sym_access_modifier_token1] = ACTIONS(3956),
    [anon_sym_LPAREN] = ACTIONS(3958),
    [anon_sym_COMMA] = ACTIONS(3956),
    [anon_sym_null] = ACTIONS(3958),
    [anon_sym_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_COLON] = ACTIONS(3956),
    [anon_sym_AMP] = ACTIONS(3958),
    [anon_sym_LBRACK] = ACTIONS(3958),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3956),
    [anon_sym_LBRACE] = ACTIONS(3958),
    [anon_sym_LT_AT] = ACTIONS(3958),
    [anon_sym_LT_AT_AT] = ACTIONS(3958),
    [anon_sym_DOT] = ACTIONS(3958),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3956),
    [anon_sym_new] = ACTIONS(3958),
    [anon_sym_with] = ACTIONS(3958),
    [anon_sym_return_BANG] = ACTIONS(3956),
    [anon_sym_yield] = ACTIONS(3958),
    [anon_sym_yield_BANG] = ACTIONS(3956),
    [anon_sym_lazy] = ACTIONS(3958),
    [anon_sym_assert] = ACTIONS(3958),
    [anon_sym_upcast] = ACTIONS(3958),
    [anon_sym_downcast] = ACTIONS(3958),
    [anon_sym_COLON_GT] = ACTIONS(3956),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3956),
    [anon_sym_for] = ACTIONS(3958),
    [anon_sym_while] = ACTIONS(3958),
    [anon_sym_if] = ACTIONS(3958),
    [anon_sym_fun] = ACTIONS(3958),
    [anon_sym_try] = ACTIONS(3958),
    [anon_sym_match] = ACTIONS(3958),
    [anon_sym_match_BANG] = ACTIONS(3956),
    [anon_sym_function] = ACTIONS(3958),
    [anon_sym_LT_DASH] = ACTIONS(3958),
    [anon_sym_DOT_LBRACK] = ACTIONS(3956),
    [anon_sym_LT] = ACTIONS(3956),
    [anon_sym_use] = ACTIONS(3958),
    [anon_sym_use_BANG] = ACTIONS(3956),
    [anon_sym_do_BANG] = ACTIONS(3956),
    [anon_sym_begin] = ACTIONS(3958),
    [anon_sym_LPAREN2] = ACTIONS(3958),
    [anon_sym_default] = ACTIONS(3958),
    [anon_sym_or] = ACTIONS(3958),
    [anon_sym_static] = ACTIONS(3958),
    [anon_sym_member] = ACTIONS(3958),
    [anon_sym_interface] = ACTIONS(3958),
    [anon_sym_abstract] = ACTIONS(3958),
    [anon_sym_val] = ACTIONS(3958),
    [anon_sym_override] = ACTIONS(3958),
    [anon_sym_inherit] = ACTIONS(3958),
    [aux_sym_char_token1] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [anon_sym_AT_DQUOTE] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [sym_bool] = ACTIONS(3958),
    [sym_unit] = ACTIONS(3956),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3958),
    [sym_op_identifier] = ACTIONS(3958),
    [anon_sym_PLUS] = ACTIONS(3958),
    [anon_sym_DASH] = ACTIONS(3958),
    [anon_sym_PLUS_DOT] = ACTIONS(3958),
    [anon_sym_DASH_DOT] = ACTIONS(3958),
    [anon_sym_PERCENT] = ACTIONS(3958),
    [anon_sym_AMP_AMP] = ACTIONS(3958),
    [anon_sym_TILDE] = ACTIONS(3956),
    [aux_sym_prefix_op_token1] = ACTIONS(3958),
    [aux_sym_infix_op_token1] = ACTIONS(3956),
    [aux_sym_infix_op_token2] = ACTIONS(3958),
    [anon_sym_PIPE_PIPE] = ACTIONS(3958),
    [anon_sym_BANG_EQ] = ACTIONS(3958),
    [anon_sym_COLON_EQ] = ACTIONS(3956),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3958),
    [sym_int] = ACTIONS(3958),
    [sym_xint] = ACTIONS(3956),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3956),
    [anon_sym_POUNDendif] = ACTIONS(3956),
    [anon_sym_POUNDelse] = ACTIONS(3956),
    [sym__newline] = ACTIONS(3956),
  },
  [1885] = {
    [sym_block_comment] = STATE(1885),
    [sym_compiler_directive_decl] = STATE(1885),
    [sym_fsi_directive_decl] = STATE(1885),
    [sym_preproc_line] = STATE(1885),
    [sym_identifier] = ACTIONS(3841),
    [anon_sym_EQ] = ACTIONS(3839),
    [anon_sym_LBRACK_LT] = ACTIONS(3839),
    [anon_sym_COLON] = ACTIONS(3841),
    [anon_sym_return] = ACTIONS(3841),
    [anon_sym_do] = ACTIONS(3841),
    [anon_sym_and] = ACTIONS(3841),
    [anon_sym_let] = ACTIONS(3841),
    [anon_sym_let_BANG] = ACTIONS(3839),
    [aux_sym_access_modifier_token1] = ACTIONS(3839),
    [anon_sym_LPAREN] = ACTIONS(3841),
    [anon_sym_COMMA] = ACTIONS(3839),
    [anon_sym_null] = ACTIONS(3841),
    [anon_sym_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_COLON] = ACTIONS(3839),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_AMP] = ACTIONS(3841),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(3841),
    [anon_sym_LT_AT] = ACTIONS(3841),
    [anon_sym_LT_AT_AT] = ACTIONS(3841),
    [anon_sym_DOT] = ACTIONS(3841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3839),
    [anon_sym_new] = ACTIONS(3841),
    [anon_sym_with] = ACTIONS(3841),
    [anon_sym_return_BANG] = ACTIONS(3839),
    [anon_sym_yield] = ACTIONS(3841),
    [anon_sym_yield_BANG] = ACTIONS(3839),
    [anon_sym_lazy] = ACTIONS(3841),
    [anon_sym_assert] = ACTIONS(3841),
    [anon_sym_upcast] = ACTIONS(3841),
    [anon_sym_downcast] = ACTIONS(3841),
    [anon_sym_COLON_GT] = ACTIONS(3839),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3839),
    [anon_sym_for] = ACTIONS(3841),
    [anon_sym_while] = ACTIONS(3841),
    [anon_sym_if] = ACTIONS(3841),
    [anon_sym_fun] = ACTIONS(3841),
    [anon_sym_try] = ACTIONS(3841),
    [anon_sym_match] = ACTIONS(3841),
    [anon_sym_match_BANG] = ACTIONS(3839),
    [anon_sym_function] = ACTIONS(3841),
    [anon_sym_LT_DASH] = ACTIONS(3841),
    [anon_sym_DOT_LBRACK] = ACTIONS(3839),
    [anon_sym_LT] = ACTIONS(3839),
    [anon_sym_use] = ACTIONS(3841),
    [anon_sym_use_BANG] = ACTIONS(3839),
    [anon_sym_do_BANG] = ACTIONS(3839),
    [anon_sym_begin] = ACTIONS(3841),
    [anon_sym_LPAREN2] = ACTIONS(3841),
    [anon_sym_default] = ACTIONS(3841),
    [anon_sym_or] = ACTIONS(3841),
    [anon_sym_static] = ACTIONS(3841),
    [anon_sym_member] = ACTIONS(3841),
    [anon_sym_interface] = ACTIONS(3841),
    [anon_sym_abstract] = ACTIONS(3841),
    [anon_sym_val] = ACTIONS(3841),
    [anon_sym_override] = ACTIONS(3841),
    [aux_sym_char_token1] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3841),
    [anon_sym_DQUOTE] = ACTIONS(3841),
    [anon_sym_AT_DQUOTE] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [sym_bool] = ACTIONS(3841),
    [sym_unit] = ACTIONS(3839),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3841),
    [sym_op_identifier] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_PLUS_DOT] = ACTIONS(3841),
    [anon_sym_DASH_DOT] = ACTIONS(3841),
    [anon_sym_PERCENT] = ACTIONS(3841),
    [anon_sym_AMP_AMP] = ACTIONS(3841),
    [anon_sym_TILDE] = ACTIONS(3839),
    [aux_sym_prefix_op_token1] = ACTIONS(3841),
    [aux_sym_infix_op_token1] = ACTIONS(3839),
    [aux_sym_infix_op_token2] = ACTIONS(3841),
    [anon_sym_PIPE_PIPE] = ACTIONS(3841),
    [anon_sym_BANG_EQ] = ACTIONS(3841),
    [anon_sym_COLON_EQ] = ACTIONS(3839),
    [anon_sym_DOLLAR] = ACTIONS(3841),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3841),
    [sym_int] = ACTIONS(3841),
    [sym_xint] = ACTIONS(3839),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3839),
    [anon_sym_POUNDendif] = ACTIONS(3839),
    [sym__newline] = ACTIONS(3839),
  },
  [1886] = {
    [sym_block_comment] = STATE(1886),
    [sym_compiler_directive_decl] = STATE(1886),
    [sym_fsi_directive_decl] = STATE(1886),
    [sym_preproc_line] = STATE(1886),
    [sym_identifier] = ACTIONS(3954),
    [anon_sym_EQ] = ACTIONS(3952),
    [anon_sym_LBRACK_LT] = ACTIONS(3952),
    [anon_sym_COLON] = ACTIONS(3954),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_do] = ACTIONS(3954),
    [anon_sym_let] = ACTIONS(3954),
    [anon_sym_let_BANG] = ACTIONS(3952),
    [aux_sym_access_modifier_token1] = ACTIONS(3952),
    [anon_sym_LPAREN] = ACTIONS(3954),
    [anon_sym_COMMA] = ACTIONS(3952),
    [anon_sym_null] = ACTIONS(3954),
    [anon_sym_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_COLON] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3954),
    [anon_sym_LBRACK] = ACTIONS(3954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(3954),
    [anon_sym_LT_AT] = ACTIONS(3954),
    [anon_sym_LT_AT_AT] = ACTIONS(3954),
    [anon_sym_DOT] = ACTIONS(3954),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3952),
    [anon_sym_new] = ACTIONS(3954),
    [anon_sym_with] = ACTIONS(3954),
    [anon_sym_return_BANG] = ACTIONS(3952),
    [anon_sym_yield] = ACTIONS(3954),
    [anon_sym_yield_BANG] = ACTIONS(3952),
    [anon_sym_lazy] = ACTIONS(3954),
    [anon_sym_assert] = ACTIONS(3954),
    [anon_sym_upcast] = ACTIONS(3954),
    [anon_sym_downcast] = ACTIONS(3954),
    [anon_sym_COLON_GT] = ACTIONS(3952),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3952),
    [anon_sym_for] = ACTIONS(3954),
    [anon_sym_while] = ACTIONS(3954),
    [anon_sym_if] = ACTIONS(3954),
    [anon_sym_fun] = ACTIONS(3954),
    [anon_sym_try] = ACTIONS(3954),
    [anon_sym_match] = ACTIONS(3954),
    [anon_sym_match_BANG] = ACTIONS(3952),
    [anon_sym_function] = ACTIONS(3954),
    [anon_sym_LT_DASH] = ACTIONS(3954),
    [anon_sym_DOT_LBRACK] = ACTIONS(3952),
    [anon_sym_LT] = ACTIONS(3952),
    [anon_sym_use] = ACTIONS(3954),
    [anon_sym_use_BANG] = ACTIONS(3952),
    [anon_sym_do_BANG] = ACTIONS(3952),
    [anon_sym_begin] = ACTIONS(3954),
    [anon_sym_LPAREN2] = ACTIONS(3954),
    [anon_sym_default] = ACTIONS(3954),
    [anon_sym_or] = ACTIONS(3954),
    [anon_sym_static] = ACTIONS(3954),
    [anon_sym_member] = ACTIONS(3954),
    [anon_sym_interface] = ACTIONS(3954),
    [anon_sym_abstract] = ACTIONS(3954),
    [anon_sym_val] = ACTIONS(3954),
    [anon_sym_override] = ACTIONS(3954),
    [anon_sym_inherit] = ACTIONS(3954),
    [aux_sym_char_token1] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3954),
    [anon_sym_DQUOTE] = ACTIONS(3954),
    [anon_sym_AT_DQUOTE] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [sym_bool] = ACTIONS(3954),
    [sym_unit] = ACTIONS(3952),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3954),
    [sym_op_identifier] = ACTIONS(3954),
    [anon_sym_PLUS] = ACTIONS(3954),
    [anon_sym_DASH] = ACTIONS(3954),
    [anon_sym_PLUS_DOT] = ACTIONS(3954),
    [anon_sym_DASH_DOT] = ACTIONS(3954),
    [anon_sym_PERCENT] = ACTIONS(3954),
    [anon_sym_AMP_AMP] = ACTIONS(3954),
    [anon_sym_TILDE] = ACTIONS(3952),
    [aux_sym_prefix_op_token1] = ACTIONS(3954),
    [aux_sym_infix_op_token1] = ACTIONS(3952),
    [aux_sym_infix_op_token2] = ACTIONS(3954),
    [anon_sym_PIPE_PIPE] = ACTIONS(3954),
    [anon_sym_BANG_EQ] = ACTIONS(3954),
    [anon_sym_COLON_EQ] = ACTIONS(3952),
    [anon_sym_DOLLAR] = ACTIONS(3954),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3954),
    [sym_int] = ACTIONS(3954),
    [sym_xint] = ACTIONS(3952),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3952),
    [anon_sym_POUNDendif] = ACTIONS(3952),
    [anon_sym_POUNDelse] = ACTIONS(3952),
    [sym__newline] = ACTIONS(3952),
  },
  [1887] = {
    [sym_block_comment] = STATE(1887),
    [sym_compiler_directive_decl] = STATE(1887),
    [sym_fsi_directive_decl] = STATE(1887),
    [sym_preproc_line] = STATE(1887),
    [sym_identifier] = ACTIONS(3841),
    [anon_sym_EQ] = ACTIONS(3839),
    [anon_sym_LBRACK_LT] = ACTIONS(3839),
    [anon_sym_COLON] = ACTIONS(3841),
    [anon_sym_return] = ACTIONS(3841),
    [anon_sym_do] = ACTIONS(3841),
    [anon_sym_let] = ACTIONS(3841),
    [anon_sym_let_BANG] = ACTIONS(3839),
    [aux_sym_access_modifier_token1] = ACTIONS(3839),
    [anon_sym_LPAREN] = ACTIONS(3841),
    [anon_sym_COMMA] = ACTIONS(3839),
    [anon_sym_null] = ACTIONS(3841),
    [anon_sym_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_COLON] = ACTIONS(3839),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_AMP] = ACTIONS(3841),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(3841),
    [anon_sym_LT_AT] = ACTIONS(3841),
    [anon_sym_LT_AT_AT] = ACTIONS(3841),
    [anon_sym_DOT] = ACTIONS(3841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3839),
    [anon_sym_new] = ACTIONS(3841),
    [anon_sym_with] = ACTIONS(3841),
    [anon_sym_return_BANG] = ACTIONS(3839),
    [anon_sym_yield] = ACTIONS(3841),
    [anon_sym_yield_BANG] = ACTIONS(3839),
    [anon_sym_lazy] = ACTIONS(3841),
    [anon_sym_assert] = ACTIONS(3841),
    [anon_sym_upcast] = ACTIONS(3841),
    [anon_sym_downcast] = ACTIONS(3841),
    [anon_sym_COLON_GT] = ACTIONS(3839),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3839),
    [anon_sym_for] = ACTIONS(3841),
    [anon_sym_while] = ACTIONS(3841),
    [anon_sym_if] = ACTIONS(3841),
    [anon_sym_fun] = ACTIONS(3841),
    [anon_sym_try] = ACTIONS(3841),
    [anon_sym_match] = ACTIONS(3841),
    [anon_sym_match_BANG] = ACTIONS(3839),
    [anon_sym_function] = ACTIONS(3841),
    [anon_sym_LT_DASH] = ACTIONS(3841),
    [anon_sym_DOT_LBRACK] = ACTIONS(3839),
    [anon_sym_LT] = ACTIONS(3839),
    [anon_sym_use] = ACTIONS(3841),
    [anon_sym_use_BANG] = ACTIONS(3839),
    [anon_sym_do_BANG] = ACTIONS(3839),
    [anon_sym_begin] = ACTIONS(3841),
    [anon_sym_LPAREN2] = ACTIONS(3841),
    [anon_sym_DOT_DOT2] = ACTIONS(3839),
    [anon_sym_default] = ACTIONS(3841),
    [anon_sym_or] = ACTIONS(3841),
    [anon_sym_static] = ACTIONS(3841),
    [anon_sym_member] = ACTIONS(3841),
    [anon_sym_interface] = ACTIONS(3841),
    [anon_sym_abstract] = ACTIONS(3841),
    [anon_sym_val] = ACTIONS(3841),
    [anon_sym_override] = ACTIONS(3841),
    [aux_sym_char_token1] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3841),
    [anon_sym_DQUOTE] = ACTIONS(3841),
    [anon_sym_AT_DQUOTE] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [sym_bool] = ACTIONS(3841),
    [sym_unit] = ACTIONS(3839),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3841),
    [sym_op_identifier] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_PLUS_DOT] = ACTIONS(3841),
    [anon_sym_DASH_DOT] = ACTIONS(3841),
    [anon_sym_PERCENT] = ACTIONS(3841),
    [anon_sym_AMP_AMP] = ACTIONS(3841),
    [anon_sym_TILDE] = ACTIONS(3839),
    [aux_sym_prefix_op_token1] = ACTIONS(3841),
    [aux_sym_infix_op_token1] = ACTIONS(3839),
    [aux_sym_infix_op_token2] = ACTIONS(3841),
    [anon_sym_PIPE_PIPE] = ACTIONS(3841),
    [anon_sym_BANG_EQ] = ACTIONS(3841),
    [anon_sym_COLON_EQ] = ACTIONS(3839),
    [anon_sym_DOLLAR] = ACTIONS(3841),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3841),
    [sym_int] = ACTIONS(3841),
    [sym_xint] = ACTIONS(3839),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3839),
    [sym__newline] = ACTIONS(3839),
    [sym__dedent] = ACTIONS(3839),
  },
  [1888] = {
    [sym_block_comment] = STATE(1888),
    [sym_compiler_directive_decl] = STATE(1888),
    [sym_fsi_directive_decl] = STATE(1888),
    [sym_preproc_line] = STATE(1888),
    [sym_identifier] = ACTIONS(3828),
    [anon_sym_EQ] = ACTIONS(3826),
    [anon_sym_LBRACK_LT] = ACTIONS(3826),
    [anon_sym_COLON] = ACTIONS(3828),
    [anon_sym_return] = ACTIONS(3828),
    [anon_sym_do] = ACTIONS(3828),
    [anon_sym_and] = ACTIONS(3828),
    [anon_sym_let] = ACTIONS(3828),
    [anon_sym_let_BANG] = ACTIONS(3826),
    [aux_sym_access_modifier_token1] = ACTIONS(3826),
    [anon_sym_LPAREN] = ACTIONS(3828),
    [anon_sym_COMMA] = ACTIONS(3826),
    [anon_sym_null] = ACTIONS(3828),
    [anon_sym_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_COLON] = ACTIONS(3826),
    [anon_sym_PIPE] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3828),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3826),
    [anon_sym_LBRACE] = ACTIONS(3828),
    [anon_sym_LT_AT] = ACTIONS(3828),
    [anon_sym_LT_AT_AT] = ACTIONS(3828),
    [anon_sym_DOT] = ACTIONS(3828),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3826),
    [anon_sym_new] = ACTIONS(3828),
    [anon_sym_with] = ACTIONS(3828),
    [anon_sym_return_BANG] = ACTIONS(3826),
    [anon_sym_yield] = ACTIONS(3828),
    [anon_sym_yield_BANG] = ACTIONS(3826),
    [anon_sym_lazy] = ACTIONS(3828),
    [anon_sym_assert] = ACTIONS(3828),
    [anon_sym_upcast] = ACTIONS(3828),
    [anon_sym_downcast] = ACTIONS(3828),
    [anon_sym_COLON_GT] = ACTIONS(3826),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3826),
    [anon_sym_for] = ACTIONS(3828),
    [anon_sym_while] = ACTIONS(3828),
    [anon_sym_if] = ACTIONS(3828),
    [anon_sym_fun] = ACTIONS(3828),
    [anon_sym_try] = ACTIONS(3828),
    [anon_sym_match] = ACTIONS(3828),
    [anon_sym_match_BANG] = ACTIONS(3826),
    [anon_sym_function] = ACTIONS(3828),
    [anon_sym_LT_DASH] = ACTIONS(3828),
    [anon_sym_DOT_LBRACK] = ACTIONS(3826),
    [anon_sym_LT] = ACTIONS(3826),
    [anon_sym_use] = ACTIONS(3828),
    [anon_sym_use_BANG] = ACTIONS(3826),
    [anon_sym_do_BANG] = ACTIONS(3826),
    [anon_sym_begin] = ACTIONS(3828),
    [anon_sym_LPAREN2] = ACTIONS(3828),
    [anon_sym_default] = ACTIONS(3828),
    [anon_sym_or] = ACTIONS(3828),
    [anon_sym_static] = ACTIONS(3828),
    [anon_sym_member] = ACTIONS(3828),
    [anon_sym_interface] = ACTIONS(3828),
    [anon_sym_abstract] = ACTIONS(3828),
    [anon_sym_val] = ACTIONS(3828),
    [anon_sym_override] = ACTIONS(3828),
    [aux_sym_char_token1] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3828),
    [anon_sym_DQUOTE] = ACTIONS(3828),
    [anon_sym_AT_DQUOTE] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [sym_bool] = ACTIONS(3828),
    [sym_unit] = ACTIONS(3826),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3828),
    [sym_op_identifier] = ACTIONS(3828),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_DASH] = ACTIONS(3828),
    [anon_sym_PLUS_DOT] = ACTIONS(3828),
    [anon_sym_DASH_DOT] = ACTIONS(3828),
    [anon_sym_PERCENT] = ACTIONS(3828),
    [anon_sym_AMP_AMP] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3826),
    [aux_sym_prefix_op_token1] = ACTIONS(3828),
    [aux_sym_infix_op_token1] = ACTIONS(3826),
    [aux_sym_infix_op_token2] = ACTIONS(3828),
    [anon_sym_PIPE_PIPE] = ACTIONS(3828),
    [anon_sym_BANG_EQ] = ACTIONS(3828),
    [anon_sym_COLON_EQ] = ACTIONS(3826),
    [anon_sym_DOLLAR] = ACTIONS(3828),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3828),
    [sym_int] = ACTIONS(3828),
    [sym_xint] = ACTIONS(3826),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3826),
    [anon_sym_POUNDendif] = ACTIONS(3826),
    [sym__newline] = ACTIONS(3826),
  },
  [1889] = {
    [sym_block_comment] = STATE(1889),
    [sym_compiler_directive_decl] = STATE(1889),
    [sym_fsi_directive_decl] = STATE(1889),
    [sym_preproc_line] = STATE(1889),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_LBRACK_LT] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_and] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [aux_sym_access_modifier_token1] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_with] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_default] = ACTIONS(3743),
    [anon_sym_or] = ACTIONS(3743),
    [anon_sym_static] = ACTIONS(3743),
    [anon_sym_member] = ACTIONS(3743),
    [anon_sym_interface] = ACTIONS(3743),
    [anon_sym_abstract] = ACTIONS(3743),
    [anon_sym_val] = ACTIONS(3743),
    [anon_sym_override] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [anon_sym_POUNDendif] = ACTIONS(3741),
    [sym__newline] = ACTIONS(3741),
  },
  [1890] = {
    [sym_block_comment] = STATE(1890),
    [sym_compiler_directive_decl] = STATE(1890),
    [sym_fsi_directive_decl] = STATE(1890),
    [sym_preproc_line] = STATE(1890),
    [aux_sym_long_identifier_repeat1] = STATE(1769),
    [sym_identifier] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3778),
    [anon_sym_LBRACK_LT] = ACTIONS(3778),
    [anon_sym_COLON] = ACTIONS(3781),
    [anon_sym_return] = ACTIONS(3781),
    [anon_sym_do] = ACTIONS(3781),
    [anon_sym_and] = ACTIONS(3781),
    [anon_sym_let] = ACTIONS(3781),
    [anon_sym_let_BANG] = ACTIONS(3778),
    [aux_sym_access_modifier_token1] = ACTIONS(3778),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3778),
    [anon_sym_null] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3781),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_LT_AT] = ACTIONS(3781),
    [anon_sym_LT_AT_AT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(4733),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3778),
    [anon_sym_new] = ACTIONS(3781),
    [anon_sym_with] = ACTIONS(3781),
    [anon_sym_return_BANG] = ACTIONS(3778),
    [anon_sym_yield] = ACTIONS(3781),
    [anon_sym_yield_BANG] = ACTIONS(3778),
    [anon_sym_lazy] = ACTIONS(3781),
    [anon_sym_assert] = ACTIONS(3781),
    [anon_sym_upcast] = ACTIONS(3781),
    [anon_sym_downcast] = ACTIONS(3781),
    [anon_sym_COLON_GT] = ACTIONS(3778),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3778),
    [anon_sym_for] = ACTIONS(3781),
    [anon_sym_while] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_fun] = ACTIONS(3781),
    [anon_sym_try] = ACTIONS(3781),
    [anon_sym_match] = ACTIONS(3781),
    [anon_sym_match_BANG] = ACTIONS(3778),
    [anon_sym_function] = ACTIONS(3781),
    [anon_sym_LT_DASH] = ACTIONS(3781),
    [anon_sym_DOT_LBRACK] = ACTIONS(3778),
    [anon_sym_LT] = ACTIONS(3778),
    [anon_sym_use] = ACTIONS(3781),
    [anon_sym_use_BANG] = ACTIONS(3778),
    [anon_sym_do_BANG] = ACTIONS(3778),
    [anon_sym_begin] = ACTIONS(3781),
    [anon_sym_LPAREN2] = ACTIONS(3781),
    [anon_sym_default] = ACTIONS(3781),
    [anon_sym_or] = ACTIONS(3781),
    [anon_sym_static] = ACTIONS(3781),
    [anon_sym_member] = ACTIONS(3781),
    [anon_sym_interface] = ACTIONS(3781),
    [anon_sym_abstract] = ACTIONS(3781),
    [anon_sym_val] = ACTIONS(3781),
    [anon_sym_override] = ACTIONS(3781),
    [aux_sym_char_token1] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3781),
    [anon_sym_DQUOTE] = ACTIONS(3781),
    [anon_sym_AT_DQUOTE] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [sym_bool] = ACTIONS(3781),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3781),
    [sym_op_identifier] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3781),
    [anon_sym_DASH] = ACTIONS(3781),
    [anon_sym_PLUS_DOT] = ACTIONS(3781),
    [anon_sym_DASH_DOT] = ACTIONS(3781),
    [anon_sym_PERCENT] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3781),
    [anon_sym_TILDE] = ACTIONS(3778),
    [aux_sym_prefix_op_token1] = ACTIONS(3781),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token2] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_COLON_EQ] = ACTIONS(3778),
    [anon_sym_DOLLAR] = ACTIONS(3781),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3781),
    [sym_int] = ACTIONS(3781),
    [sym_xint] = ACTIONS(3778),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3778),
    [anon_sym_POUNDendif] = ACTIONS(3778),
    [sym__newline] = ACTIONS(3778),
  },
  [1891] = {
    [sym_block_comment] = STATE(1891),
    [sym_compiler_directive_decl] = STATE(1891),
    [sym_fsi_directive_decl] = STATE(1891),
    [sym_preproc_line] = STATE(1891),
    [sym_identifier] = ACTIONS(3753),
    [anon_sym_EQ] = ACTIONS(3751),
    [anon_sym_LBRACK_LT] = ACTIONS(3751),
    [anon_sym_COLON] = ACTIONS(3753),
    [anon_sym_return] = ACTIONS(3753),
    [anon_sym_do] = ACTIONS(3753),
    [anon_sym_let] = ACTIONS(3753),
    [anon_sym_let_BANG] = ACTIONS(3751),
    [aux_sym_access_modifier_token1] = ACTIONS(3751),
    [anon_sym_LPAREN] = ACTIONS(3753),
    [anon_sym_COMMA] = ACTIONS(3751),
    [anon_sym_null] = ACTIONS(3753),
    [anon_sym_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_COLON] = ACTIONS(3751),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3751),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_LT_AT] = ACTIONS(3753),
    [anon_sym_LT_AT_AT] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3753),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3751),
    [anon_sym_new] = ACTIONS(3753),
    [anon_sym_with] = ACTIONS(3753),
    [anon_sym_return_BANG] = ACTIONS(3751),
    [anon_sym_yield] = ACTIONS(3753),
    [anon_sym_yield_BANG] = ACTIONS(3751),
    [anon_sym_lazy] = ACTIONS(3753),
    [anon_sym_assert] = ACTIONS(3753),
    [anon_sym_upcast] = ACTIONS(3753),
    [anon_sym_downcast] = ACTIONS(3753),
    [anon_sym_COLON_GT] = ACTIONS(3751),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3751),
    [anon_sym_for] = ACTIONS(3753),
    [anon_sym_while] = ACTIONS(3753),
    [anon_sym_if] = ACTIONS(3753),
    [anon_sym_fun] = ACTIONS(3753),
    [anon_sym_try] = ACTIONS(3753),
    [anon_sym_match] = ACTIONS(3753),
    [anon_sym_match_BANG] = ACTIONS(3751),
    [anon_sym_function] = ACTIONS(3753),
    [anon_sym_LT_DASH] = ACTIONS(3753),
    [anon_sym_DOT_LBRACK] = ACTIONS(3751),
    [anon_sym_LT] = ACTIONS(3751),
    [anon_sym_use] = ACTIONS(3753),
    [anon_sym_use_BANG] = ACTIONS(3751),
    [anon_sym_do_BANG] = ACTIONS(3751),
    [anon_sym_begin] = ACTIONS(3753),
    [anon_sym_LPAREN2] = ACTIONS(3753),
    [anon_sym_default] = ACTIONS(3753),
    [anon_sym_or] = ACTIONS(3753),
    [anon_sym_static] = ACTIONS(3753),
    [anon_sym_member] = ACTIONS(3753),
    [anon_sym_interface] = ACTIONS(3753),
    [anon_sym_abstract] = ACTIONS(3753),
    [anon_sym_val] = ACTIONS(3753),
    [anon_sym_override] = ACTIONS(3753),
    [aux_sym_char_token1] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3753),
    [anon_sym_AT_DQUOTE] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [sym_bool] = ACTIONS(3753),
    [sym_unit] = ACTIONS(3751),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3753),
    [sym_op_identifier] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PLUS_DOT] = ACTIONS(3753),
    [anon_sym_DASH_DOT] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3753),
    [anon_sym_AMP_AMP] = ACTIONS(3753),
    [anon_sym_TILDE] = ACTIONS(3751),
    [aux_sym_prefix_op_token1] = ACTIONS(3753),
    [aux_sym_infix_op_token1] = ACTIONS(3751),
    [aux_sym_infix_op_token2] = ACTIONS(3753),
    [anon_sym_PIPE_PIPE] = ACTIONS(3753),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_COLON_EQ] = ACTIONS(3751),
    [anon_sym_DOLLAR] = ACTIONS(3753),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3753),
    [sym_int] = ACTIONS(4737),
    [sym_xint] = ACTIONS(3751),
    [anon_sym_f] = ACTIONS(3753),
    [aux_sym_decimal_token1] = ACTIONS(3753),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3751),
    [sym__newline] = ACTIONS(3751),
    [sym__dedent] = ACTIONS(3751),
  },
  [1892] = {
    [sym_block_comment] = STATE(1892),
    [sym_compiler_directive_decl] = STATE(1892),
    [sym_fsi_directive_decl] = STATE(1892),
    [sym_preproc_line] = STATE(1892),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_EQ] = ACTIONS(3948),
    [anon_sym_LBRACK_LT] = ACTIONS(3948),
    [anon_sym_COLON] = ACTIONS(3950),
    [anon_sym_return] = ACTIONS(3950),
    [anon_sym_do] = ACTIONS(3950),
    [anon_sym_let] = ACTIONS(3950),
    [anon_sym_let_BANG] = ACTIONS(3948),
    [aux_sym_access_modifier_token1] = ACTIONS(3948),
    [anon_sym_LPAREN] = ACTIONS(3950),
    [anon_sym_COMMA] = ACTIONS(3948),
    [anon_sym_null] = ACTIONS(3950),
    [anon_sym_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_COLON] = ACTIONS(3948),
    [anon_sym_AMP] = ACTIONS(3950),
    [anon_sym_LBRACK] = ACTIONS(3950),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3948),
    [anon_sym_LBRACE] = ACTIONS(3950),
    [anon_sym_LT_AT] = ACTIONS(3950),
    [anon_sym_LT_AT_AT] = ACTIONS(3950),
    [anon_sym_DOT] = ACTIONS(3950),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3948),
    [anon_sym_new] = ACTIONS(3950),
    [anon_sym_with] = ACTIONS(3950),
    [anon_sym_return_BANG] = ACTIONS(3948),
    [anon_sym_yield] = ACTIONS(3950),
    [anon_sym_yield_BANG] = ACTIONS(3948),
    [anon_sym_lazy] = ACTIONS(3950),
    [anon_sym_assert] = ACTIONS(3950),
    [anon_sym_upcast] = ACTIONS(3950),
    [anon_sym_downcast] = ACTIONS(3950),
    [anon_sym_COLON_GT] = ACTIONS(3948),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3948),
    [anon_sym_for] = ACTIONS(3950),
    [anon_sym_while] = ACTIONS(3950),
    [anon_sym_if] = ACTIONS(3950),
    [anon_sym_fun] = ACTIONS(3950),
    [anon_sym_try] = ACTIONS(3950),
    [anon_sym_match] = ACTIONS(3950),
    [anon_sym_match_BANG] = ACTIONS(3948),
    [anon_sym_function] = ACTIONS(3950),
    [anon_sym_LT_DASH] = ACTIONS(3950),
    [anon_sym_DOT_LBRACK] = ACTIONS(3948),
    [anon_sym_LT] = ACTIONS(3948),
    [anon_sym_use] = ACTIONS(3950),
    [anon_sym_use_BANG] = ACTIONS(3948),
    [anon_sym_do_BANG] = ACTIONS(3948),
    [anon_sym_begin] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3950),
    [anon_sym_default] = ACTIONS(3950),
    [anon_sym_or] = ACTIONS(3950),
    [anon_sym_static] = ACTIONS(3950),
    [anon_sym_member] = ACTIONS(3950),
    [anon_sym_interface] = ACTIONS(3950),
    [anon_sym_abstract] = ACTIONS(3950),
    [anon_sym_val] = ACTIONS(3950),
    [anon_sym_override] = ACTIONS(3950),
    [anon_sym_inherit] = ACTIONS(3950),
    [aux_sym_char_token1] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3950),
    [anon_sym_DQUOTE] = ACTIONS(3950),
    [anon_sym_AT_DQUOTE] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [sym_bool] = ACTIONS(3950),
    [sym_unit] = ACTIONS(3948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3950),
    [sym_op_identifier] = ACTIONS(3950),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_DASH] = ACTIONS(3950),
    [anon_sym_PLUS_DOT] = ACTIONS(3950),
    [anon_sym_DASH_DOT] = ACTIONS(3950),
    [anon_sym_PERCENT] = ACTIONS(3950),
    [anon_sym_AMP_AMP] = ACTIONS(3950),
    [anon_sym_TILDE] = ACTIONS(3948),
    [aux_sym_prefix_op_token1] = ACTIONS(3950),
    [aux_sym_infix_op_token1] = ACTIONS(3948),
    [aux_sym_infix_op_token2] = ACTIONS(3950),
    [anon_sym_PIPE_PIPE] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3950),
    [anon_sym_COLON_EQ] = ACTIONS(3948),
    [anon_sym_DOLLAR] = ACTIONS(3950),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3950),
    [sym_int] = ACTIONS(3950),
    [sym_xint] = ACTIONS(3948),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3948),
    [anon_sym_POUNDendif] = ACTIONS(3948),
    [anon_sym_POUNDelse] = ACTIONS(3948),
    [sym__newline] = ACTIONS(3948),
  },
  [1893] = {
    [sym_block_comment] = STATE(1893),
    [sym_compiler_directive_decl] = STATE(1893),
    [sym_fsi_directive_decl] = STATE(1893),
    [sym_preproc_line] = STATE(1893),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [aux_sym_access_modifier_token1] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_member] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_val] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_f] = ACTIONS(3445),
    [aux_sym_decimal_token1] = ACTIONS(3397),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
    [sym__dedent] = ACTIONS(3191),
  },
  [1894] = {
    [sym_block_comment] = STATE(1894),
    [sym_compiler_directive_decl] = STATE(1894),
    [sym_fsi_directive_decl] = STATE(1894),
    [sym_preproc_line] = STATE(1894),
    [sym_identifier] = ACTIONS(3800),
    [anon_sym_EQ] = ACTIONS(3798),
    [anon_sym_LBRACK_LT] = ACTIONS(3798),
    [anon_sym_COLON] = ACTIONS(3800),
    [anon_sym_return] = ACTIONS(3800),
    [anon_sym_do] = ACTIONS(3800),
    [anon_sym_and] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_let_BANG] = ACTIONS(3798),
    [aux_sym_access_modifier_token1] = ACTIONS(3798),
    [anon_sym_LPAREN] = ACTIONS(3800),
    [anon_sym_COMMA] = ACTIONS(3798),
    [anon_sym_null] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_COLON] = ACTIONS(3798),
    [anon_sym_PIPE] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3800),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3798),
    [anon_sym_LBRACE] = ACTIONS(3800),
    [anon_sym_LT_AT] = ACTIONS(3800),
    [anon_sym_LT_AT_AT] = ACTIONS(3800),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3798),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_with] = ACTIONS(3800),
    [anon_sym_return_BANG] = ACTIONS(3798),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_yield_BANG] = ACTIONS(3798),
    [anon_sym_lazy] = ACTIONS(3800),
    [anon_sym_assert] = ACTIONS(3800),
    [anon_sym_upcast] = ACTIONS(3800),
    [anon_sym_downcast] = ACTIONS(3800),
    [anon_sym_COLON_GT] = ACTIONS(3798),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3798),
    [anon_sym_for] = ACTIONS(3800),
    [anon_sym_while] = ACTIONS(3800),
    [anon_sym_if] = ACTIONS(3800),
    [anon_sym_fun] = ACTIONS(3800),
    [anon_sym_try] = ACTIONS(3800),
    [anon_sym_match] = ACTIONS(3800),
    [anon_sym_match_BANG] = ACTIONS(3798),
    [anon_sym_function] = ACTIONS(3800),
    [anon_sym_LT_DASH] = ACTIONS(3800),
    [anon_sym_DOT_LBRACK] = ACTIONS(3798),
    [anon_sym_LT] = ACTIONS(3798),
    [anon_sym_use] = ACTIONS(3800),
    [anon_sym_use_BANG] = ACTIONS(3798),
    [anon_sym_do_BANG] = ACTIONS(3798),
    [anon_sym_begin] = ACTIONS(3800),
    [anon_sym_LPAREN2] = ACTIONS(3800),
    [anon_sym_default] = ACTIONS(3800),
    [anon_sym_or] = ACTIONS(3800),
    [anon_sym_static] = ACTIONS(3800),
    [anon_sym_member] = ACTIONS(3800),
    [anon_sym_interface] = ACTIONS(3800),
    [anon_sym_abstract] = ACTIONS(3800),
    [anon_sym_val] = ACTIONS(3800),
    [anon_sym_override] = ACTIONS(3800),
    [aux_sym_char_token1] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3800),
    [anon_sym_DQUOTE] = ACTIONS(3800),
    [anon_sym_AT_DQUOTE] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [sym_bool] = ACTIONS(3800),
    [sym_unit] = ACTIONS(3798),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3800),
    [sym_op_identifier] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS_DOT] = ACTIONS(3800),
    [anon_sym_DASH_DOT] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3800),
    [anon_sym_AMP_AMP] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3798),
    [aux_sym_prefix_op_token1] = ACTIONS(3800),
    [aux_sym_infix_op_token1] = ACTIONS(3798),
    [aux_sym_infix_op_token2] = ACTIONS(3800),
    [anon_sym_PIPE_PIPE] = ACTIONS(3800),
    [anon_sym_BANG_EQ] = ACTIONS(3800),
    [anon_sym_COLON_EQ] = ACTIONS(3798),
    [anon_sym_DOLLAR] = ACTIONS(3800),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3800),
    [sym_int] = ACTIONS(3800),
    [sym_xint] = ACTIONS(3798),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3798),
    [anon_sym_POUNDendif] = ACTIONS(3798),
    [sym__newline] = ACTIONS(3798),
  },
  [1895] = {
    [sym_block_comment] = STATE(1895),
    [sym_compiler_directive_decl] = STATE(1895),
    [sym_fsi_directive_decl] = STATE(1895),
    [sym_preproc_line] = STATE(1895),
    [sym_identifier] = ACTIONS(3935),
    [anon_sym_EQ] = ACTIONS(3933),
    [anon_sym_LBRACK_LT] = ACTIONS(3933),
    [anon_sym_COLON] = ACTIONS(3935),
    [anon_sym_return] = ACTIONS(3935),
    [anon_sym_do] = ACTIONS(3935),
    [anon_sym_let] = ACTIONS(3935),
    [anon_sym_let_BANG] = ACTIONS(3933),
    [aux_sym_access_modifier_token1] = ACTIONS(3933),
    [anon_sym_LPAREN] = ACTIONS(3935),
    [anon_sym_COMMA] = ACTIONS(3933),
    [anon_sym_null] = ACTIONS(3935),
    [anon_sym_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3935),
    [anon_sym_LBRACK] = ACTIONS(3935),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3933),
    [anon_sym_LBRACE] = ACTIONS(3935),
    [anon_sym_LT_AT] = ACTIONS(3935),
    [anon_sym_LT_AT_AT] = ACTIONS(3935),
    [anon_sym_DOT] = ACTIONS(3935),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3933),
    [anon_sym_new] = ACTIONS(3935),
    [anon_sym_with] = ACTIONS(3935),
    [anon_sym_return_BANG] = ACTIONS(3933),
    [anon_sym_yield] = ACTIONS(3935),
    [anon_sym_yield_BANG] = ACTIONS(3933),
    [anon_sym_lazy] = ACTIONS(3935),
    [anon_sym_assert] = ACTIONS(3935),
    [anon_sym_upcast] = ACTIONS(3935),
    [anon_sym_downcast] = ACTIONS(3935),
    [anon_sym_COLON_GT] = ACTIONS(3933),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3933),
    [anon_sym_for] = ACTIONS(3935),
    [anon_sym_while] = ACTIONS(3935),
    [anon_sym_if] = ACTIONS(3935),
    [anon_sym_fun] = ACTIONS(3935),
    [anon_sym_try] = ACTIONS(3935),
    [anon_sym_match] = ACTIONS(3935),
    [anon_sym_match_BANG] = ACTIONS(3933),
    [anon_sym_function] = ACTIONS(3935),
    [anon_sym_LT_DASH] = ACTIONS(3935),
    [anon_sym_DOT_LBRACK] = ACTIONS(3933),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_use] = ACTIONS(3935),
    [anon_sym_use_BANG] = ACTIONS(3933),
    [anon_sym_do_BANG] = ACTIONS(3933),
    [anon_sym_begin] = ACTIONS(3935),
    [anon_sym_LPAREN2] = ACTIONS(3935),
    [anon_sym_default] = ACTIONS(3935),
    [anon_sym_or] = ACTIONS(3935),
    [anon_sym_static] = ACTIONS(3935),
    [anon_sym_member] = ACTIONS(3935),
    [anon_sym_interface] = ACTIONS(3935),
    [anon_sym_abstract] = ACTIONS(3935),
    [anon_sym_val] = ACTIONS(3935),
    [anon_sym_override] = ACTIONS(3935),
    [anon_sym_inherit] = ACTIONS(3935),
    [aux_sym_char_token1] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3935),
    [anon_sym_DQUOTE] = ACTIONS(3935),
    [anon_sym_AT_DQUOTE] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [sym_bool] = ACTIONS(3935),
    [sym_unit] = ACTIONS(3933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3935),
    [sym_op_identifier] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(3935),
    [anon_sym_DASH] = ACTIONS(3935),
    [anon_sym_PLUS_DOT] = ACTIONS(3935),
    [anon_sym_DASH_DOT] = ACTIONS(3935),
    [anon_sym_PERCENT] = ACTIONS(3935),
    [anon_sym_AMP_AMP] = ACTIONS(3935),
    [anon_sym_TILDE] = ACTIONS(3933),
    [aux_sym_prefix_op_token1] = ACTIONS(3935),
    [aux_sym_infix_op_token1] = ACTIONS(3933),
    [aux_sym_infix_op_token2] = ACTIONS(3935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3935),
    [anon_sym_BANG_EQ] = ACTIONS(3935),
    [anon_sym_COLON_EQ] = ACTIONS(3933),
    [anon_sym_DOLLAR] = ACTIONS(3935),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3935),
    [sym_int] = ACTIONS(3935),
    [sym_xint] = ACTIONS(3933),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3933),
    [anon_sym_POUNDendif] = ACTIONS(3933),
    [anon_sym_POUNDelse] = ACTIONS(3933),
    [sym__newline] = ACTIONS(3933),
  },
  [1896] = {
    [sym_block_comment] = STATE(1896),
    [sym_compiler_directive_decl] = STATE(1896),
    [sym_fsi_directive_decl] = STATE(1896),
    [sym_preproc_line] = STATE(1896),
    [sym_identifier] = ACTIONS(3885),
    [anon_sym_EQ] = ACTIONS(3883),
    [anon_sym_LBRACK_LT] = ACTIONS(3883),
    [anon_sym_COLON] = ACTIONS(3885),
    [anon_sym_return] = ACTIONS(3885),
    [anon_sym_do] = ACTIONS(3885),
    [anon_sym_let] = ACTIONS(3885),
    [anon_sym_let_BANG] = ACTIONS(3883),
    [aux_sym_access_modifier_token1] = ACTIONS(3883),
    [anon_sym_LPAREN] = ACTIONS(3885),
    [anon_sym_COMMA] = ACTIONS(3883),
    [anon_sym_null] = ACTIONS(3885),
    [anon_sym_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3883),
    [anon_sym_AMP] = ACTIONS(3885),
    [anon_sym_LBRACK] = ACTIONS(3885),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3883),
    [anon_sym_LBRACE] = ACTIONS(3885),
    [anon_sym_LT_AT] = ACTIONS(3885),
    [anon_sym_LT_AT_AT] = ACTIONS(3885),
    [anon_sym_DOT] = ACTIONS(3885),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3883),
    [anon_sym_new] = ACTIONS(3885),
    [anon_sym_with] = ACTIONS(3885),
    [anon_sym_return_BANG] = ACTIONS(3883),
    [anon_sym_yield] = ACTIONS(3885),
    [anon_sym_yield_BANG] = ACTIONS(3883),
    [anon_sym_lazy] = ACTIONS(3885),
    [anon_sym_assert] = ACTIONS(3885),
    [anon_sym_upcast] = ACTIONS(3885),
    [anon_sym_downcast] = ACTIONS(3885),
    [anon_sym_COLON_GT] = ACTIONS(3883),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3883),
    [anon_sym_for] = ACTIONS(3885),
    [anon_sym_while] = ACTIONS(3885),
    [anon_sym_if] = ACTIONS(3885),
    [anon_sym_fun] = ACTIONS(3885),
    [anon_sym_try] = ACTIONS(3885),
    [anon_sym_match] = ACTIONS(3885),
    [anon_sym_match_BANG] = ACTIONS(3883),
    [anon_sym_function] = ACTIONS(3885),
    [anon_sym_LT_DASH] = ACTIONS(3885),
    [anon_sym_DOT_LBRACK] = ACTIONS(3883),
    [anon_sym_LT] = ACTIONS(3883),
    [anon_sym_use] = ACTIONS(3885),
    [anon_sym_use_BANG] = ACTIONS(3883),
    [anon_sym_do_BANG] = ACTIONS(3883),
    [anon_sym_begin] = ACTIONS(3885),
    [anon_sym_LPAREN2] = ACTIONS(3885),
    [anon_sym_default] = ACTIONS(3885),
    [anon_sym_or] = ACTIONS(3885),
    [anon_sym_static] = ACTIONS(3885),
    [anon_sym_member] = ACTIONS(3885),
    [anon_sym_interface] = ACTIONS(3885),
    [anon_sym_abstract] = ACTIONS(3885),
    [anon_sym_val] = ACTIONS(3885),
    [anon_sym_override] = ACTIONS(3885),
    [anon_sym_inherit] = ACTIONS(3885),
    [aux_sym_char_token1] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3885),
    [anon_sym_DQUOTE] = ACTIONS(3885),
    [anon_sym_AT_DQUOTE] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [sym_bool] = ACTIONS(3885),
    [sym_unit] = ACTIONS(3883),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3885),
    [sym_op_identifier] = ACTIONS(3885),
    [anon_sym_PLUS] = ACTIONS(3885),
    [anon_sym_DASH] = ACTIONS(3885),
    [anon_sym_PLUS_DOT] = ACTIONS(3885),
    [anon_sym_DASH_DOT] = ACTIONS(3885),
    [anon_sym_PERCENT] = ACTIONS(3885),
    [anon_sym_AMP_AMP] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3883),
    [aux_sym_prefix_op_token1] = ACTIONS(3885),
    [aux_sym_infix_op_token1] = ACTIONS(3883),
    [aux_sym_infix_op_token2] = ACTIONS(3885),
    [anon_sym_PIPE_PIPE] = ACTIONS(3885),
    [anon_sym_BANG_EQ] = ACTIONS(3885),
    [anon_sym_COLON_EQ] = ACTIONS(3883),
    [anon_sym_DOLLAR] = ACTIONS(3885),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3885),
    [sym_int] = ACTIONS(3885),
    [sym_xint] = ACTIONS(3883),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3883),
    [anon_sym_POUNDendif] = ACTIONS(3883),
    [anon_sym_POUNDelse] = ACTIONS(3883),
    [sym__newline] = ACTIONS(3883),
  },
  [1897] = {
    [sym_block_comment] = STATE(1897),
    [sym_compiler_directive_decl] = STATE(1897),
    [sym_fsi_directive_decl] = STATE(1897),
    [sym_preproc_line] = STATE(1897),
    [sym_identifier] = ACTIONS(4130),
    [anon_sym_EQ] = ACTIONS(4128),
    [anon_sym_LBRACK_LT] = ACTIONS(4128),
    [anon_sym_COLON] = ACTIONS(4130),
    [anon_sym_return] = ACTIONS(4130),
    [anon_sym_do] = ACTIONS(4130),
    [anon_sym_let] = ACTIONS(4130),
    [anon_sym_let_BANG] = ACTIONS(4128),
    [aux_sym_access_modifier_token1] = ACTIONS(4128),
    [anon_sym_LPAREN] = ACTIONS(4130),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_null] = ACTIONS(4130),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_COLON] = ACTIONS(4128),
    [anon_sym_AMP] = ACTIONS(4130),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4128),
    [anon_sym_LBRACE] = ACTIONS(4130),
    [anon_sym_LT_AT] = ACTIONS(4130),
    [anon_sym_LT_AT_AT] = ACTIONS(4130),
    [anon_sym_DOT] = ACTIONS(4130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4128),
    [anon_sym_new] = ACTIONS(4130),
    [anon_sym_with] = ACTIONS(4130),
    [anon_sym_return_BANG] = ACTIONS(4128),
    [anon_sym_yield] = ACTIONS(4130),
    [anon_sym_yield_BANG] = ACTIONS(4128),
    [anon_sym_lazy] = ACTIONS(4130),
    [anon_sym_assert] = ACTIONS(4130),
    [anon_sym_upcast] = ACTIONS(4130),
    [anon_sym_downcast] = ACTIONS(4130),
    [anon_sym_COLON_GT] = ACTIONS(4128),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4128),
    [anon_sym_for] = ACTIONS(4130),
    [anon_sym_while] = ACTIONS(4130),
    [anon_sym_if] = ACTIONS(4130),
    [anon_sym_fun] = ACTIONS(4130),
    [anon_sym_try] = ACTIONS(4130),
    [anon_sym_match] = ACTIONS(4130),
    [anon_sym_match_BANG] = ACTIONS(4128),
    [anon_sym_function] = ACTIONS(4130),
    [anon_sym_LT_DASH] = ACTIONS(4130),
    [anon_sym_DOT_LBRACK] = ACTIONS(4128),
    [anon_sym_LT] = ACTIONS(4128),
    [anon_sym_use] = ACTIONS(4130),
    [anon_sym_use_BANG] = ACTIONS(4128),
    [anon_sym_do_BANG] = ACTIONS(4128),
    [anon_sym_begin] = ACTIONS(4130),
    [anon_sym_LPAREN2] = ACTIONS(4130),
    [anon_sym_default] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_static] = ACTIONS(4130),
    [anon_sym_member] = ACTIONS(4130),
    [anon_sym_interface] = ACTIONS(4130),
    [anon_sym_abstract] = ACTIONS(4130),
    [anon_sym_val] = ACTIONS(4130),
    [anon_sym_override] = ACTIONS(4130),
    [anon_sym_inherit] = ACTIONS(4130),
    [aux_sym_char_token1] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4130),
    [anon_sym_DQUOTE] = ACTIONS(4130),
    [anon_sym_AT_DQUOTE] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [sym_bool] = ACTIONS(4130),
    [sym_unit] = ACTIONS(4128),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4130),
    [sym_op_identifier] = ACTIONS(4130),
    [anon_sym_PLUS] = ACTIONS(4130),
    [anon_sym_DASH] = ACTIONS(4130),
    [anon_sym_PLUS_DOT] = ACTIONS(4130),
    [anon_sym_DASH_DOT] = ACTIONS(4130),
    [anon_sym_PERCENT] = ACTIONS(4130),
    [anon_sym_AMP_AMP] = ACTIONS(4130),
    [anon_sym_TILDE] = ACTIONS(4128),
    [aux_sym_prefix_op_token1] = ACTIONS(4130),
    [aux_sym_infix_op_token1] = ACTIONS(4128),
    [aux_sym_infix_op_token2] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE] = ACTIONS(4130),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_COLON_EQ] = ACTIONS(4128),
    [anon_sym_DOLLAR] = ACTIONS(4130),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4130),
    [sym_int] = ACTIONS(4130),
    [sym_xint] = ACTIONS(4128),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4128),
    [anon_sym_POUNDendif] = ACTIONS(4128),
    [anon_sym_POUNDelse] = ACTIONS(4128),
    [sym__newline] = ACTIONS(4128),
  },
  [1898] = {
    [sym_block_comment] = STATE(1898),
    [sym_compiler_directive_decl] = STATE(1898),
    [sym_fsi_directive_decl] = STATE(1898),
    [sym_preproc_line] = STATE(1898),
    [sym_identifier] = ACTIONS(3996),
    [anon_sym_EQ] = ACTIONS(3994),
    [anon_sym_LBRACK_LT] = ACTIONS(3994),
    [anon_sym_COLON] = ACTIONS(3996),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_do] = ACTIONS(3996),
    [anon_sym_and] = ACTIONS(3996),
    [anon_sym_let] = ACTIONS(3996),
    [anon_sym_let_BANG] = ACTIONS(3994),
    [aux_sym_access_modifier_token1] = ACTIONS(3994),
    [anon_sym_LPAREN] = ACTIONS(3996),
    [anon_sym_COMMA] = ACTIONS(3994),
    [anon_sym_null] = ACTIONS(3996),
    [anon_sym_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_COLON] = ACTIONS(3994),
    [anon_sym_AMP] = ACTIONS(3996),
    [anon_sym_LBRACK] = ACTIONS(3996),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3994),
    [anon_sym_LBRACE] = ACTIONS(3996),
    [anon_sym_LT_AT] = ACTIONS(3996),
    [anon_sym_LT_AT_AT] = ACTIONS(3996),
    [anon_sym_DOT] = ACTIONS(3996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3994),
    [anon_sym_new] = ACTIONS(3996),
    [anon_sym_with] = ACTIONS(3996),
    [anon_sym_return_BANG] = ACTIONS(3994),
    [anon_sym_yield] = ACTIONS(3996),
    [anon_sym_yield_BANG] = ACTIONS(3994),
    [anon_sym_lazy] = ACTIONS(3996),
    [anon_sym_assert] = ACTIONS(3996),
    [anon_sym_upcast] = ACTIONS(3996),
    [anon_sym_downcast] = ACTIONS(3996),
    [anon_sym_COLON_GT] = ACTIONS(3994),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3994),
    [anon_sym_for] = ACTIONS(3996),
    [anon_sym_while] = ACTIONS(3996),
    [anon_sym_if] = ACTIONS(3996),
    [anon_sym_fun] = ACTIONS(3996),
    [anon_sym_try] = ACTIONS(3996),
    [anon_sym_match] = ACTIONS(3996),
    [anon_sym_match_BANG] = ACTIONS(3994),
    [anon_sym_function] = ACTIONS(3996),
    [anon_sym_LT_DASH] = ACTIONS(3996),
    [anon_sym_DOT_LBRACK] = ACTIONS(3994),
    [anon_sym_LT] = ACTIONS(3994),
    [anon_sym_use] = ACTIONS(3996),
    [anon_sym_use_BANG] = ACTIONS(3994),
    [anon_sym_do_BANG] = ACTIONS(3994),
    [anon_sym_begin] = ACTIONS(3996),
    [anon_sym_LPAREN2] = ACTIONS(3996),
    [anon_sym_default] = ACTIONS(3996),
    [anon_sym_or] = ACTIONS(3996),
    [anon_sym_static] = ACTIONS(3996),
    [anon_sym_member] = ACTIONS(3996),
    [anon_sym_interface] = ACTIONS(3996),
    [anon_sym_abstract] = ACTIONS(3996),
    [anon_sym_val] = ACTIONS(3996),
    [anon_sym_override] = ACTIONS(3996),
    [aux_sym_char_token1] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3996),
    [anon_sym_DQUOTE] = ACTIONS(3996),
    [anon_sym_AT_DQUOTE] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [sym_bool] = ACTIONS(3996),
    [sym_unit] = ACTIONS(3994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3996),
    [sym_op_identifier] = ACTIONS(3996),
    [anon_sym_PLUS] = ACTIONS(3996),
    [anon_sym_DASH] = ACTIONS(3996),
    [anon_sym_PLUS_DOT] = ACTIONS(3996),
    [anon_sym_DASH_DOT] = ACTIONS(3996),
    [anon_sym_PERCENT] = ACTIONS(3996),
    [anon_sym_AMP_AMP] = ACTIONS(3996),
    [anon_sym_TILDE] = ACTIONS(3994),
    [aux_sym_prefix_op_token1] = ACTIONS(3996),
    [aux_sym_infix_op_token1] = ACTIONS(3994),
    [aux_sym_infix_op_token2] = ACTIONS(3996),
    [anon_sym_PIPE_PIPE] = ACTIONS(3996),
    [anon_sym_BANG_EQ] = ACTIONS(3996),
    [anon_sym_COLON_EQ] = ACTIONS(3994),
    [anon_sym_DOLLAR] = ACTIONS(3996),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3996),
    [sym_int] = ACTIONS(3996),
    [sym_xint] = ACTIONS(3994),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3994),
    [anon_sym_POUNDendif] = ACTIONS(3994),
    [sym__newline] = ACTIONS(3994),
  },
  [1899] = {
    [sym_block_comment] = STATE(1899),
    [sym_compiler_directive_decl] = STATE(1899),
    [sym_fsi_directive_decl] = STATE(1899),
    [sym_preproc_line] = STATE(1899),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_LBRACK_LT] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [aux_sym_access_modifier_token1] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_with] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_DOT_DOT2] = ACTIONS(4226),
    [anon_sym_default] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [anon_sym_static] = ACTIONS(4228),
    [anon_sym_member] = ACTIONS(4228),
    [anon_sym_interface] = ACTIONS(4228),
    [anon_sym_abstract] = ACTIONS(4228),
    [anon_sym_val] = ACTIONS(4228),
    [anon_sym_override] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
    [sym__dedent] = ACTIONS(4226),
  },
  [1900] = {
    [sym_block_comment] = STATE(1900),
    [sym_compiler_directive_decl] = STATE(1900),
    [sym_fsi_directive_decl] = STATE(1900),
    [sym_preproc_line] = STATE(1900),
    [sym_identifier] = ACTIONS(4018),
    [anon_sym_EQ] = ACTIONS(4016),
    [anon_sym_LBRACK_LT] = ACTIONS(4016),
    [anon_sym_COLON] = ACTIONS(4018),
    [anon_sym_return] = ACTIONS(4018),
    [anon_sym_do] = ACTIONS(4018),
    [anon_sym_and] = ACTIONS(4018),
    [anon_sym_let] = ACTIONS(4018),
    [anon_sym_let_BANG] = ACTIONS(4016),
    [aux_sym_access_modifier_token1] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(4018),
    [anon_sym_COMMA] = ACTIONS(4016),
    [anon_sym_null] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_COLON] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4018),
    [anon_sym_LBRACK] = ACTIONS(4018),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4016),
    [anon_sym_LBRACE] = ACTIONS(4018),
    [anon_sym_LT_AT] = ACTIONS(4018),
    [anon_sym_LT_AT_AT] = ACTIONS(4018),
    [anon_sym_DOT] = ACTIONS(4018),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4016),
    [anon_sym_new] = ACTIONS(4018),
    [anon_sym_with] = ACTIONS(4018),
    [anon_sym_return_BANG] = ACTIONS(4016),
    [anon_sym_yield] = ACTIONS(4018),
    [anon_sym_yield_BANG] = ACTIONS(4016),
    [anon_sym_lazy] = ACTIONS(4018),
    [anon_sym_assert] = ACTIONS(4018),
    [anon_sym_upcast] = ACTIONS(4018),
    [anon_sym_downcast] = ACTIONS(4018),
    [anon_sym_COLON_GT] = ACTIONS(4016),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4016),
    [anon_sym_for] = ACTIONS(4018),
    [anon_sym_while] = ACTIONS(4018),
    [anon_sym_if] = ACTIONS(4018),
    [anon_sym_fun] = ACTIONS(4018),
    [anon_sym_try] = ACTIONS(4018),
    [anon_sym_match] = ACTIONS(4018),
    [anon_sym_match_BANG] = ACTIONS(4016),
    [anon_sym_function] = ACTIONS(4018),
    [anon_sym_LT_DASH] = ACTIONS(4018),
    [anon_sym_DOT_LBRACK] = ACTIONS(4016),
    [anon_sym_LT] = ACTIONS(4016),
    [anon_sym_use] = ACTIONS(4018),
    [anon_sym_use_BANG] = ACTIONS(4016),
    [anon_sym_do_BANG] = ACTIONS(4016),
    [anon_sym_begin] = ACTIONS(4018),
    [anon_sym_LPAREN2] = ACTIONS(4018),
    [anon_sym_default] = ACTIONS(4018),
    [anon_sym_or] = ACTIONS(4018),
    [anon_sym_static] = ACTIONS(4018),
    [anon_sym_member] = ACTIONS(4018),
    [anon_sym_interface] = ACTIONS(4018),
    [anon_sym_abstract] = ACTIONS(4018),
    [anon_sym_val] = ACTIONS(4018),
    [anon_sym_override] = ACTIONS(4018),
    [aux_sym_char_token1] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(4018),
    [anon_sym_AT_DQUOTE] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [sym_bool] = ACTIONS(4018),
    [sym_unit] = ACTIONS(4016),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4018),
    [sym_op_identifier] = ACTIONS(4018),
    [anon_sym_PLUS] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_PLUS_DOT] = ACTIONS(4018),
    [anon_sym_DASH_DOT] = ACTIONS(4018),
    [anon_sym_PERCENT] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4016),
    [aux_sym_prefix_op_token1] = ACTIONS(4018),
    [aux_sym_infix_op_token1] = ACTIONS(4016),
    [aux_sym_infix_op_token2] = ACTIONS(4018),
    [anon_sym_PIPE_PIPE] = ACTIONS(4018),
    [anon_sym_BANG_EQ] = ACTIONS(4018),
    [anon_sym_COLON_EQ] = ACTIONS(4016),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4018),
    [sym_int] = ACTIONS(4018),
    [sym_xint] = ACTIONS(4016),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4016),
    [sym__newline] = ACTIONS(4016),
    [sym__dedent] = ACTIONS(4016),
  },
  [1901] = {
    [sym_block_comment] = STATE(1901),
    [sym_compiler_directive_decl] = STATE(1901),
    [sym_fsi_directive_decl] = STATE(1901),
    [sym_preproc_line] = STATE(1901),
    [sym_identifier] = ACTIONS(4054),
    [anon_sym_EQ] = ACTIONS(4052),
    [anon_sym_LBRACK_LT] = ACTIONS(4052),
    [anon_sym_COLON] = ACTIONS(4054),
    [anon_sym_return] = ACTIONS(4054),
    [anon_sym_do] = ACTIONS(4054),
    [anon_sym_and] = ACTIONS(4054),
    [anon_sym_let] = ACTIONS(4054),
    [anon_sym_let_BANG] = ACTIONS(4052),
    [aux_sym_access_modifier_token1] = ACTIONS(4052),
    [anon_sym_LPAREN] = ACTIONS(4054),
    [anon_sym_COMMA] = ACTIONS(4052),
    [anon_sym_null] = ACTIONS(4054),
    [anon_sym_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_COLON] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(4054),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4052),
    [anon_sym_LBRACE] = ACTIONS(4054),
    [anon_sym_LT_AT] = ACTIONS(4054),
    [anon_sym_LT_AT_AT] = ACTIONS(4054),
    [anon_sym_DOT] = ACTIONS(4054),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_with] = ACTIONS(4054),
    [anon_sym_return_BANG] = ACTIONS(4052),
    [anon_sym_yield] = ACTIONS(4054),
    [anon_sym_yield_BANG] = ACTIONS(4052),
    [anon_sym_lazy] = ACTIONS(4054),
    [anon_sym_assert] = ACTIONS(4054),
    [anon_sym_upcast] = ACTIONS(4054),
    [anon_sym_downcast] = ACTIONS(4054),
    [anon_sym_COLON_GT] = ACTIONS(4052),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4052),
    [anon_sym_for] = ACTIONS(4054),
    [anon_sym_while] = ACTIONS(4054),
    [anon_sym_if] = ACTIONS(4054),
    [anon_sym_fun] = ACTIONS(4054),
    [anon_sym_try] = ACTIONS(4054),
    [anon_sym_match] = ACTIONS(4054),
    [anon_sym_match_BANG] = ACTIONS(4052),
    [anon_sym_function] = ACTIONS(4054),
    [anon_sym_LT_DASH] = ACTIONS(4054),
    [anon_sym_DOT_LBRACK] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_use] = ACTIONS(4054),
    [anon_sym_use_BANG] = ACTIONS(4052),
    [anon_sym_do_BANG] = ACTIONS(4052),
    [anon_sym_begin] = ACTIONS(4054),
    [anon_sym_LPAREN2] = ACTIONS(4054),
    [anon_sym_default] = ACTIONS(4054),
    [anon_sym_or] = ACTIONS(4054),
    [anon_sym_static] = ACTIONS(4054),
    [anon_sym_member] = ACTIONS(4054),
    [anon_sym_interface] = ACTIONS(4054),
    [anon_sym_abstract] = ACTIONS(4054),
    [anon_sym_val] = ACTIONS(4054),
    [anon_sym_override] = ACTIONS(4054),
    [aux_sym_char_token1] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4054),
    [anon_sym_DQUOTE] = ACTIONS(4054),
    [anon_sym_AT_DQUOTE] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [sym_bool] = ACTIONS(4054),
    [sym_unit] = ACTIONS(4052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4054),
    [sym_op_identifier] = ACTIONS(4054),
    [anon_sym_PLUS] = ACTIONS(4054),
    [anon_sym_DASH] = ACTIONS(4054),
    [anon_sym_PLUS_DOT] = ACTIONS(4054),
    [anon_sym_DASH_DOT] = ACTIONS(4054),
    [anon_sym_PERCENT] = ACTIONS(4054),
    [anon_sym_AMP_AMP] = ACTIONS(4054),
    [anon_sym_TILDE] = ACTIONS(4052),
    [aux_sym_prefix_op_token1] = ACTIONS(4054),
    [aux_sym_infix_op_token1] = ACTIONS(4052),
    [aux_sym_infix_op_token2] = ACTIONS(4054),
    [anon_sym_PIPE_PIPE] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4054),
    [anon_sym_COLON_EQ] = ACTIONS(4052),
    [anon_sym_DOLLAR] = ACTIONS(4054),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4054),
    [sym_int] = ACTIONS(4054),
    [sym_xint] = ACTIONS(4052),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4052),
    [sym__newline] = ACTIONS(4052),
    [sym__dedent] = ACTIONS(4052),
  },
  [1902] = {
    [sym_block_comment] = STATE(1902),
    [sym_compiler_directive_decl] = STATE(1902),
    [sym_fsi_directive_decl] = STATE(1902),
    [sym_preproc_line] = STATE(1902),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LBRACK_LT] = ACTIONS(4080),
    [anon_sym_COLON] = ACTIONS(4082),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_do] = ACTIONS(4082),
    [anon_sym_and] = ACTIONS(4082),
    [anon_sym_let] = ACTIONS(4082),
    [anon_sym_let_BANG] = ACTIONS(4080),
    [aux_sym_access_modifier_token1] = ACTIONS(4080),
    [anon_sym_LPAREN] = ACTIONS(4082),
    [anon_sym_COMMA] = ACTIONS(4080),
    [anon_sym_null] = ACTIONS(4082),
    [anon_sym_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_COLON] = ACTIONS(4080),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_LBRACK] = ACTIONS(4082),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(4082),
    [anon_sym_LT_AT] = ACTIONS(4082),
    [anon_sym_LT_AT_AT] = ACTIONS(4082),
    [anon_sym_DOT] = ACTIONS(4082),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4080),
    [anon_sym_new] = ACTIONS(4082),
    [anon_sym_with] = ACTIONS(4082),
    [anon_sym_return_BANG] = ACTIONS(4080),
    [anon_sym_yield] = ACTIONS(4082),
    [anon_sym_yield_BANG] = ACTIONS(4080),
    [anon_sym_lazy] = ACTIONS(4082),
    [anon_sym_assert] = ACTIONS(4082),
    [anon_sym_upcast] = ACTIONS(4082),
    [anon_sym_downcast] = ACTIONS(4082),
    [anon_sym_COLON_GT] = ACTIONS(4080),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4080),
    [anon_sym_for] = ACTIONS(4082),
    [anon_sym_while] = ACTIONS(4082),
    [anon_sym_if] = ACTIONS(4082),
    [anon_sym_fun] = ACTIONS(4082),
    [anon_sym_try] = ACTIONS(4082),
    [anon_sym_match] = ACTIONS(4082),
    [anon_sym_match_BANG] = ACTIONS(4080),
    [anon_sym_function] = ACTIONS(4082),
    [anon_sym_LT_DASH] = ACTIONS(4082),
    [anon_sym_DOT_LBRACK] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(4080),
    [anon_sym_use] = ACTIONS(4082),
    [anon_sym_use_BANG] = ACTIONS(4080),
    [anon_sym_do_BANG] = ACTIONS(4080),
    [anon_sym_begin] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4082),
    [anon_sym_default] = ACTIONS(4082),
    [anon_sym_or] = ACTIONS(4082),
    [anon_sym_static] = ACTIONS(4082),
    [anon_sym_member] = ACTIONS(4082),
    [anon_sym_interface] = ACTIONS(4082),
    [anon_sym_abstract] = ACTIONS(4082),
    [anon_sym_val] = ACTIONS(4082),
    [anon_sym_override] = ACTIONS(4082),
    [aux_sym_char_token1] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4082),
    [anon_sym_DQUOTE] = ACTIONS(4082),
    [anon_sym_AT_DQUOTE] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [sym_bool] = ACTIONS(4082),
    [sym_unit] = ACTIONS(4080),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4082),
    [sym_op_identifier] = ACTIONS(4082),
    [anon_sym_PLUS] = ACTIONS(4082),
    [anon_sym_DASH] = ACTIONS(4082),
    [anon_sym_PLUS_DOT] = ACTIONS(4082),
    [anon_sym_DASH_DOT] = ACTIONS(4082),
    [anon_sym_PERCENT] = ACTIONS(4082),
    [anon_sym_AMP_AMP] = ACTIONS(4082),
    [anon_sym_TILDE] = ACTIONS(4080),
    [aux_sym_prefix_op_token1] = ACTIONS(4082),
    [aux_sym_infix_op_token1] = ACTIONS(4080),
    [aux_sym_infix_op_token2] = ACTIONS(4082),
    [anon_sym_PIPE_PIPE] = ACTIONS(4082),
    [anon_sym_BANG_EQ] = ACTIONS(4082),
    [anon_sym_COLON_EQ] = ACTIONS(4080),
    [anon_sym_DOLLAR] = ACTIONS(4082),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4082),
    [sym_int] = ACTIONS(4082),
    [sym_xint] = ACTIONS(4080),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4080),
    [sym__newline] = ACTIONS(4080),
    [sym__dedent] = ACTIONS(4080),
  },
  [1903] = {
    [sym_block_comment] = STATE(1903),
    [sym_compiler_directive_decl] = STATE(1903),
    [sym_fsi_directive_decl] = STATE(1903),
    [sym_preproc_line] = STATE(1903),
    [sym_identifier] = ACTIONS(4086),
    [anon_sym_EQ] = ACTIONS(4084),
    [anon_sym_LBRACK_LT] = ACTIONS(4084),
    [anon_sym_COLON] = ACTIONS(4086),
    [anon_sym_return] = ACTIONS(4086),
    [anon_sym_do] = ACTIONS(4086),
    [anon_sym_and] = ACTIONS(4086),
    [anon_sym_let] = ACTIONS(4086),
    [anon_sym_let_BANG] = ACTIONS(4084),
    [aux_sym_access_modifier_token1] = ACTIONS(4084),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_COMMA] = ACTIONS(4084),
    [anon_sym_null] = ACTIONS(4086),
    [anon_sym_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_COLON] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4084),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_LT_AT] = ACTIONS(4086),
    [anon_sym_LT_AT_AT] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4086),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4084),
    [anon_sym_new] = ACTIONS(4086),
    [anon_sym_with] = ACTIONS(4086),
    [anon_sym_return_BANG] = ACTIONS(4084),
    [anon_sym_yield] = ACTIONS(4086),
    [anon_sym_yield_BANG] = ACTIONS(4084),
    [anon_sym_lazy] = ACTIONS(4086),
    [anon_sym_assert] = ACTIONS(4086),
    [anon_sym_upcast] = ACTIONS(4086),
    [anon_sym_downcast] = ACTIONS(4086),
    [anon_sym_COLON_GT] = ACTIONS(4084),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4084),
    [anon_sym_for] = ACTIONS(4086),
    [anon_sym_while] = ACTIONS(4086),
    [anon_sym_if] = ACTIONS(4086),
    [anon_sym_fun] = ACTIONS(4086),
    [anon_sym_try] = ACTIONS(4086),
    [anon_sym_match] = ACTIONS(4086),
    [anon_sym_match_BANG] = ACTIONS(4084),
    [anon_sym_function] = ACTIONS(4086),
    [anon_sym_LT_DASH] = ACTIONS(4086),
    [anon_sym_DOT_LBRACK] = ACTIONS(4084),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_use] = ACTIONS(4086),
    [anon_sym_use_BANG] = ACTIONS(4084),
    [anon_sym_do_BANG] = ACTIONS(4084),
    [anon_sym_begin] = ACTIONS(4086),
    [anon_sym_LPAREN2] = ACTIONS(4086),
    [anon_sym_default] = ACTIONS(4086),
    [anon_sym_or] = ACTIONS(4086),
    [anon_sym_static] = ACTIONS(4086),
    [anon_sym_member] = ACTIONS(4086),
    [anon_sym_interface] = ACTIONS(4086),
    [anon_sym_abstract] = ACTIONS(4086),
    [anon_sym_val] = ACTIONS(4086),
    [anon_sym_override] = ACTIONS(4086),
    [aux_sym_char_token1] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4086),
    [anon_sym_DQUOTE] = ACTIONS(4086),
    [anon_sym_AT_DQUOTE] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [sym_bool] = ACTIONS(4086),
    [sym_unit] = ACTIONS(4084),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4086),
    [sym_op_identifier] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4086),
    [anon_sym_DASH] = ACTIONS(4086),
    [anon_sym_PLUS_DOT] = ACTIONS(4086),
    [anon_sym_DASH_DOT] = ACTIONS(4086),
    [anon_sym_PERCENT] = ACTIONS(4086),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_TILDE] = ACTIONS(4084),
    [aux_sym_prefix_op_token1] = ACTIONS(4086),
    [aux_sym_infix_op_token1] = ACTIONS(4084),
    [aux_sym_infix_op_token2] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_COLON_EQ] = ACTIONS(4084),
    [anon_sym_DOLLAR] = ACTIONS(4086),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4086),
    [sym_int] = ACTIONS(4086),
    [sym_xint] = ACTIONS(4084),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4084),
    [sym__newline] = ACTIONS(4084),
    [sym__dedent] = ACTIONS(4084),
  },
  [1904] = {
    [sym_block_comment] = STATE(1904),
    [sym_compiler_directive_decl] = STATE(1904),
    [sym_fsi_directive_decl] = STATE(1904),
    [sym_preproc_line] = STATE(1904),
    [sym_identifier] = ACTIONS(3984),
    [anon_sym_EQ] = ACTIONS(3982),
    [anon_sym_LBRACK_LT] = ACTIONS(3982),
    [anon_sym_COLON] = ACTIONS(3984),
    [anon_sym_return] = ACTIONS(3984),
    [anon_sym_do] = ACTIONS(3984),
    [anon_sym_let] = ACTIONS(3984),
    [anon_sym_let_BANG] = ACTIONS(3982),
    [aux_sym_access_modifier_token1] = ACTIONS(3982),
    [anon_sym_LPAREN] = ACTIONS(3984),
    [anon_sym_COMMA] = ACTIONS(3982),
    [anon_sym_null] = ACTIONS(3984),
    [anon_sym_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AMP] = ACTIONS(3984),
    [anon_sym_LBRACK] = ACTIONS(3984),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(3984),
    [anon_sym_LT_AT] = ACTIONS(3984),
    [anon_sym_LT_AT_AT] = ACTIONS(3984),
    [anon_sym_DOT] = ACTIONS(3984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3982),
    [anon_sym_new] = ACTIONS(3984),
    [anon_sym_with] = ACTIONS(3984),
    [anon_sym_return_BANG] = ACTIONS(3982),
    [anon_sym_yield] = ACTIONS(3984),
    [anon_sym_yield_BANG] = ACTIONS(3982),
    [anon_sym_lazy] = ACTIONS(3984),
    [anon_sym_assert] = ACTIONS(3984),
    [anon_sym_upcast] = ACTIONS(3984),
    [anon_sym_downcast] = ACTIONS(3984),
    [anon_sym_COLON_GT] = ACTIONS(3982),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3982),
    [anon_sym_for] = ACTIONS(3984),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_if] = ACTIONS(3984),
    [anon_sym_fun] = ACTIONS(3984),
    [anon_sym_try] = ACTIONS(3984),
    [anon_sym_match] = ACTIONS(3984),
    [anon_sym_match_BANG] = ACTIONS(3982),
    [anon_sym_function] = ACTIONS(3984),
    [anon_sym_LT_DASH] = ACTIONS(3984),
    [anon_sym_DOT_LBRACK] = ACTIONS(3982),
    [anon_sym_LT] = ACTIONS(3982),
    [anon_sym_use] = ACTIONS(3984),
    [anon_sym_use_BANG] = ACTIONS(3982),
    [anon_sym_do_BANG] = ACTIONS(3982),
    [anon_sym_begin] = ACTIONS(3984),
    [anon_sym_LPAREN2] = ACTIONS(3984),
    [anon_sym_DOT_DOT2] = ACTIONS(3982),
    [anon_sym_default] = ACTIONS(3984),
    [anon_sym_or] = ACTIONS(3984),
    [anon_sym_static] = ACTIONS(3984),
    [anon_sym_member] = ACTIONS(3984),
    [anon_sym_interface] = ACTIONS(3984),
    [anon_sym_abstract] = ACTIONS(3984),
    [anon_sym_val] = ACTIONS(3984),
    [anon_sym_override] = ACTIONS(3984),
    [aux_sym_char_token1] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3984),
    [anon_sym_DQUOTE] = ACTIONS(3984),
    [anon_sym_AT_DQUOTE] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [sym_bool] = ACTIONS(3984),
    [sym_unit] = ACTIONS(3982),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3984),
    [sym_op_identifier] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3984),
    [anon_sym_DASH] = ACTIONS(3984),
    [anon_sym_PLUS_DOT] = ACTIONS(3984),
    [anon_sym_DASH_DOT] = ACTIONS(3984),
    [anon_sym_PERCENT] = ACTIONS(3984),
    [anon_sym_AMP_AMP] = ACTIONS(3984),
    [anon_sym_TILDE] = ACTIONS(3982),
    [aux_sym_prefix_op_token1] = ACTIONS(3984),
    [aux_sym_infix_op_token1] = ACTIONS(3982),
    [aux_sym_infix_op_token2] = ACTIONS(3984),
    [anon_sym_PIPE_PIPE] = ACTIONS(3984),
    [anon_sym_BANG_EQ] = ACTIONS(3984),
    [anon_sym_COLON_EQ] = ACTIONS(3982),
    [anon_sym_DOLLAR] = ACTIONS(3984),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3984),
    [sym_int] = ACTIONS(3984),
    [sym_xint] = ACTIONS(3982),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3982),
    [sym__newline] = ACTIONS(3982),
    [sym__dedent] = ACTIONS(3982),
  },
  [1905] = {
    [sym_block_comment] = STATE(1905),
    [sym_compiler_directive_decl] = STATE(1905),
    [sym_fsi_directive_decl] = STATE(1905),
    [sym_preproc_line] = STATE(1905),
    [sym_identifier] = ACTIONS(3988),
    [anon_sym_EQ] = ACTIONS(3986),
    [anon_sym_LBRACK_LT] = ACTIONS(3986),
    [anon_sym_COLON] = ACTIONS(3988),
    [anon_sym_return] = ACTIONS(3988),
    [anon_sym_do] = ACTIONS(3988),
    [anon_sym_let] = ACTIONS(3988),
    [anon_sym_let_BANG] = ACTIONS(3986),
    [aux_sym_access_modifier_token1] = ACTIONS(3986),
    [anon_sym_LPAREN] = ACTIONS(3988),
    [anon_sym_COMMA] = ACTIONS(3986),
    [anon_sym_null] = ACTIONS(3988),
    [anon_sym_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_COLON] = ACTIONS(3986),
    [anon_sym_AMP] = ACTIONS(3988),
    [anon_sym_LBRACK] = ACTIONS(3988),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3986),
    [anon_sym_LBRACE] = ACTIONS(3988),
    [anon_sym_LT_AT] = ACTIONS(3988),
    [anon_sym_LT_AT_AT] = ACTIONS(3988),
    [anon_sym_DOT] = ACTIONS(3988),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3986),
    [anon_sym_new] = ACTIONS(3988),
    [anon_sym_with] = ACTIONS(3988),
    [anon_sym_return_BANG] = ACTIONS(3986),
    [anon_sym_yield] = ACTIONS(3988),
    [anon_sym_yield_BANG] = ACTIONS(3986),
    [anon_sym_lazy] = ACTIONS(3988),
    [anon_sym_assert] = ACTIONS(3988),
    [anon_sym_upcast] = ACTIONS(3988),
    [anon_sym_downcast] = ACTIONS(3988),
    [anon_sym_COLON_GT] = ACTIONS(3986),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_while] = ACTIONS(3988),
    [anon_sym_if] = ACTIONS(3988),
    [anon_sym_fun] = ACTIONS(3988),
    [anon_sym_try] = ACTIONS(3988),
    [anon_sym_match] = ACTIONS(3988),
    [anon_sym_match_BANG] = ACTIONS(3986),
    [anon_sym_function] = ACTIONS(3988),
    [anon_sym_LT_DASH] = ACTIONS(3988),
    [anon_sym_DOT_LBRACK] = ACTIONS(3986),
    [anon_sym_LT] = ACTIONS(3986),
    [anon_sym_use] = ACTIONS(3988),
    [anon_sym_use_BANG] = ACTIONS(3986),
    [anon_sym_do_BANG] = ACTIONS(3986),
    [anon_sym_begin] = ACTIONS(3988),
    [anon_sym_LPAREN2] = ACTIONS(3988),
    [anon_sym_DOT_DOT2] = ACTIONS(3986),
    [anon_sym_default] = ACTIONS(3988),
    [anon_sym_or] = ACTIONS(3988),
    [anon_sym_static] = ACTIONS(3988),
    [anon_sym_member] = ACTIONS(3988),
    [anon_sym_interface] = ACTIONS(3988),
    [anon_sym_abstract] = ACTIONS(3988),
    [anon_sym_val] = ACTIONS(3988),
    [anon_sym_override] = ACTIONS(3988),
    [aux_sym_char_token1] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3988),
    [anon_sym_DQUOTE] = ACTIONS(3988),
    [anon_sym_AT_DQUOTE] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [sym_bool] = ACTIONS(3988),
    [sym_unit] = ACTIONS(3986),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3988),
    [sym_op_identifier] = ACTIONS(3988),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_PLUS_DOT] = ACTIONS(3988),
    [anon_sym_DASH_DOT] = ACTIONS(3988),
    [anon_sym_PERCENT] = ACTIONS(3988),
    [anon_sym_AMP_AMP] = ACTIONS(3988),
    [anon_sym_TILDE] = ACTIONS(3986),
    [aux_sym_prefix_op_token1] = ACTIONS(3988),
    [aux_sym_infix_op_token1] = ACTIONS(3986),
    [aux_sym_infix_op_token2] = ACTIONS(3988),
    [anon_sym_PIPE_PIPE] = ACTIONS(3988),
    [anon_sym_BANG_EQ] = ACTIONS(3988),
    [anon_sym_COLON_EQ] = ACTIONS(3986),
    [anon_sym_DOLLAR] = ACTIONS(3988),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3988),
    [sym_int] = ACTIONS(3988),
    [sym_xint] = ACTIONS(3986),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3986),
    [sym__newline] = ACTIONS(3986),
    [sym__dedent] = ACTIONS(3986),
  },
  [1906] = {
    [sym_block_comment] = STATE(1906),
    [sym_compiler_directive_decl] = STATE(1906),
    [sym_fsi_directive_decl] = STATE(1906),
    [sym_preproc_line] = STATE(1906),
    [sym_identifier] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(4076),
    [anon_sym_LBRACK_LT] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4078),
    [anon_sym_return] = ACTIONS(4078),
    [anon_sym_do] = ACTIONS(4078),
    [anon_sym_let] = ACTIONS(4078),
    [anon_sym_let_BANG] = ACTIONS(4076),
    [aux_sym_access_modifier_token1] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_null] = ACTIONS(4078),
    [anon_sym_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(4076),
    [anon_sym_AMP] = ACTIONS(4078),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4078),
    [anon_sym_LT_AT] = ACTIONS(4078),
    [anon_sym_LT_AT_AT] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(4078),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4076),
    [anon_sym_new] = ACTIONS(4078),
    [anon_sym_with] = ACTIONS(4078),
    [anon_sym_return_BANG] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(4078),
    [anon_sym_yield_BANG] = ACTIONS(4076),
    [anon_sym_lazy] = ACTIONS(4078),
    [anon_sym_assert] = ACTIONS(4078),
    [anon_sym_upcast] = ACTIONS(4078),
    [anon_sym_downcast] = ACTIONS(4078),
    [anon_sym_COLON_GT] = ACTIONS(4076),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4076),
    [anon_sym_for] = ACTIONS(4078),
    [anon_sym_while] = ACTIONS(4078),
    [anon_sym_if] = ACTIONS(4078),
    [anon_sym_fun] = ACTIONS(4078),
    [anon_sym_try] = ACTIONS(4078),
    [anon_sym_match] = ACTIONS(4078),
    [anon_sym_match_BANG] = ACTIONS(4076),
    [anon_sym_function] = ACTIONS(4078),
    [anon_sym_LT_DASH] = ACTIONS(4078),
    [anon_sym_DOT_LBRACK] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4076),
    [anon_sym_use] = ACTIONS(4078),
    [anon_sym_use_BANG] = ACTIONS(4076),
    [anon_sym_do_BANG] = ACTIONS(4076),
    [anon_sym_begin] = ACTIONS(4078),
    [anon_sym_LPAREN2] = ACTIONS(4078),
    [anon_sym_DOT_DOT2] = ACTIONS(4076),
    [anon_sym_default] = ACTIONS(4078),
    [anon_sym_or] = ACTIONS(4078),
    [anon_sym_static] = ACTIONS(4078),
    [anon_sym_member] = ACTIONS(4078),
    [anon_sym_interface] = ACTIONS(4078),
    [anon_sym_abstract] = ACTIONS(4078),
    [anon_sym_val] = ACTIONS(4078),
    [anon_sym_override] = ACTIONS(4078),
    [aux_sym_char_token1] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4078),
    [anon_sym_DQUOTE] = ACTIONS(4078),
    [anon_sym_AT_DQUOTE] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [sym_bool] = ACTIONS(4078),
    [sym_unit] = ACTIONS(4076),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4078),
    [sym_op_identifier] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(4078),
    [anon_sym_PLUS_DOT] = ACTIONS(4078),
    [anon_sym_DASH_DOT] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [anon_sym_AMP_AMP] = ACTIONS(4078),
    [anon_sym_TILDE] = ACTIONS(4076),
    [aux_sym_prefix_op_token1] = ACTIONS(4078),
    [aux_sym_infix_op_token1] = ACTIONS(4076),
    [aux_sym_infix_op_token2] = ACTIONS(4078),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_BANG_EQ] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4076),
    [anon_sym_DOLLAR] = ACTIONS(4078),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4078),
    [sym_int] = ACTIONS(4078),
    [sym_xint] = ACTIONS(4076),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4076),
    [sym__newline] = ACTIONS(4076),
    [sym__dedent] = ACTIONS(4076),
  },
  [1907] = {
    [sym_block_comment] = STATE(1907),
    [sym_compiler_directive_decl] = STATE(1907),
    [sym_fsi_directive_decl] = STATE(1907),
    [sym_preproc_line] = STATE(1907),
    [sym_identifier] = ACTIONS(3996),
    [anon_sym_EQ] = ACTIONS(3994),
    [anon_sym_LBRACK_LT] = ACTIONS(3994),
    [anon_sym_COLON] = ACTIONS(3996),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_do] = ACTIONS(3996),
    [anon_sym_and] = ACTIONS(3996),
    [anon_sym_let] = ACTIONS(3996),
    [anon_sym_let_BANG] = ACTIONS(3994),
    [aux_sym_access_modifier_token1] = ACTIONS(3994),
    [anon_sym_LPAREN] = ACTIONS(3996),
    [anon_sym_COMMA] = ACTIONS(3994),
    [anon_sym_null] = ACTIONS(3996),
    [anon_sym_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_COLON] = ACTIONS(3994),
    [anon_sym_AMP] = ACTIONS(3996),
    [anon_sym_LBRACK] = ACTIONS(3996),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3994),
    [anon_sym_LBRACE] = ACTIONS(3996),
    [anon_sym_LT_AT] = ACTIONS(3996),
    [anon_sym_LT_AT_AT] = ACTIONS(3996),
    [anon_sym_DOT] = ACTIONS(3996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3994),
    [anon_sym_new] = ACTIONS(3996),
    [anon_sym_with] = ACTIONS(3996),
    [anon_sym_return_BANG] = ACTIONS(3994),
    [anon_sym_yield] = ACTIONS(3996),
    [anon_sym_yield_BANG] = ACTIONS(3994),
    [anon_sym_lazy] = ACTIONS(3996),
    [anon_sym_assert] = ACTIONS(3996),
    [anon_sym_upcast] = ACTIONS(3996),
    [anon_sym_downcast] = ACTIONS(3996),
    [anon_sym_COLON_GT] = ACTIONS(3994),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3994),
    [anon_sym_for] = ACTIONS(3996),
    [anon_sym_while] = ACTIONS(3996),
    [anon_sym_if] = ACTIONS(3996),
    [anon_sym_fun] = ACTIONS(3996),
    [anon_sym_try] = ACTIONS(3996),
    [anon_sym_match] = ACTIONS(3996),
    [anon_sym_match_BANG] = ACTIONS(3994),
    [anon_sym_function] = ACTIONS(3996),
    [anon_sym_LT_DASH] = ACTIONS(3996),
    [anon_sym_DOT_LBRACK] = ACTIONS(3994),
    [anon_sym_LT] = ACTIONS(3994),
    [anon_sym_use] = ACTIONS(3996),
    [anon_sym_use_BANG] = ACTIONS(3994),
    [anon_sym_do_BANG] = ACTIONS(3994),
    [anon_sym_begin] = ACTIONS(3996),
    [anon_sym_LPAREN2] = ACTIONS(3996),
    [anon_sym_default] = ACTIONS(3996),
    [anon_sym_or] = ACTIONS(3996),
    [anon_sym_static] = ACTIONS(3996),
    [anon_sym_member] = ACTIONS(3996),
    [anon_sym_interface] = ACTIONS(3996),
    [anon_sym_abstract] = ACTIONS(3996),
    [anon_sym_val] = ACTIONS(3996),
    [anon_sym_override] = ACTIONS(3996),
    [aux_sym_char_token1] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3996),
    [anon_sym_DQUOTE] = ACTIONS(3996),
    [anon_sym_AT_DQUOTE] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [sym_bool] = ACTIONS(3996),
    [sym_unit] = ACTIONS(3994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3996),
    [sym_op_identifier] = ACTIONS(3996),
    [anon_sym_PLUS] = ACTIONS(3996),
    [anon_sym_DASH] = ACTIONS(3996),
    [anon_sym_PLUS_DOT] = ACTIONS(3996),
    [anon_sym_DASH_DOT] = ACTIONS(3996),
    [anon_sym_PERCENT] = ACTIONS(3996),
    [anon_sym_AMP_AMP] = ACTIONS(3996),
    [anon_sym_TILDE] = ACTIONS(3994),
    [aux_sym_prefix_op_token1] = ACTIONS(3996),
    [aux_sym_infix_op_token1] = ACTIONS(3994),
    [aux_sym_infix_op_token2] = ACTIONS(3996),
    [anon_sym_PIPE_PIPE] = ACTIONS(3996),
    [anon_sym_BANG_EQ] = ACTIONS(3996),
    [anon_sym_COLON_EQ] = ACTIONS(3994),
    [anon_sym_DOLLAR] = ACTIONS(3996),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3996),
    [sym_int] = ACTIONS(3996),
    [sym_xint] = ACTIONS(3994),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3994),
    [sym__newline] = ACTIONS(3994),
    [sym__dedent] = ACTIONS(3994),
  },
  [1908] = {
    [sym_block_comment] = STATE(1908),
    [sym_compiler_directive_decl] = STATE(1908),
    [sym_fsi_directive_decl] = STATE(1908),
    [sym_preproc_line] = STATE(1908),
    [sym_identifier] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(4091),
    [anon_sym_LBRACK_LT] = ACTIONS(4091),
    [anon_sym_COLON] = ACTIONS(4093),
    [anon_sym_return] = ACTIONS(4093),
    [anon_sym_do] = ACTIONS(4093),
    [anon_sym_and] = ACTIONS(4093),
    [anon_sym_let] = ACTIONS(4093),
    [anon_sym_let_BANG] = ACTIONS(4091),
    [aux_sym_access_modifier_token1] = ACTIONS(4091),
    [anon_sym_LPAREN] = ACTIONS(4093),
    [anon_sym_COMMA] = ACTIONS(4091),
    [anon_sym_null] = ACTIONS(4093),
    [anon_sym_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_COLON] = ACTIONS(4091),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(4093),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4091),
    [anon_sym_LBRACE] = ACTIONS(4093),
    [anon_sym_LT_AT] = ACTIONS(4093),
    [anon_sym_LT_AT_AT] = ACTIONS(4093),
    [anon_sym_DOT] = ACTIONS(4093),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4091),
    [anon_sym_new] = ACTIONS(4093),
    [anon_sym_with] = ACTIONS(4093),
    [anon_sym_return_BANG] = ACTIONS(4091),
    [anon_sym_yield] = ACTIONS(4093),
    [anon_sym_yield_BANG] = ACTIONS(4091),
    [anon_sym_lazy] = ACTIONS(4093),
    [anon_sym_assert] = ACTIONS(4093),
    [anon_sym_upcast] = ACTIONS(4093),
    [anon_sym_downcast] = ACTIONS(4093),
    [anon_sym_COLON_GT] = ACTIONS(4091),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4091),
    [anon_sym_for] = ACTIONS(4093),
    [anon_sym_while] = ACTIONS(4093),
    [anon_sym_if] = ACTIONS(4093),
    [anon_sym_fun] = ACTIONS(4093),
    [anon_sym_try] = ACTIONS(4093),
    [anon_sym_match] = ACTIONS(4093),
    [anon_sym_match_BANG] = ACTIONS(4091),
    [anon_sym_function] = ACTIONS(4093),
    [anon_sym_LT_DASH] = ACTIONS(4093),
    [anon_sym_DOT_LBRACK] = ACTIONS(4091),
    [anon_sym_LT] = ACTIONS(4091),
    [anon_sym_use] = ACTIONS(4093),
    [anon_sym_use_BANG] = ACTIONS(4091),
    [anon_sym_do_BANG] = ACTIONS(4091),
    [anon_sym_begin] = ACTIONS(4093),
    [anon_sym_LPAREN2] = ACTIONS(4093),
    [anon_sym_default] = ACTIONS(4093),
    [anon_sym_or] = ACTIONS(4093),
    [anon_sym_static] = ACTIONS(4093),
    [anon_sym_member] = ACTIONS(4093),
    [anon_sym_interface] = ACTIONS(4093),
    [anon_sym_abstract] = ACTIONS(4093),
    [anon_sym_val] = ACTIONS(4093),
    [anon_sym_override] = ACTIONS(4093),
    [aux_sym_char_token1] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4093),
    [anon_sym_DQUOTE] = ACTIONS(4093),
    [anon_sym_AT_DQUOTE] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [sym_bool] = ACTIONS(4093),
    [sym_unit] = ACTIONS(4091),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4093),
    [sym_op_identifier] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS_DOT] = ACTIONS(4093),
    [anon_sym_DASH_DOT] = ACTIONS(4093),
    [anon_sym_PERCENT] = ACTIONS(4093),
    [anon_sym_AMP_AMP] = ACTIONS(4093),
    [anon_sym_TILDE] = ACTIONS(4091),
    [aux_sym_prefix_op_token1] = ACTIONS(4093),
    [aux_sym_infix_op_token1] = ACTIONS(4091),
    [aux_sym_infix_op_token2] = ACTIONS(4093),
    [anon_sym_PIPE_PIPE] = ACTIONS(4093),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_COLON_EQ] = ACTIONS(4091),
    [anon_sym_DOLLAR] = ACTIONS(4093),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4093),
    [sym_int] = ACTIONS(4093),
    [sym_xint] = ACTIONS(4091),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4091),
    [sym__newline] = ACTIONS(4091),
    [sym__dedent] = ACTIONS(4091),
  },
  [1909] = {
    [sym_block_comment] = STATE(1909),
    [sym_compiler_directive_decl] = STATE(1909),
    [sym_fsi_directive_decl] = STATE(1909),
    [sym_preproc_line] = STATE(1909),
    [sym_identifier] = ACTIONS(3972),
    [anon_sym_EQ] = ACTIONS(3970),
    [anon_sym_LBRACK_LT] = ACTIONS(3970),
    [anon_sym_COLON] = ACTIONS(3972),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_do] = ACTIONS(3972),
    [anon_sym_and] = ACTIONS(3972),
    [anon_sym_let] = ACTIONS(3972),
    [anon_sym_let_BANG] = ACTIONS(3970),
    [aux_sym_access_modifier_token1] = ACTIONS(3970),
    [anon_sym_LPAREN] = ACTIONS(3972),
    [anon_sym_COMMA] = ACTIONS(3970),
    [anon_sym_null] = ACTIONS(3972),
    [anon_sym_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_COLON] = ACTIONS(3970),
    [anon_sym_AMP] = ACTIONS(3972),
    [anon_sym_LBRACK] = ACTIONS(3972),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3970),
    [anon_sym_LBRACE] = ACTIONS(3972),
    [anon_sym_LT_AT] = ACTIONS(3972),
    [anon_sym_LT_AT_AT] = ACTIONS(3972),
    [anon_sym_DOT] = ACTIONS(3972),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3970),
    [anon_sym_new] = ACTIONS(3972),
    [anon_sym_with] = ACTIONS(3972),
    [anon_sym_return_BANG] = ACTIONS(3970),
    [anon_sym_yield] = ACTIONS(3972),
    [anon_sym_yield_BANG] = ACTIONS(3970),
    [anon_sym_lazy] = ACTIONS(3972),
    [anon_sym_assert] = ACTIONS(3972),
    [anon_sym_upcast] = ACTIONS(3972),
    [anon_sym_downcast] = ACTIONS(3972),
    [anon_sym_COLON_GT] = ACTIONS(3970),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3970),
    [anon_sym_for] = ACTIONS(3972),
    [anon_sym_while] = ACTIONS(3972),
    [anon_sym_if] = ACTIONS(3972),
    [anon_sym_fun] = ACTIONS(3972),
    [anon_sym_try] = ACTIONS(3972),
    [anon_sym_match] = ACTIONS(3972),
    [anon_sym_match_BANG] = ACTIONS(3970),
    [anon_sym_function] = ACTIONS(3972),
    [anon_sym_LT_DASH] = ACTIONS(3972),
    [anon_sym_DOT_LBRACK] = ACTIONS(3970),
    [anon_sym_LT] = ACTIONS(3970),
    [anon_sym_use] = ACTIONS(3972),
    [anon_sym_use_BANG] = ACTIONS(3970),
    [anon_sym_do_BANG] = ACTIONS(3970),
    [anon_sym_begin] = ACTIONS(3972),
    [anon_sym_LPAREN2] = ACTIONS(3972),
    [anon_sym_default] = ACTIONS(3972),
    [anon_sym_or] = ACTIONS(3972),
    [anon_sym_static] = ACTIONS(3972),
    [anon_sym_member] = ACTIONS(3972),
    [anon_sym_interface] = ACTIONS(3972),
    [anon_sym_abstract] = ACTIONS(3972),
    [anon_sym_val] = ACTIONS(3972),
    [anon_sym_override] = ACTIONS(3972),
    [aux_sym_char_token1] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3972),
    [anon_sym_DQUOTE] = ACTIONS(3972),
    [anon_sym_AT_DQUOTE] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [sym_bool] = ACTIONS(3972),
    [sym_unit] = ACTIONS(3970),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3972),
    [sym_op_identifier] = ACTIONS(3972),
    [anon_sym_PLUS] = ACTIONS(3972),
    [anon_sym_DASH] = ACTIONS(3972),
    [anon_sym_PLUS_DOT] = ACTIONS(3972),
    [anon_sym_DASH_DOT] = ACTIONS(3972),
    [anon_sym_PERCENT] = ACTIONS(3972),
    [anon_sym_AMP_AMP] = ACTIONS(3972),
    [anon_sym_TILDE] = ACTIONS(3970),
    [aux_sym_prefix_op_token1] = ACTIONS(3972),
    [aux_sym_infix_op_token1] = ACTIONS(3970),
    [aux_sym_infix_op_token2] = ACTIONS(3972),
    [anon_sym_PIPE_PIPE] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3972),
    [anon_sym_COLON_EQ] = ACTIONS(3970),
    [anon_sym_DOLLAR] = ACTIONS(3972),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3972),
    [sym_int] = ACTIONS(3972),
    [sym_xint] = ACTIONS(3970),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3970),
    [sym__newline] = ACTIONS(3970),
    [sym__dedent] = ACTIONS(3970),
  },
  [1910] = {
    [sym_block_comment] = STATE(1910),
    [sym_compiler_directive_decl] = STATE(1910),
    [sym_fsi_directive_decl] = STATE(1910),
    [sym_preproc_line] = STATE(1910),
    [sym_identifier] = ACTIONS(3946),
    [anon_sym_EQ] = ACTIONS(3944),
    [anon_sym_LBRACK_LT] = ACTIONS(3944),
    [anon_sym_COLON] = ACTIONS(3946),
    [anon_sym_return] = ACTIONS(3946),
    [anon_sym_do] = ACTIONS(3946),
    [anon_sym_and] = ACTIONS(3946),
    [anon_sym_let] = ACTIONS(3946),
    [anon_sym_let_BANG] = ACTIONS(3944),
    [aux_sym_access_modifier_token1] = ACTIONS(3944),
    [anon_sym_LPAREN] = ACTIONS(3946),
    [anon_sym_COMMA] = ACTIONS(3944),
    [anon_sym_null] = ACTIONS(3946),
    [anon_sym_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LBRACK] = ACTIONS(3946),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3944),
    [anon_sym_LBRACE] = ACTIONS(3946),
    [anon_sym_LT_AT] = ACTIONS(3946),
    [anon_sym_LT_AT_AT] = ACTIONS(3946),
    [anon_sym_DOT] = ACTIONS(3946),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3944),
    [anon_sym_new] = ACTIONS(3946),
    [anon_sym_with] = ACTIONS(3946),
    [anon_sym_return_BANG] = ACTIONS(3944),
    [anon_sym_yield] = ACTIONS(3946),
    [anon_sym_yield_BANG] = ACTIONS(3944),
    [anon_sym_lazy] = ACTIONS(3946),
    [anon_sym_assert] = ACTIONS(3946),
    [anon_sym_upcast] = ACTIONS(3946),
    [anon_sym_downcast] = ACTIONS(3946),
    [anon_sym_COLON_GT] = ACTIONS(3944),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3944),
    [anon_sym_for] = ACTIONS(3946),
    [anon_sym_while] = ACTIONS(3946),
    [anon_sym_if] = ACTIONS(3946),
    [anon_sym_fun] = ACTIONS(3946),
    [anon_sym_try] = ACTIONS(3946),
    [anon_sym_match] = ACTIONS(3946),
    [anon_sym_match_BANG] = ACTIONS(3944),
    [anon_sym_function] = ACTIONS(3946),
    [anon_sym_LT_DASH] = ACTIONS(3946),
    [anon_sym_DOT_LBRACK] = ACTIONS(3944),
    [anon_sym_LT] = ACTIONS(3944),
    [anon_sym_use] = ACTIONS(3946),
    [anon_sym_use_BANG] = ACTIONS(3944),
    [anon_sym_do_BANG] = ACTIONS(3944),
    [anon_sym_begin] = ACTIONS(3946),
    [anon_sym_LPAREN2] = ACTIONS(3946),
    [anon_sym_default] = ACTIONS(3946),
    [anon_sym_or] = ACTIONS(3946),
    [anon_sym_static] = ACTIONS(3946),
    [anon_sym_member] = ACTIONS(3946),
    [anon_sym_interface] = ACTIONS(3946),
    [anon_sym_abstract] = ACTIONS(3946),
    [anon_sym_val] = ACTIONS(3946),
    [anon_sym_override] = ACTIONS(3946),
    [aux_sym_char_token1] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_AT_DQUOTE] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [sym_bool] = ACTIONS(3946),
    [sym_unit] = ACTIONS(3944),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3946),
    [sym_op_identifier] = ACTIONS(3946),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PLUS_DOT] = ACTIONS(3946),
    [anon_sym_DASH_DOT] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3946),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_TILDE] = ACTIONS(3944),
    [aux_sym_prefix_op_token1] = ACTIONS(3946),
    [aux_sym_infix_op_token1] = ACTIONS(3944),
    [aux_sym_infix_op_token2] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [anon_sym_BANG_EQ] = ACTIONS(3946),
    [anon_sym_COLON_EQ] = ACTIONS(3944),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3946),
    [sym_int] = ACTIONS(3946),
    [sym_xint] = ACTIONS(3944),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3944),
    [sym__newline] = ACTIONS(3944),
    [sym__dedent] = ACTIONS(3944),
  },
  [1911] = {
    [sym_block_comment] = STATE(1911),
    [sym_compiler_directive_decl] = STATE(1911),
    [sym_fsi_directive_decl] = STATE(1911),
    [sym_preproc_line] = STATE(1911),
    [sym_identifier] = ACTIONS(4108),
    [anon_sym_EQ] = ACTIONS(4106),
    [anon_sym_LBRACK_LT] = ACTIONS(4106),
    [anon_sym_COLON] = ACTIONS(4108),
    [anon_sym_return] = ACTIONS(4108),
    [anon_sym_do] = ACTIONS(4108),
    [anon_sym_and] = ACTIONS(4108),
    [anon_sym_let] = ACTIONS(4108),
    [anon_sym_let_BANG] = ACTIONS(4106),
    [aux_sym_access_modifier_token1] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(4108),
    [anon_sym_COMMA] = ACTIONS(4106),
    [anon_sym_null] = ACTIONS(4108),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_COLON] = ACTIONS(4106),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LBRACK] = ACTIONS(4108),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(4108),
    [anon_sym_LT_AT] = ACTIONS(4108),
    [anon_sym_LT_AT_AT] = ACTIONS(4108),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4106),
    [anon_sym_new] = ACTIONS(4108),
    [anon_sym_with] = ACTIONS(4108),
    [anon_sym_return_BANG] = ACTIONS(4106),
    [anon_sym_yield] = ACTIONS(4108),
    [anon_sym_yield_BANG] = ACTIONS(4106),
    [anon_sym_lazy] = ACTIONS(4108),
    [anon_sym_assert] = ACTIONS(4108),
    [anon_sym_upcast] = ACTIONS(4108),
    [anon_sym_downcast] = ACTIONS(4108),
    [anon_sym_COLON_GT] = ACTIONS(4106),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4106),
    [anon_sym_for] = ACTIONS(4108),
    [anon_sym_while] = ACTIONS(4108),
    [anon_sym_if] = ACTIONS(4108),
    [anon_sym_fun] = ACTIONS(4108),
    [anon_sym_try] = ACTIONS(4108),
    [anon_sym_match] = ACTIONS(4108),
    [anon_sym_match_BANG] = ACTIONS(4106),
    [anon_sym_function] = ACTIONS(4108),
    [anon_sym_LT_DASH] = ACTIONS(4108),
    [anon_sym_DOT_LBRACK] = ACTIONS(4106),
    [anon_sym_LT] = ACTIONS(4106),
    [anon_sym_use] = ACTIONS(4108),
    [anon_sym_use_BANG] = ACTIONS(4106),
    [anon_sym_do_BANG] = ACTIONS(4106),
    [anon_sym_begin] = ACTIONS(4108),
    [anon_sym_LPAREN2] = ACTIONS(4108),
    [anon_sym_default] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [anon_sym_static] = ACTIONS(4108),
    [anon_sym_member] = ACTIONS(4108),
    [anon_sym_interface] = ACTIONS(4108),
    [anon_sym_abstract] = ACTIONS(4108),
    [anon_sym_val] = ACTIONS(4108),
    [anon_sym_override] = ACTIONS(4108),
    [aux_sym_char_token1] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4108),
    [anon_sym_DQUOTE] = ACTIONS(4108),
    [anon_sym_AT_DQUOTE] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [sym_bool] = ACTIONS(4108),
    [sym_unit] = ACTIONS(4106),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4108),
    [sym_op_identifier] = ACTIONS(4108),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_PLUS_DOT] = ACTIONS(4108),
    [anon_sym_DASH_DOT] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_AMP_AMP] = ACTIONS(4108),
    [anon_sym_TILDE] = ACTIONS(4106),
    [aux_sym_prefix_op_token1] = ACTIONS(4108),
    [aux_sym_infix_op_token1] = ACTIONS(4106),
    [aux_sym_infix_op_token2] = ACTIONS(4108),
    [anon_sym_PIPE_PIPE] = ACTIONS(4108),
    [anon_sym_BANG_EQ] = ACTIONS(4108),
    [anon_sym_COLON_EQ] = ACTIONS(4106),
    [anon_sym_DOLLAR] = ACTIONS(4108),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4108),
    [sym_int] = ACTIONS(4108),
    [sym_xint] = ACTIONS(4106),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4106),
    [sym__newline] = ACTIONS(4106),
    [sym__dedent] = ACTIONS(4106),
  },
  [1912] = {
    [sym_block_comment] = STATE(1912),
    [sym_compiler_directive_decl] = STATE(1912),
    [sym_fsi_directive_decl] = STATE(1912),
    [sym_preproc_line] = STATE(1912),
    [sym_identifier] = ACTIONS(4112),
    [anon_sym_EQ] = ACTIONS(4110),
    [anon_sym_LBRACK_LT] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4112),
    [anon_sym_return] = ACTIONS(4112),
    [anon_sym_do] = ACTIONS(4112),
    [anon_sym_and] = ACTIONS(4112),
    [anon_sym_let] = ACTIONS(4112),
    [anon_sym_let_BANG] = ACTIONS(4110),
    [aux_sym_access_modifier_token1] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_null] = ACTIONS(4112),
    [anon_sym_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_COLON] = ACTIONS(4110),
    [anon_sym_AMP] = ACTIONS(4112),
    [anon_sym_LBRACK] = ACTIONS(4112),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4110),
    [anon_sym_LBRACE] = ACTIONS(4112),
    [anon_sym_LT_AT] = ACTIONS(4112),
    [anon_sym_LT_AT_AT] = ACTIONS(4112),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4110),
    [anon_sym_new] = ACTIONS(4112),
    [anon_sym_with] = ACTIONS(4112),
    [anon_sym_return_BANG] = ACTIONS(4110),
    [anon_sym_yield] = ACTIONS(4112),
    [anon_sym_yield_BANG] = ACTIONS(4110),
    [anon_sym_lazy] = ACTIONS(4112),
    [anon_sym_assert] = ACTIONS(4112),
    [anon_sym_upcast] = ACTIONS(4112),
    [anon_sym_downcast] = ACTIONS(4112),
    [anon_sym_COLON_GT] = ACTIONS(4110),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4110),
    [anon_sym_for] = ACTIONS(4112),
    [anon_sym_while] = ACTIONS(4112),
    [anon_sym_if] = ACTIONS(4112),
    [anon_sym_fun] = ACTIONS(4112),
    [anon_sym_try] = ACTIONS(4112),
    [anon_sym_match] = ACTIONS(4112),
    [anon_sym_match_BANG] = ACTIONS(4110),
    [anon_sym_function] = ACTIONS(4112),
    [anon_sym_LT_DASH] = ACTIONS(4112),
    [anon_sym_DOT_LBRACK] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(4110),
    [anon_sym_use] = ACTIONS(4112),
    [anon_sym_use_BANG] = ACTIONS(4110),
    [anon_sym_do_BANG] = ACTIONS(4110),
    [anon_sym_begin] = ACTIONS(4112),
    [anon_sym_LPAREN2] = ACTIONS(4112),
    [anon_sym_default] = ACTIONS(4112),
    [anon_sym_or] = ACTIONS(4112),
    [anon_sym_static] = ACTIONS(4112),
    [anon_sym_member] = ACTIONS(4112),
    [anon_sym_interface] = ACTIONS(4112),
    [anon_sym_abstract] = ACTIONS(4112),
    [anon_sym_val] = ACTIONS(4112),
    [anon_sym_override] = ACTIONS(4112),
    [aux_sym_char_token1] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4112),
    [anon_sym_DQUOTE] = ACTIONS(4112),
    [anon_sym_AT_DQUOTE] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [sym_bool] = ACTIONS(4112),
    [sym_unit] = ACTIONS(4110),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4112),
    [sym_op_identifier] = ACTIONS(4112),
    [anon_sym_PLUS] = ACTIONS(4112),
    [anon_sym_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_DOT] = ACTIONS(4112),
    [anon_sym_DASH_DOT] = ACTIONS(4112),
    [anon_sym_PERCENT] = ACTIONS(4112),
    [anon_sym_AMP_AMP] = ACTIONS(4112),
    [anon_sym_TILDE] = ACTIONS(4110),
    [aux_sym_prefix_op_token1] = ACTIONS(4112),
    [aux_sym_infix_op_token1] = ACTIONS(4110),
    [aux_sym_infix_op_token2] = ACTIONS(4112),
    [anon_sym_PIPE_PIPE] = ACTIONS(4112),
    [anon_sym_BANG_EQ] = ACTIONS(4112),
    [anon_sym_COLON_EQ] = ACTIONS(4110),
    [anon_sym_DOLLAR] = ACTIONS(4112),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4112),
    [sym_int] = ACTIONS(4112),
    [sym_xint] = ACTIONS(4110),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4110),
    [sym__newline] = ACTIONS(4110),
    [sym__dedent] = ACTIONS(4110),
  },
  [1913] = {
    [sym_block_comment] = STATE(1913),
    [sym_compiler_directive_decl] = STATE(1913),
    [sym_fsi_directive_decl] = STATE(1913),
    [sym_preproc_line] = STATE(1913),
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_EQ] = ACTIONS(3990),
    [anon_sym_LBRACK_LT] = ACTIONS(3990),
    [anon_sym_COLON] = ACTIONS(3992),
    [anon_sym_return] = ACTIONS(3992),
    [anon_sym_do] = ACTIONS(3992),
    [anon_sym_let] = ACTIONS(3992),
    [anon_sym_let_BANG] = ACTIONS(3990),
    [aux_sym_access_modifier_token1] = ACTIONS(3990),
    [anon_sym_LPAREN] = ACTIONS(3992),
    [anon_sym_COMMA] = ACTIONS(3990),
    [anon_sym_null] = ACTIONS(3992),
    [anon_sym_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [anon_sym_AMP] = ACTIONS(3992),
    [anon_sym_LBRACK] = ACTIONS(3992),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3990),
    [anon_sym_LBRACE] = ACTIONS(3992),
    [anon_sym_LT_AT] = ACTIONS(3992),
    [anon_sym_LT_AT_AT] = ACTIONS(3992),
    [anon_sym_DOT] = ACTIONS(3992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3990),
    [anon_sym_new] = ACTIONS(3992),
    [anon_sym_with] = ACTIONS(3992),
    [anon_sym_return_BANG] = ACTIONS(3990),
    [anon_sym_yield] = ACTIONS(3992),
    [anon_sym_yield_BANG] = ACTIONS(3990),
    [anon_sym_lazy] = ACTIONS(3992),
    [anon_sym_assert] = ACTIONS(3992),
    [anon_sym_upcast] = ACTIONS(3992),
    [anon_sym_downcast] = ACTIONS(3992),
    [anon_sym_COLON_GT] = ACTIONS(3990),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3990),
    [anon_sym_for] = ACTIONS(3992),
    [anon_sym_while] = ACTIONS(3992),
    [anon_sym_if] = ACTIONS(3992),
    [anon_sym_fun] = ACTIONS(3992),
    [anon_sym_try] = ACTIONS(3992),
    [anon_sym_match] = ACTIONS(3992),
    [anon_sym_match_BANG] = ACTIONS(3990),
    [anon_sym_function] = ACTIONS(3992),
    [anon_sym_LT_DASH] = ACTIONS(3992),
    [anon_sym_DOT_LBRACK] = ACTIONS(3990),
    [anon_sym_LT] = ACTIONS(3990),
    [anon_sym_use] = ACTIONS(3992),
    [anon_sym_use_BANG] = ACTIONS(3990),
    [anon_sym_do_BANG] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_LPAREN2] = ACTIONS(3992),
    [anon_sym_DOT_DOT2] = ACTIONS(3990),
    [anon_sym_default] = ACTIONS(3992),
    [anon_sym_or] = ACTIONS(3992),
    [anon_sym_static] = ACTIONS(3992),
    [anon_sym_member] = ACTIONS(3992),
    [anon_sym_interface] = ACTIONS(3992),
    [anon_sym_abstract] = ACTIONS(3992),
    [anon_sym_val] = ACTIONS(3992),
    [anon_sym_override] = ACTIONS(3992),
    [aux_sym_char_token1] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3992),
    [anon_sym_DQUOTE] = ACTIONS(3992),
    [anon_sym_AT_DQUOTE] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [sym_bool] = ACTIONS(3992),
    [sym_unit] = ACTIONS(3990),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3992),
    [sym_op_identifier] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3992),
    [anon_sym_DASH] = ACTIONS(3992),
    [anon_sym_PLUS_DOT] = ACTIONS(3992),
    [anon_sym_DASH_DOT] = ACTIONS(3992),
    [anon_sym_PERCENT] = ACTIONS(3992),
    [anon_sym_AMP_AMP] = ACTIONS(3992),
    [anon_sym_TILDE] = ACTIONS(3990),
    [aux_sym_prefix_op_token1] = ACTIONS(3992),
    [aux_sym_infix_op_token1] = ACTIONS(3990),
    [aux_sym_infix_op_token2] = ACTIONS(3992),
    [anon_sym_PIPE_PIPE] = ACTIONS(3992),
    [anon_sym_BANG_EQ] = ACTIONS(3992),
    [anon_sym_COLON_EQ] = ACTIONS(3990),
    [anon_sym_DOLLAR] = ACTIONS(3992),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3992),
    [sym_int] = ACTIONS(3992),
    [sym_xint] = ACTIONS(3990),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3990),
    [sym__newline] = ACTIONS(3990),
    [sym__dedent] = ACTIONS(3990),
  },
  [1914] = {
    [sym_block_comment] = STATE(1914),
    [sym_compiler_directive_decl] = STATE(1914),
    [sym_fsi_directive_decl] = STATE(1914),
    [sym_preproc_line] = STATE(1914),
    [sym_identifier] = ACTIONS(4118),
    [anon_sym_EQ] = ACTIONS(4116),
    [anon_sym_LBRACK_LT] = ACTIONS(4116),
    [anon_sym_COLON] = ACTIONS(4118),
    [anon_sym_return] = ACTIONS(4118),
    [anon_sym_do] = ACTIONS(4118),
    [anon_sym_and] = ACTIONS(4118),
    [anon_sym_let] = ACTIONS(4118),
    [anon_sym_let_BANG] = ACTIONS(4116),
    [aux_sym_access_modifier_token1] = ACTIONS(4116),
    [anon_sym_LPAREN] = ACTIONS(4118),
    [anon_sym_COMMA] = ACTIONS(4116),
    [anon_sym_null] = ACTIONS(4118),
    [anon_sym_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_COLON] = ACTIONS(4116),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4118),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(4118),
    [anon_sym_LT_AT] = ACTIONS(4118),
    [anon_sym_LT_AT_AT] = ACTIONS(4118),
    [anon_sym_DOT] = ACTIONS(4118),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4116),
    [anon_sym_new] = ACTIONS(4118),
    [anon_sym_with] = ACTIONS(4118),
    [anon_sym_return_BANG] = ACTIONS(4116),
    [anon_sym_yield] = ACTIONS(4118),
    [anon_sym_yield_BANG] = ACTIONS(4116),
    [anon_sym_lazy] = ACTIONS(4118),
    [anon_sym_assert] = ACTIONS(4118),
    [anon_sym_upcast] = ACTIONS(4118),
    [anon_sym_downcast] = ACTIONS(4118),
    [anon_sym_COLON_GT] = ACTIONS(4116),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4116),
    [anon_sym_for] = ACTIONS(4118),
    [anon_sym_while] = ACTIONS(4118),
    [anon_sym_if] = ACTIONS(4118),
    [anon_sym_fun] = ACTIONS(4118),
    [anon_sym_try] = ACTIONS(4118),
    [anon_sym_match] = ACTIONS(4118),
    [anon_sym_match_BANG] = ACTIONS(4116),
    [anon_sym_function] = ACTIONS(4118),
    [anon_sym_LT_DASH] = ACTIONS(4118),
    [anon_sym_DOT_LBRACK] = ACTIONS(4116),
    [anon_sym_LT] = ACTIONS(4116),
    [anon_sym_use] = ACTIONS(4118),
    [anon_sym_use_BANG] = ACTIONS(4116),
    [anon_sym_do_BANG] = ACTIONS(4116),
    [anon_sym_begin] = ACTIONS(4118),
    [anon_sym_LPAREN2] = ACTIONS(4118),
    [anon_sym_default] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [anon_sym_static] = ACTIONS(4118),
    [anon_sym_member] = ACTIONS(4118),
    [anon_sym_interface] = ACTIONS(4118),
    [anon_sym_abstract] = ACTIONS(4118),
    [anon_sym_val] = ACTIONS(4118),
    [anon_sym_override] = ACTIONS(4118),
    [aux_sym_char_token1] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4118),
    [anon_sym_DQUOTE] = ACTIONS(4118),
    [anon_sym_AT_DQUOTE] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [sym_bool] = ACTIONS(4118),
    [sym_unit] = ACTIONS(4116),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4118),
    [sym_op_identifier] = ACTIONS(4118),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_PLUS_DOT] = ACTIONS(4118),
    [anon_sym_DASH_DOT] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_AMP_AMP] = ACTIONS(4118),
    [anon_sym_TILDE] = ACTIONS(4116),
    [aux_sym_prefix_op_token1] = ACTIONS(4118),
    [aux_sym_infix_op_token1] = ACTIONS(4116),
    [aux_sym_infix_op_token2] = ACTIONS(4118),
    [anon_sym_PIPE_PIPE] = ACTIONS(4118),
    [anon_sym_BANG_EQ] = ACTIONS(4118),
    [anon_sym_COLON_EQ] = ACTIONS(4116),
    [anon_sym_DOLLAR] = ACTIONS(4118),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4118),
    [sym_int] = ACTIONS(4118),
    [sym_xint] = ACTIONS(4116),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4116),
    [sym__newline] = ACTIONS(4116),
    [sym__dedent] = ACTIONS(4116),
  },
  [1915] = {
    [sym_block_comment] = STATE(1915),
    [sym_compiler_directive_decl] = STATE(1915),
    [sym_fsi_directive_decl] = STATE(1915),
    [sym_preproc_line] = STATE(1915),
    [sym_identifier] = ACTIONS(4122),
    [anon_sym_EQ] = ACTIONS(4120),
    [anon_sym_LBRACK_LT] = ACTIONS(4120),
    [anon_sym_COLON] = ACTIONS(4122),
    [anon_sym_return] = ACTIONS(4122),
    [anon_sym_do] = ACTIONS(4122),
    [anon_sym_and] = ACTIONS(4122),
    [anon_sym_let] = ACTIONS(4122),
    [anon_sym_let_BANG] = ACTIONS(4120),
    [aux_sym_access_modifier_token1] = ACTIONS(4120),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_COMMA] = ACTIONS(4120),
    [anon_sym_null] = ACTIONS(4122),
    [anon_sym_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_COLON] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_LT_AT] = ACTIONS(4122),
    [anon_sym_LT_AT_AT] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4122),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4120),
    [anon_sym_new] = ACTIONS(4122),
    [anon_sym_with] = ACTIONS(4122),
    [anon_sym_return_BANG] = ACTIONS(4120),
    [anon_sym_yield] = ACTIONS(4122),
    [anon_sym_yield_BANG] = ACTIONS(4120),
    [anon_sym_lazy] = ACTIONS(4122),
    [anon_sym_assert] = ACTIONS(4122),
    [anon_sym_upcast] = ACTIONS(4122),
    [anon_sym_downcast] = ACTIONS(4122),
    [anon_sym_COLON_GT] = ACTIONS(4120),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4120),
    [anon_sym_for] = ACTIONS(4122),
    [anon_sym_while] = ACTIONS(4122),
    [anon_sym_if] = ACTIONS(4122),
    [anon_sym_fun] = ACTIONS(4122),
    [anon_sym_try] = ACTIONS(4122),
    [anon_sym_match] = ACTIONS(4122),
    [anon_sym_match_BANG] = ACTIONS(4120),
    [anon_sym_function] = ACTIONS(4122),
    [anon_sym_LT_DASH] = ACTIONS(4122),
    [anon_sym_DOT_LBRACK] = ACTIONS(4120),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_use] = ACTIONS(4122),
    [anon_sym_use_BANG] = ACTIONS(4120),
    [anon_sym_do_BANG] = ACTIONS(4120),
    [anon_sym_begin] = ACTIONS(4122),
    [anon_sym_LPAREN2] = ACTIONS(4122),
    [anon_sym_default] = ACTIONS(4122),
    [anon_sym_or] = ACTIONS(4122),
    [anon_sym_static] = ACTIONS(4122),
    [anon_sym_member] = ACTIONS(4122),
    [anon_sym_interface] = ACTIONS(4122),
    [anon_sym_abstract] = ACTIONS(4122),
    [anon_sym_val] = ACTIONS(4122),
    [anon_sym_override] = ACTIONS(4122),
    [aux_sym_char_token1] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4122),
    [anon_sym_DQUOTE] = ACTIONS(4122),
    [anon_sym_AT_DQUOTE] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [sym_bool] = ACTIONS(4122),
    [sym_unit] = ACTIONS(4120),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4122),
    [sym_op_identifier] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4122),
    [anon_sym_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_DOT] = ACTIONS(4122),
    [anon_sym_DASH_DOT] = ACTIONS(4122),
    [anon_sym_PERCENT] = ACTIONS(4122),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_TILDE] = ACTIONS(4120),
    [aux_sym_prefix_op_token1] = ACTIONS(4122),
    [aux_sym_infix_op_token1] = ACTIONS(4120),
    [aux_sym_infix_op_token2] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_COLON_EQ] = ACTIONS(4120),
    [anon_sym_DOLLAR] = ACTIONS(4122),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4122),
    [sym_int] = ACTIONS(4122),
    [sym_xint] = ACTIONS(4120),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4120),
    [sym__newline] = ACTIONS(4120),
    [sym__dedent] = ACTIONS(4120),
  },
  [1916] = {
    [sym_block_comment] = STATE(1916),
    [sym_compiler_directive_decl] = STATE(1916),
    [sym_fsi_directive_decl] = STATE(1916),
    [sym_preproc_line] = STATE(1916),
    [sym_identifier] = ACTIONS(4147),
    [anon_sym_EQ] = ACTIONS(4145),
    [anon_sym_LBRACK_LT] = ACTIONS(4145),
    [anon_sym_COLON] = ACTIONS(4147),
    [anon_sym_return] = ACTIONS(4147),
    [anon_sym_do] = ACTIONS(4147),
    [anon_sym_let] = ACTIONS(4147),
    [anon_sym_let_BANG] = ACTIONS(4145),
    [aux_sym_access_modifier_token1] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(4147),
    [anon_sym_COMMA] = ACTIONS(4145),
    [anon_sym_null] = ACTIONS(4147),
    [anon_sym_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_COLON] = ACTIONS(4145),
    [anon_sym_AMP] = ACTIONS(4147),
    [anon_sym_LBRACK] = ACTIONS(4147),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4145),
    [anon_sym_LBRACE] = ACTIONS(4147),
    [anon_sym_LT_AT] = ACTIONS(4147),
    [anon_sym_LT_AT_AT] = ACTIONS(4147),
    [anon_sym_DOT] = ACTIONS(4147),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4145),
    [anon_sym_new] = ACTIONS(4147),
    [anon_sym_with] = ACTIONS(4147),
    [anon_sym_return_BANG] = ACTIONS(4145),
    [anon_sym_yield] = ACTIONS(4147),
    [anon_sym_yield_BANG] = ACTIONS(4145),
    [anon_sym_lazy] = ACTIONS(4147),
    [anon_sym_assert] = ACTIONS(4147),
    [anon_sym_upcast] = ACTIONS(4147),
    [anon_sym_downcast] = ACTIONS(4147),
    [anon_sym_COLON_GT] = ACTIONS(4145),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4145),
    [anon_sym_for] = ACTIONS(4147),
    [anon_sym_while] = ACTIONS(4147),
    [anon_sym_if] = ACTIONS(4147),
    [anon_sym_fun] = ACTIONS(4147),
    [anon_sym_try] = ACTIONS(4147),
    [anon_sym_match] = ACTIONS(4147),
    [anon_sym_match_BANG] = ACTIONS(4145),
    [anon_sym_function] = ACTIONS(4147),
    [anon_sym_LT_DASH] = ACTIONS(4147),
    [anon_sym_DOT_LBRACK] = ACTIONS(4145),
    [anon_sym_LT] = ACTIONS(4145),
    [anon_sym_use] = ACTIONS(4147),
    [anon_sym_use_BANG] = ACTIONS(4145),
    [anon_sym_do_BANG] = ACTIONS(4145),
    [anon_sym_begin] = ACTIONS(4147),
    [anon_sym_LPAREN2] = ACTIONS(4147),
    [anon_sym_DOT_DOT2] = ACTIONS(4145),
    [anon_sym_default] = ACTIONS(4147),
    [anon_sym_or] = ACTIONS(4147),
    [anon_sym_static] = ACTIONS(4147),
    [anon_sym_member] = ACTIONS(4147),
    [anon_sym_interface] = ACTIONS(4147),
    [anon_sym_abstract] = ACTIONS(4147),
    [anon_sym_val] = ACTIONS(4147),
    [anon_sym_override] = ACTIONS(4147),
    [aux_sym_char_token1] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4147),
    [anon_sym_DQUOTE] = ACTIONS(4147),
    [anon_sym_AT_DQUOTE] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [sym_bool] = ACTIONS(4147),
    [sym_unit] = ACTIONS(4145),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4147),
    [sym_op_identifier] = ACTIONS(4147),
    [anon_sym_PLUS] = ACTIONS(4147),
    [anon_sym_DASH] = ACTIONS(4147),
    [anon_sym_PLUS_DOT] = ACTIONS(4147),
    [anon_sym_DASH_DOT] = ACTIONS(4147),
    [anon_sym_PERCENT] = ACTIONS(4147),
    [anon_sym_AMP_AMP] = ACTIONS(4147),
    [anon_sym_TILDE] = ACTIONS(4145),
    [aux_sym_prefix_op_token1] = ACTIONS(4147),
    [aux_sym_infix_op_token1] = ACTIONS(4145),
    [aux_sym_infix_op_token2] = ACTIONS(4147),
    [anon_sym_PIPE_PIPE] = ACTIONS(4147),
    [anon_sym_BANG_EQ] = ACTIONS(4147),
    [anon_sym_COLON_EQ] = ACTIONS(4145),
    [anon_sym_DOLLAR] = ACTIONS(4147),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4147),
    [sym_int] = ACTIONS(4147),
    [sym_xint] = ACTIONS(4145),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4145),
    [sym__newline] = ACTIONS(4145),
    [sym__dedent] = ACTIONS(4145),
  },
  [1917] = {
    [sym_block_comment] = STATE(1917),
    [sym_compiler_directive_decl] = STATE(1917),
    [sym_fsi_directive_decl] = STATE(1917),
    [sym_preproc_line] = STATE(1917),
    [sym_identifier] = ACTIONS(4126),
    [anon_sym_EQ] = ACTIONS(4124),
    [anon_sym_LBRACK_LT] = ACTIONS(4124),
    [anon_sym_COLON] = ACTIONS(4126),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_do] = ACTIONS(4126),
    [anon_sym_and] = ACTIONS(4126),
    [anon_sym_let] = ACTIONS(4126),
    [anon_sym_let_BANG] = ACTIONS(4124),
    [aux_sym_access_modifier_token1] = ACTIONS(4124),
    [anon_sym_LPAREN] = ACTIONS(4126),
    [anon_sym_COMMA] = ACTIONS(4124),
    [anon_sym_null] = ACTIONS(4126),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_COLON] = ACTIONS(4124),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LBRACK] = ACTIONS(4126),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4126),
    [anon_sym_LT_AT] = ACTIONS(4126),
    [anon_sym_LT_AT_AT] = ACTIONS(4126),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4124),
    [anon_sym_new] = ACTIONS(4126),
    [anon_sym_with] = ACTIONS(4126),
    [anon_sym_return_BANG] = ACTIONS(4124),
    [anon_sym_yield] = ACTIONS(4126),
    [anon_sym_yield_BANG] = ACTIONS(4124),
    [anon_sym_lazy] = ACTIONS(4126),
    [anon_sym_assert] = ACTIONS(4126),
    [anon_sym_upcast] = ACTIONS(4126),
    [anon_sym_downcast] = ACTIONS(4126),
    [anon_sym_COLON_GT] = ACTIONS(4124),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4124),
    [anon_sym_for] = ACTIONS(4126),
    [anon_sym_while] = ACTIONS(4126),
    [anon_sym_if] = ACTIONS(4126),
    [anon_sym_fun] = ACTIONS(4126),
    [anon_sym_try] = ACTIONS(4126),
    [anon_sym_match] = ACTIONS(4126),
    [anon_sym_match_BANG] = ACTIONS(4124),
    [anon_sym_function] = ACTIONS(4126),
    [anon_sym_LT_DASH] = ACTIONS(4126),
    [anon_sym_DOT_LBRACK] = ACTIONS(4124),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_use] = ACTIONS(4126),
    [anon_sym_use_BANG] = ACTIONS(4124),
    [anon_sym_do_BANG] = ACTIONS(4124),
    [anon_sym_begin] = ACTIONS(4126),
    [anon_sym_LPAREN2] = ACTIONS(4126),
    [anon_sym_default] = ACTIONS(4126),
    [anon_sym_or] = ACTIONS(4126),
    [anon_sym_static] = ACTIONS(4126),
    [anon_sym_member] = ACTIONS(4126),
    [anon_sym_interface] = ACTIONS(4126),
    [anon_sym_abstract] = ACTIONS(4126),
    [anon_sym_val] = ACTIONS(4126),
    [anon_sym_override] = ACTIONS(4126),
    [aux_sym_char_token1] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4126),
    [anon_sym_DQUOTE] = ACTIONS(4126),
    [anon_sym_AT_DQUOTE] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [sym_bool] = ACTIONS(4126),
    [sym_unit] = ACTIONS(4124),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4126),
    [sym_op_identifier] = ACTIONS(4126),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_PLUS_DOT] = ACTIONS(4126),
    [anon_sym_DASH_DOT] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_AMP_AMP] = ACTIONS(4126),
    [anon_sym_TILDE] = ACTIONS(4124),
    [aux_sym_prefix_op_token1] = ACTIONS(4126),
    [aux_sym_infix_op_token1] = ACTIONS(4124),
    [aux_sym_infix_op_token2] = ACTIONS(4126),
    [anon_sym_PIPE_PIPE] = ACTIONS(4126),
    [anon_sym_BANG_EQ] = ACTIONS(4126),
    [anon_sym_COLON_EQ] = ACTIONS(4124),
    [anon_sym_DOLLAR] = ACTIONS(4126),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4126),
    [sym_int] = ACTIONS(4126),
    [sym_xint] = ACTIONS(4124),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4124),
    [sym__newline] = ACTIONS(4124),
    [sym__dedent] = ACTIONS(4124),
  },
  [1918] = {
    [sym_block_comment] = STATE(1918),
    [sym_compiler_directive_decl] = STATE(1918),
    [sym_fsi_directive_decl] = STATE(1918),
    [sym_preproc_line] = STATE(1918),
    [sym_identifier] = ACTIONS(4232),
    [anon_sym_EQ] = ACTIONS(4230),
    [anon_sym_LBRACK_LT] = ACTIONS(4230),
    [anon_sym_COLON] = ACTIONS(4232),
    [anon_sym_return] = ACTIONS(4232),
    [anon_sym_do] = ACTIONS(4232),
    [anon_sym_and] = ACTIONS(4232),
    [anon_sym_let] = ACTIONS(4232),
    [anon_sym_let_BANG] = ACTIONS(4230),
    [aux_sym_access_modifier_token1] = ACTIONS(4230),
    [anon_sym_LPAREN] = ACTIONS(4232),
    [anon_sym_COMMA] = ACTIONS(4230),
    [anon_sym_null] = ACTIONS(4232),
    [anon_sym_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_COLON] = ACTIONS(4230),
    [anon_sym_AMP] = ACTIONS(4232),
    [anon_sym_LBRACK] = ACTIONS(4232),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4230),
    [anon_sym_LBRACE] = ACTIONS(4232),
    [anon_sym_LT_AT] = ACTIONS(4232),
    [anon_sym_LT_AT_AT] = ACTIONS(4232),
    [anon_sym_DOT] = ACTIONS(4232),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4230),
    [anon_sym_new] = ACTIONS(4232),
    [anon_sym_with] = ACTIONS(4232),
    [anon_sym_return_BANG] = ACTIONS(4230),
    [anon_sym_yield] = ACTIONS(4232),
    [anon_sym_yield_BANG] = ACTIONS(4230),
    [anon_sym_lazy] = ACTIONS(4232),
    [anon_sym_assert] = ACTIONS(4232),
    [anon_sym_upcast] = ACTIONS(4232),
    [anon_sym_downcast] = ACTIONS(4232),
    [anon_sym_COLON_GT] = ACTIONS(4230),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4230),
    [anon_sym_for] = ACTIONS(4232),
    [anon_sym_while] = ACTIONS(4232),
    [anon_sym_if] = ACTIONS(4232),
    [anon_sym_fun] = ACTIONS(4232),
    [anon_sym_try] = ACTIONS(4232),
    [anon_sym_match] = ACTIONS(4232),
    [anon_sym_match_BANG] = ACTIONS(4230),
    [anon_sym_function] = ACTIONS(4232),
    [anon_sym_LT_DASH] = ACTIONS(4232),
    [anon_sym_DOT_LBRACK] = ACTIONS(4230),
    [anon_sym_LT] = ACTIONS(4230),
    [anon_sym_use] = ACTIONS(4232),
    [anon_sym_use_BANG] = ACTIONS(4230),
    [anon_sym_do_BANG] = ACTIONS(4230),
    [anon_sym_begin] = ACTIONS(4232),
    [anon_sym_LPAREN2] = ACTIONS(4232),
    [anon_sym_default] = ACTIONS(4232),
    [anon_sym_or] = ACTIONS(4232),
    [anon_sym_static] = ACTIONS(4232),
    [anon_sym_member] = ACTIONS(4232),
    [anon_sym_interface] = ACTIONS(4232),
    [anon_sym_abstract] = ACTIONS(4232),
    [anon_sym_val] = ACTIONS(4232),
    [anon_sym_override] = ACTIONS(4232),
    [aux_sym_char_token1] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4232),
    [anon_sym_DQUOTE] = ACTIONS(4232),
    [anon_sym_AT_DQUOTE] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [sym_bool] = ACTIONS(4232),
    [sym_unit] = ACTIONS(4230),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4232),
    [sym_op_identifier] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4232),
    [anon_sym_DASH] = ACTIONS(4232),
    [anon_sym_PLUS_DOT] = ACTIONS(4232),
    [anon_sym_DASH_DOT] = ACTIONS(4232),
    [anon_sym_PERCENT] = ACTIONS(4232),
    [anon_sym_AMP_AMP] = ACTIONS(4232),
    [anon_sym_TILDE] = ACTIONS(4230),
    [aux_sym_prefix_op_token1] = ACTIONS(4232),
    [aux_sym_infix_op_token1] = ACTIONS(4230),
    [aux_sym_infix_op_token2] = ACTIONS(4232),
    [anon_sym_PIPE_PIPE] = ACTIONS(4232),
    [anon_sym_BANG_EQ] = ACTIONS(4232),
    [anon_sym_COLON_EQ] = ACTIONS(4230),
    [anon_sym_DOLLAR] = ACTIONS(4232),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4232),
    [sym_int] = ACTIONS(4232),
    [sym_xint] = ACTIONS(4230),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4230),
    [sym__newline] = ACTIONS(4230),
    [sym__dedent] = ACTIONS(4230),
  },
  [1919] = {
    [sym_block_comment] = STATE(1919),
    [sym_compiler_directive_decl] = STATE(1919),
    [sym_fsi_directive_decl] = STATE(1919),
    [sym_preproc_line] = STATE(1919),
    [sym_identifier] = ACTIONS(3927),
    [anon_sym_EQ] = ACTIONS(3925),
    [anon_sym_LBRACK_LT] = ACTIONS(3925),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_return] = ACTIONS(3927),
    [anon_sym_do] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3927),
    [anon_sym_let] = ACTIONS(3927),
    [anon_sym_let_BANG] = ACTIONS(3925),
    [aux_sym_access_modifier_token1] = ACTIONS(3925),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_COMMA] = ACTIONS(3925),
    [anon_sym_null] = ACTIONS(3927),
    [anon_sym_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_COLON] = ACTIONS(3925),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3925),
    [anon_sym_LBRACE] = ACTIONS(3927),
    [anon_sym_LT_AT] = ACTIONS(3927),
    [anon_sym_LT_AT_AT] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3925),
    [anon_sym_new] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3927),
    [anon_sym_return_BANG] = ACTIONS(3925),
    [anon_sym_yield] = ACTIONS(3927),
    [anon_sym_yield_BANG] = ACTIONS(3925),
    [anon_sym_lazy] = ACTIONS(3927),
    [anon_sym_assert] = ACTIONS(3927),
    [anon_sym_upcast] = ACTIONS(3927),
    [anon_sym_downcast] = ACTIONS(3927),
    [anon_sym_COLON_GT] = ACTIONS(3925),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3925),
    [anon_sym_for] = ACTIONS(3927),
    [anon_sym_while] = ACTIONS(3927),
    [anon_sym_if] = ACTIONS(3927),
    [anon_sym_fun] = ACTIONS(3927),
    [anon_sym_try] = ACTIONS(3927),
    [anon_sym_match] = ACTIONS(3927),
    [anon_sym_match_BANG] = ACTIONS(3925),
    [anon_sym_function] = ACTIONS(3927),
    [anon_sym_LT_DASH] = ACTIONS(3927),
    [anon_sym_DOT_LBRACK] = ACTIONS(3925),
    [anon_sym_LT] = ACTIONS(3925),
    [anon_sym_use] = ACTIONS(3927),
    [anon_sym_use_BANG] = ACTIONS(3925),
    [anon_sym_do_BANG] = ACTIONS(3925),
    [anon_sym_begin] = ACTIONS(3927),
    [anon_sym_LPAREN2] = ACTIONS(3927),
    [anon_sym_default] = ACTIONS(3927),
    [anon_sym_or] = ACTIONS(3927),
    [anon_sym_static] = ACTIONS(3927),
    [anon_sym_member] = ACTIONS(3927),
    [anon_sym_interface] = ACTIONS(3927),
    [anon_sym_abstract] = ACTIONS(3927),
    [anon_sym_val] = ACTIONS(3927),
    [anon_sym_override] = ACTIONS(3927),
    [aux_sym_char_token1] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_AT_DQUOTE] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [sym_bool] = ACTIONS(3927),
    [sym_unit] = ACTIONS(3925),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3927),
    [sym_op_identifier] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3927),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_PLUS_DOT] = ACTIONS(3927),
    [anon_sym_DASH_DOT] = ACTIONS(3927),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_TILDE] = ACTIONS(3925),
    [aux_sym_prefix_op_token1] = ACTIONS(3927),
    [aux_sym_infix_op_token1] = ACTIONS(3925),
    [aux_sym_infix_op_token2] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_COLON_EQ] = ACTIONS(3925),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3927),
    [sym_int] = ACTIONS(3927),
    [sym_xint] = ACTIONS(3925),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3925),
    [sym__newline] = ACTIONS(3925),
    [sym__dedent] = ACTIONS(3925),
  },
  [1920] = {
    [sym_block_comment] = STATE(1920),
    [sym_compiler_directive_decl] = STATE(1920),
    [sym_fsi_directive_decl] = STATE(1920),
    [sym_preproc_line] = STATE(1920),
    [sym_identifier] = ACTIONS(3962),
    [anon_sym_EQ] = ACTIONS(3960),
    [anon_sym_LBRACK_LT] = ACTIONS(3960),
    [anon_sym_COLON] = ACTIONS(3962),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_do] = ACTIONS(3962),
    [anon_sym_and] = ACTIONS(3962),
    [anon_sym_let] = ACTIONS(3962),
    [anon_sym_let_BANG] = ACTIONS(3960),
    [aux_sym_access_modifier_token1] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_COMMA] = ACTIONS(3960),
    [anon_sym_null] = ACTIONS(3962),
    [anon_sym_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_COLON] = ACTIONS(3960),
    [anon_sym_AMP] = ACTIONS(3962),
    [anon_sym_LBRACK] = ACTIONS(3962),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_LT_AT] = ACTIONS(3962),
    [anon_sym_LT_AT_AT] = ACTIONS(3962),
    [anon_sym_DOT] = ACTIONS(3962),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3960),
    [anon_sym_new] = ACTIONS(3962),
    [anon_sym_with] = ACTIONS(3962),
    [anon_sym_return_BANG] = ACTIONS(3960),
    [anon_sym_yield] = ACTIONS(3962),
    [anon_sym_yield_BANG] = ACTIONS(3960),
    [anon_sym_lazy] = ACTIONS(3962),
    [anon_sym_assert] = ACTIONS(3962),
    [anon_sym_upcast] = ACTIONS(3962),
    [anon_sym_downcast] = ACTIONS(3962),
    [anon_sym_COLON_GT] = ACTIONS(3960),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3960),
    [anon_sym_for] = ACTIONS(3962),
    [anon_sym_while] = ACTIONS(3962),
    [anon_sym_if] = ACTIONS(3962),
    [anon_sym_fun] = ACTIONS(3962),
    [anon_sym_try] = ACTIONS(3962),
    [anon_sym_match] = ACTIONS(3962),
    [anon_sym_match_BANG] = ACTIONS(3960),
    [anon_sym_function] = ACTIONS(3962),
    [anon_sym_LT_DASH] = ACTIONS(3962),
    [anon_sym_DOT_LBRACK] = ACTIONS(3960),
    [anon_sym_LT] = ACTIONS(3960),
    [anon_sym_use] = ACTIONS(3962),
    [anon_sym_use_BANG] = ACTIONS(3960),
    [anon_sym_do_BANG] = ACTIONS(3960),
    [anon_sym_begin] = ACTIONS(3962),
    [anon_sym_LPAREN2] = ACTIONS(3962),
    [anon_sym_default] = ACTIONS(3962),
    [anon_sym_or] = ACTIONS(3962),
    [anon_sym_static] = ACTIONS(3962),
    [anon_sym_member] = ACTIONS(3962),
    [anon_sym_interface] = ACTIONS(3962),
    [anon_sym_abstract] = ACTIONS(3962),
    [anon_sym_val] = ACTIONS(3962),
    [anon_sym_override] = ACTIONS(3962),
    [aux_sym_char_token1] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3962),
    [anon_sym_DQUOTE] = ACTIONS(3962),
    [anon_sym_AT_DQUOTE] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [sym_bool] = ACTIONS(3962),
    [sym_unit] = ACTIONS(3960),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3962),
    [sym_op_identifier] = ACTIONS(3962),
    [anon_sym_PLUS] = ACTIONS(3962),
    [anon_sym_DASH] = ACTIONS(3962),
    [anon_sym_PLUS_DOT] = ACTIONS(3962),
    [anon_sym_DASH_DOT] = ACTIONS(3962),
    [anon_sym_PERCENT] = ACTIONS(3962),
    [anon_sym_AMP_AMP] = ACTIONS(3962),
    [anon_sym_TILDE] = ACTIONS(3960),
    [aux_sym_prefix_op_token1] = ACTIONS(3962),
    [aux_sym_infix_op_token1] = ACTIONS(3960),
    [aux_sym_infix_op_token2] = ACTIONS(3962),
    [anon_sym_PIPE_PIPE] = ACTIONS(3962),
    [anon_sym_BANG_EQ] = ACTIONS(3962),
    [anon_sym_COLON_EQ] = ACTIONS(3960),
    [anon_sym_DOLLAR] = ACTIONS(3962),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3962),
    [sym_int] = ACTIONS(3962),
    [sym_xint] = ACTIONS(3960),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3960),
    [sym__newline] = ACTIONS(3960),
    [sym__dedent] = ACTIONS(3960),
  },
  [1921] = {
    [sym_block_comment] = STATE(1921),
    [sym_compiler_directive_decl] = STATE(1921),
    [sym_fsi_directive_decl] = STATE(1921),
    [sym_preproc_line] = STATE(1921),
    [aux_sym_type_argument_repeat1] = STATE(1981),
    [ts_builtin_sym_end] = ACTIONS(3474),
    [sym_identifier] = ACTIONS(3476),
    [anon_sym_namespace] = ACTIONS(3476),
    [anon_sym_module] = ACTIONS(3476),
    [anon_sym_EQ] = ACTIONS(3474),
    [anon_sym_open] = ACTIONS(3476),
    [anon_sym_LBRACK_LT] = ACTIONS(3474),
    [anon_sym_COLON] = ACTIONS(3476),
    [anon_sym_return] = ACTIONS(3476),
    [anon_sym_type] = ACTIONS(3476),
    [anon_sym_do] = ACTIONS(3476),
    [anon_sym_let] = ACTIONS(3476),
    [anon_sym_let_BANG] = ACTIONS(3474),
    [anon_sym_LPAREN] = ACTIONS(3476),
    [anon_sym_COMMA] = ACTIONS(3474),
    [anon_sym_null] = ACTIONS(3476),
    [anon_sym_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_COLON] = ACTIONS(3474),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym_LBRACK] = ACTIONS(3476),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3474),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_LT_AT] = ACTIONS(3476),
    [anon_sym_LT_AT_AT] = ACTIONS(3476),
    [anon_sym_DOT] = ACTIONS(3476),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3474),
    [anon_sym_new] = ACTIONS(3476),
    [anon_sym_return_BANG] = ACTIONS(3474),
    [anon_sym_yield] = ACTIONS(3476),
    [anon_sym_yield_BANG] = ACTIONS(3474),
    [anon_sym_lazy] = ACTIONS(3476),
    [anon_sym_assert] = ACTIONS(3476),
    [anon_sym_upcast] = ACTIONS(3476),
    [anon_sym_downcast] = ACTIONS(3476),
    [anon_sym_COLON_GT] = ACTIONS(3474),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3474),
    [anon_sym_for] = ACTIONS(3476),
    [anon_sym_while] = ACTIONS(3476),
    [anon_sym_if] = ACTIONS(3476),
    [anon_sym_fun] = ACTIONS(3476),
    [anon_sym_DASH_GT] = ACTIONS(3476),
    [anon_sym_try] = ACTIONS(3476),
    [anon_sym_match] = ACTIONS(3476),
    [anon_sym_match_BANG] = ACTIONS(3474),
    [anon_sym_function] = ACTIONS(3476),
    [anon_sym_LT_DASH] = ACTIONS(3476),
    [anon_sym_DOT_LBRACK] = ACTIONS(3474),
    [anon_sym_LT] = ACTIONS(3474),
    [anon_sym_use] = ACTIONS(3476),
    [anon_sym_use_BANG] = ACTIONS(3474),
    [anon_sym_do_BANG] = ACTIONS(3474),
    [anon_sym_begin] = ACTIONS(3476),
    [anon_sym_LPAREN2] = ACTIONS(3476),
    [anon_sym_STAR] = ACTIONS(3476),
    [anon_sym_LT2] = ACTIONS(3476),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3474),
    [anon_sym_or] = ACTIONS(3476),
    [anon_sym_exception] = ACTIONS(3476),
    [aux_sym_char_token1] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3476),
    [anon_sym_DQUOTE] = ACTIONS(3476),
    [anon_sym_AT_DQUOTE] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [sym_bool] = ACTIONS(3476),
    [sym_unit] = ACTIONS(3474),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3476),
    [sym_op_identifier] = ACTIONS(3476),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3476),
    [anon_sym_PLUS_DOT] = ACTIONS(3476),
    [anon_sym_DASH_DOT] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [anon_sym_AMP_AMP] = ACTIONS(3476),
    [anon_sym_TILDE] = ACTIONS(3474),
    [aux_sym_prefix_op_token1] = ACTIONS(3476),
    [aux_sym_infix_op_token1] = ACTIONS(3474),
    [aux_sym_infix_op_token2] = ACTIONS(3476),
    [anon_sym_PIPE_PIPE] = ACTIONS(3476),
    [anon_sym_BANG_EQ] = ACTIONS(3476),
    [anon_sym_COLON_EQ] = ACTIONS(3474),
    [anon_sym_DOLLAR] = ACTIONS(3476),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3476),
    [sym_int] = ACTIONS(3476),
    [sym_xint] = ACTIONS(3474),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3474),
    [anon_sym_POUNDload] = ACTIONS(3474),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3474),
    [sym__newline] = ACTIONS(3474),
  },
  [1922] = {
    [sym_block_comment] = STATE(1922),
    [sym_compiler_directive_decl] = STATE(1922),
    [sym_fsi_directive_decl] = STATE(1922),
    [sym_preproc_line] = STATE(1922),
    [sym_identifier] = ACTIONS(3958),
    [anon_sym_EQ] = ACTIONS(3956),
    [anon_sym_LBRACK_LT] = ACTIONS(3956),
    [anon_sym_COLON] = ACTIONS(3958),
    [anon_sym_return] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(3958),
    [anon_sym_and] = ACTIONS(3958),
    [anon_sym_let] = ACTIONS(3958),
    [anon_sym_let_BANG] = ACTIONS(3956),
    [aux_sym_access_modifier_token1] = ACTIONS(3956),
    [anon_sym_LPAREN] = ACTIONS(3958),
    [anon_sym_COMMA] = ACTIONS(3956),
    [anon_sym_null] = ACTIONS(3958),
    [anon_sym_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_COLON] = ACTIONS(3956),
    [anon_sym_AMP] = ACTIONS(3958),
    [anon_sym_LBRACK] = ACTIONS(3958),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3956),
    [anon_sym_LBRACE] = ACTIONS(3958),
    [anon_sym_LT_AT] = ACTIONS(3958),
    [anon_sym_LT_AT_AT] = ACTIONS(3958),
    [anon_sym_DOT] = ACTIONS(3958),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3956),
    [anon_sym_new] = ACTIONS(3958),
    [anon_sym_with] = ACTIONS(3958),
    [anon_sym_return_BANG] = ACTIONS(3956),
    [anon_sym_yield] = ACTIONS(3958),
    [anon_sym_yield_BANG] = ACTIONS(3956),
    [anon_sym_lazy] = ACTIONS(3958),
    [anon_sym_assert] = ACTIONS(3958),
    [anon_sym_upcast] = ACTIONS(3958),
    [anon_sym_downcast] = ACTIONS(3958),
    [anon_sym_COLON_GT] = ACTIONS(3956),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3956),
    [anon_sym_for] = ACTIONS(3958),
    [anon_sym_while] = ACTIONS(3958),
    [anon_sym_if] = ACTIONS(3958),
    [anon_sym_fun] = ACTIONS(3958),
    [anon_sym_try] = ACTIONS(3958),
    [anon_sym_match] = ACTIONS(3958),
    [anon_sym_match_BANG] = ACTIONS(3956),
    [anon_sym_function] = ACTIONS(3958),
    [anon_sym_LT_DASH] = ACTIONS(3958),
    [anon_sym_DOT_LBRACK] = ACTIONS(3956),
    [anon_sym_LT] = ACTIONS(3956),
    [anon_sym_use] = ACTIONS(3958),
    [anon_sym_use_BANG] = ACTIONS(3956),
    [anon_sym_do_BANG] = ACTIONS(3956),
    [anon_sym_begin] = ACTIONS(3958),
    [anon_sym_LPAREN2] = ACTIONS(3958),
    [anon_sym_default] = ACTIONS(3958),
    [anon_sym_or] = ACTIONS(3958),
    [anon_sym_static] = ACTIONS(3958),
    [anon_sym_member] = ACTIONS(3958),
    [anon_sym_interface] = ACTIONS(3958),
    [anon_sym_abstract] = ACTIONS(3958),
    [anon_sym_val] = ACTIONS(3958),
    [anon_sym_override] = ACTIONS(3958),
    [aux_sym_char_token1] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [anon_sym_AT_DQUOTE] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [sym_bool] = ACTIONS(3958),
    [sym_unit] = ACTIONS(3956),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3958),
    [sym_op_identifier] = ACTIONS(3958),
    [anon_sym_PLUS] = ACTIONS(3958),
    [anon_sym_DASH] = ACTIONS(3958),
    [anon_sym_PLUS_DOT] = ACTIONS(3958),
    [anon_sym_DASH_DOT] = ACTIONS(3958),
    [anon_sym_PERCENT] = ACTIONS(3958),
    [anon_sym_AMP_AMP] = ACTIONS(3958),
    [anon_sym_TILDE] = ACTIONS(3956),
    [aux_sym_prefix_op_token1] = ACTIONS(3958),
    [aux_sym_infix_op_token1] = ACTIONS(3956),
    [aux_sym_infix_op_token2] = ACTIONS(3958),
    [anon_sym_PIPE_PIPE] = ACTIONS(3958),
    [anon_sym_BANG_EQ] = ACTIONS(3958),
    [anon_sym_COLON_EQ] = ACTIONS(3956),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3958),
    [sym_int] = ACTIONS(3958),
    [sym_xint] = ACTIONS(3956),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3956),
    [sym__newline] = ACTIONS(3956),
    [sym__dedent] = ACTIONS(3956),
  },
  [1923] = {
    [sym_block_comment] = STATE(1923),
    [sym_compiler_directive_decl] = STATE(1923),
    [sym_fsi_directive_decl] = STATE(1923),
    [sym_preproc_line] = STATE(1923),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_and] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [aux_sym_access_modifier_token1] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_member] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_val] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
    [sym__dedent] = ACTIONS(3191),
  },
  [1924] = {
    [sym_block_comment] = STATE(1924),
    [sym_compiler_directive_decl] = STATE(1924),
    [sym_fsi_directive_decl] = STATE(1924),
    [sym_preproc_line] = STATE(1924),
    [sym_identifier] = ACTIONS(4170),
    [anon_sym_EQ] = ACTIONS(4168),
    [anon_sym_LBRACK_LT] = ACTIONS(4168),
    [anon_sym_COLON] = ACTIONS(4170),
    [anon_sym_return] = ACTIONS(4170),
    [anon_sym_do] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_let_BANG] = ACTIONS(4168),
    [aux_sym_access_modifier_token1] = ACTIONS(4168),
    [anon_sym_LPAREN] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4168),
    [anon_sym_null] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_COLON] = ACTIONS(4168),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4170),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4168),
    [anon_sym_LBRACE] = ACTIONS(4170),
    [anon_sym_LT_AT] = ACTIONS(4170),
    [anon_sym_LT_AT_AT] = ACTIONS(4170),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4168),
    [anon_sym_new] = ACTIONS(4170),
    [anon_sym_with] = ACTIONS(4170),
    [anon_sym_return_BANG] = ACTIONS(4168),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_yield_BANG] = ACTIONS(4168),
    [anon_sym_lazy] = ACTIONS(4170),
    [anon_sym_assert] = ACTIONS(4170),
    [anon_sym_upcast] = ACTIONS(4170),
    [anon_sym_downcast] = ACTIONS(4170),
    [anon_sym_COLON_GT] = ACTIONS(4168),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4168),
    [anon_sym_for] = ACTIONS(4170),
    [anon_sym_while] = ACTIONS(4170),
    [anon_sym_if] = ACTIONS(4170),
    [anon_sym_fun] = ACTIONS(4170),
    [anon_sym_try] = ACTIONS(4170),
    [anon_sym_match] = ACTIONS(4170),
    [anon_sym_match_BANG] = ACTIONS(4168),
    [anon_sym_function] = ACTIONS(4170),
    [anon_sym_LT_DASH] = ACTIONS(4170),
    [anon_sym_DOT_LBRACK] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4168),
    [anon_sym_use] = ACTIONS(4170),
    [anon_sym_use_BANG] = ACTIONS(4168),
    [anon_sym_do_BANG] = ACTIONS(4168),
    [anon_sym_begin] = ACTIONS(4170),
    [anon_sym_LPAREN2] = ACTIONS(4170),
    [anon_sym_DOT_DOT2] = ACTIONS(4168),
    [anon_sym_default] = ACTIONS(4170),
    [anon_sym_or] = ACTIONS(4170),
    [anon_sym_static] = ACTIONS(4170),
    [anon_sym_member] = ACTIONS(4170),
    [anon_sym_interface] = ACTIONS(4170),
    [anon_sym_abstract] = ACTIONS(4170),
    [anon_sym_val] = ACTIONS(4170),
    [anon_sym_override] = ACTIONS(4170),
    [aux_sym_char_token1] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4170),
    [anon_sym_DQUOTE] = ACTIONS(4170),
    [anon_sym_AT_DQUOTE] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [sym_bool] = ACTIONS(4170),
    [sym_unit] = ACTIONS(4168),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4170),
    [sym_op_identifier] = ACTIONS(4170),
    [anon_sym_PLUS] = ACTIONS(4170),
    [anon_sym_DASH] = ACTIONS(4170),
    [anon_sym_PLUS_DOT] = ACTIONS(4170),
    [anon_sym_DASH_DOT] = ACTIONS(4170),
    [anon_sym_PERCENT] = ACTIONS(4170),
    [anon_sym_AMP_AMP] = ACTIONS(4170),
    [anon_sym_TILDE] = ACTIONS(4168),
    [aux_sym_prefix_op_token1] = ACTIONS(4170),
    [aux_sym_infix_op_token1] = ACTIONS(4168),
    [aux_sym_infix_op_token2] = ACTIONS(4170),
    [anon_sym_PIPE_PIPE] = ACTIONS(4170),
    [anon_sym_BANG_EQ] = ACTIONS(4170),
    [anon_sym_COLON_EQ] = ACTIONS(4168),
    [anon_sym_DOLLAR] = ACTIONS(4170),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4170),
    [sym_int] = ACTIONS(4170),
    [sym_xint] = ACTIONS(4168),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4168),
    [sym__newline] = ACTIONS(4168),
    [sym__dedent] = ACTIONS(4168),
  },
  [1925] = {
    [sym_block_comment] = STATE(1925),
    [sym_compiler_directive_decl] = STATE(1925),
    [sym_fsi_directive_decl] = STATE(1925),
    [sym_preproc_line] = STATE(1925),
    [sym_identifier] = ACTIONS(4104),
    [anon_sym_EQ] = ACTIONS(4102),
    [anon_sym_LBRACK_LT] = ACTIONS(4102),
    [anon_sym_COLON] = ACTIONS(4104),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_do] = ACTIONS(4104),
    [anon_sym_and] = ACTIONS(4104),
    [anon_sym_let] = ACTIONS(4104),
    [anon_sym_let_BANG] = ACTIONS(4102),
    [aux_sym_access_modifier_token1] = ACTIONS(4102),
    [anon_sym_LPAREN] = ACTIONS(4104),
    [anon_sym_COMMA] = ACTIONS(4102),
    [anon_sym_null] = ACTIONS(4104),
    [anon_sym_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_COLON] = ACTIONS(4102),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4104),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4102),
    [anon_sym_LBRACE] = ACTIONS(4104),
    [anon_sym_LT_AT] = ACTIONS(4104),
    [anon_sym_LT_AT_AT] = ACTIONS(4104),
    [anon_sym_DOT] = ACTIONS(4104),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4102),
    [anon_sym_new] = ACTIONS(4104),
    [anon_sym_with] = ACTIONS(4104),
    [anon_sym_return_BANG] = ACTIONS(4102),
    [anon_sym_yield] = ACTIONS(4104),
    [anon_sym_yield_BANG] = ACTIONS(4102),
    [anon_sym_lazy] = ACTIONS(4104),
    [anon_sym_assert] = ACTIONS(4104),
    [anon_sym_upcast] = ACTIONS(4104),
    [anon_sym_downcast] = ACTIONS(4104),
    [anon_sym_COLON_GT] = ACTIONS(4102),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4102),
    [anon_sym_for] = ACTIONS(4104),
    [anon_sym_while] = ACTIONS(4104),
    [anon_sym_if] = ACTIONS(4104),
    [anon_sym_fun] = ACTIONS(4104),
    [anon_sym_try] = ACTIONS(4104),
    [anon_sym_match] = ACTIONS(4104),
    [anon_sym_match_BANG] = ACTIONS(4102),
    [anon_sym_function] = ACTIONS(4104),
    [anon_sym_LT_DASH] = ACTIONS(4104),
    [anon_sym_DOT_LBRACK] = ACTIONS(4102),
    [anon_sym_LT] = ACTIONS(4102),
    [anon_sym_use] = ACTIONS(4104),
    [anon_sym_use_BANG] = ACTIONS(4102),
    [anon_sym_do_BANG] = ACTIONS(4102),
    [anon_sym_begin] = ACTIONS(4104),
    [anon_sym_LPAREN2] = ACTIONS(4104),
    [anon_sym_default] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [anon_sym_static] = ACTIONS(4104),
    [anon_sym_member] = ACTIONS(4104),
    [anon_sym_interface] = ACTIONS(4104),
    [anon_sym_abstract] = ACTIONS(4104),
    [anon_sym_val] = ACTIONS(4104),
    [anon_sym_override] = ACTIONS(4104),
    [aux_sym_char_token1] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4104),
    [anon_sym_DQUOTE] = ACTIONS(4104),
    [anon_sym_AT_DQUOTE] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [sym_bool] = ACTIONS(4104),
    [sym_unit] = ACTIONS(4102),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4104),
    [sym_op_identifier] = ACTIONS(4104),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_PLUS_DOT] = ACTIONS(4104),
    [anon_sym_DASH_DOT] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_AMP_AMP] = ACTIONS(4104),
    [anon_sym_TILDE] = ACTIONS(4102),
    [aux_sym_prefix_op_token1] = ACTIONS(4104),
    [aux_sym_infix_op_token1] = ACTIONS(4102),
    [aux_sym_infix_op_token2] = ACTIONS(4104),
    [anon_sym_PIPE_PIPE] = ACTIONS(4104),
    [anon_sym_BANG_EQ] = ACTIONS(4104),
    [anon_sym_COLON_EQ] = ACTIONS(4102),
    [anon_sym_DOLLAR] = ACTIONS(4104),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4104),
    [sym_int] = ACTIONS(4104),
    [sym_xint] = ACTIONS(4102),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4102),
    [sym__newline] = ACTIONS(4102),
    [sym__dedent] = ACTIONS(4102),
  },
  [1926] = {
    [sym_block_comment] = STATE(1926),
    [sym_compiler_directive_decl] = STATE(1926),
    [sym_fsi_directive_decl] = STATE(1926),
    [sym_preproc_line] = STATE(1926),
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_EQ] = ACTIONS(4149),
    [anon_sym_LBRACK_LT] = ACTIONS(4149),
    [anon_sym_COLON] = ACTIONS(4151),
    [anon_sym_return] = ACTIONS(4151),
    [anon_sym_do] = ACTIONS(4151),
    [anon_sym_let] = ACTIONS(4151),
    [anon_sym_let_BANG] = ACTIONS(4149),
    [aux_sym_access_modifier_token1] = ACTIONS(4149),
    [anon_sym_LPAREN] = ACTIONS(4151),
    [anon_sym_COMMA] = ACTIONS(4149),
    [anon_sym_null] = ACTIONS(4151),
    [anon_sym_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_AMP] = ACTIONS(4151),
    [anon_sym_LBRACK] = ACTIONS(4151),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4149),
    [anon_sym_LBRACE] = ACTIONS(4151),
    [anon_sym_LT_AT] = ACTIONS(4151),
    [anon_sym_LT_AT_AT] = ACTIONS(4151),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4149),
    [anon_sym_new] = ACTIONS(4151),
    [anon_sym_with] = ACTIONS(4151),
    [anon_sym_return_BANG] = ACTIONS(4149),
    [anon_sym_yield] = ACTIONS(4151),
    [anon_sym_yield_BANG] = ACTIONS(4149),
    [anon_sym_lazy] = ACTIONS(4151),
    [anon_sym_assert] = ACTIONS(4151),
    [anon_sym_upcast] = ACTIONS(4151),
    [anon_sym_downcast] = ACTIONS(4151),
    [anon_sym_COLON_GT] = ACTIONS(4149),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4149),
    [anon_sym_for] = ACTIONS(4151),
    [anon_sym_while] = ACTIONS(4151),
    [anon_sym_if] = ACTIONS(4151),
    [anon_sym_fun] = ACTIONS(4151),
    [anon_sym_try] = ACTIONS(4151),
    [anon_sym_match] = ACTIONS(4151),
    [anon_sym_match_BANG] = ACTIONS(4149),
    [anon_sym_function] = ACTIONS(4151),
    [anon_sym_LT_DASH] = ACTIONS(4151),
    [anon_sym_DOT_LBRACK] = ACTIONS(4149),
    [anon_sym_LT] = ACTIONS(4149),
    [anon_sym_use] = ACTIONS(4151),
    [anon_sym_use_BANG] = ACTIONS(4149),
    [anon_sym_do_BANG] = ACTIONS(4149),
    [anon_sym_begin] = ACTIONS(4151),
    [anon_sym_LPAREN2] = ACTIONS(4151),
    [anon_sym_DOT_DOT2] = ACTIONS(4149),
    [anon_sym_default] = ACTIONS(4151),
    [anon_sym_or] = ACTIONS(4151),
    [anon_sym_static] = ACTIONS(4151),
    [anon_sym_member] = ACTIONS(4151),
    [anon_sym_interface] = ACTIONS(4151),
    [anon_sym_abstract] = ACTIONS(4151),
    [anon_sym_val] = ACTIONS(4151),
    [anon_sym_override] = ACTIONS(4151),
    [aux_sym_char_token1] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4151),
    [anon_sym_DQUOTE] = ACTIONS(4151),
    [anon_sym_AT_DQUOTE] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [sym_bool] = ACTIONS(4151),
    [sym_unit] = ACTIONS(4149),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4151),
    [sym_op_identifier] = ACTIONS(4151),
    [anon_sym_PLUS] = ACTIONS(4151),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_PLUS_DOT] = ACTIONS(4151),
    [anon_sym_DASH_DOT] = ACTIONS(4151),
    [anon_sym_PERCENT] = ACTIONS(4151),
    [anon_sym_AMP_AMP] = ACTIONS(4151),
    [anon_sym_TILDE] = ACTIONS(4149),
    [aux_sym_prefix_op_token1] = ACTIONS(4151),
    [aux_sym_infix_op_token1] = ACTIONS(4149),
    [aux_sym_infix_op_token2] = ACTIONS(4151),
    [anon_sym_PIPE_PIPE] = ACTIONS(4151),
    [anon_sym_BANG_EQ] = ACTIONS(4151),
    [anon_sym_COLON_EQ] = ACTIONS(4149),
    [anon_sym_DOLLAR] = ACTIONS(4151),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4151),
    [sym_int] = ACTIONS(4151),
    [sym_xint] = ACTIONS(4149),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4149),
    [sym__newline] = ACTIONS(4149),
    [sym__dedent] = ACTIONS(4149),
  },
  [1927] = {
    [sym_block_comment] = STATE(1927),
    [sym_compiler_directive_decl] = STATE(1927),
    [sym_fsi_directive_decl] = STATE(1927),
    [sym_preproc_line] = STATE(1927),
    [sym_identifier] = ACTIONS(4158),
    [anon_sym_EQ] = ACTIONS(4156),
    [anon_sym_LBRACK_LT] = ACTIONS(4156),
    [anon_sym_COLON] = ACTIONS(4158),
    [anon_sym_return] = ACTIONS(4158),
    [anon_sym_do] = ACTIONS(4158),
    [anon_sym_and] = ACTIONS(4158),
    [anon_sym_let] = ACTIONS(4158),
    [anon_sym_let_BANG] = ACTIONS(4156),
    [aux_sym_access_modifier_token1] = ACTIONS(4156),
    [anon_sym_LPAREN] = ACTIONS(4158),
    [anon_sym_COMMA] = ACTIONS(4156),
    [anon_sym_null] = ACTIONS(4158),
    [anon_sym_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_COLON] = ACTIONS(4156),
    [anon_sym_AMP] = ACTIONS(4158),
    [anon_sym_LBRACK] = ACTIONS(4158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(4158),
    [anon_sym_LT_AT] = ACTIONS(4158),
    [anon_sym_LT_AT_AT] = ACTIONS(4158),
    [anon_sym_DOT] = ACTIONS(4158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4156),
    [anon_sym_new] = ACTIONS(4158),
    [anon_sym_with] = ACTIONS(4158),
    [anon_sym_return_BANG] = ACTIONS(4156),
    [anon_sym_yield] = ACTIONS(4158),
    [anon_sym_yield_BANG] = ACTIONS(4156),
    [anon_sym_lazy] = ACTIONS(4158),
    [anon_sym_assert] = ACTIONS(4158),
    [anon_sym_upcast] = ACTIONS(4158),
    [anon_sym_downcast] = ACTIONS(4158),
    [anon_sym_COLON_GT] = ACTIONS(4156),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4156),
    [anon_sym_for] = ACTIONS(4158),
    [anon_sym_while] = ACTIONS(4158),
    [anon_sym_if] = ACTIONS(4158),
    [anon_sym_fun] = ACTIONS(4158),
    [anon_sym_try] = ACTIONS(4158),
    [anon_sym_match] = ACTIONS(4158),
    [anon_sym_match_BANG] = ACTIONS(4156),
    [anon_sym_function] = ACTIONS(4158),
    [anon_sym_LT_DASH] = ACTIONS(4158),
    [anon_sym_DOT_LBRACK] = ACTIONS(4156),
    [anon_sym_LT] = ACTIONS(4156),
    [anon_sym_use] = ACTIONS(4158),
    [anon_sym_use_BANG] = ACTIONS(4156),
    [anon_sym_do_BANG] = ACTIONS(4156),
    [anon_sym_begin] = ACTIONS(4158),
    [anon_sym_LPAREN2] = ACTIONS(4158),
    [anon_sym_default] = ACTIONS(4158),
    [anon_sym_or] = ACTIONS(4158),
    [anon_sym_static] = ACTIONS(4158),
    [anon_sym_member] = ACTIONS(4158),
    [anon_sym_interface] = ACTIONS(4158),
    [anon_sym_abstract] = ACTIONS(4158),
    [anon_sym_val] = ACTIONS(4158),
    [anon_sym_override] = ACTIONS(4158),
    [aux_sym_char_token1] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4158),
    [anon_sym_DQUOTE] = ACTIONS(4158),
    [anon_sym_AT_DQUOTE] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [sym_bool] = ACTIONS(4158),
    [sym_unit] = ACTIONS(4156),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4158),
    [sym_op_identifier] = ACTIONS(4158),
    [anon_sym_PLUS] = ACTIONS(4158),
    [anon_sym_DASH] = ACTIONS(4158),
    [anon_sym_PLUS_DOT] = ACTIONS(4158),
    [anon_sym_DASH_DOT] = ACTIONS(4158),
    [anon_sym_PERCENT] = ACTIONS(4158),
    [anon_sym_AMP_AMP] = ACTIONS(4158),
    [anon_sym_TILDE] = ACTIONS(4156),
    [aux_sym_prefix_op_token1] = ACTIONS(4158),
    [aux_sym_infix_op_token1] = ACTIONS(4156),
    [aux_sym_infix_op_token2] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE] = ACTIONS(4158),
    [anon_sym_BANG_EQ] = ACTIONS(4158),
    [anon_sym_COLON_EQ] = ACTIONS(4156),
    [anon_sym_DOLLAR] = ACTIONS(4158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4158),
    [sym_int] = ACTIONS(4158),
    [sym_xint] = ACTIONS(4156),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4156),
    [sym__newline] = ACTIONS(4156),
    [sym__dedent] = ACTIONS(4156),
  },
  [1928] = {
    [sym_block_comment] = STATE(1928),
    [sym_compiler_directive_decl] = STATE(1928),
    [sym_fsi_directive_decl] = STATE(1928),
    [sym_preproc_line] = STATE(1928),
    [sym_identifier] = ACTIONS(4100),
    [anon_sym_EQ] = ACTIONS(4098),
    [anon_sym_LBRACK_LT] = ACTIONS(4098),
    [anon_sym_COLON] = ACTIONS(4100),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_do] = ACTIONS(4100),
    [anon_sym_let] = ACTIONS(4100),
    [anon_sym_let_BANG] = ACTIONS(4098),
    [aux_sym_access_modifier_token1] = ACTIONS(4098),
    [anon_sym_LPAREN] = ACTIONS(4100),
    [anon_sym_COMMA] = ACTIONS(4098),
    [anon_sym_null] = ACTIONS(4100),
    [anon_sym_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_COLON] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4100),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4098),
    [anon_sym_LBRACE] = ACTIONS(4100),
    [anon_sym_LT_AT] = ACTIONS(4100),
    [anon_sym_LT_AT_AT] = ACTIONS(4100),
    [anon_sym_DOT] = ACTIONS(4100),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4098),
    [anon_sym_new] = ACTIONS(4100),
    [anon_sym_with] = ACTIONS(4100),
    [anon_sym_return_BANG] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4100),
    [anon_sym_yield_BANG] = ACTIONS(4098),
    [anon_sym_lazy] = ACTIONS(4100),
    [anon_sym_assert] = ACTIONS(4100),
    [anon_sym_upcast] = ACTIONS(4100),
    [anon_sym_downcast] = ACTIONS(4100),
    [anon_sym_COLON_GT] = ACTIONS(4098),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4098),
    [anon_sym_for] = ACTIONS(4100),
    [anon_sym_while] = ACTIONS(4100),
    [anon_sym_if] = ACTIONS(4100),
    [anon_sym_fun] = ACTIONS(4100),
    [anon_sym_try] = ACTIONS(4100),
    [anon_sym_match] = ACTIONS(4100),
    [anon_sym_match_BANG] = ACTIONS(4098),
    [anon_sym_function] = ACTIONS(4100),
    [anon_sym_LT_DASH] = ACTIONS(4100),
    [anon_sym_DOT_LBRACK] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(4098),
    [anon_sym_use] = ACTIONS(4100),
    [anon_sym_use_BANG] = ACTIONS(4098),
    [anon_sym_do_BANG] = ACTIONS(4098),
    [anon_sym_begin] = ACTIONS(4100),
    [anon_sym_LPAREN2] = ACTIONS(4100),
    [anon_sym_default] = ACTIONS(4100),
    [anon_sym_or] = ACTIONS(4100),
    [anon_sym_static] = ACTIONS(4100),
    [anon_sym_member] = ACTIONS(4100),
    [anon_sym_interface] = ACTIONS(4100),
    [anon_sym_abstract] = ACTIONS(4100),
    [anon_sym_val] = ACTIONS(4100),
    [anon_sym_override] = ACTIONS(4100),
    [anon_sym_inherit] = ACTIONS(4100),
    [aux_sym_char_token1] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4100),
    [anon_sym_DQUOTE] = ACTIONS(4100),
    [anon_sym_AT_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [sym_bool] = ACTIONS(4100),
    [sym_unit] = ACTIONS(4098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4100),
    [sym_op_identifier] = ACTIONS(4100),
    [anon_sym_PLUS] = ACTIONS(4100),
    [anon_sym_DASH] = ACTIONS(4100),
    [anon_sym_PLUS_DOT] = ACTIONS(4100),
    [anon_sym_DASH_DOT] = ACTIONS(4100),
    [anon_sym_PERCENT] = ACTIONS(4100),
    [anon_sym_AMP_AMP] = ACTIONS(4100),
    [anon_sym_TILDE] = ACTIONS(4098),
    [aux_sym_prefix_op_token1] = ACTIONS(4100),
    [aux_sym_infix_op_token1] = ACTIONS(4098),
    [aux_sym_infix_op_token2] = ACTIONS(4100),
    [anon_sym_PIPE_PIPE] = ACTIONS(4100),
    [anon_sym_BANG_EQ] = ACTIONS(4100),
    [anon_sym_COLON_EQ] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4100),
    [sym_int] = ACTIONS(4100),
    [sym_xint] = ACTIONS(4098),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4098),
    [anon_sym_POUNDendif] = ACTIONS(4098),
    [sym__newline] = ACTIONS(4098),
  },
  [1929] = {
    [sym_block_comment] = STATE(1929),
    [sym_compiler_directive_decl] = STATE(1929),
    [sym_fsi_directive_decl] = STATE(1929),
    [sym_preproc_line] = STATE(1929),
    [sym_identifier] = ACTIONS(4104),
    [anon_sym_EQ] = ACTIONS(4102),
    [anon_sym_LBRACK_LT] = ACTIONS(4102),
    [anon_sym_COLON] = ACTIONS(4104),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_do] = ACTIONS(4104),
    [anon_sym_let] = ACTIONS(4104),
    [anon_sym_let_BANG] = ACTIONS(4102),
    [aux_sym_access_modifier_token1] = ACTIONS(4102),
    [anon_sym_LPAREN] = ACTIONS(4104),
    [anon_sym_COMMA] = ACTIONS(4102),
    [anon_sym_null] = ACTIONS(4104),
    [anon_sym_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_COLON] = ACTIONS(4102),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4104),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4102),
    [anon_sym_LBRACE] = ACTIONS(4104),
    [anon_sym_LT_AT] = ACTIONS(4104),
    [anon_sym_LT_AT_AT] = ACTIONS(4104),
    [anon_sym_DOT] = ACTIONS(4104),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4102),
    [anon_sym_new] = ACTIONS(4104),
    [anon_sym_with] = ACTIONS(4104),
    [anon_sym_return_BANG] = ACTIONS(4102),
    [anon_sym_yield] = ACTIONS(4104),
    [anon_sym_yield_BANG] = ACTIONS(4102),
    [anon_sym_lazy] = ACTIONS(4104),
    [anon_sym_assert] = ACTIONS(4104),
    [anon_sym_upcast] = ACTIONS(4104),
    [anon_sym_downcast] = ACTIONS(4104),
    [anon_sym_COLON_GT] = ACTIONS(4102),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4102),
    [anon_sym_for] = ACTIONS(4104),
    [anon_sym_while] = ACTIONS(4104),
    [anon_sym_if] = ACTIONS(4104),
    [anon_sym_fun] = ACTIONS(4104),
    [anon_sym_try] = ACTIONS(4104),
    [anon_sym_match] = ACTIONS(4104),
    [anon_sym_match_BANG] = ACTIONS(4102),
    [anon_sym_function] = ACTIONS(4104),
    [anon_sym_LT_DASH] = ACTIONS(4104),
    [anon_sym_DOT_LBRACK] = ACTIONS(4102),
    [anon_sym_LT] = ACTIONS(4102),
    [anon_sym_use] = ACTIONS(4104),
    [anon_sym_use_BANG] = ACTIONS(4102),
    [anon_sym_do_BANG] = ACTIONS(4102),
    [anon_sym_begin] = ACTIONS(4104),
    [anon_sym_LPAREN2] = ACTIONS(4104),
    [anon_sym_DOT_DOT2] = ACTIONS(4102),
    [anon_sym_default] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [anon_sym_static] = ACTIONS(4104),
    [anon_sym_member] = ACTIONS(4104),
    [anon_sym_interface] = ACTIONS(4104),
    [anon_sym_abstract] = ACTIONS(4104),
    [anon_sym_val] = ACTIONS(4104),
    [anon_sym_override] = ACTIONS(4104),
    [aux_sym_char_token1] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4104),
    [anon_sym_DQUOTE] = ACTIONS(4104),
    [anon_sym_AT_DQUOTE] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [sym_bool] = ACTIONS(4104),
    [sym_unit] = ACTIONS(4102),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4104),
    [sym_op_identifier] = ACTIONS(4104),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_PLUS_DOT] = ACTIONS(4104),
    [anon_sym_DASH_DOT] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_AMP_AMP] = ACTIONS(4104),
    [anon_sym_TILDE] = ACTIONS(4102),
    [aux_sym_prefix_op_token1] = ACTIONS(4104),
    [aux_sym_infix_op_token1] = ACTIONS(4102),
    [aux_sym_infix_op_token2] = ACTIONS(4104),
    [anon_sym_PIPE_PIPE] = ACTIONS(4104),
    [anon_sym_BANG_EQ] = ACTIONS(4104),
    [anon_sym_COLON_EQ] = ACTIONS(4102),
    [anon_sym_DOLLAR] = ACTIONS(4104),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4104),
    [sym_int] = ACTIONS(4104),
    [sym_xint] = ACTIONS(4102),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4102),
    [sym__newline] = ACTIONS(4102),
    [sym__dedent] = ACTIONS(4102),
  },
  [1930] = {
    [sym_block_comment] = STATE(1930),
    [sym_compiler_directive_decl] = STATE(1930),
    [sym_fsi_directive_decl] = STATE(1930),
    [sym_preproc_line] = STATE(1930),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [aux_sym_access_modifier_token1] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_DOT_DOT2] = ACTIONS(3191),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_member] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_val] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
    [sym__dedent] = ACTIONS(3191),
  },
  [1931] = {
    [sym_block_comment] = STATE(1931),
    [sym_compiler_directive_decl] = STATE(1931),
    [sym_fsi_directive_decl] = STATE(1931),
    [sym_preproc_line] = STATE(1931),
    [sym_identifier] = ACTIONS(4162),
    [anon_sym_EQ] = ACTIONS(4160),
    [anon_sym_LBRACK_LT] = ACTIONS(4160),
    [anon_sym_COLON] = ACTIONS(4162),
    [anon_sym_return] = ACTIONS(4162),
    [anon_sym_do] = ACTIONS(4162),
    [anon_sym_and] = ACTIONS(4162),
    [anon_sym_let] = ACTIONS(4162),
    [anon_sym_let_BANG] = ACTIONS(4160),
    [aux_sym_access_modifier_token1] = ACTIONS(4160),
    [anon_sym_LPAREN] = ACTIONS(4162),
    [anon_sym_COMMA] = ACTIONS(4160),
    [anon_sym_null] = ACTIONS(4162),
    [anon_sym_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4160),
    [anon_sym_AMP] = ACTIONS(4162),
    [anon_sym_LBRACK] = ACTIONS(4162),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4160),
    [anon_sym_LBRACE] = ACTIONS(4162),
    [anon_sym_LT_AT] = ACTIONS(4162),
    [anon_sym_LT_AT_AT] = ACTIONS(4162),
    [anon_sym_DOT] = ACTIONS(4162),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4160),
    [anon_sym_new] = ACTIONS(4162),
    [anon_sym_with] = ACTIONS(4162),
    [anon_sym_return_BANG] = ACTIONS(4160),
    [anon_sym_yield] = ACTIONS(4162),
    [anon_sym_yield_BANG] = ACTIONS(4160),
    [anon_sym_lazy] = ACTIONS(4162),
    [anon_sym_assert] = ACTIONS(4162),
    [anon_sym_upcast] = ACTIONS(4162),
    [anon_sym_downcast] = ACTIONS(4162),
    [anon_sym_COLON_GT] = ACTIONS(4160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4160),
    [anon_sym_for] = ACTIONS(4162),
    [anon_sym_while] = ACTIONS(4162),
    [anon_sym_if] = ACTIONS(4162),
    [anon_sym_fun] = ACTIONS(4162),
    [anon_sym_try] = ACTIONS(4162),
    [anon_sym_match] = ACTIONS(4162),
    [anon_sym_match_BANG] = ACTIONS(4160),
    [anon_sym_function] = ACTIONS(4162),
    [anon_sym_LT_DASH] = ACTIONS(4162),
    [anon_sym_DOT_LBRACK] = ACTIONS(4160),
    [anon_sym_LT] = ACTIONS(4160),
    [anon_sym_use] = ACTIONS(4162),
    [anon_sym_use_BANG] = ACTIONS(4160),
    [anon_sym_do_BANG] = ACTIONS(4160),
    [anon_sym_begin] = ACTIONS(4162),
    [anon_sym_LPAREN2] = ACTIONS(4162),
    [anon_sym_default] = ACTIONS(4162),
    [anon_sym_or] = ACTIONS(4162),
    [anon_sym_static] = ACTIONS(4162),
    [anon_sym_member] = ACTIONS(4162),
    [anon_sym_interface] = ACTIONS(4162),
    [anon_sym_abstract] = ACTIONS(4162),
    [anon_sym_val] = ACTIONS(4162),
    [anon_sym_override] = ACTIONS(4162),
    [aux_sym_char_token1] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4162),
    [anon_sym_DQUOTE] = ACTIONS(4162),
    [anon_sym_AT_DQUOTE] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [sym_bool] = ACTIONS(4162),
    [sym_unit] = ACTIONS(4160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4162),
    [sym_op_identifier] = ACTIONS(4162),
    [anon_sym_PLUS] = ACTIONS(4162),
    [anon_sym_DASH] = ACTIONS(4162),
    [anon_sym_PLUS_DOT] = ACTIONS(4162),
    [anon_sym_DASH_DOT] = ACTIONS(4162),
    [anon_sym_PERCENT] = ACTIONS(4162),
    [anon_sym_AMP_AMP] = ACTIONS(4162),
    [anon_sym_TILDE] = ACTIONS(4160),
    [aux_sym_prefix_op_token1] = ACTIONS(4162),
    [aux_sym_infix_op_token1] = ACTIONS(4160),
    [aux_sym_infix_op_token2] = ACTIONS(4162),
    [anon_sym_PIPE_PIPE] = ACTIONS(4162),
    [anon_sym_BANG_EQ] = ACTIONS(4162),
    [anon_sym_COLON_EQ] = ACTIONS(4160),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4162),
    [sym_int] = ACTIONS(4162),
    [sym_xint] = ACTIONS(4160),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4160),
    [sym__newline] = ACTIONS(4160),
    [sym__dedent] = ACTIONS(4160),
  },
  [1932] = {
    [sym_block_comment] = STATE(1932),
    [sym_compiler_directive_decl] = STATE(1932),
    [sym_fsi_directive_decl] = STATE(1932),
    [sym_preproc_line] = STATE(1932),
    [sym_identifier] = ACTIONS(4100),
    [anon_sym_EQ] = ACTIONS(4098),
    [anon_sym_LBRACK_LT] = ACTIONS(4098),
    [anon_sym_COLON] = ACTIONS(4100),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_do] = ACTIONS(4100),
    [anon_sym_let] = ACTIONS(4100),
    [anon_sym_let_BANG] = ACTIONS(4098),
    [aux_sym_access_modifier_token1] = ACTIONS(4098),
    [anon_sym_LPAREN] = ACTIONS(4100),
    [anon_sym_COMMA] = ACTIONS(4098),
    [anon_sym_null] = ACTIONS(4100),
    [anon_sym_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_COLON] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4100),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4098),
    [anon_sym_LBRACE] = ACTIONS(4100),
    [anon_sym_LT_AT] = ACTIONS(4100),
    [anon_sym_LT_AT_AT] = ACTIONS(4100),
    [anon_sym_DOT] = ACTIONS(4100),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4098),
    [anon_sym_new] = ACTIONS(4100),
    [anon_sym_with] = ACTIONS(4100),
    [anon_sym_return_BANG] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4100),
    [anon_sym_yield_BANG] = ACTIONS(4098),
    [anon_sym_lazy] = ACTIONS(4100),
    [anon_sym_assert] = ACTIONS(4100),
    [anon_sym_upcast] = ACTIONS(4100),
    [anon_sym_downcast] = ACTIONS(4100),
    [anon_sym_COLON_GT] = ACTIONS(4098),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4098),
    [anon_sym_for] = ACTIONS(4100),
    [anon_sym_while] = ACTIONS(4100),
    [anon_sym_if] = ACTIONS(4100),
    [anon_sym_fun] = ACTIONS(4100),
    [anon_sym_try] = ACTIONS(4100),
    [anon_sym_match] = ACTIONS(4100),
    [anon_sym_match_BANG] = ACTIONS(4098),
    [anon_sym_function] = ACTIONS(4100),
    [anon_sym_LT_DASH] = ACTIONS(4100),
    [anon_sym_DOT_LBRACK] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(4098),
    [anon_sym_use] = ACTIONS(4100),
    [anon_sym_use_BANG] = ACTIONS(4098),
    [anon_sym_do_BANG] = ACTIONS(4098),
    [anon_sym_begin] = ACTIONS(4100),
    [anon_sym_LPAREN2] = ACTIONS(4100),
    [anon_sym_DOT_DOT2] = ACTIONS(4098),
    [anon_sym_default] = ACTIONS(4100),
    [anon_sym_or] = ACTIONS(4100),
    [anon_sym_static] = ACTIONS(4100),
    [anon_sym_member] = ACTIONS(4100),
    [anon_sym_interface] = ACTIONS(4100),
    [anon_sym_abstract] = ACTIONS(4100),
    [anon_sym_val] = ACTIONS(4100),
    [anon_sym_override] = ACTIONS(4100),
    [aux_sym_char_token1] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4100),
    [anon_sym_DQUOTE] = ACTIONS(4100),
    [anon_sym_AT_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [sym_bool] = ACTIONS(4100),
    [sym_unit] = ACTIONS(4098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4100),
    [sym_op_identifier] = ACTIONS(4100),
    [anon_sym_PLUS] = ACTIONS(4100),
    [anon_sym_DASH] = ACTIONS(4100),
    [anon_sym_PLUS_DOT] = ACTIONS(4100),
    [anon_sym_DASH_DOT] = ACTIONS(4100),
    [anon_sym_PERCENT] = ACTIONS(4100),
    [anon_sym_AMP_AMP] = ACTIONS(4100),
    [anon_sym_TILDE] = ACTIONS(4098),
    [aux_sym_prefix_op_token1] = ACTIONS(4100),
    [aux_sym_infix_op_token1] = ACTIONS(4098),
    [aux_sym_infix_op_token2] = ACTIONS(4100),
    [anon_sym_PIPE_PIPE] = ACTIONS(4100),
    [anon_sym_BANG_EQ] = ACTIONS(4100),
    [anon_sym_COLON_EQ] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4100),
    [sym_int] = ACTIONS(4100),
    [sym_xint] = ACTIONS(4098),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4098),
    [sym__newline] = ACTIONS(4098),
    [sym__dedent] = ACTIONS(4098),
  },
  [1933] = {
    [sym_block_comment] = STATE(1933),
    [sym_compiler_directive_decl] = STATE(1933),
    [sym_fsi_directive_decl] = STATE(1933),
    [sym_preproc_line] = STATE(1933),
    [sym_identifier] = ACTIONS(4182),
    [anon_sym_EQ] = ACTIONS(3689),
    [anon_sym_LBRACK_LT] = ACTIONS(3689),
    [anon_sym_COLON] = ACTIONS(4182),
    [anon_sym_return] = ACTIONS(4182),
    [anon_sym_do] = ACTIONS(4182),
    [anon_sym_and] = ACTIONS(4182),
    [anon_sym_let] = ACTIONS(4182),
    [anon_sym_let_BANG] = ACTIONS(3689),
    [aux_sym_access_modifier_token1] = ACTIONS(3689),
    [anon_sym_LPAREN] = ACTIONS(4182),
    [anon_sym_COMMA] = ACTIONS(3689),
    [anon_sym_null] = ACTIONS(4182),
    [anon_sym_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3689),
    [anon_sym_LBRACE] = ACTIONS(4182),
    [anon_sym_LT_AT] = ACTIONS(4182),
    [anon_sym_LT_AT_AT] = ACTIONS(4182),
    [anon_sym_DOT] = ACTIONS(4182),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3689),
    [anon_sym_new] = ACTIONS(4182),
    [anon_sym_with] = ACTIONS(4182),
    [anon_sym_return_BANG] = ACTIONS(3689),
    [anon_sym_yield] = ACTIONS(4182),
    [anon_sym_yield_BANG] = ACTIONS(3689),
    [anon_sym_lazy] = ACTIONS(4182),
    [anon_sym_assert] = ACTIONS(4182),
    [anon_sym_upcast] = ACTIONS(4182),
    [anon_sym_downcast] = ACTIONS(4182),
    [anon_sym_COLON_GT] = ACTIONS(3689),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3689),
    [anon_sym_for] = ACTIONS(4182),
    [anon_sym_while] = ACTIONS(4182),
    [anon_sym_if] = ACTIONS(4182),
    [anon_sym_fun] = ACTIONS(4182),
    [anon_sym_try] = ACTIONS(4182),
    [anon_sym_match] = ACTIONS(4182),
    [anon_sym_match_BANG] = ACTIONS(3689),
    [anon_sym_function] = ACTIONS(4182),
    [anon_sym_LT_DASH] = ACTIONS(4182),
    [anon_sym_DOT_LBRACK] = ACTIONS(3689),
    [anon_sym_LT] = ACTIONS(3689),
    [anon_sym_use] = ACTIONS(4182),
    [anon_sym_use_BANG] = ACTIONS(3689),
    [anon_sym_do_BANG] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(4182),
    [anon_sym_LPAREN2] = ACTIONS(4182),
    [anon_sym_default] = ACTIONS(4182),
    [anon_sym_or] = ACTIONS(4182),
    [anon_sym_static] = ACTIONS(4182),
    [anon_sym_member] = ACTIONS(4182),
    [anon_sym_interface] = ACTIONS(4182),
    [anon_sym_abstract] = ACTIONS(4182),
    [anon_sym_val] = ACTIONS(4182),
    [anon_sym_override] = ACTIONS(4182),
    [aux_sym_char_token1] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4182),
    [anon_sym_DQUOTE] = ACTIONS(4182),
    [anon_sym_AT_DQUOTE] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [sym_bool] = ACTIONS(4182),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4182),
    [sym_op_identifier] = ACTIONS(4182),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_PLUS_DOT] = ACTIONS(4182),
    [anon_sym_DASH_DOT] = ACTIONS(4182),
    [anon_sym_PERCENT] = ACTIONS(4182),
    [anon_sym_AMP_AMP] = ACTIONS(4182),
    [anon_sym_TILDE] = ACTIONS(3689),
    [aux_sym_prefix_op_token1] = ACTIONS(4182),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token2] = ACTIONS(4182),
    [anon_sym_PIPE_PIPE] = ACTIONS(4182),
    [anon_sym_BANG_EQ] = ACTIONS(4182),
    [anon_sym_COLON_EQ] = ACTIONS(3689),
    [anon_sym_DOLLAR] = ACTIONS(4182),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4182),
    [sym_int] = ACTIONS(4182),
    [sym_xint] = ACTIONS(3689),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3689),
    [sym__newline] = ACTIONS(3689),
    [sym__dedent] = ACTIONS(3689),
  },
  [1934] = {
    [sym_block_comment] = STATE(1934),
    [sym_compiler_directive_decl] = STATE(1934),
    [sym_fsi_directive_decl] = STATE(1934),
    [sym_preproc_line] = STATE(1934),
    [sym_identifier] = ACTIONS(4208),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LBRACK_LT] = ACTIONS(4206),
    [anon_sym_COLON] = ACTIONS(4208),
    [anon_sym_return] = ACTIONS(4208),
    [anon_sym_do] = ACTIONS(4208),
    [anon_sym_let] = ACTIONS(4208),
    [anon_sym_let_BANG] = ACTIONS(4206),
    [aux_sym_access_modifier_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(4206),
    [anon_sym_null] = ACTIONS(4208),
    [anon_sym_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_COLON] = ACTIONS(4206),
    [anon_sym_AMP] = ACTIONS(4208),
    [anon_sym_LBRACK] = ACTIONS(4208),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4206),
    [anon_sym_LBRACE] = ACTIONS(4208),
    [anon_sym_LT_AT] = ACTIONS(4208),
    [anon_sym_LT_AT_AT] = ACTIONS(4208),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4206),
    [anon_sym_new] = ACTIONS(4208),
    [anon_sym_with] = ACTIONS(4208),
    [anon_sym_return_BANG] = ACTIONS(4206),
    [anon_sym_yield] = ACTIONS(4208),
    [anon_sym_yield_BANG] = ACTIONS(4206),
    [anon_sym_lazy] = ACTIONS(4208),
    [anon_sym_assert] = ACTIONS(4208),
    [anon_sym_upcast] = ACTIONS(4208),
    [anon_sym_downcast] = ACTIONS(4208),
    [anon_sym_COLON_GT] = ACTIONS(4206),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4206),
    [anon_sym_for] = ACTIONS(4208),
    [anon_sym_while] = ACTIONS(4208),
    [anon_sym_if] = ACTIONS(4208),
    [anon_sym_fun] = ACTIONS(4208),
    [anon_sym_try] = ACTIONS(4208),
    [anon_sym_match] = ACTIONS(4208),
    [anon_sym_match_BANG] = ACTIONS(4206),
    [anon_sym_function] = ACTIONS(4208),
    [anon_sym_LT_DASH] = ACTIONS(4208),
    [anon_sym_DOT_LBRACK] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(4206),
    [anon_sym_use] = ACTIONS(4208),
    [anon_sym_use_BANG] = ACTIONS(4206),
    [anon_sym_do_BANG] = ACTIONS(4206),
    [anon_sym_begin] = ACTIONS(4208),
    [anon_sym_LPAREN2] = ACTIONS(4208),
    [anon_sym_DOT_DOT2] = ACTIONS(4206),
    [anon_sym_default] = ACTIONS(4208),
    [anon_sym_or] = ACTIONS(4208),
    [anon_sym_static] = ACTIONS(4208),
    [anon_sym_member] = ACTIONS(4208),
    [anon_sym_interface] = ACTIONS(4208),
    [anon_sym_abstract] = ACTIONS(4208),
    [anon_sym_val] = ACTIONS(4208),
    [anon_sym_override] = ACTIONS(4208),
    [aux_sym_char_token1] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4208),
    [anon_sym_DQUOTE] = ACTIONS(4208),
    [anon_sym_AT_DQUOTE] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [sym_bool] = ACTIONS(4208),
    [sym_unit] = ACTIONS(4206),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4208),
    [sym_op_identifier] = ACTIONS(4208),
    [anon_sym_PLUS] = ACTIONS(4208),
    [anon_sym_DASH] = ACTIONS(4208),
    [anon_sym_PLUS_DOT] = ACTIONS(4208),
    [anon_sym_DASH_DOT] = ACTIONS(4208),
    [anon_sym_PERCENT] = ACTIONS(4208),
    [anon_sym_AMP_AMP] = ACTIONS(4208),
    [anon_sym_TILDE] = ACTIONS(4206),
    [aux_sym_prefix_op_token1] = ACTIONS(4208),
    [aux_sym_infix_op_token1] = ACTIONS(4206),
    [aux_sym_infix_op_token2] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(4208),
    [anon_sym_BANG_EQ] = ACTIONS(4208),
    [anon_sym_COLON_EQ] = ACTIONS(4206),
    [anon_sym_DOLLAR] = ACTIONS(4208),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4208),
    [sym_int] = ACTIONS(4208),
    [sym_xint] = ACTIONS(4206),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4206),
    [sym__newline] = ACTIONS(4206),
    [sym__dedent] = ACTIONS(4206),
  },
  [1935] = {
    [sym_block_comment] = STATE(1935),
    [sym_compiler_directive_decl] = STATE(1935),
    [sym_fsi_directive_decl] = STATE(1935),
    [sym_preproc_line] = STATE(1935),
    [sym_identifier] = ACTIONS(4186),
    [anon_sym_EQ] = ACTIONS(4184),
    [anon_sym_LBRACK_LT] = ACTIONS(4184),
    [anon_sym_COLON] = ACTIONS(4186),
    [anon_sym_return] = ACTIONS(4186),
    [anon_sym_do] = ACTIONS(4186),
    [anon_sym_let] = ACTIONS(4186),
    [anon_sym_let_BANG] = ACTIONS(4184),
    [aux_sym_access_modifier_token1] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_COMMA] = ACTIONS(4184),
    [anon_sym_null] = ACTIONS(4186),
    [anon_sym_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_COLON] = ACTIONS(4184),
    [anon_sym_AMP] = ACTIONS(4186),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4184),
    [anon_sym_LBRACE] = ACTIONS(4186),
    [anon_sym_LT_AT] = ACTIONS(4186),
    [anon_sym_LT_AT_AT] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4186),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4184),
    [anon_sym_new] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4186),
    [anon_sym_return_BANG] = ACTIONS(4184),
    [anon_sym_yield] = ACTIONS(4186),
    [anon_sym_yield_BANG] = ACTIONS(4184),
    [anon_sym_lazy] = ACTIONS(4186),
    [anon_sym_assert] = ACTIONS(4186),
    [anon_sym_upcast] = ACTIONS(4186),
    [anon_sym_downcast] = ACTIONS(4186),
    [anon_sym_COLON_GT] = ACTIONS(4184),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4184),
    [anon_sym_for] = ACTIONS(4186),
    [anon_sym_while] = ACTIONS(4186),
    [anon_sym_if] = ACTIONS(4186),
    [anon_sym_fun] = ACTIONS(4186),
    [anon_sym_try] = ACTIONS(4186),
    [anon_sym_match] = ACTIONS(4186),
    [anon_sym_match_BANG] = ACTIONS(4184),
    [anon_sym_function] = ACTIONS(4186),
    [anon_sym_LT_DASH] = ACTIONS(4186),
    [anon_sym_DOT_LBRACK] = ACTIONS(4184),
    [anon_sym_LT] = ACTIONS(4184),
    [anon_sym_use] = ACTIONS(4186),
    [anon_sym_use_BANG] = ACTIONS(4184),
    [anon_sym_do_BANG] = ACTIONS(4184),
    [anon_sym_begin] = ACTIONS(4186),
    [anon_sym_LPAREN2] = ACTIONS(4186),
    [anon_sym_default] = ACTIONS(4186),
    [anon_sym_or] = ACTIONS(4186),
    [anon_sym_static] = ACTIONS(4186),
    [anon_sym_member] = ACTIONS(4186),
    [anon_sym_interface] = ACTIONS(4186),
    [anon_sym_abstract] = ACTIONS(4186),
    [anon_sym_val] = ACTIONS(4186),
    [anon_sym_override] = ACTIONS(4186),
    [anon_sym_inherit] = ACTIONS(4186),
    [aux_sym_char_token1] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4186),
    [anon_sym_DQUOTE] = ACTIONS(4186),
    [anon_sym_AT_DQUOTE] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [sym_bool] = ACTIONS(4186),
    [sym_unit] = ACTIONS(4184),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4186),
    [sym_op_identifier] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4186),
    [anon_sym_DASH] = ACTIONS(4186),
    [anon_sym_PLUS_DOT] = ACTIONS(4186),
    [anon_sym_DASH_DOT] = ACTIONS(4186),
    [anon_sym_PERCENT] = ACTIONS(4186),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_TILDE] = ACTIONS(4184),
    [aux_sym_prefix_op_token1] = ACTIONS(4186),
    [aux_sym_infix_op_token1] = ACTIONS(4184),
    [aux_sym_infix_op_token2] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_COLON_EQ] = ACTIONS(4184),
    [anon_sym_DOLLAR] = ACTIONS(4186),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4186),
    [sym_int] = ACTIONS(4186),
    [sym_xint] = ACTIONS(4184),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4184),
    [anon_sym_POUNDendif] = ACTIONS(4184),
    [sym__newline] = ACTIONS(4184),
  },
  [1936] = {
    [sym_block_comment] = STATE(1936),
    [sym_compiler_directive_decl] = STATE(1936),
    [sym_fsi_directive_decl] = STATE(1936),
    [sym_preproc_line] = STATE(1936),
    [sym_identifier] = ACTIONS(3927),
    [anon_sym_EQ] = ACTIONS(3925),
    [anon_sym_LBRACK_LT] = ACTIONS(3925),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_return] = ACTIONS(3927),
    [anon_sym_do] = ACTIONS(3927),
    [anon_sym_let] = ACTIONS(3927),
    [anon_sym_let_BANG] = ACTIONS(3925),
    [aux_sym_access_modifier_token1] = ACTIONS(3925),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_COMMA] = ACTIONS(3925),
    [anon_sym_null] = ACTIONS(3927),
    [anon_sym_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_COLON] = ACTIONS(3925),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3925),
    [anon_sym_LBRACE] = ACTIONS(3927),
    [anon_sym_LT_AT] = ACTIONS(3927),
    [anon_sym_LT_AT_AT] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3925),
    [anon_sym_new] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3927),
    [anon_sym_return_BANG] = ACTIONS(3925),
    [anon_sym_yield] = ACTIONS(3927),
    [anon_sym_yield_BANG] = ACTIONS(3925),
    [anon_sym_lazy] = ACTIONS(3927),
    [anon_sym_assert] = ACTIONS(3927),
    [anon_sym_upcast] = ACTIONS(3927),
    [anon_sym_downcast] = ACTIONS(3927),
    [anon_sym_COLON_GT] = ACTIONS(3925),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3925),
    [anon_sym_for] = ACTIONS(3927),
    [anon_sym_while] = ACTIONS(3927),
    [anon_sym_if] = ACTIONS(3927),
    [anon_sym_fun] = ACTIONS(3927),
    [anon_sym_try] = ACTIONS(3927),
    [anon_sym_match] = ACTIONS(3927),
    [anon_sym_match_BANG] = ACTIONS(3925),
    [anon_sym_function] = ACTIONS(3927),
    [anon_sym_LT_DASH] = ACTIONS(3927),
    [anon_sym_DOT_LBRACK] = ACTIONS(3925),
    [anon_sym_LT] = ACTIONS(3925),
    [anon_sym_use] = ACTIONS(3927),
    [anon_sym_use_BANG] = ACTIONS(3925),
    [anon_sym_do_BANG] = ACTIONS(3925),
    [anon_sym_begin] = ACTIONS(3927),
    [anon_sym_LPAREN2] = ACTIONS(3927),
    [anon_sym_DOT_DOT2] = ACTIONS(3925),
    [anon_sym_default] = ACTIONS(3927),
    [anon_sym_or] = ACTIONS(3927),
    [anon_sym_static] = ACTIONS(3927),
    [anon_sym_member] = ACTIONS(3927),
    [anon_sym_interface] = ACTIONS(3927),
    [anon_sym_abstract] = ACTIONS(3927),
    [anon_sym_val] = ACTIONS(3927),
    [anon_sym_override] = ACTIONS(3927),
    [aux_sym_char_token1] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_AT_DQUOTE] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [sym_bool] = ACTIONS(3927),
    [sym_unit] = ACTIONS(3925),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3927),
    [sym_op_identifier] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3927),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_PLUS_DOT] = ACTIONS(3927),
    [anon_sym_DASH_DOT] = ACTIONS(3927),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_TILDE] = ACTIONS(3925),
    [aux_sym_prefix_op_token1] = ACTIONS(3927),
    [aux_sym_infix_op_token1] = ACTIONS(3925),
    [aux_sym_infix_op_token2] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_COLON_EQ] = ACTIONS(3925),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3927),
    [sym_int] = ACTIONS(3927),
    [sym_xint] = ACTIONS(3925),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3925),
    [sym__newline] = ACTIONS(3925),
    [sym__dedent] = ACTIONS(3925),
  },
  [1937] = {
    [sym_block_comment] = STATE(1937),
    [sym_compiler_directive_decl] = STATE(1937),
    [sym_fsi_directive_decl] = STATE(1937),
    [sym_preproc_line] = STATE(1937),
    [sym_identifier] = ACTIONS(3946),
    [anon_sym_EQ] = ACTIONS(3944),
    [anon_sym_LBRACK_LT] = ACTIONS(3944),
    [anon_sym_COLON] = ACTIONS(3946),
    [anon_sym_return] = ACTIONS(3946),
    [anon_sym_do] = ACTIONS(3946),
    [anon_sym_let] = ACTIONS(3946),
    [anon_sym_let_BANG] = ACTIONS(3944),
    [aux_sym_access_modifier_token1] = ACTIONS(3944),
    [anon_sym_LPAREN] = ACTIONS(3946),
    [anon_sym_COMMA] = ACTIONS(3944),
    [anon_sym_null] = ACTIONS(3946),
    [anon_sym_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LBRACK] = ACTIONS(3946),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3944),
    [anon_sym_LBRACE] = ACTIONS(3946),
    [anon_sym_LT_AT] = ACTIONS(3946),
    [anon_sym_LT_AT_AT] = ACTIONS(3946),
    [anon_sym_DOT] = ACTIONS(3946),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3944),
    [anon_sym_new] = ACTIONS(3946),
    [anon_sym_with] = ACTIONS(3946),
    [anon_sym_return_BANG] = ACTIONS(3944),
    [anon_sym_yield] = ACTIONS(3946),
    [anon_sym_yield_BANG] = ACTIONS(3944),
    [anon_sym_lazy] = ACTIONS(3946),
    [anon_sym_assert] = ACTIONS(3946),
    [anon_sym_upcast] = ACTIONS(3946),
    [anon_sym_downcast] = ACTIONS(3946),
    [anon_sym_COLON_GT] = ACTIONS(3944),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3944),
    [anon_sym_for] = ACTIONS(3946),
    [anon_sym_while] = ACTIONS(3946),
    [anon_sym_if] = ACTIONS(3946),
    [anon_sym_fun] = ACTIONS(3946),
    [anon_sym_try] = ACTIONS(3946),
    [anon_sym_match] = ACTIONS(3946),
    [anon_sym_match_BANG] = ACTIONS(3944),
    [anon_sym_function] = ACTIONS(3946),
    [anon_sym_LT_DASH] = ACTIONS(3946),
    [anon_sym_DOT_LBRACK] = ACTIONS(3944),
    [anon_sym_LT] = ACTIONS(3944),
    [anon_sym_use] = ACTIONS(3946),
    [anon_sym_use_BANG] = ACTIONS(3944),
    [anon_sym_do_BANG] = ACTIONS(3944),
    [anon_sym_begin] = ACTIONS(3946),
    [anon_sym_LPAREN2] = ACTIONS(3946),
    [anon_sym_DOT_DOT2] = ACTIONS(3944),
    [anon_sym_default] = ACTIONS(3946),
    [anon_sym_or] = ACTIONS(3946),
    [anon_sym_static] = ACTIONS(3946),
    [anon_sym_member] = ACTIONS(3946),
    [anon_sym_interface] = ACTIONS(3946),
    [anon_sym_abstract] = ACTIONS(3946),
    [anon_sym_val] = ACTIONS(3946),
    [anon_sym_override] = ACTIONS(3946),
    [aux_sym_char_token1] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_AT_DQUOTE] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [sym_bool] = ACTIONS(3946),
    [sym_unit] = ACTIONS(3944),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3946),
    [sym_op_identifier] = ACTIONS(3946),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PLUS_DOT] = ACTIONS(3946),
    [anon_sym_DASH_DOT] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3946),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_TILDE] = ACTIONS(3944),
    [aux_sym_prefix_op_token1] = ACTIONS(3946),
    [aux_sym_infix_op_token1] = ACTIONS(3944),
    [aux_sym_infix_op_token2] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [anon_sym_BANG_EQ] = ACTIONS(3946),
    [anon_sym_COLON_EQ] = ACTIONS(3944),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3946),
    [sym_int] = ACTIONS(3946),
    [sym_xint] = ACTIONS(3944),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3944),
    [sym__newline] = ACTIONS(3944),
    [sym__dedent] = ACTIONS(3944),
  },
  [1938] = {
    [sym_block_comment] = STATE(1938),
    [sym_compiler_directive_decl] = STATE(1938),
    [sym_fsi_directive_decl] = STATE(1938),
    [sym_preproc_line] = STATE(1938),
    [sym_identifier] = ACTIONS(3954),
    [anon_sym_EQ] = ACTIONS(3952),
    [anon_sym_LBRACK_LT] = ACTIONS(3952),
    [anon_sym_COLON] = ACTIONS(3954),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_do] = ACTIONS(3954),
    [anon_sym_and] = ACTIONS(3954),
    [anon_sym_let] = ACTIONS(3954),
    [anon_sym_let_BANG] = ACTIONS(3952),
    [aux_sym_access_modifier_token1] = ACTIONS(3952),
    [anon_sym_LPAREN] = ACTIONS(3954),
    [anon_sym_COMMA] = ACTIONS(3952),
    [anon_sym_null] = ACTIONS(3954),
    [anon_sym_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_COLON] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3954),
    [anon_sym_LBRACK] = ACTIONS(3954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(3954),
    [anon_sym_LT_AT] = ACTIONS(3954),
    [anon_sym_LT_AT_AT] = ACTIONS(3954),
    [anon_sym_DOT] = ACTIONS(3954),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3952),
    [anon_sym_new] = ACTIONS(3954),
    [anon_sym_with] = ACTIONS(3954),
    [anon_sym_return_BANG] = ACTIONS(3952),
    [anon_sym_yield] = ACTIONS(3954),
    [anon_sym_yield_BANG] = ACTIONS(3952),
    [anon_sym_lazy] = ACTIONS(3954),
    [anon_sym_assert] = ACTIONS(3954),
    [anon_sym_upcast] = ACTIONS(3954),
    [anon_sym_downcast] = ACTIONS(3954),
    [anon_sym_COLON_GT] = ACTIONS(3952),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3952),
    [anon_sym_for] = ACTIONS(3954),
    [anon_sym_while] = ACTIONS(3954),
    [anon_sym_if] = ACTIONS(3954),
    [anon_sym_fun] = ACTIONS(3954),
    [anon_sym_try] = ACTIONS(3954),
    [anon_sym_match] = ACTIONS(3954),
    [anon_sym_match_BANG] = ACTIONS(3952),
    [anon_sym_function] = ACTIONS(3954),
    [anon_sym_LT_DASH] = ACTIONS(3954),
    [anon_sym_DOT_LBRACK] = ACTIONS(3952),
    [anon_sym_LT] = ACTIONS(3952),
    [anon_sym_use] = ACTIONS(3954),
    [anon_sym_use_BANG] = ACTIONS(3952),
    [anon_sym_do_BANG] = ACTIONS(3952),
    [anon_sym_begin] = ACTIONS(3954),
    [anon_sym_LPAREN2] = ACTIONS(3954),
    [anon_sym_default] = ACTIONS(3954),
    [anon_sym_or] = ACTIONS(3954),
    [anon_sym_static] = ACTIONS(3954),
    [anon_sym_member] = ACTIONS(3954),
    [anon_sym_interface] = ACTIONS(3954),
    [anon_sym_abstract] = ACTIONS(3954),
    [anon_sym_val] = ACTIONS(3954),
    [anon_sym_override] = ACTIONS(3954),
    [aux_sym_char_token1] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3954),
    [anon_sym_DQUOTE] = ACTIONS(3954),
    [anon_sym_AT_DQUOTE] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [sym_bool] = ACTIONS(3954),
    [sym_unit] = ACTIONS(3952),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3954),
    [sym_op_identifier] = ACTIONS(3954),
    [anon_sym_PLUS] = ACTIONS(3954),
    [anon_sym_DASH] = ACTIONS(3954),
    [anon_sym_PLUS_DOT] = ACTIONS(3954),
    [anon_sym_DASH_DOT] = ACTIONS(3954),
    [anon_sym_PERCENT] = ACTIONS(3954),
    [anon_sym_AMP_AMP] = ACTIONS(3954),
    [anon_sym_TILDE] = ACTIONS(3952),
    [aux_sym_prefix_op_token1] = ACTIONS(3954),
    [aux_sym_infix_op_token1] = ACTIONS(3952),
    [aux_sym_infix_op_token2] = ACTIONS(3954),
    [anon_sym_PIPE_PIPE] = ACTIONS(3954),
    [anon_sym_BANG_EQ] = ACTIONS(3954),
    [anon_sym_COLON_EQ] = ACTIONS(3952),
    [anon_sym_DOLLAR] = ACTIONS(3954),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3954),
    [sym_int] = ACTIONS(3954),
    [sym_xint] = ACTIONS(3952),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3952),
    [sym__newline] = ACTIONS(3952),
    [sym__dedent] = ACTIONS(3952),
  },
  [1939] = {
    [sym_block_comment] = STATE(1939),
    [sym_compiler_directive_decl] = STATE(1939),
    [sym_fsi_directive_decl] = STATE(1939),
    [sym_preproc_line] = STATE(1939),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_EQ] = ACTIONS(3948),
    [anon_sym_LBRACK_LT] = ACTIONS(3948),
    [anon_sym_COLON] = ACTIONS(3950),
    [anon_sym_return] = ACTIONS(3950),
    [anon_sym_do] = ACTIONS(3950),
    [anon_sym_and] = ACTIONS(3950),
    [anon_sym_let] = ACTIONS(3950),
    [anon_sym_let_BANG] = ACTIONS(3948),
    [aux_sym_access_modifier_token1] = ACTIONS(3948),
    [anon_sym_LPAREN] = ACTIONS(3950),
    [anon_sym_COMMA] = ACTIONS(3948),
    [anon_sym_null] = ACTIONS(3950),
    [anon_sym_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_COLON] = ACTIONS(3948),
    [anon_sym_AMP] = ACTIONS(3950),
    [anon_sym_LBRACK] = ACTIONS(3950),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3948),
    [anon_sym_LBRACE] = ACTIONS(3950),
    [anon_sym_LT_AT] = ACTIONS(3950),
    [anon_sym_LT_AT_AT] = ACTIONS(3950),
    [anon_sym_DOT] = ACTIONS(3950),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3948),
    [anon_sym_new] = ACTIONS(3950),
    [anon_sym_with] = ACTIONS(3950),
    [anon_sym_return_BANG] = ACTIONS(3948),
    [anon_sym_yield] = ACTIONS(3950),
    [anon_sym_yield_BANG] = ACTIONS(3948),
    [anon_sym_lazy] = ACTIONS(3950),
    [anon_sym_assert] = ACTIONS(3950),
    [anon_sym_upcast] = ACTIONS(3950),
    [anon_sym_downcast] = ACTIONS(3950),
    [anon_sym_COLON_GT] = ACTIONS(3948),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3948),
    [anon_sym_for] = ACTIONS(3950),
    [anon_sym_while] = ACTIONS(3950),
    [anon_sym_if] = ACTIONS(3950),
    [anon_sym_fun] = ACTIONS(3950),
    [anon_sym_try] = ACTIONS(3950),
    [anon_sym_match] = ACTIONS(3950),
    [anon_sym_match_BANG] = ACTIONS(3948),
    [anon_sym_function] = ACTIONS(3950),
    [anon_sym_LT_DASH] = ACTIONS(3950),
    [anon_sym_DOT_LBRACK] = ACTIONS(3948),
    [anon_sym_LT] = ACTIONS(3948),
    [anon_sym_use] = ACTIONS(3950),
    [anon_sym_use_BANG] = ACTIONS(3948),
    [anon_sym_do_BANG] = ACTIONS(3948),
    [anon_sym_begin] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3950),
    [anon_sym_default] = ACTIONS(3950),
    [anon_sym_or] = ACTIONS(3950),
    [anon_sym_static] = ACTIONS(3950),
    [anon_sym_member] = ACTIONS(3950),
    [anon_sym_interface] = ACTIONS(3950),
    [anon_sym_abstract] = ACTIONS(3950),
    [anon_sym_val] = ACTIONS(3950),
    [anon_sym_override] = ACTIONS(3950),
    [aux_sym_char_token1] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3950),
    [anon_sym_DQUOTE] = ACTIONS(3950),
    [anon_sym_AT_DQUOTE] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [sym_bool] = ACTIONS(3950),
    [sym_unit] = ACTIONS(3948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3950),
    [sym_op_identifier] = ACTIONS(3950),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_DASH] = ACTIONS(3950),
    [anon_sym_PLUS_DOT] = ACTIONS(3950),
    [anon_sym_DASH_DOT] = ACTIONS(3950),
    [anon_sym_PERCENT] = ACTIONS(3950),
    [anon_sym_AMP_AMP] = ACTIONS(3950),
    [anon_sym_TILDE] = ACTIONS(3948),
    [aux_sym_prefix_op_token1] = ACTIONS(3950),
    [aux_sym_infix_op_token1] = ACTIONS(3948),
    [aux_sym_infix_op_token2] = ACTIONS(3950),
    [anon_sym_PIPE_PIPE] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3950),
    [anon_sym_COLON_EQ] = ACTIONS(3948),
    [anon_sym_DOLLAR] = ACTIONS(3950),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3950),
    [sym_int] = ACTIONS(3950),
    [sym_xint] = ACTIONS(3948),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3948),
    [sym__newline] = ACTIONS(3948),
    [sym__dedent] = ACTIONS(3948),
  },
  [1940] = {
    [sym_block_comment] = STATE(1940),
    [sym_compiler_directive_decl] = STATE(1940),
    [sym_fsi_directive_decl] = STATE(1940),
    [sym_preproc_line] = STATE(1940),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_LBRACK_LT] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [aux_sym_access_modifier_token1] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4739),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_with] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_DOT_DOT2] = ACTIONS(4226),
    [anon_sym_default] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [anon_sym_static] = ACTIONS(4228),
    [anon_sym_member] = ACTIONS(4228),
    [anon_sym_interface] = ACTIONS(4228),
    [anon_sym_abstract] = ACTIONS(4228),
    [anon_sym_val] = ACTIONS(4228),
    [anon_sym_override] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
    [sym__dedent] = ACTIONS(4226),
  },
  [1941] = {
    [sym_block_comment] = STATE(1941),
    [sym_compiler_directive_decl] = STATE(1941),
    [sym_fsi_directive_decl] = STATE(1941),
    [sym_preproc_line] = STATE(1941),
    [sym_identifier] = ACTIONS(3935),
    [anon_sym_EQ] = ACTIONS(3933),
    [anon_sym_LBRACK_LT] = ACTIONS(3933),
    [anon_sym_COLON] = ACTIONS(3935),
    [anon_sym_return] = ACTIONS(3935),
    [anon_sym_do] = ACTIONS(3935),
    [anon_sym_and] = ACTIONS(3935),
    [anon_sym_let] = ACTIONS(3935),
    [anon_sym_let_BANG] = ACTIONS(3933),
    [aux_sym_access_modifier_token1] = ACTIONS(3933),
    [anon_sym_LPAREN] = ACTIONS(3935),
    [anon_sym_COMMA] = ACTIONS(3933),
    [anon_sym_null] = ACTIONS(3935),
    [anon_sym_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3935),
    [anon_sym_LBRACK] = ACTIONS(3935),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3933),
    [anon_sym_LBRACE] = ACTIONS(3935),
    [anon_sym_LT_AT] = ACTIONS(3935),
    [anon_sym_LT_AT_AT] = ACTIONS(3935),
    [anon_sym_DOT] = ACTIONS(3935),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3933),
    [anon_sym_new] = ACTIONS(3935),
    [anon_sym_with] = ACTIONS(3935),
    [anon_sym_return_BANG] = ACTIONS(3933),
    [anon_sym_yield] = ACTIONS(3935),
    [anon_sym_yield_BANG] = ACTIONS(3933),
    [anon_sym_lazy] = ACTIONS(3935),
    [anon_sym_assert] = ACTIONS(3935),
    [anon_sym_upcast] = ACTIONS(3935),
    [anon_sym_downcast] = ACTIONS(3935),
    [anon_sym_COLON_GT] = ACTIONS(3933),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3933),
    [anon_sym_for] = ACTIONS(3935),
    [anon_sym_while] = ACTIONS(3935),
    [anon_sym_if] = ACTIONS(3935),
    [anon_sym_fun] = ACTIONS(3935),
    [anon_sym_try] = ACTIONS(3935),
    [anon_sym_match] = ACTIONS(3935),
    [anon_sym_match_BANG] = ACTIONS(3933),
    [anon_sym_function] = ACTIONS(3935),
    [anon_sym_LT_DASH] = ACTIONS(3935),
    [anon_sym_DOT_LBRACK] = ACTIONS(3933),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_use] = ACTIONS(3935),
    [anon_sym_use_BANG] = ACTIONS(3933),
    [anon_sym_do_BANG] = ACTIONS(3933),
    [anon_sym_begin] = ACTIONS(3935),
    [anon_sym_LPAREN2] = ACTIONS(3935),
    [anon_sym_default] = ACTIONS(3935),
    [anon_sym_or] = ACTIONS(3935),
    [anon_sym_static] = ACTIONS(3935),
    [anon_sym_member] = ACTIONS(3935),
    [anon_sym_interface] = ACTIONS(3935),
    [anon_sym_abstract] = ACTIONS(3935),
    [anon_sym_val] = ACTIONS(3935),
    [anon_sym_override] = ACTIONS(3935),
    [aux_sym_char_token1] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3935),
    [anon_sym_DQUOTE] = ACTIONS(3935),
    [anon_sym_AT_DQUOTE] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [sym_bool] = ACTIONS(3935),
    [sym_unit] = ACTIONS(3933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3935),
    [sym_op_identifier] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(3935),
    [anon_sym_DASH] = ACTIONS(3935),
    [anon_sym_PLUS_DOT] = ACTIONS(3935),
    [anon_sym_DASH_DOT] = ACTIONS(3935),
    [anon_sym_PERCENT] = ACTIONS(3935),
    [anon_sym_AMP_AMP] = ACTIONS(3935),
    [anon_sym_TILDE] = ACTIONS(3933),
    [aux_sym_prefix_op_token1] = ACTIONS(3935),
    [aux_sym_infix_op_token1] = ACTIONS(3933),
    [aux_sym_infix_op_token2] = ACTIONS(3935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3935),
    [anon_sym_BANG_EQ] = ACTIONS(3935),
    [anon_sym_COLON_EQ] = ACTIONS(3933),
    [anon_sym_DOLLAR] = ACTIONS(3935),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3935),
    [sym_int] = ACTIONS(3935),
    [sym_xint] = ACTIONS(3933),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3933),
    [sym__newline] = ACTIONS(3933),
    [sym__dedent] = ACTIONS(3933),
  },
  [1942] = {
    [sym_block_comment] = STATE(1942),
    [sym_compiler_directive_decl] = STATE(1942),
    [sym_fsi_directive_decl] = STATE(1942),
    [sym_preproc_line] = STATE(1942),
    [sym_identifier] = ACTIONS(4208),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LBRACK_LT] = ACTIONS(4206),
    [anon_sym_COLON] = ACTIONS(4208),
    [anon_sym_return] = ACTIONS(4208),
    [anon_sym_do] = ACTIONS(4208),
    [anon_sym_let] = ACTIONS(4208),
    [anon_sym_let_BANG] = ACTIONS(4206),
    [aux_sym_access_modifier_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(4206),
    [anon_sym_null] = ACTIONS(4208),
    [anon_sym_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_COLON] = ACTIONS(4206),
    [anon_sym_AMP] = ACTIONS(4208),
    [anon_sym_LBRACK] = ACTIONS(4208),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4206),
    [anon_sym_LBRACE] = ACTIONS(4208),
    [anon_sym_LT_AT] = ACTIONS(4208),
    [anon_sym_LT_AT_AT] = ACTIONS(4208),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4206),
    [anon_sym_new] = ACTIONS(4208),
    [anon_sym_with] = ACTIONS(4208),
    [anon_sym_return_BANG] = ACTIONS(4206),
    [anon_sym_yield] = ACTIONS(4208),
    [anon_sym_yield_BANG] = ACTIONS(4206),
    [anon_sym_lazy] = ACTIONS(4208),
    [anon_sym_assert] = ACTIONS(4208),
    [anon_sym_upcast] = ACTIONS(4208),
    [anon_sym_downcast] = ACTIONS(4208),
    [anon_sym_COLON_GT] = ACTIONS(4206),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4206),
    [anon_sym_for] = ACTIONS(4208),
    [anon_sym_while] = ACTIONS(4208),
    [anon_sym_if] = ACTIONS(4208),
    [anon_sym_fun] = ACTIONS(4208),
    [anon_sym_try] = ACTIONS(4208),
    [anon_sym_match] = ACTIONS(4208),
    [anon_sym_match_BANG] = ACTIONS(4206),
    [anon_sym_function] = ACTIONS(4208),
    [anon_sym_LT_DASH] = ACTIONS(4208),
    [anon_sym_DOT_LBRACK] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(4206),
    [anon_sym_use] = ACTIONS(4208),
    [anon_sym_use_BANG] = ACTIONS(4206),
    [anon_sym_do_BANG] = ACTIONS(4206),
    [anon_sym_begin] = ACTIONS(4208),
    [anon_sym_LPAREN2] = ACTIONS(4208),
    [anon_sym_default] = ACTIONS(4208),
    [anon_sym_or] = ACTIONS(4208),
    [anon_sym_static] = ACTIONS(4208),
    [anon_sym_member] = ACTIONS(4208),
    [anon_sym_interface] = ACTIONS(4208),
    [anon_sym_abstract] = ACTIONS(4208),
    [anon_sym_val] = ACTIONS(4208),
    [anon_sym_override] = ACTIONS(4208),
    [anon_sym_inherit] = ACTIONS(4208),
    [aux_sym_char_token1] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4208),
    [anon_sym_DQUOTE] = ACTIONS(4208),
    [anon_sym_AT_DQUOTE] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [sym_bool] = ACTIONS(4208),
    [sym_unit] = ACTIONS(4206),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4208),
    [sym_op_identifier] = ACTIONS(4208),
    [anon_sym_PLUS] = ACTIONS(4208),
    [anon_sym_DASH] = ACTIONS(4208),
    [anon_sym_PLUS_DOT] = ACTIONS(4208),
    [anon_sym_DASH_DOT] = ACTIONS(4208),
    [anon_sym_PERCENT] = ACTIONS(4208),
    [anon_sym_AMP_AMP] = ACTIONS(4208),
    [anon_sym_TILDE] = ACTIONS(4206),
    [aux_sym_prefix_op_token1] = ACTIONS(4208),
    [aux_sym_infix_op_token1] = ACTIONS(4206),
    [aux_sym_infix_op_token2] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(4208),
    [anon_sym_BANG_EQ] = ACTIONS(4208),
    [anon_sym_COLON_EQ] = ACTIONS(4206),
    [anon_sym_DOLLAR] = ACTIONS(4208),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4208),
    [sym_int] = ACTIONS(4208),
    [sym_xint] = ACTIONS(4206),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4206),
    [anon_sym_POUNDendif] = ACTIONS(4206),
    [sym__newline] = ACTIONS(4206),
  },
  [1943] = {
    [sym_block_comment] = STATE(1943),
    [sym_compiler_directive_decl] = STATE(1943),
    [sym_fsi_directive_decl] = STATE(1943),
    [sym_preproc_line] = STATE(1943),
    [sym_identifier] = ACTIONS(3885),
    [anon_sym_EQ] = ACTIONS(3883),
    [anon_sym_LBRACK_LT] = ACTIONS(3883),
    [anon_sym_COLON] = ACTIONS(3885),
    [anon_sym_return] = ACTIONS(3885),
    [anon_sym_do] = ACTIONS(3885),
    [anon_sym_and] = ACTIONS(3885),
    [anon_sym_let] = ACTIONS(3885),
    [anon_sym_let_BANG] = ACTIONS(3883),
    [aux_sym_access_modifier_token1] = ACTIONS(3883),
    [anon_sym_LPAREN] = ACTIONS(3885),
    [anon_sym_COMMA] = ACTIONS(3883),
    [anon_sym_null] = ACTIONS(3885),
    [anon_sym_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3883),
    [anon_sym_AMP] = ACTIONS(3885),
    [anon_sym_LBRACK] = ACTIONS(3885),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3883),
    [anon_sym_LBRACE] = ACTIONS(3885),
    [anon_sym_LT_AT] = ACTIONS(3885),
    [anon_sym_LT_AT_AT] = ACTIONS(3885),
    [anon_sym_DOT] = ACTIONS(3885),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3883),
    [anon_sym_new] = ACTIONS(3885),
    [anon_sym_with] = ACTIONS(3885),
    [anon_sym_return_BANG] = ACTIONS(3883),
    [anon_sym_yield] = ACTIONS(3885),
    [anon_sym_yield_BANG] = ACTIONS(3883),
    [anon_sym_lazy] = ACTIONS(3885),
    [anon_sym_assert] = ACTIONS(3885),
    [anon_sym_upcast] = ACTIONS(3885),
    [anon_sym_downcast] = ACTIONS(3885),
    [anon_sym_COLON_GT] = ACTIONS(3883),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3883),
    [anon_sym_for] = ACTIONS(3885),
    [anon_sym_while] = ACTIONS(3885),
    [anon_sym_if] = ACTIONS(3885),
    [anon_sym_fun] = ACTIONS(3885),
    [anon_sym_try] = ACTIONS(3885),
    [anon_sym_match] = ACTIONS(3885),
    [anon_sym_match_BANG] = ACTIONS(3883),
    [anon_sym_function] = ACTIONS(3885),
    [anon_sym_LT_DASH] = ACTIONS(3885),
    [anon_sym_DOT_LBRACK] = ACTIONS(3883),
    [anon_sym_LT] = ACTIONS(3883),
    [anon_sym_use] = ACTIONS(3885),
    [anon_sym_use_BANG] = ACTIONS(3883),
    [anon_sym_do_BANG] = ACTIONS(3883),
    [anon_sym_begin] = ACTIONS(3885),
    [anon_sym_LPAREN2] = ACTIONS(3885),
    [anon_sym_default] = ACTIONS(3885),
    [anon_sym_or] = ACTIONS(3885),
    [anon_sym_static] = ACTIONS(3885),
    [anon_sym_member] = ACTIONS(3885),
    [anon_sym_interface] = ACTIONS(3885),
    [anon_sym_abstract] = ACTIONS(3885),
    [anon_sym_val] = ACTIONS(3885),
    [anon_sym_override] = ACTIONS(3885),
    [aux_sym_char_token1] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3885),
    [anon_sym_DQUOTE] = ACTIONS(3885),
    [anon_sym_AT_DQUOTE] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [sym_bool] = ACTIONS(3885),
    [sym_unit] = ACTIONS(3883),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3885),
    [sym_op_identifier] = ACTIONS(3885),
    [anon_sym_PLUS] = ACTIONS(3885),
    [anon_sym_DASH] = ACTIONS(3885),
    [anon_sym_PLUS_DOT] = ACTIONS(3885),
    [anon_sym_DASH_DOT] = ACTIONS(3885),
    [anon_sym_PERCENT] = ACTIONS(3885),
    [anon_sym_AMP_AMP] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3883),
    [aux_sym_prefix_op_token1] = ACTIONS(3885),
    [aux_sym_infix_op_token1] = ACTIONS(3883),
    [aux_sym_infix_op_token2] = ACTIONS(3885),
    [anon_sym_PIPE_PIPE] = ACTIONS(3885),
    [anon_sym_BANG_EQ] = ACTIONS(3885),
    [anon_sym_COLON_EQ] = ACTIONS(3883),
    [anon_sym_DOLLAR] = ACTIONS(3885),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3885),
    [sym_int] = ACTIONS(3885),
    [sym_xint] = ACTIONS(3883),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3883),
    [sym__newline] = ACTIONS(3883),
    [sym__dedent] = ACTIONS(3883),
  },
  [1944] = {
    [sym_block_comment] = STATE(1944),
    [sym_compiler_directive_decl] = STATE(1944),
    [sym_fsi_directive_decl] = STATE(1944),
    [sym_preproc_line] = STATE(1944),
    [sym_identifier] = ACTIONS(3881),
    [anon_sym_EQ] = ACTIONS(3879),
    [anon_sym_LBRACK_LT] = ACTIONS(3879),
    [anon_sym_COLON] = ACTIONS(3881),
    [anon_sym_return] = ACTIONS(3881),
    [anon_sym_do] = ACTIONS(3881),
    [anon_sym_and] = ACTIONS(3881),
    [anon_sym_let] = ACTIONS(3881),
    [anon_sym_let_BANG] = ACTIONS(3879),
    [aux_sym_access_modifier_token1] = ACTIONS(3879),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3879),
    [anon_sym_null] = ACTIONS(3881),
    [anon_sym_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3879),
    [anon_sym_LBRACE] = ACTIONS(3881),
    [anon_sym_LT_AT] = ACTIONS(3881),
    [anon_sym_LT_AT_AT] = ACTIONS(3881),
    [anon_sym_DOT] = ACTIONS(3881),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3879),
    [anon_sym_new] = ACTIONS(3881),
    [anon_sym_with] = ACTIONS(3881),
    [anon_sym_return_BANG] = ACTIONS(3879),
    [anon_sym_yield] = ACTIONS(3881),
    [anon_sym_yield_BANG] = ACTIONS(3879),
    [anon_sym_lazy] = ACTIONS(3881),
    [anon_sym_assert] = ACTIONS(3881),
    [anon_sym_upcast] = ACTIONS(3881),
    [anon_sym_downcast] = ACTIONS(3881),
    [anon_sym_COLON_GT] = ACTIONS(3879),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3879),
    [anon_sym_for] = ACTIONS(3881),
    [anon_sym_while] = ACTIONS(3881),
    [anon_sym_if] = ACTIONS(3881),
    [anon_sym_fun] = ACTIONS(3881),
    [anon_sym_try] = ACTIONS(3881),
    [anon_sym_match] = ACTIONS(3881),
    [anon_sym_match_BANG] = ACTIONS(3879),
    [anon_sym_function] = ACTIONS(3881),
    [anon_sym_LT_DASH] = ACTIONS(3881),
    [anon_sym_DOT_LBRACK] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_use] = ACTIONS(3881),
    [anon_sym_use_BANG] = ACTIONS(3879),
    [anon_sym_do_BANG] = ACTIONS(3879),
    [anon_sym_begin] = ACTIONS(3881),
    [anon_sym_LPAREN2] = ACTIONS(3881),
    [anon_sym_default] = ACTIONS(3881),
    [anon_sym_or] = ACTIONS(3881),
    [anon_sym_static] = ACTIONS(3881),
    [anon_sym_member] = ACTIONS(3881),
    [anon_sym_interface] = ACTIONS(3881),
    [anon_sym_abstract] = ACTIONS(3881),
    [anon_sym_val] = ACTIONS(3881),
    [anon_sym_override] = ACTIONS(3881),
    [aux_sym_char_token1] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3881),
    [anon_sym_DQUOTE] = ACTIONS(3881),
    [anon_sym_AT_DQUOTE] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [sym_bool] = ACTIONS(3881),
    [sym_unit] = ACTIONS(3879),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3881),
    [sym_op_identifier] = ACTIONS(3881),
    [anon_sym_PLUS] = ACTIONS(3881),
    [anon_sym_DASH] = ACTIONS(3881),
    [anon_sym_PLUS_DOT] = ACTIONS(3881),
    [anon_sym_DASH_DOT] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(3881),
    [anon_sym_AMP_AMP] = ACTIONS(3881),
    [anon_sym_TILDE] = ACTIONS(3879),
    [aux_sym_prefix_op_token1] = ACTIONS(3881),
    [aux_sym_infix_op_token1] = ACTIONS(3879),
    [aux_sym_infix_op_token2] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE] = ACTIONS(3881),
    [anon_sym_BANG_EQ] = ACTIONS(3881),
    [anon_sym_COLON_EQ] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3881),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3881),
    [sym_int] = ACTIONS(3881),
    [sym_xint] = ACTIONS(3879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3879),
    [sym__newline] = ACTIONS(3879),
    [sym__dedent] = ACTIONS(3879),
  },
  [1945] = {
    [sym_block_comment] = STATE(1945),
    [sym_compiler_directive_decl] = STATE(1945),
    [sym_fsi_directive_decl] = STATE(1945),
    [sym_preproc_line] = STATE(1945),
    [sym_identifier] = ACTIONS(4130),
    [anon_sym_EQ] = ACTIONS(4128),
    [anon_sym_LBRACK_LT] = ACTIONS(4128),
    [anon_sym_COLON] = ACTIONS(4130),
    [anon_sym_return] = ACTIONS(4130),
    [anon_sym_do] = ACTIONS(4130),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_let] = ACTIONS(4130),
    [anon_sym_let_BANG] = ACTIONS(4128),
    [aux_sym_access_modifier_token1] = ACTIONS(4128),
    [anon_sym_LPAREN] = ACTIONS(4130),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_null] = ACTIONS(4130),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_COLON] = ACTIONS(4128),
    [anon_sym_AMP] = ACTIONS(4130),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4128),
    [anon_sym_LBRACE] = ACTIONS(4130),
    [anon_sym_LT_AT] = ACTIONS(4130),
    [anon_sym_LT_AT_AT] = ACTIONS(4130),
    [anon_sym_DOT] = ACTIONS(4130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4128),
    [anon_sym_new] = ACTIONS(4130),
    [anon_sym_with] = ACTIONS(4130),
    [anon_sym_return_BANG] = ACTIONS(4128),
    [anon_sym_yield] = ACTIONS(4130),
    [anon_sym_yield_BANG] = ACTIONS(4128),
    [anon_sym_lazy] = ACTIONS(4130),
    [anon_sym_assert] = ACTIONS(4130),
    [anon_sym_upcast] = ACTIONS(4130),
    [anon_sym_downcast] = ACTIONS(4130),
    [anon_sym_COLON_GT] = ACTIONS(4128),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4128),
    [anon_sym_for] = ACTIONS(4130),
    [anon_sym_while] = ACTIONS(4130),
    [anon_sym_if] = ACTIONS(4130),
    [anon_sym_fun] = ACTIONS(4130),
    [anon_sym_try] = ACTIONS(4130),
    [anon_sym_match] = ACTIONS(4130),
    [anon_sym_match_BANG] = ACTIONS(4128),
    [anon_sym_function] = ACTIONS(4130),
    [anon_sym_LT_DASH] = ACTIONS(4130),
    [anon_sym_DOT_LBRACK] = ACTIONS(4128),
    [anon_sym_LT] = ACTIONS(4128),
    [anon_sym_use] = ACTIONS(4130),
    [anon_sym_use_BANG] = ACTIONS(4128),
    [anon_sym_do_BANG] = ACTIONS(4128),
    [anon_sym_begin] = ACTIONS(4130),
    [anon_sym_LPAREN2] = ACTIONS(4130),
    [anon_sym_default] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_static] = ACTIONS(4130),
    [anon_sym_member] = ACTIONS(4130),
    [anon_sym_interface] = ACTIONS(4130),
    [anon_sym_abstract] = ACTIONS(4130),
    [anon_sym_val] = ACTIONS(4130),
    [anon_sym_override] = ACTIONS(4130),
    [aux_sym_char_token1] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4130),
    [anon_sym_DQUOTE] = ACTIONS(4130),
    [anon_sym_AT_DQUOTE] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [sym_bool] = ACTIONS(4130),
    [sym_unit] = ACTIONS(4128),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4130),
    [sym_op_identifier] = ACTIONS(4130),
    [anon_sym_PLUS] = ACTIONS(4130),
    [anon_sym_DASH] = ACTIONS(4130),
    [anon_sym_PLUS_DOT] = ACTIONS(4130),
    [anon_sym_DASH_DOT] = ACTIONS(4130),
    [anon_sym_PERCENT] = ACTIONS(4130),
    [anon_sym_AMP_AMP] = ACTIONS(4130),
    [anon_sym_TILDE] = ACTIONS(4128),
    [aux_sym_prefix_op_token1] = ACTIONS(4130),
    [aux_sym_infix_op_token1] = ACTIONS(4128),
    [aux_sym_infix_op_token2] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE] = ACTIONS(4130),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_COLON_EQ] = ACTIONS(4128),
    [anon_sym_DOLLAR] = ACTIONS(4130),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4130),
    [sym_int] = ACTIONS(4130),
    [sym_xint] = ACTIONS(4128),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4128),
    [sym__newline] = ACTIONS(4128),
    [sym__dedent] = ACTIONS(4128),
  },
  [1946] = {
    [sym_block_comment] = STATE(1946),
    [sym_compiler_directive_decl] = STATE(1946),
    [sym_fsi_directive_decl] = STATE(1946),
    [sym_preproc_line] = STATE(1946),
    [sym_identifier] = ACTIONS(3856),
    [anon_sym_EQ] = ACTIONS(3854),
    [anon_sym_LBRACK_LT] = ACTIONS(3854),
    [anon_sym_COLON] = ACTIONS(3856),
    [anon_sym_return] = ACTIONS(3856),
    [anon_sym_do] = ACTIONS(3856),
    [anon_sym_and] = ACTIONS(3856),
    [anon_sym_let] = ACTIONS(3856),
    [anon_sym_let_BANG] = ACTIONS(3854),
    [aux_sym_access_modifier_token1] = ACTIONS(3854),
    [anon_sym_LPAREN] = ACTIONS(3856),
    [anon_sym_COMMA] = ACTIONS(3854),
    [anon_sym_null] = ACTIONS(3856),
    [anon_sym_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_AMP] = ACTIONS(3856),
    [anon_sym_LBRACK] = ACTIONS(3856),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3854),
    [anon_sym_LBRACE] = ACTIONS(3856),
    [anon_sym_LT_AT] = ACTIONS(3856),
    [anon_sym_LT_AT_AT] = ACTIONS(3856),
    [anon_sym_DOT] = ACTIONS(3856),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3854),
    [anon_sym_new] = ACTIONS(3856),
    [anon_sym_with] = ACTIONS(3856),
    [anon_sym_return_BANG] = ACTIONS(3854),
    [anon_sym_yield] = ACTIONS(3856),
    [anon_sym_yield_BANG] = ACTIONS(3854),
    [anon_sym_lazy] = ACTIONS(3856),
    [anon_sym_assert] = ACTIONS(3856),
    [anon_sym_upcast] = ACTIONS(3856),
    [anon_sym_downcast] = ACTIONS(3856),
    [anon_sym_COLON_GT] = ACTIONS(3854),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3854),
    [anon_sym_for] = ACTIONS(3856),
    [anon_sym_while] = ACTIONS(3856),
    [anon_sym_if] = ACTIONS(3856),
    [anon_sym_fun] = ACTIONS(3856),
    [anon_sym_try] = ACTIONS(3856),
    [anon_sym_match] = ACTIONS(3856),
    [anon_sym_match_BANG] = ACTIONS(3854),
    [anon_sym_function] = ACTIONS(3856),
    [anon_sym_LT_DASH] = ACTIONS(3856),
    [anon_sym_DOT_LBRACK] = ACTIONS(3854),
    [anon_sym_LT] = ACTIONS(3854),
    [anon_sym_use] = ACTIONS(3856),
    [anon_sym_use_BANG] = ACTIONS(3854),
    [anon_sym_do_BANG] = ACTIONS(3854),
    [anon_sym_begin] = ACTIONS(3856),
    [anon_sym_LPAREN2] = ACTIONS(3856),
    [anon_sym_default] = ACTIONS(3856),
    [anon_sym_or] = ACTIONS(3856),
    [anon_sym_static] = ACTIONS(3856),
    [anon_sym_member] = ACTIONS(3856),
    [anon_sym_interface] = ACTIONS(3856),
    [anon_sym_abstract] = ACTIONS(3856),
    [anon_sym_val] = ACTIONS(3856),
    [anon_sym_override] = ACTIONS(3856),
    [aux_sym_char_token1] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3856),
    [anon_sym_DQUOTE] = ACTIONS(3856),
    [anon_sym_AT_DQUOTE] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [sym_bool] = ACTIONS(3856),
    [sym_unit] = ACTIONS(3854),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3856),
    [sym_op_identifier] = ACTIONS(3856),
    [anon_sym_PLUS] = ACTIONS(3856),
    [anon_sym_DASH] = ACTIONS(3856),
    [anon_sym_PLUS_DOT] = ACTIONS(3856),
    [anon_sym_DASH_DOT] = ACTIONS(3856),
    [anon_sym_PERCENT] = ACTIONS(3856),
    [anon_sym_AMP_AMP] = ACTIONS(3856),
    [anon_sym_TILDE] = ACTIONS(3854),
    [aux_sym_prefix_op_token1] = ACTIONS(3856),
    [aux_sym_infix_op_token1] = ACTIONS(3854),
    [aux_sym_infix_op_token2] = ACTIONS(3856),
    [anon_sym_PIPE_PIPE] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3856),
    [anon_sym_COLON_EQ] = ACTIONS(3854),
    [anon_sym_DOLLAR] = ACTIONS(3856),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3856),
    [sym_int] = ACTIONS(3856),
    [sym_xint] = ACTIONS(3854),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3854),
    [anon_sym_POUNDendif] = ACTIONS(3854),
    [sym__newline] = ACTIONS(3854),
  },
  [1947] = {
    [sym_block_comment] = STATE(1947),
    [sym_compiler_directive_decl] = STATE(1947),
    [sym_fsi_directive_decl] = STATE(1947),
    [sym_preproc_line] = STATE(1947),
    [sym_identifier] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3919),
    [anon_sym_LBRACK_LT] = ACTIONS(3919),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_return] = ACTIONS(3921),
    [anon_sym_do] = ACTIONS(3921),
    [anon_sym_and] = ACTIONS(3921),
    [anon_sym_let] = ACTIONS(3921),
    [anon_sym_let_BANG] = ACTIONS(3919),
    [aux_sym_access_modifier_token1] = ACTIONS(3919),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3919),
    [anon_sym_null] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_COLON] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3919),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_LT_AT] = ACTIONS(3921),
    [anon_sym_LT_AT_AT] = ACTIONS(3921),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3919),
    [anon_sym_new] = ACTIONS(3921),
    [anon_sym_with] = ACTIONS(3921),
    [anon_sym_return_BANG] = ACTIONS(3919),
    [anon_sym_yield] = ACTIONS(3921),
    [anon_sym_yield_BANG] = ACTIONS(3919),
    [anon_sym_lazy] = ACTIONS(3921),
    [anon_sym_assert] = ACTIONS(3921),
    [anon_sym_upcast] = ACTIONS(3921),
    [anon_sym_downcast] = ACTIONS(3921),
    [anon_sym_COLON_GT] = ACTIONS(3919),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3919),
    [anon_sym_for] = ACTIONS(3921),
    [anon_sym_while] = ACTIONS(3921),
    [anon_sym_if] = ACTIONS(3921),
    [anon_sym_fun] = ACTIONS(3921),
    [anon_sym_try] = ACTIONS(3921),
    [anon_sym_match] = ACTIONS(3921),
    [anon_sym_match_BANG] = ACTIONS(3919),
    [anon_sym_function] = ACTIONS(3921),
    [anon_sym_LT_DASH] = ACTIONS(3921),
    [anon_sym_DOT_LBRACK] = ACTIONS(3919),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_use] = ACTIONS(3921),
    [anon_sym_use_BANG] = ACTIONS(3919),
    [anon_sym_do_BANG] = ACTIONS(3919),
    [anon_sym_begin] = ACTIONS(3921),
    [anon_sym_LPAREN2] = ACTIONS(3921),
    [anon_sym_default] = ACTIONS(3921),
    [anon_sym_or] = ACTIONS(3921),
    [anon_sym_static] = ACTIONS(3921),
    [anon_sym_member] = ACTIONS(3921),
    [anon_sym_interface] = ACTIONS(3921),
    [anon_sym_abstract] = ACTIONS(3921),
    [anon_sym_val] = ACTIONS(3921),
    [anon_sym_override] = ACTIONS(3921),
    [aux_sym_char_token1] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_AT_DQUOTE] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [sym_bool] = ACTIONS(3921),
    [sym_unit] = ACTIONS(3919),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3921),
    [sym_op_identifier] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_DOT] = ACTIONS(3921),
    [anon_sym_DASH_DOT] = ACTIONS(3921),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3919),
    [aux_sym_prefix_op_token1] = ACTIONS(3921),
    [aux_sym_infix_op_token1] = ACTIONS(3919),
    [aux_sym_infix_op_token2] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_COLON_EQ] = ACTIONS(3919),
    [anon_sym_DOLLAR] = ACTIONS(3921),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3921),
    [sym_int] = ACTIONS(3921),
    [sym_xint] = ACTIONS(3919),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3919),
    [sym__newline] = ACTIONS(3919),
    [sym__dedent] = ACTIONS(3919),
  },
  [1948] = {
    [sym_block_comment] = STATE(1948),
    [sym_compiler_directive_decl] = STATE(1948),
    [sym_fsi_directive_decl] = STATE(1948),
    [sym_preproc_line] = STATE(1948),
    [sym_identifier] = ACTIONS(4212),
    [anon_sym_EQ] = ACTIONS(4210),
    [anon_sym_LBRACK_LT] = ACTIONS(4210),
    [anon_sym_COLON] = ACTIONS(4212),
    [anon_sym_return] = ACTIONS(4212),
    [anon_sym_do] = ACTIONS(4212),
    [anon_sym_let] = ACTIONS(4212),
    [anon_sym_let_BANG] = ACTIONS(4210),
    [aux_sym_access_modifier_token1] = ACTIONS(4210),
    [anon_sym_LPAREN] = ACTIONS(4212),
    [anon_sym_COMMA] = ACTIONS(4210),
    [anon_sym_null] = ACTIONS(4212),
    [anon_sym_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_COLON] = ACTIONS(4210),
    [anon_sym_AMP] = ACTIONS(4212),
    [anon_sym_LBRACK] = ACTIONS(4212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4210),
    [anon_sym_LBRACE] = ACTIONS(4212),
    [anon_sym_LT_AT] = ACTIONS(4212),
    [anon_sym_LT_AT_AT] = ACTIONS(4212),
    [anon_sym_DOT] = ACTIONS(4212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4210),
    [anon_sym_new] = ACTIONS(4212),
    [anon_sym_with] = ACTIONS(4212),
    [anon_sym_return_BANG] = ACTIONS(4210),
    [anon_sym_yield] = ACTIONS(4212),
    [anon_sym_yield_BANG] = ACTIONS(4210),
    [anon_sym_lazy] = ACTIONS(4212),
    [anon_sym_assert] = ACTIONS(4212),
    [anon_sym_upcast] = ACTIONS(4212),
    [anon_sym_downcast] = ACTIONS(4212),
    [anon_sym_COLON_GT] = ACTIONS(4210),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4210),
    [anon_sym_for] = ACTIONS(4212),
    [anon_sym_while] = ACTIONS(4212),
    [anon_sym_if] = ACTIONS(4212),
    [anon_sym_fun] = ACTIONS(4212),
    [anon_sym_try] = ACTIONS(4212),
    [anon_sym_match] = ACTIONS(4212),
    [anon_sym_match_BANG] = ACTIONS(4210),
    [anon_sym_function] = ACTIONS(4212),
    [anon_sym_LT_DASH] = ACTIONS(4212),
    [anon_sym_DOT_LBRACK] = ACTIONS(4210),
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_use] = ACTIONS(4212),
    [anon_sym_use_BANG] = ACTIONS(4210),
    [anon_sym_do_BANG] = ACTIONS(4210),
    [anon_sym_begin] = ACTIONS(4212),
    [anon_sym_LPAREN2] = ACTIONS(4212),
    [anon_sym_default] = ACTIONS(4212),
    [anon_sym_or] = ACTIONS(4212),
    [anon_sym_static] = ACTIONS(4212),
    [anon_sym_member] = ACTIONS(4212),
    [anon_sym_interface] = ACTIONS(4212),
    [anon_sym_abstract] = ACTIONS(4212),
    [anon_sym_val] = ACTIONS(4212),
    [anon_sym_override] = ACTIONS(4212),
    [anon_sym_inherit] = ACTIONS(4212),
    [aux_sym_char_token1] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4212),
    [anon_sym_DQUOTE] = ACTIONS(4212),
    [anon_sym_AT_DQUOTE] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [sym_bool] = ACTIONS(4212),
    [sym_unit] = ACTIONS(4210),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4212),
    [anon_sym_DASH] = ACTIONS(4212),
    [anon_sym_PLUS_DOT] = ACTIONS(4212),
    [anon_sym_DASH_DOT] = ACTIONS(4212),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_AMP_AMP] = ACTIONS(4212),
    [anon_sym_TILDE] = ACTIONS(4210),
    [aux_sym_prefix_op_token1] = ACTIONS(4212),
    [aux_sym_infix_op_token1] = ACTIONS(4210),
    [aux_sym_infix_op_token2] = ACTIONS(4212),
    [anon_sym_PIPE_PIPE] = ACTIONS(4212),
    [anon_sym_BANG_EQ] = ACTIONS(4212),
    [anon_sym_COLON_EQ] = ACTIONS(4210),
    [anon_sym_DOLLAR] = ACTIONS(4212),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4212),
    [sym_int] = ACTIONS(4212),
    [sym_xint] = ACTIONS(4210),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4210),
    [anon_sym_POUNDendif] = ACTIONS(4210),
    [sym__newline] = ACTIONS(4210),
  },
  [1949] = {
    [sym_block_comment] = STATE(1949),
    [sym_compiler_directive_decl] = STATE(1949),
    [sym_fsi_directive_decl] = STATE(1949),
    [sym_preproc_line] = STATE(1949),
    [sym_identifier] = ACTIONS(4224),
    [anon_sym_EQ] = ACTIONS(4222),
    [anon_sym_LBRACK_LT] = ACTIONS(4222),
    [anon_sym_COLON] = ACTIONS(4224),
    [anon_sym_return] = ACTIONS(4224),
    [anon_sym_do] = ACTIONS(4224),
    [anon_sym_let] = ACTIONS(4224),
    [anon_sym_let_BANG] = ACTIONS(4222),
    [aux_sym_access_modifier_token1] = ACTIONS(4222),
    [anon_sym_LPAREN] = ACTIONS(4224),
    [anon_sym_COMMA] = ACTIONS(4222),
    [anon_sym_null] = ACTIONS(4224),
    [anon_sym_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_COLON] = ACTIONS(4222),
    [anon_sym_AMP] = ACTIONS(4224),
    [anon_sym_LBRACK] = ACTIONS(4224),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4222),
    [anon_sym_LBRACE] = ACTIONS(4224),
    [anon_sym_LT_AT] = ACTIONS(4224),
    [anon_sym_LT_AT_AT] = ACTIONS(4224),
    [anon_sym_DOT] = ACTIONS(4224),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4222),
    [anon_sym_new] = ACTIONS(4224),
    [anon_sym_with] = ACTIONS(4224),
    [anon_sym_return_BANG] = ACTIONS(4222),
    [anon_sym_yield] = ACTIONS(4224),
    [anon_sym_yield_BANG] = ACTIONS(4222),
    [anon_sym_lazy] = ACTIONS(4224),
    [anon_sym_assert] = ACTIONS(4224),
    [anon_sym_upcast] = ACTIONS(4224),
    [anon_sym_downcast] = ACTIONS(4224),
    [anon_sym_COLON_GT] = ACTIONS(4222),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4222),
    [anon_sym_for] = ACTIONS(4224),
    [anon_sym_while] = ACTIONS(4224),
    [anon_sym_if] = ACTIONS(4224),
    [anon_sym_fun] = ACTIONS(4224),
    [anon_sym_try] = ACTIONS(4224),
    [anon_sym_match] = ACTIONS(4224),
    [anon_sym_match_BANG] = ACTIONS(4222),
    [anon_sym_function] = ACTIONS(4224),
    [anon_sym_LT_DASH] = ACTIONS(4224),
    [anon_sym_DOT_LBRACK] = ACTIONS(4222),
    [anon_sym_LT] = ACTIONS(4222),
    [anon_sym_use] = ACTIONS(4224),
    [anon_sym_use_BANG] = ACTIONS(4222),
    [anon_sym_do_BANG] = ACTIONS(4222),
    [anon_sym_begin] = ACTIONS(4224),
    [anon_sym_LPAREN2] = ACTIONS(4224),
    [anon_sym_default] = ACTIONS(4224),
    [anon_sym_or] = ACTIONS(4224),
    [anon_sym_static] = ACTIONS(4224),
    [anon_sym_member] = ACTIONS(4224),
    [anon_sym_interface] = ACTIONS(4224),
    [anon_sym_abstract] = ACTIONS(4224),
    [anon_sym_val] = ACTIONS(4224),
    [anon_sym_override] = ACTIONS(4224),
    [anon_sym_inherit] = ACTIONS(4224),
    [aux_sym_char_token1] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4224),
    [anon_sym_DQUOTE] = ACTIONS(4224),
    [anon_sym_AT_DQUOTE] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [sym_bool] = ACTIONS(4224),
    [sym_unit] = ACTIONS(4222),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4224),
    [sym_op_identifier] = ACTIONS(4224),
    [anon_sym_PLUS] = ACTIONS(4224),
    [anon_sym_DASH] = ACTIONS(4224),
    [anon_sym_PLUS_DOT] = ACTIONS(4224),
    [anon_sym_DASH_DOT] = ACTIONS(4224),
    [anon_sym_PERCENT] = ACTIONS(4224),
    [anon_sym_AMP_AMP] = ACTIONS(4224),
    [anon_sym_TILDE] = ACTIONS(4222),
    [aux_sym_prefix_op_token1] = ACTIONS(4224),
    [aux_sym_infix_op_token1] = ACTIONS(4222),
    [aux_sym_infix_op_token2] = ACTIONS(4224),
    [anon_sym_PIPE_PIPE] = ACTIONS(4224),
    [anon_sym_BANG_EQ] = ACTIONS(4224),
    [anon_sym_COLON_EQ] = ACTIONS(4222),
    [anon_sym_DOLLAR] = ACTIONS(4224),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4224),
    [sym_int] = ACTIONS(4224),
    [sym_xint] = ACTIONS(4222),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4222),
    [anon_sym_POUNDendif] = ACTIONS(4222),
    [sym__newline] = ACTIONS(4222),
  },
  [1950] = {
    [sym_block_comment] = STATE(1950),
    [sym_compiler_directive_decl] = STATE(1950),
    [sym_fsi_directive_decl] = STATE(1950),
    [sym_preproc_line] = STATE(1950),
    [sym_identifier] = ACTIONS(4007),
    [anon_sym_EQ] = ACTIONS(4005),
    [anon_sym_LBRACK_LT] = ACTIONS(4005),
    [anon_sym_COLON] = ACTIONS(4007),
    [anon_sym_return] = ACTIONS(4007),
    [anon_sym_do] = ACTIONS(4007),
    [anon_sym_and] = ACTIONS(4007),
    [anon_sym_let] = ACTIONS(4007),
    [anon_sym_let_BANG] = ACTIONS(4005),
    [aux_sym_access_modifier_token1] = ACTIONS(4005),
    [anon_sym_LPAREN] = ACTIONS(4007),
    [anon_sym_COMMA] = ACTIONS(4005),
    [anon_sym_null] = ACTIONS(4007),
    [anon_sym_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_COLON] = ACTIONS(4005),
    [anon_sym_AMP] = ACTIONS(4007),
    [anon_sym_LBRACK] = ACTIONS(4007),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4005),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_LT_AT] = ACTIONS(4007),
    [anon_sym_LT_AT_AT] = ACTIONS(4007),
    [anon_sym_DOT] = ACTIONS(4007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4005),
    [anon_sym_new] = ACTIONS(4007),
    [anon_sym_with] = ACTIONS(4007),
    [anon_sym_return_BANG] = ACTIONS(4005),
    [anon_sym_yield] = ACTIONS(4007),
    [anon_sym_yield_BANG] = ACTIONS(4005),
    [anon_sym_lazy] = ACTIONS(4007),
    [anon_sym_assert] = ACTIONS(4007),
    [anon_sym_upcast] = ACTIONS(4007),
    [anon_sym_downcast] = ACTIONS(4007),
    [anon_sym_COLON_GT] = ACTIONS(4005),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4005),
    [anon_sym_for] = ACTIONS(4007),
    [anon_sym_while] = ACTIONS(4007),
    [anon_sym_if] = ACTIONS(4007),
    [anon_sym_fun] = ACTIONS(4007),
    [anon_sym_try] = ACTIONS(4007),
    [anon_sym_match] = ACTIONS(4007),
    [anon_sym_match_BANG] = ACTIONS(4005),
    [anon_sym_function] = ACTIONS(4007),
    [anon_sym_LT_DASH] = ACTIONS(4007),
    [anon_sym_DOT_LBRACK] = ACTIONS(4005),
    [anon_sym_LT] = ACTIONS(4005),
    [anon_sym_use] = ACTIONS(4007),
    [anon_sym_use_BANG] = ACTIONS(4005),
    [anon_sym_do_BANG] = ACTIONS(4005),
    [anon_sym_begin] = ACTIONS(4007),
    [anon_sym_LPAREN2] = ACTIONS(4007),
    [anon_sym_default] = ACTIONS(4007),
    [anon_sym_or] = ACTIONS(4007),
    [anon_sym_static] = ACTIONS(4007),
    [anon_sym_member] = ACTIONS(4007),
    [anon_sym_interface] = ACTIONS(4007),
    [anon_sym_abstract] = ACTIONS(4007),
    [anon_sym_val] = ACTIONS(4007),
    [anon_sym_override] = ACTIONS(4007),
    [aux_sym_char_token1] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4007),
    [anon_sym_DQUOTE] = ACTIONS(4007),
    [anon_sym_AT_DQUOTE] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [sym_bool] = ACTIONS(4007),
    [sym_unit] = ACTIONS(4005),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4007),
    [sym_op_identifier] = ACTIONS(4007),
    [anon_sym_PLUS] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4007),
    [anon_sym_PLUS_DOT] = ACTIONS(4007),
    [anon_sym_DASH_DOT] = ACTIONS(4007),
    [anon_sym_PERCENT] = ACTIONS(4007),
    [anon_sym_AMP_AMP] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4005),
    [aux_sym_prefix_op_token1] = ACTIONS(4007),
    [aux_sym_infix_op_token1] = ACTIONS(4005),
    [aux_sym_infix_op_token2] = ACTIONS(4007),
    [anon_sym_PIPE_PIPE] = ACTIONS(4007),
    [anon_sym_BANG_EQ] = ACTIONS(4007),
    [anon_sym_COLON_EQ] = ACTIONS(4005),
    [anon_sym_DOLLAR] = ACTIONS(4007),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4007),
    [sym_int] = ACTIONS(4007),
    [sym_xint] = ACTIONS(4005),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4005),
    [sym__newline] = ACTIONS(4005),
    [sym__dedent] = ACTIONS(4005),
  },
  [1951] = {
    [sym_block_comment] = STATE(1951),
    [sym_compiler_directive_decl] = STATE(1951),
    [sym_fsi_directive_decl] = STATE(1951),
    [sym_preproc_line] = STATE(1951),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_LBRACK_LT] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_and] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [aux_sym_access_modifier_token1] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4741),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_with] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_default] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [anon_sym_static] = ACTIONS(4228),
    [anon_sym_member] = ACTIONS(4228),
    [anon_sym_interface] = ACTIONS(4228),
    [anon_sym_abstract] = ACTIONS(4228),
    [anon_sym_val] = ACTIONS(4228),
    [anon_sym_override] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
    [sym__dedent] = ACTIONS(4226),
  },
  [1952] = {
    [sym_block_comment] = STATE(1952),
    [sym_compiler_directive_decl] = STATE(1952),
    [sym_fsi_directive_decl] = STATE(1952),
    [sym_preproc_line] = STATE(1952),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_LBRACK_LT] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_and] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [aux_sym_access_modifier_token1] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_with] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_default] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [anon_sym_static] = ACTIONS(4228),
    [anon_sym_member] = ACTIONS(4228),
    [anon_sym_interface] = ACTIONS(4228),
    [anon_sym_abstract] = ACTIONS(4228),
    [anon_sym_val] = ACTIONS(4228),
    [anon_sym_override] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
    [sym__dedent] = ACTIONS(4226),
  },
  [1953] = {
    [sym_block_comment] = STATE(1953),
    [sym_compiler_directive_decl] = STATE(1953),
    [sym_fsi_directive_decl] = STATE(1953),
    [sym_preproc_line] = STATE(1953),
    [sym_identifier] = ACTIONS(4100),
    [anon_sym_EQ] = ACTIONS(4098),
    [anon_sym_LBRACK_LT] = ACTIONS(4098),
    [anon_sym_COLON] = ACTIONS(4100),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_do] = ACTIONS(4100),
    [anon_sym_and] = ACTIONS(4100),
    [anon_sym_let] = ACTIONS(4100),
    [anon_sym_let_BANG] = ACTIONS(4098),
    [aux_sym_access_modifier_token1] = ACTIONS(4098),
    [anon_sym_LPAREN] = ACTIONS(4100),
    [anon_sym_COMMA] = ACTIONS(4098),
    [anon_sym_null] = ACTIONS(4100),
    [anon_sym_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_COLON] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4100),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4098),
    [anon_sym_LBRACE] = ACTIONS(4100),
    [anon_sym_LT_AT] = ACTIONS(4100),
    [anon_sym_LT_AT_AT] = ACTIONS(4100),
    [anon_sym_DOT] = ACTIONS(4100),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4098),
    [anon_sym_new] = ACTIONS(4100),
    [anon_sym_with] = ACTIONS(4100),
    [anon_sym_return_BANG] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4100),
    [anon_sym_yield_BANG] = ACTIONS(4098),
    [anon_sym_lazy] = ACTIONS(4100),
    [anon_sym_assert] = ACTIONS(4100),
    [anon_sym_upcast] = ACTIONS(4100),
    [anon_sym_downcast] = ACTIONS(4100),
    [anon_sym_COLON_GT] = ACTIONS(4098),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4098),
    [anon_sym_for] = ACTIONS(4100),
    [anon_sym_while] = ACTIONS(4100),
    [anon_sym_if] = ACTIONS(4100),
    [anon_sym_fun] = ACTIONS(4100),
    [anon_sym_try] = ACTIONS(4100),
    [anon_sym_match] = ACTIONS(4100),
    [anon_sym_match_BANG] = ACTIONS(4098),
    [anon_sym_function] = ACTIONS(4100),
    [anon_sym_LT_DASH] = ACTIONS(4100),
    [anon_sym_DOT_LBRACK] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(4098),
    [anon_sym_use] = ACTIONS(4100),
    [anon_sym_use_BANG] = ACTIONS(4098),
    [anon_sym_do_BANG] = ACTIONS(4098),
    [anon_sym_begin] = ACTIONS(4100),
    [anon_sym_LPAREN2] = ACTIONS(4100),
    [anon_sym_default] = ACTIONS(4100),
    [anon_sym_or] = ACTIONS(4100),
    [anon_sym_static] = ACTIONS(4100),
    [anon_sym_member] = ACTIONS(4100),
    [anon_sym_interface] = ACTIONS(4100),
    [anon_sym_abstract] = ACTIONS(4100),
    [anon_sym_val] = ACTIONS(4100),
    [anon_sym_override] = ACTIONS(4100),
    [aux_sym_char_token1] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4100),
    [anon_sym_DQUOTE] = ACTIONS(4100),
    [anon_sym_AT_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [sym_bool] = ACTIONS(4100),
    [sym_unit] = ACTIONS(4098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4100),
    [sym_op_identifier] = ACTIONS(4100),
    [anon_sym_PLUS] = ACTIONS(4100),
    [anon_sym_DASH] = ACTIONS(4100),
    [anon_sym_PLUS_DOT] = ACTIONS(4100),
    [anon_sym_DASH_DOT] = ACTIONS(4100),
    [anon_sym_PERCENT] = ACTIONS(4100),
    [anon_sym_AMP_AMP] = ACTIONS(4100),
    [anon_sym_TILDE] = ACTIONS(4098),
    [aux_sym_prefix_op_token1] = ACTIONS(4100),
    [aux_sym_infix_op_token1] = ACTIONS(4098),
    [aux_sym_infix_op_token2] = ACTIONS(4100),
    [anon_sym_PIPE_PIPE] = ACTIONS(4100),
    [anon_sym_BANG_EQ] = ACTIONS(4100),
    [anon_sym_COLON_EQ] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4100),
    [sym_int] = ACTIONS(4100),
    [sym_xint] = ACTIONS(4098),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4098),
    [anon_sym_POUNDendif] = ACTIONS(4098),
    [sym__newline] = ACTIONS(4098),
  },
  [1954] = {
    [sym_block_comment] = STATE(1954),
    [sym_compiler_directive_decl] = STATE(1954),
    [sym_fsi_directive_decl] = STATE(1954),
    [sym_preproc_line] = STATE(1954),
    [sym_identifier] = ACTIONS(3972),
    [anon_sym_EQ] = ACTIONS(3970),
    [anon_sym_LBRACK_LT] = ACTIONS(3970),
    [anon_sym_COLON] = ACTIONS(3972),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_do] = ACTIONS(3972),
    [anon_sym_let] = ACTIONS(3972),
    [anon_sym_let_BANG] = ACTIONS(3970),
    [aux_sym_access_modifier_token1] = ACTIONS(3970),
    [anon_sym_LPAREN] = ACTIONS(3972),
    [anon_sym_COMMA] = ACTIONS(3970),
    [anon_sym_null] = ACTIONS(3972),
    [anon_sym_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_COLON] = ACTIONS(3970),
    [anon_sym_AMP] = ACTIONS(3972),
    [anon_sym_LBRACK] = ACTIONS(3972),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3970),
    [anon_sym_LBRACE] = ACTIONS(3972),
    [anon_sym_LT_AT] = ACTIONS(3972),
    [anon_sym_LT_AT_AT] = ACTIONS(3972),
    [anon_sym_DOT] = ACTIONS(3972),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3970),
    [anon_sym_new] = ACTIONS(3972),
    [anon_sym_with] = ACTIONS(3972),
    [anon_sym_return_BANG] = ACTIONS(3970),
    [anon_sym_yield] = ACTIONS(3972),
    [anon_sym_yield_BANG] = ACTIONS(3970),
    [anon_sym_lazy] = ACTIONS(3972),
    [anon_sym_assert] = ACTIONS(3972),
    [anon_sym_upcast] = ACTIONS(3972),
    [anon_sym_downcast] = ACTIONS(3972),
    [anon_sym_COLON_GT] = ACTIONS(3970),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3970),
    [anon_sym_for] = ACTIONS(3972),
    [anon_sym_while] = ACTIONS(3972),
    [anon_sym_if] = ACTIONS(3972),
    [anon_sym_fun] = ACTIONS(3972),
    [anon_sym_try] = ACTIONS(3972),
    [anon_sym_match] = ACTIONS(3972),
    [anon_sym_match_BANG] = ACTIONS(3970),
    [anon_sym_function] = ACTIONS(3972),
    [anon_sym_LT_DASH] = ACTIONS(3972),
    [anon_sym_DOT_LBRACK] = ACTIONS(3970),
    [anon_sym_LT] = ACTIONS(3970),
    [anon_sym_use] = ACTIONS(3972),
    [anon_sym_use_BANG] = ACTIONS(3970),
    [anon_sym_do_BANG] = ACTIONS(3970),
    [anon_sym_begin] = ACTIONS(3972),
    [anon_sym_LPAREN2] = ACTIONS(3972),
    [anon_sym_DOT_DOT2] = ACTIONS(3970),
    [anon_sym_default] = ACTIONS(3972),
    [anon_sym_or] = ACTIONS(3972),
    [anon_sym_static] = ACTIONS(3972),
    [anon_sym_member] = ACTIONS(3972),
    [anon_sym_interface] = ACTIONS(3972),
    [anon_sym_abstract] = ACTIONS(3972),
    [anon_sym_val] = ACTIONS(3972),
    [anon_sym_override] = ACTIONS(3972),
    [aux_sym_char_token1] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3972),
    [anon_sym_DQUOTE] = ACTIONS(3972),
    [anon_sym_AT_DQUOTE] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [sym_bool] = ACTIONS(3972),
    [sym_unit] = ACTIONS(3970),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3972),
    [sym_op_identifier] = ACTIONS(3972),
    [anon_sym_PLUS] = ACTIONS(3972),
    [anon_sym_DASH] = ACTIONS(3972),
    [anon_sym_PLUS_DOT] = ACTIONS(3972),
    [anon_sym_DASH_DOT] = ACTIONS(3972),
    [anon_sym_PERCENT] = ACTIONS(3972),
    [anon_sym_AMP_AMP] = ACTIONS(3972),
    [anon_sym_TILDE] = ACTIONS(3970),
    [aux_sym_prefix_op_token1] = ACTIONS(3972),
    [aux_sym_infix_op_token1] = ACTIONS(3970),
    [aux_sym_infix_op_token2] = ACTIONS(3972),
    [anon_sym_PIPE_PIPE] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3972),
    [anon_sym_COLON_EQ] = ACTIONS(3970),
    [anon_sym_DOLLAR] = ACTIONS(3972),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3972),
    [sym_int] = ACTIONS(3972),
    [sym_xint] = ACTIONS(3970),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3970),
    [sym__newline] = ACTIONS(3970),
    [sym__dedent] = ACTIONS(3970),
  },
  [1955] = {
    [sym_block_comment] = STATE(1955),
    [sym_compiler_directive_decl] = STATE(1955),
    [sym_fsi_directive_decl] = STATE(1955),
    [sym_preproc_line] = STATE(1955),
    [sym_identifier] = ACTIONS(3996),
    [anon_sym_EQ] = ACTIONS(3994),
    [anon_sym_LBRACK_LT] = ACTIONS(3994),
    [anon_sym_COLON] = ACTIONS(3996),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_do] = ACTIONS(3996),
    [anon_sym_let] = ACTIONS(3996),
    [anon_sym_let_BANG] = ACTIONS(3994),
    [aux_sym_access_modifier_token1] = ACTIONS(3994),
    [anon_sym_LPAREN] = ACTIONS(3996),
    [anon_sym_COMMA] = ACTIONS(3994),
    [anon_sym_null] = ACTIONS(3996),
    [anon_sym_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_COLON] = ACTIONS(3994),
    [anon_sym_AMP] = ACTIONS(3996),
    [anon_sym_LBRACK] = ACTIONS(3996),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3994),
    [anon_sym_LBRACE] = ACTIONS(3996),
    [anon_sym_LT_AT] = ACTIONS(3996),
    [anon_sym_LT_AT_AT] = ACTIONS(3996),
    [anon_sym_DOT] = ACTIONS(3996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3994),
    [anon_sym_new] = ACTIONS(3996),
    [anon_sym_with] = ACTIONS(3996),
    [anon_sym_return_BANG] = ACTIONS(3994),
    [anon_sym_yield] = ACTIONS(3996),
    [anon_sym_yield_BANG] = ACTIONS(3994),
    [anon_sym_lazy] = ACTIONS(3996),
    [anon_sym_assert] = ACTIONS(3996),
    [anon_sym_upcast] = ACTIONS(3996),
    [anon_sym_downcast] = ACTIONS(3996),
    [anon_sym_COLON_GT] = ACTIONS(3994),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3994),
    [anon_sym_for] = ACTIONS(3996),
    [anon_sym_while] = ACTIONS(3996),
    [anon_sym_if] = ACTIONS(3996),
    [anon_sym_fun] = ACTIONS(3996),
    [anon_sym_try] = ACTIONS(3996),
    [anon_sym_match] = ACTIONS(3996),
    [anon_sym_match_BANG] = ACTIONS(3994),
    [anon_sym_function] = ACTIONS(3996),
    [anon_sym_LT_DASH] = ACTIONS(3996),
    [anon_sym_DOT_LBRACK] = ACTIONS(3994),
    [anon_sym_LT] = ACTIONS(3994),
    [anon_sym_use] = ACTIONS(3996),
    [anon_sym_use_BANG] = ACTIONS(3994),
    [anon_sym_do_BANG] = ACTIONS(3994),
    [anon_sym_begin] = ACTIONS(3996),
    [anon_sym_LPAREN2] = ACTIONS(3996),
    [anon_sym_DOT_DOT2] = ACTIONS(3994),
    [anon_sym_default] = ACTIONS(3996),
    [anon_sym_or] = ACTIONS(3996),
    [anon_sym_static] = ACTIONS(3996),
    [anon_sym_member] = ACTIONS(3996),
    [anon_sym_interface] = ACTIONS(3996),
    [anon_sym_abstract] = ACTIONS(3996),
    [anon_sym_val] = ACTIONS(3996),
    [anon_sym_override] = ACTIONS(3996),
    [aux_sym_char_token1] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3996),
    [anon_sym_DQUOTE] = ACTIONS(3996),
    [anon_sym_AT_DQUOTE] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [sym_bool] = ACTIONS(3996),
    [sym_unit] = ACTIONS(3994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3996),
    [sym_op_identifier] = ACTIONS(3996),
    [anon_sym_PLUS] = ACTIONS(3996),
    [anon_sym_DASH] = ACTIONS(3996),
    [anon_sym_PLUS_DOT] = ACTIONS(3996),
    [anon_sym_DASH_DOT] = ACTIONS(3996),
    [anon_sym_PERCENT] = ACTIONS(3996),
    [anon_sym_AMP_AMP] = ACTIONS(3996),
    [anon_sym_TILDE] = ACTIONS(3994),
    [aux_sym_prefix_op_token1] = ACTIONS(3996),
    [aux_sym_infix_op_token1] = ACTIONS(3994),
    [aux_sym_infix_op_token2] = ACTIONS(3996),
    [anon_sym_PIPE_PIPE] = ACTIONS(3996),
    [anon_sym_BANG_EQ] = ACTIONS(3996),
    [anon_sym_COLON_EQ] = ACTIONS(3994),
    [anon_sym_DOLLAR] = ACTIONS(3996),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3996),
    [sym_int] = ACTIONS(3996),
    [sym_xint] = ACTIONS(3994),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3994),
    [sym__newline] = ACTIONS(3994),
    [sym__dedent] = ACTIONS(3994),
  },
  [1956] = {
    [sym_block_comment] = STATE(1956),
    [sym_compiler_directive_decl] = STATE(1956),
    [sym_fsi_directive_decl] = STATE(1956),
    [sym_preproc_line] = STATE(1956),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_EQ] = ACTIONS(4001),
    [anon_sym_LBRACK_LT] = ACTIONS(4001),
    [anon_sym_COLON] = ACTIONS(4003),
    [anon_sym_return] = ACTIONS(4003),
    [anon_sym_do] = ACTIONS(4003),
    [anon_sym_let] = ACTIONS(4003),
    [anon_sym_let_BANG] = ACTIONS(4001),
    [aux_sym_access_modifier_token1] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4003),
    [anon_sym_COMMA] = ACTIONS(4001),
    [anon_sym_null] = ACTIONS(4003),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_COLON] = ACTIONS(4001),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LBRACK] = ACTIONS(4003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4001),
    [anon_sym_LBRACE] = ACTIONS(4003),
    [anon_sym_LT_AT] = ACTIONS(4003),
    [anon_sym_LT_AT_AT] = ACTIONS(4003),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4001),
    [anon_sym_new] = ACTIONS(4003),
    [anon_sym_with] = ACTIONS(4003),
    [anon_sym_return_BANG] = ACTIONS(4001),
    [anon_sym_yield] = ACTIONS(4003),
    [anon_sym_yield_BANG] = ACTIONS(4001),
    [anon_sym_lazy] = ACTIONS(4003),
    [anon_sym_assert] = ACTIONS(4003),
    [anon_sym_upcast] = ACTIONS(4003),
    [anon_sym_downcast] = ACTIONS(4003),
    [anon_sym_COLON_GT] = ACTIONS(4001),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4001),
    [anon_sym_for] = ACTIONS(4003),
    [anon_sym_while] = ACTIONS(4003),
    [anon_sym_if] = ACTIONS(4003),
    [anon_sym_fun] = ACTIONS(4003),
    [anon_sym_try] = ACTIONS(4003),
    [anon_sym_match] = ACTIONS(4003),
    [anon_sym_match_BANG] = ACTIONS(4001),
    [anon_sym_function] = ACTIONS(4003),
    [anon_sym_LT_DASH] = ACTIONS(4003),
    [anon_sym_DOT_LBRACK] = ACTIONS(4001),
    [anon_sym_LT] = ACTIONS(4001),
    [anon_sym_use] = ACTIONS(4003),
    [anon_sym_use_BANG] = ACTIONS(4001),
    [anon_sym_do_BANG] = ACTIONS(4001),
    [anon_sym_begin] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4003),
    [anon_sym_DOT_DOT2] = ACTIONS(4001),
    [anon_sym_default] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [anon_sym_static] = ACTIONS(4003),
    [anon_sym_member] = ACTIONS(4003),
    [anon_sym_interface] = ACTIONS(4003),
    [anon_sym_abstract] = ACTIONS(4003),
    [anon_sym_val] = ACTIONS(4003),
    [anon_sym_override] = ACTIONS(4003),
    [aux_sym_char_token1] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4003),
    [anon_sym_DQUOTE] = ACTIONS(4003),
    [anon_sym_AT_DQUOTE] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [sym_bool] = ACTIONS(4003),
    [sym_unit] = ACTIONS(4001),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4003),
    [sym_op_identifier] = ACTIONS(4003),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_PLUS_DOT] = ACTIONS(4003),
    [anon_sym_DASH_DOT] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4003),
    [anon_sym_TILDE] = ACTIONS(4001),
    [aux_sym_prefix_op_token1] = ACTIONS(4003),
    [aux_sym_infix_op_token1] = ACTIONS(4001),
    [aux_sym_infix_op_token2] = ACTIONS(4003),
    [anon_sym_PIPE_PIPE] = ACTIONS(4003),
    [anon_sym_BANG_EQ] = ACTIONS(4003),
    [anon_sym_COLON_EQ] = ACTIONS(4001),
    [anon_sym_DOLLAR] = ACTIONS(4003),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4003),
    [sym_int] = ACTIONS(4003),
    [sym_xint] = ACTIONS(4001),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4001),
    [sym__newline] = ACTIONS(4001),
    [sym__dedent] = ACTIONS(4001),
  },
  [1957] = {
    [sym_block_comment] = STATE(1957),
    [sym_compiler_directive_decl] = STATE(1957),
    [sym_fsi_directive_decl] = STATE(1957),
    [sym_preproc_line] = STATE(1957),
    [aux_sym_long_identifier_repeat1] = STATE(1975),
    [ts_builtin_sym_end] = ACTIONS(3449),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_namespace] = ACTIONS(3451),
    [anon_sym_module] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_open] = ACTIONS(3451),
    [anon_sym_LBRACK_LT] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_type] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(4743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_DASH_GT] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_STAR] = ACTIONS(3451),
    [anon_sym_LT2] = ACTIONS(3451),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3449),
    [anon_sym_or] = ACTIONS(3451),
    [anon_sym_exception] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3449),
    [anon_sym_POUNDload] = ACTIONS(3449),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
  },
  [1958] = {
    [sym_block_comment] = STATE(1958),
    [sym_compiler_directive_decl] = STATE(1958),
    [sym_fsi_directive_decl] = STATE(1958),
    [sym_preproc_line] = STATE(1958),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3843),
    [anon_sym_LBRACK_LT] = ACTIONS(3843),
    [anon_sym_COLON] = ACTIONS(3845),
    [anon_sym_return] = ACTIONS(3845),
    [anon_sym_do] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_let_BANG] = ACTIONS(3843),
    [aux_sym_access_modifier_token1] = ACTIONS(3843),
    [anon_sym_LPAREN] = ACTIONS(3845),
    [anon_sym_COMMA] = ACTIONS(3843),
    [anon_sym_null] = ACTIONS(3845),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3843),
    [anon_sym_LBRACE] = ACTIONS(3845),
    [anon_sym_LT_AT] = ACTIONS(3845),
    [anon_sym_LT_AT_AT] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3843),
    [anon_sym_new] = ACTIONS(3845),
    [anon_sym_with] = ACTIONS(3845),
    [anon_sym_return_BANG] = ACTIONS(3843),
    [anon_sym_yield] = ACTIONS(3845),
    [anon_sym_yield_BANG] = ACTIONS(3843),
    [anon_sym_lazy] = ACTIONS(3845),
    [anon_sym_assert] = ACTIONS(3845),
    [anon_sym_upcast] = ACTIONS(3845),
    [anon_sym_downcast] = ACTIONS(3845),
    [anon_sym_COLON_GT] = ACTIONS(3843),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3843),
    [anon_sym_for] = ACTIONS(3845),
    [anon_sym_while] = ACTIONS(3845),
    [anon_sym_if] = ACTIONS(3845),
    [anon_sym_fun] = ACTIONS(3845),
    [anon_sym_try] = ACTIONS(3845),
    [anon_sym_match] = ACTIONS(3845),
    [anon_sym_match_BANG] = ACTIONS(3843),
    [anon_sym_function] = ACTIONS(3845),
    [anon_sym_LT_DASH] = ACTIONS(3845),
    [anon_sym_DOT_LBRACK] = ACTIONS(3843),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_use] = ACTIONS(3845),
    [anon_sym_use_BANG] = ACTIONS(3843),
    [anon_sym_do_BANG] = ACTIONS(3843),
    [anon_sym_begin] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(3845),
    [anon_sym_DOT_DOT2] = ACTIONS(3843),
    [anon_sym_default] = ACTIONS(3845),
    [anon_sym_or] = ACTIONS(3845),
    [anon_sym_static] = ACTIONS(3845),
    [anon_sym_member] = ACTIONS(3845),
    [anon_sym_interface] = ACTIONS(3845),
    [anon_sym_abstract] = ACTIONS(3845),
    [anon_sym_val] = ACTIONS(3845),
    [anon_sym_override] = ACTIONS(3845),
    [aux_sym_char_token1] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3845),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_AT_DQUOTE] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [sym_bool] = ACTIONS(3845),
    [sym_unit] = ACTIONS(3843),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3845),
    [sym_op_identifier] = ACTIONS(3845),
    [anon_sym_PLUS] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_PLUS_DOT] = ACTIONS(3845),
    [anon_sym_DASH_DOT] = ACTIONS(3845),
    [anon_sym_PERCENT] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3845),
    [anon_sym_TILDE] = ACTIONS(3843),
    [aux_sym_prefix_op_token1] = ACTIONS(3845),
    [aux_sym_infix_op_token1] = ACTIONS(3843),
    [aux_sym_infix_op_token2] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(3845),
    [anon_sym_BANG_EQ] = ACTIONS(3845),
    [anon_sym_COLON_EQ] = ACTIONS(3843),
    [anon_sym_DOLLAR] = ACTIONS(3845),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3845),
    [sym_int] = ACTIONS(3845),
    [sym_xint] = ACTIONS(3843),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3843),
    [sym__newline] = ACTIONS(3843),
    [sym__dedent] = ACTIONS(3843),
  },
  [1959] = {
    [sym_block_comment] = STATE(1959),
    [sym_compiler_directive_decl] = STATE(1959),
    [sym_fsi_directive_decl] = STATE(1959),
    [sym_preproc_line] = STATE(1959),
    [sym_identifier] = ACTIONS(4011),
    [anon_sym_EQ] = ACTIONS(4009),
    [anon_sym_LBRACK_LT] = ACTIONS(4009),
    [anon_sym_COLON] = ACTIONS(4011),
    [anon_sym_return] = ACTIONS(4011),
    [anon_sym_do] = ACTIONS(4011),
    [anon_sym_and] = ACTIONS(4011),
    [anon_sym_let] = ACTIONS(4011),
    [anon_sym_let_BANG] = ACTIONS(4009),
    [aux_sym_access_modifier_token1] = ACTIONS(4009),
    [anon_sym_LPAREN] = ACTIONS(4011),
    [anon_sym_COMMA] = ACTIONS(4009),
    [anon_sym_null] = ACTIONS(4011),
    [anon_sym_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(4011),
    [anon_sym_LBRACK] = ACTIONS(4011),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4009),
    [anon_sym_LBRACE] = ACTIONS(4011),
    [anon_sym_LT_AT] = ACTIONS(4011),
    [anon_sym_LT_AT_AT] = ACTIONS(4011),
    [anon_sym_DOT] = ACTIONS(4011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4009),
    [anon_sym_new] = ACTIONS(4011),
    [anon_sym_with] = ACTIONS(4011),
    [anon_sym_return_BANG] = ACTIONS(4009),
    [anon_sym_yield] = ACTIONS(4011),
    [anon_sym_yield_BANG] = ACTIONS(4009),
    [anon_sym_lazy] = ACTIONS(4011),
    [anon_sym_assert] = ACTIONS(4011),
    [anon_sym_upcast] = ACTIONS(4011),
    [anon_sym_downcast] = ACTIONS(4011),
    [anon_sym_COLON_GT] = ACTIONS(4009),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4009),
    [anon_sym_for] = ACTIONS(4011),
    [anon_sym_while] = ACTIONS(4011),
    [anon_sym_if] = ACTIONS(4011),
    [anon_sym_fun] = ACTIONS(4011),
    [anon_sym_try] = ACTIONS(4011),
    [anon_sym_match] = ACTIONS(4011),
    [anon_sym_match_BANG] = ACTIONS(4009),
    [anon_sym_function] = ACTIONS(4011),
    [anon_sym_LT_DASH] = ACTIONS(4011),
    [anon_sym_DOT_LBRACK] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(4009),
    [anon_sym_use] = ACTIONS(4011),
    [anon_sym_use_BANG] = ACTIONS(4009),
    [anon_sym_do_BANG] = ACTIONS(4009),
    [anon_sym_begin] = ACTIONS(4011),
    [anon_sym_LPAREN2] = ACTIONS(4011),
    [anon_sym_default] = ACTIONS(4011),
    [anon_sym_or] = ACTIONS(4011),
    [anon_sym_static] = ACTIONS(4011),
    [anon_sym_member] = ACTIONS(4011),
    [anon_sym_interface] = ACTIONS(4011),
    [anon_sym_abstract] = ACTIONS(4011),
    [anon_sym_val] = ACTIONS(4011),
    [anon_sym_override] = ACTIONS(4011),
    [aux_sym_char_token1] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4011),
    [anon_sym_DQUOTE] = ACTIONS(4011),
    [anon_sym_AT_DQUOTE] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [sym_bool] = ACTIONS(4011),
    [sym_unit] = ACTIONS(4009),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4011),
    [sym_op_identifier] = ACTIONS(4011),
    [anon_sym_PLUS] = ACTIONS(4011),
    [anon_sym_DASH] = ACTIONS(4011),
    [anon_sym_PLUS_DOT] = ACTIONS(4011),
    [anon_sym_DASH_DOT] = ACTIONS(4011),
    [anon_sym_PERCENT] = ACTIONS(4011),
    [anon_sym_AMP_AMP] = ACTIONS(4011),
    [anon_sym_TILDE] = ACTIONS(4009),
    [aux_sym_prefix_op_token1] = ACTIONS(4011),
    [aux_sym_infix_op_token1] = ACTIONS(4009),
    [aux_sym_infix_op_token2] = ACTIONS(4011),
    [anon_sym_PIPE_PIPE] = ACTIONS(4011),
    [anon_sym_BANG_EQ] = ACTIONS(4011),
    [anon_sym_COLON_EQ] = ACTIONS(4009),
    [anon_sym_DOLLAR] = ACTIONS(4011),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4011),
    [sym_int] = ACTIONS(4011),
    [sym_xint] = ACTIONS(4009),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4009),
    [sym__newline] = ACTIONS(4009),
    [sym__dedent] = ACTIONS(4009),
  },
  [1960] = {
    [sym_block_comment] = STATE(1960),
    [sym_compiler_directive_decl] = STATE(1960),
    [sym_fsi_directive_decl] = STATE(1960),
    [sym_preproc_line] = STATE(1960),
    [sym_identifier] = ACTIONS(4018),
    [anon_sym_EQ] = ACTIONS(4016),
    [anon_sym_LBRACK_LT] = ACTIONS(4016),
    [anon_sym_COLON] = ACTIONS(4018),
    [anon_sym_return] = ACTIONS(4018),
    [anon_sym_do] = ACTIONS(4018),
    [anon_sym_let] = ACTIONS(4018),
    [anon_sym_let_BANG] = ACTIONS(4016),
    [aux_sym_access_modifier_token1] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(4018),
    [anon_sym_COMMA] = ACTIONS(4016),
    [anon_sym_null] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_COLON] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4018),
    [anon_sym_LBRACK] = ACTIONS(4018),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4016),
    [anon_sym_LBRACE] = ACTIONS(4018),
    [anon_sym_LT_AT] = ACTIONS(4018),
    [anon_sym_LT_AT_AT] = ACTIONS(4018),
    [anon_sym_DOT] = ACTIONS(4018),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4016),
    [anon_sym_new] = ACTIONS(4018),
    [anon_sym_with] = ACTIONS(4018),
    [anon_sym_return_BANG] = ACTIONS(4016),
    [anon_sym_yield] = ACTIONS(4018),
    [anon_sym_yield_BANG] = ACTIONS(4016),
    [anon_sym_lazy] = ACTIONS(4018),
    [anon_sym_assert] = ACTIONS(4018),
    [anon_sym_upcast] = ACTIONS(4018),
    [anon_sym_downcast] = ACTIONS(4018),
    [anon_sym_COLON_GT] = ACTIONS(4016),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4016),
    [anon_sym_for] = ACTIONS(4018),
    [anon_sym_while] = ACTIONS(4018),
    [anon_sym_if] = ACTIONS(4018),
    [anon_sym_fun] = ACTIONS(4018),
    [anon_sym_try] = ACTIONS(4018),
    [anon_sym_match] = ACTIONS(4018),
    [anon_sym_match_BANG] = ACTIONS(4016),
    [anon_sym_function] = ACTIONS(4018),
    [anon_sym_LT_DASH] = ACTIONS(4018),
    [anon_sym_DOT_LBRACK] = ACTIONS(4016),
    [anon_sym_LT] = ACTIONS(4016),
    [anon_sym_use] = ACTIONS(4018),
    [anon_sym_use_BANG] = ACTIONS(4016),
    [anon_sym_do_BANG] = ACTIONS(4016),
    [anon_sym_begin] = ACTIONS(4018),
    [anon_sym_LPAREN2] = ACTIONS(4018),
    [anon_sym_DOT_DOT2] = ACTIONS(4016),
    [anon_sym_default] = ACTIONS(4018),
    [anon_sym_or] = ACTIONS(4018),
    [anon_sym_static] = ACTIONS(4018),
    [anon_sym_member] = ACTIONS(4018),
    [anon_sym_interface] = ACTIONS(4018),
    [anon_sym_abstract] = ACTIONS(4018),
    [anon_sym_val] = ACTIONS(4018),
    [anon_sym_override] = ACTIONS(4018),
    [aux_sym_char_token1] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(4018),
    [anon_sym_AT_DQUOTE] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [sym_bool] = ACTIONS(4018),
    [sym_unit] = ACTIONS(4016),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4018),
    [sym_op_identifier] = ACTIONS(4018),
    [anon_sym_PLUS] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_PLUS_DOT] = ACTIONS(4018),
    [anon_sym_DASH_DOT] = ACTIONS(4018),
    [anon_sym_PERCENT] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4016),
    [aux_sym_prefix_op_token1] = ACTIONS(4018),
    [aux_sym_infix_op_token1] = ACTIONS(4016),
    [aux_sym_infix_op_token2] = ACTIONS(4018),
    [anon_sym_PIPE_PIPE] = ACTIONS(4018),
    [anon_sym_BANG_EQ] = ACTIONS(4018),
    [anon_sym_COLON_EQ] = ACTIONS(4016),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4018),
    [sym_int] = ACTIONS(4018),
    [sym_xint] = ACTIONS(4016),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4016),
    [sym__newline] = ACTIONS(4016),
    [sym__dedent] = ACTIONS(4016),
  },
  [1961] = {
    [sym_block_comment] = STATE(1961),
    [sym_compiler_directive_decl] = STATE(1961),
    [sym_fsi_directive_decl] = STATE(1961),
    [sym_preproc_line] = STATE(1961),
    [sym_identifier] = ACTIONS(4022),
    [anon_sym_EQ] = ACTIONS(4020),
    [anon_sym_LBRACK_LT] = ACTIONS(4020),
    [anon_sym_COLON] = ACTIONS(4022),
    [anon_sym_return] = ACTIONS(4022),
    [anon_sym_do] = ACTIONS(4022),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_let_BANG] = ACTIONS(4020),
    [aux_sym_access_modifier_token1] = ACTIONS(4020),
    [anon_sym_LPAREN] = ACTIONS(4022),
    [anon_sym_COMMA] = ACTIONS(4020),
    [anon_sym_null] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_COLON] = ACTIONS(4020),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4022),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(4022),
    [anon_sym_LT_AT] = ACTIONS(4022),
    [anon_sym_LT_AT_AT] = ACTIONS(4022),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4020),
    [anon_sym_new] = ACTIONS(4022),
    [anon_sym_with] = ACTIONS(4022),
    [anon_sym_return_BANG] = ACTIONS(4020),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_yield_BANG] = ACTIONS(4020),
    [anon_sym_lazy] = ACTIONS(4022),
    [anon_sym_assert] = ACTIONS(4022),
    [anon_sym_upcast] = ACTIONS(4022),
    [anon_sym_downcast] = ACTIONS(4022),
    [anon_sym_COLON_GT] = ACTIONS(4020),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4020),
    [anon_sym_for] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4022),
    [anon_sym_if] = ACTIONS(4022),
    [anon_sym_fun] = ACTIONS(4022),
    [anon_sym_try] = ACTIONS(4022),
    [anon_sym_match] = ACTIONS(4022),
    [anon_sym_match_BANG] = ACTIONS(4020),
    [anon_sym_function] = ACTIONS(4022),
    [anon_sym_LT_DASH] = ACTIONS(4022),
    [anon_sym_DOT_LBRACK] = ACTIONS(4020),
    [anon_sym_LT] = ACTIONS(4020),
    [anon_sym_use] = ACTIONS(4022),
    [anon_sym_use_BANG] = ACTIONS(4020),
    [anon_sym_do_BANG] = ACTIONS(4020),
    [anon_sym_begin] = ACTIONS(4022),
    [anon_sym_LPAREN2] = ACTIONS(4022),
    [anon_sym_default] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_static] = ACTIONS(4022),
    [anon_sym_member] = ACTIONS(4022),
    [anon_sym_interface] = ACTIONS(4022),
    [anon_sym_abstract] = ACTIONS(4022),
    [anon_sym_val] = ACTIONS(4022),
    [anon_sym_override] = ACTIONS(4022),
    [aux_sym_char_token1] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4022),
    [anon_sym_DQUOTE] = ACTIONS(4022),
    [anon_sym_AT_DQUOTE] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [sym_bool] = ACTIONS(4022),
    [sym_unit] = ACTIONS(4020),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4022),
    [sym_op_identifier] = ACTIONS(4022),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_PLUS_DOT] = ACTIONS(4022),
    [anon_sym_DASH_DOT] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4022),
    [anon_sym_TILDE] = ACTIONS(4020),
    [aux_sym_prefix_op_token1] = ACTIONS(4022),
    [aux_sym_infix_op_token1] = ACTIONS(4020),
    [aux_sym_infix_op_token2] = ACTIONS(4022),
    [anon_sym_PIPE_PIPE] = ACTIONS(4022),
    [anon_sym_BANG_EQ] = ACTIONS(4022),
    [anon_sym_COLON_EQ] = ACTIONS(4020),
    [anon_sym_DOLLAR] = ACTIONS(4022),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4022),
    [sym_int] = ACTIONS(4022),
    [sym_xint] = ACTIONS(4020),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4020),
    [sym__newline] = ACTIONS(4020),
    [sym__dedent] = ACTIONS(4020),
  },
  [1962] = {
    [sym_block_comment] = STATE(1962),
    [sym_compiler_directive_decl] = STATE(1962),
    [sym_fsi_directive_decl] = STATE(1962),
    [sym_preproc_line] = STATE(1962),
    [sym_identifier] = ACTIONS(4054),
    [anon_sym_EQ] = ACTIONS(4052),
    [anon_sym_LBRACK_LT] = ACTIONS(4052),
    [anon_sym_COLON] = ACTIONS(4054),
    [anon_sym_return] = ACTIONS(4054),
    [anon_sym_do] = ACTIONS(4054),
    [anon_sym_let] = ACTIONS(4054),
    [anon_sym_let_BANG] = ACTIONS(4052),
    [aux_sym_access_modifier_token1] = ACTIONS(4052),
    [anon_sym_LPAREN] = ACTIONS(4054),
    [anon_sym_COMMA] = ACTIONS(4052),
    [anon_sym_null] = ACTIONS(4054),
    [anon_sym_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_COLON] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(4054),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4052),
    [anon_sym_LBRACE] = ACTIONS(4054),
    [anon_sym_LT_AT] = ACTIONS(4054),
    [anon_sym_LT_AT_AT] = ACTIONS(4054),
    [anon_sym_DOT] = ACTIONS(4054),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_with] = ACTIONS(4054),
    [anon_sym_return_BANG] = ACTIONS(4052),
    [anon_sym_yield] = ACTIONS(4054),
    [anon_sym_yield_BANG] = ACTIONS(4052),
    [anon_sym_lazy] = ACTIONS(4054),
    [anon_sym_assert] = ACTIONS(4054),
    [anon_sym_upcast] = ACTIONS(4054),
    [anon_sym_downcast] = ACTIONS(4054),
    [anon_sym_COLON_GT] = ACTIONS(4052),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4052),
    [anon_sym_for] = ACTIONS(4054),
    [anon_sym_while] = ACTIONS(4054),
    [anon_sym_if] = ACTIONS(4054),
    [anon_sym_fun] = ACTIONS(4054),
    [anon_sym_try] = ACTIONS(4054),
    [anon_sym_match] = ACTIONS(4054),
    [anon_sym_match_BANG] = ACTIONS(4052),
    [anon_sym_function] = ACTIONS(4054),
    [anon_sym_LT_DASH] = ACTIONS(4054),
    [anon_sym_DOT_LBRACK] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_use] = ACTIONS(4054),
    [anon_sym_use_BANG] = ACTIONS(4052),
    [anon_sym_do_BANG] = ACTIONS(4052),
    [anon_sym_begin] = ACTIONS(4054),
    [anon_sym_LPAREN2] = ACTIONS(4054),
    [anon_sym_DOT_DOT2] = ACTIONS(4052),
    [anon_sym_default] = ACTIONS(4054),
    [anon_sym_or] = ACTIONS(4054),
    [anon_sym_static] = ACTIONS(4054),
    [anon_sym_member] = ACTIONS(4054),
    [anon_sym_interface] = ACTIONS(4054),
    [anon_sym_abstract] = ACTIONS(4054),
    [anon_sym_val] = ACTIONS(4054),
    [anon_sym_override] = ACTIONS(4054),
    [aux_sym_char_token1] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4054),
    [anon_sym_DQUOTE] = ACTIONS(4054),
    [anon_sym_AT_DQUOTE] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [sym_bool] = ACTIONS(4054),
    [sym_unit] = ACTIONS(4052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4054),
    [sym_op_identifier] = ACTIONS(4054),
    [anon_sym_PLUS] = ACTIONS(4054),
    [anon_sym_DASH] = ACTIONS(4054),
    [anon_sym_PLUS_DOT] = ACTIONS(4054),
    [anon_sym_DASH_DOT] = ACTIONS(4054),
    [anon_sym_PERCENT] = ACTIONS(4054),
    [anon_sym_AMP_AMP] = ACTIONS(4054),
    [anon_sym_TILDE] = ACTIONS(4052),
    [aux_sym_prefix_op_token1] = ACTIONS(4054),
    [aux_sym_infix_op_token1] = ACTIONS(4052),
    [aux_sym_infix_op_token2] = ACTIONS(4054),
    [anon_sym_PIPE_PIPE] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4054),
    [anon_sym_COLON_EQ] = ACTIONS(4052),
    [anon_sym_DOLLAR] = ACTIONS(4054),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4054),
    [sym_int] = ACTIONS(4054),
    [sym_xint] = ACTIONS(4052),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4052),
    [sym__newline] = ACTIONS(4052),
    [sym__dedent] = ACTIONS(4052),
  },
  [1963] = {
    [sym_block_comment] = STATE(1963),
    [sym_compiler_directive_decl] = STATE(1963),
    [sym_fsi_directive_decl] = STATE(1963),
    [sym_preproc_line] = STATE(1963),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LBRACK_LT] = ACTIONS(4080),
    [anon_sym_COLON] = ACTIONS(4082),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_do] = ACTIONS(4082),
    [anon_sym_let] = ACTIONS(4082),
    [anon_sym_let_BANG] = ACTIONS(4080),
    [aux_sym_access_modifier_token1] = ACTIONS(4080),
    [anon_sym_LPAREN] = ACTIONS(4082),
    [anon_sym_COMMA] = ACTIONS(4080),
    [anon_sym_null] = ACTIONS(4082),
    [anon_sym_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_COLON] = ACTIONS(4080),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_LBRACK] = ACTIONS(4082),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(4082),
    [anon_sym_LT_AT] = ACTIONS(4082),
    [anon_sym_LT_AT_AT] = ACTIONS(4082),
    [anon_sym_DOT] = ACTIONS(4082),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4080),
    [anon_sym_new] = ACTIONS(4082),
    [anon_sym_with] = ACTIONS(4082),
    [anon_sym_return_BANG] = ACTIONS(4080),
    [anon_sym_yield] = ACTIONS(4082),
    [anon_sym_yield_BANG] = ACTIONS(4080),
    [anon_sym_lazy] = ACTIONS(4082),
    [anon_sym_assert] = ACTIONS(4082),
    [anon_sym_upcast] = ACTIONS(4082),
    [anon_sym_downcast] = ACTIONS(4082),
    [anon_sym_COLON_GT] = ACTIONS(4080),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4080),
    [anon_sym_for] = ACTIONS(4082),
    [anon_sym_while] = ACTIONS(4082),
    [anon_sym_if] = ACTIONS(4082),
    [anon_sym_fun] = ACTIONS(4082),
    [anon_sym_try] = ACTIONS(4082),
    [anon_sym_match] = ACTIONS(4082),
    [anon_sym_match_BANG] = ACTIONS(4080),
    [anon_sym_function] = ACTIONS(4082),
    [anon_sym_LT_DASH] = ACTIONS(4082),
    [anon_sym_DOT_LBRACK] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(4080),
    [anon_sym_use] = ACTIONS(4082),
    [anon_sym_use_BANG] = ACTIONS(4080),
    [anon_sym_do_BANG] = ACTIONS(4080),
    [anon_sym_begin] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4082),
    [anon_sym_DOT_DOT2] = ACTIONS(4080),
    [anon_sym_default] = ACTIONS(4082),
    [anon_sym_or] = ACTIONS(4082),
    [anon_sym_static] = ACTIONS(4082),
    [anon_sym_member] = ACTIONS(4082),
    [anon_sym_interface] = ACTIONS(4082),
    [anon_sym_abstract] = ACTIONS(4082),
    [anon_sym_val] = ACTIONS(4082),
    [anon_sym_override] = ACTIONS(4082),
    [aux_sym_char_token1] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4082),
    [anon_sym_DQUOTE] = ACTIONS(4082),
    [anon_sym_AT_DQUOTE] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [sym_bool] = ACTIONS(4082),
    [sym_unit] = ACTIONS(4080),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4082),
    [sym_op_identifier] = ACTIONS(4082),
    [anon_sym_PLUS] = ACTIONS(4082),
    [anon_sym_DASH] = ACTIONS(4082),
    [anon_sym_PLUS_DOT] = ACTIONS(4082),
    [anon_sym_DASH_DOT] = ACTIONS(4082),
    [anon_sym_PERCENT] = ACTIONS(4082),
    [anon_sym_AMP_AMP] = ACTIONS(4082),
    [anon_sym_TILDE] = ACTIONS(4080),
    [aux_sym_prefix_op_token1] = ACTIONS(4082),
    [aux_sym_infix_op_token1] = ACTIONS(4080),
    [aux_sym_infix_op_token2] = ACTIONS(4082),
    [anon_sym_PIPE_PIPE] = ACTIONS(4082),
    [anon_sym_BANG_EQ] = ACTIONS(4082),
    [anon_sym_COLON_EQ] = ACTIONS(4080),
    [anon_sym_DOLLAR] = ACTIONS(4082),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4082),
    [sym_int] = ACTIONS(4082),
    [sym_xint] = ACTIONS(4080),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4080),
    [sym__newline] = ACTIONS(4080),
    [sym__dedent] = ACTIONS(4080),
  },
  [1964] = {
    [sym_block_comment] = STATE(1964),
    [sym_compiler_directive_decl] = STATE(1964),
    [sym_fsi_directive_decl] = STATE(1964),
    [sym_preproc_line] = STATE(1964),
    [sym_identifier] = ACTIONS(4137),
    [anon_sym_EQ] = ACTIONS(4135),
    [anon_sym_LBRACK_LT] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4137),
    [anon_sym_return] = ACTIONS(4137),
    [anon_sym_do] = ACTIONS(4137),
    [anon_sym_and] = ACTIONS(4137),
    [anon_sym_let] = ACTIONS(4137),
    [anon_sym_let_BANG] = ACTIONS(4135),
    [aux_sym_access_modifier_token1] = ACTIONS(4135),
    [anon_sym_LPAREN] = ACTIONS(4137),
    [anon_sym_COMMA] = ACTIONS(4135),
    [anon_sym_null] = ACTIONS(4137),
    [anon_sym_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_COLON] = ACTIONS(4135),
    [anon_sym_AMP] = ACTIONS(4137),
    [anon_sym_LBRACK] = ACTIONS(4137),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4135),
    [anon_sym_LBRACE] = ACTIONS(4137),
    [anon_sym_LT_AT] = ACTIONS(4137),
    [anon_sym_LT_AT_AT] = ACTIONS(4137),
    [anon_sym_DOT] = ACTIONS(4137),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4135),
    [anon_sym_new] = ACTIONS(4137),
    [anon_sym_with] = ACTIONS(4137),
    [anon_sym_return_BANG] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_yield_BANG] = ACTIONS(4135),
    [anon_sym_lazy] = ACTIONS(4137),
    [anon_sym_assert] = ACTIONS(4137),
    [anon_sym_upcast] = ACTIONS(4137),
    [anon_sym_downcast] = ACTIONS(4137),
    [anon_sym_COLON_GT] = ACTIONS(4135),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4135),
    [anon_sym_for] = ACTIONS(4137),
    [anon_sym_while] = ACTIONS(4137),
    [anon_sym_if] = ACTIONS(4137),
    [anon_sym_fun] = ACTIONS(4137),
    [anon_sym_try] = ACTIONS(4137),
    [anon_sym_match] = ACTIONS(4137),
    [anon_sym_match_BANG] = ACTIONS(4135),
    [anon_sym_function] = ACTIONS(4137),
    [anon_sym_LT_DASH] = ACTIONS(4137),
    [anon_sym_DOT_LBRACK] = ACTIONS(4135),
    [anon_sym_LT] = ACTIONS(4135),
    [anon_sym_use] = ACTIONS(4137),
    [anon_sym_use_BANG] = ACTIONS(4135),
    [anon_sym_do_BANG] = ACTIONS(4135),
    [anon_sym_begin] = ACTIONS(4137),
    [anon_sym_LPAREN2] = ACTIONS(4137),
    [anon_sym_default] = ACTIONS(4137),
    [anon_sym_or] = ACTIONS(4137),
    [anon_sym_static] = ACTIONS(4137),
    [anon_sym_member] = ACTIONS(4137),
    [anon_sym_interface] = ACTIONS(4137),
    [anon_sym_abstract] = ACTIONS(4137),
    [anon_sym_val] = ACTIONS(4137),
    [anon_sym_override] = ACTIONS(4137),
    [aux_sym_char_token1] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4137),
    [anon_sym_DQUOTE] = ACTIONS(4137),
    [anon_sym_AT_DQUOTE] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [sym_bool] = ACTIONS(4137),
    [sym_unit] = ACTIONS(4135),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4137),
    [sym_op_identifier] = ACTIONS(4137),
    [anon_sym_PLUS] = ACTIONS(4137),
    [anon_sym_DASH] = ACTIONS(4137),
    [anon_sym_PLUS_DOT] = ACTIONS(4137),
    [anon_sym_DASH_DOT] = ACTIONS(4137),
    [anon_sym_PERCENT] = ACTIONS(4137),
    [anon_sym_AMP_AMP] = ACTIONS(4137),
    [anon_sym_TILDE] = ACTIONS(4135),
    [aux_sym_prefix_op_token1] = ACTIONS(4137),
    [aux_sym_infix_op_token1] = ACTIONS(4135),
    [aux_sym_infix_op_token2] = ACTIONS(4137),
    [anon_sym_PIPE_PIPE] = ACTIONS(4137),
    [anon_sym_BANG_EQ] = ACTIONS(4137),
    [anon_sym_COLON_EQ] = ACTIONS(4135),
    [anon_sym_DOLLAR] = ACTIONS(4137),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4137),
    [sym_int] = ACTIONS(4137),
    [sym_xint] = ACTIONS(4135),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4135),
    [anon_sym_POUNDendif] = ACTIONS(4135),
    [sym__newline] = ACTIONS(4135),
  },
  [1965] = {
    [sym_block_comment] = STATE(1965),
    [sym_compiler_directive_decl] = STATE(1965),
    [sym_fsi_directive_decl] = STATE(1965),
    [sym_preproc_line] = STATE(1965),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4072),
    [anon_sym_LBRACK_LT] = ACTIONS(4072),
    [anon_sym_COLON] = ACTIONS(4074),
    [anon_sym_return] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_let_BANG] = ACTIONS(4072),
    [aux_sym_access_modifier_token1] = ACTIONS(4072),
    [anon_sym_LPAREN] = ACTIONS(4074),
    [anon_sym_COMMA] = ACTIONS(4072),
    [anon_sym_null] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_COLON] = ACTIONS(4072),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_LT_AT] = ACTIONS(4074),
    [anon_sym_LT_AT_AT] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4072),
    [anon_sym_new] = ACTIONS(4074),
    [anon_sym_with] = ACTIONS(4074),
    [anon_sym_return_BANG] = ACTIONS(4072),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_yield_BANG] = ACTIONS(4072),
    [anon_sym_lazy] = ACTIONS(4074),
    [anon_sym_assert] = ACTIONS(4074),
    [anon_sym_upcast] = ACTIONS(4074),
    [anon_sym_downcast] = ACTIONS(4074),
    [anon_sym_COLON_GT] = ACTIONS(4072),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4072),
    [anon_sym_for] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_fun] = ACTIONS(4074),
    [anon_sym_try] = ACTIONS(4074),
    [anon_sym_match] = ACTIONS(4074),
    [anon_sym_match_BANG] = ACTIONS(4072),
    [anon_sym_function] = ACTIONS(4074),
    [anon_sym_LT_DASH] = ACTIONS(4074),
    [anon_sym_DOT_LBRACK] = ACTIONS(4072),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_use] = ACTIONS(4074),
    [anon_sym_use_BANG] = ACTIONS(4072),
    [anon_sym_do_BANG] = ACTIONS(4072),
    [anon_sym_begin] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(4074),
    [anon_sym_default] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_static] = ACTIONS(4074),
    [anon_sym_member] = ACTIONS(4074),
    [anon_sym_interface] = ACTIONS(4074),
    [anon_sym_abstract] = ACTIONS(4074),
    [anon_sym_val] = ACTIONS(4074),
    [anon_sym_override] = ACTIONS(4074),
    [aux_sym_char_token1] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4074),
    [anon_sym_DQUOTE] = ACTIONS(4074),
    [anon_sym_AT_DQUOTE] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [sym_bool] = ACTIONS(4074),
    [sym_unit] = ACTIONS(4072),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4074),
    [sym_op_identifier] = ACTIONS(4074),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_PLUS_DOT] = ACTIONS(4074),
    [anon_sym_DASH_DOT] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_TILDE] = ACTIONS(4072),
    [aux_sym_prefix_op_token1] = ACTIONS(4074),
    [aux_sym_infix_op_token1] = ACTIONS(4072),
    [aux_sym_infix_op_token2] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [anon_sym_BANG_EQ] = ACTIONS(4074),
    [anon_sym_COLON_EQ] = ACTIONS(4072),
    [anon_sym_DOLLAR] = ACTIONS(4074),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4074),
    [sym_int] = ACTIONS(4074),
    [sym_xint] = ACTIONS(4072),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4072),
    [sym__newline] = ACTIONS(4072),
    [sym__dedent] = ACTIONS(4072),
  },
  [1966] = {
    [sym_block_comment] = STATE(1966),
    [sym_compiler_directive_decl] = STATE(1966),
    [sym_fsi_directive_decl] = STATE(1966),
    [sym_preproc_line] = STATE(1966),
    [sym_identifier] = ACTIONS(4086),
    [anon_sym_EQ] = ACTIONS(4084),
    [anon_sym_LBRACK_LT] = ACTIONS(4084),
    [anon_sym_COLON] = ACTIONS(4086),
    [anon_sym_return] = ACTIONS(4086),
    [anon_sym_do] = ACTIONS(4086),
    [anon_sym_let] = ACTIONS(4086),
    [anon_sym_let_BANG] = ACTIONS(4084),
    [aux_sym_access_modifier_token1] = ACTIONS(4084),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_COMMA] = ACTIONS(4084),
    [anon_sym_null] = ACTIONS(4086),
    [anon_sym_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_COLON] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4084),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_LT_AT] = ACTIONS(4086),
    [anon_sym_LT_AT_AT] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4086),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4084),
    [anon_sym_new] = ACTIONS(4086),
    [anon_sym_with] = ACTIONS(4086),
    [anon_sym_return_BANG] = ACTIONS(4084),
    [anon_sym_yield] = ACTIONS(4086),
    [anon_sym_yield_BANG] = ACTIONS(4084),
    [anon_sym_lazy] = ACTIONS(4086),
    [anon_sym_assert] = ACTIONS(4086),
    [anon_sym_upcast] = ACTIONS(4086),
    [anon_sym_downcast] = ACTIONS(4086),
    [anon_sym_COLON_GT] = ACTIONS(4084),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4084),
    [anon_sym_for] = ACTIONS(4086),
    [anon_sym_while] = ACTIONS(4086),
    [anon_sym_if] = ACTIONS(4086),
    [anon_sym_fun] = ACTIONS(4086),
    [anon_sym_try] = ACTIONS(4086),
    [anon_sym_match] = ACTIONS(4086),
    [anon_sym_match_BANG] = ACTIONS(4084),
    [anon_sym_function] = ACTIONS(4086),
    [anon_sym_LT_DASH] = ACTIONS(4086),
    [anon_sym_DOT_LBRACK] = ACTIONS(4084),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_use] = ACTIONS(4086),
    [anon_sym_use_BANG] = ACTIONS(4084),
    [anon_sym_do_BANG] = ACTIONS(4084),
    [anon_sym_begin] = ACTIONS(4086),
    [anon_sym_LPAREN2] = ACTIONS(4086),
    [anon_sym_DOT_DOT2] = ACTIONS(4084),
    [anon_sym_default] = ACTIONS(4086),
    [anon_sym_or] = ACTIONS(4086),
    [anon_sym_static] = ACTIONS(4086),
    [anon_sym_member] = ACTIONS(4086),
    [anon_sym_interface] = ACTIONS(4086),
    [anon_sym_abstract] = ACTIONS(4086),
    [anon_sym_val] = ACTIONS(4086),
    [anon_sym_override] = ACTIONS(4086),
    [aux_sym_char_token1] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4086),
    [anon_sym_DQUOTE] = ACTIONS(4086),
    [anon_sym_AT_DQUOTE] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [sym_bool] = ACTIONS(4086),
    [sym_unit] = ACTIONS(4084),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4086),
    [sym_op_identifier] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4086),
    [anon_sym_DASH] = ACTIONS(4086),
    [anon_sym_PLUS_DOT] = ACTIONS(4086),
    [anon_sym_DASH_DOT] = ACTIONS(4086),
    [anon_sym_PERCENT] = ACTIONS(4086),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_TILDE] = ACTIONS(4084),
    [aux_sym_prefix_op_token1] = ACTIONS(4086),
    [aux_sym_infix_op_token1] = ACTIONS(4084),
    [aux_sym_infix_op_token2] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_COLON_EQ] = ACTIONS(4084),
    [anon_sym_DOLLAR] = ACTIONS(4086),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4086),
    [sym_int] = ACTIONS(4086),
    [sym_xint] = ACTIONS(4084),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4084),
    [sym__newline] = ACTIONS(4084),
    [sym__dedent] = ACTIONS(4084),
  },
  [1967] = {
    [sym_block_comment] = STATE(1967),
    [sym_compiler_directive_decl] = STATE(1967),
    [sym_fsi_directive_decl] = STATE(1967),
    [sym_preproc_line] = STATE(1967),
    [sym_identifier] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(4091),
    [anon_sym_LBRACK_LT] = ACTIONS(4091),
    [anon_sym_COLON] = ACTIONS(4093),
    [anon_sym_return] = ACTIONS(4093),
    [anon_sym_do] = ACTIONS(4093),
    [anon_sym_let] = ACTIONS(4093),
    [anon_sym_let_BANG] = ACTIONS(4091),
    [aux_sym_access_modifier_token1] = ACTIONS(4091),
    [anon_sym_LPAREN] = ACTIONS(4093),
    [anon_sym_COMMA] = ACTIONS(4091),
    [anon_sym_null] = ACTIONS(4093),
    [anon_sym_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_COLON] = ACTIONS(4091),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(4093),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4091),
    [anon_sym_LBRACE] = ACTIONS(4093),
    [anon_sym_LT_AT] = ACTIONS(4093),
    [anon_sym_LT_AT_AT] = ACTIONS(4093),
    [anon_sym_DOT] = ACTIONS(4093),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4091),
    [anon_sym_new] = ACTIONS(4093),
    [anon_sym_with] = ACTIONS(4093),
    [anon_sym_return_BANG] = ACTIONS(4091),
    [anon_sym_yield] = ACTIONS(4093),
    [anon_sym_yield_BANG] = ACTIONS(4091),
    [anon_sym_lazy] = ACTIONS(4093),
    [anon_sym_assert] = ACTIONS(4093),
    [anon_sym_upcast] = ACTIONS(4093),
    [anon_sym_downcast] = ACTIONS(4093),
    [anon_sym_COLON_GT] = ACTIONS(4091),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4091),
    [anon_sym_for] = ACTIONS(4093),
    [anon_sym_while] = ACTIONS(4093),
    [anon_sym_if] = ACTIONS(4093),
    [anon_sym_fun] = ACTIONS(4093),
    [anon_sym_try] = ACTIONS(4093),
    [anon_sym_match] = ACTIONS(4093),
    [anon_sym_match_BANG] = ACTIONS(4091),
    [anon_sym_function] = ACTIONS(4093),
    [anon_sym_LT_DASH] = ACTIONS(4093),
    [anon_sym_DOT_LBRACK] = ACTIONS(4091),
    [anon_sym_LT] = ACTIONS(4091),
    [anon_sym_use] = ACTIONS(4093),
    [anon_sym_use_BANG] = ACTIONS(4091),
    [anon_sym_do_BANG] = ACTIONS(4091),
    [anon_sym_begin] = ACTIONS(4093),
    [anon_sym_LPAREN2] = ACTIONS(4093),
    [anon_sym_DOT_DOT2] = ACTIONS(4091),
    [anon_sym_default] = ACTIONS(4093),
    [anon_sym_or] = ACTIONS(4093),
    [anon_sym_static] = ACTIONS(4093),
    [anon_sym_member] = ACTIONS(4093),
    [anon_sym_interface] = ACTIONS(4093),
    [anon_sym_abstract] = ACTIONS(4093),
    [anon_sym_val] = ACTIONS(4093),
    [anon_sym_override] = ACTIONS(4093),
    [aux_sym_char_token1] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4093),
    [anon_sym_DQUOTE] = ACTIONS(4093),
    [anon_sym_AT_DQUOTE] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [sym_bool] = ACTIONS(4093),
    [sym_unit] = ACTIONS(4091),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4093),
    [sym_op_identifier] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS_DOT] = ACTIONS(4093),
    [anon_sym_DASH_DOT] = ACTIONS(4093),
    [anon_sym_PERCENT] = ACTIONS(4093),
    [anon_sym_AMP_AMP] = ACTIONS(4093),
    [anon_sym_TILDE] = ACTIONS(4091),
    [aux_sym_prefix_op_token1] = ACTIONS(4093),
    [aux_sym_infix_op_token1] = ACTIONS(4091),
    [aux_sym_infix_op_token2] = ACTIONS(4093),
    [anon_sym_PIPE_PIPE] = ACTIONS(4093),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_COLON_EQ] = ACTIONS(4091),
    [anon_sym_DOLLAR] = ACTIONS(4093),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4093),
    [sym_int] = ACTIONS(4093),
    [sym_xint] = ACTIONS(4091),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4091),
    [sym__newline] = ACTIONS(4091),
    [sym__dedent] = ACTIONS(4091),
  },
  [1968] = {
    [sym_block_comment] = STATE(1968),
    [sym_compiler_directive_decl] = STATE(1968),
    [sym_fsi_directive_decl] = STATE(1968),
    [sym_preproc_line] = STATE(1968),
    [sym_identifier] = ACTIONS(3889),
    [anon_sym_EQ] = ACTIONS(3887),
    [anon_sym_LBRACK_LT] = ACTIONS(3887),
    [anon_sym_COLON] = ACTIONS(3889),
    [anon_sym_return] = ACTIONS(3889),
    [anon_sym_do] = ACTIONS(3889),
    [anon_sym_let] = ACTIONS(3889),
    [anon_sym_let_BANG] = ACTIONS(3887),
    [aux_sym_access_modifier_token1] = ACTIONS(3887),
    [anon_sym_LPAREN] = ACTIONS(3889),
    [anon_sym_COMMA] = ACTIONS(3887),
    [anon_sym_null] = ACTIONS(3889),
    [anon_sym_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_COLON] = ACTIONS(3887),
    [anon_sym_AMP] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3887),
    [anon_sym_LBRACE] = ACTIONS(3889),
    [anon_sym_LT_AT] = ACTIONS(3889),
    [anon_sym_LT_AT_AT] = ACTIONS(3889),
    [anon_sym_DOT] = ACTIONS(3889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [anon_sym_new] = ACTIONS(3889),
    [anon_sym_with] = ACTIONS(3889),
    [anon_sym_return_BANG] = ACTIONS(3887),
    [anon_sym_yield] = ACTIONS(3889),
    [anon_sym_yield_BANG] = ACTIONS(3887),
    [anon_sym_lazy] = ACTIONS(3889),
    [anon_sym_assert] = ACTIONS(3889),
    [anon_sym_upcast] = ACTIONS(3889),
    [anon_sym_downcast] = ACTIONS(3889),
    [anon_sym_COLON_GT] = ACTIONS(3887),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3887),
    [anon_sym_for] = ACTIONS(3889),
    [anon_sym_while] = ACTIONS(3889),
    [anon_sym_if] = ACTIONS(3889),
    [anon_sym_fun] = ACTIONS(3889),
    [anon_sym_try] = ACTIONS(3889),
    [anon_sym_match] = ACTIONS(3889),
    [anon_sym_match_BANG] = ACTIONS(3887),
    [anon_sym_function] = ACTIONS(3889),
    [anon_sym_LT_DASH] = ACTIONS(3889),
    [anon_sym_DOT_LBRACK] = ACTIONS(3887),
    [anon_sym_LT] = ACTIONS(3887),
    [anon_sym_use] = ACTIONS(3889),
    [anon_sym_use_BANG] = ACTIONS(3887),
    [anon_sym_do_BANG] = ACTIONS(3887),
    [anon_sym_begin] = ACTIONS(3889),
    [anon_sym_LPAREN2] = ACTIONS(3889),
    [anon_sym_default] = ACTIONS(3889),
    [anon_sym_or] = ACTIONS(3889),
    [anon_sym_static] = ACTIONS(3889),
    [anon_sym_member] = ACTIONS(3889),
    [anon_sym_interface] = ACTIONS(3889),
    [anon_sym_abstract] = ACTIONS(3889),
    [anon_sym_val] = ACTIONS(3889),
    [anon_sym_override] = ACTIONS(3889),
    [anon_sym_inherit] = ACTIONS(3889),
    [aux_sym_char_token1] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3889),
    [anon_sym_DQUOTE] = ACTIONS(3889),
    [anon_sym_AT_DQUOTE] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [sym_bool] = ACTIONS(3889),
    [sym_unit] = ACTIONS(3887),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3889),
    [sym_op_identifier] = ACTIONS(3889),
    [anon_sym_PLUS] = ACTIONS(3889),
    [anon_sym_DASH] = ACTIONS(3889),
    [anon_sym_PLUS_DOT] = ACTIONS(3889),
    [anon_sym_DASH_DOT] = ACTIONS(3889),
    [anon_sym_PERCENT] = ACTIONS(3889),
    [anon_sym_AMP_AMP] = ACTIONS(3889),
    [anon_sym_TILDE] = ACTIONS(3887),
    [aux_sym_prefix_op_token1] = ACTIONS(3889),
    [aux_sym_infix_op_token1] = ACTIONS(3887),
    [aux_sym_infix_op_token2] = ACTIONS(3889),
    [anon_sym_PIPE_PIPE] = ACTIONS(3889),
    [anon_sym_BANG_EQ] = ACTIONS(3889),
    [anon_sym_COLON_EQ] = ACTIONS(3887),
    [anon_sym_DOLLAR] = ACTIONS(3889),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3889),
    [sym_int] = ACTIONS(3889),
    [sym_xint] = ACTIONS(3887),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3887),
    [anon_sym_POUNDendif] = ACTIONS(3887),
    [sym__newline] = ACTIONS(3887),
  },
  [1969] = {
    [sym_block_comment] = STATE(1969),
    [sym_compiler_directive_decl] = STATE(1969),
    [sym_fsi_directive_decl] = STATE(1969),
    [sym_preproc_line] = STATE(1969),
    [sym_identifier] = ACTIONS(4064),
    [anon_sym_EQ] = ACTIONS(4062),
    [anon_sym_LBRACK_LT] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4064),
    [anon_sym_return] = ACTIONS(4064),
    [anon_sym_do] = ACTIONS(4064),
    [anon_sym_and] = ACTIONS(4064),
    [anon_sym_let] = ACTIONS(4064),
    [anon_sym_let_BANG] = ACTIONS(4062),
    [aux_sym_access_modifier_token1] = ACTIONS(4062),
    [anon_sym_LPAREN] = ACTIONS(4064),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_null] = ACTIONS(4064),
    [anon_sym_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_COLON] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4062),
    [anon_sym_LBRACE] = ACTIONS(4064),
    [anon_sym_LT_AT] = ACTIONS(4064),
    [anon_sym_LT_AT_AT] = ACTIONS(4064),
    [anon_sym_DOT] = ACTIONS(4064),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4062),
    [anon_sym_new] = ACTIONS(4064),
    [anon_sym_with] = ACTIONS(4064),
    [anon_sym_return_BANG] = ACTIONS(4062),
    [anon_sym_yield] = ACTIONS(4064),
    [anon_sym_yield_BANG] = ACTIONS(4062),
    [anon_sym_lazy] = ACTIONS(4064),
    [anon_sym_assert] = ACTIONS(4064),
    [anon_sym_upcast] = ACTIONS(4064),
    [anon_sym_downcast] = ACTIONS(4064),
    [anon_sym_COLON_GT] = ACTIONS(4062),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4062),
    [anon_sym_for] = ACTIONS(4064),
    [anon_sym_while] = ACTIONS(4064),
    [anon_sym_if] = ACTIONS(4064),
    [anon_sym_fun] = ACTIONS(4064),
    [anon_sym_try] = ACTIONS(4064),
    [anon_sym_match] = ACTIONS(4064),
    [anon_sym_match_BANG] = ACTIONS(4062),
    [anon_sym_function] = ACTIONS(4064),
    [anon_sym_LT_DASH] = ACTIONS(4064),
    [anon_sym_DOT_LBRACK] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(4062),
    [anon_sym_use] = ACTIONS(4064),
    [anon_sym_use_BANG] = ACTIONS(4062),
    [anon_sym_do_BANG] = ACTIONS(4062),
    [anon_sym_begin] = ACTIONS(4064),
    [anon_sym_LPAREN2] = ACTIONS(4064),
    [anon_sym_default] = ACTIONS(4064),
    [anon_sym_or] = ACTIONS(4064),
    [anon_sym_static] = ACTIONS(4064),
    [anon_sym_member] = ACTIONS(4064),
    [anon_sym_interface] = ACTIONS(4064),
    [anon_sym_abstract] = ACTIONS(4064),
    [anon_sym_val] = ACTIONS(4064),
    [anon_sym_override] = ACTIONS(4064),
    [aux_sym_char_token1] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_AT_DQUOTE] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [sym_bool] = ACTIONS(4064),
    [sym_unit] = ACTIONS(4062),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4064),
    [sym_op_identifier] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4064),
    [anon_sym_DASH] = ACTIONS(4064),
    [anon_sym_PLUS_DOT] = ACTIONS(4064),
    [anon_sym_DASH_DOT] = ACTIONS(4064),
    [anon_sym_PERCENT] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_TILDE] = ACTIONS(4062),
    [aux_sym_prefix_op_token1] = ACTIONS(4064),
    [aux_sym_infix_op_token1] = ACTIONS(4062),
    [aux_sym_infix_op_token2] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_BANG_EQ] = ACTIONS(4064),
    [anon_sym_COLON_EQ] = ACTIONS(4062),
    [anon_sym_DOLLAR] = ACTIONS(4064),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4064),
    [sym_int] = ACTIONS(4064),
    [sym_xint] = ACTIONS(4062),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4062),
    [sym__newline] = ACTIONS(4062),
    [sym__dedent] = ACTIONS(4062),
  },
  [1970] = {
    [sym_block_comment] = STATE(1970),
    [sym_compiler_directive_decl] = STATE(1970),
    [sym_fsi_directive_decl] = STATE(1970),
    [sym_preproc_line] = STATE(1970),
    [sym_identifier] = ACTIONS(3863),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_LBRACK_LT] = ACTIONS(3861),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_and] = ACTIONS(3863),
    [anon_sym_let] = ACTIONS(3863),
    [anon_sym_let_BANG] = ACTIONS(3861),
    [aux_sym_access_modifier_token1] = ACTIONS(3861),
    [anon_sym_LPAREN] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3861),
    [anon_sym_null] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_COLON] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_LT_AT] = ACTIONS(3863),
    [anon_sym_LT_AT_AT] = ACTIONS(3863),
    [anon_sym_DOT] = ACTIONS(3863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3861),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_with] = ACTIONS(3863),
    [anon_sym_return_BANG] = ACTIONS(3861),
    [anon_sym_yield] = ACTIONS(3863),
    [anon_sym_yield_BANG] = ACTIONS(3861),
    [anon_sym_lazy] = ACTIONS(3863),
    [anon_sym_assert] = ACTIONS(3863),
    [anon_sym_upcast] = ACTIONS(3863),
    [anon_sym_downcast] = ACTIONS(3863),
    [anon_sym_COLON_GT] = ACTIONS(3861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_fun] = ACTIONS(3863),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_match] = ACTIONS(3863),
    [anon_sym_match_BANG] = ACTIONS(3861),
    [anon_sym_function] = ACTIONS(3863),
    [anon_sym_LT_DASH] = ACTIONS(3863),
    [anon_sym_DOT_LBRACK] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_use] = ACTIONS(3863),
    [anon_sym_use_BANG] = ACTIONS(3861),
    [anon_sym_do_BANG] = ACTIONS(3861),
    [anon_sym_begin] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(3863),
    [anon_sym_default] = ACTIONS(3863),
    [anon_sym_or] = ACTIONS(3863),
    [anon_sym_static] = ACTIONS(3863),
    [anon_sym_member] = ACTIONS(3863),
    [anon_sym_interface] = ACTIONS(3863),
    [anon_sym_abstract] = ACTIONS(3863),
    [anon_sym_val] = ACTIONS(3863),
    [anon_sym_override] = ACTIONS(3863),
    [aux_sym_char_token1] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [anon_sym_AT_DQUOTE] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [sym_bool] = ACTIONS(3863),
    [sym_unit] = ACTIONS(3861),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3863),
    [sym_op_identifier] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_DOT] = ACTIONS(3863),
    [anon_sym_DASH_DOT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3861),
    [aux_sym_prefix_op_token1] = ACTIONS(3863),
    [aux_sym_infix_op_token1] = ACTIONS(3861),
    [aux_sym_infix_op_token2] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_COLON_EQ] = ACTIONS(3861),
    [anon_sym_DOLLAR] = ACTIONS(3863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3863),
    [sym_int] = ACTIONS(3863),
    [sym_xint] = ACTIONS(3861),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3861),
    [anon_sym_POUNDendif] = ACTIONS(3861),
    [sym__newline] = ACTIONS(3861),
  },
  [1971] = {
    [sym_block_comment] = STATE(1971),
    [sym_compiler_directive_decl] = STATE(1971),
    [sym_fsi_directive_decl] = STATE(1971),
    [sym_preproc_line] = STATE(1971),
    [sym_identifier] = ACTIONS(3875),
    [anon_sym_EQ] = ACTIONS(3873),
    [anon_sym_LBRACK_LT] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(3875),
    [anon_sym_return] = ACTIONS(3875),
    [anon_sym_do] = ACTIONS(3875),
    [anon_sym_and] = ACTIONS(3875),
    [anon_sym_let] = ACTIONS(3875),
    [anon_sym_let_BANG] = ACTIONS(3873),
    [aux_sym_access_modifier_token1] = ACTIONS(3873),
    [anon_sym_LPAREN] = ACTIONS(3875),
    [anon_sym_COMMA] = ACTIONS(3873),
    [anon_sym_null] = ACTIONS(3875),
    [anon_sym_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_COLON] = ACTIONS(3873),
    [anon_sym_AMP] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(3875),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3873),
    [anon_sym_LBRACE] = ACTIONS(3875),
    [anon_sym_LT_AT] = ACTIONS(3875),
    [anon_sym_LT_AT_AT] = ACTIONS(3875),
    [anon_sym_DOT] = ACTIONS(3875),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3873),
    [anon_sym_new] = ACTIONS(3875),
    [anon_sym_with] = ACTIONS(3875),
    [anon_sym_return_BANG] = ACTIONS(3873),
    [anon_sym_yield] = ACTIONS(3875),
    [anon_sym_yield_BANG] = ACTIONS(3873),
    [anon_sym_lazy] = ACTIONS(3875),
    [anon_sym_assert] = ACTIONS(3875),
    [anon_sym_upcast] = ACTIONS(3875),
    [anon_sym_downcast] = ACTIONS(3875),
    [anon_sym_COLON_GT] = ACTIONS(3873),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3873),
    [anon_sym_for] = ACTIONS(3875),
    [anon_sym_while] = ACTIONS(3875),
    [anon_sym_if] = ACTIONS(3875),
    [anon_sym_fun] = ACTIONS(3875),
    [anon_sym_try] = ACTIONS(3875),
    [anon_sym_match] = ACTIONS(3875),
    [anon_sym_match_BANG] = ACTIONS(3873),
    [anon_sym_function] = ACTIONS(3875),
    [anon_sym_LT_DASH] = ACTIONS(3875),
    [anon_sym_DOT_LBRACK] = ACTIONS(3873),
    [anon_sym_LT] = ACTIONS(3873),
    [anon_sym_use] = ACTIONS(3875),
    [anon_sym_use_BANG] = ACTIONS(3873),
    [anon_sym_do_BANG] = ACTIONS(3873),
    [anon_sym_begin] = ACTIONS(3875),
    [anon_sym_LPAREN2] = ACTIONS(3875),
    [anon_sym_default] = ACTIONS(3875),
    [anon_sym_or] = ACTIONS(3875),
    [anon_sym_static] = ACTIONS(3875),
    [anon_sym_member] = ACTIONS(3875),
    [anon_sym_interface] = ACTIONS(3875),
    [anon_sym_abstract] = ACTIONS(3875),
    [anon_sym_val] = ACTIONS(3875),
    [anon_sym_override] = ACTIONS(3875),
    [aux_sym_char_token1] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3875),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [anon_sym_AT_DQUOTE] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [sym_bool] = ACTIONS(3875),
    [sym_unit] = ACTIONS(3873),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3875),
    [sym_op_identifier] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS_DOT] = ACTIONS(3875),
    [anon_sym_DASH_DOT] = ACTIONS(3875),
    [anon_sym_PERCENT] = ACTIONS(3875),
    [anon_sym_AMP_AMP] = ACTIONS(3875),
    [anon_sym_TILDE] = ACTIONS(3873),
    [aux_sym_prefix_op_token1] = ACTIONS(3875),
    [aux_sym_infix_op_token1] = ACTIONS(3873),
    [aux_sym_infix_op_token2] = ACTIONS(3875),
    [anon_sym_PIPE_PIPE] = ACTIONS(3875),
    [anon_sym_BANG_EQ] = ACTIONS(3875),
    [anon_sym_COLON_EQ] = ACTIONS(3873),
    [anon_sym_DOLLAR] = ACTIONS(3875),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3875),
    [sym_int] = ACTIONS(3875),
    [sym_xint] = ACTIONS(3873),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3873),
    [anon_sym_POUNDendif] = ACTIONS(3873),
    [sym__newline] = ACTIONS(3873),
  },
  [1972] = {
    [sym__else_expression] = STATE(2477),
    [sym_elif_expression] = STATE(2297),
    [sym_block_comment] = STATE(1972),
    [sym_compiler_directive_decl] = STATE(1972),
    [sym_fsi_directive_decl] = STATE(1972),
    [sym_preproc_line] = STATE(1972),
    [aux_sym_if_expression_repeat1] = STATE(2026),
    [sym_identifier] = ACTIONS(3472),
    [anon_sym_EQ] = ACTIONS(3470),
    [anon_sym_GT_RBRACK] = ACTIONS(3470),
    [anon_sym_COLON] = ACTIONS(3472),
    [anon_sym_return] = ACTIONS(3472),
    [anon_sym_do] = ACTIONS(3472),
    [anon_sym_let] = ACTIONS(3472),
    [anon_sym_let_BANG] = ACTIONS(3470),
    [anon_sym_LPAREN] = ACTIONS(3472),
    [anon_sym_COMMA] = ACTIONS(3470),
    [anon_sym_null] = ACTIONS(3472),
    [anon_sym_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_COLON] = ACTIONS(3470),
    [anon_sym_AMP] = ACTIONS(3472),
    [anon_sym_LBRACK] = ACTIONS(3472),
    [anon_sym_RBRACK] = ACTIONS(3470),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3470),
    [anon_sym_LBRACE] = ACTIONS(3472),
    [anon_sym_RBRACE] = ACTIONS(3470),
    [anon_sym_LT_AT] = ACTIONS(3472),
    [anon_sym_LT_AT_AT] = ACTIONS(3472),
    [anon_sym_DOT] = ACTIONS(3472),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3470),
    [anon_sym_new] = ACTIONS(3472),
    [anon_sym_with] = ACTIONS(3472),
    [anon_sym_return_BANG] = ACTIONS(3470),
    [anon_sym_yield] = ACTIONS(3472),
    [anon_sym_yield_BANG] = ACTIONS(3470),
    [anon_sym_lazy] = ACTIONS(3472),
    [anon_sym_assert] = ACTIONS(3472),
    [anon_sym_upcast] = ACTIONS(3472),
    [anon_sym_downcast] = ACTIONS(3472),
    [anon_sym_COLON_GT] = ACTIONS(3470),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3470),
    [anon_sym_for] = ACTIONS(3472),
    [anon_sym_to] = ACTIONS(3472),
    [anon_sym_downto] = ACTIONS(3472),
    [anon_sym_while] = ACTIONS(3472),
    [anon_sym_else] = ACTIONS(4745),
    [anon_sym_elif] = ACTIONS(4747),
    [anon_sym_if] = ACTIONS(3472),
    [anon_sym_fun] = ACTIONS(3472),
    [anon_sym_try] = ACTIONS(3472),
    [anon_sym_match] = ACTIONS(3472),
    [anon_sym_match_BANG] = ACTIONS(3470),
    [anon_sym_function] = ACTIONS(3472),
    [anon_sym_LT_DASH] = ACTIONS(3472),
    [anon_sym_DOT_LBRACK] = ACTIONS(3470),
    [anon_sym_LT] = ACTIONS(3470),
    [anon_sym_use] = ACTIONS(3472),
    [anon_sym_use_BANG] = ACTIONS(3470),
    [anon_sym_do_BANG] = ACTIONS(3470),
    [anon_sym_begin] = ACTIONS(3472),
    [anon_sym_LPAREN2] = ACTIONS(3472),
    [anon_sym_DOT_DOT2] = ACTIONS(3470),
    [anon_sym_or] = ACTIONS(3472),
    [aux_sym_char_token1] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3472),
    [anon_sym_DQUOTE] = ACTIONS(3472),
    [anon_sym_AT_DQUOTE] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [sym_bool] = ACTIONS(3472),
    [sym_unit] = ACTIONS(3470),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3472),
    [sym_op_identifier] = ACTIONS(3472),
    [anon_sym_PLUS] = ACTIONS(3472),
    [anon_sym_DASH] = ACTIONS(3472),
    [anon_sym_PLUS_DOT] = ACTIONS(3472),
    [anon_sym_DASH_DOT] = ACTIONS(3472),
    [anon_sym_PERCENT] = ACTIONS(3472),
    [anon_sym_AMP_AMP] = ACTIONS(3472),
    [anon_sym_TILDE] = ACTIONS(3470),
    [aux_sym_prefix_op_token1] = ACTIONS(3472),
    [aux_sym_infix_op_token1] = ACTIONS(3470),
    [aux_sym_infix_op_token2] = ACTIONS(3472),
    [anon_sym_PIPE_PIPE] = ACTIONS(3472),
    [anon_sym_BANG_EQ] = ACTIONS(3472),
    [anon_sym_COLON_EQ] = ACTIONS(3470),
    [anon_sym_DOLLAR] = ACTIONS(3472),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3472),
    [sym_int] = ACTIONS(3472),
    [sym_xint] = ACTIONS(3470),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3470),
    [sym__newline] = ACTIONS(3470),
  },
  [1973] = {
    [sym_block_comment] = STATE(1973),
    [sym_compiler_directive_decl] = STATE(1973),
    [sym_fsi_directive_decl] = STATE(1973),
    [sym_preproc_line] = STATE(1973),
    [sym_identifier] = ACTIONS(3893),
    [anon_sym_EQ] = ACTIONS(3891),
    [anon_sym_LBRACK_LT] = ACTIONS(3891),
    [anon_sym_COLON] = ACTIONS(3893),
    [anon_sym_return] = ACTIONS(3893),
    [anon_sym_do] = ACTIONS(3893),
    [anon_sym_and] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_let_BANG] = ACTIONS(3891),
    [aux_sym_access_modifier_token1] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_COMMA] = ACTIONS(3891),
    [anon_sym_null] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_COLON] = ACTIONS(3891),
    [anon_sym_AMP] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3891),
    [anon_sym_LBRACE] = ACTIONS(3893),
    [anon_sym_LT_AT] = ACTIONS(3893),
    [anon_sym_LT_AT_AT] = ACTIONS(3893),
    [anon_sym_DOT] = ACTIONS(3893),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3891),
    [anon_sym_new] = ACTIONS(3893),
    [anon_sym_with] = ACTIONS(3893),
    [anon_sym_return_BANG] = ACTIONS(3891),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_yield_BANG] = ACTIONS(3891),
    [anon_sym_lazy] = ACTIONS(3893),
    [anon_sym_assert] = ACTIONS(3893),
    [anon_sym_upcast] = ACTIONS(3893),
    [anon_sym_downcast] = ACTIONS(3893),
    [anon_sym_COLON_GT] = ACTIONS(3891),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3891),
    [anon_sym_for] = ACTIONS(3893),
    [anon_sym_while] = ACTIONS(3893),
    [anon_sym_if] = ACTIONS(3893),
    [anon_sym_fun] = ACTIONS(3893),
    [anon_sym_try] = ACTIONS(3893),
    [anon_sym_match] = ACTIONS(3893),
    [anon_sym_match_BANG] = ACTIONS(3891),
    [anon_sym_function] = ACTIONS(3893),
    [anon_sym_LT_DASH] = ACTIONS(3893),
    [anon_sym_DOT_LBRACK] = ACTIONS(3891),
    [anon_sym_LT] = ACTIONS(3891),
    [anon_sym_use] = ACTIONS(3893),
    [anon_sym_use_BANG] = ACTIONS(3891),
    [anon_sym_do_BANG] = ACTIONS(3891),
    [anon_sym_begin] = ACTIONS(3893),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_default] = ACTIONS(3893),
    [anon_sym_or] = ACTIONS(3893),
    [anon_sym_static] = ACTIONS(3893),
    [anon_sym_member] = ACTIONS(3893),
    [anon_sym_interface] = ACTIONS(3893),
    [anon_sym_abstract] = ACTIONS(3893),
    [anon_sym_val] = ACTIONS(3893),
    [anon_sym_override] = ACTIONS(3893),
    [aux_sym_char_token1] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3893),
    [anon_sym_DQUOTE] = ACTIONS(3893),
    [anon_sym_AT_DQUOTE] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [sym_bool] = ACTIONS(3893),
    [sym_unit] = ACTIONS(3891),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3893),
    [sym_op_identifier] = ACTIONS(3893),
    [anon_sym_PLUS] = ACTIONS(3893),
    [anon_sym_DASH] = ACTIONS(3893),
    [anon_sym_PLUS_DOT] = ACTIONS(3893),
    [anon_sym_DASH_DOT] = ACTIONS(3893),
    [anon_sym_PERCENT] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_TILDE] = ACTIONS(3891),
    [aux_sym_prefix_op_token1] = ACTIONS(3893),
    [aux_sym_infix_op_token1] = ACTIONS(3891),
    [aux_sym_infix_op_token2] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [anon_sym_BANG_EQ] = ACTIONS(3893),
    [anon_sym_COLON_EQ] = ACTIONS(3891),
    [anon_sym_DOLLAR] = ACTIONS(3893),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3893),
    [sym_int] = ACTIONS(3893),
    [sym_xint] = ACTIONS(3891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3891),
    [anon_sym_POUNDendif] = ACTIONS(3891),
    [sym__newline] = ACTIONS(3891),
  },
  [1974] = {
    [sym_block_comment] = STATE(1974),
    [sym_compiler_directive_decl] = STATE(1974),
    [sym_fsi_directive_decl] = STATE(1974),
    [sym_preproc_line] = STATE(1974),
    [aux_sym_long_identifier_repeat1] = STATE(2200),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_EQ] = ACTIONS(3492),
    [anon_sym_GT_RBRACK] = ACTIONS(3492),
    [anon_sym_COLON] = ACTIONS(3494),
    [anon_sym_return] = ACTIONS(3494),
    [anon_sym_do] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_let_BANG] = ACTIONS(3492),
    [anon_sym_LPAREN] = ACTIONS(3494),
    [anon_sym_COMMA] = ACTIONS(3492),
    [anon_sym_null] = ACTIONS(3494),
    [anon_sym_QMARK] = ACTIONS(3494),
    [anon_sym_COLON_QMARK] = ACTIONS(3494),
    [anon_sym_COLON_COLON] = ACTIONS(3492),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_RBRACK] = ACTIONS(3492),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3492),
    [anon_sym_LBRACE] = ACTIONS(3494),
    [anon_sym_RBRACE] = ACTIONS(3492),
    [anon_sym_LT_AT] = ACTIONS(3494),
    [anon_sym_LT_AT_AT] = ACTIONS(3494),
    [anon_sym_DOT] = ACTIONS(4749),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3492),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_with] = ACTIONS(3494),
    [anon_sym_return_BANG] = ACTIONS(3492),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_yield_BANG] = ACTIONS(3492),
    [anon_sym_lazy] = ACTIONS(3494),
    [anon_sym_assert] = ACTIONS(3494),
    [anon_sym_upcast] = ACTIONS(3494),
    [anon_sym_downcast] = ACTIONS(3494),
    [anon_sym_COLON_GT] = ACTIONS(3492),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3492),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_to] = ACTIONS(3494),
    [anon_sym_downto] = ACTIONS(3494),
    [anon_sym_while] = ACTIONS(3494),
    [anon_sym_if] = ACTIONS(3494),
    [anon_sym_fun] = ACTIONS(3494),
    [anon_sym_DASH_GT] = ACTIONS(3494),
    [anon_sym_try] = ACTIONS(3494),
    [anon_sym_match] = ACTIONS(3494),
    [anon_sym_match_BANG] = ACTIONS(3492),
    [anon_sym_function] = ACTIONS(3494),
    [anon_sym_LT_DASH] = ACTIONS(3494),
    [anon_sym_DOT_LBRACK] = ACTIONS(3492),
    [anon_sym_LT] = ACTIONS(3492),
    [anon_sym_use] = ACTIONS(3494),
    [anon_sym_use_BANG] = ACTIONS(3492),
    [anon_sym_do_BANG] = ACTIONS(3492),
    [anon_sym_begin] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(3494),
    [anon_sym_DOT_DOT2] = ACTIONS(3492),
    [anon_sym_STAR] = ACTIONS(3494),
    [anon_sym_LT2] = ACTIONS(3494),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3492),
    [anon_sym_or] = ACTIONS(3494),
    [aux_sym_char_token1] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3494),
    [anon_sym_DQUOTE] = ACTIONS(3494),
    [anon_sym_AT_DQUOTE] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [sym_bool] = ACTIONS(3494),
    [sym_unit] = ACTIONS(3492),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3494),
    [sym_op_identifier] = ACTIONS(3494),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_PLUS_DOT] = ACTIONS(3494),
    [anon_sym_DASH_DOT] = ACTIONS(3494),
    [anon_sym_PERCENT] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_TILDE] = ACTIONS(3492),
    [aux_sym_prefix_op_token1] = ACTIONS(3494),
    [aux_sym_infix_op_token1] = ACTIONS(3492),
    [aux_sym_infix_op_token2] = ACTIONS(3494),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_COLON_EQ] = ACTIONS(3492),
    [anon_sym_DOLLAR] = ACTIONS(3494),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3494),
    [sym_int] = ACTIONS(3494),
    [sym_xint] = ACTIONS(3492),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3492),
    [sym__newline] = ACTIONS(3492),
  },
  [1975] = {
    [sym_block_comment] = STATE(1975),
    [sym_compiler_directive_decl] = STATE(1975),
    [sym_fsi_directive_decl] = STATE(1975),
    [sym_preproc_line] = STATE(1975),
    [aux_sym_long_identifier_repeat1] = STATE(1975),
    [ts_builtin_sym_end] = ACTIONS(3485),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_namespace] = ACTIONS(3487),
    [anon_sym_module] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_open] = ACTIONS(3487),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_type] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(4751),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_exception] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3485),
    [anon_sym_POUNDload] = ACTIONS(3485),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [1976] = {
    [sym_block_comment] = STATE(1976),
    [sym_compiler_directive_decl] = STATE(1976),
    [sym_fsi_directive_decl] = STATE(1976),
    [sym_preproc_line] = STATE(1976),
    [sym_identifier] = ACTIONS(3900),
    [anon_sym_EQ] = ACTIONS(3898),
    [anon_sym_LBRACK_LT] = ACTIONS(3898),
    [anon_sym_COLON] = ACTIONS(3900),
    [anon_sym_return] = ACTIONS(3900),
    [anon_sym_do] = ACTIONS(3900),
    [anon_sym_and] = ACTIONS(3900),
    [anon_sym_let] = ACTIONS(3900),
    [anon_sym_let_BANG] = ACTIONS(3898),
    [aux_sym_access_modifier_token1] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3898),
    [anon_sym_null] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_COLON] = ACTIONS(3898),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_LBRACK] = ACTIONS(3900),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3898),
    [anon_sym_LBRACE] = ACTIONS(3900),
    [anon_sym_LT_AT] = ACTIONS(3900),
    [anon_sym_LT_AT_AT] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(3900),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3898),
    [anon_sym_new] = ACTIONS(3900),
    [anon_sym_with] = ACTIONS(3900),
    [anon_sym_return_BANG] = ACTIONS(3898),
    [anon_sym_yield] = ACTIONS(3900),
    [anon_sym_yield_BANG] = ACTIONS(3898),
    [anon_sym_lazy] = ACTIONS(3900),
    [anon_sym_assert] = ACTIONS(3900),
    [anon_sym_upcast] = ACTIONS(3900),
    [anon_sym_downcast] = ACTIONS(3900),
    [anon_sym_COLON_GT] = ACTIONS(3898),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3898),
    [anon_sym_for] = ACTIONS(3900),
    [anon_sym_while] = ACTIONS(3900),
    [anon_sym_if] = ACTIONS(3900),
    [anon_sym_fun] = ACTIONS(3900),
    [anon_sym_try] = ACTIONS(3900),
    [anon_sym_match] = ACTIONS(3900),
    [anon_sym_match_BANG] = ACTIONS(3898),
    [anon_sym_function] = ACTIONS(3900),
    [anon_sym_LT_DASH] = ACTIONS(3900),
    [anon_sym_DOT_LBRACK] = ACTIONS(3898),
    [anon_sym_LT] = ACTIONS(3898),
    [anon_sym_use] = ACTIONS(3900),
    [anon_sym_use_BANG] = ACTIONS(3898),
    [anon_sym_do_BANG] = ACTIONS(3898),
    [anon_sym_begin] = ACTIONS(3900),
    [anon_sym_LPAREN2] = ACTIONS(3900),
    [anon_sym_default] = ACTIONS(3900),
    [anon_sym_or] = ACTIONS(3900),
    [anon_sym_static] = ACTIONS(3900),
    [anon_sym_member] = ACTIONS(3900),
    [anon_sym_interface] = ACTIONS(3900),
    [anon_sym_abstract] = ACTIONS(3900),
    [anon_sym_val] = ACTIONS(3900),
    [anon_sym_override] = ACTIONS(3900),
    [aux_sym_char_token1] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3900),
    [anon_sym_DQUOTE] = ACTIONS(3900),
    [anon_sym_AT_DQUOTE] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3898),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3900),
    [sym_op_identifier] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(3900),
    [anon_sym_DASH] = ACTIONS(3900),
    [anon_sym_PLUS_DOT] = ACTIONS(3900),
    [anon_sym_DASH_DOT] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(3900),
    [anon_sym_AMP_AMP] = ACTIONS(3900),
    [anon_sym_TILDE] = ACTIONS(3898),
    [aux_sym_prefix_op_token1] = ACTIONS(3900),
    [aux_sym_infix_op_token1] = ACTIONS(3898),
    [aux_sym_infix_op_token2] = ACTIONS(3900),
    [anon_sym_PIPE_PIPE] = ACTIONS(3900),
    [anon_sym_BANG_EQ] = ACTIONS(3900),
    [anon_sym_COLON_EQ] = ACTIONS(3898),
    [anon_sym_DOLLAR] = ACTIONS(3900),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3900),
    [sym_int] = ACTIONS(3900),
    [sym_xint] = ACTIONS(3898),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3898),
    [anon_sym_POUNDendif] = ACTIONS(3898),
    [sym__newline] = ACTIONS(3898),
  },
  [1977] = {
    [sym_block_comment] = STATE(1977),
    [sym_compiler_directive_decl] = STATE(1977),
    [sym_fsi_directive_decl] = STATE(1977),
    [sym_preproc_line] = STATE(1977),
    [sym_identifier] = ACTIONS(3907),
    [anon_sym_EQ] = ACTIONS(3905),
    [anon_sym_LBRACK_LT] = ACTIONS(3905),
    [anon_sym_COLON] = ACTIONS(3907),
    [anon_sym_return] = ACTIONS(3907),
    [anon_sym_do] = ACTIONS(3907),
    [anon_sym_and] = ACTIONS(3907),
    [anon_sym_let] = ACTIONS(3907),
    [anon_sym_let_BANG] = ACTIONS(3905),
    [aux_sym_access_modifier_token1] = ACTIONS(3905),
    [anon_sym_LPAREN] = ACTIONS(3907),
    [anon_sym_COMMA] = ACTIONS(3905),
    [anon_sym_null] = ACTIONS(3907),
    [anon_sym_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_COLON] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3907),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3905),
    [anon_sym_LBRACE] = ACTIONS(3907),
    [anon_sym_LT_AT] = ACTIONS(3907),
    [anon_sym_LT_AT_AT] = ACTIONS(3907),
    [anon_sym_DOT] = ACTIONS(3907),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3905),
    [anon_sym_new] = ACTIONS(3907),
    [anon_sym_with] = ACTIONS(3907),
    [anon_sym_return_BANG] = ACTIONS(3905),
    [anon_sym_yield] = ACTIONS(3907),
    [anon_sym_yield_BANG] = ACTIONS(3905),
    [anon_sym_lazy] = ACTIONS(3907),
    [anon_sym_assert] = ACTIONS(3907),
    [anon_sym_upcast] = ACTIONS(3907),
    [anon_sym_downcast] = ACTIONS(3907),
    [anon_sym_COLON_GT] = ACTIONS(3905),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3905),
    [anon_sym_for] = ACTIONS(3907),
    [anon_sym_while] = ACTIONS(3907),
    [anon_sym_if] = ACTIONS(3907),
    [anon_sym_fun] = ACTIONS(3907),
    [anon_sym_try] = ACTIONS(3907),
    [anon_sym_match] = ACTIONS(3907),
    [anon_sym_match_BANG] = ACTIONS(3905),
    [anon_sym_function] = ACTIONS(3907),
    [anon_sym_LT_DASH] = ACTIONS(3907),
    [anon_sym_DOT_LBRACK] = ACTIONS(3905),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_use] = ACTIONS(3907),
    [anon_sym_use_BANG] = ACTIONS(3905),
    [anon_sym_do_BANG] = ACTIONS(3905),
    [anon_sym_begin] = ACTIONS(3907),
    [anon_sym_LPAREN2] = ACTIONS(3907),
    [anon_sym_default] = ACTIONS(3907),
    [anon_sym_or] = ACTIONS(3907),
    [anon_sym_static] = ACTIONS(3907),
    [anon_sym_member] = ACTIONS(3907),
    [anon_sym_interface] = ACTIONS(3907),
    [anon_sym_abstract] = ACTIONS(3907),
    [anon_sym_val] = ACTIONS(3907),
    [anon_sym_override] = ACTIONS(3907),
    [aux_sym_char_token1] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3907),
    [anon_sym_DQUOTE] = ACTIONS(3907),
    [anon_sym_AT_DQUOTE] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [sym_bool] = ACTIONS(3907),
    [sym_unit] = ACTIONS(3905),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3907),
    [sym_op_identifier] = ACTIONS(3907),
    [anon_sym_PLUS] = ACTIONS(3907),
    [anon_sym_DASH] = ACTIONS(3907),
    [anon_sym_PLUS_DOT] = ACTIONS(3907),
    [anon_sym_DASH_DOT] = ACTIONS(3907),
    [anon_sym_PERCENT] = ACTIONS(3907),
    [anon_sym_AMP_AMP] = ACTIONS(3907),
    [anon_sym_TILDE] = ACTIONS(3905),
    [aux_sym_prefix_op_token1] = ACTIONS(3907),
    [aux_sym_infix_op_token1] = ACTIONS(3905),
    [aux_sym_infix_op_token2] = ACTIONS(3907),
    [anon_sym_PIPE_PIPE] = ACTIONS(3907),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_COLON_EQ] = ACTIONS(3905),
    [anon_sym_DOLLAR] = ACTIONS(3907),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3907),
    [sym_int] = ACTIONS(3907),
    [sym_xint] = ACTIONS(3905),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3905),
    [anon_sym_POUNDendif] = ACTIONS(3905),
    [sym__newline] = ACTIONS(3905),
  },
  [1978] = {
    [sym_block_comment] = STATE(1978),
    [sym_compiler_directive_decl] = STATE(1978),
    [sym_fsi_directive_decl] = STATE(1978),
    [sym_preproc_line] = STATE(1978),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_LBRACK_LT] = ACTIONS(3865),
    [anon_sym_COLON] = ACTIONS(3867),
    [anon_sym_return] = ACTIONS(3867),
    [anon_sym_do] = ACTIONS(3867),
    [anon_sym_and] = ACTIONS(3867),
    [anon_sym_let] = ACTIONS(3867),
    [anon_sym_let_BANG] = ACTIONS(3865),
    [aux_sym_access_modifier_token1] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(3867),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_null] = ACTIONS(3867),
    [anon_sym_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_COLON] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3867),
    [anon_sym_LBRACK] = ACTIONS(3867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3867),
    [anon_sym_LT_AT] = ACTIONS(3867),
    [anon_sym_LT_AT_AT] = ACTIONS(3867),
    [anon_sym_DOT] = ACTIONS(3867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3867),
    [anon_sym_with] = ACTIONS(3867),
    [anon_sym_return_BANG] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3867),
    [anon_sym_yield_BANG] = ACTIONS(3865),
    [anon_sym_lazy] = ACTIONS(3867),
    [anon_sym_assert] = ACTIONS(3867),
    [anon_sym_upcast] = ACTIONS(3867),
    [anon_sym_downcast] = ACTIONS(3867),
    [anon_sym_COLON_GT] = ACTIONS(3865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3867),
    [anon_sym_while] = ACTIONS(3867),
    [anon_sym_if] = ACTIONS(3867),
    [anon_sym_fun] = ACTIONS(3867),
    [anon_sym_try] = ACTIONS(3867),
    [anon_sym_match] = ACTIONS(3867),
    [anon_sym_match_BANG] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(3867),
    [anon_sym_DOT_LBRACK] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_use] = ACTIONS(3867),
    [anon_sym_use_BANG] = ACTIONS(3865),
    [anon_sym_do_BANG] = ACTIONS(3865),
    [anon_sym_begin] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(3867),
    [anon_sym_default] = ACTIONS(3867),
    [anon_sym_or] = ACTIONS(3867),
    [anon_sym_static] = ACTIONS(3867),
    [anon_sym_member] = ACTIONS(3867),
    [anon_sym_interface] = ACTIONS(3867),
    [anon_sym_abstract] = ACTIONS(3867),
    [anon_sym_val] = ACTIONS(3867),
    [anon_sym_override] = ACTIONS(3867),
    [aux_sym_char_token1] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3867),
    [anon_sym_DQUOTE] = ACTIONS(3867),
    [anon_sym_AT_DQUOTE] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [sym_bool] = ACTIONS(3867),
    [sym_unit] = ACTIONS(3865),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3867),
    [sym_op_identifier] = ACTIONS(3867),
    [anon_sym_PLUS] = ACTIONS(3867),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_PLUS_DOT] = ACTIONS(3867),
    [anon_sym_DASH_DOT] = ACTIONS(3867),
    [anon_sym_PERCENT] = ACTIONS(3867),
    [anon_sym_AMP_AMP] = ACTIONS(3867),
    [anon_sym_TILDE] = ACTIONS(3865),
    [aux_sym_prefix_op_token1] = ACTIONS(3867),
    [aux_sym_infix_op_token1] = ACTIONS(3865),
    [aux_sym_infix_op_token2] = ACTIONS(3867),
    [anon_sym_PIPE_PIPE] = ACTIONS(3867),
    [anon_sym_BANG_EQ] = ACTIONS(3867),
    [anon_sym_COLON_EQ] = ACTIONS(3865),
    [anon_sym_DOLLAR] = ACTIONS(3867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3867),
    [sym_int] = ACTIONS(3867),
    [sym_xint] = ACTIONS(3865),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3865),
    [sym__newline] = ACTIONS(3865),
    [sym__dedent] = ACTIONS(3865),
  },
  [1979] = {
    [sym_block_comment] = STATE(1979),
    [sym_compiler_directive_decl] = STATE(1979),
    [sym_fsi_directive_decl] = STATE(1979),
    [sym_preproc_line] = STATE(1979),
    [sym_identifier] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(4076),
    [anon_sym_LBRACK_LT] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4078),
    [anon_sym_return] = ACTIONS(4078),
    [anon_sym_do] = ACTIONS(4078),
    [anon_sym_let] = ACTIONS(4078),
    [anon_sym_let_BANG] = ACTIONS(4076),
    [aux_sym_access_modifier_token1] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_null] = ACTIONS(4078),
    [anon_sym_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(4076),
    [anon_sym_AMP] = ACTIONS(4078),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4078),
    [anon_sym_LT_AT] = ACTIONS(4078),
    [anon_sym_LT_AT_AT] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(4078),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4076),
    [anon_sym_new] = ACTIONS(4078),
    [anon_sym_with] = ACTIONS(4078),
    [anon_sym_return_BANG] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(4078),
    [anon_sym_yield_BANG] = ACTIONS(4076),
    [anon_sym_lazy] = ACTIONS(4078),
    [anon_sym_assert] = ACTIONS(4078),
    [anon_sym_upcast] = ACTIONS(4078),
    [anon_sym_downcast] = ACTIONS(4078),
    [anon_sym_COLON_GT] = ACTIONS(4076),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4076),
    [anon_sym_for] = ACTIONS(4078),
    [anon_sym_while] = ACTIONS(4078),
    [anon_sym_if] = ACTIONS(4078),
    [anon_sym_fun] = ACTIONS(4078),
    [anon_sym_try] = ACTIONS(4078),
    [anon_sym_match] = ACTIONS(4078),
    [anon_sym_match_BANG] = ACTIONS(4076),
    [anon_sym_function] = ACTIONS(4078),
    [anon_sym_LT_DASH] = ACTIONS(4078),
    [anon_sym_DOT_LBRACK] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4076),
    [anon_sym_use] = ACTIONS(4078),
    [anon_sym_use_BANG] = ACTIONS(4076),
    [anon_sym_do_BANG] = ACTIONS(4076),
    [anon_sym_begin] = ACTIONS(4078),
    [anon_sym_LPAREN2] = ACTIONS(4078),
    [anon_sym_default] = ACTIONS(4078),
    [anon_sym_or] = ACTIONS(4078),
    [anon_sym_static] = ACTIONS(4078),
    [anon_sym_member] = ACTIONS(4078),
    [anon_sym_interface] = ACTIONS(4078),
    [anon_sym_abstract] = ACTIONS(4078),
    [anon_sym_val] = ACTIONS(4078),
    [anon_sym_override] = ACTIONS(4078),
    [anon_sym_inherit] = ACTIONS(4078),
    [aux_sym_char_token1] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4078),
    [anon_sym_DQUOTE] = ACTIONS(4078),
    [anon_sym_AT_DQUOTE] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [sym_bool] = ACTIONS(4078),
    [sym_unit] = ACTIONS(4076),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4078),
    [sym_op_identifier] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(4078),
    [anon_sym_PLUS_DOT] = ACTIONS(4078),
    [anon_sym_DASH_DOT] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [anon_sym_AMP_AMP] = ACTIONS(4078),
    [anon_sym_TILDE] = ACTIONS(4076),
    [aux_sym_prefix_op_token1] = ACTIONS(4078),
    [aux_sym_infix_op_token1] = ACTIONS(4076),
    [aux_sym_infix_op_token2] = ACTIONS(4078),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_BANG_EQ] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4076),
    [anon_sym_DOLLAR] = ACTIONS(4078),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4078),
    [sym_int] = ACTIONS(4078),
    [sym_xint] = ACTIONS(4076),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4076),
    [anon_sym_POUNDendif] = ACTIONS(4076),
    [sym__newline] = ACTIONS(4076),
  },
  [1980] = {
    [sym_block_comment] = STATE(1980),
    [sym_compiler_directive_decl] = STATE(1980),
    [sym_fsi_directive_decl] = STATE(1980),
    [sym_preproc_line] = STATE(1980),
    [aux_sym_long_identifier_repeat1] = STATE(1980),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_GT_RBRACK] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_RBRACK] = ACTIONS(3485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_RBRACE] = ACTIONS(3485),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(4754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_to] = ACTIONS(3487),
    [anon_sym_downto] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_DOT_DOT2] = ACTIONS(3485),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [1981] = {
    [sym_block_comment] = STATE(1981),
    [sym_compiler_directive_decl] = STATE(1981),
    [sym_fsi_directive_decl] = STATE(1981),
    [sym_preproc_line] = STATE(1981),
    [aux_sym_type_argument_repeat1] = STATE(1981),
    [ts_builtin_sym_end] = ACTIONS(3478),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_namespace] = ACTIONS(3480),
    [anon_sym_module] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_open] = ACTIONS(3480),
    [anon_sym_LBRACK_LT] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_type] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_COLON] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_LT_DASH] = ACTIONS(3480),
    [anon_sym_DOT_LBRACK] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_or] = ACTIONS(4757),
    [anon_sym_exception] = ACTIONS(3480),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3480),
    [anon_sym_DASH_DOT] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3480),
    [aux_sym_infix_op_token1] = ACTIONS(3478),
    [aux_sym_infix_op_token2] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3480),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3478),
    [anon_sym_POUNDload] = ACTIONS(3478),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
  },
  [1982] = {
    [sym_block_comment] = STATE(1982),
    [sym_compiler_directive_decl] = STATE(1982),
    [sym_fsi_directive_decl] = STATE(1982),
    [sym_preproc_line] = STATE(1982),
    [sym_identifier] = ACTIONS(3889),
    [anon_sym_EQ] = ACTIONS(3887),
    [anon_sym_LBRACK_LT] = ACTIONS(3887),
    [anon_sym_COLON] = ACTIONS(3889),
    [anon_sym_return] = ACTIONS(3889),
    [anon_sym_do] = ACTIONS(3889),
    [anon_sym_and] = ACTIONS(3889),
    [anon_sym_let] = ACTIONS(3889),
    [anon_sym_let_BANG] = ACTIONS(3887),
    [aux_sym_access_modifier_token1] = ACTIONS(3887),
    [anon_sym_LPAREN] = ACTIONS(3889),
    [anon_sym_COMMA] = ACTIONS(3887),
    [anon_sym_null] = ACTIONS(3889),
    [anon_sym_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_COLON] = ACTIONS(3887),
    [anon_sym_AMP] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3887),
    [anon_sym_LBRACE] = ACTIONS(3889),
    [anon_sym_LT_AT] = ACTIONS(3889),
    [anon_sym_LT_AT_AT] = ACTIONS(3889),
    [anon_sym_DOT] = ACTIONS(3889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [anon_sym_new] = ACTIONS(3889),
    [anon_sym_with] = ACTIONS(3889),
    [anon_sym_return_BANG] = ACTIONS(3887),
    [anon_sym_yield] = ACTIONS(3889),
    [anon_sym_yield_BANG] = ACTIONS(3887),
    [anon_sym_lazy] = ACTIONS(3889),
    [anon_sym_assert] = ACTIONS(3889),
    [anon_sym_upcast] = ACTIONS(3889),
    [anon_sym_downcast] = ACTIONS(3889),
    [anon_sym_COLON_GT] = ACTIONS(3887),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3887),
    [anon_sym_for] = ACTIONS(3889),
    [anon_sym_while] = ACTIONS(3889),
    [anon_sym_if] = ACTIONS(3889),
    [anon_sym_fun] = ACTIONS(3889),
    [anon_sym_try] = ACTIONS(3889),
    [anon_sym_match] = ACTIONS(3889),
    [anon_sym_match_BANG] = ACTIONS(3887),
    [anon_sym_function] = ACTIONS(3889),
    [anon_sym_LT_DASH] = ACTIONS(3889),
    [anon_sym_DOT_LBRACK] = ACTIONS(3887),
    [anon_sym_LT] = ACTIONS(3887),
    [anon_sym_use] = ACTIONS(3889),
    [anon_sym_use_BANG] = ACTIONS(3887),
    [anon_sym_do_BANG] = ACTIONS(3887),
    [anon_sym_begin] = ACTIONS(3889),
    [anon_sym_LPAREN2] = ACTIONS(3889),
    [anon_sym_default] = ACTIONS(3889),
    [anon_sym_or] = ACTIONS(3889),
    [anon_sym_static] = ACTIONS(3889),
    [anon_sym_member] = ACTIONS(3889),
    [anon_sym_interface] = ACTIONS(3889),
    [anon_sym_abstract] = ACTIONS(3889),
    [anon_sym_val] = ACTIONS(3889),
    [anon_sym_override] = ACTIONS(3889),
    [aux_sym_char_token1] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3889),
    [anon_sym_DQUOTE] = ACTIONS(3889),
    [anon_sym_AT_DQUOTE] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [sym_bool] = ACTIONS(3889),
    [sym_unit] = ACTIONS(3887),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3889),
    [sym_op_identifier] = ACTIONS(3889),
    [anon_sym_PLUS] = ACTIONS(3889),
    [anon_sym_DASH] = ACTIONS(3889),
    [anon_sym_PLUS_DOT] = ACTIONS(3889),
    [anon_sym_DASH_DOT] = ACTIONS(3889),
    [anon_sym_PERCENT] = ACTIONS(3889),
    [anon_sym_AMP_AMP] = ACTIONS(3889),
    [anon_sym_TILDE] = ACTIONS(3887),
    [aux_sym_prefix_op_token1] = ACTIONS(3889),
    [aux_sym_infix_op_token1] = ACTIONS(3887),
    [aux_sym_infix_op_token2] = ACTIONS(3889),
    [anon_sym_PIPE_PIPE] = ACTIONS(3889),
    [anon_sym_BANG_EQ] = ACTIONS(3889),
    [anon_sym_COLON_EQ] = ACTIONS(3887),
    [anon_sym_DOLLAR] = ACTIONS(3889),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3889),
    [sym_int] = ACTIONS(3889),
    [sym_xint] = ACTIONS(3887),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3887),
    [sym__newline] = ACTIONS(3887),
    [sym__dedent] = ACTIONS(3887),
  },
  [1983] = {
    [sym_block_comment] = STATE(1983),
    [sym_compiler_directive_decl] = STATE(1983),
    [sym_fsi_directive_decl] = STATE(1983),
    [sym_preproc_line] = STATE(1983),
    [sym_identifier] = ACTIONS(4193),
    [anon_sym_EQ] = ACTIONS(4191),
    [anon_sym_LBRACK_LT] = ACTIONS(4191),
    [anon_sym_COLON] = ACTIONS(4193),
    [anon_sym_return] = ACTIONS(4193),
    [anon_sym_do] = ACTIONS(4193),
    [anon_sym_let] = ACTIONS(4193),
    [anon_sym_let_BANG] = ACTIONS(4191),
    [aux_sym_access_modifier_token1] = ACTIONS(4191),
    [anon_sym_LPAREN] = ACTIONS(4193),
    [anon_sym_COMMA] = ACTIONS(4191),
    [anon_sym_null] = ACTIONS(4193),
    [anon_sym_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_COLON] = ACTIONS(4191),
    [anon_sym_AMP] = ACTIONS(4193),
    [anon_sym_LBRACK] = ACTIONS(4193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4191),
    [anon_sym_LBRACE] = ACTIONS(4193),
    [anon_sym_LT_AT] = ACTIONS(4193),
    [anon_sym_LT_AT_AT] = ACTIONS(4193),
    [anon_sym_DOT] = ACTIONS(4193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4191),
    [anon_sym_new] = ACTIONS(4193),
    [anon_sym_with] = ACTIONS(4193),
    [anon_sym_return_BANG] = ACTIONS(4191),
    [anon_sym_yield] = ACTIONS(4193),
    [anon_sym_yield_BANG] = ACTIONS(4191),
    [anon_sym_lazy] = ACTIONS(4193),
    [anon_sym_assert] = ACTIONS(4193),
    [anon_sym_upcast] = ACTIONS(4193),
    [anon_sym_downcast] = ACTIONS(4193),
    [anon_sym_COLON_GT] = ACTIONS(4191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4191),
    [anon_sym_for] = ACTIONS(4193),
    [anon_sym_while] = ACTIONS(4193),
    [anon_sym_if] = ACTIONS(4193),
    [anon_sym_fun] = ACTIONS(4193),
    [anon_sym_try] = ACTIONS(4193),
    [anon_sym_match] = ACTIONS(4193),
    [anon_sym_match_BANG] = ACTIONS(4191),
    [anon_sym_function] = ACTIONS(4193),
    [anon_sym_LT_DASH] = ACTIONS(4193),
    [anon_sym_DOT_LBRACK] = ACTIONS(4191),
    [anon_sym_LT] = ACTIONS(4191),
    [anon_sym_use] = ACTIONS(4193),
    [anon_sym_use_BANG] = ACTIONS(4191),
    [anon_sym_do_BANG] = ACTIONS(4191),
    [anon_sym_begin] = ACTIONS(4193),
    [anon_sym_LPAREN2] = ACTIONS(4193),
    [anon_sym_DOT_DOT2] = ACTIONS(4191),
    [anon_sym_default] = ACTIONS(4193),
    [anon_sym_or] = ACTIONS(4193),
    [anon_sym_static] = ACTIONS(4193),
    [anon_sym_member] = ACTIONS(4193),
    [anon_sym_interface] = ACTIONS(4193),
    [anon_sym_abstract] = ACTIONS(4193),
    [anon_sym_val] = ACTIONS(4193),
    [anon_sym_override] = ACTIONS(4193),
    [aux_sym_char_token1] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4193),
    [anon_sym_DQUOTE] = ACTIONS(4193),
    [anon_sym_AT_DQUOTE] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [sym_bool] = ACTIONS(4193),
    [sym_unit] = ACTIONS(4191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4193),
    [sym_op_identifier] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4193),
    [anon_sym_DASH] = ACTIONS(4193),
    [anon_sym_PLUS_DOT] = ACTIONS(4193),
    [anon_sym_DASH_DOT] = ACTIONS(4193),
    [anon_sym_PERCENT] = ACTIONS(4193),
    [anon_sym_AMP_AMP] = ACTIONS(4193),
    [anon_sym_TILDE] = ACTIONS(4191),
    [aux_sym_prefix_op_token1] = ACTIONS(4193),
    [aux_sym_infix_op_token1] = ACTIONS(4191),
    [aux_sym_infix_op_token2] = ACTIONS(4193),
    [anon_sym_PIPE_PIPE] = ACTIONS(4193),
    [anon_sym_BANG_EQ] = ACTIONS(4193),
    [anon_sym_COLON_EQ] = ACTIONS(4191),
    [anon_sym_DOLLAR] = ACTIONS(4193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4193),
    [sym_int] = ACTIONS(4193),
    [sym_xint] = ACTIONS(4191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4191),
    [sym__newline] = ACTIONS(4191),
    [sym__dedent] = ACTIONS(4191),
  },
  [1984] = {
    [sym_block_comment] = STATE(1984),
    [sym_compiler_directive_decl] = STATE(1984),
    [sym_fsi_directive_decl] = STATE(1984),
    [sym_preproc_line] = STATE(1984),
    [sym_identifier] = ACTIONS(4197),
    [anon_sym_EQ] = ACTIONS(4195),
    [anon_sym_LBRACK_LT] = ACTIONS(4195),
    [anon_sym_COLON] = ACTIONS(4197),
    [anon_sym_return] = ACTIONS(4197),
    [anon_sym_do] = ACTIONS(4197),
    [anon_sym_let] = ACTIONS(4197),
    [anon_sym_let_BANG] = ACTIONS(4195),
    [aux_sym_access_modifier_token1] = ACTIONS(4195),
    [anon_sym_LPAREN] = ACTIONS(4197),
    [anon_sym_COMMA] = ACTIONS(4195),
    [anon_sym_null] = ACTIONS(4197),
    [anon_sym_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_COLON] = ACTIONS(4195),
    [anon_sym_AMP] = ACTIONS(4197),
    [anon_sym_LBRACK] = ACTIONS(4197),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4195),
    [anon_sym_LBRACE] = ACTIONS(4197),
    [anon_sym_LT_AT] = ACTIONS(4197),
    [anon_sym_LT_AT_AT] = ACTIONS(4197),
    [anon_sym_DOT] = ACTIONS(4197),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4195),
    [anon_sym_new] = ACTIONS(4197),
    [anon_sym_with] = ACTIONS(4197),
    [anon_sym_return_BANG] = ACTIONS(4195),
    [anon_sym_yield] = ACTIONS(4197),
    [anon_sym_yield_BANG] = ACTIONS(4195),
    [anon_sym_lazy] = ACTIONS(4197),
    [anon_sym_assert] = ACTIONS(4197),
    [anon_sym_upcast] = ACTIONS(4197),
    [anon_sym_downcast] = ACTIONS(4197),
    [anon_sym_COLON_GT] = ACTIONS(4195),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4195),
    [anon_sym_for] = ACTIONS(4197),
    [anon_sym_while] = ACTIONS(4197),
    [anon_sym_if] = ACTIONS(4197),
    [anon_sym_fun] = ACTIONS(4197),
    [anon_sym_try] = ACTIONS(4197),
    [anon_sym_match] = ACTIONS(4197),
    [anon_sym_match_BANG] = ACTIONS(4195),
    [anon_sym_function] = ACTIONS(4197),
    [anon_sym_LT_DASH] = ACTIONS(4197),
    [anon_sym_DOT_LBRACK] = ACTIONS(4195),
    [anon_sym_LT] = ACTIONS(4195),
    [anon_sym_use] = ACTIONS(4197),
    [anon_sym_use_BANG] = ACTIONS(4195),
    [anon_sym_do_BANG] = ACTIONS(4195),
    [anon_sym_begin] = ACTIONS(4197),
    [anon_sym_LPAREN2] = ACTIONS(4197),
    [anon_sym_DOT_DOT2] = ACTIONS(4195),
    [anon_sym_default] = ACTIONS(4197),
    [anon_sym_or] = ACTIONS(4197),
    [anon_sym_static] = ACTIONS(4197),
    [anon_sym_member] = ACTIONS(4197),
    [anon_sym_interface] = ACTIONS(4197),
    [anon_sym_abstract] = ACTIONS(4197),
    [anon_sym_val] = ACTIONS(4197),
    [anon_sym_override] = ACTIONS(4197),
    [aux_sym_char_token1] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4197),
    [anon_sym_DQUOTE] = ACTIONS(4197),
    [anon_sym_AT_DQUOTE] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [sym_bool] = ACTIONS(4197),
    [sym_unit] = ACTIONS(4195),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4197),
    [sym_op_identifier] = ACTIONS(4197),
    [anon_sym_PLUS] = ACTIONS(4197),
    [anon_sym_DASH] = ACTIONS(4197),
    [anon_sym_PLUS_DOT] = ACTIONS(4197),
    [anon_sym_DASH_DOT] = ACTIONS(4197),
    [anon_sym_PERCENT] = ACTIONS(4197),
    [anon_sym_AMP_AMP] = ACTIONS(4197),
    [anon_sym_TILDE] = ACTIONS(4195),
    [aux_sym_prefix_op_token1] = ACTIONS(4197),
    [aux_sym_infix_op_token1] = ACTIONS(4195),
    [aux_sym_infix_op_token2] = ACTIONS(4197),
    [anon_sym_PIPE_PIPE] = ACTIONS(4197),
    [anon_sym_BANG_EQ] = ACTIONS(4197),
    [anon_sym_COLON_EQ] = ACTIONS(4195),
    [anon_sym_DOLLAR] = ACTIONS(4197),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4197),
    [sym_int] = ACTIONS(4197),
    [sym_xint] = ACTIONS(4195),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4195),
    [sym__newline] = ACTIONS(4195),
    [sym__dedent] = ACTIONS(4195),
  },
  [1985] = {
    [sym_block_comment] = STATE(1985),
    [sym_compiler_directive_decl] = STATE(1985),
    [sym_fsi_directive_decl] = STATE(1985),
    [sym_preproc_line] = STATE(1985),
    [sym_identifier] = ACTIONS(3917),
    [anon_sym_EQ] = ACTIONS(3915),
    [anon_sym_LBRACK_LT] = ACTIONS(3915),
    [anon_sym_COLON] = ACTIONS(3917),
    [anon_sym_return] = ACTIONS(3917),
    [anon_sym_do] = ACTIONS(3917),
    [anon_sym_and] = ACTIONS(3917),
    [anon_sym_let] = ACTIONS(3917),
    [anon_sym_let_BANG] = ACTIONS(3915),
    [aux_sym_access_modifier_token1] = ACTIONS(3915),
    [anon_sym_LPAREN] = ACTIONS(3917),
    [anon_sym_COMMA] = ACTIONS(3915),
    [anon_sym_null] = ACTIONS(3917),
    [anon_sym_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_COLON] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(3917),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3915),
    [anon_sym_LBRACE] = ACTIONS(3917),
    [anon_sym_LT_AT] = ACTIONS(3917),
    [anon_sym_LT_AT_AT] = ACTIONS(3917),
    [anon_sym_DOT] = ACTIONS(3917),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3915),
    [anon_sym_new] = ACTIONS(3917),
    [anon_sym_with] = ACTIONS(3917),
    [anon_sym_return_BANG] = ACTIONS(3915),
    [anon_sym_yield] = ACTIONS(3917),
    [anon_sym_yield_BANG] = ACTIONS(3915),
    [anon_sym_lazy] = ACTIONS(3917),
    [anon_sym_assert] = ACTIONS(3917),
    [anon_sym_upcast] = ACTIONS(3917),
    [anon_sym_downcast] = ACTIONS(3917),
    [anon_sym_COLON_GT] = ACTIONS(3915),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3915),
    [anon_sym_for] = ACTIONS(3917),
    [anon_sym_while] = ACTIONS(3917),
    [anon_sym_if] = ACTIONS(3917),
    [anon_sym_fun] = ACTIONS(3917),
    [anon_sym_try] = ACTIONS(3917),
    [anon_sym_match] = ACTIONS(3917),
    [anon_sym_match_BANG] = ACTIONS(3915),
    [anon_sym_function] = ACTIONS(3917),
    [anon_sym_LT_DASH] = ACTIONS(3917),
    [anon_sym_DOT_LBRACK] = ACTIONS(3915),
    [anon_sym_LT] = ACTIONS(3915),
    [anon_sym_use] = ACTIONS(3917),
    [anon_sym_use_BANG] = ACTIONS(3915),
    [anon_sym_do_BANG] = ACTIONS(3915),
    [anon_sym_begin] = ACTIONS(3917),
    [anon_sym_LPAREN2] = ACTIONS(3917),
    [anon_sym_default] = ACTIONS(3917),
    [anon_sym_or] = ACTIONS(3917),
    [anon_sym_static] = ACTIONS(3917),
    [anon_sym_member] = ACTIONS(3917),
    [anon_sym_interface] = ACTIONS(3917),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_val] = ACTIONS(3917),
    [anon_sym_override] = ACTIONS(3917),
    [aux_sym_char_token1] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_AT_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [sym_bool] = ACTIONS(3917),
    [sym_unit] = ACTIONS(3915),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3917),
    [sym_op_identifier] = ACTIONS(3917),
    [anon_sym_PLUS] = ACTIONS(3917),
    [anon_sym_DASH] = ACTIONS(3917),
    [anon_sym_PLUS_DOT] = ACTIONS(3917),
    [anon_sym_DASH_DOT] = ACTIONS(3917),
    [anon_sym_PERCENT] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_TILDE] = ACTIONS(3915),
    [aux_sym_prefix_op_token1] = ACTIONS(3917),
    [aux_sym_infix_op_token1] = ACTIONS(3915),
    [aux_sym_infix_op_token2] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_BANG_EQ] = ACTIONS(3917),
    [anon_sym_COLON_EQ] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3917),
    [sym_int] = ACTIONS(3917),
    [sym_xint] = ACTIONS(3915),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3915),
    [anon_sym_POUNDendif] = ACTIONS(3915),
    [sym__newline] = ACTIONS(3915),
  },
  [1986] = {
    [sym_block_comment] = STATE(1986),
    [sym_compiler_directive_decl] = STATE(1986),
    [sym_fsi_directive_decl] = STATE(1986),
    [sym_preproc_line] = STATE(1986),
    [sym_identifier] = ACTIONS(3931),
    [anon_sym_EQ] = ACTIONS(3929),
    [anon_sym_LBRACK_LT] = ACTIONS(3929),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_do] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3931),
    [anon_sym_let] = ACTIONS(3931),
    [anon_sym_let_BANG] = ACTIONS(3929),
    [aux_sym_access_modifier_token1] = ACTIONS(3929),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_COMMA] = ACTIONS(3929),
    [anon_sym_null] = ACTIONS(3931),
    [anon_sym_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_COLON] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3931),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_LT_AT] = ACTIONS(3931),
    [anon_sym_LT_AT_AT] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3931),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3929),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3931),
    [anon_sym_return_BANG] = ACTIONS(3929),
    [anon_sym_yield] = ACTIONS(3931),
    [anon_sym_yield_BANG] = ACTIONS(3929),
    [anon_sym_lazy] = ACTIONS(3931),
    [anon_sym_assert] = ACTIONS(3931),
    [anon_sym_upcast] = ACTIONS(3931),
    [anon_sym_downcast] = ACTIONS(3931),
    [anon_sym_COLON_GT] = ACTIONS(3929),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3929),
    [anon_sym_for] = ACTIONS(3931),
    [anon_sym_while] = ACTIONS(3931),
    [anon_sym_if] = ACTIONS(3931),
    [anon_sym_fun] = ACTIONS(3931),
    [anon_sym_try] = ACTIONS(3931),
    [anon_sym_match] = ACTIONS(3931),
    [anon_sym_match_BANG] = ACTIONS(3929),
    [anon_sym_function] = ACTIONS(3931),
    [anon_sym_LT_DASH] = ACTIONS(3931),
    [anon_sym_DOT_LBRACK] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_use] = ACTIONS(3931),
    [anon_sym_use_BANG] = ACTIONS(3929),
    [anon_sym_do_BANG] = ACTIONS(3929),
    [anon_sym_begin] = ACTIONS(3931),
    [anon_sym_LPAREN2] = ACTIONS(3931),
    [anon_sym_default] = ACTIONS(3931),
    [anon_sym_or] = ACTIONS(3931),
    [anon_sym_static] = ACTIONS(3931),
    [anon_sym_member] = ACTIONS(3931),
    [anon_sym_interface] = ACTIONS(3931),
    [anon_sym_abstract] = ACTIONS(3931),
    [anon_sym_val] = ACTIONS(3931),
    [anon_sym_override] = ACTIONS(3931),
    [aux_sym_char_token1] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3931),
    [anon_sym_DQUOTE] = ACTIONS(3931),
    [anon_sym_AT_DQUOTE] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [sym_bool] = ACTIONS(3931),
    [sym_unit] = ACTIONS(3929),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3931),
    [sym_op_identifier] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3931),
    [anon_sym_DASH] = ACTIONS(3931),
    [anon_sym_PLUS_DOT] = ACTIONS(3931),
    [anon_sym_DASH_DOT] = ACTIONS(3931),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_TILDE] = ACTIONS(3929),
    [aux_sym_prefix_op_token1] = ACTIONS(3931),
    [aux_sym_infix_op_token1] = ACTIONS(3929),
    [aux_sym_infix_op_token2] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_COLON_EQ] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3931),
    [sym_int] = ACTIONS(3931),
    [sym_xint] = ACTIONS(3929),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3929),
    [anon_sym_POUNDendif] = ACTIONS(3929),
    [sym__newline] = ACTIONS(3929),
  },
  [1987] = {
    [sym_block_comment] = STATE(1987),
    [sym_compiler_directive_decl] = STATE(1987),
    [sym_fsi_directive_decl] = STATE(1987),
    [sym_preproc_line] = STATE(1987),
    [sym_identifier] = ACTIONS(3942),
    [anon_sym_EQ] = ACTIONS(3940),
    [anon_sym_LBRACK_LT] = ACTIONS(3940),
    [anon_sym_COLON] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_and] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_let_BANG] = ACTIONS(3940),
    [aux_sym_access_modifier_token1] = ACTIONS(3940),
    [anon_sym_LPAREN] = ACTIONS(3942),
    [anon_sym_COMMA] = ACTIONS(3940),
    [anon_sym_null] = ACTIONS(3942),
    [anon_sym_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3940),
    [anon_sym_LBRACE] = ACTIONS(3942),
    [anon_sym_LT_AT] = ACTIONS(3942),
    [anon_sym_LT_AT_AT] = ACTIONS(3942),
    [anon_sym_DOT] = ACTIONS(3942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3940),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_with] = ACTIONS(3942),
    [anon_sym_return_BANG] = ACTIONS(3940),
    [anon_sym_yield] = ACTIONS(3942),
    [anon_sym_yield_BANG] = ACTIONS(3940),
    [anon_sym_lazy] = ACTIONS(3942),
    [anon_sym_assert] = ACTIONS(3942),
    [anon_sym_upcast] = ACTIONS(3942),
    [anon_sym_downcast] = ACTIONS(3942),
    [anon_sym_COLON_GT] = ACTIONS(3940),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3940),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_fun] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_match] = ACTIONS(3942),
    [anon_sym_match_BANG] = ACTIONS(3940),
    [anon_sym_function] = ACTIONS(3942),
    [anon_sym_LT_DASH] = ACTIONS(3942),
    [anon_sym_DOT_LBRACK] = ACTIONS(3940),
    [anon_sym_LT] = ACTIONS(3940),
    [anon_sym_use] = ACTIONS(3942),
    [anon_sym_use_BANG] = ACTIONS(3940),
    [anon_sym_do_BANG] = ACTIONS(3940),
    [anon_sym_begin] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3942),
    [anon_sym_default] = ACTIONS(3942),
    [anon_sym_or] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_member] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_abstract] = ACTIONS(3942),
    [anon_sym_val] = ACTIONS(3942),
    [anon_sym_override] = ACTIONS(3942),
    [aux_sym_char_token1] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3942),
    [anon_sym_DQUOTE] = ACTIONS(3942),
    [anon_sym_AT_DQUOTE] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [sym_bool] = ACTIONS(3942),
    [sym_unit] = ACTIONS(3940),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3942),
    [sym_op_identifier] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS_DOT] = ACTIONS(3942),
    [anon_sym_DASH_DOT] = ACTIONS(3942),
    [anon_sym_PERCENT] = ACTIONS(3942),
    [anon_sym_AMP_AMP] = ACTIONS(3942),
    [anon_sym_TILDE] = ACTIONS(3940),
    [aux_sym_prefix_op_token1] = ACTIONS(3942),
    [aux_sym_infix_op_token1] = ACTIONS(3940),
    [aux_sym_infix_op_token2] = ACTIONS(3942),
    [anon_sym_PIPE_PIPE] = ACTIONS(3942),
    [anon_sym_BANG_EQ] = ACTIONS(3942),
    [anon_sym_COLON_EQ] = ACTIONS(3940),
    [anon_sym_DOLLAR] = ACTIONS(3942),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3942),
    [sym_int] = ACTIONS(3942),
    [sym_xint] = ACTIONS(3940),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3940),
    [anon_sym_POUNDendif] = ACTIONS(3940),
    [sym__newline] = ACTIONS(3940),
  },
  [1988] = {
    [sym_block_comment] = STATE(1988),
    [sym_compiler_directive_decl] = STATE(1988),
    [sym_fsi_directive_decl] = STATE(1988),
    [sym_preproc_line] = STATE(1988),
    [sym_identifier] = ACTIONS(3966),
    [anon_sym_EQ] = ACTIONS(3964),
    [anon_sym_LBRACK_LT] = ACTIONS(3964),
    [anon_sym_COLON] = ACTIONS(3966),
    [anon_sym_return] = ACTIONS(3966),
    [anon_sym_do] = ACTIONS(3966),
    [anon_sym_and] = ACTIONS(3966),
    [anon_sym_let] = ACTIONS(3966),
    [anon_sym_let_BANG] = ACTIONS(3964),
    [aux_sym_access_modifier_token1] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COMMA] = ACTIONS(3964),
    [anon_sym_null] = ACTIONS(3966),
    [anon_sym_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(3964),
    [anon_sym_AMP] = ACTIONS(3966),
    [anon_sym_LBRACK] = ACTIONS(3966),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3964),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_LT_AT] = ACTIONS(3966),
    [anon_sym_LT_AT_AT] = ACTIONS(3966),
    [anon_sym_DOT] = ACTIONS(3966),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3964),
    [anon_sym_new] = ACTIONS(3966),
    [anon_sym_with] = ACTIONS(3966),
    [anon_sym_return_BANG] = ACTIONS(3964),
    [anon_sym_yield] = ACTIONS(3966),
    [anon_sym_yield_BANG] = ACTIONS(3964),
    [anon_sym_lazy] = ACTIONS(3966),
    [anon_sym_assert] = ACTIONS(3966),
    [anon_sym_upcast] = ACTIONS(3966),
    [anon_sym_downcast] = ACTIONS(3966),
    [anon_sym_COLON_GT] = ACTIONS(3964),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3964),
    [anon_sym_for] = ACTIONS(3966),
    [anon_sym_while] = ACTIONS(3966),
    [anon_sym_if] = ACTIONS(3966),
    [anon_sym_fun] = ACTIONS(3966),
    [anon_sym_try] = ACTIONS(3966),
    [anon_sym_match] = ACTIONS(3966),
    [anon_sym_match_BANG] = ACTIONS(3964),
    [anon_sym_function] = ACTIONS(3966),
    [anon_sym_LT_DASH] = ACTIONS(3966),
    [anon_sym_DOT_LBRACK] = ACTIONS(3964),
    [anon_sym_LT] = ACTIONS(3964),
    [anon_sym_use] = ACTIONS(3966),
    [anon_sym_use_BANG] = ACTIONS(3964),
    [anon_sym_do_BANG] = ACTIONS(3964),
    [anon_sym_begin] = ACTIONS(3966),
    [anon_sym_LPAREN2] = ACTIONS(3966),
    [anon_sym_default] = ACTIONS(3966),
    [anon_sym_or] = ACTIONS(3966),
    [anon_sym_static] = ACTIONS(3966),
    [anon_sym_member] = ACTIONS(3966),
    [anon_sym_interface] = ACTIONS(3966),
    [anon_sym_abstract] = ACTIONS(3966),
    [anon_sym_val] = ACTIONS(3966),
    [anon_sym_override] = ACTIONS(3966),
    [aux_sym_char_token1] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3966),
    [anon_sym_DQUOTE] = ACTIONS(3966),
    [anon_sym_AT_DQUOTE] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [sym_bool] = ACTIONS(3966),
    [sym_unit] = ACTIONS(3964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3966),
    [sym_op_identifier] = ACTIONS(3966),
    [anon_sym_PLUS] = ACTIONS(3966),
    [anon_sym_DASH] = ACTIONS(3966),
    [anon_sym_PLUS_DOT] = ACTIONS(3966),
    [anon_sym_DASH_DOT] = ACTIONS(3966),
    [anon_sym_PERCENT] = ACTIONS(3966),
    [anon_sym_AMP_AMP] = ACTIONS(3966),
    [anon_sym_TILDE] = ACTIONS(3964),
    [aux_sym_prefix_op_token1] = ACTIONS(3966),
    [aux_sym_infix_op_token1] = ACTIONS(3964),
    [aux_sym_infix_op_token2] = ACTIONS(3966),
    [anon_sym_PIPE_PIPE] = ACTIONS(3966),
    [anon_sym_BANG_EQ] = ACTIONS(3966),
    [anon_sym_COLON_EQ] = ACTIONS(3964),
    [anon_sym_DOLLAR] = ACTIONS(3966),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3966),
    [sym_int] = ACTIONS(3966),
    [sym_xint] = ACTIONS(3964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3964),
    [anon_sym_POUNDendif] = ACTIONS(3964),
    [sym__newline] = ACTIONS(3964),
  },
  [1989] = {
    [sym_block_comment] = STATE(1989),
    [sym_compiler_directive_decl] = STATE(1989),
    [sym_fsi_directive_decl] = STATE(1989),
    [sym_preproc_line] = STATE(1989),
    [sym_identifier] = ACTIONS(3980),
    [anon_sym_EQ] = ACTIONS(3978),
    [anon_sym_LBRACK_LT] = ACTIONS(3978),
    [anon_sym_COLON] = ACTIONS(3980),
    [anon_sym_return] = ACTIONS(3980),
    [anon_sym_do] = ACTIONS(3980),
    [anon_sym_and] = ACTIONS(3980),
    [anon_sym_let] = ACTIONS(3980),
    [anon_sym_let_BANG] = ACTIONS(3978),
    [aux_sym_access_modifier_token1] = ACTIONS(3978),
    [anon_sym_LPAREN] = ACTIONS(3980),
    [anon_sym_COMMA] = ACTIONS(3978),
    [anon_sym_null] = ACTIONS(3980),
    [anon_sym_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3978),
    [anon_sym_AMP] = ACTIONS(3980),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3978),
    [anon_sym_LBRACE] = ACTIONS(3980),
    [anon_sym_LT_AT] = ACTIONS(3980),
    [anon_sym_LT_AT_AT] = ACTIONS(3980),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3978),
    [anon_sym_new] = ACTIONS(3980),
    [anon_sym_with] = ACTIONS(3980),
    [anon_sym_return_BANG] = ACTIONS(3978),
    [anon_sym_yield] = ACTIONS(3980),
    [anon_sym_yield_BANG] = ACTIONS(3978),
    [anon_sym_lazy] = ACTIONS(3980),
    [anon_sym_assert] = ACTIONS(3980),
    [anon_sym_upcast] = ACTIONS(3980),
    [anon_sym_downcast] = ACTIONS(3980),
    [anon_sym_COLON_GT] = ACTIONS(3978),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3978),
    [anon_sym_for] = ACTIONS(3980),
    [anon_sym_while] = ACTIONS(3980),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_fun] = ACTIONS(3980),
    [anon_sym_try] = ACTIONS(3980),
    [anon_sym_match] = ACTIONS(3980),
    [anon_sym_match_BANG] = ACTIONS(3978),
    [anon_sym_function] = ACTIONS(3980),
    [anon_sym_LT_DASH] = ACTIONS(3980),
    [anon_sym_DOT_LBRACK] = ACTIONS(3978),
    [anon_sym_LT] = ACTIONS(3978),
    [anon_sym_use] = ACTIONS(3980),
    [anon_sym_use_BANG] = ACTIONS(3978),
    [anon_sym_do_BANG] = ACTIONS(3978),
    [anon_sym_begin] = ACTIONS(3980),
    [anon_sym_LPAREN2] = ACTIONS(3980),
    [anon_sym_default] = ACTIONS(3980),
    [anon_sym_or] = ACTIONS(3980),
    [anon_sym_static] = ACTIONS(3980),
    [anon_sym_member] = ACTIONS(3980),
    [anon_sym_interface] = ACTIONS(3980),
    [anon_sym_abstract] = ACTIONS(3980),
    [anon_sym_val] = ACTIONS(3980),
    [anon_sym_override] = ACTIONS(3980),
    [aux_sym_char_token1] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3980),
    [anon_sym_DQUOTE] = ACTIONS(3980),
    [anon_sym_AT_DQUOTE] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [sym_bool] = ACTIONS(3980),
    [sym_unit] = ACTIONS(3978),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3980),
    [sym_op_identifier] = ACTIONS(3980),
    [anon_sym_PLUS] = ACTIONS(3980),
    [anon_sym_DASH] = ACTIONS(3980),
    [anon_sym_PLUS_DOT] = ACTIONS(3980),
    [anon_sym_DASH_DOT] = ACTIONS(3980),
    [anon_sym_PERCENT] = ACTIONS(3980),
    [anon_sym_AMP_AMP] = ACTIONS(3980),
    [anon_sym_TILDE] = ACTIONS(3978),
    [aux_sym_prefix_op_token1] = ACTIONS(3980),
    [aux_sym_infix_op_token1] = ACTIONS(3978),
    [aux_sym_infix_op_token2] = ACTIONS(3980),
    [anon_sym_PIPE_PIPE] = ACTIONS(3980),
    [anon_sym_BANG_EQ] = ACTIONS(3980),
    [anon_sym_COLON_EQ] = ACTIONS(3978),
    [anon_sym_DOLLAR] = ACTIONS(3980),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3980),
    [sym_int] = ACTIONS(3980),
    [sym_xint] = ACTIONS(3978),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3978),
    [anon_sym_POUNDendif] = ACTIONS(3978),
    [sym__newline] = ACTIONS(3978),
  },
  [1990] = {
    [sym_block_comment] = STATE(1990),
    [sym_compiler_directive_decl] = STATE(1990),
    [sym_fsi_directive_decl] = STATE(1990),
    [sym_preproc_line] = STATE(1990),
    [sym_identifier] = ACTIONS(3984),
    [anon_sym_EQ] = ACTIONS(3982),
    [anon_sym_LBRACK_LT] = ACTIONS(3982),
    [anon_sym_COLON] = ACTIONS(3984),
    [anon_sym_return] = ACTIONS(3984),
    [anon_sym_do] = ACTIONS(3984),
    [anon_sym_and] = ACTIONS(3984),
    [anon_sym_let] = ACTIONS(3984),
    [anon_sym_let_BANG] = ACTIONS(3982),
    [aux_sym_access_modifier_token1] = ACTIONS(3982),
    [anon_sym_LPAREN] = ACTIONS(3984),
    [anon_sym_COMMA] = ACTIONS(3982),
    [anon_sym_null] = ACTIONS(3984),
    [anon_sym_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AMP] = ACTIONS(3984),
    [anon_sym_LBRACK] = ACTIONS(3984),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(3984),
    [anon_sym_LT_AT] = ACTIONS(3984),
    [anon_sym_LT_AT_AT] = ACTIONS(3984),
    [anon_sym_DOT] = ACTIONS(3984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3982),
    [anon_sym_new] = ACTIONS(3984),
    [anon_sym_with] = ACTIONS(3984),
    [anon_sym_return_BANG] = ACTIONS(3982),
    [anon_sym_yield] = ACTIONS(3984),
    [anon_sym_yield_BANG] = ACTIONS(3982),
    [anon_sym_lazy] = ACTIONS(3984),
    [anon_sym_assert] = ACTIONS(3984),
    [anon_sym_upcast] = ACTIONS(3984),
    [anon_sym_downcast] = ACTIONS(3984),
    [anon_sym_COLON_GT] = ACTIONS(3982),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3982),
    [anon_sym_for] = ACTIONS(3984),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_if] = ACTIONS(3984),
    [anon_sym_fun] = ACTIONS(3984),
    [anon_sym_try] = ACTIONS(3984),
    [anon_sym_match] = ACTIONS(3984),
    [anon_sym_match_BANG] = ACTIONS(3982),
    [anon_sym_function] = ACTIONS(3984),
    [anon_sym_LT_DASH] = ACTIONS(3984),
    [anon_sym_DOT_LBRACK] = ACTIONS(3982),
    [anon_sym_LT] = ACTIONS(3982),
    [anon_sym_use] = ACTIONS(3984),
    [anon_sym_use_BANG] = ACTIONS(3982),
    [anon_sym_do_BANG] = ACTIONS(3982),
    [anon_sym_begin] = ACTIONS(3984),
    [anon_sym_LPAREN2] = ACTIONS(3984),
    [anon_sym_default] = ACTIONS(3984),
    [anon_sym_or] = ACTIONS(3984),
    [anon_sym_static] = ACTIONS(3984),
    [anon_sym_member] = ACTIONS(3984),
    [anon_sym_interface] = ACTIONS(3984),
    [anon_sym_abstract] = ACTIONS(3984),
    [anon_sym_val] = ACTIONS(3984),
    [anon_sym_override] = ACTIONS(3984),
    [aux_sym_char_token1] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3984),
    [anon_sym_DQUOTE] = ACTIONS(3984),
    [anon_sym_AT_DQUOTE] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [sym_bool] = ACTIONS(3984),
    [sym_unit] = ACTIONS(3982),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3984),
    [sym_op_identifier] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3984),
    [anon_sym_DASH] = ACTIONS(3984),
    [anon_sym_PLUS_DOT] = ACTIONS(3984),
    [anon_sym_DASH_DOT] = ACTIONS(3984),
    [anon_sym_PERCENT] = ACTIONS(3984),
    [anon_sym_AMP_AMP] = ACTIONS(3984),
    [anon_sym_TILDE] = ACTIONS(3982),
    [aux_sym_prefix_op_token1] = ACTIONS(3984),
    [aux_sym_infix_op_token1] = ACTIONS(3982),
    [aux_sym_infix_op_token2] = ACTIONS(3984),
    [anon_sym_PIPE_PIPE] = ACTIONS(3984),
    [anon_sym_BANG_EQ] = ACTIONS(3984),
    [anon_sym_COLON_EQ] = ACTIONS(3982),
    [anon_sym_DOLLAR] = ACTIONS(3984),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3984),
    [sym_int] = ACTIONS(3984),
    [sym_xint] = ACTIONS(3982),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3982),
    [anon_sym_POUNDendif] = ACTIONS(3982),
    [sym__newline] = ACTIONS(3982),
  },
  [1991] = {
    [sym_block_comment] = STATE(1991),
    [sym_compiler_directive_decl] = STATE(1991),
    [sym_fsi_directive_decl] = STATE(1991),
    [sym_preproc_line] = STATE(1991),
    [sym_identifier] = ACTIONS(3988),
    [anon_sym_EQ] = ACTIONS(3986),
    [anon_sym_LBRACK_LT] = ACTIONS(3986),
    [anon_sym_COLON] = ACTIONS(3988),
    [anon_sym_return] = ACTIONS(3988),
    [anon_sym_do] = ACTIONS(3988),
    [anon_sym_and] = ACTIONS(3988),
    [anon_sym_let] = ACTIONS(3988),
    [anon_sym_let_BANG] = ACTIONS(3986),
    [aux_sym_access_modifier_token1] = ACTIONS(3986),
    [anon_sym_LPAREN] = ACTIONS(3988),
    [anon_sym_COMMA] = ACTIONS(3986),
    [anon_sym_null] = ACTIONS(3988),
    [anon_sym_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_COLON] = ACTIONS(3986),
    [anon_sym_AMP] = ACTIONS(3988),
    [anon_sym_LBRACK] = ACTIONS(3988),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3986),
    [anon_sym_LBRACE] = ACTIONS(3988),
    [anon_sym_LT_AT] = ACTIONS(3988),
    [anon_sym_LT_AT_AT] = ACTIONS(3988),
    [anon_sym_DOT] = ACTIONS(3988),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3986),
    [anon_sym_new] = ACTIONS(3988),
    [anon_sym_with] = ACTIONS(3988),
    [anon_sym_return_BANG] = ACTIONS(3986),
    [anon_sym_yield] = ACTIONS(3988),
    [anon_sym_yield_BANG] = ACTIONS(3986),
    [anon_sym_lazy] = ACTIONS(3988),
    [anon_sym_assert] = ACTIONS(3988),
    [anon_sym_upcast] = ACTIONS(3988),
    [anon_sym_downcast] = ACTIONS(3988),
    [anon_sym_COLON_GT] = ACTIONS(3986),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_while] = ACTIONS(3988),
    [anon_sym_if] = ACTIONS(3988),
    [anon_sym_fun] = ACTIONS(3988),
    [anon_sym_try] = ACTIONS(3988),
    [anon_sym_match] = ACTIONS(3988),
    [anon_sym_match_BANG] = ACTIONS(3986),
    [anon_sym_function] = ACTIONS(3988),
    [anon_sym_LT_DASH] = ACTIONS(3988),
    [anon_sym_DOT_LBRACK] = ACTIONS(3986),
    [anon_sym_LT] = ACTIONS(3986),
    [anon_sym_use] = ACTIONS(3988),
    [anon_sym_use_BANG] = ACTIONS(3986),
    [anon_sym_do_BANG] = ACTIONS(3986),
    [anon_sym_begin] = ACTIONS(3988),
    [anon_sym_LPAREN2] = ACTIONS(3988),
    [anon_sym_default] = ACTIONS(3988),
    [anon_sym_or] = ACTIONS(3988),
    [anon_sym_static] = ACTIONS(3988),
    [anon_sym_member] = ACTIONS(3988),
    [anon_sym_interface] = ACTIONS(3988),
    [anon_sym_abstract] = ACTIONS(3988),
    [anon_sym_val] = ACTIONS(3988),
    [anon_sym_override] = ACTIONS(3988),
    [aux_sym_char_token1] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3988),
    [anon_sym_DQUOTE] = ACTIONS(3988),
    [anon_sym_AT_DQUOTE] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [sym_bool] = ACTIONS(3988),
    [sym_unit] = ACTIONS(3986),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3988),
    [sym_op_identifier] = ACTIONS(3988),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_PLUS_DOT] = ACTIONS(3988),
    [anon_sym_DASH_DOT] = ACTIONS(3988),
    [anon_sym_PERCENT] = ACTIONS(3988),
    [anon_sym_AMP_AMP] = ACTIONS(3988),
    [anon_sym_TILDE] = ACTIONS(3986),
    [aux_sym_prefix_op_token1] = ACTIONS(3988),
    [aux_sym_infix_op_token1] = ACTIONS(3986),
    [aux_sym_infix_op_token2] = ACTIONS(3988),
    [anon_sym_PIPE_PIPE] = ACTIONS(3988),
    [anon_sym_BANG_EQ] = ACTIONS(3988),
    [anon_sym_COLON_EQ] = ACTIONS(3986),
    [anon_sym_DOLLAR] = ACTIONS(3988),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3988),
    [sym_int] = ACTIONS(3988),
    [sym_xint] = ACTIONS(3986),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3986),
    [anon_sym_POUNDendif] = ACTIONS(3986),
    [sym__newline] = ACTIONS(3986),
  },
  [1992] = {
    [sym_block_comment] = STATE(1992),
    [sym_compiler_directive_decl] = STATE(1992),
    [sym_fsi_directive_decl] = STATE(1992),
    [sym_preproc_line] = STATE(1992),
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_EQ] = ACTIONS(3990),
    [anon_sym_LBRACK_LT] = ACTIONS(3990),
    [anon_sym_COLON] = ACTIONS(3992),
    [anon_sym_return] = ACTIONS(3992),
    [anon_sym_do] = ACTIONS(3992),
    [anon_sym_and] = ACTIONS(3992),
    [anon_sym_let] = ACTIONS(3992),
    [anon_sym_let_BANG] = ACTIONS(3990),
    [aux_sym_access_modifier_token1] = ACTIONS(3990),
    [anon_sym_LPAREN] = ACTIONS(3992),
    [anon_sym_COMMA] = ACTIONS(3990),
    [anon_sym_null] = ACTIONS(3992),
    [anon_sym_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [anon_sym_AMP] = ACTIONS(3992),
    [anon_sym_LBRACK] = ACTIONS(3992),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3990),
    [anon_sym_LBRACE] = ACTIONS(3992),
    [anon_sym_LT_AT] = ACTIONS(3992),
    [anon_sym_LT_AT_AT] = ACTIONS(3992),
    [anon_sym_DOT] = ACTIONS(3992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3990),
    [anon_sym_new] = ACTIONS(3992),
    [anon_sym_with] = ACTIONS(3992),
    [anon_sym_return_BANG] = ACTIONS(3990),
    [anon_sym_yield] = ACTIONS(3992),
    [anon_sym_yield_BANG] = ACTIONS(3990),
    [anon_sym_lazy] = ACTIONS(3992),
    [anon_sym_assert] = ACTIONS(3992),
    [anon_sym_upcast] = ACTIONS(3992),
    [anon_sym_downcast] = ACTIONS(3992),
    [anon_sym_COLON_GT] = ACTIONS(3990),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3990),
    [anon_sym_for] = ACTIONS(3992),
    [anon_sym_while] = ACTIONS(3992),
    [anon_sym_if] = ACTIONS(3992),
    [anon_sym_fun] = ACTIONS(3992),
    [anon_sym_try] = ACTIONS(3992),
    [anon_sym_match] = ACTIONS(3992),
    [anon_sym_match_BANG] = ACTIONS(3990),
    [anon_sym_function] = ACTIONS(3992),
    [anon_sym_LT_DASH] = ACTIONS(3992),
    [anon_sym_DOT_LBRACK] = ACTIONS(3990),
    [anon_sym_LT] = ACTIONS(3990),
    [anon_sym_use] = ACTIONS(3992),
    [anon_sym_use_BANG] = ACTIONS(3990),
    [anon_sym_do_BANG] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_LPAREN2] = ACTIONS(3992),
    [anon_sym_default] = ACTIONS(3992),
    [anon_sym_or] = ACTIONS(3992),
    [anon_sym_static] = ACTIONS(3992),
    [anon_sym_member] = ACTIONS(3992),
    [anon_sym_interface] = ACTIONS(3992),
    [anon_sym_abstract] = ACTIONS(3992),
    [anon_sym_val] = ACTIONS(3992),
    [anon_sym_override] = ACTIONS(3992),
    [aux_sym_char_token1] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3992),
    [anon_sym_DQUOTE] = ACTIONS(3992),
    [anon_sym_AT_DQUOTE] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [sym_bool] = ACTIONS(3992),
    [sym_unit] = ACTIONS(3990),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3992),
    [sym_op_identifier] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3992),
    [anon_sym_DASH] = ACTIONS(3992),
    [anon_sym_PLUS_DOT] = ACTIONS(3992),
    [anon_sym_DASH_DOT] = ACTIONS(3992),
    [anon_sym_PERCENT] = ACTIONS(3992),
    [anon_sym_AMP_AMP] = ACTIONS(3992),
    [anon_sym_TILDE] = ACTIONS(3990),
    [aux_sym_prefix_op_token1] = ACTIONS(3992),
    [aux_sym_infix_op_token1] = ACTIONS(3990),
    [aux_sym_infix_op_token2] = ACTIONS(3992),
    [anon_sym_PIPE_PIPE] = ACTIONS(3992),
    [anon_sym_BANG_EQ] = ACTIONS(3992),
    [anon_sym_COLON_EQ] = ACTIONS(3990),
    [anon_sym_DOLLAR] = ACTIONS(3992),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3992),
    [sym_int] = ACTIONS(3992),
    [sym_xint] = ACTIONS(3990),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3990),
    [anon_sym_POUNDendif] = ACTIONS(3990),
    [sym__newline] = ACTIONS(3990),
  },
  [1993] = {
    [sym_block_comment] = STATE(1993),
    [sym_compiler_directive_decl] = STATE(1993),
    [sym_fsi_directive_decl] = STATE(1993),
    [sym_preproc_line] = STATE(1993),
    [sym_identifier] = ACTIONS(4147),
    [anon_sym_EQ] = ACTIONS(4145),
    [anon_sym_LBRACK_LT] = ACTIONS(4145),
    [anon_sym_COLON] = ACTIONS(4147),
    [anon_sym_return] = ACTIONS(4147),
    [anon_sym_do] = ACTIONS(4147),
    [anon_sym_and] = ACTIONS(4147),
    [anon_sym_let] = ACTIONS(4147),
    [anon_sym_let_BANG] = ACTIONS(4145),
    [aux_sym_access_modifier_token1] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(4147),
    [anon_sym_COMMA] = ACTIONS(4145),
    [anon_sym_null] = ACTIONS(4147),
    [anon_sym_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_COLON] = ACTIONS(4145),
    [anon_sym_AMP] = ACTIONS(4147),
    [anon_sym_LBRACK] = ACTIONS(4147),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4145),
    [anon_sym_LBRACE] = ACTIONS(4147),
    [anon_sym_LT_AT] = ACTIONS(4147),
    [anon_sym_LT_AT_AT] = ACTIONS(4147),
    [anon_sym_DOT] = ACTIONS(4147),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4145),
    [anon_sym_new] = ACTIONS(4147),
    [anon_sym_with] = ACTIONS(4147),
    [anon_sym_return_BANG] = ACTIONS(4145),
    [anon_sym_yield] = ACTIONS(4147),
    [anon_sym_yield_BANG] = ACTIONS(4145),
    [anon_sym_lazy] = ACTIONS(4147),
    [anon_sym_assert] = ACTIONS(4147),
    [anon_sym_upcast] = ACTIONS(4147),
    [anon_sym_downcast] = ACTIONS(4147),
    [anon_sym_COLON_GT] = ACTIONS(4145),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4145),
    [anon_sym_for] = ACTIONS(4147),
    [anon_sym_while] = ACTIONS(4147),
    [anon_sym_if] = ACTIONS(4147),
    [anon_sym_fun] = ACTIONS(4147),
    [anon_sym_try] = ACTIONS(4147),
    [anon_sym_match] = ACTIONS(4147),
    [anon_sym_match_BANG] = ACTIONS(4145),
    [anon_sym_function] = ACTIONS(4147),
    [anon_sym_LT_DASH] = ACTIONS(4147),
    [anon_sym_DOT_LBRACK] = ACTIONS(4145),
    [anon_sym_LT] = ACTIONS(4145),
    [anon_sym_use] = ACTIONS(4147),
    [anon_sym_use_BANG] = ACTIONS(4145),
    [anon_sym_do_BANG] = ACTIONS(4145),
    [anon_sym_begin] = ACTIONS(4147),
    [anon_sym_LPAREN2] = ACTIONS(4147),
    [anon_sym_default] = ACTIONS(4147),
    [anon_sym_or] = ACTIONS(4147),
    [anon_sym_static] = ACTIONS(4147),
    [anon_sym_member] = ACTIONS(4147),
    [anon_sym_interface] = ACTIONS(4147),
    [anon_sym_abstract] = ACTIONS(4147),
    [anon_sym_val] = ACTIONS(4147),
    [anon_sym_override] = ACTIONS(4147),
    [aux_sym_char_token1] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4147),
    [anon_sym_DQUOTE] = ACTIONS(4147),
    [anon_sym_AT_DQUOTE] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [sym_bool] = ACTIONS(4147),
    [sym_unit] = ACTIONS(4145),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4147),
    [sym_op_identifier] = ACTIONS(4147),
    [anon_sym_PLUS] = ACTIONS(4147),
    [anon_sym_DASH] = ACTIONS(4147),
    [anon_sym_PLUS_DOT] = ACTIONS(4147),
    [anon_sym_DASH_DOT] = ACTIONS(4147),
    [anon_sym_PERCENT] = ACTIONS(4147),
    [anon_sym_AMP_AMP] = ACTIONS(4147),
    [anon_sym_TILDE] = ACTIONS(4145),
    [aux_sym_prefix_op_token1] = ACTIONS(4147),
    [aux_sym_infix_op_token1] = ACTIONS(4145),
    [aux_sym_infix_op_token2] = ACTIONS(4147),
    [anon_sym_PIPE_PIPE] = ACTIONS(4147),
    [anon_sym_BANG_EQ] = ACTIONS(4147),
    [anon_sym_COLON_EQ] = ACTIONS(4145),
    [anon_sym_DOLLAR] = ACTIONS(4147),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4147),
    [sym_int] = ACTIONS(4147),
    [sym_xint] = ACTIONS(4145),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4145),
    [anon_sym_POUNDendif] = ACTIONS(4145),
    [sym__newline] = ACTIONS(4145),
  },
  [1994] = {
    [sym_block_comment] = STATE(1994),
    [sym_compiler_directive_decl] = STATE(1994),
    [sym_fsi_directive_decl] = STATE(1994),
    [sym_preproc_line] = STATE(1994),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_EQ] = ACTIONS(4199),
    [anon_sym_LBRACK_LT] = ACTIONS(4199),
    [anon_sym_COLON] = ACTIONS(4201),
    [anon_sym_return] = ACTIONS(4201),
    [anon_sym_do] = ACTIONS(4201),
    [anon_sym_let] = ACTIONS(4201),
    [anon_sym_let_BANG] = ACTIONS(4199),
    [aux_sym_access_modifier_token1] = ACTIONS(4199),
    [anon_sym_LPAREN] = ACTIONS(4201),
    [anon_sym_COMMA] = ACTIONS(4199),
    [anon_sym_null] = ACTIONS(4201),
    [anon_sym_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(4199),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_LBRACK] = ACTIONS(4201),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4199),
    [anon_sym_LBRACE] = ACTIONS(4201),
    [anon_sym_LT_AT] = ACTIONS(4201),
    [anon_sym_LT_AT_AT] = ACTIONS(4201),
    [anon_sym_DOT] = ACTIONS(4201),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4199),
    [anon_sym_new] = ACTIONS(4201),
    [anon_sym_with] = ACTIONS(4201),
    [anon_sym_return_BANG] = ACTIONS(4199),
    [anon_sym_yield] = ACTIONS(4201),
    [anon_sym_yield_BANG] = ACTIONS(4199),
    [anon_sym_lazy] = ACTIONS(4201),
    [anon_sym_assert] = ACTIONS(4201),
    [anon_sym_upcast] = ACTIONS(4201),
    [anon_sym_downcast] = ACTIONS(4201),
    [anon_sym_COLON_GT] = ACTIONS(4199),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4199),
    [anon_sym_for] = ACTIONS(4201),
    [anon_sym_while] = ACTIONS(4201),
    [anon_sym_if] = ACTIONS(4201),
    [anon_sym_fun] = ACTIONS(4201),
    [anon_sym_try] = ACTIONS(4201),
    [anon_sym_match] = ACTIONS(4201),
    [anon_sym_match_BANG] = ACTIONS(4199),
    [anon_sym_function] = ACTIONS(4201),
    [anon_sym_LT_DASH] = ACTIONS(4201),
    [anon_sym_DOT_LBRACK] = ACTIONS(4199),
    [anon_sym_LT] = ACTIONS(4199),
    [anon_sym_use] = ACTIONS(4201),
    [anon_sym_use_BANG] = ACTIONS(4199),
    [anon_sym_do_BANG] = ACTIONS(4199),
    [anon_sym_begin] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(4201),
    [anon_sym_DOT_DOT2] = ACTIONS(4199),
    [anon_sym_default] = ACTIONS(4201),
    [anon_sym_or] = ACTIONS(4201),
    [anon_sym_static] = ACTIONS(4201),
    [anon_sym_member] = ACTIONS(4201),
    [anon_sym_interface] = ACTIONS(4201),
    [anon_sym_abstract] = ACTIONS(4201),
    [anon_sym_val] = ACTIONS(4201),
    [anon_sym_override] = ACTIONS(4201),
    [aux_sym_char_token1] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4201),
    [anon_sym_DQUOTE] = ACTIONS(4201),
    [anon_sym_AT_DQUOTE] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [sym_bool] = ACTIONS(4201),
    [sym_unit] = ACTIONS(4199),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4201),
    [sym_op_identifier] = ACTIONS(4201),
    [anon_sym_PLUS] = ACTIONS(4201),
    [anon_sym_DASH] = ACTIONS(4201),
    [anon_sym_PLUS_DOT] = ACTIONS(4201),
    [anon_sym_DASH_DOT] = ACTIONS(4201),
    [anon_sym_PERCENT] = ACTIONS(4201),
    [anon_sym_AMP_AMP] = ACTIONS(4201),
    [anon_sym_TILDE] = ACTIONS(4199),
    [aux_sym_prefix_op_token1] = ACTIONS(4201),
    [aux_sym_infix_op_token1] = ACTIONS(4199),
    [aux_sym_infix_op_token2] = ACTIONS(4201),
    [anon_sym_PIPE_PIPE] = ACTIONS(4201),
    [anon_sym_BANG_EQ] = ACTIONS(4201),
    [anon_sym_COLON_EQ] = ACTIONS(4199),
    [anon_sym_DOLLAR] = ACTIONS(4201),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4201),
    [sym_int] = ACTIONS(4201),
    [sym_xint] = ACTIONS(4199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4199),
    [sym__newline] = ACTIONS(4199),
    [sym__dedent] = ACTIONS(4199),
  },
  [1995] = {
    [sym_block_comment] = STATE(1995),
    [sym_compiler_directive_decl] = STATE(1995),
    [sym_fsi_directive_decl] = STATE(1995),
    [sym_preproc_line] = STATE(1995),
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_EQ] = ACTIONS(4149),
    [anon_sym_LBRACK_LT] = ACTIONS(4149),
    [anon_sym_COLON] = ACTIONS(4151),
    [anon_sym_return] = ACTIONS(4151),
    [anon_sym_do] = ACTIONS(4151),
    [anon_sym_and] = ACTIONS(4151),
    [anon_sym_let] = ACTIONS(4151),
    [anon_sym_let_BANG] = ACTIONS(4149),
    [aux_sym_access_modifier_token1] = ACTIONS(4149),
    [anon_sym_LPAREN] = ACTIONS(4151),
    [anon_sym_COMMA] = ACTIONS(4149),
    [anon_sym_null] = ACTIONS(4151),
    [anon_sym_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_AMP] = ACTIONS(4151),
    [anon_sym_LBRACK] = ACTIONS(4151),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4149),
    [anon_sym_LBRACE] = ACTIONS(4151),
    [anon_sym_LT_AT] = ACTIONS(4151),
    [anon_sym_LT_AT_AT] = ACTIONS(4151),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4149),
    [anon_sym_new] = ACTIONS(4151),
    [anon_sym_with] = ACTIONS(4151),
    [anon_sym_return_BANG] = ACTIONS(4149),
    [anon_sym_yield] = ACTIONS(4151),
    [anon_sym_yield_BANG] = ACTIONS(4149),
    [anon_sym_lazy] = ACTIONS(4151),
    [anon_sym_assert] = ACTIONS(4151),
    [anon_sym_upcast] = ACTIONS(4151),
    [anon_sym_downcast] = ACTIONS(4151),
    [anon_sym_COLON_GT] = ACTIONS(4149),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4149),
    [anon_sym_for] = ACTIONS(4151),
    [anon_sym_while] = ACTIONS(4151),
    [anon_sym_if] = ACTIONS(4151),
    [anon_sym_fun] = ACTIONS(4151),
    [anon_sym_try] = ACTIONS(4151),
    [anon_sym_match] = ACTIONS(4151),
    [anon_sym_match_BANG] = ACTIONS(4149),
    [anon_sym_function] = ACTIONS(4151),
    [anon_sym_LT_DASH] = ACTIONS(4151),
    [anon_sym_DOT_LBRACK] = ACTIONS(4149),
    [anon_sym_LT] = ACTIONS(4149),
    [anon_sym_use] = ACTIONS(4151),
    [anon_sym_use_BANG] = ACTIONS(4149),
    [anon_sym_do_BANG] = ACTIONS(4149),
    [anon_sym_begin] = ACTIONS(4151),
    [anon_sym_LPAREN2] = ACTIONS(4151),
    [anon_sym_default] = ACTIONS(4151),
    [anon_sym_or] = ACTIONS(4151),
    [anon_sym_static] = ACTIONS(4151),
    [anon_sym_member] = ACTIONS(4151),
    [anon_sym_interface] = ACTIONS(4151),
    [anon_sym_abstract] = ACTIONS(4151),
    [anon_sym_val] = ACTIONS(4151),
    [anon_sym_override] = ACTIONS(4151),
    [aux_sym_char_token1] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4151),
    [anon_sym_DQUOTE] = ACTIONS(4151),
    [anon_sym_AT_DQUOTE] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [sym_bool] = ACTIONS(4151),
    [sym_unit] = ACTIONS(4149),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4151),
    [sym_op_identifier] = ACTIONS(4151),
    [anon_sym_PLUS] = ACTIONS(4151),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_PLUS_DOT] = ACTIONS(4151),
    [anon_sym_DASH_DOT] = ACTIONS(4151),
    [anon_sym_PERCENT] = ACTIONS(4151),
    [anon_sym_AMP_AMP] = ACTIONS(4151),
    [anon_sym_TILDE] = ACTIONS(4149),
    [aux_sym_prefix_op_token1] = ACTIONS(4151),
    [aux_sym_infix_op_token1] = ACTIONS(4149),
    [aux_sym_infix_op_token2] = ACTIONS(4151),
    [anon_sym_PIPE_PIPE] = ACTIONS(4151),
    [anon_sym_BANG_EQ] = ACTIONS(4151),
    [anon_sym_COLON_EQ] = ACTIONS(4149),
    [anon_sym_DOLLAR] = ACTIONS(4151),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4151),
    [sym_int] = ACTIONS(4151),
    [sym_xint] = ACTIONS(4149),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4149),
    [anon_sym_POUNDendif] = ACTIONS(4149),
    [sym__newline] = ACTIONS(4149),
  },
  [1996] = {
    [sym_block_comment] = STATE(1996),
    [sym_compiler_directive_decl] = STATE(1996),
    [sym_fsi_directive_decl] = STATE(1996),
    [sym_preproc_line] = STATE(1996),
    [sym_identifier] = ACTIONS(3881),
    [anon_sym_EQ] = ACTIONS(3879),
    [anon_sym_LBRACK_LT] = ACTIONS(3879),
    [anon_sym_COLON] = ACTIONS(3881),
    [anon_sym_return] = ACTIONS(3881),
    [anon_sym_do] = ACTIONS(3881),
    [anon_sym_let] = ACTIONS(3881),
    [anon_sym_let_BANG] = ACTIONS(3879),
    [aux_sym_access_modifier_token1] = ACTIONS(3879),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3879),
    [anon_sym_null] = ACTIONS(3881),
    [anon_sym_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3879),
    [anon_sym_LBRACE] = ACTIONS(3881),
    [anon_sym_LT_AT] = ACTIONS(3881),
    [anon_sym_LT_AT_AT] = ACTIONS(3881),
    [anon_sym_DOT] = ACTIONS(3881),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3879),
    [anon_sym_new] = ACTIONS(3881),
    [anon_sym_with] = ACTIONS(3881),
    [anon_sym_return_BANG] = ACTIONS(3879),
    [anon_sym_yield] = ACTIONS(3881),
    [anon_sym_yield_BANG] = ACTIONS(3879),
    [anon_sym_lazy] = ACTIONS(3881),
    [anon_sym_assert] = ACTIONS(3881),
    [anon_sym_upcast] = ACTIONS(3881),
    [anon_sym_downcast] = ACTIONS(3881),
    [anon_sym_COLON_GT] = ACTIONS(3879),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3879),
    [anon_sym_for] = ACTIONS(3881),
    [anon_sym_while] = ACTIONS(3881),
    [anon_sym_if] = ACTIONS(3881),
    [anon_sym_fun] = ACTIONS(3881),
    [anon_sym_try] = ACTIONS(3881),
    [anon_sym_match] = ACTIONS(3881),
    [anon_sym_match_BANG] = ACTIONS(3879),
    [anon_sym_function] = ACTIONS(3881),
    [anon_sym_LT_DASH] = ACTIONS(3881),
    [anon_sym_DOT_LBRACK] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_use] = ACTIONS(3881),
    [anon_sym_use_BANG] = ACTIONS(3879),
    [anon_sym_do_BANG] = ACTIONS(3879),
    [anon_sym_begin] = ACTIONS(3881),
    [anon_sym_LPAREN2] = ACTIONS(3881),
    [anon_sym_default] = ACTIONS(3881),
    [anon_sym_or] = ACTIONS(3881),
    [anon_sym_static] = ACTIONS(3881),
    [anon_sym_member] = ACTIONS(3881),
    [anon_sym_interface] = ACTIONS(3881),
    [anon_sym_abstract] = ACTIONS(3881),
    [anon_sym_val] = ACTIONS(3881),
    [anon_sym_override] = ACTIONS(3881),
    [anon_sym_inherit] = ACTIONS(3881),
    [aux_sym_char_token1] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3881),
    [anon_sym_DQUOTE] = ACTIONS(3881),
    [anon_sym_AT_DQUOTE] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [sym_bool] = ACTIONS(3881),
    [sym_unit] = ACTIONS(3879),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3881),
    [sym_op_identifier] = ACTIONS(3881),
    [anon_sym_PLUS] = ACTIONS(3881),
    [anon_sym_DASH] = ACTIONS(3881),
    [anon_sym_PLUS_DOT] = ACTIONS(3881),
    [anon_sym_DASH_DOT] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(3881),
    [anon_sym_AMP_AMP] = ACTIONS(3881),
    [anon_sym_TILDE] = ACTIONS(3879),
    [aux_sym_prefix_op_token1] = ACTIONS(3881),
    [aux_sym_infix_op_token1] = ACTIONS(3879),
    [aux_sym_infix_op_token2] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE] = ACTIONS(3881),
    [anon_sym_BANG_EQ] = ACTIONS(3881),
    [anon_sym_COLON_EQ] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3881),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3881),
    [sym_int] = ACTIONS(3881),
    [sym_xint] = ACTIONS(3879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3879),
    [anon_sym_POUNDendif] = ACTIONS(3879),
    [sym__newline] = ACTIONS(3879),
  },
  [1997] = {
    [sym_block_comment] = STATE(1997),
    [sym_compiler_directive_decl] = STATE(1997),
    [sym_fsi_directive_decl] = STATE(1997),
    [sym_preproc_line] = STATE(1997),
    [sym_identifier] = ACTIONS(4193),
    [anon_sym_EQ] = ACTIONS(4191),
    [anon_sym_LBRACK_LT] = ACTIONS(4191),
    [anon_sym_COLON] = ACTIONS(4193),
    [anon_sym_return] = ACTIONS(4193),
    [anon_sym_do] = ACTIONS(4193),
    [anon_sym_and] = ACTIONS(4193),
    [anon_sym_let] = ACTIONS(4193),
    [anon_sym_let_BANG] = ACTIONS(4191),
    [aux_sym_access_modifier_token1] = ACTIONS(4191),
    [anon_sym_LPAREN] = ACTIONS(4193),
    [anon_sym_COMMA] = ACTIONS(4191),
    [anon_sym_null] = ACTIONS(4193),
    [anon_sym_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_COLON] = ACTIONS(4191),
    [anon_sym_AMP] = ACTIONS(4193),
    [anon_sym_LBRACK] = ACTIONS(4193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4191),
    [anon_sym_LBRACE] = ACTIONS(4193),
    [anon_sym_LT_AT] = ACTIONS(4193),
    [anon_sym_LT_AT_AT] = ACTIONS(4193),
    [anon_sym_DOT] = ACTIONS(4193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4191),
    [anon_sym_new] = ACTIONS(4193),
    [anon_sym_with] = ACTIONS(4193),
    [anon_sym_return_BANG] = ACTIONS(4191),
    [anon_sym_yield] = ACTIONS(4193),
    [anon_sym_yield_BANG] = ACTIONS(4191),
    [anon_sym_lazy] = ACTIONS(4193),
    [anon_sym_assert] = ACTIONS(4193),
    [anon_sym_upcast] = ACTIONS(4193),
    [anon_sym_downcast] = ACTIONS(4193),
    [anon_sym_COLON_GT] = ACTIONS(4191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4191),
    [anon_sym_for] = ACTIONS(4193),
    [anon_sym_while] = ACTIONS(4193),
    [anon_sym_if] = ACTIONS(4193),
    [anon_sym_fun] = ACTIONS(4193),
    [anon_sym_try] = ACTIONS(4193),
    [anon_sym_match] = ACTIONS(4193),
    [anon_sym_match_BANG] = ACTIONS(4191),
    [anon_sym_function] = ACTIONS(4193),
    [anon_sym_LT_DASH] = ACTIONS(4193),
    [anon_sym_DOT_LBRACK] = ACTIONS(4191),
    [anon_sym_LT] = ACTIONS(4191),
    [anon_sym_use] = ACTIONS(4193),
    [anon_sym_use_BANG] = ACTIONS(4191),
    [anon_sym_do_BANG] = ACTIONS(4191),
    [anon_sym_begin] = ACTIONS(4193),
    [anon_sym_LPAREN2] = ACTIONS(4193),
    [anon_sym_default] = ACTIONS(4193),
    [anon_sym_or] = ACTIONS(4193),
    [anon_sym_static] = ACTIONS(4193),
    [anon_sym_member] = ACTIONS(4193),
    [anon_sym_interface] = ACTIONS(4193),
    [anon_sym_abstract] = ACTIONS(4193),
    [anon_sym_val] = ACTIONS(4193),
    [anon_sym_override] = ACTIONS(4193),
    [aux_sym_char_token1] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4193),
    [anon_sym_DQUOTE] = ACTIONS(4193),
    [anon_sym_AT_DQUOTE] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [sym_bool] = ACTIONS(4193),
    [sym_unit] = ACTIONS(4191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4193),
    [sym_op_identifier] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4193),
    [anon_sym_DASH] = ACTIONS(4193),
    [anon_sym_PLUS_DOT] = ACTIONS(4193),
    [anon_sym_DASH_DOT] = ACTIONS(4193),
    [anon_sym_PERCENT] = ACTIONS(4193),
    [anon_sym_AMP_AMP] = ACTIONS(4193),
    [anon_sym_TILDE] = ACTIONS(4191),
    [aux_sym_prefix_op_token1] = ACTIONS(4193),
    [aux_sym_infix_op_token1] = ACTIONS(4191),
    [aux_sym_infix_op_token2] = ACTIONS(4193),
    [anon_sym_PIPE_PIPE] = ACTIONS(4193),
    [anon_sym_BANG_EQ] = ACTIONS(4193),
    [anon_sym_COLON_EQ] = ACTIONS(4191),
    [anon_sym_DOLLAR] = ACTIONS(4193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4193),
    [sym_int] = ACTIONS(4193),
    [sym_xint] = ACTIONS(4191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4191),
    [anon_sym_POUNDendif] = ACTIONS(4191),
    [sym__newline] = ACTIONS(4191),
  },
  [1998] = {
    [sym_block_comment] = STATE(1998),
    [sym_compiler_directive_decl] = STATE(1998),
    [sym_fsi_directive_decl] = STATE(1998),
    [sym_preproc_line] = STATE(1998),
    [sym_identifier] = ACTIONS(4197),
    [anon_sym_EQ] = ACTIONS(4195),
    [anon_sym_LBRACK_LT] = ACTIONS(4195),
    [anon_sym_COLON] = ACTIONS(4197),
    [anon_sym_return] = ACTIONS(4197),
    [anon_sym_do] = ACTIONS(4197),
    [anon_sym_and] = ACTIONS(4197),
    [anon_sym_let] = ACTIONS(4197),
    [anon_sym_let_BANG] = ACTIONS(4195),
    [aux_sym_access_modifier_token1] = ACTIONS(4195),
    [anon_sym_LPAREN] = ACTIONS(4197),
    [anon_sym_COMMA] = ACTIONS(4195),
    [anon_sym_null] = ACTIONS(4197),
    [anon_sym_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_COLON] = ACTIONS(4195),
    [anon_sym_AMP] = ACTIONS(4197),
    [anon_sym_LBRACK] = ACTIONS(4197),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4195),
    [anon_sym_LBRACE] = ACTIONS(4197),
    [anon_sym_LT_AT] = ACTIONS(4197),
    [anon_sym_LT_AT_AT] = ACTIONS(4197),
    [anon_sym_DOT] = ACTIONS(4197),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4195),
    [anon_sym_new] = ACTIONS(4197),
    [anon_sym_with] = ACTIONS(4197),
    [anon_sym_return_BANG] = ACTIONS(4195),
    [anon_sym_yield] = ACTIONS(4197),
    [anon_sym_yield_BANG] = ACTIONS(4195),
    [anon_sym_lazy] = ACTIONS(4197),
    [anon_sym_assert] = ACTIONS(4197),
    [anon_sym_upcast] = ACTIONS(4197),
    [anon_sym_downcast] = ACTIONS(4197),
    [anon_sym_COLON_GT] = ACTIONS(4195),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4195),
    [anon_sym_for] = ACTIONS(4197),
    [anon_sym_while] = ACTIONS(4197),
    [anon_sym_if] = ACTIONS(4197),
    [anon_sym_fun] = ACTIONS(4197),
    [anon_sym_try] = ACTIONS(4197),
    [anon_sym_match] = ACTIONS(4197),
    [anon_sym_match_BANG] = ACTIONS(4195),
    [anon_sym_function] = ACTIONS(4197),
    [anon_sym_LT_DASH] = ACTIONS(4197),
    [anon_sym_DOT_LBRACK] = ACTIONS(4195),
    [anon_sym_LT] = ACTIONS(4195),
    [anon_sym_use] = ACTIONS(4197),
    [anon_sym_use_BANG] = ACTIONS(4195),
    [anon_sym_do_BANG] = ACTIONS(4195),
    [anon_sym_begin] = ACTIONS(4197),
    [anon_sym_LPAREN2] = ACTIONS(4197),
    [anon_sym_default] = ACTIONS(4197),
    [anon_sym_or] = ACTIONS(4197),
    [anon_sym_static] = ACTIONS(4197),
    [anon_sym_member] = ACTIONS(4197),
    [anon_sym_interface] = ACTIONS(4197),
    [anon_sym_abstract] = ACTIONS(4197),
    [anon_sym_val] = ACTIONS(4197),
    [anon_sym_override] = ACTIONS(4197),
    [aux_sym_char_token1] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4197),
    [anon_sym_DQUOTE] = ACTIONS(4197),
    [anon_sym_AT_DQUOTE] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [sym_bool] = ACTIONS(4197),
    [sym_unit] = ACTIONS(4195),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4197),
    [sym_op_identifier] = ACTIONS(4197),
    [anon_sym_PLUS] = ACTIONS(4197),
    [anon_sym_DASH] = ACTIONS(4197),
    [anon_sym_PLUS_DOT] = ACTIONS(4197),
    [anon_sym_DASH_DOT] = ACTIONS(4197),
    [anon_sym_PERCENT] = ACTIONS(4197),
    [anon_sym_AMP_AMP] = ACTIONS(4197),
    [anon_sym_TILDE] = ACTIONS(4195),
    [aux_sym_prefix_op_token1] = ACTIONS(4197),
    [aux_sym_infix_op_token1] = ACTIONS(4195),
    [aux_sym_infix_op_token2] = ACTIONS(4197),
    [anon_sym_PIPE_PIPE] = ACTIONS(4197),
    [anon_sym_BANG_EQ] = ACTIONS(4197),
    [anon_sym_COLON_EQ] = ACTIONS(4195),
    [anon_sym_DOLLAR] = ACTIONS(4197),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4197),
    [sym_int] = ACTIONS(4197),
    [sym_xint] = ACTIONS(4195),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4195),
    [anon_sym_POUNDendif] = ACTIONS(4195),
    [sym__newline] = ACTIONS(4195),
  },
  [1999] = {
    [sym_block_comment] = STATE(1999),
    [sym_compiler_directive_decl] = STATE(1999),
    [sym_fsi_directive_decl] = STATE(1999),
    [sym_preproc_line] = STATE(1999),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_EQ] = ACTIONS(4199),
    [anon_sym_LBRACK_LT] = ACTIONS(4199),
    [anon_sym_COLON] = ACTIONS(4201),
    [anon_sym_return] = ACTIONS(4201),
    [anon_sym_do] = ACTIONS(4201),
    [anon_sym_and] = ACTIONS(4201),
    [anon_sym_let] = ACTIONS(4201),
    [anon_sym_let_BANG] = ACTIONS(4199),
    [aux_sym_access_modifier_token1] = ACTIONS(4199),
    [anon_sym_LPAREN] = ACTIONS(4201),
    [anon_sym_COMMA] = ACTIONS(4199),
    [anon_sym_null] = ACTIONS(4201),
    [anon_sym_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(4199),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_LBRACK] = ACTIONS(4201),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4199),
    [anon_sym_LBRACE] = ACTIONS(4201),
    [anon_sym_LT_AT] = ACTIONS(4201),
    [anon_sym_LT_AT_AT] = ACTIONS(4201),
    [anon_sym_DOT] = ACTIONS(4201),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4199),
    [anon_sym_new] = ACTIONS(4201),
    [anon_sym_with] = ACTIONS(4201),
    [anon_sym_return_BANG] = ACTIONS(4199),
    [anon_sym_yield] = ACTIONS(4201),
    [anon_sym_yield_BANG] = ACTIONS(4199),
    [anon_sym_lazy] = ACTIONS(4201),
    [anon_sym_assert] = ACTIONS(4201),
    [anon_sym_upcast] = ACTIONS(4201),
    [anon_sym_downcast] = ACTIONS(4201),
    [anon_sym_COLON_GT] = ACTIONS(4199),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4199),
    [anon_sym_for] = ACTIONS(4201),
    [anon_sym_while] = ACTIONS(4201),
    [anon_sym_if] = ACTIONS(4201),
    [anon_sym_fun] = ACTIONS(4201),
    [anon_sym_try] = ACTIONS(4201),
    [anon_sym_match] = ACTIONS(4201),
    [anon_sym_match_BANG] = ACTIONS(4199),
    [anon_sym_function] = ACTIONS(4201),
    [anon_sym_LT_DASH] = ACTIONS(4201),
    [anon_sym_DOT_LBRACK] = ACTIONS(4199),
    [anon_sym_LT] = ACTIONS(4199),
    [anon_sym_use] = ACTIONS(4201),
    [anon_sym_use_BANG] = ACTIONS(4199),
    [anon_sym_do_BANG] = ACTIONS(4199),
    [anon_sym_begin] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(4201),
    [anon_sym_default] = ACTIONS(4201),
    [anon_sym_or] = ACTIONS(4201),
    [anon_sym_static] = ACTIONS(4201),
    [anon_sym_member] = ACTIONS(4201),
    [anon_sym_interface] = ACTIONS(4201),
    [anon_sym_abstract] = ACTIONS(4201),
    [anon_sym_val] = ACTIONS(4201),
    [anon_sym_override] = ACTIONS(4201),
    [aux_sym_char_token1] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4201),
    [anon_sym_DQUOTE] = ACTIONS(4201),
    [anon_sym_AT_DQUOTE] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [sym_bool] = ACTIONS(4201),
    [sym_unit] = ACTIONS(4199),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4201),
    [sym_op_identifier] = ACTIONS(4201),
    [anon_sym_PLUS] = ACTIONS(4201),
    [anon_sym_DASH] = ACTIONS(4201),
    [anon_sym_PLUS_DOT] = ACTIONS(4201),
    [anon_sym_DASH_DOT] = ACTIONS(4201),
    [anon_sym_PERCENT] = ACTIONS(4201),
    [anon_sym_AMP_AMP] = ACTIONS(4201),
    [anon_sym_TILDE] = ACTIONS(4199),
    [aux_sym_prefix_op_token1] = ACTIONS(4201),
    [aux_sym_infix_op_token1] = ACTIONS(4199),
    [aux_sym_infix_op_token2] = ACTIONS(4201),
    [anon_sym_PIPE_PIPE] = ACTIONS(4201),
    [anon_sym_BANG_EQ] = ACTIONS(4201),
    [anon_sym_COLON_EQ] = ACTIONS(4199),
    [anon_sym_DOLLAR] = ACTIONS(4201),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4201),
    [sym_int] = ACTIONS(4201),
    [sym_xint] = ACTIONS(4199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4199),
    [anon_sym_POUNDendif] = ACTIONS(4199),
    [sym__newline] = ACTIONS(4199),
  },
  [2000] = {
    [sym_block_comment] = STATE(2000),
    [sym_compiler_directive_decl] = STATE(2000),
    [sym_fsi_directive_decl] = STATE(2000),
    [sym_preproc_line] = STATE(2000),
    [sym_identifier] = ACTIONS(4216),
    [anon_sym_EQ] = ACTIONS(4214),
    [anon_sym_LBRACK_LT] = ACTIONS(4214),
    [anon_sym_COLON] = ACTIONS(4216),
    [anon_sym_return] = ACTIONS(4216),
    [anon_sym_do] = ACTIONS(4216),
    [anon_sym_and] = ACTIONS(4216),
    [anon_sym_let] = ACTIONS(4216),
    [anon_sym_let_BANG] = ACTIONS(4214),
    [aux_sym_access_modifier_token1] = ACTIONS(4214),
    [anon_sym_LPAREN] = ACTIONS(4216),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_null] = ACTIONS(4216),
    [anon_sym_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_COLON] = ACTIONS(4214),
    [anon_sym_AMP] = ACTIONS(4216),
    [anon_sym_LBRACK] = ACTIONS(4216),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4214),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_LT_AT] = ACTIONS(4216),
    [anon_sym_LT_AT_AT] = ACTIONS(4216),
    [anon_sym_DOT] = ACTIONS(4216),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4214),
    [anon_sym_new] = ACTIONS(4216),
    [anon_sym_with] = ACTIONS(4216),
    [anon_sym_return_BANG] = ACTIONS(4214),
    [anon_sym_yield] = ACTIONS(4216),
    [anon_sym_yield_BANG] = ACTIONS(4214),
    [anon_sym_lazy] = ACTIONS(4216),
    [anon_sym_assert] = ACTIONS(4216),
    [anon_sym_upcast] = ACTIONS(4216),
    [anon_sym_downcast] = ACTIONS(4216),
    [anon_sym_COLON_GT] = ACTIONS(4214),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4214),
    [anon_sym_for] = ACTIONS(4216),
    [anon_sym_while] = ACTIONS(4216),
    [anon_sym_if] = ACTIONS(4216),
    [anon_sym_fun] = ACTIONS(4216),
    [anon_sym_try] = ACTIONS(4216),
    [anon_sym_match] = ACTIONS(4216),
    [anon_sym_match_BANG] = ACTIONS(4214),
    [anon_sym_function] = ACTIONS(4216),
    [anon_sym_LT_DASH] = ACTIONS(4216),
    [anon_sym_DOT_LBRACK] = ACTIONS(4214),
    [anon_sym_LT] = ACTIONS(4214),
    [anon_sym_use] = ACTIONS(4216),
    [anon_sym_use_BANG] = ACTIONS(4214),
    [anon_sym_do_BANG] = ACTIONS(4214),
    [anon_sym_begin] = ACTIONS(4216),
    [anon_sym_LPAREN2] = ACTIONS(4216),
    [anon_sym_default] = ACTIONS(4216),
    [anon_sym_or] = ACTIONS(4216),
    [anon_sym_static] = ACTIONS(4216),
    [anon_sym_member] = ACTIONS(4216),
    [anon_sym_interface] = ACTIONS(4216),
    [anon_sym_abstract] = ACTIONS(4216),
    [anon_sym_val] = ACTIONS(4216),
    [anon_sym_override] = ACTIONS(4216),
    [aux_sym_char_token1] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4216),
    [anon_sym_DQUOTE] = ACTIONS(4216),
    [anon_sym_AT_DQUOTE] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [sym_bool] = ACTIONS(4216),
    [sym_unit] = ACTIONS(4214),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4216),
    [sym_op_identifier] = ACTIONS(4216),
    [anon_sym_PLUS] = ACTIONS(4216),
    [anon_sym_DASH] = ACTIONS(4216),
    [anon_sym_PLUS_DOT] = ACTIONS(4216),
    [anon_sym_DASH_DOT] = ACTIONS(4216),
    [anon_sym_PERCENT] = ACTIONS(4216),
    [anon_sym_AMP_AMP] = ACTIONS(4216),
    [anon_sym_TILDE] = ACTIONS(4214),
    [aux_sym_prefix_op_token1] = ACTIONS(4216),
    [aux_sym_infix_op_token1] = ACTIONS(4214),
    [aux_sym_infix_op_token2] = ACTIONS(4216),
    [anon_sym_PIPE_PIPE] = ACTIONS(4216),
    [anon_sym_BANG_EQ] = ACTIONS(4216),
    [anon_sym_COLON_EQ] = ACTIONS(4214),
    [anon_sym_DOLLAR] = ACTIONS(4216),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4216),
    [sym_int] = ACTIONS(4216),
    [sym_xint] = ACTIONS(4214),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4214),
    [anon_sym_POUNDendif] = ACTIONS(4214),
    [sym__newline] = ACTIONS(4214),
  },
  [2001] = {
    [sym_block_comment] = STATE(2001),
    [sym_compiler_directive_decl] = STATE(2001),
    [sym_fsi_directive_decl] = STATE(2001),
    [sym_preproc_line] = STATE(2001),
    [sym_identifier] = ACTIONS(4220),
    [anon_sym_EQ] = ACTIONS(4218),
    [anon_sym_LBRACK_LT] = ACTIONS(4218),
    [anon_sym_COLON] = ACTIONS(4220),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_do] = ACTIONS(4220),
    [anon_sym_and] = ACTIONS(4220),
    [anon_sym_let] = ACTIONS(4220),
    [anon_sym_let_BANG] = ACTIONS(4218),
    [aux_sym_access_modifier_token1] = ACTIONS(4218),
    [anon_sym_LPAREN] = ACTIONS(4220),
    [anon_sym_COMMA] = ACTIONS(4218),
    [anon_sym_null] = ACTIONS(4220),
    [anon_sym_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_COLON] = ACTIONS(4218),
    [anon_sym_AMP] = ACTIONS(4220),
    [anon_sym_LBRACK] = ACTIONS(4220),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(4220),
    [anon_sym_LT_AT] = ACTIONS(4220),
    [anon_sym_LT_AT_AT] = ACTIONS(4220),
    [anon_sym_DOT] = ACTIONS(4220),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4218),
    [anon_sym_new] = ACTIONS(4220),
    [anon_sym_with] = ACTIONS(4220),
    [anon_sym_return_BANG] = ACTIONS(4218),
    [anon_sym_yield] = ACTIONS(4220),
    [anon_sym_yield_BANG] = ACTIONS(4218),
    [anon_sym_lazy] = ACTIONS(4220),
    [anon_sym_assert] = ACTIONS(4220),
    [anon_sym_upcast] = ACTIONS(4220),
    [anon_sym_downcast] = ACTIONS(4220),
    [anon_sym_COLON_GT] = ACTIONS(4218),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4218),
    [anon_sym_for] = ACTIONS(4220),
    [anon_sym_while] = ACTIONS(4220),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_fun] = ACTIONS(4220),
    [anon_sym_try] = ACTIONS(4220),
    [anon_sym_match] = ACTIONS(4220),
    [anon_sym_match_BANG] = ACTIONS(4218),
    [anon_sym_function] = ACTIONS(4220),
    [anon_sym_LT_DASH] = ACTIONS(4220),
    [anon_sym_DOT_LBRACK] = ACTIONS(4218),
    [anon_sym_LT] = ACTIONS(4218),
    [anon_sym_use] = ACTIONS(4220),
    [anon_sym_use_BANG] = ACTIONS(4218),
    [anon_sym_do_BANG] = ACTIONS(4218),
    [anon_sym_begin] = ACTIONS(4220),
    [anon_sym_LPAREN2] = ACTIONS(4220),
    [anon_sym_default] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(4220),
    [anon_sym_static] = ACTIONS(4220),
    [anon_sym_member] = ACTIONS(4220),
    [anon_sym_interface] = ACTIONS(4220),
    [anon_sym_abstract] = ACTIONS(4220),
    [anon_sym_val] = ACTIONS(4220),
    [anon_sym_override] = ACTIONS(4220),
    [aux_sym_char_token1] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4220),
    [anon_sym_DQUOTE] = ACTIONS(4220),
    [anon_sym_AT_DQUOTE] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [sym_bool] = ACTIONS(4220),
    [sym_unit] = ACTIONS(4218),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4220),
    [sym_op_identifier] = ACTIONS(4220),
    [anon_sym_PLUS] = ACTIONS(4220),
    [anon_sym_DASH] = ACTIONS(4220),
    [anon_sym_PLUS_DOT] = ACTIONS(4220),
    [anon_sym_DASH_DOT] = ACTIONS(4220),
    [anon_sym_PERCENT] = ACTIONS(4220),
    [anon_sym_AMP_AMP] = ACTIONS(4220),
    [anon_sym_TILDE] = ACTIONS(4218),
    [aux_sym_prefix_op_token1] = ACTIONS(4220),
    [aux_sym_infix_op_token1] = ACTIONS(4218),
    [aux_sym_infix_op_token2] = ACTIONS(4220),
    [anon_sym_PIPE_PIPE] = ACTIONS(4220),
    [anon_sym_BANG_EQ] = ACTIONS(4220),
    [anon_sym_COLON_EQ] = ACTIONS(4218),
    [anon_sym_DOLLAR] = ACTIONS(4220),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4220),
    [sym_int] = ACTIONS(4220),
    [sym_xint] = ACTIONS(4218),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4218),
    [anon_sym_POUNDendif] = ACTIONS(4218),
    [sym__newline] = ACTIONS(4218),
  },
  [2002] = {
    [sym_block_comment] = STATE(2002),
    [sym_compiler_directive_decl] = STATE(2002),
    [sym_fsi_directive_decl] = STATE(2002),
    [sym_preproc_line] = STATE(2002),
    [sym_identifier] = ACTIONS(4236),
    [anon_sym_EQ] = ACTIONS(4234),
    [anon_sym_LBRACK_LT] = ACTIONS(4234),
    [anon_sym_COLON] = ACTIONS(4236),
    [anon_sym_return] = ACTIONS(4236),
    [anon_sym_do] = ACTIONS(4236),
    [anon_sym_and] = ACTIONS(4236),
    [anon_sym_let] = ACTIONS(4236),
    [anon_sym_let_BANG] = ACTIONS(4234),
    [aux_sym_access_modifier_token1] = ACTIONS(4234),
    [anon_sym_LPAREN] = ACTIONS(4236),
    [anon_sym_COMMA] = ACTIONS(4234),
    [anon_sym_null] = ACTIONS(4236),
    [anon_sym_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_COLON] = ACTIONS(4234),
    [anon_sym_AMP] = ACTIONS(4236),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4234),
    [anon_sym_LBRACE] = ACTIONS(4236),
    [anon_sym_LT_AT] = ACTIONS(4236),
    [anon_sym_LT_AT_AT] = ACTIONS(4236),
    [anon_sym_DOT] = ACTIONS(4236),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4234),
    [anon_sym_new] = ACTIONS(4236),
    [anon_sym_with] = ACTIONS(4236),
    [anon_sym_return_BANG] = ACTIONS(4234),
    [anon_sym_yield] = ACTIONS(4236),
    [anon_sym_yield_BANG] = ACTIONS(4234),
    [anon_sym_lazy] = ACTIONS(4236),
    [anon_sym_assert] = ACTIONS(4236),
    [anon_sym_upcast] = ACTIONS(4236),
    [anon_sym_downcast] = ACTIONS(4236),
    [anon_sym_COLON_GT] = ACTIONS(4234),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4234),
    [anon_sym_for] = ACTIONS(4236),
    [anon_sym_while] = ACTIONS(4236),
    [anon_sym_if] = ACTIONS(4236),
    [anon_sym_fun] = ACTIONS(4236),
    [anon_sym_try] = ACTIONS(4236),
    [anon_sym_match] = ACTIONS(4236),
    [anon_sym_match_BANG] = ACTIONS(4234),
    [anon_sym_function] = ACTIONS(4236),
    [anon_sym_LT_DASH] = ACTIONS(4236),
    [anon_sym_DOT_LBRACK] = ACTIONS(4234),
    [anon_sym_LT] = ACTIONS(4234),
    [anon_sym_use] = ACTIONS(4236),
    [anon_sym_use_BANG] = ACTIONS(4234),
    [anon_sym_do_BANG] = ACTIONS(4234),
    [anon_sym_begin] = ACTIONS(4236),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_default] = ACTIONS(4236),
    [anon_sym_or] = ACTIONS(4236),
    [anon_sym_static] = ACTIONS(4236),
    [anon_sym_member] = ACTIONS(4236),
    [anon_sym_interface] = ACTIONS(4236),
    [anon_sym_abstract] = ACTIONS(4236),
    [anon_sym_val] = ACTIONS(4236),
    [anon_sym_override] = ACTIONS(4236),
    [aux_sym_char_token1] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4236),
    [anon_sym_DQUOTE] = ACTIONS(4236),
    [anon_sym_AT_DQUOTE] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [sym_bool] = ACTIONS(4236),
    [sym_unit] = ACTIONS(4234),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4236),
    [sym_op_identifier] = ACTIONS(4236),
    [anon_sym_PLUS] = ACTIONS(4236),
    [anon_sym_DASH] = ACTIONS(4236),
    [anon_sym_PLUS_DOT] = ACTIONS(4236),
    [anon_sym_DASH_DOT] = ACTIONS(4236),
    [anon_sym_PERCENT] = ACTIONS(4236),
    [anon_sym_AMP_AMP] = ACTIONS(4236),
    [anon_sym_TILDE] = ACTIONS(4234),
    [aux_sym_prefix_op_token1] = ACTIONS(4236),
    [aux_sym_infix_op_token1] = ACTIONS(4234),
    [aux_sym_infix_op_token2] = ACTIONS(4236),
    [anon_sym_PIPE_PIPE] = ACTIONS(4236),
    [anon_sym_BANG_EQ] = ACTIONS(4236),
    [anon_sym_COLON_EQ] = ACTIONS(4234),
    [anon_sym_DOLLAR] = ACTIONS(4236),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4236),
    [sym_int] = ACTIONS(4236),
    [sym_xint] = ACTIONS(4234),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4234),
    [anon_sym_POUNDendif] = ACTIONS(4234),
    [sym__newline] = ACTIONS(4234),
  },
  [2003] = {
    [sym_block_comment] = STATE(2003),
    [sym_compiler_directive_decl] = STATE(2003),
    [sym_fsi_directive_decl] = STATE(2003),
    [sym_preproc_line] = STATE(2003),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_LBRACK_LT] = ACTIONS(3865),
    [anon_sym_COLON] = ACTIONS(3867),
    [anon_sym_return] = ACTIONS(3867),
    [anon_sym_do] = ACTIONS(3867),
    [anon_sym_let] = ACTIONS(3867),
    [anon_sym_let_BANG] = ACTIONS(3865),
    [aux_sym_access_modifier_token1] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(3867),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_null] = ACTIONS(3867),
    [anon_sym_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_COLON] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3867),
    [anon_sym_LBRACK] = ACTIONS(3867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3867),
    [anon_sym_LT_AT] = ACTIONS(3867),
    [anon_sym_LT_AT_AT] = ACTIONS(3867),
    [anon_sym_DOT] = ACTIONS(3867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3867),
    [anon_sym_with] = ACTIONS(3867),
    [anon_sym_return_BANG] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3867),
    [anon_sym_yield_BANG] = ACTIONS(3865),
    [anon_sym_lazy] = ACTIONS(3867),
    [anon_sym_assert] = ACTIONS(3867),
    [anon_sym_upcast] = ACTIONS(3867),
    [anon_sym_downcast] = ACTIONS(3867),
    [anon_sym_COLON_GT] = ACTIONS(3865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3867),
    [anon_sym_while] = ACTIONS(3867),
    [anon_sym_if] = ACTIONS(3867),
    [anon_sym_fun] = ACTIONS(3867),
    [anon_sym_try] = ACTIONS(3867),
    [anon_sym_match] = ACTIONS(3867),
    [anon_sym_match_BANG] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(3867),
    [anon_sym_DOT_LBRACK] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_use] = ACTIONS(3867),
    [anon_sym_use_BANG] = ACTIONS(3865),
    [anon_sym_do_BANG] = ACTIONS(3865),
    [anon_sym_begin] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(3867),
    [anon_sym_default] = ACTIONS(3867),
    [anon_sym_or] = ACTIONS(3867),
    [anon_sym_static] = ACTIONS(3867),
    [anon_sym_member] = ACTIONS(3867),
    [anon_sym_interface] = ACTIONS(3867),
    [anon_sym_abstract] = ACTIONS(3867),
    [anon_sym_val] = ACTIONS(3867),
    [anon_sym_override] = ACTIONS(3867),
    [anon_sym_inherit] = ACTIONS(3867),
    [aux_sym_char_token1] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3867),
    [anon_sym_DQUOTE] = ACTIONS(3867),
    [anon_sym_AT_DQUOTE] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [sym_bool] = ACTIONS(3867),
    [sym_unit] = ACTIONS(3865),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3867),
    [sym_op_identifier] = ACTIONS(3867),
    [anon_sym_PLUS] = ACTIONS(3867),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_PLUS_DOT] = ACTIONS(3867),
    [anon_sym_DASH_DOT] = ACTIONS(3867),
    [anon_sym_PERCENT] = ACTIONS(3867),
    [anon_sym_AMP_AMP] = ACTIONS(3867),
    [anon_sym_TILDE] = ACTIONS(3865),
    [aux_sym_prefix_op_token1] = ACTIONS(3867),
    [aux_sym_infix_op_token1] = ACTIONS(3865),
    [aux_sym_infix_op_token2] = ACTIONS(3867),
    [anon_sym_PIPE_PIPE] = ACTIONS(3867),
    [anon_sym_BANG_EQ] = ACTIONS(3867),
    [anon_sym_COLON_EQ] = ACTIONS(3865),
    [anon_sym_DOLLAR] = ACTIONS(3867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3867),
    [sym_int] = ACTIONS(3867),
    [sym_xint] = ACTIONS(3865),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3865),
    [anon_sym_POUNDendif] = ACTIONS(3865),
    [sym__newline] = ACTIONS(3865),
  },
  [2004] = {
    [sym_block_comment] = STATE(2004),
    [sym_compiler_directive_decl] = STATE(2004),
    [sym_fsi_directive_decl] = STATE(2004),
    [sym_preproc_line] = STATE(2004),
    [sym_identifier] = ACTIONS(4240),
    [anon_sym_EQ] = ACTIONS(4238),
    [anon_sym_LBRACK_LT] = ACTIONS(4238),
    [anon_sym_COLON] = ACTIONS(4240),
    [anon_sym_return] = ACTIONS(4240),
    [anon_sym_do] = ACTIONS(4240),
    [anon_sym_and] = ACTIONS(4240),
    [anon_sym_let] = ACTIONS(4240),
    [anon_sym_let_BANG] = ACTIONS(4238),
    [aux_sym_access_modifier_token1] = ACTIONS(4238),
    [anon_sym_LPAREN] = ACTIONS(4240),
    [anon_sym_COMMA] = ACTIONS(4238),
    [anon_sym_null] = ACTIONS(4240),
    [anon_sym_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_COLON] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4240),
    [anon_sym_LBRACK] = ACTIONS(4240),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4238),
    [anon_sym_LBRACE] = ACTIONS(4240),
    [anon_sym_LT_AT] = ACTIONS(4240),
    [anon_sym_LT_AT_AT] = ACTIONS(4240),
    [anon_sym_DOT] = ACTIONS(4240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4238),
    [anon_sym_new] = ACTIONS(4240),
    [anon_sym_with] = ACTIONS(4240),
    [anon_sym_return_BANG] = ACTIONS(4238),
    [anon_sym_yield] = ACTIONS(4240),
    [anon_sym_yield_BANG] = ACTIONS(4238),
    [anon_sym_lazy] = ACTIONS(4240),
    [anon_sym_assert] = ACTIONS(4240),
    [anon_sym_upcast] = ACTIONS(4240),
    [anon_sym_downcast] = ACTIONS(4240),
    [anon_sym_COLON_GT] = ACTIONS(4238),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4238),
    [anon_sym_for] = ACTIONS(4240),
    [anon_sym_while] = ACTIONS(4240),
    [anon_sym_if] = ACTIONS(4240),
    [anon_sym_fun] = ACTIONS(4240),
    [anon_sym_try] = ACTIONS(4240),
    [anon_sym_match] = ACTIONS(4240),
    [anon_sym_match_BANG] = ACTIONS(4238),
    [anon_sym_function] = ACTIONS(4240),
    [anon_sym_LT_DASH] = ACTIONS(4240),
    [anon_sym_DOT_LBRACK] = ACTIONS(4238),
    [anon_sym_LT] = ACTIONS(4238),
    [anon_sym_use] = ACTIONS(4240),
    [anon_sym_use_BANG] = ACTIONS(4238),
    [anon_sym_do_BANG] = ACTIONS(4238),
    [anon_sym_begin] = ACTIONS(4240),
    [anon_sym_LPAREN2] = ACTIONS(4240),
    [anon_sym_default] = ACTIONS(4240),
    [anon_sym_or] = ACTIONS(4240),
    [anon_sym_static] = ACTIONS(4240),
    [anon_sym_member] = ACTIONS(4240),
    [anon_sym_interface] = ACTIONS(4240),
    [anon_sym_abstract] = ACTIONS(4240),
    [anon_sym_val] = ACTIONS(4240),
    [anon_sym_override] = ACTIONS(4240),
    [aux_sym_char_token1] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4240),
    [anon_sym_DQUOTE] = ACTIONS(4240),
    [anon_sym_AT_DQUOTE] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [sym_bool] = ACTIONS(4240),
    [sym_unit] = ACTIONS(4238),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4240),
    [sym_op_identifier] = ACTIONS(4240),
    [anon_sym_PLUS] = ACTIONS(4240),
    [anon_sym_DASH] = ACTIONS(4240),
    [anon_sym_PLUS_DOT] = ACTIONS(4240),
    [anon_sym_DASH_DOT] = ACTIONS(4240),
    [anon_sym_PERCENT] = ACTIONS(4240),
    [anon_sym_AMP_AMP] = ACTIONS(4240),
    [anon_sym_TILDE] = ACTIONS(4238),
    [aux_sym_prefix_op_token1] = ACTIONS(4240),
    [aux_sym_infix_op_token1] = ACTIONS(4238),
    [aux_sym_infix_op_token2] = ACTIONS(4240),
    [anon_sym_PIPE_PIPE] = ACTIONS(4240),
    [anon_sym_BANG_EQ] = ACTIONS(4240),
    [anon_sym_COLON_EQ] = ACTIONS(4238),
    [anon_sym_DOLLAR] = ACTIONS(4240),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4240),
    [sym_int] = ACTIONS(4240),
    [sym_xint] = ACTIONS(4238),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4238),
    [anon_sym_POUNDendif] = ACTIONS(4238),
    [sym__newline] = ACTIONS(4238),
  },
  [2005] = {
    [sym_block_comment] = STATE(2005),
    [sym_compiler_directive_decl] = STATE(2005),
    [sym_fsi_directive_decl] = STATE(2005),
    [sym_preproc_line] = STATE(2005),
    [sym_identifier] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4242),
    [anon_sym_LBRACK_LT] = ACTIONS(4242),
    [anon_sym_COLON] = ACTIONS(4244),
    [anon_sym_return] = ACTIONS(4244),
    [anon_sym_do] = ACTIONS(4244),
    [anon_sym_and] = ACTIONS(4244),
    [anon_sym_let] = ACTIONS(4244),
    [anon_sym_let_BANG] = ACTIONS(4242),
    [aux_sym_access_modifier_token1] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_null] = ACTIONS(4244),
    [anon_sym_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_COLON] = ACTIONS(4242),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4244),
    [anon_sym_LT_AT] = ACTIONS(4244),
    [anon_sym_LT_AT_AT] = ACTIONS(4244),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4242),
    [anon_sym_new] = ACTIONS(4244),
    [anon_sym_with] = ACTIONS(4244),
    [anon_sym_return_BANG] = ACTIONS(4242),
    [anon_sym_yield] = ACTIONS(4244),
    [anon_sym_yield_BANG] = ACTIONS(4242),
    [anon_sym_lazy] = ACTIONS(4244),
    [anon_sym_assert] = ACTIONS(4244),
    [anon_sym_upcast] = ACTIONS(4244),
    [anon_sym_downcast] = ACTIONS(4244),
    [anon_sym_COLON_GT] = ACTIONS(4242),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4242),
    [anon_sym_for] = ACTIONS(4244),
    [anon_sym_while] = ACTIONS(4244),
    [anon_sym_if] = ACTIONS(4244),
    [anon_sym_fun] = ACTIONS(4244),
    [anon_sym_try] = ACTIONS(4244),
    [anon_sym_match] = ACTIONS(4244),
    [anon_sym_match_BANG] = ACTIONS(4242),
    [anon_sym_function] = ACTIONS(4244),
    [anon_sym_LT_DASH] = ACTIONS(4244),
    [anon_sym_DOT_LBRACK] = ACTIONS(4242),
    [anon_sym_LT] = ACTIONS(4242),
    [anon_sym_use] = ACTIONS(4244),
    [anon_sym_use_BANG] = ACTIONS(4242),
    [anon_sym_do_BANG] = ACTIONS(4242),
    [anon_sym_begin] = ACTIONS(4244),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_default] = ACTIONS(4244),
    [anon_sym_or] = ACTIONS(4244),
    [anon_sym_static] = ACTIONS(4244),
    [anon_sym_member] = ACTIONS(4244),
    [anon_sym_interface] = ACTIONS(4244),
    [anon_sym_abstract] = ACTIONS(4244),
    [anon_sym_val] = ACTIONS(4244),
    [anon_sym_override] = ACTIONS(4244),
    [aux_sym_char_token1] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4244),
    [anon_sym_DQUOTE] = ACTIONS(4244),
    [anon_sym_AT_DQUOTE] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [sym_bool] = ACTIONS(4244),
    [sym_unit] = ACTIONS(4242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4244),
    [sym_op_identifier] = ACTIONS(4244),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_DASH] = ACTIONS(4244),
    [anon_sym_PLUS_DOT] = ACTIONS(4244),
    [anon_sym_DASH_DOT] = ACTIONS(4244),
    [anon_sym_PERCENT] = ACTIONS(4244),
    [anon_sym_AMP_AMP] = ACTIONS(4244),
    [anon_sym_TILDE] = ACTIONS(4242),
    [aux_sym_prefix_op_token1] = ACTIONS(4244),
    [aux_sym_infix_op_token1] = ACTIONS(4242),
    [aux_sym_infix_op_token2] = ACTIONS(4244),
    [anon_sym_PIPE_PIPE] = ACTIONS(4244),
    [anon_sym_BANG_EQ] = ACTIONS(4244),
    [anon_sym_COLON_EQ] = ACTIONS(4242),
    [anon_sym_DOLLAR] = ACTIONS(4244),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4244),
    [sym_int] = ACTIONS(4244),
    [sym_xint] = ACTIONS(4242),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4242),
    [anon_sym_POUNDendif] = ACTIONS(4242),
    [sym__newline] = ACTIONS(4242),
  },
  [2006] = {
    [sym_block_comment] = STATE(2006),
    [sym_compiler_directive_decl] = STATE(2006),
    [sym_fsi_directive_decl] = STATE(2006),
    [sym_preproc_line] = STATE(2006),
    [sym_identifier] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4246),
    [anon_sym_LBRACK_LT] = ACTIONS(4246),
    [anon_sym_COLON] = ACTIONS(4248),
    [anon_sym_return] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4248),
    [anon_sym_and] = ACTIONS(4248),
    [anon_sym_let] = ACTIONS(4248),
    [anon_sym_let_BANG] = ACTIONS(4246),
    [aux_sym_access_modifier_token1] = ACTIONS(4246),
    [anon_sym_LPAREN] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_null] = ACTIONS(4248),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4248),
    [anon_sym_LT_AT] = ACTIONS(4248),
    [anon_sym_LT_AT_AT] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4246),
    [anon_sym_new] = ACTIONS(4248),
    [anon_sym_with] = ACTIONS(4248),
    [anon_sym_return_BANG] = ACTIONS(4246),
    [anon_sym_yield] = ACTIONS(4248),
    [anon_sym_yield_BANG] = ACTIONS(4246),
    [anon_sym_lazy] = ACTIONS(4248),
    [anon_sym_assert] = ACTIONS(4248),
    [anon_sym_upcast] = ACTIONS(4248),
    [anon_sym_downcast] = ACTIONS(4248),
    [anon_sym_COLON_GT] = ACTIONS(4246),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4246),
    [anon_sym_for] = ACTIONS(4248),
    [anon_sym_while] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4248),
    [anon_sym_fun] = ACTIONS(4248),
    [anon_sym_try] = ACTIONS(4248),
    [anon_sym_match] = ACTIONS(4248),
    [anon_sym_match_BANG] = ACTIONS(4246),
    [anon_sym_function] = ACTIONS(4248),
    [anon_sym_LT_DASH] = ACTIONS(4248),
    [anon_sym_DOT_LBRACK] = ACTIONS(4246),
    [anon_sym_LT] = ACTIONS(4246),
    [anon_sym_use] = ACTIONS(4248),
    [anon_sym_use_BANG] = ACTIONS(4246),
    [anon_sym_do_BANG] = ACTIONS(4246),
    [anon_sym_begin] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_default] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4248),
    [anon_sym_static] = ACTIONS(4248),
    [anon_sym_member] = ACTIONS(4248),
    [anon_sym_interface] = ACTIONS(4248),
    [anon_sym_abstract] = ACTIONS(4248),
    [anon_sym_val] = ACTIONS(4248),
    [anon_sym_override] = ACTIONS(4248),
    [aux_sym_char_token1] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4248),
    [anon_sym_DQUOTE] = ACTIONS(4248),
    [anon_sym_AT_DQUOTE] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [sym_bool] = ACTIONS(4248),
    [sym_unit] = ACTIONS(4246),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4248),
    [sym_op_identifier] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_DOT] = ACTIONS(4248),
    [anon_sym_DASH_DOT] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_TILDE] = ACTIONS(4246),
    [aux_sym_prefix_op_token1] = ACTIONS(4248),
    [aux_sym_infix_op_token1] = ACTIONS(4246),
    [aux_sym_infix_op_token2] = ACTIONS(4248),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_COLON_EQ] = ACTIONS(4246),
    [anon_sym_DOLLAR] = ACTIONS(4248),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4248),
    [sym_int] = ACTIONS(4248),
    [sym_xint] = ACTIONS(4246),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4246),
    [anon_sym_POUNDendif] = ACTIONS(4246),
    [sym__newline] = ACTIONS(4246),
  },
  [2007] = {
    [sym_block_comment] = STATE(2007),
    [sym_compiler_directive_decl] = STATE(2007),
    [sym_fsi_directive_decl] = STATE(2007),
    [sym_preproc_line] = STATE(2007),
    [sym_identifier] = ACTIONS(4108),
    [anon_sym_EQ] = ACTIONS(4106),
    [anon_sym_LBRACK_LT] = ACTIONS(4106),
    [anon_sym_COLON] = ACTIONS(4108),
    [anon_sym_return] = ACTIONS(4108),
    [anon_sym_do] = ACTIONS(4108),
    [anon_sym_let] = ACTIONS(4108),
    [anon_sym_let_BANG] = ACTIONS(4106),
    [aux_sym_access_modifier_token1] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(4108),
    [anon_sym_COMMA] = ACTIONS(4106),
    [anon_sym_null] = ACTIONS(4108),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_COLON] = ACTIONS(4106),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LBRACK] = ACTIONS(4108),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(4108),
    [anon_sym_LT_AT] = ACTIONS(4108),
    [anon_sym_LT_AT_AT] = ACTIONS(4108),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4106),
    [anon_sym_new] = ACTIONS(4108),
    [anon_sym_with] = ACTIONS(4108),
    [anon_sym_return_BANG] = ACTIONS(4106),
    [anon_sym_yield] = ACTIONS(4108),
    [anon_sym_yield_BANG] = ACTIONS(4106),
    [anon_sym_lazy] = ACTIONS(4108),
    [anon_sym_assert] = ACTIONS(4108),
    [anon_sym_upcast] = ACTIONS(4108),
    [anon_sym_downcast] = ACTIONS(4108),
    [anon_sym_COLON_GT] = ACTIONS(4106),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4106),
    [anon_sym_for] = ACTIONS(4108),
    [anon_sym_while] = ACTIONS(4108),
    [anon_sym_if] = ACTIONS(4108),
    [anon_sym_fun] = ACTIONS(4108),
    [anon_sym_try] = ACTIONS(4108),
    [anon_sym_match] = ACTIONS(4108),
    [anon_sym_match_BANG] = ACTIONS(4106),
    [anon_sym_function] = ACTIONS(4108),
    [anon_sym_LT_DASH] = ACTIONS(4108),
    [anon_sym_DOT_LBRACK] = ACTIONS(4106),
    [anon_sym_LT] = ACTIONS(4106),
    [anon_sym_use] = ACTIONS(4108),
    [anon_sym_use_BANG] = ACTIONS(4106),
    [anon_sym_do_BANG] = ACTIONS(4106),
    [anon_sym_begin] = ACTIONS(4108),
    [anon_sym_LPAREN2] = ACTIONS(4108),
    [anon_sym_DOT_DOT2] = ACTIONS(4106),
    [anon_sym_default] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [anon_sym_static] = ACTIONS(4108),
    [anon_sym_member] = ACTIONS(4108),
    [anon_sym_interface] = ACTIONS(4108),
    [anon_sym_abstract] = ACTIONS(4108),
    [anon_sym_val] = ACTIONS(4108),
    [anon_sym_override] = ACTIONS(4108),
    [aux_sym_char_token1] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4108),
    [anon_sym_DQUOTE] = ACTIONS(4108),
    [anon_sym_AT_DQUOTE] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [sym_bool] = ACTIONS(4108),
    [sym_unit] = ACTIONS(4106),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4108),
    [sym_op_identifier] = ACTIONS(4108),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_PLUS_DOT] = ACTIONS(4108),
    [anon_sym_DASH_DOT] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_AMP_AMP] = ACTIONS(4108),
    [anon_sym_TILDE] = ACTIONS(4106),
    [aux_sym_prefix_op_token1] = ACTIONS(4108),
    [aux_sym_infix_op_token1] = ACTIONS(4106),
    [aux_sym_infix_op_token2] = ACTIONS(4108),
    [anon_sym_PIPE_PIPE] = ACTIONS(4108),
    [anon_sym_BANG_EQ] = ACTIONS(4108),
    [anon_sym_COLON_EQ] = ACTIONS(4106),
    [anon_sym_DOLLAR] = ACTIONS(4108),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4108),
    [sym_int] = ACTIONS(4108),
    [sym_xint] = ACTIONS(4106),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4106),
    [sym__newline] = ACTIONS(4106),
    [sym__dedent] = ACTIONS(4106),
  },
  [2008] = {
    [sym_block_comment] = STATE(2008),
    [sym_compiler_directive_decl] = STATE(2008),
    [sym_fsi_directive_decl] = STATE(2008),
    [sym_preproc_line] = STATE(2008),
    [sym_identifier] = ACTIONS(4216),
    [anon_sym_EQ] = ACTIONS(4214),
    [anon_sym_LBRACK_LT] = ACTIONS(4214),
    [anon_sym_COLON] = ACTIONS(4216),
    [anon_sym_return] = ACTIONS(4216),
    [anon_sym_do] = ACTIONS(4216),
    [anon_sym_let] = ACTIONS(4216),
    [anon_sym_let_BANG] = ACTIONS(4214),
    [aux_sym_access_modifier_token1] = ACTIONS(4214),
    [anon_sym_LPAREN] = ACTIONS(4216),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_null] = ACTIONS(4216),
    [anon_sym_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_COLON] = ACTIONS(4214),
    [anon_sym_AMP] = ACTIONS(4216),
    [anon_sym_LBRACK] = ACTIONS(4216),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4214),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_LT_AT] = ACTIONS(4216),
    [anon_sym_LT_AT_AT] = ACTIONS(4216),
    [anon_sym_DOT] = ACTIONS(4216),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4214),
    [anon_sym_new] = ACTIONS(4216),
    [anon_sym_with] = ACTIONS(4216),
    [anon_sym_return_BANG] = ACTIONS(4214),
    [anon_sym_yield] = ACTIONS(4216),
    [anon_sym_yield_BANG] = ACTIONS(4214),
    [anon_sym_lazy] = ACTIONS(4216),
    [anon_sym_assert] = ACTIONS(4216),
    [anon_sym_upcast] = ACTIONS(4216),
    [anon_sym_downcast] = ACTIONS(4216),
    [anon_sym_COLON_GT] = ACTIONS(4214),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4214),
    [anon_sym_for] = ACTIONS(4216),
    [anon_sym_while] = ACTIONS(4216),
    [anon_sym_if] = ACTIONS(4216),
    [anon_sym_fun] = ACTIONS(4216),
    [anon_sym_try] = ACTIONS(4216),
    [anon_sym_match] = ACTIONS(4216),
    [anon_sym_match_BANG] = ACTIONS(4214),
    [anon_sym_function] = ACTIONS(4216),
    [anon_sym_LT_DASH] = ACTIONS(4216),
    [anon_sym_DOT_LBRACK] = ACTIONS(4214),
    [anon_sym_LT] = ACTIONS(4214),
    [anon_sym_use] = ACTIONS(4216),
    [anon_sym_use_BANG] = ACTIONS(4214),
    [anon_sym_do_BANG] = ACTIONS(4214),
    [anon_sym_begin] = ACTIONS(4216),
    [anon_sym_LPAREN2] = ACTIONS(4216),
    [anon_sym_DOT_DOT2] = ACTIONS(4214),
    [anon_sym_default] = ACTIONS(4216),
    [anon_sym_or] = ACTIONS(4216),
    [anon_sym_static] = ACTIONS(4216),
    [anon_sym_member] = ACTIONS(4216),
    [anon_sym_interface] = ACTIONS(4216),
    [anon_sym_abstract] = ACTIONS(4216),
    [anon_sym_val] = ACTIONS(4216),
    [anon_sym_override] = ACTIONS(4216),
    [aux_sym_char_token1] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4216),
    [anon_sym_DQUOTE] = ACTIONS(4216),
    [anon_sym_AT_DQUOTE] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [sym_bool] = ACTIONS(4216),
    [sym_unit] = ACTIONS(4214),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4216),
    [sym_op_identifier] = ACTIONS(4216),
    [anon_sym_PLUS] = ACTIONS(4216),
    [anon_sym_DASH] = ACTIONS(4216),
    [anon_sym_PLUS_DOT] = ACTIONS(4216),
    [anon_sym_DASH_DOT] = ACTIONS(4216),
    [anon_sym_PERCENT] = ACTIONS(4216),
    [anon_sym_AMP_AMP] = ACTIONS(4216),
    [anon_sym_TILDE] = ACTIONS(4214),
    [aux_sym_prefix_op_token1] = ACTIONS(4216),
    [aux_sym_infix_op_token1] = ACTIONS(4214),
    [aux_sym_infix_op_token2] = ACTIONS(4216),
    [anon_sym_PIPE_PIPE] = ACTIONS(4216),
    [anon_sym_BANG_EQ] = ACTIONS(4216),
    [anon_sym_COLON_EQ] = ACTIONS(4214),
    [anon_sym_DOLLAR] = ACTIONS(4216),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4216),
    [sym_int] = ACTIONS(4216),
    [sym_xint] = ACTIONS(4214),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4214),
    [sym__newline] = ACTIONS(4214),
    [sym__dedent] = ACTIONS(4214),
  },
  [2009] = {
    [sym_block_comment] = STATE(2009),
    [sym_compiler_directive_decl] = STATE(2009),
    [sym_fsi_directive_decl] = STATE(2009),
    [sym_preproc_line] = STATE(2009),
    [sym_identifier] = ACTIONS(4220),
    [anon_sym_EQ] = ACTIONS(4218),
    [anon_sym_LBRACK_LT] = ACTIONS(4218),
    [anon_sym_COLON] = ACTIONS(4220),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_do] = ACTIONS(4220),
    [anon_sym_let] = ACTIONS(4220),
    [anon_sym_let_BANG] = ACTIONS(4218),
    [aux_sym_access_modifier_token1] = ACTIONS(4218),
    [anon_sym_LPAREN] = ACTIONS(4220),
    [anon_sym_COMMA] = ACTIONS(4218),
    [anon_sym_null] = ACTIONS(4220),
    [anon_sym_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_COLON] = ACTIONS(4218),
    [anon_sym_AMP] = ACTIONS(4220),
    [anon_sym_LBRACK] = ACTIONS(4220),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(4220),
    [anon_sym_LT_AT] = ACTIONS(4220),
    [anon_sym_LT_AT_AT] = ACTIONS(4220),
    [anon_sym_DOT] = ACTIONS(4220),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4218),
    [anon_sym_new] = ACTIONS(4220),
    [anon_sym_with] = ACTIONS(4220),
    [anon_sym_return_BANG] = ACTIONS(4218),
    [anon_sym_yield] = ACTIONS(4220),
    [anon_sym_yield_BANG] = ACTIONS(4218),
    [anon_sym_lazy] = ACTIONS(4220),
    [anon_sym_assert] = ACTIONS(4220),
    [anon_sym_upcast] = ACTIONS(4220),
    [anon_sym_downcast] = ACTIONS(4220),
    [anon_sym_COLON_GT] = ACTIONS(4218),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4218),
    [anon_sym_for] = ACTIONS(4220),
    [anon_sym_while] = ACTIONS(4220),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_fun] = ACTIONS(4220),
    [anon_sym_try] = ACTIONS(4220),
    [anon_sym_match] = ACTIONS(4220),
    [anon_sym_match_BANG] = ACTIONS(4218),
    [anon_sym_function] = ACTIONS(4220),
    [anon_sym_LT_DASH] = ACTIONS(4220),
    [anon_sym_DOT_LBRACK] = ACTIONS(4218),
    [anon_sym_LT] = ACTIONS(4218),
    [anon_sym_use] = ACTIONS(4220),
    [anon_sym_use_BANG] = ACTIONS(4218),
    [anon_sym_do_BANG] = ACTIONS(4218),
    [anon_sym_begin] = ACTIONS(4220),
    [anon_sym_LPAREN2] = ACTIONS(4220),
    [anon_sym_DOT_DOT2] = ACTIONS(4218),
    [anon_sym_default] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(4220),
    [anon_sym_static] = ACTIONS(4220),
    [anon_sym_member] = ACTIONS(4220),
    [anon_sym_interface] = ACTIONS(4220),
    [anon_sym_abstract] = ACTIONS(4220),
    [anon_sym_val] = ACTIONS(4220),
    [anon_sym_override] = ACTIONS(4220),
    [aux_sym_char_token1] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4220),
    [anon_sym_DQUOTE] = ACTIONS(4220),
    [anon_sym_AT_DQUOTE] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [sym_bool] = ACTIONS(4220),
    [sym_unit] = ACTIONS(4218),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4220),
    [sym_op_identifier] = ACTIONS(4220),
    [anon_sym_PLUS] = ACTIONS(4220),
    [anon_sym_DASH] = ACTIONS(4220),
    [anon_sym_PLUS_DOT] = ACTIONS(4220),
    [anon_sym_DASH_DOT] = ACTIONS(4220),
    [anon_sym_PERCENT] = ACTIONS(4220),
    [anon_sym_AMP_AMP] = ACTIONS(4220),
    [anon_sym_TILDE] = ACTIONS(4218),
    [aux_sym_prefix_op_token1] = ACTIONS(4220),
    [aux_sym_infix_op_token1] = ACTIONS(4218),
    [aux_sym_infix_op_token2] = ACTIONS(4220),
    [anon_sym_PIPE_PIPE] = ACTIONS(4220),
    [anon_sym_BANG_EQ] = ACTIONS(4220),
    [anon_sym_COLON_EQ] = ACTIONS(4218),
    [anon_sym_DOLLAR] = ACTIONS(4220),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4220),
    [sym_int] = ACTIONS(4220),
    [sym_xint] = ACTIONS(4218),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4218),
    [sym__newline] = ACTIONS(4218),
    [sym__dedent] = ACTIONS(4218),
  },
  [2010] = {
    [sym_block_comment] = STATE(2010),
    [sym_compiler_directive_decl] = STATE(2010),
    [sym_fsi_directive_decl] = STATE(2010),
    [sym_preproc_line] = STATE(2010),
    [sym_identifier] = ACTIONS(4236),
    [anon_sym_EQ] = ACTIONS(4234),
    [anon_sym_LBRACK_LT] = ACTIONS(4234),
    [anon_sym_COLON] = ACTIONS(4236),
    [anon_sym_return] = ACTIONS(4236),
    [anon_sym_do] = ACTIONS(4236),
    [anon_sym_let] = ACTIONS(4236),
    [anon_sym_let_BANG] = ACTIONS(4234),
    [aux_sym_access_modifier_token1] = ACTIONS(4234),
    [anon_sym_LPAREN] = ACTIONS(4236),
    [anon_sym_COMMA] = ACTIONS(4234),
    [anon_sym_null] = ACTIONS(4236),
    [anon_sym_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_COLON] = ACTIONS(4234),
    [anon_sym_AMP] = ACTIONS(4236),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4234),
    [anon_sym_LBRACE] = ACTIONS(4236),
    [anon_sym_LT_AT] = ACTIONS(4236),
    [anon_sym_LT_AT_AT] = ACTIONS(4236),
    [anon_sym_DOT] = ACTIONS(4236),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4234),
    [anon_sym_new] = ACTIONS(4236),
    [anon_sym_with] = ACTIONS(4236),
    [anon_sym_return_BANG] = ACTIONS(4234),
    [anon_sym_yield] = ACTIONS(4236),
    [anon_sym_yield_BANG] = ACTIONS(4234),
    [anon_sym_lazy] = ACTIONS(4236),
    [anon_sym_assert] = ACTIONS(4236),
    [anon_sym_upcast] = ACTIONS(4236),
    [anon_sym_downcast] = ACTIONS(4236),
    [anon_sym_COLON_GT] = ACTIONS(4234),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4234),
    [anon_sym_for] = ACTIONS(4236),
    [anon_sym_while] = ACTIONS(4236),
    [anon_sym_if] = ACTIONS(4236),
    [anon_sym_fun] = ACTIONS(4236),
    [anon_sym_try] = ACTIONS(4236),
    [anon_sym_match] = ACTIONS(4236),
    [anon_sym_match_BANG] = ACTIONS(4234),
    [anon_sym_function] = ACTIONS(4236),
    [anon_sym_LT_DASH] = ACTIONS(4236),
    [anon_sym_DOT_LBRACK] = ACTIONS(4234),
    [anon_sym_LT] = ACTIONS(4234),
    [anon_sym_use] = ACTIONS(4236),
    [anon_sym_use_BANG] = ACTIONS(4234),
    [anon_sym_do_BANG] = ACTIONS(4234),
    [anon_sym_begin] = ACTIONS(4236),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_DOT_DOT2] = ACTIONS(4234),
    [anon_sym_default] = ACTIONS(4236),
    [anon_sym_or] = ACTIONS(4236),
    [anon_sym_static] = ACTIONS(4236),
    [anon_sym_member] = ACTIONS(4236),
    [anon_sym_interface] = ACTIONS(4236),
    [anon_sym_abstract] = ACTIONS(4236),
    [anon_sym_val] = ACTIONS(4236),
    [anon_sym_override] = ACTIONS(4236),
    [aux_sym_char_token1] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4236),
    [anon_sym_DQUOTE] = ACTIONS(4236),
    [anon_sym_AT_DQUOTE] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [sym_bool] = ACTIONS(4236),
    [sym_unit] = ACTIONS(4234),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4236),
    [sym_op_identifier] = ACTIONS(4236),
    [anon_sym_PLUS] = ACTIONS(4236),
    [anon_sym_DASH] = ACTIONS(4236),
    [anon_sym_PLUS_DOT] = ACTIONS(4236),
    [anon_sym_DASH_DOT] = ACTIONS(4236),
    [anon_sym_PERCENT] = ACTIONS(4236),
    [anon_sym_AMP_AMP] = ACTIONS(4236),
    [anon_sym_TILDE] = ACTIONS(4234),
    [aux_sym_prefix_op_token1] = ACTIONS(4236),
    [aux_sym_infix_op_token1] = ACTIONS(4234),
    [aux_sym_infix_op_token2] = ACTIONS(4236),
    [anon_sym_PIPE_PIPE] = ACTIONS(4236),
    [anon_sym_BANG_EQ] = ACTIONS(4236),
    [anon_sym_COLON_EQ] = ACTIONS(4234),
    [anon_sym_DOLLAR] = ACTIONS(4236),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4236),
    [sym_int] = ACTIONS(4236),
    [sym_xint] = ACTIONS(4234),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4234),
    [sym__newline] = ACTIONS(4234),
    [sym__dedent] = ACTIONS(4234),
  },
  [2011] = {
    [sym_block_comment] = STATE(2011),
    [sym_compiler_directive_decl] = STATE(2011),
    [sym_fsi_directive_decl] = STATE(2011),
    [sym_preproc_line] = STATE(2011),
    [sym_identifier] = ACTIONS(4174),
    [anon_sym_EQ] = ACTIONS(4172),
    [anon_sym_LBRACK_LT] = ACTIONS(4172),
    [anon_sym_COLON] = ACTIONS(4174),
    [anon_sym_return] = ACTIONS(4174),
    [anon_sym_do] = ACTIONS(4174),
    [anon_sym_and] = ACTIONS(4174),
    [anon_sym_let] = ACTIONS(4174),
    [anon_sym_let_BANG] = ACTIONS(4172),
    [aux_sym_access_modifier_token1] = ACTIONS(4172),
    [anon_sym_LPAREN] = ACTIONS(4174),
    [anon_sym_COMMA] = ACTIONS(4172),
    [anon_sym_null] = ACTIONS(4174),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_COLON] = ACTIONS(4172),
    [anon_sym_AMP] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4174),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4172),
    [anon_sym_LBRACE] = ACTIONS(4174),
    [anon_sym_LT_AT] = ACTIONS(4174),
    [anon_sym_LT_AT_AT] = ACTIONS(4174),
    [anon_sym_DOT] = ACTIONS(4174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4172),
    [anon_sym_new] = ACTIONS(4174),
    [anon_sym_with] = ACTIONS(4174),
    [anon_sym_return_BANG] = ACTIONS(4172),
    [anon_sym_yield] = ACTIONS(4174),
    [anon_sym_yield_BANG] = ACTIONS(4172),
    [anon_sym_lazy] = ACTIONS(4174),
    [anon_sym_assert] = ACTIONS(4174),
    [anon_sym_upcast] = ACTIONS(4174),
    [anon_sym_downcast] = ACTIONS(4174),
    [anon_sym_COLON_GT] = ACTIONS(4172),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4172),
    [anon_sym_for] = ACTIONS(4174),
    [anon_sym_while] = ACTIONS(4174),
    [anon_sym_if] = ACTIONS(4174),
    [anon_sym_fun] = ACTIONS(4174),
    [anon_sym_try] = ACTIONS(4174),
    [anon_sym_match] = ACTIONS(4174),
    [anon_sym_match_BANG] = ACTIONS(4172),
    [anon_sym_function] = ACTIONS(4174),
    [anon_sym_LT_DASH] = ACTIONS(4174),
    [anon_sym_DOT_LBRACK] = ACTIONS(4172),
    [anon_sym_LT] = ACTIONS(4172),
    [anon_sym_use] = ACTIONS(4174),
    [anon_sym_use_BANG] = ACTIONS(4172),
    [anon_sym_do_BANG] = ACTIONS(4172),
    [anon_sym_begin] = ACTIONS(4174),
    [anon_sym_LPAREN2] = ACTIONS(4174),
    [anon_sym_default] = ACTIONS(4174),
    [anon_sym_or] = ACTIONS(4174),
    [anon_sym_static] = ACTIONS(4174),
    [anon_sym_member] = ACTIONS(4174),
    [anon_sym_interface] = ACTIONS(4174),
    [anon_sym_abstract] = ACTIONS(4174),
    [anon_sym_val] = ACTIONS(4174),
    [anon_sym_override] = ACTIONS(4174),
    [aux_sym_char_token1] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4174),
    [anon_sym_DQUOTE] = ACTIONS(4174),
    [anon_sym_AT_DQUOTE] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [sym_bool] = ACTIONS(4174),
    [sym_unit] = ACTIONS(4172),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4174),
    [sym_op_identifier] = ACTIONS(4174),
    [anon_sym_PLUS] = ACTIONS(4174),
    [anon_sym_DASH] = ACTIONS(4174),
    [anon_sym_PLUS_DOT] = ACTIONS(4174),
    [anon_sym_DASH_DOT] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [anon_sym_AMP_AMP] = ACTIONS(4174),
    [anon_sym_TILDE] = ACTIONS(4172),
    [aux_sym_prefix_op_token1] = ACTIONS(4174),
    [aux_sym_infix_op_token1] = ACTIONS(4172),
    [aux_sym_infix_op_token2] = ACTIONS(4174),
    [anon_sym_PIPE_PIPE] = ACTIONS(4174),
    [anon_sym_BANG_EQ] = ACTIONS(4174),
    [anon_sym_COLON_EQ] = ACTIONS(4172),
    [anon_sym_DOLLAR] = ACTIONS(4174),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4174),
    [sym_int] = ACTIONS(4174),
    [sym_xint] = ACTIONS(4172),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4172),
    [sym__newline] = ACTIONS(4172),
    [sym__dedent] = ACTIONS(4172),
  },
  [2012] = {
    [sym_block_comment] = STATE(2012),
    [sym_compiler_directive_decl] = STATE(2012),
    [sym_fsi_directive_decl] = STATE(2012),
    [sym_preproc_line] = STATE(2012),
    [sym_identifier] = ACTIONS(4240),
    [anon_sym_EQ] = ACTIONS(4238),
    [anon_sym_LBRACK_LT] = ACTIONS(4238),
    [anon_sym_COLON] = ACTIONS(4240),
    [anon_sym_return] = ACTIONS(4240),
    [anon_sym_do] = ACTIONS(4240),
    [anon_sym_let] = ACTIONS(4240),
    [anon_sym_let_BANG] = ACTIONS(4238),
    [aux_sym_access_modifier_token1] = ACTIONS(4238),
    [anon_sym_LPAREN] = ACTIONS(4240),
    [anon_sym_COMMA] = ACTIONS(4238),
    [anon_sym_null] = ACTIONS(4240),
    [anon_sym_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_COLON] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4240),
    [anon_sym_LBRACK] = ACTIONS(4240),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4238),
    [anon_sym_LBRACE] = ACTIONS(4240),
    [anon_sym_LT_AT] = ACTIONS(4240),
    [anon_sym_LT_AT_AT] = ACTIONS(4240),
    [anon_sym_DOT] = ACTIONS(4240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4238),
    [anon_sym_new] = ACTIONS(4240),
    [anon_sym_with] = ACTIONS(4240),
    [anon_sym_return_BANG] = ACTIONS(4238),
    [anon_sym_yield] = ACTIONS(4240),
    [anon_sym_yield_BANG] = ACTIONS(4238),
    [anon_sym_lazy] = ACTIONS(4240),
    [anon_sym_assert] = ACTIONS(4240),
    [anon_sym_upcast] = ACTIONS(4240),
    [anon_sym_downcast] = ACTIONS(4240),
    [anon_sym_COLON_GT] = ACTIONS(4238),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4238),
    [anon_sym_for] = ACTIONS(4240),
    [anon_sym_while] = ACTIONS(4240),
    [anon_sym_if] = ACTIONS(4240),
    [anon_sym_fun] = ACTIONS(4240),
    [anon_sym_try] = ACTIONS(4240),
    [anon_sym_match] = ACTIONS(4240),
    [anon_sym_match_BANG] = ACTIONS(4238),
    [anon_sym_function] = ACTIONS(4240),
    [anon_sym_LT_DASH] = ACTIONS(4240),
    [anon_sym_DOT_LBRACK] = ACTIONS(4238),
    [anon_sym_LT] = ACTIONS(4238),
    [anon_sym_use] = ACTIONS(4240),
    [anon_sym_use_BANG] = ACTIONS(4238),
    [anon_sym_do_BANG] = ACTIONS(4238),
    [anon_sym_begin] = ACTIONS(4240),
    [anon_sym_LPAREN2] = ACTIONS(4240),
    [anon_sym_DOT_DOT2] = ACTIONS(4238),
    [anon_sym_default] = ACTIONS(4240),
    [anon_sym_or] = ACTIONS(4240),
    [anon_sym_static] = ACTIONS(4240),
    [anon_sym_member] = ACTIONS(4240),
    [anon_sym_interface] = ACTIONS(4240),
    [anon_sym_abstract] = ACTIONS(4240),
    [anon_sym_val] = ACTIONS(4240),
    [anon_sym_override] = ACTIONS(4240),
    [aux_sym_char_token1] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4240),
    [anon_sym_DQUOTE] = ACTIONS(4240),
    [anon_sym_AT_DQUOTE] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [sym_bool] = ACTIONS(4240),
    [sym_unit] = ACTIONS(4238),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4240),
    [sym_op_identifier] = ACTIONS(4240),
    [anon_sym_PLUS] = ACTIONS(4240),
    [anon_sym_DASH] = ACTIONS(4240),
    [anon_sym_PLUS_DOT] = ACTIONS(4240),
    [anon_sym_DASH_DOT] = ACTIONS(4240),
    [anon_sym_PERCENT] = ACTIONS(4240),
    [anon_sym_AMP_AMP] = ACTIONS(4240),
    [anon_sym_TILDE] = ACTIONS(4238),
    [aux_sym_prefix_op_token1] = ACTIONS(4240),
    [aux_sym_infix_op_token1] = ACTIONS(4238),
    [aux_sym_infix_op_token2] = ACTIONS(4240),
    [anon_sym_PIPE_PIPE] = ACTIONS(4240),
    [anon_sym_BANG_EQ] = ACTIONS(4240),
    [anon_sym_COLON_EQ] = ACTIONS(4238),
    [anon_sym_DOLLAR] = ACTIONS(4240),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4240),
    [sym_int] = ACTIONS(4240),
    [sym_xint] = ACTIONS(4238),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4238),
    [sym__newline] = ACTIONS(4238),
    [sym__dedent] = ACTIONS(4238),
  },
  [2013] = {
    [sym_block_comment] = STATE(2013),
    [sym_compiler_directive_decl] = STATE(2013),
    [sym_fsi_directive_decl] = STATE(2013),
    [sym_preproc_line] = STATE(2013),
    [sym_identifier] = ACTIONS(4112),
    [anon_sym_EQ] = ACTIONS(4110),
    [anon_sym_LBRACK_LT] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4112),
    [anon_sym_return] = ACTIONS(4112),
    [anon_sym_do] = ACTIONS(4112),
    [anon_sym_let] = ACTIONS(4112),
    [anon_sym_let_BANG] = ACTIONS(4110),
    [aux_sym_access_modifier_token1] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_null] = ACTIONS(4112),
    [anon_sym_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_COLON] = ACTIONS(4110),
    [anon_sym_AMP] = ACTIONS(4112),
    [anon_sym_LBRACK] = ACTIONS(4112),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4110),
    [anon_sym_LBRACE] = ACTIONS(4112),
    [anon_sym_LT_AT] = ACTIONS(4112),
    [anon_sym_LT_AT_AT] = ACTIONS(4112),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4110),
    [anon_sym_new] = ACTIONS(4112),
    [anon_sym_with] = ACTIONS(4112),
    [anon_sym_return_BANG] = ACTIONS(4110),
    [anon_sym_yield] = ACTIONS(4112),
    [anon_sym_yield_BANG] = ACTIONS(4110),
    [anon_sym_lazy] = ACTIONS(4112),
    [anon_sym_assert] = ACTIONS(4112),
    [anon_sym_upcast] = ACTIONS(4112),
    [anon_sym_downcast] = ACTIONS(4112),
    [anon_sym_COLON_GT] = ACTIONS(4110),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4110),
    [anon_sym_for] = ACTIONS(4112),
    [anon_sym_while] = ACTIONS(4112),
    [anon_sym_if] = ACTIONS(4112),
    [anon_sym_fun] = ACTIONS(4112),
    [anon_sym_try] = ACTIONS(4112),
    [anon_sym_match] = ACTIONS(4112),
    [anon_sym_match_BANG] = ACTIONS(4110),
    [anon_sym_function] = ACTIONS(4112),
    [anon_sym_LT_DASH] = ACTIONS(4112),
    [anon_sym_DOT_LBRACK] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(4110),
    [anon_sym_use] = ACTIONS(4112),
    [anon_sym_use_BANG] = ACTIONS(4110),
    [anon_sym_do_BANG] = ACTIONS(4110),
    [anon_sym_begin] = ACTIONS(4112),
    [anon_sym_LPAREN2] = ACTIONS(4112),
    [anon_sym_DOT_DOT2] = ACTIONS(4110),
    [anon_sym_default] = ACTIONS(4112),
    [anon_sym_or] = ACTIONS(4112),
    [anon_sym_static] = ACTIONS(4112),
    [anon_sym_member] = ACTIONS(4112),
    [anon_sym_interface] = ACTIONS(4112),
    [anon_sym_abstract] = ACTIONS(4112),
    [anon_sym_val] = ACTIONS(4112),
    [anon_sym_override] = ACTIONS(4112),
    [aux_sym_char_token1] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4112),
    [anon_sym_DQUOTE] = ACTIONS(4112),
    [anon_sym_AT_DQUOTE] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [sym_bool] = ACTIONS(4112),
    [sym_unit] = ACTIONS(4110),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4112),
    [sym_op_identifier] = ACTIONS(4112),
    [anon_sym_PLUS] = ACTIONS(4112),
    [anon_sym_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_DOT] = ACTIONS(4112),
    [anon_sym_DASH_DOT] = ACTIONS(4112),
    [anon_sym_PERCENT] = ACTIONS(4112),
    [anon_sym_AMP_AMP] = ACTIONS(4112),
    [anon_sym_TILDE] = ACTIONS(4110),
    [aux_sym_prefix_op_token1] = ACTIONS(4112),
    [aux_sym_infix_op_token1] = ACTIONS(4110),
    [aux_sym_infix_op_token2] = ACTIONS(4112),
    [anon_sym_PIPE_PIPE] = ACTIONS(4112),
    [anon_sym_BANG_EQ] = ACTIONS(4112),
    [anon_sym_COLON_EQ] = ACTIONS(4110),
    [anon_sym_DOLLAR] = ACTIONS(4112),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4112),
    [sym_int] = ACTIONS(4112),
    [sym_xint] = ACTIONS(4110),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4110),
    [sym__newline] = ACTIONS(4110),
    [sym__dedent] = ACTIONS(4110),
  },
  [2014] = {
    [sym_block_comment] = STATE(2014),
    [sym_compiler_directive_decl] = STATE(2014),
    [sym_fsi_directive_decl] = STATE(2014),
    [sym_preproc_line] = STATE(2014),
    [aux_sym_type_argument_repeat1] = STATE(2014),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_GT_RBRACK] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_COLON] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_RBRACK] = ACTIONS(3478),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_RBRACE] = ACTIONS(3478),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_with] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_to] = ACTIONS(3480),
    [anon_sym_downto] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_LT_DASH] = ACTIONS(3480),
    [anon_sym_DOT_LBRACK] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_DOT_DOT2] = ACTIONS(3478),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_or] = ACTIONS(4760),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3480),
    [anon_sym_DASH_DOT] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3480),
    [aux_sym_infix_op_token1] = ACTIONS(3478),
    [aux_sym_infix_op_token2] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3480),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
  },
  [2015] = {
    [sym_block_comment] = STATE(2015),
    [sym_compiler_directive_decl] = STATE(2015),
    [sym_fsi_directive_decl] = STATE(2015),
    [sym_preproc_line] = STATE(2015),
    [sym_identifier] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4242),
    [anon_sym_LBRACK_LT] = ACTIONS(4242),
    [anon_sym_COLON] = ACTIONS(4244),
    [anon_sym_return] = ACTIONS(4244),
    [anon_sym_do] = ACTIONS(4244),
    [anon_sym_let] = ACTIONS(4244),
    [anon_sym_let_BANG] = ACTIONS(4242),
    [aux_sym_access_modifier_token1] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_null] = ACTIONS(4244),
    [anon_sym_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_COLON] = ACTIONS(4242),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4244),
    [anon_sym_LT_AT] = ACTIONS(4244),
    [anon_sym_LT_AT_AT] = ACTIONS(4244),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4242),
    [anon_sym_new] = ACTIONS(4244),
    [anon_sym_with] = ACTIONS(4244),
    [anon_sym_return_BANG] = ACTIONS(4242),
    [anon_sym_yield] = ACTIONS(4244),
    [anon_sym_yield_BANG] = ACTIONS(4242),
    [anon_sym_lazy] = ACTIONS(4244),
    [anon_sym_assert] = ACTIONS(4244),
    [anon_sym_upcast] = ACTIONS(4244),
    [anon_sym_downcast] = ACTIONS(4244),
    [anon_sym_COLON_GT] = ACTIONS(4242),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4242),
    [anon_sym_for] = ACTIONS(4244),
    [anon_sym_while] = ACTIONS(4244),
    [anon_sym_if] = ACTIONS(4244),
    [anon_sym_fun] = ACTIONS(4244),
    [anon_sym_try] = ACTIONS(4244),
    [anon_sym_match] = ACTIONS(4244),
    [anon_sym_match_BANG] = ACTIONS(4242),
    [anon_sym_function] = ACTIONS(4244),
    [anon_sym_LT_DASH] = ACTIONS(4244),
    [anon_sym_DOT_LBRACK] = ACTIONS(4242),
    [anon_sym_LT] = ACTIONS(4242),
    [anon_sym_use] = ACTIONS(4244),
    [anon_sym_use_BANG] = ACTIONS(4242),
    [anon_sym_do_BANG] = ACTIONS(4242),
    [anon_sym_begin] = ACTIONS(4244),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_DOT_DOT2] = ACTIONS(4242),
    [anon_sym_default] = ACTIONS(4244),
    [anon_sym_or] = ACTIONS(4244),
    [anon_sym_static] = ACTIONS(4244),
    [anon_sym_member] = ACTIONS(4244),
    [anon_sym_interface] = ACTIONS(4244),
    [anon_sym_abstract] = ACTIONS(4244),
    [anon_sym_val] = ACTIONS(4244),
    [anon_sym_override] = ACTIONS(4244),
    [aux_sym_char_token1] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4244),
    [anon_sym_DQUOTE] = ACTIONS(4244),
    [anon_sym_AT_DQUOTE] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [sym_bool] = ACTIONS(4244),
    [sym_unit] = ACTIONS(4242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4244),
    [sym_op_identifier] = ACTIONS(4244),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_DASH] = ACTIONS(4244),
    [anon_sym_PLUS_DOT] = ACTIONS(4244),
    [anon_sym_DASH_DOT] = ACTIONS(4244),
    [anon_sym_PERCENT] = ACTIONS(4244),
    [anon_sym_AMP_AMP] = ACTIONS(4244),
    [anon_sym_TILDE] = ACTIONS(4242),
    [aux_sym_prefix_op_token1] = ACTIONS(4244),
    [aux_sym_infix_op_token1] = ACTIONS(4242),
    [aux_sym_infix_op_token2] = ACTIONS(4244),
    [anon_sym_PIPE_PIPE] = ACTIONS(4244),
    [anon_sym_BANG_EQ] = ACTIONS(4244),
    [anon_sym_COLON_EQ] = ACTIONS(4242),
    [anon_sym_DOLLAR] = ACTIONS(4244),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4244),
    [sym_int] = ACTIONS(4244),
    [sym_xint] = ACTIONS(4242),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4242),
    [sym__newline] = ACTIONS(4242),
    [sym__dedent] = ACTIONS(4242),
  },
  [2016] = {
    [sym_block_comment] = STATE(2016),
    [sym_compiler_directive_decl] = STATE(2016),
    [sym_fsi_directive_decl] = STATE(2016),
    [sym_preproc_line] = STATE(2016),
    [sym_identifier] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4246),
    [anon_sym_LBRACK_LT] = ACTIONS(4246),
    [anon_sym_COLON] = ACTIONS(4248),
    [anon_sym_return] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4248),
    [anon_sym_let] = ACTIONS(4248),
    [anon_sym_let_BANG] = ACTIONS(4246),
    [aux_sym_access_modifier_token1] = ACTIONS(4246),
    [anon_sym_LPAREN] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_null] = ACTIONS(4248),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4248),
    [anon_sym_LT_AT] = ACTIONS(4248),
    [anon_sym_LT_AT_AT] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4246),
    [anon_sym_new] = ACTIONS(4248),
    [anon_sym_with] = ACTIONS(4248),
    [anon_sym_return_BANG] = ACTIONS(4246),
    [anon_sym_yield] = ACTIONS(4248),
    [anon_sym_yield_BANG] = ACTIONS(4246),
    [anon_sym_lazy] = ACTIONS(4248),
    [anon_sym_assert] = ACTIONS(4248),
    [anon_sym_upcast] = ACTIONS(4248),
    [anon_sym_downcast] = ACTIONS(4248),
    [anon_sym_COLON_GT] = ACTIONS(4246),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4246),
    [anon_sym_for] = ACTIONS(4248),
    [anon_sym_while] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4248),
    [anon_sym_fun] = ACTIONS(4248),
    [anon_sym_try] = ACTIONS(4248),
    [anon_sym_match] = ACTIONS(4248),
    [anon_sym_match_BANG] = ACTIONS(4246),
    [anon_sym_function] = ACTIONS(4248),
    [anon_sym_LT_DASH] = ACTIONS(4248),
    [anon_sym_DOT_LBRACK] = ACTIONS(4246),
    [anon_sym_LT] = ACTIONS(4246),
    [anon_sym_use] = ACTIONS(4248),
    [anon_sym_use_BANG] = ACTIONS(4246),
    [anon_sym_do_BANG] = ACTIONS(4246),
    [anon_sym_begin] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_DOT_DOT2] = ACTIONS(4246),
    [anon_sym_default] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4248),
    [anon_sym_static] = ACTIONS(4248),
    [anon_sym_member] = ACTIONS(4248),
    [anon_sym_interface] = ACTIONS(4248),
    [anon_sym_abstract] = ACTIONS(4248),
    [anon_sym_val] = ACTIONS(4248),
    [anon_sym_override] = ACTIONS(4248),
    [aux_sym_char_token1] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4248),
    [anon_sym_DQUOTE] = ACTIONS(4248),
    [anon_sym_AT_DQUOTE] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [sym_bool] = ACTIONS(4248),
    [sym_unit] = ACTIONS(4246),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4248),
    [sym_op_identifier] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_DOT] = ACTIONS(4248),
    [anon_sym_DASH_DOT] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_TILDE] = ACTIONS(4246),
    [aux_sym_prefix_op_token1] = ACTIONS(4248),
    [aux_sym_infix_op_token1] = ACTIONS(4246),
    [aux_sym_infix_op_token2] = ACTIONS(4248),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_COLON_EQ] = ACTIONS(4246),
    [anon_sym_DOLLAR] = ACTIONS(4248),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4248),
    [sym_int] = ACTIONS(4248),
    [sym_xint] = ACTIONS(4246),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4246),
    [sym__newline] = ACTIONS(4246),
    [sym__dedent] = ACTIONS(4246),
  },
  [2017] = {
    [sym_block_comment] = STATE(2017),
    [sym_compiler_directive_decl] = STATE(2017),
    [sym_fsi_directive_decl] = STATE(2017),
    [sym_preproc_line] = STATE(2017),
    [sym_identifier] = ACTIONS(3976),
    [anon_sym_EQ] = ACTIONS(3974),
    [anon_sym_LBRACK_LT] = ACTIONS(3974),
    [anon_sym_COLON] = ACTIONS(3976),
    [anon_sym_return] = ACTIONS(3976),
    [anon_sym_do] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_let_BANG] = ACTIONS(3974),
    [aux_sym_access_modifier_token1] = ACTIONS(3974),
    [anon_sym_LPAREN] = ACTIONS(3976),
    [anon_sym_COMMA] = ACTIONS(3974),
    [anon_sym_null] = ACTIONS(3976),
    [anon_sym_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_COLON] = ACTIONS(3974),
    [anon_sym_AMP] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(3976),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3974),
    [anon_sym_LBRACE] = ACTIONS(3976),
    [anon_sym_LT_AT] = ACTIONS(3976),
    [anon_sym_LT_AT_AT] = ACTIONS(3976),
    [anon_sym_DOT] = ACTIONS(3976),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3974),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_with] = ACTIONS(3976),
    [anon_sym_return_BANG] = ACTIONS(3974),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_yield_BANG] = ACTIONS(3974),
    [anon_sym_lazy] = ACTIONS(3976),
    [anon_sym_assert] = ACTIONS(3976),
    [anon_sym_upcast] = ACTIONS(3976),
    [anon_sym_downcast] = ACTIONS(3976),
    [anon_sym_COLON_GT] = ACTIONS(3974),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3974),
    [anon_sym_for] = ACTIONS(3976),
    [anon_sym_while] = ACTIONS(3976),
    [anon_sym_if] = ACTIONS(3976),
    [anon_sym_fun] = ACTIONS(3976),
    [anon_sym_try] = ACTIONS(3976),
    [anon_sym_match] = ACTIONS(3976),
    [anon_sym_match_BANG] = ACTIONS(3974),
    [anon_sym_function] = ACTIONS(3976),
    [anon_sym_LT_DASH] = ACTIONS(3976),
    [anon_sym_DOT_LBRACK] = ACTIONS(3974),
    [anon_sym_LT] = ACTIONS(3974),
    [anon_sym_use] = ACTIONS(3976),
    [anon_sym_use_BANG] = ACTIONS(3974),
    [anon_sym_do_BANG] = ACTIONS(3974),
    [anon_sym_begin] = ACTIONS(3976),
    [anon_sym_LPAREN2] = ACTIONS(3976),
    [anon_sym_DOT_DOT2] = ACTIONS(3974),
    [anon_sym_default] = ACTIONS(3976),
    [anon_sym_or] = ACTIONS(3976),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_member] = ACTIONS(3976),
    [anon_sym_interface] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_val] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [aux_sym_char_token1] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3976),
    [anon_sym_DQUOTE] = ACTIONS(3976),
    [anon_sym_AT_DQUOTE] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [sym_bool] = ACTIONS(3976),
    [sym_unit] = ACTIONS(3974),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3976),
    [sym_op_identifier] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3976),
    [anon_sym_DASH] = ACTIONS(3976),
    [anon_sym_PLUS_DOT] = ACTIONS(3976),
    [anon_sym_DASH_DOT] = ACTIONS(3976),
    [anon_sym_PERCENT] = ACTIONS(3976),
    [anon_sym_AMP_AMP] = ACTIONS(3976),
    [anon_sym_TILDE] = ACTIONS(3974),
    [aux_sym_prefix_op_token1] = ACTIONS(3976),
    [aux_sym_infix_op_token1] = ACTIONS(3974),
    [aux_sym_infix_op_token2] = ACTIONS(3976),
    [anon_sym_PIPE_PIPE] = ACTIONS(3976),
    [anon_sym_BANG_EQ] = ACTIONS(3976),
    [anon_sym_COLON_EQ] = ACTIONS(3974),
    [anon_sym_DOLLAR] = ACTIONS(3976),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3976),
    [sym_int] = ACTIONS(3976),
    [sym_xint] = ACTIONS(3974),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3974),
    [sym__newline] = ACTIONS(3974),
    [sym__dedent] = ACTIONS(3974),
  },
  [2018] = {
    [sym_block_comment] = STATE(2018),
    [sym_compiler_directive_decl] = STATE(2018),
    [sym_fsi_directive_decl] = STATE(2018),
    [sym_preproc_line] = STATE(2018),
    [sym_identifier] = ACTIONS(4118),
    [anon_sym_EQ] = ACTIONS(4116),
    [anon_sym_LBRACK_LT] = ACTIONS(4116),
    [anon_sym_COLON] = ACTIONS(4118),
    [anon_sym_return] = ACTIONS(4118),
    [anon_sym_do] = ACTIONS(4118),
    [anon_sym_let] = ACTIONS(4118),
    [anon_sym_let_BANG] = ACTIONS(4116),
    [aux_sym_access_modifier_token1] = ACTIONS(4116),
    [anon_sym_LPAREN] = ACTIONS(4118),
    [anon_sym_COMMA] = ACTIONS(4116),
    [anon_sym_null] = ACTIONS(4118),
    [anon_sym_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_COLON] = ACTIONS(4116),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4118),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(4118),
    [anon_sym_LT_AT] = ACTIONS(4118),
    [anon_sym_LT_AT_AT] = ACTIONS(4118),
    [anon_sym_DOT] = ACTIONS(4118),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4116),
    [anon_sym_new] = ACTIONS(4118),
    [anon_sym_with] = ACTIONS(4118),
    [anon_sym_return_BANG] = ACTIONS(4116),
    [anon_sym_yield] = ACTIONS(4118),
    [anon_sym_yield_BANG] = ACTIONS(4116),
    [anon_sym_lazy] = ACTIONS(4118),
    [anon_sym_assert] = ACTIONS(4118),
    [anon_sym_upcast] = ACTIONS(4118),
    [anon_sym_downcast] = ACTIONS(4118),
    [anon_sym_COLON_GT] = ACTIONS(4116),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4116),
    [anon_sym_for] = ACTIONS(4118),
    [anon_sym_while] = ACTIONS(4118),
    [anon_sym_if] = ACTIONS(4118),
    [anon_sym_fun] = ACTIONS(4118),
    [anon_sym_try] = ACTIONS(4118),
    [anon_sym_match] = ACTIONS(4118),
    [anon_sym_match_BANG] = ACTIONS(4116),
    [anon_sym_function] = ACTIONS(4118),
    [anon_sym_LT_DASH] = ACTIONS(4118),
    [anon_sym_DOT_LBRACK] = ACTIONS(4116),
    [anon_sym_LT] = ACTIONS(4116),
    [anon_sym_use] = ACTIONS(4118),
    [anon_sym_use_BANG] = ACTIONS(4116),
    [anon_sym_do_BANG] = ACTIONS(4116),
    [anon_sym_begin] = ACTIONS(4118),
    [anon_sym_LPAREN2] = ACTIONS(4118),
    [anon_sym_DOT_DOT2] = ACTIONS(4116),
    [anon_sym_default] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [anon_sym_static] = ACTIONS(4118),
    [anon_sym_member] = ACTIONS(4118),
    [anon_sym_interface] = ACTIONS(4118),
    [anon_sym_abstract] = ACTIONS(4118),
    [anon_sym_val] = ACTIONS(4118),
    [anon_sym_override] = ACTIONS(4118),
    [aux_sym_char_token1] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4118),
    [anon_sym_DQUOTE] = ACTIONS(4118),
    [anon_sym_AT_DQUOTE] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [sym_bool] = ACTIONS(4118),
    [sym_unit] = ACTIONS(4116),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4118),
    [sym_op_identifier] = ACTIONS(4118),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_PLUS_DOT] = ACTIONS(4118),
    [anon_sym_DASH_DOT] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_AMP_AMP] = ACTIONS(4118),
    [anon_sym_TILDE] = ACTIONS(4116),
    [aux_sym_prefix_op_token1] = ACTIONS(4118),
    [aux_sym_infix_op_token1] = ACTIONS(4116),
    [aux_sym_infix_op_token2] = ACTIONS(4118),
    [anon_sym_PIPE_PIPE] = ACTIONS(4118),
    [anon_sym_BANG_EQ] = ACTIONS(4118),
    [anon_sym_COLON_EQ] = ACTIONS(4116),
    [anon_sym_DOLLAR] = ACTIONS(4118),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4118),
    [sym_int] = ACTIONS(4118),
    [sym_xint] = ACTIONS(4116),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4116),
    [sym__newline] = ACTIONS(4116),
    [sym__dedent] = ACTIONS(4116),
  },
  [2019] = {
    [sym_block_comment] = STATE(2019),
    [sym_compiler_directive_decl] = STATE(2019),
    [sym_fsi_directive_decl] = STATE(2019),
    [sym_preproc_line] = STATE(2019),
    [sym_identifier] = ACTIONS(4158),
    [anon_sym_EQ] = ACTIONS(4156),
    [anon_sym_LBRACK_LT] = ACTIONS(4156),
    [anon_sym_COLON] = ACTIONS(4158),
    [anon_sym_return] = ACTIONS(4158),
    [anon_sym_do] = ACTIONS(4158),
    [anon_sym_let] = ACTIONS(4158),
    [anon_sym_let_BANG] = ACTIONS(4156),
    [aux_sym_access_modifier_token1] = ACTIONS(4156),
    [anon_sym_LPAREN] = ACTIONS(4158),
    [anon_sym_COMMA] = ACTIONS(4156),
    [anon_sym_null] = ACTIONS(4158),
    [anon_sym_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_COLON] = ACTIONS(4156),
    [anon_sym_AMP] = ACTIONS(4158),
    [anon_sym_LBRACK] = ACTIONS(4158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(4158),
    [anon_sym_LT_AT] = ACTIONS(4158),
    [anon_sym_LT_AT_AT] = ACTIONS(4158),
    [anon_sym_DOT] = ACTIONS(4158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4156),
    [anon_sym_new] = ACTIONS(4158),
    [anon_sym_with] = ACTIONS(4158),
    [anon_sym_return_BANG] = ACTIONS(4156),
    [anon_sym_yield] = ACTIONS(4158),
    [anon_sym_yield_BANG] = ACTIONS(4156),
    [anon_sym_lazy] = ACTIONS(4158),
    [anon_sym_assert] = ACTIONS(4158),
    [anon_sym_upcast] = ACTIONS(4158),
    [anon_sym_downcast] = ACTIONS(4158),
    [anon_sym_COLON_GT] = ACTIONS(4156),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4156),
    [anon_sym_for] = ACTIONS(4158),
    [anon_sym_while] = ACTIONS(4158),
    [anon_sym_if] = ACTIONS(4158),
    [anon_sym_fun] = ACTIONS(4158),
    [anon_sym_try] = ACTIONS(4158),
    [anon_sym_match] = ACTIONS(4158),
    [anon_sym_match_BANG] = ACTIONS(4156),
    [anon_sym_function] = ACTIONS(4158),
    [anon_sym_LT_DASH] = ACTIONS(4158),
    [anon_sym_DOT_LBRACK] = ACTIONS(4156),
    [anon_sym_LT] = ACTIONS(4156),
    [anon_sym_use] = ACTIONS(4158),
    [anon_sym_use_BANG] = ACTIONS(4156),
    [anon_sym_do_BANG] = ACTIONS(4156),
    [anon_sym_begin] = ACTIONS(4158),
    [anon_sym_LPAREN2] = ACTIONS(4158),
    [anon_sym_default] = ACTIONS(4158),
    [anon_sym_or] = ACTIONS(4158),
    [anon_sym_static] = ACTIONS(4158),
    [anon_sym_member] = ACTIONS(4158),
    [anon_sym_interface] = ACTIONS(4158),
    [anon_sym_abstract] = ACTIONS(4158),
    [anon_sym_val] = ACTIONS(4158),
    [anon_sym_override] = ACTIONS(4158),
    [anon_sym_inherit] = ACTIONS(4158),
    [aux_sym_char_token1] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4158),
    [anon_sym_DQUOTE] = ACTIONS(4158),
    [anon_sym_AT_DQUOTE] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [sym_bool] = ACTIONS(4158),
    [sym_unit] = ACTIONS(4156),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4158),
    [sym_op_identifier] = ACTIONS(4158),
    [anon_sym_PLUS] = ACTIONS(4158),
    [anon_sym_DASH] = ACTIONS(4158),
    [anon_sym_PLUS_DOT] = ACTIONS(4158),
    [anon_sym_DASH_DOT] = ACTIONS(4158),
    [anon_sym_PERCENT] = ACTIONS(4158),
    [anon_sym_AMP_AMP] = ACTIONS(4158),
    [anon_sym_TILDE] = ACTIONS(4156),
    [aux_sym_prefix_op_token1] = ACTIONS(4158),
    [aux_sym_infix_op_token1] = ACTIONS(4156),
    [aux_sym_infix_op_token2] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE] = ACTIONS(4158),
    [anon_sym_BANG_EQ] = ACTIONS(4158),
    [anon_sym_COLON_EQ] = ACTIONS(4156),
    [anon_sym_DOLLAR] = ACTIONS(4158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4158),
    [sym_int] = ACTIONS(4158),
    [sym_xint] = ACTIONS(4156),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4156),
    [anon_sym_POUNDendif] = ACTIONS(4156),
    [sym__newline] = ACTIONS(4156),
  },
  [2020] = {
    [sym_block_comment] = STATE(2020),
    [sym_compiler_directive_decl] = STATE(2020),
    [sym_fsi_directive_decl] = STATE(2020),
    [sym_preproc_line] = STATE(2020),
    [sym_identifier] = ACTIONS(4170),
    [anon_sym_EQ] = ACTIONS(4168),
    [anon_sym_LBRACK_LT] = ACTIONS(4168),
    [anon_sym_COLON] = ACTIONS(4170),
    [anon_sym_return] = ACTIONS(4170),
    [anon_sym_do] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_let_BANG] = ACTIONS(4168),
    [aux_sym_access_modifier_token1] = ACTIONS(4168),
    [anon_sym_LPAREN] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4168),
    [anon_sym_null] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_COLON] = ACTIONS(4168),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4170),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4168),
    [anon_sym_LBRACE] = ACTIONS(4170),
    [anon_sym_LT_AT] = ACTIONS(4170),
    [anon_sym_LT_AT_AT] = ACTIONS(4170),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4168),
    [anon_sym_new] = ACTIONS(4170),
    [anon_sym_with] = ACTIONS(4170),
    [anon_sym_return_BANG] = ACTIONS(4168),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_yield_BANG] = ACTIONS(4168),
    [anon_sym_lazy] = ACTIONS(4170),
    [anon_sym_assert] = ACTIONS(4170),
    [anon_sym_upcast] = ACTIONS(4170),
    [anon_sym_downcast] = ACTIONS(4170),
    [anon_sym_COLON_GT] = ACTIONS(4168),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4168),
    [anon_sym_for] = ACTIONS(4170),
    [anon_sym_while] = ACTIONS(4170),
    [anon_sym_if] = ACTIONS(4170),
    [anon_sym_fun] = ACTIONS(4170),
    [anon_sym_try] = ACTIONS(4170),
    [anon_sym_match] = ACTIONS(4170),
    [anon_sym_match_BANG] = ACTIONS(4168),
    [anon_sym_function] = ACTIONS(4170),
    [anon_sym_LT_DASH] = ACTIONS(4170),
    [anon_sym_DOT_LBRACK] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4168),
    [anon_sym_use] = ACTIONS(4170),
    [anon_sym_use_BANG] = ACTIONS(4168),
    [anon_sym_do_BANG] = ACTIONS(4168),
    [anon_sym_begin] = ACTIONS(4170),
    [anon_sym_LPAREN2] = ACTIONS(4170),
    [anon_sym_default] = ACTIONS(4170),
    [anon_sym_or] = ACTIONS(4170),
    [anon_sym_static] = ACTIONS(4170),
    [anon_sym_member] = ACTIONS(4170),
    [anon_sym_interface] = ACTIONS(4170),
    [anon_sym_abstract] = ACTIONS(4170),
    [anon_sym_val] = ACTIONS(4170),
    [anon_sym_override] = ACTIONS(4170),
    [anon_sym_inherit] = ACTIONS(4170),
    [aux_sym_char_token1] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4170),
    [anon_sym_DQUOTE] = ACTIONS(4170),
    [anon_sym_AT_DQUOTE] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [sym_bool] = ACTIONS(4170),
    [sym_unit] = ACTIONS(4168),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4170),
    [sym_op_identifier] = ACTIONS(4170),
    [anon_sym_PLUS] = ACTIONS(4170),
    [anon_sym_DASH] = ACTIONS(4170),
    [anon_sym_PLUS_DOT] = ACTIONS(4170),
    [anon_sym_DASH_DOT] = ACTIONS(4170),
    [anon_sym_PERCENT] = ACTIONS(4170),
    [anon_sym_AMP_AMP] = ACTIONS(4170),
    [anon_sym_TILDE] = ACTIONS(4168),
    [aux_sym_prefix_op_token1] = ACTIONS(4170),
    [aux_sym_infix_op_token1] = ACTIONS(4168),
    [aux_sym_infix_op_token2] = ACTIONS(4170),
    [anon_sym_PIPE_PIPE] = ACTIONS(4170),
    [anon_sym_BANG_EQ] = ACTIONS(4170),
    [anon_sym_COLON_EQ] = ACTIONS(4168),
    [anon_sym_DOLLAR] = ACTIONS(4170),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4170),
    [sym_int] = ACTIONS(4170),
    [sym_xint] = ACTIONS(4168),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4168),
    [anon_sym_POUNDendif] = ACTIONS(4168),
    [sym__newline] = ACTIONS(4168),
  },
  [2021] = {
    [sym_block_comment] = STATE(2021),
    [sym_compiler_directive_decl] = STATE(2021),
    [sym_fsi_directive_decl] = STATE(2021),
    [sym_preproc_line] = STATE(2021),
    [sym_identifier] = ACTIONS(3917),
    [anon_sym_EQ] = ACTIONS(3915),
    [anon_sym_LBRACK_LT] = ACTIONS(3915),
    [anon_sym_COLON] = ACTIONS(3917),
    [anon_sym_return] = ACTIONS(3917),
    [anon_sym_do] = ACTIONS(3917),
    [anon_sym_let] = ACTIONS(3917),
    [anon_sym_let_BANG] = ACTIONS(3915),
    [aux_sym_access_modifier_token1] = ACTIONS(3915),
    [anon_sym_LPAREN] = ACTIONS(3917),
    [anon_sym_COMMA] = ACTIONS(3915),
    [anon_sym_null] = ACTIONS(3917),
    [anon_sym_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_COLON] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(3917),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3915),
    [anon_sym_LBRACE] = ACTIONS(3917),
    [anon_sym_LT_AT] = ACTIONS(3917),
    [anon_sym_LT_AT_AT] = ACTIONS(3917),
    [anon_sym_DOT] = ACTIONS(3917),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3915),
    [anon_sym_new] = ACTIONS(3917),
    [anon_sym_with] = ACTIONS(3917),
    [anon_sym_return_BANG] = ACTIONS(3915),
    [anon_sym_yield] = ACTIONS(3917),
    [anon_sym_yield_BANG] = ACTIONS(3915),
    [anon_sym_lazy] = ACTIONS(3917),
    [anon_sym_assert] = ACTIONS(3917),
    [anon_sym_upcast] = ACTIONS(3917),
    [anon_sym_downcast] = ACTIONS(3917),
    [anon_sym_COLON_GT] = ACTIONS(3915),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3915),
    [anon_sym_for] = ACTIONS(3917),
    [anon_sym_while] = ACTIONS(3917),
    [anon_sym_if] = ACTIONS(3917),
    [anon_sym_fun] = ACTIONS(3917),
    [anon_sym_try] = ACTIONS(3917),
    [anon_sym_match] = ACTIONS(3917),
    [anon_sym_match_BANG] = ACTIONS(3915),
    [anon_sym_function] = ACTIONS(3917),
    [anon_sym_LT_DASH] = ACTIONS(3917),
    [anon_sym_DOT_LBRACK] = ACTIONS(3915),
    [anon_sym_LT] = ACTIONS(3915),
    [anon_sym_use] = ACTIONS(3917),
    [anon_sym_use_BANG] = ACTIONS(3915),
    [anon_sym_do_BANG] = ACTIONS(3915),
    [anon_sym_begin] = ACTIONS(3917),
    [anon_sym_LPAREN2] = ACTIONS(3917),
    [anon_sym_DOT_DOT2] = ACTIONS(3915),
    [anon_sym_default] = ACTIONS(3917),
    [anon_sym_or] = ACTIONS(3917),
    [anon_sym_static] = ACTIONS(3917),
    [anon_sym_member] = ACTIONS(3917),
    [anon_sym_interface] = ACTIONS(3917),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_val] = ACTIONS(3917),
    [anon_sym_override] = ACTIONS(3917),
    [aux_sym_char_token1] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_AT_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [sym_bool] = ACTIONS(3917),
    [sym_unit] = ACTIONS(3915),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3917),
    [sym_op_identifier] = ACTIONS(3917),
    [anon_sym_PLUS] = ACTIONS(3917),
    [anon_sym_DASH] = ACTIONS(3917),
    [anon_sym_PLUS_DOT] = ACTIONS(3917),
    [anon_sym_DASH_DOT] = ACTIONS(3917),
    [anon_sym_PERCENT] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_TILDE] = ACTIONS(3915),
    [aux_sym_prefix_op_token1] = ACTIONS(3917),
    [aux_sym_infix_op_token1] = ACTIONS(3915),
    [aux_sym_infix_op_token2] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_BANG_EQ] = ACTIONS(3917),
    [anon_sym_COLON_EQ] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3917),
    [sym_int] = ACTIONS(3917),
    [sym_xint] = ACTIONS(3915),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3915),
    [sym__newline] = ACTIONS(3915),
    [sym__dedent] = ACTIONS(3915),
  },
  [2022] = {
    [sym_block_comment] = STATE(2022),
    [sym_compiler_directive_decl] = STATE(2022),
    [sym_fsi_directive_decl] = STATE(2022),
    [sym_preproc_line] = STATE(2022),
    [sym_identifier] = ACTIONS(3931),
    [anon_sym_EQ] = ACTIONS(3929),
    [anon_sym_LBRACK_LT] = ACTIONS(3929),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_do] = ACTIONS(3931),
    [anon_sym_let] = ACTIONS(3931),
    [anon_sym_let_BANG] = ACTIONS(3929),
    [aux_sym_access_modifier_token1] = ACTIONS(3929),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_COMMA] = ACTIONS(3929),
    [anon_sym_null] = ACTIONS(3931),
    [anon_sym_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_COLON] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3931),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_LT_AT] = ACTIONS(3931),
    [anon_sym_LT_AT_AT] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3931),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3929),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3931),
    [anon_sym_return_BANG] = ACTIONS(3929),
    [anon_sym_yield] = ACTIONS(3931),
    [anon_sym_yield_BANG] = ACTIONS(3929),
    [anon_sym_lazy] = ACTIONS(3931),
    [anon_sym_assert] = ACTIONS(3931),
    [anon_sym_upcast] = ACTIONS(3931),
    [anon_sym_downcast] = ACTIONS(3931),
    [anon_sym_COLON_GT] = ACTIONS(3929),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3929),
    [anon_sym_for] = ACTIONS(3931),
    [anon_sym_while] = ACTIONS(3931),
    [anon_sym_if] = ACTIONS(3931),
    [anon_sym_fun] = ACTIONS(3931),
    [anon_sym_try] = ACTIONS(3931),
    [anon_sym_match] = ACTIONS(3931),
    [anon_sym_match_BANG] = ACTIONS(3929),
    [anon_sym_function] = ACTIONS(3931),
    [anon_sym_LT_DASH] = ACTIONS(3931),
    [anon_sym_DOT_LBRACK] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_use] = ACTIONS(3931),
    [anon_sym_use_BANG] = ACTIONS(3929),
    [anon_sym_do_BANG] = ACTIONS(3929),
    [anon_sym_begin] = ACTIONS(3931),
    [anon_sym_LPAREN2] = ACTIONS(3931),
    [anon_sym_DOT_DOT2] = ACTIONS(3929),
    [anon_sym_default] = ACTIONS(3931),
    [anon_sym_or] = ACTIONS(3931),
    [anon_sym_static] = ACTIONS(3931),
    [anon_sym_member] = ACTIONS(3931),
    [anon_sym_interface] = ACTIONS(3931),
    [anon_sym_abstract] = ACTIONS(3931),
    [anon_sym_val] = ACTIONS(3931),
    [anon_sym_override] = ACTIONS(3931),
    [aux_sym_char_token1] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3931),
    [anon_sym_DQUOTE] = ACTIONS(3931),
    [anon_sym_AT_DQUOTE] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [sym_bool] = ACTIONS(3931),
    [sym_unit] = ACTIONS(3929),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3931),
    [sym_op_identifier] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3931),
    [anon_sym_DASH] = ACTIONS(3931),
    [anon_sym_PLUS_DOT] = ACTIONS(3931),
    [anon_sym_DASH_DOT] = ACTIONS(3931),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_TILDE] = ACTIONS(3929),
    [aux_sym_prefix_op_token1] = ACTIONS(3931),
    [aux_sym_infix_op_token1] = ACTIONS(3929),
    [aux_sym_infix_op_token2] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_COLON_EQ] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3931),
    [sym_int] = ACTIONS(3931),
    [sym_xint] = ACTIONS(3929),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3929),
    [sym__newline] = ACTIONS(3929),
    [sym__dedent] = ACTIONS(3929),
  },
  [2023] = {
    [sym_block_comment] = STATE(2023),
    [sym_compiler_directive_decl] = STATE(2023),
    [sym_fsi_directive_decl] = STATE(2023),
    [sym_preproc_line] = STATE(2023),
    [sym_identifier] = ACTIONS(4162),
    [anon_sym_EQ] = ACTIONS(4160),
    [anon_sym_LBRACK_LT] = ACTIONS(4160),
    [anon_sym_COLON] = ACTIONS(4162),
    [anon_sym_return] = ACTIONS(4162),
    [anon_sym_do] = ACTIONS(4162),
    [anon_sym_let] = ACTIONS(4162),
    [anon_sym_let_BANG] = ACTIONS(4160),
    [aux_sym_access_modifier_token1] = ACTIONS(4160),
    [anon_sym_LPAREN] = ACTIONS(4162),
    [anon_sym_COMMA] = ACTIONS(4160),
    [anon_sym_null] = ACTIONS(4162),
    [anon_sym_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4160),
    [anon_sym_AMP] = ACTIONS(4162),
    [anon_sym_LBRACK] = ACTIONS(4162),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4160),
    [anon_sym_LBRACE] = ACTIONS(4162),
    [anon_sym_LT_AT] = ACTIONS(4162),
    [anon_sym_LT_AT_AT] = ACTIONS(4162),
    [anon_sym_DOT] = ACTIONS(4162),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4160),
    [anon_sym_new] = ACTIONS(4162),
    [anon_sym_with] = ACTIONS(4162),
    [anon_sym_return_BANG] = ACTIONS(4160),
    [anon_sym_yield] = ACTIONS(4162),
    [anon_sym_yield_BANG] = ACTIONS(4160),
    [anon_sym_lazy] = ACTIONS(4162),
    [anon_sym_assert] = ACTIONS(4162),
    [anon_sym_upcast] = ACTIONS(4162),
    [anon_sym_downcast] = ACTIONS(4162),
    [anon_sym_COLON_GT] = ACTIONS(4160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4160),
    [anon_sym_for] = ACTIONS(4162),
    [anon_sym_while] = ACTIONS(4162),
    [anon_sym_if] = ACTIONS(4162),
    [anon_sym_fun] = ACTIONS(4162),
    [anon_sym_try] = ACTIONS(4162),
    [anon_sym_match] = ACTIONS(4162),
    [anon_sym_match_BANG] = ACTIONS(4160),
    [anon_sym_function] = ACTIONS(4162),
    [anon_sym_LT_DASH] = ACTIONS(4162),
    [anon_sym_DOT_LBRACK] = ACTIONS(4160),
    [anon_sym_LT] = ACTIONS(4160),
    [anon_sym_use] = ACTIONS(4162),
    [anon_sym_use_BANG] = ACTIONS(4160),
    [anon_sym_do_BANG] = ACTIONS(4160),
    [anon_sym_begin] = ACTIONS(4162),
    [anon_sym_LPAREN2] = ACTIONS(4162),
    [anon_sym_default] = ACTIONS(4162),
    [anon_sym_or] = ACTIONS(4162),
    [anon_sym_static] = ACTIONS(4162),
    [anon_sym_member] = ACTIONS(4162),
    [anon_sym_interface] = ACTIONS(4162),
    [anon_sym_abstract] = ACTIONS(4162),
    [anon_sym_val] = ACTIONS(4162),
    [anon_sym_override] = ACTIONS(4162),
    [anon_sym_inherit] = ACTIONS(4162),
    [aux_sym_char_token1] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4162),
    [anon_sym_DQUOTE] = ACTIONS(4162),
    [anon_sym_AT_DQUOTE] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [sym_bool] = ACTIONS(4162),
    [sym_unit] = ACTIONS(4160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4162),
    [sym_op_identifier] = ACTIONS(4162),
    [anon_sym_PLUS] = ACTIONS(4162),
    [anon_sym_DASH] = ACTIONS(4162),
    [anon_sym_PLUS_DOT] = ACTIONS(4162),
    [anon_sym_DASH_DOT] = ACTIONS(4162),
    [anon_sym_PERCENT] = ACTIONS(4162),
    [anon_sym_AMP_AMP] = ACTIONS(4162),
    [anon_sym_TILDE] = ACTIONS(4160),
    [aux_sym_prefix_op_token1] = ACTIONS(4162),
    [aux_sym_infix_op_token1] = ACTIONS(4160),
    [aux_sym_infix_op_token2] = ACTIONS(4162),
    [anon_sym_PIPE_PIPE] = ACTIONS(4162),
    [anon_sym_BANG_EQ] = ACTIONS(4162),
    [anon_sym_COLON_EQ] = ACTIONS(4160),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4162),
    [sym_int] = ACTIONS(4162),
    [sym_xint] = ACTIONS(4160),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4160),
    [anon_sym_POUNDendif] = ACTIONS(4160),
    [sym__newline] = ACTIONS(4160),
  },
  [2024] = {
    [sym_block_comment] = STATE(2024),
    [sym_compiler_directive_decl] = STATE(2024),
    [sym_fsi_directive_decl] = STATE(2024),
    [sym_preproc_line] = STATE(2024),
    [sym_identifier] = ACTIONS(4182),
    [anon_sym_EQ] = ACTIONS(3689),
    [anon_sym_LBRACK_LT] = ACTIONS(3689),
    [anon_sym_COLON] = ACTIONS(4182),
    [anon_sym_return] = ACTIONS(4182),
    [anon_sym_do] = ACTIONS(4182),
    [anon_sym_let] = ACTIONS(4182),
    [anon_sym_let_BANG] = ACTIONS(3689),
    [aux_sym_access_modifier_token1] = ACTIONS(3689),
    [anon_sym_LPAREN] = ACTIONS(4182),
    [anon_sym_COMMA] = ACTIONS(3689),
    [anon_sym_null] = ACTIONS(4182),
    [anon_sym_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3689),
    [anon_sym_LBRACE] = ACTIONS(4182),
    [anon_sym_LT_AT] = ACTIONS(4182),
    [anon_sym_LT_AT_AT] = ACTIONS(4182),
    [anon_sym_DOT] = ACTIONS(4182),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3689),
    [anon_sym_new] = ACTIONS(4182),
    [anon_sym_with] = ACTIONS(4182),
    [anon_sym_return_BANG] = ACTIONS(3689),
    [anon_sym_yield] = ACTIONS(4182),
    [anon_sym_yield_BANG] = ACTIONS(3689),
    [anon_sym_lazy] = ACTIONS(4182),
    [anon_sym_assert] = ACTIONS(4182),
    [anon_sym_upcast] = ACTIONS(4182),
    [anon_sym_downcast] = ACTIONS(4182),
    [anon_sym_COLON_GT] = ACTIONS(3689),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3689),
    [anon_sym_for] = ACTIONS(4182),
    [anon_sym_while] = ACTIONS(4182),
    [anon_sym_if] = ACTIONS(4182),
    [anon_sym_fun] = ACTIONS(4182),
    [anon_sym_try] = ACTIONS(4182),
    [anon_sym_match] = ACTIONS(4182),
    [anon_sym_match_BANG] = ACTIONS(3689),
    [anon_sym_function] = ACTIONS(4182),
    [anon_sym_LT_DASH] = ACTIONS(4182),
    [anon_sym_DOT_LBRACK] = ACTIONS(3689),
    [anon_sym_LT] = ACTIONS(3689),
    [anon_sym_use] = ACTIONS(4182),
    [anon_sym_use_BANG] = ACTIONS(3689),
    [anon_sym_do_BANG] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(4182),
    [anon_sym_LPAREN2] = ACTIONS(4182),
    [anon_sym_default] = ACTIONS(4182),
    [anon_sym_or] = ACTIONS(4182),
    [anon_sym_static] = ACTIONS(4182),
    [anon_sym_member] = ACTIONS(4182),
    [anon_sym_interface] = ACTIONS(4182),
    [anon_sym_abstract] = ACTIONS(4182),
    [anon_sym_val] = ACTIONS(4182),
    [anon_sym_override] = ACTIONS(4182),
    [anon_sym_inherit] = ACTIONS(4182),
    [aux_sym_char_token1] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4182),
    [anon_sym_DQUOTE] = ACTIONS(4182),
    [anon_sym_AT_DQUOTE] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [sym_bool] = ACTIONS(4182),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4182),
    [sym_op_identifier] = ACTIONS(4182),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_PLUS_DOT] = ACTIONS(4182),
    [anon_sym_DASH_DOT] = ACTIONS(4182),
    [anon_sym_PERCENT] = ACTIONS(4182),
    [anon_sym_AMP_AMP] = ACTIONS(4182),
    [anon_sym_TILDE] = ACTIONS(3689),
    [aux_sym_prefix_op_token1] = ACTIONS(4182),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token2] = ACTIONS(4182),
    [anon_sym_PIPE_PIPE] = ACTIONS(4182),
    [anon_sym_BANG_EQ] = ACTIONS(4182),
    [anon_sym_COLON_EQ] = ACTIONS(3689),
    [anon_sym_DOLLAR] = ACTIONS(4182),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4182),
    [sym_int] = ACTIONS(4182),
    [sym_xint] = ACTIONS(3689),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3689),
    [anon_sym_POUNDendif] = ACTIONS(3689),
    [sym__newline] = ACTIONS(3689),
  },
  [2025] = {
    [sym_block_comment] = STATE(2025),
    [sym_compiler_directive_decl] = STATE(2025),
    [sym_fsi_directive_decl] = STATE(2025),
    [sym_preproc_line] = STATE(2025),
    [sym_identifier] = ACTIONS(4180),
    [anon_sym_EQ] = ACTIONS(4178),
    [anon_sym_LBRACK_LT] = ACTIONS(4178),
    [anon_sym_COLON] = ACTIONS(4180),
    [anon_sym_return] = ACTIONS(4180),
    [anon_sym_do] = ACTIONS(4180),
    [anon_sym_and] = ACTIONS(4180),
    [anon_sym_let] = ACTIONS(4180),
    [anon_sym_let_BANG] = ACTIONS(4178),
    [aux_sym_access_modifier_token1] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(4180),
    [anon_sym_COMMA] = ACTIONS(4178),
    [anon_sym_null] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_COLON] = ACTIONS(4178),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4180),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4180),
    [anon_sym_LT_AT] = ACTIONS(4180),
    [anon_sym_LT_AT_AT] = ACTIONS(4180),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4178),
    [anon_sym_new] = ACTIONS(4180),
    [anon_sym_with] = ACTIONS(4180),
    [anon_sym_return_BANG] = ACTIONS(4178),
    [anon_sym_yield] = ACTIONS(4180),
    [anon_sym_yield_BANG] = ACTIONS(4178),
    [anon_sym_lazy] = ACTIONS(4180),
    [anon_sym_assert] = ACTIONS(4180),
    [anon_sym_upcast] = ACTIONS(4180),
    [anon_sym_downcast] = ACTIONS(4180),
    [anon_sym_COLON_GT] = ACTIONS(4178),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4178),
    [anon_sym_for] = ACTIONS(4180),
    [anon_sym_while] = ACTIONS(4180),
    [anon_sym_if] = ACTIONS(4180),
    [anon_sym_fun] = ACTIONS(4180),
    [anon_sym_try] = ACTIONS(4180),
    [anon_sym_match] = ACTIONS(4180),
    [anon_sym_match_BANG] = ACTIONS(4178),
    [anon_sym_function] = ACTIONS(4180),
    [anon_sym_LT_DASH] = ACTIONS(4180),
    [anon_sym_DOT_LBRACK] = ACTIONS(4178),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_use] = ACTIONS(4180),
    [anon_sym_use_BANG] = ACTIONS(4178),
    [anon_sym_do_BANG] = ACTIONS(4178),
    [anon_sym_begin] = ACTIONS(4180),
    [anon_sym_LPAREN2] = ACTIONS(4180),
    [anon_sym_default] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [anon_sym_static] = ACTIONS(4180),
    [anon_sym_member] = ACTIONS(4180),
    [anon_sym_interface] = ACTIONS(4180),
    [anon_sym_abstract] = ACTIONS(4180),
    [anon_sym_val] = ACTIONS(4180),
    [anon_sym_override] = ACTIONS(4180),
    [aux_sym_char_token1] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4180),
    [anon_sym_DQUOTE] = ACTIONS(4180),
    [anon_sym_AT_DQUOTE] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [sym_bool] = ACTIONS(4180),
    [sym_unit] = ACTIONS(4178),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4180),
    [sym_op_identifier] = ACTIONS(4180),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_PLUS_DOT] = ACTIONS(4180),
    [anon_sym_DASH_DOT] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_TILDE] = ACTIONS(4178),
    [aux_sym_prefix_op_token1] = ACTIONS(4180),
    [aux_sym_infix_op_token1] = ACTIONS(4178),
    [aux_sym_infix_op_token2] = ACTIONS(4180),
    [anon_sym_PIPE_PIPE] = ACTIONS(4180),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_COLON_EQ] = ACTIONS(4178),
    [anon_sym_DOLLAR] = ACTIONS(4180),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4180),
    [sym_int] = ACTIONS(4180),
    [sym_xint] = ACTIONS(4178),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4178),
    [sym__newline] = ACTIONS(4178),
    [sym__dedent] = ACTIONS(4178),
  },
  [2026] = {
    [sym__else_expression] = STATE(2534),
    [sym_elif_expression] = STATE(2297),
    [sym_block_comment] = STATE(2026),
    [sym_compiler_directive_decl] = STATE(2026),
    [sym_fsi_directive_decl] = STATE(2026),
    [sym_preproc_line] = STATE(2026),
    [aux_sym_if_expression_repeat1] = STATE(2251),
    [sym_identifier] = ACTIONS(3457),
    [anon_sym_EQ] = ACTIONS(3455),
    [anon_sym_GT_RBRACK] = ACTIONS(3455),
    [anon_sym_COLON] = ACTIONS(3457),
    [anon_sym_return] = ACTIONS(3457),
    [anon_sym_do] = ACTIONS(3457),
    [anon_sym_let] = ACTIONS(3457),
    [anon_sym_let_BANG] = ACTIONS(3455),
    [anon_sym_LPAREN] = ACTIONS(3457),
    [anon_sym_COMMA] = ACTIONS(3455),
    [anon_sym_null] = ACTIONS(3457),
    [anon_sym_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_COLON] = ACTIONS(3455),
    [anon_sym_AMP] = ACTIONS(3457),
    [anon_sym_LBRACK] = ACTIONS(3457),
    [anon_sym_RBRACK] = ACTIONS(3455),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3457),
    [anon_sym_RBRACE] = ACTIONS(3455),
    [anon_sym_LT_AT] = ACTIONS(3457),
    [anon_sym_LT_AT_AT] = ACTIONS(3457),
    [anon_sym_DOT] = ACTIONS(3457),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3457),
    [anon_sym_with] = ACTIONS(3457),
    [anon_sym_return_BANG] = ACTIONS(3455),
    [anon_sym_yield] = ACTIONS(3457),
    [anon_sym_yield_BANG] = ACTIONS(3455),
    [anon_sym_lazy] = ACTIONS(3457),
    [anon_sym_assert] = ACTIONS(3457),
    [anon_sym_upcast] = ACTIONS(3457),
    [anon_sym_downcast] = ACTIONS(3457),
    [anon_sym_COLON_GT] = ACTIONS(3455),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3457),
    [anon_sym_to] = ACTIONS(3457),
    [anon_sym_downto] = ACTIONS(3457),
    [anon_sym_while] = ACTIONS(3457),
    [anon_sym_else] = ACTIONS(4745),
    [anon_sym_elif] = ACTIONS(4747),
    [anon_sym_if] = ACTIONS(3457),
    [anon_sym_fun] = ACTIONS(3457),
    [anon_sym_try] = ACTIONS(3457),
    [anon_sym_match] = ACTIONS(3457),
    [anon_sym_match_BANG] = ACTIONS(3455),
    [anon_sym_function] = ACTIONS(3457),
    [anon_sym_LT_DASH] = ACTIONS(3457),
    [anon_sym_DOT_LBRACK] = ACTIONS(3455),
    [anon_sym_LT] = ACTIONS(3455),
    [anon_sym_use] = ACTIONS(3457),
    [anon_sym_use_BANG] = ACTIONS(3455),
    [anon_sym_do_BANG] = ACTIONS(3455),
    [anon_sym_begin] = ACTIONS(3457),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_DOT_DOT2] = ACTIONS(3455),
    [anon_sym_or] = ACTIONS(3457),
    [aux_sym_char_token1] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [anon_sym_AT_DQUOTE] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [sym_bool] = ACTIONS(3457),
    [sym_unit] = ACTIONS(3455),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3457),
    [sym_op_identifier] = ACTIONS(3457),
    [anon_sym_PLUS] = ACTIONS(3457),
    [anon_sym_DASH] = ACTIONS(3457),
    [anon_sym_PLUS_DOT] = ACTIONS(3457),
    [anon_sym_DASH_DOT] = ACTIONS(3457),
    [anon_sym_PERCENT] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3455),
    [aux_sym_prefix_op_token1] = ACTIONS(3457),
    [aux_sym_infix_op_token1] = ACTIONS(3455),
    [aux_sym_infix_op_token2] = ACTIONS(3457),
    [anon_sym_PIPE_PIPE] = ACTIONS(3457),
    [anon_sym_BANG_EQ] = ACTIONS(3457),
    [anon_sym_COLON_EQ] = ACTIONS(3455),
    [anon_sym_DOLLAR] = ACTIONS(3457),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3457),
    [sym_int] = ACTIONS(3457),
    [sym_xint] = ACTIONS(3455),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3455),
    [sym__newline] = ACTIONS(3455),
  },
  [2027] = {
    [sym_block_comment] = STATE(2027),
    [sym_compiler_directive_decl] = STATE(2027),
    [sym_fsi_directive_decl] = STATE(2027),
    [sym_preproc_line] = STATE(2027),
    [sym_identifier] = ACTIONS(3942),
    [anon_sym_EQ] = ACTIONS(3940),
    [anon_sym_LBRACK_LT] = ACTIONS(3940),
    [anon_sym_COLON] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_let_BANG] = ACTIONS(3940),
    [aux_sym_access_modifier_token1] = ACTIONS(3940),
    [anon_sym_LPAREN] = ACTIONS(3942),
    [anon_sym_COMMA] = ACTIONS(3940),
    [anon_sym_null] = ACTIONS(3942),
    [anon_sym_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3940),
    [anon_sym_LBRACE] = ACTIONS(3942),
    [anon_sym_LT_AT] = ACTIONS(3942),
    [anon_sym_LT_AT_AT] = ACTIONS(3942),
    [anon_sym_DOT] = ACTIONS(3942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3940),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_with] = ACTIONS(3942),
    [anon_sym_return_BANG] = ACTIONS(3940),
    [anon_sym_yield] = ACTIONS(3942),
    [anon_sym_yield_BANG] = ACTIONS(3940),
    [anon_sym_lazy] = ACTIONS(3942),
    [anon_sym_assert] = ACTIONS(3942),
    [anon_sym_upcast] = ACTIONS(3942),
    [anon_sym_downcast] = ACTIONS(3942),
    [anon_sym_COLON_GT] = ACTIONS(3940),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3940),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_fun] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_match] = ACTIONS(3942),
    [anon_sym_match_BANG] = ACTIONS(3940),
    [anon_sym_function] = ACTIONS(3942),
    [anon_sym_LT_DASH] = ACTIONS(3942),
    [anon_sym_DOT_LBRACK] = ACTIONS(3940),
    [anon_sym_LT] = ACTIONS(3940),
    [anon_sym_use] = ACTIONS(3942),
    [anon_sym_use_BANG] = ACTIONS(3940),
    [anon_sym_do_BANG] = ACTIONS(3940),
    [anon_sym_begin] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3942),
    [anon_sym_DOT_DOT2] = ACTIONS(3940),
    [anon_sym_default] = ACTIONS(3942),
    [anon_sym_or] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_member] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_abstract] = ACTIONS(3942),
    [anon_sym_val] = ACTIONS(3942),
    [anon_sym_override] = ACTIONS(3942),
    [aux_sym_char_token1] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3942),
    [anon_sym_DQUOTE] = ACTIONS(3942),
    [anon_sym_AT_DQUOTE] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [sym_bool] = ACTIONS(3942),
    [sym_unit] = ACTIONS(3940),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3942),
    [sym_op_identifier] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS_DOT] = ACTIONS(3942),
    [anon_sym_DASH_DOT] = ACTIONS(3942),
    [anon_sym_PERCENT] = ACTIONS(3942),
    [anon_sym_AMP_AMP] = ACTIONS(3942),
    [anon_sym_TILDE] = ACTIONS(3940),
    [aux_sym_prefix_op_token1] = ACTIONS(3942),
    [aux_sym_infix_op_token1] = ACTIONS(3940),
    [aux_sym_infix_op_token2] = ACTIONS(3942),
    [anon_sym_PIPE_PIPE] = ACTIONS(3942),
    [anon_sym_BANG_EQ] = ACTIONS(3942),
    [anon_sym_COLON_EQ] = ACTIONS(3940),
    [anon_sym_DOLLAR] = ACTIONS(3942),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3942),
    [sym_int] = ACTIONS(3942),
    [sym_xint] = ACTIONS(3940),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3940),
    [sym__newline] = ACTIONS(3940),
    [sym__dedent] = ACTIONS(3940),
  },
  [2028] = {
    [sym_block_comment] = STATE(2028),
    [sym_compiler_directive_decl] = STATE(2028),
    [sym_fsi_directive_decl] = STATE(2028),
    [sym_preproc_line] = STATE(2028),
    [sym_identifier] = ACTIONS(4180),
    [anon_sym_EQ] = ACTIONS(4178),
    [anon_sym_LBRACK_LT] = ACTIONS(4178),
    [anon_sym_COLON] = ACTIONS(4180),
    [anon_sym_return] = ACTIONS(4180),
    [anon_sym_do] = ACTIONS(4180),
    [anon_sym_and] = ACTIONS(4180),
    [anon_sym_let] = ACTIONS(4180),
    [anon_sym_let_BANG] = ACTIONS(4178),
    [aux_sym_access_modifier_token1] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(4180),
    [anon_sym_COMMA] = ACTIONS(4178),
    [anon_sym_null] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_COLON] = ACTIONS(4178),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4180),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4180),
    [anon_sym_LT_AT] = ACTIONS(4180),
    [anon_sym_LT_AT_AT] = ACTIONS(4180),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4178),
    [anon_sym_new] = ACTIONS(4180),
    [anon_sym_with] = ACTIONS(4180),
    [anon_sym_return_BANG] = ACTIONS(4178),
    [anon_sym_yield] = ACTIONS(4180),
    [anon_sym_yield_BANG] = ACTIONS(4178),
    [anon_sym_lazy] = ACTIONS(4180),
    [anon_sym_assert] = ACTIONS(4180),
    [anon_sym_upcast] = ACTIONS(4180),
    [anon_sym_downcast] = ACTIONS(4180),
    [anon_sym_COLON_GT] = ACTIONS(4178),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4178),
    [anon_sym_for] = ACTIONS(4180),
    [anon_sym_while] = ACTIONS(4180),
    [anon_sym_if] = ACTIONS(4180),
    [anon_sym_fun] = ACTIONS(4180),
    [anon_sym_try] = ACTIONS(4180),
    [anon_sym_match] = ACTIONS(4180),
    [anon_sym_match_BANG] = ACTIONS(4178),
    [anon_sym_function] = ACTIONS(4180),
    [anon_sym_LT_DASH] = ACTIONS(4180),
    [anon_sym_DOT_LBRACK] = ACTIONS(4178),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_use] = ACTIONS(4180),
    [anon_sym_use_BANG] = ACTIONS(4178),
    [anon_sym_do_BANG] = ACTIONS(4178),
    [anon_sym_begin] = ACTIONS(4180),
    [anon_sym_LPAREN2] = ACTIONS(4180),
    [anon_sym_default] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [anon_sym_static] = ACTIONS(4180),
    [anon_sym_member] = ACTIONS(4180),
    [anon_sym_interface] = ACTIONS(4180),
    [anon_sym_abstract] = ACTIONS(4180),
    [anon_sym_val] = ACTIONS(4180),
    [anon_sym_override] = ACTIONS(4180),
    [aux_sym_char_token1] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4180),
    [anon_sym_DQUOTE] = ACTIONS(4180),
    [anon_sym_AT_DQUOTE] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [sym_bool] = ACTIONS(4180),
    [sym_unit] = ACTIONS(4178),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4180),
    [sym_op_identifier] = ACTIONS(4180),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_PLUS_DOT] = ACTIONS(4180),
    [anon_sym_DASH_DOT] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_TILDE] = ACTIONS(4178),
    [aux_sym_prefix_op_token1] = ACTIONS(4180),
    [aux_sym_infix_op_token1] = ACTIONS(4178),
    [aux_sym_infix_op_token2] = ACTIONS(4180),
    [anon_sym_PIPE_PIPE] = ACTIONS(4180),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_COLON_EQ] = ACTIONS(4178),
    [anon_sym_DOLLAR] = ACTIONS(4180),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4180),
    [sym_int] = ACTIONS(4180),
    [sym_xint] = ACTIONS(4178),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4178),
    [anon_sym_POUNDendif] = ACTIONS(4178),
    [sym__newline] = ACTIONS(4178),
  },
  [2029] = {
    [sym_block_comment] = STATE(2029),
    [sym_compiler_directive_decl] = STATE(2029),
    [sym_fsi_directive_decl] = STATE(2029),
    [sym_preproc_line] = STATE(2029),
    [sym_identifier] = ACTIONS(4174),
    [anon_sym_EQ] = ACTIONS(4172),
    [anon_sym_LBRACK_LT] = ACTIONS(4172),
    [anon_sym_COLON] = ACTIONS(4174),
    [anon_sym_return] = ACTIONS(4174),
    [anon_sym_do] = ACTIONS(4174),
    [anon_sym_and] = ACTIONS(4174),
    [anon_sym_let] = ACTIONS(4174),
    [anon_sym_let_BANG] = ACTIONS(4172),
    [aux_sym_access_modifier_token1] = ACTIONS(4172),
    [anon_sym_LPAREN] = ACTIONS(4174),
    [anon_sym_COMMA] = ACTIONS(4172),
    [anon_sym_null] = ACTIONS(4174),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_COLON] = ACTIONS(4172),
    [anon_sym_AMP] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4174),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4172),
    [anon_sym_LBRACE] = ACTIONS(4174),
    [anon_sym_LT_AT] = ACTIONS(4174),
    [anon_sym_LT_AT_AT] = ACTIONS(4174),
    [anon_sym_DOT] = ACTIONS(4174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4172),
    [anon_sym_new] = ACTIONS(4174),
    [anon_sym_with] = ACTIONS(4174),
    [anon_sym_return_BANG] = ACTIONS(4172),
    [anon_sym_yield] = ACTIONS(4174),
    [anon_sym_yield_BANG] = ACTIONS(4172),
    [anon_sym_lazy] = ACTIONS(4174),
    [anon_sym_assert] = ACTIONS(4174),
    [anon_sym_upcast] = ACTIONS(4174),
    [anon_sym_downcast] = ACTIONS(4174),
    [anon_sym_COLON_GT] = ACTIONS(4172),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4172),
    [anon_sym_for] = ACTIONS(4174),
    [anon_sym_while] = ACTIONS(4174),
    [anon_sym_if] = ACTIONS(4174),
    [anon_sym_fun] = ACTIONS(4174),
    [anon_sym_try] = ACTIONS(4174),
    [anon_sym_match] = ACTIONS(4174),
    [anon_sym_match_BANG] = ACTIONS(4172),
    [anon_sym_function] = ACTIONS(4174),
    [anon_sym_LT_DASH] = ACTIONS(4174),
    [anon_sym_DOT_LBRACK] = ACTIONS(4172),
    [anon_sym_LT] = ACTIONS(4172),
    [anon_sym_use] = ACTIONS(4174),
    [anon_sym_use_BANG] = ACTIONS(4172),
    [anon_sym_do_BANG] = ACTIONS(4172),
    [anon_sym_begin] = ACTIONS(4174),
    [anon_sym_LPAREN2] = ACTIONS(4174),
    [anon_sym_default] = ACTIONS(4174),
    [anon_sym_or] = ACTIONS(4174),
    [anon_sym_static] = ACTIONS(4174),
    [anon_sym_member] = ACTIONS(4174),
    [anon_sym_interface] = ACTIONS(4174),
    [anon_sym_abstract] = ACTIONS(4174),
    [anon_sym_val] = ACTIONS(4174),
    [anon_sym_override] = ACTIONS(4174),
    [aux_sym_char_token1] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4174),
    [anon_sym_DQUOTE] = ACTIONS(4174),
    [anon_sym_AT_DQUOTE] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [sym_bool] = ACTIONS(4174),
    [sym_unit] = ACTIONS(4172),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4174),
    [sym_op_identifier] = ACTIONS(4174),
    [anon_sym_PLUS] = ACTIONS(4174),
    [anon_sym_DASH] = ACTIONS(4174),
    [anon_sym_PLUS_DOT] = ACTIONS(4174),
    [anon_sym_DASH_DOT] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [anon_sym_AMP_AMP] = ACTIONS(4174),
    [anon_sym_TILDE] = ACTIONS(4172),
    [aux_sym_prefix_op_token1] = ACTIONS(4174),
    [aux_sym_infix_op_token1] = ACTIONS(4172),
    [aux_sym_infix_op_token2] = ACTIONS(4174),
    [anon_sym_PIPE_PIPE] = ACTIONS(4174),
    [anon_sym_BANG_EQ] = ACTIONS(4174),
    [anon_sym_COLON_EQ] = ACTIONS(4172),
    [anon_sym_DOLLAR] = ACTIONS(4174),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4174),
    [sym_int] = ACTIONS(4174),
    [sym_xint] = ACTIONS(4172),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4172),
    [anon_sym_POUNDendif] = ACTIONS(4172),
    [sym__newline] = ACTIONS(4172),
  },
  [2030] = {
    [sym_block_comment] = STATE(2030),
    [sym_compiler_directive_decl] = STATE(2030),
    [sym_fsi_directive_decl] = STATE(2030),
    [sym_preproc_line] = STATE(2030),
    [sym_identifier] = ACTIONS(4064),
    [anon_sym_EQ] = ACTIONS(4062),
    [anon_sym_LBRACK_LT] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4064),
    [anon_sym_return] = ACTIONS(4064),
    [anon_sym_do] = ACTIONS(4064),
    [anon_sym_let] = ACTIONS(4064),
    [anon_sym_let_BANG] = ACTIONS(4062),
    [aux_sym_access_modifier_token1] = ACTIONS(4062),
    [anon_sym_LPAREN] = ACTIONS(4064),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_null] = ACTIONS(4064),
    [anon_sym_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_COLON] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4062),
    [anon_sym_LBRACE] = ACTIONS(4064),
    [anon_sym_LT_AT] = ACTIONS(4064),
    [anon_sym_LT_AT_AT] = ACTIONS(4064),
    [anon_sym_DOT] = ACTIONS(4064),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4062),
    [anon_sym_new] = ACTIONS(4064),
    [anon_sym_with] = ACTIONS(4064),
    [anon_sym_return_BANG] = ACTIONS(4062),
    [anon_sym_yield] = ACTIONS(4064),
    [anon_sym_yield_BANG] = ACTIONS(4062),
    [anon_sym_lazy] = ACTIONS(4064),
    [anon_sym_assert] = ACTIONS(4064),
    [anon_sym_upcast] = ACTIONS(4064),
    [anon_sym_downcast] = ACTIONS(4064),
    [anon_sym_COLON_GT] = ACTIONS(4062),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4062),
    [anon_sym_for] = ACTIONS(4064),
    [anon_sym_while] = ACTIONS(4064),
    [anon_sym_if] = ACTIONS(4064),
    [anon_sym_fun] = ACTIONS(4064),
    [anon_sym_try] = ACTIONS(4064),
    [anon_sym_match] = ACTIONS(4064),
    [anon_sym_match_BANG] = ACTIONS(4062),
    [anon_sym_function] = ACTIONS(4064),
    [anon_sym_LT_DASH] = ACTIONS(4064),
    [anon_sym_DOT_LBRACK] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(4062),
    [anon_sym_use] = ACTIONS(4064),
    [anon_sym_use_BANG] = ACTIONS(4062),
    [anon_sym_do_BANG] = ACTIONS(4062),
    [anon_sym_begin] = ACTIONS(4064),
    [anon_sym_LPAREN2] = ACTIONS(4064),
    [anon_sym_DOT_DOT2] = ACTIONS(4062),
    [anon_sym_default] = ACTIONS(4064),
    [anon_sym_or] = ACTIONS(4064),
    [anon_sym_static] = ACTIONS(4064),
    [anon_sym_member] = ACTIONS(4064),
    [anon_sym_interface] = ACTIONS(4064),
    [anon_sym_abstract] = ACTIONS(4064),
    [anon_sym_val] = ACTIONS(4064),
    [anon_sym_override] = ACTIONS(4064),
    [aux_sym_char_token1] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_AT_DQUOTE] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [sym_bool] = ACTIONS(4064),
    [sym_unit] = ACTIONS(4062),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4064),
    [sym_op_identifier] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4064),
    [anon_sym_DASH] = ACTIONS(4064),
    [anon_sym_PLUS_DOT] = ACTIONS(4064),
    [anon_sym_DASH_DOT] = ACTIONS(4064),
    [anon_sym_PERCENT] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_TILDE] = ACTIONS(4062),
    [aux_sym_prefix_op_token1] = ACTIONS(4064),
    [aux_sym_infix_op_token1] = ACTIONS(4062),
    [aux_sym_infix_op_token2] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_BANG_EQ] = ACTIONS(4064),
    [anon_sym_COLON_EQ] = ACTIONS(4062),
    [anon_sym_DOLLAR] = ACTIONS(4064),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4064),
    [sym_int] = ACTIONS(4064),
    [sym_xint] = ACTIONS(4062),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4062),
    [sym__newline] = ACTIONS(4062),
    [sym__dedent] = ACTIONS(4062),
  },
  [2031] = {
    [sym_block_comment] = STATE(2031),
    [sym_compiler_directive_decl] = STATE(2031),
    [sym_fsi_directive_decl] = STATE(2031),
    [sym_preproc_line] = STATE(2031),
    [sym_identifier] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4246),
    [anon_sym_LBRACK_LT] = ACTIONS(4246),
    [anon_sym_COLON] = ACTIONS(4248),
    [anon_sym_return] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4248),
    [anon_sym_and] = ACTIONS(4248),
    [anon_sym_let] = ACTIONS(4248),
    [anon_sym_let_BANG] = ACTIONS(4246),
    [aux_sym_access_modifier_token1] = ACTIONS(4246),
    [anon_sym_LPAREN] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_null] = ACTIONS(4248),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4248),
    [anon_sym_LT_AT] = ACTIONS(4248),
    [anon_sym_LT_AT_AT] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4246),
    [anon_sym_new] = ACTIONS(4248),
    [anon_sym_with] = ACTIONS(4248),
    [anon_sym_return_BANG] = ACTIONS(4246),
    [anon_sym_yield] = ACTIONS(4248),
    [anon_sym_yield_BANG] = ACTIONS(4246),
    [anon_sym_lazy] = ACTIONS(4248),
    [anon_sym_assert] = ACTIONS(4248),
    [anon_sym_upcast] = ACTIONS(4248),
    [anon_sym_downcast] = ACTIONS(4248),
    [anon_sym_COLON_GT] = ACTIONS(4246),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4246),
    [anon_sym_for] = ACTIONS(4248),
    [anon_sym_while] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4248),
    [anon_sym_fun] = ACTIONS(4248),
    [anon_sym_try] = ACTIONS(4248),
    [anon_sym_match] = ACTIONS(4248),
    [anon_sym_match_BANG] = ACTIONS(4246),
    [anon_sym_function] = ACTIONS(4248),
    [anon_sym_LT_DASH] = ACTIONS(4248),
    [anon_sym_DOT_LBRACK] = ACTIONS(4246),
    [anon_sym_LT] = ACTIONS(4246),
    [anon_sym_use] = ACTIONS(4248),
    [anon_sym_use_BANG] = ACTIONS(4246),
    [anon_sym_do_BANG] = ACTIONS(4246),
    [anon_sym_begin] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_default] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4248),
    [anon_sym_static] = ACTIONS(4248),
    [anon_sym_member] = ACTIONS(4248),
    [anon_sym_interface] = ACTIONS(4248),
    [anon_sym_abstract] = ACTIONS(4248),
    [anon_sym_val] = ACTIONS(4248),
    [anon_sym_override] = ACTIONS(4248),
    [aux_sym_char_token1] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4248),
    [anon_sym_DQUOTE] = ACTIONS(4248),
    [anon_sym_AT_DQUOTE] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [sym_bool] = ACTIONS(4248),
    [sym_unit] = ACTIONS(4246),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4248),
    [sym_op_identifier] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_DOT] = ACTIONS(4248),
    [anon_sym_DASH_DOT] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_TILDE] = ACTIONS(4246),
    [aux_sym_prefix_op_token1] = ACTIONS(4248),
    [aux_sym_infix_op_token1] = ACTIONS(4246),
    [aux_sym_infix_op_token2] = ACTIONS(4248),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_COLON_EQ] = ACTIONS(4246),
    [anon_sym_DOLLAR] = ACTIONS(4248),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4248),
    [sym_int] = ACTIONS(4248),
    [sym_xint] = ACTIONS(4246),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4246),
    [sym__newline] = ACTIONS(4246),
    [sym__dedent] = ACTIONS(4246),
  },
  [2032] = {
    [sym_block_comment] = STATE(2032),
    [sym_compiler_directive_decl] = STATE(2032),
    [sym_fsi_directive_decl] = STATE(2032),
    [sym_preproc_line] = STATE(2032),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4072),
    [anon_sym_LBRACK_LT] = ACTIONS(4072),
    [anon_sym_COLON] = ACTIONS(4074),
    [anon_sym_return] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_let_BANG] = ACTIONS(4072),
    [aux_sym_access_modifier_token1] = ACTIONS(4072),
    [anon_sym_LPAREN] = ACTIONS(4074),
    [anon_sym_COMMA] = ACTIONS(4072),
    [anon_sym_null] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_COLON] = ACTIONS(4072),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_LT_AT] = ACTIONS(4074),
    [anon_sym_LT_AT_AT] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4072),
    [anon_sym_new] = ACTIONS(4074),
    [anon_sym_with] = ACTIONS(4074),
    [anon_sym_return_BANG] = ACTIONS(4072),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_yield_BANG] = ACTIONS(4072),
    [anon_sym_lazy] = ACTIONS(4074),
    [anon_sym_assert] = ACTIONS(4074),
    [anon_sym_upcast] = ACTIONS(4074),
    [anon_sym_downcast] = ACTIONS(4074),
    [anon_sym_COLON_GT] = ACTIONS(4072),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4072),
    [anon_sym_for] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_fun] = ACTIONS(4074),
    [anon_sym_try] = ACTIONS(4074),
    [anon_sym_match] = ACTIONS(4074),
    [anon_sym_match_BANG] = ACTIONS(4072),
    [anon_sym_function] = ACTIONS(4074),
    [anon_sym_LT_DASH] = ACTIONS(4074),
    [anon_sym_DOT_LBRACK] = ACTIONS(4072),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_use] = ACTIONS(4074),
    [anon_sym_use_BANG] = ACTIONS(4072),
    [anon_sym_do_BANG] = ACTIONS(4072),
    [anon_sym_begin] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(4074),
    [anon_sym_default] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_static] = ACTIONS(4074),
    [anon_sym_member] = ACTIONS(4074),
    [anon_sym_interface] = ACTIONS(4074),
    [anon_sym_abstract] = ACTIONS(4074),
    [anon_sym_val] = ACTIONS(4074),
    [anon_sym_override] = ACTIONS(4074),
    [aux_sym_char_token1] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4074),
    [anon_sym_DQUOTE] = ACTIONS(4074),
    [anon_sym_AT_DQUOTE] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [sym_bool] = ACTIONS(4074),
    [sym_unit] = ACTIONS(4072),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4074),
    [sym_op_identifier] = ACTIONS(4074),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_PLUS_DOT] = ACTIONS(4074),
    [anon_sym_DASH_DOT] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_TILDE] = ACTIONS(4072),
    [aux_sym_prefix_op_token1] = ACTIONS(4074),
    [aux_sym_infix_op_token1] = ACTIONS(4072),
    [aux_sym_infix_op_token2] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [anon_sym_BANG_EQ] = ACTIONS(4074),
    [anon_sym_COLON_EQ] = ACTIONS(4072),
    [anon_sym_DOLLAR] = ACTIONS(4074),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4074),
    [sym_int] = ACTIONS(4074),
    [sym_xint] = ACTIONS(4072),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4072),
    [anon_sym_POUNDendif] = ACTIONS(4072),
    [sym__newline] = ACTIONS(4072),
  },
  [2033] = {
    [sym_block_comment] = STATE(2033),
    [sym_compiler_directive_decl] = STATE(2033),
    [sym_fsi_directive_decl] = STATE(2033),
    [sym_preproc_line] = STATE(2033),
    [sym_identifier] = ACTIONS(4022),
    [anon_sym_EQ] = ACTIONS(4020),
    [anon_sym_LBRACK_LT] = ACTIONS(4020),
    [anon_sym_COLON] = ACTIONS(4022),
    [anon_sym_return] = ACTIONS(4022),
    [anon_sym_do] = ACTIONS(4022),
    [anon_sym_and] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_let_BANG] = ACTIONS(4020),
    [aux_sym_access_modifier_token1] = ACTIONS(4020),
    [anon_sym_LPAREN] = ACTIONS(4022),
    [anon_sym_COMMA] = ACTIONS(4020),
    [anon_sym_null] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_COLON] = ACTIONS(4020),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4022),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(4022),
    [anon_sym_LT_AT] = ACTIONS(4022),
    [anon_sym_LT_AT_AT] = ACTIONS(4022),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4020),
    [anon_sym_new] = ACTIONS(4022),
    [anon_sym_with] = ACTIONS(4022),
    [anon_sym_return_BANG] = ACTIONS(4020),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_yield_BANG] = ACTIONS(4020),
    [anon_sym_lazy] = ACTIONS(4022),
    [anon_sym_assert] = ACTIONS(4022),
    [anon_sym_upcast] = ACTIONS(4022),
    [anon_sym_downcast] = ACTIONS(4022),
    [anon_sym_COLON_GT] = ACTIONS(4020),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4020),
    [anon_sym_for] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4022),
    [anon_sym_if] = ACTIONS(4022),
    [anon_sym_fun] = ACTIONS(4022),
    [anon_sym_try] = ACTIONS(4022),
    [anon_sym_match] = ACTIONS(4022),
    [anon_sym_match_BANG] = ACTIONS(4020),
    [anon_sym_function] = ACTIONS(4022),
    [anon_sym_LT_DASH] = ACTIONS(4022),
    [anon_sym_DOT_LBRACK] = ACTIONS(4020),
    [anon_sym_LT] = ACTIONS(4020),
    [anon_sym_use] = ACTIONS(4022),
    [anon_sym_use_BANG] = ACTIONS(4020),
    [anon_sym_do_BANG] = ACTIONS(4020),
    [anon_sym_begin] = ACTIONS(4022),
    [anon_sym_LPAREN2] = ACTIONS(4022),
    [anon_sym_default] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_static] = ACTIONS(4022),
    [anon_sym_member] = ACTIONS(4022),
    [anon_sym_interface] = ACTIONS(4022),
    [anon_sym_abstract] = ACTIONS(4022),
    [anon_sym_val] = ACTIONS(4022),
    [anon_sym_override] = ACTIONS(4022),
    [aux_sym_char_token1] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4022),
    [anon_sym_DQUOTE] = ACTIONS(4022),
    [anon_sym_AT_DQUOTE] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [sym_bool] = ACTIONS(4022),
    [sym_unit] = ACTIONS(4020),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4022),
    [sym_op_identifier] = ACTIONS(4022),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_PLUS_DOT] = ACTIONS(4022),
    [anon_sym_DASH_DOT] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4022),
    [anon_sym_TILDE] = ACTIONS(4020),
    [aux_sym_prefix_op_token1] = ACTIONS(4022),
    [aux_sym_infix_op_token1] = ACTIONS(4020),
    [aux_sym_infix_op_token2] = ACTIONS(4022),
    [anon_sym_PIPE_PIPE] = ACTIONS(4022),
    [anon_sym_BANG_EQ] = ACTIONS(4022),
    [anon_sym_COLON_EQ] = ACTIONS(4020),
    [anon_sym_DOLLAR] = ACTIONS(4022),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4022),
    [sym_int] = ACTIONS(4022),
    [sym_xint] = ACTIONS(4020),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4020),
    [anon_sym_POUNDendif] = ACTIONS(4020),
    [sym__newline] = ACTIONS(4020),
  },
  [2034] = {
    [sym_block_comment] = STATE(2034),
    [sym_compiler_directive_decl] = STATE(2034),
    [sym_fsi_directive_decl] = STATE(2034),
    [sym_preproc_line] = STATE(2034),
    [sym_identifier] = ACTIONS(4011),
    [anon_sym_EQ] = ACTIONS(4009),
    [anon_sym_LBRACK_LT] = ACTIONS(4009),
    [anon_sym_COLON] = ACTIONS(4011),
    [anon_sym_return] = ACTIONS(4011),
    [anon_sym_do] = ACTIONS(4011),
    [anon_sym_and] = ACTIONS(4011),
    [anon_sym_let] = ACTIONS(4011),
    [anon_sym_let_BANG] = ACTIONS(4009),
    [aux_sym_access_modifier_token1] = ACTIONS(4009),
    [anon_sym_LPAREN] = ACTIONS(4011),
    [anon_sym_COMMA] = ACTIONS(4009),
    [anon_sym_null] = ACTIONS(4011),
    [anon_sym_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(4011),
    [anon_sym_LBRACK] = ACTIONS(4011),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4009),
    [anon_sym_LBRACE] = ACTIONS(4011),
    [anon_sym_LT_AT] = ACTIONS(4011),
    [anon_sym_LT_AT_AT] = ACTIONS(4011),
    [anon_sym_DOT] = ACTIONS(4011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4009),
    [anon_sym_new] = ACTIONS(4011),
    [anon_sym_with] = ACTIONS(4011),
    [anon_sym_return_BANG] = ACTIONS(4009),
    [anon_sym_yield] = ACTIONS(4011),
    [anon_sym_yield_BANG] = ACTIONS(4009),
    [anon_sym_lazy] = ACTIONS(4011),
    [anon_sym_assert] = ACTIONS(4011),
    [anon_sym_upcast] = ACTIONS(4011),
    [anon_sym_downcast] = ACTIONS(4011),
    [anon_sym_COLON_GT] = ACTIONS(4009),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4009),
    [anon_sym_for] = ACTIONS(4011),
    [anon_sym_while] = ACTIONS(4011),
    [anon_sym_if] = ACTIONS(4011),
    [anon_sym_fun] = ACTIONS(4011),
    [anon_sym_try] = ACTIONS(4011),
    [anon_sym_match] = ACTIONS(4011),
    [anon_sym_match_BANG] = ACTIONS(4009),
    [anon_sym_function] = ACTIONS(4011),
    [anon_sym_LT_DASH] = ACTIONS(4011),
    [anon_sym_DOT_LBRACK] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(4009),
    [anon_sym_use] = ACTIONS(4011),
    [anon_sym_use_BANG] = ACTIONS(4009),
    [anon_sym_do_BANG] = ACTIONS(4009),
    [anon_sym_begin] = ACTIONS(4011),
    [anon_sym_LPAREN2] = ACTIONS(4011),
    [anon_sym_default] = ACTIONS(4011),
    [anon_sym_or] = ACTIONS(4011),
    [anon_sym_static] = ACTIONS(4011),
    [anon_sym_member] = ACTIONS(4011),
    [anon_sym_interface] = ACTIONS(4011),
    [anon_sym_abstract] = ACTIONS(4011),
    [anon_sym_val] = ACTIONS(4011),
    [anon_sym_override] = ACTIONS(4011),
    [aux_sym_char_token1] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4011),
    [anon_sym_DQUOTE] = ACTIONS(4011),
    [anon_sym_AT_DQUOTE] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [sym_bool] = ACTIONS(4011),
    [sym_unit] = ACTIONS(4009),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4011),
    [sym_op_identifier] = ACTIONS(4011),
    [anon_sym_PLUS] = ACTIONS(4011),
    [anon_sym_DASH] = ACTIONS(4011),
    [anon_sym_PLUS_DOT] = ACTIONS(4011),
    [anon_sym_DASH_DOT] = ACTIONS(4011),
    [anon_sym_PERCENT] = ACTIONS(4011),
    [anon_sym_AMP_AMP] = ACTIONS(4011),
    [anon_sym_TILDE] = ACTIONS(4009),
    [aux_sym_prefix_op_token1] = ACTIONS(4011),
    [aux_sym_infix_op_token1] = ACTIONS(4009),
    [aux_sym_infix_op_token2] = ACTIONS(4011),
    [anon_sym_PIPE_PIPE] = ACTIONS(4011),
    [anon_sym_BANG_EQ] = ACTIONS(4011),
    [anon_sym_COLON_EQ] = ACTIONS(4009),
    [anon_sym_DOLLAR] = ACTIONS(4011),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4011),
    [sym_int] = ACTIONS(4011),
    [sym_xint] = ACTIONS(4009),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4009),
    [anon_sym_POUNDendif] = ACTIONS(4009),
    [sym__newline] = ACTIONS(4009),
  },
  [2035] = {
    [sym_block_comment] = STATE(2035),
    [sym_compiler_directive_decl] = STATE(2035),
    [sym_fsi_directive_decl] = STATE(2035),
    [sym_preproc_line] = STATE(2035),
    [sym_identifier] = ACTIONS(4104),
    [anon_sym_EQ] = ACTIONS(4102),
    [anon_sym_LBRACK_LT] = ACTIONS(4102),
    [anon_sym_COLON] = ACTIONS(4104),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_do] = ACTIONS(4104),
    [anon_sym_let] = ACTIONS(4104),
    [anon_sym_let_BANG] = ACTIONS(4102),
    [aux_sym_access_modifier_token1] = ACTIONS(4102),
    [anon_sym_LPAREN] = ACTIONS(4104),
    [anon_sym_COMMA] = ACTIONS(4102),
    [anon_sym_null] = ACTIONS(4104),
    [anon_sym_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_COLON] = ACTIONS(4102),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4104),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4102),
    [anon_sym_LBRACE] = ACTIONS(4104),
    [anon_sym_LT_AT] = ACTIONS(4104),
    [anon_sym_LT_AT_AT] = ACTIONS(4104),
    [anon_sym_DOT] = ACTIONS(4104),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4102),
    [anon_sym_new] = ACTIONS(4104),
    [anon_sym_with] = ACTIONS(4104),
    [anon_sym_return_BANG] = ACTIONS(4102),
    [anon_sym_yield] = ACTIONS(4104),
    [anon_sym_yield_BANG] = ACTIONS(4102),
    [anon_sym_lazy] = ACTIONS(4104),
    [anon_sym_assert] = ACTIONS(4104),
    [anon_sym_upcast] = ACTIONS(4104),
    [anon_sym_downcast] = ACTIONS(4104),
    [anon_sym_COLON_GT] = ACTIONS(4102),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4102),
    [anon_sym_for] = ACTIONS(4104),
    [anon_sym_while] = ACTIONS(4104),
    [anon_sym_if] = ACTIONS(4104),
    [anon_sym_fun] = ACTIONS(4104),
    [anon_sym_try] = ACTIONS(4104),
    [anon_sym_match] = ACTIONS(4104),
    [anon_sym_match_BANG] = ACTIONS(4102),
    [anon_sym_function] = ACTIONS(4104),
    [anon_sym_LT_DASH] = ACTIONS(4104),
    [anon_sym_DOT_LBRACK] = ACTIONS(4102),
    [anon_sym_LT] = ACTIONS(4102),
    [anon_sym_use] = ACTIONS(4104),
    [anon_sym_use_BANG] = ACTIONS(4102),
    [anon_sym_do_BANG] = ACTIONS(4102),
    [anon_sym_begin] = ACTIONS(4104),
    [anon_sym_LPAREN2] = ACTIONS(4104),
    [anon_sym_default] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [anon_sym_static] = ACTIONS(4104),
    [anon_sym_member] = ACTIONS(4104),
    [anon_sym_interface] = ACTIONS(4104),
    [anon_sym_abstract] = ACTIONS(4104),
    [anon_sym_val] = ACTIONS(4104),
    [anon_sym_override] = ACTIONS(4104),
    [anon_sym_inherit] = ACTIONS(4104),
    [aux_sym_char_token1] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4104),
    [anon_sym_DQUOTE] = ACTIONS(4104),
    [anon_sym_AT_DQUOTE] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [sym_bool] = ACTIONS(4104),
    [sym_unit] = ACTIONS(4102),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4104),
    [sym_op_identifier] = ACTIONS(4104),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_PLUS_DOT] = ACTIONS(4104),
    [anon_sym_DASH_DOT] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_AMP_AMP] = ACTIONS(4104),
    [anon_sym_TILDE] = ACTIONS(4102),
    [aux_sym_prefix_op_token1] = ACTIONS(4104),
    [aux_sym_infix_op_token1] = ACTIONS(4102),
    [aux_sym_infix_op_token2] = ACTIONS(4104),
    [anon_sym_PIPE_PIPE] = ACTIONS(4104),
    [anon_sym_BANG_EQ] = ACTIONS(4104),
    [anon_sym_COLON_EQ] = ACTIONS(4102),
    [anon_sym_DOLLAR] = ACTIONS(4104),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4104),
    [sym_int] = ACTIONS(4104),
    [sym_xint] = ACTIONS(4102),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4102),
    [anon_sym_POUNDendif] = ACTIONS(4102),
    [sym__newline] = ACTIONS(4102),
  },
  [2036] = {
    [sym_block_comment] = STATE(2036),
    [sym_compiler_directive_decl] = STATE(2036),
    [sym_fsi_directive_decl] = STATE(2036),
    [sym_preproc_line] = STATE(2036),
    [sym_identifier] = ACTIONS(4007),
    [anon_sym_EQ] = ACTIONS(4005),
    [anon_sym_LBRACK_LT] = ACTIONS(4005),
    [anon_sym_COLON] = ACTIONS(4007),
    [anon_sym_return] = ACTIONS(4007),
    [anon_sym_do] = ACTIONS(4007),
    [anon_sym_and] = ACTIONS(4007),
    [anon_sym_let] = ACTIONS(4007),
    [anon_sym_let_BANG] = ACTIONS(4005),
    [aux_sym_access_modifier_token1] = ACTIONS(4005),
    [anon_sym_LPAREN] = ACTIONS(4007),
    [anon_sym_COMMA] = ACTIONS(4005),
    [anon_sym_null] = ACTIONS(4007),
    [anon_sym_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_COLON] = ACTIONS(4005),
    [anon_sym_AMP] = ACTIONS(4007),
    [anon_sym_LBRACK] = ACTIONS(4007),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4005),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_LT_AT] = ACTIONS(4007),
    [anon_sym_LT_AT_AT] = ACTIONS(4007),
    [anon_sym_DOT] = ACTIONS(4007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4005),
    [anon_sym_new] = ACTIONS(4007),
    [anon_sym_with] = ACTIONS(4007),
    [anon_sym_return_BANG] = ACTIONS(4005),
    [anon_sym_yield] = ACTIONS(4007),
    [anon_sym_yield_BANG] = ACTIONS(4005),
    [anon_sym_lazy] = ACTIONS(4007),
    [anon_sym_assert] = ACTIONS(4007),
    [anon_sym_upcast] = ACTIONS(4007),
    [anon_sym_downcast] = ACTIONS(4007),
    [anon_sym_COLON_GT] = ACTIONS(4005),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4005),
    [anon_sym_for] = ACTIONS(4007),
    [anon_sym_while] = ACTIONS(4007),
    [anon_sym_if] = ACTIONS(4007),
    [anon_sym_fun] = ACTIONS(4007),
    [anon_sym_try] = ACTIONS(4007),
    [anon_sym_match] = ACTIONS(4007),
    [anon_sym_match_BANG] = ACTIONS(4005),
    [anon_sym_function] = ACTIONS(4007),
    [anon_sym_LT_DASH] = ACTIONS(4007),
    [anon_sym_DOT_LBRACK] = ACTIONS(4005),
    [anon_sym_LT] = ACTIONS(4005),
    [anon_sym_use] = ACTIONS(4007),
    [anon_sym_use_BANG] = ACTIONS(4005),
    [anon_sym_do_BANG] = ACTIONS(4005),
    [anon_sym_begin] = ACTIONS(4007),
    [anon_sym_LPAREN2] = ACTIONS(4007),
    [anon_sym_default] = ACTIONS(4007),
    [anon_sym_or] = ACTIONS(4007),
    [anon_sym_static] = ACTIONS(4007),
    [anon_sym_member] = ACTIONS(4007),
    [anon_sym_interface] = ACTIONS(4007),
    [anon_sym_abstract] = ACTIONS(4007),
    [anon_sym_val] = ACTIONS(4007),
    [anon_sym_override] = ACTIONS(4007),
    [aux_sym_char_token1] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4007),
    [anon_sym_DQUOTE] = ACTIONS(4007),
    [anon_sym_AT_DQUOTE] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [sym_bool] = ACTIONS(4007),
    [sym_unit] = ACTIONS(4005),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4007),
    [sym_op_identifier] = ACTIONS(4007),
    [anon_sym_PLUS] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4007),
    [anon_sym_PLUS_DOT] = ACTIONS(4007),
    [anon_sym_DASH_DOT] = ACTIONS(4007),
    [anon_sym_PERCENT] = ACTIONS(4007),
    [anon_sym_AMP_AMP] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4005),
    [aux_sym_prefix_op_token1] = ACTIONS(4007),
    [aux_sym_infix_op_token1] = ACTIONS(4005),
    [aux_sym_infix_op_token2] = ACTIONS(4007),
    [anon_sym_PIPE_PIPE] = ACTIONS(4007),
    [anon_sym_BANG_EQ] = ACTIONS(4007),
    [anon_sym_COLON_EQ] = ACTIONS(4005),
    [anon_sym_DOLLAR] = ACTIONS(4007),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4007),
    [sym_int] = ACTIONS(4007),
    [sym_xint] = ACTIONS(4005),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4005),
    [anon_sym_POUNDendif] = ACTIONS(4005),
    [sym__newline] = ACTIONS(4005),
  },
  [2037] = {
    [sym_block_comment] = STATE(2037),
    [sym_compiler_directive_decl] = STATE(2037),
    [sym_fsi_directive_decl] = STATE(2037),
    [sym_preproc_line] = STATE(2037),
    [aux_sym_type_argument_repeat1] = STATE(2014),
    [sym_identifier] = ACTIONS(3476),
    [anon_sym_EQ] = ACTIONS(3474),
    [anon_sym_GT_RBRACK] = ACTIONS(3474),
    [anon_sym_COLON] = ACTIONS(3476),
    [anon_sym_return] = ACTIONS(3476),
    [anon_sym_do] = ACTIONS(3476),
    [anon_sym_let] = ACTIONS(3476),
    [anon_sym_let_BANG] = ACTIONS(3474),
    [anon_sym_LPAREN] = ACTIONS(3476),
    [anon_sym_COMMA] = ACTIONS(3474),
    [anon_sym_null] = ACTIONS(3476),
    [anon_sym_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_COLON] = ACTIONS(3474),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym_LBRACK] = ACTIONS(3476),
    [anon_sym_RBRACK] = ACTIONS(3474),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3474),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_RBRACE] = ACTIONS(3474),
    [anon_sym_LT_AT] = ACTIONS(3476),
    [anon_sym_LT_AT_AT] = ACTIONS(3476),
    [anon_sym_DOT] = ACTIONS(3476),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3474),
    [anon_sym_new] = ACTIONS(3476),
    [anon_sym_with] = ACTIONS(3476),
    [anon_sym_return_BANG] = ACTIONS(3474),
    [anon_sym_yield] = ACTIONS(3476),
    [anon_sym_yield_BANG] = ACTIONS(3474),
    [anon_sym_lazy] = ACTIONS(3476),
    [anon_sym_assert] = ACTIONS(3476),
    [anon_sym_upcast] = ACTIONS(3476),
    [anon_sym_downcast] = ACTIONS(3476),
    [anon_sym_COLON_GT] = ACTIONS(3474),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3474),
    [anon_sym_for] = ACTIONS(3476),
    [anon_sym_to] = ACTIONS(3476),
    [anon_sym_downto] = ACTIONS(3476),
    [anon_sym_while] = ACTIONS(3476),
    [anon_sym_if] = ACTIONS(3476),
    [anon_sym_fun] = ACTIONS(3476),
    [anon_sym_DASH_GT] = ACTIONS(3476),
    [anon_sym_try] = ACTIONS(3476),
    [anon_sym_match] = ACTIONS(3476),
    [anon_sym_match_BANG] = ACTIONS(3474),
    [anon_sym_function] = ACTIONS(3476),
    [anon_sym_LT_DASH] = ACTIONS(3476),
    [anon_sym_DOT_LBRACK] = ACTIONS(3474),
    [anon_sym_LT] = ACTIONS(3474),
    [anon_sym_use] = ACTIONS(3476),
    [anon_sym_use_BANG] = ACTIONS(3474),
    [anon_sym_do_BANG] = ACTIONS(3474),
    [anon_sym_begin] = ACTIONS(3476),
    [anon_sym_LPAREN2] = ACTIONS(3476),
    [anon_sym_DOT_DOT2] = ACTIONS(3474),
    [anon_sym_STAR] = ACTIONS(3476),
    [anon_sym_LT2] = ACTIONS(3476),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3474),
    [anon_sym_or] = ACTIONS(3476),
    [aux_sym_char_token1] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3476),
    [anon_sym_DQUOTE] = ACTIONS(3476),
    [anon_sym_AT_DQUOTE] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [sym_bool] = ACTIONS(3476),
    [sym_unit] = ACTIONS(3474),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3476),
    [sym_op_identifier] = ACTIONS(3476),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3476),
    [anon_sym_PLUS_DOT] = ACTIONS(3476),
    [anon_sym_DASH_DOT] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [anon_sym_AMP_AMP] = ACTIONS(3476),
    [anon_sym_TILDE] = ACTIONS(3474),
    [aux_sym_prefix_op_token1] = ACTIONS(3476),
    [aux_sym_infix_op_token1] = ACTIONS(3474),
    [aux_sym_infix_op_token2] = ACTIONS(3476),
    [anon_sym_PIPE_PIPE] = ACTIONS(3476),
    [anon_sym_BANG_EQ] = ACTIONS(3476),
    [anon_sym_COLON_EQ] = ACTIONS(3474),
    [anon_sym_DOLLAR] = ACTIONS(3476),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3476),
    [sym_int] = ACTIONS(3476),
    [sym_xint] = ACTIONS(3474),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3474),
    [sym__newline] = ACTIONS(3474),
  },
  [2038] = {
    [sym_block_comment] = STATE(2038),
    [sym_compiler_directive_decl] = STATE(2038),
    [sym_fsi_directive_decl] = STATE(2038),
    [sym_preproc_line] = STATE(2038),
    [sym_identifier] = ACTIONS(3966),
    [anon_sym_EQ] = ACTIONS(3964),
    [anon_sym_LBRACK_LT] = ACTIONS(3964),
    [anon_sym_COLON] = ACTIONS(3966),
    [anon_sym_return] = ACTIONS(3966),
    [anon_sym_do] = ACTIONS(3966),
    [anon_sym_let] = ACTIONS(3966),
    [anon_sym_let_BANG] = ACTIONS(3964),
    [aux_sym_access_modifier_token1] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COMMA] = ACTIONS(3964),
    [anon_sym_null] = ACTIONS(3966),
    [anon_sym_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(3964),
    [anon_sym_AMP] = ACTIONS(3966),
    [anon_sym_LBRACK] = ACTIONS(3966),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3964),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_LT_AT] = ACTIONS(3966),
    [anon_sym_LT_AT_AT] = ACTIONS(3966),
    [anon_sym_DOT] = ACTIONS(3966),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3964),
    [anon_sym_new] = ACTIONS(3966),
    [anon_sym_with] = ACTIONS(3966),
    [anon_sym_return_BANG] = ACTIONS(3964),
    [anon_sym_yield] = ACTIONS(3966),
    [anon_sym_yield_BANG] = ACTIONS(3964),
    [anon_sym_lazy] = ACTIONS(3966),
    [anon_sym_assert] = ACTIONS(3966),
    [anon_sym_upcast] = ACTIONS(3966),
    [anon_sym_downcast] = ACTIONS(3966),
    [anon_sym_COLON_GT] = ACTIONS(3964),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3964),
    [anon_sym_for] = ACTIONS(3966),
    [anon_sym_while] = ACTIONS(3966),
    [anon_sym_if] = ACTIONS(3966),
    [anon_sym_fun] = ACTIONS(3966),
    [anon_sym_try] = ACTIONS(3966),
    [anon_sym_match] = ACTIONS(3966),
    [anon_sym_match_BANG] = ACTIONS(3964),
    [anon_sym_function] = ACTIONS(3966),
    [anon_sym_LT_DASH] = ACTIONS(3966),
    [anon_sym_DOT_LBRACK] = ACTIONS(3964),
    [anon_sym_LT] = ACTIONS(3964),
    [anon_sym_use] = ACTIONS(3966),
    [anon_sym_use_BANG] = ACTIONS(3964),
    [anon_sym_do_BANG] = ACTIONS(3964),
    [anon_sym_begin] = ACTIONS(3966),
    [anon_sym_LPAREN2] = ACTIONS(3966),
    [anon_sym_DOT_DOT2] = ACTIONS(3964),
    [anon_sym_default] = ACTIONS(3966),
    [anon_sym_or] = ACTIONS(3966),
    [anon_sym_static] = ACTIONS(3966),
    [anon_sym_member] = ACTIONS(3966),
    [anon_sym_interface] = ACTIONS(3966),
    [anon_sym_abstract] = ACTIONS(3966),
    [anon_sym_val] = ACTIONS(3966),
    [anon_sym_override] = ACTIONS(3966),
    [aux_sym_char_token1] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3966),
    [anon_sym_DQUOTE] = ACTIONS(3966),
    [anon_sym_AT_DQUOTE] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [sym_bool] = ACTIONS(3966),
    [sym_unit] = ACTIONS(3964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3966),
    [sym_op_identifier] = ACTIONS(3966),
    [anon_sym_PLUS] = ACTIONS(3966),
    [anon_sym_DASH] = ACTIONS(3966),
    [anon_sym_PLUS_DOT] = ACTIONS(3966),
    [anon_sym_DASH_DOT] = ACTIONS(3966),
    [anon_sym_PERCENT] = ACTIONS(3966),
    [anon_sym_AMP_AMP] = ACTIONS(3966),
    [anon_sym_TILDE] = ACTIONS(3964),
    [aux_sym_prefix_op_token1] = ACTIONS(3966),
    [aux_sym_infix_op_token1] = ACTIONS(3964),
    [aux_sym_infix_op_token2] = ACTIONS(3966),
    [anon_sym_PIPE_PIPE] = ACTIONS(3966),
    [anon_sym_BANG_EQ] = ACTIONS(3966),
    [anon_sym_COLON_EQ] = ACTIONS(3964),
    [anon_sym_DOLLAR] = ACTIONS(3966),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3966),
    [sym_int] = ACTIONS(3966),
    [sym_xint] = ACTIONS(3964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3964),
    [sym__newline] = ACTIONS(3964),
    [sym__dedent] = ACTIONS(3964),
  },
  [2039] = {
    [sym_block_comment] = STATE(2039),
    [sym_compiler_directive_decl] = STATE(2039),
    [sym_fsi_directive_decl] = STATE(2039),
    [sym_preproc_line] = STATE(2039),
    [sym_identifier] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4242),
    [anon_sym_LBRACK_LT] = ACTIONS(4242),
    [anon_sym_COLON] = ACTIONS(4244),
    [anon_sym_return] = ACTIONS(4244),
    [anon_sym_do] = ACTIONS(4244),
    [anon_sym_and] = ACTIONS(4244),
    [anon_sym_let] = ACTIONS(4244),
    [anon_sym_let_BANG] = ACTIONS(4242),
    [aux_sym_access_modifier_token1] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_null] = ACTIONS(4244),
    [anon_sym_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_COLON] = ACTIONS(4242),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4244),
    [anon_sym_LT_AT] = ACTIONS(4244),
    [anon_sym_LT_AT_AT] = ACTIONS(4244),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4242),
    [anon_sym_new] = ACTIONS(4244),
    [anon_sym_with] = ACTIONS(4244),
    [anon_sym_return_BANG] = ACTIONS(4242),
    [anon_sym_yield] = ACTIONS(4244),
    [anon_sym_yield_BANG] = ACTIONS(4242),
    [anon_sym_lazy] = ACTIONS(4244),
    [anon_sym_assert] = ACTIONS(4244),
    [anon_sym_upcast] = ACTIONS(4244),
    [anon_sym_downcast] = ACTIONS(4244),
    [anon_sym_COLON_GT] = ACTIONS(4242),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4242),
    [anon_sym_for] = ACTIONS(4244),
    [anon_sym_while] = ACTIONS(4244),
    [anon_sym_if] = ACTIONS(4244),
    [anon_sym_fun] = ACTIONS(4244),
    [anon_sym_try] = ACTIONS(4244),
    [anon_sym_match] = ACTIONS(4244),
    [anon_sym_match_BANG] = ACTIONS(4242),
    [anon_sym_function] = ACTIONS(4244),
    [anon_sym_LT_DASH] = ACTIONS(4244),
    [anon_sym_DOT_LBRACK] = ACTIONS(4242),
    [anon_sym_LT] = ACTIONS(4242),
    [anon_sym_use] = ACTIONS(4244),
    [anon_sym_use_BANG] = ACTIONS(4242),
    [anon_sym_do_BANG] = ACTIONS(4242),
    [anon_sym_begin] = ACTIONS(4244),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_default] = ACTIONS(4244),
    [anon_sym_or] = ACTIONS(4244),
    [anon_sym_static] = ACTIONS(4244),
    [anon_sym_member] = ACTIONS(4244),
    [anon_sym_interface] = ACTIONS(4244),
    [anon_sym_abstract] = ACTIONS(4244),
    [anon_sym_val] = ACTIONS(4244),
    [anon_sym_override] = ACTIONS(4244),
    [aux_sym_char_token1] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4244),
    [anon_sym_DQUOTE] = ACTIONS(4244),
    [anon_sym_AT_DQUOTE] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [sym_bool] = ACTIONS(4244),
    [sym_unit] = ACTIONS(4242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4244),
    [sym_op_identifier] = ACTIONS(4244),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_DASH] = ACTIONS(4244),
    [anon_sym_PLUS_DOT] = ACTIONS(4244),
    [anon_sym_DASH_DOT] = ACTIONS(4244),
    [anon_sym_PERCENT] = ACTIONS(4244),
    [anon_sym_AMP_AMP] = ACTIONS(4244),
    [anon_sym_TILDE] = ACTIONS(4242),
    [aux_sym_prefix_op_token1] = ACTIONS(4244),
    [aux_sym_infix_op_token1] = ACTIONS(4242),
    [aux_sym_infix_op_token2] = ACTIONS(4244),
    [anon_sym_PIPE_PIPE] = ACTIONS(4244),
    [anon_sym_BANG_EQ] = ACTIONS(4244),
    [anon_sym_COLON_EQ] = ACTIONS(4242),
    [anon_sym_DOLLAR] = ACTIONS(4244),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4244),
    [sym_int] = ACTIONS(4244),
    [sym_xint] = ACTIONS(4242),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4242),
    [sym__newline] = ACTIONS(4242),
    [sym__dedent] = ACTIONS(4242),
  },
  [2040] = {
    [sym_block_comment] = STATE(2040),
    [sym_compiler_directive_decl] = STATE(2040),
    [sym_fsi_directive_decl] = STATE(2040),
    [sym_preproc_line] = STATE(2040),
    [sym_identifier] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3919),
    [anon_sym_LBRACK_LT] = ACTIONS(3919),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_return] = ACTIONS(3921),
    [anon_sym_do] = ACTIONS(3921),
    [anon_sym_and] = ACTIONS(3921),
    [anon_sym_let] = ACTIONS(3921),
    [anon_sym_let_BANG] = ACTIONS(3919),
    [aux_sym_access_modifier_token1] = ACTIONS(3919),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3919),
    [anon_sym_null] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_COLON] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3919),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_LT_AT] = ACTIONS(3921),
    [anon_sym_LT_AT_AT] = ACTIONS(3921),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3919),
    [anon_sym_new] = ACTIONS(3921),
    [anon_sym_with] = ACTIONS(3921),
    [anon_sym_return_BANG] = ACTIONS(3919),
    [anon_sym_yield] = ACTIONS(3921),
    [anon_sym_yield_BANG] = ACTIONS(3919),
    [anon_sym_lazy] = ACTIONS(3921),
    [anon_sym_assert] = ACTIONS(3921),
    [anon_sym_upcast] = ACTIONS(3921),
    [anon_sym_downcast] = ACTIONS(3921),
    [anon_sym_COLON_GT] = ACTIONS(3919),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3919),
    [anon_sym_for] = ACTIONS(3921),
    [anon_sym_while] = ACTIONS(3921),
    [anon_sym_if] = ACTIONS(3921),
    [anon_sym_fun] = ACTIONS(3921),
    [anon_sym_try] = ACTIONS(3921),
    [anon_sym_match] = ACTIONS(3921),
    [anon_sym_match_BANG] = ACTIONS(3919),
    [anon_sym_function] = ACTIONS(3921),
    [anon_sym_LT_DASH] = ACTIONS(3921),
    [anon_sym_DOT_LBRACK] = ACTIONS(3919),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_use] = ACTIONS(3921),
    [anon_sym_use_BANG] = ACTIONS(3919),
    [anon_sym_do_BANG] = ACTIONS(3919),
    [anon_sym_begin] = ACTIONS(3921),
    [anon_sym_LPAREN2] = ACTIONS(3921),
    [anon_sym_default] = ACTIONS(3921),
    [anon_sym_or] = ACTIONS(3921),
    [anon_sym_static] = ACTIONS(3921),
    [anon_sym_member] = ACTIONS(3921),
    [anon_sym_interface] = ACTIONS(3921),
    [anon_sym_abstract] = ACTIONS(3921),
    [anon_sym_val] = ACTIONS(3921),
    [anon_sym_override] = ACTIONS(3921),
    [aux_sym_char_token1] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_AT_DQUOTE] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [sym_bool] = ACTIONS(3921),
    [sym_unit] = ACTIONS(3919),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3921),
    [sym_op_identifier] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_DOT] = ACTIONS(3921),
    [anon_sym_DASH_DOT] = ACTIONS(3921),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3919),
    [aux_sym_prefix_op_token1] = ACTIONS(3921),
    [aux_sym_infix_op_token1] = ACTIONS(3919),
    [aux_sym_infix_op_token2] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_COLON_EQ] = ACTIONS(3919),
    [anon_sym_DOLLAR] = ACTIONS(3921),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3921),
    [sym_int] = ACTIONS(3921),
    [sym_xint] = ACTIONS(3919),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3919),
    [anon_sym_POUNDendif] = ACTIONS(3919),
    [sym__newline] = ACTIONS(3919),
  },
  [2041] = {
    [sym_block_comment] = STATE(2041),
    [sym_compiler_directive_decl] = STATE(2041),
    [sym_fsi_directive_decl] = STATE(2041),
    [sym_preproc_line] = STATE(2041),
    [sym_identifier] = ACTIONS(4182),
    [anon_sym_EQ] = ACTIONS(3689),
    [anon_sym_LBRACK_LT] = ACTIONS(3689),
    [anon_sym_COLON] = ACTIONS(4182),
    [anon_sym_return] = ACTIONS(4182),
    [anon_sym_do] = ACTIONS(4182),
    [anon_sym_and] = ACTIONS(4182),
    [anon_sym_let] = ACTIONS(4182),
    [anon_sym_let_BANG] = ACTIONS(3689),
    [aux_sym_access_modifier_token1] = ACTIONS(3689),
    [anon_sym_LPAREN] = ACTIONS(4182),
    [anon_sym_COMMA] = ACTIONS(3689),
    [anon_sym_null] = ACTIONS(4182),
    [anon_sym_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3689),
    [anon_sym_LBRACE] = ACTIONS(4182),
    [anon_sym_LT_AT] = ACTIONS(4182),
    [anon_sym_LT_AT_AT] = ACTIONS(4182),
    [anon_sym_DOT] = ACTIONS(4182),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3689),
    [anon_sym_new] = ACTIONS(4182),
    [anon_sym_with] = ACTIONS(4182),
    [anon_sym_return_BANG] = ACTIONS(3689),
    [anon_sym_yield] = ACTIONS(4182),
    [anon_sym_yield_BANG] = ACTIONS(3689),
    [anon_sym_lazy] = ACTIONS(4182),
    [anon_sym_assert] = ACTIONS(4182),
    [anon_sym_upcast] = ACTIONS(4182),
    [anon_sym_downcast] = ACTIONS(4182),
    [anon_sym_COLON_GT] = ACTIONS(3689),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3689),
    [anon_sym_for] = ACTIONS(4182),
    [anon_sym_while] = ACTIONS(4182),
    [anon_sym_if] = ACTIONS(4182),
    [anon_sym_fun] = ACTIONS(4182),
    [anon_sym_try] = ACTIONS(4182),
    [anon_sym_match] = ACTIONS(4182),
    [anon_sym_match_BANG] = ACTIONS(3689),
    [anon_sym_function] = ACTIONS(4182),
    [anon_sym_LT_DASH] = ACTIONS(4182),
    [anon_sym_DOT_LBRACK] = ACTIONS(3689),
    [anon_sym_LT] = ACTIONS(3689),
    [anon_sym_use] = ACTIONS(4182),
    [anon_sym_use_BANG] = ACTIONS(3689),
    [anon_sym_do_BANG] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(4182),
    [anon_sym_LPAREN2] = ACTIONS(4182),
    [anon_sym_default] = ACTIONS(4182),
    [anon_sym_or] = ACTIONS(4182),
    [anon_sym_static] = ACTIONS(4182),
    [anon_sym_member] = ACTIONS(4182),
    [anon_sym_interface] = ACTIONS(4182),
    [anon_sym_abstract] = ACTIONS(4182),
    [anon_sym_val] = ACTIONS(4182),
    [anon_sym_override] = ACTIONS(4182),
    [aux_sym_char_token1] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4182),
    [anon_sym_DQUOTE] = ACTIONS(4182),
    [anon_sym_AT_DQUOTE] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [sym_bool] = ACTIONS(4182),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4182),
    [sym_op_identifier] = ACTIONS(4182),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_PLUS_DOT] = ACTIONS(4182),
    [anon_sym_DASH_DOT] = ACTIONS(4182),
    [anon_sym_PERCENT] = ACTIONS(4182),
    [anon_sym_AMP_AMP] = ACTIONS(4182),
    [anon_sym_TILDE] = ACTIONS(3689),
    [aux_sym_prefix_op_token1] = ACTIONS(4182),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token2] = ACTIONS(4182),
    [anon_sym_PIPE_PIPE] = ACTIONS(4182),
    [anon_sym_BANG_EQ] = ACTIONS(4182),
    [anon_sym_COLON_EQ] = ACTIONS(3689),
    [anon_sym_DOLLAR] = ACTIONS(4182),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4182),
    [sym_int] = ACTIONS(4182),
    [sym_xint] = ACTIONS(3689),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3689),
    [anon_sym_POUNDendif] = ACTIONS(3689),
    [sym__newline] = ACTIONS(3689),
  },
  [2042] = {
    [sym_block_comment] = STATE(2042),
    [sym_compiler_directive_decl] = STATE(2042),
    [sym_fsi_directive_decl] = STATE(2042),
    [sym_preproc_line] = STATE(2042),
    [sym_identifier] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3919),
    [anon_sym_LBRACK_LT] = ACTIONS(3919),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_return] = ACTIONS(3921),
    [anon_sym_do] = ACTIONS(3921),
    [anon_sym_let] = ACTIONS(3921),
    [anon_sym_let_BANG] = ACTIONS(3919),
    [aux_sym_access_modifier_token1] = ACTIONS(3919),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3919),
    [anon_sym_null] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_COLON] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3919),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_LT_AT] = ACTIONS(3921),
    [anon_sym_LT_AT_AT] = ACTIONS(3921),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3919),
    [anon_sym_new] = ACTIONS(3921),
    [anon_sym_with] = ACTIONS(3921),
    [anon_sym_return_BANG] = ACTIONS(3919),
    [anon_sym_yield] = ACTIONS(3921),
    [anon_sym_yield_BANG] = ACTIONS(3919),
    [anon_sym_lazy] = ACTIONS(3921),
    [anon_sym_assert] = ACTIONS(3921),
    [anon_sym_upcast] = ACTIONS(3921),
    [anon_sym_downcast] = ACTIONS(3921),
    [anon_sym_COLON_GT] = ACTIONS(3919),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3919),
    [anon_sym_for] = ACTIONS(3921),
    [anon_sym_while] = ACTIONS(3921),
    [anon_sym_if] = ACTIONS(3921),
    [anon_sym_fun] = ACTIONS(3921),
    [anon_sym_try] = ACTIONS(3921),
    [anon_sym_match] = ACTIONS(3921),
    [anon_sym_match_BANG] = ACTIONS(3919),
    [anon_sym_function] = ACTIONS(3921),
    [anon_sym_LT_DASH] = ACTIONS(3921),
    [anon_sym_DOT_LBRACK] = ACTIONS(3919),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_use] = ACTIONS(3921),
    [anon_sym_use_BANG] = ACTIONS(3919),
    [anon_sym_do_BANG] = ACTIONS(3919),
    [anon_sym_begin] = ACTIONS(3921),
    [anon_sym_LPAREN2] = ACTIONS(3921),
    [anon_sym_default] = ACTIONS(3921),
    [anon_sym_or] = ACTIONS(3921),
    [anon_sym_static] = ACTIONS(3921),
    [anon_sym_member] = ACTIONS(3921),
    [anon_sym_interface] = ACTIONS(3921),
    [anon_sym_abstract] = ACTIONS(3921),
    [anon_sym_val] = ACTIONS(3921),
    [anon_sym_override] = ACTIONS(3921),
    [anon_sym_inherit] = ACTIONS(3921),
    [aux_sym_char_token1] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_AT_DQUOTE] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [sym_bool] = ACTIONS(3921),
    [sym_unit] = ACTIONS(3919),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3921),
    [sym_op_identifier] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_DOT] = ACTIONS(3921),
    [anon_sym_DASH_DOT] = ACTIONS(3921),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3919),
    [aux_sym_prefix_op_token1] = ACTIONS(3921),
    [aux_sym_infix_op_token1] = ACTIONS(3919),
    [aux_sym_infix_op_token2] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_COLON_EQ] = ACTIONS(3919),
    [anon_sym_DOLLAR] = ACTIONS(3921),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3921),
    [sym_int] = ACTIONS(3921),
    [sym_xint] = ACTIONS(3919),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3919),
    [anon_sym_POUNDendif] = ACTIONS(3919),
    [sym__newline] = ACTIONS(3919),
  },
  [2043] = {
    [sym_block_comment] = STATE(2043),
    [sym_compiler_directive_decl] = STATE(2043),
    [sym_fsi_directive_decl] = STATE(2043),
    [sym_preproc_line] = STATE(2043),
    [sym_identifier] = ACTIONS(4162),
    [anon_sym_EQ] = ACTIONS(4160),
    [anon_sym_LBRACK_LT] = ACTIONS(4160),
    [anon_sym_COLON] = ACTIONS(4162),
    [anon_sym_return] = ACTIONS(4162),
    [anon_sym_do] = ACTIONS(4162),
    [anon_sym_and] = ACTIONS(4162),
    [anon_sym_let] = ACTIONS(4162),
    [anon_sym_let_BANG] = ACTIONS(4160),
    [aux_sym_access_modifier_token1] = ACTIONS(4160),
    [anon_sym_LPAREN] = ACTIONS(4162),
    [anon_sym_COMMA] = ACTIONS(4160),
    [anon_sym_null] = ACTIONS(4162),
    [anon_sym_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4160),
    [anon_sym_AMP] = ACTIONS(4162),
    [anon_sym_LBRACK] = ACTIONS(4162),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4160),
    [anon_sym_LBRACE] = ACTIONS(4162),
    [anon_sym_LT_AT] = ACTIONS(4162),
    [anon_sym_LT_AT_AT] = ACTIONS(4162),
    [anon_sym_DOT] = ACTIONS(4162),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4160),
    [anon_sym_new] = ACTIONS(4162),
    [anon_sym_with] = ACTIONS(4162),
    [anon_sym_return_BANG] = ACTIONS(4160),
    [anon_sym_yield] = ACTIONS(4162),
    [anon_sym_yield_BANG] = ACTIONS(4160),
    [anon_sym_lazy] = ACTIONS(4162),
    [anon_sym_assert] = ACTIONS(4162),
    [anon_sym_upcast] = ACTIONS(4162),
    [anon_sym_downcast] = ACTIONS(4162),
    [anon_sym_COLON_GT] = ACTIONS(4160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4160),
    [anon_sym_for] = ACTIONS(4162),
    [anon_sym_while] = ACTIONS(4162),
    [anon_sym_if] = ACTIONS(4162),
    [anon_sym_fun] = ACTIONS(4162),
    [anon_sym_try] = ACTIONS(4162),
    [anon_sym_match] = ACTIONS(4162),
    [anon_sym_match_BANG] = ACTIONS(4160),
    [anon_sym_function] = ACTIONS(4162),
    [anon_sym_LT_DASH] = ACTIONS(4162),
    [anon_sym_DOT_LBRACK] = ACTIONS(4160),
    [anon_sym_LT] = ACTIONS(4160),
    [anon_sym_use] = ACTIONS(4162),
    [anon_sym_use_BANG] = ACTIONS(4160),
    [anon_sym_do_BANG] = ACTIONS(4160),
    [anon_sym_begin] = ACTIONS(4162),
    [anon_sym_LPAREN2] = ACTIONS(4162),
    [anon_sym_default] = ACTIONS(4162),
    [anon_sym_or] = ACTIONS(4162),
    [anon_sym_static] = ACTIONS(4162),
    [anon_sym_member] = ACTIONS(4162),
    [anon_sym_interface] = ACTIONS(4162),
    [anon_sym_abstract] = ACTIONS(4162),
    [anon_sym_val] = ACTIONS(4162),
    [anon_sym_override] = ACTIONS(4162),
    [aux_sym_char_token1] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4162),
    [anon_sym_DQUOTE] = ACTIONS(4162),
    [anon_sym_AT_DQUOTE] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [sym_bool] = ACTIONS(4162),
    [sym_unit] = ACTIONS(4160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4162),
    [sym_op_identifier] = ACTIONS(4162),
    [anon_sym_PLUS] = ACTIONS(4162),
    [anon_sym_DASH] = ACTIONS(4162),
    [anon_sym_PLUS_DOT] = ACTIONS(4162),
    [anon_sym_DASH_DOT] = ACTIONS(4162),
    [anon_sym_PERCENT] = ACTIONS(4162),
    [anon_sym_AMP_AMP] = ACTIONS(4162),
    [anon_sym_TILDE] = ACTIONS(4160),
    [aux_sym_prefix_op_token1] = ACTIONS(4162),
    [aux_sym_infix_op_token1] = ACTIONS(4160),
    [aux_sym_infix_op_token2] = ACTIONS(4162),
    [anon_sym_PIPE_PIPE] = ACTIONS(4162),
    [anon_sym_BANG_EQ] = ACTIONS(4162),
    [anon_sym_COLON_EQ] = ACTIONS(4160),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4162),
    [sym_int] = ACTIONS(4162),
    [sym_xint] = ACTIONS(4160),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4160),
    [anon_sym_POUNDendif] = ACTIONS(4160),
    [sym__newline] = ACTIONS(4160),
  },
  [2044] = {
    [sym_block_comment] = STATE(2044),
    [sym_compiler_directive_decl] = STATE(2044),
    [sym_fsi_directive_decl] = STATE(2044),
    [sym_preproc_line] = STATE(2044),
    [sym_identifier] = ACTIONS(4158),
    [anon_sym_EQ] = ACTIONS(4156),
    [anon_sym_LBRACK_LT] = ACTIONS(4156),
    [anon_sym_COLON] = ACTIONS(4158),
    [anon_sym_return] = ACTIONS(4158),
    [anon_sym_do] = ACTIONS(4158),
    [anon_sym_and] = ACTIONS(4158),
    [anon_sym_let] = ACTIONS(4158),
    [anon_sym_let_BANG] = ACTIONS(4156),
    [aux_sym_access_modifier_token1] = ACTIONS(4156),
    [anon_sym_LPAREN] = ACTIONS(4158),
    [anon_sym_COMMA] = ACTIONS(4156),
    [anon_sym_null] = ACTIONS(4158),
    [anon_sym_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_COLON] = ACTIONS(4156),
    [anon_sym_AMP] = ACTIONS(4158),
    [anon_sym_LBRACK] = ACTIONS(4158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(4158),
    [anon_sym_LT_AT] = ACTIONS(4158),
    [anon_sym_LT_AT_AT] = ACTIONS(4158),
    [anon_sym_DOT] = ACTIONS(4158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4156),
    [anon_sym_new] = ACTIONS(4158),
    [anon_sym_with] = ACTIONS(4158),
    [anon_sym_return_BANG] = ACTIONS(4156),
    [anon_sym_yield] = ACTIONS(4158),
    [anon_sym_yield_BANG] = ACTIONS(4156),
    [anon_sym_lazy] = ACTIONS(4158),
    [anon_sym_assert] = ACTIONS(4158),
    [anon_sym_upcast] = ACTIONS(4158),
    [anon_sym_downcast] = ACTIONS(4158),
    [anon_sym_COLON_GT] = ACTIONS(4156),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4156),
    [anon_sym_for] = ACTIONS(4158),
    [anon_sym_while] = ACTIONS(4158),
    [anon_sym_if] = ACTIONS(4158),
    [anon_sym_fun] = ACTIONS(4158),
    [anon_sym_try] = ACTIONS(4158),
    [anon_sym_match] = ACTIONS(4158),
    [anon_sym_match_BANG] = ACTIONS(4156),
    [anon_sym_function] = ACTIONS(4158),
    [anon_sym_LT_DASH] = ACTIONS(4158),
    [anon_sym_DOT_LBRACK] = ACTIONS(4156),
    [anon_sym_LT] = ACTIONS(4156),
    [anon_sym_use] = ACTIONS(4158),
    [anon_sym_use_BANG] = ACTIONS(4156),
    [anon_sym_do_BANG] = ACTIONS(4156),
    [anon_sym_begin] = ACTIONS(4158),
    [anon_sym_LPAREN2] = ACTIONS(4158),
    [anon_sym_default] = ACTIONS(4158),
    [anon_sym_or] = ACTIONS(4158),
    [anon_sym_static] = ACTIONS(4158),
    [anon_sym_member] = ACTIONS(4158),
    [anon_sym_interface] = ACTIONS(4158),
    [anon_sym_abstract] = ACTIONS(4158),
    [anon_sym_val] = ACTIONS(4158),
    [anon_sym_override] = ACTIONS(4158),
    [aux_sym_char_token1] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4158),
    [anon_sym_DQUOTE] = ACTIONS(4158),
    [anon_sym_AT_DQUOTE] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [sym_bool] = ACTIONS(4158),
    [sym_unit] = ACTIONS(4156),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4158),
    [sym_op_identifier] = ACTIONS(4158),
    [anon_sym_PLUS] = ACTIONS(4158),
    [anon_sym_DASH] = ACTIONS(4158),
    [anon_sym_PLUS_DOT] = ACTIONS(4158),
    [anon_sym_DASH_DOT] = ACTIONS(4158),
    [anon_sym_PERCENT] = ACTIONS(4158),
    [anon_sym_AMP_AMP] = ACTIONS(4158),
    [anon_sym_TILDE] = ACTIONS(4156),
    [aux_sym_prefix_op_token1] = ACTIONS(4158),
    [aux_sym_infix_op_token1] = ACTIONS(4156),
    [aux_sym_infix_op_token2] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE] = ACTIONS(4158),
    [anon_sym_BANG_EQ] = ACTIONS(4158),
    [anon_sym_COLON_EQ] = ACTIONS(4156),
    [anon_sym_DOLLAR] = ACTIONS(4158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4158),
    [sym_int] = ACTIONS(4158),
    [sym_xint] = ACTIONS(4156),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4156),
    [anon_sym_POUNDendif] = ACTIONS(4156),
    [sym__newline] = ACTIONS(4156),
  },
  [2045] = {
    [sym_block_comment] = STATE(2045),
    [sym_compiler_directive_decl] = STATE(2045),
    [sym_fsi_directive_decl] = STATE(2045),
    [sym_preproc_line] = STATE(2045),
    [sym_identifier] = ACTIONS(4122),
    [anon_sym_EQ] = ACTIONS(4120),
    [anon_sym_LBRACK_LT] = ACTIONS(4120),
    [anon_sym_COLON] = ACTIONS(4122),
    [anon_sym_return] = ACTIONS(4122),
    [anon_sym_do] = ACTIONS(4122),
    [anon_sym_let] = ACTIONS(4122),
    [anon_sym_let_BANG] = ACTIONS(4120),
    [aux_sym_access_modifier_token1] = ACTIONS(4120),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_COMMA] = ACTIONS(4120),
    [anon_sym_null] = ACTIONS(4122),
    [anon_sym_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_COLON] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_LT_AT] = ACTIONS(4122),
    [anon_sym_LT_AT_AT] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4122),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4120),
    [anon_sym_new] = ACTIONS(4122),
    [anon_sym_with] = ACTIONS(4122),
    [anon_sym_return_BANG] = ACTIONS(4120),
    [anon_sym_yield] = ACTIONS(4122),
    [anon_sym_yield_BANG] = ACTIONS(4120),
    [anon_sym_lazy] = ACTIONS(4122),
    [anon_sym_assert] = ACTIONS(4122),
    [anon_sym_upcast] = ACTIONS(4122),
    [anon_sym_downcast] = ACTIONS(4122),
    [anon_sym_COLON_GT] = ACTIONS(4120),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4120),
    [anon_sym_for] = ACTIONS(4122),
    [anon_sym_while] = ACTIONS(4122),
    [anon_sym_if] = ACTIONS(4122),
    [anon_sym_fun] = ACTIONS(4122),
    [anon_sym_try] = ACTIONS(4122),
    [anon_sym_match] = ACTIONS(4122),
    [anon_sym_match_BANG] = ACTIONS(4120),
    [anon_sym_function] = ACTIONS(4122),
    [anon_sym_LT_DASH] = ACTIONS(4122),
    [anon_sym_DOT_LBRACK] = ACTIONS(4120),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_use] = ACTIONS(4122),
    [anon_sym_use_BANG] = ACTIONS(4120),
    [anon_sym_do_BANG] = ACTIONS(4120),
    [anon_sym_begin] = ACTIONS(4122),
    [anon_sym_LPAREN2] = ACTIONS(4122),
    [anon_sym_DOT_DOT2] = ACTIONS(4120),
    [anon_sym_default] = ACTIONS(4122),
    [anon_sym_or] = ACTIONS(4122),
    [anon_sym_static] = ACTIONS(4122),
    [anon_sym_member] = ACTIONS(4122),
    [anon_sym_interface] = ACTIONS(4122),
    [anon_sym_abstract] = ACTIONS(4122),
    [anon_sym_val] = ACTIONS(4122),
    [anon_sym_override] = ACTIONS(4122),
    [aux_sym_char_token1] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4122),
    [anon_sym_DQUOTE] = ACTIONS(4122),
    [anon_sym_AT_DQUOTE] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [sym_bool] = ACTIONS(4122),
    [sym_unit] = ACTIONS(4120),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4122),
    [sym_op_identifier] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4122),
    [anon_sym_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_DOT] = ACTIONS(4122),
    [anon_sym_DASH_DOT] = ACTIONS(4122),
    [anon_sym_PERCENT] = ACTIONS(4122),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_TILDE] = ACTIONS(4120),
    [aux_sym_prefix_op_token1] = ACTIONS(4122),
    [aux_sym_infix_op_token1] = ACTIONS(4120),
    [aux_sym_infix_op_token2] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_COLON_EQ] = ACTIONS(4120),
    [anon_sym_DOLLAR] = ACTIONS(4122),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4122),
    [sym_int] = ACTIONS(4122),
    [sym_xint] = ACTIONS(4120),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4120),
    [sym__newline] = ACTIONS(4120),
    [sym__dedent] = ACTIONS(4120),
  },
  [2046] = {
    [sym_block_comment] = STATE(2046),
    [sym_compiler_directive_decl] = STATE(2046),
    [sym_fsi_directive_decl] = STATE(2046),
    [sym_preproc_line] = STATE(2046),
    [sym_identifier] = ACTIONS(3976),
    [anon_sym_EQ] = ACTIONS(3974),
    [anon_sym_LBRACK_LT] = ACTIONS(3974),
    [anon_sym_COLON] = ACTIONS(3976),
    [anon_sym_return] = ACTIONS(3976),
    [anon_sym_do] = ACTIONS(3976),
    [anon_sym_and] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_let_BANG] = ACTIONS(3974),
    [aux_sym_access_modifier_token1] = ACTIONS(3974),
    [anon_sym_LPAREN] = ACTIONS(3976),
    [anon_sym_COMMA] = ACTIONS(3974),
    [anon_sym_null] = ACTIONS(3976),
    [anon_sym_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_COLON] = ACTIONS(3974),
    [anon_sym_AMP] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(3976),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3974),
    [anon_sym_LBRACE] = ACTIONS(3976),
    [anon_sym_LT_AT] = ACTIONS(3976),
    [anon_sym_LT_AT_AT] = ACTIONS(3976),
    [anon_sym_DOT] = ACTIONS(3976),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3974),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_with] = ACTIONS(3976),
    [anon_sym_return_BANG] = ACTIONS(3974),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_yield_BANG] = ACTIONS(3974),
    [anon_sym_lazy] = ACTIONS(3976),
    [anon_sym_assert] = ACTIONS(3976),
    [anon_sym_upcast] = ACTIONS(3976),
    [anon_sym_downcast] = ACTIONS(3976),
    [anon_sym_COLON_GT] = ACTIONS(3974),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3974),
    [anon_sym_for] = ACTIONS(3976),
    [anon_sym_while] = ACTIONS(3976),
    [anon_sym_if] = ACTIONS(3976),
    [anon_sym_fun] = ACTIONS(3976),
    [anon_sym_try] = ACTIONS(3976),
    [anon_sym_match] = ACTIONS(3976),
    [anon_sym_match_BANG] = ACTIONS(3974),
    [anon_sym_function] = ACTIONS(3976),
    [anon_sym_LT_DASH] = ACTIONS(3976),
    [anon_sym_DOT_LBRACK] = ACTIONS(3974),
    [anon_sym_LT] = ACTIONS(3974),
    [anon_sym_use] = ACTIONS(3976),
    [anon_sym_use_BANG] = ACTIONS(3974),
    [anon_sym_do_BANG] = ACTIONS(3974),
    [anon_sym_begin] = ACTIONS(3976),
    [anon_sym_LPAREN2] = ACTIONS(3976),
    [anon_sym_default] = ACTIONS(3976),
    [anon_sym_or] = ACTIONS(3976),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_member] = ACTIONS(3976),
    [anon_sym_interface] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_val] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [aux_sym_char_token1] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3976),
    [anon_sym_DQUOTE] = ACTIONS(3976),
    [anon_sym_AT_DQUOTE] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [sym_bool] = ACTIONS(3976),
    [sym_unit] = ACTIONS(3974),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3976),
    [sym_op_identifier] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3976),
    [anon_sym_DASH] = ACTIONS(3976),
    [anon_sym_PLUS_DOT] = ACTIONS(3976),
    [anon_sym_DASH_DOT] = ACTIONS(3976),
    [anon_sym_PERCENT] = ACTIONS(3976),
    [anon_sym_AMP_AMP] = ACTIONS(3976),
    [anon_sym_TILDE] = ACTIONS(3974),
    [aux_sym_prefix_op_token1] = ACTIONS(3976),
    [aux_sym_infix_op_token1] = ACTIONS(3974),
    [aux_sym_infix_op_token2] = ACTIONS(3976),
    [anon_sym_PIPE_PIPE] = ACTIONS(3976),
    [anon_sym_BANG_EQ] = ACTIONS(3976),
    [anon_sym_COLON_EQ] = ACTIONS(3974),
    [anon_sym_DOLLAR] = ACTIONS(3976),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3976),
    [sym_int] = ACTIONS(3976),
    [sym_xint] = ACTIONS(3974),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3974),
    [sym__newline] = ACTIONS(3974),
    [sym__dedent] = ACTIONS(3974),
  },
  [2047] = {
    [sym_block_comment] = STATE(2047),
    [sym_compiler_directive_decl] = STATE(2047),
    [sym_fsi_directive_decl] = STATE(2047),
    [sym_preproc_line] = STATE(2047),
    [sym_identifier] = ACTIONS(4126),
    [anon_sym_EQ] = ACTIONS(4124),
    [anon_sym_LBRACK_LT] = ACTIONS(4124),
    [anon_sym_COLON] = ACTIONS(4126),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_do] = ACTIONS(4126),
    [anon_sym_let] = ACTIONS(4126),
    [anon_sym_let_BANG] = ACTIONS(4124),
    [aux_sym_access_modifier_token1] = ACTIONS(4124),
    [anon_sym_LPAREN] = ACTIONS(4126),
    [anon_sym_COMMA] = ACTIONS(4124),
    [anon_sym_null] = ACTIONS(4126),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_COLON] = ACTIONS(4124),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LBRACK] = ACTIONS(4126),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4126),
    [anon_sym_LT_AT] = ACTIONS(4126),
    [anon_sym_LT_AT_AT] = ACTIONS(4126),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4124),
    [anon_sym_new] = ACTIONS(4126),
    [anon_sym_with] = ACTIONS(4126),
    [anon_sym_return_BANG] = ACTIONS(4124),
    [anon_sym_yield] = ACTIONS(4126),
    [anon_sym_yield_BANG] = ACTIONS(4124),
    [anon_sym_lazy] = ACTIONS(4126),
    [anon_sym_assert] = ACTIONS(4126),
    [anon_sym_upcast] = ACTIONS(4126),
    [anon_sym_downcast] = ACTIONS(4126),
    [anon_sym_COLON_GT] = ACTIONS(4124),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4124),
    [anon_sym_for] = ACTIONS(4126),
    [anon_sym_while] = ACTIONS(4126),
    [anon_sym_if] = ACTIONS(4126),
    [anon_sym_fun] = ACTIONS(4126),
    [anon_sym_try] = ACTIONS(4126),
    [anon_sym_match] = ACTIONS(4126),
    [anon_sym_match_BANG] = ACTIONS(4124),
    [anon_sym_function] = ACTIONS(4126),
    [anon_sym_LT_DASH] = ACTIONS(4126),
    [anon_sym_DOT_LBRACK] = ACTIONS(4124),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_use] = ACTIONS(4126),
    [anon_sym_use_BANG] = ACTIONS(4124),
    [anon_sym_do_BANG] = ACTIONS(4124),
    [anon_sym_begin] = ACTIONS(4126),
    [anon_sym_LPAREN2] = ACTIONS(4126),
    [anon_sym_DOT_DOT2] = ACTIONS(4124),
    [anon_sym_default] = ACTIONS(4126),
    [anon_sym_or] = ACTIONS(4126),
    [anon_sym_static] = ACTIONS(4126),
    [anon_sym_member] = ACTIONS(4126),
    [anon_sym_interface] = ACTIONS(4126),
    [anon_sym_abstract] = ACTIONS(4126),
    [anon_sym_val] = ACTIONS(4126),
    [anon_sym_override] = ACTIONS(4126),
    [aux_sym_char_token1] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4126),
    [anon_sym_DQUOTE] = ACTIONS(4126),
    [anon_sym_AT_DQUOTE] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [sym_bool] = ACTIONS(4126),
    [sym_unit] = ACTIONS(4124),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4126),
    [sym_op_identifier] = ACTIONS(4126),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_PLUS_DOT] = ACTIONS(4126),
    [anon_sym_DASH_DOT] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_AMP_AMP] = ACTIONS(4126),
    [anon_sym_TILDE] = ACTIONS(4124),
    [aux_sym_prefix_op_token1] = ACTIONS(4126),
    [aux_sym_infix_op_token1] = ACTIONS(4124),
    [aux_sym_infix_op_token2] = ACTIONS(4126),
    [anon_sym_PIPE_PIPE] = ACTIONS(4126),
    [anon_sym_BANG_EQ] = ACTIONS(4126),
    [anon_sym_COLON_EQ] = ACTIONS(4124),
    [anon_sym_DOLLAR] = ACTIONS(4126),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4126),
    [sym_int] = ACTIONS(4126),
    [sym_xint] = ACTIONS(4124),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4124),
    [sym__newline] = ACTIONS(4124),
    [sym__dedent] = ACTIONS(4124),
  },
  [2048] = {
    [sym_block_comment] = STATE(2048),
    [sym_compiler_directive_decl] = STATE(2048),
    [sym_fsi_directive_decl] = STATE(2048),
    [sym_preproc_line] = STATE(2048),
    [sym_identifier] = ACTIONS(4232),
    [anon_sym_EQ] = ACTIONS(4230),
    [anon_sym_LBRACK_LT] = ACTIONS(4230),
    [anon_sym_COLON] = ACTIONS(4232),
    [anon_sym_return] = ACTIONS(4232),
    [anon_sym_do] = ACTIONS(4232),
    [anon_sym_let] = ACTIONS(4232),
    [anon_sym_let_BANG] = ACTIONS(4230),
    [aux_sym_access_modifier_token1] = ACTIONS(4230),
    [anon_sym_LPAREN] = ACTIONS(4232),
    [anon_sym_COMMA] = ACTIONS(4230),
    [anon_sym_null] = ACTIONS(4232),
    [anon_sym_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_COLON] = ACTIONS(4230),
    [anon_sym_AMP] = ACTIONS(4232),
    [anon_sym_LBRACK] = ACTIONS(4232),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4230),
    [anon_sym_LBRACE] = ACTIONS(4232),
    [anon_sym_LT_AT] = ACTIONS(4232),
    [anon_sym_LT_AT_AT] = ACTIONS(4232),
    [anon_sym_DOT] = ACTIONS(4232),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4230),
    [anon_sym_new] = ACTIONS(4232),
    [anon_sym_with] = ACTIONS(4232),
    [anon_sym_return_BANG] = ACTIONS(4230),
    [anon_sym_yield] = ACTIONS(4232),
    [anon_sym_yield_BANG] = ACTIONS(4230),
    [anon_sym_lazy] = ACTIONS(4232),
    [anon_sym_assert] = ACTIONS(4232),
    [anon_sym_upcast] = ACTIONS(4232),
    [anon_sym_downcast] = ACTIONS(4232),
    [anon_sym_COLON_GT] = ACTIONS(4230),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4230),
    [anon_sym_for] = ACTIONS(4232),
    [anon_sym_while] = ACTIONS(4232),
    [anon_sym_if] = ACTIONS(4232),
    [anon_sym_fun] = ACTIONS(4232),
    [anon_sym_try] = ACTIONS(4232),
    [anon_sym_match] = ACTIONS(4232),
    [anon_sym_match_BANG] = ACTIONS(4230),
    [anon_sym_function] = ACTIONS(4232),
    [anon_sym_LT_DASH] = ACTIONS(4232),
    [anon_sym_DOT_LBRACK] = ACTIONS(4230),
    [anon_sym_LT] = ACTIONS(4230),
    [anon_sym_use] = ACTIONS(4232),
    [anon_sym_use_BANG] = ACTIONS(4230),
    [anon_sym_do_BANG] = ACTIONS(4230),
    [anon_sym_begin] = ACTIONS(4232),
    [anon_sym_LPAREN2] = ACTIONS(4232),
    [anon_sym_DOT_DOT2] = ACTIONS(4230),
    [anon_sym_default] = ACTIONS(4232),
    [anon_sym_or] = ACTIONS(4232),
    [anon_sym_static] = ACTIONS(4232),
    [anon_sym_member] = ACTIONS(4232),
    [anon_sym_interface] = ACTIONS(4232),
    [anon_sym_abstract] = ACTIONS(4232),
    [anon_sym_val] = ACTIONS(4232),
    [anon_sym_override] = ACTIONS(4232),
    [aux_sym_char_token1] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4232),
    [anon_sym_DQUOTE] = ACTIONS(4232),
    [anon_sym_AT_DQUOTE] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [sym_bool] = ACTIONS(4232),
    [sym_unit] = ACTIONS(4230),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4232),
    [sym_op_identifier] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4232),
    [anon_sym_DASH] = ACTIONS(4232),
    [anon_sym_PLUS_DOT] = ACTIONS(4232),
    [anon_sym_DASH_DOT] = ACTIONS(4232),
    [anon_sym_PERCENT] = ACTIONS(4232),
    [anon_sym_AMP_AMP] = ACTIONS(4232),
    [anon_sym_TILDE] = ACTIONS(4230),
    [aux_sym_prefix_op_token1] = ACTIONS(4232),
    [aux_sym_infix_op_token1] = ACTIONS(4230),
    [aux_sym_infix_op_token2] = ACTIONS(4232),
    [anon_sym_PIPE_PIPE] = ACTIONS(4232),
    [anon_sym_BANG_EQ] = ACTIONS(4232),
    [anon_sym_COLON_EQ] = ACTIONS(4230),
    [anon_sym_DOLLAR] = ACTIONS(4232),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4232),
    [sym_int] = ACTIONS(4232),
    [sym_xint] = ACTIONS(4230),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4230),
    [sym__newline] = ACTIONS(4230),
    [sym__dedent] = ACTIONS(4230),
  },
  [2049] = {
    [sym_block_comment] = STATE(2049),
    [sym_compiler_directive_decl] = STATE(2049),
    [sym_fsi_directive_decl] = STATE(2049),
    [sym_preproc_line] = STATE(2049),
    [sym_identifier] = ACTIONS(3962),
    [anon_sym_EQ] = ACTIONS(3960),
    [anon_sym_LBRACK_LT] = ACTIONS(3960),
    [anon_sym_COLON] = ACTIONS(3962),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_do] = ACTIONS(3962),
    [anon_sym_let] = ACTIONS(3962),
    [anon_sym_let_BANG] = ACTIONS(3960),
    [aux_sym_access_modifier_token1] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_COMMA] = ACTIONS(3960),
    [anon_sym_null] = ACTIONS(3962),
    [anon_sym_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_COLON] = ACTIONS(3960),
    [anon_sym_AMP] = ACTIONS(3962),
    [anon_sym_LBRACK] = ACTIONS(3962),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_LT_AT] = ACTIONS(3962),
    [anon_sym_LT_AT_AT] = ACTIONS(3962),
    [anon_sym_DOT] = ACTIONS(3962),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3960),
    [anon_sym_new] = ACTIONS(3962),
    [anon_sym_with] = ACTIONS(3962),
    [anon_sym_return_BANG] = ACTIONS(3960),
    [anon_sym_yield] = ACTIONS(3962),
    [anon_sym_yield_BANG] = ACTIONS(3960),
    [anon_sym_lazy] = ACTIONS(3962),
    [anon_sym_assert] = ACTIONS(3962),
    [anon_sym_upcast] = ACTIONS(3962),
    [anon_sym_downcast] = ACTIONS(3962),
    [anon_sym_COLON_GT] = ACTIONS(3960),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3960),
    [anon_sym_for] = ACTIONS(3962),
    [anon_sym_while] = ACTIONS(3962),
    [anon_sym_if] = ACTIONS(3962),
    [anon_sym_fun] = ACTIONS(3962),
    [anon_sym_try] = ACTIONS(3962),
    [anon_sym_match] = ACTIONS(3962),
    [anon_sym_match_BANG] = ACTIONS(3960),
    [anon_sym_function] = ACTIONS(3962),
    [anon_sym_LT_DASH] = ACTIONS(3962),
    [anon_sym_DOT_LBRACK] = ACTIONS(3960),
    [anon_sym_LT] = ACTIONS(3960),
    [anon_sym_use] = ACTIONS(3962),
    [anon_sym_use_BANG] = ACTIONS(3960),
    [anon_sym_do_BANG] = ACTIONS(3960),
    [anon_sym_begin] = ACTIONS(3962),
    [anon_sym_LPAREN2] = ACTIONS(3962),
    [anon_sym_DOT_DOT2] = ACTIONS(3960),
    [anon_sym_default] = ACTIONS(3962),
    [anon_sym_or] = ACTIONS(3962),
    [anon_sym_static] = ACTIONS(3962),
    [anon_sym_member] = ACTIONS(3962),
    [anon_sym_interface] = ACTIONS(3962),
    [anon_sym_abstract] = ACTIONS(3962),
    [anon_sym_val] = ACTIONS(3962),
    [anon_sym_override] = ACTIONS(3962),
    [aux_sym_char_token1] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3962),
    [anon_sym_DQUOTE] = ACTIONS(3962),
    [anon_sym_AT_DQUOTE] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [sym_bool] = ACTIONS(3962),
    [sym_unit] = ACTIONS(3960),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3962),
    [sym_op_identifier] = ACTIONS(3962),
    [anon_sym_PLUS] = ACTIONS(3962),
    [anon_sym_DASH] = ACTIONS(3962),
    [anon_sym_PLUS_DOT] = ACTIONS(3962),
    [anon_sym_DASH_DOT] = ACTIONS(3962),
    [anon_sym_PERCENT] = ACTIONS(3962),
    [anon_sym_AMP_AMP] = ACTIONS(3962),
    [anon_sym_TILDE] = ACTIONS(3960),
    [aux_sym_prefix_op_token1] = ACTIONS(3962),
    [aux_sym_infix_op_token1] = ACTIONS(3960),
    [aux_sym_infix_op_token2] = ACTIONS(3962),
    [anon_sym_PIPE_PIPE] = ACTIONS(3962),
    [anon_sym_BANG_EQ] = ACTIONS(3962),
    [anon_sym_COLON_EQ] = ACTIONS(3960),
    [anon_sym_DOLLAR] = ACTIONS(3962),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3962),
    [sym_int] = ACTIONS(3962),
    [sym_xint] = ACTIONS(3960),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3960),
    [sym__newline] = ACTIONS(3960),
    [sym__dedent] = ACTIONS(3960),
  },
  [2050] = {
    [sym_block_comment] = STATE(2050),
    [sym_compiler_directive_decl] = STATE(2050),
    [sym_fsi_directive_decl] = STATE(2050),
    [sym_preproc_line] = STATE(2050),
    [sym_identifier] = ACTIONS(3980),
    [anon_sym_EQ] = ACTIONS(3978),
    [anon_sym_LBRACK_LT] = ACTIONS(3978),
    [anon_sym_COLON] = ACTIONS(3980),
    [anon_sym_return] = ACTIONS(3980),
    [anon_sym_do] = ACTIONS(3980),
    [anon_sym_let] = ACTIONS(3980),
    [anon_sym_let_BANG] = ACTIONS(3978),
    [aux_sym_access_modifier_token1] = ACTIONS(3978),
    [anon_sym_LPAREN] = ACTIONS(3980),
    [anon_sym_COMMA] = ACTIONS(3978),
    [anon_sym_null] = ACTIONS(3980),
    [anon_sym_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3978),
    [anon_sym_AMP] = ACTIONS(3980),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3978),
    [anon_sym_LBRACE] = ACTIONS(3980),
    [anon_sym_LT_AT] = ACTIONS(3980),
    [anon_sym_LT_AT_AT] = ACTIONS(3980),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3978),
    [anon_sym_new] = ACTIONS(3980),
    [anon_sym_with] = ACTIONS(3980),
    [anon_sym_return_BANG] = ACTIONS(3978),
    [anon_sym_yield] = ACTIONS(3980),
    [anon_sym_yield_BANG] = ACTIONS(3978),
    [anon_sym_lazy] = ACTIONS(3980),
    [anon_sym_assert] = ACTIONS(3980),
    [anon_sym_upcast] = ACTIONS(3980),
    [anon_sym_downcast] = ACTIONS(3980),
    [anon_sym_COLON_GT] = ACTIONS(3978),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3978),
    [anon_sym_for] = ACTIONS(3980),
    [anon_sym_while] = ACTIONS(3980),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_fun] = ACTIONS(3980),
    [anon_sym_try] = ACTIONS(3980),
    [anon_sym_match] = ACTIONS(3980),
    [anon_sym_match_BANG] = ACTIONS(3978),
    [anon_sym_function] = ACTIONS(3980),
    [anon_sym_LT_DASH] = ACTIONS(3980),
    [anon_sym_DOT_LBRACK] = ACTIONS(3978),
    [anon_sym_LT] = ACTIONS(3978),
    [anon_sym_use] = ACTIONS(3980),
    [anon_sym_use_BANG] = ACTIONS(3978),
    [anon_sym_do_BANG] = ACTIONS(3978),
    [anon_sym_begin] = ACTIONS(3980),
    [anon_sym_LPAREN2] = ACTIONS(3980),
    [anon_sym_DOT_DOT2] = ACTIONS(3978),
    [anon_sym_default] = ACTIONS(3980),
    [anon_sym_or] = ACTIONS(3980),
    [anon_sym_static] = ACTIONS(3980),
    [anon_sym_member] = ACTIONS(3980),
    [anon_sym_interface] = ACTIONS(3980),
    [anon_sym_abstract] = ACTIONS(3980),
    [anon_sym_val] = ACTIONS(3980),
    [anon_sym_override] = ACTIONS(3980),
    [aux_sym_char_token1] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3980),
    [anon_sym_DQUOTE] = ACTIONS(3980),
    [anon_sym_AT_DQUOTE] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [sym_bool] = ACTIONS(3980),
    [sym_unit] = ACTIONS(3978),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3980),
    [sym_op_identifier] = ACTIONS(3980),
    [anon_sym_PLUS] = ACTIONS(3980),
    [anon_sym_DASH] = ACTIONS(3980),
    [anon_sym_PLUS_DOT] = ACTIONS(3980),
    [anon_sym_DASH_DOT] = ACTIONS(3980),
    [anon_sym_PERCENT] = ACTIONS(3980),
    [anon_sym_AMP_AMP] = ACTIONS(3980),
    [anon_sym_TILDE] = ACTIONS(3978),
    [aux_sym_prefix_op_token1] = ACTIONS(3980),
    [aux_sym_infix_op_token1] = ACTIONS(3978),
    [aux_sym_infix_op_token2] = ACTIONS(3980),
    [anon_sym_PIPE_PIPE] = ACTIONS(3980),
    [anon_sym_BANG_EQ] = ACTIONS(3980),
    [anon_sym_COLON_EQ] = ACTIONS(3978),
    [anon_sym_DOLLAR] = ACTIONS(3980),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3980),
    [sym_int] = ACTIONS(3980),
    [sym_xint] = ACTIONS(3978),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3978),
    [sym__newline] = ACTIONS(3978),
    [sym__dedent] = ACTIONS(3978),
  },
  [2051] = {
    [sym_block_comment] = STATE(2051),
    [sym_compiler_directive_decl] = STATE(2051),
    [sym_fsi_directive_decl] = STATE(2051),
    [sym_preproc_line] = STATE(2051),
    [sym_identifier] = ACTIONS(4104),
    [anon_sym_EQ] = ACTIONS(4102),
    [anon_sym_LBRACK_LT] = ACTIONS(4102),
    [anon_sym_COLON] = ACTIONS(4104),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_do] = ACTIONS(4104),
    [anon_sym_and] = ACTIONS(4104),
    [anon_sym_let] = ACTIONS(4104),
    [anon_sym_let_BANG] = ACTIONS(4102),
    [aux_sym_access_modifier_token1] = ACTIONS(4102),
    [anon_sym_LPAREN] = ACTIONS(4104),
    [anon_sym_COMMA] = ACTIONS(4102),
    [anon_sym_null] = ACTIONS(4104),
    [anon_sym_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_COLON] = ACTIONS(4102),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4104),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4102),
    [anon_sym_LBRACE] = ACTIONS(4104),
    [anon_sym_LT_AT] = ACTIONS(4104),
    [anon_sym_LT_AT_AT] = ACTIONS(4104),
    [anon_sym_DOT] = ACTIONS(4104),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4102),
    [anon_sym_new] = ACTIONS(4104),
    [anon_sym_with] = ACTIONS(4104),
    [anon_sym_return_BANG] = ACTIONS(4102),
    [anon_sym_yield] = ACTIONS(4104),
    [anon_sym_yield_BANG] = ACTIONS(4102),
    [anon_sym_lazy] = ACTIONS(4104),
    [anon_sym_assert] = ACTIONS(4104),
    [anon_sym_upcast] = ACTIONS(4104),
    [anon_sym_downcast] = ACTIONS(4104),
    [anon_sym_COLON_GT] = ACTIONS(4102),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4102),
    [anon_sym_for] = ACTIONS(4104),
    [anon_sym_while] = ACTIONS(4104),
    [anon_sym_if] = ACTIONS(4104),
    [anon_sym_fun] = ACTIONS(4104),
    [anon_sym_try] = ACTIONS(4104),
    [anon_sym_match] = ACTIONS(4104),
    [anon_sym_match_BANG] = ACTIONS(4102),
    [anon_sym_function] = ACTIONS(4104),
    [anon_sym_LT_DASH] = ACTIONS(4104),
    [anon_sym_DOT_LBRACK] = ACTIONS(4102),
    [anon_sym_LT] = ACTIONS(4102),
    [anon_sym_use] = ACTIONS(4104),
    [anon_sym_use_BANG] = ACTIONS(4102),
    [anon_sym_do_BANG] = ACTIONS(4102),
    [anon_sym_begin] = ACTIONS(4104),
    [anon_sym_LPAREN2] = ACTIONS(4104),
    [anon_sym_default] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [anon_sym_static] = ACTIONS(4104),
    [anon_sym_member] = ACTIONS(4104),
    [anon_sym_interface] = ACTIONS(4104),
    [anon_sym_abstract] = ACTIONS(4104),
    [anon_sym_val] = ACTIONS(4104),
    [anon_sym_override] = ACTIONS(4104),
    [aux_sym_char_token1] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4104),
    [anon_sym_DQUOTE] = ACTIONS(4104),
    [anon_sym_AT_DQUOTE] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [sym_bool] = ACTIONS(4104),
    [sym_unit] = ACTIONS(4102),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4104),
    [sym_op_identifier] = ACTIONS(4104),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_PLUS_DOT] = ACTIONS(4104),
    [anon_sym_DASH_DOT] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_AMP_AMP] = ACTIONS(4104),
    [anon_sym_TILDE] = ACTIONS(4102),
    [aux_sym_prefix_op_token1] = ACTIONS(4104),
    [aux_sym_infix_op_token1] = ACTIONS(4102),
    [aux_sym_infix_op_token2] = ACTIONS(4104),
    [anon_sym_PIPE_PIPE] = ACTIONS(4104),
    [anon_sym_BANG_EQ] = ACTIONS(4104),
    [anon_sym_COLON_EQ] = ACTIONS(4102),
    [anon_sym_DOLLAR] = ACTIONS(4104),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4104),
    [sym_int] = ACTIONS(4104),
    [sym_xint] = ACTIONS(4102),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4102),
    [anon_sym_POUNDendif] = ACTIONS(4102),
    [sym__newline] = ACTIONS(4102),
  },
  [2052] = {
    [sym_block_comment] = STATE(2052),
    [sym_compiler_directive_decl] = STATE(2052),
    [sym_fsi_directive_decl] = STATE(2052),
    [sym_preproc_line] = STATE(2052),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_and] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [aux_sym_access_modifier_token1] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_member] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_val] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [anon_sym_POUNDendif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [2053] = {
    [sym_block_comment] = STATE(2053),
    [sym_compiler_directive_decl] = STATE(2053),
    [sym_fsi_directive_decl] = STATE(2053),
    [sym_preproc_line] = STATE(2053),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [aux_sym_access_modifier_token1] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_DOT_DOT2] = ACTIONS(3485),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_member] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_val] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
    [sym__dedent] = ACTIONS(3485),
  },
  [2054] = {
    [sym_block_comment] = STATE(2054),
    [sym_compiler_directive_decl] = STATE(2054),
    [sym_fsi_directive_decl] = STATE(2054),
    [sym_preproc_line] = STATE(2054),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_LBRACK_LT] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [aux_sym_access_modifier_token1] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_with] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_default] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [anon_sym_static] = ACTIONS(4228),
    [anon_sym_member] = ACTIONS(4228),
    [anon_sym_interface] = ACTIONS(4228),
    [anon_sym_abstract] = ACTIONS(4228),
    [anon_sym_val] = ACTIONS(4228),
    [anon_sym_override] = ACTIONS(4228),
    [anon_sym_inherit] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [anon_sym_POUNDendif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
  },
  [2055] = {
    [sym_block_comment] = STATE(2055),
    [sym_compiler_directive_decl] = STATE(2055),
    [sym_fsi_directive_decl] = STATE(2055),
    [sym_preproc_line] = STATE(2055),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_LBRACK_LT] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [aux_sym_access_modifier_token1] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_with] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_default] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [anon_sym_static] = ACTIONS(4228),
    [anon_sym_member] = ACTIONS(4228),
    [anon_sym_interface] = ACTIONS(4228),
    [anon_sym_abstract] = ACTIONS(4228),
    [anon_sym_val] = ACTIONS(4228),
    [anon_sym_override] = ACTIONS(4228),
    [anon_sym_inherit] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [anon_sym_POUNDendif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
  },
  [2056] = {
    [sym_block_comment] = STATE(2056),
    [sym_compiler_directive_decl] = STATE(2056),
    [sym_fsi_directive_decl] = STATE(2056),
    [sym_preproc_line] = STATE(2056),
    [sym_identifier] = ACTIONS(3927),
    [anon_sym_EQ] = ACTIONS(3925),
    [anon_sym_LBRACK_LT] = ACTIONS(3925),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_return] = ACTIONS(3927),
    [anon_sym_do] = ACTIONS(3927),
    [anon_sym_and] = ACTIONS(3927),
    [anon_sym_let] = ACTIONS(3927),
    [anon_sym_let_BANG] = ACTIONS(3925),
    [aux_sym_access_modifier_token1] = ACTIONS(3925),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_COMMA] = ACTIONS(3925),
    [anon_sym_null] = ACTIONS(3927),
    [anon_sym_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_COLON] = ACTIONS(3925),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3925),
    [anon_sym_LBRACE] = ACTIONS(3927),
    [anon_sym_LT_AT] = ACTIONS(3927),
    [anon_sym_LT_AT_AT] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3925),
    [anon_sym_new] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3927),
    [anon_sym_return_BANG] = ACTIONS(3925),
    [anon_sym_yield] = ACTIONS(3927),
    [anon_sym_yield_BANG] = ACTIONS(3925),
    [anon_sym_lazy] = ACTIONS(3927),
    [anon_sym_assert] = ACTIONS(3927),
    [anon_sym_upcast] = ACTIONS(3927),
    [anon_sym_downcast] = ACTIONS(3927),
    [anon_sym_COLON_GT] = ACTIONS(3925),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3925),
    [anon_sym_for] = ACTIONS(3927),
    [anon_sym_while] = ACTIONS(3927),
    [anon_sym_if] = ACTIONS(3927),
    [anon_sym_fun] = ACTIONS(3927),
    [anon_sym_try] = ACTIONS(3927),
    [anon_sym_match] = ACTIONS(3927),
    [anon_sym_match_BANG] = ACTIONS(3925),
    [anon_sym_function] = ACTIONS(3927),
    [anon_sym_LT_DASH] = ACTIONS(3927),
    [anon_sym_DOT_LBRACK] = ACTIONS(3925),
    [anon_sym_LT] = ACTIONS(3925),
    [anon_sym_use] = ACTIONS(3927),
    [anon_sym_use_BANG] = ACTIONS(3925),
    [anon_sym_do_BANG] = ACTIONS(3925),
    [anon_sym_begin] = ACTIONS(3927),
    [anon_sym_LPAREN2] = ACTIONS(3927),
    [anon_sym_default] = ACTIONS(3927),
    [anon_sym_or] = ACTIONS(3927),
    [anon_sym_static] = ACTIONS(3927),
    [anon_sym_member] = ACTIONS(3927),
    [anon_sym_interface] = ACTIONS(3927),
    [anon_sym_abstract] = ACTIONS(3927),
    [anon_sym_val] = ACTIONS(3927),
    [anon_sym_override] = ACTIONS(3927),
    [aux_sym_char_token1] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_AT_DQUOTE] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [sym_bool] = ACTIONS(3927),
    [sym_unit] = ACTIONS(3925),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3927),
    [sym_op_identifier] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3927),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_PLUS_DOT] = ACTIONS(3927),
    [anon_sym_DASH_DOT] = ACTIONS(3927),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_TILDE] = ACTIONS(3925),
    [aux_sym_prefix_op_token1] = ACTIONS(3927),
    [aux_sym_infix_op_token1] = ACTIONS(3925),
    [aux_sym_infix_op_token2] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_COLON_EQ] = ACTIONS(3925),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3927),
    [sym_int] = ACTIONS(3927),
    [sym_xint] = ACTIONS(3925),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3925),
    [anon_sym_POUNDendif] = ACTIONS(3925),
    [sym__newline] = ACTIONS(3925),
  },
  [2057] = {
    [sym_block_comment] = STATE(2057),
    [sym_compiler_directive_decl] = STATE(2057),
    [sym_fsi_directive_decl] = STATE(2057),
    [sym_preproc_line] = STATE(2057),
    [sym_identifier] = ACTIONS(3946),
    [anon_sym_EQ] = ACTIONS(3944),
    [anon_sym_LBRACK_LT] = ACTIONS(3944),
    [anon_sym_COLON] = ACTIONS(3946),
    [anon_sym_return] = ACTIONS(3946),
    [anon_sym_do] = ACTIONS(3946),
    [anon_sym_and] = ACTIONS(3946),
    [anon_sym_let] = ACTIONS(3946),
    [anon_sym_let_BANG] = ACTIONS(3944),
    [aux_sym_access_modifier_token1] = ACTIONS(3944),
    [anon_sym_LPAREN] = ACTIONS(3946),
    [anon_sym_COMMA] = ACTIONS(3944),
    [anon_sym_null] = ACTIONS(3946),
    [anon_sym_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LBRACK] = ACTIONS(3946),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3944),
    [anon_sym_LBRACE] = ACTIONS(3946),
    [anon_sym_LT_AT] = ACTIONS(3946),
    [anon_sym_LT_AT_AT] = ACTIONS(3946),
    [anon_sym_DOT] = ACTIONS(3946),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3944),
    [anon_sym_new] = ACTIONS(3946),
    [anon_sym_with] = ACTIONS(3946),
    [anon_sym_return_BANG] = ACTIONS(3944),
    [anon_sym_yield] = ACTIONS(3946),
    [anon_sym_yield_BANG] = ACTIONS(3944),
    [anon_sym_lazy] = ACTIONS(3946),
    [anon_sym_assert] = ACTIONS(3946),
    [anon_sym_upcast] = ACTIONS(3946),
    [anon_sym_downcast] = ACTIONS(3946),
    [anon_sym_COLON_GT] = ACTIONS(3944),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3944),
    [anon_sym_for] = ACTIONS(3946),
    [anon_sym_while] = ACTIONS(3946),
    [anon_sym_if] = ACTIONS(3946),
    [anon_sym_fun] = ACTIONS(3946),
    [anon_sym_try] = ACTIONS(3946),
    [anon_sym_match] = ACTIONS(3946),
    [anon_sym_match_BANG] = ACTIONS(3944),
    [anon_sym_function] = ACTIONS(3946),
    [anon_sym_LT_DASH] = ACTIONS(3946),
    [anon_sym_DOT_LBRACK] = ACTIONS(3944),
    [anon_sym_LT] = ACTIONS(3944),
    [anon_sym_use] = ACTIONS(3946),
    [anon_sym_use_BANG] = ACTIONS(3944),
    [anon_sym_do_BANG] = ACTIONS(3944),
    [anon_sym_begin] = ACTIONS(3946),
    [anon_sym_LPAREN2] = ACTIONS(3946),
    [anon_sym_default] = ACTIONS(3946),
    [anon_sym_or] = ACTIONS(3946),
    [anon_sym_static] = ACTIONS(3946),
    [anon_sym_member] = ACTIONS(3946),
    [anon_sym_interface] = ACTIONS(3946),
    [anon_sym_abstract] = ACTIONS(3946),
    [anon_sym_val] = ACTIONS(3946),
    [anon_sym_override] = ACTIONS(3946),
    [aux_sym_char_token1] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_AT_DQUOTE] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [sym_bool] = ACTIONS(3946),
    [sym_unit] = ACTIONS(3944),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3946),
    [sym_op_identifier] = ACTIONS(3946),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PLUS_DOT] = ACTIONS(3946),
    [anon_sym_DASH_DOT] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3946),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_TILDE] = ACTIONS(3944),
    [aux_sym_prefix_op_token1] = ACTIONS(3946),
    [aux_sym_infix_op_token1] = ACTIONS(3944),
    [aux_sym_infix_op_token2] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [anon_sym_BANG_EQ] = ACTIONS(3946),
    [anon_sym_COLON_EQ] = ACTIONS(3944),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3946),
    [sym_int] = ACTIONS(3946),
    [sym_xint] = ACTIONS(3944),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3944),
    [anon_sym_POUNDendif] = ACTIONS(3944),
    [sym__newline] = ACTIONS(3944),
  },
  [2058] = {
    [sym_block_comment] = STATE(2058),
    [sym_compiler_directive_decl] = STATE(2058),
    [sym_fsi_directive_decl] = STATE(2058),
    [sym_preproc_line] = STATE(2058),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_LBRACK_LT] = ACTIONS(3865),
    [anon_sym_COLON] = ACTIONS(3867),
    [anon_sym_return] = ACTIONS(3867),
    [anon_sym_do] = ACTIONS(3867),
    [anon_sym_and] = ACTIONS(3867),
    [anon_sym_let] = ACTIONS(3867),
    [anon_sym_let_BANG] = ACTIONS(3865),
    [aux_sym_access_modifier_token1] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(3867),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_null] = ACTIONS(3867),
    [anon_sym_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_COLON] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3867),
    [anon_sym_LBRACK] = ACTIONS(3867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3867),
    [anon_sym_LT_AT] = ACTIONS(3867),
    [anon_sym_LT_AT_AT] = ACTIONS(3867),
    [anon_sym_DOT] = ACTIONS(3867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3867),
    [anon_sym_with] = ACTIONS(3867),
    [anon_sym_return_BANG] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3867),
    [anon_sym_yield_BANG] = ACTIONS(3865),
    [anon_sym_lazy] = ACTIONS(3867),
    [anon_sym_assert] = ACTIONS(3867),
    [anon_sym_upcast] = ACTIONS(3867),
    [anon_sym_downcast] = ACTIONS(3867),
    [anon_sym_COLON_GT] = ACTIONS(3865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3867),
    [anon_sym_while] = ACTIONS(3867),
    [anon_sym_if] = ACTIONS(3867),
    [anon_sym_fun] = ACTIONS(3867),
    [anon_sym_try] = ACTIONS(3867),
    [anon_sym_match] = ACTIONS(3867),
    [anon_sym_match_BANG] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(3867),
    [anon_sym_DOT_LBRACK] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_use] = ACTIONS(3867),
    [anon_sym_use_BANG] = ACTIONS(3865),
    [anon_sym_do_BANG] = ACTIONS(3865),
    [anon_sym_begin] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(3867),
    [anon_sym_default] = ACTIONS(3867),
    [anon_sym_or] = ACTIONS(3867),
    [anon_sym_static] = ACTIONS(3867),
    [anon_sym_member] = ACTIONS(3867),
    [anon_sym_interface] = ACTIONS(3867),
    [anon_sym_abstract] = ACTIONS(3867),
    [anon_sym_val] = ACTIONS(3867),
    [anon_sym_override] = ACTIONS(3867),
    [aux_sym_char_token1] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3867),
    [anon_sym_DQUOTE] = ACTIONS(3867),
    [anon_sym_AT_DQUOTE] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [sym_bool] = ACTIONS(3867),
    [sym_unit] = ACTIONS(3865),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3867),
    [sym_op_identifier] = ACTIONS(3867),
    [anon_sym_PLUS] = ACTIONS(3867),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_PLUS_DOT] = ACTIONS(3867),
    [anon_sym_DASH_DOT] = ACTIONS(3867),
    [anon_sym_PERCENT] = ACTIONS(3867),
    [anon_sym_AMP_AMP] = ACTIONS(3867),
    [anon_sym_TILDE] = ACTIONS(3865),
    [aux_sym_prefix_op_token1] = ACTIONS(3867),
    [aux_sym_infix_op_token1] = ACTIONS(3865),
    [aux_sym_infix_op_token2] = ACTIONS(3867),
    [anon_sym_PIPE_PIPE] = ACTIONS(3867),
    [anon_sym_BANG_EQ] = ACTIONS(3867),
    [anon_sym_COLON_EQ] = ACTIONS(3865),
    [anon_sym_DOLLAR] = ACTIONS(3867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3867),
    [sym_int] = ACTIONS(3867),
    [sym_xint] = ACTIONS(3865),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3865),
    [anon_sym_POUNDendif] = ACTIONS(3865),
    [sym__newline] = ACTIONS(3865),
  },
  [2059] = {
    [sym_block_comment] = STATE(2059),
    [sym_compiler_directive_decl] = STATE(2059),
    [sym_fsi_directive_decl] = STATE(2059),
    [sym_preproc_line] = STATE(2059),
    [sym_identifier] = ACTIONS(3972),
    [anon_sym_EQ] = ACTIONS(3970),
    [anon_sym_LBRACK_LT] = ACTIONS(3970),
    [anon_sym_COLON] = ACTIONS(3972),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_do] = ACTIONS(3972),
    [anon_sym_and] = ACTIONS(3972),
    [anon_sym_let] = ACTIONS(3972),
    [anon_sym_let_BANG] = ACTIONS(3970),
    [aux_sym_access_modifier_token1] = ACTIONS(3970),
    [anon_sym_LPAREN] = ACTIONS(3972),
    [anon_sym_COMMA] = ACTIONS(3970),
    [anon_sym_null] = ACTIONS(3972),
    [anon_sym_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_COLON] = ACTIONS(3970),
    [anon_sym_AMP] = ACTIONS(3972),
    [anon_sym_LBRACK] = ACTIONS(3972),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3970),
    [anon_sym_LBRACE] = ACTIONS(3972),
    [anon_sym_LT_AT] = ACTIONS(3972),
    [anon_sym_LT_AT_AT] = ACTIONS(3972),
    [anon_sym_DOT] = ACTIONS(3972),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3970),
    [anon_sym_new] = ACTIONS(3972),
    [anon_sym_with] = ACTIONS(3972),
    [anon_sym_return_BANG] = ACTIONS(3970),
    [anon_sym_yield] = ACTIONS(3972),
    [anon_sym_yield_BANG] = ACTIONS(3970),
    [anon_sym_lazy] = ACTIONS(3972),
    [anon_sym_assert] = ACTIONS(3972),
    [anon_sym_upcast] = ACTIONS(3972),
    [anon_sym_downcast] = ACTIONS(3972),
    [anon_sym_COLON_GT] = ACTIONS(3970),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3970),
    [anon_sym_for] = ACTIONS(3972),
    [anon_sym_while] = ACTIONS(3972),
    [anon_sym_if] = ACTIONS(3972),
    [anon_sym_fun] = ACTIONS(3972),
    [anon_sym_try] = ACTIONS(3972),
    [anon_sym_match] = ACTIONS(3972),
    [anon_sym_match_BANG] = ACTIONS(3970),
    [anon_sym_function] = ACTIONS(3972),
    [anon_sym_LT_DASH] = ACTIONS(3972),
    [anon_sym_DOT_LBRACK] = ACTIONS(3970),
    [anon_sym_LT] = ACTIONS(3970),
    [anon_sym_use] = ACTIONS(3972),
    [anon_sym_use_BANG] = ACTIONS(3970),
    [anon_sym_do_BANG] = ACTIONS(3970),
    [anon_sym_begin] = ACTIONS(3972),
    [anon_sym_LPAREN2] = ACTIONS(3972),
    [anon_sym_default] = ACTIONS(3972),
    [anon_sym_or] = ACTIONS(3972),
    [anon_sym_static] = ACTIONS(3972),
    [anon_sym_member] = ACTIONS(3972),
    [anon_sym_interface] = ACTIONS(3972),
    [anon_sym_abstract] = ACTIONS(3972),
    [anon_sym_val] = ACTIONS(3972),
    [anon_sym_override] = ACTIONS(3972),
    [aux_sym_char_token1] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3972),
    [anon_sym_DQUOTE] = ACTIONS(3972),
    [anon_sym_AT_DQUOTE] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [sym_bool] = ACTIONS(3972),
    [sym_unit] = ACTIONS(3970),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3972),
    [sym_op_identifier] = ACTIONS(3972),
    [anon_sym_PLUS] = ACTIONS(3972),
    [anon_sym_DASH] = ACTIONS(3972),
    [anon_sym_PLUS_DOT] = ACTIONS(3972),
    [anon_sym_DASH_DOT] = ACTIONS(3972),
    [anon_sym_PERCENT] = ACTIONS(3972),
    [anon_sym_AMP_AMP] = ACTIONS(3972),
    [anon_sym_TILDE] = ACTIONS(3970),
    [aux_sym_prefix_op_token1] = ACTIONS(3972),
    [aux_sym_infix_op_token1] = ACTIONS(3970),
    [aux_sym_infix_op_token2] = ACTIONS(3972),
    [anon_sym_PIPE_PIPE] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3972),
    [anon_sym_COLON_EQ] = ACTIONS(3970),
    [anon_sym_DOLLAR] = ACTIONS(3972),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3972),
    [sym_int] = ACTIONS(3972),
    [sym_xint] = ACTIONS(3970),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3970),
    [anon_sym_POUNDendif] = ACTIONS(3970),
    [sym__newline] = ACTIONS(3970),
  },
  [2060] = {
    [sym_block_comment] = STATE(2060),
    [sym_compiler_directive_decl] = STATE(2060),
    [sym_fsi_directive_decl] = STATE(2060),
    [sym_preproc_line] = STATE(2060),
    [sym_identifier] = ACTIONS(4007),
    [anon_sym_EQ] = ACTIONS(4005),
    [anon_sym_LBRACK_LT] = ACTIONS(4005),
    [anon_sym_COLON] = ACTIONS(4007),
    [anon_sym_return] = ACTIONS(4007),
    [anon_sym_do] = ACTIONS(4007),
    [anon_sym_let] = ACTIONS(4007),
    [anon_sym_let_BANG] = ACTIONS(4005),
    [aux_sym_access_modifier_token1] = ACTIONS(4005),
    [anon_sym_LPAREN] = ACTIONS(4007),
    [anon_sym_COMMA] = ACTIONS(4005),
    [anon_sym_null] = ACTIONS(4007),
    [anon_sym_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_COLON] = ACTIONS(4005),
    [anon_sym_AMP] = ACTIONS(4007),
    [anon_sym_LBRACK] = ACTIONS(4007),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4005),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_LT_AT] = ACTIONS(4007),
    [anon_sym_LT_AT_AT] = ACTIONS(4007),
    [anon_sym_DOT] = ACTIONS(4007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4005),
    [anon_sym_new] = ACTIONS(4007),
    [anon_sym_with] = ACTIONS(4007),
    [anon_sym_return_BANG] = ACTIONS(4005),
    [anon_sym_yield] = ACTIONS(4007),
    [anon_sym_yield_BANG] = ACTIONS(4005),
    [anon_sym_lazy] = ACTIONS(4007),
    [anon_sym_assert] = ACTIONS(4007),
    [anon_sym_upcast] = ACTIONS(4007),
    [anon_sym_downcast] = ACTIONS(4007),
    [anon_sym_COLON_GT] = ACTIONS(4005),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4005),
    [anon_sym_for] = ACTIONS(4007),
    [anon_sym_while] = ACTIONS(4007),
    [anon_sym_if] = ACTIONS(4007),
    [anon_sym_fun] = ACTIONS(4007),
    [anon_sym_try] = ACTIONS(4007),
    [anon_sym_match] = ACTIONS(4007),
    [anon_sym_match_BANG] = ACTIONS(4005),
    [anon_sym_function] = ACTIONS(4007),
    [anon_sym_LT_DASH] = ACTIONS(4007),
    [anon_sym_DOT_LBRACK] = ACTIONS(4005),
    [anon_sym_LT] = ACTIONS(4005),
    [anon_sym_use] = ACTIONS(4007),
    [anon_sym_use_BANG] = ACTIONS(4005),
    [anon_sym_do_BANG] = ACTIONS(4005),
    [anon_sym_begin] = ACTIONS(4007),
    [anon_sym_LPAREN2] = ACTIONS(4007),
    [anon_sym_default] = ACTIONS(4007),
    [anon_sym_or] = ACTIONS(4007),
    [anon_sym_static] = ACTIONS(4007),
    [anon_sym_member] = ACTIONS(4007),
    [anon_sym_interface] = ACTIONS(4007),
    [anon_sym_abstract] = ACTIONS(4007),
    [anon_sym_val] = ACTIONS(4007),
    [anon_sym_override] = ACTIONS(4007),
    [anon_sym_inherit] = ACTIONS(4007),
    [aux_sym_char_token1] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4007),
    [anon_sym_DQUOTE] = ACTIONS(4007),
    [anon_sym_AT_DQUOTE] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [sym_bool] = ACTIONS(4007),
    [sym_unit] = ACTIONS(4005),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4007),
    [sym_op_identifier] = ACTIONS(4007),
    [anon_sym_PLUS] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4007),
    [anon_sym_PLUS_DOT] = ACTIONS(4007),
    [anon_sym_DASH_DOT] = ACTIONS(4007),
    [anon_sym_PERCENT] = ACTIONS(4007),
    [anon_sym_AMP_AMP] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4005),
    [aux_sym_prefix_op_token1] = ACTIONS(4007),
    [aux_sym_infix_op_token1] = ACTIONS(4005),
    [aux_sym_infix_op_token2] = ACTIONS(4007),
    [anon_sym_PIPE_PIPE] = ACTIONS(4007),
    [anon_sym_BANG_EQ] = ACTIONS(4007),
    [anon_sym_COLON_EQ] = ACTIONS(4005),
    [anon_sym_DOLLAR] = ACTIONS(4007),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4007),
    [sym_int] = ACTIONS(4007),
    [sym_xint] = ACTIONS(4005),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4005),
    [anon_sym_POUNDendif] = ACTIONS(4005),
    [sym__newline] = ACTIONS(4005),
  },
  [2061] = {
    [sym_block_comment] = STATE(2061),
    [sym_compiler_directive_decl] = STATE(2061),
    [sym_fsi_directive_decl] = STATE(2061),
    [sym_preproc_line] = STATE(2061),
    [sym_identifier] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(4076),
    [anon_sym_LBRACK_LT] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4078),
    [anon_sym_return] = ACTIONS(4078),
    [anon_sym_do] = ACTIONS(4078),
    [anon_sym_and] = ACTIONS(4078),
    [anon_sym_let] = ACTIONS(4078),
    [anon_sym_let_BANG] = ACTIONS(4076),
    [aux_sym_access_modifier_token1] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_null] = ACTIONS(4078),
    [anon_sym_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(4076),
    [anon_sym_AMP] = ACTIONS(4078),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4078),
    [anon_sym_LT_AT] = ACTIONS(4078),
    [anon_sym_LT_AT_AT] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(4078),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4076),
    [anon_sym_new] = ACTIONS(4078),
    [anon_sym_with] = ACTIONS(4078),
    [anon_sym_return_BANG] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(4078),
    [anon_sym_yield_BANG] = ACTIONS(4076),
    [anon_sym_lazy] = ACTIONS(4078),
    [anon_sym_assert] = ACTIONS(4078),
    [anon_sym_upcast] = ACTIONS(4078),
    [anon_sym_downcast] = ACTIONS(4078),
    [anon_sym_COLON_GT] = ACTIONS(4076),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4076),
    [anon_sym_for] = ACTIONS(4078),
    [anon_sym_while] = ACTIONS(4078),
    [anon_sym_if] = ACTIONS(4078),
    [anon_sym_fun] = ACTIONS(4078),
    [anon_sym_try] = ACTIONS(4078),
    [anon_sym_match] = ACTIONS(4078),
    [anon_sym_match_BANG] = ACTIONS(4076),
    [anon_sym_function] = ACTIONS(4078),
    [anon_sym_LT_DASH] = ACTIONS(4078),
    [anon_sym_DOT_LBRACK] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4076),
    [anon_sym_use] = ACTIONS(4078),
    [anon_sym_use_BANG] = ACTIONS(4076),
    [anon_sym_do_BANG] = ACTIONS(4076),
    [anon_sym_begin] = ACTIONS(4078),
    [anon_sym_LPAREN2] = ACTIONS(4078),
    [anon_sym_default] = ACTIONS(4078),
    [anon_sym_or] = ACTIONS(4078),
    [anon_sym_static] = ACTIONS(4078),
    [anon_sym_member] = ACTIONS(4078),
    [anon_sym_interface] = ACTIONS(4078),
    [anon_sym_abstract] = ACTIONS(4078),
    [anon_sym_val] = ACTIONS(4078),
    [anon_sym_override] = ACTIONS(4078),
    [aux_sym_char_token1] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4078),
    [anon_sym_DQUOTE] = ACTIONS(4078),
    [anon_sym_AT_DQUOTE] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [sym_bool] = ACTIONS(4078),
    [sym_unit] = ACTIONS(4076),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4078),
    [sym_op_identifier] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(4078),
    [anon_sym_PLUS_DOT] = ACTIONS(4078),
    [anon_sym_DASH_DOT] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [anon_sym_AMP_AMP] = ACTIONS(4078),
    [anon_sym_TILDE] = ACTIONS(4076),
    [aux_sym_prefix_op_token1] = ACTIONS(4078),
    [aux_sym_infix_op_token1] = ACTIONS(4076),
    [aux_sym_infix_op_token2] = ACTIONS(4078),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_BANG_EQ] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4076),
    [anon_sym_DOLLAR] = ACTIONS(4078),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4078),
    [sym_int] = ACTIONS(4078),
    [sym_xint] = ACTIONS(4076),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4076),
    [sym__newline] = ACTIONS(4076),
    [sym__dedent] = ACTIONS(4076),
  },
  [2062] = {
    [sym_block_comment] = STATE(2062),
    [sym_compiler_directive_decl] = STATE(2062),
    [sym_fsi_directive_decl] = STATE(2062),
    [sym_preproc_line] = STATE(2062),
    [sym_identifier] = ACTIONS(3935),
    [anon_sym_EQ] = ACTIONS(3933),
    [anon_sym_LBRACK_LT] = ACTIONS(3933),
    [anon_sym_COLON] = ACTIONS(3935),
    [anon_sym_return] = ACTIONS(3935),
    [anon_sym_do] = ACTIONS(3935),
    [anon_sym_let] = ACTIONS(3935),
    [anon_sym_let_BANG] = ACTIONS(3933),
    [aux_sym_access_modifier_token1] = ACTIONS(3933),
    [anon_sym_LPAREN] = ACTIONS(3935),
    [anon_sym_COMMA] = ACTIONS(3933),
    [anon_sym_null] = ACTIONS(3935),
    [anon_sym_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3935),
    [anon_sym_LBRACK] = ACTIONS(3935),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3933),
    [anon_sym_LBRACE] = ACTIONS(3935),
    [anon_sym_LT_AT] = ACTIONS(3935),
    [anon_sym_LT_AT_AT] = ACTIONS(3935),
    [anon_sym_DOT] = ACTIONS(3935),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3933),
    [anon_sym_new] = ACTIONS(3935),
    [anon_sym_with] = ACTIONS(3935),
    [anon_sym_return_BANG] = ACTIONS(3933),
    [anon_sym_yield] = ACTIONS(3935),
    [anon_sym_yield_BANG] = ACTIONS(3933),
    [anon_sym_lazy] = ACTIONS(3935),
    [anon_sym_assert] = ACTIONS(3935),
    [anon_sym_upcast] = ACTIONS(3935),
    [anon_sym_downcast] = ACTIONS(3935),
    [anon_sym_COLON_GT] = ACTIONS(3933),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3933),
    [anon_sym_for] = ACTIONS(3935),
    [anon_sym_while] = ACTIONS(3935),
    [anon_sym_if] = ACTIONS(3935),
    [anon_sym_fun] = ACTIONS(3935),
    [anon_sym_try] = ACTIONS(3935),
    [anon_sym_match] = ACTIONS(3935),
    [anon_sym_match_BANG] = ACTIONS(3933),
    [anon_sym_function] = ACTIONS(3935),
    [anon_sym_LT_DASH] = ACTIONS(3935),
    [anon_sym_DOT_LBRACK] = ACTIONS(3933),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_use] = ACTIONS(3935),
    [anon_sym_use_BANG] = ACTIONS(3933),
    [anon_sym_do_BANG] = ACTIONS(3933),
    [anon_sym_begin] = ACTIONS(3935),
    [anon_sym_LPAREN2] = ACTIONS(3935),
    [anon_sym_default] = ACTIONS(3935),
    [anon_sym_or] = ACTIONS(3935),
    [anon_sym_static] = ACTIONS(3935),
    [anon_sym_member] = ACTIONS(3935),
    [anon_sym_interface] = ACTIONS(3935),
    [anon_sym_abstract] = ACTIONS(3935),
    [anon_sym_val] = ACTIONS(3935),
    [anon_sym_override] = ACTIONS(3935),
    [anon_sym_inherit] = ACTIONS(3935),
    [aux_sym_char_token1] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3935),
    [anon_sym_DQUOTE] = ACTIONS(3935),
    [anon_sym_AT_DQUOTE] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [sym_bool] = ACTIONS(3935),
    [sym_unit] = ACTIONS(3933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3935),
    [sym_op_identifier] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(3935),
    [anon_sym_DASH] = ACTIONS(3935),
    [anon_sym_PLUS_DOT] = ACTIONS(3935),
    [anon_sym_DASH_DOT] = ACTIONS(3935),
    [anon_sym_PERCENT] = ACTIONS(3935),
    [anon_sym_AMP_AMP] = ACTIONS(3935),
    [anon_sym_TILDE] = ACTIONS(3933),
    [aux_sym_prefix_op_token1] = ACTIONS(3935),
    [aux_sym_infix_op_token1] = ACTIONS(3933),
    [aux_sym_infix_op_token2] = ACTIONS(3935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3935),
    [anon_sym_BANG_EQ] = ACTIONS(3935),
    [anon_sym_COLON_EQ] = ACTIONS(3933),
    [anon_sym_DOLLAR] = ACTIONS(3935),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3935),
    [sym_int] = ACTIONS(3935),
    [sym_xint] = ACTIONS(3933),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3933),
    [anon_sym_POUNDendif] = ACTIONS(3933),
    [sym__newline] = ACTIONS(3933),
  },
  [2063] = {
    [sym_block_comment] = STATE(2063),
    [sym_compiler_directive_decl] = STATE(2063),
    [sym_fsi_directive_decl] = STATE(2063),
    [sym_preproc_line] = STATE(2063),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3843),
    [anon_sym_LBRACK_LT] = ACTIONS(3843),
    [anon_sym_COLON] = ACTIONS(3845),
    [anon_sym_return] = ACTIONS(3845),
    [anon_sym_do] = ACTIONS(3845),
    [anon_sym_and] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_let_BANG] = ACTIONS(3843),
    [aux_sym_access_modifier_token1] = ACTIONS(3843),
    [anon_sym_LPAREN] = ACTIONS(3845),
    [anon_sym_COMMA] = ACTIONS(3843),
    [anon_sym_null] = ACTIONS(3845),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3843),
    [anon_sym_LBRACE] = ACTIONS(3845),
    [anon_sym_LT_AT] = ACTIONS(3845),
    [anon_sym_LT_AT_AT] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3843),
    [anon_sym_new] = ACTIONS(3845),
    [anon_sym_with] = ACTIONS(3845),
    [anon_sym_return_BANG] = ACTIONS(3843),
    [anon_sym_yield] = ACTIONS(3845),
    [anon_sym_yield_BANG] = ACTIONS(3843),
    [anon_sym_lazy] = ACTIONS(3845),
    [anon_sym_assert] = ACTIONS(3845),
    [anon_sym_upcast] = ACTIONS(3845),
    [anon_sym_downcast] = ACTIONS(3845),
    [anon_sym_COLON_GT] = ACTIONS(3843),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3843),
    [anon_sym_for] = ACTIONS(3845),
    [anon_sym_while] = ACTIONS(3845),
    [anon_sym_if] = ACTIONS(3845),
    [anon_sym_fun] = ACTIONS(3845),
    [anon_sym_try] = ACTIONS(3845),
    [anon_sym_match] = ACTIONS(3845),
    [anon_sym_match_BANG] = ACTIONS(3843),
    [anon_sym_function] = ACTIONS(3845),
    [anon_sym_LT_DASH] = ACTIONS(3845),
    [anon_sym_DOT_LBRACK] = ACTIONS(3843),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_use] = ACTIONS(3845),
    [anon_sym_use_BANG] = ACTIONS(3843),
    [anon_sym_do_BANG] = ACTIONS(3843),
    [anon_sym_begin] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(3845),
    [anon_sym_default] = ACTIONS(3845),
    [anon_sym_or] = ACTIONS(3845),
    [anon_sym_static] = ACTIONS(3845),
    [anon_sym_member] = ACTIONS(3845),
    [anon_sym_interface] = ACTIONS(3845),
    [anon_sym_abstract] = ACTIONS(3845),
    [anon_sym_val] = ACTIONS(3845),
    [anon_sym_override] = ACTIONS(3845),
    [aux_sym_char_token1] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3845),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_AT_DQUOTE] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [sym_bool] = ACTIONS(3845),
    [sym_unit] = ACTIONS(3843),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3845),
    [sym_op_identifier] = ACTIONS(3845),
    [anon_sym_PLUS] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_PLUS_DOT] = ACTIONS(3845),
    [anon_sym_DASH_DOT] = ACTIONS(3845),
    [anon_sym_PERCENT] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3845),
    [anon_sym_TILDE] = ACTIONS(3843),
    [aux_sym_prefix_op_token1] = ACTIONS(3845),
    [aux_sym_infix_op_token1] = ACTIONS(3843),
    [aux_sym_infix_op_token2] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(3845),
    [anon_sym_BANG_EQ] = ACTIONS(3845),
    [anon_sym_COLON_EQ] = ACTIONS(3843),
    [anon_sym_DOLLAR] = ACTIONS(3845),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3845),
    [sym_int] = ACTIONS(3845),
    [sym_xint] = ACTIONS(3843),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3843),
    [sym__newline] = ACTIONS(3843),
    [sym__dedent] = ACTIONS(3843),
  },
  [2064] = {
    [sym_block_comment] = STATE(2064),
    [sym_compiler_directive_decl] = STATE(2064),
    [sym_fsi_directive_decl] = STATE(2064),
    [sym_preproc_line] = STATE(2064),
    [sym_identifier] = ACTIONS(3893),
    [anon_sym_EQ] = ACTIONS(3891),
    [anon_sym_LBRACK_LT] = ACTIONS(3891),
    [anon_sym_COLON] = ACTIONS(3893),
    [anon_sym_return] = ACTIONS(3893),
    [anon_sym_do] = ACTIONS(3893),
    [anon_sym_and] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_let_BANG] = ACTIONS(3891),
    [aux_sym_access_modifier_token1] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_COMMA] = ACTIONS(3891),
    [anon_sym_null] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_COLON] = ACTIONS(3891),
    [anon_sym_AMP] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3891),
    [anon_sym_LBRACE] = ACTIONS(3893),
    [anon_sym_LT_AT] = ACTIONS(3893),
    [anon_sym_LT_AT_AT] = ACTIONS(3893),
    [anon_sym_DOT] = ACTIONS(3893),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3891),
    [anon_sym_new] = ACTIONS(3893),
    [anon_sym_with] = ACTIONS(3893),
    [anon_sym_return_BANG] = ACTIONS(3891),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_yield_BANG] = ACTIONS(3891),
    [anon_sym_lazy] = ACTIONS(3893),
    [anon_sym_assert] = ACTIONS(3893),
    [anon_sym_upcast] = ACTIONS(3893),
    [anon_sym_downcast] = ACTIONS(3893),
    [anon_sym_COLON_GT] = ACTIONS(3891),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3891),
    [anon_sym_for] = ACTIONS(3893),
    [anon_sym_while] = ACTIONS(3893),
    [anon_sym_if] = ACTIONS(3893),
    [anon_sym_fun] = ACTIONS(3893),
    [anon_sym_try] = ACTIONS(3893),
    [anon_sym_match] = ACTIONS(3893),
    [anon_sym_match_BANG] = ACTIONS(3891),
    [anon_sym_function] = ACTIONS(3893),
    [anon_sym_LT_DASH] = ACTIONS(3893),
    [anon_sym_DOT_LBRACK] = ACTIONS(3891),
    [anon_sym_LT] = ACTIONS(3891),
    [anon_sym_use] = ACTIONS(3893),
    [anon_sym_use_BANG] = ACTIONS(3891),
    [anon_sym_do_BANG] = ACTIONS(3891),
    [anon_sym_begin] = ACTIONS(3893),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_default] = ACTIONS(3893),
    [anon_sym_or] = ACTIONS(3893),
    [anon_sym_static] = ACTIONS(3893),
    [anon_sym_member] = ACTIONS(3893),
    [anon_sym_interface] = ACTIONS(3893),
    [anon_sym_abstract] = ACTIONS(3893),
    [anon_sym_val] = ACTIONS(3893),
    [anon_sym_override] = ACTIONS(3893),
    [aux_sym_char_token1] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3893),
    [anon_sym_DQUOTE] = ACTIONS(3893),
    [anon_sym_AT_DQUOTE] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [sym_bool] = ACTIONS(3893),
    [sym_unit] = ACTIONS(3891),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3893),
    [sym_op_identifier] = ACTIONS(3893),
    [anon_sym_PLUS] = ACTIONS(3893),
    [anon_sym_DASH] = ACTIONS(3893),
    [anon_sym_PLUS_DOT] = ACTIONS(3893),
    [anon_sym_DASH_DOT] = ACTIONS(3893),
    [anon_sym_PERCENT] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_TILDE] = ACTIONS(3891),
    [aux_sym_prefix_op_token1] = ACTIONS(3893),
    [aux_sym_infix_op_token1] = ACTIONS(3891),
    [aux_sym_infix_op_token2] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [anon_sym_BANG_EQ] = ACTIONS(3893),
    [anon_sym_COLON_EQ] = ACTIONS(3891),
    [anon_sym_DOLLAR] = ACTIONS(3893),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3893),
    [sym_int] = ACTIONS(3893),
    [sym_xint] = ACTIONS(3891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3891),
    [sym__newline] = ACTIONS(3891),
    [sym__dedent] = ACTIONS(3891),
  },
  [2065] = {
    [sym_block_comment] = STATE(2065),
    [sym_compiler_directive_decl] = STATE(2065),
    [sym_fsi_directive_decl] = STATE(2065),
    [sym_preproc_line] = STATE(2065),
    [sym_identifier] = ACTIONS(4022),
    [anon_sym_EQ] = ACTIONS(4020),
    [anon_sym_LBRACK_LT] = ACTIONS(4020),
    [anon_sym_COLON] = ACTIONS(4022),
    [anon_sym_return] = ACTIONS(4022),
    [anon_sym_do] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_let_BANG] = ACTIONS(4020),
    [aux_sym_access_modifier_token1] = ACTIONS(4020),
    [anon_sym_LPAREN] = ACTIONS(4022),
    [anon_sym_COMMA] = ACTIONS(4020),
    [anon_sym_null] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_COLON] = ACTIONS(4020),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4022),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(4022),
    [anon_sym_LT_AT] = ACTIONS(4022),
    [anon_sym_LT_AT_AT] = ACTIONS(4022),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4020),
    [anon_sym_new] = ACTIONS(4022),
    [anon_sym_with] = ACTIONS(4022),
    [anon_sym_return_BANG] = ACTIONS(4020),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_yield_BANG] = ACTIONS(4020),
    [anon_sym_lazy] = ACTIONS(4022),
    [anon_sym_assert] = ACTIONS(4022),
    [anon_sym_upcast] = ACTIONS(4022),
    [anon_sym_downcast] = ACTIONS(4022),
    [anon_sym_COLON_GT] = ACTIONS(4020),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4020),
    [anon_sym_for] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4022),
    [anon_sym_if] = ACTIONS(4022),
    [anon_sym_fun] = ACTIONS(4022),
    [anon_sym_try] = ACTIONS(4022),
    [anon_sym_match] = ACTIONS(4022),
    [anon_sym_match_BANG] = ACTIONS(4020),
    [anon_sym_function] = ACTIONS(4022),
    [anon_sym_LT_DASH] = ACTIONS(4022),
    [anon_sym_DOT_LBRACK] = ACTIONS(4020),
    [anon_sym_LT] = ACTIONS(4020),
    [anon_sym_use] = ACTIONS(4022),
    [anon_sym_use_BANG] = ACTIONS(4020),
    [anon_sym_do_BANG] = ACTIONS(4020),
    [anon_sym_begin] = ACTIONS(4022),
    [anon_sym_LPAREN2] = ACTIONS(4022),
    [anon_sym_default] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_static] = ACTIONS(4022),
    [anon_sym_member] = ACTIONS(4022),
    [anon_sym_interface] = ACTIONS(4022),
    [anon_sym_abstract] = ACTIONS(4022),
    [anon_sym_val] = ACTIONS(4022),
    [anon_sym_override] = ACTIONS(4022),
    [anon_sym_inherit] = ACTIONS(4022),
    [aux_sym_char_token1] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4022),
    [anon_sym_DQUOTE] = ACTIONS(4022),
    [anon_sym_AT_DQUOTE] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [sym_bool] = ACTIONS(4022),
    [sym_unit] = ACTIONS(4020),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4022),
    [sym_op_identifier] = ACTIONS(4022),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_PLUS_DOT] = ACTIONS(4022),
    [anon_sym_DASH_DOT] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4022),
    [anon_sym_TILDE] = ACTIONS(4020),
    [aux_sym_prefix_op_token1] = ACTIONS(4022),
    [aux_sym_infix_op_token1] = ACTIONS(4020),
    [aux_sym_infix_op_token2] = ACTIONS(4022),
    [anon_sym_PIPE_PIPE] = ACTIONS(4022),
    [anon_sym_BANG_EQ] = ACTIONS(4022),
    [anon_sym_COLON_EQ] = ACTIONS(4020),
    [anon_sym_DOLLAR] = ACTIONS(4022),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4022),
    [sym_int] = ACTIONS(4022),
    [sym_xint] = ACTIONS(4020),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4020),
    [anon_sym_POUNDendif] = ACTIONS(4020),
    [sym__newline] = ACTIONS(4020),
  },
  [2066] = {
    [sym_block_comment] = STATE(2066),
    [sym_compiler_directive_decl] = STATE(2066),
    [sym_fsi_directive_decl] = STATE(2066),
    [sym_preproc_line] = STATE(2066),
    [sym_identifier] = ACTIONS(3958),
    [anon_sym_EQ] = ACTIONS(3956),
    [anon_sym_LBRACK_LT] = ACTIONS(3956),
    [anon_sym_COLON] = ACTIONS(3958),
    [anon_sym_return] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(3958),
    [anon_sym_let] = ACTIONS(3958),
    [anon_sym_let_BANG] = ACTIONS(3956),
    [aux_sym_access_modifier_token1] = ACTIONS(3956),
    [anon_sym_LPAREN] = ACTIONS(3958),
    [anon_sym_COMMA] = ACTIONS(3956),
    [anon_sym_null] = ACTIONS(3958),
    [anon_sym_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_COLON] = ACTIONS(3956),
    [anon_sym_AMP] = ACTIONS(3958),
    [anon_sym_LBRACK] = ACTIONS(3958),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3956),
    [anon_sym_LBRACE] = ACTIONS(3958),
    [anon_sym_LT_AT] = ACTIONS(3958),
    [anon_sym_LT_AT_AT] = ACTIONS(3958),
    [anon_sym_DOT] = ACTIONS(3958),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3956),
    [anon_sym_new] = ACTIONS(3958),
    [anon_sym_with] = ACTIONS(3958),
    [anon_sym_return_BANG] = ACTIONS(3956),
    [anon_sym_yield] = ACTIONS(3958),
    [anon_sym_yield_BANG] = ACTIONS(3956),
    [anon_sym_lazy] = ACTIONS(3958),
    [anon_sym_assert] = ACTIONS(3958),
    [anon_sym_upcast] = ACTIONS(3958),
    [anon_sym_downcast] = ACTIONS(3958),
    [anon_sym_COLON_GT] = ACTIONS(3956),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3956),
    [anon_sym_for] = ACTIONS(3958),
    [anon_sym_while] = ACTIONS(3958),
    [anon_sym_if] = ACTIONS(3958),
    [anon_sym_fun] = ACTIONS(3958),
    [anon_sym_try] = ACTIONS(3958),
    [anon_sym_match] = ACTIONS(3958),
    [anon_sym_match_BANG] = ACTIONS(3956),
    [anon_sym_function] = ACTIONS(3958),
    [anon_sym_LT_DASH] = ACTIONS(3958),
    [anon_sym_DOT_LBRACK] = ACTIONS(3956),
    [anon_sym_LT] = ACTIONS(3956),
    [anon_sym_use] = ACTIONS(3958),
    [anon_sym_use_BANG] = ACTIONS(3956),
    [anon_sym_do_BANG] = ACTIONS(3956),
    [anon_sym_begin] = ACTIONS(3958),
    [anon_sym_LPAREN2] = ACTIONS(3958),
    [anon_sym_DOT_DOT2] = ACTIONS(3956),
    [anon_sym_default] = ACTIONS(3958),
    [anon_sym_or] = ACTIONS(3958),
    [anon_sym_static] = ACTIONS(3958),
    [anon_sym_member] = ACTIONS(3958),
    [anon_sym_interface] = ACTIONS(3958),
    [anon_sym_abstract] = ACTIONS(3958),
    [anon_sym_val] = ACTIONS(3958),
    [anon_sym_override] = ACTIONS(3958),
    [aux_sym_char_token1] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [anon_sym_AT_DQUOTE] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [sym_bool] = ACTIONS(3958),
    [sym_unit] = ACTIONS(3956),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3958),
    [sym_op_identifier] = ACTIONS(3958),
    [anon_sym_PLUS] = ACTIONS(3958),
    [anon_sym_DASH] = ACTIONS(3958),
    [anon_sym_PLUS_DOT] = ACTIONS(3958),
    [anon_sym_DASH_DOT] = ACTIONS(3958),
    [anon_sym_PERCENT] = ACTIONS(3958),
    [anon_sym_AMP_AMP] = ACTIONS(3958),
    [anon_sym_TILDE] = ACTIONS(3956),
    [aux_sym_prefix_op_token1] = ACTIONS(3958),
    [aux_sym_infix_op_token1] = ACTIONS(3956),
    [aux_sym_infix_op_token2] = ACTIONS(3958),
    [anon_sym_PIPE_PIPE] = ACTIONS(3958),
    [anon_sym_BANG_EQ] = ACTIONS(3958),
    [anon_sym_COLON_EQ] = ACTIONS(3956),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3958),
    [sym_int] = ACTIONS(3958),
    [sym_xint] = ACTIONS(3956),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3956),
    [sym__newline] = ACTIONS(3956),
    [sym__dedent] = ACTIONS(3956),
  },
  [2067] = {
    [sym_block_comment] = STATE(2067),
    [sym_compiler_directive_decl] = STATE(2067),
    [sym_fsi_directive_decl] = STATE(2067),
    [sym_preproc_line] = STATE(2067),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4072),
    [anon_sym_LBRACK_LT] = ACTIONS(4072),
    [anon_sym_COLON] = ACTIONS(4074),
    [anon_sym_return] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_let_BANG] = ACTIONS(4072),
    [aux_sym_access_modifier_token1] = ACTIONS(4072),
    [anon_sym_LPAREN] = ACTIONS(4074),
    [anon_sym_COMMA] = ACTIONS(4072),
    [anon_sym_null] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_COLON] = ACTIONS(4072),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_LT_AT] = ACTIONS(4074),
    [anon_sym_LT_AT_AT] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4072),
    [anon_sym_new] = ACTIONS(4074),
    [anon_sym_with] = ACTIONS(4074),
    [anon_sym_return_BANG] = ACTIONS(4072),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_yield_BANG] = ACTIONS(4072),
    [anon_sym_lazy] = ACTIONS(4074),
    [anon_sym_assert] = ACTIONS(4074),
    [anon_sym_upcast] = ACTIONS(4074),
    [anon_sym_downcast] = ACTIONS(4074),
    [anon_sym_COLON_GT] = ACTIONS(4072),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4072),
    [anon_sym_for] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_fun] = ACTIONS(4074),
    [anon_sym_try] = ACTIONS(4074),
    [anon_sym_match] = ACTIONS(4074),
    [anon_sym_match_BANG] = ACTIONS(4072),
    [anon_sym_function] = ACTIONS(4074),
    [anon_sym_LT_DASH] = ACTIONS(4074),
    [anon_sym_DOT_LBRACK] = ACTIONS(4072),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_use] = ACTIONS(4074),
    [anon_sym_use_BANG] = ACTIONS(4072),
    [anon_sym_do_BANG] = ACTIONS(4072),
    [anon_sym_begin] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(4074),
    [anon_sym_default] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_static] = ACTIONS(4074),
    [anon_sym_member] = ACTIONS(4074),
    [anon_sym_interface] = ACTIONS(4074),
    [anon_sym_abstract] = ACTIONS(4074),
    [anon_sym_val] = ACTIONS(4074),
    [anon_sym_override] = ACTIONS(4074),
    [anon_sym_inherit] = ACTIONS(4074),
    [aux_sym_char_token1] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4074),
    [anon_sym_DQUOTE] = ACTIONS(4074),
    [anon_sym_AT_DQUOTE] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [sym_bool] = ACTIONS(4074),
    [sym_unit] = ACTIONS(4072),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4074),
    [sym_op_identifier] = ACTIONS(4074),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_PLUS_DOT] = ACTIONS(4074),
    [anon_sym_DASH_DOT] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_TILDE] = ACTIONS(4072),
    [aux_sym_prefix_op_token1] = ACTIONS(4074),
    [aux_sym_infix_op_token1] = ACTIONS(4072),
    [aux_sym_infix_op_token2] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [anon_sym_BANG_EQ] = ACTIONS(4074),
    [anon_sym_COLON_EQ] = ACTIONS(4072),
    [anon_sym_DOLLAR] = ACTIONS(4074),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4074),
    [sym_int] = ACTIONS(4074),
    [sym_xint] = ACTIONS(4072),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4072),
    [anon_sym_POUNDendif] = ACTIONS(4072),
    [sym__newline] = ACTIONS(4072),
  },
  [2068] = {
    [sym_block_comment] = STATE(2068),
    [sym_compiler_directive_decl] = STATE(2068),
    [sym_fsi_directive_decl] = STATE(2068),
    [sym_preproc_line] = STATE(2068),
    [sym_identifier] = ACTIONS(4236),
    [anon_sym_EQ] = ACTIONS(4234),
    [anon_sym_LBRACK_LT] = ACTIONS(4234),
    [anon_sym_COLON] = ACTIONS(4236),
    [anon_sym_return] = ACTIONS(4236),
    [anon_sym_do] = ACTIONS(4236),
    [anon_sym_and] = ACTIONS(4236),
    [anon_sym_let] = ACTIONS(4236),
    [anon_sym_let_BANG] = ACTIONS(4234),
    [aux_sym_access_modifier_token1] = ACTIONS(4234),
    [anon_sym_LPAREN] = ACTIONS(4236),
    [anon_sym_COMMA] = ACTIONS(4234),
    [anon_sym_null] = ACTIONS(4236),
    [anon_sym_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_COLON] = ACTIONS(4234),
    [anon_sym_AMP] = ACTIONS(4236),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4234),
    [anon_sym_LBRACE] = ACTIONS(4236),
    [anon_sym_LT_AT] = ACTIONS(4236),
    [anon_sym_LT_AT_AT] = ACTIONS(4236),
    [anon_sym_DOT] = ACTIONS(4236),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4234),
    [anon_sym_new] = ACTIONS(4236),
    [anon_sym_with] = ACTIONS(4236),
    [anon_sym_return_BANG] = ACTIONS(4234),
    [anon_sym_yield] = ACTIONS(4236),
    [anon_sym_yield_BANG] = ACTIONS(4234),
    [anon_sym_lazy] = ACTIONS(4236),
    [anon_sym_assert] = ACTIONS(4236),
    [anon_sym_upcast] = ACTIONS(4236),
    [anon_sym_downcast] = ACTIONS(4236),
    [anon_sym_COLON_GT] = ACTIONS(4234),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4234),
    [anon_sym_for] = ACTIONS(4236),
    [anon_sym_while] = ACTIONS(4236),
    [anon_sym_if] = ACTIONS(4236),
    [anon_sym_fun] = ACTIONS(4236),
    [anon_sym_try] = ACTIONS(4236),
    [anon_sym_match] = ACTIONS(4236),
    [anon_sym_match_BANG] = ACTIONS(4234),
    [anon_sym_function] = ACTIONS(4236),
    [anon_sym_LT_DASH] = ACTIONS(4236),
    [anon_sym_DOT_LBRACK] = ACTIONS(4234),
    [anon_sym_LT] = ACTIONS(4234),
    [anon_sym_use] = ACTIONS(4236),
    [anon_sym_use_BANG] = ACTIONS(4234),
    [anon_sym_do_BANG] = ACTIONS(4234),
    [anon_sym_begin] = ACTIONS(4236),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_default] = ACTIONS(4236),
    [anon_sym_or] = ACTIONS(4236),
    [anon_sym_static] = ACTIONS(4236),
    [anon_sym_member] = ACTIONS(4236),
    [anon_sym_interface] = ACTIONS(4236),
    [anon_sym_abstract] = ACTIONS(4236),
    [anon_sym_val] = ACTIONS(4236),
    [anon_sym_override] = ACTIONS(4236),
    [aux_sym_char_token1] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4236),
    [anon_sym_DQUOTE] = ACTIONS(4236),
    [anon_sym_AT_DQUOTE] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [sym_bool] = ACTIONS(4236),
    [sym_unit] = ACTIONS(4234),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4236),
    [sym_op_identifier] = ACTIONS(4236),
    [anon_sym_PLUS] = ACTIONS(4236),
    [anon_sym_DASH] = ACTIONS(4236),
    [anon_sym_PLUS_DOT] = ACTIONS(4236),
    [anon_sym_DASH_DOT] = ACTIONS(4236),
    [anon_sym_PERCENT] = ACTIONS(4236),
    [anon_sym_AMP_AMP] = ACTIONS(4236),
    [anon_sym_TILDE] = ACTIONS(4234),
    [aux_sym_prefix_op_token1] = ACTIONS(4236),
    [aux_sym_infix_op_token1] = ACTIONS(4234),
    [aux_sym_infix_op_token2] = ACTIONS(4236),
    [anon_sym_PIPE_PIPE] = ACTIONS(4236),
    [anon_sym_BANG_EQ] = ACTIONS(4236),
    [anon_sym_COLON_EQ] = ACTIONS(4234),
    [anon_sym_DOLLAR] = ACTIONS(4236),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4236),
    [sym_int] = ACTIONS(4236),
    [sym_xint] = ACTIONS(4234),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4234),
    [sym__newline] = ACTIONS(4234),
    [sym__dedent] = ACTIONS(4234),
  },
  [2069] = {
    [sym_block_comment] = STATE(2069),
    [sym_compiler_directive_decl] = STATE(2069),
    [sym_fsi_directive_decl] = STATE(2069),
    [sym_preproc_line] = STATE(2069),
    [sym_identifier] = ACTIONS(3881),
    [anon_sym_EQ] = ACTIONS(3879),
    [anon_sym_LBRACK_LT] = ACTIONS(3879),
    [anon_sym_COLON] = ACTIONS(3881),
    [anon_sym_return] = ACTIONS(3881),
    [anon_sym_do] = ACTIONS(3881),
    [anon_sym_and] = ACTIONS(3881),
    [anon_sym_let] = ACTIONS(3881),
    [anon_sym_let_BANG] = ACTIONS(3879),
    [aux_sym_access_modifier_token1] = ACTIONS(3879),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3879),
    [anon_sym_null] = ACTIONS(3881),
    [anon_sym_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3879),
    [anon_sym_LBRACE] = ACTIONS(3881),
    [anon_sym_LT_AT] = ACTIONS(3881),
    [anon_sym_LT_AT_AT] = ACTIONS(3881),
    [anon_sym_DOT] = ACTIONS(3881),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3879),
    [anon_sym_new] = ACTIONS(3881),
    [anon_sym_with] = ACTIONS(3881),
    [anon_sym_return_BANG] = ACTIONS(3879),
    [anon_sym_yield] = ACTIONS(3881),
    [anon_sym_yield_BANG] = ACTIONS(3879),
    [anon_sym_lazy] = ACTIONS(3881),
    [anon_sym_assert] = ACTIONS(3881),
    [anon_sym_upcast] = ACTIONS(3881),
    [anon_sym_downcast] = ACTIONS(3881),
    [anon_sym_COLON_GT] = ACTIONS(3879),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3879),
    [anon_sym_for] = ACTIONS(3881),
    [anon_sym_while] = ACTIONS(3881),
    [anon_sym_if] = ACTIONS(3881),
    [anon_sym_fun] = ACTIONS(3881),
    [anon_sym_try] = ACTIONS(3881),
    [anon_sym_match] = ACTIONS(3881),
    [anon_sym_match_BANG] = ACTIONS(3879),
    [anon_sym_function] = ACTIONS(3881),
    [anon_sym_LT_DASH] = ACTIONS(3881),
    [anon_sym_DOT_LBRACK] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_use] = ACTIONS(3881),
    [anon_sym_use_BANG] = ACTIONS(3879),
    [anon_sym_do_BANG] = ACTIONS(3879),
    [anon_sym_begin] = ACTIONS(3881),
    [anon_sym_LPAREN2] = ACTIONS(3881),
    [anon_sym_default] = ACTIONS(3881),
    [anon_sym_or] = ACTIONS(3881),
    [anon_sym_static] = ACTIONS(3881),
    [anon_sym_member] = ACTIONS(3881),
    [anon_sym_interface] = ACTIONS(3881),
    [anon_sym_abstract] = ACTIONS(3881),
    [anon_sym_val] = ACTIONS(3881),
    [anon_sym_override] = ACTIONS(3881),
    [aux_sym_char_token1] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3881),
    [anon_sym_DQUOTE] = ACTIONS(3881),
    [anon_sym_AT_DQUOTE] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [sym_bool] = ACTIONS(3881),
    [sym_unit] = ACTIONS(3879),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3881),
    [sym_op_identifier] = ACTIONS(3881),
    [anon_sym_PLUS] = ACTIONS(3881),
    [anon_sym_DASH] = ACTIONS(3881),
    [anon_sym_PLUS_DOT] = ACTIONS(3881),
    [anon_sym_DASH_DOT] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(3881),
    [anon_sym_AMP_AMP] = ACTIONS(3881),
    [anon_sym_TILDE] = ACTIONS(3879),
    [aux_sym_prefix_op_token1] = ACTIONS(3881),
    [aux_sym_infix_op_token1] = ACTIONS(3879),
    [aux_sym_infix_op_token2] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE] = ACTIONS(3881),
    [anon_sym_BANG_EQ] = ACTIONS(3881),
    [anon_sym_COLON_EQ] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3881),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3881),
    [sym_int] = ACTIONS(3881),
    [sym_xint] = ACTIONS(3879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3879),
    [anon_sym_POUNDendif] = ACTIONS(3879),
    [sym__newline] = ACTIONS(3879),
  },
  [2070] = {
    [sym_block_comment] = STATE(2070),
    [sym_compiler_directive_decl] = STATE(2070),
    [sym_fsi_directive_decl] = STATE(2070),
    [sym_preproc_line] = STATE(2070),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [aux_sym_access_modifier_token1] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_member] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_val] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [anon_sym_inherit] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [anon_sym_POUNDendif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [2071] = {
    [sym_block_comment] = STATE(2071),
    [sym_compiler_directive_decl] = STATE(2071),
    [sym_fsi_directive_decl] = STATE(2071),
    [sym_preproc_line] = STATE(2071),
    [sym_identifier] = ACTIONS(4100),
    [anon_sym_EQ] = ACTIONS(4098),
    [anon_sym_LBRACK_LT] = ACTIONS(4098),
    [anon_sym_COLON] = ACTIONS(4100),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_do] = ACTIONS(4100),
    [anon_sym_and] = ACTIONS(4100),
    [anon_sym_let] = ACTIONS(4100),
    [anon_sym_let_BANG] = ACTIONS(4098),
    [aux_sym_access_modifier_token1] = ACTIONS(4098),
    [anon_sym_LPAREN] = ACTIONS(4100),
    [anon_sym_COMMA] = ACTIONS(4098),
    [anon_sym_null] = ACTIONS(4100),
    [anon_sym_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_COLON] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4100),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4098),
    [anon_sym_LBRACE] = ACTIONS(4100),
    [anon_sym_LT_AT] = ACTIONS(4100),
    [anon_sym_LT_AT_AT] = ACTIONS(4100),
    [anon_sym_DOT] = ACTIONS(4100),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4098),
    [anon_sym_new] = ACTIONS(4100),
    [anon_sym_with] = ACTIONS(4100),
    [anon_sym_return_BANG] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4100),
    [anon_sym_yield_BANG] = ACTIONS(4098),
    [anon_sym_lazy] = ACTIONS(4100),
    [anon_sym_assert] = ACTIONS(4100),
    [anon_sym_upcast] = ACTIONS(4100),
    [anon_sym_downcast] = ACTIONS(4100),
    [anon_sym_COLON_GT] = ACTIONS(4098),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4098),
    [anon_sym_for] = ACTIONS(4100),
    [anon_sym_while] = ACTIONS(4100),
    [anon_sym_if] = ACTIONS(4100),
    [anon_sym_fun] = ACTIONS(4100),
    [anon_sym_try] = ACTIONS(4100),
    [anon_sym_match] = ACTIONS(4100),
    [anon_sym_match_BANG] = ACTIONS(4098),
    [anon_sym_function] = ACTIONS(4100),
    [anon_sym_LT_DASH] = ACTIONS(4100),
    [anon_sym_DOT_LBRACK] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(4098),
    [anon_sym_use] = ACTIONS(4100),
    [anon_sym_use_BANG] = ACTIONS(4098),
    [anon_sym_do_BANG] = ACTIONS(4098),
    [anon_sym_begin] = ACTIONS(4100),
    [anon_sym_LPAREN2] = ACTIONS(4100),
    [anon_sym_default] = ACTIONS(4100),
    [anon_sym_or] = ACTIONS(4100),
    [anon_sym_static] = ACTIONS(4100),
    [anon_sym_member] = ACTIONS(4100),
    [anon_sym_interface] = ACTIONS(4100),
    [anon_sym_abstract] = ACTIONS(4100),
    [anon_sym_val] = ACTIONS(4100),
    [anon_sym_override] = ACTIONS(4100),
    [aux_sym_char_token1] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4100),
    [anon_sym_DQUOTE] = ACTIONS(4100),
    [anon_sym_AT_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [sym_bool] = ACTIONS(4100),
    [sym_unit] = ACTIONS(4098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4100),
    [sym_op_identifier] = ACTIONS(4100),
    [anon_sym_PLUS] = ACTIONS(4100),
    [anon_sym_DASH] = ACTIONS(4100),
    [anon_sym_PLUS_DOT] = ACTIONS(4100),
    [anon_sym_DASH_DOT] = ACTIONS(4100),
    [anon_sym_PERCENT] = ACTIONS(4100),
    [anon_sym_AMP_AMP] = ACTIONS(4100),
    [anon_sym_TILDE] = ACTIONS(4098),
    [aux_sym_prefix_op_token1] = ACTIONS(4100),
    [aux_sym_infix_op_token1] = ACTIONS(4098),
    [aux_sym_infix_op_token2] = ACTIONS(4100),
    [anon_sym_PIPE_PIPE] = ACTIONS(4100),
    [anon_sym_BANG_EQ] = ACTIONS(4100),
    [anon_sym_COLON_EQ] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4100),
    [sym_int] = ACTIONS(4100),
    [sym_xint] = ACTIONS(4098),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4098),
    [sym__newline] = ACTIONS(4098),
    [sym__dedent] = ACTIONS(4098),
  },
  [2072] = {
    [sym_block_comment] = STATE(2072),
    [sym_compiler_directive_decl] = STATE(2072),
    [sym_fsi_directive_decl] = STATE(2072),
    [sym_preproc_line] = STATE(2072),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_EQ] = ACTIONS(4001),
    [anon_sym_LBRACK_LT] = ACTIONS(4001),
    [anon_sym_COLON] = ACTIONS(4003),
    [anon_sym_return] = ACTIONS(4003),
    [anon_sym_do] = ACTIONS(4003),
    [anon_sym_and] = ACTIONS(4003),
    [anon_sym_let] = ACTIONS(4003),
    [anon_sym_let_BANG] = ACTIONS(4001),
    [aux_sym_access_modifier_token1] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4003),
    [anon_sym_COMMA] = ACTIONS(4001),
    [anon_sym_null] = ACTIONS(4003),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_COLON] = ACTIONS(4001),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LBRACK] = ACTIONS(4003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4001),
    [anon_sym_LBRACE] = ACTIONS(4003),
    [anon_sym_LT_AT] = ACTIONS(4003),
    [anon_sym_LT_AT_AT] = ACTIONS(4003),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4001),
    [anon_sym_new] = ACTIONS(4003),
    [anon_sym_with] = ACTIONS(4003),
    [anon_sym_return_BANG] = ACTIONS(4001),
    [anon_sym_yield] = ACTIONS(4003),
    [anon_sym_yield_BANG] = ACTIONS(4001),
    [anon_sym_lazy] = ACTIONS(4003),
    [anon_sym_assert] = ACTIONS(4003),
    [anon_sym_upcast] = ACTIONS(4003),
    [anon_sym_downcast] = ACTIONS(4003),
    [anon_sym_COLON_GT] = ACTIONS(4001),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4001),
    [anon_sym_for] = ACTIONS(4003),
    [anon_sym_while] = ACTIONS(4003),
    [anon_sym_if] = ACTIONS(4003),
    [anon_sym_fun] = ACTIONS(4003),
    [anon_sym_try] = ACTIONS(4003),
    [anon_sym_match] = ACTIONS(4003),
    [anon_sym_match_BANG] = ACTIONS(4001),
    [anon_sym_function] = ACTIONS(4003),
    [anon_sym_LT_DASH] = ACTIONS(4003),
    [anon_sym_DOT_LBRACK] = ACTIONS(4001),
    [anon_sym_LT] = ACTIONS(4001),
    [anon_sym_use] = ACTIONS(4003),
    [anon_sym_use_BANG] = ACTIONS(4001),
    [anon_sym_do_BANG] = ACTIONS(4001),
    [anon_sym_begin] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4003),
    [anon_sym_default] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [anon_sym_static] = ACTIONS(4003),
    [anon_sym_member] = ACTIONS(4003),
    [anon_sym_interface] = ACTIONS(4003),
    [anon_sym_abstract] = ACTIONS(4003),
    [anon_sym_val] = ACTIONS(4003),
    [anon_sym_override] = ACTIONS(4003),
    [aux_sym_char_token1] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4003),
    [anon_sym_DQUOTE] = ACTIONS(4003),
    [anon_sym_AT_DQUOTE] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [sym_bool] = ACTIONS(4003),
    [sym_unit] = ACTIONS(4001),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4003),
    [sym_op_identifier] = ACTIONS(4003),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_PLUS_DOT] = ACTIONS(4003),
    [anon_sym_DASH_DOT] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4003),
    [anon_sym_TILDE] = ACTIONS(4001),
    [aux_sym_prefix_op_token1] = ACTIONS(4003),
    [aux_sym_infix_op_token1] = ACTIONS(4001),
    [aux_sym_infix_op_token2] = ACTIONS(4003),
    [anon_sym_PIPE_PIPE] = ACTIONS(4003),
    [anon_sym_BANG_EQ] = ACTIONS(4003),
    [anon_sym_COLON_EQ] = ACTIONS(4001),
    [anon_sym_DOLLAR] = ACTIONS(4003),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4003),
    [sym_int] = ACTIONS(4003),
    [sym_xint] = ACTIONS(4001),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4001),
    [anon_sym_POUNDendif] = ACTIONS(4001),
    [sym__newline] = ACTIONS(4001),
  },
  [2073] = {
    [sym_block_comment] = STATE(2073),
    [sym_compiler_directive_decl] = STATE(2073),
    [sym_fsi_directive_decl] = STATE(2073),
    [sym_preproc_line] = STATE(2073),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3843),
    [anon_sym_LBRACK_LT] = ACTIONS(3843),
    [anon_sym_COLON] = ACTIONS(3845),
    [anon_sym_return] = ACTIONS(3845),
    [anon_sym_do] = ACTIONS(3845),
    [anon_sym_and] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_let_BANG] = ACTIONS(3843),
    [aux_sym_access_modifier_token1] = ACTIONS(3843),
    [anon_sym_LPAREN] = ACTIONS(3845),
    [anon_sym_COMMA] = ACTIONS(3843),
    [anon_sym_null] = ACTIONS(3845),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3843),
    [anon_sym_LBRACE] = ACTIONS(3845),
    [anon_sym_LT_AT] = ACTIONS(3845),
    [anon_sym_LT_AT_AT] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3843),
    [anon_sym_new] = ACTIONS(3845),
    [anon_sym_with] = ACTIONS(3845),
    [anon_sym_return_BANG] = ACTIONS(3843),
    [anon_sym_yield] = ACTIONS(3845),
    [anon_sym_yield_BANG] = ACTIONS(3843),
    [anon_sym_lazy] = ACTIONS(3845),
    [anon_sym_assert] = ACTIONS(3845),
    [anon_sym_upcast] = ACTIONS(3845),
    [anon_sym_downcast] = ACTIONS(3845),
    [anon_sym_COLON_GT] = ACTIONS(3843),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3843),
    [anon_sym_for] = ACTIONS(3845),
    [anon_sym_while] = ACTIONS(3845),
    [anon_sym_if] = ACTIONS(3845),
    [anon_sym_fun] = ACTIONS(3845),
    [anon_sym_try] = ACTIONS(3845),
    [anon_sym_match] = ACTIONS(3845),
    [anon_sym_match_BANG] = ACTIONS(3843),
    [anon_sym_function] = ACTIONS(3845),
    [anon_sym_LT_DASH] = ACTIONS(3845),
    [anon_sym_DOT_LBRACK] = ACTIONS(3843),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_use] = ACTIONS(3845),
    [anon_sym_use_BANG] = ACTIONS(3843),
    [anon_sym_do_BANG] = ACTIONS(3843),
    [anon_sym_begin] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(3845),
    [anon_sym_default] = ACTIONS(3845),
    [anon_sym_or] = ACTIONS(3845),
    [anon_sym_static] = ACTIONS(3845),
    [anon_sym_member] = ACTIONS(3845),
    [anon_sym_interface] = ACTIONS(3845),
    [anon_sym_abstract] = ACTIONS(3845),
    [anon_sym_val] = ACTIONS(3845),
    [anon_sym_override] = ACTIONS(3845),
    [aux_sym_char_token1] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3845),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_AT_DQUOTE] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [sym_bool] = ACTIONS(3845),
    [sym_unit] = ACTIONS(3843),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3845),
    [sym_op_identifier] = ACTIONS(3845),
    [anon_sym_PLUS] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_PLUS_DOT] = ACTIONS(3845),
    [anon_sym_DASH_DOT] = ACTIONS(3845),
    [anon_sym_PERCENT] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3845),
    [anon_sym_TILDE] = ACTIONS(3843),
    [aux_sym_prefix_op_token1] = ACTIONS(3845),
    [aux_sym_infix_op_token1] = ACTIONS(3843),
    [aux_sym_infix_op_token2] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(3845),
    [anon_sym_BANG_EQ] = ACTIONS(3845),
    [anon_sym_COLON_EQ] = ACTIONS(3843),
    [anon_sym_DOLLAR] = ACTIONS(3845),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3845),
    [sym_int] = ACTIONS(3845),
    [sym_xint] = ACTIONS(3843),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3843),
    [anon_sym_POUNDendif] = ACTIONS(3843),
    [sym__newline] = ACTIONS(3843),
  },
  [2074] = {
    [sym_block_comment] = STATE(2074),
    [sym_compiler_directive_decl] = STATE(2074),
    [sym_fsi_directive_decl] = STATE(2074),
    [sym_preproc_line] = STATE(2074),
    [sym_identifier] = ACTIONS(4018),
    [anon_sym_EQ] = ACTIONS(4016),
    [anon_sym_LBRACK_LT] = ACTIONS(4016),
    [anon_sym_COLON] = ACTIONS(4018),
    [anon_sym_return] = ACTIONS(4018),
    [anon_sym_do] = ACTIONS(4018),
    [anon_sym_and] = ACTIONS(4018),
    [anon_sym_let] = ACTIONS(4018),
    [anon_sym_let_BANG] = ACTIONS(4016),
    [aux_sym_access_modifier_token1] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(4018),
    [anon_sym_COMMA] = ACTIONS(4016),
    [anon_sym_null] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_COLON] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4018),
    [anon_sym_LBRACK] = ACTIONS(4018),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4016),
    [anon_sym_LBRACE] = ACTIONS(4018),
    [anon_sym_LT_AT] = ACTIONS(4018),
    [anon_sym_LT_AT_AT] = ACTIONS(4018),
    [anon_sym_DOT] = ACTIONS(4018),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4016),
    [anon_sym_new] = ACTIONS(4018),
    [anon_sym_with] = ACTIONS(4018),
    [anon_sym_return_BANG] = ACTIONS(4016),
    [anon_sym_yield] = ACTIONS(4018),
    [anon_sym_yield_BANG] = ACTIONS(4016),
    [anon_sym_lazy] = ACTIONS(4018),
    [anon_sym_assert] = ACTIONS(4018),
    [anon_sym_upcast] = ACTIONS(4018),
    [anon_sym_downcast] = ACTIONS(4018),
    [anon_sym_COLON_GT] = ACTIONS(4016),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4016),
    [anon_sym_for] = ACTIONS(4018),
    [anon_sym_while] = ACTIONS(4018),
    [anon_sym_if] = ACTIONS(4018),
    [anon_sym_fun] = ACTIONS(4018),
    [anon_sym_try] = ACTIONS(4018),
    [anon_sym_match] = ACTIONS(4018),
    [anon_sym_match_BANG] = ACTIONS(4016),
    [anon_sym_function] = ACTIONS(4018),
    [anon_sym_LT_DASH] = ACTIONS(4018),
    [anon_sym_DOT_LBRACK] = ACTIONS(4016),
    [anon_sym_LT] = ACTIONS(4016),
    [anon_sym_use] = ACTIONS(4018),
    [anon_sym_use_BANG] = ACTIONS(4016),
    [anon_sym_do_BANG] = ACTIONS(4016),
    [anon_sym_begin] = ACTIONS(4018),
    [anon_sym_LPAREN2] = ACTIONS(4018),
    [anon_sym_default] = ACTIONS(4018),
    [anon_sym_or] = ACTIONS(4018),
    [anon_sym_static] = ACTIONS(4018),
    [anon_sym_member] = ACTIONS(4018),
    [anon_sym_interface] = ACTIONS(4018),
    [anon_sym_abstract] = ACTIONS(4018),
    [anon_sym_val] = ACTIONS(4018),
    [anon_sym_override] = ACTIONS(4018),
    [aux_sym_char_token1] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(4018),
    [anon_sym_AT_DQUOTE] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [sym_bool] = ACTIONS(4018),
    [sym_unit] = ACTIONS(4016),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4018),
    [sym_op_identifier] = ACTIONS(4018),
    [anon_sym_PLUS] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_PLUS_DOT] = ACTIONS(4018),
    [anon_sym_DASH_DOT] = ACTIONS(4018),
    [anon_sym_PERCENT] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4016),
    [aux_sym_prefix_op_token1] = ACTIONS(4018),
    [aux_sym_infix_op_token1] = ACTIONS(4016),
    [aux_sym_infix_op_token2] = ACTIONS(4018),
    [anon_sym_PIPE_PIPE] = ACTIONS(4018),
    [anon_sym_BANG_EQ] = ACTIONS(4018),
    [anon_sym_COLON_EQ] = ACTIONS(4016),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4018),
    [sym_int] = ACTIONS(4018),
    [sym_xint] = ACTIONS(4016),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4016),
    [anon_sym_POUNDendif] = ACTIONS(4016),
    [sym__newline] = ACTIONS(4016),
  },
  [2075] = {
    [sym_block_comment] = STATE(2075),
    [sym_compiler_directive_decl] = STATE(2075),
    [sym_fsi_directive_decl] = STATE(2075),
    [sym_preproc_line] = STATE(2075),
    [sym_identifier] = ACTIONS(3927),
    [anon_sym_EQ] = ACTIONS(3925),
    [anon_sym_LBRACK_LT] = ACTIONS(3925),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_return] = ACTIONS(3927),
    [anon_sym_do] = ACTIONS(3927),
    [anon_sym_let] = ACTIONS(3927),
    [anon_sym_let_BANG] = ACTIONS(3925),
    [aux_sym_access_modifier_token1] = ACTIONS(3925),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_COMMA] = ACTIONS(3925),
    [anon_sym_null] = ACTIONS(3927),
    [anon_sym_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_COLON] = ACTIONS(3925),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3925),
    [anon_sym_LBRACE] = ACTIONS(3927),
    [anon_sym_LT_AT] = ACTIONS(3927),
    [anon_sym_LT_AT_AT] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3925),
    [anon_sym_new] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3927),
    [anon_sym_return_BANG] = ACTIONS(3925),
    [anon_sym_yield] = ACTIONS(3927),
    [anon_sym_yield_BANG] = ACTIONS(3925),
    [anon_sym_lazy] = ACTIONS(3927),
    [anon_sym_assert] = ACTIONS(3927),
    [anon_sym_upcast] = ACTIONS(3927),
    [anon_sym_downcast] = ACTIONS(3927),
    [anon_sym_COLON_GT] = ACTIONS(3925),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3925),
    [anon_sym_for] = ACTIONS(3927),
    [anon_sym_while] = ACTIONS(3927),
    [anon_sym_if] = ACTIONS(3927),
    [anon_sym_fun] = ACTIONS(3927),
    [anon_sym_try] = ACTIONS(3927),
    [anon_sym_match] = ACTIONS(3927),
    [anon_sym_match_BANG] = ACTIONS(3925),
    [anon_sym_function] = ACTIONS(3927),
    [anon_sym_LT_DASH] = ACTIONS(3927),
    [anon_sym_DOT_LBRACK] = ACTIONS(3925),
    [anon_sym_LT] = ACTIONS(3925),
    [anon_sym_use] = ACTIONS(3927),
    [anon_sym_use_BANG] = ACTIONS(3925),
    [anon_sym_do_BANG] = ACTIONS(3925),
    [anon_sym_begin] = ACTIONS(3927),
    [anon_sym_LPAREN2] = ACTIONS(3927),
    [anon_sym_default] = ACTIONS(3927),
    [anon_sym_or] = ACTIONS(3927),
    [anon_sym_static] = ACTIONS(3927),
    [anon_sym_member] = ACTIONS(3927),
    [anon_sym_interface] = ACTIONS(3927),
    [anon_sym_abstract] = ACTIONS(3927),
    [anon_sym_val] = ACTIONS(3927),
    [anon_sym_override] = ACTIONS(3927),
    [anon_sym_inherit] = ACTIONS(3927),
    [aux_sym_char_token1] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_AT_DQUOTE] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [sym_bool] = ACTIONS(3927),
    [sym_unit] = ACTIONS(3925),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3927),
    [sym_op_identifier] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3927),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_PLUS_DOT] = ACTIONS(3927),
    [anon_sym_DASH_DOT] = ACTIONS(3927),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_TILDE] = ACTIONS(3925),
    [aux_sym_prefix_op_token1] = ACTIONS(3927),
    [aux_sym_infix_op_token1] = ACTIONS(3925),
    [aux_sym_infix_op_token2] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_COLON_EQ] = ACTIONS(3925),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3927),
    [sym_int] = ACTIONS(3927),
    [sym_xint] = ACTIONS(3925),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3925),
    [anon_sym_POUNDendif] = ACTIONS(3925),
    [sym__newline] = ACTIONS(3925),
  },
  [2076] = {
    [sym_block_comment] = STATE(2076),
    [sym_compiler_directive_decl] = STATE(2076),
    [sym_fsi_directive_decl] = STATE(2076),
    [sym_preproc_line] = STATE(2076),
    [sym_identifier] = ACTIONS(3946),
    [anon_sym_EQ] = ACTIONS(3944),
    [anon_sym_LBRACK_LT] = ACTIONS(3944),
    [anon_sym_COLON] = ACTIONS(3946),
    [anon_sym_return] = ACTIONS(3946),
    [anon_sym_do] = ACTIONS(3946),
    [anon_sym_let] = ACTIONS(3946),
    [anon_sym_let_BANG] = ACTIONS(3944),
    [aux_sym_access_modifier_token1] = ACTIONS(3944),
    [anon_sym_LPAREN] = ACTIONS(3946),
    [anon_sym_COMMA] = ACTIONS(3944),
    [anon_sym_null] = ACTIONS(3946),
    [anon_sym_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LBRACK] = ACTIONS(3946),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3944),
    [anon_sym_LBRACE] = ACTIONS(3946),
    [anon_sym_LT_AT] = ACTIONS(3946),
    [anon_sym_LT_AT_AT] = ACTIONS(3946),
    [anon_sym_DOT] = ACTIONS(3946),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3944),
    [anon_sym_new] = ACTIONS(3946),
    [anon_sym_with] = ACTIONS(3946),
    [anon_sym_return_BANG] = ACTIONS(3944),
    [anon_sym_yield] = ACTIONS(3946),
    [anon_sym_yield_BANG] = ACTIONS(3944),
    [anon_sym_lazy] = ACTIONS(3946),
    [anon_sym_assert] = ACTIONS(3946),
    [anon_sym_upcast] = ACTIONS(3946),
    [anon_sym_downcast] = ACTIONS(3946),
    [anon_sym_COLON_GT] = ACTIONS(3944),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3944),
    [anon_sym_for] = ACTIONS(3946),
    [anon_sym_while] = ACTIONS(3946),
    [anon_sym_if] = ACTIONS(3946),
    [anon_sym_fun] = ACTIONS(3946),
    [anon_sym_try] = ACTIONS(3946),
    [anon_sym_match] = ACTIONS(3946),
    [anon_sym_match_BANG] = ACTIONS(3944),
    [anon_sym_function] = ACTIONS(3946),
    [anon_sym_LT_DASH] = ACTIONS(3946),
    [anon_sym_DOT_LBRACK] = ACTIONS(3944),
    [anon_sym_LT] = ACTIONS(3944),
    [anon_sym_use] = ACTIONS(3946),
    [anon_sym_use_BANG] = ACTIONS(3944),
    [anon_sym_do_BANG] = ACTIONS(3944),
    [anon_sym_begin] = ACTIONS(3946),
    [anon_sym_LPAREN2] = ACTIONS(3946),
    [anon_sym_default] = ACTIONS(3946),
    [anon_sym_or] = ACTIONS(3946),
    [anon_sym_static] = ACTIONS(3946),
    [anon_sym_member] = ACTIONS(3946),
    [anon_sym_interface] = ACTIONS(3946),
    [anon_sym_abstract] = ACTIONS(3946),
    [anon_sym_val] = ACTIONS(3946),
    [anon_sym_override] = ACTIONS(3946),
    [anon_sym_inherit] = ACTIONS(3946),
    [aux_sym_char_token1] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_AT_DQUOTE] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [sym_bool] = ACTIONS(3946),
    [sym_unit] = ACTIONS(3944),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3946),
    [sym_op_identifier] = ACTIONS(3946),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PLUS_DOT] = ACTIONS(3946),
    [anon_sym_DASH_DOT] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3946),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_TILDE] = ACTIONS(3944),
    [aux_sym_prefix_op_token1] = ACTIONS(3946),
    [aux_sym_infix_op_token1] = ACTIONS(3944),
    [aux_sym_infix_op_token2] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [anon_sym_BANG_EQ] = ACTIONS(3946),
    [anon_sym_COLON_EQ] = ACTIONS(3944),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3946),
    [sym_int] = ACTIONS(3946),
    [sym_xint] = ACTIONS(3944),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3944),
    [anon_sym_POUNDendif] = ACTIONS(3944),
    [sym__newline] = ACTIONS(3944),
  },
  [2077] = {
    [sym_block_comment] = STATE(2077),
    [sym_compiler_directive_decl] = STATE(2077),
    [sym_fsi_directive_decl] = STATE(2077),
    [sym_preproc_line] = STATE(2077),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_LBRACK_LT] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_and] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [aux_sym_access_modifier_token1] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4765),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_with] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_default] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [anon_sym_static] = ACTIONS(4228),
    [anon_sym_member] = ACTIONS(4228),
    [anon_sym_interface] = ACTIONS(4228),
    [anon_sym_abstract] = ACTIONS(4228),
    [anon_sym_val] = ACTIONS(4228),
    [anon_sym_override] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [anon_sym_POUNDendif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
  },
  [2078] = {
    [sym_block_comment] = STATE(2078),
    [sym_compiler_directive_decl] = STATE(2078),
    [sym_fsi_directive_decl] = STATE(2078),
    [sym_preproc_line] = STATE(2078),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_LBRACK_LT] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_and] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [aux_sym_access_modifier_token1] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_with] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_default] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [anon_sym_static] = ACTIONS(4228),
    [anon_sym_member] = ACTIONS(4228),
    [anon_sym_interface] = ACTIONS(4228),
    [anon_sym_abstract] = ACTIONS(4228),
    [anon_sym_val] = ACTIONS(4228),
    [anon_sym_override] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [anon_sym_POUNDendif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
  },
  [2079] = {
    [sym_block_comment] = STATE(2079),
    [sym_compiler_directive_decl] = STATE(2079),
    [sym_fsi_directive_decl] = STATE(2079),
    [sym_preproc_line] = STATE(2079),
    [sym_identifier] = ACTIONS(3972),
    [anon_sym_EQ] = ACTIONS(3970),
    [anon_sym_LBRACK_LT] = ACTIONS(3970),
    [anon_sym_COLON] = ACTIONS(3972),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_do] = ACTIONS(3972),
    [anon_sym_let] = ACTIONS(3972),
    [anon_sym_let_BANG] = ACTIONS(3970),
    [aux_sym_access_modifier_token1] = ACTIONS(3970),
    [anon_sym_LPAREN] = ACTIONS(3972),
    [anon_sym_COMMA] = ACTIONS(3970),
    [anon_sym_null] = ACTIONS(3972),
    [anon_sym_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_COLON] = ACTIONS(3970),
    [anon_sym_AMP] = ACTIONS(3972),
    [anon_sym_LBRACK] = ACTIONS(3972),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3970),
    [anon_sym_LBRACE] = ACTIONS(3972),
    [anon_sym_LT_AT] = ACTIONS(3972),
    [anon_sym_LT_AT_AT] = ACTIONS(3972),
    [anon_sym_DOT] = ACTIONS(3972),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3970),
    [anon_sym_new] = ACTIONS(3972),
    [anon_sym_with] = ACTIONS(3972),
    [anon_sym_return_BANG] = ACTIONS(3970),
    [anon_sym_yield] = ACTIONS(3972),
    [anon_sym_yield_BANG] = ACTIONS(3970),
    [anon_sym_lazy] = ACTIONS(3972),
    [anon_sym_assert] = ACTIONS(3972),
    [anon_sym_upcast] = ACTIONS(3972),
    [anon_sym_downcast] = ACTIONS(3972),
    [anon_sym_COLON_GT] = ACTIONS(3970),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3970),
    [anon_sym_for] = ACTIONS(3972),
    [anon_sym_while] = ACTIONS(3972),
    [anon_sym_if] = ACTIONS(3972),
    [anon_sym_fun] = ACTIONS(3972),
    [anon_sym_try] = ACTIONS(3972),
    [anon_sym_match] = ACTIONS(3972),
    [anon_sym_match_BANG] = ACTIONS(3970),
    [anon_sym_function] = ACTIONS(3972),
    [anon_sym_LT_DASH] = ACTIONS(3972),
    [anon_sym_DOT_LBRACK] = ACTIONS(3970),
    [anon_sym_LT] = ACTIONS(3970),
    [anon_sym_use] = ACTIONS(3972),
    [anon_sym_use_BANG] = ACTIONS(3970),
    [anon_sym_do_BANG] = ACTIONS(3970),
    [anon_sym_begin] = ACTIONS(3972),
    [anon_sym_LPAREN2] = ACTIONS(3972),
    [anon_sym_default] = ACTIONS(3972),
    [anon_sym_or] = ACTIONS(3972),
    [anon_sym_static] = ACTIONS(3972),
    [anon_sym_member] = ACTIONS(3972),
    [anon_sym_interface] = ACTIONS(3972),
    [anon_sym_abstract] = ACTIONS(3972),
    [anon_sym_val] = ACTIONS(3972),
    [anon_sym_override] = ACTIONS(3972),
    [anon_sym_inherit] = ACTIONS(3972),
    [aux_sym_char_token1] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3972),
    [anon_sym_DQUOTE] = ACTIONS(3972),
    [anon_sym_AT_DQUOTE] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [sym_bool] = ACTIONS(3972),
    [sym_unit] = ACTIONS(3970),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3972),
    [sym_op_identifier] = ACTIONS(3972),
    [anon_sym_PLUS] = ACTIONS(3972),
    [anon_sym_DASH] = ACTIONS(3972),
    [anon_sym_PLUS_DOT] = ACTIONS(3972),
    [anon_sym_DASH_DOT] = ACTIONS(3972),
    [anon_sym_PERCENT] = ACTIONS(3972),
    [anon_sym_AMP_AMP] = ACTIONS(3972),
    [anon_sym_TILDE] = ACTIONS(3970),
    [aux_sym_prefix_op_token1] = ACTIONS(3972),
    [aux_sym_infix_op_token1] = ACTIONS(3970),
    [aux_sym_infix_op_token2] = ACTIONS(3972),
    [anon_sym_PIPE_PIPE] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3972),
    [anon_sym_COLON_EQ] = ACTIONS(3970),
    [anon_sym_DOLLAR] = ACTIONS(3972),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3972),
    [sym_int] = ACTIONS(3972),
    [sym_xint] = ACTIONS(3970),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3970),
    [anon_sym_POUNDendif] = ACTIONS(3970),
    [sym__newline] = ACTIONS(3970),
  },
  [2080] = {
    [sym_block_comment] = STATE(2080),
    [sym_compiler_directive_decl] = STATE(2080),
    [sym_fsi_directive_decl] = STATE(2080),
    [sym_preproc_line] = STATE(2080),
    [sym_identifier] = ACTIONS(4220),
    [anon_sym_EQ] = ACTIONS(4218),
    [anon_sym_LBRACK_LT] = ACTIONS(4218),
    [anon_sym_COLON] = ACTIONS(4220),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_do] = ACTIONS(4220),
    [anon_sym_and] = ACTIONS(4220),
    [anon_sym_let] = ACTIONS(4220),
    [anon_sym_let_BANG] = ACTIONS(4218),
    [aux_sym_access_modifier_token1] = ACTIONS(4218),
    [anon_sym_LPAREN] = ACTIONS(4220),
    [anon_sym_COMMA] = ACTIONS(4218),
    [anon_sym_null] = ACTIONS(4220),
    [anon_sym_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_COLON] = ACTIONS(4218),
    [anon_sym_AMP] = ACTIONS(4220),
    [anon_sym_LBRACK] = ACTIONS(4220),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(4220),
    [anon_sym_LT_AT] = ACTIONS(4220),
    [anon_sym_LT_AT_AT] = ACTIONS(4220),
    [anon_sym_DOT] = ACTIONS(4220),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4218),
    [anon_sym_new] = ACTIONS(4220),
    [anon_sym_with] = ACTIONS(4220),
    [anon_sym_return_BANG] = ACTIONS(4218),
    [anon_sym_yield] = ACTIONS(4220),
    [anon_sym_yield_BANG] = ACTIONS(4218),
    [anon_sym_lazy] = ACTIONS(4220),
    [anon_sym_assert] = ACTIONS(4220),
    [anon_sym_upcast] = ACTIONS(4220),
    [anon_sym_downcast] = ACTIONS(4220),
    [anon_sym_COLON_GT] = ACTIONS(4218),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4218),
    [anon_sym_for] = ACTIONS(4220),
    [anon_sym_while] = ACTIONS(4220),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_fun] = ACTIONS(4220),
    [anon_sym_try] = ACTIONS(4220),
    [anon_sym_match] = ACTIONS(4220),
    [anon_sym_match_BANG] = ACTIONS(4218),
    [anon_sym_function] = ACTIONS(4220),
    [anon_sym_LT_DASH] = ACTIONS(4220),
    [anon_sym_DOT_LBRACK] = ACTIONS(4218),
    [anon_sym_LT] = ACTIONS(4218),
    [anon_sym_use] = ACTIONS(4220),
    [anon_sym_use_BANG] = ACTIONS(4218),
    [anon_sym_do_BANG] = ACTIONS(4218),
    [anon_sym_begin] = ACTIONS(4220),
    [anon_sym_LPAREN2] = ACTIONS(4220),
    [anon_sym_default] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(4220),
    [anon_sym_static] = ACTIONS(4220),
    [anon_sym_member] = ACTIONS(4220),
    [anon_sym_interface] = ACTIONS(4220),
    [anon_sym_abstract] = ACTIONS(4220),
    [anon_sym_val] = ACTIONS(4220),
    [anon_sym_override] = ACTIONS(4220),
    [aux_sym_char_token1] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4220),
    [anon_sym_DQUOTE] = ACTIONS(4220),
    [anon_sym_AT_DQUOTE] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [sym_bool] = ACTIONS(4220),
    [sym_unit] = ACTIONS(4218),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4220),
    [sym_op_identifier] = ACTIONS(4220),
    [anon_sym_PLUS] = ACTIONS(4220),
    [anon_sym_DASH] = ACTIONS(4220),
    [anon_sym_PLUS_DOT] = ACTIONS(4220),
    [anon_sym_DASH_DOT] = ACTIONS(4220),
    [anon_sym_PERCENT] = ACTIONS(4220),
    [anon_sym_AMP_AMP] = ACTIONS(4220),
    [anon_sym_TILDE] = ACTIONS(4218),
    [aux_sym_prefix_op_token1] = ACTIONS(4220),
    [aux_sym_infix_op_token1] = ACTIONS(4218),
    [aux_sym_infix_op_token2] = ACTIONS(4220),
    [anon_sym_PIPE_PIPE] = ACTIONS(4220),
    [anon_sym_BANG_EQ] = ACTIONS(4220),
    [anon_sym_COLON_EQ] = ACTIONS(4218),
    [anon_sym_DOLLAR] = ACTIONS(4220),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4220),
    [sym_int] = ACTIONS(4220),
    [sym_xint] = ACTIONS(4218),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4218),
    [sym__newline] = ACTIONS(4218),
    [sym__dedent] = ACTIONS(4218),
  },
  [2081] = {
    [sym_block_comment] = STATE(2081),
    [sym_compiler_directive_decl] = STATE(2081),
    [sym_fsi_directive_decl] = STATE(2081),
    [sym_preproc_line] = STATE(2081),
    [sym_identifier] = ACTIONS(4054),
    [anon_sym_EQ] = ACTIONS(4052),
    [anon_sym_LBRACK_LT] = ACTIONS(4052),
    [anon_sym_COLON] = ACTIONS(4054),
    [anon_sym_return] = ACTIONS(4054),
    [anon_sym_do] = ACTIONS(4054),
    [anon_sym_and] = ACTIONS(4054),
    [anon_sym_let] = ACTIONS(4054),
    [anon_sym_let_BANG] = ACTIONS(4052),
    [aux_sym_access_modifier_token1] = ACTIONS(4052),
    [anon_sym_LPAREN] = ACTIONS(4054),
    [anon_sym_COMMA] = ACTIONS(4052),
    [anon_sym_null] = ACTIONS(4054),
    [anon_sym_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_COLON] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(4054),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4052),
    [anon_sym_LBRACE] = ACTIONS(4054),
    [anon_sym_LT_AT] = ACTIONS(4054),
    [anon_sym_LT_AT_AT] = ACTIONS(4054),
    [anon_sym_DOT] = ACTIONS(4054),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_with] = ACTIONS(4054),
    [anon_sym_return_BANG] = ACTIONS(4052),
    [anon_sym_yield] = ACTIONS(4054),
    [anon_sym_yield_BANG] = ACTIONS(4052),
    [anon_sym_lazy] = ACTIONS(4054),
    [anon_sym_assert] = ACTIONS(4054),
    [anon_sym_upcast] = ACTIONS(4054),
    [anon_sym_downcast] = ACTIONS(4054),
    [anon_sym_COLON_GT] = ACTIONS(4052),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4052),
    [anon_sym_for] = ACTIONS(4054),
    [anon_sym_while] = ACTIONS(4054),
    [anon_sym_if] = ACTIONS(4054),
    [anon_sym_fun] = ACTIONS(4054),
    [anon_sym_try] = ACTIONS(4054),
    [anon_sym_match] = ACTIONS(4054),
    [anon_sym_match_BANG] = ACTIONS(4052),
    [anon_sym_function] = ACTIONS(4054),
    [anon_sym_LT_DASH] = ACTIONS(4054),
    [anon_sym_DOT_LBRACK] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_use] = ACTIONS(4054),
    [anon_sym_use_BANG] = ACTIONS(4052),
    [anon_sym_do_BANG] = ACTIONS(4052),
    [anon_sym_begin] = ACTIONS(4054),
    [anon_sym_LPAREN2] = ACTIONS(4054),
    [anon_sym_default] = ACTIONS(4054),
    [anon_sym_or] = ACTIONS(4054),
    [anon_sym_static] = ACTIONS(4054),
    [anon_sym_member] = ACTIONS(4054),
    [anon_sym_interface] = ACTIONS(4054),
    [anon_sym_abstract] = ACTIONS(4054),
    [anon_sym_val] = ACTIONS(4054),
    [anon_sym_override] = ACTIONS(4054),
    [aux_sym_char_token1] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4054),
    [anon_sym_DQUOTE] = ACTIONS(4054),
    [anon_sym_AT_DQUOTE] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [sym_bool] = ACTIONS(4054),
    [sym_unit] = ACTIONS(4052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4054),
    [sym_op_identifier] = ACTIONS(4054),
    [anon_sym_PLUS] = ACTIONS(4054),
    [anon_sym_DASH] = ACTIONS(4054),
    [anon_sym_PLUS_DOT] = ACTIONS(4054),
    [anon_sym_DASH_DOT] = ACTIONS(4054),
    [anon_sym_PERCENT] = ACTIONS(4054),
    [anon_sym_AMP_AMP] = ACTIONS(4054),
    [anon_sym_TILDE] = ACTIONS(4052),
    [aux_sym_prefix_op_token1] = ACTIONS(4054),
    [aux_sym_infix_op_token1] = ACTIONS(4052),
    [aux_sym_infix_op_token2] = ACTIONS(4054),
    [anon_sym_PIPE_PIPE] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4054),
    [anon_sym_COLON_EQ] = ACTIONS(4052),
    [anon_sym_DOLLAR] = ACTIONS(4054),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4054),
    [sym_int] = ACTIONS(4054),
    [sym_xint] = ACTIONS(4052),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4052),
    [anon_sym_POUNDendif] = ACTIONS(4052),
    [sym__newline] = ACTIONS(4052),
  },
  [2082] = {
    [sym_block_comment] = STATE(2082),
    [sym_compiler_directive_decl] = STATE(2082),
    [sym_fsi_directive_decl] = STATE(2082),
    [sym_preproc_line] = STATE(2082),
    [sym_identifier] = ACTIONS(4216),
    [anon_sym_EQ] = ACTIONS(4214),
    [anon_sym_LBRACK_LT] = ACTIONS(4214),
    [anon_sym_COLON] = ACTIONS(4216),
    [anon_sym_return] = ACTIONS(4216),
    [anon_sym_do] = ACTIONS(4216),
    [anon_sym_and] = ACTIONS(4216),
    [anon_sym_let] = ACTIONS(4216),
    [anon_sym_let_BANG] = ACTIONS(4214),
    [aux_sym_access_modifier_token1] = ACTIONS(4214),
    [anon_sym_LPAREN] = ACTIONS(4216),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_null] = ACTIONS(4216),
    [anon_sym_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_COLON] = ACTIONS(4214),
    [anon_sym_AMP] = ACTIONS(4216),
    [anon_sym_LBRACK] = ACTIONS(4216),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4214),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_LT_AT] = ACTIONS(4216),
    [anon_sym_LT_AT_AT] = ACTIONS(4216),
    [anon_sym_DOT] = ACTIONS(4216),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4214),
    [anon_sym_new] = ACTIONS(4216),
    [anon_sym_with] = ACTIONS(4216),
    [anon_sym_return_BANG] = ACTIONS(4214),
    [anon_sym_yield] = ACTIONS(4216),
    [anon_sym_yield_BANG] = ACTIONS(4214),
    [anon_sym_lazy] = ACTIONS(4216),
    [anon_sym_assert] = ACTIONS(4216),
    [anon_sym_upcast] = ACTIONS(4216),
    [anon_sym_downcast] = ACTIONS(4216),
    [anon_sym_COLON_GT] = ACTIONS(4214),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4214),
    [anon_sym_for] = ACTIONS(4216),
    [anon_sym_while] = ACTIONS(4216),
    [anon_sym_if] = ACTIONS(4216),
    [anon_sym_fun] = ACTIONS(4216),
    [anon_sym_try] = ACTIONS(4216),
    [anon_sym_match] = ACTIONS(4216),
    [anon_sym_match_BANG] = ACTIONS(4214),
    [anon_sym_function] = ACTIONS(4216),
    [anon_sym_LT_DASH] = ACTIONS(4216),
    [anon_sym_DOT_LBRACK] = ACTIONS(4214),
    [anon_sym_LT] = ACTIONS(4214),
    [anon_sym_use] = ACTIONS(4216),
    [anon_sym_use_BANG] = ACTIONS(4214),
    [anon_sym_do_BANG] = ACTIONS(4214),
    [anon_sym_begin] = ACTIONS(4216),
    [anon_sym_LPAREN2] = ACTIONS(4216),
    [anon_sym_default] = ACTIONS(4216),
    [anon_sym_or] = ACTIONS(4216),
    [anon_sym_static] = ACTIONS(4216),
    [anon_sym_member] = ACTIONS(4216),
    [anon_sym_interface] = ACTIONS(4216),
    [anon_sym_abstract] = ACTIONS(4216),
    [anon_sym_val] = ACTIONS(4216),
    [anon_sym_override] = ACTIONS(4216),
    [aux_sym_char_token1] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4216),
    [anon_sym_DQUOTE] = ACTIONS(4216),
    [anon_sym_AT_DQUOTE] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [sym_bool] = ACTIONS(4216),
    [sym_unit] = ACTIONS(4214),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4216),
    [sym_op_identifier] = ACTIONS(4216),
    [anon_sym_PLUS] = ACTIONS(4216),
    [anon_sym_DASH] = ACTIONS(4216),
    [anon_sym_PLUS_DOT] = ACTIONS(4216),
    [anon_sym_DASH_DOT] = ACTIONS(4216),
    [anon_sym_PERCENT] = ACTIONS(4216),
    [anon_sym_AMP_AMP] = ACTIONS(4216),
    [anon_sym_TILDE] = ACTIONS(4214),
    [aux_sym_prefix_op_token1] = ACTIONS(4216),
    [aux_sym_infix_op_token1] = ACTIONS(4214),
    [aux_sym_infix_op_token2] = ACTIONS(4216),
    [anon_sym_PIPE_PIPE] = ACTIONS(4216),
    [anon_sym_BANG_EQ] = ACTIONS(4216),
    [anon_sym_COLON_EQ] = ACTIONS(4214),
    [anon_sym_DOLLAR] = ACTIONS(4216),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4216),
    [sym_int] = ACTIONS(4216),
    [sym_xint] = ACTIONS(4214),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4214),
    [sym__newline] = ACTIONS(4214),
    [sym__dedent] = ACTIONS(4214),
  },
  [2083] = {
    [sym_block_comment] = STATE(2083),
    [sym_compiler_directive_decl] = STATE(2083),
    [sym_fsi_directive_decl] = STATE(2083),
    [sym_preproc_line] = STATE(2083),
    [sym_identifier] = ACTIONS(3996),
    [anon_sym_EQ] = ACTIONS(3994),
    [anon_sym_LBRACK_LT] = ACTIONS(3994),
    [anon_sym_COLON] = ACTIONS(3996),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_do] = ACTIONS(3996),
    [anon_sym_let] = ACTIONS(3996),
    [anon_sym_let_BANG] = ACTIONS(3994),
    [aux_sym_access_modifier_token1] = ACTIONS(3994),
    [anon_sym_LPAREN] = ACTIONS(3996),
    [anon_sym_COMMA] = ACTIONS(3994),
    [anon_sym_null] = ACTIONS(3996),
    [anon_sym_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_COLON] = ACTIONS(3994),
    [anon_sym_AMP] = ACTIONS(3996),
    [anon_sym_LBRACK] = ACTIONS(3996),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3994),
    [anon_sym_LBRACE] = ACTIONS(3996),
    [anon_sym_LT_AT] = ACTIONS(3996),
    [anon_sym_LT_AT_AT] = ACTIONS(3996),
    [anon_sym_DOT] = ACTIONS(3996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3994),
    [anon_sym_new] = ACTIONS(3996),
    [anon_sym_with] = ACTIONS(3996),
    [anon_sym_return_BANG] = ACTIONS(3994),
    [anon_sym_yield] = ACTIONS(3996),
    [anon_sym_yield_BANG] = ACTIONS(3994),
    [anon_sym_lazy] = ACTIONS(3996),
    [anon_sym_assert] = ACTIONS(3996),
    [anon_sym_upcast] = ACTIONS(3996),
    [anon_sym_downcast] = ACTIONS(3996),
    [anon_sym_COLON_GT] = ACTIONS(3994),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3994),
    [anon_sym_for] = ACTIONS(3996),
    [anon_sym_while] = ACTIONS(3996),
    [anon_sym_if] = ACTIONS(3996),
    [anon_sym_fun] = ACTIONS(3996),
    [anon_sym_try] = ACTIONS(3996),
    [anon_sym_match] = ACTIONS(3996),
    [anon_sym_match_BANG] = ACTIONS(3994),
    [anon_sym_function] = ACTIONS(3996),
    [anon_sym_LT_DASH] = ACTIONS(3996),
    [anon_sym_DOT_LBRACK] = ACTIONS(3994),
    [anon_sym_LT] = ACTIONS(3994),
    [anon_sym_use] = ACTIONS(3996),
    [anon_sym_use_BANG] = ACTIONS(3994),
    [anon_sym_do_BANG] = ACTIONS(3994),
    [anon_sym_begin] = ACTIONS(3996),
    [anon_sym_LPAREN2] = ACTIONS(3996),
    [anon_sym_default] = ACTIONS(3996),
    [anon_sym_or] = ACTIONS(3996),
    [anon_sym_static] = ACTIONS(3996),
    [anon_sym_member] = ACTIONS(3996),
    [anon_sym_interface] = ACTIONS(3996),
    [anon_sym_abstract] = ACTIONS(3996),
    [anon_sym_val] = ACTIONS(3996),
    [anon_sym_override] = ACTIONS(3996),
    [anon_sym_inherit] = ACTIONS(3996),
    [aux_sym_char_token1] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3996),
    [anon_sym_DQUOTE] = ACTIONS(3996),
    [anon_sym_AT_DQUOTE] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [sym_bool] = ACTIONS(3996),
    [sym_unit] = ACTIONS(3994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3996),
    [sym_op_identifier] = ACTIONS(3996),
    [anon_sym_PLUS] = ACTIONS(3996),
    [anon_sym_DASH] = ACTIONS(3996),
    [anon_sym_PLUS_DOT] = ACTIONS(3996),
    [anon_sym_DASH_DOT] = ACTIONS(3996),
    [anon_sym_PERCENT] = ACTIONS(3996),
    [anon_sym_AMP_AMP] = ACTIONS(3996),
    [anon_sym_TILDE] = ACTIONS(3994),
    [aux_sym_prefix_op_token1] = ACTIONS(3996),
    [aux_sym_infix_op_token1] = ACTIONS(3994),
    [aux_sym_infix_op_token2] = ACTIONS(3996),
    [anon_sym_PIPE_PIPE] = ACTIONS(3996),
    [anon_sym_BANG_EQ] = ACTIONS(3996),
    [anon_sym_COLON_EQ] = ACTIONS(3994),
    [anon_sym_DOLLAR] = ACTIONS(3996),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3996),
    [sym_int] = ACTIONS(3996),
    [sym_xint] = ACTIONS(3994),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3994),
    [anon_sym_POUNDendif] = ACTIONS(3994),
    [sym__newline] = ACTIONS(3994),
  },
  [2084] = {
    [sym_block_comment] = STATE(2084),
    [sym_compiler_directive_decl] = STATE(2084),
    [sym_fsi_directive_decl] = STATE(2084),
    [sym_preproc_line] = STATE(2084),
    [sym_identifier] = ACTIONS(4186),
    [anon_sym_EQ] = ACTIONS(4184),
    [anon_sym_LBRACK_LT] = ACTIONS(4184),
    [anon_sym_COLON] = ACTIONS(4186),
    [anon_sym_return] = ACTIONS(4186),
    [anon_sym_do] = ACTIONS(4186),
    [anon_sym_and] = ACTIONS(4186),
    [anon_sym_let] = ACTIONS(4186),
    [anon_sym_let_BANG] = ACTIONS(4184),
    [aux_sym_access_modifier_token1] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_COMMA] = ACTIONS(4184),
    [anon_sym_null] = ACTIONS(4186),
    [anon_sym_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_COLON] = ACTIONS(4184),
    [anon_sym_AMP] = ACTIONS(4186),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4184),
    [anon_sym_LBRACE] = ACTIONS(4186),
    [anon_sym_LT_AT] = ACTIONS(4186),
    [anon_sym_LT_AT_AT] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4186),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4184),
    [anon_sym_new] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4186),
    [anon_sym_return_BANG] = ACTIONS(4184),
    [anon_sym_yield] = ACTIONS(4186),
    [anon_sym_yield_BANG] = ACTIONS(4184),
    [anon_sym_lazy] = ACTIONS(4186),
    [anon_sym_assert] = ACTIONS(4186),
    [anon_sym_upcast] = ACTIONS(4186),
    [anon_sym_downcast] = ACTIONS(4186),
    [anon_sym_COLON_GT] = ACTIONS(4184),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4184),
    [anon_sym_for] = ACTIONS(4186),
    [anon_sym_while] = ACTIONS(4186),
    [anon_sym_if] = ACTIONS(4186),
    [anon_sym_fun] = ACTIONS(4186),
    [anon_sym_try] = ACTIONS(4186),
    [anon_sym_match] = ACTIONS(4186),
    [anon_sym_match_BANG] = ACTIONS(4184),
    [anon_sym_function] = ACTIONS(4186),
    [anon_sym_LT_DASH] = ACTIONS(4186),
    [anon_sym_DOT_LBRACK] = ACTIONS(4184),
    [anon_sym_LT] = ACTIONS(4184),
    [anon_sym_use] = ACTIONS(4186),
    [anon_sym_use_BANG] = ACTIONS(4184),
    [anon_sym_do_BANG] = ACTIONS(4184),
    [anon_sym_begin] = ACTIONS(4186),
    [anon_sym_LPAREN2] = ACTIONS(4186),
    [anon_sym_default] = ACTIONS(4186),
    [anon_sym_or] = ACTIONS(4186),
    [anon_sym_static] = ACTIONS(4186),
    [anon_sym_member] = ACTIONS(4186),
    [anon_sym_interface] = ACTIONS(4186),
    [anon_sym_abstract] = ACTIONS(4186),
    [anon_sym_val] = ACTIONS(4186),
    [anon_sym_override] = ACTIONS(4186),
    [aux_sym_char_token1] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4186),
    [anon_sym_DQUOTE] = ACTIONS(4186),
    [anon_sym_AT_DQUOTE] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [sym_bool] = ACTIONS(4186),
    [sym_unit] = ACTIONS(4184),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4186),
    [sym_op_identifier] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4186),
    [anon_sym_DASH] = ACTIONS(4186),
    [anon_sym_PLUS_DOT] = ACTIONS(4186),
    [anon_sym_DASH_DOT] = ACTIONS(4186),
    [anon_sym_PERCENT] = ACTIONS(4186),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_TILDE] = ACTIONS(4184),
    [aux_sym_prefix_op_token1] = ACTIONS(4186),
    [aux_sym_infix_op_token1] = ACTIONS(4184),
    [aux_sym_infix_op_token2] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_COLON_EQ] = ACTIONS(4184),
    [anon_sym_DOLLAR] = ACTIONS(4186),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4186),
    [sym_int] = ACTIONS(4186),
    [sym_xint] = ACTIONS(4184),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4184),
    [anon_sym_POUNDendif] = ACTIONS(4184),
    [sym__newline] = ACTIONS(4184),
  },
  [2085] = {
    [sym_block_comment] = STATE(2085),
    [sym_compiler_directive_decl] = STATE(2085),
    [sym_fsi_directive_decl] = STATE(2085),
    [sym_preproc_line] = STATE(2085),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LBRACK_LT] = ACTIONS(4080),
    [anon_sym_COLON] = ACTIONS(4082),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_do] = ACTIONS(4082),
    [anon_sym_and] = ACTIONS(4082),
    [anon_sym_let] = ACTIONS(4082),
    [anon_sym_let_BANG] = ACTIONS(4080),
    [aux_sym_access_modifier_token1] = ACTIONS(4080),
    [anon_sym_LPAREN] = ACTIONS(4082),
    [anon_sym_COMMA] = ACTIONS(4080),
    [anon_sym_null] = ACTIONS(4082),
    [anon_sym_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_COLON] = ACTIONS(4080),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_LBRACK] = ACTIONS(4082),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(4082),
    [anon_sym_LT_AT] = ACTIONS(4082),
    [anon_sym_LT_AT_AT] = ACTIONS(4082),
    [anon_sym_DOT] = ACTIONS(4082),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4080),
    [anon_sym_new] = ACTIONS(4082),
    [anon_sym_with] = ACTIONS(4082),
    [anon_sym_return_BANG] = ACTIONS(4080),
    [anon_sym_yield] = ACTIONS(4082),
    [anon_sym_yield_BANG] = ACTIONS(4080),
    [anon_sym_lazy] = ACTIONS(4082),
    [anon_sym_assert] = ACTIONS(4082),
    [anon_sym_upcast] = ACTIONS(4082),
    [anon_sym_downcast] = ACTIONS(4082),
    [anon_sym_COLON_GT] = ACTIONS(4080),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4080),
    [anon_sym_for] = ACTIONS(4082),
    [anon_sym_while] = ACTIONS(4082),
    [anon_sym_if] = ACTIONS(4082),
    [anon_sym_fun] = ACTIONS(4082),
    [anon_sym_try] = ACTIONS(4082),
    [anon_sym_match] = ACTIONS(4082),
    [anon_sym_match_BANG] = ACTIONS(4080),
    [anon_sym_function] = ACTIONS(4082),
    [anon_sym_LT_DASH] = ACTIONS(4082),
    [anon_sym_DOT_LBRACK] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(4080),
    [anon_sym_use] = ACTIONS(4082),
    [anon_sym_use_BANG] = ACTIONS(4080),
    [anon_sym_do_BANG] = ACTIONS(4080),
    [anon_sym_begin] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4082),
    [anon_sym_default] = ACTIONS(4082),
    [anon_sym_or] = ACTIONS(4082),
    [anon_sym_static] = ACTIONS(4082),
    [anon_sym_member] = ACTIONS(4082),
    [anon_sym_interface] = ACTIONS(4082),
    [anon_sym_abstract] = ACTIONS(4082),
    [anon_sym_val] = ACTIONS(4082),
    [anon_sym_override] = ACTIONS(4082),
    [aux_sym_char_token1] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4082),
    [anon_sym_DQUOTE] = ACTIONS(4082),
    [anon_sym_AT_DQUOTE] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [sym_bool] = ACTIONS(4082),
    [sym_unit] = ACTIONS(4080),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4082),
    [sym_op_identifier] = ACTIONS(4082),
    [anon_sym_PLUS] = ACTIONS(4082),
    [anon_sym_DASH] = ACTIONS(4082),
    [anon_sym_PLUS_DOT] = ACTIONS(4082),
    [anon_sym_DASH_DOT] = ACTIONS(4082),
    [anon_sym_PERCENT] = ACTIONS(4082),
    [anon_sym_AMP_AMP] = ACTIONS(4082),
    [anon_sym_TILDE] = ACTIONS(4080),
    [aux_sym_prefix_op_token1] = ACTIONS(4082),
    [aux_sym_infix_op_token1] = ACTIONS(4080),
    [aux_sym_infix_op_token2] = ACTIONS(4082),
    [anon_sym_PIPE_PIPE] = ACTIONS(4082),
    [anon_sym_BANG_EQ] = ACTIONS(4082),
    [anon_sym_COLON_EQ] = ACTIONS(4080),
    [anon_sym_DOLLAR] = ACTIONS(4082),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4082),
    [sym_int] = ACTIONS(4082),
    [sym_xint] = ACTIONS(4080),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4080),
    [anon_sym_POUNDendif] = ACTIONS(4080),
    [sym__newline] = ACTIONS(4080),
  },
  [2086] = {
    [sym_block_comment] = STATE(2086),
    [sym_compiler_directive_decl] = STATE(2086),
    [sym_fsi_directive_decl] = STATE(2086),
    [sym_preproc_line] = STATE(2086),
    [sym_identifier] = ACTIONS(4208),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LBRACK_LT] = ACTIONS(4206),
    [anon_sym_COLON] = ACTIONS(4208),
    [anon_sym_return] = ACTIONS(4208),
    [anon_sym_do] = ACTIONS(4208),
    [anon_sym_and] = ACTIONS(4208),
    [anon_sym_let] = ACTIONS(4208),
    [anon_sym_let_BANG] = ACTIONS(4206),
    [aux_sym_access_modifier_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(4206),
    [anon_sym_null] = ACTIONS(4208),
    [anon_sym_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_COLON] = ACTIONS(4206),
    [anon_sym_AMP] = ACTIONS(4208),
    [anon_sym_LBRACK] = ACTIONS(4208),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4206),
    [anon_sym_LBRACE] = ACTIONS(4208),
    [anon_sym_LT_AT] = ACTIONS(4208),
    [anon_sym_LT_AT_AT] = ACTIONS(4208),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4206),
    [anon_sym_new] = ACTIONS(4208),
    [anon_sym_with] = ACTIONS(4208),
    [anon_sym_return_BANG] = ACTIONS(4206),
    [anon_sym_yield] = ACTIONS(4208),
    [anon_sym_yield_BANG] = ACTIONS(4206),
    [anon_sym_lazy] = ACTIONS(4208),
    [anon_sym_assert] = ACTIONS(4208),
    [anon_sym_upcast] = ACTIONS(4208),
    [anon_sym_downcast] = ACTIONS(4208),
    [anon_sym_COLON_GT] = ACTIONS(4206),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4206),
    [anon_sym_for] = ACTIONS(4208),
    [anon_sym_while] = ACTIONS(4208),
    [anon_sym_if] = ACTIONS(4208),
    [anon_sym_fun] = ACTIONS(4208),
    [anon_sym_try] = ACTIONS(4208),
    [anon_sym_match] = ACTIONS(4208),
    [anon_sym_match_BANG] = ACTIONS(4206),
    [anon_sym_function] = ACTIONS(4208),
    [anon_sym_LT_DASH] = ACTIONS(4208),
    [anon_sym_DOT_LBRACK] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(4206),
    [anon_sym_use] = ACTIONS(4208),
    [anon_sym_use_BANG] = ACTIONS(4206),
    [anon_sym_do_BANG] = ACTIONS(4206),
    [anon_sym_begin] = ACTIONS(4208),
    [anon_sym_LPAREN2] = ACTIONS(4208),
    [anon_sym_default] = ACTIONS(4208),
    [anon_sym_or] = ACTIONS(4208),
    [anon_sym_static] = ACTIONS(4208),
    [anon_sym_member] = ACTIONS(4208),
    [anon_sym_interface] = ACTIONS(4208),
    [anon_sym_abstract] = ACTIONS(4208),
    [anon_sym_val] = ACTIONS(4208),
    [anon_sym_override] = ACTIONS(4208),
    [aux_sym_char_token1] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4208),
    [anon_sym_DQUOTE] = ACTIONS(4208),
    [anon_sym_AT_DQUOTE] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [sym_bool] = ACTIONS(4208),
    [sym_unit] = ACTIONS(4206),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4208),
    [sym_op_identifier] = ACTIONS(4208),
    [anon_sym_PLUS] = ACTIONS(4208),
    [anon_sym_DASH] = ACTIONS(4208),
    [anon_sym_PLUS_DOT] = ACTIONS(4208),
    [anon_sym_DASH_DOT] = ACTIONS(4208),
    [anon_sym_PERCENT] = ACTIONS(4208),
    [anon_sym_AMP_AMP] = ACTIONS(4208),
    [anon_sym_TILDE] = ACTIONS(4206),
    [aux_sym_prefix_op_token1] = ACTIONS(4208),
    [aux_sym_infix_op_token1] = ACTIONS(4206),
    [aux_sym_infix_op_token2] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(4208),
    [anon_sym_BANG_EQ] = ACTIONS(4208),
    [anon_sym_COLON_EQ] = ACTIONS(4206),
    [anon_sym_DOLLAR] = ACTIONS(4208),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4208),
    [sym_int] = ACTIONS(4208),
    [sym_xint] = ACTIONS(4206),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4206),
    [anon_sym_POUNDendif] = ACTIONS(4206),
    [sym__newline] = ACTIONS(4206),
  },
  [2087] = {
    [sym_block_comment] = STATE(2087),
    [sym_compiler_directive_decl] = STATE(2087),
    [sym_fsi_directive_decl] = STATE(2087),
    [sym_preproc_line] = STATE(2087),
    [sym_identifier] = ACTIONS(3907),
    [anon_sym_EQ] = ACTIONS(3905),
    [anon_sym_LBRACK_LT] = ACTIONS(3905),
    [anon_sym_COLON] = ACTIONS(3907),
    [anon_sym_return] = ACTIONS(3907),
    [anon_sym_do] = ACTIONS(3907),
    [anon_sym_let] = ACTIONS(3907),
    [anon_sym_let_BANG] = ACTIONS(3905),
    [aux_sym_access_modifier_token1] = ACTIONS(3905),
    [anon_sym_LPAREN] = ACTIONS(3907),
    [anon_sym_COMMA] = ACTIONS(3905),
    [anon_sym_null] = ACTIONS(3907),
    [anon_sym_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_COLON] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3907),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3905),
    [anon_sym_LBRACE] = ACTIONS(3907),
    [anon_sym_LT_AT] = ACTIONS(3907),
    [anon_sym_LT_AT_AT] = ACTIONS(3907),
    [anon_sym_DOT] = ACTIONS(3907),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3905),
    [anon_sym_new] = ACTIONS(3907),
    [anon_sym_with] = ACTIONS(3907),
    [anon_sym_return_BANG] = ACTIONS(3905),
    [anon_sym_yield] = ACTIONS(3907),
    [anon_sym_yield_BANG] = ACTIONS(3905),
    [anon_sym_lazy] = ACTIONS(3907),
    [anon_sym_assert] = ACTIONS(3907),
    [anon_sym_upcast] = ACTIONS(3907),
    [anon_sym_downcast] = ACTIONS(3907),
    [anon_sym_COLON_GT] = ACTIONS(3905),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3905),
    [anon_sym_for] = ACTIONS(3907),
    [anon_sym_while] = ACTIONS(3907),
    [anon_sym_if] = ACTIONS(3907),
    [anon_sym_fun] = ACTIONS(3907),
    [anon_sym_try] = ACTIONS(3907),
    [anon_sym_match] = ACTIONS(3907),
    [anon_sym_match_BANG] = ACTIONS(3905),
    [anon_sym_function] = ACTIONS(3907),
    [anon_sym_LT_DASH] = ACTIONS(3907),
    [anon_sym_DOT_LBRACK] = ACTIONS(3905),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_use] = ACTIONS(3907),
    [anon_sym_use_BANG] = ACTIONS(3905),
    [anon_sym_do_BANG] = ACTIONS(3905),
    [anon_sym_begin] = ACTIONS(3907),
    [anon_sym_LPAREN2] = ACTIONS(3907),
    [anon_sym_DOT_DOT2] = ACTIONS(3905),
    [anon_sym_default] = ACTIONS(3907),
    [anon_sym_or] = ACTIONS(3907),
    [anon_sym_static] = ACTIONS(3907),
    [anon_sym_member] = ACTIONS(3907),
    [anon_sym_interface] = ACTIONS(3907),
    [anon_sym_abstract] = ACTIONS(3907),
    [anon_sym_val] = ACTIONS(3907),
    [anon_sym_override] = ACTIONS(3907),
    [aux_sym_char_token1] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3907),
    [anon_sym_DQUOTE] = ACTIONS(3907),
    [anon_sym_AT_DQUOTE] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [sym_bool] = ACTIONS(3907),
    [sym_unit] = ACTIONS(3905),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3907),
    [sym_op_identifier] = ACTIONS(3907),
    [anon_sym_PLUS] = ACTIONS(3907),
    [anon_sym_DASH] = ACTIONS(3907),
    [anon_sym_PLUS_DOT] = ACTIONS(3907),
    [anon_sym_DASH_DOT] = ACTIONS(3907),
    [anon_sym_PERCENT] = ACTIONS(3907),
    [anon_sym_AMP_AMP] = ACTIONS(3907),
    [anon_sym_TILDE] = ACTIONS(3905),
    [aux_sym_prefix_op_token1] = ACTIONS(3907),
    [aux_sym_infix_op_token1] = ACTIONS(3905),
    [aux_sym_infix_op_token2] = ACTIONS(3907),
    [anon_sym_PIPE_PIPE] = ACTIONS(3907),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_COLON_EQ] = ACTIONS(3905),
    [anon_sym_DOLLAR] = ACTIONS(3907),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3907),
    [sym_int] = ACTIONS(3907),
    [sym_xint] = ACTIONS(3905),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3905),
    [sym__newline] = ACTIONS(3905),
    [sym__dedent] = ACTIONS(3905),
  },
  [2088] = {
    [sym_block_comment] = STATE(2088),
    [sym_compiler_directive_decl] = STATE(2088),
    [sym_fsi_directive_decl] = STATE(2088),
    [sym_preproc_line] = STATE(2088),
    [sym_identifier] = ACTIONS(3900),
    [anon_sym_EQ] = ACTIONS(3898),
    [anon_sym_LBRACK_LT] = ACTIONS(3898),
    [anon_sym_COLON] = ACTIONS(3900),
    [anon_sym_return] = ACTIONS(3900),
    [anon_sym_do] = ACTIONS(3900),
    [anon_sym_let] = ACTIONS(3900),
    [anon_sym_let_BANG] = ACTIONS(3898),
    [aux_sym_access_modifier_token1] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3898),
    [anon_sym_null] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_COLON] = ACTIONS(3898),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_LBRACK] = ACTIONS(3900),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3898),
    [anon_sym_LBRACE] = ACTIONS(3900),
    [anon_sym_LT_AT] = ACTIONS(3900),
    [anon_sym_LT_AT_AT] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(3900),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3898),
    [anon_sym_new] = ACTIONS(3900),
    [anon_sym_with] = ACTIONS(3900),
    [anon_sym_return_BANG] = ACTIONS(3898),
    [anon_sym_yield] = ACTIONS(3900),
    [anon_sym_yield_BANG] = ACTIONS(3898),
    [anon_sym_lazy] = ACTIONS(3900),
    [anon_sym_assert] = ACTIONS(3900),
    [anon_sym_upcast] = ACTIONS(3900),
    [anon_sym_downcast] = ACTIONS(3900),
    [anon_sym_COLON_GT] = ACTIONS(3898),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3898),
    [anon_sym_for] = ACTIONS(3900),
    [anon_sym_while] = ACTIONS(3900),
    [anon_sym_if] = ACTIONS(3900),
    [anon_sym_fun] = ACTIONS(3900),
    [anon_sym_try] = ACTIONS(3900),
    [anon_sym_match] = ACTIONS(3900),
    [anon_sym_match_BANG] = ACTIONS(3898),
    [anon_sym_function] = ACTIONS(3900),
    [anon_sym_LT_DASH] = ACTIONS(3900),
    [anon_sym_DOT_LBRACK] = ACTIONS(3898),
    [anon_sym_LT] = ACTIONS(3898),
    [anon_sym_use] = ACTIONS(3900),
    [anon_sym_use_BANG] = ACTIONS(3898),
    [anon_sym_do_BANG] = ACTIONS(3898),
    [anon_sym_begin] = ACTIONS(3900),
    [anon_sym_LPAREN2] = ACTIONS(3900),
    [anon_sym_DOT_DOT2] = ACTIONS(3898),
    [anon_sym_default] = ACTIONS(3900),
    [anon_sym_or] = ACTIONS(3900),
    [anon_sym_static] = ACTIONS(3900),
    [anon_sym_member] = ACTIONS(3900),
    [anon_sym_interface] = ACTIONS(3900),
    [anon_sym_abstract] = ACTIONS(3900),
    [anon_sym_val] = ACTIONS(3900),
    [anon_sym_override] = ACTIONS(3900),
    [aux_sym_char_token1] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3900),
    [anon_sym_DQUOTE] = ACTIONS(3900),
    [anon_sym_AT_DQUOTE] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3898),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3900),
    [sym_op_identifier] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(3900),
    [anon_sym_DASH] = ACTIONS(3900),
    [anon_sym_PLUS_DOT] = ACTIONS(3900),
    [anon_sym_DASH_DOT] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(3900),
    [anon_sym_AMP_AMP] = ACTIONS(3900),
    [anon_sym_TILDE] = ACTIONS(3898),
    [aux_sym_prefix_op_token1] = ACTIONS(3900),
    [aux_sym_infix_op_token1] = ACTIONS(3898),
    [aux_sym_infix_op_token2] = ACTIONS(3900),
    [anon_sym_PIPE_PIPE] = ACTIONS(3900),
    [anon_sym_BANG_EQ] = ACTIONS(3900),
    [anon_sym_COLON_EQ] = ACTIONS(3898),
    [anon_sym_DOLLAR] = ACTIONS(3900),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3900),
    [sym_int] = ACTIONS(3900),
    [sym_xint] = ACTIONS(3898),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3898),
    [sym__newline] = ACTIONS(3898),
    [sym__dedent] = ACTIONS(3898),
  },
  [2089] = {
    [sym_block_comment] = STATE(2089),
    [sym_compiler_directive_decl] = STATE(2089),
    [sym_fsi_directive_decl] = STATE(2089),
    [sym_preproc_line] = STATE(2089),
    [sym_identifier] = ACTIONS(4174),
    [anon_sym_EQ] = ACTIONS(4172),
    [anon_sym_LBRACK_LT] = ACTIONS(4172),
    [anon_sym_COLON] = ACTIONS(4174),
    [anon_sym_return] = ACTIONS(4174),
    [anon_sym_do] = ACTIONS(4174),
    [anon_sym_let] = ACTIONS(4174),
    [anon_sym_let_BANG] = ACTIONS(4172),
    [aux_sym_access_modifier_token1] = ACTIONS(4172),
    [anon_sym_LPAREN] = ACTIONS(4174),
    [anon_sym_COMMA] = ACTIONS(4172),
    [anon_sym_null] = ACTIONS(4174),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_COLON] = ACTIONS(4172),
    [anon_sym_AMP] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4174),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4172),
    [anon_sym_LBRACE] = ACTIONS(4174),
    [anon_sym_LT_AT] = ACTIONS(4174),
    [anon_sym_LT_AT_AT] = ACTIONS(4174),
    [anon_sym_DOT] = ACTIONS(4174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4172),
    [anon_sym_new] = ACTIONS(4174),
    [anon_sym_with] = ACTIONS(4174),
    [anon_sym_return_BANG] = ACTIONS(4172),
    [anon_sym_yield] = ACTIONS(4174),
    [anon_sym_yield_BANG] = ACTIONS(4172),
    [anon_sym_lazy] = ACTIONS(4174),
    [anon_sym_assert] = ACTIONS(4174),
    [anon_sym_upcast] = ACTIONS(4174),
    [anon_sym_downcast] = ACTIONS(4174),
    [anon_sym_COLON_GT] = ACTIONS(4172),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4172),
    [anon_sym_for] = ACTIONS(4174),
    [anon_sym_while] = ACTIONS(4174),
    [anon_sym_if] = ACTIONS(4174),
    [anon_sym_fun] = ACTIONS(4174),
    [anon_sym_try] = ACTIONS(4174),
    [anon_sym_match] = ACTIONS(4174),
    [anon_sym_match_BANG] = ACTIONS(4172),
    [anon_sym_function] = ACTIONS(4174),
    [anon_sym_LT_DASH] = ACTIONS(4174),
    [anon_sym_DOT_LBRACK] = ACTIONS(4172),
    [anon_sym_LT] = ACTIONS(4172),
    [anon_sym_use] = ACTIONS(4174),
    [anon_sym_use_BANG] = ACTIONS(4172),
    [anon_sym_do_BANG] = ACTIONS(4172),
    [anon_sym_begin] = ACTIONS(4174),
    [anon_sym_LPAREN2] = ACTIONS(4174),
    [anon_sym_default] = ACTIONS(4174),
    [anon_sym_or] = ACTIONS(4174),
    [anon_sym_static] = ACTIONS(4174),
    [anon_sym_member] = ACTIONS(4174),
    [anon_sym_interface] = ACTIONS(4174),
    [anon_sym_abstract] = ACTIONS(4174),
    [anon_sym_val] = ACTIONS(4174),
    [anon_sym_override] = ACTIONS(4174),
    [anon_sym_inherit] = ACTIONS(4174),
    [aux_sym_char_token1] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4174),
    [anon_sym_DQUOTE] = ACTIONS(4174),
    [anon_sym_AT_DQUOTE] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [sym_bool] = ACTIONS(4174),
    [sym_unit] = ACTIONS(4172),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4174),
    [sym_op_identifier] = ACTIONS(4174),
    [anon_sym_PLUS] = ACTIONS(4174),
    [anon_sym_DASH] = ACTIONS(4174),
    [anon_sym_PLUS_DOT] = ACTIONS(4174),
    [anon_sym_DASH_DOT] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [anon_sym_AMP_AMP] = ACTIONS(4174),
    [anon_sym_TILDE] = ACTIONS(4172),
    [aux_sym_prefix_op_token1] = ACTIONS(4174),
    [aux_sym_infix_op_token1] = ACTIONS(4172),
    [aux_sym_infix_op_token2] = ACTIONS(4174),
    [anon_sym_PIPE_PIPE] = ACTIONS(4174),
    [anon_sym_BANG_EQ] = ACTIONS(4174),
    [anon_sym_COLON_EQ] = ACTIONS(4172),
    [anon_sym_DOLLAR] = ACTIONS(4174),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4174),
    [sym_int] = ACTIONS(4174),
    [sym_xint] = ACTIONS(4172),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4172),
    [anon_sym_POUNDendif] = ACTIONS(4172),
    [sym__newline] = ACTIONS(4172),
  },
  [2090] = {
    [sym_block_comment] = STATE(2090),
    [sym_compiler_directive_decl] = STATE(2090),
    [sym_fsi_directive_decl] = STATE(2090),
    [sym_preproc_line] = STATE(2090),
    [sym_identifier] = ACTIONS(4180),
    [anon_sym_EQ] = ACTIONS(4178),
    [anon_sym_LBRACK_LT] = ACTIONS(4178),
    [anon_sym_COLON] = ACTIONS(4180),
    [anon_sym_return] = ACTIONS(4180),
    [anon_sym_do] = ACTIONS(4180),
    [anon_sym_let] = ACTIONS(4180),
    [anon_sym_let_BANG] = ACTIONS(4178),
    [aux_sym_access_modifier_token1] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(4180),
    [anon_sym_COMMA] = ACTIONS(4178),
    [anon_sym_null] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_COLON] = ACTIONS(4178),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4180),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4180),
    [anon_sym_LT_AT] = ACTIONS(4180),
    [anon_sym_LT_AT_AT] = ACTIONS(4180),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4178),
    [anon_sym_new] = ACTIONS(4180),
    [anon_sym_with] = ACTIONS(4180),
    [anon_sym_return_BANG] = ACTIONS(4178),
    [anon_sym_yield] = ACTIONS(4180),
    [anon_sym_yield_BANG] = ACTIONS(4178),
    [anon_sym_lazy] = ACTIONS(4180),
    [anon_sym_assert] = ACTIONS(4180),
    [anon_sym_upcast] = ACTIONS(4180),
    [anon_sym_downcast] = ACTIONS(4180),
    [anon_sym_COLON_GT] = ACTIONS(4178),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4178),
    [anon_sym_for] = ACTIONS(4180),
    [anon_sym_while] = ACTIONS(4180),
    [anon_sym_if] = ACTIONS(4180),
    [anon_sym_fun] = ACTIONS(4180),
    [anon_sym_try] = ACTIONS(4180),
    [anon_sym_match] = ACTIONS(4180),
    [anon_sym_match_BANG] = ACTIONS(4178),
    [anon_sym_function] = ACTIONS(4180),
    [anon_sym_LT_DASH] = ACTIONS(4180),
    [anon_sym_DOT_LBRACK] = ACTIONS(4178),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_use] = ACTIONS(4180),
    [anon_sym_use_BANG] = ACTIONS(4178),
    [anon_sym_do_BANG] = ACTIONS(4178),
    [anon_sym_begin] = ACTIONS(4180),
    [anon_sym_LPAREN2] = ACTIONS(4180),
    [anon_sym_default] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [anon_sym_static] = ACTIONS(4180),
    [anon_sym_member] = ACTIONS(4180),
    [anon_sym_interface] = ACTIONS(4180),
    [anon_sym_abstract] = ACTIONS(4180),
    [anon_sym_val] = ACTIONS(4180),
    [anon_sym_override] = ACTIONS(4180),
    [anon_sym_inherit] = ACTIONS(4180),
    [aux_sym_char_token1] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4180),
    [anon_sym_DQUOTE] = ACTIONS(4180),
    [anon_sym_AT_DQUOTE] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [sym_bool] = ACTIONS(4180),
    [sym_unit] = ACTIONS(4178),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4180),
    [sym_op_identifier] = ACTIONS(4180),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_PLUS_DOT] = ACTIONS(4180),
    [anon_sym_DASH_DOT] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_TILDE] = ACTIONS(4178),
    [aux_sym_prefix_op_token1] = ACTIONS(4180),
    [aux_sym_infix_op_token1] = ACTIONS(4178),
    [aux_sym_infix_op_token2] = ACTIONS(4180),
    [anon_sym_PIPE_PIPE] = ACTIONS(4180),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_COLON_EQ] = ACTIONS(4178),
    [anon_sym_DOLLAR] = ACTIONS(4180),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4180),
    [sym_int] = ACTIONS(4180),
    [sym_xint] = ACTIONS(4178),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4178),
    [anon_sym_POUNDendif] = ACTIONS(4178),
    [sym__newline] = ACTIONS(4178),
  },
  [2091] = {
    [sym_block_comment] = STATE(2091),
    [sym_compiler_directive_decl] = STATE(2091),
    [sym_fsi_directive_decl] = STATE(2091),
    [sym_preproc_line] = STATE(2091),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_EQ] = ACTIONS(4001),
    [anon_sym_LBRACK_LT] = ACTIONS(4001),
    [anon_sym_COLON] = ACTIONS(4003),
    [anon_sym_return] = ACTIONS(4003),
    [anon_sym_do] = ACTIONS(4003),
    [anon_sym_let] = ACTIONS(4003),
    [anon_sym_let_BANG] = ACTIONS(4001),
    [aux_sym_access_modifier_token1] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4003),
    [anon_sym_COMMA] = ACTIONS(4001),
    [anon_sym_null] = ACTIONS(4003),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_COLON] = ACTIONS(4001),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LBRACK] = ACTIONS(4003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4001),
    [anon_sym_LBRACE] = ACTIONS(4003),
    [anon_sym_LT_AT] = ACTIONS(4003),
    [anon_sym_LT_AT_AT] = ACTIONS(4003),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4001),
    [anon_sym_new] = ACTIONS(4003),
    [anon_sym_with] = ACTIONS(4003),
    [anon_sym_return_BANG] = ACTIONS(4001),
    [anon_sym_yield] = ACTIONS(4003),
    [anon_sym_yield_BANG] = ACTIONS(4001),
    [anon_sym_lazy] = ACTIONS(4003),
    [anon_sym_assert] = ACTIONS(4003),
    [anon_sym_upcast] = ACTIONS(4003),
    [anon_sym_downcast] = ACTIONS(4003),
    [anon_sym_COLON_GT] = ACTIONS(4001),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4001),
    [anon_sym_for] = ACTIONS(4003),
    [anon_sym_while] = ACTIONS(4003),
    [anon_sym_if] = ACTIONS(4003),
    [anon_sym_fun] = ACTIONS(4003),
    [anon_sym_try] = ACTIONS(4003),
    [anon_sym_match] = ACTIONS(4003),
    [anon_sym_match_BANG] = ACTIONS(4001),
    [anon_sym_function] = ACTIONS(4003),
    [anon_sym_LT_DASH] = ACTIONS(4003),
    [anon_sym_DOT_LBRACK] = ACTIONS(4001),
    [anon_sym_LT] = ACTIONS(4001),
    [anon_sym_use] = ACTIONS(4003),
    [anon_sym_use_BANG] = ACTIONS(4001),
    [anon_sym_do_BANG] = ACTIONS(4001),
    [anon_sym_begin] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4003),
    [anon_sym_default] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [anon_sym_static] = ACTIONS(4003),
    [anon_sym_member] = ACTIONS(4003),
    [anon_sym_interface] = ACTIONS(4003),
    [anon_sym_abstract] = ACTIONS(4003),
    [anon_sym_val] = ACTIONS(4003),
    [anon_sym_override] = ACTIONS(4003),
    [anon_sym_inherit] = ACTIONS(4003),
    [aux_sym_char_token1] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4003),
    [anon_sym_DQUOTE] = ACTIONS(4003),
    [anon_sym_AT_DQUOTE] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [sym_bool] = ACTIONS(4003),
    [sym_unit] = ACTIONS(4001),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4003),
    [sym_op_identifier] = ACTIONS(4003),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_PLUS_DOT] = ACTIONS(4003),
    [anon_sym_DASH_DOT] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4003),
    [anon_sym_TILDE] = ACTIONS(4001),
    [aux_sym_prefix_op_token1] = ACTIONS(4003),
    [aux_sym_infix_op_token1] = ACTIONS(4001),
    [aux_sym_infix_op_token2] = ACTIONS(4003),
    [anon_sym_PIPE_PIPE] = ACTIONS(4003),
    [anon_sym_BANG_EQ] = ACTIONS(4003),
    [anon_sym_COLON_EQ] = ACTIONS(4001),
    [anon_sym_DOLLAR] = ACTIONS(4003),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4003),
    [sym_int] = ACTIONS(4003),
    [sym_xint] = ACTIONS(4001),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4001),
    [anon_sym_POUNDendif] = ACTIONS(4001),
    [sym__newline] = ACTIONS(4001),
  },
  [2092] = {
    [sym_block_comment] = STATE(2092),
    [sym_compiler_directive_decl] = STATE(2092),
    [sym_fsi_directive_decl] = STATE(2092),
    [sym_preproc_line] = STATE(2092),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_EQ] = ACTIONS(4199),
    [anon_sym_LBRACK_LT] = ACTIONS(4199),
    [anon_sym_COLON] = ACTIONS(4201),
    [anon_sym_return] = ACTIONS(4201),
    [anon_sym_do] = ACTIONS(4201),
    [anon_sym_and] = ACTIONS(4201),
    [anon_sym_let] = ACTIONS(4201),
    [anon_sym_let_BANG] = ACTIONS(4199),
    [aux_sym_access_modifier_token1] = ACTIONS(4199),
    [anon_sym_LPAREN] = ACTIONS(4201),
    [anon_sym_COMMA] = ACTIONS(4199),
    [anon_sym_null] = ACTIONS(4201),
    [anon_sym_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(4199),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_LBRACK] = ACTIONS(4201),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4199),
    [anon_sym_LBRACE] = ACTIONS(4201),
    [anon_sym_LT_AT] = ACTIONS(4201),
    [anon_sym_LT_AT_AT] = ACTIONS(4201),
    [anon_sym_DOT] = ACTIONS(4201),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4199),
    [anon_sym_new] = ACTIONS(4201),
    [anon_sym_with] = ACTIONS(4201),
    [anon_sym_return_BANG] = ACTIONS(4199),
    [anon_sym_yield] = ACTIONS(4201),
    [anon_sym_yield_BANG] = ACTIONS(4199),
    [anon_sym_lazy] = ACTIONS(4201),
    [anon_sym_assert] = ACTIONS(4201),
    [anon_sym_upcast] = ACTIONS(4201),
    [anon_sym_downcast] = ACTIONS(4201),
    [anon_sym_COLON_GT] = ACTIONS(4199),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4199),
    [anon_sym_for] = ACTIONS(4201),
    [anon_sym_while] = ACTIONS(4201),
    [anon_sym_if] = ACTIONS(4201),
    [anon_sym_fun] = ACTIONS(4201),
    [anon_sym_try] = ACTIONS(4201),
    [anon_sym_match] = ACTIONS(4201),
    [anon_sym_match_BANG] = ACTIONS(4199),
    [anon_sym_function] = ACTIONS(4201),
    [anon_sym_LT_DASH] = ACTIONS(4201),
    [anon_sym_DOT_LBRACK] = ACTIONS(4199),
    [anon_sym_LT] = ACTIONS(4199),
    [anon_sym_use] = ACTIONS(4201),
    [anon_sym_use_BANG] = ACTIONS(4199),
    [anon_sym_do_BANG] = ACTIONS(4199),
    [anon_sym_begin] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(4201),
    [anon_sym_default] = ACTIONS(4201),
    [anon_sym_or] = ACTIONS(4201),
    [anon_sym_static] = ACTIONS(4201),
    [anon_sym_member] = ACTIONS(4201),
    [anon_sym_interface] = ACTIONS(4201),
    [anon_sym_abstract] = ACTIONS(4201),
    [anon_sym_val] = ACTIONS(4201),
    [anon_sym_override] = ACTIONS(4201),
    [aux_sym_char_token1] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4201),
    [anon_sym_DQUOTE] = ACTIONS(4201),
    [anon_sym_AT_DQUOTE] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [sym_bool] = ACTIONS(4201),
    [sym_unit] = ACTIONS(4199),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4201),
    [sym_op_identifier] = ACTIONS(4201),
    [anon_sym_PLUS] = ACTIONS(4201),
    [anon_sym_DASH] = ACTIONS(4201),
    [anon_sym_PLUS_DOT] = ACTIONS(4201),
    [anon_sym_DASH_DOT] = ACTIONS(4201),
    [anon_sym_PERCENT] = ACTIONS(4201),
    [anon_sym_AMP_AMP] = ACTIONS(4201),
    [anon_sym_TILDE] = ACTIONS(4199),
    [aux_sym_prefix_op_token1] = ACTIONS(4201),
    [aux_sym_infix_op_token1] = ACTIONS(4199),
    [aux_sym_infix_op_token2] = ACTIONS(4201),
    [anon_sym_PIPE_PIPE] = ACTIONS(4201),
    [anon_sym_BANG_EQ] = ACTIONS(4201),
    [anon_sym_COLON_EQ] = ACTIONS(4199),
    [anon_sym_DOLLAR] = ACTIONS(4201),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4201),
    [sym_int] = ACTIONS(4201),
    [sym_xint] = ACTIONS(4199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4199),
    [sym__newline] = ACTIONS(4199),
    [sym__dedent] = ACTIONS(4199),
  },
  [2093] = {
    [sym_block_comment] = STATE(2093),
    [sym_compiler_directive_decl] = STATE(2093),
    [sym_fsi_directive_decl] = STATE(2093),
    [sym_preproc_line] = STATE(2093),
    [sym_identifier] = ACTIONS(4212),
    [anon_sym_EQ] = ACTIONS(4210),
    [anon_sym_LBRACK_LT] = ACTIONS(4210),
    [anon_sym_COLON] = ACTIONS(4212),
    [anon_sym_return] = ACTIONS(4212),
    [anon_sym_do] = ACTIONS(4212),
    [anon_sym_and] = ACTIONS(4212),
    [anon_sym_let] = ACTIONS(4212),
    [anon_sym_let_BANG] = ACTIONS(4210),
    [aux_sym_access_modifier_token1] = ACTIONS(4210),
    [anon_sym_LPAREN] = ACTIONS(4212),
    [anon_sym_COMMA] = ACTIONS(4210),
    [anon_sym_null] = ACTIONS(4212),
    [anon_sym_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_COLON] = ACTIONS(4210),
    [anon_sym_AMP] = ACTIONS(4212),
    [anon_sym_LBRACK] = ACTIONS(4212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4210),
    [anon_sym_LBRACE] = ACTIONS(4212),
    [anon_sym_LT_AT] = ACTIONS(4212),
    [anon_sym_LT_AT_AT] = ACTIONS(4212),
    [anon_sym_DOT] = ACTIONS(4212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4210),
    [anon_sym_new] = ACTIONS(4212),
    [anon_sym_with] = ACTIONS(4212),
    [anon_sym_return_BANG] = ACTIONS(4210),
    [anon_sym_yield] = ACTIONS(4212),
    [anon_sym_yield_BANG] = ACTIONS(4210),
    [anon_sym_lazy] = ACTIONS(4212),
    [anon_sym_assert] = ACTIONS(4212),
    [anon_sym_upcast] = ACTIONS(4212),
    [anon_sym_downcast] = ACTIONS(4212),
    [anon_sym_COLON_GT] = ACTIONS(4210),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4210),
    [anon_sym_for] = ACTIONS(4212),
    [anon_sym_while] = ACTIONS(4212),
    [anon_sym_if] = ACTIONS(4212),
    [anon_sym_fun] = ACTIONS(4212),
    [anon_sym_try] = ACTIONS(4212),
    [anon_sym_match] = ACTIONS(4212),
    [anon_sym_match_BANG] = ACTIONS(4210),
    [anon_sym_function] = ACTIONS(4212),
    [anon_sym_LT_DASH] = ACTIONS(4212),
    [anon_sym_DOT_LBRACK] = ACTIONS(4210),
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_use] = ACTIONS(4212),
    [anon_sym_use_BANG] = ACTIONS(4210),
    [anon_sym_do_BANG] = ACTIONS(4210),
    [anon_sym_begin] = ACTIONS(4212),
    [anon_sym_LPAREN2] = ACTIONS(4212),
    [anon_sym_default] = ACTIONS(4212),
    [anon_sym_or] = ACTIONS(4212),
    [anon_sym_static] = ACTIONS(4212),
    [anon_sym_member] = ACTIONS(4212),
    [anon_sym_interface] = ACTIONS(4212),
    [anon_sym_abstract] = ACTIONS(4212),
    [anon_sym_val] = ACTIONS(4212),
    [anon_sym_override] = ACTIONS(4212),
    [aux_sym_char_token1] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4212),
    [anon_sym_DQUOTE] = ACTIONS(4212),
    [anon_sym_AT_DQUOTE] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [sym_bool] = ACTIONS(4212),
    [sym_unit] = ACTIONS(4210),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4212),
    [anon_sym_DASH] = ACTIONS(4212),
    [anon_sym_PLUS_DOT] = ACTIONS(4212),
    [anon_sym_DASH_DOT] = ACTIONS(4212),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_AMP_AMP] = ACTIONS(4212),
    [anon_sym_TILDE] = ACTIONS(4210),
    [aux_sym_prefix_op_token1] = ACTIONS(4212),
    [aux_sym_infix_op_token1] = ACTIONS(4210),
    [aux_sym_infix_op_token2] = ACTIONS(4212),
    [anon_sym_PIPE_PIPE] = ACTIONS(4212),
    [anon_sym_BANG_EQ] = ACTIONS(4212),
    [anon_sym_COLON_EQ] = ACTIONS(4210),
    [anon_sym_DOLLAR] = ACTIONS(4212),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4212),
    [sym_int] = ACTIONS(4212),
    [sym_xint] = ACTIONS(4210),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4210),
    [anon_sym_POUNDendif] = ACTIONS(4210),
    [sym__newline] = ACTIONS(4210),
  },
  [2094] = {
    [sym_block_comment] = STATE(2094),
    [sym_compiler_directive_decl] = STATE(2094),
    [sym_fsi_directive_decl] = STATE(2094),
    [sym_preproc_line] = STATE(2094),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3843),
    [anon_sym_LBRACK_LT] = ACTIONS(3843),
    [anon_sym_COLON] = ACTIONS(3845),
    [anon_sym_return] = ACTIONS(3845),
    [anon_sym_do] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_let_BANG] = ACTIONS(3843),
    [aux_sym_access_modifier_token1] = ACTIONS(3843),
    [anon_sym_LPAREN] = ACTIONS(3845),
    [anon_sym_COMMA] = ACTIONS(3843),
    [anon_sym_null] = ACTIONS(3845),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3843),
    [anon_sym_LBRACE] = ACTIONS(3845),
    [anon_sym_LT_AT] = ACTIONS(3845),
    [anon_sym_LT_AT_AT] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3843),
    [anon_sym_new] = ACTIONS(3845),
    [anon_sym_with] = ACTIONS(3845),
    [anon_sym_return_BANG] = ACTIONS(3843),
    [anon_sym_yield] = ACTIONS(3845),
    [anon_sym_yield_BANG] = ACTIONS(3843),
    [anon_sym_lazy] = ACTIONS(3845),
    [anon_sym_assert] = ACTIONS(3845),
    [anon_sym_upcast] = ACTIONS(3845),
    [anon_sym_downcast] = ACTIONS(3845),
    [anon_sym_COLON_GT] = ACTIONS(3843),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3843),
    [anon_sym_for] = ACTIONS(3845),
    [anon_sym_while] = ACTIONS(3845),
    [anon_sym_if] = ACTIONS(3845),
    [anon_sym_fun] = ACTIONS(3845),
    [anon_sym_try] = ACTIONS(3845),
    [anon_sym_match] = ACTIONS(3845),
    [anon_sym_match_BANG] = ACTIONS(3843),
    [anon_sym_function] = ACTIONS(3845),
    [anon_sym_LT_DASH] = ACTIONS(3845),
    [anon_sym_DOT_LBRACK] = ACTIONS(3843),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_use] = ACTIONS(3845),
    [anon_sym_use_BANG] = ACTIONS(3843),
    [anon_sym_do_BANG] = ACTIONS(3843),
    [anon_sym_begin] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(3845),
    [anon_sym_default] = ACTIONS(3845),
    [anon_sym_or] = ACTIONS(3845),
    [anon_sym_static] = ACTIONS(3845),
    [anon_sym_member] = ACTIONS(3845),
    [anon_sym_interface] = ACTIONS(3845),
    [anon_sym_abstract] = ACTIONS(3845),
    [anon_sym_val] = ACTIONS(3845),
    [anon_sym_override] = ACTIONS(3845),
    [anon_sym_inherit] = ACTIONS(3845),
    [aux_sym_char_token1] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3845),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_AT_DQUOTE] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [sym_bool] = ACTIONS(3845),
    [sym_unit] = ACTIONS(3843),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3845),
    [sym_op_identifier] = ACTIONS(3845),
    [anon_sym_PLUS] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_PLUS_DOT] = ACTIONS(3845),
    [anon_sym_DASH_DOT] = ACTIONS(3845),
    [anon_sym_PERCENT] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3845),
    [anon_sym_TILDE] = ACTIONS(3843),
    [aux_sym_prefix_op_token1] = ACTIONS(3845),
    [aux_sym_infix_op_token1] = ACTIONS(3843),
    [aux_sym_infix_op_token2] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(3845),
    [anon_sym_BANG_EQ] = ACTIONS(3845),
    [anon_sym_COLON_EQ] = ACTIONS(3843),
    [anon_sym_DOLLAR] = ACTIONS(3845),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3845),
    [sym_int] = ACTIONS(3845),
    [sym_xint] = ACTIONS(3843),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3843),
    [anon_sym_POUNDendif] = ACTIONS(3843),
    [sym__newline] = ACTIONS(3843),
  },
  [2095] = {
    [sym_block_comment] = STATE(2095),
    [sym_compiler_directive_decl] = STATE(2095),
    [sym_fsi_directive_decl] = STATE(2095),
    [sym_preproc_line] = STATE(2095),
    [sym_identifier] = ACTIONS(4086),
    [anon_sym_EQ] = ACTIONS(4084),
    [anon_sym_LBRACK_LT] = ACTIONS(4084),
    [anon_sym_COLON] = ACTIONS(4086),
    [anon_sym_return] = ACTIONS(4086),
    [anon_sym_do] = ACTIONS(4086),
    [anon_sym_and] = ACTIONS(4086),
    [anon_sym_let] = ACTIONS(4086),
    [anon_sym_let_BANG] = ACTIONS(4084),
    [aux_sym_access_modifier_token1] = ACTIONS(4084),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_COMMA] = ACTIONS(4084),
    [anon_sym_null] = ACTIONS(4086),
    [anon_sym_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_COLON] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4084),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_LT_AT] = ACTIONS(4086),
    [anon_sym_LT_AT_AT] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4086),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4084),
    [anon_sym_new] = ACTIONS(4086),
    [anon_sym_with] = ACTIONS(4086),
    [anon_sym_return_BANG] = ACTIONS(4084),
    [anon_sym_yield] = ACTIONS(4086),
    [anon_sym_yield_BANG] = ACTIONS(4084),
    [anon_sym_lazy] = ACTIONS(4086),
    [anon_sym_assert] = ACTIONS(4086),
    [anon_sym_upcast] = ACTIONS(4086),
    [anon_sym_downcast] = ACTIONS(4086),
    [anon_sym_COLON_GT] = ACTIONS(4084),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4084),
    [anon_sym_for] = ACTIONS(4086),
    [anon_sym_while] = ACTIONS(4086),
    [anon_sym_if] = ACTIONS(4086),
    [anon_sym_fun] = ACTIONS(4086),
    [anon_sym_try] = ACTIONS(4086),
    [anon_sym_match] = ACTIONS(4086),
    [anon_sym_match_BANG] = ACTIONS(4084),
    [anon_sym_function] = ACTIONS(4086),
    [anon_sym_LT_DASH] = ACTIONS(4086),
    [anon_sym_DOT_LBRACK] = ACTIONS(4084),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_use] = ACTIONS(4086),
    [anon_sym_use_BANG] = ACTIONS(4084),
    [anon_sym_do_BANG] = ACTIONS(4084),
    [anon_sym_begin] = ACTIONS(4086),
    [anon_sym_LPAREN2] = ACTIONS(4086),
    [anon_sym_default] = ACTIONS(4086),
    [anon_sym_or] = ACTIONS(4086),
    [anon_sym_static] = ACTIONS(4086),
    [anon_sym_member] = ACTIONS(4086),
    [anon_sym_interface] = ACTIONS(4086),
    [anon_sym_abstract] = ACTIONS(4086),
    [anon_sym_val] = ACTIONS(4086),
    [anon_sym_override] = ACTIONS(4086),
    [aux_sym_char_token1] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4086),
    [anon_sym_DQUOTE] = ACTIONS(4086),
    [anon_sym_AT_DQUOTE] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [sym_bool] = ACTIONS(4086),
    [sym_unit] = ACTIONS(4084),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4086),
    [sym_op_identifier] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4086),
    [anon_sym_DASH] = ACTIONS(4086),
    [anon_sym_PLUS_DOT] = ACTIONS(4086),
    [anon_sym_DASH_DOT] = ACTIONS(4086),
    [anon_sym_PERCENT] = ACTIONS(4086),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_TILDE] = ACTIONS(4084),
    [aux_sym_prefix_op_token1] = ACTIONS(4086),
    [aux_sym_infix_op_token1] = ACTIONS(4084),
    [aux_sym_infix_op_token2] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_COLON_EQ] = ACTIONS(4084),
    [anon_sym_DOLLAR] = ACTIONS(4086),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4086),
    [sym_int] = ACTIONS(4086),
    [sym_xint] = ACTIONS(4084),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4084),
    [anon_sym_POUNDendif] = ACTIONS(4084),
    [sym__newline] = ACTIONS(4084),
  },
  [2096] = {
    [sym_block_comment] = STATE(2096),
    [sym_compiler_directive_decl] = STATE(2096),
    [sym_fsi_directive_decl] = STATE(2096),
    [sym_preproc_line] = STATE(2096),
    [sym_identifier] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(4091),
    [anon_sym_LBRACK_LT] = ACTIONS(4091),
    [anon_sym_COLON] = ACTIONS(4093),
    [anon_sym_return] = ACTIONS(4093),
    [anon_sym_do] = ACTIONS(4093),
    [anon_sym_and] = ACTIONS(4093),
    [anon_sym_let] = ACTIONS(4093),
    [anon_sym_let_BANG] = ACTIONS(4091),
    [aux_sym_access_modifier_token1] = ACTIONS(4091),
    [anon_sym_LPAREN] = ACTIONS(4093),
    [anon_sym_COMMA] = ACTIONS(4091),
    [anon_sym_null] = ACTIONS(4093),
    [anon_sym_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_COLON] = ACTIONS(4091),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(4093),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4091),
    [anon_sym_LBRACE] = ACTIONS(4093),
    [anon_sym_LT_AT] = ACTIONS(4093),
    [anon_sym_LT_AT_AT] = ACTIONS(4093),
    [anon_sym_DOT] = ACTIONS(4093),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4091),
    [anon_sym_new] = ACTIONS(4093),
    [anon_sym_with] = ACTIONS(4093),
    [anon_sym_return_BANG] = ACTIONS(4091),
    [anon_sym_yield] = ACTIONS(4093),
    [anon_sym_yield_BANG] = ACTIONS(4091),
    [anon_sym_lazy] = ACTIONS(4093),
    [anon_sym_assert] = ACTIONS(4093),
    [anon_sym_upcast] = ACTIONS(4093),
    [anon_sym_downcast] = ACTIONS(4093),
    [anon_sym_COLON_GT] = ACTIONS(4091),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4091),
    [anon_sym_for] = ACTIONS(4093),
    [anon_sym_while] = ACTIONS(4093),
    [anon_sym_if] = ACTIONS(4093),
    [anon_sym_fun] = ACTIONS(4093),
    [anon_sym_try] = ACTIONS(4093),
    [anon_sym_match] = ACTIONS(4093),
    [anon_sym_match_BANG] = ACTIONS(4091),
    [anon_sym_function] = ACTIONS(4093),
    [anon_sym_LT_DASH] = ACTIONS(4093),
    [anon_sym_DOT_LBRACK] = ACTIONS(4091),
    [anon_sym_LT] = ACTIONS(4091),
    [anon_sym_use] = ACTIONS(4093),
    [anon_sym_use_BANG] = ACTIONS(4091),
    [anon_sym_do_BANG] = ACTIONS(4091),
    [anon_sym_begin] = ACTIONS(4093),
    [anon_sym_LPAREN2] = ACTIONS(4093),
    [anon_sym_default] = ACTIONS(4093),
    [anon_sym_or] = ACTIONS(4093),
    [anon_sym_static] = ACTIONS(4093),
    [anon_sym_member] = ACTIONS(4093),
    [anon_sym_interface] = ACTIONS(4093),
    [anon_sym_abstract] = ACTIONS(4093),
    [anon_sym_val] = ACTIONS(4093),
    [anon_sym_override] = ACTIONS(4093),
    [aux_sym_char_token1] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4093),
    [anon_sym_DQUOTE] = ACTIONS(4093),
    [anon_sym_AT_DQUOTE] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [sym_bool] = ACTIONS(4093),
    [sym_unit] = ACTIONS(4091),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4093),
    [sym_op_identifier] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS_DOT] = ACTIONS(4093),
    [anon_sym_DASH_DOT] = ACTIONS(4093),
    [anon_sym_PERCENT] = ACTIONS(4093),
    [anon_sym_AMP_AMP] = ACTIONS(4093),
    [anon_sym_TILDE] = ACTIONS(4091),
    [aux_sym_prefix_op_token1] = ACTIONS(4093),
    [aux_sym_infix_op_token1] = ACTIONS(4091),
    [aux_sym_infix_op_token2] = ACTIONS(4093),
    [anon_sym_PIPE_PIPE] = ACTIONS(4093),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_COLON_EQ] = ACTIONS(4091),
    [anon_sym_DOLLAR] = ACTIONS(4093),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4093),
    [sym_int] = ACTIONS(4093),
    [sym_xint] = ACTIONS(4091),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4091),
    [anon_sym_POUNDendif] = ACTIONS(4091),
    [sym__newline] = ACTIONS(4091),
  },
  [2097] = {
    [sym_block_comment] = STATE(2097),
    [sym_compiler_directive_decl] = STATE(2097),
    [sym_fsi_directive_decl] = STATE(2097),
    [sym_preproc_line] = STATE(2097),
    [sym_identifier] = ACTIONS(4197),
    [anon_sym_EQ] = ACTIONS(4195),
    [anon_sym_LBRACK_LT] = ACTIONS(4195),
    [anon_sym_COLON] = ACTIONS(4197),
    [anon_sym_return] = ACTIONS(4197),
    [anon_sym_do] = ACTIONS(4197),
    [anon_sym_and] = ACTIONS(4197),
    [anon_sym_let] = ACTIONS(4197),
    [anon_sym_let_BANG] = ACTIONS(4195),
    [aux_sym_access_modifier_token1] = ACTIONS(4195),
    [anon_sym_LPAREN] = ACTIONS(4197),
    [anon_sym_COMMA] = ACTIONS(4195),
    [anon_sym_null] = ACTIONS(4197),
    [anon_sym_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_COLON] = ACTIONS(4195),
    [anon_sym_AMP] = ACTIONS(4197),
    [anon_sym_LBRACK] = ACTIONS(4197),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4195),
    [anon_sym_LBRACE] = ACTIONS(4197),
    [anon_sym_LT_AT] = ACTIONS(4197),
    [anon_sym_LT_AT_AT] = ACTIONS(4197),
    [anon_sym_DOT] = ACTIONS(4197),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4195),
    [anon_sym_new] = ACTIONS(4197),
    [anon_sym_with] = ACTIONS(4197),
    [anon_sym_return_BANG] = ACTIONS(4195),
    [anon_sym_yield] = ACTIONS(4197),
    [anon_sym_yield_BANG] = ACTIONS(4195),
    [anon_sym_lazy] = ACTIONS(4197),
    [anon_sym_assert] = ACTIONS(4197),
    [anon_sym_upcast] = ACTIONS(4197),
    [anon_sym_downcast] = ACTIONS(4197),
    [anon_sym_COLON_GT] = ACTIONS(4195),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4195),
    [anon_sym_for] = ACTIONS(4197),
    [anon_sym_while] = ACTIONS(4197),
    [anon_sym_if] = ACTIONS(4197),
    [anon_sym_fun] = ACTIONS(4197),
    [anon_sym_try] = ACTIONS(4197),
    [anon_sym_match] = ACTIONS(4197),
    [anon_sym_match_BANG] = ACTIONS(4195),
    [anon_sym_function] = ACTIONS(4197),
    [anon_sym_LT_DASH] = ACTIONS(4197),
    [anon_sym_DOT_LBRACK] = ACTIONS(4195),
    [anon_sym_LT] = ACTIONS(4195),
    [anon_sym_use] = ACTIONS(4197),
    [anon_sym_use_BANG] = ACTIONS(4195),
    [anon_sym_do_BANG] = ACTIONS(4195),
    [anon_sym_begin] = ACTIONS(4197),
    [anon_sym_LPAREN2] = ACTIONS(4197),
    [anon_sym_default] = ACTIONS(4197),
    [anon_sym_or] = ACTIONS(4197),
    [anon_sym_static] = ACTIONS(4197),
    [anon_sym_member] = ACTIONS(4197),
    [anon_sym_interface] = ACTIONS(4197),
    [anon_sym_abstract] = ACTIONS(4197),
    [anon_sym_val] = ACTIONS(4197),
    [anon_sym_override] = ACTIONS(4197),
    [aux_sym_char_token1] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4197),
    [anon_sym_DQUOTE] = ACTIONS(4197),
    [anon_sym_AT_DQUOTE] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [sym_bool] = ACTIONS(4197),
    [sym_unit] = ACTIONS(4195),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4197),
    [sym_op_identifier] = ACTIONS(4197),
    [anon_sym_PLUS] = ACTIONS(4197),
    [anon_sym_DASH] = ACTIONS(4197),
    [anon_sym_PLUS_DOT] = ACTIONS(4197),
    [anon_sym_DASH_DOT] = ACTIONS(4197),
    [anon_sym_PERCENT] = ACTIONS(4197),
    [anon_sym_AMP_AMP] = ACTIONS(4197),
    [anon_sym_TILDE] = ACTIONS(4195),
    [aux_sym_prefix_op_token1] = ACTIONS(4197),
    [aux_sym_infix_op_token1] = ACTIONS(4195),
    [aux_sym_infix_op_token2] = ACTIONS(4197),
    [anon_sym_PIPE_PIPE] = ACTIONS(4197),
    [anon_sym_BANG_EQ] = ACTIONS(4197),
    [anon_sym_COLON_EQ] = ACTIONS(4195),
    [anon_sym_DOLLAR] = ACTIONS(4197),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4197),
    [sym_int] = ACTIONS(4197),
    [sym_xint] = ACTIONS(4195),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4195),
    [sym__newline] = ACTIONS(4195),
    [sym__dedent] = ACTIONS(4195),
  },
  [2098] = {
    [sym_block_comment] = STATE(2098),
    [sym_compiler_directive_decl] = STATE(2098),
    [sym_fsi_directive_decl] = STATE(2098),
    [sym_preproc_line] = STATE(2098),
    [sym_identifier] = ACTIONS(4193),
    [anon_sym_EQ] = ACTIONS(4191),
    [anon_sym_LBRACK_LT] = ACTIONS(4191),
    [anon_sym_COLON] = ACTIONS(4193),
    [anon_sym_return] = ACTIONS(4193),
    [anon_sym_do] = ACTIONS(4193),
    [anon_sym_and] = ACTIONS(4193),
    [anon_sym_let] = ACTIONS(4193),
    [anon_sym_let_BANG] = ACTIONS(4191),
    [aux_sym_access_modifier_token1] = ACTIONS(4191),
    [anon_sym_LPAREN] = ACTIONS(4193),
    [anon_sym_COMMA] = ACTIONS(4191),
    [anon_sym_null] = ACTIONS(4193),
    [anon_sym_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_COLON] = ACTIONS(4191),
    [anon_sym_AMP] = ACTIONS(4193),
    [anon_sym_LBRACK] = ACTIONS(4193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4191),
    [anon_sym_LBRACE] = ACTIONS(4193),
    [anon_sym_LT_AT] = ACTIONS(4193),
    [anon_sym_LT_AT_AT] = ACTIONS(4193),
    [anon_sym_DOT] = ACTIONS(4193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4191),
    [anon_sym_new] = ACTIONS(4193),
    [anon_sym_with] = ACTIONS(4193),
    [anon_sym_return_BANG] = ACTIONS(4191),
    [anon_sym_yield] = ACTIONS(4193),
    [anon_sym_yield_BANG] = ACTIONS(4191),
    [anon_sym_lazy] = ACTIONS(4193),
    [anon_sym_assert] = ACTIONS(4193),
    [anon_sym_upcast] = ACTIONS(4193),
    [anon_sym_downcast] = ACTIONS(4193),
    [anon_sym_COLON_GT] = ACTIONS(4191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4191),
    [anon_sym_for] = ACTIONS(4193),
    [anon_sym_while] = ACTIONS(4193),
    [anon_sym_if] = ACTIONS(4193),
    [anon_sym_fun] = ACTIONS(4193),
    [anon_sym_try] = ACTIONS(4193),
    [anon_sym_match] = ACTIONS(4193),
    [anon_sym_match_BANG] = ACTIONS(4191),
    [anon_sym_function] = ACTIONS(4193),
    [anon_sym_LT_DASH] = ACTIONS(4193),
    [anon_sym_DOT_LBRACK] = ACTIONS(4191),
    [anon_sym_LT] = ACTIONS(4191),
    [anon_sym_use] = ACTIONS(4193),
    [anon_sym_use_BANG] = ACTIONS(4191),
    [anon_sym_do_BANG] = ACTIONS(4191),
    [anon_sym_begin] = ACTIONS(4193),
    [anon_sym_LPAREN2] = ACTIONS(4193),
    [anon_sym_default] = ACTIONS(4193),
    [anon_sym_or] = ACTIONS(4193),
    [anon_sym_static] = ACTIONS(4193),
    [anon_sym_member] = ACTIONS(4193),
    [anon_sym_interface] = ACTIONS(4193),
    [anon_sym_abstract] = ACTIONS(4193),
    [anon_sym_val] = ACTIONS(4193),
    [anon_sym_override] = ACTIONS(4193),
    [aux_sym_char_token1] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4193),
    [anon_sym_DQUOTE] = ACTIONS(4193),
    [anon_sym_AT_DQUOTE] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [sym_bool] = ACTIONS(4193),
    [sym_unit] = ACTIONS(4191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4193),
    [sym_op_identifier] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4193),
    [anon_sym_DASH] = ACTIONS(4193),
    [anon_sym_PLUS_DOT] = ACTIONS(4193),
    [anon_sym_DASH_DOT] = ACTIONS(4193),
    [anon_sym_PERCENT] = ACTIONS(4193),
    [anon_sym_AMP_AMP] = ACTIONS(4193),
    [anon_sym_TILDE] = ACTIONS(4191),
    [aux_sym_prefix_op_token1] = ACTIONS(4193),
    [aux_sym_infix_op_token1] = ACTIONS(4191),
    [aux_sym_infix_op_token2] = ACTIONS(4193),
    [anon_sym_PIPE_PIPE] = ACTIONS(4193),
    [anon_sym_BANG_EQ] = ACTIONS(4193),
    [anon_sym_COLON_EQ] = ACTIONS(4191),
    [anon_sym_DOLLAR] = ACTIONS(4193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4193),
    [sym_int] = ACTIONS(4193),
    [sym_xint] = ACTIONS(4191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4191),
    [sym__newline] = ACTIONS(4191),
    [sym__dedent] = ACTIONS(4191),
  },
  [2099] = {
    [sym_block_comment] = STATE(2099),
    [sym_compiler_directive_decl] = STATE(2099),
    [sym_fsi_directive_decl] = STATE(2099),
    [sym_preproc_line] = STATE(2099),
    [sym_identifier] = ACTIONS(4018),
    [anon_sym_EQ] = ACTIONS(4016),
    [anon_sym_LBRACK_LT] = ACTIONS(4016),
    [anon_sym_COLON] = ACTIONS(4018),
    [anon_sym_return] = ACTIONS(4018),
    [anon_sym_do] = ACTIONS(4018),
    [anon_sym_let] = ACTIONS(4018),
    [anon_sym_let_BANG] = ACTIONS(4016),
    [aux_sym_access_modifier_token1] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(4018),
    [anon_sym_COMMA] = ACTIONS(4016),
    [anon_sym_null] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_COLON] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4018),
    [anon_sym_LBRACK] = ACTIONS(4018),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4016),
    [anon_sym_LBRACE] = ACTIONS(4018),
    [anon_sym_LT_AT] = ACTIONS(4018),
    [anon_sym_LT_AT_AT] = ACTIONS(4018),
    [anon_sym_DOT] = ACTIONS(4018),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4016),
    [anon_sym_new] = ACTIONS(4018),
    [anon_sym_with] = ACTIONS(4018),
    [anon_sym_return_BANG] = ACTIONS(4016),
    [anon_sym_yield] = ACTIONS(4018),
    [anon_sym_yield_BANG] = ACTIONS(4016),
    [anon_sym_lazy] = ACTIONS(4018),
    [anon_sym_assert] = ACTIONS(4018),
    [anon_sym_upcast] = ACTIONS(4018),
    [anon_sym_downcast] = ACTIONS(4018),
    [anon_sym_COLON_GT] = ACTIONS(4016),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4016),
    [anon_sym_for] = ACTIONS(4018),
    [anon_sym_while] = ACTIONS(4018),
    [anon_sym_if] = ACTIONS(4018),
    [anon_sym_fun] = ACTIONS(4018),
    [anon_sym_try] = ACTIONS(4018),
    [anon_sym_match] = ACTIONS(4018),
    [anon_sym_match_BANG] = ACTIONS(4016),
    [anon_sym_function] = ACTIONS(4018),
    [anon_sym_LT_DASH] = ACTIONS(4018),
    [anon_sym_DOT_LBRACK] = ACTIONS(4016),
    [anon_sym_LT] = ACTIONS(4016),
    [anon_sym_use] = ACTIONS(4018),
    [anon_sym_use_BANG] = ACTIONS(4016),
    [anon_sym_do_BANG] = ACTIONS(4016),
    [anon_sym_begin] = ACTIONS(4018),
    [anon_sym_LPAREN2] = ACTIONS(4018),
    [anon_sym_default] = ACTIONS(4018),
    [anon_sym_or] = ACTIONS(4018),
    [anon_sym_static] = ACTIONS(4018),
    [anon_sym_member] = ACTIONS(4018),
    [anon_sym_interface] = ACTIONS(4018),
    [anon_sym_abstract] = ACTIONS(4018),
    [anon_sym_val] = ACTIONS(4018),
    [anon_sym_override] = ACTIONS(4018),
    [anon_sym_inherit] = ACTIONS(4018),
    [aux_sym_char_token1] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(4018),
    [anon_sym_AT_DQUOTE] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [sym_bool] = ACTIONS(4018),
    [sym_unit] = ACTIONS(4016),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4018),
    [sym_op_identifier] = ACTIONS(4018),
    [anon_sym_PLUS] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_PLUS_DOT] = ACTIONS(4018),
    [anon_sym_DASH_DOT] = ACTIONS(4018),
    [anon_sym_PERCENT] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4016),
    [aux_sym_prefix_op_token1] = ACTIONS(4018),
    [aux_sym_infix_op_token1] = ACTIONS(4016),
    [aux_sym_infix_op_token2] = ACTIONS(4018),
    [anon_sym_PIPE_PIPE] = ACTIONS(4018),
    [anon_sym_BANG_EQ] = ACTIONS(4018),
    [anon_sym_COLON_EQ] = ACTIONS(4016),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4018),
    [sym_int] = ACTIONS(4018),
    [sym_xint] = ACTIONS(4016),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4016),
    [anon_sym_POUNDendif] = ACTIONS(4016),
    [sym__newline] = ACTIONS(4016),
  },
  [2100] = {
    [sym_block_comment] = STATE(2100),
    [sym_compiler_directive_decl] = STATE(2100),
    [sym_fsi_directive_decl] = STATE(2100),
    [sym_preproc_line] = STATE(2100),
    [sym_identifier] = ACTIONS(4054),
    [anon_sym_EQ] = ACTIONS(4052),
    [anon_sym_LBRACK_LT] = ACTIONS(4052),
    [anon_sym_COLON] = ACTIONS(4054),
    [anon_sym_return] = ACTIONS(4054),
    [anon_sym_do] = ACTIONS(4054),
    [anon_sym_let] = ACTIONS(4054),
    [anon_sym_let_BANG] = ACTIONS(4052),
    [aux_sym_access_modifier_token1] = ACTIONS(4052),
    [anon_sym_LPAREN] = ACTIONS(4054),
    [anon_sym_COMMA] = ACTIONS(4052),
    [anon_sym_null] = ACTIONS(4054),
    [anon_sym_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_COLON] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(4054),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4052),
    [anon_sym_LBRACE] = ACTIONS(4054),
    [anon_sym_LT_AT] = ACTIONS(4054),
    [anon_sym_LT_AT_AT] = ACTIONS(4054),
    [anon_sym_DOT] = ACTIONS(4054),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_with] = ACTIONS(4054),
    [anon_sym_return_BANG] = ACTIONS(4052),
    [anon_sym_yield] = ACTIONS(4054),
    [anon_sym_yield_BANG] = ACTIONS(4052),
    [anon_sym_lazy] = ACTIONS(4054),
    [anon_sym_assert] = ACTIONS(4054),
    [anon_sym_upcast] = ACTIONS(4054),
    [anon_sym_downcast] = ACTIONS(4054),
    [anon_sym_COLON_GT] = ACTIONS(4052),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4052),
    [anon_sym_for] = ACTIONS(4054),
    [anon_sym_while] = ACTIONS(4054),
    [anon_sym_if] = ACTIONS(4054),
    [anon_sym_fun] = ACTIONS(4054),
    [anon_sym_try] = ACTIONS(4054),
    [anon_sym_match] = ACTIONS(4054),
    [anon_sym_match_BANG] = ACTIONS(4052),
    [anon_sym_function] = ACTIONS(4054),
    [anon_sym_LT_DASH] = ACTIONS(4054),
    [anon_sym_DOT_LBRACK] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_use] = ACTIONS(4054),
    [anon_sym_use_BANG] = ACTIONS(4052),
    [anon_sym_do_BANG] = ACTIONS(4052),
    [anon_sym_begin] = ACTIONS(4054),
    [anon_sym_LPAREN2] = ACTIONS(4054),
    [anon_sym_default] = ACTIONS(4054),
    [anon_sym_or] = ACTIONS(4054),
    [anon_sym_static] = ACTIONS(4054),
    [anon_sym_member] = ACTIONS(4054),
    [anon_sym_interface] = ACTIONS(4054),
    [anon_sym_abstract] = ACTIONS(4054),
    [anon_sym_val] = ACTIONS(4054),
    [anon_sym_override] = ACTIONS(4054),
    [anon_sym_inherit] = ACTIONS(4054),
    [aux_sym_char_token1] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4054),
    [anon_sym_DQUOTE] = ACTIONS(4054),
    [anon_sym_AT_DQUOTE] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [sym_bool] = ACTIONS(4054),
    [sym_unit] = ACTIONS(4052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4054),
    [sym_op_identifier] = ACTIONS(4054),
    [anon_sym_PLUS] = ACTIONS(4054),
    [anon_sym_DASH] = ACTIONS(4054),
    [anon_sym_PLUS_DOT] = ACTIONS(4054),
    [anon_sym_DASH_DOT] = ACTIONS(4054),
    [anon_sym_PERCENT] = ACTIONS(4054),
    [anon_sym_AMP_AMP] = ACTIONS(4054),
    [anon_sym_TILDE] = ACTIONS(4052),
    [aux_sym_prefix_op_token1] = ACTIONS(4054),
    [aux_sym_infix_op_token1] = ACTIONS(4052),
    [aux_sym_infix_op_token2] = ACTIONS(4054),
    [anon_sym_PIPE_PIPE] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4054),
    [anon_sym_COLON_EQ] = ACTIONS(4052),
    [anon_sym_DOLLAR] = ACTIONS(4054),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4054),
    [sym_int] = ACTIONS(4054),
    [sym_xint] = ACTIONS(4052),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4052),
    [anon_sym_POUNDendif] = ACTIONS(4052),
    [sym__newline] = ACTIONS(4052),
  },
  [2101] = {
    [sym_block_comment] = STATE(2101),
    [sym_compiler_directive_decl] = STATE(2101),
    [sym_fsi_directive_decl] = STATE(2101),
    [sym_preproc_line] = STATE(2101),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LBRACK_LT] = ACTIONS(4080),
    [anon_sym_COLON] = ACTIONS(4082),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_do] = ACTIONS(4082),
    [anon_sym_let] = ACTIONS(4082),
    [anon_sym_let_BANG] = ACTIONS(4080),
    [aux_sym_access_modifier_token1] = ACTIONS(4080),
    [anon_sym_LPAREN] = ACTIONS(4082),
    [anon_sym_COMMA] = ACTIONS(4080),
    [anon_sym_null] = ACTIONS(4082),
    [anon_sym_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_COLON] = ACTIONS(4080),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_LBRACK] = ACTIONS(4082),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(4082),
    [anon_sym_LT_AT] = ACTIONS(4082),
    [anon_sym_LT_AT_AT] = ACTIONS(4082),
    [anon_sym_DOT] = ACTIONS(4082),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4080),
    [anon_sym_new] = ACTIONS(4082),
    [anon_sym_with] = ACTIONS(4082),
    [anon_sym_return_BANG] = ACTIONS(4080),
    [anon_sym_yield] = ACTIONS(4082),
    [anon_sym_yield_BANG] = ACTIONS(4080),
    [anon_sym_lazy] = ACTIONS(4082),
    [anon_sym_assert] = ACTIONS(4082),
    [anon_sym_upcast] = ACTIONS(4082),
    [anon_sym_downcast] = ACTIONS(4082),
    [anon_sym_COLON_GT] = ACTIONS(4080),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4080),
    [anon_sym_for] = ACTIONS(4082),
    [anon_sym_while] = ACTIONS(4082),
    [anon_sym_if] = ACTIONS(4082),
    [anon_sym_fun] = ACTIONS(4082),
    [anon_sym_try] = ACTIONS(4082),
    [anon_sym_match] = ACTIONS(4082),
    [anon_sym_match_BANG] = ACTIONS(4080),
    [anon_sym_function] = ACTIONS(4082),
    [anon_sym_LT_DASH] = ACTIONS(4082),
    [anon_sym_DOT_LBRACK] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(4080),
    [anon_sym_use] = ACTIONS(4082),
    [anon_sym_use_BANG] = ACTIONS(4080),
    [anon_sym_do_BANG] = ACTIONS(4080),
    [anon_sym_begin] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4082),
    [anon_sym_default] = ACTIONS(4082),
    [anon_sym_or] = ACTIONS(4082),
    [anon_sym_static] = ACTIONS(4082),
    [anon_sym_member] = ACTIONS(4082),
    [anon_sym_interface] = ACTIONS(4082),
    [anon_sym_abstract] = ACTIONS(4082),
    [anon_sym_val] = ACTIONS(4082),
    [anon_sym_override] = ACTIONS(4082),
    [anon_sym_inherit] = ACTIONS(4082),
    [aux_sym_char_token1] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4082),
    [anon_sym_DQUOTE] = ACTIONS(4082),
    [anon_sym_AT_DQUOTE] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [sym_bool] = ACTIONS(4082),
    [sym_unit] = ACTIONS(4080),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4082),
    [sym_op_identifier] = ACTIONS(4082),
    [anon_sym_PLUS] = ACTIONS(4082),
    [anon_sym_DASH] = ACTIONS(4082),
    [anon_sym_PLUS_DOT] = ACTIONS(4082),
    [anon_sym_DASH_DOT] = ACTIONS(4082),
    [anon_sym_PERCENT] = ACTIONS(4082),
    [anon_sym_AMP_AMP] = ACTIONS(4082),
    [anon_sym_TILDE] = ACTIONS(4080),
    [aux_sym_prefix_op_token1] = ACTIONS(4082),
    [aux_sym_infix_op_token1] = ACTIONS(4080),
    [aux_sym_infix_op_token2] = ACTIONS(4082),
    [anon_sym_PIPE_PIPE] = ACTIONS(4082),
    [anon_sym_BANG_EQ] = ACTIONS(4082),
    [anon_sym_COLON_EQ] = ACTIONS(4080),
    [anon_sym_DOLLAR] = ACTIONS(4082),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4082),
    [sym_int] = ACTIONS(4082),
    [sym_xint] = ACTIONS(4080),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4080),
    [anon_sym_POUNDendif] = ACTIONS(4080),
    [sym__newline] = ACTIONS(4080),
  },
  [2102] = {
    [sym_block_comment] = STATE(2102),
    [sym_compiler_directive_decl] = STATE(2102),
    [sym_fsi_directive_decl] = STATE(2102),
    [sym_preproc_line] = STATE(2102),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_and] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [aux_sym_access_modifier_token1] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_member] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_val] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
    [sym__dedent] = ACTIONS(3485),
  },
  [2103] = {
    [sym_block_comment] = STATE(2103),
    [sym_compiler_directive_decl] = STATE(2103),
    [sym_fsi_directive_decl] = STATE(2103),
    [sym_preproc_line] = STATE(2103),
    [sym_identifier] = ACTIONS(4086),
    [anon_sym_EQ] = ACTIONS(4084),
    [anon_sym_LBRACK_LT] = ACTIONS(4084),
    [anon_sym_COLON] = ACTIONS(4086),
    [anon_sym_return] = ACTIONS(4086),
    [anon_sym_do] = ACTIONS(4086),
    [anon_sym_let] = ACTIONS(4086),
    [anon_sym_let_BANG] = ACTIONS(4084),
    [aux_sym_access_modifier_token1] = ACTIONS(4084),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_COMMA] = ACTIONS(4084),
    [anon_sym_null] = ACTIONS(4086),
    [anon_sym_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_COLON] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4084),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_LT_AT] = ACTIONS(4086),
    [anon_sym_LT_AT_AT] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4086),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4084),
    [anon_sym_new] = ACTIONS(4086),
    [anon_sym_with] = ACTIONS(4086),
    [anon_sym_return_BANG] = ACTIONS(4084),
    [anon_sym_yield] = ACTIONS(4086),
    [anon_sym_yield_BANG] = ACTIONS(4084),
    [anon_sym_lazy] = ACTIONS(4086),
    [anon_sym_assert] = ACTIONS(4086),
    [anon_sym_upcast] = ACTIONS(4086),
    [anon_sym_downcast] = ACTIONS(4086),
    [anon_sym_COLON_GT] = ACTIONS(4084),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4084),
    [anon_sym_for] = ACTIONS(4086),
    [anon_sym_while] = ACTIONS(4086),
    [anon_sym_if] = ACTIONS(4086),
    [anon_sym_fun] = ACTIONS(4086),
    [anon_sym_try] = ACTIONS(4086),
    [anon_sym_match] = ACTIONS(4086),
    [anon_sym_match_BANG] = ACTIONS(4084),
    [anon_sym_function] = ACTIONS(4086),
    [anon_sym_LT_DASH] = ACTIONS(4086),
    [anon_sym_DOT_LBRACK] = ACTIONS(4084),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_use] = ACTIONS(4086),
    [anon_sym_use_BANG] = ACTIONS(4084),
    [anon_sym_do_BANG] = ACTIONS(4084),
    [anon_sym_begin] = ACTIONS(4086),
    [anon_sym_LPAREN2] = ACTIONS(4086),
    [anon_sym_default] = ACTIONS(4086),
    [anon_sym_or] = ACTIONS(4086),
    [anon_sym_static] = ACTIONS(4086),
    [anon_sym_member] = ACTIONS(4086),
    [anon_sym_interface] = ACTIONS(4086),
    [anon_sym_abstract] = ACTIONS(4086),
    [anon_sym_val] = ACTIONS(4086),
    [anon_sym_override] = ACTIONS(4086),
    [anon_sym_inherit] = ACTIONS(4086),
    [aux_sym_char_token1] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4086),
    [anon_sym_DQUOTE] = ACTIONS(4086),
    [anon_sym_AT_DQUOTE] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [sym_bool] = ACTIONS(4086),
    [sym_unit] = ACTIONS(4084),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4086),
    [sym_op_identifier] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4086),
    [anon_sym_DASH] = ACTIONS(4086),
    [anon_sym_PLUS_DOT] = ACTIONS(4086),
    [anon_sym_DASH_DOT] = ACTIONS(4086),
    [anon_sym_PERCENT] = ACTIONS(4086),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_TILDE] = ACTIONS(4084),
    [aux_sym_prefix_op_token1] = ACTIONS(4086),
    [aux_sym_infix_op_token1] = ACTIONS(4084),
    [aux_sym_infix_op_token2] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_COLON_EQ] = ACTIONS(4084),
    [anon_sym_DOLLAR] = ACTIONS(4086),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4086),
    [sym_int] = ACTIONS(4086),
    [sym_xint] = ACTIONS(4084),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4084),
    [anon_sym_POUNDendif] = ACTIONS(4084),
    [sym__newline] = ACTIONS(4084),
  },
  [2104] = {
    [sym_block_comment] = STATE(2104),
    [sym_compiler_directive_decl] = STATE(2104),
    [sym_fsi_directive_decl] = STATE(2104),
    [sym_preproc_line] = STATE(2104),
    [sym_identifier] = ACTIONS(4108),
    [anon_sym_EQ] = ACTIONS(4106),
    [anon_sym_LBRACK_LT] = ACTIONS(4106),
    [anon_sym_COLON] = ACTIONS(4108),
    [anon_sym_return] = ACTIONS(4108),
    [anon_sym_do] = ACTIONS(4108),
    [anon_sym_and] = ACTIONS(4108),
    [anon_sym_let] = ACTIONS(4108),
    [anon_sym_let_BANG] = ACTIONS(4106),
    [aux_sym_access_modifier_token1] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(4108),
    [anon_sym_COMMA] = ACTIONS(4106),
    [anon_sym_null] = ACTIONS(4108),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_COLON] = ACTIONS(4106),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LBRACK] = ACTIONS(4108),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(4108),
    [anon_sym_LT_AT] = ACTIONS(4108),
    [anon_sym_LT_AT_AT] = ACTIONS(4108),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4106),
    [anon_sym_new] = ACTIONS(4108),
    [anon_sym_with] = ACTIONS(4108),
    [anon_sym_return_BANG] = ACTIONS(4106),
    [anon_sym_yield] = ACTIONS(4108),
    [anon_sym_yield_BANG] = ACTIONS(4106),
    [anon_sym_lazy] = ACTIONS(4108),
    [anon_sym_assert] = ACTIONS(4108),
    [anon_sym_upcast] = ACTIONS(4108),
    [anon_sym_downcast] = ACTIONS(4108),
    [anon_sym_COLON_GT] = ACTIONS(4106),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4106),
    [anon_sym_for] = ACTIONS(4108),
    [anon_sym_while] = ACTIONS(4108),
    [anon_sym_if] = ACTIONS(4108),
    [anon_sym_fun] = ACTIONS(4108),
    [anon_sym_try] = ACTIONS(4108),
    [anon_sym_match] = ACTIONS(4108),
    [anon_sym_match_BANG] = ACTIONS(4106),
    [anon_sym_function] = ACTIONS(4108),
    [anon_sym_LT_DASH] = ACTIONS(4108),
    [anon_sym_DOT_LBRACK] = ACTIONS(4106),
    [anon_sym_LT] = ACTIONS(4106),
    [anon_sym_use] = ACTIONS(4108),
    [anon_sym_use_BANG] = ACTIONS(4106),
    [anon_sym_do_BANG] = ACTIONS(4106),
    [anon_sym_begin] = ACTIONS(4108),
    [anon_sym_LPAREN2] = ACTIONS(4108),
    [anon_sym_default] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [anon_sym_static] = ACTIONS(4108),
    [anon_sym_member] = ACTIONS(4108),
    [anon_sym_interface] = ACTIONS(4108),
    [anon_sym_abstract] = ACTIONS(4108),
    [anon_sym_val] = ACTIONS(4108),
    [anon_sym_override] = ACTIONS(4108),
    [aux_sym_char_token1] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4108),
    [anon_sym_DQUOTE] = ACTIONS(4108),
    [anon_sym_AT_DQUOTE] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [sym_bool] = ACTIONS(4108),
    [sym_unit] = ACTIONS(4106),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4108),
    [sym_op_identifier] = ACTIONS(4108),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_PLUS_DOT] = ACTIONS(4108),
    [anon_sym_DASH_DOT] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_AMP_AMP] = ACTIONS(4108),
    [anon_sym_TILDE] = ACTIONS(4106),
    [aux_sym_prefix_op_token1] = ACTIONS(4108),
    [aux_sym_infix_op_token1] = ACTIONS(4106),
    [aux_sym_infix_op_token2] = ACTIONS(4108),
    [anon_sym_PIPE_PIPE] = ACTIONS(4108),
    [anon_sym_BANG_EQ] = ACTIONS(4108),
    [anon_sym_COLON_EQ] = ACTIONS(4106),
    [anon_sym_DOLLAR] = ACTIONS(4108),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4108),
    [sym_int] = ACTIONS(4108),
    [sym_xint] = ACTIONS(4106),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4106),
    [anon_sym_POUNDendif] = ACTIONS(4106),
    [sym__newline] = ACTIONS(4106),
  },
  [2105] = {
    [sym_block_comment] = STATE(2105),
    [sym_compiler_directive_decl] = STATE(2105),
    [sym_fsi_directive_decl] = STATE(2105),
    [sym_preproc_line] = STATE(2105),
    [sym_identifier] = ACTIONS(4112),
    [anon_sym_EQ] = ACTIONS(4110),
    [anon_sym_LBRACK_LT] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4112),
    [anon_sym_return] = ACTIONS(4112),
    [anon_sym_do] = ACTIONS(4112),
    [anon_sym_and] = ACTIONS(4112),
    [anon_sym_let] = ACTIONS(4112),
    [anon_sym_let_BANG] = ACTIONS(4110),
    [aux_sym_access_modifier_token1] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_null] = ACTIONS(4112),
    [anon_sym_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_COLON] = ACTIONS(4110),
    [anon_sym_AMP] = ACTIONS(4112),
    [anon_sym_LBRACK] = ACTIONS(4112),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4110),
    [anon_sym_LBRACE] = ACTIONS(4112),
    [anon_sym_LT_AT] = ACTIONS(4112),
    [anon_sym_LT_AT_AT] = ACTIONS(4112),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4110),
    [anon_sym_new] = ACTIONS(4112),
    [anon_sym_with] = ACTIONS(4112),
    [anon_sym_return_BANG] = ACTIONS(4110),
    [anon_sym_yield] = ACTIONS(4112),
    [anon_sym_yield_BANG] = ACTIONS(4110),
    [anon_sym_lazy] = ACTIONS(4112),
    [anon_sym_assert] = ACTIONS(4112),
    [anon_sym_upcast] = ACTIONS(4112),
    [anon_sym_downcast] = ACTIONS(4112),
    [anon_sym_COLON_GT] = ACTIONS(4110),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4110),
    [anon_sym_for] = ACTIONS(4112),
    [anon_sym_while] = ACTIONS(4112),
    [anon_sym_if] = ACTIONS(4112),
    [anon_sym_fun] = ACTIONS(4112),
    [anon_sym_try] = ACTIONS(4112),
    [anon_sym_match] = ACTIONS(4112),
    [anon_sym_match_BANG] = ACTIONS(4110),
    [anon_sym_function] = ACTIONS(4112),
    [anon_sym_LT_DASH] = ACTIONS(4112),
    [anon_sym_DOT_LBRACK] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(4110),
    [anon_sym_use] = ACTIONS(4112),
    [anon_sym_use_BANG] = ACTIONS(4110),
    [anon_sym_do_BANG] = ACTIONS(4110),
    [anon_sym_begin] = ACTIONS(4112),
    [anon_sym_LPAREN2] = ACTIONS(4112),
    [anon_sym_default] = ACTIONS(4112),
    [anon_sym_or] = ACTIONS(4112),
    [anon_sym_static] = ACTIONS(4112),
    [anon_sym_member] = ACTIONS(4112),
    [anon_sym_interface] = ACTIONS(4112),
    [anon_sym_abstract] = ACTIONS(4112),
    [anon_sym_val] = ACTIONS(4112),
    [anon_sym_override] = ACTIONS(4112),
    [aux_sym_char_token1] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4112),
    [anon_sym_DQUOTE] = ACTIONS(4112),
    [anon_sym_AT_DQUOTE] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [sym_bool] = ACTIONS(4112),
    [sym_unit] = ACTIONS(4110),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4112),
    [sym_op_identifier] = ACTIONS(4112),
    [anon_sym_PLUS] = ACTIONS(4112),
    [anon_sym_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_DOT] = ACTIONS(4112),
    [anon_sym_DASH_DOT] = ACTIONS(4112),
    [anon_sym_PERCENT] = ACTIONS(4112),
    [anon_sym_AMP_AMP] = ACTIONS(4112),
    [anon_sym_TILDE] = ACTIONS(4110),
    [aux_sym_prefix_op_token1] = ACTIONS(4112),
    [aux_sym_infix_op_token1] = ACTIONS(4110),
    [aux_sym_infix_op_token2] = ACTIONS(4112),
    [anon_sym_PIPE_PIPE] = ACTIONS(4112),
    [anon_sym_BANG_EQ] = ACTIONS(4112),
    [anon_sym_COLON_EQ] = ACTIONS(4110),
    [anon_sym_DOLLAR] = ACTIONS(4112),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4112),
    [sym_int] = ACTIONS(4112),
    [sym_xint] = ACTIONS(4110),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4110),
    [anon_sym_POUNDendif] = ACTIONS(4110),
    [sym__newline] = ACTIONS(4110),
  },
  [2106] = {
    [sym_block_comment] = STATE(2106),
    [sym_compiler_directive_decl] = STATE(2106),
    [sym_fsi_directive_decl] = STATE(2106),
    [sym_preproc_line] = STATE(2106),
    [sym_identifier] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(4091),
    [anon_sym_LBRACK_LT] = ACTIONS(4091),
    [anon_sym_COLON] = ACTIONS(4093),
    [anon_sym_return] = ACTIONS(4093),
    [anon_sym_do] = ACTIONS(4093),
    [anon_sym_let] = ACTIONS(4093),
    [anon_sym_let_BANG] = ACTIONS(4091),
    [aux_sym_access_modifier_token1] = ACTIONS(4091),
    [anon_sym_LPAREN] = ACTIONS(4093),
    [anon_sym_COMMA] = ACTIONS(4091),
    [anon_sym_null] = ACTIONS(4093),
    [anon_sym_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_COLON] = ACTIONS(4091),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(4093),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4091),
    [anon_sym_LBRACE] = ACTIONS(4093),
    [anon_sym_LT_AT] = ACTIONS(4093),
    [anon_sym_LT_AT_AT] = ACTIONS(4093),
    [anon_sym_DOT] = ACTIONS(4093),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4091),
    [anon_sym_new] = ACTIONS(4093),
    [anon_sym_with] = ACTIONS(4093),
    [anon_sym_return_BANG] = ACTIONS(4091),
    [anon_sym_yield] = ACTIONS(4093),
    [anon_sym_yield_BANG] = ACTIONS(4091),
    [anon_sym_lazy] = ACTIONS(4093),
    [anon_sym_assert] = ACTIONS(4093),
    [anon_sym_upcast] = ACTIONS(4093),
    [anon_sym_downcast] = ACTIONS(4093),
    [anon_sym_COLON_GT] = ACTIONS(4091),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4091),
    [anon_sym_for] = ACTIONS(4093),
    [anon_sym_while] = ACTIONS(4093),
    [anon_sym_if] = ACTIONS(4093),
    [anon_sym_fun] = ACTIONS(4093),
    [anon_sym_try] = ACTIONS(4093),
    [anon_sym_match] = ACTIONS(4093),
    [anon_sym_match_BANG] = ACTIONS(4091),
    [anon_sym_function] = ACTIONS(4093),
    [anon_sym_LT_DASH] = ACTIONS(4093),
    [anon_sym_DOT_LBRACK] = ACTIONS(4091),
    [anon_sym_LT] = ACTIONS(4091),
    [anon_sym_use] = ACTIONS(4093),
    [anon_sym_use_BANG] = ACTIONS(4091),
    [anon_sym_do_BANG] = ACTIONS(4091),
    [anon_sym_begin] = ACTIONS(4093),
    [anon_sym_LPAREN2] = ACTIONS(4093),
    [anon_sym_default] = ACTIONS(4093),
    [anon_sym_or] = ACTIONS(4093),
    [anon_sym_static] = ACTIONS(4093),
    [anon_sym_member] = ACTIONS(4093),
    [anon_sym_interface] = ACTIONS(4093),
    [anon_sym_abstract] = ACTIONS(4093),
    [anon_sym_val] = ACTIONS(4093),
    [anon_sym_override] = ACTIONS(4093),
    [anon_sym_inherit] = ACTIONS(4093),
    [aux_sym_char_token1] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4093),
    [anon_sym_DQUOTE] = ACTIONS(4093),
    [anon_sym_AT_DQUOTE] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [sym_bool] = ACTIONS(4093),
    [sym_unit] = ACTIONS(4091),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4093),
    [sym_op_identifier] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS_DOT] = ACTIONS(4093),
    [anon_sym_DASH_DOT] = ACTIONS(4093),
    [anon_sym_PERCENT] = ACTIONS(4093),
    [anon_sym_AMP_AMP] = ACTIONS(4093),
    [anon_sym_TILDE] = ACTIONS(4091),
    [aux_sym_prefix_op_token1] = ACTIONS(4093),
    [aux_sym_infix_op_token1] = ACTIONS(4091),
    [aux_sym_infix_op_token2] = ACTIONS(4093),
    [anon_sym_PIPE_PIPE] = ACTIONS(4093),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_COLON_EQ] = ACTIONS(4091),
    [anon_sym_DOLLAR] = ACTIONS(4093),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4093),
    [sym_int] = ACTIONS(4093),
    [sym_xint] = ACTIONS(4091),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4091),
    [anon_sym_POUNDendif] = ACTIONS(4091),
    [sym__newline] = ACTIONS(4091),
  },
  [2107] = {
    [sym_block_comment] = STATE(2107),
    [sym_compiler_directive_decl] = STATE(2107),
    [sym_fsi_directive_decl] = STATE(2107),
    [sym_preproc_line] = STATE(2107),
    [sym_identifier] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4246),
    [anon_sym_LBRACK_LT] = ACTIONS(4246),
    [anon_sym_COLON] = ACTIONS(4248),
    [anon_sym_return] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4248),
    [anon_sym_let] = ACTIONS(4248),
    [anon_sym_let_BANG] = ACTIONS(4246),
    [aux_sym_access_modifier_token1] = ACTIONS(4246),
    [anon_sym_LPAREN] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_null] = ACTIONS(4248),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4248),
    [anon_sym_LT_AT] = ACTIONS(4248),
    [anon_sym_LT_AT_AT] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4246),
    [anon_sym_new] = ACTIONS(4248),
    [anon_sym_with] = ACTIONS(4248),
    [anon_sym_return_BANG] = ACTIONS(4246),
    [anon_sym_yield] = ACTIONS(4248),
    [anon_sym_yield_BANG] = ACTIONS(4246),
    [anon_sym_lazy] = ACTIONS(4248),
    [anon_sym_assert] = ACTIONS(4248),
    [anon_sym_upcast] = ACTIONS(4248),
    [anon_sym_downcast] = ACTIONS(4248),
    [anon_sym_COLON_GT] = ACTIONS(4246),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4246),
    [anon_sym_for] = ACTIONS(4248),
    [anon_sym_while] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4248),
    [anon_sym_fun] = ACTIONS(4248),
    [anon_sym_try] = ACTIONS(4248),
    [anon_sym_match] = ACTIONS(4248),
    [anon_sym_match_BANG] = ACTIONS(4246),
    [anon_sym_function] = ACTIONS(4248),
    [anon_sym_LT_DASH] = ACTIONS(4248),
    [anon_sym_DOT_LBRACK] = ACTIONS(4246),
    [anon_sym_LT] = ACTIONS(4246),
    [anon_sym_use] = ACTIONS(4248),
    [anon_sym_use_BANG] = ACTIONS(4246),
    [anon_sym_do_BANG] = ACTIONS(4246),
    [anon_sym_begin] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_default] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4248),
    [anon_sym_static] = ACTIONS(4248),
    [anon_sym_member] = ACTIONS(4248),
    [anon_sym_interface] = ACTIONS(4248),
    [anon_sym_abstract] = ACTIONS(4248),
    [anon_sym_val] = ACTIONS(4248),
    [anon_sym_override] = ACTIONS(4248),
    [anon_sym_inherit] = ACTIONS(4248),
    [aux_sym_char_token1] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4248),
    [anon_sym_DQUOTE] = ACTIONS(4248),
    [anon_sym_AT_DQUOTE] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [sym_bool] = ACTIONS(4248),
    [sym_unit] = ACTIONS(4246),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4248),
    [sym_op_identifier] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_DOT] = ACTIONS(4248),
    [anon_sym_DASH_DOT] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_TILDE] = ACTIONS(4246),
    [aux_sym_prefix_op_token1] = ACTIONS(4248),
    [aux_sym_infix_op_token1] = ACTIONS(4246),
    [aux_sym_infix_op_token2] = ACTIONS(4248),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_COLON_EQ] = ACTIONS(4246),
    [anon_sym_DOLLAR] = ACTIONS(4248),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4248),
    [sym_int] = ACTIONS(4248),
    [sym_xint] = ACTIONS(4246),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4246),
    [anon_sym_POUNDendif] = ACTIONS(4246),
    [sym__newline] = ACTIONS(4246),
  },
  [2108] = {
    [sym_block_comment] = STATE(2108),
    [sym_compiler_directive_decl] = STATE(2108),
    [sym_fsi_directive_decl] = STATE(2108),
    [sym_preproc_line] = STATE(2108),
    [sym_identifier] = ACTIONS(4118),
    [anon_sym_EQ] = ACTIONS(4116),
    [anon_sym_LBRACK_LT] = ACTIONS(4116),
    [anon_sym_COLON] = ACTIONS(4118),
    [anon_sym_return] = ACTIONS(4118),
    [anon_sym_do] = ACTIONS(4118),
    [anon_sym_and] = ACTIONS(4118),
    [anon_sym_let] = ACTIONS(4118),
    [anon_sym_let_BANG] = ACTIONS(4116),
    [aux_sym_access_modifier_token1] = ACTIONS(4116),
    [anon_sym_LPAREN] = ACTIONS(4118),
    [anon_sym_COMMA] = ACTIONS(4116),
    [anon_sym_null] = ACTIONS(4118),
    [anon_sym_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_COLON] = ACTIONS(4116),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4118),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(4118),
    [anon_sym_LT_AT] = ACTIONS(4118),
    [anon_sym_LT_AT_AT] = ACTIONS(4118),
    [anon_sym_DOT] = ACTIONS(4118),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4116),
    [anon_sym_new] = ACTIONS(4118),
    [anon_sym_with] = ACTIONS(4118),
    [anon_sym_return_BANG] = ACTIONS(4116),
    [anon_sym_yield] = ACTIONS(4118),
    [anon_sym_yield_BANG] = ACTIONS(4116),
    [anon_sym_lazy] = ACTIONS(4118),
    [anon_sym_assert] = ACTIONS(4118),
    [anon_sym_upcast] = ACTIONS(4118),
    [anon_sym_downcast] = ACTIONS(4118),
    [anon_sym_COLON_GT] = ACTIONS(4116),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4116),
    [anon_sym_for] = ACTIONS(4118),
    [anon_sym_while] = ACTIONS(4118),
    [anon_sym_if] = ACTIONS(4118),
    [anon_sym_fun] = ACTIONS(4118),
    [anon_sym_try] = ACTIONS(4118),
    [anon_sym_match] = ACTIONS(4118),
    [anon_sym_match_BANG] = ACTIONS(4116),
    [anon_sym_function] = ACTIONS(4118),
    [anon_sym_LT_DASH] = ACTIONS(4118),
    [anon_sym_DOT_LBRACK] = ACTIONS(4116),
    [anon_sym_LT] = ACTIONS(4116),
    [anon_sym_use] = ACTIONS(4118),
    [anon_sym_use_BANG] = ACTIONS(4116),
    [anon_sym_do_BANG] = ACTIONS(4116),
    [anon_sym_begin] = ACTIONS(4118),
    [anon_sym_LPAREN2] = ACTIONS(4118),
    [anon_sym_default] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [anon_sym_static] = ACTIONS(4118),
    [anon_sym_member] = ACTIONS(4118),
    [anon_sym_interface] = ACTIONS(4118),
    [anon_sym_abstract] = ACTIONS(4118),
    [anon_sym_val] = ACTIONS(4118),
    [anon_sym_override] = ACTIONS(4118),
    [aux_sym_char_token1] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4118),
    [anon_sym_DQUOTE] = ACTIONS(4118),
    [anon_sym_AT_DQUOTE] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [sym_bool] = ACTIONS(4118),
    [sym_unit] = ACTIONS(4116),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4118),
    [sym_op_identifier] = ACTIONS(4118),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_PLUS_DOT] = ACTIONS(4118),
    [anon_sym_DASH_DOT] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_AMP_AMP] = ACTIONS(4118),
    [anon_sym_TILDE] = ACTIONS(4116),
    [aux_sym_prefix_op_token1] = ACTIONS(4118),
    [aux_sym_infix_op_token1] = ACTIONS(4116),
    [aux_sym_infix_op_token2] = ACTIONS(4118),
    [anon_sym_PIPE_PIPE] = ACTIONS(4118),
    [anon_sym_BANG_EQ] = ACTIONS(4118),
    [anon_sym_COLON_EQ] = ACTIONS(4116),
    [anon_sym_DOLLAR] = ACTIONS(4118),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4118),
    [sym_int] = ACTIONS(4118),
    [sym_xint] = ACTIONS(4116),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4116),
    [anon_sym_POUNDendif] = ACTIONS(4116),
    [sym__newline] = ACTIONS(4116),
  },
  [2109] = {
    [sym_block_comment] = STATE(2109),
    [sym_compiler_directive_decl] = STATE(2109),
    [sym_fsi_directive_decl] = STATE(2109),
    [sym_preproc_line] = STATE(2109),
    [sym_identifier] = ACTIONS(4108),
    [anon_sym_EQ] = ACTIONS(4106),
    [anon_sym_LBRACK_LT] = ACTIONS(4106),
    [anon_sym_COLON] = ACTIONS(4108),
    [anon_sym_return] = ACTIONS(4108),
    [anon_sym_do] = ACTIONS(4108),
    [anon_sym_let] = ACTIONS(4108),
    [anon_sym_let_BANG] = ACTIONS(4106),
    [aux_sym_access_modifier_token1] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(4108),
    [anon_sym_COMMA] = ACTIONS(4106),
    [anon_sym_null] = ACTIONS(4108),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_COLON] = ACTIONS(4106),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LBRACK] = ACTIONS(4108),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(4108),
    [anon_sym_LT_AT] = ACTIONS(4108),
    [anon_sym_LT_AT_AT] = ACTIONS(4108),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4106),
    [anon_sym_new] = ACTIONS(4108),
    [anon_sym_with] = ACTIONS(4108),
    [anon_sym_return_BANG] = ACTIONS(4106),
    [anon_sym_yield] = ACTIONS(4108),
    [anon_sym_yield_BANG] = ACTIONS(4106),
    [anon_sym_lazy] = ACTIONS(4108),
    [anon_sym_assert] = ACTIONS(4108),
    [anon_sym_upcast] = ACTIONS(4108),
    [anon_sym_downcast] = ACTIONS(4108),
    [anon_sym_COLON_GT] = ACTIONS(4106),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4106),
    [anon_sym_for] = ACTIONS(4108),
    [anon_sym_while] = ACTIONS(4108),
    [anon_sym_if] = ACTIONS(4108),
    [anon_sym_fun] = ACTIONS(4108),
    [anon_sym_try] = ACTIONS(4108),
    [anon_sym_match] = ACTIONS(4108),
    [anon_sym_match_BANG] = ACTIONS(4106),
    [anon_sym_function] = ACTIONS(4108),
    [anon_sym_LT_DASH] = ACTIONS(4108),
    [anon_sym_DOT_LBRACK] = ACTIONS(4106),
    [anon_sym_LT] = ACTIONS(4106),
    [anon_sym_use] = ACTIONS(4108),
    [anon_sym_use_BANG] = ACTIONS(4106),
    [anon_sym_do_BANG] = ACTIONS(4106),
    [anon_sym_begin] = ACTIONS(4108),
    [anon_sym_LPAREN2] = ACTIONS(4108),
    [anon_sym_default] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [anon_sym_static] = ACTIONS(4108),
    [anon_sym_member] = ACTIONS(4108),
    [anon_sym_interface] = ACTIONS(4108),
    [anon_sym_abstract] = ACTIONS(4108),
    [anon_sym_val] = ACTIONS(4108),
    [anon_sym_override] = ACTIONS(4108),
    [anon_sym_inherit] = ACTIONS(4108),
    [aux_sym_char_token1] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4108),
    [anon_sym_DQUOTE] = ACTIONS(4108),
    [anon_sym_AT_DQUOTE] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [sym_bool] = ACTIONS(4108),
    [sym_unit] = ACTIONS(4106),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4108),
    [sym_op_identifier] = ACTIONS(4108),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_PLUS_DOT] = ACTIONS(4108),
    [anon_sym_DASH_DOT] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_AMP_AMP] = ACTIONS(4108),
    [anon_sym_TILDE] = ACTIONS(4106),
    [aux_sym_prefix_op_token1] = ACTIONS(4108),
    [aux_sym_infix_op_token1] = ACTIONS(4106),
    [aux_sym_infix_op_token2] = ACTIONS(4108),
    [anon_sym_PIPE_PIPE] = ACTIONS(4108),
    [anon_sym_BANG_EQ] = ACTIONS(4108),
    [anon_sym_COLON_EQ] = ACTIONS(4106),
    [anon_sym_DOLLAR] = ACTIONS(4108),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4108),
    [sym_int] = ACTIONS(4108),
    [sym_xint] = ACTIONS(4106),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4106),
    [anon_sym_POUNDendif] = ACTIONS(4106),
    [sym__newline] = ACTIONS(4106),
  },
  [2110] = {
    [sym_block_comment] = STATE(2110),
    [sym_compiler_directive_decl] = STATE(2110),
    [sym_fsi_directive_decl] = STATE(2110),
    [sym_preproc_line] = STATE(2110),
    [sym_identifier] = ACTIONS(4122),
    [anon_sym_EQ] = ACTIONS(4120),
    [anon_sym_LBRACK_LT] = ACTIONS(4120),
    [anon_sym_COLON] = ACTIONS(4122),
    [anon_sym_return] = ACTIONS(4122),
    [anon_sym_do] = ACTIONS(4122),
    [anon_sym_and] = ACTIONS(4122),
    [anon_sym_let] = ACTIONS(4122),
    [anon_sym_let_BANG] = ACTIONS(4120),
    [aux_sym_access_modifier_token1] = ACTIONS(4120),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_COMMA] = ACTIONS(4120),
    [anon_sym_null] = ACTIONS(4122),
    [anon_sym_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_COLON] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_LT_AT] = ACTIONS(4122),
    [anon_sym_LT_AT_AT] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4122),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4120),
    [anon_sym_new] = ACTIONS(4122),
    [anon_sym_with] = ACTIONS(4122),
    [anon_sym_return_BANG] = ACTIONS(4120),
    [anon_sym_yield] = ACTIONS(4122),
    [anon_sym_yield_BANG] = ACTIONS(4120),
    [anon_sym_lazy] = ACTIONS(4122),
    [anon_sym_assert] = ACTIONS(4122),
    [anon_sym_upcast] = ACTIONS(4122),
    [anon_sym_downcast] = ACTIONS(4122),
    [anon_sym_COLON_GT] = ACTIONS(4120),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4120),
    [anon_sym_for] = ACTIONS(4122),
    [anon_sym_while] = ACTIONS(4122),
    [anon_sym_if] = ACTIONS(4122),
    [anon_sym_fun] = ACTIONS(4122),
    [anon_sym_try] = ACTIONS(4122),
    [anon_sym_match] = ACTIONS(4122),
    [anon_sym_match_BANG] = ACTIONS(4120),
    [anon_sym_function] = ACTIONS(4122),
    [anon_sym_LT_DASH] = ACTIONS(4122),
    [anon_sym_DOT_LBRACK] = ACTIONS(4120),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_use] = ACTIONS(4122),
    [anon_sym_use_BANG] = ACTIONS(4120),
    [anon_sym_do_BANG] = ACTIONS(4120),
    [anon_sym_begin] = ACTIONS(4122),
    [anon_sym_LPAREN2] = ACTIONS(4122),
    [anon_sym_default] = ACTIONS(4122),
    [anon_sym_or] = ACTIONS(4122),
    [anon_sym_static] = ACTIONS(4122),
    [anon_sym_member] = ACTIONS(4122),
    [anon_sym_interface] = ACTIONS(4122),
    [anon_sym_abstract] = ACTIONS(4122),
    [anon_sym_val] = ACTIONS(4122),
    [anon_sym_override] = ACTIONS(4122),
    [aux_sym_char_token1] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4122),
    [anon_sym_DQUOTE] = ACTIONS(4122),
    [anon_sym_AT_DQUOTE] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [sym_bool] = ACTIONS(4122),
    [sym_unit] = ACTIONS(4120),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4122),
    [sym_op_identifier] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4122),
    [anon_sym_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_DOT] = ACTIONS(4122),
    [anon_sym_DASH_DOT] = ACTIONS(4122),
    [anon_sym_PERCENT] = ACTIONS(4122),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_TILDE] = ACTIONS(4120),
    [aux_sym_prefix_op_token1] = ACTIONS(4122),
    [aux_sym_infix_op_token1] = ACTIONS(4120),
    [aux_sym_infix_op_token2] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_COLON_EQ] = ACTIONS(4120),
    [anon_sym_DOLLAR] = ACTIONS(4122),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4122),
    [sym_int] = ACTIONS(4122),
    [sym_xint] = ACTIONS(4120),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4120),
    [anon_sym_POUNDendif] = ACTIONS(4120),
    [sym__newline] = ACTIONS(4120),
  },
  [2111] = {
    [sym_block_comment] = STATE(2111),
    [sym_compiler_directive_decl] = STATE(2111),
    [sym_fsi_directive_decl] = STATE(2111),
    [sym_preproc_line] = STATE(2111),
    [sym_identifier] = ACTIONS(4126),
    [anon_sym_EQ] = ACTIONS(4124),
    [anon_sym_LBRACK_LT] = ACTIONS(4124),
    [anon_sym_COLON] = ACTIONS(4126),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_do] = ACTIONS(4126),
    [anon_sym_and] = ACTIONS(4126),
    [anon_sym_let] = ACTIONS(4126),
    [anon_sym_let_BANG] = ACTIONS(4124),
    [aux_sym_access_modifier_token1] = ACTIONS(4124),
    [anon_sym_LPAREN] = ACTIONS(4126),
    [anon_sym_COMMA] = ACTIONS(4124),
    [anon_sym_null] = ACTIONS(4126),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_COLON] = ACTIONS(4124),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LBRACK] = ACTIONS(4126),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4126),
    [anon_sym_LT_AT] = ACTIONS(4126),
    [anon_sym_LT_AT_AT] = ACTIONS(4126),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4124),
    [anon_sym_new] = ACTIONS(4126),
    [anon_sym_with] = ACTIONS(4126),
    [anon_sym_return_BANG] = ACTIONS(4124),
    [anon_sym_yield] = ACTIONS(4126),
    [anon_sym_yield_BANG] = ACTIONS(4124),
    [anon_sym_lazy] = ACTIONS(4126),
    [anon_sym_assert] = ACTIONS(4126),
    [anon_sym_upcast] = ACTIONS(4126),
    [anon_sym_downcast] = ACTIONS(4126),
    [anon_sym_COLON_GT] = ACTIONS(4124),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4124),
    [anon_sym_for] = ACTIONS(4126),
    [anon_sym_while] = ACTIONS(4126),
    [anon_sym_if] = ACTIONS(4126),
    [anon_sym_fun] = ACTIONS(4126),
    [anon_sym_try] = ACTIONS(4126),
    [anon_sym_match] = ACTIONS(4126),
    [anon_sym_match_BANG] = ACTIONS(4124),
    [anon_sym_function] = ACTIONS(4126),
    [anon_sym_LT_DASH] = ACTIONS(4126),
    [anon_sym_DOT_LBRACK] = ACTIONS(4124),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_use] = ACTIONS(4126),
    [anon_sym_use_BANG] = ACTIONS(4124),
    [anon_sym_do_BANG] = ACTIONS(4124),
    [anon_sym_begin] = ACTIONS(4126),
    [anon_sym_LPAREN2] = ACTIONS(4126),
    [anon_sym_default] = ACTIONS(4126),
    [anon_sym_or] = ACTIONS(4126),
    [anon_sym_static] = ACTIONS(4126),
    [anon_sym_member] = ACTIONS(4126),
    [anon_sym_interface] = ACTIONS(4126),
    [anon_sym_abstract] = ACTIONS(4126),
    [anon_sym_val] = ACTIONS(4126),
    [anon_sym_override] = ACTIONS(4126),
    [aux_sym_char_token1] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4126),
    [anon_sym_DQUOTE] = ACTIONS(4126),
    [anon_sym_AT_DQUOTE] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [sym_bool] = ACTIONS(4126),
    [sym_unit] = ACTIONS(4124),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4126),
    [sym_op_identifier] = ACTIONS(4126),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_PLUS_DOT] = ACTIONS(4126),
    [anon_sym_DASH_DOT] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_AMP_AMP] = ACTIONS(4126),
    [anon_sym_TILDE] = ACTIONS(4124),
    [aux_sym_prefix_op_token1] = ACTIONS(4126),
    [aux_sym_infix_op_token1] = ACTIONS(4124),
    [aux_sym_infix_op_token2] = ACTIONS(4126),
    [anon_sym_PIPE_PIPE] = ACTIONS(4126),
    [anon_sym_BANG_EQ] = ACTIONS(4126),
    [anon_sym_COLON_EQ] = ACTIONS(4124),
    [anon_sym_DOLLAR] = ACTIONS(4126),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4126),
    [sym_int] = ACTIONS(4126),
    [sym_xint] = ACTIONS(4124),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4124),
    [anon_sym_POUNDendif] = ACTIONS(4124),
    [sym__newline] = ACTIONS(4124),
  },
  [2112] = {
    [sym_block_comment] = STATE(2112),
    [sym_compiler_directive_decl] = STATE(2112),
    [sym_fsi_directive_decl] = STATE(2112),
    [sym_preproc_line] = STATE(2112),
    [sym_identifier] = ACTIONS(4232),
    [anon_sym_EQ] = ACTIONS(4230),
    [anon_sym_LBRACK_LT] = ACTIONS(4230),
    [anon_sym_COLON] = ACTIONS(4232),
    [anon_sym_return] = ACTIONS(4232),
    [anon_sym_do] = ACTIONS(4232),
    [anon_sym_and] = ACTIONS(4232),
    [anon_sym_let] = ACTIONS(4232),
    [anon_sym_let_BANG] = ACTIONS(4230),
    [aux_sym_access_modifier_token1] = ACTIONS(4230),
    [anon_sym_LPAREN] = ACTIONS(4232),
    [anon_sym_COMMA] = ACTIONS(4230),
    [anon_sym_null] = ACTIONS(4232),
    [anon_sym_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_COLON] = ACTIONS(4230),
    [anon_sym_AMP] = ACTIONS(4232),
    [anon_sym_LBRACK] = ACTIONS(4232),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4230),
    [anon_sym_LBRACE] = ACTIONS(4232),
    [anon_sym_LT_AT] = ACTIONS(4232),
    [anon_sym_LT_AT_AT] = ACTIONS(4232),
    [anon_sym_DOT] = ACTIONS(4232),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4230),
    [anon_sym_new] = ACTIONS(4232),
    [anon_sym_with] = ACTIONS(4232),
    [anon_sym_return_BANG] = ACTIONS(4230),
    [anon_sym_yield] = ACTIONS(4232),
    [anon_sym_yield_BANG] = ACTIONS(4230),
    [anon_sym_lazy] = ACTIONS(4232),
    [anon_sym_assert] = ACTIONS(4232),
    [anon_sym_upcast] = ACTIONS(4232),
    [anon_sym_downcast] = ACTIONS(4232),
    [anon_sym_COLON_GT] = ACTIONS(4230),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4230),
    [anon_sym_for] = ACTIONS(4232),
    [anon_sym_while] = ACTIONS(4232),
    [anon_sym_if] = ACTIONS(4232),
    [anon_sym_fun] = ACTIONS(4232),
    [anon_sym_try] = ACTIONS(4232),
    [anon_sym_match] = ACTIONS(4232),
    [anon_sym_match_BANG] = ACTIONS(4230),
    [anon_sym_function] = ACTIONS(4232),
    [anon_sym_LT_DASH] = ACTIONS(4232),
    [anon_sym_DOT_LBRACK] = ACTIONS(4230),
    [anon_sym_LT] = ACTIONS(4230),
    [anon_sym_use] = ACTIONS(4232),
    [anon_sym_use_BANG] = ACTIONS(4230),
    [anon_sym_do_BANG] = ACTIONS(4230),
    [anon_sym_begin] = ACTIONS(4232),
    [anon_sym_LPAREN2] = ACTIONS(4232),
    [anon_sym_default] = ACTIONS(4232),
    [anon_sym_or] = ACTIONS(4232),
    [anon_sym_static] = ACTIONS(4232),
    [anon_sym_member] = ACTIONS(4232),
    [anon_sym_interface] = ACTIONS(4232),
    [anon_sym_abstract] = ACTIONS(4232),
    [anon_sym_val] = ACTIONS(4232),
    [anon_sym_override] = ACTIONS(4232),
    [aux_sym_char_token1] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4232),
    [anon_sym_DQUOTE] = ACTIONS(4232),
    [anon_sym_AT_DQUOTE] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [sym_bool] = ACTIONS(4232),
    [sym_unit] = ACTIONS(4230),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4232),
    [sym_op_identifier] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4232),
    [anon_sym_DASH] = ACTIONS(4232),
    [anon_sym_PLUS_DOT] = ACTIONS(4232),
    [anon_sym_DASH_DOT] = ACTIONS(4232),
    [anon_sym_PERCENT] = ACTIONS(4232),
    [anon_sym_AMP_AMP] = ACTIONS(4232),
    [anon_sym_TILDE] = ACTIONS(4230),
    [aux_sym_prefix_op_token1] = ACTIONS(4232),
    [aux_sym_infix_op_token1] = ACTIONS(4230),
    [aux_sym_infix_op_token2] = ACTIONS(4232),
    [anon_sym_PIPE_PIPE] = ACTIONS(4232),
    [anon_sym_BANG_EQ] = ACTIONS(4232),
    [anon_sym_COLON_EQ] = ACTIONS(4230),
    [anon_sym_DOLLAR] = ACTIONS(4232),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4232),
    [sym_int] = ACTIONS(4232),
    [sym_xint] = ACTIONS(4230),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4230),
    [anon_sym_POUNDendif] = ACTIONS(4230),
    [sym__newline] = ACTIONS(4230),
  },
  [2113] = {
    [sym_block_comment] = STATE(2113),
    [sym_compiler_directive_decl] = STATE(2113),
    [sym_fsi_directive_decl] = STATE(2113),
    [sym_preproc_line] = STATE(2113),
    [sym_identifier] = ACTIONS(4112),
    [anon_sym_EQ] = ACTIONS(4110),
    [anon_sym_LBRACK_LT] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4112),
    [anon_sym_return] = ACTIONS(4112),
    [anon_sym_do] = ACTIONS(4112),
    [anon_sym_let] = ACTIONS(4112),
    [anon_sym_let_BANG] = ACTIONS(4110),
    [aux_sym_access_modifier_token1] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_null] = ACTIONS(4112),
    [anon_sym_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_COLON] = ACTIONS(4110),
    [anon_sym_AMP] = ACTIONS(4112),
    [anon_sym_LBRACK] = ACTIONS(4112),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4110),
    [anon_sym_LBRACE] = ACTIONS(4112),
    [anon_sym_LT_AT] = ACTIONS(4112),
    [anon_sym_LT_AT_AT] = ACTIONS(4112),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4110),
    [anon_sym_new] = ACTIONS(4112),
    [anon_sym_with] = ACTIONS(4112),
    [anon_sym_return_BANG] = ACTIONS(4110),
    [anon_sym_yield] = ACTIONS(4112),
    [anon_sym_yield_BANG] = ACTIONS(4110),
    [anon_sym_lazy] = ACTIONS(4112),
    [anon_sym_assert] = ACTIONS(4112),
    [anon_sym_upcast] = ACTIONS(4112),
    [anon_sym_downcast] = ACTIONS(4112),
    [anon_sym_COLON_GT] = ACTIONS(4110),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4110),
    [anon_sym_for] = ACTIONS(4112),
    [anon_sym_while] = ACTIONS(4112),
    [anon_sym_if] = ACTIONS(4112),
    [anon_sym_fun] = ACTIONS(4112),
    [anon_sym_try] = ACTIONS(4112),
    [anon_sym_match] = ACTIONS(4112),
    [anon_sym_match_BANG] = ACTIONS(4110),
    [anon_sym_function] = ACTIONS(4112),
    [anon_sym_LT_DASH] = ACTIONS(4112),
    [anon_sym_DOT_LBRACK] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(4110),
    [anon_sym_use] = ACTIONS(4112),
    [anon_sym_use_BANG] = ACTIONS(4110),
    [anon_sym_do_BANG] = ACTIONS(4110),
    [anon_sym_begin] = ACTIONS(4112),
    [anon_sym_LPAREN2] = ACTIONS(4112),
    [anon_sym_default] = ACTIONS(4112),
    [anon_sym_or] = ACTIONS(4112),
    [anon_sym_static] = ACTIONS(4112),
    [anon_sym_member] = ACTIONS(4112),
    [anon_sym_interface] = ACTIONS(4112),
    [anon_sym_abstract] = ACTIONS(4112),
    [anon_sym_val] = ACTIONS(4112),
    [anon_sym_override] = ACTIONS(4112),
    [anon_sym_inherit] = ACTIONS(4112),
    [aux_sym_char_token1] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4112),
    [anon_sym_DQUOTE] = ACTIONS(4112),
    [anon_sym_AT_DQUOTE] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [sym_bool] = ACTIONS(4112),
    [sym_unit] = ACTIONS(4110),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4112),
    [sym_op_identifier] = ACTIONS(4112),
    [anon_sym_PLUS] = ACTIONS(4112),
    [anon_sym_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_DOT] = ACTIONS(4112),
    [anon_sym_DASH_DOT] = ACTIONS(4112),
    [anon_sym_PERCENT] = ACTIONS(4112),
    [anon_sym_AMP_AMP] = ACTIONS(4112),
    [anon_sym_TILDE] = ACTIONS(4110),
    [aux_sym_prefix_op_token1] = ACTIONS(4112),
    [aux_sym_infix_op_token1] = ACTIONS(4110),
    [aux_sym_infix_op_token2] = ACTIONS(4112),
    [anon_sym_PIPE_PIPE] = ACTIONS(4112),
    [anon_sym_BANG_EQ] = ACTIONS(4112),
    [anon_sym_COLON_EQ] = ACTIONS(4110),
    [anon_sym_DOLLAR] = ACTIONS(4112),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4112),
    [sym_int] = ACTIONS(4112),
    [sym_xint] = ACTIONS(4110),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4110),
    [anon_sym_POUNDendif] = ACTIONS(4110),
    [sym__newline] = ACTIONS(4110),
  },
  [2114] = {
    [sym_block_comment] = STATE(2114),
    [sym_compiler_directive_decl] = STATE(2114),
    [sym_fsi_directive_decl] = STATE(2114),
    [sym_preproc_line] = STATE(2114),
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_EQ] = ACTIONS(4149),
    [anon_sym_LBRACK_LT] = ACTIONS(4149),
    [anon_sym_COLON] = ACTIONS(4151),
    [anon_sym_return] = ACTIONS(4151),
    [anon_sym_do] = ACTIONS(4151),
    [anon_sym_and] = ACTIONS(4151),
    [anon_sym_let] = ACTIONS(4151),
    [anon_sym_let_BANG] = ACTIONS(4149),
    [aux_sym_access_modifier_token1] = ACTIONS(4149),
    [anon_sym_LPAREN] = ACTIONS(4151),
    [anon_sym_COMMA] = ACTIONS(4149),
    [anon_sym_null] = ACTIONS(4151),
    [anon_sym_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_AMP] = ACTIONS(4151),
    [anon_sym_LBRACK] = ACTIONS(4151),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4149),
    [anon_sym_LBRACE] = ACTIONS(4151),
    [anon_sym_LT_AT] = ACTIONS(4151),
    [anon_sym_LT_AT_AT] = ACTIONS(4151),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4149),
    [anon_sym_new] = ACTIONS(4151),
    [anon_sym_with] = ACTIONS(4151),
    [anon_sym_return_BANG] = ACTIONS(4149),
    [anon_sym_yield] = ACTIONS(4151),
    [anon_sym_yield_BANG] = ACTIONS(4149),
    [anon_sym_lazy] = ACTIONS(4151),
    [anon_sym_assert] = ACTIONS(4151),
    [anon_sym_upcast] = ACTIONS(4151),
    [anon_sym_downcast] = ACTIONS(4151),
    [anon_sym_COLON_GT] = ACTIONS(4149),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4149),
    [anon_sym_for] = ACTIONS(4151),
    [anon_sym_while] = ACTIONS(4151),
    [anon_sym_if] = ACTIONS(4151),
    [anon_sym_fun] = ACTIONS(4151),
    [anon_sym_try] = ACTIONS(4151),
    [anon_sym_match] = ACTIONS(4151),
    [anon_sym_match_BANG] = ACTIONS(4149),
    [anon_sym_function] = ACTIONS(4151),
    [anon_sym_LT_DASH] = ACTIONS(4151),
    [anon_sym_DOT_LBRACK] = ACTIONS(4149),
    [anon_sym_LT] = ACTIONS(4149),
    [anon_sym_use] = ACTIONS(4151),
    [anon_sym_use_BANG] = ACTIONS(4149),
    [anon_sym_do_BANG] = ACTIONS(4149),
    [anon_sym_begin] = ACTIONS(4151),
    [anon_sym_LPAREN2] = ACTIONS(4151),
    [anon_sym_default] = ACTIONS(4151),
    [anon_sym_or] = ACTIONS(4151),
    [anon_sym_static] = ACTIONS(4151),
    [anon_sym_member] = ACTIONS(4151),
    [anon_sym_interface] = ACTIONS(4151),
    [anon_sym_abstract] = ACTIONS(4151),
    [anon_sym_val] = ACTIONS(4151),
    [anon_sym_override] = ACTIONS(4151),
    [aux_sym_char_token1] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4151),
    [anon_sym_DQUOTE] = ACTIONS(4151),
    [anon_sym_AT_DQUOTE] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [sym_bool] = ACTIONS(4151),
    [sym_unit] = ACTIONS(4149),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4151),
    [sym_op_identifier] = ACTIONS(4151),
    [anon_sym_PLUS] = ACTIONS(4151),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_PLUS_DOT] = ACTIONS(4151),
    [anon_sym_DASH_DOT] = ACTIONS(4151),
    [anon_sym_PERCENT] = ACTIONS(4151),
    [anon_sym_AMP_AMP] = ACTIONS(4151),
    [anon_sym_TILDE] = ACTIONS(4149),
    [aux_sym_prefix_op_token1] = ACTIONS(4151),
    [aux_sym_infix_op_token1] = ACTIONS(4149),
    [aux_sym_infix_op_token2] = ACTIONS(4151),
    [anon_sym_PIPE_PIPE] = ACTIONS(4151),
    [anon_sym_BANG_EQ] = ACTIONS(4151),
    [anon_sym_COLON_EQ] = ACTIONS(4149),
    [anon_sym_DOLLAR] = ACTIONS(4151),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4151),
    [sym_int] = ACTIONS(4151),
    [sym_xint] = ACTIONS(4149),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4149),
    [sym__newline] = ACTIONS(4149),
    [sym__dedent] = ACTIONS(4149),
  },
  [2115] = {
    [sym_block_comment] = STATE(2115),
    [sym_compiler_directive_decl] = STATE(2115),
    [sym_fsi_directive_decl] = STATE(2115),
    [sym_preproc_line] = STATE(2115),
    [sym_identifier] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4242),
    [anon_sym_LBRACK_LT] = ACTIONS(4242),
    [anon_sym_COLON] = ACTIONS(4244),
    [anon_sym_return] = ACTIONS(4244),
    [anon_sym_do] = ACTIONS(4244),
    [anon_sym_let] = ACTIONS(4244),
    [anon_sym_let_BANG] = ACTIONS(4242),
    [aux_sym_access_modifier_token1] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_null] = ACTIONS(4244),
    [anon_sym_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_COLON] = ACTIONS(4242),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4244),
    [anon_sym_LT_AT] = ACTIONS(4244),
    [anon_sym_LT_AT_AT] = ACTIONS(4244),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4242),
    [anon_sym_new] = ACTIONS(4244),
    [anon_sym_with] = ACTIONS(4244),
    [anon_sym_return_BANG] = ACTIONS(4242),
    [anon_sym_yield] = ACTIONS(4244),
    [anon_sym_yield_BANG] = ACTIONS(4242),
    [anon_sym_lazy] = ACTIONS(4244),
    [anon_sym_assert] = ACTIONS(4244),
    [anon_sym_upcast] = ACTIONS(4244),
    [anon_sym_downcast] = ACTIONS(4244),
    [anon_sym_COLON_GT] = ACTIONS(4242),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4242),
    [anon_sym_for] = ACTIONS(4244),
    [anon_sym_while] = ACTIONS(4244),
    [anon_sym_if] = ACTIONS(4244),
    [anon_sym_fun] = ACTIONS(4244),
    [anon_sym_try] = ACTIONS(4244),
    [anon_sym_match] = ACTIONS(4244),
    [anon_sym_match_BANG] = ACTIONS(4242),
    [anon_sym_function] = ACTIONS(4244),
    [anon_sym_LT_DASH] = ACTIONS(4244),
    [anon_sym_DOT_LBRACK] = ACTIONS(4242),
    [anon_sym_LT] = ACTIONS(4242),
    [anon_sym_use] = ACTIONS(4244),
    [anon_sym_use_BANG] = ACTIONS(4242),
    [anon_sym_do_BANG] = ACTIONS(4242),
    [anon_sym_begin] = ACTIONS(4244),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_default] = ACTIONS(4244),
    [anon_sym_or] = ACTIONS(4244),
    [anon_sym_static] = ACTIONS(4244),
    [anon_sym_member] = ACTIONS(4244),
    [anon_sym_interface] = ACTIONS(4244),
    [anon_sym_abstract] = ACTIONS(4244),
    [anon_sym_val] = ACTIONS(4244),
    [anon_sym_override] = ACTIONS(4244),
    [anon_sym_inherit] = ACTIONS(4244),
    [aux_sym_char_token1] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4244),
    [anon_sym_DQUOTE] = ACTIONS(4244),
    [anon_sym_AT_DQUOTE] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [sym_bool] = ACTIONS(4244),
    [sym_unit] = ACTIONS(4242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4244),
    [sym_op_identifier] = ACTIONS(4244),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_DASH] = ACTIONS(4244),
    [anon_sym_PLUS_DOT] = ACTIONS(4244),
    [anon_sym_DASH_DOT] = ACTIONS(4244),
    [anon_sym_PERCENT] = ACTIONS(4244),
    [anon_sym_AMP_AMP] = ACTIONS(4244),
    [anon_sym_TILDE] = ACTIONS(4242),
    [aux_sym_prefix_op_token1] = ACTIONS(4244),
    [aux_sym_infix_op_token1] = ACTIONS(4242),
    [aux_sym_infix_op_token2] = ACTIONS(4244),
    [anon_sym_PIPE_PIPE] = ACTIONS(4244),
    [anon_sym_BANG_EQ] = ACTIONS(4244),
    [anon_sym_COLON_EQ] = ACTIONS(4242),
    [anon_sym_DOLLAR] = ACTIONS(4244),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4244),
    [sym_int] = ACTIONS(4244),
    [sym_xint] = ACTIONS(4242),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4242),
    [anon_sym_POUNDendif] = ACTIONS(4242),
    [sym__newline] = ACTIONS(4242),
  },
  [2116] = {
    [sym_block_comment] = STATE(2116),
    [sym_compiler_directive_decl] = STATE(2116),
    [sym_fsi_directive_decl] = STATE(2116),
    [sym_preproc_line] = STATE(2116),
    [sym_identifier] = ACTIONS(4240),
    [anon_sym_EQ] = ACTIONS(4238),
    [anon_sym_LBRACK_LT] = ACTIONS(4238),
    [anon_sym_COLON] = ACTIONS(4240),
    [anon_sym_return] = ACTIONS(4240),
    [anon_sym_do] = ACTIONS(4240),
    [anon_sym_let] = ACTIONS(4240),
    [anon_sym_let_BANG] = ACTIONS(4238),
    [aux_sym_access_modifier_token1] = ACTIONS(4238),
    [anon_sym_LPAREN] = ACTIONS(4240),
    [anon_sym_COMMA] = ACTIONS(4238),
    [anon_sym_null] = ACTIONS(4240),
    [anon_sym_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_COLON] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4240),
    [anon_sym_LBRACK] = ACTIONS(4240),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4238),
    [anon_sym_LBRACE] = ACTIONS(4240),
    [anon_sym_LT_AT] = ACTIONS(4240),
    [anon_sym_LT_AT_AT] = ACTIONS(4240),
    [anon_sym_DOT] = ACTIONS(4240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4238),
    [anon_sym_new] = ACTIONS(4240),
    [anon_sym_with] = ACTIONS(4240),
    [anon_sym_return_BANG] = ACTIONS(4238),
    [anon_sym_yield] = ACTIONS(4240),
    [anon_sym_yield_BANG] = ACTIONS(4238),
    [anon_sym_lazy] = ACTIONS(4240),
    [anon_sym_assert] = ACTIONS(4240),
    [anon_sym_upcast] = ACTIONS(4240),
    [anon_sym_downcast] = ACTIONS(4240),
    [anon_sym_COLON_GT] = ACTIONS(4238),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4238),
    [anon_sym_for] = ACTIONS(4240),
    [anon_sym_while] = ACTIONS(4240),
    [anon_sym_if] = ACTIONS(4240),
    [anon_sym_fun] = ACTIONS(4240),
    [anon_sym_try] = ACTIONS(4240),
    [anon_sym_match] = ACTIONS(4240),
    [anon_sym_match_BANG] = ACTIONS(4238),
    [anon_sym_function] = ACTIONS(4240),
    [anon_sym_LT_DASH] = ACTIONS(4240),
    [anon_sym_DOT_LBRACK] = ACTIONS(4238),
    [anon_sym_LT] = ACTIONS(4238),
    [anon_sym_use] = ACTIONS(4240),
    [anon_sym_use_BANG] = ACTIONS(4238),
    [anon_sym_do_BANG] = ACTIONS(4238),
    [anon_sym_begin] = ACTIONS(4240),
    [anon_sym_LPAREN2] = ACTIONS(4240),
    [anon_sym_default] = ACTIONS(4240),
    [anon_sym_or] = ACTIONS(4240),
    [anon_sym_static] = ACTIONS(4240),
    [anon_sym_member] = ACTIONS(4240),
    [anon_sym_interface] = ACTIONS(4240),
    [anon_sym_abstract] = ACTIONS(4240),
    [anon_sym_val] = ACTIONS(4240),
    [anon_sym_override] = ACTIONS(4240),
    [anon_sym_inherit] = ACTIONS(4240),
    [aux_sym_char_token1] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4240),
    [anon_sym_DQUOTE] = ACTIONS(4240),
    [anon_sym_AT_DQUOTE] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [sym_bool] = ACTIONS(4240),
    [sym_unit] = ACTIONS(4238),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4240),
    [sym_op_identifier] = ACTIONS(4240),
    [anon_sym_PLUS] = ACTIONS(4240),
    [anon_sym_DASH] = ACTIONS(4240),
    [anon_sym_PLUS_DOT] = ACTIONS(4240),
    [anon_sym_DASH_DOT] = ACTIONS(4240),
    [anon_sym_PERCENT] = ACTIONS(4240),
    [anon_sym_AMP_AMP] = ACTIONS(4240),
    [anon_sym_TILDE] = ACTIONS(4238),
    [aux_sym_prefix_op_token1] = ACTIONS(4240),
    [aux_sym_infix_op_token1] = ACTIONS(4238),
    [aux_sym_infix_op_token2] = ACTIONS(4240),
    [anon_sym_PIPE_PIPE] = ACTIONS(4240),
    [anon_sym_BANG_EQ] = ACTIONS(4240),
    [anon_sym_COLON_EQ] = ACTIONS(4238),
    [anon_sym_DOLLAR] = ACTIONS(4240),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4240),
    [sym_int] = ACTIONS(4240),
    [sym_xint] = ACTIONS(4238),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4238),
    [anon_sym_POUNDendif] = ACTIONS(4238),
    [sym__newline] = ACTIONS(4238),
  },
  [2117] = {
    [sym_block_comment] = STATE(2117),
    [sym_compiler_directive_decl] = STATE(2117),
    [sym_fsi_directive_decl] = STATE(2117),
    [sym_preproc_line] = STATE(2117),
    [sym_identifier] = ACTIONS(4147),
    [anon_sym_EQ] = ACTIONS(4145),
    [anon_sym_LBRACK_LT] = ACTIONS(4145),
    [anon_sym_COLON] = ACTIONS(4147),
    [anon_sym_return] = ACTIONS(4147),
    [anon_sym_do] = ACTIONS(4147),
    [anon_sym_and] = ACTIONS(4147),
    [anon_sym_let] = ACTIONS(4147),
    [anon_sym_let_BANG] = ACTIONS(4145),
    [aux_sym_access_modifier_token1] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(4147),
    [anon_sym_COMMA] = ACTIONS(4145),
    [anon_sym_null] = ACTIONS(4147),
    [anon_sym_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_COLON] = ACTIONS(4145),
    [anon_sym_AMP] = ACTIONS(4147),
    [anon_sym_LBRACK] = ACTIONS(4147),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4145),
    [anon_sym_LBRACE] = ACTIONS(4147),
    [anon_sym_LT_AT] = ACTIONS(4147),
    [anon_sym_LT_AT_AT] = ACTIONS(4147),
    [anon_sym_DOT] = ACTIONS(4147),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4145),
    [anon_sym_new] = ACTIONS(4147),
    [anon_sym_with] = ACTIONS(4147),
    [anon_sym_return_BANG] = ACTIONS(4145),
    [anon_sym_yield] = ACTIONS(4147),
    [anon_sym_yield_BANG] = ACTIONS(4145),
    [anon_sym_lazy] = ACTIONS(4147),
    [anon_sym_assert] = ACTIONS(4147),
    [anon_sym_upcast] = ACTIONS(4147),
    [anon_sym_downcast] = ACTIONS(4147),
    [anon_sym_COLON_GT] = ACTIONS(4145),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4145),
    [anon_sym_for] = ACTIONS(4147),
    [anon_sym_while] = ACTIONS(4147),
    [anon_sym_if] = ACTIONS(4147),
    [anon_sym_fun] = ACTIONS(4147),
    [anon_sym_try] = ACTIONS(4147),
    [anon_sym_match] = ACTIONS(4147),
    [anon_sym_match_BANG] = ACTIONS(4145),
    [anon_sym_function] = ACTIONS(4147),
    [anon_sym_LT_DASH] = ACTIONS(4147),
    [anon_sym_DOT_LBRACK] = ACTIONS(4145),
    [anon_sym_LT] = ACTIONS(4145),
    [anon_sym_use] = ACTIONS(4147),
    [anon_sym_use_BANG] = ACTIONS(4145),
    [anon_sym_do_BANG] = ACTIONS(4145),
    [anon_sym_begin] = ACTIONS(4147),
    [anon_sym_LPAREN2] = ACTIONS(4147),
    [anon_sym_default] = ACTIONS(4147),
    [anon_sym_or] = ACTIONS(4147),
    [anon_sym_static] = ACTIONS(4147),
    [anon_sym_member] = ACTIONS(4147),
    [anon_sym_interface] = ACTIONS(4147),
    [anon_sym_abstract] = ACTIONS(4147),
    [anon_sym_val] = ACTIONS(4147),
    [anon_sym_override] = ACTIONS(4147),
    [aux_sym_char_token1] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4147),
    [anon_sym_DQUOTE] = ACTIONS(4147),
    [anon_sym_AT_DQUOTE] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [sym_bool] = ACTIONS(4147),
    [sym_unit] = ACTIONS(4145),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4147),
    [sym_op_identifier] = ACTIONS(4147),
    [anon_sym_PLUS] = ACTIONS(4147),
    [anon_sym_DASH] = ACTIONS(4147),
    [anon_sym_PLUS_DOT] = ACTIONS(4147),
    [anon_sym_DASH_DOT] = ACTIONS(4147),
    [anon_sym_PERCENT] = ACTIONS(4147),
    [anon_sym_AMP_AMP] = ACTIONS(4147),
    [anon_sym_TILDE] = ACTIONS(4145),
    [aux_sym_prefix_op_token1] = ACTIONS(4147),
    [aux_sym_infix_op_token1] = ACTIONS(4145),
    [aux_sym_infix_op_token2] = ACTIONS(4147),
    [anon_sym_PIPE_PIPE] = ACTIONS(4147),
    [anon_sym_BANG_EQ] = ACTIONS(4147),
    [anon_sym_COLON_EQ] = ACTIONS(4145),
    [anon_sym_DOLLAR] = ACTIONS(4147),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4147),
    [sym_int] = ACTIONS(4147),
    [sym_xint] = ACTIONS(4145),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4145),
    [sym__newline] = ACTIONS(4145),
    [sym__dedent] = ACTIONS(4145),
  },
  [2118] = {
    [sym_block_comment] = STATE(2118),
    [sym_compiler_directive_decl] = STATE(2118),
    [sym_fsi_directive_decl] = STATE(2118),
    [sym_preproc_line] = STATE(2118),
    [sym_identifier] = ACTIONS(4236),
    [anon_sym_EQ] = ACTIONS(4234),
    [anon_sym_LBRACK_LT] = ACTIONS(4234),
    [anon_sym_COLON] = ACTIONS(4236),
    [anon_sym_return] = ACTIONS(4236),
    [anon_sym_do] = ACTIONS(4236),
    [anon_sym_let] = ACTIONS(4236),
    [anon_sym_let_BANG] = ACTIONS(4234),
    [aux_sym_access_modifier_token1] = ACTIONS(4234),
    [anon_sym_LPAREN] = ACTIONS(4236),
    [anon_sym_COMMA] = ACTIONS(4234),
    [anon_sym_null] = ACTIONS(4236),
    [anon_sym_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_COLON] = ACTIONS(4234),
    [anon_sym_AMP] = ACTIONS(4236),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4234),
    [anon_sym_LBRACE] = ACTIONS(4236),
    [anon_sym_LT_AT] = ACTIONS(4236),
    [anon_sym_LT_AT_AT] = ACTIONS(4236),
    [anon_sym_DOT] = ACTIONS(4236),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4234),
    [anon_sym_new] = ACTIONS(4236),
    [anon_sym_with] = ACTIONS(4236),
    [anon_sym_return_BANG] = ACTIONS(4234),
    [anon_sym_yield] = ACTIONS(4236),
    [anon_sym_yield_BANG] = ACTIONS(4234),
    [anon_sym_lazy] = ACTIONS(4236),
    [anon_sym_assert] = ACTIONS(4236),
    [anon_sym_upcast] = ACTIONS(4236),
    [anon_sym_downcast] = ACTIONS(4236),
    [anon_sym_COLON_GT] = ACTIONS(4234),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4234),
    [anon_sym_for] = ACTIONS(4236),
    [anon_sym_while] = ACTIONS(4236),
    [anon_sym_if] = ACTIONS(4236),
    [anon_sym_fun] = ACTIONS(4236),
    [anon_sym_try] = ACTIONS(4236),
    [anon_sym_match] = ACTIONS(4236),
    [anon_sym_match_BANG] = ACTIONS(4234),
    [anon_sym_function] = ACTIONS(4236),
    [anon_sym_LT_DASH] = ACTIONS(4236),
    [anon_sym_DOT_LBRACK] = ACTIONS(4234),
    [anon_sym_LT] = ACTIONS(4234),
    [anon_sym_use] = ACTIONS(4236),
    [anon_sym_use_BANG] = ACTIONS(4234),
    [anon_sym_do_BANG] = ACTIONS(4234),
    [anon_sym_begin] = ACTIONS(4236),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_default] = ACTIONS(4236),
    [anon_sym_or] = ACTIONS(4236),
    [anon_sym_static] = ACTIONS(4236),
    [anon_sym_member] = ACTIONS(4236),
    [anon_sym_interface] = ACTIONS(4236),
    [anon_sym_abstract] = ACTIONS(4236),
    [anon_sym_val] = ACTIONS(4236),
    [anon_sym_override] = ACTIONS(4236),
    [anon_sym_inherit] = ACTIONS(4236),
    [aux_sym_char_token1] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4236),
    [anon_sym_DQUOTE] = ACTIONS(4236),
    [anon_sym_AT_DQUOTE] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [sym_bool] = ACTIONS(4236),
    [sym_unit] = ACTIONS(4234),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4236),
    [sym_op_identifier] = ACTIONS(4236),
    [anon_sym_PLUS] = ACTIONS(4236),
    [anon_sym_DASH] = ACTIONS(4236),
    [anon_sym_PLUS_DOT] = ACTIONS(4236),
    [anon_sym_DASH_DOT] = ACTIONS(4236),
    [anon_sym_PERCENT] = ACTIONS(4236),
    [anon_sym_AMP_AMP] = ACTIONS(4236),
    [anon_sym_TILDE] = ACTIONS(4234),
    [aux_sym_prefix_op_token1] = ACTIONS(4236),
    [aux_sym_infix_op_token1] = ACTIONS(4234),
    [aux_sym_infix_op_token2] = ACTIONS(4236),
    [anon_sym_PIPE_PIPE] = ACTIONS(4236),
    [anon_sym_BANG_EQ] = ACTIONS(4236),
    [anon_sym_COLON_EQ] = ACTIONS(4234),
    [anon_sym_DOLLAR] = ACTIONS(4236),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4236),
    [sym_int] = ACTIONS(4236),
    [sym_xint] = ACTIONS(4234),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4234),
    [anon_sym_POUNDendif] = ACTIONS(4234),
    [sym__newline] = ACTIONS(4234),
  },
  [2119] = {
    [sym_block_comment] = STATE(2119),
    [sym_compiler_directive_decl] = STATE(2119),
    [sym_fsi_directive_decl] = STATE(2119),
    [sym_preproc_line] = STATE(2119),
    [sym_identifier] = ACTIONS(4220),
    [anon_sym_EQ] = ACTIONS(4218),
    [anon_sym_LBRACK_LT] = ACTIONS(4218),
    [anon_sym_COLON] = ACTIONS(4220),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_do] = ACTIONS(4220),
    [anon_sym_let] = ACTIONS(4220),
    [anon_sym_let_BANG] = ACTIONS(4218),
    [aux_sym_access_modifier_token1] = ACTIONS(4218),
    [anon_sym_LPAREN] = ACTIONS(4220),
    [anon_sym_COMMA] = ACTIONS(4218),
    [anon_sym_null] = ACTIONS(4220),
    [anon_sym_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_COLON] = ACTIONS(4218),
    [anon_sym_AMP] = ACTIONS(4220),
    [anon_sym_LBRACK] = ACTIONS(4220),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(4220),
    [anon_sym_LT_AT] = ACTIONS(4220),
    [anon_sym_LT_AT_AT] = ACTIONS(4220),
    [anon_sym_DOT] = ACTIONS(4220),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4218),
    [anon_sym_new] = ACTIONS(4220),
    [anon_sym_with] = ACTIONS(4220),
    [anon_sym_return_BANG] = ACTIONS(4218),
    [anon_sym_yield] = ACTIONS(4220),
    [anon_sym_yield_BANG] = ACTIONS(4218),
    [anon_sym_lazy] = ACTIONS(4220),
    [anon_sym_assert] = ACTIONS(4220),
    [anon_sym_upcast] = ACTIONS(4220),
    [anon_sym_downcast] = ACTIONS(4220),
    [anon_sym_COLON_GT] = ACTIONS(4218),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4218),
    [anon_sym_for] = ACTIONS(4220),
    [anon_sym_while] = ACTIONS(4220),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_fun] = ACTIONS(4220),
    [anon_sym_try] = ACTIONS(4220),
    [anon_sym_match] = ACTIONS(4220),
    [anon_sym_match_BANG] = ACTIONS(4218),
    [anon_sym_function] = ACTIONS(4220),
    [anon_sym_LT_DASH] = ACTIONS(4220),
    [anon_sym_DOT_LBRACK] = ACTIONS(4218),
    [anon_sym_LT] = ACTIONS(4218),
    [anon_sym_use] = ACTIONS(4220),
    [anon_sym_use_BANG] = ACTIONS(4218),
    [anon_sym_do_BANG] = ACTIONS(4218),
    [anon_sym_begin] = ACTIONS(4220),
    [anon_sym_LPAREN2] = ACTIONS(4220),
    [anon_sym_default] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(4220),
    [anon_sym_static] = ACTIONS(4220),
    [anon_sym_member] = ACTIONS(4220),
    [anon_sym_interface] = ACTIONS(4220),
    [anon_sym_abstract] = ACTIONS(4220),
    [anon_sym_val] = ACTIONS(4220),
    [anon_sym_override] = ACTIONS(4220),
    [anon_sym_inherit] = ACTIONS(4220),
    [aux_sym_char_token1] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4220),
    [anon_sym_DQUOTE] = ACTIONS(4220),
    [anon_sym_AT_DQUOTE] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [sym_bool] = ACTIONS(4220),
    [sym_unit] = ACTIONS(4218),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4220),
    [sym_op_identifier] = ACTIONS(4220),
    [anon_sym_PLUS] = ACTIONS(4220),
    [anon_sym_DASH] = ACTIONS(4220),
    [anon_sym_PLUS_DOT] = ACTIONS(4220),
    [anon_sym_DASH_DOT] = ACTIONS(4220),
    [anon_sym_PERCENT] = ACTIONS(4220),
    [anon_sym_AMP_AMP] = ACTIONS(4220),
    [anon_sym_TILDE] = ACTIONS(4218),
    [aux_sym_prefix_op_token1] = ACTIONS(4220),
    [aux_sym_infix_op_token1] = ACTIONS(4218),
    [aux_sym_infix_op_token2] = ACTIONS(4220),
    [anon_sym_PIPE_PIPE] = ACTIONS(4220),
    [anon_sym_BANG_EQ] = ACTIONS(4220),
    [anon_sym_COLON_EQ] = ACTIONS(4218),
    [anon_sym_DOLLAR] = ACTIONS(4220),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4220),
    [sym_int] = ACTIONS(4220),
    [sym_xint] = ACTIONS(4218),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4218),
    [anon_sym_POUNDendif] = ACTIONS(4218),
    [sym__newline] = ACTIONS(4218),
  },
  [2120] = {
    [sym_block_comment] = STATE(2120),
    [sym_compiler_directive_decl] = STATE(2120),
    [sym_fsi_directive_decl] = STATE(2120),
    [sym_preproc_line] = STATE(2120),
    [aux_sym_sequential_expression_repeat1] = STATE(2130),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_LBRACK_LT] = ACTIONS(3757),
    [anon_sym_COLON] = ACTIONS(3759),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_let_BANG] = ACTIONS(3757),
    [aux_sym_access_modifier_token1] = ACTIONS(3757),
    [anon_sym_LPAREN] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3757),
    [anon_sym_null] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3757),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_LT_AT] = ACTIONS(3759),
    [anon_sym_LT_AT_AT] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(3759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_with] = ACTIONS(3759),
    [anon_sym_return_BANG] = ACTIONS(3757),
    [anon_sym_yield] = ACTIONS(3759),
    [anon_sym_yield_BANG] = ACTIONS(3757),
    [anon_sym_lazy] = ACTIONS(3759),
    [anon_sym_assert] = ACTIONS(3759),
    [anon_sym_upcast] = ACTIONS(3759),
    [anon_sym_downcast] = ACTIONS(3759),
    [anon_sym_COLON_GT] = ACTIONS(3757),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3757),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_fun] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_match] = ACTIONS(3759),
    [anon_sym_match_BANG] = ACTIONS(3757),
    [anon_sym_function] = ACTIONS(3759),
    [anon_sym_LT_DASH] = ACTIONS(3759),
    [anon_sym_DOT_LBRACK] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_use] = ACTIONS(3759),
    [anon_sym_use_BANG] = ACTIONS(3757),
    [anon_sym_do_BANG] = ACTIONS(3757),
    [anon_sym_begin] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_default] = ACTIONS(3759),
    [anon_sym_or] = ACTIONS(3759),
    [anon_sym_static] = ACTIONS(3759),
    [anon_sym_member] = ACTIONS(3759),
    [anon_sym_interface] = ACTIONS(3759),
    [anon_sym_abstract] = ACTIONS(3759),
    [anon_sym_val] = ACTIONS(3759),
    [anon_sym_override] = ACTIONS(3759),
    [aux_sym_char_token1] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3759),
    [anon_sym_DQUOTE] = ACTIONS(3759),
    [anon_sym_AT_DQUOTE] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [sym_bool] = ACTIONS(3759),
    [sym_unit] = ACTIONS(3757),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3759),
    [sym_op_identifier] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS_DOT] = ACTIONS(3759),
    [anon_sym_DASH_DOT] = ACTIONS(3759),
    [anon_sym_PERCENT] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_TILDE] = ACTIONS(3757),
    [aux_sym_prefix_op_token1] = ACTIONS(3759),
    [aux_sym_infix_op_token1] = ACTIONS(3757),
    [aux_sym_infix_op_token2] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_COLON_EQ] = ACTIONS(3757),
    [anon_sym_DOLLAR] = ACTIONS(3759),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3759),
    [sym_int] = ACTIONS(3759),
    [sym_xint] = ACTIONS(3757),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3757),
    [sym__newline] = ACTIONS(3757),
    [sym__dedent] = ACTIONS(3757),
  },
  [2121] = {
    [sym_block_comment] = STATE(2121),
    [sym_compiler_directive_decl] = STATE(2121),
    [sym_fsi_directive_decl] = STATE(2121),
    [sym_preproc_line] = STATE(2121),
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_EQ] = ACTIONS(3990),
    [anon_sym_LBRACK_LT] = ACTIONS(3990),
    [anon_sym_COLON] = ACTIONS(3992),
    [anon_sym_return] = ACTIONS(3992),
    [anon_sym_do] = ACTIONS(3992),
    [anon_sym_and] = ACTIONS(3992),
    [anon_sym_let] = ACTIONS(3992),
    [anon_sym_let_BANG] = ACTIONS(3990),
    [aux_sym_access_modifier_token1] = ACTIONS(3990),
    [anon_sym_LPAREN] = ACTIONS(3992),
    [anon_sym_COMMA] = ACTIONS(3990),
    [anon_sym_null] = ACTIONS(3992),
    [anon_sym_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [anon_sym_AMP] = ACTIONS(3992),
    [anon_sym_LBRACK] = ACTIONS(3992),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3990),
    [anon_sym_LBRACE] = ACTIONS(3992),
    [anon_sym_LT_AT] = ACTIONS(3992),
    [anon_sym_LT_AT_AT] = ACTIONS(3992),
    [anon_sym_DOT] = ACTIONS(3992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3990),
    [anon_sym_new] = ACTIONS(3992),
    [anon_sym_with] = ACTIONS(3992),
    [anon_sym_return_BANG] = ACTIONS(3990),
    [anon_sym_yield] = ACTIONS(3992),
    [anon_sym_yield_BANG] = ACTIONS(3990),
    [anon_sym_lazy] = ACTIONS(3992),
    [anon_sym_assert] = ACTIONS(3992),
    [anon_sym_upcast] = ACTIONS(3992),
    [anon_sym_downcast] = ACTIONS(3992),
    [anon_sym_COLON_GT] = ACTIONS(3990),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3990),
    [anon_sym_for] = ACTIONS(3992),
    [anon_sym_while] = ACTIONS(3992),
    [anon_sym_if] = ACTIONS(3992),
    [anon_sym_fun] = ACTIONS(3992),
    [anon_sym_try] = ACTIONS(3992),
    [anon_sym_match] = ACTIONS(3992),
    [anon_sym_match_BANG] = ACTIONS(3990),
    [anon_sym_function] = ACTIONS(3992),
    [anon_sym_LT_DASH] = ACTIONS(3992),
    [anon_sym_DOT_LBRACK] = ACTIONS(3990),
    [anon_sym_LT] = ACTIONS(3990),
    [anon_sym_use] = ACTIONS(3992),
    [anon_sym_use_BANG] = ACTIONS(3990),
    [anon_sym_do_BANG] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_LPAREN2] = ACTIONS(3992),
    [anon_sym_default] = ACTIONS(3992),
    [anon_sym_or] = ACTIONS(3992),
    [anon_sym_static] = ACTIONS(3992),
    [anon_sym_member] = ACTIONS(3992),
    [anon_sym_interface] = ACTIONS(3992),
    [anon_sym_abstract] = ACTIONS(3992),
    [anon_sym_val] = ACTIONS(3992),
    [anon_sym_override] = ACTIONS(3992),
    [aux_sym_char_token1] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3992),
    [anon_sym_DQUOTE] = ACTIONS(3992),
    [anon_sym_AT_DQUOTE] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [sym_bool] = ACTIONS(3992),
    [sym_unit] = ACTIONS(3990),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3992),
    [sym_op_identifier] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3992),
    [anon_sym_DASH] = ACTIONS(3992),
    [anon_sym_PLUS_DOT] = ACTIONS(3992),
    [anon_sym_DASH_DOT] = ACTIONS(3992),
    [anon_sym_PERCENT] = ACTIONS(3992),
    [anon_sym_AMP_AMP] = ACTIONS(3992),
    [anon_sym_TILDE] = ACTIONS(3990),
    [aux_sym_prefix_op_token1] = ACTIONS(3992),
    [aux_sym_infix_op_token1] = ACTIONS(3990),
    [aux_sym_infix_op_token2] = ACTIONS(3992),
    [anon_sym_PIPE_PIPE] = ACTIONS(3992),
    [anon_sym_BANG_EQ] = ACTIONS(3992),
    [anon_sym_COLON_EQ] = ACTIONS(3990),
    [anon_sym_DOLLAR] = ACTIONS(3992),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3992),
    [sym_int] = ACTIONS(3992),
    [sym_xint] = ACTIONS(3990),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3990),
    [sym__newline] = ACTIONS(3990),
    [sym__dedent] = ACTIONS(3990),
  },
  [2122] = {
    [sym_block_comment] = STATE(2122),
    [sym_compiler_directive_decl] = STATE(2122),
    [sym_fsi_directive_decl] = STATE(2122),
    [sym_preproc_line] = STATE(2122),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [aux_sym_access_modifier_token1] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_member] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_val] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [anon_sym_inherit] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [anon_sym_POUNDendif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [2123] = {
    [sym_block_comment] = STATE(2123),
    [sym_compiler_directive_decl] = STATE(2123),
    [sym_fsi_directive_decl] = STATE(2123),
    [sym_preproc_line] = STATE(2123),
    [sym_identifier] = ACTIONS(4216),
    [anon_sym_EQ] = ACTIONS(4214),
    [anon_sym_LBRACK_LT] = ACTIONS(4214),
    [anon_sym_COLON] = ACTIONS(4216),
    [anon_sym_return] = ACTIONS(4216),
    [anon_sym_do] = ACTIONS(4216),
    [anon_sym_let] = ACTIONS(4216),
    [anon_sym_let_BANG] = ACTIONS(4214),
    [aux_sym_access_modifier_token1] = ACTIONS(4214),
    [anon_sym_LPAREN] = ACTIONS(4216),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_null] = ACTIONS(4216),
    [anon_sym_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_COLON] = ACTIONS(4214),
    [anon_sym_AMP] = ACTIONS(4216),
    [anon_sym_LBRACK] = ACTIONS(4216),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4214),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_LT_AT] = ACTIONS(4216),
    [anon_sym_LT_AT_AT] = ACTIONS(4216),
    [anon_sym_DOT] = ACTIONS(4216),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4214),
    [anon_sym_new] = ACTIONS(4216),
    [anon_sym_with] = ACTIONS(4216),
    [anon_sym_return_BANG] = ACTIONS(4214),
    [anon_sym_yield] = ACTIONS(4216),
    [anon_sym_yield_BANG] = ACTIONS(4214),
    [anon_sym_lazy] = ACTIONS(4216),
    [anon_sym_assert] = ACTIONS(4216),
    [anon_sym_upcast] = ACTIONS(4216),
    [anon_sym_downcast] = ACTIONS(4216),
    [anon_sym_COLON_GT] = ACTIONS(4214),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4214),
    [anon_sym_for] = ACTIONS(4216),
    [anon_sym_while] = ACTIONS(4216),
    [anon_sym_if] = ACTIONS(4216),
    [anon_sym_fun] = ACTIONS(4216),
    [anon_sym_try] = ACTIONS(4216),
    [anon_sym_match] = ACTIONS(4216),
    [anon_sym_match_BANG] = ACTIONS(4214),
    [anon_sym_function] = ACTIONS(4216),
    [anon_sym_LT_DASH] = ACTIONS(4216),
    [anon_sym_DOT_LBRACK] = ACTIONS(4214),
    [anon_sym_LT] = ACTIONS(4214),
    [anon_sym_use] = ACTIONS(4216),
    [anon_sym_use_BANG] = ACTIONS(4214),
    [anon_sym_do_BANG] = ACTIONS(4214),
    [anon_sym_begin] = ACTIONS(4216),
    [anon_sym_LPAREN2] = ACTIONS(4216),
    [anon_sym_default] = ACTIONS(4216),
    [anon_sym_or] = ACTIONS(4216),
    [anon_sym_static] = ACTIONS(4216),
    [anon_sym_member] = ACTIONS(4216),
    [anon_sym_interface] = ACTIONS(4216),
    [anon_sym_abstract] = ACTIONS(4216),
    [anon_sym_val] = ACTIONS(4216),
    [anon_sym_override] = ACTIONS(4216),
    [anon_sym_inherit] = ACTIONS(4216),
    [aux_sym_char_token1] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4216),
    [anon_sym_DQUOTE] = ACTIONS(4216),
    [anon_sym_AT_DQUOTE] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [sym_bool] = ACTIONS(4216),
    [sym_unit] = ACTIONS(4214),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4216),
    [sym_op_identifier] = ACTIONS(4216),
    [anon_sym_PLUS] = ACTIONS(4216),
    [anon_sym_DASH] = ACTIONS(4216),
    [anon_sym_PLUS_DOT] = ACTIONS(4216),
    [anon_sym_DASH_DOT] = ACTIONS(4216),
    [anon_sym_PERCENT] = ACTIONS(4216),
    [anon_sym_AMP_AMP] = ACTIONS(4216),
    [anon_sym_TILDE] = ACTIONS(4214),
    [aux_sym_prefix_op_token1] = ACTIONS(4216),
    [aux_sym_infix_op_token1] = ACTIONS(4214),
    [aux_sym_infix_op_token2] = ACTIONS(4216),
    [anon_sym_PIPE_PIPE] = ACTIONS(4216),
    [anon_sym_BANG_EQ] = ACTIONS(4216),
    [anon_sym_COLON_EQ] = ACTIONS(4214),
    [anon_sym_DOLLAR] = ACTIONS(4216),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4216),
    [sym_int] = ACTIONS(4216),
    [sym_xint] = ACTIONS(4214),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4214),
    [anon_sym_POUNDendif] = ACTIONS(4214),
    [sym__newline] = ACTIONS(4214),
  },
  [2124] = {
    [sym_block_comment] = STATE(2124),
    [sym_compiler_directive_decl] = STATE(2124),
    [sym_fsi_directive_decl] = STATE(2124),
    [sym_preproc_line] = STATE(2124),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_EQ] = ACTIONS(4199),
    [anon_sym_LBRACK_LT] = ACTIONS(4199),
    [anon_sym_COLON] = ACTIONS(4201),
    [anon_sym_return] = ACTIONS(4201),
    [anon_sym_do] = ACTIONS(4201),
    [anon_sym_let] = ACTIONS(4201),
    [anon_sym_let_BANG] = ACTIONS(4199),
    [aux_sym_access_modifier_token1] = ACTIONS(4199),
    [anon_sym_LPAREN] = ACTIONS(4201),
    [anon_sym_COMMA] = ACTIONS(4199),
    [anon_sym_null] = ACTIONS(4201),
    [anon_sym_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(4199),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_LBRACK] = ACTIONS(4201),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4199),
    [anon_sym_LBRACE] = ACTIONS(4201),
    [anon_sym_LT_AT] = ACTIONS(4201),
    [anon_sym_LT_AT_AT] = ACTIONS(4201),
    [anon_sym_DOT] = ACTIONS(4201),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4199),
    [anon_sym_new] = ACTIONS(4201),
    [anon_sym_with] = ACTIONS(4201),
    [anon_sym_return_BANG] = ACTIONS(4199),
    [anon_sym_yield] = ACTIONS(4201),
    [anon_sym_yield_BANG] = ACTIONS(4199),
    [anon_sym_lazy] = ACTIONS(4201),
    [anon_sym_assert] = ACTIONS(4201),
    [anon_sym_upcast] = ACTIONS(4201),
    [anon_sym_downcast] = ACTIONS(4201),
    [anon_sym_COLON_GT] = ACTIONS(4199),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4199),
    [anon_sym_for] = ACTIONS(4201),
    [anon_sym_while] = ACTIONS(4201),
    [anon_sym_if] = ACTIONS(4201),
    [anon_sym_fun] = ACTIONS(4201),
    [anon_sym_try] = ACTIONS(4201),
    [anon_sym_match] = ACTIONS(4201),
    [anon_sym_match_BANG] = ACTIONS(4199),
    [anon_sym_function] = ACTIONS(4201),
    [anon_sym_LT_DASH] = ACTIONS(4201),
    [anon_sym_DOT_LBRACK] = ACTIONS(4199),
    [anon_sym_LT] = ACTIONS(4199),
    [anon_sym_use] = ACTIONS(4201),
    [anon_sym_use_BANG] = ACTIONS(4199),
    [anon_sym_do_BANG] = ACTIONS(4199),
    [anon_sym_begin] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(4201),
    [anon_sym_default] = ACTIONS(4201),
    [anon_sym_or] = ACTIONS(4201),
    [anon_sym_static] = ACTIONS(4201),
    [anon_sym_member] = ACTIONS(4201),
    [anon_sym_interface] = ACTIONS(4201),
    [anon_sym_abstract] = ACTIONS(4201),
    [anon_sym_val] = ACTIONS(4201),
    [anon_sym_override] = ACTIONS(4201),
    [anon_sym_inherit] = ACTIONS(4201),
    [aux_sym_char_token1] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4201),
    [anon_sym_DQUOTE] = ACTIONS(4201),
    [anon_sym_AT_DQUOTE] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [sym_bool] = ACTIONS(4201),
    [sym_unit] = ACTIONS(4199),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4201),
    [sym_op_identifier] = ACTIONS(4201),
    [anon_sym_PLUS] = ACTIONS(4201),
    [anon_sym_DASH] = ACTIONS(4201),
    [anon_sym_PLUS_DOT] = ACTIONS(4201),
    [anon_sym_DASH_DOT] = ACTIONS(4201),
    [anon_sym_PERCENT] = ACTIONS(4201),
    [anon_sym_AMP_AMP] = ACTIONS(4201),
    [anon_sym_TILDE] = ACTIONS(4199),
    [aux_sym_prefix_op_token1] = ACTIONS(4201),
    [aux_sym_infix_op_token1] = ACTIONS(4199),
    [aux_sym_infix_op_token2] = ACTIONS(4201),
    [anon_sym_PIPE_PIPE] = ACTIONS(4201),
    [anon_sym_BANG_EQ] = ACTIONS(4201),
    [anon_sym_COLON_EQ] = ACTIONS(4199),
    [anon_sym_DOLLAR] = ACTIONS(4201),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4201),
    [sym_int] = ACTIONS(4201),
    [sym_xint] = ACTIONS(4199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4199),
    [anon_sym_POUNDendif] = ACTIONS(4199),
    [sym__newline] = ACTIONS(4199),
  },
  [2125] = {
    [sym_block_comment] = STATE(2125),
    [sym_compiler_directive_decl] = STATE(2125),
    [sym_fsi_directive_decl] = STATE(2125),
    [sym_preproc_line] = STATE(2125),
    [sym_identifier] = ACTIONS(4197),
    [anon_sym_EQ] = ACTIONS(4195),
    [anon_sym_LBRACK_LT] = ACTIONS(4195),
    [anon_sym_COLON] = ACTIONS(4197),
    [anon_sym_return] = ACTIONS(4197),
    [anon_sym_do] = ACTIONS(4197),
    [anon_sym_let] = ACTIONS(4197),
    [anon_sym_let_BANG] = ACTIONS(4195),
    [aux_sym_access_modifier_token1] = ACTIONS(4195),
    [anon_sym_LPAREN] = ACTIONS(4197),
    [anon_sym_COMMA] = ACTIONS(4195),
    [anon_sym_null] = ACTIONS(4197),
    [anon_sym_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_COLON] = ACTIONS(4195),
    [anon_sym_AMP] = ACTIONS(4197),
    [anon_sym_LBRACK] = ACTIONS(4197),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4195),
    [anon_sym_LBRACE] = ACTIONS(4197),
    [anon_sym_LT_AT] = ACTIONS(4197),
    [anon_sym_LT_AT_AT] = ACTIONS(4197),
    [anon_sym_DOT] = ACTIONS(4197),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4195),
    [anon_sym_new] = ACTIONS(4197),
    [anon_sym_with] = ACTIONS(4197),
    [anon_sym_return_BANG] = ACTIONS(4195),
    [anon_sym_yield] = ACTIONS(4197),
    [anon_sym_yield_BANG] = ACTIONS(4195),
    [anon_sym_lazy] = ACTIONS(4197),
    [anon_sym_assert] = ACTIONS(4197),
    [anon_sym_upcast] = ACTIONS(4197),
    [anon_sym_downcast] = ACTIONS(4197),
    [anon_sym_COLON_GT] = ACTIONS(4195),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4195),
    [anon_sym_for] = ACTIONS(4197),
    [anon_sym_while] = ACTIONS(4197),
    [anon_sym_if] = ACTIONS(4197),
    [anon_sym_fun] = ACTIONS(4197),
    [anon_sym_try] = ACTIONS(4197),
    [anon_sym_match] = ACTIONS(4197),
    [anon_sym_match_BANG] = ACTIONS(4195),
    [anon_sym_function] = ACTIONS(4197),
    [anon_sym_LT_DASH] = ACTIONS(4197),
    [anon_sym_DOT_LBRACK] = ACTIONS(4195),
    [anon_sym_LT] = ACTIONS(4195),
    [anon_sym_use] = ACTIONS(4197),
    [anon_sym_use_BANG] = ACTIONS(4195),
    [anon_sym_do_BANG] = ACTIONS(4195),
    [anon_sym_begin] = ACTIONS(4197),
    [anon_sym_LPAREN2] = ACTIONS(4197),
    [anon_sym_default] = ACTIONS(4197),
    [anon_sym_or] = ACTIONS(4197),
    [anon_sym_static] = ACTIONS(4197),
    [anon_sym_member] = ACTIONS(4197),
    [anon_sym_interface] = ACTIONS(4197),
    [anon_sym_abstract] = ACTIONS(4197),
    [anon_sym_val] = ACTIONS(4197),
    [anon_sym_override] = ACTIONS(4197),
    [anon_sym_inherit] = ACTIONS(4197),
    [aux_sym_char_token1] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4197),
    [anon_sym_DQUOTE] = ACTIONS(4197),
    [anon_sym_AT_DQUOTE] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [sym_bool] = ACTIONS(4197),
    [sym_unit] = ACTIONS(4195),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4197),
    [sym_op_identifier] = ACTIONS(4197),
    [anon_sym_PLUS] = ACTIONS(4197),
    [anon_sym_DASH] = ACTIONS(4197),
    [anon_sym_PLUS_DOT] = ACTIONS(4197),
    [anon_sym_DASH_DOT] = ACTIONS(4197),
    [anon_sym_PERCENT] = ACTIONS(4197),
    [anon_sym_AMP_AMP] = ACTIONS(4197),
    [anon_sym_TILDE] = ACTIONS(4195),
    [aux_sym_prefix_op_token1] = ACTIONS(4197),
    [aux_sym_infix_op_token1] = ACTIONS(4195),
    [aux_sym_infix_op_token2] = ACTIONS(4197),
    [anon_sym_PIPE_PIPE] = ACTIONS(4197),
    [anon_sym_BANG_EQ] = ACTIONS(4197),
    [anon_sym_COLON_EQ] = ACTIONS(4195),
    [anon_sym_DOLLAR] = ACTIONS(4197),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4197),
    [sym_int] = ACTIONS(4197),
    [sym_xint] = ACTIONS(4195),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4195),
    [anon_sym_POUNDendif] = ACTIONS(4195),
    [sym__newline] = ACTIONS(4195),
  },
  [2126] = {
    [sym_block_comment] = STATE(2126),
    [sym_compiler_directive_decl] = STATE(2126),
    [sym_fsi_directive_decl] = STATE(2126),
    [sym_preproc_line] = STATE(2126),
    [sym_identifier] = ACTIONS(4193),
    [anon_sym_EQ] = ACTIONS(4191),
    [anon_sym_LBRACK_LT] = ACTIONS(4191),
    [anon_sym_COLON] = ACTIONS(4193),
    [anon_sym_return] = ACTIONS(4193),
    [anon_sym_do] = ACTIONS(4193),
    [anon_sym_let] = ACTIONS(4193),
    [anon_sym_let_BANG] = ACTIONS(4191),
    [aux_sym_access_modifier_token1] = ACTIONS(4191),
    [anon_sym_LPAREN] = ACTIONS(4193),
    [anon_sym_COMMA] = ACTIONS(4191),
    [anon_sym_null] = ACTIONS(4193),
    [anon_sym_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_COLON] = ACTIONS(4191),
    [anon_sym_AMP] = ACTIONS(4193),
    [anon_sym_LBRACK] = ACTIONS(4193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4191),
    [anon_sym_LBRACE] = ACTIONS(4193),
    [anon_sym_LT_AT] = ACTIONS(4193),
    [anon_sym_LT_AT_AT] = ACTIONS(4193),
    [anon_sym_DOT] = ACTIONS(4193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4191),
    [anon_sym_new] = ACTIONS(4193),
    [anon_sym_with] = ACTIONS(4193),
    [anon_sym_return_BANG] = ACTIONS(4191),
    [anon_sym_yield] = ACTIONS(4193),
    [anon_sym_yield_BANG] = ACTIONS(4191),
    [anon_sym_lazy] = ACTIONS(4193),
    [anon_sym_assert] = ACTIONS(4193),
    [anon_sym_upcast] = ACTIONS(4193),
    [anon_sym_downcast] = ACTIONS(4193),
    [anon_sym_COLON_GT] = ACTIONS(4191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4191),
    [anon_sym_for] = ACTIONS(4193),
    [anon_sym_while] = ACTIONS(4193),
    [anon_sym_if] = ACTIONS(4193),
    [anon_sym_fun] = ACTIONS(4193),
    [anon_sym_try] = ACTIONS(4193),
    [anon_sym_match] = ACTIONS(4193),
    [anon_sym_match_BANG] = ACTIONS(4191),
    [anon_sym_function] = ACTIONS(4193),
    [anon_sym_LT_DASH] = ACTIONS(4193),
    [anon_sym_DOT_LBRACK] = ACTIONS(4191),
    [anon_sym_LT] = ACTIONS(4191),
    [anon_sym_use] = ACTIONS(4193),
    [anon_sym_use_BANG] = ACTIONS(4191),
    [anon_sym_do_BANG] = ACTIONS(4191),
    [anon_sym_begin] = ACTIONS(4193),
    [anon_sym_LPAREN2] = ACTIONS(4193),
    [anon_sym_default] = ACTIONS(4193),
    [anon_sym_or] = ACTIONS(4193),
    [anon_sym_static] = ACTIONS(4193),
    [anon_sym_member] = ACTIONS(4193),
    [anon_sym_interface] = ACTIONS(4193),
    [anon_sym_abstract] = ACTIONS(4193),
    [anon_sym_val] = ACTIONS(4193),
    [anon_sym_override] = ACTIONS(4193),
    [anon_sym_inherit] = ACTIONS(4193),
    [aux_sym_char_token1] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4193),
    [anon_sym_DQUOTE] = ACTIONS(4193),
    [anon_sym_AT_DQUOTE] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [sym_bool] = ACTIONS(4193),
    [sym_unit] = ACTIONS(4191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4193),
    [sym_op_identifier] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4193),
    [anon_sym_DASH] = ACTIONS(4193),
    [anon_sym_PLUS_DOT] = ACTIONS(4193),
    [anon_sym_DASH_DOT] = ACTIONS(4193),
    [anon_sym_PERCENT] = ACTIONS(4193),
    [anon_sym_AMP_AMP] = ACTIONS(4193),
    [anon_sym_TILDE] = ACTIONS(4191),
    [aux_sym_prefix_op_token1] = ACTIONS(4193),
    [aux_sym_infix_op_token1] = ACTIONS(4191),
    [aux_sym_infix_op_token2] = ACTIONS(4193),
    [anon_sym_PIPE_PIPE] = ACTIONS(4193),
    [anon_sym_BANG_EQ] = ACTIONS(4193),
    [anon_sym_COLON_EQ] = ACTIONS(4191),
    [anon_sym_DOLLAR] = ACTIONS(4193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4193),
    [sym_int] = ACTIONS(4193),
    [sym_xint] = ACTIONS(4191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4191),
    [anon_sym_POUNDendif] = ACTIONS(4191),
    [sym__newline] = ACTIONS(4191),
  },
  [2127] = {
    [sym_block_comment] = STATE(2127),
    [sym_compiler_directive_decl] = STATE(2127),
    [sym_fsi_directive_decl] = STATE(2127),
    [sym_preproc_line] = STATE(2127),
    [aux_sym_type_argument_repeat1] = STATE(1921),
    [ts_builtin_sym_end] = ACTIONS(3496),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_namespace] = ACTIONS(3498),
    [anon_sym_module] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_open] = ACTIONS(3498),
    [anon_sym_LBRACK_LT] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_type] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [anon_sym_DOT_LBRACK] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_or] = ACTIONS(4767),
    [anon_sym_exception] = ACTIONS(3498),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3498),
    [anon_sym_DASH_DOT] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3498),
    [aux_sym_infix_op_token1] = ACTIONS(3496),
    [aux_sym_infix_op_token2] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_COLON_EQ] = ACTIONS(3496),
    [anon_sym_DOLLAR] = ACTIONS(3498),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3498),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3496),
    [anon_sym_POUNDload] = ACTIONS(3496),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
  },
  [2128] = {
    [sym_block_comment] = STATE(2128),
    [sym_compiler_directive_decl] = STATE(2128),
    [sym_fsi_directive_decl] = STATE(2128),
    [sym_preproc_line] = STATE(2128),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_EQ] = ACTIONS(4001),
    [anon_sym_LBRACK_LT] = ACTIONS(4001),
    [anon_sym_COLON] = ACTIONS(4003),
    [anon_sym_return] = ACTIONS(4003),
    [anon_sym_do] = ACTIONS(4003),
    [anon_sym_and] = ACTIONS(4003),
    [anon_sym_let] = ACTIONS(4003),
    [anon_sym_let_BANG] = ACTIONS(4001),
    [aux_sym_access_modifier_token1] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4003),
    [anon_sym_COMMA] = ACTIONS(4001),
    [anon_sym_null] = ACTIONS(4003),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_COLON] = ACTIONS(4001),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LBRACK] = ACTIONS(4003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4001),
    [anon_sym_LBRACE] = ACTIONS(4003),
    [anon_sym_LT_AT] = ACTIONS(4003),
    [anon_sym_LT_AT_AT] = ACTIONS(4003),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4001),
    [anon_sym_new] = ACTIONS(4003),
    [anon_sym_with] = ACTIONS(4003),
    [anon_sym_return_BANG] = ACTIONS(4001),
    [anon_sym_yield] = ACTIONS(4003),
    [anon_sym_yield_BANG] = ACTIONS(4001),
    [anon_sym_lazy] = ACTIONS(4003),
    [anon_sym_assert] = ACTIONS(4003),
    [anon_sym_upcast] = ACTIONS(4003),
    [anon_sym_downcast] = ACTIONS(4003),
    [anon_sym_COLON_GT] = ACTIONS(4001),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4001),
    [anon_sym_for] = ACTIONS(4003),
    [anon_sym_while] = ACTIONS(4003),
    [anon_sym_if] = ACTIONS(4003),
    [anon_sym_fun] = ACTIONS(4003),
    [anon_sym_try] = ACTIONS(4003),
    [anon_sym_match] = ACTIONS(4003),
    [anon_sym_match_BANG] = ACTIONS(4001),
    [anon_sym_function] = ACTIONS(4003),
    [anon_sym_LT_DASH] = ACTIONS(4003),
    [anon_sym_DOT_LBRACK] = ACTIONS(4001),
    [anon_sym_LT] = ACTIONS(4001),
    [anon_sym_use] = ACTIONS(4003),
    [anon_sym_use_BANG] = ACTIONS(4001),
    [anon_sym_do_BANG] = ACTIONS(4001),
    [anon_sym_begin] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4003),
    [anon_sym_default] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [anon_sym_static] = ACTIONS(4003),
    [anon_sym_member] = ACTIONS(4003),
    [anon_sym_interface] = ACTIONS(4003),
    [anon_sym_abstract] = ACTIONS(4003),
    [anon_sym_val] = ACTIONS(4003),
    [anon_sym_override] = ACTIONS(4003),
    [aux_sym_char_token1] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4003),
    [anon_sym_DQUOTE] = ACTIONS(4003),
    [anon_sym_AT_DQUOTE] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [sym_bool] = ACTIONS(4003),
    [sym_unit] = ACTIONS(4001),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4003),
    [sym_op_identifier] = ACTIONS(4003),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_PLUS_DOT] = ACTIONS(4003),
    [anon_sym_DASH_DOT] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4003),
    [anon_sym_TILDE] = ACTIONS(4001),
    [aux_sym_prefix_op_token1] = ACTIONS(4003),
    [aux_sym_infix_op_token1] = ACTIONS(4001),
    [aux_sym_infix_op_token2] = ACTIONS(4003),
    [anon_sym_PIPE_PIPE] = ACTIONS(4003),
    [anon_sym_BANG_EQ] = ACTIONS(4003),
    [anon_sym_COLON_EQ] = ACTIONS(4001),
    [anon_sym_DOLLAR] = ACTIONS(4003),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4003),
    [sym_int] = ACTIONS(4003),
    [sym_xint] = ACTIONS(4001),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4001),
    [sym__newline] = ACTIONS(4001),
    [sym__dedent] = ACTIONS(4001),
  },
  [2129] = {
    [sym_block_comment] = STATE(2129),
    [sym_compiler_directive_decl] = STATE(2129),
    [sym_fsi_directive_decl] = STATE(2129),
    [sym_preproc_line] = STATE(2129),
    [sym_identifier] = ACTIONS(3988),
    [anon_sym_EQ] = ACTIONS(3986),
    [anon_sym_LBRACK_LT] = ACTIONS(3986),
    [anon_sym_COLON] = ACTIONS(3988),
    [anon_sym_return] = ACTIONS(3988),
    [anon_sym_do] = ACTIONS(3988),
    [anon_sym_and] = ACTIONS(3988),
    [anon_sym_let] = ACTIONS(3988),
    [anon_sym_let_BANG] = ACTIONS(3986),
    [aux_sym_access_modifier_token1] = ACTIONS(3986),
    [anon_sym_LPAREN] = ACTIONS(3988),
    [anon_sym_COMMA] = ACTIONS(3986),
    [anon_sym_null] = ACTIONS(3988),
    [anon_sym_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_COLON] = ACTIONS(3986),
    [anon_sym_AMP] = ACTIONS(3988),
    [anon_sym_LBRACK] = ACTIONS(3988),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3986),
    [anon_sym_LBRACE] = ACTIONS(3988),
    [anon_sym_LT_AT] = ACTIONS(3988),
    [anon_sym_LT_AT_AT] = ACTIONS(3988),
    [anon_sym_DOT] = ACTIONS(3988),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3986),
    [anon_sym_new] = ACTIONS(3988),
    [anon_sym_with] = ACTIONS(3988),
    [anon_sym_return_BANG] = ACTIONS(3986),
    [anon_sym_yield] = ACTIONS(3988),
    [anon_sym_yield_BANG] = ACTIONS(3986),
    [anon_sym_lazy] = ACTIONS(3988),
    [anon_sym_assert] = ACTIONS(3988),
    [anon_sym_upcast] = ACTIONS(3988),
    [anon_sym_downcast] = ACTIONS(3988),
    [anon_sym_COLON_GT] = ACTIONS(3986),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_while] = ACTIONS(3988),
    [anon_sym_if] = ACTIONS(3988),
    [anon_sym_fun] = ACTIONS(3988),
    [anon_sym_try] = ACTIONS(3988),
    [anon_sym_match] = ACTIONS(3988),
    [anon_sym_match_BANG] = ACTIONS(3986),
    [anon_sym_function] = ACTIONS(3988),
    [anon_sym_LT_DASH] = ACTIONS(3988),
    [anon_sym_DOT_LBRACK] = ACTIONS(3986),
    [anon_sym_LT] = ACTIONS(3986),
    [anon_sym_use] = ACTIONS(3988),
    [anon_sym_use_BANG] = ACTIONS(3986),
    [anon_sym_do_BANG] = ACTIONS(3986),
    [anon_sym_begin] = ACTIONS(3988),
    [anon_sym_LPAREN2] = ACTIONS(3988),
    [anon_sym_default] = ACTIONS(3988),
    [anon_sym_or] = ACTIONS(3988),
    [anon_sym_static] = ACTIONS(3988),
    [anon_sym_member] = ACTIONS(3988),
    [anon_sym_interface] = ACTIONS(3988),
    [anon_sym_abstract] = ACTIONS(3988),
    [anon_sym_val] = ACTIONS(3988),
    [anon_sym_override] = ACTIONS(3988),
    [aux_sym_char_token1] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3988),
    [anon_sym_DQUOTE] = ACTIONS(3988),
    [anon_sym_AT_DQUOTE] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [sym_bool] = ACTIONS(3988),
    [sym_unit] = ACTIONS(3986),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3988),
    [sym_op_identifier] = ACTIONS(3988),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_PLUS_DOT] = ACTIONS(3988),
    [anon_sym_DASH_DOT] = ACTIONS(3988),
    [anon_sym_PERCENT] = ACTIONS(3988),
    [anon_sym_AMP_AMP] = ACTIONS(3988),
    [anon_sym_TILDE] = ACTIONS(3986),
    [aux_sym_prefix_op_token1] = ACTIONS(3988),
    [aux_sym_infix_op_token1] = ACTIONS(3986),
    [aux_sym_infix_op_token2] = ACTIONS(3988),
    [anon_sym_PIPE_PIPE] = ACTIONS(3988),
    [anon_sym_BANG_EQ] = ACTIONS(3988),
    [anon_sym_COLON_EQ] = ACTIONS(3986),
    [anon_sym_DOLLAR] = ACTIONS(3988),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3988),
    [sym_int] = ACTIONS(3988),
    [sym_xint] = ACTIONS(3986),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3986),
    [sym__newline] = ACTIONS(3986),
    [sym__dedent] = ACTIONS(3986),
  },
  [2130] = {
    [sym_block_comment] = STATE(2130),
    [sym_compiler_directive_decl] = STATE(2130),
    [sym_fsi_directive_decl] = STATE(2130),
    [sym_preproc_line] = STATE(2130),
    [aux_sym_sequential_expression_repeat1] = STATE(2130),
    [sym_identifier] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3765),
    [anon_sym_LBRACK_LT] = ACTIONS(3765),
    [anon_sym_COLON] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_let_BANG] = ACTIONS(3765),
    [aux_sym_access_modifier_token1] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(3767),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_null] = ACTIONS(3767),
    [anon_sym_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3765),
    [anon_sym_LBRACE] = ACTIONS(3767),
    [anon_sym_LT_AT] = ACTIONS(3767),
    [anon_sym_LT_AT_AT] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3765),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_with] = ACTIONS(3767),
    [anon_sym_return_BANG] = ACTIONS(3765),
    [anon_sym_yield] = ACTIONS(3767),
    [anon_sym_yield_BANG] = ACTIONS(3765),
    [anon_sym_lazy] = ACTIONS(3767),
    [anon_sym_assert] = ACTIONS(3767),
    [anon_sym_upcast] = ACTIONS(3767),
    [anon_sym_downcast] = ACTIONS(3767),
    [anon_sym_COLON_GT] = ACTIONS(3765),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3765),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_fun] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_match] = ACTIONS(3767),
    [anon_sym_match_BANG] = ACTIONS(3765),
    [anon_sym_function] = ACTIONS(3767),
    [anon_sym_LT_DASH] = ACTIONS(3767),
    [anon_sym_DOT_LBRACK] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(3765),
    [anon_sym_use] = ACTIONS(3767),
    [anon_sym_use_BANG] = ACTIONS(3765),
    [anon_sym_do_BANG] = ACTIONS(3765),
    [anon_sym_begin] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3767),
    [anon_sym_default] = ACTIONS(3767),
    [anon_sym_or] = ACTIONS(3767),
    [anon_sym_static] = ACTIONS(3767),
    [anon_sym_member] = ACTIONS(3767),
    [anon_sym_interface] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(3767),
    [anon_sym_val] = ACTIONS(3767),
    [anon_sym_override] = ACTIONS(3767),
    [aux_sym_char_token1] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3767),
    [anon_sym_DQUOTE] = ACTIONS(3767),
    [anon_sym_AT_DQUOTE] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [sym_bool] = ACTIONS(3767),
    [sym_unit] = ACTIONS(3765),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3767),
    [sym_op_identifier] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_PLUS_DOT] = ACTIONS(3767),
    [anon_sym_DASH_DOT] = ACTIONS(3767),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_AMP_AMP] = ACTIONS(3767),
    [anon_sym_TILDE] = ACTIONS(3765),
    [aux_sym_prefix_op_token1] = ACTIONS(3767),
    [aux_sym_infix_op_token1] = ACTIONS(3765),
    [aux_sym_infix_op_token2] = ACTIONS(3767),
    [anon_sym_PIPE_PIPE] = ACTIONS(3767),
    [anon_sym_BANG_EQ] = ACTIONS(3767),
    [anon_sym_COLON_EQ] = ACTIONS(3765),
    [anon_sym_DOLLAR] = ACTIONS(3767),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3767),
    [sym_int] = ACTIONS(3767),
    [sym_xint] = ACTIONS(3765),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3765),
    [sym__newline] = ACTIONS(4770),
    [sym__dedent] = ACTIONS(3765),
  },
  [2131] = {
    [sym_block_comment] = STATE(2131),
    [sym_compiler_directive_decl] = STATE(2131),
    [sym_fsi_directive_decl] = STATE(2131),
    [sym_preproc_line] = STATE(2131),
    [sym_identifier] = ACTIONS(4118),
    [anon_sym_EQ] = ACTIONS(4116),
    [anon_sym_LBRACK_LT] = ACTIONS(4116),
    [anon_sym_COLON] = ACTIONS(4118),
    [anon_sym_return] = ACTIONS(4118),
    [anon_sym_do] = ACTIONS(4118),
    [anon_sym_let] = ACTIONS(4118),
    [anon_sym_let_BANG] = ACTIONS(4116),
    [aux_sym_access_modifier_token1] = ACTIONS(4116),
    [anon_sym_LPAREN] = ACTIONS(4118),
    [anon_sym_COMMA] = ACTIONS(4116),
    [anon_sym_null] = ACTIONS(4118),
    [anon_sym_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_COLON] = ACTIONS(4116),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4118),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(4118),
    [anon_sym_LT_AT] = ACTIONS(4118),
    [anon_sym_LT_AT_AT] = ACTIONS(4118),
    [anon_sym_DOT] = ACTIONS(4118),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4116),
    [anon_sym_new] = ACTIONS(4118),
    [anon_sym_with] = ACTIONS(4118),
    [anon_sym_return_BANG] = ACTIONS(4116),
    [anon_sym_yield] = ACTIONS(4118),
    [anon_sym_yield_BANG] = ACTIONS(4116),
    [anon_sym_lazy] = ACTIONS(4118),
    [anon_sym_assert] = ACTIONS(4118),
    [anon_sym_upcast] = ACTIONS(4118),
    [anon_sym_downcast] = ACTIONS(4118),
    [anon_sym_COLON_GT] = ACTIONS(4116),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4116),
    [anon_sym_for] = ACTIONS(4118),
    [anon_sym_while] = ACTIONS(4118),
    [anon_sym_if] = ACTIONS(4118),
    [anon_sym_fun] = ACTIONS(4118),
    [anon_sym_try] = ACTIONS(4118),
    [anon_sym_match] = ACTIONS(4118),
    [anon_sym_match_BANG] = ACTIONS(4116),
    [anon_sym_function] = ACTIONS(4118),
    [anon_sym_LT_DASH] = ACTIONS(4118),
    [anon_sym_DOT_LBRACK] = ACTIONS(4116),
    [anon_sym_LT] = ACTIONS(4116),
    [anon_sym_use] = ACTIONS(4118),
    [anon_sym_use_BANG] = ACTIONS(4116),
    [anon_sym_do_BANG] = ACTIONS(4116),
    [anon_sym_begin] = ACTIONS(4118),
    [anon_sym_LPAREN2] = ACTIONS(4118),
    [anon_sym_default] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [anon_sym_static] = ACTIONS(4118),
    [anon_sym_member] = ACTIONS(4118),
    [anon_sym_interface] = ACTIONS(4118),
    [anon_sym_abstract] = ACTIONS(4118),
    [anon_sym_val] = ACTIONS(4118),
    [anon_sym_override] = ACTIONS(4118),
    [anon_sym_inherit] = ACTIONS(4118),
    [aux_sym_char_token1] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4118),
    [anon_sym_DQUOTE] = ACTIONS(4118),
    [anon_sym_AT_DQUOTE] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [sym_bool] = ACTIONS(4118),
    [sym_unit] = ACTIONS(4116),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4118),
    [sym_op_identifier] = ACTIONS(4118),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_PLUS_DOT] = ACTIONS(4118),
    [anon_sym_DASH_DOT] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_AMP_AMP] = ACTIONS(4118),
    [anon_sym_TILDE] = ACTIONS(4116),
    [aux_sym_prefix_op_token1] = ACTIONS(4118),
    [aux_sym_infix_op_token1] = ACTIONS(4116),
    [aux_sym_infix_op_token2] = ACTIONS(4118),
    [anon_sym_PIPE_PIPE] = ACTIONS(4118),
    [anon_sym_BANG_EQ] = ACTIONS(4118),
    [anon_sym_COLON_EQ] = ACTIONS(4116),
    [anon_sym_DOLLAR] = ACTIONS(4118),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4118),
    [sym_int] = ACTIONS(4118),
    [sym_xint] = ACTIONS(4116),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4116),
    [anon_sym_POUNDendif] = ACTIONS(4116),
    [sym__newline] = ACTIONS(4116),
  },
  [2132] = {
    [sym_block_comment] = STATE(2132),
    [sym_compiler_directive_decl] = STATE(2132),
    [sym_fsi_directive_decl] = STATE(2132),
    [sym_preproc_line] = STATE(2132),
    [sym_identifier] = ACTIONS(4180),
    [anon_sym_EQ] = ACTIONS(4178),
    [anon_sym_LBRACK_LT] = ACTIONS(4178),
    [anon_sym_COLON] = ACTIONS(4180),
    [anon_sym_return] = ACTIONS(4180),
    [anon_sym_do] = ACTIONS(4180),
    [anon_sym_let] = ACTIONS(4180),
    [anon_sym_let_BANG] = ACTIONS(4178),
    [aux_sym_access_modifier_token1] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(4180),
    [anon_sym_COMMA] = ACTIONS(4178),
    [anon_sym_null] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_COLON] = ACTIONS(4178),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4180),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4180),
    [anon_sym_LT_AT] = ACTIONS(4180),
    [anon_sym_LT_AT_AT] = ACTIONS(4180),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4178),
    [anon_sym_new] = ACTIONS(4180),
    [anon_sym_with] = ACTIONS(4180),
    [anon_sym_return_BANG] = ACTIONS(4178),
    [anon_sym_yield] = ACTIONS(4180),
    [anon_sym_yield_BANG] = ACTIONS(4178),
    [anon_sym_lazy] = ACTIONS(4180),
    [anon_sym_assert] = ACTIONS(4180),
    [anon_sym_upcast] = ACTIONS(4180),
    [anon_sym_downcast] = ACTIONS(4180),
    [anon_sym_COLON_GT] = ACTIONS(4178),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4178),
    [anon_sym_for] = ACTIONS(4180),
    [anon_sym_while] = ACTIONS(4180),
    [anon_sym_if] = ACTIONS(4180),
    [anon_sym_fun] = ACTIONS(4180),
    [anon_sym_try] = ACTIONS(4180),
    [anon_sym_match] = ACTIONS(4180),
    [anon_sym_match_BANG] = ACTIONS(4178),
    [anon_sym_function] = ACTIONS(4180),
    [anon_sym_LT_DASH] = ACTIONS(4180),
    [anon_sym_DOT_LBRACK] = ACTIONS(4178),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_use] = ACTIONS(4180),
    [anon_sym_use_BANG] = ACTIONS(4178),
    [anon_sym_do_BANG] = ACTIONS(4178),
    [anon_sym_begin] = ACTIONS(4180),
    [anon_sym_LPAREN2] = ACTIONS(4180),
    [anon_sym_DOT_DOT2] = ACTIONS(4178),
    [anon_sym_default] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [anon_sym_static] = ACTIONS(4180),
    [anon_sym_member] = ACTIONS(4180),
    [anon_sym_interface] = ACTIONS(4180),
    [anon_sym_abstract] = ACTIONS(4180),
    [anon_sym_val] = ACTIONS(4180),
    [anon_sym_override] = ACTIONS(4180),
    [aux_sym_char_token1] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4180),
    [anon_sym_DQUOTE] = ACTIONS(4180),
    [anon_sym_AT_DQUOTE] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [sym_bool] = ACTIONS(4180),
    [sym_unit] = ACTIONS(4178),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4180),
    [sym_op_identifier] = ACTIONS(4180),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_PLUS_DOT] = ACTIONS(4180),
    [anon_sym_DASH_DOT] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_TILDE] = ACTIONS(4178),
    [aux_sym_prefix_op_token1] = ACTIONS(4180),
    [aux_sym_infix_op_token1] = ACTIONS(4178),
    [aux_sym_infix_op_token2] = ACTIONS(4180),
    [anon_sym_PIPE_PIPE] = ACTIONS(4180),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_COLON_EQ] = ACTIONS(4178),
    [anon_sym_DOLLAR] = ACTIONS(4180),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4180),
    [sym_int] = ACTIONS(4180),
    [sym_xint] = ACTIONS(4178),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4178),
    [sym__newline] = ACTIONS(4178),
    [sym__dedent] = ACTIONS(4178),
  },
  [2133] = {
    [sym_block_comment] = STATE(2133),
    [sym_compiler_directive_decl] = STATE(2133),
    [sym_fsi_directive_decl] = STATE(2133),
    [sym_preproc_line] = STATE(2133),
    [sym_identifier] = ACTIONS(3984),
    [anon_sym_EQ] = ACTIONS(3982),
    [anon_sym_LBRACK_LT] = ACTIONS(3982),
    [anon_sym_COLON] = ACTIONS(3984),
    [anon_sym_return] = ACTIONS(3984),
    [anon_sym_do] = ACTIONS(3984),
    [anon_sym_and] = ACTIONS(3984),
    [anon_sym_let] = ACTIONS(3984),
    [anon_sym_let_BANG] = ACTIONS(3982),
    [aux_sym_access_modifier_token1] = ACTIONS(3982),
    [anon_sym_LPAREN] = ACTIONS(3984),
    [anon_sym_COMMA] = ACTIONS(3982),
    [anon_sym_null] = ACTIONS(3984),
    [anon_sym_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AMP] = ACTIONS(3984),
    [anon_sym_LBRACK] = ACTIONS(3984),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(3984),
    [anon_sym_LT_AT] = ACTIONS(3984),
    [anon_sym_LT_AT_AT] = ACTIONS(3984),
    [anon_sym_DOT] = ACTIONS(3984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3982),
    [anon_sym_new] = ACTIONS(3984),
    [anon_sym_with] = ACTIONS(3984),
    [anon_sym_return_BANG] = ACTIONS(3982),
    [anon_sym_yield] = ACTIONS(3984),
    [anon_sym_yield_BANG] = ACTIONS(3982),
    [anon_sym_lazy] = ACTIONS(3984),
    [anon_sym_assert] = ACTIONS(3984),
    [anon_sym_upcast] = ACTIONS(3984),
    [anon_sym_downcast] = ACTIONS(3984),
    [anon_sym_COLON_GT] = ACTIONS(3982),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3982),
    [anon_sym_for] = ACTIONS(3984),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_if] = ACTIONS(3984),
    [anon_sym_fun] = ACTIONS(3984),
    [anon_sym_try] = ACTIONS(3984),
    [anon_sym_match] = ACTIONS(3984),
    [anon_sym_match_BANG] = ACTIONS(3982),
    [anon_sym_function] = ACTIONS(3984),
    [anon_sym_LT_DASH] = ACTIONS(3984),
    [anon_sym_DOT_LBRACK] = ACTIONS(3982),
    [anon_sym_LT] = ACTIONS(3982),
    [anon_sym_use] = ACTIONS(3984),
    [anon_sym_use_BANG] = ACTIONS(3982),
    [anon_sym_do_BANG] = ACTIONS(3982),
    [anon_sym_begin] = ACTIONS(3984),
    [anon_sym_LPAREN2] = ACTIONS(3984),
    [anon_sym_default] = ACTIONS(3984),
    [anon_sym_or] = ACTIONS(3984),
    [anon_sym_static] = ACTIONS(3984),
    [anon_sym_member] = ACTIONS(3984),
    [anon_sym_interface] = ACTIONS(3984),
    [anon_sym_abstract] = ACTIONS(3984),
    [anon_sym_val] = ACTIONS(3984),
    [anon_sym_override] = ACTIONS(3984),
    [aux_sym_char_token1] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3984),
    [anon_sym_DQUOTE] = ACTIONS(3984),
    [anon_sym_AT_DQUOTE] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [sym_bool] = ACTIONS(3984),
    [sym_unit] = ACTIONS(3982),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3984),
    [sym_op_identifier] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3984),
    [anon_sym_DASH] = ACTIONS(3984),
    [anon_sym_PLUS_DOT] = ACTIONS(3984),
    [anon_sym_DASH_DOT] = ACTIONS(3984),
    [anon_sym_PERCENT] = ACTIONS(3984),
    [anon_sym_AMP_AMP] = ACTIONS(3984),
    [anon_sym_TILDE] = ACTIONS(3982),
    [aux_sym_prefix_op_token1] = ACTIONS(3984),
    [aux_sym_infix_op_token1] = ACTIONS(3982),
    [aux_sym_infix_op_token2] = ACTIONS(3984),
    [anon_sym_PIPE_PIPE] = ACTIONS(3984),
    [anon_sym_BANG_EQ] = ACTIONS(3984),
    [anon_sym_COLON_EQ] = ACTIONS(3982),
    [anon_sym_DOLLAR] = ACTIONS(3984),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3984),
    [sym_int] = ACTIONS(3984),
    [sym_xint] = ACTIONS(3982),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3982),
    [sym__newline] = ACTIONS(3982),
    [sym__dedent] = ACTIONS(3982),
  },
  [2134] = {
    [sym_block_comment] = STATE(2134),
    [sym_compiler_directive_decl] = STATE(2134),
    [sym_fsi_directive_decl] = STATE(2134),
    [sym_preproc_line] = STATE(2134),
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_EQ] = ACTIONS(4149),
    [anon_sym_LBRACK_LT] = ACTIONS(4149),
    [anon_sym_COLON] = ACTIONS(4151),
    [anon_sym_return] = ACTIONS(4151),
    [anon_sym_do] = ACTIONS(4151),
    [anon_sym_let] = ACTIONS(4151),
    [anon_sym_let_BANG] = ACTIONS(4149),
    [aux_sym_access_modifier_token1] = ACTIONS(4149),
    [anon_sym_LPAREN] = ACTIONS(4151),
    [anon_sym_COMMA] = ACTIONS(4149),
    [anon_sym_null] = ACTIONS(4151),
    [anon_sym_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_AMP] = ACTIONS(4151),
    [anon_sym_LBRACK] = ACTIONS(4151),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4149),
    [anon_sym_LBRACE] = ACTIONS(4151),
    [anon_sym_LT_AT] = ACTIONS(4151),
    [anon_sym_LT_AT_AT] = ACTIONS(4151),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4149),
    [anon_sym_new] = ACTIONS(4151),
    [anon_sym_with] = ACTIONS(4151),
    [anon_sym_return_BANG] = ACTIONS(4149),
    [anon_sym_yield] = ACTIONS(4151),
    [anon_sym_yield_BANG] = ACTIONS(4149),
    [anon_sym_lazy] = ACTIONS(4151),
    [anon_sym_assert] = ACTIONS(4151),
    [anon_sym_upcast] = ACTIONS(4151),
    [anon_sym_downcast] = ACTIONS(4151),
    [anon_sym_COLON_GT] = ACTIONS(4149),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4149),
    [anon_sym_for] = ACTIONS(4151),
    [anon_sym_while] = ACTIONS(4151),
    [anon_sym_if] = ACTIONS(4151),
    [anon_sym_fun] = ACTIONS(4151),
    [anon_sym_try] = ACTIONS(4151),
    [anon_sym_match] = ACTIONS(4151),
    [anon_sym_match_BANG] = ACTIONS(4149),
    [anon_sym_function] = ACTIONS(4151),
    [anon_sym_LT_DASH] = ACTIONS(4151),
    [anon_sym_DOT_LBRACK] = ACTIONS(4149),
    [anon_sym_LT] = ACTIONS(4149),
    [anon_sym_use] = ACTIONS(4151),
    [anon_sym_use_BANG] = ACTIONS(4149),
    [anon_sym_do_BANG] = ACTIONS(4149),
    [anon_sym_begin] = ACTIONS(4151),
    [anon_sym_LPAREN2] = ACTIONS(4151),
    [anon_sym_default] = ACTIONS(4151),
    [anon_sym_or] = ACTIONS(4151),
    [anon_sym_static] = ACTIONS(4151),
    [anon_sym_member] = ACTIONS(4151),
    [anon_sym_interface] = ACTIONS(4151),
    [anon_sym_abstract] = ACTIONS(4151),
    [anon_sym_val] = ACTIONS(4151),
    [anon_sym_override] = ACTIONS(4151),
    [anon_sym_inherit] = ACTIONS(4151),
    [aux_sym_char_token1] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4151),
    [anon_sym_DQUOTE] = ACTIONS(4151),
    [anon_sym_AT_DQUOTE] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [sym_bool] = ACTIONS(4151),
    [sym_unit] = ACTIONS(4149),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4151),
    [sym_op_identifier] = ACTIONS(4151),
    [anon_sym_PLUS] = ACTIONS(4151),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_PLUS_DOT] = ACTIONS(4151),
    [anon_sym_DASH_DOT] = ACTIONS(4151),
    [anon_sym_PERCENT] = ACTIONS(4151),
    [anon_sym_AMP_AMP] = ACTIONS(4151),
    [anon_sym_TILDE] = ACTIONS(4149),
    [aux_sym_prefix_op_token1] = ACTIONS(4151),
    [aux_sym_infix_op_token1] = ACTIONS(4149),
    [aux_sym_infix_op_token2] = ACTIONS(4151),
    [anon_sym_PIPE_PIPE] = ACTIONS(4151),
    [anon_sym_BANG_EQ] = ACTIONS(4151),
    [anon_sym_COLON_EQ] = ACTIONS(4149),
    [anon_sym_DOLLAR] = ACTIONS(4151),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4151),
    [sym_int] = ACTIONS(4151),
    [sym_xint] = ACTIONS(4149),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4149),
    [anon_sym_POUNDendif] = ACTIONS(4149),
    [sym__newline] = ACTIONS(4149),
  },
  [2135] = {
    [sym_block_comment] = STATE(2135),
    [sym_compiler_directive_decl] = STATE(2135),
    [sym_fsi_directive_decl] = STATE(2135),
    [sym_preproc_line] = STATE(2135),
    [sym_identifier] = ACTIONS(4147),
    [anon_sym_EQ] = ACTIONS(4145),
    [anon_sym_LBRACK_LT] = ACTIONS(4145),
    [anon_sym_COLON] = ACTIONS(4147),
    [anon_sym_return] = ACTIONS(4147),
    [anon_sym_do] = ACTIONS(4147),
    [anon_sym_let] = ACTIONS(4147),
    [anon_sym_let_BANG] = ACTIONS(4145),
    [aux_sym_access_modifier_token1] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(4147),
    [anon_sym_COMMA] = ACTIONS(4145),
    [anon_sym_null] = ACTIONS(4147),
    [anon_sym_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_COLON] = ACTIONS(4145),
    [anon_sym_AMP] = ACTIONS(4147),
    [anon_sym_LBRACK] = ACTIONS(4147),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4145),
    [anon_sym_LBRACE] = ACTIONS(4147),
    [anon_sym_LT_AT] = ACTIONS(4147),
    [anon_sym_LT_AT_AT] = ACTIONS(4147),
    [anon_sym_DOT] = ACTIONS(4147),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4145),
    [anon_sym_new] = ACTIONS(4147),
    [anon_sym_with] = ACTIONS(4147),
    [anon_sym_return_BANG] = ACTIONS(4145),
    [anon_sym_yield] = ACTIONS(4147),
    [anon_sym_yield_BANG] = ACTIONS(4145),
    [anon_sym_lazy] = ACTIONS(4147),
    [anon_sym_assert] = ACTIONS(4147),
    [anon_sym_upcast] = ACTIONS(4147),
    [anon_sym_downcast] = ACTIONS(4147),
    [anon_sym_COLON_GT] = ACTIONS(4145),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4145),
    [anon_sym_for] = ACTIONS(4147),
    [anon_sym_while] = ACTIONS(4147),
    [anon_sym_if] = ACTIONS(4147),
    [anon_sym_fun] = ACTIONS(4147),
    [anon_sym_try] = ACTIONS(4147),
    [anon_sym_match] = ACTIONS(4147),
    [anon_sym_match_BANG] = ACTIONS(4145),
    [anon_sym_function] = ACTIONS(4147),
    [anon_sym_LT_DASH] = ACTIONS(4147),
    [anon_sym_DOT_LBRACK] = ACTIONS(4145),
    [anon_sym_LT] = ACTIONS(4145),
    [anon_sym_use] = ACTIONS(4147),
    [anon_sym_use_BANG] = ACTIONS(4145),
    [anon_sym_do_BANG] = ACTIONS(4145),
    [anon_sym_begin] = ACTIONS(4147),
    [anon_sym_LPAREN2] = ACTIONS(4147),
    [anon_sym_default] = ACTIONS(4147),
    [anon_sym_or] = ACTIONS(4147),
    [anon_sym_static] = ACTIONS(4147),
    [anon_sym_member] = ACTIONS(4147),
    [anon_sym_interface] = ACTIONS(4147),
    [anon_sym_abstract] = ACTIONS(4147),
    [anon_sym_val] = ACTIONS(4147),
    [anon_sym_override] = ACTIONS(4147),
    [anon_sym_inherit] = ACTIONS(4147),
    [aux_sym_char_token1] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4147),
    [anon_sym_DQUOTE] = ACTIONS(4147),
    [anon_sym_AT_DQUOTE] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [sym_bool] = ACTIONS(4147),
    [sym_unit] = ACTIONS(4145),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4147),
    [sym_op_identifier] = ACTIONS(4147),
    [anon_sym_PLUS] = ACTIONS(4147),
    [anon_sym_DASH] = ACTIONS(4147),
    [anon_sym_PLUS_DOT] = ACTIONS(4147),
    [anon_sym_DASH_DOT] = ACTIONS(4147),
    [anon_sym_PERCENT] = ACTIONS(4147),
    [anon_sym_AMP_AMP] = ACTIONS(4147),
    [anon_sym_TILDE] = ACTIONS(4145),
    [aux_sym_prefix_op_token1] = ACTIONS(4147),
    [aux_sym_infix_op_token1] = ACTIONS(4145),
    [aux_sym_infix_op_token2] = ACTIONS(4147),
    [anon_sym_PIPE_PIPE] = ACTIONS(4147),
    [anon_sym_BANG_EQ] = ACTIONS(4147),
    [anon_sym_COLON_EQ] = ACTIONS(4145),
    [anon_sym_DOLLAR] = ACTIONS(4147),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4147),
    [sym_int] = ACTIONS(4147),
    [sym_xint] = ACTIONS(4145),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4145),
    [anon_sym_POUNDendif] = ACTIONS(4145),
    [sym__newline] = ACTIONS(4145),
  },
  [2136] = {
    [sym_block_comment] = STATE(2136),
    [sym_compiler_directive_decl] = STATE(2136),
    [sym_fsi_directive_decl] = STATE(2136),
    [sym_preproc_line] = STATE(2136),
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_EQ] = ACTIONS(3990),
    [anon_sym_LBRACK_LT] = ACTIONS(3990),
    [anon_sym_COLON] = ACTIONS(3992),
    [anon_sym_return] = ACTIONS(3992),
    [anon_sym_do] = ACTIONS(3992),
    [anon_sym_let] = ACTIONS(3992),
    [anon_sym_let_BANG] = ACTIONS(3990),
    [aux_sym_access_modifier_token1] = ACTIONS(3990),
    [anon_sym_LPAREN] = ACTIONS(3992),
    [anon_sym_COMMA] = ACTIONS(3990),
    [anon_sym_null] = ACTIONS(3992),
    [anon_sym_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [anon_sym_AMP] = ACTIONS(3992),
    [anon_sym_LBRACK] = ACTIONS(3992),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3990),
    [anon_sym_LBRACE] = ACTIONS(3992),
    [anon_sym_LT_AT] = ACTIONS(3992),
    [anon_sym_LT_AT_AT] = ACTIONS(3992),
    [anon_sym_DOT] = ACTIONS(3992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3990),
    [anon_sym_new] = ACTIONS(3992),
    [anon_sym_with] = ACTIONS(3992),
    [anon_sym_return_BANG] = ACTIONS(3990),
    [anon_sym_yield] = ACTIONS(3992),
    [anon_sym_yield_BANG] = ACTIONS(3990),
    [anon_sym_lazy] = ACTIONS(3992),
    [anon_sym_assert] = ACTIONS(3992),
    [anon_sym_upcast] = ACTIONS(3992),
    [anon_sym_downcast] = ACTIONS(3992),
    [anon_sym_COLON_GT] = ACTIONS(3990),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3990),
    [anon_sym_for] = ACTIONS(3992),
    [anon_sym_while] = ACTIONS(3992),
    [anon_sym_if] = ACTIONS(3992),
    [anon_sym_fun] = ACTIONS(3992),
    [anon_sym_try] = ACTIONS(3992),
    [anon_sym_match] = ACTIONS(3992),
    [anon_sym_match_BANG] = ACTIONS(3990),
    [anon_sym_function] = ACTIONS(3992),
    [anon_sym_LT_DASH] = ACTIONS(3992),
    [anon_sym_DOT_LBRACK] = ACTIONS(3990),
    [anon_sym_LT] = ACTIONS(3990),
    [anon_sym_use] = ACTIONS(3992),
    [anon_sym_use_BANG] = ACTIONS(3990),
    [anon_sym_do_BANG] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_LPAREN2] = ACTIONS(3992),
    [anon_sym_default] = ACTIONS(3992),
    [anon_sym_or] = ACTIONS(3992),
    [anon_sym_static] = ACTIONS(3992),
    [anon_sym_member] = ACTIONS(3992),
    [anon_sym_interface] = ACTIONS(3992),
    [anon_sym_abstract] = ACTIONS(3992),
    [anon_sym_val] = ACTIONS(3992),
    [anon_sym_override] = ACTIONS(3992),
    [anon_sym_inherit] = ACTIONS(3992),
    [aux_sym_char_token1] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3992),
    [anon_sym_DQUOTE] = ACTIONS(3992),
    [anon_sym_AT_DQUOTE] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [sym_bool] = ACTIONS(3992),
    [sym_unit] = ACTIONS(3990),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3992),
    [sym_op_identifier] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3992),
    [anon_sym_DASH] = ACTIONS(3992),
    [anon_sym_PLUS_DOT] = ACTIONS(3992),
    [anon_sym_DASH_DOT] = ACTIONS(3992),
    [anon_sym_PERCENT] = ACTIONS(3992),
    [anon_sym_AMP_AMP] = ACTIONS(3992),
    [anon_sym_TILDE] = ACTIONS(3990),
    [aux_sym_prefix_op_token1] = ACTIONS(3992),
    [aux_sym_infix_op_token1] = ACTIONS(3990),
    [aux_sym_infix_op_token2] = ACTIONS(3992),
    [anon_sym_PIPE_PIPE] = ACTIONS(3992),
    [anon_sym_BANG_EQ] = ACTIONS(3992),
    [anon_sym_COLON_EQ] = ACTIONS(3990),
    [anon_sym_DOLLAR] = ACTIONS(3992),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3992),
    [sym_int] = ACTIONS(3992),
    [sym_xint] = ACTIONS(3990),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3990),
    [anon_sym_POUNDendif] = ACTIONS(3990),
    [sym__newline] = ACTIONS(3990),
  },
  [2137] = {
    [sym_block_comment] = STATE(2137),
    [sym_compiler_directive_decl] = STATE(2137),
    [sym_fsi_directive_decl] = STATE(2137),
    [sym_preproc_line] = STATE(2137),
    [sym_identifier] = ACTIONS(3988),
    [anon_sym_EQ] = ACTIONS(3986),
    [anon_sym_LBRACK_LT] = ACTIONS(3986),
    [anon_sym_COLON] = ACTIONS(3988),
    [anon_sym_return] = ACTIONS(3988),
    [anon_sym_do] = ACTIONS(3988),
    [anon_sym_let] = ACTIONS(3988),
    [anon_sym_let_BANG] = ACTIONS(3986),
    [aux_sym_access_modifier_token1] = ACTIONS(3986),
    [anon_sym_LPAREN] = ACTIONS(3988),
    [anon_sym_COMMA] = ACTIONS(3986),
    [anon_sym_null] = ACTIONS(3988),
    [anon_sym_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_COLON] = ACTIONS(3986),
    [anon_sym_AMP] = ACTIONS(3988),
    [anon_sym_LBRACK] = ACTIONS(3988),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3986),
    [anon_sym_LBRACE] = ACTIONS(3988),
    [anon_sym_LT_AT] = ACTIONS(3988),
    [anon_sym_LT_AT_AT] = ACTIONS(3988),
    [anon_sym_DOT] = ACTIONS(3988),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3986),
    [anon_sym_new] = ACTIONS(3988),
    [anon_sym_with] = ACTIONS(3988),
    [anon_sym_return_BANG] = ACTIONS(3986),
    [anon_sym_yield] = ACTIONS(3988),
    [anon_sym_yield_BANG] = ACTIONS(3986),
    [anon_sym_lazy] = ACTIONS(3988),
    [anon_sym_assert] = ACTIONS(3988),
    [anon_sym_upcast] = ACTIONS(3988),
    [anon_sym_downcast] = ACTIONS(3988),
    [anon_sym_COLON_GT] = ACTIONS(3986),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_while] = ACTIONS(3988),
    [anon_sym_if] = ACTIONS(3988),
    [anon_sym_fun] = ACTIONS(3988),
    [anon_sym_try] = ACTIONS(3988),
    [anon_sym_match] = ACTIONS(3988),
    [anon_sym_match_BANG] = ACTIONS(3986),
    [anon_sym_function] = ACTIONS(3988),
    [anon_sym_LT_DASH] = ACTIONS(3988),
    [anon_sym_DOT_LBRACK] = ACTIONS(3986),
    [anon_sym_LT] = ACTIONS(3986),
    [anon_sym_use] = ACTIONS(3988),
    [anon_sym_use_BANG] = ACTIONS(3986),
    [anon_sym_do_BANG] = ACTIONS(3986),
    [anon_sym_begin] = ACTIONS(3988),
    [anon_sym_LPAREN2] = ACTIONS(3988),
    [anon_sym_default] = ACTIONS(3988),
    [anon_sym_or] = ACTIONS(3988),
    [anon_sym_static] = ACTIONS(3988),
    [anon_sym_member] = ACTIONS(3988),
    [anon_sym_interface] = ACTIONS(3988),
    [anon_sym_abstract] = ACTIONS(3988),
    [anon_sym_val] = ACTIONS(3988),
    [anon_sym_override] = ACTIONS(3988),
    [anon_sym_inherit] = ACTIONS(3988),
    [aux_sym_char_token1] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3988),
    [anon_sym_DQUOTE] = ACTIONS(3988),
    [anon_sym_AT_DQUOTE] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [sym_bool] = ACTIONS(3988),
    [sym_unit] = ACTIONS(3986),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3988),
    [sym_op_identifier] = ACTIONS(3988),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_PLUS_DOT] = ACTIONS(3988),
    [anon_sym_DASH_DOT] = ACTIONS(3988),
    [anon_sym_PERCENT] = ACTIONS(3988),
    [anon_sym_AMP_AMP] = ACTIONS(3988),
    [anon_sym_TILDE] = ACTIONS(3986),
    [aux_sym_prefix_op_token1] = ACTIONS(3988),
    [aux_sym_infix_op_token1] = ACTIONS(3986),
    [aux_sym_infix_op_token2] = ACTIONS(3988),
    [anon_sym_PIPE_PIPE] = ACTIONS(3988),
    [anon_sym_BANG_EQ] = ACTIONS(3988),
    [anon_sym_COLON_EQ] = ACTIONS(3986),
    [anon_sym_DOLLAR] = ACTIONS(3988),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3988),
    [sym_int] = ACTIONS(3988),
    [sym_xint] = ACTIONS(3986),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3986),
    [anon_sym_POUNDendif] = ACTIONS(3986),
    [sym__newline] = ACTIONS(3986),
  },
  [2138] = {
    [sym_block_comment] = STATE(2138),
    [sym_compiler_directive_decl] = STATE(2138),
    [sym_fsi_directive_decl] = STATE(2138),
    [sym_preproc_line] = STATE(2138),
    [sym_identifier] = ACTIONS(3962),
    [anon_sym_EQ] = ACTIONS(3960),
    [anon_sym_LBRACK_LT] = ACTIONS(3960),
    [anon_sym_COLON] = ACTIONS(3962),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_do] = ACTIONS(3962),
    [anon_sym_and] = ACTIONS(3962),
    [anon_sym_let] = ACTIONS(3962),
    [anon_sym_let_BANG] = ACTIONS(3960),
    [aux_sym_access_modifier_token1] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_COMMA] = ACTIONS(3960),
    [anon_sym_null] = ACTIONS(3962),
    [anon_sym_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_COLON] = ACTIONS(3960),
    [anon_sym_AMP] = ACTIONS(3962),
    [anon_sym_LBRACK] = ACTIONS(3962),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_LT_AT] = ACTIONS(3962),
    [anon_sym_LT_AT_AT] = ACTIONS(3962),
    [anon_sym_DOT] = ACTIONS(3962),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3960),
    [anon_sym_new] = ACTIONS(3962),
    [anon_sym_with] = ACTIONS(3962),
    [anon_sym_return_BANG] = ACTIONS(3960),
    [anon_sym_yield] = ACTIONS(3962),
    [anon_sym_yield_BANG] = ACTIONS(3960),
    [anon_sym_lazy] = ACTIONS(3962),
    [anon_sym_assert] = ACTIONS(3962),
    [anon_sym_upcast] = ACTIONS(3962),
    [anon_sym_downcast] = ACTIONS(3962),
    [anon_sym_COLON_GT] = ACTIONS(3960),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3960),
    [anon_sym_for] = ACTIONS(3962),
    [anon_sym_while] = ACTIONS(3962),
    [anon_sym_if] = ACTIONS(3962),
    [anon_sym_fun] = ACTIONS(3962),
    [anon_sym_try] = ACTIONS(3962),
    [anon_sym_match] = ACTIONS(3962),
    [anon_sym_match_BANG] = ACTIONS(3960),
    [anon_sym_function] = ACTIONS(3962),
    [anon_sym_LT_DASH] = ACTIONS(3962),
    [anon_sym_DOT_LBRACK] = ACTIONS(3960),
    [anon_sym_LT] = ACTIONS(3960),
    [anon_sym_use] = ACTIONS(3962),
    [anon_sym_use_BANG] = ACTIONS(3960),
    [anon_sym_do_BANG] = ACTIONS(3960),
    [anon_sym_begin] = ACTIONS(3962),
    [anon_sym_LPAREN2] = ACTIONS(3962),
    [anon_sym_default] = ACTIONS(3962),
    [anon_sym_or] = ACTIONS(3962),
    [anon_sym_static] = ACTIONS(3962),
    [anon_sym_member] = ACTIONS(3962),
    [anon_sym_interface] = ACTIONS(3962),
    [anon_sym_abstract] = ACTIONS(3962),
    [anon_sym_val] = ACTIONS(3962),
    [anon_sym_override] = ACTIONS(3962),
    [aux_sym_char_token1] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3962),
    [anon_sym_DQUOTE] = ACTIONS(3962),
    [anon_sym_AT_DQUOTE] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [sym_bool] = ACTIONS(3962),
    [sym_unit] = ACTIONS(3960),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3962),
    [sym_op_identifier] = ACTIONS(3962),
    [anon_sym_PLUS] = ACTIONS(3962),
    [anon_sym_DASH] = ACTIONS(3962),
    [anon_sym_PLUS_DOT] = ACTIONS(3962),
    [anon_sym_DASH_DOT] = ACTIONS(3962),
    [anon_sym_PERCENT] = ACTIONS(3962),
    [anon_sym_AMP_AMP] = ACTIONS(3962),
    [anon_sym_TILDE] = ACTIONS(3960),
    [aux_sym_prefix_op_token1] = ACTIONS(3962),
    [aux_sym_infix_op_token1] = ACTIONS(3960),
    [aux_sym_infix_op_token2] = ACTIONS(3962),
    [anon_sym_PIPE_PIPE] = ACTIONS(3962),
    [anon_sym_BANG_EQ] = ACTIONS(3962),
    [anon_sym_COLON_EQ] = ACTIONS(3960),
    [anon_sym_DOLLAR] = ACTIONS(3962),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3962),
    [sym_int] = ACTIONS(3962),
    [sym_xint] = ACTIONS(3960),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3960),
    [anon_sym_POUNDendif] = ACTIONS(3960),
    [sym__newline] = ACTIONS(3960),
  },
  [2139] = {
    [sym_block_comment] = STATE(2139),
    [sym_compiler_directive_decl] = STATE(2139),
    [sym_fsi_directive_decl] = STATE(2139),
    [sym_preproc_line] = STATE(2139),
    [sym_identifier] = ACTIONS(3958),
    [anon_sym_EQ] = ACTIONS(3956),
    [anon_sym_LBRACK_LT] = ACTIONS(3956),
    [anon_sym_COLON] = ACTIONS(3958),
    [anon_sym_return] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(3958),
    [anon_sym_and] = ACTIONS(3958),
    [anon_sym_let] = ACTIONS(3958),
    [anon_sym_let_BANG] = ACTIONS(3956),
    [aux_sym_access_modifier_token1] = ACTIONS(3956),
    [anon_sym_LPAREN] = ACTIONS(3958),
    [anon_sym_COMMA] = ACTIONS(3956),
    [anon_sym_null] = ACTIONS(3958),
    [anon_sym_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_COLON] = ACTIONS(3956),
    [anon_sym_AMP] = ACTIONS(3958),
    [anon_sym_LBRACK] = ACTIONS(3958),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3956),
    [anon_sym_LBRACE] = ACTIONS(3958),
    [anon_sym_LT_AT] = ACTIONS(3958),
    [anon_sym_LT_AT_AT] = ACTIONS(3958),
    [anon_sym_DOT] = ACTIONS(3958),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3956),
    [anon_sym_new] = ACTIONS(3958),
    [anon_sym_with] = ACTIONS(3958),
    [anon_sym_return_BANG] = ACTIONS(3956),
    [anon_sym_yield] = ACTIONS(3958),
    [anon_sym_yield_BANG] = ACTIONS(3956),
    [anon_sym_lazy] = ACTIONS(3958),
    [anon_sym_assert] = ACTIONS(3958),
    [anon_sym_upcast] = ACTIONS(3958),
    [anon_sym_downcast] = ACTIONS(3958),
    [anon_sym_COLON_GT] = ACTIONS(3956),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3956),
    [anon_sym_for] = ACTIONS(3958),
    [anon_sym_while] = ACTIONS(3958),
    [anon_sym_if] = ACTIONS(3958),
    [anon_sym_fun] = ACTIONS(3958),
    [anon_sym_try] = ACTIONS(3958),
    [anon_sym_match] = ACTIONS(3958),
    [anon_sym_match_BANG] = ACTIONS(3956),
    [anon_sym_function] = ACTIONS(3958),
    [anon_sym_LT_DASH] = ACTIONS(3958),
    [anon_sym_DOT_LBRACK] = ACTIONS(3956),
    [anon_sym_LT] = ACTIONS(3956),
    [anon_sym_use] = ACTIONS(3958),
    [anon_sym_use_BANG] = ACTIONS(3956),
    [anon_sym_do_BANG] = ACTIONS(3956),
    [anon_sym_begin] = ACTIONS(3958),
    [anon_sym_LPAREN2] = ACTIONS(3958),
    [anon_sym_default] = ACTIONS(3958),
    [anon_sym_or] = ACTIONS(3958),
    [anon_sym_static] = ACTIONS(3958),
    [anon_sym_member] = ACTIONS(3958),
    [anon_sym_interface] = ACTIONS(3958),
    [anon_sym_abstract] = ACTIONS(3958),
    [anon_sym_val] = ACTIONS(3958),
    [anon_sym_override] = ACTIONS(3958),
    [aux_sym_char_token1] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [anon_sym_AT_DQUOTE] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [sym_bool] = ACTIONS(3958),
    [sym_unit] = ACTIONS(3956),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3958),
    [sym_op_identifier] = ACTIONS(3958),
    [anon_sym_PLUS] = ACTIONS(3958),
    [anon_sym_DASH] = ACTIONS(3958),
    [anon_sym_PLUS_DOT] = ACTIONS(3958),
    [anon_sym_DASH_DOT] = ACTIONS(3958),
    [anon_sym_PERCENT] = ACTIONS(3958),
    [anon_sym_AMP_AMP] = ACTIONS(3958),
    [anon_sym_TILDE] = ACTIONS(3956),
    [aux_sym_prefix_op_token1] = ACTIONS(3958),
    [aux_sym_infix_op_token1] = ACTIONS(3956),
    [aux_sym_infix_op_token2] = ACTIONS(3958),
    [anon_sym_PIPE_PIPE] = ACTIONS(3958),
    [anon_sym_BANG_EQ] = ACTIONS(3958),
    [anon_sym_COLON_EQ] = ACTIONS(3956),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3958),
    [sym_int] = ACTIONS(3958),
    [sym_xint] = ACTIONS(3956),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3956),
    [anon_sym_POUNDendif] = ACTIONS(3956),
    [sym__newline] = ACTIONS(3956),
  },
  [2140] = {
    [sym_block_comment] = STATE(2140),
    [sym_compiler_directive_decl] = STATE(2140),
    [sym_fsi_directive_decl] = STATE(2140),
    [sym_preproc_line] = STATE(2140),
    [sym_identifier] = ACTIONS(3954),
    [anon_sym_EQ] = ACTIONS(3952),
    [anon_sym_LBRACK_LT] = ACTIONS(3952),
    [anon_sym_COLON] = ACTIONS(3954),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_do] = ACTIONS(3954),
    [anon_sym_and] = ACTIONS(3954),
    [anon_sym_let] = ACTIONS(3954),
    [anon_sym_let_BANG] = ACTIONS(3952),
    [aux_sym_access_modifier_token1] = ACTIONS(3952),
    [anon_sym_LPAREN] = ACTIONS(3954),
    [anon_sym_COMMA] = ACTIONS(3952),
    [anon_sym_null] = ACTIONS(3954),
    [anon_sym_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_COLON] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3954),
    [anon_sym_LBRACK] = ACTIONS(3954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(3954),
    [anon_sym_LT_AT] = ACTIONS(3954),
    [anon_sym_LT_AT_AT] = ACTIONS(3954),
    [anon_sym_DOT] = ACTIONS(3954),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3952),
    [anon_sym_new] = ACTIONS(3954),
    [anon_sym_with] = ACTIONS(3954),
    [anon_sym_return_BANG] = ACTIONS(3952),
    [anon_sym_yield] = ACTIONS(3954),
    [anon_sym_yield_BANG] = ACTIONS(3952),
    [anon_sym_lazy] = ACTIONS(3954),
    [anon_sym_assert] = ACTIONS(3954),
    [anon_sym_upcast] = ACTIONS(3954),
    [anon_sym_downcast] = ACTIONS(3954),
    [anon_sym_COLON_GT] = ACTIONS(3952),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3952),
    [anon_sym_for] = ACTIONS(3954),
    [anon_sym_while] = ACTIONS(3954),
    [anon_sym_if] = ACTIONS(3954),
    [anon_sym_fun] = ACTIONS(3954),
    [anon_sym_try] = ACTIONS(3954),
    [anon_sym_match] = ACTIONS(3954),
    [anon_sym_match_BANG] = ACTIONS(3952),
    [anon_sym_function] = ACTIONS(3954),
    [anon_sym_LT_DASH] = ACTIONS(3954),
    [anon_sym_DOT_LBRACK] = ACTIONS(3952),
    [anon_sym_LT] = ACTIONS(3952),
    [anon_sym_use] = ACTIONS(3954),
    [anon_sym_use_BANG] = ACTIONS(3952),
    [anon_sym_do_BANG] = ACTIONS(3952),
    [anon_sym_begin] = ACTIONS(3954),
    [anon_sym_LPAREN2] = ACTIONS(3954),
    [anon_sym_default] = ACTIONS(3954),
    [anon_sym_or] = ACTIONS(3954),
    [anon_sym_static] = ACTIONS(3954),
    [anon_sym_member] = ACTIONS(3954),
    [anon_sym_interface] = ACTIONS(3954),
    [anon_sym_abstract] = ACTIONS(3954),
    [anon_sym_val] = ACTIONS(3954),
    [anon_sym_override] = ACTIONS(3954),
    [aux_sym_char_token1] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3954),
    [anon_sym_DQUOTE] = ACTIONS(3954),
    [anon_sym_AT_DQUOTE] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [sym_bool] = ACTIONS(3954),
    [sym_unit] = ACTIONS(3952),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3954),
    [sym_op_identifier] = ACTIONS(3954),
    [anon_sym_PLUS] = ACTIONS(3954),
    [anon_sym_DASH] = ACTIONS(3954),
    [anon_sym_PLUS_DOT] = ACTIONS(3954),
    [anon_sym_DASH_DOT] = ACTIONS(3954),
    [anon_sym_PERCENT] = ACTIONS(3954),
    [anon_sym_AMP_AMP] = ACTIONS(3954),
    [anon_sym_TILDE] = ACTIONS(3952),
    [aux_sym_prefix_op_token1] = ACTIONS(3954),
    [aux_sym_infix_op_token1] = ACTIONS(3952),
    [aux_sym_infix_op_token2] = ACTIONS(3954),
    [anon_sym_PIPE_PIPE] = ACTIONS(3954),
    [anon_sym_BANG_EQ] = ACTIONS(3954),
    [anon_sym_COLON_EQ] = ACTIONS(3952),
    [anon_sym_DOLLAR] = ACTIONS(3954),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3954),
    [sym_int] = ACTIONS(3954),
    [sym_xint] = ACTIONS(3952),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3952),
    [anon_sym_POUNDendif] = ACTIONS(3952),
    [sym__newline] = ACTIONS(3952),
  },
  [2141] = {
    [sym_block_comment] = STATE(2141),
    [sym_compiler_directive_decl] = STATE(2141),
    [sym_fsi_directive_decl] = STATE(2141),
    [sym_preproc_line] = STATE(2141),
    [sym_identifier] = ACTIONS(3984),
    [anon_sym_EQ] = ACTIONS(3982),
    [anon_sym_LBRACK_LT] = ACTIONS(3982),
    [anon_sym_COLON] = ACTIONS(3984),
    [anon_sym_return] = ACTIONS(3984),
    [anon_sym_do] = ACTIONS(3984),
    [anon_sym_let] = ACTIONS(3984),
    [anon_sym_let_BANG] = ACTIONS(3982),
    [aux_sym_access_modifier_token1] = ACTIONS(3982),
    [anon_sym_LPAREN] = ACTIONS(3984),
    [anon_sym_COMMA] = ACTIONS(3982),
    [anon_sym_null] = ACTIONS(3984),
    [anon_sym_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AMP] = ACTIONS(3984),
    [anon_sym_LBRACK] = ACTIONS(3984),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(3984),
    [anon_sym_LT_AT] = ACTIONS(3984),
    [anon_sym_LT_AT_AT] = ACTIONS(3984),
    [anon_sym_DOT] = ACTIONS(3984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3982),
    [anon_sym_new] = ACTIONS(3984),
    [anon_sym_with] = ACTIONS(3984),
    [anon_sym_return_BANG] = ACTIONS(3982),
    [anon_sym_yield] = ACTIONS(3984),
    [anon_sym_yield_BANG] = ACTIONS(3982),
    [anon_sym_lazy] = ACTIONS(3984),
    [anon_sym_assert] = ACTIONS(3984),
    [anon_sym_upcast] = ACTIONS(3984),
    [anon_sym_downcast] = ACTIONS(3984),
    [anon_sym_COLON_GT] = ACTIONS(3982),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3982),
    [anon_sym_for] = ACTIONS(3984),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_if] = ACTIONS(3984),
    [anon_sym_fun] = ACTIONS(3984),
    [anon_sym_try] = ACTIONS(3984),
    [anon_sym_match] = ACTIONS(3984),
    [anon_sym_match_BANG] = ACTIONS(3982),
    [anon_sym_function] = ACTIONS(3984),
    [anon_sym_LT_DASH] = ACTIONS(3984),
    [anon_sym_DOT_LBRACK] = ACTIONS(3982),
    [anon_sym_LT] = ACTIONS(3982),
    [anon_sym_use] = ACTIONS(3984),
    [anon_sym_use_BANG] = ACTIONS(3982),
    [anon_sym_do_BANG] = ACTIONS(3982),
    [anon_sym_begin] = ACTIONS(3984),
    [anon_sym_LPAREN2] = ACTIONS(3984),
    [anon_sym_default] = ACTIONS(3984),
    [anon_sym_or] = ACTIONS(3984),
    [anon_sym_static] = ACTIONS(3984),
    [anon_sym_member] = ACTIONS(3984),
    [anon_sym_interface] = ACTIONS(3984),
    [anon_sym_abstract] = ACTIONS(3984),
    [anon_sym_val] = ACTIONS(3984),
    [anon_sym_override] = ACTIONS(3984),
    [anon_sym_inherit] = ACTIONS(3984),
    [aux_sym_char_token1] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3984),
    [anon_sym_DQUOTE] = ACTIONS(3984),
    [anon_sym_AT_DQUOTE] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [sym_bool] = ACTIONS(3984),
    [sym_unit] = ACTIONS(3982),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3984),
    [sym_op_identifier] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3984),
    [anon_sym_DASH] = ACTIONS(3984),
    [anon_sym_PLUS_DOT] = ACTIONS(3984),
    [anon_sym_DASH_DOT] = ACTIONS(3984),
    [anon_sym_PERCENT] = ACTIONS(3984),
    [anon_sym_AMP_AMP] = ACTIONS(3984),
    [anon_sym_TILDE] = ACTIONS(3982),
    [aux_sym_prefix_op_token1] = ACTIONS(3984),
    [aux_sym_infix_op_token1] = ACTIONS(3982),
    [aux_sym_infix_op_token2] = ACTIONS(3984),
    [anon_sym_PIPE_PIPE] = ACTIONS(3984),
    [anon_sym_BANG_EQ] = ACTIONS(3984),
    [anon_sym_COLON_EQ] = ACTIONS(3982),
    [anon_sym_DOLLAR] = ACTIONS(3984),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3984),
    [sym_int] = ACTIONS(3984),
    [sym_xint] = ACTIONS(3982),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3982),
    [anon_sym_POUNDendif] = ACTIONS(3982),
    [sym__newline] = ACTIONS(3982),
  },
  [2142] = {
    [sym_block_comment] = STATE(2142),
    [sym_compiler_directive_decl] = STATE(2142),
    [sym_fsi_directive_decl] = STATE(2142),
    [sym_preproc_line] = STATE(2142),
    [sym_identifier] = ACTIONS(3980),
    [anon_sym_EQ] = ACTIONS(3978),
    [anon_sym_LBRACK_LT] = ACTIONS(3978),
    [anon_sym_COLON] = ACTIONS(3980),
    [anon_sym_return] = ACTIONS(3980),
    [anon_sym_do] = ACTIONS(3980),
    [anon_sym_let] = ACTIONS(3980),
    [anon_sym_let_BANG] = ACTIONS(3978),
    [aux_sym_access_modifier_token1] = ACTIONS(3978),
    [anon_sym_LPAREN] = ACTIONS(3980),
    [anon_sym_COMMA] = ACTIONS(3978),
    [anon_sym_null] = ACTIONS(3980),
    [anon_sym_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3978),
    [anon_sym_AMP] = ACTIONS(3980),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3978),
    [anon_sym_LBRACE] = ACTIONS(3980),
    [anon_sym_LT_AT] = ACTIONS(3980),
    [anon_sym_LT_AT_AT] = ACTIONS(3980),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3978),
    [anon_sym_new] = ACTIONS(3980),
    [anon_sym_with] = ACTIONS(3980),
    [anon_sym_return_BANG] = ACTIONS(3978),
    [anon_sym_yield] = ACTIONS(3980),
    [anon_sym_yield_BANG] = ACTIONS(3978),
    [anon_sym_lazy] = ACTIONS(3980),
    [anon_sym_assert] = ACTIONS(3980),
    [anon_sym_upcast] = ACTIONS(3980),
    [anon_sym_downcast] = ACTIONS(3980),
    [anon_sym_COLON_GT] = ACTIONS(3978),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3978),
    [anon_sym_for] = ACTIONS(3980),
    [anon_sym_while] = ACTIONS(3980),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_fun] = ACTIONS(3980),
    [anon_sym_try] = ACTIONS(3980),
    [anon_sym_match] = ACTIONS(3980),
    [anon_sym_match_BANG] = ACTIONS(3978),
    [anon_sym_function] = ACTIONS(3980),
    [anon_sym_LT_DASH] = ACTIONS(3980),
    [anon_sym_DOT_LBRACK] = ACTIONS(3978),
    [anon_sym_LT] = ACTIONS(3978),
    [anon_sym_use] = ACTIONS(3980),
    [anon_sym_use_BANG] = ACTIONS(3978),
    [anon_sym_do_BANG] = ACTIONS(3978),
    [anon_sym_begin] = ACTIONS(3980),
    [anon_sym_LPAREN2] = ACTIONS(3980),
    [anon_sym_default] = ACTIONS(3980),
    [anon_sym_or] = ACTIONS(3980),
    [anon_sym_static] = ACTIONS(3980),
    [anon_sym_member] = ACTIONS(3980),
    [anon_sym_interface] = ACTIONS(3980),
    [anon_sym_abstract] = ACTIONS(3980),
    [anon_sym_val] = ACTIONS(3980),
    [anon_sym_override] = ACTIONS(3980),
    [anon_sym_inherit] = ACTIONS(3980),
    [aux_sym_char_token1] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3980),
    [anon_sym_DQUOTE] = ACTIONS(3980),
    [anon_sym_AT_DQUOTE] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [sym_bool] = ACTIONS(3980),
    [sym_unit] = ACTIONS(3978),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3980),
    [sym_op_identifier] = ACTIONS(3980),
    [anon_sym_PLUS] = ACTIONS(3980),
    [anon_sym_DASH] = ACTIONS(3980),
    [anon_sym_PLUS_DOT] = ACTIONS(3980),
    [anon_sym_DASH_DOT] = ACTIONS(3980),
    [anon_sym_PERCENT] = ACTIONS(3980),
    [anon_sym_AMP_AMP] = ACTIONS(3980),
    [anon_sym_TILDE] = ACTIONS(3978),
    [aux_sym_prefix_op_token1] = ACTIONS(3980),
    [aux_sym_infix_op_token1] = ACTIONS(3978),
    [aux_sym_infix_op_token2] = ACTIONS(3980),
    [anon_sym_PIPE_PIPE] = ACTIONS(3980),
    [anon_sym_BANG_EQ] = ACTIONS(3980),
    [anon_sym_COLON_EQ] = ACTIONS(3978),
    [anon_sym_DOLLAR] = ACTIONS(3980),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3980),
    [sym_int] = ACTIONS(3980),
    [sym_xint] = ACTIONS(3978),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3978),
    [anon_sym_POUNDendif] = ACTIONS(3978),
    [sym__newline] = ACTIONS(3978),
  },
  [2143] = {
    [sym_block_comment] = STATE(2143),
    [sym_compiler_directive_decl] = STATE(2143),
    [sym_fsi_directive_decl] = STATE(2143),
    [sym_preproc_line] = STATE(2143),
    [sym_identifier] = ACTIONS(4122),
    [anon_sym_EQ] = ACTIONS(4120),
    [anon_sym_LBRACK_LT] = ACTIONS(4120),
    [anon_sym_COLON] = ACTIONS(4122),
    [anon_sym_return] = ACTIONS(4122),
    [anon_sym_do] = ACTIONS(4122),
    [anon_sym_let] = ACTIONS(4122),
    [anon_sym_let_BANG] = ACTIONS(4120),
    [aux_sym_access_modifier_token1] = ACTIONS(4120),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_COMMA] = ACTIONS(4120),
    [anon_sym_null] = ACTIONS(4122),
    [anon_sym_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_COLON] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_LT_AT] = ACTIONS(4122),
    [anon_sym_LT_AT_AT] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4122),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4120),
    [anon_sym_new] = ACTIONS(4122),
    [anon_sym_with] = ACTIONS(4122),
    [anon_sym_return_BANG] = ACTIONS(4120),
    [anon_sym_yield] = ACTIONS(4122),
    [anon_sym_yield_BANG] = ACTIONS(4120),
    [anon_sym_lazy] = ACTIONS(4122),
    [anon_sym_assert] = ACTIONS(4122),
    [anon_sym_upcast] = ACTIONS(4122),
    [anon_sym_downcast] = ACTIONS(4122),
    [anon_sym_COLON_GT] = ACTIONS(4120),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4120),
    [anon_sym_for] = ACTIONS(4122),
    [anon_sym_while] = ACTIONS(4122),
    [anon_sym_if] = ACTIONS(4122),
    [anon_sym_fun] = ACTIONS(4122),
    [anon_sym_try] = ACTIONS(4122),
    [anon_sym_match] = ACTIONS(4122),
    [anon_sym_match_BANG] = ACTIONS(4120),
    [anon_sym_function] = ACTIONS(4122),
    [anon_sym_LT_DASH] = ACTIONS(4122),
    [anon_sym_DOT_LBRACK] = ACTIONS(4120),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_use] = ACTIONS(4122),
    [anon_sym_use_BANG] = ACTIONS(4120),
    [anon_sym_do_BANG] = ACTIONS(4120),
    [anon_sym_begin] = ACTIONS(4122),
    [anon_sym_LPAREN2] = ACTIONS(4122),
    [anon_sym_default] = ACTIONS(4122),
    [anon_sym_or] = ACTIONS(4122),
    [anon_sym_static] = ACTIONS(4122),
    [anon_sym_member] = ACTIONS(4122),
    [anon_sym_interface] = ACTIONS(4122),
    [anon_sym_abstract] = ACTIONS(4122),
    [anon_sym_val] = ACTIONS(4122),
    [anon_sym_override] = ACTIONS(4122),
    [anon_sym_inherit] = ACTIONS(4122),
    [aux_sym_char_token1] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4122),
    [anon_sym_DQUOTE] = ACTIONS(4122),
    [anon_sym_AT_DQUOTE] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [sym_bool] = ACTIONS(4122),
    [sym_unit] = ACTIONS(4120),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4122),
    [sym_op_identifier] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4122),
    [anon_sym_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_DOT] = ACTIONS(4122),
    [anon_sym_DASH_DOT] = ACTIONS(4122),
    [anon_sym_PERCENT] = ACTIONS(4122),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_TILDE] = ACTIONS(4120),
    [aux_sym_prefix_op_token1] = ACTIONS(4122),
    [aux_sym_infix_op_token1] = ACTIONS(4120),
    [aux_sym_infix_op_token2] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_COLON_EQ] = ACTIONS(4120),
    [anon_sym_DOLLAR] = ACTIONS(4122),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4122),
    [sym_int] = ACTIONS(4122),
    [sym_xint] = ACTIONS(4120),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4120),
    [anon_sym_POUNDendif] = ACTIONS(4120),
    [sym__newline] = ACTIONS(4120),
  },
  [2144] = {
    [sym_block_comment] = STATE(2144),
    [sym_compiler_directive_decl] = STATE(2144),
    [sym_fsi_directive_decl] = STATE(2144),
    [sym_preproc_line] = STATE(2144),
    [sym_identifier] = ACTIONS(4174),
    [anon_sym_EQ] = ACTIONS(4172),
    [anon_sym_LBRACK_LT] = ACTIONS(4172),
    [anon_sym_COLON] = ACTIONS(4174),
    [anon_sym_return] = ACTIONS(4174),
    [anon_sym_do] = ACTIONS(4174),
    [anon_sym_let] = ACTIONS(4174),
    [anon_sym_let_BANG] = ACTIONS(4172),
    [aux_sym_access_modifier_token1] = ACTIONS(4172),
    [anon_sym_LPAREN] = ACTIONS(4174),
    [anon_sym_COMMA] = ACTIONS(4172),
    [anon_sym_null] = ACTIONS(4174),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_COLON] = ACTIONS(4172),
    [anon_sym_AMP] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4174),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4172),
    [anon_sym_LBRACE] = ACTIONS(4174),
    [anon_sym_LT_AT] = ACTIONS(4174),
    [anon_sym_LT_AT_AT] = ACTIONS(4174),
    [anon_sym_DOT] = ACTIONS(4174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4172),
    [anon_sym_new] = ACTIONS(4174),
    [anon_sym_with] = ACTIONS(4174),
    [anon_sym_return_BANG] = ACTIONS(4172),
    [anon_sym_yield] = ACTIONS(4174),
    [anon_sym_yield_BANG] = ACTIONS(4172),
    [anon_sym_lazy] = ACTIONS(4174),
    [anon_sym_assert] = ACTIONS(4174),
    [anon_sym_upcast] = ACTIONS(4174),
    [anon_sym_downcast] = ACTIONS(4174),
    [anon_sym_COLON_GT] = ACTIONS(4172),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4172),
    [anon_sym_for] = ACTIONS(4174),
    [anon_sym_while] = ACTIONS(4174),
    [anon_sym_if] = ACTIONS(4174),
    [anon_sym_fun] = ACTIONS(4174),
    [anon_sym_try] = ACTIONS(4174),
    [anon_sym_match] = ACTIONS(4174),
    [anon_sym_match_BANG] = ACTIONS(4172),
    [anon_sym_function] = ACTIONS(4174),
    [anon_sym_LT_DASH] = ACTIONS(4174),
    [anon_sym_DOT_LBRACK] = ACTIONS(4172),
    [anon_sym_LT] = ACTIONS(4172),
    [anon_sym_use] = ACTIONS(4174),
    [anon_sym_use_BANG] = ACTIONS(4172),
    [anon_sym_do_BANG] = ACTIONS(4172),
    [anon_sym_begin] = ACTIONS(4174),
    [anon_sym_LPAREN2] = ACTIONS(4174),
    [anon_sym_DOT_DOT2] = ACTIONS(4172),
    [anon_sym_default] = ACTIONS(4174),
    [anon_sym_or] = ACTIONS(4174),
    [anon_sym_static] = ACTIONS(4174),
    [anon_sym_member] = ACTIONS(4174),
    [anon_sym_interface] = ACTIONS(4174),
    [anon_sym_abstract] = ACTIONS(4174),
    [anon_sym_val] = ACTIONS(4174),
    [anon_sym_override] = ACTIONS(4174),
    [aux_sym_char_token1] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4174),
    [anon_sym_DQUOTE] = ACTIONS(4174),
    [anon_sym_AT_DQUOTE] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [sym_bool] = ACTIONS(4174),
    [sym_unit] = ACTIONS(4172),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4174),
    [sym_op_identifier] = ACTIONS(4174),
    [anon_sym_PLUS] = ACTIONS(4174),
    [anon_sym_DASH] = ACTIONS(4174),
    [anon_sym_PLUS_DOT] = ACTIONS(4174),
    [anon_sym_DASH_DOT] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [anon_sym_AMP_AMP] = ACTIONS(4174),
    [anon_sym_TILDE] = ACTIONS(4172),
    [aux_sym_prefix_op_token1] = ACTIONS(4174),
    [aux_sym_infix_op_token1] = ACTIONS(4172),
    [aux_sym_infix_op_token2] = ACTIONS(4174),
    [anon_sym_PIPE_PIPE] = ACTIONS(4174),
    [anon_sym_BANG_EQ] = ACTIONS(4174),
    [anon_sym_COLON_EQ] = ACTIONS(4172),
    [anon_sym_DOLLAR] = ACTIONS(4174),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4174),
    [sym_int] = ACTIONS(4174),
    [sym_xint] = ACTIONS(4172),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4172),
    [sym__newline] = ACTIONS(4172),
    [sym__dedent] = ACTIONS(4172),
  },
  [2145] = {
    [sym_block_comment] = STATE(2145),
    [sym_compiler_directive_decl] = STATE(2145),
    [sym_fsi_directive_decl] = STATE(2145),
    [sym_preproc_line] = STATE(2145),
    [sym_identifier] = ACTIONS(4170),
    [anon_sym_EQ] = ACTIONS(4168),
    [anon_sym_LBRACK_LT] = ACTIONS(4168),
    [anon_sym_COLON] = ACTIONS(4170),
    [anon_sym_return] = ACTIONS(4170),
    [anon_sym_do] = ACTIONS(4170),
    [anon_sym_and] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_let_BANG] = ACTIONS(4168),
    [aux_sym_access_modifier_token1] = ACTIONS(4168),
    [anon_sym_LPAREN] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4168),
    [anon_sym_null] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_COLON] = ACTIONS(4168),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4170),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4168),
    [anon_sym_LBRACE] = ACTIONS(4170),
    [anon_sym_LT_AT] = ACTIONS(4170),
    [anon_sym_LT_AT_AT] = ACTIONS(4170),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4168),
    [anon_sym_new] = ACTIONS(4170),
    [anon_sym_with] = ACTIONS(4170),
    [anon_sym_return_BANG] = ACTIONS(4168),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_yield_BANG] = ACTIONS(4168),
    [anon_sym_lazy] = ACTIONS(4170),
    [anon_sym_assert] = ACTIONS(4170),
    [anon_sym_upcast] = ACTIONS(4170),
    [anon_sym_downcast] = ACTIONS(4170),
    [anon_sym_COLON_GT] = ACTIONS(4168),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4168),
    [anon_sym_for] = ACTIONS(4170),
    [anon_sym_while] = ACTIONS(4170),
    [anon_sym_if] = ACTIONS(4170),
    [anon_sym_fun] = ACTIONS(4170),
    [anon_sym_try] = ACTIONS(4170),
    [anon_sym_match] = ACTIONS(4170),
    [anon_sym_match_BANG] = ACTIONS(4168),
    [anon_sym_function] = ACTIONS(4170),
    [anon_sym_LT_DASH] = ACTIONS(4170),
    [anon_sym_DOT_LBRACK] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4168),
    [anon_sym_use] = ACTIONS(4170),
    [anon_sym_use_BANG] = ACTIONS(4168),
    [anon_sym_do_BANG] = ACTIONS(4168),
    [anon_sym_begin] = ACTIONS(4170),
    [anon_sym_LPAREN2] = ACTIONS(4170),
    [anon_sym_default] = ACTIONS(4170),
    [anon_sym_or] = ACTIONS(4170),
    [anon_sym_static] = ACTIONS(4170),
    [anon_sym_member] = ACTIONS(4170),
    [anon_sym_interface] = ACTIONS(4170),
    [anon_sym_abstract] = ACTIONS(4170),
    [anon_sym_val] = ACTIONS(4170),
    [anon_sym_override] = ACTIONS(4170),
    [aux_sym_char_token1] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4170),
    [anon_sym_DQUOTE] = ACTIONS(4170),
    [anon_sym_AT_DQUOTE] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [sym_bool] = ACTIONS(4170),
    [sym_unit] = ACTIONS(4168),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4170),
    [sym_op_identifier] = ACTIONS(4170),
    [anon_sym_PLUS] = ACTIONS(4170),
    [anon_sym_DASH] = ACTIONS(4170),
    [anon_sym_PLUS_DOT] = ACTIONS(4170),
    [anon_sym_DASH_DOT] = ACTIONS(4170),
    [anon_sym_PERCENT] = ACTIONS(4170),
    [anon_sym_AMP_AMP] = ACTIONS(4170),
    [anon_sym_TILDE] = ACTIONS(4168),
    [aux_sym_prefix_op_token1] = ACTIONS(4170),
    [aux_sym_infix_op_token1] = ACTIONS(4168),
    [aux_sym_infix_op_token2] = ACTIONS(4170),
    [anon_sym_PIPE_PIPE] = ACTIONS(4170),
    [anon_sym_BANG_EQ] = ACTIONS(4170),
    [anon_sym_COLON_EQ] = ACTIONS(4168),
    [anon_sym_DOLLAR] = ACTIONS(4170),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4170),
    [sym_int] = ACTIONS(4170),
    [sym_xint] = ACTIONS(4168),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4168),
    [sym__newline] = ACTIONS(4168),
    [sym__dedent] = ACTIONS(4168),
  },
  [2146] = {
    [sym_block_comment] = STATE(2146),
    [sym_compiler_directive_decl] = STATE(2146),
    [sym_fsi_directive_decl] = STATE(2146),
    [sym_preproc_line] = STATE(2146),
    [sym_identifier] = ACTIONS(3980),
    [anon_sym_EQ] = ACTIONS(3978),
    [anon_sym_LBRACK_LT] = ACTIONS(3978),
    [anon_sym_COLON] = ACTIONS(3980),
    [anon_sym_return] = ACTIONS(3980),
    [anon_sym_do] = ACTIONS(3980),
    [anon_sym_and] = ACTIONS(3980),
    [anon_sym_let] = ACTIONS(3980),
    [anon_sym_let_BANG] = ACTIONS(3978),
    [aux_sym_access_modifier_token1] = ACTIONS(3978),
    [anon_sym_LPAREN] = ACTIONS(3980),
    [anon_sym_COMMA] = ACTIONS(3978),
    [anon_sym_null] = ACTIONS(3980),
    [anon_sym_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3978),
    [anon_sym_AMP] = ACTIONS(3980),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3978),
    [anon_sym_LBRACE] = ACTIONS(3980),
    [anon_sym_LT_AT] = ACTIONS(3980),
    [anon_sym_LT_AT_AT] = ACTIONS(3980),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3978),
    [anon_sym_new] = ACTIONS(3980),
    [anon_sym_with] = ACTIONS(3980),
    [anon_sym_return_BANG] = ACTIONS(3978),
    [anon_sym_yield] = ACTIONS(3980),
    [anon_sym_yield_BANG] = ACTIONS(3978),
    [anon_sym_lazy] = ACTIONS(3980),
    [anon_sym_assert] = ACTIONS(3980),
    [anon_sym_upcast] = ACTIONS(3980),
    [anon_sym_downcast] = ACTIONS(3980),
    [anon_sym_COLON_GT] = ACTIONS(3978),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3978),
    [anon_sym_for] = ACTIONS(3980),
    [anon_sym_while] = ACTIONS(3980),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_fun] = ACTIONS(3980),
    [anon_sym_try] = ACTIONS(3980),
    [anon_sym_match] = ACTIONS(3980),
    [anon_sym_match_BANG] = ACTIONS(3978),
    [anon_sym_function] = ACTIONS(3980),
    [anon_sym_LT_DASH] = ACTIONS(3980),
    [anon_sym_DOT_LBRACK] = ACTIONS(3978),
    [anon_sym_LT] = ACTIONS(3978),
    [anon_sym_use] = ACTIONS(3980),
    [anon_sym_use_BANG] = ACTIONS(3978),
    [anon_sym_do_BANG] = ACTIONS(3978),
    [anon_sym_begin] = ACTIONS(3980),
    [anon_sym_LPAREN2] = ACTIONS(3980),
    [anon_sym_default] = ACTIONS(3980),
    [anon_sym_or] = ACTIONS(3980),
    [anon_sym_static] = ACTIONS(3980),
    [anon_sym_member] = ACTIONS(3980),
    [anon_sym_interface] = ACTIONS(3980),
    [anon_sym_abstract] = ACTIONS(3980),
    [anon_sym_val] = ACTIONS(3980),
    [anon_sym_override] = ACTIONS(3980),
    [aux_sym_char_token1] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3980),
    [anon_sym_DQUOTE] = ACTIONS(3980),
    [anon_sym_AT_DQUOTE] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [sym_bool] = ACTIONS(3980),
    [sym_unit] = ACTIONS(3978),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3980),
    [sym_op_identifier] = ACTIONS(3980),
    [anon_sym_PLUS] = ACTIONS(3980),
    [anon_sym_DASH] = ACTIONS(3980),
    [anon_sym_PLUS_DOT] = ACTIONS(3980),
    [anon_sym_DASH_DOT] = ACTIONS(3980),
    [anon_sym_PERCENT] = ACTIONS(3980),
    [anon_sym_AMP_AMP] = ACTIONS(3980),
    [anon_sym_TILDE] = ACTIONS(3978),
    [aux_sym_prefix_op_token1] = ACTIONS(3980),
    [aux_sym_infix_op_token1] = ACTIONS(3978),
    [aux_sym_infix_op_token2] = ACTIONS(3980),
    [anon_sym_PIPE_PIPE] = ACTIONS(3980),
    [anon_sym_BANG_EQ] = ACTIONS(3980),
    [anon_sym_COLON_EQ] = ACTIONS(3978),
    [anon_sym_DOLLAR] = ACTIONS(3980),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3980),
    [sym_int] = ACTIONS(3980),
    [sym_xint] = ACTIONS(3978),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3978),
    [sym__newline] = ACTIONS(3978),
    [sym__dedent] = ACTIONS(3978),
  },
  [2147] = {
    [sym_block_comment] = STATE(2147),
    [sym_compiler_directive_decl] = STATE(2147),
    [sym_fsi_directive_decl] = STATE(2147),
    [sym_preproc_line] = STATE(2147),
    [sym_identifier] = ACTIONS(3966),
    [anon_sym_EQ] = ACTIONS(3964),
    [anon_sym_LBRACK_LT] = ACTIONS(3964),
    [anon_sym_COLON] = ACTIONS(3966),
    [anon_sym_return] = ACTIONS(3966),
    [anon_sym_do] = ACTIONS(3966),
    [anon_sym_and] = ACTIONS(3966),
    [anon_sym_let] = ACTIONS(3966),
    [anon_sym_let_BANG] = ACTIONS(3964),
    [aux_sym_access_modifier_token1] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COMMA] = ACTIONS(3964),
    [anon_sym_null] = ACTIONS(3966),
    [anon_sym_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(3964),
    [anon_sym_AMP] = ACTIONS(3966),
    [anon_sym_LBRACK] = ACTIONS(3966),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3964),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_LT_AT] = ACTIONS(3966),
    [anon_sym_LT_AT_AT] = ACTIONS(3966),
    [anon_sym_DOT] = ACTIONS(3966),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3964),
    [anon_sym_new] = ACTIONS(3966),
    [anon_sym_with] = ACTIONS(3966),
    [anon_sym_return_BANG] = ACTIONS(3964),
    [anon_sym_yield] = ACTIONS(3966),
    [anon_sym_yield_BANG] = ACTIONS(3964),
    [anon_sym_lazy] = ACTIONS(3966),
    [anon_sym_assert] = ACTIONS(3966),
    [anon_sym_upcast] = ACTIONS(3966),
    [anon_sym_downcast] = ACTIONS(3966),
    [anon_sym_COLON_GT] = ACTIONS(3964),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3964),
    [anon_sym_for] = ACTIONS(3966),
    [anon_sym_while] = ACTIONS(3966),
    [anon_sym_if] = ACTIONS(3966),
    [anon_sym_fun] = ACTIONS(3966),
    [anon_sym_try] = ACTIONS(3966),
    [anon_sym_match] = ACTIONS(3966),
    [anon_sym_match_BANG] = ACTIONS(3964),
    [anon_sym_function] = ACTIONS(3966),
    [anon_sym_LT_DASH] = ACTIONS(3966),
    [anon_sym_DOT_LBRACK] = ACTIONS(3964),
    [anon_sym_LT] = ACTIONS(3964),
    [anon_sym_use] = ACTIONS(3966),
    [anon_sym_use_BANG] = ACTIONS(3964),
    [anon_sym_do_BANG] = ACTIONS(3964),
    [anon_sym_begin] = ACTIONS(3966),
    [anon_sym_LPAREN2] = ACTIONS(3966),
    [anon_sym_default] = ACTIONS(3966),
    [anon_sym_or] = ACTIONS(3966),
    [anon_sym_static] = ACTIONS(3966),
    [anon_sym_member] = ACTIONS(3966),
    [anon_sym_interface] = ACTIONS(3966),
    [anon_sym_abstract] = ACTIONS(3966),
    [anon_sym_val] = ACTIONS(3966),
    [anon_sym_override] = ACTIONS(3966),
    [aux_sym_char_token1] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3966),
    [anon_sym_DQUOTE] = ACTIONS(3966),
    [anon_sym_AT_DQUOTE] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [sym_bool] = ACTIONS(3966),
    [sym_unit] = ACTIONS(3964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3966),
    [sym_op_identifier] = ACTIONS(3966),
    [anon_sym_PLUS] = ACTIONS(3966),
    [anon_sym_DASH] = ACTIONS(3966),
    [anon_sym_PLUS_DOT] = ACTIONS(3966),
    [anon_sym_DASH_DOT] = ACTIONS(3966),
    [anon_sym_PERCENT] = ACTIONS(3966),
    [anon_sym_AMP_AMP] = ACTIONS(3966),
    [anon_sym_TILDE] = ACTIONS(3964),
    [aux_sym_prefix_op_token1] = ACTIONS(3966),
    [aux_sym_infix_op_token1] = ACTIONS(3964),
    [aux_sym_infix_op_token2] = ACTIONS(3966),
    [anon_sym_PIPE_PIPE] = ACTIONS(3966),
    [anon_sym_BANG_EQ] = ACTIONS(3966),
    [anon_sym_COLON_EQ] = ACTIONS(3964),
    [anon_sym_DOLLAR] = ACTIONS(3966),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3966),
    [sym_int] = ACTIONS(3966),
    [sym_xint] = ACTIONS(3964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3964),
    [sym__newline] = ACTIONS(3964),
    [sym__dedent] = ACTIONS(3964),
  },
  [2148] = {
    [sym_block_comment] = STATE(2148),
    [sym_compiler_directive_decl] = STATE(2148),
    [sym_fsi_directive_decl] = STATE(2148),
    [sym_preproc_line] = STATE(2148),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_EQ] = ACTIONS(3948),
    [anon_sym_LBRACK_LT] = ACTIONS(3948),
    [anon_sym_COLON] = ACTIONS(3950),
    [anon_sym_return] = ACTIONS(3950),
    [anon_sym_do] = ACTIONS(3950),
    [anon_sym_and] = ACTIONS(3950),
    [anon_sym_let] = ACTIONS(3950),
    [anon_sym_let_BANG] = ACTIONS(3948),
    [aux_sym_access_modifier_token1] = ACTIONS(3948),
    [anon_sym_LPAREN] = ACTIONS(3950),
    [anon_sym_COMMA] = ACTIONS(3948),
    [anon_sym_null] = ACTIONS(3950),
    [anon_sym_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_COLON] = ACTIONS(3948),
    [anon_sym_AMP] = ACTIONS(3950),
    [anon_sym_LBRACK] = ACTIONS(3950),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3948),
    [anon_sym_LBRACE] = ACTIONS(3950),
    [anon_sym_LT_AT] = ACTIONS(3950),
    [anon_sym_LT_AT_AT] = ACTIONS(3950),
    [anon_sym_DOT] = ACTIONS(3950),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3948),
    [anon_sym_new] = ACTIONS(3950),
    [anon_sym_with] = ACTIONS(3950),
    [anon_sym_return_BANG] = ACTIONS(3948),
    [anon_sym_yield] = ACTIONS(3950),
    [anon_sym_yield_BANG] = ACTIONS(3948),
    [anon_sym_lazy] = ACTIONS(3950),
    [anon_sym_assert] = ACTIONS(3950),
    [anon_sym_upcast] = ACTIONS(3950),
    [anon_sym_downcast] = ACTIONS(3950),
    [anon_sym_COLON_GT] = ACTIONS(3948),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3948),
    [anon_sym_for] = ACTIONS(3950),
    [anon_sym_while] = ACTIONS(3950),
    [anon_sym_if] = ACTIONS(3950),
    [anon_sym_fun] = ACTIONS(3950),
    [anon_sym_try] = ACTIONS(3950),
    [anon_sym_match] = ACTIONS(3950),
    [anon_sym_match_BANG] = ACTIONS(3948),
    [anon_sym_function] = ACTIONS(3950),
    [anon_sym_LT_DASH] = ACTIONS(3950),
    [anon_sym_DOT_LBRACK] = ACTIONS(3948),
    [anon_sym_LT] = ACTIONS(3948),
    [anon_sym_use] = ACTIONS(3950),
    [anon_sym_use_BANG] = ACTIONS(3948),
    [anon_sym_do_BANG] = ACTIONS(3948),
    [anon_sym_begin] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3950),
    [anon_sym_default] = ACTIONS(3950),
    [anon_sym_or] = ACTIONS(3950),
    [anon_sym_static] = ACTIONS(3950),
    [anon_sym_member] = ACTIONS(3950),
    [anon_sym_interface] = ACTIONS(3950),
    [anon_sym_abstract] = ACTIONS(3950),
    [anon_sym_val] = ACTIONS(3950),
    [anon_sym_override] = ACTIONS(3950),
    [aux_sym_char_token1] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3950),
    [anon_sym_DQUOTE] = ACTIONS(3950),
    [anon_sym_AT_DQUOTE] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [sym_bool] = ACTIONS(3950),
    [sym_unit] = ACTIONS(3948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3950),
    [sym_op_identifier] = ACTIONS(3950),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_DASH] = ACTIONS(3950),
    [anon_sym_PLUS_DOT] = ACTIONS(3950),
    [anon_sym_DASH_DOT] = ACTIONS(3950),
    [anon_sym_PERCENT] = ACTIONS(3950),
    [anon_sym_AMP_AMP] = ACTIONS(3950),
    [anon_sym_TILDE] = ACTIONS(3948),
    [aux_sym_prefix_op_token1] = ACTIONS(3950),
    [aux_sym_infix_op_token1] = ACTIONS(3948),
    [aux_sym_infix_op_token2] = ACTIONS(3950),
    [anon_sym_PIPE_PIPE] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3950),
    [anon_sym_COLON_EQ] = ACTIONS(3948),
    [anon_sym_DOLLAR] = ACTIONS(3950),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3950),
    [sym_int] = ACTIONS(3950),
    [sym_xint] = ACTIONS(3948),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3948),
    [anon_sym_POUNDendif] = ACTIONS(3948),
    [sym__newline] = ACTIONS(3948),
  },
  [2149] = {
    [sym_block_comment] = STATE(2149),
    [sym_compiler_directive_decl] = STATE(2149),
    [sym_fsi_directive_decl] = STATE(2149),
    [sym_preproc_line] = STATE(2149),
    [sym_identifier] = ACTIONS(4126),
    [anon_sym_EQ] = ACTIONS(4124),
    [anon_sym_LBRACK_LT] = ACTIONS(4124),
    [anon_sym_COLON] = ACTIONS(4126),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_do] = ACTIONS(4126),
    [anon_sym_let] = ACTIONS(4126),
    [anon_sym_let_BANG] = ACTIONS(4124),
    [aux_sym_access_modifier_token1] = ACTIONS(4124),
    [anon_sym_LPAREN] = ACTIONS(4126),
    [anon_sym_COMMA] = ACTIONS(4124),
    [anon_sym_null] = ACTIONS(4126),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_COLON] = ACTIONS(4124),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LBRACK] = ACTIONS(4126),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4126),
    [anon_sym_LT_AT] = ACTIONS(4126),
    [anon_sym_LT_AT_AT] = ACTIONS(4126),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4124),
    [anon_sym_new] = ACTIONS(4126),
    [anon_sym_with] = ACTIONS(4126),
    [anon_sym_return_BANG] = ACTIONS(4124),
    [anon_sym_yield] = ACTIONS(4126),
    [anon_sym_yield_BANG] = ACTIONS(4124),
    [anon_sym_lazy] = ACTIONS(4126),
    [anon_sym_assert] = ACTIONS(4126),
    [anon_sym_upcast] = ACTIONS(4126),
    [anon_sym_downcast] = ACTIONS(4126),
    [anon_sym_COLON_GT] = ACTIONS(4124),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4124),
    [anon_sym_for] = ACTIONS(4126),
    [anon_sym_while] = ACTIONS(4126),
    [anon_sym_if] = ACTIONS(4126),
    [anon_sym_fun] = ACTIONS(4126),
    [anon_sym_try] = ACTIONS(4126),
    [anon_sym_match] = ACTIONS(4126),
    [anon_sym_match_BANG] = ACTIONS(4124),
    [anon_sym_function] = ACTIONS(4126),
    [anon_sym_LT_DASH] = ACTIONS(4126),
    [anon_sym_DOT_LBRACK] = ACTIONS(4124),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_use] = ACTIONS(4126),
    [anon_sym_use_BANG] = ACTIONS(4124),
    [anon_sym_do_BANG] = ACTIONS(4124),
    [anon_sym_begin] = ACTIONS(4126),
    [anon_sym_LPAREN2] = ACTIONS(4126),
    [anon_sym_default] = ACTIONS(4126),
    [anon_sym_or] = ACTIONS(4126),
    [anon_sym_static] = ACTIONS(4126),
    [anon_sym_member] = ACTIONS(4126),
    [anon_sym_interface] = ACTIONS(4126),
    [anon_sym_abstract] = ACTIONS(4126),
    [anon_sym_val] = ACTIONS(4126),
    [anon_sym_override] = ACTIONS(4126),
    [anon_sym_inherit] = ACTIONS(4126),
    [aux_sym_char_token1] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4126),
    [anon_sym_DQUOTE] = ACTIONS(4126),
    [anon_sym_AT_DQUOTE] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [sym_bool] = ACTIONS(4126),
    [sym_unit] = ACTIONS(4124),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4126),
    [sym_op_identifier] = ACTIONS(4126),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_PLUS_DOT] = ACTIONS(4126),
    [anon_sym_DASH_DOT] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_AMP_AMP] = ACTIONS(4126),
    [anon_sym_TILDE] = ACTIONS(4124),
    [aux_sym_prefix_op_token1] = ACTIONS(4126),
    [aux_sym_infix_op_token1] = ACTIONS(4124),
    [aux_sym_infix_op_token2] = ACTIONS(4126),
    [anon_sym_PIPE_PIPE] = ACTIONS(4126),
    [anon_sym_BANG_EQ] = ACTIONS(4126),
    [anon_sym_COLON_EQ] = ACTIONS(4124),
    [anon_sym_DOLLAR] = ACTIONS(4126),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4126),
    [sym_int] = ACTIONS(4126),
    [sym_xint] = ACTIONS(4124),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4124),
    [anon_sym_POUNDendif] = ACTIONS(4124),
    [sym__newline] = ACTIONS(4124),
  },
  [2150] = {
    [sym_block_comment] = STATE(2150),
    [sym_compiler_directive_decl] = STATE(2150),
    [sym_fsi_directive_decl] = STATE(2150),
    [sym_preproc_line] = STATE(2150),
    [sym_identifier] = ACTIONS(3935),
    [anon_sym_EQ] = ACTIONS(3933),
    [anon_sym_LBRACK_LT] = ACTIONS(3933),
    [anon_sym_COLON] = ACTIONS(3935),
    [anon_sym_return] = ACTIONS(3935),
    [anon_sym_do] = ACTIONS(3935),
    [anon_sym_and] = ACTIONS(3935),
    [anon_sym_let] = ACTIONS(3935),
    [anon_sym_let_BANG] = ACTIONS(3933),
    [aux_sym_access_modifier_token1] = ACTIONS(3933),
    [anon_sym_LPAREN] = ACTIONS(3935),
    [anon_sym_COMMA] = ACTIONS(3933),
    [anon_sym_null] = ACTIONS(3935),
    [anon_sym_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3935),
    [anon_sym_LBRACK] = ACTIONS(3935),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3933),
    [anon_sym_LBRACE] = ACTIONS(3935),
    [anon_sym_LT_AT] = ACTIONS(3935),
    [anon_sym_LT_AT_AT] = ACTIONS(3935),
    [anon_sym_DOT] = ACTIONS(3935),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3933),
    [anon_sym_new] = ACTIONS(3935),
    [anon_sym_with] = ACTIONS(3935),
    [anon_sym_return_BANG] = ACTIONS(3933),
    [anon_sym_yield] = ACTIONS(3935),
    [anon_sym_yield_BANG] = ACTIONS(3933),
    [anon_sym_lazy] = ACTIONS(3935),
    [anon_sym_assert] = ACTIONS(3935),
    [anon_sym_upcast] = ACTIONS(3935),
    [anon_sym_downcast] = ACTIONS(3935),
    [anon_sym_COLON_GT] = ACTIONS(3933),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3933),
    [anon_sym_for] = ACTIONS(3935),
    [anon_sym_while] = ACTIONS(3935),
    [anon_sym_if] = ACTIONS(3935),
    [anon_sym_fun] = ACTIONS(3935),
    [anon_sym_try] = ACTIONS(3935),
    [anon_sym_match] = ACTIONS(3935),
    [anon_sym_match_BANG] = ACTIONS(3933),
    [anon_sym_function] = ACTIONS(3935),
    [anon_sym_LT_DASH] = ACTIONS(3935),
    [anon_sym_DOT_LBRACK] = ACTIONS(3933),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_use] = ACTIONS(3935),
    [anon_sym_use_BANG] = ACTIONS(3933),
    [anon_sym_do_BANG] = ACTIONS(3933),
    [anon_sym_begin] = ACTIONS(3935),
    [anon_sym_LPAREN2] = ACTIONS(3935),
    [anon_sym_default] = ACTIONS(3935),
    [anon_sym_or] = ACTIONS(3935),
    [anon_sym_static] = ACTIONS(3935),
    [anon_sym_member] = ACTIONS(3935),
    [anon_sym_interface] = ACTIONS(3935),
    [anon_sym_abstract] = ACTIONS(3935),
    [anon_sym_val] = ACTIONS(3935),
    [anon_sym_override] = ACTIONS(3935),
    [aux_sym_char_token1] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3935),
    [anon_sym_DQUOTE] = ACTIONS(3935),
    [anon_sym_AT_DQUOTE] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [sym_bool] = ACTIONS(3935),
    [sym_unit] = ACTIONS(3933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3935),
    [sym_op_identifier] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(3935),
    [anon_sym_DASH] = ACTIONS(3935),
    [anon_sym_PLUS_DOT] = ACTIONS(3935),
    [anon_sym_DASH_DOT] = ACTIONS(3935),
    [anon_sym_PERCENT] = ACTIONS(3935),
    [anon_sym_AMP_AMP] = ACTIONS(3935),
    [anon_sym_TILDE] = ACTIONS(3933),
    [aux_sym_prefix_op_token1] = ACTIONS(3935),
    [aux_sym_infix_op_token1] = ACTIONS(3933),
    [aux_sym_infix_op_token2] = ACTIONS(3935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3935),
    [anon_sym_BANG_EQ] = ACTIONS(3935),
    [anon_sym_COLON_EQ] = ACTIONS(3933),
    [anon_sym_DOLLAR] = ACTIONS(3935),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3935),
    [sym_int] = ACTIONS(3935),
    [sym_xint] = ACTIONS(3933),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3933),
    [anon_sym_POUNDendif] = ACTIONS(3933),
    [sym__newline] = ACTIONS(3933),
  },
  [2151] = {
    [sym_block_comment] = STATE(2151),
    [sym_compiler_directive_decl] = STATE(2151),
    [sym_fsi_directive_decl] = STATE(2151),
    [sym_preproc_line] = STATE(2151),
    [sym_identifier] = ACTIONS(3885),
    [anon_sym_EQ] = ACTIONS(3883),
    [anon_sym_LBRACK_LT] = ACTIONS(3883),
    [anon_sym_COLON] = ACTIONS(3885),
    [anon_sym_return] = ACTIONS(3885),
    [anon_sym_do] = ACTIONS(3885),
    [anon_sym_and] = ACTIONS(3885),
    [anon_sym_let] = ACTIONS(3885),
    [anon_sym_let_BANG] = ACTIONS(3883),
    [aux_sym_access_modifier_token1] = ACTIONS(3883),
    [anon_sym_LPAREN] = ACTIONS(3885),
    [anon_sym_COMMA] = ACTIONS(3883),
    [anon_sym_null] = ACTIONS(3885),
    [anon_sym_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3883),
    [anon_sym_AMP] = ACTIONS(3885),
    [anon_sym_LBRACK] = ACTIONS(3885),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3883),
    [anon_sym_LBRACE] = ACTIONS(3885),
    [anon_sym_LT_AT] = ACTIONS(3885),
    [anon_sym_LT_AT_AT] = ACTIONS(3885),
    [anon_sym_DOT] = ACTIONS(3885),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3883),
    [anon_sym_new] = ACTIONS(3885),
    [anon_sym_with] = ACTIONS(3885),
    [anon_sym_return_BANG] = ACTIONS(3883),
    [anon_sym_yield] = ACTIONS(3885),
    [anon_sym_yield_BANG] = ACTIONS(3883),
    [anon_sym_lazy] = ACTIONS(3885),
    [anon_sym_assert] = ACTIONS(3885),
    [anon_sym_upcast] = ACTIONS(3885),
    [anon_sym_downcast] = ACTIONS(3885),
    [anon_sym_COLON_GT] = ACTIONS(3883),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3883),
    [anon_sym_for] = ACTIONS(3885),
    [anon_sym_while] = ACTIONS(3885),
    [anon_sym_if] = ACTIONS(3885),
    [anon_sym_fun] = ACTIONS(3885),
    [anon_sym_try] = ACTIONS(3885),
    [anon_sym_match] = ACTIONS(3885),
    [anon_sym_match_BANG] = ACTIONS(3883),
    [anon_sym_function] = ACTIONS(3885),
    [anon_sym_LT_DASH] = ACTIONS(3885),
    [anon_sym_DOT_LBRACK] = ACTIONS(3883),
    [anon_sym_LT] = ACTIONS(3883),
    [anon_sym_use] = ACTIONS(3885),
    [anon_sym_use_BANG] = ACTIONS(3883),
    [anon_sym_do_BANG] = ACTIONS(3883),
    [anon_sym_begin] = ACTIONS(3885),
    [anon_sym_LPAREN2] = ACTIONS(3885),
    [anon_sym_default] = ACTIONS(3885),
    [anon_sym_or] = ACTIONS(3885),
    [anon_sym_static] = ACTIONS(3885),
    [anon_sym_member] = ACTIONS(3885),
    [anon_sym_interface] = ACTIONS(3885),
    [anon_sym_abstract] = ACTIONS(3885),
    [anon_sym_val] = ACTIONS(3885),
    [anon_sym_override] = ACTIONS(3885),
    [aux_sym_char_token1] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3885),
    [anon_sym_DQUOTE] = ACTIONS(3885),
    [anon_sym_AT_DQUOTE] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [sym_bool] = ACTIONS(3885),
    [sym_unit] = ACTIONS(3883),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3885),
    [sym_op_identifier] = ACTIONS(3885),
    [anon_sym_PLUS] = ACTIONS(3885),
    [anon_sym_DASH] = ACTIONS(3885),
    [anon_sym_PLUS_DOT] = ACTIONS(3885),
    [anon_sym_DASH_DOT] = ACTIONS(3885),
    [anon_sym_PERCENT] = ACTIONS(3885),
    [anon_sym_AMP_AMP] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3883),
    [aux_sym_prefix_op_token1] = ACTIONS(3885),
    [aux_sym_infix_op_token1] = ACTIONS(3883),
    [aux_sym_infix_op_token2] = ACTIONS(3885),
    [anon_sym_PIPE_PIPE] = ACTIONS(3885),
    [anon_sym_BANG_EQ] = ACTIONS(3885),
    [anon_sym_COLON_EQ] = ACTIONS(3883),
    [anon_sym_DOLLAR] = ACTIONS(3885),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3885),
    [sym_int] = ACTIONS(3885),
    [sym_xint] = ACTIONS(3883),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3883),
    [anon_sym_POUNDendif] = ACTIONS(3883),
    [sym__newline] = ACTIONS(3883),
  },
  [2152] = {
    [sym_block_comment] = STATE(2152),
    [sym_compiler_directive_decl] = STATE(2152),
    [sym_fsi_directive_decl] = STATE(2152),
    [sym_preproc_line] = STATE(2152),
    [sym_identifier] = ACTIONS(4232),
    [anon_sym_EQ] = ACTIONS(4230),
    [anon_sym_LBRACK_LT] = ACTIONS(4230),
    [anon_sym_COLON] = ACTIONS(4232),
    [anon_sym_return] = ACTIONS(4232),
    [anon_sym_do] = ACTIONS(4232),
    [anon_sym_let] = ACTIONS(4232),
    [anon_sym_let_BANG] = ACTIONS(4230),
    [aux_sym_access_modifier_token1] = ACTIONS(4230),
    [anon_sym_LPAREN] = ACTIONS(4232),
    [anon_sym_COMMA] = ACTIONS(4230),
    [anon_sym_null] = ACTIONS(4232),
    [anon_sym_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_COLON] = ACTIONS(4230),
    [anon_sym_AMP] = ACTIONS(4232),
    [anon_sym_LBRACK] = ACTIONS(4232),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4230),
    [anon_sym_LBRACE] = ACTIONS(4232),
    [anon_sym_LT_AT] = ACTIONS(4232),
    [anon_sym_LT_AT_AT] = ACTIONS(4232),
    [anon_sym_DOT] = ACTIONS(4232),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4230),
    [anon_sym_new] = ACTIONS(4232),
    [anon_sym_with] = ACTIONS(4232),
    [anon_sym_return_BANG] = ACTIONS(4230),
    [anon_sym_yield] = ACTIONS(4232),
    [anon_sym_yield_BANG] = ACTIONS(4230),
    [anon_sym_lazy] = ACTIONS(4232),
    [anon_sym_assert] = ACTIONS(4232),
    [anon_sym_upcast] = ACTIONS(4232),
    [anon_sym_downcast] = ACTIONS(4232),
    [anon_sym_COLON_GT] = ACTIONS(4230),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4230),
    [anon_sym_for] = ACTIONS(4232),
    [anon_sym_while] = ACTIONS(4232),
    [anon_sym_if] = ACTIONS(4232),
    [anon_sym_fun] = ACTIONS(4232),
    [anon_sym_try] = ACTIONS(4232),
    [anon_sym_match] = ACTIONS(4232),
    [anon_sym_match_BANG] = ACTIONS(4230),
    [anon_sym_function] = ACTIONS(4232),
    [anon_sym_LT_DASH] = ACTIONS(4232),
    [anon_sym_DOT_LBRACK] = ACTIONS(4230),
    [anon_sym_LT] = ACTIONS(4230),
    [anon_sym_use] = ACTIONS(4232),
    [anon_sym_use_BANG] = ACTIONS(4230),
    [anon_sym_do_BANG] = ACTIONS(4230),
    [anon_sym_begin] = ACTIONS(4232),
    [anon_sym_LPAREN2] = ACTIONS(4232),
    [anon_sym_default] = ACTIONS(4232),
    [anon_sym_or] = ACTIONS(4232),
    [anon_sym_static] = ACTIONS(4232),
    [anon_sym_member] = ACTIONS(4232),
    [anon_sym_interface] = ACTIONS(4232),
    [anon_sym_abstract] = ACTIONS(4232),
    [anon_sym_val] = ACTIONS(4232),
    [anon_sym_override] = ACTIONS(4232),
    [anon_sym_inherit] = ACTIONS(4232),
    [aux_sym_char_token1] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4232),
    [anon_sym_DQUOTE] = ACTIONS(4232),
    [anon_sym_AT_DQUOTE] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [sym_bool] = ACTIONS(4232),
    [sym_unit] = ACTIONS(4230),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4232),
    [sym_op_identifier] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4232),
    [anon_sym_DASH] = ACTIONS(4232),
    [anon_sym_PLUS_DOT] = ACTIONS(4232),
    [anon_sym_DASH_DOT] = ACTIONS(4232),
    [anon_sym_PERCENT] = ACTIONS(4232),
    [anon_sym_AMP_AMP] = ACTIONS(4232),
    [anon_sym_TILDE] = ACTIONS(4230),
    [aux_sym_prefix_op_token1] = ACTIONS(4232),
    [aux_sym_infix_op_token1] = ACTIONS(4230),
    [aux_sym_infix_op_token2] = ACTIONS(4232),
    [anon_sym_PIPE_PIPE] = ACTIONS(4232),
    [anon_sym_BANG_EQ] = ACTIONS(4232),
    [anon_sym_COLON_EQ] = ACTIONS(4230),
    [anon_sym_DOLLAR] = ACTIONS(4232),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4232),
    [sym_int] = ACTIONS(4232),
    [sym_xint] = ACTIONS(4230),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4230),
    [anon_sym_POUNDendif] = ACTIONS(4230),
    [sym__newline] = ACTIONS(4230),
  },
  [2153] = {
    [sym_block_comment] = STATE(2153),
    [sym_compiler_directive_decl] = STATE(2153),
    [sym_fsi_directive_decl] = STATE(2153),
    [sym_preproc_line] = STATE(2153),
    [sym_identifier] = ACTIONS(4130),
    [anon_sym_EQ] = ACTIONS(4128),
    [anon_sym_LBRACK_LT] = ACTIONS(4128),
    [anon_sym_COLON] = ACTIONS(4130),
    [anon_sym_return] = ACTIONS(4130),
    [anon_sym_do] = ACTIONS(4130),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_let] = ACTIONS(4130),
    [anon_sym_let_BANG] = ACTIONS(4128),
    [aux_sym_access_modifier_token1] = ACTIONS(4128),
    [anon_sym_LPAREN] = ACTIONS(4130),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_null] = ACTIONS(4130),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_COLON] = ACTIONS(4128),
    [anon_sym_AMP] = ACTIONS(4130),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4128),
    [anon_sym_LBRACE] = ACTIONS(4130),
    [anon_sym_LT_AT] = ACTIONS(4130),
    [anon_sym_LT_AT_AT] = ACTIONS(4130),
    [anon_sym_DOT] = ACTIONS(4130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4128),
    [anon_sym_new] = ACTIONS(4130),
    [anon_sym_with] = ACTIONS(4130),
    [anon_sym_return_BANG] = ACTIONS(4128),
    [anon_sym_yield] = ACTIONS(4130),
    [anon_sym_yield_BANG] = ACTIONS(4128),
    [anon_sym_lazy] = ACTIONS(4130),
    [anon_sym_assert] = ACTIONS(4130),
    [anon_sym_upcast] = ACTIONS(4130),
    [anon_sym_downcast] = ACTIONS(4130),
    [anon_sym_COLON_GT] = ACTIONS(4128),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4128),
    [anon_sym_for] = ACTIONS(4130),
    [anon_sym_while] = ACTIONS(4130),
    [anon_sym_if] = ACTIONS(4130),
    [anon_sym_fun] = ACTIONS(4130),
    [anon_sym_try] = ACTIONS(4130),
    [anon_sym_match] = ACTIONS(4130),
    [anon_sym_match_BANG] = ACTIONS(4128),
    [anon_sym_function] = ACTIONS(4130),
    [anon_sym_LT_DASH] = ACTIONS(4130),
    [anon_sym_DOT_LBRACK] = ACTIONS(4128),
    [anon_sym_LT] = ACTIONS(4128),
    [anon_sym_use] = ACTIONS(4130),
    [anon_sym_use_BANG] = ACTIONS(4128),
    [anon_sym_do_BANG] = ACTIONS(4128),
    [anon_sym_begin] = ACTIONS(4130),
    [anon_sym_LPAREN2] = ACTIONS(4130),
    [anon_sym_default] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_static] = ACTIONS(4130),
    [anon_sym_member] = ACTIONS(4130),
    [anon_sym_interface] = ACTIONS(4130),
    [anon_sym_abstract] = ACTIONS(4130),
    [anon_sym_val] = ACTIONS(4130),
    [anon_sym_override] = ACTIONS(4130),
    [aux_sym_char_token1] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4130),
    [anon_sym_DQUOTE] = ACTIONS(4130),
    [anon_sym_AT_DQUOTE] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [sym_bool] = ACTIONS(4130),
    [sym_unit] = ACTIONS(4128),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4130),
    [sym_op_identifier] = ACTIONS(4130),
    [anon_sym_PLUS] = ACTIONS(4130),
    [anon_sym_DASH] = ACTIONS(4130),
    [anon_sym_PLUS_DOT] = ACTIONS(4130),
    [anon_sym_DASH_DOT] = ACTIONS(4130),
    [anon_sym_PERCENT] = ACTIONS(4130),
    [anon_sym_AMP_AMP] = ACTIONS(4130),
    [anon_sym_TILDE] = ACTIONS(4128),
    [aux_sym_prefix_op_token1] = ACTIONS(4130),
    [aux_sym_infix_op_token1] = ACTIONS(4128),
    [aux_sym_infix_op_token2] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE] = ACTIONS(4130),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_COLON_EQ] = ACTIONS(4128),
    [anon_sym_DOLLAR] = ACTIONS(4130),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4130),
    [sym_int] = ACTIONS(4130),
    [sym_xint] = ACTIONS(4128),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4128),
    [anon_sym_POUNDendif] = ACTIONS(4128),
    [sym__newline] = ACTIONS(4128),
  },
  [2154] = {
    [sym_block_comment] = STATE(2154),
    [sym_compiler_directive_decl] = STATE(2154),
    [sym_fsi_directive_decl] = STATE(2154),
    [sym_preproc_line] = STATE(2154),
    [sym_identifier] = ACTIONS(3966),
    [anon_sym_EQ] = ACTIONS(3964),
    [anon_sym_LBRACK_LT] = ACTIONS(3964),
    [anon_sym_COLON] = ACTIONS(3966),
    [anon_sym_return] = ACTIONS(3966),
    [anon_sym_do] = ACTIONS(3966),
    [anon_sym_let] = ACTIONS(3966),
    [anon_sym_let_BANG] = ACTIONS(3964),
    [aux_sym_access_modifier_token1] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COMMA] = ACTIONS(3964),
    [anon_sym_null] = ACTIONS(3966),
    [anon_sym_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(3964),
    [anon_sym_AMP] = ACTIONS(3966),
    [anon_sym_LBRACK] = ACTIONS(3966),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3964),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_LT_AT] = ACTIONS(3966),
    [anon_sym_LT_AT_AT] = ACTIONS(3966),
    [anon_sym_DOT] = ACTIONS(3966),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3964),
    [anon_sym_new] = ACTIONS(3966),
    [anon_sym_with] = ACTIONS(3966),
    [anon_sym_return_BANG] = ACTIONS(3964),
    [anon_sym_yield] = ACTIONS(3966),
    [anon_sym_yield_BANG] = ACTIONS(3964),
    [anon_sym_lazy] = ACTIONS(3966),
    [anon_sym_assert] = ACTIONS(3966),
    [anon_sym_upcast] = ACTIONS(3966),
    [anon_sym_downcast] = ACTIONS(3966),
    [anon_sym_COLON_GT] = ACTIONS(3964),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3964),
    [anon_sym_for] = ACTIONS(3966),
    [anon_sym_while] = ACTIONS(3966),
    [anon_sym_if] = ACTIONS(3966),
    [anon_sym_fun] = ACTIONS(3966),
    [anon_sym_try] = ACTIONS(3966),
    [anon_sym_match] = ACTIONS(3966),
    [anon_sym_match_BANG] = ACTIONS(3964),
    [anon_sym_function] = ACTIONS(3966),
    [anon_sym_LT_DASH] = ACTIONS(3966),
    [anon_sym_DOT_LBRACK] = ACTIONS(3964),
    [anon_sym_LT] = ACTIONS(3964),
    [anon_sym_use] = ACTIONS(3966),
    [anon_sym_use_BANG] = ACTIONS(3964),
    [anon_sym_do_BANG] = ACTIONS(3964),
    [anon_sym_begin] = ACTIONS(3966),
    [anon_sym_LPAREN2] = ACTIONS(3966),
    [anon_sym_default] = ACTIONS(3966),
    [anon_sym_or] = ACTIONS(3966),
    [anon_sym_static] = ACTIONS(3966),
    [anon_sym_member] = ACTIONS(3966),
    [anon_sym_interface] = ACTIONS(3966),
    [anon_sym_abstract] = ACTIONS(3966),
    [anon_sym_val] = ACTIONS(3966),
    [anon_sym_override] = ACTIONS(3966),
    [anon_sym_inherit] = ACTIONS(3966),
    [aux_sym_char_token1] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3966),
    [anon_sym_DQUOTE] = ACTIONS(3966),
    [anon_sym_AT_DQUOTE] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [sym_bool] = ACTIONS(3966),
    [sym_unit] = ACTIONS(3964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3966),
    [sym_op_identifier] = ACTIONS(3966),
    [anon_sym_PLUS] = ACTIONS(3966),
    [anon_sym_DASH] = ACTIONS(3966),
    [anon_sym_PLUS_DOT] = ACTIONS(3966),
    [anon_sym_DASH_DOT] = ACTIONS(3966),
    [anon_sym_PERCENT] = ACTIONS(3966),
    [anon_sym_AMP_AMP] = ACTIONS(3966),
    [anon_sym_TILDE] = ACTIONS(3964),
    [aux_sym_prefix_op_token1] = ACTIONS(3966),
    [aux_sym_infix_op_token1] = ACTIONS(3964),
    [aux_sym_infix_op_token2] = ACTIONS(3966),
    [anon_sym_PIPE_PIPE] = ACTIONS(3966),
    [anon_sym_BANG_EQ] = ACTIONS(3966),
    [anon_sym_COLON_EQ] = ACTIONS(3964),
    [anon_sym_DOLLAR] = ACTIONS(3966),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3966),
    [sym_int] = ACTIONS(3966),
    [sym_xint] = ACTIONS(3964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3964),
    [anon_sym_POUNDendif] = ACTIONS(3964),
    [sym__newline] = ACTIONS(3964),
  },
  [2155] = {
    [sym_block_comment] = STATE(2155),
    [sym_compiler_directive_decl] = STATE(2155),
    [sym_fsi_directive_decl] = STATE(2155),
    [sym_preproc_line] = STATE(2155),
    [sym_identifier] = ACTIONS(3942),
    [anon_sym_EQ] = ACTIONS(3940),
    [anon_sym_LBRACK_LT] = ACTIONS(3940),
    [anon_sym_COLON] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_and] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_let_BANG] = ACTIONS(3940),
    [aux_sym_access_modifier_token1] = ACTIONS(3940),
    [anon_sym_LPAREN] = ACTIONS(3942),
    [anon_sym_COMMA] = ACTIONS(3940),
    [anon_sym_null] = ACTIONS(3942),
    [anon_sym_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3940),
    [anon_sym_LBRACE] = ACTIONS(3942),
    [anon_sym_LT_AT] = ACTIONS(3942),
    [anon_sym_LT_AT_AT] = ACTIONS(3942),
    [anon_sym_DOT] = ACTIONS(3942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3940),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_with] = ACTIONS(3942),
    [anon_sym_return_BANG] = ACTIONS(3940),
    [anon_sym_yield] = ACTIONS(3942),
    [anon_sym_yield_BANG] = ACTIONS(3940),
    [anon_sym_lazy] = ACTIONS(3942),
    [anon_sym_assert] = ACTIONS(3942),
    [anon_sym_upcast] = ACTIONS(3942),
    [anon_sym_downcast] = ACTIONS(3942),
    [anon_sym_COLON_GT] = ACTIONS(3940),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3940),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_fun] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_match] = ACTIONS(3942),
    [anon_sym_match_BANG] = ACTIONS(3940),
    [anon_sym_function] = ACTIONS(3942),
    [anon_sym_LT_DASH] = ACTIONS(3942),
    [anon_sym_DOT_LBRACK] = ACTIONS(3940),
    [anon_sym_LT] = ACTIONS(3940),
    [anon_sym_use] = ACTIONS(3942),
    [anon_sym_use_BANG] = ACTIONS(3940),
    [anon_sym_do_BANG] = ACTIONS(3940),
    [anon_sym_begin] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3942),
    [anon_sym_default] = ACTIONS(3942),
    [anon_sym_or] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_member] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_abstract] = ACTIONS(3942),
    [anon_sym_val] = ACTIONS(3942),
    [anon_sym_override] = ACTIONS(3942),
    [aux_sym_char_token1] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3942),
    [anon_sym_DQUOTE] = ACTIONS(3942),
    [anon_sym_AT_DQUOTE] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [sym_bool] = ACTIONS(3942),
    [sym_unit] = ACTIONS(3940),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3942),
    [sym_op_identifier] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS_DOT] = ACTIONS(3942),
    [anon_sym_DASH_DOT] = ACTIONS(3942),
    [anon_sym_PERCENT] = ACTIONS(3942),
    [anon_sym_AMP_AMP] = ACTIONS(3942),
    [anon_sym_TILDE] = ACTIONS(3940),
    [aux_sym_prefix_op_token1] = ACTIONS(3942),
    [aux_sym_infix_op_token1] = ACTIONS(3940),
    [aux_sym_infix_op_token2] = ACTIONS(3942),
    [anon_sym_PIPE_PIPE] = ACTIONS(3942),
    [anon_sym_BANG_EQ] = ACTIONS(3942),
    [anon_sym_COLON_EQ] = ACTIONS(3940),
    [anon_sym_DOLLAR] = ACTIONS(3942),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3942),
    [sym_int] = ACTIONS(3942),
    [sym_xint] = ACTIONS(3940),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3940),
    [sym__newline] = ACTIONS(3940),
    [sym__dedent] = ACTIONS(3940),
  },
  [2156] = {
    [sym_block_comment] = STATE(2156),
    [sym_compiler_directive_decl] = STATE(2156),
    [sym_fsi_directive_decl] = STATE(2156),
    [sym_preproc_line] = STATE(2156),
    [sym_identifier] = ACTIONS(3942),
    [anon_sym_EQ] = ACTIONS(3940),
    [anon_sym_LBRACK_LT] = ACTIONS(3940),
    [anon_sym_COLON] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_let_BANG] = ACTIONS(3940),
    [aux_sym_access_modifier_token1] = ACTIONS(3940),
    [anon_sym_LPAREN] = ACTIONS(3942),
    [anon_sym_COMMA] = ACTIONS(3940),
    [anon_sym_null] = ACTIONS(3942),
    [anon_sym_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3940),
    [anon_sym_LBRACE] = ACTIONS(3942),
    [anon_sym_LT_AT] = ACTIONS(3942),
    [anon_sym_LT_AT_AT] = ACTIONS(3942),
    [anon_sym_DOT] = ACTIONS(3942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3940),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_with] = ACTIONS(3942),
    [anon_sym_return_BANG] = ACTIONS(3940),
    [anon_sym_yield] = ACTIONS(3942),
    [anon_sym_yield_BANG] = ACTIONS(3940),
    [anon_sym_lazy] = ACTIONS(3942),
    [anon_sym_assert] = ACTIONS(3942),
    [anon_sym_upcast] = ACTIONS(3942),
    [anon_sym_downcast] = ACTIONS(3942),
    [anon_sym_COLON_GT] = ACTIONS(3940),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3940),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_fun] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_match] = ACTIONS(3942),
    [anon_sym_match_BANG] = ACTIONS(3940),
    [anon_sym_function] = ACTIONS(3942),
    [anon_sym_LT_DASH] = ACTIONS(3942),
    [anon_sym_DOT_LBRACK] = ACTIONS(3940),
    [anon_sym_LT] = ACTIONS(3940),
    [anon_sym_use] = ACTIONS(3942),
    [anon_sym_use_BANG] = ACTIONS(3940),
    [anon_sym_do_BANG] = ACTIONS(3940),
    [anon_sym_begin] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3942),
    [anon_sym_default] = ACTIONS(3942),
    [anon_sym_or] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_member] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_abstract] = ACTIONS(3942),
    [anon_sym_val] = ACTIONS(3942),
    [anon_sym_override] = ACTIONS(3942),
    [anon_sym_inherit] = ACTIONS(3942),
    [aux_sym_char_token1] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3942),
    [anon_sym_DQUOTE] = ACTIONS(3942),
    [anon_sym_AT_DQUOTE] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [sym_bool] = ACTIONS(3942),
    [sym_unit] = ACTIONS(3940),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3942),
    [sym_op_identifier] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS_DOT] = ACTIONS(3942),
    [anon_sym_DASH_DOT] = ACTIONS(3942),
    [anon_sym_PERCENT] = ACTIONS(3942),
    [anon_sym_AMP_AMP] = ACTIONS(3942),
    [anon_sym_TILDE] = ACTIONS(3940),
    [aux_sym_prefix_op_token1] = ACTIONS(3942),
    [aux_sym_infix_op_token1] = ACTIONS(3940),
    [aux_sym_infix_op_token2] = ACTIONS(3942),
    [anon_sym_PIPE_PIPE] = ACTIONS(3942),
    [anon_sym_BANG_EQ] = ACTIONS(3942),
    [anon_sym_COLON_EQ] = ACTIONS(3940),
    [anon_sym_DOLLAR] = ACTIONS(3942),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3942),
    [sym_int] = ACTIONS(3942),
    [sym_xint] = ACTIONS(3940),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3940),
    [anon_sym_POUNDendif] = ACTIONS(3940),
    [sym__newline] = ACTIONS(3940),
  },
  [2157] = {
    [sym_block_comment] = STATE(2157),
    [sym_compiler_directive_decl] = STATE(2157),
    [sym_fsi_directive_decl] = STATE(2157),
    [sym_preproc_line] = STATE(2157),
    [sym_identifier] = ACTIONS(3931),
    [anon_sym_EQ] = ACTIONS(3929),
    [anon_sym_LBRACK_LT] = ACTIONS(3929),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_do] = ACTIONS(3931),
    [anon_sym_let] = ACTIONS(3931),
    [anon_sym_let_BANG] = ACTIONS(3929),
    [aux_sym_access_modifier_token1] = ACTIONS(3929),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_COMMA] = ACTIONS(3929),
    [anon_sym_null] = ACTIONS(3931),
    [anon_sym_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_COLON] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3931),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_LT_AT] = ACTIONS(3931),
    [anon_sym_LT_AT_AT] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3931),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3929),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3931),
    [anon_sym_return_BANG] = ACTIONS(3929),
    [anon_sym_yield] = ACTIONS(3931),
    [anon_sym_yield_BANG] = ACTIONS(3929),
    [anon_sym_lazy] = ACTIONS(3931),
    [anon_sym_assert] = ACTIONS(3931),
    [anon_sym_upcast] = ACTIONS(3931),
    [anon_sym_downcast] = ACTIONS(3931),
    [anon_sym_COLON_GT] = ACTIONS(3929),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3929),
    [anon_sym_for] = ACTIONS(3931),
    [anon_sym_while] = ACTIONS(3931),
    [anon_sym_if] = ACTIONS(3931),
    [anon_sym_fun] = ACTIONS(3931),
    [anon_sym_try] = ACTIONS(3931),
    [anon_sym_match] = ACTIONS(3931),
    [anon_sym_match_BANG] = ACTIONS(3929),
    [anon_sym_function] = ACTIONS(3931),
    [anon_sym_LT_DASH] = ACTIONS(3931),
    [anon_sym_DOT_LBRACK] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_use] = ACTIONS(3931),
    [anon_sym_use_BANG] = ACTIONS(3929),
    [anon_sym_do_BANG] = ACTIONS(3929),
    [anon_sym_begin] = ACTIONS(3931),
    [anon_sym_LPAREN2] = ACTIONS(3931),
    [anon_sym_default] = ACTIONS(3931),
    [anon_sym_or] = ACTIONS(3931),
    [anon_sym_static] = ACTIONS(3931),
    [anon_sym_member] = ACTIONS(3931),
    [anon_sym_interface] = ACTIONS(3931),
    [anon_sym_abstract] = ACTIONS(3931),
    [anon_sym_val] = ACTIONS(3931),
    [anon_sym_override] = ACTIONS(3931),
    [anon_sym_inherit] = ACTIONS(3931),
    [aux_sym_char_token1] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3931),
    [anon_sym_DQUOTE] = ACTIONS(3931),
    [anon_sym_AT_DQUOTE] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [sym_bool] = ACTIONS(3931),
    [sym_unit] = ACTIONS(3929),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3931),
    [sym_op_identifier] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3931),
    [anon_sym_DASH] = ACTIONS(3931),
    [anon_sym_PLUS_DOT] = ACTIONS(3931),
    [anon_sym_DASH_DOT] = ACTIONS(3931),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_TILDE] = ACTIONS(3929),
    [aux_sym_prefix_op_token1] = ACTIONS(3931),
    [aux_sym_infix_op_token1] = ACTIONS(3929),
    [aux_sym_infix_op_token2] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_COLON_EQ] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3931),
    [sym_int] = ACTIONS(3931),
    [sym_xint] = ACTIONS(3929),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3929),
    [anon_sym_POUNDendif] = ACTIONS(3929),
    [sym__newline] = ACTIONS(3929),
  },
  [2158] = {
    [sym_block_comment] = STATE(2158),
    [sym_compiler_directive_decl] = STATE(2158),
    [sym_fsi_directive_decl] = STATE(2158),
    [sym_preproc_line] = STATE(2158),
    [sym_identifier] = ACTIONS(3917),
    [anon_sym_EQ] = ACTIONS(3915),
    [anon_sym_LBRACK_LT] = ACTIONS(3915),
    [anon_sym_COLON] = ACTIONS(3917),
    [anon_sym_return] = ACTIONS(3917),
    [anon_sym_do] = ACTIONS(3917),
    [anon_sym_let] = ACTIONS(3917),
    [anon_sym_let_BANG] = ACTIONS(3915),
    [aux_sym_access_modifier_token1] = ACTIONS(3915),
    [anon_sym_LPAREN] = ACTIONS(3917),
    [anon_sym_COMMA] = ACTIONS(3915),
    [anon_sym_null] = ACTIONS(3917),
    [anon_sym_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_COLON] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(3917),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3915),
    [anon_sym_LBRACE] = ACTIONS(3917),
    [anon_sym_LT_AT] = ACTIONS(3917),
    [anon_sym_LT_AT_AT] = ACTIONS(3917),
    [anon_sym_DOT] = ACTIONS(3917),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3915),
    [anon_sym_new] = ACTIONS(3917),
    [anon_sym_with] = ACTIONS(3917),
    [anon_sym_return_BANG] = ACTIONS(3915),
    [anon_sym_yield] = ACTIONS(3917),
    [anon_sym_yield_BANG] = ACTIONS(3915),
    [anon_sym_lazy] = ACTIONS(3917),
    [anon_sym_assert] = ACTIONS(3917),
    [anon_sym_upcast] = ACTIONS(3917),
    [anon_sym_downcast] = ACTIONS(3917),
    [anon_sym_COLON_GT] = ACTIONS(3915),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3915),
    [anon_sym_for] = ACTIONS(3917),
    [anon_sym_while] = ACTIONS(3917),
    [anon_sym_if] = ACTIONS(3917),
    [anon_sym_fun] = ACTIONS(3917),
    [anon_sym_try] = ACTIONS(3917),
    [anon_sym_match] = ACTIONS(3917),
    [anon_sym_match_BANG] = ACTIONS(3915),
    [anon_sym_function] = ACTIONS(3917),
    [anon_sym_LT_DASH] = ACTIONS(3917),
    [anon_sym_DOT_LBRACK] = ACTIONS(3915),
    [anon_sym_LT] = ACTIONS(3915),
    [anon_sym_use] = ACTIONS(3917),
    [anon_sym_use_BANG] = ACTIONS(3915),
    [anon_sym_do_BANG] = ACTIONS(3915),
    [anon_sym_begin] = ACTIONS(3917),
    [anon_sym_LPAREN2] = ACTIONS(3917),
    [anon_sym_default] = ACTIONS(3917),
    [anon_sym_or] = ACTIONS(3917),
    [anon_sym_static] = ACTIONS(3917),
    [anon_sym_member] = ACTIONS(3917),
    [anon_sym_interface] = ACTIONS(3917),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_val] = ACTIONS(3917),
    [anon_sym_override] = ACTIONS(3917),
    [anon_sym_inherit] = ACTIONS(3917),
    [aux_sym_char_token1] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_AT_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [sym_bool] = ACTIONS(3917),
    [sym_unit] = ACTIONS(3915),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3917),
    [sym_op_identifier] = ACTIONS(3917),
    [anon_sym_PLUS] = ACTIONS(3917),
    [anon_sym_DASH] = ACTIONS(3917),
    [anon_sym_PLUS_DOT] = ACTIONS(3917),
    [anon_sym_DASH_DOT] = ACTIONS(3917),
    [anon_sym_PERCENT] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_TILDE] = ACTIONS(3915),
    [aux_sym_prefix_op_token1] = ACTIONS(3917),
    [aux_sym_infix_op_token1] = ACTIONS(3915),
    [aux_sym_infix_op_token2] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_BANG_EQ] = ACTIONS(3917),
    [anon_sym_COLON_EQ] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3917),
    [sym_int] = ACTIONS(3917),
    [sym_xint] = ACTIONS(3915),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3915),
    [anon_sym_POUNDendif] = ACTIONS(3915),
    [sym__newline] = ACTIONS(3915),
  },
  [2159] = {
    [sym_block_comment] = STATE(2159),
    [sym_compiler_directive_decl] = STATE(2159),
    [sym_fsi_directive_decl] = STATE(2159),
    [sym_preproc_line] = STATE(2159),
    [sym_identifier] = ACTIONS(3962),
    [anon_sym_EQ] = ACTIONS(3960),
    [anon_sym_LBRACK_LT] = ACTIONS(3960),
    [anon_sym_COLON] = ACTIONS(3962),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_do] = ACTIONS(3962),
    [anon_sym_let] = ACTIONS(3962),
    [anon_sym_let_BANG] = ACTIONS(3960),
    [aux_sym_access_modifier_token1] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_COMMA] = ACTIONS(3960),
    [anon_sym_null] = ACTIONS(3962),
    [anon_sym_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_COLON] = ACTIONS(3960),
    [anon_sym_AMP] = ACTIONS(3962),
    [anon_sym_LBRACK] = ACTIONS(3962),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_LT_AT] = ACTIONS(3962),
    [anon_sym_LT_AT_AT] = ACTIONS(3962),
    [anon_sym_DOT] = ACTIONS(3962),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3960),
    [anon_sym_new] = ACTIONS(3962),
    [anon_sym_with] = ACTIONS(3962),
    [anon_sym_return_BANG] = ACTIONS(3960),
    [anon_sym_yield] = ACTIONS(3962),
    [anon_sym_yield_BANG] = ACTIONS(3960),
    [anon_sym_lazy] = ACTIONS(3962),
    [anon_sym_assert] = ACTIONS(3962),
    [anon_sym_upcast] = ACTIONS(3962),
    [anon_sym_downcast] = ACTIONS(3962),
    [anon_sym_COLON_GT] = ACTIONS(3960),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3960),
    [anon_sym_for] = ACTIONS(3962),
    [anon_sym_while] = ACTIONS(3962),
    [anon_sym_if] = ACTIONS(3962),
    [anon_sym_fun] = ACTIONS(3962),
    [anon_sym_try] = ACTIONS(3962),
    [anon_sym_match] = ACTIONS(3962),
    [anon_sym_match_BANG] = ACTIONS(3960),
    [anon_sym_function] = ACTIONS(3962),
    [anon_sym_LT_DASH] = ACTIONS(3962),
    [anon_sym_DOT_LBRACK] = ACTIONS(3960),
    [anon_sym_LT] = ACTIONS(3960),
    [anon_sym_use] = ACTIONS(3962),
    [anon_sym_use_BANG] = ACTIONS(3960),
    [anon_sym_do_BANG] = ACTIONS(3960),
    [anon_sym_begin] = ACTIONS(3962),
    [anon_sym_LPAREN2] = ACTIONS(3962),
    [anon_sym_default] = ACTIONS(3962),
    [anon_sym_or] = ACTIONS(3962),
    [anon_sym_static] = ACTIONS(3962),
    [anon_sym_member] = ACTIONS(3962),
    [anon_sym_interface] = ACTIONS(3962),
    [anon_sym_abstract] = ACTIONS(3962),
    [anon_sym_val] = ACTIONS(3962),
    [anon_sym_override] = ACTIONS(3962),
    [anon_sym_inherit] = ACTIONS(3962),
    [aux_sym_char_token1] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3962),
    [anon_sym_DQUOTE] = ACTIONS(3962),
    [anon_sym_AT_DQUOTE] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [sym_bool] = ACTIONS(3962),
    [sym_unit] = ACTIONS(3960),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3962),
    [sym_op_identifier] = ACTIONS(3962),
    [anon_sym_PLUS] = ACTIONS(3962),
    [anon_sym_DASH] = ACTIONS(3962),
    [anon_sym_PLUS_DOT] = ACTIONS(3962),
    [anon_sym_DASH_DOT] = ACTIONS(3962),
    [anon_sym_PERCENT] = ACTIONS(3962),
    [anon_sym_AMP_AMP] = ACTIONS(3962),
    [anon_sym_TILDE] = ACTIONS(3960),
    [aux_sym_prefix_op_token1] = ACTIONS(3962),
    [aux_sym_infix_op_token1] = ACTIONS(3960),
    [aux_sym_infix_op_token2] = ACTIONS(3962),
    [anon_sym_PIPE_PIPE] = ACTIONS(3962),
    [anon_sym_BANG_EQ] = ACTIONS(3962),
    [anon_sym_COLON_EQ] = ACTIONS(3960),
    [anon_sym_DOLLAR] = ACTIONS(3962),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3962),
    [sym_int] = ACTIONS(3962),
    [sym_xint] = ACTIONS(3960),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3960),
    [anon_sym_POUNDendif] = ACTIONS(3960),
    [sym__newline] = ACTIONS(3960),
  },
  [2160] = {
    [sym_block_comment] = STATE(2160),
    [sym_compiler_directive_decl] = STATE(2160),
    [sym_fsi_directive_decl] = STATE(2160),
    [sym_preproc_line] = STATE(2160),
    [sym_identifier] = ACTIONS(4224),
    [anon_sym_EQ] = ACTIONS(4222),
    [anon_sym_LBRACK_LT] = ACTIONS(4222),
    [anon_sym_COLON] = ACTIONS(4224),
    [anon_sym_return] = ACTIONS(4224),
    [anon_sym_do] = ACTIONS(4224),
    [anon_sym_and] = ACTIONS(4224),
    [anon_sym_let] = ACTIONS(4224),
    [anon_sym_let_BANG] = ACTIONS(4222),
    [aux_sym_access_modifier_token1] = ACTIONS(4222),
    [anon_sym_LPAREN] = ACTIONS(4224),
    [anon_sym_COMMA] = ACTIONS(4222),
    [anon_sym_null] = ACTIONS(4224),
    [anon_sym_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_COLON] = ACTIONS(4222),
    [anon_sym_AMP] = ACTIONS(4224),
    [anon_sym_LBRACK] = ACTIONS(4224),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4222),
    [anon_sym_LBRACE] = ACTIONS(4224),
    [anon_sym_LT_AT] = ACTIONS(4224),
    [anon_sym_LT_AT_AT] = ACTIONS(4224),
    [anon_sym_DOT] = ACTIONS(4224),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4222),
    [anon_sym_new] = ACTIONS(4224),
    [anon_sym_with] = ACTIONS(4224),
    [anon_sym_return_BANG] = ACTIONS(4222),
    [anon_sym_yield] = ACTIONS(4224),
    [anon_sym_yield_BANG] = ACTIONS(4222),
    [anon_sym_lazy] = ACTIONS(4224),
    [anon_sym_assert] = ACTIONS(4224),
    [anon_sym_upcast] = ACTIONS(4224),
    [anon_sym_downcast] = ACTIONS(4224),
    [anon_sym_COLON_GT] = ACTIONS(4222),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4222),
    [anon_sym_for] = ACTIONS(4224),
    [anon_sym_while] = ACTIONS(4224),
    [anon_sym_if] = ACTIONS(4224),
    [anon_sym_fun] = ACTIONS(4224),
    [anon_sym_try] = ACTIONS(4224),
    [anon_sym_match] = ACTIONS(4224),
    [anon_sym_match_BANG] = ACTIONS(4222),
    [anon_sym_function] = ACTIONS(4224),
    [anon_sym_LT_DASH] = ACTIONS(4224),
    [anon_sym_DOT_LBRACK] = ACTIONS(4222),
    [anon_sym_LT] = ACTIONS(4222),
    [anon_sym_use] = ACTIONS(4224),
    [anon_sym_use_BANG] = ACTIONS(4222),
    [anon_sym_do_BANG] = ACTIONS(4222),
    [anon_sym_begin] = ACTIONS(4224),
    [anon_sym_LPAREN2] = ACTIONS(4224),
    [anon_sym_default] = ACTIONS(4224),
    [anon_sym_or] = ACTIONS(4224),
    [anon_sym_static] = ACTIONS(4224),
    [anon_sym_member] = ACTIONS(4224),
    [anon_sym_interface] = ACTIONS(4224),
    [anon_sym_abstract] = ACTIONS(4224),
    [anon_sym_val] = ACTIONS(4224),
    [anon_sym_override] = ACTIONS(4224),
    [aux_sym_char_token1] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4224),
    [anon_sym_DQUOTE] = ACTIONS(4224),
    [anon_sym_AT_DQUOTE] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [sym_bool] = ACTIONS(4224),
    [sym_unit] = ACTIONS(4222),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4224),
    [sym_op_identifier] = ACTIONS(4224),
    [anon_sym_PLUS] = ACTIONS(4224),
    [anon_sym_DASH] = ACTIONS(4224),
    [anon_sym_PLUS_DOT] = ACTIONS(4224),
    [anon_sym_DASH_DOT] = ACTIONS(4224),
    [anon_sym_PERCENT] = ACTIONS(4224),
    [anon_sym_AMP_AMP] = ACTIONS(4224),
    [anon_sym_TILDE] = ACTIONS(4222),
    [aux_sym_prefix_op_token1] = ACTIONS(4224),
    [aux_sym_infix_op_token1] = ACTIONS(4222),
    [aux_sym_infix_op_token2] = ACTIONS(4224),
    [anon_sym_PIPE_PIPE] = ACTIONS(4224),
    [anon_sym_BANG_EQ] = ACTIONS(4224),
    [anon_sym_COLON_EQ] = ACTIONS(4222),
    [anon_sym_DOLLAR] = ACTIONS(4224),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4224),
    [sym_int] = ACTIONS(4224),
    [sym_xint] = ACTIONS(4222),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4222),
    [anon_sym_POUNDendif] = ACTIONS(4222),
    [sym__newline] = ACTIONS(4222),
  },
  [2161] = {
    [sym_block_comment] = STATE(2161),
    [sym_compiler_directive_decl] = STATE(2161),
    [sym_fsi_directive_decl] = STATE(2161),
    [sym_preproc_line] = STATE(2161),
    [sym_identifier] = ACTIONS(3958),
    [anon_sym_EQ] = ACTIONS(3956),
    [anon_sym_LBRACK_LT] = ACTIONS(3956),
    [anon_sym_COLON] = ACTIONS(3958),
    [anon_sym_return] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(3958),
    [anon_sym_let] = ACTIONS(3958),
    [anon_sym_let_BANG] = ACTIONS(3956),
    [aux_sym_access_modifier_token1] = ACTIONS(3956),
    [anon_sym_LPAREN] = ACTIONS(3958),
    [anon_sym_COMMA] = ACTIONS(3956),
    [anon_sym_null] = ACTIONS(3958),
    [anon_sym_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_COLON] = ACTIONS(3956),
    [anon_sym_AMP] = ACTIONS(3958),
    [anon_sym_LBRACK] = ACTIONS(3958),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3956),
    [anon_sym_LBRACE] = ACTIONS(3958),
    [anon_sym_LT_AT] = ACTIONS(3958),
    [anon_sym_LT_AT_AT] = ACTIONS(3958),
    [anon_sym_DOT] = ACTIONS(3958),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3956),
    [anon_sym_new] = ACTIONS(3958),
    [anon_sym_with] = ACTIONS(3958),
    [anon_sym_return_BANG] = ACTIONS(3956),
    [anon_sym_yield] = ACTIONS(3958),
    [anon_sym_yield_BANG] = ACTIONS(3956),
    [anon_sym_lazy] = ACTIONS(3958),
    [anon_sym_assert] = ACTIONS(3958),
    [anon_sym_upcast] = ACTIONS(3958),
    [anon_sym_downcast] = ACTIONS(3958),
    [anon_sym_COLON_GT] = ACTIONS(3956),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3956),
    [anon_sym_for] = ACTIONS(3958),
    [anon_sym_while] = ACTIONS(3958),
    [anon_sym_if] = ACTIONS(3958),
    [anon_sym_fun] = ACTIONS(3958),
    [anon_sym_try] = ACTIONS(3958),
    [anon_sym_match] = ACTIONS(3958),
    [anon_sym_match_BANG] = ACTIONS(3956),
    [anon_sym_function] = ACTIONS(3958),
    [anon_sym_LT_DASH] = ACTIONS(3958),
    [anon_sym_DOT_LBRACK] = ACTIONS(3956),
    [anon_sym_LT] = ACTIONS(3956),
    [anon_sym_use] = ACTIONS(3958),
    [anon_sym_use_BANG] = ACTIONS(3956),
    [anon_sym_do_BANG] = ACTIONS(3956),
    [anon_sym_begin] = ACTIONS(3958),
    [anon_sym_LPAREN2] = ACTIONS(3958),
    [anon_sym_default] = ACTIONS(3958),
    [anon_sym_or] = ACTIONS(3958),
    [anon_sym_static] = ACTIONS(3958),
    [anon_sym_member] = ACTIONS(3958),
    [anon_sym_interface] = ACTIONS(3958),
    [anon_sym_abstract] = ACTIONS(3958),
    [anon_sym_val] = ACTIONS(3958),
    [anon_sym_override] = ACTIONS(3958),
    [anon_sym_inherit] = ACTIONS(3958),
    [aux_sym_char_token1] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [anon_sym_AT_DQUOTE] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [sym_bool] = ACTIONS(3958),
    [sym_unit] = ACTIONS(3956),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3958),
    [sym_op_identifier] = ACTIONS(3958),
    [anon_sym_PLUS] = ACTIONS(3958),
    [anon_sym_DASH] = ACTIONS(3958),
    [anon_sym_PLUS_DOT] = ACTIONS(3958),
    [anon_sym_DASH_DOT] = ACTIONS(3958),
    [anon_sym_PERCENT] = ACTIONS(3958),
    [anon_sym_AMP_AMP] = ACTIONS(3958),
    [anon_sym_TILDE] = ACTIONS(3956),
    [aux_sym_prefix_op_token1] = ACTIONS(3958),
    [aux_sym_infix_op_token1] = ACTIONS(3956),
    [aux_sym_infix_op_token2] = ACTIONS(3958),
    [anon_sym_PIPE_PIPE] = ACTIONS(3958),
    [anon_sym_BANG_EQ] = ACTIONS(3958),
    [anon_sym_COLON_EQ] = ACTIONS(3956),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3958),
    [sym_int] = ACTIONS(3958),
    [sym_xint] = ACTIONS(3956),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3956),
    [anon_sym_POUNDendif] = ACTIONS(3956),
    [sym__newline] = ACTIONS(3956),
  },
  [2162] = {
    [sym_block_comment] = STATE(2162),
    [sym_compiler_directive_decl] = STATE(2162),
    [sym_fsi_directive_decl] = STATE(2162),
    [sym_preproc_line] = STATE(2162),
    [sym_identifier] = ACTIONS(3881),
    [anon_sym_EQ] = ACTIONS(3879),
    [anon_sym_LBRACK_LT] = ACTIONS(3879),
    [anon_sym_COLON] = ACTIONS(3881),
    [anon_sym_return] = ACTIONS(3881),
    [anon_sym_do] = ACTIONS(3881),
    [anon_sym_let] = ACTIONS(3881),
    [anon_sym_let_BANG] = ACTIONS(3879),
    [aux_sym_access_modifier_token1] = ACTIONS(3879),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3879),
    [anon_sym_null] = ACTIONS(3881),
    [anon_sym_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3879),
    [anon_sym_LBRACE] = ACTIONS(3881),
    [anon_sym_LT_AT] = ACTIONS(3881),
    [anon_sym_LT_AT_AT] = ACTIONS(3881),
    [anon_sym_DOT] = ACTIONS(3881),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3879),
    [anon_sym_new] = ACTIONS(3881),
    [anon_sym_with] = ACTIONS(3881),
    [anon_sym_return_BANG] = ACTIONS(3879),
    [anon_sym_yield] = ACTIONS(3881),
    [anon_sym_yield_BANG] = ACTIONS(3879),
    [anon_sym_lazy] = ACTIONS(3881),
    [anon_sym_assert] = ACTIONS(3881),
    [anon_sym_upcast] = ACTIONS(3881),
    [anon_sym_downcast] = ACTIONS(3881),
    [anon_sym_COLON_GT] = ACTIONS(3879),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3879),
    [anon_sym_for] = ACTIONS(3881),
    [anon_sym_while] = ACTIONS(3881),
    [anon_sym_if] = ACTIONS(3881),
    [anon_sym_fun] = ACTIONS(3881),
    [anon_sym_try] = ACTIONS(3881),
    [anon_sym_match] = ACTIONS(3881),
    [anon_sym_match_BANG] = ACTIONS(3879),
    [anon_sym_function] = ACTIONS(3881),
    [anon_sym_LT_DASH] = ACTIONS(3881),
    [anon_sym_DOT_LBRACK] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_use] = ACTIONS(3881),
    [anon_sym_use_BANG] = ACTIONS(3879),
    [anon_sym_do_BANG] = ACTIONS(3879),
    [anon_sym_begin] = ACTIONS(3881),
    [anon_sym_LPAREN2] = ACTIONS(3881),
    [anon_sym_DOT_DOT2] = ACTIONS(3879),
    [anon_sym_default] = ACTIONS(3881),
    [anon_sym_or] = ACTIONS(3881),
    [anon_sym_static] = ACTIONS(3881),
    [anon_sym_member] = ACTIONS(3881),
    [anon_sym_interface] = ACTIONS(3881),
    [anon_sym_abstract] = ACTIONS(3881),
    [anon_sym_val] = ACTIONS(3881),
    [anon_sym_override] = ACTIONS(3881),
    [aux_sym_char_token1] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3881),
    [anon_sym_DQUOTE] = ACTIONS(3881),
    [anon_sym_AT_DQUOTE] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [sym_bool] = ACTIONS(3881),
    [sym_unit] = ACTIONS(3879),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3881),
    [sym_op_identifier] = ACTIONS(3881),
    [anon_sym_PLUS] = ACTIONS(3881),
    [anon_sym_DASH] = ACTIONS(3881),
    [anon_sym_PLUS_DOT] = ACTIONS(3881),
    [anon_sym_DASH_DOT] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(3881),
    [anon_sym_AMP_AMP] = ACTIONS(3881),
    [anon_sym_TILDE] = ACTIONS(3879),
    [aux_sym_prefix_op_token1] = ACTIONS(3881),
    [aux_sym_infix_op_token1] = ACTIONS(3879),
    [aux_sym_infix_op_token2] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE] = ACTIONS(3881),
    [anon_sym_BANG_EQ] = ACTIONS(3881),
    [anon_sym_COLON_EQ] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3881),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3881),
    [sym_int] = ACTIONS(3881),
    [sym_xint] = ACTIONS(3879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3879),
    [sym__newline] = ACTIONS(3879),
    [sym__dedent] = ACTIONS(3879),
  },
  [2163] = {
    [sym_block_comment] = STATE(2163),
    [sym_compiler_directive_decl] = STATE(2163),
    [sym_fsi_directive_decl] = STATE(2163),
    [sym_preproc_line] = STATE(2163),
    [sym_identifier] = ACTIONS(3893),
    [anon_sym_EQ] = ACTIONS(3891),
    [anon_sym_LBRACK_LT] = ACTIONS(3891),
    [anon_sym_COLON] = ACTIONS(3893),
    [anon_sym_return] = ACTIONS(3893),
    [anon_sym_do] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_let_BANG] = ACTIONS(3891),
    [aux_sym_access_modifier_token1] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_COMMA] = ACTIONS(3891),
    [anon_sym_null] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_COLON] = ACTIONS(3891),
    [anon_sym_AMP] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3891),
    [anon_sym_LBRACE] = ACTIONS(3893),
    [anon_sym_LT_AT] = ACTIONS(3893),
    [anon_sym_LT_AT_AT] = ACTIONS(3893),
    [anon_sym_DOT] = ACTIONS(3893),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3891),
    [anon_sym_new] = ACTIONS(3893),
    [anon_sym_with] = ACTIONS(3893),
    [anon_sym_return_BANG] = ACTIONS(3891),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_yield_BANG] = ACTIONS(3891),
    [anon_sym_lazy] = ACTIONS(3893),
    [anon_sym_assert] = ACTIONS(3893),
    [anon_sym_upcast] = ACTIONS(3893),
    [anon_sym_downcast] = ACTIONS(3893),
    [anon_sym_COLON_GT] = ACTIONS(3891),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3891),
    [anon_sym_for] = ACTIONS(3893),
    [anon_sym_while] = ACTIONS(3893),
    [anon_sym_if] = ACTIONS(3893),
    [anon_sym_fun] = ACTIONS(3893),
    [anon_sym_try] = ACTIONS(3893),
    [anon_sym_match] = ACTIONS(3893),
    [anon_sym_match_BANG] = ACTIONS(3891),
    [anon_sym_function] = ACTIONS(3893),
    [anon_sym_LT_DASH] = ACTIONS(3893),
    [anon_sym_DOT_LBRACK] = ACTIONS(3891),
    [anon_sym_LT] = ACTIONS(3891),
    [anon_sym_use] = ACTIONS(3893),
    [anon_sym_use_BANG] = ACTIONS(3891),
    [anon_sym_do_BANG] = ACTIONS(3891),
    [anon_sym_begin] = ACTIONS(3893),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_DOT_DOT2] = ACTIONS(3891),
    [anon_sym_default] = ACTIONS(3893),
    [anon_sym_or] = ACTIONS(3893),
    [anon_sym_static] = ACTIONS(3893),
    [anon_sym_member] = ACTIONS(3893),
    [anon_sym_interface] = ACTIONS(3893),
    [anon_sym_abstract] = ACTIONS(3893),
    [anon_sym_val] = ACTIONS(3893),
    [anon_sym_override] = ACTIONS(3893),
    [aux_sym_char_token1] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3893),
    [anon_sym_DQUOTE] = ACTIONS(3893),
    [anon_sym_AT_DQUOTE] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [sym_bool] = ACTIONS(3893),
    [sym_unit] = ACTIONS(3891),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3893),
    [sym_op_identifier] = ACTIONS(3893),
    [anon_sym_PLUS] = ACTIONS(3893),
    [anon_sym_DASH] = ACTIONS(3893),
    [anon_sym_PLUS_DOT] = ACTIONS(3893),
    [anon_sym_DASH_DOT] = ACTIONS(3893),
    [anon_sym_PERCENT] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_TILDE] = ACTIONS(3891),
    [aux_sym_prefix_op_token1] = ACTIONS(3893),
    [aux_sym_infix_op_token1] = ACTIONS(3891),
    [aux_sym_infix_op_token2] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [anon_sym_BANG_EQ] = ACTIONS(3893),
    [anon_sym_COLON_EQ] = ACTIONS(3891),
    [anon_sym_DOLLAR] = ACTIONS(3893),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3893),
    [sym_int] = ACTIONS(3893),
    [sym_xint] = ACTIONS(3891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3891),
    [sym__newline] = ACTIONS(3891),
    [sym__dedent] = ACTIONS(3891),
  },
  [2164] = {
    [sym_block_comment] = STATE(2164),
    [sym_compiler_directive_decl] = STATE(2164),
    [sym_fsi_directive_decl] = STATE(2164),
    [sym_preproc_line] = STATE(2164),
    [sym_identifier] = ACTIONS(3954),
    [anon_sym_EQ] = ACTIONS(3952),
    [anon_sym_LBRACK_LT] = ACTIONS(3952),
    [anon_sym_COLON] = ACTIONS(3954),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_do] = ACTIONS(3954),
    [anon_sym_let] = ACTIONS(3954),
    [anon_sym_let_BANG] = ACTIONS(3952),
    [aux_sym_access_modifier_token1] = ACTIONS(3952),
    [anon_sym_LPAREN] = ACTIONS(3954),
    [anon_sym_COMMA] = ACTIONS(3952),
    [anon_sym_null] = ACTIONS(3954),
    [anon_sym_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_COLON] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3954),
    [anon_sym_LBRACK] = ACTIONS(3954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(3954),
    [anon_sym_LT_AT] = ACTIONS(3954),
    [anon_sym_LT_AT_AT] = ACTIONS(3954),
    [anon_sym_DOT] = ACTIONS(3954),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3952),
    [anon_sym_new] = ACTIONS(3954),
    [anon_sym_with] = ACTIONS(3954),
    [anon_sym_return_BANG] = ACTIONS(3952),
    [anon_sym_yield] = ACTIONS(3954),
    [anon_sym_yield_BANG] = ACTIONS(3952),
    [anon_sym_lazy] = ACTIONS(3954),
    [anon_sym_assert] = ACTIONS(3954),
    [anon_sym_upcast] = ACTIONS(3954),
    [anon_sym_downcast] = ACTIONS(3954),
    [anon_sym_COLON_GT] = ACTIONS(3952),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3952),
    [anon_sym_for] = ACTIONS(3954),
    [anon_sym_while] = ACTIONS(3954),
    [anon_sym_if] = ACTIONS(3954),
    [anon_sym_fun] = ACTIONS(3954),
    [anon_sym_try] = ACTIONS(3954),
    [anon_sym_match] = ACTIONS(3954),
    [anon_sym_match_BANG] = ACTIONS(3952),
    [anon_sym_function] = ACTIONS(3954),
    [anon_sym_LT_DASH] = ACTIONS(3954),
    [anon_sym_DOT_LBRACK] = ACTIONS(3952),
    [anon_sym_LT] = ACTIONS(3952),
    [anon_sym_use] = ACTIONS(3954),
    [anon_sym_use_BANG] = ACTIONS(3952),
    [anon_sym_do_BANG] = ACTIONS(3952),
    [anon_sym_begin] = ACTIONS(3954),
    [anon_sym_LPAREN2] = ACTIONS(3954),
    [anon_sym_default] = ACTIONS(3954),
    [anon_sym_or] = ACTIONS(3954),
    [anon_sym_static] = ACTIONS(3954),
    [anon_sym_member] = ACTIONS(3954),
    [anon_sym_interface] = ACTIONS(3954),
    [anon_sym_abstract] = ACTIONS(3954),
    [anon_sym_val] = ACTIONS(3954),
    [anon_sym_override] = ACTIONS(3954),
    [anon_sym_inherit] = ACTIONS(3954),
    [aux_sym_char_token1] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3954),
    [anon_sym_DQUOTE] = ACTIONS(3954),
    [anon_sym_AT_DQUOTE] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [sym_bool] = ACTIONS(3954),
    [sym_unit] = ACTIONS(3952),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3954),
    [sym_op_identifier] = ACTIONS(3954),
    [anon_sym_PLUS] = ACTIONS(3954),
    [anon_sym_DASH] = ACTIONS(3954),
    [anon_sym_PLUS_DOT] = ACTIONS(3954),
    [anon_sym_DASH_DOT] = ACTIONS(3954),
    [anon_sym_PERCENT] = ACTIONS(3954),
    [anon_sym_AMP_AMP] = ACTIONS(3954),
    [anon_sym_TILDE] = ACTIONS(3952),
    [aux_sym_prefix_op_token1] = ACTIONS(3954),
    [aux_sym_infix_op_token1] = ACTIONS(3952),
    [aux_sym_infix_op_token2] = ACTIONS(3954),
    [anon_sym_PIPE_PIPE] = ACTIONS(3954),
    [anon_sym_BANG_EQ] = ACTIONS(3954),
    [anon_sym_COLON_EQ] = ACTIONS(3952),
    [anon_sym_DOLLAR] = ACTIONS(3954),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3954),
    [sym_int] = ACTIONS(3954),
    [sym_xint] = ACTIONS(3952),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3952),
    [anon_sym_POUNDendif] = ACTIONS(3952),
    [sym__newline] = ACTIONS(3952),
  },
  [2165] = {
    [sym_block_comment] = STATE(2165),
    [sym_compiler_directive_decl] = STATE(2165),
    [sym_fsi_directive_decl] = STATE(2165),
    [sym_preproc_line] = STATE(2165),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_EQ] = ACTIONS(3948),
    [anon_sym_LBRACK_LT] = ACTIONS(3948),
    [anon_sym_COLON] = ACTIONS(3950),
    [anon_sym_return] = ACTIONS(3950),
    [anon_sym_do] = ACTIONS(3950),
    [anon_sym_let] = ACTIONS(3950),
    [anon_sym_let_BANG] = ACTIONS(3948),
    [aux_sym_access_modifier_token1] = ACTIONS(3948),
    [anon_sym_LPAREN] = ACTIONS(3950),
    [anon_sym_COMMA] = ACTIONS(3948),
    [anon_sym_null] = ACTIONS(3950),
    [anon_sym_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_COLON] = ACTIONS(3948),
    [anon_sym_AMP] = ACTIONS(3950),
    [anon_sym_LBRACK] = ACTIONS(3950),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3948),
    [anon_sym_LBRACE] = ACTIONS(3950),
    [anon_sym_LT_AT] = ACTIONS(3950),
    [anon_sym_LT_AT_AT] = ACTIONS(3950),
    [anon_sym_DOT] = ACTIONS(3950),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3948),
    [anon_sym_new] = ACTIONS(3950),
    [anon_sym_with] = ACTIONS(3950),
    [anon_sym_return_BANG] = ACTIONS(3948),
    [anon_sym_yield] = ACTIONS(3950),
    [anon_sym_yield_BANG] = ACTIONS(3948),
    [anon_sym_lazy] = ACTIONS(3950),
    [anon_sym_assert] = ACTIONS(3950),
    [anon_sym_upcast] = ACTIONS(3950),
    [anon_sym_downcast] = ACTIONS(3950),
    [anon_sym_COLON_GT] = ACTIONS(3948),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3948),
    [anon_sym_for] = ACTIONS(3950),
    [anon_sym_while] = ACTIONS(3950),
    [anon_sym_if] = ACTIONS(3950),
    [anon_sym_fun] = ACTIONS(3950),
    [anon_sym_try] = ACTIONS(3950),
    [anon_sym_match] = ACTIONS(3950),
    [anon_sym_match_BANG] = ACTIONS(3948),
    [anon_sym_function] = ACTIONS(3950),
    [anon_sym_LT_DASH] = ACTIONS(3950),
    [anon_sym_DOT_LBRACK] = ACTIONS(3948),
    [anon_sym_LT] = ACTIONS(3948),
    [anon_sym_use] = ACTIONS(3950),
    [anon_sym_use_BANG] = ACTIONS(3948),
    [anon_sym_do_BANG] = ACTIONS(3948),
    [anon_sym_begin] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3950),
    [anon_sym_default] = ACTIONS(3950),
    [anon_sym_or] = ACTIONS(3950),
    [anon_sym_static] = ACTIONS(3950),
    [anon_sym_member] = ACTIONS(3950),
    [anon_sym_interface] = ACTIONS(3950),
    [anon_sym_abstract] = ACTIONS(3950),
    [anon_sym_val] = ACTIONS(3950),
    [anon_sym_override] = ACTIONS(3950),
    [anon_sym_inherit] = ACTIONS(3950),
    [aux_sym_char_token1] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3950),
    [anon_sym_DQUOTE] = ACTIONS(3950),
    [anon_sym_AT_DQUOTE] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [sym_bool] = ACTIONS(3950),
    [sym_unit] = ACTIONS(3948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3950),
    [sym_op_identifier] = ACTIONS(3950),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_DASH] = ACTIONS(3950),
    [anon_sym_PLUS_DOT] = ACTIONS(3950),
    [anon_sym_DASH_DOT] = ACTIONS(3950),
    [anon_sym_PERCENT] = ACTIONS(3950),
    [anon_sym_AMP_AMP] = ACTIONS(3950),
    [anon_sym_TILDE] = ACTIONS(3948),
    [aux_sym_prefix_op_token1] = ACTIONS(3950),
    [aux_sym_infix_op_token1] = ACTIONS(3948),
    [aux_sym_infix_op_token2] = ACTIONS(3950),
    [anon_sym_PIPE_PIPE] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3950),
    [anon_sym_COLON_EQ] = ACTIONS(3948),
    [anon_sym_DOLLAR] = ACTIONS(3950),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3950),
    [sym_int] = ACTIONS(3950),
    [sym_xint] = ACTIONS(3948),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3948),
    [anon_sym_POUNDendif] = ACTIONS(3948),
    [sym__newline] = ACTIONS(3948),
  },
  [2166] = {
    [sym_block_comment] = STATE(2166),
    [sym_compiler_directive_decl] = STATE(2166),
    [sym_fsi_directive_decl] = STATE(2166),
    [sym_preproc_line] = STATE(2166),
    [aux_sym_compound_type_repeat1] = STATE(2166),
    [sym_identifier] = ACTIONS(3427),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_GT_RBRACK] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_RBRACK] = ACTIONS(3425),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_RBRACE] = ACTIONS(3425),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3427),
    [anon_sym_DOT] = ACTIONS(3427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_with] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_COLON_GT] = ACTIONS(3425),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_to] = ACTIONS(3427),
    [anon_sym_downto] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(3427),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_LT_DASH] = ACTIONS(3427),
    [anon_sym_DOT_LBRACK] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_DOT_DOT2] = ACTIONS(3425),
    [anon_sym_STAR] = ACTIONS(4773),
    [anon_sym_LT2] = ACTIONS(3427),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3425),
    [anon_sym_or] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3427),
    [anon_sym_DASH_DOT] = ACTIONS(3427),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3427),
    [aux_sym_infix_op_token1] = ACTIONS(3425),
    [aux_sym_infix_op_token2] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3427),
    [anon_sym_COLON_EQ] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3427),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
  },
  [2167] = {
    [sym_block_comment] = STATE(2167),
    [sym_compiler_directive_decl] = STATE(2167),
    [sym_fsi_directive_decl] = STATE(2167),
    [sym_preproc_line] = STATE(2167),
    [sym_identifier] = ACTIONS(3885),
    [anon_sym_EQ] = ACTIONS(3883),
    [anon_sym_LBRACK_LT] = ACTIONS(3883),
    [anon_sym_COLON] = ACTIONS(3885),
    [anon_sym_return] = ACTIONS(3885),
    [anon_sym_do] = ACTIONS(3885),
    [anon_sym_let] = ACTIONS(3885),
    [anon_sym_let_BANG] = ACTIONS(3883),
    [aux_sym_access_modifier_token1] = ACTIONS(3883),
    [anon_sym_LPAREN] = ACTIONS(3885),
    [anon_sym_COMMA] = ACTIONS(3883),
    [anon_sym_null] = ACTIONS(3885),
    [anon_sym_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3883),
    [anon_sym_AMP] = ACTIONS(3885),
    [anon_sym_LBRACK] = ACTIONS(3885),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3883),
    [anon_sym_LBRACE] = ACTIONS(3885),
    [anon_sym_LT_AT] = ACTIONS(3885),
    [anon_sym_LT_AT_AT] = ACTIONS(3885),
    [anon_sym_DOT] = ACTIONS(3885),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3883),
    [anon_sym_new] = ACTIONS(3885),
    [anon_sym_with] = ACTIONS(3885),
    [anon_sym_return_BANG] = ACTIONS(3883),
    [anon_sym_yield] = ACTIONS(3885),
    [anon_sym_yield_BANG] = ACTIONS(3883),
    [anon_sym_lazy] = ACTIONS(3885),
    [anon_sym_assert] = ACTIONS(3885),
    [anon_sym_upcast] = ACTIONS(3885),
    [anon_sym_downcast] = ACTIONS(3885),
    [anon_sym_COLON_GT] = ACTIONS(3883),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3883),
    [anon_sym_for] = ACTIONS(3885),
    [anon_sym_while] = ACTIONS(3885),
    [anon_sym_if] = ACTIONS(3885),
    [anon_sym_fun] = ACTIONS(3885),
    [anon_sym_try] = ACTIONS(3885),
    [anon_sym_match] = ACTIONS(3885),
    [anon_sym_match_BANG] = ACTIONS(3883),
    [anon_sym_function] = ACTIONS(3885),
    [anon_sym_LT_DASH] = ACTIONS(3885),
    [anon_sym_DOT_LBRACK] = ACTIONS(3883),
    [anon_sym_LT] = ACTIONS(3883),
    [anon_sym_use] = ACTIONS(3885),
    [anon_sym_use_BANG] = ACTIONS(3883),
    [anon_sym_do_BANG] = ACTIONS(3883),
    [anon_sym_begin] = ACTIONS(3885),
    [anon_sym_LPAREN2] = ACTIONS(3885),
    [anon_sym_default] = ACTIONS(3885),
    [anon_sym_or] = ACTIONS(3885),
    [anon_sym_static] = ACTIONS(3885),
    [anon_sym_member] = ACTIONS(3885),
    [anon_sym_interface] = ACTIONS(3885),
    [anon_sym_abstract] = ACTIONS(3885),
    [anon_sym_val] = ACTIONS(3885),
    [anon_sym_override] = ACTIONS(3885),
    [anon_sym_inherit] = ACTIONS(3885),
    [aux_sym_char_token1] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3885),
    [anon_sym_DQUOTE] = ACTIONS(3885),
    [anon_sym_AT_DQUOTE] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [sym_bool] = ACTIONS(3885),
    [sym_unit] = ACTIONS(3883),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3885),
    [sym_op_identifier] = ACTIONS(3885),
    [anon_sym_PLUS] = ACTIONS(3885),
    [anon_sym_DASH] = ACTIONS(3885),
    [anon_sym_PLUS_DOT] = ACTIONS(3885),
    [anon_sym_DASH_DOT] = ACTIONS(3885),
    [anon_sym_PERCENT] = ACTIONS(3885),
    [anon_sym_AMP_AMP] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3883),
    [aux_sym_prefix_op_token1] = ACTIONS(3885),
    [aux_sym_infix_op_token1] = ACTIONS(3883),
    [aux_sym_infix_op_token2] = ACTIONS(3885),
    [anon_sym_PIPE_PIPE] = ACTIONS(3885),
    [anon_sym_BANG_EQ] = ACTIONS(3885),
    [anon_sym_COLON_EQ] = ACTIONS(3883),
    [anon_sym_DOLLAR] = ACTIONS(3885),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3885),
    [sym_int] = ACTIONS(3885),
    [sym_xint] = ACTIONS(3883),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3883),
    [anon_sym_POUNDendif] = ACTIONS(3883),
    [sym__newline] = ACTIONS(3883),
  },
  [2168] = {
    [sym_block_comment] = STATE(2168),
    [sym_compiler_directive_decl] = STATE(2168),
    [sym_fsi_directive_decl] = STATE(2168),
    [sym_preproc_line] = STATE(2168),
    [sym_identifier] = ACTIONS(3931),
    [anon_sym_EQ] = ACTIONS(3929),
    [anon_sym_LBRACK_LT] = ACTIONS(3929),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_do] = ACTIONS(3931),
    [anon_sym_and] = ACTIONS(3931),
    [anon_sym_let] = ACTIONS(3931),
    [anon_sym_let_BANG] = ACTIONS(3929),
    [aux_sym_access_modifier_token1] = ACTIONS(3929),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_COMMA] = ACTIONS(3929),
    [anon_sym_null] = ACTIONS(3931),
    [anon_sym_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_COLON] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3931),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_LT_AT] = ACTIONS(3931),
    [anon_sym_LT_AT_AT] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3931),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3929),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3931),
    [anon_sym_return_BANG] = ACTIONS(3929),
    [anon_sym_yield] = ACTIONS(3931),
    [anon_sym_yield_BANG] = ACTIONS(3929),
    [anon_sym_lazy] = ACTIONS(3931),
    [anon_sym_assert] = ACTIONS(3931),
    [anon_sym_upcast] = ACTIONS(3931),
    [anon_sym_downcast] = ACTIONS(3931),
    [anon_sym_COLON_GT] = ACTIONS(3929),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3929),
    [anon_sym_for] = ACTIONS(3931),
    [anon_sym_while] = ACTIONS(3931),
    [anon_sym_if] = ACTIONS(3931),
    [anon_sym_fun] = ACTIONS(3931),
    [anon_sym_try] = ACTIONS(3931),
    [anon_sym_match] = ACTIONS(3931),
    [anon_sym_match_BANG] = ACTIONS(3929),
    [anon_sym_function] = ACTIONS(3931),
    [anon_sym_LT_DASH] = ACTIONS(3931),
    [anon_sym_DOT_LBRACK] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_use] = ACTIONS(3931),
    [anon_sym_use_BANG] = ACTIONS(3929),
    [anon_sym_do_BANG] = ACTIONS(3929),
    [anon_sym_begin] = ACTIONS(3931),
    [anon_sym_LPAREN2] = ACTIONS(3931),
    [anon_sym_default] = ACTIONS(3931),
    [anon_sym_or] = ACTIONS(3931),
    [anon_sym_static] = ACTIONS(3931),
    [anon_sym_member] = ACTIONS(3931),
    [anon_sym_interface] = ACTIONS(3931),
    [anon_sym_abstract] = ACTIONS(3931),
    [anon_sym_val] = ACTIONS(3931),
    [anon_sym_override] = ACTIONS(3931),
    [aux_sym_char_token1] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3931),
    [anon_sym_DQUOTE] = ACTIONS(3931),
    [anon_sym_AT_DQUOTE] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [sym_bool] = ACTIONS(3931),
    [sym_unit] = ACTIONS(3929),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3931),
    [sym_op_identifier] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3931),
    [anon_sym_DASH] = ACTIONS(3931),
    [anon_sym_PLUS_DOT] = ACTIONS(3931),
    [anon_sym_DASH_DOT] = ACTIONS(3931),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_TILDE] = ACTIONS(3929),
    [aux_sym_prefix_op_token1] = ACTIONS(3931),
    [aux_sym_infix_op_token1] = ACTIONS(3929),
    [aux_sym_infix_op_token2] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_COLON_EQ] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3931),
    [sym_int] = ACTIONS(3931),
    [sym_xint] = ACTIONS(3929),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3929),
    [sym__newline] = ACTIONS(3929),
    [sym__dedent] = ACTIONS(3929),
  },
  [2169] = {
    [sym_block_comment] = STATE(2169),
    [sym_compiler_directive_decl] = STATE(2169),
    [sym_fsi_directive_decl] = STATE(2169),
    [sym_preproc_line] = STATE(2169),
    [sym_identifier] = ACTIONS(3907),
    [anon_sym_EQ] = ACTIONS(3905),
    [anon_sym_LBRACK_LT] = ACTIONS(3905),
    [anon_sym_COLON] = ACTIONS(3907),
    [anon_sym_return] = ACTIONS(3907),
    [anon_sym_do] = ACTIONS(3907),
    [anon_sym_let] = ACTIONS(3907),
    [anon_sym_let_BANG] = ACTIONS(3905),
    [aux_sym_access_modifier_token1] = ACTIONS(3905),
    [anon_sym_LPAREN] = ACTIONS(3907),
    [anon_sym_COMMA] = ACTIONS(3905),
    [anon_sym_null] = ACTIONS(3907),
    [anon_sym_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_COLON] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3907),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3905),
    [anon_sym_LBRACE] = ACTIONS(3907),
    [anon_sym_LT_AT] = ACTIONS(3907),
    [anon_sym_LT_AT_AT] = ACTIONS(3907),
    [anon_sym_DOT] = ACTIONS(3907),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3905),
    [anon_sym_new] = ACTIONS(3907),
    [anon_sym_with] = ACTIONS(3907),
    [anon_sym_return_BANG] = ACTIONS(3905),
    [anon_sym_yield] = ACTIONS(3907),
    [anon_sym_yield_BANG] = ACTIONS(3905),
    [anon_sym_lazy] = ACTIONS(3907),
    [anon_sym_assert] = ACTIONS(3907),
    [anon_sym_upcast] = ACTIONS(3907),
    [anon_sym_downcast] = ACTIONS(3907),
    [anon_sym_COLON_GT] = ACTIONS(3905),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3905),
    [anon_sym_for] = ACTIONS(3907),
    [anon_sym_while] = ACTIONS(3907),
    [anon_sym_if] = ACTIONS(3907),
    [anon_sym_fun] = ACTIONS(3907),
    [anon_sym_try] = ACTIONS(3907),
    [anon_sym_match] = ACTIONS(3907),
    [anon_sym_match_BANG] = ACTIONS(3905),
    [anon_sym_function] = ACTIONS(3907),
    [anon_sym_LT_DASH] = ACTIONS(3907),
    [anon_sym_DOT_LBRACK] = ACTIONS(3905),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_use] = ACTIONS(3907),
    [anon_sym_use_BANG] = ACTIONS(3905),
    [anon_sym_do_BANG] = ACTIONS(3905),
    [anon_sym_begin] = ACTIONS(3907),
    [anon_sym_LPAREN2] = ACTIONS(3907),
    [anon_sym_default] = ACTIONS(3907),
    [anon_sym_or] = ACTIONS(3907),
    [anon_sym_static] = ACTIONS(3907),
    [anon_sym_member] = ACTIONS(3907),
    [anon_sym_interface] = ACTIONS(3907),
    [anon_sym_abstract] = ACTIONS(3907),
    [anon_sym_val] = ACTIONS(3907),
    [anon_sym_override] = ACTIONS(3907),
    [anon_sym_inherit] = ACTIONS(3907),
    [aux_sym_char_token1] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3907),
    [anon_sym_DQUOTE] = ACTIONS(3907),
    [anon_sym_AT_DQUOTE] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [sym_bool] = ACTIONS(3907),
    [sym_unit] = ACTIONS(3905),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3907),
    [sym_op_identifier] = ACTIONS(3907),
    [anon_sym_PLUS] = ACTIONS(3907),
    [anon_sym_DASH] = ACTIONS(3907),
    [anon_sym_PLUS_DOT] = ACTIONS(3907),
    [anon_sym_DASH_DOT] = ACTIONS(3907),
    [anon_sym_PERCENT] = ACTIONS(3907),
    [anon_sym_AMP_AMP] = ACTIONS(3907),
    [anon_sym_TILDE] = ACTIONS(3905),
    [aux_sym_prefix_op_token1] = ACTIONS(3907),
    [aux_sym_infix_op_token1] = ACTIONS(3905),
    [aux_sym_infix_op_token2] = ACTIONS(3907),
    [anon_sym_PIPE_PIPE] = ACTIONS(3907),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_COLON_EQ] = ACTIONS(3905),
    [anon_sym_DOLLAR] = ACTIONS(3907),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3907),
    [sym_int] = ACTIONS(3907),
    [sym_xint] = ACTIONS(3905),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3905),
    [anon_sym_POUNDendif] = ACTIONS(3905),
    [sym__newline] = ACTIONS(3905),
  },
  [2170] = {
    [sym_block_comment] = STATE(2170),
    [sym_compiler_directive_decl] = STATE(2170),
    [sym_fsi_directive_decl] = STATE(2170),
    [sym_preproc_line] = STATE(2170),
    [sym_identifier] = ACTIONS(3875),
    [anon_sym_EQ] = ACTIONS(3873),
    [anon_sym_LBRACK_LT] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(3875),
    [anon_sym_return] = ACTIONS(3875),
    [anon_sym_do] = ACTIONS(3875),
    [anon_sym_let] = ACTIONS(3875),
    [anon_sym_let_BANG] = ACTIONS(3873),
    [aux_sym_access_modifier_token1] = ACTIONS(3873),
    [anon_sym_LPAREN] = ACTIONS(3875),
    [anon_sym_COMMA] = ACTIONS(3873),
    [anon_sym_null] = ACTIONS(3875),
    [anon_sym_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_COLON] = ACTIONS(3873),
    [anon_sym_AMP] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(3875),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3873),
    [anon_sym_LBRACE] = ACTIONS(3875),
    [anon_sym_LT_AT] = ACTIONS(3875),
    [anon_sym_LT_AT_AT] = ACTIONS(3875),
    [anon_sym_DOT] = ACTIONS(3875),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3873),
    [anon_sym_new] = ACTIONS(3875),
    [anon_sym_with] = ACTIONS(3875),
    [anon_sym_return_BANG] = ACTIONS(3873),
    [anon_sym_yield] = ACTIONS(3875),
    [anon_sym_yield_BANG] = ACTIONS(3873),
    [anon_sym_lazy] = ACTIONS(3875),
    [anon_sym_assert] = ACTIONS(3875),
    [anon_sym_upcast] = ACTIONS(3875),
    [anon_sym_downcast] = ACTIONS(3875),
    [anon_sym_COLON_GT] = ACTIONS(3873),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3873),
    [anon_sym_for] = ACTIONS(3875),
    [anon_sym_while] = ACTIONS(3875),
    [anon_sym_if] = ACTIONS(3875),
    [anon_sym_fun] = ACTIONS(3875),
    [anon_sym_try] = ACTIONS(3875),
    [anon_sym_match] = ACTIONS(3875),
    [anon_sym_match_BANG] = ACTIONS(3873),
    [anon_sym_function] = ACTIONS(3875),
    [anon_sym_LT_DASH] = ACTIONS(3875),
    [anon_sym_DOT_LBRACK] = ACTIONS(3873),
    [anon_sym_LT] = ACTIONS(3873),
    [anon_sym_use] = ACTIONS(3875),
    [anon_sym_use_BANG] = ACTIONS(3873),
    [anon_sym_do_BANG] = ACTIONS(3873),
    [anon_sym_begin] = ACTIONS(3875),
    [anon_sym_LPAREN2] = ACTIONS(3875),
    [anon_sym_DOT_DOT2] = ACTIONS(3873),
    [anon_sym_default] = ACTIONS(3875),
    [anon_sym_or] = ACTIONS(3875),
    [anon_sym_static] = ACTIONS(3875),
    [anon_sym_member] = ACTIONS(3875),
    [anon_sym_interface] = ACTIONS(3875),
    [anon_sym_abstract] = ACTIONS(3875),
    [anon_sym_val] = ACTIONS(3875),
    [anon_sym_override] = ACTIONS(3875),
    [aux_sym_char_token1] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3875),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [anon_sym_AT_DQUOTE] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [sym_bool] = ACTIONS(3875),
    [sym_unit] = ACTIONS(3873),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3875),
    [sym_op_identifier] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS_DOT] = ACTIONS(3875),
    [anon_sym_DASH_DOT] = ACTIONS(3875),
    [anon_sym_PERCENT] = ACTIONS(3875),
    [anon_sym_AMP_AMP] = ACTIONS(3875),
    [anon_sym_TILDE] = ACTIONS(3873),
    [aux_sym_prefix_op_token1] = ACTIONS(3875),
    [aux_sym_infix_op_token1] = ACTIONS(3873),
    [aux_sym_infix_op_token2] = ACTIONS(3875),
    [anon_sym_PIPE_PIPE] = ACTIONS(3875),
    [anon_sym_BANG_EQ] = ACTIONS(3875),
    [anon_sym_COLON_EQ] = ACTIONS(3873),
    [anon_sym_DOLLAR] = ACTIONS(3875),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3875),
    [sym_int] = ACTIONS(3875),
    [sym_xint] = ACTIONS(3873),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3873),
    [sym__newline] = ACTIONS(3873),
    [sym__dedent] = ACTIONS(3873),
  },
  [2171] = {
    [sym_block_comment] = STATE(2171),
    [sym_compiler_directive_decl] = STATE(2171),
    [sym_fsi_directive_decl] = STATE(2171),
    [sym_preproc_line] = STATE(2171),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_LBRACK_LT] = ACTIONS(3865),
    [anon_sym_COLON] = ACTIONS(3867),
    [anon_sym_return] = ACTIONS(3867),
    [anon_sym_do] = ACTIONS(3867),
    [anon_sym_let] = ACTIONS(3867),
    [anon_sym_let_BANG] = ACTIONS(3865),
    [aux_sym_access_modifier_token1] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(3867),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_null] = ACTIONS(3867),
    [anon_sym_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_COLON] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3867),
    [anon_sym_LBRACK] = ACTIONS(3867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3867),
    [anon_sym_LT_AT] = ACTIONS(3867),
    [anon_sym_LT_AT_AT] = ACTIONS(3867),
    [anon_sym_DOT] = ACTIONS(3867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3867),
    [anon_sym_with] = ACTIONS(3867),
    [anon_sym_return_BANG] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3867),
    [anon_sym_yield_BANG] = ACTIONS(3865),
    [anon_sym_lazy] = ACTIONS(3867),
    [anon_sym_assert] = ACTIONS(3867),
    [anon_sym_upcast] = ACTIONS(3867),
    [anon_sym_downcast] = ACTIONS(3867),
    [anon_sym_COLON_GT] = ACTIONS(3865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3867),
    [anon_sym_while] = ACTIONS(3867),
    [anon_sym_if] = ACTIONS(3867),
    [anon_sym_fun] = ACTIONS(3867),
    [anon_sym_try] = ACTIONS(3867),
    [anon_sym_match] = ACTIONS(3867),
    [anon_sym_match_BANG] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(3867),
    [anon_sym_DOT_LBRACK] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_use] = ACTIONS(3867),
    [anon_sym_use_BANG] = ACTIONS(3865),
    [anon_sym_do_BANG] = ACTIONS(3865),
    [anon_sym_begin] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(3867),
    [anon_sym_DOT_DOT2] = ACTIONS(3865),
    [anon_sym_default] = ACTIONS(3867),
    [anon_sym_or] = ACTIONS(3867),
    [anon_sym_static] = ACTIONS(3867),
    [anon_sym_member] = ACTIONS(3867),
    [anon_sym_interface] = ACTIONS(3867),
    [anon_sym_abstract] = ACTIONS(3867),
    [anon_sym_val] = ACTIONS(3867),
    [anon_sym_override] = ACTIONS(3867),
    [aux_sym_char_token1] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3867),
    [anon_sym_DQUOTE] = ACTIONS(3867),
    [anon_sym_AT_DQUOTE] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [sym_bool] = ACTIONS(3867),
    [sym_unit] = ACTIONS(3865),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3867),
    [sym_op_identifier] = ACTIONS(3867),
    [anon_sym_PLUS] = ACTIONS(3867),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_PLUS_DOT] = ACTIONS(3867),
    [anon_sym_DASH_DOT] = ACTIONS(3867),
    [anon_sym_PERCENT] = ACTIONS(3867),
    [anon_sym_AMP_AMP] = ACTIONS(3867),
    [anon_sym_TILDE] = ACTIONS(3865),
    [aux_sym_prefix_op_token1] = ACTIONS(3867),
    [aux_sym_infix_op_token1] = ACTIONS(3865),
    [aux_sym_infix_op_token2] = ACTIONS(3867),
    [anon_sym_PIPE_PIPE] = ACTIONS(3867),
    [anon_sym_BANG_EQ] = ACTIONS(3867),
    [anon_sym_COLON_EQ] = ACTIONS(3865),
    [anon_sym_DOLLAR] = ACTIONS(3867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3867),
    [sym_int] = ACTIONS(3867),
    [sym_xint] = ACTIONS(3865),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3865),
    [sym__newline] = ACTIONS(3865),
    [sym__dedent] = ACTIONS(3865),
  },
  [2172] = {
    [sym_block_comment] = STATE(2172),
    [sym_compiler_directive_decl] = STATE(2172),
    [sym_fsi_directive_decl] = STATE(2172),
    [sym_preproc_line] = STATE(2172),
    [sym_identifier] = ACTIONS(3900),
    [anon_sym_EQ] = ACTIONS(3898),
    [anon_sym_LBRACK_LT] = ACTIONS(3898),
    [anon_sym_COLON] = ACTIONS(3900),
    [anon_sym_return] = ACTIONS(3900),
    [anon_sym_do] = ACTIONS(3900),
    [anon_sym_let] = ACTIONS(3900),
    [anon_sym_let_BANG] = ACTIONS(3898),
    [aux_sym_access_modifier_token1] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3898),
    [anon_sym_null] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_COLON] = ACTIONS(3898),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_LBRACK] = ACTIONS(3900),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3898),
    [anon_sym_LBRACE] = ACTIONS(3900),
    [anon_sym_LT_AT] = ACTIONS(3900),
    [anon_sym_LT_AT_AT] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(3900),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3898),
    [anon_sym_new] = ACTIONS(3900),
    [anon_sym_with] = ACTIONS(3900),
    [anon_sym_return_BANG] = ACTIONS(3898),
    [anon_sym_yield] = ACTIONS(3900),
    [anon_sym_yield_BANG] = ACTIONS(3898),
    [anon_sym_lazy] = ACTIONS(3900),
    [anon_sym_assert] = ACTIONS(3900),
    [anon_sym_upcast] = ACTIONS(3900),
    [anon_sym_downcast] = ACTIONS(3900),
    [anon_sym_COLON_GT] = ACTIONS(3898),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3898),
    [anon_sym_for] = ACTIONS(3900),
    [anon_sym_while] = ACTIONS(3900),
    [anon_sym_if] = ACTIONS(3900),
    [anon_sym_fun] = ACTIONS(3900),
    [anon_sym_try] = ACTIONS(3900),
    [anon_sym_match] = ACTIONS(3900),
    [anon_sym_match_BANG] = ACTIONS(3898),
    [anon_sym_function] = ACTIONS(3900),
    [anon_sym_LT_DASH] = ACTIONS(3900),
    [anon_sym_DOT_LBRACK] = ACTIONS(3898),
    [anon_sym_LT] = ACTIONS(3898),
    [anon_sym_use] = ACTIONS(3900),
    [anon_sym_use_BANG] = ACTIONS(3898),
    [anon_sym_do_BANG] = ACTIONS(3898),
    [anon_sym_begin] = ACTIONS(3900),
    [anon_sym_LPAREN2] = ACTIONS(3900),
    [anon_sym_default] = ACTIONS(3900),
    [anon_sym_or] = ACTIONS(3900),
    [anon_sym_static] = ACTIONS(3900),
    [anon_sym_member] = ACTIONS(3900),
    [anon_sym_interface] = ACTIONS(3900),
    [anon_sym_abstract] = ACTIONS(3900),
    [anon_sym_val] = ACTIONS(3900),
    [anon_sym_override] = ACTIONS(3900),
    [anon_sym_inherit] = ACTIONS(3900),
    [aux_sym_char_token1] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3900),
    [anon_sym_DQUOTE] = ACTIONS(3900),
    [anon_sym_AT_DQUOTE] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3898),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3900),
    [sym_op_identifier] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(3900),
    [anon_sym_DASH] = ACTIONS(3900),
    [anon_sym_PLUS_DOT] = ACTIONS(3900),
    [anon_sym_DASH_DOT] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(3900),
    [anon_sym_AMP_AMP] = ACTIONS(3900),
    [anon_sym_TILDE] = ACTIONS(3898),
    [aux_sym_prefix_op_token1] = ACTIONS(3900),
    [aux_sym_infix_op_token1] = ACTIONS(3898),
    [aux_sym_infix_op_token2] = ACTIONS(3900),
    [anon_sym_PIPE_PIPE] = ACTIONS(3900),
    [anon_sym_BANG_EQ] = ACTIONS(3900),
    [anon_sym_COLON_EQ] = ACTIONS(3898),
    [anon_sym_DOLLAR] = ACTIONS(3900),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3900),
    [sym_int] = ACTIONS(3900),
    [sym_xint] = ACTIONS(3898),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3898),
    [anon_sym_POUNDendif] = ACTIONS(3898),
    [sym__newline] = ACTIONS(3898),
  },
  [2173] = {
    [sym_block_comment] = STATE(2173),
    [sym_compiler_directive_decl] = STATE(2173),
    [sym_fsi_directive_decl] = STATE(2173),
    [sym_preproc_line] = STATE(2173),
    [sym_identifier] = ACTIONS(4130),
    [anon_sym_EQ] = ACTIONS(4128),
    [anon_sym_LBRACK_LT] = ACTIONS(4128),
    [anon_sym_COLON] = ACTIONS(4130),
    [anon_sym_return] = ACTIONS(4130),
    [anon_sym_do] = ACTIONS(4130),
    [anon_sym_let] = ACTIONS(4130),
    [anon_sym_let_BANG] = ACTIONS(4128),
    [aux_sym_access_modifier_token1] = ACTIONS(4128),
    [anon_sym_LPAREN] = ACTIONS(4130),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_null] = ACTIONS(4130),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_COLON] = ACTIONS(4128),
    [anon_sym_AMP] = ACTIONS(4130),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4128),
    [anon_sym_LBRACE] = ACTIONS(4130),
    [anon_sym_LT_AT] = ACTIONS(4130),
    [anon_sym_LT_AT_AT] = ACTIONS(4130),
    [anon_sym_DOT] = ACTIONS(4130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4128),
    [anon_sym_new] = ACTIONS(4130),
    [anon_sym_with] = ACTIONS(4130),
    [anon_sym_return_BANG] = ACTIONS(4128),
    [anon_sym_yield] = ACTIONS(4130),
    [anon_sym_yield_BANG] = ACTIONS(4128),
    [anon_sym_lazy] = ACTIONS(4130),
    [anon_sym_assert] = ACTIONS(4130),
    [anon_sym_upcast] = ACTIONS(4130),
    [anon_sym_downcast] = ACTIONS(4130),
    [anon_sym_COLON_GT] = ACTIONS(4128),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4128),
    [anon_sym_for] = ACTIONS(4130),
    [anon_sym_while] = ACTIONS(4130),
    [anon_sym_if] = ACTIONS(4130),
    [anon_sym_fun] = ACTIONS(4130),
    [anon_sym_try] = ACTIONS(4130),
    [anon_sym_match] = ACTIONS(4130),
    [anon_sym_match_BANG] = ACTIONS(4128),
    [anon_sym_function] = ACTIONS(4130),
    [anon_sym_LT_DASH] = ACTIONS(4130),
    [anon_sym_DOT_LBRACK] = ACTIONS(4128),
    [anon_sym_LT] = ACTIONS(4128),
    [anon_sym_use] = ACTIONS(4130),
    [anon_sym_use_BANG] = ACTIONS(4128),
    [anon_sym_do_BANG] = ACTIONS(4128),
    [anon_sym_begin] = ACTIONS(4130),
    [anon_sym_LPAREN2] = ACTIONS(4130),
    [anon_sym_default] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_static] = ACTIONS(4130),
    [anon_sym_member] = ACTIONS(4130),
    [anon_sym_interface] = ACTIONS(4130),
    [anon_sym_abstract] = ACTIONS(4130),
    [anon_sym_val] = ACTIONS(4130),
    [anon_sym_override] = ACTIONS(4130),
    [anon_sym_inherit] = ACTIONS(4130),
    [aux_sym_char_token1] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4130),
    [anon_sym_DQUOTE] = ACTIONS(4130),
    [anon_sym_AT_DQUOTE] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [sym_bool] = ACTIONS(4130),
    [sym_unit] = ACTIONS(4128),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4130),
    [sym_op_identifier] = ACTIONS(4130),
    [anon_sym_PLUS] = ACTIONS(4130),
    [anon_sym_DASH] = ACTIONS(4130),
    [anon_sym_PLUS_DOT] = ACTIONS(4130),
    [anon_sym_DASH_DOT] = ACTIONS(4130),
    [anon_sym_PERCENT] = ACTIONS(4130),
    [anon_sym_AMP_AMP] = ACTIONS(4130),
    [anon_sym_TILDE] = ACTIONS(4128),
    [aux_sym_prefix_op_token1] = ACTIONS(4130),
    [aux_sym_infix_op_token1] = ACTIONS(4128),
    [aux_sym_infix_op_token2] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE] = ACTIONS(4130),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_COLON_EQ] = ACTIONS(4128),
    [anon_sym_DOLLAR] = ACTIONS(4130),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4130),
    [sym_int] = ACTIONS(4130),
    [sym_xint] = ACTIONS(4128),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4128),
    [anon_sym_POUNDendif] = ACTIONS(4128),
    [sym__newline] = ACTIONS(4128),
  },
  [2174] = {
    [sym_block_comment] = STATE(2174),
    [sym_compiler_directive_decl] = STATE(2174),
    [sym_fsi_directive_decl] = STATE(2174),
    [sym_preproc_line] = STATE(2174),
    [sym_identifier] = ACTIONS(3893),
    [anon_sym_EQ] = ACTIONS(3891),
    [anon_sym_LBRACK_LT] = ACTIONS(3891),
    [anon_sym_COLON] = ACTIONS(3893),
    [anon_sym_return] = ACTIONS(3893),
    [anon_sym_do] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_let_BANG] = ACTIONS(3891),
    [aux_sym_access_modifier_token1] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_COMMA] = ACTIONS(3891),
    [anon_sym_null] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_COLON] = ACTIONS(3891),
    [anon_sym_AMP] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3891),
    [anon_sym_LBRACE] = ACTIONS(3893),
    [anon_sym_LT_AT] = ACTIONS(3893),
    [anon_sym_LT_AT_AT] = ACTIONS(3893),
    [anon_sym_DOT] = ACTIONS(3893),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3891),
    [anon_sym_new] = ACTIONS(3893),
    [anon_sym_with] = ACTIONS(3893),
    [anon_sym_return_BANG] = ACTIONS(3891),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_yield_BANG] = ACTIONS(3891),
    [anon_sym_lazy] = ACTIONS(3893),
    [anon_sym_assert] = ACTIONS(3893),
    [anon_sym_upcast] = ACTIONS(3893),
    [anon_sym_downcast] = ACTIONS(3893),
    [anon_sym_COLON_GT] = ACTIONS(3891),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3891),
    [anon_sym_for] = ACTIONS(3893),
    [anon_sym_while] = ACTIONS(3893),
    [anon_sym_if] = ACTIONS(3893),
    [anon_sym_fun] = ACTIONS(3893),
    [anon_sym_try] = ACTIONS(3893),
    [anon_sym_match] = ACTIONS(3893),
    [anon_sym_match_BANG] = ACTIONS(3891),
    [anon_sym_function] = ACTIONS(3893),
    [anon_sym_LT_DASH] = ACTIONS(3893),
    [anon_sym_DOT_LBRACK] = ACTIONS(3891),
    [anon_sym_LT] = ACTIONS(3891),
    [anon_sym_use] = ACTIONS(3893),
    [anon_sym_use_BANG] = ACTIONS(3891),
    [anon_sym_do_BANG] = ACTIONS(3891),
    [anon_sym_begin] = ACTIONS(3893),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_default] = ACTIONS(3893),
    [anon_sym_or] = ACTIONS(3893),
    [anon_sym_static] = ACTIONS(3893),
    [anon_sym_member] = ACTIONS(3893),
    [anon_sym_interface] = ACTIONS(3893),
    [anon_sym_abstract] = ACTIONS(3893),
    [anon_sym_val] = ACTIONS(3893),
    [anon_sym_override] = ACTIONS(3893),
    [anon_sym_inherit] = ACTIONS(3893),
    [aux_sym_char_token1] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3893),
    [anon_sym_DQUOTE] = ACTIONS(3893),
    [anon_sym_AT_DQUOTE] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [sym_bool] = ACTIONS(3893),
    [sym_unit] = ACTIONS(3891),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3893),
    [sym_op_identifier] = ACTIONS(3893),
    [anon_sym_PLUS] = ACTIONS(3893),
    [anon_sym_DASH] = ACTIONS(3893),
    [anon_sym_PLUS_DOT] = ACTIONS(3893),
    [anon_sym_DASH_DOT] = ACTIONS(3893),
    [anon_sym_PERCENT] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_TILDE] = ACTIONS(3891),
    [aux_sym_prefix_op_token1] = ACTIONS(3893),
    [aux_sym_infix_op_token1] = ACTIONS(3891),
    [aux_sym_infix_op_token2] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [anon_sym_BANG_EQ] = ACTIONS(3893),
    [anon_sym_COLON_EQ] = ACTIONS(3891),
    [anon_sym_DOLLAR] = ACTIONS(3893),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3893),
    [sym_int] = ACTIONS(3893),
    [sym_xint] = ACTIONS(3891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3891),
    [anon_sym_POUNDendif] = ACTIONS(3891),
    [sym__newline] = ACTIONS(3891),
  },
  [2175] = {
    [sym_block_comment] = STATE(2175),
    [sym_compiler_directive_decl] = STATE(2175),
    [sym_fsi_directive_decl] = STATE(2175),
    [sym_preproc_line] = STATE(2175),
    [sym_identifier] = ACTIONS(4186),
    [anon_sym_EQ] = ACTIONS(4184),
    [anon_sym_LBRACK_LT] = ACTIONS(4184),
    [anon_sym_COLON] = ACTIONS(4186),
    [anon_sym_return] = ACTIONS(4186),
    [anon_sym_do] = ACTIONS(4186),
    [anon_sym_and] = ACTIONS(4186),
    [anon_sym_let] = ACTIONS(4186),
    [anon_sym_let_BANG] = ACTIONS(4184),
    [aux_sym_access_modifier_token1] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_COMMA] = ACTIONS(4184),
    [anon_sym_null] = ACTIONS(4186),
    [anon_sym_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_COLON] = ACTIONS(4184),
    [anon_sym_AMP] = ACTIONS(4186),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4184),
    [anon_sym_LBRACE] = ACTIONS(4186),
    [anon_sym_LT_AT] = ACTIONS(4186),
    [anon_sym_LT_AT_AT] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4186),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4184),
    [anon_sym_new] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4186),
    [anon_sym_return_BANG] = ACTIONS(4184),
    [anon_sym_yield] = ACTIONS(4186),
    [anon_sym_yield_BANG] = ACTIONS(4184),
    [anon_sym_lazy] = ACTIONS(4186),
    [anon_sym_assert] = ACTIONS(4186),
    [anon_sym_upcast] = ACTIONS(4186),
    [anon_sym_downcast] = ACTIONS(4186),
    [anon_sym_COLON_GT] = ACTIONS(4184),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4184),
    [anon_sym_for] = ACTIONS(4186),
    [anon_sym_while] = ACTIONS(4186),
    [anon_sym_if] = ACTIONS(4186),
    [anon_sym_fun] = ACTIONS(4186),
    [anon_sym_try] = ACTIONS(4186),
    [anon_sym_match] = ACTIONS(4186),
    [anon_sym_match_BANG] = ACTIONS(4184),
    [anon_sym_function] = ACTIONS(4186),
    [anon_sym_LT_DASH] = ACTIONS(4186),
    [anon_sym_DOT_LBRACK] = ACTIONS(4184),
    [anon_sym_LT] = ACTIONS(4184),
    [anon_sym_use] = ACTIONS(4186),
    [anon_sym_use_BANG] = ACTIONS(4184),
    [anon_sym_do_BANG] = ACTIONS(4184),
    [anon_sym_begin] = ACTIONS(4186),
    [anon_sym_LPAREN2] = ACTIONS(4186),
    [anon_sym_default] = ACTIONS(4186),
    [anon_sym_or] = ACTIONS(4186),
    [anon_sym_static] = ACTIONS(4186),
    [anon_sym_member] = ACTIONS(4186),
    [anon_sym_interface] = ACTIONS(4186),
    [anon_sym_abstract] = ACTIONS(4186),
    [anon_sym_val] = ACTIONS(4186),
    [anon_sym_override] = ACTIONS(4186),
    [aux_sym_char_token1] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4186),
    [anon_sym_DQUOTE] = ACTIONS(4186),
    [anon_sym_AT_DQUOTE] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [sym_bool] = ACTIONS(4186),
    [sym_unit] = ACTIONS(4184),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4186),
    [sym_op_identifier] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4186),
    [anon_sym_DASH] = ACTIONS(4186),
    [anon_sym_PLUS_DOT] = ACTIONS(4186),
    [anon_sym_DASH_DOT] = ACTIONS(4186),
    [anon_sym_PERCENT] = ACTIONS(4186),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_TILDE] = ACTIONS(4184),
    [aux_sym_prefix_op_token1] = ACTIONS(4186),
    [aux_sym_infix_op_token1] = ACTIONS(4184),
    [aux_sym_infix_op_token2] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_COLON_EQ] = ACTIONS(4184),
    [anon_sym_DOLLAR] = ACTIONS(4186),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4186),
    [sym_int] = ACTIONS(4186),
    [sym_xint] = ACTIONS(4184),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4184),
    [sym__newline] = ACTIONS(4184),
    [sym__dedent] = ACTIONS(4184),
  },
  [2176] = {
    [sym_block_comment] = STATE(2176),
    [sym_compiler_directive_decl] = STATE(2176),
    [sym_fsi_directive_decl] = STATE(2176),
    [sym_preproc_line] = STATE(2176),
    [sym_identifier] = ACTIONS(3917),
    [anon_sym_EQ] = ACTIONS(3915),
    [anon_sym_LBRACK_LT] = ACTIONS(3915),
    [anon_sym_COLON] = ACTIONS(3917),
    [anon_sym_return] = ACTIONS(3917),
    [anon_sym_do] = ACTIONS(3917),
    [anon_sym_and] = ACTIONS(3917),
    [anon_sym_let] = ACTIONS(3917),
    [anon_sym_let_BANG] = ACTIONS(3915),
    [aux_sym_access_modifier_token1] = ACTIONS(3915),
    [anon_sym_LPAREN] = ACTIONS(3917),
    [anon_sym_COMMA] = ACTIONS(3915),
    [anon_sym_null] = ACTIONS(3917),
    [anon_sym_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_COLON] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(3917),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3915),
    [anon_sym_LBRACE] = ACTIONS(3917),
    [anon_sym_LT_AT] = ACTIONS(3917),
    [anon_sym_LT_AT_AT] = ACTIONS(3917),
    [anon_sym_DOT] = ACTIONS(3917),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3915),
    [anon_sym_new] = ACTIONS(3917),
    [anon_sym_with] = ACTIONS(3917),
    [anon_sym_return_BANG] = ACTIONS(3915),
    [anon_sym_yield] = ACTIONS(3917),
    [anon_sym_yield_BANG] = ACTIONS(3915),
    [anon_sym_lazy] = ACTIONS(3917),
    [anon_sym_assert] = ACTIONS(3917),
    [anon_sym_upcast] = ACTIONS(3917),
    [anon_sym_downcast] = ACTIONS(3917),
    [anon_sym_COLON_GT] = ACTIONS(3915),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3915),
    [anon_sym_for] = ACTIONS(3917),
    [anon_sym_while] = ACTIONS(3917),
    [anon_sym_if] = ACTIONS(3917),
    [anon_sym_fun] = ACTIONS(3917),
    [anon_sym_try] = ACTIONS(3917),
    [anon_sym_match] = ACTIONS(3917),
    [anon_sym_match_BANG] = ACTIONS(3915),
    [anon_sym_function] = ACTIONS(3917),
    [anon_sym_LT_DASH] = ACTIONS(3917),
    [anon_sym_DOT_LBRACK] = ACTIONS(3915),
    [anon_sym_LT] = ACTIONS(3915),
    [anon_sym_use] = ACTIONS(3917),
    [anon_sym_use_BANG] = ACTIONS(3915),
    [anon_sym_do_BANG] = ACTIONS(3915),
    [anon_sym_begin] = ACTIONS(3917),
    [anon_sym_LPAREN2] = ACTIONS(3917),
    [anon_sym_default] = ACTIONS(3917),
    [anon_sym_or] = ACTIONS(3917),
    [anon_sym_static] = ACTIONS(3917),
    [anon_sym_member] = ACTIONS(3917),
    [anon_sym_interface] = ACTIONS(3917),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_val] = ACTIONS(3917),
    [anon_sym_override] = ACTIONS(3917),
    [aux_sym_char_token1] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_AT_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [sym_bool] = ACTIONS(3917),
    [sym_unit] = ACTIONS(3915),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3917),
    [sym_op_identifier] = ACTIONS(3917),
    [anon_sym_PLUS] = ACTIONS(3917),
    [anon_sym_DASH] = ACTIONS(3917),
    [anon_sym_PLUS_DOT] = ACTIONS(3917),
    [anon_sym_DASH_DOT] = ACTIONS(3917),
    [anon_sym_PERCENT] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_TILDE] = ACTIONS(3915),
    [aux_sym_prefix_op_token1] = ACTIONS(3917),
    [aux_sym_infix_op_token1] = ACTIONS(3915),
    [aux_sym_infix_op_token2] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_BANG_EQ] = ACTIONS(3917),
    [anon_sym_COLON_EQ] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3917),
    [sym_int] = ACTIONS(3917),
    [sym_xint] = ACTIONS(3915),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3915),
    [sym__newline] = ACTIONS(3915),
    [sym__dedent] = ACTIONS(3915),
  },
  [2177] = {
    [sym_block_comment] = STATE(2177),
    [sym_compiler_directive_decl] = STATE(2177),
    [sym_fsi_directive_decl] = STATE(2177),
    [sym_preproc_line] = STATE(2177),
    [sym_identifier] = ACTIONS(4064),
    [anon_sym_EQ] = ACTIONS(4062),
    [anon_sym_LBRACK_LT] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4064),
    [anon_sym_return] = ACTIONS(4064),
    [anon_sym_do] = ACTIONS(4064),
    [anon_sym_and] = ACTIONS(4064),
    [anon_sym_let] = ACTIONS(4064),
    [anon_sym_let_BANG] = ACTIONS(4062),
    [aux_sym_access_modifier_token1] = ACTIONS(4062),
    [anon_sym_LPAREN] = ACTIONS(4064),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_null] = ACTIONS(4064),
    [anon_sym_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_COLON] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4062),
    [anon_sym_LBRACE] = ACTIONS(4064),
    [anon_sym_LT_AT] = ACTIONS(4064),
    [anon_sym_LT_AT_AT] = ACTIONS(4064),
    [anon_sym_DOT] = ACTIONS(4064),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4062),
    [anon_sym_new] = ACTIONS(4064),
    [anon_sym_with] = ACTIONS(4064),
    [anon_sym_return_BANG] = ACTIONS(4062),
    [anon_sym_yield] = ACTIONS(4064),
    [anon_sym_yield_BANG] = ACTIONS(4062),
    [anon_sym_lazy] = ACTIONS(4064),
    [anon_sym_assert] = ACTIONS(4064),
    [anon_sym_upcast] = ACTIONS(4064),
    [anon_sym_downcast] = ACTIONS(4064),
    [anon_sym_COLON_GT] = ACTIONS(4062),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4062),
    [anon_sym_for] = ACTIONS(4064),
    [anon_sym_while] = ACTIONS(4064),
    [anon_sym_if] = ACTIONS(4064),
    [anon_sym_fun] = ACTIONS(4064),
    [anon_sym_try] = ACTIONS(4064),
    [anon_sym_match] = ACTIONS(4064),
    [anon_sym_match_BANG] = ACTIONS(4062),
    [anon_sym_function] = ACTIONS(4064),
    [anon_sym_LT_DASH] = ACTIONS(4064),
    [anon_sym_DOT_LBRACK] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(4062),
    [anon_sym_use] = ACTIONS(4064),
    [anon_sym_use_BANG] = ACTIONS(4062),
    [anon_sym_do_BANG] = ACTIONS(4062),
    [anon_sym_begin] = ACTIONS(4064),
    [anon_sym_LPAREN2] = ACTIONS(4064),
    [anon_sym_default] = ACTIONS(4064),
    [anon_sym_or] = ACTIONS(4064),
    [anon_sym_static] = ACTIONS(4064),
    [anon_sym_member] = ACTIONS(4064),
    [anon_sym_interface] = ACTIONS(4064),
    [anon_sym_abstract] = ACTIONS(4064),
    [anon_sym_val] = ACTIONS(4064),
    [anon_sym_override] = ACTIONS(4064),
    [aux_sym_char_token1] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_AT_DQUOTE] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [sym_bool] = ACTIONS(4064),
    [sym_unit] = ACTIONS(4062),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4064),
    [sym_op_identifier] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4064),
    [anon_sym_DASH] = ACTIONS(4064),
    [anon_sym_PLUS_DOT] = ACTIONS(4064),
    [anon_sym_DASH_DOT] = ACTIONS(4064),
    [anon_sym_PERCENT] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_TILDE] = ACTIONS(4062),
    [aux_sym_prefix_op_token1] = ACTIONS(4064),
    [aux_sym_infix_op_token1] = ACTIONS(4062),
    [aux_sym_infix_op_token2] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_BANG_EQ] = ACTIONS(4064),
    [anon_sym_COLON_EQ] = ACTIONS(4062),
    [anon_sym_DOLLAR] = ACTIONS(4064),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4064),
    [sym_int] = ACTIONS(4064),
    [sym_xint] = ACTIONS(4062),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4062),
    [anon_sym_POUNDendif] = ACTIONS(4062),
    [sym__newline] = ACTIONS(4062),
  },
  [2178] = {
    [sym_block_comment] = STATE(2178),
    [sym_compiler_directive_decl] = STATE(2178),
    [sym_fsi_directive_decl] = STATE(2178),
    [sym_preproc_line] = STATE(2178),
    [aux_sym_compound_type_repeat1] = STATE(2178),
    [ts_builtin_sym_end] = ACTIONS(3425),
    [sym_identifier] = ACTIONS(3427),
    [anon_sym_namespace] = ACTIONS(3427),
    [anon_sym_module] = ACTIONS(3427),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_open] = ACTIONS(3427),
    [anon_sym_LBRACK_LT] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_type] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3427),
    [anon_sym_DOT] = ACTIONS(3427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_COLON_GT] = ACTIONS(3425),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(3427),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_LT_DASH] = ACTIONS(3427),
    [anon_sym_DOT_LBRACK] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(4776),
    [anon_sym_LT2] = ACTIONS(3427),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3425),
    [anon_sym_or] = ACTIONS(3427),
    [anon_sym_exception] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3427),
    [anon_sym_DASH_DOT] = ACTIONS(3427),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3427),
    [aux_sym_infix_op_token1] = ACTIONS(3425),
    [aux_sym_infix_op_token2] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3427),
    [anon_sym_COLON_EQ] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3427),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3425),
    [anon_sym_POUNDload] = ACTIONS(3425),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
  },
  [2179] = {
    [sym_block_comment] = STATE(2179),
    [sym_compiler_directive_decl] = STATE(2179),
    [sym_fsi_directive_decl] = STATE(2179),
    [sym_preproc_line] = STATE(2179),
    [sym_identifier] = ACTIONS(3875),
    [anon_sym_EQ] = ACTIONS(3873),
    [anon_sym_LBRACK_LT] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(3875),
    [anon_sym_return] = ACTIONS(3875),
    [anon_sym_do] = ACTIONS(3875),
    [anon_sym_let] = ACTIONS(3875),
    [anon_sym_let_BANG] = ACTIONS(3873),
    [aux_sym_access_modifier_token1] = ACTIONS(3873),
    [anon_sym_LPAREN] = ACTIONS(3875),
    [anon_sym_COMMA] = ACTIONS(3873),
    [anon_sym_null] = ACTIONS(3875),
    [anon_sym_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_COLON] = ACTIONS(3873),
    [anon_sym_AMP] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(3875),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3873),
    [anon_sym_LBRACE] = ACTIONS(3875),
    [anon_sym_LT_AT] = ACTIONS(3875),
    [anon_sym_LT_AT_AT] = ACTIONS(3875),
    [anon_sym_DOT] = ACTIONS(3875),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3873),
    [anon_sym_new] = ACTIONS(3875),
    [anon_sym_with] = ACTIONS(3875),
    [anon_sym_return_BANG] = ACTIONS(3873),
    [anon_sym_yield] = ACTIONS(3875),
    [anon_sym_yield_BANG] = ACTIONS(3873),
    [anon_sym_lazy] = ACTIONS(3875),
    [anon_sym_assert] = ACTIONS(3875),
    [anon_sym_upcast] = ACTIONS(3875),
    [anon_sym_downcast] = ACTIONS(3875),
    [anon_sym_COLON_GT] = ACTIONS(3873),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3873),
    [anon_sym_for] = ACTIONS(3875),
    [anon_sym_while] = ACTIONS(3875),
    [anon_sym_if] = ACTIONS(3875),
    [anon_sym_fun] = ACTIONS(3875),
    [anon_sym_try] = ACTIONS(3875),
    [anon_sym_match] = ACTIONS(3875),
    [anon_sym_match_BANG] = ACTIONS(3873),
    [anon_sym_function] = ACTIONS(3875),
    [anon_sym_LT_DASH] = ACTIONS(3875),
    [anon_sym_DOT_LBRACK] = ACTIONS(3873),
    [anon_sym_LT] = ACTIONS(3873),
    [anon_sym_use] = ACTIONS(3875),
    [anon_sym_use_BANG] = ACTIONS(3873),
    [anon_sym_do_BANG] = ACTIONS(3873),
    [anon_sym_begin] = ACTIONS(3875),
    [anon_sym_LPAREN2] = ACTIONS(3875),
    [anon_sym_default] = ACTIONS(3875),
    [anon_sym_or] = ACTIONS(3875),
    [anon_sym_static] = ACTIONS(3875),
    [anon_sym_member] = ACTIONS(3875),
    [anon_sym_interface] = ACTIONS(3875),
    [anon_sym_abstract] = ACTIONS(3875),
    [anon_sym_val] = ACTIONS(3875),
    [anon_sym_override] = ACTIONS(3875),
    [anon_sym_inherit] = ACTIONS(3875),
    [aux_sym_char_token1] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3875),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [anon_sym_AT_DQUOTE] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [sym_bool] = ACTIONS(3875),
    [sym_unit] = ACTIONS(3873),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3875),
    [sym_op_identifier] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS_DOT] = ACTIONS(3875),
    [anon_sym_DASH_DOT] = ACTIONS(3875),
    [anon_sym_PERCENT] = ACTIONS(3875),
    [anon_sym_AMP_AMP] = ACTIONS(3875),
    [anon_sym_TILDE] = ACTIONS(3873),
    [aux_sym_prefix_op_token1] = ACTIONS(3875),
    [aux_sym_infix_op_token1] = ACTIONS(3873),
    [aux_sym_infix_op_token2] = ACTIONS(3875),
    [anon_sym_PIPE_PIPE] = ACTIONS(3875),
    [anon_sym_BANG_EQ] = ACTIONS(3875),
    [anon_sym_COLON_EQ] = ACTIONS(3873),
    [anon_sym_DOLLAR] = ACTIONS(3875),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3875),
    [sym_int] = ACTIONS(3875),
    [sym_xint] = ACTIONS(3873),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3873),
    [anon_sym_POUNDendif] = ACTIONS(3873),
    [sym__newline] = ACTIONS(3873),
  },
  [2180] = {
    [sym_block_comment] = STATE(2180),
    [sym_compiler_directive_decl] = STATE(2180),
    [sym_fsi_directive_decl] = STATE(2180),
    [sym_preproc_line] = STATE(2180),
    [sym_identifier] = ACTIONS(3889),
    [anon_sym_EQ] = ACTIONS(3887),
    [anon_sym_LBRACK_LT] = ACTIONS(3887),
    [anon_sym_COLON] = ACTIONS(3889),
    [anon_sym_return] = ACTIONS(3889),
    [anon_sym_do] = ACTIONS(3889),
    [anon_sym_and] = ACTIONS(3889),
    [anon_sym_let] = ACTIONS(3889),
    [anon_sym_let_BANG] = ACTIONS(3887),
    [aux_sym_access_modifier_token1] = ACTIONS(3887),
    [anon_sym_LPAREN] = ACTIONS(3889),
    [anon_sym_COMMA] = ACTIONS(3887),
    [anon_sym_null] = ACTIONS(3889),
    [anon_sym_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_COLON] = ACTIONS(3887),
    [anon_sym_AMP] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3887),
    [anon_sym_LBRACE] = ACTIONS(3889),
    [anon_sym_LT_AT] = ACTIONS(3889),
    [anon_sym_LT_AT_AT] = ACTIONS(3889),
    [anon_sym_DOT] = ACTIONS(3889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [anon_sym_new] = ACTIONS(3889),
    [anon_sym_with] = ACTIONS(3889),
    [anon_sym_return_BANG] = ACTIONS(3887),
    [anon_sym_yield] = ACTIONS(3889),
    [anon_sym_yield_BANG] = ACTIONS(3887),
    [anon_sym_lazy] = ACTIONS(3889),
    [anon_sym_assert] = ACTIONS(3889),
    [anon_sym_upcast] = ACTIONS(3889),
    [anon_sym_downcast] = ACTIONS(3889),
    [anon_sym_COLON_GT] = ACTIONS(3887),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3887),
    [anon_sym_for] = ACTIONS(3889),
    [anon_sym_while] = ACTIONS(3889),
    [anon_sym_if] = ACTIONS(3889),
    [anon_sym_fun] = ACTIONS(3889),
    [anon_sym_try] = ACTIONS(3889),
    [anon_sym_match] = ACTIONS(3889),
    [anon_sym_match_BANG] = ACTIONS(3887),
    [anon_sym_function] = ACTIONS(3889),
    [anon_sym_LT_DASH] = ACTIONS(3889),
    [anon_sym_DOT_LBRACK] = ACTIONS(3887),
    [anon_sym_LT] = ACTIONS(3887),
    [anon_sym_use] = ACTIONS(3889),
    [anon_sym_use_BANG] = ACTIONS(3887),
    [anon_sym_do_BANG] = ACTIONS(3887),
    [anon_sym_begin] = ACTIONS(3889),
    [anon_sym_LPAREN2] = ACTIONS(3889),
    [anon_sym_default] = ACTIONS(3889),
    [anon_sym_or] = ACTIONS(3889),
    [anon_sym_static] = ACTIONS(3889),
    [anon_sym_member] = ACTIONS(3889),
    [anon_sym_interface] = ACTIONS(3889),
    [anon_sym_abstract] = ACTIONS(3889),
    [anon_sym_val] = ACTIONS(3889),
    [anon_sym_override] = ACTIONS(3889),
    [aux_sym_char_token1] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3889),
    [anon_sym_DQUOTE] = ACTIONS(3889),
    [anon_sym_AT_DQUOTE] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [sym_bool] = ACTIONS(3889),
    [sym_unit] = ACTIONS(3887),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3889),
    [sym_op_identifier] = ACTIONS(3889),
    [anon_sym_PLUS] = ACTIONS(3889),
    [anon_sym_DASH] = ACTIONS(3889),
    [anon_sym_PLUS_DOT] = ACTIONS(3889),
    [anon_sym_DASH_DOT] = ACTIONS(3889),
    [anon_sym_PERCENT] = ACTIONS(3889),
    [anon_sym_AMP_AMP] = ACTIONS(3889),
    [anon_sym_TILDE] = ACTIONS(3887),
    [aux_sym_prefix_op_token1] = ACTIONS(3889),
    [aux_sym_infix_op_token1] = ACTIONS(3887),
    [aux_sym_infix_op_token2] = ACTIONS(3889),
    [anon_sym_PIPE_PIPE] = ACTIONS(3889),
    [anon_sym_BANG_EQ] = ACTIONS(3889),
    [anon_sym_COLON_EQ] = ACTIONS(3887),
    [anon_sym_DOLLAR] = ACTIONS(3889),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3889),
    [sym_int] = ACTIONS(3889),
    [sym_xint] = ACTIONS(3887),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3887),
    [anon_sym_POUNDendif] = ACTIONS(3887),
    [sym__newline] = ACTIONS(3887),
  },
  [2181] = {
    [sym_block_comment] = STATE(2181),
    [sym_compiler_directive_decl] = STATE(2181),
    [sym_fsi_directive_decl] = STATE(2181),
    [sym_preproc_line] = STATE(2181),
    [sym_identifier] = ACTIONS(3976),
    [anon_sym_EQ] = ACTIONS(3974),
    [anon_sym_LBRACK_LT] = ACTIONS(3974),
    [anon_sym_COLON] = ACTIONS(3976),
    [anon_sym_return] = ACTIONS(3976),
    [anon_sym_do] = ACTIONS(3976),
    [anon_sym_and] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_let_BANG] = ACTIONS(3974),
    [aux_sym_access_modifier_token1] = ACTIONS(3974),
    [anon_sym_LPAREN] = ACTIONS(3976),
    [anon_sym_COMMA] = ACTIONS(3974),
    [anon_sym_null] = ACTIONS(3976),
    [anon_sym_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_COLON] = ACTIONS(3974),
    [anon_sym_AMP] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(3976),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3974),
    [anon_sym_LBRACE] = ACTIONS(3976),
    [anon_sym_LT_AT] = ACTIONS(3976),
    [anon_sym_LT_AT_AT] = ACTIONS(3976),
    [anon_sym_DOT] = ACTIONS(3976),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3974),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_with] = ACTIONS(3976),
    [anon_sym_return_BANG] = ACTIONS(3974),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_yield_BANG] = ACTIONS(3974),
    [anon_sym_lazy] = ACTIONS(3976),
    [anon_sym_assert] = ACTIONS(3976),
    [anon_sym_upcast] = ACTIONS(3976),
    [anon_sym_downcast] = ACTIONS(3976),
    [anon_sym_COLON_GT] = ACTIONS(3974),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3974),
    [anon_sym_for] = ACTIONS(3976),
    [anon_sym_while] = ACTIONS(3976),
    [anon_sym_if] = ACTIONS(3976),
    [anon_sym_fun] = ACTIONS(3976),
    [anon_sym_try] = ACTIONS(3976),
    [anon_sym_match] = ACTIONS(3976),
    [anon_sym_match_BANG] = ACTIONS(3974),
    [anon_sym_function] = ACTIONS(3976),
    [anon_sym_LT_DASH] = ACTIONS(3976),
    [anon_sym_DOT_LBRACK] = ACTIONS(3974),
    [anon_sym_LT] = ACTIONS(3974),
    [anon_sym_use] = ACTIONS(3976),
    [anon_sym_use_BANG] = ACTIONS(3974),
    [anon_sym_do_BANG] = ACTIONS(3974),
    [anon_sym_begin] = ACTIONS(3976),
    [anon_sym_LPAREN2] = ACTIONS(3976),
    [anon_sym_default] = ACTIONS(3976),
    [anon_sym_or] = ACTIONS(3976),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_member] = ACTIONS(3976),
    [anon_sym_interface] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_val] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [aux_sym_char_token1] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3976),
    [anon_sym_DQUOTE] = ACTIONS(3976),
    [anon_sym_AT_DQUOTE] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [sym_bool] = ACTIONS(3976),
    [sym_unit] = ACTIONS(3974),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3976),
    [sym_op_identifier] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3976),
    [anon_sym_DASH] = ACTIONS(3976),
    [anon_sym_PLUS_DOT] = ACTIONS(3976),
    [anon_sym_DASH_DOT] = ACTIONS(3976),
    [anon_sym_PERCENT] = ACTIONS(3976),
    [anon_sym_AMP_AMP] = ACTIONS(3976),
    [anon_sym_TILDE] = ACTIONS(3974),
    [aux_sym_prefix_op_token1] = ACTIONS(3976),
    [aux_sym_infix_op_token1] = ACTIONS(3974),
    [aux_sym_infix_op_token2] = ACTIONS(3976),
    [anon_sym_PIPE_PIPE] = ACTIONS(3976),
    [anon_sym_BANG_EQ] = ACTIONS(3976),
    [anon_sym_COLON_EQ] = ACTIONS(3974),
    [anon_sym_DOLLAR] = ACTIONS(3976),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3976),
    [sym_int] = ACTIONS(3976),
    [sym_xint] = ACTIONS(3974),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3974),
    [anon_sym_POUNDendif] = ACTIONS(3974),
    [sym__newline] = ACTIONS(3974),
  },
  [2182] = {
    [sym_block_comment] = STATE(2182),
    [sym_compiler_directive_decl] = STATE(2182),
    [sym_fsi_directive_decl] = STATE(2182),
    [sym_preproc_line] = STATE(2182),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_and] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [aux_sym_access_modifier_token1] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_member] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_val] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [anon_sym_POUNDendif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [2183] = {
    [sym_block_comment] = STATE(2183),
    [sym_compiler_directive_decl] = STATE(2183),
    [sym_fsi_directive_decl] = STATE(2183),
    [sym_preproc_line] = STATE(2183),
    [sym_identifier] = ACTIONS(4208),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LBRACK_LT] = ACTIONS(4206),
    [anon_sym_COLON] = ACTIONS(4208),
    [anon_sym_return] = ACTIONS(4208),
    [anon_sym_do] = ACTIONS(4208),
    [anon_sym_and] = ACTIONS(4208),
    [anon_sym_let] = ACTIONS(4208),
    [anon_sym_let_BANG] = ACTIONS(4206),
    [aux_sym_access_modifier_token1] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(4206),
    [anon_sym_null] = ACTIONS(4208),
    [anon_sym_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_COLON] = ACTIONS(4206),
    [anon_sym_AMP] = ACTIONS(4208),
    [anon_sym_LBRACK] = ACTIONS(4208),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4206),
    [anon_sym_LBRACE] = ACTIONS(4208),
    [anon_sym_LT_AT] = ACTIONS(4208),
    [anon_sym_LT_AT_AT] = ACTIONS(4208),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4206),
    [anon_sym_new] = ACTIONS(4208),
    [anon_sym_with] = ACTIONS(4208),
    [anon_sym_return_BANG] = ACTIONS(4206),
    [anon_sym_yield] = ACTIONS(4208),
    [anon_sym_yield_BANG] = ACTIONS(4206),
    [anon_sym_lazy] = ACTIONS(4208),
    [anon_sym_assert] = ACTIONS(4208),
    [anon_sym_upcast] = ACTIONS(4208),
    [anon_sym_downcast] = ACTIONS(4208),
    [anon_sym_COLON_GT] = ACTIONS(4206),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4206),
    [anon_sym_for] = ACTIONS(4208),
    [anon_sym_while] = ACTIONS(4208),
    [anon_sym_if] = ACTIONS(4208),
    [anon_sym_fun] = ACTIONS(4208),
    [anon_sym_try] = ACTIONS(4208),
    [anon_sym_match] = ACTIONS(4208),
    [anon_sym_match_BANG] = ACTIONS(4206),
    [anon_sym_function] = ACTIONS(4208),
    [anon_sym_LT_DASH] = ACTIONS(4208),
    [anon_sym_DOT_LBRACK] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(4206),
    [anon_sym_use] = ACTIONS(4208),
    [anon_sym_use_BANG] = ACTIONS(4206),
    [anon_sym_do_BANG] = ACTIONS(4206),
    [anon_sym_begin] = ACTIONS(4208),
    [anon_sym_LPAREN2] = ACTIONS(4208),
    [anon_sym_default] = ACTIONS(4208),
    [anon_sym_or] = ACTIONS(4208),
    [anon_sym_static] = ACTIONS(4208),
    [anon_sym_member] = ACTIONS(4208),
    [anon_sym_interface] = ACTIONS(4208),
    [anon_sym_abstract] = ACTIONS(4208),
    [anon_sym_val] = ACTIONS(4208),
    [anon_sym_override] = ACTIONS(4208),
    [aux_sym_char_token1] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4208),
    [anon_sym_DQUOTE] = ACTIONS(4208),
    [anon_sym_AT_DQUOTE] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [sym_bool] = ACTIONS(4208),
    [sym_unit] = ACTIONS(4206),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4208),
    [sym_op_identifier] = ACTIONS(4208),
    [anon_sym_PLUS] = ACTIONS(4208),
    [anon_sym_DASH] = ACTIONS(4208),
    [anon_sym_PLUS_DOT] = ACTIONS(4208),
    [anon_sym_DASH_DOT] = ACTIONS(4208),
    [anon_sym_PERCENT] = ACTIONS(4208),
    [anon_sym_AMP_AMP] = ACTIONS(4208),
    [anon_sym_TILDE] = ACTIONS(4206),
    [aux_sym_prefix_op_token1] = ACTIONS(4208),
    [aux_sym_infix_op_token1] = ACTIONS(4206),
    [aux_sym_infix_op_token2] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(4208),
    [anon_sym_BANG_EQ] = ACTIONS(4208),
    [anon_sym_COLON_EQ] = ACTIONS(4206),
    [anon_sym_DOLLAR] = ACTIONS(4208),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4208),
    [sym_int] = ACTIONS(4208),
    [sym_xint] = ACTIONS(4206),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4206),
    [sym__newline] = ACTIONS(4206),
    [sym__dedent] = ACTIONS(4206),
  },
  [2184] = {
    [sym_block_comment] = STATE(2184),
    [sym_compiler_directive_decl] = STATE(2184),
    [sym_fsi_directive_decl] = STATE(2184),
    [sym_preproc_line] = STATE(2184),
    [sym_identifier] = ACTIONS(4212),
    [anon_sym_EQ] = ACTIONS(4210),
    [anon_sym_LBRACK_LT] = ACTIONS(4210),
    [anon_sym_COLON] = ACTIONS(4212),
    [anon_sym_return] = ACTIONS(4212),
    [anon_sym_do] = ACTIONS(4212),
    [anon_sym_and] = ACTIONS(4212),
    [anon_sym_let] = ACTIONS(4212),
    [anon_sym_let_BANG] = ACTIONS(4210),
    [aux_sym_access_modifier_token1] = ACTIONS(4210),
    [anon_sym_LPAREN] = ACTIONS(4212),
    [anon_sym_COMMA] = ACTIONS(4210),
    [anon_sym_null] = ACTIONS(4212),
    [anon_sym_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_COLON] = ACTIONS(4210),
    [anon_sym_AMP] = ACTIONS(4212),
    [anon_sym_LBRACK] = ACTIONS(4212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4210),
    [anon_sym_LBRACE] = ACTIONS(4212),
    [anon_sym_LT_AT] = ACTIONS(4212),
    [anon_sym_LT_AT_AT] = ACTIONS(4212),
    [anon_sym_DOT] = ACTIONS(4212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4210),
    [anon_sym_new] = ACTIONS(4212),
    [anon_sym_with] = ACTIONS(4212),
    [anon_sym_return_BANG] = ACTIONS(4210),
    [anon_sym_yield] = ACTIONS(4212),
    [anon_sym_yield_BANG] = ACTIONS(4210),
    [anon_sym_lazy] = ACTIONS(4212),
    [anon_sym_assert] = ACTIONS(4212),
    [anon_sym_upcast] = ACTIONS(4212),
    [anon_sym_downcast] = ACTIONS(4212),
    [anon_sym_COLON_GT] = ACTIONS(4210),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4210),
    [anon_sym_for] = ACTIONS(4212),
    [anon_sym_while] = ACTIONS(4212),
    [anon_sym_if] = ACTIONS(4212),
    [anon_sym_fun] = ACTIONS(4212),
    [anon_sym_try] = ACTIONS(4212),
    [anon_sym_match] = ACTIONS(4212),
    [anon_sym_match_BANG] = ACTIONS(4210),
    [anon_sym_function] = ACTIONS(4212),
    [anon_sym_LT_DASH] = ACTIONS(4212),
    [anon_sym_DOT_LBRACK] = ACTIONS(4210),
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_use] = ACTIONS(4212),
    [anon_sym_use_BANG] = ACTIONS(4210),
    [anon_sym_do_BANG] = ACTIONS(4210),
    [anon_sym_begin] = ACTIONS(4212),
    [anon_sym_LPAREN2] = ACTIONS(4212),
    [anon_sym_default] = ACTIONS(4212),
    [anon_sym_or] = ACTIONS(4212),
    [anon_sym_static] = ACTIONS(4212),
    [anon_sym_member] = ACTIONS(4212),
    [anon_sym_interface] = ACTIONS(4212),
    [anon_sym_abstract] = ACTIONS(4212),
    [anon_sym_val] = ACTIONS(4212),
    [anon_sym_override] = ACTIONS(4212),
    [aux_sym_char_token1] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4212),
    [anon_sym_DQUOTE] = ACTIONS(4212),
    [anon_sym_AT_DQUOTE] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [sym_bool] = ACTIONS(4212),
    [sym_unit] = ACTIONS(4210),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4212),
    [anon_sym_DASH] = ACTIONS(4212),
    [anon_sym_PLUS_DOT] = ACTIONS(4212),
    [anon_sym_DASH_DOT] = ACTIONS(4212),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_AMP_AMP] = ACTIONS(4212),
    [anon_sym_TILDE] = ACTIONS(4210),
    [aux_sym_prefix_op_token1] = ACTIONS(4212),
    [aux_sym_infix_op_token1] = ACTIONS(4210),
    [aux_sym_infix_op_token2] = ACTIONS(4212),
    [anon_sym_PIPE_PIPE] = ACTIONS(4212),
    [anon_sym_BANG_EQ] = ACTIONS(4212),
    [anon_sym_COLON_EQ] = ACTIONS(4210),
    [anon_sym_DOLLAR] = ACTIONS(4212),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4212),
    [sym_int] = ACTIONS(4212),
    [sym_xint] = ACTIONS(4210),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4210),
    [sym__newline] = ACTIONS(4210),
    [sym__dedent] = ACTIONS(4210),
  },
  [2185] = {
    [sym_block_comment] = STATE(2185),
    [sym_compiler_directive_decl] = STATE(2185),
    [sym_fsi_directive_decl] = STATE(2185),
    [sym_preproc_line] = STATE(2185),
    [sym_identifier] = ACTIONS(3863),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_LBRACK_LT] = ACTIONS(3861),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_let] = ACTIONS(3863),
    [anon_sym_let_BANG] = ACTIONS(3861),
    [aux_sym_access_modifier_token1] = ACTIONS(3861),
    [anon_sym_LPAREN] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3861),
    [anon_sym_null] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_COLON] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_LT_AT] = ACTIONS(3863),
    [anon_sym_LT_AT_AT] = ACTIONS(3863),
    [anon_sym_DOT] = ACTIONS(3863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3861),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_with] = ACTIONS(3863),
    [anon_sym_return_BANG] = ACTIONS(3861),
    [anon_sym_yield] = ACTIONS(3863),
    [anon_sym_yield_BANG] = ACTIONS(3861),
    [anon_sym_lazy] = ACTIONS(3863),
    [anon_sym_assert] = ACTIONS(3863),
    [anon_sym_upcast] = ACTIONS(3863),
    [anon_sym_downcast] = ACTIONS(3863),
    [anon_sym_COLON_GT] = ACTIONS(3861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_fun] = ACTIONS(3863),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_match] = ACTIONS(3863),
    [anon_sym_match_BANG] = ACTIONS(3861),
    [anon_sym_function] = ACTIONS(3863),
    [anon_sym_LT_DASH] = ACTIONS(3863),
    [anon_sym_DOT_LBRACK] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_use] = ACTIONS(3863),
    [anon_sym_use_BANG] = ACTIONS(3861),
    [anon_sym_do_BANG] = ACTIONS(3861),
    [anon_sym_begin] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(3863),
    [anon_sym_default] = ACTIONS(3863),
    [anon_sym_or] = ACTIONS(3863),
    [anon_sym_static] = ACTIONS(3863),
    [anon_sym_member] = ACTIONS(3863),
    [anon_sym_interface] = ACTIONS(3863),
    [anon_sym_abstract] = ACTIONS(3863),
    [anon_sym_val] = ACTIONS(3863),
    [anon_sym_override] = ACTIONS(3863),
    [anon_sym_inherit] = ACTIONS(3863),
    [aux_sym_char_token1] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [anon_sym_AT_DQUOTE] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [sym_bool] = ACTIONS(3863),
    [sym_unit] = ACTIONS(3861),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3863),
    [sym_op_identifier] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_DOT] = ACTIONS(3863),
    [anon_sym_DASH_DOT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3861),
    [aux_sym_prefix_op_token1] = ACTIONS(3863),
    [aux_sym_infix_op_token1] = ACTIONS(3861),
    [aux_sym_infix_op_token2] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_COLON_EQ] = ACTIONS(3861),
    [anon_sym_DOLLAR] = ACTIONS(3863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3863),
    [sym_int] = ACTIONS(3863),
    [sym_xint] = ACTIONS(3861),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3861),
    [anon_sym_POUNDendif] = ACTIONS(3861),
    [sym__newline] = ACTIONS(3861),
  },
  [2186] = {
    [sym_block_comment] = STATE(2186),
    [sym_compiler_directive_decl] = STATE(2186),
    [sym_fsi_directive_decl] = STATE(2186),
    [sym_preproc_line] = STATE(2186),
    [sym_identifier] = ACTIONS(3856),
    [anon_sym_EQ] = ACTIONS(3854),
    [anon_sym_LBRACK_LT] = ACTIONS(3854),
    [anon_sym_COLON] = ACTIONS(3856),
    [anon_sym_return] = ACTIONS(3856),
    [anon_sym_do] = ACTIONS(3856),
    [anon_sym_let] = ACTIONS(3856),
    [anon_sym_let_BANG] = ACTIONS(3854),
    [aux_sym_access_modifier_token1] = ACTIONS(3854),
    [anon_sym_LPAREN] = ACTIONS(3856),
    [anon_sym_COMMA] = ACTIONS(3854),
    [anon_sym_null] = ACTIONS(3856),
    [anon_sym_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_AMP] = ACTIONS(3856),
    [anon_sym_LBRACK] = ACTIONS(3856),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3854),
    [anon_sym_LBRACE] = ACTIONS(3856),
    [anon_sym_LT_AT] = ACTIONS(3856),
    [anon_sym_LT_AT_AT] = ACTIONS(3856),
    [anon_sym_DOT] = ACTIONS(3856),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3854),
    [anon_sym_new] = ACTIONS(3856),
    [anon_sym_with] = ACTIONS(3856),
    [anon_sym_return_BANG] = ACTIONS(3854),
    [anon_sym_yield] = ACTIONS(3856),
    [anon_sym_yield_BANG] = ACTIONS(3854),
    [anon_sym_lazy] = ACTIONS(3856),
    [anon_sym_assert] = ACTIONS(3856),
    [anon_sym_upcast] = ACTIONS(3856),
    [anon_sym_downcast] = ACTIONS(3856),
    [anon_sym_COLON_GT] = ACTIONS(3854),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3854),
    [anon_sym_for] = ACTIONS(3856),
    [anon_sym_while] = ACTIONS(3856),
    [anon_sym_if] = ACTIONS(3856),
    [anon_sym_fun] = ACTIONS(3856),
    [anon_sym_try] = ACTIONS(3856),
    [anon_sym_match] = ACTIONS(3856),
    [anon_sym_match_BANG] = ACTIONS(3854),
    [anon_sym_function] = ACTIONS(3856),
    [anon_sym_LT_DASH] = ACTIONS(3856),
    [anon_sym_DOT_LBRACK] = ACTIONS(3854),
    [anon_sym_LT] = ACTIONS(3854),
    [anon_sym_use] = ACTIONS(3856),
    [anon_sym_use_BANG] = ACTIONS(3854),
    [anon_sym_do_BANG] = ACTIONS(3854),
    [anon_sym_begin] = ACTIONS(3856),
    [anon_sym_LPAREN2] = ACTIONS(3856),
    [anon_sym_default] = ACTIONS(3856),
    [anon_sym_or] = ACTIONS(3856),
    [anon_sym_static] = ACTIONS(3856),
    [anon_sym_member] = ACTIONS(3856),
    [anon_sym_interface] = ACTIONS(3856),
    [anon_sym_abstract] = ACTIONS(3856),
    [anon_sym_val] = ACTIONS(3856),
    [anon_sym_override] = ACTIONS(3856),
    [anon_sym_inherit] = ACTIONS(3856),
    [aux_sym_char_token1] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3856),
    [anon_sym_DQUOTE] = ACTIONS(3856),
    [anon_sym_AT_DQUOTE] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [sym_bool] = ACTIONS(3856),
    [sym_unit] = ACTIONS(3854),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3856),
    [sym_op_identifier] = ACTIONS(3856),
    [anon_sym_PLUS] = ACTIONS(3856),
    [anon_sym_DASH] = ACTIONS(3856),
    [anon_sym_PLUS_DOT] = ACTIONS(3856),
    [anon_sym_DASH_DOT] = ACTIONS(3856),
    [anon_sym_PERCENT] = ACTIONS(3856),
    [anon_sym_AMP_AMP] = ACTIONS(3856),
    [anon_sym_TILDE] = ACTIONS(3854),
    [aux_sym_prefix_op_token1] = ACTIONS(3856),
    [aux_sym_infix_op_token1] = ACTIONS(3854),
    [aux_sym_infix_op_token2] = ACTIONS(3856),
    [anon_sym_PIPE_PIPE] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3856),
    [anon_sym_COLON_EQ] = ACTIONS(3854),
    [anon_sym_DOLLAR] = ACTIONS(3856),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3856),
    [sym_int] = ACTIONS(3856),
    [sym_xint] = ACTIONS(3854),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3854),
    [anon_sym_POUNDendif] = ACTIONS(3854),
    [sym__newline] = ACTIONS(3854),
  },
  [2187] = {
    [sym_block_comment] = STATE(2187),
    [sym_compiler_directive_decl] = STATE(2187),
    [sym_fsi_directive_decl] = STATE(2187),
    [sym_preproc_line] = STATE(2187),
    [sym_identifier] = ACTIONS(4224),
    [anon_sym_EQ] = ACTIONS(4222),
    [anon_sym_LBRACK_LT] = ACTIONS(4222),
    [anon_sym_COLON] = ACTIONS(4224),
    [anon_sym_return] = ACTIONS(4224),
    [anon_sym_do] = ACTIONS(4224),
    [anon_sym_and] = ACTIONS(4224),
    [anon_sym_let] = ACTIONS(4224),
    [anon_sym_let_BANG] = ACTIONS(4222),
    [aux_sym_access_modifier_token1] = ACTIONS(4222),
    [anon_sym_LPAREN] = ACTIONS(4224),
    [anon_sym_COMMA] = ACTIONS(4222),
    [anon_sym_null] = ACTIONS(4224),
    [anon_sym_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_COLON] = ACTIONS(4222),
    [anon_sym_AMP] = ACTIONS(4224),
    [anon_sym_LBRACK] = ACTIONS(4224),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4222),
    [anon_sym_LBRACE] = ACTIONS(4224),
    [anon_sym_LT_AT] = ACTIONS(4224),
    [anon_sym_LT_AT_AT] = ACTIONS(4224),
    [anon_sym_DOT] = ACTIONS(4224),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4222),
    [anon_sym_new] = ACTIONS(4224),
    [anon_sym_with] = ACTIONS(4224),
    [anon_sym_return_BANG] = ACTIONS(4222),
    [anon_sym_yield] = ACTIONS(4224),
    [anon_sym_yield_BANG] = ACTIONS(4222),
    [anon_sym_lazy] = ACTIONS(4224),
    [anon_sym_assert] = ACTIONS(4224),
    [anon_sym_upcast] = ACTIONS(4224),
    [anon_sym_downcast] = ACTIONS(4224),
    [anon_sym_COLON_GT] = ACTIONS(4222),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4222),
    [anon_sym_for] = ACTIONS(4224),
    [anon_sym_while] = ACTIONS(4224),
    [anon_sym_if] = ACTIONS(4224),
    [anon_sym_fun] = ACTIONS(4224),
    [anon_sym_try] = ACTIONS(4224),
    [anon_sym_match] = ACTIONS(4224),
    [anon_sym_match_BANG] = ACTIONS(4222),
    [anon_sym_function] = ACTIONS(4224),
    [anon_sym_LT_DASH] = ACTIONS(4224),
    [anon_sym_DOT_LBRACK] = ACTIONS(4222),
    [anon_sym_LT] = ACTIONS(4222),
    [anon_sym_use] = ACTIONS(4224),
    [anon_sym_use_BANG] = ACTIONS(4222),
    [anon_sym_do_BANG] = ACTIONS(4222),
    [anon_sym_begin] = ACTIONS(4224),
    [anon_sym_LPAREN2] = ACTIONS(4224),
    [anon_sym_default] = ACTIONS(4224),
    [anon_sym_or] = ACTIONS(4224),
    [anon_sym_static] = ACTIONS(4224),
    [anon_sym_member] = ACTIONS(4224),
    [anon_sym_interface] = ACTIONS(4224),
    [anon_sym_abstract] = ACTIONS(4224),
    [anon_sym_val] = ACTIONS(4224),
    [anon_sym_override] = ACTIONS(4224),
    [aux_sym_char_token1] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4224),
    [anon_sym_DQUOTE] = ACTIONS(4224),
    [anon_sym_AT_DQUOTE] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [sym_bool] = ACTIONS(4224),
    [sym_unit] = ACTIONS(4222),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4224),
    [sym_op_identifier] = ACTIONS(4224),
    [anon_sym_PLUS] = ACTIONS(4224),
    [anon_sym_DASH] = ACTIONS(4224),
    [anon_sym_PLUS_DOT] = ACTIONS(4224),
    [anon_sym_DASH_DOT] = ACTIONS(4224),
    [anon_sym_PERCENT] = ACTIONS(4224),
    [anon_sym_AMP_AMP] = ACTIONS(4224),
    [anon_sym_TILDE] = ACTIONS(4222),
    [aux_sym_prefix_op_token1] = ACTIONS(4224),
    [aux_sym_infix_op_token1] = ACTIONS(4222),
    [aux_sym_infix_op_token2] = ACTIONS(4224),
    [anon_sym_PIPE_PIPE] = ACTIONS(4224),
    [anon_sym_BANG_EQ] = ACTIONS(4224),
    [anon_sym_COLON_EQ] = ACTIONS(4222),
    [anon_sym_DOLLAR] = ACTIONS(4224),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4224),
    [sym_int] = ACTIONS(4224),
    [sym_xint] = ACTIONS(4222),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4222),
    [sym__newline] = ACTIONS(4222),
    [sym__dedent] = ACTIONS(4222),
  },
  [2188] = {
    [sym_block_comment] = STATE(2188),
    [sym_compiler_directive_decl] = STATE(2188),
    [sym_fsi_directive_decl] = STATE(2188),
    [sym_preproc_line] = STATE(2188),
    [sym_identifier] = ACTIONS(3907),
    [anon_sym_EQ] = ACTIONS(3905),
    [anon_sym_LBRACK_LT] = ACTIONS(3905),
    [anon_sym_COLON] = ACTIONS(3907),
    [anon_sym_return] = ACTIONS(3907),
    [anon_sym_do] = ACTIONS(3907),
    [anon_sym_and] = ACTIONS(3907),
    [anon_sym_let] = ACTIONS(3907),
    [anon_sym_let_BANG] = ACTIONS(3905),
    [aux_sym_access_modifier_token1] = ACTIONS(3905),
    [anon_sym_LPAREN] = ACTIONS(3907),
    [anon_sym_COMMA] = ACTIONS(3905),
    [anon_sym_null] = ACTIONS(3907),
    [anon_sym_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_COLON] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3907),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3905),
    [anon_sym_LBRACE] = ACTIONS(3907),
    [anon_sym_LT_AT] = ACTIONS(3907),
    [anon_sym_LT_AT_AT] = ACTIONS(3907),
    [anon_sym_DOT] = ACTIONS(3907),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3905),
    [anon_sym_new] = ACTIONS(3907),
    [anon_sym_with] = ACTIONS(3907),
    [anon_sym_return_BANG] = ACTIONS(3905),
    [anon_sym_yield] = ACTIONS(3907),
    [anon_sym_yield_BANG] = ACTIONS(3905),
    [anon_sym_lazy] = ACTIONS(3907),
    [anon_sym_assert] = ACTIONS(3907),
    [anon_sym_upcast] = ACTIONS(3907),
    [anon_sym_downcast] = ACTIONS(3907),
    [anon_sym_COLON_GT] = ACTIONS(3905),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3905),
    [anon_sym_for] = ACTIONS(3907),
    [anon_sym_while] = ACTIONS(3907),
    [anon_sym_if] = ACTIONS(3907),
    [anon_sym_fun] = ACTIONS(3907),
    [anon_sym_try] = ACTIONS(3907),
    [anon_sym_match] = ACTIONS(3907),
    [anon_sym_match_BANG] = ACTIONS(3905),
    [anon_sym_function] = ACTIONS(3907),
    [anon_sym_LT_DASH] = ACTIONS(3907),
    [anon_sym_DOT_LBRACK] = ACTIONS(3905),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_use] = ACTIONS(3907),
    [anon_sym_use_BANG] = ACTIONS(3905),
    [anon_sym_do_BANG] = ACTIONS(3905),
    [anon_sym_begin] = ACTIONS(3907),
    [anon_sym_LPAREN2] = ACTIONS(3907),
    [anon_sym_default] = ACTIONS(3907),
    [anon_sym_or] = ACTIONS(3907),
    [anon_sym_static] = ACTIONS(3907),
    [anon_sym_member] = ACTIONS(3907),
    [anon_sym_interface] = ACTIONS(3907),
    [anon_sym_abstract] = ACTIONS(3907),
    [anon_sym_val] = ACTIONS(3907),
    [anon_sym_override] = ACTIONS(3907),
    [aux_sym_char_token1] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3907),
    [anon_sym_DQUOTE] = ACTIONS(3907),
    [anon_sym_AT_DQUOTE] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [sym_bool] = ACTIONS(3907),
    [sym_unit] = ACTIONS(3905),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3907),
    [sym_op_identifier] = ACTIONS(3907),
    [anon_sym_PLUS] = ACTIONS(3907),
    [anon_sym_DASH] = ACTIONS(3907),
    [anon_sym_PLUS_DOT] = ACTIONS(3907),
    [anon_sym_DASH_DOT] = ACTIONS(3907),
    [anon_sym_PERCENT] = ACTIONS(3907),
    [anon_sym_AMP_AMP] = ACTIONS(3907),
    [anon_sym_TILDE] = ACTIONS(3905),
    [aux_sym_prefix_op_token1] = ACTIONS(3907),
    [aux_sym_infix_op_token1] = ACTIONS(3905),
    [aux_sym_infix_op_token2] = ACTIONS(3907),
    [anon_sym_PIPE_PIPE] = ACTIONS(3907),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_COLON_EQ] = ACTIONS(3905),
    [anon_sym_DOLLAR] = ACTIONS(3907),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3907),
    [sym_int] = ACTIONS(3907),
    [sym_xint] = ACTIONS(3905),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3905),
    [sym__newline] = ACTIONS(3905),
    [sym__dedent] = ACTIONS(3905),
  },
  [2189] = {
    [sym_block_comment] = STATE(2189),
    [sym_compiler_directive_decl] = STATE(2189),
    [sym_fsi_directive_decl] = STATE(2189),
    [sym_preproc_line] = STATE(2189),
    [sym_identifier] = ACTIONS(3900),
    [anon_sym_EQ] = ACTIONS(3898),
    [anon_sym_LBRACK_LT] = ACTIONS(3898),
    [anon_sym_COLON] = ACTIONS(3900),
    [anon_sym_return] = ACTIONS(3900),
    [anon_sym_do] = ACTIONS(3900),
    [anon_sym_and] = ACTIONS(3900),
    [anon_sym_let] = ACTIONS(3900),
    [anon_sym_let_BANG] = ACTIONS(3898),
    [aux_sym_access_modifier_token1] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3898),
    [anon_sym_null] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_COLON] = ACTIONS(3898),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_LBRACK] = ACTIONS(3900),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3898),
    [anon_sym_LBRACE] = ACTIONS(3900),
    [anon_sym_LT_AT] = ACTIONS(3900),
    [anon_sym_LT_AT_AT] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(3900),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3898),
    [anon_sym_new] = ACTIONS(3900),
    [anon_sym_with] = ACTIONS(3900),
    [anon_sym_return_BANG] = ACTIONS(3898),
    [anon_sym_yield] = ACTIONS(3900),
    [anon_sym_yield_BANG] = ACTIONS(3898),
    [anon_sym_lazy] = ACTIONS(3900),
    [anon_sym_assert] = ACTIONS(3900),
    [anon_sym_upcast] = ACTIONS(3900),
    [anon_sym_downcast] = ACTIONS(3900),
    [anon_sym_COLON_GT] = ACTIONS(3898),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3898),
    [anon_sym_for] = ACTIONS(3900),
    [anon_sym_while] = ACTIONS(3900),
    [anon_sym_if] = ACTIONS(3900),
    [anon_sym_fun] = ACTIONS(3900),
    [anon_sym_try] = ACTIONS(3900),
    [anon_sym_match] = ACTIONS(3900),
    [anon_sym_match_BANG] = ACTIONS(3898),
    [anon_sym_function] = ACTIONS(3900),
    [anon_sym_LT_DASH] = ACTIONS(3900),
    [anon_sym_DOT_LBRACK] = ACTIONS(3898),
    [anon_sym_LT] = ACTIONS(3898),
    [anon_sym_use] = ACTIONS(3900),
    [anon_sym_use_BANG] = ACTIONS(3898),
    [anon_sym_do_BANG] = ACTIONS(3898),
    [anon_sym_begin] = ACTIONS(3900),
    [anon_sym_LPAREN2] = ACTIONS(3900),
    [anon_sym_default] = ACTIONS(3900),
    [anon_sym_or] = ACTIONS(3900),
    [anon_sym_static] = ACTIONS(3900),
    [anon_sym_member] = ACTIONS(3900),
    [anon_sym_interface] = ACTIONS(3900),
    [anon_sym_abstract] = ACTIONS(3900),
    [anon_sym_val] = ACTIONS(3900),
    [anon_sym_override] = ACTIONS(3900),
    [aux_sym_char_token1] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3900),
    [anon_sym_DQUOTE] = ACTIONS(3900),
    [anon_sym_AT_DQUOTE] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3898),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3900),
    [sym_op_identifier] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(3900),
    [anon_sym_DASH] = ACTIONS(3900),
    [anon_sym_PLUS_DOT] = ACTIONS(3900),
    [anon_sym_DASH_DOT] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(3900),
    [anon_sym_AMP_AMP] = ACTIONS(3900),
    [anon_sym_TILDE] = ACTIONS(3898),
    [aux_sym_prefix_op_token1] = ACTIONS(3900),
    [aux_sym_infix_op_token1] = ACTIONS(3898),
    [aux_sym_infix_op_token2] = ACTIONS(3900),
    [anon_sym_PIPE_PIPE] = ACTIONS(3900),
    [anon_sym_BANG_EQ] = ACTIONS(3900),
    [anon_sym_COLON_EQ] = ACTIONS(3898),
    [anon_sym_DOLLAR] = ACTIONS(3900),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3900),
    [sym_int] = ACTIONS(3900),
    [sym_xint] = ACTIONS(3898),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3898),
    [sym__newline] = ACTIONS(3898),
    [sym__dedent] = ACTIONS(3898),
  },
  [2190] = {
    [sym_block_comment] = STATE(2190),
    [sym_compiler_directive_decl] = STATE(2190),
    [sym_fsi_directive_decl] = STATE(2190),
    [sym_preproc_line] = STATE(2190),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4072),
    [anon_sym_LBRACK_LT] = ACTIONS(4072),
    [anon_sym_COLON] = ACTIONS(4074),
    [anon_sym_return] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_let_BANG] = ACTIONS(4072),
    [aux_sym_access_modifier_token1] = ACTIONS(4072),
    [anon_sym_LPAREN] = ACTIONS(4074),
    [anon_sym_COMMA] = ACTIONS(4072),
    [anon_sym_null] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_COLON] = ACTIONS(4072),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_LT_AT] = ACTIONS(4074),
    [anon_sym_LT_AT_AT] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4072),
    [anon_sym_new] = ACTIONS(4074),
    [anon_sym_with] = ACTIONS(4074),
    [anon_sym_return_BANG] = ACTIONS(4072),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_yield_BANG] = ACTIONS(4072),
    [anon_sym_lazy] = ACTIONS(4074),
    [anon_sym_assert] = ACTIONS(4074),
    [anon_sym_upcast] = ACTIONS(4074),
    [anon_sym_downcast] = ACTIONS(4074),
    [anon_sym_COLON_GT] = ACTIONS(4072),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4072),
    [anon_sym_for] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_fun] = ACTIONS(4074),
    [anon_sym_try] = ACTIONS(4074),
    [anon_sym_match] = ACTIONS(4074),
    [anon_sym_match_BANG] = ACTIONS(4072),
    [anon_sym_function] = ACTIONS(4074),
    [anon_sym_LT_DASH] = ACTIONS(4074),
    [anon_sym_DOT_LBRACK] = ACTIONS(4072),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_use] = ACTIONS(4074),
    [anon_sym_use_BANG] = ACTIONS(4072),
    [anon_sym_do_BANG] = ACTIONS(4072),
    [anon_sym_begin] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(4074),
    [anon_sym_DOT_DOT2] = ACTIONS(4072),
    [anon_sym_default] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_static] = ACTIONS(4074),
    [anon_sym_member] = ACTIONS(4074),
    [anon_sym_interface] = ACTIONS(4074),
    [anon_sym_abstract] = ACTIONS(4074),
    [anon_sym_val] = ACTIONS(4074),
    [anon_sym_override] = ACTIONS(4074),
    [aux_sym_char_token1] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4074),
    [anon_sym_DQUOTE] = ACTIONS(4074),
    [anon_sym_AT_DQUOTE] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [sym_bool] = ACTIONS(4074),
    [sym_unit] = ACTIONS(4072),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4074),
    [sym_op_identifier] = ACTIONS(4074),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_PLUS_DOT] = ACTIONS(4074),
    [anon_sym_DASH_DOT] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_TILDE] = ACTIONS(4072),
    [aux_sym_prefix_op_token1] = ACTIONS(4074),
    [aux_sym_infix_op_token1] = ACTIONS(4072),
    [aux_sym_infix_op_token2] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [anon_sym_BANG_EQ] = ACTIONS(4074),
    [anon_sym_COLON_EQ] = ACTIONS(4072),
    [anon_sym_DOLLAR] = ACTIONS(4074),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4074),
    [sym_int] = ACTIONS(4074),
    [sym_xint] = ACTIONS(4072),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4072),
    [sym__newline] = ACTIONS(4072),
    [sym__dedent] = ACTIONS(4072),
  },
  [2191] = {
    [sym_block_comment] = STATE(2191),
    [sym_compiler_directive_decl] = STATE(2191),
    [sym_fsi_directive_decl] = STATE(2191),
    [sym_preproc_line] = STATE(2191),
    [aux_sym_compound_type_repeat1] = STATE(2178),
    [ts_builtin_sym_end] = ACTIONS(3466),
    [sym_identifier] = ACTIONS(3468),
    [anon_sym_namespace] = ACTIONS(3468),
    [anon_sym_module] = ACTIONS(3468),
    [anon_sym_EQ] = ACTIONS(3466),
    [anon_sym_open] = ACTIONS(3468),
    [anon_sym_LBRACK_LT] = ACTIONS(3466),
    [anon_sym_COLON] = ACTIONS(3468),
    [anon_sym_return] = ACTIONS(3468),
    [anon_sym_type] = ACTIONS(3468),
    [anon_sym_do] = ACTIONS(3468),
    [anon_sym_let] = ACTIONS(3468),
    [anon_sym_let_BANG] = ACTIONS(3466),
    [anon_sym_LPAREN] = ACTIONS(3468),
    [anon_sym_COMMA] = ACTIONS(3466),
    [anon_sym_null] = ACTIONS(3468),
    [anon_sym_QMARK] = ACTIONS(3468),
    [anon_sym_COLON_QMARK] = ACTIONS(3468),
    [anon_sym_COLON_COLON] = ACTIONS(3466),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LBRACK] = ACTIONS(3468),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3466),
    [anon_sym_LBRACE] = ACTIONS(3468),
    [anon_sym_LT_AT] = ACTIONS(3468),
    [anon_sym_LT_AT_AT] = ACTIONS(3468),
    [anon_sym_DOT] = ACTIONS(3468),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3466),
    [anon_sym_new] = ACTIONS(3468),
    [anon_sym_return_BANG] = ACTIONS(3466),
    [anon_sym_yield] = ACTIONS(3468),
    [anon_sym_yield_BANG] = ACTIONS(3466),
    [anon_sym_lazy] = ACTIONS(3468),
    [anon_sym_assert] = ACTIONS(3468),
    [anon_sym_upcast] = ACTIONS(3468),
    [anon_sym_downcast] = ACTIONS(3468),
    [anon_sym_COLON_GT] = ACTIONS(3466),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3466),
    [anon_sym_for] = ACTIONS(3468),
    [anon_sym_while] = ACTIONS(3468),
    [anon_sym_if] = ACTIONS(3468),
    [anon_sym_fun] = ACTIONS(3468),
    [anon_sym_DASH_GT] = ACTIONS(3468),
    [anon_sym_try] = ACTIONS(3468),
    [anon_sym_match] = ACTIONS(3468),
    [anon_sym_match_BANG] = ACTIONS(3466),
    [anon_sym_function] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3468),
    [anon_sym_DOT_LBRACK] = ACTIONS(3466),
    [anon_sym_LT] = ACTIONS(3466),
    [anon_sym_use] = ACTIONS(3468),
    [anon_sym_use_BANG] = ACTIONS(3466),
    [anon_sym_do_BANG] = ACTIONS(3466),
    [anon_sym_begin] = ACTIONS(3468),
    [anon_sym_LPAREN2] = ACTIONS(3468),
    [anon_sym_STAR] = ACTIONS(4530),
    [anon_sym_LT2] = ACTIONS(3468),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3466),
    [anon_sym_or] = ACTIONS(3468),
    [anon_sym_exception] = ACTIONS(3468),
    [aux_sym_char_token1] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3468),
    [anon_sym_DQUOTE] = ACTIONS(3468),
    [anon_sym_AT_DQUOTE] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [sym_bool] = ACTIONS(3468),
    [sym_unit] = ACTIONS(3466),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3468),
    [sym_op_identifier] = ACTIONS(3468),
    [anon_sym_PLUS] = ACTIONS(3468),
    [anon_sym_DASH] = ACTIONS(3468),
    [anon_sym_PLUS_DOT] = ACTIONS(3468),
    [anon_sym_DASH_DOT] = ACTIONS(3468),
    [anon_sym_PERCENT] = ACTIONS(3468),
    [anon_sym_AMP_AMP] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3466),
    [aux_sym_prefix_op_token1] = ACTIONS(3468),
    [aux_sym_infix_op_token1] = ACTIONS(3466),
    [aux_sym_infix_op_token2] = ACTIONS(3468),
    [anon_sym_PIPE_PIPE] = ACTIONS(3468),
    [anon_sym_BANG_EQ] = ACTIONS(3468),
    [anon_sym_COLON_EQ] = ACTIONS(3466),
    [anon_sym_DOLLAR] = ACTIONS(3468),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3468),
    [sym_int] = ACTIONS(3468),
    [sym_xint] = ACTIONS(3466),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3466),
    [anon_sym_POUNDload] = ACTIONS(3466),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3466),
    [sym__newline] = ACTIONS(3466),
  },
  [2192] = {
    [sym_block_comment] = STATE(2192),
    [sym_compiler_directive_decl] = STATE(2192),
    [sym_fsi_directive_decl] = STATE(2192),
    [sym_preproc_line] = STATE(2192),
    [sym_identifier] = ACTIONS(4137),
    [anon_sym_EQ] = ACTIONS(4135),
    [anon_sym_LBRACK_LT] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4137),
    [anon_sym_return] = ACTIONS(4137),
    [anon_sym_do] = ACTIONS(4137),
    [anon_sym_let] = ACTIONS(4137),
    [anon_sym_let_BANG] = ACTIONS(4135),
    [aux_sym_access_modifier_token1] = ACTIONS(4135),
    [anon_sym_LPAREN] = ACTIONS(4137),
    [anon_sym_COMMA] = ACTIONS(4135),
    [anon_sym_null] = ACTIONS(4137),
    [anon_sym_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_COLON] = ACTIONS(4135),
    [anon_sym_AMP] = ACTIONS(4137),
    [anon_sym_LBRACK] = ACTIONS(4137),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4135),
    [anon_sym_LBRACE] = ACTIONS(4137),
    [anon_sym_LT_AT] = ACTIONS(4137),
    [anon_sym_LT_AT_AT] = ACTIONS(4137),
    [anon_sym_DOT] = ACTIONS(4137),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4135),
    [anon_sym_new] = ACTIONS(4137),
    [anon_sym_with] = ACTIONS(4137),
    [anon_sym_return_BANG] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_yield_BANG] = ACTIONS(4135),
    [anon_sym_lazy] = ACTIONS(4137),
    [anon_sym_assert] = ACTIONS(4137),
    [anon_sym_upcast] = ACTIONS(4137),
    [anon_sym_downcast] = ACTIONS(4137),
    [anon_sym_COLON_GT] = ACTIONS(4135),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4135),
    [anon_sym_for] = ACTIONS(4137),
    [anon_sym_while] = ACTIONS(4137),
    [anon_sym_if] = ACTIONS(4137),
    [anon_sym_fun] = ACTIONS(4137),
    [anon_sym_try] = ACTIONS(4137),
    [anon_sym_match] = ACTIONS(4137),
    [anon_sym_match_BANG] = ACTIONS(4135),
    [anon_sym_function] = ACTIONS(4137),
    [anon_sym_LT_DASH] = ACTIONS(4137),
    [anon_sym_DOT_LBRACK] = ACTIONS(4135),
    [anon_sym_LT] = ACTIONS(4135),
    [anon_sym_use] = ACTIONS(4137),
    [anon_sym_use_BANG] = ACTIONS(4135),
    [anon_sym_do_BANG] = ACTIONS(4135),
    [anon_sym_begin] = ACTIONS(4137),
    [anon_sym_LPAREN2] = ACTIONS(4137),
    [anon_sym_default] = ACTIONS(4137),
    [anon_sym_or] = ACTIONS(4137),
    [anon_sym_static] = ACTIONS(4137),
    [anon_sym_member] = ACTIONS(4137),
    [anon_sym_interface] = ACTIONS(4137),
    [anon_sym_abstract] = ACTIONS(4137),
    [anon_sym_val] = ACTIONS(4137),
    [anon_sym_override] = ACTIONS(4137),
    [anon_sym_inherit] = ACTIONS(4137),
    [aux_sym_char_token1] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4137),
    [anon_sym_DQUOTE] = ACTIONS(4137),
    [anon_sym_AT_DQUOTE] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [sym_bool] = ACTIONS(4137),
    [sym_unit] = ACTIONS(4135),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4137),
    [sym_op_identifier] = ACTIONS(4137),
    [anon_sym_PLUS] = ACTIONS(4137),
    [anon_sym_DASH] = ACTIONS(4137),
    [anon_sym_PLUS_DOT] = ACTIONS(4137),
    [anon_sym_DASH_DOT] = ACTIONS(4137),
    [anon_sym_PERCENT] = ACTIONS(4137),
    [anon_sym_AMP_AMP] = ACTIONS(4137),
    [anon_sym_TILDE] = ACTIONS(4135),
    [aux_sym_prefix_op_token1] = ACTIONS(4137),
    [aux_sym_infix_op_token1] = ACTIONS(4135),
    [aux_sym_infix_op_token2] = ACTIONS(4137),
    [anon_sym_PIPE_PIPE] = ACTIONS(4137),
    [anon_sym_BANG_EQ] = ACTIONS(4137),
    [anon_sym_COLON_EQ] = ACTIONS(4135),
    [anon_sym_DOLLAR] = ACTIONS(4137),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4137),
    [sym_int] = ACTIONS(4137),
    [sym_xint] = ACTIONS(4135),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4135),
    [anon_sym_POUNDendif] = ACTIONS(4135),
    [sym__newline] = ACTIONS(4135),
  },
  [2193] = {
    [sym_block_comment] = STATE(2193),
    [sym_compiler_directive_decl] = STATE(2193),
    [sym_fsi_directive_decl] = STATE(2193),
    [sym_preproc_line] = STATE(2193),
    [sym_identifier] = ACTIONS(4158),
    [anon_sym_EQ] = ACTIONS(4156),
    [anon_sym_LBRACK_LT] = ACTIONS(4156),
    [anon_sym_COLON] = ACTIONS(4158),
    [anon_sym_return] = ACTIONS(4158),
    [anon_sym_do] = ACTIONS(4158),
    [anon_sym_let] = ACTIONS(4158),
    [anon_sym_let_BANG] = ACTIONS(4156),
    [aux_sym_access_modifier_token1] = ACTIONS(4156),
    [anon_sym_LPAREN] = ACTIONS(4158),
    [anon_sym_COMMA] = ACTIONS(4156),
    [anon_sym_null] = ACTIONS(4158),
    [anon_sym_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_COLON] = ACTIONS(4156),
    [anon_sym_AMP] = ACTIONS(4158),
    [anon_sym_LBRACK] = ACTIONS(4158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(4158),
    [anon_sym_LT_AT] = ACTIONS(4158),
    [anon_sym_LT_AT_AT] = ACTIONS(4158),
    [anon_sym_DOT] = ACTIONS(4158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4156),
    [anon_sym_new] = ACTIONS(4158),
    [anon_sym_with] = ACTIONS(4158),
    [anon_sym_return_BANG] = ACTIONS(4156),
    [anon_sym_yield] = ACTIONS(4158),
    [anon_sym_yield_BANG] = ACTIONS(4156),
    [anon_sym_lazy] = ACTIONS(4158),
    [anon_sym_assert] = ACTIONS(4158),
    [anon_sym_upcast] = ACTIONS(4158),
    [anon_sym_downcast] = ACTIONS(4158),
    [anon_sym_COLON_GT] = ACTIONS(4156),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4156),
    [anon_sym_for] = ACTIONS(4158),
    [anon_sym_while] = ACTIONS(4158),
    [anon_sym_if] = ACTIONS(4158),
    [anon_sym_fun] = ACTIONS(4158),
    [anon_sym_try] = ACTIONS(4158),
    [anon_sym_match] = ACTIONS(4158),
    [anon_sym_match_BANG] = ACTIONS(4156),
    [anon_sym_function] = ACTIONS(4158),
    [anon_sym_LT_DASH] = ACTIONS(4158),
    [anon_sym_DOT_LBRACK] = ACTIONS(4156),
    [anon_sym_LT] = ACTIONS(4156),
    [anon_sym_use] = ACTIONS(4158),
    [anon_sym_use_BANG] = ACTIONS(4156),
    [anon_sym_do_BANG] = ACTIONS(4156),
    [anon_sym_begin] = ACTIONS(4158),
    [anon_sym_LPAREN2] = ACTIONS(4158),
    [anon_sym_DOT_DOT2] = ACTIONS(4156),
    [anon_sym_default] = ACTIONS(4158),
    [anon_sym_or] = ACTIONS(4158),
    [anon_sym_static] = ACTIONS(4158),
    [anon_sym_member] = ACTIONS(4158),
    [anon_sym_interface] = ACTIONS(4158),
    [anon_sym_abstract] = ACTIONS(4158),
    [anon_sym_val] = ACTIONS(4158),
    [anon_sym_override] = ACTIONS(4158),
    [aux_sym_char_token1] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4158),
    [anon_sym_DQUOTE] = ACTIONS(4158),
    [anon_sym_AT_DQUOTE] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [sym_bool] = ACTIONS(4158),
    [sym_unit] = ACTIONS(4156),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4158),
    [sym_op_identifier] = ACTIONS(4158),
    [anon_sym_PLUS] = ACTIONS(4158),
    [anon_sym_DASH] = ACTIONS(4158),
    [anon_sym_PLUS_DOT] = ACTIONS(4158),
    [anon_sym_DASH_DOT] = ACTIONS(4158),
    [anon_sym_PERCENT] = ACTIONS(4158),
    [anon_sym_AMP_AMP] = ACTIONS(4158),
    [anon_sym_TILDE] = ACTIONS(4156),
    [aux_sym_prefix_op_token1] = ACTIONS(4158),
    [aux_sym_infix_op_token1] = ACTIONS(4156),
    [aux_sym_infix_op_token2] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE] = ACTIONS(4158),
    [anon_sym_BANG_EQ] = ACTIONS(4158),
    [anon_sym_COLON_EQ] = ACTIONS(4156),
    [anon_sym_DOLLAR] = ACTIONS(4158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4158),
    [sym_int] = ACTIONS(4158),
    [sym_xint] = ACTIONS(4156),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4156),
    [sym__newline] = ACTIONS(4156),
    [sym__dedent] = ACTIONS(4156),
  },
  [2194] = {
    [sym_block_comment] = STATE(2194),
    [sym_compiler_directive_decl] = STATE(2194),
    [sym_fsi_directive_decl] = STATE(2194),
    [sym_preproc_line] = STATE(2194),
    [sym_identifier] = ACTIONS(4162),
    [anon_sym_EQ] = ACTIONS(4160),
    [anon_sym_LBRACK_LT] = ACTIONS(4160),
    [anon_sym_COLON] = ACTIONS(4162),
    [anon_sym_return] = ACTIONS(4162),
    [anon_sym_do] = ACTIONS(4162),
    [anon_sym_let] = ACTIONS(4162),
    [anon_sym_let_BANG] = ACTIONS(4160),
    [aux_sym_access_modifier_token1] = ACTIONS(4160),
    [anon_sym_LPAREN] = ACTIONS(4162),
    [anon_sym_COMMA] = ACTIONS(4160),
    [anon_sym_null] = ACTIONS(4162),
    [anon_sym_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4160),
    [anon_sym_AMP] = ACTIONS(4162),
    [anon_sym_LBRACK] = ACTIONS(4162),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4160),
    [anon_sym_LBRACE] = ACTIONS(4162),
    [anon_sym_LT_AT] = ACTIONS(4162),
    [anon_sym_LT_AT_AT] = ACTIONS(4162),
    [anon_sym_DOT] = ACTIONS(4162),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4160),
    [anon_sym_new] = ACTIONS(4162),
    [anon_sym_with] = ACTIONS(4162),
    [anon_sym_return_BANG] = ACTIONS(4160),
    [anon_sym_yield] = ACTIONS(4162),
    [anon_sym_yield_BANG] = ACTIONS(4160),
    [anon_sym_lazy] = ACTIONS(4162),
    [anon_sym_assert] = ACTIONS(4162),
    [anon_sym_upcast] = ACTIONS(4162),
    [anon_sym_downcast] = ACTIONS(4162),
    [anon_sym_COLON_GT] = ACTIONS(4160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4160),
    [anon_sym_for] = ACTIONS(4162),
    [anon_sym_while] = ACTIONS(4162),
    [anon_sym_if] = ACTIONS(4162),
    [anon_sym_fun] = ACTIONS(4162),
    [anon_sym_try] = ACTIONS(4162),
    [anon_sym_match] = ACTIONS(4162),
    [anon_sym_match_BANG] = ACTIONS(4160),
    [anon_sym_function] = ACTIONS(4162),
    [anon_sym_LT_DASH] = ACTIONS(4162),
    [anon_sym_DOT_LBRACK] = ACTIONS(4160),
    [anon_sym_LT] = ACTIONS(4160),
    [anon_sym_use] = ACTIONS(4162),
    [anon_sym_use_BANG] = ACTIONS(4160),
    [anon_sym_do_BANG] = ACTIONS(4160),
    [anon_sym_begin] = ACTIONS(4162),
    [anon_sym_LPAREN2] = ACTIONS(4162),
    [anon_sym_DOT_DOT2] = ACTIONS(4160),
    [anon_sym_default] = ACTIONS(4162),
    [anon_sym_or] = ACTIONS(4162),
    [anon_sym_static] = ACTIONS(4162),
    [anon_sym_member] = ACTIONS(4162),
    [anon_sym_interface] = ACTIONS(4162),
    [anon_sym_abstract] = ACTIONS(4162),
    [anon_sym_val] = ACTIONS(4162),
    [anon_sym_override] = ACTIONS(4162),
    [aux_sym_char_token1] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4162),
    [anon_sym_DQUOTE] = ACTIONS(4162),
    [anon_sym_AT_DQUOTE] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [sym_bool] = ACTIONS(4162),
    [sym_unit] = ACTIONS(4160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4162),
    [sym_op_identifier] = ACTIONS(4162),
    [anon_sym_PLUS] = ACTIONS(4162),
    [anon_sym_DASH] = ACTIONS(4162),
    [anon_sym_PLUS_DOT] = ACTIONS(4162),
    [anon_sym_DASH_DOT] = ACTIONS(4162),
    [anon_sym_PERCENT] = ACTIONS(4162),
    [anon_sym_AMP_AMP] = ACTIONS(4162),
    [anon_sym_TILDE] = ACTIONS(4160),
    [aux_sym_prefix_op_token1] = ACTIONS(4162),
    [aux_sym_infix_op_token1] = ACTIONS(4160),
    [aux_sym_infix_op_token2] = ACTIONS(4162),
    [anon_sym_PIPE_PIPE] = ACTIONS(4162),
    [anon_sym_BANG_EQ] = ACTIONS(4162),
    [anon_sym_COLON_EQ] = ACTIONS(4160),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4162),
    [sym_int] = ACTIONS(4162),
    [sym_xint] = ACTIONS(4160),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4160),
    [sym__newline] = ACTIONS(4160),
    [sym__dedent] = ACTIONS(4160),
  },
  [2195] = {
    [sym_block_comment] = STATE(2195),
    [sym_compiler_directive_decl] = STATE(2195),
    [sym_fsi_directive_decl] = STATE(2195),
    [sym_preproc_line] = STATE(2195),
    [sym_identifier] = ACTIONS(4182),
    [anon_sym_EQ] = ACTIONS(3689),
    [anon_sym_LBRACK_LT] = ACTIONS(3689),
    [anon_sym_COLON] = ACTIONS(4182),
    [anon_sym_return] = ACTIONS(4182),
    [anon_sym_do] = ACTIONS(4182),
    [anon_sym_let] = ACTIONS(4182),
    [anon_sym_let_BANG] = ACTIONS(3689),
    [aux_sym_access_modifier_token1] = ACTIONS(3689),
    [anon_sym_LPAREN] = ACTIONS(4182),
    [anon_sym_COMMA] = ACTIONS(3689),
    [anon_sym_null] = ACTIONS(4182),
    [anon_sym_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3689),
    [anon_sym_LBRACE] = ACTIONS(4182),
    [anon_sym_LT_AT] = ACTIONS(4182),
    [anon_sym_LT_AT_AT] = ACTIONS(4182),
    [anon_sym_DOT] = ACTIONS(4182),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3689),
    [anon_sym_new] = ACTIONS(4182),
    [anon_sym_with] = ACTIONS(4182),
    [anon_sym_return_BANG] = ACTIONS(3689),
    [anon_sym_yield] = ACTIONS(4182),
    [anon_sym_yield_BANG] = ACTIONS(3689),
    [anon_sym_lazy] = ACTIONS(4182),
    [anon_sym_assert] = ACTIONS(4182),
    [anon_sym_upcast] = ACTIONS(4182),
    [anon_sym_downcast] = ACTIONS(4182),
    [anon_sym_COLON_GT] = ACTIONS(3689),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3689),
    [anon_sym_for] = ACTIONS(4182),
    [anon_sym_while] = ACTIONS(4182),
    [anon_sym_if] = ACTIONS(4182),
    [anon_sym_fun] = ACTIONS(4182),
    [anon_sym_try] = ACTIONS(4182),
    [anon_sym_match] = ACTIONS(4182),
    [anon_sym_match_BANG] = ACTIONS(3689),
    [anon_sym_function] = ACTIONS(4182),
    [anon_sym_LT_DASH] = ACTIONS(4182),
    [anon_sym_DOT_LBRACK] = ACTIONS(3689),
    [anon_sym_LT] = ACTIONS(3689),
    [anon_sym_use] = ACTIONS(4182),
    [anon_sym_use_BANG] = ACTIONS(3689),
    [anon_sym_do_BANG] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(4182),
    [anon_sym_LPAREN2] = ACTIONS(4182),
    [anon_sym_DOT_DOT2] = ACTIONS(3689),
    [anon_sym_default] = ACTIONS(4182),
    [anon_sym_or] = ACTIONS(4182),
    [anon_sym_static] = ACTIONS(4182),
    [anon_sym_member] = ACTIONS(4182),
    [anon_sym_interface] = ACTIONS(4182),
    [anon_sym_abstract] = ACTIONS(4182),
    [anon_sym_val] = ACTIONS(4182),
    [anon_sym_override] = ACTIONS(4182),
    [aux_sym_char_token1] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4182),
    [anon_sym_DQUOTE] = ACTIONS(4182),
    [anon_sym_AT_DQUOTE] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [sym_bool] = ACTIONS(4182),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4182),
    [sym_op_identifier] = ACTIONS(4182),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_PLUS_DOT] = ACTIONS(4182),
    [anon_sym_DASH_DOT] = ACTIONS(4182),
    [anon_sym_PERCENT] = ACTIONS(4182),
    [anon_sym_AMP_AMP] = ACTIONS(4182),
    [anon_sym_TILDE] = ACTIONS(3689),
    [aux_sym_prefix_op_token1] = ACTIONS(4182),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token2] = ACTIONS(4182),
    [anon_sym_PIPE_PIPE] = ACTIONS(4182),
    [anon_sym_BANG_EQ] = ACTIONS(4182),
    [anon_sym_COLON_EQ] = ACTIONS(3689),
    [anon_sym_DOLLAR] = ACTIONS(4182),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4182),
    [sym_int] = ACTIONS(4182),
    [sym_xint] = ACTIONS(3689),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3689),
    [sym__newline] = ACTIONS(3689),
    [sym__dedent] = ACTIONS(3689),
  },
  [2196] = {
    [sym_block_comment] = STATE(2196),
    [sym_compiler_directive_decl] = STATE(2196),
    [sym_fsi_directive_decl] = STATE(2196),
    [sym_preproc_line] = STATE(2196),
    [sym_identifier] = ACTIONS(4224),
    [anon_sym_EQ] = ACTIONS(4222),
    [anon_sym_LBRACK_LT] = ACTIONS(4222),
    [anon_sym_COLON] = ACTIONS(4224),
    [anon_sym_return] = ACTIONS(4224),
    [anon_sym_do] = ACTIONS(4224),
    [anon_sym_let] = ACTIONS(4224),
    [anon_sym_let_BANG] = ACTIONS(4222),
    [aux_sym_access_modifier_token1] = ACTIONS(4222),
    [anon_sym_LPAREN] = ACTIONS(4224),
    [anon_sym_COMMA] = ACTIONS(4222),
    [anon_sym_null] = ACTIONS(4224),
    [anon_sym_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_COLON] = ACTIONS(4222),
    [anon_sym_AMP] = ACTIONS(4224),
    [anon_sym_LBRACK] = ACTIONS(4224),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4222),
    [anon_sym_LBRACE] = ACTIONS(4224),
    [anon_sym_LT_AT] = ACTIONS(4224),
    [anon_sym_LT_AT_AT] = ACTIONS(4224),
    [anon_sym_DOT] = ACTIONS(4224),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4222),
    [anon_sym_new] = ACTIONS(4224),
    [anon_sym_with] = ACTIONS(4224),
    [anon_sym_return_BANG] = ACTIONS(4222),
    [anon_sym_yield] = ACTIONS(4224),
    [anon_sym_yield_BANG] = ACTIONS(4222),
    [anon_sym_lazy] = ACTIONS(4224),
    [anon_sym_assert] = ACTIONS(4224),
    [anon_sym_upcast] = ACTIONS(4224),
    [anon_sym_downcast] = ACTIONS(4224),
    [anon_sym_COLON_GT] = ACTIONS(4222),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4222),
    [anon_sym_for] = ACTIONS(4224),
    [anon_sym_while] = ACTIONS(4224),
    [anon_sym_if] = ACTIONS(4224),
    [anon_sym_fun] = ACTIONS(4224),
    [anon_sym_try] = ACTIONS(4224),
    [anon_sym_match] = ACTIONS(4224),
    [anon_sym_match_BANG] = ACTIONS(4222),
    [anon_sym_function] = ACTIONS(4224),
    [anon_sym_LT_DASH] = ACTIONS(4224),
    [anon_sym_DOT_LBRACK] = ACTIONS(4222),
    [anon_sym_LT] = ACTIONS(4222),
    [anon_sym_use] = ACTIONS(4224),
    [anon_sym_use_BANG] = ACTIONS(4222),
    [anon_sym_do_BANG] = ACTIONS(4222),
    [anon_sym_begin] = ACTIONS(4224),
    [anon_sym_LPAREN2] = ACTIONS(4224),
    [anon_sym_DOT_DOT2] = ACTIONS(4222),
    [anon_sym_default] = ACTIONS(4224),
    [anon_sym_or] = ACTIONS(4224),
    [anon_sym_static] = ACTIONS(4224),
    [anon_sym_member] = ACTIONS(4224),
    [anon_sym_interface] = ACTIONS(4224),
    [anon_sym_abstract] = ACTIONS(4224),
    [anon_sym_val] = ACTIONS(4224),
    [anon_sym_override] = ACTIONS(4224),
    [aux_sym_char_token1] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4224),
    [anon_sym_DQUOTE] = ACTIONS(4224),
    [anon_sym_AT_DQUOTE] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [sym_bool] = ACTIONS(4224),
    [sym_unit] = ACTIONS(4222),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4224),
    [sym_op_identifier] = ACTIONS(4224),
    [anon_sym_PLUS] = ACTIONS(4224),
    [anon_sym_DASH] = ACTIONS(4224),
    [anon_sym_PLUS_DOT] = ACTIONS(4224),
    [anon_sym_DASH_DOT] = ACTIONS(4224),
    [anon_sym_PERCENT] = ACTIONS(4224),
    [anon_sym_AMP_AMP] = ACTIONS(4224),
    [anon_sym_TILDE] = ACTIONS(4222),
    [aux_sym_prefix_op_token1] = ACTIONS(4224),
    [aux_sym_infix_op_token1] = ACTIONS(4222),
    [aux_sym_infix_op_token2] = ACTIONS(4224),
    [anon_sym_PIPE_PIPE] = ACTIONS(4224),
    [anon_sym_BANG_EQ] = ACTIONS(4224),
    [anon_sym_COLON_EQ] = ACTIONS(4222),
    [anon_sym_DOLLAR] = ACTIONS(4224),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4224),
    [sym_int] = ACTIONS(4224),
    [sym_xint] = ACTIONS(4222),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4222),
    [sym__newline] = ACTIONS(4222),
    [sym__dedent] = ACTIONS(4222),
  },
  [2197] = {
    [sym_block_comment] = STATE(2197),
    [sym_compiler_directive_decl] = STATE(2197),
    [sym_fsi_directive_decl] = STATE(2197),
    [sym_preproc_line] = STATE(2197),
    [aux_sym_long_identifier_repeat1] = STATE(1957),
    [ts_builtin_sym_end] = ACTIONS(3492),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_namespace] = ACTIONS(3494),
    [anon_sym_module] = ACTIONS(3494),
    [anon_sym_EQ] = ACTIONS(3492),
    [anon_sym_open] = ACTIONS(3494),
    [anon_sym_LBRACK_LT] = ACTIONS(3492),
    [anon_sym_COLON] = ACTIONS(3494),
    [anon_sym_return] = ACTIONS(3494),
    [anon_sym_type] = ACTIONS(3494),
    [anon_sym_do] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_let_BANG] = ACTIONS(3492),
    [anon_sym_LPAREN] = ACTIONS(3494),
    [anon_sym_COMMA] = ACTIONS(3492),
    [anon_sym_null] = ACTIONS(3494),
    [anon_sym_QMARK] = ACTIONS(3494),
    [anon_sym_COLON_QMARK] = ACTIONS(3494),
    [anon_sym_COLON_COLON] = ACTIONS(3492),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3492),
    [anon_sym_LBRACE] = ACTIONS(3494),
    [anon_sym_LT_AT] = ACTIONS(3494),
    [anon_sym_LT_AT_AT] = ACTIONS(3494),
    [anon_sym_DOT] = ACTIONS(4743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3492),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_return_BANG] = ACTIONS(3492),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_yield_BANG] = ACTIONS(3492),
    [anon_sym_lazy] = ACTIONS(3494),
    [anon_sym_assert] = ACTIONS(3494),
    [anon_sym_upcast] = ACTIONS(3494),
    [anon_sym_downcast] = ACTIONS(3494),
    [anon_sym_COLON_GT] = ACTIONS(3492),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3492),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_while] = ACTIONS(3494),
    [anon_sym_if] = ACTIONS(3494),
    [anon_sym_fun] = ACTIONS(3494),
    [anon_sym_DASH_GT] = ACTIONS(3494),
    [anon_sym_try] = ACTIONS(3494),
    [anon_sym_match] = ACTIONS(3494),
    [anon_sym_match_BANG] = ACTIONS(3492),
    [anon_sym_function] = ACTIONS(3494),
    [anon_sym_LT_DASH] = ACTIONS(3494),
    [anon_sym_DOT_LBRACK] = ACTIONS(3492),
    [anon_sym_LT] = ACTIONS(3492),
    [anon_sym_use] = ACTIONS(3494),
    [anon_sym_use_BANG] = ACTIONS(3492),
    [anon_sym_do_BANG] = ACTIONS(3492),
    [anon_sym_begin] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(3494),
    [anon_sym_STAR] = ACTIONS(3494),
    [anon_sym_LT2] = ACTIONS(3494),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3492),
    [anon_sym_or] = ACTIONS(3494),
    [anon_sym_exception] = ACTIONS(3494),
    [aux_sym_char_token1] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3494),
    [anon_sym_DQUOTE] = ACTIONS(3494),
    [anon_sym_AT_DQUOTE] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [sym_bool] = ACTIONS(3494),
    [sym_unit] = ACTIONS(3492),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3494),
    [sym_op_identifier] = ACTIONS(3494),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_PLUS_DOT] = ACTIONS(3494),
    [anon_sym_DASH_DOT] = ACTIONS(3494),
    [anon_sym_PERCENT] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_TILDE] = ACTIONS(3492),
    [aux_sym_prefix_op_token1] = ACTIONS(3494),
    [aux_sym_infix_op_token1] = ACTIONS(3492),
    [aux_sym_infix_op_token2] = ACTIONS(3494),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_COLON_EQ] = ACTIONS(3492),
    [anon_sym_DOLLAR] = ACTIONS(3494),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3494),
    [sym_int] = ACTIONS(3494),
    [sym_xint] = ACTIONS(3492),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3492),
    [anon_sym_POUNDload] = ACTIONS(3492),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3492),
    [sym__newline] = ACTIONS(3492),
  },
  [2198] = {
    [sym_block_comment] = STATE(2198),
    [sym_compiler_directive_decl] = STATE(2198),
    [sym_fsi_directive_decl] = STATE(2198),
    [sym_preproc_line] = STATE(2198),
    [sym_identifier] = ACTIONS(4022),
    [anon_sym_EQ] = ACTIONS(4020),
    [anon_sym_LBRACK_LT] = ACTIONS(4020),
    [anon_sym_COLON] = ACTIONS(4022),
    [anon_sym_return] = ACTIONS(4022),
    [anon_sym_do] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_let_BANG] = ACTIONS(4020),
    [aux_sym_access_modifier_token1] = ACTIONS(4020),
    [anon_sym_LPAREN] = ACTIONS(4022),
    [anon_sym_COMMA] = ACTIONS(4020),
    [anon_sym_null] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_COLON] = ACTIONS(4020),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4022),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(4022),
    [anon_sym_LT_AT] = ACTIONS(4022),
    [anon_sym_LT_AT_AT] = ACTIONS(4022),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4020),
    [anon_sym_new] = ACTIONS(4022),
    [anon_sym_with] = ACTIONS(4022),
    [anon_sym_return_BANG] = ACTIONS(4020),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_yield_BANG] = ACTIONS(4020),
    [anon_sym_lazy] = ACTIONS(4022),
    [anon_sym_assert] = ACTIONS(4022),
    [anon_sym_upcast] = ACTIONS(4022),
    [anon_sym_downcast] = ACTIONS(4022),
    [anon_sym_COLON_GT] = ACTIONS(4020),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4020),
    [anon_sym_for] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4022),
    [anon_sym_if] = ACTIONS(4022),
    [anon_sym_fun] = ACTIONS(4022),
    [anon_sym_try] = ACTIONS(4022),
    [anon_sym_match] = ACTIONS(4022),
    [anon_sym_match_BANG] = ACTIONS(4020),
    [anon_sym_function] = ACTIONS(4022),
    [anon_sym_LT_DASH] = ACTIONS(4022),
    [anon_sym_DOT_LBRACK] = ACTIONS(4020),
    [anon_sym_LT] = ACTIONS(4020),
    [anon_sym_use] = ACTIONS(4022),
    [anon_sym_use_BANG] = ACTIONS(4020),
    [anon_sym_do_BANG] = ACTIONS(4020),
    [anon_sym_begin] = ACTIONS(4022),
    [anon_sym_LPAREN2] = ACTIONS(4022),
    [anon_sym_DOT_DOT2] = ACTIONS(4020),
    [anon_sym_default] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_static] = ACTIONS(4022),
    [anon_sym_member] = ACTIONS(4022),
    [anon_sym_interface] = ACTIONS(4022),
    [anon_sym_abstract] = ACTIONS(4022),
    [anon_sym_val] = ACTIONS(4022),
    [anon_sym_override] = ACTIONS(4022),
    [aux_sym_char_token1] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4022),
    [anon_sym_DQUOTE] = ACTIONS(4022),
    [anon_sym_AT_DQUOTE] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [sym_bool] = ACTIONS(4022),
    [sym_unit] = ACTIONS(4020),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4022),
    [sym_op_identifier] = ACTIONS(4022),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_PLUS_DOT] = ACTIONS(4022),
    [anon_sym_DASH_DOT] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4022),
    [anon_sym_TILDE] = ACTIONS(4020),
    [aux_sym_prefix_op_token1] = ACTIONS(4022),
    [aux_sym_infix_op_token1] = ACTIONS(4020),
    [aux_sym_infix_op_token2] = ACTIONS(4022),
    [anon_sym_PIPE_PIPE] = ACTIONS(4022),
    [anon_sym_BANG_EQ] = ACTIONS(4022),
    [anon_sym_COLON_EQ] = ACTIONS(4020),
    [anon_sym_DOLLAR] = ACTIONS(4022),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4022),
    [sym_int] = ACTIONS(4022),
    [sym_xint] = ACTIONS(4020),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4020),
    [sym__newline] = ACTIONS(4020),
    [sym__dedent] = ACTIONS(4020),
  },
  [2199] = {
    [sym_block_comment] = STATE(2199),
    [sym_compiler_directive_decl] = STATE(2199),
    [sym_fsi_directive_decl] = STATE(2199),
    [sym_preproc_line] = STATE(2199),
    [sym_identifier] = ACTIONS(4064),
    [anon_sym_EQ] = ACTIONS(4062),
    [anon_sym_LBRACK_LT] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4064),
    [anon_sym_return] = ACTIONS(4064),
    [anon_sym_do] = ACTIONS(4064),
    [anon_sym_let] = ACTIONS(4064),
    [anon_sym_let_BANG] = ACTIONS(4062),
    [aux_sym_access_modifier_token1] = ACTIONS(4062),
    [anon_sym_LPAREN] = ACTIONS(4064),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_null] = ACTIONS(4064),
    [anon_sym_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_COLON] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4062),
    [anon_sym_LBRACE] = ACTIONS(4064),
    [anon_sym_LT_AT] = ACTIONS(4064),
    [anon_sym_LT_AT_AT] = ACTIONS(4064),
    [anon_sym_DOT] = ACTIONS(4064),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4062),
    [anon_sym_new] = ACTIONS(4064),
    [anon_sym_with] = ACTIONS(4064),
    [anon_sym_return_BANG] = ACTIONS(4062),
    [anon_sym_yield] = ACTIONS(4064),
    [anon_sym_yield_BANG] = ACTIONS(4062),
    [anon_sym_lazy] = ACTIONS(4064),
    [anon_sym_assert] = ACTIONS(4064),
    [anon_sym_upcast] = ACTIONS(4064),
    [anon_sym_downcast] = ACTIONS(4064),
    [anon_sym_COLON_GT] = ACTIONS(4062),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4062),
    [anon_sym_for] = ACTIONS(4064),
    [anon_sym_while] = ACTIONS(4064),
    [anon_sym_if] = ACTIONS(4064),
    [anon_sym_fun] = ACTIONS(4064),
    [anon_sym_try] = ACTIONS(4064),
    [anon_sym_match] = ACTIONS(4064),
    [anon_sym_match_BANG] = ACTIONS(4062),
    [anon_sym_function] = ACTIONS(4064),
    [anon_sym_LT_DASH] = ACTIONS(4064),
    [anon_sym_DOT_LBRACK] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(4062),
    [anon_sym_use] = ACTIONS(4064),
    [anon_sym_use_BANG] = ACTIONS(4062),
    [anon_sym_do_BANG] = ACTIONS(4062),
    [anon_sym_begin] = ACTIONS(4064),
    [anon_sym_LPAREN2] = ACTIONS(4064),
    [anon_sym_default] = ACTIONS(4064),
    [anon_sym_or] = ACTIONS(4064),
    [anon_sym_static] = ACTIONS(4064),
    [anon_sym_member] = ACTIONS(4064),
    [anon_sym_interface] = ACTIONS(4064),
    [anon_sym_abstract] = ACTIONS(4064),
    [anon_sym_val] = ACTIONS(4064),
    [anon_sym_override] = ACTIONS(4064),
    [anon_sym_inherit] = ACTIONS(4064),
    [aux_sym_char_token1] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_AT_DQUOTE] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [sym_bool] = ACTIONS(4064),
    [sym_unit] = ACTIONS(4062),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4064),
    [sym_op_identifier] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4064),
    [anon_sym_DASH] = ACTIONS(4064),
    [anon_sym_PLUS_DOT] = ACTIONS(4064),
    [anon_sym_DASH_DOT] = ACTIONS(4064),
    [anon_sym_PERCENT] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_TILDE] = ACTIONS(4062),
    [aux_sym_prefix_op_token1] = ACTIONS(4064),
    [aux_sym_infix_op_token1] = ACTIONS(4062),
    [aux_sym_infix_op_token2] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_BANG_EQ] = ACTIONS(4064),
    [anon_sym_COLON_EQ] = ACTIONS(4062),
    [anon_sym_DOLLAR] = ACTIONS(4064),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4064),
    [sym_int] = ACTIONS(4064),
    [sym_xint] = ACTIONS(4062),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4062),
    [anon_sym_POUNDendif] = ACTIONS(4062),
    [sym__newline] = ACTIONS(4062),
  },
  [2200] = {
    [sym_block_comment] = STATE(2200),
    [sym_compiler_directive_decl] = STATE(2200),
    [sym_fsi_directive_decl] = STATE(2200),
    [sym_preproc_line] = STATE(2200),
    [aux_sym_long_identifier_repeat1] = STATE(1980),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_GT_RBRACK] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_RBRACK] = ACTIONS(3449),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_RBRACE] = ACTIONS(3449),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(4749),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_to] = ACTIONS(3451),
    [anon_sym_downto] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_DASH_GT] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_DOT_DOT2] = ACTIONS(3449),
    [anon_sym_STAR] = ACTIONS(3451),
    [anon_sym_LT2] = ACTIONS(3451),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3449),
    [anon_sym_or] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
  },
  [2201] = {
    [sym_block_comment] = STATE(2201),
    [sym_compiler_directive_decl] = STATE(2201),
    [sym_fsi_directive_decl] = STATE(2201),
    [sym_preproc_line] = STATE(2201),
    [sym_identifier] = ACTIONS(4011),
    [anon_sym_EQ] = ACTIONS(4009),
    [anon_sym_LBRACK_LT] = ACTIONS(4009),
    [anon_sym_COLON] = ACTIONS(4011),
    [anon_sym_return] = ACTIONS(4011),
    [anon_sym_do] = ACTIONS(4011),
    [anon_sym_let] = ACTIONS(4011),
    [anon_sym_let_BANG] = ACTIONS(4009),
    [aux_sym_access_modifier_token1] = ACTIONS(4009),
    [anon_sym_LPAREN] = ACTIONS(4011),
    [anon_sym_COMMA] = ACTIONS(4009),
    [anon_sym_null] = ACTIONS(4011),
    [anon_sym_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(4011),
    [anon_sym_LBRACK] = ACTIONS(4011),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4009),
    [anon_sym_LBRACE] = ACTIONS(4011),
    [anon_sym_LT_AT] = ACTIONS(4011),
    [anon_sym_LT_AT_AT] = ACTIONS(4011),
    [anon_sym_DOT] = ACTIONS(4011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4009),
    [anon_sym_new] = ACTIONS(4011),
    [anon_sym_with] = ACTIONS(4011),
    [anon_sym_return_BANG] = ACTIONS(4009),
    [anon_sym_yield] = ACTIONS(4011),
    [anon_sym_yield_BANG] = ACTIONS(4009),
    [anon_sym_lazy] = ACTIONS(4011),
    [anon_sym_assert] = ACTIONS(4011),
    [anon_sym_upcast] = ACTIONS(4011),
    [anon_sym_downcast] = ACTIONS(4011),
    [anon_sym_COLON_GT] = ACTIONS(4009),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4009),
    [anon_sym_for] = ACTIONS(4011),
    [anon_sym_while] = ACTIONS(4011),
    [anon_sym_if] = ACTIONS(4011),
    [anon_sym_fun] = ACTIONS(4011),
    [anon_sym_try] = ACTIONS(4011),
    [anon_sym_match] = ACTIONS(4011),
    [anon_sym_match_BANG] = ACTIONS(4009),
    [anon_sym_function] = ACTIONS(4011),
    [anon_sym_LT_DASH] = ACTIONS(4011),
    [anon_sym_DOT_LBRACK] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(4009),
    [anon_sym_use] = ACTIONS(4011),
    [anon_sym_use_BANG] = ACTIONS(4009),
    [anon_sym_do_BANG] = ACTIONS(4009),
    [anon_sym_begin] = ACTIONS(4011),
    [anon_sym_LPAREN2] = ACTIONS(4011),
    [anon_sym_DOT_DOT2] = ACTIONS(4009),
    [anon_sym_default] = ACTIONS(4011),
    [anon_sym_or] = ACTIONS(4011),
    [anon_sym_static] = ACTIONS(4011),
    [anon_sym_member] = ACTIONS(4011),
    [anon_sym_interface] = ACTIONS(4011),
    [anon_sym_abstract] = ACTIONS(4011),
    [anon_sym_val] = ACTIONS(4011),
    [anon_sym_override] = ACTIONS(4011),
    [aux_sym_char_token1] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4011),
    [anon_sym_DQUOTE] = ACTIONS(4011),
    [anon_sym_AT_DQUOTE] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [sym_bool] = ACTIONS(4011),
    [sym_unit] = ACTIONS(4009),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4011),
    [sym_op_identifier] = ACTIONS(4011),
    [anon_sym_PLUS] = ACTIONS(4011),
    [anon_sym_DASH] = ACTIONS(4011),
    [anon_sym_PLUS_DOT] = ACTIONS(4011),
    [anon_sym_DASH_DOT] = ACTIONS(4011),
    [anon_sym_PERCENT] = ACTIONS(4011),
    [anon_sym_AMP_AMP] = ACTIONS(4011),
    [anon_sym_TILDE] = ACTIONS(4009),
    [aux_sym_prefix_op_token1] = ACTIONS(4011),
    [aux_sym_infix_op_token1] = ACTIONS(4009),
    [aux_sym_infix_op_token2] = ACTIONS(4011),
    [anon_sym_PIPE_PIPE] = ACTIONS(4011),
    [anon_sym_BANG_EQ] = ACTIONS(4011),
    [anon_sym_COLON_EQ] = ACTIONS(4009),
    [anon_sym_DOLLAR] = ACTIONS(4011),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4011),
    [sym_int] = ACTIONS(4011),
    [sym_xint] = ACTIONS(4009),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4009),
    [sym__newline] = ACTIONS(4009),
    [sym__dedent] = ACTIONS(4009),
  },
  [2202] = {
    [sym__else_expression] = STATE(2442),
    [sym_elif_expression] = STATE(2274),
    [sym_block_comment] = STATE(2202),
    [sym_compiler_directive_decl] = STATE(2202),
    [sym_fsi_directive_decl] = STATE(2202),
    [sym_preproc_line] = STATE(2202),
    [aux_sym_if_expression_repeat1] = STATE(2229),
    [ts_builtin_sym_end] = ACTIONS(3455),
    [sym_identifier] = ACTIONS(3457),
    [anon_sym_namespace] = ACTIONS(3457),
    [anon_sym_module] = ACTIONS(3457),
    [anon_sym_EQ] = ACTIONS(3455),
    [anon_sym_open] = ACTIONS(3457),
    [anon_sym_LBRACK_LT] = ACTIONS(3455),
    [anon_sym_COLON] = ACTIONS(3457),
    [anon_sym_return] = ACTIONS(3457),
    [anon_sym_type] = ACTIONS(3457),
    [anon_sym_do] = ACTIONS(3457),
    [anon_sym_let] = ACTIONS(3457),
    [anon_sym_let_BANG] = ACTIONS(3455),
    [anon_sym_LPAREN] = ACTIONS(3457),
    [anon_sym_COMMA] = ACTIONS(3455),
    [anon_sym_null] = ACTIONS(3457),
    [anon_sym_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_COLON] = ACTIONS(3455),
    [anon_sym_AMP] = ACTIONS(3457),
    [anon_sym_LBRACK] = ACTIONS(3457),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3457),
    [anon_sym_LT_AT] = ACTIONS(3457),
    [anon_sym_LT_AT_AT] = ACTIONS(3457),
    [anon_sym_DOT] = ACTIONS(3457),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3457),
    [anon_sym_return_BANG] = ACTIONS(3455),
    [anon_sym_yield] = ACTIONS(3457),
    [anon_sym_yield_BANG] = ACTIONS(3455),
    [anon_sym_lazy] = ACTIONS(3457),
    [anon_sym_assert] = ACTIONS(3457),
    [anon_sym_upcast] = ACTIONS(3457),
    [anon_sym_downcast] = ACTIONS(3457),
    [anon_sym_COLON_GT] = ACTIONS(3455),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3457),
    [anon_sym_while] = ACTIONS(3457),
    [anon_sym_else] = ACTIONS(4779),
    [anon_sym_elif] = ACTIONS(4781),
    [anon_sym_if] = ACTIONS(3457),
    [anon_sym_fun] = ACTIONS(3457),
    [anon_sym_try] = ACTIONS(3457),
    [anon_sym_match] = ACTIONS(3457),
    [anon_sym_match_BANG] = ACTIONS(3455),
    [anon_sym_function] = ACTIONS(3457),
    [anon_sym_LT_DASH] = ACTIONS(3457),
    [anon_sym_DOT_LBRACK] = ACTIONS(3455),
    [anon_sym_LT] = ACTIONS(3455),
    [anon_sym_use] = ACTIONS(3457),
    [anon_sym_use_BANG] = ACTIONS(3455),
    [anon_sym_do_BANG] = ACTIONS(3455),
    [anon_sym_begin] = ACTIONS(3457),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_or] = ACTIONS(3457),
    [anon_sym_exception] = ACTIONS(3457),
    [aux_sym_char_token1] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [anon_sym_AT_DQUOTE] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [sym_bool] = ACTIONS(3457),
    [sym_unit] = ACTIONS(3455),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3457),
    [sym_op_identifier] = ACTIONS(3457),
    [anon_sym_PLUS] = ACTIONS(3457),
    [anon_sym_DASH] = ACTIONS(3457),
    [anon_sym_PLUS_DOT] = ACTIONS(3457),
    [anon_sym_DASH_DOT] = ACTIONS(3457),
    [anon_sym_PERCENT] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3455),
    [aux_sym_prefix_op_token1] = ACTIONS(3457),
    [aux_sym_infix_op_token1] = ACTIONS(3455),
    [aux_sym_infix_op_token2] = ACTIONS(3457),
    [anon_sym_PIPE_PIPE] = ACTIONS(3457),
    [anon_sym_BANG_EQ] = ACTIONS(3457),
    [anon_sym_COLON_EQ] = ACTIONS(3455),
    [anon_sym_DOLLAR] = ACTIONS(3457),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3457),
    [sym_int] = ACTIONS(3457),
    [sym_xint] = ACTIONS(3455),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3455),
    [anon_sym_POUNDload] = ACTIONS(3455),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3455),
    [sym__newline] = ACTIONS(3455),
  },
  [2203] = {
    [sym_block_comment] = STATE(2203),
    [sym_compiler_directive_decl] = STATE(2203),
    [sym_fsi_directive_decl] = STATE(2203),
    [sym_preproc_line] = STATE(2203),
    [sym_identifier] = ACTIONS(4007),
    [anon_sym_EQ] = ACTIONS(4005),
    [anon_sym_LBRACK_LT] = ACTIONS(4005),
    [anon_sym_COLON] = ACTIONS(4007),
    [anon_sym_return] = ACTIONS(4007),
    [anon_sym_do] = ACTIONS(4007),
    [anon_sym_let] = ACTIONS(4007),
    [anon_sym_let_BANG] = ACTIONS(4005),
    [aux_sym_access_modifier_token1] = ACTIONS(4005),
    [anon_sym_LPAREN] = ACTIONS(4007),
    [anon_sym_COMMA] = ACTIONS(4005),
    [anon_sym_null] = ACTIONS(4007),
    [anon_sym_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_COLON] = ACTIONS(4005),
    [anon_sym_AMP] = ACTIONS(4007),
    [anon_sym_LBRACK] = ACTIONS(4007),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4005),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_LT_AT] = ACTIONS(4007),
    [anon_sym_LT_AT_AT] = ACTIONS(4007),
    [anon_sym_DOT] = ACTIONS(4007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4005),
    [anon_sym_new] = ACTIONS(4007),
    [anon_sym_with] = ACTIONS(4007),
    [anon_sym_return_BANG] = ACTIONS(4005),
    [anon_sym_yield] = ACTIONS(4007),
    [anon_sym_yield_BANG] = ACTIONS(4005),
    [anon_sym_lazy] = ACTIONS(4007),
    [anon_sym_assert] = ACTIONS(4007),
    [anon_sym_upcast] = ACTIONS(4007),
    [anon_sym_downcast] = ACTIONS(4007),
    [anon_sym_COLON_GT] = ACTIONS(4005),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4005),
    [anon_sym_for] = ACTIONS(4007),
    [anon_sym_while] = ACTIONS(4007),
    [anon_sym_if] = ACTIONS(4007),
    [anon_sym_fun] = ACTIONS(4007),
    [anon_sym_try] = ACTIONS(4007),
    [anon_sym_match] = ACTIONS(4007),
    [anon_sym_match_BANG] = ACTIONS(4005),
    [anon_sym_function] = ACTIONS(4007),
    [anon_sym_LT_DASH] = ACTIONS(4007),
    [anon_sym_DOT_LBRACK] = ACTIONS(4005),
    [anon_sym_LT] = ACTIONS(4005),
    [anon_sym_use] = ACTIONS(4007),
    [anon_sym_use_BANG] = ACTIONS(4005),
    [anon_sym_do_BANG] = ACTIONS(4005),
    [anon_sym_begin] = ACTIONS(4007),
    [anon_sym_LPAREN2] = ACTIONS(4007),
    [anon_sym_DOT_DOT2] = ACTIONS(4005),
    [anon_sym_default] = ACTIONS(4007),
    [anon_sym_or] = ACTIONS(4007),
    [anon_sym_static] = ACTIONS(4007),
    [anon_sym_member] = ACTIONS(4007),
    [anon_sym_interface] = ACTIONS(4007),
    [anon_sym_abstract] = ACTIONS(4007),
    [anon_sym_val] = ACTIONS(4007),
    [anon_sym_override] = ACTIONS(4007),
    [aux_sym_char_token1] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4007),
    [anon_sym_DQUOTE] = ACTIONS(4007),
    [anon_sym_AT_DQUOTE] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [sym_bool] = ACTIONS(4007),
    [sym_unit] = ACTIONS(4005),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4007),
    [sym_op_identifier] = ACTIONS(4007),
    [anon_sym_PLUS] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4007),
    [anon_sym_PLUS_DOT] = ACTIONS(4007),
    [anon_sym_DASH_DOT] = ACTIONS(4007),
    [anon_sym_PERCENT] = ACTIONS(4007),
    [anon_sym_AMP_AMP] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4005),
    [aux_sym_prefix_op_token1] = ACTIONS(4007),
    [aux_sym_infix_op_token1] = ACTIONS(4005),
    [aux_sym_infix_op_token2] = ACTIONS(4007),
    [anon_sym_PIPE_PIPE] = ACTIONS(4007),
    [anon_sym_BANG_EQ] = ACTIONS(4007),
    [anon_sym_COLON_EQ] = ACTIONS(4005),
    [anon_sym_DOLLAR] = ACTIONS(4007),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4007),
    [sym_int] = ACTIONS(4007),
    [sym_xint] = ACTIONS(4005),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4005),
    [sym__newline] = ACTIONS(4005),
    [sym__dedent] = ACTIONS(4005),
  },
  [2204] = {
    [sym_block_comment] = STATE(2204),
    [sym_compiler_directive_decl] = STATE(2204),
    [sym_fsi_directive_decl] = STATE(2204),
    [sym_preproc_line] = STATE(2204),
    [sym_identifier] = ACTIONS(3954),
    [anon_sym_EQ] = ACTIONS(3952),
    [anon_sym_LBRACK_LT] = ACTIONS(3952),
    [anon_sym_COLON] = ACTIONS(3954),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_do] = ACTIONS(3954),
    [anon_sym_let] = ACTIONS(3954),
    [anon_sym_let_BANG] = ACTIONS(3952),
    [aux_sym_access_modifier_token1] = ACTIONS(3952),
    [anon_sym_LPAREN] = ACTIONS(3954),
    [anon_sym_COMMA] = ACTIONS(3952),
    [anon_sym_null] = ACTIONS(3954),
    [anon_sym_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_COLON] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3954),
    [anon_sym_LBRACK] = ACTIONS(3954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(3954),
    [anon_sym_LT_AT] = ACTIONS(3954),
    [anon_sym_LT_AT_AT] = ACTIONS(3954),
    [anon_sym_DOT] = ACTIONS(3954),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3952),
    [anon_sym_new] = ACTIONS(3954),
    [anon_sym_with] = ACTIONS(3954),
    [anon_sym_return_BANG] = ACTIONS(3952),
    [anon_sym_yield] = ACTIONS(3954),
    [anon_sym_yield_BANG] = ACTIONS(3952),
    [anon_sym_lazy] = ACTIONS(3954),
    [anon_sym_assert] = ACTIONS(3954),
    [anon_sym_upcast] = ACTIONS(3954),
    [anon_sym_downcast] = ACTIONS(3954),
    [anon_sym_COLON_GT] = ACTIONS(3952),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3952),
    [anon_sym_for] = ACTIONS(3954),
    [anon_sym_while] = ACTIONS(3954),
    [anon_sym_if] = ACTIONS(3954),
    [anon_sym_fun] = ACTIONS(3954),
    [anon_sym_try] = ACTIONS(3954),
    [anon_sym_match] = ACTIONS(3954),
    [anon_sym_match_BANG] = ACTIONS(3952),
    [anon_sym_function] = ACTIONS(3954),
    [anon_sym_LT_DASH] = ACTIONS(3954),
    [anon_sym_DOT_LBRACK] = ACTIONS(3952),
    [anon_sym_LT] = ACTIONS(3952),
    [anon_sym_use] = ACTIONS(3954),
    [anon_sym_use_BANG] = ACTIONS(3952),
    [anon_sym_do_BANG] = ACTIONS(3952),
    [anon_sym_begin] = ACTIONS(3954),
    [anon_sym_LPAREN2] = ACTIONS(3954),
    [anon_sym_DOT_DOT2] = ACTIONS(3952),
    [anon_sym_default] = ACTIONS(3954),
    [anon_sym_or] = ACTIONS(3954),
    [anon_sym_static] = ACTIONS(3954),
    [anon_sym_member] = ACTIONS(3954),
    [anon_sym_interface] = ACTIONS(3954),
    [anon_sym_abstract] = ACTIONS(3954),
    [anon_sym_val] = ACTIONS(3954),
    [anon_sym_override] = ACTIONS(3954),
    [aux_sym_char_token1] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3954),
    [anon_sym_DQUOTE] = ACTIONS(3954),
    [anon_sym_AT_DQUOTE] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [sym_bool] = ACTIONS(3954),
    [sym_unit] = ACTIONS(3952),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3954),
    [sym_op_identifier] = ACTIONS(3954),
    [anon_sym_PLUS] = ACTIONS(3954),
    [anon_sym_DASH] = ACTIONS(3954),
    [anon_sym_PLUS_DOT] = ACTIONS(3954),
    [anon_sym_DASH_DOT] = ACTIONS(3954),
    [anon_sym_PERCENT] = ACTIONS(3954),
    [anon_sym_AMP_AMP] = ACTIONS(3954),
    [anon_sym_TILDE] = ACTIONS(3952),
    [aux_sym_prefix_op_token1] = ACTIONS(3954),
    [aux_sym_infix_op_token1] = ACTIONS(3952),
    [aux_sym_infix_op_token2] = ACTIONS(3954),
    [anon_sym_PIPE_PIPE] = ACTIONS(3954),
    [anon_sym_BANG_EQ] = ACTIONS(3954),
    [anon_sym_COLON_EQ] = ACTIONS(3952),
    [anon_sym_DOLLAR] = ACTIONS(3954),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3954),
    [sym_int] = ACTIONS(3954),
    [sym_xint] = ACTIONS(3952),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3952),
    [sym__newline] = ACTIONS(3952),
    [sym__dedent] = ACTIONS(3952),
  },
  [2205] = {
    [sym_block_comment] = STATE(2205),
    [sym_compiler_directive_decl] = STATE(2205),
    [sym_fsi_directive_decl] = STATE(2205),
    [sym_preproc_line] = STATE(2205),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_EQ] = ACTIONS(3948),
    [anon_sym_LBRACK_LT] = ACTIONS(3948),
    [anon_sym_COLON] = ACTIONS(3950),
    [anon_sym_return] = ACTIONS(3950),
    [anon_sym_do] = ACTIONS(3950),
    [anon_sym_let] = ACTIONS(3950),
    [anon_sym_let_BANG] = ACTIONS(3948),
    [aux_sym_access_modifier_token1] = ACTIONS(3948),
    [anon_sym_LPAREN] = ACTIONS(3950),
    [anon_sym_COMMA] = ACTIONS(3948),
    [anon_sym_null] = ACTIONS(3950),
    [anon_sym_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_COLON] = ACTIONS(3948),
    [anon_sym_AMP] = ACTIONS(3950),
    [anon_sym_LBRACK] = ACTIONS(3950),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3948),
    [anon_sym_LBRACE] = ACTIONS(3950),
    [anon_sym_LT_AT] = ACTIONS(3950),
    [anon_sym_LT_AT_AT] = ACTIONS(3950),
    [anon_sym_DOT] = ACTIONS(3950),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3948),
    [anon_sym_new] = ACTIONS(3950),
    [anon_sym_with] = ACTIONS(3950),
    [anon_sym_return_BANG] = ACTIONS(3948),
    [anon_sym_yield] = ACTIONS(3950),
    [anon_sym_yield_BANG] = ACTIONS(3948),
    [anon_sym_lazy] = ACTIONS(3950),
    [anon_sym_assert] = ACTIONS(3950),
    [anon_sym_upcast] = ACTIONS(3950),
    [anon_sym_downcast] = ACTIONS(3950),
    [anon_sym_COLON_GT] = ACTIONS(3948),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3948),
    [anon_sym_for] = ACTIONS(3950),
    [anon_sym_while] = ACTIONS(3950),
    [anon_sym_if] = ACTIONS(3950),
    [anon_sym_fun] = ACTIONS(3950),
    [anon_sym_try] = ACTIONS(3950),
    [anon_sym_match] = ACTIONS(3950),
    [anon_sym_match_BANG] = ACTIONS(3948),
    [anon_sym_function] = ACTIONS(3950),
    [anon_sym_LT_DASH] = ACTIONS(3950),
    [anon_sym_DOT_LBRACK] = ACTIONS(3948),
    [anon_sym_LT] = ACTIONS(3948),
    [anon_sym_use] = ACTIONS(3950),
    [anon_sym_use_BANG] = ACTIONS(3948),
    [anon_sym_do_BANG] = ACTIONS(3948),
    [anon_sym_begin] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3950),
    [anon_sym_DOT_DOT2] = ACTIONS(3948),
    [anon_sym_default] = ACTIONS(3950),
    [anon_sym_or] = ACTIONS(3950),
    [anon_sym_static] = ACTIONS(3950),
    [anon_sym_member] = ACTIONS(3950),
    [anon_sym_interface] = ACTIONS(3950),
    [anon_sym_abstract] = ACTIONS(3950),
    [anon_sym_val] = ACTIONS(3950),
    [anon_sym_override] = ACTIONS(3950),
    [aux_sym_char_token1] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3950),
    [anon_sym_DQUOTE] = ACTIONS(3950),
    [anon_sym_AT_DQUOTE] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [sym_bool] = ACTIONS(3950),
    [sym_unit] = ACTIONS(3948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3950),
    [sym_op_identifier] = ACTIONS(3950),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_DASH] = ACTIONS(3950),
    [anon_sym_PLUS_DOT] = ACTIONS(3950),
    [anon_sym_DASH_DOT] = ACTIONS(3950),
    [anon_sym_PERCENT] = ACTIONS(3950),
    [anon_sym_AMP_AMP] = ACTIONS(3950),
    [anon_sym_TILDE] = ACTIONS(3948),
    [aux_sym_prefix_op_token1] = ACTIONS(3950),
    [aux_sym_infix_op_token1] = ACTIONS(3948),
    [aux_sym_infix_op_token2] = ACTIONS(3950),
    [anon_sym_PIPE_PIPE] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3950),
    [anon_sym_COLON_EQ] = ACTIONS(3948),
    [anon_sym_DOLLAR] = ACTIONS(3950),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3950),
    [sym_int] = ACTIONS(3950),
    [sym_xint] = ACTIONS(3948),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3948),
    [sym__newline] = ACTIONS(3948),
    [sym__dedent] = ACTIONS(3948),
  },
  [2206] = {
    [sym_block_comment] = STATE(2206),
    [sym_compiler_directive_decl] = STATE(2206),
    [sym_fsi_directive_decl] = STATE(2206),
    [sym_preproc_line] = STATE(2206),
    [sym_identifier] = ACTIONS(4011),
    [anon_sym_EQ] = ACTIONS(4009),
    [anon_sym_LBRACK_LT] = ACTIONS(4009),
    [anon_sym_COLON] = ACTIONS(4011),
    [anon_sym_return] = ACTIONS(4011),
    [anon_sym_do] = ACTIONS(4011),
    [anon_sym_let] = ACTIONS(4011),
    [anon_sym_let_BANG] = ACTIONS(4009),
    [aux_sym_access_modifier_token1] = ACTIONS(4009),
    [anon_sym_LPAREN] = ACTIONS(4011),
    [anon_sym_COMMA] = ACTIONS(4009),
    [anon_sym_null] = ACTIONS(4011),
    [anon_sym_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(4011),
    [anon_sym_LBRACK] = ACTIONS(4011),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4009),
    [anon_sym_LBRACE] = ACTIONS(4011),
    [anon_sym_LT_AT] = ACTIONS(4011),
    [anon_sym_LT_AT_AT] = ACTIONS(4011),
    [anon_sym_DOT] = ACTIONS(4011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4009),
    [anon_sym_new] = ACTIONS(4011),
    [anon_sym_with] = ACTIONS(4011),
    [anon_sym_return_BANG] = ACTIONS(4009),
    [anon_sym_yield] = ACTIONS(4011),
    [anon_sym_yield_BANG] = ACTIONS(4009),
    [anon_sym_lazy] = ACTIONS(4011),
    [anon_sym_assert] = ACTIONS(4011),
    [anon_sym_upcast] = ACTIONS(4011),
    [anon_sym_downcast] = ACTIONS(4011),
    [anon_sym_COLON_GT] = ACTIONS(4009),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4009),
    [anon_sym_for] = ACTIONS(4011),
    [anon_sym_while] = ACTIONS(4011),
    [anon_sym_if] = ACTIONS(4011),
    [anon_sym_fun] = ACTIONS(4011),
    [anon_sym_try] = ACTIONS(4011),
    [anon_sym_match] = ACTIONS(4011),
    [anon_sym_match_BANG] = ACTIONS(4009),
    [anon_sym_function] = ACTIONS(4011),
    [anon_sym_LT_DASH] = ACTIONS(4011),
    [anon_sym_DOT_LBRACK] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(4009),
    [anon_sym_use] = ACTIONS(4011),
    [anon_sym_use_BANG] = ACTIONS(4009),
    [anon_sym_do_BANG] = ACTIONS(4009),
    [anon_sym_begin] = ACTIONS(4011),
    [anon_sym_LPAREN2] = ACTIONS(4011),
    [anon_sym_default] = ACTIONS(4011),
    [anon_sym_or] = ACTIONS(4011),
    [anon_sym_static] = ACTIONS(4011),
    [anon_sym_member] = ACTIONS(4011),
    [anon_sym_interface] = ACTIONS(4011),
    [anon_sym_abstract] = ACTIONS(4011),
    [anon_sym_val] = ACTIONS(4011),
    [anon_sym_override] = ACTIONS(4011),
    [anon_sym_inherit] = ACTIONS(4011),
    [aux_sym_char_token1] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4011),
    [anon_sym_DQUOTE] = ACTIONS(4011),
    [anon_sym_AT_DQUOTE] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [sym_bool] = ACTIONS(4011),
    [sym_unit] = ACTIONS(4009),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4011),
    [sym_op_identifier] = ACTIONS(4011),
    [anon_sym_PLUS] = ACTIONS(4011),
    [anon_sym_DASH] = ACTIONS(4011),
    [anon_sym_PLUS_DOT] = ACTIONS(4011),
    [anon_sym_DASH_DOT] = ACTIONS(4011),
    [anon_sym_PERCENT] = ACTIONS(4011),
    [anon_sym_AMP_AMP] = ACTIONS(4011),
    [anon_sym_TILDE] = ACTIONS(4009),
    [aux_sym_prefix_op_token1] = ACTIONS(4011),
    [aux_sym_infix_op_token1] = ACTIONS(4009),
    [aux_sym_infix_op_token2] = ACTIONS(4011),
    [anon_sym_PIPE_PIPE] = ACTIONS(4011),
    [anon_sym_BANG_EQ] = ACTIONS(4011),
    [anon_sym_COLON_EQ] = ACTIONS(4009),
    [anon_sym_DOLLAR] = ACTIONS(4011),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4011),
    [sym_int] = ACTIONS(4011),
    [sym_xint] = ACTIONS(4009),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4009),
    [anon_sym_POUNDendif] = ACTIONS(4009),
    [sym__newline] = ACTIONS(4009),
  },
  [2207] = {
    [sym_block_comment] = STATE(2207),
    [sym_compiler_directive_decl] = STATE(2207),
    [sym_fsi_directive_decl] = STATE(2207),
    [sym_preproc_line] = STATE(2207),
    [sym_identifier] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(4076),
    [anon_sym_LBRACK_LT] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4078),
    [anon_sym_return] = ACTIONS(4078),
    [anon_sym_do] = ACTIONS(4078),
    [anon_sym_and] = ACTIONS(4078),
    [anon_sym_let] = ACTIONS(4078),
    [anon_sym_let_BANG] = ACTIONS(4076),
    [aux_sym_access_modifier_token1] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_null] = ACTIONS(4078),
    [anon_sym_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(4076),
    [anon_sym_AMP] = ACTIONS(4078),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4078),
    [anon_sym_LT_AT] = ACTIONS(4078),
    [anon_sym_LT_AT_AT] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(4078),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4076),
    [anon_sym_new] = ACTIONS(4078),
    [anon_sym_with] = ACTIONS(4078),
    [anon_sym_return_BANG] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(4078),
    [anon_sym_yield_BANG] = ACTIONS(4076),
    [anon_sym_lazy] = ACTIONS(4078),
    [anon_sym_assert] = ACTIONS(4078),
    [anon_sym_upcast] = ACTIONS(4078),
    [anon_sym_downcast] = ACTIONS(4078),
    [anon_sym_COLON_GT] = ACTIONS(4076),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4076),
    [anon_sym_for] = ACTIONS(4078),
    [anon_sym_while] = ACTIONS(4078),
    [anon_sym_if] = ACTIONS(4078),
    [anon_sym_fun] = ACTIONS(4078),
    [anon_sym_try] = ACTIONS(4078),
    [anon_sym_match] = ACTIONS(4078),
    [anon_sym_match_BANG] = ACTIONS(4076),
    [anon_sym_function] = ACTIONS(4078),
    [anon_sym_LT_DASH] = ACTIONS(4078),
    [anon_sym_DOT_LBRACK] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4076),
    [anon_sym_use] = ACTIONS(4078),
    [anon_sym_use_BANG] = ACTIONS(4076),
    [anon_sym_do_BANG] = ACTIONS(4076),
    [anon_sym_begin] = ACTIONS(4078),
    [anon_sym_LPAREN2] = ACTIONS(4078),
    [anon_sym_default] = ACTIONS(4078),
    [anon_sym_or] = ACTIONS(4078),
    [anon_sym_static] = ACTIONS(4078),
    [anon_sym_member] = ACTIONS(4078),
    [anon_sym_interface] = ACTIONS(4078),
    [anon_sym_abstract] = ACTIONS(4078),
    [anon_sym_val] = ACTIONS(4078),
    [anon_sym_override] = ACTIONS(4078),
    [aux_sym_char_token1] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4078),
    [anon_sym_DQUOTE] = ACTIONS(4078),
    [anon_sym_AT_DQUOTE] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [sym_bool] = ACTIONS(4078),
    [sym_unit] = ACTIONS(4076),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4078),
    [sym_op_identifier] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(4078),
    [anon_sym_PLUS_DOT] = ACTIONS(4078),
    [anon_sym_DASH_DOT] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [anon_sym_AMP_AMP] = ACTIONS(4078),
    [anon_sym_TILDE] = ACTIONS(4076),
    [aux_sym_prefix_op_token1] = ACTIONS(4078),
    [aux_sym_infix_op_token1] = ACTIONS(4076),
    [aux_sym_infix_op_token2] = ACTIONS(4078),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_BANG_EQ] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4076),
    [anon_sym_DOLLAR] = ACTIONS(4078),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4078),
    [sym_int] = ACTIONS(4078),
    [sym_xint] = ACTIONS(4076),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4076),
    [anon_sym_POUNDendif] = ACTIONS(4076),
    [sym__newline] = ACTIONS(4076),
  },
  [2208] = {
    [sym_block_comment] = STATE(2208),
    [sym_compiler_directive_decl] = STATE(2208),
    [sym_fsi_directive_decl] = STATE(2208),
    [sym_preproc_line] = STATE(2208),
    [aux_sym_type_argument_repeat1] = STATE(2037),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_GT_RBRACK] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_RBRACK] = ACTIONS(3496),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_RBRACE] = ACTIONS(3496),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_with] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_to] = ACTIONS(3498),
    [anon_sym_downto] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [anon_sym_DOT_LBRACK] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_DOT_DOT2] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_or] = ACTIONS(4783),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3498),
    [anon_sym_DASH_DOT] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3498),
    [aux_sym_infix_op_token1] = ACTIONS(3496),
    [aux_sym_infix_op_token2] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_COLON_EQ] = ACTIONS(3496),
    [anon_sym_DOLLAR] = ACTIONS(3498),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3498),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
  },
  [2209] = {
    [sym_block_comment] = STATE(2209),
    [sym_compiler_directive_decl] = STATE(2209),
    [sym_fsi_directive_decl] = STATE(2209),
    [sym_preproc_line] = STATE(2209),
    [sym_identifier] = ACTIONS(3863),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_LBRACK_LT] = ACTIONS(3861),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_let] = ACTIONS(3863),
    [anon_sym_let_BANG] = ACTIONS(3861),
    [aux_sym_access_modifier_token1] = ACTIONS(3861),
    [anon_sym_LPAREN] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3861),
    [anon_sym_null] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_COLON] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_LT_AT] = ACTIONS(3863),
    [anon_sym_LT_AT_AT] = ACTIONS(3863),
    [anon_sym_DOT] = ACTIONS(3863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3861),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_with] = ACTIONS(3863),
    [anon_sym_return_BANG] = ACTIONS(3861),
    [anon_sym_yield] = ACTIONS(3863),
    [anon_sym_yield_BANG] = ACTIONS(3861),
    [anon_sym_lazy] = ACTIONS(3863),
    [anon_sym_assert] = ACTIONS(3863),
    [anon_sym_upcast] = ACTIONS(3863),
    [anon_sym_downcast] = ACTIONS(3863),
    [anon_sym_COLON_GT] = ACTIONS(3861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_fun] = ACTIONS(3863),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_match] = ACTIONS(3863),
    [anon_sym_match_BANG] = ACTIONS(3861),
    [anon_sym_function] = ACTIONS(3863),
    [anon_sym_LT_DASH] = ACTIONS(3863),
    [anon_sym_DOT_LBRACK] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_use] = ACTIONS(3863),
    [anon_sym_use_BANG] = ACTIONS(3861),
    [anon_sym_do_BANG] = ACTIONS(3861),
    [anon_sym_begin] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(3863),
    [anon_sym_DOT_DOT2] = ACTIONS(3861),
    [anon_sym_default] = ACTIONS(3863),
    [anon_sym_or] = ACTIONS(3863),
    [anon_sym_static] = ACTIONS(3863),
    [anon_sym_member] = ACTIONS(3863),
    [anon_sym_interface] = ACTIONS(3863),
    [anon_sym_abstract] = ACTIONS(3863),
    [anon_sym_val] = ACTIONS(3863),
    [anon_sym_override] = ACTIONS(3863),
    [aux_sym_char_token1] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [anon_sym_AT_DQUOTE] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [sym_bool] = ACTIONS(3863),
    [sym_unit] = ACTIONS(3861),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3863),
    [sym_op_identifier] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_DOT] = ACTIONS(3863),
    [anon_sym_DASH_DOT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3861),
    [aux_sym_prefix_op_token1] = ACTIONS(3863),
    [aux_sym_infix_op_token1] = ACTIONS(3861),
    [aux_sym_infix_op_token2] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_COLON_EQ] = ACTIONS(3861),
    [anon_sym_DOLLAR] = ACTIONS(3863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3863),
    [sym_int] = ACTIONS(3863),
    [sym_xint] = ACTIONS(3861),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3861),
    [sym__newline] = ACTIONS(3861),
    [sym__dedent] = ACTIONS(3861),
  },
  [2210] = {
    [sym_block_comment] = STATE(2210),
    [sym_compiler_directive_decl] = STATE(2210),
    [sym_fsi_directive_decl] = STATE(2210),
    [sym_preproc_line] = STATE(2210),
    [sym_identifier] = ACTIONS(4170),
    [anon_sym_EQ] = ACTIONS(4168),
    [anon_sym_LBRACK_LT] = ACTIONS(4168),
    [anon_sym_COLON] = ACTIONS(4170),
    [anon_sym_return] = ACTIONS(4170),
    [anon_sym_do] = ACTIONS(4170),
    [anon_sym_and] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_let_BANG] = ACTIONS(4168),
    [aux_sym_access_modifier_token1] = ACTIONS(4168),
    [anon_sym_LPAREN] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4168),
    [anon_sym_null] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_COLON] = ACTIONS(4168),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4170),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4168),
    [anon_sym_LBRACE] = ACTIONS(4170),
    [anon_sym_LT_AT] = ACTIONS(4170),
    [anon_sym_LT_AT_AT] = ACTIONS(4170),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4168),
    [anon_sym_new] = ACTIONS(4170),
    [anon_sym_with] = ACTIONS(4170),
    [anon_sym_return_BANG] = ACTIONS(4168),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_yield_BANG] = ACTIONS(4168),
    [anon_sym_lazy] = ACTIONS(4170),
    [anon_sym_assert] = ACTIONS(4170),
    [anon_sym_upcast] = ACTIONS(4170),
    [anon_sym_downcast] = ACTIONS(4170),
    [anon_sym_COLON_GT] = ACTIONS(4168),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4168),
    [anon_sym_for] = ACTIONS(4170),
    [anon_sym_while] = ACTIONS(4170),
    [anon_sym_if] = ACTIONS(4170),
    [anon_sym_fun] = ACTIONS(4170),
    [anon_sym_try] = ACTIONS(4170),
    [anon_sym_match] = ACTIONS(4170),
    [anon_sym_match_BANG] = ACTIONS(4168),
    [anon_sym_function] = ACTIONS(4170),
    [anon_sym_LT_DASH] = ACTIONS(4170),
    [anon_sym_DOT_LBRACK] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4168),
    [anon_sym_use] = ACTIONS(4170),
    [anon_sym_use_BANG] = ACTIONS(4168),
    [anon_sym_do_BANG] = ACTIONS(4168),
    [anon_sym_begin] = ACTIONS(4170),
    [anon_sym_LPAREN2] = ACTIONS(4170),
    [anon_sym_default] = ACTIONS(4170),
    [anon_sym_or] = ACTIONS(4170),
    [anon_sym_static] = ACTIONS(4170),
    [anon_sym_member] = ACTIONS(4170),
    [anon_sym_interface] = ACTIONS(4170),
    [anon_sym_abstract] = ACTIONS(4170),
    [anon_sym_val] = ACTIONS(4170),
    [anon_sym_override] = ACTIONS(4170),
    [aux_sym_char_token1] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4170),
    [anon_sym_DQUOTE] = ACTIONS(4170),
    [anon_sym_AT_DQUOTE] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [sym_bool] = ACTIONS(4170),
    [sym_unit] = ACTIONS(4168),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4170),
    [sym_op_identifier] = ACTIONS(4170),
    [anon_sym_PLUS] = ACTIONS(4170),
    [anon_sym_DASH] = ACTIONS(4170),
    [anon_sym_PLUS_DOT] = ACTIONS(4170),
    [anon_sym_DASH_DOT] = ACTIONS(4170),
    [anon_sym_PERCENT] = ACTIONS(4170),
    [anon_sym_AMP_AMP] = ACTIONS(4170),
    [anon_sym_TILDE] = ACTIONS(4168),
    [aux_sym_prefix_op_token1] = ACTIONS(4170),
    [aux_sym_infix_op_token1] = ACTIONS(4168),
    [aux_sym_infix_op_token2] = ACTIONS(4170),
    [anon_sym_PIPE_PIPE] = ACTIONS(4170),
    [anon_sym_BANG_EQ] = ACTIONS(4170),
    [anon_sym_COLON_EQ] = ACTIONS(4168),
    [anon_sym_DOLLAR] = ACTIONS(4170),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4170),
    [sym_int] = ACTIONS(4170),
    [sym_xint] = ACTIONS(4168),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4168),
    [anon_sym_POUNDendif] = ACTIONS(4168),
    [sym__newline] = ACTIONS(4168),
  },
  [2211] = {
    [sym_block_comment] = STATE(2211),
    [sym_compiler_directive_decl] = STATE(2211),
    [sym_fsi_directive_decl] = STATE(2211),
    [sym_preproc_line] = STATE(2211),
    [sym_identifier] = ACTIONS(3856),
    [anon_sym_EQ] = ACTIONS(3854),
    [anon_sym_LBRACK_LT] = ACTIONS(3854),
    [anon_sym_COLON] = ACTIONS(3856),
    [anon_sym_return] = ACTIONS(3856),
    [anon_sym_do] = ACTIONS(3856),
    [anon_sym_let] = ACTIONS(3856),
    [anon_sym_let_BANG] = ACTIONS(3854),
    [aux_sym_access_modifier_token1] = ACTIONS(3854),
    [anon_sym_LPAREN] = ACTIONS(3856),
    [anon_sym_COMMA] = ACTIONS(3854),
    [anon_sym_null] = ACTIONS(3856),
    [anon_sym_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_AMP] = ACTIONS(3856),
    [anon_sym_LBRACK] = ACTIONS(3856),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3854),
    [anon_sym_LBRACE] = ACTIONS(3856),
    [anon_sym_LT_AT] = ACTIONS(3856),
    [anon_sym_LT_AT_AT] = ACTIONS(3856),
    [anon_sym_DOT] = ACTIONS(3856),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3854),
    [anon_sym_new] = ACTIONS(3856),
    [anon_sym_with] = ACTIONS(3856),
    [anon_sym_return_BANG] = ACTIONS(3854),
    [anon_sym_yield] = ACTIONS(3856),
    [anon_sym_yield_BANG] = ACTIONS(3854),
    [anon_sym_lazy] = ACTIONS(3856),
    [anon_sym_assert] = ACTIONS(3856),
    [anon_sym_upcast] = ACTIONS(3856),
    [anon_sym_downcast] = ACTIONS(3856),
    [anon_sym_COLON_GT] = ACTIONS(3854),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3854),
    [anon_sym_for] = ACTIONS(3856),
    [anon_sym_while] = ACTIONS(3856),
    [anon_sym_if] = ACTIONS(3856),
    [anon_sym_fun] = ACTIONS(3856),
    [anon_sym_try] = ACTIONS(3856),
    [anon_sym_match] = ACTIONS(3856),
    [anon_sym_match_BANG] = ACTIONS(3854),
    [anon_sym_function] = ACTIONS(3856),
    [anon_sym_LT_DASH] = ACTIONS(3856),
    [anon_sym_DOT_LBRACK] = ACTIONS(3854),
    [anon_sym_LT] = ACTIONS(3854),
    [anon_sym_use] = ACTIONS(3856),
    [anon_sym_use_BANG] = ACTIONS(3854),
    [anon_sym_do_BANG] = ACTIONS(3854),
    [anon_sym_begin] = ACTIONS(3856),
    [anon_sym_LPAREN2] = ACTIONS(3856),
    [anon_sym_DOT_DOT2] = ACTIONS(3854),
    [anon_sym_default] = ACTIONS(3856),
    [anon_sym_or] = ACTIONS(3856),
    [anon_sym_static] = ACTIONS(3856),
    [anon_sym_member] = ACTIONS(3856),
    [anon_sym_interface] = ACTIONS(3856),
    [anon_sym_abstract] = ACTIONS(3856),
    [anon_sym_val] = ACTIONS(3856),
    [anon_sym_override] = ACTIONS(3856),
    [aux_sym_char_token1] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3856),
    [anon_sym_DQUOTE] = ACTIONS(3856),
    [anon_sym_AT_DQUOTE] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [sym_bool] = ACTIONS(3856),
    [sym_unit] = ACTIONS(3854),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3856),
    [sym_op_identifier] = ACTIONS(3856),
    [anon_sym_PLUS] = ACTIONS(3856),
    [anon_sym_DASH] = ACTIONS(3856),
    [anon_sym_PLUS_DOT] = ACTIONS(3856),
    [anon_sym_DASH_DOT] = ACTIONS(3856),
    [anon_sym_PERCENT] = ACTIONS(3856),
    [anon_sym_AMP_AMP] = ACTIONS(3856),
    [anon_sym_TILDE] = ACTIONS(3854),
    [aux_sym_prefix_op_token1] = ACTIONS(3856),
    [aux_sym_infix_op_token1] = ACTIONS(3854),
    [aux_sym_infix_op_token2] = ACTIONS(3856),
    [anon_sym_PIPE_PIPE] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3856),
    [anon_sym_COLON_EQ] = ACTIONS(3854),
    [anon_sym_DOLLAR] = ACTIONS(3856),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3856),
    [sym_int] = ACTIONS(3856),
    [sym_xint] = ACTIONS(3854),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3854),
    [sym__newline] = ACTIONS(3854),
    [sym__dedent] = ACTIONS(3854),
  },
  [2212] = {
    [sym_block_comment] = STATE(2212),
    [sym_compiler_directive_decl] = STATE(2212),
    [sym_fsi_directive_decl] = STATE(2212),
    [sym_preproc_line] = STATE(2212),
    [sym_identifier] = ACTIONS(3875),
    [anon_sym_EQ] = ACTIONS(3873),
    [anon_sym_LBRACK_LT] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(3875),
    [anon_sym_return] = ACTIONS(3875),
    [anon_sym_do] = ACTIONS(3875),
    [anon_sym_and] = ACTIONS(3875),
    [anon_sym_let] = ACTIONS(3875),
    [anon_sym_let_BANG] = ACTIONS(3873),
    [aux_sym_access_modifier_token1] = ACTIONS(3873),
    [anon_sym_LPAREN] = ACTIONS(3875),
    [anon_sym_COMMA] = ACTIONS(3873),
    [anon_sym_null] = ACTIONS(3875),
    [anon_sym_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_COLON] = ACTIONS(3873),
    [anon_sym_AMP] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(3875),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3873),
    [anon_sym_LBRACE] = ACTIONS(3875),
    [anon_sym_LT_AT] = ACTIONS(3875),
    [anon_sym_LT_AT_AT] = ACTIONS(3875),
    [anon_sym_DOT] = ACTIONS(3875),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3873),
    [anon_sym_new] = ACTIONS(3875),
    [anon_sym_with] = ACTIONS(3875),
    [anon_sym_return_BANG] = ACTIONS(3873),
    [anon_sym_yield] = ACTIONS(3875),
    [anon_sym_yield_BANG] = ACTIONS(3873),
    [anon_sym_lazy] = ACTIONS(3875),
    [anon_sym_assert] = ACTIONS(3875),
    [anon_sym_upcast] = ACTIONS(3875),
    [anon_sym_downcast] = ACTIONS(3875),
    [anon_sym_COLON_GT] = ACTIONS(3873),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3873),
    [anon_sym_for] = ACTIONS(3875),
    [anon_sym_while] = ACTIONS(3875),
    [anon_sym_if] = ACTIONS(3875),
    [anon_sym_fun] = ACTIONS(3875),
    [anon_sym_try] = ACTIONS(3875),
    [anon_sym_match] = ACTIONS(3875),
    [anon_sym_match_BANG] = ACTIONS(3873),
    [anon_sym_function] = ACTIONS(3875),
    [anon_sym_LT_DASH] = ACTIONS(3875),
    [anon_sym_DOT_LBRACK] = ACTIONS(3873),
    [anon_sym_LT] = ACTIONS(3873),
    [anon_sym_use] = ACTIONS(3875),
    [anon_sym_use_BANG] = ACTIONS(3873),
    [anon_sym_do_BANG] = ACTIONS(3873),
    [anon_sym_begin] = ACTIONS(3875),
    [anon_sym_LPAREN2] = ACTIONS(3875),
    [anon_sym_default] = ACTIONS(3875),
    [anon_sym_or] = ACTIONS(3875),
    [anon_sym_static] = ACTIONS(3875),
    [anon_sym_member] = ACTIONS(3875),
    [anon_sym_interface] = ACTIONS(3875),
    [anon_sym_abstract] = ACTIONS(3875),
    [anon_sym_val] = ACTIONS(3875),
    [anon_sym_override] = ACTIONS(3875),
    [aux_sym_char_token1] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3875),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [anon_sym_AT_DQUOTE] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [sym_bool] = ACTIONS(3875),
    [sym_unit] = ACTIONS(3873),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3875),
    [sym_op_identifier] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS_DOT] = ACTIONS(3875),
    [anon_sym_DASH_DOT] = ACTIONS(3875),
    [anon_sym_PERCENT] = ACTIONS(3875),
    [anon_sym_AMP_AMP] = ACTIONS(3875),
    [anon_sym_TILDE] = ACTIONS(3873),
    [aux_sym_prefix_op_token1] = ACTIONS(3875),
    [aux_sym_infix_op_token1] = ACTIONS(3873),
    [aux_sym_infix_op_token2] = ACTIONS(3875),
    [anon_sym_PIPE_PIPE] = ACTIONS(3875),
    [anon_sym_BANG_EQ] = ACTIONS(3875),
    [anon_sym_COLON_EQ] = ACTIONS(3873),
    [anon_sym_DOLLAR] = ACTIONS(3875),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3875),
    [sym_int] = ACTIONS(3875),
    [sym_xint] = ACTIONS(3873),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3873),
    [sym__newline] = ACTIONS(3873),
    [sym__dedent] = ACTIONS(3873),
  },
  [2213] = {
    [sym_block_comment] = STATE(2213),
    [sym_compiler_directive_decl] = STATE(2213),
    [sym_fsi_directive_decl] = STATE(2213),
    [sym_preproc_line] = STATE(2213),
    [sym_identifier] = ACTIONS(4137),
    [anon_sym_EQ] = ACTIONS(4135),
    [anon_sym_LBRACK_LT] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4137),
    [anon_sym_return] = ACTIONS(4137),
    [anon_sym_do] = ACTIONS(4137),
    [anon_sym_let] = ACTIONS(4137),
    [anon_sym_let_BANG] = ACTIONS(4135),
    [aux_sym_access_modifier_token1] = ACTIONS(4135),
    [anon_sym_LPAREN] = ACTIONS(4137),
    [anon_sym_COMMA] = ACTIONS(4135),
    [anon_sym_null] = ACTIONS(4137),
    [anon_sym_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_COLON] = ACTIONS(4135),
    [anon_sym_AMP] = ACTIONS(4137),
    [anon_sym_LBRACK] = ACTIONS(4137),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4135),
    [anon_sym_LBRACE] = ACTIONS(4137),
    [anon_sym_LT_AT] = ACTIONS(4137),
    [anon_sym_LT_AT_AT] = ACTIONS(4137),
    [anon_sym_DOT] = ACTIONS(4137),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4135),
    [anon_sym_new] = ACTIONS(4137),
    [anon_sym_with] = ACTIONS(4137),
    [anon_sym_return_BANG] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_yield_BANG] = ACTIONS(4135),
    [anon_sym_lazy] = ACTIONS(4137),
    [anon_sym_assert] = ACTIONS(4137),
    [anon_sym_upcast] = ACTIONS(4137),
    [anon_sym_downcast] = ACTIONS(4137),
    [anon_sym_COLON_GT] = ACTIONS(4135),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4135),
    [anon_sym_for] = ACTIONS(4137),
    [anon_sym_while] = ACTIONS(4137),
    [anon_sym_if] = ACTIONS(4137),
    [anon_sym_fun] = ACTIONS(4137),
    [anon_sym_try] = ACTIONS(4137),
    [anon_sym_match] = ACTIONS(4137),
    [anon_sym_match_BANG] = ACTIONS(4135),
    [anon_sym_function] = ACTIONS(4137),
    [anon_sym_LT_DASH] = ACTIONS(4137),
    [anon_sym_DOT_LBRACK] = ACTIONS(4135),
    [anon_sym_LT] = ACTIONS(4135),
    [anon_sym_use] = ACTIONS(4137),
    [anon_sym_use_BANG] = ACTIONS(4135),
    [anon_sym_do_BANG] = ACTIONS(4135),
    [anon_sym_begin] = ACTIONS(4137),
    [anon_sym_LPAREN2] = ACTIONS(4137),
    [anon_sym_DOT_DOT2] = ACTIONS(4135),
    [anon_sym_default] = ACTIONS(4137),
    [anon_sym_or] = ACTIONS(4137),
    [anon_sym_static] = ACTIONS(4137),
    [anon_sym_member] = ACTIONS(4137),
    [anon_sym_interface] = ACTIONS(4137),
    [anon_sym_abstract] = ACTIONS(4137),
    [anon_sym_val] = ACTIONS(4137),
    [anon_sym_override] = ACTIONS(4137),
    [aux_sym_char_token1] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4137),
    [anon_sym_DQUOTE] = ACTIONS(4137),
    [anon_sym_AT_DQUOTE] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [sym_bool] = ACTIONS(4137),
    [sym_unit] = ACTIONS(4135),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4137),
    [sym_op_identifier] = ACTIONS(4137),
    [anon_sym_PLUS] = ACTIONS(4137),
    [anon_sym_DASH] = ACTIONS(4137),
    [anon_sym_PLUS_DOT] = ACTIONS(4137),
    [anon_sym_DASH_DOT] = ACTIONS(4137),
    [anon_sym_PERCENT] = ACTIONS(4137),
    [anon_sym_AMP_AMP] = ACTIONS(4137),
    [anon_sym_TILDE] = ACTIONS(4135),
    [aux_sym_prefix_op_token1] = ACTIONS(4137),
    [aux_sym_infix_op_token1] = ACTIONS(4135),
    [aux_sym_infix_op_token2] = ACTIONS(4137),
    [anon_sym_PIPE_PIPE] = ACTIONS(4137),
    [anon_sym_BANG_EQ] = ACTIONS(4137),
    [anon_sym_COLON_EQ] = ACTIONS(4135),
    [anon_sym_DOLLAR] = ACTIONS(4137),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4137),
    [sym_int] = ACTIONS(4137),
    [sym_xint] = ACTIONS(4135),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4135),
    [sym__newline] = ACTIONS(4135),
    [sym__dedent] = ACTIONS(4135),
  },
  [2214] = {
    [sym_block_comment] = STATE(2214),
    [sym_compiler_directive_decl] = STATE(2214),
    [sym_fsi_directive_decl] = STATE(2214),
    [sym_preproc_line] = STATE(2214),
    [sym_identifier] = ACTIONS(3863),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_LBRACK_LT] = ACTIONS(3861),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_and] = ACTIONS(3863),
    [anon_sym_let] = ACTIONS(3863),
    [anon_sym_let_BANG] = ACTIONS(3861),
    [aux_sym_access_modifier_token1] = ACTIONS(3861),
    [anon_sym_LPAREN] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3861),
    [anon_sym_null] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_COLON] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_LT_AT] = ACTIONS(3863),
    [anon_sym_LT_AT_AT] = ACTIONS(3863),
    [anon_sym_DOT] = ACTIONS(3863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3861),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_with] = ACTIONS(3863),
    [anon_sym_return_BANG] = ACTIONS(3861),
    [anon_sym_yield] = ACTIONS(3863),
    [anon_sym_yield_BANG] = ACTIONS(3861),
    [anon_sym_lazy] = ACTIONS(3863),
    [anon_sym_assert] = ACTIONS(3863),
    [anon_sym_upcast] = ACTIONS(3863),
    [anon_sym_downcast] = ACTIONS(3863),
    [anon_sym_COLON_GT] = ACTIONS(3861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_fun] = ACTIONS(3863),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_match] = ACTIONS(3863),
    [anon_sym_match_BANG] = ACTIONS(3861),
    [anon_sym_function] = ACTIONS(3863),
    [anon_sym_LT_DASH] = ACTIONS(3863),
    [anon_sym_DOT_LBRACK] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_use] = ACTIONS(3863),
    [anon_sym_use_BANG] = ACTIONS(3861),
    [anon_sym_do_BANG] = ACTIONS(3861),
    [anon_sym_begin] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(3863),
    [anon_sym_default] = ACTIONS(3863),
    [anon_sym_or] = ACTIONS(3863),
    [anon_sym_static] = ACTIONS(3863),
    [anon_sym_member] = ACTIONS(3863),
    [anon_sym_interface] = ACTIONS(3863),
    [anon_sym_abstract] = ACTIONS(3863),
    [anon_sym_val] = ACTIONS(3863),
    [anon_sym_override] = ACTIONS(3863),
    [aux_sym_char_token1] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [anon_sym_AT_DQUOTE] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [sym_bool] = ACTIONS(3863),
    [sym_unit] = ACTIONS(3861),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3863),
    [sym_op_identifier] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_DOT] = ACTIONS(3863),
    [anon_sym_DASH_DOT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3861),
    [aux_sym_prefix_op_token1] = ACTIONS(3863),
    [aux_sym_infix_op_token1] = ACTIONS(3861),
    [aux_sym_infix_op_token2] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_COLON_EQ] = ACTIONS(3861),
    [anon_sym_DOLLAR] = ACTIONS(3863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3863),
    [sym_int] = ACTIONS(3863),
    [sym_xint] = ACTIONS(3861),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3861),
    [sym__newline] = ACTIONS(3861),
    [sym__dedent] = ACTIONS(3861),
  },
  [2215] = {
    [sym_block_comment] = STATE(2215),
    [sym_compiler_directive_decl] = STATE(2215),
    [sym_fsi_directive_decl] = STATE(2215),
    [sym_preproc_line] = STATE(2215),
    [sym_identifier] = ACTIONS(3935),
    [anon_sym_EQ] = ACTIONS(3933),
    [anon_sym_LBRACK_LT] = ACTIONS(3933),
    [anon_sym_COLON] = ACTIONS(3935),
    [anon_sym_return] = ACTIONS(3935),
    [anon_sym_do] = ACTIONS(3935),
    [anon_sym_let] = ACTIONS(3935),
    [anon_sym_let_BANG] = ACTIONS(3933),
    [aux_sym_access_modifier_token1] = ACTIONS(3933),
    [anon_sym_LPAREN] = ACTIONS(3935),
    [anon_sym_COMMA] = ACTIONS(3933),
    [anon_sym_null] = ACTIONS(3935),
    [anon_sym_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3935),
    [anon_sym_LBRACK] = ACTIONS(3935),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3933),
    [anon_sym_LBRACE] = ACTIONS(3935),
    [anon_sym_LT_AT] = ACTIONS(3935),
    [anon_sym_LT_AT_AT] = ACTIONS(3935),
    [anon_sym_DOT] = ACTIONS(3935),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3933),
    [anon_sym_new] = ACTIONS(3935),
    [anon_sym_with] = ACTIONS(3935),
    [anon_sym_return_BANG] = ACTIONS(3933),
    [anon_sym_yield] = ACTIONS(3935),
    [anon_sym_yield_BANG] = ACTIONS(3933),
    [anon_sym_lazy] = ACTIONS(3935),
    [anon_sym_assert] = ACTIONS(3935),
    [anon_sym_upcast] = ACTIONS(3935),
    [anon_sym_downcast] = ACTIONS(3935),
    [anon_sym_COLON_GT] = ACTIONS(3933),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3933),
    [anon_sym_for] = ACTIONS(3935),
    [anon_sym_while] = ACTIONS(3935),
    [anon_sym_if] = ACTIONS(3935),
    [anon_sym_fun] = ACTIONS(3935),
    [anon_sym_try] = ACTIONS(3935),
    [anon_sym_match] = ACTIONS(3935),
    [anon_sym_match_BANG] = ACTIONS(3933),
    [anon_sym_function] = ACTIONS(3935),
    [anon_sym_LT_DASH] = ACTIONS(3935),
    [anon_sym_DOT_LBRACK] = ACTIONS(3933),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_use] = ACTIONS(3935),
    [anon_sym_use_BANG] = ACTIONS(3933),
    [anon_sym_do_BANG] = ACTIONS(3933),
    [anon_sym_begin] = ACTIONS(3935),
    [anon_sym_LPAREN2] = ACTIONS(3935),
    [anon_sym_DOT_DOT2] = ACTIONS(3933),
    [anon_sym_default] = ACTIONS(3935),
    [anon_sym_or] = ACTIONS(3935),
    [anon_sym_static] = ACTIONS(3935),
    [anon_sym_member] = ACTIONS(3935),
    [anon_sym_interface] = ACTIONS(3935),
    [anon_sym_abstract] = ACTIONS(3935),
    [anon_sym_val] = ACTIONS(3935),
    [anon_sym_override] = ACTIONS(3935),
    [aux_sym_char_token1] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3935),
    [anon_sym_DQUOTE] = ACTIONS(3935),
    [anon_sym_AT_DQUOTE] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [sym_bool] = ACTIONS(3935),
    [sym_unit] = ACTIONS(3933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3935),
    [sym_op_identifier] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(3935),
    [anon_sym_DASH] = ACTIONS(3935),
    [anon_sym_PLUS_DOT] = ACTIONS(3935),
    [anon_sym_DASH_DOT] = ACTIONS(3935),
    [anon_sym_PERCENT] = ACTIONS(3935),
    [anon_sym_AMP_AMP] = ACTIONS(3935),
    [anon_sym_TILDE] = ACTIONS(3933),
    [aux_sym_prefix_op_token1] = ACTIONS(3935),
    [aux_sym_infix_op_token1] = ACTIONS(3933),
    [aux_sym_infix_op_token2] = ACTIONS(3935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3935),
    [anon_sym_BANG_EQ] = ACTIONS(3935),
    [anon_sym_COLON_EQ] = ACTIONS(3933),
    [anon_sym_DOLLAR] = ACTIONS(3935),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3935),
    [sym_int] = ACTIONS(3935),
    [sym_xint] = ACTIONS(3933),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3933),
    [sym__newline] = ACTIONS(3933),
    [sym__dedent] = ACTIONS(3933),
  },
  [2216] = {
    [sym_block_comment] = STATE(2216),
    [sym_compiler_directive_decl] = STATE(2216),
    [sym_fsi_directive_decl] = STATE(2216),
    [sym_preproc_line] = STATE(2216),
    [sym_identifier] = ACTIONS(3856),
    [anon_sym_EQ] = ACTIONS(3854),
    [anon_sym_LBRACK_LT] = ACTIONS(3854),
    [anon_sym_COLON] = ACTIONS(3856),
    [anon_sym_return] = ACTIONS(3856),
    [anon_sym_do] = ACTIONS(3856),
    [anon_sym_and] = ACTIONS(3856),
    [anon_sym_let] = ACTIONS(3856),
    [anon_sym_let_BANG] = ACTIONS(3854),
    [aux_sym_access_modifier_token1] = ACTIONS(3854),
    [anon_sym_LPAREN] = ACTIONS(3856),
    [anon_sym_COMMA] = ACTIONS(3854),
    [anon_sym_null] = ACTIONS(3856),
    [anon_sym_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_AMP] = ACTIONS(3856),
    [anon_sym_LBRACK] = ACTIONS(3856),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3854),
    [anon_sym_LBRACE] = ACTIONS(3856),
    [anon_sym_LT_AT] = ACTIONS(3856),
    [anon_sym_LT_AT_AT] = ACTIONS(3856),
    [anon_sym_DOT] = ACTIONS(3856),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3854),
    [anon_sym_new] = ACTIONS(3856),
    [anon_sym_with] = ACTIONS(3856),
    [anon_sym_return_BANG] = ACTIONS(3854),
    [anon_sym_yield] = ACTIONS(3856),
    [anon_sym_yield_BANG] = ACTIONS(3854),
    [anon_sym_lazy] = ACTIONS(3856),
    [anon_sym_assert] = ACTIONS(3856),
    [anon_sym_upcast] = ACTIONS(3856),
    [anon_sym_downcast] = ACTIONS(3856),
    [anon_sym_COLON_GT] = ACTIONS(3854),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3854),
    [anon_sym_for] = ACTIONS(3856),
    [anon_sym_while] = ACTIONS(3856),
    [anon_sym_if] = ACTIONS(3856),
    [anon_sym_fun] = ACTIONS(3856),
    [anon_sym_try] = ACTIONS(3856),
    [anon_sym_match] = ACTIONS(3856),
    [anon_sym_match_BANG] = ACTIONS(3854),
    [anon_sym_function] = ACTIONS(3856),
    [anon_sym_LT_DASH] = ACTIONS(3856),
    [anon_sym_DOT_LBRACK] = ACTIONS(3854),
    [anon_sym_LT] = ACTIONS(3854),
    [anon_sym_use] = ACTIONS(3856),
    [anon_sym_use_BANG] = ACTIONS(3854),
    [anon_sym_do_BANG] = ACTIONS(3854),
    [anon_sym_begin] = ACTIONS(3856),
    [anon_sym_LPAREN2] = ACTIONS(3856),
    [anon_sym_default] = ACTIONS(3856),
    [anon_sym_or] = ACTIONS(3856),
    [anon_sym_static] = ACTIONS(3856),
    [anon_sym_member] = ACTIONS(3856),
    [anon_sym_interface] = ACTIONS(3856),
    [anon_sym_abstract] = ACTIONS(3856),
    [anon_sym_val] = ACTIONS(3856),
    [anon_sym_override] = ACTIONS(3856),
    [aux_sym_char_token1] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3856),
    [anon_sym_DQUOTE] = ACTIONS(3856),
    [anon_sym_AT_DQUOTE] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [sym_bool] = ACTIONS(3856),
    [sym_unit] = ACTIONS(3854),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3856),
    [sym_op_identifier] = ACTIONS(3856),
    [anon_sym_PLUS] = ACTIONS(3856),
    [anon_sym_DASH] = ACTIONS(3856),
    [anon_sym_PLUS_DOT] = ACTIONS(3856),
    [anon_sym_DASH_DOT] = ACTIONS(3856),
    [anon_sym_PERCENT] = ACTIONS(3856),
    [anon_sym_AMP_AMP] = ACTIONS(3856),
    [anon_sym_TILDE] = ACTIONS(3854),
    [aux_sym_prefix_op_token1] = ACTIONS(3856),
    [aux_sym_infix_op_token1] = ACTIONS(3854),
    [aux_sym_infix_op_token2] = ACTIONS(3856),
    [anon_sym_PIPE_PIPE] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3856),
    [anon_sym_COLON_EQ] = ACTIONS(3854),
    [anon_sym_DOLLAR] = ACTIONS(3856),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3856),
    [sym_int] = ACTIONS(3856),
    [sym_xint] = ACTIONS(3854),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3854),
    [sym__newline] = ACTIONS(3854),
    [sym__dedent] = ACTIONS(3854),
  },
  [2217] = {
    [sym_block_comment] = STATE(2217),
    [sym_compiler_directive_decl] = STATE(2217),
    [sym_fsi_directive_decl] = STATE(2217),
    [sym_preproc_line] = STATE(2217),
    [sym_identifier] = ACTIONS(4137),
    [anon_sym_EQ] = ACTIONS(4135),
    [anon_sym_LBRACK_LT] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4137),
    [anon_sym_return] = ACTIONS(4137),
    [anon_sym_do] = ACTIONS(4137),
    [anon_sym_and] = ACTIONS(4137),
    [anon_sym_let] = ACTIONS(4137),
    [anon_sym_let_BANG] = ACTIONS(4135),
    [aux_sym_access_modifier_token1] = ACTIONS(4135),
    [anon_sym_LPAREN] = ACTIONS(4137),
    [anon_sym_COMMA] = ACTIONS(4135),
    [anon_sym_null] = ACTIONS(4137),
    [anon_sym_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_COLON] = ACTIONS(4135),
    [anon_sym_AMP] = ACTIONS(4137),
    [anon_sym_LBRACK] = ACTIONS(4137),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4135),
    [anon_sym_LBRACE] = ACTIONS(4137),
    [anon_sym_LT_AT] = ACTIONS(4137),
    [anon_sym_LT_AT_AT] = ACTIONS(4137),
    [anon_sym_DOT] = ACTIONS(4137),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4135),
    [anon_sym_new] = ACTIONS(4137),
    [anon_sym_with] = ACTIONS(4137),
    [anon_sym_return_BANG] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_yield_BANG] = ACTIONS(4135),
    [anon_sym_lazy] = ACTIONS(4137),
    [anon_sym_assert] = ACTIONS(4137),
    [anon_sym_upcast] = ACTIONS(4137),
    [anon_sym_downcast] = ACTIONS(4137),
    [anon_sym_COLON_GT] = ACTIONS(4135),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4135),
    [anon_sym_for] = ACTIONS(4137),
    [anon_sym_while] = ACTIONS(4137),
    [anon_sym_if] = ACTIONS(4137),
    [anon_sym_fun] = ACTIONS(4137),
    [anon_sym_try] = ACTIONS(4137),
    [anon_sym_match] = ACTIONS(4137),
    [anon_sym_match_BANG] = ACTIONS(4135),
    [anon_sym_function] = ACTIONS(4137),
    [anon_sym_LT_DASH] = ACTIONS(4137),
    [anon_sym_DOT_LBRACK] = ACTIONS(4135),
    [anon_sym_LT] = ACTIONS(4135),
    [anon_sym_use] = ACTIONS(4137),
    [anon_sym_use_BANG] = ACTIONS(4135),
    [anon_sym_do_BANG] = ACTIONS(4135),
    [anon_sym_begin] = ACTIONS(4137),
    [anon_sym_LPAREN2] = ACTIONS(4137),
    [anon_sym_default] = ACTIONS(4137),
    [anon_sym_or] = ACTIONS(4137),
    [anon_sym_static] = ACTIONS(4137),
    [anon_sym_member] = ACTIONS(4137),
    [anon_sym_interface] = ACTIONS(4137),
    [anon_sym_abstract] = ACTIONS(4137),
    [anon_sym_val] = ACTIONS(4137),
    [anon_sym_override] = ACTIONS(4137),
    [aux_sym_char_token1] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4137),
    [anon_sym_DQUOTE] = ACTIONS(4137),
    [anon_sym_AT_DQUOTE] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [sym_bool] = ACTIONS(4137),
    [sym_unit] = ACTIONS(4135),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4137),
    [sym_op_identifier] = ACTIONS(4137),
    [anon_sym_PLUS] = ACTIONS(4137),
    [anon_sym_DASH] = ACTIONS(4137),
    [anon_sym_PLUS_DOT] = ACTIONS(4137),
    [anon_sym_DASH_DOT] = ACTIONS(4137),
    [anon_sym_PERCENT] = ACTIONS(4137),
    [anon_sym_AMP_AMP] = ACTIONS(4137),
    [anon_sym_TILDE] = ACTIONS(4135),
    [aux_sym_prefix_op_token1] = ACTIONS(4137),
    [aux_sym_infix_op_token1] = ACTIONS(4135),
    [aux_sym_infix_op_token2] = ACTIONS(4137),
    [anon_sym_PIPE_PIPE] = ACTIONS(4137),
    [anon_sym_BANG_EQ] = ACTIONS(4137),
    [anon_sym_COLON_EQ] = ACTIONS(4135),
    [anon_sym_DOLLAR] = ACTIONS(4137),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4137),
    [sym_int] = ACTIONS(4137),
    [sym_xint] = ACTIONS(4135),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4135),
    [sym__newline] = ACTIONS(4135),
    [sym__dedent] = ACTIONS(4135),
  },
  [2218] = {
    [sym_block_comment] = STATE(2218),
    [sym_compiler_directive_decl] = STATE(2218),
    [sym_fsi_directive_decl] = STATE(2218),
    [sym_preproc_line] = STATE(2218),
    [sym_identifier] = ACTIONS(4240),
    [anon_sym_EQ] = ACTIONS(4238),
    [anon_sym_LBRACK_LT] = ACTIONS(4238),
    [anon_sym_COLON] = ACTIONS(4240),
    [anon_sym_return] = ACTIONS(4240),
    [anon_sym_do] = ACTIONS(4240),
    [anon_sym_and] = ACTIONS(4240),
    [anon_sym_let] = ACTIONS(4240),
    [anon_sym_let_BANG] = ACTIONS(4238),
    [aux_sym_access_modifier_token1] = ACTIONS(4238),
    [anon_sym_LPAREN] = ACTIONS(4240),
    [anon_sym_COMMA] = ACTIONS(4238),
    [anon_sym_null] = ACTIONS(4240),
    [anon_sym_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_COLON] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4240),
    [anon_sym_LBRACK] = ACTIONS(4240),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4238),
    [anon_sym_LBRACE] = ACTIONS(4240),
    [anon_sym_LT_AT] = ACTIONS(4240),
    [anon_sym_LT_AT_AT] = ACTIONS(4240),
    [anon_sym_DOT] = ACTIONS(4240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4238),
    [anon_sym_new] = ACTIONS(4240),
    [anon_sym_with] = ACTIONS(4240),
    [anon_sym_return_BANG] = ACTIONS(4238),
    [anon_sym_yield] = ACTIONS(4240),
    [anon_sym_yield_BANG] = ACTIONS(4238),
    [anon_sym_lazy] = ACTIONS(4240),
    [anon_sym_assert] = ACTIONS(4240),
    [anon_sym_upcast] = ACTIONS(4240),
    [anon_sym_downcast] = ACTIONS(4240),
    [anon_sym_COLON_GT] = ACTIONS(4238),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4238),
    [anon_sym_for] = ACTIONS(4240),
    [anon_sym_while] = ACTIONS(4240),
    [anon_sym_if] = ACTIONS(4240),
    [anon_sym_fun] = ACTIONS(4240),
    [anon_sym_try] = ACTIONS(4240),
    [anon_sym_match] = ACTIONS(4240),
    [anon_sym_match_BANG] = ACTIONS(4238),
    [anon_sym_function] = ACTIONS(4240),
    [anon_sym_LT_DASH] = ACTIONS(4240),
    [anon_sym_DOT_LBRACK] = ACTIONS(4238),
    [anon_sym_LT] = ACTIONS(4238),
    [anon_sym_use] = ACTIONS(4240),
    [anon_sym_use_BANG] = ACTIONS(4238),
    [anon_sym_do_BANG] = ACTIONS(4238),
    [anon_sym_begin] = ACTIONS(4240),
    [anon_sym_LPAREN2] = ACTIONS(4240),
    [anon_sym_default] = ACTIONS(4240),
    [anon_sym_or] = ACTIONS(4240),
    [anon_sym_static] = ACTIONS(4240),
    [anon_sym_member] = ACTIONS(4240),
    [anon_sym_interface] = ACTIONS(4240),
    [anon_sym_abstract] = ACTIONS(4240),
    [anon_sym_val] = ACTIONS(4240),
    [anon_sym_override] = ACTIONS(4240),
    [aux_sym_char_token1] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4240),
    [anon_sym_DQUOTE] = ACTIONS(4240),
    [anon_sym_AT_DQUOTE] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [sym_bool] = ACTIONS(4240),
    [sym_unit] = ACTIONS(4238),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4240),
    [sym_op_identifier] = ACTIONS(4240),
    [anon_sym_PLUS] = ACTIONS(4240),
    [anon_sym_DASH] = ACTIONS(4240),
    [anon_sym_PLUS_DOT] = ACTIONS(4240),
    [anon_sym_DASH_DOT] = ACTIONS(4240),
    [anon_sym_PERCENT] = ACTIONS(4240),
    [anon_sym_AMP_AMP] = ACTIONS(4240),
    [anon_sym_TILDE] = ACTIONS(4238),
    [aux_sym_prefix_op_token1] = ACTIONS(4240),
    [aux_sym_infix_op_token1] = ACTIONS(4238),
    [aux_sym_infix_op_token2] = ACTIONS(4240),
    [anon_sym_PIPE_PIPE] = ACTIONS(4240),
    [anon_sym_BANG_EQ] = ACTIONS(4240),
    [anon_sym_COLON_EQ] = ACTIONS(4238),
    [anon_sym_DOLLAR] = ACTIONS(4240),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4240),
    [sym_int] = ACTIONS(4240),
    [sym_xint] = ACTIONS(4238),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4238),
    [sym__newline] = ACTIONS(4238),
    [sym__dedent] = ACTIONS(4238),
  },
  [2219] = {
    [sym_block_comment] = STATE(2219),
    [sym_compiler_directive_decl] = STATE(2219),
    [sym_fsi_directive_decl] = STATE(2219),
    [sym_preproc_line] = STATE(2219),
    [aux_sym_compound_type_repeat1] = STATE(2166),
    [sym_identifier] = ACTIONS(3468),
    [anon_sym_EQ] = ACTIONS(3466),
    [anon_sym_GT_RBRACK] = ACTIONS(3466),
    [anon_sym_COLON] = ACTIONS(3468),
    [anon_sym_return] = ACTIONS(3468),
    [anon_sym_do] = ACTIONS(3468),
    [anon_sym_let] = ACTIONS(3468),
    [anon_sym_let_BANG] = ACTIONS(3466),
    [anon_sym_LPAREN] = ACTIONS(3468),
    [anon_sym_COMMA] = ACTIONS(3466),
    [anon_sym_null] = ACTIONS(3468),
    [anon_sym_QMARK] = ACTIONS(3468),
    [anon_sym_COLON_QMARK] = ACTIONS(3468),
    [anon_sym_COLON_COLON] = ACTIONS(3466),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LBRACK] = ACTIONS(3468),
    [anon_sym_RBRACK] = ACTIONS(3466),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3466),
    [anon_sym_LBRACE] = ACTIONS(3468),
    [anon_sym_RBRACE] = ACTIONS(3466),
    [anon_sym_LT_AT] = ACTIONS(3468),
    [anon_sym_LT_AT_AT] = ACTIONS(3468),
    [anon_sym_DOT] = ACTIONS(3468),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3466),
    [anon_sym_new] = ACTIONS(3468),
    [anon_sym_with] = ACTIONS(3468),
    [anon_sym_return_BANG] = ACTIONS(3466),
    [anon_sym_yield] = ACTIONS(3468),
    [anon_sym_yield_BANG] = ACTIONS(3466),
    [anon_sym_lazy] = ACTIONS(3468),
    [anon_sym_assert] = ACTIONS(3468),
    [anon_sym_upcast] = ACTIONS(3468),
    [anon_sym_downcast] = ACTIONS(3468),
    [anon_sym_COLON_GT] = ACTIONS(3466),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3466),
    [anon_sym_for] = ACTIONS(3468),
    [anon_sym_to] = ACTIONS(3468),
    [anon_sym_downto] = ACTIONS(3468),
    [anon_sym_while] = ACTIONS(3468),
    [anon_sym_if] = ACTIONS(3468),
    [anon_sym_fun] = ACTIONS(3468),
    [anon_sym_DASH_GT] = ACTIONS(3468),
    [anon_sym_try] = ACTIONS(3468),
    [anon_sym_match] = ACTIONS(3468),
    [anon_sym_match_BANG] = ACTIONS(3466),
    [anon_sym_function] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3468),
    [anon_sym_DOT_LBRACK] = ACTIONS(3466),
    [anon_sym_LT] = ACTIONS(3466),
    [anon_sym_use] = ACTIONS(3468),
    [anon_sym_use_BANG] = ACTIONS(3466),
    [anon_sym_do_BANG] = ACTIONS(3466),
    [anon_sym_begin] = ACTIONS(3468),
    [anon_sym_LPAREN2] = ACTIONS(3468),
    [anon_sym_DOT_DOT2] = ACTIONS(3466),
    [anon_sym_STAR] = ACTIONS(4557),
    [anon_sym_LT2] = ACTIONS(3468),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3466),
    [anon_sym_or] = ACTIONS(3468),
    [aux_sym_char_token1] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3468),
    [anon_sym_DQUOTE] = ACTIONS(3468),
    [anon_sym_AT_DQUOTE] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [sym_bool] = ACTIONS(3468),
    [sym_unit] = ACTIONS(3466),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3468),
    [sym_op_identifier] = ACTIONS(3468),
    [anon_sym_PLUS] = ACTIONS(3468),
    [anon_sym_DASH] = ACTIONS(3468),
    [anon_sym_PLUS_DOT] = ACTIONS(3468),
    [anon_sym_DASH_DOT] = ACTIONS(3468),
    [anon_sym_PERCENT] = ACTIONS(3468),
    [anon_sym_AMP_AMP] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3466),
    [aux_sym_prefix_op_token1] = ACTIONS(3468),
    [aux_sym_infix_op_token1] = ACTIONS(3466),
    [aux_sym_infix_op_token2] = ACTIONS(3468),
    [anon_sym_PIPE_PIPE] = ACTIONS(3468),
    [anon_sym_BANG_EQ] = ACTIONS(3468),
    [anon_sym_COLON_EQ] = ACTIONS(3466),
    [anon_sym_DOLLAR] = ACTIONS(3468),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3468),
    [sym_int] = ACTIONS(3468),
    [sym_xint] = ACTIONS(3466),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3466),
    [sym__newline] = ACTIONS(3466),
  },
  [2220] = {
    [sym_block_comment] = STATE(2220),
    [sym_compiler_directive_decl] = STATE(2220),
    [sym_fsi_directive_decl] = STATE(2220),
    [sym_preproc_line] = STATE(2220),
    [sym_identifier] = ACTIONS(3885),
    [anon_sym_EQ] = ACTIONS(3883),
    [anon_sym_LBRACK_LT] = ACTIONS(3883),
    [anon_sym_COLON] = ACTIONS(3885),
    [anon_sym_return] = ACTIONS(3885),
    [anon_sym_do] = ACTIONS(3885),
    [anon_sym_let] = ACTIONS(3885),
    [anon_sym_let_BANG] = ACTIONS(3883),
    [aux_sym_access_modifier_token1] = ACTIONS(3883),
    [anon_sym_LPAREN] = ACTIONS(3885),
    [anon_sym_COMMA] = ACTIONS(3883),
    [anon_sym_null] = ACTIONS(3885),
    [anon_sym_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3883),
    [anon_sym_AMP] = ACTIONS(3885),
    [anon_sym_LBRACK] = ACTIONS(3885),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3883),
    [anon_sym_LBRACE] = ACTIONS(3885),
    [anon_sym_LT_AT] = ACTIONS(3885),
    [anon_sym_LT_AT_AT] = ACTIONS(3885),
    [anon_sym_DOT] = ACTIONS(3885),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3883),
    [anon_sym_new] = ACTIONS(3885),
    [anon_sym_with] = ACTIONS(3885),
    [anon_sym_return_BANG] = ACTIONS(3883),
    [anon_sym_yield] = ACTIONS(3885),
    [anon_sym_yield_BANG] = ACTIONS(3883),
    [anon_sym_lazy] = ACTIONS(3885),
    [anon_sym_assert] = ACTIONS(3885),
    [anon_sym_upcast] = ACTIONS(3885),
    [anon_sym_downcast] = ACTIONS(3885),
    [anon_sym_COLON_GT] = ACTIONS(3883),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3883),
    [anon_sym_for] = ACTIONS(3885),
    [anon_sym_while] = ACTIONS(3885),
    [anon_sym_if] = ACTIONS(3885),
    [anon_sym_fun] = ACTIONS(3885),
    [anon_sym_try] = ACTIONS(3885),
    [anon_sym_match] = ACTIONS(3885),
    [anon_sym_match_BANG] = ACTIONS(3883),
    [anon_sym_function] = ACTIONS(3885),
    [anon_sym_LT_DASH] = ACTIONS(3885),
    [anon_sym_DOT_LBRACK] = ACTIONS(3883),
    [anon_sym_LT] = ACTIONS(3883),
    [anon_sym_use] = ACTIONS(3885),
    [anon_sym_use_BANG] = ACTIONS(3883),
    [anon_sym_do_BANG] = ACTIONS(3883),
    [anon_sym_begin] = ACTIONS(3885),
    [anon_sym_LPAREN2] = ACTIONS(3885),
    [anon_sym_DOT_DOT2] = ACTIONS(3883),
    [anon_sym_default] = ACTIONS(3885),
    [anon_sym_or] = ACTIONS(3885),
    [anon_sym_static] = ACTIONS(3885),
    [anon_sym_member] = ACTIONS(3885),
    [anon_sym_interface] = ACTIONS(3885),
    [anon_sym_abstract] = ACTIONS(3885),
    [anon_sym_val] = ACTIONS(3885),
    [anon_sym_override] = ACTIONS(3885),
    [aux_sym_char_token1] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3885),
    [anon_sym_DQUOTE] = ACTIONS(3885),
    [anon_sym_AT_DQUOTE] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [sym_bool] = ACTIONS(3885),
    [sym_unit] = ACTIONS(3883),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3885),
    [sym_op_identifier] = ACTIONS(3885),
    [anon_sym_PLUS] = ACTIONS(3885),
    [anon_sym_DASH] = ACTIONS(3885),
    [anon_sym_PLUS_DOT] = ACTIONS(3885),
    [anon_sym_DASH_DOT] = ACTIONS(3885),
    [anon_sym_PERCENT] = ACTIONS(3885),
    [anon_sym_AMP_AMP] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3883),
    [aux_sym_prefix_op_token1] = ACTIONS(3885),
    [aux_sym_infix_op_token1] = ACTIONS(3883),
    [aux_sym_infix_op_token2] = ACTIONS(3885),
    [anon_sym_PIPE_PIPE] = ACTIONS(3885),
    [anon_sym_BANG_EQ] = ACTIONS(3885),
    [anon_sym_COLON_EQ] = ACTIONS(3883),
    [anon_sym_DOLLAR] = ACTIONS(3885),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3885),
    [sym_int] = ACTIONS(3885),
    [sym_xint] = ACTIONS(3883),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3883),
    [sym__newline] = ACTIONS(3883),
    [sym__dedent] = ACTIONS(3883),
  },
  [2221] = {
    [sym__else_expression] = STATE(2384),
    [sym_elif_expression] = STATE(2274),
    [sym_block_comment] = STATE(2221),
    [sym_compiler_directive_decl] = STATE(2221),
    [sym_fsi_directive_decl] = STATE(2221),
    [sym_preproc_line] = STATE(2221),
    [aux_sym_if_expression_repeat1] = STATE(2202),
    [ts_builtin_sym_end] = ACTIONS(3470),
    [sym_identifier] = ACTIONS(3472),
    [anon_sym_namespace] = ACTIONS(3472),
    [anon_sym_module] = ACTIONS(3472),
    [anon_sym_EQ] = ACTIONS(3470),
    [anon_sym_open] = ACTIONS(3472),
    [anon_sym_LBRACK_LT] = ACTIONS(3470),
    [anon_sym_COLON] = ACTIONS(3472),
    [anon_sym_return] = ACTIONS(3472),
    [anon_sym_type] = ACTIONS(3472),
    [anon_sym_do] = ACTIONS(3472),
    [anon_sym_let] = ACTIONS(3472),
    [anon_sym_let_BANG] = ACTIONS(3470),
    [anon_sym_LPAREN] = ACTIONS(3472),
    [anon_sym_COMMA] = ACTIONS(3470),
    [anon_sym_null] = ACTIONS(3472),
    [anon_sym_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_COLON] = ACTIONS(3470),
    [anon_sym_AMP] = ACTIONS(3472),
    [anon_sym_LBRACK] = ACTIONS(3472),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3470),
    [anon_sym_LBRACE] = ACTIONS(3472),
    [anon_sym_LT_AT] = ACTIONS(3472),
    [anon_sym_LT_AT_AT] = ACTIONS(3472),
    [anon_sym_DOT] = ACTIONS(3472),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3470),
    [anon_sym_new] = ACTIONS(3472),
    [anon_sym_return_BANG] = ACTIONS(3470),
    [anon_sym_yield] = ACTIONS(3472),
    [anon_sym_yield_BANG] = ACTIONS(3470),
    [anon_sym_lazy] = ACTIONS(3472),
    [anon_sym_assert] = ACTIONS(3472),
    [anon_sym_upcast] = ACTIONS(3472),
    [anon_sym_downcast] = ACTIONS(3472),
    [anon_sym_COLON_GT] = ACTIONS(3470),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3470),
    [anon_sym_for] = ACTIONS(3472),
    [anon_sym_while] = ACTIONS(3472),
    [anon_sym_else] = ACTIONS(4779),
    [anon_sym_elif] = ACTIONS(4781),
    [anon_sym_if] = ACTIONS(3472),
    [anon_sym_fun] = ACTIONS(3472),
    [anon_sym_try] = ACTIONS(3472),
    [anon_sym_match] = ACTIONS(3472),
    [anon_sym_match_BANG] = ACTIONS(3470),
    [anon_sym_function] = ACTIONS(3472),
    [anon_sym_LT_DASH] = ACTIONS(3472),
    [anon_sym_DOT_LBRACK] = ACTIONS(3470),
    [anon_sym_LT] = ACTIONS(3470),
    [anon_sym_use] = ACTIONS(3472),
    [anon_sym_use_BANG] = ACTIONS(3470),
    [anon_sym_do_BANG] = ACTIONS(3470),
    [anon_sym_begin] = ACTIONS(3472),
    [anon_sym_LPAREN2] = ACTIONS(3472),
    [anon_sym_or] = ACTIONS(3472),
    [anon_sym_exception] = ACTIONS(3472),
    [aux_sym_char_token1] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3472),
    [anon_sym_DQUOTE] = ACTIONS(3472),
    [anon_sym_AT_DQUOTE] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [sym_bool] = ACTIONS(3472),
    [sym_unit] = ACTIONS(3470),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3472),
    [sym_op_identifier] = ACTIONS(3472),
    [anon_sym_PLUS] = ACTIONS(3472),
    [anon_sym_DASH] = ACTIONS(3472),
    [anon_sym_PLUS_DOT] = ACTIONS(3472),
    [anon_sym_DASH_DOT] = ACTIONS(3472),
    [anon_sym_PERCENT] = ACTIONS(3472),
    [anon_sym_AMP_AMP] = ACTIONS(3472),
    [anon_sym_TILDE] = ACTIONS(3470),
    [aux_sym_prefix_op_token1] = ACTIONS(3472),
    [aux_sym_infix_op_token1] = ACTIONS(3470),
    [aux_sym_infix_op_token2] = ACTIONS(3472),
    [anon_sym_PIPE_PIPE] = ACTIONS(3472),
    [anon_sym_BANG_EQ] = ACTIONS(3472),
    [anon_sym_COLON_EQ] = ACTIONS(3470),
    [anon_sym_DOLLAR] = ACTIONS(3472),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3472),
    [sym_int] = ACTIONS(3472),
    [sym_xint] = ACTIONS(3470),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3470),
    [anon_sym_POUNDload] = ACTIONS(3470),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3470),
    [sym__newline] = ACTIONS(3470),
  },
  [2222] = {
    [sym_block_comment] = STATE(2222),
    [sym_compiler_directive_decl] = STATE(2222),
    [sym_fsi_directive_decl] = STATE(2222),
    [sym_preproc_line] = STATE(2222),
    [sym_identifier] = ACTIONS(4130),
    [anon_sym_EQ] = ACTIONS(4128),
    [anon_sym_LBRACK_LT] = ACTIONS(4128),
    [anon_sym_COLON] = ACTIONS(4130),
    [anon_sym_return] = ACTIONS(4130),
    [anon_sym_do] = ACTIONS(4130),
    [anon_sym_let] = ACTIONS(4130),
    [anon_sym_let_BANG] = ACTIONS(4128),
    [aux_sym_access_modifier_token1] = ACTIONS(4128),
    [anon_sym_LPAREN] = ACTIONS(4130),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_null] = ACTIONS(4130),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_COLON] = ACTIONS(4128),
    [anon_sym_AMP] = ACTIONS(4130),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4128),
    [anon_sym_LBRACE] = ACTIONS(4130),
    [anon_sym_LT_AT] = ACTIONS(4130),
    [anon_sym_LT_AT_AT] = ACTIONS(4130),
    [anon_sym_DOT] = ACTIONS(4130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4128),
    [anon_sym_new] = ACTIONS(4130),
    [anon_sym_with] = ACTIONS(4130),
    [anon_sym_return_BANG] = ACTIONS(4128),
    [anon_sym_yield] = ACTIONS(4130),
    [anon_sym_yield_BANG] = ACTIONS(4128),
    [anon_sym_lazy] = ACTIONS(4130),
    [anon_sym_assert] = ACTIONS(4130),
    [anon_sym_upcast] = ACTIONS(4130),
    [anon_sym_downcast] = ACTIONS(4130),
    [anon_sym_COLON_GT] = ACTIONS(4128),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4128),
    [anon_sym_for] = ACTIONS(4130),
    [anon_sym_while] = ACTIONS(4130),
    [anon_sym_if] = ACTIONS(4130),
    [anon_sym_fun] = ACTIONS(4130),
    [anon_sym_try] = ACTIONS(4130),
    [anon_sym_match] = ACTIONS(4130),
    [anon_sym_match_BANG] = ACTIONS(4128),
    [anon_sym_function] = ACTIONS(4130),
    [anon_sym_LT_DASH] = ACTIONS(4130),
    [anon_sym_DOT_LBRACK] = ACTIONS(4128),
    [anon_sym_LT] = ACTIONS(4128),
    [anon_sym_use] = ACTIONS(4130),
    [anon_sym_use_BANG] = ACTIONS(4128),
    [anon_sym_do_BANG] = ACTIONS(4128),
    [anon_sym_begin] = ACTIONS(4130),
    [anon_sym_LPAREN2] = ACTIONS(4130),
    [anon_sym_DOT_DOT2] = ACTIONS(4128),
    [anon_sym_default] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_static] = ACTIONS(4130),
    [anon_sym_member] = ACTIONS(4130),
    [anon_sym_interface] = ACTIONS(4130),
    [anon_sym_abstract] = ACTIONS(4130),
    [anon_sym_val] = ACTIONS(4130),
    [anon_sym_override] = ACTIONS(4130),
    [aux_sym_char_token1] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4130),
    [anon_sym_DQUOTE] = ACTIONS(4130),
    [anon_sym_AT_DQUOTE] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [sym_bool] = ACTIONS(4130),
    [sym_unit] = ACTIONS(4128),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4130),
    [sym_op_identifier] = ACTIONS(4130),
    [anon_sym_PLUS] = ACTIONS(4130),
    [anon_sym_DASH] = ACTIONS(4130),
    [anon_sym_PLUS_DOT] = ACTIONS(4130),
    [anon_sym_DASH_DOT] = ACTIONS(4130),
    [anon_sym_PERCENT] = ACTIONS(4130),
    [anon_sym_AMP_AMP] = ACTIONS(4130),
    [anon_sym_TILDE] = ACTIONS(4128),
    [aux_sym_prefix_op_token1] = ACTIONS(4130),
    [aux_sym_infix_op_token1] = ACTIONS(4128),
    [aux_sym_infix_op_token2] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE] = ACTIONS(4130),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_COLON_EQ] = ACTIONS(4128),
    [anon_sym_DOLLAR] = ACTIONS(4130),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4130),
    [sym_int] = ACTIONS(4130),
    [sym_xint] = ACTIONS(4128),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4128),
    [sym__newline] = ACTIONS(4128),
    [sym__dedent] = ACTIONS(4128),
  },
  [2223] = {
    [sym_block_comment] = STATE(2223),
    [sym_compiler_directive_decl] = STATE(2223),
    [sym_fsi_directive_decl] = STATE(2223),
    [sym_preproc_line] = STATE(2223),
    [sym_identifier] = ACTIONS(4186),
    [anon_sym_EQ] = ACTIONS(4184),
    [anon_sym_LBRACK_LT] = ACTIONS(4184),
    [anon_sym_COLON] = ACTIONS(4186),
    [anon_sym_return] = ACTIONS(4186),
    [anon_sym_do] = ACTIONS(4186),
    [anon_sym_let] = ACTIONS(4186),
    [anon_sym_let_BANG] = ACTIONS(4184),
    [aux_sym_access_modifier_token1] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_COMMA] = ACTIONS(4184),
    [anon_sym_null] = ACTIONS(4186),
    [anon_sym_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_COLON] = ACTIONS(4184),
    [anon_sym_AMP] = ACTIONS(4186),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4184),
    [anon_sym_LBRACE] = ACTIONS(4186),
    [anon_sym_LT_AT] = ACTIONS(4186),
    [anon_sym_LT_AT_AT] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4186),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4184),
    [anon_sym_new] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4186),
    [anon_sym_return_BANG] = ACTIONS(4184),
    [anon_sym_yield] = ACTIONS(4186),
    [anon_sym_yield_BANG] = ACTIONS(4184),
    [anon_sym_lazy] = ACTIONS(4186),
    [anon_sym_assert] = ACTIONS(4186),
    [anon_sym_upcast] = ACTIONS(4186),
    [anon_sym_downcast] = ACTIONS(4186),
    [anon_sym_COLON_GT] = ACTIONS(4184),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4184),
    [anon_sym_for] = ACTIONS(4186),
    [anon_sym_while] = ACTIONS(4186),
    [anon_sym_if] = ACTIONS(4186),
    [anon_sym_fun] = ACTIONS(4186),
    [anon_sym_try] = ACTIONS(4186),
    [anon_sym_match] = ACTIONS(4186),
    [anon_sym_match_BANG] = ACTIONS(4184),
    [anon_sym_function] = ACTIONS(4186),
    [anon_sym_LT_DASH] = ACTIONS(4186),
    [anon_sym_DOT_LBRACK] = ACTIONS(4184),
    [anon_sym_LT] = ACTIONS(4184),
    [anon_sym_use] = ACTIONS(4186),
    [anon_sym_use_BANG] = ACTIONS(4184),
    [anon_sym_do_BANG] = ACTIONS(4184),
    [anon_sym_begin] = ACTIONS(4186),
    [anon_sym_LPAREN2] = ACTIONS(4186),
    [anon_sym_DOT_DOT2] = ACTIONS(4184),
    [anon_sym_default] = ACTIONS(4186),
    [anon_sym_or] = ACTIONS(4186),
    [anon_sym_static] = ACTIONS(4186),
    [anon_sym_member] = ACTIONS(4186),
    [anon_sym_interface] = ACTIONS(4186),
    [anon_sym_abstract] = ACTIONS(4186),
    [anon_sym_val] = ACTIONS(4186),
    [anon_sym_override] = ACTIONS(4186),
    [aux_sym_char_token1] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4186),
    [anon_sym_DQUOTE] = ACTIONS(4186),
    [anon_sym_AT_DQUOTE] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [sym_bool] = ACTIONS(4186),
    [sym_unit] = ACTIONS(4184),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4186),
    [sym_op_identifier] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4186),
    [anon_sym_DASH] = ACTIONS(4186),
    [anon_sym_PLUS_DOT] = ACTIONS(4186),
    [anon_sym_DASH_DOT] = ACTIONS(4186),
    [anon_sym_PERCENT] = ACTIONS(4186),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_TILDE] = ACTIONS(4184),
    [aux_sym_prefix_op_token1] = ACTIONS(4186),
    [aux_sym_infix_op_token1] = ACTIONS(4184),
    [aux_sym_infix_op_token2] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_COLON_EQ] = ACTIONS(4184),
    [anon_sym_DOLLAR] = ACTIONS(4186),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4186),
    [sym_int] = ACTIONS(4186),
    [sym_xint] = ACTIONS(4184),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4184),
    [sym__newline] = ACTIONS(4184),
    [sym__dedent] = ACTIONS(4184),
  },
  [2224] = {
    [sym_block_comment] = STATE(2224),
    [sym_compiler_directive_decl] = STATE(2224),
    [sym_fsi_directive_decl] = STATE(2224),
    [sym_preproc_line] = STATE(2224),
    [sym_identifier] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3919),
    [anon_sym_LBRACK_LT] = ACTIONS(3919),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_return] = ACTIONS(3921),
    [anon_sym_do] = ACTIONS(3921),
    [anon_sym_let] = ACTIONS(3921),
    [anon_sym_let_BANG] = ACTIONS(3919),
    [aux_sym_access_modifier_token1] = ACTIONS(3919),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3919),
    [anon_sym_null] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_COLON] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3919),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_LT_AT] = ACTIONS(3921),
    [anon_sym_LT_AT_AT] = ACTIONS(3921),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3919),
    [anon_sym_new] = ACTIONS(3921),
    [anon_sym_with] = ACTIONS(3921),
    [anon_sym_return_BANG] = ACTIONS(3919),
    [anon_sym_yield] = ACTIONS(3921),
    [anon_sym_yield_BANG] = ACTIONS(3919),
    [anon_sym_lazy] = ACTIONS(3921),
    [anon_sym_assert] = ACTIONS(3921),
    [anon_sym_upcast] = ACTIONS(3921),
    [anon_sym_downcast] = ACTIONS(3921),
    [anon_sym_COLON_GT] = ACTIONS(3919),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3919),
    [anon_sym_for] = ACTIONS(3921),
    [anon_sym_while] = ACTIONS(3921),
    [anon_sym_if] = ACTIONS(3921),
    [anon_sym_fun] = ACTIONS(3921),
    [anon_sym_try] = ACTIONS(3921),
    [anon_sym_match] = ACTIONS(3921),
    [anon_sym_match_BANG] = ACTIONS(3919),
    [anon_sym_function] = ACTIONS(3921),
    [anon_sym_LT_DASH] = ACTIONS(3921),
    [anon_sym_DOT_LBRACK] = ACTIONS(3919),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_use] = ACTIONS(3921),
    [anon_sym_use_BANG] = ACTIONS(3919),
    [anon_sym_do_BANG] = ACTIONS(3919),
    [anon_sym_begin] = ACTIONS(3921),
    [anon_sym_LPAREN2] = ACTIONS(3921),
    [anon_sym_DOT_DOT2] = ACTIONS(3919),
    [anon_sym_default] = ACTIONS(3921),
    [anon_sym_or] = ACTIONS(3921),
    [anon_sym_static] = ACTIONS(3921),
    [anon_sym_member] = ACTIONS(3921),
    [anon_sym_interface] = ACTIONS(3921),
    [anon_sym_abstract] = ACTIONS(3921),
    [anon_sym_val] = ACTIONS(3921),
    [anon_sym_override] = ACTIONS(3921),
    [aux_sym_char_token1] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_AT_DQUOTE] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [sym_bool] = ACTIONS(3921),
    [sym_unit] = ACTIONS(3919),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3921),
    [sym_op_identifier] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_DOT] = ACTIONS(3921),
    [anon_sym_DASH_DOT] = ACTIONS(3921),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3919),
    [aux_sym_prefix_op_token1] = ACTIONS(3921),
    [aux_sym_infix_op_token1] = ACTIONS(3919),
    [aux_sym_infix_op_token2] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_COLON_EQ] = ACTIONS(3919),
    [anon_sym_DOLLAR] = ACTIONS(3921),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3921),
    [sym_int] = ACTIONS(3921),
    [sym_xint] = ACTIONS(3919),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3919),
    [sym__newline] = ACTIONS(3919),
    [sym__dedent] = ACTIONS(3919),
  },
  [2225] = {
    [sym_block_comment] = STATE(2225),
    [sym_compiler_directive_decl] = STATE(2225),
    [sym_fsi_directive_decl] = STATE(2225),
    [sym_preproc_line] = STATE(2225),
    [sym_identifier] = ACTIONS(4212),
    [anon_sym_EQ] = ACTIONS(4210),
    [anon_sym_LBRACK_LT] = ACTIONS(4210),
    [anon_sym_COLON] = ACTIONS(4212),
    [anon_sym_return] = ACTIONS(4212),
    [anon_sym_do] = ACTIONS(4212),
    [anon_sym_let] = ACTIONS(4212),
    [anon_sym_let_BANG] = ACTIONS(4210),
    [aux_sym_access_modifier_token1] = ACTIONS(4210),
    [anon_sym_LPAREN] = ACTIONS(4212),
    [anon_sym_COMMA] = ACTIONS(4210),
    [anon_sym_null] = ACTIONS(4212),
    [anon_sym_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_COLON] = ACTIONS(4210),
    [anon_sym_AMP] = ACTIONS(4212),
    [anon_sym_LBRACK] = ACTIONS(4212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4210),
    [anon_sym_LBRACE] = ACTIONS(4212),
    [anon_sym_LT_AT] = ACTIONS(4212),
    [anon_sym_LT_AT_AT] = ACTIONS(4212),
    [anon_sym_DOT] = ACTIONS(4212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4210),
    [anon_sym_new] = ACTIONS(4212),
    [anon_sym_with] = ACTIONS(4212),
    [anon_sym_return_BANG] = ACTIONS(4210),
    [anon_sym_yield] = ACTIONS(4212),
    [anon_sym_yield_BANG] = ACTIONS(4210),
    [anon_sym_lazy] = ACTIONS(4212),
    [anon_sym_assert] = ACTIONS(4212),
    [anon_sym_upcast] = ACTIONS(4212),
    [anon_sym_downcast] = ACTIONS(4212),
    [anon_sym_COLON_GT] = ACTIONS(4210),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4210),
    [anon_sym_for] = ACTIONS(4212),
    [anon_sym_while] = ACTIONS(4212),
    [anon_sym_if] = ACTIONS(4212),
    [anon_sym_fun] = ACTIONS(4212),
    [anon_sym_try] = ACTIONS(4212),
    [anon_sym_match] = ACTIONS(4212),
    [anon_sym_match_BANG] = ACTIONS(4210),
    [anon_sym_function] = ACTIONS(4212),
    [anon_sym_LT_DASH] = ACTIONS(4212),
    [anon_sym_DOT_LBRACK] = ACTIONS(4210),
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_use] = ACTIONS(4212),
    [anon_sym_use_BANG] = ACTIONS(4210),
    [anon_sym_do_BANG] = ACTIONS(4210),
    [anon_sym_begin] = ACTIONS(4212),
    [anon_sym_LPAREN2] = ACTIONS(4212),
    [anon_sym_DOT_DOT2] = ACTIONS(4210),
    [anon_sym_default] = ACTIONS(4212),
    [anon_sym_or] = ACTIONS(4212),
    [anon_sym_static] = ACTIONS(4212),
    [anon_sym_member] = ACTIONS(4212),
    [anon_sym_interface] = ACTIONS(4212),
    [anon_sym_abstract] = ACTIONS(4212),
    [anon_sym_val] = ACTIONS(4212),
    [anon_sym_override] = ACTIONS(4212),
    [aux_sym_char_token1] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4212),
    [anon_sym_DQUOTE] = ACTIONS(4212),
    [anon_sym_AT_DQUOTE] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [sym_bool] = ACTIONS(4212),
    [sym_unit] = ACTIONS(4210),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4212),
    [anon_sym_DASH] = ACTIONS(4212),
    [anon_sym_PLUS_DOT] = ACTIONS(4212),
    [anon_sym_DASH_DOT] = ACTIONS(4212),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_AMP_AMP] = ACTIONS(4212),
    [anon_sym_TILDE] = ACTIONS(4210),
    [aux_sym_prefix_op_token1] = ACTIONS(4212),
    [aux_sym_infix_op_token1] = ACTIONS(4210),
    [aux_sym_infix_op_token2] = ACTIONS(4212),
    [anon_sym_PIPE_PIPE] = ACTIONS(4212),
    [anon_sym_BANG_EQ] = ACTIONS(4212),
    [anon_sym_COLON_EQ] = ACTIONS(4210),
    [anon_sym_DOLLAR] = ACTIONS(4212),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4212),
    [sym_int] = ACTIONS(4212),
    [sym_xint] = ACTIONS(4210),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4210),
    [sym__newline] = ACTIONS(4210),
    [sym__dedent] = ACTIONS(4210),
  },
  [2226] = {
    [sym_block_comment] = STATE(2226),
    [sym_compiler_directive_decl] = STATE(2226),
    [sym_fsi_directive_decl] = STATE(2226),
    [sym_preproc_line] = STATE(2226),
    [sym_identifier] = ACTIONS(3889),
    [anon_sym_EQ] = ACTIONS(3887),
    [anon_sym_LBRACK_LT] = ACTIONS(3887),
    [anon_sym_COLON] = ACTIONS(3889),
    [anon_sym_return] = ACTIONS(3889),
    [anon_sym_do] = ACTIONS(3889),
    [anon_sym_let] = ACTIONS(3889),
    [anon_sym_let_BANG] = ACTIONS(3887),
    [aux_sym_access_modifier_token1] = ACTIONS(3887),
    [anon_sym_LPAREN] = ACTIONS(3889),
    [anon_sym_COMMA] = ACTIONS(3887),
    [anon_sym_null] = ACTIONS(3889),
    [anon_sym_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_COLON] = ACTIONS(3887),
    [anon_sym_AMP] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3887),
    [anon_sym_LBRACE] = ACTIONS(3889),
    [anon_sym_LT_AT] = ACTIONS(3889),
    [anon_sym_LT_AT_AT] = ACTIONS(3889),
    [anon_sym_DOT] = ACTIONS(3889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [anon_sym_new] = ACTIONS(3889),
    [anon_sym_with] = ACTIONS(3889),
    [anon_sym_return_BANG] = ACTIONS(3887),
    [anon_sym_yield] = ACTIONS(3889),
    [anon_sym_yield_BANG] = ACTIONS(3887),
    [anon_sym_lazy] = ACTIONS(3889),
    [anon_sym_assert] = ACTIONS(3889),
    [anon_sym_upcast] = ACTIONS(3889),
    [anon_sym_downcast] = ACTIONS(3889),
    [anon_sym_COLON_GT] = ACTIONS(3887),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3887),
    [anon_sym_for] = ACTIONS(3889),
    [anon_sym_while] = ACTIONS(3889),
    [anon_sym_if] = ACTIONS(3889),
    [anon_sym_fun] = ACTIONS(3889),
    [anon_sym_try] = ACTIONS(3889),
    [anon_sym_match] = ACTIONS(3889),
    [anon_sym_match_BANG] = ACTIONS(3887),
    [anon_sym_function] = ACTIONS(3889),
    [anon_sym_LT_DASH] = ACTIONS(3889),
    [anon_sym_DOT_LBRACK] = ACTIONS(3887),
    [anon_sym_LT] = ACTIONS(3887),
    [anon_sym_use] = ACTIONS(3889),
    [anon_sym_use_BANG] = ACTIONS(3887),
    [anon_sym_do_BANG] = ACTIONS(3887),
    [anon_sym_begin] = ACTIONS(3889),
    [anon_sym_LPAREN2] = ACTIONS(3889),
    [anon_sym_DOT_DOT2] = ACTIONS(3887),
    [anon_sym_default] = ACTIONS(3889),
    [anon_sym_or] = ACTIONS(3889),
    [anon_sym_static] = ACTIONS(3889),
    [anon_sym_member] = ACTIONS(3889),
    [anon_sym_interface] = ACTIONS(3889),
    [anon_sym_abstract] = ACTIONS(3889),
    [anon_sym_val] = ACTIONS(3889),
    [anon_sym_override] = ACTIONS(3889),
    [aux_sym_char_token1] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3889),
    [anon_sym_DQUOTE] = ACTIONS(3889),
    [anon_sym_AT_DQUOTE] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [sym_bool] = ACTIONS(3889),
    [sym_unit] = ACTIONS(3887),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3889),
    [sym_op_identifier] = ACTIONS(3889),
    [anon_sym_PLUS] = ACTIONS(3889),
    [anon_sym_DASH] = ACTIONS(3889),
    [anon_sym_PLUS_DOT] = ACTIONS(3889),
    [anon_sym_DASH_DOT] = ACTIONS(3889),
    [anon_sym_PERCENT] = ACTIONS(3889),
    [anon_sym_AMP_AMP] = ACTIONS(3889),
    [anon_sym_TILDE] = ACTIONS(3887),
    [aux_sym_prefix_op_token1] = ACTIONS(3889),
    [aux_sym_infix_op_token1] = ACTIONS(3887),
    [aux_sym_infix_op_token2] = ACTIONS(3889),
    [anon_sym_PIPE_PIPE] = ACTIONS(3889),
    [anon_sym_BANG_EQ] = ACTIONS(3889),
    [anon_sym_COLON_EQ] = ACTIONS(3887),
    [anon_sym_DOLLAR] = ACTIONS(3889),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3889),
    [sym_int] = ACTIONS(3889),
    [sym_xint] = ACTIONS(3887),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3887),
    [sym__newline] = ACTIONS(3887),
    [sym__dedent] = ACTIONS(3887),
  },
  [2227] = {
    [sym_block_comment] = STATE(2227),
    [sym_compiler_directive_decl] = STATE(2227),
    [sym_fsi_directive_decl] = STATE(2227),
    [sym_preproc_line] = STATE(2227),
    [sym_identifier] = ACTIONS(3976),
    [anon_sym_EQ] = ACTIONS(3974),
    [anon_sym_LBRACK_LT] = ACTIONS(3974),
    [anon_sym_COLON] = ACTIONS(3976),
    [anon_sym_return] = ACTIONS(3976),
    [anon_sym_do] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_let_BANG] = ACTIONS(3974),
    [aux_sym_access_modifier_token1] = ACTIONS(3974),
    [anon_sym_LPAREN] = ACTIONS(3976),
    [anon_sym_COMMA] = ACTIONS(3974),
    [anon_sym_null] = ACTIONS(3976),
    [anon_sym_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_COLON] = ACTIONS(3974),
    [anon_sym_AMP] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(3976),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3974),
    [anon_sym_LBRACE] = ACTIONS(3976),
    [anon_sym_LT_AT] = ACTIONS(3976),
    [anon_sym_LT_AT_AT] = ACTIONS(3976),
    [anon_sym_DOT] = ACTIONS(3976),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3974),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_with] = ACTIONS(3976),
    [anon_sym_return_BANG] = ACTIONS(3974),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_yield_BANG] = ACTIONS(3974),
    [anon_sym_lazy] = ACTIONS(3976),
    [anon_sym_assert] = ACTIONS(3976),
    [anon_sym_upcast] = ACTIONS(3976),
    [anon_sym_downcast] = ACTIONS(3976),
    [anon_sym_COLON_GT] = ACTIONS(3974),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3974),
    [anon_sym_for] = ACTIONS(3976),
    [anon_sym_while] = ACTIONS(3976),
    [anon_sym_if] = ACTIONS(3976),
    [anon_sym_fun] = ACTIONS(3976),
    [anon_sym_try] = ACTIONS(3976),
    [anon_sym_match] = ACTIONS(3976),
    [anon_sym_match_BANG] = ACTIONS(3974),
    [anon_sym_function] = ACTIONS(3976),
    [anon_sym_LT_DASH] = ACTIONS(3976),
    [anon_sym_DOT_LBRACK] = ACTIONS(3974),
    [anon_sym_LT] = ACTIONS(3974),
    [anon_sym_use] = ACTIONS(3976),
    [anon_sym_use_BANG] = ACTIONS(3974),
    [anon_sym_do_BANG] = ACTIONS(3974),
    [anon_sym_begin] = ACTIONS(3976),
    [anon_sym_LPAREN2] = ACTIONS(3976),
    [anon_sym_default] = ACTIONS(3976),
    [anon_sym_or] = ACTIONS(3976),
    [anon_sym_static] = ACTIONS(3976),
    [anon_sym_member] = ACTIONS(3976),
    [anon_sym_interface] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3976),
    [anon_sym_val] = ACTIONS(3976),
    [anon_sym_override] = ACTIONS(3976),
    [anon_sym_inherit] = ACTIONS(3976),
    [aux_sym_char_token1] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3976),
    [anon_sym_DQUOTE] = ACTIONS(3976),
    [anon_sym_AT_DQUOTE] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [sym_bool] = ACTIONS(3976),
    [sym_unit] = ACTIONS(3974),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3976),
    [sym_op_identifier] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3976),
    [anon_sym_DASH] = ACTIONS(3976),
    [anon_sym_PLUS_DOT] = ACTIONS(3976),
    [anon_sym_DASH_DOT] = ACTIONS(3976),
    [anon_sym_PERCENT] = ACTIONS(3976),
    [anon_sym_AMP_AMP] = ACTIONS(3976),
    [anon_sym_TILDE] = ACTIONS(3974),
    [aux_sym_prefix_op_token1] = ACTIONS(3976),
    [aux_sym_infix_op_token1] = ACTIONS(3974),
    [aux_sym_infix_op_token2] = ACTIONS(3976),
    [anon_sym_PIPE_PIPE] = ACTIONS(3976),
    [anon_sym_BANG_EQ] = ACTIONS(3976),
    [anon_sym_COLON_EQ] = ACTIONS(3974),
    [anon_sym_DOLLAR] = ACTIONS(3976),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3976),
    [sym_int] = ACTIONS(3976),
    [sym_xint] = ACTIONS(3974),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3974),
    [anon_sym_POUNDendif] = ACTIONS(3974),
    [sym__newline] = ACTIONS(3974),
  },
  [2228] = {
    [sym_block_comment] = STATE(2228),
    [sym_compiler_directive_decl] = STATE(2228),
    [sym_fsi_directive_decl] = STATE(2228),
    [sym_preproc_line] = STATE(2228),
    [ts_builtin_sym_end] = ACTIONS(3513),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_namespace] = ACTIONS(3515),
    [anon_sym_module] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_open] = ACTIONS(3515),
    [anon_sym_LBRACK_LT] = ACTIONS(3513),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_type] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_COLON] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(3513),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_LT_DASH] = ACTIONS(3515),
    [anon_sym_DOT_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_or] = ACTIONS(3515),
    [anon_sym_exception] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3515),
    [anon_sym_DASH_DOT] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3515),
    [aux_sym_infix_op_token1] = ACTIONS(3513),
    [aux_sym_infix_op_token2] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3515),
    [anon_sym_COLON_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(3515),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3515),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3513),
    [anon_sym_POUNDload] = ACTIONS(3513),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
  },
  [2229] = {
    [sym_elif_expression] = STATE(2274),
    [sym_block_comment] = STATE(2229),
    [sym_compiler_directive_decl] = STATE(2229),
    [sym_fsi_directive_decl] = STATE(2229),
    [sym_preproc_line] = STATE(2229),
    [aux_sym_if_expression_repeat1] = STATE(2229),
    [ts_builtin_sym_end] = ACTIONS(3553),
    [sym_identifier] = ACTIONS(3555),
    [anon_sym_namespace] = ACTIONS(3555),
    [anon_sym_module] = ACTIONS(3555),
    [anon_sym_EQ] = ACTIONS(3553),
    [anon_sym_open] = ACTIONS(3555),
    [anon_sym_LBRACK_LT] = ACTIONS(3553),
    [anon_sym_COLON] = ACTIONS(3555),
    [anon_sym_return] = ACTIONS(3555),
    [anon_sym_type] = ACTIONS(3555),
    [anon_sym_do] = ACTIONS(3555),
    [anon_sym_let] = ACTIONS(3555),
    [anon_sym_let_BANG] = ACTIONS(3553),
    [anon_sym_LPAREN] = ACTIONS(3555),
    [anon_sym_COMMA] = ACTIONS(3553),
    [anon_sym_null] = ACTIONS(3555),
    [anon_sym_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_COLON] = ACTIONS(3553),
    [anon_sym_AMP] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(3555),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3553),
    [anon_sym_LBRACE] = ACTIONS(3555),
    [anon_sym_LT_AT] = ACTIONS(3555),
    [anon_sym_LT_AT_AT] = ACTIONS(3555),
    [anon_sym_DOT] = ACTIONS(3555),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3553),
    [anon_sym_new] = ACTIONS(3555),
    [anon_sym_return_BANG] = ACTIONS(3553),
    [anon_sym_yield] = ACTIONS(3555),
    [anon_sym_yield_BANG] = ACTIONS(3553),
    [anon_sym_lazy] = ACTIONS(3555),
    [anon_sym_assert] = ACTIONS(3555),
    [anon_sym_upcast] = ACTIONS(3555),
    [anon_sym_downcast] = ACTIONS(3555),
    [anon_sym_COLON_GT] = ACTIONS(3553),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3553),
    [anon_sym_for] = ACTIONS(3555),
    [anon_sym_while] = ACTIONS(3555),
    [anon_sym_else] = ACTIONS(3555),
    [anon_sym_elif] = ACTIONS(4786),
    [anon_sym_if] = ACTIONS(3555),
    [anon_sym_fun] = ACTIONS(3555),
    [anon_sym_try] = ACTIONS(3555),
    [anon_sym_match] = ACTIONS(3555),
    [anon_sym_match_BANG] = ACTIONS(3553),
    [anon_sym_function] = ACTIONS(3555),
    [anon_sym_LT_DASH] = ACTIONS(3555),
    [anon_sym_DOT_LBRACK] = ACTIONS(3553),
    [anon_sym_LT] = ACTIONS(3553),
    [anon_sym_use] = ACTIONS(3555),
    [anon_sym_use_BANG] = ACTIONS(3553),
    [anon_sym_do_BANG] = ACTIONS(3553),
    [anon_sym_begin] = ACTIONS(3555),
    [anon_sym_LPAREN2] = ACTIONS(3555),
    [anon_sym_or] = ACTIONS(3555),
    [anon_sym_exception] = ACTIONS(3555),
    [aux_sym_char_token1] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3555),
    [anon_sym_DQUOTE] = ACTIONS(3555),
    [anon_sym_AT_DQUOTE] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [sym_bool] = ACTIONS(3555),
    [sym_unit] = ACTIONS(3553),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3555),
    [sym_op_identifier] = ACTIONS(3555),
    [anon_sym_PLUS] = ACTIONS(3555),
    [anon_sym_DASH] = ACTIONS(3555),
    [anon_sym_PLUS_DOT] = ACTIONS(3555),
    [anon_sym_DASH_DOT] = ACTIONS(3555),
    [anon_sym_PERCENT] = ACTIONS(3555),
    [anon_sym_AMP_AMP] = ACTIONS(3555),
    [anon_sym_TILDE] = ACTIONS(3553),
    [aux_sym_prefix_op_token1] = ACTIONS(3555),
    [aux_sym_infix_op_token1] = ACTIONS(3553),
    [aux_sym_infix_op_token2] = ACTIONS(3555),
    [anon_sym_PIPE_PIPE] = ACTIONS(3555),
    [anon_sym_BANG_EQ] = ACTIONS(3555),
    [anon_sym_COLON_EQ] = ACTIONS(3553),
    [anon_sym_DOLLAR] = ACTIONS(3555),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3555),
    [sym_int] = ACTIONS(3555),
    [sym_xint] = ACTIONS(3553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3553),
    [anon_sym_POUNDload] = ACTIONS(3553),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3553),
    [sym__newline] = ACTIONS(3553),
  },
  [2230] = {
    [sym_block_comment] = STATE(2230),
    [sym_compiler_directive_decl] = STATE(2230),
    [sym_fsi_directive_decl] = STATE(2230),
    [sym_preproc_line] = STATE(2230),
    [ts_builtin_sym_end] = ACTIONS(3509),
    [sym_identifier] = ACTIONS(3511),
    [anon_sym_namespace] = ACTIONS(3511),
    [anon_sym_module] = ACTIONS(3511),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_open] = ACTIONS(3511),
    [anon_sym_LBRACK_LT] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3511),
    [anon_sym_return] = ACTIONS(3511),
    [anon_sym_type] = ACTIONS(3511),
    [anon_sym_do] = ACTIONS(3511),
    [anon_sym_let] = ACTIONS(3511),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3511),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3511),
    [anon_sym_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(3511),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_LT_AT] = ACTIONS(3511),
    [anon_sym_LT_AT_AT] = ACTIONS(3511),
    [anon_sym_DOT] = ACTIONS(3511),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3511),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3511),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3511),
    [anon_sym_assert] = ACTIONS(3511),
    [anon_sym_upcast] = ACTIONS(3511),
    [anon_sym_downcast] = ACTIONS(3511),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3511),
    [anon_sym_while] = ACTIONS(3511),
    [anon_sym_if] = ACTIONS(3511),
    [anon_sym_fun] = ACTIONS(3511),
    [anon_sym_DASH_GT] = ACTIONS(3511),
    [anon_sym_try] = ACTIONS(3511),
    [anon_sym_match] = ACTIONS(3511),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3511),
    [anon_sym_LT_DASH] = ACTIONS(3511),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3511),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3511),
    [anon_sym_LPAREN2] = ACTIONS(3511),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_LT2] = ACTIONS(3511),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3511),
    [anon_sym_exception] = ACTIONS(3511),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3511),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3511),
    [sym_unit] = ACTIONS(3509),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3511),
    [sym_op_identifier] = ACTIONS(3511),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3511),
    [anon_sym_PLUS_DOT] = ACTIONS(3511),
    [anon_sym_DASH_DOT] = ACTIONS(3511),
    [anon_sym_PERCENT] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3511),
    [aux_sym_infix_op_token1] = ACTIONS(3509),
    [aux_sym_infix_op_token2] = ACTIONS(3511),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_BANG_EQ] = ACTIONS(3511),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3511),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3511),
    [sym_int] = ACTIONS(3511),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3509),
    [anon_sym_POUNDload] = ACTIONS(3509),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [2231] = {
    [sym_block_comment] = STATE(2231),
    [sym_compiler_directive_decl] = STATE(2231),
    [sym_fsi_directive_decl] = STATE(2231),
    [sym_preproc_line] = STATE(2231),
    [sym_identifier] = ACTIONS(3531),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_GT_RBRACK] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(3531),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_do] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_null] = ACTIONS(3531),
    [anon_sym_QMARK] = ACTIONS(3531),
    [anon_sym_COLON_QMARK] = ACTIONS(3531),
    [anon_sym_COLON_COLON] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_RBRACK] = ACTIONS(3529),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3531),
    [anon_sym_RBRACE] = ACTIONS(3529),
    [anon_sym_LT_AT] = ACTIONS(3531),
    [anon_sym_LT_AT_AT] = ACTIONS(3531),
    [anon_sym_DOT] = ACTIONS(3531),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3531),
    [anon_sym_with] = ACTIONS(3531),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3531),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3531),
    [anon_sym_assert] = ACTIONS(3531),
    [anon_sym_upcast] = ACTIONS(3531),
    [anon_sym_downcast] = ACTIONS(3531),
    [anon_sym_COLON_GT] = ACTIONS(3529),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3531),
    [anon_sym_to] = ACTIONS(3531),
    [anon_sym_downto] = ACTIONS(3531),
    [anon_sym_while] = ACTIONS(3531),
    [anon_sym_if] = ACTIONS(3531),
    [anon_sym_fun] = ACTIONS(3531),
    [anon_sym_DASH_GT] = ACTIONS(3531),
    [anon_sym_try] = ACTIONS(3531),
    [anon_sym_match] = ACTIONS(3531),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3531),
    [anon_sym_LT_DASH] = ACTIONS(3531),
    [anon_sym_DOT_LBRACK] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_use] = ACTIONS(3531),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3531),
    [anon_sym_LPAREN2] = ACTIONS(3531),
    [anon_sym_DOT_DOT2] = ACTIONS(3529),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LT2] = ACTIONS(3531),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_or] = ACTIONS(3531),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3531),
    [anon_sym_DQUOTE] = ACTIONS(3531),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3531),
    [sym_unit] = ACTIONS(3529),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3531),
    [sym_op_identifier] = ACTIONS(3531),
    [anon_sym_PLUS] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(3531),
    [anon_sym_PLUS_DOT] = ACTIONS(3531),
    [anon_sym_DASH_DOT] = ACTIONS(3531),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_AMP_AMP] = ACTIONS(3531),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3531),
    [aux_sym_infix_op_token1] = ACTIONS(3529),
    [aux_sym_infix_op_token2] = ACTIONS(3531),
    [anon_sym_PIPE_PIPE] = ACTIONS(3531),
    [anon_sym_BANG_EQ] = ACTIONS(3531),
    [anon_sym_COLON_EQ] = ACTIONS(3529),
    [anon_sym_DOLLAR] = ACTIONS(3531),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3531),
    [sym_int] = ACTIONS(3531),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [sym__newline] = ACTIONS(3529),
  },
  [2232] = {
    [sym_block_comment] = STATE(2232),
    [sym_compiler_directive_decl] = STATE(2232),
    [sym_fsi_directive_decl] = STATE(2232),
    [sym_preproc_line] = STATE(2232),
    [ts_builtin_sym_end] = ACTIONS(3496),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_namespace] = ACTIONS(3498),
    [anon_sym_module] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_open] = ACTIONS(3498),
    [anon_sym_LBRACK_LT] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_type] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [anon_sym_DOT_LBRACK] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_or] = ACTIONS(3498),
    [anon_sym_exception] = ACTIONS(3498),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3498),
    [anon_sym_DASH_DOT] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3498),
    [aux_sym_infix_op_token1] = ACTIONS(3496),
    [aux_sym_infix_op_token2] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_COLON_EQ] = ACTIONS(3496),
    [anon_sym_DOLLAR] = ACTIONS(3498),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3498),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3496),
    [anon_sym_POUNDload] = ACTIONS(3496),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
  },
  [2233] = {
    [sym_block_comment] = STATE(2233),
    [sym_compiler_directive_decl] = STATE(2233),
    [sym_fsi_directive_decl] = STATE(2233),
    [sym_preproc_line] = STATE(2233),
    [sym_identifier] = ACTIONS(3539),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_GT_RBRACK] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3539),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_do] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3539),
    [anon_sym_let_BANG] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_null] = ACTIONS(3539),
    [anon_sym_QMARK] = ACTIONS(3539),
    [anon_sym_COLON_QMARK] = ACTIONS(3539),
    [anon_sym_COLON_COLON] = ACTIONS(3537),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_RBRACK] = ACTIONS(3537),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3537),
    [anon_sym_LBRACE] = ACTIONS(3539),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_LT_AT] = ACTIONS(3539),
    [anon_sym_LT_AT_AT] = ACTIONS(3539),
    [anon_sym_DOT] = ACTIONS(3539),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3537),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_with] = ACTIONS(3539),
    [anon_sym_return_BANG] = ACTIONS(3537),
    [anon_sym_yield] = ACTIONS(3539),
    [anon_sym_yield_BANG] = ACTIONS(3537),
    [anon_sym_lazy] = ACTIONS(3539),
    [anon_sym_assert] = ACTIONS(3539),
    [anon_sym_upcast] = ACTIONS(3539),
    [anon_sym_downcast] = ACTIONS(3539),
    [anon_sym_COLON_GT] = ACTIONS(3537),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3537),
    [anon_sym_for] = ACTIONS(3539),
    [anon_sym_to] = ACTIONS(3539),
    [anon_sym_downto] = ACTIONS(3539),
    [anon_sym_while] = ACTIONS(3539),
    [anon_sym_if] = ACTIONS(3539),
    [anon_sym_fun] = ACTIONS(3539),
    [anon_sym_DASH_GT] = ACTIONS(3539),
    [anon_sym_try] = ACTIONS(3539),
    [anon_sym_match] = ACTIONS(3539),
    [anon_sym_match_BANG] = ACTIONS(3537),
    [anon_sym_function] = ACTIONS(3539),
    [anon_sym_LT_DASH] = ACTIONS(3539),
    [anon_sym_DOT_LBRACK] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_use] = ACTIONS(3539),
    [anon_sym_use_BANG] = ACTIONS(3537),
    [anon_sym_do_BANG] = ACTIONS(3537),
    [anon_sym_begin] = ACTIONS(3539),
    [anon_sym_LPAREN2] = ACTIONS(3539),
    [anon_sym_DOT_DOT2] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_LT2] = ACTIONS(3539),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_or] = ACTIONS(3539),
    [aux_sym_char_token1] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3539),
    [anon_sym_DQUOTE] = ACTIONS(3539),
    [anon_sym_AT_DQUOTE] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [sym_bool] = ACTIONS(3539),
    [sym_unit] = ACTIONS(3537),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3539),
    [sym_op_identifier] = ACTIONS(3539),
    [anon_sym_PLUS] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(3539),
    [anon_sym_PLUS_DOT] = ACTIONS(3539),
    [anon_sym_DASH_DOT] = ACTIONS(3539),
    [anon_sym_PERCENT] = ACTIONS(3539),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_TILDE] = ACTIONS(3537),
    [aux_sym_prefix_op_token1] = ACTIONS(3539),
    [aux_sym_infix_op_token1] = ACTIONS(3537),
    [aux_sym_infix_op_token2] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3539),
    [anon_sym_BANG_EQ] = ACTIONS(3539),
    [anon_sym_COLON_EQ] = ACTIONS(3537),
    [anon_sym_DOLLAR] = ACTIONS(3539),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3539),
    [sym_int] = ACTIONS(3539),
    [sym_xint] = ACTIONS(3537),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3537),
    [sym__newline] = ACTIONS(3537),
  },
  [2234] = {
    [sym_block_comment] = STATE(2234),
    [sym_compiler_directive_decl] = STATE(2234),
    [sym_fsi_directive_decl] = STATE(2234),
    [sym_preproc_line] = STATE(2234),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3525),
    [anon_sym_GT_RBRACK] = ACTIONS(3525),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_COLON] = ACTIONS(3525),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_RBRACK] = ACTIONS(3525),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_RBRACE] = ACTIONS(3525),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_with] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_COLON_GT] = ACTIONS(3525),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_to] = ACTIONS(3527),
    [anon_sym_downto] = ACTIONS(3527),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_DASH_GT] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_LT_DASH] = ACTIONS(3527),
    [anon_sym_DOT_LBRACK] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_LPAREN2] = ACTIONS(3527),
    [anon_sym_DOT_DOT2] = ACTIONS(3525),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_LT2] = ACTIONS(3527),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_or] = ACTIONS(3527),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3525),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3527),
    [anon_sym_DASH_DOT] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3527),
    [aux_sym_infix_op_token1] = ACTIONS(3525),
    [aux_sym_infix_op_token2] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_COLON_EQ] = ACTIONS(3525),
    [anon_sym_DOLLAR] = ACTIONS(3527),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3527),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3525),
    [sym__newline] = ACTIONS(3525),
  },
  [2235] = {
    [sym_block_comment] = STATE(2235),
    [sym_compiler_directive_decl] = STATE(2235),
    [sym_fsi_directive_decl] = STATE(2235),
    [sym_preproc_line] = STATE(2235),
    [sym_identifier] = ACTIONS(3543),
    [anon_sym_EQ] = ACTIONS(3541),
    [anon_sym_GT_RBRACK] = ACTIONS(3541),
    [anon_sym_COLON] = ACTIONS(3543),
    [anon_sym_return] = ACTIONS(3543),
    [anon_sym_do] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3543),
    [anon_sym_let_BANG] = ACTIONS(3541),
    [anon_sym_LPAREN] = ACTIONS(3543),
    [anon_sym_COMMA] = ACTIONS(3541),
    [anon_sym_null] = ACTIONS(3543),
    [anon_sym_QMARK] = ACTIONS(3543),
    [anon_sym_COLON_QMARK] = ACTIONS(3543),
    [anon_sym_COLON_COLON] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3543),
    [anon_sym_RBRACK] = ACTIONS(3541),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3541),
    [anon_sym_LBRACE] = ACTIONS(3543),
    [anon_sym_RBRACE] = ACTIONS(3541),
    [anon_sym_LT_AT] = ACTIONS(3543),
    [anon_sym_LT_AT_AT] = ACTIONS(3543),
    [anon_sym_DOT] = ACTIONS(3543),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3541),
    [anon_sym_new] = ACTIONS(3543),
    [anon_sym_with] = ACTIONS(3543),
    [anon_sym_return_BANG] = ACTIONS(3541),
    [anon_sym_yield] = ACTIONS(3543),
    [anon_sym_yield_BANG] = ACTIONS(3541),
    [anon_sym_lazy] = ACTIONS(3543),
    [anon_sym_assert] = ACTIONS(3543),
    [anon_sym_upcast] = ACTIONS(3543),
    [anon_sym_downcast] = ACTIONS(3543),
    [anon_sym_COLON_GT] = ACTIONS(3541),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3541),
    [anon_sym_for] = ACTIONS(3543),
    [anon_sym_to] = ACTIONS(3543),
    [anon_sym_downto] = ACTIONS(3543),
    [anon_sym_while] = ACTIONS(3543),
    [anon_sym_if] = ACTIONS(3543),
    [anon_sym_fun] = ACTIONS(3543),
    [anon_sym_DASH_GT] = ACTIONS(3543),
    [anon_sym_try] = ACTIONS(3543),
    [anon_sym_match] = ACTIONS(3543),
    [anon_sym_match_BANG] = ACTIONS(3541),
    [anon_sym_function] = ACTIONS(3543),
    [anon_sym_LT_DASH] = ACTIONS(3543),
    [anon_sym_DOT_LBRACK] = ACTIONS(3541),
    [anon_sym_LT] = ACTIONS(3541),
    [anon_sym_use] = ACTIONS(3543),
    [anon_sym_use_BANG] = ACTIONS(3541),
    [anon_sym_do_BANG] = ACTIONS(3541),
    [anon_sym_begin] = ACTIONS(3543),
    [anon_sym_LPAREN2] = ACTIONS(3543),
    [anon_sym_DOT_DOT2] = ACTIONS(3541),
    [anon_sym_STAR] = ACTIONS(3543),
    [anon_sym_LT2] = ACTIONS(3543),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_or] = ACTIONS(3543),
    [aux_sym_char_token1] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3543),
    [anon_sym_DQUOTE] = ACTIONS(3543),
    [anon_sym_AT_DQUOTE] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [sym_bool] = ACTIONS(3543),
    [sym_unit] = ACTIONS(3541),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3543),
    [sym_op_identifier] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(3543),
    [anon_sym_DASH] = ACTIONS(3543),
    [anon_sym_PLUS_DOT] = ACTIONS(3543),
    [anon_sym_DASH_DOT] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3543),
    [anon_sym_AMP_AMP] = ACTIONS(3543),
    [anon_sym_TILDE] = ACTIONS(3541),
    [aux_sym_prefix_op_token1] = ACTIONS(3543),
    [aux_sym_infix_op_token1] = ACTIONS(3541),
    [aux_sym_infix_op_token2] = ACTIONS(3543),
    [anon_sym_PIPE_PIPE] = ACTIONS(3543),
    [anon_sym_BANG_EQ] = ACTIONS(3543),
    [anon_sym_COLON_EQ] = ACTIONS(3541),
    [anon_sym_DOLLAR] = ACTIONS(3543),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3543),
    [sym_int] = ACTIONS(3543),
    [sym_xint] = ACTIONS(3541),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3541),
    [sym__newline] = ACTIONS(3541),
  },
  [2236] = {
    [sym_block_comment] = STATE(2236),
    [sym_compiler_directive_decl] = STATE(2236),
    [sym_fsi_directive_decl] = STATE(2236),
    [sym_preproc_line] = STATE(2236),
    [sym_identifier] = ACTIONS(3547),
    [anon_sym_EQ] = ACTIONS(3545),
    [anon_sym_GT_RBRACK] = ACTIONS(3545),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_return] = ACTIONS(3547),
    [anon_sym_do] = ACTIONS(3547),
    [anon_sym_let] = ACTIONS(3547),
    [anon_sym_let_BANG] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(3547),
    [anon_sym_COMMA] = ACTIONS(3545),
    [anon_sym_null] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3547),
    [anon_sym_COLON_QMARK] = ACTIONS(3547),
    [anon_sym_COLON_COLON] = ACTIONS(3545),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_RBRACK] = ACTIONS(3545),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3545),
    [anon_sym_LBRACE] = ACTIONS(3547),
    [anon_sym_RBRACE] = ACTIONS(3545),
    [anon_sym_LT_AT] = ACTIONS(3547),
    [anon_sym_LT_AT_AT] = ACTIONS(3547),
    [anon_sym_DOT] = ACTIONS(3547),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3545),
    [anon_sym_new] = ACTIONS(3547),
    [anon_sym_with] = ACTIONS(3547),
    [anon_sym_return_BANG] = ACTIONS(3545),
    [anon_sym_yield] = ACTIONS(3547),
    [anon_sym_yield_BANG] = ACTIONS(3545),
    [anon_sym_lazy] = ACTIONS(3547),
    [anon_sym_assert] = ACTIONS(3547),
    [anon_sym_upcast] = ACTIONS(3547),
    [anon_sym_downcast] = ACTIONS(3547),
    [anon_sym_COLON_GT] = ACTIONS(3545),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3545),
    [anon_sym_for] = ACTIONS(3547),
    [anon_sym_to] = ACTIONS(3547),
    [anon_sym_downto] = ACTIONS(3547),
    [anon_sym_while] = ACTIONS(3547),
    [anon_sym_if] = ACTIONS(3547),
    [anon_sym_fun] = ACTIONS(3547),
    [anon_sym_DASH_GT] = ACTIONS(3547),
    [anon_sym_try] = ACTIONS(3547),
    [anon_sym_match] = ACTIONS(3547),
    [anon_sym_match_BANG] = ACTIONS(3545),
    [anon_sym_function] = ACTIONS(3547),
    [anon_sym_LT_DASH] = ACTIONS(3547),
    [anon_sym_DOT_LBRACK] = ACTIONS(3545),
    [anon_sym_LT] = ACTIONS(3545),
    [anon_sym_use] = ACTIONS(3547),
    [anon_sym_use_BANG] = ACTIONS(3545),
    [anon_sym_do_BANG] = ACTIONS(3545),
    [anon_sym_begin] = ACTIONS(3547),
    [anon_sym_LPAREN2] = ACTIONS(3547),
    [anon_sym_DOT_DOT2] = ACTIONS(3545),
    [anon_sym_STAR] = ACTIONS(3547),
    [anon_sym_LT2] = ACTIONS(3547),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_or] = ACTIONS(3547),
    [aux_sym_char_token1] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3547),
    [anon_sym_DQUOTE] = ACTIONS(3547),
    [anon_sym_AT_DQUOTE] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [sym_bool] = ACTIONS(3547),
    [sym_unit] = ACTIONS(3545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3547),
    [sym_op_identifier] = ACTIONS(3547),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PLUS_DOT] = ACTIONS(3547),
    [anon_sym_DASH_DOT] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3547),
    [anon_sym_AMP_AMP] = ACTIONS(3547),
    [anon_sym_TILDE] = ACTIONS(3545),
    [aux_sym_prefix_op_token1] = ACTIONS(3547),
    [aux_sym_infix_op_token1] = ACTIONS(3545),
    [aux_sym_infix_op_token2] = ACTIONS(3547),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_BANG_EQ] = ACTIONS(3547),
    [anon_sym_COLON_EQ] = ACTIONS(3545),
    [anon_sym_DOLLAR] = ACTIONS(3547),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3547),
    [sym_int] = ACTIONS(3547),
    [sym_xint] = ACTIONS(3545),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3545),
    [sym__newline] = ACTIONS(3545),
  },
  [2237] = {
    [sym_block_comment] = STATE(2237),
    [sym_compiler_directive_decl] = STATE(2237),
    [sym_fsi_directive_decl] = STATE(2237),
    [sym_preproc_line] = STATE(2237),
    [ts_builtin_sym_end] = ACTIONS(3525),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_namespace] = ACTIONS(3527),
    [anon_sym_module] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3525),
    [anon_sym_open] = ACTIONS(3527),
    [anon_sym_LBRACK_LT] = ACTIONS(3525),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_type] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_COLON] = ACTIONS(3525),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_COLON_GT] = ACTIONS(3525),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_DASH_GT] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_LT_DASH] = ACTIONS(3527),
    [anon_sym_DOT_LBRACK] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_LPAREN2] = ACTIONS(3527),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_LT2] = ACTIONS(3527),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_or] = ACTIONS(3527),
    [anon_sym_exception] = ACTIONS(3527),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3525),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3527),
    [anon_sym_DASH_DOT] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3527),
    [aux_sym_infix_op_token1] = ACTIONS(3525),
    [aux_sym_infix_op_token2] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_COLON_EQ] = ACTIONS(3525),
    [anon_sym_DOLLAR] = ACTIONS(3527),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3527),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3525),
    [anon_sym_POUNDload] = ACTIONS(3525),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3525),
    [sym__newline] = ACTIONS(3525),
  },
  [2238] = {
    [sym_block_comment] = STATE(2238),
    [sym_compiler_directive_decl] = STATE(2238),
    [sym_fsi_directive_decl] = STATE(2238),
    [sym_preproc_line] = STATE(2238),
    [sym_identifier] = ACTIONS(3519),
    [anon_sym_EQ] = ACTIONS(3517),
    [anon_sym_GT_RBRACK] = ACTIONS(3517),
    [anon_sym_COLON] = ACTIONS(3519),
    [anon_sym_return] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(3519),
    [anon_sym_let] = ACTIONS(3519),
    [anon_sym_let_BANG] = ACTIONS(3517),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [anon_sym_COMMA] = ACTIONS(3517),
    [anon_sym_null] = ACTIONS(3519),
    [anon_sym_QMARK] = ACTIONS(3519),
    [anon_sym_COLON_QMARK] = ACTIONS(3519),
    [anon_sym_COLON_COLON] = ACTIONS(3517),
    [anon_sym_AMP] = ACTIONS(3519),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_RBRACK] = ACTIONS(3517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_RBRACE] = ACTIONS(3517),
    [anon_sym_LT_AT] = ACTIONS(3519),
    [anon_sym_LT_AT_AT] = ACTIONS(3519),
    [anon_sym_DOT] = ACTIONS(3519),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3519),
    [anon_sym_with] = ACTIONS(3519),
    [anon_sym_return_BANG] = ACTIONS(3517),
    [anon_sym_yield] = ACTIONS(3519),
    [anon_sym_yield_BANG] = ACTIONS(3517),
    [anon_sym_lazy] = ACTIONS(3519),
    [anon_sym_assert] = ACTIONS(3519),
    [anon_sym_upcast] = ACTIONS(3519),
    [anon_sym_downcast] = ACTIONS(3519),
    [anon_sym_COLON_GT] = ACTIONS(3517),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3517),
    [anon_sym_for] = ACTIONS(3519),
    [anon_sym_to] = ACTIONS(3519),
    [anon_sym_downto] = ACTIONS(3519),
    [anon_sym_while] = ACTIONS(3519),
    [anon_sym_if] = ACTIONS(3519),
    [anon_sym_fun] = ACTIONS(3519),
    [anon_sym_DASH_GT] = ACTIONS(3519),
    [anon_sym_try] = ACTIONS(3519),
    [anon_sym_match] = ACTIONS(3519),
    [anon_sym_match_BANG] = ACTIONS(3517),
    [anon_sym_function] = ACTIONS(3519),
    [anon_sym_LT_DASH] = ACTIONS(3519),
    [anon_sym_DOT_LBRACK] = ACTIONS(3517),
    [anon_sym_LT] = ACTIONS(3517),
    [anon_sym_use] = ACTIONS(3519),
    [anon_sym_use_BANG] = ACTIONS(3517),
    [anon_sym_do_BANG] = ACTIONS(3517),
    [anon_sym_begin] = ACTIONS(3519),
    [anon_sym_LPAREN2] = ACTIONS(3519),
    [anon_sym_DOT_DOT2] = ACTIONS(3517),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_LT2] = ACTIONS(3519),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3517),
    [anon_sym_or] = ACTIONS(3519),
    [aux_sym_char_token1] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [anon_sym_AT_DQUOTE] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [sym_bool] = ACTIONS(3519),
    [sym_unit] = ACTIONS(3517),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3519),
    [sym_op_identifier] = ACTIONS(3519),
    [anon_sym_PLUS] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_DOT] = ACTIONS(3519),
    [anon_sym_DASH_DOT] = ACTIONS(3519),
    [anon_sym_PERCENT] = ACTIONS(3519),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3517),
    [aux_sym_prefix_op_token1] = ACTIONS(3519),
    [aux_sym_infix_op_token1] = ACTIONS(3517),
    [aux_sym_infix_op_token2] = ACTIONS(3519),
    [anon_sym_PIPE_PIPE] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_COLON_EQ] = ACTIONS(3517),
    [anon_sym_DOLLAR] = ACTIONS(3519),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3519),
    [sym_int] = ACTIONS(3519),
    [sym_xint] = ACTIONS(3517),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3517),
    [sym__newline] = ACTIONS(3517),
  },
  [2239] = {
    [sym_block_comment] = STATE(2239),
    [sym_compiler_directive_decl] = STATE(2239),
    [sym_fsi_directive_decl] = STATE(2239),
    [sym_preproc_line] = STATE(2239),
    [ts_builtin_sym_end] = ACTIONS(3549),
    [sym_identifier] = ACTIONS(3551),
    [anon_sym_namespace] = ACTIONS(3551),
    [anon_sym_module] = ACTIONS(3551),
    [anon_sym_EQ] = ACTIONS(3549),
    [anon_sym_open] = ACTIONS(3551),
    [anon_sym_LBRACK_LT] = ACTIONS(3549),
    [anon_sym_COLON] = ACTIONS(3551),
    [anon_sym_return] = ACTIONS(3551),
    [anon_sym_type] = ACTIONS(3551),
    [anon_sym_do] = ACTIONS(3551),
    [anon_sym_let] = ACTIONS(3551),
    [anon_sym_let_BANG] = ACTIONS(3549),
    [anon_sym_LPAREN] = ACTIONS(3551),
    [anon_sym_COMMA] = ACTIONS(3549),
    [anon_sym_null] = ACTIONS(3551),
    [anon_sym_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_COLON] = ACTIONS(3549),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(3551),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3549),
    [anon_sym_LBRACE] = ACTIONS(3551),
    [anon_sym_LT_AT] = ACTIONS(3551),
    [anon_sym_LT_AT_AT] = ACTIONS(3551),
    [anon_sym_DOT] = ACTIONS(3551),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3549),
    [anon_sym_new] = ACTIONS(3551),
    [anon_sym_return_BANG] = ACTIONS(3549),
    [anon_sym_yield] = ACTIONS(3551),
    [anon_sym_yield_BANG] = ACTIONS(3549),
    [anon_sym_lazy] = ACTIONS(3551),
    [anon_sym_assert] = ACTIONS(3551),
    [anon_sym_upcast] = ACTIONS(3551),
    [anon_sym_downcast] = ACTIONS(3551),
    [anon_sym_COLON_GT] = ACTIONS(3549),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3549),
    [anon_sym_for] = ACTIONS(3551),
    [anon_sym_while] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(3551),
    [anon_sym_fun] = ACTIONS(3551),
    [anon_sym_DASH_GT] = ACTIONS(3551),
    [anon_sym_try] = ACTIONS(3551),
    [anon_sym_match] = ACTIONS(3551),
    [anon_sym_match_BANG] = ACTIONS(3549),
    [anon_sym_function] = ACTIONS(3551),
    [anon_sym_LT_DASH] = ACTIONS(3551),
    [anon_sym_DOT_LBRACK] = ACTIONS(3549),
    [anon_sym_LT] = ACTIONS(3549),
    [anon_sym_use] = ACTIONS(3551),
    [anon_sym_use_BANG] = ACTIONS(3549),
    [anon_sym_do_BANG] = ACTIONS(3549),
    [anon_sym_begin] = ACTIONS(3551),
    [anon_sym_LPAREN2] = ACTIONS(3551),
    [anon_sym_STAR] = ACTIONS(3551),
    [anon_sym_LT2] = ACTIONS(3551),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3549),
    [anon_sym_or] = ACTIONS(3551),
    [anon_sym_exception] = ACTIONS(3551),
    [aux_sym_char_token1] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [anon_sym_AT_DQUOTE] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [sym_bool] = ACTIONS(3551),
    [sym_unit] = ACTIONS(3549),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3551),
    [sym_op_identifier] = ACTIONS(3551),
    [anon_sym_PLUS] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(3551),
    [anon_sym_PLUS_DOT] = ACTIONS(3551),
    [anon_sym_DASH_DOT] = ACTIONS(3551),
    [anon_sym_PERCENT] = ACTIONS(3551),
    [anon_sym_AMP_AMP] = ACTIONS(3551),
    [anon_sym_TILDE] = ACTIONS(3549),
    [aux_sym_prefix_op_token1] = ACTIONS(3551),
    [aux_sym_infix_op_token1] = ACTIONS(3549),
    [aux_sym_infix_op_token2] = ACTIONS(3551),
    [anon_sym_PIPE_PIPE] = ACTIONS(3551),
    [anon_sym_BANG_EQ] = ACTIONS(3551),
    [anon_sym_COLON_EQ] = ACTIONS(3549),
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3551),
    [sym_int] = ACTIONS(3551),
    [sym_xint] = ACTIONS(3549),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3549),
    [anon_sym_POUNDload] = ACTIONS(3549),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3549),
    [sym__newline] = ACTIONS(3549),
  },
  [2240] = {
    [sym_block_comment] = STATE(2240),
    [sym_compiler_directive_decl] = STATE(2240),
    [sym_fsi_directive_decl] = STATE(2240),
    [sym_preproc_line] = STATE(2240),
    [ts_builtin_sym_end] = ACTIONS(3478),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_namespace] = ACTIONS(3480),
    [anon_sym_module] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_open] = ACTIONS(3480),
    [anon_sym_LBRACK_LT] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_type] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_COLON] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_LT_DASH] = ACTIONS(3480),
    [anon_sym_DOT_LBRACK] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_or] = ACTIONS(3480),
    [anon_sym_exception] = ACTIONS(3480),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3480),
    [anon_sym_DASH_DOT] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3480),
    [aux_sym_infix_op_token1] = ACTIONS(3478),
    [aux_sym_infix_op_token2] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3480),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3478),
    [anon_sym_POUNDload] = ACTIONS(3478),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
  },
  [2241] = {
    [sym_block_comment] = STATE(2241),
    [sym_compiler_directive_decl] = STATE(2241),
    [sym_fsi_directive_decl] = STATE(2241),
    [sym_preproc_line] = STATE(2241),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_GT_RBRACK] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_RBRACK] = ACTIONS(3485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_RBRACE] = ACTIONS(3485),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_to] = ACTIONS(3487),
    [anon_sym_downto] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_DOT_DOT2] = ACTIONS(3485),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [2242] = {
    [sym_block_comment] = STATE(2242),
    [sym_compiler_directive_decl] = STATE(2242),
    [sym_fsi_directive_decl] = STATE(2242),
    [sym_preproc_line] = STATE(2242),
    [sym_identifier] = ACTIONS(3535),
    [anon_sym_EQ] = ACTIONS(3533),
    [anon_sym_GT_RBRACK] = ACTIONS(3533),
    [anon_sym_COLON] = ACTIONS(3535),
    [anon_sym_return] = ACTIONS(3535),
    [anon_sym_do] = ACTIONS(3535),
    [anon_sym_let] = ACTIONS(3535),
    [anon_sym_let_BANG] = ACTIONS(3533),
    [anon_sym_LPAREN] = ACTIONS(3535),
    [anon_sym_COMMA] = ACTIONS(3533),
    [anon_sym_null] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(3535),
    [anon_sym_COLON_QMARK] = ACTIONS(3535),
    [anon_sym_COLON_COLON] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_RBRACK] = ACTIONS(3533),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3533),
    [anon_sym_LBRACE] = ACTIONS(3535),
    [anon_sym_RBRACE] = ACTIONS(3533),
    [anon_sym_LT_AT] = ACTIONS(3535),
    [anon_sym_LT_AT_AT] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(3535),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3533),
    [anon_sym_new] = ACTIONS(3535),
    [anon_sym_with] = ACTIONS(3535),
    [anon_sym_return_BANG] = ACTIONS(3533),
    [anon_sym_yield] = ACTIONS(3535),
    [anon_sym_yield_BANG] = ACTIONS(3533),
    [anon_sym_lazy] = ACTIONS(3535),
    [anon_sym_assert] = ACTIONS(3535),
    [anon_sym_upcast] = ACTIONS(3535),
    [anon_sym_downcast] = ACTIONS(3535),
    [anon_sym_COLON_GT] = ACTIONS(3533),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3533),
    [anon_sym_for] = ACTIONS(3535),
    [anon_sym_to] = ACTIONS(3535),
    [anon_sym_downto] = ACTIONS(3535),
    [anon_sym_while] = ACTIONS(3535),
    [anon_sym_if] = ACTIONS(3535),
    [anon_sym_fun] = ACTIONS(3535),
    [anon_sym_DASH_GT] = ACTIONS(3535),
    [anon_sym_try] = ACTIONS(3535),
    [anon_sym_match] = ACTIONS(3535),
    [anon_sym_match_BANG] = ACTIONS(3533),
    [anon_sym_function] = ACTIONS(3535),
    [anon_sym_LT_DASH] = ACTIONS(3535),
    [anon_sym_DOT_LBRACK] = ACTIONS(3533),
    [anon_sym_LT] = ACTIONS(3533),
    [anon_sym_use] = ACTIONS(3535),
    [anon_sym_use_BANG] = ACTIONS(3533),
    [anon_sym_do_BANG] = ACTIONS(3533),
    [anon_sym_begin] = ACTIONS(3535),
    [anon_sym_LPAREN2] = ACTIONS(3535),
    [anon_sym_DOT_DOT2] = ACTIONS(3533),
    [anon_sym_STAR] = ACTIONS(3535),
    [anon_sym_LT2] = ACTIONS(3535),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3533),
    [anon_sym_or] = ACTIONS(3535),
    [aux_sym_char_token1] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE] = ACTIONS(3535),
    [anon_sym_AT_DQUOTE] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [sym_bool] = ACTIONS(3535),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3535),
    [sym_op_identifier] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS_DOT] = ACTIONS(3535),
    [anon_sym_DASH_DOT] = ACTIONS(3535),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(3535),
    [anon_sym_TILDE] = ACTIONS(3533),
    [aux_sym_prefix_op_token1] = ACTIONS(3535),
    [aux_sym_infix_op_token1] = ACTIONS(3533),
    [aux_sym_infix_op_token2] = ACTIONS(3535),
    [anon_sym_PIPE_PIPE] = ACTIONS(3535),
    [anon_sym_BANG_EQ] = ACTIONS(3535),
    [anon_sym_COLON_EQ] = ACTIONS(3533),
    [anon_sym_DOLLAR] = ACTIONS(3535),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3535),
    [sym_int] = ACTIONS(3535),
    [sym_xint] = ACTIONS(3533),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3533),
    [sym__newline] = ACTIONS(3533),
  },
  [2243] = {
    [sym_block_comment] = STATE(2243),
    [sym_compiler_directive_decl] = STATE(2243),
    [sym_fsi_directive_decl] = STATE(2243),
    [sym_preproc_line] = STATE(2243),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_GT_RBRACK] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_COLON] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_RBRACK] = ACTIONS(3478),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_RBRACE] = ACTIONS(3478),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_with] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_to] = ACTIONS(3480),
    [anon_sym_downto] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_LT_DASH] = ACTIONS(3480),
    [anon_sym_DOT_LBRACK] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_DOT_DOT2] = ACTIONS(3478),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_or] = ACTIONS(3480),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3480),
    [anon_sym_DASH_DOT] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3480),
    [aux_sym_infix_op_token1] = ACTIONS(3478),
    [aux_sym_infix_op_token2] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3480),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
  },
  [2244] = {
    [sym_block_comment] = STATE(2244),
    [sym_compiler_directive_decl] = STATE(2244),
    [sym_fsi_directive_decl] = STATE(2244),
    [sym_preproc_line] = STATE(2244),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_EQ] = ACTIONS(3560),
    [anon_sym_GT_RBRACK] = ACTIONS(3560),
    [anon_sym_COLON] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_let_BANG] = ACTIONS(3560),
    [anon_sym_LPAREN] = ACTIONS(3562),
    [anon_sym_COMMA] = ACTIONS(3560),
    [anon_sym_null] = ACTIONS(3562),
    [anon_sym_QMARK] = ACTIONS(3562),
    [anon_sym_COLON_QMARK] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_RBRACK] = ACTIONS(3560),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3560),
    [anon_sym_LBRACE] = ACTIONS(3562),
    [anon_sym_RBRACE] = ACTIONS(3560),
    [anon_sym_LT_AT] = ACTIONS(3562),
    [anon_sym_LT_AT_AT] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(3562),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3560),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_with] = ACTIONS(3562),
    [anon_sym_return_BANG] = ACTIONS(3560),
    [anon_sym_yield] = ACTIONS(3562),
    [anon_sym_yield_BANG] = ACTIONS(3560),
    [anon_sym_lazy] = ACTIONS(3562),
    [anon_sym_assert] = ACTIONS(3562),
    [anon_sym_upcast] = ACTIONS(3562),
    [anon_sym_downcast] = ACTIONS(3562),
    [anon_sym_COLON_GT] = ACTIONS(3560),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3560),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_to] = ACTIONS(3562),
    [anon_sym_downto] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_fun] = ACTIONS(3562),
    [anon_sym_DASH_GT] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_match] = ACTIONS(3562),
    [anon_sym_match_BANG] = ACTIONS(3560),
    [anon_sym_function] = ACTIONS(3562),
    [anon_sym_LT_DASH] = ACTIONS(3562),
    [anon_sym_DOT_LBRACK] = ACTIONS(3560),
    [anon_sym_LT] = ACTIONS(3560),
    [anon_sym_use] = ACTIONS(3562),
    [anon_sym_use_BANG] = ACTIONS(3560),
    [anon_sym_do_BANG] = ACTIONS(3560),
    [anon_sym_begin] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3562),
    [anon_sym_DOT_DOT2] = ACTIONS(3560),
    [anon_sym_STAR] = ACTIONS(3562),
    [anon_sym_LT2] = ACTIONS(3562),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3560),
    [anon_sym_or] = ACTIONS(3562),
    [aux_sym_char_token1] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(3562),
    [anon_sym_AT_DQUOTE] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [sym_bool] = ACTIONS(3562),
    [sym_unit] = ACTIONS(3560),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3562),
    [sym_op_identifier] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS_DOT] = ACTIONS(3562),
    [anon_sym_DASH_DOT] = ACTIONS(3562),
    [anon_sym_PERCENT] = ACTIONS(3562),
    [anon_sym_AMP_AMP] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3560),
    [aux_sym_prefix_op_token1] = ACTIONS(3562),
    [aux_sym_infix_op_token1] = ACTIONS(3560),
    [aux_sym_infix_op_token2] = ACTIONS(3562),
    [anon_sym_PIPE_PIPE] = ACTIONS(3562),
    [anon_sym_BANG_EQ] = ACTIONS(3562),
    [anon_sym_COLON_EQ] = ACTIONS(3560),
    [anon_sym_DOLLAR] = ACTIONS(3562),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3562),
    [sym_int] = ACTIONS(3562),
    [sym_xint] = ACTIONS(3560),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3560),
    [sym__newline] = ACTIONS(3560),
  },
  [2245] = {
    [sym_block_comment] = STATE(2245),
    [sym_compiler_directive_decl] = STATE(2245),
    [sym_fsi_directive_decl] = STATE(2245),
    [sym_preproc_line] = STATE(2245),
    [ts_builtin_sym_end] = ACTIONS(3485),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_namespace] = ACTIONS(3487),
    [anon_sym_module] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_open] = ACTIONS(3487),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_type] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_exception] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3485),
    [anon_sym_POUNDload] = ACTIONS(3485),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [2246] = {
    [sym_block_comment] = STATE(2246),
    [sym_compiler_directive_decl] = STATE(2246),
    [sym_fsi_directive_decl] = STATE(2246),
    [sym_preproc_line] = STATE(2246),
    [ts_builtin_sym_end] = ACTIONS(3503),
    [sym_identifier] = ACTIONS(3505),
    [anon_sym_namespace] = ACTIONS(3505),
    [anon_sym_module] = ACTIONS(3505),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_open] = ACTIONS(3505),
    [anon_sym_LBRACK_LT] = ACTIONS(3503),
    [anon_sym_COLON] = ACTIONS(3505),
    [anon_sym_return] = ACTIONS(3505),
    [anon_sym_type] = ACTIONS(3505),
    [anon_sym_do] = ACTIONS(3505),
    [anon_sym_let] = ACTIONS(3505),
    [anon_sym_let_BANG] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3505),
    [anon_sym_COMMA] = ACTIONS(3503),
    [anon_sym_null] = ACTIONS(3505),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_COLON_QMARK] = ACTIONS(3505),
    [anon_sym_COLON_COLON] = ACTIONS(3503),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3503),
    [anon_sym_LBRACE] = ACTIONS(3505),
    [anon_sym_LT_AT] = ACTIONS(3505),
    [anon_sym_LT_AT_AT] = ACTIONS(3505),
    [anon_sym_DOT] = ACTIONS(3505),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3503),
    [anon_sym_new] = ACTIONS(3505),
    [anon_sym_return_BANG] = ACTIONS(3503),
    [anon_sym_yield] = ACTIONS(3505),
    [anon_sym_yield_BANG] = ACTIONS(3503),
    [anon_sym_lazy] = ACTIONS(3505),
    [anon_sym_assert] = ACTIONS(3505),
    [anon_sym_upcast] = ACTIONS(3505),
    [anon_sym_downcast] = ACTIONS(3505),
    [anon_sym_COLON_GT] = ACTIONS(3503),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3503),
    [anon_sym_for] = ACTIONS(3505),
    [anon_sym_while] = ACTIONS(3505),
    [anon_sym_if] = ACTIONS(3505),
    [anon_sym_fun] = ACTIONS(3505),
    [anon_sym_DASH_GT] = ACTIONS(3505),
    [anon_sym_try] = ACTIONS(3505),
    [anon_sym_match] = ACTIONS(3505),
    [anon_sym_match_BANG] = ACTIONS(3503),
    [anon_sym_function] = ACTIONS(3505),
    [anon_sym_LT_DASH] = ACTIONS(3505),
    [anon_sym_DOT_LBRACK] = ACTIONS(3503),
    [anon_sym_LT] = ACTIONS(3503),
    [anon_sym_use] = ACTIONS(3505),
    [anon_sym_use_BANG] = ACTIONS(3503),
    [anon_sym_do_BANG] = ACTIONS(3503),
    [anon_sym_begin] = ACTIONS(3505),
    [anon_sym_LPAREN2] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3505),
    [anon_sym_LT2] = ACTIONS(4789),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_or] = ACTIONS(3505),
    [anon_sym_exception] = ACTIONS(3505),
    [aux_sym_char_token1] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3505),
    [anon_sym_DQUOTE] = ACTIONS(3505),
    [anon_sym_AT_DQUOTE] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [sym_bool] = ACTIONS(3505),
    [sym_unit] = ACTIONS(3503),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3505),
    [sym_op_identifier] = ACTIONS(3505),
    [anon_sym_PLUS] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3505),
    [anon_sym_PLUS_DOT] = ACTIONS(3505),
    [anon_sym_DASH_DOT] = ACTIONS(3505),
    [anon_sym_PERCENT] = ACTIONS(3505),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3503),
    [aux_sym_prefix_op_token1] = ACTIONS(3505),
    [aux_sym_infix_op_token1] = ACTIONS(3503),
    [aux_sym_infix_op_token2] = ACTIONS(3505),
    [anon_sym_PIPE_PIPE] = ACTIONS(3505),
    [anon_sym_BANG_EQ] = ACTIONS(3505),
    [anon_sym_COLON_EQ] = ACTIONS(3503),
    [anon_sym_DOLLAR] = ACTIONS(3505),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3505),
    [sym_int] = ACTIONS(3505),
    [sym_xint] = ACTIONS(3503),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3503),
    [anon_sym_POUNDload] = ACTIONS(3503),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3503),
    [sym__newline] = ACTIONS(3503),
  },
  [2247] = {
    [sym_block_comment] = STATE(2247),
    [sym_compiler_directive_decl] = STATE(2247),
    [sym_fsi_directive_decl] = STATE(2247),
    [sym_preproc_line] = STATE(2247),
    [ts_builtin_sym_end] = ACTIONS(3537),
    [sym_identifier] = ACTIONS(3539),
    [anon_sym_namespace] = ACTIONS(3539),
    [anon_sym_module] = ACTIONS(3539),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_open] = ACTIONS(3539),
    [anon_sym_LBRACK_LT] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3539),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_type] = ACTIONS(3539),
    [anon_sym_do] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3539),
    [anon_sym_let_BANG] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_null] = ACTIONS(3539),
    [anon_sym_QMARK] = ACTIONS(3539),
    [anon_sym_COLON_QMARK] = ACTIONS(3539),
    [anon_sym_COLON_COLON] = ACTIONS(3537),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3537),
    [anon_sym_LBRACE] = ACTIONS(3539),
    [anon_sym_LT_AT] = ACTIONS(3539),
    [anon_sym_LT_AT_AT] = ACTIONS(3539),
    [anon_sym_DOT] = ACTIONS(3539),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3537),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_return_BANG] = ACTIONS(3537),
    [anon_sym_yield] = ACTIONS(3539),
    [anon_sym_yield_BANG] = ACTIONS(3537),
    [anon_sym_lazy] = ACTIONS(3539),
    [anon_sym_assert] = ACTIONS(3539),
    [anon_sym_upcast] = ACTIONS(3539),
    [anon_sym_downcast] = ACTIONS(3539),
    [anon_sym_COLON_GT] = ACTIONS(3537),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3537),
    [anon_sym_for] = ACTIONS(3539),
    [anon_sym_while] = ACTIONS(3539),
    [anon_sym_if] = ACTIONS(3539),
    [anon_sym_fun] = ACTIONS(3539),
    [anon_sym_DASH_GT] = ACTIONS(3539),
    [anon_sym_try] = ACTIONS(3539),
    [anon_sym_match] = ACTIONS(3539),
    [anon_sym_match_BANG] = ACTIONS(3537),
    [anon_sym_function] = ACTIONS(3539),
    [anon_sym_LT_DASH] = ACTIONS(3539),
    [anon_sym_DOT_LBRACK] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_use] = ACTIONS(3539),
    [anon_sym_use_BANG] = ACTIONS(3537),
    [anon_sym_do_BANG] = ACTIONS(3537),
    [anon_sym_begin] = ACTIONS(3539),
    [anon_sym_LPAREN2] = ACTIONS(3539),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_LT2] = ACTIONS(3539),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_or] = ACTIONS(3539),
    [anon_sym_exception] = ACTIONS(3539),
    [aux_sym_char_token1] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3539),
    [anon_sym_DQUOTE] = ACTIONS(3539),
    [anon_sym_AT_DQUOTE] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [sym_bool] = ACTIONS(3539),
    [sym_unit] = ACTIONS(3537),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3539),
    [sym_op_identifier] = ACTIONS(3539),
    [anon_sym_PLUS] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(3539),
    [anon_sym_PLUS_DOT] = ACTIONS(3539),
    [anon_sym_DASH_DOT] = ACTIONS(3539),
    [anon_sym_PERCENT] = ACTIONS(3539),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_TILDE] = ACTIONS(3537),
    [aux_sym_prefix_op_token1] = ACTIONS(3539),
    [aux_sym_infix_op_token1] = ACTIONS(3537),
    [aux_sym_infix_op_token2] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3539),
    [anon_sym_BANG_EQ] = ACTIONS(3539),
    [anon_sym_COLON_EQ] = ACTIONS(3537),
    [anon_sym_DOLLAR] = ACTIONS(3539),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3539),
    [sym_int] = ACTIONS(3539),
    [sym_xint] = ACTIONS(3537),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3537),
    [anon_sym_POUNDload] = ACTIONS(3537),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3537),
    [sym__newline] = ACTIONS(3537),
  },
  [2248] = {
    [sym_block_comment] = STATE(2248),
    [sym_compiler_directive_decl] = STATE(2248),
    [sym_fsi_directive_decl] = STATE(2248),
    [sym_preproc_line] = STATE(2248),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(3521),
    [anon_sym_GT_RBRACK] = ACTIONS(3521),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_COMMA] = ACTIONS(3521),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_COLON] = ACTIONS(3521),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_RBRACK] = ACTIONS(3521),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_RBRACE] = ACTIONS(3521),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_with] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3521),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3521),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_COLON_GT] = ACTIONS(3521),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_to] = ACTIONS(3523),
    [anon_sym_downto] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_DASH_GT] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3521),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_LT_DASH] = ACTIONS(3523),
    [anon_sym_DOT_LBRACK] = ACTIONS(3521),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3521),
    [anon_sym_do_BANG] = ACTIONS(3521),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_LPAREN2] = ACTIONS(3523),
    [anon_sym_DOT_DOT2] = ACTIONS(3521),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_LT2] = ACTIONS(3523),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3521),
    [anon_sym_or] = ACTIONS(3523),
    [aux_sym_char_token1] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3521),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3523),
    [anon_sym_DASH_DOT] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3521),
    [aux_sym_prefix_op_token1] = ACTIONS(3523),
    [aux_sym_infix_op_token1] = ACTIONS(3521),
    [aux_sym_infix_op_token2] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3523),
    [anon_sym_COLON_EQ] = ACTIONS(3521),
    [anon_sym_DOLLAR] = ACTIONS(3523),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3523),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3521),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3521),
    [sym__newline] = ACTIONS(3521),
  },
  [2249] = {
    [sym_block_comment] = STATE(2249),
    [sym_compiler_directive_decl] = STATE(2249),
    [sym_fsi_directive_decl] = STATE(2249),
    [sym_preproc_line] = STATE(2249),
    [sym_identifier] = ACTIONS(3551),
    [anon_sym_EQ] = ACTIONS(3549),
    [anon_sym_GT_RBRACK] = ACTIONS(3549),
    [anon_sym_COLON] = ACTIONS(3551),
    [anon_sym_return] = ACTIONS(3551),
    [anon_sym_do] = ACTIONS(3551),
    [anon_sym_let] = ACTIONS(3551),
    [anon_sym_let_BANG] = ACTIONS(3549),
    [anon_sym_LPAREN] = ACTIONS(3551),
    [anon_sym_COMMA] = ACTIONS(3549),
    [anon_sym_null] = ACTIONS(3551),
    [anon_sym_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_COLON] = ACTIONS(3549),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(3551),
    [anon_sym_RBRACK] = ACTIONS(3549),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3549),
    [anon_sym_LBRACE] = ACTIONS(3551),
    [anon_sym_RBRACE] = ACTIONS(3549),
    [anon_sym_LT_AT] = ACTIONS(3551),
    [anon_sym_LT_AT_AT] = ACTIONS(3551),
    [anon_sym_DOT] = ACTIONS(3551),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3549),
    [anon_sym_new] = ACTIONS(3551),
    [anon_sym_with] = ACTIONS(3551),
    [anon_sym_return_BANG] = ACTIONS(3549),
    [anon_sym_yield] = ACTIONS(3551),
    [anon_sym_yield_BANG] = ACTIONS(3549),
    [anon_sym_lazy] = ACTIONS(3551),
    [anon_sym_assert] = ACTIONS(3551),
    [anon_sym_upcast] = ACTIONS(3551),
    [anon_sym_downcast] = ACTIONS(3551),
    [anon_sym_COLON_GT] = ACTIONS(3549),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3549),
    [anon_sym_for] = ACTIONS(3551),
    [anon_sym_to] = ACTIONS(3551),
    [anon_sym_downto] = ACTIONS(3551),
    [anon_sym_while] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(3551),
    [anon_sym_fun] = ACTIONS(3551),
    [anon_sym_DASH_GT] = ACTIONS(3551),
    [anon_sym_try] = ACTIONS(3551),
    [anon_sym_match] = ACTIONS(3551),
    [anon_sym_match_BANG] = ACTIONS(3549),
    [anon_sym_function] = ACTIONS(3551),
    [anon_sym_LT_DASH] = ACTIONS(3551),
    [anon_sym_DOT_LBRACK] = ACTIONS(3549),
    [anon_sym_LT] = ACTIONS(3549),
    [anon_sym_use] = ACTIONS(3551),
    [anon_sym_use_BANG] = ACTIONS(3549),
    [anon_sym_do_BANG] = ACTIONS(3549),
    [anon_sym_begin] = ACTIONS(3551),
    [anon_sym_LPAREN2] = ACTIONS(3551),
    [anon_sym_DOT_DOT2] = ACTIONS(3549),
    [anon_sym_STAR] = ACTIONS(3551),
    [anon_sym_LT2] = ACTIONS(3551),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3549),
    [anon_sym_or] = ACTIONS(3551),
    [aux_sym_char_token1] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [anon_sym_AT_DQUOTE] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [sym_bool] = ACTIONS(3551),
    [sym_unit] = ACTIONS(3549),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3551),
    [sym_op_identifier] = ACTIONS(3551),
    [anon_sym_PLUS] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(3551),
    [anon_sym_PLUS_DOT] = ACTIONS(3551),
    [anon_sym_DASH_DOT] = ACTIONS(3551),
    [anon_sym_PERCENT] = ACTIONS(3551),
    [anon_sym_AMP_AMP] = ACTIONS(3551),
    [anon_sym_TILDE] = ACTIONS(3549),
    [aux_sym_prefix_op_token1] = ACTIONS(3551),
    [aux_sym_infix_op_token1] = ACTIONS(3549),
    [aux_sym_infix_op_token2] = ACTIONS(3551),
    [anon_sym_PIPE_PIPE] = ACTIONS(3551),
    [anon_sym_BANG_EQ] = ACTIONS(3551),
    [anon_sym_COLON_EQ] = ACTIONS(3549),
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3551),
    [sym_int] = ACTIONS(3551),
    [sym_xint] = ACTIONS(3549),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3549),
    [sym__newline] = ACTIONS(3549),
  },
  [2250] = {
    [sym_block_comment] = STATE(2250),
    [sym_compiler_directive_decl] = STATE(2250),
    [sym_fsi_directive_decl] = STATE(2250),
    [sym_preproc_line] = STATE(2250),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_GT_RBRACK] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_RBRACK] = ACTIONS(3496),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_RBRACE] = ACTIONS(3496),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_with] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_to] = ACTIONS(3498),
    [anon_sym_downto] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [anon_sym_DOT_LBRACK] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_DOT_DOT2] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_or] = ACTIONS(3498),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3498),
    [anon_sym_DASH_DOT] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3498),
    [aux_sym_infix_op_token1] = ACTIONS(3496),
    [aux_sym_infix_op_token2] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_COLON_EQ] = ACTIONS(3496),
    [anon_sym_DOLLAR] = ACTIONS(3498),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3498),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
  },
  [2251] = {
    [sym_elif_expression] = STATE(2297),
    [sym_block_comment] = STATE(2251),
    [sym_compiler_directive_decl] = STATE(2251),
    [sym_fsi_directive_decl] = STATE(2251),
    [sym_preproc_line] = STATE(2251),
    [aux_sym_if_expression_repeat1] = STATE(2251),
    [sym_identifier] = ACTIONS(3555),
    [anon_sym_EQ] = ACTIONS(3553),
    [anon_sym_GT_RBRACK] = ACTIONS(3553),
    [anon_sym_COLON] = ACTIONS(3555),
    [anon_sym_return] = ACTIONS(3555),
    [anon_sym_do] = ACTIONS(3555),
    [anon_sym_let] = ACTIONS(3555),
    [anon_sym_let_BANG] = ACTIONS(3553),
    [anon_sym_LPAREN] = ACTIONS(3555),
    [anon_sym_COMMA] = ACTIONS(3553),
    [anon_sym_null] = ACTIONS(3555),
    [anon_sym_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_COLON] = ACTIONS(3553),
    [anon_sym_AMP] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(3555),
    [anon_sym_RBRACK] = ACTIONS(3553),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3553),
    [anon_sym_LBRACE] = ACTIONS(3555),
    [anon_sym_RBRACE] = ACTIONS(3553),
    [anon_sym_LT_AT] = ACTIONS(3555),
    [anon_sym_LT_AT_AT] = ACTIONS(3555),
    [anon_sym_DOT] = ACTIONS(3555),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3553),
    [anon_sym_new] = ACTIONS(3555),
    [anon_sym_with] = ACTIONS(3555),
    [anon_sym_return_BANG] = ACTIONS(3553),
    [anon_sym_yield] = ACTIONS(3555),
    [anon_sym_yield_BANG] = ACTIONS(3553),
    [anon_sym_lazy] = ACTIONS(3555),
    [anon_sym_assert] = ACTIONS(3555),
    [anon_sym_upcast] = ACTIONS(3555),
    [anon_sym_downcast] = ACTIONS(3555),
    [anon_sym_COLON_GT] = ACTIONS(3553),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3553),
    [anon_sym_for] = ACTIONS(3555),
    [anon_sym_to] = ACTIONS(3555),
    [anon_sym_downto] = ACTIONS(3555),
    [anon_sym_while] = ACTIONS(3555),
    [anon_sym_else] = ACTIONS(3555),
    [anon_sym_elif] = ACTIONS(4791),
    [anon_sym_if] = ACTIONS(3555),
    [anon_sym_fun] = ACTIONS(3555),
    [anon_sym_try] = ACTIONS(3555),
    [anon_sym_match] = ACTIONS(3555),
    [anon_sym_match_BANG] = ACTIONS(3553),
    [anon_sym_function] = ACTIONS(3555),
    [anon_sym_LT_DASH] = ACTIONS(3555),
    [anon_sym_DOT_LBRACK] = ACTIONS(3553),
    [anon_sym_LT] = ACTIONS(3553),
    [anon_sym_use] = ACTIONS(3555),
    [anon_sym_use_BANG] = ACTIONS(3553),
    [anon_sym_do_BANG] = ACTIONS(3553),
    [anon_sym_begin] = ACTIONS(3555),
    [anon_sym_LPAREN2] = ACTIONS(3555),
    [anon_sym_DOT_DOT2] = ACTIONS(3553),
    [anon_sym_or] = ACTIONS(3555),
    [aux_sym_char_token1] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3555),
    [anon_sym_DQUOTE] = ACTIONS(3555),
    [anon_sym_AT_DQUOTE] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [sym_bool] = ACTIONS(3555),
    [sym_unit] = ACTIONS(3553),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3555),
    [sym_op_identifier] = ACTIONS(3555),
    [anon_sym_PLUS] = ACTIONS(3555),
    [anon_sym_DASH] = ACTIONS(3555),
    [anon_sym_PLUS_DOT] = ACTIONS(3555),
    [anon_sym_DASH_DOT] = ACTIONS(3555),
    [anon_sym_PERCENT] = ACTIONS(3555),
    [anon_sym_AMP_AMP] = ACTIONS(3555),
    [anon_sym_TILDE] = ACTIONS(3553),
    [aux_sym_prefix_op_token1] = ACTIONS(3555),
    [aux_sym_infix_op_token1] = ACTIONS(3553),
    [aux_sym_infix_op_token2] = ACTIONS(3555),
    [anon_sym_PIPE_PIPE] = ACTIONS(3555),
    [anon_sym_BANG_EQ] = ACTIONS(3555),
    [anon_sym_COLON_EQ] = ACTIONS(3553),
    [anon_sym_DOLLAR] = ACTIONS(3555),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3555),
    [sym_int] = ACTIONS(3555),
    [sym_xint] = ACTIONS(3553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3553),
    [sym__newline] = ACTIONS(3553),
  },
  [2252] = {
    [sym_block_comment] = STATE(2252),
    [sym_compiler_directive_decl] = STATE(2252),
    [sym_fsi_directive_decl] = STATE(2252),
    [sym_preproc_line] = STATE(2252),
    [ts_builtin_sym_end] = ACTIONS(3541),
    [sym_identifier] = ACTIONS(3543),
    [anon_sym_namespace] = ACTIONS(3543),
    [anon_sym_module] = ACTIONS(3543),
    [anon_sym_EQ] = ACTIONS(3541),
    [anon_sym_open] = ACTIONS(3543),
    [anon_sym_LBRACK_LT] = ACTIONS(3541),
    [anon_sym_COLON] = ACTIONS(3543),
    [anon_sym_return] = ACTIONS(3543),
    [anon_sym_type] = ACTIONS(3543),
    [anon_sym_do] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3543),
    [anon_sym_let_BANG] = ACTIONS(3541),
    [anon_sym_LPAREN] = ACTIONS(3543),
    [anon_sym_COMMA] = ACTIONS(3541),
    [anon_sym_null] = ACTIONS(3543),
    [anon_sym_QMARK] = ACTIONS(3543),
    [anon_sym_COLON_QMARK] = ACTIONS(3543),
    [anon_sym_COLON_COLON] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3543),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3541),
    [anon_sym_LBRACE] = ACTIONS(3543),
    [anon_sym_LT_AT] = ACTIONS(3543),
    [anon_sym_LT_AT_AT] = ACTIONS(3543),
    [anon_sym_DOT] = ACTIONS(3543),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3541),
    [anon_sym_new] = ACTIONS(3543),
    [anon_sym_return_BANG] = ACTIONS(3541),
    [anon_sym_yield] = ACTIONS(3543),
    [anon_sym_yield_BANG] = ACTIONS(3541),
    [anon_sym_lazy] = ACTIONS(3543),
    [anon_sym_assert] = ACTIONS(3543),
    [anon_sym_upcast] = ACTIONS(3543),
    [anon_sym_downcast] = ACTIONS(3543),
    [anon_sym_COLON_GT] = ACTIONS(3541),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3541),
    [anon_sym_for] = ACTIONS(3543),
    [anon_sym_while] = ACTIONS(3543),
    [anon_sym_if] = ACTIONS(3543),
    [anon_sym_fun] = ACTIONS(3543),
    [anon_sym_DASH_GT] = ACTIONS(3543),
    [anon_sym_try] = ACTIONS(3543),
    [anon_sym_match] = ACTIONS(3543),
    [anon_sym_match_BANG] = ACTIONS(3541),
    [anon_sym_function] = ACTIONS(3543),
    [anon_sym_LT_DASH] = ACTIONS(3543),
    [anon_sym_DOT_LBRACK] = ACTIONS(3541),
    [anon_sym_LT] = ACTIONS(3541),
    [anon_sym_use] = ACTIONS(3543),
    [anon_sym_use_BANG] = ACTIONS(3541),
    [anon_sym_do_BANG] = ACTIONS(3541),
    [anon_sym_begin] = ACTIONS(3543),
    [anon_sym_LPAREN2] = ACTIONS(3543),
    [anon_sym_STAR] = ACTIONS(3543),
    [anon_sym_LT2] = ACTIONS(3543),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_or] = ACTIONS(3543),
    [anon_sym_exception] = ACTIONS(3543),
    [aux_sym_char_token1] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3543),
    [anon_sym_DQUOTE] = ACTIONS(3543),
    [anon_sym_AT_DQUOTE] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [sym_bool] = ACTIONS(3543),
    [sym_unit] = ACTIONS(3541),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3543),
    [sym_op_identifier] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(3543),
    [anon_sym_DASH] = ACTIONS(3543),
    [anon_sym_PLUS_DOT] = ACTIONS(3543),
    [anon_sym_DASH_DOT] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3543),
    [anon_sym_AMP_AMP] = ACTIONS(3543),
    [anon_sym_TILDE] = ACTIONS(3541),
    [aux_sym_prefix_op_token1] = ACTIONS(3543),
    [aux_sym_infix_op_token1] = ACTIONS(3541),
    [aux_sym_infix_op_token2] = ACTIONS(3543),
    [anon_sym_PIPE_PIPE] = ACTIONS(3543),
    [anon_sym_BANG_EQ] = ACTIONS(3543),
    [anon_sym_COLON_EQ] = ACTIONS(3541),
    [anon_sym_DOLLAR] = ACTIONS(3543),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3543),
    [sym_int] = ACTIONS(3543),
    [sym_xint] = ACTIONS(3541),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3541),
    [anon_sym_POUNDload] = ACTIONS(3541),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3541),
    [sym__newline] = ACTIONS(3541),
  },
  [2253] = {
    [sym_block_comment] = STATE(2253),
    [sym_compiler_directive_decl] = STATE(2253),
    [sym_fsi_directive_decl] = STATE(2253),
    [sym_preproc_line] = STATE(2253),
    [ts_builtin_sym_end] = ACTIONS(3513),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_namespace] = ACTIONS(3515),
    [anon_sym_module] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_open] = ACTIONS(3515),
    [anon_sym_LBRACK_LT] = ACTIONS(3513),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_type] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_COLON] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(3513),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_LT_DASH] = ACTIONS(3515),
    [anon_sym_DOT_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_or] = ACTIONS(3515),
    [anon_sym_exception] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3515),
    [anon_sym_DASH_DOT] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3515),
    [aux_sym_infix_op_token1] = ACTIONS(3513),
    [aux_sym_infix_op_token2] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3515),
    [anon_sym_COLON_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(3515),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3515),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3513),
    [anon_sym_POUNDload] = ACTIONS(3513),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
  },
  [2254] = {
    [sym_block_comment] = STATE(2254),
    [sym_compiler_directive_decl] = STATE(2254),
    [sym_fsi_directive_decl] = STATE(2254),
    [sym_preproc_line] = STATE(2254),
    [sym_identifier] = ACTIONS(3505),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_GT_RBRACK] = ACTIONS(3503),
    [anon_sym_COLON] = ACTIONS(3505),
    [anon_sym_return] = ACTIONS(3505),
    [anon_sym_do] = ACTIONS(3505),
    [anon_sym_let] = ACTIONS(3505),
    [anon_sym_let_BANG] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3505),
    [anon_sym_COMMA] = ACTIONS(3503),
    [anon_sym_null] = ACTIONS(3505),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_COLON_QMARK] = ACTIONS(3505),
    [anon_sym_COLON_COLON] = ACTIONS(3503),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_RBRACK] = ACTIONS(3503),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3503),
    [anon_sym_LBRACE] = ACTIONS(3505),
    [anon_sym_RBRACE] = ACTIONS(3503),
    [anon_sym_LT_AT] = ACTIONS(3505),
    [anon_sym_LT_AT_AT] = ACTIONS(3505),
    [anon_sym_DOT] = ACTIONS(3505),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3503),
    [anon_sym_new] = ACTIONS(3505),
    [anon_sym_with] = ACTIONS(3505),
    [anon_sym_return_BANG] = ACTIONS(3503),
    [anon_sym_yield] = ACTIONS(3505),
    [anon_sym_yield_BANG] = ACTIONS(3503),
    [anon_sym_lazy] = ACTIONS(3505),
    [anon_sym_assert] = ACTIONS(3505),
    [anon_sym_upcast] = ACTIONS(3505),
    [anon_sym_downcast] = ACTIONS(3505),
    [anon_sym_COLON_GT] = ACTIONS(3503),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3503),
    [anon_sym_for] = ACTIONS(3505),
    [anon_sym_to] = ACTIONS(3505),
    [anon_sym_downto] = ACTIONS(3505),
    [anon_sym_while] = ACTIONS(3505),
    [anon_sym_if] = ACTIONS(3505),
    [anon_sym_fun] = ACTIONS(3505),
    [anon_sym_DASH_GT] = ACTIONS(3505),
    [anon_sym_try] = ACTIONS(3505),
    [anon_sym_match] = ACTIONS(3505),
    [anon_sym_match_BANG] = ACTIONS(3503),
    [anon_sym_function] = ACTIONS(3505),
    [anon_sym_LT_DASH] = ACTIONS(3505),
    [anon_sym_DOT_LBRACK] = ACTIONS(3503),
    [anon_sym_LT] = ACTIONS(3503),
    [anon_sym_use] = ACTIONS(3505),
    [anon_sym_use_BANG] = ACTIONS(3503),
    [anon_sym_do_BANG] = ACTIONS(3503),
    [anon_sym_begin] = ACTIONS(3505),
    [anon_sym_LPAREN2] = ACTIONS(3505),
    [anon_sym_DOT_DOT2] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(3505),
    [anon_sym_LT2] = ACTIONS(4794),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_or] = ACTIONS(3505),
    [aux_sym_char_token1] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3505),
    [anon_sym_DQUOTE] = ACTIONS(3505),
    [anon_sym_AT_DQUOTE] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [sym_bool] = ACTIONS(3505),
    [sym_unit] = ACTIONS(3503),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3505),
    [sym_op_identifier] = ACTIONS(3505),
    [anon_sym_PLUS] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3505),
    [anon_sym_PLUS_DOT] = ACTIONS(3505),
    [anon_sym_DASH_DOT] = ACTIONS(3505),
    [anon_sym_PERCENT] = ACTIONS(3505),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3503),
    [aux_sym_prefix_op_token1] = ACTIONS(3505),
    [aux_sym_infix_op_token1] = ACTIONS(3503),
    [aux_sym_infix_op_token2] = ACTIONS(3505),
    [anon_sym_PIPE_PIPE] = ACTIONS(3505),
    [anon_sym_BANG_EQ] = ACTIONS(3505),
    [anon_sym_COLON_EQ] = ACTIONS(3503),
    [anon_sym_DOLLAR] = ACTIONS(3505),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3505),
    [sym_int] = ACTIONS(3505),
    [sym_xint] = ACTIONS(3503),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3503),
    [sym__newline] = ACTIONS(3503),
  },
  [2255] = {
    [sym_block_comment] = STATE(2255),
    [sym_compiler_directive_decl] = STATE(2255),
    [sym_fsi_directive_decl] = STATE(2255),
    [sym_preproc_line] = STATE(2255),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_GT_RBRACK] = ACTIONS(3513),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_COLON] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_RBRACK] = ACTIONS(3513),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_RBRACE] = ACTIONS(3513),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_with] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(3513),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_to] = ACTIONS(3515),
    [anon_sym_downto] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_LT_DASH] = ACTIONS(3515),
    [anon_sym_DOT_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_DOT_DOT2] = ACTIONS(3513),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_or] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3515),
    [anon_sym_DASH_DOT] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3515),
    [aux_sym_infix_op_token1] = ACTIONS(3513),
    [aux_sym_infix_op_token2] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3515),
    [anon_sym_COLON_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(3515),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3515),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
  },
  [2256] = {
    [sym_block_comment] = STATE(2256),
    [sym_compiler_directive_decl] = STATE(2256),
    [sym_fsi_directive_decl] = STATE(2256),
    [sym_preproc_line] = STATE(2256),
    [ts_builtin_sym_end] = ACTIONS(3533),
    [sym_identifier] = ACTIONS(3535),
    [anon_sym_namespace] = ACTIONS(3535),
    [anon_sym_module] = ACTIONS(3535),
    [anon_sym_EQ] = ACTIONS(3533),
    [anon_sym_open] = ACTIONS(3535),
    [anon_sym_LBRACK_LT] = ACTIONS(3533),
    [anon_sym_COLON] = ACTIONS(3535),
    [anon_sym_return] = ACTIONS(3535),
    [anon_sym_type] = ACTIONS(3535),
    [anon_sym_do] = ACTIONS(3535),
    [anon_sym_let] = ACTIONS(3535),
    [anon_sym_let_BANG] = ACTIONS(3533),
    [anon_sym_LPAREN] = ACTIONS(3535),
    [anon_sym_COMMA] = ACTIONS(3533),
    [anon_sym_null] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(3535),
    [anon_sym_COLON_QMARK] = ACTIONS(3535),
    [anon_sym_COLON_COLON] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3533),
    [anon_sym_LBRACE] = ACTIONS(3535),
    [anon_sym_LT_AT] = ACTIONS(3535),
    [anon_sym_LT_AT_AT] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(3535),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3533),
    [anon_sym_new] = ACTIONS(3535),
    [anon_sym_return_BANG] = ACTIONS(3533),
    [anon_sym_yield] = ACTIONS(3535),
    [anon_sym_yield_BANG] = ACTIONS(3533),
    [anon_sym_lazy] = ACTIONS(3535),
    [anon_sym_assert] = ACTIONS(3535),
    [anon_sym_upcast] = ACTIONS(3535),
    [anon_sym_downcast] = ACTIONS(3535),
    [anon_sym_COLON_GT] = ACTIONS(3533),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3533),
    [anon_sym_for] = ACTIONS(3535),
    [anon_sym_while] = ACTIONS(3535),
    [anon_sym_if] = ACTIONS(3535),
    [anon_sym_fun] = ACTIONS(3535),
    [anon_sym_DASH_GT] = ACTIONS(3535),
    [anon_sym_try] = ACTIONS(3535),
    [anon_sym_match] = ACTIONS(3535),
    [anon_sym_match_BANG] = ACTIONS(3533),
    [anon_sym_function] = ACTIONS(3535),
    [anon_sym_LT_DASH] = ACTIONS(3535),
    [anon_sym_DOT_LBRACK] = ACTIONS(3533),
    [anon_sym_LT] = ACTIONS(3533),
    [anon_sym_use] = ACTIONS(3535),
    [anon_sym_use_BANG] = ACTIONS(3533),
    [anon_sym_do_BANG] = ACTIONS(3533),
    [anon_sym_begin] = ACTIONS(3535),
    [anon_sym_LPAREN2] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(3535),
    [anon_sym_LT2] = ACTIONS(3535),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3533),
    [anon_sym_or] = ACTIONS(3535),
    [anon_sym_exception] = ACTIONS(3535),
    [aux_sym_char_token1] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE] = ACTIONS(3535),
    [anon_sym_AT_DQUOTE] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [sym_bool] = ACTIONS(3535),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3535),
    [sym_op_identifier] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS_DOT] = ACTIONS(3535),
    [anon_sym_DASH_DOT] = ACTIONS(3535),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(3535),
    [anon_sym_TILDE] = ACTIONS(3533),
    [aux_sym_prefix_op_token1] = ACTIONS(3535),
    [aux_sym_infix_op_token1] = ACTIONS(3533),
    [aux_sym_infix_op_token2] = ACTIONS(3535),
    [anon_sym_PIPE_PIPE] = ACTIONS(3535),
    [anon_sym_BANG_EQ] = ACTIONS(3535),
    [anon_sym_COLON_EQ] = ACTIONS(3533),
    [anon_sym_DOLLAR] = ACTIONS(3535),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3535),
    [sym_int] = ACTIONS(3535),
    [sym_xint] = ACTIONS(3533),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3533),
    [anon_sym_POUNDload] = ACTIONS(3533),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3533),
    [sym__newline] = ACTIONS(3533),
  },
  [2257] = {
    [sym_block_comment] = STATE(2257),
    [sym_compiler_directive_decl] = STATE(2257),
    [sym_fsi_directive_decl] = STATE(2257),
    [sym_preproc_line] = STATE(2257),
    [ts_builtin_sym_end] = ACTIONS(3560),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_namespace] = ACTIONS(3562),
    [anon_sym_module] = ACTIONS(3562),
    [anon_sym_EQ] = ACTIONS(3560),
    [anon_sym_open] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3560),
    [anon_sym_COLON] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_type] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_let_BANG] = ACTIONS(3560),
    [anon_sym_LPAREN] = ACTIONS(3562),
    [anon_sym_COMMA] = ACTIONS(3560),
    [anon_sym_null] = ACTIONS(3562),
    [anon_sym_QMARK] = ACTIONS(3562),
    [anon_sym_COLON_QMARK] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3560),
    [anon_sym_LBRACE] = ACTIONS(3562),
    [anon_sym_LT_AT] = ACTIONS(3562),
    [anon_sym_LT_AT_AT] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(3562),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3560),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_return_BANG] = ACTIONS(3560),
    [anon_sym_yield] = ACTIONS(3562),
    [anon_sym_yield_BANG] = ACTIONS(3560),
    [anon_sym_lazy] = ACTIONS(3562),
    [anon_sym_assert] = ACTIONS(3562),
    [anon_sym_upcast] = ACTIONS(3562),
    [anon_sym_downcast] = ACTIONS(3562),
    [anon_sym_COLON_GT] = ACTIONS(3560),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3560),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_fun] = ACTIONS(3562),
    [anon_sym_DASH_GT] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_match] = ACTIONS(3562),
    [anon_sym_match_BANG] = ACTIONS(3560),
    [anon_sym_function] = ACTIONS(3562),
    [anon_sym_LT_DASH] = ACTIONS(3562),
    [anon_sym_DOT_LBRACK] = ACTIONS(3560),
    [anon_sym_LT] = ACTIONS(3560),
    [anon_sym_use] = ACTIONS(3562),
    [anon_sym_use_BANG] = ACTIONS(3560),
    [anon_sym_do_BANG] = ACTIONS(3560),
    [anon_sym_begin] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3562),
    [anon_sym_LT2] = ACTIONS(3562),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3560),
    [anon_sym_or] = ACTIONS(3562),
    [anon_sym_exception] = ACTIONS(3562),
    [aux_sym_char_token1] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(3562),
    [anon_sym_AT_DQUOTE] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [sym_bool] = ACTIONS(3562),
    [sym_unit] = ACTIONS(3560),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3562),
    [sym_op_identifier] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS_DOT] = ACTIONS(3562),
    [anon_sym_DASH_DOT] = ACTIONS(3562),
    [anon_sym_PERCENT] = ACTIONS(3562),
    [anon_sym_AMP_AMP] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3560),
    [aux_sym_prefix_op_token1] = ACTIONS(3562),
    [aux_sym_infix_op_token1] = ACTIONS(3560),
    [aux_sym_infix_op_token2] = ACTIONS(3562),
    [anon_sym_PIPE_PIPE] = ACTIONS(3562),
    [anon_sym_BANG_EQ] = ACTIONS(3562),
    [anon_sym_COLON_EQ] = ACTIONS(3560),
    [anon_sym_DOLLAR] = ACTIONS(3562),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3562),
    [sym_int] = ACTIONS(3562),
    [sym_xint] = ACTIONS(3560),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3560),
    [anon_sym_POUNDload] = ACTIONS(3560),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3560),
    [sym__newline] = ACTIONS(3560),
  },
  [2258] = {
    [sym_block_comment] = STATE(2258),
    [sym_compiler_directive_decl] = STATE(2258),
    [sym_fsi_directive_decl] = STATE(2258),
    [sym_preproc_line] = STATE(2258),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_GT_RBRACK] = ACTIONS(3513),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_COLON] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_RBRACK] = ACTIONS(3513),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_RBRACE] = ACTIONS(3513),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_with] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(3513),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_to] = ACTIONS(3515),
    [anon_sym_downto] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_LT_DASH] = ACTIONS(3515),
    [anon_sym_DOT_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_DOT_DOT2] = ACTIONS(3513),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_or] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3515),
    [anon_sym_DASH_DOT] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3515),
    [aux_sym_infix_op_token1] = ACTIONS(3513),
    [aux_sym_infix_op_token2] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3515),
    [anon_sym_COLON_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(3515),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3515),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
  },
  [2259] = {
    [sym_block_comment] = STATE(2259),
    [sym_compiler_directive_decl] = STATE(2259),
    [sym_fsi_directive_decl] = STATE(2259),
    [sym_preproc_line] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(3529),
    [sym_identifier] = ACTIONS(3531),
    [anon_sym_namespace] = ACTIONS(3531),
    [anon_sym_module] = ACTIONS(3531),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_open] = ACTIONS(3531),
    [anon_sym_LBRACK_LT] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(3531),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_type] = ACTIONS(3531),
    [anon_sym_do] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_null] = ACTIONS(3531),
    [anon_sym_QMARK] = ACTIONS(3531),
    [anon_sym_COLON_QMARK] = ACTIONS(3531),
    [anon_sym_COLON_COLON] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3531),
    [anon_sym_LT_AT] = ACTIONS(3531),
    [anon_sym_LT_AT_AT] = ACTIONS(3531),
    [anon_sym_DOT] = ACTIONS(3531),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3531),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3531),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3531),
    [anon_sym_assert] = ACTIONS(3531),
    [anon_sym_upcast] = ACTIONS(3531),
    [anon_sym_downcast] = ACTIONS(3531),
    [anon_sym_COLON_GT] = ACTIONS(3529),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3531),
    [anon_sym_while] = ACTIONS(3531),
    [anon_sym_if] = ACTIONS(3531),
    [anon_sym_fun] = ACTIONS(3531),
    [anon_sym_DASH_GT] = ACTIONS(3531),
    [anon_sym_try] = ACTIONS(3531),
    [anon_sym_match] = ACTIONS(3531),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3531),
    [anon_sym_LT_DASH] = ACTIONS(3531),
    [anon_sym_DOT_LBRACK] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_use] = ACTIONS(3531),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3531),
    [anon_sym_LPAREN2] = ACTIONS(3531),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LT2] = ACTIONS(3531),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_or] = ACTIONS(3531),
    [anon_sym_exception] = ACTIONS(3531),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3531),
    [anon_sym_DQUOTE] = ACTIONS(3531),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3531),
    [sym_unit] = ACTIONS(3529),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3531),
    [sym_op_identifier] = ACTIONS(3531),
    [anon_sym_PLUS] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(3531),
    [anon_sym_PLUS_DOT] = ACTIONS(3531),
    [anon_sym_DASH_DOT] = ACTIONS(3531),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_AMP_AMP] = ACTIONS(3531),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3531),
    [aux_sym_infix_op_token1] = ACTIONS(3529),
    [aux_sym_infix_op_token2] = ACTIONS(3531),
    [anon_sym_PIPE_PIPE] = ACTIONS(3531),
    [anon_sym_BANG_EQ] = ACTIONS(3531),
    [anon_sym_COLON_EQ] = ACTIONS(3529),
    [anon_sym_DOLLAR] = ACTIONS(3531),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3531),
    [sym_int] = ACTIONS(3531),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3529),
    [anon_sym_POUNDload] = ACTIONS(3529),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [sym__newline] = ACTIONS(3529),
  },
  [2260] = {
    [sym_block_comment] = STATE(2260),
    [sym_compiler_directive_decl] = STATE(2260),
    [sym_fsi_directive_decl] = STATE(2260),
    [sym_preproc_line] = STATE(2260),
    [ts_builtin_sym_end] = ACTIONS(3517),
    [sym_identifier] = ACTIONS(3519),
    [anon_sym_namespace] = ACTIONS(3519),
    [anon_sym_module] = ACTIONS(3519),
    [anon_sym_EQ] = ACTIONS(3517),
    [anon_sym_open] = ACTIONS(3519),
    [anon_sym_LBRACK_LT] = ACTIONS(3517),
    [anon_sym_COLON] = ACTIONS(3519),
    [anon_sym_return] = ACTIONS(3519),
    [anon_sym_type] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(3519),
    [anon_sym_let] = ACTIONS(3519),
    [anon_sym_let_BANG] = ACTIONS(3517),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [anon_sym_COMMA] = ACTIONS(3517),
    [anon_sym_null] = ACTIONS(3519),
    [anon_sym_QMARK] = ACTIONS(3519),
    [anon_sym_COLON_QMARK] = ACTIONS(3519),
    [anon_sym_COLON_COLON] = ACTIONS(3517),
    [anon_sym_AMP] = ACTIONS(3519),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_LT_AT] = ACTIONS(3519),
    [anon_sym_LT_AT_AT] = ACTIONS(3519),
    [anon_sym_DOT] = ACTIONS(3519),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3519),
    [anon_sym_return_BANG] = ACTIONS(3517),
    [anon_sym_yield] = ACTIONS(3519),
    [anon_sym_yield_BANG] = ACTIONS(3517),
    [anon_sym_lazy] = ACTIONS(3519),
    [anon_sym_assert] = ACTIONS(3519),
    [anon_sym_upcast] = ACTIONS(3519),
    [anon_sym_downcast] = ACTIONS(3519),
    [anon_sym_COLON_GT] = ACTIONS(3517),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3517),
    [anon_sym_for] = ACTIONS(3519),
    [anon_sym_while] = ACTIONS(3519),
    [anon_sym_if] = ACTIONS(3519),
    [anon_sym_fun] = ACTIONS(3519),
    [anon_sym_DASH_GT] = ACTIONS(3519),
    [anon_sym_try] = ACTIONS(3519),
    [anon_sym_match] = ACTIONS(3519),
    [anon_sym_match_BANG] = ACTIONS(3517),
    [anon_sym_function] = ACTIONS(3519),
    [anon_sym_LT_DASH] = ACTIONS(3519),
    [anon_sym_DOT_LBRACK] = ACTIONS(3517),
    [anon_sym_LT] = ACTIONS(3517),
    [anon_sym_use] = ACTIONS(3519),
    [anon_sym_use_BANG] = ACTIONS(3517),
    [anon_sym_do_BANG] = ACTIONS(3517),
    [anon_sym_begin] = ACTIONS(3519),
    [anon_sym_LPAREN2] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_LT2] = ACTIONS(3519),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3517),
    [anon_sym_or] = ACTIONS(3519),
    [anon_sym_exception] = ACTIONS(3519),
    [aux_sym_char_token1] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [anon_sym_AT_DQUOTE] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [sym_bool] = ACTIONS(3519),
    [sym_unit] = ACTIONS(3517),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3519),
    [sym_op_identifier] = ACTIONS(3519),
    [anon_sym_PLUS] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_DOT] = ACTIONS(3519),
    [anon_sym_DASH_DOT] = ACTIONS(3519),
    [anon_sym_PERCENT] = ACTIONS(3519),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3517),
    [aux_sym_prefix_op_token1] = ACTIONS(3519),
    [aux_sym_infix_op_token1] = ACTIONS(3517),
    [aux_sym_infix_op_token2] = ACTIONS(3519),
    [anon_sym_PIPE_PIPE] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_COLON_EQ] = ACTIONS(3517),
    [anon_sym_DOLLAR] = ACTIONS(3519),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3519),
    [sym_int] = ACTIONS(3519),
    [sym_xint] = ACTIONS(3517),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3517),
    [anon_sym_POUNDload] = ACTIONS(3517),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3517),
    [sym__newline] = ACTIONS(3517),
  },
  [2261] = {
    [sym_block_comment] = STATE(2261),
    [sym_compiler_directive_decl] = STATE(2261),
    [sym_fsi_directive_decl] = STATE(2261),
    [sym_preproc_line] = STATE(2261),
    [ts_builtin_sym_end] = ACTIONS(3521),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_namespace] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(3521),
    [anon_sym_open] = ACTIONS(3523),
    [anon_sym_LBRACK_LT] = ACTIONS(3521),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_type] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_COMMA] = ACTIONS(3521),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_COLON] = ACTIONS(3521),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3521),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3521),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_COLON_GT] = ACTIONS(3521),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_DASH_GT] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3521),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_LT_DASH] = ACTIONS(3523),
    [anon_sym_DOT_LBRACK] = ACTIONS(3521),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3521),
    [anon_sym_do_BANG] = ACTIONS(3521),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_LPAREN2] = ACTIONS(3523),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_LT2] = ACTIONS(3523),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3521),
    [anon_sym_or] = ACTIONS(3523),
    [anon_sym_exception] = ACTIONS(3523),
    [aux_sym_char_token1] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3521),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3523),
    [anon_sym_DASH_DOT] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3521),
    [aux_sym_prefix_op_token1] = ACTIONS(3523),
    [aux_sym_infix_op_token1] = ACTIONS(3521),
    [aux_sym_infix_op_token2] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3523),
    [anon_sym_COLON_EQ] = ACTIONS(3521),
    [anon_sym_DOLLAR] = ACTIONS(3523),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3523),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3521),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3521),
    [anon_sym_POUNDload] = ACTIONS(3521),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3521),
    [sym__newline] = ACTIONS(3521),
  },
  [2262] = {
    [sym_block_comment] = STATE(2262),
    [sym_compiler_directive_decl] = STATE(2262),
    [sym_fsi_directive_decl] = STATE(2262),
    [sym_preproc_line] = STATE(2262),
    [ts_builtin_sym_end] = ACTIONS(3545),
    [sym_identifier] = ACTIONS(3547),
    [anon_sym_namespace] = ACTIONS(3547),
    [anon_sym_module] = ACTIONS(3547),
    [anon_sym_EQ] = ACTIONS(3545),
    [anon_sym_open] = ACTIONS(3547),
    [anon_sym_LBRACK_LT] = ACTIONS(3545),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_return] = ACTIONS(3547),
    [anon_sym_type] = ACTIONS(3547),
    [anon_sym_do] = ACTIONS(3547),
    [anon_sym_let] = ACTIONS(3547),
    [anon_sym_let_BANG] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(3547),
    [anon_sym_COMMA] = ACTIONS(3545),
    [anon_sym_null] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3547),
    [anon_sym_COLON_QMARK] = ACTIONS(3547),
    [anon_sym_COLON_COLON] = ACTIONS(3545),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3545),
    [anon_sym_LBRACE] = ACTIONS(3547),
    [anon_sym_LT_AT] = ACTIONS(3547),
    [anon_sym_LT_AT_AT] = ACTIONS(3547),
    [anon_sym_DOT] = ACTIONS(3547),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3545),
    [anon_sym_new] = ACTIONS(3547),
    [anon_sym_return_BANG] = ACTIONS(3545),
    [anon_sym_yield] = ACTIONS(3547),
    [anon_sym_yield_BANG] = ACTIONS(3545),
    [anon_sym_lazy] = ACTIONS(3547),
    [anon_sym_assert] = ACTIONS(3547),
    [anon_sym_upcast] = ACTIONS(3547),
    [anon_sym_downcast] = ACTIONS(3547),
    [anon_sym_COLON_GT] = ACTIONS(3545),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3545),
    [anon_sym_for] = ACTIONS(3547),
    [anon_sym_while] = ACTIONS(3547),
    [anon_sym_if] = ACTIONS(3547),
    [anon_sym_fun] = ACTIONS(3547),
    [anon_sym_DASH_GT] = ACTIONS(3547),
    [anon_sym_try] = ACTIONS(3547),
    [anon_sym_match] = ACTIONS(3547),
    [anon_sym_match_BANG] = ACTIONS(3545),
    [anon_sym_function] = ACTIONS(3547),
    [anon_sym_LT_DASH] = ACTIONS(3547),
    [anon_sym_DOT_LBRACK] = ACTIONS(3545),
    [anon_sym_LT] = ACTIONS(3545),
    [anon_sym_use] = ACTIONS(3547),
    [anon_sym_use_BANG] = ACTIONS(3545),
    [anon_sym_do_BANG] = ACTIONS(3545),
    [anon_sym_begin] = ACTIONS(3547),
    [anon_sym_LPAREN2] = ACTIONS(3547),
    [anon_sym_STAR] = ACTIONS(3547),
    [anon_sym_LT2] = ACTIONS(3547),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_or] = ACTIONS(3547),
    [anon_sym_exception] = ACTIONS(3547),
    [aux_sym_char_token1] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3547),
    [anon_sym_DQUOTE] = ACTIONS(3547),
    [anon_sym_AT_DQUOTE] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [sym_bool] = ACTIONS(3547),
    [sym_unit] = ACTIONS(3545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3547),
    [sym_op_identifier] = ACTIONS(3547),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PLUS_DOT] = ACTIONS(3547),
    [anon_sym_DASH_DOT] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3547),
    [anon_sym_AMP_AMP] = ACTIONS(3547),
    [anon_sym_TILDE] = ACTIONS(3545),
    [aux_sym_prefix_op_token1] = ACTIONS(3547),
    [aux_sym_infix_op_token1] = ACTIONS(3545),
    [aux_sym_infix_op_token2] = ACTIONS(3547),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_BANG_EQ] = ACTIONS(3547),
    [anon_sym_COLON_EQ] = ACTIONS(3545),
    [anon_sym_DOLLAR] = ACTIONS(3547),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3547),
    [sym_int] = ACTIONS(3547),
    [sym_xint] = ACTIONS(3545),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3545),
    [anon_sym_POUNDload] = ACTIONS(3545),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3545),
    [sym__newline] = ACTIONS(3545),
  },
  [2263] = {
    [sym_block_comment] = STATE(2263),
    [sym_compiler_directive_decl] = STATE(2263),
    [sym_fsi_directive_decl] = STATE(2263),
    [sym_preproc_line] = STATE(2263),
    [sym_identifier] = ACTIONS(3511),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_GT_RBRACK] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3511),
    [anon_sym_return] = ACTIONS(3511),
    [anon_sym_do] = ACTIONS(3511),
    [anon_sym_let] = ACTIONS(3511),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3511),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3511),
    [anon_sym_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(3511),
    [anon_sym_RBRACK] = ACTIONS(3509),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_RBRACE] = ACTIONS(3509),
    [anon_sym_LT_AT] = ACTIONS(3511),
    [anon_sym_LT_AT_AT] = ACTIONS(3511),
    [anon_sym_DOT] = ACTIONS(3511),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3511),
    [anon_sym_with] = ACTIONS(3511),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3511),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3511),
    [anon_sym_assert] = ACTIONS(3511),
    [anon_sym_upcast] = ACTIONS(3511),
    [anon_sym_downcast] = ACTIONS(3511),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3511),
    [anon_sym_to] = ACTIONS(3511),
    [anon_sym_downto] = ACTIONS(3511),
    [anon_sym_while] = ACTIONS(3511),
    [anon_sym_if] = ACTIONS(3511),
    [anon_sym_fun] = ACTIONS(3511),
    [anon_sym_DASH_GT] = ACTIONS(3511),
    [anon_sym_try] = ACTIONS(3511),
    [anon_sym_match] = ACTIONS(3511),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3511),
    [anon_sym_LT_DASH] = ACTIONS(3511),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3511),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3511),
    [anon_sym_LPAREN2] = ACTIONS(3511),
    [anon_sym_DOT_DOT2] = ACTIONS(3509),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_LT2] = ACTIONS(3511),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3511),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3511),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3511),
    [sym_unit] = ACTIONS(3509),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3511),
    [sym_op_identifier] = ACTIONS(3511),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3511),
    [anon_sym_PLUS_DOT] = ACTIONS(3511),
    [anon_sym_DASH_DOT] = ACTIONS(3511),
    [anon_sym_PERCENT] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3511),
    [aux_sym_infix_op_token1] = ACTIONS(3509),
    [aux_sym_infix_op_token2] = ACTIONS(3511),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_BANG_EQ] = ACTIONS(3511),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3511),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3511),
    [sym_int] = ACTIONS(3511),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [2264] = {
    [sym_block_comment] = STATE(2264),
    [sym_compiler_directive_decl] = STATE(2264),
    [sym_fsi_directive_decl] = STATE(2264),
    [sym_preproc_line] = STATE(2264),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_GT_RBRACK] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_RBRACK] = ACTIONS(3602),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_RBRACE] = ACTIONS(3602),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_with] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_to] = ACTIONS(3604),
    [anon_sym_downto] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_DOT_DOT2] = ACTIONS(3602),
    [anon_sym_or] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [aux_sym_float_token1] = ACTIONS(4796),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
  },
  [2265] = {
    [sym_type_arguments] = STATE(2518),
    [sym_long_identifier] = STATE(2464),
    [sym_block_comment] = STATE(2265),
    [sym_compiler_directive_decl] = STATE(2265),
    [sym_fsi_directive_decl] = STATE(2265),
    [sym_preproc_line] = STATE(2265),
    [aux_sym_compound_type_repeat1] = STATE(2345),
    [sym_identifier] = ACTIONS(4798),
    [anon_sym_EQ] = ACTIONS(3417),
    [anon_sym_COLON] = ACTIONS(3419),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_let] = ACTIONS(3419),
    [anon_sym_let_BANG] = ACTIONS(3417),
    [anon_sym_as] = ACTIONS(3419),
    [anon_sym_LPAREN] = ACTIONS(3419),
    [anon_sym_COMMA] = ACTIONS(3417),
    [anon_sym_null] = ACTIONS(3419),
    [anon_sym_QMARK] = ACTIONS(3419),
    [anon_sym_COLON_QMARK] = ACTIONS(3419),
    [anon_sym_COLON_COLON] = ACTIONS(3417),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_LT_AT] = ACTIONS(3419),
    [anon_sym_LT_AT_AT] = ACTIONS(3419),
    [anon_sym_DOT] = ACTIONS(3419),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_with] = ACTIONS(3419),
    [anon_sym_return_BANG] = ACTIONS(3417),
    [anon_sym_yield] = ACTIONS(3419),
    [anon_sym_yield_BANG] = ACTIONS(3417),
    [anon_sym_lazy] = ACTIONS(3419),
    [anon_sym_assert] = ACTIONS(3419),
    [anon_sym_upcast] = ACTIONS(3419),
    [anon_sym_downcast] = ACTIONS(3419),
    [anon_sym_COLON_GT] = ACTIONS(3417),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3417),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_fun] = ACTIONS(3419),
    [anon_sym_DASH_GT] = ACTIONS(4800),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_match] = ACTIONS(3419),
    [anon_sym_match_BANG] = ACTIONS(3417),
    [anon_sym_function] = ACTIONS(3419),
    [anon_sym_LT_DASH] = ACTIONS(3419),
    [anon_sym_DOT_LBRACK] = ACTIONS(3417),
    [anon_sym_LT] = ACTIONS(3417),
    [anon_sym_use] = ACTIONS(3419),
    [anon_sym_use_BANG] = ACTIONS(3417),
    [anon_sym_do_BANG] = ACTIONS(3417),
    [anon_sym_begin] = ACTIONS(3419),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(4802),
    [anon_sym_LT2] = ACTIONS(4804),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4806),
    [anon_sym_or] = ACTIONS(3419),
    [aux_sym_char_token1] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3419),
    [anon_sym_AT_DQUOTE] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [sym_bool] = ACTIONS(3419),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3419),
    [sym_op_identifier] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_PLUS_DOT] = ACTIONS(3419),
    [anon_sym_DASH_DOT] = ACTIONS(3419),
    [anon_sym_PERCENT] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3419),
    [anon_sym_TILDE] = ACTIONS(3417),
    [aux_sym_prefix_op_token1] = ACTIONS(3419),
    [aux_sym_infix_op_token1] = ACTIONS(3417),
    [aux_sym_infix_op_token2] = ACTIONS(3419),
    [anon_sym_PIPE_PIPE] = ACTIONS(3419),
    [anon_sym_BANG_EQ] = ACTIONS(3419),
    [anon_sym_COLON_EQ] = ACTIONS(3417),
    [anon_sym_DOLLAR] = ACTIONS(3419),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3419),
    [sym_int] = ACTIONS(3419),
    [sym_xint] = ACTIONS(3417),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3417),
    [sym__newline] = ACTIONS(3417),
    [sym__dedent] = ACTIONS(3417),
  },
  [2266] = {
    [sym_block_comment] = STATE(2266),
    [sym_compiler_directive_decl] = STATE(2266),
    [sym_fsi_directive_decl] = STATE(2266),
    [sym_preproc_line] = STATE(2266),
    [ts_builtin_sym_end] = ACTIONS(3602),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_namespace] = ACTIONS(3604),
    [anon_sym_module] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_open] = ACTIONS(3604),
    [anon_sym_LBRACK_LT] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_type] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [anon_sym_exception] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [aux_sym_float_token1] = ACTIONS(4808),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3602),
    [anon_sym_POUNDload] = ACTIONS(3602),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
  },
  [2267] = {
    [sym_type_arguments] = STATE(2518),
    [sym_long_identifier] = STATE(2464),
    [sym_block_comment] = STATE(2267),
    [sym_compiler_directive_decl] = STATE(2267),
    [sym_fsi_directive_decl] = STATE(2267),
    [sym_preproc_line] = STATE(2267),
    [aux_sym_compound_type_repeat1] = STATE(2345),
    [sym_identifier] = ACTIONS(3443),
    [anon_sym_EQ] = ACTIONS(3441),
    [anon_sym_COLON] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_let] = ACTIONS(3443),
    [anon_sym_let_BANG] = ACTIONS(3441),
    [anon_sym_as] = ACTIONS(3443),
    [anon_sym_LPAREN] = ACTIONS(3443),
    [anon_sym_COMMA] = ACTIONS(3441),
    [anon_sym_null] = ACTIONS(3443),
    [anon_sym_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_LT_AT] = ACTIONS(3443),
    [anon_sym_LT_AT_AT] = ACTIONS(3443),
    [anon_sym_DOT] = ACTIONS(3443),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_with] = ACTIONS(3443),
    [anon_sym_return_BANG] = ACTIONS(3441),
    [anon_sym_yield] = ACTIONS(3443),
    [anon_sym_yield_BANG] = ACTIONS(3441),
    [anon_sym_lazy] = ACTIONS(3443),
    [anon_sym_assert] = ACTIONS(3443),
    [anon_sym_upcast] = ACTIONS(3443),
    [anon_sym_downcast] = ACTIONS(3443),
    [anon_sym_COLON_GT] = ACTIONS(3441),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3441),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_fun] = ACTIONS(3443),
    [anon_sym_DASH_GT] = ACTIONS(4800),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_match] = ACTIONS(3443),
    [anon_sym_match_BANG] = ACTIONS(3441),
    [anon_sym_function] = ACTIONS(3443),
    [anon_sym_LT_DASH] = ACTIONS(3443),
    [anon_sym_DOT_LBRACK] = ACTIONS(3441),
    [anon_sym_LT] = ACTIONS(3441),
    [anon_sym_use] = ACTIONS(3443),
    [anon_sym_use_BANG] = ACTIONS(3441),
    [anon_sym_do_BANG] = ACTIONS(3441),
    [anon_sym_begin] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(4802),
    [anon_sym_LT2] = ACTIONS(4804),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4806),
    [anon_sym_or] = ACTIONS(3443),
    [aux_sym_char_token1] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3443),
    [anon_sym_AT_DQUOTE] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [sym_bool] = ACTIONS(3443),
    [sym_unit] = ACTIONS(3441),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3443),
    [sym_op_identifier] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_PLUS_DOT] = ACTIONS(3443),
    [anon_sym_DASH_DOT] = ACTIONS(3443),
    [anon_sym_PERCENT] = ACTIONS(3443),
    [anon_sym_AMP_AMP] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3441),
    [aux_sym_prefix_op_token1] = ACTIONS(3443),
    [aux_sym_infix_op_token1] = ACTIONS(3441),
    [aux_sym_infix_op_token2] = ACTIONS(3443),
    [anon_sym_PIPE_PIPE] = ACTIONS(3443),
    [anon_sym_BANG_EQ] = ACTIONS(3443),
    [anon_sym_COLON_EQ] = ACTIONS(3441),
    [anon_sym_DOLLAR] = ACTIONS(3443),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3443),
    [sym_int] = ACTIONS(3443),
    [sym_xint] = ACTIONS(3441),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3441),
    [sym__newline] = ACTIONS(3441),
    [sym__dedent] = ACTIONS(3441),
  },
  [2268] = {
    [sym_type_arguments] = STATE(2518),
    [sym_long_identifier] = STATE(2464),
    [sym_block_comment] = STATE(2268),
    [sym_compiler_directive_decl] = STATE(2268),
    [sym_fsi_directive_decl] = STATE(2268),
    [sym_preproc_line] = STATE(2268),
    [aux_sym_compound_type_repeat1] = STATE(2345),
    [sym_identifier] = ACTIONS(4798),
    [anon_sym_EQ] = ACTIONS(3403),
    [anon_sym_COLON] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_let_BANG] = ACTIONS(3403),
    [anon_sym_as] = ACTIONS(3407),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_COMMA] = ACTIONS(3403),
    [anon_sym_null] = ACTIONS(3407),
    [anon_sym_QMARK] = ACTIONS(3407),
    [anon_sym_COLON_QMARK] = ACTIONS(3407),
    [anon_sym_COLON_COLON] = ACTIONS(3403),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3407),
    [anon_sym_LT_AT] = ACTIONS(3407),
    [anon_sym_LT_AT_AT] = ACTIONS(3407),
    [anon_sym_DOT] = ACTIONS(3407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_with] = ACTIONS(3407),
    [anon_sym_return_BANG] = ACTIONS(3403),
    [anon_sym_yield] = ACTIONS(3407),
    [anon_sym_yield_BANG] = ACTIONS(3403),
    [anon_sym_lazy] = ACTIONS(3407),
    [anon_sym_assert] = ACTIONS(3407),
    [anon_sym_upcast] = ACTIONS(3407),
    [anon_sym_downcast] = ACTIONS(3407),
    [anon_sym_COLON_GT] = ACTIONS(3403),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_fun] = ACTIONS(3407),
    [anon_sym_DASH_GT] = ACTIONS(4800),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_match] = ACTIONS(3407),
    [anon_sym_match_BANG] = ACTIONS(3403),
    [anon_sym_function] = ACTIONS(3407),
    [anon_sym_LT_DASH] = ACTIONS(3407),
    [anon_sym_DOT_LBRACK] = ACTIONS(3403),
    [anon_sym_LT] = ACTIONS(3403),
    [anon_sym_use] = ACTIONS(3407),
    [anon_sym_use_BANG] = ACTIONS(3403),
    [anon_sym_do_BANG] = ACTIONS(3403),
    [anon_sym_begin] = ACTIONS(3407),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(4802),
    [anon_sym_LT2] = ACTIONS(4804),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4806),
    [anon_sym_or] = ACTIONS(3407),
    [aux_sym_char_token1] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3407),
    [anon_sym_DQUOTE] = ACTIONS(3407),
    [anon_sym_AT_DQUOTE] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [sym_bool] = ACTIONS(3407),
    [sym_unit] = ACTIONS(3403),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3407),
    [sym_op_identifier] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_PLUS_DOT] = ACTIONS(3407),
    [anon_sym_DASH_DOT] = ACTIONS(3407),
    [anon_sym_PERCENT] = ACTIONS(3407),
    [anon_sym_AMP_AMP] = ACTIONS(3407),
    [anon_sym_TILDE] = ACTIONS(3403),
    [aux_sym_prefix_op_token1] = ACTIONS(3407),
    [aux_sym_infix_op_token1] = ACTIONS(3403),
    [aux_sym_infix_op_token2] = ACTIONS(3407),
    [anon_sym_PIPE_PIPE] = ACTIONS(3407),
    [anon_sym_BANG_EQ] = ACTIONS(3407),
    [anon_sym_COLON_EQ] = ACTIONS(3403),
    [anon_sym_DOLLAR] = ACTIONS(3407),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3407),
    [sym_int] = ACTIONS(3407),
    [sym_xint] = ACTIONS(3403),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3403),
    [sym__newline] = ACTIONS(3403),
    [sym__dedent] = ACTIONS(3403),
  },
  [2269] = {
    [sym_type_arguments] = STATE(2518),
    [sym_long_identifier] = STATE(2464),
    [sym_block_comment] = STATE(2269),
    [sym_compiler_directive_decl] = STATE(2269),
    [sym_fsi_directive_decl] = STATE(2269),
    [sym_preproc_line] = STATE(2269),
    [aux_sym_compound_type_repeat1] = STATE(2345),
    [sym_identifier] = ACTIONS(4798),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [anon_sym_as] = ACTIONS(3427),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3427),
    [anon_sym_DOT] = ACTIONS(3427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_with] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_COLON_GT] = ACTIONS(3425),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(4800),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_LT_DASH] = ACTIONS(3427),
    [anon_sym_DOT_LBRACK] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(4802),
    [anon_sym_LT2] = ACTIONS(4804),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4806),
    [anon_sym_or] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3427),
    [anon_sym_DASH_DOT] = ACTIONS(3427),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3427),
    [aux_sym_infix_op_token1] = ACTIONS(3425),
    [aux_sym_infix_op_token2] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3427),
    [anon_sym_COLON_EQ] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3427),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
    [sym__dedent] = ACTIONS(3425),
  },
  [2270] = {
    [sym_type_arguments] = STATE(2518),
    [sym_long_identifier] = STATE(2464),
    [sym_block_comment] = STATE(2270),
    [sym_compiler_directive_decl] = STATE(2270),
    [sym_fsi_directive_decl] = STATE(2270),
    [sym_preproc_line] = STATE(2270),
    [aux_sym_compound_type_repeat1] = STATE(2345),
    [sym_identifier] = ACTIONS(4798),
    [anon_sym_EQ] = ACTIONS(3429),
    [anon_sym_COLON] = ACTIONS(3431),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_let] = ACTIONS(3431),
    [anon_sym_let_BANG] = ACTIONS(3429),
    [anon_sym_as] = ACTIONS(3431),
    [anon_sym_LPAREN] = ACTIONS(3431),
    [anon_sym_COMMA] = ACTIONS(3429),
    [anon_sym_null] = ACTIONS(3431),
    [anon_sym_QMARK] = ACTIONS(3431),
    [anon_sym_COLON_QMARK] = ACTIONS(3431),
    [anon_sym_COLON_COLON] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_LT_AT] = ACTIONS(3431),
    [anon_sym_LT_AT_AT] = ACTIONS(3431),
    [anon_sym_DOT] = ACTIONS(3431),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_with] = ACTIONS(3431),
    [anon_sym_return_BANG] = ACTIONS(3429),
    [anon_sym_yield] = ACTIONS(3431),
    [anon_sym_yield_BANG] = ACTIONS(3429),
    [anon_sym_lazy] = ACTIONS(3431),
    [anon_sym_assert] = ACTIONS(3431),
    [anon_sym_upcast] = ACTIONS(3431),
    [anon_sym_downcast] = ACTIONS(3431),
    [anon_sym_COLON_GT] = ACTIONS(3429),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_fun] = ACTIONS(3431),
    [anon_sym_DASH_GT] = ACTIONS(4800),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_match] = ACTIONS(3431),
    [anon_sym_match_BANG] = ACTIONS(3429),
    [anon_sym_function] = ACTIONS(3431),
    [anon_sym_LT_DASH] = ACTIONS(3431),
    [anon_sym_DOT_LBRACK] = ACTIONS(3429),
    [anon_sym_LT] = ACTIONS(3429),
    [anon_sym_use] = ACTIONS(3431),
    [anon_sym_use_BANG] = ACTIONS(3429),
    [anon_sym_do_BANG] = ACTIONS(3429),
    [anon_sym_begin] = ACTIONS(3431),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(4802),
    [anon_sym_LT2] = ACTIONS(4804),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4806),
    [anon_sym_or] = ACTIONS(3431),
    [aux_sym_char_token1] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [anon_sym_AT_DQUOTE] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [sym_bool] = ACTIONS(3431),
    [sym_unit] = ACTIONS(3429),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3431),
    [sym_op_identifier] = ACTIONS(3431),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_DOT] = ACTIONS(3431),
    [anon_sym_DASH_DOT] = ACTIONS(3431),
    [anon_sym_PERCENT] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3429),
    [aux_sym_prefix_op_token1] = ACTIONS(3431),
    [aux_sym_infix_op_token1] = ACTIONS(3429),
    [aux_sym_infix_op_token2] = ACTIONS(3431),
    [anon_sym_PIPE_PIPE] = ACTIONS(3431),
    [anon_sym_BANG_EQ] = ACTIONS(3431),
    [anon_sym_COLON_EQ] = ACTIONS(3429),
    [anon_sym_DOLLAR] = ACTIONS(3431),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3431),
    [sym_int] = ACTIONS(3431),
    [sym_xint] = ACTIONS(3429),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3429),
    [sym__newline] = ACTIONS(3429),
    [sym__dedent] = ACTIONS(3429),
  },
  [2271] = {
    [sym_block_comment] = STATE(2271),
    [sym_compiler_directive_decl] = STATE(2271),
    [sym_fsi_directive_decl] = STATE(2271),
    [sym_preproc_line] = STATE(2271),
    [ts_builtin_sym_end] = ACTIONS(3751),
    [sym_identifier] = ACTIONS(3753),
    [anon_sym_namespace] = ACTIONS(3753),
    [anon_sym_module] = ACTIONS(3753),
    [anon_sym_EQ] = ACTIONS(3751),
    [anon_sym_open] = ACTIONS(3753),
    [anon_sym_LBRACK_LT] = ACTIONS(3751),
    [anon_sym_COLON] = ACTIONS(3753),
    [anon_sym_return] = ACTIONS(3753),
    [anon_sym_type] = ACTIONS(3753),
    [anon_sym_do] = ACTIONS(3753),
    [anon_sym_let] = ACTIONS(3753),
    [anon_sym_let_BANG] = ACTIONS(3751),
    [anon_sym_LPAREN] = ACTIONS(3753),
    [anon_sym_COMMA] = ACTIONS(3751),
    [anon_sym_null] = ACTIONS(3753),
    [anon_sym_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_COLON] = ACTIONS(3751),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3751),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_LT_AT] = ACTIONS(3753),
    [anon_sym_LT_AT_AT] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3753),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3751),
    [anon_sym_new] = ACTIONS(3753),
    [anon_sym_return_BANG] = ACTIONS(3751),
    [anon_sym_yield] = ACTIONS(3753),
    [anon_sym_yield_BANG] = ACTIONS(3751),
    [anon_sym_lazy] = ACTIONS(3753),
    [anon_sym_assert] = ACTIONS(3753),
    [anon_sym_upcast] = ACTIONS(3753),
    [anon_sym_downcast] = ACTIONS(3753),
    [anon_sym_COLON_GT] = ACTIONS(3751),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3751),
    [anon_sym_for] = ACTIONS(3753),
    [anon_sym_while] = ACTIONS(3753),
    [anon_sym_if] = ACTIONS(3753),
    [anon_sym_fun] = ACTIONS(3753),
    [anon_sym_try] = ACTIONS(3753),
    [anon_sym_match] = ACTIONS(3753),
    [anon_sym_match_BANG] = ACTIONS(3751),
    [anon_sym_function] = ACTIONS(3753),
    [anon_sym_LT_DASH] = ACTIONS(3753),
    [anon_sym_DOT_LBRACK] = ACTIONS(3751),
    [anon_sym_LT] = ACTIONS(3751),
    [anon_sym_use] = ACTIONS(3753),
    [anon_sym_use_BANG] = ACTIONS(3751),
    [anon_sym_do_BANG] = ACTIONS(3751),
    [anon_sym_begin] = ACTIONS(3753),
    [anon_sym_LPAREN2] = ACTIONS(3753),
    [anon_sym_or] = ACTIONS(3753),
    [anon_sym_exception] = ACTIONS(3753),
    [aux_sym_char_token1] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3753),
    [anon_sym_AT_DQUOTE] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [sym_bool] = ACTIONS(3753),
    [sym_unit] = ACTIONS(3751),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3753),
    [sym_op_identifier] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PLUS_DOT] = ACTIONS(3753),
    [anon_sym_DASH_DOT] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3753),
    [anon_sym_AMP_AMP] = ACTIONS(3753),
    [anon_sym_TILDE] = ACTIONS(3751),
    [aux_sym_prefix_op_token1] = ACTIONS(3753),
    [aux_sym_infix_op_token1] = ACTIONS(3751),
    [aux_sym_infix_op_token2] = ACTIONS(3753),
    [anon_sym_PIPE_PIPE] = ACTIONS(3753),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_COLON_EQ] = ACTIONS(3751),
    [anon_sym_DOLLAR] = ACTIONS(3753),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3753),
    [sym_int] = ACTIONS(4810),
    [sym_xint] = ACTIONS(3751),
    [anon_sym_f] = ACTIONS(3753),
    [aux_sym_decimal_token1] = ACTIONS(3753),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3751),
    [anon_sym_POUNDload] = ACTIONS(3751),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3751),
    [sym__newline] = ACTIONS(3751),
  },
  [2272] = {
    [sym_block_comment] = STATE(2272),
    [sym_compiler_directive_decl] = STATE(2272),
    [sym_fsi_directive_decl] = STATE(2272),
    [sym_preproc_line] = STATE(2272),
    [ts_builtin_sym_end] = ACTIONS(3646),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_namespace] = ACTIONS(3648),
    [anon_sym_module] = ACTIONS(3648),
    [anon_sym_EQ] = ACTIONS(3646),
    [anon_sym_open] = ACTIONS(3648),
    [anon_sym_LBRACK_LT] = ACTIONS(3646),
    [anon_sym_COLON] = ACTIONS(3648),
    [anon_sym_return] = ACTIONS(3648),
    [anon_sym_type] = ACTIONS(3648),
    [anon_sym_do] = ACTIONS(3648),
    [anon_sym_let] = ACTIONS(3648),
    [anon_sym_let_BANG] = ACTIONS(3646),
    [anon_sym_LPAREN] = ACTIONS(3648),
    [anon_sym_COMMA] = ACTIONS(3646),
    [anon_sym_null] = ACTIONS(3648),
    [anon_sym_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_COLON] = ACTIONS(3646),
    [anon_sym_AMP] = ACTIONS(3648),
    [anon_sym_LBRACK] = ACTIONS(3648),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3646),
    [anon_sym_LBRACE] = ACTIONS(3648),
    [anon_sym_LT_AT] = ACTIONS(3648),
    [anon_sym_LT_AT_AT] = ACTIONS(3648),
    [anon_sym_DOT] = ACTIONS(3648),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3646),
    [anon_sym_new] = ACTIONS(3648),
    [anon_sym_return_BANG] = ACTIONS(3646),
    [anon_sym_yield] = ACTIONS(3648),
    [anon_sym_yield_BANG] = ACTIONS(3646),
    [anon_sym_lazy] = ACTIONS(3648),
    [anon_sym_assert] = ACTIONS(3648),
    [anon_sym_upcast] = ACTIONS(3648),
    [anon_sym_downcast] = ACTIONS(3648),
    [anon_sym_COLON_GT] = ACTIONS(3646),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3646),
    [anon_sym_for] = ACTIONS(3648),
    [anon_sym_while] = ACTIONS(3648),
    [anon_sym_else] = ACTIONS(3648),
    [anon_sym_elif] = ACTIONS(3648),
    [anon_sym_if] = ACTIONS(3648),
    [anon_sym_fun] = ACTIONS(3648),
    [anon_sym_try] = ACTIONS(3648),
    [anon_sym_match] = ACTIONS(3648),
    [anon_sym_match_BANG] = ACTIONS(3646),
    [anon_sym_function] = ACTIONS(3648),
    [anon_sym_LT_DASH] = ACTIONS(3648),
    [anon_sym_DOT_LBRACK] = ACTIONS(3646),
    [anon_sym_LT] = ACTIONS(3646),
    [anon_sym_use] = ACTIONS(3648),
    [anon_sym_use_BANG] = ACTIONS(3646),
    [anon_sym_do_BANG] = ACTIONS(3646),
    [anon_sym_begin] = ACTIONS(3648),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3648),
    [anon_sym_exception] = ACTIONS(3648),
    [aux_sym_char_token1] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3648),
    [anon_sym_AT_DQUOTE] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [sym_bool] = ACTIONS(3648),
    [sym_unit] = ACTIONS(3646),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3648),
    [sym_op_identifier] = ACTIONS(3648),
    [anon_sym_PLUS] = ACTIONS(3648),
    [anon_sym_DASH] = ACTIONS(3648),
    [anon_sym_PLUS_DOT] = ACTIONS(3648),
    [anon_sym_DASH_DOT] = ACTIONS(3648),
    [anon_sym_PERCENT] = ACTIONS(3648),
    [anon_sym_AMP_AMP] = ACTIONS(3648),
    [anon_sym_TILDE] = ACTIONS(3646),
    [aux_sym_prefix_op_token1] = ACTIONS(3648),
    [aux_sym_infix_op_token1] = ACTIONS(3646),
    [aux_sym_infix_op_token2] = ACTIONS(3648),
    [anon_sym_PIPE_PIPE] = ACTIONS(3648),
    [anon_sym_BANG_EQ] = ACTIONS(3648),
    [anon_sym_COLON_EQ] = ACTIONS(3646),
    [anon_sym_DOLLAR] = ACTIONS(3648),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3648),
    [sym_int] = ACTIONS(3648),
    [sym_xint] = ACTIONS(3646),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3646),
    [anon_sym_POUNDload] = ACTIONS(3646),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3646),
    [sym__newline] = ACTIONS(3646),
  },
  [2273] = {
    [sym_type_arguments] = STATE(2593),
    [sym_long_identifier] = STATE(2612),
    [sym_block_comment] = STATE(2273),
    [sym_compiler_directive_decl] = STATE(2273),
    [sym_fsi_directive_decl] = STATE(2273),
    [sym_preproc_line] = STATE(2273),
    [aux_sym_compound_type_repeat1] = STATE(2437),
    [sym_identifier] = ACTIONS(4812),
    [anon_sym_EQ] = ACTIONS(3417),
    [anon_sym_COLON] = ACTIONS(3419),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_let] = ACTIONS(3419),
    [anon_sym_let_BANG] = ACTIONS(3417),
    [anon_sym_as] = ACTIONS(3419),
    [anon_sym_LPAREN] = ACTIONS(3419),
    [anon_sym_COMMA] = ACTIONS(3417),
    [anon_sym_null] = ACTIONS(3419),
    [anon_sym_QMARK] = ACTIONS(3419),
    [anon_sym_COLON_QMARK] = ACTIONS(3419),
    [anon_sym_COLON_COLON] = ACTIONS(3417),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_LT_AT] = ACTIONS(3419),
    [anon_sym_LT_AT_AT] = ACTIONS(3419),
    [anon_sym_DOT] = ACTIONS(3419),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_with] = ACTIONS(3419),
    [anon_sym_return_BANG] = ACTIONS(3417),
    [anon_sym_yield] = ACTIONS(3419),
    [anon_sym_yield_BANG] = ACTIONS(3417),
    [anon_sym_lazy] = ACTIONS(3419),
    [anon_sym_assert] = ACTIONS(3419),
    [anon_sym_upcast] = ACTIONS(3419),
    [anon_sym_downcast] = ACTIONS(3419),
    [anon_sym_COLON_GT] = ACTIONS(3417),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3417),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_fun] = ACTIONS(3419),
    [anon_sym_DASH_GT] = ACTIONS(4814),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_match] = ACTIONS(3419),
    [anon_sym_match_BANG] = ACTIONS(3417),
    [anon_sym_function] = ACTIONS(3419),
    [anon_sym_LT_DASH] = ACTIONS(3419),
    [anon_sym_DOT_LBRACK] = ACTIONS(3417),
    [anon_sym_LT] = ACTIONS(3417),
    [anon_sym_use] = ACTIONS(3419),
    [anon_sym_use_BANG] = ACTIONS(3417),
    [anon_sym_do_BANG] = ACTIONS(3417),
    [anon_sym_begin] = ACTIONS(3419),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(4816),
    [anon_sym_LT2] = ACTIONS(4818),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4820),
    [anon_sym_or] = ACTIONS(3419),
    [aux_sym_char_token1] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3419),
    [anon_sym_AT_DQUOTE] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [sym_bool] = ACTIONS(3419),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3419),
    [sym_op_identifier] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_PLUS_DOT] = ACTIONS(3419),
    [anon_sym_DASH_DOT] = ACTIONS(3419),
    [anon_sym_PERCENT] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3419),
    [anon_sym_TILDE] = ACTIONS(3417),
    [aux_sym_prefix_op_token1] = ACTIONS(3419),
    [aux_sym_infix_op_token1] = ACTIONS(3417),
    [aux_sym_infix_op_token2] = ACTIONS(3419),
    [anon_sym_PIPE_PIPE] = ACTIONS(3419),
    [anon_sym_BANG_EQ] = ACTIONS(3419),
    [anon_sym_COLON_EQ] = ACTIONS(3417),
    [anon_sym_DOLLAR] = ACTIONS(3419),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3419),
    [sym_int] = ACTIONS(3419),
    [sym_xint] = ACTIONS(3417),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3417),
    [sym__newline] = ACTIONS(3417),
  },
  [2274] = {
    [sym_block_comment] = STATE(2274),
    [sym_compiler_directive_decl] = STATE(2274),
    [sym_fsi_directive_decl] = STATE(2274),
    [sym_preproc_line] = STATE(2274),
    [ts_builtin_sym_end] = ACTIONS(3730),
    [sym_identifier] = ACTIONS(3732),
    [anon_sym_namespace] = ACTIONS(3732),
    [anon_sym_module] = ACTIONS(3732),
    [anon_sym_EQ] = ACTIONS(3730),
    [anon_sym_open] = ACTIONS(3732),
    [anon_sym_LBRACK_LT] = ACTIONS(3730),
    [anon_sym_COLON] = ACTIONS(3732),
    [anon_sym_return] = ACTIONS(3732),
    [anon_sym_type] = ACTIONS(3732),
    [anon_sym_do] = ACTIONS(3732),
    [anon_sym_let] = ACTIONS(3732),
    [anon_sym_let_BANG] = ACTIONS(3730),
    [anon_sym_LPAREN] = ACTIONS(3732),
    [anon_sym_COMMA] = ACTIONS(3730),
    [anon_sym_null] = ACTIONS(3732),
    [anon_sym_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_LBRACK] = ACTIONS(3732),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3730),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_LT_AT] = ACTIONS(3732),
    [anon_sym_LT_AT_AT] = ACTIONS(3732),
    [anon_sym_DOT] = ACTIONS(3732),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3730),
    [anon_sym_new] = ACTIONS(3732),
    [anon_sym_return_BANG] = ACTIONS(3730),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_yield_BANG] = ACTIONS(3730),
    [anon_sym_lazy] = ACTIONS(3732),
    [anon_sym_assert] = ACTIONS(3732),
    [anon_sym_upcast] = ACTIONS(3732),
    [anon_sym_downcast] = ACTIONS(3732),
    [anon_sym_COLON_GT] = ACTIONS(3730),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3730),
    [anon_sym_for] = ACTIONS(3732),
    [anon_sym_while] = ACTIONS(3732),
    [anon_sym_else] = ACTIONS(3732),
    [anon_sym_elif] = ACTIONS(3732),
    [anon_sym_if] = ACTIONS(3732),
    [anon_sym_fun] = ACTIONS(3732),
    [anon_sym_try] = ACTIONS(3732),
    [anon_sym_match] = ACTIONS(3732),
    [anon_sym_match_BANG] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3732),
    [anon_sym_LT_DASH] = ACTIONS(3732),
    [anon_sym_DOT_LBRACK] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3730),
    [anon_sym_use] = ACTIONS(3732),
    [anon_sym_use_BANG] = ACTIONS(3730),
    [anon_sym_do_BANG] = ACTIONS(3730),
    [anon_sym_begin] = ACTIONS(3732),
    [anon_sym_LPAREN2] = ACTIONS(3732),
    [anon_sym_or] = ACTIONS(3732),
    [anon_sym_exception] = ACTIONS(3732),
    [aux_sym_char_token1] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3732),
    [anon_sym_DQUOTE] = ACTIONS(3732),
    [anon_sym_AT_DQUOTE] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [sym_bool] = ACTIONS(3732),
    [sym_unit] = ACTIONS(3730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3732),
    [sym_op_identifier] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PLUS_DOT] = ACTIONS(3732),
    [anon_sym_DASH_DOT] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3732),
    [anon_sym_AMP_AMP] = ACTIONS(3732),
    [anon_sym_TILDE] = ACTIONS(3730),
    [aux_sym_prefix_op_token1] = ACTIONS(3732),
    [aux_sym_infix_op_token1] = ACTIONS(3730),
    [aux_sym_infix_op_token2] = ACTIONS(3732),
    [anon_sym_PIPE_PIPE] = ACTIONS(3732),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_COLON_EQ] = ACTIONS(3730),
    [anon_sym_DOLLAR] = ACTIONS(3732),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3732),
    [sym_int] = ACTIONS(3732),
    [sym_xint] = ACTIONS(3730),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3730),
    [anon_sym_POUNDload] = ACTIONS(3730),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3730),
    [sym__newline] = ACTIONS(3730),
  },
  [2275] = {
    [sym_block_comment] = STATE(2275),
    [sym_compiler_directive_decl] = STATE(2275),
    [sym_fsi_directive_decl] = STATE(2275),
    [sym_preproc_line] = STATE(2275),
    [aux_sym_rules_repeat1] = STATE(2281),
    [sym_identifier] = ACTIONS(3676),
    [anon_sym_EQ] = ACTIONS(3674),
    [anon_sym_GT_RBRACK] = ACTIONS(3674),
    [anon_sym_COLON] = ACTIONS(3676),
    [anon_sym_return] = ACTIONS(3676),
    [anon_sym_do] = ACTIONS(3676),
    [anon_sym_let] = ACTIONS(3676),
    [anon_sym_let_BANG] = ACTIONS(3674),
    [anon_sym_LPAREN] = ACTIONS(3676),
    [anon_sym_COMMA] = ACTIONS(3674),
    [anon_sym_null] = ACTIONS(3676),
    [anon_sym_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_COLON] = ACTIONS(3674),
    [anon_sym_PIPE] = ACTIONS(4822),
    [anon_sym_AMP] = ACTIONS(3676),
    [anon_sym_LBRACK] = ACTIONS(3676),
    [anon_sym_RBRACK] = ACTIONS(3674),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3674),
    [anon_sym_LBRACE] = ACTIONS(3676),
    [anon_sym_RBRACE] = ACTIONS(3674),
    [anon_sym_LT_AT] = ACTIONS(3676),
    [anon_sym_LT_AT_AT] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3674),
    [anon_sym_new] = ACTIONS(3676),
    [anon_sym_with] = ACTIONS(3676),
    [anon_sym_return_BANG] = ACTIONS(3674),
    [anon_sym_yield] = ACTIONS(3676),
    [anon_sym_yield_BANG] = ACTIONS(3674),
    [anon_sym_lazy] = ACTIONS(3676),
    [anon_sym_assert] = ACTIONS(3676),
    [anon_sym_upcast] = ACTIONS(3676),
    [anon_sym_downcast] = ACTIONS(3676),
    [anon_sym_COLON_GT] = ACTIONS(3674),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3674),
    [anon_sym_for] = ACTIONS(3676),
    [anon_sym_to] = ACTIONS(3676),
    [anon_sym_downto] = ACTIONS(3676),
    [anon_sym_while] = ACTIONS(3676),
    [anon_sym_if] = ACTIONS(3676),
    [anon_sym_fun] = ACTIONS(3676),
    [anon_sym_try] = ACTIONS(3676),
    [anon_sym_match] = ACTIONS(3676),
    [anon_sym_match_BANG] = ACTIONS(3674),
    [anon_sym_function] = ACTIONS(3676),
    [anon_sym_LT_DASH] = ACTIONS(3676),
    [anon_sym_DOT_LBRACK] = ACTIONS(3674),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_use] = ACTIONS(3676),
    [anon_sym_use_BANG] = ACTIONS(3674),
    [anon_sym_do_BANG] = ACTIONS(3674),
    [anon_sym_begin] = ACTIONS(3676),
    [anon_sym_LPAREN2] = ACTIONS(3676),
    [anon_sym_DOT_DOT2] = ACTIONS(3674),
    [anon_sym_or] = ACTIONS(3676),
    [aux_sym_char_token1] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3676),
    [anon_sym_DQUOTE] = ACTIONS(3676),
    [anon_sym_AT_DQUOTE] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [sym_bool] = ACTIONS(3676),
    [sym_unit] = ACTIONS(3674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3676),
    [sym_op_identifier] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_PLUS_DOT] = ACTIONS(3676),
    [anon_sym_DASH_DOT] = ACTIONS(3676),
    [anon_sym_PERCENT] = ACTIONS(3676),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_TILDE] = ACTIONS(3674),
    [aux_sym_prefix_op_token1] = ACTIONS(3676),
    [aux_sym_infix_op_token1] = ACTIONS(3674),
    [aux_sym_infix_op_token2] = ACTIONS(3676),
    [anon_sym_PIPE_PIPE] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3676),
    [anon_sym_COLON_EQ] = ACTIONS(3674),
    [anon_sym_DOLLAR] = ACTIONS(3676),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3676),
    [sym_int] = ACTIONS(3676),
    [sym_xint] = ACTIONS(3674),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3674),
    [sym__newline] = ACTIONS(4824),
  },
  [2276] = {
    [sym_block_comment] = STATE(2276),
    [sym_compiler_directive_decl] = STATE(2276),
    [sym_fsi_directive_decl] = STATE(2276),
    [sym_preproc_line] = STATE(2276),
    [aux_sym_rules_repeat1] = STATE(2295),
    [sym_identifier] = ACTIONS(3736),
    [anon_sym_EQ] = ACTIONS(3734),
    [anon_sym_GT_RBRACK] = ACTIONS(3734),
    [anon_sym_COLON] = ACTIONS(3736),
    [anon_sym_return] = ACTIONS(3736),
    [anon_sym_do] = ACTIONS(3736),
    [anon_sym_let] = ACTIONS(3736),
    [anon_sym_let_BANG] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3736),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_null] = ACTIONS(3736),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_COLON] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(4822),
    [anon_sym_AMP] = ACTIONS(3736),
    [anon_sym_LBRACK] = ACTIONS(3736),
    [anon_sym_RBRACK] = ACTIONS(3734),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3734),
    [anon_sym_LBRACE] = ACTIONS(3736),
    [anon_sym_RBRACE] = ACTIONS(3734),
    [anon_sym_LT_AT] = ACTIONS(3736),
    [anon_sym_LT_AT_AT] = ACTIONS(3736),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3734),
    [anon_sym_new] = ACTIONS(3736),
    [anon_sym_with] = ACTIONS(3736),
    [anon_sym_return_BANG] = ACTIONS(3734),
    [anon_sym_yield] = ACTIONS(3736),
    [anon_sym_yield_BANG] = ACTIONS(3734),
    [anon_sym_lazy] = ACTIONS(3736),
    [anon_sym_assert] = ACTIONS(3736),
    [anon_sym_upcast] = ACTIONS(3736),
    [anon_sym_downcast] = ACTIONS(3736),
    [anon_sym_COLON_GT] = ACTIONS(3734),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3734),
    [anon_sym_for] = ACTIONS(3736),
    [anon_sym_to] = ACTIONS(3736),
    [anon_sym_downto] = ACTIONS(3736),
    [anon_sym_while] = ACTIONS(3736),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_fun] = ACTIONS(3736),
    [anon_sym_try] = ACTIONS(3736),
    [anon_sym_match] = ACTIONS(3736),
    [anon_sym_match_BANG] = ACTIONS(3734),
    [anon_sym_function] = ACTIONS(3736),
    [anon_sym_LT_DASH] = ACTIONS(3736),
    [anon_sym_DOT_LBRACK] = ACTIONS(3734),
    [anon_sym_LT] = ACTIONS(3734),
    [anon_sym_use] = ACTIONS(3736),
    [anon_sym_use_BANG] = ACTIONS(3734),
    [anon_sym_do_BANG] = ACTIONS(3734),
    [anon_sym_begin] = ACTIONS(3736),
    [anon_sym_LPAREN2] = ACTIONS(3736),
    [anon_sym_DOT_DOT2] = ACTIONS(3734),
    [anon_sym_or] = ACTIONS(3736),
    [aux_sym_char_token1] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3736),
    [anon_sym_DQUOTE] = ACTIONS(3736),
    [anon_sym_AT_DQUOTE] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [sym_bool] = ACTIONS(3736),
    [sym_unit] = ACTIONS(3734),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3736),
    [sym_op_identifier] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS_DOT] = ACTIONS(3736),
    [anon_sym_DASH_DOT] = ACTIONS(3736),
    [anon_sym_PERCENT] = ACTIONS(3736),
    [anon_sym_AMP_AMP] = ACTIONS(3736),
    [anon_sym_TILDE] = ACTIONS(3734),
    [aux_sym_prefix_op_token1] = ACTIONS(3736),
    [aux_sym_infix_op_token1] = ACTIONS(3734),
    [aux_sym_infix_op_token2] = ACTIONS(3736),
    [anon_sym_PIPE_PIPE] = ACTIONS(3736),
    [anon_sym_BANG_EQ] = ACTIONS(3736),
    [anon_sym_COLON_EQ] = ACTIONS(3734),
    [anon_sym_DOLLAR] = ACTIONS(3736),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3736),
    [sym_int] = ACTIONS(3736),
    [sym_xint] = ACTIONS(3734),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3734),
    [sym__newline] = ACTIONS(4827),
  },
  [2277] = {
    [sym_type_arguments] = STATE(2593),
    [sym_long_identifier] = STATE(2612),
    [sym_block_comment] = STATE(2277),
    [sym_compiler_directive_decl] = STATE(2277),
    [sym_fsi_directive_decl] = STATE(2277),
    [sym_preproc_line] = STATE(2277),
    [aux_sym_compound_type_repeat1] = STATE(2437),
    [sym_identifier] = ACTIONS(4812),
    [anon_sym_EQ] = ACTIONS(3429),
    [anon_sym_COLON] = ACTIONS(3431),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_let] = ACTIONS(3431),
    [anon_sym_let_BANG] = ACTIONS(3429),
    [anon_sym_as] = ACTIONS(3431),
    [anon_sym_LPAREN] = ACTIONS(3431),
    [anon_sym_COMMA] = ACTIONS(3429),
    [anon_sym_null] = ACTIONS(3431),
    [anon_sym_QMARK] = ACTIONS(3431),
    [anon_sym_COLON_QMARK] = ACTIONS(3431),
    [anon_sym_COLON_COLON] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_LT_AT] = ACTIONS(3431),
    [anon_sym_LT_AT_AT] = ACTIONS(3431),
    [anon_sym_DOT] = ACTIONS(3431),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_with] = ACTIONS(3431),
    [anon_sym_return_BANG] = ACTIONS(3429),
    [anon_sym_yield] = ACTIONS(3431),
    [anon_sym_yield_BANG] = ACTIONS(3429),
    [anon_sym_lazy] = ACTIONS(3431),
    [anon_sym_assert] = ACTIONS(3431),
    [anon_sym_upcast] = ACTIONS(3431),
    [anon_sym_downcast] = ACTIONS(3431),
    [anon_sym_COLON_GT] = ACTIONS(3429),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_fun] = ACTIONS(3431),
    [anon_sym_DASH_GT] = ACTIONS(4814),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_match] = ACTIONS(3431),
    [anon_sym_match_BANG] = ACTIONS(3429),
    [anon_sym_function] = ACTIONS(3431),
    [anon_sym_LT_DASH] = ACTIONS(3431),
    [anon_sym_DOT_LBRACK] = ACTIONS(3429),
    [anon_sym_LT] = ACTIONS(3429),
    [anon_sym_use] = ACTIONS(3431),
    [anon_sym_use_BANG] = ACTIONS(3429),
    [anon_sym_do_BANG] = ACTIONS(3429),
    [anon_sym_begin] = ACTIONS(3431),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(4816),
    [anon_sym_LT2] = ACTIONS(4818),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4820),
    [anon_sym_or] = ACTIONS(3431),
    [aux_sym_char_token1] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [anon_sym_AT_DQUOTE] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [sym_bool] = ACTIONS(3431),
    [sym_unit] = ACTIONS(3429),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3431),
    [sym_op_identifier] = ACTIONS(3431),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_DOT] = ACTIONS(3431),
    [anon_sym_DASH_DOT] = ACTIONS(3431),
    [anon_sym_PERCENT] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3429),
    [aux_sym_prefix_op_token1] = ACTIONS(3431),
    [aux_sym_infix_op_token1] = ACTIONS(3429),
    [aux_sym_infix_op_token2] = ACTIONS(3431),
    [anon_sym_PIPE_PIPE] = ACTIONS(3431),
    [anon_sym_BANG_EQ] = ACTIONS(3431),
    [anon_sym_COLON_EQ] = ACTIONS(3429),
    [anon_sym_DOLLAR] = ACTIONS(3431),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3431),
    [sym_int] = ACTIONS(3431),
    [sym_xint] = ACTIONS(3429),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3429),
    [sym__newline] = ACTIONS(3429),
  },
  [2278] = {
    [sym_block_comment] = STATE(2278),
    [sym_compiler_directive_decl] = STATE(2278),
    [sym_fsi_directive_decl] = STATE(2278),
    [sym_preproc_line] = STATE(2278),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_GT_RBRACK] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_RBRACK] = ACTIONS(3698),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_RBRACE] = ACTIONS(3698),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_to] = ACTIONS(3700),
    [anon_sym_downto] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_else] = ACTIONS(3700),
    [anon_sym_elif] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_DOT_DOT2] = ACTIONS(3698),
    [anon_sym_or] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [2279] = {
    [sym_block_comment] = STATE(2279),
    [sym_compiler_directive_decl] = STATE(2279),
    [sym_fsi_directive_decl] = STATE(2279),
    [sym_preproc_line] = STATE(2279),
    [aux_sym_rules_repeat1] = STATE(2285),
    [ts_builtin_sym_end] = ACTIONS(3734),
    [sym_identifier] = ACTIONS(3736),
    [anon_sym_namespace] = ACTIONS(3736),
    [anon_sym_module] = ACTIONS(3736),
    [anon_sym_EQ] = ACTIONS(3734),
    [anon_sym_open] = ACTIONS(3736),
    [anon_sym_LBRACK_LT] = ACTIONS(3734),
    [anon_sym_COLON] = ACTIONS(3736),
    [anon_sym_return] = ACTIONS(3736),
    [anon_sym_type] = ACTIONS(3736),
    [anon_sym_do] = ACTIONS(3736),
    [anon_sym_let] = ACTIONS(3736),
    [anon_sym_let_BANG] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3736),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_null] = ACTIONS(3736),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_COLON] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(4830),
    [anon_sym_AMP] = ACTIONS(3736),
    [anon_sym_LBRACK] = ACTIONS(3736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3734),
    [anon_sym_LBRACE] = ACTIONS(3736),
    [anon_sym_LT_AT] = ACTIONS(3736),
    [anon_sym_LT_AT_AT] = ACTIONS(3736),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3734),
    [anon_sym_new] = ACTIONS(3736),
    [anon_sym_return_BANG] = ACTIONS(3734),
    [anon_sym_yield] = ACTIONS(3736),
    [anon_sym_yield_BANG] = ACTIONS(3734),
    [anon_sym_lazy] = ACTIONS(3736),
    [anon_sym_assert] = ACTIONS(3736),
    [anon_sym_upcast] = ACTIONS(3736),
    [anon_sym_downcast] = ACTIONS(3736),
    [anon_sym_COLON_GT] = ACTIONS(3734),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3734),
    [anon_sym_for] = ACTIONS(3736),
    [anon_sym_while] = ACTIONS(3736),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_fun] = ACTIONS(3736),
    [anon_sym_try] = ACTIONS(3736),
    [anon_sym_match] = ACTIONS(3736),
    [anon_sym_match_BANG] = ACTIONS(3734),
    [anon_sym_function] = ACTIONS(3736),
    [anon_sym_LT_DASH] = ACTIONS(3736),
    [anon_sym_DOT_LBRACK] = ACTIONS(3734),
    [anon_sym_LT] = ACTIONS(3734),
    [anon_sym_use] = ACTIONS(3736),
    [anon_sym_use_BANG] = ACTIONS(3734),
    [anon_sym_do_BANG] = ACTIONS(3734),
    [anon_sym_begin] = ACTIONS(3736),
    [anon_sym_LPAREN2] = ACTIONS(3736),
    [anon_sym_or] = ACTIONS(3736),
    [anon_sym_exception] = ACTIONS(3736),
    [aux_sym_char_token1] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3736),
    [anon_sym_DQUOTE] = ACTIONS(3736),
    [anon_sym_AT_DQUOTE] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [sym_bool] = ACTIONS(3736),
    [sym_unit] = ACTIONS(3734),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3736),
    [sym_op_identifier] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS_DOT] = ACTIONS(3736),
    [anon_sym_DASH_DOT] = ACTIONS(3736),
    [anon_sym_PERCENT] = ACTIONS(3736),
    [anon_sym_AMP_AMP] = ACTIONS(3736),
    [anon_sym_TILDE] = ACTIONS(3734),
    [aux_sym_prefix_op_token1] = ACTIONS(3736),
    [aux_sym_infix_op_token1] = ACTIONS(3734),
    [aux_sym_infix_op_token2] = ACTIONS(3736),
    [anon_sym_PIPE_PIPE] = ACTIONS(3736),
    [anon_sym_BANG_EQ] = ACTIONS(3736),
    [anon_sym_COLON_EQ] = ACTIONS(3734),
    [anon_sym_DOLLAR] = ACTIONS(3736),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3736),
    [sym_int] = ACTIONS(3736),
    [sym_xint] = ACTIONS(3734),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3734),
    [anon_sym_POUNDload] = ACTIONS(3734),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3734),
    [sym__newline] = ACTIONS(4832),
  },
  [2280] = {
    [sym_block_comment] = STATE(2280),
    [sym_compiler_directive_decl] = STATE(2280),
    [sym_fsi_directive_decl] = STATE(2280),
    [sym_preproc_line] = STATE(2280),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_GT_RBRACK] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_RBRACK] = ACTIONS(3191),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_RBRACE] = ACTIONS(3191),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_to] = ACTIONS(3193),
    [anon_sym_downto] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_DOT_DOT2] = ACTIONS(3191),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_f] = ACTIONS(3660),
    [aux_sym_decimal_token1] = ACTIONS(3640),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [2281] = {
    [sym_block_comment] = STATE(2281),
    [sym_compiler_directive_decl] = STATE(2281),
    [sym_fsi_directive_decl] = STATE(2281),
    [sym_preproc_line] = STATE(2281),
    [aux_sym_rules_repeat1] = STATE(2281),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_GT_RBRACK] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(4835),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_RBRACK] = ACTIONS(3741),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_RBRACE] = ACTIONS(3741),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_with] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_to] = ACTIONS(3743),
    [anon_sym_downto] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_DOT_DOT2] = ACTIONS(3741),
    [anon_sym_or] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [sym__newline] = ACTIONS(4838),
  },
  [2282] = {
    [sym_block_comment] = STATE(2282),
    [sym_compiler_directive_decl] = STATE(2282),
    [sym_fsi_directive_decl] = STATE(2282),
    [sym_preproc_line] = STATE(2282),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_GT_RBRACK] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_RBRACK] = ACTIONS(3602),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_RBRACE] = ACTIONS(3602),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_with] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_to] = ACTIONS(3604),
    [anon_sym_downto] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_DOT_DOT2] = ACTIONS(3602),
    [anon_sym_or] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
  },
  [2283] = {
    [sym_block_comment] = STATE(2283),
    [sym_compiler_directive_decl] = STATE(2283),
    [sym_fsi_directive_decl] = STATE(2283),
    [sym_preproc_line] = STATE(2283),
    [ts_builtin_sym_end] = ACTIONS(3698),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_namespace] = ACTIONS(3700),
    [anon_sym_module] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_open] = ACTIONS(3700),
    [anon_sym_LBRACK_LT] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_type] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_else] = ACTIONS(3700),
    [anon_sym_elif] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [anon_sym_exception] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3698),
    [anon_sym_POUNDload] = ACTIONS(3698),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [2284] = {
    [sym_block_comment] = STATE(2284),
    [sym_compiler_directive_decl] = STATE(2284),
    [sym_fsi_directive_decl] = STATE(2284),
    [sym_preproc_line] = STATE(2284),
    [aux_sym_rules_repeat1] = STATE(2289),
    [ts_builtin_sym_end] = ACTIONS(3691),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_namespace] = ACTIONS(3693),
    [anon_sym_module] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_open] = ACTIONS(3693),
    [anon_sym_LBRACK_LT] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_type] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(4830),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_or] = ACTIONS(3693),
    [anon_sym_exception] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3691),
    [anon_sym_POUNDload] = ACTIONS(3691),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(4841),
  },
  [2285] = {
    [sym_block_comment] = STATE(2285),
    [sym_compiler_directive_decl] = STATE(2285),
    [sym_fsi_directive_decl] = STATE(2285),
    [sym_preproc_line] = STATE(2285),
    [aux_sym_rules_repeat1] = STATE(2292),
    [ts_builtin_sym_end] = ACTIONS(3691),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_namespace] = ACTIONS(3693),
    [anon_sym_module] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_open] = ACTIONS(3693),
    [anon_sym_LBRACK_LT] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_type] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(4830),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_or] = ACTIONS(3693),
    [anon_sym_exception] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3691),
    [anon_sym_POUNDload] = ACTIONS(3691),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(4841),
  },
  [2286] = {
    [sym_block_comment] = STATE(2286),
    [sym_compiler_directive_decl] = STATE(2286),
    [sym_fsi_directive_decl] = STATE(2286),
    [sym_preproc_line] = STATE(2286),
    [ts_builtin_sym_end] = ACTIONS(3191),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_namespace] = ACTIONS(3193),
    [anon_sym_module] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_open] = ACTIONS(3193),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_type] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_exception] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_f] = ACTIONS(3712),
    [aux_sym_decimal_token1] = ACTIONS(3586),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3191),
    [anon_sym_POUNDload] = ACTIONS(3191),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [2287] = {
    [sym_block_comment] = STATE(2287),
    [sym_compiler_directive_decl] = STATE(2287),
    [sym_fsi_directive_decl] = STATE(2287),
    [sym_preproc_line] = STATE(2287),
    [ts_builtin_sym_end] = ACTIONS(3726),
    [sym_identifier] = ACTIONS(3728),
    [anon_sym_namespace] = ACTIONS(3728),
    [anon_sym_module] = ACTIONS(3728),
    [anon_sym_EQ] = ACTIONS(3726),
    [anon_sym_open] = ACTIONS(3728),
    [anon_sym_LBRACK_LT] = ACTIONS(3726),
    [anon_sym_COLON] = ACTIONS(3728),
    [anon_sym_return] = ACTIONS(3728),
    [anon_sym_type] = ACTIONS(3728),
    [anon_sym_do] = ACTIONS(3728),
    [anon_sym_let] = ACTIONS(3728),
    [anon_sym_let_BANG] = ACTIONS(3726),
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_COMMA] = ACTIONS(3726),
    [anon_sym_null] = ACTIONS(3728),
    [anon_sym_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(3726),
    [anon_sym_AMP] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3726),
    [anon_sym_LBRACE] = ACTIONS(3728),
    [anon_sym_LT_AT] = ACTIONS(3728),
    [anon_sym_LT_AT_AT] = ACTIONS(3728),
    [anon_sym_DOT] = ACTIONS(3728),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3726),
    [anon_sym_new] = ACTIONS(3728),
    [anon_sym_return_BANG] = ACTIONS(3726),
    [anon_sym_yield] = ACTIONS(3728),
    [anon_sym_yield_BANG] = ACTIONS(3726),
    [anon_sym_lazy] = ACTIONS(3728),
    [anon_sym_assert] = ACTIONS(3728),
    [anon_sym_upcast] = ACTIONS(3728),
    [anon_sym_downcast] = ACTIONS(3728),
    [anon_sym_COLON_GT] = ACTIONS(3726),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3726),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_fun] = ACTIONS(3728),
    [anon_sym_try] = ACTIONS(3728),
    [anon_sym_match] = ACTIONS(3728),
    [anon_sym_match_BANG] = ACTIONS(3726),
    [anon_sym_function] = ACTIONS(3728),
    [anon_sym_LT_DASH] = ACTIONS(3728),
    [anon_sym_DOT_LBRACK] = ACTIONS(3726),
    [anon_sym_LT] = ACTIONS(3726),
    [anon_sym_use] = ACTIONS(3728),
    [anon_sym_use_BANG] = ACTIONS(3726),
    [anon_sym_do_BANG] = ACTIONS(3726),
    [anon_sym_begin] = ACTIONS(3728),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [anon_sym_exception] = ACTIONS(3728),
    [aux_sym_char_token1] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3728),
    [anon_sym_AT_DQUOTE] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [sym_bool] = ACTIONS(3728),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3728),
    [sym_op_identifier] = ACTIONS(3728),
    [anon_sym_PLUS] = ACTIONS(3728),
    [anon_sym_DASH] = ACTIONS(3728),
    [anon_sym_PLUS_DOT] = ACTIONS(3728),
    [anon_sym_DASH_DOT] = ACTIONS(3728),
    [anon_sym_PERCENT] = ACTIONS(3728),
    [anon_sym_AMP_AMP] = ACTIONS(3728),
    [anon_sym_TILDE] = ACTIONS(3726),
    [aux_sym_prefix_op_token1] = ACTIONS(3728),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token2] = ACTIONS(3728),
    [anon_sym_PIPE_PIPE] = ACTIONS(3728),
    [anon_sym_BANG_EQ] = ACTIONS(3728),
    [anon_sym_COLON_EQ] = ACTIONS(3726),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3728),
    [sym_int] = ACTIONS(3728),
    [sym_xint] = ACTIONS(3726),
    [anon_sym_f] = ACTIONS(3728),
    [aux_sym_decimal_token1] = ACTIONS(3728),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3726),
    [anon_sym_POUNDload] = ACTIONS(3726),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3726),
    [sym__newline] = ACTIONS(3726),
  },
  [2288] = {
    [sym_type_arguments] = STATE(2593),
    [sym_long_identifier] = STATE(2612),
    [sym_block_comment] = STATE(2288),
    [sym_compiler_directive_decl] = STATE(2288),
    [sym_fsi_directive_decl] = STATE(2288),
    [sym_preproc_line] = STATE(2288),
    [aux_sym_compound_type_repeat1] = STATE(2437),
    [sym_identifier] = ACTIONS(4812),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [anon_sym_as] = ACTIONS(3427),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3427),
    [anon_sym_DOT] = ACTIONS(3427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_with] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_COLON_GT] = ACTIONS(3425),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(4814),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_LT_DASH] = ACTIONS(3427),
    [anon_sym_DOT_LBRACK] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(4816),
    [anon_sym_LT2] = ACTIONS(4818),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4820),
    [anon_sym_or] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3427),
    [anon_sym_DASH_DOT] = ACTIONS(3427),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3427),
    [aux_sym_infix_op_token1] = ACTIONS(3425),
    [aux_sym_infix_op_token2] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3427),
    [anon_sym_COLON_EQ] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3427),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
  },
  [2289] = {
    [sym_block_comment] = STATE(2289),
    [sym_compiler_directive_decl] = STATE(2289),
    [sym_fsi_directive_decl] = STATE(2289),
    [sym_preproc_line] = STATE(2289),
    [aux_sym_rules_repeat1] = STATE(2292),
    [ts_builtin_sym_end] = ACTIONS(3674),
    [sym_identifier] = ACTIONS(3676),
    [anon_sym_namespace] = ACTIONS(3676),
    [anon_sym_module] = ACTIONS(3676),
    [anon_sym_EQ] = ACTIONS(3674),
    [anon_sym_open] = ACTIONS(3676),
    [anon_sym_LBRACK_LT] = ACTIONS(3674),
    [anon_sym_COLON] = ACTIONS(3676),
    [anon_sym_return] = ACTIONS(3676),
    [anon_sym_type] = ACTIONS(3676),
    [anon_sym_do] = ACTIONS(3676),
    [anon_sym_let] = ACTIONS(3676),
    [anon_sym_let_BANG] = ACTIONS(3674),
    [anon_sym_LPAREN] = ACTIONS(3676),
    [anon_sym_COMMA] = ACTIONS(3674),
    [anon_sym_null] = ACTIONS(3676),
    [anon_sym_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_COLON] = ACTIONS(3674),
    [anon_sym_PIPE] = ACTIONS(4830),
    [anon_sym_AMP] = ACTIONS(3676),
    [anon_sym_LBRACK] = ACTIONS(3676),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3674),
    [anon_sym_LBRACE] = ACTIONS(3676),
    [anon_sym_LT_AT] = ACTIONS(3676),
    [anon_sym_LT_AT_AT] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3674),
    [anon_sym_new] = ACTIONS(3676),
    [anon_sym_return_BANG] = ACTIONS(3674),
    [anon_sym_yield] = ACTIONS(3676),
    [anon_sym_yield_BANG] = ACTIONS(3674),
    [anon_sym_lazy] = ACTIONS(3676),
    [anon_sym_assert] = ACTIONS(3676),
    [anon_sym_upcast] = ACTIONS(3676),
    [anon_sym_downcast] = ACTIONS(3676),
    [anon_sym_COLON_GT] = ACTIONS(3674),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3674),
    [anon_sym_for] = ACTIONS(3676),
    [anon_sym_while] = ACTIONS(3676),
    [anon_sym_if] = ACTIONS(3676),
    [anon_sym_fun] = ACTIONS(3676),
    [anon_sym_try] = ACTIONS(3676),
    [anon_sym_match] = ACTIONS(3676),
    [anon_sym_match_BANG] = ACTIONS(3674),
    [anon_sym_function] = ACTIONS(3676),
    [anon_sym_LT_DASH] = ACTIONS(3676),
    [anon_sym_DOT_LBRACK] = ACTIONS(3674),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_use] = ACTIONS(3676),
    [anon_sym_use_BANG] = ACTIONS(3674),
    [anon_sym_do_BANG] = ACTIONS(3674),
    [anon_sym_begin] = ACTIONS(3676),
    [anon_sym_LPAREN2] = ACTIONS(3676),
    [anon_sym_or] = ACTIONS(3676),
    [anon_sym_exception] = ACTIONS(3676),
    [aux_sym_char_token1] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3676),
    [anon_sym_DQUOTE] = ACTIONS(3676),
    [anon_sym_AT_DQUOTE] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [sym_bool] = ACTIONS(3676),
    [sym_unit] = ACTIONS(3674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3676),
    [sym_op_identifier] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_PLUS_DOT] = ACTIONS(3676),
    [anon_sym_DASH_DOT] = ACTIONS(3676),
    [anon_sym_PERCENT] = ACTIONS(3676),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_TILDE] = ACTIONS(3674),
    [aux_sym_prefix_op_token1] = ACTIONS(3676),
    [aux_sym_infix_op_token1] = ACTIONS(3674),
    [aux_sym_infix_op_token2] = ACTIONS(3676),
    [anon_sym_PIPE_PIPE] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3676),
    [anon_sym_COLON_EQ] = ACTIONS(3674),
    [anon_sym_DOLLAR] = ACTIONS(3676),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3676),
    [sym_int] = ACTIONS(3676),
    [sym_xint] = ACTIONS(3674),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3674),
    [anon_sym_POUNDload] = ACTIONS(3674),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3674),
    [sym__newline] = ACTIONS(4844),
  },
  [2290] = {
    [sym_block_comment] = STATE(2290),
    [sym_compiler_directive_decl] = STATE(2290),
    [sym_fsi_directive_decl] = STATE(2290),
    [sym_preproc_line] = STATE(2290),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_EQ] = ACTIONS(3646),
    [anon_sym_GT_RBRACK] = ACTIONS(3646),
    [anon_sym_COLON] = ACTIONS(3648),
    [anon_sym_return] = ACTIONS(3648),
    [anon_sym_do] = ACTIONS(3648),
    [anon_sym_let] = ACTIONS(3648),
    [anon_sym_let_BANG] = ACTIONS(3646),
    [anon_sym_LPAREN] = ACTIONS(3648),
    [anon_sym_COMMA] = ACTIONS(3646),
    [anon_sym_null] = ACTIONS(3648),
    [anon_sym_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_COLON] = ACTIONS(3646),
    [anon_sym_AMP] = ACTIONS(3648),
    [anon_sym_LBRACK] = ACTIONS(3648),
    [anon_sym_RBRACK] = ACTIONS(3646),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3646),
    [anon_sym_LBRACE] = ACTIONS(3648),
    [anon_sym_RBRACE] = ACTIONS(3646),
    [anon_sym_LT_AT] = ACTIONS(3648),
    [anon_sym_LT_AT_AT] = ACTIONS(3648),
    [anon_sym_DOT] = ACTIONS(3648),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3646),
    [anon_sym_new] = ACTIONS(3648),
    [anon_sym_with] = ACTIONS(3648),
    [anon_sym_return_BANG] = ACTIONS(3646),
    [anon_sym_yield] = ACTIONS(3648),
    [anon_sym_yield_BANG] = ACTIONS(3646),
    [anon_sym_lazy] = ACTIONS(3648),
    [anon_sym_assert] = ACTIONS(3648),
    [anon_sym_upcast] = ACTIONS(3648),
    [anon_sym_downcast] = ACTIONS(3648),
    [anon_sym_COLON_GT] = ACTIONS(3646),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3646),
    [anon_sym_for] = ACTIONS(3648),
    [anon_sym_to] = ACTIONS(3648),
    [anon_sym_downto] = ACTIONS(3648),
    [anon_sym_while] = ACTIONS(3648),
    [anon_sym_else] = ACTIONS(3648),
    [anon_sym_elif] = ACTIONS(3648),
    [anon_sym_if] = ACTIONS(3648),
    [anon_sym_fun] = ACTIONS(3648),
    [anon_sym_try] = ACTIONS(3648),
    [anon_sym_match] = ACTIONS(3648),
    [anon_sym_match_BANG] = ACTIONS(3646),
    [anon_sym_function] = ACTIONS(3648),
    [anon_sym_LT_DASH] = ACTIONS(3648),
    [anon_sym_DOT_LBRACK] = ACTIONS(3646),
    [anon_sym_LT] = ACTIONS(3646),
    [anon_sym_use] = ACTIONS(3648),
    [anon_sym_use_BANG] = ACTIONS(3646),
    [anon_sym_do_BANG] = ACTIONS(3646),
    [anon_sym_begin] = ACTIONS(3648),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_DOT_DOT2] = ACTIONS(3646),
    [anon_sym_or] = ACTIONS(3648),
    [aux_sym_char_token1] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3648),
    [anon_sym_AT_DQUOTE] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [sym_bool] = ACTIONS(3648),
    [sym_unit] = ACTIONS(3646),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3648),
    [sym_op_identifier] = ACTIONS(3648),
    [anon_sym_PLUS] = ACTIONS(3648),
    [anon_sym_DASH] = ACTIONS(3648),
    [anon_sym_PLUS_DOT] = ACTIONS(3648),
    [anon_sym_DASH_DOT] = ACTIONS(3648),
    [anon_sym_PERCENT] = ACTIONS(3648),
    [anon_sym_AMP_AMP] = ACTIONS(3648),
    [anon_sym_TILDE] = ACTIONS(3646),
    [aux_sym_prefix_op_token1] = ACTIONS(3648),
    [aux_sym_infix_op_token1] = ACTIONS(3646),
    [aux_sym_infix_op_token2] = ACTIONS(3648),
    [anon_sym_PIPE_PIPE] = ACTIONS(3648),
    [anon_sym_BANG_EQ] = ACTIONS(3648),
    [anon_sym_COLON_EQ] = ACTIONS(3646),
    [anon_sym_DOLLAR] = ACTIONS(3648),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3648),
    [sym_int] = ACTIONS(3648),
    [sym_xint] = ACTIONS(3646),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3646),
    [sym__newline] = ACTIONS(3646),
  },
  [2291] = {
    [sym_type_arguments] = STATE(2593),
    [sym_long_identifier] = STATE(2612),
    [sym_block_comment] = STATE(2291),
    [sym_compiler_directive_decl] = STATE(2291),
    [sym_fsi_directive_decl] = STATE(2291),
    [sym_preproc_line] = STATE(2291),
    [aux_sym_compound_type_repeat1] = STATE(2437),
    [sym_identifier] = ACTIONS(3443),
    [anon_sym_EQ] = ACTIONS(3441),
    [anon_sym_COLON] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_let] = ACTIONS(3443),
    [anon_sym_let_BANG] = ACTIONS(3441),
    [anon_sym_as] = ACTIONS(3443),
    [anon_sym_LPAREN] = ACTIONS(3443),
    [anon_sym_COMMA] = ACTIONS(3441),
    [anon_sym_null] = ACTIONS(3443),
    [anon_sym_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_LT_AT] = ACTIONS(3443),
    [anon_sym_LT_AT_AT] = ACTIONS(3443),
    [anon_sym_DOT] = ACTIONS(3443),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_with] = ACTIONS(3443),
    [anon_sym_return_BANG] = ACTIONS(3441),
    [anon_sym_yield] = ACTIONS(3443),
    [anon_sym_yield_BANG] = ACTIONS(3441),
    [anon_sym_lazy] = ACTIONS(3443),
    [anon_sym_assert] = ACTIONS(3443),
    [anon_sym_upcast] = ACTIONS(3443),
    [anon_sym_downcast] = ACTIONS(3443),
    [anon_sym_COLON_GT] = ACTIONS(3441),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3441),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_fun] = ACTIONS(3443),
    [anon_sym_DASH_GT] = ACTIONS(4814),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_match] = ACTIONS(3443),
    [anon_sym_match_BANG] = ACTIONS(3441),
    [anon_sym_function] = ACTIONS(3443),
    [anon_sym_LT_DASH] = ACTIONS(3443),
    [anon_sym_DOT_LBRACK] = ACTIONS(3441),
    [anon_sym_LT] = ACTIONS(3441),
    [anon_sym_use] = ACTIONS(3443),
    [anon_sym_use_BANG] = ACTIONS(3441),
    [anon_sym_do_BANG] = ACTIONS(3441),
    [anon_sym_begin] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(4816),
    [anon_sym_LT2] = ACTIONS(4818),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4820),
    [anon_sym_or] = ACTIONS(3443),
    [aux_sym_char_token1] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3443),
    [anon_sym_AT_DQUOTE] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [sym_bool] = ACTIONS(3443),
    [sym_unit] = ACTIONS(3441),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3443),
    [sym_op_identifier] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_PLUS_DOT] = ACTIONS(3443),
    [anon_sym_DASH_DOT] = ACTIONS(3443),
    [anon_sym_PERCENT] = ACTIONS(3443),
    [anon_sym_AMP_AMP] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3441),
    [aux_sym_prefix_op_token1] = ACTIONS(3443),
    [aux_sym_infix_op_token1] = ACTIONS(3441),
    [aux_sym_infix_op_token2] = ACTIONS(3443),
    [anon_sym_PIPE_PIPE] = ACTIONS(3443),
    [anon_sym_BANG_EQ] = ACTIONS(3443),
    [anon_sym_COLON_EQ] = ACTIONS(3441),
    [anon_sym_DOLLAR] = ACTIONS(3443),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3443),
    [sym_int] = ACTIONS(3443),
    [sym_xint] = ACTIONS(3441),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3441),
    [sym__newline] = ACTIONS(3441),
  },
  [2292] = {
    [sym_block_comment] = STATE(2292),
    [sym_compiler_directive_decl] = STATE(2292),
    [sym_fsi_directive_decl] = STATE(2292),
    [sym_preproc_line] = STATE(2292),
    [aux_sym_rules_repeat1] = STATE(2292),
    [ts_builtin_sym_end] = ACTIONS(3741),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_namespace] = ACTIONS(3743),
    [anon_sym_module] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_open] = ACTIONS(3743),
    [anon_sym_LBRACK_LT] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_type] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(4847),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_or] = ACTIONS(3743),
    [anon_sym_exception] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3741),
    [anon_sym_POUNDload] = ACTIONS(3741),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [sym__newline] = ACTIONS(4850),
  },
  [2293] = {
    [sym_block_comment] = STATE(2293),
    [sym_compiler_directive_decl] = STATE(2293),
    [sym_fsi_directive_decl] = STATE(2293),
    [sym_preproc_line] = STATE(2293),
    [ts_builtin_sym_end] = ACTIONS(3602),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_namespace] = ACTIONS(3604),
    [anon_sym_module] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_open] = ACTIONS(3604),
    [anon_sym_LBRACK_LT] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_type] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [anon_sym_exception] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3602),
    [anon_sym_POUNDload] = ACTIONS(3602),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
  },
  [2294] = {
    [sym_block_comment] = STATE(2294),
    [sym_compiler_directive_decl] = STATE(2294),
    [sym_fsi_directive_decl] = STATE(2294),
    [sym_preproc_line] = STATE(2294),
    [ts_builtin_sym_end] = ACTIONS(3683),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_namespace] = ACTIONS(3685),
    [anon_sym_module] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_open] = ACTIONS(3685),
    [anon_sym_LBRACK_LT] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_type] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(4853),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_DOT_DOT] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [anon_sym_exception] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3683),
    [anon_sym_POUNDload] = ACTIONS(3683),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
  },
  [2295] = {
    [sym_block_comment] = STATE(2295),
    [sym_compiler_directive_decl] = STATE(2295),
    [sym_fsi_directive_decl] = STATE(2295),
    [sym_preproc_line] = STATE(2295),
    [aux_sym_rules_repeat1] = STATE(2281),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_GT_RBRACK] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(4822),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_RBRACK] = ACTIONS(3691),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_RBRACE] = ACTIONS(3691),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_with] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_to] = ACTIONS(3693),
    [anon_sym_downto] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_DOT_DOT2] = ACTIONS(3691),
    [anon_sym_or] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(4855),
  },
  [2296] = {
    [sym_block_comment] = STATE(2296),
    [sym_compiler_directive_decl] = STATE(2296),
    [sym_fsi_directive_decl] = STATE(2296),
    [sym_preproc_line] = STATE(2296),
    [aux_sym_rules_repeat1] = STATE(2275),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_GT_RBRACK] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(4822),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_RBRACK] = ACTIONS(3691),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_RBRACE] = ACTIONS(3691),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_with] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_to] = ACTIONS(3693),
    [anon_sym_downto] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_DOT_DOT2] = ACTIONS(3691),
    [anon_sym_or] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(4855),
  },
  [2297] = {
    [sym_block_comment] = STATE(2297),
    [sym_compiler_directive_decl] = STATE(2297),
    [sym_fsi_directive_decl] = STATE(2297),
    [sym_preproc_line] = STATE(2297),
    [sym_identifier] = ACTIONS(3732),
    [anon_sym_EQ] = ACTIONS(3730),
    [anon_sym_GT_RBRACK] = ACTIONS(3730),
    [anon_sym_COLON] = ACTIONS(3732),
    [anon_sym_return] = ACTIONS(3732),
    [anon_sym_do] = ACTIONS(3732),
    [anon_sym_let] = ACTIONS(3732),
    [anon_sym_let_BANG] = ACTIONS(3730),
    [anon_sym_LPAREN] = ACTIONS(3732),
    [anon_sym_COMMA] = ACTIONS(3730),
    [anon_sym_null] = ACTIONS(3732),
    [anon_sym_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_LBRACK] = ACTIONS(3732),
    [anon_sym_RBRACK] = ACTIONS(3730),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3730),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_RBRACE] = ACTIONS(3730),
    [anon_sym_LT_AT] = ACTIONS(3732),
    [anon_sym_LT_AT_AT] = ACTIONS(3732),
    [anon_sym_DOT] = ACTIONS(3732),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3730),
    [anon_sym_new] = ACTIONS(3732),
    [anon_sym_with] = ACTIONS(3732),
    [anon_sym_return_BANG] = ACTIONS(3730),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_yield_BANG] = ACTIONS(3730),
    [anon_sym_lazy] = ACTIONS(3732),
    [anon_sym_assert] = ACTIONS(3732),
    [anon_sym_upcast] = ACTIONS(3732),
    [anon_sym_downcast] = ACTIONS(3732),
    [anon_sym_COLON_GT] = ACTIONS(3730),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3730),
    [anon_sym_for] = ACTIONS(3732),
    [anon_sym_to] = ACTIONS(3732),
    [anon_sym_downto] = ACTIONS(3732),
    [anon_sym_while] = ACTIONS(3732),
    [anon_sym_else] = ACTIONS(3732),
    [anon_sym_elif] = ACTIONS(3732),
    [anon_sym_if] = ACTIONS(3732),
    [anon_sym_fun] = ACTIONS(3732),
    [anon_sym_try] = ACTIONS(3732),
    [anon_sym_match] = ACTIONS(3732),
    [anon_sym_match_BANG] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3732),
    [anon_sym_LT_DASH] = ACTIONS(3732),
    [anon_sym_DOT_LBRACK] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3730),
    [anon_sym_use] = ACTIONS(3732),
    [anon_sym_use_BANG] = ACTIONS(3730),
    [anon_sym_do_BANG] = ACTIONS(3730),
    [anon_sym_begin] = ACTIONS(3732),
    [anon_sym_LPAREN2] = ACTIONS(3732),
    [anon_sym_DOT_DOT2] = ACTIONS(3730),
    [anon_sym_or] = ACTIONS(3732),
    [aux_sym_char_token1] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3732),
    [anon_sym_DQUOTE] = ACTIONS(3732),
    [anon_sym_AT_DQUOTE] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [sym_bool] = ACTIONS(3732),
    [sym_unit] = ACTIONS(3730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3732),
    [sym_op_identifier] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PLUS_DOT] = ACTIONS(3732),
    [anon_sym_DASH_DOT] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3732),
    [anon_sym_AMP_AMP] = ACTIONS(3732),
    [anon_sym_TILDE] = ACTIONS(3730),
    [aux_sym_prefix_op_token1] = ACTIONS(3732),
    [aux_sym_infix_op_token1] = ACTIONS(3730),
    [aux_sym_infix_op_token2] = ACTIONS(3732),
    [anon_sym_PIPE_PIPE] = ACTIONS(3732),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_COLON_EQ] = ACTIONS(3730),
    [anon_sym_DOLLAR] = ACTIONS(3732),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3732),
    [sym_int] = ACTIONS(3732),
    [sym_xint] = ACTIONS(3730),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3730),
    [sym__newline] = ACTIONS(3730),
  },
  [2298] = {
    [sym_block_comment] = STATE(2298),
    [sym_compiler_directive_decl] = STATE(2298),
    [sym_fsi_directive_decl] = STATE(2298),
    [sym_preproc_line] = STATE(2298),
    [sym_identifier] = ACTIONS(3728),
    [anon_sym_EQ] = ACTIONS(3726),
    [anon_sym_GT_RBRACK] = ACTIONS(3726),
    [anon_sym_COLON] = ACTIONS(3728),
    [anon_sym_return] = ACTIONS(3728),
    [anon_sym_do] = ACTIONS(3728),
    [anon_sym_let] = ACTIONS(3728),
    [anon_sym_let_BANG] = ACTIONS(3726),
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_COMMA] = ACTIONS(3726),
    [anon_sym_null] = ACTIONS(3728),
    [anon_sym_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(3726),
    [anon_sym_AMP] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_RBRACK] = ACTIONS(3726),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3726),
    [anon_sym_LBRACE] = ACTIONS(3728),
    [anon_sym_RBRACE] = ACTIONS(3726),
    [anon_sym_LT_AT] = ACTIONS(3728),
    [anon_sym_LT_AT_AT] = ACTIONS(3728),
    [anon_sym_DOT] = ACTIONS(3728),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3726),
    [anon_sym_new] = ACTIONS(3728),
    [anon_sym_with] = ACTIONS(3728),
    [anon_sym_return_BANG] = ACTIONS(3726),
    [anon_sym_yield] = ACTIONS(3728),
    [anon_sym_yield_BANG] = ACTIONS(3726),
    [anon_sym_lazy] = ACTIONS(3728),
    [anon_sym_assert] = ACTIONS(3728),
    [anon_sym_upcast] = ACTIONS(3728),
    [anon_sym_downcast] = ACTIONS(3728),
    [anon_sym_COLON_GT] = ACTIONS(3726),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3726),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_to] = ACTIONS(3728),
    [anon_sym_downto] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_fun] = ACTIONS(3728),
    [anon_sym_try] = ACTIONS(3728),
    [anon_sym_match] = ACTIONS(3728),
    [anon_sym_match_BANG] = ACTIONS(3726),
    [anon_sym_function] = ACTIONS(3728),
    [anon_sym_LT_DASH] = ACTIONS(3728),
    [anon_sym_DOT_LBRACK] = ACTIONS(3726),
    [anon_sym_LT] = ACTIONS(3726),
    [anon_sym_use] = ACTIONS(3728),
    [anon_sym_use_BANG] = ACTIONS(3726),
    [anon_sym_do_BANG] = ACTIONS(3726),
    [anon_sym_begin] = ACTIONS(3728),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_DOT_DOT2] = ACTIONS(3726),
    [anon_sym_or] = ACTIONS(3728),
    [aux_sym_char_token1] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3728),
    [anon_sym_AT_DQUOTE] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [sym_bool] = ACTIONS(3728),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3728),
    [sym_op_identifier] = ACTIONS(3728),
    [anon_sym_PLUS] = ACTIONS(3728),
    [anon_sym_DASH] = ACTIONS(3728),
    [anon_sym_PLUS_DOT] = ACTIONS(3728),
    [anon_sym_DASH_DOT] = ACTIONS(3728),
    [anon_sym_PERCENT] = ACTIONS(3728),
    [anon_sym_AMP_AMP] = ACTIONS(3728),
    [anon_sym_TILDE] = ACTIONS(3726),
    [aux_sym_prefix_op_token1] = ACTIONS(3728),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token2] = ACTIONS(3728),
    [anon_sym_PIPE_PIPE] = ACTIONS(3728),
    [anon_sym_BANG_EQ] = ACTIONS(3728),
    [anon_sym_COLON_EQ] = ACTIONS(3726),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3728),
    [sym_int] = ACTIONS(3728),
    [sym_xint] = ACTIONS(3726),
    [anon_sym_f] = ACTIONS(3728),
    [aux_sym_decimal_token1] = ACTIONS(3728),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3726),
    [sym__newline] = ACTIONS(3726),
  },
  [2299] = {
    [sym_block_comment] = STATE(2299),
    [sym_compiler_directive_decl] = STATE(2299),
    [sym_fsi_directive_decl] = STATE(2299),
    [sym_preproc_line] = STATE(2299),
    [ts_builtin_sym_end] = ACTIONS(3698),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_namespace] = ACTIONS(3700),
    [anon_sym_module] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_open] = ACTIONS(3700),
    [anon_sym_LBRACK_LT] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_type] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_done] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_DOT_DOT] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [anon_sym_exception] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3698),
    [anon_sym_POUNDload] = ACTIONS(3698),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [2300] = {
    [sym_block_comment] = STATE(2300),
    [sym_compiler_directive_decl] = STATE(2300),
    [sym_fsi_directive_decl] = STATE(2300),
    [sym_preproc_line] = STATE(2300),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_GT_RBRACK] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_RBRACK] = ACTIONS(3698),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_RBRACE] = ACTIONS(3698),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_to] = ACTIONS(3700),
    [anon_sym_downto] = ACTIONS(3700),
    [anon_sym_done] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_DOT_DOT] = ACTIONS(3700),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_DOT_DOT2] = ACTIONS(3698),
    [anon_sym_or] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [2301] = {
    [sym_block_comment] = STATE(2301),
    [sym_compiler_directive_decl] = STATE(2301),
    [sym_fsi_directive_decl] = STATE(2301),
    [sym_preproc_line] = STATE(2301),
    [sym_identifier] = ACTIONS(3753),
    [anon_sym_EQ] = ACTIONS(3751),
    [anon_sym_GT_RBRACK] = ACTIONS(3751),
    [anon_sym_COLON] = ACTIONS(3753),
    [anon_sym_return] = ACTIONS(3753),
    [anon_sym_do] = ACTIONS(3753),
    [anon_sym_let] = ACTIONS(3753),
    [anon_sym_let_BANG] = ACTIONS(3751),
    [anon_sym_LPAREN] = ACTIONS(3753),
    [anon_sym_COMMA] = ACTIONS(3751),
    [anon_sym_null] = ACTIONS(3753),
    [anon_sym_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_COLON] = ACTIONS(3751),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_RBRACK] = ACTIONS(3751),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3751),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_RBRACE] = ACTIONS(3751),
    [anon_sym_LT_AT] = ACTIONS(3753),
    [anon_sym_LT_AT_AT] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3753),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3751),
    [anon_sym_new] = ACTIONS(3753),
    [anon_sym_with] = ACTIONS(3753),
    [anon_sym_return_BANG] = ACTIONS(3751),
    [anon_sym_yield] = ACTIONS(3753),
    [anon_sym_yield_BANG] = ACTIONS(3751),
    [anon_sym_lazy] = ACTIONS(3753),
    [anon_sym_assert] = ACTIONS(3753),
    [anon_sym_upcast] = ACTIONS(3753),
    [anon_sym_downcast] = ACTIONS(3753),
    [anon_sym_COLON_GT] = ACTIONS(3751),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3751),
    [anon_sym_for] = ACTIONS(3753),
    [anon_sym_to] = ACTIONS(3753),
    [anon_sym_downto] = ACTIONS(3753),
    [anon_sym_while] = ACTIONS(3753),
    [anon_sym_if] = ACTIONS(3753),
    [anon_sym_fun] = ACTIONS(3753),
    [anon_sym_try] = ACTIONS(3753),
    [anon_sym_match] = ACTIONS(3753),
    [anon_sym_match_BANG] = ACTIONS(3751),
    [anon_sym_function] = ACTIONS(3753),
    [anon_sym_LT_DASH] = ACTIONS(3753),
    [anon_sym_DOT_LBRACK] = ACTIONS(3751),
    [anon_sym_LT] = ACTIONS(3751),
    [anon_sym_use] = ACTIONS(3753),
    [anon_sym_use_BANG] = ACTIONS(3751),
    [anon_sym_do_BANG] = ACTIONS(3751),
    [anon_sym_begin] = ACTIONS(3753),
    [anon_sym_LPAREN2] = ACTIONS(3753),
    [anon_sym_DOT_DOT2] = ACTIONS(3751),
    [anon_sym_or] = ACTIONS(3753),
    [aux_sym_char_token1] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3753),
    [anon_sym_AT_DQUOTE] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [sym_bool] = ACTIONS(3753),
    [sym_unit] = ACTIONS(3751),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3753),
    [sym_op_identifier] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PLUS_DOT] = ACTIONS(3753),
    [anon_sym_DASH_DOT] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3753),
    [anon_sym_AMP_AMP] = ACTIONS(3753),
    [anon_sym_TILDE] = ACTIONS(3751),
    [aux_sym_prefix_op_token1] = ACTIONS(3753),
    [aux_sym_infix_op_token1] = ACTIONS(3751),
    [aux_sym_infix_op_token2] = ACTIONS(3753),
    [anon_sym_PIPE_PIPE] = ACTIONS(3753),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_COLON_EQ] = ACTIONS(3751),
    [anon_sym_DOLLAR] = ACTIONS(3753),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3753),
    [sym_int] = ACTIONS(4858),
    [sym_xint] = ACTIONS(3751),
    [anon_sym_f] = ACTIONS(3753),
    [aux_sym_decimal_token1] = ACTIONS(3753),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3751),
    [sym__newline] = ACTIONS(3751),
  },
  [2302] = {
    [sym_type_arguments] = STATE(2593),
    [sym_long_identifier] = STATE(2612),
    [sym_block_comment] = STATE(2302),
    [sym_compiler_directive_decl] = STATE(2302),
    [sym_fsi_directive_decl] = STATE(2302),
    [sym_preproc_line] = STATE(2302),
    [aux_sym_compound_type_repeat1] = STATE(2437),
    [sym_identifier] = ACTIONS(4812),
    [anon_sym_EQ] = ACTIONS(3403),
    [anon_sym_COLON] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_let_BANG] = ACTIONS(3403),
    [anon_sym_as] = ACTIONS(3407),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_COMMA] = ACTIONS(3403),
    [anon_sym_null] = ACTIONS(3407),
    [anon_sym_QMARK] = ACTIONS(3407),
    [anon_sym_COLON_QMARK] = ACTIONS(3407),
    [anon_sym_COLON_COLON] = ACTIONS(3403),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3407),
    [anon_sym_LT_AT] = ACTIONS(3407),
    [anon_sym_LT_AT_AT] = ACTIONS(3407),
    [anon_sym_DOT] = ACTIONS(3407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_with] = ACTIONS(3407),
    [anon_sym_return_BANG] = ACTIONS(3403),
    [anon_sym_yield] = ACTIONS(3407),
    [anon_sym_yield_BANG] = ACTIONS(3403),
    [anon_sym_lazy] = ACTIONS(3407),
    [anon_sym_assert] = ACTIONS(3407),
    [anon_sym_upcast] = ACTIONS(3407),
    [anon_sym_downcast] = ACTIONS(3407),
    [anon_sym_COLON_GT] = ACTIONS(3403),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_fun] = ACTIONS(3407),
    [anon_sym_DASH_GT] = ACTIONS(4814),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_match] = ACTIONS(3407),
    [anon_sym_match_BANG] = ACTIONS(3403),
    [anon_sym_function] = ACTIONS(3407),
    [anon_sym_LT_DASH] = ACTIONS(3407),
    [anon_sym_DOT_LBRACK] = ACTIONS(3403),
    [anon_sym_LT] = ACTIONS(3403),
    [anon_sym_use] = ACTIONS(3407),
    [anon_sym_use_BANG] = ACTIONS(3403),
    [anon_sym_do_BANG] = ACTIONS(3403),
    [anon_sym_begin] = ACTIONS(3407),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(4816),
    [anon_sym_LT2] = ACTIONS(4818),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4820),
    [anon_sym_or] = ACTIONS(3407),
    [aux_sym_char_token1] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3407),
    [anon_sym_DQUOTE] = ACTIONS(3407),
    [anon_sym_AT_DQUOTE] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [sym_bool] = ACTIONS(3407),
    [sym_unit] = ACTIONS(3403),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3407),
    [sym_op_identifier] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_PLUS_DOT] = ACTIONS(3407),
    [anon_sym_DASH_DOT] = ACTIONS(3407),
    [anon_sym_PERCENT] = ACTIONS(3407),
    [anon_sym_AMP_AMP] = ACTIONS(3407),
    [anon_sym_TILDE] = ACTIONS(3403),
    [aux_sym_prefix_op_token1] = ACTIONS(3407),
    [aux_sym_infix_op_token1] = ACTIONS(3403),
    [aux_sym_infix_op_token2] = ACTIONS(3407),
    [anon_sym_PIPE_PIPE] = ACTIONS(3407),
    [anon_sym_BANG_EQ] = ACTIONS(3407),
    [anon_sym_COLON_EQ] = ACTIONS(3403),
    [anon_sym_DOLLAR] = ACTIONS(3407),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3407),
    [sym_int] = ACTIONS(3407),
    [sym_xint] = ACTIONS(3403),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3403),
    [sym__newline] = ACTIONS(3403),
  },
  [2303] = {
    [sym_type_arguments] = STATE(2702),
    [sym_long_identifier] = STATE(2689),
    [sym_block_comment] = STATE(2303),
    [sym_compiler_directive_decl] = STATE(2303),
    [sym_fsi_directive_decl] = STATE(2303),
    [sym_preproc_line] = STATE(2303),
    [aux_sym_compound_type_repeat1] = STATE(2575),
    [sym_identifier] = ACTIONS(3443),
    [anon_sym_EQ] = ACTIONS(3441),
    [anon_sym_COLON] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_let] = ACTIONS(3443),
    [anon_sym_let_BANG] = ACTIONS(3441),
    [anon_sym_LPAREN] = ACTIONS(3443),
    [anon_sym_COMMA] = ACTIONS(3441),
    [anon_sym_null] = ACTIONS(3443),
    [anon_sym_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_LT_AT] = ACTIONS(3443),
    [anon_sym_LT_AT_AT] = ACTIONS(3443),
    [anon_sym_DOT] = ACTIONS(3443),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_return_BANG] = ACTIONS(3441),
    [anon_sym_yield] = ACTIONS(3443),
    [anon_sym_yield_BANG] = ACTIONS(3441),
    [anon_sym_lazy] = ACTIONS(3443),
    [anon_sym_assert] = ACTIONS(3443),
    [anon_sym_upcast] = ACTIONS(3443),
    [anon_sym_downcast] = ACTIONS(3443),
    [anon_sym_COLON_GT] = ACTIONS(3441),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3441),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_fun] = ACTIONS(3443),
    [anon_sym_DASH_GT] = ACTIONS(3443),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_match] = ACTIONS(3443),
    [anon_sym_match_BANG] = ACTIONS(3441),
    [anon_sym_function] = ACTIONS(3443),
    [anon_sym_LT_DASH] = ACTIONS(3443),
    [anon_sym_DOT_LBRACK] = ACTIONS(3441),
    [anon_sym_LT] = ACTIONS(3441),
    [anon_sym_use] = ACTIONS(3443),
    [anon_sym_use_BANG] = ACTIONS(3441),
    [anon_sym_do_BANG] = ACTIONS(3441),
    [anon_sym_DOT_DOT] = ACTIONS(3441),
    [anon_sym_begin] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(4860),
    [anon_sym_LT2] = ACTIONS(4862),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4864),
    [anon_sym_or] = ACTIONS(3443),
    [aux_sym_char_token1] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3443),
    [anon_sym_AT_DQUOTE] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [sym_bool] = ACTIONS(3443),
    [sym_unit] = ACTIONS(3441),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3443),
    [sym_op_identifier] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_PLUS_DOT] = ACTIONS(3443),
    [anon_sym_DASH_DOT] = ACTIONS(3443),
    [anon_sym_PERCENT] = ACTIONS(3443),
    [anon_sym_AMP_AMP] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3441),
    [aux_sym_prefix_op_token1] = ACTIONS(3443),
    [aux_sym_infix_op_token1] = ACTIONS(3441),
    [aux_sym_infix_op_token2] = ACTIONS(3443),
    [anon_sym_PIPE_PIPE] = ACTIONS(3443),
    [anon_sym_BANG_EQ] = ACTIONS(3443),
    [anon_sym_COLON_EQ] = ACTIONS(3441),
    [anon_sym_DOLLAR] = ACTIONS(3443),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3443),
    [sym_int] = ACTIONS(3443),
    [sym_xint] = ACTIONS(3441),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3441),
    [sym__newline] = ACTIONS(3441),
  },
  [2304] = {
    [sym_block_comment] = STATE(2304),
    [sym_compiler_directive_decl] = STATE(2304),
    [sym_fsi_directive_decl] = STATE(2304),
    [sym_preproc_line] = STATE(2304),
    [ts_builtin_sym_end] = ACTIONS(3811),
    [sym_identifier] = ACTIONS(3813),
    [anon_sym_namespace] = ACTIONS(3813),
    [anon_sym_module] = ACTIONS(3813),
    [anon_sym_EQ] = ACTIONS(3811),
    [anon_sym_open] = ACTIONS(3813),
    [anon_sym_LBRACK_LT] = ACTIONS(3811),
    [anon_sym_COLON] = ACTIONS(3813),
    [anon_sym_return] = ACTIONS(3813),
    [anon_sym_type] = ACTIONS(3813),
    [anon_sym_do] = ACTIONS(3813),
    [anon_sym_let] = ACTIONS(3813),
    [anon_sym_let_BANG] = ACTIONS(3811),
    [anon_sym_LPAREN] = ACTIONS(3813),
    [anon_sym_COMMA] = ACTIONS(3811),
    [anon_sym_null] = ACTIONS(3813),
    [anon_sym_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_COLON] = ACTIONS(3811),
    [anon_sym_AMP] = ACTIONS(3813),
    [anon_sym_LBRACK] = ACTIONS(3813),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3811),
    [anon_sym_LBRACE] = ACTIONS(3813),
    [anon_sym_LT_AT] = ACTIONS(3813),
    [anon_sym_LT_AT_AT] = ACTIONS(3813),
    [anon_sym_DOT] = ACTIONS(3813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3811),
    [anon_sym_new] = ACTIONS(3813),
    [anon_sym_return_BANG] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_yield_BANG] = ACTIONS(3811),
    [anon_sym_lazy] = ACTIONS(3813),
    [anon_sym_assert] = ACTIONS(3813),
    [anon_sym_upcast] = ACTIONS(3813),
    [anon_sym_downcast] = ACTIONS(3813),
    [anon_sym_COLON_GT] = ACTIONS(3811),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3811),
    [anon_sym_for] = ACTIONS(3813),
    [anon_sym_done] = ACTIONS(4866),
    [anon_sym_while] = ACTIONS(3813),
    [anon_sym_if] = ACTIONS(3813),
    [anon_sym_fun] = ACTIONS(3813),
    [anon_sym_try] = ACTIONS(3813),
    [anon_sym_match] = ACTIONS(3813),
    [anon_sym_match_BANG] = ACTIONS(3811),
    [anon_sym_function] = ACTIONS(3813),
    [anon_sym_LT_DASH] = ACTIONS(3813),
    [anon_sym_DOT_LBRACK] = ACTIONS(3811),
    [anon_sym_LT] = ACTIONS(3811),
    [anon_sym_use] = ACTIONS(3813),
    [anon_sym_use_BANG] = ACTIONS(3811),
    [anon_sym_do_BANG] = ACTIONS(3811),
    [anon_sym_begin] = ACTIONS(3813),
    [anon_sym_LPAREN2] = ACTIONS(3813),
    [anon_sym_or] = ACTIONS(3813),
    [anon_sym_exception] = ACTIONS(3813),
    [aux_sym_char_token1] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3813),
    [anon_sym_DQUOTE] = ACTIONS(3813),
    [anon_sym_AT_DQUOTE] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [sym_bool] = ACTIONS(3813),
    [sym_unit] = ACTIONS(3811),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3813),
    [sym_op_identifier] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PLUS_DOT] = ACTIONS(3813),
    [anon_sym_DASH_DOT] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3813),
    [anon_sym_AMP_AMP] = ACTIONS(3813),
    [anon_sym_TILDE] = ACTIONS(3811),
    [aux_sym_prefix_op_token1] = ACTIONS(3813),
    [aux_sym_infix_op_token1] = ACTIONS(3811),
    [aux_sym_infix_op_token2] = ACTIONS(3813),
    [anon_sym_PIPE_PIPE] = ACTIONS(3813),
    [anon_sym_BANG_EQ] = ACTIONS(3813),
    [anon_sym_COLON_EQ] = ACTIONS(3811),
    [anon_sym_DOLLAR] = ACTIONS(3813),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3813),
    [sym_int] = ACTIONS(3813),
    [sym_xint] = ACTIONS(3811),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3811),
    [anon_sym_POUNDload] = ACTIONS(3811),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3811),
    [sym__newline] = ACTIONS(3811),
  },
  [2305] = {
    [sym_block_comment] = STATE(2305),
    [sym_compiler_directive_decl] = STATE(2305),
    [sym_fsi_directive_decl] = STATE(2305),
    [sym_preproc_line] = STATE(2305),
    [aux_sym_long_identifier_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_EQ] = ACTIONS(3492),
    [anon_sym_COLON] = ACTIONS(3494),
    [anon_sym_return] = ACTIONS(3494),
    [anon_sym_do] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_let_BANG] = ACTIONS(3492),
    [anon_sym_as] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(3494),
    [anon_sym_COMMA] = ACTIONS(3492),
    [anon_sym_null] = ACTIONS(3494),
    [anon_sym_QMARK] = ACTIONS(3494),
    [anon_sym_COLON_QMARK] = ACTIONS(3494),
    [anon_sym_COLON_COLON] = ACTIONS(3492),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3492),
    [anon_sym_LBRACE] = ACTIONS(3494),
    [anon_sym_LT_AT] = ACTIONS(3494),
    [anon_sym_LT_AT_AT] = ACTIONS(3494),
    [anon_sym_DOT] = ACTIONS(4868),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3492),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_with] = ACTIONS(3494),
    [anon_sym_return_BANG] = ACTIONS(3492),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_yield_BANG] = ACTIONS(3492),
    [anon_sym_lazy] = ACTIONS(3494),
    [anon_sym_assert] = ACTIONS(3494),
    [anon_sym_upcast] = ACTIONS(3494),
    [anon_sym_downcast] = ACTIONS(3494),
    [anon_sym_COLON_GT] = ACTIONS(3492),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3492),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_while] = ACTIONS(3494),
    [anon_sym_if] = ACTIONS(3494),
    [anon_sym_fun] = ACTIONS(3494),
    [anon_sym_DASH_GT] = ACTIONS(3494),
    [anon_sym_try] = ACTIONS(3494),
    [anon_sym_match] = ACTIONS(3494),
    [anon_sym_match_BANG] = ACTIONS(3492),
    [anon_sym_function] = ACTIONS(3494),
    [anon_sym_LT_DASH] = ACTIONS(3494),
    [anon_sym_DOT_LBRACK] = ACTIONS(3492),
    [anon_sym_LT] = ACTIONS(3492),
    [anon_sym_use] = ACTIONS(3494),
    [anon_sym_use_BANG] = ACTIONS(3492),
    [anon_sym_do_BANG] = ACTIONS(3492),
    [anon_sym_begin] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(3494),
    [anon_sym_STAR] = ACTIONS(3494),
    [anon_sym_LT2] = ACTIONS(3494),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3492),
    [anon_sym_or] = ACTIONS(3494),
    [aux_sym_char_token1] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3494),
    [anon_sym_DQUOTE] = ACTIONS(3494),
    [anon_sym_AT_DQUOTE] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [sym_bool] = ACTIONS(3494),
    [sym_unit] = ACTIONS(3492),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3494),
    [sym_op_identifier] = ACTIONS(3494),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_PLUS_DOT] = ACTIONS(3494),
    [anon_sym_DASH_DOT] = ACTIONS(3494),
    [anon_sym_PERCENT] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_TILDE] = ACTIONS(3492),
    [aux_sym_prefix_op_token1] = ACTIONS(3494),
    [aux_sym_infix_op_token1] = ACTIONS(3492),
    [aux_sym_infix_op_token2] = ACTIONS(3494),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_COLON_EQ] = ACTIONS(3492),
    [anon_sym_DOLLAR] = ACTIONS(3494),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3494),
    [sym_int] = ACTIONS(3494),
    [sym_xint] = ACTIONS(3492),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3492),
    [sym__newline] = ACTIONS(3492),
    [sym__dedent] = ACTIONS(3492),
  },
  [2306] = {
    [sym_type_arguments] = STATE(2702),
    [sym_long_identifier] = STATE(2689),
    [sym_block_comment] = STATE(2306),
    [sym_compiler_directive_decl] = STATE(2306),
    [sym_fsi_directive_decl] = STATE(2306),
    [sym_preproc_line] = STATE(2306),
    [aux_sym_compound_type_repeat1] = STATE(2575),
    [sym_identifier] = ACTIONS(4870),
    [anon_sym_EQ] = ACTIONS(3403),
    [anon_sym_COLON] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_let_BANG] = ACTIONS(3403),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_COMMA] = ACTIONS(3403),
    [anon_sym_null] = ACTIONS(3407),
    [anon_sym_QMARK] = ACTIONS(3407),
    [anon_sym_COLON_QMARK] = ACTIONS(3407),
    [anon_sym_COLON_COLON] = ACTIONS(3403),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3407),
    [anon_sym_LT_AT] = ACTIONS(3407),
    [anon_sym_LT_AT_AT] = ACTIONS(3407),
    [anon_sym_DOT] = ACTIONS(3407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_return_BANG] = ACTIONS(3403),
    [anon_sym_yield] = ACTIONS(3407),
    [anon_sym_yield_BANG] = ACTIONS(3403),
    [anon_sym_lazy] = ACTIONS(3407),
    [anon_sym_assert] = ACTIONS(3407),
    [anon_sym_upcast] = ACTIONS(3407),
    [anon_sym_downcast] = ACTIONS(3407),
    [anon_sym_COLON_GT] = ACTIONS(3403),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_fun] = ACTIONS(3407),
    [anon_sym_DASH_GT] = ACTIONS(4872),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_match] = ACTIONS(3407),
    [anon_sym_match_BANG] = ACTIONS(3403),
    [anon_sym_function] = ACTIONS(3407),
    [anon_sym_LT_DASH] = ACTIONS(3407),
    [anon_sym_DOT_LBRACK] = ACTIONS(3403),
    [anon_sym_LT] = ACTIONS(3403),
    [anon_sym_use] = ACTIONS(3407),
    [anon_sym_use_BANG] = ACTIONS(3403),
    [anon_sym_do_BANG] = ACTIONS(3403),
    [anon_sym_DOT_DOT] = ACTIONS(3403),
    [anon_sym_begin] = ACTIONS(3407),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(4860),
    [anon_sym_LT2] = ACTIONS(4862),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4864),
    [anon_sym_or] = ACTIONS(3407),
    [aux_sym_char_token1] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3407),
    [anon_sym_DQUOTE] = ACTIONS(3407),
    [anon_sym_AT_DQUOTE] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [sym_bool] = ACTIONS(3407),
    [sym_unit] = ACTIONS(3403),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3407),
    [sym_op_identifier] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_PLUS_DOT] = ACTIONS(3407),
    [anon_sym_DASH_DOT] = ACTIONS(3407),
    [anon_sym_PERCENT] = ACTIONS(3407),
    [anon_sym_AMP_AMP] = ACTIONS(3407),
    [anon_sym_TILDE] = ACTIONS(3403),
    [aux_sym_prefix_op_token1] = ACTIONS(3407),
    [aux_sym_infix_op_token1] = ACTIONS(3403),
    [aux_sym_infix_op_token2] = ACTIONS(3407),
    [anon_sym_PIPE_PIPE] = ACTIONS(3407),
    [anon_sym_BANG_EQ] = ACTIONS(3407),
    [anon_sym_COLON_EQ] = ACTIONS(3403),
    [anon_sym_DOLLAR] = ACTIONS(3407),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3407),
    [sym_int] = ACTIONS(3407),
    [sym_xint] = ACTIONS(3403),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3403),
    [sym__newline] = ACTIONS(3403),
  },
  [2307] = {
    [sym_type_arguments] = STATE(2692),
    [sym_long_identifier] = STATE(2683),
    [sym_block_comment] = STATE(2307),
    [sym_compiler_directive_decl] = STATE(2307),
    [sym_fsi_directive_decl] = STATE(2307),
    [sym_preproc_line] = STATE(2307),
    [aux_sym_compound_type_repeat1] = STATE(2563),
    [sym_identifier] = ACTIONS(4874),
    [anon_sym_EQ] = ACTIONS(3429),
    [anon_sym_COLON] = ACTIONS(3431),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_let] = ACTIONS(3431),
    [anon_sym_let_BANG] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(3431),
    [anon_sym_COMMA] = ACTIONS(3429),
    [anon_sym_null] = ACTIONS(3431),
    [anon_sym_QMARK] = ACTIONS(3431),
    [anon_sym_COLON_QMARK] = ACTIONS(3431),
    [anon_sym_COLON_COLON] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_LT_AT] = ACTIONS(3431),
    [anon_sym_LT_AT_AT] = ACTIONS(3431),
    [anon_sym_DOT] = ACTIONS(3431),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_return_BANG] = ACTIONS(3429),
    [anon_sym_yield] = ACTIONS(3431),
    [anon_sym_yield_BANG] = ACTIONS(3429),
    [anon_sym_lazy] = ACTIONS(3431),
    [anon_sym_assert] = ACTIONS(3431),
    [anon_sym_upcast] = ACTIONS(3431),
    [anon_sym_downcast] = ACTIONS(3431),
    [anon_sym_COLON_GT] = ACTIONS(3429),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_fun] = ACTIONS(3431),
    [anon_sym_DASH_GT] = ACTIONS(4876),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_match] = ACTIONS(3431),
    [anon_sym_match_BANG] = ACTIONS(3429),
    [anon_sym_function] = ACTIONS(3431),
    [anon_sym_LT_DASH] = ACTIONS(3431),
    [anon_sym_DOT_LBRACK] = ACTIONS(3429),
    [anon_sym_LT] = ACTIONS(3429),
    [anon_sym_GT] = ACTIONS(3431),
    [anon_sym_use] = ACTIONS(3431),
    [anon_sym_use_BANG] = ACTIONS(3429),
    [anon_sym_do_BANG] = ACTIONS(3429),
    [anon_sym_begin] = ACTIONS(3431),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(4878),
    [anon_sym_LT2] = ACTIONS(4880),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4882),
    [anon_sym_or] = ACTIONS(3431),
    [aux_sym_char_token1] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [anon_sym_AT_DQUOTE] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [sym_bool] = ACTIONS(3431),
    [sym_unit] = ACTIONS(3429),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3431),
    [sym_op_identifier] = ACTIONS(3431),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_DOT] = ACTIONS(3431),
    [anon_sym_DASH_DOT] = ACTIONS(3431),
    [anon_sym_PERCENT] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3429),
    [aux_sym_prefix_op_token1] = ACTIONS(3431),
    [aux_sym_infix_op_token1] = ACTIONS(3429),
    [aux_sym_infix_op_token2] = ACTIONS(3431),
    [anon_sym_PIPE_PIPE] = ACTIONS(3431),
    [anon_sym_BANG_EQ] = ACTIONS(3431),
    [anon_sym_COLON_EQ] = ACTIONS(3429),
    [anon_sym_DOLLAR] = ACTIONS(3431),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3431),
    [sym_int] = ACTIONS(3431),
    [sym_xint] = ACTIONS(3429),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3429),
    [sym__newline] = ACTIONS(3429),
  },
  [2308] = {
    [sym_type_arguments] = STATE(2702),
    [sym_long_identifier] = STATE(2689),
    [sym_block_comment] = STATE(2308),
    [sym_compiler_directive_decl] = STATE(2308),
    [sym_fsi_directive_decl] = STATE(2308),
    [sym_preproc_line] = STATE(2308),
    [aux_sym_compound_type_repeat1] = STATE(2575),
    [sym_identifier] = ACTIONS(4870),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3427),
    [anon_sym_DOT] = ACTIONS(3427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_COLON_GT] = ACTIONS(3425),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(4872),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_LT_DASH] = ACTIONS(3427),
    [anon_sym_DOT_LBRACK] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_DOT_DOT] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(4860),
    [anon_sym_LT2] = ACTIONS(4862),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4864),
    [anon_sym_or] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3427),
    [anon_sym_DASH_DOT] = ACTIONS(3427),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3427),
    [aux_sym_infix_op_token1] = ACTIONS(3425),
    [aux_sym_infix_op_token2] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3427),
    [anon_sym_COLON_EQ] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3427),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
  },
  [2309] = {
    [sym_type_arguments] = STATE(2692),
    [sym_long_identifier] = STATE(2683),
    [sym_block_comment] = STATE(2309),
    [sym_compiler_directive_decl] = STATE(2309),
    [sym_fsi_directive_decl] = STATE(2309),
    [sym_preproc_line] = STATE(2309),
    [aux_sym_compound_type_repeat1] = STATE(2563),
    [sym_identifier] = ACTIONS(4874),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3427),
    [anon_sym_DOT] = ACTIONS(3427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_COLON_GT] = ACTIONS(3425),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(4876),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_LT_DASH] = ACTIONS(3427),
    [anon_sym_DOT_LBRACK] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_GT] = ACTIONS(3427),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(4878),
    [anon_sym_LT2] = ACTIONS(4880),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4882),
    [anon_sym_or] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3427),
    [anon_sym_DASH_DOT] = ACTIONS(3427),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3427),
    [aux_sym_infix_op_token1] = ACTIONS(3425),
    [aux_sym_infix_op_token2] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3427),
    [anon_sym_COLON_EQ] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3427),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
  },
  [2310] = {
    [sym_type_arguments] = STATE(2692),
    [sym_long_identifier] = STATE(2683),
    [sym_block_comment] = STATE(2310),
    [sym_compiler_directive_decl] = STATE(2310),
    [sym_fsi_directive_decl] = STATE(2310),
    [sym_preproc_line] = STATE(2310),
    [aux_sym_compound_type_repeat1] = STATE(2563),
    [sym_identifier] = ACTIONS(4874),
    [anon_sym_EQ] = ACTIONS(3403),
    [anon_sym_COLON] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_let_BANG] = ACTIONS(3403),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_COMMA] = ACTIONS(3403),
    [anon_sym_null] = ACTIONS(3407),
    [anon_sym_QMARK] = ACTIONS(3407),
    [anon_sym_COLON_QMARK] = ACTIONS(3407),
    [anon_sym_COLON_COLON] = ACTIONS(3403),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3407),
    [anon_sym_LT_AT] = ACTIONS(3407),
    [anon_sym_LT_AT_AT] = ACTIONS(3407),
    [anon_sym_DOT] = ACTIONS(3407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_return_BANG] = ACTIONS(3403),
    [anon_sym_yield] = ACTIONS(3407),
    [anon_sym_yield_BANG] = ACTIONS(3403),
    [anon_sym_lazy] = ACTIONS(3407),
    [anon_sym_assert] = ACTIONS(3407),
    [anon_sym_upcast] = ACTIONS(3407),
    [anon_sym_downcast] = ACTIONS(3407),
    [anon_sym_COLON_GT] = ACTIONS(3403),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_fun] = ACTIONS(3407),
    [anon_sym_DASH_GT] = ACTIONS(4876),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_match] = ACTIONS(3407),
    [anon_sym_match_BANG] = ACTIONS(3403),
    [anon_sym_function] = ACTIONS(3407),
    [anon_sym_LT_DASH] = ACTIONS(3407),
    [anon_sym_DOT_LBRACK] = ACTIONS(3403),
    [anon_sym_LT] = ACTIONS(3403),
    [anon_sym_GT] = ACTIONS(3407),
    [anon_sym_use] = ACTIONS(3407),
    [anon_sym_use_BANG] = ACTIONS(3403),
    [anon_sym_do_BANG] = ACTIONS(3403),
    [anon_sym_begin] = ACTIONS(3407),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(4878),
    [anon_sym_LT2] = ACTIONS(4880),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4882),
    [anon_sym_or] = ACTIONS(3407),
    [aux_sym_char_token1] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3407),
    [anon_sym_DQUOTE] = ACTIONS(3407),
    [anon_sym_AT_DQUOTE] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [sym_bool] = ACTIONS(3407),
    [sym_unit] = ACTIONS(3403),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3407),
    [sym_op_identifier] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_PLUS_DOT] = ACTIONS(3407),
    [anon_sym_DASH_DOT] = ACTIONS(3407),
    [anon_sym_PERCENT] = ACTIONS(3407),
    [anon_sym_AMP_AMP] = ACTIONS(3407),
    [anon_sym_TILDE] = ACTIONS(3403),
    [aux_sym_prefix_op_token1] = ACTIONS(3407),
    [aux_sym_infix_op_token1] = ACTIONS(3403),
    [aux_sym_infix_op_token2] = ACTIONS(3407),
    [anon_sym_PIPE_PIPE] = ACTIONS(3407),
    [anon_sym_BANG_EQ] = ACTIONS(3407),
    [anon_sym_COLON_EQ] = ACTIONS(3403),
    [anon_sym_DOLLAR] = ACTIONS(3407),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3407),
    [sym_int] = ACTIONS(3407),
    [sym_xint] = ACTIONS(3403),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3403),
    [sym__newline] = ACTIONS(3403),
  },
  [2311] = {
    [sym_type_arguments] = STATE(2702),
    [sym_long_identifier] = STATE(2689),
    [sym_block_comment] = STATE(2311),
    [sym_compiler_directive_decl] = STATE(2311),
    [sym_fsi_directive_decl] = STATE(2311),
    [sym_preproc_line] = STATE(2311),
    [aux_sym_compound_type_repeat1] = STATE(2575),
    [sym_identifier] = ACTIONS(4870),
    [anon_sym_EQ] = ACTIONS(3429),
    [anon_sym_COLON] = ACTIONS(3431),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_let] = ACTIONS(3431),
    [anon_sym_let_BANG] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(3431),
    [anon_sym_COMMA] = ACTIONS(3429),
    [anon_sym_null] = ACTIONS(3431),
    [anon_sym_QMARK] = ACTIONS(3431),
    [anon_sym_COLON_QMARK] = ACTIONS(3431),
    [anon_sym_COLON_COLON] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_LT_AT] = ACTIONS(3431),
    [anon_sym_LT_AT_AT] = ACTIONS(3431),
    [anon_sym_DOT] = ACTIONS(3431),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_return_BANG] = ACTIONS(3429),
    [anon_sym_yield] = ACTIONS(3431),
    [anon_sym_yield_BANG] = ACTIONS(3429),
    [anon_sym_lazy] = ACTIONS(3431),
    [anon_sym_assert] = ACTIONS(3431),
    [anon_sym_upcast] = ACTIONS(3431),
    [anon_sym_downcast] = ACTIONS(3431),
    [anon_sym_COLON_GT] = ACTIONS(3429),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_fun] = ACTIONS(3431),
    [anon_sym_DASH_GT] = ACTIONS(4872),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_match] = ACTIONS(3431),
    [anon_sym_match_BANG] = ACTIONS(3429),
    [anon_sym_function] = ACTIONS(3431),
    [anon_sym_LT_DASH] = ACTIONS(3431),
    [anon_sym_DOT_LBRACK] = ACTIONS(3429),
    [anon_sym_LT] = ACTIONS(3429),
    [anon_sym_use] = ACTIONS(3431),
    [anon_sym_use_BANG] = ACTIONS(3429),
    [anon_sym_do_BANG] = ACTIONS(3429),
    [anon_sym_DOT_DOT] = ACTIONS(3429),
    [anon_sym_begin] = ACTIONS(3431),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(4860),
    [anon_sym_LT2] = ACTIONS(4862),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4864),
    [anon_sym_or] = ACTIONS(3431),
    [aux_sym_char_token1] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [anon_sym_AT_DQUOTE] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [sym_bool] = ACTIONS(3431),
    [sym_unit] = ACTIONS(3429),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3431),
    [sym_op_identifier] = ACTIONS(3431),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_DOT] = ACTIONS(3431),
    [anon_sym_DASH_DOT] = ACTIONS(3431),
    [anon_sym_PERCENT] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3429),
    [aux_sym_prefix_op_token1] = ACTIONS(3431),
    [aux_sym_infix_op_token1] = ACTIONS(3429),
    [aux_sym_infix_op_token2] = ACTIONS(3431),
    [anon_sym_PIPE_PIPE] = ACTIONS(3431),
    [anon_sym_BANG_EQ] = ACTIONS(3431),
    [anon_sym_COLON_EQ] = ACTIONS(3429),
    [anon_sym_DOLLAR] = ACTIONS(3431),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3431),
    [sym_int] = ACTIONS(3431),
    [sym_xint] = ACTIONS(3429),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3429),
    [sym__newline] = ACTIONS(3429),
  },
  [2312] = {
    [sym_block_comment] = STATE(2312),
    [sym_compiler_directive_decl] = STATE(2312),
    [sym_fsi_directive_decl] = STATE(2312),
    [sym_preproc_line] = STATE(2312),
    [ts_builtin_sym_end] = ACTIONS(3698),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_namespace] = ACTIONS(3700),
    [anon_sym_module] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_open] = ACTIONS(3700),
    [anon_sym_LBRACK_LT] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_type] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [anon_sym_exception] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3698),
    [anon_sym_POUNDload] = ACTIONS(3698),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [2313] = {
    [sym_block_comment] = STATE(2313),
    [sym_compiler_directive_decl] = STATE(2313),
    [sym_fsi_directive_decl] = STATE(2313),
    [sym_preproc_line] = STATE(2313),
    [ts_builtin_sym_end] = ACTIONS(3839),
    [sym_identifier] = ACTIONS(3841),
    [anon_sym_namespace] = ACTIONS(3841),
    [anon_sym_module] = ACTIONS(3841),
    [anon_sym_EQ] = ACTIONS(3839),
    [anon_sym_open] = ACTIONS(3841),
    [anon_sym_LBRACK_LT] = ACTIONS(3839),
    [anon_sym_COLON] = ACTIONS(3841),
    [anon_sym_return] = ACTIONS(3841),
    [anon_sym_type] = ACTIONS(3841),
    [anon_sym_do] = ACTIONS(3841),
    [anon_sym_let] = ACTIONS(3841),
    [anon_sym_let_BANG] = ACTIONS(3839),
    [anon_sym_LPAREN] = ACTIONS(3841),
    [anon_sym_COMMA] = ACTIONS(3839),
    [anon_sym_null] = ACTIONS(3841),
    [anon_sym_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_COLON] = ACTIONS(3839),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_AMP] = ACTIONS(3841),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(3841),
    [anon_sym_LT_AT] = ACTIONS(3841),
    [anon_sym_LT_AT_AT] = ACTIONS(3841),
    [anon_sym_DOT] = ACTIONS(3841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3839),
    [anon_sym_new] = ACTIONS(3841),
    [anon_sym_return_BANG] = ACTIONS(3839),
    [anon_sym_yield] = ACTIONS(3841),
    [anon_sym_yield_BANG] = ACTIONS(3839),
    [anon_sym_lazy] = ACTIONS(3841),
    [anon_sym_assert] = ACTIONS(3841),
    [anon_sym_upcast] = ACTIONS(3841),
    [anon_sym_downcast] = ACTIONS(3841),
    [anon_sym_COLON_GT] = ACTIONS(3839),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3839),
    [anon_sym_for] = ACTIONS(3841),
    [anon_sym_while] = ACTIONS(3841),
    [anon_sym_if] = ACTIONS(3841),
    [anon_sym_fun] = ACTIONS(3841),
    [anon_sym_try] = ACTIONS(3841),
    [anon_sym_match] = ACTIONS(3841),
    [anon_sym_match_BANG] = ACTIONS(3839),
    [anon_sym_function] = ACTIONS(3841),
    [anon_sym_LT_DASH] = ACTIONS(3841),
    [anon_sym_DOT_LBRACK] = ACTIONS(3839),
    [anon_sym_LT] = ACTIONS(3839),
    [anon_sym_use] = ACTIONS(3841),
    [anon_sym_use_BANG] = ACTIONS(3839),
    [anon_sym_do_BANG] = ACTIONS(3839),
    [anon_sym_begin] = ACTIONS(3841),
    [anon_sym_LPAREN2] = ACTIONS(3841),
    [anon_sym_or] = ACTIONS(3841),
    [anon_sym_exception] = ACTIONS(3841),
    [aux_sym_char_token1] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3841),
    [anon_sym_DQUOTE] = ACTIONS(3841),
    [anon_sym_AT_DQUOTE] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [sym_bool] = ACTIONS(3841),
    [sym_unit] = ACTIONS(3839),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3841),
    [sym_op_identifier] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_PLUS_DOT] = ACTIONS(3841),
    [anon_sym_DASH_DOT] = ACTIONS(3841),
    [anon_sym_PERCENT] = ACTIONS(3841),
    [anon_sym_AMP_AMP] = ACTIONS(3841),
    [anon_sym_TILDE] = ACTIONS(3839),
    [aux_sym_prefix_op_token1] = ACTIONS(3841),
    [aux_sym_infix_op_token1] = ACTIONS(3839),
    [aux_sym_infix_op_token2] = ACTIONS(3841),
    [anon_sym_PIPE_PIPE] = ACTIONS(3841),
    [anon_sym_BANG_EQ] = ACTIONS(3841),
    [anon_sym_COLON_EQ] = ACTIONS(3839),
    [anon_sym_DOLLAR] = ACTIONS(3841),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3841),
    [sym_int] = ACTIONS(3841),
    [sym_xint] = ACTIONS(3839),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3839),
    [anon_sym_POUNDload] = ACTIONS(3839),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3839),
    [sym__newline] = ACTIONS(3839),
  },
  [2314] = {
    [sym_block_comment] = STATE(2314),
    [sym_compiler_directive_decl] = STATE(2314),
    [sym_fsi_directive_decl] = STATE(2314),
    [sym_preproc_line] = STATE(2314),
    [aux_sym_long_identifier_repeat1] = STATE(2353),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_GT_RBRACK] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_RBRACK] = ACTIONS(3449),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_RBRACE] = ACTIONS(3449),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(4884),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_to] = ACTIONS(3451),
    [anon_sym_downto] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_DOT_DOT2] = ACTIONS(3449),
    [anon_sym_or] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
  },
  [2315] = {
    [sym_block_comment] = STATE(2315),
    [sym_compiler_directive_decl] = STATE(2315),
    [sym_fsi_directive_decl] = STATE(2315),
    [sym_preproc_line] = STATE(2315),
    [sym_identifier] = ACTIONS(3841),
    [anon_sym_EQ] = ACTIONS(3839),
    [anon_sym_GT_RBRACK] = ACTIONS(3839),
    [anon_sym_COLON] = ACTIONS(3841),
    [anon_sym_return] = ACTIONS(3841),
    [anon_sym_do] = ACTIONS(3841),
    [anon_sym_let] = ACTIONS(3841),
    [anon_sym_let_BANG] = ACTIONS(3839),
    [anon_sym_LPAREN] = ACTIONS(3841),
    [anon_sym_COMMA] = ACTIONS(3839),
    [anon_sym_null] = ACTIONS(3841),
    [anon_sym_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_COLON] = ACTIONS(3839),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_AMP] = ACTIONS(3841),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_RBRACK] = ACTIONS(3839),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(3841),
    [anon_sym_RBRACE] = ACTIONS(3839),
    [anon_sym_LT_AT] = ACTIONS(3841),
    [anon_sym_LT_AT_AT] = ACTIONS(3841),
    [anon_sym_DOT] = ACTIONS(3841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3839),
    [anon_sym_new] = ACTIONS(3841),
    [anon_sym_with] = ACTIONS(3841),
    [anon_sym_return_BANG] = ACTIONS(3839),
    [anon_sym_yield] = ACTIONS(3841),
    [anon_sym_yield_BANG] = ACTIONS(3839),
    [anon_sym_lazy] = ACTIONS(3841),
    [anon_sym_assert] = ACTIONS(3841),
    [anon_sym_upcast] = ACTIONS(3841),
    [anon_sym_downcast] = ACTIONS(3841),
    [anon_sym_COLON_GT] = ACTIONS(3839),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3839),
    [anon_sym_for] = ACTIONS(3841),
    [anon_sym_to] = ACTIONS(3841),
    [anon_sym_downto] = ACTIONS(3841),
    [anon_sym_while] = ACTIONS(3841),
    [anon_sym_if] = ACTIONS(3841),
    [anon_sym_fun] = ACTIONS(3841),
    [anon_sym_try] = ACTIONS(3841),
    [anon_sym_match] = ACTIONS(3841),
    [anon_sym_match_BANG] = ACTIONS(3839),
    [anon_sym_function] = ACTIONS(3841),
    [anon_sym_LT_DASH] = ACTIONS(3841),
    [anon_sym_DOT_LBRACK] = ACTIONS(3839),
    [anon_sym_LT] = ACTIONS(3839),
    [anon_sym_use] = ACTIONS(3841),
    [anon_sym_use_BANG] = ACTIONS(3839),
    [anon_sym_do_BANG] = ACTIONS(3839),
    [anon_sym_begin] = ACTIONS(3841),
    [anon_sym_LPAREN2] = ACTIONS(3841),
    [anon_sym_DOT_DOT2] = ACTIONS(3839),
    [anon_sym_or] = ACTIONS(3841),
    [aux_sym_char_token1] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3841),
    [anon_sym_DQUOTE] = ACTIONS(3841),
    [anon_sym_AT_DQUOTE] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [sym_bool] = ACTIONS(3841),
    [sym_unit] = ACTIONS(3839),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3841),
    [sym_op_identifier] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_PLUS_DOT] = ACTIONS(3841),
    [anon_sym_DASH_DOT] = ACTIONS(3841),
    [anon_sym_PERCENT] = ACTIONS(3841),
    [anon_sym_AMP_AMP] = ACTIONS(3841),
    [anon_sym_TILDE] = ACTIONS(3839),
    [aux_sym_prefix_op_token1] = ACTIONS(3841),
    [aux_sym_infix_op_token1] = ACTIONS(3839),
    [aux_sym_infix_op_token2] = ACTIONS(3841),
    [anon_sym_PIPE_PIPE] = ACTIONS(3841),
    [anon_sym_BANG_EQ] = ACTIONS(3841),
    [anon_sym_COLON_EQ] = ACTIONS(3839),
    [anon_sym_DOLLAR] = ACTIONS(3841),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3841),
    [sym_int] = ACTIONS(3841),
    [sym_xint] = ACTIONS(3839),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3839),
    [sym__newline] = ACTIONS(3839),
  },
  [2316] = {
    [sym_block_comment] = STATE(2316),
    [sym_compiler_directive_decl] = STATE(2316),
    [sym_fsi_directive_decl] = STATE(2316),
    [sym_preproc_line] = STATE(2316),
    [aux_sym_sequential_expression_repeat1] = STATE(2340),
    [ts_builtin_sym_end] = ACTIONS(3757),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_namespace] = ACTIONS(3759),
    [anon_sym_module] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_open] = ACTIONS(3759),
    [anon_sym_LBRACK_LT] = ACTIONS(3757),
    [anon_sym_COLON] = ACTIONS(3759),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_type] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_let_BANG] = ACTIONS(3757),
    [anon_sym_LPAREN] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3757),
    [anon_sym_null] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3757),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_LT_AT] = ACTIONS(3759),
    [anon_sym_LT_AT_AT] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(3759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_return_BANG] = ACTIONS(3757),
    [anon_sym_yield] = ACTIONS(3759),
    [anon_sym_yield_BANG] = ACTIONS(3757),
    [anon_sym_lazy] = ACTIONS(3759),
    [anon_sym_assert] = ACTIONS(3759),
    [anon_sym_upcast] = ACTIONS(3759),
    [anon_sym_downcast] = ACTIONS(3759),
    [anon_sym_COLON_GT] = ACTIONS(3757),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3757),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_fun] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_match] = ACTIONS(3759),
    [anon_sym_match_BANG] = ACTIONS(3757),
    [anon_sym_function] = ACTIONS(3759),
    [anon_sym_LT_DASH] = ACTIONS(3759),
    [anon_sym_DOT_LBRACK] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_use] = ACTIONS(3759),
    [anon_sym_use_BANG] = ACTIONS(3757),
    [anon_sym_do_BANG] = ACTIONS(3757),
    [anon_sym_begin] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_or] = ACTIONS(3759),
    [anon_sym_exception] = ACTIONS(3759),
    [aux_sym_char_token1] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3759),
    [anon_sym_DQUOTE] = ACTIONS(3759),
    [anon_sym_AT_DQUOTE] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [sym_bool] = ACTIONS(3759),
    [sym_unit] = ACTIONS(3757),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3759),
    [sym_op_identifier] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS_DOT] = ACTIONS(3759),
    [anon_sym_DASH_DOT] = ACTIONS(3759),
    [anon_sym_PERCENT] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_TILDE] = ACTIONS(3757),
    [aux_sym_prefix_op_token1] = ACTIONS(3759),
    [aux_sym_infix_op_token1] = ACTIONS(3757),
    [aux_sym_infix_op_token2] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_COLON_EQ] = ACTIONS(3757),
    [anon_sym_DOLLAR] = ACTIONS(3759),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3759),
    [sym_int] = ACTIONS(3759),
    [sym_xint] = ACTIONS(3757),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3757),
    [anon_sym_POUNDload] = ACTIONS(3757),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3757),
    [sym__newline] = ACTIONS(3757),
  },
  [2317] = {
    [sym_block_comment] = STATE(2317),
    [sym_compiler_directive_decl] = STATE(2317),
    [sym_fsi_directive_decl] = STATE(2317),
    [sym_preproc_line] = STATE(2317),
    [ts_builtin_sym_end] = ACTIONS(3826),
    [sym_identifier] = ACTIONS(3828),
    [anon_sym_namespace] = ACTIONS(3828),
    [anon_sym_module] = ACTIONS(3828),
    [anon_sym_EQ] = ACTIONS(3826),
    [anon_sym_open] = ACTIONS(3828),
    [anon_sym_LBRACK_LT] = ACTIONS(3826),
    [anon_sym_COLON] = ACTIONS(3828),
    [anon_sym_return] = ACTIONS(3828),
    [anon_sym_type] = ACTIONS(3828),
    [anon_sym_do] = ACTIONS(3828),
    [anon_sym_let] = ACTIONS(3828),
    [anon_sym_let_BANG] = ACTIONS(3826),
    [anon_sym_LPAREN] = ACTIONS(3828),
    [anon_sym_COMMA] = ACTIONS(3826),
    [anon_sym_null] = ACTIONS(3828),
    [anon_sym_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_COLON] = ACTIONS(3826),
    [anon_sym_PIPE] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3828),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3826),
    [anon_sym_LBRACE] = ACTIONS(3828),
    [anon_sym_LT_AT] = ACTIONS(3828),
    [anon_sym_LT_AT_AT] = ACTIONS(3828),
    [anon_sym_DOT] = ACTIONS(3828),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3826),
    [anon_sym_new] = ACTIONS(3828),
    [anon_sym_return_BANG] = ACTIONS(3826),
    [anon_sym_yield] = ACTIONS(3828),
    [anon_sym_yield_BANG] = ACTIONS(3826),
    [anon_sym_lazy] = ACTIONS(3828),
    [anon_sym_assert] = ACTIONS(3828),
    [anon_sym_upcast] = ACTIONS(3828),
    [anon_sym_downcast] = ACTIONS(3828),
    [anon_sym_COLON_GT] = ACTIONS(3826),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3826),
    [anon_sym_for] = ACTIONS(3828),
    [anon_sym_while] = ACTIONS(3828),
    [anon_sym_if] = ACTIONS(3828),
    [anon_sym_fun] = ACTIONS(3828),
    [anon_sym_try] = ACTIONS(3828),
    [anon_sym_match] = ACTIONS(3828),
    [anon_sym_match_BANG] = ACTIONS(3826),
    [anon_sym_function] = ACTIONS(3828),
    [anon_sym_LT_DASH] = ACTIONS(3828),
    [anon_sym_DOT_LBRACK] = ACTIONS(3826),
    [anon_sym_LT] = ACTIONS(3826),
    [anon_sym_use] = ACTIONS(3828),
    [anon_sym_use_BANG] = ACTIONS(3826),
    [anon_sym_do_BANG] = ACTIONS(3826),
    [anon_sym_begin] = ACTIONS(3828),
    [anon_sym_LPAREN2] = ACTIONS(3828),
    [anon_sym_or] = ACTIONS(3828),
    [anon_sym_exception] = ACTIONS(3828),
    [aux_sym_char_token1] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3828),
    [anon_sym_DQUOTE] = ACTIONS(3828),
    [anon_sym_AT_DQUOTE] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [sym_bool] = ACTIONS(3828),
    [sym_unit] = ACTIONS(3826),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3828),
    [sym_op_identifier] = ACTIONS(3828),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_DASH] = ACTIONS(3828),
    [anon_sym_PLUS_DOT] = ACTIONS(3828),
    [anon_sym_DASH_DOT] = ACTIONS(3828),
    [anon_sym_PERCENT] = ACTIONS(3828),
    [anon_sym_AMP_AMP] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3826),
    [aux_sym_prefix_op_token1] = ACTIONS(3828),
    [aux_sym_infix_op_token1] = ACTIONS(3826),
    [aux_sym_infix_op_token2] = ACTIONS(3828),
    [anon_sym_PIPE_PIPE] = ACTIONS(3828),
    [anon_sym_BANG_EQ] = ACTIONS(3828),
    [anon_sym_COLON_EQ] = ACTIONS(3826),
    [anon_sym_DOLLAR] = ACTIONS(3828),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3828),
    [sym_int] = ACTIONS(3828),
    [sym_xint] = ACTIONS(3826),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3826),
    [anon_sym_POUNDload] = ACTIONS(3826),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3826),
    [sym__newline] = ACTIONS(3826),
  },
  [2318] = {
    [sym_block_comment] = STATE(2318),
    [sym_compiler_directive_decl] = STATE(2318),
    [sym_fsi_directive_decl] = STATE(2318),
    [sym_preproc_line] = STATE(2318),
    [aux_sym_long_identifier_repeat1] = STATE(2326),
    [ts_builtin_sym_end] = ACTIONS(3449),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_namespace] = ACTIONS(3451),
    [anon_sym_module] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_open] = ACTIONS(3451),
    [anon_sym_LBRACK_LT] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_type] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(4886),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_or] = ACTIONS(3451),
    [anon_sym_exception] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3449),
    [anon_sym_POUNDload] = ACTIONS(3449),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
  },
  [2319] = {
    [sym_type_arguments] = STATE(2660),
    [sym_long_identifier] = STATE(2627),
    [sym_block_comment] = STATE(2319),
    [sym_compiler_directive_decl] = STATE(2319),
    [sym_fsi_directive_decl] = STATE(2319),
    [sym_preproc_line] = STATE(2319),
    [aux_sym_compound_type_repeat1] = STATE(2565),
    [sym_identifier] = ACTIONS(4888),
    [anon_sym_EQ] = ACTIONS(3417),
    [anon_sym_COLON] = ACTIONS(3419),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_let] = ACTIONS(3419),
    [anon_sym_let_BANG] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(3419),
    [anon_sym_COMMA] = ACTIONS(3417),
    [anon_sym_null] = ACTIONS(3419),
    [anon_sym_QMARK] = ACTIONS(3419),
    [anon_sym_COLON_QMARK] = ACTIONS(3419),
    [anon_sym_COLON_COLON] = ACTIONS(3417),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_LT_AT] = ACTIONS(3419),
    [anon_sym_LT_AT_AT] = ACTIONS(3419),
    [anon_sym_AT_AT_GT] = ACTIONS(3419),
    [anon_sym_DOT] = ACTIONS(3419),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_return_BANG] = ACTIONS(3417),
    [anon_sym_yield] = ACTIONS(3419),
    [anon_sym_yield_BANG] = ACTIONS(3417),
    [anon_sym_lazy] = ACTIONS(3419),
    [anon_sym_assert] = ACTIONS(3419),
    [anon_sym_upcast] = ACTIONS(3419),
    [anon_sym_downcast] = ACTIONS(3419),
    [anon_sym_COLON_GT] = ACTIONS(3417),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3417),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_fun] = ACTIONS(3419),
    [anon_sym_DASH_GT] = ACTIONS(4890),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_match] = ACTIONS(3419),
    [anon_sym_match_BANG] = ACTIONS(3417),
    [anon_sym_function] = ACTIONS(3419),
    [anon_sym_LT_DASH] = ACTIONS(3419),
    [anon_sym_DOT_LBRACK] = ACTIONS(3417),
    [anon_sym_LT] = ACTIONS(3417),
    [anon_sym_use] = ACTIONS(3419),
    [anon_sym_use_BANG] = ACTIONS(3417),
    [anon_sym_do_BANG] = ACTIONS(3417),
    [anon_sym_begin] = ACTIONS(3419),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(4892),
    [anon_sym_LT2] = ACTIONS(4894),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4896),
    [anon_sym_or] = ACTIONS(3419),
    [aux_sym_char_token1] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3419),
    [anon_sym_AT_DQUOTE] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [sym_bool] = ACTIONS(3419),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3419),
    [sym_op_identifier] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_PLUS_DOT] = ACTIONS(3419),
    [anon_sym_DASH_DOT] = ACTIONS(3419),
    [anon_sym_PERCENT] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3419),
    [anon_sym_TILDE] = ACTIONS(3417),
    [aux_sym_prefix_op_token1] = ACTIONS(3419),
    [aux_sym_infix_op_token1] = ACTIONS(3417),
    [aux_sym_infix_op_token2] = ACTIONS(3419),
    [anon_sym_PIPE_PIPE] = ACTIONS(3419),
    [anon_sym_BANG_EQ] = ACTIONS(3419),
    [anon_sym_COLON_EQ] = ACTIONS(3417),
    [anon_sym_DOLLAR] = ACTIONS(3419),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3419),
    [sym_int] = ACTIONS(3419),
    [sym_xint] = ACTIONS(3417),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3417),
    [sym__newline] = ACTIONS(3417),
  },
  [2320] = {
    [sym_type_arguments] = STATE(2637),
    [sym_long_identifier] = STATE(2681),
    [sym_block_comment] = STATE(2320),
    [sym_compiler_directive_decl] = STATE(2320),
    [sym_fsi_directive_decl] = STATE(2320),
    [sym_preproc_line] = STATE(2320),
    [aux_sym_compound_type_repeat1] = STATE(2555),
    [sym_identifier] = ACTIONS(4898),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_AT_GT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3427),
    [anon_sym_DOT] = ACTIONS(3427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_COLON_GT] = ACTIONS(3425),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(4900),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_LT_DASH] = ACTIONS(3427),
    [anon_sym_DOT_LBRACK] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(4902),
    [anon_sym_LT2] = ACTIONS(4904),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4906),
    [anon_sym_or] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3427),
    [anon_sym_DASH_DOT] = ACTIONS(3427),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3427),
    [aux_sym_infix_op_token1] = ACTIONS(3425),
    [aux_sym_infix_op_token2] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3427),
    [anon_sym_COLON_EQ] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3427),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
  },
  [2321] = {
    [sym_block_comment] = STATE(2321),
    [sym_compiler_directive_decl] = STATE(2321),
    [sym_fsi_directive_decl] = STATE(2321),
    [sym_preproc_line] = STATE(2321),
    [aux_sym_long_identifier_repeat1] = STATE(2321),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_as] = ACTIONS(3487),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(4908),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
    [sym__dedent] = ACTIONS(3485),
  },
  [2322] = {
    [sym_block_comment] = STATE(2322),
    [sym_compiler_directive_decl] = STATE(2322),
    [sym_fsi_directive_decl] = STATE(2322),
    [sym_preproc_line] = STATE(2322),
    [aux_sym_type_argument_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [anon_sym_as] = ACTIONS(3480),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_COLON] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_with] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_LT_DASH] = ACTIONS(3480),
    [anon_sym_DOT_LBRACK] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_or] = ACTIONS(4911),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3480),
    [anon_sym_DASH_DOT] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3480),
    [aux_sym_infix_op_token1] = ACTIONS(3478),
    [aux_sym_infix_op_token2] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3480),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
    [sym__dedent] = ACTIONS(3478),
  },
  [2323] = {
    [sym_block_comment] = STATE(2323),
    [sym_compiler_directive_decl] = STATE(2323),
    [sym_fsi_directive_decl] = STATE(2323),
    [sym_preproc_line] = STATE(2323),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_GT_RBRACK] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_RBRACK] = ACTIONS(3683),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_RBRACE] = ACTIONS(3683),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_with] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_to] = ACTIONS(3685),
    [anon_sym_downto] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(4914),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_DOT_DOT] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
  },
  [2324] = {
    [sym_block_comment] = STATE(2324),
    [sym_compiler_directive_decl] = STATE(2324),
    [sym_fsi_directive_decl] = STATE(2324),
    [sym_preproc_line] = STATE(2324),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_GT_RBRACK] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_RBRACK] = ACTIONS(3683),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_RBRACE] = ACTIONS(3683),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_with] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_to] = ACTIONS(3685),
    [anon_sym_downto] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(4914),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_DOT_DOT2] = ACTIONS(3683),
    [anon_sym_or] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
  },
  [2325] = {
    [sym_type_arguments] = STATE(2692),
    [sym_long_identifier] = STATE(2683),
    [sym_block_comment] = STATE(2325),
    [sym_compiler_directive_decl] = STATE(2325),
    [sym_fsi_directive_decl] = STATE(2325),
    [sym_preproc_line] = STATE(2325),
    [aux_sym_compound_type_repeat1] = STATE(2563),
    [sym_identifier] = ACTIONS(3443),
    [anon_sym_EQ] = ACTIONS(3441),
    [anon_sym_COLON] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_let] = ACTIONS(3443),
    [anon_sym_let_BANG] = ACTIONS(3441),
    [anon_sym_LPAREN] = ACTIONS(3443),
    [anon_sym_COMMA] = ACTIONS(3441),
    [anon_sym_null] = ACTIONS(3443),
    [anon_sym_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_LT_AT] = ACTIONS(3443),
    [anon_sym_LT_AT_AT] = ACTIONS(3443),
    [anon_sym_DOT] = ACTIONS(3443),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_return_BANG] = ACTIONS(3441),
    [anon_sym_yield] = ACTIONS(3443),
    [anon_sym_yield_BANG] = ACTIONS(3441),
    [anon_sym_lazy] = ACTIONS(3443),
    [anon_sym_assert] = ACTIONS(3443),
    [anon_sym_upcast] = ACTIONS(3443),
    [anon_sym_downcast] = ACTIONS(3443),
    [anon_sym_COLON_GT] = ACTIONS(3441),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3441),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_fun] = ACTIONS(3443),
    [anon_sym_DASH_GT] = ACTIONS(4876),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_match] = ACTIONS(3443),
    [anon_sym_match_BANG] = ACTIONS(3441),
    [anon_sym_function] = ACTIONS(3443),
    [anon_sym_LT_DASH] = ACTIONS(3443),
    [anon_sym_DOT_LBRACK] = ACTIONS(3441),
    [anon_sym_LT] = ACTIONS(3441),
    [anon_sym_GT] = ACTIONS(3443),
    [anon_sym_use] = ACTIONS(3443),
    [anon_sym_use_BANG] = ACTIONS(3441),
    [anon_sym_do_BANG] = ACTIONS(3441),
    [anon_sym_begin] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(4878),
    [anon_sym_LT2] = ACTIONS(4880),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4882),
    [anon_sym_or] = ACTIONS(3443),
    [aux_sym_char_token1] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3443),
    [anon_sym_AT_DQUOTE] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [sym_bool] = ACTIONS(3443),
    [sym_unit] = ACTIONS(3441),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3443),
    [sym_op_identifier] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_PLUS_DOT] = ACTIONS(3443),
    [anon_sym_DASH_DOT] = ACTIONS(3443),
    [anon_sym_PERCENT] = ACTIONS(3443),
    [anon_sym_AMP_AMP] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3441),
    [aux_sym_prefix_op_token1] = ACTIONS(3443),
    [aux_sym_infix_op_token1] = ACTIONS(3441),
    [aux_sym_infix_op_token2] = ACTIONS(3443),
    [anon_sym_PIPE_PIPE] = ACTIONS(3443),
    [anon_sym_BANG_EQ] = ACTIONS(3443),
    [anon_sym_COLON_EQ] = ACTIONS(3441),
    [anon_sym_DOLLAR] = ACTIONS(3443),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3443),
    [sym_int] = ACTIONS(3443),
    [sym_xint] = ACTIONS(3441),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3441),
    [sym__newline] = ACTIONS(3441),
  },
  [2326] = {
    [sym_block_comment] = STATE(2326),
    [sym_compiler_directive_decl] = STATE(2326),
    [sym_fsi_directive_decl] = STATE(2326),
    [sym_preproc_line] = STATE(2326),
    [aux_sym_long_identifier_repeat1] = STATE(2326),
    [ts_builtin_sym_end] = ACTIONS(3485),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_namespace] = ACTIONS(3487),
    [anon_sym_module] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_open] = ACTIONS(3487),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_type] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(4916),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_exception] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3485),
    [anon_sym_POUNDload] = ACTIONS(3485),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [2327] = {
    [sym_block_comment] = STATE(2327),
    [sym_compiler_directive_decl] = STATE(2327),
    [sym_fsi_directive_decl] = STATE(2327),
    [sym_preproc_line] = STATE(2327),
    [aux_sym_type_argument_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(3476),
    [anon_sym_EQ] = ACTIONS(3474),
    [anon_sym_COLON] = ACTIONS(3476),
    [anon_sym_return] = ACTIONS(3476),
    [anon_sym_do] = ACTIONS(3476),
    [anon_sym_let] = ACTIONS(3476),
    [anon_sym_let_BANG] = ACTIONS(3474),
    [anon_sym_as] = ACTIONS(3476),
    [anon_sym_LPAREN] = ACTIONS(3476),
    [anon_sym_COMMA] = ACTIONS(3474),
    [anon_sym_null] = ACTIONS(3476),
    [anon_sym_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_COLON] = ACTIONS(3474),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym_LBRACK] = ACTIONS(3476),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3474),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_LT_AT] = ACTIONS(3476),
    [anon_sym_LT_AT_AT] = ACTIONS(3476),
    [anon_sym_DOT] = ACTIONS(3476),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3474),
    [anon_sym_new] = ACTIONS(3476),
    [anon_sym_with] = ACTIONS(3476),
    [anon_sym_return_BANG] = ACTIONS(3474),
    [anon_sym_yield] = ACTIONS(3476),
    [anon_sym_yield_BANG] = ACTIONS(3474),
    [anon_sym_lazy] = ACTIONS(3476),
    [anon_sym_assert] = ACTIONS(3476),
    [anon_sym_upcast] = ACTIONS(3476),
    [anon_sym_downcast] = ACTIONS(3476),
    [anon_sym_COLON_GT] = ACTIONS(3474),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3474),
    [anon_sym_for] = ACTIONS(3476),
    [anon_sym_while] = ACTIONS(3476),
    [anon_sym_if] = ACTIONS(3476),
    [anon_sym_fun] = ACTIONS(3476),
    [anon_sym_DASH_GT] = ACTIONS(3476),
    [anon_sym_try] = ACTIONS(3476),
    [anon_sym_match] = ACTIONS(3476),
    [anon_sym_match_BANG] = ACTIONS(3474),
    [anon_sym_function] = ACTIONS(3476),
    [anon_sym_LT_DASH] = ACTIONS(3476),
    [anon_sym_DOT_LBRACK] = ACTIONS(3474),
    [anon_sym_LT] = ACTIONS(3474),
    [anon_sym_use] = ACTIONS(3476),
    [anon_sym_use_BANG] = ACTIONS(3474),
    [anon_sym_do_BANG] = ACTIONS(3474),
    [anon_sym_begin] = ACTIONS(3476),
    [anon_sym_LPAREN2] = ACTIONS(3476),
    [anon_sym_STAR] = ACTIONS(3476),
    [anon_sym_LT2] = ACTIONS(3476),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3474),
    [anon_sym_or] = ACTIONS(3476),
    [aux_sym_char_token1] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3476),
    [anon_sym_DQUOTE] = ACTIONS(3476),
    [anon_sym_AT_DQUOTE] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [sym_bool] = ACTIONS(3476),
    [sym_unit] = ACTIONS(3474),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3476),
    [sym_op_identifier] = ACTIONS(3476),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3476),
    [anon_sym_PLUS_DOT] = ACTIONS(3476),
    [anon_sym_DASH_DOT] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [anon_sym_AMP_AMP] = ACTIONS(3476),
    [anon_sym_TILDE] = ACTIONS(3474),
    [aux_sym_prefix_op_token1] = ACTIONS(3476),
    [aux_sym_infix_op_token1] = ACTIONS(3474),
    [aux_sym_infix_op_token2] = ACTIONS(3476),
    [anon_sym_PIPE_PIPE] = ACTIONS(3476),
    [anon_sym_BANG_EQ] = ACTIONS(3476),
    [anon_sym_COLON_EQ] = ACTIONS(3474),
    [anon_sym_DOLLAR] = ACTIONS(3476),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3476),
    [sym_int] = ACTIONS(3476),
    [sym_xint] = ACTIONS(3474),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3474),
    [sym__newline] = ACTIONS(3474),
    [sym__dedent] = ACTIONS(3474),
  },
  [2328] = {
    [sym_type_arguments] = STATE(2637),
    [sym_long_identifier] = STATE(2681),
    [sym_block_comment] = STATE(2328),
    [sym_compiler_directive_decl] = STATE(2328),
    [sym_fsi_directive_decl] = STATE(2328),
    [sym_preproc_line] = STATE(2328),
    [aux_sym_compound_type_repeat1] = STATE(2555),
    [sym_identifier] = ACTIONS(4898),
    [anon_sym_EQ] = ACTIONS(3403),
    [anon_sym_COLON] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_let_BANG] = ACTIONS(3403),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_COMMA] = ACTIONS(3403),
    [anon_sym_null] = ACTIONS(3407),
    [anon_sym_QMARK] = ACTIONS(3407),
    [anon_sym_COLON_QMARK] = ACTIONS(3407),
    [anon_sym_COLON_COLON] = ACTIONS(3403),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3407),
    [anon_sym_LT_AT] = ACTIONS(3407),
    [anon_sym_AT_GT] = ACTIONS(3407),
    [anon_sym_LT_AT_AT] = ACTIONS(3407),
    [anon_sym_DOT] = ACTIONS(3407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_return_BANG] = ACTIONS(3403),
    [anon_sym_yield] = ACTIONS(3407),
    [anon_sym_yield_BANG] = ACTIONS(3403),
    [anon_sym_lazy] = ACTIONS(3407),
    [anon_sym_assert] = ACTIONS(3407),
    [anon_sym_upcast] = ACTIONS(3407),
    [anon_sym_downcast] = ACTIONS(3407),
    [anon_sym_COLON_GT] = ACTIONS(3403),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_fun] = ACTIONS(3407),
    [anon_sym_DASH_GT] = ACTIONS(4900),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_match] = ACTIONS(3407),
    [anon_sym_match_BANG] = ACTIONS(3403),
    [anon_sym_function] = ACTIONS(3407),
    [anon_sym_LT_DASH] = ACTIONS(3407),
    [anon_sym_DOT_LBRACK] = ACTIONS(3403),
    [anon_sym_LT] = ACTIONS(3403),
    [anon_sym_use] = ACTIONS(3407),
    [anon_sym_use_BANG] = ACTIONS(3403),
    [anon_sym_do_BANG] = ACTIONS(3403),
    [anon_sym_begin] = ACTIONS(3407),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(4902),
    [anon_sym_LT2] = ACTIONS(4904),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4906),
    [anon_sym_or] = ACTIONS(3407),
    [aux_sym_char_token1] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3407),
    [anon_sym_DQUOTE] = ACTIONS(3407),
    [anon_sym_AT_DQUOTE] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [sym_bool] = ACTIONS(3407),
    [sym_unit] = ACTIONS(3403),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3407),
    [sym_op_identifier] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_PLUS_DOT] = ACTIONS(3407),
    [anon_sym_DASH_DOT] = ACTIONS(3407),
    [anon_sym_PERCENT] = ACTIONS(3407),
    [anon_sym_AMP_AMP] = ACTIONS(3407),
    [anon_sym_TILDE] = ACTIONS(3403),
    [aux_sym_prefix_op_token1] = ACTIONS(3407),
    [aux_sym_infix_op_token1] = ACTIONS(3403),
    [aux_sym_infix_op_token2] = ACTIONS(3407),
    [anon_sym_PIPE_PIPE] = ACTIONS(3407),
    [anon_sym_BANG_EQ] = ACTIONS(3407),
    [anon_sym_COLON_EQ] = ACTIONS(3403),
    [anon_sym_DOLLAR] = ACTIONS(3407),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3407),
    [sym_int] = ACTIONS(3407),
    [sym_xint] = ACTIONS(3403),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3403),
    [sym__newline] = ACTIONS(3403),
  },
  [2329] = {
    [sym_block_comment] = STATE(2329),
    [sym_compiler_directive_decl] = STATE(2329),
    [sym_fsi_directive_decl] = STATE(2329),
    [sym_preproc_line] = STATE(2329),
    [aux_sym_long_identifier_repeat1] = STATE(2321),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [anon_sym_as] = ACTIONS(3451),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(4868),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_DASH_GT] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_STAR] = ACTIONS(3451),
    [anon_sym_LT2] = ACTIONS(3451),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3449),
    [anon_sym_or] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
    [sym__dedent] = ACTIONS(3449),
  },
  [2330] = {
    [sym_block_comment] = STATE(2330),
    [sym_compiler_directive_decl] = STATE(2330),
    [sym_fsi_directive_decl] = STATE(2330),
    [sym_preproc_line] = STATE(2330),
    [ts_builtin_sym_end] = ACTIONS(3741),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_namespace] = ACTIONS(3743),
    [anon_sym_module] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_open] = ACTIONS(3743),
    [anon_sym_LBRACK_LT] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_type] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_or] = ACTIONS(3743),
    [anon_sym_exception] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3741),
    [anon_sym_POUNDload] = ACTIONS(3741),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [sym__newline] = ACTIONS(3741),
  },
  [2331] = {
    [sym_block_comment] = STATE(2331),
    [sym_compiler_directive_decl] = STATE(2331),
    [sym_fsi_directive_decl] = STATE(2331),
    [sym_preproc_line] = STATE(2331),
    [sym_identifier] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3772),
    [anon_sym_GT_RBRACK] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3774),
    [anon_sym_do] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3774),
    [anon_sym_let_BANG] = ACTIONS(3772),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3772),
    [anon_sym_null] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_COLON] = ACTIONS(3772),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_RBRACK] = ACTIONS(3772),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_RBRACE] = ACTIONS(3772),
    [anon_sym_LT_AT] = ACTIONS(3774),
    [anon_sym_LT_AT_AT] = ACTIONS(3774),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3772),
    [anon_sym_new] = ACTIONS(3774),
    [anon_sym_with] = ACTIONS(3774),
    [anon_sym_return_BANG] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3774),
    [anon_sym_yield_BANG] = ACTIONS(3772),
    [anon_sym_lazy] = ACTIONS(3774),
    [anon_sym_assert] = ACTIONS(3774),
    [anon_sym_upcast] = ACTIONS(3774),
    [anon_sym_downcast] = ACTIONS(3774),
    [anon_sym_COLON_GT] = ACTIONS(3772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3774),
    [anon_sym_to] = ACTIONS(3774),
    [anon_sym_downto] = ACTIONS(3774),
    [anon_sym_done] = ACTIONS(4919),
    [anon_sym_while] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3774),
    [anon_sym_fun] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3774),
    [anon_sym_match] = ACTIONS(3774),
    [anon_sym_match_BANG] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3774),
    [anon_sym_LT_DASH] = ACTIONS(3774),
    [anon_sym_DOT_LBRACK] = ACTIONS(3772),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_use] = ACTIONS(3774),
    [anon_sym_use_BANG] = ACTIONS(3772),
    [anon_sym_do_BANG] = ACTIONS(3772),
    [anon_sym_begin] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3774),
    [anon_sym_DOT_DOT2] = ACTIONS(3772),
    [anon_sym_or] = ACTIONS(3774),
    [aux_sym_char_token1] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_AT_DQUOTE] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [sym_bool] = ACTIONS(3774),
    [sym_unit] = ACTIONS(3772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3774),
    [sym_op_identifier] = ACTIONS(3774),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_DOT] = ACTIONS(3774),
    [anon_sym_DASH_DOT] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3772),
    [aux_sym_prefix_op_token1] = ACTIONS(3774),
    [aux_sym_infix_op_token1] = ACTIONS(3772),
    [aux_sym_infix_op_token2] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3774),
    [anon_sym_COLON_EQ] = ACTIONS(3772),
    [anon_sym_DOLLAR] = ACTIONS(3774),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3774),
    [sym_int] = ACTIONS(3774),
    [sym_xint] = ACTIONS(3772),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3772),
    [sym__newline] = ACTIONS(3772),
  },
  [2332] = {
    [sym_block_comment] = STATE(2332),
    [sym_compiler_directive_decl] = STATE(2332),
    [sym_fsi_directive_decl] = STATE(2332),
    [sym_preproc_line] = STATE(2332),
    [ts_builtin_sym_end] = ACTIONS(3683),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_namespace] = ACTIONS(3685),
    [anon_sym_module] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_open] = ACTIONS(3685),
    [anon_sym_LBRACK_LT] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_type] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(4853),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [anon_sym_exception] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3683),
    [anon_sym_POUNDload] = ACTIONS(3683),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
  },
  [2333] = {
    [sym_block_comment] = STATE(2333),
    [sym_compiler_directive_decl] = STATE(2333),
    [sym_fsi_directive_decl] = STATE(2333),
    [sym_preproc_line] = STATE(2333),
    [ts_builtin_sym_end] = ACTIONS(3798),
    [sym_identifier] = ACTIONS(3800),
    [anon_sym_namespace] = ACTIONS(3800),
    [anon_sym_module] = ACTIONS(3800),
    [anon_sym_EQ] = ACTIONS(3798),
    [anon_sym_open] = ACTIONS(3800),
    [anon_sym_LBRACK_LT] = ACTIONS(3798),
    [anon_sym_COLON] = ACTIONS(3800),
    [anon_sym_return] = ACTIONS(3800),
    [anon_sym_type] = ACTIONS(3800),
    [anon_sym_do] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_let_BANG] = ACTIONS(3798),
    [anon_sym_LPAREN] = ACTIONS(3800),
    [anon_sym_COMMA] = ACTIONS(3798),
    [anon_sym_null] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_COLON] = ACTIONS(3798),
    [anon_sym_PIPE] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3800),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3798),
    [anon_sym_LBRACE] = ACTIONS(3800),
    [anon_sym_LT_AT] = ACTIONS(3800),
    [anon_sym_LT_AT_AT] = ACTIONS(3800),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3798),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_return_BANG] = ACTIONS(3798),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_yield_BANG] = ACTIONS(3798),
    [anon_sym_lazy] = ACTIONS(3800),
    [anon_sym_assert] = ACTIONS(3800),
    [anon_sym_upcast] = ACTIONS(3800),
    [anon_sym_downcast] = ACTIONS(3800),
    [anon_sym_COLON_GT] = ACTIONS(3798),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3798),
    [anon_sym_for] = ACTIONS(3800),
    [anon_sym_while] = ACTIONS(3800),
    [anon_sym_if] = ACTIONS(3800),
    [anon_sym_fun] = ACTIONS(3800),
    [anon_sym_try] = ACTIONS(3800),
    [anon_sym_match] = ACTIONS(3800),
    [anon_sym_match_BANG] = ACTIONS(3798),
    [anon_sym_function] = ACTIONS(3800),
    [anon_sym_LT_DASH] = ACTIONS(3800),
    [anon_sym_DOT_LBRACK] = ACTIONS(3798),
    [anon_sym_LT] = ACTIONS(3798),
    [anon_sym_use] = ACTIONS(3800),
    [anon_sym_use_BANG] = ACTIONS(3798),
    [anon_sym_do_BANG] = ACTIONS(3798),
    [anon_sym_begin] = ACTIONS(3800),
    [anon_sym_LPAREN2] = ACTIONS(3800),
    [anon_sym_or] = ACTIONS(3800),
    [anon_sym_exception] = ACTIONS(3800),
    [aux_sym_char_token1] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3800),
    [anon_sym_DQUOTE] = ACTIONS(3800),
    [anon_sym_AT_DQUOTE] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [sym_bool] = ACTIONS(3800),
    [sym_unit] = ACTIONS(3798),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3800),
    [sym_op_identifier] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS_DOT] = ACTIONS(3800),
    [anon_sym_DASH_DOT] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3800),
    [anon_sym_AMP_AMP] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3798),
    [aux_sym_prefix_op_token1] = ACTIONS(3800),
    [aux_sym_infix_op_token1] = ACTIONS(3798),
    [aux_sym_infix_op_token2] = ACTIONS(3800),
    [anon_sym_PIPE_PIPE] = ACTIONS(3800),
    [anon_sym_BANG_EQ] = ACTIONS(3800),
    [anon_sym_COLON_EQ] = ACTIONS(3798),
    [anon_sym_DOLLAR] = ACTIONS(3800),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3800),
    [sym_int] = ACTIONS(3800),
    [sym_xint] = ACTIONS(3798),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3798),
    [anon_sym_POUNDload] = ACTIONS(3798),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3798),
    [sym__newline] = ACTIONS(3798),
  },
  [2334] = {
    [sym_block_comment] = STATE(2334),
    [sym_compiler_directive_decl] = STATE(2334),
    [sym_fsi_directive_decl] = STATE(2334),
    [sym_preproc_line] = STATE(2334),
    [sym_identifier] = ACTIONS(3828),
    [anon_sym_EQ] = ACTIONS(3826),
    [anon_sym_GT_RBRACK] = ACTIONS(3826),
    [anon_sym_COLON] = ACTIONS(3828),
    [anon_sym_return] = ACTIONS(3828),
    [anon_sym_do] = ACTIONS(3828),
    [anon_sym_let] = ACTIONS(3828),
    [anon_sym_let_BANG] = ACTIONS(3826),
    [anon_sym_LPAREN] = ACTIONS(3828),
    [anon_sym_COMMA] = ACTIONS(3826),
    [anon_sym_null] = ACTIONS(3828),
    [anon_sym_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_COLON] = ACTIONS(3826),
    [anon_sym_PIPE] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3828),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [anon_sym_RBRACK] = ACTIONS(3826),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3826),
    [anon_sym_LBRACE] = ACTIONS(3828),
    [anon_sym_RBRACE] = ACTIONS(3826),
    [anon_sym_LT_AT] = ACTIONS(3828),
    [anon_sym_LT_AT_AT] = ACTIONS(3828),
    [anon_sym_DOT] = ACTIONS(3828),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3826),
    [anon_sym_new] = ACTIONS(3828),
    [anon_sym_with] = ACTIONS(3828),
    [anon_sym_return_BANG] = ACTIONS(3826),
    [anon_sym_yield] = ACTIONS(3828),
    [anon_sym_yield_BANG] = ACTIONS(3826),
    [anon_sym_lazy] = ACTIONS(3828),
    [anon_sym_assert] = ACTIONS(3828),
    [anon_sym_upcast] = ACTIONS(3828),
    [anon_sym_downcast] = ACTIONS(3828),
    [anon_sym_COLON_GT] = ACTIONS(3826),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3826),
    [anon_sym_for] = ACTIONS(3828),
    [anon_sym_to] = ACTIONS(3828),
    [anon_sym_downto] = ACTIONS(3828),
    [anon_sym_while] = ACTIONS(3828),
    [anon_sym_if] = ACTIONS(3828),
    [anon_sym_fun] = ACTIONS(3828),
    [anon_sym_try] = ACTIONS(3828),
    [anon_sym_match] = ACTIONS(3828),
    [anon_sym_match_BANG] = ACTIONS(3826),
    [anon_sym_function] = ACTIONS(3828),
    [anon_sym_LT_DASH] = ACTIONS(3828),
    [anon_sym_DOT_LBRACK] = ACTIONS(3826),
    [anon_sym_LT] = ACTIONS(3826),
    [anon_sym_use] = ACTIONS(3828),
    [anon_sym_use_BANG] = ACTIONS(3826),
    [anon_sym_do_BANG] = ACTIONS(3826),
    [anon_sym_begin] = ACTIONS(3828),
    [anon_sym_LPAREN2] = ACTIONS(3828),
    [anon_sym_DOT_DOT2] = ACTIONS(3826),
    [anon_sym_or] = ACTIONS(3828),
    [aux_sym_char_token1] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3828),
    [anon_sym_DQUOTE] = ACTIONS(3828),
    [anon_sym_AT_DQUOTE] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [sym_bool] = ACTIONS(3828),
    [sym_unit] = ACTIONS(3826),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3828),
    [sym_op_identifier] = ACTIONS(3828),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_DASH] = ACTIONS(3828),
    [anon_sym_PLUS_DOT] = ACTIONS(3828),
    [anon_sym_DASH_DOT] = ACTIONS(3828),
    [anon_sym_PERCENT] = ACTIONS(3828),
    [anon_sym_AMP_AMP] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3826),
    [aux_sym_prefix_op_token1] = ACTIONS(3828),
    [aux_sym_infix_op_token1] = ACTIONS(3826),
    [aux_sym_infix_op_token2] = ACTIONS(3828),
    [anon_sym_PIPE_PIPE] = ACTIONS(3828),
    [anon_sym_BANG_EQ] = ACTIONS(3828),
    [anon_sym_COLON_EQ] = ACTIONS(3826),
    [anon_sym_DOLLAR] = ACTIONS(3828),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3828),
    [sym_int] = ACTIONS(3828),
    [sym_xint] = ACTIONS(3826),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3826),
    [sym__newline] = ACTIONS(3826),
  },
  [2335] = {
    [sym_block_comment] = STATE(2335),
    [sym_compiler_directive_decl] = STATE(2335),
    [sym_fsi_directive_decl] = STATE(2335),
    [sym_preproc_line] = STATE(2335),
    [ts_builtin_sym_end] = ACTIONS(3772),
    [sym_identifier] = ACTIONS(3774),
    [anon_sym_namespace] = ACTIONS(3774),
    [anon_sym_module] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3772),
    [anon_sym_open] = ACTIONS(3774),
    [anon_sym_LBRACK_LT] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3774),
    [anon_sym_type] = ACTIONS(3774),
    [anon_sym_do] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3774),
    [anon_sym_let_BANG] = ACTIONS(3772),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3772),
    [anon_sym_null] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_COLON] = ACTIONS(3772),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_LT_AT] = ACTIONS(3774),
    [anon_sym_LT_AT_AT] = ACTIONS(3774),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3772),
    [anon_sym_new] = ACTIONS(3774),
    [anon_sym_return_BANG] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3774),
    [anon_sym_yield_BANG] = ACTIONS(3772),
    [anon_sym_lazy] = ACTIONS(3774),
    [anon_sym_assert] = ACTIONS(3774),
    [anon_sym_upcast] = ACTIONS(3774),
    [anon_sym_downcast] = ACTIONS(3774),
    [anon_sym_COLON_GT] = ACTIONS(3772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3774),
    [anon_sym_done] = ACTIONS(4921),
    [anon_sym_while] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3774),
    [anon_sym_fun] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3774),
    [anon_sym_match] = ACTIONS(3774),
    [anon_sym_match_BANG] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3774),
    [anon_sym_LT_DASH] = ACTIONS(3774),
    [anon_sym_DOT_LBRACK] = ACTIONS(3772),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_use] = ACTIONS(3774),
    [anon_sym_use_BANG] = ACTIONS(3772),
    [anon_sym_do_BANG] = ACTIONS(3772),
    [anon_sym_begin] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3774),
    [anon_sym_or] = ACTIONS(3774),
    [anon_sym_exception] = ACTIONS(3774),
    [aux_sym_char_token1] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_AT_DQUOTE] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [sym_bool] = ACTIONS(3774),
    [sym_unit] = ACTIONS(3772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3774),
    [sym_op_identifier] = ACTIONS(3774),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_DOT] = ACTIONS(3774),
    [anon_sym_DASH_DOT] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3772),
    [aux_sym_prefix_op_token1] = ACTIONS(3774),
    [aux_sym_infix_op_token1] = ACTIONS(3772),
    [aux_sym_infix_op_token2] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3774),
    [anon_sym_COLON_EQ] = ACTIONS(3772),
    [anon_sym_DOLLAR] = ACTIONS(3774),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3774),
    [sym_int] = ACTIONS(3774),
    [sym_xint] = ACTIONS(3772),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3772),
    [anon_sym_POUNDload] = ACTIONS(3772),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3772),
    [sym__newline] = ACTIONS(3772),
  },
  [2336] = {
    [sym_type_arguments] = STATE(2660),
    [sym_long_identifier] = STATE(2627),
    [sym_block_comment] = STATE(2336),
    [sym_compiler_directive_decl] = STATE(2336),
    [sym_fsi_directive_decl] = STATE(2336),
    [sym_preproc_line] = STATE(2336),
    [aux_sym_compound_type_repeat1] = STATE(2565),
    [sym_identifier] = ACTIONS(3443),
    [anon_sym_EQ] = ACTIONS(3441),
    [anon_sym_COLON] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_let] = ACTIONS(3443),
    [anon_sym_let_BANG] = ACTIONS(3441),
    [anon_sym_LPAREN] = ACTIONS(3443),
    [anon_sym_COMMA] = ACTIONS(3441),
    [anon_sym_null] = ACTIONS(3443),
    [anon_sym_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_LT_AT] = ACTIONS(3443),
    [anon_sym_LT_AT_AT] = ACTIONS(3443),
    [anon_sym_AT_AT_GT] = ACTIONS(3443),
    [anon_sym_DOT] = ACTIONS(3443),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_return_BANG] = ACTIONS(3441),
    [anon_sym_yield] = ACTIONS(3443),
    [anon_sym_yield_BANG] = ACTIONS(3441),
    [anon_sym_lazy] = ACTIONS(3443),
    [anon_sym_assert] = ACTIONS(3443),
    [anon_sym_upcast] = ACTIONS(3443),
    [anon_sym_downcast] = ACTIONS(3443),
    [anon_sym_COLON_GT] = ACTIONS(3441),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3441),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_fun] = ACTIONS(3443),
    [anon_sym_DASH_GT] = ACTIONS(4890),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_match] = ACTIONS(3443),
    [anon_sym_match_BANG] = ACTIONS(3441),
    [anon_sym_function] = ACTIONS(3443),
    [anon_sym_LT_DASH] = ACTIONS(3443),
    [anon_sym_DOT_LBRACK] = ACTIONS(3441),
    [anon_sym_LT] = ACTIONS(3441),
    [anon_sym_use] = ACTIONS(3443),
    [anon_sym_use_BANG] = ACTIONS(3441),
    [anon_sym_do_BANG] = ACTIONS(3441),
    [anon_sym_begin] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(4892),
    [anon_sym_LT2] = ACTIONS(4894),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4896),
    [anon_sym_or] = ACTIONS(3443),
    [aux_sym_char_token1] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3443),
    [anon_sym_AT_DQUOTE] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [sym_bool] = ACTIONS(3443),
    [sym_unit] = ACTIONS(3441),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3443),
    [sym_op_identifier] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_PLUS_DOT] = ACTIONS(3443),
    [anon_sym_DASH_DOT] = ACTIONS(3443),
    [anon_sym_PERCENT] = ACTIONS(3443),
    [anon_sym_AMP_AMP] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3441),
    [aux_sym_prefix_op_token1] = ACTIONS(3443),
    [aux_sym_infix_op_token1] = ACTIONS(3441),
    [aux_sym_infix_op_token2] = ACTIONS(3443),
    [anon_sym_PIPE_PIPE] = ACTIONS(3443),
    [anon_sym_BANG_EQ] = ACTIONS(3443),
    [anon_sym_COLON_EQ] = ACTIONS(3441),
    [anon_sym_DOLLAR] = ACTIONS(3443),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3443),
    [sym_int] = ACTIONS(3443),
    [sym_xint] = ACTIONS(3441),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3441),
    [sym__newline] = ACTIONS(3441),
  },
  [2337] = {
    [sym_type_arguments] = STATE(2660),
    [sym_long_identifier] = STATE(2627),
    [sym_block_comment] = STATE(2337),
    [sym_compiler_directive_decl] = STATE(2337),
    [sym_fsi_directive_decl] = STATE(2337),
    [sym_preproc_line] = STATE(2337),
    [aux_sym_compound_type_repeat1] = STATE(2565),
    [sym_identifier] = ACTIONS(4888),
    [anon_sym_EQ] = ACTIONS(3403),
    [anon_sym_COLON] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_let_BANG] = ACTIONS(3403),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_COMMA] = ACTIONS(3403),
    [anon_sym_null] = ACTIONS(3407),
    [anon_sym_QMARK] = ACTIONS(3407),
    [anon_sym_COLON_QMARK] = ACTIONS(3407),
    [anon_sym_COLON_COLON] = ACTIONS(3403),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3407),
    [anon_sym_LT_AT] = ACTIONS(3407),
    [anon_sym_LT_AT_AT] = ACTIONS(3407),
    [anon_sym_AT_AT_GT] = ACTIONS(3407),
    [anon_sym_DOT] = ACTIONS(3407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_return_BANG] = ACTIONS(3403),
    [anon_sym_yield] = ACTIONS(3407),
    [anon_sym_yield_BANG] = ACTIONS(3403),
    [anon_sym_lazy] = ACTIONS(3407),
    [anon_sym_assert] = ACTIONS(3407),
    [anon_sym_upcast] = ACTIONS(3407),
    [anon_sym_downcast] = ACTIONS(3407),
    [anon_sym_COLON_GT] = ACTIONS(3403),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_fun] = ACTIONS(3407),
    [anon_sym_DASH_GT] = ACTIONS(4890),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_match] = ACTIONS(3407),
    [anon_sym_match_BANG] = ACTIONS(3403),
    [anon_sym_function] = ACTIONS(3407),
    [anon_sym_LT_DASH] = ACTIONS(3407),
    [anon_sym_DOT_LBRACK] = ACTIONS(3403),
    [anon_sym_LT] = ACTIONS(3403),
    [anon_sym_use] = ACTIONS(3407),
    [anon_sym_use_BANG] = ACTIONS(3403),
    [anon_sym_do_BANG] = ACTIONS(3403),
    [anon_sym_begin] = ACTIONS(3407),
    [anon_sym_LPAREN2] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(4892),
    [anon_sym_LT2] = ACTIONS(4894),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4896),
    [anon_sym_or] = ACTIONS(3407),
    [aux_sym_char_token1] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3407),
    [anon_sym_DQUOTE] = ACTIONS(3407),
    [anon_sym_AT_DQUOTE] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [sym_bool] = ACTIONS(3407),
    [sym_unit] = ACTIONS(3403),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3407),
    [sym_op_identifier] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_PLUS_DOT] = ACTIONS(3407),
    [anon_sym_DASH_DOT] = ACTIONS(3407),
    [anon_sym_PERCENT] = ACTIONS(3407),
    [anon_sym_AMP_AMP] = ACTIONS(3407),
    [anon_sym_TILDE] = ACTIONS(3403),
    [aux_sym_prefix_op_token1] = ACTIONS(3407),
    [aux_sym_infix_op_token1] = ACTIONS(3403),
    [aux_sym_infix_op_token2] = ACTIONS(3407),
    [anon_sym_PIPE_PIPE] = ACTIONS(3407),
    [anon_sym_BANG_EQ] = ACTIONS(3407),
    [anon_sym_COLON_EQ] = ACTIONS(3403),
    [anon_sym_DOLLAR] = ACTIONS(3407),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3407),
    [sym_int] = ACTIONS(3407),
    [sym_xint] = ACTIONS(3403),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3403),
    [sym__newline] = ACTIONS(3403),
  },
  [2338] = {
    [sym_type_arguments] = STATE(2660),
    [sym_long_identifier] = STATE(2627),
    [sym_block_comment] = STATE(2338),
    [sym_compiler_directive_decl] = STATE(2338),
    [sym_fsi_directive_decl] = STATE(2338),
    [sym_preproc_line] = STATE(2338),
    [aux_sym_compound_type_repeat1] = STATE(2565),
    [sym_identifier] = ACTIONS(4888),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3427),
    [anon_sym_AT_AT_GT] = ACTIONS(3427),
    [anon_sym_DOT] = ACTIONS(3427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_COLON_GT] = ACTIONS(3425),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(4890),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_LT_DASH] = ACTIONS(3427),
    [anon_sym_DOT_LBRACK] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(4892),
    [anon_sym_LT2] = ACTIONS(4894),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4896),
    [anon_sym_or] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3427),
    [anon_sym_DASH_DOT] = ACTIONS(3427),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3427),
    [aux_sym_infix_op_token1] = ACTIONS(3425),
    [aux_sym_infix_op_token2] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3427),
    [anon_sym_COLON_EQ] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3427),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
  },
  [2339] = {
    [sym_block_comment] = STATE(2339),
    [sym_compiler_directive_decl] = STATE(2339),
    [sym_fsi_directive_decl] = STATE(2339),
    [sym_preproc_line] = STATE(2339),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_GT_RBRACK] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_RBRACK] = ACTIONS(3698),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_RBRACE] = ACTIONS(3698),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_to] = ACTIONS(3700),
    [anon_sym_downto] = ACTIONS(3700),
    [anon_sym_done] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_DOT_DOT] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [2340] = {
    [sym_block_comment] = STATE(2340),
    [sym_compiler_directive_decl] = STATE(2340),
    [sym_fsi_directive_decl] = STATE(2340),
    [sym_preproc_line] = STATE(2340),
    [aux_sym_sequential_expression_repeat1] = STATE(2340),
    [ts_builtin_sym_end] = ACTIONS(3765),
    [sym_identifier] = ACTIONS(3767),
    [anon_sym_namespace] = ACTIONS(3767),
    [anon_sym_module] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3765),
    [anon_sym_open] = ACTIONS(3767),
    [anon_sym_LBRACK_LT] = ACTIONS(3765),
    [anon_sym_COLON] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_type] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_let_BANG] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(3767),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_null] = ACTIONS(3767),
    [anon_sym_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3765),
    [anon_sym_LBRACE] = ACTIONS(3767),
    [anon_sym_LT_AT] = ACTIONS(3767),
    [anon_sym_LT_AT_AT] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3765),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_return_BANG] = ACTIONS(3765),
    [anon_sym_yield] = ACTIONS(3767),
    [anon_sym_yield_BANG] = ACTIONS(3765),
    [anon_sym_lazy] = ACTIONS(3767),
    [anon_sym_assert] = ACTIONS(3767),
    [anon_sym_upcast] = ACTIONS(3767),
    [anon_sym_downcast] = ACTIONS(3767),
    [anon_sym_COLON_GT] = ACTIONS(3765),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3765),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_fun] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_match] = ACTIONS(3767),
    [anon_sym_match_BANG] = ACTIONS(3765),
    [anon_sym_function] = ACTIONS(3767),
    [anon_sym_LT_DASH] = ACTIONS(3767),
    [anon_sym_DOT_LBRACK] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(3765),
    [anon_sym_use] = ACTIONS(3767),
    [anon_sym_use_BANG] = ACTIONS(3765),
    [anon_sym_do_BANG] = ACTIONS(3765),
    [anon_sym_begin] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3767),
    [anon_sym_or] = ACTIONS(3767),
    [anon_sym_exception] = ACTIONS(3767),
    [aux_sym_char_token1] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3767),
    [anon_sym_DQUOTE] = ACTIONS(3767),
    [anon_sym_AT_DQUOTE] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [sym_bool] = ACTIONS(3767),
    [sym_unit] = ACTIONS(3765),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3767),
    [sym_op_identifier] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_PLUS_DOT] = ACTIONS(3767),
    [anon_sym_DASH_DOT] = ACTIONS(3767),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_AMP_AMP] = ACTIONS(3767),
    [anon_sym_TILDE] = ACTIONS(3765),
    [aux_sym_prefix_op_token1] = ACTIONS(3767),
    [aux_sym_infix_op_token1] = ACTIONS(3765),
    [aux_sym_infix_op_token2] = ACTIONS(3767),
    [anon_sym_PIPE_PIPE] = ACTIONS(3767),
    [anon_sym_BANG_EQ] = ACTIONS(3767),
    [anon_sym_COLON_EQ] = ACTIONS(3765),
    [anon_sym_DOLLAR] = ACTIONS(3767),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3767),
    [sym_int] = ACTIONS(3767),
    [sym_xint] = ACTIONS(3765),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3765),
    [anon_sym_POUNDload] = ACTIONS(3765),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3765),
    [sym__newline] = ACTIONS(4923),
  },
  [2341] = {
    [sym_type_arguments] = STATE(2660),
    [sym_long_identifier] = STATE(2627),
    [sym_block_comment] = STATE(2341),
    [sym_compiler_directive_decl] = STATE(2341),
    [sym_fsi_directive_decl] = STATE(2341),
    [sym_preproc_line] = STATE(2341),
    [aux_sym_compound_type_repeat1] = STATE(2565),
    [sym_identifier] = ACTIONS(4888),
    [anon_sym_EQ] = ACTIONS(3429),
    [anon_sym_COLON] = ACTIONS(3431),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_let] = ACTIONS(3431),
    [anon_sym_let_BANG] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(3431),
    [anon_sym_COMMA] = ACTIONS(3429),
    [anon_sym_null] = ACTIONS(3431),
    [anon_sym_QMARK] = ACTIONS(3431),
    [anon_sym_COLON_QMARK] = ACTIONS(3431),
    [anon_sym_COLON_COLON] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_LT_AT] = ACTIONS(3431),
    [anon_sym_LT_AT_AT] = ACTIONS(3431),
    [anon_sym_AT_AT_GT] = ACTIONS(3431),
    [anon_sym_DOT] = ACTIONS(3431),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_return_BANG] = ACTIONS(3429),
    [anon_sym_yield] = ACTIONS(3431),
    [anon_sym_yield_BANG] = ACTIONS(3429),
    [anon_sym_lazy] = ACTIONS(3431),
    [anon_sym_assert] = ACTIONS(3431),
    [anon_sym_upcast] = ACTIONS(3431),
    [anon_sym_downcast] = ACTIONS(3431),
    [anon_sym_COLON_GT] = ACTIONS(3429),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_fun] = ACTIONS(3431),
    [anon_sym_DASH_GT] = ACTIONS(4890),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_match] = ACTIONS(3431),
    [anon_sym_match_BANG] = ACTIONS(3429),
    [anon_sym_function] = ACTIONS(3431),
    [anon_sym_LT_DASH] = ACTIONS(3431),
    [anon_sym_DOT_LBRACK] = ACTIONS(3429),
    [anon_sym_LT] = ACTIONS(3429),
    [anon_sym_use] = ACTIONS(3431),
    [anon_sym_use_BANG] = ACTIONS(3429),
    [anon_sym_do_BANG] = ACTIONS(3429),
    [anon_sym_begin] = ACTIONS(3431),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(4892),
    [anon_sym_LT2] = ACTIONS(4894),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4896),
    [anon_sym_or] = ACTIONS(3431),
    [aux_sym_char_token1] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [anon_sym_AT_DQUOTE] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [sym_bool] = ACTIONS(3431),
    [sym_unit] = ACTIONS(3429),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3431),
    [sym_op_identifier] = ACTIONS(3431),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_DOT] = ACTIONS(3431),
    [anon_sym_DASH_DOT] = ACTIONS(3431),
    [anon_sym_PERCENT] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3429),
    [aux_sym_prefix_op_token1] = ACTIONS(3431),
    [aux_sym_infix_op_token1] = ACTIONS(3429),
    [aux_sym_infix_op_token2] = ACTIONS(3431),
    [anon_sym_PIPE_PIPE] = ACTIONS(3431),
    [anon_sym_BANG_EQ] = ACTIONS(3431),
    [anon_sym_COLON_EQ] = ACTIONS(3429),
    [anon_sym_DOLLAR] = ACTIONS(3431),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3431),
    [sym_int] = ACTIONS(3431),
    [sym_xint] = ACTIONS(3429),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3429),
    [sym__newline] = ACTIONS(3429),
  },
  [2342] = {
    [sym__else_expression] = STATE(2882),
    [sym_elif_expression] = STATE(2693),
    [sym_block_comment] = STATE(2342),
    [sym_compiler_directive_decl] = STATE(2342),
    [sym_fsi_directive_decl] = STATE(2342),
    [sym_preproc_line] = STATE(2342),
    [aux_sym_if_expression_repeat1] = STATE(2385),
    [sym_identifier] = ACTIONS(3457),
    [anon_sym_EQ] = ACTIONS(3455),
    [anon_sym_COLON] = ACTIONS(3457),
    [anon_sym_return] = ACTIONS(3457),
    [anon_sym_do] = ACTIONS(3457),
    [anon_sym_let] = ACTIONS(3457),
    [anon_sym_let_BANG] = ACTIONS(3455),
    [anon_sym_as] = ACTIONS(3457),
    [anon_sym_LPAREN] = ACTIONS(3457),
    [anon_sym_COMMA] = ACTIONS(3455),
    [anon_sym_null] = ACTIONS(3457),
    [anon_sym_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_COLON] = ACTIONS(3455),
    [anon_sym_AMP] = ACTIONS(3457),
    [anon_sym_LBRACK] = ACTIONS(3457),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3457),
    [anon_sym_LT_AT] = ACTIONS(3457),
    [anon_sym_LT_AT_AT] = ACTIONS(3457),
    [anon_sym_DOT] = ACTIONS(3457),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3457),
    [anon_sym_with] = ACTIONS(3457),
    [anon_sym_return_BANG] = ACTIONS(3455),
    [anon_sym_yield] = ACTIONS(3457),
    [anon_sym_yield_BANG] = ACTIONS(3455),
    [anon_sym_lazy] = ACTIONS(3457),
    [anon_sym_assert] = ACTIONS(3457),
    [anon_sym_upcast] = ACTIONS(3457),
    [anon_sym_downcast] = ACTIONS(3457),
    [anon_sym_COLON_GT] = ACTIONS(3455),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3457),
    [anon_sym_while] = ACTIONS(3457),
    [anon_sym_else] = ACTIONS(4926),
    [anon_sym_elif] = ACTIONS(4928),
    [anon_sym_if] = ACTIONS(3457),
    [anon_sym_fun] = ACTIONS(3457),
    [anon_sym_try] = ACTIONS(3457),
    [anon_sym_match] = ACTIONS(3457),
    [anon_sym_match_BANG] = ACTIONS(3455),
    [anon_sym_function] = ACTIONS(3457),
    [anon_sym_LT_DASH] = ACTIONS(3457),
    [anon_sym_DOT_LBRACK] = ACTIONS(3455),
    [anon_sym_LT] = ACTIONS(3455),
    [anon_sym_use] = ACTIONS(3457),
    [anon_sym_use_BANG] = ACTIONS(3455),
    [anon_sym_do_BANG] = ACTIONS(3455),
    [anon_sym_begin] = ACTIONS(3457),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_or] = ACTIONS(3457),
    [aux_sym_char_token1] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [anon_sym_AT_DQUOTE] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [sym_bool] = ACTIONS(3457),
    [sym_unit] = ACTIONS(3455),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3457),
    [sym_op_identifier] = ACTIONS(3457),
    [anon_sym_PLUS] = ACTIONS(3457),
    [anon_sym_DASH] = ACTIONS(3457),
    [anon_sym_PLUS_DOT] = ACTIONS(3457),
    [anon_sym_DASH_DOT] = ACTIONS(3457),
    [anon_sym_PERCENT] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3455),
    [aux_sym_prefix_op_token1] = ACTIONS(3457),
    [aux_sym_infix_op_token1] = ACTIONS(3455),
    [aux_sym_infix_op_token2] = ACTIONS(3457),
    [anon_sym_PIPE_PIPE] = ACTIONS(3457),
    [anon_sym_BANG_EQ] = ACTIONS(3457),
    [anon_sym_COLON_EQ] = ACTIONS(3455),
    [anon_sym_DOLLAR] = ACTIONS(3457),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3457),
    [sym_int] = ACTIONS(3457),
    [sym_xint] = ACTIONS(3455),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3455),
    [sym__newline] = ACTIONS(3455),
    [sym__dedent] = ACTIONS(3455),
  },
  [2343] = {
    [sym__else_expression] = STATE(2854),
    [sym_elif_expression] = STATE(2693),
    [sym_block_comment] = STATE(2343),
    [sym_compiler_directive_decl] = STATE(2343),
    [sym_fsi_directive_decl] = STATE(2343),
    [sym_preproc_line] = STATE(2343),
    [aux_sym_if_expression_repeat1] = STATE(2342),
    [sym_identifier] = ACTIONS(3472),
    [anon_sym_EQ] = ACTIONS(3470),
    [anon_sym_COLON] = ACTIONS(3472),
    [anon_sym_return] = ACTIONS(3472),
    [anon_sym_do] = ACTIONS(3472),
    [anon_sym_let] = ACTIONS(3472),
    [anon_sym_let_BANG] = ACTIONS(3470),
    [anon_sym_as] = ACTIONS(3472),
    [anon_sym_LPAREN] = ACTIONS(3472),
    [anon_sym_COMMA] = ACTIONS(3470),
    [anon_sym_null] = ACTIONS(3472),
    [anon_sym_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_COLON] = ACTIONS(3470),
    [anon_sym_AMP] = ACTIONS(3472),
    [anon_sym_LBRACK] = ACTIONS(3472),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3470),
    [anon_sym_LBRACE] = ACTIONS(3472),
    [anon_sym_LT_AT] = ACTIONS(3472),
    [anon_sym_LT_AT_AT] = ACTIONS(3472),
    [anon_sym_DOT] = ACTIONS(3472),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3470),
    [anon_sym_new] = ACTIONS(3472),
    [anon_sym_with] = ACTIONS(3472),
    [anon_sym_return_BANG] = ACTIONS(3470),
    [anon_sym_yield] = ACTIONS(3472),
    [anon_sym_yield_BANG] = ACTIONS(3470),
    [anon_sym_lazy] = ACTIONS(3472),
    [anon_sym_assert] = ACTIONS(3472),
    [anon_sym_upcast] = ACTIONS(3472),
    [anon_sym_downcast] = ACTIONS(3472),
    [anon_sym_COLON_GT] = ACTIONS(3470),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3470),
    [anon_sym_for] = ACTIONS(3472),
    [anon_sym_while] = ACTIONS(3472),
    [anon_sym_else] = ACTIONS(4926),
    [anon_sym_elif] = ACTIONS(4928),
    [anon_sym_if] = ACTIONS(3472),
    [anon_sym_fun] = ACTIONS(3472),
    [anon_sym_try] = ACTIONS(3472),
    [anon_sym_match] = ACTIONS(3472),
    [anon_sym_match_BANG] = ACTIONS(3470),
    [anon_sym_function] = ACTIONS(3472),
    [anon_sym_LT_DASH] = ACTIONS(3472),
    [anon_sym_DOT_LBRACK] = ACTIONS(3470),
    [anon_sym_LT] = ACTIONS(3470),
    [anon_sym_use] = ACTIONS(3472),
    [anon_sym_use_BANG] = ACTIONS(3470),
    [anon_sym_do_BANG] = ACTIONS(3470),
    [anon_sym_begin] = ACTIONS(3472),
    [anon_sym_LPAREN2] = ACTIONS(3472),
    [anon_sym_or] = ACTIONS(3472),
    [aux_sym_char_token1] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3472),
    [anon_sym_DQUOTE] = ACTIONS(3472),
    [anon_sym_AT_DQUOTE] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [sym_bool] = ACTIONS(3472),
    [sym_unit] = ACTIONS(3470),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3472),
    [sym_op_identifier] = ACTIONS(3472),
    [anon_sym_PLUS] = ACTIONS(3472),
    [anon_sym_DASH] = ACTIONS(3472),
    [anon_sym_PLUS_DOT] = ACTIONS(3472),
    [anon_sym_DASH_DOT] = ACTIONS(3472),
    [anon_sym_PERCENT] = ACTIONS(3472),
    [anon_sym_AMP_AMP] = ACTIONS(3472),
    [anon_sym_TILDE] = ACTIONS(3470),
    [aux_sym_prefix_op_token1] = ACTIONS(3472),
    [aux_sym_infix_op_token1] = ACTIONS(3470),
    [aux_sym_infix_op_token2] = ACTIONS(3472),
    [anon_sym_PIPE_PIPE] = ACTIONS(3472),
    [anon_sym_BANG_EQ] = ACTIONS(3472),
    [anon_sym_COLON_EQ] = ACTIONS(3470),
    [anon_sym_DOLLAR] = ACTIONS(3472),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3472),
    [sym_int] = ACTIONS(3472),
    [sym_xint] = ACTIONS(3470),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3470),
    [sym__newline] = ACTIONS(3470),
    [sym__dedent] = ACTIONS(3470),
  },
  [2344] = {
    [sym_block_comment] = STATE(2344),
    [sym_compiler_directive_decl] = STATE(2344),
    [sym_fsi_directive_decl] = STATE(2344),
    [sym_preproc_line] = STATE(2344),
    [aux_sym_long_identifier_repeat1] = STATE(2318),
    [ts_builtin_sym_end] = ACTIONS(3778),
    [sym_identifier] = ACTIONS(3781),
    [anon_sym_namespace] = ACTIONS(3781),
    [anon_sym_module] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3778),
    [anon_sym_open] = ACTIONS(3781),
    [anon_sym_LBRACK_LT] = ACTIONS(3778),
    [anon_sym_COLON] = ACTIONS(3781),
    [anon_sym_return] = ACTIONS(3781),
    [anon_sym_type] = ACTIONS(3781),
    [anon_sym_do] = ACTIONS(3781),
    [anon_sym_let] = ACTIONS(3781),
    [anon_sym_let_BANG] = ACTIONS(3778),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3778),
    [anon_sym_null] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3781),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_LT_AT] = ACTIONS(3781),
    [anon_sym_LT_AT_AT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(4930),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3778),
    [anon_sym_new] = ACTIONS(3781),
    [anon_sym_return_BANG] = ACTIONS(3778),
    [anon_sym_yield] = ACTIONS(3781),
    [anon_sym_yield_BANG] = ACTIONS(3778),
    [anon_sym_lazy] = ACTIONS(3781),
    [anon_sym_assert] = ACTIONS(3781),
    [anon_sym_upcast] = ACTIONS(3781),
    [anon_sym_downcast] = ACTIONS(3781),
    [anon_sym_COLON_GT] = ACTIONS(3778),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3778),
    [anon_sym_for] = ACTIONS(3781),
    [anon_sym_while] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_fun] = ACTIONS(3781),
    [anon_sym_try] = ACTIONS(3781),
    [anon_sym_match] = ACTIONS(3781),
    [anon_sym_match_BANG] = ACTIONS(3778),
    [anon_sym_function] = ACTIONS(3781),
    [anon_sym_LT_DASH] = ACTIONS(3781),
    [anon_sym_DOT_LBRACK] = ACTIONS(3778),
    [anon_sym_LT] = ACTIONS(3778),
    [anon_sym_use] = ACTIONS(3781),
    [anon_sym_use_BANG] = ACTIONS(3778),
    [anon_sym_do_BANG] = ACTIONS(3778),
    [anon_sym_begin] = ACTIONS(3781),
    [anon_sym_LPAREN2] = ACTIONS(3781),
    [anon_sym_or] = ACTIONS(3781),
    [anon_sym_exception] = ACTIONS(3781),
    [aux_sym_char_token1] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3781),
    [anon_sym_DQUOTE] = ACTIONS(3781),
    [anon_sym_AT_DQUOTE] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [sym_bool] = ACTIONS(3781),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3781),
    [sym_op_identifier] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3781),
    [anon_sym_DASH] = ACTIONS(3781),
    [anon_sym_PLUS_DOT] = ACTIONS(3781),
    [anon_sym_DASH_DOT] = ACTIONS(3781),
    [anon_sym_PERCENT] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3781),
    [anon_sym_TILDE] = ACTIONS(3778),
    [aux_sym_prefix_op_token1] = ACTIONS(3781),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token2] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_COLON_EQ] = ACTIONS(3778),
    [anon_sym_DOLLAR] = ACTIONS(3781),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3781),
    [sym_int] = ACTIONS(3781),
    [sym_xint] = ACTIONS(3778),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3778),
    [anon_sym_POUNDload] = ACTIONS(3778),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3778),
    [sym__newline] = ACTIONS(3778),
  },
  [2345] = {
    [sym_block_comment] = STATE(2345),
    [sym_compiler_directive_decl] = STATE(2345),
    [sym_fsi_directive_decl] = STATE(2345),
    [sym_preproc_line] = STATE(2345),
    [aux_sym_compound_type_repeat1] = STATE(2347),
    [sym_identifier] = ACTIONS(3468),
    [anon_sym_EQ] = ACTIONS(3466),
    [anon_sym_COLON] = ACTIONS(3468),
    [anon_sym_return] = ACTIONS(3468),
    [anon_sym_do] = ACTIONS(3468),
    [anon_sym_let] = ACTIONS(3468),
    [anon_sym_let_BANG] = ACTIONS(3466),
    [anon_sym_as] = ACTIONS(3468),
    [anon_sym_LPAREN] = ACTIONS(3468),
    [anon_sym_COMMA] = ACTIONS(3466),
    [anon_sym_null] = ACTIONS(3468),
    [anon_sym_QMARK] = ACTIONS(3468),
    [anon_sym_COLON_QMARK] = ACTIONS(3468),
    [anon_sym_COLON_COLON] = ACTIONS(3466),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LBRACK] = ACTIONS(3468),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3466),
    [anon_sym_LBRACE] = ACTIONS(3468),
    [anon_sym_LT_AT] = ACTIONS(3468),
    [anon_sym_LT_AT_AT] = ACTIONS(3468),
    [anon_sym_DOT] = ACTIONS(3468),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3466),
    [anon_sym_new] = ACTIONS(3468),
    [anon_sym_with] = ACTIONS(3468),
    [anon_sym_return_BANG] = ACTIONS(3466),
    [anon_sym_yield] = ACTIONS(3468),
    [anon_sym_yield_BANG] = ACTIONS(3466),
    [anon_sym_lazy] = ACTIONS(3468),
    [anon_sym_assert] = ACTIONS(3468),
    [anon_sym_upcast] = ACTIONS(3468),
    [anon_sym_downcast] = ACTIONS(3468),
    [anon_sym_COLON_GT] = ACTIONS(3466),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3466),
    [anon_sym_for] = ACTIONS(3468),
    [anon_sym_while] = ACTIONS(3468),
    [anon_sym_if] = ACTIONS(3468),
    [anon_sym_fun] = ACTIONS(3468),
    [anon_sym_DASH_GT] = ACTIONS(3468),
    [anon_sym_try] = ACTIONS(3468),
    [anon_sym_match] = ACTIONS(3468),
    [anon_sym_match_BANG] = ACTIONS(3466),
    [anon_sym_function] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3468),
    [anon_sym_DOT_LBRACK] = ACTIONS(3466),
    [anon_sym_LT] = ACTIONS(3466),
    [anon_sym_use] = ACTIONS(3468),
    [anon_sym_use_BANG] = ACTIONS(3466),
    [anon_sym_do_BANG] = ACTIONS(3466),
    [anon_sym_begin] = ACTIONS(3468),
    [anon_sym_LPAREN2] = ACTIONS(3468),
    [anon_sym_STAR] = ACTIONS(4802),
    [anon_sym_LT2] = ACTIONS(3468),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3466),
    [anon_sym_or] = ACTIONS(3468),
    [aux_sym_char_token1] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3468),
    [anon_sym_DQUOTE] = ACTIONS(3468),
    [anon_sym_AT_DQUOTE] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [sym_bool] = ACTIONS(3468),
    [sym_unit] = ACTIONS(3466),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3468),
    [sym_op_identifier] = ACTIONS(3468),
    [anon_sym_PLUS] = ACTIONS(3468),
    [anon_sym_DASH] = ACTIONS(3468),
    [anon_sym_PLUS_DOT] = ACTIONS(3468),
    [anon_sym_DASH_DOT] = ACTIONS(3468),
    [anon_sym_PERCENT] = ACTIONS(3468),
    [anon_sym_AMP_AMP] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3466),
    [aux_sym_prefix_op_token1] = ACTIONS(3468),
    [aux_sym_infix_op_token1] = ACTIONS(3466),
    [aux_sym_infix_op_token2] = ACTIONS(3468),
    [anon_sym_PIPE_PIPE] = ACTIONS(3468),
    [anon_sym_BANG_EQ] = ACTIONS(3468),
    [anon_sym_COLON_EQ] = ACTIONS(3466),
    [anon_sym_DOLLAR] = ACTIONS(3468),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3468),
    [sym_int] = ACTIONS(3468),
    [sym_xint] = ACTIONS(3466),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3466),
    [sym__newline] = ACTIONS(3466),
    [sym__dedent] = ACTIONS(3466),
  },
  [2346] = {
    [sym_block_comment] = STATE(2346),
    [sym_compiler_directive_decl] = STATE(2346),
    [sym_fsi_directive_decl] = STATE(2346),
    [sym_preproc_line] = STATE(2346),
    [sym_identifier] = ACTIONS(3813),
    [anon_sym_EQ] = ACTIONS(3811),
    [anon_sym_GT_RBRACK] = ACTIONS(3811),
    [anon_sym_COLON] = ACTIONS(3813),
    [anon_sym_return] = ACTIONS(3813),
    [anon_sym_do] = ACTIONS(3813),
    [anon_sym_let] = ACTIONS(3813),
    [anon_sym_let_BANG] = ACTIONS(3811),
    [anon_sym_LPAREN] = ACTIONS(3813),
    [anon_sym_COMMA] = ACTIONS(3811),
    [anon_sym_null] = ACTIONS(3813),
    [anon_sym_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_COLON] = ACTIONS(3811),
    [anon_sym_AMP] = ACTIONS(3813),
    [anon_sym_LBRACK] = ACTIONS(3813),
    [anon_sym_RBRACK] = ACTIONS(3811),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3811),
    [anon_sym_LBRACE] = ACTIONS(3813),
    [anon_sym_RBRACE] = ACTIONS(3811),
    [anon_sym_LT_AT] = ACTIONS(3813),
    [anon_sym_LT_AT_AT] = ACTIONS(3813),
    [anon_sym_DOT] = ACTIONS(3813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3811),
    [anon_sym_new] = ACTIONS(3813),
    [anon_sym_with] = ACTIONS(3813),
    [anon_sym_return_BANG] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_yield_BANG] = ACTIONS(3811),
    [anon_sym_lazy] = ACTIONS(3813),
    [anon_sym_assert] = ACTIONS(3813),
    [anon_sym_upcast] = ACTIONS(3813),
    [anon_sym_downcast] = ACTIONS(3813),
    [anon_sym_COLON_GT] = ACTIONS(3811),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3811),
    [anon_sym_for] = ACTIONS(3813),
    [anon_sym_to] = ACTIONS(3813),
    [anon_sym_downto] = ACTIONS(3813),
    [anon_sym_done] = ACTIONS(4934),
    [anon_sym_while] = ACTIONS(3813),
    [anon_sym_if] = ACTIONS(3813),
    [anon_sym_fun] = ACTIONS(3813),
    [anon_sym_try] = ACTIONS(3813),
    [anon_sym_match] = ACTIONS(3813),
    [anon_sym_match_BANG] = ACTIONS(3811),
    [anon_sym_function] = ACTIONS(3813),
    [anon_sym_LT_DASH] = ACTIONS(3813),
    [anon_sym_DOT_LBRACK] = ACTIONS(3811),
    [anon_sym_LT] = ACTIONS(3811),
    [anon_sym_use] = ACTIONS(3813),
    [anon_sym_use_BANG] = ACTIONS(3811),
    [anon_sym_do_BANG] = ACTIONS(3811),
    [anon_sym_begin] = ACTIONS(3813),
    [anon_sym_LPAREN2] = ACTIONS(3813),
    [anon_sym_DOT_DOT2] = ACTIONS(3811),
    [anon_sym_or] = ACTIONS(3813),
    [aux_sym_char_token1] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3813),
    [anon_sym_DQUOTE] = ACTIONS(3813),
    [anon_sym_AT_DQUOTE] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [sym_bool] = ACTIONS(3813),
    [sym_unit] = ACTIONS(3811),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3813),
    [sym_op_identifier] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PLUS_DOT] = ACTIONS(3813),
    [anon_sym_DASH_DOT] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3813),
    [anon_sym_AMP_AMP] = ACTIONS(3813),
    [anon_sym_TILDE] = ACTIONS(3811),
    [aux_sym_prefix_op_token1] = ACTIONS(3813),
    [aux_sym_infix_op_token1] = ACTIONS(3811),
    [aux_sym_infix_op_token2] = ACTIONS(3813),
    [anon_sym_PIPE_PIPE] = ACTIONS(3813),
    [anon_sym_BANG_EQ] = ACTIONS(3813),
    [anon_sym_COLON_EQ] = ACTIONS(3811),
    [anon_sym_DOLLAR] = ACTIONS(3813),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3813),
    [sym_int] = ACTIONS(3813),
    [sym_xint] = ACTIONS(3811),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3811),
    [sym__newline] = ACTIONS(3811),
  },
  [2347] = {
    [sym_block_comment] = STATE(2347),
    [sym_compiler_directive_decl] = STATE(2347),
    [sym_fsi_directive_decl] = STATE(2347),
    [sym_preproc_line] = STATE(2347),
    [aux_sym_compound_type_repeat1] = STATE(2347),
    [sym_identifier] = ACTIONS(3427),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [anon_sym_as] = ACTIONS(3427),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3427),
    [anon_sym_DOT] = ACTIONS(3427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_with] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_COLON_GT] = ACTIONS(3425),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(3427),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_LT_DASH] = ACTIONS(3427),
    [anon_sym_DOT_LBRACK] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(4936),
    [anon_sym_LT2] = ACTIONS(3427),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3425),
    [anon_sym_or] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3427),
    [anon_sym_DASH_DOT] = ACTIONS(3427),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3427),
    [aux_sym_infix_op_token1] = ACTIONS(3425),
    [aux_sym_infix_op_token2] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3427),
    [anon_sym_COLON_EQ] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3427),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
    [sym__dedent] = ACTIONS(3425),
  },
  [2348] = {
    [sym_type_arguments] = STATE(2692),
    [sym_long_identifier] = STATE(2683),
    [sym_block_comment] = STATE(2348),
    [sym_compiler_directive_decl] = STATE(2348),
    [sym_fsi_directive_decl] = STATE(2348),
    [sym_preproc_line] = STATE(2348),
    [aux_sym_compound_type_repeat1] = STATE(2563),
    [sym_identifier] = ACTIONS(4874),
    [anon_sym_EQ] = ACTIONS(3417),
    [anon_sym_COLON] = ACTIONS(3419),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_let] = ACTIONS(3419),
    [anon_sym_let_BANG] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(3419),
    [anon_sym_COMMA] = ACTIONS(3417),
    [anon_sym_null] = ACTIONS(3419),
    [anon_sym_QMARK] = ACTIONS(3419),
    [anon_sym_COLON_QMARK] = ACTIONS(3419),
    [anon_sym_COLON_COLON] = ACTIONS(3417),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_LT_AT] = ACTIONS(3419),
    [anon_sym_LT_AT_AT] = ACTIONS(3419),
    [anon_sym_DOT] = ACTIONS(3419),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_return_BANG] = ACTIONS(3417),
    [anon_sym_yield] = ACTIONS(3419),
    [anon_sym_yield_BANG] = ACTIONS(3417),
    [anon_sym_lazy] = ACTIONS(3419),
    [anon_sym_assert] = ACTIONS(3419),
    [anon_sym_upcast] = ACTIONS(3419),
    [anon_sym_downcast] = ACTIONS(3419),
    [anon_sym_COLON_GT] = ACTIONS(3417),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3417),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_fun] = ACTIONS(3419),
    [anon_sym_DASH_GT] = ACTIONS(4876),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_match] = ACTIONS(3419),
    [anon_sym_match_BANG] = ACTIONS(3417),
    [anon_sym_function] = ACTIONS(3419),
    [anon_sym_LT_DASH] = ACTIONS(3419),
    [anon_sym_DOT_LBRACK] = ACTIONS(3417),
    [anon_sym_LT] = ACTIONS(3417),
    [anon_sym_GT] = ACTIONS(3419),
    [anon_sym_use] = ACTIONS(3419),
    [anon_sym_use_BANG] = ACTIONS(3417),
    [anon_sym_do_BANG] = ACTIONS(3417),
    [anon_sym_begin] = ACTIONS(3419),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(4878),
    [anon_sym_LT2] = ACTIONS(4880),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4882),
    [anon_sym_or] = ACTIONS(3419),
    [aux_sym_char_token1] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3419),
    [anon_sym_AT_DQUOTE] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [sym_bool] = ACTIONS(3419),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3419),
    [sym_op_identifier] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_PLUS_DOT] = ACTIONS(3419),
    [anon_sym_DASH_DOT] = ACTIONS(3419),
    [anon_sym_PERCENT] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3419),
    [anon_sym_TILDE] = ACTIONS(3417),
    [aux_sym_prefix_op_token1] = ACTIONS(3419),
    [aux_sym_infix_op_token1] = ACTIONS(3417),
    [aux_sym_infix_op_token2] = ACTIONS(3419),
    [anon_sym_PIPE_PIPE] = ACTIONS(3419),
    [anon_sym_BANG_EQ] = ACTIONS(3419),
    [anon_sym_COLON_EQ] = ACTIONS(3417),
    [anon_sym_DOLLAR] = ACTIONS(3419),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3419),
    [sym_int] = ACTIONS(3419),
    [sym_xint] = ACTIONS(3417),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3417),
    [sym__newline] = ACTIONS(3417),
  },
  [2349] = {
    [sym_type_arguments] = STATE(2637),
    [sym_long_identifier] = STATE(2681),
    [sym_block_comment] = STATE(2349),
    [sym_compiler_directive_decl] = STATE(2349),
    [sym_fsi_directive_decl] = STATE(2349),
    [sym_preproc_line] = STATE(2349),
    [aux_sym_compound_type_repeat1] = STATE(2555),
    [sym_identifier] = ACTIONS(4898),
    [anon_sym_EQ] = ACTIONS(3417),
    [anon_sym_COLON] = ACTIONS(3419),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_let] = ACTIONS(3419),
    [anon_sym_let_BANG] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(3419),
    [anon_sym_COMMA] = ACTIONS(3417),
    [anon_sym_null] = ACTIONS(3419),
    [anon_sym_QMARK] = ACTIONS(3419),
    [anon_sym_COLON_QMARK] = ACTIONS(3419),
    [anon_sym_COLON_COLON] = ACTIONS(3417),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_LT_AT] = ACTIONS(3419),
    [anon_sym_AT_GT] = ACTIONS(3419),
    [anon_sym_LT_AT_AT] = ACTIONS(3419),
    [anon_sym_DOT] = ACTIONS(3419),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_return_BANG] = ACTIONS(3417),
    [anon_sym_yield] = ACTIONS(3419),
    [anon_sym_yield_BANG] = ACTIONS(3417),
    [anon_sym_lazy] = ACTIONS(3419),
    [anon_sym_assert] = ACTIONS(3419),
    [anon_sym_upcast] = ACTIONS(3419),
    [anon_sym_downcast] = ACTIONS(3419),
    [anon_sym_COLON_GT] = ACTIONS(3417),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3417),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_fun] = ACTIONS(3419),
    [anon_sym_DASH_GT] = ACTIONS(4900),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_match] = ACTIONS(3419),
    [anon_sym_match_BANG] = ACTIONS(3417),
    [anon_sym_function] = ACTIONS(3419),
    [anon_sym_LT_DASH] = ACTIONS(3419),
    [anon_sym_DOT_LBRACK] = ACTIONS(3417),
    [anon_sym_LT] = ACTIONS(3417),
    [anon_sym_use] = ACTIONS(3419),
    [anon_sym_use_BANG] = ACTIONS(3417),
    [anon_sym_do_BANG] = ACTIONS(3417),
    [anon_sym_begin] = ACTIONS(3419),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(4902),
    [anon_sym_LT2] = ACTIONS(4904),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4906),
    [anon_sym_or] = ACTIONS(3419),
    [aux_sym_char_token1] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3419),
    [anon_sym_AT_DQUOTE] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [sym_bool] = ACTIONS(3419),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3419),
    [sym_op_identifier] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_PLUS_DOT] = ACTIONS(3419),
    [anon_sym_DASH_DOT] = ACTIONS(3419),
    [anon_sym_PERCENT] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3419),
    [anon_sym_TILDE] = ACTIONS(3417),
    [aux_sym_prefix_op_token1] = ACTIONS(3419),
    [aux_sym_infix_op_token1] = ACTIONS(3417),
    [aux_sym_infix_op_token2] = ACTIONS(3419),
    [anon_sym_PIPE_PIPE] = ACTIONS(3419),
    [anon_sym_BANG_EQ] = ACTIONS(3419),
    [anon_sym_COLON_EQ] = ACTIONS(3417),
    [anon_sym_DOLLAR] = ACTIONS(3419),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3419),
    [sym_int] = ACTIONS(3419),
    [sym_xint] = ACTIONS(3417),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3417),
    [sym__newline] = ACTIONS(3417),
  },
  [2350] = {
    [sym_type_arguments] = STATE(2637),
    [sym_long_identifier] = STATE(2681),
    [sym_block_comment] = STATE(2350),
    [sym_compiler_directive_decl] = STATE(2350),
    [sym_fsi_directive_decl] = STATE(2350),
    [sym_preproc_line] = STATE(2350),
    [aux_sym_compound_type_repeat1] = STATE(2555),
    [sym_identifier] = ACTIONS(3443),
    [anon_sym_EQ] = ACTIONS(3441),
    [anon_sym_COLON] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_let] = ACTIONS(3443),
    [anon_sym_let_BANG] = ACTIONS(3441),
    [anon_sym_LPAREN] = ACTIONS(3443),
    [anon_sym_COMMA] = ACTIONS(3441),
    [anon_sym_null] = ACTIONS(3443),
    [anon_sym_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_LT_AT] = ACTIONS(3443),
    [anon_sym_AT_GT] = ACTIONS(3443),
    [anon_sym_LT_AT_AT] = ACTIONS(3443),
    [anon_sym_DOT] = ACTIONS(3443),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_return_BANG] = ACTIONS(3441),
    [anon_sym_yield] = ACTIONS(3443),
    [anon_sym_yield_BANG] = ACTIONS(3441),
    [anon_sym_lazy] = ACTIONS(3443),
    [anon_sym_assert] = ACTIONS(3443),
    [anon_sym_upcast] = ACTIONS(3443),
    [anon_sym_downcast] = ACTIONS(3443),
    [anon_sym_COLON_GT] = ACTIONS(3441),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3441),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_fun] = ACTIONS(3443),
    [anon_sym_DASH_GT] = ACTIONS(4900),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_match] = ACTIONS(3443),
    [anon_sym_match_BANG] = ACTIONS(3441),
    [anon_sym_function] = ACTIONS(3443),
    [anon_sym_LT_DASH] = ACTIONS(3443),
    [anon_sym_DOT_LBRACK] = ACTIONS(3441),
    [anon_sym_LT] = ACTIONS(3441),
    [anon_sym_use] = ACTIONS(3443),
    [anon_sym_use_BANG] = ACTIONS(3441),
    [anon_sym_do_BANG] = ACTIONS(3441),
    [anon_sym_begin] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(4902),
    [anon_sym_LT2] = ACTIONS(4904),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4906),
    [anon_sym_or] = ACTIONS(3443),
    [aux_sym_char_token1] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3443),
    [anon_sym_AT_DQUOTE] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [sym_bool] = ACTIONS(3443),
    [sym_unit] = ACTIONS(3441),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3443),
    [sym_op_identifier] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_PLUS_DOT] = ACTIONS(3443),
    [anon_sym_DASH_DOT] = ACTIONS(3443),
    [anon_sym_PERCENT] = ACTIONS(3443),
    [anon_sym_AMP_AMP] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3441),
    [aux_sym_prefix_op_token1] = ACTIONS(3443),
    [aux_sym_infix_op_token1] = ACTIONS(3441),
    [aux_sym_infix_op_token2] = ACTIONS(3443),
    [anon_sym_PIPE_PIPE] = ACTIONS(3443),
    [anon_sym_BANG_EQ] = ACTIONS(3443),
    [anon_sym_COLON_EQ] = ACTIONS(3441),
    [anon_sym_DOLLAR] = ACTIONS(3443),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3443),
    [sym_int] = ACTIONS(3443),
    [sym_xint] = ACTIONS(3441),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3441),
    [sym__newline] = ACTIONS(3441),
  },
  [2351] = {
    [sym_block_comment] = STATE(2351),
    [sym_compiler_directive_decl] = STATE(2351),
    [sym_fsi_directive_decl] = STATE(2351),
    [sym_preproc_line] = STATE(2351),
    [aux_sym_long_identifier_repeat1] = STATE(2314),
    [sym_identifier] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3778),
    [anon_sym_GT_RBRACK] = ACTIONS(3778),
    [anon_sym_COLON] = ACTIONS(3781),
    [anon_sym_return] = ACTIONS(3781),
    [anon_sym_do] = ACTIONS(3781),
    [anon_sym_let] = ACTIONS(3781),
    [anon_sym_let_BANG] = ACTIONS(3778),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3778),
    [anon_sym_null] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3781),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_RBRACK] = ACTIONS(3778),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_RBRACE] = ACTIONS(3778),
    [anon_sym_LT_AT] = ACTIONS(3781),
    [anon_sym_LT_AT_AT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(4939),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3778),
    [anon_sym_new] = ACTIONS(3781),
    [anon_sym_with] = ACTIONS(3781),
    [anon_sym_return_BANG] = ACTIONS(3778),
    [anon_sym_yield] = ACTIONS(3781),
    [anon_sym_yield_BANG] = ACTIONS(3778),
    [anon_sym_lazy] = ACTIONS(3781),
    [anon_sym_assert] = ACTIONS(3781),
    [anon_sym_upcast] = ACTIONS(3781),
    [anon_sym_downcast] = ACTIONS(3781),
    [anon_sym_COLON_GT] = ACTIONS(3778),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3778),
    [anon_sym_for] = ACTIONS(3781),
    [anon_sym_to] = ACTIONS(3781),
    [anon_sym_downto] = ACTIONS(3781),
    [anon_sym_while] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_fun] = ACTIONS(3781),
    [anon_sym_try] = ACTIONS(3781),
    [anon_sym_match] = ACTIONS(3781),
    [anon_sym_match_BANG] = ACTIONS(3778),
    [anon_sym_function] = ACTIONS(3781),
    [anon_sym_LT_DASH] = ACTIONS(3781),
    [anon_sym_DOT_LBRACK] = ACTIONS(3778),
    [anon_sym_LT] = ACTIONS(3778),
    [anon_sym_use] = ACTIONS(3781),
    [anon_sym_use_BANG] = ACTIONS(3778),
    [anon_sym_do_BANG] = ACTIONS(3778),
    [anon_sym_begin] = ACTIONS(3781),
    [anon_sym_LPAREN2] = ACTIONS(3781),
    [anon_sym_DOT_DOT2] = ACTIONS(3778),
    [anon_sym_or] = ACTIONS(3781),
    [aux_sym_char_token1] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3781),
    [anon_sym_DQUOTE] = ACTIONS(3781),
    [anon_sym_AT_DQUOTE] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [sym_bool] = ACTIONS(3781),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3781),
    [sym_op_identifier] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3781),
    [anon_sym_DASH] = ACTIONS(3781),
    [anon_sym_PLUS_DOT] = ACTIONS(3781),
    [anon_sym_DASH_DOT] = ACTIONS(3781),
    [anon_sym_PERCENT] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3781),
    [anon_sym_TILDE] = ACTIONS(3778),
    [aux_sym_prefix_op_token1] = ACTIONS(3781),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token2] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_COLON_EQ] = ACTIONS(3778),
    [anon_sym_DOLLAR] = ACTIONS(3781),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3781),
    [sym_int] = ACTIONS(3781),
    [sym_xint] = ACTIONS(3778),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3778),
    [sym__newline] = ACTIONS(3778),
  },
  [2352] = {
    [sym_block_comment] = STATE(2352),
    [sym_compiler_directive_decl] = STATE(2352),
    [sym_fsi_directive_decl] = STATE(2352),
    [sym_preproc_line] = STATE(2352),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_GT_RBRACK] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_RBRACK] = ACTIONS(3698),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_RBRACE] = ACTIONS(3698),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_to] = ACTIONS(3700),
    [anon_sym_downto] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_DOT_DOT2] = ACTIONS(3698),
    [anon_sym_or] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [2353] = {
    [sym_block_comment] = STATE(2353),
    [sym_compiler_directive_decl] = STATE(2353),
    [sym_fsi_directive_decl] = STATE(2353),
    [sym_preproc_line] = STATE(2353),
    [aux_sym_long_identifier_repeat1] = STATE(2353),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_GT_RBRACK] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_RBRACK] = ACTIONS(3485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_RBRACE] = ACTIONS(3485),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(4943),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_to] = ACTIONS(3487),
    [anon_sym_downto] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_DOT_DOT2] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [2354] = {
    [sym_block_comment] = STATE(2354),
    [sym_compiler_directive_decl] = STATE(2354),
    [sym_fsi_directive_decl] = STATE(2354),
    [sym_preproc_line] = STATE(2354),
    [aux_sym_type_argument_repeat1] = STATE(2327),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [anon_sym_as] = ACTIONS(3498),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_with] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [anon_sym_DOT_LBRACK] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_or] = ACTIONS(4946),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3498),
    [anon_sym_DASH_DOT] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3498),
    [aux_sym_infix_op_token1] = ACTIONS(3496),
    [aux_sym_infix_op_token2] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_COLON_EQ] = ACTIONS(3496),
    [anon_sym_DOLLAR] = ACTIONS(3498),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3498),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
    [sym__dedent] = ACTIONS(3496),
  },
  [2355] = {
    [sym_type_arguments] = STATE(2702),
    [sym_long_identifier] = STATE(2689),
    [sym_block_comment] = STATE(2355),
    [sym_compiler_directive_decl] = STATE(2355),
    [sym_fsi_directive_decl] = STATE(2355),
    [sym_preproc_line] = STATE(2355),
    [aux_sym_compound_type_repeat1] = STATE(2575),
    [sym_identifier] = ACTIONS(4870),
    [anon_sym_EQ] = ACTIONS(3417),
    [anon_sym_COLON] = ACTIONS(3419),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_let] = ACTIONS(3419),
    [anon_sym_let_BANG] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(3419),
    [anon_sym_COMMA] = ACTIONS(3417),
    [anon_sym_null] = ACTIONS(3419),
    [anon_sym_QMARK] = ACTIONS(3419),
    [anon_sym_COLON_QMARK] = ACTIONS(3419),
    [anon_sym_COLON_COLON] = ACTIONS(3417),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_LT_AT] = ACTIONS(3419),
    [anon_sym_LT_AT_AT] = ACTIONS(3419),
    [anon_sym_DOT] = ACTIONS(3419),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_return_BANG] = ACTIONS(3417),
    [anon_sym_yield] = ACTIONS(3419),
    [anon_sym_yield_BANG] = ACTIONS(3417),
    [anon_sym_lazy] = ACTIONS(3419),
    [anon_sym_assert] = ACTIONS(3419),
    [anon_sym_upcast] = ACTIONS(3419),
    [anon_sym_downcast] = ACTIONS(3419),
    [anon_sym_COLON_GT] = ACTIONS(3417),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3417),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_fun] = ACTIONS(3419),
    [anon_sym_DASH_GT] = ACTIONS(4872),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_match] = ACTIONS(3419),
    [anon_sym_match_BANG] = ACTIONS(3417),
    [anon_sym_function] = ACTIONS(3419),
    [anon_sym_LT_DASH] = ACTIONS(3419),
    [anon_sym_DOT_LBRACK] = ACTIONS(3417),
    [anon_sym_LT] = ACTIONS(3417),
    [anon_sym_use] = ACTIONS(3419),
    [anon_sym_use_BANG] = ACTIONS(3417),
    [anon_sym_do_BANG] = ACTIONS(3417),
    [anon_sym_DOT_DOT] = ACTIONS(3417),
    [anon_sym_begin] = ACTIONS(3419),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(4860),
    [anon_sym_LT2] = ACTIONS(4862),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4864),
    [anon_sym_or] = ACTIONS(3419),
    [aux_sym_char_token1] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3419),
    [anon_sym_AT_DQUOTE] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [sym_bool] = ACTIONS(3419),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3419),
    [sym_op_identifier] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_PLUS_DOT] = ACTIONS(3419),
    [anon_sym_DASH_DOT] = ACTIONS(3419),
    [anon_sym_PERCENT] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3419),
    [anon_sym_TILDE] = ACTIONS(3417),
    [aux_sym_prefix_op_token1] = ACTIONS(3419),
    [aux_sym_infix_op_token1] = ACTIONS(3417),
    [aux_sym_infix_op_token2] = ACTIONS(3419),
    [anon_sym_PIPE_PIPE] = ACTIONS(3419),
    [anon_sym_BANG_EQ] = ACTIONS(3419),
    [anon_sym_COLON_EQ] = ACTIONS(3417),
    [anon_sym_DOLLAR] = ACTIONS(3419),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3419),
    [sym_int] = ACTIONS(3419),
    [sym_xint] = ACTIONS(3417),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3417),
    [sym__newline] = ACTIONS(3417),
  },
  [2356] = {
    [sym_type_arguments] = STATE(2702),
    [sym_long_identifier] = STATE(2689),
    [sym_block_comment] = STATE(2356),
    [sym_compiler_directive_decl] = STATE(2356),
    [sym_fsi_directive_decl] = STATE(2356),
    [sym_preproc_line] = STATE(2356),
    [aux_sym_compound_type_repeat1] = STATE(2575),
    [sym_identifier] = ACTIONS(3443),
    [anon_sym_EQ] = ACTIONS(3441),
    [anon_sym_COLON] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_let] = ACTIONS(3443),
    [anon_sym_let_BANG] = ACTIONS(3441),
    [anon_sym_LPAREN] = ACTIONS(3443),
    [anon_sym_COMMA] = ACTIONS(3441),
    [anon_sym_null] = ACTIONS(3443),
    [anon_sym_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_LT_AT] = ACTIONS(3443),
    [anon_sym_LT_AT_AT] = ACTIONS(3443),
    [anon_sym_DOT] = ACTIONS(3443),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_return_BANG] = ACTIONS(3441),
    [anon_sym_yield] = ACTIONS(3443),
    [anon_sym_yield_BANG] = ACTIONS(3441),
    [anon_sym_lazy] = ACTIONS(3443),
    [anon_sym_assert] = ACTIONS(3443),
    [anon_sym_upcast] = ACTIONS(3443),
    [anon_sym_downcast] = ACTIONS(3443),
    [anon_sym_COLON_GT] = ACTIONS(3441),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3441),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_fun] = ACTIONS(3443),
    [anon_sym_DASH_GT] = ACTIONS(4872),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_match] = ACTIONS(3443),
    [anon_sym_match_BANG] = ACTIONS(3441),
    [anon_sym_function] = ACTIONS(3443),
    [anon_sym_LT_DASH] = ACTIONS(3443),
    [anon_sym_DOT_LBRACK] = ACTIONS(3441),
    [anon_sym_LT] = ACTIONS(3441),
    [anon_sym_use] = ACTIONS(3443),
    [anon_sym_use_BANG] = ACTIONS(3441),
    [anon_sym_do_BANG] = ACTIONS(3441),
    [anon_sym_DOT_DOT] = ACTIONS(3441),
    [anon_sym_begin] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(4860),
    [anon_sym_LT2] = ACTIONS(4862),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4864),
    [anon_sym_or] = ACTIONS(3443),
    [aux_sym_char_token1] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3443),
    [anon_sym_AT_DQUOTE] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [sym_bool] = ACTIONS(3443),
    [sym_unit] = ACTIONS(3441),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3443),
    [sym_op_identifier] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_PLUS_DOT] = ACTIONS(3443),
    [anon_sym_DASH_DOT] = ACTIONS(3443),
    [anon_sym_PERCENT] = ACTIONS(3443),
    [anon_sym_AMP_AMP] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3441),
    [aux_sym_prefix_op_token1] = ACTIONS(3443),
    [aux_sym_infix_op_token1] = ACTIONS(3441),
    [aux_sym_infix_op_token2] = ACTIONS(3443),
    [anon_sym_PIPE_PIPE] = ACTIONS(3443),
    [anon_sym_BANG_EQ] = ACTIONS(3443),
    [anon_sym_COLON_EQ] = ACTIONS(3441),
    [anon_sym_DOLLAR] = ACTIONS(3443),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3443),
    [sym_int] = ACTIONS(3443),
    [sym_xint] = ACTIONS(3441),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3441),
    [sym__newline] = ACTIONS(3441),
  },
  [2357] = {
    [sym_type_arguments] = STATE(2637),
    [sym_long_identifier] = STATE(2681),
    [sym_block_comment] = STATE(2357),
    [sym_compiler_directive_decl] = STATE(2357),
    [sym_fsi_directive_decl] = STATE(2357),
    [sym_preproc_line] = STATE(2357),
    [aux_sym_compound_type_repeat1] = STATE(2555),
    [sym_identifier] = ACTIONS(4898),
    [anon_sym_EQ] = ACTIONS(3429),
    [anon_sym_COLON] = ACTIONS(3431),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_let] = ACTIONS(3431),
    [anon_sym_let_BANG] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(3431),
    [anon_sym_COMMA] = ACTIONS(3429),
    [anon_sym_null] = ACTIONS(3431),
    [anon_sym_QMARK] = ACTIONS(3431),
    [anon_sym_COLON_QMARK] = ACTIONS(3431),
    [anon_sym_COLON_COLON] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_LT_AT] = ACTIONS(3431),
    [anon_sym_AT_GT] = ACTIONS(3431),
    [anon_sym_LT_AT_AT] = ACTIONS(3431),
    [anon_sym_DOT] = ACTIONS(3431),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_return_BANG] = ACTIONS(3429),
    [anon_sym_yield] = ACTIONS(3431),
    [anon_sym_yield_BANG] = ACTIONS(3429),
    [anon_sym_lazy] = ACTIONS(3431),
    [anon_sym_assert] = ACTIONS(3431),
    [anon_sym_upcast] = ACTIONS(3431),
    [anon_sym_downcast] = ACTIONS(3431),
    [anon_sym_COLON_GT] = ACTIONS(3429),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_fun] = ACTIONS(3431),
    [anon_sym_DASH_GT] = ACTIONS(4900),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_match] = ACTIONS(3431),
    [anon_sym_match_BANG] = ACTIONS(3429),
    [anon_sym_function] = ACTIONS(3431),
    [anon_sym_LT_DASH] = ACTIONS(3431),
    [anon_sym_DOT_LBRACK] = ACTIONS(3429),
    [anon_sym_LT] = ACTIONS(3429),
    [anon_sym_use] = ACTIONS(3431),
    [anon_sym_use_BANG] = ACTIONS(3429),
    [anon_sym_do_BANG] = ACTIONS(3429),
    [anon_sym_begin] = ACTIONS(3431),
    [anon_sym_LPAREN2] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(4902),
    [anon_sym_LT2] = ACTIONS(4904),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4906),
    [anon_sym_or] = ACTIONS(3431),
    [aux_sym_char_token1] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [anon_sym_AT_DQUOTE] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [sym_bool] = ACTIONS(3431),
    [sym_unit] = ACTIONS(3429),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3431),
    [sym_op_identifier] = ACTIONS(3431),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_DOT] = ACTIONS(3431),
    [anon_sym_DASH_DOT] = ACTIONS(3431),
    [anon_sym_PERCENT] = ACTIONS(3431),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3429),
    [aux_sym_prefix_op_token1] = ACTIONS(3431),
    [aux_sym_infix_op_token1] = ACTIONS(3429),
    [aux_sym_infix_op_token2] = ACTIONS(3431),
    [anon_sym_PIPE_PIPE] = ACTIONS(3431),
    [anon_sym_BANG_EQ] = ACTIONS(3431),
    [anon_sym_COLON_EQ] = ACTIONS(3429),
    [anon_sym_DOLLAR] = ACTIONS(3431),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3431),
    [sym_int] = ACTIONS(3431),
    [sym_xint] = ACTIONS(3429),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3429),
    [sym__newline] = ACTIONS(3429),
  },
  [2358] = {
    [sym_block_comment] = STATE(2358),
    [sym_compiler_directive_decl] = STATE(2358),
    [sym_fsi_directive_decl] = STATE(2358),
    [sym_preproc_line] = STATE(2358),
    [sym_identifier] = ACTIONS(3800),
    [anon_sym_EQ] = ACTIONS(3798),
    [anon_sym_GT_RBRACK] = ACTIONS(3798),
    [anon_sym_COLON] = ACTIONS(3800),
    [anon_sym_return] = ACTIONS(3800),
    [anon_sym_do] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_let_BANG] = ACTIONS(3798),
    [anon_sym_LPAREN] = ACTIONS(3800),
    [anon_sym_COMMA] = ACTIONS(3798),
    [anon_sym_null] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_COLON] = ACTIONS(3798),
    [anon_sym_PIPE] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3800),
    [anon_sym_RBRACK] = ACTIONS(3798),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3798),
    [anon_sym_LBRACE] = ACTIONS(3800),
    [anon_sym_RBRACE] = ACTIONS(3798),
    [anon_sym_LT_AT] = ACTIONS(3800),
    [anon_sym_LT_AT_AT] = ACTIONS(3800),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3798),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_with] = ACTIONS(3800),
    [anon_sym_return_BANG] = ACTIONS(3798),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_yield_BANG] = ACTIONS(3798),
    [anon_sym_lazy] = ACTIONS(3800),
    [anon_sym_assert] = ACTIONS(3800),
    [anon_sym_upcast] = ACTIONS(3800),
    [anon_sym_downcast] = ACTIONS(3800),
    [anon_sym_COLON_GT] = ACTIONS(3798),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3798),
    [anon_sym_for] = ACTIONS(3800),
    [anon_sym_to] = ACTIONS(3800),
    [anon_sym_downto] = ACTIONS(3800),
    [anon_sym_while] = ACTIONS(3800),
    [anon_sym_if] = ACTIONS(3800),
    [anon_sym_fun] = ACTIONS(3800),
    [anon_sym_try] = ACTIONS(3800),
    [anon_sym_match] = ACTIONS(3800),
    [anon_sym_match_BANG] = ACTIONS(3798),
    [anon_sym_function] = ACTIONS(3800),
    [anon_sym_LT_DASH] = ACTIONS(3800),
    [anon_sym_DOT_LBRACK] = ACTIONS(3798),
    [anon_sym_LT] = ACTIONS(3798),
    [anon_sym_use] = ACTIONS(3800),
    [anon_sym_use_BANG] = ACTIONS(3798),
    [anon_sym_do_BANG] = ACTIONS(3798),
    [anon_sym_begin] = ACTIONS(3800),
    [anon_sym_LPAREN2] = ACTIONS(3800),
    [anon_sym_DOT_DOT2] = ACTIONS(3798),
    [anon_sym_or] = ACTIONS(3800),
    [aux_sym_char_token1] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3800),
    [anon_sym_DQUOTE] = ACTIONS(3800),
    [anon_sym_AT_DQUOTE] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [sym_bool] = ACTIONS(3800),
    [sym_unit] = ACTIONS(3798),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3800),
    [sym_op_identifier] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS_DOT] = ACTIONS(3800),
    [anon_sym_DASH_DOT] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3800),
    [anon_sym_AMP_AMP] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3798),
    [aux_sym_prefix_op_token1] = ACTIONS(3800),
    [aux_sym_infix_op_token1] = ACTIONS(3798),
    [aux_sym_infix_op_token2] = ACTIONS(3800),
    [anon_sym_PIPE_PIPE] = ACTIONS(3800),
    [anon_sym_BANG_EQ] = ACTIONS(3800),
    [anon_sym_COLON_EQ] = ACTIONS(3798),
    [anon_sym_DOLLAR] = ACTIONS(3800),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3800),
    [sym_int] = ACTIONS(3800),
    [sym_xint] = ACTIONS(3798),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3798),
    [sym__newline] = ACTIONS(3798),
  },
  [2359] = {
    [sym_block_comment] = STATE(2359),
    [sym_compiler_directive_decl] = STATE(2359),
    [sym_fsi_directive_decl] = STATE(2359),
    [sym_preproc_line] = STATE(2359),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_GT_RBRACK] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_RBRACK] = ACTIONS(3741),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_RBRACE] = ACTIONS(3741),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_with] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_to] = ACTIONS(3743),
    [anon_sym_downto] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_DOT_DOT2] = ACTIONS(3741),
    [anon_sym_or] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [sym__newline] = ACTIONS(3741),
  },
  [2360] = {
    [sym_block_comment] = STATE(2360),
    [sym_compiler_directive_decl] = STATE(2360),
    [sym_fsi_directive_decl] = STATE(2360),
    [sym_preproc_line] = STATE(2360),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_EQ] = ACTIONS(4199),
    [anon_sym_GT_RBRACK] = ACTIONS(4199),
    [anon_sym_COLON] = ACTIONS(4201),
    [anon_sym_return] = ACTIONS(4201),
    [anon_sym_do] = ACTIONS(4201),
    [anon_sym_let] = ACTIONS(4201),
    [anon_sym_let_BANG] = ACTIONS(4199),
    [anon_sym_LPAREN] = ACTIONS(4201),
    [anon_sym_COMMA] = ACTIONS(4199),
    [anon_sym_null] = ACTIONS(4201),
    [anon_sym_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(4199),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_LBRACK] = ACTIONS(4201),
    [anon_sym_RBRACK] = ACTIONS(4199),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4199),
    [anon_sym_LBRACE] = ACTIONS(4201),
    [anon_sym_RBRACE] = ACTIONS(4199),
    [anon_sym_LT_AT] = ACTIONS(4201),
    [anon_sym_LT_AT_AT] = ACTIONS(4201),
    [anon_sym_DOT] = ACTIONS(4201),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4199),
    [anon_sym_new] = ACTIONS(4201),
    [anon_sym_with] = ACTIONS(4201),
    [anon_sym_return_BANG] = ACTIONS(4199),
    [anon_sym_yield] = ACTIONS(4201),
    [anon_sym_yield_BANG] = ACTIONS(4199),
    [anon_sym_lazy] = ACTIONS(4201),
    [anon_sym_assert] = ACTIONS(4201),
    [anon_sym_upcast] = ACTIONS(4201),
    [anon_sym_downcast] = ACTIONS(4201),
    [anon_sym_COLON_GT] = ACTIONS(4199),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4199),
    [anon_sym_for] = ACTIONS(4201),
    [anon_sym_to] = ACTIONS(4201),
    [anon_sym_downto] = ACTIONS(4201),
    [anon_sym_while] = ACTIONS(4201),
    [anon_sym_if] = ACTIONS(4201),
    [anon_sym_fun] = ACTIONS(4201),
    [anon_sym_try] = ACTIONS(4201),
    [anon_sym_match] = ACTIONS(4201),
    [anon_sym_match_BANG] = ACTIONS(4199),
    [anon_sym_function] = ACTIONS(4201),
    [anon_sym_LT_DASH] = ACTIONS(4201),
    [anon_sym_DOT_LBRACK] = ACTIONS(4199),
    [anon_sym_LT] = ACTIONS(4199),
    [anon_sym_use] = ACTIONS(4201),
    [anon_sym_use_BANG] = ACTIONS(4199),
    [anon_sym_do_BANG] = ACTIONS(4199),
    [anon_sym_begin] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(4201),
    [anon_sym_DOT_DOT2] = ACTIONS(4199),
    [anon_sym_or] = ACTIONS(4201),
    [aux_sym_char_token1] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4201),
    [anon_sym_DQUOTE] = ACTIONS(4201),
    [anon_sym_AT_DQUOTE] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [sym_bool] = ACTIONS(4201),
    [sym_unit] = ACTIONS(4199),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4201),
    [sym_op_identifier] = ACTIONS(4201),
    [anon_sym_PLUS] = ACTIONS(4201),
    [anon_sym_DASH] = ACTIONS(4201),
    [anon_sym_PLUS_DOT] = ACTIONS(4201),
    [anon_sym_DASH_DOT] = ACTIONS(4201),
    [anon_sym_PERCENT] = ACTIONS(4201),
    [anon_sym_AMP_AMP] = ACTIONS(4201),
    [anon_sym_TILDE] = ACTIONS(4199),
    [aux_sym_prefix_op_token1] = ACTIONS(4201),
    [aux_sym_infix_op_token1] = ACTIONS(4199),
    [aux_sym_infix_op_token2] = ACTIONS(4201),
    [anon_sym_PIPE_PIPE] = ACTIONS(4201),
    [anon_sym_BANG_EQ] = ACTIONS(4201),
    [anon_sym_COLON_EQ] = ACTIONS(4199),
    [anon_sym_DOLLAR] = ACTIONS(4201),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4201),
    [sym_int] = ACTIONS(4201),
    [sym_xint] = ACTIONS(4199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4199),
    [sym__newline] = ACTIONS(4199),
  },
  [2361] = {
    [sym_block_comment] = STATE(2361),
    [sym_compiler_directive_decl] = STATE(2361),
    [sym_fsi_directive_decl] = STATE(2361),
    [sym_preproc_line] = STATE(2361),
    [aux_sym_long_identifier_repeat1] = STATE(2535),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [anon_sym_as] = ACTIONS(3451),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(4949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_DASH_GT] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_STAR] = ACTIONS(3451),
    [anon_sym_LT2] = ACTIONS(3451),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3449),
    [anon_sym_or] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
  },
  [2362] = {
    [sym_block_comment] = STATE(2362),
    [sym_compiler_directive_decl] = STATE(2362),
    [sym_fsi_directive_decl] = STATE(2362),
    [sym_preproc_line] = STATE(2362),
    [ts_builtin_sym_end] = ACTIONS(4246),
    [sym_identifier] = ACTIONS(4248),
    [anon_sym_namespace] = ACTIONS(4248),
    [anon_sym_module] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4246),
    [anon_sym_open] = ACTIONS(4248),
    [anon_sym_LBRACK_LT] = ACTIONS(4246),
    [anon_sym_COLON] = ACTIONS(4248),
    [anon_sym_return] = ACTIONS(4248),
    [anon_sym_type] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4248),
    [anon_sym_let] = ACTIONS(4248),
    [anon_sym_let_BANG] = ACTIONS(4246),
    [anon_sym_LPAREN] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_null] = ACTIONS(4248),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4248),
    [anon_sym_LT_AT] = ACTIONS(4248),
    [anon_sym_LT_AT_AT] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4246),
    [anon_sym_new] = ACTIONS(4248),
    [anon_sym_return_BANG] = ACTIONS(4246),
    [anon_sym_yield] = ACTIONS(4248),
    [anon_sym_yield_BANG] = ACTIONS(4246),
    [anon_sym_lazy] = ACTIONS(4248),
    [anon_sym_assert] = ACTIONS(4248),
    [anon_sym_upcast] = ACTIONS(4248),
    [anon_sym_downcast] = ACTIONS(4248),
    [anon_sym_COLON_GT] = ACTIONS(4246),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4246),
    [anon_sym_for] = ACTIONS(4248),
    [anon_sym_while] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4248),
    [anon_sym_fun] = ACTIONS(4248),
    [anon_sym_try] = ACTIONS(4248),
    [anon_sym_match] = ACTIONS(4248),
    [anon_sym_match_BANG] = ACTIONS(4246),
    [anon_sym_function] = ACTIONS(4248),
    [anon_sym_LT_DASH] = ACTIONS(4248),
    [anon_sym_DOT_LBRACK] = ACTIONS(4246),
    [anon_sym_LT] = ACTIONS(4246),
    [anon_sym_use] = ACTIONS(4248),
    [anon_sym_use_BANG] = ACTIONS(4246),
    [anon_sym_do_BANG] = ACTIONS(4246),
    [anon_sym_begin] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4248),
    [anon_sym_exception] = ACTIONS(4248),
    [aux_sym_char_token1] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4248),
    [anon_sym_DQUOTE] = ACTIONS(4248),
    [anon_sym_AT_DQUOTE] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [sym_bool] = ACTIONS(4248),
    [sym_unit] = ACTIONS(4246),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4248),
    [sym_op_identifier] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_DOT] = ACTIONS(4248),
    [anon_sym_DASH_DOT] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_TILDE] = ACTIONS(4246),
    [aux_sym_prefix_op_token1] = ACTIONS(4248),
    [aux_sym_infix_op_token1] = ACTIONS(4246),
    [aux_sym_infix_op_token2] = ACTIONS(4248),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_COLON_EQ] = ACTIONS(4246),
    [anon_sym_DOLLAR] = ACTIONS(4248),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4248),
    [sym_int] = ACTIONS(4248),
    [sym_xint] = ACTIONS(4246),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4246),
    [anon_sym_POUNDload] = ACTIONS(4246),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4246),
    [sym__newline] = ACTIONS(4246),
  },
  [2363] = {
    [sym_block_comment] = STATE(2363),
    [sym_compiler_directive_decl] = STATE(2363),
    [sym_fsi_directive_decl] = STATE(2363),
    [sym_preproc_line] = STATE(2363),
    [ts_builtin_sym_end] = ACTIONS(4172),
    [sym_identifier] = ACTIONS(4174),
    [anon_sym_namespace] = ACTIONS(4174),
    [anon_sym_module] = ACTIONS(4174),
    [anon_sym_EQ] = ACTIONS(4172),
    [anon_sym_open] = ACTIONS(4174),
    [anon_sym_LBRACK_LT] = ACTIONS(4172),
    [anon_sym_COLON] = ACTIONS(4174),
    [anon_sym_return] = ACTIONS(4174),
    [anon_sym_type] = ACTIONS(4174),
    [anon_sym_do] = ACTIONS(4174),
    [anon_sym_let] = ACTIONS(4174),
    [anon_sym_let_BANG] = ACTIONS(4172),
    [anon_sym_LPAREN] = ACTIONS(4174),
    [anon_sym_COMMA] = ACTIONS(4172),
    [anon_sym_null] = ACTIONS(4174),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_COLON] = ACTIONS(4172),
    [anon_sym_AMP] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4174),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4172),
    [anon_sym_LBRACE] = ACTIONS(4174),
    [anon_sym_LT_AT] = ACTIONS(4174),
    [anon_sym_LT_AT_AT] = ACTIONS(4174),
    [anon_sym_DOT] = ACTIONS(4174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4172),
    [anon_sym_new] = ACTIONS(4174),
    [anon_sym_return_BANG] = ACTIONS(4172),
    [anon_sym_yield] = ACTIONS(4174),
    [anon_sym_yield_BANG] = ACTIONS(4172),
    [anon_sym_lazy] = ACTIONS(4174),
    [anon_sym_assert] = ACTIONS(4174),
    [anon_sym_upcast] = ACTIONS(4174),
    [anon_sym_downcast] = ACTIONS(4174),
    [anon_sym_COLON_GT] = ACTIONS(4172),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4172),
    [anon_sym_for] = ACTIONS(4174),
    [anon_sym_while] = ACTIONS(4174),
    [anon_sym_if] = ACTIONS(4174),
    [anon_sym_fun] = ACTIONS(4174),
    [anon_sym_try] = ACTIONS(4174),
    [anon_sym_match] = ACTIONS(4174),
    [anon_sym_match_BANG] = ACTIONS(4172),
    [anon_sym_function] = ACTIONS(4174),
    [anon_sym_LT_DASH] = ACTIONS(4174),
    [anon_sym_DOT_LBRACK] = ACTIONS(4172),
    [anon_sym_LT] = ACTIONS(4172),
    [anon_sym_use] = ACTIONS(4174),
    [anon_sym_use_BANG] = ACTIONS(4172),
    [anon_sym_do_BANG] = ACTIONS(4172),
    [anon_sym_begin] = ACTIONS(4174),
    [anon_sym_LPAREN2] = ACTIONS(4174),
    [anon_sym_or] = ACTIONS(4174),
    [anon_sym_exception] = ACTIONS(4174),
    [aux_sym_char_token1] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4174),
    [anon_sym_DQUOTE] = ACTIONS(4174),
    [anon_sym_AT_DQUOTE] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [sym_bool] = ACTIONS(4174),
    [sym_unit] = ACTIONS(4172),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4174),
    [sym_op_identifier] = ACTIONS(4174),
    [anon_sym_PLUS] = ACTIONS(4174),
    [anon_sym_DASH] = ACTIONS(4174),
    [anon_sym_PLUS_DOT] = ACTIONS(4174),
    [anon_sym_DASH_DOT] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [anon_sym_AMP_AMP] = ACTIONS(4174),
    [anon_sym_TILDE] = ACTIONS(4172),
    [aux_sym_prefix_op_token1] = ACTIONS(4174),
    [aux_sym_infix_op_token1] = ACTIONS(4172),
    [aux_sym_infix_op_token2] = ACTIONS(4174),
    [anon_sym_PIPE_PIPE] = ACTIONS(4174),
    [anon_sym_BANG_EQ] = ACTIONS(4174),
    [anon_sym_COLON_EQ] = ACTIONS(4172),
    [anon_sym_DOLLAR] = ACTIONS(4174),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4174),
    [sym_int] = ACTIONS(4174),
    [sym_xint] = ACTIONS(4172),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4172),
    [anon_sym_POUNDload] = ACTIONS(4172),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4172),
    [sym__newline] = ACTIONS(4172),
  },
  [2364] = {
    [sym_block_comment] = STATE(2364),
    [sym_compiler_directive_decl] = STATE(2364),
    [sym_fsi_directive_decl] = STATE(2364),
    [sym_preproc_line] = STATE(2364),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_as] = ACTIONS(3487),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
    [sym__dedent] = ACTIONS(3485),
  },
  [2365] = {
    [sym_block_comment] = STATE(2365),
    [sym_compiler_directive_decl] = STATE(2365),
    [sym_fsi_directive_decl] = STATE(2365),
    [sym_preproc_line] = STATE(2365),
    [sym_identifier] = ACTIONS(3881),
    [anon_sym_EQ] = ACTIONS(3879),
    [anon_sym_GT_RBRACK] = ACTIONS(3879),
    [anon_sym_COLON] = ACTIONS(3881),
    [anon_sym_return] = ACTIONS(3881),
    [anon_sym_do] = ACTIONS(3881),
    [anon_sym_let] = ACTIONS(3881),
    [anon_sym_let_BANG] = ACTIONS(3879),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3879),
    [anon_sym_null] = ACTIONS(3881),
    [anon_sym_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [anon_sym_RBRACK] = ACTIONS(3879),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3879),
    [anon_sym_LBRACE] = ACTIONS(3881),
    [anon_sym_RBRACE] = ACTIONS(3879),
    [anon_sym_LT_AT] = ACTIONS(3881),
    [anon_sym_LT_AT_AT] = ACTIONS(3881),
    [anon_sym_DOT] = ACTIONS(3881),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3879),
    [anon_sym_new] = ACTIONS(3881),
    [anon_sym_with] = ACTIONS(3881),
    [anon_sym_return_BANG] = ACTIONS(3879),
    [anon_sym_yield] = ACTIONS(3881),
    [anon_sym_yield_BANG] = ACTIONS(3879),
    [anon_sym_lazy] = ACTIONS(3881),
    [anon_sym_assert] = ACTIONS(3881),
    [anon_sym_upcast] = ACTIONS(3881),
    [anon_sym_downcast] = ACTIONS(3881),
    [anon_sym_COLON_GT] = ACTIONS(3879),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3879),
    [anon_sym_for] = ACTIONS(3881),
    [anon_sym_to] = ACTIONS(3881),
    [anon_sym_downto] = ACTIONS(3881),
    [anon_sym_while] = ACTIONS(3881),
    [anon_sym_if] = ACTIONS(3881),
    [anon_sym_fun] = ACTIONS(3881),
    [anon_sym_try] = ACTIONS(3881),
    [anon_sym_match] = ACTIONS(3881),
    [anon_sym_match_BANG] = ACTIONS(3879),
    [anon_sym_function] = ACTIONS(3881),
    [anon_sym_LT_DASH] = ACTIONS(3881),
    [anon_sym_DOT_LBRACK] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_use] = ACTIONS(3881),
    [anon_sym_use_BANG] = ACTIONS(3879),
    [anon_sym_do_BANG] = ACTIONS(3879),
    [anon_sym_begin] = ACTIONS(3881),
    [anon_sym_LPAREN2] = ACTIONS(3881),
    [anon_sym_DOT_DOT2] = ACTIONS(3879),
    [anon_sym_or] = ACTIONS(3881),
    [aux_sym_char_token1] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3881),
    [anon_sym_DQUOTE] = ACTIONS(3881),
    [anon_sym_AT_DQUOTE] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [sym_bool] = ACTIONS(3881),
    [sym_unit] = ACTIONS(3879),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3881),
    [sym_op_identifier] = ACTIONS(3881),
    [anon_sym_PLUS] = ACTIONS(3881),
    [anon_sym_DASH] = ACTIONS(3881),
    [anon_sym_PLUS_DOT] = ACTIONS(3881),
    [anon_sym_DASH_DOT] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(3881),
    [anon_sym_AMP_AMP] = ACTIONS(3881),
    [anon_sym_TILDE] = ACTIONS(3879),
    [aux_sym_prefix_op_token1] = ACTIONS(3881),
    [aux_sym_infix_op_token1] = ACTIONS(3879),
    [aux_sym_infix_op_token2] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE] = ACTIONS(3881),
    [anon_sym_BANG_EQ] = ACTIONS(3881),
    [anon_sym_COLON_EQ] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3881),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3881),
    [sym_int] = ACTIONS(3881),
    [sym_xint] = ACTIONS(3879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3879),
    [sym__newline] = ACTIONS(3879),
  },
  [2366] = {
    [sym_block_comment] = STATE(2366),
    [sym_compiler_directive_decl] = STATE(2366),
    [sym_fsi_directive_decl] = STATE(2366),
    [sym_preproc_line] = STATE(2366),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_GT_RBRACK] = ACTIONS(3865),
    [anon_sym_COLON] = ACTIONS(3867),
    [anon_sym_return] = ACTIONS(3867),
    [anon_sym_do] = ACTIONS(3867),
    [anon_sym_let] = ACTIONS(3867),
    [anon_sym_let_BANG] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(3867),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_null] = ACTIONS(3867),
    [anon_sym_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_COLON] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3867),
    [anon_sym_LBRACK] = ACTIONS(3867),
    [anon_sym_RBRACK] = ACTIONS(3865),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3867),
    [anon_sym_RBRACE] = ACTIONS(3865),
    [anon_sym_LT_AT] = ACTIONS(3867),
    [anon_sym_LT_AT_AT] = ACTIONS(3867),
    [anon_sym_DOT] = ACTIONS(3867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3867),
    [anon_sym_with] = ACTIONS(3867),
    [anon_sym_return_BANG] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3867),
    [anon_sym_yield_BANG] = ACTIONS(3865),
    [anon_sym_lazy] = ACTIONS(3867),
    [anon_sym_assert] = ACTIONS(3867),
    [anon_sym_upcast] = ACTIONS(3867),
    [anon_sym_downcast] = ACTIONS(3867),
    [anon_sym_COLON_GT] = ACTIONS(3865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3867),
    [anon_sym_to] = ACTIONS(3867),
    [anon_sym_downto] = ACTIONS(3867),
    [anon_sym_while] = ACTIONS(3867),
    [anon_sym_if] = ACTIONS(3867),
    [anon_sym_fun] = ACTIONS(3867),
    [anon_sym_try] = ACTIONS(3867),
    [anon_sym_match] = ACTIONS(3867),
    [anon_sym_match_BANG] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(3867),
    [anon_sym_DOT_LBRACK] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_use] = ACTIONS(3867),
    [anon_sym_use_BANG] = ACTIONS(3865),
    [anon_sym_do_BANG] = ACTIONS(3865),
    [anon_sym_begin] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(3867),
    [anon_sym_DOT_DOT2] = ACTIONS(3865),
    [anon_sym_or] = ACTIONS(3867),
    [aux_sym_char_token1] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3867),
    [anon_sym_DQUOTE] = ACTIONS(3867),
    [anon_sym_AT_DQUOTE] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [sym_bool] = ACTIONS(3867),
    [sym_unit] = ACTIONS(3865),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3867),
    [sym_op_identifier] = ACTIONS(3867),
    [anon_sym_PLUS] = ACTIONS(3867),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_PLUS_DOT] = ACTIONS(3867),
    [anon_sym_DASH_DOT] = ACTIONS(3867),
    [anon_sym_PERCENT] = ACTIONS(3867),
    [anon_sym_AMP_AMP] = ACTIONS(3867),
    [anon_sym_TILDE] = ACTIONS(3865),
    [aux_sym_prefix_op_token1] = ACTIONS(3867),
    [aux_sym_infix_op_token1] = ACTIONS(3865),
    [aux_sym_infix_op_token2] = ACTIONS(3867),
    [anon_sym_PIPE_PIPE] = ACTIONS(3867),
    [anon_sym_BANG_EQ] = ACTIONS(3867),
    [anon_sym_COLON_EQ] = ACTIONS(3865),
    [anon_sym_DOLLAR] = ACTIONS(3867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3867),
    [sym_int] = ACTIONS(3867),
    [sym_xint] = ACTIONS(3865),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3865),
    [sym__newline] = ACTIONS(3865),
  },
  [2367] = {
    [sym_block_comment] = STATE(2367),
    [sym_compiler_directive_decl] = STATE(2367),
    [sym_fsi_directive_decl] = STATE(2367),
    [sym_preproc_line] = STATE(2367),
    [sym_identifier] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(4076),
    [anon_sym_GT_RBRACK] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4078),
    [anon_sym_return] = ACTIONS(4078),
    [anon_sym_do] = ACTIONS(4078),
    [anon_sym_let] = ACTIONS(4078),
    [anon_sym_let_BANG] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_null] = ACTIONS(4078),
    [anon_sym_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(4076),
    [anon_sym_AMP] = ACTIONS(4078),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_RBRACK] = ACTIONS(4076),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4078),
    [anon_sym_RBRACE] = ACTIONS(4076),
    [anon_sym_LT_AT] = ACTIONS(4078),
    [anon_sym_LT_AT_AT] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(4078),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4076),
    [anon_sym_new] = ACTIONS(4078),
    [anon_sym_with] = ACTIONS(4078),
    [anon_sym_return_BANG] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(4078),
    [anon_sym_yield_BANG] = ACTIONS(4076),
    [anon_sym_lazy] = ACTIONS(4078),
    [anon_sym_assert] = ACTIONS(4078),
    [anon_sym_upcast] = ACTIONS(4078),
    [anon_sym_downcast] = ACTIONS(4078),
    [anon_sym_COLON_GT] = ACTIONS(4076),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4076),
    [anon_sym_for] = ACTIONS(4078),
    [anon_sym_to] = ACTIONS(4078),
    [anon_sym_downto] = ACTIONS(4078),
    [anon_sym_while] = ACTIONS(4078),
    [anon_sym_if] = ACTIONS(4078),
    [anon_sym_fun] = ACTIONS(4078),
    [anon_sym_try] = ACTIONS(4078),
    [anon_sym_match] = ACTIONS(4078),
    [anon_sym_match_BANG] = ACTIONS(4076),
    [anon_sym_function] = ACTIONS(4078),
    [anon_sym_LT_DASH] = ACTIONS(4078),
    [anon_sym_DOT_LBRACK] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4076),
    [anon_sym_use] = ACTIONS(4078),
    [anon_sym_use_BANG] = ACTIONS(4076),
    [anon_sym_do_BANG] = ACTIONS(4076),
    [anon_sym_begin] = ACTIONS(4078),
    [anon_sym_LPAREN2] = ACTIONS(4078),
    [anon_sym_DOT_DOT2] = ACTIONS(4076),
    [anon_sym_or] = ACTIONS(4078),
    [aux_sym_char_token1] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4078),
    [anon_sym_DQUOTE] = ACTIONS(4078),
    [anon_sym_AT_DQUOTE] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [sym_bool] = ACTIONS(4078),
    [sym_unit] = ACTIONS(4076),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4078),
    [sym_op_identifier] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(4078),
    [anon_sym_PLUS_DOT] = ACTIONS(4078),
    [anon_sym_DASH_DOT] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [anon_sym_AMP_AMP] = ACTIONS(4078),
    [anon_sym_TILDE] = ACTIONS(4076),
    [aux_sym_prefix_op_token1] = ACTIONS(4078),
    [aux_sym_infix_op_token1] = ACTIONS(4076),
    [aux_sym_infix_op_token2] = ACTIONS(4078),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_BANG_EQ] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4076),
    [anon_sym_DOLLAR] = ACTIONS(4078),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4078),
    [sym_int] = ACTIONS(4078),
    [sym_xint] = ACTIONS(4076),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4076),
    [sym__newline] = ACTIONS(4076),
  },
  [2368] = {
    [sym_block_comment] = STATE(2368),
    [sym_compiler_directive_decl] = STATE(2368),
    [sym_fsi_directive_decl] = STATE(2368),
    [sym_preproc_line] = STATE(2368),
    [ts_builtin_sym_end] = ACTIONS(4242),
    [sym_identifier] = ACTIONS(4244),
    [anon_sym_namespace] = ACTIONS(4244),
    [anon_sym_module] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4242),
    [anon_sym_open] = ACTIONS(4244),
    [anon_sym_LBRACK_LT] = ACTIONS(4242),
    [anon_sym_COLON] = ACTIONS(4244),
    [anon_sym_return] = ACTIONS(4244),
    [anon_sym_type] = ACTIONS(4244),
    [anon_sym_do] = ACTIONS(4244),
    [anon_sym_let] = ACTIONS(4244),
    [anon_sym_let_BANG] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_null] = ACTIONS(4244),
    [anon_sym_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_COLON] = ACTIONS(4242),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4244),
    [anon_sym_LT_AT] = ACTIONS(4244),
    [anon_sym_LT_AT_AT] = ACTIONS(4244),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4242),
    [anon_sym_new] = ACTIONS(4244),
    [anon_sym_return_BANG] = ACTIONS(4242),
    [anon_sym_yield] = ACTIONS(4244),
    [anon_sym_yield_BANG] = ACTIONS(4242),
    [anon_sym_lazy] = ACTIONS(4244),
    [anon_sym_assert] = ACTIONS(4244),
    [anon_sym_upcast] = ACTIONS(4244),
    [anon_sym_downcast] = ACTIONS(4244),
    [anon_sym_COLON_GT] = ACTIONS(4242),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4242),
    [anon_sym_for] = ACTIONS(4244),
    [anon_sym_while] = ACTIONS(4244),
    [anon_sym_if] = ACTIONS(4244),
    [anon_sym_fun] = ACTIONS(4244),
    [anon_sym_try] = ACTIONS(4244),
    [anon_sym_match] = ACTIONS(4244),
    [anon_sym_match_BANG] = ACTIONS(4242),
    [anon_sym_function] = ACTIONS(4244),
    [anon_sym_LT_DASH] = ACTIONS(4244),
    [anon_sym_DOT_LBRACK] = ACTIONS(4242),
    [anon_sym_LT] = ACTIONS(4242),
    [anon_sym_use] = ACTIONS(4244),
    [anon_sym_use_BANG] = ACTIONS(4242),
    [anon_sym_do_BANG] = ACTIONS(4242),
    [anon_sym_begin] = ACTIONS(4244),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_or] = ACTIONS(4244),
    [anon_sym_exception] = ACTIONS(4244),
    [aux_sym_char_token1] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4244),
    [anon_sym_DQUOTE] = ACTIONS(4244),
    [anon_sym_AT_DQUOTE] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [sym_bool] = ACTIONS(4244),
    [sym_unit] = ACTIONS(4242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4244),
    [sym_op_identifier] = ACTIONS(4244),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_DASH] = ACTIONS(4244),
    [anon_sym_PLUS_DOT] = ACTIONS(4244),
    [anon_sym_DASH_DOT] = ACTIONS(4244),
    [anon_sym_PERCENT] = ACTIONS(4244),
    [anon_sym_AMP_AMP] = ACTIONS(4244),
    [anon_sym_TILDE] = ACTIONS(4242),
    [aux_sym_prefix_op_token1] = ACTIONS(4244),
    [aux_sym_infix_op_token1] = ACTIONS(4242),
    [aux_sym_infix_op_token2] = ACTIONS(4244),
    [anon_sym_PIPE_PIPE] = ACTIONS(4244),
    [anon_sym_BANG_EQ] = ACTIONS(4244),
    [anon_sym_COLON_EQ] = ACTIONS(4242),
    [anon_sym_DOLLAR] = ACTIONS(4244),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4244),
    [sym_int] = ACTIONS(4244),
    [sym_xint] = ACTIONS(4242),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4242),
    [anon_sym_POUNDload] = ACTIONS(4242),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4242),
    [sym__newline] = ACTIONS(4242),
  },
  [2369] = {
    [sym_block_comment] = STATE(2369),
    [sym_compiler_directive_decl] = STATE(2369),
    [sym_fsi_directive_decl] = STATE(2369),
    [sym_preproc_line] = STATE(2369),
    [ts_builtin_sym_end] = ACTIONS(4238),
    [sym_identifier] = ACTIONS(4240),
    [anon_sym_namespace] = ACTIONS(4240),
    [anon_sym_module] = ACTIONS(4240),
    [anon_sym_EQ] = ACTIONS(4238),
    [anon_sym_open] = ACTIONS(4240),
    [anon_sym_LBRACK_LT] = ACTIONS(4238),
    [anon_sym_COLON] = ACTIONS(4240),
    [anon_sym_return] = ACTIONS(4240),
    [anon_sym_type] = ACTIONS(4240),
    [anon_sym_do] = ACTIONS(4240),
    [anon_sym_let] = ACTIONS(4240),
    [anon_sym_let_BANG] = ACTIONS(4238),
    [anon_sym_LPAREN] = ACTIONS(4240),
    [anon_sym_COMMA] = ACTIONS(4238),
    [anon_sym_null] = ACTIONS(4240),
    [anon_sym_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_COLON] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4240),
    [anon_sym_LBRACK] = ACTIONS(4240),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4238),
    [anon_sym_LBRACE] = ACTIONS(4240),
    [anon_sym_LT_AT] = ACTIONS(4240),
    [anon_sym_LT_AT_AT] = ACTIONS(4240),
    [anon_sym_DOT] = ACTIONS(4240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4238),
    [anon_sym_new] = ACTIONS(4240),
    [anon_sym_return_BANG] = ACTIONS(4238),
    [anon_sym_yield] = ACTIONS(4240),
    [anon_sym_yield_BANG] = ACTIONS(4238),
    [anon_sym_lazy] = ACTIONS(4240),
    [anon_sym_assert] = ACTIONS(4240),
    [anon_sym_upcast] = ACTIONS(4240),
    [anon_sym_downcast] = ACTIONS(4240),
    [anon_sym_COLON_GT] = ACTIONS(4238),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4238),
    [anon_sym_for] = ACTIONS(4240),
    [anon_sym_while] = ACTIONS(4240),
    [anon_sym_if] = ACTIONS(4240),
    [anon_sym_fun] = ACTIONS(4240),
    [anon_sym_try] = ACTIONS(4240),
    [anon_sym_match] = ACTIONS(4240),
    [anon_sym_match_BANG] = ACTIONS(4238),
    [anon_sym_function] = ACTIONS(4240),
    [anon_sym_LT_DASH] = ACTIONS(4240),
    [anon_sym_DOT_LBRACK] = ACTIONS(4238),
    [anon_sym_LT] = ACTIONS(4238),
    [anon_sym_use] = ACTIONS(4240),
    [anon_sym_use_BANG] = ACTIONS(4238),
    [anon_sym_do_BANG] = ACTIONS(4238),
    [anon_sym_begin] = ACTIONS(4240),
    [anon_sym_LPAREN2] = ACTIONS(4240),
    [anon_sym_or] = ACTIONS(4240),
    [anon_sym_exception] = ACTIONS(4240),
    [aux_sym_char_token1] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4240),
    [anon_sym_DQUOTE] = ACTIONS(4240),
    [anon_sym_AT_DQUOTE] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [sym_bool] = ACTIONS(4240),
    [sym_unit] = ACTIONS(4238),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4240),
    [sym_op_identifier] = ACTIONS(4240),
    [anon_sym_PLUS] = ACTIONS(4240),
    [anon_sym_DASH] = ACTIONS(4240),
    [anon_sym_PLUS_DOT] = ACTIONS(4240),
    [anon_sym_DASH_DOT] = ACTIONS(4240),
    [anon_sym_PERCENT] = ACTIONS(4240),
    [anon_sym_AMP_AMP] = ACTIONS(4240),
    [anon_sym_TILDE] = ACTIONS(4238),
    [aux_sym_prefix_op_token1] = ACTIONS(4240),
    [aux_sym_infix_op_token1] = ACTIONS(4238),
    [aux_sym_infix_op_token2] = ACTIONS(4240),
    [anon_sym_PIPE_PIPE] = ACTIONS(4240),
    [anon_sym_BANG_EQ] = ACTIONS(4240),
    [anon_sym_COLON_EQ] = ACTIONS(4238),
    [anon_sym_DOLLAR] = ACTIONS(4240),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4240),
    [sym_int] = ACTIONS(4240),
    [sym_xint] = ACTIONS(4238),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4238),
    [anon_sym_POUNDload] = ACTIONS(4238),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4238),
    [sym__newline] = ACTIONS(4238),
  },
  [2370] = {
    [sym_block_comment] = STATE(2370),
    [sym_compiler_directive_decl] = STATE(2370),
    [sym_fsi_directive_decl] = STATE(2370),
    [sym_preproc_line] = STATE(2370),
    [sym_identifier] = ACTIONS(4170),
    [anon_sym_EQ] = ACTIONS(4168),
    [anon_sym_GT_RBRACK] = ACTIONS(4168),
    [anon_sym_COLON] = ACTIONS(4170),
    [anon_sym_return] = ACTIONS(4170),
    [anon_sym_do] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_let_BANG] = ACTIONS(4168),
    [anon_sym_LPAREN] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4168),
    [anon_sym_null] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_COLON] = ACTIONS(4168),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4170),
    [anon_sym_RBRACK] = ACTIONS(4168),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4168),
    [anon_sym_LBRACE] = ACTIONS(4170),
    [anon_sym_RBRACE] = ACTIONS(4168),
    [anon_sym_LT_AT] = ACTIONS(4170),
    [anon_sym_LT_AT_AT] = ACTIONS(4170),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4168),
    [anon_sym_new] = ACTIONS(4170),
    [anon_sym_with] = ACTIONS(4170),
    [anon_sym_return_BANG] = ACTIONS(4168),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_yield_BANG] = ACTIONS(4168),
    [anon_sym_lazy] = ACTIONS(4170),
    [anon_sym_assert] = ACTIONS(4170),
    [anon_sym_upcast] = ACTIONS(4170),
    [anon_sym_downcast] = ACTIONS(4170),
    [anon_sym_COLON_GT] = ACTIONS(4168),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4168),
    [anon_sym_for] = ACTIONS(4170),
    [anon_sym_to] = ACTIONS(4170),
    [anon_sym_downto] = ACTIONS(4170),
    [anon_sym_while] = ACTIONS(4170),
    [anon_sym_if] = ACTIONS(4170),
    [anon_sym_fun] = ACTIONS(4170),
    [anon_sym_try] = ACTIONS(4170),
    [anon_sym_match] = ACTIONS(4170),
    [anon_sym_match_BANG] = ACTIONS(4168),
    [anon_sym_function] = ACTIONS(4170),
    [anon_sym_LT_DASH] = ACTIONS(4170),
    [anon_sym_DOT_LBRACK] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4168),
    [anon_sym_use] = ACTIONS(4170),
    [anon_sym_use_BANG] = ACTIONS(4168),
    [anon_sym_do_BANG] = ACTIONS(4168),
    [anon_sym_begin] = ACTIONS(4170),
    [anon_sym_LPAREN2] = ACTIONS(4170),
    [anon_sym_DOT_DOT2] = ACTIONS(4168),
    [anon_sym_or] = ACTIONS(4170),
    [aux_sym_char_token1] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4170),
    [anon_sym_DQUOTE] = ACTIONS(4170),
    [anon_sym_AT_DQUOTE] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [sym_bool] = ACTIONS(4170),
    [sym_unit] = ACTIONS(4168),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4170),
    [sym_op_identifier] = ACTIONS(4170),
    [anon_sym_PLUS] = ACTIONS(4170),
    [anon_sym_DASH] = ACTIONS(4170),
    [anon_sym_PLUS_DOT] = ACTIONS(4170),
    [anon_sym_DASH_DOT] = ACTIONS(4170),
    [anon_sym_PERCENT] = ACTIONS(4170),
    [anon_sym_AMP_AMP] = ACTIONS(4170),
    [anon_sym_TILDE] = ACTIONS(4168),
    [aux_sym_prefix_op_token1] = ACTIONS(4170),
    [aux_sym_infix_op_token1] = ACTIONS(4168),
    [aux_sym_infix_op_token2] = ACTIONS(4170),
    [anon_sym_PIPE_PIPE] = ACTIONS(4170),
    [anon_sym_BANG_EQ] = ACTIONS(4170),
    [anon_sym_COLON_EQ] = ACTIONS(4168),
    [anon_sym_DOLLAR] = ACTIONS(4170),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4170),
    [sym_int] = ACTIONS(4170),
    [sym_xint] = ACTIONS(4168),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4168),
    [sym__newline] = ACTIONS(4168),
  },
  [2371] = {
    [sym_block_comment] = STATE(2371),
    [sym_compiler_directive_decl] = STATE(2371),
    [sym_fsi_directive_decl] = STATE(2371),
    [sym_preproc_line] = STATE(2371),
    [sym_identifier] = ACTIONS(4158),
    [anon_sym_EQ] = ACTIONS(4156),
    [anon_sym_GT_RBRACK] = ACTIONS(4156),
    [anon_sym_COLON] = ACTIONS(4158),
    [anon_sym_return] = ACTIONS(4158),
    [anon_sym_do] = ACTIONS(4158),
    [anon_sym_let] = ACTIONS(4158),
    [anon_sym_let_BANG] = ACTIONS(4156),
    [anon_sym_LPAREN] = ACTIONS(4158),
    [anon_sym_COMMA] = ACTIONS(4156),
    [anon_sym_null] = ACTIONS(4158),
    [anon_sym_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_COLON] = ACTIONS(4156),
    [anon_sym_AMP] = ACTIONS(4158),
    [anon_sym_LBRACK] = ACTIONS(4158),
    [anon_sym_RBRACK] = ACTIONS(4156),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(4158),
    [anon_sym_RBRACE] = ACTIONS(4156),
    [anon_sym_LT_AT] = ACTIONS(4158),
    [anon_sym_LT_AT_AT] = ACTIONS(4158),
    [anon_sym_DOT] = ACTIONS(4158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4156),
    [anon_sym_new] = ACTIONS(4158),
    [anon_sym_with] = ACTIONS(4158),
    [anon_sym_return_BANG] = ACTIONS(4156),
    [anon_sym_yield] = ACTIONS(4158),
    [anon_sym_yield_BANG] = ACTIONS(4156),
    [anon_sym_lazy] = ACTIONS(4158),
    [anon_sym_assert] = ACTIONS(4158),
    [anon_sym_upcast] = ACTIONS(4158),
    [anon_sym_downcast] = ACTIONS(4158),
    [anon_sym_COLON_GT] = ACTIONS(4156),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4156),
    [anon_sym_for] = ACTIONS(4158),
    [anon_sym_to] = ACTIONS(4158),
    [anon_sym_downto] = ACTIONS(4158),
    [anon_sym_while] = ACTIONS(4158),
    [anon_sym_if] = ACTIONS(4158),
    [anon_sym_fun] = ACTIONS(4158),
    [anon_sym_try] = ACTIONS(4158),
    [anon_sym_match] = ACTIONS(4158),
    [anon_sym_match_BANG] = ACTIONS(4156),
    [anon_sym_function] = ACTIONS(4158),
    [anon_sym_LT_DASH] = ACTIONS(4158),
    [anon_sym_DOT_LBRACK] = ACTIONS(4156),
    [anon_sym_LT] = ACTIONS(4156),
    [anon_sym_use] = ACTIONS(4158),
    [anon_sym_use_BANG] = ACTIONS(4156),
    [anon_sym_do_BANG] = ACTIONS(4156),
    [anon_sym_begin] = ACTIONS(4158),
    [anon_sym_LPAREN2] = ACTIONS(4158),
    [anon_sym_DOT_DOT2] = ACTIONS(4156),
    [anon_sym_or] = ACTIONS(4158),
    [aux_sym_char_token1] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4158),
    [anon_sym_DQUOTE] = ACTIONS(4158),
    [anon_sym_AT_DQUOTE] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [sym_bool] = ACTIONS(4158),
    [sym_unit] = ACTIONS(4156),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4158),
    [sym_op_identifier] = ACTIONS(4158),
    [anon_sym_PLUS] = ACTIONS(4158),
    [anon_sym_DASH] = ACTIONS(4158),
    [anon_sym_PLUS_DOT] = ACTIONS(4158),
    [anon_sym_DASH_DOT] = ACTIONS(4158),
    [anon_sym_PERCENT] = ACTIONS(4158),
    [anon_sym_AMP_AMP] = ACTIONS(4158),
    [anon_sym_TILDE] = ACTIONS(4156),
    [aux_sym_prefix_op_token1] = ACTIONS(4158),
    [aux_sym_infix_op_token1] = ACTIONS(4156),
    [aux_sym_infix_op_token2] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE] = ACTIONS(4158),
    [anon_sym_BANG_EQ] = ACTIONS(4158),
    [anon_sym_COLON_EQ] = ACTIONS(4156),
    [anon_sym_DOLLAR] = ACTIONS(4158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4158),
    [sym_int] = ACTIONS(4158),
    [sym_xint] = ACTIONS(4156),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4156),
    [sym__newline] = ACTIONS(4156),
  },
  [2372] = {
    [sym_block_comment] = STATE(2372),
    [sym_compiler_directive_decl] = STATE(2372),
    [sym_fsi_directive_decl] = STATE(2372),
    [sym_preproc_line] = STATE(2372),
    [sym_identifier] = ACTIONS(4162),
    [anon_sym_EQ] = ACTIONS(4160),
    [anon_sym_GT_RBRACK] = ACTIONS(4160),
    [anon_sym_COLON] = ACTIONS(4162),
    [anon_sym_return] = ACTIONS(4162),
    [anon_sym_do] = ACTIONS(4162),
    [anon_sym_let] = ACTIONS(4162),
    [anon_sym_let_BANG] = ACTIONS(4160),
    [anon_sym_LPAREN] = ACTIONS(4162),
    [anon_sym_COMMA] = ACTIONS(4160),
    [anon_sym_null] = ACTIONS(4162),
    [anon_sym_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4160),
    [anon_sym_AMP] = ACTIONS(4162),
    [anon_sym_LBRACK] = ACTIONS(4162),
    [anon_sym_RBRACK] = ACTIONS(4160),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4160),
    [anon_sym_LBRACE] = ACTIONS(4162),
    [anon_sym_RBRACE] = ACTIONS(4160),
    [anon_sym_LT_AT] = ACTIONS(4162),
    [anon_sym_LT_AT_AT] = ACTIONS(4162),
    [anon_sym_DOT] = ACTIONS(4162),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4160),
    [anon_sym_new] = ACTIONS(4162),
    [anon_sym_with] = ACTIONS(4162),
    [anon_sym_return_BANG] = ACTIONS(4160),
    [anon_sym_yield] = ACTIONS(4162),
    [anon_sym_yield_BANG] = ACTIONS(4160),
    [anon_sym_lazy] = ACTIONS(4162),
    [anon_sym_assert] = ACTIONS(4162),
    [anon_sym_upcast] = ACTIONS(4162),
    [anon_sym_downcast] = ACTIONS(4162),
    [anon_sym_COLON_GT] = ACTIONS(4160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4160),
    [anon_sym_for] = ACTIONS(4162),
    [anon_sym_to] = ACTIONS(4162),
    [anon_sym_downto] = ACTIONS(4162),
    [anon_sym_while] = ACTIONS(4162),
    [anon_sym_if] = ACTIONS(4162),
    [anon_sym_fun] = ACTIONS(4162),
    [anon_sym_try] = ACTIONS(4162),
    [anon_sym_match] = ACTIONS(4162),
    [anon_sym_match_BANG] = ACTIONS(4160),
    [anon_sym_function] = ACTIONS(4162),
    [anon_sym_LT_DASH] = ACTIONS(4162),
    [anon_sym_DOT_LBRACK] = ACTIONS(4160),
    [anon_sym_LT] = ACTIONS(4160),
    [anon_sym_use] = ACTIONS(4162),
    [anon_sym_use_BANG] = ACTIONS(4160),
    [anon_sym_do_BANG] = ACTIONS(4160),
    [anon_sym_begin] = ACTIONS(4162),
    [anon_sym_LPAREN2] = ACTIONS(4162),
    [anon_sym_DOT_DOT2] = ACTIONS(4160),
    [anon_sym_or] = ACTIONS(4162),
    [aux_sym_char_token1] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4162),
    [anon_sym_DQUOTE] = ACTIONS(4162),
    [anon_sym_AT_DQUOTE] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [sym_bool] = ACTIONS(4162),
    [sym_unit] = ACTIONS(4160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4162),
    [sym_op_identifier] = ACTIONS(4162),
    [anon_sym_PLUS] = ACTIONS(4162),
    [anon_sym_DASH] = ACTIONS(4162),
    [anon_sym_PLUS_DOT] = ACTIONS(4162),
    [anon_sym_DASH_DOT] = ACTIONS(4162),
    [anon_sym_PERCENT] = ACTIONS(4162),
    [anon_sym_AMP_AMP] = ACTIONS(4162),
    [anon_sym_TILDE] = ACTIONS(4160),
    [aux_sym_prefix_op_token1] = ACTIONS(4162),
    [aux_sym_infix_op_token1] = ACTIONS(4160),
    [aux_sym_infix_op_token2] = ACTIONS(4162),
    [anon_sym_PIPE_PIPE] = ACTIONS(4162),
    [anon_sym_BANG_EQ] = ACTIONS(4162),
    [anon_sym_COLON_EQ] = ACTIONS(4160),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4162),
    [sym_int] = ACTIONS(4162),
    [sym_xint] = ACTIONS(4160),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4160),
    [sym__newline] = ACTIONS(4160),
  },
  [2373] = {
    [sym_block_comment] = STATE(2373),
    [sym_compiler_directive_decl] = STATE(2373),
    [sym_fsi_directive_decl] = STATE(2373),
    [sym_preproc_line] = STATE(2373),
    [sym_identifier] = ACTIONS(4182),
    [anon_sym_EQ] = ACTIONS(3689),
    [anon_sym_GT_RBRACK] = ACTIONS(3689),
    [anon_sym_COLON] = ACTIONS(4182),
    [anon_sym_return] = ACTIONS(4182),
    [anon_sym_do] = ACTIONS(4182),
    [anon_sym_let] = ACTIONS(4182),
    [anon_sym_let_BANG] = ACTIONS(3689),
    [anon_sym_LPAREN] = ACTIONS(4182),
    [anon_sym_COMMA] = ACTIONS(3689),
    [anon_sym_null] = ACTIONS(4182),
    [anon_sym_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_RBRACK] = ACTIONS(3689),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3689),
    [anon_sym_LBRACE] = ACTIONS(4182),
    [anon_sym_RBRACE] = ACTIONS(3689),
    [anon_sym_LT_AT] = ACTIONS(4182),
    [anon_sym_LT_AT_AT] = ACTIONS(4182),
    [anon_sym_DOT] = ACTIONS(4182),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3689),
    [anon_sym_new] = ACTIONS(4182),
    [anon_sym_with] = ACTIONS(4182),
    [anon_sym_return_BANG] = ACTIONS(3689),
    [anon_sym_yield] = ACTIONS(4182),
    [anon_sym_yield_BANG] = ACTIONS(3689),
    [anon_sym_lazy] = ACTIONS(4182),
    [anon_sym_assert] = ACTIONS(4182),
    [anon_sym_upcast] = ACTIONS(4182),
    [anon_sym_downcast] = ACTIONS(4182),
    [anon_sym_COLON_GT] = ACTIONS(3689),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3689),
    [anon_sym_for] = ACTIONS(4182),
    [anon_sym_to] = ACTIONS(4182),
    [anon_sym_downto] = ACTIONS(4182),
    [anon_sym_while] = ACTIONS(4182),
    [anon_sym_if] = ACTIONS(4182),
    [anon_sym_fun] = ACTIONS(4182),
    [anon_sym_try] = ACTIONS(4182),
    [anon_sym_match] = ACTIONS(4182),
    [anon_sym_match_BANG] = ACTIONS(3689),
    [anon_sym_function] = ACTIONS(4182),
    [anon_sym_LT_DASH] = ACTIONS(4182),
    [anon_sym_DOT_LBRACK] = ACTIONS(3689),
    [anon_sym_LT] = ACTIONS(3689),
    [anon_sym_use] = ACTIONS(4182),
    [anon_sym_use_BANG] = ACTIONS(3689),
    [anon_sym_do_BANG] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(4182),
    [anon_sym_LPAREN2] = ACTIONS(4182),
    [anon_sym_DOT_DOT2] = ACTIONS(3689),
    [anon_sym_or] = ACTIONS(4182),
    [aux_sym_char_token1] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4182),
    [anon_sym_DQUOTE] = ACTIONS(4182),
    [anon_sym_AT_DQUOTE] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [sym_bool] = ACTIONS(4182),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4182),
    [sym_op_identifier] = ACTIONS(4182),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_PLUS_DOT] = ACTIONS(4182),
    [anon_sym_DASH_DOT] = ACTIONS(4182),
    [anon_sym_PERCENT] = ACTIONS(4182),
    [anon_sym_AMP_AMP] = ACTIONS(4182),
    [anon_sym_TILDE] = ACTIONS(3689),
    [aux_sym_prefix_op_token1] = ACTIONS(4182),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token2] = ACTIONS(4182),
    [anon_sym_PIPE_PIPE] = ACTIONS(4182),
    [anon_sym_BANG_EQ] = ACTIONS(4182),
    [anon_sym_COLON_EQ] = ACTIONS(3689),
    [anon_sym_DOLLAR] = ACTIONS(4182),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4182),
    [sym_int] = ACTIONS(4182),
    [sym_xint] = ACTIONS(3689),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3689),
    [sym__newline] = ACTIONS(3689),
  },
  [2374] = {
    [sym_block_comment] = STATE(2374),
    [sym_compiler_directive_decl] = STATE(2374),
    [sym_fsi_directive_decl] = STATE(2374),
    [sym_preproc_line] = STATE(2374),
    [ts_builtin_sym_end] = ACTIONS(4206),
    [sym_identifier] = ACTIONS(4208),
    [anon_sym_namespace] = ACTIONS(4208),
    [anon_sym_module] = ACTIONS(4208),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_open] = ACTIONS(4208),
    [anon_sym_LBRACK_LT] = ACTIONS(4206),
    [anon_sym_COLON] = ACTIONS(4208),
    [anon_sym_return] = ACTIONS(4208),
    [anon_sym_type] = ACTIONS(4208),
    [anon_sym_do] = ACTIONS(4208),
    [anon_sym_let] = ACTIONS(4208),
    [anon_sym_let_BANG] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(4206),
    [anon_sym_null] = ACTIONS(4208),
    [anon_sym_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_COLON] = ACTIONS(4206),
    [anon_sym_AMP] = ACTIONS(4208),
    [anon_sym_LBRACK] = ACTIONS(4208),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4206),
    [anon_sym_LBRACE] = ACTIONS(4208),
    [anon_sym_LT_AT] = ACTIONS(4208),
    [anon_sym_LT_AT_AT] = ACTIONS(4208),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4206),
    [anon_sym_new] = ACTIONS(4208),
    [anon_sym_return_BANG] = ACTIONS(4206),
    [anon_sym_yield] = ACTIONS(4208),
    [anon_sym_yield_BANG] = ACTIONS(4206),
    [anon_sym_lazy] = ACTIONS(4208),
    [anon_sym_assert] = ACTIONS(4208),
    [anon_sym_upcast] = ACTIONS(4208),
    [anon_sym_downcast] = ACTIONS(4208),
    [anon_sym_COLON_GT] = ACTIONS(4206),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4206),
    [anon_sym_for] = ACTIONS(4208),
    [anon_sym_while] = ACTIONS(4208),
    [anon_sym_if] = ACTIONS(4208),
    [anon_sym_fun] = ACTIONS(4208),
    [anon_sym_try] = ACTIONS(4208),
    [anon_sym_match] = ACTIONS(4208),
    [anon_sym_match_BANG] = ACTIONS(4206),
    [anon_sym_function] = ACTIONS(4208),
    [anon_sym_LT_DASH] = ACTIONS(4208),
    [anon_sym_DOT_LBRACK] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(4206),
    [anon_sym_use] = ACTIONS(4208),
    [anon_sym_use_BANG] = ACTIONS(4206),
    [anon_sym_do_BANG] = ACTIONS(4206),
    [anon_sym_begin] = ACTIONS(4208),
    [anon_sym_LPAREN2] = ACTIONS(4208),
    [anon_sym_or] = ACTIONS(4208),
    [anon_sym_exception] = ACTIONS(4208),
    [aux_sym_char_token1] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4208),
    [anon_sym_DQUOTE] = ACTIONS(4208),
    [anon_sym_AT_DQUOTE] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [sym_bool] = ACTIONS(4208),
    [sym_unit] = ACTIONS(4206),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4208),
    [sym_op_identifier] = ACTIONS(4208),
    [anon_sym_PLUS] = ACTIONS(4208),
    [anon_sym_DASH] = ACTIONS(4208),
    [anon_sym_PLUS_DOT] = ACTIONS(4208),
    [anon_sym_DASH_DOT] = ACTIONS(4208),
    [anon_sym_PERCENT] = ACTIONS(4208),
    [anon_sym_AMP_AMP] = ACTIONS(4208),
    [anon_sym_TILDE] = ACTIONS(4206),
    [aux_sym_prefix_op_token1] = ACTIONS(4208),
    [aux_sym_infix_op_token1] = ACTIONS(4206),
    [aux_sym_infix_op_token2] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(4208),
    [anon_sym_BANG_EQ] = ACTIONS(4208),
    [anon_sym_COLON_EQ] = ACTIONS(4206),
    [anon_sym_DOLLAR] = ACTIONS(4208),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4208),
    [sym_int] = ACTIONS(4208),
    [sym_xint] = ACTIONS(4206),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4206),
    [anon_sym_POUNDload] = ACTIONS(4206),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4206),
    [sym__newline] = ACTIONS(4206),
  },
  [2375] = {
    [sym_block_comment] = STATE(2375),
    [sym_compiler_directive_decl] = STATE(2375),
    [sym_fsi_directive_decl] = STATE(2375),
    [sym_preproc_line] = STATE(2375),
    [ts_builtin_sym_end] = ACTIONS(4234),
    [sym_identifier] = ACTIONS(4236),
    [anon_sym_namespace] = ACTIONS(4236),
    [anon_sym_module] = ACTIONS(4236),
    [anon_sym_EQ] = ACTIONS(4234),
    [anon_sym_open] = ACTIONS(4236),
    [anon_sym_LBRACK_LT] = ACTIONS(4234),
    [anon_sym_COLON] = ACTIONS(4236),
    [anon_sym_return] = ACTIONS(4236),
    [anon_sym_type] = ACTIONS(4236),
    [anon_sym_do] = ACTIONS(4236),
    [anon_sym_let] = ACTIONS(4236),
    [anon_sym_let_BANG] = ACTIONS(4234),
    [anon_sym_LPAREN] = ACTIONS(4236),
    [anon_sym_COMMA] = ACTIONS(4234),
    [anon_sym_null] = ACTIONS(4236),
    [anon_sym_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_COLON] = ACTIONS(4234),
    [anon_sym_AMP] = ACTIONS(4236),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4234),
    [anon_sym_LBRACE] = ACTIONS(4236),
    [anon_sym_LT_AT] = ACTIONS(4236),
    [anon_sym_LT_AT_AT] = ACTIONS(4236),
    [anon_sym_DOT] = ACTIONS(4236),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4234),
    [anon_sym_new] = ACTIONS(4236),
    [anon_sym_return_BANG] = ACTIONS(4234),
    [anon_sym_yield] = ACTIONS(4236),
    [anon_sym_yield_BANG] = ACTIONS(4234),
    [anon_sym_lazy] = ACTIONS(4236),
    [anon_sym_assert] = ACTIONS(4236),
    [anon_sym_upcast] = ACTIONS(4236),
    [anon_sym_downcast] = ACTIONS(4236),
    [anon_sym_COLON_GT] = ACTIONS(4234),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4234),
    [anon_sym_for] = ACTIONS(4236),
    [anon_sym_while] = ACTIONS(4236),
    [anon_sym_if] = ACTIONS(4236),
    [anon_sym_fun] = ACTIONS(4236),
    [anon_sym_try] = ACTIONS(4236),
    [anon_sym_match] = ACTIONS(4236),
    [anon_sym_match_BANG] = ACTIONS(4234),
    [anon_sym_function] = ACTIONS(4236),
    [anon_sym_LT_DASH] = ACTIONS(4236),
    [anon_sym_DOT_LBRACK] = ACTIONS(4234),
    [anon_sym_LT] = ACTIONS(4234),
    [anon_sym_use] = ACTIONS(4236),
    [anon_sym_use_BANG] = ACTIONS(4234),
    [anon_sym_do_BANG] = ACTIONS(4234),
    [anon_sym_begin] = ACTIONS(4236),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_or] = ACTIONS(4236),
    [anon_sym_exception] = ACTIONS(4236),
    [aux_sym_char_token1] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4236),
    [anon_sym_DQUOTE] = ACTIONS(4236),
    [anon_sym_AT_DQUOTE] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [sym_bool] = ACTIONS(4236),
    [sym_unit] = ACTIONS(4234),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4236),
    [sym_op_identifier] = ACTIONS(4236),
    [anon_sym_PLUS] = ACTIONS(4236),
    [anon_sym_DASH] = ACTIONS(4236),
    [anon_sym_PLUS_DOT] = ACTIONS(4236),
    [anon_sym_DASH_DOT] = ACTIONS(4236),
    [anon_sym_PERCENT] = ACTIONS(4236),
    [anon_sym_AMP_AMP] = ACTIONS(4236),
    [anon_sym_TILDE] = ACTIONS(4234),
    [aux_sym_prefix_op_token1] = ACTIONS(4236),
    [aux_sym_infix_op_token1] = ACTIONS(4234),
    [aux_sym_infix_op_token2] = ACTIONS(4236),
    [anon_sym_PIPE_PIPE] = ACTIONS(4236),
    [anon_sym_BANG_EQ] = ACTIONS(4236),
    [anon_sym_COLON_EQ] = ACTIONS(4234),
    [anon_sym_DOLLAR] = ACTIONS(4236),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4236),
    [sym_int] = ACTIONS(4236),
    [sym_xint] = ACTIONS(4234),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4234),
    [anon_sym_POUNDload] = ACTIONS(4234),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4234),
    [sym__newline] = ACTIONS(4234),
  },
  [2376] = {
    [sym_block_comment] = STATE(2376),
    [sym_compiler_directive_decl] = STATE(2376),
    [sym_fsi_directive_decl] = STATE(2376),
    [sym_preproc_line] = STATE(2376),
    [ts_builtin_sym_end] = ACTIONS(3887),
    [sym_identifier] = ACTIONS(3889),
    [anon_sym_namespace] = ACTIONS(3889),
    [anon_sym_module] = ACTIONS(3889),
    [anon_sym_EQ] = ACTIONS(3887),
    [anon_sym_open] = ACTIONS(3889),
    [anon_sym_LBRACK_LT] = ACTIONS(3887),
    [anon_sym_COLON] = ACTIONS(3889),
    [anon_sym_return] = ACTIONS(3889),
    [anon_sym_type] = ACTIONS(3889),
    [anon_sym_do] = ACTIONS(3889),
    [anon_sym_let] = ACTIONS(3889),
    [anon_sym_let_BANG] = ACTIONS(3887),
    [anon_sym_LPAREN] = ACTIONS(3889),
    [anon_sym_COMMA] = ACTIONS(3887),
    [anon_sym_null] = ACTIONS(3889),
    [anon_sym_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_COLON] = ACTIONS(3887),
    [anon_sym_AMP] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3887),
    [anon_sym_LBRACE] = ACTIONS(3889),
    [anon_sym_LT_AT] = ACTIONS(3889),
    [anon_sym_LT_AT_AT] = ACTIONS(3889),
    [anon_sym_DOT] = ACTIONS(3889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [anon_sym_new] = ACTIONS(3889),
    [anon_sym_return_BANG] = ACTIONS(3887),
    [anon_sym_yield] = ACTIONS(3889),
    [anon_sym_yield_BANG] = ACTIONS(3887),
    [anon_sym_lazy] = ACTIONS(3889),
    [anon_sym_assert] = ACTIONS(3889),
    [anon_sym_upcast] = ACTIONS(3889),
    [anon_sym_downcast] = ACTIONS(3889),
    [anon_sym_COLON_GT] = ACTIONS(3887),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3887),
    [anon_sym_for] = ACTIONS(3889),
    [anon_sym_while] = ACTIONS(3889),
    [anon_sym_if] = ACTIONS(3889),
    [anon_sym_fun] = ACTIONS(3889),
    [anon_sym_try] = ACTIONS(3889),
    [anon_sym_match] = ACTIONS(3889),
    [anon_sym_match_BANG] = ACTIONS(3887),
    [anon_sym_function] = ACTIONS(3889),
    [anon_sym_LT_DASH] = ACTIONS(3889),
    [anon_sym_DOT_LBRACK] = ACTIONS(3887),
    [anon_sym_LT] = ACTIONS(3887),
    [anon_sym_use] = ACTIONS(3889),
    [anon_sym_use_BANG] = ACTIONS(3887),
    [anon_sym_do_BANG] = ACTIONS(3887),
    [anon_sym_begin] = ACTIONS(3889),
    [anon_sym_LPAREN2] = ACTIONS(3889),
    [anon_sym_or] = ACTIONS(3889),
    [anon_sym_exception] = ACTIONS(3889),
    [aux_sym_char_token1] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3889),
    [anon_sym_DQUOTE] = ACTIONS(3889),
    [anon_sym_AT_DQUOTE] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [sym_bool] = ACTIONS(3889),
    [sym_unit] = ACTIONS(3887),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3889),
    [sym_op_identifier] = ACTIONS(3889),
    [anon_sym_PLUS] = ACTIONS(3889),
    [anon_sym_DASH] = ACTIONS(3889),
    [anon_sym_PLUS_DOT] = ACTIONS(3889),
    [anon_sym_DASH_DOT] = ACTIONS(3889),
    [anon_sym_PERCENT] = ACTIONS(3889),
    [anon_sym_AMP_AMP] = ACTIONS(3889),
    [anon_sym_TILDE] = ACTIONS(3887),
    [aux_sym_prefix_op_token1] = ACTIONS(3889),
    [aux_sym_infix_op_token1] = ACTIONS(3887),
    [aux_sym_infix_op_token2] = ACTIONS(3889),
    [anon_sym_PIPE_PIPE] = ACTIONS(3889),
    [anon_sym_BANG_EQ] = ACTIONS(3889),
    [anon_sym_COLON_EQ] = ACTIONS(3887),
    [anon_sym_DOLLAR] = ACTIONS(3889),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3889),
    [sym_int] = ACTIONS(3889),
    [sym_xint] = ACTIONS(3887),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3887),
    [anon_sym_POUNDload] = ACTIONS(3887),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3887),
    [sym__newline] = ACTIONS(3887),
  },
  [2377] = {
    [sym_block_comment] = STATE(2377),
    [sym_compiler_directive_decl] = STATE(2377),
    [sym_fsi_directive_decl] = STATE(2377),
    [sym_preproc_line] = STATE(2377),
    [ts_builtin_sym_end] = ACTIONS(4218),
    [sym_identifier] = ACTIONS(4220),
    [anon_sym_namespace] = ACTIONS(4220),
    [anon_sym_module] = ACTIONS(4220),
    [anon_sym_EQ] = ACTIONS(4218),
    [anon_sym_open] = ACTIONS(4220),
    [anon_sym_LBRACK_LT] = ACTIONS(4218),
    [anon_sym_COLON] = ACTIONS(4220),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_type] = ACTIONS(4220),
    [anon_sym_do] = ACTIONS(4220),
    [anon_sym_let] = ACTIONS(4220),
    [anon_sym_let_BANG] = ACTIONS(4218),
    [anon_sym_LPAREN] = ACTIONS(4220),
    [anon_sym_COMMA] = ACTIONS(4218),
    [anon_sym_null] = ACTIONS(4220),
    [anon_sym_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_COLON] = ACTIONS(4218),
    [anon_sym_AMP] = ACTIONS(4220),
    [anon_sym_LBRACK] = ACTIONS(4220),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(4220),
    [anon_sym_LT_AT] = ACTIONS(4220),
    [anon_sym_LT_AT_AT] = ACTIONS(4220),
    [anon_sym_DOT] = ACTIONS(4220),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4218),
    [anon_sym_new] = ACTIONS(4220),
    [anon_sym_return_BANG] = ACTIONS(4218),
    [anon_sym_yield] = ACTIONS(4220),
    [anon_sym_yield_BANG] = ACTIONS(4218),
    [anon_sym_lazy] = ACTIONS(4220),
    [anon_sym_assert] = ACTIONS(4220),
    [anon_sym_upcast] = ACTIONS(4220),
    [anon_sym_downcast] = ACTIONS(4220),
    [anon_sym_COLON_GT] = ACTIONS(4218),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4218),
    [anon_sym_for] = ACTIONS(4220),
    [anon_sym_while] = ACTIONS(4220),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_fun] = ACTIONS(4220),
    [anon_sym_try] = ACTIONS(4220),
    [anon_sym_match] = ACTIONS(4220),
    [anon_sym_match_BANG] = ACTIONS(4218),
    [anon_sym_function] = ACTIONS(4220),
    [anon_sym_LT_DASH] = ACTIONS(4220),
    [anon_sym_DOT_LBRACK] = ACTIONS(4218),
    [anon_sym_LT] = ACTIONS(4218),
    [anon_sym_use] = ACTIONS(4220),
    [anon_sym_use_BANG] = ACTIONS(4218),
    [anon_sym_do_BANG] = ACTIONS(4218),
    [anon_sym_begin] = ACTIONS(4220),
    [anon_sym_LPAREN2] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(4220),
    [anon_sym_exception] = ACTIONS(4220),
    [aux_sym_char_token1] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4220),
    [anon_sym_DQUOTE] = ACTIONS(4220),
    [anon_sym_AT_DQUOTE] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [sym_bool] = ACTIONS(4220),
    [sym_unit] = ACTIONS(4218),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4220),
    [sym_op_identifier] = ACTIONS(4220),
    [anon_sym_PLUS] = ACTIONS(4220),
    [anon_sym_DASH] = ACTIONS(4220),
    [anon_sym_PLUS_DOT] = ACTIONS(4220),
    [anon_sym_DASH_DOT] = ACTIONS(4220),
    [anon_sym_PERCENT] = ACTIONS(4220),
    [anon_sym_AMP_AMP] = ACTIONS(4220),
    [anon_sym_TILDE] = ACTIONS(4218),
    [aux_sym_prefix_op_token1] = ACTIONS(4220),
    [aux_sym_infix_op_token1] = ACTIONS(4218),
    [aux_sym_infix_op_token2] = ACTIONS(4220),
    [anon_sym_PIPE_PIPE] = ACTIONS(4220),
    [anon_sym_BANG_EQ] = ACTIONS(4220),
    [anon_sym_COLON_EQ] = ACTIONS(4218),
    [anon_sym_DOLLAR] = ACTIONS(4220),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4220),
    [sym_int] = ACTIONS(4220),
    [sym_xint] = ACTIONS(4218),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4218),
    [anon_sym_POUNDload] = ACTIONS(4218),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4218),
    [sym__newline] = ACTIONS(4218),
  },
  [2378] = {
    [sym_block_comment] = STATE(2378),
    [sym_compiler_directive_decl] = STATE(2378),
    [sym_fsi_directive_decl] = STATE(2378),
    [sym_preproc_line] = STATE(2378),
    [ts_builtin_sym_end] = ACTIONS(4214),
    [sym_identifier] = ACTIONS(4216),
    [anon_sym_namespace] = ACTIONS(4216),
    [anon_sym_module] = ACTIONS(4216),
    [anon_sym_EQ] = ACTIONS(4214),
    [anon_sym_open] = ACTIONS(4216),
    [anon_sym_LBRACK_LT] = ACTIONS(4214),
    [anon_sym_COLON] = ACTIONS(4216),
    [anon_sym_return] = ACTIONS(4216),
    [anon_sym_type] = ACTIONS(4216),
    [anon_sym_do] = ACTIONS(4216),
    [anon_sym_let] = ACTIONS(4216),
    [anon_sym_let_BANG] = ACTIONS(4214),
    [anon_sym_LPAREN] = ACTIONS(4216),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_null] = ACTIONS(4216),
    [anon_sym_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_COLON] = ACTIONS(4214),
    [anon_sym_AMP] = ACTIONS(4216),
    [anon_sym_LBRACK] = ACTIONS(4216),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4214),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_LT_AT] = ACTIONS(4216),
    [anon_sym_LT_AT_AT] = ACTIONS(4216),
    [anon_sym_DOT] = ACTIONS(4216),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4214),
    [anon_sym_new] = ACTIONS(4216),
    [anon_sym_return_BANG] = ACTIONS(4214),
    [anon_sym_yield] = ACTIONS(4216),
    [anon_sym_yield_BANG] = ACTIONS(4214),
    [anon_sym_lazy] = ACTIONS(4216),
    [anon_sym_assert] = ACTIONS(4216),
    [anon_sym_upcast] = ACTIONS(4216),
    [anon_sym_downcast] = ACTIONS(4216),
    [anon_sym_COLON_GT] = ACTIONS(4214),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4214),
    [anon_sym_for] = ACTIONS(4216),
    [anon_sym_while] = ACTIONS(4216),
    [anon_sym_if] = ACTIONS(4216),
    [anon_sym_fun] = ACTIONS(4216),
    [anon_sym_try] = ACTIONS(4216),
    [anon_sym_match] = ACTIONS(4216),
    [anon_sym_match_BANG] = ACTIONS(4214),
    [anon_sym_function] = ACTIONS(4216),
    [anon_sym_LT_DASH] = ACTIONS(4216),
    [anon_sym_DOT_LBRACK] = ACTIONS(4214),
    [anon_sym_LT] = ACTIONS(4214),
    [anon_sym_use] = ACTIONS(4216),
    [anon_sym_use_BANG] = ACTIONS(4214),
    [anon_sym_do_BANG] = ACTIONS(4214),
    [anon_sym_begin] = ACTIONS(4216),
    [anon_sym_LPAREN2] = ACTIONS(4216),
    [anon_sym_or] = ACTIONS(4216),
    [anon_sym_exception] = ACTIONS(4216),
    [aux_sym_char_token1] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4216),
    [anon_sym_DQUOTE] = ACTIONS(4216),
    [anon_sym_AT_DQUOTE] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [sym_bool] = ACTIONS(4216),
    [sym_unit] = ACTIONS(4214),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4216),
    [sym_op_identifier] = ACTIONS(4216),
    [anon_sym_PLUS] = ACTIONS(4216),
    [anon_sym_DASH] = ACTIONS(4216),
    [anon_sym_PLUS_DOT] = ACTIONS(4216),
    [anon_sym_DASH_DOT] = ACTIONS(4216),
    [anon_sym_PERCENT] = ACTIONS(4216),
    [anon_sym_AMP_AMP] = ACTIONS(4216),
    [anon_sym_TILDE] = ACTIONS(4214),
    [aux_sym_prefix_op_token1] = ACTIONS(4216),
    [aux_sym_infix_op_token1] = ACTIONS(4214),
    [aux_sym_infix_op_token2] = ACTIONS(4216),
    [anon_sym_PIPE_PIPE] = ACTIONS(4216),
    [anon_sym_BANG_EQ] = ACTIONS(4216),
    [anon_sym_COLON_EQ] = ACTIONS(4214),
    [anon_sym_DOLLAR] = ACTIONS(4216),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4216),
    [sym_int] = ACTIONS(4216),
    [sym_xint] = ACTIONS(4214),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4214),
    [anon_sym_POUNDload] = ACTIONS(4214),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4214),
    [sym__newline] = ACTIONS(4214),
  },
  [2379] = {
    [sym_block_comment] = STATE(2379),
    [sym_compiler_directive_decl] = STATE(2379),
    [sym_fsi_directive_decl] = STATE(2379),
    [sym_preproc_line] = STATE(2379),
    [ts_builtin_sym_end] = ACTIONS(4199),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_namespace] = ACTIONS(4201),
    [anon_sym_module] = ACTIONS(4201),
    [anon_sym_EQ] = ACTIONS(4199),
    [anon_sym_open] = ACTIONS(4201),
    [anon_sym_LBRACK_LT] = ACTIONS(4199),
    [anon_sym_COLON] = ACTIONS(4201),
    [anon_sym_return] = ACTIONS(4201),
    [anon_sym_type] = ACTIONS(4201),
    [anon_sym_do] = ACTIONS(4201),
    [anon_sym_let] = ACTIONS(4201),
    [anon_sym_let_BANG] = ACTIONS(4199),
    [anon_sym_LPAREN] = ACTIONS(4201),
    [anon_sym_COMMA] = ACTIONS(4199),
    [anon_sym_null] = ACTIONS(4201),
    [anon_sym_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(4199),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_LBRACK] = ACTIONS(4201),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4199),
    [anon_sym_LBRACE] = ACTIONS(4201),
    [anon_sym_LT_AT] = ACTIONS(4201),
    [anon_sym_LT_AT_AT] = ACTIONS(4201),
    [anon_sym_DOT] = ACTIONS(4201),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4199),
    [anon_sym_new] = ACTIONS(4201),
    [anon_sym_return_BANG] = ACTIONS(4199),
    [anon_sym_yield] = ACTIONS(4201),
    [anon_sym_yield_BANG] = ACTIONS(4199),
    [anon_sym_lazy] = ACTIONS(4201),
    [anon_sym_assert] = ACTIONS(4201),
    [anon_sym_upcast] = ACTIONS(4201),
    [anon_sym_downcast] = ACTIONS(4201),
    [anon_sym_COLON_GT] = ACTIONS(4199),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4199),
    [anon_sym_for] = ACTIONS(4201),
    [anon_sym_while] = ACTIONS(4201),
    [anon_sym_if] = ACTIONS(4201),
    [anon_sym_fun] = ACTIONS(4201),
    [anon_sym_try] = ACTIONS(4201),
    [anon_sym_match] = ACTIONS(4201),
    [anon_sym_match_BANG] = ACTIONS(4199),
    [anon_sym_function] = ACTIONS(4201),
    [anon_sym_LT_DASH] = ACTIONS(4201),
    [anon_sym_DOT_LBRACK] = ACTIONS(4199),
    [anon_sym_LT] = ACTIONS(4199),
    [anon_sym_use] = ACTIONS(4201),
    [anon_sym_use_BANG] = ACTIONS(4199),
    [anon_sym_do_BANG] = ACTIONS(4199),
    [anon_sym_begin] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(4201),
    [anon_sym_or] = ACTIONS(4201),
    [anon_sym_exception] = ACTIONS(4201),
    [aux_sym_char_token1] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4201),
    [anon_sym_DQUOTE] = ACTIONS(4201),
    [anon_sym_AT_DQUOTE] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [sym_bool] = ACTIONS(4201),
    [sym_unit] = ACTIONS(4199),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4201),
    [sym_op_identifier] = ACTIONS(4201),
    [anon_sym_PLUS] = ACTIONS(4201),
    [anon_sym_DASH] = ACTIONS(4201),
    [anon_sym_PLUS_DOT] = ACTIONS(4201),
    [anon_sym_DASH_DOT] = ACTIONS(4201),
    [anon_sym_PERCENT] = ACTIONS(4201),
    [anon_sym_AMP_AMP] = ACTIONS(4201),
    [anon_sym_TILDE] = ACTIONS(4199),
    [aux_sym_prefix_op_token1] = ACTIONS(4201),
    [aux_sym_infix_op_token1] = ACTIONS(4199),
    [aux_sym_infix_op_token2] = ACTIONS(4201),
    [anon_sym_PIPE_PIPE] = ACTIONS(4201),
    [anon_sym_BANG_EQ] = ACTIONS(4201),
    [anon_sym_COLON_EQ] = ACTIONS(4199),
    [anon_sym_DOLLAR] = ACTIONS(4201),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4201),
    [sym_int] = ACTIONS(4201),
    [sym_xint] = ACTIONS(4199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4199),
    [anon_sym_POUNDload] = ACTIONS(4199),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4199),
    [sym__newline] = ACTIONS(4199),
  },
  [2380] = {
    [sym_block_comment] = STATE(2380),
    [sym_compiler_directive_decl] = STATE(2380),
    [sym_fsi_directive_decl] = STATE(2380),
    [sym_preproc_line] = STATE(2380),
    [ts_builtin_sym_end] = ACTIONS(4195),
    [sym_identifier] = ACTIONS(4197),
    [anon_sym_namespace] = ACTIONS(4197),
    [anon_sym_module] = ACTIONS(4197),
    [anon_sym_EQ] = ACTIONS(4195),
    [anon_sym_open] = ACTIONS(4197),
    [anon_sym_LBRACK_LT] = ACTIONS(4195),
    [anon_sym_COLON] = ACTIONS(4197),
    [anon_sym_return] = ACTIONS(4197),
    [anon_sym_type] = ACTIONS(4197),
    [anon_sym_do] = ACTIONS(4197),
    [anon_sym_let] = ACTIONS(4197),
    [anon_sym_let_BANG] = ACTIONS(4195),
    [anon_sym_LPAREN] = ACTIONS(4197),
    [anon_sym_COMMA] = ACTIONS(4195),
    [anon_sym_null] = ACTIONS(4197),
    [anon_sym_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_COLON] = ACTIONS(4195),
    [anon_sym_AMP] = ACTIONS(4197),
    [anon_sym_LBRACK] = ACTIONS(4197),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4195),
    [anon_sym_LBRACE] = ACTIONS(4197),
    [anon_sym_LT_AT] = ACTIONS(4197),
    [anon_sym_LT_AT_AT] = ACTIONS(4197),
    [anon_sym_DOT] = ACTIONS(4197),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4195),
    [anon_sym_new] = ACTIONS(4197),
    [anon_sym_return_BANG] = ACTIONS(4195),
    [anon_sym_yield] = ACTIONS(4197),
    [anon_sym_yield_BANG] = ACTIONS(4195),
    [anon_sym_lazy] = ACTIONS(4197),
    [anon_sym_assert] = ACTIONS(4197),
    [anon_sym_upcast] = ACTIONS(4197),
    [anon_sym_downcast] = ACTIONS(4197),
    [anon_sym_COLON_GT] = ACTIONS(4195),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4195),
    [anon_sym_for] = ACTIONS(4197),
    [anon_sym_while] = ACTIONS(4197),
    [anon_sym_if] = ACTIONS(4197),
    [anon_sym_fun] = ACTIONS(4197),
    [anon_sym_try] = ACTIONS(4197),
    [anon_sym_match] = ACTIONS(4197),
    [anon_sym_match_BANG] = ACTIONS(4195),
    [anon_sym_function] = ACTIONS(4197),
    [anon_sym_LT_DASH] = ACTIONS(4197),
    [anon_sym_DOT_LBRACK] = ACTIONS(4195),
    [anon_sym_LT] = ACTIONS(4195),
    [anon_sym_use] = ACTIONS(4197),
    [anon_sym_use_BANG] = ACTIONS(4195),
    [anon_sym_do_BANG] = ACTIONS(4195),
    [anon_sym_begin] = ACTIONS(4197),
    [anon_sym_LPAREN2] = ACTIONS(4197),
    [anon_sym_or] = ACTIONS(4197),
    [anon_sym_exception] = ACTIONS(4197),
    [aux_sym_char_token1] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4197),
    [anon_sym_DQUOTE] = ACTIONS(4197),
    [anon_sym_AT_DQUOTE] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [sym_bool] = ACTIONS(4197),
    [sym_unit] = ACTIONS(4195),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4197),
    [sym_op_identifier] = ACTIONS(4197),
    [anon_sym_PLUS] = ACTIONS(4197),
    [anon_sym_DASH] = ACTIONS(4197),
    [anon_sym_PLUS_DOT] = ACTIONS(4197),
    [anon_sym_DASH_DOT] = ACTIONS(4197),
    [anon_sym_PERCENT] = ACTIONS(4197),
    [anon_sym_AMP_AMP] = ACTIONS(4197),
    [anon_sym_TILDE] = ACTIONS(4195),
    [aux_sym_prefix_op_token1] = ACTIONS(4197),
    [aux_sym_infix_op_token1] = ACTIONS(4195),
    [aux_sym_infix_op_token2] = ACTIONS(4197),
    [anon_sym_PIPE_PIPE] = ACTIONS(4197),
    [anon_sym_BANG_EQ] = ACTIONS(4197),
    [anon_sym_COLON_EQ] = ACTIONS(4195),
    [anon_sym_DOLLAR] = ACTIONS(4197),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4197),
    [sym_int] = ACTIONS(4197),
    [sym_xint] = ACTIONS(4195),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4195),
    [anon_sym_POUNDload] = ACTIONS(4195),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4195),
    [sym__newline] = ACTIONS(4195),
  },
  [2381] = {
    [sym_block_comment] = STATE(2381),
    [sym_compiler_directive_decl] = STATE(2381),
    [sym_fsi_directive_decl] = STATE(2381),
    [sym_preproc_line] = STATE(2381),
    [aux_sym_sequential_expression_repeat1] = STATE(2381),
    [ts_builtin_sym_end] = ACTIONS(3765),
    [sym_identifier] = ACTIONS(3767),
    [anon_sym_module] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3765),
    [anon_sym_open] = ACTIONS(3767),
    [anon_sym_LBRACK_LT] = ACTIONS(3765),
    [anon_sym_COLON] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_type] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_let_BANG] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(3767),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_null] = ACTIONS(3767),
    [anon_sym_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3765),
    [anon_sym_LBRACE] = ACTIONS(3767),
    [anon_sym_LT_AT] = ACTIONS(3767),
    [anon_sym_LT_AT_AT] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3765),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_return_BANG] = ACTIONS(3765),
    [anon_sym_yield] = ACTIONS(3767),
    [anon_sym_yield_BANG] = ACTIONS(3765),
    [anon_sym_lazy] = ACTIONS(3767),
    [anon_sym_assert] = ACTIONS(3767),
    [anon_sym_upcast] = ACTIONS(3767),
    [anon_sym_downcast] = ACTIONS(3767),
    [anon_sym_COLON_GT] = ACTIONS(3765),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3765),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_fun] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_match] = ACTIONS(3767),
    [anon_sym_match_BANG] = ACTIONS(3765),
    [anon_sym_function] = ACTIONS(3767),
    [anon_sym_LT_DASH] = ACTIONS(3767),
    [anon_sym_DOT_LBRACK] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(3765),
    [anon_sym_use] = ACTIONS(3767),
    [anon_sym_use_BANG] = ACTIONS(3765),
    [anon_sym_do_BANG] = ACTIONS(3765),
    [anon_sym_begin] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3767),
    [anon_sym_or] = ACTIONS(3767),
    [anon_sym_exception] = ACTIONS(3767),
    [aux_sym_char_token1] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3767),
    [anon_sym_DQUOTE] = ACTIONS(3767),
    [anon_sym_AT_DQUOTE] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [sym_bool] = ACTIONS(3767),
    [sym_unit] = ACTIONS(3765),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3767),
    [sym_op_identifier] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_PLUS_DOT] = ACTIONS(3767),
    [anon_sym_DASH_DOT] = ACTIONS(3767),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_AMP_AMP] = ACTIONS(3767),
    [anon_sym_TILDE] = ACTIONS(3765),
    [aux_sym_prefix_op_token1] = ACTIONS(3767),
    [aux_sym_infix_op_token1] = ACTIONS(3765),
    [aux_sym_infix_op_token2] = ACTIONS(3767),
    [anon_sym_PIPE_PIPE] = ACTIONS(3767),
    [anon_sym_BANG_EQ] = ACTIONS(3767),
    [anon_sym_COLON_EQ] = ACTIONS(3765),
    [anon_sym_DOLLAR] = ACTIONS(3767),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3767),
    [sym_int] = ACTIONS(3767),
    [sym_xint] = ACTIONS(3765),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3765),
    [anon_sym_POUNDload] = ACTIONS(3765),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3765),
    [sym__newline] = ACTIONS(4951),
  },
  [2382] = {
    [sym_block_comment] = STATE(2382),
    [sym_compiler_directive_decl] = STATE(2382),
    [sym_fsi_directive_decl] = STATE(2382),
    [sym_preproc_line] = STATE(2382),
    [ts_builtin_sym_end] = ACTIONS(4178),
    [sym_identifier] = ACTIONS(4180),
    [anon_sym_namespace] = ACTIONS(4180),
    [anon_sym_module] = ACTIONS(4180),
    [anon_sym_EQ] = ACTIONS(4178),
    [anon_sym_open] = ACTIONS(4180),
    [anon_sym_LBRACK_LT] = ACTIONS(4178),
    [anon_sym_COLON] = ACTIONS(4180),
    [anon_sym_return] = ACTIONS(4180),
    [anon_sym_type] = ACTIONS(4180),
    [anon_sym_do] = ACTIONS(4180),
    [anon_sym_let] = ACTIONS(4180),
    [anon_sym_let_BANG] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(4180),
    [anon_sym_COMMA] = ACTIONS(4178),
    [anon_sym_null] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_COLON] = ACTIONS(4178),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4180),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4180),
    [anon_sym_LT_AT] = ACTIONS(4180),
    [anon_sym_LT_AT_AT] = ACTIONS(4180),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4178),
    [anon_sym_new] = ACTIONS(4180),
    [anon_sym_return_BANG] = ACTIONS(4178),
    [anon_sym_yield] = ACTIONS(4180),
    [anon_sym_yield_BANG] = ACTIONS(4178),
    [anon_sym_lazy] = ACTIONS(4180),
    [anon_sym_assert] = ACTIONS(4180),
    [anon_sym_upcast] = ACTIONS(4180),
    [anon_sym_downcast] = ACTIONS(4180),
    [anon_sym_COLON_GT] = ACTIONS(4178),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4178),
    [anon_sym_for] = ACTIONS(4180),
    [anon_sym_while] = ACTIONS(4180),
    [anon_sym_if] = ACTIONS(4180),
    [anon_sym_fun] = ACTIONS(4180),
    [anon_sym_try] = ACTIONS(4180),
    [anon_sym_match] = ACTIONS(4180),
    [anon_sym_match_BANG] = ACTIONS(4178),
    [anon_sym_function] = ACTIONS(4180),
    [anon_sym_LT_DASH] = ACTIONS(4180),
    [anon_sym_DOT_LBRACK] = ACTIONS(4178),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_use] = ACTIONS(4180),
    [anon_sym_use_BANG] = ACTIONS(4178),
    [anon_sym_do_BANG] = ACTIONS(4178),
    [anon_sym_begin] = ACTIONS(4180),
    [anon_sym_LPAREN2] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [anon_sym_exception] = ACTIONS(4180),
    [aux_sym_char_token1] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4180),
    [anon_sym_DQUOTE] = ACTIONS(4180),
    [anon_sym_AT_DQUOTE] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [sym_bool] = ACTIONS(4180),
    [sym_unit] = ACTIONS(4178),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4180),
    [sym_op_identifier] = ACTIONS(4180),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_PLUS_DOT] = ACTIONS(4180),
    [anon_sym_DASH_DOT] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_TILDE] = ACTIONS(4178),
    [aux_sym_prefix_op_token1] = ACTIONS(4180),
    [aux_sym_infix_op_token1] = ACTIONS(4178),
    [aux_sym_infix_op_token2] = ACTIONS(4180),
    [anon_sym_PIPE_PIPE] = ACTIONS(4180),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_COLON_EQ] = ACTIONS(4178),
    [anon_sym_DOLLAR] = ACTIONS(4180),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4180),
    [sym_int] = ACTIONS(4180),
    [sym_xint] = ACTIONS(4178),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4178),
    [anon_sym_POUNDload] = ACTIONS(4178),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4178),
    [sym__newline] = ACTIONS(4178),
  },
  [2383] = {
    [sym_block_comment] = STATE(2383),
    [sym_compiler_directive_decl] = STATE(2383),
    [sym_fsi_directive_decl] = STATE(2383),
    [sym_preproc_line] = STATE(2383),
    [ts_builtin_sym_end] = ACTIONS(3485),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_namespace] = ACTIONS(3487),
    [anon_sym_module] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_open] = ACTIONS(3487),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_type] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_exception] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3485),
    [anon_sym_POUNDload] = ACTIONS(3485),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [2384] = {
    [sym_block_comment] = STATE(2384),
    [sym_compiler_directive_decl] = STATE(2384),
    [sym_fsi_directive_decl] = STATE(2384),
    [sym_preproc_line] = STATE(2384),
    [ts_builtin_sym_end] = ACTIONS(4191),
    [sym_identifier] = ACTIONS(4193),
    [anon_sym_namespace] = ACTIONS(4193),
    [anon_sym_module] = ACTIONS(4193),
    [anon_sym_EQ] = ACTIONS(4191),
    [anon_sym_open] = ACTIONS(4193),
    [anon_sym_LBRACK_LT] = ACTIONS(4191),
    [anon_sym_COLON] = ACTIONS(4193),
    [anon_sym_return] = ACTIONS(4193),
    [anon_sym_type] = ACTIONS(4193),
    [anon_sym_do] = ACTIONS(4193),
    [anon_sym_let] = ACTIONS(4193),
    [anon_sym_let_BANG] = ACTIONS(4191),
    [anon_sym_LPAREN] = ACTIONS(4193),
    [anon_sym_COMMA] = ACTIONS(4191),
    [anon_sym_null] = ACTIONS(4193),
    [anon_sym_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_COLON] = ACTIONS(4191),
    [anon_sym_AMP] = ACTIONS(4193),
    [anon_sym_LBRACK] = ACTIONS(4193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4191),
    [anon_sym_LBRACE] = ACTIONS(4193),
    [anon_sym_LT_AT] = ACTIONS(4193),
    [anon_sym_LT_AT_AT] = ACTIONS(4193),
    [anon_sym_DOT] = ACTIONS(4193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4191),
    [anon_sym_new] = ACTIONS(4193),
    [anon_sym_return_BANG] = ACTIONS(4191),
    [anon_sym_yield] = ACTIONS(4193),
    [anon_sym_yield_BANG] = ACTIONS(4191),
    [anon_sym_lazy] = ACTIONS(4193),
    [anon_sym_assert] = ACTIONS(4193),
    [anon_sym_upcast] = ACTIONS(4193),
    [anon_sym_downcast] = ACTIONS(4193),
    [anon_sym_COLON_GT] = ACTIONS(4191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4191),
    [anon_sym_for] = ACTIONS(4193),
    [anon_sym_while] = ACTIONS(4193),
    [anon_sym_if] = ACTIONS(4193),
    [anon_sym_fun] = ACTIONS(4193),
    [anon_sym_try] = ACTIONS(4193),
    [anon_sym_match] = ACTIONS(4193),
    [anon_sym_match_BANG] = ACTIONS(4191),
    [anon_sym_function] = ACTIONS(4193),
    [anon_sym_LT_DASH] = ACTIONS(4193),
    [anon_sym_DOT_LBRACK] = ACTIONS(4191),
    [anon_sym_LT] = ACTIONS(4191),
    [anon_sym_use] = ACTIONS(4193),
    [anon_sym_use_BANG] = ACTIONS(4191),
    [anon_sym_do_BANG] = ACTIONS(4191),
    [anon_sym_begin] = ACTIONS(4193),
    [anon_sym_LPAREN2] = ACTIONS(4193),
    [anon_sym_or] = ACTIONS(4193),
    [anon_sym_exception] = ACTIONS(4193),
    [aux_sym_char_token1] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4193),
    [anon_sym_DQUOTE] = ACTIONS(4193),
    [anon_sym_AT_DQUOTE] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [sym_bool] = ACTIONS(4193),
    [sym_unit] = ACTIONS(4191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4193),
    [sym_op_identifier] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4193),
    [anon_sym_DASH] = ACTIONS(4193),
    [anon_sym_PLUS_DOT] = ACTIONS(4193),
    [anon_sym_DASH_DOT] = ACTIONS(4193),
    [anon_sym_PERCENT] = ACTIONS(4193),
    [anon_sym_AMP_AMP] = ACTIONS(4193),
    [anon_sym_TILDE] = ACTIONS(4191),
    [aux_sym_prefix_op_token1] = ACTIONS(4193),
    [aux_sym_infix_op_token1] = ACTIONS(4191),
    [aux_sym_infix_op_token2] = ACTIONS(4193),
    [anon_sym_PIPE_PIPE] = ACTIONS(4193),
    [anon_sym_BANG_EQ] = ACTIONS(4193),
    [anon_sym_COLON_EQ] = ACTIONS(4191),
    [anon_sym_DOLLAR] = ACTIONS(4193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4193),
    [sym_int] = ACTIONS(4193),
    [sym_xint] = ACTIONS(4191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4191),
    [anon_sym_POUNDload] = ACTIONS(4191),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4191),
    [sym__newline] = ACTIONS(4191),
  },
  [2385] = {
    [sym_elif_expression] = STATE(2693),
    [sym_block_comment] = STATE(2385),
    [sym_compiler_directive_decl] = STATE(2385),
    [sym_fsi_directive_decl] = STATE(2385),
    [sym_preproc_line] = STATE(2385),
    [aux_sym_if_expression_repeat1] = STATE(2385),
    [sym_identifier] = ACTIONS(3555),
    [anon_sym_EQ] = ACTIONS(3553),
    [anon_sym_COLON] = ACTIONS(3555),
    [anon_sym_return] = ACTIONS(3555),
    [anon_sym_do] = ACTIONS(3555),
    [anon_sym_let] = ACTIONS(3555),
    [anon_sym_let_BANG] = ACTIONS(3553),
    [anon_sym_as] = ACTIONS(3555),
    [anon_sym_LPAREN] = ACTIONS(3555),
    [anon_sym_COMMA] = ACTIONS(3553),
    [anon_sym_null] = ACTIONS(3555),
    [anon_sym_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_COLON] = ACTIONS(3553),
    [anon_sym_AMP] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(3555),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3553),
    [anon_sym_LBRACE] = ACTIONS(3555),
    [anon_sym_LT_AT] = ACTIONS(3555),
    [anon_sym_LT_AT_AT] = ACTIONS(3555),
    [anon_sym_DOT] = ACTIONS(3555),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3553),
    [anon_sym_new] = ACTIONS(3555),
    [anon_sym_with] = ACTIONS(3555),
    [anon_sym_return_BANG] = ACTIONS(3553),
    [anon_sym_yield] = ACTIONS(3555),
    [anon_sym_yield_BANG] = ACTIONS(3553),
    [anon_sym_lazy] = ACTIONS(3555),
    [anon_sym_assert] = ACTIONS(3555),
    [anon_sym_upcast] = ACTIONS(3555),
    [anon_sym_downcast] = ACTIONS(3555),
    [anon_sym_COLON_GT] = ACTIONS(3553),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3553),
    [anon_sym_for] = ACTIONS(3555),
    [anon_sym_while] = ACTIONS(3555),
    [anon_sym_else] = ACTIONS(3555),
    [anon_sym_elif] = ACTIONS(4954),
    [anon_sym_if] = ACTIONS(3555),
    [anon_sym_fun] = ACTIONS(3555),
    [anon_sym_try] = ACTIONS(3555),
    [anon_sym_match] = ACTIONS(3555),
    [anon_sym_match_BANG] = ACTIONS(3553),
    [anon_sym_function] = ACTIONS(3555),
    [anon_sym_LT_DASH] = ACTIONS(3555),
    [anon_sym_DOT_LBRACK] = ACTIONS(3553),
    [anon_sym_LT] = ACTIONS(3553),
    [anon_sym_use] = ACTIONS(3555),
    [anon_sym_use_BANG] = ACTIONS(3553),
    [anon_sym_do_BANG] = ACTIONS(3553),
    [anon_sym_begin] = ACTIONS(3555),
    [anon_sym_LPAREN2] = ACTIONS(3555),
    [anon_sym_or] = ACTIONS(3555),
    [aux_sym_char_token1] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3555),
    [anon_sym_DQUOTE] = ACTIONS(3555),
    [anon_sym_AT_DQUOTE] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [sym_bool] = ACTIONS(3555),
    [sym_unit] = ACTIONS(3553),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3555),
    [sym_op_identifier] = ACTIONS(3555),
    [anon_sym_PLUS] = ACTIONS(3555),
    [anon_sym_DASH] = ACTIONS(3555),
    [anon_sym_PLUS_DOT] = ACTIONS(3555),
    [anon_sym_DASH_DOT] = ACTIONS(3555),
    [anon_sym_PERCENT] = ACTIONS(3555),
    [anon_sym_AMP_AMP] = ACTIONS(3555),
    [anon_sym_TILDE] = ACTIONS(3553),
    [aux_sym_prefix_op_token1] = ACTIONS(3555),
    [aux_sym_infix_op_token1] = ACTIONS(3553),
    [aux_sym_infix_op_token2] = ACTIONS(3555),
    [anon_sym_PIPE_PIPE] = ACTIONS(3555),
    [anon_sym_BANG_EQ] = ACTIONS(3555),
    [anon_sym_COLON_EQ] = ACTIONS(3553),
    [anon_sym_DOLLAR] = ACTIONS(3555),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3555),
    [sym_int] = ACTIONS(3555),
    [sym_xint] = ACTIONS(3553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3553),
    [sym__newline] = ACTIONS(3553),
    [sym__dedent] = ACTIONS(3553),
  },
  [2386] = {
    [sym_block_comment] = STATE(2386),
    [sym_compiler_directive_decl] = STATE(2386),
    [sym_fsi_directive_decl] = STATE(2386),
    [sym_preproc_line] = STATE(2386),
    [ts_builtin_sym_end] = ACTIONS(4184),
    [sym_identifier] = ACTIONS(4186),
    [anon_sym_namespace] = ACTIONS(4186),
    [anon_sym_module] = ACTIONS(4186),
    [anon_sym_EQ] = ACTIONS(4184),
    [anon_sym_open] = ACTIONS(4186),
    [anon_sym_LBRACK_LT] = ACTIONS(4184),
    [anon_sym_COLON] = ACTIONS(4186),
    [anon_sym_return] = ACTIONS(4186),
    [anon_sym_type] = ACTIONS(4186),
    [anon_sym_do] = ACTIONS(4186),
    [anon_sym_let] = ACTIONS(4186),
    [anon_sym_let_BANG] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_COMMA] = ACTIONS(4184),
    [anon_sym_null] = ACTIONS(4186),
    [anon_sym_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_COLON] = ACTIONS(4184),
    [anon_sym_AMP] = ACTIONS(4186),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4184),
    [anon_sym_LBRACE] = ACTIONS(4186),
    [anon_sym_LT_AT] = ACTIONS(4186),
    [anon_sym_LT_AT_AT] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4186),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4184),
    [anon_sym_new] = ACTIONS(4186),
    [anon_sym_return_BANG] = ACTIONS(4184),
    [anon_sym_yield] = ACTIONS(4186),
    [anon_sym_yield_BANG] = ACTIONS(4184),
    [anon_sym_lazy] = ACTIONS(4186),
    [anon_sym_assert] = ACTIONS(4186),
    [anon_sym_upcast] = ACTIONS(4186),
    [anon_sym_downcast] = ACTIONS(4186),
    [anon_sym_COLON_GT] = ACTIONS(4184),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4184),
    [anon_sym_for] = ACTIONS(4186),
    [anon_sym_while] = ACTIONS(4186),
    [anon_sym_if] = ACTIONS(4186),
    [anon_sym_fun] = ACTIONS(4186),
    [anon_sym_try] = ACTIONS(4186),
    [anon_sym_match] = ACTIONS(4186),
    [anon_sym_match_BANG] = ACTIONS(4184),
    [anon_sym_function] = ACTIONS(4186),
    [anon_sym_LT_DASH] = ACTIONS(4186),
    [anon_sym_DOT_LBRACK] = ACTIONS(4184),
    [anon_sym_LT] = ACTIONS(4184),
    [anon_sym_use] = ACTIONS(4186),
    [anon_sym_use_BANG] = ACTIONS(4184),
    [anon_sym_do_BANG] = ACTIONS(4184),
    [anon_sym_begin] = ACTIONS(4186),
    [anon_sym_LPAREN2] = ACTIONS(4186),
    [anon_sym_or] = ACTIONS(4186),
    [anon_sym_exception] = ACTIONS(4186),
    [aux_sym_char_token1] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4186),
    [anon_sym_DQUOTE] = ACTIONS(4186),
    [anon_sym_AT_DQUOTE] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [sym_bool] = ACTIONS(4186),
    [sym_unit] = ACTIONS(4184),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4186),
    [sym_op_identifier] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4186),
    [anon_sym_DASH] = ACTIONS(4186),
    [anon_sym_PLUS_DOT] = ACTIONS(4186),
    [anon_sym_DASH_DOT] = ACTIONS(4186),
    [anon_sym_PERCENT] = ACTIONS(4186),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_TILDE] = ACTIONS(4184),
    [aux_sym_prefix_op_token1] = ACTIONS(4186),
    [aux_sym_infix_op_token1] = ACTIONS(4184),
    [aux_sym_infix_op_token2] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_COLON_EQ] = ACTIONS(4184),
    [anon_sym_DOLLAR] = ACTIONS(4186),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4186),
    [sym_int] = ACTIONS(4186),
    [sym_xint] = ACTIONS(4184),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4184),
    [anon_sym_POUNDload] = ACTIONS(4184),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4184),
    [sym__newline] = ACTIONS(4184),
  },
  [2387] = {
    [sym_block_comment] = STATE(2387),
    [sym_compiler_directive_decl] = STATE(2387),
    [sym_fsi_directive_decl] = STATE(2387),
    [sym_preproc_line] = STATE(2387),
    [ts_builtin_sym_end] = ACTIONS(4128),
    [sym_identifier] = ACTIONS(4130),
    [anon_sym_namespace] = ACTIONS(4130),
    [anon_sym_module] = ACTIONS(4130),
    [anon_sym_EQ] = ACTIONS(4128),
    [anon_sym_open] = ACTIONS(4130),
    [anon_sym_LBRACK_LT] = ACTIONS(4128),
    [anon_sym_COLON] = ACTIONS(4130),
    [anon_sym_return] = ACTIONS(4130),
    [anon_sym_type] = ACTIONS(4130),
    [anon_sym_do] = ACTIONS(4130),
    [anon_sym_let] = ACTIONS(4130),
    [anon_sym_let_BANG] = ACTIONS(4128),
    [anon_sym_LPAREN] = ACTIONS(4130),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_null] = ACTIONS(4130),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_COLON] = ACTIONS(4128),
    [anon_sym_AMP] = ACTIONS(4130),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4128),
    [anon_sym_LBRACE] = ACTIONS(4130),
    [anon_sym_LT_AT] = ACTIONS(4130),
    [anon_sym_LT_AT_AT] = ACTIONS(4130),
    [anon_sym_DOT] = ACTIONS(4130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4128),
    [anon_sym_new] = ACTIONS(4130),
    [anon_sym_return_BANG] = ACTIONS(4128),
    [anon_sym_yield] = ACTIONS(4130),
    [anon_sym_yield_BANG] = ACTIONS(4128),
    [anon_sym_lazy] = ACTIONS(4130),
    [anon_sym_assert] = ACTIONS(4130),
    [anon_sym_upcast] = ACTIONS(4130),
    [anon_sym_downcast] = ACTIONS(4130),
    [anon_sym_COLON_GT] = ACTIONS(4128),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4128),
    [anon_sym_for] = ACTIONS(4130),
    [anon_sym_while] = ACTIONS(4130),
    [anon_sym_if] = ACTIONS(4130),
    [anon_sym_fun] = ACTIONS(4130),
    [anon_sym_try] = ACTIONS(4130),
    [anon_sym_match] = ACTIONS(4130),
    [anon_sym_match_BANG] = ACTIONS(4128),
    [anon_sym_function] = ACTIONS(4130),
    [anon_sym_LT_DASH] = ACTIONS(4130),
    [anon_sym_DOT_LBRACK] = ACTIONS(4128),
    [anon_sym_LT] = ACTIONS(4128),
    [anon_sym_use] = ACTIONS(4130),
    [anon_sym_use_BANG] = ACTIONS(4128),
    [anon_sym_do_BANG] = ACTIONS(4128),
    [anon_sym_begin] = ACTIONS(4130),
    [anon_sym_LPAREN2] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_exception] = ACTIONS(4130),
    [aux_sym_char_token1] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4130),
    [anon_sym_DQUOTE] = ACTIONS(4130),
    [anon_sym_AT_DQUOTE] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [sym_bool] = ACTIONS(4130),
    [sym_unit] = ACTIONS(4128),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4130),
    [sym_op_identifier] = ACTIONS(4130),
    [anon_sym_PLUS] = ACTIONS(4130),
    [anon_sym_DASH] = ACTIONS(4130),
    [anon_sym_PLUS_DOT] = ACTIONS(4130),
    [anon_sym_DASH_DOT] = ACTIONS(4130),
    [anon_sym_PERCENT] = ACTIONS(4130),
    [anon_sym_AMP_AMP] = ACTIONS(4130),
    [anon_sym_TILDE] = ACTIONS(4128),
    [aux_sym_prefix_op_token1] = ACTIONS(4130),
    [aux_sym_infix_op_token1] = ACTIONS(4128),
    [aux_sym_infix_op_token2] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE] = ACTIONS(4130),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_COLON_EQ] = ACTIONS(4128),
    [anon_sym_DOLLAR] = ACTIONS(4130),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4130),
    [sym_int] = ACTIONS(4130),
    [sym_xint] = ACTIONS(4128),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4128),
    [anon_sym_POUNDload] = ACTIONS(4128),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4128),
    [sym__newline] = ACTIONS(4128),
  },
  [2388] = {
    [sym_block_comment] = STATE(2388),
    [sym_compiler_directive_decl] = STATE(2388),
    [sym_fsi_directive_decl] = STATE(2388),
    [sym_preproc_line] = STATE(2388),
    [sym_identifier] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3919),
    [anon_sym_GT_RBRACK] = ACTIONS(3919),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_return] = ACTIONS(3921),
    [anon_sym_do] = ACTIONS(3921),
    [anon_sym_let] = ACTIONS(3921),
    [anon_sym_let_BANG] = ACTIONS(3919),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3919),
    [anon_sym_null] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_COLON] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_RBRACK] = ACTIONS(3919),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3919),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_RBRACE] = ACTIONS(3919),
    [anon_sym_LT_AT] = ACTIONS(3921),
    [anon_sym_LT_AT_AT] = ACTIONS(3921),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3919),
    [anon_sym_new] = ACTIONS(3921),
    [anon_sym_with] = ACTIONS(3921),
    [anon_sym_return_BANG] = ACTIONS(3919),
    [anon_sym_yield] = ACTIONS(3921),
    [anon_sym_yield_BANG] = ACTIONS(3919),
    [anon_sym_lazy] = ACTIONS(3921),
    [anon_sym_assert] = ACTIONS(3921),
    [anon_sym_upcast] = ACTIONS(3921),
    [anon_sym_downcast] = ACTIONS(3921),
    [anon_sym_COLON_GT] = ACTIONS(3919),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3919),
    [anon_sym_for] = ACTIONS(3921),
    [anon_sym_to] = ACTIONS(3921),
    [anon_sym_downto] = ACTIONS(3921),
    [anon_sym_while] = ACTIONS(3921),
    [anon_sym_if] = ACTIONS(3921),
    [anon_sym_fun] = ACTIONS(3921),
    [anon_sym_try] = ACTIONS(3921),
    [anon_sym_match] = ACTIONS(3921),
    [anon_sym_match_BANG] = ACTIONS(3919),
    [anon_sym_function] = ACTIONS(3921),
    [anon_sym_LT_DASH] = ACTIONS(3921),
    [anon_sym_DOT_LBRACK] = ACTIONS(3919),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_use] = ACTIONS(3921),
    [anon_sym_use_BANG] = ACTIONS(3919),
    [anon_sym_do_BANG] = ACTIONS(3919),
    [anon_sym_begin] = ACTIONS(3921),
    [anon_sym_LPAREN2] = ACTIONS(3921),
    [anon_sym_DOT_DOT2] = ACTIONS(3919),
    [anon_sym_or] = ACTIONS(3921),
    [aux_sym_char_token1] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_AT_DQUOTE] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [sym_bool] = ACTIONS(3921),
    [sym_unit] = ACTIONS(3919),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3921),
    [sym_op_identifier] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_DOT] = ACTIONS(3921),
    [anon_sym_DASH_DOT] = ACTIONS(3921),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3919),
    [aux_sym_prefix_op_token1] = ACTIONS(3921),
    [aux_sym_infix_op_token1] = ACTIONS(3919),
    [aux_sym_infix_op_token2] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_COLON_EQ] = ACTIONS(3919),
    [anon_sym_DOLLAR] = ACTIONS(3921),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3921),
    [sym_int] = ACTIONS(3921),
    [sym_xint] = ACTIONS(3919),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3919),
    [sym__newline] = ACTIONS(3919),
  },
  [2389] = {
    [sym_block_comment] = STATE(2389),
    [sym_compiler_directive_decl] = STATE(2389),
    [sym_fsi_directive_decl] = STATE(2389),
    [sym_preproc_line] = STATE(2389),
    [aux_sym_sequential_expression_repeat1] = STATE(2427),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_GT_RBRACK] = ACTIONS(3757),
    [anon_sym_COLON] = ACTIONS(3759),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_let_BANG] = ACTIONS(3757),
    [anon_sym_LPAREN] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3757),
    [anon_sym_null] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_RBRACK] = ACTIONS(3757),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3757),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_RBRACE] = ACTIONS(3757),
    [anon_sym_LT_AT] = ACTIONS(3759),
    [anon_sym_LT_AT_AT] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(3759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_with] = ACTIONS(3759),
    [anon_sym_return_BANG] = ACTIONS(3757),
    [anon_sym_yield] = ACTIONS(3759),
    [anon_sym_yield_BANG] = ACTIONS(3757),
    [anon_sym_lazy] = ACTIONS(3759),
    [anon_sym_assert] = ACTIONS(3759),
    [anon_sym_upcast] = ACTIONS(3759),
    [anon_sym_downcast] = ACTIONS(3759),
    [anon_sym_COLON_GT] = ACTIONS(3757),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3757),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_to] = ACTIONS(3759),
    [anon_sym_downto] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_fun] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_match] = ACTIONS(3759),
    [anon_sym_match_BANG] = ACTIONS(3757),
    [anon_sym_function] = ACTIONS(3759),
    [anon_sym_LT_DASH] = ACTIONS(3759),
    [anon_sym_DOT_LBRACK] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_use] = ACTIONS(3759),
    [anon_sym_use_BANG] = ACTIONS(3757),
    [anon_sym_do_BANG] = ACTIONS(3757),
    [anon_sym_begin] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_or] = ACTIONS(3759),
    [aux_sym_char_token1] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3759),
    [anon_sym_DQUOTE] = ACTIONS(3759),
    [anon_sym_AT_DQUOTE] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [sym_bool] = ACTIONS(3759),
    [sym_unit] = ACTIONS(3757),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3759),
    [sym_op_identifier] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS_DOT] = ACTIONS(3759),
    [anon_sym_DASH_DOT] = ACTIONS(3759),
    [anon_sym_PERCENT] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_TILDE] = ACTIONS(3757),
    [aux_sym_prefix_op_token1] = ACTIONS(3759),
    [aux_sym_infix_op_token1] = ACTIONS(3757),
    [aux_sym_infix_op_token2] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_COLON_EQ] = ACTIONS(3757),
    [anon_sym_DOLLAR] = ACTIONS(3759),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3759),
    [sym_int] = ACTIONS(3759),
    [sym_xint] = ACTIONS(3757),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3757),
    [sym__newline] = ACTIONS(3757),
  },
  [2390] = {
    [sym_block_comment] = STATE(2390),
    [sym_compiler_directive_decl] = STATE(2390),
    [sym_fsi_directive_decl] = STATE(2390),
    [sym_preproc_line] = STATE(2390),
    [ts_builtin_sym_end] = ACTIONS(3883),
    [sym_identifier] = ACTIONS(3885),
    [anon_sym_namespace] = ACTIONS(3885),
    [anon_sym_module] = ACTIONS(3885),
    [anon_sym_EQ] = ACTIONS(3883),
    [anon_sym_open] = ACTIONS(3885),
    [anon_sym_LBRACK_LT] = ACTIONS(3883),
    [anon_sym_COLON] = ACTIONS(3885),
    [anon_sym_return] = ACTIONS(3885),
    [anon_sym_type] = ACTIONS(3885),
    [anon_sym_do] = ACTIONS(3885),
    [anon_sym_let] = ACTIONS(3885),
    [anon_sym_let_BANG] = ACTIONS(3883),
    [anon_sym_LPAREN] = ACTIONS(3885),
    [anon_sym_COMMA] = ACTIONS(3883),
    [anon_sym_null] = ACTIONS(3885),
    [anon_sym_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3883),
    [anon_sym_AMP] = ACTIONS(3885),
    [anon_sym_LBRACK] = ACTIONS(3885),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3883),
    [anon_sym_LBRACE] = ACTIONS(3885),
    [anon_sym_LT_AT] = ACTIONS(3885),
    [anon_sym_LT_AT_AT] = ACTIONS(3885),
    [anon_sym_DOT] = ACTIONS(3885),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3883),
    [anon_sym_new] = ACTIONS(3885),
    [anon_sym_return_BANG] = ACTIONS(3883),
    [anon_sym_yield] = ACTIONS(3885),
    [anon_sym_yield_BANG] = ACTIONS(3883),
    [anon_sym_lazy] = ACTIONS(3885),
    [anon_sym_assert] = ACTIONS(3885),
    [anon_sym_upcast] = ACTIONS(3885),
    [anon_sym_downcast] = ACTIONS(3885),
    [anon_sym_COLON_GT] = ACTIONS(3883),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3883),
    [anon_sym_for] = ACTIONS(3885),
    [anon_sym_while] = ACTIONS(3885),
    [anon_sym_if] = ACTIONS(3885),
    [anon_sym_fun] = ACTIONS(3885),
    [anon_sym_try] = ACTIONS(3885),
    [anon_sym_match] = ACTIONS(3885),
    [anon_sym_match_BANG] = ACTIONS(3883),
    [anon_sym_function] = ACTIONS(3885),
    [anon_sym_LT_DASH] = ACTIONS(3885),
    [anon_sym_DOT_LBRACK] = ACTIONS(3883),
    [anon_sym_LT] = ACTIONS(3883),
    [anon_sym_use] = ACTIONS(3885),
    [anon_sym_use_BANG] = ACTIONS(3883),
    [anon_sym_do_BANG] = ACTIONS(3883),
    [anon_sym_begin] = ACTIONS(3885),
    [anon_sym_LPAREN2] = ACTIONS(3885),
    [anon_sym_or] = ACTIONS(3885),
    [anon_sym_exception] = ACTIONS(3885),
    [aux_sym_char_token1] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3885),
    [anon_sym_DQUOTE] = ACTIONS(3885),
    [anon_sym_AT_DQUOTE] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [sym_bool] = ACTIONS(3885),
    [sym_unit] = ACTIONS(3883),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3885),
    [sym_op_identifier] = ACTIONS(3885),
    [anon_sym_PLUS] = ACTIONS(3885),
    [anon_sym_DASH] = ACTIONS(3885),
    [anon_sym_PLUS_DOT] = ACTIONS(3885),
    [anon_sym_DASH_DOT] = ACTIONS(3885),
    [anon_sym_PERCENT] = ACTIONS(3885),
    [anon_sym_AMP_AMP] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3883),
    [aux_sym_prefix_op_token1] = ACTIONS(3885),
    [aux_sym_infix_op_token1] = ACTIONS(3883),
    [aux_sym_infix_op_token2] = ACTIONS(3885),
    [anon_sym_PIPE_PIPE] = ACTIONS(3885),
    [anon_sym_BANG_EQ] = ACTIONS(3885),
    [anon_sym_COLON_EQ] = ACTIONS(3883),
    [anon_sym_DOLLAR] = ACTIONS(3885),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3885),
    [sym_int] = ACTIONS(3885),
    [sym_xint] = ACTIONS(3883),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3883),
    [anon_sym_POUNDload] = ACTIONS(3883),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3883),
    [sym__newline] = ACTIONS(3883),
  },
  [2391] = {
    [sym_block_comment] = STATE(2391),
    [sym_compiler_directive_decl] = STATE(2391),
    [sym_fsi_directive_decl] = STATE(2391),
    [sym_preproc_line] = STATE(2391),
    [ts_builtin_sym_end] = ACTIONS(3933),
    [sym_identifier] = ACTIONS(3935),
    [anon_sym_namespace] = ACTIONS(3935),
    [anon_sym_module] = ACTIONS(3935),
    [anon_sym_EQ] = ACTIONS(3933),
    [anon_sym_open] = ACTIONS(3935),
    [anon_sym_LBRACK_LT] = ACTIONS(3933),
    [anon_sym_COLON] = ACTIONS(3935),
    [anon_sym_return] = ACTIONS(3935),
    [anon_sym_type] = ACTIONS(3935),
    [anon_sym_do] = ACTIONS(3935),
    [anon_sym_let] = ACTIONS(3935),
    [anon_sym_let_BANG] = ACTIONS(3933),
    [anon_sym_LPAREN] = ACTIONS(3935),
    [anon_sym_COMMA] = ACTIONS(3933),
    [anon_sym_null] = ACTIONS(3935),
    [anon_sym_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3935),
    [anon_sym_LBRACK] = ACTIONS(3935),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3933),
    [anon_sym_LBRACE] = ACTIONS(3935),
    [anon_sym_LT_AT] = ACTIONS(3935),
    [anon_sym_LT_AT_AT] = ACTIONS(3935),
    [anon_sym_DOT] = ACTIONS(3935),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3933),
    [anon_sym_new] = ACTIONS(3935),
    [anon_sym_return_BANG] = ACTIONS(3933),
    [anon_sym_yield] = ACTIONS(3935),
    [anon_sym_yield_BANG] = ACTIONS(3933),
    [anon_sym_lazy] = ACTIONS(3935),
    [anon_sym_assert] = ACTIONS(3935),
    [anon_sym_upcast] = ACTIONS(3935),
    [anon_sym_downcast] = ACTIONS(3935),
    [anon_sym_COLON_GT] = ACTIONS(3933),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3933),
    [anon_sym_for] = ACTIONS(3935),
    [anon_sym_while] = ACTIONS(3935),
    [anon_sym_if] = ACTIONS(3935),
    [anon_sym_fun] = ACTIONS(3935),
    [anon_sym_try] = ACTIONS(3935),
    [anon_sym_match] = ACTIONS(3935),
    [anon_sym_match_BANG] = ACTIONS(3933),
    [anon_sym_function] = ACTIONS(3935),
    [anon_sym_LT_DASH] = ACTIONS(3935),
    [anon_sym_DOT_LBRACK] = ACTIONS(3933),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_use] = ACTIONS(3935),
    [anon_sym_use_BANG] = ACTIONS(3933),
    [anon_sym_do_BANG] = ACTIONS(3933),
    [anon_sym_begin] = ACTIONS(3935),
    [anon_sym_LPAREN2] = ACTIONS(3935),
    [anon_sym_or] = ACTIONS(3935),
    [anon_sym_exception] = ACTIONS(3935),
    [aux_sym_char_token1] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3935),
    [anon_sym_DQUOTE] = ACTIONS(3935),
    [anon_sym_AT_DQUOTE] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [sym_bool] = ACTIONS(3935),
    [sym_unit] = ACTIONS(3933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3935),
    [sym_op_identifier] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(3935),
    [anon_sym_DASH] = ACTIONS(3935),
    [anon_sym_PLUS_DOT] = ACTIONS(3935),
    [anon_sym_DASH_DOT] = ACTIONS(3935),
    [anon_sym_PERCENT] = ACTIONS(3935),
    [anon_sym_AMP_AMP] = ACTIONS(3935),
    [anon_sym_TILDE] = ACTIONS(3933),
    [aux_sym_prefix_op_token1] = ACTIONS(3935),
    [aux_sym_infix_op_token1] = ACTIONS(3933),
    [aux_sym_infix_op_token2] = ACTIONS(3935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3935),
    [anon_sym_BANG_EQ] = ACTIONS(3935),
    [anon_sym_COLON_EQ] = ACTIONS(3933),
    [anon_sym_DOLLAR] = ACTIONS(3935),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3935),
    [sym_int] = ACTIONS(3935),
    [sym_xint] = ACTIONS(3933),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3933),
    [anon_sym_POUNDload] = ACTIONS(3933),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3933),
    [sym__newline] = ACTIONS(3933),
  },
  [2392] = {
    [sym_block_comment] = STATE(2392),
    [sym_compiler_directive_decl] = STATE(2392),
    [sym_fsi_directive_decl] = STATE(2392),
    [sym_preproc_line] = STATE(2392),
    [ts_builtin_sym_end] = ACTIONS(3974),
    [sym_identifier] = ACTIONS(3976),
    [anon_sym_namespace] = ACTIONS(3976),
    [anon_sym_module] = ACTIONS(3976),
    [anon_sym_EQ] = ACTIONS(3974),
    [anon_sym_open] = ACTIONS(3976),
    [anon_sym_LBRACK_LT] = ACTIONS(3974),
    [anon_sym_COLON] = ACTIONS(3976),
    [anon_sym_return] = ACTIONS(3976),
    [anon_sym_type] = ACTIONS(3976),
    [anon_sym_do] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_let_BANG] = ACTIONS(3974),
    [anon_sym_LPAREN] = ACTIONS(3976),
    [anon_sym_COMMA] = ACTIONS(3974),
    [anon_sym_null] = ACTIONS(3976),
    [anon_sym_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_COLON] = ACTIONS(3974),
    [anon_sym_AMP] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(3976),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3974),
    [anon_sym_LBRACE] = ACTIONS(3976),
    [anon_sym_LT_AT] = ACTIONS(3976),
    [anon_sym_LT_AT_AT] = ACTIONS(3976),
    [anon_sym_DOT] = ACTIONS(3976),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3974),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_return_BANG] = ACTIONS(3974),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_yield_BANG] = ACTIONS(3974),
    [anon_sym_lazy] = ACTIONS(3976),
    [anon_sym_assert] = ACTIONS(3976),
    [anon_sym_upcast] = ACTIONS(3976),
    [anon_sym_downcast] = ACTIONS(3976),
    [anon_sym_COLON_GT] = ACTIONS(3974),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3974),
    [anon_sym_for] = ACTIONS(3976),
    [anon_sym_while] = ACTIONS(3976),
    [anon_sym_if] = ACTIONS(3976),
    [anon_sym_fun] = ACTIONS(3976),
    [anon_sym_try] = ACTIONS(3976),
    [anon_sym_match] = ACTIONS(3976),
    [anon_sym_match_BANG] = ACTIONS(3974),
    [anon_sym_function] = ACTIONS(3976),
    [anon_sym_LT_DASH] = ACTIONS(3976),
    [anon_sym_DOT_LBRACK] = ACTIONS(3974),
    [anon_sym_LT] = ACTIONS(3974),
    [anon_sym_use] = ACTIONS(3976),
    [anon_sym_use_BANG] = ACTIONS(3974),
    [anon_sym_do_BANG] = ACTIONS(3974),
    [anon_sym_begin] = ACTIONS(3976),
    [anon_sym_LPAREN2] = ACTIONS(3976),
    [anon_sym_or] = ACTIONS(3976),
    [anon_sym_exception] = ACTIONS(3976),
    [aux_sym_char_token1] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3976),
    [anon_sym_DQUOTE] = ACTIONS(3976),
    [anon_sym_AT_DQUOTE] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [sym_bool] = ACTIONS(3976),
    [sym_unit] = ACTIONS(3974),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3976),
    [sym_op_identifier] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3976),
    [anon_sym_DASH] = ACTIONS(3976),
    [anon_sym_PLUS_DOT] = ACTIONS(3976),
    [anon_sym_DASH_DOT] = ACTIONS(3976),
    [anon_sym_PERCENT] = ACTIONS(3976),
    [anon_sym_AMP_AMP] = ACTIONS(3976),
    [anon_sym_TILDE] = ACTIONS(3974),
    [aux_sym_prefix_op_token1] = ACTIONS(3976),
    [aux_sym_infix_op_token1] = ACTIONS(3974),
    [aux_sym_infix_op_token2] = ACTIONS(3976),
    [anon_sym_PIPE_PIPE] = ACTIONS(3976),
    [anon_sym_BANG_EQ] = ACTIONS(3976),
    [anon_sym_COLON_EQ] = ACTIONS(3974),
    [anon_sym_DOLLAR] = ACTIONS(3976),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3976),
    [sym_int] = ACTIONS(3976),
    [sym_xint] = ACTIONS(3974),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3974),
    [anon_sym_POUNDload] = ACTIONS(3974),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3974),
    [sym__newline] = ACTIONS(3974),
  },
  [2393] = {
    [sym_block_comment] = STATE(2393),
    [sym_compiler_directive_decl] = STATE(2393),
    [sym_fsi_directive_decl] = STATE(2393),
    [sym_preproc_line] = STATE(2393),
    [ts_builtin_sym_end] = ACTIONS(3879),
    [sym_identifier] = ACTIONS(3881),
    [anon_sym_namespace] = ACTIONS(3881),
    [anon_sym_module] = ACTIONS(3881),
    [anon_sym_EQ] = ACTIONS(3879),
    [anon_sym_open] = ACTIONS(3881),
    [anon_sym_LBRACK_LT] = ACTIONS(3879),
    [anon_sym_COLON] = ACTIONS(3881),
    [anon_sym_return] = ACTIONS(3881),
    [anon_sym_type] = ACTIONS(3881),
    [anon_sym_do] = ACTIONS(3881),
    [anon_sym_let] = ACTIONS(3881),
    [anon_sym_let_BANG] = ACTIONS(3879),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3879),
    [anon_sym_null] = ACTIONS(3881),
    [anon_sym_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3879),
    [anon_sym_LBRACE] = ACTIONS(3881),
    [anon_sym_LT_AT] = ACTIONS(3881),
    [anon_sym_LT_AT_AT] = ACTIONS(3881),
    [anon_sym_DOT] = ACTIONS(3881),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3879),
    [anon_sym_new] = ACTIONS(3881),
    [anon_sym_return_BANG] = ACTIONS(3879),
    [anon_sym_yield] = ACTIONS(3881),
    [anon_sym_yield_BANG] = ACTIONS(3879),
    [anon_sym_lazy] = ACTIONS(3881),
    [anon_sym_assert] = ACTIONS(3881),
    [anon_sym_upcast] = ACTIONS(3881),
    [anon_sym_downcast] = ACTIONS(3881),
    [anon_sym_COLON_GT] = ACTIONS(3879),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3879),
    [anon_sym_for] = ACTIONS(3881),
    [anon_sym_while] = ACTIONS(3881),
    [anon_sym_if] = ACTIONS(3881),
    [anon_sym_fun] = ACTIONS(3881),
    [anon_sym_try] = ACTIONS(3881),
    [anon_sym_match] = ACTIONS(3881),
    [anon_sym_match_BANG] = ACTIONS(3879),
    [anon_sym_function] = ACTIONS(3881),
    [anon_sym_LT_DASH] = ACTIONS(3881),
    [anon_sym_DOT_LBRACK] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_use] = ACTIONS(3881),
    [anon_sym_use_BANG] = ACTIONS(3879),
    [anon_sym_do_BANG] = ACTIONS(3879),
    [anon_sym_begin] = ACTIONS(3881),
    [anon_sym_LPAREN2] = ACTIONS(3881),
    [anon_sym_or] = ACTIONS(3881),
    [anon_sym_exception] = ACTIONS(3881),
    [aux_sym_char_token1] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3881),
    [anon_sym_DQUOTE] = ACTIONS(3881),
    [anon_sym_AT_DQUOTE] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [sym_bool] = ACTIONS(3881),
    [sym_unit] = ACTIONS(3879),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3881),
    [sym_op_identifier] = ACTIONS(3881),
    [anon_sym_PLUS] = ACTIONS(3881),
    [anon_sym_DASH] = ACTIONS(3881),
    [anon_sym_PLUS_DOT] = ACTIONS(3881),
    [anon_sym_DASH_DOT] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(3881),
    [anon_sym_AMP_AMP] = ACTIONS(3881),
    [anon_sym_TILDE] = ACTIONS(3879),
    [aux_sym_prefix_op_token1] = ACTIONS(3881),
    [aux_sym_infix_op_token1] = ACTIONS(3879),
    [aux_sym_infix_op_token2] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE] = ACTIONS(3881),
    [anon_sym_BANG_EQ] = ACTIONS(3881),
    [anon_sym_COLON_EQ] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3881),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3881),
    [sym_int] = ACTIONS(3881),
    [sym_xint] = ACTIONS(3879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3879),
    [anon_sym_POUNDload] = ACTIONS(3879),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3879),
    [sym__newline] = ACTIONS(3879),
  },
  [2394] = {
    [sym_block_comment] = STATE(2394),
    [sym_compiler_directive_decl] = STATE(2394),
    [sym_fsi_directive_decl] = STATE(2394),
    [sym_preproc_line] = STATE(2394),
    [sym_identifier] = ACTIONS(4007),
    [anon_sym_EQ] = ACTIONS(4005),
    [anon_sym_GT_RBRACK] = ACTIONS(4005),
    [anon_sym_COLON] = ACTIONS(4007),
    [anon_sym_return] = ACTIONS(4007),
    [anon_sym_do] = ACTIONS(4007),
    [anon_sym_let] = ACTIONS(4007),
    [anon_sym_let_BANG] = ACTIONS(4005),
    [anon_sym_LPAREN] = ACTIONS(4007),
    [anon_sym_COMMA] = ACTIONS(4005),
    [anon_sym_null] = ACTIONS(4007),
    [anon_sym_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_COLON] = ACTIONS(4005),
    [anon_sym_AMP] = ACTIONS(4007),
    [anon_sym_LBRACK] = ACTIONS(4007),
    [anon_sym_RBRACK] = ACTIONS(4005),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4005),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_RBRACE] = ACTIONS(4005),
    [anon_sym_LT_AT] = ACTIONS(4007),
    [anon_sym_LT_AT_AT] = ACTIONS(4007),
    [anon_sym_DOT] = ACTIONS(4007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4005),
    [anon_sym_new] = ACTIONS(4007),
    [anon_sym_with] = ACTIONS(4007),
    [anon_sym_return_BANG] = ACTIONS(4005),
    [anon_sym_yield] = ACTIONS(4007),
    [anon_sym_yield_BANG] = ACTIONS(4005),
    [anon_sym_lazy] = ACTIONS(4007),
    [anon_sym_assert] = ACTIONS(4007),
    [anon_sym_upcast] = ACTIONS(4007),
    [anon_sym_downcast] = ACTIONS(4007),
    [anon_sym_COLON_GT] = ACTIONS(4005),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4005),
    [anon_sym_for] = ACTIONS(4007),
    [anon_sym_to] = ACTIONS(4007),
    [anon_sym_downto] = ACTIONS(4007),
    [anon_sym_while] = ACTIONS(4007),
    [anon_sym_if] = ACTIONS(4007),
    [anon_sym_fun] = ACTIONS(4007),
    [anon_sym_try] = ACTIONS(4007),
    [anon_sym_match] = ACTIONS(4007),
    [anon_sym_match_BANG] = ACTIONS(4005),
    [anon_sym_function] = ACTIONS(4007),
    [anon_sym_LT_DASH] = ACTIONS(4007),
    [anon_sym_DOT_LBRACK] = ACTIONS(4005),
    [anon_sym_LT] = ACTIONS(4005),
    [anon_sym_use] = ACTIONS(4007),
    [anon_sym_use_BANG] = ACTIONS(4005),
    [anon_sym_do_BANG] = ACTIONS(4005),
    [anon_sym_begin] = ACTIONS(4007),
    [anon_sym_LPAREN2] = ACTIONS(4007),
    [anon_sym_DOT_DOT2] = ACTIONS(4005),
    [anon_sym_or] = ACTIONS(4007),
    [aux_sym_char_token1] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4007),
    [anon_sym_DQUOTE] = ACTIONS(4007),
    [anon_sym_AT_DQUOTE] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [sym_bool] = ACTIONS(4007),
    [sym_unit] = ACTIONS(4005),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4007),
    [sym_op_identifier] = ACTIONS(4007),
    [anon_sym_PLUS] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4007),
    [anon_sym_PLUS_DOT] = ACTIONS(4007),
    [anon_sym_DASH_DOT] = ACTIONS(4007),
    [anon_sym_PERCENT] = ACTIONS(4007),
    [anon_sym_AMP_AMP] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4005),
    [aux_sym_prefix_op_token1] = ACTIONS(4007),
    [aux_sym_infix_op_token1] = ACTIONS(4005),
    [aux_sym_infix_op_token2] = ACTIONS(4007),
    [anon_sym_PIPE_PIPE] = ACTIONS(4007),
    [anon_sym_BANG_EQ] = ACTIONS(4007),
    [anon_sym_COLON_EQ] = ACTIONS(4005),
    [anon_sym_DOLLAR] = ACTIONS(4007),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4007),
    [sym_int] = ACTIONS(4007),
    [sym_xint] = ACTIONS(4005),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4005),
    [sym__newline] = ACTIONS(4005),
  },
  [2395] = {
    [sym_block_comment] = STATE(2395),
    [sym_compiler_directive_decl] = STATE(2395),
    [sym_fsi_directive_decl] = STATE(2395),
    [sym_preproc_line] = STATE(2395),
    [sym_identifier] = ACTIONS(4130),
    [anon_sym_EQ] = ACTIONS(4128),
    [anon_sym_GT_RBRACK] = ACTIONS(4128),
    [anon_sym_COLON] = ACTIONS(4130),
    [anon_sym_return] = ACTIONS(4130),
    [anon_sym_do] = ACTIONS(4130),
    [anon_sym_let] = ACTIONS(4130),
    [anon_sym_let_BANG] = ACTIONS(4128),
    [anon_sym_LPAREN] = ACTIONS(4130),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_null] = ACTIONS(4130),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_COLON] = ACTIONS(4128),
    [anon_sym_AMP] = ACTIONS(4130),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_RBRACK] = ACTIONS(4128),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4128),
    [anon_sym_LBRACE] = ACTIONS(4130),
    [anon_sym_RBRACE] = ACTIONS(4128),
    [anon_sym_LT_AT] = ACTIONS(4130),
    [anon_sym_LT_AT_AT] = ACTIONS(4130),
    [anon_sym_DOT] = ACTIONS(4130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4128),
    [anon_sym_new] = ACTIONS(4130),
    [anon_sym_with] = ACTIONS(4130),
    [anon_sym_return_BANG] = ACTIONS(4128),
    [anon_sym_yield] = ACTIONS(4130),
    [anon_sym_yield_BANG] = ACTIONS(4128),
    [anon_sym_lazy] = ACTIONS(4130),
    [anon_sym_assert] = ACTIONS(4130),
    [anon_sym_upcast] = ACTIONS(4130),
    [anon_sym_downcast] = ACTIONS(4130),
    [anon_sym_COLON_GT] = ACTIONS(4128),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4128),
    [anon_sym_for] = ACTIONS(4130),
    [anon_sym_to] = ACTIONS(4130),
    [anon_sym_downto] = ACTIONS(4130),
    [anon_sym_while] = ACTIONS(4130),
    [anon_sym_if] = ACTIONS(4130),
    [anon_sym_fun] = ACTIONS(4130),
    [anon_sym_try] = ACTIONS(4130),
    [anon_sym_match] = ACTIONS(4130),
    [anon_sym_match_BANG] = ACTIONS(4128),
    [anon_sym_function] = ACTIONS(4130),
    [anon_sym_LT_DASH] = ACTIONS(4130),
    [anon_sym_DOT_LBRACK] = ACTIONS(4128),
    [anon_sym_LT] = ACTIONS(4128),
    [anon_sym_use] = ACTIONS(4130),
    [anon_sym_use_BANG] = ACTIONS(4128),
    [anon_sym_do_BANG] = ACTIONS(4128),
    [anon_sym_begin] = ACTIONS(4130),
    [anon_sym_LPAREN2] = ACTIONS(4130),
    [anon_sym_DOT_DOT2] = ACTIONS(4128),
    [anon_sym_or] = ACTIONS(4130),
    [aux_sym_char_token1] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4130),
    [anon_sym_DQUOTE] = ACTIONS(4130),
    [anon_sym_AT_DQUOTE] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [sym_bool] = ACTIONS(4130),
    [sym_unit] = ACTIONS(4128),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4130),
    [sym_op_identifier] = ACTIONS(4130),
    [anon_sym_PLUS] = ACTIONS(4130),
    [anon_sym_DASH] = ACTIONS(4130),
    [anon_sym_PLUS_DOT] = ACTIONS(4130),
    [anon_sym_DASH_DOT] = ACTIONS(4130),
    [anon_sym_PERCENT] = ACTIONS(4130),
    [anon_sym_AMP_AMP] = ACTIONS(4130),
    [anon_sym_TILDE] = ACTIONS(4128),
    [aux_sym_prefix_op_token1] = ACTIONS(4130),
    [aux_sym_infix_op_token1] = ACTIONS(4128),
    [aux_sym_infix_op_token2] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE] = ACTIONS(4130),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_COLON_EQ] = ACTIONS(4128),
    [anon_sym_DOLLAR] = ACTIONS(4130),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4130),
    [sym_int] = ACTIONS(4130),
    [sym_xint] = ACTIONS(4128),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4128),
    [sym__newline] = ACTIONS(4128),
  },
  [2396] = {
    [sym_block_comment] = STATE(2396),
    [sym_compiler_directive_decl] = STATE(2396),
    [sym_fsi_directive_decl] = STATE(2396),
    [sym_preproc_line] = STATE(2396),
    [sym_identifier] = ACTIONS(3885),
    [anon_sym_EQ] = ACTIONS(3883),
    [anon_sym_GT_RBRACK] = ACTIONS(3883),
    [anon_sym_COLON] = ACTIONS(3885),
    [anon_sym_return] = ACTIONS(3885),
    [anon_sym_do] = ACTIONS(3885),
    [anon_sym_let] = ACTIONS(3885),
    [anon_sym_let_BANG] = ACTIONS(3883),
    [anon_sym_LPAREN] = ACTIONS(3885),
    [anon_sym_COMMA] = ACTIONS(3883),
    [anon_sym_null] = ACTIONS(3885),
    [anon_sym_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3883),
    [anon_sym_AMP] = ACTIONS(3885),
    [anon_sym_LBRACK] = ACTIONS(3885),
    [anon_sym_RBRACK] = ACTIONS(3883),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3883),
    [anon_sym_LBRACE] = ACTIONS(3885),
    [anon_sym_RBRACE] = ACTIONS(3883),
    [anon_sym_LT_AT] = ACTIONS(3885),
    [anon_sym_LT_AT_AT] = ACTIONS(3885),
    [anon_sym_DOT] = ACTIONS(3885),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3883),
    [anon_sym_new] = ACTIONS(3885),
    [anon_sym_with] = ACTIONS(3885),
    [anon_sym_return_BANG] = ACTIONS(3883),
    [anon_sym_yield] = ACTIONS(3885),
    [anon_sym_yield_BANG] = ACTIONS(3883),
    [anon_sym_lazy] = ACTIONS(3885),
    [anon_sym_assert] = ACTIONS(3885),
    [anon_sym_upcast] = ACTIONS(3885),
    [anon_sym_downcast] = ACTIONS(3885),
    [anon_sym_COLON_GT] = ACTIONS(3883),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3883),
    [anon_sym_for] = ACTIONS(3885),
    [anon_sym_to] = ACTIONS(3885),
    [anon_sym_downto] = ACTIONS(3885),
    [anon_sym_while] = ACTIONS(3885),
    [anon_sym_if] = ACTIONS(3885),
    [anon_sym_fun] = ACTIONS(3885),
    [anon_sym_try] = ACTIONS(3885),
    [anon_sym_match] = ACTIONS(3885),
    [anon_sym_match_BANG] = ACTIONS(3883),
    [anon_sym_function] = ACTIONS(3885),
    [anon_sym_LT_DASH] = ACTIONS(3885),
    [anon_sym_DOT_LBRACK] = ACTIONS(3883),
    [anon_sym_LT] = ACTIONS(3883),
    [anon_sym_use] = ACTIONS(3885),
    [anon_sym_use_BANG] = ACTIONS(3883),
    [anon_sym_do_BANG] = ACTIONS(3883),
    [anon_sym_begin] = ACTIONS(3885),
    [anon_sym_LPAREN2] = ACTIONS(3885),
    [anon_sym_DOT_DOT2] = ACTIONS(3883),
    [anon_sym_or] = ACTIONS(3885),
    [aux_sym_char_token1] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3885),
    [anon_sym_DQUOTE] = ACTIONS(3885),
    [anon_sym_AT_DQUOTE] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [sym_bool] = ACTIONS(3885),
    [sym_unit] = ACTIONS(3883),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3885),
    [sym_op_identifier] = ACTIONS(3885),
    [anon_sym_PLUS] = ACTIONS(3885),
    [anon_sym_DASH] = ACTIONS(3885),
    [anon_sym_PLUS_DOT] = ACTIONS(3885),
    [anon_sym_DASH_DOT] = ACTIONS(3885),
    [anon_sym_PERCENT] = ACTIONS(3885),
    [anon_sym_AMP_AMP] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3883),
    [aux_sym_prefix_op_token1] = ACTIONS(3885),
    [aux_sym_infix_op_token1] = ACTIONS(3883),
    [aux_sym_infix_op_token2] = ACTIONS(3885),
    [anon_sym_PIPE_PIPE] = ACTIONS(3885),
    [anon_sym_BANG_EQ] = ACTIONS(3885),
    [anon_sym_COLON_EQ] = ACTIONS(3883),
    [anon_sym_DOLLAR] = ACTIONS(3885),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3885),
    [sym_int] = ACTIONS(3885),
    [sym_xint] = ACTIONS(3883),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3883),
    [sym__newline] = ACTIONS(3883),
  },
  [2397] = {
    [sym_block_comment] = STATE(2397),
    [sym_compiler_directive_decl] = STATE(2397),
    [sym_fsi_directive_decl] = STATE(2397),
    [sym_preproc_line] = STATE(2397),
    [ts_builtin_sym_end] = ACTIONS(4102),
    [sym_identifier] = ACTIONS(4104),
    [anon_sym_namespace] = ACTIONS(4104),
    [anon_sym_module] = ACTIONS(4104),
    [anon_sym_EQ] = ACTIONS(4102),
    [anon_sym_open] = ACTIONS(4104),
    [anon_sym_LBRACK_LT] = ACTIONS(4102),
    [anon_sym_COLON] = ACTIONS(4104),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_type] = ACTIONS(4104),
    [anon_sym_do] = ACTIONS(4104),
    [anon_sym_let] = ACTIONS(4104),
    [anon_sym_let_BANG] = ACTIONS(4102),
    [anon_sym_LPAREN] = ACTIONS(4104),
    [anon_sym_COMMA] = ACTIONS(4102),
    [anon_sym_null] = ACTIONS(4104),
    [anon_sym_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_COLON] = ACTIONS(4102),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4104),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4102),
    [anon_sym_LBRACE] = ACTIONS(4104),
    [anon_sym_LT_AT] = ACTIONS(4104),
    [anon_sym_LT_AT_AT] = ACTIONS(4104),
    [anon_sym_DOT] = ACTIONS(4104),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4102),
    [anon_sym_new] = ACTIONS(4104),
    [anon_sym_return_BANG] = ACTIONS(4102),
    [anon_sym_yield] = ACTIONS(4104),
    [anon_sym_yield_BANG] = ACTIONS(4102),
    [anon_sym_lazy] = ACTIONS(4104),
    [anon_sym_assert] = ACTIONS(4104),
    [anon_sym_upcast] = ACTIONS(4104),
    [anon_sym_downcast] = ACTIONS(4104),
    [anon_sym_COLON_GT] = ACTIONS(4102),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4102),
    [anon_sym_for] = ACTIONS(4104),
    [anon_sym_while] = ACTIONS(4104),
    [anon_sym_if] = ACTIONS(4104),
    [anon_sym_fun] = ACTIONS(4104),
    [anon_sym_try] = ACTIONS(4104),
    [anon_sym_match] = ACTIONS(4104),
    [anon_sym_match_BANG] = ACTIONS(4102),
    [anon_sym_function] = ACTIONS(4104),
    [anon_sym_LT_DASH] = ACTIONS(4104),
    [anon_sym_DOT_LBRACK] = ACTIONS(4102),
    [anon_sym_LT] = ACTIONS(4102),
    [anon_sym_use] = ACTIONS(4104),
    [anon_sym_use_BANG] = ACTIONS(4102),
    [anon_sym_do_BANG] = ACTIONS(4102),
    [anon_sym_begin] = ACTIONS(4104),
    [anon_sym_LPAREN2] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [anon_sym_exception] = ACTIONS(4104),
    [aux_sym_char_token1] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4104),
    [anon_sym_DQUOTE] = ACTIONS(4104),
    [anon_sym_AT_DQUOTE] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [sym_bool] = ACTIONS(4104),
    [sym_unit] = ACTIONS(4102),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4104),
    [sym_op_identifier] = ACTIONS(4104),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_PLUS_DOT] = ACTIONS(4104),
    [anon_sym_DASH_DOT] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_AMP_AMP] = ACTIONS(4104),
    [anon_sym_TILDE] = ACTIONS(4102),
    [aux_sym_prefix_op_token1] = ACTIONS(4104),
    [aux_sym_infix_op_token1] = ACTIONS(4102),
    [aux_sym_infix_op_token2] = ACTIONS(4104),
    [anon_sym_PIPE_PIPE] = ACTIONS(4104),
    [anon_sym_BANG_EQ] = ACTIONS(4104),
    [anon_sym_COLON_EQ] = ACTIONS(4102),
    [anon_sym_DOLLAR] = ACTIONS(4104),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4104),
    [sym_int] = ACTIONS(4104),
    [sym_xint] = ACTIONS(4102),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4102),
    [anon_sym_POUNDload] = ACTIONS(4102),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4102),
    [sym__newline] = ACTIONS(4102),
  },
  [2398] = {
    [sym_block_comment] = STATE(2398),
    [sym_compiler_directive_decl] = STATE(2398),
    [sym_fsi_directive_decl] = STATE(2398),
    [sym_preproc_line] = STATE(2398),
    [sym_identifier] = ACTIONS(3935),
    [anon_sym_EQ] = ACTIONS(3933),
    [anon_sym_GT_RBRACK] = ACTIONS(3933),
    [anon_sym_COLON] = ACTIONS(3935),
    [anon_sym_return] = ACTIONS(3935),
    [anon_sym_do] = ACTIONS(3935),
    [anon_sym_let] = ACTIONS(3935),
    [anon_sym_let_BANG] = ACTIONS(3933),
    [anon_sym_LPAREN] = ACTIONS(3935),
    [anon_sym_COMMA] = ACTIONS(3933),
    [anon_sym_null] = ACTIONS(3935),
    [anon_sym_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3935),
    [anon_sym_LBRACK] = ACTIONS(3935),
    [anon_sym_RBRACK] = ACTIONS(3933),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3933),
    [anon_sym_LBRACE] = ACTIONS(3935),
    [anon_sym_RBRACE] = ACTIONS(3933),
    [anon_sym_LT_AT] = ACTIONS(3935),
    [anon_sym_LT_AT_AT] = ACTIONS(3935),
    [anon_sym_DOT] = ACTIONS(3935),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3933),
    [anon_sym_new] = ACTIONS(3935),
    [anon_sym_with] = ACTIONS(3935),
    [anon_sym_return_BANG] = ACTIONS(3933),
    [anon_sym_yield] = ACTIONS(3935),
    [anon_sym_yield_BANG] = ACTIONS(3933),
    [anon_sym_lazy] = ACTIONS(3935),
    [anon_sym_assert] = ACTIONS(3935),
    [anon_sym_upcast] = ACTIONS(3935),
    [anon_sym_downcast] = ACTIONS(3935),
    [anon_sym_COLON_GT] = ACTIONS(3933),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3933),
    [anon_sym_for] = ACTIONS(3935),
    [anon_sym_to] = ACTIONS(3935),
    [anon_sym_downto] = ACTIONS(3935),
    [anon_sym_while] = ACTIONS(3935),
    [anon_sym_if] = ACTIONS(3935),
    [anon_sym_fun] = ACTIONS(3935),
    [anon_sym_try] = ACTIONS(3935),
    [anon_sym_match] = ACTIONS(3935),
    [anon_sym_match_BANG] = ACTIONS(3933),
    [anon_sym_function] = ACTIONS(3935),
    [anon_sym_LT_DASH] = ACTIONS(3935),
    [anon_sym_DOT_LBRACK] = ACTIONS(3933),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_use] = ACTIONS(3935),
    [anon_sym_use_BANG] = ACTIONS(3933),
    [anon_sym_do_BANG] = ACTIONS(3933),
    [anon_sym_begin] = ACTIONS(3935),
    [anon_sym_LPAREN2] = ACTIONS(3935),
    [anon_sym_DOT_DOT2] = ACTIONS(3933),
    [anon_sym_or] = ACTIONS(3935),
    [aux_sym_char_token1] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3935),
    [anon_sym_DQUOTE] = ACTIONS(3935),
    [anon_sym_AT_DQUOTE] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [sym_bool] = ACTIONS(3935),
    [sym_unit] = ACTIONS(3933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3935),
    [sym_op_identifier] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(3935),
    [anon_sym_DASH] = ACTIONS(3935),
    [anon_sym_PLUS_DOT] = ACTIONS(3935),
    [anon_sym_DASH_DOT] = ACTIONS(3935),
    [anon_sym_PERCENT] = ACTIONS(3935),
    [anon_sym_AMP_AMP] = ACTIONS(3935),
    [anon_sym_TILDE] = ACTIONS(3933),
    [aux_sym_prefix_op_token1] = ACTIONS(3935),
    [aux_sym_infix_op_token1] = ACTIONS(3933),
    [aux_sym_infix_op_token2] = ACTIONS(3935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3935),
    [anon_sym_BANG_EQ] = ACTIONS(3935),
    [anon_sym_COLON_EQ] = ACTIONS(3933),
    [anon_sym_DOLLAR] = ACTIONS(3935),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3935),
    [sym_int] = ACTIONS(3935),
    [sym_xint] = ACTIONS(3933),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3933),
    [sym__newline] = ACTIONS(3933),
  },
  [2399] = {
    [sym_block_comment] = STATE(2399),
    [sym_compiler_directive_decl] = STATE(2399),
    [sym_fsi_directive_decl] = STATE(2399),
    [sym_preproc_line] = STATE(2399),
    [sym_identifier] = ACTIONS(3976),
    [anon_sym_EQ] = ACTIONS(3974),
    [anon_sym_GT_RBRACK] = ACTIONS(3974),
    [anon_sym_COLON] = ACTIONS(3976),
    [anon_sym_return] = ACTIONS(3976),
    [anon_sym_do] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_let_BANG] = ACTIONS(3974),
    [anon_sym_LPAREN] = ACTIONS(3976),
    [anon_sym_COMMA] = ACTIONS(3974),
    [anon_sym_null] = ACTIONS(3976),
    [anon_sym_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_COLON] = ACTIONS(3974),
    [anon_sym_AMP] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(3976),
    [anon_sym_RBRACK] = ACTIONS(3974),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3974),
    [anon_sym_LBRACE] = ACTIONS(3976),
    [anon_sym_RBRACE] = ACTIONS(3974),
    [anon_sym_LT_AT] = ACTIONS(3976),
    [anon_sym_LT_AT_AT] = ACTIONS(3976),
    [anon_sym_DOT] = ACTIONS(3976),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3974),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_with] = ACTIONS(3976),
    [anon_sym_return_BANG] = ACTIONS(3974),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_yield_BANG] = ACTIONS(3974),
    [anon_sym_lazy] = ACTIONS(3976),
    [anon_sym_assert] = ACTIONS(3976),
    [anon_sym_upcast] = ACTIONS(3976),
    [anon_sym_downcast] = ACTIONS(3976),
    [anon_sym_COLON_GT] = ACTIONS(3974),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3974),
    [anon_sym_for] = ACTIONS(3976),
    [anon_sym_to] = ACTIONS(3976),
    [anon_sym_downto] = ACTIONS(3976),
    [anon_sym_while] = ACTIONS(3976),
    [anon_sym_if] = ACTIONS(3976),
    [anon_sym_fun] = ACTIONS(3976),
    [anon_sym_try] = ACTIONS(3976),
    [anon_sym_match] = ACTIONS(3976),
    [anon_sym_match_BANG] = ACTIONS(3974),
    [anon_sym_function] = ACTIONS(3976),
    [anon_sym_LT_DASH] = ACTIONS(3976),
    [anon_sym_DOT_LBRACK] = ACTIONS(3974),
    [anon_sym_LT] = ACTIONS(3974),
    [anon_sym_use] = ACTIONS(3976),
    [anon_sym_use_BANG] = ACTIONS(3974),
    [anon_sym_do_BANG] = ACTIONS(3974),
    [anon_sym_begin] = ACTIONS(3976),
    [anon_sym_LPAREN2] = ACTIONS(3976),
    [anon_sym_DOT_DOT2] = ACTIONS(3974),
    [anon_sym_or] = ACTIONS(3976),
    [aux_sym_char_token1] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3976),
    [anon_sym_DQUOTE] = ACTIONS(3976),
    [anon_sym_AT_DQUOTE] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [sym_bool] = ACTIONS(3976),
    [sym_unit] = ACTIONS(3974),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3976),
    [sym_op_identifier] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3976),
    [anon_sym_DASH] = ACTIONS(3976),
    [anon_sym_PLUS_DOT] = ACTIONS(3976),
    [anon_sym_DASH_DOT] = ACTIONS(3976),
    [anon_sym_PERCENT] = ACTIONS(3976),
    [anon_sym_AMP_AMP] = ACTIONS(3976),
    [anon_sym_TILDE] = ACTIONS(3974),
    [aux_sym_prefix_op_token1] = ACTIONS(3976),
    [aux_sym_infix_op_token1] = ACTIONS(3974),
    [aux_sym_infix_op_token2] = ACTIONS(3976),
    [anon_sym_PIPE_PIPE] = ACTIONS(3976),
    [anon_sym_BANG_EQ] = ACTIONS(3976),
    [anon_sym_COLON_EQ] = ACTIONS(3974),
    [anon_sym_DOLLAR] = ACTIONS(3976),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3976),
    [sym_int] = ACTIONS(3976),
    [sym_xint] = ACTIONS(3974),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3974),
    [sym__newline] = ACTIONS(3974),
  },
  [2400] = {
    [sym_block_comment] = STATE(2400),
    [sym_compiler_directive_decl] = STATE(2400),
    [sym_fsi_directive_decl] = STATE(2400),
    [sym_preproc_line] = STATE(2400),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_EQ] = ACTIONS(3948),
    [anon_sym_GT_RBRACK] = ACTIONS(3948),
    [anon_sym_COLON] = ACTIONS(3950),
    [anon_sym_return] = ACTIONS(3950),
    [anon_sym_do] = ACTIONS(3950),
    [anon_sym_let] = ACTIONS(3950),
    [anon_sym_let_BANG] = ACTIONS(3948),
    [anon_sym_LPAREN] = ACTIONS(3950),
    [anon_sym_COMMA] = ACTIONS(3948),
    [anon_sym_null] = ACTIONS(3950),
    [anon_sym_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_COLON] = ACTIONS(3948),
    [anon_sym_AMP] = ACTIONS(3950),
    [anon_sym_LBRACK] = ACTIONS(3950),
    [anon_sym_RBRACK] = ACTIONS(3948),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3948),
    [anon_sym_LBRACE] = ACTIONS(3950),
    [anon_sym_RBRACE] = ACTIONS(3948),
    [anon_sym_LT_AT] = ACTIONS(3950),
    [anon_sym_LT_AT_AT] = ACTIONS(3950),
    [anon_sym_DOT] = ACTIONS(3950),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3948),
    [anon_sym_new] = ACTIONS(3950),
    [anon_sym_with] = ACTIONS(3950),
    [anon_sym_return_BANG] = ACTIONS(3948),
    [anon_sym_yield] = ACTIONS(3950),
    [anon_sym_yield_BANG] = ACTIONS(3948),
    [anon_sym_lazy] = ACTIONS(3950),
    [anon_sym_assert] = ACTIONS(3950),
    [anon_sym_upcast] = ACTIONS(3950),
    [anon_sym_downcast] = ACTIONS(3950),
    [anon_sym_COLON_GT] = ACTIONS(3948),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3948),
    [anon_sym_for] = ACTIONS(3950),
    [anon_sym_to] = ACTIONS(3950),
    [anon_sym_downto] = ACTIONS(3950),
    [anon_sym_while] = ACTIONS(3950),
    [anon_sym_if] = ACTIONS(3950),
    [anon_sym_fun] = ACTIONS(3950),
    [anon_sym_try] = ACTIONS(3950),
    [anon_sym_match] = ACTIONS(3950),
    [anon_sym_match_BANG] = ACTIONS(3948),
    [anon_sym_function] = ACTIONS(3950),
    [anon_sym_LT_DASH] = ACTIONS(3950),
    [anon_sym_DOT_LBRACK] = ACTIONS(3948),
    [anon_sym_LT] = ACTIONS(3948),
    [anon_sym_use] = ACTIONS(3950),
    [anon_sym_use_BANG] = ACTIONS(3948),
    [anon_sym_do_BANG] = ACTIONS(3948),
    [anon_sym_begin] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3950),
    [anon_sym_DOT_DOT2] = ACTIONS(3948),
    [anon_sym_or] = ACTIONS(3950),
    [aux_sym_char_token1] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3950),
    [anon_sym_DQUOTE] = ACTIONS(3950),
    [anon_sym_AT_DQUOTE] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [sym_bool] = ACTIONS(3950),
    [sym_unit] = ACTIONS(3948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3950),
    [sym_op_identifier] = ACTIONS(3950),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_DASH] = ACTIONS(3950),
    [anon_sym_PLUS_DOT] = ACTIONS(3950),
    [anon_sym_DASH_DOT] = ACTIONS(3950),
    [anon_sym_PERCENT] = ACTIONS(3950),
    [anon_sym_AMP_AMP] = ACTIONS(3950),
    [anon_sym_TILDE] = ACTIONS(3948),
    [aux_sym_prefix_op_token1] = ACTIONS(3950),
    [aux_sym_infix_op_token1] = ACTIONS(3948),
    [aux_sym_infix_op_token2] = ACTIONS(3950),
    [anon_sym_PIPE_PIPE] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3950),
    [anon_sym_COLON_EQ] = ACTIONS(3948),
    [anon_sym_DOLLAR] = ACTIONS(3950),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3950),
    [sym_int] = ACTIONS(3950),
    [sym_xint] = ACTIONS(3948),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3948),
    [sym__newline] = ACTIONS(3948),
  },
  [2401] = {
    [sym_block_comment] = STATE(2401),
    [sym_compiler_directive_decl] = STATE(2401),
    [sym_fsi_directive_decl] = STATE(2401),
    [sym_preproc_line] = STATE(2401),
    [sym_identifier] = ACTIONS(4011),
    [anon_sym_EQ] = ACTIONS(4009),
    [anon_sym_GT_RBRACK] = ACTIONS(4009),
    [anon_sym_COLON] = ACTIONS(4011),
    [anon_sym_return] = ACTIONS(4011),
    [anon_sym_do] = ACTIONS(4011),
    [anon_sym_let] = ACTIONS(4011),
    [anon_sym_let_BANG] = ACTIONS(4009),
    [anon_sym_LPAREN] = ACTIONS(4011),
    [anon_sym_COMMA] = ACTIONS(4009),
    [anon_sym_null] = ACTIONS(4011),
    [anon_sym_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(4011),
    [anon_sym_LBRACK] = ACTIONS(4011),
    [anon_sym_RBRACK] = ACTIONS(4009),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4009),
    [anon_sym_LBRACE] = ACTIONS(4011),
    [anon_sym_RBRACE] = ACTIONS(4009),
    [anon_sym_LT_AT] = ACTIONS(4011),
    [anon_sym_LT_AT_AT] = ACTIONS(4011),
    [anon_sym_DOT] = ACTIONS(4011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4009),
    [anon_sym_new] = ACTIONS(4011),
    [anon_sym_with] = ACTIONS(4011),
    [anon_sym_return_BANG] = ACTIONS(4009),
    [anon_sym_yield] = ACTIONS(4011),
    [anon_sym_yield_BANG] = ACTIONS(4009),
    [anon_sym_lazy] = ACTIONS(4011),
    [anon_sym_assert] = ACTIONS(4011),
    [anon_sym_upcast] = ACTIONS(4011),
    [anon_sym_downcast] = ACTIONS(4011),
    [anon_sym_COLON_GT] = ACTIONS(4009),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4009),
    [anon_sym_for] = ACTIONS(4011),
    [anon_sym_to] = ACTIONS(4011),
    [anon_sym_downto] = ACTIONS(4011),
    [anon_sym_while] = ACTIONS(4011),
    [anon_sym_if] = ACTIONS(4011),
    [anon_sym_fun] = ACTIONS(4011),
    [anon_sym_try] = ACTIONS(4011),
    [anon_sym_match] = ACTIONS(4011),
    [anon_sym_match_BANG] = ACTIONS(4009),
    [anon_sym_function] = ACTIONS(4011),
    [anon_sym_LT_DASH] = ACTIONS(4011),
    [anon_sym_DOT_LBRACK] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(4009),
    [anon_sym_use] = ACTIONS(4011),
    [anon_sym_use_BANG] = ACTIONS(4009),
    [anon_sym_do_BANG] = ACTIONS(4009),
    [anon_sym_begin] = ACTIONS(4011),
    [anon_sym_LPAREN2] = ACTIONS(4011),
    [anon_sym_DOT_DOT2] = ACTIONS(4009),
    [anon_sym_or] = ACTIONS(4011),
    [aux_sym_char_token1] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4011),
    [anon_sym_DQUOTE] = ACTIONS(4011),
    [anon_sym_AT_DQUOTE] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [sym_bool] = ACTIONS(4011),
    [sym_unit] = ACTIONS(4009),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4011),
    [sym_op_identifier] = ACTIONS(4011),
    [anon_sym_PLUS] = ACTIONS(4011),
    [anon_sym_DASH] = ACTIONS(4011),
    [anon_sym_PLUS_DOT] = ACTIONS(4011),
    [anon_sym_DASH_DOT] = ACTIONS(4011),
    [anon_sym_PERCENT] = ACTIONS(4011),
    [anon_sym_AMP_AMP] = ACTIONS(4011),
    [anon_sym_TILDE] = ACTIONS(4009),
    [aux_sym_prefix_op_token1] = ACTIONS(4011),
    [aux_sym_infix_op_token1] = ACTIONS(4009),
    [aux_sym_infix_op_token2] = ACTIONS(4011),
    [anon_sym_PIPE_PIPE] = ACTIONS(4011),
    [anon_sym_BANG_EQ] = ACTIONS(4011),
    [anon_sym_COLON_EQ] = ACTIONS(4009),
    [anon_sym_DOLLAR] = ACTIONS(4011),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4011),
    [sym_int] = ACTIONS(4011),
    [sym_xint] = ACTIONS(4009),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4009),
    [sym__newline] = ACTIONS(4009),
  },
  [2402] = {
    [sym_block_comment] = STATE(2402),
    [sym_compiler_directive_decl] = STATE(2402),
    [sym_fsi_directive_decl] = STATE(2402),
    [sym_preproc_line] = STATE(2402),
    [sym_identifier] = ACTIONS(3954),
    [anon_sym_EQ] = ACTIONS(3952),
    [anon_sym_GT_RBRACK] = ACTIONS(3952),
    [anon_sym_COLON] = ACTIONS(3954),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_do] = ACTIONS(3954),
    [anon_sym_let] = ACTIONS(3954),
    [anon_sym_let_BANG] = ACTIONS(3952),
    [anon_sym_LPAREN] = ACTIONS(3954),
    [anon_sym_COMMA] = ACTIONS(3952),
    [anon_sym_null] = ACTIONS(3954),
    [anon_sym_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_COLON] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3954),
    [anon_sym_LBRACK] = ACTIONS(3954),
    [anon_sym_RBRACK] = ACTIONS(3952),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(3954),
    [anon_sym_RBRACE] = ACTIONS(3952),
    [anon_sym_LT_AT] = ACTIONS(3954),
    [anon_sym_LT_AT_AT] = ACTIONS(3954),
    [anon_sym_DOT] = ACTIONS(3954),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3952),
    [anon_sym_new] = ACTIONS(3954),
    [anon_sym_with] = ACTIONS(3954),
    [anon_sym_return_BANG] = ACTIONS(3952),
    [anon_sym_yield] = ACTIONS(3954),
    [anon_sym_yield_BANG] = ACTIONS(3952),
    [anon_sym_lazy] = ACTIONS(3954),
    [anon_sym_assert] = ACTIONS(3954),
    [anon_sym_upcast] = ACTIONS(3954),
    [anon_sym_downcast] = ACTIONS(3954),
    [anon_sym_COLON_GT] = ACTIONS(3952),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3952),
    [anon_sym_for] = ACTIONS(3954),
    [anon_sym_to] = ACTIONS(3954),
    [anon_sym_downto] = ACTIONS(3954),
    [anon_sym_while] = ACTIONS(3954),
    [anon_sym_if] = ACTIONS(3954),
    [anon_sym_fun] = ACTIONS(3954),
    [anon_sym_try] = ACTIONS(3954),
    [anon_sym_match] = ACTIONS(3954),
    [anon_sym_match_BANG] = ACTIONS(3952),
    [anon_sym_function] = ACTIONS(3954),
    [anon_sym_LT_DASH] = ACTIONS(3954),
    [anon_sym_DOT_LBRACK] = ACTIONS(3952),
    [anon_sym_LT] = ACTIONS(3952),
    [anon_sym_use] = ACTIONS(3954),
    [anon_sym_use_BANG] = ACTIONS(3952),
    [anon_sym_do_BANG] = ACTIONS(3952),
    [anon_sym_begin] = ACTIONS(3954),
    [anon_sym_LPAREN2] = ACTIONS(3954),
    [anon_sym_DOT_DOT2] = ACTIONS(3952),
    [anon_sym_or] = ACTIONS(3954),
    [aux_sym_char_token1] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3954),
    [anon_sym_DQUOTE] = ACTIONS(3954),
    [anon_sym_AT_DQUOTE] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [sym_bool] = ACTIONS(3954),
    [sym_unit] = ACTIONS(3952),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3954),
    [sym_op_identifier] = ACTIONS(3954),
    [anon_sym_PLUS] = ACTIONS(3954),
    [anon_sym_DASH] = ACTIONS(3954),
    [anon_sym_PLUS_DOT] = ACTIONS(3954),
    [anon_sym_DASH_DOT] = ACTIONS(3954),
    [anon_sym_PERCENT] = ACTIONS(3954),
    [anon_sym_AMP_AMP] = ACTIONS(3954),
    [anon_sym_TILDE] = ACTIONS(3952),
    [aux_sym_prefix_op_token1] = ACTIONS(3954),
    [aux_sym_infix_op_token1] = ACTIONS(3952),
    [aux_sym_infix_op_token2] = ACTIONS(3954),
    [anon_sym_PIPE_PIPE] = ACTIONS(3954),
    [anon_sym_BANG_EQ] = ACTIONS(3954),
    [anon_sym_COLON_EQ] = ACTIONS(3952),
    [anon_sym_DOLLAR] = ACTIONS(3954),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3954),
    [sym_int] = ACTIONS(3954),
    [sym_xint] = ACTIONS(3952),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3952),
    [sym__newline] = ACTIONS(3952),
  },
  [2403] = {
    [sym_block_comment] = STATE(2403),
    [sym_compiler_directive_decl] = STATE(2403),
    [sym_fsi_directive_decl] = STATE(2403),
    [sym_preproc_line] = STATE(2403),
    [ts_builtin_sym_end] = ACTIONS(3191),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_namespace] = ACTIONS(3193),
    [anon_sym_module] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_open] = ACTIONS(3193),
    [anon_sym_LBRACK_LT] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_type] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [anon_sym_exception] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3191),
    [anon_sym_POUNDload] = ACTIONS(3191),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [2404] = {
    [sym_block_comment] = STATE(2404),
    [sym_compiler_directive_decl] = STATE(2404),
    [sym_fsi_directive_decl] = STATE(2404),
    [sym_preproc_line] = STATE(2404),
    [ts_builtin_sym_end] = ACTIONS(4098),
    [sym_identifier] = ACTIONS(4100),
    [anon_sym_namespace] = ACTIONS(4100),
    [anon_sym_module] = ACTIONS(4100),
    [anon_sym_EQ] = ACTIONS(4098),
    [anon_sym_open] = ACTIONS(4100),
    [anon_sym_LBRACK_LT] = ACTIONS(4098),
    [anon_sym_COLON] = ACTIONS(4100),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_type] = ACTIONS(4100),
    [anon_sym_do] = ACTIONS(4100),
    [anon_sym_let] = ACTIONS(4100),
    [anon_sym_let_BANG] = ACTIONS(4098),
    [anon_sym_LPAREN] = ACTIONS(4100),
    [anon_sym_COMMA] = ACTIONS(4098),
    [anon_sym_null] = ACTIONS(4100),
    [anon_sym_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_COLON] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4100),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4098),
    [anon_sym_LBRACE] = ACTIONS(4100),
    [anon_sym_LT_AT] = ACTIONS(4100),
    [anon_sym_LT_AT_AT] = ACTIONS(4100),
    [anon_sym_DOT] = ACTIONS(4100),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4098),
    [anon_sym_new] = ACTIONS(4100),
    [anon_sym_return_BANG] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4100),
    [anon_sym_yield_BANG] = ACTIONS(4098),
    [anon_sym_lazy] = ACTIONS(4100),
    [anon_sym_assert] = ACTIONS(4100),
    [anon_sym_upcast] = ACTIONS(4100),
    [anon_sym_downcast] = ACTIONS(4100),
    [anon_sym_COLON_GT] = ACTIONS(4098),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4098),
    [anon_sym_for] = ACTIONS(4100),
    [anon_sym_while] = ACTIONS(4100),
    [anon_sym_if] = ACTIONS(4100),
    [anon_sym_fun] = ACTIONS(4100),
    [anon_sym_try] = ACTIONS(4100),
    [anon_sym_match] = ACTIONS(4100),
    [anon_sym_match_BANG] = ACTIONS(4098),
    [anon_sym_function] = ACTIONS(4100),
    [anon_sym_LT_DASH] = ACTIONS(4100),
    [anon_sym_DOT_LBRACK] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(4098),
    [anon_sym_use] = ACTIONS(4100),
    [anon_sym_use_BANG] = ACTIONS(4098),
    [anon_sym_do_BANG] = ACTIONS(4098),
    [anon_sym_begin] = ACTIONS(4100),
    [anon_sym_LPAREN2] = ACTIONS(4100),
    [anon_sym_or] = ACTIONS(4100),
    [anon_sym_exception] = ACTIONS(4100),
    [aux_sym_char_token1] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4100),
    [anon_sym_DQUOTE] = ACTIONS(4100),
    [anon_sym_AT_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [sym_bool] = ACTIONS(4100),
    [sym_unit] = ACTIONS(4098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4100),
    [sym_op_identifier] = ACTIONS(4100),
    [anon_sym_PLUS] = ACTIONS(4100),
    [anon_sym_DASH] = ACTIONS(4100),
    [anon_sym_PLUS_DOT] = ACTIONS(4100),
    [anon_sym_DASH_DOT] = ACTIONS(4100),
    [anon_sym_PERCENT] = ACTIONS(4100),
    [anon_sym_AMP_AMP] = ACTIONS(4100),
    [anon_sym_TILDE] = ACTIONS(4098),
    [aux_sym_prefix_op_token1] = ACTIONS(4100),
    [aux_sym_infix_op_token1] = ACTIONS(4098),
    [aux_sym_infix_op_token2] = ACTIONS(4100),
    [anon_sym_PIPE_PIPE] = ACTIONS(4100),
    [anon_sym_BANG_EQ] = ACTIONS(4100),
    [anon_sym_COLON_EQ] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4100),
    [sym_int] = ACTIONS(4100),
    [sym_xint] = ACTIONS(4098),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4098),
    [anon_sym_POUNDload] = ACTIONS(4098),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4098),
    [sym__newline] = ACTIONS(4098),
  },
  [2405] = {
    [sym_block_comment] = STATE(2405),
    [sym_compiler_directive_decl] = STATE(2405),
    [sym_fsi_directive_decl] = STATE(2405),
    [sym_preproc_line] = STATE(2405),
    [sym_identifier] = ACTIONS(4022),
    [anon_sym_EQ] = ACTIONS(4020),
    [anon_sym_GT_RBRACK] = ACTIONS(4020),
    [anon_sym_COLON] = ACTIONS(4022),
    [anon_sym_return] = ACTIONS(4022),
    [anon_sym_do] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_let_BANG] = ACTIONS(4020),
    [anon_sym_LPAREN] = ACTIONS(4022),
    [anon_sym_COMMA] = ACTIONS(4020),
    [anon_sym_null] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_COLON] = ACTIONS(4020),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4022),
    [anon_sym_RBRACK] = ACTIONS(4020),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(4022),
    [anon_sym_RBRACE] = ACTIONS(4020),
    [anon_sym_LT_AT] = ACTIONS(4022),
    [anon_sym_LT_AT_AT] = ACTIONS(4022),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4020),
    [anon_sym_new] = ACTIONS(4022),
    [anon_sym_with] = ACTIONS(4022),
    [anon_sym_return_BANG] = ACTIONS(4020),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_yield_BANG] = ACTIONS(4020),
    [anon_sym_lazy] = ACTIONS(4022),
    [anon_sym_assert] = ACTIONS(4022),
    [anon_sym_upcast] = ACTIONS(4022),
    [anon_sym_downcast] = ACTIONS(4022),
    [anon_sym_COLON_GT] = ACTIONS(4020),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4020),
    [anon_sym_for] = ACTIONS(4022),
    [anon_sym_to] = ACTIONS(4022),
    [anon_sym_downto] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4022),
    [anon_sym_if] = ACTIONS(4022),
    [anon_sym_fun] = ACTIONS(4022),
    [anon_sym_try] = ACTIONS(4022),
    [anon_sym_match] = ACTIONS(4022),
    [anon_sym_match_BANG] = ACTIONS(4020),
    [anon_sym_function] = ACTIONS(4022),
    [anon_sym_LT_DASH] = ACTIONS(4022),
    [anon_sym_DOT_LBRACK] = ACTIONS(4020),
    [anon_sym_LT] = ACTIONS(4020),
    [anon_sym_use] = ACTIONS(4022),
    [anon_sym_use_BANG] = ACTIONS(4020),
    [anon_sym_do_BANG] = ACTIONS(4020),
    [anon_sym_begin] = ACTIONS(4022),
    [anon_sym_LPAREN2] = ACTIONS(4022),
    [anon_sym_DOT_DOT2] = ACTIONS(4020),
    [anon_sym_or] = ACTIONS(4022),
    [aux_sym_char_token1] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4022),
    [anon_sym_DQUOTE] = ACTIONS(4022),
    [anon_sym_AT_DQUOTE] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [sym_bool] = ACTIONS(4022),
    [sym_unit] = ACTIONS(4020),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4022),
    [sym_op_identifier] = ACTIONS(4022),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_PLUS_DOT] = ACTIONS(4022),
    [anon_sym_DASH_DOT] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4022),
    [anon_sym_TILDE] = ACTIONS(4020),
    [aux_sym_prefix_op_token1] = ACTIONS(4022),
    [aux_sym_infix_op_token1] = ACTIONS(4020),
    [aux_sym_infix_op_token2] = ACTIONS(4022),
    [anon_sym_PIPE_PIPE] = ACTIONS(4022),
    [anon_sym_BANG_EQ] = ACTIONS(4022),
    [anon_sym_COLON_EQ] = ACTIONS(4020),
    [anon_sym_DOLLAR] = ACTIONS(4022),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4022),
    [sym_int] = ACTIONS(4022),
    [sym_xint] = ACTIONS(4020),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4020),
    [sym__newline] = ACTIONS(4020),
  },
  [2406] = {
    [sym_block_comment] = STATE(2406),
    [sym_compiler_directive_decl] = STATE(2406),
    [sym_fsi_directive_decl] = STATE(2406),
    [sym_preproc_line] = STATE(2406),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4072),
    [anon_sym_GT_RBRACK] = ACTIONS(4072),
    [anon_sym_COLON] = ACTIONS(4074),
    [anon_sym_return] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_let_BANG] = ACTIONS(4072),
    [anon_sym_LPAREN] = ACTIONS(4074),
    [anon_sym_COMMA] = ACTIONS(4072),
    [anon_sym_null] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_COLON] = ACTIONS(4072),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_RBRACK] = ACTIONS(4072),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_RBRACE] = ACTIONS(4072),
    [anon_sym_LT_AT] = ACTIONS(4074),
    [anon_sym_LT_AT_AT] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4072),
    [anon_sym_new] = ACTIONS(4074),
    [anon_sym_with] = ACTIONS(4074),
    [anon_sym_return_BANG] = ACTIONS(4072),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_yield_BANG] = ACTIONS(4072),
    [anon_sym_lazy] = ACTIONS(4074),
    [anon_sym_assert] = ACTIONS(4074),
    [anon_sym_upcast] = ACTIONS(4074),
    [anon_sym_downcast] = ACTIONS(4074),
    [anon_sym_COLON_GT] = ACTIONS(4072),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4072),
    [anon_sym_for] = ACTIONS(4074),
    [anon_sym_to] = ACTIONS(4074),
    [anon_sym_downto] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_fun] = ACTIONS(4074),
    [anon_sym_try] = ACTIONS(4074),
    [anon_sym_match] = ACTIONS(4074),
    [anon_sym_match_BANG] = ACTIONS(4072),
    [anon_sym_function] = ACTIONS(4074),
    [anon_sym_LT_DASH] = ACTIONS(4074),
    [anon_sym_DOT_LBRACK] = ACTIONS(4072),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_use] = ACTIONS(4074),
    [anon_sym_use_BANG] = ACTIONS(4072),
    [anon_sym_do_BANG] = ACTIONS(4072),
    [anon_sym_begin] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(4074),
    [anon_sym_DOT_DOT2] = ACTIONS(4072),
    [anon_sym_or] = ACTIONS(4074),
    [aux_sym_char_token1] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4074),
    [anon_sym_DQUOTE] = ACTIONS(4074),
    [anon_sym_AT_DQUOTE] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [sym_bool] = ACTIONS(4074),
    [sym_unit] = ACTIONS(4072),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4074),
    [sym_op_identifier] = ACTIONS(4074),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_PLUS_DOT] = ACTIONS(4074),
    [anon_sym_DASH_DOT] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_TILDE] = ACTIONS(4072),
    [aux_sym_prefix_op_token1] = ACTIONS(4074),
    [aux_sym_infix_op_token1] = ACTIONS(4072),
    [aux_sym_infix_op_token2] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [anon_sym_BANG_EQ] = ACTIONS(4074),
    [anon_sym_COLON_EQ] = ACTIONS(4072),
    [anon_sym_DOLLAR] = ACTIONS(4074),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4074),
    [sym_int] = ACTIONS(4074),
    [sym_xint] = ACTIONS(4072),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4072),
    [sym__newline] = ACTIONS(4072),
  },
  [2407] = {
    [sym_block_comment] = STATE(2407),
    [sym_compiler_directive_decl] = STATE(2407),
    [sym_fsi_directive_decl] = STATE(2407),
    [sym_preproc_line] = STATE(2407),
    [ts_builtin_sym_end] = ACTIONS(3865),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_namespace] = ACTIONS(3867),
    [anon_sym_module] = ACTIONS(3867),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_open] = ACTIONS(3867),
    [anon_sym_LBRACK_LT] = ACTIONS(3865),
    [anon_sym_COLON] = ACTIONS(3867),
    [anon_sym_return] = ACTIONS(3867),
    [anon_sym_type] = ACTIONS(3867),
    [anon_sym_do] = ACTIONS(3867),
    [anon_sym_let] = ACTIONS(3867),
    [anon_sym_let_BANG] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(3867),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_null] = ACTIONS(3867),
    [anon_sym_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_COLON] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3867),
    [anon_sym_LBRACK] = ACTIONS(3867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3867),
    [anon_sym_LT_AT] = ACTIONS(3867),
    [anon_sym_LT_AT_AT] = ACTIONS(3867),
    [anon_sym_DOT] = ACTIONS(3867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3867),
    [anon_sym_return_BANG] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3867),
    [anon_sym_yield_BANG] = ACTIONS(3865),
    [anon_sym_lazy] = ACTIONS(3867),
    [anon_sym_assert] = ACTIONS(3867),
    [anon_sym_upcast] = ACTIONS(3867),
    [anon_sym_downcast] = ACTIONS(3867),
    [anon_sym_COLON_GT] = ACTIONS(3865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3867),
    [anon_sym_while] = ACTIONS(3867),
    [anon_sym_if] = ACTIONS(3867),
    [anon_sym_fun] = ACTIONS(3867),
    [anon_sym_try] = ACTIONS(3867),
    [anon_sym_match] = ACTIONS(3867),
    [anon_sym_match_BANG] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(3867),
    [anon_sym_DOT_LBRACK] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_use] = ACTIONS(3867),
    [anon_sym_use_BANG] = ACTIONS(3865),
    [anon_sym_do_BANG] = ACTIONS(3865),
    [anon_sym_begin] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(3867),
    [anon_sym_or] = ACTIONS(3867),
    [anon_sym_exception] = ACTIONS(3867),
    [aux_sym_char_token1] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3867),
    [anon_sym_DQUOTE] = ACTIONS(3867),
    [anon_sym_AT_DQUOTE] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [sym_bool] = ACTIONS(3867),
    [sym_unit] = ACTIONS(3865),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3867),
    [sym_op_identifier] = ACTIONS(3867),
    [anon_sym_PLUS] = ACTIONS(3867),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_PLUS_DOT] = ACTIONS(3867),
    [anon_sym_DASH_DOT] = ACTIONS(3867),
    [anon_sym_PERCENT] = ACTIONS(3867),
    [anon_sym_AMP_AMP] = ACTIONS(3867),
    [anon_sym_TILDE] = ACTIONS(3865),
    [aux_sym_prefix_op_token1] = ACTIONS(3867),
    [aux_sym_infix_op_token1] = ACTIONS(3865),
    [aux_sym_infix_op_token2] = ACTIONS(3867),
    [anon_sym_PIPE_PIPE] = ACTIONS(3867),
    [anon_sym_BANG_EQ] = ACTIONS(3867),
    [anon_sym_COLON_EQ] = ACTIONS(3865),
    [anon_sym_DOLLAR] = ACTIONS(3867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3867),
    [sym_int] = ACTIONS(3867),
    [sym_xint] = ACTIONS(3865),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3865),
    [anon_sym_POUNDload] = ACTIONS(3865),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3865),
    [sym__newline] = ACTIONS(3865),
  },
  [2408] = {
    [sym_block_comment] = STATE(2408),
    [sym_compiler_directive_decl] = STATE(2408),
    [sym_fsi_directive_decl] = STATE(2408),
    [sym_preproc_line] = STATE(2408),
    [ts_builtin_sym_end] = ACTIONS(3925),
    [sym_identifier] = ACTIONS(3927),
    [anon_sym_namespace] = ACTIONS(3927),
    [anon_sym_module] = ACTIONS(3927),
    [anon_sym_EQ] = ACTIONS(3925),
    [anon_sym_open] = ACTIONS(3927),
    [anon_sym_LBRACK_LT] = ACTIONS(3925),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_return] = ACTIONS(3927),
    [anon_sym_type] = ACTIONS(3927),
    [anon_sym_do] = ACTIONS(3927),
    [anon_sym_let] = ACTIONS(3927),
    [anon_sym_let_BANG] = ACTIONS(3925),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_COMMA] = ACTIONS(3925),
    [anon_sym_null] = ACTIONS(3927),
    [anon_sym_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_COLON] = ACTIONS(3925),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3925),
    [anon_sym_LBRACE] = ACTIONS(3927),
    [anon_sym_LT_AT] = ACTIONS(3927),
    [anon_sym_LT_AT_AT] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3925),
    [anon_sym_new] = ACTIONS(3927),
    [anon_sym_return_BANG] = ACTIONS(3925),
    [anon_sym_yield] = ACTIONS(3927),
    [anon_sym_yield_BANG] = ACTIONS(3925),
    [anon_sym_lazy] = ACTIONS(3927),
    [anon_sym_assert] = ACTIONS(3927),
    [anon_sym_upcast] = ACTIONS(3927),
    [anon_sym_downcast] = ACTIONS(3927),
    [anon_sym_COLON_GT] = ACTIONS(3925),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3925),
    [anon_sym_for] = ACTIONS(3927),
    [anon_sym_while] = ACTIONS(3927),
    [anon_sym_if] = ACTIONS(3927),
    [anon_sym_fun] = ACTIONS(3927),
    [anon_sym_try] = ACTIONS(3927),
    [anon_sym_match] = ACTIONS(3927),
    [anon_sym_match_BANG] = ACTIONS(3925),
    [anon_sym_function] = ACTIONS(3927),
    [anon_sym_LT_DASH] = ACTIONS(3927),
    [anon_sym_DOT_LBRACK] = ACTIONS(3925),
    [anon_sym_LT] = ACTIONS(3925),
    [anon_sym_use] = ACTIONS(3927),
    [anon_sym_use_BANG] = ACTIONS(3925),
    [anon_sym_do_BANG] = ACTIONS(3925),
    [anon_sym_begin] = ACTIONS(3927),
    [anon_sym_LPAREN2] = ACTIONS(3927),
    [anon_sym_or] = ACTIONS(3927),
    [anon_sym_exception] = ACTIONS(3927),
    [aux_sym_char_token1] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_AT_DQUOTE] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [sym_bool] = ACTIONS(3927),
    [sym_unit] = ACTIONS(3925),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3927),
    [sym_op_identifier] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3927),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_PLUS_DOT] = ACTIONS(3927),
    [anon_sym_DASH_DOT] = ACTIONS(3927),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_TILDE] = ACTIONS(3925),
    [aux_sym_prefix_op_token1] = ACTIONS(3927),
    [aux_sym_infix_op_token1] = ACTIONS(3925),
    [aux_sym_infix_op_token2] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_COLON_EQ] = ACTIONS(3925),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3927),
    [sym_int] = ACTIONS(3927),
    [sym_xint] = ACTIONS(3925),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3925),
    [anon_sym_POUNDload] = ACTIONS(3925),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3925),
    [sym__newline] = ACTIONS(3925),
  },
  [2409] = {
    [sym_block_comment] = STATE(2409),
    [sym_compiler_directive_decl] = STATE(2409),
    [sym_fsi_directive_decl] = STATE(2409),
    [sym_preproc_line] = STATE(2409),
    [ts_builtin_sym_end] = ACTIONS(3944),
    [sym_identifier] = ACTIONS(3946),
    [anon_sym_namespace] = ACTIONS(3946),
    [anon_sym_module] = ACTIONS(3946),
    [anon_sym_EQ] = ACTIONS(3944),
    [anon_sym_open] = ACTIONS(3946),
    [anon_sym_LBRACK_LT] = ACTIONS(3944),
    [anon_sym_COLON] = ACTIONS(3946),
    [anon_sym_return] = ACTIONS(3946),
    [anon_sym_type] = ACTIONS(3946),
    [anon_sym_do] = ACTIONS(3946),
    [anon_sym_let] = ACTIONS(3946),
    [anon_sym_let_BANG] = ACTIONS(3944),
    [anon_sym_LPAREN] = ACTIONS(3946),
    [anon_sym_COMMA] = ACTIONS(3944),
    [anon_sym_null] = ACTIONS(3946),
    [anon_sym_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LBRACK] = ACTIONS(3946),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3944),
    [anon_sym_LBRACE] = ACTIONS(3946),
    [anon_sym_LT_AT] = ACTIONS(3946),
    [anon_sym_LT_AT_AT] = ACTIONS(3946),
    [anon_sym_DOT] = ACTIONS(3946),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3944),
    [anon_sym_new] = ACTIONS(3946),
    [anon_sym_return_BANG] = ACTIONS(3944),
    [anon_sym_yield] = ACTIONS(3946),
    [anon_sym_yield_BANG] = ACTIONS(3944),
    [anon_sym_lazy] = ACTIONS(3946),
    [anon_sym_assert] = ACTIONS(3946),
    [anon_sym_upcast] = ACTIONS(3946),
    [anon_sym_downcast] = ACTIONS(3946),
    [anon_sym_COLON_GT] = ACTIONS(3944),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3944),
    [anon_sym_for] = ACTIONS(3946),
    [anon_sym_while] = ACTIONS(3946),
    [anon_sym_if] = ACTIONS(3946),
    [anon_sym_fun] = ACTIONS(3946),
    [anon_sym_try] = ACTIONS(3946),
    [anon_sym_match] = ACTIONS(3946),
    [anon_sym_match_BANG] = ACTIONS(3944),
    [anon_sym_function] = ACTIONS(3946),
    [anon_sym_LT_DASH] = ACTIONS(3946),
    [anon_sym_DOT_LBRACK] = ACTIONS(3944),
    [anon_sym_LT] = ACTIONS(3944),
    [anon_sym_use] = ACTIONS(3946),
    [anon_sym_use_BANG] = ACTIONS(3944),
    [anon_sym_do_BANG] = ACTIONS(3944),
    [anon_sym_begin] = ACTIONS(3946),
    [anon_sym_LPAREN2] = ACTIONS(3946),
    [anon_sym_or] = ACTIONS(3946),
    [anon_sym_exception] = ACTIONS(3946),
    [aux_sym_char_token1] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_AT_DQUOTE] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [sym_bool] = ACTIONS(3946),
    [sym_unit] = ACTIONS(3944),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3946),
    [sym_op_identifier] = ACTIONS(3946),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PLUS_DOT] = ACTIONS(3946),
    [anon_sym_DASH_DOT] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3946),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_TILDE] = ACTIONS(3944),
    [aux_sym_prefix_op_token1] = ACTIONS(3946),
    [aux_sym_infix_op_token1] = ACTIONS(3944),
    [aux_sym_infix_op_token2] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [anon_sym_BANG_EQ] = ACTIONS(3946),
    [anon_sym_COLON_EQ] = ACTIONS(3944),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3946),
    [sym_int] = ACTIONS(3946),
    [sym_xint] = ACTIONS(3944),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3944),
    [anon_sym_POUNDload] = ACTIONS(3944),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3944),
    [sym__newline] = ACTIONS(3944),
  },
  [2410] = {
    [sym_block_comment] = STATE(2410),
    [sym_compiler_directive_decl] = STATE(2410),
    [sym_fsi_directive_decl] = STATE(2410),
    [sym_preproc_line] = STATE(2410),
    [sym_identifier] = ACTIONS(4224),
    [anon_sym_EQ] = ACTIONS(4222),
    [anon_sym_GT_RBRACK] = ACTIONS(4222),
    [anon_sym_COLON] = ACTIONS(4224),
    [anon_sym_return] = ACTIONS(4224),
    [anon_sym_do] = ACTIONS(4224),
    [anon_sym_let] = ACTIONS(4224),
    [anon_sym_let_BANG] = ACTIONS(4222),
    [anon_sym_LPAREN] = ACTIONS(4224),
    [anon_sym_COMMA] = ACTIONS(4222),
    [anon_sym_null] = ACTIONS(4224),
    [anon_sym_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_COLON] = ACTIONS(4222),
    [anon_sym_AMP] = ACTIONS(4224),
    [anon_sym_LBRACK] = ACTIONS(4224),
    [anon_sym_RBRACK] = ACTIONS(4222),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4222),
    [anon_sym_LBRACE] = ACTIONS(4224),
    [anon_sym_RBRACE] = ACTIONS(4222),
    [anon_sym_LT_AT] = ACTIONS(4224),
    [anon_sym_LT_AT_AT] = ACTIONS(4224),
    [anon_sym_DOT] = ACTIONS(4224),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4222),
    [anon_sym_new] = ACTIONS(4224),
    [anon_sym_with] = ACTIONS(4224),
    [anon_sym_return_BANG] = ACTIONS(4222),
    [anon_sym_yield] = ACTIONS(4224),
    [anon_sym_yield_BANG] = ACTIONS(4222),
    [anon_sym_lazy] = ACTIONS(4224),
    [anon_sym_assert] = ACTIONS(4224),
    [anon_sym_upcast] = ACTIONS(4224),
    [anon_sym_downcast] = ACTIONS(4224),
    [anon_sym_COLON_GT] = ACTIONS(4222),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4222),
    [anon_sym_for] = ACTIONS(4224),
    [anon_sym_to] = ACTIONS(4224),
    [anon_sym_downto] = ACTIONS(4224),
    [anon_sym_while] = ACTIONS(4224),
    [anon_sym_if] = ACTIONS(4224),
    [anon_sym_fun] = ACTIONS(4224),
    [anon_sym_try] = ACTIONS(4224),
    [anon_sym_match] = ACTIONS(4224),
    [anon_sym_match_BANG] = ACTIONS(4222),
    [anon_sym_function] = ACTIONS(4224),
    [anon_sym_LT_DASH] = ACTIONS(4224),
    [anon_sym_DOT_LBRACK] = ACTIONS(4222),
    [anon_sym_LT] = ACTIONS(4222),
    [anon_sym_use] = ACTIONS(4224),
    [anon_sym_use_BANG] = ACTIONS(4222),
    [anon_sym_do_BANG] = ACTIONS(4222),
    [anon_sym_begin] = ACTIONS(4224),
    [anon_sym_LPAREN2] = ACTIONS(4224),
    [anon_sym_DOT_DOT2] = ACTIONS(4222),
    [anon_sym_or] = ACTIONS(4224),
    [aux_sym_char_token1] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4224),
    [anon_sym_DQUOTE] = ACTIONS(4224),
    [anon_sym_AT_DQUOTE] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [sym_bool] = ACTIONS(4224),
    [sym_unit] = ACTIONS(4222),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4224),
    [sym_op_identifier] = ACTIONS(4224),
    [anon_sym_PLUS] = ACTIONS(4224),
    [anon_sym_DASH] = ACTIONS(4224),
    [anon_sym_PLUS_DOT] = ACTIONS(4224),
    [anon_sym_DASH_DOT] = ACTIONS(4224),
    [anon_sym_PERCENT] = ACTIONS(4224),
    [anon_sym_AMP_AMP] = ACTIONS(4224),
    [anon_sym_TILDE] = ACTIONS(4222),
    [aux_sym_prefix_op_token1] = ACTIONS(4224),
    [aux_sym_infix_op_token1] = ACTIONS(4222),
    [aux_sym_infix_op_token2] = ACTIONS(4224),
    [anon_sym_PIPE_PIPE] = ACTIONS(4224),
    [anon_sym_BANG_EQ] = ACTIONS(4224),
    [anon_sym_COLON_EQ] = ACTIONS(4222),
    [anon_sym_DOLLAR] = ACTIONS(4224),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4224),
    [sym_int] = ACTIONS(4224),
    [sym_xint] = ACTIONS(4222),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4222),
    [sym__newline] = ACTIONS(4222),
  },
  [2411] = {
    [sym_block_comment] = STATE(2411),
    [sym_compiler_directive_decl] = STATE(2411),
    [sym_fsi_directive_decl] = STATE(2411),
    [sym_preproc_line] = STATE(2411),
    [ts_builtin_sym_end] = ACTIONS(3948),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_namespace] = ACTIONS(3950),
    [anon_sym_module] = ACTIONS(3950),
    [anon_sym_EQ] = ACTIONS(3948),
    [anon_sym_open] = ACTIONS(3950),
    [anon_sym_LBRACK_LT] = ACTIONS(3948),
    [anon_sym_COLON] = ACTIONS(3950),
    [anon_sym_return] = ACTIONS(3950),
    [anon_sym_type] = ACTIONS(3950),
    [anon_sym_do] = ACTIONS(3950),
    [anon_sym_let] = ACTIONS(3950),
    [anon_sym_let_BANG] = ACTIONS(3948),
    [anon_sym_LPAREN] = ACTIONS(3950),
    [anon_sym_COMMA] = ACTIONS(3948),
    [anon_sym_null] = ACTIONS(3950),
    [anon_sym_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_COLON] = ACTIONS(3948),
    [anon_sym_AMP] = ACTIONS(3950),
    [anon_sym_LBRACK] = ACTIONS(3950),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3948),
    [anon_sym_LBRACE] = ACTIONS(3950),
    [anon_sym_LT_AT] = ACTIONS(3950),
    [anon_sym_LT_AT_AT] = ACTIONS(3950),
    [anon_sym_DOT] = ACTIONS(3950),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3948),
    [anon_sym_new] = ACTIONS(3950),
    [anon_sym_return_BANG] = ACTIONS(3948),
    [anon_sym_yield] = ACTIONS(3950),
    [anon_sym_yield_BANG] = ACTIONS(3948),
    [anon_sym_lazy] = ACTIONS(3950),
    [anon_sym_assert] = ACTIONS(3950),
    [anon_sym_upcast] = ACTIONS(3950),
    [anon_sym_downcast] = ACTIONS(3950),
    [anon_sym_COLON_GT] = ACTIONS(3948),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3948),
    [anon_sym_for] = ACTIONS(3950),
    [anon_sym_while] = ACTIONS(3950),
    [anon_sym_if] = ACTIONS(3950),
    [anon_sym_fun] = ACTIONS(3950),
    [anon_sym_try] = ACTIONS(3950),
    [anon_sym_match] = ACTIONS(3950),
    [anon_sym_match_BANG] = ACTIONS(3948),
    [anon_sym_function] = ACTIONS(3950),
    [anon_sym_LT_DASH] = ACTIONS(3950),
    [anon_sym_DOT_LBRACK] = ACTIONS(3948),
    [anon_sym_LT] = ACTIONS(3948),
    [anon_sym_use] = ACTIONS(3950),
    [anon_sym_use_BANG] = ACTIONS(3948),
    [anon_sym_do_BANG] = ACTIONS(3948),
    [anon_sym_begin] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3950),
    [anon_sym_or] = ACTIONS(3950),
    [anon_sym_exception] = ACTIONS(3950),
    [aux_sym_char_token1] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3950),
    [anon_sym_DQUOTE] = ACTIONS(3950),
    [anon_sym_AT_DQUOTE] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [sym_bool] = ACTIONS(3950),
    [sym_unit] = ACTIONS(3948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3950),
    [sym_op_identifier] = ACTIONS(3950),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_DASH] = ACTIONS(3950),
    [anon_sym_PLUS_DOT] = ACTIONS(3950),
    [anon_sym_DASH_DOT] = ACTIONS(3950),
    [anon_sym_PERCENT] = ACTIONS(3950),
    [anon_sym_AMP_AMP] = ACTIONS(3950),
    [anon_sym_TILDE] = ACTIONS(3948),
    [aux_sym_prefix_op_token1] = ACTIONS(3950),
    [aux_sym_infix_op_token1] = ACTIONS(3948),
    [aux_sym_infix_op_token2] = ACTIONS(3950),
    [anon_sym_PIPE_PIPE] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3950),
    [anon_sym_COLON_EQ] = ACTIONS(3948),
    [anon_sym_DOLLAR] = ACTIONS(3950),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3950),
    [sym_int] = ACTIONS(3950),
    [sym_xint] = ACTIONS(3948),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3948),
    [anon_sym_POUNDload] = ACTIONS(3948),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3948),
    [sym__newline] = ACTIONS(3948),
  },
  [2412] = {
    [sym_block_comment] = STATE(2412),
    [sym_compiler_directive_decl] = STATE(2412),
    [sym_fsi_directive_decl] = STATE(2412),
    [sym_preproc_line] = STATE(2412),
    [aux_sym_type_argument_repeat1] = STATE(2414),
    [sym_identifier] = ACTIONS(3476),
    [anon_sym_EQ] = ACTIONS(3474),
    [anon_sym_COLON] = ACTIONS(3476),
    [anon_sym_return] = ACTIONS(3476),
    [anon_sym_do] = ACTIONS(3476),
    [anon_sym_let] = ACTIONS(3476),
    [anon_sym_let_BANG] = ACTIONS(3474),
    [anon_sym_as] = ACTIONS(3476),
    [anon_sym_LPAREN] = ACTIONS(3476),
    [anon_sym_COMMA] = ACTIONS(3474),
    [anon_sym_null] = ACTIONS(3476),
    [anon_sym_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_COLON] = ACTIONS(3474),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym_LBRACK] = ACTIONS(3476),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3474),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_LT_AT] = ACTIONS(3476),
    [anon_sym_LT_AT_AT] = ACTIONS(3476),
    [anon_sym_DOT] = ACTIONS(3476),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3474),
    [anon_sym_new] = ACTIONS(3476),
    [anon_sym_with] = ACTIONS(3476),
    [anon_sym_return_BANG] = ACTIONS(3474),
    [anon_sym_yield] = ACTIONS(3476),
    [anon_sym_yield_BANG] = ACTIONS(3474),
    [anon_sym_lazy] = ACTIONS(3476),
    [anon_sym_assert] = ACTIONS(3476),
    [anon_sym_upcast] = ACTIONS(3476),
    [anon_sym_downcast] = ACTIONS(3476),
    [anon_sym_COLON_GT] = ACTIONS(3474),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3474),
    [anon_sym_for] = ACTIONS(3476),
    [anon_sym_while] = ACTIONS(3476),
    [anon_sym_if] = ACTIONS(3476),
    [anon_sym_fun] = ACTIONS(3476),
    [anon_sym_DASH_GT] = ACTIONS(3476),
    [anon_sym_try] = ACTIONS(3476),
    [anon_sym_match] = ACTIONS(3476),
    [anon_sym_match_BANG] = ACTIONS(3474),
    [anon_sym_function] = ACTIONS(3476),
    [anon_sym_LT_DASH] = ACTIONS(3476),
    [anon_sym_DOT_LBRACK] = ACTIONS(3474),
    [anon_sym_LT] = ACTIONS(3474),
    [anon_sym_use] = ACTIONS(3476),
    [anon_sym_use_BANG] = ACTIONS(3474),
    [anon_sym_do_BANG] = ACTIONS(3474),
    [anon_sym_begin] = ACTIONS(3476),
    [anon_sym_LPAREN2] = ACTIONS(3476),
    [anon_sym_STAR] = ACTIONS(3476),
    [anon_sym_LT2] = ACTIONS(3476),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3474),
    [anon_sym_or] = ACTIONS(3476),
    [aux_sym_char_token1] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3476),
    [anon_sym_DQUOTE] = ACTIONS(3476),
    [anon_sym_AT_DQUOTE] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [sym_bool] = ACTIONS(3476),
    [sym_unit] = ACTIONS(3474),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3476),
    [sym_op_identifier] = ACTIONS(3476),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3476),
    [anon_sym_PLUS_DOT] = ACTIONS(3476),
    [anon_sym_DASH_DOT] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [anon_sym_AMP_AMP] = ACTIONS(3476),
    [anon_sym_TILDE] = ACTIONS(3474),
    [aux_sym_prefix_op_token1] = ACTIONS(3476),
    [aux_sym_infix_op_token1] = ACTIONS(3474),
    [aux_sym_infix_op_token2] = ACTIONS(3476),
    [anon_sym_PIPE_PIPE] = ACTIONS(3476),
    [anon_sym_BANG_EQ] = ACTIONS(3476),
    [anon_sym_COLON_EQ] = ACTIONS(3474),
    [anon_sym_DOLLAR] = ACTIONS(3476),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3476),
    [sym_int] = ACTIONS(3476),
    [sym_xint] = ACTIONS(3474),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3474),
    [sym__newline] = ACTIONS(3474),
  },
  [2413] = {
    [sym_block_comment] = STATE(2413),
    [sym_compiler_directive_decl] = STATE(2413),
    [sym_fsi_directive_decl] = STATE(2413),
    [sym_preproc_line] = STATE(2413),
    [ts_builtin_sym_end] = ACTIONS(4145),
    [sym_identifier] = ACTIONS(4147),
    [anon_sym_namespace] = ACTIONS(4147),
    [anon_sym_module] = ACTIONS(4147),
    [anon_sym_EQ] = ACTIONS(4145),
    [anon_sym_open] = ACTIONS(4147),
    [anon_sym_LBRACK_LT] = ACTIONS(4145),
    [anon_sym_COLON] = ACTIONS(4147),
    [anon_sym_return] = ACTIONS(4147),
    [anon_sym_type] = ACTIONS(4147),
    [anon_sym_do] = ACTIONS(4147),
    [anon_sym_let] = ACTIONS(4147),
    [anon_sym_let_BANG] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(4147),
    [anon_sym_COMMA] = ACTIONS(4145),
    [anon_sym_null] = ACTIONS(4147),
    [anon_sym_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_COLON] = ACTIONS(4145),
    [anon_sym_AMP] = ACTIONS(4147),
    [anon_sym_LBRACK] = ACTIONS(4147),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4145),
    [anon_sym_LBRACE] = ACTIONS(4147),
    [anon_sym_LT_AT] = ACTIONS(4147),
    [anon_sym_LT_AT_AT] = ACTIONS(4147),
    [anon_sym_DOT] = ACTIONS(4147),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4145),
    [anon_sym_new] = ACTIONS(4147),
    [anon_sym_return_BANG] = ACTIONS(4145),
    [anon_sym_yield] = ACTIONS(4147),
    [anon_sym_yield_BANG] = ACTIONS(4145),
    [anon_sym_lazy] = ACTIONS(4147),
    [anon_sym_assert] = ACTIONS(4147),
    [anon_sym_upcast] = ACTIONS(4147),
    [anon_sym_downcast] = ACTIONS(4147),
    [anon_sym_COLON_GT] = ACTIONS(4145),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4145),
    [anon_sym_for] = ACTIONS(4147),
    [anon_sym_while] = ACTIONS(4147),
    [anon_sym_if] = ACTIONS(4147),
    [anon_sym_fun] = ACTIONS(4147),
    [anon_sym_try] = ACTIONS(4147),
    [anon_sym_match] = ACTIONS(4147),
    [anon_sym_match_BANG] = ACTIONS(4145),
    [anon_sym_function] = ACTIONS(4147),
    [anon_sym_LT_DASH] = ACTIONS(4147),
    [anon_sym_DOT_LBRACK] = ACTIONS(4145),
    [anon_sym_LT] = ACTIONS(4145),
    [anon_sym_use] = ACTIONS(4147),
    [anon_sym_use_BANG] = ACTIONS(4145),
    [anon_sym_do_BANG] = ACTIONS(4145),
    [anon_sym_begin] = ACTIONS(4147),
    [anon_sym_LPAREN2] = ACTIONS(4147),
    [anon_sym_or] = ACTIONS(4147),
    [anon_sym_exception] = ACTIONS(4147),
    [aux_sym_char_token1] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4147),
    [anon_sym_DQUOTE] = ACTIONS(4147),
    [anon_sym_AT_DQUOTE] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [sym_bool] = ACTIONS(4147),
    [sym_unit] = ACTIONS(4145),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4147),
    [sym_op_identifier] = ACTIONS(4147),
    [anon_sym_PLUS] = ACTIONS(4147),
    [anon_sym_DASH] = ACTIONS(4147),
    [anon_sym_PLUS_DOT] = ACTIONS(4147),
    [anon_sym_DASH_DOT] = ACTIONS(4147),
    [anon_sym_PERCENT] = ACTIONS(4147),
    [anon_sym_AMP_AMP] = ACTIONS(4147),
    [anon_sym_TILDE] = ACTIONS(4145),
    [aux_sym_prefix_op_token1] = ACTIONS(4147),
    [aux_sym_infix_op_token1] = ACTIONS(4145),
    [aux_sym_infix_op_token2] = ACTIONS(4147),
    [anon_sym_PIPE_PIPE] = ACTIONS(4147),
    [anon_sym_BANG_EQ] = ACTIONS(4147),
    [anon_sym_COLON_EQ] = ACTIONS(4145),
    [anon_sym_DOLLAR] = ACTIONS(4147),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4147),
    [sym_int] = ACTIONS(4147),
    [sym_xint] = ACTIONS(4145),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4145),
    [anon_sym_POUNDload] = ACTIONS(4145),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4145),
    [sym__newline] = ACTIONS(4145),
  },
  [2414] = {
    [sym_block_comment] = STATE(2414),
    [sym_compiler_directive_decl] = STATE(2414),
    [sym_fsi_directive_decl] = STATE(2414),
    [sym_preproc_line] = STATE(2414),
    [aux_sym_type_argument_repeat1] = STATE(2414),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [anon_sym_as] = ACTIONS(3480),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_COLON] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_with] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_LT_DASH] = ACTIONS(3480),
    [anon_sym_DOT_LBRACK] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_or] = ACTIONS(4957),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3480),
    [anon_sym_DASH_DOT] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3480),
    [aux_sym_infix_op_token1] = ACTIONS(3478),
    [aux_sym_infix_op_token2] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3480),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
  },
  [2415] = {
    [sym_block_comment] = STATE(2415),
    [sym_compiler_directive_decl] = STATE(2415),
    [sym_fsi_directive_decl] = STATE(2415),
    [sym_preproc_line] = STATE(2415),
    [ts_builtin_sym_end] = ACTIONS(3990),
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_namespace] = ACTIONS(3992),
    [anon_sym_module] = ACTIONS(3992),
    [anon_sym_EQ] = ACTIONS(3990),
    [anon_sym_open] = ACTIONS(3992),
    [anon_sym_LBRACK_LT] = ACTIONS(3990),
    [anon_sym_COLON] = ACTIONS(3992),
    [anon_sym_return] = ACTIONS(3992),
    [anon_sym_type] = ACTIONS(3992),
    [anon_sym_do] = ACTIONS(3992),
    [anon_sym_let] = ACTIONS(3992),
    [anon_sym_let_BANG] = ACTIONS(3990),
    [anon_sym_LPAREN] = ACTIONS(3992),
    [anon_sym_COMMA] = ACTIONS(3990),
    [anon_sym_null] = ACTIONS(3992),
    [anon_sym_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [anon_sym_AMP] = ACTIONS(3992),
    [anon_sym_LBRACK] = ACTIONS(3992),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3990),
    [anon_sym_LBRACE] = ACTIONS(3992),
    [anon_sym_LT_AT] = ACTIONS(3992),
    [anon_sym_LT_AT_AT] = ACTIONS(3992),
    [anon_sym_DOT] = ACTIONS(3992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3990),
    [anon_sym_new] = ACTIONS(3992),
    [anon_sym_return_BANG] = ACTIONS(3990),
    [anon_sym_yield] = ACTIONS(3992),
    [anon_sym_yield_BANG] = ACTIONS(3990),
    [anon_sym_lazy] = ACTIONS(3992),
    [anon_sym_assert] = ACTIONS(3992),
    [anon_sym_upcast] = ACTIONS(3992),
    [anon_sym_downcast] = ACTIONS(3992),
    [anon_sym_COLON_GT] = ACTIONS(3990),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3990),
    [anon_sym_for] = ACTIONS(3992),
    [anon_sym_while] = ACTIONS(3992),
    [anon_sym_if] = ACTIONS(3992),
    [anon_sym_fun] = ACTIONS(3992),
    [anon_sym_try] = ACTIONS(3992),
    [anon_sym_match] = ACTIONS(3992),
    [anon_sym_match_BANG] = ACTIONS(3990),
    [anon_sym_function] = ACTIONS(3992),
    [anon_sym_LT_DASH] = ACTIONS(3992),
    [anon_sym_DOT_LBRACK] = ACTIONS(3990),
    [anon_sym_LT] = ACTIONS(3990),
    [anon_sym_use] = ACTIONS(3992),
    [anon_sym_use_BANG] = ACTIONS(3990),
    [anon_sym_do_BANG] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_LPAREN2] = ACTIONS(3992),
    [anon_sym_or] = ACTIONS(3992),
    [anon_sym_exception] = ACTIONS(3992),
    [aux_sym_char_token1] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3992),
    [anon_sym_DQUOTE] = ACTIONS(3992),
    [anon_sym_AT_DQUOTE] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [sym_bool] = ACTIONS(3992),
    [sym_unit] = ACTIONS(3990),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3992),
    [sym_op_identifier] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3992),
    [anon_sym_DASH] = ACTIONS(3992),
    [anon_sym_PLUS_DOT] = ACTIONS(3992),
    [anon_sym_DASH_DOT] = ACTIONS(3992),
    [anon_sym_PERCENT] = ACTIONS(3992),
    [anon_sym_AMP_AMP] = ACTIONS(3992),
    [anon_sym_TILDE] = ACTIONS(3990),
    [aux_sym_prefix_op_token1] = ACTIONS(3992),
    [aux_sym_infix_op_token1] = ACTIONS(3990),
    [aux_sym_infix_op_token2] = ACTIONS(3992),
    [anon_sym_PIPE_PIPE] = ACTIONS(3992),
    [anon_sym_BANG_EQ] = ACTIONS(3992),
    [anon_sym_COLON_EQ] = ACTIONS(3990),
    [anon_sym_DOLLAR] = ACTIONS(3992),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3992),
    [sym_int] = ACTIONS(3992),
    [sym_xint] = ACTIONS(3990),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3990),
    [anon_sym_POUNDload] = ACTIONS(3990),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3990),
    [sym__newline] = ACTIONS(3990),
  },
  [2416] = {
    [sym_block_comment] = STATE(2416),
    [sym_compiler_directive_decl] = STATE(2416),
    [sym_fsi_directive_decl] = STATE(2416),
    [sym_preproc_line] = STATE(2416),
    [sym_identifier] = ACTIONS(3539),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3539),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_do] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3539),
    [anon_sym_let_BANG] = ACTIONS(3537),
    [anon_sym_as] = ACTIONS(3539),
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_null] = ACTIONS(3539),
    [anon_sym_QMARK] = ACTIONS(3539),
    [anon_sym_COLON_QMARK] = ACTIONS(3539),
    [anon_sym_COLON_COLON] = ACTIONS(3537),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3537),
    [anon_sym_LBRACE] = ACTIONS(3539),
    [anon_sym_LT_AT] = ACTIONS(3539),
    [anon_sym_LT_AT_AT] = ACTIONS(3539),
    [anon_sym_DOT] = ACTIONS(3539),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3537),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_with] = ACTIONS(3539),
    [anon_sym_return_BANG] = ACTIONS(3537),
    [anon_sym_yield] = ACTIONS(3539),
    [anon_sym_yield_BANG] = ACTIONS(3537),
    [anon_sym_lazy] = ACTIONS(3539),
    [anon_sym_assert] = ACTIONS(3539),
    [anon_sym_upcast] = ACTIONS(3539),
    [anon_sym_downcast] = ACTIONS(3539),
    [anon_sym_COLON_GT] = ACTIONS(3537),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3537),
    [anon_sym_for] = ACTIONS(3539),
    [anon_sym_while] = ACTIONS(3539),
    [anon_sym_if] = ACTIONS(3539),
    [anon_sym_fun] = ACTIONS(3539),
    [anon_sym_DASH_GT] = ACTIONS(3539),
    [anon_sym_try] = ACTIONS(3539),
    [anon_sym_match] = ACTIONS(3539),
    [anon_sym_match_BANG] = ACTIONS(3537),
    [anon_sym_function] = ACTIONS(3539),
    [anon_sym_LT_DASH] = ACTIONS(3539),
    [anon_sym_DOT_LBRACK] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_use] = ACTIONS(3539),
    [anon_sym_use_BANG] = ACTIONS(3537),
    [anon_sym_do_BANG] = ACTIONS(3537),
    [anon_sym_begin] = ACTIONS(3539),
    [anon_sym_LPAREN2] = ACTIONS(3539),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_LT2] = ACTIONS(3539),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_or] = ACTIONS(3539),
    [aux_sym_char_token1] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3539),
    [anon_sym_DQUOTE] = ACTIONS(3539),
    [anon_sym_AT_DQUOTE] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [sym_bool] = ACTIONS(3539),
    [sym_unit] = ACTIONS(3537),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3539),
    [sym_op_identifier] = ACTIONS(3539),
    [anon_sym_PLUS] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(3539),
    [anon_sym_PLUS_DOT] = ACTIONS(3539),
    [anon_sym_DASH_DOT] = ACTIONS(3539),
    [anon_sym_PERCENT] = ACTIONS(3539),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_TILDE] = ACTIONS(3537),
    [aux_sym_prefix_op_token1] = ACTIONS(3539),
    [aux_sym_infix_op_token1] = ACTIONS(3537),
    [aux_sym_infix_op_token2] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3539),
    [anon_sym_BANG_EQ] = ACTIONS(3539),
    [anon_sym_COLON_EQ] = ACTIONS(3537),
    [anon_sym_DOLLAR] = ACTIONS(3539),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3539),
    [sym_int] = ACTIONS(3539),
    [sym_xint] = ACTIONS(3537),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3537),
    [sym__newline] = ACTIONS(3537),
    [sym__dedent] = ACTIONS(3537),
  },
  [2417] = {
    [sym_block_comment] = STATE(2417),
    [sym_compiler_directive_decl] = STATE(2417),
    [sym_fsi_directive_decl] = STATE(2417),
    [sym_preproc_line] = STATE(2417),
    [ts_builtin_sym_end] = ACTIONS(3986),
    [sym_identifier] = ACTIONS(3988),
    [anon_sym_namespace] = ACTIONS(3988),
    [anon_sym_module] = ACTIONS(3988),
    [anon_sym_EQ] = ACTIONS(3986),
    [anon_sym_open] = ACTIONS(3988),
    [anon_sym_LBRACK_LT] = ACTIONS(3986),
    [anon_sym_COLON] = ACTIONS(3988),
    [anon_sym_return] = ACTIONS(3988),
    [anon_sym_type] = ACTIONS(3988),
    [anon_sym_do] = ACTIONS(3988),
    [anon_sym_let] = ACTIONS(3988),
    [anon_sym_let_BANG] = ACTIONS(3986),
    [anon_sym_LPAREN] = ACTIONS(3988),
    [anon_sym_COMMA] = ACTIONS(3986),
    [anon_sym_null] = ACTIONS(3988),
    [anon_sym_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_COLON] = ACTIONS(3986),
    [anon_sym_AMP] = ACTIONS(3988),
    [anon_sym_LBRACK] = ACTIONS(3988),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3986),
    [anon_sym_LBRACE] = ACTIONS(3988),
    [anon_sym_LT_AT] = ACTIONS(3988),
    [anon_sym_LT_AT_AT] = ACTIONS(3988),
    [anon_sym_DOT] = ACTIONS(3988),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3986),
    [anon_sym_new] = ACTIONS(3988),
    [anon_sym_return_BANG] = ACTIONS(3986),
    [anon_sym_yield] = ACTIONS(3988),
    [anon_sym_yield_BANG] = ACTIONS(3986),
    [anon_sym_lazy] = ACTIONS(3988),
    [anon_sym_assert] = ACTIONS(3988),
    [anon_sym_upcast] = ACTIONS(3988),
    [anon_sym_downcast] = ACTIONS(3988),
    [anon_sym_COLON_GT] = ACTIONS(3986),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_while] = ACTIONS(3988),
    [anon_sym_if] = ACTIONS(3988),
    [anon_sym_fun] = ACTIONS(3988),
    [anon_sym_try] = ACTIONS(3988),
    [anon_sym_match] = ACTIONS(3988),
    [anon_sym_match_BANG] = ACTIONS(3986),
    [anon_sym_function] = ACTIONS(3988),
    [anon_sym_LT_DASH] = ACTIONS(3988),
    [anon_sym_DOT_LBRACK] = ACTIONS(3986),
    [anon_sym_LT] = ACTIONS(3986),
    [anon_sym_use] = ACTIONS(3988),
    [anon_sym_use_BANG] = ACTIONS(3986),
    [anon_sym_do_BANG] = ACTIONS(3986),
    [anon_sym_begin] = ACTIONS(3988),
    [anon_sym_LPAREN2] = ACTIONS(3988),
    [anon_sym_or] = ACTIONS(3988),
    [anon_sym_exception] = ACTIONS(3988),
    [aux_sym_char_token1] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3988),
    [anon_sym_DQUOTE] = ACTIONS(3988),
    [anon_sym_AT_DQUOTE] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [sym_bool] = ACTIONS(3988),
    [sym_unit] = ACTIONS(3986),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3988),
    [sym_op_identifier] = ACTIONS(3988),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_PLUS_DOT] = ACTIONS(3988),
    [anon_sym_DASH_DOT] = ACTIONS(3988),
    [anon_sym_PERCENT] = ACTIONS(3988),
    [anon_sym_AMP_AMP] = ACTIONS(3988),
    [anon_sym_TILDE] = ACTIONS(3986),
    [aux_sym_prefix_op_token1] = ACTIONS(3988),
    [aux_sym_infix_op_token1] = ACTIONS(3986),
    [aux_sym_infix_op_token2] = ACTIONS(3988),
    [anon_sym_PIPE_PIPE] = ACTIONS(3988),
    [anon_sym_BANG_EQ] = ACTIONS(3988),
    [anon_sym_COLON_EQ] = ACTIONS(3986),
    [anon_sym_DOLLAR] = ACTIONS(3988),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3988),
    [sym_int] = ACTIONS(3988),
    [sym_xint] = ACTIONS(3986),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3986),
    [anon_sym_POUNDload] = ACTIONS(3986),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3986),
    [sym__newline] = ACTIONS(3986),
  },
  [2418] = {
    [sym_block_comment] = STATE(2418),
    [sym_compiler_directive_decl] = STATE(2418),
    [sym_fsi_directive_decl] = STATE(2418),
    [sym_preproc_line] = STATE(2418),
    [ts_builtin_sym_end] = ACTIONS(3982),
    [sym_identifier] = ACTIONS(3984),
    [anon_sym_namespace] = ACTIONS(3984),
    [anon_sym_module] = ACTIONS(3984),
    [anon_sym_EQ] = ACTIONS(3982),
    [anon_sym_open] = ACTIONS(3984),
    [anon_sym_LBRACK_LT] = ACTIONS(3982),
    [anon_sym_COLON] = ACTIONS(3984),
    [anon_sym_return] = ACTIONS(3984),
    [anon_sym_type] = ACTIONS(3984),
    [anon_sym_do] = ACTIONS(3984),
    [anon_sym_let] = ACTIONS(3984),
    [anon_sym_let_BANG] = ACTIONS(3982),
    [anon_sym_LPAREN] = ACTIONS(3984),
    [anon_sym_COMMA] = ACTIONS(3982),
    [anon_sym_null] = ACTIONS(3984),
    [anon_sym_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AMP] = ACTIONS(3984),
    [anon_sym_LBRACK] = ACTIONS(3984),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(3984),
    [anon_sym_LT_AT] = ACTIONS(3984),
    [anon_sym_LT_AT_AT] = ACTIONS(3984),
    [anon_sym_DOT] = ACTIONS(3984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3982),
    [anon_sym_new] = ACTIONS(3984),
    [anon_sym_return_BANG] = ACTIONS(3982),
    [anon_sym_yield] = ACTIONS(3984),
    [anon_sym_yield_BANG] = ACTIONS(3982),
    [anon_sym_lazy] = ACTIONS(3984),
    [anon_sym_assert] = ACTIONS(3984),
    [anon_sym_upcast] = ACTIONS(3984),
    [anon_sym_downcast] = ACTIONS(3984),
    [anon_sym_COLON_GT] = ACTIONS(3982),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3982),
    [anon_sym_for] = ACTIONS(3984),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_if] = ACTIONS(3984),
    [anon_sym_fun] = ACTIONS(3984),
    [anon_sym_try] = ACTIONS(3984),
    [anon_sym_match] = ACTIONS(3984),
    [anon_sym_match_BANG] = ACTIONS(3982),
    [anon_sym_function] = ACTIONS(3984),
    [anon_sym_LT_DASH] = ACTIONS(3984),
    [anon_sym_DOT_LBRACK] = ACTIONS(3982),
    [anon_sym_LT] = ACTIONS(3982),
    [anon_sym_use] = ACTIONS(3984),
    [anon_sym_use_BANG] = ACTIONS(3982),
    [anon_sym_do_BANG] = ACTIONS(3982),
    [anon_sym_begin] = ACTIONS(3984),
    [anon_sym_LPAREN2] = ACTIONS(3984),
    [anon_sym_or] = ACTIONS(3984),
    [anon_sym_exception] = ACTIONS(3984),
    [aux_sym_char_token1] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3984),
    [anon_sym_DQUOTE] = ACTIONS(3984),
    [anon_sym_AT_DQUOTE] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [sym_bool] = ACTIONS(3984),
    [sym_unit] = ACTIONS(3982),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3984),
    [sym_op_identifier] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3984),
    [anon_sym_DASH] = ACTIONS(3984),
    [anon_sym_PLUS_DOT] = ACTIONS(3984),
    [anon_sym_DASH_DOT] = ACTIONS(3984),
    [anon_sym_PERCENT] = ACTIONS(3984),
    [anon_sym_AMP_AMP] = ACTIONS(3984),
    [anon_sym_TILDE] = ACTIONS(3982),
    [aux_sym_prefix_op_token1] = ACTIONS(3984),
    [aux_sym_infix_op_token1] = ACTIONS(3982),
    [aux_sym_infix_op_token2] = ACTIONS(3984),
    [anon_sym_PIPE_PIPE] = ACTIONS(3984),
    [anon_sym_BANG_EQ] = ACTIONS(3984),
    [anon_sym_COLON_EQ] = ACTIONS(3982),
    [anon_sym_DOLLAR] = ACTIONS(3984),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3984),
    [sym_int] = ACTIONS(3984),
    [sym_xint] = ACTIONS(3982),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3982),
    [anon_sym_POUNDload] = ACTIONS(3982),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3982),
    [sym__newline] = ACTIONS(3982),
  },
  [2419] = {
    [sym_block_comment] = STATE(2419),
    [sym_compiler_directive_decl] = STATE(2419),
    [sym_fsi_directive_decl] = STATE(2419),
    [sym_preproc_line] = STATE(2419),
    [ts_builtin_sym_end] = ACTIONS(4168),
    [sym_identifier] = ACTIONS(4170),
    [anon_sym_namespace] = ACTIONS(4170),
    [anon_sym_module] = ACTIONS(4170),
    [anon_sym_EQ] = ACTIONS(4168),
    [anon_sym_open] = ACTIONS(4170),
    [anon_sym_LBRACK_LT] = ACTIONS(4168),
    [anon_sym_COLON] = ACTIONS(4170),
    [anon_sym_return] = ACTIONS(4170),
    [anon_sym_type] = ACTIONS(4170),
    [anon_sym_do] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_let_BANG] = ACTIONS(4168),
    [anon_sym_LPAREN] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4168),
    [anon_sym_null] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_COLON] = ACTIONS(4168),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4170),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4168),
    [anon_sym_LBRACE] = ACTIONS(4170),
    [anon_sym_LT_AT] = ACTIONS(4170),
    [anon_sym_LT_AT_AT] = ACTIONS(4170),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4168),
    [anon_sym_new] = ACTIONS(4170),
    [anon_sym_return_BANG] = ACTIONS(4168),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_yield_BANG] = ACTIONS(4168),
    [anon_sym_lazy] = ACTIONS(4170),
    [anon_sym_assert] = ACTIONS(4170),
    [anon_sym_upcast] = ACTIONS(4170),
    [anon_sym_downcast] = ACTIONS(4170),
    [anon_sym_COLON_GT] = ACTIONS(4168),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4168),
    [anon_sym_for] = ACTIONS(4170),
    [anon_sym_while] = ACTIONS(4170),
    [anon_sym_if] = ACTIONS(4170),
    [anon_sym_fun] = ACTIONS(4170),
    [anon_sym_try] = ACTIONS(4170),
    [anon_sym_match] = ACTIONS(4170),
    [anon_sym_match_BANG] = ACTIONS(4168),
    [anon_sym_function] = ACTIONS(4170),
    [anon_sym_LT_DASH] = ACTIONS(4170),
    [anon_sym_DOT_LBRACK] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4168),
    [anon_sym_use] = ACTIONS(4170),
    [anon_sym_use_BANG] = ACTIONS(4168),
    [anon_sym_do_BANG] = ACTIONS(4168),
    [anon_sym_begin] = ACTIONS(4170),
    [anon_sym_LPAREN2] = ACTIONS(4170),
    [anon_sym_or] = ACTIONS(4170),
    [anon_sym_exception] = ACTIONS(4170),
    [aux_sym_char_token1] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4170),
    [anon_sym_DQUOTE] = ACTIONS(4170),
    [anon_sym_AT_DQUOTE] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [sym_bool] = ACTIONS(4170),
    [sym_unit] = ACTIONS(4168),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4170),
    [sym_op_identifier] = ACTIONS(4170),
    [anon_sym_PLUS] = ACTIONS(4170),
    [anon_sym_DASH] = ACTIONS(4170),
    [anon_sym_PLUS_DOT] = ACTIONS(4170),
    [anon_sym_DASH_DOT] = ACTIONS(4170),
    [anon_sym_PERCENT] = ACTIONS(4170),
    [anon_sym_AMP_AMP] = ACTIONS(4170),
    [anon_sym_TILDE] = ACTIONS(4168),
    [aux_sym_prefix_op_token1] = ACTIONS(4170),
    [aux_sym_infix_op_token1] = ACTIONS(4168),
    [aux_sym_infix_op_token2] = ACTIONS(4170),
    [anon_sym_PIPE_PIPE] = ACTIONS(4170),
    [anon_sym_BANG_EQ] = ACTIONS(4170),
    [anon_sym_COLON_EQ] = ACTIONS(4168),
    [anon_sym_DOLLAR] = ACTIONS(4170),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4170),
    [sym_int] = ACTIONS(4170),
    [sym_xint] = ACTIONS(4168),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4168),
    [anon_sym_POUNDload] = ACTIONS(4168),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4168),
    [sym__newline] = ACTIONS(4168),
  },
  [2420] = {
    [sym_block_comment] = STATE(2420),
    [sym_compiler_directive_decl] = STATE(2420),
    [sym_fsi_directive_decl] = STATE(2420),
    [sym_preproc_line] = STATE(2420),
    [sym_identifier] = ACTIONS(3543),
    [anon_sym_EQ] = ACTIONS(3541),
    [anon_sym_COLON] = ACTIONS(3543),
    [anon_sym_return] = ACTIONS(3543),
    [anon_sym_do] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3543),
    [anon_sym_let_BANG] = ACTIONS(3541),
    [anon_sym_as] = ACTIONS(3543),
    [anon_sym_LPAREN] = ACTIONS(3543),
    [anon_sym_COMMA] = ACTIONS(3541),
    [anon_sym_null] = ACTIONS(3543),
    [anon_sym_QMARK] = ACTIONS(3543),
    [anon_sym_COLON_QMARK] = ACTIONS(3543),
    [anon_sym_COLON_COLON] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3543),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3541),
    [anon_sym_LBRACE] = ACTIONS(3543),
    [anon_sym_LT_AT] = ACTIONS(3543),
    [anon_sym_LT_AT_AT] = ACTIONS(3543),
    [anon_sym_DOT] = ACTIONS(3543),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3541),
    [anon_sym_new] = ACTIONS(3543),
    [anon_sym_with] = ACTIONS(3543),
    [anon_sym_return_BANG] = ACTIONS(3541),
    [anon_sym_yield] = ACTIONS(3543),
    [anon_sym_yield_BANG] = ACTIONS(3541),
    [anon_sym_lazy] = ACTIONS(3543),
    [anon_sym_assert] = ACTIONS(3543),
    [anon_sym_upcast] = ACTIONS(3543),
    [anon_sym_downcast] = ACTIONS(3543),
    [anon_sym_COLON_GT] = ACTIONS(3541),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3541),
    [anon_sym_for] = ACTIONS(3543),
    [anon_sym_while] = ACTIONS(3543),
    [anon_sym_if] = ACTIONS(3543),
    [anon_sym_fun] = ACTIONS(3543),
    [anon_sym_DASH_GT] = ACTIONS(3543),
    [anon_sym_try] = ACTIONS(3543),
    [anon_sym_match] = ACTIONS(3543),
    [anon_sym_match_BANG] = ACTIONS(3541),
    [anon_sym_function] = ACTIONS(3543),
    [anon_sym_LT_DASH] = ACTIONS(3543),
    [anon_sym_DOT_LBRACK] = ACTIONS(3541),
    [anon_sym_LT] = ACTIONS(3541),
    [anon_sym_use] = ACTIONS(3543),
    [anon_sym_use_BANG] = ACTIONS(3541),
    [anon_sym_do_BANG] = ACTIONS(3541),
    [anon_sym_begin] = ACTIONS(3543),
    [anon_sym_LPAREN2] = ACTIONS(3543),
    [anon_sym_STAR] = ACTIONS(3543),
    [anon_sym_LT2] = ACTIONS(3543),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_or] = ACTIONS(3543),
    [aux_sym_char_token1] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3543),
    [anon_sym_DQUOTE] = ACTIONS(3543),
    [anon_sym_AT_DQUOTE] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [sym_bool] = ACTIONS(3543),
    [sym_unit] = ACTIONS(3541),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3543),
    [sym_op_identifier] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(3543),
    [anon_sym_DASH] = ACTIONS(3543),
    [anon_sym_PLUS_DOT] = ACTIONS(3543),
    [anon_sym_DASH_DOT] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3543),
    [anon_sym_AMP_AMP] = ACTIONS(3543),
    [anon_sym_TILDE] = ACTIONS(3541),
    [aux_sym_prefix_op_token1] = ACTIONS(3543),
    [aux_sym_infix_op_token1] = ACTIONS(3541),
    [aux_sym_infix_op_token2] = ACTIONS(3543),
    [anon_sym_PIPE_PIPE] = ACTIONS(3543),
    [anon_sym_BANG_EQ] = ACTIONS(3543),
    [anon_sym_COLON_EQ] = ACTIONS(3541),
    [anon_sym_DOLLAR] = ACTIONS(3543),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3543),
    [sym_int] = ACTIONS(3543),
    [sym_xint] = ACTIONS(3541),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3541),
    [sym__newline] = ACTIONS(3541),
    [sym__dedent] = ACTIONS(3541),
  },
  [2421] = {
    [sym_block_comment] = STATE(2421),
    [sym_compiler_directive_decl] = STATE(2421),
    [sym_fsi_directive_decl] = STATE(2421),
    [sym_preproc_line] = STATE(2421),
    [ts_builtin_sym_end] = ACTIONS(3952),
    [sym_identifier] = ACTIONS(3954),
    [anon_sym_namespace] = ACTIONS(3954),
    [anon_sym_module] = ACTIONS(3954),
    [anon_sym_EQ] = ACTIONS(3952),
    [anon_sym_open] = ACTIONS(3954),
    [anon_sym_LBRACK_LT] = ACTIONS(3952),
    [anon_sym_COLON] = ACTIONS(3954),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_type] = ACTIONS(3954),
    [anon_sym_do] = ACTIONS(3954),
    [anon_sym_let] = ACTIONS(3954),
    [anon_sym_let_BANG] = ACTIONS(3952),
    [anon_sym_LPAREN] = ACTIONS(3954),
    [anon_sym_COMMA] = ACTIONS(3952),
    [anon_sym_null] = ACTIONS(3954),
    [anon_sym_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_COLON] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3954),
    [anon_sym_LBRACK] = ACTIONS(3954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(3954),
    [anon_sym_LT_AT] = ACTIONS(3954),
    [anon_sym_LT_AT_AT] = ACTIONS(3954),
    [anon_sym_DOT] = ACTIONS(3954),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3952),
    [anon_sym_new] = ACTIONS(3954),
    [anon_sym_return_BANG] = ACTIONS(3952),
    [anon_sym_yield] = ACTIONS(3954),
    [anon_sym_yield_BANG] = ACTIONS(3952),
    [anon_sym_lazy] = ACTIONS(3954),
    [anon_sym_assert] = ACTIONS(3954),
    [anon_sym_upcast] = ACTIONS(3954),
    [anon_sym_downcast] = ACTIONS(3954),
    [anon_sym_COLON_GT] = ACTIONS(3952),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3952),
    [anon_sym_for] = ACTIONS(3954),
    [anon_sym_while] = ACTIONS(3954),
    [anon_sym_if] = ACTIONS(3954),
    [anon_sym_fun] = ACTIONS(3954),
    [anon_sym_try] = ACTIONS(3954),
    [anon_sym_match] = ACTIONS(3954),
    [anon_sym_match_BANG] = ACTIONS(3952),
    [anon_sym_function] = ACTIONS(3954),
    [anon_sym_LT_DASH] = ACTIONS(3954),
    [anon_sym_DOT_LBRACK] = ACTIONS(3952),
    [anon_sym_LT] = ACTIONS(3952),
    [anon_sym_use] = ACTIONS(3954),
    [anon_sym_use_BANG] = ACTIONS(3952),
    [anon_sym_do_BANG] = ACTIONS(3952),
    [anon_sym_begin] = ACTIONS(3954),
    [anon_sym_LPAREN2] = ACTIONS(3954),
    [anon_sym_or] = ACTIONS(3954),
    [anon_sym_exception] = ACTIONS(3954),
    [aux_sym_char_token1] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3954),
    [anon_sym_DQUOTE] = ACTIONS(3954),
    [anon_sym_AT_DQUOTE] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [sym_bool] = ACTIONS(3954),
    [sym_unit] = ACTIONS(3952),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3954),
    [sym_op_identifier] = ACTIONS(3954),
    [anon_sym_PLUS] = ACTIONS(3954),
    [anon_sym_DASH] = ACTIONS(3954),
    [anon_sym_PLUS_DOT] = ACTIONS(3954),
    [anon_sym_DASH_DOT] = ACTIONS(3954),
    [anon_sym_PERCENT] = ACTIONS(3954),
    [anon_sym_AMP_AMP] = ACTIONS(3954),
    [anon_sym_TILDE] = ACTIONS(3952),
    [aux_sym_prefix_op_token1] = ACTIONS(3954),
    [aux_sym_infix_op_token1] = ACTIONS(3952),
    [aux_sym_infix_op_token2] = ACTIONS(3954),
    [anon_sym_PIPE_PIPE] = ACTIONS(3954),
    [anon_sym_BANG_EQ] = ACTIONS(3954),
    [anon_sym_COLON_EQ] = ACTIONS(3952),
    [anon_sym_DOLLAR] = ACTIONS(3954),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3954),
    [sym_int] = ACTIONS(3954),
    [sym_xint] = ACTIONS(3952),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3952),
    [anon_sym_POUNDload] = ACTIONS(3952),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3952),
    [sym__newline] = ACTIONS(3952),
  },
  [2422] = {
    [sym_block_comment] = STATE(2422),
    [sym_compiler_directive_decl] = STATE(2422),
    [sym_fsi_directive_decl] = STATE(2422),
    [sym_preproc_line] = STATE(2422),
    [sym_identifier] = ACTIONS(3547),
    [anon_sym_EQ] = ACTIONS(3545),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_return] = ACTIONS(3547),
    [anon_sym_do] = ACTIONS(3547),
    [anon_sym_let] = ACTIONS(3547),
    [anon_sym_let_BANG] = ACTIONS(3545),
    [anon_sym_as] = ACTIONS(3547),
    [anon_sym_LPAREN] = ACTIONS(3547),
    [anon_sym_COMMA] = ACTIONS(3545),
    [anon_sym_null] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3547),
    [anon_sym_COLON_QMARK] = ACTIONS(3547),
    [anon_sym_COLON_COLON] = ACTIONS(3545),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3545),
    [anon_sym_LBRACE] = ACTIONS(3547),
    [anon_sym_LT_AT] = ACTIONS(3547),
    [anon_sym_LT_AT_AT] = ACTIONS(3547),
    [anon_sym_DOT] = ACTIONS(3547),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3545),
    [anon_sym_new] = ACTIONS(3547),
    [anon_sym_with] = ACTIONS(3547),
    [anon_sym_return_BANG] = ACTIONS(3545),
    [anon_sym_yield] = ACTIONS(3547),
    [anon_sym_yield_BANG] = ACTIONS(3545),
    [anon_sym_lazy] = ACTIONS(3547),
    [anon_sym_assert] = ACTIONS(3547),
    [anon_sym_upcast] = ACTIONS(3547),
    [anon_sym_downcast] = ACTIONS(3547),
    [anon_sym_COLON_GT] = ACTIONS(3545),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3545),
    [anon_sym_for] = ACTIONS(3547),
    [anon_sym_while] = ACTIONS(3547),
    [anon_sym_if] = ACTIONS(3547),
    [anon_sym_fun] = ACTIONS(3547),
    [anon_sym_DASH_GT] = ACTIONS(3547),
    [anon_sym_try] = ACTIONS(3547),
    [anon_sym_match] = ACTIONS(3547),
    [anon_sym_match_BANG] = ACTIONS(3545),
    [anon_sym_function] = ACTIONS(3547),
    [anon_sym_LT_DASH] = ACTIONS(3547),
    [anon_sym_DOT_LBRACK] = ACTIONS(3545),
    [anon_sym_LT] = ACTIONS(3545),
    [anon_sym_use] = ACTIONS(3547),
    [anon_sym_use_BANG] = ACTIONS(3545),
    [anon_sym_do_BANG] = ACTIONS(3545),
    [anon_sym_begin] = ACTIONS(3547),
    [anon_sym_LPAREN2] = ACTIONS(3547),
    [anon_sym_STAR] = ACTIONS(3547),
    [anon_sym_LT2] = ACTIONS(3547),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_or] = ACTIONS(3547),
    [aux_sym_char_token1] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3547),
    [anon_sym_DQUOTE] = ACTIONS(3547),
    [anon_sym_AT_DQUOTE] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [sym_bool] = ACTIONS(3547),
    [sym_unit] = ACTIONS(3545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3547),
    [sym_op_identifier] = ACTIONS(3547),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PLUS_DOT] = ACTIONS(3547),
    [anon_sym_DASH_DOT] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3547),
    [anon_sym_AMP_AMP] = ACTIONS(3547),
    [anon_sym_TILDE] = ACTIONS(3545),
    [aux_sym_prefix_op_token1] = ACTIONS(3547),
    [aux_sym_infix_op_token1] = ACTIONS(3545),
    [aux_sym_infix_op_token2] = ACTIONS(3547),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_BANG_EQ] = ACTIONS(3547),
    [anon_sym_COLON_EQ] = ACTIONS(3545),
    [anon_sym_DOLLAR] = ACTIONS(3547),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3547),
    [sym_int] = ACTIONS(3547),
    [sym_xint] = ACTIONS(3545),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3545),
    [sym__newline] = ACTIONS(3545),
    [sym__dedent] = ACTIONS(3545),
  },
  [2423] = {
    [sym_block_comment] = STATE(2423),
    [sym_compiler_directive_decl] = STATE(2423),
    [sym_fsi_directive_decl] = STATE(2423),
    [sym_preproc_line] = STATE(2423),
    [sym_identifier] = ACTIONS(4174),
    [anon_sym_EQ] = ACTIONS(4172),
    [anon_sym_GT_RBRACK] = ACTIONS(4172),
    [anon_sym_COLON] = ACTIONS(4174),
    [anon_sym_return] = ACTIONS(4174),
    [anon_sym_do] = ACTIONS(4174),
    [anon_sym_let] = ACTIONS(4174),
    [anon_sym_let_BANG] = ACTIONS(4172),
    [anon_sym_LPAREN] = ACTIONS(4174),
    [anon_sym_COMMA] = ACTIONS(4172),
    [anon_sym_null] = ACTIONS(4174),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_COLON] = ACTIONS(4172),
    [anon_sym_AMP] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4174),
    [anon_sym_RBRACK] = ACTIONS(4172),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4172),
    [anon_sym_LBRACE] = ACTIONS(4174),
    [anon_sym_RBRACE] = ACTIONS(4172),
    [anon_sym_LT_AT] = ACTIONS(4174),
    [anon_sym_LT_AT_AT] = ACTIONS(4174),
    [anon_sym_DOT] = ACTIONS(4174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4172),
    [anon_sym_new] = ACTIONS(4174),
    [anon_sym_with] = ACTIONS(4174),
    [anon_sym_return_BANG] = ACTIONS(4172),
    [anon_sym_yield] = ACTIONS(4174),
    [anon_sym_yield_BANG] = ACTIONS(4172),
    [anon_sym_lazy] = ACTIONS(4174),
    [anon_sym_assert] = ACTIONS(4174),
    [anon_sym_upcast] = ACTIONS(4174),
    [anon_sym_downcast] = ACTIONS(4174),
    [anon_sym_COLON_GT] = ACTIONS(4172),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4172),
    [anon_sym_for] = ACTIONS(4174),
    [anon_sym_to] = ACTIONS(4174),
    [anon_sym_downto] = ACTIONS(4174),
    [anon_sym_while] = ACTIONS(4174),
    [anon_sym_if] = ACTIONS(4174),
    [anon_sym_fun] = ACTIONS(4174),
    [anon_sym_try] = ACTIONS(4174),
    [anon_sym_match] = ACTIONS(4174),
    [anon_sym_match_BANG] = ACTIONS(4172),
    [anon_sym_function] = ACTIONS(4174),
    [anon_sym_LT_DASH] = ACTIONS(4174),
    [anon_sym_DOT_LBRACK] = ACTIONS(4172),
    [anon_sym_LT] = ACTIONS(4172),
    [anon_sym_use] = ACTIONS(4174),
    [anon_sym_use_BANG] = ACTIONS(4172),
    [anon_sym_do_BANG] = ACTIONS(4172),
    [anon_sym_begin] = ACTIONS(4174),
    [anon_sym_LPAREN2] = ACTIONS(4174),
    [anon_sym_DOT_DOT2] = ACTIONS(4172),
    [anon_sym_or] = ACTIONS(4174),
    [aux_sym_char_token1] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4174),
    [anon_sym_DQUOTE] = ACTIONS(4174),
    [anon_sym_AT_DQUOTE] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [sym_bool] = ACTIONS(4174),
    [sym_unit] = ACTIONS(4172),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4174),
    [sym_op_identifier] = ACTIONS(4174),
    [anon_sym_PLUS] = ACTIONS(4174),
    [anon_sym_DASH] = ACTIONS(4174),
    [anon_sym_PLUS_DOT] = ACTIONS(4174),
    [anon_sym_DASH_DOT] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [anon_sym_AMP_AMP] = ACTIONS(4174),
    [anon_sym_TILDE] = ACTIONS(4172),
    [aux_sym_prefix_op_token1] = ACTIONS(4174),
    [aux_sym_infix_op_token1] = ACTIONS(4172),
    [aux_sym_infix_op_token2] = ACTIONS(4174),
    [anon_sym_PIPE_PIPE] = ACTIONS(4174),
    [anon_sym_BANG_EQ] = ACTIONS(4174),
    [anon_sym_COLON_EQ] = ACTIONS(4172),
    [anon_sym_DOLLAR] = ACTIONS(4174),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4174),
    [sym_int] = ACTIONS(4174),
    [sym_xint] = ACTIONS(4172),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4172),
    [sym__newline] = ACTIONS(4172),
  },
  [2424] = {
    [sym_block_comment] = STATE(2424),
    [sym_compiler_directive_decl] = STATE(2424),
    [sym_fsi_directive_decl] = STATE(2424),
    [sym_preproc_line] = STATE(2424),
    [sym_identifier] = ACTIONS(4180),
    [anon_sym_EQ] = ACTIONS(4178),
    [anon_sym_GT_RBRACK] = ACTIONS(4178),
    [anon_sym_COLON] = ACTIONS(4180),
    [anon_sym_return] = ACTIONS(4180),
    [anon_sym_do] = ACTIONS(4180),
    [anon_sym_let] = ACTIONS(4180),
    [anon_sym_let_BANG] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(4180),
    [anon_sym_COMMA] = ACTIONS(4178),
    [anon_sym_null] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_COLON] = ACTIONS(4178),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4180),
    [anon_sym_RBRACK] = ACTIONS(4178),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4180),
    [anon_sym_RBRACE] = ACTIONS(4178),
    [anon_sym_LT_AT] = ACTIONS(4180),
    [anon_sym_LT_AT_AT] = ACTIONS(4180),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4178),
    [anon_sym_new] = ACTIONS(4180),
    [anon_sym_with] = ACTIONS(4180),
    [anon_sym_return_BANG] = ACTIONS(4178),
    [anon_sym_yield] = ACTIONS(4180),
    [anon_sym_yield_BANG] = ACTIONS(4178),
    [anon_sym_lazy] = ACTIONS(4180),
    [anon_sym_assert] = ACTIONS(4180),
    [anon_sym_upcast] = ACTIONS(4180),
    [anon_sym_downcast] = ACTIONS(4180),
    [anon_sym_COLON_GT] = ACTIONS(4178),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4178),
    [anon_sym_for] = ACTIONS(4180),
    [anon_sym_to] = ACTIONS(4180),
    [anon_sym_downto] = ACTIONS(4180),
    [anon_sym_while] = ACTIONS(4180),
    [anon_sym_if] = ACTIONS(4180),
    [anon_sym_fun] = ACTIONS(4180),
    [anon_sym_try] = ACTIONS(4180),
    [anon_sym_match] = ACTIONS(4180),
    [anon_sym_match_BANG] = ACTIONS(4178),
    [anon_sym_function] = ACTIONS(4180),
    [anon_sym_LT_DASH] = ACTIONS(4180),
    [anon_sym_DOT_LBRACK] = ACTIONS(4178),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_use] = ACTIONS(4180),
    [anon_sym_use_BANG] = ACTIONS(4178),
    [anon_sym_do_BANG] = ACTIONS(4178),
    [anon_sym_begin] = ACTIONS(4180),
    [anon_sym_LPAREN2] = ACTIONS(4180),
    [anon_sym_DOT_DOT2] = ACTIONS(4178),
    [anon_sym_or] = ACTIONS(4180),
    [aux_sym_char_token1] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4180),
    [anon_sym_DQUOTE] = ACTIONS(4180),
    [anon_sym_AT_DQUOTE] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [sym_bool] = ACTIONS(4180),
    [sym_unit] = ACTIONS(4178),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4180),
    [sym_op_identifier] = ACTIONS(4180),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_PLUS_DOT] = ACTIONS(4180),
    [anon_sym_DASH_DOT] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_TILDE] = ACTIONS(4178),
    [aux_sym_prefix_op_token1] = ACTIONS(4180),
    [aux_sym_infix_op_token1] = ACTIONS(4178),
    [aux_sym_infix_op_token2] = ACTIONS(4180),
    [anon_sym_PIPE_PIPE] = ACTIONS(4180),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_COLON_EQ] = ACTIONS(4178),
    [anon_sym_DOLLAR] = ACTIONS(4180),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4180),
    [sym_int] = ACTIONS(4180),
    [sym_xint] = ACTIONS(4178),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4178),
    [sym__newline] = ACTIONS(4178),
  },
  [2425] = {
    [sym_block_comment] = STATE(2425),
    [sym_compiler_directive_decl] = STATE(2425),
    [sym_fsi_directive_decl] = STATE(2425),
    [sym_preproc_line] = STATE(2425),
    [ts_builtin_sym_end] = ACTIONS(3978),
    [sym_identifier] = ACTIONS(3980),
    [anon_sym_namespace] = ACTIONS(3980),
    [anon_sym_module] = ACTIONS(3980),
    [anon_sym_EQ] = ACTIONS(3978),
    [anon_sym_open] = ACTIONS(3980),
    [anon_sym_LBRACK_LT] = ACTIONS(3978),
    [anon_sym_COLON] = ACTIONS(3980),
    [anon_sym_return] = ACTIONS(3980),
    [anon_sym_type] = ACTIONS(3980),
    [anon_sym_do] = ACTIONS(3980),
    [anon_sym_let] = ACTIONS(3980),
    [anon_sym_let_BANG] = ACTIONS(3978),
    [anon_sym_LPAREN] = ACTIONS(3980),
    [anon_sym_COMMA] = ACTIONS(3978),
    [anon_sym_null] = ACTIONS(3980),
    [anon_sym_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3978),
    [anon_sym_AMP] = ACTIONS(3980),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3978),
    [anon_sym_LBRACE] = ACTIONS(3980),
    [anon_sym_LT_AT] = ACTIONS(3980),
    [anon_sym_LT_AT_AT] = ACTIONS(3980),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3978),
    [anon_sym_new] = ACTIONS(3980),
    [anon_sym_return_BANG] = ACTIONS(3978),
    [anon_sym_yield] = ACTIONS(3980),
    [anon_sym_yield_BANG] = ACTIONS(3978),
    [anon_sym_lazy] = ACTIONS(3980),
    [anon_sym_assert] = ACTIONS(3980),
    [anon_sym_upcast] = ACTIONS(3980),
    [anon_sym_downcast] = ACTIONS(3980),
    [anon_sym_COLON_GT] = ACTIONS(3978),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3978),
    [anon_sym_for] = ACTIONS(3980),
    [anon_sym_while] = ACTIONS(3980),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_fun] = ACTIONS(3980),
    [anon_sym_try] = ACTIONS(3980),
    [anon_sym_match] = ACTIONS(3980),
    [anon_sym_match_BANG] = ACTIONS(3978),
    [anon_sym_function] = ACTIONS(3980),
    [anon_sym_LT_DASH] = ACTIONS(3980),
    [anon_sym_DOT_LBRACK] = ACTIONS(3978),
    [anon_sym_LT] = ACTIONS(3978),
    [anon_sym_use] = ACTIONS(3980),
    [anon_sym_use_BANG] = ACTIONS(3978),
    [anon_sym_do_BANG] = ACTIONS(3978),
    [anon_sym_begin] = ACTIONS(3980),
    [anon_sym_LPAREN2] = ACTIONS(3980),
    [anon_sym_or] = ACTIONS(3980),
    [anon_sym_exception] = ACTIONS(3980),
    [aux_sym_char_token1] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3980),
    [anon_sym_DQUOTE] = ACTIONS(3980),
    [anon_sym_AT_DQUOTE] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [sym_bool] = ACTIONS(3980),
    [sym_unit] = ACTIONS(3978),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3980),
    [sym_op_identifier] = ACTIONS(3980),
    [anon_sym_PLUS] = ACTIONS(3980),
    [anon_sym_DASH] = ACTIONS(3980),
    [anon_sym_PLUS_DOT] = ACTIONS(3980),
    [anon_sym_DASH_DOT] = ACTIONS(3980),
    [anon_sym_PERCENT] = ACTIONS(3980),
    [anon_sym_AMP_AMP] = ACTIONS(3980),
    [anon_sym_TILDE] = ACTIONS(3978),
    [aux_sym_prefix_op_token1] = ACTIONS(3980),
    [aux_sym_infix_op_token1] = ACTIONS(3978),
    [aux_sym_infix_op_token2] = ACTIONS(3980),
    [anon_sym_PIPE_PIPE] = ACTIONS(3980),
    [anon_sym_BANG_EQ] = ACTIONS(3980),
    [anon_sym_COLON_EQ] = ACTIONS(3978),
    [anon_sym_DOLLAR] = ACTIONS(3980),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3980),
    [sym_int] = ACTIONS(3980),
    [sym_xint] = ACTIONS(3978),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3978),
    [anon_sym_POUNDload] = ACTIONS(3978),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3978),
    [sym__newline] = ACTIONS(3978),
  },
  [2426] = {
    [sym_block_comment] = STATE(2426),
    [sym_compiler_directive_decl] = STATE(2426),
    [sym_fsi_directive_decl] = STATE(2426),
    [sym_preproc_line] = STATE(2426),
    [aux_sym_compound_type_repeat1] = STATE(2426),
    [sym_identifier] = ACTIONS(3427),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [anon_sym_as] = ACTIONS(3427),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3427),
    [anon_sym_DOT] = ACTIONS(3427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_with] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_COLON_GT] = ACTIONS(3425),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(3427),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_LT_DASH] = ACTIONS(3427),
    [anon_sym_DOT_LBRACK] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(4960),
    [anon_sym_LT2] = ACTIONS(3427),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3425),
    [anon_sym_or] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3427),
    [anon_sym_DASH_DOT] = ACTIONS(3427),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3427),
    [aux_sym_infix_op_token1] = ACTIONS(3425),
    [aux_sym_infix_op_token2] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3427),
    [anon_sym_COLON_EQ] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3427),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
  },
  [2427] = {
    [sym_block_comment] = STATE(2427),
    [sym_compiler_directive_decl] = STATE(2427),
    [sym_fsi_directive_decl] = STATE(2427),
    [sym_preproc_line] = STATE(2427),
    [aux_sym_sequential_expression_repeat1] = STATE(2427),
    [sym_identifier] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3765),
    [anon_sym_GT_RBRACK] = ACTIONS(3765),
    [anon_sym_COLON] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_let_BANG] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(3767),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_null] = ACTIONS(3767),
    [anon_sym_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_RBRACK] = ACTIONS(3765),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3765),
    [anon_sym_LBRACE] = ACTIONS(3767),
    [anon_sym_RBRACE] = ACTIONS(3765),
    [anon_sym_LT_AT] = ACTIONS(3767),
    [anon_sym_LT_AT_AT] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3765),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_with] = ACTIONS(3767),
    [anon_sym_return_BANG] = ACTIONS(3765),
    [anon_sym_yield] = ACTIONS(3767),
    [anon_sym_yield_BANG] = ACTIONS(3765),
    [anon_sym_lazy] = ACTIONS(3767),
    [anon_sym_assert] = ACTIONS(3767),
    [anon_sym_upcast] = ACTIONS(3767),
    [anon_sym_downcast] = ACTIONS(3767),
    [anon_sym_COLON_GT] = ACTIONS(3765),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3765),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_to] = ACTIONS(3767),
    [anon_sym_downto] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_fun] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_match] = ACTIONS(3767),
    [anon_sym_match_BANG] = ACTIONS(3765),
    [anon_sym_function] = ACTIONS(3767),
    [anon_sym_LT_DASH] = ACTIONS(3767),
    [anon_sym_DOT_LBRACK] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(3765),
    [anon_sym_use] = ACTIONS(3767),
    [anon_sym_use_BANG] = ACTIONS(3765),
    [anon_sym_do_BANG] = ACTIONS(3765),
    [anon_sym_begin] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3767),
    [anon_sym_or] = ACTIONS(3767),
    [aux_sym_char_token1] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3767),
    [anon_sym_DQUOTE] = ACTIONS(3767),
    [anon_sym_AT_DQUOTE] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [sym_bool] = ACTIONS(3767),
    [sym_unit] = ACTIONS(3765),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3767),
    [sym_op_identifier] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_PLUS_DOT] = ACTIONS(3767),
    [anon_sym_DASH_DOT] = ACTIONS(3767),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_AMP_AMP] = ACTIONS(3767),
    [anon_sym_TILDE] = ACTIONS(3765),
    [aux_sym_prefix_op_token1] = ACTIONS(3767),
    [aux_sym_infix_op_token1] = ACTIONS(3765),
    [aux_sym_infix_op_token2] = ACTIONS(3767),
    [anon_sym_PIPE_PIPE] = ACTIONS(3767),
    [anon_sym_BANG_EQ] = ACTIONS(3767),
    [anon_sym_COLON_EQ] = ACTIONS(3765),
    [anon_sym_DOLLAR] = ACTIONS(3767),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3767),
    [sym_int] = ACTIONS(3767),
    [sym_xint] = ACTIONS(3765),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3765),
    [sym__newline] = ACTIONS(4963),
  },
  [2428] = {
    [sym_block_comment] = STATE(2428),
    [sym_compiler_directive_decl] = STATE(2428),
    [sym_fsi_directive_decl] = STATE(2428),
    [sym_preproc_line] = STATE(2428),
    [sym_identifier] = ACTIONS(4212),
    [anon_sym_EQ] = ACTIONS(4210),
    [anon_sym_GT_RBRACK] = ACTIONS(4210),
    [anon_sym_COLON] = ACTIONS(4212),
    [anon_sym_return] = ACTIONS(4212),
    [anon_sym_do] = ACTIONS(4212),
    [anon_sym_let] = ACTIONS(4212),
    [anon_sym_let_BANG] = ACTIONS(4210),
    [anon_sym_LPAREN] = ACTIONS(4212),
    [anon_sym_COMMA] = ACTIONS(4210),
    [anon_sym_null] = ACTIONS(4212),
    [anon_sym_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_COLON] = ACTIONS(4210),
    [anon_sym_AMP] = ACTIONS(4212),
    [anon_sym_LBRACK] = ACTIONS(4212),
    [anon_sym_RBRACK] = ACTIONS(4210),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4210),
    [anon_sym_LBRACE] = ACTIONS(4212),
    [anon_sym_RBRACE] = ACTIONS(4210),
    [anon_sym_LT_AT] = ACTIONS(4212),
    [anon_sym_LT_AT_AT] = ACTIONS(4212),
    [anon_sym_DOT] = ACTIONS(4212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4210),
    [anon_sym_new] = ACTIONS(4212),
    [anon_sym_with] = ACTIONS(4212),
    [anon_sym_return_BANG] = ACTIONS(4210),
    [anon_sym_yield] = ACTIONS(4212),
    [anon_sym_yield_BANG] = ACTIONS(4210),
    [anon_sym_lazy] = ACTIONS(4212),
    [anon_sym_assert] = ACTIONS(4212),
    [anon_sym_upcast] = ACTIONS(4212),
    [anon_sym_downcast] = ACTIONS(4212),
    [anon_sym_COLON_GT] = ACTIONS(4210),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4210),
    [anon_sym_for] = ACTIONS(4212),
    [anon_sym_to] = ACTIONS(4212),
    [anon_sym_downto] = ACTIONS(4212),
    [anon_sym_while] = ACTIONS(4212),
    [anon_sym_if] = ACTIONS(4212),
    [anon_sym_fun] = ACTIONS(4212),
    [anon_sym_try] = ACTIONS(4212),
    [anon_sym_match] = ACTIONS(4212),
    [anon_sym_match_BANG] = ACTIONS(4210),
    [anon_sym_function] = ACTIONS(4212),
    [anon_sym_LT_DASH] = ACTIONS(4212),
    [anon_sym_DOT_LBRACK] = ACTIONS(4210),
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_use] = ACTIONS(4212),
    [anon_sym_use_BANG] = ACTIONS(4210),
    [anon_sym_do_BANG] = ACTIONS(4210),
    [anon_sym_begin] = ACTIONS(4212),
    [anon_sym_LPAREN2] = ACTIONS(4212),
    [anon_sym_DOT_DOT2] = ACTIONS(4210),
    [anon_sym_or] = ACTIONS(4212),
    [aux_sym_char_token1] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4212),
    [anon_sym_DQUOTE] = ACTIONS(4212),
    [anon_sym_AT_DQUOTE] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [sym_bool] = ACTIONS(4212),
    [sym_unit] = ACTIONS(4210),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4212),
    [anon_sym_DASH] = ACTIONS(4212),
    [anon_sym_PLUS_DOT] = ACTIONS(4212),
    [anon_sym_DASH_DOT] = ACTIONS(4212),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_AMP_AMP] = ACTIONS(4212),
    [anon_sym_TILDE] = ACTIONS(4210),
    [aux_sym_prefix_op_token1] = ACTIONS(4212),
    [aux_sym_infix_op_token1] = ACTIONS(4210),
    [aux_sym_infix_op_token2] = ACTIONS(4212),
    [anon_sym_PIPE_PIPE] = ACTIONS(4212),
    [anon_sym_BANG_EQ] = ACTIONS(4212),
    [anon_sym_COLON_EQ] = ACTIONS(4210),
    [anon_sym_DOLLAR] = ACTIONS(4212),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4212),
    [sym_int] = ACTIONS(4212),
    [sym_xint] = ACTIONS(4210),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4210),
    [sym__newline] = ACTIONS(4210),
  },
  [2429] = {
    [sym_block_comment] = STATE(2429),
    [sym_compiler_directive_decl] = STATE(2429),
    [sym_fsi_directive_decl] = STATE(2429),
    [sym_preproc_line] = STATE(2429),
    [sym_identifier] = ACTIONS(3958),
    [anon_sym_EQ] = ACTIONS(3956),
    [anon_sym_GT_RBRACK] = ACTIONS(3956),
    [anon_sym_COLON] = ACTIONS(3958),
    [anon_sym_return] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(3958),
    [anon_sym_let] = ACTIONS(3958),
    [anon_sym_let_BANG] = ACTIONS(3956),
    [anon_sym_LPAREN] = ACTIONS(3958),
    [anon_sym_COMMA] = ACTIONS(3956),
    [anon_sym_null] = ACTIONS(3958),
    [anon_sym_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_COLON] = ACTIONS(3956),
    [anon_sym_AMP] = ACTIONS(3958),
    [anon_sym_LBRACK] = ACTIONS(3958),
    [anon_sym_RBRACK] = ACTIONS(3956),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3956),
    [anon_sym_LBRACE] = ACTIONS(3958),
    [anon_sym_RBRACE] = ACTIONS(3956),
    [anon_sym_LT_AT] = ACTIONS(3958),
    [anon_sym_LT_AT_AT] = ACTIONS(3958),
    [anon_sym_DOT] = ACTIONS(3958),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3956),
    [anon_sym_new] = ACTIONS(3958),
    [anon_sym_with] = ACTIONS(3958),
    [anon_sym_return_BANG] = ACTIONS(3956),
    [anon_sym_yield] = ACTIONS(3958),
    [anon_sym_yield_BANG] = ACTIONS(3956),
    [anon_sym_lazy] = ACTIONS(3958),
    [anon_sym_assert] = ACTIONS(3958),
    [anon_sym_upcast] = ACTIONS(3958),
    [anon_sym_downcast] = ACTIONS(3958),
    [anon_sym_COLON_GT] = ACTIONS(3956),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3956),
    [anon_sym_for] = ACTIONS(3958),
    [anon_sym_to] = ACTIONS(3958),
    [anon_sym_downto] = ACTIONS(3958),
    [anon_sym_while] = ACTIONS(3958),
    [anon_sym_if] = ACTIONS(3958),
    [anon_sym_fun] = ACTIONS(3958),
    [anon_sym_try] = ACTIONS(3958),
    [anon_sym_match] = ACTIONS(3958),
    [anon_sym_match_BANG] = ACTIONS(3956),
    [anon_sym_function] = ACTIONS(3958),
    [anon_sym_LT_DASH] = ACTIONS(3958),
    [anon_sym_DOT_LBRACK] = ACTIONS(3956),
    [anon_sym_LT] = ACTIONS(3956),
    [anon_sym_use] = ACTIONS(3958),
    [anon_sym_use_BANG] = ACTIONS(3956),
    [anon_sym_do_BANG] = ACTIONS(3956),
    [anon_sym_begin] = ACTIONS(3958),
    [anon_sym_LPAREN2] = ACTIONS(3958),
    [anon_sym_DOT_DOT2] = ACTIONS(3956),
    [anon_sym_or] = ACTIONS(3958),
    [aux_sym_char_token1] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [anon_sym_AT_DQUOTE] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [sym_bool] = ACTIONS(3958),
    [sym_unit] = ACTIONS(3956),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3958),
    [sym_op_identifier] = ACTIONS(3958),
    [anon_sym_PLUS] = ACTIONS(3958),
    [anon_sym_DASH] = ACTIONS(3958),
    [anon_sym_PLUS_DOT] = ACTIONS(3958),
    [anon_sym_DASH_DOT] = ACTIONS(3958),
    [anon_sym_PERCENT] = ACTIONS(3958),
    [anon_sym_AMP_AMP] = ACTIONS(3958),
    [anon_sym_TILDE] = ACTIONS(3956),
    [aux_sym_prefix_op_token1] = ACTIONS(3958),
    [aux_sym_infix_op_token1] = ACTIONS(3956),
    [aux_sym_infix_op_token2] = ACTIONS(3958),
    [anon_sym_PIPE_PIPE] = ACTIONS(3958),
    [anon_sym_BANG_EQ] = ACTIONS(3958),
    [anon_sym_COLON_EQ] = ACTIONS(3956),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3958),
    [sym_int] = ACTIONS(3958),
    [sym_xint] = ACTIONS(3956),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3956),
    [sym__newline] = ACTIONS(3956),
  },
  [2430] = {
    [sym_block_comment] = STATE(2430),
    [sym_compiler_directive_decl] = STATE(2430),
    [sym_fsi_directive_decl] = STATE(2430),
    [sym_preproc_line] = STATE(2430),
    [ts_builtin_sym_end] = ACTIONS(4210),
    [sym_identifier] = ACTIONS(4212),
    [anon_sym_namespace] = ACTIONS(4212),
    [anon_sym_module] = ACTIONS(4212),
    [anon_sym_EQ] = ACTIONS(4210),
    [anon_sym_open] = ACTIONS(4212),
    [anon_sym_LBRACK_LT] = ACTIONS(4210),
    [anon_sym_COLON] = ACTIONS(4212),
    [anon_sym_return] = ACTIONS(4212),
    [anon_sym_type] = ACTIONS(4212),
    [anon_sym_do] = ACTIONS(4212),
    [anon_sym_let] = ACTIONS(4212),
    [anon_sym_let_BANG] = ACTIONS(4210),
    [anon_sym_LPAREN] = ACTIONS(4212),
    [anon_sym_COMMA] = ACTIONS(4210),
    [anon_sym_null] = ACTIONS(4212),
    [anon_sym_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_COLON] = ACTIONS(4210),
    [anon_sym_AMP] = ACTIONS(4212),
    [anon_sym_LBRACK] = ACTIONS(4212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4210),
    [anon_sym_LBRACE] = ACTIONS(4212),
    [anon_sym_LT_AT] = ACTIONS(4212),
    [anon_sym_LT_AT_AT] = ACTIONS(4212),
    [anon_sym_DOT] = ACTIONS(4212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4210),
    [anon_sym_new] = ACTIONS(4212),
    [anon_sym_return_BANG] = ACTIONS(4210),
    [anon_sym_yield] = ACTIONS(4212),
    [anon_sym_yield_BANG] = ACTIONS(4210),
    [anon_sym_lazy] = ACTIONS(4212),
    [anon_sym_assert] = ACTIONS(4212),
    [anon_sym_upcast] = ACTIONS(4212),
    [anon_sym_downcast] = ACTIONS(4212),
    [anon_sym_COLON_GT] = ACTIONS(4210),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4210),
    [anon_sym_for] = ACTIONS(4212),
    [anon_sym_while] = ACTIONS(4212),
    [anon_sym_if] = ACTIONS(4212),
    [anon_sym_fun] = ACTIONS(4212),
    [anon_sym_try] = ACTIONS(4212),
    [anon_sym_match] = ACTIONS(4212),
    [anon_sym_match_BANG] = ACTIONS(4210),
    [anon_sym_function] = ACTIONS(4212),
    [anon_sym_LT_DASH] = ACTIONS(4212),
    [anon_sym_DOT_LBRACK] = ACTIONS(4210),
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_use] = ACTIONS(4212),
    [anon_sym_use_BANG] = ACTIONS(4210),
    [anon_sym_do_BANG] = ACTIONS(4210),
    [anon_sym_begin] = ACTIONS(4212),
    [anon_sym_LPAREN2] = ACTIONS(4212),
    [anon_sym_or] = ACTIONS(4212),
    [anon_sym_exception] = ACTIONS(4212),
    [aux_sym_char_token1] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4212),
    [anon_sym_DQUOTE] = ACTIONS(4212),
    [anon_sym_AT_DQUOTE] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [sym_bool] = ACTIONS(4212),
    [sym_unit] = ACTIONS(4210),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4212),
    [anon_sym_DASH] = ACTIONS(4212),
    [anon_sym_PLUS_DOT] = ACTIONS(4212),
    [anon_sym_DASH_DOT] = ACTIONS(4212),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_AMP_AMP] = ACTIONS(4212),
    [anon_sym_TILDE] = ACTIONS(4210),
    [aux_sym_prefix_op_token1] = ACTIONS(4212),
    [aux_sym_infix_op_token1] = ACTIONS(4210),
    [aux_sym_infix_op_token2] = ACTIONS(4212),
    [anon_sym_PIPE_PIPE] = ACTIONS(4212),
    [anon_sym_BANG_EQ] = ACTIONS(4212),
    [anon_sym_COLON_EQ] = ACTIONS(4210),
    [anon_sym_DOLLAR] = ACTIONS(4212),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4212),
    [sym_int] = ACTIONS(4212),
    [sym_xint] = ACTIONS(4210),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4210),
    [anon_sym_POUNDload] = ACTIONS(4210),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4210),
    [sym__newline] = ACTIONS(4210),
  },
  [2431] = {
    [sym_block_comment] = STATE(2431),
    [sym_compiler_directive_decl] = STATE(2431),
    [sym_fsi_directive_decl] = STATE(2431),
    [sym_preproc_line] = STATE(2431),
    [ts_builtin_sym_end] = ACTIONS(3964),
    [sym_identifier] = ACTIONS(3966),
    [anon_sym_namespace] = ACTIONS(3966),
    [anon_sym_module] = ACTIONS(3966),
    [anon_sym_EQ] = ACTIONS(3964),
    [anon_sym_open] = ACTIONS(3966),
    [anon_sym_LBRACK_LT] = ACTIONS(3964),
    [anon_sym_COLON] = ACTIONS(3966),
    [anon_sym_return] = ACTIONS(3966),
    [anon_sym_type] = ACTIONS(3966),
    [anon_sym_do] = ACTIONS(3966),
    [anon_sym_let] = ACTIONS(3966),
    [anon_sym_let_BANG] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COMMA] = ACTIONS(3964),
    [anon_sym_null] = ACTIONS(3966),
    [anon_sym_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(3964),
    [anon_sym_AMP] = ACTIONS(3966),
    [anon_sym_LBRACK] = ACTIONS(3966),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3964),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_LT_AT] = ACTIONS(3966),
    [anon_sym_LT_AT_AT] = ACTIONS(3966),
    [anon_sym_DOT] = ACTIONS(3966),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3964),
    [anon_sym_new] = ACTIONS(3966),
    [anon_sym_return_BANG] = ACTIONS(3964),
    [anon_sym_yield] = ACTIONS(3966),
    [anon_sym_yield_BANG] = ACTIONS(3964),
    [anon_sym_lazy] = ACTIONS(3966),
    [anon_sym_assert] = ACTIONS(3966),
    [anon_sym_upcast] = ACTIONS(3966),
    [anon_sym_downcast] = ACTIONS(3966),
    [anon_sym_COLON_GT] = ACTIONS(3964),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3964),
    [anon_sym_for] = ACTIONS(3966),
    [anon_sym_while] = ACTIONS(3966),
    [anon_sym_if] = ACTIONS(3966),
    [anon_sym_fun] = ACTIONS(3966),
    [anon_sym_try] = ACTIONS(3966),
    [anon_sym_match] = ACTIONS(3966),
    [anon_sym_match_BANG] = ACTIONS(3964),
    [anon_sym_function] = ACTIONS(3966),
    [anon_sym_LT_DASH] = ACTIONS(3966),
    [anon_sym_DOT_LBRACK] = ACTIONS(3964),
    [anon_sym_LT] = ACTIONS(3964),
    [anon_sym_use] = ACTIONS(3966),
    [anon_sym_use_BANG] = ACTIONS(3964),
    [anon_sym_do_BANG] = ACTIONS(3964),
    [anon_sym_begin] = ACTIONS(3966),
    [anon_sym_LPAREN2] = ACTIONS(3966),
    [anon_sym_or] = ACTIONS(3966),
    [anon_sym_exception] = ACTIONS(3966),
    [aux_sym_char_token1] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3966),
    [anon_sym_DQUOTE] = ACTIONS(3966),
    [anon_sym_AT_DQUOTE] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [sym_bool] = ACTIONS(3966),
    [sym_unit] = ACTIONS(3964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3966),
    [sym_op_identifier] = ACTIONS(3966),
    [anon_sym_PLUS] = ACTIONS(3966),
    [anon_sym_DASH] = ACTIONS(3966),
    [anon_sym_PLUS_DOT] = ACTIONS(3966),
    [anon_sym_DASH_DOT] = ACTIONS(3966),
    [anon_sym_PERCENT] = ACTIONS(3966),
    [anon_sym_AMP_AMP] = ACTIONS(3966),
    [anon_sym_TILDE] = ACTIONS(3964),
    [aux_sym_prefix_op_token1] = ACTIONS(3966),
    [aux_sym_infix_op_token1] = ACTIONS(3964),
    [aux_sym_infix_op_token2] = ACTIONS(3966),
    [anon_sym_PIPE_PIPE] = ACTIONS(3966),
    [anon_sym_BANG_EQ] = ACTIONS(3966),
    [anon_sym_COLON_EQ] = ACTIONS(3964),
    [anon_sym_DOLLAR] = ACTIONS(3966),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3966),
    [sym_int] = ACTIONS(3966),
    [sym_xint] = ACTIONS(3964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3964),
    [anon_sym_POUNDload] = ACTIONS(3964),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3964),
    [sym__newline] = ACTIONS(3964),
  },
  [2432] = {
    [sym_block_comment] = STATE(2432),
    [sym_compiler_directive_decl] = STATE(2432),
    [sym_fsi_directive_decl] = STATE(2432),
    [sym_preproc_line] = STATE(2432),
    [sym_identifier] = ACTIONS(3962),
    [anon_sym_EQ] = ACTIONS(3960),
    [anon_sym_GT_RBRACK] = ACTIONS(3960),
    [anon_sym_COLON] = ACTIONS(3962),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_do] = ACTIONS(3962),
    [anon_sym_let] = ACTIONS(3962),
    [anon_sym_let_BANG] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_COMMA] = ACTIONS(3960),
    [anon_sym_null] = ACTIONS(3962),
    [anon_sym_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_COLON] = ACTIONS(3960),
    [anon_sym_AMP] = ACTIONS(3962),
    [anon_sym_LBRACK] = ACTIONS(3962),
    [anon_sym_RBRACK] = ACTIONS(3960),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_RBRACE] = ACTIONS(3960),
    [anon_sym_LT_AT] = ACTIONS(3962),
    [anon_sym_LT_AT_AT] = ACTIONS(3962),
    [anon_sym_DOT] = ACTIONS(3962),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3960),
    [anon_sym_new] = ACTIONS(3962),
    [anon_sym_with] = ACTIONS(3962),
    [anon_sym_return_BANG] = ACTIONS(3960),
    [anon_sym_yield] = ACTIONS(3962),
    [anon_sym_yield_BANG] = ACTIONS(3960),
    [anon_sym_lazy] = ACTIONS(3962),
    [anon_sym_assert] = ACTIONS(3962),
    [anon_sym_upcast] = ACTIONS(3962),
    [anon_sym_downcast] = ACTIONS(3962),
    [anon_sym_COLON_GT] = ACTIONS(3960),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3960),
    [anon_sym_for] = ACTIONS(3962),
    [anon_sym_to] = ACTIONS(3962),
    [anon_sym_downto] = ACTIONS(3962),
    [anon_sym_while] = ACTIONS(3962),
    [anon_sym_if] = ACTIONS(3962),
    [anon_sym_fun] = ACTIONS(3962),
    [anon_sym_try] = ACTIONS(3962),
    [anon_sym_match] = ACTIONS(3962),
    [anon_sym_match_BANG] = ACTIONS(3960),
    [anon_sym_function] = ACTIONS(3962),
    [anon_sym_LT_DASH] = ACTIONS(3962),
    [anon_sym_DOT_LBRACK] = ACTIONS(3960),
    [anon_sym_LT] = ACTIONS(3960),
    [anon_sym_use] = ACTIONS(3962),
    [anon_sym_use_BANG] = ACTIONS(3960),
    [anon_sym_do_BANG] = ACTIONS(3960),
    [anon_sym_begin] = ACTIONS(3962),
    [anon_sym_LPAREN2] = ACTIONS(3962),
    [anon_sym_DOT_DOT2] = ACTIONS(3960),
    [anon_sym_or] = ACTIONS(3962),
    [aux_sym_char_token1] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3962),
    [anon_sym_DQUOTE] = ACTIONS(3962),
    [anon_sym_AT_DQUOTE] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [sym_bool] = ACTIONS(3962),
    [sym_unit] = ACTIONS(3960),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3962),
    [sym_op_identifier] = ACTIONS(3962),
    [anon_sym_PLUS] = ACTIONS(3962),
    [anon_sym_DASH] = ACTIONS(3962),
    [anon_sym_PLUS_DOT] = ACTIONS(3962),
    [anon_sym_DASH_DOT] = ACTIONS(3962),
    [anon_sym_PERCENT] = ACTIONS(3962),
    [anon_sym_AMP_AMP] = ACTIONS(3962),
    [anon_sym_TILDE] = ACTIONS(3960),
    [aux_sym_prefix_op_token1] = ACTIONS(3962),
    [aux_sym_infix_op_token1] = ACTIONS(3960),
    [aux_sym_infix_op_token2] = ACTIONS(3962),
    [anon_sym_PIPE_PIPE] = ACTIONS(3962),
    [anon_sym_BANG_EQ] = ACTIONS(3962),
    [anon_sym_COLON_EQ] = ACTIONS(3960),
    [anon_sym_DOLLAR] = ACTIONS(3962),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3962),
    [sym_int] = ACTIONS(3962),
    [sym_xint] = ACTIONS(3960),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3960),
    [sym__newline] = ACTIONS(3960),
  },
  [2433] = {
    [sym_block_comment] = STATE(2433),
    [sym_compiler_directive_decl] = STATE(2433),
    [sym_fsi_directive_decl] = STATE(2433),
    [sym_preproc_line] = STATE(2433),
    [sym_identifier] = ACTIONS(4232),
    [anon_sym_EQ] = ACTIONS(4230),
    [anon_sym_GT_RBRACK] = ACTIONS(4230),
    [anon_sym_COLON] = ACTIONS(4232),
    [anon_sym_return] = ACTIONS(4232),
    [anon_sym_do] = ACTIONS(4232),
    [anon_sym_let] = ACTIONS(4232),
    [anon_sym_let_BANG] = ACTIONS(4230),
    [anon_sym_LPAREN] = ACTIONS(4232),
    [anon_sym_COMMA] = ACTIONS(4230),
    [anon_sym_null] = ACTIONS(4232),
    [anon_sym_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_COLON] = ACTIONS(4230),
    [anon_sym_AMP] = ACTIONS(4232),
    [anon_sym_LBRACK] = ACTIONS(4232),
    [anon_sym_RBRACK] = ACTIONS(4230),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4230),
    [anon_sym_LBRACE] = ACTIONS(4232),
    [anon_sym_RBRACE] = ACTIONS(4230),
    [anon_sym_LT_AT] = ACTIONS(4232),
    [anon_sym_LT_AT_AT] = ACTIONS(4232),
    [anon_sym_DOT] = ACTIONS(4232),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4230),
    [anon_sym_new] = ACTIONS(4232),
    [anon_sym_with] = ACTIONS(4232),
    [anon_sym_return_BANG] = ACTIONS(4230),
    [anon_sym_yield] = ACTIONS(4232),
    [anon_sym_yield_BANG] = ACTIONS(4230),
    [anon_sym_lazy] = ACTIONS(4232),
    [anon_sym_assert] = ACTIONS(4232),
    [anon_sym_upcast] = ACTIONS(4232),
    [anon_sym_downcast] = ACTIONS(4232),
    [anon_sym_COLON_GT] = ACTIONS(4230),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4230),
    [anon_sym_for] = ACTIONS(4232),
    [anon_sym_to] = ACTIONS(4232),
    [anon_sym_downto] = ACTIONS(4232),
    [anon_sym_while] = ACTIONS(4232),
    [anon_sym_if] = ACTIONS(4232),
    [anon_sym_fun] = ACTIONS(4232),
    [anon_sym_try] = ACTIONS(4232),
    [anon_sym_match] = ACTIONS(4232),
    [anon_sym_match_BANG] = ACTIONS(4230),
    [anon_sym_function] = ACTIONS(4232),
    [anon_sym_LT_DASH] = ACTIONS(4232),
    [anon_sym_DOT_LBRACK] = ACTIONS(4230),
    [anon_sym_LT] = ACTIONS(4230),
    [anon_sym_use] = ACTIONS(4232),
    [anon_sym_use_BANG] = ACTIONS(4230),
    [anon_sym_do_BANG] = ACTIONS(4230),
    [anon_sym_begin] = ACTIONS(4232),
    [anon_sym_LPAREN2] = ACTIONS(4232),
    [anon_sym_DOT_DOT2] = ACTIONS(4230),
    [anon_sym_or] = ACTIONS(4232),
    [aux_sym_char_token1] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4232),
    [anon_sym_DQUOTE] = ACTIONS(4232),
    [anon_sym_AT_DQUOTE] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [sym_bool] = ACTIONS(4232),
    [sym_unit] = ACTIONS(4230),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4232),
    [sym_op_identifier] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4232),
    [anon_sym_DASH] = ACTIONS(4232),
    [anon_sym_PLUS_DOT] = ACTIONS(4232),
    [anon_sym_DASH_DOT] = ACTIONS(4232),
    [anon_sym_PERCENT] = ACTIONS(4232),
    [anon_sym_AMP_AMP] = ACTIONS(4232),
    [anon_sym_TILDE] = ACTIONS(4230),
    [aux_sym_prefix_op_token1] = ACTIONS(4232),
    [aux_sym_infix_op_token1] = ACTIONS(4230),
    [aux_sym_infix_op_token2] = ACTIONS(4232),
    [anon_sym_PIPE_PIPE] = ACTIONS(4232),
    [anon_sym_BANG_EQ] = ACTIONS(4232),
    [anon_sym_COLON_EQ] = ACTIONS(4230),
    [anon_sym_DOLLAR] = ACTIONS(4232),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4232),
    [sym_int] = ACTIONS(4232),
    [sym_xint] = ACTIONS(4230),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4230),
    [sym__newline] = ACTIONS(4230),
  },
  [2434] = {
    [sym_block_comment] = STATE(2434),
    [sym_compiler_directive_decl] = STATE(2434),
    [sym_fsi_directive_decl] = STATE(2434),
    [sym_preproc_line] = STATE(2434),
    [sym_identifier] = ACTIONS(4126),
    [anon_sym_EQ] = ACTIONS(4124),
    [anon_sym_GT_RBRACK] = ACTIONS(4124),
    [anon_sym_COLON] = ACTIONS(4126),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_do] = ACTIONS(4126),
    [anon_sym_let] = ACTIONS(4126),
    [anon_sym_let_BANG] = ACTIONS(4124),
    [anon_sym_LPAREN] = ACTIONS(4126),
    [anon_sym_COMMA] = ACTIONS(4124),
    [anon_sym_null] = ACTIONS(4126),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_COLON] = ACTIONS(4124),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LBRACK] = ACTIONS(4126),
    [anon_sym_RBRACK] = ACTIONS(4124),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4126),
    [anon_sym_RBRACE] = ACTIONS(4124),
    [anon_sym_LT_AT] = ACTIONS(4126),
    [anon_sym_LT_AT_AT] = ACTIONS(4126),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4124),
    [anon_sym_new] = ACTIONS(4126),
    [anon_sym_with] = ACTIONS(4126),
    [anon_sym_return_BANG] = ACTIONS(4124),
    [anon_sym_yield] = ACTIONS(4126),
    [anon_sym_yield_BANG] = ACTIONS(4124),
    [anon_sym_lazy] = ACTIONS(4126),
    [anon_sym_assert] = ACTIONS(4126),
    [anon_sym_upcast] = ACTIONS(4126),
    [anon_sym_downcast] = ACTIONS(4126),
    [anon_sym_COLON_GT] = ACTIONS(4124),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4124),
    [anon_sym_for] = ACTIONS(4126),
    [anon_sym_to] = ACTIONS(4126),
    [anon_sym_downto] = ACTIONS(4126),
    [anon_sym_while] = ACTIONS(4126),
    [anon_sym_if] = ACTIONS(4126),
    [anon_sym_fun] = ACTIONS(4126),
    [anon_sym_try] = ACTIONS(4126),
    [anon_sym_match] = ACTIONS(4126),
    [anon_sym_match_BANG] = ACTIONS(4124),
    [anon_sym_function] = ACTIONS(4126),
    [anon_sym_LT_DASH] = ACTIONS(4126),
    [anon_sym_DOT_LBRACK] = ACTIONS(4124),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_use] = ACTIONS(4126),
    [anon_sym_use_BANG] = ACTIONS(4124),
    [anon_sym_do_BANG] = ACTIONS(4124),
    [anon_sym_begin] = ACTIONS(4126),
    [anon_sym_LPAREN2] = ACTIONS(4126),
    [anon_sym_DOT_DOT2] = ACTIONS(4124),
    [anon_sym_or] = ACTIONS(4126),
    [aux_sym_char_token1] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4126),
    [anon_sym_DQUOTE] = ACTIONS(4126),
    [anon_sym_AT_DQUOTE] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [sym_bool] = ACTIONS(4126),
    [sym_unit] = ACTIONS(4124),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4126),
    [sym_op_identifier] = ACTIONS(4126),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_PLUS_DOT] = ACTIONS(4126),
    [anon_sym_DASH_DOT] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_AMP_AMP] = ACTIONS(4126),
    [anon_sym_TILDE] = ACTIONS(4124),
    [aux_sym_prefix_op_token1] = ACTIONS(4126),
    [aux_sym_infix_op_token1] = ACTIONS(4124),
    [aux_sym_infix_op_token2] = ACTIONS(4126),
    [anon_sym_PIPE_PIPE] = ACTIONS(4126),
    [anon_sym_BANG_EQ] = ACTIONS(4126),
    [anon_sym_COLON_EQ] = ACTIONS(4124),
    [anon_sym_DOLLAR] = ACTIONS(4126),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4126),
    [sym_int] = ACTIONS(4126),
    [sym_xint] = ACTIONS(4124),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4124),
    [sym__newline] = ACTIONS(4124),
  },
  [2435] = {
    [sym_block_comment] = STATE(2435),
    [sym_compiler_directive_decl] = STATE(2435),
    [sym_fsi_directive_decl] = STATE(2435),
    [sym_preproc_line] = STATE(2435),
    [ts_builtin_sym_end] = ACTIONS(3940),
    [sym_identifier] = ACTIONS(3942),
    [anon_sym_namespace] = ACTIONS(3942),
    [anon_sym_module] = ACTIONS(3942),
    [anon_sym_EQ] = ACTIONS(3940),
    [anon_sym_open] = ACTIONS(3942),
    [anon_sym_LBRACK_LT] = ACTIONS(3940),
    [anon_sym_COLON] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_type] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_let_BANG] = ACTIONS(3940),
    [anon_sym_LPAREN] = ACTIONS(3942),
    [anon_sym_COMMA] = ACTIONS(3940),
    [anon_sym_null] = ACTIONS(3942),
    [anon_sym_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3940),
    [anon_sym_LBRACE] = ACTIONS(3942),
    [anon_sym_LT_AT] = ACTIONS(3942),
    [anon_sym_LT_AT_AT] = ACTIONS(3942),
    [anon_sym_DOT] = ACTIONS(3942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3940),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_return_BANG] = ACTIONS(3940),
    [anon_sym_yield] = ACTIONS(3942),
    [anon_sym_yield_BANG] = ACTIONS(3940),
    [anon_sym_lazy] = ACTIONS(3942),
    [anon_sym_assert] = ACTIONS(3942),
    [anon_sym_upcast] = ACTIONS(3942),
    [anon_sym_downcast] = ACTIONS(3942),
    [anon_sym_COLON_GT] = ACTIONS(3940),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3940),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_fun] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_match] = ACTIONS(3942),
    [anon_sym_match_BANG] = ACTIONS(3940),
    [anon_sym_function] = ACTIONS(3942),
    [anon_sym_LT_DASH] = ACTIONS(3942),
    [anon_sym_DOT_LBRACK] = ACTIONS(3940),
    [anon_sym_LT] = ACTIONS(3940),
    [anon_sym_use] = ACTIONS(3942),
    [anon_sym_use_BANG] = ACTIONS(3940),
    [anon_sym_do_BANG] = ACTIONS(3940),
    [anon_sym_begin] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3942),
    [anon_sym_or] = ACTIONS(3942),
    [anon_sym_exception] = ACTIONS(3942),
    [aux_sym_char_token1] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3942),
    [anon_sym_DQUOTE] = ACTIONS(3942),
    [anon_sym_AT_DQUOTE] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [sym_bool] = ACTIONS(3942),
    [sym_unit] = ACTIONS(3940),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3942),
    [sym_op_identifier] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS_DOT] = ACTIONS(3942),
    [anon_sym_DASH_DOT] = ACTIONS(3942),
    [anon_sym_PERCENT] = ACTIONS(3942),
    [anon_sym_AMP_AMP] = ACTIONS(3942),
    [anon_sym_TILDE] = ACTIONS(3940),
    [aux_sym_prefix_op_token1] = ACTIONS(3942),
    [aux_sym_infix_op_token1] = ACTIONS(3940),
    [aux_sym_infix_op_token2] = ACTIONS(3942),
    [anon_sym_PIPE_PIPE] = ACTIONS(3942),
    [anon_sym_BANG_EQ] = ACTIONS(3942),
    [anon_sym_COLON_EQ] = ACTIONS(3940),
    [anon_sym_DOLLAR] = ACTIONS(3942),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3942),
    [sym_int] = ACTIONS(3942),
    [sym_xint] = ACTIONS(3940),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3940),
    [anon_sym_POUNDload] = ACTIONS(3940),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3940),
    [sym__newline] = ACTIONS(3940),
  },
  [2436] = {
    [sym_block_comment] = STATE(2436),
    [sym_compiler_directive_decl] = STATE(2436),
    [sym_fsi_directive_decl] = STATE(2436),
    [sym_preproc_line] = STATE(2436),
    [sym_identifier] = ACTIONS(4122),
    [anon_sym_EQ] = ACTIONS(4120),
    [anon_sym_GT_RBRACK] = ACTIONS(4120),
    [anon_sym_COLON] = ACTIONS(4122),
    [anon_sym_return] = ACTIONS(4122),
    [anon_sym_do] = ACTIONS(4122),
    [anon_sym_let] = ACTIONS(4122),
    [anon_sym_let_BANG] = ACTIONS(4120),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_COMMA] = ACTIONS(4120),
    [anon_sym_null] = ACTIONS(4122),
    [anon_sym_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_COLON] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_RBRACK] = ACTIONS(4120),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_RBRACE] = ACTIONS(4120),
    [anon_sym_LT_AT] = ACTIONS(4122),
    [anon_sym_LT_AT_AT] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4122),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4120),
    [anon_sym_new] = ACTIONS(4122),
    [anon_sym_with] = ACTIONS(4122),
    [anon_sym_return_BANG] = ACTIONS(4120),
    [anon_sym_yield] = ACTIONS(4122),
    [anon_sym_yield_BANG] = ACTIONS(4120),
    [anon_sym_lazy] = ACTIONS(4122),
    [anon_sym_assert] = ACTIONS(4122),
    [anon_sym_upcast] = ACTIONS(4122),
    [anon_sym_downcast] = ACTIONS(4122),
    [anon_sym_COLON_GT] = ACTIONS(4120),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4120),
    [anon_sym_for] = ACTIONS(4122),
    [anon_sym_to] = ACTIONS(4122),
    [anon_sym_downto] = ACTIONS(4122),
    [anon_sym_while] = ACTIONS(4122),
    [anon_sym_if] = ACTIONS(4122),
    [anon_sym_fun] = ACTIONS(4122),
    [anon_sym_try] = ACTIONS(4122),
    [anon_sym_match] = ACTIONS(4122),
    [anon_sym_match_BANG] = ACTIONS(4120),
    [anon_sym_function] = ACTIONS(4122),
    [anon_sym_LT_DASH] = ACTIONS(4122),
    [anon_sym_DOT_LBRACK] = ACTIONS(4120),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_use] = ACTIONS(4122),
    [anon_sym_use_BANG] = ACTIONS(4120),
    [anon_sym_do_BANG] = ACTIONS(4120),
    [anon_sym_begin] = ACTIONS(4122),
    [anon_sym_LPAREN2] = ACTIONS(4122),
    [anon_sym_DOT_DOT2] = ACTIONS(4120),
    [anon_sym_or] = ACTIONS(4122),
    [aux_sym_char_token1] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4122),
    [anon_sym_DQUOTE] = ACTIONS(4122),
    [anon_sym_AT_DQUOTE] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [sym_bool] = ACTIONS(4122),
    [sym_unit] = ACTIONS(4120),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4122),
    [sym_op_identifier] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4122),
    [anon_sym_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_DOT] = ACTIONS(4122),
    [anon_sym_DASH_DOT] = ACTIONS(4122),
    [anon_sym_PERCENT] = ACTIONS(4122),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_TILDE] = ACTIONS(4120),
    [aux_sym_prefix_op_token1] = ACTIONS(4122),
    [aux_sym_infix_op_token1] = ACTIONS(4120),
    [aux_sym_infix_op_token2] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_COLON_EQ] = ACTIONS(4120),
    [anon_sym_DOLLAR] = ACTIONS(4122),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4122),
    [sym_int] = ACTIONS(4122),
    [sym_xint] = ACTIONS(4120),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4120),
    [sym__newline] = ACTIONS(4120),
  },
  [2437] = {
    [sym_block_comment] = STATE(2437),
    [sym_compiler_directive_decl] = STATE(2437),
    [sym_fsi_directive_decl] = STATE(2437),
    [sym_preproc_line] = STATE(2437),
    [aux_sym_compound_type_repeat1] = STATE(2426),
    [sym_identifier] = ACTIONS(3468),
    [anon_sym_EQ] = ACTIONS(3466),
    [anon_sym_COLON] = ACTIONS(3468),
    [anon_sym_return] = ACTIONS(3468),
    [anon_sym_do] = ACTIONS(3468),
    [anon_sym_let] = ACTIONS(3468),
    [anon_sym_let_BANG] = ACTIONS(3466),
    [anon_sym_as] = ACTIONS(3468),
    [anon_sym_LPAREN] = ACTIONS(3468),
    [anon_sym_COMMA] = ACTIONS(3466),
    [anon_sym_null] = ACTIONS(3468),
    [anon_sym_QMARK] = ACTIONS(3468),
    [anon_sym_COLON_QMARK] = ACTIONS(3468),
    [anon_sym_COLON_COLON] = ACTIONS(3466),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LBRACK] = ACTIONS(3468),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3466),
    [anon_sym_LBRACE] = ACTIONS(3468),
    [anon_sym_LT_AT] = ACTIONS(3468),
    [anon_sym_LT_AT_AT] = ACTIONS(3468),
    [anon_sym_DOT] = ACTIONS(3468),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3466),
    [anon_sym_new] = ACTIONS(3468),
    [anon_sym_with] = ACTIONS(3468),
    [anon_sym_return_BANG] = ACTIONS(3466),
    [anon_sym_yield] = ACTIONS(3468),
    [anon_sym_yield_BANG] = ACTIONS(3466),
    [anon_sym_lazy] = ACTIONS(3468),
    [anon_sym_assert] = ACTIONS(3468),
    [anon_sym_upcast] = ACTIONS(3468),
    [anon_sym_downcast] = ACTIONS(3468),
    [anon_sym_COLON_GT] = ACTIONS(3466),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3466),
    [anon_sym_for] = ACTIONS(3468),
    [anon_sym_while] = ACTIONS(3468),
    [anon_sym_if] = ACTIONS(3468),
    [anon_sym_fun] = ACTIONS(3468),
    [anon_sym_DASH_GT] = ACTIONS(3468),
    [anon_sym_try] = ACTIONS(3468),
    [anon_sym_match] = ACTIONS(3468),
    [anon_sym_match_BANG] = ACTIONS(3466),
    [anon_sym_function] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3468),
    [anon_sym_DOT_LBRACK] = ACTIONS(3466),
    [anon_sym_LT] = ACTIONS(3466),
    [anon_sym_use] = ACTIONS(3468),
    [anon_sym_use_BANG] = ACTIONS(3466),
    [anon_sym_do_BANG] = ACTIONS(3466),
    [anon_sym_begin] = ACTIONS(3468),
    [anon_sym_LPAREN2] = ACTIONS(3468),
    [anon_sym_STAR] = ACTIONS(4816),
    [anon_sym_LT2] = ACTIONS(3468),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3466),
    [anon_sym_or] = ACTIONS(3468),
    [aux_sym_char_token1] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3468),
    [anon_sym_DQUOTE] = ACTIONS(3468),
    [anon_sym_AT_DQUOTE] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [sym_bool] = ACTIONS(3468),
    [sym_unit] = ACTIONS(3466),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3468),
    [sym_op_identifier] = ACTIONS(3468),
    [anon_sym_PLUS] = ACTIONS(3468),
    [anon_sym_DASH] = ACTIONS(3468),
    [anon_sym_PLUS_DOT] = ACTIONS(3468),
    [anon_sym_DASH_DOT] = ACTIONS(3468),
    [anon_sym_PERCENT] = ACTIONS(3468),
    [anon_sym_AMP_AMP] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3466),
    [aux_sym_prefix_op_token1] = ACTIONS(3468),
    [aux_sym_infix_op_token1] = ACTIONS(3466),
    [aux_sym_infix_op_token2] = ACTIONS(3468),
    [anon_sym_PIPE_PIPE] = ACTIONS(3468),
    [anon_sym_BANG_EQ] = ACTIONS(3468),
    [anon_sym_COLON_EQ] = ACTIONS(3466),
    [anon_sym_DOLLAR] = ACTIONS(3468),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3468),
    [sym_int] = ACTIONS(3468),
    [sym_xint] = ACTIONS(3466),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3466),
    [sym__newline] = ACTIONS(3466),
  },
  [2438] = {
    [sym_block_comment] = STATE(2438),
    [sym_compiler_directive_decl] = STATE(2438),
    [sym_fsi_directive_decl] = STATE(2438),
    [sym_preproc_line] = STATE(2438),
    [ts_builtin_sym_end] = ACTIONS(3929),
    [sym_identifier] = ACTIONS(3931),
    [anon_sym_namespace] = ACTIONS(3931),
    [anon_sym_module] = ACTIONS(3931),
    [anon_sym_EQ] = ACTIONS(3929),
    [anon_sym_open] = ACTIONS(3931),
    [anon_sym_LBRACK_LT] = ACTIONS(3929),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_type] = ACTIONS(3931),
    [anon_sym_do] = ACTIONS(3931),
    [anon_sym_let] = ACTIONS(3931),
    [anon_sym_let_BANG] = ACTIONS(3929),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_COMMA] = ACTIONS(3929),
    [anon_sym_null] = ACTIONS(3931),
    [anon_sym_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_COLON] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3931),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_LT_AT] = ACTIONS(3931),
    [anon_sym_LT_AT_AT] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3931),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3929),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_return_BANG] = ACTIONS(3929),
    [anon_sym_yield] = ACTIONS(3931),
    [anon_sym_yield_BANG] = ACTIONS(3929),
    [anon_sym_lazy] = ACTIONS(3931),
    [anon_sym_assert] = ACTIONS(3931),
    [anon_sym_upcast] = ACTIONS(3931),
    [anon_sym_downcast] = ACTIONS(3931),
    [anon_sym_COLON_GT] = ACTIONS(3929),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3929),
    [anon_sym_for] = ACTIONS(3931),
    [anon_sym_while] = ACTIONS(3931),
    [anon_sym_if] = ACTIONS(3931),
    [anon_sym_fun] = ACTIONS(3931),
    [anon_sym_try] = ACTIONS(3931),
    [anon_sym_match] = ACTIONS(3931),
    [anon_sym_match_BANG] = ACTIONS(3929),
    [anon_sym_function] = ACTIONS(3931),
    [anon_sym_LT_DASH] = ACTIONS(3931),
    [anon_sym_DOT_LBRACK] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_use] = ACTIONS(3931),
    [anon_sym_use_BANG] = ACTIONS(3929),
    [anon_sym_do_BANG] = ACTIONS(3929),
    [anon_sym_begin] = ACTIONS(3931),
    [anon_sym_LPAREN2] = ACTIONS(3931),
    [anon_sym_or] = ACTIONS(3931),
    [anon_sym_exception] = ACTIONS(3931),
    [aux_sym_char_token1] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3931),
    [anon_sym_DQUOTE] = ACTIONS(3931),
    [anon_sym_AT_DQUOTE] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [sym_bool] = ACTIONS(3931),
    [sym_unit] = ACTIONS(3929),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3931),
    [sym_op_identifier] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3931),
    [anon_sym_DASH] = ACTIONS(3931),
    [anon_sym_PLUS_DOT] = ACTIONS(3931),
    [anon_sym_DASH_DOT] = ACTIONS(3931),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_TILDE] = ACTIONS(3929),
    [aux_sym_prefix_op_token1] = ACTIONS(3931),
    [aux_sym_infix_op_token1] = ACTIONS(3929),
    [aux_sym_infix_op_token2] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_COLON_EQ] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3931),
    [sym_int] = ACTIONS(3931),
    [sym_xint] = ACTIONS(3929),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3929),
    [anon_sym_POUNDload] = ACTIONS(3929),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3929),
    [sym__newline] = ACTIONS(3929),
  },
  [2439] = {
    [sym_block_comment] = STATE(2439),
    [sym_compiler_directive_decl] = STATE(2439),
    [sym_fsi_directive_decl] = STATE(2439),
    [sym_preproc_line] = STATE(2439),
    [ts_builtin_sym_end] = ACTIONS(4149),
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_namespace] = ACTIONS(4151),
    [anon_sym_module] = ACTIONS(4151),
    [anon_sym_EQ] = ACTIONS(4149),
    [anon_sym_open] = ACTIONS(4151),
    [anon_sym_LBRACK_LT] = ACTIONS(4149),
    [anon_sym_COLON] = ACTIONS(4151),
    [anon_sym_return] = ACTIONS(4151),
    [anon_sym_type] = ACTIONS(4151),
    [anon_sym_do] = ACTIONS(4151),
    [anon_sym_let] = ACTIONS(4151),
    [anon_sym_let_BANG] = ACTIONS(4149),
    [anon_sym_LPAREN] = ACTIONS(4151),
    [anon_sym_COMMA] = ACTIONS(4149),
    [anon_sym_null] = ACTIONS(4151),
    [anon_sym_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_AMP] = ACTIONS(4151),
    [anon_sym_LBRACK] = ACTIONS(4151),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4149),
    [anon_sym_LBRACE] = ACTIONS(4151),
    [anon_sym_LT_AT] = ACTIONS(4151),
    [anon_sym_LT_AT_AT] = ACTIONS(4151),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4149),
    [anon_sym_new] = ACTIONS(4151),
    [anon_sym_return_BANG] = ACTIONS(4149),
    [anon_sym_yield] = ACTIONS(4151),
    [anon_sym_yield_BANG] = ACTIONS(4149),
    [anon_sym_lazy] = ACTIONS(4151),
    [anon_sym_assert] = ACTIONS(4151),
    [anon_sym_upcast] = ACTIONS(4151),
    [anon_sym_downcast] = ACTIONS(4151),
    [anon_sym_COLON_GT] = ACTIONS(4149),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4149),
    [anon_sym_for] = ACTIONS(4151),
    [anon_sym_while] = ACTIONS(4151),
    [anon_sym_if] = ACTIONS(4151),
    [anon_sym_fun] = ACTIONS(4151),
    [anon_sym_try] = ACTIONS(4151),
    [anon_sym_match] = ACTIONS(4151),
    [anon_sym_match_BANG] = ACTIONS(4149),
    [anon_sym_function] = ACTIONS(4151),
    [anon_sym_LT_DASH] = ACTIONS(4151),
    [anon_sym_DOT_LBRACK] = ACTIONS(4149),
    [anon_sym_LT] = ACTIONS(4149),
    [anon_sym_use] = ACTIONS(4151),
    [anon_sym_use_BANG] = ACTIONS(4149),
    [anon_sym_do_BANG] = ACTIONS(4149),
    [anon_sym_begin] = ACTIONS(4151),
    [anon_sym_LPAREN2] = ACTIONS(4151),
    [anon_sym_or] = ACTIONS(4151),
    [anon_sym_exception] = ACTIONS(4151),
    [aux_sym_char_token1] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4151),
    [anon_sym_DQUOTE] = ACTIONS(4151),
    [anon_sym_AT_DQUOTE] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [sym_bool] = ACTIONS(4151),
    [sym_unit] = ACTIONS(4149),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4151),
    [sym_op_identifier] = ACTIONS(4151),
    [anon_sym_PLUS] = ACTIONS(4151),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_PLUS_DOT] = ACTIONS(4151),
    [anon_sym_DASH_DOT] = ACTIONS(4151),
    [anon_sym_PERCENT] = ACTIONS(4151),
    [anon_sym_AMP_AMP] = ACTIONS(4151),
    [anon_sym_TILDE] = ACTIONS(4149),
    [aux_sym_prefix_op_token1] = ACTIONS(4151),
    [aux_sym_infix_op_token1] = ACTIONS(4149),
    [aux_sym_infix_op_token2] = ACTIONS(4151),
    [anon_sym_PIPE_PIPE] = ACTIONS(4151),
    [anon_sym_BANG_EQ] = ACTIONS(4151),
    [anon_sym_COLON_EQ] = ACTIONS(4149),
    [anon_sym_DOLLAR] = ACTIONS(4151),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4151),
    [sym_int] = ACTIONS(4151),
    [sym_xint] = ACTIONS(4149),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4149),
    [anon_sym_POUNDload] = ACTIONS(4149),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4149),
    [sym__newline] = ACTIONS(4149),
  },
  [2440] = {
    [sym_block_comment] = STATE(2440),
    [sym_compiler_directive_decl] = STATE(2440),
    [sym_fsi_directive_decl] = STATE(2440),
    [sym_preproc_line] = STATE(2440),
    [sym_identifier] = ACTIONS(4118),
    [anon_sym_EQ] = ACTIONS(4116),
    [anon_sym_GT_RBRACK] = ACTIONS(4116),
    [anon_sym_COLON] = ACTIONS(4118),
    [anon_sym_return] = ACTIONS(4118),
    [anon_sym_do] = ACTIONS(4118),
    [anon_sym_let] = ACTIONS(4118),
    [anon_sym_let_BANG] = ACTIONS(4116),
    [anon_sym_LPAREN] = ACTIONS(4118),
    [anon_sym_COMMA] = ACTIONS(4116),
    [anon_sym_null] = ACTIONS(4118),
    [anon_sym_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_COLON] = ACTIONS(4116),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4118),
    [anon_sym_RBRACK] = ACTIONS(4116),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(4118),
    [anon_sym_RBRACE] = ACTIONS(4116),
    [anon_sym_LT_AT] = ACTIONS(4118),
    [anon_sym_LT_AT_AT] = ACTIONS(4118),
    [anon_sym_DOT] = ACTIONS(4118),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4116),
    [anon_sym_new] = ACTIONS(4118),
    [anon_sym_with] = ACTIONS(4118),
    [anon_sym_return_BANG] = ACTIONS(4116),
    [anon_sym_yield] = ACTIONS(4118),
    [anon_sym_yield_BANG] = ACTIONS(4116),
    [anon_sym_lazy] = ACTIONS(4118),
    [anon_sym_assert] = ACTIONS(4118),
    [anon_sym_upcast] = ACTIONS(4118),
    [anon_sym_downcast] = ACTIONS(4118),
    [anon_sym_COLON_GT] = ACTIONS(4116),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4116),
    [anon_sym_for] = ACTIONS(4118),
    [anon_sym_to] = ACTIONS(4118),
    [anon_sym_downto] = ACTIONS(4118),
    [anon_sym_while] = ACTIONS(4118),
    [anon_sym_if] = ACTIONS(4118),
    [anon_sym_fun] = ACTIONS(4118),
    [anon_sym_try] = ACTIONS(4118),
    [anon_sym_match] = ACTIONS(4118),
    [anon_sym_match_BANG] = ACTIONS(4116),
    [anon_sym_function] = ACTIONS(4118),
    [anon_sym_LT_DASH] = ACTIONS(4118),
    [anon_sym_DOT_LBRACK] = ACTIONS(4116),
    [anon_sym_LT] = ACTIONS(4116),
    [anon_sym_use] = ACTIONS(4118),
    [anon_sym_use_BANG] = ACTIONS(4116),
    [anon_sym_do_BANG] = ACTIONS(4116),
    [anon_sym_begin] = ACTIONS(4118),
    [anon_sym_LPAREN2] = ACTIONS(4118),
    [anon_sym_DOT_DOT2] = ACTIONS(4116),
    [anon_sym_or] = ACTIONS(4118),
    [aux_sym_char_token1] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4118),
    [anon_sym_DQUOTE] = ACTIONS(4118),
    [anon_sym_AT_DQUOTE] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [sym_bool] = ACTIONS(4118),
    [sym_unit] = ACTIONS(4116),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4118),
    [sym_op_identifier] = ACTIONS(4118),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_PLUS_DOT] = ACTIONS(4118),
    [anon_sym_DASH_DOT] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_AMP_AMP] = ACTIONS(4118),
    [anon_sym_TILDE] = ACTIONS(4116),
    [aux_sym_prefix_op_token1] = ACTIONS(4118),
    [aux_sym_infix_op_token1] = ACTIONS(4116),
    [aux_sym_infix_op_token2] = ACTIONS(4118),
    [anon_sym_PIPE_PIPE] = ACTIONS(4118),
    [anon_sym_BANG_EQ] = ACTIONS(4118),
    [anon_sym_COLON_EQ] = ACTIONS(4116),
    [anon_sym_DOLLAR] = ACTIONS(4118),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4118),
    [sym_int] = ACTIONS(4118),
    [sym_xint] = ACTIONS(4116),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4116),
    [sym__newline] = ACTIONS(4116),
  },
  [2441] = {
    [sym_block_comment] = STATE(2441),
    [sym_compiler_directive_decl] = STATE(2441),
    [sym_fsi_directive_decl] = STATE(2441),
    [sym_preproc_line] = STATE(2441),
    [sym_identifier] = ACTIONS(4112),
    [anon_sym_EQ] = ACTIONS(4110),
    [anon_sym_GT_RBRACK] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4112),
    [anon_sym_return] = ACTIONS(4112),
    [anon_sym_do] = ACTIONS(4112),
    [anon_sym_let] = ACTIONS(4112),
    [anon_sym_let_BANG] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_null] = ACTIONS(4112),
    [anon_sym_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_COLON] = ACTIONS(4110),
    [anon_sym_AMP] = ACTIONS(4112),
    [anon_sym_LBRACK] = ACTIONS(4112),
    [anon_sym_RBRACK] = ACTIONS(4110),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4110),
    [anon_sym_LBRACE] = ACTIONS(4112),
    [anon_sym_RBRACE] = ACTIONS(4110),
    [anon_sym_LT_AT] = ACTIONS(4112),
    [anon_sym_LT_AT_AT] = ACTIONS(4112),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4110),
    [anon_sym_new] = ACTIONS(4112),
    [anon_sym_with] = ACTIONS(4112),
    [anon_sym_return_BANG] = ACTIONS(4110),
    [anon_sym_yield] = ACTIONS(4112),
    [anon_sym_yield_BANG] = ACTIONS(4110),
    [anon_sym_lazy] = ACTIONS(4112),
    [anon_sym_assert] = ACTIONS(4112),
    [anon_sym_upcast] = ACTIONS(4112),
    [anon_sym_downcast] = ACTIONS(4112),
    [anon_sym_COLON_GT] = ACTIONS(4110),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4110),
    [anon_sym_for] = ACTIONS(4112),
    [anon_sym_to] = ACTIONS(4112),
    [anon_sym_downto] = ACTIONS(4112),
    [anon_sym_while] = ACTIONS(4112),
    [anon_sym_if] = ACTIONS(4112),
    [anon_sym_fun] = ACTIONS(4112),
    [anon_sym_try] = ACTIONS(4112),
    [anon_sym_match] = ACTIONS(4112),
    [anon_sym_match_BANG] = ACTIONS(4110),
    [anon_sym_function] = ACTIONS(4112),
    [anon_sym_LT_DASH] = ACTIONS(4112),
    [anon_sym_DOT_LBRACK] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(4110),
    [anon_sym_use] = ACTIONS(4112),
    [anon_sym_use_BANG] = ACTIONS(4110),
    [anon_sym_do_BANG] = ACTIONS(4110),
    [anon_sym_begin] = ACTIONS(4112),
    [anon_sym_LPAREN2] = ACTIONS(4112),
    [anon_sym_DOT_DOT2] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4112),
    [aux_sym_char_token1] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4112),
    [anon_sym_DQUOTE] = ACTIONS(4112),
    [anon_sym_AT_DQUOTE] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [sym_bool] = ACTIONS(4112),
    [sym_unit] = ACTIONS(4110),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4112),
    [sym_op_identifier] = ACTIONS(4112),
    [anon_sym_PLUS] = ACTIONS(4112),
    [anon_sym_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_DOT] = ACTIONS(4112),
    [anon_sym_DASH_DOT] = ACTIONS(4112),
    [anon_sym_PERCENT] = ACTIONS(4112),
    [anon_sym_AMP_AMP] = ACTIONS(4112),
    [anon_sym_TILDE] = ACTIONS(4110),
    [aux_sym_prefix_op_token1] = ACTIONS(4112),
    [aux_sym_infix_op_token1] = ACTIONS(4110),
    [aux_sym_infix_op_token2] = ACTIONS(4112),
    [anon_sym_PIPE_PIPE] = ACTIONS(4112),
    [anon_sym_BANG_EQ] = ACTIONS(4112),
    [anon_sym_COLON_EQ] = ACTIONS(4110),
    [anon_sym_DOLLAR] = ACTIONS(4112),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4112),
    [sym_int] = ACTIONS(4112),
    [sym_xint] = ACTIONS(4110),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4110),
    [sym__newline] = ACTIONS(4110),
  },
  [2442] = {
    [sym_block_comment] = STATE(2442),
    [sym_compiler_directive_decl] = STATE(2442),
    [sym_fsi_directive_decl] = STATE(2442),
    [sym_preproc_line] = STATE(2442),
    [ts_builtin_sym_end] = ACTIONS(3915),
    [sym_identifier] = ACTIONS(3917),
    [anon_sym_namespace] = ACTIONS(3917),
    [anon_sym_module] = ACTIONS(3917),
    [anon_sym_EQ] = ACTIONS(3915),
    [anon_sym_open] = ACTIONS(3917),
    [anon_sym_LBRACK_LT] = ACTIONS(3915),
    [anon_sym_COLON] = ACTIONS(3917),
    [anon_sym_return] = ACTIONS(3917),
    [anon_sym_type] = ACTIONS(3917),
    [anon_sym_do] = ACTIONS(3917),
    [anon_sym_let] = ACTIONS(3917),
    [anon_sym_let_BANG] = ACTIONS(3915),
    [anon_sym_LPAREN] = ACTIONS(3917),
    [anon_sym_COMMA] = ACTIONS(3915),
    [anon_sym_null] = ACTIONS(3917),
    [anon_sym_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_COLON] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(3917),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3915),
    [anon_sym_LBRACE] = ACTIONS(3917),
    [anon_sym_LT_AT] = ACTIONS(3917),
    [anon_sym_LT_AT_AT] = ACTIONS(3917),
    [anon_sym_DOT] = ACTIONS(3917),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3915),
    [anon_sym_new] = ACTIONS(3917),
    [anon_sym_return_BANG] = ACTIONS(3915),
    [anon_sym_yield] = ACTIONS(3917),
    [anon_sym_yield_BANG] = ACTIONS(3915),
    [anon_sym_lazy] = ACTIONS(3917),
    [anon_sym_assert] = ACTIONS(3917),
    [anon_sym_upcast] = ACTIONS(3917),
    [anon_sym_downcast] = ACTIONS(3917),
    [anon_sym_COLON_GT] = ACTIONS(3915),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3915),
    [anon_sym_for] = ACTIONS(3917),
    [anon_sym_while] = ACTIONS(3917),
    [anon_sym_if] = ACTIONS(3917),
    [anon_sym_fun] = ACTIONS(3917),
    [anon_sym_try] = ACTIONS(3917),
    [anon_sym_match] = ACTIONS(3917),
    [anon_sym_match_BANG] = ACTIONS(3915),
    [anon_sym_function] = ACTIONS(3917),
    [anon_sym_LT_DASH] = ACTIONS(3917),
    [anon_sym_DOT_LBRACK] = ACTIONS(3915),
    [anon_sym_LT] = ACTIONS(3915),
    [anon_sym_use] = ACTIONS(3917),
    [anon_sym_use_BANG] = ACTIONS(3915),
    [anon_sym_do_BANG] = ACTIONS(3915),
    [anon_sym_begin] = ACTIONS(3917),
    [anon_sym_LPAREN2] = ACTIONS(3917),
    [anon_sym_or] = ACTIONS(3917),
    [anon_sym_exception] = ACTIONS(3917),
    [aux_sym_char_token1] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_AT_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [sym_bool] = ACTIONS(3917),
    [sym_unit] = ACTIONS(3915),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3917),
    [sym_op_identifier] = ACTIONS(3917),
    [anon_sym_PLUS] = ACTIONS(3917),
    [anon_sym_DASH] = ACTIONS(3917),
    [anon_sym_PLUS_DOT] = ACTIONS(3917),
    [anon_sym_DASH_DOT] = ACTIONS(3917),
    [anon_sym_PERCENT] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_TILDE] = ACTIONS(3915),
    [aux_sym_prefix_op_token1] = ACTIONS(3917),
    [aux_sym_infix_op_token1] = ACTIONS(3915),
    [aux_sym_infix_op_token2] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_BANG_EQ] = ACTIONS(3917),
    [anon_sym_COLON_EQ] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3917),
    [sym_int] = ACTIONS(3917),
    [sym_xint] = ACTIONS(3915),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3915),
    [anon_sym_POUNDload] = ACTIONS(3915),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3915),
    [sym__newline] = ACTIONS(3915),
  },
  [2443] = {
    [sym_block_comment] = STATE(2443),
    [sym_compiler_directive_decl] = STATE(2443),
    [sym_fsi_directive_decl] = STATE(2443),
    [sym_preproc_line] = STATE(2443),
    [sym_identifier] = ACTIONS(4108),
    [anon_sym_EQ] = ACTIONS(4106),
    [anon_sym_GT_RBRACK] = ACTIONS(4106),
    [anon_sym_COLON] = ACTIONS(4108),
    [anon_sym_return] = ACTIONS(4108),
    [anon_sym_do] = ACTIONS(4108),
    [anon_sym_let] = ACTIONS(4108),
    [anon_sym_let_BANG] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(4108),
    [anon_sym_COMMA] = ACTIONS(4106),
    [anon_sym_null] = ACTIONS(4108),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_COLON] = ACTIONS(4106),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LBRACK] = ACTIONS(4108),
    [anon_sym_RBRACK] = ACTIONS(4106),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(4108),
    [anon_sym_RBRACE] = ACTIONS(4106),
    [anon_sym_LT_AT] = ACTIONS(4108),
    [anon_sym_LT_AT_AT] = ACTIONS(4108),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4106),
    [anon_sym_new] = ACTIONS(4108),
    [anon_sym_with] = ACTIONS(4108),
    [anon_sym_return_BANG] = ACTIONS(4106),
    [anon_sym_yield] = ACTIONS(4108),
    [anon_sym_yield_BANG] = ACTIONS(4106),
    [anon_sym_lazy] = ACTIONS(4108),
    [anon_sym_assert] = ACTIONS(4108),
    [anon_sym_upcast] = ACTIONS(4108),
    [anon_sym_downcast] = ACTIONS(4108),
    [anon_sym_COLON_GT] = ACTIONS(4106),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4106),
    [anon_sym_for] = ACTIONS(4108),
    [anon_sym_to] = ACTIONS(4108),
    [anon_sym_downto] = ACTIONS(4108),
    [anon_sym_while] = ACTIONS(4108),
    [anon_sym_if] = ACTIONS(4108),
    [anon_sym_fun] = ACTIONS(4108),
    [anon_sym_try] = ACTIONS(4108),
    [anon_sym_match] = ACTIONS(4108),
    [anon_sym_match_BANG] = ACTIONS(4106),
    [anon_sym_function] = ACTIONS(4108),
    [anon_sym_LT_DASH] = ACTIONS(4108),
    [anon_sym_DOT_LBRACK] = ACTIONS(4106),
    [anon_sym_LT] = ACTIONS(4106),
    [anon_sym_use] = ACTIONS(4108),
    [anon_sym_use_BANG] = ACTIONS(4106),
    [anon_sym_do_BANG] = ACTIONS(4106),
    [anon_sym_begin] = ACTIONS(4108),
    [anon_sym_LPAREN2] = ACTIONS(4108),
    [anon_sym_DOT_DOT2] = ACTIONS(4106),
    [anon_sym_or] = ACTIONS(4108),
    [aux_sym_char_token1] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4108),
    [anon_sym_DQUOTE] = ACTIONS(4108),
    [anon_sym_AT_DQUOTE] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [sym_bool] = ACTIONS(4108),
    [sym_unit] = ACTIONS(4106),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4108),
    [sym_op_identifier] = ACTIONS(4108),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_PLUS_DOT] = ACTIONS(4108),
    [anon_sym_DASH_DOT] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_AMP_AMP] = ACTIONS(4108),
    [anon_sym_TILDE] = ACTIONS(4106),
    [aux_sym_prefix_op_token1] = ACTIONS(4108),
    [aux_sym_infix_op_token1] = ACTIONS(4106),
    [aux_sym_infix_op_token2] = ACTIONS(4108),
    [anon_sym_PIPE_PIPE] = ACTIONS(4108),
    [anon_sym_BANG_EQ] = ACTIONS(4108),
    [anon_sym_COLON_EQ] = ACTIONS(4106),
    [anon_sym_DOLLAR] = ACTIONS(4108),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4108),
    [sym_int] = ACTIONS(4108),
    [sym_xint] = ACTIONS(4106),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4106),
    [sym__newline] = ACTIONS(4106),
  },
  [2444] = {
    [sym_block_comment] = STATE(2444),
    [sym_compiler_directive_decl] = STATE(2444),
    [sym_fsi_directive_decl] = STATE(2444),
    [sym_preproc_line] = STATE(2444),
    [ts_builtin_sym_end] = ACTIONS(4072),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_namespace] = ACTIONS(4074),
    [anon_sym_module] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4072),
    [anon_sym_open] = ACTIONS(4074),
    [anon_sym_LBRACK_LT] = ACTIONS(4072),
    [anon_sym_COLON] = ACTIONS(4074),
    [anon_sym_return] = ACTIONS(4074),
    [anon_sym_type] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_let_BANG] = ACTIONS(4072),
    [anon_sym_LPAREN] = ACTIONS(4074),
    [anon_sym_COMMA] = ACTIONS(4072),
    [anon_sym_null] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_COLON] = ACTIONS(4072),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_LT_AT] = ACTIONS(4074),
    [anon_sym_LT_AT_AT] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4072),
    [anon_sym_new] = ACTIONS(4074),
    [anon_sym_return_BANG] = ACTIONS(4072),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_yield_BANG] = ACTIONS(4072),
    [anon_sym_lazy] = ACTIONS(4074),
    [anon_sym_assert] = ACTIONS(4074),
    [anon_sym_upcast] = ACTIONS(4074),
    [anon_sym_downcast] = ACTIONS(4074),
    [anon_sym_COLON_GT] = ACTIONS(4072),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4072),
    [anon_sym_for] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_fun] = ACTIONS(4074),
    [anon_sym_try] = ACTIONS(4074),
    [anon_sym_match] = ACTIONS(4074),
    [anon_sym_match_BANG] = ACTIONS(4072),
    [anon_sym_function] = ACTIONS(4074),
    [anon_sym_LT_DASH] = ACTIONS(4074),
    [anon_sym_DOT_LBRACK] = ACTIONS(4072),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_use] = ACTIONS(4074),
    [anon_sym_use_BANG] = ACTIONS(4072),
    [anon_sym_do_BANG] = ACTIONS(4072),
    [anon_sym_begin] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_exception] = ACTIONS(4074),
    [aux_sym_char_token1] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4074),
    [anon_sym_DQUOTE] = ACTIONS(4074),
    [anon_sym_AT_DQUOTE] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [sym_bool] = ACTIONS(4074),
    [sym_unit] = ACTIONS(4072),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4074),
    [sym_op_identifier] = ACTIONS(4074),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_PLUS_DOT] = ACTIONS(4074),
    [anon_sym_DASH_DOT] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_TILDE] = ACTIONS(4072),
    [aux_sym_prefix_op_token1] = ACTIONS(4074),
    [aux_sym_infix_op_token1] = ACTIONS(4072),
    [aux_sym_infix_op_token2] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [anon_sym_BANG_EQ] = ACTIONS(4074),
    [anon_sym_COLON_EQ] = ACTIONS(4072),
    [anon_sym_DOLLAR] = ACTIONS(4074),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4074),
    [sym_int] = ACTIONS(4074),
    [sym_xint] = ACTIONS(4072),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4072),
    [anon_sym_POUNDload] = ACTIONS(4072),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4072),
    [sym__newline] = ACTIONS(4072),
  },
  [2445] = {
    [sym_block_comment] = STATE(2445),
    [sym_compiler_directive_decl] = STATE(2445),
    [sym_fsi_directive_decl] = STATE(2445),
    [sym_preproc_line] = STATE(2445),
    [sym_identifier] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4246),
    [anon_sym_GT_RBRACK] = ACTIONS(4246),
    [anon_sym_COLON] = ACTIONS(4248),
    [anon_sym_return] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4248),
    [anon_sym_let] = ACTIONS(4248),
    [anon_sym_let_BANG] = ACTIONS(4246),
    [anon_sym_LPAREN] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_null] = ACTIONS(4248),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_RBRACK] = ACTIONS(4246),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4248),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_LT_AT] = ACTIONS(4248),
    [anon_sym_LT_AT_AT] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4246),
    [anon_sym_new] = ACTIONS(4248),
    [anon_sym_with] = ACTIONS(4248),
    [anon_sym_return_BANG] = ACTIONS(4246),
    [anon_sym_yield] = ACTIONS(4248),
    [anon_sym_yield_BANG] = ACTIONS(4246),
    [anon_sym_lazy] = ACTIONS(4248),
    [anon_sym_assert] = ACTIONS(4248),
    [anon_sym_upcast] = ACTIONS(4248),
    [anon_sym_downcast] = ACTIONS(4248),
    [anon_sym_COLON_GT] = ACTIONS(4246),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4246),
    [anon_sym_for] = ACTIONS(4248),
    [anon_sym_to] = ACTIONS(4248),
    [anon_sym_downto] = ACTIONS(4248),
    [anon_sym_while] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4248),
    [anon_sym_fun] = ACTIONS(4248),
    [anon_sym_try] = ACTIONS(4248),
    [anon_sym_match] = ACTIONS(4248),
    [anon_sym_match_BANG] = ACTIONS(4246),
    [anon_sym_function] = ACTIONS(4248),
    [anon_sym_LT_DASH] = ACTIONS(4248),
    [anon_sym_DOT_LBRACK] = ACTIONS(4246),
    [anon_sym_LT] = ACTIONS(4246),
    [anon_sym_use] = ACTIONS(4248),
    [anon_sym_use_BANG] = ACTIONS(4246),
    [anon_sym_do_BANG] = ACTIONS(4246),
    [anon_sym_begin] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_DOT_DOT2] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4248),
    [aux_sym_char_token1] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4248),
    [anon_sym_DQUOTE] = ACTIONS(4248),
    [anon_sym_AT_DQUOTE] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [sym_bool] = ACTIONS(4248),
    [sym_unit] = ACTIONS(4246),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4248),
    [sym_op_identifier] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_DOT] = ACTIONS(4248),
    [anon_sym_DASH_DOT] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_TILDE] = ACTIONS(4246),
    [aux_sym_prefix_op_token1] = ACTIONS(4248),
    [aux_sym_infix_op_token1] = ACTIONS(4246),
    [aux_sym_infix_op_token2] = ACTIONS(4248),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_COLON_EQ] = ACTIONS(4246),
    [anon_sym_DOLLAR] = ACTIONS(4248),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4248),
    [sym_int] = ACTIONS(4248),
    [sym_xint] = ACTIONS(4246),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4246),
    [sym__newline] = ACTIONS(4246),
  },
  [2446] = {
    [sym_block_comment] = STATE(2446),
    [sym_compiler_directive_decl] = STATE(2446),
    [sym_fsi_directive_decl] = STATE(2446),
    [sym_preproc_line] = STATE(2446),
    [sym_identifier] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4242),
    [anon_sym_GT_RBRACK] = ACTIONS(4242),
    [anon_sym_COLON] = ACTIONS(4244),
    [anon_sym_return] = ACTIONS(4244),
    [anon_sym_do] = ACTIONS(4244),
    [anon_sym_let] = ACTIONS(4244),
    [anon_sym_let_BANG] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_null] = ACTIONS(4244),
    [anon_sym_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_COLON] = ACTIONS(4242),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [anon_sym_RBRACK] = ACTIONS(4242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4244),
    [anon_sym_RBRACE] = ACTIONS(4242),
    [anon_sym_LT_AT] = ACTIONS(4244),
    [anon_sym_LT_AT_AT] = ACTIONS(4244),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4242),
    [anon_sym_new] = ACTIONS(4244),
    [anon_sym_with] = ACTIONS(4244),
    [anon_sym_return_BANG] = ACTIONS(4242),
    [anon_sym_yield] = ACTIONS(4244),
    [anon_sym_yield_BANG] = ACTIONS(4242),
    [anon_sym_lazy] = ACTIONS(4244),
    [anon_sym_assert] = ACTIONS(4244),
    [anon_sym_upcast] = ACTIONS(4244),
    [anon_sym_downcast] = ACTIONS(4244),
    [anon_sym_COLON_GT] = ACTIONS(4242),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4242),
    [anon_sym_for] = ACTIONS(4244),
    [anon_sym_to] = ACTIONS(4244),
    [anon_sym_downto] = ACTIONS(4244),
    [anon_sym_while] = ACTIONS(4244),
    [anon_sym_if] = ACTIONS(4244),
    [anon_sym_fun] = ACTIONS(4244),
    [anon_sym_try] = ACTIONS(4244),
    [anon_sym_match] = ACTIONS(4244),
    [anon_sym_match_BANG] = ACTIONS(4242),
    [anon_sym_function] = ACTIONS(4244),
    [anon_sym_LT_DASH] = ACTIONS(4244),
    [anon_sym_DOT_LBRACK] = ACTIONS(4242),
    [anon_sym_LT] = ACTIONS(4242),
    [anon_sym_use] = ACTIONS(4244),
    [anon_sym_use_BANG] = ACTIONS(4242),
    [anon_sym_do_BANG] = ACTIONS(4242),
    [anon_sym_begin] = ACTIONS(4244),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_DOT_DOT2] = ACTIONS(4242),
    [anon_sym_or] = ACTIONS(4244),
    [aux_sym_char_token1] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4244),
    [anon_sym_DQUOTE] = ACTIONS(4244),
    [anon_sym_AT_DQUOTE] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [sym_bool] = ACTIONS(4244),
    [sym_unit] = ACTIONS(4242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4244),
    [sym_op_identifier] = ACTIONS(4244),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_DASH] = ACTIONS(4244),
    [anon_sym_PLUS_DOT] = ACTIONS(4244),
    [anon_sym_DASH_DOT] = ACTIONS(4244),
    [anon_sym_PERCENT] = ACTIONS(4244),
    [anon_sym_AMP_AMP] = ACTIONS(4244),
    [anon_sym_TILDE] = ACTIONS(4242),
    [aux_sym_prefix_op_token1] = ACTIONS(4244),
    [aux_sym_infix_op_token1] = ACTIONS(4242),
    [aux_sym_infix_op_token2] = ACTIONS(4244),
    [anon_sym_PIPE_PIPE] = ACTIONS(4244),
    [anon_sym_BANG_EQ] = ACTIONS(4244),
    [anon_sym_COLON_EQ] = ACTIONS(4242),
    [anon_sym_DOLLAR] = ACTIONS(4244),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4244),
    [sym_int] = ACTIONS(4244),
    [sym_xint] = ACTIONS(4242),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4242),
    [sym__newline] = ACTIONS(4242),
  },
  [2447] = {
    [sym_block_comment] = STATE(2447),
    [sym_compiler_directive_decl] = STATE(2447),
    [sym_fsi_directive_decl] = STATE(2447),
    [sym_preproc_line] = STATE(2447),
    [aux_sym_type_argument_repeat1] = STATE(2412),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [anon_sym_as] = ACTIONS(3498),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_with] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [anon_sym_DOT_LBRACK] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_or] = ACTIONS(4966),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3498),
    [anon_sym_DASH_DOT] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3498),
    [aux_sym_infix_op_token1] = ACTIONS(3496),
    [aux_sym_infix_op_token2] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_COLON_EQ] = ACTIONS(3496),
    [anon_sym_DOLLAR] = ACTIONS(3498),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3498),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
  },
  [2448] = {
    [sym_block_comment] = STATE(2448),
    [sym_compiler_directive_decl] = STATE(2448),
    [sym_fsi_directive_decl] = STATE(2448),
    [sym_preproc_line] = STATE(2448),
    [sym_identifier] = ACTIONS(4240),
    [anon_sym_EQ] = ACTIONS(4238),
    [anon_sym_GT_RBRACK] = ACTIONS(4238),
    [anon_sym_COLON] = ACTIONS(4240),
    [anon_sym_return] = ACTIONS(4240),
    [anon_sym_do] = ACTIONS(4240),
    [anon_sym_let] = ACTIONS(4240),
    [anon_sym_let_BANG] = ACTIONS(4238),
    [anon_sym_LPAREN] = ACTIONS(4240),
    [anon_sym_COMMA] = ACTIONS(4238),
    [anon_sym_null] = ACTIONS(4240),
    [anon_sym_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_COLON] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4240),
    [anon_sym_LBRACK] = ACTIONS(4240),
    [anon_sym_RBRACK] = ACTIONS(4238),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4238),
    [anon_sym_LBRACE] = ACTIONS(4240),
    [anon_sym_RBRACE] = ACTIONS(4238),
    [anon_sym_LT_AT] = ACTIONS(4240),
    [anon_sym_LT_AT_AT] = ACTIONS(4240),
    [anon_sym_DOT] = ACTIONS(4240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4238),
    [anon_sym_new] = ACTIONS(4240),
    [anon_sym_with] = ACTIONS(4240),
    [anon_sym_return_BANG] = ACTIONS(4238),
    [anon_sym_yield] = ACTIONS(4240),
    [anon_sym_yield_BANG] = ACTIONS(4238),
    [anon_sym_lazy] = ACTIONS(4240),
    [anon_sym_assert] = ACTIONS(4240),
    [anon_sym_upcast] = ACTIONS(4240),
    [anon_sym_downcast] = ACTIONS(4240),
    [anon_sym_COLON_GT] = ACTIONS(4238),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4238),
    [anon_sym_for] = ACTIONS(4240),
    [anon_sym_to] = ACTIONS(4240),
    [anon_sym_downto] = ACTIONS(4240),
    [anon_sym_while] = ACTIONS(4240),
    [anon_sym_if] = ACTIONS(4240),
    [anon_sym_fun] = ACTIONS(4240),
    [anon_sym_try] = ACTIONS(4240),
    [anon_sym_match] = ACTIONS(4240),
    [anon_sym_match_BANG] = ACTIONS(4238),
    [anon_sym_function] = ACTIONS(4240),
    [anon_sym_LT_DASH] = ACTIONS(4240),
    [anon_sym_DOT_LBRACK] = ACTIONS(4238),
    [anon_sym_LT] = ACTIONS(4238),
    [anon_sym_use] = ACTIONS(4240),
    [anon_sym_use_BANG] = ACTIONS(4238),
    [anon_sym_do_BANG] = ACTIONS(4238),
    [anon_sym_begin] = ACTIONS(4240),
    [anon_sym_LPAREN2] = ACTIONS(4240),
    [anon_sym_DOT_DOT2] = ACTIONS(4238),
    [anon_sym_or] = ACTIONS(4240),
    [aux_sym_char_token1] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4240),
    [anon_sym_DQUOTE] = ACTIONS(4240),
    [anon_sym_AT_DQUOTE] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [sym_bool] = ACTIONS(4240),
    [sym_unit] = ACTIONS(4238),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4240),
    [sym_op_identifier] = ACTIONS(4240),
    [anon_sym_PLUS] = ACTIONS(4240),
    [anon_sym_DASH] = ACTIONS(4240),
    [anon_sym_PLUS_DOT] = ACTIONS(4240),
    [anon_sym_DASH_DOT] = ACTIONS(4240),
    [anon_sym_PERCENT] = ACTIONS(4240),
    [anon_sym_AMP_AMP] = ACTIONS(4240),
    [anon_sym_TILDE] = ACTIONS(4238),
    [aux_sym_prefix_op_token1] = ACTIONS(4240),
    [aux_sym_infix_op_token1] = ACTIONS(4238),
    [aux_sym_infix_op_token2] = ACTIONS(4240),
    [anon_sym_PIPE_PIPE] = ACTIONS(4240),
    [anon_sym_BANG_EQ] = ACTIONS(4240),
    [anon_sym_COLON_EQ] = ACTIONS(4238),
    [anon_sym_DOLLAR] = ACTIONS(4240),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4240),
    [sym_int] = ACTIONS(4240),
    [sym_xint] = ACTIONS(4238),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4238),
    [sym__newline] = ACTIONS(4238),
  },
  [2449] = {
    [sym_block_comment] = STATE(2449),
    [sym_compiler_directive_decl] = STATE(2449),
    [sym_fsi_directive_decl] = STATE(2449),
    [sym_preproc_line] = STATE(2449),
    [sym_identifier] = ACTIONS(4100),
    [anon_sym_EQ] = ACTIONS(4098),
    [anon_sym_GT_RBRACK] = ACTIONS(4098),
    [anon_sym_COLON] = ACTIONS(4100),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_do] = ACTIONS(4100),
    [anon_sym_let] = ACTIONS(4100),
    [anon_sym_let_BANG] = ACTIONS(4098),
    [anon_sym_LPAREN] = ACTIONS(4100),
    [anon_sym_COMMA] = ACTIONS(4098),
    [anon_sym_null] = ACTIONS(4100),
    [anon_sym_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_COLON] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4100),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_RBRACK] = ACTIONS(4098),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4098),
    [anon_sym_LBRACE] = ACTIONS(4100),
    [anon_sym_RBRACE] = ACTIONS(4098),
    [anon_sym_LT_AT] = ACTIONS(4100),
    [anon_sym_LT_AT_AT] = ACTIONS(4100),
    [anon_sym_DOT] = ACTIONS(4100),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4098),
    [anon_sym_new] = ACTIONS(4100),
    [anon_sym_with] = ACTIONS(4100),
    [anon_sym_return_BANG] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4100),
    [anon_sym_yield_BANG] = ACTIONS(4098),
    [anon_sym_lazy] = ACTIONS(4100),
    [anon_sym_assert] = ACTIONS(4100),
    [anon_sym_upcast] = ACTIONS(4100),
    [anon_sym_downcast] = ACTIONS(4100),
    [anon_sym_COLON_GT] = ACTIONS(4098),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4098),
    [anon_sym_for] = ACTIONS(4100),
    [anon_sym_to] = ACTIONS(4100),
    [anon_sym_downto] = ACTIONS(4100),
    [anon_sym_while] = ACTIONS(4100),
    [anon_sym_if] = ACTIONS(4100),
    [anon_sym_fun] = ACTIONS(4100),
    [anon_sym_try] = ACTIONS(4100),
    [anon_sym_match] = ACTIONS(4100),
    [anon_sym_match_BANG] = ACTIONS(4098),
    [anon_sym_function] = ACTIONS(4100),
    [anon_sym_LT_DASH] = ACTIONS(4100),
    [anon_sym_DOT_LBRACK] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(4098),
    [anon_sym_use] = ACTIONS(4100),
    [anon_sym_use_BANG] = ACTIONS(4098),
    [anon_sym_do_BANG] = ACTIONS(4098),
    [anon_sym_begin] = ACTIONS(4100),
    [anon_sym_LPAREN2] = ACTIONS(4100),
    [anon_sym_DOT_DOT2] = ACTIONS(4098),
    [anon_sym_or] = ACTIONS(4100),
    [aux_sym_char_token1] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4100),
    [anon_sym_DQUOTE] = ACTIONS(4100),
    [anon_sym_AT_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [sym_bool] = ACTIONS(4100),
    [sym_unit] = ACTIONS(4098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4100),
    [sym_op_identifier] = ACTIONS(4100),
    [anon_sym_PLUS] = ACTIONS(4100),
    [anon_sym_DASH] = ACTIONS(4100),
    [anon_sym_PLUS_DOT] = ACTIONS(4100),
    [anon_sym_DASH_DOT] = ACTIONS(4100),
    [anon_sym_PERCENT] = ACTIONS(4100),
    [anon_sym_AMP_AMP] = ACTIONS(4100),
    [anon_sym_TILDE] = ACTIONS(4098),
    [aux_sym_prefix_op_token1] = ACTIONS(4100),
    [aux_sym_infix_op_token1] = ACTIONS(4098),
    [aux_sym_infix_op_token2] = ACTIONS(4100),
    [anon_sym_PIPE_PIPE] = ACTIONS(4100),
    [anon_sym_BANG_EQ] = ACTIONS(4100),
    [anon_sym_COLON_EQ] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4100),
    [sym_int] = ACTIONS(4100),
    [sym_xint] = ACTIONS(4098),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4098),
    [sym__newline] = ACTIONS(4098),
  },
  [2450] = {
    [sym_block_comment] = STATE(2450),
    [sym_compiler_directive_decl] = STATE(2450),
    [sym_fsi_directive_decl] = STATE(2450),
    [sym_preproc_line] = STATE(2450),
    [sym_identifier] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(4091),
    [anon_sym_GT_RBRACK] = ACTIONS(4091),
    [anon_sym_COLON] = ACTIONS(4093),
    [anon_sym_return] = ACTIONS(4093),
    [anon_sym_do] = ACTIONS(4093),
    [anon_sym_let] = ACTIONS(4093),
    [anon_sym_let_BANG] = ACTIONS(4091),
    [anon_sym_LPAREN] = ACTIONS(4093),
    [anon_sym_COMMA] = ACTIONS(4091),
    [anon_sym_null] = ACTIONS(4093),
    [anon_sym_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_COLON] = ACTIONS(4091),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(4093),
    [anon_sym_RBRACK] = ACTIONS(4091),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4091),
    [anon_sym_LBRACE] = ACTIONS(4093),
    [anon_sym_RBRACE] = ACTIONS(4091),
    [anon_sym_LT_AT] = ACTIONS(4093),
    [anon_sym_LT_AT_AT] = ACTIONS(4093),
    [anon_sym_DOT] = ACTIONS(4093),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4091),
    [anon_sym_new] = ACTIONS(4093),
    [anon_sym_with] = ACTIONS(4093),
    [anon_sym_return_BANG] = ACTIONS(4091),
    [anon_sym_yield] = ACTIONS(4093),
    [anon_sym_yield_BANG] = ACTIONS(4091),
    [anon_sym_lazy] = ACTIONS(4093),
    [anon_sym_assert] = ACTIONS(4093),
    [anon_sym_upcast] = ACTIONS(4093),
    [anon_sym_downcast] = ACTIONS(4093),
    [anon_sym_COLON_GT] = ACTIONS(4091),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4091),
    [anon_sym_for] = ACTIONS(4093),
    [anon_sym_to] = ACTIONS(4093),
    [anon_sym_downto] = ACTIONS(4093),
    [anon_sym_while] = ACTIONS(4093),
    [anon_sym_if] = ACTIONS(4093),
    [anon_sym_fun] = ACTIONS(4093),
    [anon_sym_try] = ACTIONS(4093),
    [anon_sym_match] = ACTIONS(4093),
    [anon_sym_match_BANG] = ACTIONS(4091),
    [anon_sym_function] = ACTIONS(4093),
    [anon_sym_LT_DASH] = ACTIONS(4093),
    [anon_sym_DOT_LBRACK] = ACTIONS(4091),
    [anon_sym_LT] = ACTIONS(4091),
    [anon_sym_use] = ACTIONS(4093),
    [anon_sym_use_BANG] = ACTIONS(4091),
    [anon_sym_do_BANG] = ACTIONS(4091),
    [anon_sym_begin] = ACTIONS(4093),
    [anon_sym_LPAREN2] = ACTIONS(4093),
    [anon_sym_DOT_DOT2] = ACTIONS(4091),
    [anon_sym_or] = ACTIONS(4093),
    [aux_sym_char_token1] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4093),
    [anon_sym_DQUOTE] = ACTIONS(4093),
    [anon_sym_AT_DQUOTE] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [sym_bool] = ACTIONS(4093),
    [sym_unit] = ACTIONS(4091),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4093),
    [sym_op_identifier] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS_DOT] = ACTIONS(4093),
    [anon_sym_DASH_DOT] = ACTIONS(4093),
    [anon_sym_PERCENT] = ACTIONS(4093),
    [anon_sym_AMP_AMP] = ACTIONS(4093),
    [anon_sym_TILDE] = ACTIONS(4091),
    [aux_sym_prefix_op_token1] = ACTIONS(4093),
    [aux_sym_infix_op_token1] = ACTIONS(4091),
    [aux_sym_infix_op_token2] = ACTIONS(4093),
    [anon_sym_PIPE_PIPE] = ACTIONS(4093),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_COLON_EQ] = ACTIONS(4091),
    [anon_sym_DOLLAR] = ACTIONS(4093),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4093),
    [sym_int] = ACTIONS(4093),
    [sym_xint] = ACTIONS(4091),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4091),
    [sym__newline] = ACTIONS(4091),
  },
  [2451] = {
    [sym_block_comment] = STATE(2451),
    [sym_compiler_directive_decl] = STATE(2451),
    [sym_fsi_directive_decl] = STATE(2451),
    [sym_preproc_line] = STATE(2451),
    [sym_identifier] = ACTIONS(4086),
    [anon_sym_EQ] = ACTIONS(4084),
    [anon_sym_GT_RBRACK] = ACTIONS(4084),
    [anon_sym_COLON] = ACTIONS(4086),
    [anon_sym_return] = ACTIONS(4086),
    [anon_sym_do] = ACTIONS(4086),
    [anon_sym_let] = ACTIONS(4086),
    [anon_sym_let_BANG] = ACTIONS(4084),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_COMMA] = ACTIONS(4084),
    [anon_sym_null] = ACTIONS(4086),
    [anon_sym_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_COLON] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_RBRACK] = ACTIONS(4084),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4084),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_RBRACE] = ACTIONS(4084),
    [anon_sym_LT_AT] = ACTIONS(4086),
    [anon_sym_LT_AT_AT] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4086),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4084),
    [anon_sym_new] = ACTIONS(4086),
    [anon_sym_with] = ACTIONS(4086),
    [anon_sym_return_BANG] = ACTIONS(4084),
    [anon_sym_yield] = ACTIONS(4086),
    [anon_sym_yield_BANG] = ACTIONS(4084),
    [anon_sym_lazy] = ACTIONS(4086),
    [anon_sym_assert] = ACTIONS(4086),
    [anon_sym_upcast] = ACTIONS(4086),
    [anon_sym_downcast] = ACTIONS(4086),
    [anon_sym_COLON_GT] = ACTIONS(4084),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4084),
    [anon_sym_for] = ACTIONS(4086),
    [anon_sym_to] = ACTIONS(4086),
    [anon_sym_downto] = ACTIONS(4086),
    [anon_sym_while] = ACTIONS(4086),
    [anon_sym_if] = ACTIONS(4086),
    [anon_sym_fun] = ACTIONS(4086),
    [anon_sym_try] = ACTIONS(4086),
    [anon_sym_match] = ACTIONS(4086),
    [anon_sym_match_BANG] = ACTIONS(4084),
    [anon_sym_function] = ACTIONS(4086),
    [anon_sym_LT_DASH] = ACTIONS(4086),
    [anon_sym_DOT_LBRACK] = ACTIONS(4084),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_use] = ACTIONS(4086),
    [anon_sym_use_BANG] = ACTIONS(4084),
    [anon_sym_do_BANG] = ACTIONS(4084),
    [anon_sym_begin] = ACTIONS(4086),
    [anon_sym_LPAREN2] = ACTIONS(4086),
    [anon_sym_DOT_DOT2] = ACTIONS(4084),
    [anon_sym_or] = ACTIONS(4086),
    [aux_sym_char_token1] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4086),
    [anon_sym_DQUOTE] = ACTIONS(4086),
    [anon_sym_AT_DQUOTE] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [sym_bool] = ACTIONS(4086),
    [sym_unit] = ACTIONS(4084),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4086),
    [sym_op_identifier] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4086),
    [anon_sym_DASH] = ACTIONS(4086),
    [anon_sym_PLUS_DOT] = ACTIONS(4086),
    [anon_sym_DASH_DOT] = ACTIONS(4086),
    [anon_sym_PERCENT] = ACTIONS(4086),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_TILDE] = ACTIONS(4084),
    [aux_sym_prefix_op_token1] = ACTIONS(4086),
    [aux_sym_infix_op_token1] = ACTIONS(4084),
    [aux_sym_infix_op_token2] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_COLON_EQ] = ACTIONS(4084),
    [anon_sym_DOLLAR] = ACTIONS(4086),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4086),
    [sym_int] = ACTIONS(4086),
    [sym_xint] = ACTIONS(4084),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4084),
    [sym__newline] = ACTIONS(4084),
  },
  [2452] = {
    [sym_block_comment] = STATE(2452),
    [sym_compiler_directive_decl] = STATE(2452),
    [sym_fsi_directive_decl] = STATE(2452),
    [sym_preproc_line] = STATE(2452),
    [ts_builtin_sym_end] = ACTIONS(4020),
    [sym_identifier] = ACTIONS(4022),
    [anon_sym_namespace] = ACTIONS(4022),
    [anon_sym_module] = ACTIONS(4022),
    [anon_sym_EQ] = ACTIONS(4020),
    [anon_sym_open] = ACTIONS(4022),
    [anon_sym_LBRACK_LT] = ACTIONS(4020),
    [anon_sym_COLON] = ACTIONS(4022),
    [anon_sym_return] = ACTIONS(4022),
    [anon_sym_type] = ACTIONS(4022),
    [anon_sym_do] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_let_BANG] = ACTIONS(4020),
    [anon_sym_LPAREN] = ACTIONS(4022),
    [anon_sym_COMMA] = ACTIONS(4020),
    [anon_sym_null] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_COLON] = ACTIONS(4020),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4022),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(4022),
    [anon_sym_LT_AT] = ACTIONS(4022),
    [anon_sym_LT_AT_AT] = ACTIONS(4022),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4020),
    [anon_sym_new] = ACTIONS(4022),
    [anon_sym_return_BANG] = ACTIONS(4020),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_yield_BANG] = ACTIONS(4020),
    [anon_sym_lazy] = ACTIONS(4022),
    [anon_sym_assert] = ACTIONS(4022),
    [anon_sym_upcast] = ACTIONS(4022),
    [anon_sym_downcast] = ACTIONS(4022),
    [anon_sym_COLON_GT] = ACTIONS(4020),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4020),
    [anon_sym_for] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4022),
    [anon_sym_if] = ACTIONS(4022),
    [anon_sym_fun] = ACTIONS(4022),
    [anon_sym_try] = ACTIONS(4022),
    [anon_sym_match] = ACTIONS(4022),
    [anon_sym_match_BANG] = ACTIONS(4020),
    [anon_sym_function] = ACTIONS(4022),
    [anon_sym_LT_DASH] = ACTIONS(4022),
    [anon_sym_DOT_LBRACK] = ACTIONS(4020),
    [anon_sym_LT] = ACTIONS(4020),
    [anon_sym_use] = ACTIONS(4022),
    [anon_sym_use_BANG] = ACTIONS(4020),
    [anon_sym_do_BANG] = ACTIONS(4020),
    [anon_sym_begin] = ACTIONS(4022),
    [anon_sym_LPAREN2] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [anon_sym_exception] = ACTIONS(4022),
    [aux_sym_char_token1] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4022),
    [anon_sym_DQUOTE] = ACTIONS(4022),
    [anon_sym_AT_DQUOTE] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [sym_bool] = ACTIONS(4022),
    [sym_unit] = ACTIONS(4020),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4022),
    [sym_op_identifier] = ACTIONS(4022),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_PLUS_DOT] = ACTIONS(4022),
    [anon_sym_DASH_DOT] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4022),
    [anon_sym_TILDE] = ACTIONS(4020),
    [aux_sym_prefix_op_token1] = ACTIONS(4022),
    [aux_sym_infix_op_token1] = ACTIONS(4020),
    [aux_sym_infix_op_token2] = ACTIONS(4022),
    [anon_sym_PIPE_PIPE] = ACTIONS(4022),
    [anon_sym_BANG_EQ] = ACTIONS(4022),
    [anon_sym_COLON_EQ] = ACTIONS(4020),
    [anon_sym_DOLLAR] = ACTIONS(4022),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4022),
    [sym_int] = ACTIONS(4022),
    [sym_xint] = ACTIONS(4020),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4020),
    [anon_sym_POUNDload] = ACTIONS(4020),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4020),
    [sym__newline] = ACTIONS(4020),
  },
  [2453] = {
    [sym_block_comment] = STATE(2453),
    [sym_compiler_directive_decl] = STATE(2453),
    [sym_fsi_directive_decl] = STATE(2453),
    [sym_preproc_line] = STATE(2453),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_GT_RBRACK] = ACTIONS(4080),
    [anon_sym_COLON] = ACTIONS(4082),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_do] = ACTIONS(4082),
    [anon_sym_let] = ACTIONS(4082),
    [anon_sym_let_BANG] = ACTIONS(4080),
    [anon_sym_LPAREN] = ACTIONS(4082),
    [anon_sym_COMMA] = ACTIONS(4080),
    [anon_sym_null] = ACTIONS(4082),
    [anon_sym_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_COLON] = ACTIONS(4080),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_LBRACK] = ACTIONS(4082),
    [anon_sym_RBRACK] = ACTIONS(4080),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(4082),
    [anon_sym_RBRACE] = ACTIONS(4080),
    [anon_sym_LT_AT] = ACTIONS(4082),
    [anon_sym_LT_AT_AT] = ACTIONS(4082),
    [anon_sym_DOT] = ACTIONS(4082),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4080),
    [anon_sym_new] = ACTIONS(4082),
    [anon_sym_with] = ACTIONS(4082),
    [anon_sym_return_BANG] = ACTIONS(4080),
    [anon_sym_yield] = ACTIONS(4082),
    [anon_sym_yield_BANG] = ACTIONS(4080),
    [anon_sym_lazy] = ACTIONS(4082),
    [anon_sym_assert] = ACTIONS(4082),
    [anon_sym_upcast] = ACTIONS(4082),
    [anon_sym_downcast] = ACTIONS(4082),
    [anon_sym_COLON_GT] = ACTIONS(4080),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4080),
    [anon_sym_for] = ACTIONS(4082),
    [anon_sym_to] = ACTIONS(4082),
    [anon_sym_downto] = ACTIONS(4082),
    [anon_sym_while] = ACTIONS(4082),
    [anon_sym_if] = ACTIONS(4082),
    [anon_sym_fun] = ACTIONS(4082),
    [anon_sym_try] = ACTIONS(4082),
    [anon_sym_match] = ACTIONS(4082),
    [anon_sym_match_BANG] = ACTIONS(4080),
    [anon_sym_function] = ACTIONS(4082),
    [anon_sym_LT_DASH] = ACTIONS(4082),
    [anon_sym_DOT_LBRACK] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(4080),
    [anon_sym_use] = ACTIONS(4082),
    [anon_sym_use_BANG] = ACTIONS(4080),
    [anon_sym_do_BANG] = ACTIONS(4080),
    [anon_sym_begin] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4082),
    [anon_sym_DOT_DOT2] = ACTIONS(4080),
    [anon_sym_or] = ACTIONS(4082),
    [aux_sym_char_token1] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4082),
    [anon_sym_DQUOTE] = ACTIONS(4082),
    [anon_sym_AT_DQUOTE] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [sym_bool] = ACTIONS(4082),
    [sym_unit] = ACTIONS(4080),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4082),
    [sym_op_identifier] = ACTIONS(4082),
    [anon_sym_PLUS] = ACTIONS(4082),
    [anon_sym_DASH] = ACTIONS(4082),
    [anon_sym_PLUS_DOT] = ACTIONS(4082),
    [anon_sym_DASH_DOT] = ACTIONS(4082),
    [anon_sym_PERCENT] = ACTIONS(4082),
    [anon_sym_AMP_AMP] = ACTIONS(4082),
    [anon_sym_TILDE] = ACTIONS(4080),
    [aux_sym_prefix_op_token1] = ACTIONS(4082),
    [aux_sym_infix_op_token1] = ACTIONS(4080),
    [aux_sym_infix_op_token2] = ACTIONS(4082),
    [anon_sym_PIPE_PIPE] = ACTIONS(4082),
    [anon_sym_BANG_EQ] = ACTIONS(4082),
    [anon_sym_COLON_EQ] = ACTIONS(4080),
    [anon_sym_DOLLAR] = ACTIONS(4082),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4082),
    [sym_int] = ACTIONS(4082),
    [sym_xint] = ACTIONS(4080),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4080),
    [sym__newline] = ACTIONS(4080),
  },
  [2454] = {
    [sym_block_comment] = STATE(2454),
    [sym_compiler_directive_decl] = STATE(2454),
    [sym_fsi_directive_decl] = STATE(2454),
    [sym_preproc_line] = STATE(2454),
    [sym_identifier] = ACTIONS(4054),
    [anon_sym_EQ] = ACTIONS(4052),
    [anon_sym_GT_RBRACK] = ACTIONS(4052),
    [anon_sym_COLON] = ACTIONS(4054),
    [anon_sym_return] = ACTIONS(4054),
    [anon_sym_do] = ACTIONS(4054),
    [anon_sym_let] = ACTIONS(4054),
    [anon_sym_let_BANG] = ACTIONS(4052),
    [anon_sym_LPAREN] = ACTIONS(4054),
    [anon_sym_COMMA] = ACTIONS(4052),
    [anon_sym_null] = ACTIONS(4054),
    [anon_sym_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_COLON] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(4054),
    [anon_sym_RBRACK] = ACTIONS(4052),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4052),
    [anon_sym_LBRACE] = ACTIONS(4054),
    [anon_sym_RBRACE] = ACTIONS(4052),
    [anon_sym_LT_AT] = ACTIONS(4054),
    [anon_sym_LT_AT_AT] = ACTIONS(4054),
    [anon_sym_DOT] = ACTIONS(4054),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_with] = ACTIONS(4054),
    [anon_sym_return_BANG] = ACTIONS(4052),
    [anon_sym_yield] = ACTIONS(4054),
    [anon_sym_yield_BANG] = ACTIONS(4052),
    [anon_sym_lazy] = ACTIONS(4054),
    [anon_sym_assert] = ACTIONS(4054),
    [anon_sym_upcast] = ACTIONS(4054),
    [anon_sym_downcast] = ACTIONS(4054),
    [anon_sym_COLON_GT] = ACTIONS(4052),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4052),
    [anon_sym_for] = ACTIONS(4054),
    [anon_sym_to] = ACTIONS(4054),
    [anon_sym_downto] = ACTIONS(4054),
    [anon_sym_while] = ACTIONS(4054),
    [anon_sym_if] = ACTIONS(4054),
    [anon_sym_fun] = ACTIONS(4054),
    [anon_sym_try] = ACTIONS(4054),
    [anon_sym_match] = ACTIONS(4054),
    [anon_sym_match_BANG] = ACTIONS(4052),
    [anon_sym_function] = ACTIONS(4054),
    [anon_sym_LT_DASH] = ACTIONS(4054),
    [anon_sym_DOT_LBRACK] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_use] = ACTIONS(4054),
    [anon_sym_use_BANG] = ACTIONS(4052),
    [anon_sym_do_BANG] = ACTIONS(4052),
    [anon_sym_begin] = ACTIONS(4054),
    [anon_sym_LPAREN2] = ACTIONS(4054),
    [anon_sym_DOT_DOT2] = ACTIONS(4052),
    [anon_sym_or] = ACTIONS(4054),
    [aux_sym_char_token1] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4054),
    [anon_sym_DQUOTE] = ACTIONS(4054),
    [anon_sym_AT_DQUOTE] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [sym_bool] = ACTIONS(4054),
    [sym_unit] = ACTIONS(4052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4054),
    [sym_op_identifier] = ACTIONS(4054),
    [anon_sym_PLUS] = ACTIONS(4054),
    [anon_sym_DASH] = ACTIONS(4054),
    [anon_sym_PLUS_DOT] = ACTIONS(4054),
    [anon_sym_DASH_DOT] = ACTIONS(4054),
    [anon_sym_PERCENT] = ACTIONS(4054),
    [anon_sym_AMP_AMP] = ACTIONS(4054),
    [anon_sym_TILDE] = ACTIONS(4052),
    [aux_sym_prefix_op_token1] = ACTIONS(4054),
    [aux_sym_infix_op_token1] = ACTIONS(4052),
    [aux_sym_infix_op_token2] = ACTIONS(4054),
    [anon_sym_PIPE_PIPE] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4054),
    [anon_sym_COLON_EQ] = ACTIONS(4052),
    [anon_sym_DOLLAR] = ACTIONS(4054),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4054),
    [sym_int] = ACTIONS(4054),
    [sym_xint] = ACTIONS(4052),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4052),
    [sym__newline] = ACTIONS(4052),
  },
  [2455] = {
    [sym_block_comment] = STATE(2455),
    [sym_compiler_directive_decl] = STATE(2455),
    [sym_fsi_directive_decl] = STATE(2455),
    [sym_preproc_line] = STATE(2455),
    [sym_identifier] = ACTIONS(4236),
    [anon_sym_EQ] = ACTIONS(4234),
    [anon_sym_GT_RBRACK] = ACTIONS(4234),
    [anon_sym_COLON] = ACTIONS(4236),
    [anon_sym_return] = ACTIONS(4236),
    [anon_sym_do] = ACTIONS(4236),
    [anon_sym_let] = ACTIONS(4236),
    [anon_sym_let_BANG] = ACTIONS(4234),
    [anon_sym_LPAREN] = ACTIONS(4236),
    [anon_sym_COMMA] = ACTIONS(4234),
    [anon_sym_null] = ACTIONS(4236),
    [anon_sym_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_COLON] = ACTIONS(4234),
    [anon_sym_AMP] = ACTIONS(4236),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_RBRACK] = ACTIONS(4234),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4234),
    [anon_sym_LBRACE] = ACTIONS(4236),
    [anon_sym_RBRACE] = ACTIONS(4234),
    [anon_sym_LT_AT] = ACTIONS(4236),
    [anon_sym_LT_AT_AT] = ACTIONS(4236),
    [anon_sym_DOT] = ACTIONS(4236),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4234),
    [anon_sym_new] = ACTIONS(4236),
    [anon_sym_with] = ACTIONS(4236),
    [anon_sym_return_BANG] = ACTIONS(4234),
    [anon_sym_yield] = ACTIONS(4236),
    [anon_sym_yield_BANG] = ACTIONS(4234),
    [anon_sym_lazy] = ACTIONS(4236),
    [anon_sym_assert] = ACTIONS(4236),
    [anon_sym_upcast] = ACTIONS(4236),
    [anon_sym_downcast] = ACTIONS(4236),
    [anon_sym_COLON_GT] = ACTIONS(4234),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4234),
    [anon_sym_for] = ACTIONS(4236),
    [anon_sym_to] = ACTIONS(4236),
    [anon_sym_downto] = ACTIONS(4236),
    [anon_sym_while] = ACTIONS(4236),
    [anon_sym_if] = ACTIONS(4236),
    [anon_sym_fun] = ACTIONS(4236),
    [anon_sym_try] = ACTIONS(4236),
    [anon_sym_match] = ACTIONS(4236),
    [anon_sym_match_BANG] = ACTIONS(4234),
    [anon_sym_function] = ACTIONS(4236),
    [anon_sym_LT_DASH] = ACTIONS(4236),
    [anon_sym_DOT_LBRACK] = ACTIONS(4234),
    [anon_sym_LT] = ACTIONS(4234),
    [anon_sym_use] = ACTIONS(4236),
    [anon_sym_use_BANG] = ACTIONS(4234),
    [anon_sym_do_BANG] = ACTIONS(4234),
    [anon_sym_begin] = ACTIONS(4236),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_DOT_DOT2] = ACTIONS(4234),
    [anon_sym_or] = ACTIONS(4236),
    [aux_sym_char_token1] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4236),
    [anon_sym_DQUOTE] = ACTIONS(4236),
    [anon_sym_AT_DQUOTE] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [sym_bool] = ACTIONS(4236),
    [sym_unit] = ACTIONS(4234),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4236),
    [sym_op_identifier] = ACTIONS(4236),
    [anon_sym_PLUS] = ACTIONS(4236),
    [anon_sym_DASH] = ACTIONS(4236),
    [anon_sym_PLUS_DOT] = ACTIONS(4236),
    [anon_sym_DASH_DOT] = ACTIONS(4236),
    [anon_sym_PERCENT] = ACTIONS(4236),
    [anon_sym_AMP_AMP] = ACTIONS(4236),
    [anon_sym_TILDE] = ACTIONS(4234),
    [aux_sym_prefix_op_token1] = ACTIONS(4236),
    [aux_sym_infix_op_token1] = ACTIONS(4234),
    [aux_sym_infix_op_token2] = ACTIONS(4236),
    [anon_sym_PIPE_PIPE] = ACTIONS(4236),
    [anon_sym_BANG_EQ] = ACTIONS(4236),
    [anon_sym_COLON_EQ] = ACTIONS(4234),
    [anon_sym_DOLLAR] = ACTIONS(4236),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4236),
    [sym_int] = ACTIONS(4236),
    [sym_xint] = ACTIONS(4234),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4234),
    [sym__newline] = ACTIONS(4234),
  },
  [2456] = {
    [sym_block_comment] = STATE(2456),
    [sym_compiler_directive_decl] = STATE(2456),
    [sym_fsi_directive_decl] = STATE(2456),
    [sym_preproc_line] = STATE(2456),
    [sym_identifier] = ACTIONS(4018),
    [anon_sym_EQ] = ACTIONS(4016),
    [anon_sym_GT_RBRACK] = ACTIONS(4016),
    [anon_sym_COLON] = ACTIONS(4018),
    [anon_sym_return] = ACTIONS(4018),
    [anon_sym_do] = ACTIONS(4018),
    [anon_sym_let] = ACTIONS(4018),
    [anon_sym_let_BANG] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(4018),
    [anon_sym_COMMA] = ACTIONS(4016),
    [anon_sym_null] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_COLON] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4018),
    [anon_sym_LBRACK] = ACTIONS(4018),
    [anon_sym_RBRACK] = ACTIONS(4016),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4016),
    [anon_sym_LBRACE] = ACTIONS(4018),
    [anon_sym_RBRACE] = ACTIONS(4016),
    [anon_sym_LT_AT] = ACTIONS(4018),
    [anon_sym_LT_AT_AT] = ACTIONS(4018),
    [anon_sym_DOT] = ACTIONS(4018),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4016),
    [anon_sym_new] = ACTIONS(4018),
    [anon_sym_with] = ACTIONS(4018),
    [anon_sym_return_BANG] = ACTIONS(4016),
    [anon_sym_yield] = ACTIONS(4018),
    [anon_sym_yield_BANG] = ACTIONS(4016),
    [anon_sym_lazy] = ACTIONS(4018),
    [anon_sym_assert] = ACTIONS(4018),
    [anon_sym_upcast] = ACTIONS(4018),
    [anon_sym_downcast] = ACTIONS(4018),
    [anon_sym_COLON_GT] = ACTIONS(4016),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4016),
    [anon_sym_for] = ACTIONS(4018),
    [anon_sym_to] = ACTIONS(4018),
    [anon_sym_downto] = ACTIONS(4018),
    [anon_sym_while] = ACTIONS(4018),
    [anon_sym_if] = ACTIONS(4018),
    [anon_sym_fun] = ACTIONS(4018),
    [anon_sym_try] = ACTIONS(4018),
    [anon_sym_match] = ACTIONS(4018),
    [anon_sym_match_BANG] = ACTIONS(4016),
    [anon_sym_function] = ACTIONS(4018),
    [anon_sym_LT_DASH] = ACTIONS(4018),
    [anon_sym_DOT_LBRACK] = ACTIONS(4016),
    [anon_sym_LT] = ACTIONS(4016),
    [anon_sym_use] = ACTIONS(4018),
    [anon_sym_use_BANG] = ACTIONS(4016),
    [anon_sym_do_BANG] = ACTIONS(4016),
    [anon_sym_begin] = ACTIONS(4018),
    [anon_sym_LPAREN2] = ACTIONS(4018),
    [anon_sym_DOT_DOT2] = ACTIONS(4016),
    [anon_sym_or] = ACTIONS(4018),
    [aux_sym_char_token1] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(4018),
    [anon_sym_AT_DQUOTE] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [sym_bool] = ACTIONS(4018),
    [sym_unit] = ACTIONS(4016),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4018),
    [sym_op_identifier] = ACTIONS(4018),
    [anon_sym_PLUS] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_PLUS_DOT] = ACTIONS(4018),
    [anon_sym_DASH_DOT] = ACTIONS(4018),
    [anon_sym_PERCENT] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4016),
    [aux_sym_prefix_op_token1] = ACTIONS(4018),
    [aux_sym_infix_op_token1] = ACTIONS(4016),
    [aux_sym_infix_op_token2] = ACTIONS(4018),
    [anon_sym_PIPE_PIPE] = ACTIONS(4018),
    [anon_sym_BANG_EQ] = ACTIONS(4018),
    [anon_sym_COLON_EQ] = ACTIONS(4016),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4018),
    [sym_int] = ACTIONS(4018),
    [sym_xint] = ACTIONS(4016),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4016),
    [sym__newline] = ACTIONS(4016),
  },
  [2457] = {
    [sym_block_comment] = STATE(2457),
    [sym_compiler_directive_decl] = STATE(2457),
    [sym_fsi_directive_decl] = STATE(2457),
    [sym_preproc_line] = STATE(2457),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3843),
    [anon_sym_GT_RBRACK] = ACTIONS(3843),
    [anon_sym_COLON] = ACTIONS(3845),
    [anon_sym_return] = ACTIONS(3845),
    [anon_sym_do] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_let_BANG] = ACTIONS(3843),
    [anon_sym_LPAREN] = ACTIONS(3845),
    [anon_sym_COMMA] = ACTIONS(3843),
    [anon_sym_null] = ACTIONS(3845),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_RBRACK] = ACTIONS(3843),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3843),
    [anon_sym_LBRACE] = ACTIONS(3845),
    [anon_sym_RBRACE] = ACTIONS(3843),
    [anon_sym_LT_AT] = ACTIONS(3845),
    [anon_sym_LT_AT_AT] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3843),
    [anon_sym_new] = ACTIONS(3845),
    [anon_sym_with] = ACTIONS(3845),
    [anon_sym_return_BANG] = ACTIONS(3843),
    [anon_sym_yield] = ACTIONS(3845),
    [anon_sym_yield_BANG] = ACTIONS(3843),
    [anon_sym_lazy] = ACTIONS(3845),
    [anon_sym_assert] = ACTIONS(3845),
    [anon_sym_upcast] = ACTIONS(3845),
    [anon_sym_downcast] = ACTIONS(3845),
    [anon_sym_COLON_GT] = ACTIONS(3843),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3843),
    [anon_sym_for] = ACTIONS(3845),
    [anon_sym_to] = ACTIONS(3845),
    [anon_sym_downto] = ACTIONS(3845),
    [anon_sym_while] = ACTIONS(3845),
    [anon_sym_if] = ACTIONS(3845),
    [anon_sym_fun] = ACTIONS(3845),
    [anon_sym_try] = ACTIONS(3845),
    [anon_sym_match] = ACTIONS(3845),
    [anon_sym_match_BANG] = ACTIONS(3843),
    [anon_sym_function] = ACTIONS(3845),
    [anon_sym_LT_DASH] = ACTIONS(3845),
    [anon_sym_DOT_LBRACK] = ACTIONS(3843),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_use] = ACTIONS(3845),
    [anon_sym_use_BANG] = ACTIONS(3843),
    [anon_sym_do_BANG] = ACTIONS(3843),
    [anon_sym_begin] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(3845),
    [anon_sym_DOT_DOT2] = ACTIONS(3843),
    [anon_sym_or] = ACTIONS(3845),
    [aux_sym_char_token1] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3845),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_AT_DQUOTE] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [sym_bool] = ACTIONS(3845),
    [sym_unit] = ACTIONS(3843),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3845),
    [sym_op_identifier] = ACTIONS(3845),
    [anon_sym_PLUS] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_PLUS_DOT] = ACTIONS(3845),
    [anon_sym_DASH_DOT] = ACTIONS(3845),
    [anon_sym_PERCENT] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3845),
    [anon_sym_TILDE] = ACTIONS(3843),
    [aux_sym_prefix_op_token1] = ACTIONS(3845),
    [aux_sym_infix_op_token1] = ACTIONS(3843),
    [aux_sym_infix_op_token2] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(3845),
    [anon_sym_BANG_EQ] = ACTIONS(3845),
    [anon_sym_COLON_EQ] = ACTIONS(3843),
    [anon_sym_DOLLAR] = ACTIONS(3845),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3845),
    [sym_int] = ACTIONS(3845),
    [sym_xint] = ACTIONS(3843),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3843),
    [sym__newline] = ACTIONS(3843),
  },
  [2458] = {
    [sym_block_comment] = STATE(2458),
    [sym_compiler_directive_decl] = STATE(2458),
    [sym_fsi_directive_decl] = STATE(2458),
    [sym_preproc_line] = STATE(2458),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_GT_RBRACK] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4226),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_RBRACE] = ACTIONS(4226),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_with] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_to] = ACTIONS(4228),
    [anon_sym_downto] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_DOT_DOT2] = ACTIONS(4226),
    [anon_sym_or] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
  },
  [2459] = {
    [sym_block_comment] = STATE(2459),
    [sym_compiler_directive_decl] = STATE(2459),
    [sym_fsi_directive_decl] = STATE(2459),
    [sym_preproc_line] = STATE(2459),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_EQ] = ACTIONS(4001),
    [anon_sym_GT_RBRACK] = ACTIONS(4001),
    [anon_sym_COLON] = ACTIONS(4003),
    [anon_sym_return] = ACTIONS(4003),
    [anon_sym_do] = ACTIONS(4003),
    [anon_sym_let] = ACTIONS(4003),
    [anon_sym_let_BANG] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4003),
    [anon_sym_COMMA] = ACTIONS(4001),
    [anon_sym_null] = ACTIONS(4003),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_COLON] = ACTIONS(4001),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LBRACK] = ACTIONS(4003),
    [anon_sym_RBRACK] = ACTIONS(4001),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4001),
    [anon_sym_LBRACE] = ACTIONS(4003),
    [anon_sym_RBRACE] = ACTIONS(4001),
    [anon_sym_LT_AT] = ACTIONS(4003),
    [anon_sym_LT_AT_AT] = ACTIONS(4003),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4001),
    [anon_sym_new] = ACTIONS(4003),
    [anon_sym_with] = ACTIONS(4003),
    [anon_sym_return_BANG] = ACTIONS(4001),
    [anon_sym_yield] = ACTIONS(4003),
    [anon_sym_yield_BANG] = ACTIONS(4001),
    [anon_sym_lazy] = ACTIONS(4003),
    [anon_sym_assert] = ACTIONS(4003),
    [anon_sym_upcast] = ACTIONS(4003),
    [anon_sym_downcast] = ACTIONS(4003),
    [anon_sym_COLON_GT] = ACTIONS(4001),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4001),
    [anon_sym_for] = ACTIONS(4003),
    [anon_sym_to] = ACTIONS(4003),
    [anon_sym_downto] = ACTIONS(4003),
    [anon_sym_while] = ACTIONS(4003),
    [anon_sym_if] = ACTIONS(4003),
    [anon_sym_fun] = ACTIONS(4003),
    [anon_sym_try] = ACTIONS(4003),
    [anon_sym_match] = ACTIONS(4003),
    [anon_sym_match_BANG] = ACTIONS(4001),
    [anon_sym_function] = ACTIONS(4003),
    [anon_sym_LT_DASH] = ACTIONS(4003),
    [anon_sym_DOT_LBRACK] = ACTIONS(4001),
    [anon_sym_LT] = ACTIONS(4001),
    [anon_sym_use] = ACTIONS(4003),
    [anon_sym_use_BANG] = ACTIONS(4001),
    [anon_sym_do_BANG] = ACTIONS(4001),
    [anon_sym_begin] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4003),
    [anon_sym_DOT_DOT2] = ACTIONS(4001),
    [anon_sym_or] = ACTIONS(4003),
    [aux_sym_char_token1] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4003),
    [anon_sym_DQUOTE] = ACTIONS(4003),
    [anon_sym_AT_DQUOTE] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [sym_bool] = ACTIONS(4003),
    [sym_unit] = ACTIONS(4001),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4003),
    [sym_op_identifier] = ACTIONS(4003),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_PLUS_DOT] = ACTIONS(4003),
    [anon_sym_DASH_DOT] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4003),
    [anon_sym_TILDE] = ACTIONS(4001),
    [aux_sym_prefix_op_token1] = ACTIONS(4003),
    [aux_sym_infix_op_token1] = ACTIONS(4001),
    [aux_sym_infix_op_token2] = ACTIONS(4003),
    [anon_sym_PIPE_PIPE] = ACTIONS(4003),
    [anon_sym_BANG_EQ] = ACTIONS(4003),
    [anon_sym_COLON_EQ] = ACTIONS(4001),
    [anon_sym_DOLLAR] = ACTIONS(4003),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4003),
    [sym_int] = ACTIONS(4003),
    [sym_xint] = ACTIONS(4001),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4001),
    [sym__newline] = ACTIONS(4001),
  },
  [2460] = {
    [sym_block_comment] = STATE(2460),
    [sym_compiler_directive_decl] = STATE(2460),
    [sym_fsi_directive_decl] = STATE(2460),
    [sym_preproc_line] = STATE(2460),
    [sym_identifier] = ACTIONS(4064),
    [anon_sym_EQ] = ACTIONS(4062),
    [anon_sym_GT_RBRACK] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4064),
    [anon_sym_return] = ACTIONS(4064),
    [anon_sym_do] = ACTIONS(4064),
    [anon_sym_let] = ACTIONS(4064),
    [anon_sym_let_BANG] = ACTIONS(4062),
    [anon_sym_LPAREN] = ACTIONS(4064),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_null] = ACTIONS(4064),
    [anon_sym_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_COLON] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_RBRACK] = ACTIONS(4062),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4062),
    [anon_sym_LBRACE] = ACTIONS(4064),
    [anon_sym_RBRACE] = ACTIONS(4062),
    [anon_sym_LT_AT] = ACTIONS(4064),
    [anon_sym_LT_AT_AT] = ACTIONS(4064),
    [anon_sym_DOT] = ACTIONS(4064),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4062),
    [anon_sym_new] = ACTIONS(4064),
    [anon_sym_with] = ACTIONS(4064),
    [anon_sym_return_BANG] = ACTIONS(4062),
    [anon_sym_yield] = ACTIONS(4064),
    [anon_sym_yield_BANG] = ACTIONS(4062),
    [anon_sym_lazy] = ACTIONS(4064),
    [anon_sym_assert] = ACTIONS(4064),
    [anon_sym_upcast] = ACTIONS(4064),
    [anon_sym_downcast] = ACTIONS(4064),
    [anon_sym_COLON_GT] = ACTIONS(4062),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4062),
    [anon_sym_for] = ACTIONS(4064),
    [anon_sym_to] = ACTIONS(4064),
    [anon_sym_downto] = ACTIONS(4064),
    [anon_sym_while] = ACTIONS(4064),
    [anon_sym_if] = ACTIONS(4064),
    [anon_sym_fun] = ACTIONS(4064),
    [anon_sym_try] = ACTIONS(4064),
    [anon_sym_match] = ACTIONS(4064),
    [anon_sym_match_BANG] = ACTIONS(4062),
    [anon_sym_function] = ACTIONS(4064),
    [anon_sym_LT_DASH] = ACTIONS(4064),
    [anon_sym_DOT_LBRACK] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(4062),
    [anon_sym_use] = ACTIONS(4064),
    [anon_sym_use_BANG] = ACTIONS(4062),
    [anon_sym_do_BANG] = ACTIONS(4062),
    [anon_sym_begin] = ACTIONS(4064),
    [anon_sym_LPAREN2] = ACTIONS(4064),
    [anon_sym_DOT_DOT2] = ACTIONS(4062),
    [anon_sym_or] = ACTIONS(4064),
    [aux_sym_char_token1] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_AT_DQUOTE] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [sym_bool] = ACTIONS(4064),
    [sym_unit] = ACTIONS(4062),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4064),
    [sym_op_identifier] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4064),
    [anon_sym_DASH] = ACTIONS(4064),
    [anon_sym_PLUS_DOT] = ACTIONS(4064),
    [anon_sym_DASH_DOT] = ACTIONS(4064),
    [anon_sym_PERCENT] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_TILDE] = ACTIONS(4062),
    [aux_sym_prefix_op_token1] = ACTIONS(4064),
    [aux_sym_infix_op_token1] = ACTIONS(4062),
    [aux_sym_infix_op_token2] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_BANG_EQ] = ACTIONS(4064),
    [anon_sym_COLON_EQ] = ACTIONS(4062),
    [anon_sym_DOLLAR] = ACTIONS(4064),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4064),
    [sym_int] = ACTIONS(4064),
    [sym_xint] = ACTIONS(4062),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4062),
    [sym__newline] = ACTIONS(4062),
  },
  [2461] = {
    [sym_block_comment] = STATE(2461),
    [sym_compiler_directive_decl] = STATE(2461),
    [sym_fsi_directive_decl] = STATE(2461),
    [sym_preproc_line] = STATE(2461),
    [sym_identifier] = ACTIONS(3996),
    [anon_sym_EQ] = ACTIONS(3994),
    [anon_sym_GT_RBRACK] = ACTIONS(3994),
    [anon_sym_COLON] = ACTIONS(3996),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_do] = ACTIONS(3996),
    [anon_sym_let] = ACTIONS(3996),
    [anon_sym_let_BANG] = ACTIONS(3994),
    [anon_sym_LPAREN] = ACTIONS(3996),
    [anon_sym_COMMA] = ACTIONS(3994),
    [anon_sym_null] = ACTIONS(3996),
    [anon_sym_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_COLON] = ACTIONS(3994),
    [anon_sym_AMP] = ACTIONS(3996),
    [anon_sym_LBRACK] = ACTIONS(3996),
    [anon_sym_RBRACK] = ACTIONS(3994),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3994),
    [anon_sym_LBRACE] = ACTIONS(3996),
    [anon_sym_RBRACE] = ACTIONS(3994),
    [anon_sym_LT_AT] = ACTIONS(3996),
    [anon_sym_LT_AT_AT] = ACTIONS(3996),
    [anon_sym_DOT] = ACTIONS(3996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3994),
    [anon_sym_new] = ACTIONS(3996),
    [anon_sym_with] = ACTIONS(3996),
    [anon_sym_return_BANG] = ACTIONS(3994),
    [anon_sym_yield] = ACTIONS(3996),
    [anon_sym_yield_BANG] = ACTIONS(3994),
    [anon_sym_lazy] = ACTIONS(3996),
    [anon_sym_assert] = ACTIONS(3996),
    [anon_sym_upcast] = ACTIONS(3996),
    [anon_sym_downcast] = ACTIONS(3996),
    [anon_sym_COLON_GT] = ACTIONS(3994),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3994),
    [anon_sym_for] = ACTIONS(3996),
    [anon_sym_to] = ACTIONS(3996),
    [anon_sym_downto] = ACTIONS(3996),
    [anon_sym_while] = ACTIONS(3996),
    [anon_sym_if] = ACTIONS(3996),
    [anon_sym_fun] = ACTIONS(3996),
    [anon_sym_try] = ACTIONS(3996),
    [anon_sym_match] = ACTIONS(3996),
    [anon_sym_match_BANG] = ACTIONS(3994),
    [anon_sym_function] = ACTIONS(3996),
    [anon_sym_LT_DASH] = ACTIONS(3996),
    [anon_sym_DOT_LBRACK] = ACTIONS(3994),
    [anon_sym_LT] = ACTIONS(3994),
    [anon_sym_use] = ACTIONS(3996),
    [anon_sym_use_BANG] = ACTIONS(3994),
    [anon_sym_do_BANG] = ACTIONS(3994),
    [anon_sym_begin] = ACTIONS(3996),
    [anon_sym_LPAREN2] = ACTIONS(3996),
    [anon_sym_DOT_DOT2] = ACTIONS(3994),
    [anon_sym_or] = ACTIONS(3996),
    [aux_sym_char_token1] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3996),
    [anon_sym_DQUOTE] = ACTIONS(3996),
    [anon_sym_AT_DQUOTE] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [sym_bool] = ACTIONS(3996),
    [sym_unit] = ACTIONS(3994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3996),
    [sym_op_identifier] = ACTIONS(3996),
    [anon_sym_PLUS] = ACTIONS(3996),
    [anon_sym_DASH] = ACTIONS(3996),
    [anon_sym_PLUS_DOT] = ACTIONS(3996),
    [anon_sym_DASH_DOT] = ACTIONS(3996),
    [anon_sym_PERCENT] = ACTIONS(3996),
    [anon_sym_AMP_AMP] = ACTIONS(3996),
    [anon_sym_TILDE] = ACTIONS(3994),
    [aux_sym_prefix_op_token1] = ACTIONS(3996),
    [aux_sym_infix_op_token1] = ACTIONS(3994),
    [aux_sym_infix_op_token2] = ACTIONS(3996),
    [anon_sym_PIPE_PIPE] = ACTIONS(3996),
    [anon_sym_BANG_EQ] = ACTIONS(3996),
    [anon_sym_COLON_EQ] = ACTIONS(3994),
    [anon_sym_DOLLAR] = ACTIONS(3996),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3996),
    [sym_int] = ACTIONS(3996),
    [sym_xint] = ACTIONS(3994),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3994),
    [sym__newline] = ACTIONS(3994),
  },
  [2462] = {
    [sym_block_comment] = STATE(2462),
    [sym_compiler_directive_decl] = STATE(2462),
    [sym_fsi_directive_decl] = STATE(2462),
    [sym_preproc_line] = STATE(2462),
    [sym_identifier] = ACTIONS(4220),
    [anon_sym_EQ] = ACTIONS(4218),
    [anon_sym_GT_RBRACK] = ACTIONS(4218),
    [anon_sym_COLON] = ACTIONS(4220),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_do] = ACTIONS(4220),
    [anon_sym_let] = ACTIONS(4220),
    [anon_sym_let_BANG] = ACTIONS(4218),
    [anon_sym_LPAREN] = ACTIONS(4220),
    [anon_sym_COMMA] = ACTIONS(4218),
    [anon_sym_null] = ACTIONS(4220),
    [anon_sym_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_COLON] = ACTIONS(4218),
    [anon_sym_AMP] = ACTIONS(4220),
    [anon_sym_LBRACK] = ACTIONS(4220),
    [anon_sym_RBRACK] = ACTIONS(4218),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(4220),
    [anon_sym_RBRACE] = ACTIONS(4218),
    [anon_sym_LT_AT] = ACTIONS(4220),
    [anon_sym_LT_AT_AT] = ACTIONS(4220),
    [anon_sym_DOT] = ACTIONS(4220),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4218),
    [anon_sym_new] = ACTIONS(4220),
    [anon_sym_with] = ACTIONS(4220),
    [anon_sym_return_BANG] = ACTIONS(4218),
    [anon_sym_yield] = ACTIONS(4220),
    [anon_sym_yield_BANG] = ACTIONS(4218),
    [anon_sym_lazy] = ACTIONS(4220),
    [anon_sym_assert] = ACTIONS(4220),
    [anon_sym_upcast] = ACTIONS(4220),
    [anon_sym_downcast] = ACTIONS(4220),
    [anon_sym_COLON_GT] = ACTIONS(4218),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4218),
    [anon_sym_for] = ACTIONS(4220),
    [anon_sym_to] = ACTIONS(4220),
    [anon_sym_downto] = ACTIONS(4220),
    [anon_sym_while] = ACTIONS(4220),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_fun] = ACTIONS(4220),
    [anon_sym_try] = ACTIONS(4220),
    [anon_sym_match] = ACTIONS(4220),
    [anon_sym_match_BANG] = ACTIONS(4218),
    [anon_sym_function] = ACTIONS(4220),
    [anon_sym_LT_DASH] = ACTIONS(4220),
    [anon_sym_DOT_LBRACK] = ACTIONS(4218),
    [anon_sym_LT] = ACTIONS(4218),
    [anon_sym_use] = ACTIONS(4220),
    [anon_sym_use_BANG] = ACTIONS(4218),
    [anon_sym_do_BANG] = ACTIONS(4218),
    [anon_sym_begin] = ACTIONS(4220),
    [anon_sym_LPAREN2] = ACTIONS(4220),
    [anon_sym_DOT_DOT2] = ACTIONS(4218),
    [anon_sym_or] = ACTIONS(4220),
    [aux_sym_char_token1] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4220),
    [anon_sym_DQUOTE] = ACTIONS(4220),
    [anon_sym_AT_DQUOTE] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [sym_bool] = ACTIONS(4220),
    [sym_unit] = ACTIONS(4218),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4220),
    [sym_op_identifier] = ACTIONS(4220),
    [anon_sym_PLUS] = ACTIONS(4220),
    [anon_sym_DASH] = ACTIONS(4220),
    [anon_sym_PLUS_DOT] = ACTIONS(4220),
    [anon_sym_DASH_DOT] = ACTIONS(4220),
    [anon_sym_PERCENT] = ACTIONS(4220),
    [anon_sym_AMP_AMP] = ACTIONS(4220),
    [anon_sym_TILDE] = ACTIONS(4218),
    [aux_sym_prefix_op_token1] = ACTIONS(4220),
    [aux_sym_infix_op_token1] = ACTIONS(4218),
    [aux_sym_infix_op_token2] = ACTIONS(4220),
    [anon_sym_PIPE_PIPE] = ACTIONS(4220),
    [anon_sym_BANG_EQ] = ACTIONS(4220),
    [anon_sym_COLON_EQ] = ACTIONS(4218),
    [anon_sym_DOLLAR] = ACTIONS(4220),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4220),
    [sym_int] = ACTIONS(4220),
    [sym_xint] = ACTIONS(4218),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4218),
    [sym__newline] = ACTIONS(4218),
  },
  [2463] = {
    [sym_block_comment] = STATE(2463),
    [sym_compiler_directive_decl] = STATE(2463),
    [sym_fsi_directive_decl] = STATE(2463),
    [sym_preproc_line] = STATE(2463),
    [sym_identifier] = ACTIONS(3972),
    [anon_sym_EQ] = ACTIONS(3970),
    [anon_sym_GT_RBRACK] = ACTIONS(3970),
    [anon_sym_COLON] = ACTIONS(3972),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_do] = ACTIONS(3972),
    [anon_sym_let] = ACTIONS(3972),
    [anon_sym_let_BANG] = ACTIONS(3970),
    [anon_sym_LPAREN] = ACTIONS(3972),
    [anon_sym_COMMA] = ACTIONS(3970),
    [anon_sym_null] = ACTIONS(3972),
    [anon_sym_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_COLON] = ACTIONS(3970),
    [anon_sym_AMP] = ACTIONS(3972),
    [anon_sym_LBRACK] = ACTIONS(3972),
    [anon_sym_RBRACK] = ACTIONS(3970),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3970),
    [anon_sym_LBRACE] = ACTIONS(3972),
    [anon_sym_RBRACE] = ACTIONS(3970),
    [anon_sym_LT_AT] = ACTIONS(3972),
    [anon_sym_LT_AT_AT] = ACTIONS(3972),
    [anon_sym_DOT] = ACTIONS(3972),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3970),
    [anon_sym_new] = ACTIONS(3972),
    [anon_sym_with] = ACTIONS(3972),
    [anon_sym_return_BANG] = ACTIONS(3970),
    [anon_sym_yield] = ACTIONS(3972),
    [anon_sym_yield_BANG] = ACTIONS(3970),
    [anon_sym_lazy] = ACTIONS(3972),
    [anon_sym_assert] = ACTIONS(3972),
    [anon_sym_upcast] = ACTIONS(3972),
    [anon_sym_downcast] = ACTIONS(3972),
    [anon_sym_COLON_GT] = ACTIONS(3970),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3970),
    [anon_sym_for] = ACTIONS(3972),
    [anon_sym_to] = ACTIONS(3972),
    [anon_sym_downto] = ACTIONS(3972),
    [anon_sym_while] = ACTIONS(3972),
    [anon_sym_if] = ACTIONS(3972),
    [anon_sym_fun] = ACTIONS(3972),
    [anon_sym_try] = ACTIONS(3972),
    [anon_sym_match] = ACTIONS(3972),
    [anon_sym_match_BANG] = ACTIONS(3970),
    [anon_sym_function] = ACTIONS(3972),
    [anon_sym_LT_DASH] = ACTIONS(3972),
    [anon_sym_DOT_LBRACK] = ACTIONS(3970),
    [anon_sym_LT] = ACTIONS(3970),
    [anon_sym_use] = ACTIONS(3972),
    [anon_sym_use_BANG] = ACTIONS(3970),
    [anon_sym_do_BANG] = ACTIONS(3970),
    [anon_sym_begin] = ACTIONS(3972),
    [anon_sym_LPAREN2] = ACTIONS(3972),
    [anon_sym_DOT_DOT2] = ACTIONS(3970),
    [anon_sym_or] = ACTIONS(3972),
    [aux_sym_char_token1] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3972),
    [anon_sym_DQUOTE] = ACTIONS(3972),
    [anon_sym_AT_DQUOTE] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [sym_bool] = ACTIONS(3972),
    [sym_unit] = ACTIONS(3970),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3972),
    [sym_op_identifier] = ACTIONS(3972),
    [anon_sym_PLUS] = ACTIONS(3972),
    [anon_sym_DASH] = ACTIONS(3972),
    [anon_sym_PLUS_DOT] = ACTIONS(3972),
    [anon_sym_DASH_DOT] = ACTIONS(3972),
    [anon_sym_PERCENT] = ACTIONS(3972),
    [anon_sym_AMP_AMP] = ACTIONS(3972),
    [anon_sym_TILDE] = ACTIONS(3970),
    [aux_sym_prefix_op_token1] = ACTIONS(3972),
    [aux_sym_infix_op_token1] = ACTIONS(3970),
    [aux_sym_infix_op_token2] = ACTIONS(3972),
    [anon_sym_PIPE_PIPE] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3972),
    [anon_sym_COLON_EQ] = ACTIONS(3970),
    [anon_sym_DOLLAR] = ACTIONS(3972),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3972),
    [sym_int] = ACTIONS(3972),
    [sym_xint] = ACTIONS(3970),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3970),
    [sym__newline] = ACTIONS(3970),
  },
  [2464] = {
    [sym_block_comment] = STATE(2464),
    [sym_compiler_directive_decl] = STATE(2464),
    [sym_fsi_directive_decl] = STATE(2464),
    [sym_preproc_line] = STATE(2464),
    [sym_identifier] = ACTIONS(3531),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(3531),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_do] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [anon_sym_as] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_null] = ACTIONS(3531),
    [anon_sym_QMARK] = ACTIONS(3531),
    [anon_sym_COLON_QMARK] = ACTIONS(3531),
    [anon_sym_COLON_COLON] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3531),
    [anon_sym_LT_AT] = ACTIONS(3531),
    [anon_sym_LT_AT_AT] = ACTIONS(3531),
    [anon_sym_DOT] = ACTIONS(3531),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3531),
    [anon_sym_with] = ACTIONS(3531),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3531),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3531),
    [anon_sym_assert] = ACTIONS(3531),
    [anon_sym_upcast] = ACTIONS(3531),
    [anon_sym_downcast] = ACTIONS(3531),
    [anon_sym_COLON_GT] = ACTIONS(3529),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3531),
    [anon_sym_while] = ACTIONS(3531),
    [anon_sym_if] = ACTIONS(3531),
    [anon_sym_fun] = ACTIONS(3531),
    [anon_sym_DASH_GT] = ACTIONS(3531),
    [anon_sym_try] = ACTIONS(3531),
    [anon_sym_match] = ACTIONS(3531),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3531),
    [anon_sym_LT_DASH] = ACTIONS(3531),
    [anon_sym_DOT_LBRACK] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_use] = ACTIONS(3531),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3531),
    [anon_sym_LPAREN2] = ACTIONS(3531),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LT2] = ACTIONS(3531),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_or] = ACTIONS(3531),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3531),
    [anon_sym_DQUOTE] = ACTIONS(3531),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3531),
    [sym_unit] = ACTIONS(3529),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3531),
    [sym_op_identifier] = ACTIONS(3531),
    [anon_sym_PLUS] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(3531),
    [anon_sym_PLUS_DOT] = ACTIONS(3531),
    [anon_sym_DASH_DOT] = ACTIONS(3531),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_AMP_AMP] = ACTIONS(3531),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3531),
    [aux_sym_infix_op_token1] = ACTIONS(3529),
    [aux_sym_infix_op_token2] = ACTIONS(3531),
    [anon_sym_PIPE_PIPE] = ACTIONS(3531),
    [anon_sym_BANG_EQ] = ACTIONS(3531),
    [anon_sym_COLON_EQ] = ACTIONS(3529),
    [anon_sym_DOLLAR] = ACTIONS(3531),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3531),
    [sym_int] = ACTIONS(3531),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [sym__newline] = ACTIONS(3529),
    [sym__dedent] = ACTIONS(3529),
  },
  [2465] = {
    [sym_block_comment] = STATE(2465),
    [sym_compiler_directive_decl] = STATE(2465),
    [sym_fsi_directive_decl] = STATE(2465),
    [sym_preproc_line] = STATE(2465),
    [ts_builtin_sym_end] = ACTIONS(4226),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_namespace] = ACTIONS(4228),
    [anon_sym_module] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_open] = ACTIONS(4228),
    [anon_sym_LBRACK_LT] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_type] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4971),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [anon_sym_exception] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4226),
    [anon_sym_POUNDload] = ACTIONS(4226),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
  },
  [2466] = {
    [sym_block_comment] = STATE(2466),
    [sym_compiler_directive_decl] = STATE(2466),
    [sym_fsi_directive_decl] = STATE(2466),
    [sym_preproc_line] = STATE(2466),
    [ts_builtin_sym_end] = ACTIONS(4226),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_namespace] = ACTIONS(4228),
    [anon_sym_module] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_open] = ACTIONS(4228),
    [anon_sym_LBRACK_LT] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_type] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [anon_sym_exception] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4226),
    [anon_sym_POUNDload] = ACTIONS(4226),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
  },
  [2467] = {
    [sym_block_comment] = STATE(2467),
    [sym_compiler_directive_decl] = STATE(2467),
    [sym_fsi_directive_decl] = STATE(2467),
    [sym_preproc_line] = STATE(2467),
    [sym_identifier] = ACTIONS(4216),
    [anon_sym_EQ] = ACTIONS(4214),
    [anon_sym_GT_RBRACK] = ACTIONS(4214),
    [anon_sym_COLON] = ACTIONS(4216),
    [anon_sym_return] = ACTIONS(4216),
    [anon_sym_do] = ACTIONS(4216),
    [anon_sym_let] = ACTIONS(4216),
    [anon_sym_let_BANG] = ACTIONS(4214),
    [anon_sym_LPAREN] = ACTIONS(4216),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_null] = ACTIONS(4216),
    [anon_sym_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_COLON] = ACTIONS(4214),
    [anon_sym_AMP] = ACTIONS(4216),
    [anon_sym_LBRACK] = ACTIONS(4216),
    [anon_sym_RBRACK] = ACTIONS(4214),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4214),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_RBRACE] = ACTIONS(4214),
    [anon_sym_LT_AT] = ACTIONS(4216),
    [anon_sym_LT_AT_AT] = ACTIONS(4216),
    [anon_sym_DOT] = ACTIONS(4216),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4214),
    [anon_sym_new] = ACTIONS(4216),
    [anon_sym_with] = ACTIONS(4216),
    [anon_sym_return_BANG] = ACTIONS(4214),
    [anon_sym_yield] = ACTIONS(4216),
    [anon_sym_yield_BANG] = ACTIONS(4214),
    [anon_sym_lazy] = ACTIONS(4216),
    [anon_sym_assert] = ACTIONS(4216),
    [anon_sym_upcast] = ACTIONS(4216),
    [anon_sym_downcast] = ACTIONS(4216),
    [anon_sym_COLON_GT] = ACTIONS(4214),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4214),
    [anon_sym_for] = ACTIONS(4216),
    [anon_sym_to] = ACTIONS(4216),
    [anon_sym_downto] = ACTIONS(4216),
    [anon_sym_while] = ACTIONS(4216),
    [anon_sym_if] = ACTIONS(4216),
    [anon_sym_fun] = ACTIONS(4216),
    [anon_sym_try] = ACTIONS(4216),
    [anon_sym_match] = ACTIONS(4216),
    [anon_sym_match_BANG] = ACTIONS(4214),
    [anon_sym_function] = ACTIONS(4216),
    [anon_sym_LT_DASH] = ACTIONS(4216),
    [anon_sym_DOT_LBRACK] = ACTIONS(4214),
    [anon_sym_LT] = ACTIONS(4214),
    [anon_sym_use] = ACTIONS(4216),
    [anon_sym_use_BANG] = ACTIONS(4214),
    [anon_sym_do_BANG] = ACTIONS(4214),
    [anon_sym_begin] = ACTIONS(4216),
    [anon_sym_LPAREN2] = ACTIONS(4216),
    [anon_sym_DOT_DOT2] = ACTIONS(4214),
    [anon_sym_or] = ACTIONS(4216),
    [aux_sym_char_token1] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4216),
    [anon_sym_DQUOTE] = ACTIONS(4216),
    [anon_sym_AT_DQUOTE] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [sym_bool] = ACTIONS(4216),
    [sym_unit] = ACTIONS(4214),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4216),
    [sym_op_identifier] = ACTIONS(4216),
    [anon_sym_PLUS] = ACTIONS(4216),
    [anon_sym_DASH] = ACTIONS(4216),
    [anon_sym_PLUS_DOT] = ACTIONS(4216),
    [anon_sym_DASH_DOT] = ACTIONS(4216),
    [anon_sym_PERCENT] = ACTIONS(4216),
    [anon_sym_AMP_AMP] = ACTIONS(4216),
    [anon_sym_TILDE] = ACTIONS(4214),
    [aux_sym_prefix_op_token1] = ACTIONS(4216),
    [aux_sym_infix_op_token1] = ACTIONS(4214),
    [aux_sym_infix_op_token2] = ACTIONS(4216),
    [anon_sym_PIPE_PIPE] = ACTIONS(4216),
    [anon_sym_BANG_EQ] = ACTIONS(4216),
    [anon_sym_COLON_EQ] = ACTIONS(4214),
    [anon_sym_DOLLAR] = ACTIONS(4216),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4216),
    [sym_int] = ACTIONS(4216),
    [sym_xint] = ACTIONS(4214),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4214),
    [sym__newline] = ACTIONS(4214),
  },
  [2468] = {
    [sym_block_comment] = STATE(2468),
    [sym_compiler_directive_decl] = STATE(2468),
    [sym_fsi_directive_decl] = STATE(2468),
    [sym_preproc_line] = STATE(2468),
    [ts_builtin_sym_end] = ACTIONS(4973),
    [sym_identifier] = ACTIONS(4975),
    [anon_sym_namespace] = ACTIONS(4975),
    [anon_sym_module] = ACTIONS(4975),
    [anon_sym_EQ] = ACTIONS(3689),
    [anon_sym_open] = ACTIONS(4975),
    [anon_sym_LBRACK_LT] = ACTIONS(4973),
    [anon_sym_COLON] = ACTIONS(4182),
    [anon_sym_return] = ACTIONS(4975),
    [anon_sym_type] = ACTIONS(4975),
    [anon_sym_do] = ACTIONS(4975),
    [anon_sym_let] = ACTIONS(4975),
    [anon_sym_let_BANG] = ACTIONS(4973),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [anon_sym_COMMA] = ACTIONS(3689),
    [anon_sym_null] = ACTIONS(4975),
    [anon_sym_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(4975),
    [anon_sym_LBRACK] = ACTIONS(4975),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4973),
    [anon_sym_LBRACE] = ACTIONS(4975),
    [anon_sym_LT_AT] = ACTIONS(4975),
    [anon_sym_LT_AT_AT] = ACTIONS(4975),
    [anon_sym_DOT] = ACTIONS(4182),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4973),
    [anon_sym_new] = ACTIONS(4975),
    [anon_sym_return_BANG] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_yield_BANG] = ACTIONS(4973),
    [anon_sym_lazy] = ACTIONS(4975),
    [anon_sym_assert] = ACTIONS(4975),
    [anon_sym_upcast] = ACTIONS(4975),
    [anon_sym_downcast] = ACTIONS(4975),
    [anon_sym_COLON_GT] = ACTIONS(3689),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3689),
    [anon_sym_for] = ACTIONS(4975),
    [anon_sym_while] = ACTIONS(4975),
    [anon_sym_if] = ACTIONS(4975),
    [anon_sym_fun] = ACTIONS(4975),
    [anon_sym_try] = ACTIONS(4975),
    [anon_sym_match] = ACTIONS(4975),
    [anon_sym_match_BANG] = ACTIONS(4973),
    [anon_sym_function] = ACTIONS(4975),
    [anon_sym_LT_DASH] = ACTIONS(4182),
    [anon_sym_DOT_LBRACK] = ACTIONS(3689),
    [anon_sym_LT] = ACTIONS(3689),
    [anon_sym_use] = ACTIONS(4975),
    [anon_sym_use_BANG] = ACTIONS(4973),
    [anon_sym_do_BANG] = ACTIONS(4973),
    [anon_sym_begin] = ACTIONS(4975),
    [anon_sym_LPAREN2] = ACTIONS(4182),
    [anon_sym_or] = ACTIONS(4182),
    [anon_sym_exception] = ACTIONS(4975),
    [aux_sym_char_token1] = ACTIONS(4973),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4975),
    [anon_sym_DQUOTE] = ACTIONS(4975),
    [anon_sym_AT_DQUOTE] = ACTIONS(4973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4973),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4973),
    [sym_bool] = ACTIONS(4975),
    [sym_unit] = ACTIONS(4973),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4975),
    [sym_op_identifier] = ACTIONS(4975),
    [anon_sym_PLUS] = ACTIONS(4975),
    [anon_sym_DASH] = ACTIONS(4975),
    [anon_sym_PLUS_DOT] = ACTIONS(4975),
    [anon_sym_DASH_DOT] = ACTIONS(4975),
    [anon_sym_PERCENT] = ACTIONS(4975),
    [anon_sym_AMP_AMP] = ACTIONS(4975),
    [anon_sym_TILDE] = ACTIONS(4973),
    [aux_sym_prefix_op_token1] = ACTIONS(4975),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token2] = ACTIONS(4182),
    [anon_sym_PIPE_PIPE] = ACTIONS(4182),
    [anon_sym_BANG_EQ] = ACTIONS(4182),
    [anon_sym_COLON_EQ] = ACTIONS(3689),
    [anon_sym_DOLLAR] = ACTIONS(4182),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4182),
    [sym_int] = ACTIONS(4975),
    [sym_xint] = ACTIONS(4973),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4973),
    [anon_sym_POUNDload] = ACTIONS(4973),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4973),
    [sym__newline] = ACTIONS(3689),
  },
  [2469] = {
    [sym_block_comment] = STATE(2469),
    [sym_compiler_directive_decl] = STATE(2469),
    [sym_fsi_directive_decl] = STATE(2469),
    [sym_preproc_line] = STATE(2469),
    [ts_builtin_sym_end] = ACTIONS(4009),
    [sym_identifier] = ACTIONS(4011),
    [anon_sym_namespace] = ACTIONS(4011),
    [anon_sym_module] = ACTIONS(4011),
    [anon_sym_EQ] = ACTIONS(4009),
    [anon_sym_open] = ACTIONS(4011),
    [anon_sym_LBRACK_LT] = ACTIONS(4009),
    [anon_sym_COLON] = ACTIONS(4011),
    [anon_sym_return] = ACTIONS(4011),
    [anon_sym_type] = ACTIONS(4011),
    [anon_sym_do] = ACTIONS(4011),
    [anon_sym_let] = ACTIONS(4011),
    [anon_sym_let_BANG] = ACTIONS(4009),
    [anon_sym_LPAREN] = ACTIONS(4011),
    [anon_sym_COMMA] = ACTIONS(4009),
    [anon_sym_null] = ACTIONS(4011),
    [anon_sym_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(4011),
    [anon_sym_LBRACK] = ACTIONS(4011),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4009),
    [anon_sym_LBRACE] = ACTIONS(4011),
    [anon_sym_LT_AT] = ACTIONS(4011),
    [anon_sym_LT_AT_AT] = ACTIONS(4011),
    [anon_sym_DOT] = ACTIONS(4011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4009),
    [anon_sym_new] = ACTIONS(4011),
    [anon_sym_return_BANG] = ACTIONS(4009),
    [anon_sym_yield] = ACTIONS(4011),
    [anon_sym_yield_BANG] = ACTIONS(4009),
    [anon_sym_lazy] = ACTIONS(4011),
    [anon_sym_assert] = ACTIONS(4011),
    [anon_sym_upcast] = ACTIONS(4011),
    [anon_sym_downcast] = ACTIONS(4011),
    [anon_sym_COLON_GT] = ACTIONS(4009),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4009),
    [anon_sym_for] = ACTIONS(4011),
    [anon_sym_while] = ACTIONS(4011),
    [anon_sym_if] = ACTIONS(4011),
    [anon_sym_fun] = ACTIONS(4011),
    [anon_sym_try] = ACTIONS(4011),
    [anon_sym_match] = ACTIONS(4011),
    [anon_sym_match_BANG] = ACTIONS(4009),
    [anon_sym_function] = ACTIONS(4011),
    [anon_sym_LT_DASH] = ACTIONS(4011),
    [anon_sym_DOT_LBRACK] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(4009),
    [anon_sym_use] = ACTIONS(4011),
    [anon_sym_use_BANG] = ACTIONS(4009),
    [anon_sym_do_BANG] = ACTIONS(4009),
    [anon_sym_begin] = ACTIONS(4011),
    [anon_sym_LPAREN2] = ACTIONS(4011),
    [anon_sym_or] = ACTIONS(4011),
    [anon_sym_exception] = ACTIONS(4011),
    [aux_sym_char_token1] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4011),
    [anon_sym_DQUOTE] = ACTIONS(4011),
    [anon_sym_AT_DQUOTE] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [sym_bool] = ACTIONS(4011),
    [sym_unit] = ACTIONS(4009),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4011),
    [sym_op_identifier] = ACTIONS(4011),
    [anon_sym_PLUS] = ACTIONS(4011),
    [anon_sym_DASH] = ACTIONS(4011),
    [anon_sym_PLUS_DOT] = ACTIONS(4011),
    [anon_sym_DASH_DOT] = ACTIONS(4011),
    [anon_sym_PERCENT] = ACTIONS(4011),
    [anon_sym_AMP_AMP] = ACTIONS(4011),
    [anon_sym_TILDE] = ACTIONS(4009),
    [aux_sym_prefix_op_token1] = ACTIONS(4011),
    [aux_sym_infix_op_token1] = ACTIONS(4009),
    [aux_sym_infix_op_token2] = ACTIONS(4011),
    [anon_sym_PIPE_PIPE] = ACTIONS(4011),
    [anon_sym_BANG_EQ] = ACTIONS(4011),
    [anon_sym_COLON_EQ] = ACTIONS(4009),
    [anon_sym_DOLLAR] = ACTIONS(4011),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4011),
    [sym_int] = ACTIONS(4011),
    [sym_xint] = ACTIONS(4009),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4009),
    [anon_sym_POUNDload] = ACTIONS(4009),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4009),
    [sym__newline] = ACTIONS(4009),
  },
  [2470] = {
    [sym_block_comment] = STATE(2470),
    [sym_compiler_directive_decl] = STATE(2470),
    [sym_fsi_directive_decl] = STATE(2470),
    [sym_preproc_line] = STATE(2470),
    [ts_builtin_sym_end] = ACTIONS(4160),
    [sym_identifier] = ACTIONS(4162),
    [anon_sym_namespace] = ACTIONS(4162),
    [anon_sym_module] = ACTIONS(4162),
    [anon_sym_EQ] = ACTIONS(4160),
    [anon_sym_open] = ACTIONS(4162),
    [anon_sym_LBRACK_LT] = ACTIONS(4160),
    [anon_sym_COLON] = ACTIONS(4162),
    [anon_sym_return] = ACTIONS(4162),
    [anon_sym_type] = ACTIONS(4162),
    [anon_sym_do] = ACTIONS(4162),
    [anon_sym_let] = ACTIONS(4162),
    [anon_sym_let_BANG] = ACTIONS(4160),
    [anon_sym_LPAREN] = ACTIONS(4162),
    [anon_sym_COMMA] = ACTIONS(4160),
    [anon_sym_null] = ACTIONS(4162),
    [anon_sym_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4160),
    [anon_sym_AMP] = ACTIONS(4162),
    [anon_sym_LBRACK] = ACTIONS(4162),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4160),
    [anon_sym_LBRACE] = ACTIONS(4162),
    [anon_sym_LT_AT] = ACTIONS(4162),
    [anon_sym_LT_AT_AT] = ACTIONS(4162),
    [anon_sym_DOT] = ACTIONS(4162),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4160),
    [anon_sym_new] = ACTIONS(4162),
    [anon_sym_return_BANG] = ACTIONS(4160),
    [anon_sym_yield] = ACTIONS(4162),
    [anon_sym_yield_BANG] = ACTIONS(4160),
    [anon_sym_lazy] = ACTIONS(4162),
    [anon_sym_assert] = ACTIONS(4162),
    [anon_sym_upcast] = ACTIONS(4162),
    [anon_sym_downcast] = ACTIONS(4162),
    [anon_sym_COLON_GT] = ACTIONS(4160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4160),
    [anon_sym_for] = ACTIONS(4162),
    [anon_sym_while] = ACTIONS(4162),
    [anon_sym_if] = ACTIONS(4162),
    [anon_sym_fun] = ACTIONS(4162),
    [anon_sym_try] = ACTIONS(4162),
    [anon_sym_match] = ACTIONS(4162),
    [anon_sym_match_BANG] = ACTIONS(4160),
    [anon_sym_function] = ACTIONS(4162),
    [anon_sym_LT_DASH] = ACTIONS(4162),
    [anon_sym_DOT_LBRACK] = ACTIONS(4160),
    [anon_sym_LT] = ACTIONS(4160),
    [anon_sym_use] = ACTIONS(4162),
    [anon_sym_use_BANG] = ACTIONS(4160),
    [anon_sym_do_BANG] = ACTIONS(4160),
    [anon_sym_begin] = ACTIONS(4162),
    [anon_sym_LPAREN2] = ACTIONS(4162),
    [anon_sym_or] = ACTIONS(4162),
    [anon_sym_exception] = ACTIONS(4162),
    [aux_sym_char_token1] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4162),
    [anon_sym_DQUOTE] = ACTIONS(4162),
    [anon_sym_AT_DQUOTE] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [sym_bool] = ACTIONS(4162),
    [sym_unit] = ACTIONS(4160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4162),
    [sym_op_identifier] = ACTIONS(4162),
    [anon_sym_PLUS] = ACTIONS(4162),
    [anon_sym_DASH] = ACTIONS(4162),
    [anon_sym_PLUS_DOT] = ACTIONS(4162),
    [anon_sym_DASH_DOT] = ACTIONS(4162),
    [anon_sym_PERCENT] = ACTIONS(4162),
    [anon_sym_AMP_AMP] = ACTIONS(4162),
    [anon_sym_TILDE] = ACTIONS(4160),
    [aux_sym_prefix_op_token1] = ACTIONS(4162),
    [aux_sym_infix_op_token1] = ACTIONS(4160),
    [aux_sym_infix_op_token2] = ACTIONS(4162),
    [anon_sym_PIPE_PIPE] = ACTIONS(4162),
    [anon_sym_BANG_EQ] = ACTIONS(4162),
    [anon_sym_COLON_EQ] = ACTIONS(4160),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4162),
    [sym_int] = ACTIONS(4162),
    [sym_xint] = ACTIONS(4160),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4160),
    [anon_sym_POUNDload] = ACTIONS(4160),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4160),
    [sym__newline] = ACTIONS(4160),
  },
  [2471] = {
    [sym_block_comment] = STATE(2471),
    [sym_compiler_directive_decl] = STATE(2471),
    [sym_fsi_directive_decl] = STATE(2471),
    [sym_preproc_line] = STATE(2471),
    [sym_identifier] = ACTIONS(4197),
    [anon_sym_EQ] = ACTIONS(4195),
    [anon_sym_GT_RBRACK] = ACTIONS(4195),
    [anon_sym_COLON] = ACTIONS(4197),
    [anon_sym_return] = ACTIONS(4197),
    [anon_sym_do] = ACTIONS(4197),
    [anon_sym_let] = ACTIONS(4197),
    [anon_sym_let_BANG] = ACTIONS(4195),
    [anon_sym_LPAREN] = ACTIONS(4197),
    [anon_sym_COMMA] = ACTIONS(4195),
    [anon_sym_null] = ACTIONS(4197),
    [anon_sym_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_COLON] = ACTIONS(4195),
    [anon_sym_AMP] = ACTIONS(4197),
    [anon_sym_LBRACK] = ACTIONS(4197),
    [anon_sym_RBRACK] = ACTIONS(4195),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4195),
    [anon_sym_LBRACE] = ACTIONS(4197),
    [anon_sym_RBRACE] = ACTIONS(4195),
    [anon_sym_LT_AT] = ACTIONS(4197),
    [anon_sym_LT_AT_AT] = ACTIONS(4197),
    [anon_sym_DOT] = ACTIONS(4197),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4195),
    [anon_sym_new] = ACTIONS(4197),
    [anon_sym_with] = ACTIONS(4197),
    [anon_sym_return_BANG] = ACTIONS(4195),
    [anon_sym_yield] = ACTIONS(4197),
    [anon_sym_yield_BANG] = ACTIONS(4195),
    [anon_sym_lazy] = ACTIONS(4197),
    [anon_sym_assert] = ACTIONS(4197),
    [anon_sym_upcast] = ACTIONS(4197),
    [anon_sym_downcast] = ACTIONS(4197),
    [anon_sym_COLON_GT] = ACTIONS(4195),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4195),
    [anon_sym_for] = ACTIONS(4197),
    [anon_sym_to] = ACTIONS(4197),
    [anon_sym_downto] = ACTIONS(4197),
    [anon_sym_while] = ACTIONS(4197),
    [anon_sym_if] = ACTIONS(4197),
    [anon_sym_fun] = ACTIONS(4197),
    [anon_sym_try] = ACTIONS(4197),
    [anon_sym_match] = ACTIONS(4197),
    [anon_sym_match_BANG] = ACTIONS(4195),
    [anon_sym_function] = ACTIONS(4197),
    [anon_sym_LT_DASH] = ACTIONS(4197),
    [anon_sym_DOT_LBRACK] = ACTIONS(4195),
    [anon_sym_LT] = ACTIONS(4195),
    [anon_sym_use] = ACTIONS(4197),
    [anon_sym_use_BANG] = ACTIONS(4195),
    [anon_sym_do_BANG] = ACTIONS(4195),
    [anon_sym_begin] = ACTIONS(4197),
    [anon_sym_LPAREN2] = ACTIONS(4197),
    [anon_sym_DOT_DOT2] = ACTIONS(4195),
    [anon_sym_or] = ACTIONS(4197),
    [aux_sym_char_token1] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4197),
    [anon_sym_DQUOTE] = ACTIONS(4197),
    [anon_sym_AT_DQUOTE] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [sym_bool] = ACTIONS(4197),
    [sym_unit] = ACTIONS(4195),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4197),
    [sym_op_identifier] = ACTIONS(4197),
    [anon_sym_PLUS] = ACTIONS(4197),
    [anon_sym_DASH] = ACTIONS(4197),
    [anon_sym_PLUS_DOT] = ACTIONS(4197),
    [anon_sym_DASH_DOT] = ACTIONS(4197),
    [anon_sym_PERCENT] = ACTIONS(4197),
    [anon_sym_AMP_AMP] = ACTIONS(4197),
    [anon_sym_TILDE] = ACTIONS(4195),
    [aux_sym_prefix_op_token1] = ACTIONS(4197),
    [aux_sym_infix_op_token1] = ACTIONS(4195),
    [aux_sym_infix_op_token2] = ACTIONS(4197),
    [anon_sym_PIPE_PIPE] = ACTIONS(4197),
    [anon_sym_BANG_EQ] = ACTIONS(4197),
    [anon_sym_COLON_EQ] = ACTIONS(4195),
    [anon_sym_DOLLAR] = ACTIONS(4197),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4197),
    [sym_int] = ACTIONS(4197),
    [sym_xint] = ACTIONS(4195),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4195),
    [sym__newline] = ACTIONS(4195),
  },
  [2472] = {
    [sym__else_expression] = STATE(2971),
    [sym_elif_expression] = STATE(2768),
    [sym_block_comment] = STATE(2472),
    [sym_compiler_directive_decl] = STATE(2472),
    [sym_fsi_directive_decl] = STATE(2472),
    [sym_preproc_line] = STATE(2472),
    [aux_sym_if_expression_repeat1] = STATE(2589),
    [sym_identifier] = ACTIONS(3457),
    [anon_sym_EQ] = ACTIONS(3455),
    [anon_sym_COLON] = ACTIONS(3457),
    [anon_sym_return] = ACTIONS(3457),
    [anon_sym_do] = ACTIONS(3457),
    [anon_sym_let] = ACTIONS(3457),
    [anon_sym_let_BANG] = ACTIONS(3455),
    [anon_sym_as] = ACTIONS(3457),
    [anon_sym_LPAREN] = ACTIONS(3457),
    [anon_sym_COMMA] = ACTIONS(3455),
    [anon_sym_null] = ACTIONS(3457),
    [anon_sym_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_COLON] = ACTIONS(3455),
    [anon_sym_AMP] = ACTIONS(3457),
    [anon_sym_LBRACK] = ACTIONS(3457),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3457),
    [anon_sym_LT_AT] = ACTIONS(3457),
    [anon_sym_LT_AT_AT] = ACTIONS(3457),
    [anon_sym_DOT] = ACTIONS(3457),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3457),
    [anon_sym_with] = ACTIONS(3457),
    [anon_sym_return_BANG] = ACTIONS(3455),
    [anon_sym_yield] = ACTIONS(3457),
    [anon_sym_yield_BANG] = ACTIONS(3455),
    [anon_sym_lazy] = ACTIONS(3457),
    [anon_sym_assert] = ACTIONS(3457),
    [anon_sym_upcast] = ACTIONS(3457),
    [anon_sym_downcast] = ACTIONS(3457),
    [anon_sym_COLON_GT] = ACTIONS(3455),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3457),
    [anon_sym_while] = ACTIONS(3457),
    [anon_sym_else] = ACTIONS(4977),
    [anon_sym_elif] = ACTIONS(4979),
    [anon_sym_if] = ACTIONS(3457),
    [anon_sym_fun] = ACTIONS(3457),
    [anon_sym_try] = ACTIONS(3457),
    [anon_sym_match] = ACTIONS(3457),
    [anon_sym_match_BANG] = ACTIONS(3455),
    [anon_sym_function] = ACTIONS(3457),
    [anon_sym_LT_DASH] = ACTIONS(3457),
    [anon_sym_DOT_LBRACK] = ACTIONS(3455),
    [anon_sym_LT] = ACTIONS(3455),
    [anon_sym_use] = ACTIONS(3457),
    [anon_sym_use_BANG] = ACTIONS(3455),
    [anon_sym_do_BANG] = ACTIONS(3455),
    [anon_sym_begin] = ACTIONS(3457),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_or] = ACTIONS(3457),
    [aux_sym_char_token1] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [anon_sym_AT_DQUOTE] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [sym_bool] = ACTIONS(3457),
    [sym_unit] = ACTIONS(3455),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3457),
    [sym_op_identifier] = ACTIONS(3457),
    [anon_sym_PLUS] = ACTIONS(3457),
    [anon_sym_DASH] = ACTIONS(3457),
    [anon_sym_PLUS_DOT] = ACTIONS(3457),
    [anon_sym_DASH_DOT] = ACTIONS(3457),
    [anon_sym_PERCENT] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3455),
    [aux_sym_prefix_op_token1] = ACTIONS(3457),
    [aux_sym_infix_op_token1] = ACTIONS(3455),
    [aux_sym_infix_op_token2] = ACTIONS(3457),
    [anon_sym_PIPE_PIPE] = ACTIONS(3457),
    [anon_sym_BANG_EQ] = ACTIONS(3457),
    [anon_sym_COLON_EQ] = ACTIONS(3455),
    [anon_sym_DOLLAR] = ACTIONS(3457),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3457),
    [sym_int] = ACTIONS(3457),
    [sym_xint] = ACTIONS(3455),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3455),
    [sym__newline] = ACTIONS(3455),
  },
  [2473] = {
    [sym_block_comment] = STATE(2473),
    [sym_compiler_directive_decl] = STATE(2473),
    [sym_fsi_directive_decl] = STATE(2473),
    [sym_preproc_line] = STATE(2473),
    [ts_builtin_sym_end] = ACTIONS(3905),
    [sym_identifier] = ACTIONS(3907),
    [anon_sym_namespace] = ACTIONS(3907),
    [anon_sym_module] = ACTIONS(3907),
    [anon_sym_EQ] = ACTIONS(3905),
    [anon_sym_open] = ACTIONS(3907),
    [anon_sym_LBRACK_LT] = ACTIONS(3905),
    [anon_sym_COLON] = ACTIONS(3907),
    [anon_sym_return] = ACTIONS(3907),
    [anon_sym_type] = ACTIONS(3907),
    [anon_sym_do] = ACTIONS(3907),
    [anon_sym_let] = ACTIONS(3907),
    [anon_sym_let_BANG] = ACTIONS(3905),
    [anon_sym_LPAREN] = ACTIONS(3907),
    [anon_sym_COMMA] = ACTIONS(3905),
    [anon_sym_null] = ACTIONS(3907),
    [anon_sym_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_COLON] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3907),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3905),
    [anon_sym_LBRACE] = ACTIONS(3907),
    [anon_sym_LT_AT] = ACTIONS(3907),
    [anon_sym_LT_AT_AT] = ACTIONS(3907),
    [anon_sym_DOT] = ACTIONS(3907),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3905),
    [anon_sym_new] = ACTIONS(3907),
    [anon_sym_return_BANG] = ACTIONS(3905),
    [anon_sym_yield] = ACTIONS(3907),
    [anon_sym_yield_BANG] = ACTIONS(3905),
    [anon_sym_lazy] = ACTIONS(3907),
    [anon_sym_assert] = ACTIONS(3907),
    [anon_sym_upcast] = ACTIONS(3907),
    [anon_sym_downcast] = ACTIONS(3907),
    [anon_sym_COLON_GT] = ACTIONS(3905),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3905),
    [anon_sym_for] = ACTIONS(3907),
    [anon_sym_while] = ACTIONS(3907),
    [anon_sym_if] = ACTIONS(3907),
    [anon_sym_fun] = ACTIONS(3907),
    [anon_sym_try] = ACTIONS(3907),
    [anon_sym_match] = ACTIONS(3907),
    [anon_sym_match_BANG] = ACTIONS(3905),
    [anon_sym_function] = ACTIONS(3907),
    [anon_sym_LT_DASH] = ACTIONS(3907),
    [anon_sym_DOT_LBRACK] = ACTIONS(3905),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_use] = ACTIONS(3907),
    [anon_sym_use_BANG] = ACTIONS(3905),
    [anon_sym_do_BANG] = ACTIONS(3905),
    [anon_sym_begin] = ACTIONS(3907),
    [anon_sym_LPAREN2] = ACTIONS(3907),
    [anon_sym_or] = ACTIONS(3907),
    [anon_sym_exception] = ACTIONS(3907),
    [aux_sym_char_token1] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3907),
    [anon_sym_DQUOTE] = ACTIONS(3907),
    [anon_sym_AT_DQUOTE] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [sym_bool] = ACTIONS(3907),
    [sym_unit] = ACTIONS(3905),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3907),
    [sym_op_identifier] = ACTIONS(3907),
    [anon_sym_PLUS] = ACTIONS(3907),
    [anon_sym_DASH] = ACTIONS(3907),
    [anon_sym_PLUS_DOT] = ACTIONS(3907),
    [anon_sym_DASH_DOT] = ACTIONS(3907),
    [anon_sym_PERCENT] = ACTIONS(3907),
    [anon_sym_AMP_AMP] = ACTIONS(3907),
    [anon_sym_TILDE] = ACTIONS(3905),
    [aux_sym_prefix_op_token1] = ACTIONS(3907),
    [aux_sym_infix_op_token1] = ACTIONS(3905),
    [aux_sym_infix_op_token2] = ACTIONS(3907),
    [anon_sym_PIPE_PIPE] = ACTIONS(3907),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_COLON_EQ] = ACTIONS(3905),
    [anon_sym_DOLLAR] = ACTIONS(3907),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3907),
    [sym_int] = ACTIONS(3907),
    [sym_xint] = ACTIONS(3905),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3905),
    [anon_sym_POUNDload] = ACTIONS(3905),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3905),
    [sym__newline] = ACTIONS(3905),
  },
  [2474] = {
    [sym_block_comment] = STATE(2474),
    [sym_compiler_directive_decl] = STATE(2474),
    [sym_fsi_directive_decl] = STATE(2474),
    [sym_preproc_line] = STATE(2474),
    [ts_builtin_sym_end] = ACTIONS(3689),
    [sym_identifier] = ACTIONS(4182),
    [anon_sym_namespace] = ACTIONS(4182),
    [anon_sym_module] = ACTIONS(4182),
    [anon_sym_EQ] = ACTIONS(3689),
    [anon_sym_open] = ACTIONS(4182),
    [anon_sym_LBRACK_LT] = ACTIONS(3689),
    [anon_sym_COLON] = ACTIONS(4182),
    [anon_sym_return] = ACTIONS(4182),
    [anon_sym_type] = ACTIONS(4182),
    [anon_sym_do] = ACTIONS(4182),
    [anon_sym_let] = ACTIONS(4182),
    [anon_sym_let_BANG] = ACTIONS(3689),
    [anon_sym_LPAREN] = ACTIONS(4182),
    [anon_sym_COMMA] = ACTIONS(3689),
    [anon_sym_null] = ACTIONS(4182),
    [anon_sym_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3689),
    [anon_sym_LBRACE] = ACTIONS(4182),
    [anon_sym_LT_AT] = ACTIONS(4182),
    [anon_sym_LT_AT_AT] = ACTIONS(4182),
    [anon_sym_DOT] = ACTIONS(4182),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3689),
    [anon_sym_new] = ACTIONS(4182),
    [anon_sym_return_BANG] = ACTIONS(3689),
    [anon_sym_yield] = ACTIONS(4182),
    [anon_sym_yield_BANG] = ACTIONS(3689),
    [anon_sym_lazy] = ACTIONS(4182),
    [anon_sym_assert] = ACTIONS(4182),
    [anon_sym_upcast] = ACTIONS(4182),
    [anon_sym_downcast] = ACTIONS(4182),
    [anon_sym_COLON_GT] = ACTIONS(3689),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3689),
    [anon_sym_for] = ACTIONS(4182),
    [anon_sym_while] = ACTIONS(4182),
    [anon_sym_if] = ACTIONS(4182),
    [anon_sym_fun] = ACTIONS(4182),
    [anon_sym_try] = ACTIONS(4182),
    [anon_sym_match] = ACTIONS(4182),
    [anon_sym_match_BANG] = ACTIONS(3689),
    [anon_sym_function] = ACTIONS(4182),
    [anon_sym_LT_DASH] = ACTIONS(4182),
    [anon_sym_DOT_LBRACK] = ACTIONS(3689),
    [anon_sym_LT] = ACTIONS(3689),
    [anon_sym_use] = ACTIONS(4182),
    [anon_sym_use_BANG] = ACTIONS(3689),
    [anon_sym_do_BANG] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(4182),
    [anon_sym_LPAREN2] = ACTIONS(4182),
    [anon_sym_or] = ACTIONS(4182),
    [anon_sym_exception] = ACTIONS(4182),
    [aux_sym_char_token1] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4182),
    [anon_sym_DQUOTE] = ACTIONS(4182),
    [anon_sym_AT_DQUOTE] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [sym_bool] = ACTIONS(4182),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4182),
    [sym_op_identifier] = ACTIONS(4182),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_PLUS_DOT] = ACTIONS(4182),
    [anon_sym_DASH_DOT] = ACTIONS(4182),
    [anon_sym_PERCENT] = ACTIONS(4182),
    [anon_sym_AMP_AMP] = ACTIONS(4182),
    [anon_sym_TILDE] = ACTIONS(3689),
    [aux_sym_prefix_op_token1] = ACTIONS(4182),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token2] = ACTIONS(4182),
    [anon_sym_PIPE_PIPE] = ACTIONS(4182),
    [anon_sym_BANG_EQ] = ACTIONS(4182),
    [anon_sym_COLON_EQ] = ACTIONS(3689),
    [anon_sym_DOLLAR] = ACTIONS(4182),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4182),
    [sym_int] = ACTIONS(4182),
    [sym_xint] = ACTIONS(3689),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3689),
    [anon_sym_POUNDload] = ACTIONS(3689),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3689),
    [sym__newline] = ACTIONS(3689),
  },
  [2475] = {
    [sym_block_comment] = STATE(2475),
    [sym_compiler_directive_decl] = STATE(2475),
    [sym_fsi_directive_decl] = STATE(2475),
    [sym_preproc_line] = STATE(2475),
    [ts_builtin_sym_end] = ACTIONS(3970),
    [sym_identifier] = ACTIONS(3972),
    [anon_sym_namespace] = ACTIONS(3972),
    [anon_sym_module] = ACTIONS(3972),
    [anon_sym_EQ] = ACTIONS(3970),
    [anon_sym_open] = ACTIONS(3972),
    [anon_sym_LBRACK_LT] = ACTIONS(3970),
    [anon_sym_COLON] = ACTIONS(3972),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_type] = ACTIONS(3972),
    [anon_sym_do] = ACTIONS(3972),
    [anon_sym_let] = ACTIONS(3972),
    [anon_sym_let_BANG] = ACTIONS(3970),
    [anon_sym_LPAREN] = ACTIONS(3972),
    [anon_sym_COMMA] = ACTIONS(3970),
    [anon_sym_null] = ACTIONS(3972),
    [anon_sym_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_COLON] = ACTIONS(3970),
    [anon_sym_AMP] = ACTIONS(3972),
    [anon_sym_LBRACK] = ACTIONS(3972),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3970),
    [anon_sym_LBRACE] = ACTIONS(3972),
    [anon_sym_LT_AT] = ACTIONS(3972),
    [anon_sym_LT_AT_AT] = ACTIONS(3972),
    [anon_sym_DOT] = ACTIONS(3972),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3970),
    [anon_sym_new] = ACTIONS(3972),
    [anon_sym_return_BANG] = ACTIONS(3970),
    [anon_sym_yield] = ACTIONS(3972),
    [anon_sym_yield_BANG] = ACTIONS(3970),
    [anon_sym_lazy] = ACTIONS(3972),
    [anon_sym_assert] = ACTIONS(3972),
    [anon_sym_upcast] = ACTIONS(3972),
    [anon_sym_downcast] = ACTIONS(3972),
    [anon_sym_COLON_GT] = ACTIONS(3970),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3970),
    [anon_sym_for] = ACTIONS(3972),
    [anon_sym_while] = ACTIONS(3972),
    [anon_sym_if] = ACTIONS(3972),
    [anon_sym_fun] = ACTIONS(3972),
    [anon_sym_try] = ACTIONS(3972),
    [anon_sym_match] = ACTIONS(3972),
    [anon_sym_match_BANG] = ACTIONS(3970),
    [anon_sym_function] = ACTIONS(3972),
    [anon_sym_LT_DASH] = ACTIONS(3972),
    [anon_sym_DOT_LBRACK] = ACTIONS(3970),
    [anon_sym_LT] = ACTIONS(3970),
    [anon_sym_use] = ACTIONS(3972),
    [anon_sym_use_BANG] = ACTIONS(3970),
    [anon_sym_do_BANG] = ACTIONS(3970),
    [anon_sym_begin] = ACTIONS(3972),
    [anon_sym_LPAREN2] = ACTIONS(3972),
    [anon_sym_or] = ACTIONS(3972),
    [anon_sym_exception] = ACTIONS(3972),
    [aux_sym_char_token1] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3972),
    [anon_sym_DQUOTE] = ACTIONS(3972),
    [anon_sym_AT_DQUOTE] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [sym_bool] = ACTIONS(3972),
    [sym_unit] = ACTIONS(3970),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3972),
    [sym_op_identifier] = ACTIONS(3972),
    [anon_sym_PLUS] = ACTIONS(3972),
    [anon_sym_DASH] = ACTIONS(3972),
    [anon_sym_PLUS_DOT] = ACTIONS(3972),
    [anon_sym_DASH_DOT] = ACTIONS(3972),
    [anon_sym_PERCENT] = ACTIONS(3972),
    [anon_sym_AMP_AMP] = ACTIONS(3972),
    [anon_sym_TILDE] = ACTIONS(3970),
    [aux_sym_prefix_op_token1] = ACTIONS(3972),
    [aux_sym_infix_op_token1] = ACTIONS(3970),
    [aux_sym_infix_op_token2] = ACTIONS(3972),
    [anon_sym_PIPE_PIPE] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3972),
    [anon_sym_COLON_EQ] = ACTIONS(3970),
    [anon_sym_DOLLAR] = ACTIONS(3972),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3972),
    [sym_int] = ACTIONS(3972),
    [sym_xint] = ACTIONS(3970),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3970),
    [anon_sym_POUNDload] = ACTIONS(3970),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3970),
    [sym__newline] = ACTIONS(3970),
  },
  [2476] = {
    [sym_block_comment] = STATE(2476),
    [sym_compiler_directive_decl] = STATE(2476),
    [sym_fsi_directive_decl] = STATE(2476),
    [sym_preproc_line] = STATE(2476),
    [ts_builtin_sym_end] = ACTIONS(4076),
    [sym_identifier] = ACTIONS(4078),
    [anon_sym_namespace] = ACTIONS(4078),
    [anon_sym_module] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(4076),
    [anon_sym_open] = ACTIONS(4078),
    [anon_sym_LBRACK_LT] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4078),
    [anon_sym_return] = ACTIONS(4078),
    [anon_sym_type] = ACTIONS(4078),
    [anon_sym_do] = ACTIONS(4078),
    [anon_sym_let] = ACTIONS(4078),
    [anon_sym_let_BANG] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_null] = ACTIONS(4078),
    [anon_sym_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(4076),
    [anon_sym_AMP] = ACTIONS(4078),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4078),
    [anon_sym_LT_AT] = ACTIONS(4078),
    [anon_sym_LT_AT_AT] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(4078),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4076),
    [anon_sym_new] = ACTIONS(4078),
    [anon_sym_return_BANG] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(4078),
    [anon_sym_yield_BANG] = ACTIONS(4076),
    [anon_sym_lazy] = ACTIONS(4078),
    [anon_sym_assert] = ACTIONS(4078),
    [anon_sym_upcast] = ACTIONS(4078),
    [anon_sym_downcast] = ACTIONS(4078),
    [anon_sym_COLON_GT] = ACTIONS(4076),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4076),
    [anon_sym_for] = ACTIONS(4078),
    [anon_sym_while] = ACTIONS(4078),
    [anon_sym_if] = ACTIONS(4078),
    [anon_sym_fun] = ACTIONS(4078),
    [anon_sym_try] = ACTIONS(4078),
    [anon_sym_match] = ACTIONS(4078),
    [anon_sym_match_BANG] = ACTIONS(4076),
    [anon_sym_function] = ACTIONS(4078),
    [anon_sym_LT_DASH] = ACTIONS(4078),
    [anon_sym_DOT_LBRACK] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4076),
    [anon_sym_use] = ACTIONS(4078),
    [anon_sym_use_BANG] = ACTIONS(4076),
    [anon_sym_do_BANG] = ACTIONS(4076),
    [anon_sym_begin] = ACTIONS(4078),
    [anon_sym_LPAREN2] = ACTIONS(4078),
    [anon_sym_or] = ACTIONS(4078),
    [anon_sym_exception] = ACTIONS(4078),
    [aux_sym_char_token1] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4078),
    [anon_sym_DQUOTE] = ACTIONS(4078),
    [anon_sym_AT_DQUOTE] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [sym_bool] = ACTIONS(4078),
    [sym_unit] = ACTIONS(4076),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4078),
    [sym_op_identifier] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(4078),
    [anon_sym_PLUS_DOT] = ACTIONS(4078),
    [anon_sym_DASH_DOT] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [anon_sym_AMP_AMP] = ACTIONS(4078),
    [anon_sym_TILDE] = ACTIONS(4076),
    [aux_sym_prefix_op_token1] = ACTIONS(4078),
    [aux_sym_infix_op_token1] = ACTIONS(4076),
    [aux_sym_infix_op_token2] = ACTIONS(4078),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_BANG_EQ] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4076),
    [anon_sym_DOLLAR] = ACTIONS(4078),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4078),
    [sym_int] = ACTIONS(4078),
    [sym_xint] = ACTIONS(4076),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4076),
    [anon_sym_POUNDload] = ACTIONS(4076),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4076),
    [sym__newline] = ACTIONS(4076),
  },
  [2477] = {
    [sym_block_comment] = STATE(2477),
    [sym_compiler_directive_decl] = STATE(2477),
    [sym_fsi_directive_decl] = STATE(2477),
    [sym_preproc_line] = STATE(2477),
    [sym_identifier] = ACTIONS(4193),
    [anon_sym_EQ] = ACTIONS(4191),
    [anon_sym_GT_RBRACK] = ACTIONS(4191),
    [anon_sym_COLON] = ACTIONS(4193),
    [anon_sym_return] = ACTIONS(4193),
    [anon_sym_do] = ACTIONS(4193),
    [anon_sym_let] = ACTIONS(4193),
    [anon_sym_let_BANG] = ACTIONS(4191),
    [anon_sym_LPAREN] = ACTIONS(4193),
    [anon_sym_COMMA] = ACTIONS(4191),
    [anon_sym_null] = ACTIONS(4193),
    [anon_sym_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_COLON] = ACTIONS(4191),
    [anon_sym_AMP] = ACTIONS(4193),
    [anon_sym_LBRACK] = ACTIONS(4193),
    [anon_sym_RBRACK] = ACTIONS(4191),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4191),
    [anon_sym_LBRACE] = ACTIONS(4193),
    [anon_sym_RBRACE] = ACTIONS(4191),
    [anon_sym_LT_AT] = ACTIONS(4193),
    [anon_sym_LT_AT_AT] = ACTIONS(4193),
    [anon_sym_DOT] = ACTIONS(4193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4191),
    [anon_sym_new] = ACTIONS(4193),
    [anon_sym_with] = ACTIONS(4193),
    [anon_sym_return_BANG] = ACTIONS(4191),
    [anon_sym_yield] = ACTIONS(4193),
    [anon_sym_yield_BANG] = ACTIONS(4191),
    [anon_sym_lazy] = ACTIONS(4193),
    [anon_sym_assert] = ACTIONS(4193),
    [anon_sym_upcast] = ACTIONS(4193),
    [anon_sym_downcast] = ACTIONS(4193),
    [anon_sym_COLON_GT] = ACTIONS(4191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4191),
    [anon_sym_for] = ACTIONS(4193),
    [anon_sym_to] = ACTIONS(4193),
    [anon_sym_downto] = ACTIONS(4193),
    [anon_sym_while] = ACTIONS(4193),
    [anon_sym_if] = ACTIONS(4193),
    [anon_sym_fun] = ACTIONS(4193),
    [anon_sym_try] = ACTIONS(4193),
    [anon_sym_match] = ACTIONS(4193),
    [anon_sym_match_BANG] = ACTIONS(4191),
    [anon_sym_function] = ACTIONS(4193),
    [anon_sym_LT_DASH] = ACTIONS(4193),
    [anon_sym_DOT_LBRACK] = ACTIONS(4191),
    [anon_sym_LT] = ACTIONS(4191),
    [anon_sym_use] = ACTIONS(4193),
    [anon_sym_use_BANG] = ACTIONS(4191),
    [anon_sym_do_BANG] = ACTIONS(4191),
    [anon_sym_begin] = ACTIONS(4193),
    [anon_sym_LPAREN2] = ACTIONS(4193),
    [anon_sym_DOT_DOT2] = ACTIONS(4191),
    [anon_sym_or] = ACTIONS(4193),
    [aux_sym_char_token1] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4193),
    [anon_sym_DQUOTE] = ACTIONS(4193),
    [anon_sym_AT_DQUOTE] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [sym_bool] = ACTIONS(4193),
    [sym_unit] = ACTIONS(4191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4193),
    [sym_op_identifier] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4193),
    [anon_sym_DASH] = ACTIONS(4193),
    [anon_sym_PLUS_DOT] = ACTIONS(4193),
    [anon_sym_DASH_DOT] = ACTIONS(4193),
    [anon_sym_PERCENT] = ACTIONS(4193),
    [anon_sym_AMP_AMP] = ACTIONS(4193),
    [anon_sym_TILDE] = ACTIONS(4191),
    [aux_sym_prefix_op_token1] = ACTIONS(4193),
    [aux_sym_infix_op_token1] = ACTIONS(4191),
    [aux_sym_infix_op_token2] = ACTIONS(4193),
    [anon_sym_PIPE_PIPE] = ACTIONS(4193),
    [anon_sym_BANG_EQ] = ACTIONS(4193),
    [anon_sym_COLON_EQ] = ACTIONS(4191),
    [anon_sym_DOLLAR] = ACTIONS(4193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4193),
    [sym_int] = ACTIONS(4193),
    [sym_xint] = ACTIONS(4191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4191),
    [sym__newline] = ACTIONS(4191),
  },
  [2478] = {
    [sym_block_comment] = STATE(2478),
    [sym_compiler_directive_decl] = STATE(2478),
    [sym_fsi_directive_decl] = STATE(2478),
    [sym_preproc_line] = STATE(2478),
    [sym_identifier] = ACTIONS(4208),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_GT_RBRACK] = ACTIONS(4206),
    [anon_sym_COLON] = ACTIONS(4208),
    [anon_sym_return] = ACTIONS(4208),
    [anon_sym_do] = ACTIONS(4208),
    [anon_sym_let] = ACTIONS(4208),
    [anon_sym_let_BANG] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(4206),
    [anon_sym_null] = ACTIONS(4208),
    [anon_sym_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_COLON] = ACTIONS(4206),
    [anon_sym_AMP] = ACTIONS(4208),
    [anon_sym_LBRACK] = ACTIONS(4208),
    [anon_sym_RBRACK] = ACTIONS(4206),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4206),
    [anon_sym_LBRACE] = ACTIONS(4208),
    [anon_sym_RBRACE] = ACTIONS(4206),
    [anon_sym_LT_AT] = ACTIONS(4208),
    [anon_sym_LT_AT_AT] = ACTIONS(4208),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4206),
    [anon_sym_new] = ACTIONS(4208),
    [anon_sym_with] = ACTIONS(4208),
    [anon_sym_return_BANG] = ACTIONS(4206),
    [anon_sym_yield] = ACTIONS(4208),
    [anon_sym_yield_BANG] = ACTIONS(4206),
    [anon_sym_lazy] = ACTIONS(4208),
    [anon_sym_assert] = ACTIONS(4208),
    [anon_sym_upcast] = ACTIONS(4208),
    [anon_sym_downcast] = ACTIONS(4208),
    [anon_sym_COLON_GT] = ACTIONS(4206),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4206),
    [anon_sym_for] = ACTIONS(4208),
    [anon_sym_to] = ACTIONS(4208),
    [anon_sym_downto] = ACTIONS(4208),
    [anon_sym_while] = ACTIONS(4208),
    [anon_sym_if] = ACTIONS(4208),
    [anon_sym_fun] = ACTIONS(4208),
    [anon_sym_try] = ACTIONS(4208),
    [anon_sym_match] = ACTIONS(4208),
    [anon_sym_match_BANG] = ACTIONS(4206),
    [anon_sym_function] = ACTIONS(4208),
    [anon_sym_LT_DASH] = ACTIONS(4208),
    [anon_sym_DOT_LBRACK] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(4206),
    [anon_sym_use] = ACTIONS(4208),
    [anon_sym_use_BANG] = ACTIONS(4206),
    [anon_sym_do_BANG] = ACTIONS(4206),
    [anon_sym_begin] = ACTIONS(4208),
    [anon_sym_LPAREN2] = ACTIONS(4208),
    [anon_sym_DOT_DOT2] = ACTIONS(4206),
    [anon_sym_or] = ACTIONS(4208),
    [aux_sym_char_token1] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4208),
    [anon_sym_DQUOTE] = ACTIONS(4208),
    [anon_sym_AT_DQUOTE] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [sym_bool] = ACTIONS(4208),
    [sym_unit] = ACTIONS(4206),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4208),
    [sym_op_identifier] = ACTIONS(4208),
    [anon_sym_PLUS] = ACTIONS(4208),
    [anon_sym_DASH] = ACTIONS(4208),
    [anon_sym_PLUS_DOT] = ACTIONS(4208),
    [anon_sym_DASH_DOT] = ACTIONS(4208),
    [anon_sym_PERCENT] = ACTIONS(4208),
    [anon_sym_AMP_AMP] = ACTIONS(4208),
    [anon_sym_TILDE] = ACTIONS(4206),
    [aux_sym_prefix_op_token1] = ACTIONS(4208),
    [aux_sym_infix_op_token1] = ACTIONS(4206),
    [aux_sym_infix_op_token2] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(4208),
    [anon_sym_BANG_EQ] = ACTIONS(4208),
    [anon_sym_COLON_EQ] = ACTIONS(4206),
    [anon_sym_DOLLAR] = ACTIONS(4208),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4208),
    [sym_int] = ACTIONS(4208),
    [sym_xint] = ACTIONS(4206),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4206),
    [sym__newline] = ACTIONS(4206),
  },
  [2479] = {
    [sym_block_comment] = STATE(2479),
    [sym_compiler_directive_decl] = STATE(2479),
    [sym_fsi_directive_decl] = STATE(2479),
    [sym_preproc_line] = STATE(2479),
    [ts_builtin_sym_end] = ACTIONS(4005),
    [sym_identifier] = ACTIONS(4007),
    [anon_sym_namespace] = ACTIONS(4007),
    [anon_sym_module] = ACTIONS(4007),
    [anon_sym_EQ] = ACTIONS(4005),
    [anon_sym_open] = ACTIONS(4007),
    [anon_sym_LBRACK_LT] = ACTIONS(4005),
    [anon_sym_COLON] = ACTIONS(4007),
    [anon_sym_return] = ACTIONS(4007),
    [anon_sym_type] = ACTIONS(4007),
    [anon_sym_do] = ACTIONS(4007),
    [anon_sym_let] = ACTIONS(4007),
    [anon_sym_let_BANG] = ACTIONS(4005),
    [anon_sym_LPAREN] = ACTIONS(4007),
    [anon_sym_COMMA] = ACTIONS(4005),
    [anon_sym_null] = ACTIONS(4007),
    [anon_sym_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_COLON] = ACTIONS(4005),
    [anon_sym_AMP] = ACTIONS(4007),
    [anon_sym_LBRACK] = ACTIONS(4007),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4005),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_LT_AT] = ACTIONS(4007),
    [anon_sym_LT_AT_AT] = ACTIONS(4007),
    [anon_sym_DOT] = ACTIONS(4007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4005),
    [anon_sym_new] = ACTIONS(4007),
    [anon_sym_return_BANG] = ACTIONS(4005),
    [anon_sym_yield] = ACTIONS(4007),
    [anon_sym_yield_BANG] = ACTIONS(4005),
    [anon_sym_lazy] = ACTIONS(4007),
    [anon_sym_assert] = ACTIONS(4007),
    [anon_sym_upcast] = ACTIONS(4007),
    [anon_sym_downcast] = ACTIONS(4007),
    [anon_sym_COLON_GT] = ACTIONS(4005),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4005),
    [anon_sym_for] = ACTIONS(4007),
    [anon_sym_while] = ACTIONS(4007),
    [anon_sym_if] = ACTIONS(4007),
    [anon_sym_fun] = ACTIONS(4007),
    [anon_sym_try] = ACTIONS(4007),
    [anon_sym_match] = ACTIONS(4007),
    [anon_sym_match_BANG] = ACTIONS(4005),
    [anon_sym_function] = ACTIONS(4007),
    [anon_sym_LT_DASH] = ACTIONS(4007),
    [anon_sym_DOT_LBRACK] = ACTIONS(4005),
    [anon_sym_LT] = ACTIONS(4005),
    [anon_sym_use] = ACTIONS(4007),
    [anon_sym_use_BANG] = ACTIONS(4005),
    [anon_sym_do_BANG] = ACTIONS(4005),
    [anon_sym_begin] = ACTIONS(4007),
    [anon_sym_LPAREN2] = ACTIONS(4007),
    [anon_sym_or] = ACTIONS(4007),
    [anon_sym_exception] = ACTIONS(4007),
    [aux_sym_char_token1] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4007),
    [anon_sym_DQUOTE] = ACTIONS(4007),
    [anon_sym_AT_DQUOTE] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [sym_bool] = ACTIONS(4007),
    [sym_unit] = ACTIONS(4005),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4007),
    [sym_op_identifier] = ACTIONS(4007),
    [anon_sym_PLUS] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4007),
    [anon_sym_PLUS_DOT] = ACTIONS(4007),
    [anon_sym_DASH_DOT] = ACTIONS(4007),
    [anon_sym_PERCENT] = ACTIONS(4007),
    [anon_sym_AMP_AMP] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4005),
    [aux_sym_prefix_op_token1] = ACTIONS(4007),
    [aux_sym_infix_op_token1] = ACTIONS(4005),
    [aux_sym_infix_op_token2] = ACTIONS(4007),
    [anon_sym_PIPE_PIPE] = ACTIONS(4007),
    [anon_sym_BANG_EQ] = ACTIONS(4007),
    [anon_sym_COLON_EQ] = ACTIONS(4005),
    [anon_sym_DOLLAR] = ACTIONS(4007),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4007),
    [sym_int] = ACTIONS(4007),
    [sym_xint] = ACTIONS(4005),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4005),
    [anon_sym_POUNDload] = ACTIONS(4005),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4005),
    [sym__newline] = ACTIONS(4005),
  },
  [2480] = {
    [sym_block_comment] = STATE(2480),
    [sym_compiler_directive_decl] = STATE(2480),
    [sym_fsi_directive_decl] = STATE(2480),
    [sym_preproc_line] = STATE(2480),
    [ts_builtin_sym_end] = ACTIONS(3898),
    [sym_identifier] = ACTIONS(3900),
    [anon_sym_namespace] = ACTIONS(3900),
    [anon_sym_module] = ACTIONS(3900),
    [anon_sym_EQ] = ACTIONS(3898),
    [anon_sym_open] = ACTIONS(3900),
    [anon_sym_LBRACK_LT] = ACTIONS(3898),
    [anon_sym_COLON] = ACTIONS(3900),
    [anon_sym_return] = ACTIONS(3900),
    [anon_sym_type] = ACTIONS(3900),
    [anon_sym_do] = ACTIONS(3900),
    [anon_sym_let] = ACTIONS(3900),
    [anon_sym_let_BANG] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3898),
    [anon_sym_null] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_COLON] = ACTIONS(3898),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_LBRACK] = ACTIONS(3900),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3898),
    [anon_sym_LBRACE] = ACTIONS(3900),
    [anon_sym_LT_AT] = ACTIONS(3900),
    [anon_sym_LT_AT_AT] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(3900),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3898),
    [anon_sym_new] = ACTIONS(3900),
    [anon_sym_return_BANG] = ACTIONS(3898),
    [anon_sym_yield] = ACTIONS(3900),
    [anon_sym_yield_BANG] = ACTIONS(3898),
    [anon_sym_lazy] = ACTIONS(3900),
    [anon_sym_assert] = ACTIONS(3900),
    [anon_sym_upcast] = ACTIONS(3900),
    [anon_sym_downcast] = ACTIONS(3900),
    [anon_sym_COLON_GT] = ACTIONS(3898),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3898),
    [anon_sym_for] = ACTIONS(3900),
    [anon_sym_while] = ACTIONS(3900),
    [anon_sym_if] = ACTIONS(3900),
    [anon_sym_fun] = ACTIONS(3900),
    [anon_sym_try] = ACTIONS(3900),
    [anon_sym_match] = ACTIONS(3900),
    [anon_sym_match_BANG] = ACTIONS(3898),
    [anon_sym_function] = ACTIONS(3900),
    [anon_sym_LT_DASH] = ACTIONS(3900),
    [anon_sym_DOT_LBRACK] = ACTIONS(3898),
    [anon_sym_LT] = ACTIONS(3898),
    [anon_sym_use] = ACTIONS(3900),
    [anon_sym_use_BANG] = ACTIONS(3898),
    [anon_sym_do_BANG] = ACTIONS(3898),
    [anon_sym_begin] = ACTIONS(3900),
    [anon_sym_LPAREN2] = ACTIONS(3900),
    [anon_sym_or] = ACTIONS(3900),
    [anon_sym_exception] = ACTIONS(3900),
    [aux_sym_char_token1] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3900),
    [anon_sym_DQUOTE] = ACTIONS(3900),
    [anon_sym_AT_DQUOTE] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3898),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3900),
    [sym_op_identifier] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(3900),
    [anon_sym_DASH] = ACTIONS(3900),
    [anon_sym_PLUS_DOT] = ACTIONS(3900),
    [anon_sym_DASH_DOT] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(3900),
    [anon_sym_AMP_AMP] = ACTIONS(3900),
    [anon_sym_TILDE] = ACTIONS(3898),
    [aux_sym_prefix_op_token1] = ACTIONS(3900),
    [aux_sym_infix_op_token1] = ACTIONS(3898),
    [aux_sym_infix_op_token2] = ACTIONS(3900),
    [anon_sym_PIPE_PIPE] = ACTIONS(3900),
    [anon_sym_BANG_EQ] = ACTIONS(3900),
    [anon_sym_COLON_EQ] = ACTIONS(3898),
    [anon_sym_DOLLAR] = ACTIONS(3900),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3900),
    [sym_int] = ACTIONS(3900),
    [sym_xint] = ACTIONS(3898),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3898),
    [anon_sym_POUNDload] = ACTIONS(3898),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3898),
    [sym__newline] = ACTIONS(3898),
  },
  [2481] = {
    [sym_block_comment] = STATE(2481),
    [sym_compiler_directive_decl] = STATE(2481),
    [sym_fsi_directive_decl] = STATE(2481),
    [sym_preproc_line] = STATE(2481),
    [ts_builtin_sym_end] = ACTIONS(3994),
    [sym_identifier] = ACTIONS(3996),
    [anon_sym_namespace] = ACTIONS(3996),
    [anon_sym_module] = ACTIONS(3996),
    [anon_sym_EQ] = ACTIONS(3994),
    [anon_sym_open] = ACTIONS(3996),
    [anon_sym_LBRACK_LT] = ACTIONS(3994),
    [anon_sym_COLON] = ACTIONS(3996),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_type] = ACTIONS(3996),
    [anon_sym_do] = ACTIONS(3996),
    [anon_sym_let] = ACTIONS(3996),
    [anon_sym_let_BANG] = ACTIONS(3994),
    [anon_sym_LPAREN] = ACTIONS(3996),
    [anon_sym_COMMA] = ACTIONS(3994),
    [anon_sym_null] = ACTIONS(3996),
    [anon_sym_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_COLON] = ACTIONS(3994),
    [anon_sym_AMP] = ACTIONS(3996),
    [anon_sym_LBRACK] = ACTIONS(3996),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3994),
    [anon_sym_LBRACE] = ACTIONS(3996),
    [anon_sym_LT_AT] = ACTIONS(3996),
    [anon_sym_LT_AT_AT] = ACTIONS(3996),
    [anon_sym_DOT] = ACTIONS(3996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3994),
    [anon_sym_new] = ACTIONS(3996),
    [anon_sym_return_BANG] = ACTIONS(3994),
    [anon_sym_yield] = ACTIONS(3996),
    [anon_sym_yield_BANG] = ACTIONS(3994),
    [anon_sym_lazy] = ACTIONS(3996),
    [anon_sym_assert] = ACTIONS(3996),
    [anon_sym_upcast] = ACTIONS(3996),
    [anon_sym_downcast] = ACTIONS(3996),
    [anon_sym_COLON_GT] = ACTIONS(3994),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3994),
    [anon_sym_for] = ACTIONS(3996),
    [anon_sym_while] = ACTIONS(3996),
    [anon_sym_if] = ACTIONS(3996),
    [anon_sym_fun] = ACTIONS(3996),
    [anon_sym_try] = ACTIONS(3996),
    [anon_sym_match] = ACTIONS(3996),
    [anon_sym_match_BANG] = ACTIONS(3994),
    [anon_sym_function] = ACTIONS(3996),
    [anon_sym_LT_DASH] = ACTIONS(3996),
    [anon_sym_DOT_LBRACK] = ACTIONS(3994),
    [anon_sym_LT] = ACTIONS(3994),
    [anon_sym_use] = ACTIONS(3996),
    [anon_sym_use_BANG] = ACTIONS(3994),
    [anon_sym_do_BANG] = ACTIONS(3994),
    [anon_sym_begin] = ACTIONS(3996),
    [anon_sym_LPAREN2] = ACTIONS(3996),
    [anon_sym_or] = ACTIONS(3996),
    [anon_sym_exception] = ACTIONS(3996),
    [aux_sym_char_token1] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3996),
    [anon_sym_DQUOTE] = ACTIONS(3996),
    [anon_sym_AT_DQUOTE] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [sym_bool] = ACTIONS(3996),
    [sym_unit] = ACTIONS(3994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3996),
    [sym_op_identifier] = ACTIONS(3996),
    [anon_sym_PLUS] = ACTIONS(3996),
    [anon_sym_DASH] = ACTIONS(3996),
    [anon_sym_PLUS_DOT] = ACTIONS(3996),
    [anon_sym_DASH_DOT] = ACTIONS(3996),
    [anon_sym_PERCENT] = ACTIONS(3996),
    [anon_sym_AMP_AMP] = ACTIONS(3996),
    [anon_sym_TILDE] = ACTIONS(3994),
    [aux_sym_prefix_op_token1] = ACTIONS(3996),
    [aux_sym_infix_op_token1] = ACTIONS(3994),
    [aux_sym_infix_op_token2] = ACTIONS(3996),
    [anon_sym_PIPE_PIPE] = ACTIONS(3996),
    [anon_sym_BANG_EQ] = ACTIONS(3996),
    [anon_sym_COLON_EQ] = ACTIONS(3994),
    [anon_sym_DOLLAR] = ACTIONS(3996),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3996),
    [sym_int] = ACTIONS(3996),
    [sym_xint] = ACTIONS(3994),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3994),
    [anon_sym_POUNDload] = ACTIONS(3994),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3994),
    [sym__newline] = ACTIONS(3994),
  },
  [2482] = {
    [sym_block_comment] = STATE(2482),
    [sym_compiler_directive_decl] = STATE(2482),
    [sym_fsi_directive_decl] = STATE(2482),
    [sym_preproc_line] = STATE(2482),
    [ts_builtin_sym_end] = ACTIONS(3891),
    [sym_identifier] = ACTIONS(3893),
    [anon_sym_namespace] = ACTIONS(3893),
    [anon_sym_module] = ACTIONS(3893),
    [anon_sym_EQ] = ACTIONS(3891),
    [anon_sym_open] = ACTIONS(3893),
    [anon_sym_LBRACK_LT] = ACTIONS(3891),
    [anon_sym_COLON] = ACTIONS(3893),
    [anon_sym_return] = ACTIONS(3893),
    [anon_sym_type] = ACTIONS(3893),
    [anon_sym_do] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_let_BANG] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_COMMA] = ACTIONS(3891),
    [anon_sym_null] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_COLON] = ACTIONS(3891),
    [anon_sym_AMP] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3891),
    [anon_sym_LBRACE] = ACTIONS(3893),
    [anon_sym_LT_AT] = ACTIONS(3893),
    [anon_sym_LT_AT_AT] = ACTIONS(3893),
    [anon_sym_DOT] = ACTIONS(3893),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3891),
    [anon_sym_new] = ACTIONS(3893),
    [anon_sym_return_BANG] = ACTIONS(3891),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_yield_BANG] = ACTIONS(3891),
    [anon_sym_lazy] = ACTIONS(3893),
    [anon_sym_assert] = ACTIONS(3893),
    [anon_sym_upcast] = ACTIONS(3893),
    [anon_sym_downcast] = ACTIONS(3893),
    [anon_sym_COLON_GT] = ACTIONS(3891),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3891),
    [anon_sym_for] = ACTIONS(3893),
    [anon_sym_while] = ACTIONS(3893),
    [anon_sym_if] = ACTIONS(3893),
    [anon_sym_fun] = ACTIONS(3893),
    [anon_sym_try] = ACTIONS(3893),
    [anon_sym_match] = ACTIONS(3893),
    [anon_sym_match_BANG] = ACTIONS(3891),
    [anon_sym_function] = ACTIONS(3893),
    [anon_sym_LT_DASH] = ACTIONS(3893),
    [anon_sym_DOT_LBRACK] = ACTIONS(3891),
    [anon_sym_LT] = ACTIONS(3891),
    [anon_sym_use] = ACTIONS(3893),
    [anon_sym_use_BANG] = ACTIONS(3891),
    [anon_sym_do_BANG] = ACTIONS(3891),
    [anon_sym_begin] = ACTIONS(3893),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_or] = ACTIONS(3893),
    [anon_sym_exception] = ACTIONS(3893),
    [aux_sym_char_token1] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3893),
    [anon_sym_DQUOTE] = ACTIONS(3893),
    [anon_sym_AT_DQUOTE] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [sym_bool] = ACTIONS(3893),
    [sym_unit] = ACTIONS(3891),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3893),
    [sym_op_identifier] = ACTIONS(3893),
    [anon_sym_PLUS] = ACTIONS(3893),
    [anon_sym_DASH] = ACTIONS(3893),
    [anon_sym_PLUS_DOT] = ACTIONS(3893),
    [anon_sym_DASH_DOT] = ACTIONS(3893),
    [anon_sym_PERCENT] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_TILDE] = ACTIONS(3891),
    [aux_sym_prefix_op_token1] = ACTIONS(3893),
    [aux_sym_infix_op_token1] = ACTIONS(3891),
    [aux_sym_infix_op_token2] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [anon_sym_BANG_EQ] = ACTIONS(3893),
    [anon_sym_COLON_EQ] = ACTIONS(3891),
    [anon_sym_DOLLAR] = ACTIONS(3893),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3893),
    [sym_int] = ACTIONS(3893),
    [sym_xint] = ACTIONS(3891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3891),
    [anon_sym_POUNDload] = ACTIONS(3891),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3891),
    [sym__newline] = ACTIONS(3891),
  },
  [2483] = {
    [sym_block_comment] = STATE(2483),
    [sym_compiler_directive_decl] = STATE(2483),
    [sym_fsi_directive_decl] = STATE(2483),
    [sym_preproc_line] = STATE(2483),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [anon_sym_as] = ACTIONS(3515),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_COLON] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_with] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(3513),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_LT_DASH] = ACTIONS(3515),
    [anon_sym_DOT_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_or] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3515),
    [anon_sym_DASH_DOT] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3515),
    [aux_sym_infix_op_token1] = ACTIONS(3513),
    [aux_sym_infix_op_token2] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3515),
    [anon_sym_COLON_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(3515),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3515),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
    [sym__dedent] = ACTIONS(3513),
  },
  [2484] = {
    [sym_block_comment] = STATE(2484),
    [sym_compiler_directive_decl] = STATE(2484),
    [sym_fsi_directive_decl] = STATE(2484),
    [sym_preproc_line] = STATE(2484),
    [ts_builtin_sym_end] = ACTIONS(4062),
    [sym_identifier] = ACTIONS(4064),
    [anon_sym_namespace] = ACTIONS(4064),
    [anon_sym_module] = ACTIONS(4064),
    [anon_sym_EQ] = ACTIONS(4062),
    [anon_sym_open] = ACTIONS(4064),
    [anon_sym_LBRACK_LT] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4064),
    [anon_sym_return] = ACTIONS(4064),
    [anon_sym_type] = ACTIONS(4064),
    [anon_sym_do] = ACTIONS(4064),
    [anon_sym_let] = ACTIONS(4064),
    [anon_sym_let_BANG] = ACTIONS(4062),
    [anon_sym_LPAREN] = ACTIONS(4064),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_null] = ACTIONS(4064),
    [anon_sym_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_COLON] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4062),
    [anon_sym_LBRACE] = ACTIONS(4064),
    [anon_sym_LT_AT] = ACTIONS(4064),
    [anon_sym_LT_AT_AT] = ACTIONS(4064),
    [anon_sym_DOT] = ACTIONS(4064),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4062),
    [anon_sym_new] = ACTIONS(4064),
    [anon_sym_return_BANG] = ACTIONS(4062),
    [anon_sym_yield] = ACTIONS(4064),
    [anon_sym_yield_BANG] = ACTIONS(4062),
    [anon_sym_lazy] = ACTIONS(4064),
    [anon_sym_assert] = ACTIONS(4064),
    [anon_sym_upcast] = ACTIONS(4064),
    [anon_sym_downcast] = ACTIONS(4064),
    [anon_sym_COLON_GT] = ACTIONS(4062),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4062),
    [anon_sym_for] = ACTIONS(4064),
    [anon_sym_while] = ACTIONS(4064),
    [anon_sym_if] = ACTIONS(4064),
    [anon_sym_fun] = ACTIONS(4064),
    [anon_sym_try] = ACTIONS(4064),
    [anon_sym_match] = ACTIONS(4064),
    [anon_sym_match_BANG] = ACTIONS(4062),
    [anon_sym_function] = ACTIONS(4064),
    [anon_sym_LT_DASH] = ACTIONS(4064),
    [anon_sym_DOT_LBRACK] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(4062),
    [anon_sym_use] = ACTIONS(4064),
    [anon_sym_use_BANG] = ACTIONS(4062),
    [anon_sym_do_BANG] = ACTIONS(4062),
    [anon_sym_begin] = ACTIONS(4064),
    [anon_sym_LPAREN2] = ACTIONS(4064),
    [anon_sym_or] = ACTIONS(4064),
    [anon_sym_exception] = ACTIONS(4064),
    [aux_sym_char_token1] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_AT_DQUOTE] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [sym_bool] = ACTIONS(4064),
    [sym_unit] = ACTIONS(4062),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4064),
    [sym_op_identifier] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4064),
    [anon_sym_DASH] = ACTIONS(4064),
    [anon_sym_PLUS_DOT] = ACTIONS(4064),
    [anon_sym_DASH_DOT] = ACTIONS(4064),
    [anon_sym_PERCENT] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_TILDE] = ACTIONS(4062),
    [aux_sym_prefix_op_token1] = ACTIONS(4064),
    [aux_sym_infix_op_token1] = ACTIONS(4062),
    [aux_sym_infix_op_token2] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_BANG_EQ] = ACTIONS(4064),
    [anon_sym_COLON_EQ] = ACTIONS(4062),
    [anon_sym_DOLLAR] = ACTIONS(4064),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4064),
    [sym_int] = ACTIONS(4064),
    [sym_xint] = ACTIONS(4062),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4062),
    [anon_sym_POUNDload] = ACTIONS(4062),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4062),
    [sym__newline] = ACTIONS(4062),
  },
  [2485] = {
    [sym_block_comment] = STATE(2485),
    [sym_compiler_directive_decl] = STATE(2485),
    [sym_fsi_directive_decl] = STATE(2485),
    [sym_preproc_line] = STATE(2485),
    [ts_builtin_sym_end] = ACTIONS(4001),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_namespace] = ACTIONS(4003),
    [anon_sym_module] = ACTIONS(4003),
    [anon_sym_EQ] = ACTIONS(4001),
    [anon_sym_open] = ACTIONS(4003),
    [anon_sym_LBRACK_LT] = ACTIONS(4001),
    [anon_sym_COLON] = ACTIONS(4003),
    [anon_sym_return] = ACTIONS(4003),
    [anon_sym_type] = ACTIONS(4003),
    [anon_sym_do] = ACTIONS(4003),
    [anon_sym_let] = ACTIONS(4003),
    [anon_sym_let_BANG] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4003),
    [anon_sym_COMMA] = ACTIONS(4001),
    [anon_sym_null] = ACTIONS(4003),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_COLON] = ACTIONS(4001),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LBRACK] = ACTIONS(4003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4001),
    [anon_sym_LBRACE] = ACTIONS(4003),
    [anon_sym_LT_AT] = ACTIONS(4003),
    [anon_sym_LT_AT_AT] = ACTIONS(4003),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4001),
    [anon_sym_new] = ACTIONS(4003),
    [anon_sym_return_BANG] = ACTIONS(4001),
    [anon_sym_yield] = ACTIONS(4003),
    [anon_sym_yield_BANG] = ACTIONS(4001),
    [anon_sym_lazy] = ACTIONS(4003),
    [anon_sym_assert] = ACTIONS(4003),
    [anon_sym_upcast] = ACTIONS(4003),
    [anon_sym_downcast] = ACTIONS(4003),
    [anon_sym_COLON_GT] = ACTIONS(4001),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4001),
    [anon_sym_for] = ACTIONS(4003),
    [anon_sym_while] = ACTIONS(4003),
    [anon_sym_if] = ACTIONS(4003),
    [anon_sym_fun] = ACTIONS(4003),
    [anon_sym_try] = ACTIONS(4003),
    [anon_sym_match] = ACTIONS(4003),
    [anon_sym_match_BANG] = ACTIONS(4001),
    [anon_sym_function] = ACTIONS(4003),
    [anon_sym_LT_DASH] = ACTIONS(4003),
    [anon_sym_DOT_LBRACK] = ACTIONS(4001),
    [anon_sym_LT] = ACTIONS(4001),
    [anon_sym_use] = ACTIONS(4003),
    [anon_sym_use_BANG] = ACTIONS(4001),
    [anon_sym_do_BANG] = ACTIONS(4001),
    [anon_sym_begin] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [anon_sym_exception] = ACTIONS(4003),
    [aux_sym_char_token1] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4003),
    [anon_sym_DQUOTE] = ACTIONS(4003),
    [anon_sym_AT_DQUOTE] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [sym_bool] = ACTIONS(4003),
    [sym_unit] = ACTIONS(4001),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4003),
    [sym_op_identifier] = ACTIONS(4003),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_PLUS_DOT] = ACTIONS(4003),
    [anon_sym_DASH_DOT] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4003),
    [anon_sym_TILDE] = ACTIONS(4001),
    [aux_sym_prefix_op_token1] = ACTIONS(4003),
    [aux_sym_infix_op_token1] = ACTIONS(4001),
    [aux_sym_infix_op_token2] = ACTIONS(4003),
    [anon_sym_PIPE_PIPE] = ACTIONS(4003),
    [anon_sym_BANG_EQ] = ACTIONS(4003),
    [anon_sym_COLON_EQ] = ACTIONS(4001),
    [anon_sym_DOLLAR] = ACTIONS(4003),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4003),
    [sym_int] = ACTIONS(4003),
    [sym_xint] = ACTIONS(4001),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4001),
    [anon_sym_POUNDload] = ACTIONS(4001),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4001),
    [sym__newline] = ACTIONS(4001),
  },
  [2486] = {
    [sym_block_comment] = STATE(2486),
    [sym_compiler_directive_decl] = STATE(2486),
    [sym_fsi_directive_decl] = STATE(2486),
    [sym_preproc_line] = STATE(2486),
    [ts_builtin_sym_end] = ACTIONS(3843),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_namespace] = ACTIONS(3845),
    [anon_sym_module] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3843),
    [anon_sym_open] = ACTIONS(3845),
    [anon_sym_LBRACK_LT] = ACTIONS(3843),
    [anon_sym_COLON] = ACTIONS(3845),
    [anon_sym_return] = ACTIONS(3845),
    [anon_sym_type] = ACTIONS(3845),
    [anon_sym_do] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_let_BANG] = ACTIONS(3843),
    [anon_sym_LPAREN] = ACTIONS(3845),
    [anon_sym_COMMA] = ACTIONS(3843),
    [anon_sym_null] = ACTIONS(3845),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3843),
    [anon_sym_LBRACE] = ACTIONS(3845),
    [anon_sym_LT_AT] = ACTIONS(3845),
    [anon_sym_LT_AT_AT] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3843),
    [anon_sym_new] = ACTIONS(3845),
    [anon_sym_return_BANG] = ACTIONS(3843),
    [anon_sym_yield] = ACTIONS(3845),
    [anon_sym_yield_BANG] = ACTIONS(3843),
    [anon_sym_lazy] = ACTIONS(3845),
    [anon_sym_assert] = ACTIONS(3845),
    [anon_sym_upcast] = ACTIONS(3845),
    [anon_sym_downcast] = ACTIONS(3845),
    [anon_sym_COLON_GT] = ACTIONS(3843),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3843),
    [anon_sym_for] = ACTIONS(3845),
    [anon_sym_while] = ACTIONS(3845),
    [anon_sym_if] = ACTIONS(3845),
    [anon_sym_fun] = ACTIONS(3845),
    [anon_sym_try] = ACTIONS(3845),
    [anon_sym_match] = ACTIONS(3845),
    [anon_sym_match_BANG] = ACTIONS(3843),
    [anon_sym_function] = ACTIONS(3845),
    [anon_sym_LT_DASH] = ACTIONS(3845),
    [anon_sym_DOT_LBRACK] = ACTIONS(3843),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_use] = ACTIONS(3845),
    [anon_sym_use_BANG] = ACTIONS(3843),
    [anon_sym_do_BANG] = ACTIONS(3843),
    [anon_sym_begin] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(3845),
    [anon_sym_or] = ACTIONS(3845),
    [anon_sym_exception] = ACTIONS(3845),
    [aux_sym_char_token1] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3845),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_AT_DQUOTE] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [sym_bool] = ACTIONS(3845),
    [sym_unit] = ACTIONS(3843),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3845),
    [sym_op_identifier] = ACTIONS(3845),
    [anon_sym_PLUS] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_PLUS_DOT] = ACTIONS(3845),
    [anon_sym_DASH_DOT] = ACTIONS(3845),
    [anon_sym_PERCENT] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3845),
    [anon_sym_TILDE] = ACTIONS(3843),
    [aux_sym_prefix_op_token1] = ACTIONS(3845),
    [aux_sym_infix_op_token1] = ACTIONS(3843),
    [aux_sym_infix_op_token2] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(3845),
    [anon_sym_BANG_EQ] = ACTIONS(3845),
    [anon_sym_COLON_EQ] = ACTIONS(3843),
    [anon_sym_DOLLAR] = ACTIONS(3845),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3845),
    [sym_int] = ACTIONS(3845),
    [sym_xint] = ACTIONS(3843),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3843),
    [anon_sym_POUNDload] = ACTIONS(3843),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3843),
    [sym__newline] = ACTIONS(3843),
  },
  [2487] = {
    [sym_block_comment] = STATE(2487),
    [sym_compiler_directive_decl] = STATE(2487),
    [sym_fsi_directive_decl] = STATE(2487),
    [sym_preproc_line] = STATE(2487),
    [ts_builtin_sym_end] = ACTIONS(4016),
    [sym_identifier] = ACTIONS(4018),
    [anon_sym_namespace] = ACTIONS(4018),
    [anon_sym_module] = ACTIONS(4018),
    [anon_sym_EQ] = ACTIONS(4016),
    [anon_sym_open] = ACTIONS(4018),
    [anon_sym_LBRACK_LT] = ACTIONS(4016),
    [anon_sym_COLON] = ACTIONS(4018),
    [anon_sym_return] = ACTIONS(4018),
    [anon_sym_type] = ACTIONS(4018),
    [anon_sym_do] = ACTIONS(4018),
    [anon_sym_let] = ACTIONS(4018),
    [anon_sym_let_BANG] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(4018),
    [anon_sym_COMMA] = ACTIONS(4016),
    [anon_sym_null] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_COLON] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4018),
    [anon_sym_LBRACK] = ACTIONS(4018),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4016),
    [anon_sym_LBRACE] = ACTIONS(4018),
    [anon_sym_LT_AT] = ACTIONS(4018),
    [anon_sym_LT_AT_AT] = ACTIONS(4018),
    [anon_sym_DOT] = ACTIONS(4018),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4016),
    [anon_sym_new] = ACTIONS(4018),
    [anon_sym_return_BANG] = ACTIONS(4016),
    [anon_sym_yield] = ACTIONS(4018),
    [anon_sym_yield_BANG] = ACTIONS(4016),
    [anon_sym_lazy] = ACTIONS(4018),
    [anon_sym_assert] = ACTIONS(4018),
    [anon_sym_upcast] = ACTIONS(4018),
    [anon_sym_downcast] = ACTIONS(4018),
    [anon_sym_COLON_GT] = ACTIONS(4016),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4016),
    [anon_sym_for] = ACTIONS(4018),
    [anon_sym_while] = ACTIONS(4018),
    [anon_sym_if] = ACTIONS(4018),
    [anon_sym_fun] = ACTIONS(4018),
    [anon_sym_try] = ACTIONS(4018),
    [anon_sym_match] = ACTIONS(4018),
    [anon_sym_match_BANG] = ACTIONS(4016),
    [anon_sym_function] = ACTIONS(4018),
    [anon_sym_LT_DASH] = ACTIONS(4018),
    [anon_sym_DOT_LBRACK] = ACTIONS(4016),
    [anon_sym_LT] = ACTIONS(4016),
    [anon_sym_use] = ACTIONS(4018),
    [anon_sym_use_BANG] = ACTIONS(4016),
    [anon_sym_do_BANG] = ACTIONS(4016),
    [anon_sym_begin] = ACTIONS(4018),
    [anon_sym_LPAREN2] = ACTIONS(4018),
    [anon_sym_or] = ACTIONS(4018),
    [anon_sym_exception] = ACTIONS(4018),
    [aux_sym_char_token1] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(4018),
    [anon_sym_AT_DQUOTE] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [sym_bool] = ACTIONS(4018),
    [sym_unit] = ACTIONS(4016),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4018),
    [sym_op_identifier] = ACTIONS(4018),
    [anon_sym_PLUS] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_PLUS_DOT] = ACTIONS(4018),
    [anon_sym_DASH_DOT] = ACTIONS(4018),
    [anon_sym_PERCENT] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4016),
    [aux_sym_prefix_op_token1] = ACTIONS(4018),
    [aux_sym_infix_op_token1] = ACTIONS(4016),
    [aux_sym_infix_op_token2] = ACTIONS(4018),
    [anon_sym_PIPE_PIPE] = ACTIONS(4018),
    [anon_sym_BANG_EQ] = ACTIONS(4018),
    [anon_sym_COLON_EQ] = ACTIONS(4016),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4018),
    [sym_int] = ACTIONS(4018),
    [sym_xint] = ACTIONS(4016),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4016),
    [anon_sym_POUNDload] = ACTIONS(4016),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4016),
    [sym__newline] = ACTIONS(4016),
  },
  [2488] = {
    [sym_block_comment] = STATE(2488),
    [sym_compiler_directive_decl] = STATE(2488),
    [sym_fsi_directive_decl] = STATE(2488),
    [sym_preproc_line] = STATE(2488),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_GT_RBRACK] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_RBRACK] = ACTIONS(3485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_RBRACE] = ACTIONS(3485),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_to] = ACTIONS(3487),
    [anon_sym_downto] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_DOT_DOT2] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [2489] = {
    [sym_block_comment] = STATE(2489),
    [sym_compiler_directive_decl] = STATE(2489),
    [sym_fsi_directive_decl] = STATE(2489),
    [sym_preproc_line] = STATE(2489),
    [ts_builtin_sym_end] = ACTIONS(4052),
    [sym_identifier] = ACTIONS(4054),
    [anon_sym_namespace] = ACTIONS(4054),
    [anon_sym_module] = ACTIONS(4054),
    [anon_sym_EQ] = ACTIONS(4052),
    [anon_sym_open] = ACTIONS(4054),
    [anon_sym_LBRACK_LT] = ACTIONS(4052),
    [anon_sym_COLON] = ACTIONS(4054),
    [anon_sym_return] = ACTIONS(4054),
    [anon_sym_type] = ACTIONS(4054),
    [anon_sym_do] = ACTIONS(4054),
    [anon_sym_let] = ACTIONS(4054),
    [anon_sym_let_BANG] = ACTIONS(4052),
    [anon_sym_LPAREN] = ACTIONS(4054),
    [anon_sym_COMMA] = ACTIONS(4052),
    [anon_sym_null] = ACTIONS(4054),
    [anon_sym_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_COLON] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(4054),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4052),
    [anon_sym_LBRACE] = ACTIONS(4054),
    [anon_sym_LT_AT] = ACTIONS(4054),
    [anon_sym_LT_AT_AT] = ACTIONS(4054),
    [anon_sym_DOT] = ACTIONS(4054),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_return_BANG] = ACTIONS(4052),
    [anon_sym_yield] = ACTIONS(4054),
    [anon_sym_yield_BANG] = ACTIONS(4052),
    [anon_sym_lazy] = ACTIONS(4054),
    [anon_sym_assert] = ACTIONS(4054),
    [anon_sym_upcast] = ACTIONS(4054),
    [anon_sym_downcast] = ACTIONS(4054),
    [anon_sym_COLON_GT] = ACTIONS(4052),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4052),
    [anon_sym_for] = ACTIONS(4054),
    [anon_sym_while] = ACTIONS(4054),
    [anon_sym_if] = ACTIONS(4054),
    [anon_sym_fun] = ACTIONS(4054),
    [anon_sym_try] = ACTIONS(4054),
    [anon_sym_match] = ACTIONS(4054),
    [anon_sym_match_BANG] = ACTIONS(4052),
    [anon_sym_function] = ACTIONS(4054),
    [anon_sym_LT_DASH] = ACTIONS(4054),
    [anon_sym_DOT_LBRACK] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_use] = ACTIONS(4054),
    [anon_sym_use_BANG] = ACTIONS(4052),
    [anon_sym_do_BANG] = ACTIONS(4052),
    [anon_sym_begin] = ACTIONS(4054),
    [anon_sym_LPAREN2] = ACTIONS(4054),
    [anon_sym_or] = ACTIONS(4054),
    [anon_sym_exception] = ACTIONS(4054),
    [aux_sym_char_token1] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4054),
    [anon_sym_DQUOTE] = ACTIONS(4054),
    [anon_sym_AT_DQUOTE] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [sym_bool] = ACTIONS(4054),
    [sym_unit] = ACTIONS(4052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4054),
    [sym_op_identifier] = ACTIONS(4054),
    [anon_sym_PLUS] = ACTIONS(4054),
    [anon_sym_DASH] = ACTIONS(4054),
    [anon_sym_PLUS_DOT] = ACTIONS(4054),
    [anon_sym_DASH_DOT] = ACTIONS(4054),
    [anon_sym_PERCENT] = ACTIONS(4054),
    [anon_sym_AMP_AMP] = ACTIONS(4054),
    [anon_sym_TILDE] = ACTIONS(4052),
    [aux_sym_prefix_op_token1] = ACTIONS(4054),
    [aux_sym_infix_op_token1] = ACTIONS(4052),
    [aux_sym_infix_op_token2] = ACTIONS(4054),
    [anon_sym_PIPE_PIPE] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4054),
    [anon_sym_COLON_EQ] = ACTIONS(4052),
    [anon_sym_DOLLAR] = ACTIONS(4054),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4054),
    [sym_int] = ACTIONS(4054),
    [sym_xint] = ACTIONS(4052),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4052),
    [anon_sym_POUNDload] = ACTIONS(4052),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4052),
    [sym__newline] = ACTIONS(4052),
  },
  [2490] = {
    [sym_block_comment] = STATE(2490),
    [sym_compiler_directive_decl] = STATE(2490),
    [sym_fsi_directive_decl] = STATE(2490),
    [sym_preproc_line] = STATE(2490),
    [ts_builtin_sym_end] = ACTIONS(4080),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_namespace] = ACTIONS(4082),
    [anon_sym_module] = ACTIONS(4082),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_open] = ACTIONS(4082),
    [anon_sym_LBRACK_LT] = ACTIONS(4080),
    [anon_sym_COLON] = ACTIONS(4082),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_type] = ACTIONS(4082),
    [anon_sym_do] = ACTIONS(4082),
    [anon_sym_let] = ACTIONS(4082),
    [anon_sym_let_BANG] = ACTIONS(4080),
    [anon_sym_LPAREN] = ACTIONS(4082),
    [anon_sym_COMMA] = ACTIONS(4080),
    [anon_sym_null] = ACTIONS(4082),
    [anon_sym_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_COLON] = ACTIONS(4080),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_LBRACK] = ACTIONS(4082),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(4082),
    [anon_sym_LT_AT] = ACTIONS(4082),
    [anon_sym_LT_AT_AT] = ACTIONS(4082),
    [anon_sym_DOT] = ACTIONS(4082),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4080),
    [anon_sym_new] = ACTIONS(4082),
    [anon_sym_return_BANG] = ACTIONS(4080),
    [anon_sym_yield] = ACTIONS(4082),
    [anon_sym_yield_BANG] = ACTIONS(4080),
    [anon_sym_lazy] = ACTIONS(4082),
    [anon_sym_assert] = ACTIONS(4082),
    [anon_sym_upcast] = ACTIONS(4082),
    [anon_sym_downcast] = ACTIONS(4082),
    [anon_sym_COLON_GT] = ACTIONS(4080),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4080),
    [anon_sym_for] = ACTIONS(4082),
    [anon_sym_while] = ACTIONS(4082),
    [anon_sym_if] = ACTIONS(4082),
    [anon_sym_fun] = ACTIONS(4082),
    [anon_sym_try] = ACTIONS(4082),
    [anon_sym_match] = ACTIONS(4082),
    [anon_sym_match_BANG] = ACTIONS(4080),
    [anon_sym_function] = ACTIONS(4082),
    [anon_sym_LT_DASH] = ACTIONS(4082),
    [anon_sym_DOT_LBRACK] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(4080),
    [anon_sym_use] = ACTIONS(4082),
    [anon_sym_use_BANG] = ACTIONS(4080),
    [anon_sym_do_BANG] = ACTIONS(4080),
    [anon_sym_begin] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4082),
    [anon_sym_or] = ACTIONS(4082),
    [anon_sym_exception] = ACTIONS(4082),
    [aux_sym_char_token1] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4082),
    [anon_sym_DQUOTE] = ACTIONS(4082),
    [anon_sym_AT_DQUOTE] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [sym_bool] = ACTIONS(4082),
    [sym_unit] = ACTIONS(4080),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4082),
    [sym_op_identifier] = ACTIONS(4082),
    [anon_sym_PLUS] = ACTIONS(4082),
    [anon_sym_DASH] = ACTIONS(4082),
    [anon_sym_PLUS_DOT] = ACTIONS(4082),
    [anon_sym_DASH_DOT] = ACTIONS(4082),
    [anon_sym_PERCENT] = ACTIONS(4082),
    [anon_sym_AMP_AMP] = ACTIONS(4082),
    [anon_sym_TILDE] = ACTIONS(4080),
    [aux_sym_prefix_op_token1] = ACTIONS(4082),
    [aux_sym_infix_op_token1] = ACTIONS(4080),
    [aux_sym_infix_op_token2] = ACTIONS(4082),
    [anon_sym_PIPE_PIPE] = ACTIONS(4082),
    [anon_sym_BANG_EQ] = ACTIONS(4082),
    [anon_sym_COLON_EQ] = ACTIONS(4080),
    [anon_sym_DOLLAR] = ACTIONS(4082),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4082),
    [sym_int] = ACTIONS(4082),
    [sym_xint] = ACTIONS(4080),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4080),
    [anon_sym_POUNDload] = ACTIONS(4080),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4080),
    [sym__newline] = ACTIONS(4080),
  },
  [2491] = {
    [sym_block_comment] = STATE(2491),
    [sym_compiler_directive_decl] = STATE(2491),
    [sym_fsi_directive_decl] = STATE(2491),
    [sym_preproc_line] = STATE(2491),
    [ts_builtin_sym_end] = ACTIONS(4084),
    [sym_identifier] = ACTIONS(4086),
    [anon_sym_namespace] = ACTIONS(4086),
    [anon_sym_module] = ACTIONS(4086),
    [anon_sym_EQ] = ACTIONS(4084),
    [anon_sym_open] = ACTIONS(4086),
    [anon_sym_LBRACK_LT] = ACTIONS(4084),
    [anon_sym_COLON] = ACTIONS(4086),
    [anon_sym_return] = ACTIONS(4086),
    [anon_sym_type] = ACTIONS(4086),
    [anon_sym_do] = ACTIONS(4086),
    [anon_sym_let] = ACTIONS(4086),
    [anon_sym_let_BANG] = ACTIONS(4084),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_COMMA] = ACTIONS(4084),
    [anon_sym_null] = ACTIONS(4086),
    [anon_sym_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_COLON] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4084),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_LT_AT] = ACTIONS(4086),
    [anon_sym_LT_AT_AT] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4086),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4084),
    [anon_sym_new] = ACTIONS(4086),
    [anon_sym_return_BANG] = ACTIONS(4084),
    [anon_sym_yield] = ACTIONS(4086),
    [anon_sym_yield_BANG] = ACTIONS(4084),
    [anon_sym_lazy] = ACTIONS(4086),
    [anon_sym_assert] = ACTIONS(4086),
    [anon_sym_upcast] = ACTIONS(4086),
    [anon_sym_downcast] = ACTIONS(4086),
    [anon_sym_COLON_GT] = ACTIONS(4084),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4084),
    [anon_sym_for] = ACTIONS(4086),
    [anon_sym_while] = ACTIONS(4086),
    [anon_sym_if] = ACTIONS(4086),
    [anon_sym_fun] = ACTIONS(4086),
    [anon_sym_try] = ACTIONS(4086),
    [anon_sym_match] = ACTIONS(4086),
    [anon_sym_match_BANG] = ACTIONS(4084),
    [anon_sym_function] = ACTIONS(4086),
    [anon_sym_LT_DASH] = ACTIONS(4086),
    [anon_sym_DOT_LBRACK] = ACTIONS(4084),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_use] = ACTIONS(4086),
    [anon_sym_use_BANG] = ACTIONS(4084),
    [anon_sym_do_BANG] = ACTIONS(4084),
    [anon_sym_begin] = ACTIONS(4086),
    [anon_sym_LPAREN2] = ACTIONS(4086),
    [anon_sym_or] = ACTIONS(4086),
    [anon_sym_exception] = ACTIONS(4086),
    [aux_sym_char_token1] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4086),
    [anon_sym_DQUOTE] = ACTIONS(4086),
    [anon_sym_AT_DQUOTE] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [sym_bool] = ACTIONS(4086),
    [sym_unit] = ACTIONS(4084),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4086),
    [sym_op_identifier] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4086),
    [anon_sym_DASH] = ACTIONS(4086),
    [anon_sym_PLUS_DOT] = ACTIONS(4086),
    [anon_sym_DASH_DOT] = ACTIONS(4086),
    [anon_sym_PERCENT] = ACTIONS(4086),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_TILDE] = ACTIONS(4084),
    [aux_sym_prefix_op_token1] = ACTIONS(4086),
    [aux_sym_infix_op_token1] = ACTIONS(4084),
    [aux_sym_infix_op_token2] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_COLON_EQ] = ACTIONS(4084),
    [anon_sym_DOLLAR] = ACTIONS(4086),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4086),
    [sym_int] = ACTIONS(4086),
    [sym_xint] = ACTIONS(4084),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4084),
    [anon_sym_POUNDload] = ACTIONS(4084),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4084),
    [sym__newline] = ACTIONS(4084),
  },
  [2492] = {
    [sym_block_comment] = STATE(2492),
    [sym_compiler_directive_decl] = STATE(2492),
    [sym_fsi_directive_decl] = STATE(2492),
    [sym_preproc_line] = STATE(2492),
    [ts_builtin_sym_end] = ACTIONS(4091),
    [sym_identifier] = ACTIONS(4093),
    [anon_sym_namespace] = ACTIONS(4093),
    [anon_sym_module] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(4091),
    [anon_sym_open] = ACTIONS(4093),
    [anon_sym_LBRACK_LT] = ACTIONS(4091),
    [anon_sym_COLON] = ACTIONS(4093),
    [anon_sym_return] = ACTIONS(4093),
    [anon_sym_type] = ACTIONS(4093),
    [anon_sym_do] = ACTIONS(4093),
    [anon_sym_let] = ACTIONS(4093),
    [anon_sym_let_BANG] = ACTIONS(4091),
    [anon_sym_LPAREN] = ACTIONS(4093),
    [anon_sym_COMMA] = ACTIONS(4091),
    [anon_sym_null] = ACTIONS(4093),
    [anon_sym_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_COLON] = ACTIONS(4091),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(4093),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4091),
    [anon_sym_LBRACE] = ACTIONS(4093),
    [anon_sym_LT_AT] = ACTIONS(4093),
    [anon_sym_LT_AT_AT] = ACTIONS(4093),
    [anon_sym_DOT] = ACTIONS(4093),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4091),
    [anon_sym_new] = ACTIONS(4093),
    [anon_sym_return_BANG] = ACTIONS(4091),
    [anon_sym_yield] = ACTIONS(4093),
    [anon_sym_yield_BANG] = ACTIONS(4091),
    [anon_sym_lazy] = ACTIONS(4093),
    [anon_sym_assert] = ACTIONS(4093),
    [anon_sym_upcast] = ACTIONS(4093),
    [anon_sym_downcast] = ACTIONS(4093),
    [anon_sym_COLON_GT] = ACTIONS(4091),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4091),
    [anon_sym_for] = ACTIONS(4093),
    [anon_sym_while] = ACTIONS(4093),
    [anon_sym_if] = ACTIONS(4093),
    [anon_sym_fun] = ACTIONS(4093),
    [anon_sym_try] = ACTIONS(4093),
    [anon_sym_match] = ACTIONS(4093),
    [anon_sym_match_BANG] = ACTIONS(4091),
    [anon_sym_function] = ACTIONS(4093),
    [anon_sym_LT_DASH] = ACTIONS(4093),
    [anon_sym_DOT_LBRACK] = ACTIONS(4091),
    [anon_sym_LT] = ACTIONS(4091),
    [anon_sym_use] = ACTIONS(4093),
    [anon_sym_use_BANG] = ACTIONS(4091),
    [anon_sym_do_BANG] = ACTIONS(4091),
    [anon_sym_begin] = ACTIONS(4093),
    [anon_sym_LPAREN2] = ACTIONS(4093),
    [anon_sym_or] = ACTIONS(4093),
    [anon_sym_exception] = ACTIONS(4093),
    [aux_sym_char_token1] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4093),
    [anon_sym_DQUOTE] = ACTIONS(4093),
    [anon_sym_AT_DQUOTE] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [sym_bool] = ACTIONS(4093),
    [sym_unit] = ACTIONS(4091),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4093),
    [sym_op_identifier] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS_DOT] = ACTIONS(4093),
    [anon_sym_DASH_DOT] = ACTIONS(4093),
    [anon_sym_PERCENT] = ACTIONS(4093),
    [anon_sym_AMP_AMP] = ACTIONS(4093),
    [anon_sym_TILDE] = ACTIONS(4091),
    [aux_sym_prefix_op_token1] = ACTIONS(4093),
    [aux_sym_infix_op_token1] = ACTIONS(4091),
    [aux_sym_infix_op_token2] = ACTIONS(4093),
    [anon_sym_PIPE_PIPE] = ACTIONS(4093),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_COLON_EQ] = ACTIONS(4091),
    [anon_sym_DOLLAR] = ACTIONS(4093),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4093),
    [sym_int] = ACTIONS(4093),
    [sym_xint] = ACTIONS(4091),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4091),
    [anon_sym_POUNDload] = ACTIONS(4091),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4091),
    [sym__newline] = ACTIONS(4091),
  },
  [2493] = {
    [sym_block_comment] = STATE(2493),
    [sym_compiler_directive_decl] = STATE(2493),
    [sym_fsi_directive_decl] = STATE(2493),
    [sym_preproc_line] = STATE(2493),
    [ts_builtin_sym_end] = ACTIONS(4106),
    [sym_identifier] = ACTIONS(4108),
    [anon_sym_namespace] = ACTIONS(4108),
    [anon_sym_module] = ACTIONS(4108),
    [anon_sym_EQ] = ACTIONS(4106),
    [anon_sym_open] = ACTIONS(4108),
    [anon_sym_LBRACK_LT] = ACTIONS(4106),
    [anon_sym_COLON] = ACTIONS(4108),
    [anon_sym_return] = ACTIONS(4108),
    [anon_sym_type] = ACTIONS(4108),
    [anon_sym_do] = ACTIONS(4108),
    [anon_sym_let] = ACTIONS(4108),
    [anon_sym_let_BANG] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(4108),
    [anon_sym_COMMA] = ACTIONS(4106),
    [anon_sym_null] = ACTIONS(4108),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_COLON] = ACTIONS(4106),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LBRACK] = ACTIONS(4108),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(4108),
    [anon_sym_LT_AT] = ACTIONS(4108),
    [anon_sym_LT_AT_AT] = ACTIONS(4108),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4106),
    [anon_sym_new] = ACTIONS(4108),
    [anon_sym_return_BANG] = ACTIONS(4106),
    [anon_sym_yield] = ACTIONS(4108),
    [anon_sym_yield_BANG] = ACTIONS(4106),
    [anon_sym_lazy] = ACTIONS(4108),
    [anon_sym_assert] = ACTIONS(4108),
    [anon_sym_upcast] = ACTIONS(4108),
    [anon_sym_downcast] = ACTIONS(4108),
    [anon_sym_COLON_GT] = ACTIONS(4106),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4106),
    [anon_sym_for] = ACTIONS(4108),
    [anon_sym_while] = ACTIONS(4108),
    [anon_sym_if] = ACTIONS(4108),
    [anon_sym_fun] = ACTIONS(4108),
    [anon_sym_try] = ACTIONS(4108),
    [anon_sym_match] = ACTIONS(4108),
    [anon_sym_match_BANG] = ACTIONS(4106),
    [anon_sym_function] = ACTIONS(4108),
    [anon_sym_LT_DASH] = ACTIONS(4108),
    [anon_sym_DOT_LBRACK] = ACTIONS(4106),
    [anon_sym_LT] = ACTIONS(4106),
    [anon_sym_use] = ACTIONS(4108),
    [anon_sym_use_BANG] = ACTIONS(4106),
    [anon_sym_do_BANG] = ACTIONS(4106),
    [anon_sym_begin] = ACTIONS(4108),
    [anon_sym_LPAREN2] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [anon_sym_exception] = ACTIONS(4108),
    [aux_sym_char_token1] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4108),
    [anon_sym_DQUOTE] = ACTIONS(4108),
    [anon_sym_AT_DQUOTE] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [sym_bool] = ACTIONS(4108),
    [sym_unit] = ACTIONS(4106),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4108),
    [sym_op_identifier] = ACTIONS(4108),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_PLUS_DOT] = ACTIONS(4108),
    [anon_sym_DASH_DOT] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_AMP_AMP] = ACTIONS(4108),
    [anon_sym_TILDE] = ACTIONS(4106),
    [aux_sym_prefix_op_token1] = ACTIONS(4108),
    [aux_sym_infix_op_token1] = ACTIONS(4106),
    [aux_sym_infix_op_token2] = ACTIONS(4108),
    [anon_sym_PIPE_PIPE] = ACTIONS(4108),
    [anon_sym_BANG_EQ] = ACTIONS(4108),
    [anon_sym_COLON_EQ] = ACTIONS(4106),
    [anon_sym_DOLLAR] = ACTIONS(4108),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4108),
    [sym_int] = ACTIONS(4108),
    [sym_xint] = ACTIONS(4106),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4106),
    [anon_sym_POUNDload] = ACTIONS(4106),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4106),
    [sym__newline] = ACTIONS(4106),
  },
  [2494] = {
    [sym_block_comment] = STATE(2494),
    [sym_compiler_directive_decl] = STATE(2494),
    [sym_fsi_directive_decl] = STATE(2494),
    [sym_preproc_line] = STATE(2494),
    [ts_builtin_sym_end] = ACTIONS(4110),
    [sym_identifier] = ACTIONS(4112),
    [anon_sym_namespace] = ACTIONS(4112),
    [anon_sym_module] = ACTIONS(4112),
    [anon_sym_EQ] = ACTIONS(4110),
    [anon_sym_open] = ACTIONS(4112),
    [anon_sym_LBRACK_LT] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4112),
    [anon_sym_return] = ACTIONS(4112),
    [anon_sym_type] = ACTIONS(4112),
    [anon_sym_do] = ACTIONS(4112),
    [anon_sym_let] = ACTIONS(4112),
    [anon_sym_let_BANG] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_null] = ACTIONS(4112),
    [anon_sym_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_COLON] = ACTIONS(4110),
    [anon_sym_AMP] = ACTIONS(4112),
    [anon_sym_LBRACK] = ACTIONS(4112),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4110),
    [anon_sym_LBRACE] = ACTIONS(4112),
    [anon_sym_LT_AT] = ACTIONS(4112),
    [anon_sym_LT_AT_AT] = ACTIONS(4112),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4110),
    [anon_sym_new] = ACTIONS(4112),
    [anon_sym_return_BANG] = ACTIONS(4110),
    [anon_sym_yield] = ACTIONS(4112),
    [anon_sym_yield_BANG] = ACTIONS(4110),
    [anon_sym_lazy] = ACTIONS(4112),
    [anon_sym_assert] = ACTIONS(4112),
    [anon_sym_upcast] = ACTIONS(4112),
    [anon_sym_downcast] = ACTIONS(4112),
    [anon_sym_COLON_GT] = ACTIONS(4110),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4110),
    [anon_sym_for] = ACTIONS(4112),
    [anon_sym_while] = ACTIONS(4112),
    [anon_sym_if] = ACTIONS(4112),
    [anon_sym_fun] = ACTIONS(4112),
    [anon_sym_try] = ACTIONS(4112),
    [anon_sym_match] = ACTIONS(4112),
    [anon_sym_match_BANG] = ACTIONS(4110),
    [anon_sym_function] = ACTIONS(4112),
    [anon_sym_LT_DASH] = ACTIONS(4112),
    [anon_sym_DOT_LBRACK] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(4110),
    [anon_sym_use] = ACTIONS(4112),
    [anon_sym_use_BANG] = ACTIONS(4110),
    [anon_sym_do_BANG] = ACTIONS(4110),
    [anon_sym_begin] = ACTIONS(4112),
    [anon_sym_LPAREN2] = ACTIONS(4112),
    [anon_sym_or] = ACTIONS(4112),
    [anon_sym_exception] = ACTIONS(4112),
    [aux_sym_char_token1] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4112),
    [anon_sym_DQUOTE] = ACTIONS(4112),
    [anon_sym_AT_DQUOTE] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [sym_bool] = ACTIONS(4112),
    [sym_unit] = ACTIONS(4110),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4112),
    [sym_op_identifier] = ACTIONS(4112),
    [anon_sym_PLUS] = ACTIONS(4112),
    [anon_sym_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_DOT] = ACTIONS(4112),
    [anon_sym_DASH_DOT] = ACTIONS(4112),
    [anon_sym_PERCENT] = ACTIONS(4112),
    [anon_sym_AMP_AMP] = ACTIONS(4112),
    [anon_sym_TILDE] = ACTIONS(4110),
    [aux_sym_prefix_op_token1] = ACTIONS(4112),
    [aux_sym_infix_op_token1] = ACTIONS(4110),
    [aux_sym_infix_op_token2] = ACTIONS(4112),
    [anon_sym_PIPE_PIPE] = ACTIONS(4112),
    [anon_sym_BANG_EQ] = ACTIONS(4112),
    [anon_sym_COLON_EQ] = ACTIONS(4110),
    [anon_sym_DOLLAR] = ACTIONS(4112),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4112),
    [sym_int] = ACTIONS(4112),
    [sym_xint] = ACTIONS(4110),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4110),
    [anon_sym_POUNDload] = ACTIONS(4110),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4110),
    [sym__newline] = ACTIONS(4110),
  },
  [2495] = {
    [sym_block_comment] = STATE(2495),
    [sym_compiler_directive_decl] = STATE(2495),
    [sym_fsi_directive_decl] = STATE(2495),
    [sym_preproc_line] = STATE(2495),
    [ts_builtin_sym_end] = ACTIONS(4116),
    [sym_identifier] = ACTIONS(4118),
    [anon_sym_namespace] = ACTIONS(4118),
    [anon_sym_module] = ACTIONS(4118),
    [anon_sym_EQ] = ACTIONS(4116),
    [anon_sym_open] = ACTIONS(4118),
    [anon_sym_LBRACK_LT] = ACTIONS(4116),
    [anon_sym_COLON] = ACTIONS(4118),
    [anon_sym_return] = ACTIONS(4118),
    [anon_sym_type] = ACTIONS(4118),
    [anon_sym_do] = ACTIONS(4118),
    [anon_sym_let] = ACTIONS(4118),
    [anon_sym_let_BANG] = ACTIONS(4116),
    [anon_sym_LPAREN] = ACTIONS(4118),
    [anon_sym_COMMA] = ACTIONS(4116),
    [anon_sym_null] = ACTIONS(4118),
    [anon_sym_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_COLON] = ACTIONS(4116),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4118),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(4118),
    [anon_sym_LT_AT] = ACTIONS(4118),
    [anon_sym_LT_AT_AT] = ACTIONS(4118),
    [anon_sym_DOT] = ACTIONS(4118),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4116),
    [anon_sym_new] = ACTIONS(4118),
    [anon_sym_return_BANG] = ACTIONS(4116),
    [anon_sym_yield] = ACTIONS(4118),
    [anon_sym_yield_BANG] = ACTIONS(4116),
    [anon_sym_lazy] = ACTIONS(4118),
    [anon_sym_assert] = ACTIONS(4118),
    [anon_sym_upcast] = ACTIONS(4118),
    [anon_sym_downcast] = ACTIONS(4118),
    [anon_sym_COLON_GT] = ACTIONS(4116),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4116),
    [anon_sym_for] = ACTIONS(4118),
    [anon_sym_while] = ACTIONS(4118),
    [anon_sym_if] = ACTIONS(4118),
    [anon_sym_fun] = ACTIONS(4118),
    [anon_sym_try] = ACTIONS(4118),
    [anon_sym_match] = ACTIONS(4118),
    [anon_sym_match_BANG] = ACTIONS(4116),
    [anon_sym_function] = ACTIONS(4118),
    [anon_sym_LT_DASH] = ACTIONS(4118),
    [anon_sym_DOT_LBRACK] = ACTIONS(4116),
    [anon_sym_LT] = ACTIONS(4116),
    [anon_sym_use] = ACTIONS(4118),
    [anon_sym_use_BANG] = ACTIONS(4116),
    [anon_sym_do_BANG] = ACTIONS(4116),
    [anon_sym_begin] = ACTIONS(4118),
    [anon_sym_LPAREN2] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [anon_sym_exception] = ACTIONS(4118),
    [aux_sym_char_token1] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4118),
    [anon_sym_DQUOTE] = ACTIONS(4118),
    [anon_sym_AT_DQUOTE] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [sym_bool] = ACTIONS(4118),
    [sym_unit] = ACTIONS(4116),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4118),
    [sym_op_identifier] = ACTIONS(4118),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_PLUS_DOT] = ACTIONS(4118),
    [anon_sym_DASH_DOT] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_AMP_AMP] = ACTIONS(4118),
    [anon_sym_TILDE] = ACTIONS(4116),
    [aux_sym_prefix_op_token1] = ACTIONS(4118),
    [aux_sym_infix_op_token1] = ACTIONS(4116),
    [aux_sym_infix_op_token2] = ACTIONS(4118),
    [anon_sym_PIPE_PIPE] = ACTIONS(4118),
    [anon_sym_BANG_EQ] = ACTIONS(4118),
    [anon_sym_COLON_EQ] = ACTIONS(4116),
    [anon_sym_DOLLAR] = ACTIONS(4118),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4118),
    [sym_int] = ACTIONS(4118),
    [sym_xint] = ACTIONS(4116),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4116),
    [anon_sym_POUNDload] = ACTIONS(4116),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4116),
    [sym__newline] = ACTIONS(4116),
  },
  [2496] = {
    [sym_block_comment] = STATE(2496),
    [sym_compiler_directive_decl] = STATE(2496),
    [sym_fsi_directive_decl] = STATE(2496),
    [sym_preproc_line] = STATE(2496),
    [ts_builtin_sym_end] = ACTIONS(4120),
    [sym_identifier] = ACTIONS(4122),
    [anon_sym_namespace] = ACTIONS(4122),
    [anon_sym_module] = ACTIONS(4122),
    [anon_sym_EQ] = ACTIONS(4120),
    [anon_sym_open] = ACTIONS(4122),
    [anon_sym_LBRACK_LT] = ACTIONS(4120),
    [anon_sym_COLON] = ACTIONS(4122),
    [anon_sym_return] = ACTIONS(4122),
    [anon_sym_type] = ACTIONS(4122),
    [anon_sym_do] = ACTIONS(4122),
    [anon_sym_let] = ACTIONS(4122),
    [anon_sym_let_BANG] = ACTIONS(4120),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_COMMA] = ACTIONS(4120),
    [anon_sym_null] = ACTIONS(4122),
    [anon_sym_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_COLON] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_LT_AT] = ACTIONS(4122),
    [anon_sym_LT_AT_AT] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4122),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4120),
    [anon_sym_new] = ACTIONS(4122),
    [anon_sym_return_BANG] = ACTIONS(4120),
    [anon_sym_yield] = ACTIONS(4122),
    [anon_sym_yield_BANG] = ACTIONS(4120),
    [anon_sym_lazy] = ACTIONS(4122),
    [anon_sym_assert] = ACTIONS(4122),
    [anon_sym_upcast] = ACTIONS(4122),
    [anon_sym_downcast] = ACTIONS(4122),
    [anon_sym_COLON_GT] = ACTIONS(4120),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4120),
    [anon_sym_for] = ACTIONS(4122),
    [anon_sym_while] = ACTIONS(4122),
    [anon_sym_if] = ACTIONS(4122),
    [anon_sym_fun] = ACTIONS(4122),
    [anon_sym_try] = ACTIONS(4122),
    [anon_sym_match] = ACTIONS(4122),
    [anon_sym_match_BANG] = ACTIONS(4120),
    [anon_sym_function] = ACTIONS(4122),
    [anon_sym_LT_DASH] = ACTIONS(4122),
    [anon_sym_DOT_LBRACK] = ACTIONS(4120),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_use] = ACTIONS(4122),
    [anon_sym_use_BANG] = ACTIONS(4120),
    [anon_sym_do_BANG] = ACTIONS(4120),
    [anon_sym_begin] = ACTIONS(4122),
    [anon_sym_LPAREN2] = ACTIONS(4122),
    [anon_sym_or] = ACTIONS(4122),
    [anon_sym_exception] = ACTIONS(4122),
    [aux_sym_char_token1] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4122),
    [anon_sym_DQUOTE] = ACTIONS(4122),
    [anon_sym_AT_DQUOTE] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [sym_bool] = ACTIONS(4122),
    [sym_unit] = ACTIONS(4120),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4122),
    [sym_op_identifier] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4122),
    [anon_sym_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_DOT] = ACTIONS(4122),
    [anon_sym_DASH_DOT] = ACTIONS(4122),
    [anon_sym_PERCENT] = ACTIONS(4122),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_TILDE] = ACTIONS(4120),
    [aux_sym_prefix_op_token1] = ACTIONS(4122),
    [aux_sym_infix_op_token1] = ACTIONS(4120),
    [aux_sym_infix_op_token2] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_COLON_EQ] = ACTIONS(4120),
    [anon_sym_DOLLAR] = ACTIONS(4122),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4122),
    [sym_int] = ACTIONS(4122),
    [sym_xint] = ACTIONS(4120),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4120),
    [anon_sym_POUNDload] = ACTIONS(4120),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4120),
    [sym__newline] = ACTIONS(4120),
  },
  [2497] = {
    [sym_block_comment] = STATE(2497),
    [sym_compiler_directive_decl] = STATE(2497),
    [sym_fsi_directive_decl] = STATE(2497),
    [sym_preproc_line] = STATE(2497),
    [sym_identifier] = ACTIONS(3551),
    [anon_sym_EQ] = ACTIONS(3549),
    [anon_sym_COLON] = ACTIONS(3551),
    [anon_sym_return] = ACTIONS(3551),
    [anon_sym_do] = ACTIONS(3551),
    [anon_sym_let] = ACTIONS(3551),
    [anon_sym_let_BANG] = ACTIONS(3549),
    [anon_sym_as] = ACTIONS(3551),
    [anon_sym_LPAREN] = ACTIONS(3551),
    [anon_sym_COMMA] = ACTIONS(3549),
    [anon_sym_null] = ACTIONS(3551),
    [anon_sym_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_COLON] = ACTIONS(3549),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(3551),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3549),
    [anon_sym_LBRACE] = ACTIONS(3551),
    [anon_sym_LT_AT] = ACTIONS(3551),
    [anon_sym_LT_AT_AT] = ACTIONS(3551),
    [anon_sym_DOT] = ACTIONS(3551),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3549),
    [anon_sym_new] = ACTIONS(3551),
    [anon_sym_with] = ACTIONS(3551),
    [anon_sym_return_BANG] = ACTIONS(3549),
    [anon_sym_yield] = ACTIONS(3551),
    [anon_sym_yield_BANG] = ACTIONS(3549),
    [anon_sym_lazy] = ACTIONS(3551),
    [anon_sym_assert] = ACTIONS(3551),
    [anon_sym_upcast] = ACTIONS(3551),
    [anon_sym_downcast] = ACTIONS(3551),
    [anon_sym_COLON_GT] = ACTIONS(3549),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3549),
    [anon_sym_for] = ACTIONS(3551),
    [anon_sym_while] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(3551),
    [anon_sym_fun] = ACTIONS(3551),
    [anon_sym_DASH_GT] = ACTIONS(3551),
    [anon_sym_try] = ACTIONS(3551),
    [anon_sym_match] = ACTIONS(3551),
    [anon_sym_match_BANG] = ACTIONS(3549),
    [anon_sym_function] = ACTIONS(3551),
    [anon_sym_LT_DASH] = ACTIONS(3551),
    [anon_sym_DOT_LBRACK] = ACTIONS(3549),
    [anon_sym_LT] = ACTIONS(3549),
    [anon_sym_use] = ACTIONS(3551),
    [anon_sym_use_BANG] = ACTIONS(3549),
    [anon_sym_do_BANG] = ACTIONS(3549),
    [anon_sym_begin] = ACTIONS(3551),
    [anon_sym_LPAREN2] = ACTIONS(3551),
    [anon_sym_STAR] = ACTIONS(3551),
    [anon_sym_LT2] = ACTIONS(3551),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3549),
    [anon_sym_or] = ACTIONS(3551),
    [aux_sym_char_token1] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [anon_sym_AT_DQUOTE] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [sym_bool] = ACTIONS(3551),
    [sym_unit] = ACTIONS(3549),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3551),
    [sym_op_identifier] = ACTIONS(3551),
    [anon_sym_PLUS] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(3551),
    [anon_sym_PLUS_DOT] = ACTIONS(3551),
    [anon_sym_DASH_DOT] = ACTIONS(3551),
    [anon_sym_PERCENT] = ACTIONS(3551),
    [anon_sym_AMP_AMP] = ACTIONS(3551),
    [anon_sym_TILDE] = ACTIONS(3549),
    [aux_sym_prefix_op_token1] = ACTIONS(3551),
    [aux_sym_infix_op_token1] = ACTIONS(3549),
    [aux_sym_infix_op_token2] = ACTIONS(3551),
    [anon_sym_PIPE_PIPE] = ACTIONS(3551),
    [anon_sym_BANG_EQ] = ACTIONS(3551),
    [anon_sym_COLON_EQ] = ACTIONS(3549),
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3551),
    [sym_int] = ACTIONS(3551),
    [sym_xint] = ACTIONS(3549),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3549),
    [sym__newline] = ACTIONS(3549),
    [sym__dedent] = ACTIONS(3549),
  },
  [2498] = {
    [sym_block_comment] = STATE(2498),
    [sym_compiler_directive_decl] = STATE(2498),
    [sym_fsi_directive_decl] = STATE(2498),
    [sym_preproc_line] = STATE(2498),
    [ts_builtin_sym_end] = ACTIONS(4124),
    [sym_identifier] = ACTIONS(4126),
    [anon_sym_namespace] = ACTIONS(4126),
    [anon_sym_module] = ACTIONS(4126),
    [anon_sym_EQ] = ACTIONS(4124),
    [anon_sym_open] = ACTIONS(4126),
    [anon_sym_LBRACK_LT] = ACTIONS(4124),
    [anon_sym_COLON] = ACTIONS(4126),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_type] = ACTIONS(4126),
    [anon_sym_do] = ACTIONS(4126),
    [anon_sym_let] = ACTIONS(4126),
    [anon_sym_let_BANG] = ACTIONS(4124),
    [anon_sym_LPAREN] = ACTIONS(4126),
    [anon_sym_COMMA] = ACTIONS(4124),
    [anon_sym_null] = ACTIONS(4126),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_COLON] = ACTIONS(4124),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LBRACK] = ACTIONS(4126),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4126),
    [anon_sym_LT_AT] = ACTIONS(4126),
    [anon_sym_LT_AT_AT] = ACTIONS(4126),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4124),
    [anon_sym_new] = ACTIONS(4126),
    [anon_sym_return_BANG] = ACTIONS(4124),
    [anon_sym_yield] = ACTIONS(4126),
    [anon_sym_yield_BANG] = ACTIONS(4124),
    [anon_sym_lazy] = ACTIONS(4126),
    [anon_sym_assert] = ACTIONS(4126),
    [anon_sym_upcast] = ACTIONS(4126),
    [anon_sym_downcast] = ACTIONS(4126),
    [anon_sym_COLON_GT] = ACTIONS(4124),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4124),
    [anon_sym_for] = ACTIONS(4126),
    [anon_sym_while] = ACTIONS(4126),
    [anon_sym_if] = ACTIONS(4126),
    [anon_sym_fun] = ACTIONS(4126),
    [anon_sym_try] = ACTIONS(4126),
    [anon_sym_match] = ACTIONS(4126),
    [anon_sym_match_BANG] = ACTIONS(4124),
    [anon_sym_function] = ACTIONS(4126),
    [anon_sym_LT_DASH] = ACTIONS(4126),
    [anon_sym_DOT_LBRACK] = ACTIONS(4124),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_use] = ACTIONS(4126),
    [anon_sym_use_BANG] = ACTIONS(4124),
    [anon_sym_do_BANG] = ACTIONS(4124),
    [anon_sym_begin] = ACTIONS(4126),
    [anon_sym_LPAREN2] = ACTIONS(4126),
    [anon_sym_or] = ACTIONS(4126),
    [anon_sym_exception] = ACTIONS(4126),
    [aux_sym_char_token1] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4126),
    [anon_sym_DQUOTE] = ACTIONS(4126),
    [anon_sym_AT_DQUOTE] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [sym_bool] = ACTIONS(4126),
    [sym_unit] = ACTIONS(4124),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4126),
    [sym_op_identifier] = ACTIONS(4126),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_PLUS_DOT] = ACTIONS(4126),
    [anon_sym_DASH_DOT] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_AMP_AMP] = ACTIONS(4126),
    [anon_sym_TILDE] = ACTIONS(4124),
    [aux_sym_prefix_op_token1] = ACTIONS(4126),
    [aux_sym_infix_op_token1] = ACTIONS(4124),
    [aux_sym_infix_op_token2] = ACTIONS(4126),
    [anon_sym_PIPE_PIPE] = ACTIONS(4126),
    [anon_sym_BANG_EQ] = ACTIONS(4126),
    [anon_sym_COLON_EQ] = ACTIONS(4124),
    [anon_sym_DOLLAR] = ACTIONS(4126),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4126),
    [sym_int] = ACTIONS(4126),
    [sym_xint] = ACTIONS(4124),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4124),
    [anon_sym_POUNDload] = ACTIONS(4124),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4124),
    [sym__newline] = ACTIONS(4124),
  },
  [2499] = {
    [sym_block_comment] = STATE(2499),
    [sym_compiler_directive_decl] = STATE(2499),
    [sym_fsi_directive_decl] = STATE(2499),
    [sym_preproc_line] = STATE(2499),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [anon_sym_as] = ACTIONS(3515),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_COLON] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_with] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(3513),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_LT_DASH] = ACTIONS(3515),
    [anon_sym_DOT_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_or] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3515),
    [anon_sym_DASH_DOT] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3515),
    [aux_sym_infix_op_token1] = ACTIONS(3513),
    [aux_sym_infix_op_token2] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3515),
    [anon_sym_COLON_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(3515),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3515),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
    [sym__dedent] = ACTIONS(3513),
  },
  [2500] = {
    [sym_type_arguments] = STATE(2244),
    [sym_long_identifier] = STATE(2231),
    [sym_block_comment] = STATE(2500),
    [sym_compiler_directive_decl] = STATE(2500),
    [sym_fsi_directive_decl] = STATE(2500),
    [sym_preproc_line] = STATE(2500),
    [aux_sym_compound_type_repeat1] = STATE(2219),
    [sym_identifier] = ACTIONS(3443),
    [anon_sym_EQ] = ACTIONS(3441),
    [anon_sym_COLON] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_let] = ACTIONS(3443),
    [anon_sym_let_BANG] = ACTIONS(3441),
    [anon_sym_LPAREN] = ACTIONS(3443),
    [anon_sym_COMMA] = ACTIONS(3441),
    [anon_sym_null] = ACTIONS(3443),
    [anon_sym_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_QMARK] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_LT_AT] = ACTIONS(3443),
    [anon_sym_LT_AT_AT] = ACTIONS(3443),
    [anon_sym_DOT] = ACTIONS(3443),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_return_BANG] = ACTIONS(3441),
    [anon_sym_yield] = ACTIONS(3443),
    [anon_sym_yield_BANG] = ACTIONS(3441),
    [anon_sym_lazy] = ACTIONS(3443),
    [anon_sym_assert] = ACTIONS(3443),
    [anon_sym_upcast] = ACTIONS(3443),
    [anon_sym_downcast] = ACTIONS(3443),
    [anon_sym_COLON_GT] = ACTIONS(3441),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3441),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_fun] = ACTIONS(3443),
    [anon_sym_DASH_GT] = ACTIONS(3443),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_match] = ACTIONS(3443),
    [anon_sym_match_BANG] = ACTIONS(3441),
    [anon_sym_function] = ACTIONS(3443),
    [anon_sym_LT_DASH] = ACTIONS(3443),
    [anon_sym_DOT_LBRACK] = ACTIONS(3441),
    [anon_sym_LT] = ACTIONS(3441),
    [anon_sym_use] = ACTIONS(3443),
    [anon_sym_use_BANG] = ACTIONS(3441),
    [anon_sym_do_BANG] = ACTIONS(3441),
    [anon_sym_begin] = ACTIONS(3443),
    [anon_sym_LPAREN2] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(4557),
    [anon_sym_LT2] = ACTIONS(4559),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4561),
    [anon_sym_or] = ACTIONS(3443),
    [aux_sym_char_token1] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3443),
    [anon_sym_AT_DQUOTE] = ACTIONS(3441),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3441),
    [sym_bool] = ACTIONS(3443),
    [sym_unit] = ACTIONS(3441),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3443),
    [sym_op_identifier] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_PLUS_DOT] = ACTIONS(3443),
    [anon_sym_DASH_DOT] = ACTIONS(3443),
    [anon_sym_PERCENT] = ACTIONS(3443),
    [anon_sym_AMP_AMP] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3441),
    [aux_sym_prefix_op_token1] = ACTIONS(3443),
    [aux_sym_infix_op_token1] = ACTIONS(3441),
    [aux_sym_infix_op_token2] = ACTIONS(3443),
    [anon_sym_PIPE_PIPE] = ACTIONS(3443),
    [anon_sym_BANG_EQ] = ACTIONS(3443),
    [anon_sym_COLON_EQ] = ACTIONS(3441),
    [anon_sym_DOLLAR] = ACTIONS(3443),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3443),
    [sym_int] = ACTIONS(3443),
    [sym_xint] = ACTIONS(3441),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3441),
    [sym__newline] = ACTIONS(3441),
  },
  [2501] = {
    [sym_block_comment] = STATE(2501),
    [sym_compiler_directive_decl] = STATE(2501),
    [sym_fsi_directive_decl] = STATE(2501),
    [sym_preproc_line] = STATE(2501),
    [ts_builtin_sym_end] = ACTIONS(4230),
    [sym_identifier] = ACTIONS(4232),
    [anon_sym_namespace] = ACTIONS(4232),
    [anon_sym_module] = ACTIONS(4232),
    [anon_sym_EQ] = ACTIONS(4230),
    [anon_sym_open] = ACTIONS(4232),
    [anon_sym_LBRACK_LT] = ACTIONS(4230),
    [anon_sym_COLON] = ACTIONS(4232),
    [anon_sym_return] = ACTIONS(4232),
    [anon_sym_type] = ACTIONS(4232),
    [anon_sym_do] = ACTIONS(4232),
    [anon_sym_let] = ACTIONS(4232),
    [anon_sym_let_BANG] = ACTIONS(4230),
    [anon_sym_LPAREN] = ACTIONS(4232),
    [anon_sym_COMMA] = ACTIONS(4230),
    [anon_sym_null] = ACTIONS(4232),
    [anon_sym_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_COLON] = ACTIONS(4230),
    [anon_sym_AMP] = ACTIONS(4232),
    [anon_sym_LBRACK] = ACTIONS(4232),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4230),
    [anon_sym_LBRACE] = ACTIONS(4232),
    [anon_sym_LT_AT] = ACTIONS(4232),
    [anon_sym_LT_AT_AT] = ACTIONS(4232),
    [anon_sym_DOT] = ACTIONS(4232),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4230),
    [anon_sym_new] = ACTIONS(4232),
    [anon_sym_return_BANG] = ACTIONS(4230),
    [anon_sym_yield] = ACTIONS(4232),
    [anon_sym_yield_BANG] = ACTIONS(4230),
    [anon_sym_lazy] = ACTIONS(4232),
    [anon_sym_assert] = ACTIONS(4232),
    [anon_sym_upcast] = ACTIONS(4232),
    [anon_sym_downcast] = ACTIONS(4232),
    [anon_sym_COLON_GT] = ACTIONS(4230),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4230),
    [anon_sym_for] = ACTIONS(4232),
    [anon_sym_while] = ACTIONS(4232),
    [anon_sym_if] = ACTIONS(4232),
    [anon_sym_fun] = ACTIONS(4232),
    [anon_sym_try] = ACTIONS(4232),
    [anon_sym_match] = ACTIONS(4232),
    [anon_sym_match_BANG] = ACTIONS(4230),
    [anon_sym_function] = ACTIONS(4232),
    [anon_sym_LT_DASH] = ACTIONS(4232),
    [anon_sym_DOT_LBRACK] = ACTIONS(4230),
    [anon_sym_LT] = ACTIONS(4230),
    [anon_sym_use] = ACTIONS(4232),
    [anon_sym_use_BANG] = ACTIONS(4230),
    [anon_sym_do_BANG] = ACTIONS(4230),
    [anon_sym_begin] = ACTIONS(4232),
    [anon_sym_LPAREN2] = ACTIONS(4232),
    [anon_sym_or] = ACTIONS(4232),
    [anon_sym_exception] = ACTIONS(4232),
    [aux_sym_char_token1] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4232),
    [anon_sym_DQUOTE] = ACTIONS(4232),
    [anon_sym_AT_DQUOTE] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [sym_bool] = ACTIONS(4232),
    [sym_unit] = ACTIONS(4230),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4232),
    [sym_op_identifier] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4232),
    [anon_sym_DASH] = ACTIONS(4232),
    [anon_sym_PLUS_DOT] = ACTIONS(4232),
    [anon_sym_DASH_DOT] = ACTIONS(4232),
    [anon_sym_PERCENT] = ACTIONS(4232),
    [anon_sym_AMP_AMP] = ACTIONS(4232),
    [anon_sym_TILDE] = ACTIONS(4230),
    [aux_sym_prefix_op_token1] = ACTIONS(4232),
    [aux_sym_infix_op_token1] = ACTIONS(4230),
    [aux_sym_infix_op_token2] = ACTIONS(4232),
    [anon_sym_PIPE_PIPE] = ACTIONS(4232),
    [anon_sym_BANG_EQ] = ACTIONS(4232),
    [anon_sym_COLON_EQ] = ACTIONS(4230),
    [anon_sym_DOLLAR] = ACTIONS(4232),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4232),
    [sym_int] = ACTIONS(4232),
    [sym_xint] = ACTIONS(4230),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4230),
    [anon_sym_POUNDload] = ACTIONS(4230),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4230),
    [sym__newline] = ACTIONS(4230),
  },
  [2502] = {
    [sym_block_comment] = STATE(2502),
    [sym_compiler_directive_decl] = STATE(2502),
    [sym_fsi_directive_decl] = STATE(2502),
    [sym_preproc_line] = STATE(2502),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_GT_RBRACK] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4226),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_RBRACE] = ACTIONS(4226),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_with] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_to] = ACTIONS(4228),
    [anon_sym_downto] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_DOT_DOT2] = ACTIONS(4226),
    [anon_sym_or] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
  },
  [2503] = {
    [sym_block_comment] = STATE(2503),
    [sym_compiler_directive_decl] = STATE(2503),
    [sym_fsi_directive_decl] = STATE(2503),
    [sym_preproc_line] = STATE(2503),
    [sym_identifier] = ACTIONS(3505),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_COLON] = ACTIONS(3505),
    [anon_sym_return] = ACTIONS(3505),
    [anon_sym_do] = ACTIONS(3505),
    [anon_sym_let] = ACTIONS(3505),
    [anon_sym_let_BANG] = ACTIONS(3503),
    [anon_sym_as] = ACTIONS(3505),
    [anon_sym_LPAREN] = ACTIONS(3505),
    [anon_sym_COMMA] = ACTIONS(3503),
    [anon_sym_null] = ACTIONS(3505),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_COLON_QMARK] = ACTIONS(3505),
    [anon_sym_COLON_COLON] = ACTIONS(3503),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3503),
    [anon_sym_LBRACE] = ACTIONS(3505),
    [anon_sym_LT_AT] = ACTIONS(3505),
    [anon_sym_LT_AT_AT] = ACTIONS(3505),
    [anon_sym_DOT] = ACTIONS(3505),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3503),
    [anon_sym_new] = ACTIONS(3505),
    [anon_sym_with] = ACTIONS(3505),
    [anon_sym_return_BANG] = ACTIONS(3503),
    [anon_sym_yield] = ACTIONS(3505),
    [anon_sym_yield_BANG] = ACTIONS(3503),
    [anon_sym_lazy] = ACTIONS(3505),
    [anon_sym_assert] = ACTIONS(3505),
    [anon_sym_upcast] = ACTIONS(3505),
    [anon_sym_downcast] = ACTIONS(3505),
    [anon_sym_COLON_GT] = ACTIONS(3503),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3503),
    [anon_sym_for] = ACTIONS(3505),
    [anon_sym_while] = ACTIONS(3505),
    [anon_sym_if] = ACTIONS(3505),
    [anon_sym_fun] = ACTIONS(3505),
    [anon_sym_DASH_GT] = ACTIONS(3505),
    [anon_sym_try] = ACTIONS(3505),
    [anon_sym_match] = ACTIONS(3505),
    [anon_sym_match_BANG] = ACTIONS(3503),
    [anon_sym_function] = ACTIONS(3505),
    [anon_sym_LT_DASH] = ACTIONS(3505),
    [anon_sym_DOT_LBRACK] = ACTIONS(3503),
    [anon_sym_LT] = ACTIONS(3503),
    [anon_sym_use] = ACTIONS(3505),
    [anon_sym_use_BANG] = ACTIONS(3503),
    [anon_sym_do_BANG] = ACTIONS(3503),
    [anon_sym_begin] = ACTIONS(3505),
    [anon_sym_LPAREN2] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3505),
    [anon_sym_LT2] = ACTIONS(4981),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_or] = ACTIONS(3505),
    [aux_sym_char_token1] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3505),
    [anon_sym_DQUOTE] = ACTIONS(3505),
    [anon_sym_AT_DQUOTE] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [sym_bool] = ACTIONS(3505),
    [sym_unit] = ACTIONS(3503),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3505),
    [sym_op_identifier] = ACTIONS(3505),
    [anon_sym_PLUS] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3505),
    [anon_sym_PLUS_DOT] = ACTIONS(3505),
    [anon_sym_DASH_DOT] = ACTIONS(3505),
    [anon_sym_PERCENT] = ACTIONS(3505),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3503),
    [aux_sym_prefix_op_token1] = ACTIONS(3505),
    [aux_sym_infix_op_token1] = ACTIONS(3503),
    [aux_sym_infix_op_token2] = ACTIONS(3505),
    [anon_sym_PIPE_PIPE] = ACTIONS(3505),
    [anon_sym_BANG_EQ] = ACTIONS(3505),
    [anon_sym_COLON_EQ] = ACTIONS(3503),
    [anon_sym_DOLLAR] = ACTIONS(3505),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3505),
    [sym_int] = ACTIONS(3505),
    [sym_xint] = ACTIONS(3503),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3503),
    [sym__newline] = ACTIONS(3503),
    [sym__dedent] = ACTIONS(3503),
  },
  [2504] = {
    [sym_block_comment] = STATE(2504),
    [sym_compiler_directive_decl] = STATE(2504),
    [sym_fsi_directive_decl] = STATE(2504),
    [sym_preproc_line] = STATE(2504),
    [sym_identifier] = ACTIONS(3946),
    [anon_sym_EQ] = ACTIONS(3944),
    [anon_sym_GT_RBRACK] = ACTIONS(3944),
    [anon_sym_COLON] = ACTIONS(3946),
    [anon_sym_return] = ACTIONS(3946),
    [anon_sym_do] = ACTIONS(3946),
    [anon_sym_let] = ACTIONS(3946),
    [anon_sym_let_BANG] = ACTIONS(3944),
    [anon_sym_LPAREN] = ACTIONS(3946),
    [anon_sym_COMMA] = ACTIONS(3944),
    [anon_sym_null] = ACTIONS(3946),
    [anon_sym_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LBRACK] = ACTIONS(3946),
    [anon_sym_RBRACK] = ACTIONS(3944),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3944),
    [anon_sym_LBRACE] = ACTIONS(3946),
    [anon_sym_RBRACE] = ACTIONS(3944),
    [anon_sym_LT_AT] = ACTIONS(3946),
    [anon_sym_LT_AT_AT] = ACTIONS(3946),
    [anon_sym_DOT] = ACTIONS(3946),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3944),
    [anon_sym_new] = ACTIONS(3946),
    [anon_sym_with] = ACTIONS(3946),
    [anon_sym_return_BANG] = ACTIONS(3944),
    [anon_sym_yield] = ACTIONS(3946),
    [anon_sym_yield_BANG] = ACTIONS(3944),
    [anon_sym_lazy] = ACTIONS(3946),
    [anon_sym_assert] = ACTIONS(3946),
    [anon_sym_upcast] = ACTIONS(3946),
    [anon_sym_downcast] = ACTIONS(3946),
    [anon_sym_COLON_GT] = ACTIONS(3944),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3944),
    [anon_sym_for] = ACTIONS(3946),
    [anon_sym_to] = ACTIONS(3946),
    [anon_sym_downto] = ACTIONS(3946),
    [anon_sym_while] = ACTIONS(3946),
    [anon_sym_if] = ACTIONS(3946),
    [anon_sym_fun] = ACTIONS(3946),
    [anon_sym_try] = ACTIONS(3946),
    [anon_sym_match] = ACTIONS(3946),
    [anon_sym_match_BANG] = ACTIONS(3944),
    [anon_sym_function] = ACTIONS(3946),
    [anon_sym_LT_DASH] = ACTIONS(3946),
    [anon_sym_DOT_LBRACK] = ACTIONS(3944),
    [anon_sym_LT] = ACTIONS(3944),
    [anon_sym_use] = ACTIONS(3946),
    [anon_sym_use_BANG] = ACTIONS(3944),
    [anon_sym_do_BANG] = ACTIONS(3944),
    [anon_sym_begin] = ACTIONS(3946),
    [anon_sym_LPAREN2] = ACTIONS(3946),
    [anon_sym_DOT_DOT2] = ACTIONS(3944),
    [anon_sym_or] = ACTIONS(3946),
    [aux_sym_char_token1] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_AT_DQUOTE] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [sym_bool] = ACTIONS(3946),
    [sym_unit] = ACTIONS(3944),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3946),
    [sym_op_identifier] = ACTIONS(3946),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PLUS_DOT] = ACTIONS(3946),
    [anon_sym_DASH_DOT] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3946),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_TILDE] = ACTIONS(3944),
    [aux_sym_prefix_op_token1] = ACTIONS(3946),
    [aux_sym_infix_op_token1] = ACTIONS(3944),
    [aux_sym_infix_op_token2] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [anon_sym_BANG_EQ] = ACTIONS(3946),
    [anon_sym_COLON_EQ] = ACTIONS(3944),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3946),
    [sym_int] = ACTIONS(3946),
    [sym_xint] = ACTIONS(3944),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3944),
    [sym__newline] = ACTIONS(3944),
  },
  [2505] = {
    [sym_block_comment] = STATE(2505),
    [sym_compiler_directive_decl] = STATE(2505),
    [sym_fsi_directive_decl] = STATE(2505),
    [sym_preproc_line] = STATE(2505),
    [sym_identifier] = ACTIONS(3927),
    [anon_sym_EQ] = ACTIONS(3925),
    [anon_sym_GT_RBRACK] = ACTIONS(3925),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_return] = ACTIONS(3927),
    [anon_sym_do] = ACTIONS(3927),
    [anon_sym_let] = ACTIONS(3927),
    [anon_sym_let_BANG] = ACTIONS(3925),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_COMMA] = ACTIONS(3925),
    [anon_sym_null] = ACTIONS(3927),
    [anon_sym_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_COLON] = ACTIONS(3925),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_RBRACK] = ACTIONS(3925),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3925),
    [anon_sym_LBRACE] = ACTIONS(3927),
    [anon_sym_RBRACE] = ACTIONS(3925),
    [anon_sym_LT_AT] = ACTIONS(3927),
    [anon_sym_LT_AT_AT] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3925),
    [anon_sym_new] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3927),
    [anon_sym_return_BANG] = ACTIONS(3925),
    [anon_sym_yield] = ACTIONS(3927),
    [anon_sym_yield_BANG] = ACTIONS(3925),
    [anon_sym_lazy] = ACTIONS(3927),
    [anon_sym_assert] = ACTIONS(3927),
    [anon_sym_upcast] = ACTIONS(3927),
    [anon_sym_downcast] = ACTIONS(3927),
    [anon_sym_COLON_GT] = ACTIONS(3925),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3925),
    [anon_sym_for] = ACTIONS(3927),
    [anon_sym_to] = ACTIONS(3927),
    [anon_sym_downto] = ACTIONS(3927),
    [anon_sym_while] = ACTIONS(3927),
    [anon_sym_if] = ACTIONS(3927),
    [anon_sym_fun] = ACTIONS(3927),
    [anon_sym_try] = ACTIONS(3927),
    [anon_sym_match] = ACTIONS(3927),
    [anon_sym_match_BANG] = ACTIONS(3925),
    [anon_sym_function] = ACTIONS(3927),
    [anon_sym_LT_DASH] = ACTIONS(3927),
    [anon_sym_DOT_LBRACK] = ACTIONS(3925),
    [anon_sym_LT] = ACTIONS(3925),
    [anon_sym_use] = ACTIONS(3927),
    [anon_sym_use_BANG] = ACTIONS(3925),
    [anon_sym_do_BANG] = ACTIONS(3925),
    [anon_sym_begin] = ACTIONS(3927),
    [anon_sym_LPAREN2] = ACTIONS(3927),
    [anon_sym_DOT_DOT2] = ACTIONS(3925),
    [anon_sym_or] = ACTIONS(3927),
    [aux_sym_char_token1] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_AT_DQUOTE] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [sym_bool] = ACTIONS(3927),
    [sym_unit] = ACTIONS(3925),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3927),
    [sym_op_identifier] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3927),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_PLUS_DOT] = ACTIONS(3927),
    [anon_sym_DASH_DOT] = ACTIONS(3927),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_TILDE] = ACTIONS(3925),
    [aux_sym_prefix_op_token1] = ACTIONS(3927),
    [aux_sym_infix_op_token1] = ACTIONS(3925),
    [aux_sym_infix_op_token2] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_COLON_EQ] = ACTIONS(3925),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3927),
    [sym_int] = ACTIONS(3927),
    [sym_xint] = ACTIONS(3925),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3925),
    [sym__newline] = ACTIONS(3925),
  },
  [2506] = {
    [sym_block_comment] = STATE(2506),
    [sym_compiler_directive_decl] = STATE(2506),
    [sym_fsi_directive_decl] = STATE(2506),
    [sym_preproc_line] = STATE(2506),
    [ts_builtin_sym_end] = ACTIONS(3873),
    [sym_identifier] = ACTIONS(3875),
    [anon_sym_namespace] = ACTIONS(3875),
    [anon_sym_module] = ACTIONS(3875),
    [anon_sym_EQ] = ACTIONS(3873),
    [anon_sym_open] = ACTIONS(3875),
    [anon_sym_LBRACK_LT] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(3875),
    [anon_sym_return] = ACTIONS(3875),
    [anon_sym_type] = ACTIONS(3875),
    [anon_sym_do] = ACTIONS(3875),
    [anon_sym_let] = ACTIONS(3875),
    [anon_sym_let_BANG] = ACTIONS(3873),
    [anon_sym_LPAREN] = ACTIONS(3875),
    [anon_sym_COMMA] = ACTIONS(3873),
    [anon_sym_null] = ACTIONS(3875),
    [anon_sym_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_COLON] = ACTIONS(3873),
    [anon_sym_AMP] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(3875),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3873),
    [anon_sym_LBRACE] = ACTIONS(3875),
    [anon_sym_LT_AT] = ACTIONS(3875),
    [anon_sym_LT_AT_AT] = ACTIONS(3875),
    [anon_sym_DOT] = ACTIONS(3875),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3873),
    [anon_sym_new] = ACTIONS(3875),
    [anon_sym_return_BANG] = ACTIONS(3873),
    [anon_sym_yield] = ACTIONS(3875),
    [anon_sym_yield_BANG] = ACTIONS(3873),
    [anon_sym_lazy] = ACTIONS(3875),
    [anon_sym_assert] = ACTIONS(3875),
    [anon_sym_upcast] = ACTIONS(3875),
    [anon_sym_downcast] = ACTIONS(3875),
    [anon_sym_COLON_GT] = ACTIONS(3873),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3873),
    [anon_sym_for] = ACTIONS(3875),
    [anon_sym_while] = ACTIONS(3875),
    [anon_sym_if] = ACTIONS(3875),
    [anon_sym_fun] = ACTIONS(3875),
    [anon_sym_try] = ACTIONS(3875),
    [anon_sym_match] = ACTIONS(3875),
    [anon_sym_match_BANG] = ACTIONS(3873),
    [anon_sym_function] = ACTIONS(3875),
    [anon_sym_LT_DASH] = ACTIONS(3875),
    [anon_sym_DOT_LBRACK] = ACTIONS(3873),
    [anon_sym_LT] = ACTIONS(3873),
    [anon_sym_use] = ACTIONS(3875),
    [anon_sym_use_BANG] = ACTIONS(3873),
    [anon_sym_do_BANG] = ACTIONS(3873),
    [anon_sym_begin] = ACTIONS(3875),
    [anon_sym_LPAREN2] = ACTIONS(3875),
    [anon_sym_or] = ACTIONS(3875),
    [anon_sym_exception] = ACTIONS(3875),
    [aux_sym_char_token1] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3875),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [anon_sym_AT_DQUOTE] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [sym_bool] = ACTIONS(3875),
    [sym_unit] = ACTIONS(3873),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3875),
    [sym_op_identifier] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS_DOT] = ACTIONS(3875),
    [anon_sym_DASH_DOT] = ACTIONS(3875),
    [anon_sym_PERCENT] = ACTIONS(3875),
    [anon_sym_AMP_AMP] = ACTIONS(3875),
    [anon_sym_TILDE] = ACTIONS(3873),
    [aux_sym_prefix_op_token1] = ACTIONS(3875),
    [aux_sym_infix_op_token1] = ACTIONS(3873),
    [aux_sym_infix_op_token2] = ACTIONS(3875),
    [anon_sym_PIPE_PIPE] = ACTIONS(3875),
    [anon_sym_BANG_EQ] = ACTIONS(3875),
    [anon_sym_COLON_EQ] = ACTIONS(3873),
    [anon_sym_DOLLAR] = ACTIONS(3875),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3875),
    [sym_int] = ACTIONS(3875),
    [sym_xint] = ACTIONS(3873),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3873),
    [anon_sym_POUNDload] = ACTIONS(3873),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3873),
    [sym__newline] = ACTIONS(3873),
  },
  [2507] = {
    [sym__else_expression] = STATE(3089),
    [sym_elif_expression] = STATE(2749),
    [sym_block_comment] = STATE(2507),
    [sym_compiler_directive_decl] = STATE(2507),
    [sym_fsi_directive_decl] = STATE(2507),
    [sym_preproc_line] = STATE(2507),
    [aux_sym_if_expression_repeat1] = STATE(2540),
    [sym_identifier] = ACTIONS(3472),
    [anon_sym_EQ] = ACTIONS(3470),
    [anon_sym_COLON] = ACTIONS(3472),
    [anon_sym_return] = ACTIONS(3472),
    [anon_sym_do] = ACTIONS(3472),
    [anon_sym_let] = ACTIONS(3472),
    [anon_sym_let_BANG] = ACTIONS(3470),
    [anon_sym_LPAREN] = ACTIONS(3472),
    [anon_sym_COMMA] = ACTIONS(3470),
    [anon_sym_null] = ACTIONS(3472),
    [anon_sym_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_COLON] = ACTIONS(3470),
    [anon_sym_AMP] = ACTIONS(3472),
    [anon_sym_LBRACK] = ACTIONS(3472),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3470),
    [anon_sym_LBRACE] = ACTIONS(3472),
    [anon_sym_LT_AT] = ACTIONS(3472),
    [anon_sym_LT_AT_AT] = ACTIONS(3472),
    [anon_sym_DOT] = ACTIONS(3472),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3470),
    [anon_sym_new] = ACTIONS(3472),
    [anon_sym_return_BANG] = ACTIONS(3470),
    [anon_sym_yield] = ACTIONS(3472),
    [anon_sym_yield_BANG] = ACTIONS(3470),
    [anon_sym_lazy] = ACTIONS(3472),
    [anon_sym_assert] = ACTIONS(3472),
    [anon_sym_upcast] = ACTIONS(3472),
    [anon_sym_downcast] = ACTIONS(3472),
    [anon_sym_COLON_GT] = ACTIONS(3470),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3470),
    [anon_sym_for] = ACTIONS(3472),
    [anon_sym_while] = ACTIONS(3472),
    [anon_sym_else] = ACTIONS(4983),
    [anon_sym_elif] = ACTIONS(4985),
    [anon_sym_if] = ACTIONS(3472),
    [anon_sym_fun] = ACTIONS(3472),
    [anon_sym_DASH_GT] = ACTIONS(3472),
    [anon_sym_try] = ACTIONS(3472),
    [anon_sym_match] = ACTIONS(3472),
    [anon_sym_match_BANG] = ACTIONS(3470),
    [anon_sym_function] = ACTIONS(3472),
    [anon_sym_LT_DASH] = ACTIONS(3472),
    [anon_sym_DOT_LBRACK] = ACTIONS(3470),
    [anon_sym_LT] = ACTIONS(3470),
    [anon_sym_use] = ACTIONS(3472),
    [anon_sym_use_BANG] = ACTIONS(3470),
    [anon_sym_do_BANG] = ACTIONS(3470),
    [anon_sym_DOT_DOT] = ACTIONS(3470),
    [anon_sym_begin] = ACTIONS(3472),
    [anon_sym_LPAREN2] = ACTIONS(3472),
    [anon_sym_or] = ACTIONS(3472),
    [aux_sym_char_token1] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3472),
    [anon_sym_DQUOTE] = ACTIONS(3472),
    [anon_sym_AT_DQUOTE] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [sym_bool] = ACTIONS(3472),
    [sym_unit] = ACTIONS(3470),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3472),
    [sym_op_identifier] = ACTIONS(3472),
    [anon_sym_PLUS] = ACTIONS(3472),
    [anon_sym_DASH] = ACTIONS(3472),
    [anon_sym_PLUS_DOT] = ACTIONS(3472),
    [anon_sym_DASH_DOT] = ACTIONS(3472),
    [anon_sym_PERCENT] = ACTIONS(3472),
    [anon_sym_AMP_AMP] = ACTIONS(3472),
    [anon_sym_TILDE] = ACTIONS(3470),
    [aux_sym_prefix_op_token1] = ACTIONS(3472),
    [aux_sym_infix_op_token1] = ACTIONS(3470),
    [aux_sym_infix_op_token2] = ACTIONS(3472),
    [anon_sym_PIPE_PIPE] = ACTIONS(3472),
    [anon_sym_BANG_EQ] = ACTIONS(3472),
    [anon_sym_COLON_EQ] = ACTIONS(3470),
    [anon_sym_DOLLAR] = ACTIONS(3472),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3472),
    [sym_int] = ACTIONS(3472),
    [sym_xint] = ACTIONS(3470),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3470),
    [sym__newline] = ACTIONS(3470),
  },
  [2508] = {
    [sym_block_comment] = STATE(2508),
    [sym_compiler_directive_decl] = STATE(2508),
    [sym_fsi_directive_decl] = STATE(2508),
    [sym_preproc_line] = STATE(2508),
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_EQ] = ACTIONS(4149),
    [anon_sym_GT_RBRACK] = ACTIONS(4149),
    [anon_sym_COLON] = ACTIONS(4151),
    [anon_sym_return] = ACTIONS(4151),
    [anon_sym_do] = ACTIONS(4151),
    [anon_sym_let] = ACTIONS(4151),
    [anon_sym_let_BANG] = ACTIONS(4149),
    [anon_sym_LPAREN] = ACTIONS(4151),
    [anon_sym_COMMA] = ACTIONS(4149),
    [anon_sym_null] = ACTIONS(4151),
    [anon_sym_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_AMP] = ACTIONS(4151),
    [anon_sym_LBRACK] = ACTIONS(4151),
    [anon_sym_RBRACK] = ACTIONS(4149),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4149),
    [anon_sym_LBRACE] = ACTIONS(4151),
    [anon_sym_RBRACE] = ACTIONS(4149),
    [anon_sym_LT_AT] = ACTIONS(4151),
    [anon_sym_LT_AT_AT] = ACTIONS(4151),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4149),
    [anon_sym_new] = ACTIONS(4151),
    [anon_sym_with] = ACTIONS(4151),
    [anon_sym_return_BANG] = ACTIONS(4149),
    [anon_sym_yield] = ACTIONS(4151),
    [anon_sym_yield_BANG] = ACTIONS(4149),
    [anon_sym_lazy] = ACTIONS(4151),
    [anon_sym_assert] = ACTIONS(4151),
    [anon_sym_upcast] = ACTIONS(4151),
    [anon_sym_downcast] = ACTIONS(4151),
    [anon_sym_COLON_GT] = ACTIONS(4149),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4149),
    [anon_sym_for] = ACTIONS(4151),
    [anon_sym_to] = ACTIONS(4151),
    [anon_sym_downto] = ACTIONS(4151),
    [anon_sym_while] = ACTIONS(4151),
    [anon_sym_if] = ACTIONS(4151),
    [anon_sym_fun] = ACTIONS(4151),
    [anon_sym_try] = ACTIONS(4151),
    [anon_sym_match] = ACTIONS(4151),
    [anon_sym_match_BANG] = ACTIONS(4149),
    [anon_sym_function] = ACTIONS(4151),
    [anon_sym_LT_DASH] = ACTIONS(4151),
    [anon_sym_DOT_LBRACK] = ACTIONS(4149),
    [anon_sym_LT] = ACTIONS(4149),
    [anon_sym_use] = ACTIONS(4151),
    [anon_sym_use_BANG] = ACTIONS(4149),
    [anon_sym_do_BANG] = ACTIONS(4149),
    [anon_sym_begin] = ACTIONS(4151),
    [anon_sym_LPAREN2] = ACTIONS(4151),
    [anon_sym_DOT_DOT2] = ACTIONS(4149),
    [anon_sym_or] = ACTIONS(4151),
    [aux_sym_char_token1] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4151),
    [anon_sym_DQUOTE] = ACTIONS(4151),
    [anon_sym_AT_DQUOTE] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [sym_bool] = ACTIONS(4151),
    [sym_unit] = ACTIONS(4149),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4151),
    [sym_op_identifier] = ACTIONS(4151),
    [anon_sym_PLUS] = ACTIONS(4151),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_PLUS_DOT] = ACTIONS(4151),
    [anon_sym_DASH_DOT] = ACTIONS(4151),
    [anon_sym_PERCENT] = ACTIONS(4151),
    [anon_sym_AMP_AMP] = ACTIONS(4151),
    [anon_sym_TILDE] = ACTIONS(4149),
    [aux_sym_prefix_op_token1] = ACTIONS(4151),
    [aux_sym_infix_op_token1] = ACTIONS(4149),
    [aux_sym_infix_op_token2] = ACTIONS(4151),
    [anon_sym_PIPE_PIPE] = ACTIONS(4151),
    [anon_sym_BANG_EQ] = ACTIONS(4151),
    [anon_sym_COLON_EQ] = ACTIONS(4149),
    [anon_sym_DOLLAR] = ACTIONS(4151),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4151),
    [sym_int] = ACTIONS(4151),
    [sym_xint] = ACTIONS(4149),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4149),
    [sym__newline] = ACTIONS(4149),
  },
  [2509] = {
    [sym_block_comment] = STATE(2509),
    [sym_compiler_directive_decl] = STATE(2509),
    [sym_fsi_directive_decl] = STATE(2509),
    [sym_preproc_line] = STATE(2509),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_GT_RBRACK] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_RBRACK] = ACTIONS(3191),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_RBRACE] = ACTIONS(3191),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_to] = ACTIONS(3193),
    [anon_sym_downto] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_DOT_DOT2] = ACTIONS(3191),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [2510] = {
    [sym_block_comment] = STATE(2510),
    [sym_compiler_directive_decl] = STATE(2510),
    [sym_fsi_directive_decl] = STATE(2510),
    [sym_preproc_line] = STATE(2510),
    [sym_identifier] = ACTIONS(4147),
    [anon_sym_EQ] = ACTIONS(4145),
    [anon_sym_GT_RBRACK] = ACTIONS(4145),
    [anon_sym_COLON] = ACTIONS(4147),
    [anon_sym_return] = ACTIONS(4147),
    [anon_sym_do] = ACTIONS(4147),
    [anon_sym_let] = ACTIONS(4147),
    [anon_sym_let_BANG] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(4147),
    [anon_sym_COMMA] = ACTIONS(4145),
    [anon_sym_null] = ACTIONS(4147),
    [anon_sym_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_COLON] = ACTIONS(4145),
    [anon_sym_AMP] = ACTIONS(4147),
    [anon_sym_LBRACK] = ACTIONS(4147),
    [anon_sym_RBRACK] = ACTIONS(4145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4145),
    [anon_sym_LBRACE] = ACTIONS(4147),
    [anon_sym_RBRACE] = ACTIONS(4145),
    [anon_sym_LT_AT] = ACTIONS(4147),
    [anon_sym_LT_AT_AT] = ACTIONS(4147),
    [anon_sym_DOT] = ACTIONS(4147),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4145),
    [anon_sym_new] = ACTIONS(4147),
    [anon_sym_with] = ACTIONS(4147),
    [anon_sym_return_BANG] = ACTIONS(4145),
    [anon_sym_yield] = ACTIONS(4147),
    [anon_sym_yield_BANG] = ACTIONS(4145),
    [anon_sym_lazy] = ACTIONS(4147),
    [anon_sym_assert] = ACTIONS(4147),
    [anon_sym_upcast] = ACTIONS(4147),
    [anon_sym_downcast] = ACTIONS(4147),
    [anon_sym_COLON_GT] = ACTIONS(4145),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4145),
    [anon_sym_for] = ACTIONS(4147),
    [anon_sym_to] = ACTIONS(4147),
    [anon_sym_downto] = ACTIONS(4147),
    [anon_sym_while] = ACTIONS(4147),
    [anon_sym_if] = ACTIONS(4147),
    [anon_sym_fun] = ACTIONS(4147),
    [anon_sym_try] = ACTIONS(4147),
    [anon_sym_match] = ACTIONS(4147),
    [anon_sym_match_BANG] = ACTIONS(4145),
    [anon_sym_function] = ACTIONS(4147),
    [anon_sym_LT_DASH] = ACTIONS(4147),
    [anon_sym_DOT_LBRACK] = ACTIONS(4145),
    [anon_sym_LT] = ACTIONS(4145),
    [anon_sym_use] = ACTIONS(4147),
    [anon_sym_use_BANG] = ACTIONS(4145),
    [anon_sym_do_BANG] = ACTIONS(4145),
    [anon_sym_begin] = ACTIONS(4147),
    [anon_sym_LPAREN2] = ACTIONS(4147),
    [anon_sym_DOT_DOT2] = ACTIONS(4145),
    [anon_sym_or] = ACTIONS(4147),
    [aux_sym_char_token1] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4147),
    [anon_sym_DQUOTE] = ACTIONS(4147),
    [anon_sym_AT_DQUOTE] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [sym_bool] = ACTIONS(4147),
    [sym_unit] = ACTIONS(4145),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4147),
    [sym_op_identifier] = ACTIONS(4147),
    [anon_sym_PLUS] = ACTIONS(4147),
    [anon_sym_DASH] = ACTIONS(4147),
    [anon_sym_PLUS_DOT] = ACTIONS(4147),
    [anon_sym_DASH_DOT] = ACTIONS(4147),
    [anon_sym_PERCENT] = ACTIONS(4147),
    [anon_sym_AMP_AMP] = ACTIONS(4147),
    [anon_sym_TILDE] = ACTIONS(4145),
    [aux_sym_prefix_op_token1] = ACTIONS(4147),
    [aux_sym_infix_op_token1] = ACTIONS(4145),
    [aux_sym_infix_op_token2] = ACTIONS(4147),
    [anon_sym_PIPE_PIPE] = ACTIONS(4147),
    [anon_sym_BANG_EQ] = ACTIONS(4147),
    [anon_sym_COLON_EQ] = ACTIONS(4145),
    [anon_sym_DOLLAR] = ACTIONS(4147),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4147),
    [sym_int] = ACTIONS(4147),
    [sym_xint] = ACTIONS(4145),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4145),
    [sym__newline] = ACTIONS(4145),
  },
  [2511] = {
    [sym_block_comment] = STATE(2511),
    [sym_compiler_directive_decl] = STATE(2511),
    [sym_fsi_directive_decl] = STATE(2511),
    [sym_preproc_line] = STATE(2511),
    [ts_builtin_sym_end] = ACTIONS(3960),
    [sym_identifier] = ACTIONS(3962),
    [anon_sym_namespace] = ACTIONS(3962),
    [anon_sym_module] = ACTIONS(3962),
    [anon_sym_EQ] = ACTIONS(3960),
    [anon_sym_open] = ACTIONS(3962),
    [anon_sym_LBRACK_LT] = ACTIONS(3960),
    [anon_sym_COLON] = ACTIONS(3962),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_type] = ACTIONS(3962),
    [anon_sym_do] = ACTIONS(3962),
    [anon_sym_let] = ACTIONS(3962),
    [anon_sym_let_BANG] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_COMMA] = ACTIONS(3960),
    [anon_sym_null] = ACTIONS(3962),
    [anon_sym_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_COLON] = ACTIONS(3960),
    [anon_sym_AMP] = ACTIONS(3962),
    [anon_sym_LBRACK] = ACTIONS(3962),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_LT_AT] = ACTIONS(3962),
    [anon_sym_LT_AT_AT] = ACTIONS(3962),
    [anon_sym_DOT] = ACTIONS(3962),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3960),
    [anon_sym_new] = ACTIONS(3962),
    [anon_sym_return_BANG] = ACTIONS(3960),
    [anon_sym_yield] = ACTIONS(3962),
    [anon_sym_yield_BANG] = ACTIONS(3960),
    [anon_sym_lazy] = ACTIONS(3962),
    [anon_sym_assert] = ACTIONS(3962),
    [anon_sym_upcast] = ACTIONS(3962),
    [anon_sym_downcast] = ACTIONS(3962),
    [anon_sym_COLON_GT] = ACTIONS(3960),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3960),
    [anon_sym_for] = ACTIONS(3962),
    [anon_sym_while] = ACTIONS(3962),
    [anon_sym_if] = ACTIONS(3962),
    [anon_sym_fun] = ACTIONS(3962),
    [anon_sym_try] = ACTIONS(3962),
    [anon_sym_match] = ACTIONS(3962),
    [anon_sym_match_BANG] = ACTIONS(3960),
    [anon_sym_function] = ACTIONS(3962),
    [anon_sym_LT_DASH] = ACTIONS(3962),
    [anon_sym_DOT_LBRACK] = ACTIONS(3960),
    [anon_sym_LT] = ACTIONS(3960),
    [anon_sym_use] = ACTIONS(3962),
    [anon_sym_use_BANG] = ACTIONS(3960),
    [anon_sym_do_BANG] = ACTIONS(3960),
    [anon_sym_begin] = ACTIONS(3962),
    [anon_sym_LPAREN2] = ACTIONS(3962),
    [anon_sym_or] = ACTIONS(3962),
    [anon_sym_exception] = ACTIONS(3962),
    [aux_sym_char_token1] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3962),
    [anon_sym_DQUOTE] = ACTIONS(3962),
    [anon_sym_AT_DQUOTE] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [sym_bool] = ACTIONS(3962),
    [sym_unit] = ACTIONS(3960),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3962),
    [sym_op_identifier] = ACTIONS(3962),
    [anon_sym_PLUS] = ACTIONS(3962),
    [anon_sym_DASH] = ACTIONS(3962),
    [anon_sym_PLUS_DOT] = ACTIONS(3962),
    [anon_sym_DASH_DOT] = ACTIONS(3962),
    [anon_sym_PERCENT] = ACTIONS(3962),
    [anon_sym_AMP_AMP] = ACTIONS(3962),
    [anon_sym_TILDE] = ACTIONS(3960),
    [aux_sym_prefix_op_token1] = ACTIONS(3962),
    [aux_sym_infix_op_token1] = ACTIONS(3960),
    [aux_sym_infix_op_token2] = ACTIONS(3962),
    [anon_sym_PIPE_PIPE] = ACTIONS(3962),
    [anon_sym_BANG_EQ] = ACTIONS(3962),
    [anon_sym_COLON_EQ] = ACTIONS(3960),
    [anon_sym_DOLLAR] = ACTIONS(3962),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3962),
    [sym_int] = ACTIONS(3962),
    [sym_xint] = ACTIONS(3960),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3960),
    [anon_sym_POUNDload] = ACTIONS(3960),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3960),
    [sym__newline] = ACTIONS(3960),
  },
  [2512] = {
    [sym_block_comment] = STATE(2512),
    [sym_compiler_directive_decl] = STATE(2512),
    [sym_fsi_directive_decl] = STATE(2512),
    [sym_preproc_line] = STATE(2512),
    [ts_builtin_sym_end] = ACTIONS(3956),
    [sym_identifier] = ACTIONS(3958),
    [anon_sym_namespace] = ACTIONS(3958),
    [anon_sym_module] = ACTIONS(3958),
    [anon_sym_EQ] = ACTIONS(3956),
    [anon_sym_open] = ACTIONS(3958),
    [anon_sym_LBRACK_LT] = ACTIONS(3956),
    [anon_sym_COLON] = ACTIONS(3958),
    [anon_sym_return] = ACTIONS(3958),
    [anon_sym_type] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(3958),
    [anon_sym_let] = ACTIONS(3958),
    [anon_sym_let_BANG] = ACTIONS(3956),
    [anon_sym_LPAREN] = ACTIONS(3958),
    [anon_sym_COMMA] = ACTIONS(3956),
    [anon_sym_null] = ACTIONS(3958),
    [anon_sym_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_COLON] = ACTIONS(3956),
    [anon_sym_AMP] = ACTIONS(3958),
    [anon_sym_LBRACK] = ACTIONS(3958),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3956),
    [anon_sym_LBRACE] = ACTIONS(3958),
    [anon_sym_LT_AT] = ACTIONS(3958),
    [anon_sym_LT_AT_AT] = ACTIONS(3958),
    [anon_sym_DOT] = ACTIONS(3958),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3956),
    [anon_sym_new] = ACTIONS(3958),
    [anon_sym_return_BANG] = ACTIONS(3956),
    [anon_sym_yield] = ACTIONS(3958),
    [anon_sym_yield_BANG] = ACTIONS(3956),
    [anon_sym_lazy] = ACTIONS(3958),
    [anon_sym_assert] = ACTIONS(3958),
    [anon_sym_upcast] = ACTIONS(3958),
    [anon_sym_downcast] = ACTIONS(3958),
    [anon_sym_COLON_GT] = ACTIONS(3956),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3956),
    [anon_sym_for] = ACTIONS(3958),
    [anon_sym_while] = ACTIONS(3958),
    [anon_sym_if] = ACTIONS(3958),
    [anon_sym_fun] = ACTIONS(3958),
    [anon_sym_try] = ACTIONS(3958),
    [anon_sym_match] = ACTIONS(3958),
    [anon_sym_match_BANG] = ACTIONS(3956),
    [anon_sym_function] = ACTIONS(3958),
    [anon_sym_LT_DASH] = ACTIONS(3958),
    [anon_sym_DOT_LBRACK] = ACTIONS(3956),
    [anon_sym_LT] = ACTIONS(3956),
    [anon_sym_use] = ACTIONS(3958),
    [anon_sym_use_BANG] = ACTIONS(3956),
    [anon_sym_do_BANG] = ACTIONS(3956),
    [anon_sym_begin] = ACTIONS(3958),
    [anon_sym_LPAREN2] = ACTIONS(3958),
    [anon_sym_or] = ACTIONS(3958),
    [anon_sym_exception] = ACTIONS(3958),
    [aux_sym_char_token1] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [anon_sym_AT_DQUOTE] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [sym_bool] = ACTIONS(3958),
    [sym_unit] = ACTIONS(3956),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3958),
    [sym_op_identifier] = ACTIONS(3958),
    [anon_sym_PLUS] = ACTIONS(3958),
    [anon_sym_DASH] = ACTIONS(3958),
    [anon_sym_PLUS_DOT] = ACTIONS(3958),
    [anon_sym_DASH_DOT] = ACTIONS(3958),
    [anon_sym_PERCENT] = ACTIONS(3958),
    [anon_sym_AMP_AMP] = ACTIONS(3958),
    [anon_sym_TILDE] = ACTIONS(3956),
    [aux_sym_prefix_op_token1] = ACTIONS(3958),
    [aux_sym_infix_op_token1] = ACTIONS(3956),
    [aux_sym_infix_op_token2] = ACTIONS(3958),
    [anon_sym_PIPE_PIPE] = ACTIONS(3958),
    [anon_sym_BANG_EQ] = ACTIONS(3958),
    [anon_sym_COLON_EQ] = ACTIONS(3956),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3958),
    [sym_int] = ACTIONS(3958),
    [sym_xint] = ACTIONS(3956),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3956),
    [anon_sym_POUNDload] = ACTIONS(3956),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3956),
    [sym__newline] = ACTIONS(3956),
  },
  [2513] = {
    [sym_block_comment] = STATE(2513),
    [sym_compiler_directive_decl] = STATE(2513),
    [sym_fsi_directive_decl] = STATE(2513),
    [sym_preproc_line] = STATE(2513),
    [sym_identifier] = ACTIONS(4104),
    [anon_sym_EQ] = ACTIONS(4102),
    [anon_sym_GT_RBRACK] = ACTIONS(4102),
    [anon_sym_COLON] = ACTIONS(4104),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_do] = ACTIONS(4104),
    [anon_sym_let] = ACTIONS(4104),
    [anon_sym_let_BANG] = ACTIONS(4102),
    [anon_sym_LPAREN] = ACTIONS(4104),
    [anon_sym_COMMA] = ACTIONS(4102),
    [anon_sym_null] = ACTIONS(4104),
    [anon_sym_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_COLON] = ACTIONS(4102),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4104),
    [anon_sym_RBRACK] = ACTIONS(4102),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4102),
    [anon_sym_LBRACE] = ACTIONS(4104),
    [anon_sym_RBRACE] = ACTIONS(4102),
    [anon_sym_LT_AT] = ACTIONS(4104),
    [anon_sym_LT_AT_AT] = ACTIONS(4104),
    [anon_sym_DOT] = ACTIONS(4104),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4102),
    [anon_sym_new] = ACTIONS(4104),
    [anon_sym_with] = ACTIONS(4104),
    [anon_sym_return_BANG] = ACTIONS(4102),
    [anon_sym_yield] = ACTIONS(4104),
    [anon_sym_yield_BANG] = ACTIONS(4102),
    [anon_sym_lazy] = ACTIONS(4104),
    [anon_sym_assert] = ACTIONS(4104),
    [anon_sym_upcast] = ACTIONS(4104),
    [anon_sym_downcast] = ACTIONS(4104),
    [anon_sym_COLON_GT] = ACTIONS(4102),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4102),
    [anon_sym_for] = ACTIONS(4104),
    [anon_sym_to] = ACTIONS(4104),
    [anon_sym_downto] = ACTIONS(4104),
    [anon_sym_while] = ACTIONS(4104),
    [anon_sym_if] = ACTIONS(4104),
    [anon_sym_fun] = ACTIONS(4104),
    [anon_sym_try] = ACTIONS(4104),
    [anon_sym_match] = ACTIONS(4104),
    [anon_sym_match_BANG] = ACTIONS(4102),
    [anon_sym_function] = ACTIONS(4104),
    [anon_sym_LT_DASH] = ACTIONS(4104),
    [anon_sym_DOT_LBRACK] = ACTIONS(4102),
    [anon_sym_LT] = ACTIONS(4102),
    [anon_sym_use] = ACTIONS(4104),
    [anon_sym_use_BANG] = ACTIONS(4102),
    [anon_sym_do_BANG] = ACTIONS(4102),
    [anon_sym_begin] = ACTIONS(4104),
    [anon_sym_LPAREN2] = ACTIONS(4104),
    [anon_sym_DOT_DOT2] = ACTIONS(4102),
    [anon_sym_or] = ACTIONS(4104),
    [aux_sym_char_token1] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4104),
    [anon_sym_DQUOTE] = ACTIONS(4104),
    [anon_sym_AT_DQUOTE] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [sym_bool] = ACTIONS(4104),
    [sym_unit] = ACTIONS(4102),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4104),
    [sym_op_identifier] = ACTIONS(4104),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_PLUS_DOT] = ACTIONS(4104),
    [anon_sym_DASH_DOT] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_AMP_AMP] = ACTIONS(4104),
    [anon_sym_TILDE] = ACTIONS(4102),
    [aux_sym_prefix_op_token1] = ACTIONS(4104),
    [aux_sym_infix_op_token1] = ACTIONS(4102),
    [aux_sym_infix_op_token2] = ACTIONS(4104),
    [anon_sym_PIPE_PIPE] = ACTIONS(4104),
    [anon_sym_BANG_EQ] = ACTIONS(4104),
    [anon_sym_COLON_EQ] = ACTIONS(4102),
    [anon_sym_DOLLAR] = ACTIONS(4104),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4104),
    [sym_int] = ACTIONS(4104),
    [sym_xint] = ACTIONS(4102),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4102),
    [sym__newline] = ACTIONS(4102),
  },
  [2514] = {
    [sym_block_comment] = STATE(2514),
    [sym_compiler_directive_decl] = STATE(2514),
    [sym_fsi_directive_decl] = STATE(2514),
    [sym_preproc_line] = STATE(2514),
    [ts_builtin_sym_end] = ACTIONS(3919),
    [sym_identifier] = ACTIONS(3921),
    [anon_sym_namespace] = ACTIONS(3921),
    [anon_sym_module] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3919),
    [anon_sym_open] = ACTIONS(3921),
    [anon_sym_LBRACK_LT] = ACTIONS(3919),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_return] = ACTIONS(3921),
    [anon_sym_type] = ACTIONS(3921),
    [anon_sym_do] = ACTIONS(3921),
    [anon_sym_let] = ACTIONS(3921),
    [anon_sym_let_BANG] = ACTIONS(3919),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3919),
    [anon_sym_null] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_COLON] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3919),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_LT_AT] = ACTIONS(3921),
    [anon_sym_LT_AT_AT] = ACTIONS(3921),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3919),
    [anon_sym_new] = ACTIONS(3921),
    [anon_sym_return_BANG] = ACTIONS(3919),
    [anon_sym_yield] = ACTIONS(3921),
    [anon_sym_yield_BANG] = ACTIONS(3919),
    [anon_sym_lazy] = ACTIONS(3921),
    [anon_sym_assert] = ACTIONS(3921),
    [anon_sym_upcast] = ACTIONS(3921),
    [anon_sym_downcast] = ACTIONS(3921),
    [anon_sym_COLON_GT] = ACTIONS(3919),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3919),
    [anon_sym_for] = ACTIONS(3921),
    [anon_sym_while] = ACTIONS(3921),
    [anon_sym_if] = ACTIONS(3921),
    [anon_sym_fun] = ACTIONS(3921),
    [anon_sym_try] = ACTIONS(3921),
    [anon_sym_match] = ACTIONS(3921),
    [anon_sym_match_BANG] = ACTIONS(3919),
    [anon_sym_function] = ACTIONS(3921),
    [anon_sym_LT_DASH] = ACTIONS(3921),
    [anon_sym_DOT_LBRACK] = ACTIONS(3919),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_use] = ACTIONS(3921),
    [anon_sym_use_BANG] = ACTIONS(3919),
    [anon_sym_do_BANG] = ACTIONS(3919),
    [anon_sym_begin] = ACTIONS(3921),
    [anon_sym_LPAREN2] = ACTIONS(3921),
    [anon_sym_or] = ACTIONS(3921),
    [anon_sym_exception] = ACTIONS(3921),
    [aux_sym_char_token1] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_AT_DQUOTE] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [sym_bool] = ACTIONS(3921),
    [sym_unit] = ACTIONS(3919),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3921),
    [sym_op_identifier] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_DOT] = ACTIONS(3921),
    [anon_sym_DASH_DOT] = ACTIONS(3921),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3919),
    [aux_sym_prefix_op_token1] = ACTIONS(3921),
    [aux_sym_infix_op_token1] = ACTIONS(3919),
    [aux_sym_infix_op_token2] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_COLON_EQ] = ACTIONS(3919),
    [anon_sym_DOLLAR] = ACTIONS(3921),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3921),
    [sym_int] = ACTIONS(3921),
    [sym_xint] = ACTIONS(3919),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3919),
    [anon_sym_POUNDload] = ACTIONS(3919),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3919),
    [sym__newline] = ACTIONS(3919),
  },
  [2515] = {
    [sym_block_comment] = STATE(2515),
    [sym_compiler_directive_decl] = STATE(2515),
    [sym_fsi_directive_decl] = STATE(2515),
    [sym_preproc_line] = STATE(2515),
    [aux_sym_sequential_expression_repeat1] = STATE(2381),
    [ts_builtin_sym_end] = ACTIONS(3757),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_module] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_open] = ACTIONS(3759),
    [anon_sym_LBRACK_LT] = ACTIONS(3757),
    [anon_sym_COLON] = ACTIONS(3759),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_type] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_let_BANG] = ACTIONS(3757),
    [anon_sym_LPAREN] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3757),
    [anon_sym_null] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3757),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_LT_AT] = ACTIONS(3759),
    [anon_sym_LT_AT_AT] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(3759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_return_BANG] = ACTIONS(3757),
    [anon_sym_yield] = ACTIONS(3759),
    [anon_sym_yield_BANG] = ACTIONS(3757),
    [anon_sym_lazy] = ACTIONS(3759),
    [anon_sym_assert] = ACTIONS(3759),
    [anon_sym_upcast] = ACTIONS(3759),
    [anon_sym_downcast] = ACTIONS(3759),
    [anon_sym_COLON_GT] = ACTIONS(3757),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3757),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_fun] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_match] = ACTIONS(3759),
    [anon_sym_match_BANG] = ACTIONS(3757),
    [anon_sym_function] = ACTIONS(3759),
    [anon_sym_LT_DASH] = ACTIONS(3759),
    [anon_sym_DOT_LBRACK] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_use] = ACTIONS(3759),
    [anon_sym_use_BANG] = ACTIONS(3757),
    [anon_sym_do_BANG] = ACTIONS(3757),
    [anon_sym_begin] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_or] = ACTIONS(3759),
    [anon_sym_exception] = ACTIONS(3759),
    [aux_sym_char_token1] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3759),
    [anon_sym_DQUOTE] = ACTIONS(3759),
    [anon_sym_AT_DQUOTE] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [sym_bool] = ACTIONS(3759),
    [sym_unit] = ACTIONS(3757),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3759),
    [sym_op_identifier] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS_DOT] = ACTIONS(3759),
    [anon_sym_DASH_DOT] = ACTIONS(3759),
    [anon_sym_PERCENT] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_TILDE] = ACTIONS(3757),
    [aux_sym_prefix_op_token1] = ACTIONS(3759),
    [aux_sym_infix_op_token1] = ACTIONS(3757),
    [aux_sym_infix_op_token2] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_COLON_EQ] = ACTIONS(3757),
    [anon_sym_DOLLAR] = ACTIONS(3759),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3759),
    [sym_int] = ACTIONS(3759),
    [sym_xint] = ACTIONS(3757),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3757),
    [anon_sym_POUNDload] = ACTIONS(3757),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3757),
    [sym__newline] = ACTIONS(3757),
  },
  [2516] = {
    [sym_block_comment] = STATE(2516),
    [sym_compiler_directive_decl] = STATE(2516),
    [sym_fsi_directive_decl] = STATE(2516),
    [sym_preproc_line] = STATE(2516),
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_EQ] = ACTIONS(3990),
    [anon_sym_GT_RBRACK] = ACTIONS(3990),
    [anon_sym_COLON] = ACTIONS(3992),
    [anon_sym_return] = ACTIONS(3992),
    [anon_sym_do] = ACTIONS(3992),
    [anon_sym_let] = ACTIONS(3992),
    [anon_sym_let_BANG] = ACTIONS(3990),
    [anon_sym_LPAREN] = ACTIONS(3992),
    [anon_sym_COMMA] = ACTIONS(3990),
    [anon_sym_null] = ACTIONS(3992),
    [anon_sym_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [anon_sym_AMP] = ACTIONS(3992),
    [anon_sym_LBRACK] = ACTIONS(3992),
    [anon_sym_RBRACK] = ACTIONS(3990),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3990),
    [anon_sym_LBRACE] = ACTIONS(3992),
    [anon_sym_RBRACE] = ACTIONS(3990),
    [anon_sym_LT_AT] = ACTIONS(3992),
    [anon_sym_LT_AT_AT] = ACTIONS(3992),
    [anon_sym_DOT] = ACTIONS(3992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3990),
    [anon_sym_new] = ACTIONS(3992),
    [anon_sym_with] = ACTIONS(3992),
    [anon_sym_return_BANG] = ACTIONS(3990),
    [anon_sym_yield] = ACTIONS(3992),
    [anon_sym_yield_BANG] = ACTIONS(3990),
    [anon_sym_lazy] = ACTIONS(3992),
    [anon_sym_assert] = ACTIONS(3992),
    [anon_sym_upcast] = ACTIONS(3992),
    [anon_sym_downcast] = ACTIONS(3992),
    [anon_sym_COLON_GT] = ACTIONS(3990),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3990),
    [anon_sym_for] = ACTIONS(3992),
    [anon_sym_to] = ACTIONS(3992),
    [anon_sym_downto] = ACTIONS(3992),
    [anon_sym_while] = ACTIONS(3992),
    [anon_sym_if] = ACTIONS(3992),
    [anon_sym_fun] = ACTIONS(3992),
    [anon_sym_try] = ACTIONS(3992),
    [anon_sym_match] = ACTIONS(3992),
    [anon_sym_match_BANG] = ACTIONS(3990),
    [anon_sym_function] = ACTIONS(3992),
    [anon_sym_LT_DASH] = ACTIONS(3992),
    [anon_sym_DOT_LBRACK] = ACTIONS(3990),
    [anon_sym_LT] = ACTIONS(3990),
    [anon_sym_use] = ACTIONS(3992),
    [anon_sym_use_BANG] = ACTIONS(3990),
    [anon_sym_do_BANG] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_LPAREN2] = ACTIONS(3992),
    [anon_sym_DOT_DOT2] = ACTIONS(3990),
    [anon_sym_or] = ACTIONS(3992),
    [aux_sym_char_token1] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3992),
    [anon_sym_DQUOTE] = ACTIONS(3992),
    [anon_sym_AT_DQUOTE] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [sym_bool] = ACTIONS(3992),
    [sym_unit] = ACTIONS(3990),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3992),
    [sym_op_identifier] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3992),
    [anon_sym_DASH] = ACTIONS(3992),
    [anon_sym_PLUS_DOT] = ACTIONS(3992),
    [anon_sym_DASH_DOT] = ACTIONS(3992),
    [anon_sym_PERCENT] = ACTIONS(3992),
    [anon_sym_AMP_AMP] = ACTIONS(3992),
    [anon_sym_TILDE] = ACTIONS(3990),
    [aux_sym_prefix_op_token1] = ACTIONS(3992),
    [aux_sym_infix_op_token1] = ACTIONS(3990),
    [aux_sym_infix_op_token2] = ACTIONS(3992),
    [anon_sym_PIPE_PIPE] = ACTIONS(3992),
    [anon_sym_BANG_EQ] = ACTIONS(3992),
    [anon_sym_COLON_EQ] = ACTIONS(3990),
    [anon_sym_DOLLAR] = ACTIONS(3992),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3992),
    [sym_int] = ACTIONS(3992),
    [sym_xint] = ACTIONS(3990),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3990),
    [sym__newline] = ACTIONS(3990),
  },
  [2517] = {
    [sym_block_comment] = STATE(2517),
    [sym_compiler_directive_decl] = STATE(2517),
    [sym_fsi_directive_decl] = STATE(2517),
    [sym_preproc_line] = STATE(2517),
    [sym_identifier] = ACTIONS(3988),
    [anon_sym_EQ] = ACTIONS(3986),
    [anon_sym_GT_RBRACK] = ACTIONS(3986),
    [anon_sym_COLON] = ACTIONS(3988),
    [anon_sym_return] = ACTIONS(3988),
    [anon_sym_do] = ACTIONS(3988),
    [anon_sym_let] = ACTIONS(3988),
    [anon_sym_let_BANG] = ACTIONS(3986),
    [anon_sym_LPAREN] = ACTIONS(3988),
    [anon_sym_COMMA] = ACTIONS(3986),
    [anon_sym_null] = ACTIONS(3988),
    [anon_sym_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_COLON] = ACTIONS(3986),
    [anon_sym_AMP] = ACTIONS(3988),
    [anon_sym_LBRACK] = ACTIONS(3988),
    [anon_sym_RBRACK] = ACTIONS(3986),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3986),
    [anon_sym_LBRACE] = ACTIONS(3988),
    [anon_sym_RBRACE] = ACTIONS(3986),
    [anon_sym_LT_AT] = ACTIONS(3988),
    [anon_sym_LT_AT_AT] = ACTIONS(3988),
    [anon_sym_DOT] = ACTIONS(3988),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3986),
    [anon_sym_new] = ACTIONS(3988),
    [anon_sym_with] = ACTIONS(3988),
    [anon_sym_return_BANG] = ACTIONS(3986),
    [anon_sym_yield] = ACTIONS(3988),
    [anon_sym_yield_BANG] = ACTIONS(3986),
    [anon_sym_lazy] = ACTIONS(3988),
    [anon_sym_assert] = ACTIONS(3988),
    [anon_sym_upcast] = ACTIONS(3988),
    [anon_sym_downcast] = ACTIONS(3988),
    [anon_sym_COLON_GT] = ACTIONS(3986),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_to] = ACTIONS(3988),
    [anon_sym_downto] = ACTIONS(3988),
    [anon_sym_while] = ACTIONS(3988),
    [anon_sym_if] = ACTIONS(3988),
    [anon_sym_fun] = ACTIONS(3988),
    [anon_sym_try] = ACTIONS(3988),
    [anon_sym_match] = ACTIONS(3988),
    [anon_sym_match_BANG] = ACTIONS(3986),
    [anon_sym_function] = ACTIONS(3988),
    [anon_sym_LT_DASH] = ACTIONS(3988),
    [anon_sym_DOT_LBRACK] = ACTIONS(3986),
    [anon_sym_LT] = ACTIONS(3986),
    [anon_sym_use] = ACTIONS(3988),
    [anon_sym_use_BANG] = ACTIONS(3986),
    [anon_sym_do_BANG] = ACTIONS(3986),
    [anon_sym_begin] = ACTIONS(3988),
    [anon_sym_LPAREN2] = ACTIONS(3988),
    [anon_sym_DOT_DOT2] = ACTIONS(3986),
    [anon_sym_or] = ACTIONS(3988),
    [aux_sym_char_token1] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3988),
    [anon_sym_DQUOTE] = ACTIONS(3988),
    [anon_sym_AT_DQUOTE] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [sym_bool] = ACTIONS(3988),
    [sym_unit] = ACTIONS(3986),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3988),
    [sym_op_identifier] = ACTIONS(3988),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_PLUS_DOT] = ACTIONS(3988),
    [anon_sym_DASH_DOT] = ACTIONS(3988),
    [anon_sym_PERCENT] = ACTIONS(3988),
    [anon_sym_AMP_AMP] = ACTIONS(3988),
    [anon_sym_TILDE] = ACTIONS(3986),
    [aux_sym_prefix_op_token1] = ACTIONS(3988),
    [aux_sym_infix_op_token1] = ACTIONS(3986),
    [aux_sym_infix_op_token2] = ACTIONS(3988),
    [anon_sym_PIPE_PIPE] = ACTIONS(3988),
    [anon_sym_BANG_EQ] = ACTIONS(3988),
    [anon_sym_COLON_EQ] = ACTIONS(3986),
    [anon_sym_DOLLAR] = ACTIONS(3988),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3988),
    [sym_int] = ACTIONS(3988),
    [sym_xint] = ACTIONS(3986),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3986),
    [sym__newline] = ACTIONS(3986),
  },
  [2518] = {
    [sym_block_comment] = STATE(2518),
    [sym_compiler_directive_decl] = STATE(2518),
    [sym_fsi_directive_decl] = STATE(2518),
    [sym_preproc_line] = STATE(2518),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_EQ] = ACTIONS(3560),
    [anon_sym_COLON] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_let_BANG] = ACTIONS(3560),
    [anon_sym_as] = ACTIONS(3562),
    [anon_sym_LPAREN] = ACTIONS(3562),
    [anon_sym_COMMA] = ACTIONS(3560),
    [anon_sym_null] = ACTIONS(3562),
    [anon_sym_QMARK] = ACTIONS(3562),
    [anon_sym_COLON_QMARK] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3560),
    [anon_sym_LBRACE] = ACTIONS(3562),
    [anon_sym_LT_AT] = ACTIONS(3562),
    [anon_sym_LT_AT_AT] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(3562),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3560),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_with] = ACTIONS(3562),
    [anon_sym_return_BANG] = ACTIONS(3560),
    [anon_sym_yield] = ACTIONS(3562),
    [anon_sym_yield_BANG] = ACTIONS(3560),
    [anon_sym_lazy] = ACTIONS(3562),
    [anon_sym_assert] = ACTIONS(3562),
    [anon_sym_upcast] = ACTIONS(3562),
    [anon_sym_downcast] = ACTIONS(3562),
    [anon_sym_COLON_GT] = ACTIONS(3560),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3560),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_fun] = ACTIONS(3562),
    [anon_sym_DASH_GT] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_match] = ACTIONS(3562),
    [anon_sym_match_BANG] = ACTIONS(3560),
    [anon_sym_function] = ACTIONS(3562),
    [anon_sym_LT_DASH] = ACTIONS(3562),
    [anon_sym_DOT_LBRACK] = ACTIONS(3560),
    [anon_sym_LT] = ACTIONS(3560),
    [anon_sym_use] = ACTIONS(3562),
    [anon_sym_use_BANG] = ACTIONS(3560),
    [anon_sym_do_BANG] = ACTIONS(3560),
    [anon_sym_begin] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3562),
    [anon_sym_LT2] = ACTIONS(3562),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3560),
    [anon_sym_or] = ACTIONS(3562),
    [aux_sym_char_token1] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(3562),
    [anon_sym_AT_DQUOTE] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [sym_bool] = ACTIONS(3562),
    [sym_unit] = ACTIONS(3560),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3562),
    [sym_op_identifier] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS_DOT] = ACTIONS(3562),
    [anon_sym_DASH_DOT] = ACTIONS(3562),
    [anon_sym_PERCENT] = ACTIONS(3562),
    [anon_sym_AMP_AMP] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3560),
    [aux_sym_prefix_op_token1] = ACTIONS(3562),
    [aux_sym_infix_op_token1] = ACTIONS(3560),
    [aux_sym_infix_op_token2] = ACTIONS(3562),
    [anon_sym_PIPE_PIPE] = ACTIONS(3562),
    [anon_sym_BANG_EQ] = ACTIONS(3562),
    [anon_sym_COLON_EQ] = ACTIONS(3560),
    [anon_sym_DOLLAR] = ACTIONS(3562),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3562),
    [sym_int] = ACTIONS(3562),
    [sym_xint] = ACTIONS(3560),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3560),
    [sym__newline] = ACTIONS(3560),
    [sym__dedent] = ACTIONS(3560),
  },
  [2519] = {
    [sym_block_comment] = STATE(2519),
    [sym_compiler_directive_decl] = STATE(2519),
    [sym_fsi_directive_decl] = STATE(2519),
    [sym_preproc_line] = STATE(2519),
    [sym_identifier] = ACTIONS(3984),
    [anon_sym_EQ] = ACTIONS(3982),
    [anon_sym_GT_RBRACK] = ACTIONS(3982),
    [anon_sym_COLON] = ACTIONS(3984),
    [anon_sym_return] = ACTIONS(3984),
    [anon_sym_do] = ACTIONS(3984),
    [anon_sym_let] = ACTIONS(3984),
    [anon_sym_let_BANG] = ACTIONS(3982),
    [anon_sym_LPAREN] = ACTIONS(3984),
    [anon_sym_COMMA] = ACTIONS(3982),
    [anon_sym_null] = ACTIONS(3984),
    [anon_sym_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AMP] = ACTIONS(3984),
    [anon_sym_LBRACK] = ACTIONS(3984),
    [anon_sym_RBRACK] = ACTIONS(3982),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(3984),
    [anon_sym_RBRACE] = ACTIONS(3982),
    [anon_sym_LT_AT] = ACTIONS(3984),
    [anon_sym_LT_AT_AT] = ACTIONS(3984),
    [anon_sym_DOT] = ACTIONS(3984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3982),
    [anon_sym_new] = ACTIONS(3984),
    [anon_sym_with] = ACTIONS(3984),
    [anon_sym_return_BANG] = ACTIONS(3982),
    [anon_sym_yield] = ACTIONS(3984),
    [anon_sym_yield_BANG] = ACTIONS(3982),
    [anon_sym_lazy] = ACTIONS(3984),
    [anon_sym_assert] = ACTIONS(3984),
    [anon_sym_upcast] = ACTIONS(3984),
    [anon_sym_downcast] = ACTIONS(3984),
    [anon_sym_COLON_GT] = ACTIONS(3982),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3982),
    [anon_sym_for] = ACTIONS(3984),
    [anon_sym_to] = ACTIONS(3984),
    [anon_sym_downto] = ACTIONS(3984),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_if] = ACTIONS(3984),
    [anon_sym_fun] = ACTIONS(3984),
    [anon_sym_try] = ACTIONS(3984),
    [anon_sym_match] = ACTIONS(3984),
    [anon_sym_match_BANG] = ACTIONS(3982),
    [anon_sym_function] = ACTIONS(3984),
    [anon_sym_LT_DASH] = ACTIONS(3984),
    [anon_sym_DOT_LBRACK] = ACTIONS(3982),
    [anon_sym_LT] = ACTIONS(3982),
    [anon_sym_use] = ACTIONS(3984),
    [anon_sym_use_BANG] = ACTIONS(3982),
    [anon_sym_do_BANG] = ACTIONS(3982),
    [anon_sym_begin] = ACTIONS(3984),
    [anon_sym_LPAREN2] = ACTIONS(3984),
    [anon_sym_DOT_DOT2] = ACTIONS(3982),
    [anon_sym_or] = ACTIONS(3984),
    [aux_sym_char_token1] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3984),
    [anon_sym_DQUOTE] = ACTIONS(3984),
    [anon_sym_AT_DQUOTE] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [sym_bool] = ACTIONS(3984),
    [sym_unit] = ACTIONS(3982),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3984),
    [sym_op_identifier] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3984),
    [anon_sym_DASH] = ACTIONS(3984),
    [anon_sym_PLUS_DOT] = ACTIONS(3984),
    [anon_sym_DASH_DOT] = ACTIONS(3984),
    [anon_sym_PERCENT] = ACTIONS(3984),
    [anon_sym_AMP_AMP] = ACTIONS(3984),
    [anon_sym_TILDE] = ACTIONS(3982),
    [aux_sym_prefix_op_token1] = ACTIONS(3984),
    [aux_sym_infix_op_token1] = ACTIONS(3982),
    [aux_sym_infix_op_token2] = ACTIONS(3984),
    [anon_sym_PIPE_PIPE] = ACTIONS(3984),
    [anon_sym_BANG_EQ] = ACTIONS(3984),
    [anon_sym_COLON_EQ] = ACTIONS(3982),
    [anon_sym_DOLLAR] = ACTIONS(3984),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3984),
    [sym_int] = ACTIONS(3984),
    [sym_xint] = ACTIONS(3982),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3982),
    [sym__newline] = ACTIONS(3982),
  },
  [2520] = {
    [sym_block_comment] = STATE(2520),
    [sym_compiler_directive_decl] = STATE(2520),
    [sym_fsi_directive_decl] = STATE(2520),
    [sym_preproc_line] = STATE(2520),
    [ts_builtin_sym_end] = ACTIONS(3861),
    [sym_identifier] = ACTIONS(3863),
    [anon_sym_namespace] = ACTIONS(3863),
    [anon_sym_module] = ACTIONS(3863),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_open] = ACTIONS(3863),
    [anon_sym_LBRACK_LT] = ACTIONS(3861),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_type] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_let] = ACTIONS(3863),
    [anon_sym_let_BANG] = ACTIONS(3861),
    [anon_sym_LPAREN] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3861),
    [anon_sym_null] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_COLON] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_LT_AT] = ACTIONS(3863),
    [anon_sym_LT_AT_AT] = ACTIONS(3863),
    [anon_sym_DOT] = ACTIONS(3863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3861),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_return_BANG] = ACTIONS(3861),
    [anon_sym_yield] = ACTIONS(3863),
    [anon_sym_yield_BANG] = ACTIONS(3861),
    [anon_sym_lazy] = ACTIONS(3863),
    [anon_sym_assert] = ACTIONS(3863),
    [anon_sym_upcast] = ACTIONS(3863),
    [anon_sym_downcast] = ACTIONS(3863),
    [anon_sym_COLON_GT] = ACTIONS(3861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_fun] = ACTIONS(3863),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_match] = ACTIONS(3863),
    [anon_sym_match_BANG] = ACTIONS(3861),
    [anon_sym_function] = ACTIONS(3863),
    [anon_sym_LT_DASH] = ACTIONS(3863),
    [anon_sym_DOT_LBRACK] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_use] = ACTIONS(3863),
    [anon_sym_use_BANG] = ACTIONS(3861),
    [anon_sym_do_BANG] = ACTIONS(3861),
    [anon_sym_begin] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(3863),
    [anon_sym_or] = ACTIONS(3863),
    [anon_sym_exception] = ACTIONS(3863),
    [aux_sym_char_token1] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [anon_sym_AT_DQUOTE] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [sym_bool] = ACTIONS(3863),
    [sym_unit] = ACTIONS(3861),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3863),
    [sym_op_identifier] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_DOT] = ACTIONS(3863),
    [anon_sym_DASH_DOT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3861),
    [aux_sym_prefix_op_token1] = ACTIONS(3863),
    [aux_sym_infix_op_token1] = ACTIONS(3861),
    [aux_sym_infix_op_token2] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_COLON_EQ] = ACTIONS(3861),
    [anon_sym_DOLLAR] = ACTIONS(3863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3863),
    [sym_int] = ACTIONS(3863),
    [sym_xint] = ACTIONS(3861),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3861),
    [anon_sym_POUNDload] = ACTIONS(3861),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3861),
    [sym__newline] = ACTIONS(3861),
  },
  [2521] = {
    [sym_block_comment] = STATE(2521),
    [sym_compiler_directive_decl] = STATE(2521),
    [sym_fsi_directive_decl] = STATE(2521),
    [sym_preproc_line] = STATE(2521),
    [ts_builtin_sym_end] = ACTIONS(3854),
    [sym_identifier] = ACTIONS(3856),
    [anon_sym_namespace] = ACTIONS(3856),
    [anon_sym_module] = ACTIONS(3856),
    [anon_sym_EQ] = ACTIONS(3854),
    [anon_sym_open] = ACTIONS(3856),
    [anon_sym_LBRACK_LT] = ACTIONS(3854),
    [anon_sym_COLON] = ACTIONS(3856),
    [anon_sym_return] = ACTIONS(3856),
    [anon_sym_type] = ACTIONS(3856),
    [anon_sym_do] = ACTIONS(3856),
    [anon_sym_let] = ACTIONS(3856),
    [anon_sym_let_BANG] = ACTIONS(3854),
    [anon_sym_LPAREN] = ACTIONS(3856),
    [anon_sym_COMMA] = ACTIONS(3854),
    [anon_sym_null] = ACTIONS(3856),
    [anon_sym_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_AMP] = ACTIONS(3856),
    [anon_sym_LBRACK] = ACTIONS(3856),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3854),
    [anon_sym_LBRACE] = ACTIONS(3856),
    [anon_sym_LT_AT] = ACTIONS(3856),
    [anon_sym_LT_AT_AT] = ACTIONS(3856),
    [anon_sym_DOT] = ACTIONS(3856),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3854),
    [anon_sym_new] = ACTIONS(3856),
    [anon_sym_return_BANG] = ACTIONS(3854),
    [anon_sym_yield] = ACTIONS(3856),
    [anon_sym_yield_BANG] = ACTIONS(3854),
    [anon_sym_lazy] = ACTIONS(3856),
    [anon_sym_assert] = ACTIONS(3856),
    [anon_sym_upcast] = ACTIONS(3856),
    [anon_sym_downcast] = ACTIONS(3856),
    [anon_sym_COLON_GT] = ACTIONS(3854),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3854),
    [anon_sym_for] = ACTIONS(3856),
    [anon_sym_while] = ACTIONS(3856),
    [anon_sym_if] = ACTIONS(3856),
    [anon_sym_fun] = ACTIONS(3856),
    [anon_sym_try] = ACTIONS(3856),
    [anon_sym_match] = ACTIONS(3856),
    [anon_sym_match_BANG] = ACTIONS(3854),
    [anon_sym_function] = ACTIONS(3856),
    [anon_sym_LT_DASH] = ACTIONS(3856),
    [anon_sym_DOT_LBRACK] = ACTIONS(3854),
    [anon_sym_LT] = ACTIONS(3854),
    [anon_sym_use] = ACTIONS(3856),
    [anon_sym_use_BANG] = ACTIONS(3854),
    [anon_sym_do_BANG] = ACTIONS(3854),
    [anon_sym_begin] = ACTIONS(3856),
    [anon_sym_LPAREN2] = ACTIONS(3856),
    [anon_sym_or] = ACTIONS(3856),
    [anon_sym_exception] = ACTIONS(3856),
    [aux_sym_char_token1] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3856),
    [anon_sym_DQUOTE] = ACTIONS(3856),
    [anon_sym_AT_DQUOTE] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [sym_bool] = ACTIONS(3856),
    [sym_unit] = ACTIONS(3854),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3856),
    [sym_op_identifier] = ACTIONS(3856),
    [anon_sym_PLUS] = ACTIONS(3856),
    [anon_sym_DASH] = ACTIONS(3856),
    [anon_sym_PLUS_DOT] = ACTIONS(3856),
    [anon_sym_DASH_DOT] = ACTIONS(3856),
    [anon_sym_PERCENT] = ACTIONS(3856),
    [anon_sym_AMP_AMP] = ACTIONS(3856),
    [anon_sym_TILDE] = ACTIONS(3854),
    [aux_sym_prefix_op_token1] = ACTIONS(3856),
    [aux_sym_infix_op_token1] = ACTIONS(3854),
    [aux_sym_infix_op_token2] = ACTIONS(3856),
    [anon_sym_PIPE_PIPE] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3856),
    [anon_sym_COLON_EQ] = ACTIONS(3854),
    [anon_sym_DOLLAR] = ACTIONS(3856),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3856),
    [sym_int] = ACTIONS(3856),
    [sym_xint] = ACTIONS(3854),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3854),
    [anon_sym_POUNDload] = ACTIONS(3854),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3854),
    [sym__newline] = ACTIONS(3854),
  },
  [2522] = {
    [sym_block_comment] = STATE(2522),
    [sym_compiler_directive_decl] = STATE(2522),
    [sym_fsi_directive_decl] = STATE(2522),
    [sym_preproc_line] = STATE(2522),
    [sym_identifier] = ACTIONS(3980),
    [anon_sym_EQ] = ACTIONS(3978),
    [anon_sym_GT_RBRACK] = ACTIONS(3978),
    [anon_sym_COLON] = ACTIONS(3980),
    [anon_sym_return] = ACTIONS(3980),
    [anon_sym_do] = ACTIONS(3980),
    [anon_sym_let] = ACTIONS(3980),
    [anon_sym_let_BANG] = ACTIONS(3978),
    [anon_sym_LPAREN] = ACTIONS(3980),
    [anon_sym_COMMA] = ACTIONS(3978),
    [anon_sym_null] = ACTIONS(3980),
    [anon_sym_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3978),
    [anon_sym_AMP] = ACTIONS(3980),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [anon_sym_RBRACK] = ACTIONS(3978),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3978),
    [anon_sym_LBRACE] = ACTIONS(3980),
    [anon_sym_RBRACE] = ACTIONS(3978),
    [anon_sym_LT_AT] = ACTIONS(3980),
    [anon_sym_LT_AT_AT] = ACTIONS(3980),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3978),
    [anon_sym_new] = ACTIONS(3980),
    [anon_sym_with] = ACTIONS(3980),
    [anon_sym_return_BANG] = ACTIONS(3978),
    [anon_sym_yield] = ACTIONS(3980),
    [anon_sym_yield_BANG] = ACTIONS(3978),
    [anon_sym_lazy] = ACTIONS(3980),
    [anon_sym_assert] = ACTIONS(3980),
    [anon_sym_upcast] = ACTIONS(3980),
    [anon_sym_downcast] = ACTIONS(3980),
    [anon_sym_COLON_GT] = ACTIONS(3978),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3978),
    [anon_sym_for] = ACTIONS(3980),
    [anon_sym_to] = ACTIONS(3980),
    [anon_sym_downto] = ACTIONS(3980),
    [anon_sym_while] = ACTIONS(3980),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_fun] = ACTIONS(3980),
    [anon_sym_try] = ACTIONS(3980),
    [anon_sym_match] = ACTIONS(3980),
    [anon_sym_match_BANG] = ACTIONS(3978),
    [anon_sym_function] = ACTIONS(3980),
    [anon_sym_LT_DASH] = ACTIONS(3980),
    [anon_sym_DOT_LBRACK] = ACTIONS(3978),
    [anon_sym_LT] = ACTIONS(3978),
    [anon_sym_use] = ACTIONS(3980),
    [anon_sym_use_BANG] = ACTIONS(3978),
    [anon_sym_do_BANG] = ACTIONS(3978),
    [anon_sym_begin] = ACTIONS(3980),
    [anon_sym_LPAREN2] = ACTIONS(3980),
    [anon_sym_DOT_DOT2] = ACTIONS(3978),
    [anon_sym_or] = ACTIONS(3980),
    [aux_sym_char_token1] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3980),
    [anon_sym_DQUOTE] = ACTIONS(3980),
    [anon_sym_AT_DQUOTE] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [sym_bool] = ACTIONS(3980),
    [sym_unit] = ACTIONS(3978),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3980),
    [sym_op_identifier] = ACTIONS(3980),
    [anon_sym_PLUS] = ACTIONS(3980),
    [anon_sym_DASH] = ACTIONS(3980),
    [anon_sym_PLUS_DOT] = ACTIONS(3980),
    [anon_sym_DASH_DOT] = ACTIONS(3980),
    [anon_sym_PERCENT] = ACTIONS(3980),
    [anon_sym_AMP_AMP] = ACTIONS(3980),
    [anon_sym_TILDE] = ACTIONS(3978),
    [aux_sym_prefix_op_token1] = ACTIONS(3980),
    [aux_sym_infix_op_token1] = ACTIONS(3978),
    [aux_sym_infix_op_token2] = ACTIONS(3980),
    [anon_sym_PIPE_PIPE] = ACTIONS(3980),
    [anon_sym_BANG_EQ] = ACTIONS(3980),
    [anon_sym_COLON_EQ] = ACTIONS(3978),
    [anon_sym_DOLLAR] = ACTIONS(3980),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3980),
    [sym_int] = ACTIONS(3980),
    [sym_xint] = ACTIONS(3978),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3978),
    [sym__newline] = ACTIONS(3978),
  },
  [2523] = {
    [sym_block_comment] = STATE(2523),
    [sym_compiler_directive_decl] = STATE(2523),
    [sym_fsi_directive_decl] = STATE(2523),
    [sym_preproc_line] = STATE(2523),
    [ts_builtin_sym_end] = ACTIONS(4222),
    [sym_identifier] = ACTIONS(4224),
    [anon_sym_namespace] = ACTIONS(4224),
    [anon_sym_module] = ACTIONS(4224),
    [anon_sym_EQ] = ACTIONS(4222),
    [anon_sym_open] = ACTIONS(4224),
    [anon_sym_LBRACK_LT] = ACTIONS(4222),
    [anon_sym_COLON] = ACTIONS(4224),
    [anon_sym_return] = ACTIONS(4224),
    [anon_sym_type] = ACTIONS(4224),
    [anon_sym_do] = ACTIONS(4224),
    [anon_sym_let] = ACTIONS(4224),
    [anon_sym_let_BANG] = ACTIONS(4222),
    [anon_sym_LPAREN] = ACTIONS(4224),
    [anon_sym_COMMA] = ACTIONS(4222),
    [anon_sym_null] = ACTIONS(4224),
    [anon_sym_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_COLON] = ACTIONS(4222),
    [anon_sym_AMP] = ACTIONS(4224),
    [anon_sym_LBRACK] = ACTIONS(4224),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4222),
    [anon_sym_LBRACE] = ACTIONS(4224),
    [anon_sym_LT_AT] = ACTIONS(4224),
    [anon_sym_LT_AT_AT] = ACTIONS(4224),
    [anon_sym_DOT] = ACTIONS(4224),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4222),
    [anon_sym_new] = ACTIONS(4224),
    [anon_sym_return_BANG] = ACTIONS(4222),
    [anon_sym_yield] = ACTIONS(4224),
    [anon_sym_yield_BANG] = ACTIONS(4222),
    [anon_sym_lazy] = ACTIONS(4224),
    [anon_sym_assert] = ACTIONS(4224),
    [anon_sym_upcast] = ACTIONS(4224),
    [anon_sym_downcast] = ACTIONS(4224),
    [anon_sym_COLON_GT] = ACTIONS(4222),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4222),
    [anon_sym_for] = ACTIONS(4224),
    [anon_sym_while] = ACTIONS(4224),
    [anon_sym_if] = ACTIONS(4224),
    [anon_sym_fun] = ACTIONS(4224),
    [anon_sym_try] = ACTIONS(4224),
    [anon_sym_match] = ACTIONS(4224),
    [anon_sym_match_BANG] = ACTIONS(4222),
    [anon_sym_function] = ACTIONS(4224),
    [anon_sym_LT_DASH] = ACTIONS(4224),
    [anon_sym_DOT_LBRACK] = ACTIONS(4222),
    [anon_sym_LT] = ACTIONS(4222),
    [anon_sym_use] = ACTIONS(4224),
    [anon_sym_use_BANG] = ACTIONS(4222),
    [anon_sym_do_BANG] = ACTIONS(4222),
    [anon_sym_begin] = ACTIONS(4224),
    [anon_sym_LPAREN2] = ACTIONS(4224),
    [anon_sym_or] = ACTIONS(4224),
    [anon_sym_exception] = ACTIONS(4224),
    [aux_sym_char_token1] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4224),
    [anon_sym_DQUOTE] = ACTIONS(4224),
    [anon_sym_AT_DQUOTE] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [sym_bool] = ACTIONS(4224),
    [sym_unit] = ACTIONS(4222),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4224),
    [sym_op_identifier] = ACTIONS(4224),
    [anon_sym_PLUS] = ACTIONS(4224),
    [anon_sym_DASH] = ACTIONS(4224),
    [anon_sym_PLUS_DOT] = ACTIONS(4224),
    [anon_sym_DASH_DOT] = ACTIONS(4224),
    [anon_sym_PERCENT] = ACTIONS(4224),
    [anon_sym_AMP_AMP] = ACTIONS(4224),
    [anon_sym_TILDE] = ACTIONS(4222),
    [aux_sym_prefix_op_token1] = ACTIONS(4224),
    [aux_sym_infix_op_token1] = ACTIONS(4222),
    [aux_sym_infix_op_token2] = ACTIONS(4224),
    [anon_sym_PIPE_PIPE] = ACTIONS(4224),
    [anon_sym_BANG_EQ] = ACTIONS(4224),
    [anon_sym_COLON_EQ] = ACTIONS(4222),
    [anon_sym_DOLLAR] = ACTIONS(4224),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4224),
    [sym_int] = ACTIONS(4224),
    [sym_xint] = ACTIONS(4222),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4222),
    [anon_sym_POUNDload] = ACTIONS(4222),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4222),
    [sym__newline] = ACTIONS(4222),
  },
  [2524] = {
    [sym_block_comment] = STATE(2524),
    [sym_compiler_directive_decl] = STATE(2524),
    [sym_fsi_directive_decl] = STATE(2524),
    [sym_preproc_line] = STATE(2524),
    [sym_identifier] = ACTIONS(3535),
    [anon_sym_EQ] = ACTIONS(3533),
    [anon_sym_COLON] = ACTIONS(3535),
    [anon_sym_return] = ACTIONS(3535),
    [anon_sym_do] = ACTIONS(3535),
    [anon_sym_let] = ACTIONS(3535),
    [anon_sym_let_BANG] = ACTIONS(3533),
    [anon_sym_as] = ACTIONS(3535),
    [anon_sym_LPAREN] = ACTIONS(3535),
    [anon_sym_COMMA] = ACTIONS(3533),
    [anon_sym_null] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(3535),
    [anon_sym_COLON_QMARK] = ACTIONS(3535),
    [anon_sym_COLON_COLON] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3533),
    [anon_sym_LBRACE] = ACTIONS(3535),
    [anon_sym_LT_AT] = ACTIONS(3535),
    [anon_sym_LT_AT_AT] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(3535),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3533),
    [anon_sym_new] = ACTIONS(3535),
    [anon_sym_with] = ACTIONS(3535),
    [anon_sym_return_BANG] = ACTIONS(3533),
    [anon_sym_yield] = ACTIONS(3535),
    [anon_sym_yield_BANG] = ACTIONS(3533),
    [anon_sym_lazy] = ACTIONS(3535),
    [anon_sym_assert] = ACTIONS(3535),
    [anon_sym_upcast] = ACTIONS(3535),
    [anon_sym_downcast] = ACTIONS(3535),
    [anon_sym_COLON_GT] = ACTIONS(3533),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3533),
    [anon_sym_for] = ACTIONS(3535),
    [anon_sym_while] = ACTIONS(3535),
    [anon_sym_if] = ACTIONS(3535),
    [anon_sym_fun] = ACTIONS(3535),
    [anon_sym_DASH_GT] = ACTIONS(3535),
    [anon_sym_try] = ACTIONS(3535),
    [anon_sym_match] = ACTIONS(3535),
    [anon_sym_match_BANG] = ACTIONS(3533),
    [anon_sym_function] = ACTIONS(3535),
    [anon_sym_LT_DASH] = ACTIONS(3535),
    [anon_sym_DOT_LBRACK] = ACTIONS(3533),
    [anon_sym_LT] = ACTIONS(3533),
    [anon_sym_use] = ACTIONS(3535),
    [anon_sym_use_BANG] = ACTIONS(3533),
    [anon_sym_do_BANG] = ACTIONS(3533),
    [anon_sym_begin] = ACTIONS(3535),
    [anon_sym_LPAREN2] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(3535),
    [anon_sym_LT2] = ACTIONS(3535),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3533),
    [anon_sym_or] = ACTIONS(3535),
    [aux_sym_char_token1] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE] = ACTIONS(3535),
    [anon_sym_AT_DQUOTE] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [sym_bool] = ACTIONS(3535),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3535),
    [sym_op_identifier] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS_DOT] = ACTIONS(3535),
    [anon_sym_DASH_DOT] = ACTIONS(3535),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(3535),
    [anon_sym_TILDE] = ACTIONS(3533),
    [aux_sym_prefix_op_token1] = ACTIONS(3535),
    [aux_sym_infix_op_token1] = ACTIONS(3533),
    [aux_sym_infix_op_token2] = ACTIONS(3535),
    [anon_sym_PIPE_PIPE] = ACTIONS(3535),
    [anon_sym_BANG_EQ] = ACTIONS(3535),
    [anon_sym_COLON_EQ] = ACTIONS(3533),
    [anon_sym_DOLLAR] = ACTIONS(3535),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3535),
    [sym_int] = ACTIONS(3535),
    [sym_xint] = ACTIONS(3533),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3533),
    [sym__newline] = ACTIONS(3533),
    [sym__dedent] = ACTIONS(3533),
  },
  [2525] = {
    [sym_block_comment] = STATE(2525),
    [sym_compiler_directive_decl] = STATE(2525),
    [sym_fsi_directive_decl] = STATE(2525),
    [sym_preproc_line] = STATE(2525),
    [ts_builtin_sym_end] = ACTIONS(4135),
    [sym_identifier] = ACTIONS(4137),
    [anon_sym_namespace] = ACTIONS(4137),
    [anon_sym_module] = ACTIONS(4137),
    [anon_sym_EQ] = ACTIONS(4135),
    [anon_sym_open] = ACTIONS(4137),
    [anon_sym_LBRACK_LT] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4137),
    [anon_sym_return] = ACTIONS(4137),
    [anon_sym_type] = ACTIONS(4137),
    [anon_sym_do] = ACTIONS(4137),
    [anon_sym_let] = ACTIONS(4137),
    [anon_sym_let_BANG] = ACTIONS(4135),
    [anon_sym_LPAREN] = ACTIONS(4137),
    [anon_sym_COMMA] = ACTIONS(4135),
    [anon_sym_null] = ACTIONS(4137),
    [anon_sym_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_COLON] = ACTIONS(4135),
    [anon_sym_AMP] = ACTIONS(4137),
    [anon_sym_LBRACK] = ACTIONS(4137),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4135),
    [anon_sym_LBRACE] = ACTIONS(4137),
    [anon_sym_LT_AT] = ACTIONS(4137),
    [anon_sym_LT_AT_AT] = ACTIONS(4137),
    [anon_sym_DOT] = ACTIONS(4137),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4135),
    [anon_sym_new] = ACTIONS(4137),
    [anon_sym_return_BANG] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_yield_BANG] = ACTIONS(4135),
    [anon_sym_lazy] = ACTIONS(4137),
    [anon_sym_assert] = ACTIONS(4137),
    [anon_sym_upcast] = ACTIONS(4137),
    [anon_sym_downcast] = ACTIONS(4137),
    [anon_sym_COLON_GT] = ACTIONS(4135),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4135),
    [anon_sym_for] = ACTIONS(4137),
    [anon_sym_while] = ACTIONS(4137),
    [anon_sym_if] = ACTIONS(4137),
    [anon_sym_fun] = ACTIONS(4137),
    [anon_sym_try] = ACTIONS(4137),
    [anon_sym_match] = ACTIONS(4137),
    [anon_sym_match_BANG] = ACTIONS(4135),
    [anon_sym_function] = ACTIONS(4137),
    [anon_sym_LT_DASH] = ACTIONS(4137),
    [anon_sym_DOT_LBRACK] = ACTIONS(4135),
    [anon_sym_LT] = ACTIONS(4135),
    [anon_sym_use] = ACTIONS(4137),
    [anon_sym_use_BANG] = ACTIONS(4135),
    [anon_sym_do_BANG] = ACTIONS(4135),
    [anon_sym_begin] = ACTIONS(4137),
    [anon_sym_LPAREN2] = ACTIONS(4137),
    [anon_sym_or] = ACTIONS(4137),
    [anon_sym_exception] = ACTIONS(4137),
    [aux_sym_char_token1] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4137),
    [anon_sym_DQUOTE] = ACTIONS(4137),
    [anon_sym_AT_DQUOTE] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [sym_bool] = ACTIONS(4137),
    [sym_unit] = ACTIONS(4135),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4137),
    [sym_op_identifier] = ACTIONS(4137),
    [anon_sym_PLUS] = ACTIONS(4137),
    [anon_sym_DASH] = ACTIONS(4137),
    [anon_sym_PLUS_DOT] = ACTIONS(4137),
    [anon_sym_DASH_DOT] = ACTIONS(4137),
    [anon_sym_PERCENT] = ACTIONS(4137),
    [anon_sym_AMP_AMP] = ACTIONS(4137),
    [anon_sym_TILDE] = ACTIONS(4135),
    [aux_sym_prefix_op_token1] = ACTIONS(4137),
    [aux_sym_infix_op_token1] = ACTIONS(4135),
    [aux_sym_infix_op_token2] = ACTIONS(4137),
    [anon_sym_PIPE_PIPE] = ACTIONS(4137),
    [anon_sym_BANG_EQ] = ACTIONS(4137),
    [anon_sym_COLON_EQ] = ACTIONS(4135),
    [anon_sym_DOLLAR] = ACTIONS(4137),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4137),
    [sym_int] = ACTIONS(4137),
    [sym_xint] = ACTIONS(4135),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4135),
    [anon_sym_POUNDload] = ACTIONS(4135),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4135),
    [sym__newline] = ACTIONS(4135),
  },
  [2526] = {
    [sym_block_comment] = STATE(2526),
    [sym_compiler_directive_decl] = STATE(2526),
    [sym_fsi_directive_decl] = STATE(2526),
    [sym_preproc_line] = STATE(2526),
    [sym_identifier] = ACTIONS(3966),
    [anon_sym_EQ] = ACTIONS(3964),
    [anon_sym_GT_RBRACK] = ACTIONS(3964),
    [anon_sym_COLON] = ACTIONS(3966),
    [anon_sym_return] = ACTIONS(3966),
    [anon_sym_do] = ACTIONS(3966),
    [anon_sym_let] = ACTIONS(3966),
    [anon_sym_let_BANG] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COMMA] = ACTIONS(3964),
    [anon_sym_null] = ACTIONS(3966),
    [anon_sym_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(3964),
    [anon_sym_AMP] = ACTIONS(3966),
    [anon_sym_LBRACK] = ACTIONS(3966),
    [anon_sym_RBRACK] = ACTIONS(3964),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3964),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_RBRACE] = ACTIONS(3964),
    [anon_sym_LT_AT] = ACTIONS(3966),
    [anon_sym_LT_AT_AT] = ACTIONS(3966),
    [anon_sym_DOT] = ACTIONS(3966),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3964),
    [anon_sym_new] = ACTIONS(3966),
    [anon_sym_with] = ACTIONS(3966),
    [anon_sym_return_BANG] = ACTIONS(3964),
    [anon_sym_yield] = ACTIONS(3966),
    [anon_sym_yield_BANG] = ACTIONS(3964),
    [anon_sym_lazy] = ACTIONS(3966),
    [anon_sym_assert] = ACTIONS(3966),
    [anon_sym_upcast] = ACTIONS(3966),
    [anon_sym_downcast] = ACTIONS(3966),
    [anon_sym_COLON_GT] = ACTIONS(3964),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3964),
    [anon_sym_for] = ACTIONS(3966),
    [anon_sym_to] = ACTIONS(3966),
    [anon_sym_downto] = ACTIONS(3966),
    [anon_sym_while] = ACTIONS(3966),
    [anon_sym_if] = ACTIONS(3966),
    [anon_sym_fun] = ACTIONS(3966),
    [anon_sym_try] = ACTIONS(3966),
    [anon_sym_match] = ACTIONS(3966),
    [anon_sym_match_BANG] = ACTIONS(3964),
    [anon_sym_function] = ACTIONS(3966),
    [anon_sym_LT_DASH] = ACTIONS(3966),
    [anon_sym_DOT_LBRACK] = ACTIONS(3964),
    [anon_sym_LT] = ACTIONS(3964),
    [anon_sym_use] = ACTIONS(3966),
    [anon_sym_use_BANG] = ACTIONS(3964),
    [anon_sym_do_BANG] = ACTIONS(3964),
    [anon_sym_begin] = ACTIONS(3966),
    [anon_sym_LPAREN2] = ACTIONS(3966),
    [anon_sym_DOT_DOT2] = ACTIONS(3964),
    [anon_sym_or] = ACTIONS(3966),
    [aux_sym_char_token1] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3966),
    [anon_sym_DQUOTE] = ACTIONS(3966),
    [anon_sym_AT_DQUOTE] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [sym_bool] = ACTIONS(3966),
    [sym_unit] = ACTIONS(3964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3966),
    [sym_op_identifier] = ACTIONS(3966),
    [anon_sym_PLUS] = ACTIONS(3966),
    [anon_sym_DASH] = ACTIONS(3966),
    [anon_sym_PLUS_DOT] = ACTIONS(3966),
    [anon_sym_DASH_DOT] = ACTIONS(3966),
    [anon_sym_PERCENT] = ACTIONS(3966),
    [anon_sym_AMP_AMP] = ACTIONS(3966),
    [anon_sym_TILDE] = ACTIONS(3964),
    [aux_sym_prefix_op_token1] = ACTIONS(3966),
    [aux_sym_infix_op_token1] = ACTIONS(3964),
    [aux_sym_infix_op_token2] = ACTIONS(3966),
    [anon_sym_PIPE_PIPE] = ACTIONS(3966),
    [anon_sym_BANG_EQ] = ACTIONS(3966),
    [anon_sym_COLON_EQ] = ACTIONS(3964),
    [anon_sym_DOLLAR] = ACTIONS(3966),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3966),
    [sym_int] = ACTIONS(3966),
    [sym_xint] = ACTIONS(3964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3964),
    [sym__newline] = ACTIONS(3964),
  },
  [2527] = {
    [sym_block_comment] = STATE(2527),
    [sym_compiler_directive_decl] = STATE(2527),
    [sym_fsi_directive_decl] = STATE(2527),
    [sym_preproc_line] = STATE(2527),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3525),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [anon_sym_as] = ACTIONS(3527),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_COLON] = ACTIONS(3525),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_with] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_COLON_GT] = ACTIONS(3525),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_DASH_GT] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_LT_DASH] = ACTIONS(3527),
    [anon_sym_DOT_LBRACK] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_LPAREN2] = ACTIONS(3527),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_LT2] = ACTIONS(3527),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_or] = ACTIONS(3527),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3525),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3527),
    [anon_sym_DASH_DOT] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3527),
    [aux_sym_infix_op_token1] = ACTIONS(3525),
    [aux_sym_infix_op_token2] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_COLON_EQ] = ACTIONS(3525),
    [anon_sym_DOLLAR] = ACTIONS(3527),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3527),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3525),
    [sym__newline] = ACTIONS(3525),
    [sym__dedent] = ACTIONS(3525),
  },
  [2528] = {
    [sym_block_comment] = STATE(2528),
    [sym_compiler_directive_decl] = STATE(2528),
    [sym_fsi_directive_decl] = STATE(2528),
    [sym_preproc_line] = STATE(2528),
    [sym_identifier] = ACTIONS(3519),
    [anon_sym_EQ] = ACTIONS(3517),
    [anon_sym_COLON] = ACTIONS(3519),
    [anon_sym_return] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(3519),
    [anon_sym_let] = ACTIONS(3519),
    [anon_sym_let_BANG] = ACTIONS(3517),
    [anon_sym_as] = ACTIONS(3519),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [anon_sym_COMMA] = ACTIONS(3517),
    [anon_sym_null] = ACTIONS(3519),
    [anon_sym_QMARK] = ACTIONS(3519),
    [anon_sym_COLON_QMARK] = ACTIONS(3519),
    [anon_sym_COLON_COLON] = ACTIONS(3517),
    [anon_sym_AMP] = ACTIONS(3519),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_LT_AT] = ACTIONS(3519),
    [anon_sym_LT_AT_AT] = ACTIONS(3519),
    [anon_sym_DOT] = ACTIONS(3519),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3519),
    [anon_sym_with] = ACTIONS(3519),
    [anon_sym_return_BANG] = ACTIONS(3517),
    [anon_sym_yield] = ACTIONS(3519),
    [anon_sym_yield_BANG] = ACTIONS(3517),
    [anon_sym_lazy] = ACTIONS(3519),
    [anon_sym_assert] = ACTIONS(3519),
    [anon_sym_upcast] = ACTIONS(3519),
    [anon_sym_downcast] = ACTIONS(3519),
    [anon_sym_COLON_GT] = ACTIONS(3517),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3517),
    [anon_sym_for] = ACTIONS(3519),
    [anon_sym_while] = ACTIONS(3519),
    [anon_sym_if] = ACTIONS(3519),
    [anon_sym_fun] = ACTIONS(3519),
    [anon_sym_DASH_GT] = ACTIONS(3519),
    [anon_sym_try] = ACTIONS(3519),
    [anon_sym_match] = ACTIONS(3519),
    [anon_sym_match_BANG] = ACTIONS(3517),
    [anon_sym_function] = ACTIONS(3519),
    [anon_sym_LT_DASH] = ACTIONS(3519),
    [anon_sym_DOT_LBRACK] = ACTIONS(3517),
    [anon_sym_LT] = ACTIONS(3517),
    [anon_sym_use] = ACTIONS(3519),
    [anon_sym_use_BANG] = ACTIONS(3517),
    [anon_sym_do_BANG] = ACTIONS(3517),
    [anon_sym_begin] = ACTIONS(3519),
    [anon_sym_LPAREN2] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_LT2] = ACTIONS(3519),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3517),
    [anon_sym_or] = ACTIONS(3519),
    [aux_sym_char_token1] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [anon_sym_AT_DQUOTE] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [sym_bool] = ACTIONS(3519),
    [sym_unit] = ACTIONS(3517),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3519),
    [sym_op_identifier] = ACTIONS(3519),
    [anon_sym_PLUS] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_DOT] = ACTIONS(3519),
    [anon_sym_DASH_DOT] = ACTIONS(3519),
    [anon_sym_PERCENT] = ACTIONS(3519),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3517),
    [aux_sym_prefix_op_token1] = ACTIONS(3519),
    [aux_sym_infix_op_token1] = ACTIONS(3517),
    [aux_sym_infix_op_token2] = ACTIONS(3519),
    [anon_sym_PIPE_PIPE] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_COLON_EQ] = ACTIONS(3517),
    [anon_sym_DOLLAR] = ACTIONS(3519),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3519),
    [sym_int] = ACTIONS(3519),
    [sym_xint] = ACTIONS(3517),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3517),
    [sym__newline] = ACTIONS(3517),
    [sym__dedent] = ACTIONS(3517),
  },
  [2529] = {
    [sym_block_comment] = STATE(2529),
    [sym_compiler_directive_decl] = STATE(2529),
    [sym_fsi_directive_decl] = STATE(2529),
    [sym_preproc_line] = STATE(2529),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(3521),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3521),
    [anon_sym_as] = ACTIONS(3523),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_COMMA] = ACTIONS(3521),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_COLON] = ACTIONS(3521),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_with] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3521),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3521),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_COLON_GT] = ACTIONS(3521),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_DASH_GT] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3521),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_LT_DASH] = ACTIONS(3523),
    [anon_sym_DOT_LBRACK] = ACTIONS(3521),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3521),
    [anon_sym_do_BANG] = ACTIONS(3521),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_LPAREN2] = ACTIONS(3523),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_LT2] = ACTIONS(3523),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3521),
    [anon_sym_or] = ACTIONS(3523),
    [aux_sym_char_token1] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3521),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3523),
    [anon_sym_DASH_DOT] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3521),
    [aux_sym_prefix_op_token1] = ACTIONS(3523),
    [aux_sym_infix_op_token1] = ACTIONS(3521),
    [aux_sym_infix_op_token2] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3523),
    [anon_sym_COLON_EQ] = ACTIONS(3521),
    [anon_sym_DOLLAR] = ACTIONS(3523),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3523),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3521),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3521),
    [sym__newline] = ACTIONS(3521),
    [sym__dedent] = ACTIONS(3521),
  },
  [2530] = {
    [sym_block_comment] = STATE(2530),
    [sym_compiler_directive_decl] = STATE(2530),
    [sym_fsi_directive_decl] = STATE(2530),
    [sym_preproc_line] = STATE(2530),
    [aux_sym_long_identifier_repeat1] = STATE(2361),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_EQ] = ACTIONS(3492),
    [anon_sym_COLON] = ACTIONS(3494),
    [anon_sym_return] = ACTIONS(3494),
    [anon_sym_do] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_let_BANG] = ACTIONS(3492),
    [anon_sym_as] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(3494),
    [anon_sym_COMMA] = ACTIONS(3492),
    [anon_sym_null] = ACTIONS(3494),
    [anon_sym_QMARK] = ACTIONS(3494),
    [anon_sym_COLON_QMARK] = ACTIONS(3494),
    [anon_sym_COLON_COLON] = ACTIONS(3492),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3492),
    [anon_sym_LBRACE] = ACTIONS(3494),
    [anon_sym_LT_AT] = ACTIONS(3494),
    [anon_sym_LT_AT_AT] = ACTIONS(3494),
    [anon_sym_DOT] = ACTIONS(4949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3492),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_with] = ACTIONS(3494),
    [anon_sym_return_BANG] = ACTIONS(3492),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_yield_BANG] = ACTIONS(3492),
    [anon_sym_lazy] = ACTIONS(3494),
    [anon_sym_assert] = ACTIONS(3494),
    [anon_sym_upcast] = ACTIONS(3494),
    [anon_sym_downcast] = ACTIONS(3494),
    [anon_sym_COLON_GT] = ACTIONS(3492),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3492),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_while] = ACTIONS(3494),
    [anon_sym_if] = ACTIONS(3494),
    [anon_sym_fun] = ACTIONS(3494),
    [anon_sym_DASH_GT] = ACTIONS(3494),
    [anon_sym_try] = ACTIONS(3494),
    [anon_sym_match] = ACTIONS(3494),
    [anon_sym_match_BANG] = ACTIONS(3492),
    [anon_sym_function] = ACTIONS(3494),
    [anon_sym_LT_DASH] = ACTIONS(3494),
    [anon_sym_DOT_LBRACK] = ACTIONS(3492),
    [anon_sym_LT] = ACTIONS(3492),
    [anon_sym_use] = ACTIONS(3494),
    [anon_sym_use_BANG] = ACTIONS(3492),
    [anon_sym_do_BANG] = ACTIONS(3492),
    [anon_sym_begin] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(3494),
    [anon_sym_STAR] = ACTIONS(3494),
    [anon_sym_LT2] = ACTIONS(3494),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3492),
    [anon_sym_or] = ACTIONS(3494),
    [aux_sym_char_token1] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3494),
    [anon_sym_DQUOTE] = ACTIONS(3494),
    [anon_sym_AT_DQUOTE] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [sym_bool] = ACTIONS(3494),
    [sym_unit] = ACTIONS(3492),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3494),
    [sym_op_identifier] = ACTIONS(3494),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_PLUS_DOT] = ACTIONS(3494),
    [anon_sym_DASH_DOT] = ACTIONS(3494),
    [anon_sym_PERCENT] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_TILDE] = ACTIONS(3492),
    [aux_sym_prefix_op_token1] = ACTIONS(3494),
    [aux_sym_infix_op_token1] = ACTIONS(3492),
    [aux_sym_infix_op_token2] = ACTIONS(3494),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_COLON_EQ] = ACTIONS(3492),
    [anon_sym_DOLLAR] = ACTIONS(3494),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3494),
    [sym_int] = ACTIONS(3494),
    [sym_xint] = ACTIONS(3492),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3492),
    [sym__newline] = ACTIONS(3492),
  },
  [2531] = {
    [sym_block_comment] = STATE(2531),
    [sym_compiler_directive_decl] = STATE(2531),
    [sym_fsi_directive_decl] = STATE(2531),
    [sym_preproc_line] = STATE(2531),
    [sym_identifier] = ACTIONS(4137),
    [anon_sym_EQ] = ACTIONS(4135),
    [anon_sym_GT_RBRACK] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4137),
    [anon_sym_return] = ACTIONS(4137),
    [anon_sym_do] = ACTIONS(4137),
    [anon_sym_let] = ACTIONS(4137),
    [anon_sym_let_BANG] = ACTIONS(4135),
    [anon_sym_LPAREN] = ACTIONS(4137),
    [anon_sym_COMMA] = ACTIONS(4135),
    [anon_sym_null] = ACTIONS(4137),
    [anon_sym_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_COLON] = ACTIONS(4135),
    [anon_sym_AMP] = ACTIONS(4137),
    [anon_sym_LBRACK] = ACTIONS(4137),
    [anon_sym_RBRACK] = ACTIONS(4135),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4135),
    [anon_sym_LBRACE] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(4135),
    [anon_sym_LT_AT] = ACTIONS(4137),
    [anon_sym_LT_AT_AT] = ACTIONS(4137),
    [anon_sym_DOT] = ACTIONS(4137),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4135),
    [anon_sym_new] = ACTIONS(4137),
    [anon_sym_with] = ACTIONS(4137),
    [anon_sym_return_BANG] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_yield_BANG] = ACTIONS(4135),
    [anon_sym_lazy] = ACTIONS(4137),
    [anon_sym_assert] = ACTIONS(4137),
    [anon_sym_upcast] = ACTIONS(4137),
    [anon_sym_downcast] = ACTIONS(4137),
    [anon_sym_COLON_GT] = ACTIONS(4135),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4135),
    [anon_sym_for] = ACTIONS(4137),
    [anon_sym_to] = ACTIONS(4137),
    [anon_sym_downto] = ACTIONS(4137),
    [anon_sym_while] = ACTIONS(4137),
    [anon_sym_if] = ACTIONS(4137),
    [anon_sym_fun] = ACTIONS(4137),
    [anon_sym_try] = ACTIONS(4137),
    [anon_sym_match] = ACTIONS(4137),
    [anon_sym_match_BANG] = ACTIONS(4135),
    [anon_sym_function] = ACTIONS(4137),
    [anon_sym_LT_DASH] = ACTIONS(4137),
    [anon_sym_DOT_LBRACK] = ACTIONS(4135),
    [anon_sym_LT] = ACTIONS(4135),
    [anon_sym_use] = ACTIONS(4137),
    [anon_sym_use_BANG] = ACTIONS(4135),
    [anon_sym_do_BANG] = ACTIONS(4135),
    [anon_sym_begin] = ACTIONS(4137),
    [anon_sym_LPAREN2] = ACTIONS(4137),
    [anon_sym_DOT_DOT2] = ACTIONS(4135),
    [anon_sym_or] = ACTIONS(4137),
    [aux_sym_char_token1] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4137),
    [anon_sym_DQUOTE] = ACTIONS(4137),
    [anon_sym_AT_DQUOTE] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [sym_bool] = ACTIONS(4137),
    [sym_unit] = ACTIONS(4135),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4137),
    [sym_op_identifier] = ACTIONS(4137),
    [anon_sym_PLUS] = ACTIONS(4137),
    [anon_sym_DASH] = ACTIONS(4137),
    [anon_sym_PLUS_DOT] = ACTIONS(4137),
    [anon_sym_DASH_DOT] = ACTIONS(4137),
    [anon_sym_PERCENT] = ACTIONS(4137),
    [anon_sym_AMP_AMP] = ACTIONS(4137),
    [anon_sym_TILDE] = ACTIONS(4135),
    [aux_sym_prefix_op_token1] = ACTIONS(4137),
    [aux_sym_infix_op_token1] = ACTIONS(4135),
    [aux_sym_infix_op_token2] = ACTIONS(4137),
    [anon_sym_PIPE_PIPE] = ACTIONS(4137),
    [anon_sym_BANG_EQ] = ACTIONS(4137),
    [anon_sym_COLON_EQ] = ACTIONS(4135),
    [anon_sym_DOLLAR] = ACTIONS(4137),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4137),
    [sym_int] = ACTIONS(4137),
    [sym_xint] = ACTIONS(4135),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4135),
    [sym__newline] = ACTIONS(4135),
  },
  [2532] = {
    [sym_block_comment] = STATE(2532),
    [sym_compiler_directive_decl] = STATE(2532),
    [sym_fsi_directive_decl] = STATE(2532),
    [sym_preproc_line] = STATE(2532),
    [sym_identifier] = ACTIONS(3942),
    [anon_sym_EQ] = ACTIONS(3940),
    [anon_sym_GT_RBRACK] = ACTIONS(3940),
    [anon_sym_COLON] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_let_BANG] = ACTIONS(3940),
    [anon_sym_LPAREN] = ACTIONS(3942),
    [anon_sym_COMMA] = ACTIONS(3940),
    [anon_sym_null] = ACTIONS(3942),
    [anon_sym_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_RBRACK] = ACTIONS(3940),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3940),
    [anon_sym_LBRACE] = ACTIONS(3942),
    [anon_sym_RBRACE] = ACTIONS(3940),
    [anon_sym_LT_AT] = ACTIONS(3942),
    [anon_sym_LT_AT_AT] = ACTIONS(3942),
    [anon_sym_DOT] = ACTIONS(3942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3940),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_with] = ACTIONS(3942),
    [anon_sym_return_BANG] = ACTIONS(3940),
    [anon_sym_yield] = ACTIONS(3942),
    [anon_sym_yield_BANG] = ACTIONS(3940),
    [anon_sym_lazy] = ACTIONS(3942),
    [anon_sym_assert] = ACTIONS(3942),
    [anon_sym_upcast] = ACTIONS(3942),
    [anon_sym_downcast] = ACTIONS(3942),
    [anon_sym_COLON_GT] = ACTIONS(3940),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3940),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_to] = ACTIONS(3942),
    [anon_sym_downto] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_fun] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_match] = ACTIONS(3942),
    [anon_sym_match_BANG] = ACTIONS(3940),
    [anon_sym_function] = ACTIONS(3942),
    [anon_sym_LT_DASH] = ACTIONS(3942),
    [anon_sym_DOT_LBRACK] = ACTIONS(3940),
    [anon_sym_LT] = ACTIONS(3940),
    [anon_sym_use] = ACTIONS(3942),
    [anon_sym_use_BANG] = ACTIONS(3940),
    [anon_sym_do_BANG] = ACTIONS(3940),
    [anon_sym_begin] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3942),
    [anon_sym_DOT_DOT2] = ACTIONS(3940),
    [anon_sym_or] = ACTIONS(3942),
    [aux_sym_char_token1] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3942),
    [anon_sym_DQUOTE] = ACTIONS(3942),
    [anon_sym_AT_DQUOTE] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [sym_bool] = ACTIONS(3942),
    [sym_unit] = ACTIONS(3940),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3942),
    [sym_op_identifier] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS_DOT] = ACTIONS(3942),
    [anon_sym_DASH_DOT] = ACTIONS(3942),
    [anon_sym_PERCENT] = ACTIONS(3942),
    [anon_sym_AMP_AMP] = ACTIONS(3942),
    [anon_sym_TILDE] = ACTIONS(3940),
    [aux_sym_prefix_op_token1] = ACTIONS(3942),
    [aux_sym_infix_op_token1] = ACTIONS(3940),
    [aux_sym_infix_op_token2] = ACTIONS(3942),
    [anon_sym_PIPE_PIPE] = ACTIONS(3942),
    [anon_sym_BANG_EQ] = ACTIONS(3942),
    [anon_sym_COLON_EQ] = ACTIONS(3940),
    [anon_sym_DOLLAR] = ACTIONS(3942),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3942),
    [sym_int] = ACTIONS(3942),
    [sym_xint] = ACTIONS(3940),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3940),
    [sym__newline] = ACTIONS(3940),
  },
  [2533] = {
    [sym_block_comment] = STATE(2533),
    [sym_compiler_directive_decl] = STATE(2533),
    [sym_fsi_directive_decl] = STATE(2533),
    [sym_preproc_line] = STATE(2533),
    [sym_identifier] = ACTIONS(3931),
    [anon_sym_EQ] = ACTIONS(3929),
    [anon_sym_GT_RBRACK] = ACTIONS(3929),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_do] = ACTIONS(3931),
    [anon_sym_let] = ACTIONS(3931),
    [anon_sym_let_BANG] = ACTIONS(3929),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_COMMA] = ACTIONS(3929),
    [anon_sym_null] = ACTIONS(3931),
    [anon_sym_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_COLON] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3931),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_RBRACK] = ACTIONS(3929),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_RBRACE] = ACTIONS(3929),
    [anon_sym_LT_AT] = ACTIONS(3931),
    [anon_sym_LT_AT_AT] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3931),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3929),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3931),
    [anon_sym_return_BANG] = ACTIONS(3929),
    [anon_sym_yield] = ACTIONS(3931),
    [anon_sym_yield_BANG] = ACTIONS(3929),
    [anon_sym_lazy] = ACTIONS(3931),
    [anon_sym_assert] = ACTIONS(3931),
    [anon_sym_upcast] = ACTIONS(3931),
    [anon_sym_downcast] = ACTIONS(3931),
    [anon_sym_COLON_GT] = ACTIONS(3929),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3929),
    [anon_sym_for] = ACTIONS(3931),
    [anon_sym_to] = ACTIONS(3931),
    [anon_sym_downto] = ACTIONS(3931),
    [anon_sym_while] = ACTIONS(3931),
    [anon_sym_if] = ACTIONS(3931),
    [anon_sym_fun] = ACTIONS(3931),
    [anon_sym_try] = ACTIONS(3931),
    [anon_sym_match] = ACTIONS(3931),
    [anon_sym_match_BANG] = ACTIONS(3929),
    [anon_sym_function] = ACTIONS(3931),
    [anon_sym_LT_DASH] = ACTIONS(3931),
    [anon_sym_DOT_LBRACK] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_use] = ACTIONS(3931),
    [anon_sym_use_BANG] = ACTIONS(3929),
    [anon_sym_do_BANG] = ACTIONS(3929),
    [anon_sym_begin] = ACTIONS(3931),
    [anon_sym_LPAREN2] = ACTIONS(3931),
    [anon_sym_DOT_DOT2] = ACTIONS(3929),
    [anon_sym_or] = ACTIONS(3931),
    [aux_sym_char_token1] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3931),
    [anon_sym_DQUOTE] = ACTIONS(3931),
    [anon_sym_AT_DQUOTE] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [sym_bool] = ACTIONS(3931),
    [sym_unit] = ACTIONS(3929),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3931),
    [sym_op_identifier] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3931),
    [anon_sym_DASH] = ACTIONS(3931),
    [anon_sym_PLUS_DOT] = ACTIONS(3931),
    [anon_sym_DASH_DOT] = ACTIONS(3931),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_TILDE] = ACTIONS(3929),
    [aux_sym_prefix_op_token1] = ACTIONS(3931),
    [aux_sym_infix_op_token1] = ACTIONS(3929),
    [aux_sym_infix_op_token2] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_COLON_EQ] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3931),
    [sym_int] = ACTIONS(3931),
    [sym_xint] = ACTIONS(3929),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3929),
    [sym__newline] = ACTIONS(3929),
  },
  [2534] = {
    [sym_block_comment] = STATE(2534),
    [sym_compiler_directive_decl] = STATE(2534),
    [sym_fsi_directive_decl] = STATE(2534),
    [sym_preproc_line] = STATE(2534),
    [sym_identifier] = ACTIONS(3917),
    [anon_sym_EQ] = ACTIONS(3915),
    [anon_sym_GT_RBRACK] = ACTIONS(3915),
    [anon_sym_COLON] = ACTIONS(3917),
    [anon_sym_return] = ACTIONS(3917),
    [anon_sym_do] = ACTIONS(3917),
    [anon_sym_let] = ACTIONS(3917),
    [anon_sym_let_BANG] = ACTIONS(3915),
    [anon_sym_LPAREN] = ACTIONS(3917),
    [anon_sym_COMMA] = ACTIONS(3915),
    [anon_sym_null] = ACTIONS(3917),
    [anon_sym_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_COLON] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(3917),
    [anon_sym_RBRACK] = ACTIONS(3915),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3915),
    [anon_sym_LBRACE] = ACTIONS(3917),
    [anon_sym_RBRACE] = ACTIONS(3915),
    [anon_sym_LT_AT] = ACTIONS(3917),
    [anon_sym_LT_AT_AT] = ACTIONS(3917),
    [anon_sym_DOT] = ACTIONS(3917),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3915),
    [anon_sym_new] = ACTIONS(3917),
    [anon_sym_with] = ACTIONS(3917),
    [anon_sym_return_BANG] = ACTIONS(3915),
    [anon_sym_yield] = ACTIONS(3917),
    [anon_sym_yield_BANG] = ACTIONS(3915),
    [anon_sym_lazy] = ACTIONS(3917),
    [anon_sym_assert] = ACTIONS(3917),
    [anon_sym_upcast] = ACTIONS(3917),
    [anon_sym_downcast] = ACTIONS(3917),
    [anon_sym_COLON_GT] = ACTIONS(3915),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3915),
    [anon_sym_for] = ACTIONS(3917),
    [anon_sym_to] = ACTIONS(3917),
    [anon_sym_downto] = ACTIONS(3917),
    [anon_sym_while] = ACTIONS(3917),
    [anon_sym_if] = ACTIONS(3917),
    [anon_sym_fun] = ACTIONS(3917),
    [anon_sym_try] = ACTIONS(3917),
    [anon_sym_match] = ACTIONS(3917),
    [anon_sym_match_BANG] = ACTIONS(3915),
    [anon_sym_function] = ACTIONS(3917),
    [anon_sym_LT_DASH] = ACTIONS(3917),
    [anon_sym_DOT_LBRACK] = ACTIONS(3915),
    [anon_sym_LT] = ACTIONS(3915),
    [anon_sym_use] = ACTIONS(3917),
    [anon_sym_use_BANG] = ACTIONS(3915),
    [anon_sym_do_BANG] = ACTIONS(3915),
    [anon_sym_begin] = ACTIONS(3917),
    [anon_sym_LPAREN2] = ACTIONS(3917),
    [anon_sym_DOT_DOT2] = ACTIONS(3915),
    [anon_sym_or] = ACTIONS(3917),
    [aux_sym_char_token1] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_AT_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [sym_bool] = ACTIONS(3917),
    [sym_unit] = ACTIONS(3915),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3917),
    [sym_op_identifier] = ACTIONS(3917),
    [anon_sym_PLUS] = ACTIONS(3917),
    [anon_sym_DASH] = ACTIONS(3917),
    [anon_sym_PLUS_DOT] = ACTIONS(3917),
    [anon_sym_DASH_DOT] = ACTIONS(3917),
    [anon_sym_PERCENT] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_TILDE] = ACTIONS(3915),
    [aux_sym_prefix_op_token1] = ACTIONS(3917),
    [aux_sym_infix_op_token1] = ACTIONS(3915),
    [aux_sym_infix_op_token2] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_BANG_EQ] = ACTIONS(3917),
    [anon_sym_COLON_EQ] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3917),
    [sym_int] = ACTIONS(3917),
    [sym_xint] = ACTIONS(3915),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3915),
    [sym__newline] = ACTIONS(3915),
  },
  [2535] = {
    [sym_block_comment] = STATE(2535),
    [sym_compiler_directive_decl] = STATE(2535),
    [sym_fsi_directive_decl] = STATE(2535),
    [sym_preproc_line] = STATE(2535),
    [aux_sym_long_identifier_repeat1] = STATE(2535),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_as] = ACTIONS(3487),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(4987),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [2536] = {
    [sym_block_comment] = STATE(2536),
    [sym_compiler_directive_decl] = STATE(2536),
    [sym_fsi_directive_decl] = STATE(2536),
    [sym_preproc_line] = STATE(2536),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [anon_sym_as] = ACTIONS(3480),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_COLON] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_with] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_LT_DASH] = ACTIONS(3480),
    [anon_sym_DOT_LBRACK] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_or] = ACTIONS(3480),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3480),
    [anon_sym_DASH_DOT] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3480),
    [aux_sym_infix_op_token1] = ACTIONS(3478),
    [aux_sym_infix_op_token2] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3480),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
    [sym__dedent] = ACTIONS(3478),
  },
  [2537] = {
    [sym_block_comment] = STATE(2537),
    [sym_compiler_directive_decl] = STATE(2537),
    [sym_fsi_directive_decl] = STATE(2537),
    [sym_preproc_line] = STATE(2537),
    [sym_identifier] = ACTIONS(3907),
    [anon_sym_EQ] = ACTIONS(3905),
    [anon_sym_GT_RBRACK] = ACTIONS(3905),
    [anon_sym_COLON] = ACTIONS(3907),
    [anon_sym_return] = ACTIONS(3907),
    [anon_sym_do] = ACTIONS(3907),
    [anon_sym_let] = ACTIONS(3907),
    [anon_sym_let_BANG] = ACTIONS(3905),
    [anon_sym_LPAREN] = ACTIONS(3907),
    [anon_sym_COMMA] = ACTIONS(3905),
    [anon_sym_null] = ACTIONS(3907),
    [anon_sym_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_COLON] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3907),
    [anon_sym_RBRACK] = ACTIONS(3905),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3905),
    [anon_sym_LBRACE] = ACTIONS(3907),
    [anon_sym_RBRACE] = ACTIONS(3905),
    [anon_sym_LT_AT] = ACTIONS(3907),
    [anon_sym_LT_AT_AT] = ACTIONS(3907),
    [anon_sym_DOT] = ACTIONS(3907),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3905),
    [anon_sym_new] = ACTIONS(3907),
    [anon_sym_with] = ACTIONS(3907),
    [anon_sym_return_BANG] = ACTIONS(3905),
    [anon_sym_yield] = ACTIONS(3907),
    [anon_sym_yield_BANG] = ACTIONS(3905),
    [anon_sym_lazy] = ACTIONS(3907),
    [anon_sym_assert] = ACTIONS(3907),
    [anon_sym_upcast] = ACTIONS(3907),
    [anon_sym_downcast] = ACTIONS(3907),
    [anon_sym_COLON_GT] = ACTIONS(3905),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3905),
    [anon_sym_for] = ACTIONS(3907),
    [anon_sym_to] = ACTIONS(3907),
    [anon_sym_downto] = ACTIONS(3907),
    [anon_sym_while] = ACTIONS(3907),
    [anon_sym_if] = ACTIONS(3907),
    [anon_sym_fun] = ACTIONS(3907),
    [anon_sym_try] = ACTIONS(3907),
    [anon_sym_match] = ACTIONS(3907),
    [anon_sym_match_BANG] = ACTIONS(3905),
    [anon_sym_function] = ACTIONS(3907),
    [anon_sym_LT_DASH] = ACTIONS(3907),
    [anon_sym_DOT_LBRACK] = ACTIONS(3905),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_use] = ACTIONS(3907),
    [anon_sym_use_BANG] = ACTIONS(3905),
    [anon_sym_do_BANG] = ACTIONS(3905),
    [anon_sym_begin] = ACTIONS(3907),
    [anon_sym_LPAREN2] = ACTIONS(3907),
    [anon_sym_DOT_DOT2] = ACTIONS(3905),
    [anon_sym_or] = ACTIONS(3907),
    [aux_sym_char_token1] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3907),
    [anon_sym_DQUOTE] = ACTIONS(3907),
    [anon_sym_AT_DQUOTE] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [sym_bool] = ACTIONS(3907),
    [sym_unit] = ACTIONS(3905),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3907),
    [sym_op_identifier] = ACTIONS(3907),
    [anon_sym_PLUS] = ACTIONS(3907),
    [anon_sym_DASH] = ACTIONS(3907),
    [anon_sym_PLUS_DOT] = ACTIONS(3907),
    [anon_sym_DASH_DOT] = ACTIONS(3907),
    [anon_sym_PERCENT] = ACTIONS(3907),
    [anon_sym_AMP_AMP] = ACTIONS(3907),
    [anon_sym_TILDE] = ACTIONS(3905),
    [aux_sym_prefix_op_token1] = ACTIONS(3907),
    [aux_sym_infix_op_token1] = ACTIONS(3905),
    [aux_sym_infix_op_token2] = ACTIONS(3907),
    [anon_sym_PIPE_PIPE] = ACTIONS(3907),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_COLON_EQ] = ACTIONS(3905),
    [anon_sym_DOLLAR] = ACTIONS(3907),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3907),
    [sym_int] = ACTIONS(3907),
    [sym_xint] = ACTIONS(3905),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3905),
    [sym__newline] = ACTIONS(3905),
  },
  [2538] = {
    [sym_block_comment] = STATE(2538),
    [sym_compiler_directive_decl] = STATE(2538),
    [sym_fsi_directive_decl] = STATE(2538),
    [sym_preproc_line] = STATE(2538),
    [sym_identifier] = ACTIONS(3889),
    [anon_sym_EQ] = ACTIONS(3887),
    [anon_sym_GT_RBRACK] = ACTIONS(3887),
    [anon_sym_COLON] = ACTIONS(3889),
    [anon_sym_return] = ACTIONS(3889),
    [anon_sym_do] = ACTIONS(3889),
    [anon_sym_let] = ACTIONS(3889),
    [anon_sym_let_BANG] = ACTIONS(3887),
    [anon_sym_LPAREN] = ACTIONS(3889),
    [anon_sym_COMMA] = ACTIONS(3887),
    [anon_sym_null] = ACTIONS(3889),
    [anon_sym_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_COLON] = ACTIONS(3887),
    [anon_sym_AMP] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [anon_sym_RBRACK] = ACTIONS(3887),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3887),
    [anon_sym_LBRACE] = ACTIONS(3889),
    [anon_sym_RBRACE] = ACTIONS(3887),
    [anon_sym_LT_AT] = ACTIONS(3889),
    [anon_sym_LT_AT_AT] = ACTIONS(3889),
    [anon_sym_DOT] = ACTIONS(3889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [anon_sym_new] = ACTIONS(3889),
    [anon_sym_with] = ACTIONS(3889),
    [anon_sym_return_BANG] = ACTIONS(3887),
    [anon_sym_yield] = ACTIONS(3889),
    [anon_sym_yield_BANG] = ACTIONS(3887),
    [anon_sym_lazy] = ACTIONS(3889),
    [anon_sym_assert] = ACTIONS(3889),
    [anon_sym_upcast] = ACTIONS(3889),
    [anon_sym_downcast] = ACTIONS(3889),
    [anon_sym_COLON_GT] = ACTIONS(3887),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3887),
    [anon_sym_for] = ACTIONS(3889),
    [anon_sym_to] = ACTIONS(3889),
    [anon_sym_downto] = ACTIONS(3889),
    [anon_sym_while] = ACTIONS(3889),
    [anon_sym_if] = ACTIONS(3889),
    [anon_sym_fun] = ACTIONS(3889),
    [anon_sym_try] = ACTIONS(3889),
    [anon_sym_match] = ACTIONS(3889),
    [anon_sym_match_BANG] = ACTIONS(3887),
    [anon_sym_function] = ACTIONS(3889),
    [anon_sym_LT_DASH] = ACTIONS(3889),
    [anon_sym_DOT_LBRACK] = ACTIONS(3887),
    [anon_sym_LT] = ACTIONS(3887),
    [anon_sym_use] = ACTIONS(3889),
    [anon_sym_use_BANG] = ACTIONS(3887),
    [anon_sym_do_BANG] = ACTIONS(3887),
    [anon_sym_begin] = ACTIONS(3889),
    [anon_sym_LPAREN2] = ACTIONS(3889),
    [anon_sym_DOT_DOT2] = ACTIONS(3887),
    [anon_sym_or] = ACTIONS(3889),
    [aux_sym_char_token1] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3889),
    [anon_sym_DQUOTE] = ACTIONS(3889),
    [anon_sym_AT_DQUOTE] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [sym_bool] = ACTIONS(3889),
    [sym_unit] = ACTIONS(3887),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3889),
    [sym_op_identifier] = ACTIONS(3889),
    [anon_sym_PLUS] = ACTIONS(3889),
    [anon_sym_DASH] = ACTIONS(3889),
    [anon_sym_PLUS_DOT] = ACTIONS(3889),
    [anon_sym_DASH_DOT] = ACTIONS(3889),
    [anon_sym_PERCENT] = ACTIONS(3889),
    [anon_sym_AMP_AMP] = ACTIONS(3889),
    [anon_sym_TILDE] = ACTIONS(3887),
    [aux_sym_prefix_op_token1] = ACTIONS(3889),
    [aux_sym_infix_op_token1] = ACTIONS(3887),
    [aux_sym_infix_op_token2] = ACTIONS(3889),
    [anon_sym_PIPE_PIPE] = ACTIONS(3889),
    [anon_sym_BANG_EQ] = ACTIONS(3889),
    [anon_sym_COLON_EQ] = ACTIONS(3887),
    [anon_sym_DOLLAR] = ACTIONS(3889),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3889),
    [sym_int] = ACTIONS(3889),
    [sym_xint] = ACTIONS(3887),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3887),
    [sym__newline] = ACTIONS(3887),
  },
  [2539] = {
    [sym__else_expression] = STATE(2980),
    [sym_elif_expression] = STATE(2768),
    [sym_block_comment] = STATE(2539),
    [sym_compiler_directive_decl] = STATE(2539),
    [sym_fsi_directive_decl] = STATE(2539),
    [sym_preproc_line] = STATE(2539),
    [aux_sym_if_expression_repeat1] = STATE(2472),
    [sym_identifier] = ACTIONS(3472),
    [anon_sym_EQ] = ACTIONS(3470),
    [anon_sym_COLON] = ACTIONS(3472),
    [anon_sym_return] = ACTIONS(3472),
    [anon_sym_do] = ACTIONS(3472),
    [anon_sym_let] = ACTIONS(3472),
    [anon_sym_let_BANG] = ACTIONS(3470),
    [anon_sym_as] = ACTIONS(3472),
    [anon_sym_LPAREN] = ACTIONS(3472),
    [anon_sym_COMMA] = ACTIONS(3470),
    [anon_sym_null] = ACTIONS(3472),
    [anon_sym_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_COLON] = ACTIONS(3470),
    [anon_sym_AMP] = ACTIONS(3472),
    [anon_sym_LBRACK] = ACTIONS(3472),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3470),
    [anon_sym_LBRACE] = ACTIONS(3472),
    [anon_sym_LT_AT] = ACTIONS(3472),
    [anon_sym_LT_AT_AT] = ACTIONS(3472),
    [anon_sym_DOT] = ACTIONS(3472),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3470),
    [anon_sym_new] = ACTIONS(3472),
    [anon_sym_with] = ACTIONS(3472),
    [anon_sym_return_BANG] = ACTIONS(3470),
    [anon_sym_yield] = ACTIONS(3472),
    [anon_sym_yield_BANG] = ACTIONS(3470),
    [anon_sym_lazy] = ACTIONS(3472),
    [anon_sym_assert] = ACTIONS(3472),
    [anon_sym_upcast] = ACTIONS(3472),
    [anon_sym_downcast] = ACTIONS(3472),
    [anon_sym_COLON_GT] = ACTIONS(3470),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3470),
    [anon_sym_for] = ACTIONS(3472),
    [anon_sym_while] = ACTIONS(3472),
    [anon_sym_else] = ACTIONS(4977),
    [anon_sym_elif] = ACTIONS(4979),
    [anon_sym_if] = ACTIONS(3472),
    [anon_sym_fun] = ACTIONS(3472),
    [anon_sym_try] = ACTIONS(3472),
    [anon_sym_match] = ACTIONS(3472),
    [anon_sym_match_BANG] = ACTIONS(3470),
    [anon_sym_function] = ACTIONS(3472),
    [anon_sym_LT_DASH] = ACTIONS(3472),
    [anon_sym_DOT_LBRACK] = ACTIONS(3470),
    [anon_sym_LT] = ACTIONS(3470),
    [anon_sym_use] = ACTIONS(3472),
    [anon_sym_use_BANG] = ACTIONS(3470),
    [anon_sym_do_BANG] = ACTIONS(3470),
    [anon_sym_begin] = ACTIONS(3472),
    [anon_sym_LPAREN2] = ACTIONS(3472),
    [anon_sym_or] = ACTIONS(3472),
    [aux_sym_char_token1] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3472),
    [anon_sym_DQUOTE] = ACTIONS(3472),
    [anon_sym_AT_DQUOTE] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [sym_bool] = ACTIONS(3472),
    [sym_unit] = ACTIONS(3470),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3472),
    [sym_op_identifier] = ACTIONS(3472),
    [anon_sym_PLUS] = ACTIONS(3472),
    [anon_sym_DASH] = ACTIONS(3472),
    [anon_sym_PLUS_DOT] = ACTIONS(3472),
    [anon_sym_DASH_DOT] = ACTIONS(3472),
    [anon_sym_PERCENT] = ACTIONS(3472),
    [anon_sym_AMP_AMP] = ACTIONS(3472),
    [anon_sym_TILDE] = ACTIONS(3470),
    [aux_sym_prefix_op_token1] = ACTIONS(3472),
    [aux_sym_infix_op_token1] = ACTIONS(3470),
    [aux_sym_infix_op_token2] = ACTIONS(3472),
    [anon_sym_PIPE_PIPE] = ACTIONS(3472),
    [anon_sym_BANG_EQ] = ACTIONS(3472),
    [anon_sym_COLON_EQ] = ACTIONS(3470),
    [anon_sym_DOLLAR] = ACTIONS(3472),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3472),
    [sym_int] = ACTIONS(3472),
    [sym_xint] = ACTIONS(3470),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3470),
    [sym__newline] = ACTIONS(3470),
  },
  [2540] = {
    [sym__else_expression] = STATE(3039),
    [sym_elif_expression] = STATE(2749),
    [sym_block_comment] = STATE(2540),
    [sym_compiler_directive_decl] = STATE(2540),
    [sym_fsi_directive_decl] = STATE(2540),
    [sym_preproc_line] = STATE(2540),
    [aux_sym_if_expression_repeat1] = STATE(2553),
    [sym_identifier] = ACTIONS(3457),
    [anon_sym_EQ] = ACTIONS(3455),
    [anon_sym_COLON] = ACTIONS(3457),
    [anon_sym_return] = ACTIONS(3457),
    [anon_sym_do] = ACTIONS(3457),
    [anon_sym_let] = ACTIONS(3457),
    [anon_sym_let_BANG] = ACTIONS(3455),
    [anon_sym_LPAREN] = ACTIONS(3457),
    [anon_sym_COMMA] = ACTIONS(3455),
    [anon_sym_null] = ACTIONS(3457),
    [anon_sym_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_COLON] = ACTIONS(3455),
    [anon_sym_AMP] = ACTIONS(3457),
    [anon_sym_LBRACK] = ACTIONS(3457),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3457),
    [anon_sym_LT_AT] = ACTIONS(3457),
    [anon_sym_LT_AT_AT] = ACTIONS(3457),
    [anon_sym_DOT] = ACTIONS(3457),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3457),
    [anon_sym_return_BANG] = ACTIONS(3455),
    [anon_sym_yield] = ACTIONS(3457),
    [anon_sym_yield_BANG] = ACTIONS(3455),
    [anon_sym_lazy] = ACTIONS(3457),
    [anon_sym_assert] = ACTIONS(3457),
    [anon_sym_upcast] = ACTIONS(3457),
    [anon_sym_downcast] = ACTIONS(3457),
    [anon_sym_COLON_GT] = ACTIONS(3455),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3457),
    [anon_sym_while] = ACTIONS(3457),
    [anon_sym_else] = ACTIONS(4983),
    [anon_sym_elif] = ACTIONS(4985),
    [anon_sym_if] = ACTIONS(3457),
    [anon_sym_fun] = ACTIONS(3457),
    [anon_sym_DASH_GT] = ACTIONS(3457),
    [anon_sym_try] = ACTIONS(3457),
    [anon_sym_match] = ACTIONS(3457),
    [anon_sym_match_BANG] = ACTIONS(3455),
    [anon_sym_function] = ACTIONS(3457),
    [anon_sym_LT_DASH] = ACTIONS(3457),
    [anon_sym_DOT_LBRACK] = ACTIONS(3455),
    [anon_sym_LT] = ACTIONS(3455),
    [anon_sym_use] = ACTIONS(3457),
    [anon_sym_use_BANG] = ACTIONS(3455),
    [anon_sym_do_BANG] = ACTIONS(3455),
    [anon_sym_DOT_DOT] = ACTIONS(3455),
    [anon_sym_begin] = ACTIONS(3457),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_or] = ACTIONS(3457),
    [aux_sym_char_token1] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [anon_sym_AT_DQUOTE] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [sym_bool] = ACTIONS(3457),
    [sym_unit] = ACTIONS(3455),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3457),
    [sym_op_identifier] = ACTIONS(3457),
    [anon_sym_PLUS] = ACTIONS(3457),
    [anon_sym_DASH] = ACTIONS(3457),
    [anon_sym_PLUS_DOT] = ACTIONS(3457),
    [anon_sym_DASH_DOT] = ACTIONS(3457),
    [anon_sym_PERCENT] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3455),
    [aux_sym_prefix_op_token1] = ACTIONS(3457),
    [aux_sym_infix_op_token1] = ACTIONS(3455),
    [aux_sym_infix_op_token2] = ACTIONS(3457),
    [anon_sym_PIPE_PIPE] = ACTIONS(3457),
    [anon_sym_BANG_EQ] = ACTIONS(3457),
    [anon_sym_COLON_EQ] = ACTIONS(3455),
    [anon_sym_DOLLAR] = ACTIONS(3457),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3457),
    [sym_int] = ACTIONS(3457),
    [sym_xint] = ACTIONS(3455),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3455),
    [sym__newline] = ACTIONS(3455),
  },
  [2541] = {
    [sym_block_comment] = STATE(2541),
    [sym_compiler_directive_decl] = STATE(2541),
    [sym_fsi_directive_decl] = STATE(2541),
    [sym_preproc_line] = STATE(2541),
    [sym_identifier] = ACTIONS(3900),
    [anon_sym_EQ] = ACTIONS(3898),
    [anon_sym_GT_RBRACK] = ACTIONS(3898),
    [anon_sym_COLON] = ACTIONS(3900),
    [anon_sym_return] = ACTIONS(3900),
    [anon_sym_do] = ACTIONS(3900),
    [anon_sym_let] = ACTIONS(3900),
    [anon_sym_let_BANG] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3898),
    [anon_sym_null] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_COLON] = ACTIONS(3898),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_LBRACK] = ACTIONS(3900),
    [anon_sym_RBRACK] = ACTIONS(3898),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3898),
    [anon_sym_LBRACE] = ACTIONS(3900),
    [anon_sym_RBRACE] = ACTIONS(3898),
    [anon_sym_LT_AT] = ACTIONS(3900),
    [anon_sym_LT_AT_AT] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(3900),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3898),
    [anon_sym_new] = ACTIONS(3900),
    [anon_sym_with] = ACTIONS(3900),
    [anon_sym_return_BANG] = ACTIONS(3898),
    [anon_sym_yield] = ACTIONS(3900),
    [anon_sym_yield_BANG] = ACTIONS(3898),
    [anon_sym_lazy] = ACTIONS(3900),
    [anon_sym_assert] = ACTIONS(3900),
    [anon_sym_upcast] = ACTIONS(3900),
    [anon_sym_downcast] = ACTIONS(3900),
    [anon_sym_COLON_GT] = ACTIONS(3898),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3898),
    [anon_sym_for] = ACTIONS(3900),
    [anon_sym_to] = ACTIONS(3900),
    [anon_sym_downto] = ACTIONS(3900),
    [anon_sym_while] = ACTIONS(3900),
    [anon_sym_if] = ACTIONS(3900),
    [anon_sym_fun] = ACTIONS(3900),
    [anon_sym_try] = ACTIONS(3900),
    [anon_sym_match] = ACTIONS(3900),
    [anon_sym_match_BANG] = ACTIONS(3898),
    [anon_sym_function] = ACTIONS(3900),
    [anon_sym_LT_DASH] = ACTIONS(3900),
    [anon_sym_DOT_LBRACK] = ACTIONS(3898),
    [anon_sym_LT] = ACTIONS(3898),
    [anon_sym_use] = ACTIONS(3900),
    [anon_sym_use_BANG] = ACTIONS(3898),
    [anon_sym_do_BANG] = ACTIONS(3898),
    [anon_sym_begin] = ACTIONS(3900),
    [anon_sym_LPAREN2] = ACTIONS(3900),
    [anon_sym_DOT_DOT2] = ACTIONS(3898),
    [anon_sym_or] = ACTIONS(3900),
    [aux_sym_char_token1] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3900),
    [anon_sym_DQUOTE] = ACTIONS(3900),
    [anon_sym_AT_DQUOTE] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3898),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3900),
    [sym_op_identifier] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(3900),
    [anon_sym_DASH] = ACTIONS(3900),
    [anon_sym_PLUS_DOT] = ACTIONS(3900),
    [anon_sym_DASH_DOT] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(3900),
    [anon_sym_AMP_AMP] = ACTIONS(3900),
    [anon_sym_TILDE] = ACTIONS(3898),
    [aux_sym_prefix_op_token1] = ACTIONS(3900),
    [aux_sym_infix_op_token1] = ACTIONS(3898),
    [aux_sym_infix_op_token2] = ACTIONS(3900),
    [anon_sym_PIPE_PIPE] = ACTIONS(3900),
    [anon_sym_BANG_EQ] = ACTIONS(3900),
    [anon_sym_COLON_EQ] = ACTIONS(3898),
    [anon_sym_DOLLAR] = ACTIONS(3900),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3900),
    [sym_int] = ACTIONS(3900),
    [sym_xint] = ACTIONS(3898),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3898),
    [sym__newline] = ACTIONS(3898),
  },
  [2542] = {
    [sym_block_comment] = STATE(2542),
    [sym_compiler_directive_decl] = STATE(2542),
    [sym_fsi_directive_decl] = STATE(2542),
    [sym_preproc_line] = STATE(2542),
    [sym_identifier] = ACTIONS(3893),
    [anon_sym_EQ] = ACTIONS(3891),
    [anon_sym_GT_RBRACK] = ACTIONS(3891),
    [anon_sym_COLON] = ACTIONS(3893),
    [anon_sym_return] = ACTIONS(3893),
    [anon_sym_do] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_let_BANG] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_COMMA] = ACTIONS(3891),
    [anon_sym_null] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_COLON] = ACTIONS(3891),
    [anon_sym_AMP] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_RBRACK] = ACTIONS(3891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3891),
    [anon_sym_LBRACE] = ACTIONS(3893),
    [anon_sym_RBRACE] = ACTIONS(3891),
    [anon_sym_LT_AT] = ACTIONS(3893),
    [anon_sym_LT_AT_AT] = ACTIONS(3893),
    [anon_sym_DOT] = ACTIONS(3893),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3891),
    [anon_sym_new] = ACTIONS(3893),
    [anon_sym_with] = ACTIONS(3893),
    [anon_sym_return_BANG] = ACTIONS(3891),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_yield_BANG] = ACTIONS(3891),
    [anon_sym_lazy] = ACTIONS(3893),
    [anon_sym_assert] = ACTIONS(3893),
    [anon_sym_upcast] = ACTIONS(3893),
    [anon_sym_downcast] = ACTIONS(3893),
    [anon_sym_COLON_GT] = ACTIONS(3891),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3891),
    [anon_sym_for] = ACTIONS(3893),
    [anon_sym_to] = ACTIONS(3893),
    [anon_sym_downto] = ACTIONS(3893),
    [anon_sym_while] = ACTIONS(3893),
    [anon_sym_if] = ACTIONS(3893),
    [anon_sym_fun] = ACTIONS(3893),
    [anon_sym_try] = ACTIONS(3893),
    [anon_sym_match] = ACTIONS(3893),
    [anon_sym_match_BANG] = ACTIONS(3891),
    [anon_sym_function] = ACTIONS(3893),
    [anon_sym_LT_DASH] = ACTIONS(3893),
    [anon_sym_DOT_LBRACK] = ACTIONS(3891),
    [anon_sym_LT] = ACTIONS(3891),
    [anon_sym_use] = ACTIONS(3893),
    [anon_sym_use_BANG] = ACTIONS(3891),
    [anon_sym_do_BANG] = ACTIONS(3891),
    [anon_sym_begin] = ACTIONS(3893),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_DOT_DOT2] = ACTIONS(3891),
    [anon_sym_or] = ACTIONS(3893),
    [aux_sym_char_token1] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3893),
    [anon_sym_DQUOTE] = ACTIONS(3893),
    [anon_sym_AT_DQUOTE] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [sym_bool] = ACTIONS(3893),
    [sym_unit] = ACTIONS(3891),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3893),
    [sym_op_identifier] = ACTIONS(3893),
    [anon_sym_PLUS] = ACTIONS(3893),
    [anon_sym_DASH] = ACTIONS(3893),
    [anon_sym_PLUS_DOT] = ACTIONS(3893),
    [anon_sym_DASH_DOT] = ACTIONS(3893),
    [anon_sym_PERCENT] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_TILDE] = ACTIONS(3891),
    [aux_sym_prefix_op_token1] = ACTIONS(3893),
    [aux_sym_infix_op_token1] = ACTIONS(3891),
    [aux_sym_infix_op_token2] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [anon_sym_BANG_EQ] = ACTIONS(3893),
    [anon_sym_COLON_EQ] = ACTIONS(3891),
    [anon_sym_DOLLAR] = ACTIONS(3893),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3893),
    [sym_int] = ACTIONS(3893),
    [sym_xint] = ACTIONS(3891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3891),
    [sym__newline] = ACTIONS(3891),
  },
  [2543] = {
    [sym_block_comment] = STATE(2543),
    [sym_compiler_directive_decl] = STATE(2543),
    [sym_fsi_directive_decl] = STATE(2543),
    [sym_preproc_line] = STATE(2543),
    [sym_identifier] = ACTIONS(3875),
    [anon_sym_EQ] = ACTIONS(3873),
    [anon_sym_GT_RBRACK] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(3875),
    [anon_sym_return] = ACTIONS(3875),
    [anon_sym_do] = ACTIONS(3875),
    [anon_sym_let] = ACTIONS(3875),
    [anon_sym_let_BANG] = ACTIONS(3873),
    [anon_sym_LPAREN] = ACTIONS(3875),
    [anon_sym_COMMA] = ACTIONS(3873),
    [anon_sym_null] = ACTIONS(3875),
    [anon_sym_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_COLON] = ACTIONS(3873),
    [anon_sym_AMP] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(3875),
    [anon_sym_RBRACK] = ACTIONS(3873),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3873),
    [anon_sym_LBRACE] = ACTIONS(3875),
    [anon_sym_RBRACE] = ACTIONS(3873),
    [anon_sym_LT_AT] = ACTIONS(3875),
    [anon_sym_LT_AT_AT] = ACTIONS(3875),
    [anon_sym_DOT] = ACTIONS(3875),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3873),
    [anon_sym_new] = ACTIONS(3875),
    [anon_sym_with] = ACTIONS(3875),
    [anon_sym_return_BANG] = ACTIONS(3873),
    [anon_sym_yield] = ACTIONS(3875),
    [anon_sym_yield_BANG] = ACTIONS(3873),
    [anon_sym_lazy] = ACTIONS(3875),
    [anon_sym_assert] = ACTIONS(3875),
    [anon_sym_upcast] = ACTIONS(3875),
    [anon_sym_downcast] = ACTIONS(3875),
    [anon_sym_COLON_GT] = ACTIONS(3873),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3873),
    [anon_sym_for] = ACTIONS(3875),
    [anon_sym_to] = ACTIONS(3875),
    [anon_sym_downto] = ACTIONS(3875),
    [anon_sym_while] = ACTIONS(3875),
    [anon_sym_if] = ACTIONS(3875),
    [anon_sym_fun] = ACTIONS(3875),
    [anon_sym_try] = ACTIONS(3875),
    [anon_sym_match] = ACTIONS(3875),
    [anon_sym_match_BANG] = ACTIONS(3873),
    [anon_sym_function] = ACTIONS(3875),
    [anon_sym_LT_DASH] = ACTIONS(3875),
    [anon_sym_DOT_LBRACK] = ACTIONS(3873),
    [anon_sym_LT] = ACTIONS(3873),
    [anon_sym_use] = ACTIONS(3875),
    [anon_sym_use_BANG] = ACTIONS(3873),
    [anon_sym_do_BANG] = ACTIONS(3873),
    [anon_sym_begin] = ACTIONS(3875),
    [anon_sym_LPAREN2] = ACTIONS(3875),
    [anon_sym_DOT_DOT2] = ACTIONS(3873),
    [anon_sym_or] = ACTIONS(3875),
    [aux_sym_char_token1] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3875),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [anon_sym_AT_DQUOTE] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [sym_bool] = ACTIONS(3875),
    [sym_unit] = ACTIONS(3873),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3875),
    [sym_op_identifier] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS_DOT] = ACTIONS(3875),
    [anon_sym_DASH_DOT] = ACTIONS(3875),
    [anon_sym_PERCENT] = ACTIONS(3875),
    [anon_sym_AMP_AMP] = ACTIONS(3875),
    [anon_sym_TILDE] = ACTIONS(3873),
    [aux_sym_prefix_op_token1] = ACTIONS(3875),
    [aux_sym_infix_op_token1] = ACTIONS(3873),
    [aux_sym_infix_op_token2] = ACTIONS(3875),
    [anon_sym_PIPE_PIPE] = ACTIONS(3875),
    [anon_sym_BANG_EQ] = ACTIONS(3875),
    [anon_sym_COLON_EQ] = ACTIONS(3873),
    [anon_sym_DOLLAR] = ACTIONS(3875),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3875),
    [sym_int] = ACTIONS(3875),
    [sym_xint] = ACTIONS(3873),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3873),
    [sym__newline] = ACTIONS(3873),
  },
  [2544] = {
    [sym_block_comment] = STATE(2544),
    [sym_compiler_directive_decl] = STATE(2544),
    [sym_fsi_directive_decl] = STATE(2544),
    [sym_preproc_line] = STATE(2544),
    [sym_identifier] = ACTIONS(3511),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3511),
    [anon_sym_return] = ACTIONS(3511),
    [anon_sym_do] = ACTIONS(3511),
    [anon_sym_let] = ACTIONS(3511),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_as] = ACTIONS(3511),
    [anon_sym_LPAREN] = ACTIONS(3511),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3511),
    [anon_sym_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(3511),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_LT_AT] = ACTIONS(3511),
    [anon_sym_LT_AT_AT] = ACTIONS(3511),
    [anon_sym_DOT] = ACTIONS(3511),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3511),
    [anon_sym_with] = ACTIONS(3511),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3511),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3511),
    [anon_sym_assert] = ACTIONS(3511),
    [anon_sym_upcast] = ACTIONS(3511),
    [anon_sym_downcast] = ACTIONS(3511),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3511),
    [anon_sym_while] = ACTIONS(3511),
    [anon_sym_if] = ACTIONS(3511),
    [anon_sym_fun] = ACTIONS(3511),
    [anon_sym_DASH_GT] = ACTIONS(3511),
    [anon_sym_try] = ACTIONS(3511),
    [anon_sym_match] = ACTIONS(3511),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3511),
    [anon_sym_LT_DASH] = ACTIONS(3511),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3511),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3511),
    [anon_sym_LPAREN2] = ACTIONS(3511),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_LT2] = ACTIONS(3511),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3511),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3511),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3511),
    [sym_unit] = ACTIONS(3509),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3511),
    [sym_op_identifier] = ACTIONS(3511),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3511),
    [anon_sym_PLUS_DOT] = ACTIONS(3511),
    [anon_sym_DASH_DOT] = ACTIONS(3511),
    [anon_sym_PERCENT] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3511),
    [aux_sym_infix_op_token1] = ACTIONS(3509),
    [aux_sym_infix_op_token2] = ACTIONS(3511),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_BANG_EQ] = ACTIONS(3511),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3511),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3511),
    [sym_int] = ACTIONS(3511),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
    [sym__dedent] = ACTIONS(3509),
  },
  [2545] = {
    [sym_block_comment] = STATE(2545),
    [sym_compiler_directive_decl] = STATE(2545),
    [sym_fsi_directive_decl] = STATE(2545),
    [sym_preproc_line] = STATE(2545),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [anon_sym_as] = ACTIONS(3498),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_with] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [anon_sym_DOT_LBRACK] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_or] = ACTIONS(3498),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3498),
    [anon_sym_DASH_DOT] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3498),
    [aux_sym_infix_op_token1] = ACTIONS(3496),
    [aux_sym_infix_op_token2] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_COLON_EQ] = ACTIONS(3496),
    [anon_sym_DOLLAR] = ACTIONS(3498),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3498),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
    [sym__dedent] = ACTIONS(3496),
  },
  [2546] = {
    [sym_block_comment] = STATE(2546),
    [sym_compiler_directive_decl] = STATE(2546),
    [sym_fsi_directive_decl] = STATE(2546),
    [sym_preproc_line] = STATE(2546),
    [ts_builtin_sym_end] = ACTIONS(4156),
    [sym_identifier] = ACTIONS(4158),
    [anon_sym_namespace] = ACTIONS(4158),
    [anon_sym_module] = ACTIONS(4158),
    [anon_sym_EQ] = ACTIONS(4156),
    [anon_sym_open] = ACTIONS(4158),
    [anon_sym_LBRACK_LT] = ACTIONS(4156),
    [anon_sym_COLON] = ACTIONS(4158),
    [anon_sym_return] = ACTIONS(4158),
    [anon_sym_type] = ACTIONS(4158),
    [anon_sym_do] = ACTIONS(4158),
    [anon_sym_let] = ACTIONS(4158),
    [anon_sym_let_BANG] = ACTIONS(4156),
    [anon_sym_LPAREN] = ACTIONS(4158),
    [anon_sym_COMMA] = ACTIONS(4156),
    [anon_sym_null] = ACTIONS(4158),
    [anon_sym_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_COLON] = ACTIONS(4156),
    [anon_sym_AMP] = ACTIONS(4158),
    [anon_sym_LBRACK] = ACTIONS(4158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(4158),
    [anon_sym_LT_AT] = ACTIONS(4158),
    [anon_sym_LT_AT_AT] = ACTIONS(4158),
    [anon_sym_DOT] = ACTIONS(4158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4156),
    [anon_sym_new] = ACTIONS(4158),
    [anon_sym_return_BANG] = ACTIONS(4156),
    [anon_sym_yield] = ACTIONS(4158),
    [anon_sym_yield_BANG] = ACTIONS(4156),
    [anon_sym_lazy] = ACTIONS(4158),
    [anon_sym_assert] = ACTIONS(4158),
    [anon_sym_upcast] = ACTIONS(4158),
    [anon_sym_downcast] = ACTIONS(4158),
    [anon_sym_COLON_GT] = ACTIONS(4156),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4156),
    [anon_sym_for] = ACTIONS(4158),
    [anon_sym_while] = ACTIONS(4158),
    [anon_sym_if] = ACTIONS(4158),
    [anon_sym_fun] = ACTIONS(4158),
    [anon_sym_try] = ACTIONS(4158),
    [anon_sym_match] = ACTIONS(4158),
    [anon_sym_match_BANG] = ACTIONS(4156),
    [anon_sym_function] = ACTIONS(4158),
    [anon_sym_LT_DASH] = ACTIONS(4158),
    [anon_sym_DOT_LBRACK] = ACTIONS(4156),
    [anon_sym_LT] = ACTIONS(4156),
    [anon_sym_use] = ACTIONS(4158),
    [anon_sym_use_BANG] = ACTIONS(4156),
    [anon_sym_do_BANG] = ACTIONS(4156),
    [anon_sym_begin] = ACTIONS(4158),
    [anon_sym_LPAREN2] = ACTIONS(4158),
    [anon_sym_or] = ACTIONS(4158),
    [anon_sym_exception] = ACTIONS(4158),
    [aux_sym_char_token1] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4158),
    [anon_sym_DQUOTE] = ACTIONS(4158),
    [anon_sym_AT_DQUOTE] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [sym_bool] = ACTIONS(4158),
    [sym_unit] = ACTIONS(4156),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4158),
    [sym_op_identifier] = ACTIONS(4158),
    [anon_sym_PLUS] = ACTIONS(4158),
    [anon_sym_DASH] = ACTIONS(4158),
    [anon_sym_PLUS_DOT] = ACTIONS(4158),
    [anon_sym_DASH_DOT] = ACTIONS(4158),
    [anon_sym_PERCENT] = ACTIONS(4158),
    [anon_sym_AMP_AMP] = ACTIONS(4158),
    [anon_sym_TILDE] = ACTIONS(4156),
    [aux_sym_prefix_op_token1] = ACTIONS(4158),
    [aux_sym_infix_op_token1] = ACTIONS(4156),
    [aux_sym_infix_op_token2] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE] = ACTIONS(4158),
    [anon_sym_BANG_EQ] = ACTIONS(4158),
    [anon_sym_COLON_EQ] = ACTIONS(4156),
    [anon_sym_DOLLAR] = ACTIONS(4158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4158),
    [sym_int] = ACTIONS(4158),
    [sym_xint] = ACTIONS(4156),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4156),
    [anon_sym_POUNDload] = ACTIONS(4156),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4156),
    [sym__newline] = ACTIONS(4156),
  },
  [2547] = {
    [sym_block_comment] = STATE(2547),
    [sym_compiler_directive_decl] = STATE(2547),
    [sym_fsi_directive_decl] = STATE(2547),
    [sym_preproc_line] = STATE(2547),
    [sym_identifier] = ACTIONS(4186),
    [anon_sym_EQ] = ACTIONS(4184),
    [anon_sym_GT_RBRACK] = ACTIONS(4184),
    [anon_sym_COLON] = ACTIONS(4186),
    [anon_sym_return] = ACTIONS(4186),
    [anon_sym_do] = ACTIONS(4186),
    [anon_sym_let] = ACTIONS(4186),
    [anon_sym_let_BANG] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_COMMA] = ACTIONS(4184),
    [anon_sym_null] = ACTIONS(4186),
    [anon_sym_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_COLON] = ACTIONS(4184),
    [anon_sym_AMP] = ACTIONS(4186),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_RBRACK] = ACTIONS(4184),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4184),
    [anon_sym_LBRACE] = ACTIONS(4186),
    [anon_sym_RBRACE] = ACTIONS(4184),
    [anon_sym_LT_AT] = ACTIONS(4186),
    [anon_sym_LT_AT_AT] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4186),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4184),
    [anon_sym_new] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4186),
    [anon_sym_return_BANG] = ACTIONS(4184),
    [anon_sym_yield] = ACTIONS(4186),
    [anon_sym_yield_BANG] = ACTIONS(4184),
    [anon_sym_lazy] = ACTIONS(4186),
    [anon_sym_assert] = ACTIONS(4186),
    [anon_sym_upcast] = ACTIONS(4186),
    [anon_sym_downcast] = ACTIONS(4186),
    [anon_sym_COLON_GT] = ACTIONS(4184),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4184),
    [anon_sym_for] = ACTIONS(4186),
    [anon_sym_to] = ACTIONS(4186),
    [anon_sym_downto] = ACTIONS(4186),
    [anon_sym_while] = ACTIONS(4186),
    [anon_sym_if] = ACTIONS(4186),
    [anon_sym_fun] = ACTIONS(4186),
    [anon_sym_try] = ACTIONS(4186),
    [anon_sym_match] = ACTIONS(4186),
    [anon_sym_match_BANG] = ACTIONS(4184),
    [anon_sym_function] = ACTIONS(4186),
    [anon_sym_LT_DASH] = ACTIONS(4186),
    [anon_sym_DOT_LBRACK] = ACTIONS(4184),
    [anon_sym_LT] = ACTIONS(4184),
    [anon_sym_use] = ACTIONS(4186),
    [anon_sym_use_BANG] = ACTIONS(4184),
    [anon_sym_do_BANG] = ACTIONS(4184),
    [anon_sym_begin] = ACTIONS(4186),
    [anon_sym_LPAREN2] = ACTIONS(4186),
    [anon_sym_DOT_DOT2] = ACTIONS(4184),
    [anon_sym_or] = ACTIONS(4186),
    [aux_sym_char_token1] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4186),
    [anon_sym_DQUOTE] = ACTIONS(4186),
    [anon_sym_AT_DQUOTE] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [sym_bool] = ACTIONS(4186),
    [sym_unit] = ACTIONS(4184),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4186),
    [sym_op_identifier] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4186),
    [anon_sym_DASH] = ACTIONS(4186),
    [anon_sym_PLUS_DOT] = ACTIONS(4186),
    [anon_sym_DASH_DOT] = ACTIONS(4186),
    [anon_sym_PERCENT] = ACTIONS(4186),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_TILDE] = ACTIONS(4184),
    [aux_sym_prefix_op_token1] = ACTIONS(4186),
    [aux_sym_infix_op_token1] = ACTIONS(4184),
    [aux_sym_infix_op_token2] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_COLON_EQ] = ACTIONS(4184),
    [anon_sym_DOLLAR] = ACTIONS(4186),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4186),
    [sym_int] = ACTIONS(4186),
    [sym_xint] = ACTIONS(4184),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4184),
    [sym__newline] = ACTIONS(4184),
  },
  [2548] = {
    [sym_block_comment] = STATE(2548),
    [sym_compiler_directive_decl] = STATE(2548),
    [sym_fsi_directive_decl] = STATE(2548),
    [sym_preproc_line] = STATE(2548),
    [sym_identifier] = ACTIONS(3863),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_GT_RBRACK] = ACTIONS(3861),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_let] = ACTIONS(3863),
    [anon_sym_let_BANG] = ACTIONS(3861),
    [anon_sym_LPAREN] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3861),
    [anon_sym_null] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_COLON] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3863),
    [anon_sym_RBRACK] = ACTIONS(3861),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_RBRACE] = ACTIONS(3861),
    [anon_sym_LT_AT] = ACTIONS(3863),
    [anon_sym_LT_AT_AT] = ACTIONS(3863),
    [anon_sym_DOT] = ACTIONS(3863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3861),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_with] = ACTIONS(3863),
    [anon_sym_return_BANG] = ACTIONS(3861),
    [anon_sym_yield] = ACTIONS(3863),
    [anon_sym_yield_BANG] = ACTIONS(3861),
    [anon_sym_lazy] = ACTIONS(3863),
    [anon_sym_assert] = ACTIONS(3863),
    [anon_sym_upcast] = ACTIONS(3863),
    [anon_sym_downcast] = ACTIONS(3863),
    [anon_sym_COLON_GT] = ACTIONS(3861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_to] = ACTIONS(3863),
    [anon_sym_downto] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_fun] = ACTIONS(3863),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_match] = ACTIONS(3863),
    [anon_sym_match_BANG] = ACTIONS(3861),
    [anon_sym_function] = ACTIONS(3863),
    [anon_sym_LT_DASH] = ACTIONS(3863),
    [anon_sym_DOT_LBRACK] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_use] = ACTIONS(3863),
    [anon_sym_use_BANG] = ACTIONS(3861),
    [anon_sym_do_BANG] = ACTIONS(3861),
    [anon_sym_begin] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(3863),
    [anon_sym_DOT_DOT2] = ACTIONS(3861),
    [anon_sym_or] = ACTIONS(3863),
    [aux_sym_char_token1] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [anon_sym_AT_DQUOTE] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [sym_bool] = ACTIONS(3863),
    [sym_unit] = ACTIONS(3861),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3863),
    [sym_op_identifier] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_DOT] = ACTIONS(3863),
    [anon_sym_DASH_DOT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3861),
    [aux_sym_prefix_op_token1] = ACTIONS(3863),
    [aux_sym_infix_op_token1] = ACTIONS(3861),
    [aux_sym_infix_op_token2] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_COLON_EQ] = ACTIONS(3861),
    [anon_sym_DOLLAR] = ACTIONS(3863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3863),
    [sym_int] = ACTIONS(3863),
    [sym_xint] = ACTIONS(3861),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3861),
    [sym__newline] = ACTIONS(3861),
  },
  [2549] = {
    [sym_block_comment] = STATE(2549),
    [sym_compiler_directive_decl] = STATE(2549),
    [sym_fsi_directive_decl] = STATE(2549),
    [sym_preproc_line] = STATE(2549),
    [sym_identifier] = ACTIONS(3856),
    [anon_sym_EQ] = ACTIONS(3854),
    [anon_sym_GT_RBRACK] = ACTIONS(3854),
    [anon_sym_COLON] = ACTIONS(3856),
    [anon_sym_return] = ACTIONS(3856),
    [anon_sym_do] = ACTIONS(3856),
    [anon_sym_let] = ACTIONS(3856),
    [anon_sym_let_BANG] = ACTIONS(3854),
    [anon_sym_LPAREN] = ACTIONS(3856),
    [anon_sym_COMMA] = ACTIONS(3854),
    [anon_sym_null] = ACTIONS(3856),
    [anon_sym_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_AMP] = ACTIONS(3856),
    [anon_sym_LBRACK] = ACTIONS(3856),
    [anon_sym_RBRACK] = ACTIONS(3854),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3854),
    [anon_sym_LBRACE] = ACTIONS(3856),
    [anon_sym_RBRACE] = ACTIONS(3854),
    [anon_sym_LT_AT] = ACTIONS(3856),
    [anon_sym_LT_AT_AT] = ACTIONS(3856),
    [anon_sym_DOT] = ACTIONS(3856),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3854),
    [anon_sym_new] = ACTIONS(3856),
    [anon_sym_with] = ACTIONS(3856),
    [anon_sym_return_BANG] = ACTIONS(3854),
    [anon_sym_yield] = ACTIONS(3856),
    [anon_sym_yield_BANG] = ACTIONS(3854),
    [anon_sym_lazy] = ACTIONS(3856),
    [anon_sym_assert] = ACTIONS(3856),
    [anon_sym_upcast] = ACTIONS(3856),
    [anon_sym_downcast] = ACTIONS(3856),
    [anon_sym_COLON_GT] = ACTIONS(3854),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3854),
    [anon_sym_for] = ACTIONS(3856),
    [anon_sym_to] = ACTIONS(3856),
    [anon_sym_downto] = ACTIONS(3856),
    [anon_sym_while] = ACTIONS(3856),
    [anon_sym_if] = ACTIONS(3856),
    [anon_sym_fun] = ACTIONS(3856),
    [anon_sym_try] = ACTIONS(3856),
    [anon_sym_match] = ACTIONS(3856),
    [anon_sym_match_BANG] = ACTIONS(3854),
    [anon_sym_function] = ACTIONS(3856),
    [anon_sym_LT_DASH] = ACTIONS(3856),
    [anon_sym_DOT_LBRACK] = ACTIONS(3854),
    [anon_sym_LT] = ACTIONS(3854),
    [anon_sym_use] = ACTIONS(3856),
    [anon_sym_use_BANG] = ACTIONS(3854),
    [anon_sym_do_BANG] = ACTIONS(3854),
    [anon_sym_begin] = ACTIONS(3856),
    [anon_sym_LPAREN2] = ACTIONS(3856),
    [anon_sym_DOT_DOT2] = ACTIONS(3854),
    [anon_sym_or] = ACTIONS(3856),
    [aux_sym_char_token1] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3856),
    [anon_sym_DQUOTE] = ACTIONS(3856),
    [anon_sym_AT_DQUOTE] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [sym_bool] = ACTIONS(3856),
    [sym_unit] = ACTIONS(3854),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3856),
    [sym_op_identifier] = ACTIONS(3856),
    [anon_sym_PLUS] = ACTIONS(3856),
    [anon_sym_DASH] = ACTIONS(3856),
    [anon_sym_PLUS_DOT] = ACTIONS(3856),
    [anon_sym_DASH_DOT] = ACTIONS(3856),
    [anon_sym_PERCENT] = ACTIONS(3856),
    [anon_sym_AMP_AMP] = ACTIONS(3856),
    [anon_sym_TILDE] = ACTIONS(3854),
    [aux_sym_prefix_op_token1] = ACTIONS(3856),
    [aux_sym_infix_op_token1] = ACTIONS(3854),
    [aux_sym_infix_op_token2] = ACTIONS(3856),
    [anon_sym_PIPE_PIPE] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3856),
    [anon_sym_COLON_EQ] = ACTIONS(3854),
    [anon_sym_DOLLAR] = ACTIONS(3856),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3856),
    [sym_int] = ACTIONS(3856),
    [sym_xint] = ACTIONS(3854),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3854),
    [sym__newline] = ACTIONS(3854),
  },
  [2550] = {
    [sym_block_comment] = STATE(2550),
    [sym_compiler_directive_decl] = STATE(2550),
    [sym_fsi_directive_decl] = STATE(2550),
    [sym_preproc_line] = STATE(2550),
    [sym_identifier] = ACTIONS(3505),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_COLON] = ACTIONS(3505),
    [anon_sym_return] = ACTIONS(3505),
    [anon_sym_do] = ACTIONS(3505),
    [anon_sym_let] = ACTIONS(3505),
    [anon_sym_let_BANG] = ACTIONS(3503),
    [anon_sym_as] = ACTIONS(3505),
    [anon_sym_LPAREN] = ACTIONS(3505),
    [anon_sym_COMMA] = ACTIONS(3503),
    [anon_sym_null] = ACTIONS(3505),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_COLON_QMARK] = ACTIONS(3505),
    [anon_sym_COLON_COLON] = ACTIONS(3503),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3503),
    [anon_sym_LBRACE] = ACTIONS(3505),
    [anon_sym_LT_AT] = ACTIONS(3505),
    [anon_sym_LT_AT_AT] = ACTIONS(3505),
    [anon_sym_DOT] = ACTIONS(3505),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3503),
    [anon_sym_new] = ACTIONS(3505),
    [anon_sym_with] = ACTIONS(3505),
    [anon_sym_return_BANG] = ACTIONS(3503),
    [anon_sym_yield] = ACTIONS(3505),
    [anon_sym_yield_BANG] = ACTIONS(3503),
    [anon_sym_lazy] = ACTIONS(3505),
    [anon_sym_assert] = ACTIONS(3505),
    [anon_sym_upcast] = ACTIONS(3505),
    [anon_sym_downcast] = ACTIONS(3505),
    [anon_sym_COLON_GT] = ACTIONS(3503),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3503),
    [anon_sym_for] = ACTIONS(3505),
    [anon_sym_while] = ACTIONS(3505),
    [anon_sym_if] = ACTIONS(3505),
    [anon_sym_fun] = ACTIONS(3505),
    [anon_sym_DASH_GT] = ACTIONS(3505),
    [anon_sym_try] = ACTIONS(3505),
    [anon_sym_match] = ACTIONS(3505),
    [anon_sym_match_BANG] = ACTIONS(3503),
    [anon_sym_function] = ACTIONS(3505),
    [anon_sym_LT_DASH] = ACTIONS(3505),
    [anon_sym_DOT_LBRACK] = ACTIONS(3503),
    [anon_sym_LT] = ACTIONS(3503),
    [anon_sym_use] = ACTIONS(3505),
    [anon_sym_use_BANG] = ACTIONS(3503),
    [anon_sym_do_BANG] = ACTIONS(3503),
    [anon_sym_begin] = ACTIONS(3505),
    [anon_sym_LPAREN2] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3505),
    [anon_sym_LT2] = ACTIONS(4990),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_or] = ACTIONS(3505),
    [aux_sym_char_token1] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3505),
    [anon_sym_DQUOTE] = ACTIONS(3505),
    [anon_sym_AT_DQUOTE] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [sym_bool] = ACTIONS(3505),
    [sym_unit] = ACTIONS(3503),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3505),
    [sym_op_identifier] = ACTIONS(3505),
    [anon_sym_PLUS] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3505),
    [anon_sym_PLUS_DOT] = ACTIONS(3505),
    [anon_sym_DASH_DOT] = ACTIONS(3505),
    [anon_sym_PERCENT] = ACTIONS(3505),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3503),
    [aux_sym_prefix_op_token1] = ACTIONS(3505),
    [aux_sym_infix_op_token1] = ACTIONS(3503),
    [aux_sym_infix_op_token2] = ACTIONS(3505),
    [anon_sym_PIPE_PIPE] = ACTIONS(3505),
    [anon_sym_BANG_EQ] = ACTIONS(3505),
    [anon_sym_COLON_EQ] = ACTIONS(3503),
    [anon_sym_DOLLAR] = ACTIONS(3505),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3505),
    [sym_int] = ACTIONS(3505),
    [sym_xint] = ACTIONS(3503),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3503),
    [sym__newline] = ACTIONS(3503),
  },
  [2551] = {
    [sym_block_comment] = STATE(2551),
    [sym_compiler_directive_decl] = STATE(2551),
    [sym_fsi_directive_decl] = STATE(2551),
    [sym_preproc_line] = STATE(2551),
    [aux_sym_type_argument_repeat1] = STATE(2551),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_COLON] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_LT_DASH] = ACTIONS(3480),
    [anon_sym_DOT_LBRACK] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_DOT_DOT] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_or] = ACTIONS(4992),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3480),
    [anon_sym_DASH_DOT] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3480),
    [aux_sym_infix_op_token1] = ACTIONS(3478),
    [aux_sym_infix_op_token2] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3480),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
  },
  [2552] = {
    [sym_block_comment] = STATE(2552),
    [sym_compiler_directive_decl] = STATE(2552),
    [sym_fsi_directive_decl] = STATE(2552),
    [sym_preproc_line] = STATE(2552),
    [aux_sym_long_identifier_repeat1] = STATE(2572),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(4995),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_DASH_GT] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_DOT_DOT] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_STAR] = ACTIONS(3451),
    [anon_sym_LT2] = ACTIONS(3451),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3449),
    [anon_sym_or] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
  },
  [2553] = {
    [sym_elif_expression] = STATE(2749),
    [sym_block_comment] = STATE(2553),
    [sym_compiler_directive_decl] = STATE(2553),
    [sym_fsi_directive_decl] = STATE(2553),
    [sym_preproc_line] = STATE(2553),
    [aux_sym_if_expression_repeat1] = STATE(2553),
    [sym_identifier] = ACTIONS(3555),
    [anon_sym_EQ] = ACTIONS(3553),
    [anon_sym_COLON] = ACTIONS(3555),
    [anon_sym_return] = ACTIONS(3555),
    [anon_sym_do] = ACTIONS(3555),
    [anon_sym_let] = ACTIONS(3555),
    [anon_sym_let_BANG] = ACTIONS(3553),
    [anon_sym_LPAREN] = ACTIONS(3555),
    [anon_sym_COMMA] = ACTIONS(3553),
    [anon_sym_null] = ACTIONS(3555),
    [anon_sym_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_COLON] = ACTIONS(3553),
    [anon_sym_AMP] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(3555),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3553),
    [anon_sym_LBRACE] = ACTIONS(3555),
    [anon_sym_LT_AT] = ACTIONS(3555),
    [anon_sym_LT_AT_AT] = ACTIONS(3555),
    [anon_sym_DOT] = ACTIONS(3555),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3553),
    [anon_sym_new] = ACTIONS(3555),
    [anon_sym_return_BANG] = ACTIONS(3553),
    [anon_sym_yield] = ACTIONS(3555),
    [anon_sym_yield_BANG] = ACTIONS(3553),
    [anon_sym_lazy] = ACTIONS(3555),
    [anon_sym_assert] = ACTIONS(3555),
    [anon_sym_upcast] = ACTIONS(3555),
    [anon_sym_downcast] = ACTIONS(3555),
    [anon_sym_COLON_GT] = ACTIONS(3553),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3553),
    [anon_sym_for] = ACTIONS(3555),
    [anon_sym_while] = ACTIONS(3555),
    [anon_sym_else] = ACTIONS(3555),
    [anon_sym_elif] = ACTIONS(4997),
    [anon_sym_if] = ACTIONS(3555),
    [anon_sym_fun] = ACTIONS(3555),
    [anon_sym_DASH_GT] = ACTIONS(3555),
    [anon_sym_try] = ACTIONS(3555),
    [anon_sym_match] = ACTIONS(3555),
    [anon_sym_match_BANG] = ACTIONS(3553),
    [anon_sym_function] = ACTIONS(3555),
    [anon_sym_LT_DASH] = ACTIONS(3555),
    [anon_sym_DOT_LBRACK] = ACTIONS(3553),
    [anon_sym_LT] = ACTIONS(3553),
    [anon_sym_use] = ACTIONS(3555),
    [anon_sym_use_BANG] = ACTIONS(3553),
    [anon_sym_do_BANG] = ACTIONS(3553),
    [anon_sym_DOT_DOT] = ACTIONS(3553),
    [anon_sym_begin] = ACTIONS(3555),
    [anon_sym_LPAREN2] = ACTIONS(3555),
    [anon_sym_or] = ACTIONS(3555),
    [aux_sym_char_token1] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3555),
    [anon_sym_DQUOTE] = ACTIONS(3555),
    [anon_sym_AT_DQUOTE] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [sym_bool] = ACTIONS(3555),
    [sym_unit] = ACTIONS(3553),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3555),
    [sym_op_identifier] = ACTIONS(3555),
    [anon_sym_PLUS] = ACTIONS(3555),
    [anon_sym_DASH] = ACTIONS(3555),
    [anon_sym_PLUS_DOT] = ACTIONS(3555),
    [anon_sym_DASH_DOT] = ACTIONS(3555),
    [anon_sym_PERCENT] = ACTIONS(3555),
    [anon_sym_AMP_AMP] = ACTIONS(3555),
    [anon_sym_TILDE] = ACTIONS(3553),
    [aux_sym_prefix_op_token1] = ACTIONS(3555),
    [aux_sym_infix_op_token1] = ACTIONS(3553),
    [aux_sym_infix_op_token2] = ACTIONS(3555),
    [anon_sym_PIPE_PIPE] = ACTIONS(3555),
    [anon_sym_BANG_EQ] = ACTIONS(3555),
    [anon_sym_COLON_EQ] = ACTIONS(3553),
    [anon_sym_DOLLAR] = ACTIONS(3555),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3555),
    [sym_int] = ACTIONS(3555),
    [sym_xint] = ACTIONS(3553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3553),
    [sym__newline] = ACTIONS(3553),
  },
  [2554] = {
    [sym_block_comment] = STATE(2554),
    [sym_compiler_directive_decl] = STATE(2554),
    [sym_fsi_directive_decl] = STATE(2554),
    [sym_preproc_line] = STATE(2554),
    [aux_sym_type_argument_repeat1] = STATE(2551),
    [sym_identifier] = ACTIONS(3476),
    [anon_sym_EQ] = ACTIONS(3474),
    [anon_sym_COLON] = ACTIONS(3476),
    [anon_sym_return] = ACTIONS(3476),
    [anon_sym_do] = ACTIONS(3476),
    [anon_sym_let] = ACTIONS(3476),
    [anon_sym_let_BANG] = ACTIONS(3474),
    [anon_sym_LPAREN] = ACTIONS(3476),
    [anon_sym_COMMA] = ACTIONS(3474),
    [anon_sym_null] = ACTIONS(3476),
    [anon_sym_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_COLON] = ACTIONS(3474),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym_LBRACK] = ACTIONS(3476),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3474),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_LT_AT] = ACTIONS(3476),
    [anon_sym_LT_AT_AT] = ACTIONS(3476),
    [anon_sym_DOT] = ACTIONS(3476),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3474),
    [anon_sym_new] = ACTIONS(3476),
    [anon_sym_return_BANG] = ACTIONS(3474),
    [anon_sym_yield] = ACTIONS(3476),
    [anon_sym_yield_BANG] = ACTIONS(3474),
    [anon_sym_lazy] = ACTIONS(3476),
    [anon_sym_assert] = ACTIONS(3476),
    [anon_sym_upcast] = ACTIONS(3476),
    [anon_sym_downcast] = ACTIONS(3476),
    [anon_sym_COLON_GT] = ACTIONS(3474),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3474),
    [anon_sym_for] = ACTIONS(3476),
    [anon_sym_while] = ACTIONS(3476),
    [anon_sym_if] = ACTIONS(3476),
    [anon_sym_fun] = ACTIONS(3476),
    [anon_sym_DASH_GT] = ACTIONS(3476),
    [anon_sym_try] = ACTIONS(3476),
    [anon_sym_match] = ACTIONS(3476),
    [anon_sym_match_BANG] = ACTIONS(3474),
    [anon_sym_function] = ACTIONS(3476),
    [anon_sym_LT_DASH] = ACTIONS(3476),
    [anon_sym_DOT_LBRACK] = ACTIONS(3474),
    [anon_sym_LT] = ACTIONS(3474),
    [anon_sym_use] = ACTIONS(3476),
    [anon_sym_use_BANG] = ACTIONS(3474),
    [anon_sym_do_BANG] = ACTIONS(3474),
    [anon_sym_DOT_DOT] = ACTIONS(3474),
    [anon_sym_begin] = ACTIONS(3476),
    [anon_sym_LPAREN2] = ACTIONS(3476),
    [anon_sym_STAR] = ACTIONS(3476),
    [anon_sym_LT2] = ACTIONS(3476),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3474),
    [anon_sym_or] = ACTIONS(3476),
    [aux_sym_char_token1] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3476),
    [anon_sym_DQUOTE] = ACTIONS(3476),
    [anon_sym_AT_DQUOTE] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [sym_bool] = ACTIONS(3476),
    [sym_unit] = ACTIONS(3474),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3476),
    [sym_op_identifier] = ACTIONS(3476),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3476),
    [anon_sym_PLUS_DOT] = ACTIONS(3476),
    [anon_sym_DASH_DOT] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [anon_sym_AMP_AMP] = ACTIONS(3476),
    [anon_sym_TILDE] = ACTIONS(3474),
    [aux_sym_prefix_op_token1] = ACTIONS(3476),
    [aux_sym_infix_op_token1] = ACTIONS(3474),
    [aux_sym_infix_op_token2] = ACTIONS(3476),
    [anon_sym_PIPE_PIPE] = ACTIONS(3476),
    [anon_sym_BANG_EQ] = ACTIONS(3476),
    [anon_sym_COLON_EQ] = ACTIONS(3474),
    [anon_sym_DOLLAR] = ACTIONS(3476),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3476),
    [sym_int] = ACTIONS(3476),
    [sym_xint] = ACTIONS(3474),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3474),
    [sym__newline] = ACTIONS(3474),
  },
  [2555] = {
    [sym_block_comment] = STATE(2555),
    [sym_compiler_directive_decl] = STATE(2555),
    [sym_fsi_directive_decl] = STATE(2555),
    [sym_preproc_line] = STATE(2555),
    [aux_sym_compound_type_repeat1] = STATE(2566),
    [sym_identifier] = ACTIONS(3468),
    [anon_sym_EQ] = ACTIONS(3466),
    [anon_sym_COLON] = ACTIONS(3468),
    [anon_sym_return] = ACTIONS(3468),
    [anon_sym_do] = ACTIONS(3468),
    [anon_sym_let] = ACTIONS(3468),
    [anon_sym_let_BANG] = ACTIONS(3466),
    [anon_sym_LPAREN] = ACTIONS(3468),
    [anon_sym_COMMA] = ACTIONS(3466),
    [anon_sym_null] = ACTIONS(3468),
    [anon_sym_QMARK] = ACTIONS(3468),
    [anon_sym_COLON_QMARK] = ACTIONS(3468),
    [anon_sym_COLON_COLON] = ACTIONS(3466),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LBRACK] = ACTIONS(3468),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3466),
    [anon_sym_LBRACE] = ACTIONS(3468),
    [anon_sym_LT_AT] = ACTIONS(3468),
    [anon_sym_AT_GT] = ACTIONS(3468),
    [anon_sym_LT_AT_AT] = ACTIONS(3468),
    [anon_sym_DOT] = ACTIONS(3468),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3466),
    [anon_sym_new] = ACTIONS(3468),
    [anon_sym_return_BANG] = ACTIONS(3466),
    [anon_sym_yield] = ACTIONS(3468),
    [anon_sym_yield_BANG] = ACTIONS(3466),
    [anon_sym_lazy] = ACTIONS(3468),
    [anon_sym_assert] = ACTIONS(3468),
    [anon_sym_upcast] = ACTIONS(3468),
    [anon_sym_downcast] = ACTIONS(3468),
    [anon_sym_COLON_GT] = ACTIONS(3466),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3466),
    [anon_sym_for] = ACTIONS(3468),
    [anon_sym_while] = ACTIONS(3468),
    [anon_sym_if] = ACTIONS(3468),
    [anon_sym_fun] = ACTIONS(3468),
    [anon_sym_DASH_GT] = ACTIONS(3468),
    [anon_sym_try] = ACTIONS(3468),
    [anon_sym_match] = ACTIONS(3468),
    [anon_sym_match_BANG] = ACTIONS(3466),
    [anon_sym_function] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3468),
    [anon_sym_DOT_LBRACK] = ACTIONS(3466),
    [anon_sym_LT] = ACTIONS(3466),
    [anon_sym_use] = ACTIONS(3468),
    [anon_sym_use_BANG] = ACTIONS(3466),
    [anon_sym_do_BANG] = ACTIONS(3466),
    [anon_sym_begin] = ACTIONS(3468),
    [anon_sym_LPAREN2] = ACTIONS(3468),
    [anon_sym_STAR] = ACTIONS(4902),
    [anon_sym_LT2] = ACTIONS(3468),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3466),
    [anon_sym_or] = ACTIONS(3468),
    [aux_sym_char_token1] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3468),
    [anon_sym_DQUOTE] = ACTIONS(3468),
    [anon_sym_AT_DQUOTE] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [sym_bool] = ACTIONS(3468),
    [sym_unit] = ACTIONS(3466),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3468),
    [sym_op_identifier] = ACTIONS(3468),
    [anon_sym_PLUS] = ACTIONS(3468),
    [anon_sym_DASH] = ACTIONS(3468),
    [anon_sym_PLUS_DOT] = ACTIONS(3468),
    [anon_sym_DASH_DOT] = ACTIONS(3468),
    [anon_sym_PERCENT] = ACTIONS(3468),
    [anon_sym_AMP_AMP] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3466),
    [aux_sym_prefix_op_token1] = ACTIONS(3468),
    [aux_sym_infix_op_token1] = ACTIONS(3466),
    [aux_sym_infix_op_token2] = ACTIONS(3468),
    [anon_sym_PIPE_PIPE] = ACTIONS(3468),
    [anon_sym_BANG_EQ] = ACTIONS(3468),
    [anon_sym_COLON_EQ] = ACTIONS(3466),
    [anon_sym_DOLLAR] = ACTIONS(3468),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3468),
    [sym_int] = ACTIONS(3468),
    [sym_xint] = ACTIONS(3466),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3466),
    [sym__newline] = ACTIONS(3466),
  },
  [2556] = {
    [sym_block_comment] = STATE(2556),
    [sym_compiler_directive_decl] = STATE(2556),
    [sym_fsi_directive_decl] = STATE(2556),
    [sym_preproc_line] = STATE(2556),
    [aux_sym_long_identifier_repeat1] = STATE(2552),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_EQ] = ACTIONS(3492),
    [anon_sym_COLON] = ACTIONS(3494),
    [anon_sym_return] = ACTIONS(3494),
    [anon_sym_do] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_let_BANG] = ACTIONS(3492),
    [anon_sym_LPAREN] = ACTIONS(3494),
    [anon_sym_COMMA] = ACTIONS(3492),
    [anon_sym_null] = ACTIONS(3494),
    [anon_sym_QMARK] = ACTIONS(3494),
    [anon_sym_COLON_QMARK] = ACTIONS(3494),
    [anon_sym_COLON_COLON] = ACTIONS(3492),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3492),
    [anon_sym_LBRACE] = ACTIONS(3494),
    [anon_sym_LT_AT] = ACTIONS(3494),
    [anon_sym_LT_AT_AT] = ACTIONS(3494),
    [anon_sym_DOT] = ACTIONS(4995),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3492),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_return_BANG] = ACTIONS(3492),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_yield_BANG] = ACTIONS(3492),
    [anon_sym_lazy] = ACTIONS(3494),
    [anon_sym_assert] = ACTIONS(3494),
    [anon_sym_upcast] = ACTIONS(3494),
    [anon_sym_downcast] = ACTIONS(3494),
    [anon_sym_COLON_GT] = ACTIONS(3492),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3492),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_while] = ACTIONS(3494),
    [anon_sym_if] = ACTIONS(3494),
    [anon_sym_fun] = ACTIONS(3494),
    [anon_sym_DASH_GT] = ACTIONS(3494),
    [anon_sym_try] = ACTIONS(3494),
    [anon_sym_match] = ACTIONS(3494),
    [anon_sym_match_BANG] = ACTIONS(3492),
    [anon_sym_function] = ACTIONS(3494),
    [anon_sym_LT_DASH] = ACTIONS(3494),
    [anon_sym_DOT_LBRACK] = ACTIONS(3492),
    [anon_sym_LT] = ACTIONS(3492),
    [anon_sym_use] = ACTIONS(3494),
    [anon_sym_use_BANG] = ACTIONS(3492),
    [anon_sym_do_BANG] = ACTIONS(3492),
    [anon_sym_DOT_DOT] = ACTIONS(3492),
    [anon_sym_begin] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(3494),
    [anon_sym_STAR] = ACTIONS(3494),
    [anon_sym_LT2] = ACTIONS(3494),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3492),
    [anon_sym_or] = ACTIONS(3494),
    [aux_sym_char_token1] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3494),
    [anon_sym_DQUOTE] = ACTIONS(3494),
    [anon_sym_AT_DQUOTE] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [sym_bool] = ACTIONS(3494),
    [sym_unit] = ACTIONS(3492),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3494),
    [sym_op_identifier] = ACTIONS(3494),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_PLUS_DOT] = ACTIONS(3494),
    [anon_sym_DASH_DOT] = ACTIONS(3494),
    [anon_sym_PERCENT] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_TILDE] = ACTIONS(3492),
    [aux_sym_prefix_op_token1] = ACTIONS(3494),
    [aux_sym_infix_op_token1] = ACTIONS(3492),
    [aux_sym_infix_op_token2] = ACTIONS(3494),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_COLON_EQ] = ACTIONS(3492),
    [anon_sym_DOLLAR] = ACTIONS(3494),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3494),
    [sym_int] = ACTIONS(3494),
    [sym_xint] = ACTIONS(3492),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3492),
    [sym__newline] = ACTIONS(3492),
  },
  [2557] = {
    [sym_block_comment] = STATE(2557),
    [sym_compiler_directive_decl] = STATE(2557),
    [sym_fsi_directive_decl] = STATE(2557),
    [sym_preproc_line] = STATE(2557),
    [aux_sym_type_argument_repeat1] = STATE(2557),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_COLON] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3480),
    [anon_sym_AT_AT_GT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_LT_DASH] = ACTIONS(3480),
    [anon_sym_DOT_LBRACK] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_or] = ACTIONS(5000),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3480),
    [anon_sym_DASH_DOT] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3480),
    [aux_sym_infix_op_token1] = ACTIONS(3478),
    [aux_sym_infix_op_token2] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3480),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
  },
  [2558] = {
    [sym_block_comment] = STATE(2558),
    [sym_compiler_directive_decl] = STATE(2558),
    [sym_fsi_directive_decl] = STATE(2558),
    [sym_preproc_line] = STATE(2558),
    [aux_sym_type_argument_repeat1] = STATE(2557),
    [sym_identifier] = ACTIONS(3476),
    [anon_sym_EQ] = ACTIONS(3474),
    [anon_sym_COLON] = ACTIONS(3476),
    [anon_sym_return] = ACTIONS(3476),
    [anon_sym_do] = ACTIONS(3476),
    [anon_sym_let] = ACTIONS(3476),
    [anon_sym_let_BANG] = ACTIONS(3474),
    [anon_sym_LPAREN] = ACTIONS(3476),
    [anon_sym_COMMA] = ACTIONS(3474),
    [anon_sym_null] = ACTIONS(3476),
    [anon_sym_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_COLON] = ACTIONS(3474),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym_LBRACK] = ACTIONS(3476),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3474),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_LT_AT] = ACTIONS(3476),
    [anon_sym_LT_AT_AT] = ACTIONS(3476),
    [anon_sym_AT_AT_GT] = ACTIONS(3476),
    [anon_sym_DOT] = ACTIONS(3476),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3474),
    [anon_sym_new] = ACTIONS(3476),
    [anon_sym_return_BANG] = ACTIONS(3474),
    [anon_sym_yield] = ACTIONS(3476),
    [anon_sym_yield_BANG] = ACTIONS(3474),
    [anon_sym_lazy] = ACTIONS(3476),
    [anon_sym_assert] = ACTIONS(3476),
    [anon_sym_upcast] = ACTIONS(3476),
    [anon_sym_downcast] = ACTIONS(3476),
    [anon_sym_COLON_GT] = ACTIONS(3474),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3474),
    [anon_sym_for] = ACTIONS(3476),
    [anon_sym_while] = ACTIONS(3476),
    [anon_sym_if] = ACTIONS(3476),
    [anon_sym_fun] = ACTIONS(3476),
    [anon_sym_DASH_GT] = ACTIONS(3476),
    [anon_sym_try] = ACTIONS(3476),
    [anon_sym_match] = ACTIONS(3476),
    [anon_sym_match_BANG] = ACTIONS(3474),
    [anon_sym_function] = ACTIONS(3476),
    [anon_sym_LT_DASH] = ACTIONS(3476),
    [anon_sym_DOT_LBRACK] = ACTIONS(3474),
    [anon_sym_LT] = ACTIONS(3474),
    [anon_sym_use] = ACTIONS(3476),
    [anon_sym_use_BANG] = ACTIONS(3474),
    [anon_sym_do_BANG] = ACTIONS(3474),
    [anon_sym_begin] = ACTIONS(3476),
    [anon_sym_LPAREN2] = ACTIONS(3476),
    [anon_sym_STAR] = ACTIONS(3476),
    [anon_sym_LT2] = ACTIONS(3476),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3474),
    [anon_sym_or] = ACTIONS(3476),
    [aux_sym_char_token1] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3476),
    [anon_sym_DQUOTE] = ACTIONS(3476),
    [anon_sym_AT_DQUOTE] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [sym_bool] = ACTIONS(3476),
    [sym_unit] = ACTIONS(3474),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3476),
    [sym_op_identifier] = ACTIONS(3476),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3476),
    [anon_sym_PLUS_DOT] = ACTIONS(3476),
    [anon_sym_DASH_DOT] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [anon_sym_AMP_AMP] = ACTIONS(3476),
    [anon_sym_TILDE] = ACTIONS(3474),
    [aux_sym_prefix_op_token1] = ACTIONS(3476),
    [aux_sym_infix_op_token1] = ACTIONS(3474),
    [aux_sym_infix_op_token2] = ACTIONS(3476),
    [anon_sym_PIPE_PIPE] = ACTIONS(3476),
    [anon_sym_BANG_EQ] = ACTIONS(3476),
    [anon_sym_COLON_EQ] = ACTIONS(3474),
    [anon_sym_DOLLAR] = ACTIONS(3476),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3476),
    [sym_int] = ACTIONS(3476),
    [sym_xint] = ACTIONS(3474),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3474),
    [sym__newline] = ACTIONS(3474),
  },
  [2559] = {
    [sym_block_comment] = STATE(2559),
    [sym_compiler_directive_decl] = STATE(2559),
    [sym_fsi_directive_decl] = STATE(2559),
    [sym_preproc_line] = STATE(2559),
    [aux_sym_compound_type_repeat1] = STATE(2559),
    [sym_identifier] = ACTIONS(3427),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3427),
    [anon_sym_DOT] = ACTIONS(3427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_COLON_GT] = ACTIONS(3425),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(3427),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_LT_DASH] = ACTIONS(3427),
    [anon_sym_DOT_LBRACK] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_GT] = ACTIONS(3427),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(5003),
    [anon_sym_LT2] = ACTIONS(3427),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3425),
    [anon_sym_or] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3427),
    [anon_sym_DASH_DOT] = ACTIONS(3427),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3427),
    [aux_sym_infix_op_token1] = ACTIONS(3425),
    [aux_sym_infix_op_token2] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3427),
    [anon_sym_COLON_EQ] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3427),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
  },
  [2560] = {
    [sym_block_comment] = STATE(2560),
    [sym_compiler_directive_decl] = STATE(2560),
    [sym_fsi_directive_decl] = STATE(2560),
    [sym_preproc_line] = STATE(2560),
    [aux_sym_type_argument_repeat1] = STATE(2592),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_AT_GT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [anon_sym_DOT_LBRACK] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_or] = ACTIONS(5006),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3498),
    [anon_sym_DASH_DOT] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3498),
    [aux_sym_infix_op_token1] = ACTIONS(3496),
    [aux_sym_infix_op_token2] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_COLON_EQ] = ACTIONS(3496),
    [anon_sym_DOLLAR] = ACTIONS(3498),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3498),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
  },
  [2561] = {
    [sym_block_comment] = STATE(2561),
    [sym_compiler_directive_decl] = STATE(2561),
    [sym_fsi_directive_decl] = STATE(2561),
    [sym_preproc_line] = STATE(2561),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_with] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_DOT_DOT2] = ACTIONS(3602),
    [anon_sym_or] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [aux_sym_float_token1] = ACTIONS(5009),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
    [sym__dedent] = ACTIONS(3602),
  },
  [2562] = {
    [sym_block_comment] = STATE(2562),
    [sym_compiler_directive_decl] = STATE(2562),
    [sym_fsi_directive_decl] = STATE(2562),
    [sym_preproc_line] = STATE(2562),
    [aux_sym_compound_type_repeat1] = STATE(2562),
    [sym_identifier] = ACTIONS(3427),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3427),
    [anon_sym_DOT] = ACTIONS(3427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_COLON_GT] = ACTIONS(3425),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(3427),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_LT_DASH] = ACTIONS(3427),
    [anon_sym_DOT_LBRACK] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_DOT_DOT] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(5011),
    [anon_sym_LT2] = ACTIONS(3427),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3425),
    [anon_sym_or] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3427),
    [anon_sym_DASH_DOT] = ACTIONS(3427),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3427),
    [aux_sym_infix_op_token1] = ACTIONS(3425),
    [aux_sym_infix_op_token2] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3427),
    [anon_sym_COLON_EQ] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3427),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
  },
  [2563] = {
    [sym_block_comment] = STATE(2563),
    [sym_compiler_directive_decl] = STATE(2563),
    [sym_fsi_directive_decl] = STATE(2563),
    [sym_preproc_line] = STATE(2563),
    [aux_sym_compound_type_repeat1] = STATE(2559),
    [sym_identifier] = ACTIONS(3468),
    [anon_sym_EQ] = ACTIONS(3466),
    [anon_sym_COLON] = ACTIONS(3468),
    [anon_sym_return] = ACTIONS(3468),
    [anon_sym_do] = ACTIONS(3468),
    [anon_sym_let] = ACTIONS(3468),
    [anon_sym_let_BANG] = ACTIONS(3466),
    [anon_sym_LPAREN] = ACTIONS(3468),
    [anon_sym_COMMA] = ACTIONS(3466),
    [anon_sym_null] = ACTIONS(3468),
    [anon_sym_QMARK] = ACTIONS(3468),
    [anon_sym_COLON_QMARK] = ACTIONS(3468),
    [anon_sym_COLON_COLON] = ACTIONS(3466),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LBRACK] = ACTIONS(3468),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3466),
    [anon_sym_LBRACE] = ACTIONS(3468),
    [anon_sym_LT_AT] = ACTIONS(3468),
    [anon_sym_LT_AT_AT] = ACTIONS(3468),
    [anon_sym_DOT] = ACTIONS(3468),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3466),
    [anon_sym_new] = ACTIONS(3468),
    [anon_sym_return_BANG] = ACTIONS(3466),
    [anon_sym_yield] = ACTIONS(3468),
    [anon_sym_yield_BANG] = ACTIONS(3466),
    [anon_sym_lazy] = ACTIONS(3468),
    [anon_sym_assert] = ACTIONS(3468),
    [anon_sym_upcast] = ACTIONS(3468),
    [anon_sym_downcast] = ACTIONS(3468),
    [anon_sym_COLON_GT] = ACTIONS(3466),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3466),
    [anon_sym_for] = ACTIONS(3468),
    [anon_sym_while] = ACTIONS(3468),
    [anon_sym_if] = ACTIONS(3468),
    [anon_sym_fun] = ACTIONS(3468),
    [anon_sym_DASH_GT] = ACTIONS(3468),
    [anon_sym_try] = ACTIONS(3468),
    [anon_sym_match] = ACTIONS(3468),
    [anon_sym_match_BANG] = ACTIONS(3466),
    [anon_sym_function] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3468),
    [anon_sym_DOT_LBRACK] = ACTIONS(3466),
    [anon_sym_LT] = ACTIONS(3466),
    [anon_sym_GT] = ACTIONS(3468),
    [anon_sym_use] = ACTIONS(3468),
    [anon_sym_use_BANG] = ACTIONS(3466),
    [anon_sym_do_BANG] = ACTIONS(3466),
    [anon_sym_begin] = ACTIONS(3468),
    [anon_sym_LPAREN2] = ACTIONS(3468),
    [anon_sym_STAR] = ACTIONS(4878),
    [anon_sym_LT2] = ACTIONS(3468),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3466),
    [anon_sym_or] = ACTIONS(3468),
    [aux_sym_char_token1] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3468),
    [anon_sym_DQUOTE] = ACTIONS(3468),
    [anon_sym_AT_DQUOTE] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [sym_bool] = ACTIONS(3468),
    [sym_unit] = ACTIONS(3466),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3468),
    [sym_op_identifier] = ACTIONS(3468),
    [anon_sym_PLUS] = ACTIONS(3468),
    [anon_sym_DASH] = ACTIONS(3468),
    [anon_sym_PLUS_DOT] = ACTIONS(3468),
    [anon_sym_DASH_DOT] = ACTIONS(3468),
    [anon_sym_PERCENT] = ACTIONS(3468),
    [anon_sym_AMP_AMP] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3466),
    [aux_sym_prefix_op_token1] = ACTIONS(3468),
    [aux_sym_infix_op_token1] = ACTIONS(3466),
    [aux_sym_infix_op_token2] = ACTIONS(3468),
    [anon_sym_PIPE_PIPE] = ACTIONS(3468),
    [anon_sym_BANG_EQ] = ACTIONS(3468),
    [anon_sym_COLON_EQ] = ACTIONS(3466),
    [anon_sym_DOLLAR] = ACTIONS(3468),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3468),
    [sym_int] = ACTIONS(3468),
    [sym_xint] = ACTIONS(3466),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3466),
    [sym__newline] = ACTIONS(3466),
  },
  [2564] = {
    [sym_block_comment] = STATE(2564),
    [sym_compiler_directive_decl] = STATE(2564),
    [sym_fsi_directive_decl] = STATE(2564),
    [sym_preproc_line] = STATE(2564),
    [aux_sym_type_argument_repeat1] = STATE(2558),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3498),
    [anon_sym_AT_AT_GT] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [anon_sym_DOT_LBRACK] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_or] = ACTIONS(5014),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3498),
    [anon_sym_DASH_DOT] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3498),
    [aux_sym_infix_op_token1] = ACTIONS(3496),
    [aux_sym_infix_op_token2] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_COLON_EQ] = ACTIONS(3496),
    [anon_sym_DOLLAR] = ACTIONS(3498),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3498),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
  },
  [2565] = {
    [sym_block_comment] = STATE(2565),
    [sym_compiler_directive_decl] = STATE(2565),
    [sym_fsi_directive_decl] = STATE(2565),
    [sym_preproc_line] = STATE(2565),
    [aux_sym_compound_type_repeat1] = STATE(2608),
    [sym_identifier] = ACTIONS(3468),
    [anon_sym_EQ] = ACTIONS(3466),
    [anon_sym_COLON] = ACTIONS(3468),
    [anon_sym_return] = ACTIONS(3468),
    [anon_sym_do] = ACTIONS(3468),
    [anon_sym_let] = ACTIONS(3468),
    [anon_sym_let_BANG] = ACTIONS(3466),
    [anon_sym_LPAREN] = ACTIONS(3468),
    [anon_sym_COMMA] = ACTIONS(3466),
    [anon_sym_null] = ACTIONS(3468),
    [anon_sym_QMARK] = ACTIONS(3468),
    [anon_sym_COLON_QMARK] = ACTIONS(3468),
    [anon_sym_COLON_COLON] = ACTIONS(3466),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LBRACK] = ACTIONS(3468),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3466),
    [anon_sym_LBRACE] = ACTIONS(3468),
    [anon_sym_LT_AT] = ACTIONS(3468),
    [anon_sym_LT_AT_AT] = ACTIONS(3468),
    [anon_sym_AT_AT_GT] = ACTIONS(3468),
    [anon_sym_DOT] = ACTIONS(3468),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3466),
    [anon_sym_new] = ACTIONS(3468),
    [anon_sym_return_BANG] = ACTIONS(3466),
    [anon_sym_yield] = ACTIONS(3468),
    [anon_sym_yield_BANG] = ACTIONS(3466),
    [anon_sym_lazy] = ACTIONS(3468),
    [anon_sym_assert] = ACTIONS(3468),
    [anon_sym_upcast] = ACTIONS(3468),
    [anon_sym_downcast] = ACTIONS(3468),
    [anon_sym_COLON_GT] = ACTIONS(3466),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3466),
    [anon_sym_for] = ACTIONS(3468),
    [anon_sym_while] = ACTIONS(3468),
    [anon_sym_if] = ACTIONS(3468),
    [anon_sym_fun] = ACTIONS(3468),
    [anon_sym_DASH_GT] = ACTIONS(3468),
    [anon_sym_try] = ACTIONS(3468),
    [anon_sym_match] = ACTIONS(3468),
    [anon_sym_match_BANG] = ACTIONS(3466),
    [anon_sym_function] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3468),
    [anon_sym_DOT_LBRACK] = ACTIONS(3466),
    [anon_sym_LT] = ACTIONS(3466),
    [anon_sym_use] = ACTIONS(3468),
    [anon_sym_use_BANG] = ACTIONS(3466),
    [anon_sym_do_BANG] = ACTIONS(3466),
    [anon_sym_begin] = ACTIONS(3468),
    [anon_sym_LPAREN2] = ACTIONS(3468),
    [anon_sym_STAR] = ACTIONS(4892),
    [anon_sym_LT2] = ACTIONS(3468),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3466),
    [anon_sym_or] = ACTIONS(3468),
    [aux_sym_char_token1] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3468),
    [anon_sym_DQUOTE] = ACTIONS(3468),
    [anon_sym_AT_DQUOTE] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [sym_bool] = ACTIONS(3468),
    [sym_unit] = ACTIONS(3466),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3468),
    [sym_op_identifier] = ACTIONS(3468),
    [anon_sym_PLUS] = ACTIONS(3468),
    [anon_sym_DASH] = ACTIONS(3468),
    [anon_sym_PLUS_DOT] = ACTIONS(3468),
    [anon_sym_DASH_DOT] = ACTIONS(3468),
    [anon_sym_PERCENT] = ACTIONS(3468),
    [anon_sym_AMP_AMP] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3466),
    [aux_sym_prefix_op_token1] = ACTIONS(3468),
    [aux_sym_infix_op_token1] = ACTIONS(3466),
    [aux_sym_infix_op_token2] = ACTIONS(3468),
    [anon_sym_PIPE_PIPE] = ACTIONS(3468),
    [anon_sym_BANG_EQ] = ACTIONS(3468),
    [anon_sym_COLON_EQ] = ACTIONS(3466),
    [anon_sym_DOLLAR] = ACTIONS(3468),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3468),
    [sym_int] = ACTIONS(3468),
    [sym_xint] = ACTIONS(3466),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3466),
    [sym__newline] = ACTIONS(3466),
  },
  [2566] = {
    [sym_block_comment] = STATE(2566),
    [sym_compiler_directive_decl] = STATE(2566),
    [sym_fsi_directive_decl] = STATE(2566),
    [sym_preproc_line] = STATE(2566),
    [aux_sym_compound_type_repeat1] = STATE(2566),
    [sym_identifier] = ACTIONS(3427),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_AT_GT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3427),
    [anon_sym_DOT] = ACTIONS(3427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_COLON_GT] = ACTIONS(3425),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(3427),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_LT_DASH] = ACTIONS(3427),
    [anon_sym_DOT_LBRACK] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(5017),
    [anon_sym_LT2] = ACTIONS(3427),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3425),
    [anon_sym_or] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3427),
    [anon_sym_DASH_DOT] = ACTIONS(3427),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3427),
    [aux_sym_infix_op_token1] = ACTIONS(3425),
    [aux_sym_infix_op_token2] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3427),
    [anon_sym_COLON_EQ] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3427),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
  },
  [2567] = {
    [sym__else_expression] = STATE(3472),
    [sym_elif_expression] = STATE(2860),
    [sym_block_comment] = STATE(2567),
    [sym_compiler_directive_decl] = STATE(2567),
    [sym_fsi_directive_decl] = STATE(2567),
    [sym_preproc_line] = STATE(2567),
    [aux_sym_if_expression_repeat1] = STATE(2658),
    [sym_identifier] = ACTIONS(3457),
    [anon_sym_EQ] = ACTIONS(3455),
    [anon_sym_COLON] = ACTIONS(3457),
    [anon_sym_return] = ACTIONS(3457),
    [anon_sym_do] = ACTIONS(3457),
    [anon_sym_let] = ACTIONS(3457),
    [anon_sym_let_BANG] = ACTIONS(3455),
    [anon_sym_LPAREN] = ACTIONS(3457),
    [anon_sym_COMMA] = ACTIONS(3455),
    [anon_sym_null] = ACTIONS(3457),
    [anon_sym_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_COLON] = ACTIONS(3455),
    [anon_sym_AMP] = ACTIONS(3457),
    [anon_sym_LBRACK] = ACTIONS(3457),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3457),
    [anon_sym_LT_AT] = ACTIONS(3457),
    [anon_sym_LT_AT_AT] = ACTIONS(3457),
    [anon_sym_AT_AT_GT] = ACTIONS(3457),
    [anon_sym_DOT] = ACTIONS(3457),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3457),
    [anon_sym_return_BANG] = ACTIONS(3455),
    [anon_sym_yield] = ACTIONS(3457),
    [anon_sym_yield_BANG] = ACTIONS(3455),
    [anon_sym_lazy] = ACTIONS(3457),
    [anon_sym_assert] = ACTIONS(3457),
    [anon_sym_upcast] = ACTIONS(3457),
    [anon_sym_downcast] = ACTIONS(3457),
    [anon_sym_COLON_GT] = ACTIONS(3455),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3457),
    [anon_sym_while] = ACTIONS(3457),
    [anon_sym_else] = ACTIONS(5020),
    [anon_sym_elif] = ACTIONS(5022),
    [anon_sym_if] = ACTIONS(3457),
    [anon_sym_fun] = ACTIONS(3457),
    [anon_sym_try] = ACTIONS(3457),
    [anon_sym_match] = ACTIONS(3457),
    [anon_sym_match_BANG] = ACTIONS(3455),
    [anon_sym_function] = ACTIONS(3457),
    [anon_sym_LT_DASH] = ACTIONS(3457),
    [anon_sym_DOT_LBRACK] = ACTIONS(3455),
    [anon_sym_LT] = ACTIONS(3455),
    [anon_sym_use] = ACTIONS(3457),
    [anon_sym_use_BANG] = ACTIONS(3455),
    [anon_sym_do_BANG] = ACTIONS(3455),
    [anon_sym_begin] = ACTIONS(3457),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_or] = ACTIONS(3457),
    [aux_sym_char_token1] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [anon_sym_AT_DQUOTE] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [sym_bool] = ACTIONS(3457),
    [sym_unit] = ACTIONS(3455),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3457),
    [sym_op_identifier] = ACTIONS(3457),
    [anon_sym_PLUS] = ACTIONS(3457),
    [anon_sym_DASH] = ACTIONS(3457),
    [anon_sym_PLUS_DOT] = ACTIONS(3457),
    [anon_sym_DASH_DOT] = ACTIONS(3457),
    [anon_sym_PERCENT] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3455),
    [aux_sym_prefix_op_token1] = ACTIONS(3457),
    [aux_sym_infix_op_token1] = ACTIONS(3455),
    [aux_sym_infix_op_token2] = ACTIONS(3457),
    [anon_sym_PIPE_PIPE] = ACTIONS(3457),
    [anon_sym_BANG_EQ] = ACTIONS(3457),
    [anon_sym_COLON_EQ] = ACTIONS(3455),
    [anon_sym_DOLLAR] = ACTIONS(3457),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3457),
    [sym_int] = ACTIONS(3457),
    [sym_xint] = ACTIONS(3455),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3455),
    [sym__newline] = ACTIONS(3455),
  },
  [2568] = {
    [sym_block_comment] = STATE(2568),
    [sym_compiler_directive_decl] = STATE(2568),
    [sym_fsi_directive_decl] = STATE(2568),
    [sym_preproc_line] = STATE(2568),
    [aux_sym_long_identifier_repeat1] = STATE(2600),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_EQ] = ACTIONS(3492),
    [anon_sym_COLON] = ACTIONS(3494),
    [anon_sym_return] = ACTIONS(3494),
    [anon_sym_do] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_let_BANG] = ACTIONS(3492),
    [anon_sym_LPAREN] = ACTIONS(3494),
    [anon_sym_COMMA] = ACTIONS(3492),
    [anon_sym_null] = ACTIONS(3494),
    [anon_sym_QMARK] = ACTIONS(3494),
    [anon_sym_COLON_QMARK] = ACTIONS(3494),
    [anon_sym_COLON_COLON] = ACTIONS(3492),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3492),
    [anon_sym_LBRACE] = ACTIONS(3494),
    [anon_sym_LT_AT] = ACTIONS(3494),
    [anon_sym_LT_AT_AT] = ACTIONS(3494),
    [anon_sym_DOT] = ACTIONS(5024),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3492),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_return_BANG] = ACTIONS(3492),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_yield_BANG] = ACTIONS(3492),
    [anon_sym_lazy] = ACTIONS(3494),
    [anon_sym_assert] = ACTIONS(3494),
    [anon_sym_upcast] = ACTIONS(3494),
    [anon_sym_downcast] = ACTIONS(3494),
    [anon_sym_COLON_GT] = ACTIONS(3492),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3492),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_while] = ACTIONS(3494),
    [anon_sym_if] = ACTIONS(3494),
    [anon_sym_fun] = ACTIONS(3494),
    [anon_sym_DASH_GT] = ACTIONS(3494),
    [anon_sym_try] = ACTIONS(3494),
    [anon_sym_match] = ACTIONS(3494),
    [anon_sym_match_BANG] = ACTIONS(3492),
    [anon_sym_function] = ACTIONS(3494),
    [anon_sym_LT_DASH] = ACTIONS(3494),
    [anon_sym_DOT_LBRACK] = ACTIONS(3492),
    [anon_sym_LT] = ACTIONS(3492),
    [anon_sym_GT] = ACTIONS(3494),
    [anon_sym_use] = ACTIONS(3494),
    [anon_sym_use_BANG] = ACTIONS(3492),
    [anon_sym_do_BANG] = ACTIONS(3492),
    [anon_sym_begin] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(3494),
    [anon_sym_STAR] = ACTIONS(3494),
    [anon_sym_LT2] = ACTIONS(3494),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3492),
    [anon_sym_or] = ACTIONS(3494),
    [aux_sym_char_token1] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3494),
    [anon_sym_DQUOTE] = ACTIONS(3494),
    [anon_sym_AT_DQUOTE] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [sym_bool] = ACTIONS(3494),
    [sym_unit] = ACTIONS(3492),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3494),
    [sym_op_identifier] = ACTIONS(3494),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_PLUS_DOT] = ACTIONS(3494),
    [anon_sym_DASH_DOT] = ACTIONS(3494),
    [anon_sym_PERCENT] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_TILDE] = ACTIONS(3492),
    [aux_sym_prefix_op_token1] = ACTIONS(3494),
    [aux_sym_infix_op_token1] = ACTIONS(3492),
    [aux_sym_infix_op_token2] = ACTIONS(3494),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_COLON_EQ] = ACTIONS(3492),
    [anon_sym_DOLLAR] = ACTIONS(3494),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3494),
    [sym_int] = ACTIONS(3494),
    [sym_xint] = ACTIONS(3492),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3492),
    [sym__newline] = ACTIONS(3492),
  },
  [2569] = {
    [sym_block_comment] = STATE(2569),
    [sym_compiler_directive_decl] = STATE(2569),
    [sym_fsi_directive_decl] = STATE(2569),
    [sym_preproc_line] = STATE(2569),
    [aux_sym_type_argument_repeat1] = STATE(2582),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [anon_sym_DOT_LBRACK] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_GT] = ACTIONS(3498),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_or] = ACTIONS(5026),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3498),
    [anon_sym_DASH_DOT] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3498),
    [aux_sym_infix_op_token1] = ACTIONS(3496),
    [aux_sym_infix_op_token2] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_COLON_EQ] = ACTIONS(3496),
    [anon_sym_DOLLAR] = ACTIONS(3498),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3498),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
  },
  [2570] = {
    [sym__else_expression] = STATE(3340),
    [sym_elif_expression] = STATE(2836),
    [sym_block_comment] = STATE(2570),
    [sym_compiler_directive_decl] = STATE(2570),
    [sym_fsi_directive_decl] = STATE(2570),
    [sym_preproc_line] = STATE(2570),
    [aux_sym_if_expression_repeat1] = STATE(2610),
    [sym_identifier] = ACTIONS(3472),
    [anon_sym_EQ] = ACTIONS(3470),
    [anon_sym_COLON] = ACTIONS(3472),
    [anon_sym_return] = ACTIONS(3472),
    [anon_sym_do] = ACTIONS(3472),
    [anon_sym_let] = ACTIONS(3472),
    [anon_sym_let_BANG] = ACTIONS(3470),
    [anon_sym_LPAREN] = ACTIONS(3472),
    [anon_sym_COMMA] = ACTIONS(3470),
    [anon_sym_null] = ACTIONS(3472),
    [anon_sym_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_COLON] = ACTIONS(3470),
    [anon_sym_AMP] = ACTIONS(3472),
    [anon_sym_LBRACK] = ACTIONS(3472),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3470),
    [anon_sym_LBRACE] = ACTIONS(3472),
    [anon_sym_LT_AT] = ACTIONS(3472),
    [anon_sym_AT_GT] = ACTIONS(3472),
    [anon_sym_LT_AT_AT] = ACTIONS(3472),
    [anon_sym_DOT] = ACTIONS(3472),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3470),
    [anon_sym_new] = ACTIONS(3472),
    [anon_sym_return_BANG] = ACTIONS(3470),
    [anon_sym_yield] = ACTIONS(3472),
    [anon_sym_yield_BANG] = ACTIONS(3470),
    [anon_sym_lazy] = ACTIONS(3472),
    [anon_sym_assert] = ACTIONS(3472),
    [anon_sym_upcast] = ACTIONS(3472),
    [anon_sym_downcast] = ACTIONS(3472),
    [anon_sym_COLON_GT] = ACTIONS(3470),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3470),
    [anon_sym_for] = ACTIONS(3472),
    [anon_sym_while] = ACTIONS(3472),
    [anon_sym_else] = ACTIONS(5029),
    [anon_sym_elif] = ACTIONS(5031),
    [anon_sym_if] = ACTIONS(3472),
    [anon_sym_fun] = ACTIONS(3472),
    [anon_sym_try] = ACTIONS(3472),
    [anon_sym_match] = ACTIONS(3472),
    [anon_sym_match_BANG] = ACTIONS(3470),
    [anon_sym_function] = ACTIONS(3472),
    [anon_sym_LT_DASH] = ACTIONS(3472),
    [anon_sym_DOT_LBRACK] = ACTIONS(3470),
    [anon_sym_LT] = ACTIONS(3470),
    [anon_sym_use] = ACTIONS(3472),
    [anon_sym_use_BANG] = ACTIONS(3470),
    [anon_sym_do_BANG] = ACTIONS(3470),
    [anon_sym_begin] = ACTIONS(3472),
    [anon_sym_LPAREN2] = ACTIONS(3472),
    [anon_sym_or] = ACTIONS(3472),
    [aux_sym_char_token1] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3472),
    [anon_sym_DQUOTE] = ACTIONS(3472),
    [anon_sym_AT_DQUOTE] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [sym_bool] = ACTIONS(3472),
    [sym_unit] = ACTIONS(3470),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3472),
    [sym_op_identifier] = ACTIONS(3472),
    [anon_sym_PLUS] = ACTIONS(3472),
    [anon_sym_DASH] = ACTIONS(3472),
    [anon_sym_PLUS_DOT] = ACTIONS(3472),
    [anon_sym_DASH_DOT] = ACTIONS(3472),
    [anon_sym_PERCENT] = ACTIONS(3472),
    [anon_sym_AMP_AMP] = ACTIONS(3472),
    [anon_sym_TILDE] = ACTIONS(3470),
    [aux_sym_prefix_op_token1] = ACTIONS(3472),
    [aux_sym_infix_op_token1] = ACTIONS(3470),
    [aux_sym_infix_op_token2] = ACTIONS(3472),
    [anon_sym_PIPE_PIPE] = ACTIONS(3472),
    [anon_sym_BANG_EQ] = ACTIONS(3472),
    [anon_sym_COLON_EQ] = ACTIONS(3470),
    [anon_sym_DOLLAR] = ACTIONS(3472),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3472),
    [sym_int] = ACTIONS(3472),
    [sym_xint] = ACTIONS(3470),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3470),
    [sym__newline] = ACTIONS(3470),
  },
  [2571] = {
    [sym_block_comment] = STATE(2571),
    [sym_compiler_directive_decl] = STATE(2571),
    [sym_fsi_directive_decl] = STATE(2571),
    [sym_preproc_line] = STATE(2571),
    [aux_sym_long_identifier_repeat1] = STATE(2578),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_EQ] = ACTIONS(3492),
    [anon_sym_COLON] = ACTIONS(3494),
    [anon_sym_return] = ACTIONS(3494),
    [anon_sym_do] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_let_BANG] = ACTIONS(3492),
    [anon_sym_LPAREN] = ACTIONS(3494),
    [anon_sym_COMMA] = ACTIONS(3492),
    [anon_sym_null] = ACTIONS(3494),
    [anon_sym_QMARK] = ACTIONS(3494),
    [anon_sym_COLON_QMARK] = ACTIONS(3494),
    [anon_sym_COLON_COLON] = ACTIONS(3492),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3492),
    [anon_sym_LBRACE] = ACTIONS(3494),
    [anon_sym_LT_AT] = ACTIONS(3494),
    [anon_sym_LT_AT_AT] = ACTIONS(3494),
    [anon_sym_AT_AT_GT] = ACTIONS(3494),
    [anon_sym_DOT] = ACTIONS(5033),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3492),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_return_BANG] = ACTIONS(3492),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_yield_BANG] = ACTIONS(3492),
    [anon_sym_lazy] = ACTIONS(3494),
    [anon_sym_assert] = ACTIONS(3494),
    [anon_sym_upcast] = ACTIONS(3494),
    [anon_sym_downcast] = ACTIONS(3494),
    [anon_sym_COLON_GT] = ACTIONS(3492),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3492),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_while] = ACTIONS(3494),
    [anon_sym_if] = ACTIONS(3494),
    [anon_sym_fun] = ACTIONS(3494),
    [anon_sym_DASH_GT] = ACTIONS(3494),
    [anon_sym_try] = ACTIONS(3494),
    [anon_sym_match] = ACTIONS(3494),
    [anon_sym_match_BANG] = ACTIONS(3492),
    [anon_sym_function] = ACTIONS(3494),
    [anon_sym_LT_DASH] = ACTIONS(3494),
    [anon_sym_DOT_LBRACK] = ACTIONS(3492),
    [anon_sym_LT] = ACTIONS(3492),
    [anon_sym_use] = ACTIONS(3494),
    [anon_sym_use_BANG] = ACTIONS(3492),
    [anon_sym_do_BANG] = ACTIONS(3492),
    [anon_sym_begin] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(3494),
    [anon_sym_STAR] = ACTIONS(3494),
    [anon_sym_LT2] = ACTIONS(3494),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3492),
    [anon_sym_or] = ACTIONS(3494),
    [aux_sym_char_token1] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3494),
    [anon_sym_DQUOTE] = ACTIONS(3494),
    [anon_sym_AT_DQUOTE] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [sym_bool] = ACTIONS(3494),
    [sym_unit] = ACTIONS(3492),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3494),
    [sym_op_identifier] = ACTIONS(3494),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_PLUS_DOT] = ACTIONS(3494),
    [anon_sym_DASH_DOT] = ACTIONS(3494),
    [anon_sym_PERCENT] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_TILDE] = ACTIONS(3492),
    [aux_sym_prefix_op_token1] = ACTIONS(3494),
    [aux_sym_infix_op_token1] = ACTIONS(3492),
    [aux_sym_infix_op_token2] = ACTIONS(3494),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_COLON_EQ] = ACTIONS(3492),
    [anon_sym_DOLLAR] = ACTIONS(3494),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3494),
    [sym_int] = ACTIONS(3494),
    [sym_xint] = ACTIONS(3492),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3492),
    [sym__newline] = ACTIONS(3492),
  },
  [2572] = {
    [sym_block_comment] = STATE(2572),
    [sym_compiler_directive_decl] = STATE(2572),
    [sym_fsi_directive_decl] = STATE(2572),
    [sym_preproc_line] = STATE(2572),
    [aux_sym_long_identifier_repeat1] = STATE(2572),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(5035),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_DOT_DOT] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [2573] = {
    [sym_block_comment] = STATE(2573),
    [sym_compiler_directive_decl] = STATE(2573),
    [sym_fsi_directive_decl] = STATE(2573),
    [sym_preproc_line] = STATE(2573),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_as] = ACTIONS(3487),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [2574] = {
    [sym_block_comment] = STATE(2574),
    [sym_compiler_directive_decl] = STATE(2574),
    [sym_fsi_directive_decl] = STATE(2574),
    [sym_preproc_line] = STATE(2574),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [anon_sym_as] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_with] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [aux_sym_float_token1] = ACTIONS(5038),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
    [sym__dedent] = ACTIONS(3602),
  },
  [2575] = {
    [sym_block_comment] = STATE(2575),
    [sym_compiler_directive_decl] = STATE(2575),
    [sym_fsi_directive_decl] = STATE(2575),
    [sym_preproc_line] = STATE(2575),
    [aux_sym_compound_type_repeat1] = STATE(2562),
    [sym_identifier] = ACTIONS(3468),
    [anon_sym_EQ] = ACTIONS(3466),
    [anon_sym_COLON] = ACTIONS(3468),
    [anon_sym_return] = ACTIONS(3468),
    [anon_sym_do] = ACTIONS(3468),
    [anon_sym_let] = ACTIONS(3468),
    [anon_sym_let_BANG] = ACTIONS(3466),
    [anon_sym_LPAREN] = ACTIONS(3468),
    [anon_sym_COMMA] = ACTIONS(3466),
    [anon_sym_null] = ACTIONS(3468),
    [anon_sym_QMARK] = ACTIONS(3468),
    [anon_sym_COLON_QMARK] = ACTIONS(3468),
    [anon_sym_COLON_COLON] = ACTIONS(3466),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LBRACK] = ACTIONS(3468),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3466),
    [anon_sym_LBRACE] = ACTIONS(3468),
    [anon_sym_LT_AT] = ACTIONS(3468),
    [anon_sym_LT_AT_AT] = ACTIONS(3468),
    [anon_sym_DOT] = ACTIONS(3468),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3466),
    [anon_sym_new] = ACTIONS(3468),
    [anon_sym_return_BANG] = ACTIONS(3466),
    [anon_sym_yield] = ACTIONS(3468),
    [anon_sym_yield_BANG] = ACTIONS(3466),
    [anon_sym_lazy] = ACTIONS(3468),
    [anon_sym_assert] = ACTIONS(3468),
    [anon_sym_upcast] = ACTIONS(3468),
    [anon_sym_downcast] = ACTIONS(3468),
    [anon_sym_COLON_GT] = ACTIONS(3466),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3466),
    [anon_sym_for] = ACTIONS(3468),
    [anon_sym_while] = ACTIONS(3468),
    [anon_sym_if] = ACTIONS(3468),
    [anon_sym_fun] = ACTIONS(3468),
    [anon_sym_DASH_GT] = ACTIONS(3468),
    [anon_sym_try] = ACTIONS(3468),
    [anon_sym_match] = ACTIONS(3468),
    [anon_sym_match_BANG] = ACTIONS(3466),
    [anon_sym_function] = ACTIONS(3468),
    [anon_sym_LT_DASH] = ACTIONS(3468),
    [anon_sym_DOT_LBRACK] = ACTIONS(3466),
    [anon_sym_LT] = ACTIONS(3466),
    [anon_sym_use] = ACTIONS(3468),
    [anon_sym_use_BANG] = ACTIONS(3466),
    [anon_sym_do_BANG] = ACTIONS(3466),
    [anon_sym_DOT_DOT] = ACTIONS(3466),
    [anon_sym_begin] = ACTIONS(3468),
    [anon_sym_LPAREN2] = ACTIONS(3468),
    [anon_sym_STAR] = ACTIONS(4860),
    [anon_sym_LT2] = ACTIONS(3468),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3466),
    [anon_sym_or] = ACTIONS(3468),
    [aux_sym_char_token1] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3468),
    [anon_sym_DQUOTE] = ACTIONS(3468),
    [anon_sym_AT_DQUOTE] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [sym_bool] = ACTIONS(3468),
    [sym_unit] = ACTIONS(3466),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3468),
    [sym_op_identifier] = ACTIONS(3468),
    [anon_sym_PLUS] = ACTIONS(3468),
    [anon_sym_DASH] = ACTIONS(3468),
    [anon_sym_PLUS_DOT] = ACTIONS(3468),
    [anon_sym_DASH_DOT] = ACTIONS(3468),
    [anon_sym_PERCENT] = ACTIONS(3468),
    [anon_sym_AMP_AMP] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3466),
    [aux_sym_prefix_op_token1] = ACTIONS(3468),
    [aux_sym_infix_op_token1] = ACTIONS(3466),
    [aux_sym_infix_op_token2] = ACTIONS(3468),
    [anon_sym_PIPE_PIPE] = ACTIONS(3468),
    [anon_sym_BANG_EQ] = ACTIONS(3468),
    [anon_sym_COLON_EQ] = ACTIONS(3466),
    [anon_sym_DOLLAR] = ACTIONS(3468),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3468),
    [sym_int] = ACTIONS(3468),
    [sym_xint] = ACTIONS(3466),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3466),
    [sym__newline] = ACTIONS(3466),
  },
  [2576] = {
    [sym__else_expression] = STATE(3222),
    [sym_elif_expression] = STATE(2822),
    [sym_block_comment] = STATE(2576),
    [sym_compiler_directive_decl] = STATE(2576),
    [sym_fsi_directive_decl] = STATE(2576),
    [sym_preproc_line] = STATE(2576),
    [aux_sym_if_expression_repeat1] = STATE(2714),
    [sym_identifier] = ACTIONS(3457),
    [anon_sym_EQ] = ACTIONS(3455),
    [anon_sym_COLON] = ACTIONS(3457),
    [anon_sym_return] = ACTIONS(3457),
    [anon_sym_do] = ACTIONS(3457),
    [anon_sym_let] = ACTIONS(3457),
    [anon_sym_let_BANG] = ACTIONS(3455),
    [anon_sym_LPAREN] = ACTIONS(3457),
    [anon_sym_COMMA] = ACTIONS(3455),
    [anon_sym_null] = ACTIONS(3457),
    [anon_sym_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_COLON] = ACTIONS(3455),
    [anon_sym_AMP] = ACTIONS(3457),
    [anon_sym_LBRACK] = ACTIONS(3457),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3457),
    [anon_sym_LT_AT] = ACTIONS(3457),
    [anon_sym_LT_AT_AT] = ACTIONS(3457),
    [anon_sym_DOT] = ACTIONS(3457),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3457),
    [anon_sym_return_BANG] = ACTIONS(3455),
    [anon_sym_yield] = ACTIONS(3457),
    [anon_sym_yield_BANG] = ACTIONS(3455),
    [anon_sym_lazy] = ACTIONS(3457),
    [anon_sym_assert] = ACTIONS(3457),
    [anon_sym_upcast] = ACTIONS(3457),
    [anon_sym_downcast] = ACTIONS(3457),
    [anon_sym_COLON_GT] = ACTIONS(3455),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3457),
    [anon_sym_while] = ACTIONS(3457),
    [anon_sym_else] = ACTIONS(5040),
    [anon_sym_elif] = ACTIONS(5042),
    [anon_sym_if] = ACTIONS(3457),
    [anon_sym_fun] = ACTIONS(3457),
    [anon_sym_try] = ACTIONS(3457),
    [anon_sym_match] = ACTIONS(3457),
    [anon_sym_match_BANG] = ACTIONS(3455),
    [anon_sym_function] = ACTIONS(3457),
    [anon_sym_LT_DASH] = ACTIONS(3457),
    [anon_sym_DOT_LBRACK] = ACTIONS(3455),
    [anon_sym_LT] = ACTIONS(3455),
    [anon_sym_GT] = ACTIONS(3457),
    [anon_sym_use] = ACTIONS(3457),
    [anon_sym_use_BANG] = ACTIONS(3455),
    [anon_sym_do_BANG] = ACTIONS(3455),
    [anon_sym_begin] = ACTIONS(3457),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_or] = ACTIONS(3457),
    [aux_sym_char_token1] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [anon_sym_AT_DQUOTE] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [sym_bool] = ACTIONS(3457),
    [sym_unit] = ACTIONS(3455),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3457),
    [sym_op_identifier] = ACTIONS(3457),
    [anon_sym_PLUS] = ACTIONS(3457),
    [anon_sym_DASH] = ACTIONS(3457),
    [anon_sym_PLUS_DOT] = ACTIONS(3457),
    [anon_sym_DASH_DOT] = ACTIONS(3457),
    [anon_sym_PERCENT] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3455),
    [aux_sym_prefix_op_token1] = ACTIONS(3457),
    [aux_sym_infix_op_token1] = ACTIONS(3455),
    [aux_sym_infix_op_token2] = ACTIONS(3457),
    [anon_sym_PIPE_PIPE] = ACTIONS(3457),
    [anon_sym_BANG_EQ] = ACTIONS(3457),
    [anon_sym_COLON_EQ] = ACTIONS(3455),
    [anon_sym_DOLLAR] = ACTIONS(3457),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3457),
    [sym_int] = ACTIONS(3457),
    [sym_xint] = ACTIONS(3455),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3455),
    [sym__newline] = ACTIONS(3455),
  },
  [2577] = {
    [sym__else_expression] = STATE(3491),
    [sym_elif_expression] = STATE(2860),
    [sym_block_comment] = STATE(2577),
    [sym_compiler_directive_decl] = STATE(2577),
    [sym_fsi_directive_decl] = STATE(2577),
    [sym_preproc_line] = STATE(2577),
    [aux_sym_if_expression_repeat1] = STATE(2567),
    [sym_identifier] = ACTIONS(3472),
    [anon_sym_EQ] = ACTIONS(3470),
    [anon_sym_COLON] = ACTIONS(3472),
    [anon_sym_return] = ACTIONS(3472),
    [anon_sym_do] = ACTIONS(3472),
    [anon_sym_let] = ACTIONS(3472),
    [anon_sym_let_BANG] = ACTIONS(3470),
    [anon_sym_LPAREN] = ACTIONS(3472),
    [anon_sym_COMMA] = ACTIONS(3470),
    [anon_sym_null] = ACTIONS(3472),
    [anon_sym_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_COLON] = ACTIONS(3470),
    [anon_sym_AMP] = ACTIONS(3472),
    [anon_sym_LBRACK] = ACTIONS(3472),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3470),
    [anon_sym_LBRACE] = ACTIONS(3472),
    [anon_sym_LT_AT] = ACTIONS(3472),
    [anon_sym_LT_AT_AT] = ACTIONS(3472),
    [anon_sym_AT_AT_GT] = ACTIONS(3472),
    [anon_sym_DOT] = ACTIONS(3472),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3470),
    [anon_sym_new] = ACTIONS(3472),
    [anon_sym_return_BANG] = ACTIONS(3470),
    [anon_sym_yield] = ACTIONS(3472),
    [anon_sym_yield_BANG] = ACTIONS(3470),
    [anon_sym_lazy] = ACTIONS(3472),
    [anon_sym_assert] = ACTIONS(3472),
    [anon_sym_upcast] = ACTIONS(3472),
    [anon_sym_downcast] = ACTIONS(3472),
    [anon_sym_COLON_GT] = ACTIONS(3470),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3470),
    [anon_sym_for] = ACTIONS(3472),
    [anon_sym_while] = ACTIONS(3472),
    [anon_sym_else] = ACTIONS(5020),
    [anon_sym_elif] = ACTIONS(5022),
    [anon_sym_if] = ACTIONS(3472),
    [anon_sym_fun] = ACTIONS(3472),
    [anon_sym_try] = ACTIONS(3472),
    [anon_sym_match] = ACTIONS(3472),
    [anon_sym_match_BANG] = ACTIONS(3470),
    [anon_sym_function] = ACTIONS(3472),
    [anon_sym_LT_DASH] = ACTIONS(3472),
    [anon_sym_DOT_LBRACK] = ACTIONS(3470),
    [anon_sym_LT] = ACTIONS(3470),
    [anon_sym_use] = ACTIONS(3472),
    [anon_sym_use_BANG] = ACTIONS(3470),
    [anon_sym_do_BANG] = ACTIONS(3470),
    [anon_sym_begin] = ACTIONS(3472),
    [anon_sym_LPAREN2] = ACTIONS(3472),
    [anon_sym_or] = ACTIONS(3472),
    [aux_sym_char_token1] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3472),
    [anon_sym_DQUOTE] = ACTIONS(3472),
    [anon_sym_AT_DQUOTE] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [sym_bool] = ACTIONS(3472),
    [sym_unit] = ACTIONS(3470),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3472),
    [sym_op_identifier] = ACTIONS(3472),
    [anon_sym_PLUS] = ACTIONS(3472),
    [anon_sym_DASH] = ACTIONS(3472),
    [anon_sym_PLUS_DOT] = ACTIONS(3472),
    [anon_sym_DASH_DOT] = ACTIONS(3472),
    [anon_sym_PERCENT] = ACTIONS(3472),
    [anon_sym_AMP_AMP] = ACTIONS(3472),
    [anon_sym_TILDE] = ACTIONS(3470),
    [aux_sym_prefix_op_token1] = ACTIONS(3472),
    [aux_sym_infix_op_token1] = ACTIONS(3470),
    [aux_sym_infix_op_token2] = ACTIONS(3472),
    [anon_sym_PIPE_PIPE] = ACTIONS(3472),
    [anon_sym_BANG_EQ] = ACTIONS(3472),
    [anon_sym_COLON_EQ] = ACTIONS(3470),
    [anon_sym_DOLLAR] = ACTIONS(3472),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3472),
    [sym_int] = ACTIONS(3472),
    [sym_xint] = ACTIONS(3470),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3470),
    [sym__newline] = ACTIONS(3470),
  },
  [2578] = {
    [sym_block_comment] = STATE(2578),
    [sym_compiler_directive_decl] = STATE(2578),
    [sym_fsi_directive_decl] = STATE(2578),
    [sym_preproc_line] = STATE(2578),
    [aux_sym_long_identifier_repeat1] = STATE(2584),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_AT_AT_GT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(5033),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_DASH_GT] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_STAR] = ACTIONS(3451),
    [anon_sym_LT2] = ACTIONS(3451),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3449),
    [anon_sym_or] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
  },
  [2579] = {
    [sym_block_comment] = STATE(2579),
    [sym_compiler_directive_decl] = STATE(2579),
    [sym_fsi_directive_decl] = STATE(2579),
    [sym_preproc_line] = STATE(2579),
    [aux_sym_type_argument_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_COLON] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_LT_DASH] = ACTIONS(3480),
    [anon_sym_DOT_LBRACK] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_GT] = ACTIONS(3480),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_or] = ACTIONS(5044),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3480),
    [anon_sym_DASH_DOT] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3480),
    [aux_sym_infix_op_token1] = ACTIONS(3478),
    [aux_sym_infix_op_token2] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3480),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
  },
  [2580] = {
    [sym_attributes] = STATE(7112),
    [sym__attribute_set] = STATE(6370),
    [sym_function_or_value_defn] = STATE(3854),
    [sym_access_modifier] = STATE(10931),
    [sym__class_function_or_value_defn] = STATE(3860),
    [aux_sym__type_extension_inner] = STATE(2580),
    [sym__type_defn_elements] = STATE(3860),
    [sym_interface_implementation] = STATE(3863),
    [sym_member_defn] = STATE(3863),
    [sym_additional_constr_defn] = STATE(3864),
    [sym_block_comment] = STATE(2580),
    [sym_compiler_directive_decl] = STATE(2580),
    [sym_fsi_directive_decl] = STATE(2580),
    [sym_preproc_line] = STATE(2580),
    [sym_preproc_if_in_class_definition] = STATE(3860),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [ts_builtin_sym_end] = ACTIONS(5047),
    [sym_identifier] = ACTIONS(5049),
    [anon_sym_namespace] = ACTIONS(5049),
    [anon_sym_module] = ACTIONS(5049),
    [anon_sym_open] = ACTIONS(5049),
    [anon_sym_LBRACK_LT] = ACTIONS(5051),
    [anon_sym_return] = ACTIONS(5049),
    [anon_sym_type] = ACTIONS(5049),
    [anon_sym_do] = ACTIONS(5054),
    [anon_sym_and] = ACTIONS(5049),
    [anon_sym_let] = ACTIONS(5057),
    [anon_sym_let_BANG] = ACTIONS(5060),
    [aux_sym_access_modifier_token1] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(5049),
    [anon_sym_null] = ACTIONS(5049),
    [anon_sym_AMP] = ACTIONS(5049),
    [anon_sym_LBRACK] = ACTIONS(5049),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5047),
    [anon_sym_LBRACE] = ACTIONS(5049),
    [anon_sym_LT_AT] = ACTIONS(5049),
    [anon_sym_LT_AT_AT] = ACTIONS(5047),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5047),
    [anon_sym_new] = ACTIONS(5066),
    [anon_sym_return_BANG] = ACTIONS(5047),
    [anon_sym_yield] = ACTIONS(5049),
    [anon_sym_yield_BANG] = ACTIONS(5047),
    [anon_sym_lazy] = ACTIONS(5049),
    [anon_sym_assert] = ACTIONS(5049),
    [anon_sym_upcast] = ACTIONS(5049),
    [anon_sym_downcast] = ACTIONS(5049),
    [anon_sym_for] = ACTIONS(5049),
    [anon_sym_while] = ACTIONS(5049),
    [anon_sym_if] = ACTIONS(5049),
    [anon_sym_fun] = ACTIONS(5049),
    [anon_sym_try] = ACTIONS(5049),
    [anon_sym_match] = ACTIONS(5049),
    [anon_sym_match_BANG] = ACTIONS(5047),
    [anon_sym_function] = ACTIONS(5049),
    [anon_sym_use] = ACTIONS(5049),
    [anon_sym_use_BANG] = ACTIONS(5047),
    [anon_sym_do_BANG] = ACTIONS(5047),
    [anon_sym_begin] = ACTIONS(5049),
    [anon_sym_default] = ACTIONS(5069),
    [anon_sym_static] = ACTIONS(5072),
    [anon_sym_member] = ACTIONS(5075),
    [anon_sym_interface] = ACTIONS(5078),
    [anon_sym_exception] = ACTIONS(5049),
    [anon_sym_abstract] = ACTIONS(5081),
    [anon_sym_val] = ACTIONS(5084),
    [anon_sym_override] = ACTIONS(5069),
    [aux_sym_char_token1] = ACTIONS(5047),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5049),
    [anon_sym_DQUOTE] = ACTIONS(5049),
    [anon_sym_AT_DQUOTE] = ACTIONS(5047),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5047),
    [sym_bool] = ACTIONS(5049),
    [sym_unit] = ACTIONS(5047),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5049),
    [sym_op_identifier] = ACTIONS(5047),
    [anon_sym_PLUS] = ACTIONS(5049),
    [anon_sym_DASH] = ACTIONS(5049),
    [anon_sym_PLUS_DOT] = ACTIONS(5047),
    [anon_sym_DASH_DOT] = ACTIONS(5047),
    [anon_sym_PERCENT] = ACTIONS(5047),
    [anon_sym_AMP_AMP] = ACTIONS(5047),
    [anon_sym_TILDE] = ACTIONS(5047),
    [aux_sym_prefix_op_token1] = ACTIONS(5047),
    [sym_int] = ACTIONS(5049),
    [sym_xint] = ACTIONS(5047),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5047),
    [anon_sym_POUNDload] = ACTIONS(5047),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(5087),
  },
  [2581] = {
    [sym__else_expression] = STATE(3280),
    [sym_elif_expression] = STATE(2826),
    [sym_block_comment] = STATE(2581),
    [sym_compiler_directive_decl] = STATE(2581),
    [sym_fsi_directive_decl] = STATE(2581),
    [sym_preproc_line] = STATE(2581),
    [aux_sym_if_expression_repeat1] = STATE(2694),
    [sym_identifier] = ACTIONS(3457),
    [anon_sym_EQ] = ACTIONS(3455),
    [anon_sym_COLON] = ACTIONS(3457),
    [anon_sym_return] = ACTIONS(3457),
    [anon_sym_do] = ACTIONS(3457),
    [anon_sym_let] = ACTIONS(3457),
    [anon_sym_let_BANG] = ACTIONS(3455),
    [anon_sym_LPAREN] = ACTIONS(3457),
    [anon_sym_COMMA] = ACTIONS(3455),
    [anon_sym_null] = ACTIONS(3457),
    [anon_sym_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_COLON] = ACTIONS(3455),
    [anon_sym_AMP] = ACTIONS(3457),
    [anon_sym_LBRACK] = ACTIONS(3457),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3457),
    [anon_sym_LT_AT] = ACTIONS(3457),
    [anon_sym_LT_AT_AT] = ACTIONS(3457),
    [anon_sym_DOT] = ACTIONS(3457),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3457),
    [anon_sym_return_BANG] = ACTIONS(3455),
    [anon_sym_yield] = ACTIONS(3457),
    [anon_sym_yield_BANG] = ACTIONS(3455),
    [anon_sym_lazy] = ACTIONS(3457),
    [anon_sym_assert] = ACTIONS(3457),
    [anon_sym_upcast] = ACTIONS(3457),
    [anon_sym_downcast] = ACTIONS(3457),
    [anon_sym_COLON_GT] = ACTIONS(3455),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3457),
    [anon_sym_while] = ACTIONS(3457),
    [anon_sym_else] = ACTIONS(5090),
    [anon_sym_elif] = ACTIONS(5092),
    [anon_sym_if] = ACTIONS(3457),
    [anon_sym_fun] = ACTIONS(3457),
    [anon_sym_try] = ACTIONS(3457),
    [anon_sym_match] = ACTIONS(3457),
    [anon_sym_match_BANG] = ACTIONS(3455),
    [anon_sym_function] = ACTIONS(3457),
    [anon_sym_LT_DASH] = ACTIONS(3457),
    [anon_sym_DOT_LBRACK] = ACTIONS(3455),
    [anon_sym_LT] = ACTIONS(3455),
    [anon_sym_use] = ACTIONS(3457),
    [anon_sym_use_BANG] = ACTIONS(3455),
    [anon_sym_do_BANG] = ACTIONS(3455),
    [anon_sym_DOT_DOT] = ACTIONS(3455),
    [anon_sym_begin] = ACTIONS(3457),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_or] = ACTIONS(3457),
    [aux_sym_char_token1] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [anon_sym_AT_DQUOTE] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [sym_bool] = ACTIONS(3457),
    [sym_unit] = ACTIONS(3455),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3457),
    [sym_op_identifier] = ACTIONS(3457),
    [anon_sym_PLUS] = ACTIONS(3457),
    [anon_sym_DASH] = ACTIONS(3457),
    [anon_sym_PLUS_DOT] = ACTIONS(3457),
    [anon_sym_DASH_DOT] = ACTIONS(3457),
    [anon_sym_PERCENT] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3455),
    [aux_sym_prefix_op_token1] = ACTIONS(3457),
    [aux_sym_infix_op_token1] = ACTIONS(3455),
    [aux_sym_infix_op_token2] = ACTIONS(3457),
    [anon_sym_PIPE_PIPE] = ACTIONS(3457),
    [anon_sym_BANG_EQ] = ACTIONS(3457),
    [anon_sym_COLON_EQ] = ACTIONS(3455),
    [anon_sym_DOLLAR] = ACTIONS(3457),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3457),
    [sym_int] = ACTIONS(3457),
    [sym_xint] = ACTIONS(3455),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3455),
    [sym__newline] = ACTIONS(3455),
  },
  [2582] = {
    [sym_block_comment] = STATE(2582),
    [sym_compiler_directive_decl] = STATE(2582),
    [sym_fsi_directive_decl] = STATE(2582),
    [sym_preproc_line] = STATE(2582),
    [aux_sym_type_argument_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(3476),
    [anon_sym_EQ] = ACTIONS(3474),
    [anon_sym_COLON] = ACTIONS(3476),
    [anon_sym_return] = ACTIONS(3476),
    [anon_sym_do] = ACTIONS(3476),
    [anon_sym_let] = ACTIONS(3476),
    [anon_sym_let_BANG] = ACTIONS(3474),
    [anon_sym_LPAREN] = ACTIONS(3476),
    [anon_sym_COMMA] = ACTIONS(3474),
    [anon_sym_null] = ACTIONS(3476),
    [anon_sym_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_COLON] = ACTIONS(3474),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym_LBRACK] = ACTIONS(3476),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3474),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_LT_AT] = ACTIONS(3476),
    [anon_sym_LT_AT_AT] = ACTIONS(3476),
    [anon_sym_DOT] = ACTIONS(3476),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3474),
    [anon_sym_new] = ACTIONS(3476),
    [anon_sym_return_BANG] = ACTIONS(3474),
    [anon_sym_yield] = ACTIONS(3476),
    [anon_sym_yield_BANG] = ACTIONS(3474),
    [anon_sym_lazy] = ACTIONS(3476),
    [anon_sym_assert] = ACTIONS(3476),
    [anon_sym_upcast] = ACTIONS(3476),
    [anon_sym_downcast] = ACTIONS(3476),
    [anon_sym_COLON_GT] = ACTIONS(3474),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3474),
    [anon_sym_for] = ACTIONS(3476),
    [anon_sym_while] = ACTIONS(3476),
    [anon_sym_if] = ACTIONS(3476),
    [anon_sym_fun] = ACTIONS(3476),
    [anon_sym_DASH_GT] = ACTIONS(3476),
    [anon_sym_try] = ACTIONS(3476),
    [anon_sym_match] = ACTIONS(3476),
    [anon_sym_match_BANG] = ACTIONS(3474),
    [anon_sym_function] = ACTIONS(3476),
    [anon_sym_LT_DASH] = ACTIONS(3476),
    [anon_sym_DOT_LBRACK] = ACTIONS(3474),
    [anon_sym_LT] = ACTIONS(3474),
    [anon_sym_GT] = ACTIONS(3476),
    [anon_sym_use] = ACTIONS(3476),
    [anon_sym_use_BANG] = ACTIONS(3474),
    [anon_sym_do_BANG] = ACTIONS(3474),
    [anon_sym_begin] = ACTIONS(3476),
    [anon_sym_LPAREN2] = ACTIONS(3476),
    [anon_sym_STAR] = ACTIONS(3476),
    [anon_sym_LT2] = ACTIONS(3476),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3474),
    [anon_sym_or] = ACTIONS(3476),
    [aux_sym_char_token1] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3476),
    [anon_sym_DQUOTE] = ACTIONS(3476),
    [anon_sym_AT_DQUOTE] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [sym_bool] = ACTIONS(3476),
    [sym_unit] = ACTIONS(3474),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3476),
    [sym_op_identifier] = ACTIONS(3476),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3476),
    [anon_sym_PLUS_DOT] = ACTIONS(3476),
    [anon_sym_DASH_DOT] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [anon_sym_AMP_AMP] = ACTIONS(3476),
    [anon_sym_TILDE] = ACTIONS(3474),
    [aux_sym_prefix_op_token1] = ACTIONS(3476),
    [aux_sym_infix_op_token1] = ACTIONS(3474),
    [aux_sym_infix_op_token2] = ACTIONS(3476),
    [anon_sym_PIPE_PIPE] = ACTIONS(3476),
    [anon_sym_BANG_EQ] = ACTIONS(3476),
    [anon_sym_COLON_EQ] = ACTIONS(3474),
    [anon_sym_DOLLAR] = ACTIONS(3476),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3476),
    [sym_int] = ACTIONS(3476),
    [sym_xint] = ACTIONS(3474),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3474),
    [sym__newline] = ACTIONS(3474),
  },
  [2583] = {
    [sym_block_comment] = STATE(2583),
    [sym_compiler_directive_decl] = STATE(2583),
    [sym_fsi_directive_decl] = STATE(2583),
    [sym_preproc_line] = STATE(2583),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [anon_sym_as] = ACTIONS(3498),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_with] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [anon_sym_DOT_LBRACK] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_or] = ACTIONS(3498),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3498),
    [anon_sym_DASH_DOT] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3498),
    [aux_sym_infix_op_token1] = ACTIONS(3496),
    [aux_sym_infix_op_token2] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_COLON_EQ] = ACTIONS(3496),
    [anon_sym_DOLLAR] = ACTIONS(3498),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3498),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
  },
  [2584] = {
    [sym_block_comment] = STATE(2584),
    [sym_compiler_directive_decl] = STATE(2584),
    [sym_fsi_directive_decl] = STATE(2584),
    [sym_preproc_line] = STATE(2584),
    [aux_sym_long_identifier_repeat1] = STATE(2584),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_AT_AT_GT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(5094),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [2585] = {
    [sym_block_comment] = STATE(2585),
    [sym_compiler_directive_decl] = STATE(2585),
    [sym_fsi_directive_decl] = STATE(2585),
    [sym_preproc_line] = STATE(2585),
    [sym_identifier] = ACTIONS(3511),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3511),
    [anon_sym_return] = ACTIONS(3511),
    [anon_sym_do] = ACTIONS(3511),
    [anon_sym_let] = ACTIONS(3511),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_as] = ACTIONS(3511),
    [anon_sym_LPAREN] = ACTIONS(3511),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3511),
    [anon_sym_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(3511),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_LT_AT] = ACTIONS(3511),
    [anon_sym_LT_AT_AT] = ACTIONS(3511),
    [anon_sym_DOT] = ACTIONS(3511),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3511),
    [anon_sym_with] = ACTIONS(3511),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3511),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3511),
    [anon_sym_assert] = ACTIONS(3511),
    [anon_sym_upcast] = ACTIONS(3511),
    [anon_sym_downcast] = ACTIONS(3511),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3511),
    [anon_sym_while] = ACTIONS(3511),
    [anon_sym_if] = ACTIONS(3511),
    [anon_sym_fun] = ACTIONS(3511),
    [anon_sym_DASH_GT] = ACTIONS(3511),
    [anon_sym_try] = ACTIONS(3511),
    [anon_sym_match] = ACTIONS(3511),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3511),
    [anon_sym_LT_DASH] = ACTIONS(3511),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3511),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3511),
    [anon_sym_LPAREN2] = ACTIONS(3511),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_LT2] = ACTIONS(3511),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3511),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3511),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3511),
    [sym_unit] = ACTIONS(3509),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3511),
    [sym_op_identifier] = ACTIONS(3511),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3511),
    [anon_sym_PLUS_DOT] = ACTIONS(3511),
    [anon_sym_DASH_DOT] = ACTIONS(3511),
    [anon_sym_PERCENT] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3511),
    [aux_sym_infix_op_token1] = ACTIONS(3509),
    [aux_sym_infix_op_token2] = ACTIONS(3511),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_BANG_EQ] = ACTIONS(3511),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3511),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3511),
    [sym_int] = ACTIONS(3511),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [2586] = {
    [sym_block_comment] = STATE(2586),
    [sym_compiler_directive_decl] = STATE(2586),
    [sym_fsi_directive_decl] = STATE(2586),
    [sym_preproc_line] = STATE(2586),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [anon_sym_as] = ACTIONS(3480),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_COLON] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_with] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_LT_DASH] = ACTIONS(3480),
    [anon_sym_DOT_LBRACK] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_or] = ACTIONS(3480),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3480),
    [anon_sym_DASH_DOT] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3480),
    [aux_sym_infix_op_token1] = ACTIONS(3478),
    [aux_sym_infix_op_token2] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3480),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
  },
  [2587] = {
    [sym_block_comment] = STATE(2587),
    [sym_compiler_directive_decl] = STATE(2587),
    [sym_fsi_directive_decl] = STATE(2587),
    [sym_preproc_line] = STATE(2587),
    [sym_identifier] = ACTIONS(3519),
    [anon_sym_EQ] = ACTIONS(3517),
    [anon_sym_COLON] = ACTIONS(3519),
    [anon_sym_return] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(3519),
    [anon_sym_let] = ACTIONS(3519),
    [anon_sym_let_BANG] = ACTIONS(3517),
    [anon_sym_as] = ACTIONS(3519),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [anon_sym_COMMA] = ACTIONS(3517),
    [anon_sym_null] = ACTIONS(3519),
    [anon_sym_QMARK] = ACTIONS(3519),
    [anon_sym_COLON_QMARK] = ACTIONS(3519),
    [anon_sym_COLON_COLON] = ACTIONS(3517),
    [anon_sym_AMP] = ACTIONS(3519),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_LT_AT] = ACTIONS(3519),
    [anon_sym_LT_AT_AT] = ACTIONS(3519),
    [anon_sym_DOT] = ACTIONS(3519),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3519),
    [anon_sym_with] = ACTIONS(3519),
    [anon_sym_return_BANG] = ACTIONS(3517),
    [anon_sym_yield] = ACTIONS(3519),
    [anon_sym_yield_BANG] = ACTIONS(3517),
    [anon_sym_lazy] = ACTIONS(3519),
    [anon_sym_assert] = ACTIONS(3519),
    [anon_sym_upcast] = ACTIONS(3519),
    [anon_sym_downcast] = ACTIONS(3519),
    [anon_sym_COLON_GT] = ACTIONS(3517),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3517),
    [anon_sym_for] = ACTIONS(3519),
    [anon_sym_while] = ACTIONS(3519),
    [anon_sym_if] = ACTIONS(3519),
    [anon_sym_fun] = ACTIONS(3519),
    [anon_sym_DASH_GT] = ACTIONS(3519),
    [anon_sym_try] = ACTIONS(3519),
    [anon_sym_match] = ACTIONS(3519),
    [anon_sym_match_BANG] = ACTIONS(3517),
    [anon_sym_function] = ACTIONS(3519),
    [anon_sym_LT_DASH] = ACTIONS(3519),
    [anon_sym_DOT_LBRACK] = ACTIONS(3517),
    [anon_sym_LT] = ACTIONS(3517),
    [anon_sym_use] = ACTIONS(3519),
    [anon_sym_use_BANG] = ACTIONS(3517),
    [anon_sym_do_BANG] = ACTIONS(3517),
    [anon_sym_begin] = ACTIONS(3519),
    [anon_sym_LPAREN2] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_LT2] = ACTIONS(3519),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3517),
    [anon_sym_or] = ACTIONS(3519),
    [aux_sym_char_token1] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [anon_sym_AT_DQUOTE] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [sym_bool] = ACTIONS(3519),
    [sym_unit] = ACTIONS(3517),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3519),
    [sym_op_identifier] = ACTIONS(3519),
    [anon_sym_PLUS] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_DOT] = ACTIONS(3519),
    [anon_sym_DASH_DOT] = ACTIONS(3519),
    [anon_sym_PERCENT] = ACTIONS(3519),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3517),
    [aux_sym_prefix_op_token1] = ACTIONS(3519),
    [aux_sym_infix_op_token1] = ACTIONS(3517),
    [aux_sym_infix_op_token2] = ACTIONS(3519),
    [anon_sym_PIPE_PIPE] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_COLON_EQ] = ACTIONS(3517),
    [anon_sym_DOLLAR] = ACTIONS(3519),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3519),
    [sym_int] = ACTIONS(3519),
    [sym_xint] = ACTIONS(3517),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3517),
    [sym__newline] = ACTIONS(3517),
  },
  [2588] = {
    [sym_block_comment] = STATE(2588),
    [sym_compiler_directive_decl] = STATE(2588),
    [sym_fsi_directive_decl] = STATE(2588),
    [sym_preproc_line] = STATE(2588),
    [aux_sym_long_identifier_repeat1] = STATE(2588),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_AT_GT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(5097),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [2589] = {
    [sym_elif_expression] = STATE(2768),
    [sym_block_comment] = STATE(2589),
    [sym_compiler_directive_decl] = STATE(2589),
    [sym_fsi_directive_decl] = STATE(2589),
    [sym_preproc_line] = STATE(2589),
    [aux_sym_if_expression_repeat1] = STATE(2589),
    [sym_identifier] = ACTIONS(3555),
    [anon_sym_EQ] = ACTIONS(3553),
    [anon_sym_COLON] = ACTIONS(3555),
    [anon_sym_return] = ACTIONS(3555),
    [anon_sym_do] = ACTIONS(3555),
    [anon_sym_let] = ACTIONS(3555),
    [anon_sym_let_BANG] = ACTIONS(3553),
    [anon_sym_as] = ACTIONS(3555),
    [anon_sym_LPAREN] = ACTIONS(3555),
    [anon_sym_COMMA] = ACTIONS(3553),
    [anon_sym_null] = ACTIONS(3555),
    [anon_sym_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_COLON] = ACTIONS(3553),
    [anon_sym_AMP] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(3555),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3553),
    [anon_sym_LBRACE] = ACTIONS(3555),
    [anon_sym_LT_AT] = ACTIONS(3555),
    [anon_sym_LT_AT_AT] = ACTIONS(3555),
    [anon_sym_DOT] = ACTIONS(3555),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3553),
    [anon_sym_new] = ACTIONS(3555),
    [anon_sym_with] = ACTIONS(3555),
    [anon_sym_return_BANG] = ACTIONS(3553),
    [anon_sym_yield] = ACTIONS(3555),
    [anon_sym_yield_BANG] = ACTIONS(3553),
    [anon_sym_lazy] = ACTIONS(3555),
    [anon_sym_assert] = ACTIONS(3555),
    [anon_sym_upcast] = ACTIONS(3555),
    [anon_sym_downcast] = ACTIONS(3555),
    [anon_sym_COLON_GT] = ACTIONS(3553),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3553),
    [anon_sym_for] = ACTIONS(3555),
    [anon_sym_while] = ACTIONS(3555),
    [anon_sym_else] = ACTIONS(3555),
    [anon_sym_elif] = ACTIONS(5100),
    [anon_sym_if] = ACTIONS(3555),
    [anon_sym_fun] = ACTIONS(3555),
    [anon_sym_try] = ACTIONS(3555),
    [anon_sym_match] = ACTIONS(3555),
    [anon_sym_match_BANG] = ACTIONS(3553),
    [anon_sym_function] = ACTIONS(3555),
    [anon_sym_LT_DASH] = ACTIONS(3555),
    [anon_sym_DOT_LBRACK] = ACTIONS(3553),
    [anon_sym_LT] = ACTIONS(3553),
    [anon_sym_use] = ACTIONS(3555),
    [anon_sym_use_BANG] = ACTIONS(3553),
    [anon_sym_do_BANG] = ACTIONS(3553),
    [anon_sym_begin] = ACTIONS(3555),
    [anon_sym_LPAREN2] = ACTIONS(3555),
    [anon_sym_or] = ACTIONS(3555),
    [aux_sym_char_token1] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3555),
    [anon_sym_DQUOTE] = ACTIONS(3555),
    [anon_sym_AT_DQUOTE] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [sym_bool] = ACTIONS(3555),
    [sym_unit] = ACTIONS(3553),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3555),
    [sym_op_identifier] = ACTIONS(3555),
    [anon_sym_PLUS] = ACTIONS(3555),
    [anon_sym_DASH] = ACTIONS(3555),
    [anon_sym_PLUS_DOT] = ACTIONS(3555),
    [anon_sym_DASH_DOT] = ACTIONS(3555),
    [anon_sym_PERCENT] = ACTIONS(3555),
    [anon_sym_AMP_AMP] = ACTIONS(3555),
    [anon_sym_TILDE] = ACTIONS(3553),
    [aux_sym_prefix_op_token1] = ACTIONS(3555),
    [aux_sym_infix_op_token1] = ACTIONS(3553),
    [aux_sym_infix_op_token2] = ACTIONS(3555),
    [anon_sym_PIPE_PIPE] = ACTIONS(3555),
    [anon_sym_BANG_EQ] = ACTIONS(3555),
    [anon_sym_COLON_EQ] = ACTIONS(3553),
    [anon_sym_DOLLAR] = ACTIONS(3555),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3555),
    [sym_int] = ACTIONS(3555),
    [sym_xint] = ACTIONS(3553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3553),
    [sym__newline] = ACTIONS(3553),
  },
  [2590] = {
    [sym_block_comment] = STATE(2590),
    [sym_compiler_directive_decl] = STATE(2590),
    [sym_fsi_directive_decl] = STATE(2590),
    [sym_preproc_line] = STATE(2590),
    [aux_sym_long_identifier_repeat1] = STATE(2599),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_EQ] = ACTIONS(3492),
    [anon_sym_COLON] = ACTIONS(3494),
    [anon_sym_return] = ACTIONS(3494),
    [anon_sym_do] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_let_BANG] = ACTIONS(3492),
    [anon_sym_LPAREN] = ACTIONS(3494),
    [anon_sym_COMMA] = ACTIONS(3492),
    [anon_sym_null] = ACTIONS(3494),
    [anon_sym_QMARK] = ACTIONS(3494),
    [anon_sym_COLON_QMARK] = ACTIONS(3494),
    [anon_sym_COLON_COLON] = ACTIONS(3492),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3492),
    [anon_sym_LBRACE] = ACTIONS(3494),
    [anon_sym_LT_AT] = ACTIONS(3494),
    [anon_sym_AT_GT] = ACTIONS(3494),
    [anon_sym_LT_AT_AT] = ACTIONS(3494),
    [anon_sym_DOT] = ACTIONS(5103),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3492),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_return_BANG] = ACTIONS(3492),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_yield_BANG] = ACTIONS(3492),
    [anon_sym_lazy] = ACTIONS(3494),
    [anon_sym_assert] = ACTIONS(3494),
    [anon_sym_upcast] = ACTIONS(3494),
    [anon_sym_downcast] = ACTIONS(3494),
    [anon_sym_COLON_GT] = ACTIONS(3492),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3492),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_while] = ACTIONS(3494),
    [anon_sym_if] = ACTIONS(3494),
    [anon_sym_fun] = ACTIONS(3494),
    [anon_sym_DASH_GT] = ACTIONS(3494),
    [anon_sym_try] = ACTIONS(3494),
    [anon_sym_match] = ACTIONS(3494),
    [anon_sym_match_BANG] = ACTIONS(3492),
    [anon_sym_function] = ACTIONS(3494),
    [anon_sym_LT_DASH] = ACTIONS(3494),
    [anon_sym_DOT_LBRACK] = ACTIONS(3492),
    [anon_sym_LT] = ACTIONS(3492),
    [anon_sym_use] = ACTIONS(3494),
    [anon_sym_use_BANG] = ACTIONS(3492),
    [anon_sym_do_BANG] = ACTIONS(3492),
    [anon_sym_begin] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(3494),
    [anon_sym_STAR] = ACTIONS(3494),
    [anon_sym_LT2] = ACTIONS(3494),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3492),
    [anon_sym_or] = ACTIONS(3494),
    [aux_sym_char_token1] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3494),
    [anon_sym_DQUOTE] = ACTIONS(3494),
    [anon_sym_AT_DQUOTE] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [sym_bool] = ACTIONS(3494),
    [sym_unit] = ACTIONS(3492),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3494),
    [sym_op_identifier] = ACTIONS(3494),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_PLUS_DOT] = ACTIONS(3494),
    [anon_sym_DASH_DOT] = ACTIONS(3494),
    [anon_sym_PERCENT] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_TILDE] = ACTIONS(3492),
    [aux_sym_prefix_op_token1] = ACTIONS(3494),
    [aux_sym_infix_op_token1] = ACTIONS(3492),
    [aux_sym_infix_op_token2] = ACTIONS(3494),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_COLON_EQ] = ACTIONS(3492),
    [anon_sym_DOLLAR] = ACTIONS(3494),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3494),
    [sym_int] = ACTIONS(3494),
    [sym_xint] = ACTIONS(3492),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3492),
    [sym__newline] = ACTIONS(3492),
  },
  [2591] = {
    [sym_block_comment] = STATE(2591),
    [sym_compiler_directive_decl] = STATE(2591),
    [sym_fsi_directive_decl] = STATE(2591),
    [sym_preproc_line] = STATE(2591),
    [sym_identifier] = ACTIONS(3551),
    [anon_sym_EQ] = ACTIONS(3549),
    [anon_sym_COLON] = ACTIONS(3551),
    [anon_sym_return] = ACTIONS(3551),
    [anon_sym_do] = ACTIONS(3551),
    [anon_sym_let] = ACTIONS(3551),
    [anon_sym_let_BANG] = ACTIONS(3549),
    [anon_sym_as] = ACTIONS(3551),
    [anon_sym_LPAREN] = ACTIONS(3551),
    [anon_sym_COMMA] = ACTIONS(3549),
    [anon_sym_null] = ACTIONS(3551),
    [anon_sym_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_COLON] = ACTIONS(3549),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(3551),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3549),
    [anon_sym_LBRACE] = ACTIONS(3551),
    [anon_sym_LT_AT] = ACTIONS(3551),
    [anon_sym_LT_AT_AT] = ACTIONS(3551),
    [anon_sym_DOT] = ACTIONS(3551),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3549),
    [anon_sym_new] = ACTIONS(3551),
    [anon_sym_with] = ACTIONS(3551),
    [anon_sym_return_BANG] = ACTIONS(3549),
    [anon_sym_yield] = ACTIONS(3551),
    [anon_sym_yield_BANG] = ACTIONS(3549),
    [anon_sym_lazy] = ACTIONS(3551),
    [anon_sym_assert] = ACTIONS(3551),
    [anon_sym_upcast] = ACTIONS(3551),
    [anon_sym_downcast] = ACTIONS(3551),
    [anon_sym_COLON_GT] = ACTIONS(3549),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3549),
    [anon_sym_for] = ACTIONS(3551),
    [anon_sym_while] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(3551),
    [anon_sym_fun] = ACTIONS(3551),
    [anon_sym_DASH_GT] = ACTIONS(3551),
    [anon_sym_try] = ACTIONS(3551),
    [anon_sym_match] = ACTIONS(3551),
    [anon_sym_match_BANG] = ACTIONS(3549),
    [anon_sym_function] = ACTIONS(3551),
    [anon_sym_LT_DASH] = ACTIONS(3551),
    [anon_sym_DOT_LBRACK] = ACTIONS(3549),
    [anon_sym_LT] = ACTIONS(3549),
    [anon_sym_use] = ACTIONS(3551),
    [anon_sym_use_BANG] = ACTIONS(3549),
    [anon_sym_do_BANG] = ACTIONS(3549),
    [anon_sym_begin] = ACTIONS(3551),
    [anon_sym_LPAREN2] = ACTIONS(3551),
    [anon_sym_STAR] = ACTIONS(3551),
    [anon_sym_LT2] = ACTIONS(3551),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3549),
    [anon_sym_or] = ACTIONS(3551),
    [aux_sym_char_token1] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [anon_sym_AT_DQUOTE] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [sym_bool] = ACTIONS(3551),
    [sym_unit] = ACTIONS(3549),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3551),
    [sym_op_identifier] = ACTIONS(3551),
    [anon_sym_PLUS] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(3551),
    [anon_sym_PLUS_DOT] = ACTIONS(3551),
    [anon_sym_DASH_DOT] = ACTIONS(3551),
    [anon_sym_PERCENT] = ACTIONS(3551),
    [anon_sym_AMP_AMP] = ACTIONS(3551),
    [anon_sym_TILDE] = ACTIONS(3549),
    [aux_sym_prefix_op_token1] = ACTIONS(3551),
    [aux_sym_infix_op_token1] = ACTIONS(3549),
    [aux_sym_infix_op_token2] = ACTIONS(3551),
    [anon_sym_PIPE_PIPE] = ACTIONS(3551),
    [anon_sym_BANG_EQ] = ACTIONS(3551),
    [anon_sym_COLON_EQ] = ACTIONS(3549),
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3551),
    [sym_int] = ACTIONS(3551),
    [sym_xint] = ACTIONS(3549),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3549),
    [sym__newline] = ACTIONS(3549),
  },
  [2592] = {
    [sym_block_comment] = STATE(2592),
    [sym_compiler_directive_decl] = STATE(2592),
    [sym_fsi_directive_decl] = STATE(2592),
    [sym_preproc_line] = STATE(2592),
    [aux_sym_type_argument_repeat1] = STATE(2614),
    [sym_identifier] = ACTIONS(3476),
    [anon_sym_EQ] = ACTIONS(3474),
    [anon_sym_COLON] = ACTIONS(3476),
    [anon_sym_return] = ACTIONS(3476),
    [anon_sym_do] = ACTIONS(3476),
    [anon_sym_let] = ACTIONS(3476),
    [anon_sym_let_BANG] = ACTIONS(3474),
    [anon_sym_LPAREN] = ACTIONS(3476),
    [anon_sym_COMMA] = ACTIONS(3474),
    [anon_sym_null] = ACTIONS(3476),
    [anon_sym_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_QMARK] = ACTIONS(3476),
    [anon_sym_COLON_COLON] = ACTIONS(3474),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym_LBRACK] = ACTIONS(3476),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3474),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_LT_AT] = ACTIONS(3476),
    [anon_sym_AT_GT] = ACTIONS(3476),
    [anon_sym_LT_AT_AT] = ACTIONS(3476),
    [anon_sym_DOT] = ACTIONS(3476),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3474),
    [anon_sym_new] = ACTIONS(3476),
    [anon_sym_return_BANG] = ACTIONS(3474),
    [anon_sym_yield] = ACTIONS(3476),
    [anon_sym_yield_BANG] = ACTIONS(3474),
    [anon_sym_lazy] = ACTIONS(3476),
    [anon_sym_assert] = ACTIONS(3476),
    [anon_sym_upcast] = ACTIONS(3476),
    [anon_sym_downcast] = ACTIONS(3476),
    [anon_sym_COLON_GT] = ACTIONS(3474),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3474),
    [anon_sym_for] = ACTIONS(3476),
    [anon_sym_while] = ACTIONS(3476),
    [anon_sym_if] = ACTIONS(3476),
    [anon_sym_fun] = ACTIONS(3476),
    [anon_sym_DASH_GT] = ACTIONS(3476),
    [anon_sym_try] = ACTIONS(3476),
    [anon_sym_match] = ACTIONS(3476),
    [anon_sym_match_BANG] = ACTIONS(3474),
    [anon_sym_function] = ACTIONS(3476),
    [anon_sym_LT_DASH] = ACTIONS(3476),
    [anon_sym_DOT_LBRACK] = ACTIONS(3474),
    [anon_sym_LT] = ACTIONS(3474),
    [anon_sym_use] = ACTIONS(3476),
    [anon_sym_use_BANG] = ACTIONS(3474),
    [anon_sym_do_BANG] = ACTIONS(3474),
    [anon_sym_begin] = ACTIONS(3476),
    [anon_sym_LPAREN2] = ACTIONS(3476),
    [anon_sym_STAR] = ACTIONS(3476),
    [anon_sym_LT2] = ACTIONS(3476),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3474),
    [anon_sym_or] = ACTIONS(3476),
    [aux_sym_char_token1] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3476),
    [anon_sym_DQUOTE] = ACTIONS(3476),
    [anon_sym_AT_DQUOTE] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [sym_bool] = ACTIONS(3476),
    [sym_unit] = ACTIONS(3474),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3476),
    [sym_op_identifier] = ACTIONS(3476),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3476),
    [anon_sym_PLUS_DOT] = ACTIONS(3476),
    [anon_sym_DASH_DOT] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [anon_sym_AMP_AMP] = ACTIONS(3476),
    [anon_sym_TILDE] = ACTIONS(3474),
    [aux_sym_prefix_op_token1] = ACTIONS(3476),
    [aux_sym_infix_op_token1] = ACTIONS(3474),
    [aux_sym_infix_op_token2] = ACTIONS(3476),
    [anon_sym_PIPE_PIPE] = ACTIONS(3476),
    [anon_sym_BANG_EQ] = ACTIONS(3476),
    [anon_sym_COLON_EQ] = ACTIONS(3474),
    [anon_sym_DOLLAR] = ACTIONS(3476),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3476),
    [sym_int] = ACTIONS(3476),
    [sym_xint] = ACTIONS(3474),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3474),
    [sym__newline] = ACTIONS(3474),
  },
  [2593] = {
    [sym_block_comment] = STATE(2593),
    [sym_compiler_directive_decl] = STATE(2593),
    [sym_fsi_directive_decl] = STATE(2593),
    [sym_preproc_line] = STATE(2593),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_EQ] = ACTIONS(3560),
    [anon_sym_COLON] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_let_BANG] = ACTIONS(3560),
    [anon_sym_as] = ACTIONS(3562),
    [anon_sym_LPAREN] = ACTIONS(3562),
    [anon_sym_COMMA] = ACTIONS(3560),
    [anon_sym_null] = ACTIONS(3562),
    [anon_sym_QMARK] = ACTIONS(3562),
    [anon_sym_COLON_QMARK] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3560),
    [anon_sym_LBRACE] = ACTIONS(3562),
    [anon_sym_LT_AT] = ACTIONS(3562),
    [anon_sym_LT_AT_AT] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(3562),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3560),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_with] = ACTIONS(3562),
    [anon_sym_return_BANG] = ACTIONS(3560),
    [anon_sym_yield] = ACTIONS(3562),
    [anon_sym_yield_BANG] = ACTIONS(3560),
    [anon_sym_lazy] = ACTIONS(3562),
    [anon_sym_assert] = ACTIONS(3562),
    [anon_sym_upcast] = ACTIONS(3562),
    [anon_sym_downcast] = ACTIONS(3562),
    [anon_sym_COLON_GT] = ACTIONS(3560),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3560),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_fun] = ACTIONS(3562),
    [anon_sym_DASH_GT] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_match] = ACTIONS(3562),
    [anon_sym_match_BANG] = ACTIONS(3560),
    [anon_sym_function] = ACTIONS(3562),
    [anon_sym_LT_DASH] = ACTIONS(3562),
    [anon_sym_DOT_LBRACK] = ACTIONS(3560),
    [anon_sym_LT] = ACTIONS(3560),
    [anon_sym_use] = ACTIONS(3562),
    [anon_sym_use_BANG] = ACTIONS(3560),
    [anon_sym_do_BANG] = ACTIONS(3560),
    [anon_sym_begin] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3562),
    [anon_sym_LT2] = ACTIONS(3562),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3560),
    [anon_sym_or] = ACTIONS(3562),
    [aux_sym_char_token1] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(3562),
    [anon_sym_AT_DQUOTE] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [sym_bool] = ACTIONS(3562),
    [sym_unit] = ACTIONS(3560),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3562),
    [sym_op_identifier] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS_DOT] = ACTIONS(3562),
    [anon_sym_DASH_DOT] = ACTIONS(3562),
    [anon_sym_PERCENT] = ACTIONS(3562),
    [anon_sym_AMP_AMP] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3560),
    [aux_sym_prefix_op_token1] = ACTIONS(3562),
    [aux_sym_infix_op_token1] = ACTIONS(3560),
    [aux_sym_infix_op_token2] = ACTIONS(3562),
    [anon_sym_PIPE_PIPE] = ACTIONS(3562),
    [anon_sym_BANG_EQ] = ACTIONS(3562),
    [anon_sym_COLON_EQ] = ACTIONS(3560),
    [anon_sym_DOLLAR] = ACTIONS(3562),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3562),
    [sym_int] = ACTIONS(3562),
    [sym_xint] = ACTIONS(3560),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3560),
    [sym__newline] = ACTIONS(3560),
  },
  [2594] = {
    [sym_block_comment] = STATE(2594),
    [sym_compiler_directive_decl] = STATE(2594),
    [sym_fsi_directive_decl] = STATE(2594),
    [sym_preproc_line] = STATE(2594),
    [sym_identifier] = ACTIONS(3539),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3539),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_do] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3539),
    [anon_sym_let_BANG] = ACTIONS(3537),
    [anon_sym_as] = ACTIONS(3539),
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_null] = ACTIONS(3539),
    [anon_sym_QMARK] = ACTIONS(3539),
    [anon_sym_COLON_QMARK] = ACTIONS(3539),
    [anon_sym_COLON_COLON] = ACTIONS(3537),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3537),
    [anon_sym_LBRACE] = ACTIONS(3539),
    [anon_sym_LT_AT] = ACTIONS(3539),
    [anon_sym_LT_AT_AT] = ACTIONS(3539),
    [anon_sym_DOT] = ACTIONS(3539),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3537),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_with] = ACTIONS(3539),
    [anon_sym_return_BANG] = ACTIONS(3537),
    [anon_sym_yield] = ACTIONS(3539),
    [anon_sym_yield_BANG] = ACTIONS(3537),
    [anon_sym_lazy] = ACTIONS(3539),
    [anon_sym_assert] = ACTIONS(3539),
    [anon_sym_upcast] = ACTIONS(3539),
    [anon_sym_downcast] = ACTIONS(3539),
    [anon_sym_COLON_GT] = ACTIONS(3537),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3537),
    [anon_sym_for] = ACTIONS(3539),
    [anon_sym_while] = ACTIONS(3539),
    [anon_sym_if] = ACTIONS(3539),
    [anon_sym_fun] = ACTIONS(3539),
    [anon_sym_DASH_GT] = ACTIONS(3539),
    [anon_sym_try] = ACTIONS(3539),
    [anon_sym_match] = ACTIONS(3539),
    [anon_sym_match_BANG] = ACTIONS(3537),
    [anon_sym_function] = ACTIONS(3539),
    [anon_sym_LT_DASH] = ACTIONS(3539),
    [anon_sym_DOT_LBRACK] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_use] = ACTIONS(3539),
    [anon_sym_use_BANG] = ACTIONS(3537),
    [anon_sym_do_BANG] = ACTIONS(3537),
    [anon_sym_begin] = ACTIONS(3539),
    [anon_sym_LPAREN2] = ACTIONS(3539),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_LT2] = ACTIONS(3539),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_or] = ACTIONS(3539),
    [aux_sym_char_token1] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3539),
    [anon_sym_DQUOTE] = ACTIONS(3539),
    [anon_sym_AT_DQUOTE] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [sym_bool] = ACTIONS(3539),
    [sym_unit] = ACTIONS(3537),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3539),
    [sym_op_identifier] = ACTIONS(3539),
    [anon_sym_PLUS] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(3539),
    [anon_sym_PLUS_DOT] = ACTIONS(3539),
    [anon_sym_DASH_DOT] = ACTIONS(3539),
    [anon_sym_PERCENT] = ACTIONS(3539),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_TILDE] = ACTIONS(3537),
    [aux_sym_prefix_op_token1] = ACTIONS(3539),
    [aux_sym_infix_op_token1] = ACTIONS(3537),
    [aux_sym_infix_op_token2] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3539),
    [anon_sym_BANG_EQ] = ACTIONS(3539),
    [anon_sym_COLON_EQ] = ACTIONS(3537),
    [anon_sym_DOLLAR] = ACTIONS(3539),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3539),
    [sym_int] = ACTIONS(3539),
    [sym_xint] = ACTIONS(3537),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3537),
    [sym__newline] = ACTIONS(3537),
  },
  [2595] = {
    [sym_block_comment] = STATE(2595),
    [sym_compiler_directive_decl] = STATE(2595),
    [sym_fsi_directive_decl] = STATE(2595),
    [sym_preproc_line] = STATE(2595),
    [sym_identifier] = ACTIONS(3543),
    [anon_sym_EQ] = ACTIONS(3541),
    [anon_sym_COLON] = ACTIONS(3543),
    [anon_sym_return] = ACTIONS(3543),
    [anon_sym_do] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3543),
    [anon_sym_let_BANG] = ACTIONS(3541),
    [anon_sym_as] = ACTIONS(3543),
    [anon_sym_LPAREN] = ACTIONS(3543),
    [anon_sym_COMMA] = ACTIONS(3541),
    [anon_sym_null] = ACTIONS(3543),
    [anon_sym_QMARK] = ACTIONS(3543),
    [anon_sym_COLON_QMARK] = ACTIONS(3543),
    [anon_sym_COLON_COLON] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3543),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3541),
    [anon_sym_LBRACE] = ACTIONS(3543),
    [anon_sym_LT_AT] = ACTIONS(3543),
    [anon_sym_LT_AT_AT] = ACTIONS(3543),
    [anon_sym_DOT] = ACTIONS(3543),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3541),
    [anon_sym_new] = ACTIONS(3543),
    [anon_sym_with] = ACTIONS(3543),
    [anon_sym_return_BANG] = ACTIONS(3541),
    [anon_sym_yield] = ACTIONS(3543),
    [anon_sym_yield_BANG] = ACTIONS(3541),
    [anon_sym_lazy] = ACTIONS(3543),
    [anon_sym_assert] = ACTIONS(3543),
    [anon_sym_upcast] = ACTIONS(3543),
    [anon_sym_downcast] = ACTIONS(3543),
    [anon_sym_COLON_GT] = ACTIONS(3541),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3541),
    [anon_sym_for] = ACTIONS(3543),
    [anon_sym_while] = ACTIONS(3543),
    [anon_sym_if] = ACTIONS(3543),
    [anon_sym_fun] = ACTIONS(3543),
    [anon_sym_DASH_GT] = ACTIONS(3543),
    [anon_sym_try] = ACTIONS(3543),
    [anon_sym_match] = ACTIONS(3543),
    [anon_sym_match_BANG] = ACTIONS(3541),
    [anon_sym_function] = ACTIONS(3543),
    [anon_sym_LT_DASH] = ACTIONS(3543),
    [anon_sym_DOT_LBRACK] = ACTIONS(3541),
    [anon_sym_LT] = ACTIONS(3541),
    [anon_sym_use] = ACTIONS(3543),
    [anon_sym_use_BANG] = ACTIONS(3541),
    [anon_sym_do_BANG] = ACTIONS(3541),
    [anon_sym_begin] = ACTIONS(3543),
    [anon_sym_LPAREN2] = ACTIONS(3543),
    [anon_sym_STAR] = ACTIONS(3543),
    [anon_sym_LT2] = ACTIONS(3543),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_or] = ACTIONS(3543),
    [aux_sym_char_token1] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3543),
    [anon_sym_DQUOTE] = ACTIONS(3543),
    [anon_sym_AT_DQUOTE] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [sym_bool] = ACTIONS(3543),
    [sym_unit] = ACTIONS(3541),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3543),
    [sym_op_identifier] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(3543),
    [anon_sym_DASH] = ACTIONS(3543),
    [anon_sym_PLUS_DOT] = ACTIONS(3543),
    [anon_sym_DASH_DOT] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3543),
    [anon_sym_AMP_AMP] = ACTIONS(3543),
    [anon_sym_TILDE] = ACTIONS(3541),
    [aux_sym_prefix_op_token1] = ACTIONS(3543),
    [aux_sym_infix_op_token1] = ACTIONS(3541),
    [aux_sym_infix_op_token2] = ACTIONS(3543),
    [anon_sym_PIPE_PIPE] = ACTIONS(3543),
    [anon_sym_BANG_EQ] = ACTIONS(3543),
    [anon_sym_COLON_EQ] = ACTIONS(3541),
    [anon_sym_DOLLAR] = ACTIONS(3543),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3543),
    [sym_int] = ACTIONS(3543),
    [sym_xint] = ACTIONS(3541),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3541),
    [sym__newline] = ACTIONS(3541),
  },
  [2596] = {
    [sym_block_comment] = STATE(2596),
    [sym_compiler_directive_decl] = STATE(2596),
    [sym_fsi_directive_decl] = STATE(2596),
    [sym_preproc_line] = STATE(2596),
    [sym_identifier] = ACTIONS(3547),
    [anon_sym_EQ] = ACTIONS(3545),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_return] = ACTIONS(3547),
    [anon_sym_do] = ACTIONS(3547),
    [anon_sym_let] = ACTIONS(3547),
    [anon_sym_let_BANG] = ACTIONS(3545),
    [anon_sym_as] = ACTIONS(3547),
    [anon_sym_LPAREN] = ACTIONS(3547),
    [anon_sym_COMMA] = ACTIONS(3545),
    [anon_sym_null] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3547),
    [anon_sym_COLON_QMARK] = ACTIONS(3547),
    [anon_sym_COLON_COLON] = ACTIONS(3545),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3545),
    [anon_sym_LBRACE] = ACTIONS(3547),
    [anon_sym_LT_AT] = ACTIONS(3547),
    [anon_sym_LT_AT_AT] = ACTIONS(3547),
    [anon_sym_DOT] = ACTIONS(3547),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3545),
    [anon_sym_new] = ACTIONS(3547),
    [anon_sym_with] = ACTIONS(3547),
    [anon_sym_return_BANG] = ACTIONS(3545),
    [anon_sym_yield] = ACTIONS(3547),
    [anon_sym_yield_BANG] = ACTIONS(3545),
    [anon_sym_lazy] = ACTIONS(3547),
    [anon_sym_assert] = ACTIONS(3547),
    [anon_sym_upcast] = ACTIONS(3547),
    [anon_sym_downcast] = ACTIONS(3547),
    [anon_sym_COLON_GT] = ACTIONS(3545),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3545),
    [anon_sym_for] = ACTIONS(3547),
    [anon_sym_while] = ACTIONS(3547),
    [anon_sym_if] = ACTIONS(3547),
    [anon_sym_fun] = ACTIONS(3547),
    [anon_sym_DASH_GT] = ACTIONS(3547),
    [anon_sym_try] = ACTIONS(3547),
    [anon_sym_match] = ACTIONS(3547),
    [anon_sym_match_BANG] = ACTIONS(3545),
    [anon_sym_function] = ACTIONS(3547),
    [anon_sym_LT_DASH] = ACTIONS(3547),
    [anon_sym_DOT_LBRACK] = ACTIONS(3545),
    [anon_sym_LT] = ACTIONS(3545),
    [anon_sym_use] = ACTIONS(3547),
    [anon_sym_use_BANG] = ACTIONS(3545),
    [anon_sym_do_BANG] = ACTIONS(3545),
    [anon_sym_begin] = ACTIONS(3547),
    [anon_sym_LPAREN2] = ACTIONS(3547),
    [anon_sym_STAR] = ACTIONS(3547),
    [anon_sym_LT2] = ACTIONS(3547),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_or] = ACTIONS(3547),
    [aux_sym_char_token1] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3547),
    [anon_sym_DQUOTE] = ACTIONS(3547),
    [anon_sym_AT_DQUOTE] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [sym_bool] = ACTIONS(3547),
    [sym_unit] = ACTIONS(3545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3547),
    [sym_op_identifier] = ACTIONS(3547),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PLUS_DOT] = ACTIONS(3547),
    [anon_sym_DASH_DOT] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3547),
    [anon_sym_AMP_AMP] = ACTIONS(3547),
    [anon_sym_TILDE] = ACTIONS(3545),
    [aux_sym_prefix_op_token1] = ACTIONS(3547),
    [aux_sym_infix_op_token1] = ACTIONS(3545),
    [aux_sym_infix_op_token2] = ACTIONS(3547),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_BANG_EQ] = ACTIONS(3547),
    [anon_sym_COLON_EQ] = ACTIONS(3545),
    [anon_sym_DOLLAR] = ACTIONS(3547),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3547),
    [sym_int] = ACTIONS(3547),
    [sym_xint] = ACTIONS(3545),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3545),
    [sym__newline] = ACTIONS(3545),
  },
  [2597] = {
    [sym_block_comment] = STATE(2597),
    [sym_compiler_directive_decl] = STATE(2597),
    [sym_fsi_directive_decl] = STATE(2597),
    [sym_preproc_line] = STATE(2597),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3525),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [anon_sym_as] = ACTIONS(3527),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_COLON] = ACTIONS(3525),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_with] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_COLON_GT] = ACTIONS(3525),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_DASH_GT] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_LT_DASH] = ACTIONS(3527),
    [anon_sym_DOT_LBRACK] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_LPAREN2] = ACTIONS(3527),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_LT2] = ACTIONS(3527),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_or] = ACTIONS(3527),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3525),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3527),
    [anon_sym_DASH_DOT] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3527),
    [aux_sym_infix_op_token1] = ACTIONS(3525),
    [aux_sym_infix_op_token2] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_COLON_EQ] = ACTIONS(3525),
    [anon_sym_DOLLAR] = ACTIONS(3527),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3527),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3525),
    [sym__newline] = ACTIONS(3525),
  },
  [2598] = {
    [sym_attributes] = STATE(7112),
    [sym__attribute_set] = STATE(6370),
    [sym_function_or_value_defn] = STATE(3854),
    [sym_access_modifier] = STATE(10931),
    [sym__class_function_or_value_defn] = STATE(3860),
    [aux_sym__type_extension_inner] = STATE(2580),
    [sym__type_defn_elements] = STATE(3860),
    [sym_interface_implementation] = STATE(3863),
    [sym_member_defn] = STATE(3863),
    [sym_additional_constr_defn] = STATE(3864),
    [sym_block_comment] = STATE(2598),
    [sym_compiler_directive_decl] = STATE(2598),
    [sym_fsi_directive_decl] = STATE(2598),
    [sym_preproc_line] = STATE(2598),
    [sym_preproc_if_in_class_definition] = STATE(3860),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [ts_builtin_sym_end] = ACTIONS(5105),
    [sym_identifier] = ACTIONS(5107),
    [anon_sym_namespace] = ACTIONS(5107),
    [anon_sym_module] = ACTIONS(5107),
    [anon_sym_open] = ACTIONS(5107),
    [anon_sym_LBRACK_LT] = ACTIONS(5105),
    [anon_sym_return] = ACTIONS(5107),
    [anon_sym_type] = ACTIONS(5107),
    [anon_sym_do] = ACTIONS(5107),
    [anon_sym_and] = ACTIONS(5107),
    [anon_sym_let] = ACTIONS(5107),
    [anon_sym_let_BANG] = ACTIONS(5105),
    [aux_sym_access_modifier_token1] = ACTIONS(5109),
    [anon_sym_LPAREN] = ACTIONS(5107),
    [anon_sym_null] = ACTIONS(5107),
    [anon_sym_AMP] = ACTIONS(5107),
    [anon_sym_LBRACK] = ACTIONS(5107),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5105),
    [anon_sym_LBRACE] = ACTIONS(5107),
    [anon_sym_LT_AT] = ACTIONS(5107),
    [anon_sym_LT_AT_AT] = ACTIONS(5105),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5105),
    [anon_sym_new] = ACTIONS(5107),
    [anon_sym_return_BANG] = ACTIONS(5105),
    [anon_sym_yield] = ACTIONS(5107),
    [anon_sym_yield_BANG] = ACTIONS(5105),
    [anon_sym_lazy] = ACTIONS(5107),
    [anon_sym_assert] = ACTIONS(5107),
    [anon_sym_upcast] = ACTIONS(5107),
    [anon_sym_downcast] = ACTIONS(5107),
    [anon_sym_for] = ACTIONS(5107),
    [anon_sym_while] = ACTIONS(5107),
    [anon_sym_if] = ACTIONS(5107),
    [anon_sym_fun] = ACTIONS(5107),
    [anon_sym_try] = ACTIONS(5107),
    [anon_sym_match] = ACTIONS(5107),
    [anon_sym_match_BANG] = ACTIONS(5105),
    [anon_sym_function] = ACTIONS(5107),
    [anon_sym_use] = ACTIONS(5107),
    [anon_sym_use_BANG] = ACTIONS(5105),
    [anon_sym_do_BANG] = ACTIONS(5105),
    [anon_sym_begin] = ACTIONS(5107),
    [anon_sym_default] = ACTIONS(5111),
    [anon_sym_static] = ACTIONS(5113),
    [anon_sym_member] = ACTIONS(5115),
    [anon_sym_interface] = ACTIONS(5117),
    [anon_sym_exception] = ACTIONS(5107),
    [anon_sym_abstract] = ACTIONS(5119),
    [anon_sym_val] = ACTIONS(5121),
    [anon_sym_override] = ACTIONS(5111),
    [aux_sym_char_token1] = ACTIONS(5105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5107),
    [anon_sym_DQUOTE] = ACTIONS(5107),
    [anon_sym_AT_DQUOTE] = ACTIONS(5105),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5105),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5105),
    [sym_bool] = ACTIONS(5107),
    [sym_unit] = ACTIONS(5105),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5107),
    [sym_op_identifier] = ACTIONS(5105),
    [anon_sym_PLUS] = ACTIONS(5107),
    [anon_sym_DASH] = ACTIONS(5107),
    [anon_sym_PLUS_DOT] = ACTIONS(5105),
    [anon_sym_DASH_DOT] = ACTIONS(5105),
    [anon_sym_PERCENT] = ACTIONS(5105),
    [anon_sym_AMP_AMP] = ACTIONS(5105),
    [anon_sym_TILDE] = ACTIONS(5105),
    [aux_sym_prefix_op_token1] = ACTIONS(5105),
    [sym_int] = ACTIONS(5107),
    [sym_xint] = ACTIONS(5105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5105),
    [anon_sym_POUNDload] = ACTIONS(5105),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(5105),
  },
  [2599] = {
    [sym_block_comment] = STATE(2599),
    [sym_compiler_directive_decl] = STATE(2599),
    [sym_fsi_directive_decl] = STATE(2599),
    [sym_preproc_line] = STATE(2599),
    [aux_sym_long_identifier_repeat1] = STATE(2588),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_AT_GT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(5103),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_DASH_GT] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_STAR] = ACTIONS(3451),
    [anon_sym_LT2] = ACTIONS(3451),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3449),
    [anon_sym_or] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
  },
  [2600] = {
    [sym_block_comment] = STATE(2600),
    [sym_compiler_directive_decl] = STATE(2600),
    [sym_fsi_directive_decl] = STATE(2600),
    [sym_preproc_line] = STATE(2600),
    [aux_sym_long_identifier_repeat1] = STATE(2605),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(5024),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_DASH_GT] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_GT] = ACTIONS(3451),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_STAR] = ACTIONS(3451),
    [anon_sym_LT2] = ACTIONS(3451),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3449),
    [anon_sym_or] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
  },
  [2601] = {
    [sym_block_comment] = STATE(2601),
    [sym_compiler_directive_decl] = STATE(2601),
    [sym_fsi_directive_decl] = STATE(2601),
    [sym_preproc_line] = STATE(2601),
    [aux_sym_type_argument_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [anon_sym_DOT_LBRACK] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_DOT_DOT] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_or] = ACTIONS(5123),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3498),
    [anon_sym_DASH_DOT] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3498),
    [aux_sym_infix_op_token1] = ACTIONS(3496),
    [aux_sym_infix_op_token2] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_COLON_EQ] = ACTIONS(3496),
    [anon_sym_DOLLAR] = ACTIONS(3498),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3498),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
  },
  [2602] = {
    [sym_block_comment] = STATE(2602),
    [sym_compiler_directive_decl] = STATE(2602),
    [sym_fsi_directive_decl] = STATE(2602),
    [sym_preproc_line] = STATE(2602),
    [aux_sym_long_identifier_repeat1] = STATE(1328),
    [sym_identifier] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3778),
    [anon_sym_COLON] = ACTIONS(3781),
    [anon_sym_return] = ACTIONS(3781),
    [anon_sym_do] = ACTIONS(3781),
    [anon_sym_let] = ACTIONS(3781),
    [anon_sym_let_BANG] = ACTIONS(3778),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3778),
    [anon_sym_null] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3781),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_LT_AT] = ACTIONS(3781),
    [anon_sym_LT_AT_AT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(5126),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3778),
    [anon_sym_new] = ACTIONS(3781),
    [anon_sym_return_BANG] = ACTIONS(3778),
    [anon_sym_yield] = ACTIONS(3781),
    [anon_sym_yield_BANG] = ACTIONS(3778),
    [anon_sym_lazy] = ACTIONS(3781),
    [anon_sym_assert] = ACTIONS(3781),
    [anon_sym_upcast] = ACTIONS(3781),
    [anon_sym_downcast] = ACTIONS(3781),
    [anon_sym_COLON_GT] = ACTIONS(3778),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3778),
    [anon_sym_for] = ACTIONS(3781),
    [anon_sym_while] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_fun] = ACTIONS(3781),
    [anon_sym_DASH_GT] = ACTIONS(3494),
    [anon_sym_try] = ACTIONS(3781),
    [anon_sym_match] = ACTIONS(3781),
    [anon_sym_match_BANG] = ACTIONS(3778),
    [anon_sym_function] = ACTIONS(3781),
    [anon_sym_LT_DASH] = ACTIONS(3781),
    [anon_sym_DOT_LBRACK] = ACTIONS(3778),
    [anon_sym_LT] = ACTIONS(3778),
    [anon_sym_use] = ACTIONS(3781),
    [anon_sym_use_BANG] = ACTIONS(3778),
    [anon_sym_do_BANG] = ACTIONS(3778),
    [anon_sym_begin] = ACTIONS(3781),
    [anon_sym_LPAREN2] = ACTIONS(3781),
    [anon_sym_STAR] = ACTIONS(3494),
    [anon_sym_LT2] = ACTIONS(3494),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3492),
    [anon_sym_or] = ACTIONS(3781),
    [aux_sym_char_token1] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3781),
    [anon_sym_DQUOTE] = ACTIONS(3781),
    [anon_sym_AT_DQUOTE] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [sym_bool] = ACTIONS(3781),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3781),
    [sym_op_identifier] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3781),
    [anon_sym_DASH] = ACTIONS(3781),
    [anon_sym_PLUS_DOT] = ACTIONS(3781),
    [anon_sym_DASH_DOT] = ACTIONS(3781),
    [anon_sym_PERCENT] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3781),
    [anon_sym_TILDE] = ACTIONS(3778),
    [aux_sym_prefix_op_token1] = ACTIONS(3781),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token2] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_COLON_EQ] = ACTIONS(3778),
    [anon_sym_DOLLAR] = ACTIONS(3781),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3781),
    [sym_int] = ACTIONS(3781),
    [sym_xint] = ACTIONS(3778),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3778),
    [sym__newline] = ACTIONS(3778),
    [sym__dedent] = ACTIONS(3778),
  },
  [2603] = {
    [sym__else_expression] = STATE(3434),
    [sym_elif_expression] = STATE(2822),
    [sym_block_comment] = STATE(2603),
    [sym_compiler_directive_decl] = STATE(2603),
    [sym_fsi_directive_decl] = STATE(2603),
    [sym_preproc_line] = STATE(2603),
    [aux_sym_if_expression_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(3472),
    [anon_sym_EQ] = ACTIONS(3470),
    [anon_sym_COLON] = ACTIONS(3472),
    [anon_sym_return] = ACTIONS(3472),
    [anon_sym_do] = ACTIONS(3472),
    [anon_sym_let] = ACTIONS(3472),
    [anon_sym_let_BANG] = ACTIONS(3470),
    [anon_sym_LPAREN] = ACTIONS(3472),
    [anon_sym_COMMA] = ACTIONS(3470),
    [anon_sym_null] = ACTIONS(3472),
    [anon_sym_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_COLON] = ACTIONS(3470),
    [anon_sym_AMP] = ACTIONS(3472),
    [anon_sym_LBRACK] = ACTIONS(3472),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3470),
    [anon_sym_LBRACE] = ACTIONS(3472),
    [anon_sym_LT_AT] = ACTIONS(3472),
    [anon_sym_LT_AT_AT] = ACTIONS(3472),
    [anon_sym_DOT] = ACTIONS(3472),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3470),
    [anon_sym_new] = ACTIONS(3472),
    [anon_sym_return_BANG] = ACTIONS(3470),
    [anon_sym_yield] = ACTIONS(3472),
    [anon_sym_yield_BANG] = ACTIONS(3470),
    [anon_sym_lazy] = ACTIONS(3472),
    [anon_sym_assert] = ACTIONS(3472),
    [anon_sym_upcast] = ACTIONS(3472),
    [anon_sym_downcast] = ACTIONS(3472),
    [anon_sym_COLON_GT] = ACTIONS(3470),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3470),
    [anon_sym_for] = ACTIONS(3472),
    [anon_sym_while] = ACTIONS(3472),
    [anon_sym_else] = ACTIONS(5040),
    [anon_sym_elif] = ACTIONS(5042),
    [anon_sym_if] = ACTIONS(3472),
    [anon_sym_fun] = ACTIONS(3472),
    [anon_sym_try] = ACTIONS(3472),
    [anon_sym_match] = ACTIONS(3472),
    [anon_sym_match_BANG] = ACTIONS(3470),
    [anon_sym_function] = ACTIONS(3472),
    [anon_sym_LT_DASH] = ACTIONS(3472),
    [anon_sym_DOT_LBRACK] = ACTIONS(3470),
    [anon_sym_LT] = ACTIONS(3470),
    [anon_sym_GT] = ACTIONS(3472),
    [anon_sym_use] = ACTIONS(3472),
    [anon_sym_use_BANG] = ACTIONS(3470),
    [anon_sym_do_BANG] = ACTIONS(3470),
    [anon_sym_begin] = ACTIONS(3472),
    [anon_sym_LPAREN2] = ACTIONS(3472),
    [anon_sym_or] = ACTIONS(3472),
    [aux_sym_char_token1] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3472),
    [anon_sym_DQUOTE] = ACTIONS(3472),
    [anon_sym_AT_DQUOTE] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [sym_bool] = ACTIONS(3472),
    [sym_unit] = ACTIONS(3470),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3472),
    [sym_op_identifier] = ACTIONS(3472),
    [anon_sym_PLUS] = ACTIONS(3472),
    [anon_sym_DASH] = ACTIONS(3472),
    [anon_sym_PLUS_DOT] = ACTIONS(3472),
    [anon_sym_DASH_DOT] = ACTIONS(3472),
    [anon_sym_PERCENT] = ACTIONS(3472),
    [anon_sym_AMP_AMP] = ACTIONS(3472),
    [anon_sym_TILDE] = ACTIONS(3470),
    [aux_sym_prefix_op_token1] = ACTIONS(3472),
    [aux_sym_infix_op_token1] = ACTIONS(3470),
    [aux_sym_infix_op_token2] = ACTIONS(3472),
    [anon_sym_PIPE_PIPE] = ACTIONS(3472),
    [anon_sym_BANG_EQ] = ACTIONS(3472),
    [anon_sym_COLON_EQ] = ACTIONS(3470),
    [anon_sym_DOLLAR] = ACTIONS(3472),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3472),
    [sym_int] = ACTIONS(3472),
    [sym_xint] = ACTIONS(3470),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3470),
    [sym__newline] = ACTIONS(3470),
  },
  [2604] = {
    [sym_block_comment] = STATE(2604),
    [sym_compiler_directive_decl] = STATE(2604),
    [sym_fsi_directive_decl] = STATE(2604),
    [sym_preproc_line] = STATE(2604),
    [aux_sym_long_identifier_repeat1] = STATE(2200),
    [sym_identifier] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3778),
    [anon_sym_GT_RBRACK] = ACTIONS(3778),
    [anon_sym_COLON] = ACTIONS(3781),
    [anon_sym_return] = ACTIONS(3781),
    [anon_sym_do] = ACTIONS(3781),
    [anon_sym_let] = ACTIONS(3781),
    [anon_sym_let_BANG] = ACTIONS(3778),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3778),
    [anon_sym_null] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3781),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_LT_AT] = ACTIONS(3781),
    [anon_sym_LT_AT_AT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(5130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3778),
    [anon_sym_new] = ACTIONS(3781),
    [anon_sym_return_BANG] = ACTIONS(3778),
    [anon_sym_yield] = ACTIONS(3781),
    [anon_sym_yield_BANG] = ACTIONS(3778),
    [anon_sym_lazy] = ACTIONS(3781),
    [anon_sym_assert] = ACTIONS(3781),
    [anon_sym_upcast] = ACTIONS(3781),
    [anon_sym_downcast] = ACTIONS(3781),
    [anon_sym_COLON_GT] = ACTIONS(3778),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3778),
    [anon_sym_for] = ACTIONS(3781),
    [anon_sym_while] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_fun] = ACTIONS(3781),
    [anon_sym_DASH_GT] = ACTIONS(3494),
    [anon_sym_try] = ACTIONS(3781),
    [anon_sym_match] = ACTIONS(3781),
    [anon_sym_match_BANG] = ACTIONS(3778),
    [anon_sym_function] = ACTIONS(3781),
    [anon_sym_LT_DASH] = ACTIONS(3781),
    [anon_sym_DOT_LBRACK] = ACTIONS(3778),
    [anon_sym_LT] = ACTIONS(3778),
    [anon_sym_use] = ACTIONS(3781),
    [anon_sym_use_BANG] = ACTIONS(3778),
    [anon_sym_do_BANG] = ACTIONS(3778),
    [anon_sym_begin] = ACTIONS(3781),
    [anon_sym_LPAREN2] = ACTIONS(3781),
    [anon_sym_STAR] = ACTIONS(3494),
    [anon_sym_LT2] = ACTIONS(3494),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3492),
    [anon_sym_or] = ACTIONS(3781),
    [aux_sym_char_token1] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3781),
    [anon_sym_DQUOTE] = ACTIONS(3781),
    [anon_sym_AT_DQUOTE] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [sym_bool] = ACTIONS(3781),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3781),
    [sym_op_identifier] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3781),
    [anon_sym_DASH] = ACTIONS(3781),
    [anon_sym_PLUS_DOT] = ACTIONS(3781),
    [anon_sym_DASH_DOT] = ACTIONS(3781),
    [anon_sym_PERCENT] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3781),
    [anon_sym_TILDE] = ACTIONS(3778),
    [aux_sym_prefix_op_token1] = ACTIONS(3781),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token2] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_COLON_EQ] = ACTIONS(3778),
    [anon_sym_DOLLAR] = ACTIONS(3781),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3781),
    [sym_int] = ACTIONS(3781),
    [sym_xint] = ACTIONS(3778),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3778),
    [sym__newline] = ACTIONS(3778),
  },
  [2605] = {
    [sym_block_comment] = STATE(2605),
    [sym_compiler_directive_decl] = STATE(2605),
    [sym_fsi_directive_decl] = STATE(2605),
    [sym_preproc_line] = STATE(2605),
    [aux_sym_long_identifier_repeat1] = STATE(2605),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(5134),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_GT] = ACTIONS(3487),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [2606] = {
    [sym_block_comment] = STATE(2606),
    [sym_compiler_directive_decl] = STATE(2606),
    [sym_fsi_directive_decl] = STATE(2606),
    [sym_preproc_line] = STATE(2606),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [anon_sym_as] = ACTIONS(3515),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_COLON] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_with] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(3513),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_LT_DASH] = ACTIONS(3515),
    [anon_sym_DOT_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_or] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3515),
    [anon_sym_DASH_DOT] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3515),
    [aux_sym_infix_op_token1] = ACTIONS(3513),
    [aux_sym_infix_op_token2] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3515),
    [anon_sym_COLON_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(3515),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3515),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
  },
  [2607] = {
    [sym__else_expression] = STATE(3301),
    [sym_elif_expression] = STATE(2826),
    [sym_block_comment] = STATE(2607),
    [sym_compiler_directive_decl] = STATE(2607),
    [sym_fsi_directive_decl] = STATE(2607),
    [sym_preproc_line] = STATE(2607),
    [aux_sym_if_expression_repeat1] = STATE(2581),
    [sym_identifier] = ACTIONS(3472),
    [anon_sym_EQ] = ACTIONS(3470),
    [anon_sym_COLON] = ACTIONS(3472),
    [anon_sym_return] = ACTIONS(3472),
    [anon_sym_do] = ACTIONS(3472),
    [anon_sym_let] = ACTIONS(3472),
    [anon_sym_let_BANG] = ACTIONS(3470),
    [anon_sym_LPAREN] = ACTIONS(3472),
    [anon_sym_COMMA] = ACTIONS(3470),
    [anon_sym_null] = ACTIONS(3472),
    [anon_sym_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_QMARK] = ACTIONS(3472),
    [anon_sym_COLON_COLON] = ACTIONS(3470),
    [anon_sym_AMP] = ACTIONS(3472),
    [anon_sym_LBRACK] = ACTIONS(3472),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3470),
    [anon_sym_LBRACE] = ACTIONS(3472),
    [anon_sym_LT_AT] = ACTIONS(3472),
    [anon_sym_LT_AT_AT] = ACTIONS(3472),
    [anon_sym_DOT] = ACTIONS(3472),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3470),
    [anon_sym_new] = ACTIONS(3472),
    [anon_sym_return_BANG] = ACTIONS(3470),
    [anon_sym_yield] = ACTIONS(3472),
    [anon_sym_yield_BANG] = ACTIONS(3470),
    [anon_sym_lazy] = ACTIONS(3472),
    [anon_sym_assert] = ACTIONS(3472),
    [anon_sym_upcast] = ACTIONS(3472),
    [anon_sym_downcast] = ACTIONS(3472),
    [anon_sym_COLON_GT] = ACTIONS(3470),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3470),
    [anon_sym_for] = ACTIONS(3472),
    [anon_sym_while] = ACTIONS(3472),
    [anon_sym_else] = ACTIONS(5090),
    [anon_sym_elif] = ACTIONS(5092),
    [anon_sym_if] = ACTIONS(3472),
    [anon_sym_fun] = ACTIONS(3472),
    [anon_sym_try] = ACTIONS(3472),
    [anon_sym_match] = ACTIONS(3472),
    [anon_sym_match_BANG] = ACTIONS(3470),
    [anon_sym_function] = ACTIONS(3472),
    [anon_sym_LT_DASH] = ACTIONS(3472),
    [anon_sym_DOT_LBRACK] = ACTIONS(3470),
    [anon_sym_LT] = ACTIONS(3470),
    [anon_sym_use] = ACTIONS(3472),
    [anon_sym_use_BANG] = ACTIONS(3470),
    [anon_sym_do_BANG] = ACTIONS(3470),
    [anon_sym_DOT_DOT] = ACTIONS(3470),
    [anon_sym_begin] = ACTIONS(3472),
    [anon_sym_LPAREN2] = ACTIONS(3472),
    [anon_sym_or] = ACTIONS(3472),
    [aux_sym_char_token1] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3472),
    [anon_sym_DQUOTE] = ACTIONS(3472),
    [anon_sym_AT_DQUOTE] = ACTIONS(3470),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3470),
    [sym_bool] = ACTIONS(3472),
    [sym_unit] = ACTIONS(3470),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3472),
    [sym_op_identifier] = ACTIONS(3472),
    [anon_sym_PLUS] = ACTIONS(3472),
    [anon_sym_DASH] = ACTIONS(3472),
    [anon_sym_PLUS_DOT] = ACTIONS(3472),
    [anon_sym_DASH_DOT] = ACTIONS(3472),
    [anon_sym_PERCENT] = ACTIONS(3472),
    [anon_sym_AMP_AMP] = ACTIONS(3472),
    [anon_sym_TILDE] = ACTIONS(3470),
    [aux_sym_prefix_op_token1] = ACTIONS(3472),
    [aux_sym_infix_op_token1] = ACTIONS(3470),
    [aux_sym_infix_op_token2] = ACTIONS(3472),
    [anon_sym_PIPE_PIPE] = ACTIONS(3472),
    [anon_sym_BANG_EQ] = ACTIONS(3472),
    [anon_sym_COLON_EQ] = ACTIONS(3470),
    [anon_sym_DOLLAR] = ACTIONS(3472),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3472),
    [sym_int] = ACTIONS(3472),
    [sym_xint] = ACTIONS(3470),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3470),
    [sym__newline] = ACTIONS(3470),
  },
  [2608] = {
    [sym_block_comment] = STATE(2608),
    [sym_compiler_directive_decl] = STATE(2608),
    [sym_fsi_directive_decl] = STATE(2608),
    [sym_preproc_line] = STATE(2608),
    [aux_sym_compound_type_repeat1] = STATE(2608),
    [sym_identifier] = ACTIONS(3427),
    [anon_sym_EQ] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_QMARK] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3427),
    [anon_sym_AT_AT_GT] = ACTIONS(3427),
    [anon_sym_DOT] = ACTIONS(3427),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_COLON_GT] = ACTIONS(3425),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(3427),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_LT_DASH] = ACTIONS(3427),
    [anon_sym_DOT_LBRACK] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_LPAREN2] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(5137),
    [anon_sym_LT2] = ACTIONS(3427),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3425),
    [anon_sym_or] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3427),
    [anon_sym_DASH_DOT] = ACTIONS(3427),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3427),
    [aux_sym_infix_op_token1] = ACTIONS(3425),
    [aux_sym_infix_op_token2] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3427),
    [anon_sym_COLON_EQ] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3427),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
  },
  [2609] = {
    [sym_block_comment] = STATE(2609),
    [sym_compiler_directive_decl] = STATE(2609),
    [sym_fsi_directive_decl] = STATE(2609),
    [sym_preproc_line] = STATE(2609),
    [sym_identifier] = ACTIONS(3535),
    [anon_sym_EQ] = ACTIONS(3533),
    [anon_sym_COLON] = ACTIONS(3535),
    [anon_sym_return] = ACTIONS(3535),
    [anon_sym_do] = ACTIONS(3535),
    [anon_sym_let] = ACTIONS(3535),
    [anon_sym_let_BANG] = ACTIONS(3533),
    [anon_sym_as] = ACTIONS(3535),
    [anon_sym_LPAREN] = ACTIONS(3535),
    [anon_sym_COMMA] = ACTIONS(3533),
    [anon_sym_null] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(3535),
    [anon_sym_COLON_QMARK] = ACTIONS(3535),
    [anon_sym_COLON_COLON] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3533),
    [anon_sym_LBRACE] = ACTIONS(3535),
    [anon_sym_LT_AT] = ACTIONS(3535),
    [anon_sym_LT_AT_AT] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(3535),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3533),
    [anon_sym_new] = ACTIONS(3535),
    [anon_sym_with] = ACTIONS(3535),
    [anon_sym_return_BANG] = ACTIONS(3533),
    [anon_sym_yield] = ACTIONS(3535),
    [anon_sym_yield_BANG] = ACTIONS(3533),
    [anon_sym_lazy] = ACTIONS(3535),
    [anon_sym_assert] = ACTIONS(3535),
    [anon_sym_upcast] = ACTIONS(3535),
    [anon_sym_downcast] = ACTIONS(3535),
    [anon_sym_COLON_GT] = ACTIONS(3533),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3533),
    [anon_sym_for] = ACTIONS(3535),
    [anon_sym_while] = ACTIONS(3535),
    [anon_sym_if] = ACTIONS(3535),
    [anon_sym_fun] = ACTIONS(3535),
    [anon_sym_DASH_GT] = ACTIONS(3535),
    [anon_sym_try] = ACTIONS(3535),
    [anon_sym_match] = ACTIONS(3535),
    [anon_sym_match_BANG] = ACTIONS(3533),
    [anon_sym_function] = ACTIONS(3535),
    [anon_sym_LT_DASH] = ACTIONS(3535),
    [anon_sym_DOT_LBRACK] = ACTIONS(3533),
    [anon_sym_LT] = ACTIONS(3533),
    [anon_sym_use] = ACTIONS(3535),
    [anon_sym_use_BANG] = ACTIONS(3533),
    [anon_sym_do_BANG] = ACTIONS(3533),
    [anon_sym_begin] = ACTIONS(3535),
    [anon_sym_LPAREN2] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(3535),
    [anon_sym_LT2] = ACTIONS(3535),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3533),
    [anon_sym_or] = ACTIONS(3535),
    [aux_sym_char_token1] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE] = ACTIONS(3535),
    [anon_sym_AT_DQUOTE] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [sym_bool] = ACTIONS(3535),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3535),
    [sym_op_identifier] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS_DOT] = ACTIONS(3535),
    [anon_sym_DASH_DOT] = ACTIONS(3535),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(3535),
    [anon_sym_TILDE] = ACTIONS(3533),
    [aux_sym_prefix_op_token1] = ACTIONS(3535),
    [aux_sym_infix_op_token1] = ACTIONS(3533),
    [aux_sym_infix_op_token2] = ACTIONS(3535),
    [anon_sym_PIPE_PIPE] = ACTIONS(3535),
    [anon_sym_BANG_EQ] = ACTIONS(3535),
    [anon_sym_COLON_EQ] = ACTIONS(3533),
    [anon_sym_DOLLAR] = ACTIONS(3535),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3535),
    [sym_int] = ACTIONS(3535),
    [sym_xint] = ACTIONS(3533),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3533),
    [sym__newline] = ACTIONS(3533),
  },
  [2610] = {
    [sym__else_expression] = STATE(3404),
    [sym_elif_expression] = STATE(2836),
    [sym_block_comment] = STATE(2610),
    [sym_compiler_directive_decl] = STATE(2610),
    [sym_fsi_directive_decl] = STATE(2610),
    [sym_preproc_line] = STATE(2610),
    [aux_sym_if_expression_repeat1] = STATE(2621),
    [sym_identifier] = ACTIONS(3457),
    [anon_sym_EQ] = ACTIONS(3455),
    [anon_sym_COLON] = ACTIONS(3457),
    [anon_sym_return] = ACTIONS(3457),
    [anon_sym_do] = ACTIONS(3457),
    [anon_sym_let] = ACTIONS(3457),
    [anon_sym_let_BANG] = ACTIONS(3455),
    [anon_sym_LPAREN] = ACTIONS(3457),
    [anon_sym_COMMA] = ACTIONS(3455),
    [anon_sym_null] = ACTIONS(3457),
    [anon_sym_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_QMARK] = ACTIONS(3457),
    [anon_sym_COLON_COLON] = ACTIONS(3455),
    [anon_sym_AMP] = ACTIONS(3457),
    [anon_sym_LBRACK] = ACTIONS(3457),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3457),
    [anon_sym_LT_AT] = ACTIONS(3457),
    [anon_sym_AT_GT] = ACTIONS(3457),
    [anon_sym_LT_AT_AT] = ACTIONS(3457),
    [anon_sym_DOT] = ACTIONS(3457),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3457),
    [anon_sym_return_BANG] = ACTIONS(3455),
    [anon_sym_yield] = ACTIONS(3457),
    [anon_sym_yield_BANG] = ACTIONS(3455),
    [anon_sym_lazy] = ACTIONS(3457),
    [anon_sym_assert] = ACTIONS(3457),
    [anon_sym_upcast] = ACTIONS(3457),
    [anon_sym_downcast] = ACTIONS(3457),
    [anon_sym_COLON_GT] = ACTIONS(3455),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3457),
    [anon_sym_while] = ACTIONS(3457),
    [anon_sym_else] = ACTIONS(5029),
    [anon_sym_elif] = ACTIONS(5031),
    [anon_sym_if] = ACTIONS(3457),
    [anon_sym_fun] = ACTIONS(3457),
    [anon_sym_try] = ACTIONS(3457),
    [anon_sym_match] = ACTIONS(3457),
    [anon_sym_match_BANG] = ACTIONS(3455),
    [anon_sym_function] = ACTIONS(3457),
    [anon_sym_LT_DASH] = ACTIONS(3457),
    [anon_sym_DOT_LBRACK] = ACTIONS(3455),
    [anon_sym_LT] = ACTIONS(3455),
    [anon_sym_use] = ACTIONS(3457),
    [anon_sym_use_BANG] = ACTIONS(3455),
    [anon_sym_do_BANG] = ACTIONS(3455),
    [anon_sym_begin] = ACTIONS(3457),
    [anon_sym_LPAREN2] = ACTIONS(3457),
    [anon_sym_or] = ACTIONS(3457),
    [aux_sym_char_token1] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3457),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [anon_sym_AT_DQUOTE] = ACTIONS(3455),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3455),
    [sym_bool] = ACTIONS(3457),
    [sym_unit] = ACTIONS(3455),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3457),
    [sym_op_identifier] = ACTIONS(3457),
    [anon_sym_PLUS] = ACTIONS(3457),
    [anon_sym_DASH] = ACTIONS(3457),
    [anon_sym_PLUS_DOT] = ACTIONS(3457),
    [anon_sym_DASH_DOT] = ACTIONS(3457),
    [anon_sym_PERCENT] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3455),
    [aux_sym_prefix_op_token1] = ACTIONS(3457),
    [aux_sym_infix_op_token1] = ACTIONS(3455),
    [aux_sym_infix_op_token2] = ACTIONS(3457),
    [anon_sym_PIPE_PIPE] = ACTIONS(3457),
    [anon_sym_BANG_EQ] = ACTIONS(3457),
    [anon_sym_COLON_EQ] = ACTIONS(3455),
    [anon_sym_DOLLAR] = ACTIONS(3457),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3457),
    [sym_int] = ACTIONS(3457),
    [sym_xint] = ACTIONS(3455),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3455),
    [sym__newline] = ACTIONS(3455),
  },
  [2611] = {
    [sym_block_comment] = STATE(2611),
    [sym_compiler_directive_decl] = STATE(2611),
    [sym_fsi_directive_decl] = STATE(2611),
    [sym_preproc_line] = STATE(2611),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [anon_sym_as] = ACTIONS(3515),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_COLON] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_with] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(3513),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_LT_DASH] = ACTIONS(3515),
    [anon_sym_DOT_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_or] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3515),
    [anon_sym_DASH_DOT] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3515),
    [aux_sym_infix_op_token1] = ACTIONS(3513),
    [aux_sym_infix_op_token2] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3515),
    [anon_sym_COLON_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(3515),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3515),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
  },
  [2612] = {
    [sym_block_comment] = STATE(2612),
    [sym_compiler_directive_decl] = STATE(2612),
    [sym_fsi_directive_decl] = STATE(2612),
    [sym_preproc_line] = STATE(2612),
    [sym_identifier] = ACTIONS(3531),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(3531),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_do] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [anon_sym_as] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_null] = ACTIONS(3531),
    [anon_sym_QMARK] = ACTIONS(3531),
    [anon_sym_COLON_QMARK] = ACTIONS(3531),
    [anon_sym_COLON_COLON] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3531),
    [anon_sym_LT_AT] = ACTIONS(3531),
    [anon_sym_LT_AT_AT] = ACTIONS(3531),
    [anon_sym_DOT] = ACTIONS(3531),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3531),
    [anon_sym_with] = ACTIONS(3531),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3531),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3531),
    [anon_sym_assert] = ACTIONS(3531),
    [anon_sym_upcast] = ACTIONS(3531),
    [anon_sym_downcast] = ACTIONS(3531),
    [anon_sym_COLON_GT] = ACTIONS(3529),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3531),
    [anon_sym_while] = ACTIONS(3531),
    [anon_sym_if] = ACTIONS(3531),
    [anon_sym_fun] = ACTIONS(3531),
    [anon_sym_DASH_GT] = ACTIONS(3531),
    [anon_sym_try] = ACTIONS(3531),
    [anon_sym_match] = ACTIONS(3531),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3531),
    [anon_sym_LT_DASH] = ACTIONS(3531),
    [anon_sym_DOT_LBRACK] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_use] = ACTIONS(3531),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3531),
    [anon_sym_LPAREN2] = ACTIONS(3531),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LT2] = ACTIONS(3531),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_or] = ACTIONS(3531),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3531),
    [anon_sym_DQUOTE] = ACTIONS(3531),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3531),
    [sym_unit] = ACTIONS(3529),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3531),
    [sym_op_identifier] = ACTIONS(3531),
    [anon_sym_PLUS] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(3531),
    [anon_sym_PLUS_DOT] = ACTIONS(3531),
    [anon_sym_DASH_DOT] = ACTIONS(3531),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_AMP_AMP] = ACTIONS(3531),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3531),
    [aux_sym_infix_op_token1] = ACTIONS(3529),
    [aux_sym_infix_op_token2] = ACTIONS(3531),
    [anon_sym_PIPE_PIPE] = ACTIONS(3531),
    [anon_sym_BANG_EQ] = ACTIONS(3531),
    [anon_sym_COLON_EQ] = ACTIONS(3529),
    [anon_sym_DOLLAR] = ACTIONS(3531),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3531),
    [sym_int] = ACTIONS(3531),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [sym__newline] = ACTIONS(3529),
  },
  [2613] = {
    [sym_block_comment] = STATE(2613),
    [sym_compiler_directive_decl] = STATE(2613),
    [sym_fsi_directive_decl] = STATE(2613),
    [sym_preproc_line] = STATE(2613),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(3521),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3521),
    [anon_sym_as] = ACTIONS(3523),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_COMMA] = ACTIONS(3521),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_COLON] = ACTIONS(3521),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_with] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3521),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3521),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_COLON_GT] = ACTIONS(3521),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_DASH_GT] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3521),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_LT_DASH] = ACTIONS(3523),
    [anon_sym_DOT_LBRACK] = ACTIONS(3521),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3521),
    [anon_sym_do_BANG] = ACTIONS(3521),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_LPAREN2] = ACTIONS(3523),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_LT2] = ACTIONS(3523),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3521),
    [anon_sym_or] = ACTIONS(3523),
    [aux_sym_char_token1] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3521),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3523),
    [anon_sym_DASH_DOT] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3521),
    [aux_sym_prefix_op_token1] = ACTIONS(3523),
    [aux_sym_infix_op_token1] = ACTIONS(3521),
    [aux_sym_infix_op_token2] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3523),
    [anon_sym_COLON_EQ] = ACTIONS(3521),
    [anon_sym_DOLLAR] = ACTIONS(3523),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3523),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3521),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3521),
    [sym__newline] = ACTIONS(3521),
  },
  [2614] = {
    [sym_block_comment] = STATE(2614),
    [sym_compiler_directive_decl] = STATE(2614),
    [sym_fsi_directive_decl] = STATE(2614),
    [sym_preproc_line] = STATE(2614),
    [aux_sym_type_argument_repeat1] = STATE(2614),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_COLON] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_AT_GT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_LT_DASH] = ACTIONS(3480),
    [anon_sym_DOT_LBRACK] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_or] = ACTIONS(5140),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3480),
    [anon_sym_DASH_DOT] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3480),
    [aux_sym_infix_op_token1] = ACTIONS(3478),
    [aux_sym_infix_op_token2] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3480),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
  },
  [2615] = {
    [sym_block_comment] = STATE(2615),
    [sym_compiler_directive_decl] = STATE(2615),
    [sym_fsi_directive_decl] = STATE(2615),
    [sym_preproc_line] = STATE(2615),
    [sym_identifier] = ACTIONS(3505),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_COLON] = ACTIONS(3505),
    [anon_sym_return] = ACTIONS(3505),
    [anon_sym_do] = ACTIONS(3505),
    [anon_sym_let] = ACTIONS(3505),
    [anon_sym_let_BANG] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3505),
    [anon_sym_COMMA] = ACTIONS(3503),
    [anon_sym_null] = ACTIONS(3505),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_COLON_QMARK] = ACTIONS(3505),
    [anon_sym_COLON_COLON] = ACTIONS(3503),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3503),
    [anon_sym_LBRACE] = ACTIONS(3505),
    [anon_sym_LT_AT] = ACTIONS(3505),
    [anon_sym_LT_AT_AT] = ACTIONS(3505),
    [anon_sym_DOT] = ACTIONS(3505),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3503),
    [anon_sym_new] = ACTIONS(3505),
    [anon_sym_return_BANG] = ACTIONS(3503),
    [anon_sym_yield] = ACTIONS(3505),
    [anon_sym_yield_BANG] = ACTIONS(3503),
    [anon_sym_lazy] = ACTIONS(3505),
    [anon_sym_assert] = ACTIONS(3505),
    [anon_sym_upcast] = ACTIONS(3505),
    [anon_sym_downcast] = ACTIONS(3505),
    [anon_sym_COLON_GT] = ACTIONS(3503),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3503),
    [anon_sym_for] = ACTIONS(3505),
    [anon_sym_while] = ACTIONS(3505),
    [anon_sym_if] = ACTIONS(3505),
    [anon_sym_fun] = ACTIONS(3505),
    [anon_sym_DASH_GT] = ACTIONS(3505),
    [anon_sym_try] = ACTIONS(3505),
    [anon_sym_match] = ACTIONS(3505),
    [anon_sym_match_BANG] = ACTIONS(3503),
    [anon_sym_function] = ACTIONS(3505),
    [anon_sym_LT_DASH] = ACTIONS(3505),
    [anon_sym_DOT_LBRACK] = ACTIONS(3503),
    [anon_sym_LT] = ACTIONS(3503),
    [anon_sym_GT] = ACTIONS(3505),
    [anon_sym_use] = ACTIONS(3505),
    [anon_sym_use_BANG] = ACTIONS(3503),
    [anon_sym_do_BANG] = ACTIONS(3503),
    [anon_sym_begin] = ACTIONS(3505),
    [anon_sym_LPAREN2] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3505),
    [anon_sym_LT2] = ACTIONS(5143),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_or] = ACTIONS(3505),
    [aux_sym_char_token1] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3505),
    [anon_sym_DQUOTE] = ACTIONS(3505),
    [anon_sym_AT_DQUOTE] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [sym_bool] = ACTIONS(3505),
    [sym_unit] = ACTIONS(3503),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3505),
    [sym_op_identifier] = ACTIONS(3505),
    [anon_sym_PLUS] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3505),
    [anon_sym_PLUS_DOT] = ACTIONS(3505),
    [anon_sym_DASH_DOT] = ACTIONS(3505),
    [anon_sym_PERCENT] = ACTIONS(3505),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3503),
    [aux_sym_prefix_op_token1] = ACTIONS(3505),
    [aux_sym_infix_op_token1] = ACTIONS(3503),
    [aux_sym_infix_op_token2] = ACTIONS(3505),
    [anon_sym_PIPE_PIPE] = ACTIONS(3505),
    [anon_sym_BANG_EQ] = ACTIONS(3505),
    [anon_sym_COLON_EQ] = ACTIONS(3503),
    [anon_sym_DOLLAR] = ACTIONS(3505),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3505),
    [sym_int] = ACTIONS(3505),
    [sym_xint] = ACTIONS(3503),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3503),
    [sym__newline] = ACTIONS(3503),
  },
  [2616] = {
    [sym_block_comment] = STATE(2616),
    [sym_compiler_directive_decl] = STATE(2616),
    [sym_fsi_directive_decl] = STATE(2616),
    [sym_preproc_line] = STATE(2616),
    [sym_identifier] = ACTIONS(3505),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_COLON] = ACTIONS(3505),
    [anon_sym_return] = ACTIONS(3505),
    [anon_sym_do] = ACTIONS(3505),
    [anon_sym_let] = ACTIONS(3505),
    [anon_sym_let_BANG] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3505),
    [anon_sym_COMMA] = ACTIONS(3503),
    [anon_sym_null] = ACTIONS(3505),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_COLON_QMARK] = ACTIONS(3505),
    [anon_sym_COLON_COLON] = ACTIONS(3503),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3503),
    [anon_sym_LBRACE] = ACTIONS(3505),
    [anon_sym_LT_AT] = ACTIONS(3505),
    [anon_sym_LT_AT_AT] = ACTIONS(3505),
    [anon_sym_AT_AT_GT] = ACTIONS(3505),
    [anon_sym_DOT] = ACTIONS(3505),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3503),
    [anon_sym_new] = ACTIONS(3505),
    [anon_sym_return_BANG] = ACTIONS(3503),
    [anon_sym_yield] = ACTIONS(3505),
    [anon_sym_yield_BANG] = ACTIONS(3503),
    [anon_sym_lazy] = ACTIONS(3505),
    [anon_sym_assert] = ACTIONS(3505),
    [anon_sym_upcast] = ACTIONS(3505),
    [anon_sym_downcast] = ACTIONS(3505),
    [anon_sym_COLON_GT] = ACTIONS(3503),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3503),
    [anon_sym_for] = ACTIONS(3505),
    [anon_sym_while] = ACTIONS(3505),
    [anon_sym_if] = ACTIONS(3505),
    [anon_sym_fun] = ACTIONS(3505),
    [anon_sym_DASH_GT] = ACTIONS(3505),
    [anon_sym_try] = ACTIONS(3505),
    [anon_sym_match] = ACTIONS(3505),
    [anon_sym_match_BANG] = ACTIONS(3503),
    [anon_sym_function] = ACTIONS(3505),
    [anon_sym_LT_DASH] = ACTIONS(3505),
    [anon_sym_DOT_LBRACK] = ACTIONS(3503),
    [anon_sym_LT] = ACTIONS(3503),
    [anon_sym_use] = ACTIONS(3505),
    [anon_sym_use_BANG] = ACTIONS(3503),
    [anon_sym_do_BANG] = ACTIONS(3503),
    [anon_sym_begin] = ACTIONS(3505),
    [anon_sym_LPAREN2] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3505),
    [anon_sym_LT2] = ACTIONS(5145),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_or] = ACTIONS(3505),
    [aux_sym_char_token1] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3505),
    [anon_sym_DQUOTE] = ACTIONS(3505),
    [anon_sym_AT_DQUOTE] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [sym_bool] = ACTIONS(3505),
    [sym_unit] = ACTIONS(3503),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3505),
    [sym_op_identifier] = ACTIONS(3505),
    [anon_sym_PLUS] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3505),
    [anon_sym_PLUS_DOT] = ACTIONS(3505),
    [anon_sym_DASH_DOT] = ACTIONS(3505),
    [anon_sym_PERCENT] = ACTIONS(3505),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3503),
    [aux_sym_prefix_op_token1] = ACTIONS(3505),
    [aux_sym_infix_op_token1] = ACTIONS(3503),
    [aux_sym_infix_op_token2] = ACTIONS(3505),
    [anon_sym_PIPE_PIPE] = ACTIONS(3505),
    [anon_sym_BANG_EQ] = ACTIONS(3505),
    [anon_sym_COLON_EQ] = ACTIONS(3503),
    [anon_sym_DOLLAR] = ACTIONS(3505),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3505),
    [sym_int] = ACTIONS(3505),
    [sym_xint] = ACTIONS(3503),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3503),
    [sym__newline] = ACTIONS(3503),
  },
  [2617] = {
    [sym_block_comment] = STATE(2617),
    [sym_compiler_directive_decl] = STATE(2617),
    [sym_fsi_directive_decl] = STATE(2617),
    [sym_preproc_line] = STATE(2617),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_AT_GT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [2618] = {
    [sym_block_comment] = STATE(2618),
    [sym_compiler_directive_decl] = STATE(2618),
    [sym_fsi_directive_decl] = STATE(2618),
    [sym_preproc_line] = STATE(2618),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_COLON] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_LT_DASH] = ACTIONS(3480),
    [anon_sym_DOT_LBRACK] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_DOT_DOT] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_or] = ACTIONS(3480),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3480),
    [anon_sym_DASH_DOT] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3480),
    [aux_sym_infix_op_token1] = ACTIONS(3478),
    [aux_sym_infix_op_token2] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3480),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
  },
  [2619] = {
    [sym_block_comment] = STATE(2619),
    [sym_compiler_directive_decl] = STATE(2619),
    [sym_fsi_directive_decl] = STATE(2619),
    [sym_preproc_line] = STATE(2619),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_and] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [aux_sym_float_token1] = ACTIONS(5147),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
    [sym__dedent] = ACTIONS(3602),
  },
  [2620] = {
    [sym_block_comment] = STATE(2620),
    [sym_compiler_directive_decl] = STATE(2620),
    [sym_fsi_directive_decl] = STATE(2620),
    [sym_preproc_line] = STATE(2620),
    [sym_identifier] = ACTIONS(3753),
    [anon_sym_EQ] = ACTIONS(3751),
    [anon_sym_COLON] = ACTIONS(3753),
    [anon_sym_return] = ACTIONS(3753),
    [anon_sym_do] = ACTIONS(3753),
    [anon_sym_let] = ACTIONS(3753),
    [anon_sym_let_BANG] = ACTIONS(3751),
    [anon_sym_LPAREN] = ACTIONS(3753),
    [anon_sym_COMMA] = ACTIONS(3751),
    [anon_sym_null] = ACTIONS(3753),
    [anon_sym_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_COLON] = ACTIONS(3751),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3751),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_LT_AT] = ACTIONS(3753),
    [anon_sym_LT_AT_AT] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3753),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3751),
    [anon_sym_new] = ACTIONS(3753),
    [anon_sym_with] = ACTIONS(3753),
    [anon_sym_return_BANG] = ACTIONS(3751),
    [anon_sym_yield] = ACTIONS(3753),
    [anon_sym_yield_BANG] = ACTIONS(3751),
    [anon_sym_lazy] = ACTIONS(3753),
    [anon_sym_assert] = ACTIONS(3753),
    [anon_sym_upcast] = ACTIONS(3753),
    [anon_sym_downcast] = ACTIONS(3753),
    [anon_sym_COLON_GT] = ACTIONS(3751),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3751),
    [anon_sym_for] = ACTIONS(3753),
    [anon_sym_while] = ACTIONS(3753),
    [anon_sym_if] = ACTIONS(3753),
    [anon_sym_fun] = ACTIONS(3753),
    [anon_sym_try] = ACTIONS(3753),
    [anon_sym_match] = ACTIONS(3753),
    [anon_sym_match_BANG] = ACTIONS(3751),
    [anon_sym_function] = ACTIONS(3753),
    [anon_sym_LT_DASH] = ACTIONS(3753),
    [anon_sym_DOT_LBRACK] = ACTIONS(3751),
    [anon_sym_LT] = ACTIONS(3751),
    [anon_sym_use] = ACTIONS(3753),
    [anon_sym_use_BANG] = ACTIONS(3751),
    [anon_sym_do_BANG] = ACTIONS(3751),
    [anon_sym_begin] = ACTIONS(3753),
    [anon_sym_LPAREN2] = ACTIONS(3753),
    [anon_sym_DOT_DOT2] = ACTIONS(3751),
    [anon_sym_or] = ACTIONS(3753),
    [aux_sym_char_token1] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3753),
    [anon_sym_AT_DQUOTE] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [sym_bool] = ACTIONS(3753),
    [sym_unit] = ACTIONS(3751),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3753),
    [sym_op_identifier] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PLUS_DOT] = ACTIONS(3753),
    [anon_sym_DASH_DOT] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3753),
    [anon_sym_AMP_AMP] = ACTIONS(3753),
    [anon_sym_TILDE] = ACTIONS(3751),
    [aux_sym_prefix_op_token1] = ACTIONS(3753),
    [aux_sym_infix_op_token1] = ACTIONS(3751),
    [aux_sym_infix_op_token2] = ACTIONS(3753),
    [anon_sym_PIPE_PIPE] = ACTIONS(3753),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_COLON_EQ] = ACTIONS(3751),
    [anon_sym_DOLLAR] = ACTIONS(3753),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3753),
    [sym_int] = ACTIONS(5149),
    [sym_xint] = ACTIONS(3751),
    [anon_sym_f] = ACTIONS(3753),
    [aux_sym_decimal_token1] = ACTIONS(3753),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3751),
    [sym__newline] = ACTIONS(3751),
    [sym__dedent] = ACTIONS(3751),
  },
  [2621] = {
    [sym_elif_expression] = STATE(2836),
    [sym_block_comment] = STATE(2621),
    [sym_compiler_directive_decl] = STATE(2621),
    [sym_fsi_directive_decl] = STATE(2621),
    [sym_preproc_line] = STATE(2621),
    [aux_sym_if_expression_repeat1] = STATE(2621),
    [sym_identifier] = ACTIONS(3555),
    [anon_sym_EQ] = ACTIONS(3553),
    [anon_sym_COLON] = ACTIONS(3555),
    [anon_sym_return] = ACTIONS(3555),
    [anon_sym_do] = ACTIONS(3555),
    [anon_sym_let] = ACTIONS(3555),
    [anon_sym_let_BANG] = ACTIONS(3553),
    [anon_sym_LPAREN] = ACTIONS(3555),
    [anon_sym_COMMA] = ACTIONS(3553),
    [anon_sym_null] = ACTIONS(3555),
    [anon_sym_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_COLON] = ACTIONS(3553),
    [anon_sym_AMP] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(3555),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3553),
    [anon_sym_LBRACE] = ACTIONS(3555),
    [anon_sym_LT_AT] = ACTIONS(3555),
    [anon_sym_AT_GT] = ACTIONS(3555),
    [anon_sym_LT_AT_AT] = ACTIONS(3555),
    [anon_sym_DOT] = ACTIONS(3555),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3553),
    [anon_sym_new] = ACTIONS(3555),
    [anon_sym_return_BANG] = ACTIONS(3553),
    [anon_sym_yield] = ACTIONS(3555),
    [anon_sym_yield_BANG] = ACTIONS(3553),
    [anon_sym_lazy] = ACTIONS(3555),
    [anon_sym_assert] = ACTIONS(3555),
    [anon_sym_upcast] = ACTIONS(3555),
    [anon_sym_downcast] = ACTIONS(3555),
    [anon_sym_COLON_GT] = ACTIONS(3553),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3553),
    [anon_sym_for] = ACTIONS(3555),
    [anon_sym_while] = ACTIONS(3555),
    [anon_sym_else] = ACTIONS(3555),
    [anon_sym_elif] = ACTIONS(5151),
    [anon_sym_if] = ACTIONS(3555),
    [anon_sym_fun] = ACTIONS(3555),
    [anon_sym_try] = ACTIONS(3555),
    [anon_sym_match] = ACTIONS(3555),
    [anon_sym_match_BANG] = ACTIONS(3553),
    [anon_sym_function] = ACTIONS(3555),
    [anon_sym_LT_DASH] = ACTIONS(3555),
    [anon_sym_DOT_LBRACK] = ACTIONS(3553),
    [anon_sym_LT] = ACTIONS(3553),
    [anon_sym_use] = ACTIONS(3555),
    [anon_sym_use_BANG] = ACTIONS(3553),
    [anon_sym_do_BANG] = ACTIONS(3553),
    [anon_sym_begin] = ACTIONS(3555),
    [anon_sym_LPAREN2] = ACTIONS(3555),
    [anon_sym_or] = ACTIONS(3555),
    [aux_sym_char_token1] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3555),
    [anon_sym_DQUOTE] = ACTIONS(3555),
    [anon_sym_AT_DQUOTE] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [sym_bool] = ACTIONS(3555),
    [sym_unit] = ACTIONS(3553),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3555),
    [sym_op_identifier] = ACTIONS(3555),
    [anon_sym_PLUS] = ACTIONS(3555),
    [anon_sym_DASH] = ACTIONS(3555),
    [anon_sym_PLUS_DOT] = ACTIONS(3555),
    [anon_sym_DASH_DOT] = ACTIONS(3555),
    [anon_sym_PERCENT] = ACTIONS(3555),
    [anon_sym_AMP_AMP] = ACTIONS(3555),
    [anon_sym_TILDE] = ACTIONS(3553),
    [aux_sym_prefix_op_token1] = ACTIONS(3555),
    [aux_sym_infix_op_token1] = ACTIONS(3553),
    [aux_sym_infix_op_token2] = ACTIONS(3555),
    [anon_sym_PIPE_PIPE] = ACTIONS(3555),
    [anon_sym_BANG_EQ] = ACTIONS(3555),
    [anon_sym_COLON_EQ] = ACTIONS(3553),
    [anon_sym_DOLLAR] = ACTIONS(3555),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3555),
    [sym_int] = ACTIONS(3555),
    [sym_xint] = ACTIONS(3553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3553),
    [sym__newline] = ACTIONS(3553),
  },
  [2622] = {
    [sym_block_comment] = STATE(2622),
    [sym_compiler_directive_decl] = STATE(2622),
    [sym_fsi_directive_decl] = STATE(2622),
    [sym_preproc_line] = STATE(2622),
    [sym_identifier] = ACTIONS(3511),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3511),
    [anon_sym_return] = ACTIONS(3511),
    [anon_sym_do] = ACTIONS(3511),
    [anon_sym_let] = ACTIONS(3511),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3511),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3511),
    [anon_sym_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(3511),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_LT_AT] = ACTIONS(3511),
    [anon_sym_LT_AT_AT] = ACTIONS(3511),
    [anon_sym_DOT] = ACTIONS(3511),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3511),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3511),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3511),
    [anon_sym_assert] = ACTIONS(3511),
    [anon_sym_upcast] = ACTIONS(3511),
    [anon_sym_downcast] = ACTIONS(3511),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3511),
    [anon_sym_while] = ACTIONS(3511),
    [anon_sym_if] = ACTIONS(3511),
    [anon_sym_fun] = ACTIONS(3511),
    [anon_sym_DASH_GT] = ACTIONS(3511),
    [anon_sym_try] = ACTIONS(3511),
    [anon_sym_match] = ACTIONS(3511),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3511),
    [anon_sym_LT_DASH] = ACTIONS(3511),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3511),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_DOT_DOT] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3511),
    [anon_sym_LPAREN2] = ACTIONS(3511),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_LT2] = ACTIONS(3511),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3511),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3511),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3511),
    [sym_unit] = ACTIONS(3509),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3511),
    [sym_op_identifier] = ACTIONS(3511),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3511),
    [anon_sym_PLUS_DOT] = ACTIONS(3511),
    [anon_sym_DASH_DOT] = ACTIONS(3511),
    [anon_sym_PERCENT] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3511),
    [aux_sym_infix_op_token1] = ACTIONS(3509),
    [aux_sym_infix_op_token2] = ACTIONS(3511),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_BANG_EQ] = ACTIONS(3511),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3511),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3511),
    [sym_int] = ACTIONS(3511),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [2623] = {
    [sym_block_comment] = STATE(2623),
    [sym_compiler_directive_decl] = STATE(2623),
    [sym_fsi_directive_decl] = STATE(2623),
    [sym_preproc_line] = STATE(2623),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [anon_sym_DOT_LBRACK] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_DOT_DOT] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_or] = ACTIONS(3498),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3498),
    [anon_sym_DASH_DOT] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3498),
    [aux_sym_infix_op_token1] = ACTIONS(3496),
    [aux_sym_infix_op_token2] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_COLON_EQ] = ACTIONS(3496),
    [anon_sym_DOLLAR] = ACTIONS(3498),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3498),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
  },
  [2624] = {
    [sym_block_comment] = STATE(2624),
    [sym_compiler_directive_decl] = STATE(2624),
    [sym_fsi_directive_decl] = STATE(2624),
    [sym_preproc_line] = STATE(2624),
    [sym_identifier] = ACTIONS(3511),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3511),
    [anon_sym_return] = ACTIONS(3511),
    [anon_sym_do] = ACTIONS(3511),
    [anon_sym_let] = ACTIONS(3511),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3511),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3511),
    [anon_sym_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(3511),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_LT_AT] = ACTIONS(3511),
    [anon_sym_LT_AT_AT] = ACTIONS(3511),
    [anon_sym_DOT] = ACTIONS(3511),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3511),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3511),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3511),
    [anon_sym_assert] = ACTIONS(3511),
    [anon_sym_upcast] = ACTIONS(3511),
    [anon_sym_downcast] = ACTIONS(3511),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3511),
    [anon_sym_while] = ACTIONS(3511),
    [anon_sym_if] = ACTIONS(3511),
    [anon_sym_fun] = ACTIONS(3511),
    [anon_sym_DASH_GT] = ACTIONS(3511),
    [anon_sym_try] = ACTIONS(3511),
    [anon_sym_match] = ACTIONS(3511),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3511),
    [anon_sym_LT_DASH] = ACTIONS(3511),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_GT] = ACTIONS(3511),
    [anon_sym_use] = ACTIONS(3511),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3511),
    [anon_sym_LPAREN2] = ACTIONS(3511),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_LT2] = ACTIONS(3511),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3511),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3511),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3511),
    [sym_unit] = ACTIONS(3509),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3511),
    [sym_op_identifier] = ACTIONS(3511),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3511),
    [anon_sym_PLUS_DOT] = ACTIONS(3511),
    [anon_sym_DASH_DOT] = ACTIONS(3511),
    [anon_sym_PERCENT] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3511),
    [aux_sym_infix_op_token1] = ACTIONS(3509),
    [aux_sym_infix_op_token2] = ACTIONS(3511),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_BANG_EQ] = ACTIONS(3511),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3511),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3511),
    [sym_int] = ACTIONS(3511),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [2625] = {
    [sym_block_comment] = STATE(2625),
    [sym_compiler_directive_decl] = STATE(2625),
    [sym_fsi_directive_decl] = STATE(2625),
    [sym_preproc_line] = STATE(2625),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_GT] = ACTIONS(3487),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [2626] = {
    [sym_block_comment] = STATE(2626),
    [sym_compiler_directive_decl] = STATE(2626),
    [sym_fsi_directive_decl] = STATE(2626),
    [sym_preproc_line] = STATE(2626),
    [sym_identifier] = ACTIONS(3535),
    [anon_sym_EQ] = ACTIONS(3533),
    [anon_sym_COLON] = ACTIONS(3535),
    [anon_sym_return] = ACTIONS(3535),
    [anon_sym_do] = ACTIONS(3535),
    [anon_sym_let] = ACTIONS(3535),
    [anon_sym_let_BANG] = ACTIONS(3533),
    [anon_sym_LPAREN] = ACTIONS(3535),
    [anon_sym_COMMA] = ACTIONS(3533),
    [anon_sym_null] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(3535),
    [anon_sym_COLON_QMARK] = ACTIONS(3535),
    [anon_sym_COLON_COLON] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3533),
    [anon_sym_LBRACE] = ACTIONS(3535),
    [anon_sym_LT_AT] = ACTIONS(3535),
    [anon_sym_LT_AT_AT] = ACTIONS(3535),
    [anon_sym_AT_AT_GT] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(3535),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3533),
    [anon_sym_new] = ACTIONS(3535),
    [anon_sym_return_BANG] = ACTIONS(3533),
    [anon_sym_yield] = ACTIONS(3535),
    [anon_sym_yield_BANG] = ACTIONS(3533),
    [anon_sym_lazy] = ACTIONS(3535),
    [anon_sym_assert] = ACTIONS(3535),
    [anon_sym_upcast] = ACTIONS(3535),
    [anon_sym_downcast] = ACTIONS(3535),
    [anon_sym_COLON_GT] = ACTIONS(3533),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3533),
    [anon_sym_for] = ACTIONS(3535),
    [anon_sym_while] = ACTIONS(3535),
    [anon_sym_if] = ACTIONS(3535),
    [anon_sym_fun] = ACTIONS(3535),
    [anon_sym_DASH_GT] = ACTIONS(3535),
    [anon_sym_try] = ACTIONS(3535),
    [anon_sym_match] = ACTIONS(3535),
    [anon_sym_match_BANG] = ACTIONS(3533),
    [anon_sym_function] = ACTIONS(3535),
    [anon_sym_LT_DASH] = ACTIONS(3535),
    [anon_sym_DOT_LBRACK] = ACTIONS(3533),
    [anon_sym_LT] = ACTIONS(3533),
    [anon_sym_use] = ACTIONS(3535),
    [anon_sym_use_BANG] = ACTIONS(3533),
    [anon_sym_do_BANG] = ACTIONS(3533),
    [anon_sym_begin] = ACTIONS(3535),
    [anon_sym_LPAREN2] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(3535),
    [anon_sym_LT2] = ACTIONS(3535),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3533),
    [anon_sym_or] = ACTIONS(3535),
    [aux_sym_char_token1] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE] = ACTIONS(3535),
    [anon_sym_AT_DQUOTE] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [sym_bool] = ACTIONS(3535),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3535),
    [sym_op_identifier] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS_DOT] = ACTIONS(3535),
    [anon_sym_DASH_DOT] = ACTIONS(3535),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(3535),
    [anon_sym_TILDE] = ACTIONS(3533),
    [aux_sym_prefix_op_token1] = ACTIONS(3535),
    [aux_sym_infix_op_token1] = ACTIONS(3533),
    [aux_sym_infix_op_token2] = ACTIONS(3535),
    [anon_sym_PIPE_PIPE] = ACTIONS(3535),
    [anon_sym_BANG_EQ] = ACTIONS(3535),
    [anon_sym_COLON_EQ] = ACTIONS(3533),
    [anon_sym_DOLLAR] = ACTIONS(3535),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3535),
    [sym_int] = ACTIONS(3535),
    [sym_xint] = ACTIONS(3533),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3533),
    [sym__newline] = ACTIONS(3533),
  },
  [2627] = {
    [sym_block_comment] = STATE(2627),
    [sym_compiler_directive_decl] = STATE(2627),
    [sym_fsi_directive_decl] = STATE(2627),
    [sym_preproc_line] = STATE(2627),
    [sym_identifier] = ACTIONS(3531),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(3531),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_do] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_null] = ACTIONS(3531),
    [anon_sym_QMARK] = ACTIONS(3531),
    [anon_sym_COLON_QMARK] = ACTIONS(3531),
    [anon_sym_COLON_COLON] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3531),
    [anon_sym_LT_AT] = ACTIONS(3531),
    [anon_sym_LT_AT_AT] = ACTIONS(3531),
    [anon_sym_AT_AT_GT] = ACTIONS(3531),
    [anon_sym_DOT] = ACTIONS(3531),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3531),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3531),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3531),
    [anon_sym_assert] = ACTIONS(3531),
    [anon_sym_upcast] = ACTIONS(3531),
    [anon_sym_downcast] = ACTIONS(3531),
    [anon_sym_COLON_GT] = ACTIONS(3529),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3531),
    [anon_sym_while] = ACTIONS(3531),
    [anon_sym_if] = ACTIONS(3531),
    [anon_sym_fun] = ACTIONS(3531),
    [anon_sym_DASH_GT] = ACTIONS(3531),
    [anon_sym_try] = ACTIONS(3531),
    [anon_sym_match] = ACTIONS(3531),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3531),
    [anon_sym_LT_DASH] = ACTIONS(3531),
    [anon_sym_DOT_LBRACK] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_use] = ACTIONS(3531),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3531),
    [anon_sym_LPAREN2] = ACTIONS(3531),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LT2] = ACTIONS(3531),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_or] = ACTIONS(3531),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3531),
    [anon_sym_DQUOTE] = ACTIONS(3531),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3531),
    [sym_unit] = ACTIONS(3529),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3531),
    [sym_op_identifier] = ACTIONS(3531),
    [anon_sym_PLUS] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(3531),
    [anon_sym_PLUS_DOT] = ACTIONS(3531),
    [anon_sym_DASH_DOT] = ACTIONS(3531),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_AMP_AMP] = ACTIONS(3531),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3531),
    [aux_sym_infix_op_token1] = ACTIONS(3529),
    [aux_sym_infix_op_token2] = ACTIONS(3531),
    [anon_sym_PIPE_PIPE] = ACTIONS(3531),
    [anon_sym_BANG_EQ] = ACTIONS(3531),
    [anon_sym_COLON_EQ] = ACTIONS(3529),
    [anon_sym_DOLLAR] = ACTIONS(3531),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3531),
    [sym_int] = ACTIONS(3531),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [sym__newline] = ACTIONS(3529),
  },
  [2628] = {
    [sym_block_comment] = STATE(2628),
    [sym_compiler_directive_decl] = STATE(2628),
    [sym_fsi_directive_decl] = STATE(2628),
    [sym_preproc_line] = STATE(2628),
    [sym_identifier] = ACTIONS(3547),
    [anon_sym_EQ] = ACTIONS(3545),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_return] = ACTIONS(3547),
    [anon_sym_do] = ACTIONS(3547),
    [anon_sym_let] = ACTIONS(3547),
    [anon_sym_let_BANG] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(3547),
    [anon_sym_COMMA] = ACTIONS(3545),
    [anon_sym_null] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3547),
    [anon_sym_COLON_QMARK] = ACTIONS(3547),
    [anon_sym_COLON_COLON] = ACTIONS(3545),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3545),
    [anon_sym_LBRACE] = ACTIONS(3547),
    [anon_sym_LT_AT] = ACTIONS(3547),
    [anon_sym_LT_AT_AT] = ACTIONS(3547),
    [anon_sym_AT_AT_GT] = ACTIONS(3547),
    [anon_sym_DOT] = ACTIONS(3547),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3545),
    [anon_sym_new] = ACTIONS(3547),
    [anon_sym_return_BANG] = ACTIONS(3545),
    [anon_sym_yield] = ACTIONS(3547),
    [anon_sym_yield_BANG] = ACTIONS(3545),
    [anon_sym_lazy] = ACTIONS(3547),
    [anon_sym_assert] = ACTIONS(3547),
    [anon_sym_upcast] = ACTIONS(3547),
    [anon_sym_downcast] = ACTIONS(3547),
    [anon_sym_COLON_GT] = ACTIONS(3545),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3545),
    [anon_sym_for] = ACTIONS(3547),
    [anon_sym_while] = ACTIONS(3547),
    [anon_sym_if] = ACTIONS(3547),
    [anon_sym_fun] = ACTIONS(3547),
    [anon_sym_DASH_GT] = ACTIONS(3547),
    [anon_sym_try] = ACTIONS(3547),
    [anon_sym_match] = ACTIONS(3547),
    [anon_sym_match_BANG] = ACTIONS(3545),
    [anon_sym_function] = ACTIONS(3547),
    [anon_sym_LT_DASH] = ACTIONS(3547),
    [anon_sym_DOT_LBRACK] = ACTIONS(3545),
    [anon_sym_LT] = ACTIONS(3545),
    [anon_sym_use] = ACTIONS(3547),
    [anon_sym_use_BANG] = ACTIONS(3545),
    [anon_sym_do_BANG] = ACTIONS(3545),
    [anon_sym_begin] = ACTIONS(3547),
    [anon_sym_LPAREN2] = ACTIONS(3547),
    [anon_sym_STAR] = ACTIONS(3547),
    [anon_sym_LT2] = ACTIONS(3547),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_or] = ACTIONS(3547),
    [aux_sym_char_token1] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3547),
    [anon_sym_DQUOTE] = ACTIONS(3547),
    [anon_sym_AT_DQUOTE] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [sym_bool] = ACTIONS(3547),
    [sym_unit] = ACTIONS(3545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3547),
    [sym_op_identifier] = ACTIONS(3547),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PLUS_DOT] = ACTIONS(3547),
    [anon_sym_DASH_DOT] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3547),
    [anon_sym_AMP_AMP] = ACTIONS(3547),
    [anon_sym_TILDE] = ACTIONS(3545),
    [aux_sym_prefix_op_token1] = ACTIONS(3547),
    [aux_sym_infix_op_token1] = ACTIONS(3545),
    [aux_sym_infix_op_token2] = ACTIONS(3547),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_BANG_EQ] = ACTIONS(3547),
    [anon_sym_COLON_EQ] = ACTIONS(3545),
    [anon_sym_DOLLAR] = ACTIONS(3547),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3547),
    [sym_int] = ACTIONS(3547),
    [sym_xint] = ACTIONS(3545),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3545),
    [sym__newline] = ACTIONS(3545),
  },
  [2629] = {
    [sym_block_comment] = STATE(2629),
    [sym_compiler_directive_decl] = STATE(2629),
    [sym_fsi_directive_decl] = STATE(2629),
    [sym_preproc_line] = STATE(2629),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3525),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_COLON] = ACTIONS(3525),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3527),
    [anon_sym_AT_AT_GT] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_COLON_GT] = ACTIONS(3525),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_DASH_GT] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_LT_DASH] = ACTIONS(3527),
    [anon_sym_DOT_LBRACK] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_LPAREN2] = ACTIONS(3527),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_LT2] = ACTIONS(3527),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_or] = ACTIONS(3527),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3525),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3527),
    [anon_sym_DASH_DOT] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3527),
    [aux_sym_infix_op_token1] = ACTIONS(3525),
    [aux_sym_infix_op_token2] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_COLON_EQ] = ACTIONS(3525),
    [anon_sym_DOLLAR] = ACTIONS(3527),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3527),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3525),
    [sym__newline] = ACTIONS(3525),
  },
  [2630] = {
    [sym_block_comment] = STATE(2630),
    [sym_compiler_directive_decl] = STATE(2630),
    [sym_fsi_directive_decl] = STATE(2630),
    [sym_preproc_line] = STATE(2630),
    [aux_sym_rules_repeat1] = STATE(2639),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_as] = ACTIONS(3693),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(5154),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_with] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_or] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(5156),
    [sym__dedent] = ACTIONS(3691),
  },
  [2631] = {
    [sym_block_comment] = STATE(2631),
    [sym_compiler_directive_decl] = STATE(2631),
    [sym_fsi_directive_decl] = STATE(2631),
    [sym_preproc_line] = STATE(2631),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_DOT_DOT] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [2632] = {
    [sym_block_comment] = STATE(2632),
    [sym_compiler_directive_decl] = STATE(2632),
    [sym_fsi_directive_decl] = STATE(2632),
    [sym_preproc_line] = STATE(2632),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_COLON] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_AT_GT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_LT_DASH] = ACTIONS(3480),
    [anon_sym_DOT_LBRACK] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_or] = ACTIONS(3480),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3480),
    [anon_sym_DASH_DOT] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3480),
    [aux_sym_infix_op_token1] = ACTIONS(3478),
    [aux_sym_infix_op_token2] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3480),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
  },
  [2633] = {
    [sym_block_comment] = STATE(2633),
    [sym_compiler_directive_decl] = STATE(2633),
    [sym_fsi_directive_decl] = STATE(2633),
    [sym_preproc_line] = STATE(2633),
    [sym_identifier] = ACTIONS(3543),
    [anon_sym_EQ] = ACTIONS(3541),
    [anon_sym_COLON] = ACTIONS(3543),
    [anon_sym_return] = ACTIONS(3543),
    [anon_sym_do] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3543),
    [anon_sym_let_BANG] = ACTIONS(3541),
    [anon_sym_LPAREN] = ACTIONS(3543),
    [anon_sym_COMMA] = ACTIONS(3541),
    [anon_sym_null] = ACTIONS(3543),
    [anon_sym_QMARK] = ACTIONS(3543),
    [anon_sym_COLON_QMARK] = ACTIONS(3543),
    [anon_sym_COLON_COLON] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3543),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3541),
    [anon_sym_LBRACE] = ACTIONS(3543),
    [anon_sym_LT_AT] = ACTIONS(3543),
    [anon_sym_LT_AT_AT] = ACTIONS(3543),
    [anon_sym_AT_AT_GT] = ACTIONS(3543),
    [anon_sym_DOT] = ACTIONS(3543),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3541),
    [anon_sym_new] = ACTIONS(3543),
    [anon_sym_return_BANG] = ACTIONS(3541),
    [anon_sym_yield] = ACTIONS(3543),
    [anon_sym_yield_BANG] = ACTIONS(3541),
    [anon_sym_lazy] = ACTIONS(3543),
    [anon_sym_assert] = ACTIONS(3543),
    [anon_sym_upcast] = ACTIONS(3543),
    [anon_sym_downcast] = ACTIONS(3543),
    [anon_sym_COLON_GT] = ACTIONS(3541),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3541),
    [anon_sym_for] = ACTIONS(3543),
    [anon_sym_while] = ACTIONS(3543),
    [anon_sym_if] = ACTIONS(3543),
    [anon_sym_fun] = ACTIONS(3543),
    [anon_sym_DASH_GT] = ACTIONS(3543),
    [anon_sym_try] = ACTIONS(3543),
    [anon_sym_match] = ACTIONS(3543),
    [anon_sym_match_BANG] = ACTIONS(3541),
    [anon_sym_function] = ACTIONS(3543),
    [anon_sym_LT_DASH] = ACTIONS(3543),
    [anon_sym_DOT_LBRACK] = ACTIONS(3541),
    [anon_sym_LT] = ACTIONS(3541),
    [anon_sym_use] = ACTIONS(3543),
    [anon_sym_use_BANG] = ACTIONS(3541),
    [anon_sym_do_BANG] = ACTIONS(3541),
    [anon_sym_begin] = ACTIONS(3543),
    [anon_sym_LPAREN2] = ACTIONS(3543),
    [anon_sym_STAR] = ACTIONS(3543),
    [anon_sym_LT2] = ACTIONS(3543),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_or] = ACTIONS(3543),
    [aux_sym_char_token1] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3543),
    [anon_sym_DQUOTE] = ACTIONS(3543),
    [anon_sym_AT_DQUOTE] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [sym_bool] = ACTIONS(3543),
    [sym_unit] = ACTIONS(3541),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3543),
    [sym_op_identifier] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(3543),
    [anon_sym_DASH] = ACTIONS(3543),
    [anon_sym_PLUS_DOT] = ACTIONS(3543),
    [anon_sym_DASH_DOT] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3543),
    [anon_sym_AMP_AMP] = ACTIONS(3543),
    [anon_sym_TILDE] = ACTIONS(3541),
    [aux_sym_prefix_op_token1] = ACTIONS(3543),
    [aux_sym_infix_op_token1] = ACTIONS(3541),
    [aux_sym_infix_op_token2] = ACTIONS(3543),
    [anon_sym_PIPE_PIPE] = ACTIONS(3543),
    [anon_sym_BANG_EQ] = ACTIONS(3543),
    [anon_sym_COLON_EQ] = ACTIONS(3541),
    [anon_sym_DOLLAR] = ACTIONS(3543),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3543),
    [sym_int] = ACTIONS(3543),
    [sym_xint] = ACTIONS(3541),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3541),
    [sym__newline] = ACTIONS(3541),
  },
  [2634] = {
    [sym_attributes] = STATE(7162),
    [sym__attribute_set] = STATE(6370),
    [sym_function_or_value_defn] = STATE(3854),
    [sym_access_modifier] = STATE(10931),
    [sym__class_function_or_value_defn] = STATE(3860),
    [aux_sym__type_extension_inner] = STATE(2634),
    [sym__type_defn_elements] = STATE(3860),
    [sym_interface_implementation] = STATE(3863),
    [sym_member_defn] = STATE(3863),
    [sym_additional_constr_defn] = STATE(3864),
    [sym_block_comment] = STATE(2634),
    [sym_compiler_directive_decl] = STATE(2634),
    [sym_fsi_directive_decl] = STATE(2634),
    [sym_preproc_line] = STATE(2634),
    [sym_preproc_if_in_class_definition] = STATE(3860),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [ts_builtin_sym_end] = ACTIONS(5047),
    [sym_identifier] = ACTIONS(5049),
    [anon_sym_module] = ACTIONS(5049),
    [anon_sym_open] = ACTIONS(5049),
    [anon_sym_LBRACK_LT] = ACTIONS(5051),
    [anon_sym_return] = ACTIONS(5049),
    [anon_sym_type] = ACTIONS(5049),
    [anon_sym_do] = ACTIONS(5054),
    [anon_sym_and] = ACTIONS(5049),
    [anon_sym_let] = ACTIONS(5057),
    [anon_sym_let_BANG] = ACTIONS(5060),
    [aux_sym_access_modifier_token1] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(5049),
    [anon_sym_null] = ACTIONS(5049),
    [anon_sym_AMP] = ACTIONS(5049),
    [anon_sym_LBRACK] = ACTIONS(5049),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5047),
    [anon_sym_LBRACE] = ACTIONS(5049),
    [anon_sym_LT_AT] = ACTIONS(5049),
    [anon_sym_LT_AT_AT] = ACTIONS(5047),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5047),
    [anon_sym_new] = ACTIONS(5066),
    [anon_sym_return_BANG] = ACTIONS(5047),
    [anon_sym_yield] = ACTIONS(5049),
    [anon_sym_yield_BANG] = ACTIONS(5047),
    [anon_sym_lazy] = ACTIONS(5049),
    [anon_sym_assert] = ACTIONS(5049),
    [anon_sym_upcast] = ACTIONS(5049),
    [anon_sym_downcast] = ACTIONS(5049),
    [anon_sym_for] = ACTIONS(5049),
    [anon_sym_while] = ACTIONS(5049),
    [anon_sym_if] = ACTIONS(5049),
    [anon_sym_fun] = ACTIONS(5049),
    [anon_sym_try] = ACTIONS(5049),
    [anon_sym_match] = ACTIONS(5049),
    [anon_sym_match_BANG] = ACTIONS(5047),
    [anon_sym_function] = ACTIONS(5049),
    [anon_sym_use] = ACTIONS(5049),
    [anon_sym_use_BANG] = ACTIONS(5047),
    [anon_sym_do_BANG] = ACTIONS(5047),
    [anon_sym_begin] = ACTIONS(5049),
    [anon_sym_default] = ACTIONS(5069),
    [anon_sym_static] = ACTIONS(5072),
    [anon_sym_member] = ACTIONS(5159),
    [anon_sym_interface] = ACTIONS(5078),
    [anon_sym_exception] = ACTIONS(5049),
    [anon_sym_abstract] = ACTIONS(5081),
    [anon_sym_val] = ACTIONS(5084),
    [anon_sym_override] = ACTIONS(5069),
    [aux_sym_char_token1] = ACTIONS(5047),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5049),
    [anon_sym_DQUOTE] = ACTIONS(5049),
    [anon_sym_AT_DQUOTE] = ACTIONS(5047),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5047),
    [sym_bool] = ACTIONS(5049),
    [sym_unit] = ACTIONS(5047),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5049),
    [sym_op_identifier] = ACTIONS(5047),
    [anon_sym_PLUS] = ACTIONS(5049),
    [anon_sym_DASH] = ACTIONS(5049),
    [anon_sym_PLUS_DOT] = ACTIONS(5047),
    [anon_sym_DASH_DOT] = ACTIONS(5047),
    [anon_sym_PERCENT] = ACTIONS(5047),
    [anon_sym_AMP_AMP] = ACTIONS(5047),
    [anon_sym_TILDE] = ACTIONS(5047),
    [aux_sym_prefix_op_token1] = ACTIONS(5047),
    [sym_int] = ACTIONS(5049),
    [sym_xint] = ACTIONS(5047),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5047),
    [anon_sym_POUNDload] = ACTIONS(5047),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(5087),
  },
  [2635] = {
    [sym_block_comment] = STATE(2635),
    [sym_compiler_directive_decl] = STATE(2635),
    [sym_fsi_directive_decl] = STATE(2635),
    [sym_preproc_line] = STATE(2635),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [anon_sym_DOT_LBRACK] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_GT] = ACTIONS(3498),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_or] = ACTIONS(3498),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3498),
    [anon_sym_DASH_DOT] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3498),
    [aux_sym_infix_op_token1] = ACTIONS(3496),
    [aux_sym_infix_op_token2] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_COLON_EQ] = ACTIONS(3496),
    [anon_sym_DOLLAR] = ACTIONS(3498),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3498),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
  },
  [2636] = {
    [sym_block_comment] = STATE(2636),
    [sym_compiler_directive_decl] = STATE(2636),
    [sym_fsi_directive_decl] = STATE(2636),
    [sym_preproc_line] = STATE(2636),
    [aux_sym_rules_repeat1] = STATE(2651),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_as] = ACTIONS(3693),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(5154),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_with] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_or] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(5156),
    [sym__dedent] = ACTIONS(3691),
  },
  [2637] = {
    [sym_block_comment] = STATE(2637),
    [sym_compiler_directive_decl] = STATE(2637),
    [sym_fsi_directive_decl] = STATE(2637),
    [sym_preproc_line] = STATE(2637),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_EQ] = ACTIONS(3560),
    [anon_sym_COLON] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_let_BANG] = ACTIONS(3560),
    [anon_sym_LPAREN] = ACTIONS(3562),
    [anon_sym_COMMA] = ACTIONS(3560),
    [anon_sym_null] = ACTIONS(3562),
    [anon_sym_QMARK] = ACTIONS(3562),
    [anon_sym_COLON_QMARK] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3560),
    [anon_sym_LBRACE] = ACTIONS(3562),
    [anon_sym_LT_AT] = ACTIONS(3562),
    [anon_sym_AT_GT] = ACTIONS(3562),
    [anon_sym_LT_AT_AT] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(3562),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3560),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_return_BANG] = ACTIONS(3560),
    [anon_sym_yield] = ACTIONS(3562),
    [anon_sym_yield_BANG] = ACTIONS(3560),
    [anon_sym_lazy] = ACTIONS(3562),
    [anon_sym_assert] = ACTIONS(3562),
    [anon_sym_upcast] = ACTIONS(3562),
    [anon_sym_downcast] = ACTIONS(3562),
    [anon_sym_COLON_GT] = ACTIONS(3560),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3560),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_fun] = ACTIONS(3562),
    [anon_sym_DASH_GT] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_match] = ACTIONS(3562),
    [anon_sym_match_BANG] = ACTIONS(3560),
    [anon_sym_function] = ACTIONS(3562),
    [anon_sym_LT_DASH] = ACTIONS(3562),
    [anon_sym_DOT_LBRACK] = ACTIONS(3560),
    [anon_sym_LT] = ACTIONS(3560),
    [anon_sym_use] = ACTIONS(3562),
    [anon_sym_use_BANG] = ACTIONS(3560),
    [anon_sym_do_BANG] = ACTIONS(3560),
    [anon_sym_begin] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3562),
    [anon_sym_LT2] = ACTIONS(3562),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3560),
    [anon_sym_or] = ACTIONS(3562),
    [aux_sym_char_token1] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(3562),
    [anon_sym_AT_DQUOTE] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [sym_bool] = ACTIONS(3562),
    [sym_unit] = ACTIONS(3560),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3562),
    [sym_op_identifier] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS_DOT] = ACTIONS(3562),
    [anon_sym_DASH_DOT] = ACTIONS(3562),
    [anon_sym_PERCENT] = ACTIONS(3562),
    [anon_sym_AMP_AMP] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3560),
    [aux_sym_prefix_op_token1] = ACTIONS(3562),
    [aux_sym_infix_op_token1] = ACTIONS(3560),
    [aux_sym_infix_op_token2] = ACTIONS(3562),
    [anon_sym_PIPE_PIPE] = ACTIONS(3562),
    [anon_sym_BANG_EQ] = ACTIONS(3562),
    [anon_sym_COLON_EQ] = ACTIONS(3560),
    [anon_sym_DOLLAR] = ACTIONS(3562),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3562),
    [sym_int] = ACTIONS(3562),
    [sym_xint] = ACTIONS(3560),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3560),
    [sym__newline] = ACTIONS(3560),
  },
  [2638] = {
    [sym_block_comment] = STATE(2638),
    [sym_compiler_directive_decl] = STATE(2638),
    [sym_fsi_directive_decl] = STATE(2638),
    [sym_preproc_line] = STATE(2638),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [aux_sym_float_token1] = ACTIONS(5162),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [anon_sym_POUNDendif] = ACTIONS(3602),
    [anon_sym_POUNDelse] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
  },
  [2639] = {
    [sym_block_comment] = STATE(2639),
    [sym_compiler_directive_decl] = STATE(2639),
    [sym_fsi_directive_decl] = STATE(2639),
    [sym_preproc_line] = STATE(2639),
    [aux_sym_rules_repeat1] = STATE(2651),
    [sym_identifier] = ACTIONS(3676),
    [anon_sym_EQ] = ACTIONS(3674),
    [anon_sym_COLON] = ACTIONS(3676),
    [anon_sym_return] = ACTIONS(3676),
    [anon_sym_do] = ACTIONS(3676),
    [anon_sym_let] = ACTIONS(3676),
    [anon_sym_let_BANG] = ACTIONS(3674),
    [anon_sym_as] = ACTIONS(3676),
    [anon_sym_LPAREN] = ACTIONS(3676),
    [anon_sym_COMMA] = ACTIONS(3674),
    [anon_sym_null] = ACTIONS(3676),
    [anon_sym_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_COLON] = ACTIONS(3674),
    [anon_sym_PIPE] = ACTIONS(5154),
    [anon_sym_AMP] = ACTIONS(3676),
    [anon_sym_LBRACK] = ACTIONS(3676),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3674),
    [anon_sym_LBRACE] = ACTIONS(3676),
    [anon_sym_LT_AT] = ACTIONS(3676),
    [anon_sym_LT_AT_AT] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3674),
    [anon_sym_new] = ACTIONS(3676),
    [anon_sym_with] = ACTIONS(3676),
    [anon_sym_return_BANG] = ACTIONS(3674),
    [anon_sym_yield] = ACTIONS(3676),
    [anon_sym_yield_BANG] = ACTIONS(3674),
    [anon_sym_lazy] = ACTIONS(3676),
    [anon_sym_assert] = ACTIONS(3676),
    [anon_sym_upcast] = ACTIONS(3676),
    [anon_sym_downcast] = ACTIONS(3676),
    [anon_sym_COLON_GT] = ACTIONS(3674),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3674),
    [anon_sym_for] = ACTIONS(3676),
    [anon_sym_while] = ACTIONS(3676),
    [anon_sym_if] = ACTIONS(3676),
    [anon_sym_fun] = ACTIONS(3676),
    [anon_sym_try] = ACTIONS(3676),
    [anon_sym_match] = ACTIONS(3676),
    [anon_sym_match_BANG] = ACTIONS(3674),
    [anon_sym_function] = ACTIONS(3676),
    [anon_sym_LT_DASH] = ACTIONS(3676),
    [anon_sym_DOT_LBRACK] = ACTIONS(3674),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_use] = ACTIONS(3676),
    [anon_sym_use_BANG] = ACTIONS(3674),
    [anon_sym_do_BANG] = ACTIONS(3674),
    [anon_sym_begin] = ACTIONS(3676),
    [anon_sym_LPAREN2] = ACTIONS(3676),
    [anon_sym_or] = ACTIONS(3676),
    [aux_sym_char_token1] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3676),
    [anon_sym_DQUOTE] = ACTIONS(3676),
    [anon_sym_AT_DQUOTE] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [sym_bool] = ACTIONS(3676),
    [sym_unit] = ACTIONS(3674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3676),
    [sym_op_identifier] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_PLUS_DOT] = ACTIONS(3676),
    [anon_sym_DASH_DOT] = ACTIONS(3676),
    [anon_sym_PERCENT] = ACTIONS(3676),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_TILDE] = ACTIONS(3674),
    [aux_sym_prefix_op_token1] = ACTIONS(3676),
    [aux_sym_infix_op_token1] = ACTIONS(3674),
    [aux_sym_infix_op_token2] = ACTIONS(3676),
    [anon_sym_PIPE_PIPE] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3676),
    [anon_sym_COLON_EQ] = ACTIONS(3674),
    [anon_sym_DOLLAR] = ACTIONS(3676),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3676),
    [sym_int] = ACTIONS(3676),
    [sym_xint] = ACTIONS(3674),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3674),
    [sym__newline] = ACTIONS(5164),
    [sym__dedent] = ACTIONS(3674),
  },
  [2640] = {
    [sym_block_comment] = STATE(2640),
    [sym_compiler_directive_decl] = STATE(2640),
    [sym_fsi_directive_decl] = STATE(2640),
    [sym_preproc_line] = STATE(2640),
    [sym_identifier] = ACTIONS(3547),
    [anon_sym_EQ] = ACTIONS(3545),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_return] = ACTIONS(3547),
    [anon_sym_do] = ACTIONS(3547),
    [anon_sym_let] = ACTIONS(3547),
    [anon_sym_let_BANG] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(3547),
    [anon_sym_COMMA] = ACTIONS(3545),
    [anon_sym_null] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3547),
    [anon_sym_COLON_QMARK] = ACTIONS(3547),
    [anon_sym_COLON_COLON] = ACTIONS(3545),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3545),
    [anon_sym_LBRACE] = ACTIONS(3547),
    [anon_sym_LT_AT] = ACTIONS(3547),
    [anon_sym_LT_AT_AT] = ACTIONS(3547),
    [anon_sym_DOT] = ACTIONS(3547),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3545),
    [anon_sym_new] = ACTIONS(3547),
    [anon_sym_return_BANG] = ACTIONS(3545),
    [anon_sym_yield] = ACTIONS(3547),
    [anon_sym_yield_BANG] = ACTIONS(3545),
    [anon_sym_lazy] = ACTIONS(3547),
    [anon_sym_assert] = ACTIONS(3547),
    [anon_sym_upcast] = ACTIONS(3547),
    [anon_sym_downcast] = ACTIONS(3547),
    [anon_sym_COLON_GT] = ACTIONS(3545),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3545),
    [anon_sym_for] = ACTIONS(3547),
    [anon_sym_while] = ACTIONS(3547),
    [anon_sym_if] = ACTIONS(3547),
    [anon_sym_fun] = ACTIONS(3547),
    [anon_sym_DASH_GT] = ACTIONS(3547),
    [anon_sym_try] = ACTIONS(3547),
    [anon_sym_match] = ACTIONS(3547),
    [anon_sym_match_BANG] = ACTIONS(3545),
    [anon_sym_function] = ACTIONS(3547),
    [anon_sym_LT_DASH] = ACTIONS(3547),
    [anon_sym_DOT_LBRACK] = ACTIONS(3545),
    [anon_sym_LT] = ACTIONS(3545),
    [anon_sym_use] = ACTIONS(3547),
    [anon_sym_use_BANG] = ACTIONS(3545),
    [anon_sym_do_BANG] = ACTIONS(3545),
    [anon_sym_DOT_DOT] = ACTIONS(3545),
    [anon_sym_begin] = ACTIONS(3547),
    [anon_sym_LPAREN2] = ACTIONS(3547),
    [anon_sym_STAR] = ACTIONS(3547),
    [anon_sym_LT2] = ACTIONS(3547),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_or] = ACTIONS(3547),
    [aux_sym_char_token1] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3547),
    [anon_sym_DQUOTE] = ACTIONS(3547),
    [anon_sym_AT_DQUOTE] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [sym_bool] = ACTIONS(3547),
    [sym_unit] = ACTIONS(3545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3547),
    [sym_op_identifier] = ACTIONS(3547),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PLUS_DOT] = ACTIONS(3547),
    [anon_sym_DASH_DOT] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3547),
    [anon_sym_AMP_AMP] = ACTIONS(3547),
    [anon_sym_TILDE] = ACTIONS(3545),
    [aux_sym_prefix_op_token1] = ACTIONS(3547),
    [aux_sym_infix_op_token1] = ACTIONS(3545),
    [aux_sym_infix_op_token2] = ACTIONS(3547),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_BANG_EQ] = ACTIONS(3547),
    [anon_sym_COLON_EQ] = ACTIONS(3545),
    [anon_sym_DOLLAR] = ACTIONS(3547),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3547),
    [sym_int] = ACTIONS(3547),
    [sym_xint] = ACTIONS(3545),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3545),
    [sym__newline] = ACTIONS(3545),
  },
  [2641] = {
    [sym_block_comment] = STATE(2641),
    [sym_compiler_directive_decl] = STATE(2641),
    [sym_fsi_directive_decl] = STATE(2641),
    [sym_preproc_line] = STATE(2641),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(3521),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_COMMA] = ACTIONS(3521),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_COLON] = ACTIONS(3521),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3521),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3521),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_COLON_GT] = ACTIONS(3521),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_DASH_GT] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3521),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_LT_DASH] = ACTIONS(3523),
    [anon_sym_DOT_LBRACK] = ACTIONS(3521),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3523),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3521),
    [anon_sym_do_BANG] = ACTIONS(3521),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_LPAREN2] = ACTIONS(3523),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_LT2] = ACTIONS(3523),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3521),
    [anon_sym_or] = ACTIONS(3523),
    [aux_sym_char_token1] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3521),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3523),
    [anon_sym_DASH_DOT] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3521),
    [aux_sym_prefix_op_token1] = ACTIONS(3523),
    [aux_sym_infix_op_token1] = ACTIONS(3521),
    [aux_sym_infix_op_token2] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3523),
    [anon_sym_COLON_EQ] = ACTIONS(3521),
    [anon_sym_DOLLAR] = ACTIONS(3523),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3523),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3521),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3521),
    [sym__newline] = ACTIONS(3521),
  },
  [2642] = {
    [sym_block_comment] = STATE(2642),
    [sym_compiler_directive_decl] = STATE(2642),
    [sym_fsi_directive_decl] = STATE(2642),
    [sym_preproc_line] = STATE(2642),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_DASH_GT] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_DOT_DOT] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [aux_sym_float_token1] = ACTIONS(5167),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
  },
  [2643] = {
    [sym_block_comment] = STATE(2643),
    [sym_compiler_directive_decl] = STATE(2643),
    [sym_fsi_directive_decl] = STATE(2643),
    [sym_preproc_line] = STATE(2643),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_COLON] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3480),
    [anon_sym_AT_AT_GT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_LT_DASH] = ACTIONS(3480),
    [anon_sym_DOT_LBRACK] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_or] = ACTIONS(3480),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3480),
    [anon_sym_DASH_DOT] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3480),
    [aux_sym_infix_op_token1] = ACTIONS(3478),
    [aux_sym_infix_op_token2] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3480),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
  },
  [2644] = {
    [sym_block_comment] = STATE(2644),
    [sym_compiler_directive_decl] = STATE(2644),
    [sym_fsi_directive_decl] = STATE(2644),
    [sym_preproc_line] = STATE(2644),
    [sym_identifier] = ACTIONS(3519),
    [anon_sym_EQ] = ACTIONS(3517),
    [anon_sym_COLON] = ACTIONS(3519),
    [anon_sym_return] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(3519),
    [anon_sym_let] = ACTIONS(3519),
    [anon_sym_let_BANG] = ACTIONS(3517),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [anon_sym_COMMA] = ACTIONS(3517),
    [anon_sym_null] = ACTIONS(3519),
    [anon_sym_QMARK] = ACTIONS(3519),
    [anon_sym_COLON_QMARK] = ACTIONS(3519),
    [anon_sym_COLON_COLON] = ACTIONS(3517),
    [anon_sym_AMP] = ACTIONS(3519),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_LT_AT] = ACTIONS(3519),
    [anon_sym_LT_AT_AT] = ACTIONS(3519),
    [anon_sym_DOT] = ACTIONS(3519),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3519),
    [anon_sym_return_BANG] = ACTIONS(3517),
    [anon_sym_yield] = ACTIONS(3519),
    [anon_sym_yield_BANG] = ACTIONS(3517),
    [anon_sym_lazy] = ACTIONS(3519),
    [anon_sym_assert] = ACTIONS(3519),
    [anon_sym_upcast] = ACTIONS(3519),
    [anon_sym_downcast] = ACTIONS(3519),
    [anon_sym_COLON_GT] = ACTIONS(3517),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3517),
    [anon_sym_for] = ACTIONS(3519),
    [anon_sym_while] = ACTIONS(3519),
    [anon_sym_if] = ACTIONS(3519),
    [anon_sym_fun] = ACTIONS(3519),
    [anon_sym_DASH_GT] = ACTIONS(3519),
    [anon_sym_try] = ACTIONS(3519),
    [anon_sym_match] = ACTIONS(3519),
    [anon_sym_match_BANG] = ACTIONS(3517),
    [anon_sym_function] = ACTIONS(3519),
    [anon_sym_LT_DASH] = ACTIONS(3519),
    [anon_sym_DOT_LBRACK] = ACTIONS(3517),
    [anon_sym_LT] = ACTIONS(3517),
    [anon_sym_GT] = ACTIONS(3519),
    [anon_sym_use] = ACTIONS(3519),
    [anon_sym_use_BANG] = ACTIONS(3517),
    [anon_sym_do_BANG] = ACTIONS(3517),
    [anon_sym_begin] = ACTIONS(3519),
    [anon_sym_LPAREN2] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_LT2] = ACTIONS(3519),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3517),
    [anon_sym_or] = ACTIONS(3519),
    [aux_sym_char_token1] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [anon_sym_AT_DQUOTE] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [sym_bool] = ACTIONS(3519),
    [sym_unit] = ACTIONS(3517),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3519),
    [sym_op_identifier] = ACTIONS(3519),
    [anon_sym_PLUS] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_DOT] = ACTIONS(3519),
    [anon_sym_DASH_DOT] = ACTIONS(3519),
    [anon_sym_PERCENT] = ACTIONS(3519),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3517),
    [aux_sym_prefix_op_token1] = ACTIONS(3519),
    [aux_sym_infix_op_token1] = ACTIONS(3517),
    [aux_sym_infix_op_token2] = ACTIONS(3519),
    [anon_sym_PIPE_PIPE] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_COLON_EQ] = ACTIONS(3517),
    [anon_sym_DOLLAR] = ACTIONS(3519),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3519),
    [sym_int] = ACTIONS(3519),
    [sym_xint] = ACTIONS(3517),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3517),
    [sym__newline] = ACTIONS(3517),
  },
  [2645] = {
    [sym_block_comment] = STATE(2645),
    [sym_compiler_directive_decl] = STATE(2645),
    [sym_fsi_directive_decl] = STATE(2645),
    [sym_preproc_line] = STATE(2645),
    [sym_identifier] = ACTIONS(3543),
    [anon_sym_EQ] = ACTIONS(3541),
    [anon_sym_COLON] = ACTIONS(3543),
    [anon_sym_return] = ACTIONS(3543),
    [anon_sym_do] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3543),
    [anon_sym_let_BANG] = ACTIONS(3541),
    [anon_sym_LPAREN] = ACTIONS(3543),
    [anon_sym_COMMA] = ACTIONS(3541),
    [anon_sym_null] = ACTIONS(3543),
    [anon_sym_QMARK] = ACTIONS(3543),
    [anon_sym_COLON_QMARK] = ACTIONS(3543),
    [anon_sym_COLON_COLON] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3543),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3541),
    [anon_sym_LBRACE] = ACTIONS(3543),
    [anon_sym_LT_AT] = ACTIONS(3543),
    [anon_sym_LT_AT_AT] = ACTIONS(3543),
    [anon_sym_DOT] = ACTIONS(3543),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3541),
    [anon_sym_new] = ACTIONS(3543),
    [anon_sym_return_BANG] = ACTIONS(3541),
    [anon_sym_yield] = ACTIONS(3543),
    [anon_sym_yield_BANG] = ACTIONS(3541),
    [anon_sym_lazy] = ACTIONS(3543),
    [anon_sym_assert] = ACTIONS(3543),
    [anon_sym_upcast] = ACTIONS(3543),
    [anon_sym_downcast] = ACTIONS(3543),
    [anon_sym_COLON_GT] = ACTIONS(3541),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3541),
    [anon_sym_for] = ACTIONS(3543),
    [anon_sym_while] = ACTIONS(3543),
    [anon_sym_if] = ACTIONS(3543),
    [anon_sym_fun] = ACTIONS(3543),
    [anon_sym_DASH_GT] = ACTIONS(3543),
    [anon_sym_try] = ACTIONS(3543),
    [anon_sym_match] = ACTIONS(3543),
    [anon_sym_match_BANG] = ACTIONS(3541),
    [anon_sym_function] = ACTIONS(3543),
    [anon_sym_LT_DASH] = ACTIONS(3543),
    [anon_sym_DOT_LBRACK] = ACTIONS(3541),
    [anon_sym_LT] = ACTIONS(3541),
    [anon_sym_use] = ACTIONS(3543),
    [anon_sym_use_BANG] = ACTIONS(3541),
    [anon_sym_do_BANG] = ACTIONS(3541),
    [anon_sym_DOT_DOT] = ACTIONS(3541),
    [anon_sym_begin] = ACTIONS(3543),
    [anon_sym_LPAREN2] = ACTIONS(3543),
    [anon_sym_STAR] = ACTIONS(3543),
    [anon_sym_LT2] = ACTIONS(3543),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_or] = ACTIONS(3543),
    [aux_sym_char_token1] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3543),
    [anon_sym_DQUOTE] = ACTIONS(3543),
    [anon_sym_AT_DQUOTE] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [sym_bool] = ACTIONS(3543),
    [sym_unit] = ACTIONS(3541),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3543),
    [sym_op_identifier] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(3543),
    [anon_sym_DASH] = ACTIONS(3543),
    [anon_sym_PLUS_DOT] = ACTIONS(3543),
    [anon_sym_DASH_DOT] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3543),
    [anon_sym_AMP_AMP] = ACTIONS(3543),
    [anon_sym_TILDE] = ACTIONS(3541),
    [aux_sym_prefix_op_token1] = ACTIONS(3543),
    [aux_sym_infix_op_token1] = ACTIONS(3541),
    [aux_sym_infix_op_token2] = ACTIONS(3543),
    [anon_sym_PIPE_PIPE] = ACTIONS(3543),
    [anon_sym_BANG_EQ] = ACTIONS(3543),
    [anon_sym_COLON_EQ] = ACTIONS(3541),
    [anon_sym_DOLLAR] = ACTIONS(3543),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3543),
    [sym_int] = ACTIONS(3543),
    [sym_xint] = ACTIONS(3541),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3541),
    [sym__newline] = ACTIONS(3541),
  },
  [2646] = {
    [sym_block_comment] = STATE(2646),
    [sym_compiler_directive_decl] = STATE(2646),
    [sym_fsi_directive_decl] = STATE(2646),
    [sym_preproc_line] = STATE(2646),
    [sym_identifier] = ACTIONS(3551),
    [anon_sym_EQ] = ACTIONS(3549),
    [anon_sym_COLON] = ACTIONS(3551),
    [anon_sym_return] = ACTIONS(3551),
    [anon_sym_do] = ACTIONS(3551),
    [anon_sym_let] = ACTIONS(3551),
    [anon_sym_let_BANG] = ACTIONS(3549),
    [anon_sym_LPAREN] = ACTIONS(3551),
    [anon_sym_COMMA] = ACTIONS(3549),
    [anon_sym_null] = ACTIONS(3551),
    [anon_sym_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_COLON] = ACTIONS(3549),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(3551),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3549),
    [anon_sym_LBRACE] = ACTIONS(3551),
    [anon_sym_LT_AT] = ACTIONS(3551),
    [anon_sym_AT_GT] = ACTIONS(3551),
    [anon_sym_LT_AT_AT] = ACTIONS(3551),
    [anon_sym_DOT] = ACTIONS(3551),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3549),
    [anon_sym_new] = ACTIONS(3551),
    [anon_sym_return_BANG] = ACTIONS(3549),
    [anon_sym_yield] = ACTIONS(3551),
    [anon_sym_yield_BANG] = ACTIONS(3549),
    [anon_sym_lazy] = ACTIONS(3551),
    [anon_sym_assert] = ACTIONS(3551),
    [anon_sym_upcast] = ACTIONS(3551),
    [anon_sym_downcast] = ACTIONS(3551),
    [anon_sym_COLON_GT] = ACTIONS(3549),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3549),
    [anon_sym_for] = ACTIONS(3551),
    [anon_sym_while] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(3551),
    [anon_sym_fun] = ACTIONS(3551),
    [anon_sym_DASH_GT] = ACTIONS(3551),
    [anon_sym_try] = ACTIONS(3551),
    [anon_sym_match] = ACTIONS(3551),
    [anon_sym_match_BANG] = ACTIONS(3549),
    [anon_sym_function] = ACTIONS(3551),
    [anon_sym_LT_DASH] = ACTIONS(3551),
    [anon_sym_DOT_LBRACK] = ACTIONS(3549),
    [anon_sym_LT] = ACTIONS(3549),
    [anon_sym_use] = ACTIONS(3551),
    [anon_sym_use_BANG] = ACTIONS(3549),
    [anon_sym_do_BANG] = ACTIONS(3549),
    [anon_sym_begin] = ACTIONS(3551),
    [anon_sym_LPAREN2] = ACTIONS(3551),
    [anon_sym_STAR] = ACTIONS(3551),
    [anon_sym_LT2] = ACTIONS(3551),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3549),
    [anon_sym_or] = ACTIONS(3551),
    [aux_sym_char_token1] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [anon_sym_AT_DQUOTE] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [sym_bool] = ACTIONS(3551),
    [sym_unit] = ACTIONS(3549),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3551),
    [sym_op_identifier] = ACTIONS(3551),
    [anon_sym_PLUS] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(3551),
    [anon_sym_PLUS_DOT] = ACTIONS(3551),
    [anon_sym_DASH_DOT] = ACTIONS(3551),
    [anon_sym_PERCENT] = ACTIONS(3551),
    [anon_sym_AMP_AMP] = ACTIONS(3551),
    [anon_sym_TILDE] = ACTIONS(3549),
    [aux_sym_prefix_op_token1] = ACTIONS(3551),
    [aux_sym_infix_op_token1] = ACTIONS(3549),
    [aux_sym_infix_op_token2] = ACTIONS(3551),
    [anon_sym_PIPE_PIPE] = ACTIONS(3551),
    [anon_sym_BANG_EQ] = ACTIONS(3551),
    [anon_sym_COLON_EQ] = ACTIONS(3549),
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3551),
    [sym_int] = ACTIONS(3551),
    [sym_xint] = ACTIONS(3549),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3549),
    [sym__newline] = ACTIONS(3549),
  },
  [2647] = {
    [sym_block_comment] = STATE(2647),
    [sym_compiler_directive_decl] = STATE(2647),
    [sym_fsi_directive_decl] = STATE(2647),
    [sym_preproc_line] = STATE(2647),
    [sym_identifier] = ACTIONS(3539),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3539),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_do] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3539),
    [anon_sym_let_BANG] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_null] = ACTIONS(3539),
    [anon_sym_QMARK] = ACTIONS(3539),
    [anon_sym_COLON_QMARK] = ACTIONS(3539),
    [anon_sym_COLON_COLON] = ACTIONS(3537),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3537),
    [anon_sym_LBRACE] = ACTIONS(3539),
    [anon_sym_LT_AT] = ACTIONS(3539),
    [anon_sym_LT_AT_AT] = ACTIONS(3539),
    [anon_sym_DOT] = ACTIONS(3539),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3537),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_return_BANG] = ACTIONS(3537),
    [anon_sym_yield] = ACTIONS(3539),
    [anon_sym_yield_BANG] = ACTIONS(3537),
    [anon_sym_lazy] = ACTIONS(3539),
    [anon_sym_assert] = ACTIONS(3539),
    [anon_sym_upcast] = ACTIONS(3539),
    [anon_sym_downcast] = ACTIONS(3539),
    [anon_sym_COLON_GT] = ACTIONS(3537),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3537),
    [anon_sym_for] = ACTIONS(3539),
    [anon_sym_while] = ACTIONS(3539),
    [anon_sym_if] = ACTIONS(3539),
    [anon_sym_fun] = ACTIONS(3539),
    [anon_sym_DASH_GT] = ACTIONS(3539),
    [anon_sym_try] = ACTIONS(3539),
    [anon_sym_match] = ACTIONS(3539),
    [anon_sym_match_BANG] = ACTIONS(3537),
    [anon_sym_function] = ACTIONS(3539),
    [anon_sym_LT_DASH] = ACTIONS(3539),
    [anon_sym_DOT_LBRACK] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_use] = ACTIONS(3539),
    [anon_sym_use_BANG] = ACTIONS(3537),
    [anon_sym_do_BANG] = ACTIONS(3537),
    [anon_sym_DOT_DOT] = ACTIONS(3537),
    [anon_sym_begin] = ACTIONS(3539),
    [anon_sym_LPAREN2] = ACTIONS(3539),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_LT2] = ACTIONS(3539),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_or] = ACTIONS(3539),
    [aux_sym_char_token1] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3539),
    [anon_sym_DQUOTE] = ACTIONS(3539),
    [anon_sym_AT_DQUOTE] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [sym_bool] = ACTIONS(3539),
    [sym_unit] = ACTIONS(3537),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3539),
    [sym_op_identifier] = ACTIONS(3539),
    [anon_sym_PLUS] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(3539),
    [anon_sym_PLUS_DOT] = ACTIONS(3539),
    [anon_sym_DASH_DOT] = ACTIONS(3539),
    [anon_sym_PERCENT] = ACTIONS(3539),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_TILDE] = ACTIONS(3537),
    [aux_sym_prefix_op_token1] = ACTIONS(3539),
    [aux_sym_infix_op_token1] = ACTIONS(3537),
    [aux_sym_infix_op_token2] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3539),
    [anon_sym_BANG_EQ] = ACTIONS(3539),
    [anon_sym_COLON_EQ] = ACTIONS(3537),
    [anon_sym_DOLLAR] = ACTIONS(3539),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3539),
    [sym_int] = ACTIONS(3539),
    [sym_xint] = ACTIONS(3537),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3537),
    [sym__newline] = ACTIONS(3537),
  },
  [2648] = {
    [sym_block_comment] = STATE(2648),
    [sym_compiler_directive_decl] = STATE(2648),
    [sym_fsi_directive_decl] = STATE(2648),
    [sym_preproc_line] = STATE(2648),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_as] = ACTIONS(3700),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_done] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_DOT_DOT] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
    [sym__dedent] = ACTIONS(3698),
  },
  [2649] = {
    [sym_block_comment] = STATE(2649),
    [sym_compiler_directive_decl] = STATE(2649),
    [sym_fsi_directive_decl] = STATE(2649),
    [sym_preproc_line] = STATE(2649),
    [sym_identifier] = ACTIONS(3547),
    [anon_sym_EQ] = ACTIONS(3545),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_return] = ACTIONS(3547),
    [anon_sym_do] = ACTIONS(3547),
    [anon_sym_let] = ACTIONS(3547),
    [anon_sym_let_BANG] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(3547),
    [anon_sym_COMMA] = ACTIONS(3545),
    [anon_sym_null] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3547),
    [anon_sym_COLON_QMARK] = ACTIONS(3547),
    [anon_sym_COLON_COLON] = ACTIONS(3545),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3545),
    [anon_sym_LBRACE] = ACTIONS(3547),
    [anon_sym_LT_AT] = ACTIONS(3547),
    [anon_sym_AT_GT] = ACTIONS(3547),
    [anon_sym_LT_AT_AT] = ACTIONS(3547),
    [anon_sym_DOT] = ACTIONS(3547),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3545),
    [anon_sym_new] = ACTIONS(3547),
    [anon_sym_return_BANG] = ACTIONS(3545),
    [anon_sym_yield] = ACTIONS(3547),
    [anon_sym_yield_BANG] = ACTIONS(3545),
    [anon_sym_lazy] = ACTIONS(3547),
    [anon_sym_assert] = ACTIONS(3547),
    [anon_sym_upcast] = ACTIONS(3547),
    [anon_sym_downcast] = ACTIONS(3547),
    [anon_sym_COLON_GT] = ACTIONS(3545),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3545),
    [anon_sym_for] = ACTIONS(3547),
    [anon_sym_while] = ACTIONS(3547),
    [anon_sym_if] = ACTIONS(3547),
    [anon_sym_fun] = ACTIONS(3547),
    [anon_sym_DASH_GT] = ACTIONS(3547),
    [anon_sym_try] = ACTIONS(3547),
    [anon_sym_match] = ACTIONS(3547),
    [anon_sym_match_BANG] = ACTIONS(3545),
    [anon_sym_function] = ACTIONS(3547),
    [anon_sym_LT_DASH] = ACTIONS(3547),
    [anon_sym_DOT_LBRACK] = ACTIONS(3545),
    [anon_sym_LT] = ACTIONS(3545),
    [anon_sym_use] = ACTIONS(3547),
    [anon_sym_use_BANG] = ACTIONS(3545),
    [anon_sym_do_BANG] = ACTIONS(3545),
    [anon_sym_begin] = ACTIONS(3547),
    [anon_sym_LPAREN2] = ACTIONS(3547),
    [anon_sym_STAR] = ACTIONS(3547),
    [anon_sym_LT2] = ACTIONS(3547),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_or] = ACTIONS(3547),
    [aux_sym_char_token1] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3547),
    [anon_sym_DQUOTE] = ACTIONS(3547),
    [anon_sym_AT_DQUOTE] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [sym_bool] = ACTIONS(3547),
    [sym_unit] = ACTIONS(3545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3547),
    [sym_op_identifier] = ACTIONS(3547),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PLUS_DOT] = ACTIONS(3547),
    [anon_sym_DASH_DOT] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3547),
    [anon_sym_AMP_AMP] = ACTIONS(3547),
    [anon_sym_TILDE] = ACTIONS(3545),
    [aux_sym_prefix_op_token1] = ACTIONS(3547),
    [aux_sym_infix_op_token1] = ACTIONS(3545),
    [aux_sym_infix_op_token2] = ACTIONS(3547),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_BANG_EQ] = ACTIONS(3547),
    [anon_sym_COLON_EQ] = ACTIONS(3545),
    [anon_sym_DOLLAR] = ACTIONS(3547),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3547),
    [sym_int] = ACTIONS(3547),
    [sym_xint] = ACTIONS(3545),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3545),
    [sym__newline] = ACTIONS(3545),
  },
  [2650] = {
    [sym_block_comment] = STATE(2650),
    [sym_compiler_directive_decl] = STATE(2650),
    [sym_fsi_directive_decl] = STATE(2650),
    [sym_preproc_line] = STATE(2650),
    [sym_identifier] = ACTIONS(3531),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_do] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(3531),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3531),
    [anon_sym_LT_AT] = ACTIONS(3531),
    [anon_sym_LT_AT_AT] = ACTIONS(3531),
    [anon_sym_DOT] = ACTIONS(4739),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3531),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3531),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3531),
    [anon_sym_assert] = ACTIONS(3531),
    [anon_sym_upcast] = ACTIONS(3531),
    [anon_sym_downcast] = ACTIONS(3531),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(3531),
    [anon_sym_while] = ACTIONS(3531),
    [anon_sym_if] = ACTIONS(3531),
    [anon_sym_fun] = ACTIONS(3531),
    [anon_sym_DASH_GT] = ACTIONS(3531),
    [anon_sym_try] = ACTIONS(3531),
    [anon_sym_match] = ACTIONS(3531),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3531),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(3531),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3531),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LT2] = ACTIONS(3531),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_or] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3531),
    [anon_sym_DQUOTE] = ACTIONS(3531),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3531),
    [sym_unit] = ACTIONS(3529),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3531),
    [sym_op_identifier] = ACTIONS(3531),
    [anon_sym_PLUS] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(3531),
    [anon_sym_PLUS_DOT] = ACTIONS(3531),
    [anon_sym_DASH_DOT] = ACTIONS(3531),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_AMP_AMP] = ACTIONS(3531),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3531),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(3531),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [sym__newline] = ACTIONS(4226),
    [sym__dedent] = ACTIONS(3529),
  },
  [2651] = {
    [sym_block_comment] = STATE(2651),
    [sym_compiler_directive_decl] = STATE(2651),
    [sym_fsi_directive_decl] = STATE(2651),
    [sym_preproc_line] = STATE(2651),
    [aux_sym_rules_repeat1] = STATE(2651),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [anon_sym_as] = ACTIONS(3743),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(5169),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_with] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_or] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [sym__newline] = ACTIONS(5172),
    [sym__dedent] = ACTIONS(3741),
  },
  [2652] = {
    [sym_block_comment] = STATE(2652),
    [sym_compiler_directive_decl] = STATE(2652),
    [sym_fsi_directive_decl] = STATE(2652),
    [sym_preproc_line] = STATE(2652),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_as] = ACTIONS(3193),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_f] = ACTIONS(4438),
    [aux_sym_decimal_token1] = ACTIONS(4046),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
    [sym__dedent] = ACTIONS(3191),
  },
  [2653] = {
    [sym_block_comment] = STATE(2653),
    [sym_compiler_directive_decl] = STATE(2653),
    [sym_fsi_directive_decl] = STATE(2653),
    [sym_preproc_line] = STATE(2653),
    [sym_identifier] = ACTIONS(3551),
    [anon_sym_EQ] = ACTIONS(3549),
    [anon_sym_COLON] = ACTIONS(3551),
    [anon_sym_return] = ACTIONS(3551),
    [anon_sym_do] = ACTIONS(3551),
    [anon_sym_let] = ACTIONS(3551),
    [anon_sym_let_BANG] = ACTIONS(3549),
    [anon_sym_LPAREN] = ACTIONS(3551),
    [anon_sym_COMMA] = ACTIONS(3549),
    [anon_sym_null] = ACTIONS(3551),
    [anon_sym_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_COLON] = ACTIONS(3549),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(3551),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3549),
    [anon_sym_LBRACE] = ACTIONS(3551),
    [anon_sym_LT_AT] = ACTIONS(3551),
    [anon_sym_LT_AT_AT] = ACTIONS(3551),
    [anon_sym_AT_AT_GT] = ACTIONS(3551),
    [anon_sym_DOT] = ACTIONS(3551),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3549),
    [anon_sym_new] = ACTIONS(3551),
    [anon_sym_return_BANG] = ACTIONS(3549),
    [anon_sym_yield] = ACTIONS(3551),
    [anon_sym_yield_BANG] = ACTIONS(3549),
    [anon_sym_lazy] = ACTIONS(3551),
    [anon_sym_assert] = ACTIONS(3551),
    [anon_sym_upcast] = ACTIONS(3551),
    [anon_sym_downcast] = ACTIONS(3551),
    [anon_sym_COLON_GT] = ACTIONS(3549),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3549),
    [anon_sym_for] = ACTIONS(3551),
    [anon_sym_while] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(3551),
    [anon_sym_fun] = ACTIONS(3551),
    [anon_sym_DASH_GT] = ACTIONS(3551),
    [anon_sym_try] = ACTIONS(3551),
    [anon_sym_match] = ACTIONS(3551),
    [anon_sym_match_BANG] = ACTIONS(3549),
    [anon_sym_function] = ACTIONS(3551),
    [anon_sym_LT_DASH] = ACTIONS(3551),
    [anon_sym_DOT_LBRACK] = ACTIONS(3549),
    [anon_sym_LT] = ACTIONS(3549),
    [anon_sym_use] = ACTIONS(3551),
    [anon_sym_use_BANG] = ACTIONS(3549),
    [anon_sym_do_BANG] = ACTIONS(3549),
    [anon_sym_begin] = ACTIONS(3551),
    [anon_sym_LPAREN2] = ACTIONS(3551),
    [anon_sym_STAR] = ACTIONS(3551),
    [anon_sym_LT2] = ACTIONS(3551),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3549),
    [anon_sym_or] = ACTIONS(3551),
    [aux_sym_char_token1] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [anon_sym_AT_DQUOTE] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [sym_bool] = ACTIONS(3551),
    [sym_unit] = ACTIONS(3549),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3551),
    [sym_op_identifier] = ACTIONS(3551),
    [anon_sym_PLUS] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(3551),
    [anon_sym_PLUS_DOT] = ACTIONS(3551),
    [anon_sym_DASH_DOT] = ACTIONS(3551),
    [anon_sym_PERCENT] = ACTIONS(3551),
    [anon_sym_AMP_AMP] = ACTIONS(3551),
    [anon_sym_TILDE] = ACTIONS(3549),
    [aux_sym_prefix_op_token1] = ACTIONS(3551),
    [aux_sym_infix_op_token1] = ACTIONS(3549),
    [aux_sym_infix_op_token2] = ACTIONS(3551),
    [anon_sym_PIPE_PIPE] = ACTIONS(3551),
    [anon_sym_BANG_EQ] = ACTIONS(3551),
    [anon_sym_COLON_EQ] = ACTIONS(3549),
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3551),
    [sym_int] = ACTIONS(3551),
    [sym_xint] = ACTIONS(3549),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3549),
    [sym__newline] = ACTIONS(3549),
  },
  [2654] = {
    [sym_block_comment] = STATE(2654),
    [sym_compiler_directive_decl] = STATE(2654),
    [sym_fsi_directive_decl] = STATE(2654),
    [sym_preproc_line] = STATE(2654),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_done] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_DASH_GT] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_DOT_DOT] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
    [sym__dedent] = ACTIONS(3698),
  },
  [2655] = {
    [sym_block_comment] = STATE(2655),
    [sym_compiler_directive_decl] = STATE(2655),
    [sym_fsi_directive_decl] = STATE(2655),
    [sym_preproc_line] = STATE(2655),
    [sym_identifier] = ACTIONS(3539),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3539),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_do] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3539),
    [anon_sym_let_BANG] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_null] = ACTIONS(3539),
    [anon_sym_QMARK] = ACTIONS(3539),
    [anon_sym_COLON_QMARK] = ACTIONS(3539),
    [anon_sym_COLON_COLON] = ACTIONS(3537),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3537),
    [anon_sym_LBRACE] = ACTIONS(3539),
    [anon_sym_LT_AT] = ACTIONS(3539),
    [anon_sym_LT_AT_AT] = ACTIONS(3539),
    [anon_sym_DOT] = ACTIONS(3539),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3537),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_return_BANG] = ACTIONS(3537),
    [anon_sym_yield] = ACTIONS(3539),
    [anon_sym_yield_BANG] = ACTIONS(3537),
    [anon_sym_lazy] = ACTIONS(3539),
    [anon_sym_assert] = ACTIONS(3539),
    [anon_sym_upcast] = ACTIONS(3539),
    [anon_sym_downcast] = ACTIONS(3539),
    [anon_sym_COLON_GT] = ACTIONS(3537),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3537),
    [anon_sym_for] = ACTIONS(3539),
    [anon_sym_while] = ACTIONS(3539),
    [anon_sym_if] = ACTIONS(3539),
    [anon_sym_fun] = ACTIONS(3539),
    [anon_sym_DASH_GT] = ACTIONS(3539),
    [anon_sym_try] = ACTIONS(3539),
    [anon_sym_match] = ACTIONS(3539),
    [anon_sym_match_BANG] = ACTIONS(3537),
    [anon_sym_function] = ACTIONS(3539),
    [anon_sym_LT_DASH] = ACTIONS(3539),
    [anon_sym_DOT_LBRACK] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_GT] = ACTIONS(3539),
    [anon_sym_use] = ACTIONS(3539),
    [anon_sym_use_BANG] = ACTIONS(3537),
    [anon_sym_do_BANG] = ACTIONS(3537),
    [anon_sym_begin] = ACTIONS(3539),
    [anon_sym_LPAREN2] = ACTIONS(3539),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_LT2] = ACTIONS(3539),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_or] = ACTIONS(3539),
    [aux_sym_char_token1] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3539),
    [anon_sym_DQUOTE] = ACTIONS(3539),
    [anon_sym_AT_DQUOTE] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [sym_bool] = ACTIONS(3539),
    [sym_unit] = ACTIONS(3537),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3539),
    [sym_op_identifier] = ACTIONS(3539),
    [anon_sym_PLUS] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(3539),
    [anon_sym_PLUS_DOT] = ACTIONS(3539),
    [anon_sym_DASH_DOT] = ACTIONS(3539),
    [anon_sym_PERCENT] = ACTIONS(3539),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_TILDE] = ACTIONS(3537),
    [aux_sym_prefix_op_token1] = ACTIONS(3539),
    [aux_sym_infix_op_token1] = ACTIONS(3537),
    [aux_sym_infix_op_token2] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3539),
    [anon_sym_BANG_EQ] = ACTIONS(3539),
    [anon_sym_COLON_EQ] = ACTIONS(3537),
    [anon_sym_DOLLAR] = ACTIONS(3539),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3539),
    [sym_int] = ACTIONS(3539),
    [sym_xint] = ACTIONS(3537),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3537),
    [sym__newline] = ACTIONS(3537),
  },
  [2656] = {
    [sym_block_comment] = STATE(2656),
    [sym_compiler_directive_decl] = STATE(2656),
    [sym_fsi_directive_decl] = STATE(2656),
    [sym_preproc_line] = STATE(2656),
    [sym_identifier] = ACTIONS(3511),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3511),
    [anon_sym_return] = ACTIONS(3511),
    [anon_sym_do] = ACTIONS(3511),
    [anon_sym_let] = ACTIONS(3511),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3511),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3511),
    [anon_sym_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(3511),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_LT_AT] = ACTIONS(3511),
    [anon_sym_LT_AT_AT] = ACTIONS(3511),
    [anon_sym_AT_AT_GT] = ACTIONS(3511),
    [anon_sym_DOT] = ACTIONS(3511),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3511),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3511),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3511),
    [anon_sym_assert] = ACTIONS(3511),
    [anon_sym_upcast] = ACTIONS(3511),
    [anon_sym_downcast] = ACTIONS(3511),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3511),
    [anon_sym_while] = ACTIONS(3511),
    [anon_sym_if] = ACTIONS(3511),
    [anon_sym_fun] = ACTIONS(3511),
    [anon_sym_DASH_GT] = ACTIONS(3511),
    [anon_sym_try] = ACTIONS(3511),
    [anon_sym_match] = ACTIONS(3511),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3511),
    [anon_sym_LT_DASH] = ACTIONS(3511),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3511),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3511),
    [anon_sym_LPAREN2] = ACTIONS(3511),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_LT2] = ACTIONS(3511),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3511),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3511),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3511),
    [sym_unit] = ACTIONS(3509),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3511),
    [sym_op_identifier] = ACTIONS(3511),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3511),
    [anon_sym_PLUS_DOT] = ACTIONS(3511),
    [anon_sym_DASH_DOT] = ACTIONS(3511),
    [anon_sym_PERCENT] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3511),
    [aux_sym_infix_op_token1] = ACTIONS(3509),
    [aux_sym_infix_op_token2] = ACTIONS(3511),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_BANG_EQ] = ACTIONS(3511),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3511),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3511),
    [sym_int] = ACTIONS(3511),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [2657] = {
    [sym_block_comment] = STATE(2657),
    [sym_compiler_directive_decl] = STATE(2657),
    [sym_fsi_directive_decl] = STATE(2657),
    [sym_preproc_line] = STATE(2657),
    [sym_identifier] = ACTIONS(3543),
    [anon_sym_EQ] = ACTIONS(3541),
    [anon_sym_COLON] = ACTIONS(3543),
    [anon_sym_return] = ACTIONS(3543),
    [anon_sym_do] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3543),
    [anon_sym_let_BANG] = ACTIONS(3541),
    [anon_sym_LPAREN] = ACTIONS(3543),
    [anon_sym_COMMA] = ACTIONS(3541),
    [anon_sym_null] = ACTIONS(3543),
    [anon_sym_QMARK] = ACTIONS(3543),
    [anon_sym_COLON_QMARK] = ACTIONS(3543),
    [anon_sym_COLON_COLON] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3543),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3541),
    [anon_sym_LBRACE] = ACTIONS(3543),
    [anon_sym_LT_AT] = ACTIONS(3543),
    [anon_sym_AT_GT] = ACTIONS(3543),
    [anon_sym_LT_AT_AT] = ACTIONS(3543),
    [anon_sym_DOT] = ACTIONS(3543),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3541),
    [anon_sym_new] = ACTIONS(3543),
    [anon_sym_return_BANG] = ACTIONS(3541),
    [anon_sym_yield] = ACTIONS(3543),
    [anon_sym_yield_BANG] = ACTIONS(3541),
    [anon_sym_lazy] = ACTIONS(3543),
    [anon_sym_assert] = ACTIONS(3543),
    [anon_sym_upcast] = ACTIONS(3543),
    [anon_sym_downcast] = ACTIONS(3543),
    [anon_sym_COLON_GT] = ACTIONS(3541),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3541),
    [anon_sym_for] = ACTIONS(3543),
    [anon_sym_while] = ACTIONS(3543),
    [anon_sym_if] = ACTIONS(3543),
    [anon_sym_fun] = ACTIONS(3543),
    [anon_sym_DASH_GT] = ACTIONS(3543),
    [anon_sym_try] = ACTIONS(3543),
    [anon_sym_match] = ACTIONS(3543),
    [anon_sym_match_BANG] = ACTIONS(3541),
    [anon_sym_function] = ACTIONS(3543),
    [anon_sym_LT_DASH] = ACTIONS(3543),
    [anon_sym_DOT_LBRACK] = ACTIONS(3541),
    [anon_sym_LT] = ACTIONS(3541),
    [anon_sym_use] = ACTIONS(3543),
    [anon_sym_use_BANG] = ACTIONS(3541),
    [anon_sym_do_BANG] = ACTIONS(3541),
    [anon_sym_begin] = ACTIONS(3543),
    [anon_sym_LPAREN2] = ACTIONS(3543),
    [anon_sym_STAR] = ACTIONS(3543),
    [anon_sym_LT2] = ACTIONS(3543),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_or] = ACTIONS(3543),
    [aux_sym_char_token1] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3543),
    [anon_sym_DQUOTE] = ACTIONS(3543),
    [anon_sym_AT_DQUOTE] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [sym_bool] = ACTIONS(3543),
    [sym_unit] = ACTIONS(3541),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3543),
    [sym_op_identifier] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(3543),
    [anon_sym_DASH] = ACTIONS(3543),
    [anon_sym_PLUS_DOT] = ACTIONS(3543),
    [anon_sym_DASH_DOT] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3543),
    [anon_sym_AMP_AMP] = ACTIONS(3543),
    [anon_sym_TILDE] = ACTIONS(3541),
    [aux_sym_prefix_op_token1] = ACTIONS(3543),
    [aux_sym_infix_op_token1] = ACTIONS(3541),
    [aux_sym_infix_op_token2] = ACTIONS(3543),
    [anon_sym_PIPE_PIPE] = ACTIONS(3543),
    [anon_sym_BANG_EQ] = ACTIONS(3543),
    [anon_sym_COLON_EQ] = ACTIONS(3541),
    [anon_sym_DOLLAR] = ACTIONS(3543),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3543),
    [sym_int] = ACTIONS(3543),
    [sym_xint] = ACTIONS(3541),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3541),
    [sym__newline] = ACTIONS(3541),
  },
  [2658] = {
    [sym_elif_expression] = STATE(2860),
    [sym_block_comment] = STATE(2658),
    [sym_compiler_directive_decl] = STATE(2658),
    [sym_fsi_directive_decl] = STATE(2658),
    [sym_preproc_line] = STATE(2658),
    [aux_sym_if_expression_repeat1] = STATE(2658),
    [sym_identifier] = ACTIONS(3555),
    [anon_sym_EQ] = ACTIONS(3553),
    [anon_sym_COLON] = ACTIONS(3555),
    [anon_sym_return] = ACTIONS(3555),
    [anon_sym_do] = ACTIONS(3555),
    [anon_sym_let] = ACTIONS(3555),
    [anon_sym_let_BANG] = ACTIONS(3553),
    [anon_sym_LPAREN] = ACTIONS(3555),
    [anon_sym_COMMA] = ACTIONS(3553),
    [anon_sym_null] = ACTIONS(3555),
    [anon_sym_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_COLON] = ACTIONS(3553),
    [anon_sym_AMP] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(3555),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3553),
    [anon_sym_LBRACE] = ACTIONS(3555),
    [anon_sym_LT_AT] = ACTIONS(3555),
    [anon_sym_LT_AT_AT] = ACTIONS(3555),
    [anon_sym_AT_AT_GT] = ACTIONS(3555),
    [anon_sym_DOT] = ACTIONS(3555),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3553),
    [anon_sym_new] = ACTIONS(3555),
    [anon_sym_return_BANG] = ACTIONS(3553),
    [anon_sym_yield] = ACTIONS(3555),
    [anon_sym_yield_BANG] = ACTIONS(3553),
    [anon_sym_lazy] = ACTIONS(3555),
    [anon_sym_assert] = ACTIONS(3555),
    [anon_sym_upcast] = ACTIONS(3555),
    [anon_sym_downcast] = ACTIONS(3555),
    [anon_sym_COLON_GT] = ACTIONS(3553),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3553),
    [anon_sym_for] = ACTIONS(3555),
    [anon_sym_while] = ACTIONS(3555),
    [anon_sym_else] = ACTIONS(3555),
    [anon_sym_elif] = ACTIONS(5175),
    [anon_sym_if] = ACTIONS(3555),
    [anon_sym_fun] = ACTIONS(3555),
    [anon_sym_try] = ACTIONS(3555),
    [anon_sym_match] = ACTIONS(3555),
    [anon_sym_match_BANG] = ACTIONS(3553),
    [anon_sym_function] = ACTIONS(3555),
    [anon_sym_LT_DASH] = ACTIONS(3555),
    [anon_sym_DOT_LBRACK] = ACTIONS(3553),
    [anon_sym_LT] = ACTIONS(3553),
    [anon_sym_use] = ACTIONS(3555),
    [anon_sym_use_BANG] = ACTIONS(3553),
    [anon_sym_do_BANG] = ACTIONS(3553),
    [anon_sym_begin] = ACTIONS(3555),
    [anon_sym_LPAREN2] = ACTIONS(3555),
    [anon_sym_or] = ACTIONS(3555),
    [aux_sym_char_token1] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3555),
    [anon_sym_DQUOTE] = ACTIONS(3555),
    [anon_sym_AT_DQUOTE] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [sym_bool] = ACTIONS(3555),
    [sym_unit] = ACTIONS(3553),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3555),
    [sym_op_identifier] = ACTIONS(3555),
    [anon_sym_PLUS] = ACTIONS(3555),
    [anon_sym_DASH] = ACTIONS(3555),
    [anon_sym_PLUS_DOT] = ACTIONS(3555),
    [anon_sym_DASH_DOT] = ACTIONS(3555),
    [anon_sym_PERCENT] = ACTIONS(3555),
    [anon_sym_AMP_AMP] = ACTIONS(3555),
    [anon_sym_TILDE] = ACTIONS(3553),
    [aux_sym_prefix_op_token1] = ACTIONS(3555),
    [aux_sym_infix_op_token1] = ACTIONS(3553),
    [aux_sym_infix_op_token2] = ACTIONS(3555),
    [anon_sym_PIPE_PIPE] = ACTIONS(3555),
    [anon_sym_BANG_EQ] = ACTIONS(3555),
    [anon_sym_COLON_EQ] = ACTIONS(3553),
    [anon_sym_DOLLAR] = ACTIONS(3555),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3555),
    [sym_int] = ACTIONS(3555),
    [sym_xint] = ACTIONS(3553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3553),
    [sym__newline] = ACTIONS(3553),
  },
  [2659] = {
    [sym_block_comment] = STATE(2659),
    [sym_compiler_directive_decl] = STATE(2659),
    [sym_fsi_directive_decl] = STATE(2659),
    [sym_preproc_line] = STATE(2659),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3525),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_COLON] = ACTIONS(3525),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_COLON_GT] = ACTIONS(3525),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_DASH_GT] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_LT_DASH] = ACTIONS(3527),
    [anon_sym_DOT_LBRACK] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_LPAREN2] = ACTIONS(3527),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_LT2] = ACTIONS(3527),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_or] = ACTIONS(3527),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3525),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3527),
    [anon_sym_DASH_DOT] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3527),
    [aux_sym_infix_op_token1] = ACTIONS(3525),
    [aux_sym_infix_op_token2] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_COLON_EQ] = ACTIONS(3525),
    [anon_sym_DOLLAR] = ACTIONS(3527),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3527),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3525),
    [sym__newline] = ACTIONS(3525),
  },
  [2660] = {
    [sym_block_comment] = STATE(2660),
    [sym_compiler_directive_decl] = STATE(2660),
    [sym_fsi_directive_decl] = STATE(2660),
    [sym_preproc_line] = STATE(2660),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_EQ] = ACTIONS(3560),
    [anon_sym_COLON] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_let_BANG] = ACTIONS(3560),
    [anon_sym_LPAREN] = ACTIONS(3562),
    [anon_sym_COMMA] = ACTIONS(3560),
    [anon_sym_null] = ACTIONS(3562),
    [anon_sym_QMARK] = ACTIONS(3562),
    [anon_sym_COLON_QMARK] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3560),
    [anon_sym_LBRACE] = ACTIONS(3562),
    [anon_sym_LT_AT] = ACTIONS(3562),
    [anon_sym_LT_AT_AT] = ACTIONS(3562),
    [anon_sym_AT_AT_GT] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(3562),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3560),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_return_BANG] = ACTIONS(3560),
    [anon_sym_yield] = ACTIONS(3562),
    [anon_sym_yield_BANG] = ACTIONS(3560),
    [anon_sym_lazy] = ACTIONS(3562),
    [anon_sym_assert] = ACTIONS(3562),
    [anon_sym_upcast] = ACTIONS(3562),
    [anon_sym_downcast] = ACTIONS(3562),
    [anon_sym_COLON_GT] = ACTIONS(3560),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3560),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_fun] = ACTIONS(3562),
    [anon_sym_DASH_GT] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_match] = ACTIONS(3562),
    [anon_sym_match_BANG] = ACTIONS(3560),
    [anon_sym_function] = ACTIONS(3562),
    [anon_sym_LT_DASH] = ACTIONS(3562),
    [anon_sym_DOT_LBRACK] = ACTIONS(3560),
    [anon_sym_LT] = ACTIONS(3560),
    [anon_sym_use] = ACTIONS(3562),
    [anon_sym_use_BANG] = ACTIONS(3560),
    [anon_sym_do_BANG] = ACTIONS(3560),
    [anon_sym_begin] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3562),
    [anon_sym_LT2] = ACTIONS(3562),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3560),
    [anon_sym_or] = ACTIONS(3562),
    [aux_sym_char_token1] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(3562),
    [anon_sym_AT_DQUOTE] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [sym_bool] = ACTIONS(3562),
    [sym_unit] = ACTIONS(3560),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3562),
    [sym_op_identifier] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS_DOT] = ACTIONS(3562),
    [anon_sym_DASH_DOT] = ACTIONS(3562),
    [anon_sym_PERCENT] = ACTIONS(3562),
    [anon_sym_AMP_AMP] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3560),
    [aux_sym_prefix_op_token1] = ACTIONS(3562),
    [aux_sym_infix_op_token1] = ACTIONS(3560),
    [aux_sym_infix_op_token2] = ACTIONS(3562),
    [anon_sym_PIPE_PIPE] = ACTIONS(3562),
    [anon_sym_BANG_EQ] = ACTIONS(3562),
    [anon_sym_COLON_EQ] = ACTIONS(3560),
    [anon_sym_DOLLAR] = ACTIONS(3562),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3562),
    [sym_int] = ACTIONS(3562),
    [sym_xint] = ACTIONS(3560),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3560),
    [sym__newline] = ACTIONS(3560),
  },
  [2661] = {
    [sym_block_comment] = STATE(2661),
    [sym_compiler_directive_decl] = STATE(2661),
    [sym_fsi_directive_decl] = STATE(2661),
    [sym_preproc_line] = STATE(2661),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(3521),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_COMMA] = ACTIONS(3521),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_COLON] = ACTIONS(3521),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_AT_GT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3521),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3521),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_COLON_GT] = ACTIONS(3521),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_DASH_GT] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3521),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_LT_DASH] = ACTIONS(3523),
    [anon_sym_DOT_LBRACK] = ACTIONS(3521),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3521),
    [anon_sym_do_BANG] = ACTIONS(3521),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_LPAREN2] = ACTIONS(3523),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_LT2] = ACTIONS(3523),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3521),
    [anon_sym_or] = ACTIONS(3523),
    [aux_sym_char_token1] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3521),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3523),
    [anon_sym_DASH_DOT] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3521),
    [aux_sym_prefix_op_token1] = ACTIONS(3523),
    [aux_sym_infix_op_token1] = ACTIONS(3521),
    [aux_sym_infix_op_token2] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3523),
    [anon_sym_COLON_EQ] = ACTIONS(3521),
    [anon_sym_DOLLAR] = ACTIONS(3523),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3523),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3521),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3521),
    [sym__newline] = ACTIONS(3521),
  },
  [2662] = {
    [sym_block_comment] = STATE(2662),
    [sym_compiler_directive_decl] = STATE(2662),
    [sym_fsi_directive_decl] = STATE(2662),
    [sym_preproc_line] = STATE(2662),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_EQ] = ACTIONS(3646),
    [anon_sym_COLON] = ACTIONS(3648),
    [anon_sym_return] = ACTIONS(3648),
    [anon_sym_do] = ACTIONS(3648),
    [anon_sym_let] = ACTIONS(3648),
    [anon_sym_let_BANG] = ACTIONS(3646),
    [anon_sym_as] = ACTIONS(3648),
    [anon_sym_LPAREN] = ACTIONS(3648),
    [anon_sym_COMMA] = ACTIONS(3646),
    [anon_sym_null] = ACTIONS(3648),
    [anon_sym_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_COLON] = ACTIONS(3646),
    [anon_sym_AMP] = ACTIONS(3648),
    [anon_sym_LBRACK] = ACTIONS(3648),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3646),
    [anon_sym_LBRACE] = ACTIONS(3648),
    [anon_sym_LT_AT] = ACTIONS(3648),
    [anon_sym_LT_AT_AT] = ACTIONS(3648),
    [anon_sym_DOT] = ACTIONS(3648),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3646),
    [anon_sym_new] = ACTIONS(3648),
    [anon_sym_with] = ACTIONS(3648),
    [anon_sym_return_BANG] = ACTIONS(3646),
    [anon_sym_yield] = ACTIONS(3648),
    [anon_sym_yield_BANG] = ACTIONS(3646),
    [anon_sym_lazy] = ACTIONS(3648),
    [anon_sym_assert] = ACTIONS(3648),
    [anon_sym_upcast] = ACTIONS(3648),
    [anon_sym_downcast] = ACTIONS(3648),
    [anon_sym_COLON_GT] = ACTIONS(3646),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3646),
    [anon_sym_for] = ACTIONS(3648),
    [anon_sym_while] = ACTIONS(3648),
    [anon_sym_else] = ACTIONS(3648),
    [anon_sym_elif] = ACTIONS(3648),
    [anon_sym_if] = ACTIONS(3648),
    [anon_sym_fun] = ACTIONS(3648),
    [anon_sym_try] = ACTIONS(3648),
    [anon_sym_match] = ACTIONS(3648),
    [anon_sym_match_BANG] = ACTIONS(3646),
    [anon_sym_function] = ACTIONS(3648),
    [anon_sym_LT_DASH] = ACTIONS(3648),
    [anon_sym_DOT_LBRACK] = ACTIONS(3646),
    [anon_sym_LT] = ACTIONS(3646),
    [anon_sym_use] = ACTIONS(3648),
    [anon_sym_use_BANG] = ACTIONS(3646),
    [anon_sym_do_BANG] = ACTIONS(3646),
    [anon_sym_begin] = ACTIONS(3648),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3648),
    [aux_sym_char_token1] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3648),
    [anon_sym_AT_DQUOTE] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [sym_bool] = ACTIONS(3648),
    [sym_unit] = ACTIONS(3646),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3648),
    [sym_op_identifier] = ACTIONS(3648),
    [anon_sym_PLUS] = ACTIONS(3648),
    [anon_sym_DASH] = ACTIONS(3648),
    [anon_sym_PLUS_DOT] = ACTIONS(3648),
    [anon_sym_DASH_DOT] = ACTIONS(3648),
    [anon_sym_PERCENT] = ACTIONS(3648),
    [anon_sym_AMP_AMP] = ACTIONS(3648),
    [anon_sym_TILDE] = ACTIONS(3646),
    [aux_sym_prefix_op_token1] = ACTIONS(3648),
    [aux_sym_infix_op_token1] = ACTIONS(3646),
    [aux_sym_infix_op_token2] = ACTIONS(3648),
    [anon_sym_PIPE_PIPE] = ACTIONS(3648),
    [anon_sym_BANG_EQ] = ACTIONS(3648),
    [anon_sym_COLON_EQ] = ACTIONS(3646),
    [anon_sym_DOLLAR] = ACTIONS(3648),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3648),
    [sym_int] = ACTIONS(3648),
    [sym_xint] = ACTIONS(3646),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3646),
    [sym__newline] = ACTIONS(3646),
    [sym__dedent] = ACTIONS(3646),
  },
  [2663] = {
    [sym_block_comment] = STATE(2663),
    [sym_compiler_directive_decl] = STATE(2663),
    [sym_fsi_directive_decl] = STATE(2663),
    [sym_preproc_line] = STATE(2663),
    [sym_identifier] = ACTIONS(3543),
    [anon_sym_EQ] = ACTIONS(3541),
    [anon_sym_COLON] = ACTIONS(3543),
    [anon_sym_return] = ACTIONS(3543),
    [anon_sym_do] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3543),
    [anon_sym_let_BANG] = ACTIONS(3541),
    [anon_sym_LPAREN] = ACTIONS(3543),
    [anon_sym_COMMA] = ACTIONS(3541),
    [anon_sym_null] = ACTIONS(3543),
    [anon_sym_QMARK] = ACTIONS(3543),
    [anon_sym_COLON_QMARK] = ACTIONS(3543),
    [anon_sym_COLON_COLON] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3543),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3541),
    [anon_sym_LBRACE] = ACTIONS(3543),
    [anon_sym_LT_AT] = ACTIONS(3543),
    [anon_sym_LT_AT_AT] = ACTIONS(3543),
    [anon_sym_DOT] = ACTIONS(3543),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3541),
    [anon_sym_new] = ACTIONS(3543),
    [anon_sym_return_BANG] = ACTIONS(3541),
    [anon_sym_yield] = ACTIONS(3543),
    [anon_sym_yield_BANG] = ACTIONS(3541),
    [anon_sym_lazy] = ACTIONS(3543),
    [anon_sym_assert] = ACTIONS(3543),
    [anon_sym_upcast] = ACTIONS(3543),
    [anon_sym_downcast] = ACTIONS(3543),
    [anon_sym_COLON_GT] = ACTIONS(3541),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3541),
    [anon_sym_for] = ACTIONS(3543),
    [anon_sym_while] = ACTIONS(3543),
    [anon_sym_if] = ACTIONS(3543),
    [anon_sym_fun] = ACTIONS(3543),
    [anon_sym_DASH_GT] = ACTIONS(3543),
    [anon_sym_try] = ACTIONS(3543),
    [anon_sym_match] = ACTIONS(3543),
    [anon_sym_match_BANG] = ACTIONS(3541),
    [anon_sym_function] = ACTIONS(3543),
    [anon_sym_LT_DASH] = ACTIONS(3543),
    [anon_sym_DOT_LBRACK] = ACTIONS(3541),
    [anon_sym_LT] = ACTIONS(3541),
    [anon_sym_GT] = ACTIONS(3543),
    [anon_sym_use] = ACTIONS(3543),
    [anon_sym_use_BANG] = ACTIONS(3541),
    [anon_sym_do_BANG] = ACTIONS(3541),
    [anon_sym_begin] = ACTIONS(3543),
    [anon_sym_LPAREN2] = ACTIONS(3543),
    [anon_sym_STAR] = ACTIONS(3543),
    [anon_sym_LT2] = ACTIONS(3543),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_or] = ACTIONS(3543),
    [aux_sym_char_token1] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3543),
    [anon_sym_DQUOTE] = ACTIONS(3543),
    [anon_sym_AT_DQUOTE] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [sym_bool] = ACTIONS(3543),
    [sym_unit] = ACTIONS(3541),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3543),
    [sym_op_identifier] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(3543),
    [anon_sym_DASH] = ACTIONS(3543),
    [anon_sym_PLUS_DOT] = ACTIONS(3543),
    [anon_sym_DASH_DOT] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3543),
    [anon_sym_AMP_AMP] = ACTIONS(3543),
    [anon_sym_TILDE] = ACTIONS(3541),
    [aux_sym_prefix_op_token1] = ACTIONS(3543),
    [aux_sym_infix_op_token1] = ACTIONS(3541),
    [aux_sym_infix_op_token2] = ACTIONS(3543),
    [anon_sym_PIPE_PIPE] = ACTIONS(3543),
    [anon_sym_BANG_EQ] = ACTIONS(3543),
    [anon_sym_COLON_EQ] = ACTIONS(3541),
    [anon_sym_DOLLAR] = ACTIONS(3543),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3543),
    [sym_int] = ACTIONS(3543),
    [sym_xint] = ACTIONS(3541),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3541),
    [sym__newline] = ACTIONS(3541),
  },
  [2664] = {
    [sym_block_comment] = STATE(2664),
    [sym_compiler_directive_decl] = STATE(2664),
    [sym_fsi_directive_decl] = STATE(2664),
    [sym_preproc_line] = STATE(2664),
    [sym_identifier] = ACTIONS(3547),
    [anon_sym_EQ] = ACTIONS(3545),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_return] = ACTIONS(3547),
    [anon_sym_do] = ACTIONS(3547),
    [anon_sym_let] = ACTIONS(3547),
    [anon_sym_let_BANG] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(3547),
    [anon_sym_COMMA] = ACTIONS(3545),
    [anon_sym_null] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3547),
    [anon_sym_COLON_QMARK] = ACTIONS(3547),
    [anon_sym_COLON_COLON] = ACTIONS(3545),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3545),
    [anon_sym_LBRACE] = ACTIONS(3547),
    [anon_sym_LT_AT] = ACTIONS(3547),
    [anon_sym_LT_AT_AT] = ACTIONS(3547),
    [anon_sym_DOT] = ACTIONS(3547),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3545),
    [anon_sym_new] = ACTIONS(3547),
    [anon_sym_return_BANG] = ACTIONS(3545),
    [anon_sym_yield] = ACTIONS(3547),
    [anon_sym_yield_BANG] = ACTIONS(3545),
    [anon_sym_lazy] = ACTIONS(3547),
    [anon_sym_assert] = ACTIONS(3547),
    [anon_sym_upcast] = ACTIONS(3547),
    [anon_sym_downcast] = ACTIONS(3547),
    [anon_sym_COLON_GT] = ACTIONS(3545),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3545),
    [anon_sym_for] = ACTIONS(3547),
    [anon_sym_while] = ACTIONS(3547),
    [anon_sym_if] = ACTIONS(3547),
    [anon_sym_fun] = ACTIONS(3547),
    [anon_sym_DASH_GT] = ACTIONS(3547),
    [anon_sym_try] = ACTIONS(3547),
    [anon_sym_match] = ACTIONS(3547),
    [anon_sym_match_BANG] = ACTIONS(3545),
    [anon_sym_function] = ACTIONS(3547),
    [anon_sym_LT_DASH] = ACTIONS(3547),
    [anon_sym_DOT_LBRACK] = ACTIONS(3545),
    [anon_sym_LT] = ACTIONS(3545),
    [anon_sym_GT] = ACTIONS(3547),
    [anon_sym_use] = ACTIONS(3547),
    [anon_sym_use_BANG] = ACTIONS(3545),
    [anon_sym_do_BANG] = ACTIONS(3545),
    [anon_sym_begin] = ACTIONS(3547),
    [anon_sym_LPAREN2] = ACTIONS(3547),
    [anon_sym_STAR] = ACTIONS(3547),
    [anon_sym_LT2] = ACTIONS(3547),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_or] = ACTIONS(3547),
    [aux_sym_char_token1] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3547),
    [anon_sym_DQUOTE] = ACTIONS(3547),
    [anon_sym_AT_DQUOTE] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [sym_bool] = ACTIONS(3547),
    [sym_unit] = ACTIONS(3545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3547),
    [sym_op_identifier] = ACTIONS(3547),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PLUS_DOT] = ACTIONS(3547),
    [anon_sym_DASH_DOT] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3547),
    [anon_sym_AMP_AMP] = ACTIONS(3547),
    [anon_sym_TILDE] = ACTIONS(3545),
    [aux_sym_prefix_op_token1] = ACTIONS(3547),
    [aux_sym_infix_op_token1] = ACTIONS(3545),
    [aux_sym_infix_op_token2] = ACTIONS(3547),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_BANG_EQ] = ACTIONS(3547),
    [anon_sym_COLON_EQ] = ACTIONS(3545),
    [anon_sym_DOLLAR] = ACTIONS(3547),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3547),
    [sym_int] = ACTIONS(3547),
    [sym_xint] = ACTIONS(3545),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3545),
    [sym__newline] = ACTIONS(3545),
  },
  [2665] = {
    [sym_block_comment] = STATE(2665),
    [sym_compiler_directive_decl] = STATE(2665),
    [sym_fsi_directive_decl] = STATE(2665),
    [sym_preproc_line] = STATE(2665),
    [sym_identifier] = ACTIONS(3505),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_COLON] = ACTIONS(3505),
    [anon_sym_return] = ACTIONS(3505),
    [anon_sym_do] = ACTIONS(3505),
    [anon_sym_let] = ACTIONS(3505),
    [anon_sym_let_BANG] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3505),
    [anon_sym_COMMA] = ACTIONS(3503),
    [anon_sym_null] = ACTIONS(3505),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_COLON_QMARK] = ACTIONS(3505),
    [anon_sym_COLON_COLON] = ACTIONS(3503),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3503),
    [anon_sym_LBRACE] = ACTIONS(3505),
    [anon_sym_LT_AT] = ACTIONS(3505),
    [anon_sym_AT_GT] = ACTIONS(3505),
    [anon_sym_LT_AT_AT] = ACTIONS(3505),
    [anon_sym_DOT] = ACTIONS(3505),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3503),
    [anon_sym_new] = ACTIONS(3505),
    [anon_sym_return_BANG] = ACTIONS(3503),
    [anon_sym_yield] = ACTIONS(3505),
    [anon_sym_yield_BANG] = ACTIONS(3503),
    [anon_sym_lazy] = ACTIONS(3505),
    [anon_sym_assert] = ACTIONS(3505),
    [anon_sym_upcast] = ACTIONS(3505),
    [anon_sym_downcast] = ACTIONS(3505),
    [anon_sym_COLON_GT] = ACTIONS(3503),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3503),
    [anon_sym_for] = ACTIONS(3505),
    [anon_sym_while] = ACTIONS(3505),
    [anon_sym_if] = ACTIONS(3505),
    [anon_sym_fun] = ACTIONS(3505),
    [anon_sym_DASH_GT] = ACTIONS(3505),
    [anon_sym_try] = ACTIONS(3505),
    [anon_sym_match] = ACTIONS(3505),
    [anon_sym_match_BANG] = ACTIONS(3503),
    [anon_sym_function] = ACTIONS(3505),
    [anon_sym_LT_DASH] = ACTIONS(3505),
    [anon_sym_DOT_LBRACK] = ACTIONS(3503),
    [anon_sym_LT] = ACTIONS(3503),
    [anon_sym_use] = ACTIONS(3505),
    [anon_sym_use_BANG] = ACTIONS(3503),
    [anon_sym_do_BANG] = ACTIONS(3503),
    [anon_sym_begin] = ACTIONS(3505),
    [anon_sym_LPAREN2] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3505),
    [anon_sym_LT2] = ACTIONS(5178),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_or] = ACTIONS(3505),
    [aux_sym_char_token1] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3505),
    [anon_sym_DQUOTE] = ACTIONS(3505),
    [anon_sym_AT_DQUOTE] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [sym_bool] = ACTIONS(3505),
    [sym_unit] = ACTIONS(3503),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3505),
    [sym_op_identifier] = ACTIONS(3505),
    [anon_sym_PLUS] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3505),
    [anon_sym_PLUS_DOT] = ACTIONS(3505),
    [anon_sym_DASH_DOT] = ACTIONS(3505),
    [anon_sym_PERCENT] = ACTIONS(3505),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3503),
    [aux_sym_prefix_op_token1] = ACTIONS(3505),
    [aux_sym_infix_op_token1] = ACTIONS(3503),
    [aux_sym_infix_op_token2] = ACTIONS(3505),
    [anon_sym_PIPE_PIPE] = ACTIONS(3505),
    [anon_sym_BANG_EQ] = ACTIONS(3505),
    [anon_sym_COLON_EQ] = ACTIONS(3503),
    [anon_sym_DOLLAR] = ACTIONS(3505),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3505),
    [sym_int] = ACTIONS(3505),
    [sym_xint] = ACTIONS(3503),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3503),
    [sym__newline] = ACTIONS(3503),
  },
  [2666] = {
    [sym_block_comment] = STATE(2666),
    [sym_compiler_directive_decl] = STATE(2666),
    [sym_fsi_directive_decl] = STATE(2666),
    [sym_preproc_line] = STATE(2666),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_COLON] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_AT_GT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(3513),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_LT_DASH] = ACTIONS(3515),
    [anon_sym_DOT_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_or] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3515),
    [anon_sym_DASH_DOT] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3515),
    [aux_sym_infix_op_token1] = ACTIONS(3513),
    [aux_sym_infix_op_token2] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3515),
    [anon_sym_COLON_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(3515),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3515),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
  },
  [2667] = {
    [sym_block_comment] = STATE(2667),
    [sym_compiler_directive_decl] = STATE(2667),
    [sym_fsi_directive_decl] = STATE(2667),
    [sym_preproc_line] = STATE(2667),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(4667),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_DASH_GT] = ACTIONS(4182),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_DOT_DOT] = ACTIONS(4182),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_DOT_DOT2] = ACTIONS(3683),
    [anon_sym_or] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
    [sym__dedent] = ACTIONS(3683),
  },
  [2668] = {
    [sym_attributes] = STATE(7162),
    [sym__attribute_set] = STATE(6370),
    [sym_function_or_value_defn] = STATE(3854),
    [sym_access_modifier] = STATE(10931),
    [sym__class_function_or_value_defn] = STATE(3860),
    [aux_sym__type_extension_inner] = STATE(2634),
    [sym__type_defn_elements] = STATE(3860),
    [sym_interface_implementation] = STATE(3863),
    [sym_member_defn] = STATE(3863),
    [sym_additional_constr_defn] = STATE(3864),
    [sym_block_comment] = STATE(2668),
    [sym_compiler_directive_decl] = STATE(2668),
    [sym_fsi_directive_decl] = STATE(2668),
    [sym_preproc_line] = STATE(2668),
    [sym_preproc_if_in_class_definition] = STATE(3860),
    [aux_sym_attributes_repeat1] = STATE(6195),
    [ts_builtin_sym_end] = ACTIONS(5105),
    [sym_identifier] = ACTIONS(5107),
    [anon_sym_module] = ACTIONS(5107),
    [anon_sym_open] = ACTIONS(5107),
    [anon_sym_LBRACK_LT] = ACTIONS(5105),
    [anon_sym_return] = ACTIONS(5107),
    [anon_sym_type] = ACTIONS(5107),
    [anon_sym_do] = ACTIONS(5107),
    [anon_sym_and] = ACTIONS(5107),
    [anon_sym_let] = ACTIONS(5107),
    [anon_sym_let_BANG] = ACTIONS(5105),
    [aux_sym_access_modifier_token1] = ACTIONS(5109),
    [anon_sym_LPAREN] = ACTIONS(5107),
    [anon_sym_null] = ACTIONS(5107),
    [anon_sym_AMP] = ACTIONS(5107),
    [anon_sym_LBRACK] = ACTIONS(5107),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5105),
    [anon_sym_LBRACE] = ACTIONS(5107),
    [anon_sym_LT_AT] = ACTIONS(5107),
    [anon_sym_LT_AT_AT] = ACTIONS(5105),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5105),
    [anon_sym_new] = ACTIONS(5107),
    [anon_sym_return_BANG] = ACTIONS(5105),
    [anon_sym_yield] = ACTIONS(5107),
    [anon_sym_yield_BANG] = ACTIONS(5105),
    [anon_sym_lazy] = ACTIONS(5107),
    [anon_sym_assert] = ACTIONS(5107),
    [anon_sym_upcast] = ACTIONS(5107),
    [anon_sym_downcast] = ACTIONS(5107),
    [anon_sym_for] = ACTIONS(5107),
    [anon_sym_while] = ACTIONS(5107),
    [anon_sym_if] = ACTIONS(5107),
    [anon_sym_fun] = ACTIONS(5107),
    [anon_sym_try] = ACTIONS(5107),
    [anon_sym_match] = ACTIONS(5107),
    [anon_sym_match_BANG] = ACTIONS(5105),
    [anon_sym_function] = ACTIONS(5107),
    [anon_sym_use] = ACTIONS(5107),
    [anon_sym_use_BANG] = ACTIONS(5105),
    [anon_sym_do_BANG] = ACTIONS(5105),
    [anon_sym_begin] = ACTIONS(5107),
    [anon_sym_default] = ACTIONS(5111),
    [anon_sym_static] = ACTIONS(5113),
    [anon_sym_member] = ACTIONS(5180),
    [anon_sym_interface] = ACTIONS(5117),
    [anon_sym_exception] = ACTIONS(5107),
    [anon_sym_abstract] = ACTIONS(5119),
    [anon_sym_val] = ACTIONS(5121),
    [anon_sym_override] = ACTIONS(5111),
    [aux_sym_char_token1] = ACTIONS(5105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5107),
    [anon_sym_DQUOTE] = ACTIONS(5107),
    [anon_sym_AT_DQUOTE] = ACTIONS(5105),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5105),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5105),
    [sym_bool] = ACTIONS(5107),
    [sym_unit] = ACTIONS(5105),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5107),
    [sym_op_identifier] = ACTIONS(5105),
    [anon_sym_PLUS] = ACTIONS(5107),
    [anon_sym_DASH] = ACTIONS(5107),
    [anon_sym_PLUS_DOT] = ACTIONS(5105),
    [anon_sym_DASH_DOT] = ACTIONS(5105),
    [anon_sym_PERCENT] = ACTIONS(5105),
    [anon_sym_AMP_AMP] = ACTIONS(5105),
    [anon_sym_TILDE] = ACTIONS(5105),
    [aux_sym_prefix_op_token1] = ACTIONS(5105),
    [sym_int] = ACTIONS(5107),
    [sym_xint] = ACTIONS(5105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5105),
    [anon_sym_POUNDload] = ACTIONS(5105),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(5105),
  },
  [2669] = {
    [sym_block_comment] = STATE(2669),
    [sym_compiler_directive_decl] = STATE(2669),
    [sym_fsi_directive_decl] = STATE(2669),
    [sym_preproc_line] = STATE(2669),
    [sym_identifier] = ACTIONS(3728),
    [anon_sym_EQ] = ACTIONS(3726),
    [anon_sym_COLON] = ACTIONS(3728),
    [anon_sym_return] = ACTIONS(3728),
    [anon_sym_do] = ACTIONS(3728),
    [anon_sym_let] = ACTIONS(3728),
    [anon_sym_let_BANG] = ACTIONS(3726),
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_COMMA] = ACTIONS(3726),
    [anon_sym_null] = ACTIONS(3728),
    [anon_sym_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(3726),
    [anon_sym_AMP] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3726),
    [anon_sym_LBRACE] = ACTIONS(3728),
    [anon_sym_LT_AT] = ACTIONS(3728),
    [anon_sym_LT_AT_AT] = ACTIONS(3728),
    [anon_sym_DOT] = ACTIONS(3728),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3726),
    [anon_sym_new] = ACTIONS(3728),
    [anon_sym_with] = ACTIONS(3728),
    [anon_sym_return_BANG] = ACTIONS(3726),
    [anon_sym_yield] = ACTIONS(3728),
    [anon_sym_yield_BANG] = ACTIONS(3726),
    [anon_sym_lazy] = ACTIONS(3728),
    [anon_sym_assert] = ACTIONS(3728),
    [anon_sym_upcast] = ACTIONS(3728),
    [anon_sym_downcast] = ACTIONS(3728),
    [anon_sym_COLON_GT] = ACTIONS(3726),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3726),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_fun] = ACTIONS(3728),
    [anon_sym_try] = ACTIONS(3728),
    [anon_sym_match] = ACTIONS(3728),
    [anon_sym_match_BANG] = ACTIONS(3726),
    [anon_sym_function] = ACTIONS(3728),
    [anon_sym_LT_DASH] = ACTIONS(3728),
    [anon_sym_DOT_LBRACK] = ACTIONS(3726),
    [anon_sym_LT] = ACTIONS(3726),
    [anon_sym_use] = ACTIONS(3728),
    [anon_sym_use_BANG] = ACTIONS(3726),
    [anon_sym_do_BANG] = ACTIONS(3726),
    [anon_sym_begin] = ACTIONS(3728),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_DOT_DOT2] = ACTIONS(3726),
    [anon_sym_or] = ACTIONS(3728),
    [aux_sym_char_token1] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3728),
    [anon_sym_AT_DQUOTE] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [sym_bool] = ACTIONS(3728),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3728),
    [sym_op_identifier] = ACTIONS(3728),
    [anon_sym_PLUS] = ACTIONS(3728),
    [anon_sym_DASH] = ACTIONS(3728),
    [anon_sym_PLUS_DOT] = ACTIONS(3728),
    [anon_sym_DASH_DOT] = ACTIONS(3728),
    [anon_sym_PERCENT] = ACTIONS(3728),
    [anon_sym_AMP_AMP] = ACTIONS(3728),
    [anon_sym_TILDE] = ACTIONS(3726),
    [aux_sym_prefix_op_token1] = ACTIONS(3728),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token2] = ACTIONS(3728),
    [anon_sym_PIPE_PIPE] = ACTIONS(3728),
    [anon_sym_BANG_EQ] = ACTIONS(3728),
    [anon_sym_COLON_EQ] = ACTIONS(3726),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3728),
    [sym_int] = ACTIONS(3728),
    [sym_xint] = ACTIONS(3726),
    [anon_sym_f] = ACTIONS(3728),
    [aux_sym_decimal_token1] = ACTIONS(3728),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3726),
    [sym__newline] = ACTIONS(3726),
    [sym__dedent] = ACTIONS(3726),
  },
  [2670] = {
    [sym_block_comment] = STATE(2670),
    [sym_compiler_directive_decl] = STATE(2670),
    [sym_fsi_directive_decl] = STATE(2670),
    [sym_preproc_line] = STATE(2670),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_COLON] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_AT_GT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(3513),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_LT_DASH] = ACTIONS(3515),
    [anon_sym_DOT_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_or] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3515),
    [anon_sym_DASH_DOT] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3515),
    [aux_sym_infix_op_token1] = ACTIONS(3513),
    [aux_sym_infix_op_token2] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3515),
    [anon_sym_COLON_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(3515),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3515),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
  },
  [2671] = {
    [sym_block_comment] = STATE(2671),
    [sym_compiler_directive_decl] = STATE(2671),
    [sym_fsi_directive_decl] = STATE(2671),
    [sym_preproc_line] = STATE(2671),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(3521),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_COMMA] = ACTIONS(3521),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_COLON] = ACTIONS(3521),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3521),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3521),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_COLON_GT] = ACTIONS(3521),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_DASH_GT] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3521),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_LT_DASH] = ACTIONS(3523),
    [anon_sym_DOT_LBRACK] = ACTIONS(3521),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3521),
    [anon_sym_do_BANG] = ACTIONS(3521),
    [anon_sym_DOT_DOT] = ACTIONS(3521),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_LPAREN2] = ACTIONS(3523),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_LT2] = ACTIONS(3523),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3521),
    [anon_sym_or] = ACTIONS(3523),
    [aux_sym_char_token1] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3521),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3523),
    [anon_sym_DASH_DOT] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3521),
    [aux_sym_prefix_op_token1] = ACTIONS(3523),
    [aux_sym_infix_op_token1] = ACTIONS(3521),
    [aux_sym_infix_op_token2] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3523),
    [anon_sym_COLON_EQ] = ACTIONS(3521),
    [anon_sym_DOLLAR] = ACTIONS(3523),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3523),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3521),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3521),
    [sym__newline] = ACTIONS(3521),
  },
  [2672] = {
    [sym_block_comment] = STATE(2672),
    [sym_compiler_directive_decl] = STATE(2672),
    [sym_fsi_directive_decl] = STATE(2672),
    [sym_preproc_line] = STATE(2672),
    [sym_identifier] = ACTIONS(3511),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_COLON] = ACTIONS(3511),
    [anon_sym_return] = ACTIONS(3511),
    [anon_sym_do] = ACTIONS(3511),
    [anon_sym_let] = ACTIONS(3511),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3511),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_null] = ACTIONS(3511),
    [anon_sym_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_QMARK] = ACTIONS(3511),
    [anon_sym_COLON_COLON] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(3511),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_LT_AT] = ACTIONS(3511),
    [anon_sym_AT_GT] = ACTIONS(3511),
    [anon_sym_LT_AT_AT] = ACTIONS(3511),
    [anon_sym_DOT] = ACTIONS(3511),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3511),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3511),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3511),
    [anon_sym_assert] = ACTIONS(3511),
    [anon_sym_upcast] = ACTIONS(3511),
    [anon_sym_downcast] = ACTIONS(3511),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3511),
    [anon_sym_while] = ACTIONS(3511),
    [anon_sym_if] = ACTIONS(3511),
    [anon_sym_fun] = ACTIONS(3511),
    [anon_sym_DASH_GT] = ACTIONS(3511),
    [anon_sym_try] = ACTIONS(3511),
    [anon_sym_match] = ACTIONS(3511),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3511),
    [anon_sym_LT_DASH] = ACTIONS(3511),
    [anon_sym_DOT_LBRACK] = ACTIONS(3509),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_use] = ACTIONS(3511),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3511),
    [anon_sym_LPAREN2] = ACTIONS(3511),
    [anon_sym_STAR] = ACTIONS(3511),
    [anon_sym_LT2] = ACTIONS(3511),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3511),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3511),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3511),
    [sym_unit] = ACTIONS(3509),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3511),
    [sym_op_identifier] = ACTIONS(3511),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3511),
    [anon_sym_PLUS_DOT] = ACTIONS(3511),
    [anon_sym_DASH_DOT] = ACTIONS(3511),
    [anon_sym_PERCENT] = ACTIONS(3511),
    [anon_sym_AMP_AMP] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3511),
    [aux_sym_infix_op_token1] = ACTIONS(3509),
    [aux_sym_infix_op_token2] = ACTIONS(3511),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_BANG_EQ] = ACTIONS(3511),
    [anon_sym_COLON_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(3511),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3511),
    [sym_int] = ACTIONS(3511),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [2673] = {
    [sym_block_comment] = STATE(2673),
    [sym_compiler_directive_decl] = STATE(2673),
    [sym_fsi_directive_decl] = STATE(2673),
    [sym_preproc_line] = STATE(2673),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_DOT_DOT2] = ACTIONS(3191),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_f] = ACTIONS(3445),
    [aux_sym_decimal_token1] = ACTIONS(3397),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
    [sym__dedent] = ACTIONS(3191),
  },
  [2674] = {
    [sym_block_comment] = STATE(2674),
    [sym_compiler_directive_decl] = STATE(2674),
    [sym_fsi_directive_decl] = STATE(2674),
    [sym_preproc_line] = STATE(2674),
    [sym_identifier] = ACTIONS(3519),
    [anon_sym_EQ] = ACTIONS(3517),
    [anon_sym_COLON] = ACTIONS(3519),
    [anon_sym_return] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(3519),
    [anon_sym_let] = ACTIONS(3519),
    [anon_sym_let_BANG] = ACTIONS(3517),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [anon_sym_COMMA] = ACTIONS(3517),
    [anon_sym_null] = ACTIONS(3519),
    [anon_sym_QMARK] = ACTIONS(3519),
    [anon_sym_COLON_QMARK] = ACTIONS(3519),
    [anon_sym_COLON_COLON] = ACTIONS(3517),
    [anon_sym_AMP] = ACTIONS(3519),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_LT_AT] = ACTIONS(3519),
    [anon_sym_LT_AT_AT] = ACTIONS(3519),
    [anon_sym_DOT] = ACTIONS(3519),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3519),
    [anon_sym_return_BANG] = ACTIONS(3517),
    [anon_sym_yield] = ACTIONS(3519),
    [anon_sym_yield_BANG] = ACTIONS(3517),
    [anon_sym_lazy] = ACTIONS(3519),
    [anon_sym_assert] = ACTIONS(3519),
    [anon_sym_upcast] = ACTIONS(3519),
    [anon_sym_downcast] = ACTIONS(3519),
    [anon_sym_COLON_GT] = ACTIONS(3517),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3517),
    [anon_sym_for] = ACTIONS(3519),
    [anon_sym_while] = ACTIONS(3519),
    [anon_sym_if] = ACTIONS(3519),
    [anon_sym_fun] = ACTIONS(3519),
    [anon_sym_DASH_GT] = ACTIONS(3519),
    [anon_sym_try] = ACTIONS(3519),
    [anon_sym_match] = ACTIONS(3519),
    [anon_sym_match_BANG] = ACTIONS(3517),
    [anon_sym_function] = ACTIONS(3519),
    [anon_sym_LT_DASH] = ACTIONS(3519),
    [anon_sym_DOT_LBRACK] = ACTIONS(3517),
    [anon_sym_LT] = ACTIONS(3517),
    [anon_sym_use] = ACTIONS(3519),
    [anon_sym_use_BANG] = ACTIONS(3517),
    [anon_sym_do_BANG] = ACTIONS(3517),
    [anon_sym_DOT_DOT] = ACTIONS(3517),
    [anon_sym_begin] = ACTIONS(3519),
    [anon_sym_LPAREN2] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_LT2] = ACTIONS(3519),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3517),
    [anon_sym_or] = ACTIONS(3519),
    [aux_sym_char_token1] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [anon_sym_AT_DQUOTE] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [sym_bool] = ACTIONS(3519),
    [sym_unit] = ACTIONS(3517),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3519),
    [sym_op_identifier] = ACTIONS(3519),
    [anon_sym_PLUS] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_DOT] = ACTIONS(3519),
    [anon_sym_DASH_DOT] = ACTIONS(3519),
    [anon_sym_PERCENT] = ACTIONS(3519),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3517),
    [aux_sym_prefix_op_token1] = ACTIONS(3519),
    [aux_sym_infix_op_token1] = ACTIONS(3517),
    [aux_sym_infix_op_token2] = ACTIONS(3519),
    [anon_sym_PIPE_PIPE] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_COLON_EQ] = ACTIONS(3517),
    [anon_sym_DOLLAR] = ACTIONS(3519),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3519),
    [sym_int] = ACTIONS(3519),
    [sym_xint] = ACTIONS(3517),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3517),
    [sym__newline] = ACTIONS(3517),
  },
  [2675] = {
    [sym_block_comment] = STATE(2675),
    [sym_compiler_directive_decl] = STATE(2675),
    [sym_fsi_directive_decl] = STATE(2675),
    [sym_preproc_line] = STATE(2675),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3525),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_COLON] = ACTIONS(3525),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_COLON_GT] = ACTIONS(3525),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_DASH_GT] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_LT_DASH] = ACTIONS(3527),
    [anon_sym_DOT_LBRACK] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_DOT_DOT] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_LPAREN2] = ACTIONS(3527),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_LT2] = ACTIONS(3527),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_or] = ACTIONS(3527),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3525),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3527),
    [anon_sym_DASH_DOT] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3527),
    [aux_sym_infix_op_token1] = ACTIONS(3525),
    [aux_sym_infix_op_token2] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_COLON_EQ] = ACTIONS(3525),
    [anon_sym_DOLLAR] = ACTIONS(3527),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3527),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3525),
    [sym__newline] = ACTIONS(3525),
  },
  [2676] = {
    [sym_block_comment] = STATE(2676),
    [sym_compiler_directive_decl] = STATE(2676),
    [sym_fsi_directive_decl] = STATE(2676),
    [sym_preproc_line] = STATE(2676),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_with] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_DOT_DOT2] = ACTIONS(3602),
    [anon_sym_or] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
    [sym__dedent] = ACTIONS(3602),
  },
  [2677] = {
    [sym_block_comment] = STATE(2677),
    [sym_compiler_directive_decl] = STATE(2677),
    [sym_fsi_directive_decl] = STATE(2677),
    [sym_preproc_line] = STATE(2677),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_COLON] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3515),
    [anon_sym_AT_AT_GT] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(3513),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_LT_DASH] = ACTIONS(3515),
    [anon_sym_DOT_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_or] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3515),
    [anon_sym_DASH_DOT] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3515),
    [aux_sym_infix_op_token1] = ACTIONS(3513),
    [aux_sym_infix_op_token2] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3515),
    [anon_sym_COLON_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(3515),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3515),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
  },
  [2678] = {
    [sym_block_comment] = STATE(2678),
    [sym_compiler_directive_decl] = STATE(2678),
    [sym_fsi_directive_decl] = STATE(2678),
    [sym_preproc_line] = STATE(2678),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_AT_AT_GT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3487),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_or] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [2679] = {
    [sym_block_comment] = STATE(2679),
    [sym_compiler_directive_decl] = STATE(2679),
    [sym_fsi_directive_decl] = STATE(2679),
    [sym_preproc_line] = STATE(2679),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_with] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(4667),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_DASH_GT] = ACTIONS(4182),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_DOT_DOT] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
    [sym__dedent] = ACTIONS(3683),
  },
  [2680] = {
    [sym_block_comment] = STATE(2680),
    [sym_compiler_directive_decl] = STATE(2680),
    [sym_fsi_directive_decl] = STATE(2680),
    [sym_preproc_line] = STATE(2680),
    [sym_identifier] = ACTIONS(3535),
    [anon_sym_EQ] = ACTIONS(3533),
    [anon_sym_COLON] = ACTIONS(3535),
    [anon_sym_return] = ACTIONS(3535),
    [anon_sym_do] = ACTIONS(3535),
    [anon_sym_let] = ACTIONS(3535),
    [anon_sym_let_BANG] = ACTIONS(3533),
    [anon_sym_LPAREN] = ACTIONS(3535),
    [anon_sym_COMMA] = ACTIONS(3533),
    [anon_sym_null] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(3535),
    [anon_sym_COLON_QMARK] = ACTIONS(3535),
    [anon_sym_COLON_COLON] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3533),
    [anon_sym_LBRACE] = ACTIONS(3535),
    [anon_sym_LT_AT] = ACTIONS(3535),
    [anon_sym_AT_GT] = ACTIONS(3535),
    [anon_sym_LT_AT_AT] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(3535),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3533),
    [anon_sym_new] = ACTIONS(3535),
    [anon_sym_return_BANG] = ACTIONS(3533),
    [anon_sym_yield] = ACTIONS(3535),
    [anon_sym_yield_BANG] = ACTIONS(3533),
    [anon_sym_lazy] = ACTIONS(3535),
    [anon_sym_assert] = ACTIONS(3535),
    [anon_sym_upcast] = ACTIONS(3535),
    [anon_sym_downcast] = ACTIONS(3535),
    [anon_sym_COLON_GT] = ACTIONS(3533),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3533),
    [anon_sym_for] = ACTIONS(3535),
    [anon_sym_while] = ACTIONS(3535),
    [anon_sym_if] = ACTIONS(3535),
    [anon_sym_fun] = ACTIONS(3535),
    [anon_sym_DASH_GT] = ACTIONS(3535),
    [anon_sym_try] = ACTIONS(3535),
    [anon_sym_match] = ACTIONS(3535),
    [anon_sym_match_BANG] = ACTIONS(3533),
    [anon_sym_function] = ACTIONS(3535),
    [anon_sym_LT_DASH] = ACTIONS(3535),
    [anon_sym_DOT_LBRACK] = ACTIONS(3533),
    [anon_sym_LT] = ACTIONS(3533),
    [anon_sym_use] = ACTIONS(3535),
    [anon_sym_use_BANG] = ACTIONS(3533),
    [anon_sym_do_BANG] = ACTIONS(3533),
    [anon_sym_begin] = ACTIONS(3535),
    [anon_sym_LPAREN2] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(3535),
    [anon_sym_LT2] = ACTIONS(3535),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3533),
    [anon_sym_or] = ACTIONS(3535),
    [aux_sym_char_token1] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE] = ACTIONS(3535),
    [anon_sym_AT_DQUOTE] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [sym_bool] = ACTIONS(3535),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3535),
    [sym_op_identifier] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS_DOT] = ACTIONS(3535),
    [anon_sym_DASH_DOT] = ACTIONS(3535),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(3535),
    [anon_sym_TILDE] = ACTIONS(3533),
    [aux_sym_prefix_op_token1] = ACTIONS(3535),
    [aux_sym_infix_op_token1] = ACTIONS(3533),
    [aux_sym_infix_op_token2] = ACTIONS(3535),
    [anon_sym_PIPE_PIPE] = ACTIONS(3535),
    [anon_sym_BANG_EQ] = ACTIONS(3535),
    [anon_sym_COLON_EQ] = ACTIONS(3533),
    [anon_sym_DOLLAR] = ACTIONS(3535),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3535),
    [sym_int] = ACTIONS(3535),
    [sym_xint] = ACTIONS(3533),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3533),
    [sym__newline] = ACTIONS(3533),
  },
  [2681] = {
    [sym_block_comment] = STATE(2681),
    [sym_compiler_directive_decl] = STATE(2681),
    [sym_fsi_directive_decl] = STATE(2681),
    [sym_preproc_line] = STATE(2681),
    [sym_identifier] = ACTIONS(3531),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(3531),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_do] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_null] = ACTIONS(3531),
    [anon_sym_QMARK] = ACTIONS(3531),
    [anon_sym_COLON_QMARK] = ACTIONS(3531),
    [anon_sym_COLON_COLON] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3531),
    [anon_sym_LT_AT] = ACTIONS(3531),
    [anon_sym_AT_GT] = ACTIONS(3531),
    [anon_sym_LT_AT_AT] = ACTIONS(3531),
    [anon_sym_DOT] = ACTIONS(3531),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3531),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3531),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3531),
    [anon_sym_assert] = ACTIONS(3531),
    [anon_sym_upcast] = ACTIONS(3531),
    [anon_sym_downcast] = ACTIONS(3531),
    [anon_sym_COLON_GT] = ACTIONS(3529),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3531),
    [anon_sym_while] = ACTIONS(3531),
    [anon_sym_if] = ACTIONS(3531),
    [anon_sym_fun] = ACTIONS(3531),
    [anon_sym_DASH_GT] = ACTIONS(3531),
    [anon_sym_try] = ACTIONS(3531),
    [anon_sym_match] = ACTIONS(3531),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3531),
    [anon_sym_LT_DASH] = ACTIONS(3531),
    [anon_sym_DOT_LBRACK] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_use] = ACTIONS(3531),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3531),
    [anon_sym_LPAREN2] = ACTIONS(3531),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LT2] = ACTIONS(3531),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_or] = ACTIONS(3531),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3531),
    [anon_sym_DQUOTE] = ACTIONS(3531),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3531),
    [sym_unit] = ACTIONS(3529),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3531),
    [sym_op_identifier] = ACTIONS(3531),
    [anon_sym_PLUS] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(3531),
    [anon_sym_PLUS_DOT] = ACTIONS(3531),
    [anon_sym_DASH_DOT] = ACTIONS(3531),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_AMP_AMP] = ACTIONS(3531),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3531),
    [aux_sym_infix_op_token1] = ACTIONS(3529),
    [aux_sym_infix_op_token2] = ACTIONS(3531),
    [anon_sym_PIPE_PIPE] = ACTIONS(3531),
    [anon_sym_BANG_EQ] = ACTIONS(3531),
    [anon_sym_COLON_EQ] = ACTIONS(3529),
    [anon_sym_DOLLAR] = ACTIONS(3531),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3531),
    [sym_int] = ACTIONS(3531),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [sym__newline] = ACTIONS(3529),
  },
  [2682] = {
    [sym_block_comment] = STATE(2682),
    [sym_compiler_directive_decl] = STATE(2682),
    [sym_fsi_directive_decl] = STATE(2682),
    [sym_preproc_line] = STATE(2682),
    [sym_identifier] = ACTIONS(3753),
    [anon_sym_EQ] = ACTIONS(3751),
    [anon_sym_COLON] = ACTIONS(3753),
    [anon_sym_return] = ACTIONS(3753),
    [anon_sym_do] = ACTIONS(3753),
    [anon_sym_let] = ACTIONS(3753),
    [anon_sym_let_BANG] = ACTIONS(3751),
    [anon_sym_as] = ACTIONS(3753),
    [anon_sym_LPAREN] = ACTIONS(3753),
    [anon_sym_COMMA] = ACTIONS(3751),
    [anon_sym_null] = ACTIONS(3753),
    [anon_sym_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_COLON] = ACTIONS(3751),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3751),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_LT_AT] = ACTIONS(3753),
    [anon_sym_LT_AT_AT] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3753),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3751),
    [anon_sym_new] = ACTIONS(3753),
    [anon_sym_with] = ACTIONS(3753),
    [anon_sym_return_BANG] = ACTIONS(3751),
    [anon_sym_yield] = ACTIONS(3753),
    [anon_sym_yield_BANG] = ACTIONS(3751),
    [anon_sym_lazy] = ACTIONS(3753),
    [anon_sym_assert] = ACTIONS(3753),
    [anon_sym_upcast] = ACTIONS(3753),
    [anon_sym_downcast] = ACTIONS(3753),
    [anon_sym_COLON_GT] = ACTIONS(3751),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3751),
    [anon_sym_for] = ACTIONS(3753),
    [anon_sym_while] = ACTIONS(3753),
    [anon_sym_if] = ACTIONS(3753),
    [anon_sym_fun] = ACTIONS(3753),
    [anon_sym_try] = ACTIONS(3753),
    [anon_sym_match] = ACTIONS(3753),
    [anon_sym_match_BANG] = ACTIONS(3751),
    [anon_sym_function] = ACTIONS(3753),
    [anon_sym_LT_DASH] = ACTIONS(3753),
    [anon_sym_DOT_LBRACK] = ACTIONS(3751),
    [anon_sym_LT] = ACTIONS(3751),
    [anon_sym_use] = ACTIONS(3753),
    [anon_sym_use_BANG] = ACTIONS(3751),
    [anon_sym_do_BANG] = ACTIONS(3751),
    [anon_sym_begin] = ACTIONS(3753),
    [anon_sym_LPAREN2] = ACTIONS(3753),
    [anon_sym_or] = ACTIONS(3753),
    [aux_sym_char_token1] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3753),
    [anon_sym_AT_DQUOTE] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [sym_bool] = ACTIONS(3753),
    [sym_unit] = ACTIONS(3751),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3753),
    [sym_op_identifier] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PLUS_DOT] = ACTIONS(3753),
    [anon_sym_DASH_DOT] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3753),
    [anon_sym_AMP_AMP] = ACTIONS(3753),
    [anon_sym_TILDE] = ACTIONS(3751),
    [aux_sym_prefix_op_token1] = ACTIONS(3753),
    [aux_sym_infix_op_token1] = ACTIONS(3751),
    [aux_sym_infix_op_token2] = ACTIONS(3753),
    [anon_sym_PIPE_PIPE] = ACTIONS(3753),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_COLON_EQ] = ACTIONS(3751),
    [anon_sym_DOLLAR] = ACTIONS(3753),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3753),
    [sym_int] = ACTIONS(5182),
    [sym_xint] = ACTIONS(3751),
    [anon_sym_f] = ACTIONS(3753),
    [aux_sym_decimal_token1] = ACTIONS(3753),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3751),
    [sym__newline] = ACTIONS(3751),
    [sym__dedent] = ACTIONS(3751),
  },
  [2683] = {
    [sym_block_comment] = STATE(2683),
    [sym_compiler_directive_decl] = STATE(2683),
    [sym_fsi_directive_decl] = STATE(2683),
    [sym_preproc_line] = STATE(2683),
    [sym_identifier] = ACTIONS(3531),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(3531),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_do] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_null] = ACTIONS(3531),
    [anon_sym_QMARK] = ACTIONS(3531),
    [anon_sym_COLON_QMARK] = ACTIONS(3531),
    [anon_sym_COLON_COLON] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3531),
    [anon_sym_LT_AT] = ACTIONS(3531),
    [anon_sym_LT_AT_AT] = ACTIONS(3531),
    [anon_sym_DOT] = ACTIONS(3531),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3531),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3531),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3531),
    [anon_sym_assert] = ACTIONS(3531),
    [anon_sym_upcast] = ACTIONS(3531),
    [anon_sym_downcast] = ACTIONS(3531),
    [anon_sym_COLON_GT] = ACTIONS(3529),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3531),
    [anon_sym_while] = ACTIONS(3531),
    [anon_sym_if] = ACTIONS(3531),
    [anon_sym_fun] = ACTIONS(3531),
    [anon_sym_DASH_GT] = ACTIONS(3531),
    [anon_sym_try] = ACTIONS(3531),
    [anon_sym_match] = ACTIONS(3531),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3531),
    [anon_sym_LT_DASH] = ACTIONS(3531),
    [anon_sym_DOT_LBRACK] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_GT] = ACTIONS(3531),
    [anon_sym_use] = ACTIONS(3531),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3531),
    [anon_sym_LPAREN2] = ACTIONS(3531),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LT2] = ACTIONS(3531),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_or] = ACTIONS(3531),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3531),
    [anon_sym_DQUOTE] = ACTIONS(3531),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3531),
    [sym_unit] = ACTIONS(3529),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3531),
    [sym_op_identifier] = ACTIONS(3531),
    [anon_sym_PLUS] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(3531),
    [anon_sym_PLUS_DOT] = ACTIONS(3531),
    [anon_sym_DASH_DOT] = ACTIONS(3531),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_AMP_AMP] = ACTIONS(3531),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3531),
    [aux_sym_infix_op_token1] = ACTIONS(3529),
    [aux_sym_infix_op_token2] = ACTIONS(3531),
    [anon_sym_PIPE_PIPE] = ACTIONS(3531),
    [anon_sym_BANG_EQ] = ACTIONS(3531),
    [anon_sym_COLON_EQ] = ACTIONS(3529),
    [anon_sym_DOLLAR] = ACTIONS(3531),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3531),
    [sym_int] = ACTIONS(3531),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [sym__newline] = ACTIONS(3529),
  },
  [2684] = {
    [sym_block_comment] = STATE(2684),
    [sym_compiler_directive_decl] = STATE(2684),
    [sym_fsi_directive_decl] = STATE(2684),
    [sym_preproc_line] = STATE(2684),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_AT_GT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [anon_sym_DOT_LBRACK] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_or] = ACTIONS(3498),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3498),
    [anon_sym_DASH_DOT] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3498),
    [aux_sym_infix_op_token1] = ACTIONS(3496),
    [aux_sym_infix_op_token2] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_COLON_EQ] = ACTIONS(3496),
    [anon_sym_DOLLAR] = ACTIONS(3498),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3498),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
  },
  [2685] = {
    [sym_block_comment] = STATE(2685),
    [sym_compiler_directive_decl] = STATE(2685),
    [sym_fsi_directive_decl] = STATE(2685),
    [sym_preproc_line] = STATE(2685),
    [sym_identifier] = ACTIONS(3535),
    [anon_sym_EQ] = ACTIONS(3533),
    [anon_sym_COLON] = ACTIONS(3535),
    [anon_sym_return] = ACTIONS(3535),
    [anon_sym_do] = ACTIONS(3535),
    [anon_sym_let] = ACTIONS(3535),
    [anon_sym_let_BANG] = ACTIONS(3533),
    [anon_sym_LPAREN] = ACTIONS(3535),
    [anon_sym_COMMA] = ACTIONS(3533),
    [anon_sym_null] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(3535),
    [anon_sym_COLON_QMARK] = ACTIONS(3535),
    [anon_sym_COLON_COLON] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3533),
    [anon_sym_LBRACE] = ACTIONS(3535),
    [anon_sym_LT_AT] = ACTIONS(3535),
    [anon_sym_LT_AT_AT] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(3535),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3533),
    [anon_sym_new] = ACTIONS(3535),
    [anon_sym_return_BANG] = ACTIONS(3533),
    [anon_sym_yield] = ACTIONS(3535),
    [anon_sym_yield_BANG] = ACTIONS(3533),
    [anon_sym_lazy] = ACTIONS(3535),
    [anon_sym_assert] = ACTIONS(3535),
    [anon_sym_upcast] = ACTIONS(3535),
    [anon_sym_downcast] = ACTIONS(3535),
    [anon_sym_COLON_GT] = ACTIONS(3533),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3533),
    [anon_sym_for] = ACTIONS(3535),
    [anon_sym_while] = ACTIONS(3535),
    [anon_sym_if] = ACTIONS(3535),
    [anon_sym_fun] = ACTIONS(3535),
    [anon_sym_DASH_GT] = ACTIONS(3535),
    [anon_sym_try] = ACTIONS(3535),
    [anon_sym_match] = ACTIONS(3535),
    [anon_sym_match_BANG] = ACTIONS(3533),
    [anon_sym_function] = ACTIONS(3535),
    [anon_sym_LT_DASH] = ACTIONS(3535),
    [anon_sym_DOT_LBRACK] = ACTIONS(3533),
    [anon_sym_LT] = ACTIONS(3533),
    [anon_sym_GT] = ACTIONS(3535),
    [anon_sym_use] = ACTIONS(3535),
    [anon_sym_use_BANG] = ACTIONS(3533),
    [anon_sym_do_BANG] = ACTIONS(3533),
    [anon_sym_begin] = ACTIONS(3535),
    [anon_sym_LPAREN2] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(3535),
    [anon_sym_LT2] = ACTIONS(3535),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3533),
    [anon_sym_or] = ACTIONS(3535),
    [aux_sym_char_token1] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE] = ACTIONS(3535),
    [anon_sym_AT_DQUOTE] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [sym_bool] = ACTIONS(3535),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3535),
    [sym_op_identifier] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS_DOT] = ACTIONS(3535),
    [anon_sym_DASH_DOT] = ACTIONS(3535),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(3535),
    [anon_sym_TILDE] = ACTIONS(3533),
    [aux_sym_prefix_op_token1] = ACTIONS(3535),
    [aux_sym_infix_op_token1] = ACTIONS(3533),
    [aux_sym_infix_op_token2] = ACTIONS(3535),
    [anon_sym_PIPE_PIPE] = ACTIONS(3535),
    [anon_sym_BANG_EQ] = ACTIONS(3535),
    [anon_sym_COLON_EQ] = ACTIONS(3533),
    [anon_sym_DOLLAR] = ACTIONS(3535),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3535),
    [sym_int] = ACTIONS(3535),
    [sym_xint] = ACTIONS(3533),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3533),
    [sym__newline] = ACTIONS(3533),
  },
  [2686] = {
    [sym_block_comment] = STATE(2686),
    [sym_compiler_directive_decl] = STATE(2686),
    [sym_fsi_directive_decl] = STATE(2686),
    [sym_preproc_line] = STATE(2686),
    [sym_identifier] = ACTIONS(3519),
    [anon_sym_EQ] = ACTIONS(3517),
    [anon_sym_COLON] = ACTIONS(3519),
    [anon_sym_return] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(3519),
    [anon_sym_let] = ACTIONS(3519),
    [anon_sym_let_BANG] = ACTIONS(3517),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [anon_sym_COMMA] = ACTIONS(3517),
    [anon_sym_null] = ACTIONS(3519),
    [anon_sym_QMARK] = ACTIONS(3519),
    [anon_sym_COLON_QMARK] = ACTIONS(3519),
    [anon_sym_COLON_COLON] = ACTIONS(3517),
    [anon_sym_AMP] = ACTIONS(3519),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_LT_AT] = ACTIONS(3519),
    [anon_sym_AT_GT] = ACTIONS(3519),
    [anon_sym_LT_AT_AT] = ACTIONS(3519),
    [anon_sym_DOT] = ACTIONS(3519),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3519),
    [anon_sym_return_BANG] = ACTIONS(3517),
    [anon_sym_yield] = ACTIONS(3519),
    [anon_sym_yield_BANG] = ACTIONS(3517),
    [anon_sym_lazy] = ACTIONS(3519),
    [anon_sym_assert] = ACTIONS(3519),
    [anon_sym_upcast] = ACTIONS(3519),
    [anon_sym_downcast] = ACTIONS(3519),
    [anon_sym_COLON_GT] = ACTIONS(3517),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3517),
    [anon_sym_for] = ACTIONS(3519),
    [anon_sym_while] = ACTIONS(3519),
    [anon_sym_if] = ACTIONS(3519),
    [anon_sym_fun] = ACTIONS(3519),
    [anon_sym_DASH_GT] = ACTIONS(3519),
    [anon_sym_try] = ACTIONS(3519),
    [anon_sym_match] = ACTIONS(3519),
    [anon_sym_match_BANG] = ACTIONS(3517),
    [anon_sym_function] = ACTIONS(3519),
    [anon_sym_LT_DASH] = ACTIONS(3519),
    [anon_sym_DOT_LBRACK] = ACTIONS(3517),
    [anon_sym_LT] = ACTIONS(3517),
    [anon_sym_use] = ACTIONS(3519),
    [anon_sym_use_BANG] = ACTIONS(3517),
    [anon_sym_do_BANG] = ACTIONS(3517),
    [anon_sym_begin] = ACTIONS(3519),
    [anon_sym_LPAREN2] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_LT2] = ACTIONS(3519),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3517),
    [anon_sym_or] = ACTIONS(3519),
    [aux_sym_char_token1] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [anon_sym_AT_DQUOTE] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [sym_bool] = ACTIONS(3519),
    [sym_unit] = ACTIONS(3517),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3519),
    [sym_op_identifier] = ACTIONS(3519),
    [anon_sym_PLUS] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_DOT] = ACTIONS(3519),
    [anon_sym_DASH_DOT] = ACTIONS(3519),
    [anon_sym_PERCENT] = ACTIONS(3519),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3517),
    [aux_sym_prefix_op_token1] = ACTIONS(3519),
    [aux_sym_infix_op_token1] = ACTIONS(3517),
    [aux_sym_infix_op_token2] = ACTIONS(3519),
    [anon_sym_PIPE_PIPE] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_COLON_EQ] = ACTIONS(3517),
    [anon_sym_DOLLAR] = ACTIONS(3519),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3519),
    [sym_int] = ACTIONS(3519),
    [sym_xint] = ACTIONS(3517),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3517),
    [sym__newline] = ACTIONS(3517),
  },
  [2687] = {
    [sym_block_comment] = STATE(2687),
    [sym_compiler_directive_decl] = STATE(2687),
    [sym_fsi_directive_decl] = STATE(2687),
    [sym_preproc_line] = STATE(2687),
    [sym_identifier] = ACTIONS(3539),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3539),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_do] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3539),
    [anon_sym_let_BANG] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_null] = ACTIONS(3539),
    [anon_sym_QMARK] = ACTIONS(3539),
    [anon_sym_COLON_QMARK] = ACTIONS(3539),
    [anon_sym_COLON_COLON] = ACTIONS(3537),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3537),
    [anon_sym_LBRACE] = ACTIONS(3539),
    [anon_sym_LT_AT] = ACTIONS(3539),
    [anon_sym_AT_GT] = ACTIONS(3539),
    [anon_sym_LT_AT_AT] = ACTIONS(3539),
    [anon_sym_DOT] = ACTIONS(3539),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3537),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_return_BANG] = ACTIONS(3537),
    [anon_sym_yield] = ACTIONS(3539),
    [anon_sym_yield_BANG] = ACTIONS(3537),
    [anon_sym_lazy] = ACTIONS(3539),
    [anon_sym_assert] = ACTIONS(3539),
    [anon_sym_upcast] = ACTIONS(3539),
    [anon_sym_downcast] = ACTIONS(3539),
    [anon_sym_COLON_GT] = ACTIONS(3537),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3537),
    [anon_sym_for] = ACTIONS(3539),
    [anon_sym_while] = ACTIONS(3539),
    [anon_sym_if] = ACTIONS(3539),
    [anon_sym_fun] = ACTIONS(3539),
    [anon_sym_DASH_GT] = ACTIONS(3539),
    [anon_sym_try] = ACTIONS(3539),
    [anon_sym_match] = ACTIONS(3539),
    [anon_sym_match_BANG] = ACTIONS(3537),
    [anon_sym_function] = ACTIONS(3539),
    [anon_sym_LT_DASH] = ACTIONS(3539),
    [anon_sym_DOT_LBRACK] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_use] = ACTIONS(3539),
    [anon_sym_use_BANG] = ACTIONS(3537),
    [anon_sym_do_BANG] = ACTIONS(3537),
    [anon_sym_begin] = ACTIONS(3539),
    [anon_sym_LPAREN2] = ACTIONS(3539),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_LT2] = ACTIONS(3539),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_or] = ACTIONS(3539),
    [aux_sym_char_token1] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3539),
    [anon_sym_DQUOTE] = ACTIONS(3539),
    [anon_sym_AT_DQUOTE] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [sym_bool] = ACTIONS(3539),
    [sym_unit] = ACTIONS(3537),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3539),
    [sym_op_identifier] = ACTIONS(3539),
    [anon_sym_PLUS] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(3539),
    [anon_sym_PLUS_DOT] = ACTIONS(3539),
    [anon_sym_DASH_DOT] = ACTIONS(3539),
    [anon_sym_PERCENT] = ACTIONS(3539),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_TILDE] = ACTIONS(3537),
    [aux_sym_prefix_op_token1] = ACTIONS(3539),
    [aux_sym_infix_op_token1] = ACTIONS(3537),
    [aux_sym_infix_op_token2] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3539),
    [anon_sym_BANG_EQ] = ACTIONS(3539),
    [anon_sym_COLON_EQ] = ACTIONS(3537),
    [anon_sym_DOLLAR] = ACTIONS(3539),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3539),
    [sym_int] = ACTIONS(3539),
    [sym_xint] = ACTIONS(3537),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3537),
    [sym__newline] = ACTIONS(3537),
  },
  [2688] = {
    [sym_block_comment] = STATE(2688),
    [sym_compiler_directive_decl] = STATE(2688),
    [sym_fsi_directive_decl] = STATE(2688),
    [sym_preproc_line] = STATE(2688),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_COLON] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3515),
    [anon_sym_AT_AT_GT] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(3513),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_LT_DASH] = ACTIONS(3515),
    [anon_sym_DOT_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_or] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3515),
    [anon_sym_DASH_DOT] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3515),
    [aux_sym_infix_op_token1] = ACTIONS(3513),
    [aux_sym_infix_op_token2] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3515),
    [anon_sym_COLON_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(3515),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3515),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
  },
  [2689] = {
    [sym_block_comment] = STATE(2689),
    [sym_compiler_directive_decl] = STATE(2689),
    [sym_fsi_directive_decl] = STATE(2689),
    [sym_preproc_line] = STATE(2689),
    [sym_identifier] = ACTIONS(3531),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(3531),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_do] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_null] = ACTIONS(3531),
    [anon_sym_QMARK] = ACTIONS(3531),
    [anon_sym_COLON_QMARK] = ACTIONS(3531),
    [anon_sym_COLON_COLON] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3531),
    [anon_sym_LT_AT] = ACTIONS(3531),
    [anon_sym_LT_AT_AT] = ACTIONS(3531),
    [anon_sym_DOT] = ACTIONS(3531),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3531),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3531),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3531),
    [anon_sym_assert] = ACTIONS(3531),
    [anon_sym_upcast] = ACTIONS(3531),
    [anon_sym_downcast] = ACTIONS(3531),
    [anon_sym_COLON_GT] = ACTIONS(3529),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3529),
    [anon_sym_for] = ACTIONS(3531),
    [anon_sym_while] = ACTIONS(3531),
    [anon_sym_if] = ACTIONS(3531),
    [anon_sym_fun] = ACTIONS(3531),
    [anon_sym_DASH_GT] = ACTIONS(3531),
    [anon_sym_try] = ACTIONS(3531),
    [anon_sym_match] = ACTIONS(3531),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3531),
    [anon_sym_LT_DASH] = ACTIONS(3531),
    [anon_sym_DOT_LBRACK] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_use] = ACTIONS(3531),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_DOT_DOT] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3531),
    [anon_sym_LPAREN2] = ACTIONS(3531),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LT2] = ACTIONS(3531),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_or] = ACTIONS(3531),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3531),
    [anon_sym_DQUOTE] = ACTIONS(3531),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3531),
    [sym_unit] = ACTIONS(3529),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3531),
    [sym_op_identifier] = ACTIONS(3531),
    [anon_sym_PLUS] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(3531),
    [anon_sym_PLUS_DOT] = ACTIONS(3531),
    [anon_sym_DASH_DOT] = ACTIONS(3531),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_AMP_AMP] = ACTIONS(3531),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3531),
    [aux_sym_infix_op_token1] = ACTIONS(3529),
    [aux_sym_infix_op_token2] = ACTIONS(3531),
    [anon_sym_PIPE_PIPE] = ACTIONS(3531),
    [anon_sym_BANG_EQ] = ACTIONS(3531),
    [anon_sym_COLON_EQ] = ACTIONS(3529),
    [anon_sym_DOLLAR] = ACTIONS(3531),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3531),
    [sym_int] = ACTIONS(3531),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [sym__newline] = ACTIONS(3529),
  },
  [2690] = {
    [sym_block_comment] = STATE(2690),
    [sym_compiler_directive_decl] = STATE(2690),
    [sym_fsi_directive_decl] = STATE(2690),
    [sym_preproc_line] = STATE(2690),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_QMARK] = ACTIONS(3480),
    [anon_sym_COLON_COLON] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_LT_DASH] = ACTIONS(3480),
    [anon_sym_DOT_LBRACK] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_GT] = ACTIONS(3480),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_or] = ACTIONS(3480),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3480),
    [anon_sym_DASH_DOT] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3480),
    [aux_sym_infix_op_token1] = ACTIONS(3478),
    [aux_sym_infix_op_token2] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3480),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
  },
  [2691] = {
    [sym_block_comment] = STATE(2691),
    [sym_compiler_directive_decl] = STATE(2691),
    [sym_fsi_directive_decl] = STATE(2691),
    [sym_preproc_line] = STATE(2691),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_COLON] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(3513),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_LT_DASH] = ACTIONS(3515),
    [anon_sym_DOT_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_DOT_DOT] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_or] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3515),
    [anon_sym_DASH_DOT] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3515),
    [aux_sym_infix_op_token1] = ACTIONS(3513),
    [aux_sym_infix_op_token2] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3515),
    [anon_sym_COLON_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(3515),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3515),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
  },
  [2692] = {
    [sym_block_comment] = STATE(2692),
    [sym_compiler_directive_decl] = STATE(2692),
    [sym_fsi_directive_decl] = STATE(2692),
    [sym_preproc_line] = STATE(2692),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_EQ] = ACTIONS(3560),
    [anon_sym_COLON] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_let_BANG] = ACTIONS(3560),
    [anon_sym_LPAREN] = ACTIONS(3562),
    [anon_sym_COMMA] = ACTIONS(3560),
    [anon_sym_null] = ACTIONS(3562),
    [anon_sym_QMARK] = ACTIONS(3562),
    [anon_sym_COLON_QMARK] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3560),
    [anon_sym_LBRACE] = ACTIONS(3562),
    [anon_sym_LT_AT] = ACTIONS(3562),
    [anon_sym_LT_AT_AT] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(3562),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3560),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_return_BANG] = ACTIONS(3560),
    [anon_sym_yield] = ACTIONS(3562),
    [anon_sym_yield_BANG] = ACTIONS(3560),
    [anon_sym_lazy] = ACTIONS(3562),
    [anon_sym_assert] = ACTIONS(3562),
    [anon_sym_upcast] = ACTIONS(3562),
    [anon_sym_downcast] = ACTIONS(3562),
    [anon_sym_COLON_GT] = ACTIONS(3560),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3560),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_fun] = ACTIONS(3562),
    [anon_sym_DASH_GT] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_match] = ACTIONS(3562),
    [anon_sym_match_BANG] = ACTIONS(3560),
    [anon_sym_function] = ACTIONS(3562),
    [anon_sym_LT_DASH] = ACTIONS(3562),
    [anon_sym_DOT_LBRACK] = ACTIONS(3560),
    [anon_sym_LT] = ACTIONS(3560),
    [anon_sym_GT] = ACTIONS(3562),
    [anon_sym_use] = ACTIONS(3562),
    [anon_sym_use_BANG] = ACTIONS(3560),
    [anon_sym_do_BANG] = ACTIONS(3560),
    [anon_sym_begin] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3562),
    [anon_sym_LT2] = ACTIONS(3562),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3560),
    [anon_sym_or] = ACTIONS(3562),
    [aux_sym_char_token1] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(3562),
    [anon_sym_AT_DQUOTE] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [sym_bool] = ACTIONS(3562),
    [sym_unit] = ACTIONS(3560),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3562),
    [sym_op_identifier] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS_DOT] = ACTIONS(3562),
    [anon_sym_DASH_DOT] = ACTIONS(3562),
    [anon_sym_PERCENT] = ACTIONS(3562),
    [anon_sym_AMP_AMP] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3560),
    [aux_sym_prefix_op_token1] = ACTIONS(3562),
    [aux_sym_infix_op_token1] = ACTIONS(3560),
    [aux_sym_infix_op_token2] = ACTIONS(3562),
    [anon_sym_PIPE_PIPE] = ACTIONS(3562),
    [anon_sym_BANG_EQ] = ACTIONS(3562),
    [anon_sym_COLON_EQ] = ACTIONS(3560),
    [anon_sym_DOLLAR] = ACTIONS(3562),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3562),
    [sym_int] = ACTIONS(3562),
    [sym_xint] = ACTIONS(3560),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3560),
    [sym__newline] = ACTIONS(3560),
  },
  [2693] = {
    [sym_block_comment] = STATE(2693),
    [sym_compiler_directive_decl] = STATE(2693),
    [sym_fsi_directive_decl] = STATE(2693),
    [sym_preproc_line] = STATE(2693),
    [sym_identifier] = ACTIONS(3732),
    [anon_sym_EQ] = ACTIONS(3730),
    [anon_sym_COLON] = ACTIONS(3732),
    [anon_sym_return] = ACTIONS(3732),
    [anon_sym_do] = ACTIONS(3732),
    [anon_sym_let] = ACTIONS(3732),
    [anon_sym_let_BANG] = ACTIONS(3730),
    [anon_sym_as] = ACTIONS(3732),
    [anon_sym_LPAREN] = ACTIONS(3732),
    [anon_sym_COMMA] = ACTIONS(3730),
    [anon_sym_null] = ACTIONS(3732),
    [anon_sym_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_LBRACK] = ACTIONS(3732),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3730),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_LT_AT] = ACTIONS(3732),
    [anon_sym_LT_AT_AT] = ACTIONS(3732),
    [anon_sym_DOT] = ACTIONS(3732),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3730),
    [anon_sym_new] = ACTIONS(3732),
    [anon_sym_with] = ACTIONS(3732),
    [anon_sym_return_BANG] = ACTIONS(3730),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_yield_BANG] = ACTIONS(3730),
    [anon_sym_lazy] = ACTIONS(3732),
    [anon_sym_assert] = ACTIONS(3732),
    [anon_sym_upcast] = ACTIONS(3732),
    [anon_sym_downcast] = ACTIONS(3732),
    [anon_sym_COLON_GT] = ACTIONS(3730),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3730),
    [anon_sym_for] = ACTIONS(3732),
    [anon_sym_while] = ACTIONS(3732),
    [anon_sym_else] = ACTIONS(3732),
    [anon_sym_elif] = ACTIONS(3732),
    [anon_sym_if] = ACTIONS(3732),
    [anon_sym_fun] = ACTIONS(3732),
    [anon_sym_try] = ACTIONS(3732),
    [anon_sym_match] = ACTIONS(3732),
    [anon_sym_match_BANG] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3732),
    [anon_sym_LT_DASH] = ACTIONS(3732),
    [anon_sym_DOT_LBRACK] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3730),
    [anon_sym_use] = ACTIONS(3732),
    [anon_sym_use_BANG] = ACTIONS(3730),
    [anon_sym_do_BANG] = ACTIONS(3730),
    [anon_sym_begin] = ACTIONS(3732),
    [anon_sym_LPAREN2] = ACTIONS(3732),
    [anon_sym_or] = ACTIONS(3732),
    [aux_sym_char_token1] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3732),
    [anon_sym_DQUOTE] = ACTIONS(3732),
    [anon_sym_AT_DQUOTE] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [sym_bool] = ACTIONS(3732),
    [sym_unit] = ACTIONS(3730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3732),
    [sym_op_identifier] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PLUS_DOT] = ACTIONS(3732),
    [anon_sym_DASH_DOT] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3732),
    [anon_sym_AMP_AMP] = ACTIONS(3732),
    [anon_sym_TILDE] = ACTIONS(3730),
    [aux_sym_prefix_op_token1] = ACTIONS(3732),
    [aux_sym_infix_op_token1] = ACTIONS(3730),
    [aux_sym_infix_op_token2] = ACTIONS(3732),
    [anon_sym_PIPE_PIPE] = ACTIONS(3732),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_COLON_EQ] = ACTIONS(3730),
    [anon_sym_DOLLAR] = ACTIONS(3732),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3732),
    [sym_int] = ACTIONS(3732),
    [sym_xint] = ACTIONS(3730),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3730),
    [sym__newline] = ACTIONS(3730),
    [sym__dedent] = ACTIONS(3730),
  },
  [2694] = {
    [sym_elif_expression] = STATE(2826),
    [sym_block_comment] = STATE(2694),
    [sym_compiler_directive_decl] = STATE(2694),
    [sym_fsi_directive_decl] = STATE(2694),
    [sym_preproc_line] = STATE(2694),
    [aux_sym_if_expression_repeat1] = STATE(2694),
    [sym_identifier] = ACTIONS(3555),
    [anon_sym_EQ] = ACTIONS(3553),
    [anon_sym_COLON] = ACTIONS(3555),
    [anon_sym_return] = ACTIONS(3555),
    [anon_sym_do] = ACTIONS(3555),
    [anon_sym_let] = ACTIONS(3555),
    [anon_sym_let_BANG] = ACTIONS(3553),
    [anon_sym_LPAREN] = ACTIONS(3555),
    [anon_sym_COMMA] = ACTIONS(3553),
    [anon_sym_null] = ACTIONS(3555),
    [anon_sym_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_COLON] = ACTIONS(3553),
    [anon_sym_AMP] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(3555),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3553),
    [anon_sym_LBRACE] = ACTIONS(3555),
    [anon_sym_LT_AT] = ACTIONS(3555),
    [anon_sym_LT_AT_AT] = ACTIONS(3555),
    [anon_sym_DOT] = ACTIONS(3555),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3553),
    [anon_sym_new] = ACTIONS(3555),
    [anon_sym_return_BANG] = ACTIONS(3553),
    [anon_sym_yield] = ACTIONS(3555),
    [anon_sym_yield_BANG] = ACTIONS(3553),
    [anon_sym_lazy] = ACTIONS(3555),
    [anon_sym_assert] = ACTIONS(3555),
    [anon_sym_upcast] = ACTIONS(3555),
    [anon_sym_downcast] = ACTIONS(3555),
    [anon_sym_COLON_GT] = ACTIONS(3553),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3553),
    [anon_sym_for] = ACTIONS(3555),
    [anon_sym_while] = ACTIONS(3555),
    [anon_sym_else] = ACTIONS(3555),
    [anon_sym_elif] = ACTIONS(5184),
    [anon_sym_if] = ACTIONS(3555),
    [anon_sym_fun] = ACTIONS(3555),
    [anon_sym_try] = ACTIONS(3555),
    [anon_sym_match] = ACTIONS(3555),
    [anon_sym_match_BANG] = ACTIONS(3553),
    [anon_sym_function] = ACTIONS(3555),
    [anon_sym_LT_DASH] = ACTIONS(3555),
    [anon_sym_DOT_LBRACK] = ACTIONS(3553),
    [anon_sym_LT] = ACTIONS(3553),
    [anon_sym_use] = ACTIONS(3555),
    [anon_sym_use_BANG] = ACTIONS(3553),
    [anon_sym_do_BANG] = ACTIONS(3553),
    [anon_sym_DOT_DOT] = ACTIONS(3553),
    [anon_sym_begin] = ACTIONS(3555),
    [anon_sym_LPAREN2] = ACTIONS(3555),
    [anon_sym_or] = ACTIONS(3555),
    [aux_sym_char_token1] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3555),
    [anon_sym_DQUOTE] = ACTIONS(3555),
    [anon_sym_AT_DQUOTE] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [sym_bool] = ACTIONS(3555),
    [sym_unit] = ACTIONS(3553),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3555),
    [sym_op_identifier] = ACTIONS(3555),
    [anon_sym_PLUS] = ACTIONS(3555),
    [anon_sym_DASH] = ACTIONS(3555),
    [anon_sym_PLUS_DOT] = ACTIONS(3555),
    [anon_sym_DASH_DOT] = ACTIONS(3555),
    [anon_sym_PERCENT] = ACTIONS(3555),
    [anon_sym_AMP_AMP] = ACTIONS(3555),
    [anon_sym_TILDE] = ACTIONS(3553),
    [aux_sym_prefix_op_token1] = ACTIONS(3555),
    [aux_sym_infix_op_token1] = ACTIONS(3553),
    [aux_sym_infix_op_token2] = ACTIONS(3555),
    [anon_sym_PIPE_PIPE] = ACTIONS(3555),
    [anon_sym_BANG_EQ] = ACTIONS(3555),
    [anon_sym_COLON_EQ] = ACTIONS(3553),
    [anon_sym_DOLLAR] = ACTIONS(3555),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3555),
    [sym_int] = ACTIONS(3555),
    [sym_xint] = ACTIONS(3553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3553),
    [sym__newline] = ACTIONS(3553),
  },
  [2695] = {
    [sym_block_comment] = STATE(2695),
    [sym_compiler_directive_decl] = STATE(2695),
    [sym_fsi_directive_decl] = STATE(2695),
    [sym_preproc_line] = STATE(2695),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [anon_sym_as] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_with] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(5187),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_DOT_DOT] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
    [sym__dedent] = ACTIONS(3683),
  },
  [2696] = {
    [sym_block_comment] = STATE(2696),
    [sym_compiler_directive_decl] = STATE(2696),
    [sym_fsi_directive_decl] = STATE(2696),
    [sym_preproc_line] = STATE(2696),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_COLON] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(3513),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_LT_DASH] = ACTIONS(3515),
    [anon_sym_DOT_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_DOT_DOT] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_or] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3515),
    [anon_sym_DASH_DOT] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3515),
    [aux_sym_infix_op_token1] = ACTIONS(3513),
    [aux_sym_infix_op_token2] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3515),
    [anon_sym_COLON_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(3515),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3515),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
  },
  [2697] = {
    [sym_block_comment] = STATE(2697),
    [sym_compiler_directive_decl] = STATE(2697),
    [sym_fsi_directive_decl] = STATE(2697),
    [sym_preproc_line] = STATE(2697),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [anon_sym_as] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_with] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [aux_sym_float_token1] = ACTIONS(5189),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
  },
  [2698] = {
    [sym_block_comment] = STATE(2698),
    [sym_compiler_directive_decl] = STATE(2698),
    [sym_fsi_directive_decl] = STATE(2698),
    [sym_preproc_line] = STATE(2698),
    [sym_identifier] = ACTIONS(3505),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_COLON] = ACTIONS(3505),
    [anon_sym_return] = ACTIONS(3505),
    [anon_sym_do] = ACTIONS(3505),
    [anon_sym_let] = ACTIONS(3505),
    [anon_sym_let_BANG] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3505),
    [anon_sym_COMMA] = ACTIONS(3503),
    [anon_sym_null] = ACTIONS(3505),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_COLON_QMARK] = ACTIONS(3505),
    [anon_sym_COLON_COLON] = ACTIONS(3503),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3503),
    [anon_sym_LBRACE] = ACTIONS(3505),
    [anon_sym_LT_AT] = ACTIONS(3505),
    [anon_sym_LT_AT_AT] = ACTIONS(3505),
    [anon_sym_DOT] = ACTIONS(3505),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3503),
    [anon_sym_new] = ACTIONS(3505),
    [anon_sym_return_BANG] = ACTIONS(3503),
    [anon_sym_yield] = ACTIONS(3505),
    [anon_sym_yield_BANG] = ACTIONS(3503),
    [anon_sym_lazy] = ACTIONS(3505),
    [anon_sym_assert] = ACTIONS(3505),
    [anon_sym_upcast] = ACTIONS(3505),
    [anon_sym_downcast] = ACTIONS(3505),
    [anon_sym_COLON_GT] = ACTIONS(3503),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3503),
    [anon_sym_for] = ACTIONS(3505),
    [anon_sym_while] = ACTIONS(3505),
    [anon_sym_if] = ACTIONS(3505),
    [anon_sym_fun] = ACTIONS(3505),
    [anon_sym_DASH_GT] = ACTIONS(3505),
    [anon_sym_try] = ACTIONS(3505),
    [anon_sym_match] = ACTIONS(3505),
    [anon_sym_match_BANG] = ACTIONS(3503),
    [anon_sym_function] = ACTIONS(3505),
    [anon_sym_LT_DASH] = ACTIONS(3505),
    [anon_sym_DOT_LBRACK] = ACTIONS(3503),
    [anon_sym_LT] = ACTIONS(3503),
    [anon_sym_use] = ACTIONS(3505),
    [anon_sym_use_BANG] = ACTIONS(3503),
    [anon_sym_do_BANG] = ACTIONS(3503),
    [anon_sym_DOT_DOT] = ACTIONS(3503),
    [anon_sym_begin] = ACTIONS(3505),
    [anon_sym_LPAREN2] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3505),
    [anon_sym_LT2] = ACTIONS(5191),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_or] = ACTIONS(3505),
    [aux_sym_char_token1] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3505),
    [anon_sym_DQUOTE] = ACTIONS(3505),
    [anon_sym_AT_DQUOTE] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [sym_bool] = ACTIONS(3505),
    [sym_unit] = ACTIONS(3503),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3505),
    [sym_op_identifier] = ACTIONS(3505),
    [anon_sym_PLUS] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3505),
    [anon_sym_PLUS_DOT] = ACTIONS(3505),
    [anon_sym_DASH_DOT] = ACTIONS(3505),
    [anon_sym_PERCENT] = ACTIONS(3505),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3503),
    [aux_sym_prefix_op_token1] = ACTIONS(3505),
    [aux_sym_infix_op_token1] = ACTIONS(3503),
    [aux_sym_infix_op_token2] = ACTIONS(3505),
    [anon_sym_PIPE_PIPE] = ACTIONS(3505),
    [anon_sym_BANG_EQ] = ACTIONS(3505),
    [anon_sym_COLON_EQ] = ACTIONS(3503),
    [anon_sym_DOLLAR] = ACTIONS(3505),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3505),
    [sym_int] = ACTIONS(3505),
    [sym_xint] = ACTIONS(3503),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3503),
    [sym__newline] = ACTIONS(3503),
  },
  [2699] = {
    [sym_block_comment] = STATE(2699),
    [sym_compiler_directive_decl] = STATE(2699),
    [sym_fsi_directive_decl] = STATE(2699),
    [sym_preproc_line] = STATE(2699),
    [sym_identifier] = ACTIONS(3551),
    [anon_sym_EQ] = ACTIONS(3549),
    [anon_sym_COLON] = ACTIONS(3551),
    [anon_sym_return] = ACTIONS(3551),
    [anon_sym_do] = ACTIONS(3551),
    [anon_sym_let] = ACTIONS(3551),
    [anon_sym_let_BANG] = ACTIONS(3549),
    [anon_sym_LPAREN] = ACTIONS(3551),
    [anon_sym_COMMA] = ACTIONS(3549),
    [anon_sym_null] = ACTIONS(3551),
    [anon_sym_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_COLON] = ACTIONS(3549),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(3551),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3549),
    [anon_sym_LBRACE] = ACTIONS(3551),
    [anon_sym_LT_AT] = ACTIONS(3551),
    [anon_sym_LT_AT_AT] = ACTIONS(3551),
    [anon_sym_DOT] = ACTIONS(3551),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3549),
    [anon_sym_new] = ACTIONS(3551),
    [anon_sym_return_BANG] = ACTIONS(3549),
    [anon_sym_yield] = ACTIONS(3551),
    [anon_sym_yield_BANG] = ACTIONS(3549),
    [anon_sym_lazy] = ACTIONS(3551),
    [anon_sym_assert] = ACTIONS(3551),
    [anon_sym_upcast] = ACTIONS(3551),
    [anon_sym_downcast] = ACTIONS(3551),
    [anon_sym_COLON_GT] = ACTIONS(3549),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3549),
    [anon_sym_for] = ACTIONS(3551),
    [anon_sym_while] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(3551),
    [anon_sym_fun] = ACTIONS(3551),
    [anon_sym_DASH_GT] = ACTIONS(3551),
    [anon_sym_try] = ACTIONS(3551),
    [anon_sym_match] = ACTIONS(3551),
    [anon_sym_match_BANG] = ACTIONS(3549),
    [anon_sym_function] = ACTIONS(3551),
    [anon_sym_LT_DASH] = ACTIONS(3551),
    [anon_sym_DOT_LBRACK] = ACTIONS(3549),
    [anon_sym_LT] = ACTIONS(3549),
    [anon_sym_use] = ACTIONS(3551),
    [anon_sym_use_BANG] = ACTIONS(3549),
    [anon_sym_do_BANG] = ACTIONS(3549),
    [anon_sym_DOT_DOT] = ACTIONS(3549),
    [anon_sym_begin] = ACTIONS(3551),
    [anon_sym_LPAREN2] = ACTIONS(3551),
    [anon_sym_STAR] = ACTIONS(3551),
    [anon_sym_LT2] = ACTIONS(3551),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3549),
    [anon_sym_or] = ACTIONS(3551),
    [aux_sym_char_token1] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [anon_sym_AT_DQUOTE] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [sym_bool] = ACTIONS(3551),
    [sym_unit] = ACTIONS(3549),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3551),
    [sym_op_identifier] = ACTIONS(3551),
    [anon_sym_PLUS] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(3551),
    [anon_sym_PLUS_DOT] = ACTIONS(3551),
    [anon_sym_DASH_DOT] = ACTIONS(3551),
    [anon_sym_PERCENT] = ACTIONS(3551),
    [anon_sym_AMP_AMP] = ACTIONS(3551),
    [anon_sym_TILDE] = ACTIONS(3549),
    [aux_sym_prefix_op_token1] = ACTIONS(3551),
    [aux_sym_infix_op_token1] = ACTIONS(3549),
    [aux_sym_infix_op_token2] = ACTIONS(3551),
    [anon_sym_PIPE_PIPE] = ACTIONS(3551),
    [anon_sym_BANG_EQ] = ACTIONS(3551),
    [anon_sym_COLON_EQ] = ACTIONS(3549),
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3551),
    [sym_int] = ACTIONS(3551),
    [sym_xint] = ACTIONS(3549),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3549),
    [sym__newline] = ACTIONS(3549),
  },
  [2700] = {
    [sym_block_comment] = STATE(2700),
    [sym_compiler_directive_decl] = STATE(2700),
    [sym_fsi_directive_decl] = STATE(2700),
    [sym_preproc_line] = STATE(2700),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_as] = ACTIONS(3700),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_else] = ACTIONS(3700),
    [anon_sym_elif] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
    [sym__dedent] = ACTIONS(3698),
  },
  [2701] = {
    [sym_block_comment] = STATE(2701),
    [sym_compiler_directive_decl] = STATE(2701),
    [sym_fsi_directive_decl] = STATE(2701),
    [sym_preproc_line] = STATE(2701),
    [sym_identifier] = ACTIONS(3539),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3539),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_do] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3539),
    [anon_sym_let_BANG] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_null] = ACTIONS(3539),
    [anon_sym_QMARK] = ACTIONS(3539),
    [anon_sym_COLON_QMARK] = ACTIONS(3539),
    [anon_sym_COLON_COLON] = ACTIONS(3537),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3537),
    [anon_sym_LBRACE] = ACTIONS(3539),
    [anon_sym_LT_AT] = ACTIONS(3539),
    [anon_sym_LT_AT_AT] = ACTIONS(3539),
    [anon_sym_AT_AT_GT] = ACTIONS(3539),
    [anon_sym_DOT] = ACTIONS(3539),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3537),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_return_BANG] = ACTIONS(3537),
    [anon_sym_yield] = ACTIONS(3539),
    [anon_sym_yield_BANG] = ACTIONS(3537),
    [anon_sym_lazy] = ACTIONS(3539),
    [anon_sym_assert] = ACTIONS(3539),
    [anon_sym_upcast] = ACTIONS(3539),
    [anon_sym_downcast] = ACTIONS(3539),
    [anon_sym_COLON_GT] = ACTIONS(3537),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3537),
    [anon_sym_for] = ACTIONS(3539),
    [anon_sym_while] = ACTIONS(3539),
    [anon_sym_if] = ACTIONS(3539),
    [anon_sym_fun] = ACTIONS(3539),
    [anon_sym_DASH_GT] = ACTIONS(3539),
    [anon_sym_try] = ACTIONS(3539),
    [anon_sym_match] = ACTIONS(3539),
    [anon_sym_match_BANG] = ACTIONS(3537),
    [anon_sym_function] = ACTIONS(3539),
    [anon_sym_LT_DASH] = ACTIONS(3539),
    [anon_sym_DOT_LBRACK] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_use] = ACTIONS(3539),
    [anon_sym_use_BANG] = ACTIONS(3537),
    [anon_sym_do_BANG] = ACTIONS(3537),
    [anon_sym_begin] = ACTIONS(3539),
    [anon_sym_LPAREN2] = ACTIONS(3539),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_LT2] = ACTIONS(3539),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_or] = ACTIONS(3539),
    [aux_sym_char_token1] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3539),
    [anon_sym_DQUOTE] = ACTIONS(3539),
    [anon_sym_AT_DQUOTE] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [sym_bool] = ACTIONS(3539),
    [sym_unit] = ACTIONS(3537),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3539),
    [sym_op_identifier] = ACTIONS(3539),
    [anon_sym_PLUS] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(3539),
    [anon_sym_PLUS_DOT] = ACTIONS(3539),
    [anon_sym_DASH_DOT] = ACTIONS(3539),
    [anon_sym_PERCENT] = ACTIONS(3539),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_TILDE] = ACTIONS(3537),
    [aux_sym_prefix_op_token1] = ACTIONS(3539),
    [aux_sym_infix_op_token1] = ACTIONS(3537),
    [aux_sym_infix_op_token2] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3539),
    [anon_sym_BANG_EQ] = ACTIONS(3539),
    [anon_sym_COLON_EQ] = ACTIONS(3537),
    [anon_sym_DOLLAR] = ACTIONS(3539),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3539),
    [sym_int] = ACTIONS(3539),
    [sym_xint] = ACTIONS(3537),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3537),
    [sym__newline] = ACTIONS(3537),
  },
  [2702] = {
    [sym_block_comment] = STATE(2702),
    [sym_compiler_directive_decl] = STATE(2702),
    [sym_fsi_directive_decl] = STATE(2702),
    [sym_preproc_line] = STATE(2702),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_EQ] = ACTIONS(3560),
    [anon_sym_COLON] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_let_BANG] = ACTIONS(3560),
    [anon_sym_LPAREN] = ACTIONS(3562),
    [anon_sym_COMMA] = ACTIONS(3560),
    [anon_sym_null] = ACTIONS(3562),
    [anon_sym_QMARK] = ACTIONS(3562),
    [anon_sym_COLON_QMARK] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3560),
    [anon_sym_LBRACE] = ACTIONS(3562),
    [anon_sym_LT_AT] = ACTIONS(3562),
    [anon_sym_LT_AT_AT] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(3562),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3560),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_return_BANG] = ACTIONS(3560),
    [anon_sym_yield] = ACTIONS(3562),
    [anon_sym_yield_BANG] = ACTIONS(3560),
    [anon_sym_lazy] = ACTIONS(3562),
    [anon_sym_assert] = ACTIONS(3562),
    [anon_sym_upcast] = ACTIONS(3562),
    [anon_sym_downcast] = ACTIONS(3562),
    [anon_sym_COLON_GT] = ACTIONS(3560),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3560),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_fun] = ACTIONS(3562),
    [anon_sym_DASH_GT] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_match] = ACTIONS(3562),
    [anon_sym_match_BANG] = ACTIONS(3560),
    [anon_sym_function] = ACTIONS(3562),
    [anon_sym_LT_DASH] = ACTIONS(3562),
    [anon_sym_DOT_LBRACK] = ACTIONS(3560),
    [anon_sym_LT] = ACTIONS(3560),
    [anon_sym_use] = ACTIONS(3562),
    [anon_sym_use_BANG] = ACTIONS(3560),
    [anon_sym_do_BANG] = ACTIONS(3560),
    [anon_sym_DOT_DOT] = ACTIONS(3560),
    [anon_sym_begin] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3562),
    [anon_sym_LT2] = ACTIONS(3562),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3560),
    [anon_sym_or] = ACTIONS(3562),
    [aux_sym_char_token1] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(3562),
    [anon_sym_AT_DQUOTE] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [sym_bool] = ACTIONS(3562),
    [sym_unit] = ACTIONS(3560),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3562),
    [sym_op_identifier] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS_DOT] = ACTIONS(3562),
    [anon_sym_DASH_DOT] = ACTIONS(3562),
    [anon_sym_PERCENT] = ACTIONS(3562),
    [anon_sym_AMP_AMP] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3560),
    [aux_sym_prefix_op_token1] = ACTIONS(3562),
    [aux_sym_infix_op_token1] = ACTIONS(3560),
    [aux_sym_infix_op_token2] = ACTIONS(3562),
    [anon_sym_PIPE_PIPE] = ACTIONS(3562),
    [anon_sym_BANG_EQ] = ACTIONS(3562),
    [anon_sym_COLON_EQ] = ACTIONS(3560),
    [anon_sym_DOLLAR] = ACTIONS(3562),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3562),
    [sym_int] = ACTIONS(3562),
    [sym_xint] = ACTIONS(3560),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3560),
    [sym__newline] = ACTIONS(3560),
  },
  [2703] = {
    [sym_block_comment] = STATE(2703),
    [sym_compiler_directive_decl] = STATE(2703),
    [sym_fsi_directive_decl] = STATE(2703),
    [sym_preproc_line] = STATE(2703),
    [sym_identifier] = ACTIONS(3551),
    [anon_sym_EQ] = ACTIONS(3549),
    [anon_sym_COLON] = ACTIONS(3551),
    [anon_sym_return] = ACTIONS(3551),
    [anon_sym_do] = ACTIONS(3551),
    [anon_sym_let] = ACTIONS(3551),
    [anon_sym_let_BANG] = ACTIONS(3549),
    [anon_sym_LPAREN] = ACTIONS(3551),
    [anon_sym_COMMA] = ACTIONS(3549),
    [anon_sym_null] = ACTIONS(3551),
    [anon_sym_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_QMARK] = ACTIONS(3551),
    [anon_sym_COLON_COLON] = ACTIONS(3549),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(3551),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3549),
    [anon_sym_LBRACE] = ACTIONS(3551),
    [anon_sym_LT_AT] = ACTIONS(3551),
    [anon_sym_LT_AT_AT] = ACTIONS(3551),
    [anon_sym_DOT] = ACTIONS(3551),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3549),
    [anon_sym_new] = ACTIONS(3551),
    [anon_sym_return_BANG] = ACTIONS(3549),
    [anon_sym_yield] = ACTIONS(3551),
    [anon_sym_yield_BANG] = ACTIONS(3549),
    [anon_sym_lazy] = ACTIONS(3551),
    [anon_sym_assert] = ACTIONS(3551),
    [anon_sym_upcast] = ACTIONS(3551),
    [anon_sym_downcast] = ACTIONS(3551),
    [anon_sym_COLON_GT] = ACTIONS(3549),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3549),
    [anon_sym_for] = ACTIONS(3551),
    [anon_sym_while] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(3551),
    [anon_sym_fun] = ACTIONS(3551),
    [anon_sym_DASH_GT] = ACTIONS(3551),
    [anon_sym_try] = ACTIONS(3551),
    [anon_sym_match] = ACTIONS(3551),
    [anon_sym_match_BANG] = ACTIONS(3549),
    [anon_sym_function] = ACTIONS(3551),
    [anon_sym_LT_DASH] = ACTIONS(3551),
    [anon_sym_DOT_LBRACK] = ACTIONS(3549),
    [anon_sym_LT] = ACTIONS(3549),
    [anon_sym_GT] = ACTIONS(3551),
    [anon_sym_use] = ACTIONS(3551),
    [anon_sym_use_BANG] = ACTIONS(3549),
    [anon_sym_do_BANG] = ACTIONS(3549),
    [anon_sym_begin] = ACTIONS(3551),
    [anon_sym_LPAREN2] = ACTIONS(3551),
    [anon_sym_STAR] = ACTIONS(3551),
    [anon_sym_LT2] = ACTIONS(3551),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3549),
    [anon_sym_or] = ACTIONS(3551),
    [aux_sym_char_token1] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [anon_sym_AT_DQUOTE] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [sym_bool] = ACTIONS(3551),
    [sym_unit] = ACTIONS(3549),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3551),
    [sym_op_identifier] = ACTIONS(3551),
    [anon_sym_PLUS] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(3551),
    [anon_sym_PLUS_DOT] = ACTIONS(3551),
    [anon_sym_DASH_DOT] = ACTIONS(3551),
    [anon_sym_PERCENT] = ACTIONS(3551),
    [anon_sym_AMP_AMP] = ACTIONS(3551),
    [anon_sym_TILDE] = ACTIONS(3549),
    [aux_sym_prefix_op_token1] = ACTIONS(3551),
    [aux_sym_infix_op_token1] = ACTIONS(3549),
    [aux_sym_infix_op_token2] = ACTIONS(3551),
    [anon_sym_PIPE_PIPE] = ACTIONS(3551),
    [anon_sym_BANG_EQ] = ACTIONS(3551),
    [anon_sym_COLON_EQ] = ACTIONS(3549),
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3551),
    [sym_int] = ACTIONS(3551),
    [sym_xint] = ACTIONS(3549),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3549),
    [sym__newline] = ACTIONS(3549),
  },
  [2704] = {
    [sym_block_comment] = STATE(2704),
    [sym_compiler_directive_decl] = STATE(2704),
    [sym_fsi_directive_decl] = STATE(2704),
    [sym_preproc_line] = STATE(2704),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3525),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_QMARK] = ACTIONS(3527),
    [anon_sym_COLON_COLON] = ACTIONS(3525),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_AT_GT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_COLON_GT] = ACTIONS(3525),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_DASH_GT] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_LT_DASH] = ACTIONS(3527),
    [anon_sym_DOT_LBRACK] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_LPAREN2] = ACTIONS(3527),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_LT2] = ACTIONS(3527),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_or] = ACTIONS(3527),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3525),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3527),
    [anon_sym_DASH_DOT] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3527),
    [aux_sym_infix_op_token1] = ACTIONS(3525),
    [aux_sym_infix_op_token2] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_COLON_EQ] = ACTIONS(3525),
    [anon_sym_DOLLAR] = ACTIONS(3527),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3527),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3525),
    [sym__newline] = ACTIONS(3525),
  },
  [2705] = {
    [sym_block_comment] = STATE(2705),
    [sym_compiler_directive_decl] = STATE(2705),
    [sym_fsi_directive_decl] = STATE(2705),
    [sym_preproc_line] = STATE(2705),
    [sym_identifier] = ACTIONS(3535),
    [anon_sym_EQ] = ACTIONS(3533),
    [anon_sym_COLON] = ACTIONS(3535),
    [anon_sym_return] = ACTIONS(3535),
    [anon_sym_do] = ACTIONS(3535),
    [anon_sym_let] = ACTIONS(3535),
    [anon_sym_let_BANG] = ACTIONS(3533),
    [anon_sym_LPAREN] = ACTIONS(3535),
    [anon_sym_COMMA] = ACTIONS(3533),
    [anon_sym_null] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(3535),
    [anon_sym_COLON_QMARK] = ACTIONS(3535),
    [anon_sym_COLON_COLON] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3533),
    [anon_sym_LBRACE] = ACTIONS(3535),
    [anon_sym_LT_AT] = ACTIONS(3535),
    [anon_sym_LT_AT_AT] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(3535),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3533),
    [anon_sym_new] = ACTIONS(3535),
    [anon_sym_return_BANG] = ACTIONS(3533),
    [anon_sym_yield] = ACTIONS(3535),
    [anon_sym_yield_BANG] = ACTIONS(3533),
    [anon_sym_lazy] = ACTIONS(3535),
    [anon_sym_assert] = ACTIONS(3535),
    [anon_sym_upcast] = ACTIONS(3535),
    [anon_sym_downcast] = ACTIONS(3535),
    [anon_sym_COLON_GT] = ACTIONS(3533),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3533),
    [anon_sym_for] = ACTIONS(3535),
    [anon_sym_while] = ACTIONS(3535),
    [anon_sym_if] = ACTIONS(3535),
    [anon_sym_fun] = ACTIONS(3535),
    [anon_sym_DASH_GT] = ACTIONS(3535),
    [anon_sym_try] = ACTIONS(3535),
    [anon_sym_match] = ACTIONS(3535),
    [anon_sym_match_BANG] = ACTIONS(3533),
    [anon_sym_function] = ACTIONS(3535),
    [anon_sym_LT_DASH] = ACTIONS(3535),
    [anon_sym_DOT_LBRACK] = ACTIONS(3533),
    [anon_sym_LT] = ACTIONS(3533),
    [anon_sym_use] = ACTIONS(3535),
    [anon_sym_use_BANG] = ACTIONS(3533),
    [anon_sym_do_BANG] = ACTIONS(3533),
    [anon_sym_DOT_DOT] = ACTIONS(3533),
    [anon_sym_begin] = ACTIONS(3535),
    [anon_sym_LPAREN2] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(3535),
    [anon_sym_LT2] = ACTIONS(3535),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3533),
    [anon_sym_or] = ACTIONS(3535),
    [aux_sym_char_token1] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE] = ACTIONS(3535),
    [anon_sym_AT_DQUOTE] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [sym_bool] = ACTIONS(3535),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3535),
    [sym_op_identifier] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS_DOT] = ACTIONS(3535),
    [anon_sym_DASH_DOT] = ACTIONS(3535),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(3535),
    [anon_sym_TILDE] = ACTIONS(3533),
    [aux_sym_prefix_op_token1] = ACTIONS(3535),
    [aux_sym_infix_op_token1] = ACTIONS(3533),
    [aux_sym_infix_op_token2] = ACTIONS(3535),
    [anon_sym_PIPE_PIPE] = ACTIONS(3535),
    [anon_sym_BANG_EQ] = ACTIONS(3535),
    [anon_sym_COLON_EQ] = ACTIONS(3533),
    [anon_sym_DOLLAR] = ACTIONS(3535),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3535),
    [sym_int] = ACTIONS(3535),
    [sym_xint] = ACTIONS(3533),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3533),
    [sym__newline] = ACTIONS(3533),
  },
  [2706] = {
    [sym_block_comment] = STATE(2706),
    [sym_compiler_directive_decl] = STATE(2706),
    [sym_fsi_directive_decl] = STATE(2706),
    [sym_preproc_line] = STATE(2706),
    [sym_identifier] = ACTIONS(3519),
    [anon_sym_EQ] = ACTIONS(3517),
    [anon_sym_COLON] = ACTIONS(3519),
    [anon_sym_return] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(3519),
    [anon_sym_let] = ACTIONS(3519),
    [anon_sym_let_BANG] = ACTIONS(3517),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [anon_sym_COMMA] = ACTIONS(3517),
    [anon_sym_null] = ACTIONS(3519),
    [anon_sym_QMARK] = ACTIONS(3519),
    [anon_sym_COLON_QMARK] = ACTIONS(3519),
    [anon_sym_COLON_COLON] = ACTIONS(3517),
    [anon_sym_AMP] = ACTIONS(3519),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_LT_AT] = ACTIONS(3519),
    [anon_sym_LT_AT_AT] = ACTIONS(3519),
    [anon_sym_AT_AT_GT] = ACTIONS(3519),
    [anon_sym_DOT] = ACTIONS(3519),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3519),
    [anon_sym_return_BANG] = ACTIONS(3517),
    [anon_sym_yield] = ACTIONS(3519),
    [anon_sym_yield_BANG] = ACTIONS(3517),
    [anon_sym_lazy] = ACTIONS(3519),
    [anon_sym_assert] = ACTIONS(3519),
    [anon_sym_upcast] = ACTIONS(3519),
    [anon_sym_downcast] = ACTIONS(3519),
    [anon_sym_COLON_GT] = ACTIONS(3517),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3517),
    [anon_sym_for] = ACTIONS(3519),
    [anon_sym_while] = ACTIONS(3519),
    [anon_sym_if] = ACTIONS(3519),
    [anon_sym_fun] = ACTIONS(3519),
    [anon_sym_DASH_GT] = ACTIONS(3519),
    [anon_sym_try] = ACTIONS(3519),
    [anon_sym_match] = ACTIONS(3519),
    [anon_sym_match_BANG] = ACTIONS(3517),
    [anon_sym_function] = ACTIONS(3519),
    [anon_sym_LT_DASH] = ACTIONS(3519),
    [anon_sym_DOT_LBRACK] = ACTIONS(3517),
    [anon_sym_LT] = ACTIONS(3517),
    [anon_sym_use] = ACTIONS(3519),
    [anon_sym_use_BANG] = ACTIONS(3517),
    [anon_sym_do_BANG] = ACTIONS(3517),
    [anon_sym_begin] = ACTIONS(3519),
    [anon_sym_LPAREN2] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3519),
    [anon_sym_LT2] = ACTIONS(3519),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3517),
    [anon_sym_or] = ACTIONS(3519),
    [aux_sym_char_token1] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [anon_sym_AT_DQUOTE] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [sym_bool] = ACTIONS(3519),
    [sym_unit] = ACTIONS(3517),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3519),
    [sym_op_identifier] = ACTIONS(3519),
    [anon_sym_PLUS] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_DOT] = ACTIONS(3519),
    [anon_sym_DASH_DOT] = ACTIONS(3519),
    [anon_sym_PERCENT] = ACTIONS(3519),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3517),
    [aux_sym_prefix_op_token1] = ACTIONS(3519),
    [aux_sym_infix_op_token1] = ACTIONS(3517),
    [aux_sym_infix_op_token2] = ACTIONS(3519),
    [anon_sym_PIPE_PIPE] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3519),
    [anon_sym_COLON_EQ] = ACTIONS(3517),
    [anon_sym_DOLLAR] = ACTIONS(3519),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3519),
    [sym_int] = ACTIONS(3519),
    [sym_xint] = ACTIONS(3517),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3517),
    [sym__newline] = ACTIONS(3517),
  },
  [2707] = {
    [sym_block_comment] = STATE(2707),
    [sym_compiler_directive_decl] = STATE(2707),
    [sym_fsi_directive_decl] = STATE(2707),
    [sym_preproc_line] = STATE(2707),
    [sym_identifier] = ACTIONS(3531),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_GT_RBRACK] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_do] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(3531),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3531),
    [anon_sym_LT_AT] = ACTIONS(3531),
    [anon_sym_LT_AT_AT] = ACTIONS(3531),
    [anon_sym_DOT] = ACTIONS(4969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3531),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3531),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3531),
    [anon_sym_assert] = ACTIONS(3531),
    [anon_sym_upcast] = ACTIONS(3531),
    [anon_sym_downcast] = ACTIONS(3531),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(3531),
    [anon_sym_while] = ACTIONS(3531),
    [anon_sym_if] = ACTIONS(3531),
    [anon_sym_fun] = ACTIONS(3531),
    [anon_sym_DASH_GT] = ACTIONS(3531),
    [anon_sym_try] = ACTIONS(3531),
    [anon_sym_match] = ACTIONS(3531),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3531),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(3531),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3531),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LT2] = ACTIONS(3531),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_or] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3531),
    [anon_sym_DQUOTE] = ACTIONS(3531),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3531),
    [sym_unit] = ACTIONS(3529),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3531),
    [sym_op_identifier] = ACTIONS(3531),
    [anon_sym_PLUS] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(3531),
    [anon_sym_PLUS_DOT] = ACTIONS(3531),
    [anon_sym_DASH_DOT] = ACTIONS(3531),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_AMP_AMP] = ACTIONS(3531),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3531),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(3531),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [sym__newline] = ACTIONS(3529),
  },
  [2708] = {
    [sym_block_comment] = STATE(2708),
    [sym_compiler_directive_decl] = STATE(2708),
    [sym_fsi_directive_decl] = STATE(2708),
    [sym_preproc_line] = STATE(2708),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_COLON] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(3513),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_LT_DASH] = ACTIONS(3515),
    [anon_sym_DOT_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_GT] = ACTIONS(3515),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_or] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3515),
    [anon_sym_DASH_DOT] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3515),
    [aux_sym_infix_op_token1] = ACTIONS(3513),
    [aux_sym_infix_op_token2] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3515),
    [anon_sym_COLON_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(3515),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3515),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
  },
  [2709] = {
    [sym_block_comment] = STATE(2709),
    [sym_compiler_directive_decl] = STATE(2709),
    [sym_fsi_directive_decl] = STATE(2709),
    [sym_preproc_line] = STATE(2709),
    [aux_sym_rules_repeat1] = STATE(2636),
    [sym_identifier] = ACTIONS(3736),
    [anon_sym_EQ] = ACTIONS(3734),
    [anon_sym_COLON] = ACTIONS(3736),
    [anon_sym_return] = ACTIONS(3736),
    [anon_sym_do] = ACTIONS(3736),
    [anon_sym_let] = ACTIONS(3736),
    [anon_sym_let_BANG] = ACTIONS(3734),
    [anon_sym_as] = ACTIONS(3736),
    [anon_sym_LPAREN] = ACTIONS(3736),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_null] = ACTIONS(3736),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_COLON] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(5154),
    [anon_sym_AMP] = ACTIONS(3736),
    [anon_sym_LBRACK] = ACTIONS(3736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3734),
    [anon_sym_LBRACE] = ACTIONS(3736),
    [anon_sym_LT_AT] = ACTIONS(3736),
    [anon_sym_LT_AT_AT] = ACTIONS(3736),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3734),
    [anon_sym_new] = ACTIONS(3736),
    [anon_sym_with] = ACTIONS(3736),
    [anon_sym_return_BANG] = ACTIONS(3734),
    [anon_sym_yield] = ACTIONS(3736),
    [anon_sym_yield_BANG] = ACTIONS(3734),
    [anon_sym_lazy] = ACTIONS(3736),
    [anon_sym_assert] = ACTIONS(3736),
    [anon_sym_upcast] = ACTIONS(3736),
    [anon_sym_downcast] = ACTIONS(3736),
    [anon_sym_COLON_GT] = ACTIONS(3734),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3734),
    [anon_sym_for] = ACTIONS(3736),
    [anon_sym_while] = ACTIONS(3736),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_fun] = ACTIONS(3736),
    [anon_sym_try] = ACTIONS(3736),
    [anon_sym_match] = ACTIONS(3736),
    [anon_sym_match_BANG] = ACTIONS(3734),
    [anon_sym_function] = ACTIONS(3736),
    [anon_sym_LT_DASH] = ACTIONS(3736),
    [anon_sym_DOT_LBRACK] = ACTIONS(3734),
    [anon_sym_LT] = ACTIONS(3734),
    [anon_sym_use] = ACTIONS(3736),
    [anon_sym_use_BANG] = ACTIONS(3734),
    [anon_sym_do_BANG] = ACTIONS(3734),
    [anon_sym_begin] = ACTIONS(3736),
    [anon_sym_LPAREN2] = ACTIONS(3736),
    [anon_sym_or] = ACTIONS(3736),
    [aux_sym_char_token1] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3736),
    [anon_sym_DQUOTE] = ACTIONS(3736),
    [anon_sym_AT_DQUOTE] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [sym_bool] = ACTIONS(3736),
    [sym_unit] = ACTIONS(3734),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3736),
    [sym_op_identifier] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS_DOT] = ACTIONS(3736),
    [anon_sym_DASH_DOT] = ACTIONS(3736),
    [anon_sym_PERCENT] = ACTIONS(3736),
    [anon_sym_AMP_AMP] = ACTIONS(3736),
    [anon_sym_TILDE] = ACTIONS(3734),
    [aux_sym_prefix_op_token1] = ACTIONS(3736),
    [aux_sym_infix_op_token1] = ACTIONS(3734),
    [aux_sym_infix_op_token2] = ACTIONS(3736),
    [anon_sym_PIPE_PIPE] = ACTIONS(3736),
    [anon_sym_BANG_EQ] = ACTIONS(3736),
    [anon_sym_COLON_EQ] = ACTIONS(3734),
    [anon_sym_DOLLAR] = ACTIONS(3736),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3736),
    [sym_int] = ACTIONS(3736),
    [sym_xint] = ACTIONS(3734),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3734),
    [sym__newline] = ACTIONS(5193),
    [sym__dedent] = ACTIONS(3734),
  },
  [2710] = {
    [sym_block_comment] = STATE(2710),
    [sym_compiler_directive_decl] = STATE(2710),
    [sym_fsi_directive_decl] = STATE(2710),
    [sym_preproc_line] = STATE(2710),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_QMARK] = ACTIONS(3515),
    [anon_sym_COLON_COLON] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(3513),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3513),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_LT_DASH] = ACTIONS(3515),
    [anon_sym_DOT_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_GT] = ACTIONS(3515),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3515),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_or] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3515),
    [anon_sym_DASH_DOT] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3515),
    [aux_sym_infix_op_token1] = ACTIONS(3513),
    [aux_sym_infix_op_token2] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3515),
    [anon_sym_COLON_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(3515),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3515),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
  },
  [2711] = {
    [sym_block_comment] = STATE(2711),
    [sym_compiler_directive_decl] = STATE(2711),
    [sym_fsi_directive_decl] = STATE(2711),
    [sym_preproc_line] = STATE(2711),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_done] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_DASH_GT] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_DOT_DOT] = ACTIONS(3700),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_DOT_DOT2] = ACTIONS(3698),
    [anon_sym_or] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
    [sym__dedent] = ACTIONS(3698),
  },
  [2712] = {
    [sym_block_comment] = STATE(2712),
    [sym_compiler_directive_decl] = STATE(2712),
    [sym_fsi_directive_decl] = STATE(2712),
    [sym_preproc_line] = STATE(2712),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [anon_sym_as] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_with] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
    [sym__dedent] = ACTIONS(3602),
  },
  [2713] = {
    [sym_block_comment] = STATE(2713),
    [sym_compiler_directive_decl] = STATE(2713),
    [sym_fsi_directive_decl] = STATE(2713),
    [sym_preproc_line] = STATE(2713),
    [sym_identifier] = ACTIONS(3728),
    [anon_sym_EQ] = ACTIONS(3726),
    [anon_sym_COLON] = ACTIONS(3728),
    [anon_sym_return] = ACTIONS(3728),
    [anon_sym_do] = ACTIONS(3728),
    [anon_sym_let] = ACTIONS(3728),
    [anon_sym_let_BANG] = ACTIONS(3726),
    [anon_sym_as] = ACTIONS(3728),
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_COMMA] = ACTIONS(3726),
    [anon_sym_null] = ACTIONS(3728),
    [anon_sym_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(3726),
    [anon_sym_AMP] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3726),
    [anon_sym_LBRACE] = ACTIONS(3728),
    [anon_sym_LT_AT] = ACTIONS(3728),
    [anon_sym_LT_AT_AT] = ACTIONS(3728),
    [anon_sym_DOT] = ACTIONS(3728),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3726),
    [anon_sym_new] = ACTIONS(3728),
    [anon_sym_with] = ACTIONS(3728),
    [anon_sym_return_BANG] = ACTIONS(3726),
    [anon_sym_yield] = ACTIONS(3728),
    [anon_sym_yield_BANG] = ACTIONS(3726),
    [anon_sym_lazy] = ACTIONS(3728),
    [anon_sym_assert] = ACTIONS(3728),
    [anon_sym_upcast] = ACTIONS(3728),
    [anon_sym_downcast] = ACTIONS(3728),
    [anon_sym_COLON_GT] = ACTIONS(3726),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3726),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_fun] = ACTIONS(3728),
    [anon_sym_try] = ACTIONS(3728),
    [anon_sym_match] = ACTIONS(3728),
    [anon_sym_match_BANG] = ACTIONS(3726),
    [anon_sym_function] = ACTIONS(3728),
    [anon_sym_LT_DASH] = ACTIONS(3728),
    [anon_sym_DOT_LBRACK] = ACTIONS(3726),
    [anon_sym_LT] = ACTIONS(3726),
    [anon_sym_use] = ACTIONS(3728),
    [anon_sym_use_BANG] = ACTIONS(3726),
    [anon_sym_do_BANG] = ACTIONS(3726),
    [anon_sym_begin] = ACTIONS(3728),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [aux_sym_char_token1] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3728),
    [anon_sym_AT_DQUOTE] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [sym_bool] = ACTIONS(3728),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3728),
    [sym_op_identifier] = ACTIONS(3728),
    [anon_sym_PLUS] = ACTIONS(3728),
    [anon_sym_DASH] = ACTIONS(3728),
    [anon_sym_PLUS_DOT] = ACTIONS(3728),
    [anon_sym_DASH_DOT] = ACTIONS(3728),
    [anon_sym_PERCENT] = ACTIONS(3728),
    [anon_sym_AMP_AMP] = ACTIONS(3728),
    [anon_sym_TILDE] = ACTIONS(3726),
    [aux_sym_prefix_op_token1] = ACTIONS(3728),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token2] = ACTIONS(3728),
    [anon_sym_PIPE_PIPE] = ACTIONS(3728),
    [anon_sym_BANG_EQ] = ACTIONS(3728),
    [anon_sym_COLON_EQ] = ACTIONS(3726),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3728),
    [sym_int] = ACTIONS(3728),
    [sym_xint] = ACTIONS(3726),
    [anon_sym_f] = ACTIONS(3728),
    [aux_sym_decimal_token1] = ACTIONS(3728),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3726),
    [sym__newline] = ACTIONS(3726),
    [sym__dedent] = ACTIONS(3726),
  },
  [2714] = {
    [sym_elif_expression] = STATE(2822),
    [sym_block_comment] = STATE(2714),
    [sym_compiler_directive_decl] = STATE(2714),
    [sym_fsi_directive_decl] = STATE(2714),
    [sym_preproc_line] = STATE(2714),
    [aux_sym_if_expression_repeat1] = STATE(2714),
    [sym_identifier] = ACTIONS(3555),
    [anon_sym_EQ] = ACTIONS(3553),
    [anon_sym_COLON] = ACTIONS(3555),
    [anon_sym_return] = ACTIONS(3555),
    [anon_sym_do] = ACTIONS(3555),
    [anon_sym_let] = ACTIONS(3555),
    [anon_sym_let_BANG] = ACTIONS(3553),
    [anon_sym_LPAREN] = ACTIONS(3555),
    [anon_sym_COMMA] = ACTIONS(3553),
    [anon_sym_null] = ACTIONS(3555),
    [anon_sym_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_QMARK] = ACTIONS(3555),
    [anon_sym_COLON_COLON] = ACTIONS(3553),
    [anon_sym_AMP] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(3555),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3553),
    [anon_sym_LBRACE] = ACTIONS(3555),
    [anon_sym_LT_AT] = ACTIONS(3555),
    [anon_sym_LT_AT_AT] = ACTIONS(3555),
    [anon_sym_DOT] = ACTIONS(3555),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3553),
    [anon_sym_new] = ACTIONS(3555),
    [anon_sym_return_BANG] = ACTIONS(3553),
    [anon_sym_yield] = ACTIONS(3555),
    [anon_sym_yield_BANG] = ACTIONS(3553),
    [anon_sym_lazy] = ACTIONS(3555),
    [anon_sym_assert] = ACTIONS(3555),
    [anon_sym_upcast] = ACTIONS(3555),
    [anon_sym_downcast] = ACTIONS(3555),
    [anon_sym_COLON_GT] = ACTIONS(3553),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3553),
    [anon_sym_for] = ACTIONS(3555),
    [anon_sym_while] = ACTIONS(3555),
    [anon_sym_else] = ACTIONS(3555),
    [anon_sym_elif] = ACTIONS(5196),
    [anon_sym_if] = ACTIONS(3555),
    [anon_sym_fun] = ACTIONS(3555),
    [anon_sym_try] = ACTIONS(3555),
    [anon_sym_match] = ACTIONS(3555),
    [anon_sym_match_BANG] = ACTIONS(3553),
    [anon_sym_function] = ACTIONS(3555),
    [anon_sym_LT_DASH] = ACTIONS(3555),
    [anon_sym_DOT_LBRACK] = ACTIONS(3553),
    [anon_sym_LT] = ACTIONS(3553),
    [anon_sym_GT] = ACTIONS(3555),
    [anon_sym_use] = ACTIONS(3555),
    [anon_sym_use_BANG] = ACTIONS(3553),
    [anon_sym_do_BANG] = ACTIONS(3553),
    [anon_sym_begin] = ACTIONS(3555),
    [anon_sym_LPAREN2] = ACTIONS(3555),
    [anon_sym_or] = ACTIONS(3555),
    [aux_sym_char_token1] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3555),
    [anon_sym_DQUOTE] = ACTIONS(3555),
    [anon_sym_AT_DQUOTE] = ACTIONS(3553),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3553),
    [sym_bool] = ACTIONS(3555),
    [sym_unit] = ACTIONS(3553),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3555),
    [sym_op_identifier] = ACTIONS(3555),
    [anon_sym_PLUS] = ACTIONS(3555),
    [anon_sym_DASH] = ACTIONS(3555),
    [anon_sym_PLUS_DOT] = ACTIONS(3555),
    [anon_sym_DASH_DOT] = ACTIONS(3555),
    [anon_sym_PERCENT] = ACTIONS(3555),
    [anon_sym_AMP_AMP] = ACTIONS(3555),
    [anon_sym_TILDE] = ACTIONS(3553),
    [aux_sym_prefix_op_token1] = ACTIONS(3555),
    [aux_sym_infix_op_token1] = ACTIONS(3553),
    [aux_sym_infix_op_token2] = ACTIONS(3555),
    [anon_sym_PIPE_PIPE] = ACTIONS(3555),
    [anon_sym_BANG_EQ] = ACTIONS(3555),
    [anon_sym_COLON_EQ] = ACTIONS(3553),
    [anon_sym_DOLLAR] = ACTIONS(3555),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3555),
    [sym_int] = ACTIONS(3555),
    [sym_xint] = ACTIONS(3553),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3553),
    [sym__newline] = ACTIONS(3553),
  },
  [2715] = {
    [sym_block_comment] = STATE(2715),
    [sym_compiler_directive_decl] = STATE(2715),
    [sym_fsi_directive_decl] = STATE(2715),
    [sym_preproc_line] = STATE(2715),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(3521),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_COMMA] = ACTIONS(3521),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_QMARK] = ACTIONS(3523),
    [anon_sym_COLON_COLON] = ACTIONS(3521),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3523),
    [anon_sym_AT_AT_GT] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3521),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3521),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_COLON_GT] = ACTIONS(3521),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3521),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_DASH_GT] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3521),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_LT_DASH] = ACTIONS(3523),
    [anon_sym_DOT_LBRACK] = ACTIONS(3521),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3521),
    [anon_sym_do_BANG] = ACTIONS(3521),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_LPAREN2] = ACTIONS(3523),
    [anon_sym_STAR] = ACTIONS(3523),
    [anon_sym_LT2] = ACTIONS(3523),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3521),
    [anon_sym_or] = ACTIONS(3523),
    [aux_sym_char_token1] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3521),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3523),
    [anon_sym_DASH_DOT] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_TILDE] = ACTIONS(3521),
    [aux_sym_prefix_op_token1] = ACTIONS(3523),
    [aux_sym_infix_op_token1] = ACTIONS(3521),
    [aux_sym_infix_op_token2] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3523),
    [anon_sym_COLON_EQ] = ACTIONS(3521),
    [anon_sym_DOLLAR] = ACTIONS(3523),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3523),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3521),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3521),
    [sym__newline] = ACTIONS(3521),
  },
  [2716] = {
    [sym_block_comment] = STATE(2716),
    [sym_compiler_directive_decl] = STATE(2716),
    [sym_fsi_directive_decl] = STATE(2716),
    [sym_preproc_line] = STATE(2716),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3498),
    [anon_sym_AT_AT_GT] = ACTIONS(3498),
    [anon_sym_DOT] = ACTIONS(3498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_LT_DASH] = ACTIONS(3498),
    [anon_sym_DOT_LBRACK] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_or] = ACTIONS(3498),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3498),
    [anon_sym_DASH_DOT] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3498),
    [aux_sym_infix_op_token1] = ACTIONS(3496),
    [aux_sym_infix_op_token2] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_COLON_EQ] = ACTIONS(3496),
    [anon_sym_DOLLAR] = ACTIONS(3498),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3498),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
  },
  [2717] = {
    [sym_block_comment] = STATE(2717),
    [sym_compiler_directive_decl] = STATE(2717),
    [sym_fsi_directive_decl] = STATE(2717),
    [sym_preproc_line] = STATE(2717),
    [aux_sym_rules_repeat1] = STATE(2722),
    [sym_identifier] = ACTIONS(3736),
    [anon_sym_EQ] = ACTIONS(3734),
    [anon_sym_COLON] = ACTIONS(3736),
    [anon_sym_return] = ACTIONS(3736),
    [anon_sym_do] = ACTIONS(3736),
    [anon_sym_let] = ACTIONS(3736),
    [anon_sym_let_BANG] = ACTIONS(3734),
    [anon_sym_as] = ACTIONS(3736),
    [anon_sym_LPAREN] = ACTIONS(3736),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_null] = ACTIONS(3736),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_COLON] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(5199),
    [anon_sym_AMP] = ACTIONS(3736),
    [anon_sym_LBRACK] = ACTIONS(3736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3734),
    [anon_sym_LBRACE] = ACTIONS(3736),
    [anon_sym_LT_AT] = ACTIONS(3736),
    [anon_sym_LT_AT_AT] = ACTIONS(3736),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3734),
    [anon_sym_new] = ACTIONS(3736),
    [anon_sym_with] = ACTIONS(3736),
    [anon_sym_return_BANG] = ACTIONS(3734),
    [anon_sym_yield] = ACTIONS(3736),
    [anon_sym_yield_BANG] = ACTIONS(3734),
    [anon_sym_lazy] = ACTIONS(3736),
    [anon_sym_assert] = ACTIONS(3736),
    [anon_sym_upcast] = ACTIONS(3736),
    [anon_sym_downcast] = ACTIONS(3736),
    [anon_sym_COLON_GT] = ACTIONS(3734),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3734),
    [anon_sym_for] = ACTIONS(3736),
    [anon_sym_while] = ACTIONS(3736),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_fun] = ACTIONS(3736),
    [anon_sym_try] = ACTIONS(3736),
    [anon_sym_match] = ACTIONS(3736),
    [anon_sym_match_BANG] = ACTIONS(3734),
    [anon_sym_function] = ACTIONS(3736),
    [anon_sym_LT_DASH] = ACTIONS(3736),
    [anon_sym_DOT_LBRACK] = ACTIONS(3734),
    [anon_sym_LT] = ACTIONS(3734),
    [anon_sym_use] = ACTIONS(3736),
    [anon_sym_use_BANG] = ACTIONS(3734),
    [anon_sym_do_BANG] = ACTIONS(3734),
    [anon_sym_begin] = ACTIONS(3736),
    [anon_sym_LPAREN2] = ACTIONS(3736),
    [anon_sym_or] = ACTIONS(3736),
    [aux_sym_char_token1] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3736),
    [anon_sym_DQUOTE] = ACTIONS(3736),
    [anon_sym_AT_DQUOTE] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [sym_bool] = ACTIONS(3736),
    [sym_unit] = ACTIONS(3734),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3736),
    [sym_op_identifier] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS_DOT] = ACTIONS(3736),
    [anon_sym_DASH_DOT] = ACTIONS(3736),
    [anon_sym_PERCENT] = ACTIONS(3736),
    [anon_sym_AMP_AMP] = ACTIONS(3736),
    [anon_sym_TILDE] = ACTIONS(3734),
    [aux_sym_prefix_op_token1] = ACTIONS(3736),
    [aux_sym_infix_op_token1] = ACTIONS(3734),
    [aux_sym_infix_op_token2] = ACTIONS(3736),
    [anon_sym_PIPE_PIPE] = ACTIONS(3736),
    [anon_sym_BANG_EQ] = ACTIONS(3736),
    [anon_sym_COLON_EQ] = ACTIONS(3734),
    [anon_sym_DOLLAR] = ACTIONS(3736),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3736),
    [sym_int] = ACTIONS(3736),
    [sym_xint] = ACTIONS(3734),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3734),
    [sym__newline] = ACTIONS(5201),
  },
  [2718] = {
    [sym_block_comment] = STATE(2718),
    [sym_compiler_directive_decl] = STATE(2718),
    [sym_fsi_directive_decl] = STATE(2718),
    [sym_preproc_line] = STATE(2718),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_and] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_f] = ACTIONS(3437),
    [aux_sym_decimal_token1] = ACTIONS(3361),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
    [sym__dedent] = ACTIONS(3191),
  },
  [2719] = {
    [sym_block_comment] = STATE(2719),
    [sym_compiler_directive_decl] = STATE(2719),
    [sym_fsi_directive_decl] = STATE(2719),
    [sym_preproc_line] = STATE(2719),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_EQ] = ACTIONS(3646),
    [anon_sym_COLON] = ACTIONS(3648),
    [anon_sym_return] = ACTIONS(3648),
    [anon_sym_do] = ACTIONS(3648),
    [anon_sym_let] = ACTIONS(3648),
    [anon_sym_let_BANG] = ACTIONS(3646),
    [anon_sym_LPAREN] = ACTIONS(3648),
    [anon_sym_COMMA] = ACTIONS(3646),
    [anon_sym_null] = ACTIONS(3648),
    [anon_sym_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_COLON] = ACTIONS(3646),
    [anon_sym_AMP] = ACTIONS(3648),
    [anon_sym_LBRACK] = ACTIONS(3648),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3646),
    [anon_sym_LBRACE] = ACTIONS(3648),
    [anon_sym_LT_AT] = ACTIONS(3648),
    [anon_sym_LT_AT_AT] = ACTIONS(3648),
    [anon_sym_DOT] = ACTIONS(3648),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3646),
    [anon_sym_new] = ACTIONS(3648),
    [anon_sym_return_BANG] = ACTIONS(3646),
    [anon_sym_yield] = ACTIONS(3648),
    [anon_sym_yield_BANG] = ACTIONS(3646),
    [anon_sym_lazy] = ACTIONS(3648),
    [anon_sym_assert] = ACTIONS(3648),
    [anon_sym_upcast] = ACTIONS(3648),
    [anon_sym_downcast] = ACTIONS(3648),
    [anon_sym_COLON_GT] = ACTIONS(3646),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3646),
    [anon_sym_for] = ACTIONS(3648),
    [anon_sym_while] = ACTIONS(3648),
    [anon_sym_else] = ACTIONS(3648),
    [anon_sym_elif] = ACTIONS(3648),
    [anon_sym_if] = ACTIONS(3648),
    [anon_sym_fun] = ACTIONS(3648),
    [anon_sym_DASH_GT] = ACTIONS(3648),
    [anon_sym_try] = ACTIONS(3648),
    [anon_sym_match] = ACTIONS(3648),
    [anon_sym_match_BANG] = ACTIONS(3646),
    [anon_sym_function] = ACTIONS(3648),
    [anon_sym_LT_DASH] = ACTIONS(3648),
    [anon_sym_DOT_LBRACK] = ACTIONS(3646),
    [anon_sym_LT] = ACTIONS(3646),
    [anon_sym_use] = ACTIONS(3648),
    [anon_sym_use_BANG] = ACTIONS(3646),
    [anon_sym_do_BANG] = ACTIONS(3646),
    [anon_sym_DOT_DOT] = ACTIONS(3646),
    [anon_sym_begin] = ACTIONS(3648),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3648),
    [aux_sym_char_token1] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3648),
    [anon_sym_AT_DQUOTE] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [sym_bool] = ACTIONS(3648),
    [sym_unit] = ACTIONS(3646),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3648),
    [sym_op_identifier] = ACTIONS(3648),
    [anon_sym_PLUS] = ACTIONS(3648),
    [anon_sym_DASH] = ACTIONS(3648),
    [anon_sym_PLUS_DOT] = ACTIONS(3648),
    [anon_sym_DASH_DOT] = ACTIONS(3648),
    [anon_sym_PERCENT] = ACTIONS(3648),
    [anon_sym_AMP_AMP] = ACTIONS(3648),
    [anon_sym_TILDE] = ACTIONS(3646),
    [aux_sym_prefix_op_token1] = ACTIONS(3648),
    [aux_sym_infix_op_token1] = ACTIONS(3646),
    [aux_sym_infix_op_token2] = ACTIONS(3648),
    [anon_sym_PIPE_PIPE] = ACTIONS(3648),
    [anon_sym_BANG_EQ] = ACTIONS(3648),
    [anon_sym_COLON_EQ] = ACTIONS(3646),
    [anon_sym_DOLLAR] = ACTIONS(3648),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3648),
    [sym_int] = ACTIONS(3648),
    [sym_xint] = ACTIONS(3646),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3646),
    [sym__newline] = ACTIONS(3646),
  },
  [2720] = {
    [sym_block_comment] = STATE(2720),
    [sym_compiler_directive_decl] = STATE(2720),
    [sym_fsi_directive_decl] = STATE(2720),
    [sym_preproc_line] = STATE(2720),
    [aux_sym_rules_repeat1] = STATE(2740),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_as] = ACTIONS(3693),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(5199),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_with] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_or] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(5204),
  },
  [2721] = {
    [sym_block_comment] = STATE(2721),
    [sym_compiler_directive_decl] = STATE(2721),
    [sym_fsi_directive_decl] = STATE(2721),
    [sym_preproc_line] = STATE(2721),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_as] = ACTIONS(3700),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_done] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_DOT_DOT] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [2722] = {
    [sym_block_comment] = STATE(2722),
    [sym_compiler_directive_decl] = STATE(2722),
    [sym_fsi_directive_decl] = STATE(2722),
    [sym_preproc_line] = STATE(2722),
    [aux_sym_rules_repeat1] = STATE(2741),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_as] = ACTIONS(3693),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(5199),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_with] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_or] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(5204),
  },
  [2723] = {
    [sym_block_comment] = STATE(2723),
    [sym_compiler_directive_decl] = STATE(2723),
    [sym_fsi_directive_decl] = STATE(2723),
    [sym_preproc_line] = STATE(2723),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(4667),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_DOT_DOT] = ACTIONS(4182),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_DOT_DOT2] = ACTIONS(3683),
    [anon_sym_or] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
    [sym__dedent] = ACTIONS(3683),
  },
  [2724] = {
    [sym_block_comment] = STATE(2724),
    [sym_compiler_directive_decl] = STATE(2724),
    [sym_fsi_directive_decl] = STATE(2724),
    [sym_preproc_line] = STATE(2724),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_f] = ACTIONS(3371),
    [aux_sym_decimal_token1] = ACTIONS(3249),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [anon_sym_POUNDendif] = ACTIONS(3191),
    [anon_sym_POUNDelse] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [2725] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defns] = STATE(11247),
    [sym__function_or_value_defn_body] = STATE(7291),
    [sym_function_declaration_left] = STATE(9771),
    [sym_value_declaration_left] = STATE(9771),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_property_accessor] = STATE(8960),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(2725),
    [sym_compiler_directive_decl] = STATE(2725),
    [sym_fsi_directive_decl] = STATE(2725),
    [sym_preproc_line] = STATE(2725),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [anon_sym_get] = ACTIONS(5233),
    [anon_sym_set] = ACTIONS(5233),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2726] = {
    [sym_block_comment] = STATE(2726),
    [sym_compiler_directive_decl] = STATE(2726),
    [sym_fsi_directive_decl] = STATE(2726),
    [sym_preproc_line] = STATE(2726),
    [aux_sym_sequential_expression_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3765),
    [anon_sym_COLON] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_let_BANG] = ACTIONS(3765),
    [anon_sym_as] = ACTIONS(3767),
    [anon_sym_LPAREN] = ACTIONS(3767),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_null] = ACTIONS(3767),
    [anon_sym_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3765),
    [anon_sym_LBRACE] = ACTIONS(3767),
    [anon_sym_LT_AT] = ACTIONS(3767),
    [anon_sym_LT_AT_AT] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3765),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_with] = ACTIONS(3767),
    [anon_sym_return_BANG] = ACTIONS(3765),
    [anon_sym_yield] = ACTIONS(3767),
    [anon_sym_yield_BANG] = ACTIONS(3765),
    [anon_sym_lazy] = ACTIONS(3767),
    [anon_sym_assert] = ACTIONS(3767),
    [anon_sym_upcast] = ACTIONS(3767),
    [anon_sym_downcast] = ACTIONS(3767),
    [anon_sym_COLON_GT] = ACTIONS(3765),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3765),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_fun] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_match] = ACTIONS(3767),
    [anon_sym_match_BANG] = ACTIONS(3765),
    [anon_sym_function] = ACTIONS(3767),
    [anon_sym_LT_DASH] = ACTIONS(3767),
    [anon_sym_DOT_LBRACK] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(3765),
    [anon_sym_use] = ACTIONS(3767),
    [anon_sym_use_BANG] = ACTIONS(3765),
    [anon_sym_do_BANG] = ACTIONS(3765),
    [anon_sym_begin] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3767),
    [anon_sym_or] = ACTIONS(3767),
    [aux_sym_char_token1] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3767),
    [anon_sym_DQUOTE] = ACTIONS(3767),
    [anon_sym_AT_DQUOTE] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [sym_bool] = ACTIONS(3767),
    [sym_unit] = ACTIONS(3765),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3767),
    [sym_op_identifier] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_PLUS_DOT] = ACTIONS(3767),
    [anon_sym_DASH_DOT] = ACTIONS(3767),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_AMP_AMP] = ACTIONS(3767),
    [anon_sym_TILDE] = ACTIONS(3765),
    [aux_sym_prefix_op_token1] = ACTIONS(3767),
    [aux_sym_infix_op_token1] = ACTIONS(3765),
    [aux_sym_infix_op_token2] = ACTIONS(3767),
    [anon_sym_PIPE_PIPE] = ACTIONS(3767),
    [anon_sym_BANG_EQ] = ACTIONS(3767),
    [anon_sym_COLON_EQ] = ACTIONS(3765),
    [anon_sym_DOLLAR] = ACTIONS(3767),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3767),
    [sym_int] = ACTIONS(3767),
    [sym_xint] = ACTIONS(3765),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3765),
    [sym__newline] = ACTIONS(5259),
    [sym__dedent] = ACTIONS(3765),
  },
  [2727] = {
    [sym_block_comment] = STATE(2727),
    [sym_compiler_directive_decl] = STATE(2727),
    [sym_fsi_directive_decl] = STATE(2727),
    [sym_preproc_line] = STATE(2727),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [anon_sym_as] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_with] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(5187),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
    [sym__dedent] = ACTIONS(3683),
  },
  [2728] = {
    [sym_block_comment] = STATE(2728),
    [sym_compiler_directive_decl] = STATE(2728),
    [sym_fsi_directive_decl] = STATE(2728),
    [sym_preproc_line] = STATE(2728),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [anon_sym_as] = ACTIONS(3604),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_with] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
  },
  [2729] = {
    [sym_block_comment] = STATE(2729),
    [sym_compiler_directive_decl] = STATE(2729),
    [sym_fsi_directive_decl] = STATE(2729),
    [sym_preproc_line] = STATE(2729),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_EQ] = ACTIONS(3646),
    [anon_sym_COLON] = ACTIONS(3648),
    [anon_sym_return] = ACTIONS(3648),
    [anon_sym_do] = ACTIONS(3648),
    [anon_sym_let] = ACTIONS(3648),
    [anon_sym_let_BANG] = ACTIONS(3646),
    [anon_sym_as] = ACTIONS(3648),
    [anon_sym_LPAREN] = ACTIONS(3648),
    [anon_sym_COMMA] = ACTIONS(3646),
    [anon_sym_null] = ACTIONS(3648),
    [anon_sym_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_COLON] = ACTIONS(3646),
    [anon_sym_AMP] = ACTIONS(3648),
    [anon_sym_LBRACK] = ACTIONS(3648),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3646),
    [anon_sym_LBRACE] = ACTIONS(3648),
    [anon_sym_LT_AT] = ACTIONS(3648),
    [anon_sym_LT_AT_AT] = ACTIONS(3648),
    [anon_sym_DOT] = ACTIONS(3648),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3646),
    [anon_sym_new] = ACTIONS(3648),
    [anon_sym_with] = ACTIONS(3648),
    [anon_sym_return_BANG] = ACTIONS(3646),
    [anon_sym_yield] = ACTIONS(3648),
    [anon_sym_yield_BANG] = ACTIONS(3646),
    [anon_sym_lazy] = ACTIONS(3648),
    [anon_sym_assert] = ACTIONS(3648),
    [anon_sym_upcast] = ACTIONS(3648),
    [anon_sym_downcast] = ACTIONS(3648),
    [anon_sym_COLON_GT] = ACTIONS(3646),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3646),
    [anon_sym_for] = ACTIONS(3648),
    [anon_sym_while] = ACTIONS(3648),
    [anon_sym_else] = ACTIONS(3648),
    [anon_sym_elif] = ACTIONS(3648),
    [anon_sym_if] = ACTIONS(3648),
    [anon_sym_fun] = ACTIONS(3648),
    [anon_sym_try] = ACTIONS(3648),
    [anon_sym_match] = ACTIONS(3648),
    [anon_sym_match_BANG] = ACTIONS(3646),
    [anon_sym_function] = ACTIONS(3648),
    [anon_sym_LT_DASH] = ACTIONS(3648),
    [anon_sym_DOT_LBRACK] = ACTIONS(3646),
    [anon_sym_LT] = ACTIONS(3646),
    [anon_sym_use] = ACTIONS(3648),
    [anon_sym_use_BANG] = ACTIONS(3646),
    [anon_sym_do_BANG] = ACTIONS(3646),
    [anon_sym_begin] = ACTIONS(3648),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3648),
    [aux_sym_char_token1] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3648),
    [anon_sym_AT_DQUOTE] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [sym_bool] = ACTIONS(3648),
    [sym_unit] = ACTIONS(3646),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3648),
    [sym_op_identifier] = ACTIONS(3648),
    [anon_sym_PLUS] = ACTIONS(3648),
    [anon_sym_DASH] = ACTIONS(3648),
    [anon_sym_PLUS_DOT] = ACTIONS(3648),
    [anon_sym_DASH_DOT] = ACTIONS(3648),
    [anon_sym_PERCENT] = ACTIONS(3648),
    [anon_sym_AMP_AMP] = ACTIONS(3648),
    [anon_sym_TILDE] = ACTIONS(3646),
    [aux_sym_prefix_op_token1] = ACTIONS(3648),
    [aux_sym_infix_op_token1] = ACTIONS(3646),
    [aux_sym_infix_op_token2] = ACTIONS(3648),
    [anon_sym_PIPE_PIPE] = ACTIONS(3648),
    [anon_sym_BANG_EQ] = ACTIONS(3648),
    [anon_sym_COLON_EQ] = ACTIONS(3646),
    [anon_sym_DOLLAR] = ACTIONS(3648),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3648),
    [sym_int] = ACTIONS(3648),
    [sym_xint] = ACTIONS(3646),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3646),
    [sym__newline] = ACTIONS(3646),
  },
  [2730] = {
    [sym_block_comment] = STATE(2730),
    [sym_compiler_directive_decl] = STATE(2730),
    [sym_fsi_directive_decl] = STATE(2730),
    [sym_preproc_line] = STATE(2730),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_DASH_GT] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_DOT_DOT] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_f] = ACTIONS(4545),
    [aux_sym_decimal_token1] = ACTIONS(4315),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [2731] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defns] = STATE(11323),
    [sym__function_or_value_defn_body] = STATE(7291),
    [sym_function_declaration_left] = STATE(9771),
    [sym_value_declaration_left] = STATE(9771),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_property_accessor] = STATE(9044),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(2731),
    [sym_compiler_directive_decl] = STATE(2731),
    [sym_fsi_directive_decl] = STATE(2731),
    [sym_preproc_line] = STATE(2731),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [anon_sym_get] = ACTIONS(5233),
    [anon_sym_set] = ACTIONS(5233),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2732] = {
    [sym_block_comment] = STATE(2732),
    [sym_compiler_directive_decl] = STATE(2732),
    [sym_fsi_directive_decl] = STATE(2732),
    [sym_preproc_line] = STATE(2732),
    [sym_identifier] = ACTIONS(3728),
    [anon_sym_EQ] = ACTIONS(3726),
    [anon_sym_COLON] = ACTIONS(3728),
    [anon_sym_return] = ACTIONS(3728),
    [anon_sym_do] = ACTIONS(3728),
    [anon_sym_let] = ACTIONS(3728),
    [anon_sym_let_BANG] = ACTIONS(3726),
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_COMMA] = ACTIONS(3726),
    [anon_sym_null] = ACTIONS(3728),
    [anon_sym_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(3726),
    [anon_sym_AMP] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3726),
    [anon_sym_LBRACE] = ACTIONS(3728),
    [anon_sym_LT_AT] = ACTIONS(3728),
    [anon_sym_LT_AT_AT] = ACTIONS(3728),
    [anon_sym_DOT] = ACTIONS(3728),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3726),
    [anon_sym_new] = ACTIONS(3728),
    [anon_sym_return_BANG] = ACTIONS(3726),
    [anon_sym_yield] = ACTIONS(3728),
    [anon_sym_yield_BANG] = ACTIONS(3726),
    [anon_sym_lazy] = ACTIONS(3728),
    [anon_sym_assert] = ACTIONS(3728),
    [anon_sym_upcast] = ACTIONS(3728),
    [anon_sym_downcast] = ACTIONS(3728),
    [anon_sym_COLON_GT] = ACTIONS(3726),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3726),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_fun] = ACTIONS(3728),
    [anon_sym_try] = ACTIONS(3728),
    [anon_sym_match] = ACTIONS(3728),
    [anon_sym_match_BANG] = ACTIONS(3726),
    [anon_sym_function] = ACTIONS(3728),
    [anon_sym_LT_DASH] = ACTIONS(3728),
    [anon_sym_DOT_LBRACK] = ACTIONS(3726),
    [anon_sym_LT] = ACTIONS(3726),
    [anon_sym_use] = ACTIONS(3728),
    [anon_sym_use_BANG] = ACTIONS(3726),
    [anon_sym_do_BANG] = ACTIONS(3726),
    [anon_sym_begin] = ACTIONS(3728),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [aux_sym_char_token1] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3728),
    [anon_sym_AT_DQUOTE] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [sym_bool] = ACTIONS(3728),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3728),
    [sym_op_identifier] = ACTIONS(3728),
    [anon_sym_PLUS] = ACTIONS(3728),
    [anon_sym_DASH] = ACTIONS(3728),
    [anon_sym_PLUS_DOT] = ACTIONS(3728),
    [anon_sym_DASH_DOT] = ACTIONS(3728),
    [anon_sym_PERCENT] = ACTIONS(3728),
    [anon_sym_AMP_AMP] = ACTIONS(3728),
    [anon_sym_TILDE] = ACTIONS(3726),
    [aux_sym_prefix_op_token1] = ACTIONS(3728),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token2] = ACTIONS(3728),
    [anon_sym_PIPE_PIPE] = ACTIONS(3728),
    [anon_sym_BANG_EQ] = ACTIONS(3728),
    [anon_sym_COLON_EQ] = ACTIONS(3726),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3728),
    [sym_int] = ACTIONS(3728),
    [sym_xint] = ACTIONS(3726),
    [anon_sym_f] = ACTIONS(3728),
    [aux_sym_decimal_token1] = ACTIONS(3728),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3726),
    [anon_sym_POUNDendif] = ACTIONS(3726),
    [anon_sym_POUNDelse] = ACTIONS(3726),
    [sym__newline] = ACTIONS(3726),
  },
  [2733] = {
    [sym_block_comment] = STATE(2733),
    [sym_compiler_directive_decl] = STATE(2733),
    [sym_fsi_directive_decl] = STATE(2733),
    [sym_preproc_line] = STATE(2733),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_AT_GT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [aux_sym_float_token1] = ACTIONS(5262),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
  },
  [2734] = {
    [sym_block_comment] = STATE(2734),
    [sym_compiler_directive_decl] = STATE(2734),
    [sym_fsi_directive_decl] = STATE(2734),
    [sym_preproc_line] = STATE(2734),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_AT_AT_GT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [aux_sym_float_token1] = ACTIONS(5264),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
  },
  [2735] = {
    [sym_block_comment] = STATE(2735),
    [sym_compiler_directive_decl] = STATE(2735),
    [sym_fsi_directive_decl] = STATE(2735),
    [sym_preproc_line] = STATE(2735),
    [sym_identifier] = ACTIONS(3841),
    [anon_sym_EQ] = ACTIONS(3839),
    [anon_sym_COLON] = ACTIONS(3841),
    [anon_sym_return] = ACTIONS(3841),
    [anon_sym_do] = ACTIONS(3841),
    [anon_sym_let] = ACTIONS(3841),
    [anon_sym_let_BANG] = ACTIONS(3839),
    [anon_sym_as] = ACTIONS(3841),
    [anon_sym_LPAREN] = ACTIONS(3841),
    [anon_sym_COMMA] = ACTIONS(3839),
    [anon_sym_null] = ACTIONS(3841),
    [anon_sym_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_COLON] = ACTIONS(3839),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_AMP] = ACTIONS(3841),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(3841),
    [anon_sym_LT_AT] = ACTIONS(3841),
    [anon_sym_LT_AT_AT] = ACTIONS(3841),
    [anon_sym_DOT] = ACTIONS(3841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3839),
    [anon_sym_new] = ACTIONS(3841),
    [anon_sym_with] = ACTIONS(3841),
    [anon_sym_return_BANG] = ACTIONS(3839),
    [anon_sym_yield] = ACTIONS(3841),
    [anon_sym_yield_BANG] = ACTIONS(3839),
    [anon_sym_lazy] = ACTIONS(3841),
    [anon_sym_assert] = ACTIONS(3841),
    [anon_sym_upcast] = ACTIONS(3841),
    [anon_sym_downcast] = ACTIONS(3841),
    [anon_sym_COLON_GT] = ACTIONS(3839),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3839),
    [anon_sym_for] = ACTIONS(3841),
    [anon_sym_while] = ACTIONS(3841),
    [anon_sym_if] = ACTIONS(3841),
    [anon_sym_fun] = ACTIONS(3841),
    [anon_sym_try] = ACTIONS(3841),
    [anon_sym_match] = ACTIONS(3841),
    [anon_sym_match_BANG] = ACTIONS(3839),
    [anon_sym_function] = ACTIONS(3841),
    [anon_sym_LT_DASH] = ACTIONS(3841),
    [anon_sym_DOT_LBRACK] = ACTIONS(3839),
    [anon_sym_LT] = ACTIONS(3839),
    [anon_sym_use] = ACTIONS(3841),
    [anon_sym_use_BANG] = ACTIONS(3839),
    [anon_sym_do_BANG] = ACTIONS(3839),
    [anon_sym_begin] = ACTIONS(3841),
    [anon_sym_LPAREN2] = ACTIONS(3841),
    [anon_sym_or] = ACTIONS(3841),
    [aux_sym_char_token1] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3841),
    [anon_sym_DQUOTE] = ACTIONS(3841),
    [anon_sym_AT_DQUOTE] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [sym_bool] = ACTIONS(3841),
    [sym_unit] = ACTIONS(3839),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3841),
    [sym_op_identifier] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_PLUS_DOT] = ACTIONS(3841),
    [anon_sym_DASH_DOT] = ACTIONS(3841),
    [anon_sym_PERCENT] = ACTIONS(3841),
    [anon_sym_AMP_AMP] = ACTIONS(3841),
    [anon_sym_TILDE] = ACTIONS(3839),
    [aux_sym_prefix_op_token1] = ACTIONS(3841),
    [aux_sym_infix_op_token1] = ACTIONS(3839),
    [aux_sym_infix_op_token2] = ACTIONS(3841),
    [anon_sym_PIPE_PIPE] = ACTIONS(3841),
    [anon_sym_BANG_EQ] = ACTIONS(3841),
    [anon_sym_COLON_EQ] = ACTIONS(3839),
    [anon_sym_DOLLAR] = ACTIONS(3841),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3841),
    [sym_int] = ACTIONS(3841),
    [sym_xint] = ACTIONS(3839),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3839),
    [sym__newline] = ACTIONS(3839),
    [sym__dedent] = ACTIONS(3839),
  },
  [2736] = {
    [sym_block_comment] = STATE(2736),
    [sym_compiler_directive_decl] = STATE(2736),
    [sym_fsi_directive_decl] = STATE(2736),
    [sym_preproc_line] = STATE(2736),
    [sym_identifier] = ACTIONS(3828),
    [anon_sym_EQ] = ACTIONS(3826),
    [anon_sym_COLON] = ACTIONS(3828),
    [anon_sym_return] = ACTIONS(3828),
    [anon_sym_do] = ACTIONS(3828),
    [anon_sym_let] = ACTIONS(3828),
    [anon_sym_let_BANG] = ACTIONS(3826),
    [anon_sym_as] = ACTIONS(3828),
    [anon_sym_LPAREN] = ACTIONS(3828),
    [anon_sym_COMMA] = ACTIONS(3826),
    [anon_sym_null] = ACTIONS(3828),
    [anon_sym_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_COLON] = ACTIONS(3826),
    [anon_sym_PIPE] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3828),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3826),
    [anon_sym_LBRACE] = ACTIONS(3828),
    [anon_sym_LT_AT] = ACTIONS(3828),
    [anon_sym_LT_AT_AT] = ACTIONS(3828),
    [anon_sym_DOT] = ACTIONS(3828),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3826),
    [anon_sym_new] = ACTIONS(3828),
    [anon_sym_with] = ACTIONS(3828),
    [anon_sym_return_BANG] = ACTIONS(3826),
    [anon_sym_yield] = ACTIONS(3828),
    [anon_sym_yield_BANG] = ACTIONS(3826),
    [anon_sym_lazy] = ACTIONS(3828),
    [anon_sym_assert] = ACTIONS(3828),
    [anon_sym_upcast] = ACTIONS(3828),
    [anon_sym_downcast] = ACTIONS(3828),
    [anon_sym_COLON_GT] = ACTIONS(3826),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3826),
    [anon_sym_for] = ACTIONS(3828),
    [anon_sym_while] = ACTIONS(3828),
    [anon_sym_if] = ACTIONS(3828),
    [anon_sym_fun] = ACTIONS(3828),
    [anon_sym_try] = ACTIONS(3828),
    [anon_sym_match] = ACTIONS(3828),
    [anon_sym_match_BANG] = ACTIONS(3826),
    [anon_sym_function] = ACTIONS(3828),
    [anon_sym_LT_DASH] = ACTIONS(3828),
    [anon_sym_DOT_LBRACK] = ACTIONS(3826),
    [anon_sym_LT] = ACTIONS(3826),
    [anon_sym_use] = ACTIONS(3828),
    [anon_sym_use_BANG] = ACTIONS(3826),
    [anon_sym_do_BANG] = ACTIONS(3826),
    [anon_sym_begin] = ACTIONS(3828),
    [anon_sym_LPAREN2] = ACTIONS(3828),
    [anon_sym_or] = ACTIONS(3828),
    [aux_sym_char_token1] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3828),
    [anon_sym_DQUOTE] = ACTIONS(3828),
    [anon_sym_AT_DQUOTE] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [sym_bool] = ACTIONS(3828),
    [sym_unit] = ACTIONS(3826),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3828),
    [sym_op_identifier] = ACTIONS(3828),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_DASH] = ACTIONS(3828),
    [anon_sym_PLUS_DOT] = ACTIONS(3828),
    [anon_sym_DASH_DOT] = ACTIONS(3828),
    [anon_sym_PERCENT] = ACTIONS(3828),
    [anon_sym_AMP_AMP] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3826),
    [aux_sym_prefix_op_token1] = ACTIONS(3828),
    [aux_sym_infix_op_token1] = ACTIONS(3826),
    [aux_sym_infix_op_token2] = ACTIONS(3828),
    [anon_sym_PIPE_PIPE] = ACTIONS(3828),
    [anon_sym_BANG_EQ] = ACTIONS(3828),
    [anon_sym_COLON_EQ] = ACTIONS(3826),
    [anon_sym_DOLLAR] = ACTIONS(3828),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3828),
    [sym_int] = ACTIONS(3828),
    [sym_xint] = ACTIONS(3826),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3826),
    [sym__newline] = ACTIONS(3826),
    [sym__dedent] = ACTIONS(3826),
  },
  [2737] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defns] = STATE(11415),
    [sym__function_or_value_defn_body] = STATE(7291),
    [sym_function_declaration_left] = STATE(9771),
    [sym_value_declaration_left] = STATE(9771),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_property_accessor] = STATE(9246),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(2737),
    [sym_compiler_directive_decl] = STATE(2737),
    [sym_fsi_directive_decl] = STATE(2737),
    [sym_preproc_line] = STATE(2737),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [anon_sym_get] = ACTIONS(5233),
    [anon_sym_set] = ACTIONS(5233),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2738] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defns] = STATE(11487),
    [sym__function_or_value_defn_body] = STATE(7291),
    [sym_function_declaration_left] = STATE(9771),
    [sym_value_declaration_left] = STATE(9771),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_property_accessor] = STATE(9167),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(2738),
    [sym_compiler_directive_decl] = STATE(2738),
    [sym_fsi_directive_decl] = STATE(2738),
    [sym_preproc_line] = STATE(2738),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [anon_sym_get] = ACTIONS(5233),
    [anon_sym_set] = ACTIONS(5233),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2739] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defns] = STATE(11570),
    [sym__function_or_value_defn_body] = STATE(7291),
    [sym_function_declaration_left] = STATE(9771),
    [sym_value_declaration_left] = STATE(9771),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_property_accessor] = STATE(9059),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(2739),
    [sym_compiler_directive_decl] = STATE(2739),
    [sym_fsi_directive_decl] = STATE(2739),
    [sym_preproc_line] = STATE(2739),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [anon_sym_get] = ACTIONS(5233),
    [anon_sym_set] = ACTIONS(5233),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2740] = {
    [sym_block_comment] = STATE(2740),
    [sym_compiler_directive_decl] = STATE(2740),
    [sym_fsi_directive_decl] = STATE(2740),
    [sym_preproc_line] = STATE(2740),
    [aux_sym_rules_repeat1] = STATE(2741),
    [sym_identifier] = ACTIONS(3676),
    [anon_sym_EQ] = ACTIONS(3674),
    [anon_sym_COLON] = ACTIONS(3676),
    [anon_sym_return] = ACTIONS(3676),
    [anon_sym_do] = ACTIONS(3676),
    [anon_sym_let] = ACTIONS(3676),
    [anon_sym_let_BANG] = ACTIONS(3674),
    [anon_sym_as] = ACTIONS(3676),
    [anon_sym_LPAREN] = ACTIONS(3676),
    [anon_sym_COMMA] = ACTIONS(3674),
    [anon_sym_null] = ACTIONS(3676),
    [anon_sym_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_COLON] = ACTIONS(3674),
    [anon_sym_PIPE] = ACTIONS(5199),
    [anon_sym_AMP] = ACTIONS(3676),
    [anon_sym_LBRACK] = ACTIONS(3676),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3674),
    [anon_sym_LBRACE] = ACTIONS(3676),
    [anon_sym_LT_AT] = ACTIONS(3676),
    [anon_sym_LT_AT_AT] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3674),
    [anon_sym_new] = ACTIONS(3676),
    [anon_sym_with] = ACTIONS(3676),
    [anon_sym_return_BANG] = ACTIONS(3674),
    [anon_sym_yield] = ACTIONS(3676),
    [anon_sym_yield_BANG] = ACTIONS(3674),
    [anon_sym_lazy] = ACTIONS(3676),
    [anon_sym_assert] = ACTIONS(3676),
    [anon_sym_upcast] = ACTIONS(3676),
    [anon_sym_downcast] = ACTIONS(3676),
    [anon_sym_COLON_GT] = ACTIONS(3674),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3674),
    [anon_sym_for] = ACTIONS(3676),
    [anon_sym_while] = ACTIONS(3676),
    [anon_sym_if] = ACTIONS(3676),
    [anon_sym_fun] = ACTIONS(3676),
    [anon_sym_try] = ACTIONS(3676),
    [anon_sym_match] = ACTIONS(3676),
    [anon_sym_match_BANG] = ACTIONS(3674),
    [anon_sym_function] = ACTIONS(3676),
    [anon_sym_LT_DASH] = ACTIONS(3676),
    [anon_sym_DOT_LBRACK] = ACTIONS(3674),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_use] = ACTIONS(3676),
    [anon_sym_use_BANG] = ACTIONS(3674),
    [anon_sym_do_BANG] = ACTIONS(3674),
    [anon_sym_begin] = ACTIONS(3676),
    [anon_sym_LPAREN2] = ACTIONS(3676),
    [anon_sym_or] = ACTIONS(3676),
    [aux_sym_char_token1] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3676),
    [anon_sym_DQUOTE] = ACTIONS(3676),
    [anon_sym_AT_DQUOTE] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [sym_bool] = ACTIONS(3676),
    [sym_unit] = ACTIONS(3674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3676),
    [sym_op_identifier] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_PLUS_DOT] = ACTIONS(3676),
    [anon_sym_DASH_DOT] = ACTIONS(3676),
    [anon_sym_PERCENT] = ACTIONS(3676),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_TILDE] = ACTIONS(3674),
    [aux_sym_prefix_op_token1] = ACTIONS(3676),
    [aux_sym_infix_op_token1] = ACTIONS(3674),
    [aux_sym_infix_op_token2] = ACTIONS(3676),
    [anon_sym_PIPE_PIPE] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3676),
    [anon_sym_COLON_EQ] = ACTIONS(3674),
    [anon_sym_DOLLAR] = ACTIONS(3676),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3676),
    [sym_int] = ACTIONS(3676),
    [sym_xint] = ACTIONS(3674),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3674),
    [sym__newline] = ACTIONS(5266),
  },
  [2741] = {
    [sym_block_comment] = STATE(2741),
    [sym_compiler_directive_decl] = STATE(2741),
    [sym_fsi_directive_decl] = STATE(2741),
    [sym_preproc_line] = STATE(2741),
    [aux_sym_rules_repeat1] = STATE(2741),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [anon_sym_as] = ACTIONS(3743),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(5269),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_with] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_or] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [sym__newline] = ACTIONS(5272),
  },
  [2742] = {
    [sym_block_comment] = STATE(2742),
    [sym_compiler_directive_decl] = STATE(2742),
    [sym_fsi_directive_decl] = STATE(2742),
    [sym_preproc_line] = STATE(2742),
    [aux_sym_long_identifier_repeat1] = STATE(2745),
    [sym_identifier] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3778),
    [anon_sym_COLON] = ACTIONS(3781),
    [anon_sym_return] = ACTIONS(3781),
    [anon_sym_do] = ACTIONS(3781),
    [anon_sym_let] = ACTIONS(3781),
    [anon_sym_let_BANG] = ACTIONS(3778),
    [anon_sym_as] = ACTIONS(3781),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3778),
    [anon_sym_null] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3781),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_LT_AT] = ACTIONS(3781),
    [anon_sym_LT_AT_AT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(5275),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3778),
    [anon_sym_new] = ACTIONS(3781),
    [anon_sym_with] = ACTIONS(3781),
    [anon_sym_return_BANG] = ACTIONS(3778),
    [anon_sym_yield] = ACTIONS(3781),
    [anon_sym_yield_BANG] = ACTIONS(3778),
    [anon_sym_lazy] = ACTIONS(3781),
    [anon_sym_assert] = ACTIONS(3781),
    [anon_sym_upcast] = ACTIONS(3781),
    [anon_sym_downcast] = ACTIONS(3781),
    [anon_sym_COLON_GT] = ACTIONS(3778),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3778),
    [anon_sym_for] = ACTIONS(3781),
    [anon_sym_while] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_fun] = ACTIONS(3781),
    [anon_sym_try] = ACTIONS(3781),
    [anon_sym_match] = ACTIONS(3781),
    [anon_sym_match_BANG] = ACTIONS(3778),
    [anon_sym_function] = ACTIONS(3781),
    [anon_sym_LT_DASH] = ACTIONS(3781),
    [anon_sym_DOT_LBRACK] = ACTIONS(3778),
    [anon_sym_LT] = ACTIONS(3778),
    [anon_sym_use] = ACTIONS(3781),
    [anon_sym_use_BANG] = ACTIONS(3778),
    [anon_sym_do_BANG] = ACTIONS(3778),
    [anon_sym_begin] = ACTIONS(3781),
    [anon_sym_LPAREN2] = ACTIONS(3781),
    [anon_sym_or] = ACTIONS(3781),
    [aux_sym_char_token1] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3781),
    [anon_sym_DQUOTE] = ACTIONS(3781),
    [anon_sym_AT_DQUOTE] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [sym_bool] = ACTIONS(3781),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3781),
    [sym_op_identifier] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3781),
    [anon_sym_DASH] = ACTIONS(3781),
    [anon_sym_PLUS_DOT] = ACTIONS(3781),
    [anon_sym_DASH_DOT] = ACTIONS(3781),
    [anon_sym_PERCENT] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3781),
    [anon_sym_TILDE] = ACTIONS(3778),
    [aux_sym_prefix_op_token1] = ACTIONS(3781),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token2] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_COLON_EQ] = ACTIONS(3778),
    [anon_sym_DOLLAR] = ACTIONS(3781),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3781),
    [sym_int] = ACTIONS(3781),
    [sym_xint] = ACTIONS(3778),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3778),
    [sym__newline] = ACTIONS(3778),
    [sym__dedent] = ACTIONS(3778),
  },
  [2743] = {
    [sym_block_comment] = STATE(2743),
    [sym_compiler_directive_decl] = STATE(2743),
    [sym_fsi_directive_decl] = STATE(2743),
    [sym_preproc_line] = STATE(2743),
    [sym_identifier] = ACTIONS(3728),
    [anon_sym_EQ] = ACTIONS(3726),
    [anon_sym_COLON] = ACTIONS(3728),
    [anon_sym_return] = ACTIONS(3728),
    [anon_sym_do] = ACTIONS(3728),
    [anon_sym_and] = ACTIONS(3728),
    [anon_sym_let] = ACTIONS(3728),
    [anon_sym_let_BANG] = ACTIONS(3726),
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_COMMA] = ACTIONS(3726),
    [anon_sym_null] = ACTIONS(3728),
    [anon_sym_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(3726),
    [anon_sym_AMP] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3726),
    [anon_sym_LBRACE] = ACTIONS(3728),
    [anon_sym_LT_AT] = ACTIONS(3728),
    [anon_sym_LT_AT_AT] = ACTIONS(3728),
    [anon_sym_DOT] = ACTIONS(3728),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3726),
    [anon_sym_new] = ACTIONS(3728),
    [anon_sym_return_BANG] = ACTIONS(3726),
    [anon_sym_yield] = ACTIONS(3728),
    [anon_sym_yield_BANG] = ACTIONS(3726),
    [anon_sym_lazy] = ACTIONS(3728),
    [anon_sym_assert] = ACTIONS(3728),
    [anon_sym_upcast] = ACTIONS(3728),
    [anon_sym_downcast] = ACTIONS(3728),
    [anon_sym_COLON_GT] = ACTIONS(3726),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3726),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_fun] = ACTIONS(3728),
    [anon_sym_try] = ACTIONS(3728),
    [anon_sym_match] = ACTIONS(3728),
    [anon_sym_match_BANG] = ACTIONS(3726),
    [anon_sym_function] = ACTIONS(3728),
    [anon_sym_LT_DASH] = ACTIONS(3728),
    [anon_sym_DOT_LBRACK] = ACTIONS(3726),
    [anon_sym_LT] = ACTIONS(3726),
    [anon_sym_use] = ACTIONS(3728),
    [anon_sym_use_BANG] = ACTIONS(3726),
    [anon_sym_do_BANG] = ACTIONS(3726),
    [anon_sym_begin] = ACTIONS(3728),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [aux_sym_char_token1] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3728),
    [anon_sym_AT_DQUOTE] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [sym_bool] = ACTIONS(3728),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3728),
    [sym_op_identifier] = ACTIONS(3728),
    [anon_sym_PLUS] = ACTIONS(3728),
    [anon_sym_DASH] = ACTIONS(3728),
    [anon_sym_PLUS_DOT] = ACTIONS(3728),
    [anon_sym_DASH_DOT] = ACTIONS(3728),
    [anon_sym_PERCENT] = ACTIONS(3728),
    [anon_sym_AMP_AMP] = ACTIONS(3728),
    [anon_sym_TILDE] = ACTIONS(3726),
    [aux_sym_prefix_op_token1] = ACTIONS(3728),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token2] = ACTIONS(3728),
    [anon_sym_PIPE_PIPE] = ACTIONS(3728),
    [anon_sym_BANG_EQ] = ACTIONS(3728),
    [anon_sym_COLON_EQ] = ACTIONS(3726),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3728),
    [sym_int] = ACTIONS(3728),
    [sym_xint] = ACTIONS(3726),
    [anon_sym_f] = ACTIONS(3728),
    [aux_sym_decimal_token1] = ACTIONS(3728),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3726),
    [sym__newline] = ACTIONS(3726),
    [sym__dedent] = ACTIONS(3726),
  },
  [2744] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defns] = STATE(11648),
    [sym__function_or_value_defn_body] = STATE(7291),
    [sym_function_declaration_left] = STATE(9771),
    [sym_value_declaration_left] = STATE(9771),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_property_accessor] = STATE(9224),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(2744),
    [sym_compiler_directive_decl] = STATE(2744),
    [sym_fsi_directive_decl] = STATE(2744),
    [sym_preproc_line] = STATE(2744),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [anon_sym_get] = ACTIONS(5233),
    [anon_sym_set] = ACTIONS(5233),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2745] = {
    [sym_block_comment] = STATE(2745),
    [sym_compiler_directive_decl] = STATE(2745),
    [sym_fsi_directive_decl] = STATE(2745),
    [sym_preproc_line] = STATE(2745),
    [aux_sym_long_identifier_repeat1] = STATE(2780),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [anon_sym_as] = ACTIONS(3451),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(5279),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_or] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
    [sym__dedent] = ACTIONS(3449),
  },
  [2746] = {
    [sym_block_comment] = STATE(2746),
    [sym_compiler_directive_decl] = STATE(2746),
    [sym_fsi_directive_decl] = STATE(2746),
    [sym_preproc_line] = STATE(2746),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_else] = ACTIONS(3700),
    [anon_sym_elif] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_DASH_GT] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_DOT_DOT] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [2747] = {
    [sym_block_comment] = STATE(2747),
    [sym_compiler_directive_decl] = STATE(2747),
    [sym_fsi_directive_decl] = STATE(2747),
    [sym_preproc_line] = STATE(2747),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_as] = ACTIONS(3700),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_else] = ACTIONS(3700),
    [anon_sym_elif] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [2748] = {
    [sym_block_comment] = STATE(2748),
    [sym_compiler_directive_decl] = STATE(2748),
    [sym_fsi_directive_decl] = STATE(2748),
    [sym_preproc_line] = STATE(2748),
    [sym_identifier] = ACTIONS(3813),
    [anon_sym_EQ] = ACTIONS(3811),
    [anon_sym_COLON] = ACTIONS(3813),
    [anon_sym_return] = ACTIONS(3813),
    [anon_sym_do] = ACTIONS(3813),
    [anon_sym_let] = ACTIONS(3813),
    [anon_sym_let_BANG] = ACTIONS(3811),
    [anon_sym_as] = ACTIONS(3813),
    [anon_sym_LPAREN] = ACTIONS(3813),
    [anon_sym_COMMA] = ACTIONS(3811),
    [anon_sym_null] = ACTIONS(3813),
    [anon_sym_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_COLON] = ACTIONS(3811),
    [anon_sym_AMP] = ACTIONS(3813),
    [anon_sym_LBRACK] = ACTIONS(3813),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3811),
    [anon_sym_LBRACE] = ACTIONS(3813),
    [anon_sym_LT_AT] = ACTIONS(3813),
    [anon_sym_LT_AT_AT] = ACTIONS(3813),
    [anon_sym_DOT] = ACTIONS(3813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3811),
    [anon_sym_new] = ACTIONS(3813),
    [anon_sym_with] = ACTIONS(3813),
    [anon_sym_return_BANG] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_yield_BANG] = ACTIONS(3811),
    [anon_sym_lazy] = ACTIONS(3813),
    [anon_sym_assert] = ACTIONS(3813),
    [anon_sym_upcast] = ACTIONS(3813),
    [anon_sym_downcast] = ACTIONS(3813),
    [anon_sym_COLON_GT] = ACTIONS(3811),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3811),
    [anon_sym_for] = ACTIONS(3813),
    [anon_sym_done] = ACTIONS(5281),
    [anon_sym_while] = ACTIONS(3813),
    [anon_sym_if] = ACTIONS(3813),
    [anon_sym_fun] = ACTIONS(3813),
    [anon_sym_try] = ACTIONS(3813),
    [anon_sym_match] = ACTIONS(3813),
    [anon_sym_match_BANG] = ACTIONS(3811),
    [anon_sym_function] = ACTIONS(3813),
    [anon_sym_LT_DASH] = ACTIONS(3813),
    [anon_sym_DOT_LBRACK] = ACTIONS(3811),
    [anon_sym_LT] = ACTIONS(3811),
    [anon_sym_use] = ACTIONS(3813),
    [anon_sym_use_BANG] = ACTIONS(3811),
    [anon_sym_do_BANG] = ACTIONS(3811),
    [anon_sym_begin] = ACTIONS(3813),
    [anon_sym_LPAREN2] = ACTIONS(3813),
    [anon_sym_or] = ACTIONS(3813),
    [aux_sym_char_token1] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3813),
    [anon_sym_DQUOTE] = ACTIONS(3813),
    [anon_sym_AT_DQUOTE] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [sym_bool] = ACTIONS(3813),
    [sym_unit] = ACTIONS(3811),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3813),
    [sym_op_identifier] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PLUS_DOT] = ACTIONS(3813),
    [anon_sym_DASH_DOT] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3813),
    [anon_sym_AMP_AMP] = ACTIONS(3813),
    [anon_sym_TILDE] = ACTIONS(3811),
    [aux_sym_prefix_op_token1] = ACTIONS(3813),
    [aux_sym_infix_op_token1] = ACTIONS(3811),
    [aux_sym_infix_op_token2] = ACTIONS(3813),
    [anon_sym_PIPE_PIPE] = ACTIONS(3813),
    [anon_sym_BANG_EQ] = ACTIONS(3813),
    [anon_sym_COLON_EQ] = ACTIONS(3811),
    [anon_sym_DOLLAR] = ACTIONS(3813),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3813),
    [sym_int] = ACTIONS(3813),
    [sym_xint] = ACTIONS(3811),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3811),
    [sym__newline] = ACTIONS(3811),
    [sym__dedent] = ACTIONS(3811),
  },
  [2749] = {
    [sym_block_comment] = STATE(2749),
    [sym_compiler_directive_decl] = STATE(2749),
    [sym_fsi_directive_decl] = STATE(2749),
    [sym_preproc_line] = STATE(2749),
    [sym_identifier] = ACTIONS(3732),
    [anon_sym_EQ] = ACTIONS(3730),
    [anon_sym_COLON] = ACTIONS(3732),
    [anon_sym_return] = ACTIONS(3732),
    [anon_sym_do] = ACTIONS(3732),
    [anon_sym_let] = ACTIONS(3732),
    [anon_sym_let_BANG] = ACTIONS(3730),
    [anon_sym_LPAREN] = ACTIONS(3732),
    [anon_sym_COMMA] = ACTIONS(3730),
    [anon_sym_null] = ACTIONS(3732),
    [anon_sym_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_LBRACK] = ACTIONS(3732),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3730),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_LT_AT] = ACTIONS(3732),
    [anon_sym_LT_AT_AT] = ACTIONS(3732),
    [anon_sym_DOT] = ACTIONS(3732),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3730),
    [anon_sym_new] = ACTIONS(3732),
    [anon_sym_return_BANG] = ACTIONS(3730),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_yield_BANG] = ACTIONS(3730),
    [anon_sym_lazy] = ACTIONS(3732),
    [anon_sym_assert] = ACTIONS(3732),
    [anon_sym_upcast] = ACTIONS(3732),
    [anon_sym_downcast] = ACTIONS(3732),
    [anon_sym_COLON_GT] = ACTIONS(3730),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3730),
    [anon_sym_for] = ACTIONS(3732),
    [anon_sym_while] = ACTIONS(3732),
    [anon_sym_else] = ACTIONS(3732),
    [anon_sym_elif] = ACTIONS(3732),
    [anon_sym_if] = ACTIONS(3732),
    [anon_sym_fun] = ACTIONS(3732),
    [anon_sym_DASH_GT] = ACTIONS(3732),
    [anon_sym_try] = ACTIONS(3732),
    [anon_sym_match] = ACTIONS(3732),
    [anon_sym_match_BANG] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3732),
    [anon_sym_LT_DASH] = ACTIONS(3732),
    [anon_sym_DOT_LBRACK] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3730),
    [anon_sym_use] = ACTIONS(3732),
    [anon_sym_use_BANG] = ACTIONS(3730),
    [anon_sym_do_BANG] = ACTIONS(3730),
    [anon_sym_DOT_DOT] = ACTIONS(3730),
    [anon_sym_begin] = ACTIONS(3732),
    [anon_sym_LPAREN2] = ACTIONS(3732),
    [anon_sym_or] = ACTIONS(3732),
    [aux_sym_char_token1] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3732),
    [anon_sym_DQUOTE] = ACTIONS(3732),
    [anon_sym_AT_DQUOTE] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [sym_bool] = ACTIONS(3732),
    [sym_unit] = ACTIONS(3730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3732),
    [sym_op_identifier] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PLUS_DOT] = ACTIONS(3732),
    [anon_sym_DASH_DOT] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3732),
    [anon_sym_AMP_AMP] = ACTIONS(3732),
    [anon_sym_TILDE] = ACTIONS(3730),
    [aux_sym_prefix_op_token1] = ACTIONS(3732),
    [aux_sym_infix_op_token1] = ACTIONS(3730),
    [aux_sym_infix_op_token2] = ACTIONS(3732),
    [anon_sym_PIPE_PIPE] = ACTIONS(3732),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_COLON_EQ] = ACTIONS(3730),
    [anon_sym_DOLLAR] = ACTIONS(3732),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3732),
    [sym_int] = ACTIONS(3732),
    [sym_xint] = ACTIONS(3730),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3730),
    [sym__newline] = ACTIONS(3730),
  },
  [2750] = {
    [sym_block_comment] = STATE(2750),
    [sym_compiler_directive_decl] = STATE(2750),
    [sym_fsi_directive_decl] = STATE(2750),
    [sym_preproc_line] = STATE(2750),
    [aux_sym_long_identifier_repeat1] = STATE(2750),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3487),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(5283),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_EQ2] = ACTIONS(3485),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
    [sym__dedent] = ACTIONS(3485),
  },
  [2751] = {
    [sym_block_comment] = STATE(2751),
    [sym_compiler_directive_decl] = STATE(2751),
    [sym_fsi_directive_decl] = STATE(2751),
    [sym_preproc_line] = STATE(2751),
    [sym_identifier] = ACTIONS(3753),
    [anon_sym_EQ] = ACTIONS(3751),
    [anon_sym_COLON] = ACTIONS(3753),
    [anon_sym_return] = ACTIONS(3753),
    [anon_sym_do] = ACTIONS(3753),
    [anon_sym_let] = ACTIONS(3753),
    [anon_sym_let_BANG] = ACTIONS(3751),
    [anon_sym_as] = ACTIONS(3753),
    [anon_sym_LPAREN] = ACTIONS(3753),
    [anon_sym_COMMA] = ACTIONS(3751),
    [anon_sym_null] = ACTIONS(3753),
    [anon_sym_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_COLON] = ACTIONS(3751),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3751),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_LT_AT] = ACTIONS(3753),
    [anon_sym_LT_AT_AT] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3753),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3751),
    [anon_sym_new] = ACTIONS(3753),
    [anon_sym_with] = ACTIONS(3753),
    [anon_sym_return_BANG] = ACTIONS(3751),
    [anon_sym_yield] = ACTIONS(3753),
    [anon_sym_yield_BANG] = ACTIONS(3751),
    [anon_sym_lazy] = ACTIONS(3753),
    [anon_sym_assert] = ACTIONS(3753),
    [anon_sym_upcast] = ACTIONS(3753),
    [anon_sym_downcast] = ACTIONS(3753),
    [anon_sym_COLON_GT] = ACTIONS(3751),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3751),
    [anon_sym_for] = ACTIONS(3753),
    [anon_sym_while] = ACTIONS(3753),
    [anon_sym_if] = ACTIONS(3753),
    [anon_sym_fun] = ACTIONS(3753),
    [anon_sym_try] = ACTIONS(3753),
    [anon_sym_match] = ACTIONS(3753),
    [anon_sym_match_BANG] = ACTIONS(3751),
    [anon_sym_function] = ACTIONS(3753),
    [anon_sym_LT_DASH] = ACTIONS(3753),
    [anon_sym_DOT_LBRACK] = ACTIONS(3751),
    [anon_sym_LT] = ACTIONS(3751),
    [anon_sym_use] = ACTIONS(3753),
    [anon_sym_use_BANG] = ACTIONS(3751),
    [anon_sym_do_BANG] = ACTIONS(3751),
    [anon_sym_begin] = ACTIONS(3753),
    [anon_sym_LPAREN2] = ACTIONS(3753),
    [anon_sym_or] = ACTIONS(3753),
    [aux_sym_char_token1] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3753),
    [anon_sym_AT_DQUOTE] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [sym_bool] = ACTIONS(3753),
    [sym_unit] = ACTIONS(3751),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3753),
    [sym_op_identifier] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PLUS_DOT] = ACTIONS(3753),
    [anon_sym_DASH_DOT] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3753),
    [anon_sym_AMP_AMP] = ACTIONS(3753),
    [anon_sym_TILDE] = ACTIONS(3751),
    [aux_sym_prefix_op_token1] = ACTIONS(3753),
    [aux_sym_infix_op_token1] = ACTIONS(3751),
    [aux_sym_infix_op_token2] = ACTIONS(3753),
    [anon_sym_PIPE_PIPE] = ACTIONS(3753),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_COLON_EQ] = ACTIONS(3751),
    [anon_sym_DOLLAR] = ACTIONS(3753),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3753),
    [sym_int] = ACTIONS(5286),
    [sym_xint] = ACTIONS(3751),
    [anon_sym_f] = ACTIONS(3753),
    [aux_sym_decimal_token1] = ACTIONS(3753),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3751),
    [sym__newline] = ACTIONS(3751),
  },
  [2752] = {
    [sym_block_comment] = STATE(2752),
    [sym_compiler_directive_decl] = STATE(2752),
    [sym_fsi_directive_decl] = STATE(2752),
    [sym_preproc_line] = STATE(2752),
    [aux_sym_sequential_expression_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_COLON] = ACTIONS(3759),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_let_BANG] = ACTIONS(3757),
    [anon_sym_as] = ACTIONS(3759),
    [anon_sym_LPAREN] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3757),
    [anon_sym_null] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3757),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_LT_AT] = ACTIONS(3759),
    [anon_sym_LT_AT_AT] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(3759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_with] = ACTIONS(3759),
    [anon_sym_return_BANG] = ACTIONS(3757),
    [anon_sym_yield] = ACTIONS(3759),
    [anon_sym_yield_BANG] = ACTIONS(3757),
    [anon_sym_lazy] = ACTIONS(3759),
    [anon_sym_assert] = ACTIONS(3759),
    [anon_sym_upcast] = ACTIONS(3759),
    [anon_sym_downcast] = ACTIONS(3759),
    [anon_sym_COLON_GT] = ACTIONS(3757),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3757),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_fun] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_match] = ACTIONS(3759),
    [anon_sym_match_BANG] = ACTIONS(3757),
    [anon_sym_function] = ACTIONS(3759),
    [anon_sym_LT_DASH] = ACTIONS(3759),
    [anon_sym_DOT_LBRACK] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_use] = ACTIONS(3759),
    [anon_sym_use_BANG] = ACTIONS(3757),
    [anon_sym_do_BANG] = ACTIONS(3757),
    [anon_sym_begin] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_or] = ACTIONS(3759),
    [aux_sym_char_token1] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3759),
    [anon_sym_DQUOTE] = ACTIONS(3759),
    [anon_sym_AT_DQUOTE] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [sym_bool] = ACTIONS(3759),
    [sym_unit] = ACTIONS(3757),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3759),
    [sym_op_identifier] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS_DOT] = ACTIONS(3759),
    [anon_sym_DASH_DOT] = ACTIONS(3759),
    [anon_sym_PERCENT] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_TILDE] = ACTIONS(3757),
    [aux_sym_prefix_op_token1] = ACTIONS(3759),
    [aux_sym_infix_op_token1] = ACTIONS(3757),
    [aux_sym_infix_op_token2] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_COLON_EQ] = ACTIONS(3757),
    [anon_sym_DOLLAR] = ACTIONS(3759),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3759),
    [sym_int] = ACTIONS(3759),
    [sym_xint] = ACTIONS(3757),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3757),
    [sym__newline] = ACTIONS(3757),
    [sym__dedent] = ACTIONS(3757),
  },
  [2753] = {
    [sym_block_comment] = STATE(2753),
    [sym_compiler_directive_decl] = STATE(2753),
    [sym_fsi_directive_decl] = STATE(2753),
    [sym_preproc_line] = STATE(2753),
    [sym_identifier] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3774),
    [anon_sym_do] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3774),
    [anon_sym_let_BANG] = ACTIONS(3772),
    [anon_sym_as] = ACTIONS(3774),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3772),
    [anon_sym_null] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_COLON] = ACTIONS(3772),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_LT_AT] = ACTIONS(3774),
    [anon_sym_LT_AT_AT] = ACTIONS(3774),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3772),
    [anon_sym_new] = ACTIONS(3774),
    [anon_sym_with] = ACTIONS(3774),
    [anon_sym_return_BANG] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3774),
    [anon_sym_yield_BANG] = ACTIONS(3772),
    [anon_sym_lazy] = ACTIONS(3774),
    [anon_sym_assert] = ACTIONS(3774),
    [anon_sym_upcast] = ACTIONS(3774),
    [anon_sym_downcast] = ACTIONS(3774),
    [anon_sym_COLON_GT] = ACTIONS(3772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3774),
    [anon_sym_done] = ACTIONS(5288),
    [anon_sym_while] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3774),
    [anon_sym_fun] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3774),
    [anon_sym_match] = ACTIONS(3774),
    [anon_sym_match_BANG] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3774),
    [anon_sym_LT_DASH] = ACTIONS(3774),
    [anon_sym_DOT_LBRACK] = ACTIONS(3772),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_use] = ACTIONS(3774),
    [anon_sym_use_BANG] = ACTIONS(3772),
    [anon_sym_do_BANG] = ACTIONS(3772),
    [anon_sym_begin] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3774),
    [anon_sym_or] = ACTIONS(3774),
    [aux_sym_char_token1] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_AT_DQUOTE] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [sym_bool] = ACTIONS(3774),
    [sym_unit] = ACTIONS(3772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3774),
    [sym_op_identifier] = ACTIONS(3774),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_DOT] = ACTIONS(3774),
    [anon_sym_DASH_DOT] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3772),
    [aux_sym_prefix_op_token1] = ACTIONS(3774),
    [aux_sym_infix_op_token1] = ACTIONS(3772),
    [aux_sym_infix_op_token2] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3774),
    [anon_sym_COLON_EQ] = ACTIONS(3772),
    [anon_sym_DOLLAR] = ACTIONS(3774),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3774),
    [sym_int] = ACTIONS(3774),
    [sym_xint] = ACTIONS(3772),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3772),
    [sym__newline] = ACTIONS(3772),
    [sym__dedent] = ACTIONS(3772),
  },
  [2754] = {
    [sym_block_comment] = STATE(2754),
    [sym_compiler_directive_decl] = STATE(2754),
    [sym_fsi_directive_decl] = STATE(2754),
    [sym_preproc_line] = STATE(2754),
    [aux_sym_rules_repeat1] = STATE(2754),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(5290),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_DASH_GT] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_DOT_DOT] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_or] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [sym__newline] = ACTIONS(5293),
  },
  [2755] = {
    [sym_block_comment] = STATE(2755),
    [sym_compiler_directive_decl] = STATE(2755),
    [sym_fsi_directive_decl] = STATE(2755),
    [sym_preproc_line] = STATE(2755),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_RBRACK] = ACTIONS(3683),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(4914),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_DOT_DOT] = ACTIONS(4182),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_DOT_DOT2] = ACTIONS(3683),
    [anon_sym_or] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
  },
  [2756] = {
    [sym_block_comment] = STATE(2756),
    [sym_compiler_directive_decl] = STATE(2756),
    [sym_fsi_directive_decl] = STATE(2756),
    [sym_preproc_line] = STATE(2756),
    [aux_sym_rules_repeat1] = STATE(2754),
    [sym_identifier] = ACTIONS(3676),
    [anon_sym_EQ] = ACTIONS(3674),
    [anon_sym_COLON] = ACTIONS(3676),
    [anon_sym_return] = ACTIONS(3676),
    [anon_sym_do] = ACTIONS(3676),
    [anon_sym_let] = ACTIONS(3676),
    [anon_sym_let_BANG] = ACTIONS(3674),
    [anon_sym_LPAREN] = ACTIONS(3676),
    [anon_sym_COMMA] = ACTIONS(3674),
    [anon_sym_null] = ACTIONS(3676),
    [anon_sym_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_COLON] = ACTIONS(3674),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(3676),
    [anon_sym_LBRACK] = ACTIONS(3676),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3674),
    [anon_sym_LBRACE] = ACTIONS(3676),
    [anon_sym_LT_AT] = ACTIONS(3676),
    [anon_sym_LT_AT_AT] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3674),
    [anon_sym_new] = ACTIONS(3676),
    [anon_sym_return_BANG] = ACTIONS(3674),
    [anon_sym_yield] = ACTIONS(3676),
    [anon_sym_yield_BANG] = ACTIONS(3674),
    [anon_sym_lazy] = ACTIONS(3676),
    [anon_sym_assert] = ACTIONS(3676),
    [anon_sym_upcast] = ACTIONS(3676),
    [anon_sym_downcast] = ACTIONS(3676),
    [anon_sym_COLON_GT] = ACTIONS(3674),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3674),
    [anon_sym_for] = ACTIONS(3676),
    [anon_sym_while] = ACTIONS(3676),
    [anon_sym_if] = ACTIONS(3676),
    [anon_sym_fun] = ACTIONS(3676),
    [anon_sym_DASH_GT] = ACTIONS(3676),
    [anon_sym_try] = ACTIONS(3676),
    [anon_sym_match] = ACTIONS(3676),
    [anon_sym_match_BANG] = ACTIONS(3674),
    [anon_sym_function] = ACTIONS(3676),
    [anon_sym_LT_DASH] = ACTIONS(3676),
    [anon_sym_DOT_LBRACK] = ACTIONS(3674),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_use] = ACTIONS(3676),
    [anon_sym_use_BANG] = ACTIONS(3674),
    [anon_sym_do_BANG] = ACTIONS(3674),
    [anon_sym_DOT_DOT] = ACTIONS(3674),
    [anon_sym_begin] = ACTIONS(3676),
    [anon_sym_LPAREN2] = ACTIONS(3676),
    [anon_sym_or] = ACTIONS(3676),
    [aux_sym_char_token1] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3676),
    [anon_sym_DQUOTE] = ACTIONS(3676),
    [anon_sym_AT_DQUOTE] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [sym_bool] = ACTIONS(3676),
    [sym_unit] = ACTIONS(3674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3676),
    [sym_op_identifier] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_PLUS_DOT] = ACTIONS(3676),
    [anon_sym_DASH_DOT] = ACTIONS(3676),
    [anon_sym_PERCENT] = ACTIONS(3676),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_TILDE] = ACTIONS(3674),
    [aux_sym_prefix_op_token1] = ACTIONS(3676),
    [aux_sym_infix_op_token1] = ACTIONS(3674),
    [aux_sym_infix_op_token2] = ACTIONS(3676),
    [anon_sym_PIPE_PIPE] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3676),
    [anon_sym_COLON_EQ] = ACTIONS(3674),
    [anon_sym_DOLLAR] = ACTIONS(3676),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3676),
    [sym_int] = ACTIONS(3676),
    [sym_xint] = ACTIONS(3674),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3674),
    [sym__newline] = ACTIONS(5298),
  },
  [2757] = {
    [sym_block_comment] = STATE(2757),
    [sym_compiler_directive_decl] = STATE(2757),
    [sym_fsi_directive_decl] = STATE(2757),
    [sym_preproc_line] = STATE(2757),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [anon_sym_as] = ACTIONS(3743),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_with] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_or] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [sym__newline] = ACTIONS(3741),
    [sym__dedent] = ACTIONS(3741),
  },
  [2758] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defns] = STATE(11729),
    [sym__function_or_value_defn_body] = STATE(7291),
    [sym_function_declaration_left] = STATE(9771),
    [sym_value_declaration_left] = STATE(9771),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_property_accessor] = STATE(9374),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(2758),
    [sym_compiler_directive_decl] = STATE(2758),
    [sym_fsi_directive_decl] = STATE(2758),
    [sym_preproc_line] = STATE(2758),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [anon_sym_get] = ACTIONS(5233),
    [anon_sym_set] = ACTIONS(5233),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2759] = {
    [sym_block_comment] = STATE(2759),
    [sym_compiler_directive_decl] = STATE(2759),
    [sym_fsi_directive_decl] = STATE(2759),
    [sym_preproc_line] = STATE(2759),
    [sym_identifier] = ACTIONS(3800),
    [anon_sym_EQ] = ACTIONS(3798),
    [anon_sym_COLON] = ACTIONS(3800),
    [anon_sym_return] = ACTIONS(3800),
    [anon_sym_do] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_let_BANG] = ACTIONS(3798),
    [anon_sym_as] = ACTIONS(3800),
    [anon_sym_LPAREN] = ACTIONS(3800),
    [anon_sym_COMMA] = ACTIONS(3798),
    [anon_sym_null] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_COLON] = ACTIONS(3798),
    [anon_sym_PIPE] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3800),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3798),
    [anon_sym_LBRACE] = ACTIONS(3800),
    [anon_sym_LT_AT] = ACTIONS(3800),
    [anon_sym_LT_AT_AT] = ACTIONS(3800),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3798),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_with] = ACTIONS(3800),
    [anon_sym_return_BANG] = ACTIONS(3798),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_yield_BANG] = ACTIONS(3798),
    [anon_sym_lazy] = ACTIONS(3800),
    [anon_sym_assert] = ACTIONS(3800),
    [anon_sym_upcast] = ACTIONS(3800),
    [anon_sym_downcast] = ACTIONS(3800),
    [anon_sym_COLON_GT] = ACTIONS(3798),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3798),
    [anon_sym_for] = ACTIONS(3800),
    [anon_sym_while] = ACTIONS(3800),
    [anon_sym_if] = ACTIONS(3800),
    [anon_sym_fun] = ACTIONS(3800),
    [anon_sym_try] = ACTIONS(3800),
    [anon_sym_match] = ACTIONS(3800),
    [anon_sym_match_BANG] = ACTIONS(3798),
    [anon_sym_function] = ACTIONS(3800),
    [anon_sym_LT_DASH] = ACTIONS(3800),
    [anon_sym_DOT_LBRACK] = ACTIONS(3798),
    [anon_sym_LT] = ACTIONS(3798),
    [anon_sym_use] = ACTIONS(3800),
    [anon_sym_use_BANG] = ACTIONS(3798),
    [anon_sym_do_BANG] = ACTIONS(3798),
    [anon_sym_begin] = ACTIONS(3800),
    [anon_sym_LPAREN2] = ACTIONS(3800),
    [anon_sym_or] = ACTIONS(3800),
    [aux_sym_char_token1] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3800),
    [anon_sym_DQUOTE] = ACTIONS(3800),
    [anon_sym_AT_DQUOTE] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [sym_bool] = ACTIONS(3800),
    [sym_unit] = ACTIONS(3798),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3800),
    [sym_op_identifier] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS_DOT] = ACTIONS(3800),
    [anon_sym_DASH_DOT] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3800),
    [anon_sym_AMP_AMP] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3798),
    [aux_sym_prefix_op_token1] = ACTIONS(3800),
    [aux_sym_infix_op_token1] = ACTIONS(3798),
    [aux_sym_infix_op_token2] = ACTIONS(3800),
    [anon_sym_PIPE_PIPE] = ACTIONS(3800),
    [anon_sym_BANG_EQ] = ACTIONS(3800),
    [anon_sym_COLON_EQ] = ACTIONS(3798),
    [anon_sym_DOLLAR] = ACTIONS(3800),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3800),
    [sym_int] = ACTIONS(3800),
    [sym_xint] = ACTIONS(3798),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3798),
    [sym__newline] = ACTIONS(3798),
    [sym__dedent] = ACTIONS(3798),
  },
  [2760] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defns] = STATE(11817),
    [sym__function_or_value_defn_body] = STATE(7291),
    [sym_function_declaration_left] = STATE(9771),
    [sym_value_declaration_left] = STATE(9771),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_property_accessor] = STATE(9268),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(2760),
    [sym_compiler_directive_decl] = STATE(2760),
    [sym_fsi_directive_decl] = STATE(2760),
    [sym_preproc_line] = STATE(2760),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [anon_sym_get] = ACTIONS(5233),
    [anon_sym_set] = ACTIONS(5233),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2761] = {
    [sym_block_comment] = STATE(2761),
    [sym_compiler_directive_decl] = STATE(2761),
    [sym_fsi_directive_decl] = STATE(2761),
    [sym_preproc_line] = STATE(2761),
    [aux_sym_rules_repeat1] = STATE(2754),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_DASH_GT] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_DOT_DOT] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_or] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(5301),
  },
  [2762] = {
    [sym_block_comment] = STATE(2762),
    [sym_compiler_directive_decl] = STATE(2762),
    [sym_fsi_directive_decl] = STATE(2762),
    [sym_preproc_line] = STATE(2762),
    [sym_identifier] = ACTIONS(3753),
    [anon_sym_EQ] = ACTIONS(3751),
    [anon_sym_COLON] = ACTIONS(3753),
    [anon_sym_return] = ACTIONS(3753),
    [anon_sym_do] = ACTIONS(3753),
    [anon_sym_let] = ACTIONS(3753),
    [anon_sym_let_BANG] = ACTIONS(3751),
    [anon_sym_LPAREN] = ACTIONS(3753),
    [anon_sym_COMMA] = ACTIONS(3751),
    [anon_sym_null] = ACTIONS(3753),
    [anon_sym_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_COLON] = ACTIONS(3751),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3751),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_LT_AT] = ACTIONS(3753),
    [anon_sym_LT_AT_AT] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3753),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3751),
    [anon_sym_new] = ACTIONS(3753),
    [anon_sym_return_BANG] = ACTIONS(3751),
    [anon_sym_yield] = ACTIONS(3753),
    [anon_sym_yield_BANG] = ACTIONS(3751),
    [anon_sym_lazy] = ACTIONS(3753),
    [anon_sym_assert] = ACTIONS(3753),
    [anon_sym_upcast] = ACTIONS(3753),
    [anon_sym_downcast] = ACTIONS(3753),
    [anon_sym_COLON_GT] = ACTIONS(3751),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3751),
    [anon_sym_for] = ACTIONS(3753),
    [anon_sym_while] = ACTIONS(3753),
    [anon_sym_if] = ACTIONS(3753),
    [anon_sym_fun] = ACTIONS(3753),
    [anon_sym_DASH_GT] = ACTIONS(3753),
    [anon_sym_try] = ACTIONS(3753),
    [anon_sym_match] = ACTIONS(3753),
    [anon_sym_match_BANG] = ACTIONS(3751),
    [anon_sym_function] = ACTIONS(3753),
    [anon_sym_LT_DASH] = ACTIONS(3753),
    [anon_sym_DOT_LBRACK] = ACTIONS(3751),
    [anon_sym_LT] = ACTIONS(3751),
    [anon_sym_use] = ACTIONS(3753),
    [anon_sym_use_BANG] = ACTIONS(3751),
    [anon_sym_do_BANG] = ACTIONS(3751),
    [anon_sym_DOT_DOT] = ACTIONS(3751),
    [anon_sym_begin] = ACTIONS(3753),
    [anon_sym_LPAREN2] = ACTIONS(3753),
    [anon_sym_or] = ACTIONS(3753),
    [aux_sym_char_token1] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3753),
    [anon_sym_AT_DQUOTE] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [sym_bool] = ACTIONS(3753),
    [sym_unit] = ACTIONS(3751),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3753),
    [sym_op_identifier] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PLUS_DOT] = ACTIONS(3753),
    [anon_sym_DASH_DOT] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3753),
    [anon_sym_AMP_AMP] = ACTIONS(3753),
    [anon_sym_TILDE] = ACTIONS(3751),
    [aux_sym_prefix_op_token1] = ACTIONS(3753),
    [aux_sym_infix_op_token1] = ACTIONS(3751),
    [aux_sym_infix_op_token2] = ACTIONS(3753),
    [anon_sym_PIPE_PIPE] = ACTIONS(3753),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_COLON_EQ] = ACTIONS(3751),
    [anon_sym_DOLLAR] = ACTIONS(3753),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3753),
    [sym_int] = ACTIONS(5304),
    [sym_xint] = ACTIONS(3751),
    [anon_sym_f] = ACTIONS(3753),
    [aux_sym_decimal_token1] = ACTIONS(3753),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3751),
    [sym__newline] = ACTIONS(3751),
  },
  [2763] = {
    [sym_block_comment] = STATE(2763),
    [sym_compiler_directive_decl] = STATE(2763),
    [sym_fsi_directive_decl] = STATE(2763),
    [sym_preproc_line] = STATE(2763),
    [aux_sym_rules_repeat1] = STATE(2756),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_DASH_GT] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_DOT_DOT] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_or] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(5301),
  },
  [2764] = {
    [sym_block_comment] = STATE(2764),
    [sym_compiler_directive_decl] = STATE(2764),
    [sym_fsi_directive_decl] = STATE(2764),
    [sym_preproc_line] = STATE(2764),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [aux_sym_float_token1] = ACTIONS(5306),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [anon_sym_POUNDendif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
  },
  [2765] = {
    [sym_block_comment] = STATE(2765),
    [sym_compiler_directive_decl] = STATE(2765),
    [sym_fsi_directive_decl] = STATE(2765),
    [sym_preproc_line] = STATE(2765),
    [sym_identifier] = ACTIONS(3728),
    [anon_sym_EQ] = ACTIONS(3726),
    [anon_sym_COLON] = ACTIONS(3728),
    [anon_sym_return] = ACTIONS(3728),
    [anon_sym_do] = ACTIONS(3728),
    [anon_sym_let] = ACTIONS(3728),
    [anon_sym_let_BANG] = ACTIONS(3726),
    [anon_sym_as] = ACTIONS(3728),
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_COMMA] = ACTIONS(3726),
    [anon_sym_null] = ACTIONS(3728),
    [anon_sym_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(3726),
    [anon_sym_AMP] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3726),
    [anon_sym_LBRACE] = ACTIONS(3728),
    [anon_sym_LT_AT] = ACTIONS(3728),
    [anon_sym_LT_AT_AT] = ACTIONS(3728),
    [anon_sym_DOT] = ACTIONS(3728),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3726),
    [anon_sym_new] = ACTIONS(3728),
    [anon_sym_with] = ACTIONS(3728),
    [anon_sym_return_BANG] = ACTIONS(3726),
    [anon_sym_yield] = ACTIONS(3728),
    [anon_sym_yield_BANG] = ACTIONS(3726),
    [anon_sym_lazy] = ACTIONS(3728),
    [anon_sym_assert] = ACTIONS(3728),
    [anon_sym_upcast] = ACTIONS(3728),
    [anon_sym_downcast] = ACTIONS(3728),
    [anon_sym_COLON_GT] = ACTIONS(3726),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3726),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_fun] = ACTIONS(3728),
    [anon_sym_try] = ACTIONS(3728),
    [anon_sym_match] = ACTIONS(3728),
    [anon_sym_match_BANG] = ACTIONS(3726),
    [anon_sym_function] = ACTIONS(3728),
    [anon_sym_LT_DASH] = ACTIONS(3728),
    [anon_sym_DOT_LBRACK] = ACTIONS(3726),
    [anon_sym_LT] = ACTIONS(3726),
    [anon_sym_use] = ACTIONS(3728),
    [anon_sym_use_BANG] = ACTIONS(3726),
    [anon_sym_do_BANG] = ACTIONS(3726),
    [anon_sym_begin] = ACTIONS(3728),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [aux_sym_char_token1] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3728),
    [anon_sym_AT_DQUOTE] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [sym_bool] = ACTIONS(3728),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3728),
    [sym_op_identifier] = ACTIONS(3728),
    [anon_sym_PLUS] = ACTIONS(3728),
    [anon_sym_DASH] = ACTIONS(3728),
    [anon_sym_PLUS_DOT] = ACTIONS(3728),
    [anon_sym_DASH_DOT] = ACTIONS(3728),
    [anon_sym_PERCENT] = ACTIONS(3728),
    [anon_sym_AMP_AMP] = ACTIONS(3728),
    [anon_sym_TILDE] = ACTIONS(3726),
    [aux_sym_prefix_op_token1] = ACTIONS(3728),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token2] = ACTIONS(3728),
    [anon_sym_PIPE_PIPE] = ACTIONS(3728),
    [anon_sym_BANG_EQ] = ACTIONS(3728),
    [anon_sym_COLON_EQ] = ACTIONS(3726),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3728),
    [sym_int] = ACTIONS(3728),
    [sym_xint] = ACTIONS(3726),
    [anon_sym_f] = ACTIONS(3728),
    [aux_sym_decimal_token1] = ACTIONS(3728),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3726),
    [sym__newline] = ACTIONS(3726),
  },
  [2766] = {
    [sym_block_comment] = STATE(2766),
    [sym_compiler_directive_decl] = STATE(2766),
    [sym_fsi_directive_decl] = STATE(2766),
    [sym_preproc_line] = STATE(2766),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [anon_sym_POUNDendif] = ACTIONS(3602),
    [anon_sym_POUNDelse] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
  },
  [2767] = {
    [sym_block_comment] = STATE(2767),
    [sym_compiler_directive_decl] = STATE(2767),
    [sym_fsi_directive_decl] = STATE(2767),
    [sym_preproc_line] = STATE(2767),
    [sym_identifier] = ACTIONS(3753),
    [anon_sym_EQ] = ACTIONS(3751),
    [anon_sym_COLON] = ACTIONS(3753),
    [anon_sym_return] = ACTIONS(3753),
    [anon_sym_do] = ACTIONS(3753),
    [anon_sym_and] = ACTIONS(3753),
    [anon_sym_let] = ACTIONS(3753),
    [anon_sym_let_BANG] = ACTIONS(3751),
    [anon_sym_LPAREN] = ACTIONS(3753),
    [anon_sym_COMMA] = ACTIONS(3751),
    [anon_sym_null] = ACTIONS(3753),
    [anon_sym_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_COLON] = ACTIONS(3751),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3751),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_LT_AT] = ACTIONS(3753),
    [anon_sym_LT_AT_AT] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3753),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3751),
    [anon_sym_new] = ACTIONS(3753),
    [anon_sym_return_BANG] = ACTIONS(3751),
    [anon_sym_yield] = ACTIONS(3753),
    [anon_sym_yield_BANG] = ACTIONS(3751),
    [anon_sym_lazy] = ACTIONS(3753),
    [anon_sym_assert] = ACTIONS(3753),
    [anon_sym_upcast] = ACTIONS(3753),
    [anon_sym_downcast] = ACTIONS(3753),
    [anon_sym_COLON_GT] = ACTIONS(3751),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3751),
    [anon_sym_for] = ACTIONS(3753),
    [anon_sym_while] = ACTIONS(3753),
    [anon_sym_if] = ACTIONS(3753),
    [anon_sym_fun] = ACTIONS(3753),
    [anon_sym_try] = ACTIONS(3753),
    [anon_sym_match] = ACTIONS(3753),
    [anon_sym_match_BANG] = ACTIONS(3751),
    [anon_sym_function] = ACTIONS(3753),
    [anon_sym_LT_DASH] = ACTIONS(3753),
    [anon_sym_DOT_LBRACK] = ACTIONS(3751),
    [anon_sym_LT] = ACTIONS(3751),
    [anon_sym_use] = ACTIONS(3753),
    [anon_sym_use_BANG] = ACTIONS(3751),
    [anon_sym_do_BANG] = ACTIONS(3751),
    [anon_sym_begin] = ACTIONS(3753),
    [anon_sym_LPAREN2] = ACTIONS(3753),
    [anon_sym_or] = ACTIONS(3753),
    [aux_sym_char_token1] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3753),
    [anon_sym_AT_DQUOTE] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [sym_bool] = ACTIONS(3753),
    [sym_unit] = ACTIONS(3751),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3753),
    [sym_op_identifier] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PLUS_DOT] = ACTIONS(3753),
    [anon_sym_DASH_DOT] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3753),
    [anon_sym_AMP_AMP] = ACTIONS(3753),
    [anon_sym_TILDE] = ACTIONS(3751),
    [aux_sym_prefix_op_token1] = ACTIONS(3753),
    [aux_sym_infix_op_token1] = ACTIONS(3751),
    [aux_sym_infix_op_token2] = ACTIONS(3753),
    [anon_sym_PIPE_PIPE] = ACTIONS(3753),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_COLON_EQ] = ACTIONS(3751),
    [anon_sym_DOLLAR] = ACTIONS(3753),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3753),
    [sym_int] = ACTIONS(5308),
    [sym_xint] = ACTIONS(3751),
    [anon_sym_f] = ACTIONS(3753),
    [aux_sym_decimal_token1] = ACTIONS(3753),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3751),
    [sym__newline] = ACTIONS(3751),
    [sym__dedent] = ACTIONS(3751),
  },
  [2768] = {
    [sym_block_comment] = STATE(2768),
    [sym_compiler_directive_decl] = STATE(2768),
    [sym_fsi_directive_decl] = STATE(2768),
    [sym_preproc_line] = STATE(2768),
    [sym_identifier] = ACTIONS(3732),
    [anon_sym_EQ] = ACTIONS(3730),
    [anon_sym_COLON] = ACTIONS(3732),
    [anon_sym_return] = ACTIONS(3732),
    [anon_sym_do] = ACTIONS(3732),
    [anon_sym_let] = ACTIONS(3732),
    [anon_sym_let_BANG] = ACTIONS(3730),
    [anon_sym_as] = ACTIONS(3732),
    [anon_sym_LPAREN] = ACTIONS(3732),
    [anon_sym_COMMA] = ACTIONS(3730),
    [anon_sym_null] = ACTIONS(3732),
    [anon_sym_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_LBRACK] = ACTIONS(3732),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3730),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_LT_AT] = ACTIONS(3732),
    [anon_sym_LT_AT_AT] = ACTIONS(3732),
    [anon_sym_DOT] = ACTIONS(3732),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3730),
    [anon_sym_new] = ACTIONS(3732),
    [anon_sym_with] = ACTIONS(3732),
    [anon_sym_return_BANG] = ACTIONS(3730),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_yield_BANG] = ACTIONS(3730),
    [anon_sym_lazy] = ACTIONS(3732),
    [anon_sym_assert] = ACTIONS(3732),
    [anon_sym_upcast] = ACTIONS(3732),
    [anon_sym_downcast] = ACTIONS(3732),
    [anon_sym_COLON_GT] = ACTIONS(3730),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3730),
    [anon_sym_for] = ACTIONS(3732),
    [anon_sym_while] = ACTIONS(3732),
    [anon_sym_else] = ACTIONS(3732),
    [anon_sym_elif] = ACTIONS(3732),
    [anon_sym_if] = ACTIONS(3732),
    [anon_sym_fun] = ACTIONS(3732),
    [anon_sym_try] = ACTIONS(3732),
    [anon_sym_match] = ACTIONS(3732),
    [anon_sym_match_BANG] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3732),
    [anon_sym_LT_DASH] = ACTIONS(3732),
    [anon_sym_DOT_LBRACK] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3730),
    [anon_sym_use] = ACTIONS(3732),
    [anon_sym_use_BANG] = ACTIONS(3730),
    [anon_sym_do_BANG] = ACTIONS(3730),
    [anon_sym_begin] = ACTIONS(3732),
    [anon_sym_LPAREN2] = ACTIONS(3732),
    [anon_sym_or] = ACTIONS(3732),
    [aux_sym_char_token1] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3732),
    [anon_sym_DQUOTE] = ACTIONS(3732),
    [anon_sym_AT_DQUOTE] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [sym_bool] = ACTIONS(3732),
    [sym_unit] = ACTIONS(3730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3732),
    [sym_op_identifier] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PLUS_DOT] = ACTIONS(3732),
    [anon_sym_DASH_DOT] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3732),
    [anon_sym_AMP_AMP] = ACTIONS(3732),
    [anon_sym_TILDE] = ACTIONS(3730),
    [aux_sym_prefix_op_token1] = ACTIONS(3732),
    [aux_sym_infix_op_token1] = ACTIONS(3730),
    [aux_sym_infix_op_token2] = ACTIONS(3732),
    [anon_sym_PIPE_PIPE] = ACTIONS(3732),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_COLON_EQ] = ACTIONS(3730),
    [anon_sym_DOLLAR] = ACTIONS(3732),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3732),
    [sym_int] = ACTIONS(3732),
    [sym_xint] = ACTIONS(3730),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3730),
    [sym__newline] = ACTIONS(3730),
  },
  [2769] = {
    [sym_block_comment] = STATE(2769),
    [sym_compiler_directive_decl] = STATE(2769),
    [sym_fsi_directive_decl] = STATE(2769),
    [sym_preproc_line] = STATE(2769),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [anon_sym_as] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_with] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(5310),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_DOT_DOT] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
  },
  [2770] = {
    [sym_block_comment] = STATE(2770),
    [sym_compiler_directive_decl] = STATE(2770),
    [sym_fsi_directive_decl] = STATE(2770),
    [sym_preproc_line] = STATE(2770),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_as] = ACTIONS(3193),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_f] = ACTIONS(4603),
    [aux_sym_decimal_token1] = ACTIONS(4279),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [2771] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defns] = STATE(11940),
    [sym__function_or_value_defn_body] = STATE(7291),
    [sym_function_declaration_left] = STATE(9771),
    [sym_value_declaration_left] = STATE(9771),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_property_accessor] = STATE(9153),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(2771),
    [sym_compiler_directive_decl] = STATE(2771),
    [sym_fsi_directive_decl] = STATE(2771),
    [sym_preproc_line] = STATE(2771),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [anon_sym_get] = ACTIONS(5233),
    [anon_sym_set] = ACTIONS(5233),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2772] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defns] = STATE(10912),
    [sym__function_or_value_defn_body] = STATE(7291),
    [sym_function_declaration_left] = STATE(9771),
    [sym_value_declaration_left] = STATE(9771),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_property_accessor] = STATE(9007),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(2772),
    [sym_compiler_directive_decl] = STATE(2772),
    [sym_fsi_directive_decl] = STATE(2772),
    [sym_preproc_line] = STATE(2772),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [anon_sym_get] = ACTIONS(5233),
    [anon_sym_set] = ACTIONS(5233),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2773] = {
    [sym_block_comment] = STATE(2773),
    [sym_compiler_directive_decl] = STATE(2773),
    [sym_fsi_directive_decl] = STATE(2773),
    [sym_preproc_line] = STATE(2773),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_GT] = ACTIONS(3604),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [aux_sym_float_token1] = ACTIONS(5312),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
  },
  [2774] = {
    [sym_block_comment] = STATE(2774),
    [sym_compiler_directive_decl] = STATE(2774),
    [sym_fsi_directive_decl] = STATE(2774),
    [sym_preproc_line] = STATE(2774),
    [aux_sym_long_identifier_repeat1] = STATE(2750),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3451),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(5314),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_or] = ACTIONS(3451),
    [anon_sym_EQ2] = ACTIONS(3449),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
    [sym__dedent] = ACTIONS(3449),
  },
  [2775] = {
    [sym_block_comment] = STATE(2775),
    [sym_compiler_directive_decl] = STATE(2775),
    [sym_fsi_directive_decl] = STATE(2775),
    [sym_preproc_line] = STATE(2775),
    [aux_sym_long_identifier_repeat1] = STATE(2774),
    [sym_identifier] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3781),
    [anon_sym_COLON] = ACTIONS(3781),
    [anon_sym_return] = ACTIONS(3781),
    [anon_sym_do] = ACTIONS(3781),
    [anon_sym_let] = ACTIONS(3781),
    [anon_sym_let_BANG] = ACTIONS(3778),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3778),
    [anon_sym_null] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3781),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_LT_AT] = ACTIONS(3781),
    [anon_sym_LT_AT_AT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(5316),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3778),
    [anon_sym_new] = ACTIONS(3781),
    [anon_sym_with] = ACTIONS(3781),
    [anon_sym_return_BANG] = ACTIONS(3778),
    [anon_sym_yield] = ACTIONS(3781),
    [anon_sym_yield_BANG] = ACTIONS(3778),
    [anon_sym_lazy] = ACTIONS(3781),
    [anon_sym_assert] = ACTIONS(3781),
    [anon_sym_upcast] = ACTIONS(3781),
    [anon_sym_downcast] = ACTIONS(3781),
    [anon_sym_COLON_GT] = ACTIONS(3778),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3778),
    [anon_sym_for] = ACTIONS(3781),
    [anon_sym_while] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_fun] = ACTIONS(3781),
    [anon_sym_try] = ACTIONS(3781),
    [anon_sym_match] = ACTIONS(3781),
    [anon_sym_match_BANG] = ACTIONS(3778),
    [anon_sym_function] = ACTIONS(3781),
    [anon_sym_LT_DASH] = ACTIONS(3781),
    [anon_sym_DOT_LBRACK] = ACTIONS(3778),
    [anon_sym_LT] = ACTIONS(3778),
    [anon_sym_use] = ACTIONS(3781),
    [anon_sym_use_BANG] = ACTIONS(3778),
    [anon_sym_do_BANG] = ACTIONS(3778),
    [anon_sym_begin] = ACTIONS(3781),
    [anon_sym_LPAREN2] = ACTIONS(3781),
    [anon_sym_or] = ACTIONS(3781),
    [anon_sym_EQ2] = ACTIONS(3492),
    [aux_sym_char_token1] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3781),
    [anon_sym_DQUOTE] = ACTIONS(3781),
    [anon_sym_AT_DQUOTE] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [sym_bool] = ACTIONS(3781),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3781),
    [sym_op_identifier] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3781),
    [anon_sym_DASH] = ACTIONS(3781),
    [anon_sym_PLUS_DOT] = ACTIONS(3781),
    [anon_sym_DASH_DOT] = ACTIONS(3781),
    [anon_sym_PERCENT] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3781),
    [anon_sym_TILDE] = ACTIONS(3778),
    [aux_sym_prefix_op_token1] = ACTIONS(3781),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token2] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_COLON_EQ] = ACTIONS(3778),
    [anon_sym_DOLLAR] = ACTIONS(3781),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3781),
    [sym_int] = ACTIONS(3781),
    [sym_xint] = ACTIONS(3778),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3778),
    [sym__newline] = ACTIONS(3778),
    [sym__dedent] = ACTIONS(3778),
  },
  [2776] = {
    [sym_block_comment] = STATE(2776),
    [sym_compiler_directive_decl] = STATE(2776),
    [sym_fsi_directive_decl] = STATE(2776),
    [sym_preproc_line] = STATE(2776),
    [sym_identifier] = ACTIONS(3753),
    [anon_sym_EQ] = ACTIONS(3751),
    [anon_sym_COLON] = ACTIONS(3753),
    [anon_sym_return] = ACTIONS(3753),
    [anon_sym_do] = ACTIONS(3753),
    [anon_sym_let] = ACTIONS(3753),
    [anon_sym_let_BANG] = ACTIONS(3751),
    [anon_sym_LPAREN] = ACTIONS(3753),
    [anon_sym_COMMA] = ACTIONS(3751),
    [anon_sym_null] = ACTIONS(3753),
    [anon_sym_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_COLON] = ACTIONS(3751),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3751),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_LT_AT] = ACTIONS(3753),
    [anon_sym_LT_AT_AT] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3753),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3751),
    [anon_sym_new] = ACTIONS(3753),
    [anon_sym_return_BANG] = ACTIONS(3751),
    [anon_sym_yield] = ACTIONS(3753),
    [anon_sym_yield_BANG] = ACTIONS(3751),
    [anon_sym_lazy] = ACTIONS(3753),
    [anon_sym_assert] = ACTIONS(3753),
    [anon_sym_upcast] = ACTIONS(3753),
    [anon_sym_downcast] = ACTIONS(3753),
    [anon_sym_COLON_GT] = ACTIONS(3751),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3751),
    [anon_sym_for] = ACTIONS(3753),
    [anon_sym_while] = ACTIONS(3753),
    [anon_sym_if] = ACTIONS(3753),
    [anon_sym_fun] = ACTIONS(3753),
    [anon_sym_try] = ACTIONS(3753),
    [anon_sym_match] = ACTIONS(3753),
    [anon_sym_match_BANG] = ACTIONS(3751),
    [anon_sym_function] = ACTIONS(3753),
    [anon_sym_LT_DASH] = ACTIONS(3753),
    [anon_sym_DOT_LBRACK] = ACTIONS(3751),
    [anon_sym_LT] = ACTIONS(3751),
    [anon_sym_use] = ACTIONS(3753),
    [anon_sym_use_BANG] = ACTIONS(3751),
    [anon_sym_do_BANG] = ACTIONS(3751),
    [anon_sym_begin] = ACTIONS(3753),
    [anon_sym_LPAREN2] = ACTIONS(3753),
    [anon_sym_or] = ACTIONS(3753),
    [aux_sym_char_token1] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3753),
    [anon_sym_AT_DQUOTE] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [sym_bool] = ACTIONS(3753),
    [sym_unit] = ACTIONS(3751),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3753),
    [sym_op_identifier] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PLUS_DOT] = ACTIONS(3753),
    [anon_sym_DASH_DOT] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3753),
    [anon_sym_AMP_AMP] = ACTIONS(3753),
    [anon_sym_TILDE] = ACTIONS(3751),
    [aux_sym_prefix_op_token1] = ACTIONS(3753),
    [aux_sym_infix_op_token1] = ACTIONS(3751),
    [aux_sym_infix_op_token2] = ACTIONS(3753),
    [anon_sym_PIPE_PIPE] = ACTIONS(3753),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_COLON_EQ] = ACTIONS(3751),
    [anon_sym_DOLLAR] = ACTIONS(3753),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3753),
    [sym_int] = ACTIONS(5320),
    [sym_xint] = ACTIONS(3751),
    [anon_sym_f] = ACTIONS(3753),
    [aux_sym_decimal_token1] = ACTIONS(3753),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3751),
    [anon_sym_POUNDendif] = ACTIONS(3751),
    [anon_sym_POUNDelse] = ACTIONS(3751),
    [sym__newline] = ACTIONS(3751),
  },
  [2777] = {
    [sym_block_comment] = STATE(2777),
    [sym_compiler_directive_decl] = STATE(2777),
    [sym_fsi_directive_decl] = STATE(2777),
    [sym_preproc_line] = STATE(2777),
    [aux_sym_rules_repeat1] = STATE(2761),
    [sym_identifier] = ACTIONS(3736),
    [anon_sym_EQ] = ACTIONS(3734),
    [anon_sym_COLON] = ACTIONS(3736),
    [anon_sym_return] = ACTIONS(3736),
    [anon_sym_do] = ACTIONS(3736),
    [anon_sym_let] = ACTIONS(3736),
    [anon_sym_let_BANG] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3736),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_null] = ACTIONS(3736),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_COLON] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(3736),
    [anon_sym_LBRACK] = ACTIONS(3736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3734),
    [anon_sym_LBRACE] = ACTIONS(3736),
    [anon_sym_LT_AT] = ACTIONS(3736),
    [anon_sym_LT_AT_AT] = ACTIONS(3736),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3734),
    [anon_sym_new] = ACTIONS(3736),
    [anon_sym_return_BANG] = ACTIONS(3734),
    [anon_sym_yield] = ACTIONS(3736),
    [anon_sym_yield_BANG] = ACTIONS(3734),
    [anon_sym_lazy] = ACTIONS(3736),
    [anon_sym_assert] = ACTIONS(3736),
    [anon_sym_upcast] = ACTIONS(3736),
    [anon_sym_downcast] = ACTIONS(3736),
    [anon_sym_COLON_GT] = ACTIONS(3734),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3734),
    [anon_sym_for] = ACTIONS(3736),
    [anon_sym_while] = ACTIONS(3736),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_fun] = ACTIONS(3736),
    [anon_sym_DASH_GT] = ACTIONS(3736),
    [anon_sym_try] = ACTIONS(3736),
    [anon_sym_match] = ACTIONS(3736),
    [anon_sym_match_BANG] = ACTIONS(3734),
    [anon_sym_function] = ACTIONS(3736),
    [anon_sym_LT_DASH] = ACTIONS(3736),
    [anon_sym_DOT_LBRACK] = ACTIONS(3734),
    [anon_sym_LT] = ACTIONS(3734),
    [anon_sym_use] = ACTIONS(3736),
    [anon_sym_use_BANG] = ACTIONS(3734),
    [anon_sym_do_BANG] = ACTIONS(3734),
    [anon_sym_DOT_DOT] = ACTIONS(3734),
    [anon_sym_begin] = ACTIONS(3736),
    [anon_sym_LPAREN2] = ACTIONS(3736),
    [anon_sym_or] = ACTIONS(3736),
    [aux_sym_char_token1] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3736),
    [anon_sym_DQUOTE] = ACTIONS(3736),
    [anon_sym_AT_DQUOTE] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [sym_bool] = ACTIONS(3736),
    [sym_unit] = ACTIONS(3734),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3736),
    [sym_op_identifier] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS_DOT] = ACTIONS(3736),
    [anon_sym_DASH_DOT] = ACTIONS(3736),
    [anon_sym_PERCENT] = ACTIONS(3736),
    [anon_sym_AMP_AMP] = ACTIONS(3736),
    [anon_sym_TILDE] = ACTIONS(3734),
    [aux_sym_prefix_op_token1] = ACTIONS(3736),
    [aux_sym_infix_op_token1] = ACTIONS(3734),
    [aux_sym_infix_op_token2] = ACTIONS(3736),
    [anon_sym_PIPE_PIPE] = ACTIONS(3736),
    [anon_sym_BANG_EQ] = ACTIONS(3736),
    [anon_sym_COLON_EQ] = ACTIONS(3734),
    [anon_sym_DOLLAR] = ACTIONS(3736),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3736),
    [sym_int] = ACTIONS(3736),
    [sym_xint] = ACTIONS(3734),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3734),
    [sym__newline] = ACTIONS(5322),
  },
  [2778] = {
    [sym_block_comment] = STATE(2778),
    [sym_compiler_directive_decl] = STATE(2778),
    [sym_fsi_directive_decl] = STATE(2778),
    [sym_preproc_line] = STATE(2778),
    [sym_identifier] = ACTIONS(3728),
    [anon_sym_EQ] = ACTIONS(3726),
    [anon_sym_COLON] = ACTIONS(3728),
    [anon_sym_return] = ACTIONS(3728),
    [anon_sym_do] = ACTIONS(3728),
    [anon_sym_let] = ACTIONS(3728),
    [anon_sym_let_BANG] = ACTIONS(3726),
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_COMMA] = ACTIONS(3726),
    [anon_sym_null] = ACTIONS(3728),
    [anon_sym_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(3726),
    [anon_sym_AMP] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3726),
    [anon_sym_LBRACE] = ACTIONS(3728),
    [anon_sym_LT_AT] = ACTIONS(3728),
    [anon_sym_LT_AT_AT] = ACTIONS(3728),
    [anon_sym_DOT] = ACTIONS(3728),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3726),
    [anon_sym_new] = ACTIONS(3728),
    [anon_sym_return_BANG] = ACTIONS(3726),
    [anon_sym_yield] = ACTIONS(3728),
    [anon_sym_yield_BANG] = ACTIONS(3726),
    [anon_sym_lazy] = ACTIONS(3728),
    [anon_sym_assert] = ACTIONS(3728),
    [anon_sym_upcast] = ACTIONS(3728),
    [anon_sym_downcast] = ACTIONS(3728),
    [anon_sym_COLON_GT] = ACTIONS(3726),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3726),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_fun] = ACTIONS(3728),
    [anon_sym_DASH_GT] = ACTIONS(3728),
    [anon_sym_try] = ACTIONS(3728),
    [anon_sym_match] = ACTIONS(3728),
    [anon_sym_match_BANG] = ACTIONS(3726),
    [anon_sym_function] = ACTIONS(3728),
    [anon_sym_LT_DASH] = ACTIONS(3728),
    [anon_sym_DOT_LBRACK] = ACTIONS(3726),
    [anon_sym_LT] = ACTIONS(3726),
    [anon_sym_use] = ACTIONS(3728),
    [anon_sym_use_BANG] = ACTIONS(3726),
    [anon_sym_do_BANG] = ACTIONS(3726),
    [anon_sym_DOT_DOT] = ACTIONS(3726),
    [anon_sym_begin] = ACTIONS(3728),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [aux_sym_char_token1] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3728),
    [anon_sym_AT_DQUOTE] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [sym_bool] = ACTIONS(3728),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3728),
    [sym_op_identifier] = ACTIONS(3728),
    [anon_sym_PLUS] = ACTIONS(3728),
    [anon_sym_DASH] = ACTIONS(3728),
    [anon_sym_PLUS_DOT] = ACTIONS(3728),
    [anon_sym_DASH_DOT] = ACTIONS(3728),
    [anon_sym_PERCENT] = ACTIONS(3728),
    [anon_sym_AMP_AMP] = ACTIONS(3728),
    [anon_sym_TILDE] = ACTIONS(3726),
    [aux_sym_prefix_op_token1] = ACTIONS(3728),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token2] = ACTIONS(3728),
    [anon_sym_PIPE_PIPE] = ACTIONS(3728),
    [anon_sym_BANG_EQ] = ACTIONS(3728),
    [anon_sym_COLON_EQ] = ACTIONS(3726),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3728),
    [sym_int] = ACTIONS(3728),
    [sym_xint] = ACTIONS(3726),
    [anon_sym_f] = ACTIONS(3728),
    [aux_sym_decimal_token1] = ACTIONS(3728),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3726),
    [sym__newline] = ACTIONS(3726),
  },
  [2779] = {
    [sym_block_comment] = STATE(2779),
    [sym_compiler_directive_decl] = STATE(2779),
    [sym_fsi_directive_decl] = STATE(2779),
    [sym_preproc_line] = STATE(2779),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_DOT_DOT] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [aux_sym_float_token1] = ACTIONS(5325),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
  },
  [2780] = {
    [sym_block_comment] = STATE(2780),
    [sym_compiler_directive_decl] = STATE(2780),
    [sym_fsi_directive_decl] = STATE(2780),
    [sym_preproc_line] = STATE(2780),
    [aux_sym_long_identifier_repeat1] = STATE(2780),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_as] = ACTIONS(3487),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(5327),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
    [sym__dedent] = ACTIONS(3485),
  },
  [2781] = {
    [sym_block_comment] = STATE(2781),
    [sym_compiler_directive_decl] = STATE(2781),
    [sym_fsi_directive_decl] = STATE(2781),
    [sym_preproc_line] = STATE(2781),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_and] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
    [sym__dedent] = ACTIONS(3602),
  },
  [2782] = {
    [sym_block_comment] = STATE(2782),
    [sym_compiler_directive_decl] = STATE(2782),
    [sym_fsi_directive_decl] = STATE(2782),
    [sym_preproc_line] = STATE(2782),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_DASH_GT] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_DOT_DOT] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
  },
  [2783] = {
    [sym_block_comment] = STATE(2783),
    [sym_compiler_directive_decl] = STATE(2783),
    [sym_fsi_directive_decl] = STATE(2783),
    [sym_preproc_line] = STATE(2783),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_as] = ACTIONS(3700),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
    [sym__dedent] = ACTIONS(3698),
  },
  [2784] = {
    [sym_block_comment] = STATE(2784),
    [sym_compiler_directive_decl] = STATE(2784),
    [sym_fsi_directive_decl] = STATE(2784),
    [sym_preproc_line] = STATE(2784),
    [sym_identifier] = ACTIONS(3753),
    [anon_sym_EQ] = ACTIONS(3751),
    [anon_sym_COLON] = ACTIONS(3753),
    [anon_sym_return] = ACTIONS(3753),
    [anon_sym_do] = ACTIONS(3753),
    [anon_sym_let] = ACTIONS(3753),
    [anon_sym_let_BANG] = ACTIONS(3751),
    [anon_sym_LPAREN] = ACTIONS(3753),
    [anon_sym_COMMA] = ACTIONS(3751),
    [anon_sym_null] = ACTIONS(3753),
    [anon_sym_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_COLON] = ACTIONS(3751),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3751),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_LT_AT] = ACTIONS(3753),
    [anon_sym_LT_AT_AT] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3753),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3751),
    [anon_sym_new] = ACTIONS(3753),
    [anon_sym_return_BANG] = ACTIONS(3751),
    [anon_sym_yield] = ACTIONS(3753),
    [anon_sym_yield_BANG] = ACTIONS(3751),
    [anon_sym_lazy] = ACTIONS(3753),
    [anon_sym_assert] = ACTIONS(3753),
    [anon_sym_upcast] = ACTIONS(3753),
    [anon_sym_downcast] = ACTIONS(3753),
    [anon_sym_COLON_GT] = ACTIONS(3751),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3751),
    [anon_sym_for] = ACTIONS(3753),
    [anon_sym_while] = ACTIONS(3753),
    [anon_sym_if] = ACTIONS(3753),
    [anon_sym_fun] = ACTIONS(3753),
    [anon_sym_try] = ACTIONS(3753),
    [anon_sym_match] = ACTIONS(3753),
    [anon_sym_match_BANG] = ACTIONS(3751),
    [anon_sym_function] = ACTIONS(3753),
    [anon_sym_LT_DASH] = ACTIONS(3753),
    [anon_sym_DOT_LBRACK] = ACTIONS(3751),
    [anon_sym_LT] = ACTIONS(3751),
    [anon_sym_use] = ACTIONS(3753),
    [anon_sym_use_BANG] = ACTIONS(3751),
    [anon_sym_do_BANG] = ACTIONS(3751),
    [anon_sym_begin] = ACTIONS(3753),
    [anon_sym_LPAREN2] = ACTIONS(3753),
    [anon_sym_or] = ACTIONS(3753),
    [aux_sym_char_token1] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3753),
    [anon_sym_AT_DQUOTE] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [sym_bool] = ACTIONS(3753),
    [sym_unit] = ACTIONS(3751),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3753),
    [sym_op_identifier] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PLUS_DOT] = ACTIONS(3753),
    [anon_sym_DASH_DOT] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3753),
    [anon_sym_AMP_AMP] = ACTIONS(3753),
    [anon_sym_TILDE] = ACTIONS(3751),
    [aux_sym_prefix_op_token1] = ACTIONS(3753),
    [aux_sym_infix_op_token1] = ACTIONS(3751),
    [aux_sym_infix_op_token2] = ACTIONS(3753),
    [anon_sym_PIPE_PIPE] = ACTIONS(3753),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_COLON_EQ] = ACTIONS(3751),
    [anon_sym_DOLLAR] = ACTIONS(3753),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3753),
    [sym_int] = ACTIONS(5330),
    [sym_xint] = ACTIONS(3751),
    [anon_sym_f] = ACTIONS(3753),
    [aux_sym_decimal_token1] = ACTIONS(3753),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3751),
    [anon_sym_POUNDendif] = ACTIONS(3751),
    [sym__newline] = ACTIONS(3751),
  },
  [2785] = {
    [sym_block_comment] = STATE(2785),
    [sym_compiler_directive_decl] = STATE(2785),
    [sym_fsi_directive_decl] = STATE(2785),
    [sym_preproc_line] = STATE(2785),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_AT_GT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_f] = ACTIONS(4704),
    [aux_sym_decimal_token1] = ACTIONS(4386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [2786] = {
    [sym_block_comment] = STATE(2786),
    [sym_compiler_directive_decl] = STATE(2786),
    [sym_fsi_directive_decl] = STATE(2786),
    [sym_preproc_line] = STATE(2786),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_GT] = ACTIONS(3604),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
  },
  [2787] = {
    [sym_block_comment] = STATE(2787),
    [sym_compiler_directive_decl] = STATE(2787),
    [sym_fsi_directive_decl] = STATE(2787),
    [sym_preproc_line] = STATE(2787),
    [sym_identifier] = ACTIONS(3753),
    [anon_sym_EQ] = ACTIONS(3751),
    [anon_sym_COLON] = ACTIONS(3753),
    [anon_sym_return] = ACTIONS(3753),
    [anon_sym_do] = ACTIONS(3753),
    [anon_sym_let] = ACTIONS(3753),
    [anon_sym_let_BANG] = ACTIONS(3751),
    [anon_sym_LPAREN] = ACTIONS(3753),
    [anon_sym_COMMA] = ACTIONS(3751),
    [anon_sym_null] = ACTIONS(3753),
    [anon_sym_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_COLON] = ACTIONS(3751),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3751),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_LT_AT] = ACTIONS(3753),
    [anon_sym_LT_AT_AT] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3753),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3751),
    [anon_sym_new] = ACTIONS(3753),
    [anon_sym_return_BANG] = ACTIONS(3751),
    [anon_sym_yield] = ACTIONS(3753),
    [anon_sym_yield_BANG] = ACTIONS(3751),
    [anon_sym_lazy] = ACTIONS(3753),
    [anon_sym_assert] = ACTIONS(3753),
    [anon_sym_upcast] = ACTIONS(3753),
    [anon_sym_downcast] = ACTIONS(3753),
    [anon_sym_COLON_GT] = ACTIONS(3751),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3751),
    [anon_sym_for] = ACTIONS(3753),
    [anon_sym_while] = ACTIONS(3753),
    [anon_sym_if] = ACTIONS(3753),
    [anon_sym_fun] = ACTIONS(3753),
    [anon_sym_try] = ACTIONS(3753),
    [anon_sym_match] = ACTIONS(3753),
    [anon_sym_match_BANG] = ACTIONS(3751),
    [anon_sym_function] = ACTIONS(3753),
    [anon_sym_LT_DASH] = ACTIONS(3753),
    [anon_sym_DOT_LBRACK] = ACTIONS(3751),
    [anon_sym_LT] = ACTIONS(3751),
    [anon_sym_GT] = ACTIONS(3753),
    [anon_sym_use] = ACTIONS(3753),
    [anon_sym_use_BANG] = ACTIONS(3751),
    [anon_sym_do_BANG] = ACTIONS(3751),
    [anon_sym_begin] = ACTIONS(3753),
    [anon_sym_LPAREN2] = ACTIONS(3753),
    [anon_sym_or] = ACTIONS(3753),
    [aux_sym_char_token1] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3753),
    [anon_sym_AT_DQUOTE] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [sym_bool] = ACTIONS(3753),
    [sym_unit] = ACTIONS(3751),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3753),
    [sym_op_identifier] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PLUS_DOT] = ACTIONS(3753),
    [anon_sym_DASH_DOT] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3753),
    [anon_sym_AMP_AMP] = ACTIONS(3753),
    [anon_sym_TILDE] = ACTIONS(3751),
    [aux_sym_prefix_op_token1] = ACTIONS(3753),
    [aux_sym_infix_op_token1] = ACTIONS(3751),
    [aux_sym_infix_op_token2] = ACTIONS(3753),
    [anon_sym_PIPE_PIPE] = ACTIONS(3753),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_COLON_EQ] = ACTIONS(3751),
    [anon_sym_DOLLAR] = ACTIONS(3753),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3753),
    [sym_int] = ACTIONS(5332),
    [sym_xint] = ACTIONS(3751),
    [anon_sym_f] = ACTIONS(3753),
    [aux_sym_decimal_token1] = ACTIONS(3753),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3751),
    [sym__newline] = ACTIONS(3751),
  },
  [2788] = {
    [sym_block_comment] = STATE(2788),
    [sym_compiler_directive_decl] = STATE(2788),
    [sym_fsi_directive_decl] = STATE(2788),
    [sym_preproc_line] = STATE(2788),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_EQ] = ACTIONS(3646),
    [anon_sym_COLON] = ACTIONS(3648),
    [anon_sym_return] = ACTIONS(3648),
    [anon_sym_do] = ACTIONS(3648),
    [anon_sym_let] = ACTIONS(3648),
    [anon_sym_let_BANG] = ACTIONS(3646),
    [anon_sym_LPAREN] = ACTIONS(3648),
    [anon_sym_COMMA] = ACTIONS(3646),
    [anon_sym_null] = ACTIONS(3648),
    [anon_sym_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_COLON] = ACTIONS(3646),
    [anon_sym_AMP] = ACTIONS(3648),
    [anon_sym_LBRACK] = ACTIONS(3648),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3646),
    [anon_sym_LBRACE] = ACTIONS(3648),
    [anon_sym_LT_AT] = ACTIONS(3648),
    [anon_sym_LT_AT_AT] = ACTIONS(3648),
    [anon_sym_DOT] = ACTIONS(3648),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3646),
    [anon_sym_new] = ACTIONS(3648),
    [anon_sym_return_BANG] = ACTIONS(3646),
    [anon_sym_yield] = ACTIONS(3648),
    [anon_sym_yield_BANG] = ACTIONS(3646),
    [anon_sym_lazy] = ACTIONS(3648),
    [anon_sym_assert] = ACTIONS(3648),
    [anon_sym_upcast] = ACTIONS(3648),
    [anon_sym_downcast] = ACTIONS(3648),
    [anon_sym_COLON_GT] = ACTIONS(3646),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3646),
    [anon_sym_for] = ACTIONS(3648),
    [anon_sym_while] = ACTIONS(3648),
    [anon_sym_else] = ACTIONS(3648),
    [anon_sym_elif] = ACTIONS(3648),
    [anon_sym_if] = ACTIONS(3648),
    [anon_sym_fun] = ACTIONS(3648),
    [anon_sym_try] = ACTIONS(3648),
    [anon_sym_match] = ACTIONS(3648),
    [anon_sym_match_BANG] = ACTIONS(3646),
    [anon_sym_function] = ACTIONS(3648),
    [anon_sym_LT_DASH] = ACTIONS(3648),
    [anon_sym_DOT_LBRACK] = ACTIONS(3646),
    [anon_sym_LT] = ACTIONS(3646),
    [anon_sym_use] = ACTIONS(3648),
    [anon_sym_use_BANG] = ACTIONS(3646),
    [anon_sym_do_BANG] = ACTIONS(3646),
    [anon_sym_DOT_DOT] = ACTIONS(3646),
    [anon_sym_begin] = ACTIONS(3648),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3648),
    [aux_sym_char_token1] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3648),
    [anon_sym_AT_DQUOTE] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [sym_bool] = ACTIONS(3648),
    [sym_unit] = ACTIONS(3646),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3648),
    [sym_op_identifier] = ACTIONS(3648),
    [anon_sym_PLUS] = ACTIONS(3648),
    [anon_sym_DASH] = ACTIONS(3648),
    [anon_sym_PLUS_DOT] = ACTIONS(3648),
    [anon_sym_DASH_DOT] = ACTIONS(3648),
    [anon_sym_PERCENT] = ACTIONS(3648),
    [anon_sym_AMP_AMP] = ACTIONS(3648),
    [anon_sym_TILDE] = ACTIONS(3646),
    [aux_sym_prefix_op_token1] = ACTIONS(3648),
    [aux_sym_infix_op_token1] = ACTIONS(3646),
    [aux_sym_infix_op_token2] = ACTIONS(3648),
    [anon_sym_PIPE_PIPE] = ACTIONS(3648),
    [anon_sym_BANG_EQ] = ACTIONS(3648),
    [anon_sym_COLON_EQ] = ACTIONS(3646),
    [anon_sym_DOLLAR] = ACTIONS(3648),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3648),
    [sym_int] = ACTIONS(3648),
    [sym_xint] = ACTIONS(3646),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3646),
    [sym__newline] = ACTIONS(3646),
  },
  [2789] = {
    [sym_block_comment] = STATE(2789),
    [sym_compiler_directive_decl] = STATE(2789),
    [sym_fsi_directive_decl] = STATE(2789),
    [sym_preproc_line] = STATE(2789),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_DASH_GT] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_DOT_DOT] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [2790] = {
    [sym_block_comment] = STATE(2790),
    [sym_compiler_directive_decl] = STATE(2790),
    [sym_fsi_directive_decl] = STATE(2790),
    [sym_preproc_line] = STATE(2790),
    [sym_identifier] = ACTIONS(4180),
    [anon_sym_EQ] = ACTIONS(4178),
    [anon_sym_COLON] = ACTIONS(4180),
    [anon_sym_return] = ACTIONS(4180),
    [anon_sym_do] = ACTIONS(4180),
    [anon_sym_let] = ACTIONS(4180),
    [anon_sym_let_BANG] = ACTIONS(4178),
    [anon_sym_as] = ACTIONS(4180),
    [anon_sym_LPAREN] = ACTIONS(4180),
    [anon_sym_COMMA] = ACTIONS(4178),
    [anon_sym_null] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_COLON] = ACTIONS(4178),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4180),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4180),
    [anon_sym_LT_AT] = ACTIONS(4180),
    [anon_sym_LT_AT_AT] = ACTIONS(4180),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4178),
    [anon_sym_new] = ACTIONS(4180),
    [anon_sym_with] = ACTIONS(4180),
    [anon_sym_return_BANG] = ACTIONS(4178),
    [anon_sym_yield] = ACTIONS(4180),
    [anon_sym_yield_BANG] = ACTIONS(4178),
    [anon_sym_lazy] = ACTIONS(4180),
    [anon_sym_assert] = ACTIONS(4180),
    [anon_sym_upcast] = ACTIONS(4180),
    [anon_sym_downcast] = ACTIONS(4180),
    [anon_sym_COLON_GT] = ACTIONS(4178),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4178),
    [anon_sym_for] = ACTIONS(4180),
    [anon_sym_while] = ACTIONS(4180),
    [anon_sym_if] = ACTIONS(4180),
    [anon_sym_fun] = ACTIONS(4180),
    [anon_sym_try] = ACTIONS(4180),
    [anon_sym_match] = ACTIONS(4180),
    [anon_sym_match_BANG] = ACTIONS(4178),
    [anon_sym_function] = ACTIONS(4180),
    [anon_sym_LT_DASH] = ACTIONS(4180),
    [anon_sym_DOT_LBRACK] = ACTIONS(4178),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_use] = ACTIONS(4180),
    [anon_sym_use_BANG] = ACTIONS(4178),
    [anon_sym_do_BANG] = ACTIONS(4178),
    [anon_sym_begin] = ACTIONS(4180),
    [anon_sym_LPAREN2] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [aux_sym_char_token1] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4180),
    [anon_sym_DQUOTE] = ACTIONS(4180),
    [anon_sym_AT_DQUOTE] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [sym_bool] = ACTIONS(4180),
    [sym_unit] = ACTIONS(4178),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4180),
    [sym_op_identifier] = ACTIONS(4180),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_PLUS_DOT] = ACTIONS(4180),
    [anon_sym_DASH_DOT] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_TILDE] = ACTIONS(4178),
    [aux_sym_prefix_op_token1] = ACTIONS(4180),
    [aux_sym_infix_op_token1] = ACTIONS(4178),
    [aux_sym_infix_op_token2] = ACTIONS(4180),
    [anon_sym_PIPE_PIPE] = ACTIONS(4180),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_COLON_EQ] = ACTIONS(4178),
    [anon_sym_DOLLAR] = ACTIONS(4180),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4180),
    [sym_int] = ACTIONS(4180),
    [sym_xint] = ACTIONS(4178),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4178),
    [sym__newline] = ACTIONS(4178),
    [sym__dedent] = ACTIONS(4178),
  },
  [2791] = {
    [sym_block_comment] = STATE(2791),
    [sym_compiler_directive_decl] = STATE(2791),
    [sym_fsi_directive_decl] = STATE(2791),
    [sym_preproc_line] = STATE(2791),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_DOT_DOT] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_f] = ACTIONS(4669),
    [aux_sym_decimal_token1] = ACTIONS(4502),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [2792] = {
    [sym_block_comment] = STATE(2792),
    [sym_compiler_directive_decl] = STATE(2792),
    [sym_fsi_directive_decl] = STATE(2792),
    [sym_preproc_line] = STATE(2792),
    [aux_sym_rules_repeat1] = STATE(2807),
    [sym_identifier] = ACTIONS(3736),
    [anon_sym_EQ] = ACTIONS(3734),
    [anon_sym_COLON] = ACTIONS(3736),
    [anon_sym_return] = ACTIONS(3736),
    [anon_sym_do] = ACTIONS(3736),
    [anon_sym_let] = ACTIONS(3736),
    [anon_sym_let_BANG] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3736),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_null] = ACTIONS(3736),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_COLON] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(5334),
    [anon_sym_AMP] = ACTIONS(3736),
    [anon_sym_LBRACK] = ACTIONS(3736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3734),
    [anon_sym_LBRACE] = ACTIONS(3736),
    [anon_sym_LT_AT] = ACTIONS(3736),
    [anon_sym_LT_AT_AT] = ACTIONS(3736),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3734),
    [anon_sym_new] = ACTIONS(3736),
    [anon_sym_return_BANG] = ACTIONS(3734),
    [anon_sym_yield] = ACTIONS(3736),
    [anon_sym_yield_BANG] = ACTIONS(3734),
    [anon_sym_lazy] = ACTIONS(3736),
    [anon_sym_assert] = ACTIONS(3736),
    [anon_sym_upcast] = ACTIONS(3736),
    [anon_sym_downcast] = ACTIONS(3736),
    [anon_sym_COLON_GT] = ACTIONS(3734),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3734),
    [anon_sym_for] = ACTIONS(3736),
    [anon_sym_while] = ACTIONS(3736),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_fun] = ACTIONS(3736),
    [anon_sym_try] = ACTIONS(3736),
    [anon_sym_match] = ACTIONS(3736),
    [anon_sym_match_BANG] = ACTIONS(3734),
    [anon_sym_function] = ACTIONS(3736),
    [anon_sym_LT_DASH] = ACTIONS(3736),
    [anon_sym_DOT_LBRACK] = ACTIONS(3734),
    [anon_sym_LT] = ACTIONS(3734),
    [anon_sym_use] = ACTIONS(3736),
    [anon_sym_use_BANG] = ACTIONS(3734),
    [anon_sym_do_BANG] = ACTIONS(3734),
    [anon_sym_DOT_DOT] = ACTIONS(3734),
    [anon_sym_begin] = ACTIONS(3736),
    [anon_sym_LPAREN2] = ACTIONS(3736),
    [anon_sym_or] = ACTIONS(3736),
    [aux_sym_char_token1] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3736),
    [anon_sym_DQUOTE] = ACTIONS(3736),
    [anon_sym_AT_DQUOTE] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [sym_bool] = ACTIONS(3736),
    [sym_unit] = ACTIONS(3734),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3736),
    [sym_op_identifier] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS_DOT] = ACTIONS(3736),
    [anon_sym_DASH_DOT] = ACTIONS(3736),
    [anon_sym_PERCENT] = ACTIONS(3736),
    [anon_sym_AMP_AMP] = ACTIONS(3736),
    [anon_sym_TILDE] = ACTIONS(3734),
    [aux_sym_prefix_op_token1] = ACTIONS(3736),
    [aux_sym_infix_op_token1] = ACTIONS(3734),
    [aux_sym_infix_op_token2] = ACTIONS(3736),
    [anon_sym_PIPE_PIPE] = ACTIONS(3736),
    [anon_sym_BANG_EQ] = ACTIONS(3736),
    [anon_sym_COLON_EQ] = ACTIONS(3734),
    [anon_sym_DOLLAR] = ACTIONS(3736),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3736),
    [sym_int] = ACTIONS(3736),
    [sym_xint] = ACTIONS(3734),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3734),
    [sym__newline] = ACTIONS(5336),
  },
  [2793] = {
    [sym_block_comment] = STATE(2793),
    [sym_compiler_directive_decl] = STATE(2793),
    [sym_fsi_directive_decl] = STATE(2793),
    [sym_preproc_line] = STATE(2793),
    [sym_identifier] = ACTIONS(4174),
    [anon_sym_EQ] = ACTIONS(4172),
    [anon_sym_COLON] = ACTIONS(4174),
    [anon_sym_return] = ACTIONS(4174),
    [anon_sym_do] = ACTIONS(4174),
    [anon_sym_let] = ACTIONS(4174),
    [anon_sym_let_BANG] = ACTIONS(4172),
    [anon_sym_as] = ACTIONS(4174),
    [anon_sym_LPAREN] = ACTIONS(4174),
    [anon_sym_COMMA] = ACTIONS(4172),
    [anon_sym_null] = ACTIONS(4174),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_COLON] = ACTIONS(4172),
    [anon_sym_AMP] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4174),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4172),
    [anon_sym_LBRACE] = ACTIONS(4174),
    [anon_sym_LT_AT] = ACTIONS(4174),
    [anon_sym_LT_AT_AT] = ACTIONS(4174),
    [anon_sym_DOT] = ACTIONS(4174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4172),
    [anon_sym_new] = ACTIONS(4174),
    [anon_sym_with] = ACTIONS(4174),
    [anon_sym_return_BANG] = ACTIONS(4172),
    [anon_sym_yield] = ACTIONS(4174),
    [anon_sym_yield_BANG] = ACTIONS(4172),
    [anon_sym_lazy] = ACTIONS(4174),
    [anon_sym_assert] = ACTIONS(4174),
    [anon_sym_upcast] = ACTIONS(4174),
    [anon_sym_downcast] = ACTIONS(4174),
    [anon_sym_COLON_GT] = ACTIONS(4172),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4172),
    [anon_sym_for] = ACTIONS(4174),
    [anon_sym_while] = ACTIONS(4174),
    [anon_sym_if] = ACTIONS(4174),
    [anon_sym_fun] = ACTIONS(4174),
    [anon_sym_try] = ACTIONS(4174),
    [anon_sym_match] = ACTIONS(4174),
    [anon_sym_match_BANG] = ACTIONS(4172),
    [anon_sym_function] = ACTIONS(4174),
    [anon_sym_LT_DASH] = ACTIONS(4174),
    [anon_sym_DOT_LBRACK] = ACTIONS(4172),
    [anon_sym_LT] = ACTIONS(4172),
    [anon_sym_use] = ACTIONS(4174),
    [anon_sym_use_BANG] = ACTIONS(4172),
    [anon_sym_do_BANG] = ACTIONS(4172),
    [anon_sym_begin] = ACTIONS(4174),
    [anon_sym_LPAREN2] = ACTIONS(4174),
    [anon_sym_or] = ACTIONS(4174),
    [aux_sym_char_token1] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4174),
    [anon_sym_DQUOTE] = ACTIONS(4174),
    [anon_sym_AT_DQUOTE] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [sym_bool] = ACTIONS(4174),
    [sym_unit] = ACTIONS(4172),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4174),
    [sym_op_identifier] = ACTIONS(4174),
    [anon_sym_PLUS] = ACTIONS(4174),
    [anon_sym_DASH] = ACTIONS(4174),
    [anon_sym_PLUS_DOT] = ACTIONS(4174),
    [anon_sym_DASH_DOT] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [anon_sym_AMP_AMP] = ACTIONS(4174),
    [anon_sym_TILDE] = ACTIONS(4172),
    [aux_sym_prefix_op_token1] = ACTIONS(4174),
    [aux_sym_infix_op_token1] = ACTIONS(4172),
    [aux_sym_infix_op_token2] = ACTIONS(4174),
    [anon_sym_PIPE_PIPE] = ACTIONS(4174),
    [anon_sym_BANG_EQ] = ACTIONS(4174),
    [anon_sym_COLON_EQ] = ACTIONS(4172),
    [anon_sym_DOLLAR] = ACTIONS(4174),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4174),
    [sym_int] = ACTIONS(4174),
    [sym_xint] = ACTIONS(4172),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4172),
    [sym__newline] = ACTIONS(4172),
    [sym__dedent] = ACTIONS(4172),
  },
  [2794] = {
    [sym_block_comment] = STATE(2794),
    [sym_compiler_directive_decl] = STATE(2794),
    [sym_fsi_directive_decl] = STATE(2794),
    [sym_preproc_line] = STATE(2794),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_EQ] = ACTIONS(3646),
    [anon_sym_COLON] = ACTIONS(3648),
    [anon_sym_return] = ACTIONS(3648),
    [anon_sym_do] = ACTIONS(3648),
    [anon_sym_let] = ACTIONS(3648),
    [anon_sym_let_BANG] = ACTIONS(3646),
    [anon_sym_LPAREN] = ACTIONS(3648),
    [anon_sym_COMMA] = ACTIONS(3646),
    [anon_sym_null] = ACTIONS(3648),
    [anon_sym_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_COLON] = ACTIONS(3646),
    [anon_sym_AMP] = ACTIONS(3648),
    [anon_sym_LBRACK] = ACTIONS(3648),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3646),
    [anon_sym_LBRACE] = ACTIONS(3648),
    [anon_sym_LT_AT] = ACTIONS(3648),
    [anon_sym_LT_AT_AT] = ACTIONS(3648),
    [anon_sym_AT_AT_GT] = ACTIONS(3648),
    [anon_sym_DOT] = ACTIONS(3648),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3646),
    [anon_sym_new] = ACTIONS(3648),
    [anon_sym_return_BANG] = ACTIONS(3646),
    [anon_sym_yield] = ACTIONS(3648),
    [anon_sym_yield_BANG] = ACTIONS(3646),
    [anon_sym_lazy] = ACTIONS(3648),
    [anon_sym_assert] = ACTIONS(3648),
    [anon_sym_upcast] = ACTIONS(3648),
    [anon_sym_downcast] = ACTIONS(3648),
    [anon_sym_COLON_GT] = ACTIONS(3646),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3646),
    [anon_sym_for] = ACTIONS(3648),
    [anon_sym_while] = ACTIONS(3648),
    [anon_sym_else] = ACTIONS(3648),
    [anon_sym_elif] = ACTIONS(3648),
    [anon_sym_if] = ACTIONS(3648),
    [anon_sym_fun] = ACTIONS(3648),
    [anon_sym_try] = ACTIONS(3648),
    [anon_sym_match] = ACTIONS(3648),
    [anon_sym_match_BANG] = ACTIONS(3646),
    [anon_sym_function] = ACTIONS(3648),
    [anon_sym_LT_DASH] = ACTIONS(3648),
    [anon_sym_DOT_LBRACK] = ACTIONS(3646),
    [anon_sym_LT] = ACTIONS(3646),
    [anon_sym_use] = ACTIONS(3648),
    [anon_sym_use_BANG] = ACTIONS(3646),
    [anon_sym_do_BANG] = ACTIONS(3646),
    [anon_sym_begin] = ACTIONS(3648),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3648),
    [aux_sym_char_token1] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3648),
    [anon_sym_AT_DQUOTE] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [sym_bool] = ACTIONS(3648),
    [sym_unit] = ACTIONS(3646),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3648),
    [sym_op_identifier] = ACTIONS(3648),
    [anon_sym_PLUS] = ACTIONS(3648),
    [anon_sym_DASH] = ACTIONS(3648),
    [anon_sym_PLUS_DOT] = ACTIONS(3648),
    [anon_sym_DASH_DOT] = ACTIONS(3648),
    [anon_sym_PERCENT] = ACTIONS(3648),
    [anon_sym_AMP_AMP] = ACTIONS(3648),
    [anon_sym_TILDE] = ACTIONS(3646),
    [aux_sym_prefix_op_token1] = ACTIONS(3648),
    [aux_sym_infix_op_token1] = ACTIONS(3646),
    [aux_sym_infix_op_token2] = ACTIONS(3648),
    [anon_sym_PIPE_PIPE] = ACTIONS(3648),
    [anon_sym_BANG_EQ] = ACTIONS(3648),
    [anon_sym_COLON_EQ] = ACTIONS(3646),
    [anon_sym_DOLLAR] = ACTIONS(3648),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3648),
    [sym_int] = ACTIONS(3648),
    [sym_xint] = ACTIONS(3646),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3646),
    [sym__newline] = ACTIONS(3646),
  },
  [2795] = {
    [sym_block_comment] = STATE(2795),
    [sym_compiler_directive_decl] = STATE(2795),
    [sym_fsi_directive_decl] = STATE(2795),
    [sym_preproc_line] = STATE(2795),
    [aux_sym_long_identifier_repeat1] = STATE(2964),
    [sym_identifier] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3778),
    [anon_sym_COLON] = ACTIONS(3781),
    [anon_sym_return] = ACTIONS(3781),
    [anon_sym_do] = ACTIONS(3781),
    [anon_sym_let] = ACTIONS(3781),
    [anon_sym_let_BANG] = ACTIONS(3778),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3778),
    [anon_sym_null] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3781),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_LT_AT] = ACTIONS(3781),
    [anon_sym_LT_AT_AT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(5339),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3778),
    [anon_sym_new] = ACTIONS(3781),
    [anon_sym_return_BANG] = ACTIONS(3778),
    [anon_sym_yield] = ACTIONS(3781),
    [anon_sym_yield_BANG] = ACTIONS(3778),
    [anon_sym_lazy] = ACTIONS(3781),
    [anon_sym_assert] = ACTIONS(3781),
    [anon_sym_upcast] = ACTIONS(3781),
    [anon_sym_downcast] = ACTIONS(3781),
    [anon_sym_COLON_GT] = ACTIONS(3778),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3778),
    [anon_sym_for] = ACTIONS(3781),
    [anon_sym_while] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_fun] = ACTIONS(3781),
    [anon_sym_DASH_GT] = ACTIONS(3781),
    [anon_sym_try] = ACTIONS(3781),
    [anon_sym_match] = ACTIONS(3781),
    [anon_sym_match_BANG] = ACTIONS(3778),
    [anon_sym_function] = ACTIONS(3781),
    [anon_sym_LT_DASH] = ACTIONS(3781),
    [anon_sym_DOT_LBRACK] = ACTIONS(3778),
    [anon_sym_LT] = ACTIONS(3778),
    [anon_sym_use] = ACTIONS(3781),
    [anon_sym_use_BANG] = ACTIONS(3778),
    [anon_sym_do_BANG] = ACTIONS(3778),
    [anon_sym_DOT_DOT] = ACTIONS(3778),
    [anon_sym_begin] = ACTIONS(3781),
    [anon_sym_LPAREN2] = ACTIONS(3781),
    [anon_sym_or] = ACTIONS(3781),
    [aux_sym_char_token1] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3781),
    [anon_sym_DQUOTE] = ACTIONS(3781),
    [anon_sym_AT_DQUOTE] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [sym_bool] = ACTIONS(3781),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3781),
    [sym_op_identifier] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3781),
    [anon_sym_DASH] = ACTIONS(3781),
    [anon_sym_PLUS_DOT] = ACTIONS(3781),
    [anon_sym_DASH_DOT] = ACTIONS(3781),
    [anon_sym_PERCENT] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3781),
    [anon_sym_TILDE] = ACTIONS(3778),
    [aux_sym_prefix_op_token1] = ACTIONS(3781),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token2] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_COLON_EQ] = ACTIONS(3778),
    [anon_sym_DOLLAR] = ACTIONS(3781),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3781),
    [sym_int] = ACTIONS(3781),
    [sym_xint] = ACTIONS(3778),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3778),
    [sym__newline] = ACTIONS(3778),
  },
  [2796] = {
    [sym_block_comment] = STATE(2796),
    [sym_compiler_directive_decl] = STATE(2796),
    [sym_fsi_directive_decl] = STATE(2796),
    [sym_preproc_line] = STATE(2796),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4228),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4739),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_with] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [anon_sym_EQ2] = ACTIONS(5343),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
    [sym__dedent] = ACTIONS(4226),
  },
  [2797] = {
    [sym_block_comment] = STATE(2797),
    [sym_compiler_directive_decl] = STATE(2797),
    [sym_fsi_directive_decl] = STATE(2797),
    [sym_preproc_line] = STATE(2797),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_GT] = ACTIONS(3193),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_f] = ACTIONS(4722),
    [aux_sym_decimal_token1] = ACTIONS(4464),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [2798] = {
    [sym_block_comment] = STATE(2798),
    [sym_compiler_directive_decl] = STATE(2798),
    [sym_fsi_directive_decl] = STATE(2798),
    [sym_preproc_line] = STATE(2798),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_else] = ACTIONS(3700),
    [anon_sym_elif] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_DOT_DOT] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [2799] = {
    [sym_block_comment] = STATE(2799),
    [sym_compiler_directive_decl] = STATE(2799),
    [sym_fsi_directive_decl] = STATE(2799),
    [sym_preproc_line] = STATE(2799),
    [aux_sym_sequential_expression_repeat1] = STATE(2843),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_COLON] = ACTIONS(3759),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_let_BANG] = ACTIONS(3757),
    [anon_sym_LPAREN] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3757),
    [anon_sym_null] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3757),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_LT_AT] = ACTIONS(3759),
    [anon_sym_LT_AT_AT] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(3759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_return_BANG] = ACTIONS(3757),
    [anon_sym_yield] = ACTIONS(3759),
    [anon_sym_yield_BANG] = ACTIONS(3757),
    [anon_sym_lazy] = ACTIONS(3759),
    [anon_sym_assert] = ACTIONS(3759),
    [anon_sym_upcast] = ACTIONS(3759),
    [anon_sym_downcast] = ACTIONS(3759),
    [anon_sym_COLON_GT] = ACTIONS(3757),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3757),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_fun] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_match] = ACTIONS(3759),
    [anon_sym_match_BANG] = ACTIONS(3757),
    [anon_sym_function] = ACTIONS(3759),
    [anon_sym_LT_DASH] = ACTIONS(3759),
    [anon_sym_DOT_LBRACK] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_use] = ACTIONS(3759),
    [anon_sym_use_BANG] = ACTIONS(3757),
    [anon_sym_do_BANG] = ACTIONS(3757),
    [anon_sym_begin] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_or] = ACTIONS(3759),
    [aux_sym_char_token1] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3759),
    [anon_sym_DQUOTE] = ACTIONS(3759),
    [anon_sym_AT_DQUOTE] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [sym_bool] = ACTIONS(3759),
    [sym_unit] = ACTIONS(3757),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3759),
    [sym_op_identifier] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS_DOT] = ACTIONS(3759),
    [anon_sym_DASH_DOT] = ACTIONS(3759),
    [anon_sym_PERCENT] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_TILDE] = ACTIONS(3757),
    [aux_sym_prefix_op_token1] = ACTIONS(3759),
    [aux_sym_infix_op_token1] = ACTIONS(3757),
    [aux_sym_infix_op_token2] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_COLON_EQ] = ACTIONS(3757),
    [anon_sym_DOLLAR] = ACTIONS(3759),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3759),
    [sym_int] = ACTIONS(3759),
    [sym_xint] = ACTIONS(3757),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3757),
    [anon_sym_POUNDendif] = ACTIONS(3757),
    [anon_sym_POUNDelse] = ACTIONS(3757),
    [sym__newline] = ACTIONS(3757),
  },
  [2800] = {
    [sym_block_comment] = STATE(2800),
    [sym_compiler_directive_decl] = STATE(2800),
    [sym_fsi_directive_decl] = STATE(2800),
    [sym_preproc_line] = STATE(2800),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3487),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_EQ2] = ACTIONS(3485),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
    [sym__dedent] = ACTIONS(3485),
  },
  [2801] = {
    [sym_block_comment] = STATE(2801),
    [sym_compiler_directive_decl] = STATE(2801),
    [sym_fsi_directive_decl] = STATE(2801),
    [sym_preproc_line] = STATE(2801),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_AT_GT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_done] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_DOT_DOT] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [2802] = {
    [sym_block_comment] = STATE(2802),
    [sym_compiler_directive_decl] = STATE(2802),
    [sym_fsi_directive_decl] = STATE(2802),
    [sym_preproc_line] = STATE(2802),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_else] = ACTIONS(3700),
    [anon_sym_elif] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_GT] = ACTIONS(3700),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [2803] = {
    [sym_block_comment] = STATE(2803),
    [sym_compiler_directive_decl] = STATE(2803),
    [sym_fsi_directive_decl] = STATE(2803),
    [sym_preproc_line] = STATE(2803),
    [sym_identifier] = ACTIONS(3728),
    [anon_sym_EQ] = ACTIONS(3726),
    [anon_sym_COLON] = ACTIONS(3728),
    [anon_sym_return] = ACTIONS(3728),
    [anon_sym_do] = ACTIONS(3728),
    [anon_sym_let] = ACTIONS(3728),
    [anon_sym_let_BANG] = ACTIONS(3726),
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_COMMA] = ACTIONS(3726),
    [anon_sym_null] = ACTIONS(3728),
    [anon_sym_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(3726),
    [anon_sym_AMP] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3726),
    [anon_sym_LBRACE] = ACTIONS(3728),
    [anon_sym_LT_AT] = ACTIONS(3728),
    [anon_sym_LT_AT_AT] = ACTIONS(3728),
    [anon_sym_DOT] = ACTIONS(3728),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3726),
    [anon_sym_new] = ACTIONS(3728),
    [anon_sym_return_BANG] = ACTIONS(3726),
    [anon_sym_yield] = ACTIONS(3728),
    [anon_sym_yield_BANG] = ACTIONS(3726),
    [anon_sym_lazy] = ACTIONS(3728),
    [anon_sym_assert] = ACTIONS(3728),
    [anon_sym_upcast] = ACTIONS(3728),
    [anon_sym_downcast] = ACTIONS(3728),
    [anon_sym_COLON_GT] = ACTIONS(3726),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3726),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_fun] = ACTIONS(3728),
    [anon_sym_try] = ACTIONS(3728),
    [anon_sym_match] = ACTIONS(3728),
    [anon_sym_match_BANG] = ACTIONS(3726),
    [anon_sym_function] = ACTIONS(3728),
    [anon_sym_LT_DASH] = ACTIONS(3728),
    [anon_sym_DOT_LBRACK] = ACTIONS(3726),
    [anon_sym_LT] = ACTIONS(3726),
    [anon_sym_use] = ACTIONS(3728),
    [anon_sym_use_BANG] = ACTIONS(3726),
    [anon_sym_do_BANG] = ACTIONS(3726),
    [anon_sym_DOT_DOT] = ACTIONS(3726),
    [anon_sym_begin] = ACTIONS(3728),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [aux_sym_char_token1] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3728),
    [anon_sym_AT_DQUOTE] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [sym_bool] = ACTIONS(3728),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3728),
    [sym_op_identifier] = ACTIONS(3728),
    [anon_sym_PLUS] = ACTIONS(3728),
    [anon_sym_DASH] = ACTIONS(3728),
    [anon_sym_PLUS_DOT] = ACTIONS(3728),
    [anon_sym_DASH_DOT] = ACTIONS(3728),
    [anon_sym_PERCENT] = ACTIONS(3728),
    [anon_sym_AMP_AMP] = ACTIONS(3728),
    [anon_sym_TILDE] = ACTIONS(3726),
    [aux_sym_prefix_op_token1] = ACTIONS(3728),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token2] = ACTIONS(3728),
    [anon_sym_PIPE_PIPE] = ACTIONS(3728),
    [anon_sym_BANG_EQ] = ACTIONS(3728),
    [anon_sym_COLON_EQ] = ACTIONS(3726),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3728),
    [sym_int] = ACTIONS(3728),
    [sym_xint] = ACTIONS(3726),
    [anon_sym_f] = ACTIONS(3728),
    [aux_sym_decimal_token1] = ACTIONS(3728),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3726),
    [sym__newline] = ACTIONS(3726),
  },
  [2804] = {
    [sym_block_comment] = STATE(2804),
    [sym_compiler_directive_decl] = STATE(2804),
    [sym_fsi_directive_decl] = STATE(2804),
    [sym_preproc_line] = STATE(2804),
    [aux_sym_rules_repeat1] = STATE(2815),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(5334),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_DOT_DOT] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_or] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(5345),
  },
  [2805] = {
    [sym_block_comment] = STATE(2805),
    [sym_compiler_directive_decl] = STATE(2805),
    [sym_fsi_directive_decl] = STATE(2805),
    [sym_preproc_line] = STATE(2805),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_AT_AT_GT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(5348),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_DOT_DOT] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
  },
  [2806] = {
    [sym_block_comment] = STATE(2806),
    [sym_compiler_directive_decl] = STATE(2806),
    [sym_fsi_directive_decl] = STATE(2806),
    [sym_preproc_line] = STATE(2806),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4072),
    [anon_sym_COLON] = ACTIONS(4074),
    [anon_sym_return] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_let_BANG] = ACTIONS(4072),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_LPAREN] = ACTIONS(4074),
    [anon_sym_COMMA] = ACTIONS(4072),
    [anon_sym_null] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_COLON] = ACTIONS(4072),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_LT_AT] = ACTIONS(4074),
    [anon_sym_LT_AT_AT] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4072),
    [anon_sym_new] = ACTIONS(4074),
    [anon_sym_with] = ACTIONS(4074),
    [anon_sym_return_BANG] = ACTIONS(4072),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_yield_BANG] = ACTIONS(4072),
    [anon_sym_lazy] = ACTIONS(4074),
    [anon_sym_assert] = ACTIONS(4074),
    [anon_sym_upcast] = ACTIONS(4074),
    [anon_sym_downcast] = ACTIONS(4074),
    [anon_sym_COLON_GT] = ACTIONS(4072),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4072),
    [anon_sym_for] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_fun] = ACTIONS(4074),
    [anon_sym_try] = ACTIONS(4074),
    [anon_sym_match] = ACTIONS(4074),
    [anon_sym_match_BANG] = ACTIONS(4072),
    [anon_sym_function] = ACTIONS(4074),
    [anon_sym_LT_DASH] = ACTIONS(4074),
    [anon_sym_DOT_LBRACK] = ACTIONS(4072),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_use] = ACTIONS(4074),
    [anon_sym_use_BANG] = ACTIONS(4072),
    [anon_sym_do_BANG] = ACTIONS(4072),
    [anon_sym_begin] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [aux_sym_char_token1] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4074),
    [anon_sym_DQUOTE] = ACTIONS(4074),
    [anon_sym_AT_DQUOTE] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [sym_bool] = ACTIONS(4074),
    [sym_unit] = ACTIONS(4072),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4074),
    [sym_op_identifier] = ACTIONS(4074),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_PLUS_DOT] = ACTIONS(4074),
    [anon_sym_DASH_DOT] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_TILDE] = ACTIONS(4072),
    [aux_sym_prefix_op_token1] = ACTIONS(4074),
    [aux_sym_infix_op_token1] = ACTIONS(4072),
    [aux_sym_infix_op_token2] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [anon_sym_BANG_EQ] = ACTIONS(4074),
    [anon_sym_COLON_EQ] = ACTIONS(4072),
    [anon_sym_DOLLAR] = ACTIONS(4074),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4074),
    [sym_int] = ACTIONS(4074),
    [sym_xint] = ACTIONS(4072),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4072),
    [sym__newline] = ACTIONS(4072),
    [sym__dedent] = ACTIONS(4072),
  },
  [2807] = {
    [sym_block_comment] = STATE(2807),
    [sym_compiler_directive_decl] = STATE(2807),
    [sym_fsi_directive_decl] = STATE(2807),
    [sym_preproc_line] = STATE(2807),
    [aux_sym_rules_repeat1] = STATE(2816),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(5334),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_DOT_DOT] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_or] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(5345),
  },
  [2808] = {
    [sym_block_comment] = STATE(2808),
    [sym_compiler_directive_decl] = STATE(2808),
    [sym_fsi_directive_decl] = STATE(2808),
    [sym_preproc_line] = STATE(2808),
    [sym_identifier] = ACTIONS(4022),
    [anon_sym_EQ] = ACTIONS(4020),
    [anon_sym_COLON] = ACTIONS(4022),
    [anon_sym_return] = ACTIONS(4022),
    [anon_sym_do] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_let_BANG] = ACTIONS(4020),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(4022),
    [anon_sym_COMMA] = ACTIONS(4020),
    [anon_sym_null] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_COLON] = ACTIONS(4020),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4022),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(4022),
    [anon_sym_LT_AT] = ACTIONS(4022),
    [anon_sym_LT_AT_AT] = ACTIONS(4022),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4020),
    [anon_sym_new] = ACTIONS(4022),
    [anon_sym_with] = ACTIONS(4022),
    [anon_sym_return_BANG] = ACTIONS(4020),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_yield_BANG] = ACTIONS(4020),
    [anon_sym_lazy] = ACTIONS(4022),
    [anon_sym_assert] = ACTIONS(4022),
    [anon_sym_upcast] = ACTIONS(4022),
    [anon_sym_downcast] = ACTIONS(4022),
    [anon_sym_COLON_GT] = ACTIONS(4020),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4020),
    [anon_sym_for] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4022),
    [anon_sym_if] = ACTIONS(4022),
    [anon_sym_fun] = ACTIONS(4022),
    [anon_sym_try] = ACTIONS(4022),
    [anon_sym_match] = ACTIONS(4022),
    [anon_sym_match_BANG] = ACTIONS(4020),
    [anon_sym_function] = ACTIONS(4022),
    [anon_sym_LT_DASH] = ACTIONS(4022),
    [anon_sym_DOT_LBRACK] = ACTIONS(4020),
    [anon_sym_LT] = ACTIONS(4020),
    [anon_sym_use] = ACTIONS(4022),
    [anon_sym_use_BANG] = ACTIONS(4020),
    [anon_sym_do_BANG] = ACTIONS(4020),
    [anon_sym_begin] = ACTIONS(4022),
    [anon_sym_LPAREN2] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [aux_sym_char_token1] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4022),
    [anon_sym_DQUOTE] = ACTIONS(4022),
    [anon_sym_AT_DQUOTE] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [sym_bool] = ACTIONS(4022),
    [sym_unit] = ACTIONS(4020),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4022),
    [sym_op_identifier] = ACTIONS(4022),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_PLUS_DOT] = ACTIONS(4022),
    [anon_sym_DASH_DOT] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4022),
    [anon_sym_TILDE] = ACTIONS(4020),
    [aux_sym_prefix_op_token1] = ACTIONS(4022),
    [aux_sym_infix_op_token1] = ACTIONS(4020),
    [aux_sym_infix_op_token2] = ACTIONS(4022),
    [anon_sym_PIPE_PIPE] = ACTIONS(4022),
    [anon_sym_BANG_EQ] = ACTIONS(4022),
    [anon_sym_COLON_EQ] = ACTIONS(4020),
    [anon_sym_DOLLAR] = ACTIONS(4022),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4022),
    [sym_int] = ACTIONS(4022),
    [sym_xint] = ACTIONS(4020),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4020),
    [sym__newline] = ACTIONS(4020),
    [sym__dedent] = ACTIONS(4020),
  },
  [2809] = {
    [sym_block_comment] = STATE(2809),
    [sym_compiler_directive_decl] = STATE(2809),
    [sym_fsi_directive_decl] = STATE(2809),
    [sym_preproc_line] = STATE(2809),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_DOT_DOT] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
  },
  [2810] = {
    [sym_block_comment] = STATE(2810),
    [sym_compiler_directive_decl] = STATE(2810),
    [sym_fsi_directive_decl] = STATE(2810),
    [sym_preproc_line] = STATE(2810),
    [sym_identifier] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4078),
    [anon_sym_return] = ACTIONS(4078),
    [anon_sym_do] = ACTIONS(4078),
    [anon_sym_let] = ACTIONS(4078),
    [anon_sym_let_BANG] = ACTIONS(4076),
    [anon_sym_as] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_null] = ACTIONS(4078),
    [anon_sym_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(4076),
    [anon_sym_AMP] = ACTIONS(4078),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4078),
    [anon_sym_LT_AT] = ACTIONS(4078),
    [anon_sym_LT_AT_AT] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(4078),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4076),
    [anon_sym_new] = ACTIONS(4078),
    [anon_sym_with] = ACTIONS(4078),
    [anon_sym_return_BANG] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(4078),
    [anon_sym_yield_BANG] = ACTIONS(4076),
    [anon_sym_lazy] = ACTIONS(4078),
    [anon_sym_assert] = ACTIONS(4078),
    [anon_sym_upcast] = ACTIONS(4078),
    [anon_sym_downcast] = ACTIONS(4078),
    [anon_sym_COLON_GT] = ACTIONS(4076),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4076),
    [anon_sym_for] = ACTIONS(4078),
    [anon_sym_while] = ACTIONS(4078),
    [anon_sym_if] = ACTIONS(4078),
    [anon_sym_fun] = ACTIONS(4078),
    [anon_sym_try] = ACTIONS(4078),
    [anon_sym_match] = ACTIONS(4078),
    [anon_sym_match_BANG] = ACTIONS(4076),
    [anon_sym_function] = ACTIONS(4078),
    [anon_sym_LT_DASH] = ACTIONS(4078),
    [anon_sym_DOT_LBRACK] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4076),
    [anon_sym_use] = ACTIONS(4078),
    [anon_sym_use_BANG] = ACTIONS(4076),
    [anon_sym_do_BANG] = ACTIONS(4076),
    [anon_sym_begin] = ACTIONS(4078),
    [anon_sym_LPAREN2] = ACTIONS(4078),
    [anon_sym_or] = ACTIONS(4078),
    [aux_sym_char_token1] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4078),
    [anon_sym_DQUOTE] = ACTIONS(4078),
    [anon_sym_AT_DQUOTE] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [sym_bool] = ACTIONS(4078),
    [sym_unit] = ACTIONS(4076),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4078),
    [sym_op_identifier] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(4078),
    [anon_sym_PLUS_DOT] = ACTIONS(4078),
    [anon_sym_DASH_DOT] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [anon_sym_AMP_AMP] = ACTIONS(4078),
    [anon_sym_TILDE] = ACTIONS(4076),
    [aux_sym_prefix_op_token1] = ACTIONS(4078),
    [aux_sym_infix_op_token1] = ACTIONS(4076),
    [aux_sym_infix_op_token2] = ACTIONS(4078),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_BANG_EQ] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4076),
    [anon_sym_DOLLAR] = ACTIONS(4078),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4078),
    [sym_int] = ACTIONS(4078),
    [sym_xint] = ACTIONS(4076),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4076),
    [sym__newline] = ACTIONS(4076),
    [sym__dedent] = ACTIONS(4076),
  },
  [2811] = {
    [sym_block_comment] = STATE(2811),
    [sym_compiler_directive_decl] = STATE(2811),
    [sym_fsi_directive_decl] = STATE(2811),
    [sym_preproc_line] = STATE(2811),
    [sym_identifier] = ACTIONS(4011),
    [anon_sym_EQ] = ACTIONS(4009),
    [anon_sym_COLON] = ACTIONS(4011),
    [anon_sym_return] = ACTIONS(4011),
    [anon_sym_do] = ACTIONS(4011),
    [anon_sym_let] = ACTIONS(4011),
    [anon_sym_let_BANG] = ACTIONS(4009),
    [anon_sym_as] = ACTIONS(4011),
    [anon_sym_LPAREN] = ACTIONS(4011),
    [anon_sym_COMMA] = ACTIONS(4009),
    [anon_sym_null] = ACTIONS(4011),
    [anon_sym_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(4011),
    [anon_sym_LBRACK] = ACTIONS(4011),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4009),
    [anon_sym_LBRACE] = ACTIONS(4011),
    [anon_sym_LT_AT] = ACTIONS(4011),
    [anon_sym_LT_AT_AT] = ACTIONS(4011),
    [anon_sym_DOT] = ACTIONS(4011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4009),
    [anon_sym_new] = ACTIONS(4011),
    [anon_sym_with] = ACTIONS(4011),
    [anon_sym_return_BANG] = ACTIONS(4009),
    [anon_sym_yield] = ACTIONS(4011),
    [anon_sym_yield_BANG] = ACTIONS(4009),
    [anon_sym_lazy] = ACTIONS(4011),
    [anon_sym_assert] = ACTIONS(4011),
    [anon_sym_upcast] = ACTIONS(4011),
    [anon_sym_downcast] = ACTIONS(4011),
    [anon_sym_COLON_GT] = ACTIONS(4009),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4009),
    [anon_sym_for] = ACTIONS(4011),
    [anon_sym_while] = ACTIONS(4011),
    [anon_sym_if] = ACTIONS(4011),
    [anon_sym_fun] = ACTIONS(4011),
    [anon_sym_try] = ACTIONS(4011),
    [anon_sym_match] = ACTIONS(4011),
    [anon_sym_match_BANG] = ACTIONS(4009),
    [anon_sym_function] = ACTIONS(4011),
    [anon_sym_LT_DASH] = ACTIONS(4011),
    [anon_sym_DOT_LBRACK] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(4009),
    [anon_sym_use] = ACTIONS(4011),
    [anon_sym_use_BANG] = ACTIONS(4009),
    [anon_sym_do_BANG] = ACTIONS(4009),
    [anon_sym_begin] = ACTIONS(4011),
    [anon_sym_LPAREN2] = ACTIONS(4011),
    [anon_sym_or] = ACTIONS(4011),
    [aux_sym_char_token1] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4011),
    [anon_sym_DQUOTE] = ACTIONS(4011),
    [anon_sym_AT_DQUOTE] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [sym_bool] = ACTIONS(4011),
    [sym_unit] = ACTIONS(4009),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4011),
    [sym_op_identifier] = ACTIONS(4011),
    [anon_sym_PLUS] = ACTIONS(4011),
    [anon_sym_DASH] = ACTIONS(4011),
    [anon_sym_PLUS_DOT] = ACTIONS(4011),
    [anon_sym_DASH_DOT] = ACTIONS(4011),
    [anon_sym_PERCENT] = ACTIONS(4011),
    [anon_sym_AMP_AMP] = ACTIONS(4011),
    [anon_sym_TILDE] = ACTIONS(4009),
    [aux_sym_prefix_op_token1] = ACTIONS(4011),
    [aux_sym_infix_op_token1] = ACTIONS(4009),
    [aux_sym_infix_op_token2] = ACTIONS(4011),
    [anon_sym_PIPE_PIPE] = ACTIONS(4011),
    [anon_sym_BANG_EQ] = ACTIONS(4011),
    [anon_sym_COLON_EQ] = ACTIONS(4009),
    [anon_sym_DOLLAR] = ACTIONS(4011),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4011),
    [sym_int] = ACTIONS(4011),
    [sym_xint] = ACTIONS(4009),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4009),
    [sym__newline] = ACTIONS(4009),
    [sym__dedent] = ACTIONS(4009),
  },
  [2812] = {
    [sym_block_comment] = STATE(2812),
    [sym_compiler_directive_decl] = STATE(2812),
    [sym_fsi_directive_decl] = STATE(2812),
    [sym_preproc_line] = STATE(2812),
    [sym_identifier] = ACTIONS(4007),
    [anon_sym_EQ] = ACTIONS(4005),
    [anon_sym_COLON] = ACTIONS(4007),
    [anon_sym_return] = ACTIONS(4007),
    [anon_sym_do] = ACTIONS(4007),
    [anon_sym_let] = ACTIONS(4007),
    [anon_sym_let_BANG] = ACTIONS(4005),
    [anon_sym_as] = ACTIONS(4007),
    [anon_sym_LPAREN] = ACTIONS(4007),
    [anon_sym_COMMA] = ACTIONS(4005),
    [anon_sym_null] = ACTIONS(4007),
    [anon_sym_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_COLON] = ACTIONS(4005),
    [anon_sym_AMP] = ACTIONS(4007),
    [anon_sym_LBRACK] = ACTIONS(4007),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4005),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_LT_AT] = ACTIONS(4007),
    [anon_sym_LT_AT_AT] = ACTIONS(4007),
    [anon_sym_DOT] = ACTIONS(4007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4005),
    [anon_sym_new] = ACTIONS(4007),
    [anon_sym_with] = ACTIONS(4007),
    [anon_sym_return_BANG] = ACTIONS(4005),
    [anon_sym_yield] = ACTIONS(4007),
    [anon_sym_yield_BANG] = ACTIONS(4005),
    [anon_sym_lazy] = ACTIONS(4007),
    [anon_sym_assert] = ACTIONS(4007),
    [anon_sym_upcast] = ACTIONS(4007),
    [anon_sym_downcast] = ACTIONS(4007),
    [anon_sym_COLON_GT] = ACTIONS(4005),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4005),
    [anon_sym_for] = ACTIONS(4007),
    [anon_sym_while] = ACTIONS(4007),
    [anon_sym_if] = ACTIONS(4007),
    [anon_sym_fun] = ACTIONS(4007),
    [anon_sym_try] = ACTIONS(4007),
    [anon_sym_match] = ACTIONS(4007),
    [anon_sym_match_BANG] = ACTIONS(4005),
    [anon_sym_function] = ACTIONS(4007),
    [anon_sym_LT_DASH] = ACTIONS(4007),
    [anon_sym_DOT_LBRACK] = ACTIONS(4005),
    [anon_sym_LT] = ACTIONS(4005),
    [anon_sym_use] = ACTIONS(4007),
    [anon_sym_use_BANG] = ACTIONS(4005),
    [anon_sym_do_BANG] = ACTIONS(4005),
    [anon_sym_begin] = ACTIONS(4007),
    [anon_sym_LPAREN2] = ACTIONS(4007),
    [anon_sym_or] = ACTIONS(4007),
    [aux_sym_char_token1] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4007),
    [anon_sym_DQUOTE] = ACTIONS(4007),
    [anon_sym_AT_DQUOTE] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [sym_bool] = ACTIONS(4007),
    [sym_unit] = ACTIONS(4005),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4007),
    [sym_op_identifier] = ACTIONS(4007),
    [anon_sym_PLUS] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4007),
    [anon_sym_PLUS_DOT] = ACTIONS(4007),
    [anon_sym_DASH_DOT] = ACTIONS(4007),
    [anon_sym_PERCENT] = ACTIONS(4007),
    [anon_sym_AMP_AMP] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4005),
    [aux_sym_prefix_op_token1] = ACTIONS(4007),
    [aux_sym_infix_op_token1] = ACTIONS(4005),
    [aux_sym_infix_op_token2] = ACTIONS(4007),
    [anon_sym_PIPE_PIPE] = ACTIONS(4007),
    [anon_sym_BANG_EQ] = ACTIONS(4007),
    [anon_sym_COLON_EQ] = ACTIONS(4005),
    [anon_sym_DOLLAR] = ACTIONS(4007),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4007),
    [sym_int] = ACTIONS(4007),
    [sym_xint] = ACTIONS(4005),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4005),
    [sym__newline] = ACTIONS(4005),
    [sym__dedent] = ACTIONS(4005),
  },
  [2813] = {
    [sym_block_comment] = STATE(2813),
    [sym_compiler_directive_decl] = STATE(2813),
    [sym_fsi_directive_decl] = STATE(2813),
    [sym_preproc_line] = STATE(2813),
    [sym_identifier] = ACTIONS(4240),
    [anon_sym_EQ] = ACTIONS(4238),
    [anon_sym_COLON] = ACTIONS(4240),
    [anon_sym_return] = ACTIONS(4240),
    [anon_sym_do] = ACTIONS(4240),
    [anon_sym_let] = ACTIONS(4240),
    [anon_sym_let_BANG] = ACTIONS(4238),
    [anon_sym_as] = ACTIONS(4240),
    [anon_sym_LPAREN] = ACTIONS(4240),
    [anon_sym_COMMA] = ACTIONS(4238),
    [anon_sym_null] = ACTIONS(4240),
    [anon_sym_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_COLON] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4240),
    [anon_sym_LBRACK] = ACTIONS(4240),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4238),
    [anon_sym_LBRACE] = ACTIONS(4240),
    [anon_sym_LT_AT] = ACTIONS(4240),
    [anon_sym_LT_AT_AT] = ACTIONS(4240),
    [anon_sym_DOT] = ACTIONS(4240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4238),
    [anon_sym_new] = ACTIONS(4240),
    [anon_sym_with] = ACTIONS(4240),
    [anon_sym_return_BANG] = ACTIONS(4238),
    [anon_sym_yield] = ACTIONS(4240),
    [anon_sym_yield_BANG] = ACTIONS(4238),
    [anon_sym_lazy] = ACTIONS(4240),
    [anon_sym_assert] = ACTIONS(4240),
    [anon_sym_upcast] = ACTIONS(4240),
    [anon_sym_downcast] = ACTIONS(4240),
    [anon_sym_COLON_GT] = ACTIONS(4238),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4238),
    [anon_sym_for] = ACTIONS(4240),
    [anon_sym_while] = ACTIONS(4240),
    [anon_sym_if] = ACTIONS(4240),
    [anon_sym_fun] = ACTIONS(4240),
    [anon_sym_try] = ACTIONS(4240),
    [anon_sym_match] = ACTIONS(4240),
    [anon_sym_match_BANG] = ACTIONS(4238),
    [anon_sym_function] = ACTIONS(4240),
    [anon_sym_LT_DASH] = ACTIONS(4240),
    [anon_sym_DOT_LBRACK] = ACTIONS(4238),
    [anon_sym_LT] = ACTIONS(4238),
    [anon_sym_use] = ACTIONS(4240),
    [anon_sym_use_BANG] = ACTIONS(4238),
    [anon_sym_do_BANG] = ACTIONS(4238),
    [anon_sym_begin] = ACTIONS(4240),
    [anon_sym_LPAREN2] = ACTIONS(4240),
    [anon_sym_or] = ACTIONS(4240),
    [aux_sym_char_token1] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4240),
    [anon_sym_DQUOTE] = ACTIONS(4240),
    [anon_sym_AT_DQUOTE] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [sym_bool] = ACTIONS(4240),
    [sym_unit] = ACTIONS(4238),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4240),
    [sym_op_identifier] = ACTIONS(4240),
    [anon_sym_PLUS] = ACTIONS(4240),
    [anon_sym_DASH] = ACTIONS(4240),
    [anon_sym_PLUS_DOT] = ACTIONS(4240),
    [anon_sym_DASH_DOT] = ACTIONS(4240),
    [anon_sym_PERCENT] = ACTIONS(4240),
    [anon_sym_AMP_AMP] = ACTIONS(4240),
    [anon_sym_TILDE] = ACTIONS(4238),
    [aux_sym_prefix_op_token1] = ACTIONS(4240),
    [aux_sym_infix_op_token1] = ACTIONS(4238),
    [aux_sym_infix_op_token2] = ACTIONS(4240),
    [anon_sym_PIPE_PIPE] = ACTIONS(4240),
    [anon_sym_BANG_EQ] = ACTIONS(4240),
    [anon_sym_COLON_EQ] = ACTIONS(4238),
    [anon_sym_DOLLAR] = ACTIONS(4240),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4240),
    [sym_int] = ACTIONS(4240),
    [sym_xint] = ACTIONS(4238),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4238),
    [sym__newline] = ACTIONS(4238),
    [sym__dedent] = ACTIONS(4238),
  },
  [2814] = {
    [sym_block_comment] = STATE(2814),
    [sym_compiler_directive_decl] = STATE(2814),
    [sym_fsi_directive_decl] = STATE(2814),
    [sym_preproc_line] = STATE(2814),
    [aux_sym_long_identifier_repeat1] = STATE(2891),
    [sym_identifier] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3778),
    [anon_sym_COLON] = ACTIONS(3781),
    [anon_sym_return] = ACTIONS(3781),
    [anon_sym_do] = ACTIONS(3781),
    [anon_sym_let] = ACTIONS(3781),
    [anon_sym_let_BANG] = ACTIONS(3778),
    [anon_sym_as] = ACTIONS(3781),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3778),
    [anon_sym_null] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3781),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_LT_AT] = ACTIONS(3781),
    [anon_sym_LT_AT_AT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(5350),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3778),
    [anon_sym_new] = ACTIONS(3781),
    [anon_sym_with] = ACTIONS(3781),
    [anon_sym_return_BANG] = ACTIONS(3778),
    [anon_sym_yield] = ACTIONS(3781),
    [anon_sym_yield_BANG] = ACTIONS(3778),
    [anon_sym_lazy] = ACTIONS(3781),
    [anon_sym_assert] = ACTIONS(3781),
    [anon_sym_upcast] = ACTIONS(3781),
    [anon_sym_downcast] = ACTIONS(3781),
    [anon_sym_COLON_GT] = ACTIONS(3778),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3778),
    [anon_sym_for] = ACTIONS(3781),
    [anon_sym_while] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_fun] = ACTIONS(3781),
    [anon_sym_try] = ACTIONS(3781),
    [anon_sym_match] = ACTIONS(3781),
    [anon_sym_match_BANG] = ACTIONS(3778),
    [anon_sym_function] = ACTIONS(3781),
    [anon_sym_LT_DASH] = ACTIONS(3781),
    [anon_sym_DOT_LBRACK] = ACTIONS(3778),
    [anon_sym_LT] = ACTIONS(3778),
    [anon_sym_use] = ACTIONS(3781),
    [anon_sym_use_BANG] = ACTIONS(3778),
    [anon_sym_do_BANG] = ACTIONS(3778),
    [anon_sym_begin] = ACTIONS(3781),
    [anon_sym_LPAREN2] = ACTIONS(3781),
    [anon_sym_or] = ACTIONS(3781),
    [aux_sym_char_token1] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3781),
    [anon_sym_DQUOTE] = ACTIONS(3781),
    [anon_sym_AT_DQUOTE] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [sym_bool] = ACTIONS(3781),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3781),
    [sym_op_identifier] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3781),
    [anon_sym_DASH] = ACTIONS(3781),
    [anon_sym_PLUS_DOT] = ACTIONS(3781),
    [anon_sym_DASH_DOT] = ACTIONS(3781),
    [anon_sym_PERCENT] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3781),
    [anon_sym_TILDE] = ACTIONS(3778),
    [aux_sym_prefix_op_token1] = ACTIONS(3781),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token2] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_COLON_EQ] = ACTIONS(3778),
    [anon_sym_DOLLAR] = ACTIONS(3781),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3781),
    [sym_int] = ACTIONS(3781),
    [sym_xint] = ACTIONS(3778),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3778),
    [sym__newline] = ACTIONS(3778),
  },
  [2815] = {
    [sym_block_comment] = STATE(2815),
    [sym_compiler_directive_decl] = STATE(2815),
    [sym_fsi_directive_decl] = STATE(2815),
    [sym_preproc_line] = STATE(2815),
    [aux_sym_rules_repeat1] = STATE(2816),
    [sym_identifier] = ACTIONS(3676),
    [anon_sym_EQ] = ACTIONS(3674),
    [anon_sym_COLON] = ACTIONS(3676),
    [anon_sym_return] = ACTIONS(3676),
    [anon_sym_do] = ACTIONS(3676),
    [anon_sym_let] = ACTIONS(3676),
    [anon_sym_let_BANG] = ACTIONS(3674),
    [anon_sym_LPAREN] = ACTIONS(3676),
    [anon_sym_COMMA] = ACTIONS(3674),
    [anon_sym_null] = ACTIONS(3676),
    [anon_sym_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_COLON] = ACTIONS(3674),
    [anon_sym_PIPE] = ACTIONS(5334),
    [anon_sym_AMP] = ACTIONS(3676),
    [anon_sym_LBRACK] = ACTIONS(3676),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3674),
    [anon_sym_LBRACE] = ACTIONS(3676),
    [anon_sym_LT_AT] = ACTIONS(3676),
    [anon_sym_LT_AT_AT] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3674),
    [anon_sym_new] = ACTIONS(3676),
    [anon_sym_return_BANG] = ACTIONS(3674),
    [anon_sym_yield] = ACTIONS(3676),
    [anon_sym_yield_BANG] = ACTIONS(3674),
    [anon_sym_lazy] = ACTIONS(3676),
    [anon_sym_assert] = ACTIONS(3676),
    [anon_sym_upcast] = ACTIONS(3676),
    [anon_sym_downcast] = ACTIONS(3676),
    [anon_sym_COLON_GT] = ACTIONS(3674),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3674),
    [anon_sym_for] = ACTIONS(3676),
    [anon_sym_while] = ACTIONS(3676),
    [anon_sym_if] = ACTIONS(3676),
    [anon_sym_fun] = ACTIONS(3676),
    [anon_sym_try] = ACTIONS(3676),
    [anon_sym_match] = ACTIONS(3676),
    [anon_sym_match_BANG] = ACTIONS(3674),
    [anon_sym_function] = ACTIONS(3676),
    [anon_sym_LT_DASH] = ACTIONS(3676),
    [anon_sym_DOT_LBRACK] = ACTIONS(3674),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_use] = ACTIONS(3676),
    [anon_sym_use_BANG] = ACTIONS(3674),
    [anon_sym_do_BANG] = ACTIONS(3674),
    [anon_sym_DOT_DOT] = ACTIONS(3674),
    [anon_sym_begin] = ACTIONS(3676),
    [anon_sym_LPAREN2] = ACTIONS(3676),
    [anon_sym_or] = ACTIONS(3676),
    [aux_sym_char_token1] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3676),
    [anon_sym_DQUOTE] = ACTIONS(3676),
    [anon_sym_AT_DQUOTE] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [sym_bool] = ACTIONS(3676),
    [sym_unit] = ACTIONS(3674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3676),
    [sym_op_identifier] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_PLUS_DOT] = ACTIONS(3676),
    [anon_sym_DASH_DOT] = ACTIONS(3676),
    [anon_sym_PERCENT] = ACTIONS(3676),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_TILDE] = ACTIONS(3674),
    [aux_sym_prefix_op_token1] = ACTIONS(3676),
    [aux_sym_infix_op_token1] = ACTIONS(3674),
    [aux_sym_infix_op_token2] = ACTIONS(3676),
    [anon_sym_PIPE_PIPE] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3676),
    [anon_sym_COLON_EQ] = ACTIONS(3674),
    [anon_sym_DOLLAR] = ACTIONS(3676),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3676),
    [sym_int] = ACTIONS(3676),
    [sym_xint] = ACTIONS(3674),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3674),
    [sym__newline] = ACTIONS(5354),
  },
  [2816] = {
    [sym_block_comment] = STATE(2816),
    [sym_compiler_directive_decl] = STATE(2816),
    [sym_fsi_directive_decl] = STATE(2816),
    [sym_preproc_line] = STATE(2816),
    [aux_sym_rules_repeat1] = STATE(2816),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(5357),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_DOT_DOT] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_or] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [sym__newline] = ACTIONS(5360),
  },
  [2817] = {
    [sym_attributes] = STATE(3988),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4988),
    [sym__pattern] = STATE(4899),
    [sym_optional_pattern] = STATE(4988),
    [sym_type_check_pattern] = STATE(4988),
    [sym_attribute_pattern] = STATE(4988),
    [sym_paren_pattern] = STATE(4988),
    [sym_as_pattern] = STATE(4988),
    [sym_cons_pattern] = STATE(4988),
    [sym_disjunct_pattern] = STATE(4988),
    [sym_conjunct_pattern] = STATE(4988),
    [sym_typed_pattern] = STATE(4988),
    [sym_list_pattern] = STATE(4988),
    [sym_array_pattern] = STATE(4988),
    [sym_record_pattern] = STATE(4988),
    [sym_named_field_pattern] = STATE(4988),
    [sym_identifier_pattern] = STATE(4988),
    [sym_long_identifier_or_op] = STATE(3177),
    [sym_char] = STATE(5109),
    [sym_format_string] = STATE(5097),
    [sym__string_literal] = STATE(5097),
    [sym_string] = STATE(5109),
    [sym_verbatim_string] = STATE(5109),
    [sym_bytearray] = STATE(5109),
    [sym_verbatim_bytearray] = STATE(5109),
    [sym_format_triple_quoted_string] = STATE(5096),
    [sym_triple_quoted_string] = STATE(5109),
    [sym_const] = STATE(4988),
    [sym_long_identifier] = STATE(4907),
    [sym_active_pattern] = STATE(5059),
    [sym__identifier_or_op] = STATE(4927),
    [sym_sbyte] = STATE(5109),
    [sym_byte] = STATE(5109),
    [sym_int16] = STATE(5109),
    [sym_uint16] = STATE(5109),
    [sym_int32] = STATE(5109),
    [sym_uint32] = STATE(5109),
    [sym_nativeint] = STATE(5109),
    [sym_unativeint] = STATE(5109),
    [sym_int64] = STATE(5109),
    [sym_uint64] = STATE(5109),
    [sym_ieee32] = STATE(5109),
    [sym_ieee64] = STATE(5109),
    [sym_bignum] = STATE(5109),
    [sym_decimal] = STATE(5109),
    [sym_float] = STATE(4781),
    [sym_block_comment] = STATE(2817),
    [sym_compiler_directive_decl] = STATE(2817),
    [sym_fsi_directive_decl] = STATE(2817),
    [sym_preproc_line] = STATE(2817),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym_repeat_pattern_repeat1] = STATE(4826),
    [sym_identifier] = ACTIONS(5363),
    [anon_sym_LBRACK_LT] = ACTIONS(5365),
    [anon_sym_COLON] = ACTIONS(5363),
    [anon_sym_as] = ACTIONS(5367),
    [anon_sym_LPAREN] = ACTIONS(5363),
    [anon_sym_RPAREN] = ACTIONS(5365),
    [anon_sym_COMMA] = ACTIONS(5369),
    [anon_sym_null] = ACTIONS(5363),
    [anon_sym__] = ACTIONS(5363),
    [anon_sym_QMARK] = ACTIONS(5365),
    [anon_sym_COLON_QMARK] = ACTIONS(5365),
    [anon_sym_COLON_COLON] = ACTIONS(5371),
    [anon_sym_PIPE] = ACTIONS(5373),
    [anon_sym_AMP] = ACTIONS(5375),
    [anon_sym_LBRACK] = ACTIONS(5363),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5365),
    [anon_sym_LBRACE] = ACTIONS(5365),
    [anon_sym_RBRACE] = ACTIONS(5365),
    [aux_sym_char_token1] = ACTIONS(5365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5363),
    [anon_sym_DQUOTE] = ACTIONS(5363),
    [anon_sym_AT_DQUOTE] = ACTIONS(5365),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5365),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5365),
    [sym_bool] = ACTIONS(5363),
    [sym_unit] = ACTIONS(5365),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5363),
    [sym_op_identifier] = ACTIONS(5365),
    [sym_int] = ACTIONS(5363),
    [sym_xint] = ACTIONS(5365),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [sym__newline] = ACTIONS(5365),
  },
  [2818] = {
    [sym_type_arguments] = STATE(3605),
    [sym__object_members] = STATE(3824),
    [sym_long_identifier] = STATE(3604),
    [sym_block_comment] = STATE(2818),
    [sym_compiler_directive_decl] = STATE(2818),
    [sym_fsi_directive_decl] = STATE(2818),
    [sym_preproc_line] = STATE(2818),
    [aux_sym_compound_type_repeat1] = STATE(3597),
    [ts_builtin_sym_end] = ACTIONS(5377),
    [sym_identifier] = ACTIONS(5379),
    [anon_sym_namespace] = ACTIONS(5381),
    [anon_sym_module] = ACTIONS(5381),
    [anon_sym_open] = ACTIONS(5381),
    [anon_sym_LBRACK_LT] = ACTIONS(5377),
    [anon_sym_return] = ACTIONS(5381),
    [anon_sym_type] = ACTIONS(5381),
    [anon_sym_do] = ACTIONS(5381),
    [anon_sym_and] = ACTIONS(5381),
    [anon_sym_let] = ACTIONS(5381),
    [anon_sym_let_BANG] = ACTIONS(5377),
    [aux_sym_access_modifier_token1] = ACTIONS(5377),
    [anon_sym_LPAREN] = ACTIONS(5381),
    [anon_sym_null] = ACTIONS(5381),
    [anon_sym_AMP] = ACTIONS(5381),
    [anon_sym_LBRACK] = ACTIONS(5381),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5377),
    [anon_sym_LBRACE] = ACTIONS(5381),
    [anon_sym_LT_AT] = ACTIONS(5381),
    [anon_sym_LT_AT_AT] = ACTIONS(5377),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5377),
    [anon_sym_new] = ACTIONS(5381),
    [anon_sym_with] = ACTIONS(5383),
    [anon_sym_return_BANG] = ACTIONS(5377),
    [anon_sym_yield] = ACTIONS(5381),
    [anon_sym_yield_BANG] = ACTIONS(5377),
    [anon_sym_lazy] = ACTIONS(5381),
    [anon_sym_assert] = ACTIONS(5381),
    [anon_sym_upcast] = ACTIONS(5381),
    [anon_sym_downcast] = ACTIONS(5381),
    [anon_sym_for] = ACTIONS(5381),
    [anon_sym_while] = ACTIONS(5381),
    [anon_sym_if] = ACTIONS(5381),
    [anon_sym_fun] = ACTIONS(5381),
    [anon_sym_DASH_GT] = ACTIONS(5385),
    [anon_sym_try] = ACTIONS(5381),
    [anon_sym_match] = ACTIONS(5381),
    [anon_sym_match_BANG] = ACTIONS(5377),
    [anon_sym_function] = ACTIONS(5381),
    [anon_sym_use] = ACTIONS(5381),
    [anon_sym_use_BANG] = ACTIONS(5377),
    [anon_sym_do_BANG] = ACTIONS(5377),
    [anon_sym_begin] = ACTIONS(5381),
    [anon_sym_STAR] = ACTIONS(5387),
    [anon_sym_LT2] = ACTIONS(5389),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5391),
    [anon_sym_default] = ACTIONS(5381),
    [anon_sym_static] = ACTIONS(5381),
    [anon_sym_member] = ACTIONS(5381),
    [anon_sym_interface] = ACTIONS(5381),
    [anon_sym_exception] = ACTIONS(5381),
    [anon_sym_abstract] = ACTIONS(5381),
    [anon_sym_val] = ACTIONS(5381),
    [anon_sym_override] = ACTIONS(5381),
    [aux_sym_char_token1] = ACTIONS(5377),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5381),
    [anon_sym_DQUOTE] = ACTIONS(5381),
    [anon_sym_AT_DQUOTE] = ACTIONS(5377),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5377),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5377),
    [sym_bool] = ACTIONS(5381),
    [sym_unit] = ACTIONS(5377),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5381),
    [sym_op_identifier] = ACTIONS(5377),
    [anon_sym_PLUS] = ACTIONS(5381),
    [anon_sym_DASH] = ACTIONS(5381),
    [anon_sym_PLUS_DOT] = ACTIONS(5377),
    [anon_sym_DASH_DOT] = ACTIONS(5377),
    [anon_sym_PERCENT] = ACTIONS(5377),
    [anon_sym_AMP_AMP] = ACTIONS(5377),
    [anon_sym_TILDE] = ACTIONS(5377),
    [aux_sym_prefix_op_token1] = ACTIONS(5377),
    [sym_int] = ACTIONS(5381),
    [sym_xint] = ACTIONS(5377),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5377),
    [anon_sym_POUNDload] = ACTIONS(5377),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(5377),
  },
  [2819] = {
    [sym_block_comment] = STATE(2819),
    [sym_compiler_directive_decl] = STATE(2819),
    [sym_fsi_directive_decl] = STATE(2819),
    [sym_preproc_line] = STATE(2819),
    [sym_identifier] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3919),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_return] = ACTIONS(3921),
    [anon_sym_do] = ACTIONS(3921),
    [anon_sym_let] = ACTIONS(3921),
    [anon_sym_let_BANG] = ACTIONS(3919),
    [anon_sym_as] = ACTIONS(3921),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3919),
    [anon_sym_null] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_COLON] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3919),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_LT_AT] = ACTIONS(3921),
    [anon_sym_LT_AT_AT] = ACTIONS(3921),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3919),
    [anon_sym_new] = ACTIONS(3921),
    [anon_sym_with] = ACTIONS(3921),
    [anon_sym_return_BANG] = ACTIONS(3919),
    [anon_sym_yield] = ACTIONS(3921),
    [anon_sym_yield_BANG] = ACTIONS(3919),
    [anon_sym_lazy] = ACTIONS(3921),
    [anon_sym_assert] = ACTIONS(3921),
    [anon_sym_upcast] = ACTIONS(3921),
    [anon_sym_downcast] = ACTIONS(3921),
    [anon_sym_COLON_GT] = ACTIONS(3919),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3919),
    [anon_sym_for] = ACTIONS(3921),
    [anon_sym_while] = ACTIONS(3921),
    [anon_sym_if] = ACTIONS(3921),
    [anon_sym_fun] = ACTIONS(3921),
    [anon_sym_try] = ACTIONS(3921),
    [anon_sym_match] = ACTIONS(3921),
    [anon_sym_match_BANG] = ACTIONS(3919),
    [anon_sym_function] = ACTIONS(3921),
    [anon_sym_LT_DASH] = ACTIONS(3921),
    [anon_sym_DOT_LBRACK] = ACTIONS(3919),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_use] = ACTIONS(3921),
    [anon_sym_use_BANG] = ACTIONS(3919),
    [anon_sym_do_BANG] = ACTIONS(3919),
    [anon_sym_begin] = ACTIONS(3921),
    [anon_sym_LPAREN2] = ACTIONS(3921),
    [anon_sym_or] = ACTIONS(3921),
    [aux_sym_char_token1] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_AT_DQUOTE] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [sym_bool] = ACTIONS(3921),
    [sym_unit] = ACTIONS(3919),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3921),
    [sym_op_identifier] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_DOT] = ACTIONS(3921),
    [anon_sym_DASH_DOT] = ACTIONS(3921),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3919),
    [aux_sym_prefix_op_token1] = ACTIONS(3921),
    [aux_sym_infix_op_token1] = ACTIONS(3919),
    [aux_sym_infix_op_token2] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_COLON_EQ] = ACTIONS(3919),
    [anon_sym_DOLLAR] = ACTIONS(3921),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3921),
    [sym_int] = ACTIONS(3921),
    [sym_xint] = ACTIONS(3919),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3919),
    [sym__newline] = ACTIONS(3919),
    [sym__dedent] = ACTIONS(3919),
  },
  [2820] = {
    [sym_block_comment] = STATE(2820),
    [sym_compiler_directive_decl] = STATE(2820),
    [sym_fsi_directive_decl] = STATE(2820),
    [sym_preproc_line] = STATE(2820),
    [sym_identifier] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4246),
    [anon_sym_COLON] = ACTIONS(4248),
    [anon_sym_return] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4248),
    [anon_sym_let] = ACTIONS(4248),
    [anon_sym_let_BANG] = ACTIONS(4246),
    [anon_sym_as] = ACTIONS(4248),
    [anon_sym_LPAREN] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_null] = ACTIONS(4248),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4248),
    [anon_sym_LT_AT] = ACTIONS(4248),
    [anon_sym_LT_AT_AT] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4246),
    [anon_sym_new] = ACTIONS(4248),
    [anon_sym_with] = ACTIONS(4248),
    [anon_sym_return_BANG] = ACTIONS(4246),
    [anon_sym_yield] = ACTIONS(4248),
    [anon_sym_yield_BANG] = ACTIONS(4246),
    [anon_sym_lazy] = ACTIONS(4248),
    [anon_sym_assert] = ACTIONS(4248),
    [anon_sym_upcast] = ACTIONS(4248),
    [anon_sym_downcast] = ACTIONS(4248),
    [anon_sym_COLON_GT] = ACTIONS(4246),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4246),
    [anon_sym_for] = ACTIONS(4248),
    [anon_sym_while] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4248),
    [anon_sym_fun] = ACTIONS(4248),
    [anon_sym_try] = ACTIONS(4248),
    [anon_sym_match] = ACTIONS(4248),
    [anon_sym_match_BANG] = ACTIONS(4246),
    [anon_sym_function] = ACTIONS(4248),
    [anon_sym_LT_DASH] = ACTIONS(4248),
    [anon_sym_DOT_LBRACK] = ACTIONS(4246),
    [anon_sym_LT] = ACTIONS(4246),
    [anon_sym_use] = ACTIONS(4248),
    [anon_sym_use_BANG] = ACTIONS(4246),
    [anon_sym_do_BANG] = ACTIONS(4246),
    [anon_sym_begin] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4248),
    [aux_sym_char_token1] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4248),
    [anon_sym_DQUOTE] = ACTIONS(4248),
    [anon_sym_AT_DQUOTE] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [sym_bool] = ACTIONS(4248),
    [sym_unit] = ACTIONS(4246),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4248),
    [sym_op_identifier] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_DOT] = ACTIONS(4248),
    [anon_sym_DASH_DOT] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_TILDE] = ACTIONS(4246),
    [aux_sym_prefix_op_token1] = ACTIONS(4248),
    [aux_sym_infix_op_token1] = ACTIONS(4246),
    [aux_sym_infix_op_token2] = ACTIONS(4248),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_COLON_EQ] = ACTIONS(4246),
    [anon_sym_DOLLAR] = ACTIONS(4248),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4248),
    [sym_int] = ACTIONS(4248),
    [sym_xint] = ACTIONS(4246),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4246),
    [sym__newline] = ACTIONS(4246),
    [sym__dedent] = ACTIONS(4246),
  },
  [2821] = {
    [sym_block_comment] = STATE(2821),
    [sym_compiler_directive_decl] = STATE(2821),
    [sym_fsi_directive_decl] = STATE(2821),
    [sym_preproc_line] = STATE(2821),
    [sym_identifier] = ACTIONS(4170),
    [anon_sym_EQ] = ACTIONS(4168),
    [anon_sym_COLON] = ACTIONS(4170),
    [anon_sym_return] = ACTIONS(4170),
    [anon_sym_do] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_let_BANG] = ACTIONS(4168),
    [anon_sym_as] = ACTIONS(4170),
    [anon_sym_LPAREN] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4168),
    [anon_sym_null] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_COLON] = ACTIONS(4168),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4170),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4168),
    [anon_sym_LBRACE] = ACTIONS(4170),
    [anon_sym_LT_AT] = ACTIONS(4170),
    [anon_sym_LT_AT_AT] = ACTIONS(4170),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4168),
    [anon_sym_new] = ACTIONS(4170),
    [anon_sym_with] = ACTIONS(4170),
    [anon_sym_return_BANG] = ACTIONS(4168),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_yield_BANG] = ACTIONS(4168),
    [anon_sym_lazy] = ACTIONS(4170),
    [anon_sym_assert] = ACTIONS(4170),
    [anon_sym_upcast] = ACTIONS(4170),
    [anon_sym_downcast] = ACTIONS(4170),
    [anon_sym_COLON_GT] = ACTIONS(4168),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4168),
    [anon_sym_for] = ACTIONS(4170),
    [anon_sym_while] = ACTIONS(4170),
    [anon_sym_if] = ACTIONS(4170),
    [anon_sym_fun] = ACTIONS(4170),
    [anon_sym_try] = ACTIONS(4170),
    [anon_sym_match] = ACTIONS(4170),
    [anon_sym_match_BANG] = ACTIONS(4168),
    [anon_sym_function] = ACTIONS(4170),
    [anon_sym_LT_DASH] = ACTIONS(4170),
    [anon_sym_DOT_LBRACK] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4168),
    [anon_sym_use] = ACTIONS(4170),
    [anon_sym_use_BANG] = ACTIONS(4168),
    [anon_sym_do_BANG] = ACTIONS(4168),
    [anon_sym_begin] = ACTIONS(4170),
    [anon_sym_LPAREN2] = ACTIONS(4170),
    [anon_sym_or] = ACTIONS(4170),
    [aux_sym_char_token1] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4170),
    [anon_sym_DQUOTE] = ACTIONS(4170),
    [anon_sym_AT_DQUOTE] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [sym_bool] = ACTIONS(4170),
    [sym_unit] = ACTIONS(4168),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4170),
    [sym_op_identifier] = ACTIONS(4170),
    [anon_sym_PLUS] = ACTIONS(4170),
    [anon_sym_DASH] = ACTIONS(4170),
    [anon_sym_PLUS_DOT] = ACTIONS(4170),
    [anon_sym_DASH_DOT] = ACTIONS(4170),
    [anon_sym_PERCENT] = ACTIONS(4170),
    [anon_sym_AMP_AMP] = ACTIONS(4170),
    [anon_sym_TILDE] = ACTIONS(4168),
    [aux_sym_prefix_op_token1] = ACTIONS(4170),
    [aux_sym_infix_op_token1] = ACTIONS(4168),
    [aux_sym_infix_op_token2] = ACTIONS(4170),
    [anon_sym_PIPE_PIPE] = ACTIONS(4170),
    [anon_sym_BANG_EQ] = ACTIONS(4170),
    [anon_sym_COLON_EQ] = ACTIONS(4168),
    [anon_sym_DOLLAR] = ACTIONS(4170),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4170),
    [sym_int] = ACTIONS(4170),
    [sym_xint] = ACTIONS(4168),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4168),
    [sym__newline] = ACTIONS(4168),
    [sym__dedent] = ACTIONS(4168),
  },
  [2822] = {
    [sym_block_comment] = STATE(2822),
    [sym_compiler_directive_decl] = STATE(2822),
    [sym_fsi_directive_decl] = STATE(2822),
    [sym_preproc_line] = STATE(2822),
    [sym_identifier] = ACTIONS(3732),
    [anon_sym_EQ] = ACTIONS(3730),
    [anon_sym_COLON] = ACTIONS(3732),
    [anon_sym_return] = ACTIONS(3732),
    [anon_sym_do] = ACTIONS(3732),
    [anon_sym_let] = ACTIONS(3732),
    [anon_sym_let_BANG] = ACTIONS(3730),
    [anon_sym_LPAREN] = ACTIONS(3732),
    [anon_sym_COMMA] = ACTIONS(3730),
    [anon_sym_null] = ACTIONS(3732),
    [anon_sym_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_LBRACK] = ACTIONS(3732),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3730),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_LT_AT] = ACTIONS(3732),
    [anon_sym_LT_AT_AT] = ACTIONS(3732),
    [anon_sym_DOT] = ACTIONS(3732),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3730),
    [anon_sym_new] = ACTIONS(3732),
    [anon_sym_return_BANG] = ACTIONS(3730),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_yield_BANG] = ACTIONS(3730),
    [anon_sym_lazy] = ACTIONS(3732),
    [anon_sym_assert] = ACTIONS(3732),
    [anon_sym_upcast] = ACTIONS(3732),
    [anon_sym_downcast] = ACTIONS(3732),
    [anon_sym_COLON_GT] = ACTIONS(3730),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3730),
    [anon_sym_for] = ACTIONS(3732),
    [anon_sym_while] = ACTIONS(3732),
    [anon_sym_else] = ACTIONS(3732),
    [anon_sym_elif] = ACTIONS(3732),
    [anon_sym_if] = ACTIONS(3732),
    [anon_sym_fun] = ACTIONS(3732),
    [anon_sym_try] = ACTIONS(3732),
    [anon_sym_match] = ACTIONS(3732),
    [anon_sym_match_BANG] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3732),
    [anon_sym_LT_DASH] = ACTIONS(3732),
    [anon_sym_DOT_LBRACK] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3730),
    [anon_sym_GT] = ACTIONS(3732),
    [anon_sym_use] = ACTIONS(3732),
    [anon_sym_use_BANG] = ACTIONS(3730),
    [anon_sym_do_BANG] = ACTIONS(3730),
    [anon_sym_begin] = ACTIONS(3732),
    [anon_sym_LPAREN2] = ACTIONS(3732),
    [anon_sym_or] = ACTIONS(3732),
    [aux_sym_char_token1] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3732),
    [anon_sym_DQUOTE] = ACTIONS(3732),
    [anon_sym_AT_DQUOTE] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [sym_bool] = ACTIONS(3732),
    [sym_unit] = ACTIONS(3730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3732),
    [sym_op_identifier] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PLUS_DOT] = ACTIONS(3732),
    [anon_sym_DASH_DOT] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3732),
    [anon_sym_AMP_AMP] = ACTIONS(3732),
    [anon_sym_TILDE] = ACTIONS(3730),
    [aux_sym_prefix_op_token1] = ACTIONS(3732),
    [aux_sym_infix_op_token1] = ACTIONS(3730),
    [aux_sym_infix_op_token2] = ACTIONS(3732),
    [anon_sym_PIPE_PIPE] = ACTIONS(3732),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_COLON_EQ] = ACTIONS(3730),
    [anon_sym_DOLLAR] = ACTIONS(3732),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3732),
    [sym_int] = ACTIONS(3732),
    [sym_xint] = ACTIONS(3730),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3730),
    [sym__newline] = ACTIONS(3730),
  },
  [2823] = {
    [sym_block_comment] = STATE(2823),
    [sym_compiler_directive_decl] = STATE(2823),
    [sym_fsi_directive_decl] = STATE(2823),
    [sym_preproc_line] = STATE(2823),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_EQ] = ACTIONS(3646),
    [anon_sym_COLON] = ACTIONS(3648),
    [anon_sym_return] = ACTIONS(3648),
    [anon_sym_do] = ACTIONS(3648),
    [anon_sym_let] = ACTIONS(3648),
    [anon_sym_let_BANG] = ACTIONS(3646),
    [anon_sym_LPAREN] = ACTIONS(3648),
    [anon_sym_COMMA] = ACTIONS(3646),
    [anon_sym_null] = ACTIONS(3648),
    [anon_sym_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_COLON] = ACTIONS(3646),
    [anon_sym_AMP] = ACTIONS(3648),
    [anon_sym_LBRACK] = ACTIONS(3648),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3646),
    [anon_sym_LBRACE] = ACTIONS(3648),
    [anon_sym_LT_AT] = ACTIONS(3648),
    [anon_sym_LT_AT_AT] = ACTIONS(3648),
    [anon_sym_DOT] = ACTIONS(3648),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3646),
    [anon_sym_new] = ACTIONS(3648),
    [anon_sym_return_BANG] = ACTIONS(3646),
    [anon_sym_yield] = ACTIONS(3648),
    [anon_sym_yield_BANG] = ACTIONS(3646),
    [anon_sym_lazy] = ACTIONS(3648),
    [anon_sym_assert] = ACTIONS(3648),
    [anon_sym_upcast] = ACTIONS(3648),
    [anon_sym_downcast] = ACTIONS(3648),
    [anon_sym_COLON_GT] = ACTIONS(3646),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3646),
    [anon_sym_for] = ACTIONS(3648),
    [anon_sym_while] = ACTIONS(3648),
    [anon_sym_else] = ACTIONS(3648),
    [anon_sym_elif] = ACTIONS(3648),
    [anon_sym_if] = ACTIONS(3648),
    [anon_sym_fun] = ACTIONS(3648),
    [anon_sym_try] = ACTIONS(3648),
    [anon_sym_match] = ACTIONS(3648),
    [anon_sym_match_BANG] = ACTIONS(3646),
    [anon_sym_function] = ACTIONS(3648),
    [anon_sym_LT_DASH] = ACTIONS(3648),
    [anon_sym_DOT_LBRACK] = ACTIONS(3646),
    [anon_sym_LT] = ACTIONS(3646),
    [anon_sym_GT] = ACTIONS(3648),
    [anon_sym_use] = ACTIONS(3648),
    [anon_sym_use_BANG] = ACTIONS(3646),
    [anon_sym_do_BANG] = ACTIONS(3646),
    [anon_sym_begin] = ACTIONS(3648),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3648),
    [aux_sym_char_token1] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3648),
    [anon_sym_AT_DQUOTE] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [sym_bool] = ACTIONS(3648),
    [sym_unit] = ACTIONS(3646),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3648),
    [sym_op_identifier] = ACTIONS(3648),
    [anon_sym_PLUS] = ACTIONS(3648),
    [anon_sym_DASH] = ACTIONS(3648),
    [anon_sym_PLUS_DOT] = ACTIONS(3648),
    [anon_sym_DASH_DOT] = ACTIONS(3648),
    [anon_sym_PERCENT] = ACTIONS(3648),
    [anon_sym_AMP_AMP] = ACTIONS(3648),
    [anon_sym_TILDE] = ACTIONS(3646),
    [aux_sym_prefix_op_token1] = ACTIONS(3648),
    [aux_sym_infix_op_token1] = ACTIONS(3646),
    [aux_sym_infix_op_token2] = ACTIONS(3648),
    [anon_sym_PIPE_PIPE] = ACTIONS(3648),
    [anon_sym_BANG_EQ] = ACTIONS(3648),
    [anon_sym_COLON_EQ] = ACTIONS(3646),
    [anon_sym_DOLLAR] = ACTIONS(3648),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3648),
    [sym_int] = ACTIONS(3648),
    [sym_xint] = ACTIONS(3646),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3646),
    [sym__newline] = ACTIONS(3646),
  },
  [2824] = {
    [sym_block_comment] = STATE(2824),
    [sym_compiler_directive_decl] = STATE(2824),
    [sym_fsi_directive_decl] = STATE(2824),
    [sym_preproc_line] = STATE(2824),
    [sym_identifier] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4242),
    [anon_sym_COLON] = ACTIONS(4244),
    [anon_sym_return] = ACTIONS(4244),
    [anon_sym_do] = ACTIONS(4244),
    [anon_sym_let] = ACTIONS(4244),
    [anon_sym_let_BANG] = ACTIONS(4242),
    [anon_sym_as] = ACTIONS(4244),
    [anon_sym_LPAREN] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_null] = ACTIONS(4244),
    [anon_sym_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_COLON] = ACTIONS(4242),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4244),
    [anon_sym_LT_AT] = ACTIONS(4244),
    [anon_sym_LT_AT_AT] = ACTIONS(4244),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4242),
    [anon_sym_new] = ACTIONS(4244),
    [anon_sym_with] = ACTIONS(4244),
    [anon_sym_return_BANG] = ACTIONS(4242),
    [anon_sym_yield] = ACTIONS(4244),
    [anon_sym_yield_BANG] = ACTIONS(4242),
    [anon_sym_lazy] = ACTIONS(4244),
    [anon_sym_assert] = ACTIONS(4244),
    [anon_sym_upcast] = ACTIONS(4244),
    [anon_sym_downcast] = ACTIONS(4244),
    [anon_sym_COLON_GT] = ACTIONS(4242),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4242),
    [anon_sym_for] = ACTIONS(4244),
    [anon_sym_while] = ACTIONS(4244),
    [anon_sym_if] = ACTIONS(4244),
    [anon_sym_fun] = ACTIONS(4244),
    [anon_sym_try] = ACTIONS(4244),
    [anon_sym_match] = ACTIONS(4244),
    [anon_sym_match_BANG] = ACTIONS(4242),
    [anon_sym_function] = ACTIONS(4244),
    [anon_sym_LT_DASH] = ACTIONS(4244),
    [anon_sym_DOT_LBRACK] = ACTIONS(4242),
    [anon_sym_LT] = ACTIONS(4242),
    [anon_sym_use] = ACTIONS(4244),
    [anon_sym_use_BANG] = ACTIONS(4242),
    [anon_sym_do_BANG] = ACTIONS(4242),
    [anon_sym_begin] = ACTIONS(4244),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_or] = ACTIONS(4244),
    [aux_sym_char_token1] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4244),
    [anon_sym_DQUOTE] = ACTIONS(4244),
    [anon_sym_AT_DQUOTE] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [sym_bool] = ACTIONS(4244),
    [sym_unit] = ACTIONS(4242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4244),
    [sym_op_identifier] = ACTIONS(4244),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_DASH] = ACTIONS(4244),
    [anon_sym_PLUS_DOT] = ACTIONS(4244),
    [anon_sym_DASH_DOT] = ACTIONS(4244),
    [anon_sym_PERCENT] = ACTIONS(4244),
    [anon_sym_AMP_AMP] = ACTIONS(4244),
    [anon_sym_TILDE] = ACTIONS(4242),
    [aux_sym_prefix_op_token1] = ACTIONS(4244),
    [aux_sym_infix_op_token1] = ACTIONS(4242),
    [aux_sym_infix_op_token2] = ACTIONS(4244),
    [anon_sym_PIPE_PIPE] = ACTIONS(4244),
    [anon_sym_BANG_EQ] = ACTIONS(4244),
    [anon_sym_COLON_EQ] = ACTIONS(4242),
    [anon_sym_DOLLAR] = ACTIONS(4244),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4244),
    [sym_int] = ACTIONS(4244),
    [sym_xint] = ACTIONS(4242),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4242),
    [sym__newline] = ACTIONS(4242),
    [sym__dedent] = ACTIONS(4242),
  },
  [2825] = {
    [sym_block_comment] = STATE(2825),
    [sym_compiler_directive_decl] = STATE(2825),
    [sym_fsi_directive_decl] = STATE(2825),
    [sym_preproc_line] = STATE(2825),
    [aux_sym_sequential_expression_repeat1] = STATE(2921),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_COLON] = ACTIONS(3759),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_and] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_let_BANG] = ACTIONS(3757),
    [anon_sym_LPAREN] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3757),
    [anon_sym_null] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3757),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_LT_AT] = ACTIONS(3759),
    [anon_sym_LT_AT_AT] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(3759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_return_BANG] = ACTIONS(3757),
    [anon_sym_yield] = ACTIONS(3759),
    [anon_sym_yield_BANG] = ACTIONS(3757),
    [anon_sym_lazy] = ACTIONS(3759),
    [anon_sym_assert] = ACTIONS(3759),
    [anon_sym_upcast] = ACTIONS(3759),
    [anon_sym_downcast] = ACTIONS(3759),
    [anon_sym_COLON_GT] = ACTIONS(3757),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3757),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_fun] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_match] = ACTIONS(3759),
    [anon_sym_match_BANG] = ACTIONS(3757),
    [anon_sym_function] = ACTIONS(3759),
    [anon_sym_LT_DASH] = ACTIONS(3759),
    [anon_sym_DOT_LBRACK] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_use] = ACTIONS(3759),
    [anon_sym_use_BANG] = ACTIONS(3757),
    [anon_sym_do_BANG] = ACTIONS(3757),
    [anon_sym_begin] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_or] = ACTIONS(3759),
    [aux_sym_char_token1] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3759),
    [anon_sym_DQUOTE] = ACTIONS(3759),
    [anon_sym_AT_DQUOTE] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [sym_bool] = ACTIONS(3759),
    [sym_unit] = ACTIONS(3757),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3759),
    [sym_op_identifier] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS_DOT] = ACTIONS(3759),
    [anon_sym_DASH_DOT] = ACTIONS(3759),
    [anon_sym_PERCENT] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_TILDE] = ACTIONS(3757),
    [aux_sym_prefix_op_token1] = ACTIONS(3759),
    [aux_sym_infix_op_token1] = ACTIONS(3757),
    [aux_sym_infix_op_token2] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_COLON_EQ] = ACTIONS(3757),
    [anon_sym_DOLLAR] = ACTIONS(3759),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3759),
    [sym_int] = ACTIONS(3759),
    [sym_xint] = ACTIONS(3757),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3757),
    [sym__newline] = ACTIONS(3757),
    [sym__dedent] = ACTIONS(3757),
  },
  [2826] = {
    [sym_block_comment] = STATE(2826),
    [sym_compiler_directive_decl] = STATE(2826),
    [sym_fsi_directive_decl] = STATE(2826),
    [sym_preproc_line] = STATE(2826),
    [sym_identifier] = ACTIONS(3732),
    [anon_sym_EQ] = ACTIONS(3730),
    [anon_sym_COLON] = ACTIONS(3732),
    [anon_sym_return] = ACTIONS(3732),
    [anon_sym_do] = ACTIONS(3732),
    [anon_sym_let] = ACTIONS(3732),
    [anon_sym_let_BANG] = ACTIONS(3730),
    [anon_sym_LPAREN] = ACTIONS(3732),
    [anon_sym_COMMA] = ACTIONS(3730),
    [anon_sym_null] = ACTIONS(3732),
    [anon_sym_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_LBRACK] = ACTIONS(3732),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3730),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_LT_AT] = ACTIONS(3732),
    [anon_sym_LT_AT_AT] = ACTIONS(3732),
    [anon_sym_DOT] = ACTIONS(3732),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3730),
    [anon_sym_new] = ACTIONS(3732),
    [anon_sym_return_BANG] = ACTIONS(3730),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_yield_BANG] = ACTIONS(3730),
    [anon_sym_lazy] = ACTIONS(3732),
    [anon_sym_assert] = ACTIONS(3732),
    [anon_sym_upcast] = ACTIONS(3732),
    [anon_sym_downcast] = ACTIONS(3732),
    [anon_sym_COLON_GT] = ACTIONS(3730),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3730),
    [anon_sym_for] = ACTIONS(3732),
    [anon_sym_while] = ACTIONS(3732),
    [anon_sym_else] = ACTIONS(3732),
    [anon_sym_elif] = ACTIONS(3732),
    [anon_sym_if] = ACTIONS(3732),
    [anon_sym_fun] = ACTIONS(3732),
    [anon_sym_try] = ACTIONS(3732),
    [anon_sym_match] = ACTIONS(3732),
    [anon_sym_match_BANG] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3732),
    [anon_sym_LT_DASH] = ACTIONS(3732),
    [anon_sym_DOT_LBRACK] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3730),
    [anon_sym_use] = ACTIONS(3732),
    [anon_sym_use_BANG] = ACTIONS(3730),
    [anon_sym_do_BANG] = ACTIONS(3730),
    [anon_sym_DOT_DOT] = ACTIONS(3730),
    [anon_sym_begin] = ACTIONS(3732),
    [anon_sym_LPAREN2] = ACTIONS(3732),
    [anon_sym_or] = ACTIONS(3732),
    [aux_sym_char_token1] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3732),
    [anon_sym_DQUOTE] = ACTIONS(3732),
    [anon_sym_AT_DQUOTE] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [sym_bool] = ACTIONS(3732),
    [sym_unit] = ACTIONS(3730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3732),
    [sym_op_identifier] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PLUS_DOT] = ACTIONS(3732),
    [anon_sym_DASH_DOT] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3732),
    [anon_sym_AMP_AMP] = ACTIONS(3732),
    [anon_sym_TILDE] = ACTIONS(3730),
    [aux_sym_prefix_op_token1] = ACTIONS(3732),
    [aux_sym_infix_op_token1] = ACTIONS(3730),
    [aux_sym_infix_op_token2] = ACTIONS(3732),
    [anon_sym_PIPE_PIPE] = ACTIONS(3732),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_COLON_EQ] = ACTIONS(3730),
    [anon_sym_DOLLAR] = ACTIONS(3732),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3732),
    [sym_int] = ACTIONS(3732),
    [sym_xint] = ACTIONS(3730),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3730),
    [sym__newline] = ACTIONS(3730),
  },
  [2827] = {
    [sym_block_comment] = STATE(2827),
    [sym_compiler_directive_decl] = STATE(2827),
    [sym_fsi_directive_decl] = STATE(2827),
    [sym_preproc_line] = STATE(2827),
    [sym_identifier] = ACTIONS(3728),
    [anon_sym_EQ] = ACTIONS(3726),
    [anon_sym_COLON] = ACTIONS(3728),
    [anon_sym_return] = ACTIONS(3728),
    [anon_sym_do] = ACTIONS(3728),
    [anon_sym_let] = ACTIONS(3728),
    [anon_sym_let_BANG] = ACTIONS(3726),
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_COMMA] = ACTIONS(3726),
    [anon_sym_null] = ACTIONS(3728),
    [anon_sym_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(3726),
    [anon_sym_AMP] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3726),
    [anon_sym_LBRACE] = ACTIONS(3728),
    [anon_sym_LT_AT] = ACTIONS(3728),
    [anon_sym_AT_GT] = ACTIONS(3728),
    [anon_sym_LT_AT_AT] = ACTIONS(3728),
    [anon_sym_DOT] = ACTIONS(3728),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3726),
    [anon_sym_new] = ACTIONS(3728),
    [anon_sym_return_BANG] = ACTIONS(3726),
    [anon_sym_yield] = ACTIONS(3728),
    [anon_sym_yield_BANG] = ACTIONS(3726),
    [anon_sym_lazy] = ACTIONS(3728),
    [anon_sym_assert] = ACTIONS(3728),
    [anon_sym_upcast] = ACTIONS(3728),
    [anon_sym_downcast] = ACTIONS(3728),
    [anon_sym_COLON_GT] = ACTIONS(3726),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3726),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_fun] = ACTIONS(3728),
    [anon_sym_try] = ACTIONS(3728),
    [anon_sym_match] = ACTIONS(3728),
    [anon_sym_match_BANG] = ACTIONS(3726),
    [anon_sym_function] = ACTIONS(3728),
    [anon_sym_LT_DASH] = ACTIONS(3728),
    [anon_sym_DOT_LBRACK] = ACTIONS(3726),
    [anon_sym_LT] = ACTIONS(3726),
    [anon_sym_use] = ACTIONS(3728),
    [anon_sym_use_BANG] = ACTIONS(3726),
    [anon_sym_do_BANG] = ACTIONS(3726),
    [anon_sym_begin] = ACTIONS(3728),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [aux_sym_char_token1] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3728),
    [anon_sym_AT_DQUOTE] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [sym_bool] = ACTIONS(3728),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3728),
    [sym_op_identifier] = ACTIONS(3728),
    [anon_sym_PLUS] = ACTIONS(3728),
    [anon_sym_DASH] = ACTIONS(3728),
    [anon_sym_PLUS_DOT] = ACTIONS(3728),
    [anon_sym_DASH_DOT] = ACTIONS(3728),
    [anon_sym_PERCENT] = ACTIONS(3728),
    [anon_sym_AMP_AMP] = ACTIONS(3728),
    [anon_sym_TILDE] = ACTIONS(3726),
    [aux_sym_prefix_op_token1] = ACTIONS(3728),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token2] = ACTIONS(3728),
    [anon_sym_PIPE_PIPE] = ACTIONS(3728),
    [anon_sym_BANG_EQ] = ACTIONS(3728),
    [anon_sym_COLON_EQ] = ACTIONS(3726),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3728),
    [sym_int] = ACTIONS(3728),
    [sym_xint] = ACTIONS(3726),
    [anon_sym_f] = ACTIONS(3728),
    [aux_sym_decimal_token1] = ACTIONS(3728),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3726),
    [sym__newline] = ACTIONS(3726),
  },
  [2828] = {
    [sym_block_comment] = STATE(2828),
    [sym_compiler_directive_decl] = STATE(2828),
    [sym_fsi_directive_decl] = STATE(2828),
    [sym_preproc_line] = STATE(2828),
    [sym_identifier] = ACTIONS(3728),
    [anon_sym_EQ] = ACTIONS(3726),
    [anon_sym_COLON] = ACTIONS(3728),
    [anon_sym_return] = ACTIONS(3728),
    [anon_sym_do] = ACTIONS(3728),
    [anon_sym_let] = ACTIONS(3728),
    [anon_sym_let_BANG] = ACTIONS(3726),
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_COMMA] = ACTIONS(3726),
    [anon_sym_null] = ACTIONS(3728),
    [anon_sym_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(3726),
    [anon_sym_AMP] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3726),
    [anon_sym_LBRACE] = ACTIONS(3728),
    [anon_sym_LT_AT] = ACTIONS(3728),
    [anon_sym_LT_AT_AT] = ACTIONS(3728),
    [anon_sym_DOT] = ACTIONS(3728),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3726),
    [anon_sym_new] = ACTIONS(3728),
    [anon_sym_return_BANG] = ACTIONS(3726),
    [anon_sym_yield] = ACTIONS(3728),
    [anon_sym_yield_BANG] = ACTIONS(3726),
    [anon_sym_lazy] = ACTIONS(3728),
    [anon_sym_assert] = ACTIONS(3728),
    [anon_sym_upcast] = ACTIONS(3728),
    [anon_sym_downcast] = ACTIONS(3728),
    [anon_sym_COLON_GT] = ACTIONS(3726),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3726),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_fun] = ACTIONS(3728),
    [anon_sym_try] = ACTIONS(3728),
    [anon_sym_match] = ACTIONS(3728),
    [anon_sym_match_BANG] = ACTIONS(3726),
    [anon_sym_function] = ACTIONS(3728),
    [anon_sym_LT_DASH] = ACTIONS(3728),
    [anon_sym_DOT_LBRACK] = ACTIONS(3726),
    [anon_sym_LT] = ACTIONS(3726),
    [anon_sym_GT] = ACTIONS(3728),
    [anon_sym_use] = ACTIONS(3728),
    [anon_sym_use_BANG] = ACTIONS(3726),
    [anon_sym_do_BANG] = ACTIONS(3726),
    [anon_sym_begin] = ACTIONS(3728),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [aux_sym_char_token1] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3728),
    [anon_sym_AT_DQUOTE] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [sym_bool] = ACTIONS(3728),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3728),
    [sym_op_identifier] = ACTIONS(3728),
    [anon_sym_PLUS] = ACTIONS(3728),
    [anon_sym_DASH] = ACTIONS(3728),
    [anon_sym_PLUS_DOT] = ACTIONS(3728),
    [anon_sym_DASH_DOT] = ACTIONS(3728),
    [anon_sym_PERCENT] = ACTIONS(3728),
    [anon_sym_AMP_AMP] = ACTIONS(3728),
    [anon_sym_TILDE] = ACTIONS(3726),
    [aux_sym_prefix_op_token1] = ACTIONS(3728),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token2] = ACTIONS(3728),
    [anon_sym_PIPE_PIPE] = ACTIONS(3728),
    [anon_sym_BANG_EQ] = ACTIONS(3728),
    [anon_sym_COLON_EQ] = ACTIONS(3726),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3728),
    [sym_int] = ACTIONS(3728),
    [sym_xint] = ACTIONS(3726),
    [anon_sym_f] = ACTIONS(3728),
    [aux_sym_decimal_token1] = ACTIONS(3728),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3726),
    [sym__newline] = ACTIONS(3726),
  },
  [2829] = {
    [sym_block_comment] = STATE(2829),
    [sym_compiler_directive_decl] = STATE(2829),
    [sym_fsi_directive_decl] = STATE(2829),
    [sym_preproc_line] = STATE(2829),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(5393),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_DASH_GT] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_DOT_DOT] = ACTIONS(3683),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
  },
  [2830] = {
    [sym_block_comment] = STATE(2830),
    [sym_compiler_directive_decl] = STATE(2830),
    [sym_fsi_directive_decl] = STATE(2830),
    [sym_preproc_line] = STATE(2830),
    [aux_sym_rules_repeat1] = STATE(2830),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(5395),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_AT_GT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_or] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [sym__newline] = ACTIONS(5398),
  },
  [2831] = {
    [sym_block_comment] = STATE(2831),
    [sym_compiler_directive_decl] = STATE(2831),
    [sym_fsi_directive_decl] = STATE(2831),
    [sym_preproc_line] = STATE(2831),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_AT_AT_GT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
  },
  [2832] = {
    [sym_block_comment] = STATE(2832),
    [sym_compiler_directive_decl] = STATE(2832),
    [sym_fsi_directive_decl] = STATE(2832),
    [sym_preproc_line] = STATE(2832),
    [sym_identifier] = ACTIONS(4236),
    [anon_sym_EQ] = ACTIONS(4234),
    [anon_sym_COLON] = ACTIONS(4236),
    [anon_sym_return] = ACTIONS(4236),
    [anon_sym_do] = ACTIONS(4236),
    [anon_sym_let] = ACTIONS(4236),
    [anon_sym_let_BANG] = ACTIONS(4234),
    [anon_sym_as] = ACTIONS(4236),
    [anon_sym_LPAREN] = ACTIONS(4236),
    [anon_sym_COMMA] = ACTIONS(4234),
    [anon_sym_null] = ACTIONS(4236),
    [anon_sym_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_COLON] = ACTIONS(4234),
    [anon_sym_AMP] = ACTIONS(4236),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4234),
    [anon_sym_LBRACE] = ACTIONS(4236),
    [anon_sym_LT_AT] = ACTIONS(4236),
    [anon_sym_LT_AT_AT] = ACTIONS(4236),
    [anon_sym_DOT] = ACTIONS(4236),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4234),
    [anon_sym_new] = ACTIONS(4236),
    [anon_sym_with] = ACTIONS(4236),
    [anon_sym_return_BANG] = ACTIONS(4234),
    [anon_sym_yield] = ACTIONS(4236),
    [anon_sym_yield_BANG] = ACTIONS(4234),
    [anon_sym_lazy] = ACTIONS(4236),
    [anon_sym_assert] = ACTIONS(4236),
    [anon_sym_upcast] = ACTIONS(4236),
    [anon_sym_downcast] = ACTIONS(4236),
    [anon_sym_COLON_GT] = ACTIONS(4234),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4234),
    [anon_sym_for] = ACTIONS(4236),
    [anon_sym_while] = ACTIONS(4236),
    [anon_sym_if] = ACTIONS(4236),
    [anon_sym_fun] = ACTIONS(4236),
    [anon_sym_try] = ACTIONS(4236),
    [anon_sym_match] = ACTIONS(4236),
    [anon_sym_match_BANG] = ACTIONS(4234),
    [anon_sym_function] = ACTIONS(4236),
    [anon_sym_LT_DASH] = ACTIONS(4236),
    [anon_sym_DOT_LBRACK] = ACTIONS(4234),
    [anon_sym_LT] = ACTIONS(4234),
    [anon_sym_use] = ACTIONS(4236),
    [anon_sym_use_BANG] = ACTIONS(4234),
    [anon_sym_do_BANG] = ACTIONS(4234),
    [anon_sym_begin] = ACTIONS(4236),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_or] = ACTIONS(4236),
    [aux_sym_char_token1] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4236),
    [anon_sym_DQUOTE] = ACTIONS(4236),
    [anon_sym_AT_DQUOTE] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [sym_bool] = ACTIONS(4236),
    [sym_unit] = ACTIONS(4234),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4236),
    [sym_op_identifier] = ACTIONS(4236),
    [anon_sym_PLUS] = ACTIONS(4236),
    [anon_sym_DASH] = ACTIONS(4236),
    [anon_sym_PLUS_DOT] = ACTIONS(4236),
    [anon_sym_DASH_DOT] = ACTIONS(4236),
    [anon_sym_PERCENT] = ACTIONS(4236),
    [anon_sym_AMP_AMP] = ACTIONS(4236),
    [anon_sym_TILDE] = ACTIONS(4234),
    [aux_sym_prefix_op_token1] = ACTIONS(4236),
    [aux_sym_infix_op_token1] = ACTIONS(4234),
    [aux_sym_infix_op_token2] = ACTIONS(4236),
    [anon_sym_PIPE_PIPE] = ACTIONS(4236),
    [anon_sym_BANG_EQ] = ACTIONS(4236),
    [anon_sym_COLON_EQ] = ACTIONS(4234),
    [anon_sym_DOLLAR] = ACTIONS(4236),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4236),
    [sym_int] = ACTIONS(4236),
    [sym_xint] = ACTIONS(4234),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4234),
    [sym__newline] = ACTIONS(4234),
    [sym__dedent] = ACTIONS(4234),
  },
  [2833] = {
    [sym_block_comment] = STATE(2833),
    [sym_compiler_directive_decl] = STATE(2833),
    [sym_fsi_directive_decl] = STATE(2833),
    [sym_preproc_line] = STATE(2833),
    [sym_identifier] = ACTIONS(4100),
    [anon_sym_EQ] = ACTIONS(4098),
    [anon_sym_COLON] = ACTIONS(4100),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_do] = ACTIONS(4100),
    [anon_sym_let] = ACTIONS(4100),
    [anon_sym_let_BANG] = ACTIONS(4098),
    [anon_sym_as] = ACTIONS(4100),
    [anon_sym_LPAREN] = ACTIONS(4100),
    [anon_sym_COMMA] = ACTIONS(4098),
    [anon_sym_null] = ACTIONS(4100),
    [anon_sym_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_COLON] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4100),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4098),
    [anon_sym_LBRACE] = ACTIONS(4100),
    [anon_sym_LT_AT] = ACTIONS(4100),
    [anon_sym_LT_AT_AT] = ACTIONS(4100),
    [anon_sym_DOT] = ACTIONS(4100),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4098),
    [anon_sym_new] = ACTIONS(4100),
    [anon_sym_with] = ACTIONS(4100),
    [anon_sym_return_BANG] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4100),
    [anon_sym_yield_BANG] = ACTIONS(4098),
    [anon_sym_lazy] = ACTIONS(4100),
    [anon_sym_assert] = ACTIONS(4100),
    [anon_sym_upcast] = ACTIONS(4100),
    [anon_sym_downcast] = ACTIONS(4100),
    [anon_sym_COLON_GT] = ACTIONS(4098),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4098),
    [anon_sym_for] = ACTIONS(4100),
    [anon_sym_while] = ACTIONS(4100),
    [anon_sym_if] = ACTIONS(4100),
    [anon_sym_fun] = ACTIONS(4100),
    [anon_sym_try] = ACTIONS(4100),
    [anon_sym_match] = ACTIONS(4100),
    [anon_sym_match_BANG] = ACTIONS(4098),
    [anon_sym_function] = ACTIONS(4100),
    [anon_sym_LT_DASH] = ACTIONS(4100),
    [anon_sym_DOT_LBRACK] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(4098),
    [anon_sym_use] = ACTIONS(4100),
    [anon_sym_use_BANG] = ACTIONS(4098),
    [anon_sym_do_BANG] = ACTIONS(4098),
    [anon_sym_begin] = ACTIONS(4100),
    [anon_sym_LPAREN2] = ACTIONS(4100),
    [anon_sym_or] = ACTIONS(4100),
    [aux_sym_char_token1] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4100),
    [anon_sym_DQUOTE] = ACTIONS(4100),
    [anon_sym_AT_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [sym_bool] = ACTIONS(4100),
    [sym_unit] = ACTIONS(4098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4100),
    [sym_op_identifier] = ACTIONS(4100),
    [anon_sym_PLUS] = ACTIONS(4100),
    [anon_sym_DASH] = ACTIONS(4100),
    [anon_sym_PLUS_DOT] = ACTIONS(4100),
    [anon_sym_DASH_DOT] = ACTIONS(4100),
    [anon_sym_PERCENT] = ACTIONS(4100),
    [anon_sym_AMP_AMP] = ACTIONS(4100),
    [anon_sym_TILDE] = ACTIONS(4098),
    [aux_sym_prefix_op_token1] = ACTIONS(4100),
    [aux_sym_infix_op_token1] = ACTIONS(4098),
    [aux_sym_infix_op_token2] = ACTIONS(4100),
    [anon_sym_PIPE_PIPE] = ACTIONS(4100),
    [anon_sym_BANG_EQ] = ACTIONS(4100),
    [anon_sym_COLON_EQ] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4100),
    [sym_int] = ACTIONS(4100),
    [sym_xint] = ACTIONS(4098),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4098),
    [sym__newline] = ACTIONS(4098),
    [sym__dedent] = ACTIONS(4098),
  },
  [2834] = {
    [sym_block_comment] = STATE(2834),
    [sym_compiler_directive_decl] = STATE(2834),
    [sym_fsi_directive_decl] = STATE(2834),
    [sym_preproc_line] = STATE(2834),
    [sym_identifier] = ACTIONS(3889),
    [anon_sym_EQ] = ACTIONS(3887),
    [anon_sym_COLON] = ACTIONS(3889),
    [anon_sym_return] = ACTIONS(3889),
    [anon_sym_do] = ACTIONS(3889),
    [anon_sym_let] = ACTIONS(3889),
    [anon_sym_let_BANG] = ACTIONS(3887),
    [anon_sym_as] = ACTIONS(3889),
    [anon_sym_LPAREN] = ACTIONS(3889),
    [anon_sym_COMMA] = ACTIONS(3887),
    [anon_sym_null] = ACTIONS(3889),
    [anon_sym_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_COLON] = ACTIONS(3887),
    [anon_sym_AMP] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3887),
    [anon_sym_LBRACE] = ACTIONS(3889),
    [anon_sym_LT_AT] = ACTIONS(3889),
    [anon_sym_LT_AT_AT] = ACTIONS(3889),
    [anon_sym_DOT] = ACTIONS(3889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [anon_sym_new] = ACTIONS(3889),
    [anon_sym_with] = ACTIONS(3889),
    [anon_sym_return_BANG] = ACTIONS(3887),
    [anon_sym_yield] = ACTIONS(3889),
    [anon_sym_yield_BANG] = ACTIONS(3887),
    [anon_sym_lazy] = ACTIONS(3889),
    [anon_sym_assert] = ACTIONS(3889),
    [anon_sym_upcast] = ACTIONS(3889),
    [anon_sym_downcast] = ACTIONS(3889),
    [anon_sym_COLON_GT] = ACTIONS(3887),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3887),
    [anon_sym_for] = ACTIONS(3889),
    [anon_sym_while] = ACTIONS(3889),
    [anon_sym_if] = ACTIONS(3889),
    [anon_sym_fun] = ACTIONS(3889),
    [anon_sym_try] = ACTIONS(3889),
    [anon_sym_match] = ACTIONS(3889),
    [anon_sym_match_BANG] = ACTIONS(3887),
    [anon_sym_function] = ACTIONS(3889),
    [anon_sym_LT_DASH] = ACTIONS(3889),
    [anon_sym_DOT_LBRACK] = ACTIONS(3887),
    [anon_sym_LT] = ACTIONS(3887),
    [anon_sym_use] = ACTIONS(3889),
    [anon_sym_use_BANG] = ACTIONS(3887),
    [anon_sym_do_BANG] = ACTIONS(3887),
    [anon_sym_begin] = ACTIONS(3889),
    [anon_sym_LPAREN2] = ACTIONS(3889),
    [anon_sym_or] = ACTIONS(3889),
    [aux_sym_char_token1] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3889),
    [anon_sym_DQUOTE] = ACTIONS(3889),
    [anon_sym_AT_DQUOTE] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [sym_bool] = ACTIONS(3889),
    [sym_unit] = ACTIONS(3887),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3889),
    [sym_op_identifier] = ACTIONS(3889),
    [anon_sym_PLUS] = ACTIONS(3889),
    [anon_sym_DASH] = ACTIONS(3889),
    [anon_sym_PLUS_DOT] = ACTIONS(3889),
    [anon_sym_DASH_DOT] = ACTIONS(3889),
    [anon_sym_PERCENT] = ACTIONS(3889),
    [anon_sym_AMP_AMP] = ACTIONS(3889),
    [anon_sym_TILDE] = ACTIONS(3887),
    [aux_sym_prefix_op_token1] = ACTIONS(3889),
    [aux_sym_infix_op_token1] = ACTIONS(3887),
    [aux_sym_infix_op_token2] = ACTIONS(3889),
    [anon_sym_PIPE_PIPE] = ACTIONS(3889),
    [anon_sym_BANG_EQ] = ACTIONS(3889),
    [anon_sym_COLON_EQ] = ACTIONS(3887),
    [anon_sym_DOLLAR] = ACTIONS(3889),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3889),
    [sym_int] = ACTIONS(3889),
    [sym_xint] = ACTIONS(3887),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3887),
    [sym__newline] = ACTIONS(3887),
    [sym__dedent] = ACTIONS(3887),
  },
  [2835] = {
    [sym_block_comment] = STATE(2835),
    [sym_compiler_directive_decl] = STATE(2835),
    [sym_fsi_directive_decl] = STATE(2835),
    [sym_preproc_line] = STATE(2835),
    [aux_sym_sequential_expression_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_COLON] = ACTIONS(3759),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_let_BANG] = ACTIONS(3757),
    [anon_sym_LPAREN] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3757),
    [anon_sym_null] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3757),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_LT_AT] = ACTIONS(3759),
    [anon_sym_LT_AT_AT] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(3759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_with] = ACTIONS(3759),
    [anon_sym_return_BANG] = ACTIONS(3757),
    [anon_sym_yield] = ACTIONS(3759),
    [anon_sym_yield_BANG] = ACTIONS(3757),
    [anon_sym_lazy] = ACTIONS(3759),
    [anon_sym_assert] = ACTIONS(3759),
    [anon_sym_upcast] = ACTIONS(3759),
    [anon_sym_downcast] = ACTIONS(3759),
    [anon_sym_COLON_GT] = ACTIONS(3757),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3757),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_fun] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_match] = ACTIONS(3759),
    [anon_sym_match_BANG] = ACTIONS(3757),
    [anon_sym_function] = ACTIONS(3759),
    [anon_sym_LT_DASH] = ACTIONS(3759),
    [anon_sym_DOT_LBRACK] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_use] = ACTIONS(3759),
    [anon_sym_use_BANG] = ACTIONS(3757),
    [anon_sym_do_BANG] = ACTIONS(3757),
    [anon_sym_begin] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_or] = ACTIONS(3759),
    [aux_sym_char_token1] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3759),
    [anon_sym_DQUOTE] = ACTIONS(3759),
    [anon_sym_AT_DQUOTE] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [sym_bool] = ACTIONS(3759),
    [sym_unit] = ACTIONS(3757),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3759),
    [sym_op_identifier] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS_DOT] = ACTIONS(3759),
    [anon_sym_DASH_DOT] = ACTIONS(3759),
    [anon_sym_PERCENT] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_TILDE] = ACTIONS(3757),
    [aux_sym_prefix_op_token1] = ACTIONS(3759),
    [aux_sym_infix_op_token1] = ACTIONS(3757),
    [aux_sym_infix_op_token2] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_COLON_EQ] = ACTIONS(3757),
    [anon_sym_DOLLAR] = ACTIONS(3759),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3759),
    [sym_int] = ACTIONS(3759),
    [sym_xint] = ACTIONS(3757),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3757),
    [sym__newline] = ACTIONS(3757),
    [sym__dedent] = ACTIONS(3757),
  },
  [2836] = {
    [sym_block_comment] = STATE(2836),
    [sym_compiler_directive_decl] = STATE(2836),
    [sym_fsi_directive_decl] = STATE(2836),
    [sym_preproc_line] = STATE(2836),
    [sym_identifier] = ACTIONS(3732),
    [anon_sym_EQ] = ACTIONS(3730),
    [anon_sym_COLON] = ACTIONS(3732),
    [anon_sym_return] = ACTIONS(3732),
    [anon_sym_do] = ACTIONS(3732),
    [anon_sym_let] = ACTIONS(3732),
    [anon_sym_let_BANG] = ACTIONS(3730),
    [anon_sym_LPAREN] = ACTIONS(3732),
    [anon_sym_COMMA] = ACTIONS(3730),
    [anon_sym_null] = ACTIONS(3732),
    [anon_sym_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_LBRACK] = ACTIONS(3732),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3730),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_LT_AT] = ACTIONS(3732),
    [anon_sym_AT_GT] = ACTIONS(3732),
    [anon_sym_LT_AT_AT] = ACTIONS(3732),
    [anon_sym_DOT] = ACTIONS(3732),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3730),
    [anon_sym_new] = ACTIONS(3732),
    [anon_sym_return_BANG] = ACTIONS(3730),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_yield_BANG] = ACTIONS(3730),
    [anon_sym_lazy] = ACTIONS(3732),
    [anon_sym_assert] = ACTIONS(3732),
    [anon_sym_upcast] = ACTIONS(3732),
    [anon_sym_downcast] = ACTIONS(3732),
    [anon_sym_COLON_GT] = ACTIONS(3730),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3730),
    [anon_sym_for] = ACTIONS(3732),
    [anon_sym_while] = ACTIONS(3732),
    [anon_sym_else] = ACTIONS(3732),
    [anon_sym_elif] = ACTIONS(3732),
    [anon_sym_if] = ACTIONS(3732),
    [anon_sym_fun] = ACTIONS(3732),
    [anon_sym_try] = ACTIONS(3732),
    [anon_sym_match] = ACTIONS(3732),
    [anon_sym_match_BANG] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3732),
    [anon_sym_LT_DASH] = ACTIONS(3732),
    [anon_sym_DOT_LBRACK] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3730),
    [anon_sym_use] = ACTIONS(3732),
    [anon_sym_use_BANG] = ACTIONS(3730),
    [anon_sym_do_BANG] = ACTIONS(3730),
    [anon_sym_begin] = ACTIONS(3732),
    [anon_sym_LPAREN2] = ACTIONS(3732),
    [anon_sym_or] = ACTIONS(3732),
    [aux_sym_char_token1] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3732),
    [anon_sym_DQUOTE] = ACTIONS(3732),
    [anon_sym_AT_DQUOTE] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [sym_bool] = ACTIONS(3732),
    [sym_unit] = ACTIONS(3730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3732),
    [sym_op_identifier] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PLUS_DOT] = ACTIONS(3732),
    [anon_sym_DASH_DOT] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3732),
    [anon_sym_AMP_AMP] = ACTIONS(3732),
    [anon_sym_TILDE] = ACTIONS(3730),
    [aux_sym_prefix_op_token1] = ACTIONS(3732),
    [aux_sym_infix_op_token1] = ACTIONS(3730),
    [aux_sym_infix_op_token2] = ACTIONS(3732),
    [anon_sym_PIPE_PIPE] = ACTIONS(3732),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_COLON_EQ] = ACTIONS(3730),
    [anon_sym_DOLLAR] = ACTIONS(3732),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3732),
    [sym_int] = ACTIONS(3732),
    [sym_xint] = ACTIONS(3730),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3730),
    [sym__newline] = ACTIONS(3730),
  },
  [2837] = {
    [sym_block_comment] = STATE(2837),
    [sym_compiler_directive_decl] = STATE(2837),
    [sym_fsi_directive_decl] = STATE(2837),
    [sym_preproc_line] = STATE(2837),
    [aux_sym_rules_repeat1] = STATE(2830),
    [sym_identifier] = ACTIONS(3676),
    [anon_sym_EQ] = ACTIONS(3674),
    [anon_sym_COLON] = ACTIONS(3676),
    [anon_sym_return] = ACTIONS(3676),
    [anon_sym_do] = ACTIONS(3676),
    [anon_sym_let] = ACTIONS(3676),
    [anon_sym_let_BANG] = ACTIONS(3674),
    [anon_sym_LPAREN] = ACTIONS(3676),
    [anon_sym_COMMA] = ACTIONS(3674),
    [anon_sym_null] = ACTIONS(3676),
    [anon_sym_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_COLON] = ACTIONS(3674),
    [anon_sym_PIPE] = ACTIONS(5401),
    [anon_sym_AMP] = ACTIONS(3676),
    [anon_sym_LBRACK] = ACTIONS(3676),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3674),
    [anon_sym_LBRACE] = ACTIONS(3676),
    [anon_sym_LT_AT] = ACTIONS(3676),
    [anon_sym_AT_GT] = ACTIONS(3676),
    [anon_sym_LT_AT_AT] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3674),
    [anon_sym_new] = ACTIONS(3676),
    [anon_sym_return_BANG] = ACTIONS(3674),
    [anon_sym_yield] = ACTIONS(3676),
    [anon_sym_yield_BANG] = ACTIONS(3674),
    [anon_sym_lazy] = ACTIONS(3676),
    [anon_sym_assert] = ACTIONS(3676),
    [anon_sym_upcast] = ACTIONS(3676),
    [anon_sym_downcast] = ACTIONS(3676),
    [anon_sym_COLON_GT] = ACTIONS(3674),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3674),
    [anon_sym_for] = ACTIONS(3676),
    [anon_sym_while] = ACTIONS(3676),
    [anon_sym_if] = ACTIONS(3676),
    [anon_sym_fun] = ACTIONS(3676),
    [anon_sym_try] = ACTIONS(3676),
    [anon_sym_match] = ACTIONS(3676),
    [anon_sym_match_BANG] = ACTIONS(3674),
    [anon_sym_function] = ACTIONS(3676),
    [anon_sym_LT_DASH] = ACTIONS(3676),
    [anon_sym_DOT_LBRACK] = ACTIONS(3674),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_use] = ACTIONS(3676),
    [anon_sym_use_BANG] = ACTIONS(3674),
    [anon_sym_do_BANG] = ACTIONS(3674),
    [anon_sym_begin] = ACTIONS(3676),
    [anon_sym_LPAREN2] = ACTIONS(3676),
    [anon_sym_or] = ACTIONS(3676),
    [aux_sym_char_token1] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3676),
    [anon_sym_DQUOTE] = ACTIONS(3676),
    [anon_sym_AT_DQUOTE] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [sym_bool] = ACTIONS(3676),
    [sym_unit] = ACTIONS(3674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3676),
    [sym_op_identifier] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_PLUS_DOT] = ACTIONS(3676),
    [anon_sym_DASH_DOT] = ACTIONS(3676),
    [anon_sym_PERCENT] = ACTIONS(3676),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_TILDE] = ACTIONS(3674),
    [aux_sym_prefix_op_token1] = ACTIONS(3676),
    [aux_sym_infix_op_token1] = ACTIONS(3674),
    [aux_sym_infix_op_token2] = ACTIONS(3676),
    [anon_sym_PIPE_PIPE] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3676),
    [anon_sym_COLON_EQ] = ACTIONS(3674),
    [anon_sym_DOLLAR] = ACTIONS(3676),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3676),
    [sym_int] = ACTIONS(3676),
    [sym_xint] = ACTIONS(3674),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3674),
    [sym__newline] = ACTIONS(5403),
  },
  [2838] = {
    [sym_block_comment] = STATE(2838),
    [sym_compiler_directive_decl] = STATE(2838),
    [sym_fsi_directive_decl] = STATE(2838),
    [sym_preproc_line] = STATE(2838),
    [aux_sym_long_identifier_repeat1] = STATE(2838),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3487),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(5406),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_EQ2] = ACTIONS(3485),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [2839] = {
    [sym_block_comment] = STATE(2839),
    [sym_compiler_directive_decl] = STATE(2839),
    [sym_fsi_directive_decl] = STATE(2839),
    [sym_preproc_line] = STATE(2839),
    [sym_identifier] = ACTIONS(4186),
    [anon_sym_EQ] = ACTIONS(4184),
    [anon_sym_COLON] = ACTIONS(4186),
    [anon_sym_return] = ACTIONS(4186),
    [anon_sym_do] = ACTIONS(4186),
    [anon_sym_let] = ACTIONS(4186),
    [anon_sym_let_BANG] = ACTIONS(4184),
    [anon_sym_as] = ACTIONS(4186),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_COMMA] = ACTIONS(4184),
    [anon_sym_null] = ACTIONS(4186),
    [anon_sym_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_COLON] = ACTIONS(4184),
    [anon_sym_AMP] = ACTIONS(4186),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4184),
    [anon_sym_LBRACE] = ACTIONS(4186),
    [anon_sym_LT_AT] = ACTIONS(4186),
    [anon_sym_LT_AT_AT] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4186),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4184),
    [anon_sym_new] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4186),
    [anon_sym_return_BANG] = ACTIONS(4184),
    [anon_sym_yield] = ACTIONS(4186),
    [anon_sym_yield_BANG] = ACTIONS(4184),
    [anon_sym_lazy] = ACTIONS(4186),
    [anon_sym_assert] = ACTIONS(4186),
    [anon_sym_upcast] = ACTIONS(4186),
    [anon_sym_downcast] = ACTIONS(4186),
    [anon_sym_COLON_GT] = ACTIONS(4184),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4184),
    [anon_sym_for] = ACTIONS(4186),
    [anon_sym_while] = ACTIONS(4186),
    [anon_sym_if] = ACTIONS(4186),
    [anon_sym_fun] = ACTIONS(4186),
    [anon_sym_try] = ACTIONS(4186),
    [anon_sym_match] = ACTIONS(4186),
    [anon_sym_match_BANG] = ACTIONS(4184),
    [anon_sym_function] = ACTIONS(4186),
    [anon_sym_LT_DASH] = ACTIONS(4186),
    [anon_sym_DOT_LBRACK] = ACTIONS(4184),
    [anon_sym_LT] = ACTIONS(4184),
    [anon_sym_use] = ACTIONS(4186),
    [anon_sym_use_BANG] = ACTIONS(4184),
    [anon_sym_do_BANG] = ACTIONS(4184),
    [anon_sym_begin] = ACTIONS(4186),
    [anon_sym_LPAREN2] = ACTIONS(4186),
    [anon_sym_or] = ACTIONS(4186),
    [aux_sym_char_token1] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4186),
    [anon_sym_DQUOTE] = ACTIONS(4186),
    [anon_sym_AT_DQUOTE] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [sym_bool] = ACTIONS(4186),
    [sym_unit] = ACTIONS(4184),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4186),
    [sym_op_identifier] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4186),
    [anon_sym_DASH] = ACTIONS(4186),
    [anon_sym_PLUS_DOT] = ACTIONS(4186),
    [anon_sym_DASH_DOT] = ACTIONS(4186),
    [anon_sym_PERCENT] = ACTIONS(4186),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_TILDE] = ACTIONS(4184),
    [aux_sym_prefix_op_token1] = ACTIONS(4186),
    [aux_sym_infix_op_token1] = ACTIONS(4184),
    [aux_sym_infix_op_token2] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_COLON_EQ] = ACTIONS(4184),
    [anon_sym_DOLLAR] = ACTIONS(4186),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4186),
    [sym_int] = ACTIONS(4186),
    [sym_xint] = ACTIONS(4184),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4184),
    [sym__newline] = ACTIONS(4184),
    [sym__dedent] = ACTIONS(4184),
  },
  [2840] = {
    [sym_block_comment] = STATE(2840),
    [sym_compiler_directive_decl] = STATE(2840),
    [sym_fsi_directive_decl] = STATE(2840),
    [sym_preproc_line] = STATE(2840),
    [aux_sym_rules_repeat1] = STATE(2871),
    [sym_identifier] = ACTIONS(3736),
    [anon_sym_EQ] = ACTIONS(3734),
    [anon_sym_COLON] = ACTIONS(3736),
    [anon_sym_return] = ACTIONS(3736),
    [anon_sym_do] = ACTIONS(3736),
    [anon_sym_let] = ACTIONS(3736),
    [anon_sym_let_BANG] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3736),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_null] = ACTIONS(3736),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_COLON] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(5409),
    [anon_sym_AMP] = ACTIONS(3736),
    [anon_sym_LBRACK] = ACTIONS(3736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3734),
    [anon_sym_LBRACE] = ACTIONS(3736),
    [anon_sym_LT_AT] = ACTIONS(3736),
    [anon_sym_LT_AT_AT] = ACTIONS(3736),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3734),
    [anon_sym_new] = ACTIONS(3736),
    [anon_sym_return_BANG] = ACTIONS(3734),
    [anon_sym_yield] = ACTIONS(3736),
    [anon_sym_yield_BANG] = ACTIONS(3734),
    [anon_sym_lazy] = ACTIONS(3736),
    [anon_sym_assert] = ACTIONS(3736),
    [anon_sym_upcast] = ACTIONS(3736),
    [anon_sym_downcast] = ACTIONS(3736),
    [anon_sym_COLON_GT] = ACTIONS(3734),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3734),
    [anon_sym_for] = ACTIONS(3736),
    [anon_sym_while] = ACTIONS(3736),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_fun] = ACTIONS(3736),
    [anon_sym_try] = ACTIONS(3736),
    [anon_sym_match] = ACTIONS(3736),
    [anon_sym_match_BANG] = ACTIONS(3734),
    [anon_sym_function] = ACTIONS(3736),
    [anon_sym_LT_DASH] = ACTIONS(3736),
    [anon_sym_DOT_LBRACK] = ACTIONS(3734),
    [anon_sym_LT] = ACTIONS(3734),
    [anon_sym_GT] = ACTIONS(3736),
    [anon_sym_use] = ACTIONS(3736),
    [anon_sym_use_BANG] = ACTIONS(3734),
    [anon_sym_do_BANG] = ACTIONS(3734),
    [anon_sym_begin] = ACTIONS(3736),
    [anon_sym_LPAREN2] = ACTIONS(3736),
    [anon_sym_or] = ACTIONS(3736),
    [aux_sym_char_token1] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3736),
    [anon_sym_DQUOTE] = ACTIONS(3736),
    [anon_sym_AT_DQUOTE] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [sym_bool] = ACTIONS(3736),
    [sym_unit] = ACTIONS(3734),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3736),
    [sym_op_identifier] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS_DOT] = ACTIONS(3736),
    [anon_sym_DASH_DOT] = ACTIONS(3736),
    [anon_sym_PERCENT] = ACTIONS(3736),
    [anon_sym_AMP_AMP] = ACTIONS(3736),
    [anon_sym_TILDE] = ACTIONS(3734),
    [aux_sym_prefix_op_token1] = ACTIONS(3736),
    [aux_sym_infix_op_token1] = ACTIONS(3734),
    [aux_sym_infix_op_token2] = ACTIONS(3736),
    [anon_sym_PIPE_PIPE] = ACTIONS(3736),
    [anon_sym_BANG_EQ] = ACTIONS(3736),
    [anon_sym_COLON_EQ] = ACTIONS(3734),
    [anon_sym_DOLLAR] = ACTIONS(3736),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3736),
    [sym_int] = ACTIONS(3736),
    [sym_xint] = ACTIONS(3734),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3734),
    [sym__newline] = ACTIONS(5411),
  },
  [2841] = {
    [sym_block_comment] = STATE(2841),
    [sym_compiler_directive_decl] = STATE(2841),
    [sym_fsi_directive_decl] = STATE(2841),
    [sym_preproc_line] = STATE(2841),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_AT_GT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_else] = ACTIONS(3700),
    [anon_sym_elif] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [2842] = {
    [sym_block_comment] = STATE(2842),
    [sym_compiler_directive_decl] = STATE(2842),
    [sym_fsi_directive_decl] = STATE(2842),
    [sym_preproc_line] = STATE(2842),
    [sym_identifier] = ACTIONS(3753),
    [anon_sym_EQ] = ACTIONS(3751),
    [anon_sym_COLON] = ACTIONS(3753),
    [anon_sym_return] = ACTIONS(3753),
    [anon_sym_do] = ACTIONS(3753),
    [anon_sym_let] = ACTIONS(3753),
    [anon_sym_let_BANG] = ACTIONS(3751),
    [anon_sym_LPAREN] = ACTIONS(3753),
    [anon_sym_COMMA] = ACTIONS(3751),
    [anon_sym_null] = ACTIONS(3753),
    [anon_sym_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_COLON] = ACTIONS(3751),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3751),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_LT_AT] = ACTIONS(3753),
    [anon_sym_LT_AT_AT] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3753),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3751),
    [anon_sym_new] = ACTIONS(3753),
    [anon_sym_return_BANG] = ACTIONS(3751),
    [anon_sym_yield] = ACTIONS(3753),
    [anon_sym_yield_BANG] = ACTIONS(3751),
    [anon_sym_lazy] = ACTIONS(3753),
    [anon_sym_assert] = ACTIONS(3753),
    [anon_sym_upcast] = ACTIONS(3753),
    [anon_sym_downcast] = ACTIONS(3753),
    [anon_sym_COLON_GT] = ACTIONS(3751),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3751),
    [anon_sym_for] = ACTIONS(3753),
    [anon_sym_while] = ACTIONS(3753),
    [anon_sym_if] = ACTIONS(3753),
    [anon_sym_fun] = ACTIONS(3753),
    [anon_sym_try] = ACTIONS(3753),
    [anon_sym_match] = ACTIONS(3753),
    [anon_sym_match_BANG] = ACTIONS(3751),
    [anon_sym_function] = ACTIONS(3753),
    [anon_sym_LT_DASH] = ACTIONS(3753),
    [anon_sym_DOT_LBRACK] = ACTIONS(3751),
    [anon_sym_LT] = ACTIONS(3751),
    [anon_sym_use] = ACTIONS(3753),
    [anon_sym_use_BANG] = ACTIONS(3751),
    [anon_sym_do_BANG] = ACTIONS(3751),
    [anon_sym_DOT_DOT] = ACTIONS(3751),
    [anon_sym_begin] = ACTIONS(3753),
    [anon_sym_LPAREN2] = ACTIONS(3753),
    [anon_sym_or] = ACTIONS(3753),
    [aux_sym_char_token1] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3753),
    [anon_sym_AT_DQUOTE] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [sym_bool] = ACTIONS(3753),
    [sym_unit] = ACTIONS(3751),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3753),
    [sym_op_identifier] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PLUS_DOT] = ACTIONS(3753),
    [anon_sym_DASH_DOT] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3753),
    [anon_sym_AMP_AMP] = ACTIONS(3753),
    [anon_sym_TILDE] = ACTIONS(3751),
    [aux_sym_prefix_op_token1] = ACTIONS(3753),
    [aux_sym_infix_op_token1] = ACTIONS(3751),
    [aux_sym_infix_op_token2] = ACTIONS(3753),
    [anon_sym_PIPE_PIPE] = ACTIONS(3753),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_COLON_EQ] = ACTIONS(3751),
    [anon_sym_DOLLAR] = ACTIONS(3753),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3753),
    [sym_int] = ACTIONS(5414),
    [sym_xint] = ACTIONS(3751),
    [anon_sym_f] = ACTIONS(3753),
    [aux_sym_decimal_token1] = ACTIONS(3753),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3751),
    [sym__newline] = ACTIONS(3751),
  },
  [2843] = {
    [sym_block_comment] = STATE(2843),
    [sym_compiler_directive_decl] = STATE(2843),
    [sym_fsi_directive_decl] = STATE(2843),
    [sym_preproc_line] = STATE(2843),
    [aux_sym_sequential_expression_repeat1] = STATE(2843),
    [sym_identifier] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3765),
    [anon_sym_COLON] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_let_BANG] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(3767),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_null] = ACTIONS(3767),
    [anon_sym_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3765),
    [anon_sym_LBRACE] = ACTIONS(3767),
    [anon_sym_LT_AT] = ACTIONS(3767),
    [anon_sym_LT_AT_AT] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3765),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_return_BANG] = ACTIONS(3765),
    [anon_sym_yield] = ACTIONS(3767),
    [anon_sym_yield_BANG] = ACTIONS(3765),
    [anon_sym_lazy] = ACTIONS(3767),
    [anon_sym_assert] = ACTIONS(3767),
    [anon_sym_upcast] = ACTIONS(3767),
    [anon_sym_downcast] = ACTIONS(3767),
    [anon_sym_COLON_GT] = ACTIONS(3765),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3765),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_fun] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_match] = ACTIONS(3767),
    [anon_sym_match_BANG] = ACTIONS(3765),
    [anon_sym_function] = ACTIONS(3767),
    [anon_sym_LT_DASH] = ACTIONS(3767),
    [anon_sym_DOT_LBRACK] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(3765),
    [anon_sym_use] = ACTIONS(3767),
    [anon_sym_use_BANG] = ACTIONS(3765),
    [anon_sym_do_BANG] = ACTIONS(3765),
    [anon_sym_begin] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3767),
    [anon_sym_or] = ACTIONS(3767),
    [aux_sym_char_token1] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3767),
    [anon_sym_DQUOTE] = ACTIONS(3767),
    [anon_sym_AT_DQUOTE] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [sym_bool] = ACTIONS(3767),
    [sym_unit] = ACTIONS(3765),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3767),
    [sym_op_identifier] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_PLUS_DOT] = ACTIONS(3767),
    [anon_sym_DASH_DOT] = ACTIONS(3767),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_AMP_AMP] = ACTIONS(3767),
    [anon_sym_TILDE] = ACTIONS(3765),
    [aux_sym_prefix_op_token1] = ACTIONS(3767),
    [aux_sym_infix_op_token1] = ACTIONS(3765),
    [aux_sym_infix_op_token2] = ACTIONS(3767),
    [anon_sym_PIPE_PIPE] = ACTIONS(3767),
    [anon_sym_BANG_EQ] = ACTIONS(3767),
    [anon_sym_COLON_EQ] = ACTIONS(3765),
    [anon_sym_DOLLAR] = ACTIONS(3767),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3767),
    [sym_int] = ACTIONS(3767),
    [sym_xint] = ACTIONS(3765),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3765),
    [anon_sym_POUNDendif] = ACTIONS(3765),
    [anon_sym_POUNDelse] = ACTIONS(3765),
    [sym__newline] = ACTIONS(5416),
  },
  [2844] = {
    [sym_block_comment] = STATE(2844),
    [sym_compiler_directive_decl] = STATE(2844),
    [sym_fsi_directive_decl] = STATE(2844),
    [sym_preproc_line] = STATE(2844),
    [aux_sym_sequential_expression_repeat1] = STATE(2844),
    [sym_identifier] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3765),
    [anon_sym_COLON] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_let_BANG] = ACTIONS(3765),
    [anon_sym_as] = ACTIONS(3767),
    [anon_sym_LPAREN] = ACTIONS(3767),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_null] = ACTIONS(3767),
    [anon_sym_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3765),
    [anon_sym_LBRACE] = ACTIONS(3767),
    [anon_sym_LT_AT] = ACTIONS(3767),
    [anon_sym_LT_AT_AT] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3765),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_with] = ACTIONS(3767),
    [anon_sym_return_BANG] = ACTIONS(3765),
    [anon_sym_yield] = ACTIONS(3767),
    [anon_sym_yield_BANG] = ACTIONS(3765),
    [anon_sym_lazy] = ACTIONS(3767),
    [anon_sym_assert] = ACTIONS(3767),
    [anon_sym_upcast] = ACTIONS(3767),
    [anon_sym_downcast] = ACTIONS(3767),
    [anon_sym_COLON_GT] = ACTIONS(3765),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3765),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_fun] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_match] = ACTIONS(3767),
    [anon_sym_match_BANG] = ACTIONS(3765),
    [anon_sym_function] = ACTIONS(3767),
    [anon_sym_LT_DASH] = ACTIONS(3767),
    [anon_sym_DOT_LBRACK] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(3765),
    [anon_sym_use] = ACTIONS(3767),
    [anon_sym_use_BANG] = ACTIONS(3765),
    [anon_sym_do_BANG] = ACTIONS(3765),
    [anon_sym_begin] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3767),
    [anon_sym_or] = ACTIONS(3767),
    [aux_sym_char_token1] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3767),
    [anon_sym_DQUOTE] = ACTIONS(3767),
    [anon_sym_AT_DQUOTE] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [sym_bool] = ACTIONS(3767),
    [sym_unit] = ACTIONS(3765),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3767),
    [sym_op_identifier] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_PLUS_DOT] = ACTIONS(3767),
    [anon_sym_DASH_DOT] = ACTIONS(3767),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_AMP_AMP] = ACTIONS(3767),
    [anon_sym_TILDE] = ACTIONS(3765),
    [aux_sym_prefix_op_token1] = ACTIONS(3767),
    [aux_sym_infix_op_token1] = ACTIONS(3765),
    [aux_sym_infix_op_token2] = ACTIONS(3767),
    [anon_sym_PIPE_PIPE] = ACTIONS(3767),
    [anon_sym_BANG_EQ] = ACTIONS(3767),
    [anon_sym_COLON_EQ] = ACTIONS(3765),
    [anon_sym_DOLLAR] = ACTIONS(3767),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3767),
    [sym_int] = ACTIONS(3767),
    [sym_xint] = ACTIONS(3765),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3765),
    [sym__newline] = ACTIONS(5419),
  },
  [2845] = {
    [sym_block_comment] = STATE(2845),
    [sym_compiler_directive_decl] = STATE(2845),
    [sym_fsi_directive_decl] = STATE(2845),
    [sym_preproc_line] = STATE(2845),
    [aux_sym_long_identifier_repeat1] = STATE(2838),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3451),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(5422),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_or] = ACTIONS(3451),
    [anon_sym_EQ2] = ACTIONS(3449),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
  },
  [2846] = {
    [sym_block_comment] = STATE(2846),
    [sym_compiler_directive_decl] = STATE(2846),
    [sym_fsi_directive_decl] = STATE(2846),
    [sym_preproc_line] = STATE(2846),
    [aux_sym_sequential_expression_repeat1] = STATE(2844),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_COLON] = ACTIONS(3759),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_let_BANG] = ACTIONS(3757),
    [anon_sym_as] = ACTIONS(3759),
    [anon_sym_LPAREN] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3757),
    [anon_sym_null] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3757),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_LT_AT] = ACTIONS(3759),
    [anon_sym_LT_AT_AT] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(3759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_with] = ACTIONS(3759),
    [anon_sym_return_BANG] = ACTIONS(3757),
    [anon_sym_yield] = ACTIONS(3759),
    [anon_sym_yield_BANG] = ACTIONS(3757),
    [anon_sym_lazy] = ACTIONS(3759),
    [anon_sym_assert] = ACTIONS(3759),
    [anon_sym_upcast] = ACTIONS(3759),
    [anon_sym_downcast] = ACTIONS(3759),
    [anon_sym_COLON_GT] = ACTIONS(3757),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3757),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_fun] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_match] = ACTIONS(3759),
    [anon_sym_match_BANG] = ACTIONS(3757),
    [anon_sym_function] = ACTIONS(3759),
    [anon_sym_LT_DASH] = ACTIONS(3759),
    [anon_sym_DOT_LBRACK] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_use] = ACTIONS(3759),
    [anon_sym_use_BANG] = ACTIONS(3757),
    [anon_sym_do_BANG] = ACTIONS(3757),
    [anon_sym_begin] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_or] = ACTIONS(3759),
    [aux_sym_char_token1] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3759),
    [anon_sym_DQUOTE] = ACTIONS(3759),
    [anon_sym_AT_DQUOTE] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [sym_bool] = ACTIONS(3759),
    [sym_unit] = ACTIONS(3757),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3759),
    [sym_op_identifier] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS_DOT] = ACTIONS(3759),
    [anon_sym_DASH_DOT] = ACTIONS(3759),
    [anon_sym_PERCENT] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_TILDE] = ACTIONS(3757),
    [aux_sym_prefix_op_token1] = ACTIONS(3759),
    [aux_sym_infix_op_token1] = ACTIONS(3757),
    [aux_sym_infix_op_token2] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_COLON_EQ] = ACTIONS(3757),
    [anon_sym_DOLLAR] = ACTIONS(3759),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3759),
    [sym_int] = ACTIONS(3759),
    [sym_xint] = ACTIONS(3757),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3757),
    [sym__newline] = ACTIONS(3757),
  },
  [2847] = {
    [sym_block_comment] = STATE(2847),
    [sym_compiler_directive_decl] = STATE(2847),
    [sym_fsi_directive_decl] = STATE(2847),
    [sym_preproc_line] = STATE(2847),
    [sym_identifier] = ACTIONS(4220),
    [anon_sym_EQ] = ACTIONS(4218),
    [anon_sym_COLON] = ACTIONS(4220),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_do] = ACTIONS(4220),
    [anon_sym_let] = ACTIONS(4220),
    [anon_sym_let_BANG] = ACTIONS(4218),
    [anon_sym_as] = ACTIONS(4220),
    [anon_sym_LPAREN] = ACTIONS(4220),
    [anon_sym_COMMA] = ACTIONS(4218),
    [anon_sym_null] = ACTIONS(4220),
    [anon_sym_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_COLON] = ACTIONS(4218),
    [anon_sym_AMP] = ACTIONS(4220),
    [anon_sym_LBRACK] = ACTIONS(4220),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(4220),
    [anon_sym_LT_AT] = ACTIONS(4220),
    [anon_sym_LT_AT_AT] = ACTIONS(4220),
    [anon_sym_DOT] = ACTIONS(4220),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4218),
    [anon_sym_new] = ACTIONS(4220),
    [anon_sym_with] = ACTIONS(4220),
    [anon_sym_return_BANG] = ACTIONS(4218),
    [anon_sym_yield] = ACTIONS(4220),
    [anon_sym_yield_BANG] = ACTIONS(4218),
    [anon_sym_lazy] = ACTIONS(4220),
    [anon_sym_assert] = ACTIONS(4220),
    [anon_sym_upcast] = ACTIONS(4220),
    [anon_sym_downcast] = ACTIONS(4220),
    [anon_sym_COLON_GT] = ACTIONS(4218),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4218),
    [anon_sym_for] = ACTIONS(4220),
    [anon_sym_while] = ACTIONS(4220),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_fun] = ACTIONS(4220),
    [anon_sym_try] = ACTIONS(4220),
    [anon_sym_match] = ACTIONS(4220),
    [anon_sym_match_BANG] = ACTIONS(4218),
    [anon_sym_function] = ACTIONS(4220),
    [anon_sym_LT_DASH] = ACTIONS(4220),
    [anon_sym_DOT_LBRACK] = ACTIONS(4218),
    [anon_sym_LT] = ACTIONS(4218),
    [anon_sym_use] = ACTIONS(4220),
    [anon_sym_use_BANG] = ACTIONS(4218),
    [anon_sym_do_BANG] = ACTIONS(4218),
    [anon_sym_begin] = ACTIONS(4220),
    [anon_sym_LPAREN2] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(4220),
    [aux_sym_char_token1] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4220),
    [anon_sym_DQUOTE] = ACTIONS(4220),
    [anon_sym_AT_DQUOTE] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [sym_bool] = ACTIONS(4220),
    [sym_unit] = ACTIONS(4218),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4220),
    [sym_op_identifier] = ACTIONS(4220),
    [anon_sym_PLUS] = ACTIONS(4220),
    [anon_sym_DASH] = ACTIONS(4220),
    [anon_sym_PLUS_DOT] = ACTIONS(4220),
    [anon_sym_DASH_DOT] = ACTIONS(4220),
    [anon_sym_PERCENT] = ACTIONS(4220),
    [anon_sym_AMP_AMP] = ACTIONS(4220),
    [anon_sym_TILDE] = ACTIONS(4218),
    [aux_sym_prefix_op_token1] = ACTIONS(4220),
    [aux_sym_infix_op_token1] = ACTIONS(4218),
    [aux_sym_infix_op_token2] = ACTIONS(4220),
    [anon_sym_PIPE_PIPE] = ACTIONS(4220),
    [anon_sym_BANG_EQ] = ACTIONS(4220),
    [anon_sym_COLON_EQ] = ACTIONS(4218),
    [anon_sym_DOLLAR] = ACTIONS(4220),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4220),
    [sym_int] = ACTIONS(4220),
    [sym_xint] = ACTIONS(4218),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4218),
    [sym__newline] = ACTIONS(4218),
    [sym__dedent] = ACTIONS(4218),
  },
  [2848] = {
    [sym_block_comment] = STATE(2848),
    [sym_compiler_directive_decl] = STATE(2848),
    [sym_fsi_directive_decl] = STATE(2848),
    [sym_preproc_line] = STATE(2848),
    [sym_identifier] = ACTIONS(4216),
    [anon_sym_EQ] = ACTIONS(4214),
    [anon_sym_COLON] = ACTIONS(4216),
    [anon_sym_return] = ACTIONS(4216),
    [anon_sym_do] = ACTIONS(4216),
    [anon_sym_let] = ACTIONS(4216),
    [anon_sym_let_BANG] = ACTIONS(4214),
    [anon_sym_as] = ACTIONS(4216),
    [anon_sym_LPAREN] = ACTIONS(4216),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_null] = ACTIONS(4216),
    [anon_sym_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_COLON] = ACTIONS(4214),
    [anon_sym_AMP] = ACTIONS(4216),
    [anon_sym_LBRACK] = ACTIONS(4216),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4214),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_LT_AT] = ACTIONS(4216),
    [anon_sym_LT_AT_AT] = ACTIONS(4216),
    [anon_sym_DOT] = ACTIONS(4216),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4214),
    [anon_sym_new] = ACTIONS(4216),
    [anon_sym_with] = ACTIONS(4216),
    [anon_sym_return_BANG] = ACTIONS(4214),
    [anon_sym_yield] = ACTIONS(4216),
    [anon_sym_yield_BANG] = ACTIONS(4214),
    [anon_sym_lazy] = ACTIONS(4216),
    [anon_sym_assert] = ACTIONS(4216),
    [anon_sym_upcast] = ACTIONS(4216),
    [anon_sym_downcast] = ACTIONS(4216),
    [anon_sym_COLON_GT] = ACTIONS(4214),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4214),
    [anon_sym_for] = ACTIONS(4216),
    [anon_sym_while] = ACTIONS(4216),
    [anon_sym_if] = ACTIONS(4216),
    [anon_sym_fun] = ACTIONS(4216),
    [anon_sym_try] = ACTIONS(4216),
    [anon_sym_match] = ACTIONS(4216),
    [anon_sym_match_BANG] = ACTIONS(4214),
    [anon_sym_function] = ACTIONS(4216),
    [anon_sym_LT_DASH] = ACTIONS(4216),
    [anon_sym_DOT_LBRACK] = ACTIONS(4214),
    [anon_sym_LT] = ACTIONS(4214),
    [anon_sym_use] = ACTIONS(4216),
    [anon_sym_use_BANG] = ACTIONS(4214),
    [anon_sym_do_BANG] = ACTIONS(4214),
    [anon_sym_begin] = ACTIONS(4216),
    [anon_sym_LPAREN2] = ACTIONS(4216),
    [anon_sym_or] = ACTIONS(4216),
    [aux_sym_char_token1] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4216),
    [anon_sym_DQUOTE] = ACTIONS(4216),
    [anon_sym_AT_DQUOTE] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [sym_bool] = ACTIONS(4216),
    [sym_unit] = ACTIONS(4214),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4216),
    [sym_op_identifier] = ACTIONS(4216),
    [anon_sym_PLUS] = ACTIONS(4216),
    [anon_sym_DASH] = ACTIONS(4216),
    [anon_sym_PLUS_DOT] = ACTIONS(4216),
    [anon_sym_DASH_DOT] = ACTIONS(4216),
    [anon_sym_PERCENT] = ACTIONS(4216),
    [anon_sym_AMP_AMP] = ACTIONS(4216),
    [anon_sym_TILDE] = ACTIONS(4214),
    [aux_sym_prefix_op_token1] = ACTIONS(4216),
    [aux_sym_infix_op_token1] = ACTIONS(4214),
    [aux_sym_infix_op_token2] = ACTIONS(4216),
    [anon_sym_PIPE_PIPE] = ACTIONS(4216),
    [anon_sym_BANG_EQ] = ACTIONS(4216),
    [anon_sym_COLON_EQ] = ACTIONS(4214),
    [anon_sym_DOLLAR] = ACTIONS(4216),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4216),
    [sym_int] = ACTIONS(4216),
    [sym_xint] = ACTIONS(4214),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4214),
    [sym__newline] = ACTIONS(4214),
    [sym__dedent] = ACTIONS(4214),
  },
  [2849] = {
    [sym_block_comment] = STATE(2849),
    [sym_compiler_directive_decl] = STATE(2849),
    [sym_fsi_directive_decl] = STATE(2849),
    [sym_preproc_line] = STATE(2849),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_EQ] = ACTIONS(4199),
    [anon_sym_COLON] = ACTIONS(4201),
    [anon_sym_return] = ACTIONS(4201),
    [anon_sym_do] = ACTIONS(4201),
    [anon_sym_let] = ACTIONS(4201),
    [anon_sym_let_BANG] = ACTIONS(4199),
    [anon_sym_as] = ACTIONS(4201),
    [anon_sym_LPAREN] = ACTIONS(4201),
    [anon_sym_COMMA] = ACTIONS(4199),
    [anon_sym_null] = ACTIONS(4201),
    [anon_sym_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(4199),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_LBRACK] = ACTIONS(4201),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4199),
    [anon_sym_LBRACE] = ACTIONS(4201),
    [anon_sym_LT_AT] = ACTIONS(4201),
    [anon_sym_LT_AT_AT] = ACTIONS(4201),
    [anon_sym_DOT] = ACTIONS(4201),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4199),
    [anon_sym_new] = ACTIONS(4201),
    [anon_sym_with] = ACTIONS(4201),
    [anon_sym_return_BANG] = ACTIONS(4199),
    [anon_sym_yield] = ACTIONS(4201),
    [anon_sym_yield_BANG] = ACTIONS(4199),
    [anon_sym_lazy] = ACTIONS(4201),
    [anon_sym_assert] = ACTIONS(4201),
    [anon_sym_upcast] = ACTIONS(4201),
    [anon_sym_downcast] = ACTIONS(4201),
    [anon_sym_COLON_GT] = ACTIONS(4199),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4199),
    [anon_sym_for] = ACTIONS(4201),
    [anon_sym_while] = ACTIONS(4201),
    [anon_sym_if] = ACTIONS(4201),
    [anon_sym_fun] = ACTIONS(4201),
    [anon_sym_try] = ACTIONS(4201),
    [anon_sym_match] = ACTIONS(4201),
    [anon_sym_match_BANG] = ACTIONS(4199),
    [anon_sym_function] = ACTIONS(4201),
    [anon_sym_LT_DASH] = ACTIONS(4201),
    [anon_sym_DOT_LBRACK] = ACTIONS(4199),
    [anon_sym_LT] = ACTIONS(4199),
    [anon_sym_use] = ACTIONS(4201),
    [anon_sym_use_BANG] = ACTIONS(4199),
    [anon_sym_do_BANG] = ACTIONS(4199),
    [anon_sym_begin] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(4201),
    [anon_sym_or] = ACTIONS(4201),
    [aux_sym_char_token1] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4201),
    [anon_sym_DQUOTE] = ACTIONS(4201),
    [anon_sym_AT_DQUOTE] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [sym_bool] = ACTIONS(4201),
    [sym_unit] = ACTIONS(4199),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4201),
    [sym_op_identifier] = ACTIONS(4201),
    [anon_sym_PLUS] = ACTIONS(4201),
    [anon_sym_DASH] = ACTIONS(4201),
    [anon_sym_PLUS_DOT] = ACTIONS(4201),
    [anon_sym_DASH_DOT] = ACTIONS(4201),
    [anon_sym_PERCENT] = ACTIONS(4201),
    [anon_sym_AMP_AMP] = ACTIONS(4201),
    [anon_sym_TILDE] = ACTIONS(4199),
    [aux_sym_prefix_op_token1] = ACTIONS(4201),
    [aux_sym_infix_op_token1] = ACTIONS(4199),
    [aux_sym_infix_op_token2] = ACTIONS(4201),
    [anon_sym_PIPE_PIPE] = ACTIONS(4201),
    [anon_sym_BANG_EQ] = ACTIONS(4201),
    [anon_sym_COLON_EQ] = ACTIONS(4199),
    [anon_sym_DOLLAR] = ACTIONS(4201),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4201),
    [sym_int] = ACTIONS(4201),
    [sym_xint] = ACTIONS(4199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4199),
    [sym__newline] = ACTIONS(4199),
    [sym__dedent] = ACTIONS(4199),
  },
  [2850] = {
    [sym_block_comment] = STATE(2850),
    [sym_compiler_directive_decl] = STATE(2850),
    [sym_fsi_directive_decl] = STATE(2850),
    [sym_preproc_line] = STATE(2850),
    [sym_identifier] = ACTIONS(4208),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_COLON] = ACTIONS(4208),
    [anon_sym_return] = ACTIONS(4208),
    [anon_sym_do] = ACTIONS(4208),
    [anon_sym_let] = ACTIONS(4208),
    [anon_sym_let_BANG] = ACTIONS(4206),
    [anon_sym_as] = ACTIONS(4208),
    [anon_sym_LPAREN] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(4206),
    [anon_sym_null] = ACTIONS(4208),
    [anon_sym_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_COLON] = ACTIONS(4206),
    [anon_sym_AMP] = ACTIONS(4208),
    [anon_sym_LBRACK] = ACTIONS(4208),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4206),
    [anon_sym_LBRACE] = ACTIONS(4208),
    [anon_sym_LT_AT] = ACTIONS(4208),
    [anon_sym_LT_AT_AT] = ACTIONS(4208),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4206),
    [anon_sym_new] = ACTIONS(4208),
    [anon_sym_with] = ACTIONS(4208),
    [anon_sym_return_BANG] = ACTIONS(4206),
    [anon_sym_yield] = ACTIONS(4208),
    [anon_sym_yield_BANG] = ACTIONS(4206),
    [anon_sym_lazy] = ACTIONS(4208),
    [anon_sym_assert] = ACTIONS(4208),
    [anon_sym_upcast] = ACTIONS(4208),
    [anon_sym_downcast] = ACTIONS(4208),
    [anon_sym_COLON_GT] = ACTIONS(4206),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4206),
    [anon_sym_for] = ACTIONS(4208),
    [anon_sym_while] = ACTIONS(4208),
    [anon_sym_if] = ACTIONS(4208),
    [anon_sym_fun] = ACTIONS(4208),
    [anon_sym_try] = ACTIONS(4208),
    [anon_sym_match] = ACTIONS(4208),
    [anon_sym_match_BANG] = ACTIONS(4206),
    [anon_sym_function] = ACTIONS(4208),
    [anon_sym_LT_DASH] = ACTIONS(4208),
    [anon_sym_DOT_LBRACK] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(4206),
    [anon_sym_use] = ACTIONS(4208),
    [anon_sym_use_BANG] = ACTIONS(4206),
    [anon_sym_do_BANG] = ACTIONS(4206),
    [anon_sym_begin] = ACTIONS(4208),
    [anon_sym_LPAREN2] = ACTIONS(4208),
    [anon_sym_or] = ACTIONS(4208),
    [aux_sym_char_token1] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4208),
    [anon_sym_DQUOTE] = ACTIONS(4208),
    [anon_sym_AT_DQUOTE] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [sym_bool] = ACTIONS(4208),
    [sym_unit] = ACTIONS(4206),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4208),
    [sym_op_identifier] = ACTIONS(4208),
    [anon_sym_PLUS] = ACTIONS(4208),
    [anon_sym_DASH] = ACTIONS(4208),
    [anon_sym_PLUS_DOT] = ACTIONS(4208),
    [anon_sym_DASH_DOT] = ACTIONS(4208),
    [anon_sym_PERCENT] = ACTIONS(4208),
    [anon_sym_AMP_AMP] = ACTIONS(4208),
    [anon_sym_TILDE] = ACTIONS(4206),
    [aux_sym_prefix_op_token1] = ACTIONS(4208),
    [aux_sym_infix_op_token1] = ACTIONS(4206),
    [aux_sym_infix_op_token2] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(4208),
    [anon_sym_BANG_EQ] = ACTIONS(4208),
    [anon_sym_COLON_EQ] = ACTIONS(4206),
    [anon_sym_DOLLAR] = ACTIONS(4208),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4208),
    [sym_int] = ACTIONS(4208),
    [sym_xint] = ACTIONS(4206),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4206),
    [sym__newline] = ACTIONS(4206),
    [sym__dedent] = ACTIONS(4206),
  },
  [2851] = {
    [sym_block_comment] = STATE(2851),
    [sym_compiler_directive_decl] = STATE(2851),
    [sym_fsi_directive_decl] = STATE(2851),
    [sym_preproc_line] = STATE(2851),
    [sym_identifier] = ACTIONS(4212),
    [anon_sym_EQ] = ACTIONS(4210),
    [anon_sym_COLON] = ACTIONS(4212),
    [anon_sym_return] = ACTIONS(4212),
    [anon_sym_do] = ACTIONS(4212),
    [anon_sym_let] = ACTIONS(4212),
    [anon_sym_let_BANG] = ACTIONS(4210),
    [anon_sym_as] = ACTIONS(4212),
    [anon_sym_LPAREN] = ACTIONS(4212),
    [anon_sym_COMMA] = ACTIONS(4210),
    [anon_sym_null] = ACTIONS(4212),
    [anon_sym_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_COLON] = ACTIONS(4210),
    [anon_sym_AMP] = ACTIONS(4212),
    [anon_sym_LBRACK] = ACTIONS(4212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4210),
    [anon_sym_LBRACE] = ACTIONS(4212),
    [anon_sym_LT_AT] = ACTIONS(4212),
    [anon_sym_LT_AT_AT] = ACTIONS(4212),
    [anon_sym_DOT] = ACTIONS(4212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4210),
    [anon_sym_new] = ACTIONS(4212),
    [anon_sym_with] = ACTIONS(4212),
    [anon_sym_return_BANG] = ACTIONS(4210),
    [anon_sym_yield] = ACTIONS(4212),
    [anon_sym_yield_BANG] = ACTIONS(4210),
    [anon_sym_lazy] = ACTIONS(4212),
    [anon_sym_assert] = ACTIONS(4212),
    [anon_sym_upcast] = ACTIONS(4212),
    [anon_sym_downcast] = ACTIONS(4212),
    [anon_sym_COLON_GT] = ACTIONS(4210),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4210),
    [anon_sym_for] = ACTIONS(4212),
    [anon_sym_while] = ACTIONS(4212),
    [anon_sym_if] = ACTIONS(4212),
    [anon_sym_fun] = ACTIONS(4212),
    [anon_sym_try] = ACTIONS(4212),
    [anon_sym_match] = ACTIONS(4212),
    [anon_sym_match_BANG] = ACTIONS(4210),
    [anon_sym_function] = ACTIONS(4212),
    [anon_sym_LT_DASH] = ACTIONS(4212),
    [anon_sym_DOT_LBRACK] = ACTIONS(4210),
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_use] = ACTIONS(4212),
    [anon_sym_use_BANG] = ACTIONS(4210),
    [anon_sym_do_BANG] = ACTIONS(4210),
    [anon_sym_begin] = ACTIONS(4212),
    [anon_sym_LPAREN2] = ACTIONS(4212),
    [anon_sym_or] = ACTIONS(4212),
    [aux_sym_char_token1] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4212),
    [anon_sym_DQUOTE] = ACTIONS(4212),
    [anon_sym_AT_DQUOTE] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [sym_bool] = ACTIONS(4212),
    [sym_unit] = ACTIONS(4210),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4212),
    [anon_sym_DASH] = ACTIONS(4212),
    [anon_sym_PLUS_DOT] = ACTIONS(4212),
    [anon_sym_DASH_DOT] = ACTIONS(4212),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_AMP_AMP] = ACTIONS(4212),
    [anon_sym_TILDE] = ACTIONS(4210),
    [aux_sym_prefix_op_token1] = ACTIONS(4212),
    [aux_sym_infix_op_token1] = ACTIONS(4210),
    [aux_sym_infix_op_token2] = ACTIONS(4212),
    [anon_sym_PIPE_PIPE] = ACTIONS(4212),
    [anon_sym_BANG_EQ] = ACTIONS(4212),
    [anon_sym_COLON_EQ] = ACTIONS(4210),
    [anon_sym_DOLLAR] = ACTIONS(4212),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4212),
    [sym_int] = ACTIONS(4212),
    [sym_xint] = ACTIONS(4210),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4210),
    [sym__newline] = ACTIONS(4210),
    [sym__dedent] = ACTIONS(4210),
  },
  [2852] = {
    [sym_block_comment] = STATE(2852),
    [sym_compiler_directive_decl] = STATE(2852),
    [sym_fsi_directive_decl] = STATE(2852),
    [sym_preproc_line] = STATE(2852),
    [sym_identifier] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3774),
    [anon_sym_do] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3774),
    [anon_sym_let_BANG] = ACTIONS(3772),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3772),
    [anon_sym_null] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_COLON] = ACTIONS(3772),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_LT_AT] = ACTIONS(3774),
    [anon_sym_LT_AT_AT] = ACTIONS(3774),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3772),
    [anon_sym_new] = ACTIONS(3774),
    [anon_sym_return_BANG] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3774),
    [anon_sym_yield_BANG] = ACTIONS(3772),
    [anon_sym_lazy] = ACTIONS(3774),
    [anon_sym_assert] = ACTIONS(3774),
    [anon_sym_upcast] = ACTIONS(3774),
    [anon_sym_downcast] = ACTIONS(3774),
    [anon_sym_COLON_GT] = ACTIONS(3772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3774),
    [anon_sym_done] = ACTIONS(5424),
    [anon_sym_while] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3774),
    [anon_sym_fun] = ACTIONS(3774),
    [anon_sym_DASH_GT] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3774),
    [anon_sym_match] = ACTIONS(3774),
    [anon_sym_match_BANG] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3774),
    [anon_sym_LT_DASH] = ACTIONS(3774),
    [anon_sym_DOT_LBRACK] = ACTIONS(3772),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_use] = ACTIONS(3774),
    [anon_sym_use_BANG] = ACTIONS(3772),
    [anon_sym_do_BANG] = ACTIONS(3772),
    [anon_sym_DOT_DOT] = ACTIONS(3772),
    [anon_sym_begin] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3774),
    [anon_sym_or] = ACTIONS(3774),
    [aux_sym_char_token1] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_AT_DQUOTE] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [sym_bool] = ACTIONS(3774),
    [sym_unit] = ACTIONS(3772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3774),
    [sym_op_identifier] = ACTIONS(3774),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_DOT] = ACTIONS(3774),
    [anon_sym_DASH_DOT] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3772),
    [aux_sym_prefix_op_token1] = ACTIONS(3774),
    [aux_sym_infix_op_token1] = ACTIONS(3772),
    [aux_sym_infix_op_token2] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3774),
    [anon_sym_COLON_EQ] = ACTIONS(3772),
    [anon_sym_DOLLAR] = ACTIONS(3774),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3774),
    [sym_int] = ACTIONS(3774),
    [sym_xint] = ACTIONS(3772),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3772),
    [sym__newline] = ACTIONS(3772),
  },
  [2853] = {
    [sym_block_comment] = STATE(2853),
    [sym_compiler_directive_decl] = STATE(2853),
    [sym_fsi_directive_decl] = STATE(2853),
    [sym_preproc_line] = STATE(2853),
    [sym_identifier] = ACTIONS(4197),
    [anon_sym_EQ] = ACTIONS(4195),
    [anon_sym_COLON] = ACTIONS(4197),
    [anon_sym_return] = ACTIONS(4197),
    [anon_sym_do] = ACTIONS(4197),
    [anon_sym_let] = ACTIONS(4197),
    [anon_sym_let_BANG] = ACTIONS(4195),
    [anon_sym_as] = ACTIONS(4197),
    [anon_sym_LPAREN] = ACTIONS(4197),
    [anon_sym_COMMA] = ACTIONS(4195),
    [anon_sym_null] = ACTIONS(4197),
    [anon_sym_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_COLON] = ACTIONS(4195),
    [anon_sym_AMP] = ACTIONS(4197),
    [anon_sym_LBRACK] = ACTIONS(4197),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4195),
    [anon_sym_LBRACE] = ACTIONS(4197),
    [anon_sym_LT_AT] = ACTIONS(4197),
    [anon_sym_LT_AT_AT] = ACTIONS(4197),
    [anon_sym_DOT] = ACTIONS(4197),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4195),
    [anon_sym_new] = ACTIONS(4197),
    [anon_sym_with] = ACTIONS(4197),
    [anon_sym_return_BANG] = ACTIONS(4195),
    [anon_sym_yield] = ACTIONS(4197),
    [anon_sym_yield_BANG] = ACTIONS(4195),
    [anon_sym_lazy] = ACTIONS(4197),
    [anon_sym_assert] = ACTIONS(4197),
    [anon_sym_upcast] = ACTIONS(4197),
    [anon_sym_downcast] = ACTIONS(4197),
    [anon_sym_COLON_GT] = ACTIONS(4195),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4195),
    [anon_sym_for] = ACTIONS(4197),
    [anon_sym_while] = ACTIONS(4197),
    [anon_sym_if] = ACTIONS(4197),
    [anon_sym_fun] = ACTIONS(4197),
    [anon_sym_try] = ACTIONS(4197),
    [anon_sym_match] = ACTIONS(4197),
    [anon_sym_match_BANG] = ACTIONS(4195),
    [anon_sym_function] = ACTIONS(4197),
    [anon_sym_LT_DASH] = ACTIONS(4197),
    [anon_sym_DOT_LBRACK] = ACTIONS(4195),
    [anon_sym_LT] = ACTIONS(4195),
    [anon_sym_use] = ACTIONS(4197),
    [anon_sym_use_BANG] = ACTIONS(4195),
    [anon_sym_do_BANG] = ACTIONS(4195),
    [anon_sym_begin] = ACTIONS(4197),
    [anon_sym_LPAREN2] = ACTIONS(4197),
    [anon_sym_or] = ACTIONS(4197),
    [aux_sym_char_token1] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4197),
    [anon_sym_DQUOTE] = ACTIONS(4197),
    [anon_sym_AT_DQUOTE] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [sym_bool] = ACTIONS(4197),
    [sym_unit] = ACTIONS(4195),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4197),
    [sym_op_identifier] = ACTIONS(4197),
    [anon_sym_PLUS] = ACTIONS(4197),
    [anon_sym_DASH] = ACTIONS(4197),
    [anon_sym_PLUS_DOT] = ACTIONS(4197),
    [anon_sym_DASH_DOT] = ACTIONS(4197),
    [anon_sym_PERCENT] = ACTIONS(4197),
    [anon_sym_AMP_AMP] = ACTIONS(4197),
    [anon_sym_TILDE] = ACTIONS(4195),
    [aux_sym_prefix_op_token1] = ACTIONS(4197),
    [aux_sym_infix_op_token1] = ACTIONS(4195),
    [aux_sym_infix_op_token2] = ACTIONS(4197),
    [anon_sym_PIPE_PIPE] = ACTIONS(4197),
    [anon_sym_BANG_EQ] = ACTIONS(4197),
    [anon_sym_COLON_EQ] = ACTIONS(4195),
    [anon_sym_DOLLAR] = ACTIONS(4197),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4197),
    [sym_int] = ACTIONS(4197),
    [sym_xint] = ACTIONS(4195),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4195),
    [sym__newline] = ACTIONS(4195),
    [sym__dedent] = ACTIONS(4195),
  },
  [2854] = {
    [sym_block_comment] = STATE(2854),
    [sym_compiler_directive_decl] = STATE(2854),
    [sym_fsi_directive_decl] = STATE(2854),
    [sym_preproc_line] = STATE(2854),
    [sym_identifier] = ACTIONS(4193),
    [anon_sym_EQ] = ACTIONS(4191),
    [anon_sym_COLON] = ACTIONS(4193),
    [anon_sym_return] = ACTIONS(4193),
    [anon_sym_do] = ACTIONS(4193),
    [anon_sym_let] = ACTIONS(4193),
    [anon_sym_let_BANG] = ACTIONS(4191),
    [anon_sym_as] = ACTIONS(4193),
    [anon_sym_LPAREN] = ACTIONS(4193),
    [anon_sym_COMMA] = ACTIONS(4191),
    [anon_sym_null] = ACTIONS(4193),
    [anon_sym_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_COLON] = ACTIONS(4191),
    [anon_sym_AMP] = ACTIONS(4193),
    [anon_sym_LBRACK] = ACTIONS(4193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4191),
    [anon_sym_LBRACE] = ACTIONS(4193),
    [anon_sym_LT_AT] = ACTIONS(4193),
    [anon_sym_LT_AT_AT] = ACTIONS(4193),
    [anon_sym_DOT] = ACTIONS(4193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4191),
    [anon_sym_new] = ACTIONS(4193),
    [anon_sym_with] = ACTIONS(4193),
    [anon_sym_return_BANG] = ACTIONS(4191),
    [anon_sym_yield] = ACTIONS(4193),
    [anon_sym_yield_BANG] = ACTIONS(4191),
    [anon_sym_lazy] = ACTIONS(4193),
    [anon_sym_assert] = ACTIONS(4193),
    [anon_sym_upcast] = ACTIONS(4193),
    [anon_sym_downcast] = ACTIONS(4193),
    [anon_sym_COLON_GT] = ACTIONS(4191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4191),
    [anon_sym_for] = ACTIONS(4193),
    [anon_sym_while] = ACTIONS(4193),
    [anon_sym_if] = ACTIONS(4193),
    [anon_sym_fun] = ACTIONS(4193),
    [anon_sym_try] = ACTIONS(4193),
    [anon_sym_match] = ACTIONS(4193),
    [anon_sym_match_BANG] = ACTIONS(4191),
    [anon_sym_function] = ACTIONS(4193),
    [anon_sym_LT_DASH] = ACTIONS(4193),
    [anon_sym_DOT_LBRACK] = ACTIONS(4191),
    [anon_sym_LT] = ACTIONS(4191),
    [anon_sym_use] = ACTIONS(4193),
    [anon_sym_use_BANG] = ACTIONS(4191),
    [anon_sym_do_BANG] = ACTIONS(4191),
    [anon_sym_begin] = ACTIONS(4193),
    [anon_sym_LPAREN2] = ACTIONS(4193),
    [anon_sym_or] = ACTIONS(4193),
    [aux_sym_char_token1] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4193),
    [anon_sym_DQUOTE] = ACTIONS(4193),
    [anon_sym_AT_DQUOTE] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [sym_bool] = ACTIONS(4193),
    [sym_unit] = ACTIONS(4191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4193),
    [sym_op_identifier] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4193),
    [anon_sym_DASH] = ACTIONS(4193),
    [anon_sym_PLUS_DOT] = ACTIONS(4193),
    [anon_sym_DASH_DOT] = ACTIONS(4193),
    [anon_sym_PERCENT] = ACTIONS(4193),
    [anon_sym_AMP_AMP] = ACTIONS(4193),
    [anon_sym_TILDE] = ACTIONS(4191),
    [aux_sym_prefix_op_token1] = ACTIONS(4193),
    [aux_sym_infix_op_token1] = ACTIONS(4191),
    [aux_sym_infix_op_token2] = ACTIONS(4193),
    [anon_sym_PIPE_PIPE] = ACTIONS(4193),
    [anon_sym_BANG_EQ] = ACTIONS(4193),
    [anon_sym_COLON_EQ] = ACTIONS(4191),
    [anon_sym_DOLLAR] = ACTIONS(4193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4193),
    [sym_int] = ACTIONS(4193),
    [sym_xint] = ACTIONS(4191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4191),
    [sym__newline] = ACTIONS(4191),
    [sym__dedent] = ACTIONS(4191),
  },
  [2855] = {
    [sym_block_comment] = STATE(2855),
    [sym_compiler_directive_decl] = STATE(2855),
    [sym_fsi_directive_decl] = STATE(2855),
    [sym_preproc_line] = STATE(2855),
    [sym_identifier] = ACTIONS(4224),
    [anon_sym_EQ] = ACTIONS(4222),
    [anon_sym_COLON] = ACTIONS(4224),
    [anon_sym_return] = ACTIONS(4224),
    [anon_sym_do] = ACTIONS(4224),
    [anon_sym_let] = ACTIONS(4224),
    [anon_sym_let_BANG] = ACTIONS(4222),
    [anon_sym_as] = ACTIONS(4224),
    [anon_sym_LPAREN] = ACTIONS(4224),
    [anon_sym_COMMA] = ACTIONS(4222),
    [anon_sym_null] = ACTIONS(4224),
    [anon_sym_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_COLON] = ACTIONS(4222),
    [anon_sym_AMP] = ACTIONS(4224),
    [anon_sym_LBRACK] = ACTIONS(4224),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4222),
    [anon_sym_LBRACE] = ACTIONS(4224),
    [anon_sym_LT_AT] = ACTIONS(4224),
    [anon_sym_LT_AT_AT] = ACTIONS(4224),
    [anon_sym_DOT] = ACTIONS(4224),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4222),
    [anon_sym_new] = ACTIONS(4224),
    [anon_sym_with] = ACTIONS(4224),
    [anon_sym_return_BANG] = ACTIONS(4222),
    [anon_sym_yield] = ACTIONS(4224),
    [anon_sym_yield_BANG] = ACTIONS(4222),
    [anon_sym_lazy] = ACTIONS(4224),
    [anon_sym_assert] = ACTIONS(4224),
    [anon_sym_upcast] = ACTIONS(4224),
    [anon_sym_downcast] = ACTIONS(4224),
    [anon_sym_COLON_GT] = ACTIONS(4222),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4222),
    [anon_sym_for] = ACTIONS(4224),
    [anon_sym_while] = ACTIONS(4224),
    [anon_sym_if] = ACTIONS(4224),
    [anon_sym_fun] = ACTIONS(4224),
    [anon_sym_try] = ACTIONS(4224),
    [anon_sym_match] = ACTIONS(4224),
    [anon_sym_match_BANG] = ACTIONS(4222),
    [anon_sym_function] = ACTIONS(4224),
    [anon_sym_LT_DASH] = ACTIONS(4224),
    [anon_sym_DOT_LBRACK] = ACTIONS(4222),
    [anon_sym_LT] = ACTIONS(4222),
    [anon_sym_use] = ACTIONS(4224),
    [anon_sym_use_BANG] = ACTIONS(4222),
    [anon_sym_do_BANG] = ACTIONS(4222),
    [anon_sym_begin] = ACTIONS(4224),
    [anon_sym_LPAREN2] = ACTIONS(4224),
    [anon_sym_or] = ACTIONS(4224),
    [aux_sym_char_token1] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4224),
    [anon_sym_DQUOTE] = ACTIONS(4224),
    [anon_sym_AT_DQUOTE] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [sym_bool] = ACTIONS(4224),
    [sym_unit] = ACTIONS(4222),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4224),
    [sym_op_identifier] = ACTIONS(4224),
    [anon_sym_PLUS] = ACTIONS(4224),
    [anon_sym_DASH] = ACTIONS(4224),
    [anon_sym_PLUS_DOT] = ACTIONS(4224),
    [anon_sym_DASH_DOT] = ACTIONS(4224),
    [anon_sym_PERCENT] = ACTIONS(4224),
    [anon_sym_AMP_AMP] = ACTIONS(4224),
    [anon_sym_TILDE] = ACTIONS(4222),
    [aux_sym_prefix_op_token1] = ACTIONS(4224),
    [aux_sym_infix_op_token1] = ACTIONS(4222),
    [aux_sym_infix_op_token2] = ACTIONS(4224),
    [anon_sym_PIPE_PIPE] = ACTIONS(4224),
    [anon_sym_BANG_EQ] = ACTIONS(4224),
    [anon_sym_COLON_EQ] = ACTIONS(4222),
    [anon_sym_DOLLAR] = ACTIONS(4224),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4224),
    [sym_int] = ACTIONS(4224),
    [sym_xint] = ACTIONS(4222),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4222),
    [sym__newline] = ACTIONS(4222),
    [sym__dedent] = ACTIONS(4222),
  },
  [2856] = {
    [sym_block_comment] = STATE(2856),
    [sym_compiler_directive_decl] = STATE(2856),
    [sym_fsi_directive_decl] = STATE(2856),
    [sym_preproc_line] = STATE(2856),
    [sym_identifier] = ACTIONS(4182),
    [anon_sym_EQ] = ACTIONS(3689),
    [anon_sym_COLON] = ACTIONS(4182),
    [anon_sym_return] = ACTIONS(4182),
    [anon_sym_do] = ACTIONS(4182),
    [anon_sym_let] = ACTIONS(4182),
    [anon_sym_let_BANG] = ACTIONS(3689),
    [anon_sym_as] = ACTIONS(4182),
    [anon_sym_LPAREN] = ACTIONS(4182),
    [anon_sym_COMMA] = ACTIONS(3689),
    [anon_sym_null] = ACTIONS(4182),
    [anon_sym_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3689),
    [anon_sym_LBRACE] = ACTIONS(4182),
    [anon_sym_LT_AT] = ACTIONS(4182),
    [anon_sym_LT_AT_AT] = ACTIONS(4182),
    [anon_sym_DOT] = ACTIONS(4182),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3689),
    [anon_sym_new] = ACTIONS(4182),
    [anon_sym_with] = ACTIONS(4182),
    [anon_sym_return_BANG] = ACTIONS(3689),
    [anon_sym_yield] = ACTIONS(4182),
    [anon_sym_yield_BANG] = ACTIONS(3689),
    [anon_sym_lazy] = ACTIONS(4182),
    [anon_sym_assert] = ACTIONS(4182),
    [anon_sym_upcast] = ACTIONS(4182),
    [anon_sym_downcast] = ACTIONS(4182),
    [anon_sym_COLON_GT] = ACTIONS(3689),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3689),
    [anon_sym_for] = ACTIONS(4182),
    [anon_sym_while] = ACTIONS(4182),
    [anon_sym_if] = ACTIONS(4182),
    [anon_sym_fun] = ACTIONS(4182),
    [anon_sym_try] = ACTIONS(4182),
    [anon_sym_match] = ACTIONS(4182),
    [anon_sym_match_BANG] = ACTIONS(3689),
    [anon_sym_function] = ACTIONS(4182),
    [anon_sym_LT_DASH] = ACTIONS(4182),
    [anon_sym_DOT_LBRACK] = ACTIONS(3689),
    [anon_sym_LT] = ACTIONS(3689),
    [anon_sym_use] = ACTIONS(4182),
    [anon_sym_use_BANG] = ACTIONS(3689),
    [anon_sym_do_BANG] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(4182),
    [anon_sym_LPAREN2] = ACTIONS(4182),
    [anon_sym_or] = ACTIONS(4182),
    [aux_sym_char_token1] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4182),
    [anon_sym_DQUOTE] = ACTIONS(4182),
    [anon_sym_AT_DQUOTE] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [sym_bool] = ACTIONS(4182),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4182),
    [sym_op_identifier] = ACTIONS(4182),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_PLUS_DOT] = ACTIONS(4182),
    [anon_sym_DASH_DOT] = ACTIONS(4182),
    [anon_sym_PERCENT] = ACTIONS(4182),
    [anon_sym_AMP_AMP] = ACTIONS(4182),
    [anon_sym_TILDE] = ACTIONS(3689),
    [aux_sym_prefix_op_token1] = ACTIONS(4182),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token2] = ACTIONS(4182),
    [anon_sym_PIPE_PIPE] = ACTIONS(4182),
    [anon_sym_BANG_EQ] = ACTIONS(4182),
    [anon_sym_COLON_EQ] = ACTIONS(3689),
    [anon_sym_DOLLAR] = ACTIONS(4182),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4182),
    [sym_int] = ACTIONS(4182),
    [sym_xint] = ACTIONS(3689),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3689),
    [sym__newline] = ACTIONS(3689),
    [sym__dedent] = ACTIONS(3689),
  },
  [2857] = {
    [sym_block_comment] = STATE(2857),
    [sym_compiler_directive_decl] = STATE(2857),
    [sym_fsi_directive_decl] = STATE(2857),
    [sym_preproc_line] = STATE(2857),
    [sym_identifier] = ACTIONS(4162),
    [anon_sym_EQ] = ACTIONS(4160),
    [anon_sym_COLON] = ACTIONS(4162),
    [anon_sym_return] = ACTIONS(4162),
    [anon_sym_do] = ACTIONS(4162),
    [anon_sym_let] = ACTIONS(4162),
    [anon_sym_let_BANG] = ACTIONS(4160),
    [anon_sym_as] = ACTIONS(4162),
    [anon_sym_LPAREN] = ACTIONS(4162),
    [anon_sym_COMMA] = ACTIONS(4160),
    [anon_sym_null] = ACTIONS(4162),
    [anon_sym_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4160),
    [anon_sym_AMP] = ACTIONS(4162),
    [anon_sym_LBRACK] = ACTIONS(4162),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4160),
    [anon_sym_LBRACE] = ACTIONS(4162),
    [anon_sym_LT_AT] = ACTIONS(4162),
    [anon_sym_LT_AT_AT] = ACTIONS(4162),
    [anon_sym_DOT] = ACTIONS(4162),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4160),
    [anon_sym_new] = ACTIONS(4162),
    [anon_sym_with] = ACTIONS(4162),
    [anon_sym_return_BANG] = ACTIONS(4160),
    [anon_sym_yield] = ACTIONS(4162),
    [anon_sym_yield_BANG] = ACTIONS(4160),
    [anon_sym_lazy] = ACTIONS(4162),
    [anon_sym_assert] = ACTIONS(4162),
    [anon_sym_upcast] = ACTIONS(4162),
    [anon_sym_downcast] = ACTIONS(4162),
    [anon_sym_COLON_GT] = ACTIONS(4160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4160),
    [anon_sym_for] = ACTIONS(4162),
    [anon_sym_while] = ACTIONS(4162),
    [anon_sym_if] = ACTIONS(4162),
    [anon_sym_fun] = ACTIONS(4162),
    [anon_sym_try] = ACTIONS(4162),
    [anon_sym_match] = ACTIONS(4162),
    [anon_sym_match_BANG] = ACTIONS(4160),
    [anon_sym_function] = ACTIONS(4162),
    [anon_sym_LT_DASH] = ACTIONS(4162),
    [anon_sym_DOT_LBRACK] = ACTIONS(4160),
    [anon_sym_LT] = ACTIONS(4160),
    [anon_sym_use] = ACTIONS(4162),
    [anon_sym_use_BANG] = ACTIONS(4160),
    [anon_sym_do_BANG] = ACTIONS(4160),
    [anon_sym_begin] = ACTIONS(4162),
    [anon_sym_LPAREN2] = ACTIONS(4162),
    [anon_sym_or] = ACTIONS(4162),
    [aux_sym_char_token1] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4162),
    [anon_sym_DQUOTE] = ACTIONS(4162),
    [anon_sym_AT_DQUOTE] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [sym_bool] = ACTIONS(4162),
    [sym_unit] = ACTIONS(4160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4162),
    [sym_op_identifier] = ACTIONS(4162),
    [anon_sym_PLUS] = ACTIONS(4162),
    [anon_sym_DASH] = ACTIONS(4162),
    [anon_sym_PLUS_DOT] = ACTIONS(4162),
    [anon_sym_DASH_DOT] = ACTIONS(4162),
    [anon_sym_PERCENT] = ACTIONS(4162),
    [anon_sym_AMP_AMP] = ACTIONS(4162),
    [anon_sym_TILDE] = ACTIONS(4160),
    [aux_sym_prefix_op_token1] = ACTIONS(4162),
    [aux_sym_infix_op_token1] = ACTIONS(4160),
    [aux_sym_infix_op_token2] = ACTIONS(4162),
    [anon_sym_PIPE_PIPE] = ACTIONS(4162),
    [anon_sym_BANG_EQ] = ACTIONS(4162),
    [anon_sym_COLON_EQ] = ACTIONS(4160),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4162),
    [sym_int] = ACTIONS(4162),
    [sym_xint] = ACTIONS(4160),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4160),
    [sym__newline] = ACTIONS(4160),
    [sym__dedent] = ACTIONS(4160),
  },
  [2858] = {
    [sym_block_comment] = STATE(2858),
    [sym_compiler_directive_decl] = STATE(2858),
    [sym_fsi_directive_decl] = STATE(2858),
    [sym_preproc_line] = STATE(2858),
    [sym_identifier] = ACTIONS(4158),
    [anon_sym_EQ] = ACTIONS(4156),
    [anon_sym_COLON] = ACTIONS(4158),
    [anon_sym_return] = ACTIONS(4158),
    [anon_sym_do] = ACTIONS(4158),
    [anon_sym_let] = ACTIONS(4158),
    [anon_sym_let_BANG] = ACTIONS(4156),
    [anon_sym_as] = ACTIONS(4158),
    [anon_sym_LPAREN] = ACTIONS(4158),
    [anon_sym_COMMA] = ACTIONS(4156),
    [anon_sym_null] = ACTIONS(4158),
    [anon_sym_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_COLON] = ACTIONS(4156),
    [anon_sym_AMP] = ACTIONS(4158),
    [anon_sym_LBRACK] = ACTIONS(4158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(4158),
    [anon_sym_LT_AT] = ACTIONS(4158),
    [anon_sym_LT_AT_AT] = ACTIONS(4158),
    [anon_sym_DOT] = ACTIONS(4158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4156),
    [anon_sym_new] = ACTIONS(4158),
    [anon_sym_with] = ACTIONS(4158),
    [anon_sym_return_BANG] = ACTIONS(4156),
    [anon_sym_yield] = ACTIONS(4158),
    [anon_sym_yield_BANG] = ACTIONS(4156),
    [anon_sym_lazy] = ACTIONS(4158),
    [anon_sym_assert] = ACTIONS(4158),
    [anon_sym_upcast] = ACTIONS(4158),
    [anon_sym_downcast] = ACTIONS(4158),
    [anon_sym_COLON_GT] = ACTIONS(4156),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4156),
    [anon_sym_for] = ACTIONS(4158),
    [anon_sym_while] = ACTIONS(4158),
    [anon_sym_if] = ACTIONS(4158),
    [anon_sym_fun] = ACTIONS(4158),
    [anon_sym_try] = ACTIONS(4158),
    [anon_sym_match] = ACTIONS(4158),
    [anon_sym_match_BANG] = ACTIONS(4156),
    [anon_sym_function] = ACTIONS(4158),
    [anon_sym_LT_DASH] = ACTIONS(4158),
    [anon_sym_DOT_LBRACK] = ACTIONS(4156),
    [anon_sym_LT] = ACTIONS(4156),
    [anon_sym_use] = ACTIONS(4158),
    [anon_sym_use_BANG] = ACTIONS(4156),
    [anon_sym_do_BANG] = ACTIONS(4156),
    [anon_sym_begin] = ACTIONS(4158),
    [anon_sym_LPAREN2] = ACTIONS(4158),
    [anon_sym_or] = ACTIONS(4158),
    [aux_sym_char_token1] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4158),
    [anon_sym_DQUOTE] = ACTIONS(4158),
    [anon_sym_AT_DQUOTE] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [sym_bool] = ACTIONS(4158),
    [sym_unit] = ACTIONS(4156),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4158),
    [sym_op_identifier] = ACTIONS(4158),
    [anon_sym_PLUS] = ACTIONS(4158),
    [anon_sym_DASH] = ACTIONS(4158),
    [anon_sym_PLUS_DOT] = ACTIONS(4158),
    [anon_sym_DASH_DOT] = ACTIONS(4158),
    [anon_sym_PERCENT] = ACTIONS(4158),
    [anon_sym_AMP_AMP] = ACTIONS(4158),
    [anon_sym_TILDE] = ACTIONS(4156),
    [aux_sym_prefix_op_token1] = ACTIONS(4158),
    [aux_sym_infix_op_token1] = ACTIONS(4156),
    [aux_sym_infix_op_token2] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE] = ACTIONS(4158),
    [anon_sym_BANG_EQ] = ACTIONS(4158),
    [anon_sym_COLON_EQ] = ACTIONS(4156),
    [anon_sym_DOLLAR] = ACTIONS(4158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4158),
    [sym_int] = ACTIONS(4158),
    [sym_xint] = ACTIONS(4156),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4156),
    [sym__newline] = ACTIONS(4156),
    [sym__dedent] = ACTIONS(4156),
  },
  [2859] = {
    [sym_block_comment] = STATE(2859),
    [sym_compiler_directive_decl] = STATE(2859),
    [sym_fsi_directive_decl] = STATE(2859),
    [sym_preproc_line] = STATE(2859),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_done] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_DASH_GT] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_DOT_DOT] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [2860] = {
    [sym_block_comment] = STATE(2860),
    [sym_compiler_directive_decl] = STATE(2860),
    [sym_fsi_directive_decl] = STATE(2860),
    [sym_preproc_line] = STATE(2860),
    [sym_identifier] = ACTIONS(3732),
    [anon_sym_EQ] = ACTIONS(3730),
    [anon_sym_COLON] = ACTIONS(3732),
    [anon_sym_return] = ACTIONS(3732),
    [anon_sym_do] = ACTIONS(3732),
    [anon_sym_let] = ACTIONS(3732),
    [anon_sym_let_BANG] = ACTIONS(3730),
    [anon_sym_LPAREN] = ACTIONS(3732),
    [anon_sym_COMMA] = ACTIONS(3730),
    [anon_sym_null] = ACTIONS(3732),
    [anon_sym_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_QMARK] = ACTIONS(3732),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_LBRACK] = ACTIONS(3732),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3730),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_LT_AT] = ACTIONS(3732),
    [anon_sym_LT_AT_AT] = ACTIONS(3732),
    [anon_sym_AT_AT_GT] = ACTIONS(3732),
    [anon_sym_DOT] = ACTIONS(3732),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3730),
    [anon_sym_new] = ACTIONS(3732),
    [anon_sym_return_BANG] = ACTIONS(3730),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_yield_BANG] = ACTIONS(3730),
    [anon_sym_lazy] = ACTIONS(3732),
    [anon_sym_assert] = ACTIONS(3732),
    [anon_sym_upcast] = ACTIONS(3732),
    [anon_sym_downcast] = ACTIONS(3732),
    [anon_sym_COLON_GT] = ACTIONS(3730),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3730),
    [anon_sym_for] = ACTIONS(3732),
    [anon_sym_while] = ACTIONS(3732),
    [anon_sym_else] = ACTIONS(3732),
    [anon_sym_elif] = ACTIONS(3732),
    [anon_sym_if] = ACTIONS(3732),
    [anon_sym_fun] = ACTIONS(3732),
    [anon_sym_try] = ACTIONS(3732),
    [anon_sym_match] = ACTIONS(3732),
    [anon_sym_match_BANG] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3732),
    [anon_sym_LT_DASH] = ACTIONS(3732),
    [anon_sym_DOT_LBRACK] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3730),
    [anon_sym_use] = ACTIONS(3732),
    [anon_sym_use_BANG] = ACTIONS(3730),
    [anon_sym_do_BANG] = ACTIONS(3730),
    [anon_sym_begin] = ACTIONS(3732),
    [anon_sym_LPAREN2] = ACTIONS(3732),
    [anon_sym_or] = ACTIONS(3732),
    [aux_sym_char_token1] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3732),
    [anon_sym_DQUOTE] = ACTIONS(3732),
    [anon_sym_AT_DQUOTE] = ACTIONS(3730),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3730),
    [sym_bool] = ACTIONS(3732),
    [sym_unit] = ACTIONS(3730),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3732),
    [sym_op_identifier] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PLUS_DOT] = ACTIONS(3732),
    [anon_sym_DASH_DOT] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3732),
    [anon_sym_AMP_AMP] = ACTIONS(3732),
    [anon_sym_TILDE] = ACTIONS(3730),
    [aux_sym_prefix_op_token1] = ACTIONS(3732),
    [aux_sym_infix_op_token1] = ACTIONS(3730),
    [aux_sym_infix_op_token2] = ACTIONS(3732),
    [anon_sym_PIPE_PIPE] = ACTIONS(3732),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_COLON_EQ] = ACTIONS(3730),
    [anon_sym_DOLLAR] = ACTIONS(3732),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3732),
    [sym_int] = ACTIONS(3732),
    [sym_xint] = ACTIONS(3730),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3730),
    [sym__newline] = ACTIONS(3730),
  },
  [2861] = {
    [sym_block_comment] = STATE(2861),
    [sym_compiler_directive_decl] = STATE(2861),
    [sym_fsi_directive_decl] = STATE(2861),
    [sym_preproc_line] = STATE(2861),
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_EQ] = ACTIONS(4149),
    [anon_sym_COLON] = ACTIONS(4151),
    [anon_sym_return] = ACTIONS(4151),
    [anon_sym_do] = ACTIONS(4151),
    [anon_sym_let] = ACTIONS(4151),
    [anon_sym_let_BANG] = ACTIONS(4149),
    [anon_sym_as] = ACTIONS(4151),
    [anon_sym_LPAREN] = ACTIONS(4151),
    [anon_sym_COMMA] = ACTIONS(4149),
    [anon_sym_null] = ACTIONS(4151),
    [anon_sym_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_AMP] = ACTIONS(4151),
    [anon_sym_LBRACK] = ACTIONS(4151),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4149),
    [anon_sym_LBRACE] = ACTIONS(4151),
    [anon_sym_LT_AT] = ACTIONS(4151),
    [anon_sym_LT_AT_AT] = ACTIONS(4151),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4149),
    [anon_sym_new] = ACTIONS(4151),
    [anon_sym_with] = ACTIONS(4151),
    [anon_sym_return_BANG] = ACTIONS(4149),
    [anon_sym_yield] = ACTIONS(4151),
    [anon_sym_yield_BANG] = ACTIONS(4149),
    [anon_sym_lazy] = ACTIONS(4151),
    [anon_sym_assert] = ACTIONS(4151),
    [anon_sym_upcast] = ACTIONS(4151),
    [anon_sym_downcast] = ACTIONS(4151),
    [anon_sym_COLON_GT] = ACTIONS(4149),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4149),
    [anon_sym_for] = ACTIONS(4151),
    [anon_sym_while] = ACTIONS(4151),
    [anon_sym_if] = ACTIONS(4151),
    [anon_sym_fun] = ACTIONS(4151),
    [anon_sym_try] = ACTIONS(4151),
    [anon_sym_match] = ACTIONS(4151),
    [anon_sym_match_BANG] = ACTIONS(4149),
    [anon_sym_function] = ACTIONS(4151),
    [anon_sym_LT_DASH] = ACTIONS(4151),
    [anon_sym_DOT_LBRACK] = ACTIONS(4149),
    [anon_sym_LT] = ACTIONS(4149),
    [anon_sym_use] = ACTIONS(4151),
    [anon_sym_use_BANG] = ACTIONS(4149),
    [anon_sym_do_BANG] = ACTIONS(4149),
    [anon_sym_begin] = ACTIONS(4151),
    [anon_sym_LPAREN2] = ACTIONS(4151),
    [anon_sym_or] = ACTIONS(4151),
    [aux_sym_char_token1] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4151),
    [anon_sym_DQUOTE] = ACTIONS(4151),
    [anon_sym_AT_DQUOTE] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [sym_bool] = ACTIONS(4151),
    [sym_unit] = ACTIONS(4149),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4151),
    [sym_op_identifier] = ACTIONS(4151),
    [anon_sym_PLUS] = ACTIONS(4151),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_PLUS_DOT] = ACTIONS(4151),
    [anon_sym_DASH_DOT] = ACTIONS(4151),
    [anon_sym_PERCENT] = ACTIONS(4151),
    [anon_sym_AMP_AMP] = ACTIONS(4151),
    [anon_sym_TILDE] = ACTIONS(4149),
    [aux_sym_prefix_op_token1] = ACTIONS(4151),
    [aux_sym_infix_op_token1] = ACTIONS(4149),
    [aux_sym_infix_op_token2] = ACTIONS(4151),
    [anon_sym_PIPE_PIPE] = ACTIONS(4151),
    [anon_sym_BANG_EQ] = ACTIONS(4151),
    [anon_sym_COLON_EQ] = ACTIONS(4149),
    [anon_sym_DOLLAR] = ACTIONS(4151),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4151),
    [sym_int] = ACTIONS(4151),
    [sym_xint] = ACTIONS(4149),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4149),
    [sym__newline] = ACTIONS(4149),
    [sym__dedent] = ACTIONS(4149),
  },
  [2862] = {
    [sym_block_comment] = STATE(2862),
    [sym_compiler_directive_decl] = STATE(2862),
    [sym_fsi_directive_decl] = STATE(2862),
    [sym_preproc_line] = STATE(2862),
    [sym_identifier] = ACTIONS(3976),
    [anon_sym_EQ] = ACTIONS(3974),
    [anon_sym_COLON] = ACTIONS(3976),
    [anon_sym_return] = ACTIONS(3976),
    [anon_sym_do] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_let_BANG] = ACTIONS(3974),
    [anon_sym_as] = ACTIONS(3976),
    [anon_sym_LPAREN] = ACTIONS(3976),
    [anon_sym_COMMA] = ACTIONS(3974),
    [anon_sym_null] = ACTIONS(3976),
    [anon_sym_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_COLON] = ACTIONS(3974),
    [anon_sym_AMP] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(3976),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3974),
    [anon_sym_LBRACE] = ACTIONS(3976),
    [anon_sym_LT_AT] = ACTIONS(3976),
    [anon_sym_LT_AT_AT] = ACTIONS(3976),
    [anon_sym_DOT] = ACTIONS(3976),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3974),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_with] = ACTIONS(3976),
    [anon_sym_return_BANG] = ACTIONS(3974),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_yield_BANG] = ACTIONS(3974),
    [anon_sym_lazy] = ACTIONS(3976),
    [anon_sym_assert] = ACTIONS(3976),
    [anon_sym_upcast] = ACTIONS(3976),
    [anon_sym_downcast] = ACTIONS(3976),
    [anon_sym_COLON_GT] = ACTIONS(3974),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3974),
    [anon_sym_for] = ACTIONS(3976),
    [anon_sym_while] = ACTIONS(3976),
    [anon_sym_if] = ACTIONS(3976),
    [anon_sym_fun] = ACTIONS(3976),
    [anon_sym_try] = ACTIONS(3976),
    [anon_sym_match] = ACTIONS(3976),
    [anon_sym_match_BANG] = ACTIONS(3974),
    [anon_sym_function] = ACTIONS(3976),
    [anon_sym_LT_DASH] = ACTIONS(3976),
    [anon_sym_DOT_LBRACK] = ACTIONS(3974),
    [anon_sym_LT] = ACTIONS(3974),
    [anon_sym_use] = ACTIONS(3976),
    [anon_sym_use_BANG] = ACTIONS(3974),
    [anon_sym_do_BANG] = ACTIONS(3974),
    [anon_sym_begin] = ACTIONS(3976),
    [anon_sym_LPAREN2] = ACTIONS(3976),
    [anon_sym_or] = ACTIONS(3976),
    [aux_sym_char_token1] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3976),
    [anon_sym_DQUOTE] = ACTIONS(3976),
    [anon_sym_AT_DQUOTE] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [sym_bool] = ACTIONS(3976),
    [sym_unit] = ACTIONS(3974),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3976),
    [sym_op_identifier] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3976),
    [anon_sym_DASH] = ACTIONS(3976),
    [anon_sym_PLUS_DOT] = ACTIONS(3976),
    [anon_sym_DASH_DOT] = ACTIONS(3976),
    [anon_sym_PERCENT] = ACTIONS(3976),
    [anon_sym_AMP_AMP] = ACTIONS(3976),
    [anon_sym_TILDE] = ACTIONS(3974),
    [aux_sym_prefix_op_token1] = ACTIONS(3976),
    [aux_sym_infix_op_token1] = ACTIONS(3974),
    [aux_sym_infix_op_token2] = ACTIONS(3976),
    [anon_sym_PIPE_PIPE] = ACTIONS(3976),
    [anon_sym_BANG_EQ] = ACTIONS(3976),
    [anon_sym_COLON_EQ] = ACTIONS(3974),
    [anon_sym_DOLLAR] = ACTIONS(3976),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3976),
    [sym_int] = ACTIONS(3976),
    [sym_xint] = ACTIONS(3974),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3974),
    [sym__newline] = ACTIONS(3974),
    [sym__dedent] = ACTIONS(3974),
  },
  [2863] = {
    [sym_block_comment] = STATE(2863),
    [sym_compiler_directive_decl] = STATE(2863),
    [sym_fsi_directive_decl] = STATE(2863),
    [sym_preproc_line] = STATE(2863),
    [sym_identifier] = ACTIONS(4147),
    [anon_sym_EQ] = ACTIONS(4145),
    [anon_sym_COLON] = ACTIONS(4147),
    [anon_sym_return] = ACTIONS(4147),
    [anon_sym_do] = ACTIONS(4147),
    [anon_sym_let] = ACTIONS(4147),
    [anon_sym_let_BANG] = ACTIONS(4145),
    [anon_sym_as] = ACTIONS(4147),
    [anon_sym_LPAREN] = ACTIONS(4147),
    [anon_sym_COMMA] = ACTIONS(4145),
    [anon_sym_null] = ACTIONS(4147),
    [anon_sym_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_COLON] = ACTIONS(4145),
    [anon_sym_AMP] = ACTIONS(4147),
    [anon_sym_LBRACK] = ACTIONS(4147),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4145),
    [anon_sym_LBRACE] = ACTIONS(4147),
    [anon_sym_LT_AT] = ACTIONS(4147),
    [anon_sym_LT_AT_AT] = ACTIONS(4147),
    [anon_sym_DOT] = ACTIONS(4147),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4145),
    [anon_sym_new] = ACTIONS(4147),
    [anon_sym_with] = ACTIONS(4147),
    [anon_sym_return_BANG] = ACTIONS(4145),
    [anon_sym_yield] = ACTIONS(4147),
    [anon_sym_yield_BANG] = ACTIONS(4145),
    [anon_sym_lazy] = ACTIONS(4147),
    [anon_sym_assert] = ACTIONS(4147),
    [anon_sym_upcast] = ACTIONS(4147),
    [anon_sym_downcast] = ACTIONS(4147),
    [anon_sym_COLON_GT] = ACTIONS(4145),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4145),
    [anon_sym_for] = ACTIONS(4147),
    [anon_sym_while] = ACTIONS(4147),
    [anon_sym_if] = ACTIONS(4147),
    [anon_sym_fun] = ACTIONS(4147),
    [anon_sym_try] = ACTIONS(4147),
    [anon_sym_match] = ACTIONS(4147),
    [anon_sym_match_BANG] = ACTIONS(4145),
    [anon_sym_function] = ACTIONS(4147),
    [anon_sym_LT_DASH] = ACTIONS(4147),
    [anon_sym_DOT_LBRACK] = ACTIONS(4145),
    [anon_sym_LT] = ACTIONS(4145),
    [anon_sym_use] = ACTIONS(4147),
    [anon_sym_use_BANG] = ACTIONS(4145),
    [anon_sym_do_BANG] = ACTIONS(4145),
    [anon_sym_begin] = ACTIONS(4147),
    [anon_sym_LPAREN2] = ACTIONS(4147),
    [anon_sym_or] = ACTIONS(4147),
    [aux_sym_char_token1] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4147),
    [anon_sym_DQUOTE] = ACTIONS(4147),
    [anon_sym_AT_DQUOTE] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [sym_bool] = ACTIONS(4147),
    [sym_unit] = ACTIONS(4145),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4147),
    [sym_op_identifier] = ACTIONS(4147),
    [anon_sym_PLUS] = ACTIONS(4147),
    [anon_sym_DASH] = ACTIONS(4147),
    [anon_sym_PLUS_DOT] = ACTIONS(4147),
    [anon_sym_DASH_DOT] = ACTIONS(4147),
    [anon_sym_PERCENT] = ACTIONS(4147),
    [anon_sym_AMP_AMP] = ACTIONS(4147),
    [anon_sym_TILDE] = ACTIONS(4145),
    [aux_sym_prefix_op_token1] = ACTIONS(4147),
    [aux_sym_infix_op_token1] = ACTIONS(4145),
    [aux_sym_infix_op_token2] = ACTIONS(4147),
    [anon_sym_PIPE_PIPE] = ACTIONS(4147),
    [anon_sym_BANG_EQ] = ACTIONS(4147),
    [anon_sym_COLON_EQ] = ACTIONS(4145),
    [anon_sym_DOLLAR] = ACTIONS(4147),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4147),
    [sym_int] = ACTIONS(4147),
    [sym_xint] = ACTIONS(4145),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4145),
    [sym__newline] = ACTIONS(4145),
    [sym__dedent] = ACTIONS(4145),
  },
  [2864] = {
    [sym_block_comment] = STATE(2864),
    [sym_compiler_directive_decl] = STATE(2864),
    [sym_fsi_directive_decl] = STATE(2864),
    [sym_preproc_line] = STATE(2864),
    [sym_identifier] = ACTIONS(4064),
    [anon_sym_EQ] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4064),
    [anon_sym_return] = ACTIONS(4064),
    [anon_sym_do] = ACTIONS(4064),
    [anon_sym_let] = ACTIONS(4064),
    [anon_sym_let_BANG] = ACTIONS(4062),
    [anon_sym_as] = ACTIONS(4064),
    [anon_sym_LPAREN] = ACTIONS(4064),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_null] = ACTIONS(4064),
    [anon_sym_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_COLON] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4062),
    [anon_sym_LBRACE] = ACTIONS(4064),
    [anon_sym_LT_AT] = ACTIONS(4064),
    [anon_sym_LT_AT_AT] = ACTIONS(4064),
    [anon_sym_DOT] = ACTIONS(4064),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4062),
    [anon_sym_new] = ACTIONS(4064),
    [anon_sym_with] = ACTIONS(4064),
    [anon_sym_return_BANG] = ACTIONS(4062),
    [anon_sym_yield] = ACTIONS(4064),
    [anon_sym_yield_BANG] = ACTIONS(4062),
    [anon_sym_lazy] = ACTIONS(4064),
    [anon_sym_assert] = ACTIONS(4064),
    [anon_sym_upcast] = ACTIONS(4064),
    [anon_sym_downcast] = ACTIONS(4064),
    [anon_sym_COLON_GT] = ACTIONS(4062),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4062),
    [anon_sym_for] = ACTIONS(4064),
    [anon_sym_while] = ACTIONS(4064),
    [anon_sym_if] = ACTIONS(4064),
    [anon_sym_fun] = ACTIONS(4064),
    [anon_sym_try] = ACTIONS(4064),
    [anon_sym_match] = ACTIONS(4064),
    [anon_sym_match_BANG] = ACTIONS(4062),
    [anon_sym_function] = ACTIONS(4064),
    [anon_sym_LT_DASH] = ACTIONS(4064),
    [anon_sym_DOT_LBRACK] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(4062),
    [anon_sym_use] = ACTIONS(4064),
    [anon_sym_use_BANG] = ACTIONS(4062),
    [anon_sym_do_BANG] = ACTIONS(4062),
    [anon_sym_begin] = ACTIONS(4064),
    [anon_sym_LPAREN2] = ACTIONS(4064),
    [anon_sym_or] = ACTIONS(4064),
    [aux_sym_char_token1] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_AT_DQUOTE] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [sym_bool] = ACTIONS(4064),
    [sym_unit] = ACTIONS(4062),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4064),
    [sym_op_identifier] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4064),
    [anon_sym_DASH] = ACTIONS(4064),
    [anon_sym_PLUS_DOT] = ACTIONS(4064),
    [anon_sym_DASH_DOT] = ACTIONS(4064),
    [anon_sym_PERCENT] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_TILDE] = ACTIONS(4062),
    [aux_sym_prefix_op_token1] = ACTIONS(4064),
    [aux_sym_infix_op_token1] = ACTIONS(4062),
    [aux_sym_infix_op_token2] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_BANG_EQ] = ACTIONS(4064),
    [anon_sym_COLON_EQ] = ACTIONS(4062),
    [anon_sym_DOLLAR] = ACTIONS(4064),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4064),
    [sym_int] = ACTIONS(4064),
    [sym_xint] = ACTIONS(4062),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4062),
    [sym__newline] = ACTIONS(4062),
    [sym__dedent] = ACTIONS(4062),
  },
  [2865] = {
    [sym_block_comment] = STATE(2865),
    [sym_compiler_directive_decl] = STATE(2865),
    [sym_fsi_directive_decl] = STATE(2865),
    [sym_preproc_line] = STATE(2865),
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_EQ] = ACTIONS(3990),
    [anon_sym_COLON] = ACTIONS(3992),
    [anon_sym_return] = ACTIONS(3992),
    [anon_sym_do] = ACTIONS(3992),
    [anon_sym_let] = ACTIONS(3992),
    [anon_sym_let_BANG] = ACTIONS(3990),
    [anon_sym_as] = ACTIONS(3992),
    [anon_sym_LPAREN] = ACTIONS(3992),
    [anon_sym_COMMA] = ACTIONS(3990),
    [anon_sym_null] = ACTIONS(3992),
    [anon_sym_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [anon_sym_AMP] = ACTIONS(3992),
    [anon_sym_LBRACK] = ACTIONS(3992),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3990),
    [anon_sym_LBRACE] = ACTIONS(3992),
    [anon_sym_LT_AT] = ACTIONS(3992),
    [anon_sym_LT_AT_AT] = ACTIONS(3992),
    [anon_sym_DOT] = ACTIONS(3992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3990),
    [anon_sym_new] = ACTIONS(3992),
    [anon_sym_with] = ACTIONS(3992),
    [anon_sym_return_BANG] = ACTIONS(3990),
    [anon_sym_yield] = ACTIONS(3992),
    [anon_sym_yield_BANG] = ACTIONS(3990),
    [anon_sym_lazy] = ACTIONS(3992),
    [anon_sym_assert] = ACTIONS(3992),
    [anon_sym_upcast] = ACTIONS(3992),
    [anon_sym_downcast] = ACTIONS(3992),
    [anon_sym_COLON_GT] = ACTIONS(3990),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3990),
    [anon_sym_for] = ACTIONS(3992),
    [anon_sym_while] = ACTIONS(3992),
    [anon_sym_if] = ACTIONS(3992),
    [anon_sym_fun] = ACTIONS(3992),
    [anon_sym_try] = ACTIONS(3992),
    [anon_sym_match] = ACTIONS(3992),
    [anon_sym_match_BANG] = ACTIONS(3990),
    [anon_sym_function] = ACTIONS(3992),
    [anon_sym_LT_DASH] = ACTIONS(3992),
    [anon_sym_DOT_LBRACK] = ACTIONS(3990),
    [anon_sym_LT] = ACTIONS(3990),
    [anon_sym_use] = ACTIONS(3992),
    [anon_sym_use_BANG] = ACTIONS(3990),
    [anon_sym_do_BANG] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_LPAREN2] = ACTIONS(3992),
    [anon_sym_or] = ACTIONS(3992),
    [aux_sym_char_token1] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3992),
    [anon_sym_DQUOTE] = ACTIONS(3992),
    [anon_sym_AT_DQUOTE] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [sym_bool] = ACTIONS(3992),
    [sym_unit] = ACTIONS(3990),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3992),
    [sym_op_identifier] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3992),
    [anon_sym_DASH] = ACTIONS(3992),
    [anon_sym_PLUS_DOT] = ACTIONS(3992),
    [anon_sym_DASH_DOT] = ACTIONS(3992),
    [anon_sym_PERCENT] = ACTIONS(3992),
    [anon_sym_AMP_AMP] = ACTIONS(3992),
    [anon_sym_TILDE] = ACTIONS(3990),
    [aux_sym_prefix_op_token1] = ACTIONS(3992),
    [aux_sym_infix_op_token1] = ACTIONS(3990),
    [aux_sym_infix_op_token2] = ACTIONS(3992),
    [anon_sym_PIPE_PIPE] = ACTIONS(3992),
    [anon_sym_BANG_EQ] = ACTIONS(3992),
    [anon_sym_COLON_EQ] = ACTIONS(3990),
    [anon_sym_DOLLAR] = ACTIONS(3992),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3992),
    [sym_int] = ACTIONS(3992),
    [sym_xint] = ACTIONS(3990),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3990),
    [sym__newline] = ACTIONS(3990),
    [sym__dedent] = ACTIONS(3990),
  },
  [2866] = {
    [sym_block_comment] = STATE(2866),
    [sym_compiler_directive_decl] = STATE(2866),
    [sym_fsi_directive_decl] = STATE(2866),
    [sym_preproc_line] = STATE(2866),
    [sym_identifier] = ACTIONS(3988),
    [anon_sym_EQ] = ACTIONS(3986),
    [anon_sym_COLON] = ACTIONS(3988),
    [anon_sym_return] = ACTIONS(3988),
    [anon_sym_do] = ACTIONS(3988),
    [anon_sym_let] = ACTIONS(3988),
    [anon_sym_let_BANG] = ACTIONS(3986),
    [anon_sym_as] = ACTIONS(3988),
    [anon_sym_LPAREN] = ACTIONS(3988),
    [anon_sym_COMMA] = ACTIONS(3986),
    [anon_sym_null] = ACTIONS(3988),
    [anon_sym_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_COLON] = ACTIONS(3986),
    [anon_sym_AMP] = ACTIONS(3988),
    [anon_sym_LBRACK] = ACTIONS(3988),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3986),
    [anon_sym_LBRACE] = ACTIONS(3988),
    [anon_sym_LT_AT] = ACTIONS(3988),
    [anon_sym_LT_AT_AT] = ACTIONS(3988),
    [anon_sym_DOT] = ACTIONS(3988),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3986),
    [anon_sym_new] = ACTIONS(3988),
    [anon_sym_with] = ACTIONS(3988),
    [anon_sym_return_BANG] = ACTIONS(3986),
    [anon_sym_yield] = ACTIONS(3988),
    [anon_sym_yield_BANG] = ACTIONS(3986),
    [anon_sym_lazy] = ACTIONS(3988),
    [anon_sym_assert] = ACTIONS(3988),
    [anon_sym_upcast] = ACTIONS(3988),
    [anon_sym_downcast] = ACTIONS(3988),
    [anon_sym_COLON_GT] = ACTIONS(3986),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_while] = ACTIONS(3988),
    [anon_sym_if] = ACTIONS(3988),
    [anon_sym_fun] = ACTIONS(3988),
    [anon_sym_try] = ACTIONS(3988),
    [anon_sym_match] = ACTIONS(3988),
    [anon_sym_match_BANG] = ACTIONS(3986),
    [anon_sym_function] = ACTIONS(3988),
    [anon_sym_LT_DASH] = ACTIONS(3988),
    [anon_sym_DOT_LBRACK] = ACTIONS(3986),
    [anon_sym_LT] = ACTIONS(3986),
    [anon_sym_use] = ACTIONS(3988),
    [anon_sym_use_BANG] = ACTIONS(3986),
    [anon_sym_do_BANG] = ACTIONS(3986),
    [anon_sym_begin] = ACTIONS(3988),
    [anon_sym_LPAREN2] = ACTIONS(3988),
    [anon_sym_or] = ACTIONS(3988),
    [aux_sym_char_token1] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3988),
    [anon_sym_DQUOTE] = ACTIONS(3988),
    [anon_sym_AT_DQUOTE] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [sym_bool] = ACTIONS(3988),
    [sym_unit] = ACTIONS(3986),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3988),
    [sym_op_identifier] = ACTIONS(3988),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_PLUS_DOT] = ACTIONS(3988),
    [anon_sym_DASH_DOT] = ACTIONS(3988),
    [anon_sym_PERCENT] = ACTIONS(3988),
    [anon_sym_AMP_AMP] = ACTIONS(3988),
    [anon_sym_TILDE] = ACTIONS(3986),
    [aux_sym_prefix_op_token1] = ACTIONS(3988),
    [aux_sym_infix_op_token1] = ACTIONS(3986),
    [aux_sym_infix_op_token2] = ACTIONS(3988),
    [anon_sym_PIPE_PIPE] = ACTIONS(3988),
    [anon_sym_BANG_EQ] = ACTIONS(3988),
    [anon_sym_COLON_EQ] = ACTIONS(3986),
    [anon_sym_DOLLAR] = ACTIONS(3988),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3988),
    [sym_int] = ACTIONS(3988),
    [sym_xint] = ACTIONS(3986),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3986),
    [sym__newline] = ACTIONS(3986),
    [sym__dedent] = ACTIONS(3986),
  },
  [2867] = {
    [sym_block_comment] = STATE(2867),
    [sym_compiler_directive_decl] = STATE(2867),
    [sym_fsi_directive_decl] = STATE(2867),
    [sym_preproc_line] = STATE(2867),
    [sym_identifier] = ACTIONS(3984),
    [anon_sym_EQ] = ACTIONS(3982),
    [anon_sym_COLON] = ACTIONS(3984),
    [anon_sym_return] = ACTIONS(3984),
    [anon_sym_do] = ACTIONS(3984),
    [anon_sym_let] = ACTIONS(3984),
    [anon_sym_let_BANG] = ACTIONS(3982),
    [anon_sym_as] = ACTIONS(3984),
    [anon_sym_LPAREN] = ACTIONS(3984),
    [anon_sym_COMMA] = ACTIONS(3982),
    [anon_sym_null] = ACTIONS(3984),
    [anon_sym_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AMP] = ACTIONS(3984),
    [anon_sym_LBRACK] = ACTIONS(3984),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(3984),
    [anon_sym_LT_AT] = ACTIONS(3984),
    [anon_sym_LT_AT_AT] = ACTIONS(3984),
    [anon_sym_DOT] = ACTIONS(3984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3982),
    [anon_sym_new] = ACTIONS(3984),
    [anon_sym_with] = ACTIONS(3984),
    [anon_sym_return_BANG] = ACTIONS(3982),
    [anon_sym_yield] = ACTIONS(3984),
    [anon_sym_yield_BANG] = ACTIONS(3982),
    [anon_sym_lazy] = ACTIONS(3984),
    [anon_sym_assert] = ACTIONS(3984),
    [anon_sym_upcast] = ACTIONS(3984),
    [anon_sym_downcast] = ACTIONS(3984),
    [anon_sym_COLON_GT] = ACTIONS(3982),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3982),
    [anon_sym_for] = ACTIONS(3984),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_if] = ACTIONS(3984),
    [anon_sym_fun] = ACTIONS(3984),
    [anon_sym_try] = ACTIONS(3984),
    [anon_sym_match] = ACTIONS(3984),
    [anon_sym_match_BANG] = ACTIONS(3982),
    [anon_sym_function] = ACTIONS(3984),
    [anon_sym_LT_DASH] = ACTIONS(3984),
    [anon_sym_DOT_LBRACK] = ACTIONS(3982),
    [anon_sym_LT] = ACTIONS(3982),
    [anon_sym_use] = ACTIONS(3984),
    [anon_sym_use_BANG] = ACTIONS(3982),
    [anon_sym_do_BANG] = ACTIONS(3982),
    [anon_sym_begin] = ACTIONS(3984),
    [anon_sym_LPAREN2] = ACTIONS(3984),
    [anon_sym_or] = ACTIONS(3984),
    [aux_sym_char_token1] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3984),
    [anon_sym_DQUOTE] = ACTIONS(3984),
    [anon_sym_AT_DQUOTE] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [sym_bool] = ACTIONS(3984),
    [sym_unit] = ACTIONS(3982),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3984),
    [sym_op_identifier] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3984),
    [anon_sym_DASH] = ACTIONS(3984),
    [anon_sym_PLUS_DOT] = ACTIONS(3984),
    [anon_sym_DASH_DOT] = ACTIONS(3984),
    [anon_sym_PERCENT] = ACTIONS(3984),
    [anon_sym_AMP_AMP] = ACTIONS(3984),
    [anon_sym_TILDE] = ACTIONS(3982),
    [aux_sym_prefix_op_token1] = ACTIONS(3984),
    [aux_sym_infix_op_token1] = ACTIONS(3982),
    [aux_sym_infix_op_token2] = ACTIONS(3984),
    [anon_sym_PIPE_PIPE] = ACTIONS(3984),
    [anon_sym_BANG_EQ] = ACTIONS(3984),
    [anon_sym_COLON_EQ] = ACTIONS(3982),
    [anon_sym_DOLLAR] = ACTIONS(3984),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3984),
    [sym_int] = ACTIONS(3984),
    [sym_xint] = ACTIONS(3982),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3982),
    [sym__newline] = ACTIONS(3982),
    [sym__dedent] = ACTIONS(3982),
  },
  [2868] = {
    [sym_block_comment] = STATE(2868),
    [sym_compiler_directive_decl] = STATE(2868),
    [sym_fsi_directive_decl] = STATE(2868),
    [sym_preproc_line] = STATE(2868),
    [sym_identifier] = ACTIONS(3980),
    [anon_sym_EQ] = ACTIONS(3978),
    [anon_sym_COLON] = ACTIONS(3980),
    [anon_sym_return] = ACTIONS(3980),
    [anon_sym_do] = ACTIONS(3980),
    [anon_sym_let] = ACTIONS(3980),
    [anon_sym_let_BANG] = ACTIONS(3978),
    [anon_sym_as] = ACTIONS(3980),
    [anon_sym_LPAREN] = ACTIONS(3980),
    [anon_sym_COMMA] = ACTIONS(3978),
    [anon_sym_null] = ACTIONS(3980),
    [anon_sym_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3978),
    [anon_sym_AMP] = ACTIONS(3980),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3978),
    [anon_sym_LBRACE] = ACTIONS(3980),
    [anon_sym_LT_AT] = ACTIONS(3980),
    [anon_sym_LT_AT_AT] = ACTIONS(3980),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3978),
    [anon_sym_new] = ACTIONS(3980),
    [anon_sym_with] = ACTIONS(3980),
    [anon_sym_return_BANG] = ACTIONS(3978),
    [anon_sym_yield] = ACTIONS(3980),
    [anon_sym_yield_BANG] = ACTIONS(3978),
    [anon_sym_lazy] = ACTIONS(3980),
    [anon_sym_assert] = ACTIONS(3980),
    [anon_sym_upcast] = ACTIONS(3980),
    [anon_sym_downcast] = ACTIONS(3980),
    [anon_sym_COLON_GT] = ACTIONS(3978),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3978),
    [anon_sym_for] = ACTIONS(3980),
    [anon_sym_while] = ACTIONS(3980),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_fun] = ACTIONS(3980),
    [anon_sym_try] = ACTIONS(3980),
    [anon_sym_match] = ACTIONS(3980),
    [anon_sym_match_BANG] = ACTIONS(3978),
    [anon_sym_function] = ACTIONS(3980),
    [anon_sym_LT_DASH] = ACTIONS(3980),
    [anon_sym_DOT_LBRACK] = ACTIONS(3978),
    [anon_sym_LT] = ACTIONS(3978),
    [anon_sym_use] = ACTIONS(3980),
    [anon_sym_use_BANG] = ACTIONS(3978),
    [anon_sym_do_BANG] = ACTIONS(3978),
    [anon_sym_begin] = ACTIONS(3980),
    [anon_sym_LPAREN2] = ACTIONS(3980),
    [anon_sym_or] = ACTIONS(3980),
    [aux_sym_char_token1] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3980),
    [anon_sym_DQUOTE] = ACTIONS(3980),
    [anon_sym_AT_DQUOTE] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [sym_bool] = ACTIONS(3980),
    [sym_unit] = ACTIONS(3978),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3980),
    [sym_op_identifier] = ACTIONS(3980),
    [anon_sym_PLUS] = ACTIONS(3980),
    [anon_sym_DASH] = ACTIONS(3980),
    [anon_sym_PLUS_DOT] = ACTIONS(3980),
    [anon_sym_DASH_DOT] = ACTIONS(3980),
    [anon_sym_PERCENT] = ACTIONS(3980),
    [anon_sym_AMP_AMP] = ACTIONS(3980),
    [anon_sym_TILDE] = ACTIONS(3978),
    [aux_sym_prefix_op_token1] = ACTIONS(3980),
    [aux_sym_infix_op_token1] = ACTIONS(3978),
    [aux_sym_infix_op_token2] = ACTIONS(3980),
    [anon_sym_PIPE_PIPE] = ACTIONS(3980),
    [anon_sym_BANG_EQ] = ACTIONS(3980),
    [anon_sym_COLON_EQ] = ACTIONS(3978),
    [anon_sym_DOLLAR] = ACTIONS(3980),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3980),
    [sym_int] = ACTIONS(3980),
    [sym_xint] = ACTIONS(3978),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3978),
    [sym__newline] = ACTIONS(3978),
    [sym__dedent] = ACTIONS(3978),
  },
  [2869] = {
    [sym_block_comment] = STATE(2869),
    [sym_compiler_directive_decl] = STATE(2869),
    [sym_fsi_directive_decl] = STATE(2869),
    [sym_preproc_line] = STATE(2869),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_AT_AT_GT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_else] = ACTIONS(3700),
    [anon_sym_elif] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [2870] = {
    [sym_block_comment] = STATE(2870),
    [sym_compiler_directive_decl] = STATE(2870),
    [sym_fsi_directive_decl] = STATE(2870),
    [sym_preproc_line] = STATE(2870),
    [aux_sym_rules_repeat1] = STATE(2874),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(5409),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_GT] = ACTIONS(3693),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_or] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(5426),
  },
  [2871] = {
    [sym_block_comment] = STATE(2871),
    [sym_compiler_directive_decl] = STATE(2871),
    [sym_fsi_directive_decl] = STATE(2871),
    [sym_preproc_line] = STATE(2871),
    [aux_sym_rules_repeat1] = STATE(2878),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(5409),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_GT] = ACTIONS(3693),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_or] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(5426),
  },
  [2872] = {
    [sym_block_comment] = STATE(2872),
    [sym_compiler_directive_decl] = STATE(2872),
    [sym_fsi_directive_decl] = STATE(2872),
    [sym_preproc_line] = STATE(2872),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_COLON] = ACTIONS(3867),
    [anon_sym_return] = ACTIONS(3867),
    [anon_sym_do] = ACTIONS(3867),
    [anon_sym_let] = ACTIONS(3867),
    [anon_sym_let_BANG] = ACTIONS(3865),
    [anon_sym_as] = ACTIONS(3867),
    [anon_sym_LPAREN] = ACTIONS(3867),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_null] = ACTIONS(3867),
    [anon_sym_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_COLON] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3867),
    [anon_sym_LBRACK] = ACTIONS(3867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3867),
    [anon_sym_LT_AT] = ACTIONS(3867),
    [anon_sym_LT_AT_AT] = ACTIONS(3867),
    [anon_sym_DOT] = ACTIONS(3867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3867),
    [anon_sym_with] = ACTIONS(3867),
    [anon_sym_return_BANG] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3867),
    [anon_sym_yield_BANG] = ACTIONS(3865),
    [anon_sym_lazy] = ACTIONS(3867),
    [anon_sym_assert] = ACTIONS(3867),
    [anon_sym_upcast] = ACTIONS(3867),
    [anon_sym_downcast] = ACTIONS(3867),
    [anon_sym_COLON_GT] = ACTIONS(3865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3867),
    [anon_sym_while] = ACTIONS(3867),
    [anon_sym_if] = ACTIONS(3867),
    [anon_sym_fun] = ACTIONS(3867),
    [anon_sym_try] = ACTIONS(3867),
    [anon_sym_match] = ACTIONS(3867),
    [anon_sym_match_BANG] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(3867),
    [anon_sym_DOT_LBRACK] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_use] = ACTIONS(3867),
    [anon_sym_use_BANG] = ACTIONS(3865),
    [anon_sym_do_BANG] = ACTIONS(3865),
    [anon_sym_begin] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(3867),
    [anon_sym_or] = ACTIONS(3867),
    [aux_sym_char_token1] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3867),
    [anon_sym_DQUOTE] = ACTIONS(3867),
    [anon_sym_AT_DQUOTE] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [sym_bool] = ACTIONS(3867),
    [sym_unit] = ACTIONS(3865),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3867),
    [sym_op_identifier] = ACTIONS(3867),
    [anon_sym_PLUS] = ACTIONS(3867),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_PLUS_DOT] = ACTIONS(3867),
    [anon_sym_DASH_DOT] = ACTIONS(3867),
    [anon_sym_PERCENT] = ACTIONS(3867),
    [anon_sym_AMP_AMP] = ACTIONS(3867),
    [anon_sym_TILDE] = ACTIONS(3865),
    [aux_sym_prefix_op_token1] = ACTIONS(3867),
    [aux_sym_infix_op_token1] = ACTIONS(3865),
    [aux_sym_infix_op_token2] = ACTIONS(3867),
    [anon_sym_PIPE_PIPE] = ACTIONS(3867),
    [anon_sym_BANG_EQ] = ACTIONS(3867),
    [anon_sym_COLON_EQ] = ACTIONS(3865),
    [anon_sym_DOLLAR] = ACTIONS(3867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3867),
    [sym_int] = ACTIONS(3867),
    [sym_xint] = ACTIONS(3865),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3865),
    [sym__newline] = ACTIONS(3865),
    [sym__dedent] = ACTIONS(3865),
  },
  [2873] = {
    [sym_block_comment] = STATE(2873),
    [sym_compiler_directive_decl] = STATE(2873),
    [sym_fsi_directive_decl] = STATE(2873),
    [sym_preproc_line] = STATE(2873),
    [aux_sym_rules_repeat1] = STATE(2830),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(5401),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_AT_GT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_or] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(5429),
  },
  [2874] = {
    [sym_block_comment] = STATE(2874),
    [sym_compiler_directive_decl] = STATE(2874),
    [sym_fsi_directive_decl] = STATE(2874),
    [sym_preproc_line] = STATE(2874),
    [aux_sym_rules_repeat1] = STATE(2878),
    [sym_identifier] = ACTIONS(3676),
    [anon_sym_EQ] = ACTIONS(3674),
    [anon_sym_COLON] = ACTIONS(3676),
    [anon_sym_return] = ACTIONS(3676),
    [anon_sym_do] = ACTIONS(3676),
    [anon_sym_let] = ACTIONS(3676),
    [anon_sym_let_BANG] = ACTIONS(3674),
    [anon_sym_LPAREN] = ACTIONS(3676),
    [anon_sym_COMMA] = ACTIONS(3674),
    [anon_sym_null] = ACTIONS(3676),
    [anon_sym_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_COLON] = ACTIONS(3674),
    [anon_sym_PIPE] = ACTIONS(5409),
    [anon_sym_AMP] = ACTIONS(3676),
    [anon_sym_LBRACK] = ACTIONS(3676),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3674),
    [anon_sym_LBRACE] = ACTIONS(3676),
    [anon_sym_LT_AT] = ACTIONS(3676),
    [anon_sym_LT_AT_AT] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3674),
    [anon_sym_new] = ACTIONS(3676),
    [anon_sym_return_BANG] = ACTIONS(3674),
    [anon_sym_yield] = ACTIONS(3676),
    [anon_sym_yield_BANG] = ACTIONS(3674),
    [anon_sym_lazy] = ACTIONS(3676),
    [anon_sym_assert] = ACTIONS(3676),
    [anon_sym_upcast] = ACTIONS(3676),
    [anon_sym_downcast] = ACTIONS(3676),
    [anon_sym_COLON_GT] = ACTIONS(3674),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3674),
    [anon_sym_for] = ACTIONS(3676),
    [anon_sym_while] = ACTIONS(3676),
    [anon_sym_if] = ACTIONS(3676),
    [anon_sym_fun] = ACTIONS(3676),
    [anon_sym_try] = ACTIONS(3676),
    [anon_sym_match] = ACTIONS(3676),
    [anon_sym_match_BANG] = ACTIONS(3674),
    [anon_sym_function] = ACTIONS(3676),
    [anon_sym_LT_DASH] = ACTIONS(3676),
    [anon_sym_DOT_LBRACK] = ACTIONS(3674),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_GT] = ACTIONS(3676),
    [anon_sym_use] = ACTIONS(3676),
    [anon_sym_use_BANG] = ACTIONS(3674),
    [anon_sym_do_BANG] = ACTIONS(3674),
    [anon_sym_begin] = ACTIONS(3676),
    [anon_sym_LPAREN2] = ACTIONS(3676),
    [anon_sym_or] = ACTIONS(3676),
    [aux_sym_char_token1] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3676),
    [anon_sym_DQUOTE] = ACTIONS(3676),
    [anon_sym_AT_DQUOTE] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [sym_bool] = ACTIONS(3676),
    [sym_unit] = ACTIONS(3674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3676),
    [sym_op_identifier] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_PLUS_DOT] = ACTIONS(3676),
    [anon_sym_DASH_DOT] = ACTIONS(3676),
    [anon_sym_PERCENT] = ACTIONS(3676),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_TILDE] = ACTIONS(3674),
    [aux_sym_prefix_op_token1] = ACTIONS(3676),
    [aux_sym_infix_op_token1] = ACTIONS(3674),
    [aux_sym_infix_op_token2] = ACTIONS(3676),
    [anon_sym_PIPE_PIPE] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3676),
    [anon_sym_COLON_EQ] = ACTIONS(3674),
    [anon_sym_DOLLAR] = ACTIONS(3676),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3676),
    [sym_int] = ACTIONS(3676),
    [sym_xint] = ACTIONS(3674),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3674),
    [sym__newline] = ACTIONS(5432),
  },
  [2875] = {
    [sym_block_comment] = STATE(2875),
    [sym_compiler_directive_decl] = STATE(2875),
    [sym_fsi_directive_decl] = STATE(2875),
    [sym_preproc_line] = STATE(2875),
    [sym_identifier] = ACTIONS(3966),
    [anon_sym_EQ] = ACTIONS(3964),
    [anon_sym_COLON] = ACTIONS(3966),
    [anon_sym_return] = ACTIONS(3966),
    [anon_sym_do] = ACTIONS(3966),
    [anon_sym_let] = ACTIONS(3966),
    [anon_sym_let_BANG] = ACTIONS(3964),
    [anon_sym_as] = ACTIONS(3966),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COMMA] = ACTIONS(3964),
    [anon_sym_null] = ACTIONS(3966),
    [anon_sym_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(3964),
    [anon_sym_AMP] = ACTIONS(3966),
    [anon_sym_LBRACK] = ACTIONS(3966),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3964),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_LT_AT] = ACTIONS(3966),
    [anon_sym_LT_AT_AT] = ACTIONS(3966),
    [anon_sym_DOT] = ACTIONS(3966),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3964),
    [anon_sym_new] = ACTIONS(3966),
    [anon_sym_with] = ACTIONS(3966),
    [anon_sym_return_BANG] = ACTIONS(3964),
    [anon_sym_yield] = ACTIONS(3966),
    [anon_sym_yield_BANG] = ACTIONS(3964),
    [anon_sym_lazy] = ACTIONS(3966),
    [anon_sym_assert] = ACTIONS(3966),
    [anon_sym_upcast] = ACTIONS(3966),
    [anon_sym_downcast] = ACTIONS(3966),
    [anon_sym_COLON_GT] = ACTIONS(3964),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3964),
    [anon_sym_for] = ACTIONS(3966),
    [anon_sym_while] = ACTIONS(3966),
    [anon_sym_if] = ACTIONS(3966),
    [anon_sym_fun] = ACTIONS(3966),
    [anon_sym_try] = ACTIONS(3966),
    [anon_sym_match] = ACTIONS(3966),
    [anon_sym_match_BANG] = ACTIONS(3964),
    [anon_sym_function] = ACTIONS(3966),
    [anon_sym_LT_DASH] = ACTIONS(3966),
    [anon_sym_DOT_LBRACK] = ACTIONS(3964),
    [anon_sym_LT] = ACTIONS(3964),
    [anon_sym_use] = ACTIONS(3966),
    [anon_sym_use_BANG] = ACTIONS(3964),
    [anon_sym_do_BANG] = ACTIONS(3964),
    [anon_sym_begin] = ACTIONS(3966),
    [anon_sym_LPAREN2] = ACTIONS(3966),
    [anon_sym_or] = ACTIONS(3966),
    [aux_sym_char_token1] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3966),
    [anon_sym_DQUOTE] = ACTIONS(3966),
    [anon_sym_AT_DQUOTE] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [sym_bool] = ACTIONS(3966),
    [sym_unit] = ACTIONS(3964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3966),
    [sym_op_identifier] = ACTIONS(3966),
    [anon_sym_PLUS] = ACTIONS(3966),
    [anon_sym_DASH] = ACTIONS(3966),
    [anon_sym_PLUS_DOT] = ACTIONS(3966),
    [anon_sym_DASH_DOT] = ACTIONS(3966),
    [anon_sym_PERCENT] = ACTIONS(3966),
    [anon_sym_AMP_AMP] = ACTIONS(3966),
    [anon_sym_TILDE] = ACTIONS(3964),
    [aux_sym_prefix_op_token1] = ACTIONS(3966),
    [aux_sym_infix_op_token1] = ACTIONS(3964),
    [aux_sym_infix_op_token2] = ACTIONS(3966),
    [anon_sym_PIPE_PIPE] = ACTIONS(3966),
    [anon_sym_BANG_EQ] = ACTIONS(3966),
    [anon_sym_COLON_EQ] = ACTIONS(3964),
    [anon_sym_DOLLAR] = ACTIONS(3966),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3966),
    [sym_int] = ACTIONS(3966),
    [sym_xint] = ACTIONS(3964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3964),
    [sym__newline] = ACTIONS(3964),
    [sym__dedent] = ACTIONS(3964),
  },
  [2876] = {
    [sym_block_comment] = STATE(2876),
    [sym_compiler_directive_decl] = STATE(2876),
    [sym_fsi_directive_decl] = STATE(2876),
    [sym_preproc_line] = STATE(2876),
    [sym_identifier] = ACTIONS(3942),
    [anon_sym_EQ] = ACTIONS(3940),
    [anon_sym_COLON] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_let_BANG] = ACTIONS(3940),
    [anon_sym_as] = ACTIONS(3942),
    [anon_sym_LPAREN] = ACTIONS(3942),
    [anon_sym_COMMA] = ACTIONS(3940),
    [anon_sym_null] = ACTIONS(3942),
    [anon_sym_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3940),
    [anon_sym_LBRACE] = ACTIONS(3942),
    [anon_sym_LT_AT] = ACTIONS(3942),
    [anon_sym_LT_AT_AT] = ACTIONS(3942),
    [anon_sym_DOT] = ACTIONS(3942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3940),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_with] = ACTIONS(3942),
    [anon_sym_return_BANG] = ACTIONS(3940),
    [anon_sym_yield] = ACTIONS(3942),
    [anon_sym_yield_BANG] = ACTIONS(3940),
    [anon_sym_lazy] = ACTIONS(3942),
    [anon_sym_assert] = ACTIONS(3942),
    [anon_sym_upcast] = ACTIONS(3942),
    [anon_sym_downcast] = ACTIONS(3942),
    [anon_sym_COLON_GT] = ACTIONS(3940),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3940),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_fun] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_match] = ACTIONS(3942),
    [anon_sym_match_BANG] = ACTIONS(3940),
    [anon_sym_function] = ACTIONS(3942),
    [anon_sym_LT_DASH] = ACTIONS(3942),
    [anon_sym_DOT_LBRACK] = ACTIONS(3940),
    [anon_sym_LT] = ACTIONS(3940),
    [anon_sym_use] = ACTIONS(3942),
    [anon_sym_use_BANG] = ACTIONS(3940),
    [anon_sym_do_BANG] = ACTIONS(3940),
    [anon_sym_begin] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3942),
    [anon_sym_or] = ACTIONS(3942),
    [aux_sym_char_token1] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3942),
    [anon_sym_DQUOTE] = ACTIONS(3942),
    [anon_sym_AT_DQUOTE] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [sym_bool] = ACTIONS(3942),
    [sym_unit] = ACTIONS(3940),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3942),
    [sym_op_identifier] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS_DOT] = ACTIONS(3942),
    [anon_sym_DASH_DOT] = ACTIONS(3942),
    [anon_sym_PERCENT] = ACTIONS(3942),
    [anon_sym_AMP_AMP] = ACTIONS(3942),
    [anon_sym_TILDE] = ACTIONS(3940),
    [aux_sym_prefix_op_token1] = ACTIONS(3942),
    [aux_sym_infix_op_token1] = ACTIONS(3940),
    [aux_sym_infix_op_token2] = ACTIONS(3942),
    [anon_sym_PIPE_PIPE] = ACTIONS(3942),
    [anon_sym_BANG_EQ] = ACTIONS(3942),
    [anon_sym_COLON_EQ] = ACTIONS(3940),
    [anon_sym_DOLLAR] = ACTIONS(3942),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3942),
    [sym_int] = ACTIONS(3942),
    [sym_xint] = ACTIONS(3940),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3940),
    [sym__newline] = ACTIONS(3940),
    [sym__dedent] = ACTIONS(3940),
  },
  [2877] = {
    [sym_block_comment] = STATE(2877),
    [sym_compiler_directive_decl] = STATE(2877),
    [sym_fsi_directive_decl] = STATE(2877),
    [sym_preproc_line] = STATE(2877),
    [aux_sym_rules_repeat1] = STATE(2837),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(5401),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_AT_GT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_or] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(5429),
  },
  [2878] = {
    [sym_block_comment] = STATE(2878),
    [sym_compiler_directive_decl] = STATE(2878),
    [sym_fsi_directive_decl] = STATE(2878),
    [sym_preproc_line] = STATE(2878),
    [aux_sym_rules_repeat1] = STATE(2878),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(5435),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_GT] = ACTIONS(3743),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_or] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [sym__newline] = ACTIONS(5438),
  },
  [2879] = {
    [sym_block_comment] = STATE(2879),
    [sym_compiler_directive_decl] = STATE(2879),
    [sym_fsi_directive_decl] = STATE(2879),
    [sym_preproc_line] = STATE(2879),
    [aux_sym_long_identifier_repeat1] = STATE(2879),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(5441),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_DOT_DOT] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [2880] = {
    [sym_block_comment] = STATE(2880),
    [sym_compiler_directive_decl] = STATE(2880),
    [sym_fsi_directive_decl] = STATE(2880),
    [sym_preproc_line] = STATE(2880),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_as] = ACTIONS(3487),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
    [sym__dedent] = ACTIONS(3485),
  },
  [2881] = {
    [sym_block_comment] = STATE(2881),
    [sym_compiler_directive_decl] = STATE(2881),
    [sym_fsi_directive_decl] = STATE(2881),
    [sym_preproc_line] = STATE(2881),
    [sym_identifier] = ACTIONS(3931),
    [anon_sym_EQ] = ACTIONS(3929),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_do] = ACTIONS(3931),
    [anon_sym_let] = ACTIONS(3931),
    [anon_sym_let_BANG] = ACTIONS(3929),
    [anon_sym_as] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_COMMA] = ACTIONS(3929),
    [anon_sym_null] = ACTIONS(3931),
    [anon_sym_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_COLON] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3931),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_LT_AT] = ACTIONS(3931),
    [anon_sym_LT_AT_AT] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3931),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3929),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3931),
    [anon_sym_return_BANG] = ACTIONS(3929),
    [anon_sym_yield] = ACTIONS(3931),
    [anon_sym_yield_BANG] = ACTIONS(3929),
    [anon_sym_lazy] = ACTIONS(3931),
    [anon_sym_assert] = ACTIONS(3931),
    [anon_sym_upcast] = ACTIONS(3931),
    [anon_sym_downcast] = ACTIONS(3931),
    [anon_sym_COLON_GT] = ACTIONS(3929),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3929),
    [anon_sym_for] = ACTIONS(3931),
    [anon_sym_while] = ACTIONS(3931),
    [anon_sym_if] = ACTIONS(3931),
    [anon_sym_fun] = ACTIONS(3931),
    [anon_sym_try] = ACTIONS(3931),
    [anon_sym_match] = ACTIONS(3931),
    [anon_sym_match_BANG] = ACTIONS(3929),
    [anon_sym_function] = ACTIONS(3931),
    [anon_sym_LT_DASH] = ACTIONS(3931),
    [anon_sym_DOT_LBRACK] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_use] = ACTIONS(3931),
    [anon_sym_use_BANG] = ACTIONS(3929),
    [anon_sym_do_BANG] = ACTIONS(3929),
    [anon_sym_begin] = ACTIONS(3931),
    [anon_sym_LPAREN2] = ACTIONS(3931),
    [anon_sym_or] = ACTIONS(3931),
    [aux_sym_char_token1] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3931),
    [anon_sym_DQUOTE] = ACTIONS(3931),
    [anon_sym_AT_DQUOTE] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [sym_bool] = ACTIONS(3931),
    [sym_unit] = ACTIONS(3929),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3931),
    [sym_op_identifier] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3931),
    [anon_sym_DASH] = ACTIONS(3931),
    [anon_sym_PLUS_DOT] = ACTIONS(3931),
    [anon_sym_DASH_DOT] = ACTIONS(3931),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_TILDE] = ACTIONS(3929),
    [aux_sym_prefix_op_token1] = ACTIONS(3931),
    [aux_sym_infix_op_token1] = ACTIONS(3929),
    [aux_sym_infix_op_token2] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_COLON_EQ] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3931),
    [sym_int] = ACTIONS(3931),
    [sym_xint] = ACTIONS(3929),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3929),
    [sym__newline] = ACTIONS(3929),
    [sym__dedent] = ACTIONS(3929),
  },
  [2882] = {
    [sym_block_comment] = STATE(2882),
    [sym_compiler_directive_decl] = STATE(2882),
    [sym_fsi_directive_decl] = STATE(2882),
    [sym_preproc_line] = STATE(2882),
    [sym_identifier] = ACTIONS(3917),
    [anon_sym_EQ] = ACTIONS(3915),
    [anon_sym_COLON] = ACTIONS(3917),
    [anon_sym_return] = ACTIONS(3917),
    [anon_sym_do] = ACTIONS(3917),
    [anon_sym_let] = ACTIONS(3917),
    [anon_sym_let_BANG] = ACTIONS(3915),
    [anon_sym_as] = ACTIONS(3917),
    [anon_sym_LPAREN] = ACTIONS(3917),
    [anon_sym_COMMA] = ACTIONS(3915),
    [anon_sym_null] = ACTIONS(3917),
    [anon_sym_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_COLON] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(3917),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3915),
    [anon_sym_LBRACE] = ACTIONS(3917),
    [anon_sym_LT_AT] = ACTIONS(3917),
    [anon_sym_LT_AT_AT] = ACTIONS(3917),
    [anon_sym_DOT] = ACTIONS(3917),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3915),
    [anon_sym_new] = ACTIONS(3917),
    [anon_sym_with] = ACTIONS(3917),
    [anon_sym_return_BANG] = ACTIONS(3915),
    [anon_sym_yield] = ACTIONS(3917),
    [anon_sym_yield_BANG] = ACTIONS(3915),
    [anon_sym_lazy] = ACTIONS(3917),
    [anon_sym_assert] = ACTIONS(3917),
    [anon_sym_upcast] = ACTIONS(3917),
    [anon_sym_downcast] = ACTIONS(3917),
    [anon_sym_COLON_GT] = ACTIONS(3915),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3915),
    [anon_sym_for] = ACTIONS(3917),
    [anon_sym_while] = ACTIONS(3917),
    [anon_sym_if] = ACTIONS(3917),
    [anon_sym_fun] = ACTIONS(3917),
    [anon_sym_try] = ACTIONS(3917),
    [anon_sym_match] = ACTIONS(3917),
    [anon_sym_match_BANG] = ACTIONS(3915),
    [anon_sym_function] = ACTIONS(3917),
    [anon_sym_LT_DASH] = ACTIONS(3917),
    [anon_sym_DOT_LBRACK] = ACTIONS(3915),
    [anon_sym_LT] = ACTIONS(3915),
    [anon_sym_use] = ACTIONS(3917),
    [anon_sym_use_BANG] = ACTIONS(3915),
    [anon_sym_do_BANG] = ACTIONS(3915),
    [anon_sym_begin] = ACTIONS(3917),
    [anon_sym_LPAREN2] = ACTIONS(3917),
    [anon_sym_or] = ACTIONS(3917),
    [aux_sym_char_token1] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_AT_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [sym_bool] = ACTIONS(3917),
    [sym_unit] = ACTIONS(3915),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3917),
    [sym_op_identifier] = ACTIONS(3917),
    [anon_sym_PLUS] = ACTIONS(3917),
    [anon_sym_DASH] = ACTIONS(3917),
    [anon_sym_PLUS_DOT] = ACTIONS(3917),
    [anon_sym_DASH_DOT] = ACTIONS(3917),
    [anon_sym_PERCENT] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_TILDE] = ACTIONS(3915),
    [aux_sym_prefix_op_token1] = ACTIONS(3917),
    [aux_sym_infix_op_token1] = ACTIONS(3915),
    [aux_sym_infix_op_token2] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_BANG_EQ] = ACTIONS(3917),
    [anon_sym_COLON_EQ] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3917),
    [sym_int] = ACTIONS(3917),
    [sym_xint] = ACTIONS(3915),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3915),
    [sym__newline] = ACTIONS(3915),
    [sym__dedent] = ACTIONS(3915),
  },
  [2883] = {
    [sym_block_comment] = STATE(2883),
    [sym_compiler_directive_decl] = STATE(2883),
    [sym_fsi_directive_decl] = STATE(2883),
    [sym_preproc_line] = STATE(2883),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [anon_sym_as] = ACTIONS(4228),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_with] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
    [sym__dedent] = ACTIONS(4226),
  },
  [2884] = {
    [sym_block_comment] = STATE(2884),
    [sym_compiler_directive_decl] = STATE(2884),
    [sym_fsi_directive_decl] = STATE(2884),
    [sym_preproc_line] = STATE(2884),
    [sym_identifier] = ACTIONS(3881),
    [anon_sym_EQ] = ACTIONS(3879),
    [anon_sym_COLON] = ACTIONS(3881),
    [anon_sym_return] = ACTIONS(3881),
    [anon_sym_do] = ACTIONS(3881),
    [anon_sym_let] = ACTIONS(3881),
    [anon_sym_let_BANG] = ACTIONS(3879),
    [anon_sym_as] = ACTIONS(3881),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3879),
    [anon_sym_null] = ACTIONS(3881),
    [anon_sym_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3879),
    [anon_sym_LBRACE] = ACTIONS(3881),
    [anon_sym_LT_AT] = ACTIONS(3881),
    [anon_sym_LT_AT_AT] = ACTIONS(3881),
    [anon_sym_DOT] = ACTIONS(3881),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3879),
    [anon_sym_new] = ACTIONS(3881),
    [anon_sym_with] = ACTIONS(3881),
    [anon_sym_return_BANG] = ACTIONS(3879),
    [anon_sym_yield] = ACTIONS(3881),
    [anon_sym_yield_BANG] = ACTIONS(3879),
    [anon_sym_lazy] = ACTIONS(3881),
    [anon_sym_assert] = ACTIONS(3881),
    [anon_sym_upcast] = ACTIONS(3881),
    [anon_sym_downcast] = ACTIONS(3881),
    [anon_sym_COLON_GT] = ACTIONS(3879),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3879),
    [anon_sym_for] = ACTIONS(3881),
    [anon_sym_while] = ACTIONS(3881),
    [anon_sym_if] = ACTIONS(3881),
    [anon_sym_fun] = ACTIONS(3881),
    [anon_sym_try] = ACTIONS(3881),
    [anon_sym_match] = ACTIONS(3881),
    [anon_sym_match_BANG] = ACTIONS(3879),
    [anon_sym_function] = ACTIONS(3881),
    [anon_sym_LT_DASH] = ACTIONS(3881),
    [anon_sym_DOT_LBRACK] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_use] = ACTIONS(3881),
    [anon_sym_use_BANG] = ACTIONS(3879),
    [anon_sym_do_BANG] = ACTIONS(3879),
    [anon_sym_begin] = ACTIONS(3881),
    [anon_sym_LPAREN2] = ACTIONS(3881),
    [anon_sym_or] = ACTIONS(3881),
    [aux_sym_char_token1] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3881),
    [anon_sym_DQUOTE] = ACTIONS(3881),
    [anon_sym_AT_DQUOTE] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [sym_bool] = ACTIONS(3881),
    [sym_unit] = ACTIONS(3879),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3881),
    [sym_op_identifier] = ACTIONS(3881),
    [anon_sym_PLUS] = ACTIONS(3881),
    [anon_sym_DASH] = ACTIONS(3881),
    [anon_sym_PLUS_DOT] = ACTIONS(3881),
    [anon_sym_DASH_DOT] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(3881),
    [anon_sym_AMP_AMP] = ACTIONS(3881),
    [anon_sym_TILDE] = ACTIONS(3879),
    [aux_sym_prefix_op_token1] = ACTIONS(3881),
    [aux_sym_infix_op_token1] = ACTIONS(3879),
    [aux_sym_infix_op_token2] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE] = ACTIONS(3881),
    [anon_sym_BANG_EQ] = ACTIONS(3881),
    [anon_sym_COLON_EQ] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3881),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3881),
    [sym_int] = ACTIONS(3881),
    [sym_xint] = ACTIONS(3879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3879),
    [sym__newline] = ACTIONS(3879),
    [sym__dedent] = ACTIONS(3879),
  },
  [2885] = {
    [sym_block_comment] = STATE(2885),
    [sym_compiler_directive_decl] = STATE(2885),
    [sym_fsi_directive_decl] = STATE(2885),
    [sym_preproc_line] = STATE(2885),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [anon_sym_as] = ACTIONS(4228),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(5444),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_with] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
    [sym__dedent] = ACTIONS(4226),
  },
  [2886] = {
    [sym_block_comment] = STATE(2886),
    [sym_compiler_directive_decl] = STATE(2886),
    [sym_fsi_directive_decl] = STATE(2886),
    [sym_preproc_line] = STATE(2886),
    [sym_identifier] = ACTIONS(3753),
    [anon_sym_EQ] = ACTIONS(3751),
    [anon_sym_COLON] = ACTIONS(3753),
    [anon_sym_return] = ACTIONS(3753),
    [anon_sym_do] = ACTIONS(3753),
    [anon_sym_let] = ACTIONS(3753),
    [anon_sym_let_BANG] = ACTIONS(3751),
    [anon_sym_LPAREN] = ACTIONS(3753),
    [anon_sym_COMMA] = ACTIONS(3751),
    [anon_sym_null] = ACTIONS(3753),
    [anon_sym_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_COLON] = ACTIONS(3751),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3751),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_LT_AT] = ACTIONS(3753),
    [anon_sym_LT_AT_AT] = ACTIONS(3753),
    [anon_sym_AT_AT_GT] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3753),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3751),
    [anon_sym_new] = ACTIONS(3753),
    [anon_sym_return_BANG] = ACTIONS(3751),
    [anon_sym_yield] = ACTIONS(3753),
    [anon_sym_yield_BANG] = ACTIONS(3751),
    [anon_sym_lazy] = ACTIONS(3753),
    [anon_sym_assert] = ACTIONS(3753),
    [anon_sym_upcast] = ACTIONS(3753),
    [anon_sym_downcast] = ACTIONS(3753),
    [anon_sym_COLON_GT] = ACTIONS(3751),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3751),
    [anon_sym_for] = ACTIONS(3753),
    [anon_sym_while] = ACTIONS(3753),
    [anon_sym_if] = ACTIONS(3753),
    [anon_sym_fun] = ACTIONS(3753),
    [anon_sym_try] = ACTIONS(3753),
    [anon_sym_match] = ACTIONS(3753),
    [anon_sym_match_BANG] = ACTIONS(3751),
    [anon_sym_function] = ACTIONS(3753),
    [anon_sym_LT_DASH] = ACTIONS(3753),
    [anon_sym_DOT_LBRACK] = ACTIONS(3751),
    [anon_sym_LT] = ACTIONS(3751),
    [anon_sym_use] = ACTIONS(3753),
    [anon_sym_use_BANG] = ACTIONS(3751),
    [anon_sym_do_BANG] = ACTIONS(3751),
    [anon_sym_begin] = ACTIONS(3753),
    [anon_sym_LPAREN2] = ACTIONS(3753),
    [anon_sym_or] = ACTIONS(3753),
    [aux_sym_char_token1] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3753),
    [anon_sym_AT_DQUOTE] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [sym_bool] = ACTIONS(3753),
    [sym_unit] = ACTIONS(3751),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3753),
    [sym_op_identifier] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PLUS_DOT] = ACTIONS(3753),
    [anon_sym_DASH_DOT] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3753),
    [anon_sym_AMP_AMP] = ACTIONS(3753),
    [anon_sym_TILDE] = ACTIONS(3751),
    [aux_sym_prefix_op_token1] = ACTIONS(3753),
    [aux_sym_infix_op_token1] = ACTIONS(3751),
    [aux_sym_infix_op_token2] = ACTIONS(3753),
    [anon_sym_PIPE_PIPE] = ACTIONS(3753),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_COLON_EQ] = ACTIONS(3751),
    [anon_sym_DOLLAR] = ACTIONS(3753),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3753),
    [sym_int] = ACTIONS(5446),
    [sym_xint] = ACTIONS(3751),
    [anon_sym_f] = ACTIONS(3753),
    [aux_sym_decimal_token1] = ACTIONS(3753),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3751),
    [sym__newline] = ACTIONS(3751),
  },
  [2887] = {
    [sym_block_comment] = STATE(2887),
    [sym_compiler_directive_decl] = STATE(2887),
    [sym_fsi_directive_decl] = STATE(2887),
    [sym_preproc_line] = STATE(2887),
    [sym_identifier] = ACTIONS(3813),
    [anon_sym_EQ] = ACTIONS(3811),
    [anon_sym_COLON] = ACTIONS(3813),
    [anon_sym_return] = ACTIONS(3813),
    [anon_sym_do] = ACTIONS(3813),
    [anon_sym_let] = ACTIONS(3813),
    [anon_sym_let_BANG] = ACTIONS(3811),
    [anon_sym_as] = ACTIONS(3813),
    [anon_sym_LPAREN] = ACTIONS(3813),
    [anon_sym_COMMA] = ACTIONS(3811),
    [anon_sym_null] = ACTIONS(3813),
    [anon_sym_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_COLON] = ACTIONS(3811),
    [anon_sym_AMP] = ACTIONS(3813),
    [anon_sym_LBRACK] = ACTIONS(3813),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3811),
    [anon_sym_LBRACE] = ACTIONS(3813),
    [anon_sym_LT_AT] = ACTIONS(3813),
    [anon_sym_LT_AT_AT] = ACTIONS(3813),
    [anon_sym_DOT] = ACTIONS(3813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3811),
    [anon_sym_new] = ACTIONS(3813),
    [anon_sym_with] = ACTIONS(3813),
    [anon_sym_return_BANG] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_yield_BANG] = ACTIONS(3811),
    [anon_sym_lazy] = ACTIONS(3813),
    [anon_sym_assert] = ACTIONS(3813),
    [anon_sym_upcast] = ACTIONS(3813),
    [anon_sym_downcast] = ACTIONS(3813),
    [anon_sym_COLON_GT] = ACTIONS(3811),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3811),
    [anon_sym_for] = ACTIONS(3813),
    [anon_sym_done] = ACTIONS(5448),
    [anon_sym_while] = ACTIONS(3813),
    [anon_sym_if] = ACTIONS(3813),
    [anon_sym_fun] = ACTIONS(3813),
    [anon_sym_try] = ACTIONS(3813),
    [anon_sym_match] = ACTIONS(3813),
    [anon_sym_match_BANG] = ACTIONS(3811),
    [anon_sym_function] = ACTIONS(3813),
    [anon_sym_LT_DASH] = ACTIONS(3813),
    [anon_sym_DOT_LBRACK] = ACTIONS(3811),
    [anon_sym_LT] = ACTIONS(3811),
    [anon_sym_use] = ACTIONS(3813),
    [anon_sym_use_BANG] = ACTIONS(3811),
    [anon_sym_do_BANG] = ACTIONS(3811),
    [anon_sym_begin] = ACTIONS(3813),
    [anon_sym_LPAREN2] = ACTIONS(3813),
    [anon_sym_or] = ACTIONS(3813),
    [aux_sym_char_token1] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3813),
    [anon_sym_DQUOTE] = ACTIONS(3813),
    [anon_sym_AT_DQUOTE] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [sym_bool] = ACTIONS(3813),
    [sym_unit] = ACTIONS(3811),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3813),
    [sym_op_identifier] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PLUS_DOT] = ACTIONS(3813),
    [anon_sym_DASH_DOT] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3813),
    [anon_sym_AMP_AMP] = ACTIONS(3813),
    [anon_sym_TILDE] = ACTIONS(3811),
    [aux_sym_prefix_op_token1] = ACTIONS(3813),
    [aux_sym_infix_op_token1] = ACTIONS(3811),
    [aux_sym_infix_op_token2] = ACTIONS(3813),
    [anon_sym_PIPE_PIPE] = ACTIONS(3813),
    [anon_sym_BANG_EQ] = ACTIONS(3813),
    [anon_sym_COLON_EQ] = ACTIONS(3811),
    [anon_sym_DOLLAR] = ACTIONS(3813),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3813),
    [sym_int] = ACTIONS(3813),
    [sym_xint] = ACTIONS(3811),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3811),
    [sym__newline] = ACTIONS(3811),
  },
  [2888] = {
    [sym_block_comment] = STATE(2888),
    [sym_compiler_directive_decl] = STATE(2888),
    [sym_fsi_directive_decl] = STATE(2888),
    [sym_preproc_line] = STATE(2888),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(5393),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_DASH_GT] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_DOT_DOT] = ACTIONS(3683),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
  },
  [2889] = {
    [sym_block_comment] = STATE(2889),
    [sym_compiler_directive_decl] = STATE(2889),
    [sym_fsi_directive_decl] = STATE(2889),
    [sym_preproc_line] = STATE(2889),
    [sym_identifier] = ACTIONS(3907),
    [anon_sym_EQ] = ACTIONS(3905),
    [anon_sym_COLON] = ACTIONS(3907),
    [anon_sym_return] = ACTIONS(3907),
    [anon_sym_do] = ACTIONS(3907),
    [anon_sym_let] = ACTIONS(3907),
    [anon_sym_let_BANG] = ACTIONS(3905),
    [anon_sym_as] = ACTIONS(3907),
    [anon_sym_LPAREN] = ACTIONS(3907),
    [anon_sym_COMMA] = ACTIONS(3905),
    [anon_sym_null] = ACTIONS(3907),
    [anon_sym_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_COLON] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3907),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3905),
    [anon_sym_LBRACE] = ACTIONS(3907),
    [anon_sym_LT_AT] = ACTIONS(3907),
    [anon_sym_LT_AT_AT] = ACTIONS(3907),
    [anon_sym_DOT] = ACTIONS(3907),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3905),
    [anon_sym_new] = ACTIONS(3907),
    [anon_sym_with] = ACTIONS(3907),
    [anon_sym_return_BANG] = ACTIONS(3905),
    [anon_sym_yield] = ACTIONS(3907),
    [anon_sym_yield_BANG] = ACTIONS(3905),
    [anon_sym_lazy] = ACTIONS(3907),
    [anon_sym_assert] = ACTIONS(3907),
    [anon_sym_upcast] = ACTIONS(3907),
    [anon_sym_downcast] = ACTIONS(3907),
    [anon_sym_COLON_GT] = ACTIONS(3905),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3905),
    [anon_sym_for] = ACTIONS(3907),
    [anon_sym_while] = ACTIONS(3907),
    [anon_sym_if] = ACTIONS(3907),
    [anon_sym_fun] = ACTIONS(3907),
    [anon_sym_try] = ACTIONS(3907),
    [anon_sym_match] = ACTIONS(3907),
    [anon_sym_match_BANG] = ACTIONS(3905),
    [anon_sym_function] = ACTIONS(3907),
    [anon_sym_LT_DASH] = ACTIONS(3907),
    [anon_sym_DOT_LBRACK] = ACTIONS(3905),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_use] = ACTIONS(3907),
    [anon_sym_use_BANG] = ACTIONS(3905),
    [anon_sym_do_BANG] = ACTIONS(3905),
    [anon_sym_begin] = ACTIONS(3907),
    [anon_sym_LPAREN2] = ACTIONS(3907),
    [anon_sym_or] = ACTIONS(3907),
    [aux_sym_char_token1] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3907),
    [anon_sym_DQUOTE] = ACTIONS(3907),
    [anon_sym_AT_DQUOTE] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [sym_bool] = ACTIONS(3907),
    [sym_unit] = ACTIONS(3905),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3907),
    [sym_op_identifier] = ACTIONS(3907),
    [anon_sym_PLUS] = ACTIONS(3907),
    [anon_sym_DASH] = ACTIONS(3907),
    [anon_sym_PLUS_DOT] = ACTIONS(3907),
    [anon_sym_DASH_DOT] = ACTIONS(3907),
    [anon_sym_PERCENT] = ACTIONS(3907),
    [anon_sym_AMP_AMP] = ACTIONS(3907),
    [anon_sym_TILDE] = ACTIONS(3905),
    [aux_sym_prefix_op_token1] = ACTIONS(3907),
    [aux_sym_infix_op_token1] = ACTIONS(3905),
    [aux_sym_infix_op_token2] = ACTIONS(3907),
    [anon_sym_PIPE_PIPE] = ACTIONS(3907),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_COLON_EQ] = ACTIONS(3905),
    [anon_sym_DOLLAR] = ACTIONS(3907),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3907),
    [sym_int] = ACTIONS(3907),
    [sym_xint] = ACTIONS(3905),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3905),
    [sym__newline] = ACTIONS(3905),
    [sym__dedent] = ACTIONS(3905),
  },
  [2890] = {
    [sym_block_comment] = STATE(2890),
    [sym_compiler_directive_decl] = STATE(2890),
    [sym_fsi_directive_decl] = STATE(2890),
    [sym_preproc_line] = STATE(2890),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_EQ] = ACTIONS(3646),
    [anon_sym_COLON] = ACTIONS(3648),
    [anon_sym_return] = ACTIONS(3648),
    [anon_sym_do] = ACTIONS(3648),
    [anon_sym_let] = ACTIONS(3648),
    [anon_sym_let_BANG] = ACTIONS(3646),
    [anon_sym_LPAREN] = ACTIONS(3648),
    [anon_sym_COMMA] = ACTIONS(3646),
    [anon_sym_null] = ACTIONS(3648),
    [anon_sym_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_QMARK] = ACTIONS(3648),
    [anon_sym_COLON_COLON] = ACTIONS(3646),
    [anon_sym_AMP] = ACTIONS(3648),
    [anon_sym_LBRACK] = ACTIONS(3648),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3646),
    [anon_sym_LBRACE] = ACTIONS(3648),
    [anon_sym_LT_AT] = ACTIONS(3648),
    [anon_sym_AT_GT] = ACTIONS(3648),
    [anon_sym_LT_AT_AT] = ACTIONS(3648),
    [anon_sym_DOT] = ACTIONS(3648),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3646),
    [anon_sym_new] = ACTIONS(3648),
    [anon_sym_return_BANG] = ACTIONS(3646),
    [anon_sym_yield] = ACTIONS(3648),
    [anon_sym_yield_BANG] = ACTIONS(3646),
    [anon_sym_lazy] = ACTIONS(3648),
    [anon_sym_assert] = ACTIONS(3648),
    [anon_sym_upcast] = ACTIONS(3648),
    [anon_sym_downcast] = ACTIONS(3648),
    [anon_sym_COLON_GT] = ACTIONS(3646),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3646),
    [anon_sym_for] = ACTIONS(3648),
    [anon_sym_while] = ACTIONS(3648),
    [anon_sym_else] = ACTIONS(3648),
    [anon_sym_elif] = ACTIONS(3648),
    [anon_sym_if] = ACTIONS(3648),
    [anon_sym_fun] = ACTIONS(3648),
    [anon_sym_try] = ACTIONS(3648),
    [anon_sym_match] = ACTIONS(3648),
    [anon_sym_match_BANG] = ACTIONS(3646),
    [anon_sym_function] = ACTIONS(3648),
    [anon_sym_LT_DASH] = ACTIONS(3648),
    [anon_sym_DOT_LBRACK] = ACTIONS(3646),
    [anon_sym_LT] = ACTIONS(3646),
    [anon_sym_use] = ACTIONS(3648),
    [anon_sym_use_BANG] = ACTIONS(3646),
    [anon_sym_do_BANG] = ACTIONS(3646),
    [anon_sym_begin] = ACTIONS(3648),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_or] = ACTIONS(3648),
    [aux_sym_char_token1] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3648),
    [anon_sym_AT_DQUOTE] = ACTIONS(3646),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3646),
    [sym_bool] = ACTIONS(3648),
    [sym_unit] = ACTIONS(3646),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3648),
    [sym_op_identifier] = ACTIONS(3648),
    [anon_sym_PLUS] = ACTIONS(3648),
    [anon_sym_DASH] = ACTIONS(3648),
    [anon_sym_PLUS_DOT] = ACTIONS(3648),
    [anon_sym_DASH_DOT] = ACTIONS(3648),
    [anon_sym_PERCENT] = ACTIONS(3648),
    [anon_sym_AMP_AMP] = ACTIONS(3648),
    [anon_sym_TILDE] = ACTIONS(3646),
    [aux_sym_prefix_op_token1] = ACTIONS(3648),
    [aux_sym_infix_op_token1] = ACTIONS(3646),
    [aux_sym_infix_op_token2] = ACTIONS(3648),
    [anon_sym_PIPE_PIPE] = ACTIONS(3648),
    [anon_sym_BANG_EQ] = ACTIONS(3648),
    [anon_sym_COLON_EQ] = ACTIONS(3646),
    [anon_sym_DOLLAR] = ACTIONS(3648),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3648),
    [sym_int] = ACTIONS(3648),
    [sym_xint] = ACTIONS(3646),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3646),
    [sym__newline] = ACTIONS(3646),
  },
  [2891] = {
    [sym_block_comment] = STATE(2891),
    [sym_compiler_directive_decl] = STATE(2891),
    [sym_fsi_directive_decl] = STATE(2891),
    [sym_preproc_line] = STATE(2891),
    [aux_sym_long_identifier_repeat1] = STATE(2926),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [anon_sym_as] = ACTIONS(3451),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(5450),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_or] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
  },
  [2892] = {
    [sym_block_comment] = STATE(2892),
    [sym_compiler_directive_decl] = STATE(2892),
    [sym_fsi_directive_decl] = STATE(2892),
    [sym_preproc_line] = STATE(2892),
    [aux_sym_sequential_expression_repeat1] = STATE(2892),
    [sym_identifier] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3765),
    [anon_sym_COLON] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_let_BANG] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(3767),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_null] = ACTIONS(3767),
    [anon_sym_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3765),
    [anon_sym_LBRACE] = ACTIONS(3767),
    [anon_sym_LT_AT] = ACTIONS(3767),
    [anon_sym_LT_AT_AT] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3765),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_with] = ACTIONS(3767),
    [anon_sym_return_BANG] = ACTIONS(3765),
    [anon_sym_yield] = ACTIONS(3767),
    [anon_sym_yield_BANG] = ACTIONS(3765),
    [anon_sym_lazy] = ACTIONS(3767),
    [anon_sym_assert] = ACTIONS(3767),
    [anon_sym_upcast] = ACTIONS(3767),
    [anon_sym_downcast] = ACTIONS(3767),
    [anon_sym_COLON_GT] = ACTIONS(3765),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3765),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_fun] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_match] = ACTIONS(3767),
    [anon_sym_match_BANG] = ACTIONS(3765),
    [anon_sym_function] = ACTIONS(3767),
    [anon_sym_LT_DASH] = ACTIONS(3767),
    [anon_sym_DOT_LBRACK] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(3765),
    [anon_sym_use] = ACTIONS(3767),
    [anon_sym_use_BANG] = ACTIONS(3765),
    [anon_sym_do_BANG] = ACTIONS(3765),
    [anon_sym_begin] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3767),
    [anon_sym_or] = ACTIONS(3767),
    [aux_sym_char_token1] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3767),
    [anon_sym_DQUOTE] = ACTIONS(3767),
    [anon_sym_AT_DQUOTE] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [sym_bool] = ACTIONS(3767),
    [sym_unit] = ACTIONS(3765),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3767),
    [sym_op_identifier] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_PLUS_DOT] = ACTIONS(3767),
    [anon_sym_DASH_DOT] = ACTIONS(3767),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_AMP_AMP] = ACTIONS(3767),
    [anon_sym_TILDE] = ACTIONS(3765),
    [aux_sym_prefix_op_token1] = ACTIONS(3767),
    [aux_sym_infix_op_token1] = ACTIONS(3765),
    [aux_sym_infix_op_token2] = ACTIONS(3767),
    [anon_sym_PIPE_PIPE] = ACTIONS(3767),
    [anon_sym_BANG_EQ] = ACTIONS(3767),
    [anon_sym_COLON_EQ] = ACTIONS(3765),
    [anon_sym_DOLLAR] = ACTIONS(3767),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3767),
    [sym_int] = ACTIONS(3767),
    [sym_xint] = ACTIONS(3765),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3765),
    [sym__newline] = ACTIONS(5452),
    [sym__dedent] = ACTIONS(3765),
  },
  [2893] = {
    [sym_block_comment] = STATE(2893),
    [sym_compiler_directive_decl] = STATE(2893),
    [sym_fsi_directive_decl] = STATE(2893),
    [sym_preproc_line] = STATE(2893),
    [aux_sym_sequential_expression_repeat1] = STATE(2893),
    [sym_identifier] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3765),
    [anon_sym_COLON] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_let_BANG] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(3767),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_null] = ACTIONS(3767),
    [anon_sym_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_RBRACK] = ACTIONS(3765),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3765),
    [anon_sym_LBRACE] = ACTIONS(3767),
    [anon_sym_LT_AT] = ACTIONS(3767),
    [anon_sym_LT_AT_AT] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3765),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_return_BANG] = ACTIONS(3765),
    [anon_sym_yield] = ACTIONS(3767),
    [anon_sym_yield_BANG] = ACTIONS(3765),
    [anon_sym_lazy] = ACTIONS(3767),
    [anon_sym_assert] = ACTIONS(3767),
    [anon_sym_upcast] = ACTIONS(3767),
    [anon_sym_downcast] = ACTIONS(3767),
    [anon_sym_COLON_GT] = ACTIONS(3765),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3765),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_fun] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_match] = ACTIONS(3767),
    [anon_sym_match_BANG] = ACTIONS(3765),
    [anon_sym_function] = ACTIONS(3767),
    [anon_sym_LT_DASH] = ACTIONS(3767),
    [anon_sym_DOT_LBRACK] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(3765),
    [anon_sym_use] = ACTIONS(3767),
    [anon_sym_use_BANG] = ACTIONS(3765),
    [anon_sym_do_BANG] = ACTIONS(3765),
    [anon_sym_begin] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3767),
    [anon_sym_DOT_DOT2] = ACTIONS(3765),
    [anon_sym_or] = ACTIONS(3767),
    [aux_sym_char_token1] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3767),
    [anon_sym_DQUOTE] = ACTIONS(3767),
    [anon_sym_AT_DQUOTE] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [sym_bool] = ACTIONS(3767),
    [sym_unit] = ACTIONS(3765),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3767),
    [sym_op_identifier] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_PLUS_DOT] = ACTIONS(3767),
    [anon_sym_DASH_DOT] = ACTIONS(3767),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_AMP_AMP] = ACTIONS(3767),
    [anon_sym_TILDE] = ACTIONS(3765),
    [aux_sym_prefix_op_token1] = ACTIONS(3767),
    [aux_sym_infix_op_token1] = ACTIONS(3765),
    [aux_sym_infix_op_token2] = ACTIONS(3767),
    [anon_sym_PIPE_PIPE] = ACTIONS(3767),
    [anon_sym_BANG_EQ] = ACTIONS(3767),
    [anon_sym_COLON_EQ] = ACTIONS(3765),
    [anon_sym_DOLLAR] = ACTIONS(3767),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3767),
    [sym_int] = ACTIONS(3767),
    [sym_xint] = ACTIONS(3765),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3765),
    [sym__newline] = ACTIONS(5455),
  },
  [2894] = {
    [sym_block_comment] = STATE(2894),
    [sym_compiler_directive_decl] = STATE(2894),
    [sym_fsi_directive_decl] = STATE(2894),
    [sym_preproc_line] = STATE(2894),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_AT_GT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
  },
  [2895] = {
    [sym_block_comment] = STATE(2895),
    [sym_compiler_directive_decl] = STATE(2895),
    [sym_fsi_directive_decl] = STATE(2895),
    [sym_preproc_line] = STATE(2895),
    [sym_identifier] = ACTIONS(3900),
    [anon_sym_EQ] = ACTIONS(3898),
    [anon_sym_COLON] = ACTIONS(3900),
    [anon_sym_return] = ACTIONS(3900),
    [anon_sym_do] = ACTIONS(3900),
    [anon_sym_let] = ACTIONS(3900),
    [anon_sym_let_BANG] = ACTIONS(3898),
    [anon_sym_as] = ACTIONS(3900),
    [anon_sym_LPAREN] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3898),
    [anon_sym_null] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_COLON] = ACTIONS(3898),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_LBRACK] = ACTIONS(3900),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3898),
    [anon_sym_LBRACE] = ACTIONS(3900),
    [anon_sym_LT_AT] = ACTIONS(3900),
    [anon_sym_LT_AT_AT] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(3900),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3898),
    [anon_sym_new] = ACTIONS(3900),
    [anon_sym_with] = ACTIONS(3900),
    [anon_sym_return_BANG] = ACTIONS(3898),
    [anon_sym_yield] = ACTIONS(3900),
    [anon_sym_yield_BANG] = ACTIONS(3898),
    [anon_sym_lazy] = ACTIONS(3900),
    [anon_sym_assert] = ACTIONS(3900),
    [anon_sym_upcast] = ACTIONS(3900),
    [anon_sym_downcast] = ACTIONS(3900),
    [anon_sym_COLON_GT] = ACTIONS(3898),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3898),
    [anon_sym_for] = ACTIONS(3900),
    [anon_sym_while] = ACTIONS(3900),
    [anon_sym_if] = ACTIONS(3900),
    [anon_sym_fun] = ACTIONS(3900),
    [anon_sym_try] = ACTIONS(3900),
    [anon_sym_match] = ACTIONS(3900),
    [anon_sym_match_BANG] = ACTIONS(3898),
    [anon_sym_function] = ACTIONS(3900),
    [anon_sym_LT_DASH] = ACTIONS(3900),
    [anon_sym_DOT_LBRACK] = ACTIONS(3898),
    [anon_sym_LT] = ACTIONS(3898),
    [anon_sym_use] = ACTIONS(3900),
    [anon_sym_use_BANG] = ACTIONS(3898),
    [anon_sym_do_BANG] = ACTIONS(3898),
    [anon_sym_begin] = ACTIONS(3900),
    [anon_sym_LPAREN2] = ACTIONS(3900),
    [anon_sym_or] = ACTIONS(3900),
    [aux_sym_char_token1] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3900),
    [anon_sym_DQUOTE] = ACTIONS(3900),
    [anon_sym_AT_DQUOTE] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3898),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3900),
    [sym_op_identifier] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(3900),
    [anon_sym_DASH] = ACTIONS(3900),
    [anon_sym_PLUS_DOT] = ACTIONS(3900),
    [anon_sym_DASH_DOT] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(3900),
    [anon_sym_AMP_AMP] = ACTIONS(3900),
    [anon_sym_TILDE] = ACTIONS(3898),
    [aux_sym_prefix_op_token1] = ACTIONS(3900),
    [aux_sym_infix_op_token1] = ACTIONS(3898),
    [aux_sym_infix_op_token2] = ACTIONS(3900),
    [anon_sym_PIPE_PIPE] = ACTIONS(3900),
    [anon_sym_BANG_EQ] = ACTIONS(3900),
    [anon_sym_COLON_EQ] = ACTIONS(3898),
    [anon_sym_DOLLAR] = ACTIONS(3900),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3900),
    [sym_int] = ACTIONS(3900),
    [sym_xint] = ACTIONS(3898),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3898),
    [sym__newline] = ACTIONS(3898),
    [sym__dedent] = ACTIONS(3898),
  },
  [2896] = {
    [sym_block_comment] = STATE(2896),
    [sym_compiler_directive_decl] = STATE(2896),
    [sym_fsi_directive_decl] = STATE(2896),
    [sym_preproc_line] = STATE(2896),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_AT_GT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(5458),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_DOT_DOT] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
  },
  [2897] = {
    [sym_block_comment] = STATE(2897),
    [sym_compiler_directive_decl] = STATE(2897),
    [sym_fsi_directive_decl] = STATE(2897),
    [sym_preproc_line] = STATE(2897),
    [sym_identifier] = ACTIONS(4130),
    [anon_sym_EQ] = ACTIONS(4128),
    [anon_sym_COLON] = ACTIONS(4130),
    [anon_sym_return] = ACTIONS(4130),
    [anon_sym_do] = ACTIONS(4130),
    [anon_sym_let] = ACTIONS(4130),
    [anon_sym_let_BANG] = ACTIONS(4128),
    [anon_sym_as] = ACTIONS(4130),
    [anon_sym_LPAREN] = ACTIONS(4130),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_null] = ACTIONS(4130),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_COLON] = ACTIONS(4128),
    [anon_sym_AMP] = ACTIONS(4130),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4128),
    [anon_sym_LBRACE] = ACTIONS(4130),
    [anon_sym_LT_AT] = ACTIONS(4130),
    [anon_sym_LT_AT_AT] = ACTIONS(4130),
    [anon_sym_DOT] = ACTIONS(4130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4128),
    [anon_sym_new] = ACTIONS(4130),
    [anon_sym_with] = ACTIONS(4130),
    [anon_sym_return_BANG] = ACTIONS(4128),
    [anon_sym_yield] = ACTIONS(4130),
    [anon_sym_yield_BANG] = ACTIONS(4128),
    [anon_sym_lazy] = ACTIONS(4130),
    [anon_sym_assert] = ACTIONS(4130),
    [anon_sym_upcast] = ACTIONS(4130),
    [anon_sym_downcast] = ACTIONS(4130),
    [anon_sym_COLON_GT] = ACTIONS(4128),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4128),
    [anon_sym_for] = ACTIONS(4130),
    [anon_sym_while] = ACTIONS(4130),
    [anon_sym_if] = ACTIONS(4130),
    [anon_sym_fun] = ACTIONS(4130),
    [anon_sym_try] = ACTIONS(4130),
    [anon_sym_match] = ACTIONS(4130),
    [anon_sym_match_BANG] = ACTIONS(4128),
    [anon_sym_function] = ACTIONS(4130),
    [anon_sym_LT_DASH] = ACTIONS(4130),
    [anon_sym_DOT_LBRACK] = ACTIONS(4128),
    [anon_sym_LT] = ACTIONS(4128),
    [anon_sym_use] = ACTIONS(4130),
    [anon_sym_use_BANG] = ACTIONS(4128),
    [anon_sym_do_BANG] = ACTIONS(4128),
    [anon_sym_begin] = ACTIONS(4130),
    [anon_sym_LPAREN2] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [aux_sym_char_token1] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4130),
    [anon_sym_DQUOTE] = ACTIONS(4130),
    [anon_sym_AT_DQUOTE] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [sym_bool] = ACTIONS(4130),
    [sym_unit] = ACTIONS(4128),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4130),
    [sym_op_identifier] = ACTIONS(4130),
    [anon_sym_PLUS] = ACTIONS(4130),
    [anon_sym_DASH] = ACTIONS(4130),
    [anon_sym_PLUS_DOT] = ACTIONS(4130),
    [anon_sym_DASH_DOT] = ACTIONS(4130),
    [anon_sym_PERCENT] = ACTIONS(4130),
    [anon_sym_AMP_AMP] = ACTIONS(4130),
    [anon_sym_TILDE] = ACTIONS(4128),
    [aux_sym_prefix_op_token1] = ACTIONS(4130),
    [aux_sym_infix_op_token1] = ACTIONS(4128),
    [aux_sym_infix_op_token2] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE] = ACTIONS(4130),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_COLON_EQ] = ACTIONS(4128),
    [anon_sym_DOLLAR] = ACTIONS(4130),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4130),
    [sym_int] = ACTIONS(4130),
    [sym_xint] = ACTIONS(4128),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4128),
    [sym__newline] = ACTIONS(4128),
    [sym__dedent] = ACTIONS(4128),
  },
  [2898] = {
    [sym_block_comment] = STATE(2898),
    [sym_compiler_directive_decl] = STATE(2898),
    [sym_fsi_directive_decl] = STATE(2898),
    [sym_preproc_line] = STATE(2898),
    [sym_identifier] = ACTIONS(3885),
    [anon_sym_EQ] = ACTIONS(3883),
    [anon_sym_COLON] = ACTIONS(3885),
    [anon_sym_return] = ACTIONS(3885),
    [anon_sym_do] = ACTIONS(3885),
    [anon_sym_let] = ACTIONS(3885),
    [anon_sym_let_BANG] = ACTIONS(3883),
    [anon_sym_as] = ACTIONS(3885),
    [anon_sym_LPAREN] = ACTIONS(3885),
    [anon_sym_COMMA] = ACTIONS(3883),
    [anon_sym_null] = ACTIONS(3885),
    [anon_sym_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3883),
    [anon_sym_AMP] = ACTIONS(3885),
    [anon_sym_LBRACK] = ACTIONS(3885),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3883),
    [anon_sym_LBRACE] = ACTIONS(3885),
    [anon_sym_LT_AT] = ACTIONS(3885),
    [anon_sym_LT_AT_AT] = ACTIONS(3885),
    [anon_sym_DOT] = ACTIONS(3885),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3883),
    [anon_sym_new] = ACTIONS(3885),
    [anon_sym_with] = ACTIONS(3885),
    [anon_sym_return_BANG] = ACTIONS(3883),
    [anon_sym_yield] = ACTIONS(3885),
    [anon_sym_yield_BANG] = ACTIONS(3883),
    [anon_sym_lazy] = ACTIONS(3885),
    [anon_sym_assert] = ACTIONS(3885),
    [anon_sym_upcast] = ACTIONS(3885),
    [anon_sym_downcast] = ACTIONS(3885),
    [anon_sym_COLON_GT] = ACTIONS(3883),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3883),
    [anon_sym_for] = ACTIONS(3885),
    [anon_sym_while] = ACTIONS(3885),
    [anon_sym_if] = ACTIONS(3885),
    [anon_sym_fun] = ACTIONS(3885),
    [anon_sym_try] = ACTIONS(3885),
    [anon_sym_match] = ACTIONS(3885),
    [anon_sym_match_BANG] = ACTIONS(3883),
    [anon_sym_function] = ACTIONS(3885),
    [anon_sym_LT_DASH] = ACTIONS(3885),
    [anon_sym_DOT_LBRACK] = ACTIONS(3883),
    [anon_sym_LT] = ACTIONS(3883),
    [anon_sym_use] = ACTIONS(3885),
    [anon_sym_use_BANG] = ACTIONS(3883),
    [anon_sym_do_BANG] = ACTIONS(3883),
    [anon_sym_begin] = ACTIONS(3885),
    [anon_sym_LPAREN2] = ACTIONS(3885),
    [anon_sym_or] = ACTIONS(3885),
    [aux_sym_char_token1] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3885),
    [anon_sym_DQUOTE] = ACTIONS(3885),
    [anon_sym_AT_DQUOTE] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [sym_bool] = ACTIONS(3885),
    [sym_unit] = ACTIONS(3883),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3885),
    [sym_op_identifier] = ACTIONS(3885),
    [anon_sym_PLUS] = ACTIONS(3885),
    [anon_sym_DASH] = ACTIONS(3885),
    [anon_sym_PLUS_DOT] = ACTIONS(3885),
    [anon_sym_DASH_DOT] = ACTIONS(3885),
    [anon_sym_PERCENT] = ACTIONS(3885),
    [anon_sym_AMP_AMP] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3883),
    [aux_sym_prefix_op_token1] = ACTIONS(3885),
    [aux_sym_infix_op_token1] = ACTIONS(3883),
    [aux_sym_infix_op_token2] = ACTIONS(3885),
    [anon_sym_PIPE_PIPE] = ACTIONS(3885),
    [anon_sym_BANG_EQ] = ACTIONS(3885),
    [anon_sym_COLON_EQ] = ACTIONS(3883),
    [anon_sym_DOLLAR] = ACTIONS(3885),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3885),
    [sym_int] = ACTIONS(3885),
    [sym_xint] = ACTIONS(3883),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3883),
    [sym__newline] = ACTIONS(3883),
    [sym__dedent] = ACTIONS(3883),
  },
  [2899] = {
    [sym_block_comment] = STATE(2899),
    [sym_compiler_directive_decl] = STATE(2899),
    [sym_fsi_directive_decl] = STATE(2899),
    [sym_preproc_line] = STATE(2899),
    [sym_identifier] = ACTIONS(3935),
    [anon_sym_EQ] = ACTIONS(3933),
    [anon_sym_COLON] = ACTIONS(3935),
    [anon_sym_return] = ACTIONS(3935),
    [anon_sym_do] = ACTIONS(3935),
    [anon_sym_let] = ACTIONS(3935),
    [anon_sym_let_BANG] = ACTIONS(3933),
    [anon_sym_as] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3935),
    [anon_sym_COMMA] = ACTIONS(3933),
    [anon_sym_null] = ACTIONS(3935),
    [anon_sym_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3935),
    [anon_sym_LBRACK] = ACTIONS(3935),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3933),
    [anon_sym_LBRACE] = ACTIONS(3935),
    [anon_sym_LT_AT] = ACTIONS(3935),
    [anon_sym_LT_AT_AT] = ACTIONS(3935),
    [anon_sym_DOT] = ACTIONS(3935),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3933),
    [anon_sym_new] = ACTIONS(3935),
    [anon_sym_with] = ACTIONS(3935),
    [anon_sym_return_BANG] = ACTIONS(3933),
    [anon_sym_yield] = ACTIONS(3935),
    [anon_sym_yield_BANG] = ACTIONS(3933),
    [anon_sym_lazy] = ACTIONS(3935),
    [anon_sym_assert] = ACTIONS(3935),
    [anon_sym_upcast] = ACTIONS(3935),
    [anon_sym_downcast] = ACTIONS(3935),
    [anon_sym_COLON_GT] = ACTIONS(3933),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3933),
    [anon_sym_for] = ACTIONS(3935),
    [anon_sym_while] = ACTIONS(3935),
    [anon_sym_if] = ACTIONS(3935),
    [anon_sym_fun] = ACTIONS(3935),
    [anon_sym_try] = ACTIONS(3935),
    [anon_sym_match] = ACTIONS(3935),
    [anon_sym_match_BANG] = ACTIONS(3933),
    [anon_sym_function] = ACTIONS(3935),
    [anon_sym_LT_DASH] = ACTIONS(3935),
    [anon_sym_DOT_LBRACK] = ACTIONS(3933),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_use] = ACTIONS(3935),
    [anon_sym_use_BANG] = ACTIONS(3933),
    [anon_sym_do_BANG] = ACTIONS(3933),
    [anon_sym_begin] = ACTIONS(3935),
    [anon_sym_LPAREN2] = ACTIONS(3935),
    [anon_sym_or] = ACTIONS(3935),
    [aux_sym_char_token1] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3935),
    [anon_sym_DQUOTE] = ACTIONS(3935),
    [anon_sym_AT_DQUOTE] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [sym_bool] = ACTIONS(3935),
    [sym_unit] = ACTIONS(3933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3935),
    [sym_op_identifier] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(3935),
    [anon_sym_DASH] = ACTIONS(3935),
    [anon_sym_PLUS_DOT] = ACTIONS(3935),
    [anon_sym_DASH_DOT] = ACTIONS(3935),
    [anon_sym_PERCENT] = ACTIONS(3935),
    [anon_sym_AMP_AMP] = ACTIONS(3935),
    [anon_sym_TILDE] = ACTIONS(3933),
    [aux_sym_prefix_op_token1] = ACTIONS(3935),
    [aux_sym_infix_op_token1] = ACTIONS(3933),
    [aux_sym_infix_op_token2] = ACTIONS(3935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3935),
    [anon_sym_BANG_EQ] = ACTIONS(3935),
    [anon_sym_COLON_EQ] = ACTIONS(3933),
    [anon_sym_DOLLAR] = ACTIONS(3935),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3935),
    [sym_int] = ACTIONS(3935),
    [sym_xint] = ACTIONS(3933),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3933),
    [sym__newline] = ACTIONS(3933),
    [sym__dedent] = ACTIONS(3933),
  },
  [2900] = {
    [sym_block_comment] = STATE(2900),
    [sym_compiler_directive_decl] = STATE(2900),
    [sym_fsi_directive_decl] = STATE(2900),
    [sym_preproc_line] = STATE(2900),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_as] = ACTIONS(3700),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_with] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [2901] = {
    [sym_block_comment] = STATE(2901),
    [sym_compiler_directive_decl] = STATE(2901),
    [sym_fsi_directive_decl] = STATE(2901),
    [sym_preproc_line] = STATE(2901),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_EQ] = ACTIONS(3948),
    [anon_sym_COLON] = ACTIONS(3950),
    [anon_sym_return] = ACTIONS(3950),
    [anon_sym_do] = ACTIONS(3950),
    [anon_sym_let] = ACTIONS(3950),
    [anon_sym_let_BANG] = ACTIONS(3948),
    [anon_sym_as] = ACTIONS(3950),
    [anon_sym_LPAREN] = ACTIONS(3950),
    [anon_sym_COMMA] = ACTIONS(3948),
    [anon_sym_null] = ACTIONS(3950),
    [anon_sym_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_COLON] = ACTIONS(3948),
    [anon_sym_AMP] = ACTIONS(3950),
    [anon_sym_LBRACK] = ACTIONS(3950),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3948),
    [anon_sym_LBRACE] = ACTIONS(3950),
    [anon_sym_LT_AT] = ACTIONS(3950),
    [anon_sym_LT_AT_AT] = ACTIONS(3950),
    [anon_sym_DOT] = ACTIONS(3950),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3948),
    [anon_sym_new] = ACTIONS(3950),
    [anon_sym_with] = ACTIONS(3950),
    [anon_sym_return_BANG] = ACTIONS(3948),
    [anon_sym_yield] = ACTIONS(3950),
    [anon_sym_yield_BANG] = ACTIONS(3948),
    [anon_sym_lazy] = ACTIONS(3950),
    [anon_sym_assert] = ACTIONS(3950),
    [anon_sym_upcast] = ACTIONS(3950),
    [anon_sym_downcast] = ACTIONS(3950),
    [anon_sym_COLON_GT] = ACTIONS(3948),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3948),
    [anon_sym_for] = ACTIONS(3950),
    [anon_sym_while] = ACTIONS(3950),
    [anon_sym_if] = ACTIONS(3950),
    [anon_sym_fun] = ACTIONS(3950),
    [anon_sym_try] = ACTIONS(3950),
    [anon_sym_match] = ACTIONS(3950),
    [anon_sym_match_BANG] = ACTIONS(3948),
    [anon_sym_function] = ACTIONS(3950),
    [anon_sym_LT_DASH] = ACTIONS(3950),
    [anon_sym_DOT_LBRACK] = ACTIONS(3948),
    [anon_sym_LT] = ACTIONS(3948),
    [anon_sym_use] = ACTIONS(3950),
    [anon_sym_use_BANG] = ACTIONS(3948),
    [anon_sym_do_BANG] = ACTIONS(3948),
    [anon_sym_begin] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3950),
    [anon_sym_or] = ACTIONS(3950),
    [aux_sym_char_token1] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3950),
    [anon_sym_DQUOTE] = ACTIONS(3950),
    [anon_sym_AT_DQUOTE] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [sym_bool] = ACTIONS(3950),
    [sym_unit] = ACTIONS(3948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3950),
    [sym_op_identifier] = ACTIONS(3950),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_DASH] = ACTIONS(3950),
    [anon_sym_PLUS_DOT] = ACTIONS(3950),
    [anon_sym_DASH_DOT] = ACTIONS(3950),
    [anon_sym_PERCENT] = ACTIONS(3950),
    [anon_sym_AMP_AMP] = ACTIONS(3950),
    [anon_sym_TILDE] = ACTIONS(3948),
    [aux_sym_prefix_op_token1] = ACTIONS(3950),
    [aux_sym_infix_op_token1] = ACTIONS(3948),
    [aux_sym_infix_op_token2] = ACTIONS(3950),
    [anon_sym_PIPE_PIPE] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3950),
    [anon_sym_COLON_EQ] = ACTIONS(3948),
    [anon_sym_DOLLAR] = ACTIONS(3950),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3950),
    [sym_int] = ACTIONS(3950),
    [sym_xint] = ACTIONS(3948),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3948),
    [sym__newline] = ACTIONS(3948),
    [sym__dedent] = ACTIONS(3948),
  },
  [2902] = {
    [sym_block_comment] = STATE(2902),
    [sym_compiler_directive_decl] = STATE(2902),
    [sym_fsi_directive_decl] = STATE(2902),
    [sym_preproc_line] = STATE(2902),
    [sym_identifier] = ACTIONS(3728),
    [anon_sym_EQ] = ACTIONS(3726),
    [anon_sym_COLON] = ACTIONS(3728),
    [anon_sym_return] = ACTIONS(3728),
    [anon_sym_do] = ACTIONS(3728),
    [anon_sym_let] = ACTIONS(3728),
    [anon_sym_let_BANG] = ACTIONS(3726),
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_COMMA] = ACTIONS(3726),
    [anon_sym_null] = ACTIONS(3728),
    [anon_sym_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(3726),
    [anon_sym_AMP] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3726),
    [anon_sym_LBRACE] = ACTIONS(3728),
    [anon_sym_LT_AT] = ACTIONS(3728),
    [anon_sym_LT_AT_AT] = ACTIONS(3728),
    [anon_sym_AT_AT_GT] = ACTIONS(3728),
    [anon_sym_DOT] = ACTIONS(3728),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3726),
    [anon_sym_new] = ACTIONS(3728),
    [anon_sym_return_BANG] = ACTIONS(3726),
    [anon_sym_yield] = ACTIONS(3728),
    [anon_sym_yield_BANG] = ACTIONS(3726),
    [anon_sym_lazy] = ACTIONS(3728),
    [anon_sym_assert] = ACTIONS(3728),
    [anon_sym_upcast] = ACTIONS(3728),
    [anon_sym_downcast] = ACTIONS(3728),
    [anon_sym_COLON_GT] = ACTIONS(3726),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3726),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_fun] = ACTIONS(3728),
    [anon_sym_try] = ACTIONS(3728),
    [anon_sym_match] = ACTIONS(3728),
    [anon_sym_match_BANG] = ACTIONS(3726),
    [anon_sym_function] = ACTIONS(3728),
    [anon_sym_LT_DASH] = ACTIONS(3728),
    [anon_sym_DOT_LBRACK] = ACTIONS(3726),
    [anon_sym_LT] = ACTIONS(3726),
    [anon_sym_use] = ACTIONS(3728),
    [anon_sym_use_BANG] = ACTIONS(3726),
    [anon_sym_do_BANG] = ACTIONS(3726),
    [anon_sym_begin] = ACTIONS(3728),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [aux_sym_char_token1] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3728),
    [anon_sym_AT_DQUOTE] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [sym_bool] = ACTIONS(3728),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3728),
    [sym_op_identifier] = ACTIONS(3728),
    [anon_sym_PLUS] = ACTIONS(3728),
    [anon_sym_DASH] = ACTIONS(3728),
    [anon_sym_PLUS_DOT] = ACTIONS(3728),
    [anon_sym_DASH_DOT] = ACTIONS(3728),
    [anon_sym_PERCENT] = ACTIONS(3728),
    [anon_sym_AMP_AMP] = ACTIONS(3728),
    [anon_sym_TILDE] = ACTIONS(3726),
    [aux_sym_prefix_op_token1] = ACTIONS(3728),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token2] = ACTIONS(3728),
    [anon_sym_PIPE_PIPE] = ACTIONS(3728),
    [anon_sym_BANG_EQ] = ACTIONS(3728),
    [anon_sym_COLON_EQ] = ACTIONS(3726),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3728),
    [sym_int] = ACTIONS(3728),
    [sym_xint] = ACTIONS(3726),
    [anon_sym_f] = ACTIONS(3728),
    [aux_sym_decimal_token1] = ACTIONS(3728),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3726),
    [sym__newline] = ACTIONS(3726),
  },
  [2903] = {
    [sym_block_comment] = STATE(2903),
    [sym_compiler_directive_decl] = STATE(2903),
    [sym_fsi_directive_decl] = STATE(2903),
    [sym_preproc_line] = STATE(2903),
    [sym_identifier] = ACTIONS(3954),
    [anon_sym_EQ] = ACTIONS(3952),
    [anon_sym_COLON] = ACTIONS(3954),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_do] = ACTIONS(3954),
    [anon_sym_let] = ACTIONS(3954),
    [anon_sym_let_BANG] = ACTIONS(3952),
    [anon_sym_as] = ACTIONS(3954),
    [anon_sym_LPAREN] = ACTIONS(3954),
    [anon_sym_COMMA] = ACTIONS(3952),
    [anon_sym_null] = ACTIONS(3954),
    [anon_sym_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_COLON] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3954),
    [anon_sym_LBRACK] = ACTIONS(3954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(3954),
    [anon_sym_LT_AT] = ACTIONS(3954),
    [anon_sym_LT_AT_AT] = ACTIONS(3954),
    [anon_sym_DOT] = ACTIONS(3954),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3952),
    [anon_sym_new] = ACTIONS(3954),
    [anon_sym_with] = ACTIONS(3954),
    [anon_sym_return_BANG] = ACTIONS(3952),
    [anon_sym_yield] = ACTIONS(3954),
    [anon_sym_yield_BANG] = ACTIONS(3952),
    [anon_sym_lazy] = ACTIONS(3954),
    [anon_sym_assert] = ACTIONS(3954),
    [anon_sym_upcast] = ACTIONS(3954),
    [anon_sym_downcast] = ACTIONS(3954),
    [anon_sym_COLON_GT] = ACTIONS(3952),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3952),
    [anon_sym_for] = ACTIONS(3954),
    [anon_sym_while] = ACTIONS(3954),
    [anon_sym_if] = ACTIONS(3954),
    [anon_sym_fun] = ACTIONS(3954),
    [anon_sym_try] = ACTIONS(3954),
    [anon_sym_match] = ACTIONS(3954),
    [anon_sym_match_BANG] = ACTIONS(3952),
    [anon_sym_function] = ACTIONS(3954),
    [anon_sym_LT_DASH] = ACTIONS(3954),
    [anon_sym_DOT_LBRACK] = ACTIONS(3952),
    [anon_sym_LT] = ACTIONS(3952),
    [anon_sym_use] = ACTIONS(3954),
    [anon_sym_use_BANG] = ACTIONS(3952),
    [anon_sym_do_BANG] = ACTIONS(3952),
    [anon_sym_begin] = ACTIONS(3954),
    [anon_sym_LPAREN2] = ACTIONS(3954),
    [anon_sym_or] = ACTIONS(3954),
    [aux_sym_char_token1] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3954),
    [anon_sym_DQUOTE] = ACTIONS(3954),
    [anon_sym_AT_DQUOTE] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [sym_bool] = ACTIONS(3954),
    [sym_unit] = ACTIONS(3952),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3954),
    [sym_op_identifier] = ACTIONS(3954),
    [anon_sym_PLUS] = ACTIONS(3954),
    [anon_sym_DASH] = ACTIONS(3954),
    [anon_sym_PLUS_DOT] = ACTIONS(3954),
    [anon_sym_DASH_DOT] = ACTIONS(3954),
    [anon_sym_PERCENT] = ACTIONS(3954),
    [anon_sym_AMP_AMP] = ACTIONS(3954),
    [anon_sym_TILDE] = ACTIONS(3952),
    [aux_sym_prefix_op_token1] = ACTIONS(3954),
    [aux_sym_infix_op_token1] = ACTIONS(3952),
    [aux_sym_infix_op_token2] = ACTIONS(3954),
    [anon_sym_PIPE_PIPE] = ACTIONS(3954),
    [anon_sym_BANG_EQ] = ACTIONS(3954),
    [anon_sym_COLON_EQ] = ACTIONS(3952),
    [anon_sym_DOLLAR] = ACTIONS(3954),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3954),
    [sym_int] = ACTIONS(3954),
    [sym_xint] = ACTIONS(3952),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3952),
    [sym__newline] = ACTIONS(3952),
    [sym__dedent] = ACTIONS(3952),
  },
  [2904] = {
    [sym_block_comment] = STATE(2904),
    [sym_compiler_directive_decl] = STATE(2904),
    [sym_fsi_directive_decl] = STATE(2904),
    [sym_preproc_line] = STATE(2904),
    [sym_identifier] = ACTIONS(3958),
    [anon_sym_EQ] = ACTIONS(3956),
    [anon_sym_COLON] = ACTIONS(3958),
    [anon_sym_return] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(3958),
    [anon_sym_let] = ACTIONS(3958),
    [anon_sym_let_BANG] = ACTIONS(3956),
    [anon_sym_as] = ACTIONS(3958),
    [anon_sym_LPAREN] = ACTIONS(3958),
    [anon_sym_COMMA] = ACTIONS(3956),
    [anon_sym_null] = ACTIONS(3958),
    [anon_sym_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_COLON] = ACTIONS(3956),
    [anon_sym_AMP] = ACTIONS(3958),
    [anon_sym_LBRACK] = ACTIONS(3958),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3956),
    [anon_sym_LBRACE] = ACTIONS(3958),
    [anon_sym_LT_AT] = ACTIONS(3958),
    [anon_sym_LT_AT_AT] = ACTIONS(3958),
    [anon_sym_DOT] = ACTIONS(3958),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3956),
    [anon_sym_new] = ACTIONS(3958),
    [anon_sym_with] = ACTIONS(3958),
    [anon_sym_return_BANG] = ACTIONS(3956),
    [anon_sym_yield] = ACTIONS(3958),
    [anon_sym_yield_BANG] = ACTIONS(3956),
    [anon_sym_lazy] = ACTIONS(3958),
    [anon_sym_assert] = ACTIONS(3958),
    [anon_sym_upcast] = ACTIONS(3958),
    [anon_sym_downcast] = ACTIONS(3958),
    [anon_sym_COLON_GT] = ACTIONS(3956),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3956),
    [anon_sym_for] = ACTIONS(3958),
    [anon_sym_while] = ACTIONS(3958),
    [anon_sym_if] = ACTIONS(3958),
    [anon_sym_fun] = ACTIONS(3958),
    [anon_sym_try] = ACTIONS(3958),
    [anon_sym_match] = ACTIONS(3958),
    [anon_sym_match_BANG] = ACTIONS(3956),
    [anon_sym_function] = ACTIONS(3958),
    [anon_sym_LT_DASH] = ACTIONS(3958),
    [anon_sym_DOT_LBRACK] = ACTIONS(3956),
    [anon_sym_LT] = ACTIONS(3956),
    [anon_sym_use] = ACTIONS(3958),
    [anon_sym_use_BANG] = ACTIONS(3956),
    [anon_sym_do_BANG] = ACTIONS(3956),
    [anon_sym_begin] = ACTIONS(3958),
    [anon_sym_LPAREN2] = ACTIONS(3958),
    [anon_sym_or] = ACTIONS(3958),
    [aux_sym_char_token1] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [anon_sym_AT_DQUOTE] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [sym_bool] = ACTIONS(3958),
    [sym_unit] = ACTIONS(3956),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3958),
    [sym_op_identifier] = ACTIONS(3958),
    [anon_sym_PLUS] = ACTIONS(3958),
    [anon_sym_DASH] = ACTIONS(3958),
    [anon_sym_PLUS_DOT] = ACTIONS(3958),
    [anon_sym_DASH_DOT] = ACTIONS(3958),
    [anon_sym_PERCENT] = ACTIONS(3958),
    [anon_sym_AMP_AMP] = ACTIONS(3958),
    [anon_sym_TILDE] = ACTIONS(3956),
    [aux_sym_prefix_op_token1] = ACTIONS(3958),
    [aux_sym_infix_op_token1] = ACTIONS(3956),
    [aux_sym_infix_op_token2] = ACTIONS(3958),
    [anon_sym_PIPE_PIPE] = ACTIONS(3958),
    [anon_sym_BANG_EQ] = ACTIONS(3958),
    [anon_sym_COLON_EQ] = ACTIONS(3956),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3958),
    [sym_int] = ACTIONS(3958),
    [sym_xint] = ACTIONS(3956),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3956),
    [sym__newline] = ACTIONS(3956),
    [sym__dedent] = ACTIONS(3956),
  },
  [2905] = {
    [sym_block_comment] = STATE(2905),
    [sym_compiler_directive_decl] = STATE(2905),
    [sym_fsi_directive_decl] = STATE(2905),
    [sym_preproc_line] = STATE(2905),
    [sym_identifier] = ACTIONS(3962),
    [anon_sym_EQ] = ACTIONS(3960),
    [anon_sym_COLON] = ACTIONS(3962),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_do] = ACTIONS(3962),
    [anon_sym_let] = ACTIONS(3962),
    [anon_sym_let_BANG] = ACTIONS(3960),
    [anon_sym_as] = ACTIONS(3962),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_COMMA] = ACTIONS(3960),
    [anon_sym_null] = ACTIONS(3962),
    [anon_sym_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_COLON] = ACTIONS(3960),
    [anon_sym_AMP] = ACTIONS(3962),
    [anon_sym_LBRACK] = ACTIONS(3962),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_LT_AT] = ACTIONS(3962),
    [anon_sym_LT_AT_AT] = ACTIONS(3962),
    [anon_sym_DOT] = ACTIONS(3962),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3960),
    [anon_sym_new] = ACTIONS(3962),
    [anon_sym_with] = ACTIONS(3962),
    [anon_sym_return_BANG] = ACTIONS(3960),
    [anon_sym_yield] = ACTIONS(3962),
    [anon_sym_yield_BANG] = ACTIONS(3960),
    [anon_sym_lazy] = ACTIONS(3962),
    [anon_sym_assert] = ACTIONS(3962),
    [anon_sym_upcast] = ACTIONS(3962),
    [anon_sym_downcast] = ACTIONS(3962),
    [anon_sym_COLON_GT] = ACTIONS(3960),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3960),
    [anon_sym_for] = ACTIONS(3962),
    [anon_sym_while] = ACTIONS(3962),
    [anon_sym_if] = ACTIONS(3962),
    [anon_sym_fun] = ACTIONS(3962),
    [anon_sym_try] = ACTIONS(3962),
    [anon_sym_match] = ACTIONS(3962),
    [anon_sym_match_BANG] = ACTIONS(3960),
    [anon_sym_function] = ACTIONS(3962),
    [anon_sym_LT_DASH] = ACTIONS(3962),
    [anon_sym_DOT_LBRACK] = ACTIONS(3960),
    [anon_sym_LT] = ACTIONS(3960),
    [anon_sym_use] = ACTIONS(3962),
    [anon_sym_use_BANG] = ACTIONS(3960),
    [anon_sym_do_BANG] = ACTIONS(3960),
    [anon_sym_begin] = ACTIONS(3962),
    [anon_sym_LPAREN2] = ACTIONS(3962),
    [anon_sym_or] = ACTIONS(3962),
    [aux_sym_char_token1] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3962),
    [anon_sym_DQUOTE] = ACTIONS(3962),
    [anon_sym_AT_DQUOTE] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [sym_bool] = ACTIONS(3962),
    [sym_unit] = ACTIONS(3960),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3962),
    [sym_op_identifier] = ACTIONS(3962),
    [anon_sym_PLUS] = ACTIONS(3962),
    [anon_sym_DASH] = ACTIONS(3962),
    [anon_sym_PLUS_DOT] = ACTIONS(3962),
    [anon_sym_DASH_DOT] = ACTIONS(3962),
    [anon_sym_PERCENT] = ACTIONS(3962),
    [anon_sym_AMP_AMP] = ACTIONS(3962),
    [anon_sym_TILDE] = ACTIONS(3960),
    [aux_sym_prefix_op_token1] = ACTIONS(3962),
    [aux_sym_infix_op_token1] = ACTIONS(3960),
    [aux_sym_infix_op_token2] = ACTIONS(3962),
    [anon_sym_PIPE_PIPE] = ACTIONS(3962),
    [anon_sym_BANG_EQ] = ACTIONS(3962),
    [anon_sym_COLON_EQ] = ACTIONS(3960),
    [anon_sym_DOLLAR] = ACTIONS(3962),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3962),
    [sym_int] = ACTIONS(3962),
    [sym_xint] = ACTIONS(3960),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3960),
    [sym__newline] = ACTIONS(3960),
    [sym__dedent] = ACTIONS(3960),
  },
  [2906] = {
    [sym_block_comment] = STATE(2906),
    [sym_compiler_directive_decl] = STATE(2906),
    [sym_fsi_directive_decl] = STATE(2906),
    [sym_preproc_line] = STATE(2906),
    [sym_identifier] = ACTIONS(3893),
    [anon_sym_EQ] = ACTIONS(3891),
    [anon_sym_COLON] = ACTIONS(3893),
    [anon_sym_return] = ACTIONS(3893),
    [anon_sym_do] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_let_BANG] = ACTIONS(3891),
    [anon_sym_as] = ACTIONS(3893),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_COMMA] = ACTIONS(3891),
    [anon_sym_null] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_COLON] = ACTIONS(3891),
    [anon_sym_AMP] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3891),
    [anon_sym_LBRACE] = ACTIONS(3893),
    [anon_sym_LT_AT] = ACTIONS(3893),
    [anon_sym_LT_AT_AT] = ACTIONS(3893),
    [anon_sym_DOT] = ACTIONS(3893),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3891),
    [anon_sym_new] = ACTIONS(3893),
    [anon_sym_with] = ACTIONS(3893),
    [anon_sym_return_BANG] = ACTIONS(3891),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_yield_BANG] = ACTIONS(3891),
    [anon_sym_lazy] = ACTIONS(3893),
    [anon_sym_assert] = ACTIONS(3893),
    [anon_sym_upcast] = ACTIONS(3893),
    [anon_sym_downcast] = ACTIONS(3893),
    [anon_sym_COLON_GT] = ACTIONS(3891),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3891),
    [anon_sym_for] = ACTIONS(3893),
    [anon_sym_while] = ACTIONS(3893),
    [anon_sym_if] = ACTIONS(3893),
    [anon_sym_fun] = ACTIONS(3893),
    [anon_sym_try] = ACTIONS(3893),
    [anon_sym_match] = ACTIONS(3893),
    [anon_sym_match_BANG] = ACTIONS(3891),
    [anon_sym_function] = ACTIONS(3893),
    [anon_sym_LT_DASH] = ACTIONS(3893),
    [anon_sym_DOT_LBRACK] = ACTIONS(3891),
    [anon_sym_LT] = ACTIONS(3891),
    [anon_sym_use] = ACTIONS(3893),
    [anon_sym_use_BANG] = ACTIONS(3891),
    [anon_sym_do_BANG] = ACTIONS(3891),
    [anon_sym_begin] = ACTIONS(3893),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_or] = ACTIONS(3893),
    [aux_sym_char_token1] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3893),
    [anon_sym_DQUOTE] = ACTIONS(3893),
    [anon_sym_AT_DQUOTE] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [sym_bool] = ACTIONS(3893),
    [sym_unit] = ACTIONS(3891),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3893),
    [sym_op_identifier] = ACTIONS(3893),
    [anon_sym_PLUS] = ACTIONS(3893),
    [anon_sym_DASH] = ACTIONS(3893),
    [anon_sym_PLUS_DOT] = ACTIONS(3893),
    [anon_sym_DASH_DOT] = ACTIONS(3893),
    [anon_sym_PERCENT] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_TILDE] = ACTIONS(3891),
    [aux_sym_prefix_op_token1] = ACTIONS(3893),
    [aux_sym_infix_op_token1] = ACTIONS(3891),
    [aux_sym_infix_op_token2] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [anon_sym_BANG_EQ] = ACTIONS(3893),
    [anon_sym_COLON_EQ] = ACTIONS(3891),
    [anon_sym_DOLLAR] = ACTIONS(3893),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3893),
    [sym_int] = ACTIONS(3893),
    [sym_xint] = ACTIONS(3891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3891),
    [sym__newline] = ACTIONS(3891),
    [sym__dedent] = ACTIONS(3891),
  },
  [2907] = {
    [sym_block_comment] = STATE(2907),
    [sym_compiler_directive_decl] = STATE(2907),
    [sym_fsi_directive_decl] = STATE(2907),
    [sym_preproc_line] = STATE(2907),
    [sym_identifier] = ACTIONS(4232),
    [anon_sym_EQ] = ACTIONS(4230),
    [anon_sym_COLON] = ACTIONS(4232),
    [anon_sym_return] = ACTIONS(4232),
    [anon_sym_do] = ACTIONS(4232),
    [anon_sym_let] = ACTIONS(4232),
    [anon_sym_let_BANG] = ACTIONS(4230),
    [anon_sym_as] = ACTIONS(4232),
    [anon_sym_LPAREN] = ACTIONS(4232),
    [anon_sym_COMMA] = ACTIONS(4230),
    [anon_sym_null] = ACTIONS(4232),
    [anon_sym_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_COLON] = ACTIONS(4230),
    [anon_sym_AMP] = ACTIONS(4232),
    [anon_sym_LBRACK] = ACTIONS(4232),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4230),
    [anon_sym_LBRACE] = ACTIONS(4232),
    [anon_sym_LT_AT] = ACTIONS(4232),
    [anon_sym_LT_AT_AT] = ACTIONS(4232),
    [anon_sym_DOT] = ACTIONS(4232),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4230),
    [anon_sym_new] = ACTIONS(4232),
    [anon_sym_with] = ACTIONS(4232),
    [anon_sym_return_BANG] = ACTIONS(4230),
    [anon_sym_yield] = ACTIONS(4232),
    [anon_sym_yield_BANG] = ACTIONS(4230),
    [anon_sym_lazy] = ACTIONS(4232),
    [anon_sym_assert] = ACTIONS(4232),
    [anon_sym_upcast] = ACTIONS(4232),
    [anon_sym_downcast] = ACTIONS(4232),
    [anon_sym_COLON_GT] = ACTIONS(4230),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4230),
    [anon_sym_for] = ACTIONS(4232),
    [anon_sym_while] = ACTIONS(4232),
    [anon_sym_if] = ACTIONS(4232),
    [anon_sym_fun] = ACTIONS(4232),
    [anon_sym_try] = ACTIONS(4232),
    [anon_sym_match] = ACTIONS(4232),
    [anon_sym_match_BANG] = ACTIONS(4230),
    [anon_sym_function] = ACTIONS(4232),
    [anon_sym_LT_DASH] = ACTIONS(4232),
    [anon_sym_DOT_LBRACK] = ACTIONS(4230),
    [anon_sym_LT] = ACTIONS(4230),
    [anon_sym_use] = ACTIONS(4232),
    [anon_sym_use_BANG] = ACTIONS(4230),
    [anon_sym_do_BANG] = ACTIONS(4230),
    [anon_sym_begin] = ACTIONS(4232),
    [anon_sym_LPAREN2] = ACTIONS(4232),
    [anon_sym_or] = ACTIONS(4232),
    [aux_sym_char_token1] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4232),
    [anon_sym_DQUOTE] = ACTIONS(4232),
    [anon_sym_AT_DQUOTE] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [sym_bool] = ACTIONS(4232),
    [sym_unit] = ACTIONS(4230),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4232),
    [sym_op_identifier] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4232),
    [anon_sym_DASH] = ACTIONS(4232),
    [anon_sym_PLUS_DOT] = ACTIONS(4232),
    [anon_sym_DASH_DOT] = ACTIONS(4232),
    [anon_sym_PERCENT] = ACTIONS(4232),
    [anon_sym_AMP_AMP] = ACTIONS(4232),
    [anon_sym_TILDE] = ACTIONS(4230),
    [aux_sym_prefix_op_token1] = ACTIONS(4232),
    [aux_sym_infix_op_token1] = ACTIONS(4230),
    [aux_sym_infix_op_token2] = ACTIONS(4232),
    [anon_sym_PIPE_PIPE] = ACTIONS(4232),
    [anon_sym_BANG_EQ] = ACTIONS(4232),
    [anon_sym_COLON_EQ] = ACTIONS(4230),
    [anon_sym_DOLLAR] = ACTIONS(4232),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4232),
    [sym_int] = ACTIONS(4232),
    [sym_xint] = ACTIONS(4230),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4230),
    [sym__newline] = ACTIONS(4230),
    [sym__dedent] = ACTIONS(4230),
  },
  [2908] = {
    [sym_block_comment] = STATE(2908),
    [sym_compiler_directive_decl] = STATE(2908),
    [sym_fsi_directive_decl] = STATE(2908),
    [sym_preproc_line] = STATE(2908),
    [sym_identifier] = ACTIONS(4126),
    [anon_sym_EQ] = ACTIONS(4124),
    [anon_sym_COLON] = ACTIONS(4126),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_do] = ACTIONS(4126),
    [anon_sym_let] = ACTIONS(4126),
    [anon_sym_let_BANG] = ACTIONS(4124),
    [anon_sym_as] = ACTIONS(4126),
    [anon_sym_LPAREN] = ACTIONS(4126),
    [anon_sym_COMMA] = ACTIONS(4124),
    [anon_sym_null] = ACTIONS(4126),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_COLON] = ACTIONS(4124),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LBRACK] = ACTIONS(4126),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4126),
    [anon_sym_LT_AT] = ACTIONS(4126),
    [anon_sym_LT_AT_AT] = ACTIONS(4126),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4124),
    [anon_sym_new] = ACTIONS(4126),
    [anon_sym_with] = ACTIONS(4126),
    [anon_sym_return_BANG] = ACTIONS(4124),
    [anon_sym_yield] = ACTIONS(4126),
    [anon_sym_yield_BANG] = ACTIONS(4124),
    [anon_sym_lazy] = ACTIONS(4126),
    [anon_sym_assert] = ACTIONS(4126),
    [anon_sym_upcast] = ACTIONS(4126),
    [anon_sym_downcast] = ACTIONS(4126),
    [anon_sym_COLON_GT] = ACTIONS(4124),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4124),
    [anon_sym_for] = ACTIONS(4126),
    [anon_sym_while] = ACTIONS(4126),
    [anon_sym_if] = ACTIONS(4126),
    [anon_sym_fun] = ACTIONS(4126),
    [anon_sym_try] = ACTIONS(4126),
    [anon_sym_match] = ACTIONS(4126),
    [anon_sym_match_BANG] = ACTIONS(4124),
    [anon_sym_function] = ACTIONS(4126),
    [anon_sym_LT_DASH] = ACTIONS(4126),
    [anon_sym_DOT_LBRACK] = ACTIONS(4124),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_use] = ACTIONS(4126),
    [anon_sym_use_BANG] = ACTIONS(4124),
    [anon_sym_do_BANG] = ACTIONS(4124),
    [anon_sym_begin] = ACTIONS(4126),
    [anon_sym_LPAREN2] = ACTIONS(4126),
    [anon_sym_or] = ACTIONS(4126),
    [aux_sym_char_token1] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4126),
    [anon_sym_DQUOTE] = ACTIONS(4126),
    [anon_sym_AT_DQUOTE] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [sym_bool] = ACTIONS(4126),
    [sym_unit] = ACTIONS(4124),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4126),
    [sym_op_identifier] = ACTIONS(4126),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_PLUS_DOT] = ACTIONS(4126),
    [anon_sym_DASH_DOT] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_AMP_AMP] = ACTIONS(4126),
    [anon_sym_TILDE] = ACTIONS(4124),
    [aux_sym_prefix_op_token1] = ACTIONS(4126),
    [aux_sym_infix_op_token1] = ACTIONS(4124),
    [aux_sym_infix_op_token2] = ACTIONS(4126),
    [anon_sym_PIPE_PIPE] = ACTIONS(4126),
    [anon_sym_BANG_EQ] = ACTIONS(4126),
    [anon_sym_COLON_EQ] = ACTIONS(4124),
    [anon_sym_DOLLAR] = ACTIONS(4126),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4126),
    [sym_int] = ACTIONS(4126),
    [sym_xint] = ACTIONS(4124),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4124),
    [sym__newline] = ACTIONS(4124),
    [sym__dedent] = ACTIONS(4124),
  },
  [2909] = {
    [sym_block_comment] = STATE(2909),
    [sym_compiler_directive_decl] = STATE(2909),
    [sym_fsi_directive_decl] = STATE(2909),
    [sym_preproc_line] = STATE(2909),
    [sym_identifier] = ACTIONS(4122),
    [anon_sym_EQ] = ACTIONS(4120),
    [anon_sym_COLON] = ACTIONS(4122),
    [anon_sym_return] = ACTIONS(4122),
    [anon_sym_do] = ACTIONS(4122),
    [anon_sym_let] = ACTIONS(4122),
    [anon_sym_let_BANG] = ACTIONS(4120),
    [anon_sym_as] = ACTIONS(4122),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_COMMA] = ACTIONS(4120),
    [anon_sym_null] = ACTIONS(4122),
    [anon_sym_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_COLON] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_LT_AT] = ACTIONS(4122),
    [anon_sym_LT_AT_AT] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4122),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4120),
    [anon_sym_new] = ACTIONS(4122),
    [anon_sym_with] = ACTIONS(4122),
    [anon_sym_return_BANG] = ACTIONS(4120),
    [anon_sym_yield] = ACTIONS(4122),
    [anon_sym_yield_BANG] = ACTIONS(4120),
    [anon_sym_lazy] = ACTIONS(4122),
    [anon_sym_assert] = ACTIONS(4122),
    [anon_sym_upcast] = ACTIONS(4122),
    [anon_sym_downcast] = ACTIONS(4122),
    [anon_sym_COLON_GT] = ACTIONS(4120),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4120),
    [anon_sym_for] = ACTIONS(4122),
    [anon_sym_while] = ACTIONS(4122),
    [anon_sym_if] = ACTIONS(4122),
    [anon_sym_fun] = ACTIONS(4122),
    [anon_sym_try] = ACTIONS(4122),
    [anon_sym_match] = ACTIONS(4122),
    [anon_sym_match_BANG] = ACTIONS(4120),
    [anon_sym_function] = ACTIONS(4122),
    [anon_sym_LT_DASH] = ACTIONS(4122),
    [anon_sym_DOT_LBRACK] = ACTIONS(4120),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_use] = ACTIONS(4122),
    [anon_sym_use_BANG] = ACTIONS(4120),
    [anon_sym_do_BANG] = ACTIONS(4120),
    [anon_sym_begin] = ACTIONS(4122),
    [anon_sym_LPAREN2] = ACTIONS(4122),
    [anon_sym_or] = ACTIONS(4122),
    [aux_sym_char_token1] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4122),
    [anon_sym_DQUOTE] = ACTIONS(4122),
    [anon_sym_AT_DQUOTE] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [sym_bool] = ACTIONS(4122),
    [sym_unit] = ACTIONS(4120),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4122),
    [sym_op_identifier] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4122),
    [anon_sym_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_DOT] = ACTIONS(4122),
    [anon_sym_DASH_DOT] = ACTIONS(4122),
    [anon_sym_PERCENT] = ACTIONS(4122),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_TILDE] = ACTIONS(4120),
    [aux_sym_prefix_op_token1] = ACTIONS(4122),
    [aux_sym_infix_op_token1] = ACTIONS(4120),
    [aux_sym_infix_op_token2] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_COLON_EQ] = ACTIONS(4120),
    [anon_sym_DOLLAR] = ACTIONS(4122),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4122),
    [sym_int] = ACTIONS(4122),
    [sym_xint] = ACTIONS(4120),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4120),
    [sym__newline] = ACTIONS(4120),
    [sym__dedent] = ACTIONS(4120),
  },
  [2910] = {
    [sym_block_comment] = STATE(2910),
    [sym_compiler_directive_decl] = STATE(2910),
    [sym_fsi_directive_decl] = STATE(2910),
    [sym_preproc_line] = STATE(2910),
    [sym_identifier] = ACTIONS(4118),
    [anon_sym_EQ] = ACTIONS(4116),
    [anon_sym_COLON] = ACTIONS(4118),
    [anon_sym_return] = ACTIONS(4118),
    [anon_sym_do] = ACTIONS(4118),
    [anon_sym_let] = ACTIONS(4118),
    [anon_sym_let_BANG] = ACTIONS(4116),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_LPAREN] = ACTIONS(4118),
    [anon_sym_COMMA] = ACTIONS(4116),
    [anon_sym_null] = ACTIONS(4118),
    [anon_sym_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_COLON] = ACTIONS(4116),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4118),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(4118),
    [anon_sym_LT_AT] = ACTIONS(4118),
    [anon_sym_LT_AT_AT] = ACTIONS(4118),
    [anon_sym_DOT] = ACTIONS(4118),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4116),
    [anon_sym_new] = ACTIONS(4118),
    [anon_sym_with] = ACTIONS(4118),
    [anon_sym_return_BANG] = ACTIONS(4116),
    [anon_sym_yield] = ACTIONS(4118),
    [anon_sym_yield_BANG] = ACTIONS(4116),
    [anon_sym_lazy] = ACTIONS(4118),
    [anon_sym_assert] = ACTIONS(4118),
    [anon_sym_upcast] = ACTIONS(4118),
    [anon_sym_downcast] = ACTIONS(4118),
    [anon_sym_COLON_GT] = ACTIONS(4116),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4116),
    [anon_sym_for] = ACTIONS(4118),
    [anon_sym_while] = ACTIONS(4118),
    [anon_sym_if] = ACTIONS(4118),
    [anon_sym_fun] = ACTIONS(4118),
    [anon_sym_try] = ACTIONS(4118),
    [anon_sym_match] = ACTIONS(4118),
    [anon_sym_match_BANG] = ACTIONS(4116),
    [anon_sym_function] = ACTIONS(4118),
    [anon_sym_LT_DASH] = ACTIONS(4118),
    [anon_sym_DOT_LBRACK] = ACTIONS(4116),
    [anon_sym_LT] = ACTIONS(4116),
    [anon_sym_use] = ACTIONS(4118),
    [anon_sym_use_BANG] = ACTIONS(4116),
    [anon_sym_do_BANG] = ACTIONS(4116),
    [anon_sym_begin] = ACTIONS(4118),
    [anon_sym_LPAREN2] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [aux_sym_char_token1] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4118),
    [anon_sym_DQUOTE] = ACTIONS(4118),
    [anon_sym_AT_DQUOTE] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [sym_bool] = ACTIONS(4118),
    [sym_unit] = ACTIONS(4116),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4118),
    [sym_op_identifier] = ACTIONS(4118),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_PLUS_DOT] = ACTIONS(4118),
    [anon_sym_DASH_DOT] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_AMP_AMP] = ACTIONS(4118),
    [anon_sym_TILDE] = ACTIONS(4116),
    [aux_sym_prefix_op_token1] = ACTIONS(4118),
    [aux_sym_infix_op_token1] = ACTIONS(4116),
    [aux_sym_infix_op_token2] = ACTIONS(4118),
    [anon_sym_PIPE_PIPE] = ACTIONS(4118),
    [anon_sym_BANG_EQ] = ACTIONS(4118),
    [anon_sym_COLON_EQ] = ACTIONS(4116),
    [anon_sym_DOLLAR] = ACTIONS(4118),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4118),
    [sym_int] = ACTIONS(4118),
    [sym_xint] = ACTIONS(4116),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4116),
    [sym__newline] = ACTIONS(4116),
    [sym__dedent] = ACTIONS(4116),
  },
  [2911] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(4912),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(2911),
    [sym_compiler_directive_decl] = STATE(2911),
    [sym_fsi_directive_decl] = STATE(2911),
    [sym_preproc_line] = STATE(2911),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym_repeat_pattern_repeat1] = STATE(4823),
    [sym_identifier] = ACTIONS(5363),
    [anon_sym_EQ] = ACTIONS(5365),
    [anon_sym_LBRACK_LT] = ACTIONS(5365),
    [anon_sym_COLON] = ACTIONS(5363),
    [anon_sym_as] = ACTIONS(5460),
    [anon_sym_LPAREN] = ACTIONS(5363),
    [anon_sym_RPAREN] = ACTIONS(5365),
    [anon_sym_COMMA] = ACTIONS(5462),
    [anon_sym_null] = ACTIONS(5363),
    [anon_sym__] = ACTIONS(5363),
    [anon_sym_QMARK] = ACTIONS(5365),
    [anon_sym_COLON_QMARK] = ACTIONS(5365),
    [anon_sym_COLON_COLON] = ACTIONS(5464),
    [anon_sym_PIPE] = ACTIONS(5466),
    [anon_sym_AMP] = ACTIONS(5468),
    [anon_sym_LBRACK] = ACTIONS(5363),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5365),
    [anon_sym_LBRACE] = ACTIONS(5365),
    [anon_sym_LT2] = ACTIONS(5365),
    [aux_sym_char_token1] = ACTIONS(5365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5363),
    [anon_sym_DQUOTE] = ACTIONS(5363),
    [anon_sym_AT_DQUOTE] = ACTIONS(5365),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5365),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5365),
    [sym_bool] = ACTIONS(5363),
    [sym_unit] = ACTIONS(5365),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5363),
    [sym_op_identifier] = ACTIONS(5365),
    [sym_int] = ACTIONS(5363),
    [sym_xint] = ACTIONS(5365),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2912] = {
    [sym_block_comment] = STATE(2912),
    [sym_compiler_directive_decl] = STATE(2912),
    [sym_fsi_directive_decl] = STATE(2912),
    [sym_preproc_line] = STATE(2912),
    [sym_identifier] = ACTIONS(3841),
    [anon_sym_EQ] = ACTIONS(3839),
    [anon_sym_COLON] = ACTIONS(3841),
    [anon_sym_return] = ACTIONS(3841),
    [anon_sym_do] = ACTIONS(3841),
    [anon_sym_let] = ACTIONS(3841),
    [anon_sym_let_BANG] = ACTIONS(3839),
    [anon_sym_LPAREN] = ACTIONS(3841),
    [anon_sym_COMMA] = ACTIONS(3839),
    [anon_sym_null] = ACTIONS(3841),
    [anon_sym_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_COLON] = ACTIONS(3839),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_AMP] = ACTIONS(3841),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(3841),
    [anon_sym_LT_AT] = ACTIONS(3841),
    [anon_sym_LT_AT_AT] = ACTIONS(3841),
    [anon_sym_DOT] = ACTIONS(3841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3839),
    [anon_sym_new] = ACTIONS(3841),
    [anon_sym_return_BANG] = ACTIONS(3839),
    [anon_sym_yield] = ACTIONS(3841),
    [anon_sym_yield_BANG] = ACTIONS(3839),
    [anon_sym_lazy] = ACTIONS(3841),
    [anon_sym_assert] = ACTIONS(3841),
    [anon_sym_upcast] = ACTIONS(3841),
    [anon_sym_downcast] = ACTIONS(3841),
    [anon_sym_COLON_GT] = ACTIONS(3839),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3839),
    [anon_sym_for] = ACTIONS(3841),
    [anon_sym_while] = ACTIONS(3841),
    [anon_sym_if] = ACTIONS(3841),
    [anon_sym_fun] = ACTIONS(3841),
    [anon_sym_DASH_GT] = ACTIONS(3841),
    [anon_sym_try] = ACTIONS(3841),
    [anon_sym_match] = ACTIONS(3841),
    [anon_sym_match_BANG] = ACTIONS(3839),
    [anon_sym_function] = ACTIONS(3841),
    [anon_sym_LT_DASH] = ACTIONS(3841),
    [anon_sym_DOT_LBRACK] = ACTIONS(3839),
    [anon_sym_LT] = ACTIONS(3839),
    [anon_sym_use] = ACTIONS(3841),
    [anon_sym_use_BANG] = ACTIONS(3839),
    [anon_sym_do_BANG] = ACTIONS(3839),
    [anon_sym_DOT_DOT] = ACTIONS(3839),
    [anon_sym_begin] = ACTIONS(3841),
    [anon_sym_LPAREN2] = ACTIONS(3841),
    [anon_sym_or] = ACTIONS(3841),
    [aux_sym_char_token1] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3841),
    [anon_sym_DQUOTE] = ACTIONS(3841),
    [anon_sym_AT_DQUOTE] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [sym_bool] = ACTIONS(3841),
    [sym_unit] = ACTIONS(3839),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3841),
    [sym_op_identifier] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_PLUS_DOT] = ACTIONS(3841),
    [anon_sym_DASH_DOT] = ACTIONS(3841),
    [anon_sym_PERCENT] = ACTIONS(3841),
    [anon_sym_AMP_AMP] = ACTIONS(3841),
    [anon_sym_TILDE] = ACTIONS(3839),
    [aux_sym_prefix_op_token1] = ACTIONS(3841),
    [aux_sym_infix_op_token1] = ACTIONS(3839),
    [aux_sym_infix_op_token2] = ACTIONS(3841),
    [anon_sym_PIPE_PIPE] = ACTIONS(3841),
    [anon_sym_BANG_EQ] = ACTIONS(3841),
    [anon_sym_COLON_EQ] = ACTIONS(3839),
    [anon_sym_DOLLAR] = ACTIONS(3841),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3841),
    [sym_int] = ACTIONS(3841),
    [sym_xint] = ACTIONS(3839),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3839),
    [sym__newline] = ACTIONS(3839),
  },
  [2913] = {
    [sym_block_comment] = STATE(2913),
    [sym_compiler_directive_decl] = STATE(2913),
    [sym_fsi_directive_decl] = STATE(2913),
    [sym_preproc_line] = STATE(2913),
    [aux_sym_rules_repeat1] = STATE(2940),
    [sym_identifier] = ACTIONS(3736),
    [anon_sym_EQ] = ACTIONS(3734),
    [anon_sym_COLON] = ACTIONS(3736),
    [anon_sym_return] = ACTIONS(3736),
    [anon_sym_do] = ACTIONS(3736),
    [anon_sym_let] = ACTIONS(3736),
    [anon_sym_let_BANG] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3736),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_null] = ACTIONS(3736),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_COLON] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(5470),
    [anon_sym_AMP] = ACTIONS(3736),
    [anon_sym_LBRACK] = ACTIONS(3736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3734),
    [anon_sym_LBRACE] = ACTIONS(3736),
    [anon_sym_LT_AT] = ACTIONS(3736),
    [anon_sym_LT_AT_AT] = ACTIONS(3736),
    [anon_sym_AT_AT_GT] = ACTIONS(3736),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3734),
    [anon_sym_new] = ACTIONS(3736),
    [anon_sym_return_BANG] = ACTIONS(3734),
    [anon_sym_yield] = ACTIONS(3736),
    [anon_sym_yield_BANG] = ACTIONS(3734),
    [anon_sym_lazy] = ACTIONS(3736),
    [anon_sym_assert] = ACTIONS(3736),
    [anon_sym_upcast] = ACTIONS(3736),
    [anon_sym_downcast] = ACTIONS(3736),
    [anon_sym_COLON_GT] = ACTIONS(3734),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3734),
    [anon_sym_for] = ACTIONS(3736),
    [anon_sym_while] = ACTIONS(3736),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_fun] = ACTIONS(3736),
    [anon_sym_try] = ACTIONS(3736),
    [anon_sym_match] = ACTIONS(3736),
    [anon_sym_match_BANG] = ACTIONS(3734),
    [anon_sym_function] = ACTIONS(3736),
    [anon_sym_LT_DASH] = ACTIONS(3736),
    [anon_sym_DOT_LBRACK] = ACTIONS(3734),
    [anon_sym_LT] = ACTIONS(3734),
    [anon_sym_use] = ACTIONS(3736),
    [anon_sym_use_BANG] = ACTIONS(3734),
    [anon_sym_do_BANG] = ACTIONS(3734),
    [anon_sym_begin] = ACTIONS(3736),
    [anon_sym_LPAREN2] = ACTIONS(3736),
    [anon_sym_or] = ACTIONS(3736),
    [aux_sym_char_token1] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3736),
    [anon_sym_DQUOTE] = ACTIONS(3736),
    [anon_sym_AT_DQUOTE] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [sym_bool] = ACTIONS(3736),
    [sym_unit] = ACTIONS(3734),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3736),
    [sym_op_identifier] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS_DOT] = ACTIONS(3736),
    [anon_sym_DASH_DOT] = ACTIONS(3736),
    [anon_sym_PERCENT] = ACTIONS(3736),
    [anon_sym_AMP_AMP] = ACTIONS(3736),
    [anon_sym_TILDE] = ACTIONS(3734),
    [aux_sym_prefix_op_token1] = ACTIONS(3736),
    [aux_sym_infix_op_token1] = ACTIONS(3734),
    [aux_sym_infix_op_token2] = ACTIONS(3736),
    [anon_sym_PIPE_PIPE] = ACTIONS(3736),
    [anon_sym_BANG_EQ] = ACTIONS(3736),
    [anon_sym_COLON_EQ] = ACTIONS(3734),
    [anon_sym_DOLLAR] = ACTIONS(3736),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3736),
    [sym_int] = ACTIONS(3736),
    [sym_xint] = ACTIONS(3734),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3734),
    [sym__newline] = ACTIONS(5472),
  },
  [2914] = {
    [sym_block_comment] = STATE(2914),
    [sym_compiler_directive_decl] = STATE(2914),
    [sym_fsi_directive_decl] = STATE(2914),
    [sym_preproc_line] = STATE(2914),
    [sym_identifier] = ACTIONS(3828),
    [anon_sym_EQ] = ACTIONS(3826),
    [anon_sym_COLON] = ACTIONS(3828),
    [anon_sym_return] = ACTIONS(3828),
    [anon_sym_do] = ACTIONS(3828),
    [anon_sym_let] = ACTIONS(3828),
    [anon_sym_let_BANG] = ACTIONS(3826),
    [anon_sym_LPAREN] = ACTIONS(3828),
    [anon_sym_COMMA] = ACTIONS(3826),
    [anon_sym_null] = ACTIONS(3828),
    [anon_sym_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_COLON] = ACTIONS(3826),
    [anon_sym_PIPE] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3828),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3826),
    [anon_sym_LBRACE] = ACTIONS(3828),
    [anon_sym_LT_AT] = ACTIONS(3828),
    [anon_sym_LT_AT_AT] = ACTIONS(3828),
    [anon_sym_DOT] = ACTIONS(3828),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3826),
    [anon_sym_new] = ACTIONS(3828),
    [anon_sym_return_BANG] = ACTIONS(3826),
    [anon_sym_yield] = ACTIONS(3828),
    [anon_sym_yield_BANG] = ACTIONS(3826),
    [anon_sym_lazy] = ACTIONS(3828),
    [anon_sym_assert] = ACTIONS(3828),
    [anon_sym_upcast] = ACTIONS(3828),
    [anon_sym_downcast] = ACTIONS(3828),
    [anon_sym_COLON_GT] = ACTIONS(3826),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3826),
    [anon_sym_for] = ACTIONS(3828),
    [anon_sym_while] = ACTIONS(3828),
    [anon_sym_if] = ACTIONS(3828),
    [anon_sym_fun] = ACTIONS(3828),
    [anon_sym_DASH_GT] = ACTIONS(3828),
    [anon_sym_try] = ACTIONS(3828),
    [anon_sym_match] = ACTIONS(3828),
    [anon_sym_match_BANG] = ACTIONS(3826),
    [anon_sym_function] = ACTIONS(3828),
    [anon_sym_LT_DASH] = ACTIONS(3828),
    [anon_sym_DOT_LBRACK] = ACTIONS(3826),
    [anon_sym_LT] = ACTIONS(3826),
    [anon_sym_use] = ACTIONS(3828),
    [anon_sym_use_BANG] = ACTIONS(3826),
    [anon_sym_do_BANG] = ACTIONS(3826),
    [anon_sym_DOT_DOT] = ACTIONS(3826),
    [anon_sym_begin] = ACTIONS(3828),
    [anon_sym_LPAREN2] = ACTIONS(3828),
    [anon_sym_or] = ACTIONS(3828),
    [aux_sym_char_token1] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3828),
    [anon_sym_DQUOTE] = ACTIONS(3828),
    [anon_sym_AT_DQUOTE] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [sym_bool] = ACTIONS(3828),
    [sym_unit] = ACTIONS(3826),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3828),
    [sym_op_identifier] = ACTIONS(3828),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_DASH] = ACTIONS(3828),
    [anon_sym_PLUS_DOT] = ACTIONS(3828),
    [anon_sym_DASH_DOT] = ACTIONS(3828),
    [anon_sym_PERCENT] = ACTIONS(3828),
    [anon_sym_AMP_AMP] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3826),
    [aux_sym_prefix_op_token1] = ACTIONS(3828),
    [aux_sym_infix_op_token1] = ACTIONS(3826),
    [aux_sym_infix_op_token2] = ACTIONS(3828),
    [anon_sym_PIPE_PIPE] = ACTIONS(3828),
    [anon_sym_BANG_EQ] = ACTIONS(3828),
    [anon_sym_COLON_EQ] = ACTIONS(3826),
    [anon_sym_DOLLAR] = ACTIONS(3828),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3828),
    [sym_int] = ACTIONS(3828),
    [sym_xint] = ACTIONS(3826),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3826),
    [sym__newline] = ACTIONS(3826),
  },
  [2915] = {
    [sym_block_comment] = STATE(2915),
    [sym_compiler_directive_decl] = STATE(2915),
    [sym_fsi_directive_decl] = STATE(2915),
    [sym_preproc_line] = STATE(2915),
    [sym_identifier] = ACTIONS(3875),
    [anon_sym_EQ] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(3875),
    [anon_sym_return] = ACTIONS(3875),
    [anon_sym_do] = ACTIONS(3875),
    [anon_sym_let] = ACTIONS(3875),
    [anon_sym_let_BANG] = ACTIONS(3873),
    [anon_sym_as] = ACTIONS(3875),
    [anon_sym_LPAREN] = ACTIONS(3875),
    [anon_sym_COMMA] = ACTIONS(3873),
    [anon_sym_null] = ACTIONS(3875),
    [anon_sym_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_COLON] = ACTIONS(3873),
    [anon_sym_AMP] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(3875),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3873),
    [anon_sym_LBRACE] = ACTIONS(3875),
    [anon_sym_LT_AT] = ACTIONS(3875),
    [anon_sym_LT_AT_AT] = ACTIONS(3875),
    [anon_sym_DOT] = ACTIONS(3875),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3873),
    [anon_sym_new] = ACTIONS(3875),
    [anon_sym_with] = ACTIONS(3875),
    [anon_sym_return_BANG] = ACTIONS(3873),
    [anon_sym_yield] = ACTIONS(3875),
    [anon_sym_yield_BANG] = ACTIONS(3873),
    [anon_sym_lazy] = ACTIONS(3875),
    [anon_sym_assert] = ACTIONS(3875),
    [anon_sym_upcast] = ACTIONS(3875),
    [anon_sym_downcast] = ACTIONS(3875),
    [anon_sym_COLON_GT] = ACTIONS(3873),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3873),
    [anon_sym_for] = ACTIONS(3875),
    [anon_sym_while] = ACTIONS(3875),
    [anon_sym_if] = ACTIONS(3875),
    [anon_sym_fun] = ACTIONS(3875),
    [anon_sym_try] = ACTIONS(3875),
    [anon_sym_match] = ACTIONS(3875),
    [anon_sym_match_BANG] = ACTIONS(3873),
    [anon_sym_function] = ACTIONS(3875),
    [anon_sym_LT_DASH] = ACTIONS(3875),
    [anon_sym_DOT_LBRACK] = ACTIONS(3873),
    [anon_sym_LT] = ACTIONS(3873),
    [anon_sym_use] = ACTIONS(3875),
    [anon_sym_use_BANG] = ACTIONS(3873),
    [anon_sym_do_BANG] = ACTIONS(3873),
    [anon_sym_begin] = ACTIONS(3875),
    [anon_sym_LPAREN2] = ACTIONS(3875),
    [anon_sym_or] = ACTIONS(3875),
    [aux_sym_char_token1] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3875),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [anon_sym_AT_DQUOTE] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [sym_bool] = ACTIONS(3875),
    [sym_unit] = ACTIONS(3873),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3875),
    [sym_op_identifier] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS_DOT] = ACTIONS(3875),
    [anon_sym_DASH_DOT] = ACTIONS(3875),
    [anon_sym_PERCENT] = ACTIONS(3875),
    [anon_sym_AMP_AMP] = ACTIONS(3875),
    [anon_sym_TILDE] = ACTIONS(3873),
    [aux_sym_prefix_op_token1] = ACTIONS(3875),
    [aux_sym_infix_op_token1] = ACTIONS(3873),
    [aux_sym_infix_op_token2] = ACTIONS(3875),
    [anon_sym_PIPE_PIPE] = ACTIONS(3875),
    [anon_sym_BANG_EQ] = ACTIONS(3875),
    [anon_sym_COLON_EQ] = ACTIONS(3873),
    [anon_sym_DOLLAR] = ACTIONS(3875),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3875),
    [sym_int] = ACTIONS(3875),
    [sym_xint] = ACTIONS(3873),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3873),
    [sym__newline] = ACTIONS(3873),
    [sym__dedent] = ACTIONS(3873),
  },
  [2916] = {
    [sym_block_comment] = STATE(2916),
    [sym_compiler_directive_decl] = STATE(2916),
    [sym_fsi_directive_decl] = STATE(2916),
    [sym_preproc_line] = STATE(2916),
    [sym_identifier] = ACTIONS(3813),
    [anon_sym_EQ] = ACTIONS(3811),
    [anon_sym_COLON] = ACTIONS(3813),
    [anon_sym_return] = ACTIONS(3813),
    [anon_sym_do] = ACTIONS(3813),
    [anon_sym_let] = ACTIONS(3813),
    [anon_sym_let_BANG] = ACTIONS(3811),
    [anon_sym_LPAREN] = ACTIONS(3813),
    [anon_sym_COMMA] = ACTIONS(3811),
    [anon_sym_null] = ACTIONS(3813),
    [anon_sym_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_COLON] = ACTIONS(3811),
    [anon_sym_AMP] = ACTIONS(3813),
    [anon_sym_LBRACK] = ACTIONS(3813),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3811),
    [anon_sym_LBRACE] = ACTIONS(3813),
    [anon_sym_LT_AT] = ACTIONS(3813),
    [anon_sym_LT_AT_AT] = ACTIONS(3813),
    [anon_sym_DOT] = ACTIONS(3813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3811),
    [anon_sym_new] = ACTIONS(3813),
    [anon_sym_return_BANG] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_yield_BANG] = ACTIONS(3811),
    [anon_sym_lazy] = ACTIONS(3813),
    [anon_sym_assert] = ACTIONS(3813),
    [anon_sym_upcast] = ACTIONS(3813),
    [anon_sym_downcast] = ACTIONS(3813),
    [anon_sym_COLON_GT] = ACTIONS(3811),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3811),
    [anon_sym_for] = ACTIONS(3813),
    [anon_sym_done] = ACTIONS(5475),
    [anon_sym_while] = ACTIONS(3813),
    [anon_sym_if] = ACTIONS(3813),
    [anon_sym_fun] = ACTIONS(3813),
    [anon_sym_DASH_GT] = ACTIONS(3813),
    [anon_sym_try] = ACTIONS(3813),
    [anon_sym_match] = ACTIONS(3813),
    [anon_sym_match_BANG] = ACTIONS(3811),
    [anon_sym_function] = ACTIONS(3813),
    [anon_sym_LT_DASH] = ACTIONS(3813),
    [anon_sym_DOT_LBRACK] = ACTIONS(3811),
    [anon_sym_LT] = ACTIONS(3811),
    [anon_sym_use] = ACTIONS(3813),
    [anon_sym_use_BANG] = ACTIONS(3811),
    [anon_sym_do_BANG] = ACTIONS(3811),
    [anon_sym_DOT_DOT] = ACTIONS(3811),
    [anon_sym_begin] = ACTIONS(3813),
    [anon_sym_LPAREN2] = ACTIONS(3813),
    [anon_sym_or] = ACTIONS(3813),
    [aux_sym_char_token1] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3813),
    [anon_sym_DQUOTE] = ACTIONS(3813),
    [anon_sym_AT_DQUOTE] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [sym_bool] = ACTIONS(3813),
    [sym_unit] = ACTIONS(3811),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3813),
    [sym_op_identifier] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PLUS_DOT] = ACTIONS(3813),
    [anon_sym_DASH_DOT] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3813),
    [anon_sym_AMP_AMP] = ACTIONS(3813),
    [anon_sym_TILDE] = ACTIONS(3811),
    [aux_sym_prefix_op_token1] = ACTIONS(3813),
    [aux_sym_infix_op_token1] = ACTIONS(3811),
    [aux_sym_infix_op_token2] = ACTIONS(3813),
    [anon_sym_PIPE_PIPE] = ACTIONS(3813),
    [anon_sym_BANG_EQ] = ACTIONS(3813),
    [anon_sym_COLON_EQ] = ACTIONS(3811),
    [anon_sym_DOLLAR] = ACTIONS(3813),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3813),
    [sym_int] = ACTIONS(3813),
    [sym_xint] = ACTIONS(3811),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3811),
    [sym__newline] = ACTIONS(3811),
  },
  [2917] = {
    [sym_block_comment] = STATE(2917),
    [sym_compiler_directive_decl] = STATE(2917),
    [sym_fsi_directive_decl] = STATE(2917),
    [sym_preproc_line] = STATE(2917),
    [sym_identifier] = ACTIONS(3800),
    [anon_sym_EQ] = ACTIONS(3798),
    [anon_sym_COLON] = ACTIONS(3800),
    [anon_sym_return] = ACTIONS(3800),
    [anon_sym_do] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_let_BANG] = ACTIONS(3798),
    [anon_sym_as] = ACTIONS(3800),
    [anon_sym_LPAREN] = ACTIONS(3800),
    [anon_sym_COMMA] = ACTIONS(3798),
    [anon_sym_null] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_COLON] = ACTIONS(3798),
    [anon_sym_PIPE] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3800),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3798),
    [anon_sym_LBRACE] = ACTIONS(3800),
    [anon_sym_LT_AT] = ACTIONS(3800),
    [anon_sym_LT_AT_AT] = ACTIONS(3800),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3798),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_with] = ACTIONS(3800),
    [anon_sym_return_BANG] = ACTIONS(3798),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_yield_BANG] = ACTIONS(3798),
    [anon_sym_lazy] = ACTIONS(3800),
    [anon_sym_assert] = ACTIONS(3800),
    [anon_sym_upcast] = ACTIONS(3800),
    [anon_sym_downcast] = ACTIONS(3800),
    [anon_sym_COLON_GT] = ACTIONS(3798),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3798),
    [anon_sym_for] = ACTIONS(3800),
    [anon_sym_while] = ACTIONS(3800),
    [anon_sym_if] = ACTIONS(3800),
    [anon_sym_fun] = ACTIONS(3800),
    [anon_sym_try] = ACTIONS(3800),
    [anon_sym_match] = ACTIONS(3800),
    [anon_sym_match_BANG] = ACTIONS(3798),
    [anon_sym_function] = ACTIONS(3800),
    [anon_sym_LT_DASH] = ACTIONS(3800),
    [anon_sym_DOT_LBRACK] = ACTIONS(3798),
    [anon_sym_LT] = ACTIONS(3798),
    [anon_sym_use] = ACTIONS(3800),
    [anon_sym_use_BANG] = ACTIONS(3798),
    [anon_sym_do_BANG] = ACTIONS(3798),
    [anon_sym_begin] = ACTIONS(3800),
    [anon_sym_LPAREN2] = ACTIONS(3800),
    [anon_sym_or] = ACTIONS(3800),
    [aux_sym_char_token1] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3800),
    [anon_sym_DQUOTE] = ACTIONS(3800),
    [anon_sym_AT_DQUOTE] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [sym_bool] = ACTIONS(3800),
    [sym_unit] = ACTIONS(3798),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3800),
    [sym_op_identifier] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS_DOT] = ACTIONS(3800),
    [anon_sym_DASH_DOT] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3800),
    [anon_sym_AMP_AMP] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3798),
    [aux_sym_prefix_op_token1] = ACTIONS(3800),
    [aux_sym_infix_op_token1] = ACTIONS(3798),
    [aux_sym_infix_op_token2] = ACTIONS(3800),
    [anon_sym_PIPE_PIPE] = ACTIONS(3800),
    [anon_sym_BANG_EQ] = ACTIONS(3800),
    [anon_sym_COLON_EQ] = ACTIONS(3798),
    [anon_sym_DOLLAR] = ACTIONS(3800),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3800),
    [sym_int] = ACTIONS(3800),
    [sym_xint] = ACTIONS(3798),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3798),
    [sym__newline] = ACTIONS(3798),
  },
  [2918] = {
    [sym_block_comment] = STATE(2918),
    [sym_compiler_directive_decl] = STATE(2918),
    [sym_fsi_directive_decl] = STATE(2918),
    [sym_preproc_line] = STATE(2918),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [anon_sym_as] = ACTIONS(3743),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_with] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_or] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [sym__newline] = ACTIONS(3741),
  },
  [2919] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7665),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(2919),
    [sym_compiler_directive_decl] = STATE(2919),
    [sym_fsi_directive_decl] = STATE(2919),
    [sym_preproc_line] = STATE(2919),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym_repeat_pattern_repeat1] = STATE(4823),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(5365),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_COLON] = ACTIONS(5363),
    [anon_sym_as] = ACTIONS(5460),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_RPAREN] = ACTIONS(5365),
    [anon_sym_COMMA] = ACTIONS(5462),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_COLON_COLON] = ACTIONS(5464),
    [anon_sym_PIPE] = ACTIONS(5466),
    [anon_sym_AMP] = ACTIONS(5468),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [anon_sym_LT2] = ACTIONS(5365),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2920] = {
    [sym_block_comment] = STATE(2920),
    [sym_compiler_directive_decl] = STATE(2920),
    [sym_fsi_directive_decl] = STATE(2920),
    [sym_preproc_line] = STATE(2920),
    [aux_sym_long_identifier_repeat1] = STATE(2845),
    [sym_identifier] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3781),
    [anon_sym_COLON] = ACTIONS(3781),
    [anon_sym_return] = ACTIONS(3781),
    [anon_sym_do] = ACTIONS(3781),
    [anon_sym_let] = ACTIONS(3781),
    [anon_sym_let_BANG] = ACTIONS(3778),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3778),
    [anon_sym_null] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3781),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_LT_AT] = ACTIONS(3781),
    [anon_sym_LT_AT_AT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(5477),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3778),
    [anon_sym_new] = ACTIONS(3781),
    [anon_sym_with] = ACTIONS(3781),
    [anon_sym_return_BANG] = ACTIONS(3778),
    [anon_sym_yield] = ACTIONS(3781),
    [anon_sym_yield_BANG] = ACTIONS(3778),
    [anon_sym_lazy] = ACTIONS(3781),
    [anon_sym_assert] = ACTIONS(3781),
    [anon_sym_upcast] = ACTIONS(3781),
    [anon_sym_downcast] = ACTIONS(3781),
    [anon_sym_COLON_GT] = ACTIONS(3778),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3778),
    [anon_sym_for] = ACTIONS(3781),
    [anon_sym_while] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_fun] = ACTIONS(3781),
    [anon_sym_try] = ACTIONS(3781),
    [anon_sym_match] = ACTIONS(3781),
    [anon_sym_match_BANG] = ACTIONS(3778),
    [anon_sym_function] = ACTIONS(3781),
    [anon_sym_LT_DASH] = ACTIONS(3781),
    [anon_sym_DOT_LBRACK] = ACTIONS(3778),
    [anon_sym_LT] = ACTIONS(3778),
    [anon_sym_use] = ACTIONS(3781),
    [anon_sym_use_BANG] = ACTIONS(3778),
    [anon_sym_do_BANG] = ACTIONS(3778),
    [anon_sym_begin] = ACTIONS(3781),
    [anon_sym_LPAREN2] = ACTIONS(3781),
    [anon_sym_or] = ACTIONS(3781),
    [anon_sym_EQ2] = ACTIONS(3492),
    [aux_sym_char_token1] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3781),
    [anon_sym_DQUOTE] = ACTIONS(3781),
    [anon_sym_AT_DQUOTE] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [sym_bool] = ACTIONS(3781),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3781),
    [sym_op_identifier] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3781),
    [anon_sym_DASH] = ACTIONS(3781),
    [anon_sym_PLUS_DOT] = ACTIONS(3781),
    [anon_sym_DASH_DOT] = ACTIONS(3781),
    [anon_sym_PERCENT] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3781),
    [anon_sym_TILDE] = ACTIONS(3778),
    [aux_sym_prefix_op_token1] = ACTIONS(3781),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token2] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_COLON_EQ] = ACTIONS(3778),
    [anon_sym_DOLLAR] = ACTIONS(3781),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3781),
    [sym_int] = ACTIONS(3781),
    [sym_xint] = ACTIONS(3778),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3778),
    [sym__newline] = ACTIONS(3778),
  },
  [2921] = {
    [sym_block_comment] = STATE(2921),
    [sym_compiler_directive_decl] = STATE(2921),
    [sym_fsi_directive_decl] = STATE(2921),
    [sym_preproc_line] = STATE(2921),
    [aux_sym_sequential_expression_repeat1] = STATE(2921),
    [sym_identifier] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3765),
    [anon_sym_COLON] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_and] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_let_BANG] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(3767),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_null] = ACTIONS(3767),
    [anon_sym_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3765),
    [anon_sym_LBRACE] = ACTIONS(3767),
    [anon_sym_LT_AT] = ACTIONS(3767),
    [anon_sym_LT_AT_AT] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3765),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_return_BANG] = ACTIONS(3765),
    [anon_sym_yield] = ACTIONS(3767),
    [anon_sym_yield_BANG] = ACTIONS(3765),
    [anon_sym_lazy] = ACTIONS(3767),
    [anon_sym_assert] = ACTIONS(3767),
    [anon_sym_upcast] = ACTIONS(3767),
    [anon_sym_downcast] = ACTIONS(3767),
    [anon_sym_COLON_GT] = ACTIONS(3765),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3765),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_fun] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_match] = ACTIONS(3767),
    [anon_sym_match_BANG] = ACTIONS(3765),
    [anon_sym_function] = ACTIONS(3767),
    [anon_sym_LT_DASH] = ACTIONS(3767),
    [anon_sym_DOT_LBRACK] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(3765),
    [anon_sym_use] = ACTIONS(3767),
    [anon_sym_use_BANG] = ACTIONS(3765),
    [anon_sym_do_BANG] = ACTIONS(3765),
    [anon_sym_begin] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3767),
    [anon_sym_or] = ACTIONS(3767),
    [aux_sym_char_token1] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3767),
    [anon_sym_DQUOTE] = ACTIONS(3767),
    [anon_sym_AT_DQUOTE] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [sym_bool] = ACTIONS(3767),
    [sym_unit] = ACTIONS(3765),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3767),
    [sym_op_identifier] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_PLUS_DOT] = ACTIONS(3767),
    [anon_sym_DASH_DOT] = ACTIONS(3767),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_AMP_AMP] = ACTIONS(3767),
    [anon_sym_TILDE] = ACTIONS(3765),
    [aux_sym_prefix_op_token1] = ACTIONS(3767),
    [aux_sym_infix_op_token1] = ACTIONS(3765),
    [aux_sym_infix_op_token2] = ACTIONS(3767),
    [anon_sym_PIPE_PIPE] = ACTIONS(3767),
    [anon_sym_BANG_EQ] = ACTIONS(3767),
    [anon_sym_COLON_EQ] = ACTIONS(3765),
    [anon_sym_DOLLAR] = ACTIONS(3767),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3767),
    [sym_int] = ACTIONS(3767),
    [sym_xint] = ACTIONS(3765),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3765),
    [sym__newline] = ACTIONS(5481),
    [sym__dedent] = ACTIONS(3765),
  },
  [2922] = {
    [sym_block_comment] = STATE(2922),
    [sym_compiler_directive_decl] = STATE(2922),
    [sym_fsi_directive_decl] = STATE(2922),
    [sym_preproc_line] = STATE(2922),
    [aux_sym_rules_repeat1] = STATE(2873),
    [sym_identifier] = ACTIONS(3736),
    [anon_sym_EQ] = ACTIONS(3734),
    [anon_sym_COLON] = ACTIONS(3736),
    [anon_sym_return] = ACTIONS(3736),
    [anon_sym_do] = ACTIONS(3736),
    [anon_sym_let] = ACTIONS(3736),
    [anon_sym_let_BANG] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3736),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_null] = ACTIONS(3736),
    [anon_sym_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_COLON] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(5401),
    [anon_sym_AMP] = ACTIONS(3736),
    [anon_sym_LBRACK] = ACTIONS(3736),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3734),
    [anon_sym_LBRACE] = ACTIONS(3736),
    [anon_sym_LT_AT] = ACTIONS(3736),
    [anon_sym_AT_GT] = ACTIONS(3736),
    [anon_sym_LT_AT_AT] = ACTIONS(3736),
    [anon_sym_DOT] = ACTIONS(3736),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3734),
    [anon_sym_new] = ACTIONS(3736),
    [anon_sym_return_BANG] = ACTIONS(3734),
    [anon_sym_yield] = ACTIONS(3736),
    [anon_sym_yield_BANG] = ACTIONS(3734),
    [anon_sym_lazy] = ACTIONS(3736),
    [anon_sym_assert] = ACTIONS(3736),
    [anon_sym_upcast] = ACTIONS(3736),
    [anon_sym_downcast] = ACTIONS(3736),
    [anon_sym_COLON_GT] = ACTIONS(3734),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3734),
    [anon_sym_for] = ACTIONS(3736),
    [anon_sym_while] = ACTIONS(3736),
    [anon_sym_if] = ACTIONS(3736),
    [anon_sym_fun] = ACTIONS(3736),
    [anon_sym_try] = ACTIONS(3736),
    [anon_sym_match] = ACTIONS(3736),
    [anon_sym_match_BANG] = ACTIONS(3734),
    [anon_sym_function] = ACTIONS(3736),
    [anon_sym_LT_DASH] = ACTIONS(3736),
    [anon_sym_DOT_LBRACK] = ACTIONS(3734),
    [anon_sym_LT] = ACTIONS(3734),
    [anon_sym_use] = ACTIONS(3736),
    [anon_sym_use_BANG] = ACTIONS(3734),
    [anon_sym_do_BANG] = ACTIONS(3734),
    [anon_sym_begin] = ACTIONS(3736),
    [anon_sym_LPAREN2] = ACTIONS(3736),
    [anon_sym_or] = ACTIONS(3736),
    [aux_sym_char_token1] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3736),
    [anon_sym_DQUOTE] = ACTIONS(3736),
    [anon_sym_AT_DQUOTE] = ACTIONS(3734),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3734),
    [sym_bool] = ACTIONS(3736),
    [sym_unit] = ACTIONS(3734),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3736),
    [sym_op_identifier] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS_DOT] = ACTIONS(3736),
    [anon_sym_DASH_DOT] = ACTIONS(3736),
    [anon_sym_PERCENT] = ACTIONS(3736),
    [anon_sym_AMP_AMP] = ACTIONS(3736),
    [anon_sym_TILDE] = ACTIONS(3734),
    [aux_sym_prefix_op_token1] = ACTIONS(3736),
    [aux_sym_infix_op_token1] = ACTIONS(3734),
    [aux_sym_infix_op_token2] = ACTIONS(3736),
    [anon_sym_PIPE_PIPE] = ACTIONS(3736),
    [anon_sym_BANG_EQ] = ACTIONS(3736),
    [anon_sym_COLON_EQ] = ACTIONS(3734),
    [anon_sym_DOLLAR] = ACTIONS(3736),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3736),
    [sym_int] = ACTIONS(3736),
    [sym_xint] = ACTIONS(3734),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3734),
    [sym__newline] = ACTIONS(5484),
  },
  [2923] = {
    [sym_block_comment] = STATE(2923),
    [sym_compiler_directive_decl] = STATE(2923),
    [sym_fsi_directive_decl] = STATE(2923),
    [sym_preproc_line] = STATE(2923),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_AT_AT_GT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_done] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_DOT_DOT] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [2924] = {
    [sym_block_comment] = STATE(2924),
    [sym_compiler_directive_decl] = STATE(2924),
    [sym_fsi_directive_decl] = STATE(2924),
    [sym_preproc_line] = STATE(2924),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_f] = ACTIONS(3421),
    [aux_sym_decimal_token1] = ACTIONS(3305),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [anon_sym_POUNDendif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [2925] = {
    [sym_block_comment] = STATE(2925),
    [sym_compiler_directive_decl] = STATE(2925),
    [sym_fsi_directive_decl] = STATE(2925),
    [sym_preproc_line] = STATE(2925),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [anon_sym_as] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_with] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(5310),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
  },
  [2926] = {
    [sym_block_comment] = STATE(2926),
    [sym_compiler_directive_decl] = STATE(2926),
    [sym_fsi_directive_decl] = STATE(2926),
    [sym_preproc_line] = STATE(2926),
    [aux_sym_long_identifier_repeat1] = STATE(2926),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_as] = ACTIONS(3487),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(5487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [2927] = {
    [sym_block_comment] = STATE(2927),
    [sym_compiler_directive_decl] = STATE(2927),
    [sym_fsi_directive_decl] = STATE(2927),
    [sym_preproc_line] = STATE(2927),
    [sym_identifier] = ACTIONS(3863),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_let] = ACTIONS(3863),
    [anon_sym_let_BANG] = ACTIONS(3861),
    [anon_sym_as] = ACTIONS(3863),
    [anon_sym_LPAREN] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3861),
    [anon_sym_null] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_COLON] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_LT_AT] = ACTIONS(3863),
    [anon_sym_LT_AT_AT] = ACTIONS(3863),
    [anon_sym_DOT] = ACTIONS(3863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3861),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_with] = ACTIONS(3863),
    [anon_sym_return_BANG] = ACTIONS(3861),
    [anon_sym_yield] = ACTIONS(3863),
    [anon_sym_yield_BANG] = ACTIONS(3861),
    [anon_sym_lazy] = ACTIONS(3863),
    [anon_sym_assert] = ACTIONS(3863),
    [anon_sym_upcast] = ACTIONS(3863),
    [anon_sym_downcast] = ACTIONS(3863),
    [anon_sym_COLON_GT] = ACTIONS(3861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_fun] = ACTIONS(3863),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_match] = ACTIONS(3863),
    [anon_sym_match_BANG] = ACTIONS(3861),
    [anon_sym_function] = ACTIONS(3863),
    [anon_sym_LT_DASH] = ACTIONS(3863),
    [anon_sym_DOT_LBRACK] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_use] = ACTIONS(3863),
    [anon_sym_use_BANG] = ACTIONS(3861),
    [anon_sym_do_BANG] = ACTIONS(3861),
    [anon_sym_begin] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(3863),
    [anon_sym_or] = ACTIONS(3863),
    [aux_sym_char_token1] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [anon_sym_AT_DQUOTE] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [sym_bool] = ACTIONS(3863),
    [sym_unit] = ACTIONS(3861),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3863),
    [sym_op_identifier] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_DOT] = ACTIONS(3863),
    [anon_sym_DASH_DOT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3861),
    [aux_sym_prefix_op_token1] = ACTIONS(3863),
    [aux_sym_infix_op_token1] = ACTIONS(3861),
    [aux_sym_infix_op_token2] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_COLON_EQ] = ACTIONS(3861),
    [anon_sym_DOLLAR] = ACTIONS(3863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3863),
    [sym_int] = ACTIONS(3863),
    [sym_xint] = ACTIONS(3861),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3861),
    [sym__newline] = ACTIONS(3861),
    [sym__dedent] = ACTIONS(3861),
  },
  [2928] = {
    [sym_attributes] = STATE(3905),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(8258),
    [sym__pattern] = STATE(7872),
    [sym_optional_pattern] = STATE(8258),
    [sym_type_check_pattern] = STATE(8258),
    [sym_attribute_pattern] = STATE(8258),
    [sym_paren_pattern] = STATE(8258),
    [sym_as_pattern] = STATE(8258),
    [sym_cons_pattern] = STATE(8258),
    [sym_disjunct_pattern] = STATE(8258),
    [sym_conjunct_pattern] = STATE(8258),
    [sym_typed_pattern] = STATE(8258),
    [sym_list_pattern] = STATE(8258),
    [sym_array_pattern] = STATE(8258),
    [sym_record_pattern] = STATE(8258),
    [sym_named_field_pattern] = STATE(8258),
    [sym_identifier_pattern] = STATE(8258),
    [sym_long_identifier_or_op] = STATE(2968),
    [sym_char] = STATE(8017),
    [sym_format_string] = STATE(8065),
    [sym__string_literal] = STATE(8065),
    [sym_string] = STATE(8017),
    [sym_verbatim_string] = STATE(8017),
    [sym_bytearray] = STATE(8017),
    [sym_verbatim_bytearray] = STATE(8017),
    [sym_format_triple_quoted_string] = STATE(8066),
    [sym_triple_quoted_string] = STATE(8017),
    [sym_const] = STATE(8258),
    [sym_long_identifier] = STATE(4907),
    [sym_active_pattern] = STATE(5059),
    [sym__identifier_or_op] = STATE(4927),
    [sym_sbyte] = STATE(8017),
    [sym_byte] = STATE(8017),
    [sym_int16] = STATE(8017),
    [sym_uint16] = STATE(8017),
    [sym_int32] = STATE(8017),
    [sym_uint32] = STATE(8017),
    [sym_nativeint] = STATE(8017),
    [sym_unativeint] = STATE(8017),
    [sym_int64] = STATE(8017),
    [sym_uint64] = STATE(8017),
    [sym_ieee32] = STATE(8017),
    [sym_ieee64] = STATE(8017),
    [sym_bignum] = STATE(8017),
    [sym_decimal] = STATE(8017),
    [sym_float] = STATE(7544),
    [sym_block_comment] = STATE(2928),
    [sym_compiler_directive_decl] = STATE(2928),
    [sym_fsi_directive_decl] = STATE(2928),
    [sym_preproc_line] = STATE(2928),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym_repeat_pattern_repeat1] = STATE(4826),
    [sym_identifier] = ACTIONS(5490),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_COLON] = ACTIONS(5363),
    [anon_sym_as] = ACTIONS(5367),
    [anon_sym_LPAREN] = ACTIONS(5492),
    [anon_sym_RPAREN] = ACTIONS(5365),
    [anon_sym_COMMA] = ACTIONS(5369),
    [anon_sym_null] = ACTIONS(5494),
    [anon_sym__] = ACTIONS(5496),
    [anon_sym_QMARK] = ACTIONS(5498),
    [anon_sym_COLON_QMARK] = ACTIONS(5500),
    [anon_sym_COLON_COLON] = ACTIONS(5371),
    [anon_sym_PIPE] = ACTIONS(5373),
    [anon_sym_AMP] = ACTIONS(5375),
    [anon_sym_LBRACK] = ACTIONS(5502),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5504),
    [anon_sym_LBRACE] = ACTIONS(5506),
    [anon_sym_RBRACE] = ACTIONS(5365),
    [aux_sym_char_token1] = ACTIONS(5508),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5510),
    [anon_sym_DQUOTE] = ACTIONS(5512),
    [anon_sym_AT_DQUOTE] = ACTIONS(5514),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5516),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5518),
    [sym_bool] = ACTIONS(5520),
    [sym_unit] = ACTIONS(5522),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5524),
    [sym_op_identifier] = ACTIONS(5526),
    [sym_int] = ACTIONS(5528),
    [sym_xint] = ACTIONS(5530),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [sym__newline] = ACTIONS(5365),
  },
  [2929] = {
    [sym_block_comment] = STATE(2929),
    [sym_compiler_directive_decl] = STATE(2929),
    [sym_fsi_directive_decl] = STATE(2929),
    [sym_preproc_line] = STATE(2929),
    [sym_identifier] = ACTIONS(3856),
    [anon_sym_EQ] = ACTIONS(3854),
    [anon_sym_COLON] = ACTIONS(3856),
    [anon_sym_return] = ACTIONS(3856),
    [anon_sym_do] = ACTIONS(3856),
    [anon_sym_let] = ACTIONS(3856),
    [anon_sym_let_BANG] = ACTIONS(3854),
    [anon_sym_as] = ACTIONS(3856),
    [anon_sym_LPAREN] = ACTIONS(3856),
    [anon_sym_COMMA] = ACTIONS(3854),
    [anon_sym_null] = ACTIONS(3856),
    [anon_sym_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_AMP] = ACTIONS(3856),
    [anon_sym_LBRACK] = ACTIONS(3856),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3854),
    [anon_sym_LBRACE] = ACTIONS(3856),
    [anon_sym_LT_AT] = ACTIONS(3856),
    [anon_sym_LT_AT_AT] = ACTIONS(3856),
    [anon_sym_DOT] = ACTIONS(3856),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3854),
    [anon_sym_new] = ACTIONS(3856),
    [anon_sym_with] = ACTIONS(3856),
    [anon_sym_return_BANG] = ACTIONS(3854),
    [anon_sym_yield] = ACTIONS(3856),
    [anon_sym_yield_BANG] = ACTIONS(3854),
    [anon_sym_lazy] = ACTIONS(3856),
    [anon_sym_assert] = ACTIONS(3856),
    [anon_sym_upcast] = ACTIONS(3856),
    [anon_sym_downcast] = ACTIONS(3856),
    [anon_sym_COLON_GT] = ACTIONS(3854),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3854),
    [anon_sym_for] = ACTIONS(3856),
    [anon_sym_while] = ACTIONS(3856),
    [anon_sym_if] = ACTIONS(3856),
    [anon_sym_fun] = ACTIONS(3856),
    [anon_sym_try] = ACTIONS(3856),
    [anon_sym_match] = ACTIONS(3856),
    [anon_sym_match_BANG] = ACTIONS(3854),
    [anon_sym_function] = ACTIONS(3856),
    [anon_sym_LT_DASH] = ACTIONS(3856),
    [anon_sym_DOT_LBRACK] = ACTIONS(3854),
    [anon_sym_LT] = ACTIONS(3854),
    [anon_sym_use] = ACTIONS(3856),
    [anon_sym_use_BANG] = ACTIONS(3854),
    [anon_sym_do_BANG] = ACTIONS(3854),
    [anon_sym_begin] = ACTIONS(3856),
    [anon_sym_LPAREN2] = ACTIONS(3856),
    [anon_sym_or] = ACTIONS(3856),
    [aux_sym_char_token1] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3856),
    [anon_sym_DQUOTE] = ACTIONS(3856),
    [anon_sym_AT_DQUOTE] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [sym_bool] = ACTIONS(3856),
    [sym_unit] = ACTIONS(3854),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3856),
    [sym_op_identifier] = ACTIONS(3856),
    [anon_sym_PLUS] = ACTIONS(3856),
    [anon_sym_DASH] = ACTIONS(3856),
    [anon_sym_PLUS_DOT] = ACTIONS(3856),
    [anon_sym_DASH_DOT] = ACTIONS(3856),
    [anon_sym_PERCENT] = ACTIONS(3856),
    [anon_sym_AMP_AMP] = ACTIONS(3856),
    [anon_sym_TILDE] = ACTIONS(3854),
    [aux_sym_prefix_op_token1] = ACTIONS(3856),
    [aux_sym_infix_op_token1] = ACTIONS(3854),
    [aux_sym_infix_op_token2] = ACTIONS(3856),
    [anon_sym_PIPE_PIPE] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3856),
    [anon_sym_COLON_EQ] = ACTIONS(3854),
    [anon_sym_DOLLAR] = ACTIONS(3856),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3856),
    [sym_int] = ACTIONS(3856),
    [sym_xint] = ACTIONS(3854),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3854),
    [sym__newline] = ACTIONS(3854),
    [sym__dedent] = ACTIONS(3854),
  },
  [2930] = {
    [sym_block_comment] = STATE(2930),
    [sym_compiler_directive_decl] = STATE(2930),
    [sym_fsi_directive_decl] = STATE(2930),
    [sym_preproc_line] = STATE(2930),
    [sym_identifier] = ACTIONS(4112),
    [anon_sym_EQ] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4112),
    [anon_sym_return] = ACTIONS(4112),
    [anon_sym_do] = ACTIONS(4112),
    [anon_sym_let] = ACTIONS(4112),
    [anon_sym_let_BANG] = ACTIONS(4110),
    [anon_sym_as] = ACTIONS(4112),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_null] = ACTIONS(4112),
    [anon_sym_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_COLON] = ACTIONS(4110),
    [anon_sym_AMP] = ACTIONS(4112),
    [anon_sym_LBRACK] = ACTIONS(4112),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4110),
    [anon_sym_LBRACE] = ACTIONS(4112),
    [anon_sym_LT_AT] = ACTIONS(4112),
    [anon_sym_LT_AT_AT] = ACTIONS(4112),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4110),
    [anon_sym_new] = ACTIONS(4112),
    [anon_sym_with] = ACTIONS(4112),
    [anon_sym_return_BANG] = ACTIONS(4110),
    [anon_sym_yield] = ACTIONS(4112),
    [anon_sym_yield_BANG] = ACTIONS(4110),
    [anon_sym_lazy] = ACTIONS(4112),
    [anon_sym_assert] = ACTIONS(4112),
    [anon_sym_upcast] = ACTIONS(4112),
    [anon_sym_downcast] = ACTIONS(4112),
    [anon_sym_COLON_GT] = ACTIONS(4110),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4110),
    [anon_sym_for] = ACTIONS(4112),
    [anon_sym_while] = ACTIONS(4112),
    [anon_sym_if] = ACTIONS(4112),
    [anon_sym_fun] = ACTIONS(4112),
    [anon_sym_try] = ACTIONS(4112),
    [anon_sym_match] = ACTIONS(4112),
    [anon_sym_match_BANG] = ACTIONS(4110),
    [anon_sym_function] = ACTIONS(4112),
    [anon_sym_LT_DASH] = ACTIONS(4112),
    [anon_sym_DOT_LBRACK] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(4110),
    [anon_sym_use] = ACTIONS(4112),
    [anon_sym_use_BANG] = ACTIONS(4110),
    [anon_sym_do_BANG] = ACTIONS(4110),
    [anon_sym_begin] = ACTIONS(4112),
    [anon_sym_LPAREN2] = ACTIONS(4112),
    [anon_sym_or] = ACTIONS(4112),
    [aux_sym_char_token1] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4112),
    [anon_sym_DQUOTE] = ACTIONS(4112),
    [anon_sym_AT_DQUOTE] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [sym_bool] = ACTIONS(4112),
    [sym_unit] = ACTIONS(4110),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4112),
    [sym_op_identifier] = ACTIONS(4112),
    [anon_sym_PLUS] = ACTIONS(4112),
    [anon_sym_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_DOT] = ACTIONS(4112),
    [anon_sym_DASH_DOT] = ACTIONS(4112),
    [anon_sym_PERCENT] = ACTIONS(4112),
    [anon_sym_AMP_AMP] = ACTIONS(4112),
    [anon_sym_TILDE] = ACTIONS(4110),
    [aux_sym_prefix_op_token1] = ACTIONS(4112),
    [aux_sym_infix_op_token1] = ACTIONS(4110),
    [aux_sym_infix_op_token2] = ACTIONS(4112),
    [anon_sym_PIPE_PIPE] = ACTIONS(4112),
    [anon_sym_BANG_EQ] = ACTIONS(4112),
    [anon_sym_COLON_EQ] = ACTIONS(4110),
    [anon_sym_DOLLAR] = ACTIONS(4112),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4112),
    [sym_int] = ACTIONS(4112),
    [sym_xint] = ACTIONS(4110),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4110),
    [sym__newline] = ACTIONS(4110),
    [sym__dedent] = ACTIONS(4110),
  },
  [2931] = {
    [sym_block_comment] = STATE(2931),
    [sym_compiler_directive_decl] = STATE(2931),
    [sym_fsi_directive_decl] = STATE(2931),
    [sym_preproc_line] = STATE(2931),
    [aux_sym_rules_repeat1] = STATE(2931),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_AT_AT_GT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_or] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [sym__newline] = ACTIONS(5535),
  },
  [2932] = {
    [sym_block_comment] = STATE(2932),
    [sym_compiler_directive_decl] = STATE(2932),
    [sym_fsi_directive_decl] = STATE(2932),
    [sym_preproc_line] = STATE(2932),
    [sym_identifier] = ACTIONS(4108),
    [anon_sym_EQ] = ACTIONS(4106),
    [anon_sym_COLON] = ACTIONS(4108),
    [anon_sym_return] = ACTIONS(4108),
    [anon_sym_do] = ACTIONS(4108),
    [anon_sym_let] = ACTIONS(4108),
    [anon_sym_let_BANG] = ACTIONS(4106),
    [anon_sym_as] = ACTIONS(4108),
    [anon_sym_LPAREN] = ACTIONS(4108),
    [anon_sym_COMMA] = ACTIONS(4106),
    [anon_sym_null] = ACTIONS(4108),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_COLON] = ACTIONS(4106),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LBRACK] = ACTIONS(4108),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(4108),
    [anon_sym_LT_AT] = ACTIONS(4108),
    [anon_sym_LT_AT_AT] = ACTIONS(4108),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4106),
    [anon_sym_new] = ACTIONS(4108),
    [anon_sym_with] = ACTIONS(4108),
    [anon_sym_return_BANG] = ACTIONS(4106),
    [anon_sym_yield] = ACTIONS(4108),
    [anon_sym_yield_BANG] = ACTIONS(4106),
    [anon_sym_lazy] = ACTIONS(4108),
    [anon_sym_assert] = ACTIONS(4108),
    [anon_sym_upcast] = ACTIONS(4108),
    [anon_sym_downcast] = ACTIONS(4108),
    [anon_sym_COLON_GT] = ACTIONS(4106),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4106),
    [anon_sym_for] = ACTIONS(4108),
    [anon_sym_while] = ACTIONS(4108),
    [anon_sym_if] = ACTIONS(4108),
    [anon_sym_fun] = ACTIONS(4108),
    [anon_sym_try] = ACTIONS(4108),
    [anon_sym_match] = ACTIONS(4108),
    [anon_sym_match_BANG] = ACTIONS(4106),
    [anon_sym_function] = ACTIONS(4108),
    [anon_sym_LT_DASH] = ACTIONS(4108),
    [anon_sym_DOT_LBRACK] = ACTIONS(4106),
    [anon_sym_LT] = ACTIONS(4106),
    [anon_sym_use] = ACTIONS(4108),
    [anon_sym_use_BANG] = ACTIONS(4106),
    [anon_sym_do_BANG] = ACTIONS(4106),
    [anon_sym_begin] = ACTIONS(4108),
    [anon_sym_LPAREN2] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [aux_sym_char_token1] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4108),
    [anon_sym_DQUOTE] = ACTIONS(4108),
    [anon_sym_AT_DQUOTE] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [sym_bool] = ACTIONS(4108),
    [sym_unit] = ACTIONS(4106),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4108),
    [sym_op_identifier] = ACTIONS(4108),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_PLUS_DOT] = ACTIONS(4108),
    [anon_sym_DASH_DOT] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_AMP_AMP] = ACTIONS(4108),
    [anon_sym_TILDE] = ACTIONS(4106),
    [aux_sym_prefix_op_token1] = ACTIONS(4108),
    [aux_sym_infix_op_token1] = ACTIONS(4106),
    [aux_sym_infix_op_token2] = ACTIONS(4108),
    [anon_sym_PIPE_PIPE] = ACTIONS(4108),
    [anon_sym_BANG_EQ] = ACTIONS(4108),
    [anon_sym_COLON_EQ] = ACTIONS(4106),
    [anon_sym_DOLLAR] = ACTIONS(4108),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4108),
    [sym_int] = ACTIONS(4108),
    [sym_xint] = ACTIONS(4106),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4106),
    [sym__newline] = ACTIONS(4106),
    [sym__dedent] = ACTIONS(4106),
  },
  [2933] = {
    [sym_block_comment] = STATE(2933),
    [sym_compiler_directive_decl] = STATE(2933),
    [sym_fsi_directive_decl] = STATE(2933),
    [sym_preproc_line] = STATE(2933),
    [sym_identifier] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(4091),
    [anon_sym_COLON] = ACTIONS(4093),
    [anon_sym_return] = ACTIONS(4093),
    [anon_sym_do] = ACTIONS(4093),
    [anon_sym_let] = ACTIONS(4093),
    [anon_sym_let_BANG] = ACTIONS(4091),
    [anon_sym_as] = ACTIONS(4093),
    [anon_sym_LPAREN] = ACTIONS(4093),
    [anon_sym_COMMA] = ACTIONS(4091),
    [anon_sym_null] = ACTIONS(4093),
    [anon_sym_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_COLON] = ACTIONS(4091),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(4093),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4091),
    [anon_sym_LBRACE] = ACTIONS(4093),
    [anon_sym_LT_AT] = ACTIONS(4093),
    [anon_sym_LT_AT_AT] = ACTIONS(4093),
    [anon_sym_DOT] = ACTIONS(4093),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4091),
    [anon_sym_new] = ACTIONS(4093),
    [anon_sym_with] = ACTIONS(4093),
    [anon_sym_return_BANG] = ACTIONS(4091),
    [anon_sym_yield] = ACTIONS(4093),
    [anon_sym_yield_BANG] = ACTIONS(4091),
    [anon_sym_lazy] = ACTIONS(4093),
    [anon_sym_assert] = ACTIONS(4093),
    [anon_sym_upcast] = ACTIONS(4093),
    [anon_sym_downcast] = ACTIONS(4093),
    [anon_sym_COLON_GT] = ACTIONS(4091),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4091),
    [anon_sym_for] = ACTIONS(4093),
    [anon_sym_while] = ACTIONS(4093),
    [anon_sym_if] = ACTIONS(4093),
    [anon_sym_fun] = ACTIONS(4093),
    [anon_sym_try] = ACTIONS(4093),
    [anon_sym_match] = ACTIONS(4093),
    [anon_sym_match_BANG] = ACTIONS(4091),
    [anon_sym_function] = ACTIONS(4093),
    [anon_sym_LT_DASH] = ACTIONS(4093),
    [anon_sym_DOT_LBRACK] = ACTIONS(4091),
    [anon_sym_LT] = ACTIONS(4091),
    [anon_sym_use] = ACTIONS(4093),
    [anon_sym_use_BANG] = ACTIONS(4091),
    [anon_sym_do_BANG] = ACTIONS(4091),
    [anon_sym_begin] = ACTIONS(4093),
    [anon_sym_LPAREN2] = ACTIONS(4093),
    [anon_sym_or] = ACTIONS(4093),
    [aux_sym_char_token1] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4093),
    [anon_sym_DQUOTE] = ACTIONS(4093),
    [anon_sym_AT_DQUOTE] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [sym_bool] = ACTIONS(4093),
    [sym_unit] = ACTIONS(4091),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4093),
    [sym_op_identifier] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS_DOT] = ACTIONS(4093),
    [anon_sym_DASH_DOT] = ACTIONS(4093),
    [anon_sym_PERCENT] = ACTIONS(4093),
    [anon_sym_AMP_AMP] = ACTIONS(4093),
    [anon_sym_TILDE] = ACTIONS(4091),
    [aux_sym_prefix_op_token1] = ACTIONS(4093),
    [aux_sym_infix_op_token1] = ACTIONS(4091),
    [aux_sym_infix_op_token2] = ACTIONS(4093),
    [anon_sym_PIPE_PIPE] = ACTIONS(4093),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_COLON_EQ] = ACTIONS(4091),
    [anon_sym_DOLLAR] = ACTIONS(4093),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4093),
    [sym_int] = ACTIONS(4093),
    [sym_xint] = ACTIONS(4091),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4091),
    [sym__newline] = ACTIONS(4091),
    [sym__dedent] = ACTIONS(4091),
  },
  [2934] = {
    [sym_block_comment] = STATE(2934),
    [sym_compiler_directive_decl] = STATE(2934),
    [sym_fsi_directive_decl] = STATE(2934),
    [sym_preproc_line] = STATE(2934),
    [sym_identifier] = ACTIONS(4086),
    [anon_sym_EQ] = ACTIONS(4084),
    [anon_sym_COLON] = ACTIONS(4086),
    [anon_sym_return] = ACTIONS(4086),
    [anon_sym_do] = ACTIONS(4086),
    [anon_sym_let] = ACTIONS(4086),
    [anon_sym_let_BANG] = ACTIONS(4084),
    [anon_sym_as] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_COMMA] = ACTIONS(4084),
    [anon_sym_null] = ACTIONS(4086),
    [anon_sym_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_COLON] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4084),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_LT_AT] = ACTIONS(4086),
    [anon_sym_LT_AT_AT] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4086),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4084),
    [anon_sym_new] = ACTIONS(4086),
    [anon_sym_with] = ACTIONS(4086),
    [anon_sym_return_BANG] = ACTIONS(4084),
    [anon_sym_yield] = ACTIONS(4086),
    [anon_sym_yield_BANG] = ACTIONS(4084),
    [anon_sym_lazy] = ACTIONS(4086),
    [anon_sym_assert] = ACTIONS(4086),
    [anon_sym_upcast] = ACTIONS(4086),
    [anon_sym_downcast] = ACTIONS(4086),
    [anon_sym_COLON_GT] = ACTIONS(4084),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4084),
    [anon_sym_for] = ACTIONS(4086),
    [anon_sym_while] = ACTIONS(4086),
    [anon_sym_if] = ACTIONS(4086),
    [anon_sym_fun] = ACTIONS(4086),
    [anon_sym_try] = ACTIONS(4086),
    [anon_sym_match] = ACTIONS(4086),
    [anon_sym_match_BANG] = ACTIONS(4084),
    [anon_sym_function] = ACTIONS(4086),
    [anon_sym_LT_DASH] = ACTIONS(4086),
    [anon_sym_DOT_LBRACK] = ACTIONS(4084),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_use] = ACTIONS(4086),
    [anon_sym_use_BANG] = ACTIONS(4084),
    [anon_sym_do_BANG] = ACTIONS(4084),
    [anon_sym_begin] = ACTIONS(4086),
    [anon_sym_LPAREN2] = ACTIONS(4086),
    [anon_sym_or] = ACTIONS(4086),
    [aux_sym_char_token1] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4086),
    [anon_sym_DQUOTE] = ACTIONS(4086),
    [anon_sym_AT_DQUOTE] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [sym_bool] = ACTIONS(4086),
    [sym_unit] = ACTIONS(4084),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4086),
    [sym_op_identifier] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4086),
    [anon_sym_DASH] = ACTIONS(4086),
    [anon_sym_PLUS_DOT] = ACTIONS(4086),
    [anon_sym_DASH_DOT] = ACTIONS(4086),
    [anon_sym_PERCENT] = ACTIONS(4086),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_TILDE] = ACTIONS(4084),
    [aux_sym_prefix_op_token1] = ACTIONS(4086),
    [aux_sym_infix_op_token1] = ACTIONS(4084),
    [aux_sym_infix_op_token2] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_COLON_EQ] = ACTIONS(4084),
    [anon_sym_DOLLAR] = ACTIONS(4086),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4086),
    [sym_int] = ACTIONS(4086),
    [sym_xint] = ACTIONS(4084),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4084),
    [sym__newline] = ACTIONS(4084),
    [sym__dedent] = ACTIONS(4084),
  },
  [2935] = {
    [sym_block_comment] = STATE(2935),
    [sym_compiler_directive_decl] = STATE(2935),
    [sym_fsi_directive_decl] = STATE(2935),
    [sym_preproc_line] = STATE(2935),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_COLON] = ACTIONS(4082),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_do] = ACTIONS(4082),
    [anon_sym_let] = ACTIONS(4082),
    [anon_sym_let_BANG] = ACTIONS(4080),
    [anon_sym_as] = ACTIONS(4082),
    [anon_sym_LPAREN] = ACTIONS(4082),
    [anon_sym_COMMA] = ACTIONS(4080),
    [anon_sym_null] = ACTIONS(4082),
    [anon_sym_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_COLON] = ACTIONS(4080),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_LBRACK] = ACTIONS(4082),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(4082),
    [anon_sym_LT_AT] = ACTIONS(4082),
    [anon_sym_LT_AT_AT] = ACTIONS(4082),
    [anon_sym_DOT] = ACTIONS(4082),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4080),
    [anon_sym_new] = ACTIONS(4082),
    [anon_sym_with] = ACTIONS(4082),
    [anon_sym_return_BANG] = ACTIONS(4080),
    [anon_sym_yield] = ACTIONS(4082),
    [anon_sym_yield_BANG] = ACTIONS(4080),
    [anon_sym_lazy] = ACTIONS(4082),
    [anon_sym_assert] = ACTIONS(4082),
    [anon_sym_upcast] = ACTIONS(4082),
    [anon_sym_downcast] = ACTIONS(4082),
    [anon_sym_COLON_GT] = ACTIONS(4080),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4080),
    [anon_sym_for] = ACTIONS(4082),
    [anon_sym_while] = ACTIONS(4082),
    [anon_sym_if] = ACTIONS(4082),
    [anon_sym_fun] = ACTIONS(4082),
    [anon_sym_try] = ACTIONS(4082),
    [anon_sym_match] = ACTIONS(4082),
    [anon_sym_match_BANG] = ACTIONS(4080),
    [anon_sym_function] = ACTIONS(4082),
    [anon_sym_LT_DASH] = ACTIONS(4082),
    [anon_sym_DOT_LBRACK] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(4080),
    [anon_sym_use] = ACTIONS(4082),
    [anon_sym_use_BANG] = ACTIONS(4080),
    [anon_sym_do_BANG] = ACTIONS(4080),
    [anon_sym_begin] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4082),
    [anon_sym_or] = ACTIONS(4082),
    [aux_sym_char_token1] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4082),
    [anon_sym_DQUOTE] = ACTIONS(4082),
    [anon_sym_AT_DQUOTE] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [sym_bool] = ACTIONS(4082),
    [sym_unit] = ACTIONS(4080),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4082),
    [sym_op_identifier] = ACTIONS(4082),
    [anon_sym_PLUS] = ACTIONS(4082),
    [anon_sym_DASH] = ACTIONS(4082),
    [anon_sym_PLUS_DOT] = ACTIONS(4082),
    [anon_sym_DASH_DOT] = ACTIONS(4082),
    [anon_sym_PERCENT] = ACTIONS(4082),
    [anon_sym_AMP_AMP] = ACTIONS(4082),
    [anon_sym_TILDE] = ACTIONS(4080),
    [aux_sym_prefix_op_token1] = ACTIONS(4082),
    [aux_sym_infix_op_token1] = ACTIONS(4080),
    [aux_sym_infix_op_token2] = ACTIONS(4082),
    [anon_sym_PIPE_PIPE] = ACTIONS(4082),
    [anon_sym_BANG_EQ] = ACTIONS(4082),
    [anon_sym_COLON_EQ] = ACTIONS(4080),
    [anon_sym_DOLLAR] = ACTIONS(4082),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4082),
    [sym_int] = ACTIONS(4082),
    [sym_xint] = ACTIONS(4080),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4080),
    [sym__newline] = ACTIONS(4080),
    [sym__dedent] = ACTIONS(4080),
  },
  [2936] = {
    [sym_block_comment] = STATE(2936),
    [sym_compiler_directive_decl] = STATE(2936),
    [sym_fsi_directive_decl] = STATE(2936),
    [sym_preproc_line] = STATE(2936),
    [sym_identifier] = ACTIONS(4054),
    [anon_sym_EQ] = ACTIONS(4052),
    [anon_sym_COLON] = ACTIONS(4054),
    [anon_sym_return] = ACTIONS(4054),
    [anon_sym_do] = ACTIONS(4054),
    [anon_sym_let] = ACTIONS(4054),
    [anon_sym_let_BANG] = ACTIONS(4052),
    [anon_sym_as] = ACTIONS(4054),
    [anon_sym_LPAREN] = ACTIONS(4054),
    [anon_sym_COMMA] = ACTIONS(4052),
    [anon_sym_null] = ACTIONS(4054),
    [anon_sym_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_COLON] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(4054),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4052),
    [anon_sym_LBRACE] = ACTIONS(4054),
    [anon_sym_LT_AT] = ACTIONS(4054),
    [anon_sym_LT_AT_AT] = ACTIONS(4054),
    [anon_sym_DOT] = ACTIONS(4054),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_with] = ACTIONS(4054),
    [anon_sym_return_BANG] = ACTIONS(4052),
    [anon_sym_yield] = ACTIONS(4054),
    [anon_sym_yield_BANG] = ACTIONS(4052),
    [anon_sym_lazy] = ACTIONS(4054),
    [anon_sym_assert] = ACTIONS(4054),
    [anon_sym_upcast] = ACTIONS(4054),
    [anon_sym_downcast] = ACTIONS(4054),
    [anon_sym_COLON_GT] = ACTIONS(4052),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4052),
    [anon_sym_for] = ACTIONS(4054),
    [anon_sym_while] = ACTIONS(4054),
    [anon_sym_if] = ACTIONS(4054),
    [anon_sym_fun] = ACTIONS(4054),
    [anon_sym_try] = ACTIONS(4054),
    [anon_sym_match] = ACTIONS(4054),
    [anon_sym_match_BANG] = ACTIONS(4052),
    [anon_sym_function] = ACTIONS(4054),
    [anon_sym_LT_DASH] = ACTIONS(4054),
    [anon_sym_DOT_LBRACK] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_use] = ACTIONS(4054),
    [anon_sym_use_BANG] = ACTIONS(4052),
    [anon_sym_do_BANG] = ACTIONS(4052),
    [anon_sym_begin] = ACTIONS(4054),
    [anon_sym_LPAREN2] = ACTIONS(4054),
    [anon_sym_or] = ACTIONS(4054),
    [aux_sym_char_token1] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4054),
    [anon_sym_DQUOTE] = ACTIONS(4054),
    [anon_sym_AT_DQUOTE] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [sym_bool] = ACTIONS(4054),
    [sym_unit] = ACTIONS(4052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4054),
    [sym_op_identifier] = ACTIONS(4054),
    [anon_sym_PLUS] = ACTIONS(4054),
    [anon_sym_DASH] = ACTIONS(4054),
    [anon_sym_PLUS_DOT] = ACTIONS(4054),
    [anon_sym_DASH_DOT] = ACTIONS(4054),
    [anon_sym_PERCENT] = ACTIONS(4054),
    [anon_sym_AMP_AMP] = ACTIONS(4054),
    [anon_sym_TILDE] = ACTIONS(4052),
    [aux_sym_prefix_op_token1] = ACTIONS(4054),
    [aux_sym_infix_op_token1] = ACTIONS(4052),
    [aux_sym_infix_op_token2] = ACTIONS(4054),
    [anon_sym_PIPE_PIPE] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4054),
    [anon_sym_COLON_EQ] = ACTIONS(4052),
    [anon_sym_DOLLAR] = ACTIONS(4054),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4054),
    [sym_int] = ACTIONS(4054),
    [sym_xint] = ACTIONS(4052),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4052),
    [sym__newline] = ACTIONS(4052),
    [sym__dedent] = ACTIONS(4052),
  },
  [2937] = {
    [sym_block_comment] = STATE(2937),
    [sym_compiler_directive_decl] = STATE(2937),
    [sym_fsi_directive_decl] = STATE(2937),
    [sym_preproc_line] = STATE(2937),
    [sym_identifier] = ACTIONS(4018),
    [anon_sym_EQ] = ACTIONS(4016),
    [anon_sym_COLON] = ACTIONS(4018),
    [anon_sym_return] = ACTIONS(4018),
    [anon_sym_do] = ACTIONS(4018),
    [anon_sym_let] = ACTIONS(4018),
    [anon_sym_let_BANG] = ACTIONS(4016),
    [anon_sym_as] = ACTIONS(4018),
    [anon_sym_LPAREN] = ACTIONS(4018),
    [anon_sym_COMMA] = ACTIONS(4016),
    [anon_sym_null] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_COLON] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4018),
    [anon_sym_LBRACK] = ACTIONS(4018),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4016),
    [anon_sym_LBRACE] = ACTIONS(4018),
    [anon_sym_LT_AT] = ACTIONS(4018),
    [anon_sym_LT_AT_AT] = ACTIONS(4018),
    [anon_sym_DOT] = ACTIONS(4018),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4016),
    [anon_sym_new] = ACTIONS(4018),
    [anon_sym_with] = ACTIONS(4018),
    [anon_sym_return_BANG] = ACTIONS(4016),
    [anon_sym_yield] = ACTIONS(4018),
    [anon_sym_yield_BANG] = ACTIONS(4016),
    [anon_sym_lazy] = ACTIONS(4018),
    [anon_sym_assert] = ACTIONS(4018),
    [anon_sym_upcast] = ACTIONS(4018),
    [anon_sym_downcast] = ACTIONS(4018),
    [anon_sym_COLON_GT] = ACTIONS(4016),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4016),
    [anon_sym_for] = ACTIONS(4018),
    [anon_sym_while] = ACTIONS(4018),
    [anon_sym_if] = ACTIONS(4018),
    [anon_sym_fun] = ACTIONS(4018),
    [anon_sym_try] = ACTIONS(4018),
    [anon_sym_match] = ACTIONS(4018),
    [anon_sym_match_BANG] = ACTIONS(4016),
    [anon_sym_function] = ACTIONS(4018),
    [anon_sym_LT_DASH] = ACTIONS(4018),
    [anon_sym_DOT_LBRACK] = ACTIONS(4016),
    [anon_sym_LT] = ACTIONS(4016),
    [anon_sym_use] = ACTIONS(4018),
    [anon_sym_use_BANG] = ACTIONS(4016),
    [anon_sym_do_BANG] = ACTIONS(4016),
    [anon_sym_begin] = ACTIONS(4018),
    [anon_sym_LPAREN2] = ACTIONS(4018),
    [anon_sym_or] = ACTIONS(4018),
    [aux_sym_char_token1] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(4018),
    [anon_sym_AT_DQUOTE] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [sym_bool] = ACTIONS(4018),
    [sym_unit] = ACTIONS(4016),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4018),
    [sym_op_identifier] = ACTIONS(4018),
    [anon_sym_PLUS] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_PLUS_DOT] = ACTIONS(4018),
    [anon_sym_DASH_DOT] = ACTIONS(4018),
    [anon_sym_PERCENT] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4016),
    [aux_sym_prefix_op_token1] = ACTIONS(4018),
    [aux_sym_infix_op_token1] = ACTIONS(4016),
    [aux_sym_infix_op_token2] = ACTIONS(4018),
    [anon_sym_PIPE_PIPE] = ACTIONS(4018),
    [anon_sym_BANG_EQ] = ACTIONS(4018),
    [anon_sym_COLON_EQ] = ACTIONS(4016),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4018),
    [sym_int] = ACTIONS(4018),
    [sym_xint] = ACTIONS(4016),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4016),
    [sym__newline] = ACTIONS(4016),
    [sym__dedent] = ACTIONS(4016),
  },
  [2938] = {
    [sym_block_comment] = STATE(2938),
    [sym_compiler_directive_decl] = STATE(2938),
    [sym_fsi_directive_decl] = STATE(2938),
    [sym_preproc_line] = STATE(2938),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3843),
    [anon_sym_COLON] = ACTIONS(3845),
    [anon_sym_return] = ACTIONS(3845),
    [anon_sym_do] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_let_BANG] = ACTIONS(3843),
    [anon_sym_as] = ACTIONS(3845),
    [anon_sym_LPAREN] = ACTIONS(3845),
    [anon_sym_COMMA] = ACTIONS(3843),
    [anon_sym_null] = ACTIONS(3845),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3843),
    [anon_sym_LBRACE] = ACTIONS(3845),
    [anon_sym_LT_AT] = ACTIONS(3845),
    [anon_sym_LT_AT_AT] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3843),
    [anon_sym_new] = ACTIONS(3845),
    [anon_sym_with] = ACTIONS(3845),
    [anon_sym_return_BANG] = ACTIONS(3843),
    [anon_sym_yield] = ACTIONS(3845),
    [anon_sym_yield_BANG] = ACTIONS(3843),
    [anon_sym_lazy] = ACTIONS(3845),
    [anon_sym_assert] = ACTIONS(3845),
    [anon_sym_upcast] = ACTIONS(3845),
    [anon_sym_downcast] = ACTIONS(3845),
    [anon_sym_COLON_GT] = ACTIONS(3843),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3843),
    [anon_sym_for] = ACTIONS(3845),
    [anon_sym_while] = ACTIONS(3845),
    [anon_sym_if] = ACTIONS(3845),
    [anon_sym_fun] = ACTIONS(3845),
    [anon_sym_try] = ACTIONS(3845),
    [anon_sym_match] = ACTIONS(3845),
    [anon_sym_match_BANG] = ACTIONS(3843),
    [anon_sym_function] = ACTIONS(3845),
    [anon_sym_LT_DASH] = ACTIONS(3845),
    [anon_sym_DOT_LBRACK] = ACTIONS(3843),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_use] = ACTIONS(3845),
    [anon_sym_use_BANG] = ACTIONS(3843),
    [anon_sym_do_BANG] = ACTIONS(3843),
    [anon_sym_begin] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(3845),
    [anon_sym_or] = ACTIONS(3845),
    [aux_sym_char_token1] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3845),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_AT_DQUOTE] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [sym_bool] = ACTIONS(3845),
    [sym_unit] = ACTIONS(3843),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3845),
    [sym_op_identifier] = ACTIONS(3845),
    [anon_sym_PLUS] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_PLUS_DOT] = ACTIONS(3845),
    [anon_sym_DASH_DOT] = ACTIONS(3845),
    [anon_sym_PERCENT] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3845),
    [anon_sym_TILDE] = ACTIONS(3843),
    [aux_sym_prefix_op_token1] = ACTIONS(3845),
    [aux_sym_infix_op_token1] = ACTIONS(3843),
    [aux_sym_infix_op_token2] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(3845),
    [anon_sym_BANG_EQ] = ACTIONS(3845),
    [anon_sym_COLON_EQ] = ACTIONS(3843),
    [anon_sym_DOLLAR] = ACTIONS(3845),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3845),
    [sym_int] = ACTIONS(3845),
    [sym_xint] = ACTIONS(3843),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3843),
    [sym__newline] = ACTIONS(3843),
    [sym__dedent] = ACTIONS(3843),
  },
  [2939] = {
    [sym_block_comment] = STATE(2939),
    [sym_compiler_directive_decl] = STATE(2939),
    [sym_fsi_directive_decl] = STATE(2939),
    [sym_preproc_line] = STATE(2939),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_EQ] = ACTIONS(4001),
    [anon_sym_COLON] = ACTIONS(4003),
    [anon_sym_return] = ACTIONS(4003),
    [anon_sym_do] = ACTIONS(4003),
    [anon_sym_let] = ACTIONS(4003),
    [anon_sym_let_BANG] = ACTIONS(4001),
    [anon_sym_as] = ACTIONS(4003),
    [anon_sym_LPAREN] = ACTIONS(4003),
    [anon_sym_COMMA] = ACTIONS(4001),
    [anon_sym_null] = ACTIONS(4003),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_COLON] = ACTIONS(4001),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LBRACK] = ACTIONS(4003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4001),
    [anon_sym_LBRACE] = ACTIONS(4003),
    [anon_sym_LT_AT] = ACTIONS(4003),
    [anon_sym_LT_AT_AT] = ACTIONS(4003),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4001),
    [anon_sym_new] = ACTIONS(4003),
    [anon_sym_with] = ACTIONS(4003),
    [anon_sym_return_BANG] = ACTIONS(4001),
    [anon_sym_yield] = ACTIONS(4003),
    [anon_sym_yield_BANG] = ACTIONS(4001),
    [anon_sym_lazy] = ACTIONS(4003),
    [anon_sym_assert] = ACTIONS(4003),
    [anon_sym_upcast] = ACTIONS(4003),
    [anon_sym_downcast] = ACTIONS(4003),
    [anon_sym_COLON_GT] = ACTIONS(4001),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4001),
    [anon_sym_for] = ACTIONS(4003),
    [anon_sym_while] = ACTIONS(4003),
    [anon_sym_if] = ACTIONS(4003),
    [anon_sym_fun] = ACTIONS(4003),
    [anon_sym_try] = ACTIONS(4003),
    [anon_sym_match] = ACTIONS(4003),
    [anon_sym_match_BANG] = ACTIONS(4001),
    [anon_sym_function] = ACTIONS(4003),
    [anon_sym_LT_DASH] = ACTIONS(4003),
    [anon_sym_DOT_LBRACK] = ACTIONS(4001),
    [anon_sym_LT] = ACTIONS(4001),
    [anon_sym_use] = ACTIONS(4003),
    [anon_sym_use_BANG] = ACTIONS(4001),
    [anon_sym_do_BANG] = ACTIONS(4001),
    [anon_sym_begin] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [aux_sym_char_token1] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4003),
    [anon_sym_DQUOTE] = ACTIONS(4003),
    [anon_sym_AT_DQUOTE] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [sym_bool] = ACTIONS(4003),
    [sym_unit] = ACTIONS(4001),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4003),
    [sym_op_identifier] = ACTIONS(4003),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_PLUS_DOT] = ACTIONS(4003),
    [anon_sym_DASH_DOT] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4003),
    [anon_sym_TILDE] = ACTIONS(4001),
    [aux_sym_prefix_op_token1] = ACTIONS(4003),
    [aux_sym_infix_op_token1] = ACTIONS(4001),
    [aux_sym_infix_op_token2] = ACTIONS(4003),
    [anon_sym_PIPE_PIPE] = ACTIONS(4003),
    [anon_sym_BANG_EQ] = ACTIONS(4003),
    [anon_sym_COLON_EQ] = ACTIONS(4001),
    [anon_sym_DOLLAR] = ACTIONS(4003),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4003),
    [sym_int] = ACTIONS(4003),
    [sym_xint] = ACTIONS(4001),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4001),
    [sym__newline] = ACTIONS(4001),
    [sym__dedent] = ACTIONS(4001),
  },
  [2940] = {
    [sym_block_comment] = STATE(2940),
    [sym_compiler_directive_decl] = STATE(2940),
    [sym_fsi_directive_decl] = STATE(2940),
    [sym_preproc_line] = STATE(2940),
    [aux_sym_rules_repeat1] = STATE(2931),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(5470),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_AT_AT_GT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_or] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(5538),
  },
  [2941] = {
    [sym_block_comment] = STATE(2941),
    [sym_compiler_directive_decl] = STATE(2941),
    [sym_fsi_directive_decl] = STATE(2941),
    [sym_preproc_line] = STATE(2941),
    [sym_identifier] = ACTIONS(3996),
    [anon_sym_EQ] = ACTIONS(3994),
    [anon_sym_COLON] = ACTIONS(3996),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_do] = ACTIONS(3996),
    [anon_sym_let] = ACTIONS(3996),
    [anon_sym_let_BANG] = ACTIONS(3994),
    [anon_sym_as] = ACTIONS(3996),
    [anon_sym_LPAREN] = ACTIONS(3996),
    [anon_sym_COMMA] = ACTIONS(3994),
    [anon_sym_null] = ACTIONS(3996),
    [anon_sym_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_COLON] = ACTIONS(3994),
    [anon_sym_AMP] = ACTIONS(3996),
    [anon_sym_LBRACK] = ACTIONS(3996),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3994),
    [anon_sym_LBRACE] = ACTIONS(3996),
    [anon_sym_LT_AT] = ACTIONS(3996),
    [anon_sym_LT_AT_AT] = ACTIONS(3996),
    [anon_sym_DOT] = ACTIONS(3996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3994),
    [anon_sym_new] = ACTIONS(3996),
    [anon_sym_with] = ACTIONS(3996),
    [anon_sym_return_BANG] = ACTIONS(3994),
    [anon_sym_yield] = ACTIONS(3996),
    [anon_sym_yield_BANG] = ACTIONS(3994),
    [anon_sym_lazy] = ACTIONS(3996),
    [anon_sym_assert] = ACTIONS(3996),
    [anon_sym_upcast] = ACTIONS(3996),
    [anon_sym_downcast] = ACTIONS(3996),
    [anon_sym_COLON_GT] = ACTIONS(3994),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3994),
    [anon_sym_for] = ACTIONS(3996),
    [anon_sym_while] = ACTIONS(3996),
    [anon_sym_if] = ACTIONS(3996),
    [anon_sym_fun] = ACTIONS(3996),
    [anon_sym_try] = ACTIONS(3996),
    [anon_sym_match] = ACTIONS(3996),
    [anon_sym_match_BANG] = ACTIONS(3994),
    [anon_sym_function] = ACTIONS(3996),
    [anon_sym_LT_DASH] = ACTIONS(3996),
    [anon_sym_DOT_LBRACK] = ACTIONS(3994),
    [anon_sym_LT] = ACTIONS(3994),
    [anon_sym_use] = ACTIONS(3996),
    [anon_sym_use_BANG] = ACTIONS(3994),
    [anon_sym_do_BANG] = ACTIONS(3994),
    [anon_sym_begin] = ACTIONS(3996),
    [anon_sym_LPAREN2] = ACTIONS(3996),
    [anon_sym_or] = ACTIONS(3996),
    [aux_sym_char_token1] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3996),
    [anon_sym_DQUOTE] = ACTIONS(3996),
    [anon_sym_AT_DQUOTE] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [sym_bool] = ACTIONS(3996),
    [sym_unit] = ACTIONS(3994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3996),
    [sym_op_identifier] = ACTIONS(3996),
    [anon_sym_PLUS] = ACTIONS(3996),
    [anon_sym_DASH] = ACTIONS(3996),
    [anon_sym_PLUS_DOT] = ACTIONS(3996),
    [anon_sym_DASH_DOT] = ACTIONS(3996),
    [anon_sym_PERCENT] = ACTIONS(3996),
    [anon_sym_AMP_AMP] = ACTIONS(3996),
    [anon_sym_TILDE] = ACTIONS(3994),
    [aux_sym_prefix_op_token1] = ACTIONS(3996),
    [aux_sym_infix_op_token1] = ACTIONS(3994),
    [aux_sym_infix_op_token2] = ACTIONS(3996),
    [anon_sym_PIPE_PIPE] = ACTIONS(3996),
    [anon_sym_BANG_EQ] = ACTIONS(3996),
    [anon_sym_COLON_EQ] = ACTIONS(3994),
    [anon_sym_DOLLAR] = ACTIONS(3996),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3996),
    [sym_int] = ACTIONS(3996),
    [sym_xint] = ACTIONS(3994),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3994),
    [sym__newline] = ACTIONS(3994),
    [sym__dedent] = ACTIONS(3994),
  },
  [2942] = {
    [sym_block_comment] = STATE(2942),
    [sym_compiler_directive_decl] = STATE(2942),
    [sym_fsi_directive_decl] = STATE(2942),
    [sym_preproc_line] = STATE(2942),
    [aux_sym_rules_repeat1] = STATE(2931),
    [sym_identifier] = ACTIONS(3676),
    [anon_sym_EQ] = ACTIONS(3674),
    [anon_sym_COLON] = ACTIONS(3676),
    [anon_sym_return] = ACTIONS(3676),
    [anon_sym_do] = ACTIONS(3676),
    [anon_sym_let] = ACTIONS(3676),
    [anon_sym_let_BANG] = ACTIONS(3674),
    [anon_sym_LPAREN] = ACTIONS(3676),
    [anon_sym_COMMA] = ACTIONS(3674),
    [anon_sym_null] = ACTIONS(3676),
    [anon_sym_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_QMARK] = ACTIONS(3676),
    [anon_sym_COLON_COLON] = ACTIONS(3674),
    [anon_sym_PIPE] = ACTIONS(5470),
    [anon_sym_AMP] = ACTIONS(3676),
    [anon_sym_LBRACK] = ACTIONS(3676),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3674),
    [anon_sym_LBRACE] = ACTIONS(3676),
    [anon_sym_LT_AT] = ACTIONS(3676),
    [anon_sym_LT_AT_AT] = ACTIONS(3676),
    [anon_sym_AT_AT_GT] = ACTIONS(3676),
    [anon_sym_DOT] = ACTIONS(3676),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3674),
    [anon_sym_new] = ACTIONS(3676),
    [anon_sym_return_BANG] = ACTIONS(3674),
    [anon_sym_yield] = ACTIONS(3676),
    [anon_sym_yield_BANG] = ACTIONS(3674),
    [anon_sym_lazy] = ACTIONS(3676),
    [anon_sym_assert] = ACTIONS(3676),
    [anon_sym_upcast] = ACTIONS(3676),
    [anon_sym_downcast] = ACTIONS(3676),
    [anon_sym_COLON_GT] = ACTIONS(3674),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3674),
    [anon_sym_for] = ACTIONS(3676),
    [anon_sym_while] = ACTIONS(3676),
    [anon_sym_if] = ACTIONS(3676),
    [anon_sym_fun] = ACTIONS(3676),
    [anon_sym_try] = ACTIONS(3676),
    [anon_sym_match] = ACTIONS(3676),
    [anon_sym_match_BANG] = ACTIONS(3674),
    [anon_sym_function] = ACTIONS(3676),
    [anon_sym_LT_DASH] = ACTIONS(3676),
    [anon_sym_DOT_LBRACK] = ACTIONS(3674),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_use] = ACTIONS(3676),
    [anon_sym_use_BANG] = ACTIONS(3674),
    [anon_sym_do_BANG] = ACTIONS(3674),
    [anon_sym_begin] = ACTIONS(3676),
    [anon_sym_LPAREN2] = ACTIONS(3676),
    [anon_sym_or] = ACTIONS(3676),
    [aux_sym_char_token1] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3676),
    [anon_sym_DQUOTE] = ACTIONS(3676),
    [anon_sym_AT_DQUOTE] = ACTIONS(3674),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3674),
    [sym_bool] = ACTIONS(3676),
    [sym_unit] = ACTIONS(3674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3676),
    [sym_op_identifier] = ACTIONS(3676),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_PLUS_DOT] = ACTIONS(3676),
    [anon_sym_DASH_DOT] = ACTIONS(3676),
    [anon_sym_PERCENT] = ACTIONS(3676),
    [anon_sym_AMP_AMP] = ACTIONS(3676),
    [anon_sym_TILDE] = ACTIONS(3674),
    [aux_sym_prefix_op_token1] = ACTIONS(3676),
    [aux_sym_infix_op_token1] = ACTIONS(3674),
    [aux_sym_infix_op_token2] = ACTIONS(3676),
    [anon_sym_PIPE_PIPE] = ACTIONS(3676),
    [anon_sym_BANG_EQ] = ACTIONS(3676),
    [anon_sym_COLON_EQ] = ACTIONS(3674),
    [anon_sym_DOLLAR] = ACTIONS(3676),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3676),
    [sym_int] = ACTIONS(3676),
    [sym_xint] = ACTIONS(3674),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3674),
    [sym__newline] = ACTIONS(5541),
  },
  [2943] = {
    [sym_block_comment] = STATE(2943),
    [sym_compiler_directive_decl] = STATE(2943),
    [sym_fsi_directive_decl] = STATE(2943),
    [sym_preproc_line] = STATE(2943),
    [sym_identifier] = ACTIONS(3972),
    [anon_sym_EQ] = ACTIONS(3970),
    [anon_sym_COLON] = ACTIONS(3972),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_do] = ACTIONS(3972),
    [anon_sym_let] = ACTIONS(3972),
    [anon_sym_let_BANG] = ACTIONS(3970),
    [anon_sym_as] = ACTIONS(3972),
    [anon_sym_LPAREN] = ACTIONS(3972),
    [anon_sym_COMMA] = ACTIONS(3970),
    [anon_sym_null] = ACTIONS(3972),
    [anon_sym_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_COLON] = ACTIONS(3970),
    [anon_sym_AMP] = ACTIONS(3972),
    [anon_sym_LBRACK] = ACTIONS(3972),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3970),
    [anon_sym_LBRACE] = ACTIONS(3972),
    [anon_sym_LT_AT] = ACTIONS(3972),
    [anon_sym_LT_AT_AT] = ACTIONS(3972),
    [anon_sym_DOT] = ACTIONS(3972),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3970),
    [anon_sym_new] = ACTIONS(3972),
    [anon_sym_with] = ACTIONS(3972),
    [anon_sym_return_BANG] = ACTIONS(3970),
    [anon_sym_yield] = ACTIONS(3972),
    [anon_sym_yield_BANG] = ACTIONS(3970),
    [anon_sym_lazy] = ACTIONS(3972),
    [anon_sym_assert] = ACTIONS(3972),
    [anon_sym_upcast] = ACTIONS(3972),
    [anon_sym_downcast] = ACTIONS(3972),
    [anon_sym_COLON_GT] = ACTIONS(3970),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3970),
    [anon_sym_for] = ACTIONS(3972),
    [anon_sym_while] = ACTIONS(3972),
    [anon_sym_if] = ACTIONS(3972),
    [anon_sym_fun] = ACTIONS(3972),
    [anon_sym_try] = ACTIONS(3972),
    [anon_sym_match] = ACTIONS(3972),
    [anon_sym_match_BANG] = ACTIONS(3970),
    [anon_sym_function] = ACTIONS(3972),
    [anon_sym_LT_DASH] = ACTIONS(3972),
    [anon_sym_DOT_LBRACK] = ACTIONS(3970),
    [anon_sym_LT] = ACTIONS(3970),
    [anon_sym_use] = ACTIONS(3972),
    [anon_sym_use_BANG] = ACTIONS(3970),
    [anon_sym_do_BANG] = ACTIONS(3970),
    [anon_sym_begin] = ACTIONS(3972),
    [anon_sym_LPAREN2] = ACTIONS(3972),
    [anon_sym_or] = ACTIONS(3972),
    [aux_sym_char_token1] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3972),
    [anon_sym_DQUOTE] = ACTIONS(3972),
    [anon_sym_AT_DQUOTE] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [sym_bool] = ACTIONS(3972),
    [sym_unit] = ACTIONS(3970),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3972),
    [sym_op_identifier] = ACTIONS(3972),
    [anon_sym_PLUS] = ACTIONS(3972),
    [anon_sym_DASH] = ACTIONS(3972),
    [anon_sym_PLUS_DOT] = ACTIONS(3972),
    [anon_sym_DASH_DOT] = ACTIONS(3972),
    [anon_sym_PERCENT] = ACTIONS(3972),
    [anon_sym_AMP_AMP] = ACTIONS(3972),
    [anon_sym_TILDE] = ACTIONS(3970),
    [aux_sym_prefix_op_token1] = ACTIONS(3972),
    [aux_sym_infix_op_token1] = ACTIONS(3970),
    [aux_sym_infix_op_token2] = ACTIONS(3972),
    [anon_sym_PIPE_PIPE] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3972),
    [anon_sym_COLON_EQ] = ACTIONS(3970),
    [anon_sym_DOLLAR] = ACTIONS(3972),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3972),
    [sym_int] = ACTIONS(3972),
    [sym_xint] = ACTIONS(3970),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3970),
    [sym__newline] = ACTIONS(3970),
    [sym__dedent] = ACTIONS(3970),
  },
  [2944] = {
    [sym_block_comment] = STATE(2944),
    [sym_compiler_directive_decl] = STATE(2944),
    [sym_fsi_directive_decl] = STATE(2944),
    [sym_preproc_line] = STATE(2944),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_DASH_GT] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_DOT_DOT] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_or] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [sym__newline] = ACTIONS(3741),
  },
  [2945] = {
    [sym_block_comment] = STATE(2945),
    [sym_compiler_directive_decl] = STATE(2945),
    [sym_fsi_directive_decl] = STATE(2945),
    [sym_preproc_line] = STATE(2945),
    [sym_identifier] = ACTIONS(3800),
    [anon_sym_EQ] = ACTIONS(3798),
    [anon_sym_COLON] = ACTIONS(3800),
    [anon_sym_return] = ACTIONS(3800),
    [anon_sym_do] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_let_BANG] = ACTIONS(3798),
    [anon_sym_LPAREN] = ACTIONS(3800),
    [anon_sym_COMMA] = ACTIONS(3798),
    [anon_sym_null] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_COLON] = ACTIONS(3798),
    [anon_sym_PIPE] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3800),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3798),
    [anon_sym_LBRACE] = ACTIONS(3800),
    [anon_sym_LT_AT] = ACTIONS(3800),
    [anon_sym_LT_AT_AT] = ACTIONS(3800),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3798),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_return_BANG] = ACTIONS(3798),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_yield_BANG] = ACTIONS(3798),
    [anon_sym_lazy] = ACTIONS(3800),
    [anon_sym_assert] = ACTIONS(3800),
    [anon_sym_upcast] = ACTIONS(3800),
    [anon_sym_downcast] = ACTIONS(3800),
    [anon_sym_COLON_GT] = ACTIONS(3798),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3798),
    [anon_sym_for] = ACTIONS(3800),
    [anon_sym_while] = ACTIONS(3800),
    [anon_sym_if] = ACTIONS(3800),
    [anon_sym_fun] = ACTIONS(3800),
    [anon_sym_DASH_GT] = ACTIONS(3800),
    [anon_sym_try] = ACTIONS(3800),
    [anon_sym_match] = ACTIONS(3800),
    [anon_sym_match_BANG] = ACTIONS(3798),
    [anon_sym_function] = ACTIONS(3800),
    [anon_sym_LT_DASH] = ACTIONS(3800),
    [anon_sym_DOT_LBRACK] = ACTIONS(3798),
    [anon_sym_LT] = ACTIONS(3798),
    [anon_sym_use] = ACTIONS(3800),
    [anon_sym_use_BANG] = ACTIONS(3798),
    [anon_sym_do_BANG] = ACTIONS(3798),
    [anon_sym_DOT_DOT] = ACTIONS(3798),
    [anon_sym_begin] = ACTIONS(3800),
    [anon_sym_LPAREN2] = ACTIONS(3800),
    [anon_sym_or] = ACTIONS(3800),
    [aux_sym_char_token1] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3800),
    [anon_sym_DQUOTE] = ACTIONS(3800),
    [anon_sym_AT_DQUOTE] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [sym_bool] = ACTIONS(3800),
    [sym_unit] = ACTIONS(3798),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3800),
    [sym_op_identifier] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS_DOT] = ACTIONS(3800),
    [anon_sym_DASH_DOT] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3800),
    [anon_sym_AMP_AMP] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3798),
    [aux_sym_prefix_op_token1] = ACTIONS(3800),
    [aux_sym_infix_op_token1] = ACTIONS(3798),
    [aux_sym_infix_op_token2] = ACTIONS(3800),
    [anon_sym_PIPE_PIPE] = ACTIONS(3800),
    [anon_sym_BANG_EQ] = ACTIONS(3800),
    [anon_sym_COLON_EQ] = ACTIONS(3798),
    [anon_sym_DOLLAR] = ACTIONS(3800),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3800),
    [sym_int] = ACTIONS(3800),
    [sym_xint] = ACTIONS(3798),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3798),
    [sym__newline] = ACTIONS(3798),
  },
  [2946] = {
    [sym_block_comment] = STATE(2946),
    [sym_compiler_directive_decl] = STATE(2946),
    [sym_fsi_directive_decl] = STATE(2946),
    [sym_preproc_line] = STATE(2946),
    [sym_identifier] = ACTIONS(3828),
    [anon_sym_EQ] = ACTIONS(3826),
    [anon_sym_COLON] = ACTIONS(3828),
    [anon_sym_return] = ACTIONS(3828),
    [anon_sym_do] = ACTIONS(3828),
    [anon_sym_let] = ACTIONS(3828),
    [anon_sym_let_BANG] = ACTIONS(3826),
    [anon_sym_as] = ACTIONS(3828),
    [anon_sym_LPAREN] = ACTIONS(3828),
    [anon_sym_COMMA] = ACTIONS(3826),
    [anon_sym_null] = ACTIONS(3828),
    [anon_sym_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_COLON] = ACTIONS(3826),
    [anon_sym_PIPE] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3828),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3826),
    [anon_sym_LBRACE] = ACTIONS(3828),
    [anon_sym_LT_AT] = ACTIONS(3828),
    [anon_sym_LT_AT_AT] = ACTIONS(3828),
    [anon_sym_DOT] = ACTIONS(3828),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3826),
    [anon_sym_new] = ACTIONS(3828),
    [anon_sym_with] = ACTIONS(3828),
    [anon_sym_return_BANG] = ACTIONS(3826),
    [anon_sym_yield] = ACTIONS(3828),
    [anon_sym_yield_BANG] = ACTIONS(3826),
    [anon_sym_lazy] = ACTIONS(3828),
    [anon_sym_assert] = ACTIONS(3828),
    [anon_sym_upcast] = ACTIONS(3828),
    [anon_sym_downcast] = ACTIONS(3828),
    [anon_sym_COLON_GT] = ACTIONS(3826),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3826),
    [anon_sym_for] = ACTIONS(3828),
    [anon_sym_while] = ACTIONS(3828),
    [anon_sym_if] = ACTIONS(3828),
    [anon_sym_fun] = ACTIONS(3828),
    [anon_sym_try] = ACTIONS(3828),
    [anon_sym_match] = ACTIONS(3828),
    [anon_sym_match_BANG] = ACTIONS(3826),
    [anon_sym_function] = ACTIONS(3828),
    [anon_sym_LT_DASH] = ACTIONS(3828),
    [anon_sym_DOT_LBRACK] = ACTIONS(3826),
    [anon_sym_LT] = ACTIONS(3826),
    [anon_sym_use] = ACTIONS(3828),
    [anon_sym_use_BANG] = ACTIONS(3826),
    [anon_sym_do_BANG] = ACTIONS(3826),
    [anon_sym_begin] = ACTIONS(3828),
    [anon_sym_LPAREN2] = ACTIONS(3828),
    [anon_sym_or] = ACTIONS(3828),
    [aux_sym_char_token1] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3828),
    [anon_sym_DQUOTE] = ACTIONS(3828),
    [anon_sym_AT_DQUOTE] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [sym_bool] = ACTIONS(3828),
    [sym_unit] = ACTIONS(3826),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3828),
    [sym_op_identifier] = ACTIONS(3828),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_DASH] = ACTIONS(3828),
    [anon_sym_PLUS_DOT] = ACTIONS(3828),
    [anon_sym_DASH_DOT] = ACTIONS(3828),
    [anon_sym_PERCENT] = ACTIONS(3828),
    [anon_sym_AMP_AMP] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3826),
    [aux_sym_prefix_op_token1] = ACTIONS(3828),
    [aux_sym_infix_op_token1] = ACTIONS(3826),
    [aux_sym_infix_op_token2] = ACTIONS(3828),
    [anon_sym_PIPE_PIPE] = ACTIONS(3828),
    [anon_sym_BANG_EQ] = ACTIONS(3828),
    [anon_sym_COLON_EQ] = ACTIONS(3826),
    [anon_sym_DOLLAR] = ACTIONS(3828),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3828),
    [sym_int] = ACTIONS(3828),
    [sym_xint] = ACTIONS(3826),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3826),
    [sym__newline] = ACTIONS(3826),
  },
  [2947] = {
    [sym_block_comment] = STATE(2947),
    [sym_compiler_directive_decl] = STATE(2947),
    [sym_fsi_directive_decl] = STATE(2947),
    [sym_preproc_line] = STATE(2947),
    [aux_sym_sequential_expression_repeat1] = STATE(2947),
    [sym_identifier] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3765),
    [anon_sym_COLON] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_let_BANG] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(3767),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_null] = ACTIONS(3767),
    [anon_sym_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3765),
    [anon_sym_LBRACE] = ACTIONS(3767),
    [anon_sym_LT_AT] = ACTIONS(3767),
    [anon_sym_LT_AT_AT] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3765),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_return_BANG] = ACTIONS(3765),
    [anon_sym_yield] = ACTIONS(3767),
    [anon_sym_yield_BANG] = ACTIONS(3765),
    [anon_sym_lazy] = ACTIONS(3767),
    [anon_sym_assert] = ACTIONS(3767),
    [anon_sym_upcast] = ACTIONS(3767),
    [anon_sym_downcast] = ACTIONS(3767),
    [anon_sym_COLON_GT] = ACTIONS(3765),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3765),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_fun] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_match] = ACTIONS(3767),
    [anon_sym_match_BANG] = ACTIONS(3765),
    [anon_sym_function] = ACTIONS(3767),
    [anon_sym_LT_DASH] = ACTIONS(3767),
    [anon_sym_DOT_LBRACK] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(3765),
    [anon_sym_use] = ACTIONS(3767),
    [anon_sym_use_BANG] = ACTIONS(3765),
    [anon_sym_do_BANG] = ACTIONS(3765),
    [anon_sym_begin] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3767),
    [anon_sym_DOT_DOT2] = ACTIONS(3765),
    [anon_sym_or] = ACTIONS(3767),
    [aux_sym_char_token1] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3767),
    [anon_sym_DQUOTE] = ACTIONS(3767),
    [anon_sym_AT_DQUOTE] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [sym_bool] = ACTIONS(3767),
    [sym_unit] = ACTIONS(3765),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3767),
    [sym_op_identifier] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_PLUS_DOT] = ACTIONS(3767),
    [anon_sym_DASH_DOT] = ACTIONS(3767),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_AMP_AMP] = ACTIONS(3767),
    [anon_sym_TILDE] = ACTIONS(3765),
    [aux_sym_prefix_op_token1] = ACTIONS(3767),
    [aux_sym_infix_op_token1] = ACTIONS(3765),
    [aux_sym_infix_op_token2] = ACTIONS(3767),
    [anon_sym_PIPE_PIPE] = ACTIONS(3767),
    [anon_sym_BANG_EQ] = ACTIONS(3767),
    [anon_sym_COLON_EQ] = ACTIONS(3765),
    [anon_sym_DOLLAR] = ACTIONS(3767),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3767),
    [sym_int] = ACTIONS(3767),
    [sym_xint] = ACTIONS(3765),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3765),
    [sym__newline] = ACTIONS(5544),
    [sym__dedent] = ACTIONS(3765),
  },
  [2948] = {
    [sym_block_comment] = STATE(2948),
    [sym_compiler_directive_decl] = STATE(2948),
    [sym_fsi_directive_decl] = STATE(2948),
    [sym_preproc_line] = STATE(2948),
    [sym_identifier] = ACTIONS(4137),
    [anon_sym_EQ] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4137),
    [anon_sym_return] = ACTIONS(4137),
    [anon_sym_do] = ACTIONS(4137),
    [anon_sym_let] = ACTIONS(4137),
    [anon_sym_let_BANG] = ACTIONS(4135),
    [anon_sym_as] = ACTIONS(4137),
    [anon_sym_LPAREN] = ACTIONS(4137),
    [anon_sym_COMMA] = ACTIONS(4135),
    [anon_sym_null] = ACTIONS(4137),
    [anon_sym_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_COLON] = ACTIONS(4135),
    [anon_sym_AMP] = ACTIONS(4137),
    [anon_sym_LBRACK] = ACTIONS(4137),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4135),
    [anon_sym_LBRACE] = ACTIONS(4137),
    [anon_sym_LT_AT] = ACTIONS(4137),
    [anon_sym_LT_AT_AT] = ACTIONS(4137),
    [anon_sym_DOT] = ACTIONS(4137),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4135),
    [anon_sym_new] = ACTIONS(4137),
    [anon_sym_with] = ACTIONS(4137),
    [anon_sym_return_BANG] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_yield_BANG] = ACTIONS(4135),
    [anon_sym_lazy] = ACTIONS(4137),
    [anon_sym_assert] = ACTIONS(4137),
    [anon_sym_upcast] = ACTIONS(4137),
    [anon_sym_downcast] = ACTIONS(4137),
    [anon_sym_COLON_GT] = ACTIONS(4135),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4135),
    [anon_sym_for] = ACTIONS(4137),
    [anon_sym_while] = ACTIONS(4137),
    [anon_sym_if] = ACTIONS(4137),
    [anon_sym_fun] = ACTIONS(4137),
    [anon_sym_try] = ACTIONS(4137),
    [anon_sym_match] = ACTIONS(4137),
    [anon_sym_match_BANG] = ACTIONS(4135),
    [anon_sym_function] = ACTIONS(4137),
    [anon_sym_LT_DASH] = ACTIONS(4137),
    [anon_sym_DOT_LBRACK] = ACTIONS(4135),
    [anon_sym_LT] = ACTIONS(4135),
    [anon_sym_use] = ACTIONS(4137),
    [anon_sym_use_BANG] = ACTIONS(4135),
    [anon_sym_do_BANG] = ACTIONS(4135),
    [anon_sym_begin] = ACTIONS(4137),
    [anon_sym_LPAREN2] = ACTIONS(4137),
    [anon_sym_or] = ACTIONS(4137),
    [aux_sym_char_token1] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4137),
    [anon_sym_DQUOTE] = ACTIONS(4137),
    [anon_sym_AT_DQUOTE] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [sym_bool] = ACTIONS(4137),
    [sym_unit] = ACTIONS(4135),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4137),
    [sym_op_identifier] = ACTIONS(4137),
    [anon_sym_PLUS] = ACTIONS(4137),
    [anon_sym_DASH] = ACTIONS(4137),
    [anon_sym_PLUS_DOT] = ACTIONS(4137),
    [anon_sym_DASH_DOT] = ACTIONS(4137),
    [anon_sym_PERCENT] = ACTIONS(4137),
    [anon_sym_AMP_AMP] = ACTIONS(4137),
    [anon_sym_TILDE] = ACTIONS(4135),
    [aux_sym_prefix_op_token1] = ACTIONS(4137),
    [aux_sym_infix_op_token1] = ACTIONS(4135),
    [aux_sym_infix_op_token2] = ACTIONS(4137),
    [anon_sym_PIPE_PIPE] = ACTIONS(4137),
    [anon_sym_BANG_EQ] = ACTIONS(4137),
    [anon_sym_COLON_EQ] = ACTIONS(4135),
    [anon_sym_DOLLAR] = ACTIONS(4137),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4137),
    [sym_int] = ACTIONS(4137),
    [sym_xint] = ACTIONS(4135),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4135),
    [sym__newline] = ACTIONS(4135),
    [sym__dedent] = ACTIONS(4135),
  },
  [2949] = {
    [sym_block_comment] = STATE(2949),
    [sym_compiler_directive_decl] = STATE(2949),
    [sym_fsi_directive_decl] = STATE(2949),
    [sym_preproc_line] = STATE(2949),
    [sym_identifier] = ACTIONS(3946),
    [anon_sym_EQ] = ACTIONS(3944),
    [anon_sym_COLON] = ACTIONS(3946),
    [anon_sym_return] = ACTIONS(3946),
    [anon_sym_do] = ACTIONS(3946),
    [anon_sym_let] = ACTIONS(3946),
    [anon_sym_let_BANG] = ACTIONS(3944),
    [anon_sym_as] = ACTIONS(3946),
    [anon_sym_LPAREN] = ACTIONS(3946),
    [anon_sym_COMMA] = ACTIONS(3944),
    [anon_sym_null] = ACTIONS(3946),
    [anon_sym_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LBRACK] = ACTIONS(3946),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3944),
    [anon_sym_LBRACE] = ACTIONS(3946),
    [anon_sym_LT_AT] = ACTIONS(3946),
    [anon_sym_LT_AT_AT] = ACTIONS(3946),
    [anon_sym_DOT] = ACTIONS(3946),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3944),
    [anon_sym_new] = ACTIONS(3946),
    [anon_sym_with] = ACTIONS(3946),
    [anon_sym_return_BANG] = ACTIONS(3944),
    [anon_sym_yield] = ACTIONS(3946),
    [anon_sym_yield_BANG] = ACTIONS(3944),
    [anon_sym_lazy] = ACTIONS(3946),
    [anon_sym_assert] = ACTIONS(3946),
    [anon_sym_upcast] = ACTIONS(3946),
    [anon_sym_downcast] = ACTIONS(3946),
    [anon_sym_COLON_GT] = ACTIONS(3944),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3944),
    [anon_sym_for] = ACTIONS(3946),
    [anon_sym_while] = ACTIONS(3946),
    [anon_sym_if] = ACTIONS(3946),
    [anon_sym_fun] = ACTIONS(3946),
    [anon_sym_try] = ACTIONS(3946),
    [anon_sym_match] = ACTIONS(3946),
    [anon_sym_match_BANG] = ACTIONS(3944),
    [anon_sym_function] = ACTIONS(3946),
    [anon_sym_LT_DASH] = ACTIONS(3946),
    [anon_sym_DOT_LBRACK] = ACTIONS(3944),
    [anon_sym_LT] = ACTIONS(3944),
    [anon_sym_use] = ACTIONS(3946),
    [anon_sym_use_BANG] = ACTIONS(3944),
    [anon_sym_do_BANG] = ACTIONS(3944),
    [anon_sym_begin] = ACTIONS(3946),
    [anon_sym_LPAREN2] = ACTIONS(3946),
    [anon_sym_or] = ACTIONS(3946),
    [aux_sym_char_token1] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_AT_DQUOTE] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [sym_bool] = ACTIONS(3946),
    [sym_unit] = ACTIONS(3944),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3946),
    [sym_op_identifier] = ACTIONS(3946),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PLUS_DOT] = ACTIONS(3946),
    [anon_sym_DASH_DOT] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3946),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_TILDE] = ACTIONS(3944),
    [aux_sym_prefix_op_token1] = ACTIONS(3946),
    [aux_sym_infix_op_token1] = ACTIONS(3944),
    [aux_sym_infix_op_token2] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [anon_sym_BANG_EQ] = ACTIONS(3946),
    [anon_sym_COLON_EQ] = ACTIONS(3944),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3946),
    [sym_int] = ACTIONS(3946),
    [sym_xint] = ACTIONS(3944),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3944),
    [sym__newline] = ACTIONS(3944),
    [sym__dedent] = ACTIONS(3944),
  },
  [2950] = {
    [sym_block_comment] = STATE(2950),
    [sym_compiler_directive_decl] = STATE(2950),
    [sym_fsi_directive_decl] = STATE(2950),
    [sym_preproc_line] = STATE(2950),
    [aux_sym_sequential_expression_repeat1] = STATE(2958),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_COLON] = ACTIONS(3759),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_let_BANG] = ACTIONS(3757),
    [anon_sym_LPAREN] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3757),
    [anon_sym_null] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3757),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_LT_AT] = ACTIONS(3759),
    [anon_sym_LT_AT_AT] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(3759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_return_BANG] = ACTIONS(3757),
    [anon_sym_yield] = ACTIONS(3759),
    [anon_sym_yield_BANG] = ACTIONS(3757),
    [anon_sym_lazy] = ACTIONS(3759),
    [anon_sym_assert] = ACTIONS(3759),
    [anon_sym_upcast] = ACTIONS(3759),
    [anon_sym_downcast] = ACTIONS(3759),
    [anon_sym_COLON_GT] = ACTIONS(3757),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3757),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_fun] = ACTIONS(3759),
    [anon_sym_DASH_GT] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_match] = ACTIONS(3759),
    [anon_sym_match_BANG] = ACTIONS(3757),
    [anon_sym_function] = ACTIONS(3759),
    [anon_sym_LT_DASH] = ACTIONS(3759),
    [anon_sym_DOT_LBRACK] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_use] = ACTIONS(3759),
    [anon_sym_use_BANG] = ACTIONS(3757),
    [anon_sym_do_BANG] = ACTIONS(3757),
    [anon_sym_DOT_DOT] = ACTIONS(3757),
    [anon_sym_begin] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_or] = ACTIONS(3759),
    [aux_sym_char_token1] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3759),
    [anon_sym_DQUOTE] = ACTIONS(3759),
    [anon_sym_AT_DQUOTE] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [sym_bool] = ACTIONS(3759),
    [sym_unit] = ACTIONS(3757),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3759),
    [sym_op_identifier] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS_DOT] = ACTIONS(3759),
    [anon_sym_DASH_DOT] = ACTIONS(3759),
    [anon_sym_PERCENT] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_TILDE] = ACTIONS(3757),
    [aux_sym_prefix_op_token1] = ACTIONS(3759),
    [aux_sym_infix_op_token1] = ACTIONS(3757),
    [aux_sym_infix_op_token2] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_COLON_EQ] = ACTIONS(3757),
    [anon_sym_DOLLAR] = ACTIONS(3759),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3759),
    [sym_int] = ACTIONS(3759),
    [sym_xint] = ACTIONS(3757),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3757),
    [sym__newline] = ACTIONS(3757),
  },
  [2951] = {
    [sym_block_comment] = STATE(2951),
    [sym_compiler_directive_decl] = STATE(2951),
    [sym_fsi_directive_decl] = STATE(2951),
    [sym_preproc_line] = STATE(2951),
    [sym_identifier] = ACTIONS(3927),
    [anon_sym_EQ] = ACTIONS(3925),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_return] = ACTIONS(3927),
    [anon_sym_do] = ACTIONS(3927),
    [anon_sym_let] = ACTIONS(3927),
    [anon_sym_let_BANG] = ACTIONS(3925),
    [anon_sym_as] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_COMMA] = ACTIONS(3925),
    [anon_sym_null] = ACTIONS(3927),
    [anon_sym_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_COLON] = ACTIONS(3925),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3925),
    [anon_sym_LBRACE] = ACTIONS(3927),
    [anon_sym_LT_AT] = ACTIONS(3927),
    [anon_sym_LT_AT_AT] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3925),
    [anon_sym_new] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3927),
    [anon_sym_return_BANG] = ACTIONS(3925),
    [anon_sym_yield] = ACTIONS(3927),
    [anon_sym_yield_BANG] = ACTIONS(3925),
    [anon_sym_lazy] = ACTIONS(3927),
    [anon_sym_assert] = ACTIONS(3927),
    [anon_sym_upcast] = ACTIONS(3927),
    [anon_sym_downcast] = ACTIONS(3927),
    [anon_sym_COLON_GT] = ACTIONS(3925),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3925),
    [anon_sym_for] = ACTIONS(3927),
    [anon_sym_while] = ACTIONS(3927),
    [anon_sym_if] = ACTIONS(3927),
    [anon_sym_fun] = ACTIONS(3927),
    [anon_sym_try] = ACTIONS(3927),
    [anon_sym_match] = ACTIONS(3927),
    [anon_sym_match_BANG] = ACTIONS(3925),
    [anon_sym_function] = ACTIONS(3927),
    [anon_sym_LT_DASH] = ACTIONS(3927),
    [anon_sym_DOT_LBRACK] = ACTIONS(3925),
    [anon_sym_LT] = ACTIONS(3925),
    [anon_sym_use] = ACTIONS(3927),
    [anon_sym_use_BANG] = ACTIONS(3925),
    [anon_sym_do_BANG] = ACTIONS(3925),
    [anon_sym_begin] = ACTIONS(3927),
    [anon_sym_LPAREN2] = ACTIONS(3927),
    [anon_sym_or] = ACTIONS(3927),
    [aux_sym_char_token1] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_AT_DQUOTE] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [sym_bool] = ACTIONS(3927),
    [sym_unit] = ACTIONS(3925),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3927),
    [sym_op_identifier] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3927),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_PLUS_DOT] = ACTIONS(3927),
    [anon_sym_DASH_DOT] = ACTIONS(3927),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_TILDE] = ACTIONS(3925),
    [aux_sym_prefix_op_token1] = ACTIONS(3927),
    [aux_sym_infix_op_token1] = ACTIONS(3925),
    [aux_sym_infix_op_token2] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_COLON_EQ] = ACTIONS(3925),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3927),
    [sym_int] = ACTIONS(3927),
    [sym_xint] = ACTIONS(3925),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3925),
    [sym__newline] = ACTIONS(3925),
    [sym__dedent] = ACTIONS(3925),
  },
  [2952] = {
    [sym_block_comment] = STATE(2952),
    [sym_compiler_directive_decl] = STATE(2952),
    [sym_fsi_directive_decl] = STATE(2952),
    [sym_preproc_line] = STATE(2952),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(5547),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_GT] = ACTIONS(3685),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_DOT_DOT] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
  },
  [2953] = {
    [sym_block_comment] = STATE(2953),
    [sym_compiler_directive_decl] = STATE(2953),
    [sym_fsi_directive_decl] = STATE(2953),
    [sym_preproc_line] = STATE(2953),
    [sym_identifier] = ACTIONS(3753),
    [anon_sym_EQ] = ACTIONS(3751),
    [anon_sym_COLON] = ACTIONS(3753),
    [anon_sym_return] = ACTIONS(3753),
    [anon_sym_do] = ACTIONS(3753),
    [anon_sym_let] = ACTIONS(3753),
    [anon_sym_let_BANG] = ACTIONS(3751),
    [anon_sym_LPAREN] = ACTIONS(3753),
    [anon_sym_COMMA] = ACTIONS(3751),
    [anon_sym_null] = ACTIONS(3753),
    [anon_sym_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_QMARK] = ACTIONS(3753),
    [anon_sym_COLON_COLON] = ACTIONS(3751),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3751),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_LT_AT] = ACTIONS(3753),
    [anon_sym_AT_GT] = ACTIONS(3753),
    [anon_sym_LT_AT_AT] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3753),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3751),
    [anon_sym_new] = ACTIONS(3753),
    [anon_sym_return_BANG] = ACTIONS(3751),
    [anon_sym_yield] = ACTIONS(3753),
    [anon_sym_yield_BANG] = ACTIONS(3751),
    [anon_sym_lazy] = ACTIONS(3753),
    [anon_sym_assert] = ACTIONS(3753),
    [anon_sym_upcast] = ACTIONS(3753),
    [anon_sym_downcast] = ACTIONS(3753),
    [anon_sym_COLON_GT] = ACTIONS(3751),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3751),
    [anon_sym_for] = ACTIONS(3753),
    [anon_sym_while] = ACTIONS(3753),
    [anon_sym_if] = ACTIONS(3753),
    [anon_sym_fun] = ACTIONS(3753),
    [anon_sym_try] = ACTIONS(3753),
    [anon_sym_match] = ACTIONS(3753),
    [anon_sym_match_BANG] = ACTIONS(3751),
    [anon_sym_function] = ACTIONS(3753),
    [anon_sym_LT_DASH] = ACTIONS(3753),
    [anon_sym_DOT_LBRACK] = ACTIONS(3751),
    [anon_sym_LT] = ACTIONS(3751),
    [anon_sym_use] = ACTIONS(3753),
    [anon_sym_use_BANG] = ACTIONS(3751),
    [anon_sym_do_BANG] = ACTIONS(3751),
    [anon_sym_begin] = ACTIONS(3753),
    [anon_sym_LPAREN2] = ACTIONS(3753),
    [anon_sym_or] = ACTIONS(3753),
    [aux_sym_char_token1] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3753),
    [anon_sym_AT_DQUOTE] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [sym_bool] = ACTIONS(3753),
    [sym_unit] = ACTIONS(3751),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3753),
    [sym_op_identifier] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PLUS_DOT] = ACTIONS(3753),
    [anon_sym_DASH_DOT] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3753),
    [anon_sym_AMP_AMP] = ACTIONS(3753),
    [anon_sym_TILDE] = ACTIONS(3751),
    [aux_sym_prefix_op_token1] = ACTIONS(3753),
    [aux_sym_infix_op_token1] = ACTIONS(3751),
    [aux_sym_infix_op_token2] = ACTIONS(3753),
    [anon_sym_PIPE_PIPE] = ACTIONS(3753),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_COLON_EQ] = ACTIONS(3751),
    [anon_sym_DOLLAR] = ACTIONS(3753),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3753),
    [sym_int] = ACTIONS(5549),
    [sym_xint] = ACTIONS(3751),
    [anon_sym_f] = ACTIONS(3753),
    [aux_sym_decimal_token1] = ACTIONS(3753),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3751),
    [sym__newline] = ACTIONS(3751),
  },
  [2954] = {
    [sym_block_comment] = STATE(2954),
    [sym_compiler_directive_decl] = STATE(2954),
    [sym_fsi_directive_decl] = STATE(2954),
    [sym_preproc_line] = STATE(2954),
    [sym_identifier] = ACTIONS(3841),
    [anon_sym_EQ] = ACTIONS(3839),
    [anon_sym_COLON] = ACTIONS(3841),
    [anon_sym_return] = ACTIONS(3841),
    [anon_sym_do] = ACTIONS(3841),
    [anon_sym_let] = ACTIONS(3841),
    [anon_sym_let_BANG] = ACTIONS(3839),
    [anon_sym_as] = ACTIONS(3841),
    [anon_sym_LPAREN] = ACTIONS(3841),
    [anon_sym_COMMA] = ACTIONS(3839),
    [anon_sym_null] = ACTIONS(3841),
    [anon_sym_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_COLON] = ACTIONS(3839),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_AMP] = ACTIONS(3841),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(3841),
    [anon_sym_LT_AT] = ACTIONS(3841),
    [anon_sym_LT_AT_AT] = ACTIONS(3841),
    [anon_sym_DOT] = ACTIONS(3841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3839),
    [anon_sym_new] = ACTIONS(3841),
    [anon_sym_with] = ACTIONS(3841),
    [anon_sym_return_BANG] = ACTIONS(3839),
    [anon_sym_yield] = ACTIONS(3841),
    [anon_sym_yield_BANG] = ACTIONS(3839),
    [anon_sym_lazy] = ACTIONS(3841),
    [anon_sym_assert] = ACTIONS(3841),
    [anon_sym_upcast] = ACTIONS(3841),
    [anon_sym_downcast] = ACTIONS(3841),
    [anon_sym_COLON_GT] = ACTIONS(3839),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3839),
    [anon_sym_for] = ACTIONS(3841),
    [anon_sym_while] = ACTIONS(3841),
    [anon_sym_if] = ACTIONS(3841),
    [anon_sym_fun] = ACTIONS(3841),
    [anon_sym_try] = ACTIONS(3841),
    [anon_sym_match] = ACTIONS(3841),
    [anon_sym_match_BANG] = ACTIONS(3839),
    [anon_sym_function] = ACTIONS(3841),
    [anon_sym_LT_DASH] = ACTIONS(3841),
    [anon_sym_DOT_LBRACK] = ACTIONS(3839),
    [anon_sym_LT] = ACTIONS(3839),
    [anon_sym_use] = ACTIONS(3841),
    [anon_sym_use_BANG] = ACTIONS(3839),
    [anon_sym_do_BANG] = ACTIONS(3839),
    [anon_sym_begin] = ACTIONS(3841),
    [anon_sym_LPAREN2] = ACTIONS(3841),
    [anon_sym_or] = ACTIONS(3841),
    [aux_sym_char_token1] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3841),
    [anon_sym_DQUOTE] = ACTIONS(3841),
    [anon_sym_AT_DQUOTE] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [sym_bool] = ACTIONS(3841),
    [sym_unit] = ACTIONS(3839),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3841),
    [sym_op_identifier] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_PLUS_DOT] = ACTIONS(3841),
    [anon_sym_DASH_DOT] = ACTIONS(3841),
    [anon_sym_PERCENT] = ACTIONS(3841),
    [anon_sym_AMP_AMP] = ACTIONS(3841),
    [anon_sym_TILDE] = ACTIONS(3839),
    [aux_sym_prefix_op_token1] = ACTIONS(3841),
    [aux_sym_infix_op_token1] = ACTIONS(3839),
    [aux_sym_infix_op_token2] = ACTIONS(3841),
    [anon_sym_PIPE_PIPE] = ACTIONS(3841),
    [anon_sym_BANG_EQ] = ACTIONS(3841),
    [anon_sym_COLON_EQ] = ACTIONS(3839),
    [anon_sym_DOLLAR] = ACTIONS(3841),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3841),
    [sym_int] = ACTIONS(3841),
    [sym_xint] = ACTIONS(3839),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3839),
    [sym__newline] = ACTIONS(3839),
  },
  [2955] = {
    [sym_block_comment] = STATE(2955),
    [sym_compiler_directive_decl] = STATE(2955),
    [sym_fsi_directive_decl] = STATE(2955),
    [sym_preproc_line] = STATE(2955),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_as] = ACTIONS(3193),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
    [sym__dedent] = ACTIONS(3191),
  },
  [2956] = {
    [sym_block_comment] = STATE(2956),
    [sym_compiler_directive_decl] = STATE(2956),
    [sym_fsi_directive_decl] = STATE(2956),
    [sym_preproc_line] = STATE(2956),
    [sym_identifier] = ACTIONS(4104),
    [anon_sym_EQ] = ACTIONS(4102),
    [anon_sym_COLON] = ACTIONS(4104),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_do] = ACTIONS(4104),
    [anon_sym_let] = ACTIONS(4104),
    [anon_sym_let_BANG] = ACTIONS(4102),
    [anon_sym_as] = ACTIONS(4104),
    [anon_sym_LPAREN] = ACTIONS(4104),
    [anon_sym_COMMA] = ACTIONS(4102),
    [anon_sym_null] = ACTIONS(4104),
    [anon_sym_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_COLON] = ACTIONS(4102),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4104),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4102),
    [anon_sym_LBRACE] = ACTIONS(4104),
    [anon_sym_LT_AT] = ACTIONS(4104),
    [anon_sym_LT_AT_AT] = ACTIONS(4104),
    [anon_sym_DOT] = ACTIONS(4104),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4102),
    [anon_sym_new] = ACTIONS(4104),
    [anon_sym_with] = ACTIONS(4104),
    [anon_sym_return_BANG] = ACTIONS(4102),
    [anon_sym_yield] = ACTIONS(4104),
    [anon_sym_yield_BANG] = ACTIONS(4102),
    [anon_sym_lazy] = ACTIONS(4104),
    [anon_sym_assert] = ACTIONS(4104),
    [anon_sym_upcast] = ACTIONS(4104),
    [anon_sym_downcast] = ACTIONS(4104),
    [anon_sym_COLON_GT] = ACTIONS(4102),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4102),
    [anon_sym_for] = ACTIONS(4104),
    [anon_sym_while] = ACTIONS(4104),
    [anon_sym_if] = ACTIONS(4104),
    [anon_sym_fun] = ACTIONS(4104),
    [anon_sym_try] = ACTIONS(4104),
    [anon_sym_match] = ACTIONS(4104),
    [anon_sym_match_BANG] = ACTIONS(4102),
    [anon_sym_function] = ACTIONS(4104),
    [anon_sym_LT_DASH] = ACTIONS(4104),
    [anon_sym_DOT_LBRACK] = ACTIONS(4102),
    [anon_sym_LT] = ACTIONS(4102),
    [anon_sym_use] = ACTIONS(4104),
    [anon_sym_use_BANG] = ACTIONS(4102),
    [anon_sym_do_BANG] = ACTIONS(4102),
    [anon_sym_begin] = ACTIONS(4104),
    [anon_sym_LPAREN2] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [aux_sym_char_token1] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4104),
    [anon_sym_DQUOTE] = ACTIONS(4104),
    [anon_sym_AT_DQUOTE] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [sym_bool] = ACTIONS(4104),
    [sym_unit] = ACTIONS(4102),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4104),
    [sym_op_identifier] = ACTIONS(4104),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_PLUS_DOT] = ACTIONS(4104),
    [anon_sym_DASH_DOT] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_AMP_AMP] = ACTIONS(4104),
    [anon_sym_TILDE] = ACTIONS(4102),
    [aux_sym_prefix_op_token1] = ACTIONS(4104),
    [aux_sym_infix_op_token1] = ACTIONS(4102),
    [aux_sym_infix_op_token2] = ACTIONS(4104),
    [anon_sym_PIPE_PIPE] = ACTIONS(4104),
    [anon_sym_BANG_EQ] = ACTIONS(4104),
    [anon_sym_COLON_EQ] = ACTIONS(4102),
    [anon_sym_DOLLAR] = ACTIONS(4104),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4104),
    [sym_int] = ACTIONS(4104),
    [sym_xint] = ACTIONS(4102),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4102),
    [sym__newline] = ACTIONS(4102),
    [sym__dedent] = ACTIONS(4102),
  },
  [2957] = {
    [sym_block_comment] = STATE(2957),
    [sym_compiler_directive_decl] = STATE(2957),
    [sym_fsi_directive_decl] = STATE(2957),
    [sym_preproc_line] = STATE(2957),
    [sym_identifier] = ACTIONS(3728),
    [anon_sym_EQ] = ACTIONS(3726),
    [anon_sym_COLON] = ACTIONS(3728),
    [anon_sym_return] = ACTIONS(3728),
    [anon_sym_do] = ACTIONS(3728),
    [anon_sym_let] = ACTIONS(3728),
    [anon_sym_let_BANG] = ACTIONS(3726),
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_COMMA] = ACTIONS(3726),
    [anon_sym_null] = ACTIONS(3728),
    [anon_sym_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_QMARK] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(3726),
    [anon_sym_AMP] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3726),
    [anon_sym_LBRACE] = ACTIONS(3728),
    [anon_sym_LT_AT] = ACTIONS(3728),
    [anon_sym_LT_AT_AT] = ACTIONS(3728),
    [anon_sym_DOT] = ACTIONS(3728),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3726),
    [anon_sym_new] = ACTIONS(3728),
    [anon_sym_return_BANG] = ACTIONS(3726),
    [anon_sym_yield] = ACTIONS(3728),
    [anon_sym_yield_BANG] = ACTIONS(3726),
    [anon_sym_lazy] = ACTIONS(3728),
    [anon_sym_assert] = ACTIONS(3728),
    [anon_sym_upcast] = ACTIONS(3728),
    [anon_sym_downcast] = ACTIONS(3728),
    [anon_sym_COLON_GT] = ACTIONS(3726),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3726),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_fun] = ACTIONS(3728),
    [anon_sym_try] = ACTIONS(3728),
    [anon_sym_match] = ACTIONS(3728),
    [anon_sym_match_BANG] = ACTIONS(3726),
    [anon_sym_function] = ACTIONS(3728),
    [anon_sym_LT_DASH] = ACTIONS(3728),
    [anon_sym_DOT_LBRACK] = ACTIONS(3726),
    [anon_sym_LT] = ACTIONS(3726),
    [anon_sym_use] = ACTIONS(3728),
    [anon_sym_use_BANG] = ACTIONS(3726),
    [anon_sym_do_BANG] = ACTIONS(3726),
    [anon_sym_begin] = ACTIONS(3728),
    [anon_sym_LPAREN2] = ACTIONS(3728),
    [anon_sym_or] = ACTIONS(3728),
    [aux_sym_char_token1] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3728),
    [anon_sym_AT_DQUOTE] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [sym_bool] = ACTIONS(3728),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3728),
    [sym_op_identifier] = ACTIONS(3728),
    [anon_sym_PLUS] = ACTIONS(3728),
    [anon_sym_DASH] = ACTIONS(3728),
    [anon_sym_PLUS_DOT] = ACTIONS(3728),
    [anon_sym_DASH_DOT] = ACTIONS(3728),
    [anon_sym_PERCENT] = ACTIONS(3728),
    [anon_sym_AMP_AMP] = ACTIONS(3728),
    [anon_sym_TILDE] = ACTIONS(3726),
    [aux_sym_prefix_op_token1] = ACTIONS(3728),
    [aux_sym_infix_op_token1] = ACTIONS(3726),
    [aux_sym_infix_op_token2] = ACTIONS(3728),
    [anon_sym_PIPE_PIPE] = ACTIONS(3728),
    [anon_sym_BANG_EQ] = ACTIONS(3728),
    [anon_sym_COLON_EQ] = ACTIONS(3726),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3728),
    [sym_int] = ACTIONS(3728),
    [sym_xint] = ACTIONS(3726),
    [anon_sym_f] = ACTIONS(3728),
    [aux_sym_decimal_token1] = ACTIONS(3728),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3726),
    [anon_sym_POUNDendif] = ACTIONS(3726),
    [sym__newline] = ACTIONS(3726),
  },
  [2958] = {
    [sym_block_comment] = STATE(2958),
    [sym_compiler_directive_decl] = STATE(2958),
    [sym_fsi_directive_decl] = STATE(2958),
    [sym_preproc_line] = STATE(2958),
    [aux_sym_sequential_expression_repeat1] = STATE(2958),
    [sym_identifier] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3765),
    [anon_sym_COLON] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_let_BANG] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(3767),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_null] = ACTIONS(3767),
    [anon_sym_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3765),
    [anon_sym_LBRACE] = ACTIONS(3767),
    [anon_sym_LT_AT] = ACTIONS(3767),
    [anon_sym_LT_AT_AT] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3765),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_return_BANG] = ACTIONS(3765),
    [anon_sym_yield] = ACTIONS(3767),
    [anon_sym_yield_BANG] = ACTIONS(3765),
    [anon_sym_lazy] = ACTIONS(3767),
    [anon_sym_assert] = ACTIONS(3767),
    [anon_sym_upcast] = ACTIONS(3767),
    [anon_sym_downcast] = ACTIONS(3767),
    [anon_sym_COLON_GT] = ACTIONS(3765),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3765),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_fun] = ACTIONS(3767),
    [anon_sym_DASH_GT] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_match] = ACTIONS(3767),
    [anon_sym_match_BANG] = ACTIONS(3765),
    [anon_sym_function] = ACTIONS(3767),
    [anon_sym_LT_DASH] = ACTIONS(3767),
    [anon_sym_DOT_LBRACK] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(3765),
    [anon_sym_use] = ACTIONS(3767),
    [anon_sym_use_BANG] = ACTIONS(3765),
    [anon_sym_do_BANG] = ACTIONS(3765),
    [anon_sym_DOT_DOT] = ACTIONS(3765),
    [anon_sym_begin] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3767),
    [anon_sym_or] = ACTIONS(3767),
    [aux_sym_char_token1] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3767),
    [anon_sym_DQUOTE] = ACTIONS(3767),
    [anon_sym_AT_DQUOTE] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [sym_bool] = ACTIONS(3767),
    [sym_unit] = ACTIONS(3765),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3767),
    [sym_op_identifier] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_PLUS_DOT] = ACTIONS(3767),
    [anon_sym_DASH_DOT] = ACTIONS(3767),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_AMP_AMP] = ACTIONS(3767),
    [anon_sym_TILDE] = ACTIONS(3765),
    [aux_sym_prefix_op_token1] = ACTIONS(3767),
    [aux_sym_infix_op_token1] = ACTIONS(3765),
    [aux_sym_infix_op_token2] = ACTIONS(3767),
    [anon_sym_PIPE_PIPE] = ACTIONS(3767),
    [anon_sym_BANG_EQ] = ACTIONS(3767),
    [anon_sym_COLON_EQ] = ACTIONS(3765),
    [anon_sym_DOLLAR] = ACTIONS(3767),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3767),
    [sym_int] = ACTIONS(3767),
    [sym_xint] = ACTIONS(3765),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3765),
    [sym__newline] = ACTIONS(5551),
  },
  [2959] = {
    [sym_block_comment] = STATE(2959),
    [sym_compiler_directive_decl] = STATE(2959),
    [sym_fsi_directive_decl] = STATE(2959),
    [sym_preproc_line] = STATE(2959),
    [aux_sym_sequential_expression_repeat1] = STATE(2947),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_COLON] = ACTIONS(3759),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_let_BANG] = ACTIONS(3757),
    [anon_sym_LPAREN] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3757),
    [anon_sym_null] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3757),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_LT_AT] = ACTIONS(3759),
    [anon_sym_LT_AT_AT] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(3759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_return_BANG] = ACTIONS(3757),
    [anon_sym_yield] = ACTIONS(3759),
    [anon_sym_yield_BANG] = ACTIONS(3757),
    [anon_sym_lazy] = ACTIONS(3759),
    [anon_sym_assert] = ACTIONS(3759),
    [anon_sym_upcast] = ACTIONS(3759),
    [anon_sym_downcast] = ACTIONS(3759),
    [anon_sym_COLON_GT] = ACTIONS(3757),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3757),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_fun] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_match] = ACTIONS(3759),
    [anon_sym_match_BANG] = ACTIONS(3757),
    [anon_sym_function] = ACTIONS(3759),
    [anon_sym_LT_DASH] = ACTIONS(3759),
    [anon_sym_DOT_LBRACK] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_use] = ACTIONS(3759),
    [anon_sym_use_BANG] = ACTIONS(3757),
    [anon_sym_do_BANG] = ACTIONS(3757),
    [anon_sym_begin] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_DOT_DOT2] = ACTIONS(3757),
    [anon_sym_or] = ACTIONS(3759),
    [aux_sym_char_token1] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3759),
    [anon_sym_DQUOTE] = ACTIONS(3759),
    [anon_sym_AT_DQUOTE] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [sym_bool] = ACTIONS(3759),
    [sym_unit] = ACTIONS(3757),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3759),
    [sym_op_identifier] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS_DOT] = ACTIONS(3759),
    [anon_sym_DASH_DOT] = ACTIONS(3759),
    [anon_sym_PERCENT] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_TILDE] = ACTIONS(3757),
    [aux_sym_prefix_op_token1] = ACTIONS(3759),
    [aux_sym_infix_op_token1] = ACTIONS(3757),
    [aux_sym_infix_op_token2] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_COLON_EQ] = ACTIONS(3757),
    [anon_sym_DOLLAR] = ACTIONS(3759),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3759),
    [sym_int] = ACTIONS(3759),
    [sym_xint] = ACTIONS(3757),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3757),
    [sym__newline] = ACTIONS(3757),
    [sym__dedent] = ACTIONS(3757),
  },
  [2960] = {
    [sym_block_comment] = STATE(2960),
    [sym_compiler_directive_decl] = STATE(2960),
    [sym_fsi_directive_decl] = STATE(2960),
    [sym_preproc_line] = STATE(2960),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_done] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_GT] = ACTIONS(3700),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_DOT_DOT] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [2961] = {
    [sym_block_comment] = STATE(2961),
    [sym_compiler_directive_decl] = STATE(2961),
    [sym_fsi_directive_decl] = STATE(2961),
    [sym_preproc_line] = STATE(2961),
    [aux_sym_sequential_expression_repeat1] = STATE(2893),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_COLON] = ACTIONS(3759),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_let_BANG] = ACTIONS(3757),
    [anon_sym_LPAREN] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3757),
    [anon_sym_null] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_RBRACK] = ACTIONS(3757),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3757),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_LT_AT] = ACTIONS(3759),
    [anon_sym_LT_AT_AT] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(3759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_return_BANG] = ACTIONS(3757),
    [anon_sym_yield] = ACTIONS(3759),
    [anon_sym_yield_BANG] = ACTIONS(3757),
    [anon_sym_lazy] = ACTIONS(3759),
    [anon_sym_assert] = ACTIONS(3759),
    [anon_sym_upcast] = ACTIONS(3759),
    [anon_sym_downcast] = ACTIONS(3759),
    [anon_sym_COLON_GT] = ACTIONS(3757),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3757),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_fun] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_match] = ACTIONS(3759),
    [anon_sym_match_BANG] = ACTIONS(3757),
    [anon_sym_function] = ACTIONS(3759),
    [anon_sym_LT_DASH] = ACTIONS(3759),
    [anon_sym_DOT_LBRACK] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_use] = ACTIONS(3759),
    [anon_sym_use_BANG] = ACTIONS(3757),
    [anon_sym_do_BANG] = ACTIONS(3757),
    [anon_sym_begin] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_DOT_DOT2] = ACTIONS(3757),
    [anon_sym_or] = ACTIONS(3759),
    [aux_sym_char_token1] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3759),
    [anon_sym_DQUOTE] = ACTIONS(3759),
    [anon_sym_AT_DQUOTE] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [sym_bool] = ACTIONS(3759),
    [sym_unit] = ACTIONS(3757),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3759),
    [sym_op_identifier] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS_DOT] = ACTIONS(3759),
    [anon_sym_DASH_DOT] = ACTIONS(3759),
    [anon_sym_PERCENT] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_TILDE] = ACTIONS(3757),
    [aux_sym_prefix_op_token1] = ACTIONS(3759),
    [aux_sym_infix_op_token1] = ACTIONS(3757),
    [aux_sym_infix_op_token2] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_COLON_EQ] = ACTIONS(3757),
    [anon_sym_DOLLAR] = ACTIONS(3759),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3759),
    [sym_int] = ACTIONS(3759),
    [sym_xint] = ACTIONS(3757),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3757),
    [sym__newline] = ACTIONS(3757),
  },
  [2962] = {
    [sym_block_comment] = STATE(2962),
    [sym_compiler_directive_decl] = STATE(2962),
    [sym_fsi_directive_decl] = STATE(2962),
    [sym_preproc_line] = STATE(2962),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_QMARK] = ACTIONS(3604),
    [anon_sym_COLON_COLON] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3604),
    [anon_sym_DOT] = ACTIONS(3604),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_COLON_GT] = ACTIONS(3602),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3602),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_LT_DASH] = ACTIONS(3604),
    [anon_sym_DOT_LBRACK] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(3604),
    [anon_sym_or] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3604),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3604),
    [anon_sym_DASH_DOT] = ACTIONS(3604),
    [anon_sym_PERCENT] = ACTIONS(3604),
    [anon_sym_AMP_AMP] = ACTIONS(3604),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3604),
    [aux_sym_infix_op_token1] = ACTIONS(3602),
    [aux_sym_infix_op_token2] = ACTIONS(3604),
    [anon_sym_PIPE_PIPE] = ACTIONS(3604),
    [anon_sym_BANG_EQ] = ACTIONS(3604),
    [anon_sym_COLON_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3604),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
    [anon_sym_POUNDendif] = ACTIONS(3602),
    [sym__newline] = ACTIONS(3602),
  },
  [2963] = {
    [sym_block_comment] = STATE(2963),
    [sym_compiler_directive_decl] = STATE(2963),
    [sym_fsi_directive_decl] = STATE(2963),
    [sym_preproc_line] = STATE(2963),
    [aux_sym_rules_repeat1] = STATE(2942),
    [sym_identifier] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(3691),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_do] = ACTIONS(3693),
    [anon_sym_let] = ACTIONS(3693),
    [anon_sym_let_BANG] = ACTIONS(3691),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_null] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_QMARK] = ACTIONS(3693),
    [anon_sym_COLON_COLON] = ACTIONS(3691),
    [anon_sym_PIPE] = ACTIONS(5470),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_LT_AT] = ACTIONS(3693),
    [anon_sym_LT_AT_AT] = ACTIONS(3693),
    [anon_sym_AT_AT_GT] = ACTIONS(3693),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3693),
    [anon_sym_return_BANG] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_yield_BANG] = ACTIONS(3691),
    [anon_sym_lazy] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_upcast] = ACTIONS(3693),
    [anon_sym_downcast] = ACTIONS(3693),
    [anon_sym_COLON_GT] = ACTIONS(3691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_fun] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_match] = ACTIONS(3693),
    [anon_sym_match_BANG] = ACTIONS(3691),
    [anon_sym_function] = ACTIONS(3693),
    [anon_sym_LT_DASH] = ACTIONS(3693),
    [anon_sym_DOT_LBRACK] = ACTIONS(3691),
    [anon_sym_LT] = ACTIONS(3691),
    [anon_sym_use] = ACTIONS(3693),
    [anon_sym_use_BANG] = ACTIONS(3691),
    [anon_sym_do_BANG] = ACTIONS(3691),
    [anon_sym_begin] = ACTIONS(3693),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_or] = ACTIONS(3693),
    [aux_sym_char_token1] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_AT_DQUOTE] = ACTIONS(3691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3691),
    [sym_bool] = ACTIONS(3693),
    [sym_unit] = ACTIONS(3691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3693),
    [sym_op_identifier] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_DOT] = ACTIONS(3693),
    [anon_sym_DASH_DOT] = ACTIONS(3693),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3691),
    [aux_sym_prefix_op_token1] = ACTIONS(3693),
    [aux_sym_infix_op_token1] = ACTIONS(3691),
    [aux_sym_infix_op_token2] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3693),
    [anon_sym_COLON_EQ] = ACTIONS(3691),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3693),
    [sym_int] = ACTIONS(3693),
    [sym_xint] = ACTIONS(3691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3691),
    [sym__newline] = ACTIONS(5538),
  },
  [2964] = {
    [sym_block_comment] = STATE(2964),
    [sym_compiler_directive_decl] = STATE(2964),
    [sym_fsi_directive_decl] = STATE(2964),
    [sym_preproc_line] = STATE(2964),
    [aux_sym_long_identifier_repeat1] = STATE(2879),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_DASH_GT] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_DOT_DOT] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_or] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
  },
  [2965] = {
    [sym_block_comment] = STATE(2965),
    [sym_compiler_directive_decl] = STATE(2965),
    [sym_fsi_directive_decl] = STATE(2965),
    [sym_preproc_line] = STATE(2965),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(5393),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_DASH_GT] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_DOT_DOT] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
  },
  [2966] = {
    [sym_block_comment] = STATE(2966),
    [sym_compiler_directive_decl] = STATE(2966),
    [sym_fsi_directive_decl] = STATE(2966),
    [sym_preproc_line] = STATE(2966),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_AT_AT_GT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_f] = ACTIONS(4714),
    [aux_sym_decimal_token1] = ACTIONS(4432),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [2967] = {
    [sym_block_comment] = STATE(2967),
    [sym_compiler_directive_decl] = STATE(2967),
    [sym_fsi_directive_decl] = STATE(2967),
    [sym_preproc_line] = STATE(2967),
    [sym_identifier] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3774),
    [anon_sym_do] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3774),
    [anon_sym_let_BANG] = ACTIONS(3772),
    [anon_sym_as] = ACTIONS(3774),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3772),
    [anon_sym_null] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_COLON] = ACTIONS(3772),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_LT_AT] = ACTIONS(3774),
    [anon_sym_LT_AT_AT] = ACTIONS(3774),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3772),
    [anon_sym_new] = ACTIONS(3774),
    [anon_sym_with] = ACTIONS(3774),
    [anon_sym_return_BANG] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3774),
    [anon_sym_yield_BANG] = ACTIONS(3772),
    [anon_sym_lazy] = ACTIONS(3774),
    [anon_sym_assert] = ACTIONS(3774),
    [anon_sym_upcast] = ACTIONS(3774),
    [anon_sym_downcast] = ACTIONS(3774),
    [anon_sym_COLON_GT] = ACTIONS(3772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3774),
    [anon_sym_done] = ACTIONS(5556),
    [anon_sym_while] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3774),
    [anon_sym_fun] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3774),
    [anon_sym_match] = ACTIONS(3774),
    [anon_sym_match_BANG] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3774),
    [anon_sym_LT_DASH] = ACTIONS(3774),
    [anon_sym_DOT_LBRACK] = ACTIONS(3772),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_use] = ACTIONS(3774),
    [anon_sym_use_BANG] = ACTIONS(3772),
    [anon_sym_do_BANG] = ACTIONS(3772),
    [anon_sym_begin] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3774),
    [anon_sym_or] = ACTIONS(3774),
    [aux_sym_char_token1] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_AT_DQUOTE] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [sym_bool] = ACTIONS(3774),
    [sym_unit] = ACTIONS(3772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3774),
    [sym_op_identifier] = ACTIONS(3774),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_DOT] = ACTIONS(3774),
    [anon_sym_DASH_DOT] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3772),
    [aux_sym_prefix_op_token1] = ACTIONS(3774),
    [aux_sym_infix_op_token1] = ACTIONS(3772),
    [aux_sym_infix_op_token2] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3774),
    [anon_sym_COLON_EQ] = ACTIONS(3772),
    [anon_sym_DOLLAR] = ACTIONS(3774),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3774),
    [sym_int] = ACTIONS(3774),
    [sym_xint] = ACTIONS(3772),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3772),
    [sym__newline] = ACTIONS(3772),
  },
  [2968] = {
    [sym_attributes] = STATE(3988),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4988),
    [sym__pattern] = STATE(2928),
    [sym_optional_pattern] = STATE(4988),
    [sym_type_check_pattern] = STATE(4988),
    [sym_attribute_pattern] = STATE(4988),
    [sym_paren_pattern] = STATE(4988),
    [sym_as_pattern] = STATE(4988),
    [sym_cons_pattern] = STATE(4988),
    [sym_disjunct_pattern] = STATE(4988),
    [sym_conjunct_pattern] = STATE(4988),
    [sym_typed_pattern] = STATE(4988),
    [sym_list_pattern] = STATE(4988),
    [sym_array_pattern] = STATE(4988),
    [sym_record_pattern] = STATE(4988),
    [sym_named_field_pattern] = STATE(4988),
    [sym_identifier_pattern] = STATE(4988),
    [sym_long_identifier_or_op] = STATE(3177),
    [sym_char] = STATE(5109),
    [sym_format_string] = STATE(5097),
    [sym__string_literal] = STATE(5097),
    [sym_string] = STATE(5109),
    [sym_verbatim_string] = STATE(5109),
    [sym_bytearray] = STATE(5109),
    [sym_verbatim_bytearray] = STATE(5109),
    [sym_format_triple_quoted_string] = STATE(5096),
    [sym_triple_quoted_string] = STATE(5109),
    [sym_const] = STATE(4988),
    [sym_long_identifier] = STATE(4907),
    [sym_active_pattern] = STATE(5059),
    [sym__identifier_or_op] = STATE(4927),
    [sym_sbyte] = STATE(5109),
    [sym_byte] = STATE(5109),
    [sym_int16] = STATE(5109),
    [sym_uint16] = STATE(5109),
    [sym_int32] = STATE(5109),
    [sym_uint32] = STATE(5109),
    [sym_nativeint] = STATE(5109),
    [sym_unativeint] = STATE(5109),
    [sym_int64] = STATE(5109),
    [sym_uint64] = STATE(5109),
    [sym_ieee32] = STATE(5109),
    [sym_ieee64] = STATE(5109),
    [sym_bignum] = STATE(5109),
    [sym_decimal] = STATE(5109),
    [sym_float] = STATE(4781),
    [sym_block_comment] = STATE(2968),
    [sym_compiler_directive_decl] = STATE(2968),
    [sym_fsi_directive_decl] = STATE(2968),
    [sym_preproc_line] = STATE(2968),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5490),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_COLON] = ACTIONS(5558),
    [anon_sym_as] = ACTIONS(5558),
    [anon_sym_LPAREN] = ACTIONS(5560),
    [anon_sym_RPAREN] = ACTIONS(5562),
    [anon_sym_COMMA] = ACTIONS(5562),
    [anon_sym_null] = ACTIONS(5564),
    [anon_sym__] = ACTIONS(5566),
    [anon_sym_QMARK] = ACTIONS(5568),
    [anon_sym_COLON_QMARK] = ACTIONS(5570),
    [anon_sym_COLON_COLON] = ACTIONS(5562),
    [anon_sym_PIPE] = ACTIONS(5562),
    [anon_sym_AMP] = ACTIONS(5562),
    [anon_sym_LBRACK] = ACTIONS(5572),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5574),
    [anon_sym_LBRACE] = ACTIONS(5576),
    [anon_sym_RBRACE] = ACTIONS(5562),
    [aux_sym_char_token1] = ACTIONS(5578),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5580),
    [anon_sym_DQUOTE] = ACTIONS(5582),
    [anon_sym_AT_DQUOTE] = ACTIONS(5584),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5586),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5588),
    [sym_bool] = ACTIONS(5590),
    [sym_unit] = ACTIONS(5592),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5524),
    [sym_op_identifier] = ACTIONS(5526),
    [sym_int] = ACTIONS(5594),
    [sym_xint] = ACTIONS(5596),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [sym__newline] = ACTIONS(5562),
  },
  [2969] = {
    [sym_block_comment] = STATE(2969),
    [sym_compiler_directive_decl] = STATE(2969),
    [sym_fsi_directive_decl] = STATE(2969),
    [sym_preproc_line] = STATE(2969),
    [sym_identifier] = ACTIONS(3996),
    [anon_sym_EQ] = ACTIONS(3994),
    [anon_sym_COLON] = ACTIONS(3996),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_do] = ACTIONS(3996),
    [anon_sym_let] = ACTIONS(3996),
    [anon_sym_let_BANG] = ACTIONS(3994),
    [anon_sym_LPAREN] = ACTIONS(3996),
    [anon_sym_COMMA] = ACTIONS(3994),
    [anon_sym_null] = ACTIONS(3996),
    [anon_sym_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_COLON] = ACTIONS(3994),
    [anon_sym_AMP] = ACTIONS(3996),
    [anon_sym_LBRACK] = ACTIONS(3996),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3994),
    [anon_sym_LBRACE] = ACTIONS(3996),
    [anon_sym_LT_AT] = ACTIONS(3996),
    [anon_sym_LT_AT_AT] = ACTIONS(3996),
    [anon_sym_DOT] = ACTIONS(3996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3994),
    [anon_sym_new] = ACTIONS(3996),
    [anon_sym_return_BANG] = ACTIONS(3994),
    [anon_sym_yield] = ACTIONS(3996),
    [anon_sym_yield_BANG] = ACTIONS(3994),
    [anon_sym_lazy] = ACTIONS(3996),
    [anon_sym_assert] = ACTIONS(3996),
    [anon_sym_upcast] = ACTIONS(3996),
    [anon_sym_downcast] = ACTIONS(3996),
    [anon_sym_COLON_GT] = ACTIONS(3994),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3994),
    [anon_sym_for] = ACTIONS(3996),
    [anon_sym_while] = ACTIONS(3996),
    [anon_sym_if] = ACTIONS(3996),
    [anon_sym_fun] = ACTIONS(3996),
    [anon_sym_DASH_GT] = ACTIONS(3996),
    [anon_sym_try] = ACTIONS(3996),
    [anon_sym_match] = ACTIONS(3996),
    [anon_sym_match_BANG] = ACTIONS(3994),
    [anon_sym_function] = ACTIONS(3996),
    [anon_sym_LT_DASH] = ACTIONS(3996),
    [anon_sym_DOT_LBRACK] = ACTIONS(3994),
    [anon_sym_LT] = ACTIONS(3994),
    [anon_sym_use] = ACTIONS(3996),
    [anon_sym_use_BANG] = ACTIONS(3994),
    [anon_sym_do_BANG] = ACTIONS(3994),
    [anon_sym_DOT_DOT] = ACTIONS(3994),
    [anon_sym_begin] = ACTIONS(3996),
    [anon_sym_LPAREN2] = ACTIONS(3996),
    [anon_sym_or] = ACTIONS(3996),
    [aux_sym_char_token1] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3996),
    [anon_sym_DQUOTE] = ACTIONS(3996),
    [anon_sym_AT_DQUOTE] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [sym_bool] = ACTIONS(3996),
    [sym_unit] = ACTIONS(3994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3996),
    [sym_op_identifier] = ACTIONS(3996),
    [anon_sym_PLUS] = ACTIONS(3996),
    [anon_sym_DASH] = ACTIONS(3996),
    [anon_sym_PLUS_DOT] = ACTIONS(3996),
    [anon_sym_DASH_DOT] = ACTIONS(3996),
    [anon_sym_PERCENT] = ACTIONS(3996),
    [anon_sym_AMP_AMP] = ACTIONS(3996),
    [anon_sym_TILDE] = ACTIONS(3994),
    [aux_sym_prefix_op_token1] = ACTIONS(3996),
    [aux_sym_infix_op_token1] = ACTIONS(3994),
    [aux_sym_infix_op_token2] = ACTIONS(3996),
    [anon_sym_PIPE_PIPE] = ACTIONS(3996),
    [anon_sym_BANG_EQ] = ACTIONS(3996),
    [anon_sym_COLON_EQ] = ACTIONS(3994),
    [anon_sym_DOLLAR] = ACTIONS(3996),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3996),
    [sym_int] = ACTIONS(3996),
    [sym_xint] = ACTIONS(3994),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3994),
    [sym__newline] = ACTIONS(3994),
  },
  [2970] = {
    [sym_type_arguments] = STATE(3605),
    [sym_long_identifier] = STATE(3604),
    [sym_block_comment] = STATE(2970),
    [sym_compiler_directive_decl] = STATE(2970),
    [sym_fsi_directive_decl] = STATE(2970),
    [sym_preproc_line] = STATE(2970),
    [aux_sym_compound_type_repeat1] = STATE(3597),
    [ts_builtin_sym_end] = ACTIONS(3429),
    [sym_identifier] = ACTIONS(5379),
    [anon_sym_namespace] = ACTIONS(3431),
    [anon_sym_module] = ACTIONS(3431),
    [anon_sym_open] = ACTIONS(3431),
    [anon_sym_LBRACK_LT] = ACTIONS(3429),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_type] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_and] = ACTIONS(3431),
    [anon_sym_let] = ACTIONS(3431),
    [anon_sym_let_BANG] = ACTIONS(3429),
    [aux_sym_access_modifier_token1] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(3431),
    [anon_sym_null] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_LT_AT] = ACTIONS(3431),
    [anon_sym_LT_AT_AT] = ACTIONS(3429),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_with] = ACTIONS(3431),
    [anon_sym_return_BANG] = ACTIONS(3429),
    [anon_sym_yield] = ACTIONS(3431),
    [anon_sym_yield_BANG] = ACTIONS(3429),
    [anon_sym_lazy] = ACTIONS(3431),
    [anon_sym_assert] = ACTIONS(3431),
    [anon_sym_upcast] = ACTIONS(3431),
    [anon_sym_downcast] = ACTIONS(3431),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_fun] = ACTIONS(3431),
    [anon_sym_DASH_GT] = ACTIONS(5385),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_match] = ACTIONS(3431),
    [anon_sym_match_BANG] = ACTIONS(3429),
    [anon_sym_function] = ACTIONS(3431),
    [anon_sym_use] = ACTIONS(3431),
    [anon_sym_use_BANG] = ACTIONS(3429),
    [anon_sym_do_BANG] = ACTIONS(3429),
    [anon_sym_begin] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(5387),
    [anon_sym_LT2] = ACTIONS(5389),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5391),
    [anon_sym_default] = ACTIONS(3431),
    [anon_sym_static] = ACTIONS(3431),
    [anon_sym_member] = ACTIONS(3431),
    [anon_sym_interface] = ACTIONS(3431),
    [anon_sym_exception] = ACTIONS(3431),
    [anon_sym_abstract] = ACTIONS(3431),
    [anon_sym_val] = ACTIONS(3431),
    [anon_sym_override] = ACTIONS(3431),
    [aux_sym_char_token1] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [anon_sym_AT_DQUOTE] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [sym_bool] = ACTIONS(3431),
    [sym_unit] = ACTIONS(3429),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3431),
    [sym_op_identifier] = ACTIONS(3429),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_DOT] = ACTIONS(3429),
    [anon_sym_DASH_DOT] = ACTIONS(3429),
    [anon_sym_PERCENT] = ACTIONS(3429),
    [anon_sym_AMP_AMP] = ACTIONS(3429),
    [anon_sym_TILDE] = ACTIONS(3429),
    [aux_sym_prefix_op_token1] = ACTIONS(3429),
    [sym_int] = ACTIONS(3431),
    [sym_xint] = ACTIONS(3429),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3429),
    [anon_sym_POUNDload] = ACTIONS(3429),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3429),
  },
  [2971] = {
    [sym_block_comment] = STATE(2971),
    [sym_compiler_directive_decl] = STATE(2971),
    [sym_fsi_directive_decl] = STATE(2971),
    [sym_preproc_line] = STATE(2971),
    [sym_identifier] = ACTIONS(3917),
    [anon_sym_EQ] = ACTIONS(3915),
    [anon_sym_COLON] = ACTIONS(3917),
    [anon_sym_return] = ACTIONS(3917),
    [anon_sym_do] = ACTIONS(3917),
    [anon_sym_let] = ACTIONS(3917),
    [anon_sym_let_BANG] = ACTIONS(3915),
    [anon_sym_as] = ACTIONS(3917),
    [anon_sym_LPAREN] = ACTIONS(3917),
    [anon_sym_COMMA] = ACTIONS(3915),
    [anon_sym_null] = ACTIONS(3917),
    [anon_sym_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_COLON] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(3917),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3915),
    [anon_sym_LBRACE] = ACTIONS(3917),
    [anon_sym_LT_AT] = ACTIONS(3917),
    [anon_sym_LT_AT_AT] = ACTIONS(3917),
    [anon_sym_DOT] = ACTIONS(3917),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3915),
    [anon_sym_new] = ACTIONS(3917),
    [anon_sym_with] = ACTIONS(3917),
    [anon_sym_return_BANG] = ACTIONS(3915),
    [anon_sym_yield] = ACTIONS(3917),
    [anon_sym_yield_BANG] = ACTIONS(3915),
    [anon_sym_lazy] = ACTIONS(3917),
    [anon_sym_assert] = ACTIONS(3917),
    [anon_sym_upcast] = ACTIONS(3917),
    [anon_sym_downcast] = ACTIONS(3917),
    [anon_sym_COLON_GT] = ACTIONS(3915),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3915),
    [anon_sym_for] = ACTIONS(3917),
    [anon_sym_while] = ACTIONS(3917),
    [anon_sym_if] = ACTIONS(3917),
    [anon_sym_fun] = ACTIONS(3917),
    [anon_sym_try] = ACTIONS(3917),
    [anon_sym_match] = ACTIONS(3917),
    [anon_sym_match_BANG] = ACTIONS(3915),
    [anon_sym_function] = ACTIONS(3917),
    [anon_sym_LT_DASH] = ACTIONS(3917),
    [anon_sym_DOT_LBRACK] = ACTIONS(3915),
    [anon_sym_LT] = ACTIONS(3915),
    [anon_sym_use] = ACTIONS(3917),
    [anon_sym_use_BANG] = ACTIONS(3915),
    [anon_sym_do_BANG] = ACTIONS(3915),
    [anon_sym_begin] = ACTIONS(3917),
    [anon_sym_LPAREN2] = ACTIONS(3917),
    [anon_sym_or] = ACTIONS(3917),
    [aux_sym_char_token1] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_AT_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [sym_bool] = ACTIONS(3917),
    [sym_unit] = ACTIONS(3915),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3917),
    [sym_op_identifier] = ACTIONS(3917),
    [anon_sym_PLUS] = ACTIONS(3917),
    [anon_sym_DASH] = ACTIONS(3917),
    [anon_sym_PLUS_DOT] = ACTIONS(3917),
    [anon_sym_DASH_DOT] = ACTIONS(3917),
    [anon_sym_PERCENT] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_TILDE] = ACTIONS(3915),
    [aux_sym_prefix_op_token1] = ACTIONS(3917),
    [aux_sym_infix_op_token1] = ACTIONS(3915),
    [aux_sym_infix_op_token2] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_BANG_EQ] = ACTIONS(3917),
    [anon_sym_COLON_EQ] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3917),
    [sym_int] = ACTIONS(3917),
    [sym_xint] = ACTIONS(3915),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3915),
    [sym__newline] = ACTIONS(3915),
  },
  [2972] = {
    [sym_block_comment] = STATE(2972),
    [sym_compiler_directive_decl] = STATE(2972),
    [sym_fsi_directive_decl] = STATE(2972),
    [sym_preproc_line] = STATE(2972),
    [aux_sym_sequential_expression_repeat1] = STATE(3032),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_COLON] = ACTIONS(3759),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_let_BANG] = ACTIONS(3757),
    [anon_sym_LPAREN] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3757),
    [anon_sym_null] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3757),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_LT_AT] = ACTIONS(3759),
    [anon_sym_LT_AT_AT] = ACTIONS(3759),
    [anon_sym_AT_AT_GT] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(3759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_return_BANG] = ACTIONS(3757),
    [anon_sym_yield] = ACTIONS(3759),
    [anon_sym_yield_BANG] = ACTIONS(3757),
    [anon_sym_lazy] = ACTIONS(3759),
    [anon_sym_assert] = ACTIONS(3759),
    [anon_sym_upcast] = ACTIONS(3759),
    [anon_sym_downcast] = ACTIONS(3759),
    [anon_sym_COLON_GT] = ACTIONS(3757),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3757),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_fun] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_match] = ACTIONS(3759),
    [anon_sym_match_BANG] = ACTIONS(3757),
    [anon_sym_function] = ACTIONS(3759),
    [anon_sym_LT_DASH] = ACTIONS(3759),
    [anon_sym_DOT_LBRACK] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_use] = ACTIONS(3759),
    [anon_sym_use_BANG] = ACTIONS(3757),
    [anon_sym_do_BANG] = ACTIONS(3757),
    [anon_sym_begin] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_or] = ACTIONS(3759),
    [aux_sym_char_token1] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3759),
    [anon_sym_DQUOTE] = ACTIONS(3759),
    [anon_sym_AT_DQUOTE] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [sym_bool] = ACTIONS(3759),
    [sym_unit] = ACTIONS(3757),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3759),
    [sym_op_identifier] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS_DOT] = ACTIONS(3759),
    [anon_sym_DASH_DOT] = ACTIONS(3759),
    [anon_sym_PERCENT] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_TILDE] = ACTIONS(3757),
    [aux_sym_prefix_op_token1] = ACTIONS(3759),
    [aux_sym_infix_op_token1] = ACTIONS(3757),
    [aux_sym_infix_op_token2] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_COLON_EQ] = ACTIONS(3757),
    [anon_sym_DOLLAR] = ACTIONS(3759),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3759),
    [sym_int] = ACTIONS(3759),
    [sym_xint] = ACTIONS(3757),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3757),
    [sym__newline] = ACTIONS(3757),
  },
  [2973] = {
    [sym_block_comment] = STATE(2973),
    [sym_compiler_directive_decl] = STATE(2973),
    [sym_fsi_directive_decl] = STATE(2973),
    [sym_preproc_line] = STATE(2973),
    [sym_identifier] = ACTIONS(3942),
    [anon_sym_EQ] = ACTIONS(3940),
    [anon_sym_COLON] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_let_BANG] = ACTIONS(3940),
    [anon_sym_as] = ACTIONS(3942),
    [anon_sym_LPAREN] = ACTIONS(3942),
    [anon_sym_COMMA] = ACTIONS(3940),
    [anon_sym_null] = ACTIONS(3942),
    [anon_sym_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3940),
    [anon_sym_LBRACE] = ACTIONS(3942),
    [anon_sym_LT_AT] = ACTIONS(3942),
    [anon_sym_LT_AT_AT] = ACTIONS(3942),
    [anon_sym_DOT] = ACTIONS(3942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3940),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_with] = ACTIONS(3942),
    [anon_sym_return_BANG] = ACTIONS(3940),
    [anon_sym_yield] = ACTIONS(3942),
    [anon_sym_yield_BANG] = ACTIONS(3940),
    [anon_sym_lazy] = ACTIONS(3942),
    [anon_sym_assert] = ACTIONS(3942),
    [anon_sym_upcast] = ACTIONS(3942),
    [anon_sym_downcast] = ACTIONS(3942),
    [anon_sym_COLON_GT] = ACTIONS(3940),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3940),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_fun] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_match] = ACTIONS(3942),
    [anon_sym_match_BANG] = ACTIONS(3940),
    [anon_sym_function] = ACTIONS(3942),
    [anon_sym_LT_DASH] = ACTIONS(3942),
    [anon_sym_DOT_LBRACK] = ACTIONS(3940),
    [anon_sym_LT] = ACTIONS(3940),
    [anon_sym_use] = ACTIONS(3942),
    [anon_sym_use_BANG] = ACTIONS(3940),
    [anon_sym_do_BANG] = ACTIONS(3940),
    [anon_sym_begin] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3942),
    [anon_sym_or] = ACTIONS(3942),
    [aux_sym_char_token1] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3942),
    [anon_sym_DQUOTE] = ACTIONS(3942),
    [anon_sym_AT_DQUOTE] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [sym_bool] = ACTIONS(3942),
    [sym_unit] = ACTIONS(3940),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3942),
    [sym_op_identifier] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS_DOT] = ACTIONS(3942),
    [anon_sym_DASH_DOT] = ACTIONS(3942),
    [anon_sym_PERCENT] = ACTIONS(3942),
    [anon_sym_AMP_AMP] = ACTIONS(3942),
    [anon_sym_TILDE] = ACTIONS(3940),
    [aux_sym_prefix_op_token1] = ACTIONS(3942),
    [aux_sym_infix_op_token1] = ACTIONS(3940),
    [aux_sym_infix_op_token2] = ACTIONS(3942),
    [anon_sym_PIPE_PIPE] = ACTIONS(3942),
    [anon_sym_BANG_EQ] = ACTIONS(3942),
    [anon_sym_COLON_EQ] = ACTIONS(3940),
    [anon_sym_DOLLAR] = ACTIONS(3942),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3942),
    [sym_int] = ACTIONS(3942),
    [sym_xint] = ACTIONS(3940),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3940),
    [sym__newline] = ACTIONS(3940),
  },
  [2974] = {
    [sym_type_arguments] = STATE(3605),
    [sym_long_identifier] = STATE(3604),
    [sym_block_comment] = STATE(2974),
    [sym_compiler_directive_decl] = STATE(2974),
    [sym_fsi_directive_decl] = STATE(2974),
    [sym_preproc_line] = STATE(2974),
    [aux_sym_compound_type_repeat1] = STATE(3597),
    [ts_builtin_sym_end] = ACTIONS(3403),
    [sym_identifier] = ACTIONS(5379),
    [anon_sym_namespace] = ACTIONS(3407),
    [anon_sym_module] = ACTIONS(3407),
    [anon_sym_open] = ACTIONS(3407),
    [anon_sym_LBRACK_LT] = ACTIONS(3403),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_type] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_and] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_let_BANG] = ACTIONS(3403),
    [aux_sym_access_modifier_token1] = ACTIONS(3403),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_null] = ACTIONS(3407),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3407),
    [anon_sym_LT_AT] = ACTIONS(3407),
    [anon_sym_LT_AT_AT] = ACTIONS(3403),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_with] = ACTIONS(3407),
    [anon_sym_return_BANG] = ACTIONS(3403),
    [anon_sym_yield] = ACTIONS(3407),
    [anon_sym_yield_BANG] = ACTIONS(3403),
    [anon_sym_lazy] = ACTIONS(3407),
    [anon_sym_assert] = ACTIONS(3407),
    [anon_sym_upcast] = ACTIONS(3407),
    [anon_sym_downcast] = ACTIONS(3407),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_fun] = ACTIONS(3407),
    [anon_sym_DASH_GT] = ACTIONS(5385),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_match] = ACTIONS(3407),
    [anon_sym_match_BANG] = ACTIONS(3403),
    [anon_sym_function] = ACTIONS(3407),
    [anon_sym_use] = ACTIONS(3407),
    [anon_sym_use_BANG] = ACTIONS(3403),
    [anon_sym_do_BANG] = ACTIONS(3403),
    [anon_sym_begin] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(5387),
    [anon_sym_LT2] = ACTIONS(5389),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5391),
    [anon_sym_default] = ACTIONS(3407),
    [anon_sym_static] = ACTIONS(3407),
    [anon_sym_member] = ACTIONS(3407),
    [anon_sym_interface] = ACTIONS(3407),
    [anon_sym_exception] = ACTIONS(3407),
    [anon_sym_abstract] = ACTIONS(3407),
    [anon_sym_val] = ACTIONS(3407),
    [anon_sym_override] = ACTIONS(3407),
    [aux_sym_char_token1] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3407),
    [anon_sym_DQUOTE] = ACTIONS(3407),
    [anon_sym_AT_DQUOTE] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [sym_bool] = ACTIONS(3407),
    [sym_unit] = ACTIONS(3403),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3407),
    [sym_op_identifier] = ACTIONS(3403),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_PLUS_DOT] = ACTIONS(3403),
    [anon_sym_DASH_DOT] = ACTIONS(3403),
    [anon_sym_PERCENT] = ACTIONS(3403),
    [anon_sym_AMP_AMP] = ACTIONS(3403),
    [anon_sym_TILDE] = ACTIONS(3403),
    [aux_sym_prefix_op_token1] = ACTIONS(3403),
    [sym_int] = ACTIONS(3407),
    [sym_xint] = ACTIONS(3403),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3403),
    [anon_sym_POUNDload] = ACTIONS(3403),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3403),
  },
  [2975] = {
    [sym_block_comment] = STATE(2975),
    [sym_compiler_directive_decl] = STATE(2975),
    [sym_fsi_directive_decl] = STATE(2975),
    [sym_preproc_line] = STATE(2975),
    [sym_identifier] = ACTIONS(3984),
    [anon_sym_EQ] = ACTIONS(3982),
    [anon_sym_COLON] = ACTIONS(3984),
    [anon_sym_return] = ACTIONS(3984),
    [anon_sym_do] = ACTIONS(3984),
    [anon_sym_let] = ACTIONS(3984),
    [anon_sym_let_BANG] = ACTIONS(3982),
    [anon_sym_as] = ACTIONS(3984),
    [anon_sym_LPAREN] = ACTIONS(3984),
    [anon_sym_COMMA] = ACTIONS(3982),
    [anon_sym_null] = ACTIONS(3984),
    [anon_sym_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AMP] = ACTIONS(3984),
    [anon_sym_LBRACK] = ACTIONS(3984),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(3984),
    [anon_sym_LT_AT] = ACTIONS(3984),
    [anon_sym_LT_AT_AT] = ACTIONS(3984),
    [anon_sym_DOT] = ACTIONS(3984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3982),
    [anon_sym_new] = ACTIONS(3984),
    [anon_sym_with] = ACTIONS(3984),
    [anon_sym_return_BANG] = ACTIONS(3982),
    [anon_sym_yield] = ACTIONS(3984),
    [anon_sym_yield_BANG] = ACTIONS(3982),
    [anon_sym_lazy] = ACTIONS(3984),
    [anon_sym_assert] = ACTIONS(3984),
    [anon_sym_upcast] = ACTIONS(3984),
    [anon_sym_downcast] = ACTIONS(3984),
    [anon_sym_COLON_GT] = ACTIONS(3982),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3982),
    [anon_sym_for] = ACTIONS(3984),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_if] = ACTIONS(3984),
    [anon_sym_fun] = ACTIONS(3984),
    [anon_sym_try] = ACTIONS(3984),
    [anon_sym_match] = ACTIONS(3984),
    [anon_sym_match_BANG] = ACTIONS(3982),
    [anon_sym_function] = ACTIONS(3984),
    [anon_sym_LT_DASH] = ACTIONS(3984),
    [anon_sym_DOT_LBRACK] = ACTIONS(3982),
    [anon_sym_LT] = ACTIONS(3982),
    [anon_sym_use] = ACTIONS(3984),
    [anon_sym_use_BANG] = ACTIONS(3982),
    [anon_sym_do_BANG] = ACTIONS(3982),
    [anon_sym_begin] = ACTIONS(3984),
    [anon_sym_LPAREN2] = ACTIONS(3984),
    [anon_sym_or] = ACTIONS(3984),
    [aux_sym_char_token1] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3984),
    [anon_sym_DQUOTE] = ACTIONS(3984),
    [anon_sym_AT_DQUOTE] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [sym_bool] = ACTIONS(3984),
    [sym_unit] = ACTIONS(3982),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3984),
    [sym_op_identifier] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3984),
    [anon_sym_DASH] = ACTIONS(3984),
    [anon_sym_PLUS_DOT] = ACTIONS(3984),
    [anon_sym_DASH_DOT] = ACTIONS(3984),
    [anon_sym_PERCENT] = ACTIONS(3984),
    [anon_sym_AMP_AMP] = ACTIONS(3984),
    [anon_sym_TILDE] = ACTIONS(3982),
    [aux_sym_prefix_op_token1] = ACTIONS(3984),
    [aux_sym_infix_op_token1] = ACTIONS(3982),
    [aux_sym_infix_op_token2] = ACTIONS(3984),
    [anon_sym_PIPE_PIPE] = ACTIONS(3984),
    [anon_sym_BANG_EQ] = ACTIONS(3984),
    [anon_sym_COLON_EQ] = ACTIONS(3982),
    [anon_sym_DOLLAR] = ACTIONS(3984),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3984),
    [sym_int] = ACTIONS(3984),
    [sym_xint] = ACTIONS(3982),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3982),
    [sym__newline] = ACTIONS(3982),
  },
  [2976] = {
    [sym_block_comment] = STATE(2976),
    [sym_compiler_directive_decl] = STATE(2976),
    [sym_fsi_directive_decl] = STATE(2976),
    [sym_preproc_line] = STATE(2976),
    [sym_identifier] = ACTIONS(3966),
    [anon_sym_EQ] = ACTIONS(3964),
    [anon_sym_COLON] = ACTIONS(3966),
    [anon_sym_return] = ACTIONS(3966),
    [anon_sym_do] = ACTIONS(3966),
    [anon_sym_let] = ACTIONS(3966),
    [anon_sym_let_BANG] = ACTIONS(3964),
    [anon_sym_as] = ACTIONS(3966),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COMMA] = ACTIONS(3964),
    [anon_sym_null] = ACTIONS(3966),
    [anon_sym_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(3964),
    [anon_sym_AMP] = ACTIONS(3966),
    [anon_sym_LBRACK] = ACTIONS(3966),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3964),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_LT_AT] = ACTIONS(3966),
    [anon_sym_LT_AT_AT] = ACTIONS(3966),
    [anon_sym_DOT] = ACTIONS(3966),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3964),
    [anon_sym_new] = ACTIONS(3966),
    [anon_sym_with] = ACTIONS(3966),
    [anon_sym_return_BANG] = ACTIONS(3964),
    [anon_sym_yield] = ACTIONS(3966),
    [anon_sym_yield_BANG] = ACTIONS(3964),
    [anon_sym_lazy] = ACTIONS(3966),
    [anon_sym_assert] = ACTIONS(3966),
    [anon_sym_upcast] = ACTIONS(3966),
    [anon_sym_downcast] = ACTIONS(3966),
    [anon_sym_COLON_GT] = ACTIONS(3964),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3964),
    [anon_sym_for] = ACTIONS(3966),
    [anon_sym_while] = ACTIONS(3966),
    [anon_sym_if] = ACTIONS(3966),
    [anon_sym_fun] = ACTIONS(3966),
    [anon_sym_try] = ACTIONS(3966),
    [anon_sym_match] = ACTIONS(3966),
    [anon_sym_match_BANG] = ACTIONS(3964),
    [anon_sym_function] = ACTIONS(3966),
    [anon_sym_LT_DASH] = ACTIONS(3966),
    [anon_sym_DOT_LBRACK] = ACTIONS(3964),
    [anon_sym_LT] = ACTIONS(3964),
    [anon_sym_use] = ACTIONS(3966),
    [anon_sym_use_BANG] = ACTIONS(3964),
    [anon_sym_do_BANG] = ACTIONS(3964),
    [anon_sym_begin] = ACTIONS(3966),
    [anon_sym_LPAREN2] = ACTIONS(3966),
    [anon_sym_or] = ACTIONS(3966),
    [aux_sym_char_token1] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3966),
    [anon_sym_DQUOTE] = ACTIONS(3966),
    [anon_sym_AT_DQUOTE] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [sym_bool] = ACTIONS(3966),
    [sym_unit] = ACTIONS(3964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3966),
    [sym_op_identifier] = ACTIONS(3966),
    [anon_sym_PLUS] = ACTIONS(3966),
    [anon_sym_DASH] = ACTIONS(3966),
    [anon_sym_PLUS_DOT] = ACTIONS(3966),
    [anon_sym_DASH_DOT] = ACTIONS(3966),
    [anon_sym_PERCENT] = ACTIONS(3966),
    [anon_sym_AMP_AMP] = ACTIONS(3966),
    [anon_sym_TILDE] = ACTIONS(3964),
    [aux_sym_prefix_op_token1] = ACTIONS(3966),
    [aux_sym_infix_op_token1] = ACTIONS(3964),
    [aux_sym_infix_op_token2] = ACTIONS(3966),
    [anon_sym_PIPE_PIPE] = ACTIONS(3966),
    [anon_sym_BANG_EQ] = ACTIONS(3966),
    [anon_sym_COLON_EQ] = ACTIONS(3964),
    [anon_sym_DOLLAR] = ACTIONS(3966),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3966),
    [sym_int] = ACTIONS(3966),
    [sym_xint] = ACTIONS(3964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3964),
    [sym__newline] = ACTIONS(3964),
  },
  [2977] = {
    [sym_block_comment] = STATE(2977),
    [sym_compiler_directive_decl] = STATE(2977),
    [sym_fsi_directive_decl] = STATE(2977),
    [sym_preproc_line] = STATE(2977),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4228),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_with] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [anon_sym_EQ2] = ACTIONS(5343),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
  },
  [2978] = {
    [sym_block_comment] = STATE(2978),
    [sym_compiler_directive_decl] = STATE(2978),
    [sym_fsi_directive_decl] = STATE(2978),
    [sym_preproc_line] = STATE(2978),
    [sym_identifier] = ACTIONS(3988),
    [anon_sym_EQ] = ACTIONS(3986),
    [anon_sym_COLON] = ACTIONS(3988),
    [anon_sym_return] = ACTIONS(3988),
    [anon_sym_do] = ACTIONS(3988),
    [anon_sym_let] = ACTIONS(3988),
    [anon_sym_let_BANG] = ACTIONS(3986),
    [anon_sym_as] = ACTIONS(3988),
    [anon_sym_LPAREN] = ACTIONS(3988),
    [anon_sym_COMMA] = ACTIONS(3986),
    [anon_sym_null] = ACTIONS(3988),
    [anon_sym_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_COLON] = ACTIONS(3986),
    [anon_sym_AMP] = ACTIONS(3988),
    [anon_sym_LBRACK] = ACTIONS(3988),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3986),
    [anon_sym_LBRACE] = ACTIONS(3988),
    [anon_sym_LT_AT] = ACTIONS(3988),
    [anon_sym_LT_AT_AT] = ACTIONS(3988),
    [anon_sym_DOT] = ACTIONS(3988),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3986),
    [anon_sym_new] = ACTIONS(3988),
    [anon_sym_with] = ACTIONS(3988),
    [anon_sym_return_BANG] = ACTIONS(3986),
    [anon_sym_yield] = ACTIONS(3988),
    [anon_sym_yield_BANG] = ACTIONS(3986),
    [anon_sym_lazy] = ACTIONS(3988),
    [anon_sym_assert] = ACTIONS(3988),
    [anon_sym_upcast] = ACTIONS(3988),
    [anon_sym_downcast] = ACTIONS(3988),
    [anon_sym_COLON_GT] = ACTIONS(3986),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_while] = ACTIONS(3988),
    [anon_sym_if] = ACTIONS(3988),
    [anon_sym_fun] = ACTIONS(3988),
    [anon_sym_try] = ACTIONS(3988),
    [anon_sym_match] = ACTIONS(3988),
    [anon_sym_match_BANG] = ACTIONS(3986),
    [anon_sym_function] = ACTIONS(3988),
    [anon_sym_LT_DASH] = ACTIONS(3988),
    [anon_sym_DOT_LBRACK] = ACTIONS(3986),
    [anon_sym_LT] = ACTIONS(3986),
    [anon_sym_use] = ACTIONS(3988),
    [anon_sym_use_BANG] = ACTIONS(3986),
    [anon_sym_do_BANG] = ACTIONS(3986),
    [anon_sym_begin] = ACTIONS(3988),
    [anon_sym_LPAREN2] = ACTIONS(3988),
    [anon_sym_or] = ACTIONS(3988),
    [aux_sym_char_token1] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3988),
    [anon_sym_DQUOTE] = ACTIONS(3988),
    [anon_sym_AT_DQUOTE] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [sym_bool] = ACTIONS(3988),
    [sym_unit] = ACTIONS(3986),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3988),
    [sym_op_identifier] = ACTIONS(3988),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_PLUS_DOT] = ACTIONS(3988),
    [anon_sym_DASH_DOT] = ACTIONS(3988),
    [anon_sym_PERCENT] = ACTIONS(3988),
    [anon_sym_AMP_AMP] = ACTIONS(3988),
    [anon_sym_TILDE] = ACTIONS(3986),
    [aux_sym_prefix_op_token1] = ACTIONS(3988),
    [aux_sym_infix_op_token1] = ACTIONS(3986),
    [aux_sym_infix_op_token2] = ACTIONS(3988),
    [anon_sym_PIPE_PIPE] = ACTIONS(3988),
    [anon_sym_BANG_EQ] = ACTIONS(3988),
    [anon_sym_COLON_EQ] = ACTIONS(3986),
    [anon_sym_DOLLAR] = ACTIONS(3988),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3988),
    [sym_int] = ACTIONS(3988),
    [sym_xint] = ACTIONS(3986),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3986),
    [sym__newline] = ACTIONS(3986),
  },
  [2979] = {
    [sym_block_comment] = STATE(2979),
    [sym_compiler_directive_decl] = STATE(2979),
    [sym_fsi_directive_decl] = STATE(2979),
    [sym_preproc_line] = STATE(2979),
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_EQ] = ACTIONS(3990),
    [anon_sym_COLON] = ACTIONS(3992),
    [anon_sym_return] = ACTIONS(3992),
    [anon_sym_do] = ACTIONS(3992),
    [anon_sym_let] = ACTIONS(3992),
    [anon_sym_let_BANG] = ACTIONS(3990),
    [anon_sym_as] = ACTIONS(3992),
    [anon_sym_LPAREN] = ACTIONS(3992),
    [anon_sym_COMMA] = ACTIONS(3990),
    [anon_sym_null] = ACTIONS(3992),
    [anon_sym_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [anon_sym_AMP] = ACTIONS(3992),
    [anon_sym_LBRACK] = ACTIONS(3992),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3990),
    [anon_sym_LBRACE] = ACTIONS(3992),
    [anon_sym_LT_AT] = ACTIONS(3992),
    [anon_sym_LT_AT_AT] = ACTIONS(3992),
    [anon_sym_DOT] = ACTIONS(3992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3990),
    [anon_sym_new] = ACTIONS(3992),
    [anon_sym_with] = ACTIONS(3992),
    [anon_sym_return_BANG] = ACTIONS(3990),
    [anon_sym_yield] = ACTIONS(3992),
    [anon_sym_yield_BANG] = ACTIONS(3990),
    [anon_sym_lazy] = ACTIONS(3992),
    [anon_sym_assert] = ACTIONS(3992),
    [anon_sym_upcast] = ACTIONS(3992),
    [anon_sym_downcast] = ACTIONS(3992),
    [anon_sym_COLON_GT] = ACTIONS(3990),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3990),
    [anon_sym_for] = ACTIONS(3992),
    [anon_sym_while] = ACTIONS(3992),
    [anon_sym_if] = ACTIONS(3992),
    [anon_sym_fun] = ACTIONS(3992),
    [anon_sym_try] = ACTIONS(3992),
    [anon_sym_match] = ACTIONS(3992),
    [anon_sym_match_BANG] = ACTIONS(3990),
    [anon_sym_function] = ACTIONS(3992),
    [anon_sym_LT_DASH] = ACTIONS(3992),
    [anon_sym_DOT_LBRACK] = ACTIONS(3990),
    [anon_sym_LT] = ACTIONS(3990),
    [anon_sym_use] = ACTIONS(3992),
    [anon_sym_use_BANG] = ACTIONS(3990),
    [anon_sym_do_BANG] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_LPAREN2] = ACTIONS(3992),
    [anon_sym_or] = ACTIONS(3992),
    [aux_sym_char_token1] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3992),
    [anon_sym_DQUOTE] = ACTIONS(3992),
    [anon_sym_AT_DQUOTE] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [sym_bool] = ACTIONS(3992),
    [sym_unit] = ACTIONS(3990),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3992),
    [sym_op_identifier] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3992),
    [anon_sym_DASH] = ACTIONS(3992),
    [anon_sym_PLUS_DOT] = ACTIONS(3992),
    [anon_sym_DASH_DOT] = ACTIONS(3992),
    [anon_sym_PERCENT] = ACTIONS(3992),
    [anon_sym_AMP_AMP] = ACTIONS(3992),
    [anon_sym_TILDE] = ACTIONS(3990),
    [aux_sym_prefix_op_token1] = ACTIONS(3992),
    [aux_sym_infix_op_token1] = ACTIONS(3990),
    [aux_sym_infix_op_token2] = ACTIONS(3992),
    [anon_sym_PIPE_PIPE] = ACTIONS(3992),
    [anon_sym_BANG_EQ] = ACTIONS(3992),
    [anon_sym_COLON_EQ] = ACTIONS(3990),
    [anon_sym_DOLLAR] = ACTIONS(3992),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3992),
    [sym_int] = ACTIONS(3992),
    [sym_xint] = ACTIONS(3990),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3990),
    [sym__newline] = ACTIONS(3990),
  },
  [2980] = {
    [sym_block_comment] = STATE(2980),
    [sym_compiler_directive_decl] = STATE(2980),
    [sym_fsi_directive_decl] = STATE(2980),
    [sym_preproc_line] = STATE(2980),
    [sym_identifier] = ACTIONS(4193),
    [anon_sym_EQ] = ACTIONS(4191),
    [anon_sym_COLON] = ACTIONS(4193),
    [anon_sym_return] = ACTIONS(4193),
    [anon_sym_do] = ACTIONS(4193),
    [anon_sym_let] = ACTIONS(4193),
    [anon_sym_let_BANG] = ACTIONS(4191),
    [anon_sym_as] = ACTIONS(4193),
    [anon_sym_LPAREN] = ACTIONS(4193),
    [anon_sym_COMMA] = ACTIONS(4191),
    [anon_sym_null] = ACTIONS(4193),
    [anon_sym_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_COLON] = ACTIONS(4191),
    [anon_sym_AMP] = ACTIONS(4193),
    [anon_sym_LBRACK] = ACTIONS(4193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4191),
    [anon_sym_LBRACE] = ACTIONS(4193),
    [anon_sym_LT_AT] = ACTIONS(4193),
    [anon_sym_LT_AT_AT] = ACTIONS(4193),
    [anon_sym_DOT] = ACTIONS(4193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4191),
    [anon_sym_new] = ACTIONS(4193),
    [anon_sym_with] = ACTIONS(4193),
    [anon_sym_return_BANG] = ACTIONS(4191),
    [anon_sym_yield] = ACTIONS(4193),
    [anon_sym_yield_BANG] = ACTIONS(4191),
    [anon_sym_lazy] = ACTIONS(4193),
    [anon_sym_assert] = ACTIONS(4193),
    [anon_sym_upcast] = ACTIONS(4193),
    [anon_sym_downcast] = ACTIONS(4193),
    [anon_sym_COLON_GT] = ACTIONS(4191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4191),
    [anon_sym_for] = ACTIONS(4193),
    [anon_sym_while] = ACTIONS(4193),
    [anon_sym_if] = ACTIONS(4193),
    [anon_sym_fun] = ACTIONS(4193),
    [anon_sym_try] = ACTIONS(4193),
    [anon_sym_match] = ACTIONS(4193),
    [anon_sym_match_BANG] = ACTIONS(4191),
    [anon_sym_function] = ACTIONS(4193),
    [anon_sym_LT_DASH] = ACTIONS(4193),
    [anon_sym_DOT_LBRACK] = ACTIONS(4191),
    [anon_sym_LT] = ACTIONS(4191),
    [anon_sym_use] = ACTIONS(4193),
    [anon_sym_use_BANG] = ACTIONS(4191),
    [anon_sym_do_BANG] = ACTIONS(4191),
    [anon_sym_begin] = ACTIONS(4193),
    [anon_sym_LPAREN2] = ACTIONS(4193),
    [anon_sym_or] = ACTIONS(4193),
    [aux_sym_char_token1] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4193),
    [anon_sym_DQUOTE] = ACTIONS(4193),
    [anon_sym_AT_DQUOTE] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [sym_bool] = ACTIONS(4193),
    [sym_unit] = ACTIONS(4191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4193),
    [sym_op_identifier] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4193),
    [anon_sym_DASH] = ACTIONS(4193),
    [anon_sym_PLUS_DOT] = ACTIONS(4193),
    [anon_sym_DASH_DOT] = ACTIONS(4193),
    [anon_sym_PERCENT] = ACTIONS(4193),
    [anon_sym_AMP_AMP] = ACTIONS(4193),
    [anon_sym_TILDE] = ACTIONS(4191),
    [aux_sym_prefix_op_token1] = ACTIONS(4193),
    [aux_sym_infix_op_token1] = ACTIONS(4191),
    [aux_sym_infix_op_token2] = ACTIONS(4193),
    [anon_sym_PIPE_PIPE] = ACTIONS(4193),
    [anon_sym_BANG_EQ] = ACTIONS(4193),
    [anon_sym_COLON_EQ] = ACTIONS(4191),
    [anon_sym_DOLLAR] = ACTIONS(4193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4193),
    [sym_int] = ACTIONS(4193),
    [sym_xint] = ACTIONS(4191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4191),
    [sym__newline] = ACTIONS(4191),
  },
  [2981] = {
    [sym_block_comment] = STATE(2981),
    [sym_compiler_directive_decl] = STATE(2981),
    [sym_fsi_directive_decl] = STATE(2981),
    [sym_preproc_line] = STATE(2981),
    [sym_identifier] = ACTIONS(4197),
    [anon_sym_EQ] = ACTIONS(4195),
    [anon_sym_COLON] = ACTIONS(4197),
    [anon_sym_return] = ACTIONS(4197),
    [anon_sym_do] = ACTIONS(4197),
    [anon_sym_let] = ACTIONS(4197),
    [anon_sym_let_BANG] = ACTIONS(4195),
    [anon_sym_as] = ACTIONS(4197),
    [anon_sym_LPAREN] = ACTIONS(4197),
    [anon_sym_COMMA] = ACTIONS(4195),
    [anon_sym_null] = ACTIONS(4197),
    [anon_sym_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_COLON] = ACTIONS(4195),
    [anon_sym_AMP] = ACTIONS(4197),
    [anon_sym_LBRACK] = ACTIONS(4197),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4195),
    [anon_sym_LBRACE] = ACTIONS(4197),
    [anon_sym_LT_AT] = ACTIONS(4197),
    [anon_sym_LT_AT_AT] = ACTIONS(4197),
    [anon_sym_DOT] = ACTIONS(4197),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4195),
    [anon_sym_new] = ACTIONS(4197),
    [anon_sym_with] = ACTIONS(4197),
    [anon_sym_return_BANG] = ACTIONS(4195),
    [anon_sym_yield] = ACTIONS(4197),
    [anon_sym_yield_BANG] = ACTIONS(4195),
    [anon_sym_lazy] = ACTIONS(4197),
    [anon_sym_assert] = ACTIONS(4197),
    [anon_sym_upcast] = ACTIONS(4197),
    [anon_sym_downcast] = ACTIONS(4197),
    [anon_sym_COLON_GT] = ACTIONS(4195),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4195),
    [anon_sym_for] = ACTIONS(4197),
    [anon_sym_while] = ACTIONS(4197),
    [anon_sym_if] = ACTIONS(4197),
    [anon_sym_fun] = ACTIONS(4197),
    [anon_sym_try] = ACTIONS(4197),
    [anon_sym_match] = ACTIONS(4197),
    [anon_sym_match_BANG] = ACTIONS(4195),
    [anon_sym_function] = ACTIONS(4197),
    [anon_sym_LT_DASH] = ACTIONS(4197),
    [anon_sym_DOT_LBRACK] = ACTIONS(4195),
    [anon_sym_LT] = ACTIONS(4195),
    [anon_sym_use] = ACTIONS(4197),
    [anon_sym_use_BANG] = ACTIONS(4195),
    [anon_sym_do_BANG] = ACTIONS(4195),
    [anon_sym_begin] = ACTIONS(4197),
    [anon_sym_LPAREN2] = ACTIONS(4197),
    [anon_sym_or] = ACTIONS(4197),
    [aux_sym_char_token1] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4197),
    [anon_sym_DQUOTE] = ACTIONS(4197),
    [anon_sym_AT_DQUOTE] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [sym_bool] = ACTIONS(4197),
    [sym_unit] = ACTIONS(4195),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4197),
    [sym_op_identifier] = ACTIONS(4197),
    [anon_sym_PLUS] = ACTIONS(4197),
    [anon_sym_DASH] = ACTIONS(4197),
    [anon_sym_PLUS_DOT] = ACTIONS(4197),
    [anon_sym_DASH_DOT] = ACTIONS(4197),
    [anon_sym_PERCENT] = ACTIONS(4197),
    [anon_sym_AMP_AMP] = ACTIONS(4197),
    [anon_sym_TILDE] = ACTIONS(4195),
    [aux_sym_prefix_op_token1] = ACTIONS(4197),
    [aux_sym_infix_op_token1] = ACTIONS(4195),
    [aux_sym_infix_op_token2] = ACTIONS(4197),
    [anon_sym_PIPE_PIPE] = ACTIONS(4197),
    [anon_sym_BANG_EQ] = ACTIONS(4197),
    [anon_sym_COLON_EQ] = ACTIONS(4195),
    [anon_sym_DOLLAR] = ACTIONS(4197),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4197),
    [sym_int] = ACTIONS(4197),
    [sym_xint] = ACTIONS(4195),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4195),
    [sym__newline] = ACTIONS(4195),
  },
  [2982] = {
    [sym_block_comment] = STATE(2982),
    [sym_compiler_directive_decl] = STATE(2982),
    [sym_fsi_directive_decl] = STATE(2982),
    [sym_preproc_line] = STATE(2982),
    [sym_identifier] = ACTIONS(3980),
    [anon_sym_EQ] = ACTIONS(3978),
    [anon_sym_COLON] = ACTIONS(3980),
    [anon_sym_return] = ACTIONS(3980),
    [anon_sym_do] = ACTIONS(3980),
    [anon_sym_let] = ACTIONS(3980),
    [anon_sym_let_BANG] = ACTIONS(3978),
    [anon_sym_as] = ACTIONS(3980),
    [anon_sym_LPAREN] = ACTIONS(3980),
    [anon_sym_COMMA] = ACTIONS(3978),
    [anon_sym_null] = ACTIONS(3980),
    [anon_sym_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3978),
    [anon_sym_AMP] = ACTIONS(3980),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3978),
    [anon_sym_LBRACE] = ACTIONS(3980),
    [anon_sym_LT_AT] = ACTIONS(3980),
    [anon_sym_LT_AT_AT] = ACTIONS(3980),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3978),
    [anon_sym_new] = ACTIONS(3980),
    [anon_sym_with] = ACTIONS(3980),
    [anon_sym_return_BANG] = ACTIONS(3978),
    [anon_sym_yield] = ACTIONS(3980),
    [anon_sym_yield_BANG] = ACTIONS(3978),
    [anon_sym_lazy] = ACTIONS(3980),
    [anon_sym_assert] = ACTIONS(3980),
    [anon_sym_upcast] = ACTIONS(3980),
    [anon_sym_downcast] = ACTIONS(3980),
    [anon_sym_COLON_GT] = ACTIONS(3978),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3978),
    [anon_sym_for] = ACTIONS(3980),
    [anon_sym_while] = ACTIONS(3980),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_fun] = ACTIONS(3980),
    [anon_sym_try] = ACTIONS(3980),
    [anon_sym_match] = ACTIONS(3980),
    [anon_sym_match_BANG] = ACTIONS(3978),
    [anon_sym_function] = ACTIONS(3980),
    [anon_sym_LT_DASH] = ACTIONS(3980),
    [anon_sym_DOT_LBRACK] = ACTIONS(3978),
    [anon_sym_LT] = ACTIONS(3978),
    [anon_sym_use] = ACTIONS(3980),
    [anon_sym_use_BANG] = ACTIONS(3978),
    [anon_sym_do_BANG] = ACTIONS(3978),
    [anon_sym_begin] = ACTIONS(3980),
    [anon_sym_LPAREN2] = ACTIONS(3980),
    [anon_sym_or] = ACTIONS(3980),
    [aux_sym_char_token1] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3980),
    [anon_sym_DQUOTE] = ACTIONS(3980),
    [anon_sym_AT_DQUOTE] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [sym_bool] = ACTIONS(3980),
    [sym_unit] = ACTIONS(3978),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3980),
    [sym_op_identifier] = ACTIONS(3980),
    [anon_sym_PLUS] = ACTIONS(3980),
    [anon_sym_DASH] = ACTIONS(3980),
    [anon_sym_PLUS_DOT] = ACTIONS(3980),
    [anon_sym_DASH_DOT] = ACTIONS(3980),
    [anon_sym_PERCENT] = ACTIONS(3980),
    [anon_sym_AMP_AMP] = ACTIONS(3980),
    [anon_sym_TILDE] = ACTIONS(3978),
    [aux_sym_prefix_op_token1] = ACTIONS(3980),
    [aux_sym_infix_op_token1] = ACTIONS(3978),
    [aux_sym_infix_op_token2] = ACTIONS(3980),
    [anon_sym_PIPE_PIPE] = ACTIONS(3980),
    [anon_sym_BANG_EQ] = ACTIONS(3980),
    [anon_sym_COLON_EQ] = ACTIONS(3978),
    [anon_sym_DOLLAR] = ACTIONS(3980),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3980),
    [sym_int] = ACTIONS(3980),
    [sym_xint] = ACTIONS(3978),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3978),
    [sym__newline] = ACTIONS(3978),
  },
  [2983] = {
    [sym_block_comment] = STATE(2983),
    [sym_compiler_directive_decl] = STATE(2983),
    [sym_fsi_directive_decl] = STATE(2983),
    [sym_preproc_line] = STATE(2983),
    [sym_identifier] = ACTIONS(3976),
    [anon_sym_EQ] = ACTIONS(3974),
    [anon_sym_COLON] = ACTIONS(3976),
    [anon_sym_return] = ACTIONS(3976),
    [anon_sym_do] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_let_BANG] = ACTIONS(3974),
    [anon_sym_LPAREN] = ACTIONS(3976),
    [anon_sym_COMMA] = ACTIONS(3974),
    [anon_sym_null] = ACTIONS(3976),
    [anon_sym_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_COLON] = ACTIONS(3974),
    [anon_sym_AMP] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(3976),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3974),
    [anon_sym_LBRACE] = ACTIONS(3976),
    [anon_sym_LT_AT] = ACTIONS(3976),
    [anon_sym_LT_AT_AT] = ACTIONS(3976),
    [anon_sym_DOT] = ACTIONS(3976),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3974),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_return_BANG] = ACTIONS(3974),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_yield_BANG] = ACTIONS(3974),
    [anon_sym_lazy] = ACTIONS(3976),
    [anon_sym_assert] = ACTIONS(3976),
    [anon_sym_upcast] = ACTIONS(3976),
    [anon_sym_downcast] = ACTIONS(3976),
    [anon_sym_COLON_GT] = ACTIONS(3974),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3974),
    [anon_sym_for] = ACTIONS(3976),
    [anon_sym_while] = ACTIONS(3976),
    [anon_sym_if] = ACTIONS(3976),
    [anon_sym_fun] = ACTIONS(3976),
    [anon_sym_DASH_GT] = ACTIONS(3976),
    [anon_sym_try] = ACTIONS(3976),
    [anon_sym_match] = ACTIONS(3976),
    [anon_sym_match_BANG] = ACTIONS(3974),
    [anon_sym_function] = ACTIONS(3976),
    [anon_sym_LT_DASH] = ACTIONS(3976),
    [anon_sym_DOT_LBRACK] = ACTIONS(3974),
    [anon_sym_LT] = ACTIONS(3974),
    [anon_sym_use] = ACTIONS(3976),
    [anon_sym_use_BANG] = ACTIONS(3974),
    [anon_sym_do_BANG] = ACTIONS(3974),
    [anon_sym_DOT_DOT] = ACTIONS(3974),
    [anon_sym_begin] = ACTIONS(3976),
    [anon_sym_LPAREN2] = ACTIONS(3976),
    [anon_sym_or] = ACTIONS(3976),
    [aux_sym_char_token1] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3976),
    [anon_sym_DQUOTE] = ACTIONS(3976),
    [anon_sym_AT_DQUOTE] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [sym_bool] = ACTIONS(3976),
    [sym_unit] = ACTIONS(3974),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3976),
    [sym_op_identifier] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3976),
    [anon_sym_DASH] = ACTIONS(3976),
    [anon_sym_PLUS_DOT] = ACTIONS(3976),
    [anon_sym_DASH_DOT] = ACTIONS(3976),
    [anon_sym_PERCENT] = ACTIONS(3976),
    [anon_sym_AMP_AMP] = ACTIONS(3976),
    [anon_sym_TILDE] = ACTIONS(3974),
    [aux_sym_prefix_op_token1] = ACTIONS(3976),
    [aux_sym_infix_op_token1] = ACTIONS(3974),
    [aux_sym_infix_op_token2] = ACTIONS(3976),
    [anon_sym_PIPE_PIPE] = ACTIONS(3976),
    [anon_sym_BANG_EQ] = ACTIONS(3976),
    [anon_sym_COLON_EQ] = ACTIONS(3974),
    [anon_sym_DOLLAR] = ACTIONS(3976),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3976),
    [sym_int] = ACTIONS(3976),
    [sym_xint] = ACTIONS(3974),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3974),
    [sym__newline] = ACTIONS(3974),
  },
  [2984] = {
    [sym_block_comment] = STATE(2984),
    [sym_compiler_directive_decl] = STATE(2984),
    [sym_fsi_directive_decl] = STATE(2984),
    [sym_preproc_line] = STATE(2984),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_EQ] = ACTIONS(4199),
    [anon_sym_COLON] = ACTIONS(4201),
    [anon_sym_return] = ACTIONS(4201),
    [anon_sym_do] = ACTIONS(4201),
    [anon_sym_let] = ACTIONS(4201),
    [anon_sym_let_BANG] = ACTIONS(4199),
    [anon_sym_as] = ACTIONS(4201),
    [anon_sym_LPAREN] = ACTIONS(4201),
    [anon_sym_COMMA] = ACTIONS(4199),
    [anon_sym_null] = ACTIONS(4201),
    [anon_sym_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(4199),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_LBRACK] = ACTIONS(4201),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4199),
    [anon_sym_LBRACE] = ACTIONS(4201),
    [anon_sym_LT_AT] = ACTIONS(4201),
    [anon_sym_LT_AT_AT] = ACTIONS(4201),
    [anon_sym_DOT] = ACTIONS(4201),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4199),
    [anon_sym_new] = ACTIONS(4201),
    [anon_sym_with] = ACTIONS(4201),
    [anon_sym_return_BANG] = ACTIONS(4199),
    [anon_sym_yield] = ACTIONS(4201),
    [anon_sym_yield_BANG] = ACTIONS(4199),
    [anon_sym_lazy] = ACTIONS(4201),
    [anon_sym_assert] = ACTIONS(4201),
    [anon_sym_upcast] = ACTIONS(4201),
    [anon_sym_downcast] = ACTIONS(4201),
    [anon_sym_COLON_GT] = ACTIONS(4199),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4199),
    [anon_sym_for] = ACTIONS(4201),
    [anon_sym_while] = ACTIONS(4201),
    [anon_sym_if] = ACTIONS(4201),
    [anon_sym_fun] = ACTIONS(4201),
    [anon_sym_try] = ACTIONS(4201),
    [anon_sym_match] = ACTIONS(4201),
    [anon_sym_match_BANG] = ACTIONS(4199),
    [anon_sym_function] = ACTIONS(4201),
    [anon_sym_LT_DASH] = ACTIONS(4201),
    [anon_sym_DOT_LBRACK] = ACTIONS(4199),
    [anon_sym_LT] = ACTIONS(4199),
    [anon_sym_use] = ACTIONS(4201),
    [anon_sym_use_BANG] = ACTIONS(4199),
    [anon_sym_do_BANG] = ACTIONS(4199),
    [anon_sym_begin] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(4201),
    [anon_sym_or] = ACTIONS(4201),
    [aux_sym_char_token1] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4201),
    [anon_sym_DQUOTE] = ACTIONS(4201),
    [anon_sym_AT_DQUOTE] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [sym_bool] = ACTIONS(4201),
    [sym_unit] = ACTIONS(4199),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4201),
    [sym_op_identifier] = ACTIONS(4201),
    [anon_sym_PLUS] = ACTIONS(4201),
    [anon_sym_DASH] = ACTIONS(4201),
    [anon_sym_PLUS_DOT] = ACTIONS(4201),
    [anon_sym_DASH_DOT] = ACTIONS(4201),
    [anon_sym_PERCENT] = ACTIONS(4201),
    [anon_sym_AMP_AMP] = ACTIONS(4201),
    [anon_sym_TILDE] = ACTIONS(4199),
    [aux_sym_prefix_op_token1] = ACTIONS(4201),
    [aux_sym_infix_op_token1] = ACTIONS(4199),
    [aux_sym_infix_op_token2] = ACTIONS(4201),
    [anon_sym_PIPE_PIPE] = ACTIONS(4201),
    [anon_sym_BANG_EQ] = ACTIONS(4201),
    [anon_sym_COLON_EQ] = ACTIONS(4199),
    [anon_sym_DOLLAR] = ACTIONS(4201),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4201),
    [sym_int] = ACTIONS(4201),
    [sym_xint] = ACTIONS(4199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4199),
    [sym__newline] = ACTIONS(4199),
  },
  [2985] = {
    [sym_block_comment] = STATE(2985),
    [sym_compiler_directive_decl] = STATE(2985),
    [sym_fsi_directive_decl] = STATE(2985),
    [sym_preproc_line] = STATE(2985),
    [aux_sym_sequential_expression_repeat1] = STATE(2985),
    [sym_identifier] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3765),
    [anon_sym_COLON] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_let_BANG] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(3767),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_null] = ACTIONS(3767),
    [anon_sym_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3765),
    [anon_sym_LBRACE] = ACTIONS(3767),
    [anon_sym_LT_AT] = ACTIONS(3767),
    [anon_sym_LT_AT_AT] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3765),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_return_BANG] = ACTIONS(3765),
    [anon_sym_yield] = ACTIONS(3767),
    [anon_sym_yield_BANG] = ACTIONS(3765),
    [anon_sym_lazy] = ACTIONS(3767),
    [anon_sym_assert] = ACTIONS(3767),
    [anon_sym_upcast] = ACTIONS(3767),
    [anon_sym_downcast] = ACTIONS(3767),
    [anon_sym_COLON_GT] = ACTIONS(3765),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3765),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_fun] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_match] = ACTIONS(3767),
    [anon_sym_match_BANG] = ACTIONS(3765),
    [anon_sym_function] = ACTIONS(3767),
    [anon_sym_LT_DASH] = ACTIONS(3767),
    [anon_sym_DOT_LBRACK] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(3765),
    [anon_sym_GT] = ACTIONS(3767),
    [anon_sym_use] = ACTIONS(3767),
    [anon_sym_use_BANG] = ACTIONS(3765),
    [anon_sym_do_BANG] = ACTIONS(3765),
    [anon_sym_begin] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3767),
    [anon_sym_or] = ACTIONS(3767),
    [aux_sym_char_token1] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3767),
    [anon_sym_DQUOTE] = ACTIONS(3767),
    [anon_sym_AT_DQUOTE] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [sym_bool] = ACTIONS(3767),
    [sym_unit] = ACTIONS(3765),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3767),
    [sym_op_identifier] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_PLUS_DOT] = ACTIONS(3767),
    [anon_sym_DASH_DOT] = ACTIONS(3767),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_AMP_AMP] = ACTIONS(3767),
    [anon_sym_TILDE] = ACTIONS(3765),
    [aux_sym_prefix_op_token1] = ACTIONS(3767),
    [aux_sym_infix_op_token1] = ACTIONS(3765),
    [aux_sym_infix_op_token2] = ACTIONS(3767),
    [anon_sym_PIPE_PIPE] = ACTIONS(3767),
    [anon_sym_BANG_EQ] = ACTIONS(3767),
    [anon_sym_COLON_EQ] = ACTIONS(3765),
    [anon_sym_DOLLAR] = ACTIONS(3767),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3767),
    [sym_int] = ACTIONS(3767),
    [sym_xint] = ACTIONS(3765),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3765),
    [sym__newline] = ACTIONS(5598),
  },
  [2986] = {
    [sym_block_comment] = STATE(2986),
    [sym_compiler_directive_decl] = STATE(2986),
    [sym_fsi_directive_decl] = STATE(2986),
    [sym_preproc_line] = STATE(2986),
    [aux_sym_long_identifier_repeat1] = STATE(3436),
    [ts_builtin_sym_end] = ACTIONS(3492),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_namespace] = ACTIONS(3494),
    [anon_sym_module] = ACTIONS(3494),
    [anon_sym_open] = ACTIONS(3494),
    [anon_sym_LBRACK_LT] = ACTIONS(3492),
    [anon_sym_COLON] = ACTIONS(5601),
    [anon_sym_return] = ACTIONS(3494),
    [anon_sym_type] = ACTIONS(3494),
    [anon_sym_do] = ACTIONS(3494),
    [anon_sym_and] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_let_BANG] = ACTIONS(3492),
    [aux_sym_access_modifier_token1] = ACTIONS(3492),
    [anon_sym_LPAREN] = ACTIONS(3494),
    [anon_sym_null] = ACTIONS(3494),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3492),
    [anon_sym_LBRACE] = ACTIONS(3494),
    [anon_sym_LT_AT] = ACTIONS(3494),
    [anon_sym_LT_AT_AT] = ACTIONS(3492),
    [anon_sym_DOT] = ACTIONS(5603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3492),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_with] = ACTIONS(3494),
    [anon_sym_return_BANG] = ACTIONS(3492),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_yield_BANG] = ACTIONS(3492),
    [anon_sym_lazy] = ACTIONS(3494),
    [anon_sym_assert] = ACTIONS(3494),
    [anon_sym_upcast] = ACTIONS(3494),
    [anon_sym_downcast] = ACTIONS(3494),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_while] = ACTIONS(3494),
    [anon_sym_if] = ACTIONS(3494),
    [anon_sym_fun] = ACTIONS(3494),
    [anon_sym_DASH_GT] = ACTIONS(3492),
    [anon_sym_try] = ACTIONS(3494),
    [anon_sym_match] = ACTIONS(3494),
    [anon_sym_match_BANG] = ACTIONS(3492),
    [anon_sym_function] = ACTIONS(3494),
    [anon_sym_use] = ACTIONS(3494),
    [anon_sym_use_BANG] = ACTIONS(3492),
    [anon_sym_do_BANG] = ACTIONS(3492),
    [anon_sym_begin] = ACTIONS(3494),
    [anon_sym_STAR] = ACTIONS(3492),
    [anon_sym_LT2] = ACTIONS(3494),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3492),
    [anon_sym_default] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_member] = ACTIONS(3494),
    [anon_sym_interface] = ACTIONS(3494),
    [anon_sym_exception] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_val] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [aux_sym_char_token1] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3494),
    [anon_sym_DQUOTE] = ACTIONS(3494),
    [anon_sym_AT_DQUOTE] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [sym_bool] = ACTIONS(3494),
    [sym_unit] = ACTIONS(3492),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3494),
    [sym_op_identifier] = ACTIONS(3492),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_PLUS_DOT] = ACTIONS(3492),
    [anon_sym_DASH_DOT] = ACTIONS(3492),
    [anon_sym_PERCENT] = ACTIONS(3492),
    [anon_sym_AMP_AMP] = ACTIONS(3492),
    [anon_sym_TILDE] = ACTIONS(3492),
    [aux_sym_prefix_op_token1] = ACTIONS(3492),
    [sym_int] = ACTIONS(3494),
    [sym_xint] = ACTIONS(3492),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3492),
    [anon_sym_POUNDload] = ACTIONS(3492),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3492),
  },
  [2987] = {
    [sym_type_arguments] = STATE(3605),
    [sym_long_identifier] = STATE(3604),
    [sym_block_comment] = STATE(2987),
    [sym_compiler_directive_decl] = STATE(2987),
    [sym_fsi_directive_decl] = STATE(2987),
    [sym_preproc_line] = STATE(2987),
    [aux_sym_compound_type_repeat1] = STATE(3597),
    [ts_builtin_sym_end] = ACTIONS(5605),
    [sym_identifier] = ACTIONS(5379),
    [anon_sym_namespace] = ACTIONS(5607),
    [anon_sym_module] = ACTIONS(5607),
    [anon_sym_open] = ACTIONS(5607),
    [anon_sym_LBRACK_LT] = ACTIONS(5605),
    [anon_sym_return] = ACTIONS(5607),
    [anon_sym_type] = ACTIONS(5607),
    [anon_sym_do] = ACTIONS(5607),
    [anon_sym_and] = ACTIONS(5607),
    [anon_sym_let] = ACTIONS(5607),
    [anon_sym_let_BANG] = ACTIONS(5605),
    [aux_sym_access_modifier_token1] = ACTIONS(5605),
    [anon_sym_LPAREN] = ACTIONS(5607),
    [anon_sym_null] = ACTIONS(5607),
    [anon_sym_AMP] = ACTIONS(5607),
    [anon_sym_LBRACK] = ACTIONS(5607),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5605),
    [anon_sym_LBRACE] = ACTIONS(5607),
    [anon_sym_LT_AT] = ACTIONS(5607),
    [anon_sym_LT_AT_AT] = ACTIONS(5605),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5605),
    [anon_sym_new] = ACTIONS(5607),
    [anon_sym_with] = ACTIONS(5607),
    [anon_sym_return_BANG] = ACTIONS(5605),
    [anon_sym_yield] = ACTIONS(5607),
    [anon_sym_yield_BANG] = ACTIONS(5605),
    [anon_sym_lazy] = ACTIONS(5607),
    [anon_sym_assert] = ACTIONS(5607),
    [anon_sym_upcast] = ACTIONS(5607),
    [anon_sym_downcast] = ACTIONS(5607),
    [anon_sym_for] = ACTIONS(5607),
    [anon_sym_while] = ACTIONS(5607),
    [anon_sym_if] = ACTIONS(5607),
    [anon_sym_fun] = ACTIONS(5607),
    [anon_sym_DASH_GT] = ACTIONS(5609),
    [anon_sym_try] = ACTIONS(5607),
    [anon_sym_match] = ACTIONS(5607),
    [anon_sym_match_BANG] = ACTIONS(5605),
    [anon_sym_function] = ACTIONS(5607),
    [anon_sym_use] = ACTIONS(5607),
    [anon_sym_use_BANG] = ACTIONS(5605),
    [anon_sym_do_BANG] = ACTIONS(5605),
    [anon_sym_begin] = ACTIONS(5607),
    [anon_sym_STAR] = ACTIONS(5609),
    [anon_sym_LT2] = ACTIONS(5389),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5391),
    [anon_sym_default] = ACTIONS(5607),
    [anon_sym_static] = ACTIONS(5607),
    [anon_sym_member] = ACTIONS(5607),
    [anon_sym_interface] = ACTIONS(5607),
    [anon_sym_exception] = ACTIONS(5607),
    [anon_sym_abstract] = ACTIONS(5607),
    [anon_sym_val] = ACTIONS(5607),
    [anon_sym_override] = ACTIONS(5607),
    [aux_sym_char_token1] = ACTIONS(5605),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5607),
    [anon_sym_DQUOTE] = ACTIONS(5607),
    [anon_sym_AT_DQUOTE] = ACTIONS(5605),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5605),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5605),
    [sym_bool] = ACTIONS(5607),
    [sym_unit] = ACTIONS(5605),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5607),
    [sym_op_identifier] = ACTIONS(5605),
    [anon_sym_PLUS] = ACTIONS(5607),
    [anon_sym_DASH] = ACTIONS(5607),
    [anon_sym_PLUS_DOT] = ACTIONS(5605),
    [anon_sym_DASH_DOT] = ACTIONS(5605),
    [anon_sym_PERCENT] = ACTIONS(5605),
    [anon_sym_AMP_AMP] = ACTIONS(5605),
    [anon_sym_TILDE] = ACTIONS(5605),
    [aux_sym_prefix_op_token1] = ACTIONS(5605),
    [sym_int] = ACTIONS(5607),
    [sym_xint] = ACTIONS(5605),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5605),
    [anon_sym_POUNDload] = ACTIONS(5605),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(5605),
  },
  [2988] = {
    [sym_block_comment] = STATE(2988),
    [sym_compiler_directive_decl] = STATE(2988),
    [sym_fsi_directive_decl] = STATE(2988),
    [sym_preproc_line] = STATE(2988),
    [sym_identifier] = ACTIONS(4216),
    [anon_sym_EQ] = ACTIONS(4214),
    [anon_sym_COLON] = ACTIONS(4216),
    [anon_sym_return] = ACTIONS(4216),
    [anon_sym_do] = ACTIONS(4216),
    [anon_sym_let] = ACTIONS(4216),
    [anon_sym_let_BANG] = ACTIONS(4214),
    [anon_sym_as] = ACTIONS(4216),
    [anon_sym_LPAREN] = ACTIONS(4216),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_null] = ACTIONS(4216),
    [anon_sym_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_COLON] = ACTIONS(4214),
    [anon_sym_AMP] = ACTIONS(4216),
    [anon_sym_LBRACK] = ACTIONS(4216),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4214),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_LT_AT] = ACTIONS(4216),
    [anon_sym_LT_AT_AT] = ACTIONS(4216),
    [anon_sym_DOT] = ACTIONS(4216),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4214),
    [anon_sym_new] = ACTIONS(4216),
    [anon_sym_with] = ACTIONS(4216),
    [anon_sym_return_BANG] = ACTIONS(4214),
    [anon_sym_yield] = ACTIONS(4216),
    [anon_sym_yield_BANG] = ACTIONS(4214),
    [anon_sym_lazy] = ACTIONS(4216),
    [anon_sym_assert] = ACTIONS(4216),
    [anon_sym_upcast] = ACTIONS(4216),
    [anon_sym_downcast] = ACTIONS(4216),
    [anon_sym_COLON_GT] = ACTIONS(4214),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4214),
    [anon_sym_for] = ACTIONS(4216),
    [anon_sym_while] = ACTIONS(4216),
    [anon_sym_if] = ACTIONS(4216),
    [anon_sym_fun] = ACTIONS(4216),
    [anon_sym_try] = ACTIONS(4216),
    [anon_sym_match] = ACTIONS(4216),
    [anon_sym_match_BANG] = ACTIONS(4214),
    [anon_sym_function] = ACTIONS(4216),
    [anon_sym_LT_DASH] = ACTIONS(4216),
    [anon_sym_DOT_LBRACK] = ACTIONS(4214),
    [anon_sym_LT] = ACTIONS(4214),
    [anon_sym_use] = ACTIONS(4216),
    [anon_sym_use_BANG] = ACTIONS(4214),
    [anon_sym_do_BANG] = ACTIONS(4214),
    [anon_sym_begin] = ACTIONS(4216),
    [anon_sym_LPAREN2] = ACTIONS(4216),
    [anon_sym_or] = ACTIONS(4216),
    [aux_sym_char_token1] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4216),
    [anon_sym_DQUOTE] = ACTIONS(4216),
    [anon_sym_AT_DQUOTE] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [sym_bool] = ACTIONS(4216),
    [sym_unit] = ACTIONS(4214),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4216),
    [sym_op_identifier] = ACTIONS(4216),
    [anon_sym_PLUS] = ACTIONS(4216),
    [anon_sym_DASH] = ACTIONS(4216),
    [anon_sym_PLUS_DOT] = ACTIONS(4216),
    [anon_sym_DASH_DOT] = ACTIONS(4216),
    [anon_sym_PERCENT] = ACTIONS(4216),
    [anon_sym_AMP_AMP] = ACTIONS(4216),
    [anon_sym_TILDE] = ACTIONS(4214),
    [aux_sym_prefix_op_token1] = ACTIONS(4216),
    [aux_sym_infix_op_token1] = ACTIONS(4214),
    [aux_sym_infix_op_token2] = ACTIONS(4216),
    [anon_sym_PIPE_PIPE] = ACTIONS(4216),
    [anon_sym_BANG_EQ] = ACTIONS(4216),
    [anon_sym_COLON_EQ] = ACTIONS(4214),
    [anon_sym_DOLLAR] = ACTIONS(4216),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4216),
    [sym_int] = ACTIONS(4216),
    [sym_xint] = ACTIONS(4214),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4214),
    [sym__newline] = ACTIONS(4214),
  },
  [2989] = {
    [sym_block_comment] = STATE(2989),
    [sym_compiler_directive_decl] = STATE(2989),
    [sym_fsi_directive_decl] = STATE(2989),
    [sym_preproc_line] = STATE(2989),
    [sym_identifier] = ACTIONS(4220),
    [anon_sym_EQ] = ACTIONS(4218),
    [anon_sym_COLON] = ACTIONS(4220),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_do] = ACTIONS(4220),
    [anon_sym_let] = ACTIONS(4220),
    [anon_sym_let_BANG] = ACTIONS(4218),
    [anon_sym_as] = ACTIONS(4220),
    [anon_sym_LPAREN] = ACTIONS(4220),
    [anon_sym_COMMA] = ACTIONS(4218),
    [anon_sym_null] = ACTIONS(4220),
    [anon_sym_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_COLON] = ACTIONS(4218),
    [anon_sym_AMP] = ACTIONS(4220),
    [anon_sym_LBRACK] = ACTIONS(4220),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(4220),
    [anon_sym_LT_AT] = ACTIONS(4220),
    [anon_sym_LT_AT_AT] = ACTIONS(4220),
    [anon_sym_DOT] = ACTIONS(4220),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4218),
    [anon_sym_new] = ACTIONS(4220),
    [anon_sym_with] = ACTIONS(4220),
    [anon_sym_return_BANG] = ACTIONS(4218),
    [anon_sym_yield] = ACTIONS(4220),
    [anon_sym_yield_BANG] = ACTIONS(4218),
    [anon_sym_lazy] = ACTIONS(4220),
    [anon_sym_assert] = ACTIONS(4220),
    [anon_sym_upcast] = ACTIONS(4220),
    [anon_sym_downcast] = ACTIONS(4220),
    [anon_sym_COLON_GT] = ACTIONS(4218),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4218),
    [anon_sym_for] = ACTIONS(4220),
    [anon_sym_while] = ACTIONS(4220),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_fun] = ACTIONS(4220),
    [anon_sym_try] = ACTIONS(4220),
    [anon_sym_match] = ACTIONS(4220),
    [anon_sym_match_BANG] = ACTIONS(4218),
    [anon_sym_function] = ACTIONS(4220),
    [anon_sym_LT_DASH] = ACTIONS(4220),
    [anon_sym_DOT_LBRACK] = ACTIONS(4218),
    [anon_sym_LT] = ACTIONS(4218),
    [anon_sym_use] = ACTIONS(4220),
    [anon_sym_use_BANG] = ACTIONS(4218),
    [anon_sym_do_BANG] = ACTIONS(4218),
    [anon_sym_begin] = ACTIONS(4220),
    [anon_sym_LPAREN2] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(4220),
    [aux_sym_char_token1] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4220),
    [anon_sym_DQUOTE] = ACTIONS(4220),
    [anon_sym_AT_DQUOTE] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [sym_bool] = ACTIONS(4220),
    [sym_unit] = ACTIONS(4218),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4220),
    [sym_op_identifier] = ACTIONS(4220),
    [anon_sym_PLUS] = ACTIONS(4220),
    [anon_sym_DASH] = ACTIONS(4220),
    [anon_sym_PLUS_DOT] = ACTIONS(4220),
    [anon_sym_DASH_DOT] = ACTIONS(4220),
    [anon_sym_PERCENT] = ACTIONS(4220),
    [anon_sym_AMP_AMP] = ACTIONS(4220),
    [anon_sym_TILDE] = ACTIONS(4218),
    [aux_sym_prefix_op_token1] = ACTIONS(4220),
    [aux_sym_infix_op_token1] = ACTIONS(4218),
    [aux_sym_infix_op_token2] = ACTIONS(4220),
    [anon_sym_PIPE_PIPE] = ACTIONS(4220),
    [anon_sym_BANG_EQ] = ACTIONS(4220),
    [anon_sym_COLON_EQ] = ACTIONS(4218),
    [anon_sym_DOLLAR] = ACTIONS(4220),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4220),
    [sym_int] = ACTIONS(4220),
    [sym_xint] = ACTIONS(4218),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4218),
    [sym__newline] = ACTIONS(4218),
  },
  [2990] = {
    [sym_block_comment] = STATE(2990),
    [sym_compiler_directive_decl] = STATE(2990),
    [sym_fsi_directive_decl] = STATE(2990),
    [sym_preproc_line] = STATE(2990),
    [sym_identifier] = ACTIONS(4236),
    [anon_sym_EQ] = ACTIONS(4234),
    [anon_sym_COLON] = ACTIONS(4236),
    [anon_sym_return] = ACTIONS(4236),
    [anon_sym_do] = ACTIONS(4236),
    [anon_sym_let] = ACTIONS(4236),
    [anon_sym_let_BANG] = ACTIONS(4234),
    [anon_sym_as] = ACTIONS(4236),
    [anon_sym_LPAREN] = ACTIONS(4236),
    [anon_sym_COMMA] = ACTIONS(4234),
    [anon_sym_null] = ACTIONS(4236),
    [anon_sym_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_COLON] = ACTIONS(4234),
    [anon_sym_AMP] = ACTIONS(4236),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4234),
    [anon_sym_LBRACE] = ACTIONS(4236),
    [anon_sym_LT_AT] = ACTIONS(4236),
    [anon_sym_LT_AT_AT] = ACTIONS(4236),
    [anon_sym_DOT] = ACTIONS(4236),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4234),
    [anon_sym_new] = ACTIONS(4236),
    [anon_sym_with] = ACTIONS(4236),
    [anon_sym_return_BANG] = ACTIONS(4234),
    [anon_sym_yield] = ACTIONS(4236),
    [anon_sym_yield_BANG] = ACTIONS(4234),
    [anon_sym_lazy] = ACTIONS(4236),
    [anon_sym_assert] = ACTIONS(4236),
    [anon_sym_upcast] = ACTIONS(4236),
    [anon_sym_downcast] = ACTIONS(4236),
    [anon_sym_COLON_GT] = ACTIONS(4234),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4234),
    [anon_sym_for] = ACTIONS(4236),
    [anon_sym_while] = ACTIONS(4236),
    [anon_sym_if] = ACTIONS(4236),
    [anon_sym_fun] = ACTIONS(4236),
    [anon_sym_try] = ACTIONS(4236),
    [anon_sym_match] = ACTIONS(4236),
    [anon_sym_match_BANG] = ACTIONS(4234),
    [anon_sym_function] = ACTIONS(4236),
    [anon_sym_LT_DASH] = ACTIONS(4236),
    [anon_sym_DOT_LBRACK] = ACTIONS(4234),
    [anon_sym_LT] = ACTIONS(4234),
    [anon_sym_use] = ACTIONS(4236),
    [anon_sym_use_BANG] = ACTIONS(4234),
    [anon_sym_do_BANG] = ACTIONS(4234),
    [anon_sym_begin] = ACTIONS(4236),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_or] = ACTIONS(4236),
    [aux_sym_char_token1] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4236),
    [anon_sym_DQUOTE] = ACTIONS(4236),
    [anon_sym_AT_DQUOTE] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [sym_bool] = ACTIONS(4236),
    [sym_unit] = ACTIONS(4234),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4236),
    [sym_op_identifier] = ACTIONS(4236),
    [anon_sym_PLUS] = ACTIONS(4236),
    [anon_sym_DASH] = ACTIONS(4236),
    [anon_sym_PLUS_DOT] = ACTIONS(4236),
    [anon_sym_DASH_DOT] = ACTIONS(4236),
    [anon_sym_PERCENT] = ACTIONS(4236),
    [anon_sym_AMP_AMP] = ACTIONS(4236),
    [anon_sym_TILDE] = ACTIONS(4234),
    [aux_sym_prefix_op_token1] = ACTIONS(4236),
    [aux_sym_infix_op_token1] = ACTIONS(4234),
    [aux_sym_infix_op_token2] = ACTIONS(4236),
    [anon_sym_PIPE_PIPE] = ACTIONS(4236),
    [anon_sym_BANG_EQ] = ACTIONS(4236),
    [anon_sym_COLON_EQ] = ACTIONS(4234),
    [anon_sym_DOLLAR] = ACTIONS(4236),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4236),
    [sym_int] = ACTIONS(4236),
    [sym_xint] = ACTIONS(4234),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4234),
    [sym__newline] = ACTIONS(4234),
  },
  [2991] = {
    [sym_block_comment] = STATE(2991),
    [sym_compiler_directive_decl] = STATE(2991),
    [sym_fsi_directive_decl] = STATE(2991),
    [sym_preproc_line] = STATE(2991),
    [sym_identifier] = ACTIONS(4147),
    [anon_sym_EQ] = ACTIONS(4145),
    [anon_sym_COLON] = ACTIONS(4147),
    [anon_sym_return] = ACTIONS(4147),
    [anon_sym_do] = ACTIONS(4147),
    [anon_sym_let] = ACTIONS(4147),
    [anon_sym_let_BANG] = ACTIONS(4145),
    [anon_sym_as] = ACTIONS(4147),
    [anon_sym_LPAREN] = ACTIONS(4147),
    [anon_sym_COMMA] = ACTIONS(4145),
    [anon_sym_null] = ACTIONS(4147),
    [anon_sym_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_COLON] = ACTIONS(4145),
    [anon_sym_AMP] = ACTIONS(4147),
    [anon_sym_LBRACK] = ACTIONS(4147),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4145),
    [anon_sym_LBRACE] = ACTIONS(4147),
    [anon_sym_LT_AT] = ACTIONS(4147),
    [anon_sym_LT_AT_AT] = ACTIONS(4147),
    [anon_sym_DOT] = ACTIONS(4147),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4145),
    [anon_sym_new] = ACTIONS(4147),
    [anon_sym_with] = ACTIONS(4147),
    [anon_sym_return_BANG] = ACTIONS(4145),
    [anon_sym_yield] = ACTIONS(4147),
    [anon_sym_yield_BANG] = ACTIONS(4145),
    [anon_sym_lazy] = ACTIONS(4147),
    [anon_sym_assert] = ACTIONS(4147),
    [anon_sym_upcast] = ACTIONS(4147),
    [anon_sym_downcast] = ACTIONS(4147),
    [anon_sym_COLON_GT] = ACTIONS(4145),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4145),
    [anon_sym_for] = ACTIONS(4147),
    [anon_sym_while] = ACTIONS(4147),
    [anon_sym_if] = ACTIONS(4147),
    [anon_sym_fun] = ACTIONS(4147),
    [anon_sym_try] = ACTIONS(4147),
    [anon_sym_match] = ACTIONS(4147),
    [anon_sym_match_BANG] = ACTIONS(4145),
    [anon_sym_function] = ACTIONS(4147),
    [anon_sym_LT_DASH] = ACTIONS(4147),
    [anon_sym_DOT_LBRACK] = ACTIONS(4145),
    [anon_sym_LT] = ACTIONS(4145),
    [anon_sym_use] = ACTIONS(4147),
    [anon_sym_use_BANG] = ACTIONS(4145),
    [anon_sym_do_BANG] = ACTIONS(4145),
    [anon_sym_begin] = ACTIONS(4147),
    [anon_sym_LPAREN2] = ACTIONS(4147),
    [anon_sym_or] = ACTIONS(4147),
    [aux_sym_char_token1] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4147),
    [anon_sym_DQUOTE] = ACTIONS(4147),
    [anon_sym_AT_DQUOTE] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [sym_bool] = ACTIONS(4147),
    [sym_unit] = ACTIONS(4145),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4147),
    [sym_op_identifier] = ACTIONS(4147),
    [anon_sym_PLUS] = ACTIONS(4147),
    [anon_sym_DASH] = ACTIONS(4147),
    [anon_sym_PLUS_DOT] = ACTIONS(4147),
    [anon_sym_DASH_DOT] = ACTIONS(4147),
    [anon_sym_PERCENT] = ACTIONS(4147),
    [anon_sym_AMP_AMP] = ACTIONS(4147),
    [anon_sym_TILDE] = ACTIONS(4145),
    [aux_sym_prefix_op_token1] = ACTIONS(4147),
    [aux_sym_infix_op_token1] = ACTIONS(4145),
    [aux_sym_infix_op_token2] = ACTIONS(4147),
    [anon_sym_PIPE_PIPE] = ACTIONS(4147),
    [anon_sym_BANG_EQ] = ACTIONS(4147),
    [anon_sym_COLON_EQ] = ACTIONS(4145),
    [anon_sym_DOLLAR] = ACTIONS(4147),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4147),
    [sym_int] = ACTIONS(4147),
    [sym_xint] = ACTIONS(4145),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4145),
    [sym__newline] = ACTIONS(4145),
  },
  [2992] = {
    [sym_block_comment] = STATE(2992),
    [sym_compiler_directive_decl] = STATE(2992),
    [sym_fsi_directive_decl] = STATE(2992),
    [sym_preproc_line] = STATE(2992),
    [sym_identifier] = ACTIONS(4240),
    [anon_sym_EQ] = ACTIONS(4238),
    [anon_sym_COLON] = ACTIONS(4240),
    [anon_sym_return] = ACTIONS(4240),
    [anon_sym_do] = ACTIONS(4240),
    [anon_sym_let] = ACTIONS(4240),
    [anon_sym_let_BANG] = ACTIONS(4238),
    [anon_sym_as] = ACTIONS(4240),
    [anon_sym_LPAREN] = ACTIONS(4240),
    [anon_sym_COMMA] = ACTIONS(4238),
    [anon_sym_null] = ACTIONS(4240),
    [anon_sym_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_COLON] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4240),
    [anon_sym_LBRACK] = ACTIONS(4240),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4238),
    [anon_sym_LBRACE] = ACTIONS(4240),
    [anon_sym_LT_AT] = ACTIONS(4240),
    [anon_sym_LT_AT_AT] = ACTIONS(4240),
    [anon_sym_DOT] = ACTIONS(4240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4238),
    [anon_sym_new] = ACTIONS(4240),
    [anon_sym_with] = ACTIONS(4240),
    [anon_sym_return_BANG] = ACTIONS(4238),
    [anon_sym_yield] = ACTIONS(4240),
    [anon_sym_yield_BANG] = ACTIONS(4238),
    [anon_sym_lazy] = ACTIONS(4240),
    [anon_sym_assert] = ACTIONS(4240),
    [anon_sym_upcast] = ACTIONS(4240),
    [anon_sym_downcast] = ACTIONS(4240),
    [anon_sym_COLON_GT] = ACTIONS(4238),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4238),
    [anon_sym_for] = ACTIONS(4240),
    [anon_sym_while] = ACTIONS(4240),
    [anon_sym_if] = ACTIONS(4240),
    [anon_sym_fun] = ACTIONS(4240),
    [anon_sym_try] = ACTIONS(4240),
    [anon_sym_match] = ACTIONS(4240),
    [anon_sym_match_BANG] = ACTIONS(4238),
    [anon_sym_function] = ACTIONS(4240),
    [anon_sym_LT_DASH] = ACTIONS(4240),
    [anon_sym_DOT_LBRACK] = ACTIONS(4238),
    [anon_sym_LT] = ACTIONS(4238),
    [anon_sym_use] = ACTIONS(4240),
    [anon_sym_use_BANG] = ACTIONS(4238),
    [anon_sym_do_BANG] = ACTIONS(4238),
    [anon_sym_begin] = ACTIONS(4240),
    [anon_sym_LPAREN2] = ACTIONS(4240),
    [anon_sym_or] = ACTIONS(4240),
    [aux_sym_char_token1] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4240),
    [anon_sym_DQUOTE] = ACTIONS(4240),
    [anon_sym_AT_DQUOTE] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [sym_bool] = ACTIONS(4240),
    [sym_unit] = ACTIONS(4238),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4240),
    [sym_op_identifier] = ACTIONS(4240),
    [anon_sym_PLUS] = ACTIONS(4240),
    [anon_sym_DASH] = ACTIONS(4240),
    [anon_sym_PLUS_DOT] = ACTIONS(4240),
    [anon_sym_DASH_DOT] = ACTIONS(4240),
    [anon_sym_PERCENT] = ACTIONS(4240),
    [anon_sym_AMP_AMP] = ACTIONS(4240),
    [anon_sym_TILDE] = ACTIONS(4238),
    [aux_sym_prefix_op_token1] = ACTIONS(4240),
    [aux_sym_infix_op_token1] = ACTIONS(4238),
    [aux_sym_infix_op_token2] = ACTIONS(4240),
    [anon_sym_PIPE_PIPE] = ACTIONS(4240),
    [anon_sym_BANG_EQ] = ACTIONS(4240),
    [anon_sym_COLON_EQ] = ACTIONS(4238),
    [anon_sym_DOLLAR] = ACTIONS(4240),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4240),
    [sym_int] = ACTIONS(4240),
    [sym_xint] = ACTIONS(4238),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4238),
    [sym__newline] = ACTIONS(4238),
  },
  [2993] = {
    [sym_block_comment] = STATE(2993),
    [sym_compiler_directive_decl] = STATE(2993),
    [sym_fsi_directive_decl] = STATE(2993),
    [sym_preproc_line] = STATE(2993),
    [sym_identifier] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4242),
    [anon_sym_COLON] = ACTIONS(4244),
    [anon_sym_return] = ACTIONS(4244),
    [anon_sym_do] = ACTIONS(4244),
    [anon_sym_let] = ACTIONS(4244),
    [anon_sym_let_BANG] = ACTIONS(4242),
    [anon_sym_as] = ACTIONS(4244),
    [anon_sym_LPAREN] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_null] = ACTIONS(4244),
    [anon_sym_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_COLON] = ACTIONS(4242),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4244),
    [anon_sym_LT_AT] = ACTIONS(4244),
    [anon_sym_LT_AT_AT] = ACTIONS(4244),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4242),
    [anon_sym_new] = ACTIONS(4244),
    [anon_sym_with] = ACTIONS(4244),
    [anon_sym_return_BANG] = ACTIONS(4242),
    [anon_sym_yield] = ACTIONS(4244),
    [anon_sym_yield_BANG] = ACTIONS(4242),
    [anon_sym_lazy] = ACTIONS(4244),
    [anon_sym_assert] = ACTIONS(4244),
    [anon_sym_upcast] = ACTIONS(4244),
    [anon_sym_downcast] = ACTIONS(4244),
    [anon_sym_COLON_GT] = ACTIONS(4242),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4242),
    [anon_sym_for] = ACTIONS(4244),
    [anon_sym_while] = ACTIONS(4244),
    [anon_sym_if] = ACTIONS(4244),
    [anon_sym_fun] = ACTIONS(4244),
    [anon_sym_try] = ACTIONS(4244),
    [anon_sym_match] = ACTIONS(4244),
    [anon_sym_match_BANG] = ACTIONS(4242),
    [anon_sym_function] = ACTIONS(4244),
    [anon_sym_LT_DASH] = ACTIONS(4244),
    [anon_sym_DOT_LBRACK] = ACTIONS(4242),
    [anon_sym_LT] = ACTIONS(4242),
    [anon_sym_use] = ACTIONS(4244),
    [anon_sym_use_BANG] = ACTIONS(4242),
    [anon_sym_do_BANG] = ACTIONS(4242),
    [anon_sym_begin] = ACTIONS(4244),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_or] = ACTIONS(4244),
    [aux_sym_char_token1] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4244),
    [anon_sym_DQUOTE] = ACTIONS(4244),
    [anon_sym_AT_DQUOTE] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [sym_bool] = ACTIONS(4244),
    [sym_unit] = ACTIONS(4242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4244),
    [sym_op_identifier] = ACTIONS(4244),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_DASH] = ACTIONS(4244),
    [anon_sym_PLUS_DOT] = ACTIONS(4244),
    [anon_sym_DASH_DOT] = ACTIONS(4244),
    [anon_sym_PERCENT] = ACTIONS(4244),
    [anon_sym_AMP_AMP] = ACTIONS(4244),
    [anon_sym_TILDE] = ACTIONS(4242),
    [aux_sym_prefix_op_token1] = ACTIONS(4244),
    [aux_sym_infix_op_token1] = ACTIONS(4242),
    [aux_sym_infix_op_token2] = ACTIONS(4244),
    [anon_sym_PIPE_PIPE] = ACTIONS(4244),
    [anon_sym_BANG_EQ] = ACTIONS(4244),
    [anon_sym_COLON_EQ] = ACTIONS(4242),
    [anon_sym_DOLLAR] = ACTIONS(4244),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4244),
    [sym_int] = ACTIONS(4244),
    [sym_xint] = ACTIONS(4242),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4242),
    [sym__newline] = ACTIONS(4242),
  },
  [2994] = {
    [sym_block_comment] = STATE(2994),
    [sym_compiler_directive_decl] = STATE(2994),
    [sym_fsi_directive_decl] = STATE(2994),
    [sym_preproc_line] = STATE(2994),
    [sym_identifier] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4246),
    [anon_sym_COLON] = ACTIONS(4248),
    [anon_sym_return] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4248),
    [anon_sym_let] = ACTIONS(4248),
    [anon_sym_let_BANG] = ACTIONS(4246),
    [anon_sym_as] = ACTIONS(4248),
    [anon_sym_LPAREN] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_null] = ACTIONS(4248),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4248),
    [anon_sym_LT_AT] = ACTIONS(4248),
    [anon_sym_LT_AT_AT] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4246),
    [anon_sym_new] = ACTIONS(4248),
    [anon_sym_with] = ACTIONS(4248),
    [anon_sym_return_BANG] = ACTIONS(4246),
    [anon_sym_yield] = ACTIONS(4248),
    [anon_sym_yield_BANG] = ACTIONS(4246),
    [anon_sym_lazy] = ACTIONS(4248),
    [anon_sym_assert] = ACTIONS(4248),
    [anon_sym_upcast] = ACTIONS(4248),
    [anon_sym_downcast] = ACTIONS(4248),
    [anon_sym_COLON_GT] = ACTIONS(4246),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4246),
    [anon_sym_for] = ACTIONS(4248),
    [anon_sym_while] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4248),
    [anon_sym_fun] = ACTIONS(4248),
    [anon_sym_try] = ACTIONS(4248),
    [anon_sym_match] = ACTIONS(4248),
    [anon_sym_match_BANG] = ACTIONS(4246),
    [anon_sym_function] = ACTIONS(4248),
    [anon_sym_LT_DASH] = ACTIONS(4248),
    [anon_sym_DOT_LBRACK] = ACTIONS(4246),
    [anon_sym_LT] = ACTIONS(4246),
    [anon_sym_use] = ACTIONS(4248),
    [anon_sym_use_BANG] = ACTIONS(4246),
    [anon_sym_do_BANG] = ACTIONS(4246),
    [anon_sym_begin] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4248),
    [aux_sym_char_token1] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4248),
    [anon_sym_DQUOTE] = ACTIONS(4248),
    [anon_sym_AT_DQUOTE] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [sym_bool] = ACTIONS(4248),
    [sym_unit] = ACTIONS(4246),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4248),
    [sym_op_identifier] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_DOT] = ACTIONS(4248),
    [anon_sym_DASH_DOT] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_TILDE] = ACTIONS(4246),
    [aux_sym_prefix_op_token1] = ACTIONS(4248),
    [aux_sym_infix_op_token1] = ACTIONS(4246),
    [aux_sym_infix_op_token2] = ACTIONS(4248),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_COLON_EQ] = ACTIONS(4246),
    [anon_sym_DOLLAR] = ACTIONS(4248),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4248),
    [sym_int] = ACTIONS(4248),
    [sym_xint] = ACTIONS(4246),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4246),
    [sym__newline] = ACTIONS(4246),
  },
  [2995] = {
    [sym_block_comment] = STATE(2995),
    [sym_compiler_directive_decl] = STATE(2995),
    [sym_fsi_directive_decl] = STATE(2995),
    [sym_preproc_line] = STATE(2995),
    [sym_identifier] = ACTIONS(4224),
    [anon_sym_EQ] = ACTIONS(4222),
    [anon_sym_COLON] = ACTIONS(4224),
    [anon_sym_return] = ACTIONS(4224),
    [anon_sym_do] = ACTIONS(4224),
    [anon_sym_let] = ACTIONS(4224),
    [anon_sym_let_BANG] = ACTIONS(4222),
    [anon_sym_as] = ACTIONS(4224),
    [anon_sym_LPAREN] = ACTIONS(4224),
    [anon_sym_COMMA] = ACTIONS(4222),
    [anon_sym_null] = ACTIONS(4224),
    [anon_sym_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_COLON] = ACTIONS(4222),
    [anon_sym_AMP] = ACTIONS(4224),
    [anon_sym_LBRACK] = ACTIONS(4224),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4222),
    [anon_sym_LBRACE] = ACTIONS(4224),
    [anon_sym_LT_AT] = ACTIONS(4224),
    [anon_sym_LT_AT_AT] = ACTIONS(4224),
    [anon_sym_DOT] = ACTIONS(4224),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4222),
    [anon_sym_new] = ACTIONS(4224),
    [anon_sym_with] = ACTIONS(4224),
    [anon_sym_return_BANG] = ACTIONS(4222),
    [anon_sym_yield] = ACTIONS(4224),
    [anon_sym_yield_BANG] = ACTIONS(4222),
    [anon_sym_lazy] = ACTIONS(4224),
    [anon_sym_assert] = ACTIONS(4224),
    [anon_sym_upcast] = ACTIONS(4224),
    [anon_sym_downcast] = ACTIONS(4224),
    [anon_sym_COLON_GT] = ACTIONS(4222),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4222),
    [anon_sym_for] = ACTIONS(4224),
    [anon_sym_while] = ACTIONS(4224),
    [anon_sym_if] = ACTIONS(4224),
    [anon_sym_fun] = ACTIONS(4224),
    [anon_sym_try] = ACTIONS(4224),
    [anon_sym_match] = ACTIONS(4224),
    [anon_sym_match_BANG] = ACTIONS(4222),
    [anon_sym_function] = ACTIONS(4224),
    [anon_sym_LT_DASH] = ACTIONS(4224),
    [anon_sym_DOT_LBRACK] = ACTIONS(4222),
    [anon_sym_LT] = ACTIONS(4222),
    [anon_sym_use] = ACTIONS(4224),
    [anon_sym_use_BANG] = ACTIONS(4222),
    [anon_sym_do_BANG] = ACTIONS(4222),
    [anon_sym_begin] = ACTIONS(4224),
    [anon_sym_LPAREN2] = ACTIONS(4224),
    [anon_sym_or] = ACTIONS(4224),
    [aux_sym_char_token1] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4224),
    [anon_sym_DQUOTE] = ACTIONS(4224),
    [anon_sym_AT_DQUOTE] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [sym_bool] = ACTIONS(4224),
    [sym_unit] = ACTIONS(4222),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4224),
    [sym_op_identifier] = ACTIONS(4224),
    [anon_sym_PLUS] = ACTIONS(4224),
    [anon_sym_DASH] = ACTIONS(4224),
    [anon_sym_PLUS_DOT] = ACTIONS(4224),
    [anon_sym_DASH_DOT] = ACTIONS(4224),
    [anon_sym_PERCENT] = ACTIONS(4224),
    [anon_sym_AMP_AMP] = ACTIONS(4224),
    [anon_sym_TILDE] = ACTIONS(4222),
    [aux_sym_prefix_op_token1] = ACTIONS(4224),
    [aux_sym_infix_op_token1] = ACTIONS(4222),
    [aux_sym_infix_op_token2] = ACTIONS(4224),
    [anon_sym_PIPE_PIPE] = ACTIONS(4224),
    [anon_sym_BANG_EQ] = ACTIONS(4224),
    [anon_sym_COLON_EQ] = ACTIONS(4222),
    [anon_sym_DOLLAR] = ACTIONS(4224),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4224),
    [sym_int] = ACTIONS(4224),
    [sym_xint] = ACTIONS(4222),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4222),
    [sym__newline] = ACTIONS(4222),
  },
  [2996] = {
    [sym_block_comment] = STATE(2996),
    [sym_compiler_directive_decl] = STATE(2996),
    [sym_fsi_directive_decl] = STATE(2996),
    [sym_preproc_line] = STATE(2996),
    [sym_identifier] = ACTIONS(3931),
    [anon_sym_EQ] = ACTIONS(3929),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_do] = ACTIONS(3931),
    [anon_sym_let] = ACTIONS(3931),
    [anon_sym_let_BANG] = ACTIONS(3929),
    [anon_sym_as] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_COMMA] = ACTIONS(3929),
    [anon_sym_null] = ACTIONS(3931),
    [anon_sym_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_COLON] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3931),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_LT_AT] = ACTIONS(3931),
    [anon_sym_LT_AT_AT] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3931),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3929),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_with] = ACTIONS(3931),
    [anon_sym_return_BANG] = ACTIONS(3929),
    [anon_sym_yield] = ACTIONS(3931),
    [anon_sym_yield_BANG] = ACTIONS(3929),
    [anon_sym_lazy] = ACTIONS(3931),
    [anon_sym_assert] = ACTIONS(3931),
    [anon_sym_upcast] = ACTIONS(3931),
    [anon_sym_downcast] = ACTIONS(3931),
    [anon_sym_COLON_GT] = ACTIONS(3929),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3929),
    [anon_sym_for] = ACTIONS(3931),
    [anon_sym_while] = ACTIONS(3931),
    [anon_sym_if] = ACTIONS(3931),
    [anon_sym_fun] = ACTIONS(3931),
    [anon_sym_try] = ACTIONS(3931),
    [anon_sym_match] = ACTIONS(3931),
    [anon_sym_match_BANG] = ACTIONS(3929),
    [anon_sym_function] = ACTIONS(3931),
    [anon_sym_LT_DASH] = ACTIONS(3931),
    [anon_sym_DOT_LBRACK] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_use] = ACTIONS(3931),
    [anon_sym_use_BANG] = ACTIONS(3929),
    [anon_sym_do_BANG] = ACTIONS(3929),
    [anon_sym_begin] = ACTIONS(3931),
    [anon_sym_LPAREN2] = ACTIONS(3931),
    [anon_sym_or] = ACTIONS(3931),
    [aux_sym_char_token1] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3931),
    [anon_sym_DQUOTE] = ACTIONS(3931),
    [anon_sym_AT_DQUOTE] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [sym_bool] = ACTIONS(3931),
    [sym_unit] = ACTIONS(3929),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3931),
    [sym_op_identifier] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3931),
    [anon_sym_DASH] = ACTIONS(3931),
    [anon_sym_PLUS_DOT] = ACTIONS(3931),
    [anon_sym_DASH_DOT] = ACTIONS(3931),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_TILDE] = ACTIONS(3929),
    [aux_sym_prefix_op_token1] = ACTIONS(3931),
    [aux_sym_infix_op_token1] = ACTIONS(3929),
    [aux_sym_infix_op_token2] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_COLON_EQ] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3931),
    [sym_int] = ACTIONS(3931),
    [sym_xint] = ACTIONS(3929),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3929),
    [sym__newline] = ACTIONS(3929),
  },
  [2997] = {
    [sym_attributes] = STATE(3968),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(5183),
    [sym__pattern] = STATE(5073),
    [sym_optional_pattern] = STATE(5183),
    [sym_type_check_pattern] = STATE(5183),
    [sym_attribute_pattern] = STATE(5183),
    [sym_paren_pattern] = STATE(5183),
    [sym_as_pattern] = STATE(5183),
    [sym_cons_pattern] = STATE(5183),
    [sym_disjunct_pattern] = STATE(5183),
    [sym_conjunct_pattern] = STATE(5183),
    [sym_typed_pattern] = STATE(5183),
    [sym_list_pattern] = STATE(5183),
    [sym_array_pattern] = STATE(5183),
    [sym_record_pattern] = STATE(5183),
    [sym_named_field_pattern] = STATE(5183),
    [sym_identifier_pattern] = STATE(5183),
    [sym_long_identifier_or_op] = STATE(3528),
    [sym_char] = STATE(5133),
    [sym_format_string] = STATE(5135),
    [sym__string_literal] = STATE(5135),
    [sym_string] = STATE(5133),
    [sym_verbatim_string] = STATE(5133),
    [sym_bytearray] = STATE(5133),
    [sym_verbatim_bytearray] = STATE(5133),
    [sym_format_triple_quoted_string] = STATE(5136),
    [sym_triple_quoted_string] = STATE(5133),
    [sym_const] = STATE(5183),
    [sym_long_identifier] = STATE(4953),
    [sym_active_pattern] = STATE(5117),
    [sym__identifier_or_op] = STATE(5167),
    [sym_sbyte] = STATE(5133),
    [sym_byte] = STATE(5133),
    [sym_int16] = STATE(5133),
    [sym_uint16] = STATE(5133),
    [sym_int32] = STATE(5133),
    [sym_uint32] = STATE(5133),
    [sym_nativeint] = STATE(5133),
    [sym_unativeint] = STATE(5133),
    [sym_int64] = STATE(5133),
    [sym_uint64] = STATE(5133),
    [sym_ieee32] = STATE(5133),
    [sym_ieee64] = STATE(5133),
    [sym_bignum] = STATE(5133),
    [sym_decimal] = STATE(5133),
    [sym_float] = STATE(4916),
    [sym_block_comment] = STATE(2997),
    [sym_compiler_directive_decl] = STATE(2997),
    [sym_fsi_directive_decl] = STATE(2997),
    [sym_preproc_line] = STATE(2997),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym_repeat_pattern_repeat1] = STATE(5000),
    [sym_identifier] = ACTIONS(5363),
    [anon_sym_LBRACK_LT] = ACTIONS(5365),
    [anon_sym_COLON] = ACTIONS(5363),
    [anon_sym_as] = ACTIONS(5611),
    [anon_sym_LPAREN] = ACTIONS(5363),
    [anon_sym_COMMA] = ACTIONS(5613),
    [anon_sym_null] = ACTIONS(5363),
    [anon_sym__] = ACTIONS(5363),
    [anon_sym_QMARK] = ACTIONS(5365),
    [anon_sym_COLON_QMARK] = ACTIONS(5365),
    [anon_sym_COLON_COLON] = ACTIONS(5615),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_AMP] = ACTIONS(5619),
    [anon_sym_LBRACK] = ACTIONS(5363),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5365),
    [anon_sym_LBRACE] = ACTIONS(5365),
    [aux_sym_char_token1] = ACTIONS(5365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5363),
    [anon_sym_DQUOTE] = ACTIONS(5363),
    [anon_sym_AT_DQUOTE] = ACTIONS(5365),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5365),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5365),
    [sym_bool] = ACTIONS(5363),
    [sym_unit] = ACTIONS(5365),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5363),
    [sym_op_identifier] = ACTIONS(5365),
    [sym_int] = ACTIONS(5363),
    [sym_xint] = ACTIONS(5365),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [sym__newline] = ACTIONS(5365),
    [sym__dedent] = ACTIONS(5365),
  },
  [2998] = {
    [sym_block_comment] = STATE(2998),
    [sym_compiler_directive_decl] = STATE(2998),
    [sym_fsi_directive_decl] = STATE(2998),
    [sym_preproc_line] = STATE(2998),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_as] = ACTIONS(3487),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [2999] = {
    [sym_type_arguments] = STATE(3605),
    [sym_long_identifier] = STATE(3604),
    [sym_block_comment] = STATE(2999),
    [sym_compiler_directive_decl] = STATE(2999),
    [sym_fsi_directive_decl] = STATE(2999),
    [sym_preproc_line] = STATE(2999),
    [aux_sym_compound_type_repeat1] = STATE(3597),
    [ts_builtin_sym_end] = ACTIONS(5621),
    [sym_identifier] = ACTIONS(5379),
    [anon_sym_namespace] = ACTIONS(5623),
    [anon_sym_module] = ACTIONS(5623),
    [anon_sym_open] = ACTIONS(5623),
    [anon_sym_LBRACK_LT] = ACTIONS(5621),
    [anon_sym_return] = ACTIONS(5623),
    [anon_sym_type] = ACTIONS(5623),
    [anon_sym_do] = ACTIONS(5623),
    [anon_sym_and] = ACTIONS(5623),
    [anon_sym_let] = ACTIONS(5623),
    [anon_sym_let_BANG] = ACTIONS(5621),
    [aux_sym_access_modifier_token1] = ACTIONS(5621),
    [anon_sym_LPAREN] = ACTIONS(5623),
    [anon_sym_null] = ACTIONS(5623),
    [anon_sym_AMP] = ACTIONS(5623),
    [anon_sym_LBRACK] = ACTIONS(5623),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5621),
    [anon_sym_LBRACE] = ACTIONS(5623),
    [anon_sym_LT_AT] = ACTIONS(5623),
    [anon_sym_LT_AT_AT] = ACTIONS(5621),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5621),
    [anon_sym_new] = ACTIONS(5623),
    [anon_sym_with] = ACTIONS(5623),
    [anon_sym_return_BANG] = ACTIONS(5621),
    [anon_sym_yield] = ACTIONS(5623),
    [anon_sym_yield_BANG] = ACTIONS(5621),
    [anon_sym_lazy] = ACTIONS(5623),
    [anon_sym_assert] = ACTIONS(5623),
    [anon_sym_upcast] = ACTIONS(5623),
    [anon_sym_downcast] = ACTIONS(5623),
    [anon_sym_for] = ACTIONS(5623),
    [anon_sym_while] = ACTIONS(5623),
    [anon_sym_if] = ACTIONS(5623),
    [anon_sym_fun] = ACTIONS(5623),
    [anon_sym_DASH_GT] = ACTIONS(5609),
    [anon_sym_try] = ACTIONS(5623),
    [anon_sym_match] = ACTIONS(5623),
    [anon_sym_match_BANG] = ACTIONS(5621),
    [anon_sym_function] = ACTIONS(5623),
    [anon_sym_use] = ACTIONS(5623),
    [anon_sym_use_BANG] = ACTIONS(5621),
    [anon_sym_do_BANG] = ACTIONS(5621),
    [anon_sym_begin] = ACTIONS(5623),
    [anon_sym_STAR] = ACTIONS(5609),
    [anon_sym_LT2] = ACTIONS(5389),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5391),
    [anon_sym_default] = ACTIONS(5623),
    [anon_sym_static] = ACTIONS(5623),
    [anon_sym_member] = ACTIONS(5623),
    [anon_sym_interface] = ACTIONS(5623),
    [anon_sym_exception] = ACTIONS(5623),
    [anon_sym_abstract] = ACTIONS(5623),
    [anon_sym_val] = ACTIONS(5623),
    [anon_sym_override] = ACTIONS(5623),
    [aux_sym_char_token1] = ACTIONS(5621),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5623),
    [anon_sym_DQUOTE] = ACTIONS(5623),
    [anon_sym_AT_DQUOTE] = ACTIONS(5621),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5621),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5621),
    [sym_bool] = ACTIONS(5623),
    [sym_unit] = ACTIONS(5621),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5623),
    [sym_op_identifier] = ACTIONS(5621),
    [anon_sym_PLUS] = ACTIONS(5623),
    [anon_sym_DASH] = ACTIONS(5623),
    [anon_sym_PLUS_DOT] = ACTIONS(5621),
    [anon_sym_DASH_DOT] = ACTIONS(5621),
    [anon_sym_PERCENT] = ACTIONS(5621),
    [anon_sym_AMP_AMP] = ACTIONS(5621),
    [anon_sym_TILDE] = ACTIONS(5621),
    [aux_sym_prefix_op_token1] = ACTIONS(5621),
    [sym_int] = ACTIONS(5623),
    [sym_xint] = ACTIONS(5621),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5621),
    [anon_sym_POUNDload] = ACTIONS(5621),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(5621),
  },
  [3000] = {
    [sym_type_arguments] = STATE(3605),
    [sym_long_identifier] = STATE(3604),
    [sym_block_comment] = STATE(3000),
    [sym_compiler_directive_decl] = STATE(3000),
    [sym_fsi_directive_decl] = STATE(3000),
    [sym_preproc_line] = STATE(3000),
    [aux_sym_compound_type_repeat1] = STATE(3597),
    [ts_builtin_sym_end] = ACTIONS(3425),
    [sym_identifier] = ACTIONS(5379),
    [anon_sym_namespace] = ACTIONS(3427),
    [anon_sym_module] = ACTIONS(3427),
    [anon_sym_open] = ACTIONS(3427),
    [anon_sym_LBRACK_LT] = ACTIONS(3425),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_type] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_and] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [aux_sym_access_modifier_token1] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3425),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_with] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(5385),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(5387),
    [anon_sym_LT2] = ACTIONS(5389),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5391),
    [anon_sym_default] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_member] = ACTIONS(3427),
    [anon_sym_interface] = ACTIONS(3427),
    [anon_sym_exception] = ACTIONS(3427),
    [anon_sym_abstract] = ACTIONS(3427),
    [anon_sym_val] = ACTIONS(3427),
    [anon_sym_override] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3425),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3425),
    [anon_sym_DASH_DOT] = ACTIONS(3425),
    [anon_sym_PERCENT] = ACTIONS(3425),
    [anon_sym_AMP_AMP] = ACTIONS(3425),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3425),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3425),
    [anon_sym_POUNDload] = ACTIONS(3425),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
  },
  [3001] = {
    [sym_block_comment] = STATE(3001),
    [sym_compiler_directive_decl] = STATE(3001),
    [sym_fsi_directive_decl] = STATE(3001),
    [sym_preproc_line] = STATE(3001),
    [aux_sym_sequential_expression_repeat1] = STATE(3122),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_COLON] = ACTIONS(3759),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_let_BANG] = ACTIONS(3757),
    [anon_sym_LPAREN] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3757),
    [anon_sym_null] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3757),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_LT_AT] = ACTIONS(3759),
    [anon_sym_LT_AT_AT] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(3759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_return_BANG] = ACTIONS(3757),
    [anon_sym_yield] = ACTIONS(3759),
    [anon_sym_yield_BANG] = ACTIONS(3757),
    [anon_sym_lazy] = ACTIONS(3759),
    [anon_sym_assert] = ACTIONS(3759),
    [anon_sym_upcast] = ACTIONS(3759),
    [anon_sym_downcast] = ACTIONS(3759),
    [anon_sym_COLON_GT] = ACTIONS(3757),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3757),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_fun] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_match] = ACTIONS(3759),
    [anon_sym_match_BANG] = ACTIONS(3757),
    [anon_sym_function] = ACTIONS(3759),
    [anon_sym_LT_DASH] = ACTIONS(3759),
    [anon_sym_DOT_LBRACK] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_use] = ACTIONS(3759),
    [anon_sym_use_BANG] = ACTIONS(3757),
    [anon_sym_do_BANG] = ACTIONS(3757),
    [anon_sym_begin] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_or] = ACTIONS(3759),
    [aux_sym_char_token1] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3759),
    [anon_sym_DQUOTE] = ACTIONS(3759),
    [anon_sym_AT_DQUOTE] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [sym_bool] = ACTIONS(3759),
    [sym_unit] = ACTIONS(3757),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3759),
    [sym_op_identifier] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS_DOT] = ACTIONS(3759),
    [anon_sym_DASH_DOT] = ACTIONS(3759),
    [anon_sym_PERCENT] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_TILDE] = ACTIONS(3757),
    [aux_sym_prefix_op_token1] = ACTIONS(3759),
    [aux_sym_infix_op_token1] = ACTIONS(3757),
    [aux_sym_infix_op_token2] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_COLON_EQ] = ACTIONS(3757),
    [anon_sym_DOLLAR] = ACTIONS(3759),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3759),
    [sym_int] = ACTIONS(3759),
    [sym_xint] = ACTIONS(3757),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3757),
    [anon_sym_POUNDendif] = ACTIONS(3757),
    [sym__newline] = ACTIONS(3757),
  },
  [3002] = {
    [sym_block_comment] = STATE(3002),
    [sym_compiler_directive_decl] = STATE(3002),
    [sym_fsi_directive_decl] = STATE(3002),
    [sym_preproc_line] = STATE(3002),
    [aux_sym_long_identifier_repeat1] = STATE(3071),
    [sym_identifier] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3778),
    [anon_sym_COLON] = ACTIONS(3781),
    [anon_sym_return] = ACTIONS(3781),
    [anon_sym_do] = ACTIONS(3781),
    [anon_sym_let] = ACTIONS(3781),
    [anon_sym_let_BANG] = ACTIONS(3778),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3778),
    [anon_sym_null] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3781),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_LT_AT] = ACTIONS(3781),
    [anon_sym_AT_GT] = ACTIONS(3781),
    [anon_sym_LT_AT_AT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(5625),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3778),
    [anon_sym_new] = ACTIONS(3781),
    [anon_sym_return_BANG] = ACTIONS(3778),
    [anon_sym_yield] = ACTIONS(3781),
    [anon_sym_yield_BANG] = ACTIONS(3778),
    [anon_sym_lazy] = ACTIONS(3781),
    [anon_sym_assert] = ACTIONS(3781),
    [anon_sym_upcast] = ACTIONS(3781),
    [anon_sym_downcast] = ACTIONS(3781),
    [anon_sym_COLON_GT] = ACTIONS(3778),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3778),
    [anon_sym_for] = ACTIONS(3781),
    [anon_sym_while] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_fun] = ACTIONS(3781),
    [anon_sym_try] = ACTIONS(3781),
    [anon_sym_match] = ACTIONS(3781),
    [anon_sym_match_BANG] = ACTIONS(3778),
    [anon_sym_function] = ACTIONS(3781),
    [anon_sym_LT_DASH] = ACTIONS(3781),
    [anon_sym_DOT_LBRACK] = ACTIONS(3778),
    [anon_sym_LT] = ACTIONS(3778),
    [anon_sym_use] = ACTIONS(3781),
    [anon_sym_use_BANG] = ACTIONS(3778),
    [anon_sym_do_BANG] = ACTIONS(3778),
    [anon_sym_begin] = ACTIONS(3781),
    [anon_sym_LPAREN2] = ACTIONS(3781),
    [anon_sym_or] = ACTIONS(3781),
    [aux_sym_char_token1] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3781),
    [anon_sym_DQUOTE] = ACTIONS(3781),
    [anon_sym_AT_DQUOTE] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [sym_bool] = ACTIONS(3781),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3781),
    [sym_op_identifier] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3781),
    [anon_sym_DASH] = ACTIONS(3781),
    [anon_sym_PLUS_DOT] = ACTIONS(3781),
    [anon_sym_DASH_DOT] = ACTIONS(3781),
    [anon_sym_PERCENT] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3781),
    [anon_sym_TILDE] = ACTIONS(3778),
    [aux_sym_prefix_op_token1] = ACTIONS(3781),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token2] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_COLON_EQ] = ACTIONS(3778),
    [anon_sym_DOLLAR] = ACTIONS(3781),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3781),
    [sym_int] = ACTIONS(3781),
    [sym_xint] = ACTIONS(3778),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3778),
    [sym__newline] = ACTIONS(3778),
  },
  [3003] = {
    [sym_block_comment] = STATE(3003),
    [sym_compiler_directive_decl] = STATE(3003),
    [sym_fsi_directive_decl] = STATE(3003),
    [sym_preproc_line] = STATE(3003),
    [sym_identifier] = ACTIONS(4064),
    [anon_sym_EQ] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4064),
    [anon_sym_return] = ACTIONS(4064),
    [anon_sym_do] = ACTIONS(4064),
    [anon_sym_let] = ACTIONS(4064),
    [anon_sym_let_BANG] = ACTIONS(4062),
    [anon_sym_as] = ACTIONS(4064),
    [anon_sym_LPAREN] = ACTIONS(4064),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_null] = ACTIONS(4064),
    [anon_sym_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_COLON] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4062),
    [anon_sym_LBRACE] = ACTIONS(4064),
    [anon_sym_LT_AT] = ACTIONS(4064),
    [anon_sym_LT_AT_AT] = ACTIONS(4064),
    [anon_sym_DOT] = ACTIONS(4064),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4062),
    [anon_sym_new] = ACTIONS(4064),
    [anon_sym_with] = ACTIONS(4064),
    [anon_sym_return_BANG] = ACTIONS(4062),
    [anon_sym_yield] = ACTIONS(4064),
    [anon_sym_yield_BANG] = ACTIONS(4062),
    [anon_sym_lazy] = ACTIONS(4064),
    [anon_sym_assert] = ACTIONS(4064),
    [anon_sym_upcast] = ACTIONS(4064),
    [anon_sym_downcast] = ACTIONS(4064),
    [anon_sym_COLON_GT] = ACTIONS(4062),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4062),
    [anon_sym_for] = ACTIONS(4064),
    [anon_sym_while] = ACTIONS(4064),
    [anon_sym_if] = ACTIONS(4064),
    [anon_sym_fun] = ACTIONS(4064),
    [anon_sym_try] = ACTIONS(4064),
    [anon_sym_match] = ACTIONS(4064),
    [anon_sym_match_BANG] = ACTIONS(4062),
    [anon_sym_function] = ACTIONS(4064),
    [anon_sym_LT_DASH] = ACTIONS(4064),
    [anon_sym_DOT_LBRACK] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(4062),
    [anon_sym_use] = ACTIONS(4064),
    [anon_sym_use_BANG] = ACTIONS(4062),
    [anon_sym_do_BANG] = ACTIONS(4062),
    [anon_sym_begin] = ACTIONS(4064),
    [anon_sym_LPAREN2] = ACTIONS(4064),
    [anon_sym_or] = ACTIONS(4064),
    [aux_sym_char_token1] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_AT_DQUOTE] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [sym_bool] = ACTIONS(4064),
    [sym_unit] = ACTIONS(4062),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4064),
    [sym_op_identifier] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4064),
    [anon_sym_DASH] = ACTIONS(4064),
    [anon_sym_PLUS_DOT] = ACTIONS(4064),
    [anon_sym_DASH_DOT] = ACTIONS(4064),
    [anon_sym_PERCENT] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_TILDE] = ACTIONS(4062),
    [aux_sym_prefix_op_token1] = ACTIONS(4064),
    [aux_sym_infix_op_token1] = ACTIONS(4062),
    [aux_sym_infix_op_token2] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_BANG_EQ] = ACTIONS(4064),
    [anon_sym_COLON_EQ] = ACTIONS(4062),
    [anon_sym_DOLLAR] = ACTIONS(4064),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4064),
    [sym_int] = ACTIONS(4064),
    [sym_xint] = ACTIONS(4062),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4062),
    [sym__newline] = ACTIONS(4062),
  },
  [3004] = {
    [sym_block_comment] = STATE(3004),
    [sym_compiler_directive_decl] = STATE(3004),
    [sym_fsi_directive_decl] = STATE(3004),
    [sym_preproc_line] = STATE(3004),
    [sym_identifier] = ACTIONS(4064),
    [anon_sym_EQ] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4064),
    [anon_sym_return] = ACTIONS(4064),
    [anon_sym_do] = ACTIONS(4064),
    [anon_sym_let] = ACTIONS(4064),
    [anon_sym_let_BANG] = ACTIONS(4062),
    [anon_sym_LPAREN] = ACTIONS(4064),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_null] = ACTIONS(4064),
    [anon_sym_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_COLON] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4062),
    [anon_sym_LBRACE] = ACTIONS(4064),
    [anon_sym_LT_AT] = ACTIONS(4064),
    [anon_sym_LT_AT_AT] = ACTIONS(4064),
    [anon_sym_DOT] = ACTIONS(4064),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4062),
    [anon_sym_new] = ACTIONS(4064),
    [anon_sym_return_BANG] = ACTIONS(4062),
    [anon_sym_yield] = ACTIONS(4064),
    [anon_sym_yield_BANG] = ACTIONS(4062),
    [anon_sym_lazy] = ACTIONS(4064),
    [anon_sym_assert] = ACTIONS(4064),
    [anon_sym_upcast] = ACTIONS(4064),
    [anon_sym_downcast] = ACTIONS(4064),
    [anon_sym_COLON_GT] = ACTIONS(4062),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4062),
    [anon_sym_for] = ACTIONS(4064),
    [anon_sym_while] = ACTIONS(4064),
    [anon_sym_if] = ACTIONS(4064),
    [anon_sym_fun] = ACTIONS(4064),
    [anon_sym_DASH_GT] = ACTIONS(4064),
    [anon_sym_try] = ACTIONS(4064),
    [anon_sym_match] = ACTIONS(4064),
    [anon_sym_match_BANG] = ACTIONS(4062),
    [anon_sym_function] = ACTIONS(4064),
    [anon_sym_LT_DASH] = ACTIONS(4064),
    [anon_sym_DOT_LBRACK] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(4062),
    [anon_sym_use] = ACTIONS(4064),
    [anon_sym_use_BANG] = ACTIONS(4062),
    [anon_sym_do_BANG] = ACTIONS(4062),
    [anon_sym_DOT_DOT] = ACTIONS(4062),
    [anon_sym_begin] = ACTIONS(4064),
    [anon_sym_LPAREN2] = ACTIONS(4064),
    [anon_sym_or] = ACTIONS(4064),
    [aux_sym_char_token1] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_AT_DQUOTE] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [sym_bool] = ACTIONS(4064),
    [sym_unit] = ACTIONS(4062),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4064),
    [sym_op_identifier] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4064),
    [anon_sym_DASH] = ACTIONS(4064),
    [anon_sym_PLUS_DOT] = ACTIONS(4064),
    [anon_sym_DASH_DOT] = ACTIONS(4064),
    [anon_sym_PERCENT] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_TILDE] = ACTIONS(4062),
    [aux_sym_prefix_op_token1] = ACTIONS(4064),
    [aux_sym_infix_op_token1] = ACTIONS(4062),
    [aux_sym_infix_op_token2] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_BANG_EQ] = ACTIONS(4064),
    [anon_sym_COLON_EQ] = ACTIONS(4062),
    [anon_sym_DOLLAR] = ACTIONS(4064),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4064),
    [sym_int] = ACTIONS(4064),
    [sym_xint] = ACTIONS(4062),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4062),
    [sym__newline] = ACTIONS(4062),
  },
  [3005] = {
    [sym_block_comment] = STATE(3005),
    [sym_compiler_directive_decl] = STATE(3005),
    [sym_fsi_directive_decl] = STATE(3005),
    [sym_preproc_line] = STATE(3005),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_AT_AT_GT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_or] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [sym__newline] = ACTIONS(3741),
  },
  [3006] = {
    [sym_block_comment] = STATE(3006),
    [sym_compiler_directive_decl] = STATE(3006),
    [sym_fsi_directive_decl] = STATE(3006),
    [sym_preproc_line] = STATE(3006),
    [sym_identifier] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4078),
    [anon_sym_return] = ACTIONS(4078),
    [anon_sym_do] = ACTIONS(4078),
    [anon_sym_let] = ACTIONS(4078),
    [anon_sym_let_BANG] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_null] = ACTIONS(4078),
    [anon_sym_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(4076),
    [anon_sym_AMP] = ACTIONS(4078),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4078),
    [anon_sym_LT_AT] = ACTIONS(4078),
    [anon_sym_LT_AT_AT] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(4078),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4076),
    [anon_sym_new] = ACTIONS(4078),
    [anon_sym_return_BANG] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(4078),
    [anon_sym_yield_BANG] = ACTIONS(4076),
    [anon_sym_lazy] = ACTIONS(4078),
    [anon_sym_assert] = ACTIONS(4078),
    [anon_sym_upcast] = ACTIONS(4078),
    [anon_sym_downcast] = ACTIONS(4078),
    [anon_sym_COLON_GT] = ACTIONS(4076),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4076),
    [anon_sym_for] = ACTIONS(4078),
    [anon_sym_while] = ACTIONS(4078),
    [anon_sym_if] = ACTIONS(4078),
    [anon_sym_fun] = ACTIONS(4078),
    [anon_sym_DASH_GT] = ACTIONS(4078),
    [anon_sym_try] = ACTIONS(4078),
    [anon_sym_match] = ACTIONS(4078),
    [anon_sym_match_BANG] = ACTIONS(4076),
    [anon_sym_function] = ACTIONS(4078),
    [anon_sym_LT_DASH] = ACTIONS(4078),
    [anon_sym_DOT_LBRACK] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4076),
    [anon_sym_use] = ACTIONS(4078),
    [anon_sym_use_BANG] = ACTIONS(4076),
    [anon_sym_do_BANG] = ACTIONS(4076),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_begin] = ACTIONS(4078),
    [anon_sym_LPAREN2] = ACTIONS(4078),
    [anon_sym_or] = ACTIONS(4078),
    [aux_sym_char_token1] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4078),
    [anon_sym_DQUOTE] = ACTIONS(4078),
    [anon_sym_AT_DQUOTE] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [sym_bool] = ACTIONS(4078),
    [sym_unit] = ACTIONS(4076),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4078),
    [sym_op_identifier] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(4078),
    [anon_sym_PLUS_DOT] = ACTIONS(4078),
    [anon_sym_DASH_DOT] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [anon_sym_AMP_AMP] = ACTIONS(4078),
    [anon_sym_TILDE] = ACTIONS(4076),
    [aux_sym_prefix_op_token1] = ACTIONS(4078),
    [aux_sym_infix_op_token1] = ACTIONS(4076),
    [aux_sym_infix_op_token2] = ACTIONS(4078),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_BANG_EQ] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4076),
    [anon_sym_DOLLAR] = ACTIONS(4078),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4078),
    [sym_int] = ACTIONS(4078),
    [sym_xint] = ACTIONS(4076),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4076),
    [sym__newline] = ACTIONS(4076),
  },
  [3007] = {
    [sym_block_comment] = STATE(3007),
    [sym_compiler_directive_decl] = STATE(3007),
    [sym_fsi_directive_decl] = STATE(3007),
    [sym_preproc_line] = STATE(3007),
    [sym_identifier] = ACTIONS(3976),
    [anon_sym_EQ] = ACTIONS(3974),
    [anon_sym_COLON] = ACTIONS(3976),
    [anon_sym_return] = ACTIONS(3976),
    [anon_sym_do] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_let_BANG] = ACTIONS(3974),
    [anon_sym_as] = ACTIONS(3976),
    [anon_sym_LPAREN] = ACTIONS(3976),
    [anon_sym_COMMA] = ACTIONS(3974),
    [anon_sym_null] = ACTIONS(3976),
    [anon_sym_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_COLON] = ACTIONS(3974),
    [anon_sym_AMP] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(3976),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3974),
    [anon_sym_LBRACE] = ACTIONS(3976),
    [anon_sym_LT_AT] = ACTIONS(3976),
    [anon_sym_LT_AT_AT] = ACTIONS(3976),
    [anon_sym_DOT] = ACTIONS(3976),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3974),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_with] = ACTIONS(3976),
    [anon_sym_return_BANG] = ACTIONS(3974),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_yield_BANG] = ACTIONS(3974),
    [anon_sym_lazy] = ACTIONS(3976),
    [anon_sym_assert] = ACTIONS(3976),
    [anon_sym_upcast] = ACTIONS(3976),
    [anon_sym_downcast] = ACTIONS(3976),
    [anon_sym_COLON_GT] = ACTIONS(3974),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3974),
    [anon_sym_for] = ACTIONS(3976),
    [anon_sym_while] = ACTIONS(3976),
    [anon_sym_if] = ACTIONS(3976),
    [anon_sym_fun] = ACTIONS(3976),
    [anon_sym_try] = ACTIONS(3976),
    [anon_sym_match] = ACTIONS(3976),
    [anon_sym_match_BANG] = ACTIONS(3974),
    [anon_sym_function] = ACTIONS(3976),
    [anon_sym_LT_DASH] = ACTIONS(3976),
    [anon_sym_DOT_LBRACK] = ACTIONS(3974),
    [anon_sym_LT] = ACTIONS(3974),
    [anon_sym_use] = ACTIONS(3976),
    [anon_sym_use_BANG] = ACTIONS(3974),
    [anon_sym_do_BANG] = ACTIONS(3974),
    [anon_sym_begin] = ACTIONS(3976),
    [anon_sym_LPAREN2] = ACTIONS(3976),
    [anon_sym_or] = ACTIONS(3976),
    [aux_sym_char_token1] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3976),
    [anon_sym_DQUOTE] = ACTIONS(3976),
    [anon_sym_AT_DQUOTE] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [sym_bool] = ACTIONS(3976),
    [sym_unit] = ACTIONS(3974),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3976),
    [sym_op_identifier] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3976),
    [anon_sym_DASH] = ACTIONS(3976),
    [anon_sym_PLUS_DOT] = ACTIONS(3976),
    [anon_sym_DASH_DOT] = ACTIONS(3976),
    [anon_sym_PERCENT] = ACTIONS(3976),
    [anon_sym_AMP_AMP] = ACTIONS(3976),
    [anon_sym_TILDE] = ACTIONS(3974),
    [aux_sym_prefix_op_token1] = ACTIONS(3976),
    [aux_sym_infix_op_token1] = ACTIONS(3974),
    [aux_sym_infix_op_token2] = ACTIONS(3976),
    [anon_sym_PIPE_PIPE] = ACTIONS(3976),
    [anon_sym_BANG_EQ] = ACTIONS(3976),
    [anon_sym_COLON_EQ] = ACTIONS(3974),
    [anon_sym_DOLLAR] = ACTIONS(3976),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3976),
    [sym_int] = ACTIONS(3976),
    [sym_xint] = ACTIONS(3974),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3974),
    [sym__newline] = ACTIONS(3974),
  },
  [3008] = {
    [sym_block_comment] = STATE(3008),
    [sym_compiler_directive_decl] = STATE(3008),
    [sym_fsi_directive_decl] = STATE(3008),
    [sym_preproc_line] = STATE(3008),
    [aux_sym_long_identifier_repeat1] = STATE(3181),
    [sym_identifier] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3778),
    [anon_sym_COLON] = ACTIONS(3781),
    [anon_sym_return] = ACTIONS(3781),
    [anon_sym_do] = ACTIONS(3781),
    [anon_sym_let] = ACTIONS(3781),
    [anon_sym_let_BANG] = ACTIONS(3778),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3778),
    [anon_sym_null] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3781),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_LT_AT] = ACTIONS(3781),
    [anon_sym_LT_AT_AT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(5629),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3778),
    [anon_sym_new] = ACTIONS(3781),
    [anon_sym_return_BANG] = ACTIONS(3778),
    [anon_sym_yield] = ACTIONS(3781),
    [anon_sym_yield_BANG] = ACTIONS(3778),
    [anon_sym_lazy] = ACTIONS(3781),
    [anon_sym_assert] = ACTIONS(3781),
    [anon_sym_upcast] = ACTIONS(3781),
    [anon_sym_downcast] = ACTIONS(3781),
    [anon_sym_COLON_GT] = ACTIONS(3778),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3778),
    [anon_sym_for] = ACTIONS(3781),
    [anon_sym_while] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_fun] = ACTIONS(3781),
    [anon_sym_try] = ACTIONS(3781),
    [anon_sym_match] = ACTIONS(3781),
    [anon_sym_match_BANG] = ACTIONS(3778),
    [anon_sym_function] = ACTIONS(3781),
    [anon_sym_LT_DASH] = ACTIONS(3781),
    [anon_sym_DOT_LBRACK] = ACTIONS(3778),
    [anon_sym_LT] = ACTIONS(3778),
    [anon_sym_use] = ACTIONS(3781),
    [anon_sym_use_BANG] = ACTIONS(3778),
    [anon_sym_do_BANG] = ACTIONS(3778),
    [anon_sym_DOT_DOT] = ACTIONS(3778),
    [anon_sym_begin] = ACTIONS(3781),
    [anon_sym_LPAREN2] = ACTIONS(3781),
    [anon_sym_or] = ACTIONS(3781),
    [aux_sym_char_token1] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3781),
    [anon_sym_DQUOTE] = ACTIONS(3781),
    [anon_sym_AT_DQUOTE] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [sym_bool] = ACTIONS(3781),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3781),
    [sym_op_identifier] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3781),
    [anon_sym_DASH] = ACTIONS(3781),
    [anon_sym_PLUS_DOT] = ACTIONS(3781),
    [anon_sym_DASH_DOT] = ACTIONS(3781),
    [anon_sym_PERCENT] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3781),
    [anon_sym_TILDE] = ACTIONS(3778),
    [aux_sym_prefix_op_token1] = ACTIONS(3781),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token2] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_COLON_EQ] = ACTIONS(3778),
    [anon_sym_DOLLAR] = ACTIONS(3781),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3781),
    [sym_int] = ACTIONS(3781),
    [sym_xint] = ACTIONS(3778),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3778),
    [sym__newline] = ACTIONS(3778),
  },
  [3009] = {
    [sym_block_comment] = STATE(3009),
    [sym_compiler_directive_decl] = STATE(3009),
    [sym_fsi_directive_decl] = STATE(3009),
    [sym_preproc_line] = STATE(3009),
    [sym_identifier] = ACTIONS(3907),
    [anon_sym_EQ] = ACTIONS(3905),
    [anon_sym_COLON] = ACTIONS(3907),
    [anon_sym_return] = ACTIONS(3907),
    [anon_sym_do] = ACTIONS(3907),
    [anon_sym_let] = ACTIONS(3907),
    [anon_sym_let_BANG] = ACTIONS(3905),
    [anon_sym_as] = ACTIONS(3907),
    [anon_sym_LPAREN] = ACTIONS(3907),
    [anon_sym_COMMA] = ACTIONS(3905),
    [anon_sym_null] = ACTIONS(3907),
    [anon_sym_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_COLON] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3907),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3905),
    [anon_sym_LBRACE] = ACTIONS(3907),
    [anon_sym_LT_AT] = ACTIONS(3907),
    [anon_sym_LT_AT_AT] = ACTIONS(3907),
    [anon_sym_DOT] = ACTIONS(3907),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3905),
    [anon_sym_new] = ACTIONS(3907),
    [anon_sym_with] = ACTIONS(3907),
    [anon_sym_return_BANG] = ACTIONS(3905),
    [anon_sym_yield] = ACTIONS(3907),
    [anon_sym_yield_BANG] = ACTIONS(3905),
    [anon_sym_lazy] = ACTIONS(3907),
    [anon_sym_assert] = ACTIONS(3907),
    [anon_sym_upcast] = ACTIONS(3907),
    [anon_sym_downcast] = ACTIONS(3907),
    [anon_sym_COLON_GT] = ACTIONS(3905),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3905),
    [anon_sym_for] = ACTIONS(3907),
    [anon_sym_while] = ACTIONS(3907),
    [anon_sym_if] = ACTIONS(3907),
    [anon_sym_fun] = ACTIONS(3907),
    [anon_sym_try] = ACTIONS(3907),
    [anon_sym_match] = ACTIONS(3907),
    [anon_sym_match_BANG] = ACTIONS(3905),
    [anon_sym_function] = ACTIONS(3907),
    [anon_sym_LT_DASH] = ACTIONS(3907),
    [anon_sym_DOT_LBRACK] = ACTIONS(3905),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_use] = ACTIONS(3907),
    [anon_sym_use_BANG] = ACTIONS(3905),
    [anon_sym_do_BANG] = ACTIONS(3905),
    [anon_sym_begin] = ACTIONS(3907),
    [anon_sym_LPAREN2] = ACTIONS(3907),
    [anon_sym_or] = ACTIONS(3907),
    [aux_sym_char_token1] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3907),
    [anon_sym_DQUOTE] = ACTIONS(3907),
    [anon_sym_AT_DQUOTE] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [sym_bool] = ACTIONS(3907),
    [sym_unit] = ACTIONS(3905),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3907),
    [sym_op_identifier] = ACTIONS(3907),
    [anon_sym_PLUS] = ACTIONS(3907),
    [anon_sym_DASH] = ACTIONS(3907),
    [anon_sym_PLUS_DOT] = ACTIONS(3907),
    [anon_sym_DASH_DOT] = ACTIONS(3907),
    [anon_sym_PERCENT] = ACTIONS(3907),
    [anon_sym_AMP_AMP] = ACTIONS(3907),
    [anon_sym_TILDE] = ACTIONS(3905),
    [aux_sym_prefix_op_token1] = ACTIONS(3907),
    [aux_sym_infix_op_token1] = ACTIONS(3905),
    [aux_sym_infix_op_token2] = ACTIONS(3907),
    [anon_sym_PIPE_PIPE] = ACTIONS(3907),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_COLON_EQ] = ACTIONS(3905),
    [anon_sym_DOLLAR] = ACTIONS(3907),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3907),
    [sym_int] = ACTIONS(3907),
    [sym_xint] = ACTIONS(3905),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3905),
    [sym__newline] = ACTIONS(3905),
  },
  [3010] = {
    [sym_block_comment] = STATE(3010),
    [sym_compiler_directive_decl] = STATE(3010),
    [sym_fsi_directive_decl] = STATE(3010),
    [sym_preproc_line] = STATE(3010),
    [sym_identifier] = ACTIONS(3900),
    [anon_sym_EQ] = ACTIONS(3898),
    [anon_sym_COLON] = ACTIONS(3900),
    [anon_sym_return] = ACTIONS(3900),
    [anon_sym_do] = ACTIONS(3900),
    [anon_sym_let] = ACTIONS(3900),
    [anon_sym_let_BANG] = ACTIONS(3898),
    [anon_sym_as] = ACTIONS(3900),
    [anon_sym_LPAREN] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3898),
    [anon_sym_null] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_COLON] = ACTIONS(3898),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_LBRACK] = ACTIONS(3900),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3898),
    [anon_sym_LBRACE] = ACTIONS(3900),
    [anon_sym_LT_AT] = ACTIONS(3900),
    [anon_sym_LT_AT_AT] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(3900),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3898),
    [anon_sym_new] = ACTIONS(3900),
    [anon_sym_with] = ACTIONS(3900),
    [anon_sym_return_BANG] = ACTIONS(3898),
    [anon_sym_yield] = ACTIONS(3900),
    [anon_sym_yield_BANG] = ACTIONS(3898),
    [anon_sym_lazy] = ACTIONS(3900),
    [anon_sym_assert] = ACTIONS(3900),
    [anon_sym_upcast] = ACTIONS(3900),
    [anon_sym_downcast] = ACTIONS(3900),
    [anon_sym_COLON_GT] = ACTIONS(3898),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3898),
    [anon_sym_for] = ACTIONS(3900),
    [anon_sym_while] = ACTIONS(3900),
    [anon_sym_if] = ACTIONS(3900),
    [anon_sym_fun] = ACTIONS(3900),
    [anon_sym_try] = ACTIONS(3900),
    [anon_sym_match] = ACTIONS(3900),
    [anon_sym_match_BANG] = ACTIONS(3898),
    [anon_sym_function] = ACTIONS(3900),
    [anon_sym_LT_DASH] = ACTIONS(3900),
    [anon_sym_DOT_LBRACK] = ACTIONS(3898),
    [anon_sym_LT] = ACTIONS(3898),
    [anon_sym_use] = ACTIONS(3900),
    [anon_sym_use_BANG] = ACTIONS(3898),
    [anon_sym_do_BANG] = ACTIONS(3898),
    [anon_sym_begin] = ACTIONS(3900),
    [anon_sym_LPAREN2] = ACTIONS(3900),
    [anon_sym_or] = ACTIONS(3900),
    [aux_sym_char_token1] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3900),
    [anon_sym_DQUOTE] = ACTIONS(3900),
    [anon_sym_AT_DQUOTE] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3898),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3900),
    [sym_op_identifier] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(3900),
    [anon_sym_DASH] = ACTIONS(3900),
    [anon_sym_PLUS_DOT] = ACTIONS(3900),
    [anon_sym_DASH_DOT] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(3900),
    [anon_sym_AMP_AMP] = ACTIONS(3900),
    [anon_sym_TILDE] = ACTIONS(3898),
    [aux_sym_prefix_op_token1] = ACTIONS(3900),
    [aux_sym_infix_op_token1] = ACTIONS(3898),
    [aux_sym_infix_op_token2] = ACTIONS(3900),
    [anon_sym_PIPE_PIPE] = ACTIONS(3900),
    [anon_sym_BANG_EQ] = ACTIONS(3900),
    [anon_sym_COLON_EQ] = ACTIONS(3898),
    [anon_sym_DOLLAR] = ACTIONS(3900),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3900),
    [sym_int] = ACTIONS(3900),
    [sym_xint] = ACTIONS(3898),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3898),
    [sym__newline] = ACTIONS(3898),
  },
  [3011] = {
    [sym_block_comment] = STATE(3011),
    [sym_compiler_directive_decl] = STATE(3011),
    [sym_fsi_directive_decl] = STATE(3011),
    [sym_preproc_line] = STATE(3011),
    [sym_identifier] = ACTIONS(3893),
    [anon_sym_EQ] = ACTIONS(3891),
    [anon_sym_COLON] = ACTIONS(3893),
    [anon_sym_return] = ACTIONS(3893),
    [anon_sym_do] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_let_BANG] = ACTIONS(3891),
    [anon_sym_as] = ACTIONS(3893),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_COMMA] = ACTIONS(3891),
    [anon_sym_null] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_COLON] = ACTIONS(3891),
    [anon_sym_AMP] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3891),
    [anon_sym_LBRACE] = ACTIONS(3893),
    [anon_sym_LT_AT] = ACTIONS(3893),
    [anon_sym_LT_AT_AT] = ACTIONS(3893),
    [anon_sym_DOT] = ACTIONS(3893),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3891),
    [anon_sym_new] = ACTIONS(3893),
    [anon_sym_with] = ACTIONS(3893),
    [anon_sym_return_BANG] = ACTIONS(3891),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_yield_BANG] = ACTIONS(3891),
    [anon_sym_lazy] = ACTIONS(3893),
    [anon_sym_assert] = ACTIONS(3893),
    [anon_sym_upcast] = ACTIONS(3893),
    [anon_sym_downcast] = ACTIONS(3893),
    [anon_sym_COLON_GT] = ACTIONS(3891),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3891),
    [anon_sym_for] = ACTIONS(3893),
    [anon_sym_while] = ACTIONS(3893),
    [anon_sym_if] = ACTIONS(3893),
    [anon_sym_fun] = ACTIONS(3893),
    [anon_sym_try] = ACTIONS(3893),
    [anon_sym_match] = ACTIONS(3893),
    [anon_sym_match_BANG] = ACTIONS(3891),
    [anon_sym_function] = ACTIONS(3893),
    [anon_sym_LT_DASH] = ACTIONS(3893),
    [anon_sym_DOT_LBRACK] = ACTIONS(3891),
    [anon_sym_LT] = ACTIONS(3891),
    [anon_sym_use] = ACTIONS(3893),
    [anon_sym_use_BANG] = ACTIONS(3891),
    [anon_sym_do_BANG] = ACTIONS(3891),
    [anon_sym_begin] = ACTIONS(3893),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_or] = ACTIONS(3893),
    [aux_sym_char_token1] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3893),
    [anon_sym_DQUOTE] = ACTIONS(3893),
    [anon_sym_AT_DQUOTE] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [sym_bool] = ACTIONS(3893),
    [sym_unit] = ACTIONS(3891),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3893),
    [sym_op_identifier] = ACTIONS(3893),
    [anon_sym_PLUS] = ACTIONS(3893),
    [anon_sym_DASH] = ACTIONS(3893),
    [anon_sym_PLUS_DOT] = ACTIONS(3893),
    [anon_sym_DASH_DOT] = ACTIONS(3893),
    [anon_sym_PERCENT] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_TILDE] = ACTIONS(3891),
    [aux_sym_prefix_op_token1] = ACTIONS(3893),
    [aux_sym_infix_op_token1] = ACTIONS(3891),
    [aux_sym_infix_op_token2] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [anon_sym_BANG_EQ] = ACTIONS(3893),
    [anon_sym_COLON_EQ] = ACTIONS(3891),
    [anon_sym_DOLLAR] = ACTIONS(3893),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3893),
    [sym_int] = ACTIONS(3893),
    [sym_xint] = ACTIONS(3891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3891),
    [sym__newline] = ACTIONS(3891),
  },
  [3012] = {
    [sym_block_comment] = STATE(3012),
    [sym_compiler_directive_decl] = STATE(3012),
    [sym_fsi_directive_decl] = STATE(3012),
    [sym_preproc_line] = STATE(3012),
    [sym_identifier] = ACTIONS(3813),
    [anon_sym_EQ] = ACTIONS(3811),
    [anon_sym_COLON] = ACTIONS(3813),
    [anon_sym_return] = ACTIONS(3813),
    [anon_sym_do] = ACTIONS(3813),
    [anon_sym_let] = ACTIONS(3813),
    [anon_sym_let_BANG] = ACTIONS(3811),
    [anon_sym_LPAREN] = ACTIONS(3813),
    [anon_sym_COMMA] = ACTIONS(3811),
    [anon_sym_null] = ACTIONS(3813),
    [anon_sym_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_COLON] = ACTIONS(3811),
    [anon_sym_AMP] = ACTIONS(3813),
    [anon_sym_LBRACK] = ACTIONS(3813),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3811),
    [anon_sym_LBRACE] = ACTIONS(3813),
    [anon_sym_LT_AT] = ACTIONS(3813),
    [anon_sym_AT_GT] = ACTIONS(3813),
    [anon_sym_LT_AT_AT] = ACTIONS(3813),
    [anon_sym_DOT] = ACTIONS(3813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3811),
    [anon_sym_new] = ACTIONS(3813),
    [anon_sym_return_BANG] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_yield_BANG] = ACTIONS(3811),
    [anon_sym_lazy] = ACTIONS(3813),
    [anon_sym_assert] = ACTIONS(3813),
    [anon_sym_upcast] = ACTIONS(3813),
    [anon_sym_downcast] = ACTIONS(3813),
    [anon_sym_COLON_GT] = ACTIONS(3811),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3811),
    [anon_sym_for] = ACTIONS(3813),
    [anon_sym_done] = ACTIONS(5633),
    [anon_sym_while] = ACTIONS(3813),
    [anon_sym_if] = ACTIONS(3813),
    [anon_sym_fun] = ACTIONS(3813),
    [anon_sym_try] = ACTIONS(3813),
    [anon_sym_match] = ACTIONS(3813),
    [anon_sym_match_BANG] = ACTIONS(3811),
    [anon_sym_function] = ACTIONS(3813),
    [anon_sym_LT_DASH] = ACTIONS(3813),
    [anon_sym_DOT_LBRACK] = ACTIONS(3811),
    [anon_sym_LT] = ACTIONS(3811),
    [anon_sym_use] = ACTIONS(3813),
    [anon_sym_use_BANG] = ACTIONS(3811),
    [anon_sym_do_BANG] = ACTIONS(3811),
    [anon_sym_begin] = ACTIONS(3813),
    [anon_sym_LPAREN2] = ACTIONS(3813),
    [anon_sym_or] = ACTIONS(3813),
    [aux_sym_char_token1] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3813),
    [anon_sym_DQUOTE] = ACTIONS(3813),
    [anon_sym_AT_DQUOTE] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [sym_bool] = ACTIONS(3813),
    [sym_unit] = ACTIONS(3811),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3813),
    [sym_op_identifier] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PLUS_DOT] = ACTIONS(3813),
    [anon_sym_DASH_DOT] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3813),
    [anon_sym_AMP_AMP] = ACTIONS(3813),
    [anon_sym_TILDE] = ACTIONS(3811),
    [aux_sym_prefix_op_token1] = ACTIONS(3813),
    [aux_sym_infix_op_token1] = ACTIONS(3811),
    [aux_sym_infix_op_token2] = ACTIONS(3813),
    [anon_sym_PIPE_PIPE] = ACTIONS(3813),
    [anon_sym_BANG_EQ] = ACTIONS(3813),
    [anon_sym_COLON_EQ] = ACTIONS(3811),
    [anon_sym_DOLLAR] = ACTIONS(3813),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3813),
    [sym_int] = ACTIONS(3813),
    [sym_xint] = ACTIONS(3811),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3811),
    [sym__newline] = ACTIONS(3811),
  },
  [3013] = {
    [sym_block_comment] = STATE(3013),
    [sym_compiler_directive_decl] = STATE(3013),
    [sym_fsi_directive_decl] = STATE(3013),
    [sym_preproc_line] = STATE(3013),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(5635),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_DOT_DOT] = ACTIONS(3683),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
  },
  [3014] = {
    [sym_block_comment] = STATE(3014),
    [sym_compiler_directive_decl] = STATE(3014),
    [sym_fsi_directive_decl] = STATE(3014),
    [sym_preproc_line] = STATE(3014),
    [sym_identifier] = ACTIONS(4137),
    [anon_sym_EQ] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4137),
    [anon_sym_return] = ACTIONS(4137),
    [anon_sym_do] = ACTIONS(4137),
    [anon_sym_let] = ACTIONS(4137),
    [anon_sym_let_BANG] = ACTIONS(4135),
    [anon_sym_LPAREN] = ACTIONS(4137),
    [anon_sym_COMMA] = ACTIONS(4135),
    [anon_sym_null] = ACTIONS(4137),
    [anon_sym_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_COLON] = ACTIONS(4135),
    [anon_sym_AMP] = ACTIONS(4137),
    [anon_sym_LBRACK] = ACTIONS(4137),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4135),
    [anon_sym_LBRACE] = ACTIONS(4137),
    [anon_sym_LT_AT] = ACTIONS(4137),
    [anon_sym_LT_AT_AT] = ACTIONS(4137),
    [anon_sym_DOT] = ACTIONS(4137),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4135),
    [anon_sym_new] = ACTIONS(4137),
    [anon_sym_return_BANG] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_yield_BANG] = ACTIONS(4135),
    [anon_sym_lazy] = ACTIONS(4137),
    [anon_sym_assert] = ACTIONS(4137),
    [anon_sym_upcast] = ACTIONS(4137),
    [anon_sym_downcast] = ACTIONS(4137),
    [anon_sym_COLON_GT] = ACTIONS(4135),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4135),
    [anon_sym_for] = ACTIONS(4137),
    [anon_sym_while] = ACTIONS(4137),
    [anon_sym_if] = ACTIONS(4137),
    [anon_sym_fun] = ACTIONS(4137),
    [anon_sym_DASH_GT] = ACTIONS(4137),
    [anon_sym_try] = ACTIONS(4137),
    [anon_sym_match] = ACTIONS(4137),
    [anon_sym_match_BANG] = ACTIONS(4135),
    [anon_sym_function] = ACTIONS(4137),
    [anon_sym_LT_DASH] = ACTIONS(4137),
    [anon_sym_DOT_LBRACK] = ACTIONS(4135),
    [anon_sym_LT] = ACTIONS(4135),
    [anon_sym_use] = ACTIONS(4137),
    [anon_sym_use_BANG] = ACTIONS(4135),
    [anon_sym_do_BANG] = ACTIONS(4135),
    [anon_sym_DOT_DOT] = ACTIONS(4135),
    [anon_sym_begin] = ACTIONS(4137),
    [anon_sym_LPAREN2] = ACTIONS(4137),
    [anon_sym_or] = ACTIONS(4137),
    [aux_sym_char_token1] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4137),
    [anon_sym_DQUOTE] = ACTIONS(4137),
    [anon_sym_AT_DQUOTE] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [sym_bool] = ACTIONS(4137),
    [sym_unit] = ACTIONS(4135),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4137),
    [sym_op_identifier] = ACTIONS(4137),
    [anon_sym_PLUS] = ACTIONS(4137),
    [anon_sym_DASH] = ACTIONS(4137),
    [anon_sym_PLUS_DOT] = ACTIONS(4137),
    [anon_sym_DASH_DOT] = ACTIONS(4137),
    [anon_sym_PERCENT] = ACTIONS(4137),
    [anon_sym_AMP_AMP] = ACTIONS(4137),
    [anon_sym_TILDE] = ACTIONS(4135),
    [aux_sym_prefix_op_token1] = ACTIONS(4137),
    [aux_sym_infix_op_token1] = ACTIONS(4135),
    [aux_sym_infix_op_token2] = ACTIONS(4137),
    [anon_sym_PIPE_PIPE] = ACTIONS(4137),
    [anon_sym_BANG_EQ] = ACTIONS(4137),
    [anon_sym_COLON_EQ] = ACTIONS(4135),
    [anon_sym_DOLLAR] = ACTIONS(4137),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4137),
    [sym_int] = ACTIONS(4137),
    [sym_xint] = ACTIONS(4135),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4135),
    [sym__newline] = ACTIONS(4135),
  },
  [3015] = {
    [sym_block_comment] = STATE(3015),
    [sym_compiler_directive_decl] = STATE(3015),
    [sym_fsi_directive_decl] = STATE(3015),
    [sym_preproc_line] = STATE(3015),
    [sym_identifier] = ACTIONS(3875),
    [anon_sym_EQ] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(3875),
    [anon_sym_return] = ACTIONS(3875),
    [anon_sym_do] = ACTIONS(3875),
    [anon_sym_let] = ACTIONS(3875),
    [anon_sym_let_BANG] = ACTIONS(3873),
    [anon_sym_as] = ACTIONS(3875),
    [anon_sym_LPAREN] = ACTIONS(3875),
    [anon_sym_COMMA] = ACTIONS(3873),
    [anon_sym_null] = ACTIONS(3875),
    [anon_sym_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_COLON] = ACTIONS(3873),
    [anon_sym_AMP] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(3875),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3873),
    [anon_sym_LBRACE] = ACTIONS(3875),
    [anon_sym_LT_AT] = ACTIONS(3875),
    [anon_sym_LT_AT_AT] = ACTIONS(3875),
    [anon_sym_DOT] = ACTIONS(3875),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3873),
    [anon_sym_new] = ACTIONS(3875),
    [anon_sym_with] = ACTIONS(3875),
    [anon_sym_return_BANG] = ACTIONS(3873),
    [anon_sym_yield] = ACTIONS(3875),
    [anon_sym_yield_BANG] = ACTIONS(3873),
    [anon_sym_lazy] = ACTIONS(3875),
    [anon_sym_assert] = ACTIONS(3875),
    [anon_sym_upcast] = ACTIONS(3875),
    [anon_sym_downcast] = ACTIONS(3875),
    [anon_sym_COLON_GT] = ACTIONS(3873),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3873),
    [anon_sym_for] = ACTIONS(3875),
    [anon_sym_while] = ACTIONS(3875),
    [anon_sym_if] = ACTIONS(3875),
    [anon_sym_fun] = ACTIONS(3875),
    [anon_sym_try] = ACTIONS(3875),
    [anon_sym_match] = ACTIONS(3875),
    [anon_sym_match_BANG] = ACTIONS(3873),
    [anon_sym_function] = ACTIONS(3875),
    [anon_sym_LT_DASH] = ACTIONS(3875),
    [anon_sym_DOT_LBRACK] = ACTIONS(3873),
    [anon_sym_LT] = ACTIONS(3873),
    [anon_sym_use] = ACTIONS(3875),
    [anon_sym_use_BANG] = ACTIONS(3873),
    [anon_sym_do_BANG] = ACTIONS(3873),
    [anon_sym_begin] = ACTIONS(3875),
    [anon_sym_LPAREN2] = ACTIONS(3875),
    [anon_sym_or] = ACTIONS(3875),
    [aux_sym_char_token1] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3875),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [anon_sym_AT_DQUOTE] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [sym_bool] = ACTIONS(3875),
    [sym_unit] = ACTIONS(3873),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3875),
    [sym_op_identifier] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS_DOT] = ACTIONS(3875),
    [anon_sym_DASH_DOT] = ACTIONS(3875),
    [anon_sym_PERCENT] = ACTIONS(3875),
    [anon_sym_AMP_AMP] = ACTIONS(3875),
    [anon_sym_TILDE] = ACTIONS(3873),
    [aux_sym_prefix_op_token1] = ACTIONS(3875),
    [aux_sym_infix_op_token1] = ACTIONS(3873),
    [aux_sym_infix_op_token2] = ACTIONS(3875),
    [anon_sym_PIPE_PIPE] = ACTIONS(3875),
    [anon_sym_BANG_EQ] = ACTIONS(3875),
    [anon_sym_COLON_EQ] = ACTIONS(3873),
    [anon_sym_DOLLAR] = ACTIONS(3875),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3875),
    [sym_int] = ACTIONS(3875),
    [sym_xint] = ACTIONS(3873),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3873),
    [sym__newline] = ACTIONS(3873),
  },
  [3016] = {
    [sym_block_comment] = STATE(3016),
    [sym_compiler_directive_decl] = STATE(3016),
    [sym_fsi_directive_decl] = STATE(3016),
    [sym_preproc_line] = STATE(3016),
    [sym_identifier] = ACTIONS(3954),
    [anon_sym_EQ] = ACTIONS(3952),
    [anon_sym_COLON] = ACTIONS(3954),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_do] = ACTIONS(3954),
    [anon_sym_let] = ACTIONS(3954),
    [anon_sym_let_BANG] = ACTIONS(3952),
    [anon_sym_as] = ACTIONS(3954),
    [anon_sym_LPAREN] = ACTIONS(3954),
    [anon_sym_COMMA] = ACTIONS(3952),
    [anon_sym_null] = ACTIONS(3954),
    [anon_sym_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_COLON] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3954),
    [anon_sym_LBRACK] = ACTIONS(3954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(3954),
    [anon_sym_LT_AT] = ACTIONS(3954),
    [anon_sym_LT_AT_AT] = ACTIONS(3954),
    [anon_sym_DOT] = ACTIONS(3954),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3952),
    [anon_sym_new] = ACTIONS(3954),
    [anon_sym_with] = ACTIONS(3954),
    [anon_sym_return_BANG] = ACTIONS(3952),
    [anon_sym_yield] = ACTIONS(3954),
    [anon_sym_yield_BANG] = ACTIONS(3952),
    [anon_sym_lazy] = ACTIONS(3954),
    [anon_sym_assert] = ACTIONS(3954),
    [anon_sym_upcast] = ACTIONS(3954),
    [anon_sym_downcast] = ACTIONS(3954),
    [anon_sym_COLON_GT] = ACTIONS(3952),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3952),
    [anon_sym_for] = ACTIONS(3954),
    [anon_sym_while] = ACTIONS(3954),
    [anon_sym_if] = ACTIONS(3954),
    [anon_sym_fun] = ACTIONS(3954),
    [anon_sym_try] = ACTIONS(3954),
    [anon_sym_match] = ACTIONS(3954),
    [anon_sym_match_BANG] = ACTIONS(3952),
    [anon_sym_function] = ACTIONS(3954),
    [anon_sym_LT_DASH] = ACTIONS(3954),
    [anon_sym_DOT_LBRACK] = ACTIONS(3952),
    [anon_sym_LT] = ACTIONS(3952),
    [anon_sym_use] = ACTIONS(3954),
    [anon_sym_use_BANG] = ACTIONS(3952),
    [anon_sym_do_BANG] = ACTIONS(3952),
    [anon_sym_begin] = ACTIONS(3954),
    [anon_sym_LPAREN2] = ACTIONS(3954),
    [anon_sym_or] = ACTIONS(3954),
    [aux_sym_char_token1] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3954),
    [anon_sym_DQUOTE] = ACTIONS(3954),
    [anon_sym_AT_DQUOTE] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [sym_bool] = ACTIONS(3954),
    [sym_unit] = ACTIONS(3952),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3954),
    [sym_op_identifier] = ACTIONS(3954),
    [anon_sym_PLUS] = ACTIONS(3954),
    [anon_sym_DASH] = ACTIONS(3954),
    [anon_sym_PLUS_DOT] = ACTIONS(3954),
    [anon_sym_DASH_DOT] = ACTIONS(3954),
    [anon_sym_PERCENT] = ACTIONS(3954),
    [anon_sym_AMP_AMP] = ACTIONS(3954),
    [anon_sym_TILDE] = ACTIONS(3952),
    [aux_sym_prefix_op_token1] = ACTIONS(3954),
    [aux_sym_infix_op_token1] = ACTIONS(3952),
    [aux_sym_infix_op_token2] = ACTIONS(3954),
    [anon_sym_PIPE_PIPE] = ACTIONS(3954),
    [anon_sym_BANG_EQ] = ACTIONS(3954),
    [anon_sym_COLON_EQ] = ACTIONS(3952),
    [anon_sym_DOLLAR] = ACTIONS(3954),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3954),
    [sym_int] = ACTIONS(3954),
    [sym_xint] = ACTIONS(3952),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3952),
    [sym__newline] = ACTIONS(3952),
  },
  [3017] = {
    [sym_block_comment] = STATE(3017),
    [sym_compiler_directive_decl] = STATE(3017),
    [sym_fsi_directive_decl] = STATE(3017),
    [sym_preproc_line] = STATE(3017),
    [sym_identifier] = ACTIONS(4170),
    [anon_sym_EQ] = ACTIONS(4168),
    [anon_sym_COLON] = ACTIONS(4170),
    [anon_sym_return] = ACTIONS(4170),
    [anon_sym_do] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_let_BANG] = ACTIONS(4168),
    [anon_sym_LPAREN] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4168),
    [anon_sym_null] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_COLON] = ACTIONS(4168),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4170),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4168),
    [anon_sym_LBRACE] = ACTIONS(4170),
    [anon_sym_LT_AT] = ACTIONS(4170),
    [anon_sym_LT_AT_AT] = ACTIONS(4170),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4168),
    [anon_sym_new] = ACTIONS(4170),
    [anon_sym_return_BANG] = ACTIONS(4168),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_yield_BANG] = ACTIONS(4168),
    [anon_sym_lazy] = ACTIONS(4170),
    [anon_sym_assert] = ACTIONS(4170),
    [anon_sym_upcast] = ACTIONS(4170),
    [anon_sym_downcast] = ACTIONS(4170),
    [anon_sym_COLON_GT] = ACTIONS(4168),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4168),
    [anon_sym_for] = ACTIONS(4170),
    [anon_sym_while] = ACTIONS(4170),
    [anon_sym_if] = ACTIONS(4170),
    [anon_sym_fun] = ACTIONS(4170),
    [anon_sym_DASH_GT] = ACTIONS(4170),
    [anon_sym_try] = ACTIONS(4170),
    [anon_sym_match] = ACTIONS(4170),
    [anon_sym_match_BANG] = ACTIONS(4168),
    [anon_sym_function] = ACTIONS(4170),
    [anon_sym_LT_DASH] = ACTIONS(4170),
    [anon_sym_DOT_LBRACK] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4168),
    [anon_sym_use] = ACTIONS(4170),
    [anon_sym_use_BANG] = ACTIONS(4168),
    [anon_sym_do_BANG] = ACTIONS(4168),
    [anon_sym_DOT_DOT] = ACTIONS(4168),
    [anon_sym_begin] = ACTIONS(4170),
    [anon_sym_LPAREN2] = ACTIONS(4170),
    [anon_sym_or] = ACTIONS(4170),
    [aux_sym_char_token1] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4170),
    [anon_sym_DQUOTE] = ACTIONS(4170),
    [anon_sym_AT_DQUOTE] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [sym_bool] = ACTIONS(4170),
    [sym_unit] = ACTIONS(4168),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4170),
    [sym_op_identifier] = ACTIONS(4170),
    [anon_sym_PLUS] = ACTIONS(4170),
    [anon_sym_DASH] = ACTIONS(4170),
    [anon_sym_PLUS_DOT] = ACTIONS(4170),
    [anon_sym_DASH_DOT] = ACTIONS(4170),
    [anon_sym_PERCENT] = ACTIONS(4170),
    [anon_sym_AMP_AMP] = ACTIONS(4170),
    [anon_sym_TILDE] = ACTIONS(4168),
    [aux_sym_prefix_op_token1] = ACTIONS(4170),
    [aux_sym_infix_op_token1] = ACTIONS(4168),
    [aux_sym_infix_op_token2] = ACTIONS(4170),
    [anon_sym_PIPE_PIPE] = ACTIONS(4170),
    [anon_sym_BANG_EQ] = ACTIONS(4170),
    [anon_sym_COLON_EQ] = ACTIONS(4168),
    [anon_sym_DOLLAR] = ACTIONS(4170),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4170),
    [sym_int] = ACTIONS(4170),
    [sym_xint] = ACTIONS(4168),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4168),
    [sym__newline] = ACTIONS(4168),
  },
  [3018] = {
    [sym_block_comment] = STATE(3018),
    [sym_compiler_directive_decl] = STATE(3018),
    [sym_fsi_directive_decl] = STATE(3018),
    [sym_preproc_line] = STATE(3018),
    [sym_identifier] = ACTIONS(3841),
    [anon_sym_EQ] = ACTIONS(3839),
    [anon_sym_COLON] = ACTIONS(3841),
    [anon_sym_return] = ACTIONS(3841),
    [anon_sym_do] = ACTIONS(3841),
    [anon_sym_let] = ACTIONS(3841),
    [anon_sym_let_BANG] = ACTIONS(3839),
    [anon_sym_LPAREN] = ACTIONS(3841),
    [anon_sym_COMMA] = ACTIONS(3839),
    [anon_sym_null] = ACTIONS(3841),
    [anon_sym_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_COLON] = ACTIONS(3839),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_AMP] = ACTIONS(3841),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(3841),
    [anon_sym_LT_AT] = ACTIONS(3841),
    [anon_sym_LT_AT_AT] = ACTIONS(3841),
    [anon_sym_DOT] = ACTIONS(3841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3839),
    [anon_sym_new] = ACTIONS(3841),
    [anon_sym_return_BANG] = ACTIONS(3839),
    [anon_sym_yield] = ACTIONS(3841),
    [anon_sym_yield_BANG] = ACTIONS(3839),
    [anon_sym_lazy] = ACTIONS(3841),
    [anon_sym_assert] = ACTIONS(3841),
    [anon_sym_upcast] = ACTIONS(3841),
    [anon_sym_downcast] = ACTIONS(3841),
    [anon_sym_COLON_GT] = ACTIONS(3839),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3839),
    [anon_sym_for] = ACTIONS(3841),
    [anon_sym_while] = ACTIONS(3841),
    [anon_sym_if] = ACTIONS(3841),
    [anon_sym_fun] = ACTIONS(3841),
    [anon_sym_try] = ACTIONS(3841),
    [anon_sym_match] = ACTIONS(3841),
    [anon_sym_match_BANG] = ACTIONS(3839),
    [anon_sym_function] = ACTIONS(3841),
    [anon_sym_LT_DASH] = ACTIONS(3841),
    [anon_sym_DOT_LBRACK] = ACTIONS(3839),
    [anon_sym_LT] = ACTIONS(3839),
    [anon_sym_GT] = ACTIONS(3841),
    [anon_sym_use] = ACTIONS(3841),
    [anon_sym_use_BANG] = ACTIONS(3839),
    [anon_sym_do_BANG] = ACTIONS(3839),
    [anon_sym_begin] = ACTIONS(3841),
    [anon_sym_LPAREN2] = ACTIONS(3841),
    [anon_sym_or] = ACTIONS(3841),
    [aux_sym_char_token1] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3841),
    [anon_sym_DQUOTE] = ACTIONS(3841),
    [anon_sym_AT_DQUOTE] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [sym_bool] = ACTIONS(3841),
    [sym_unit] = ACTIONS(3839),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3841),
    [sym_op_identifier] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_PLUS_DOT] = ACTIONS(3841),
    [anon_sym_DASH_DOT] = ACTIONS(3841),
    [anon_sym_PERCENT] = ACTIONS(3841),
    [anon_sym_AMP_AMP] = ACTIONS(3841),
    [anon_sym_TILDE] = ACTIONS(3839),
    [aux_sym_prefix_op_token1] = ACTIONS(3841),
    [aux_sym_infix_op_token1] = ACTIONS(3839),
    [aux_sym_infix_op_token2] = ACTIONS(3841),
    [anon_sym_PIPE_PIPE] = ACTIONS(3841),
    [anon_sym_BANG_EQ] = ACTIONS(3841),
    [anon_sym_COLON_EQ] = ACTIONS(3839),
    [anon_sym_DOLLAR] = ACTIONS(3841),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3841),
    [sym_int] = ACTIONS(3841),
    [sym_xint] = ACTIONS(3839),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3839),
    [sym__newline] = ACTIONS(3839),
  },
  [3019] = {
    [sym_block_comment] = STATE(3019),
    [sym_compiler_directive_decl] = STATE(3019),
    [sym_fsi_directive_decl] = STATE(3019),
    [sym_preproc_line] = STATE(3019),
    [sym_identifier] = ACTIONS(3856),
    [anon_sym_EQ] = ACTIONS(3854),
    [anon_sym_COLON] = ACTIONS(3856),
    [anon_sym_return] = ACTIONS(3856),
    [anon_sym_do] = ACTIONS(3856),
    [anon_sym_let] = ACTIONS(3856),
    [anon_sym_let_BANG] = ACTIONS(3854),
    [anon_sym_LPAREN] = ACTIONS(3856),
    [anon_sym_COMMA] = ACTIONS(3854),
    [anon_sym_null] = ACTIONS(3856),
    [anon_sym_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_AMP] = ACTIONS(3856),
    [anon_sym_LBRACK] = ACTIONS(3856),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3854),
    [anon_sym_LBRACE] = ACTIONS(3856),
    [anon_sym_LT_AT] = ACTIONS(3856),
    [anon_sym_LT_AT_AT] = ACTIONS(3856),
    [anon_sym_DOT] = ACTIONS(3856),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3854),
    [anon_sym_new] = ACTIONS(3856),
    [anon_sym_return_BANG] = ACTIONS(3854),
    [anon_sym_yield] = ACTIONS(3856),
    [anon_sym_yield_BANG] = ACTIONS(3854),
    [anon_sym_lazy] = ACTIONS(3856),
    [anon_sym_assert] = ACTIONS(3856),
    [anon_sym_upcast] = ACTIONS(3856),
    [anon_sym_downcast] = ACTIONS(3856),
    [anon_sym_COLON_GT] = ACTIONS(3854),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3854),
    [anon_sym_for] = ACTIONS(3856),
    [anon_sym_while] = ACTIONS(3856),
    [anon_sym_if] = ACTIONS(3856),
    [anon_sym_fun] = ACTIONS(3856),
    [anon_sym_DASH_GT] = ACTIONS(3856),
    [anon_sym_try] = ACTIONS(3856),
    [anon_sym_match] = ACTIONS(3856),
    [anon_sym_match_BANG] = ACTIONS(3854),
    [anon_sym_function] = ACTIONS(3856),
    [anon_sym_LT_DASH] = ACTIONS(3856),
    [anon_sym_DOT_LBRACK] = ACTIONS(3854),
    [anon_sym_LT] = ACTIONS(3854),
    [anon_sym_use] = ACTIONS(3856),
    [anon_sym_use_BANG] = ACTIONS(3854),
    [anon_sym_do_BANG] = ACTIONS(3854),
    [anon_sym_DOT_DOT] = ACTIONS(3854),
    [anon_sym_begin] = ACTIONS(3856),
    [anon_sym_LPAREN2] = ACTIONS(3856),
    [anon_sym_or] = ACTIONS(3856),
    [aux_sym_char_token1] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3856),
    [anon_sym_DQUOTE] = ACTIONS(3856),
    [anon_sym_AT_DQUOTE] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [sym_bool] = ACTIONS(3856),
    [sym_unit] = ACTIONS(3854),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3856),
    [sym_op_identifier] = ACTIONS(3856),
    [anon_sym_PLUS] = ACTIONS(3856),
    [anon_sym_DASH] = ACTIONS(3856),
    [anon_sym_PLUS_DOT] = ACTIONS(3856),
    [anon_sym_DASH_DOT] = ACTIONS(3856),
    [anon_sym_PERCENT] = ACTIONS(3856),
    [anon_sym_AMP_AMP] = ACTIONS(3856),
    [anon_sym_TILDE] = ACTIONS(3854),
    [aux_sym_prefix_op_token1] = ACTIONS(3856),
    [aux_sym_infix_op_token1] = ACTIONS(3854),
    [aux_sym_infix_op_token2] = ACTIONS(3856),
    [anon_sym_PIPE_PIPE] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3856),
    [anon_sym_COLON_EQ] = ACTIONS(3854),
    [anon_sym_DOLLAR] = ACTIONS(3856),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3856),
    [sym_int] = ACTIONS(3856),
    [sym_xint] = ACTIONS(3854),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3854),
    [sym__newline] = ACTIONS(3854),
  },
  [3020] = {
    [sym_block_comment] = STATE(3020),
    [sym_compiler_directive_decl] = STATE(3020),
    [sym_fsi_directive_decl] = STATE(3020),
    [sym_preproc_line] = STATE(3020),
    [sym_identifier] = ACTIONS(3863),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_let] = ACTIONS(3863),
    [anon_sym_let_BANG] = ACTIONS(3861),
    [anon_sym_as] = ACTIONS(3863),
    [anon_sym_LPAREN] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3861),
    [anon_sym_null] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_COLON] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_LT_AT] = ACTIONS(3863),
    [anon_sym_LT_AT_AT] = ACTIONS(3863),
    [anon_sym_DOT] = ACTIONS(3863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3861),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_with] = ACTIONS(3863),
    [anon_sym_return_BANG] = ACTIONS(3861),
    [anon_sym_yield] = ACTIONS(3863),
    [anon_sym_yield_BANG] = ACTIONS(3861),
    [anon_sym_lazy] = ACTIONS(3863),
    [anon_sym_assert] = ACTIONS(3863),
    [anon_sym_upcast] = ACTIONS(3863),
    [anon_sym_downcast] = ACTIONS(3863),
    [anon_sym_COLON_GT] = ACTIONS(3861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_fun] = ACTIONS(3863),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_match] = ACTIONS(3863),
    [anon_sym_match_BANG] = ACTIONS(3861),
    [anon_sym_function] = ACTIONS(3863),
    [anon_sym_LT_DASH] = ACTIONS(3863),
    [anon_sym_DOT_LBRACK] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_use] = ACTIONS(3863),
    [anon_sym_use_BANG] = ACTIONS(3861),
    [anon_sym_do_BANG] = ACTIONS(3861),
    [anon_sym_begin] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(3863),
    [anon_sym_or] = ACTIONS(3863),
    [aux_sym_char_token1] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [anon_sym_AT_DQUOTE] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [sym_bool] = ACTIONS(3863),
    [sym_unit] = ACTIONS(3861),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3863),
    [sym_op_identifier] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_DOT] = ACTIONS(3863),
    [anon_sym_DASH_DOT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3861),
    [aux_sym_prefix_op_token1] = ACTIONS(3863),
    [aux_sym_infix_op_token1] = ACTIONS(3861),
    [aux_sym_infix_op_token2] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_COLON_EQ] = ACTIONS(3861),
    [anon_sym_DOLLAR] = ACTIONS(3863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3863),
    [sym_int] = ACTIONS(3863),
    [sym_xint] = ACTIONS(3861),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3861),
    [sym__newline] = ACTIONS(3861),
  },
  [3021] = {
    [sym_block_comment] = STATE(3021),
    [sym_compiler_directive_decl] = STATE(3021),
    [sym_fsi_directive_decl] = STATE(3021),
    [sym_preproc_line] = STATE(3021),
    [sym_identifier] = ACTIONS(4212),
    [anon_sym_EQ] = ACTIONS(4210),
    [anon_sym_COLON] = ACTIONS(4212),
    [anon_sym_return] = ACTIONS(4212),
    [anon_sym_do] = ACTIONS(4212),
    [anon_sym_let] = ACTIONS(4212),
    [anon_sym_let_BANG] = ACTIONS(4210),
    [anon_sym_as] = ACTIONS(4212),
    [anon_sym_LPAREN] = ACTIONS(4212),
    [anon_sym_COMMA] = ACTIONS(4210),
    [anon_sym_null] = ACTIONS(4212),
    [anon_sym_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_COLON] = ACTIONS(4210),
    [anon_sym_AMP] = ACTIONS(4212),
    [anon_sym_LBRACK] = ACTIONS(4212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4210),
    [anon_sym_LBRACE] = ACTIONS(4212),
    [anon_sym_LT_AT] = ACTIONS(4212),
    [anon_sym_LT_AT_AT] = ACTIONS(4212),
    [anon_sym_DOT] = ACTIONS(4212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4210),
    [anon_sym_new] = ACTIONS(4212),
    [anon_sym_with] = ACTIONS(4212),
    [anon_sym_return_BANG] = ACTIONS(4210),
    [anon_sym_yield] = ACTIONS(4212),
    [anon_sym_yield_BANG] = ACTIONS(4210),
    [anon_sym_lazy] = ACTIONS(4212),
    [anon_sym_assert] = ACTIONS(4212),
    [anon_sym_upcast] = ACTIONS(4212),
    [anon_sym_downcast] = ACTIONS(4212),
    [anon_sym_COLON_GT] = ACTIONS(4210),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4210),
    [anon_sym_for] = ACTIONS(4212),
    [anon_sym_while] = ACTIONS(4212),
    [anon_sym_if] = ACTIONS(4212),
    [anon_sym_fun] = ACTIONS(4212),
    [anon_sym_try] = ACTIONS(4212),
    [anon_sym_match] = ACTIONS(4212),
    [anon_sym_match_BANG] = ACTIONS(4210),
    [anon_sym_function] = ACTIONS(4212),
    [anon_sym_LT_DASH] = ACTIONS(4212),
    [anon_sym_DOT_LBRACK] = ACTIONS(4210),
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_use] = ACTIONS(4212),
    [anon_sym_use_BANG] = ACTIONS(4210),
    [anon_sym_do_BANG] = ACTIONS(4210),
    [anon_sym_begin] = ACTIONS(4212),
    [anon_sym_LPAREN2] = ACTIONS(4212),
    [anon_sym_or] = ACTIONS(4212),
    [aux_sym_char_token1] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4212),
    [anon_sym_DQUOTE] = ACTIONS(4212),
    [anon_sym_AT_DQUOTE] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [sym_bool] = ACTIONS(4212),
    [sym_unit] = ACTIONS(4210),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4212),
    [anon_sym_DASH] = ACTIONS(4212),
    [anon_sym_PLUS_DOT] = ACTIONS(4212),
    [anon_sym_DASH_DOT] = ACTIONS(4212),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_AMP_AMP] = ACTIONS(4212),
    [anon_sym_TILDE] = ACTIONS(4210),
    [aux_sym_prefix_op_token1] = ACTIONS(4212),
    [aux_sym_infix_op_token1] = ACTIONS(4210),
    [aux_sym_infix_op_token2] = ACTIONS(4212),
    [anon_sym_PIPE_PIPE] = ACTIONS(4212),
    [anon_sym_BANG_EQ] = ACTIONS(4212),
    [anon_sym_COLON_EQ] = ACTIONS(4210),
    [anon_sym_DOLLAR] = ACTIONS(4212),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4212),
    [sym_int] = ACTIONS(4212),
    [sym_xint] = ACTIONS(4210),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4210),
    [sym__newline] = ACTIONS(4210),
  },
  [3022] = {
    [sym_block_comment] = STATE(3022),
    [sym_compiler_directive_decl] = STATE(3022),
    [sym_fsi_directive_decl] = STATE(3022),
    [sym_preproc_line] = STATE(3022),
    [sym_identifier] = ACTIONS(3856),
    [anon_sym_EQ] = ACTIONS(3854),
    [anon_sym_COLON] = ACTIONS(3856),
    [anon_sym_return] = ACTIONS(3856),
    [anon_sym_do] = ACTIONS(3856),
    [anon_sym_let] = ACTIONS(3856),
    [anon_sym_let_BANG] = ACTIONS(3854),
    [anon_sym_as] = ACTIONS(3856),
    [anon_sym_LPAREN] = ACTIONS(3856),
    [anon_sym_COMMA] = ACTIONS(3854),
    [anon_sym_null] = ACTIONS(3856),
    [anon_sym_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_AMP] = ACTIONS(3856),
    [anon_sym_LBRACK] = ACTIONS(3856),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3854),
    [anon_sym_LBRACE] = ACTIONS(3856),
    [anon_sym_LT_AT] = ACTIONS(3856),
    [anon_sym_LT_AT_AT] = ACTIONS(3856),
    [anon_sym_DOT] = ACTIONS(3856),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3854),
    [anon_sym_new] = ACTIONS(3856),
    [anon_sym_with] = ACTIONS(3856),
    [anon_sym_return_BANG] = ACTIONS(3854),
    [anon_sym_yield] = ACTIONS(3856),
    [anon_sym_yield_BANG] = ACTIONS(3854),
    [anon_sym_lazy] = ACTIONS(3856),
    [anon_sym_assert] = ACTIONS(3856),
    [anon_sym_upcast] = ACTIONS(3856),
    [anon_sym_downcast] = ACTIONS(3856),
    [anon_sym_COLON_GT] = ACTIONS(3854),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3854),
    [anon_sym_for] = ACTIONS(3856),
    [anon_sym_while] = ACTIONS(3856),
    [anon_sym_if] = ACTIONS(3856),
    [anon_sym_fun] = ACTIONS(3856),
    [anon_sym_try] = ACTIONS(3856),
    [anon_sym_match] = ACTIONS(3856),
    [anon_sym_match_BANG] = ACTIONS(3854),
    [anon_sym_function] = ACTIONS(3856),
    [anon_sym_LT_DASH] = ACTIONS(3856),
    [anon_sym_DOT_LBRACK] = ACTIONS(3854),
    [anon_sym_LT] = ACTIONS(3854),
    [anon_sym_use] = ACTIONS(3856),
    [anon_sym_use_BANG] = ACTIONS(3854),
    [anon_sym_do_BANG] = ACTIONS(3854),
    [anon_sym_begin] = ACTIONS(3856),
    [anon_sym_LPAREN2] = ACTIONS(3856),
    [anon_sym_or] = ACTIONS(3856),
    [aux_sym_char_token1] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3856),
    [anon_sym_DQUOTE] = ACTIONS(3856),
    [anon_sym_AT_DQUOTE] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [sym_bool] = ACTIONS(3856),
    [sym_unit] = ACTIONS(3854),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3856),
    [sym_op_identifier] = ACTIONS(3856),
    [anon_sym_PLUS] = ACTIONS(3856),
    [anon_sym_DASH] = ACTIONS(3856),
    [anon_sym_PLUS_DOT] = ACTIONS(3856),
    [anon_sym_DASH_DOT] = ACTIONS(3856),
    [anon_sym_PERCENT] = ACTIONS(3856),
    [anon_sym_AMP_AMP] = ACTIONS(3856),
    [anon_sym_TILDE] = ACTIONS(3854),
    [aux_sym_prefix_op_token1] = ACTIONS(3856),
    [aux_sym_infix_op_token1] = ACTIONS(3854),
    [aux_sym_infix_op_token2] = ACTIONS(3856),
    [anon_sym_PIPE_PIPE] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3856),
    [anon_sym_COLON_EQ] = ACTIONS(3854),
    [anon_sym_DOLLAR] = ACTIONS(3856),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3856),
    [sym_int] = ACTIONS(3856),
    [sym_xint] = ACTIONS(3854),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3854),
    [sym__newline] = ACTIONS(3854),
  },
  [3023] = {
    [sym_block_comment] = STATE(3023),
    [sym_compiler_directive_decl] = STATE(3023),
    [sym_fsi_directive_decl] = STATE(3023),
    [sym_preproc_line] = STATE(3023),
    [sym_identifier] = ACTIONS(4180),
    [anon_sym_EQ] = ACTIONS(4178),
    [anon_sym_COLON] = ACTIONS(4180),
    [anon_sym_return] = ACTIONS(4180),
    [anon_sym_do] = ACTIONS(4180),
    [anon_sym_let] = ACTIONS(4180),
    [anon_sym_let_BANG] = ACTIONS(4178),
    [anon_sym_as] = ACTIONS(4180),
    [anon_sym_LPAREN] = ACTIONS(4180),
    [anon_sym_COMMA] = ACTIONS(4178),
    [anon_sym_null] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_COLON] = ACTIONS(4178),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4180),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4180),
    [anon_sym_LT_AT] = ACTIONS(4180),
    [anon_sym_LT_AT_AT] = ACTIONS(4180),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4178),
    [anon_sym_new] = ACTIONS(4180),
    [anon_sym_with] = ACTIONS(4180),
    [anon_sym_return_BANG] = ACTIONS(4178),
    [anon_sym_yield] = ACTIONS(4180),
    [anon_sym_yield_BANG] = ACTIONS(4178),
    [anon_sym_lazy] = ACTIONS(4180),
    [anon_sym_assert] = ACTIONS(4180),
    [anon_sym_upcast] = ACTIONS(4180),
    [anon_sym_downcast] = ACTIONS(4180),
    [anon_sym_COLON_GT] = ACTIONS(4178),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4178),
    [anon_sym_for] = ACTIONS(4180),
    [anon_sym_while] = ACTIONS(4180),
    [anon_sym_if] = ACTIONS(4180),
    [anon_sym_fun] = ACTIONS(4180),
    [anon_sym_try] = ACTIONS(4180),
    [anon_sym_match] = ACTIONS(4180),
    [anon_sym_match_BANG] = ACTIONS(4178),
    [anon_sym_function] = ACTIONS(4180),
    [anon_sym_LT_DASH] = ACTIONS(4180),
    [anon_sym_DOT_LBRACK] = ACTIONS(4178),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_use] = ACTIONS(4180),
    [anon_sym_use_BANG] = ACTIONS(4178),
    [anon_sym_do_BANG] = ACTIONS(4178),
    [anon_sym_begin] = ACTIONS(4180),
    [anon_sym_LPAREN2] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [aux_sym_char_token1] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4180),
    [anon_sym_DQUOTE] = ACTIONS(4180),
    [anon_sym_AT_DQUOTE] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [sym_bool] = ACTIONS(4180),
    [sym_unit] = ACTIONS(4178),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4180),
    [sym_op_identifier] = ACTIONS(4180),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_PLUS_DOT] = ACTIONS(4180),
    [anon_sym_DASH_DOT] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_TILDE] = ACTIONS(4178),
    [aux_sym_prefix_op_token1] = ACTIONS(4180),
    [aux_sym_infix_op_token1] = ACTIONS(4178),
    [aux_sym_infix_op_token2] = ACTIONS(4180),
    [anon_sym_PIPE_PIPE] = ACTIONS(4180),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_COLON_EQ] = ACTIONS(4178),
    [anon_sym_DOLLAR] = ACTIONS(4180),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4180),
    [sym_int] = ACTIONS(4180),
    [sym_xint] = ACTIONS(4178),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4178),
    [sym__newline] = ACTIONS(4178),
  },
  [3024] = {
    [sym_block_comment] = STATE(3024),
    [sym_compiler_directive_decl] = STATE(3024),
    [sym_fsi_directive_decl] = STATE(3024),
    [sym_preproc_line] = STATE(3024),
    [sym_identifier] = ACTIONS(3828),
    [anon_sym_EQ] = ACTIONS(3826),
    [anon_sym_COLON] = ACTIONS(3828),
    [anon_sym_return] = ACTIONS(3828),
    [anon_sym_do] = ACTIONS(3828),
    [anon_sym_let] = ACTIONS(3828),
    [anon_sym_let_BANG] = ACTIONS(3826),
    [anon_sym_LPAREN] = ACTIONS(3828),
    [anon_sym_COMMA] = ACTIONS(3826),
    [anon_sym_null] = ACTIONS(3828),
    [anon_sym_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_COLON] = ACTIONS(3826),
    [anon_sym_PIPE] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3828),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3826),
    [anon_sym_LBRACE] = ACTIONS(3828),
    [anon_sym_LT_AT] = ACTIONS(3828),
    [anon_sym_LT_AT_AT] = ACTIONS(3828),
    [anon_sym_AT_AT_GT] = ACTIONS(3828),
    [anon_sym_DOT] = ACTIONS(3828),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3826),
    [anon_sym_new] = ACTIONS(3828),
    [anon_sym_return_BANG] = ACTIONS(3826),
    [anon_sym_yield] = ACTIONS(3828),
    [anon_sym_yield_BANG] = ACTIONS(3826),
    [anon_sym_lazy] = ACTIONS(3828),
    [anon_sym_assert] = ACTIONS(3828),
    [anon_sym_upcast] = ACTIONS(3828),
    [anon_sym_downcast] = ACTIONS(3828),
    [anon_sym_COLON_GT] = ACTIONS(3826),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3826),
    [anon_sym_for] = ACTIONS(3828),
    [anon_sym_while] = ACTIONS(3828),
    [anon_sym_if] = ACTIONS(3828),
    [anon_sym_fun] = ACTIONS(3828),
    [anon_sym_try] = ACTIONS(3828),
    [anon_sym_match] = ACTIONS(3828),
    [anon_sym_match_BANG] = ACTIONS(3826),
    [anon_sym_function] = ACTIONS(3828),
    [anon_sym_LT_DASH] = ACTIONS(3828),
    [anon_sym_DOT_LBRACK] = ACTIONS(3826),
    [anon_sym_LT] = ACTIONS(3826),
    [anon_sym_use] = ACTIONS(3828),
    [anon_sym_use_BANG] = ACTIONS(3826),
    [anon_sym_do_BANG] = ACTIONS(3826),
    [anon_sym_begin] = ACTIONS(3828),
    [anon_sym_LPAREN2] = ACTIONS(3828),
    [anon_sym_or] = ACTIONS(3828),
    [aux_sym_char_token1] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3828),
    [anon_sym_DQUOTE] = ACTIONS(3828),
    [anon_sym_AT_DQUOTE] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [sym_bool] = ACTIONS(3828),
    [sym_unit] = ACTIONS(3826),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3828),
    [sym_op_identifier] = ACTIONS(3828),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_DASH] = ACTIONS(3828),
    [anon_sym_PLUS_DOT] = ACTIONS(3828),
    [anon_sym_DASH_DOT] = ACTIONS(3828),
    [anon_sym_PERCENT] = ACTIONS(3828),
    [anon_sym_AMP_AMP] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3826),
    [aux_sym_prefix_op_token1] = ACTIONS(3828),
    [aux_sym_infix_op_token1] = ACTIONS(3826),
    [aux_sym_infix_op_token2] = ACTIONS(3828),
    [anon_sym_PIPE_PIPE] = ACTIONS(3828),
    [anon_sym_BANG_EQ] = ACTIONS(3828),
    [anon_sym_COLON_EQ] = ACTIONS(3826),
    [anon_sym_DOLLAR] = ACTIONS(3828),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3828),
    [sym_int] = ACTIONS(3828),
    [sym_xint] = ACTIONS(3826),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3826),
    [sym__newline] = ACTIONS(3826),
  },
  [3025] = {
    [sym_block_comment] = STATE(3025),
    [sym_compiler_directive_decl] = STATE(3025),
    [sym_fsi_directive_decl] = STATE(3025),
    [sym_preproc_line] = STATE(3025),
    [sym_identifier] = ACTIONS(3863),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_let] = ACTIONS(3863),
    [anon_sym_let_BANG] = ACTIONS(3861),
    [anon_sym_LPAREN] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3861),
    [anon_sym_null] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_COLON] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_LT_AT] = ACTIONS(3863),
    [anon_sym_LT_AT_AT] = ACTIONS(3863),
    [anon_sym_DOT] = ACTIONS(3863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3861),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_return_BANG] = ACTIONS(3861),
    [anon_sym_yield] = ACTIONS(3863),
    [anon_sym_yield_BANG] = ACTIONS(3861),
    [anon_sym_lazy] = ACTIONS(3863),
    [anon_sym_assert] = ACTIONS(3863),
    [anon_sym_upcast] = ACTIONS(3863),
    [anon_sym_downcast] = ACTIONS(3863),
    [anon_sym_COLON_GT] = ACTIONS(3861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_fun] = ACTIONS(3863),
    [anon_sym_DASH_GT] = ACTIONS(3863),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_match] = ACTIONS(3863),
    [anon_sym_match_BANG] = ACTIONS(3861),
    [anon_sym_function] = ACTIONS(3863),
    [anon_sym_LT_DASH] = ACTIONS(3863),
    [anon_sym_DOT_LBRACK] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_use] = ACTIONS(3863),
    [anon_sym_use_BANG] = ACTIONS(3861),
    [anon_sym_do_BANG] = ACTIONS(3861),
    [anon_sym_DOT_DOT] = ACTIONS(3861),
    [anon_sym_begin] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(3863),
    [anon_sym_or] = ACTIONS(3863),
    [aux_sym_char_token1] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [anon_sym_AT_DQUOTE] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [sym_bool] = ACTIONS(3863),
    [sym_unit] = ACTIONS(3861),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3863),
    [sym_op_identifier] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_DOT] = ACTIONS(3863),
    [anon_sym_DASH_DOT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3861),
    [aux_sym_prefix_op_token1] = ACTIONS(3863),
    [aux_sym_infix_op_token1] = ACTIONS(3861),
    [aux_sym_infix_op_token2] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_COLON_EQ] = ACTIONS(3861),
    [anon_sym_DOLLAR] = ACTIONS(3863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3863),
    [sym_int] = ACTIONS(3863),
    [sym_xint] = ACTIONS(3861),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3861),
    [sym__newline] = ACTIONS(3861),
  },
  [3026] = {
    [sym_block_comment] = STATE(3026),
    [sym_compiler_directive_decl] = STATE(3026),
    [sym_fsi_directive_decl] = STATE(3026),
    [sym_preproc_line] = STATE(3026),
    [sym_identifier] = ACTIONS(3875),
    [anon_sym_EQ] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(3875),
    [anon_sym_return] = ACTIONS(3875),
    [anon_sym_do] = ACTIONS(3875),
    [anon_sym_let] = ACTIONS(3875),
    [anon_sym_let_BANG] = ACTIONS(3873),
    [anon_sym_LPAREN] = ACTIONS(3875),
    [anon_sym_COMMA] = ACTIONS(3873),
    [anon_sym_null] = ACTIONS(3875),
    [anon_sym_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_COLON] = ACTIONS(3873),
    [anon_sym_AMP] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(3875),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3873),
    [anon_sym_LBRACE] = ACTIONS(3875),
    [anon_sym_LT_AT] = ACTIONS(3875),
    [anon_sym_LT_AT_AT] = ACTIONS(3875),
    [anon_sym_DOT] = ACTIONS(3875),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3873),
    [anon_sym_new] = ACTIONS(3875),
    [anon_sym_return_BANG] = ACTIONS(3873),
    [anon_sym_yield] = ACTIONS(3875),
    [anon_sym_yield_BANG] = ACTIONS(3873),
    [anon_sym_lazy] = ACTIONS(3875),
    [anon_sym_assert] = ACTIONS(3875),
    [anon_sym_upcast] = ACTIONS(3875),
    [anon_sym_downcast] = ACTIONS(3875),
    [anon_sym_COLON_GT] = ACTIONS(3873),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3873),
    [anon_sym_for] = ACTIONS(3875),
    [anon_sym_while] = ACTIONS(3875),
    [anon_sym_if] = ACTIONS(3875),
    [anon_sym_fun] = ACTIONS(3875),
    [anon_sym_DASH_GT] = ACTIONS(3875),
    [anon_sym_try] = ACTIONS(3875),
    [anon_sym_match] = ACTIONS(3875),
    [anon_sym_match_BANG] = ACTIONS(3873),
    [anon_sym_function] = ACTIONS(3875),
    [anon_sym_LT_DASH] = ACTIONS(3875),
    [anon_sym_DOT_LBRACK] = ACTIONS(3873),
    [anon_sym_LT] = ACTIONS(3873),
    [anon_sym_use] = ACTIONS(3875),
    [anon_sym_use_BANG] = ACTIONS(3873),
    [anon_sym_do_BANG] = ACTIONS(3873),
    [anon_sym_DOT_DOT] = ACTIONS(3873),
    [anon_sym_begin] = ACTIONS(3875),
    [anon_sym_LPAREN2] = ACTIONS(3875),
    [anon_sym_or] = ACTIONS(3875),
    [aux_sym_char_token1] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3875),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [anon_sym_AT_DQUOTE] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [sym_bool] = ACTIONS(3875),
    [sym_unit] = ACTIONS(3873),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3875),
    [sym_op_identifier] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS_DOT] = ACTIONS(3875),
    [anon_sym_DASH_DOT] = ACTIONS(3875),
    [anon_sym_PERCENT] = ACTIONS(3875),
    [anon_sym_AMP_AMP] = ACTIONS(3875),
    [anon_sym_TILDE] = ACTIONS(3873),
    [aux_sym_prefix_op_token1] = ACTIONS(3875),
    [aux_sym_infix_op_token1] = ACTIONS(3873),
    [aux_sym_infix_op_token2] = ACTIONS(3875),
    [anon_sym_PIPE_PIPE] = ACTIONS(3875),
    [anon_sym_BANG_EQ] = ACTIONS(3875),
    [anon_sym_COLON_EQ] = ACTIONS(3873),
    [anon_sym_DOLLAR] = ACTIONS(3875),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3875),
    [sym_int] = ACTIONS(3875),
    [sym_xint] = ACTIONS(3873),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3873),
    [sym__newline] = ACTIONS(3873),
  },
  [3027] = {
    [sym_block_comment] = STATE(3027),
    [sym_compiler_directive_decl] = STATE(3027),
    [sym_fsi_directive_decl] = STATE(3027),
    [sym_preproc_line] = STATE(3027),
    [sym_identifier] = ACTIONS(3893),
    [anon_sym_EQ] = ACTIONS(3891),
    [anon_sym_COLON] = ACTIONS(3893),
    [anon_sym_return] = ACTIONS(3893),
    [anon_sym_do] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_let_BANG] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_COMMA] = ACTIONS(3891),
    [anon_sym_null] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_COLON] = ACTIONS(3891),
    [anon_sym_AMP] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3891),
    [anon_sym_LBRACE] = ACTIONS(3893),
    [anon_sym_LT_AT] = ACTIONS(3893),
    [anon_sym_LT_AT_AT] = ACTIONS(3893),
    [anon_sym_DOT] = ACTIONS(3893),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3891),
    [anon_sym_new] = ACTIONS(3893),
    [anon_sym_return_BANG] = ACTIONS(3891),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_yield_BANG] = ACTIONS(3891),
    [anon_sym_lazy] = ACTIONS(3893),
    [anon_sym_assert] = ACTIONS(3893),
    [anon_sym_upcast] = ACTIONS(3893),
    [anon_sym_downcast] = ACTIONS(3893),
    [anon_sym_COLON_GT] = ACTIONS(3891),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3891),
    [anon_sym_for] = ACTIONS(3893),
    [anon_sym_while] = ACTIONS(3893),
    [anon_sym_if] = ACTIONS(3893),
    [anon_sym_fun] = ACTIONS(3893),
    [anon_sym_DASH_GT] = ACTIONS(3893),
    [anon_sym_try] = ACTIONS(3893),
    [anon_sym_match] = ACTIONS(3893),
    [anon_sym_match_BANG] = ACTIONS(3891),
    [anon_sym_function] = ACTIONS(3893),
    [anon_sym_LT_DASH] = ACTIONS(3893),
    [anon_sym_DOT_LBRACK] = ACTIONS(3891),
    [anon_sym_LT] = ACTIONS(3891),
    [anon_sym_use] = ACTIONS(3893),
    [anon_sym_use_BANG] = ACTIONS(3891),
    [anon_sym_do_BANG] = ACTIONS(3891),
    [anon_sym_DOT_DOT] = ACTIONS(3891),
    [anon_sym_begin] = ACTIONS(3893),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_or] = ACTIONS(3893),
    [aux_sym_char_token1] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3893),
    [anon_sym_DQUOTE] = ACTIONS(3893),
    [anon_sym_AT_DQUOTE] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [sym_bool] = ACTIONS(3893),
    [sym_unit] = ACTIONS(3891),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3893),
    [sym_op_identifier] = ACTIONS(3893),
    [anon_sym_PLUS] = ACTIONS(3893),
    [anon_sym_DASH] = ACTIONS(3893),
    [anon_sym_PLUS_DOT] = ACTIONS(3893),
    [anon_sym_DASH_DOT] = ACTIONS(3893),
    [anon_sym_PERCENT] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_TILDE] = ACTIONS(3891),
    [aux_sym_prefix_op_token1] = ACTIONS(3893),
    [aux_sym_infix_op_token1] = ACTIONS(3891),
    [aux_sym_infix_op_token2] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [anon_sym_BANG_EQ] = ACTIONS(3893),
    [anon_sym_COLON_EQ] = ACTIONS(3891),
    [anon_sym_DOLLAR] = ACTIONS(3893),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3893),
    [sym_int] = ACTIONS(3893),
    [sym_xint] = ACTIONS(3891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3891),
    [sym__newline] = ACTIONS(3891),
  },
  [3028] = {
    [sym_block_comment] = STATE(3028),
    [sym_compiler_directive_decl] = STATE(3028),
    [sym_fsi_directive_decl] = STATE(3028),
    [sym_preproc_line] = STATE(3028),
    [sym_identifier] = ACTIONS(3889),
    [anon_sym_EQ] = ACTIONS(3887),
    [anon_sym_COLON] = ACTIONS(3889),
    [anon_sym_return] = ACTIONS(3889),
    [anon_sym_do] = ACTIONS(3889),
    [anon_sym_let] = ACTIONS(3889),
    [anon_sym_let_BANG] = ACTIONS(3887),
    [anon_sym_LPAREN] = ACTIONS(3889),
    [anon_sym_COMMA] = ACTIONS(3887),
    [anon_sym_null] = ACTIONS(3889),
    [anon_sym_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_COLON] = ACTIONS(3887),
    [anon_sym_AMP] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3887),
    [anon_sym_LBRACE] = ACTIONS(3889),
    [anon_sym_LT_AT] = ACTIONS(3889),
    [anon_sym_LT_AT_AT] = ACTIONS(3889),
    [anon_sym_DOT] = ACTIONS(3889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [anon_sym_new] = ACTIONS(3889),
    [anon_sym_return_BANG] = ACTIONS(3887),
    [anon_sym_yield] = ACTIONS(3889),
    [anon_sym_yield_BANG] = ACTIONS(3887),
    [anon_sym_lazy] = ACTIONS(3889),
    [anon_sym_assert] = ACTIONS(3889),
    [anon_sym_upcast] = ACTIONS(3889),
    [anon_sym_downcast] = ACTIONS(3889),
    [anon_sym_COLON_GT] = ACTIONS(3887),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3887),
    [anon_sym_for] = ACTIONS(3889),
    [anon_sym_while] = ACTIONS(3889),
    [anon_sym_if] = ACTIONS(3889),
    [anon_sym_fun] = ACTIONS(3889),
    [anon_sym_DASH_GT] = ACTIONS(3889),
    [anon_sym_try] = ACTIONS(3889),
    [anon_sym_match] = ACTIONS(3889),
    [anon_sym_match_BANG] = ACTIONS(3887),
    [anon_sym_function] = ACTIONS(3889),
    [anon_sym_LT_DASH] = ACTIONS(3889),
    [anon_sym_DOT_LBRACK] = ACTIONS(3887),
    [anon_sym_LT] = ACTIONS(3887),
    [anon_sym_use] = ACTIONS(3889),
    [anon_sym_use_BANG] = ACTIONS(3887),
    [anon_sym_do_BANG] = ACTIONS(3887),
    [anon_sym_DOT_DOT] = ACTIONS(3887),
    [anon_sym_begin] = ACTIONS(3889),
    [anon_sym_LPAREN2] = ACTIONS(3889),
    [anon_sym_or] = ACTIONS(3889),
    [aux_sym_char_token1] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3889),
    [anon_sym_DQUOTE] = ACTIONS(3889),
    [anon_sym_AT_DQUOTE] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [sym_bool] = ACTIONS(3889),
    [sym_unit] = ACTIONS(3887),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3889),
    [sym_op_identifier] = ACTIONS(3889),
    [anon_sym_PLUS] = ACTIONS(3889),
    [anon_sym_DASH] = ACTIONS(3889),
    [anon_sym_PLUS_DOT] = ACTIONS(3889),
    [anon_sym_DASH_DOT] = ACTIONS(3889),
    [anon_sym_PERCENT] = ACTIONS(3889),
    [anon_sym_AMP_AMP] = ACTIONS(3889),
    [anon_sym_TILDE] = ACTIONS(3887),
    [aux_sym_prefix_op_token1] = ACTIONS(3889),
    [aux_sym_infix_op_token1] = ACTIONS(3887),
    [aux_sym_infix_op_token2] = ACTIONS(3889),
    [anon_sym_PIPE_PIPE] = ACTIONS(3889),
    [anon_sym_BANG_EQ] = ACTIONS(3889),
    [anon_sym_COLON_EQ] = ACTIONS(3887),
    [anon_sym_DOLLAR] = ACTIONS(3889),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3889),
    [sym_int] = ACTIONS(3889),
    [sym_xint] = ACTIONS(3887),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3887),
    [sym__newline] = ACTIONS(3887),
  },
  [3029] = {
    [sym_block_comment] = STATE(3029),
    [sym_compiler_directive_decl] = STATE(3029),
    [sym_fsi_directive_decl] = STATE(3029),
    [sym_preproc_line] = STATE(3029),
    [sym_identifier] = ACTIONS(3828),
    [anon_sym_EQ] = ACTIONS(3826),
    [anon_sym_COLON] = ACTIONS(3828),
    [anon_sym_return] = ACTIONS(3828),
    [anon_sym_do] = ACTIONS(3828),
    [anon_sym_let] = ACTIONS(3828),
    [anon_sym_let_BANG] = ACTIONS(3826),
    [anon_sym_LPAREN] = ACTIONS(3828),
    [anon_sym_COMMA] = ACTIONS(3826),
    [anon_sym_null] = ACTIONS(3828),
    [anon_sym_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_COLON] = ACTIONS(3826),
    [anon_sym_PIPE] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3828),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3826),
    [anon_sym_LBRACE] = ACTIONS(3828),
    [anon_sym_LT_AT] = ACTIONS(3828),
    [anon_sym_LT_AT_AT] = ACTIONS(3828),
    [anon_sym_DOT] = ACTIONS(3828),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3826),
    [anon_sym_new] = ACTIONS(3828),
    [anon_sym_return_BANG] = ACTIONS(3826),
    [anon_sym_yield] = ACTIONS(3828),
    [anon_sym_yield_BANG] = ACTIONS(3826),
    [anon_sym_lazy] = ACTIONS(3828),
    [anon_sym_assert] = ACTIONS(3828),
    [anon_sym_upcast] = ACTIONS(3828),
    [anon_sym_downcast] = ACTIONS(3828),
    [anon_sym_COLON_GT] = ACTIONS(3826),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3826),
    [anon_sym_for] = ACTIONS(3828),
    [anon_sym_while] = ACTIONS(3828),
    [anon_sym_if] = ACTIONS(3828),
    [anon_sym_fun] = ACTIONS(3828),
    [anon_sym_try] = ACTIONS(3828),
    [anon_sym_match] = ACTIONS(3828),
    [anon_sym_match_BANG] = ACTIONS(3826),
    [anon_sym_function] = ACTIONS(3828),
    [anon_sym_LT_DASH] = ACTIONS(3828),
    [anon_sym_DOT_LBRACK] = ACTIONS(3826),
    [anon_sym_LT] = ACTIONS(3826),
    [anon_sym_GT] = ACTIONS(3828),
    [anon_sym_use] = ACTIONS(3828),
    [anon_sym_use_BANG] = ACTIONS(3826),
    [anon_sym_do_BANG] = ACTIONS(3826),
    [anon_sym_begin] = ACTIONS(3828),
    [anon_sym_LPAREN2] = ACTIONS(3828),
    [anon_sym_or] = ACTIONS(3828),
    [aux_sym_char_token1] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3828),
    [anon_sym_DQUOTE] = ACTIONS(3828),
    [anon_sym_AT_DQUOTE] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [sym_bool] = ACTIONS(3828),
    [sym_unit] = ACTIONS(3826),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3828),
    [sym_op_identifier] = ACTIONS(3828),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_DASH] = ACTIONS(3828),
    [anon_sym_PLUS_DOT] = ACTIONS(3828),
    [anon_sym_DASH_DOT] = ACTIONS(3828),
    [anon_sym_PERCENT] = ACTIONS(3828),
    [anon_sym_AMP_AMP] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3826),
    [aux_sym_prefix_op_token1] = ACTIONS(3828),
    [aux_sym_infix_op_token1] = ACTIONS(3826),
    [aux_sym_infix_op_token2] = ACTIONS(3828),
    [anon_sym_PIPE_PIPE] = ACTIONS(3828),
    [anon_sym_BANG_EQ] = ACTIONS(3828),
    [anon_sym_COLON_EQ] = ACTIONS(3826),
    [anon_sym_DOLLAR] = ACTIONS(3828),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3828),
    [sym_int] = ACTIONS(3828),
    [sym_xint] = ACTIONS(3826),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3826),
    [sym__newline] = ACTIONS(3826),
  },
  [3030] = {
    [sym_block_comment] = STATE(3030),
    [sym_compiler_directive_decl] = STATE(3030),
    [sym_fsi_directive_decl] = STATE(3030),
    [sym_preproc_line] = STATE(3030),
    [sym_identifier] = ACTIONS(3900),
    [anon_sym_EQ] = ACTIONS(3898),
    [anon_sym_COLON] = ACTIONS(3900),
    [anon_sym_return] = ACTIONS(3900),
    [anon_sym_do] = ACTIONS(3900),
    [anon_sym_let] = ACTIONS(3900),
    [anon_sym_let_BANG] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3898),
    [anon_sym_null] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_COLON] = ACTIONS(3898),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_LBRACK] = ACTIONS(3900),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3898),
    [anon_sym_LBRACE] = ACTIONS(3900),
    [anon_sym_LT_AT] = ACTIONS(3900),
    [anon_sym_LT_AT_AT] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(3900),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3898),
    [anon_sym_new] = ACTIONS(3900),
    [anon_sym_return_BANG] = ACTIONS(3898),
    [anon_sym_yield] = ACTIONS(3900),
    [anon_sym_yield_BANG] = ACTIONS(3898),
    [anon_sym_lazy] = ACTIONS(3900),
    [anon_sym_assert] = ACTIONS(3900),
    [anon_sym_upcast] = ACTIONS(3900),
    [anon_sym_downcast] = ACTIONS(3900),
    [anon_sym_COLON_GT] = ACTIONS(3898),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3898),
    [anon_sym_for] = ACTIONS(3900),
    [anon_sym_while] = ACTIONS(3900),
    [anon_sym_if] = ACTIONS(3900),
    [anon_sym_fun] = ACTIONS(3900),
    [anon_sym_DASH_GT] = ACTIONS(3900),
    [anon_sym_try] = ACTIONS(3900),
    [anon_sym_match] = ACTIONS(3900),
    [anon_sym_match_BANG] = ACTIONS(3898),
    [anon_sym_function] = ACTIONS(3900),
    [anon_sym_LT_DASH] = ACTIONS(3900),
    [anon_sym_DOT_LBRACK] = ACTIONS(3898),
    [anon_sym_LT] = ACTIONS(3898),
    [anon_sym_use] = ACTIONS(3900),
    [anon_sym_use_BANG] = ACTIONS(3898),
    [anon_sym_do_BANG] = ACTIONS(3898),
    [anon_sym_DOT_DOT] = ACTIONS(3898),
    [anon_sym_begin] = ACTIONS(3900),
    [anon_sym_LPAREN2] = ACTIONS(3900),
    [anon_sym_or] = ACTIONS(3900),
    [aux_sym_char_token1] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3900),
    [anon_sym_DQUOTE] = ACTIONS(3900),
    [anon_sym_AT_DQUOTE] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3898),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3900),
    [sym_op_identifier] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(3900),
    [anon_sym_DASH] = ACTIONS(3900),
    [anon_sym_PLUS_DOT] = ACTIONS(3900),
    [anon_sym_DASH_DOT] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(3900),
    [anon_sym_AMP_AMP] = ACTIONS(3900),
    [anon_sym_TILDE] = ACTIONS(3898),
    [aux_sym_prefix_op_token1] = ACTIONS(3900),
    [aux_sym_infix_op_token1] = ACTIONS(3898),
    [aux_sym_infix_op_token2] = ACTIONS(3900),
    [anon_sym_PIPE_PIPE] = ACTIONS(3900),
    [anon_sym_BANG_EQ] = ACTIONS(3900),
    [anon_sym_COLON_EQ] = ACTIONS(3898),
    [anon_sym_DOLLAR] = ACTIONS(3900),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3900),
    [sym_int] = ACTIONS(3900),
    [sym_xint] = ACTIONS(3898),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3898),
    [sym__newline] = ACTIONS(3898),
  },
  [3031] = {
    [sym_block_comment] = STATE(3031),
    [sym_compiler_directive_decl] = STATE(3031),
    [sym_fsi_directive_decl] = STATE(3031),
    [sym_preproc_line] = STATE(3031),
    [sym_identifier] = ACTIONS(3907),
    [anon_sym_EQ] = ACTIONS(3905),
    [anon_sym_COLON] = ACTIONS(3907),
    [anon_sym_return] = ACTIONS(3907),
    [anon_sym_do] = ACTIONS(3907),
    [anon_sym_let] = ACTIONS(3907),
    [anon_sym_let_BANG] = ACTIONS(3905),
    [anon_sym_LPAREN] = ACTIONS(3907),
    [anon_sym_COMMA] = ACTIONS(3905),
    [anon_sym_null] = ACTIONS(3907),
    [anon_sym_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_COLON] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3907),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3905),
    [anon_sym_LBRACE] = ACTIONS(3907),
    [anon_sym_LT_AT] = ACTIONS(3907),
    [anon_sym_LT_AT_AT] = ACTIONS(3907),
    [anon_sym_DOT] = ACTIONS(3907),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3905),
    [anon_sym_new] = ACTIONS(3907),
    [anon_sym_return_BANG] = ACTIONS(3905),
    [anon_sym_yield] = ACTIONS(3907),
    [anon_sym_yield_BANG] = ACTIONS(3905),
    [anon_sym_lazy] = ACTIONS(3907),
    [anon_sym_assert] = ACTIONS(3907),
    [anon_sym_upcast] = ACTIONS(3907),
    [anon_sym_downcast] = ACTIONS(3907),
    [anon_sym_COLON_GT] = ACTIONS(3905),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3905),
    [anon_sym_for] = ACTIONS(3907),
    [anon_sym_while] = ACTIONS(3907),
    [anon_sym_if] = ACTIONS(3907),
    [anon_sym_fun] = ACTIONS(3907),
    [anon_sym_DASH_GT] = ACTIONS(3907),
    [anon_sym_try] = ACTIONS(3907),
    [anon_sym_match] = ACTIONS(3907),
    [anon_sym_match_BANG] = ACTIONS(3905),
    [anon_sym_function] = ACTIONS(3907),
    [anon_sym_LT_DASH] = ACTIONS(3907),
    [anon_sym_DOT_LBRACK] = ACTIONS(3905),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_use] = ACTIONS(3907),
    [anon_sym_use_BANG] = ACTIONS(3905),
    [anon_sym_do_BANG] = ACTIONS(3905),
    [anon_sym_DOT_DOT] = ACTIONS(3905),
    [anon_sym_begin] = ACTIONS(3907),
    [anon_sym_LPAREN2] = ACTIONS(3907),
    [anon_sym_or] = ACTIONS(3907),
    [aux_sym_char_token1] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3907),
    [anon_sym_DQUOTE] = ACTIONS(3907),
    [anon_sym_AT_DQUOTE] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [sym_bool] = ACTIONS(3907),
    [sym_unit] = ACTIONS(3905),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3907),
    [sym_op_identifier] = ACTIONS(3907),
    [anon_sym_PLUS] = ACTIONS(3907),
    [anon_sym_DASH] = ACTIONS(3907),
    [anon_sym_PLUS_DOT] = ACTIONS(3907),
    [anon_sym_DASH_DOT] = ACTIONS(3907),
    [anon_sym_PERCENT] = ACTIONS(3907),
    [anon_sym_AMP_AMP] = ACTIONS(3907),
    [anon_sym_TILDE] = ACTIONS(3905),
    [aux_sym_prefix_op_token1] = ACTIONS(3907),
    [aux_sym_infix_op_token1] = ACTIONS(3905),
    [aux_sym_infix_op_token2] = ACTIONS(3907),
    [anon_sym_PIPE_PIPE] = ACTIONS(3907),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_COLON_EQ] = ACTIONS(3905),
    [anon_sym_DOLLAR] = ACTIONS(3907),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3907),
    [sym_int] = ACTIONS(3907),
    [sym_xint] = ACTIONS(3905),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3905),
    [sym__newline] = ACTIONS(3905),
  },
  [3032] = {
    [sym_block_comment] = STATE(3032),
    [sym_compiler_directive_decl] = STATE(3032),
    [sym_fsi_directive_decl] = STATE(3032),
    [sym_preproc_line] = STATE(3032),
    [aux_sym_sequential_expression_repeat1] = STATE(3032),
    [sym_identifier] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3765),
    [anon_sym_COLON] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_let_BANG] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(3767),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_null] = ACTIONS(3767),
    [anon_sym_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3765),
    [anon_sym_LBRACE] = ACTIONS(3767),
    [anon_sym_LT_AT] = ACTIONS(3767),
    [anon_sym_LT_AT_AT] = ACTIONS(3767),
    [anon_sym_AT_AT_GT] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3765),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_return_BANG] = ACTIONS(3765),
    [anon_sym_yield] = ACTIONS(3767),
    [anon_sym_yield_BANG] = ACTIONS(3765),
    [anon_sym_lazy] = ACTIONS(3767),
    [anon_sym_assert] = ACTIONS(3767),
    [anon_sym_upcast] = ACTIONS(3767),
    [anon_sym_downcast] = ACTIONS(3767),
    [anon_sym_COLON_GT] = ACTIONS(3765),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3765),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_fun] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_match] = ACTIONS(3767),
    [anon_sym_match_BANG] = ACTIONS(3765),
    [anon_sym_function] = ACTIONS(3767),
    [anon_sym_LT_DASH] = ACTIONS(3767),
    [anon_sym_DOT_LBRACK] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(3765),
    [anon_sym_use] = ACTIONS(3767),
    [anon_sym_use_BANG] = ACTIONS(3765),
    [anon_sym_do_BANG] = ACTIONS(3765),
    [anon_sym_begin] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3767),
    [anon_sym_or] = ACTIONS(3767),
    [aux_sym_char_token1] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3767),
    [anon_sym_DQUOTE] = ACTIONS(3767),
    [anon_sym_AT_DQUOTE] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [sym_bool] = ACTIONS(3767),
    [sym_unit] = ACTIONS(3765),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3767),
    [sym_op_identifier] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_PLUS_DOT] = ACTIONS(3767),
    [anon_sym_DASH_DOT] = ACTIONS(3767),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_AMP_AMP] = ACTIONS(3767),
    [anon_sym_TILDE] = ACTIONS(3765),
    [aux_sym_prefix_op_token1] = ACTIONS(3767),
    [aux_sym_infix_op_token1] = ACTIONS(3765),
    [aux_sym_infix_op_token2] = ACTIONS(3767),
    [anon_sym_PIPE_PIPE] = ACTIONS(3767),
    [anon_sym_BANG_EQ] = ACTIONS(3767),
    [anon_sym_COLON_EQ] = ACTIONS(3765),
    [anon_sym_DOLLAR] = ACTIONS(3767),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3767),
    [sym_int] = ACTIONS(3767),
    [sym_xint] = ACTIONS(3765),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3765),
    [sym__newline] = ACTIONS(5637),
  },
  [3033] = {
    [sym_block_comment] = STATE(3033),
    [sym_compiler_directive_decl] = STATE(3033),
    [sym_fsi_directive_decl] = STATE(3033),
    [sym_preproc_line] = STATE(3033),
    [sym_identifier] = ACTIONS(4174),
    [anon_sym_EQ] = ACTIONS(4172),
    [anon_sym_COLON] = ACTIONS(4174),
    [anon_sym_return] = ACTIONS(4174),
    [anon_sym_do] = ACTIONS(4174),
    [anon_sym_let] = ACTIONS(4174),
    [anon_sym_let_BANG] = ACTIONS(4172),
    [anon_sym_as] = ACTIONS(4174),
    [anon_sym_LPAREN] = ACTIONS(4174),
    [anon_sym_COMMA] = ACTIONS(4172),
    [anon_sym_null] = ACTIONS(4174),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_COLON] = ACTIONS(4172),
    [anon_sym_AMP] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4174),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4172),
    [anon_sym_LBRACE] = ACTIONS(4174),
    [anon_sym_LT_AT] = ACTIONS(4174),
    [anon_sym_LT_AT_AT] = ACTIONS(4174),
    [anon_sym_DOT] = ACTIONS(4174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4172),
    [anon_sym_new] = ACTIONS(4174),
    [anon_sym_with] = ACTIONS(4174),
    [anon_sym_return_BANG] = ACTIONS(4172),
    [anon_sym_yield] = ACTIONS(4174),
    [anon_sym_yield_BANG] = ACTIONS(4172),
    [anon_sym_lazy] = ACTIONS(4174),
    [anon_sym_assert] = ACTIONS(4174),
    [anon_sym_upcast] = ACTIONS(4174),
    [anon_sym_downcast] = ACTIONS(4174),
    [anon_sym_COLON_GT] = ACTIONS(4172),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4172),
    [anon_sym_for] = ACTIONS(4174),
    [anon_sym_while] = ACTIONS(4174),
    [anon_sym_if] = ACTIONS(4174),
    [anon_sym_fun] = ACTIONS(4174),
    [anon_sym_try] = ACTIONS(4174),
    [anon_sym_match] = ACTIONS(4174),
    [anon_sym_match_BANG] = ACTIONS(4172),
    [anon_sym_function] = ACTIONS(4174),
    [anon_sym_LT_DASH] = ACTIONS(4174),
    [anon_sym_DOT_LBRACK] = ACTIONS(4172),
    [anon_sym_LT] = ACTIONS(4172),
    [anon_sym_use] = ACTIONS(4174),
    [anon_sym_use_BANG] = ACTIONS(4172),
    [anon_sym_do_BANG] = ACTIONS(4172),
    [anon_sym_begin] = ACTIONS(4174),
    [anon_sym_LPAREN2] = ACTIONS(4174),
    [anon_sym_or] = ACTIONS(4174),
    [aux_sym_char_token1] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4174),
    [anon_sym_DQUOTE] = ACTIONS(4174),
    [anon_sym_AT_DQUOTE] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [sym_bool] = ACTIONS(4174),
    [sym_unit] = ACTIONS(4172),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4174),
    [sym_op_identifier] = ACTIONS(4174),
    [anon_sym_PLUS] = ACTIONS(4174),
    [anon_sym_DASH] = ACTIONS(4174),
    [anon_sym_PLUS_DOT] = ACTIONS(4174),
    [anon_sym_DASH_DOT] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [anon_sym_AMP_AMP] = ACTIONS(4174),
    [anon_sym_TILDE] = ACTIONS(4172),
    [aux_sym_prefix_op_token1] = ACTIONS(4174),
    [aux_sym_infix_op_token1] = ACTIONS(4172),
    [aux_sym_infix_op_token2] = ACTIONS(4174),
    [anon_sym_PIPE_PIPE] = ACTIONS(4174),
    [anon_sym_BANG_EQ] = ACTIONS(4174),
    [anon_sym_COLON_EQ] = ACTIONS(4172),
    [anon_sym_DOLLAR] = ACTIONS(4174),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4174),
    [sym_int] = ACTIONS(4174),
    [sym_xint] = ACTIONS(4172),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4172),
    [sym__newline] = ACTIONS(4172),
  },
  [3034] = {
    [sym_block_comment] = STATE(3034),
    [sym_compiler_directive_decl] = STATE(3034),
    [sym_fsi_directive_decl] = STATE(3034),
    [sym_preproc_line] = STATE(3034),
    [sym_identifier] = ACTIONS(4100),
    [anon_sym_EQ] = ACTIONS(4098),
    [anon_sym_COLON] = ACTIONS(4100),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_do] = ACTIONS(4100),
    [anon_sym_let] = ACTIONS(4100),
    [anon_sym_let_BANG] = ACTIONS(4098),
    [anon_sym_LPAREN] = ACTIONS(4100),
    [anon_sym_COMMA] = ACTIONS(4098),
    [anon_sym_null] = ACTIONS(4100),
    [anon_sym_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_COLON] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4100),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4098),
    [anon_sym_LBRACE] = ACTIONS(4100),
    [anon_sym_LT_AT] = ACTIONS(4100),
    [anon_sym_LT_AT_AT] = ACTIONS(4100),
    [anon_sym_DOT] = ACTIONS(4100),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4098),
    [anon_sym_new] = ACTIONS(4100),
    [anon_sym_return_BANG] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4100),
    [anon_sym_yield_BANG] = ACTIONS(4098),
    [anon_sym_lazy] = ACTIONS(4100),
    [anon_sym_assert] = ACTIONS(4100),
    [anon_sym_upcast] = ACTIONS(4100),
    [anon_sym_downcast] = ACTIONS(4100),
    [anon_sym_COLON_GT] = ACTIONS(4098),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4098),
    [anon_sym_for] = ACTIONS(4100),
    [anon_sym_while] = ACTIONS(4100),
    [anon_sym_if] = ACTIONS(4100),
    [anon_sym_fun] = ACTIONS(4100),
    [anon_sym_DASH_GT] = ACTIONS(4100),
    [anon_sym_try] = ACTIONS(4100),
    [anon_sym_match] = ACTIONS(4100),
    [anon_sym_match_BANG] = ACTIONS(4098),
    [anon_sym_function] = ACTIONS(4100),
    [anon_sym_LT_DASH] = ACTIONS(4100),
    [anon_sym_DOT_LBRACK] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(4098),
    [anon_sym_use] = ACTIONS(4100),
    [anon_sym_use_BANG] = ACTIONS(4098),
    [anon_sym_do_BANG] = ACTIONS(4098),
    [anon_sym_DOT_DOT] = ACTIONS(4098),
    [anon_sym_begin] = ACTIONS(4100),
    [anon_sym_LPAREN2] = ACTIONS(4100),
    [anon_sym_or] = ACTIONS(4100),
    [aux_sym_char_token1] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4100),
    [anon_sym_DQUOTE] = ACTIONS(4100),
    [anon_sym_AT_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [sym_bool] = ACTIONS(4100),
    [sym_unit] = ACTIONS(4098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4100),
    [sym_op_identifier] = ACTIONS(4100),
    [anon_sym_PLUS] = ACTIONS(4100),
    [anon_sym_DASH] = ACTIONS(4100),
    [anon_sym_PLUS_DOT] = ACTIONS(4100),
    [anon_sym_DASH_DOT] = ACTIONS(4100),
    [anon_sym_PERCENT] = ACTIONS(4100),
    [anon_sym_AMP_AMP] = ACTIONS(4100),
    [anon_sym_TILDE] = ACTIONS(4098),
    [aux_sym_prefix_op_token1] = ACTIONS(4100),
    [aux_sym_infix_op_token1] = ACTIONS(4098),
    [aux_sym_infix_op_token2] = ACTIONS(4100),
    [anon_sym_PIPE_PIPE] = ACTIONS(4100),
    [anon_sym_BANG_EQ] = ACTIONS(4100),
    [anon_sym_COLON_EQ] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4100),
    [sym_int] = ACTIONS(4100),
    [sym_xint] = ACTIONS(4098),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4098),
    [sym__newline] = ACTIONS(4098),
  },
  [3035] = {
    [sym_block_comment] = STATE(3035),
    [sym_compiler_directive_decl] = STATE(3035),
    [sym_fsi_directive_decl] = STATE(3035),
    [sym_preproc_line] = STATE(3035),
    [aux_sym_long_identifier_repeat1] = STATE(3182),
    [sym_identifier] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3778),
    [anon_sym_COLON] = ACTIONS(3781),
    [anon_sym_return] = ACTIONS(3781),
    [anon_sym_do] = ACTIONS(3781),
    [anon_sym_let] = ACTIONS(3781),
    [anon_sym_let_BANG] = ACTIONS(3778),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3778),
    [anon_sym_null] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3781),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_LT_AT] = ACTIONS(3781),
    [anon_sym_LT_AT_AT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(5640),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3778),
    [anon_sym_new] = ACTIONS(3781),
    [anon_sym_return_BANG] = ACTIONS(3778),
    [anon_sym_yield] = ACTIONS(3781),
    [anon_sym_yield_BANG] = ACTIONS(3778),
    [anon_sym_lazy] = ACTIONS(3781),
    [anon_sym_assert] = ACTIONS(3781),
    [anon_sym_upcast] = ACTIONS(3781),
    [anon_sym_downcast] = ACTIONS(3781),
    [anon_sym_COLON_GT] = ACTIONS(3778),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3778),
    [anon_sym_for] = ACTIONS(3781),
    [anon_sym_while] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_fun] = ACTIONS(3781),
    [anon_sym_try] = ACTIONS(3781),
    [anon_sym_match] = ACTIONS(3781),
    [anon_sym_match_BANG] = ACTIONS(3778),
    [anon_sym_function] = ACTIONS(3781),
    [anon_sym_LT_DASH] = ACTIONS(3781),
    [anon_sym_DOT_LBRACK] = ACTIONS(3778),
    [anon_sym_LT] = ACTIONS(3778),
    [anon_sym_GT] = ACTIONS(3781),
    [anon_sym_use] = ACTIONS(3781),
    [anon_sym_use_BANG] = ACTIONS(3778),
    [anon_sym_do_BANG] = ACTIONS(3778),
    [anon_sym_begin] = ACTIONS(3781),
    [anon_sym_LPAREN2] = ACTIONS(3781),
    [anon_sym_or] = ACTIONS(3781),
    [aux_sym_char_token1] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3781),
    [anon_sym_DQUOTE] = ACTIONS(3781),
    [anon_sym_AT_DQUOTE] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [sym_bool] = ACTIONS(3781),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3781),
    [sym_op_identifier] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3781),
    [anon_sym_DASH] = ACTIONS(3781),
    [anon_sym_PLUS_DOT] = ACTIONS(3781),
    [anon_sym_DASH_DOT] = ACTIONS(3781),
    [anon_sym_PERCENT] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3781),
    [anon_sym_TILDE] = ACTIONS(3778),
    [aux_sym_prefix_op_token1] = ACTIONS(3781),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token2] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_COLON_EQ] = ACTIONS(3778),
    [anon_sym_DOLLAR] = ACTIONS(3781),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3781),
    [sym_int] = ACTIONS(3781),
    [sym_xint] = ACTIONS(3778),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3778),
    [sym__newline] = ACTIONS(3778),
  },
  [3036] = {
    [sym_type_arguments] = STATE(3605),
    [sym_long_identifier] = STATE(3604),
    [sym_block_comment] = STATE(3036),
    [sym_compiler_directive_decl] = STATE(3036),
    [sym_fsi_directive_decl] = STATE(3036),
    [sym_preproc_line] = STATE(3036),
    [aux_sym_compound_type_repeat1] = STATE(3597),
    [ts_builtin_sym_end] = ACTIONS(3417),
    [sym_identifier] = ACTIONS(5379),
    [anon_sym_namespace] = ACTIONS(3419),
    [anon_sym_module] = ACTIONS(3419),
    [anon_sym_open] = ACTIONS(3419),
    [anon_sym_LBRACK_LT] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_type] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_and] = ACTIONS(3419),
    [anon_sym_let] = ACTIONS(3419),
    [anon_sym_let_BANG] = ACTIONS(3417),
    [aux_sym_access_modifier_token1] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(3419),
    [anon_sym_null] = ACTIONS(3419),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_LT_AT] = ACTIONS(3419),
    [anon_sym_LT_AT_AT] = ACTIONS(3417),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_with] = ACTIONS(3419),
    [anon_sym_return_BANG] = ACTIONS(3417),
    [anon_sym_yield] = ACTIONS(3419),
    [anon_sym_yield_BANG] = ACTIONS(3417),
    [anon_sym_lazy] = ACTIONS(3419),
    [anon_sym_assert] = ACTIONS(3419),
    [anon_sym_upcast] = ACTIONS(3419),
    [anon_sym_downcast] = ACTIONS(3419),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_fun] = ACTIONS(3419),
    [anon_sym_DASH_GT] = ACTIONS(5385),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_match] = ACTIONS(3419),
    [anon_sym_match_BANG] = ACTIONS(3417),
    [anon_sym_function] = ACTIONS(3419),
    [anon_sym_use] = ACTIONS(3419),
    [anon_sym_use_BANG] = ACTIONS(3417),
    [anon_sym_do_BANG] = ACTIONS(3417),
    [anon_sym_begin] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(5387),
    [anon_sym_LT2] = ACTIONS(5389),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5391),
    [anon_sym_default] = ACTIONS(3419),
    [anon_sym_static] = ACTIONS(3419),
    [anon_sym_member] = ACTIONS(3419),
    [anon_sym_interface] = ACTIONS(3419),
    [anon_sym_exception] = ACTIONS(3419),
    [anon_sym_abstract] = ACTIONS(3419),
    [anon_sym_val] = ACTIONS(3419),
    [anon_sym_override] = ACTIONS(3419),
    [aux_sym_char_token1] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3419),
    [anon_sym_AT_DQUOTE] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [sym_bool] = ACTIONS(3419),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3419),
    [sym_op_identifier] = ACTIONS(3417),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_PLUS_DOT] = ACTIONS(3417),
    [anon_sym_DASH_DOT] = ACTIONS(3417),
    [anon_sym_PERCENT] = ACTIONS(3417),
    [anon_sym_AMP_AMP] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3417),
    [aux_sym_prefix_op_token1] = ACTIONS(3417),
    [sym_int] = ACTIONS(3419),
    [sym_xint] = ACTIONS(3417),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3417),
    [anon_sym_POUNDload] = ACTIONS(3417),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3417),
  },
  [3037] = {
    [sym_block_comment] = STATE(3037),
    [sym_compiler_directive_decl] = STATE(3037),
    [sym_fsi_directive_decl] = STATE(3037),
    [sym_preproc_line] = STATE(3037),
    [aux_sym_long_identifier_repeat1] = STATE(3037),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_AT_GT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(5644),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [3038] = {
    [sym_block_comment] = STATE(3038),
    [sym_compiler_directive_decl] = STATE(3038),
    [sym_fsi_directive_decl] = STATE(3038),
    [sym_preproc_line] = STATE(3038),
    [sym_identifier] = ACTIONS(4208),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_COLON] = ACTIONS(4208),
    [anon_sym_return] = ACTIONS(4208),
    [anon_sym_do] = ACTIONS(4208),
    [anon_sym_let] = ACTIONS(4208),
    [anon_sym_let_BANG] = ACTIONS(4206),
    [anon_sym_as] = ACTIONS(4208),
    [anon_sym_LPAREN] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(4206),
    [anon_sym_null] = ACTIONS(4208),
    [anon_sym_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_COLON] = ACTIONS(4206),
    [anon_sym_AMP] = ACTIONS(4208),
    [anon_sym_LBRACK] = ACTIONS(4208),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4206),
    [anon_sym_LBRACE] = ACTIONS(4208),
    [anon_sym_LT_AT] = ACTIONS(4208),
    [anon_sym_LT_AT_AT] = ACTIONS(4208),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4206),
    [anon_sym_new] = ACTIONS(4208),
    [anon_sym_with] = ACTIONS(4208),
    [anon_sym_return_BANG] = ACTIONS(4206),
    [anon_sym_yield] = ACTIONS(4208),
    [anon_sym_yield_BANG] = ACTIONS(4206),
    [anon_sym_lazy] = ACTIONS(4208),
    [anon_sym_assert] = ACTIONS(4208),
    [anon_sym_upcast] = ACTIONS(4208),
    [anon_sym_downcast] = ACTIONS(4208),
    [anon_sym_COLON_GT] = ACTIONS(4206),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4206),
    [anon_sym_for] = ACTIONS(4208),
    [anon_sym_while] = ACTIONS(4208),
    [anon_sym_if] = ACTIONS(4208),
    [anon_sym_fun] = ACTIONS(4208),
    [anon_sym_try] = ACTIONS(4208),
    [anon_sym_match] = ACTIONS(4208),
    [anon_sym_match_BANG] = ACTIONS(4206),
    [anon_sym_function] = ACTIONS(4208),
    [anon_sym_LT_DASH] = ACTIONS(4208),
    [anon_sym_DOT_LBRACK] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(4206),
    [anon_sym_use] = ACTIONS(4208),
    [anon_sym_use_BANG] = ACTIONS(4206),
    [anon_sym_do_BANG] = ACTIONS(4206),
    [anon_sym_begin] = ACTIONS(4208),
    [anon_sym_LPAREN2] = ACTIONS(4208),
    [anon_sym_or] = ACTIONS(4208),
    [aux_sym_char_token1] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4208),
    [anon_sym_DQUOTE] = ACTIONS(4208),
    [anon_sym_AT_DQUOTE] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [sym_bool] = ACTIONS(4208),
    [sym_unit] = ACTIONS(4206),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4208),
    [sym_op_identifier] = ACTIONS(4208),
    [anon_sym_PLUS] = ACTIONS(4208),
    [anon_sym_DASH] = ACTIONS(4208),
    [anon_sym_PLUS_DOT] = ACTIONS(4208),
    [anon_sym_DASH_DOT] = ACTIONS(4208),
    [anon_sym_PERCENT] = ACTIONS(4208),
    [anon_sym_AMP_AMP] = ACTIONS(4208),
    [anon_sym_TILDE] = ACTIONS(4206),
    [aux_sym_prefix_op_token1] = ACTIONS(4208),
    [aux_sym_infix_op_token1] = ACTIONS(4206),
    [aux_sym_infix_op_token2] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(4208),
    [anon_sym_BANG_EQ] = ACTIONS(4208),
    [anon_sym_COLON_EQ] = ACTIONS(4206),
    [anon_sym_DOLLAR] = ACTIONS(4208),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4208),
    [sym_int] = ACTIONS(4208),
    [sym_xint] = ACTIONS(4206),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4206),
    [sym__newline] = ACTIONS(4206),
  },
  [3039] = {
    [sym_block_comment] = STATE(3039),
    [sym_compiler_directive_decl] = STATE(3039),
    [sym_fsi_directive_decl] = STATE(3039),
    [sym_preproc_line] = STATE(3039),
    [sym_identifier] = ACTIONS(3917),
    [anon_sym_EQ] = ACTIONS(3915),
    [anon_sym_COLON] = ACTIONS(3917),
    [anon_sym_return] = ACTIONS(3917),
    [anon_sym_do] = ACTIONS(3917),
    [anon_sym_let] = ACTIONS(3917),
    [anon_sym_let_BANG] = ACTIONS(3915),
    [anon_sym_LPAREN] = ACTIONS(3917),
    [anon_sym_COMMA] = ACTIONS(3915),
    [anon_sym_null] = ACTIONS(3917),
    [anon_sym_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_COLON] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(3917),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3915),
    [anon_sym_LBRACE] = ACTIONS(3917),
    [anon_sym_LT_AT] = ACTIONS(3917),
    [anon_sym_LT_AT_AT] = ACTIONS(3917),
    [anon_sym_DOT] = ACTIONS(3917),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3915),
    [anon_sym_new] = ACTIONS(3917),
    [anon_sym_return_BANG] = ACTIONS(3915),
    [anon_sym_yield] = ACTIONS(3917),
    [anon_sym_yield_BANG] = ACTIONS(3915),
    [anon_sym_lazy] = ACTIONS(3917),
    [anon_sym_assert] = ACTIONS(3917),
    [anon_sym_upcast] = ACTIONS(3917),
    [anon_sym_downcast] = ACTIONS(3917),
    [anon_sym_COLON_GT] = ACTIONS(3915),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3915),
    [anon_sym_for] = ACTIONS(3917),
    [anon_sym_while] = ACTIONS(3917),
    [anon_sym_if] = ACTIONS(3917),
    [anon_sym_fun] = ACTIONS(3917),
    [anon_sym_DASH_GT] = ACTIONS(3917),
    [anon_sym_try] = ACTIONS(3917),
    [anon_sym_match] = ACTIONS(3917),
    [anon_sym_match_BANG] = ACTIONS(3915),
    [anon_sym_function] = ACTIONS(3917),
    [anon_sym_LT_DASH] = ACTIONS(3917),
    [anon_sym_DOT_LBRACK] = ACTIONS(3915),
    [anon_sym_LT] = ACTIONS(3915),
    [anon_sym_use] = ACTIONS(3917),
    [anon_sym_use_BANG] = ACTIONS(3915),
    [anon_sym_do_BANG] = ACTIONS(3915),
    [anon_sym_DOT_DOT] = ACTIONS(3915),
    [anon_sym_begin] = ACTIONS(3917),
    [anon_sym_LPAREN2] = ACTIONS(3917),
    [anon_sym_or] = ACTIONS(3917),
    [aux_sym_char_token1] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_AT_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [sym_bool] = ACTIONS(3917),
    [sym_unit] = ACTIONS(3915),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3917),
    [sym_op_identifier] = ACTIONS(3917),
    [anon_sym_PLUS] = ACTIONS(3917),
    [anon_sym_DASH] = ACTIONS(3917),
    [anon_sym_PLUS_DOT] = ACTIONS(3917),
    [anon_sym_DASH_DOT] = ACTIONS(3917),
    [anon_sym_PERCENT] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_TILDE] = ACTIONS(3915),
    [aux_sym_prefix_op_token1] = ACTIONS(3917),
    [aux_sym_infix_op_token1] = ACTIONS(3915),
    [aux_sym_infix_op_token2] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_BANG_EQ] = ACTIONS(3917),
    [anon_sym_COLON_EQ] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3917),
    [sym_int] = ACTIONS(3917),
    [sym_xint] = ACTIONS(3915),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3915),
    [sym__newline] = ACTIONS(3915),
  },
  [3040] = {
    [sym_block_comment] = STATE(3040),
    [sym_compiler_directive_decl] = STATE(3040),
    [sym_fsi_directive_decl] = STATE(3040),
    [sym_preproc_line] = STATE(3040),
    [sym_identifier] = ACTIONS(3931),
    [anon_sym_EQ] = ACTIONS(3929),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_do] = ACTIONS(3931),
    [anon_sym_let] = ACTIONS(3931),
    [anon_sym_let_BANG] = ACTIONS(3929),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_COMMA] = ACTIONS(3929),
    [anon_sym_null] = ACTIONS(3931),
    [anon_sym_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_COLON] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3931),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_LT_AT] = ACTIONS(3931),
    [anon_sym_LT_AT_AT] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3931),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3929),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_return_BANG] = ACTIONS(3929),
    [anon_sym_yield] = ACTIONS(3931),
    [anon_sym_yield_BANG] = ACTIONS(3929),
    [anon_sym_lazy] = ACTIONS(3931),
    [anon_sym_assert] = ACTIONS(3931),
    [anon_sym_upcast] = ACTIONS(3931),
    [anon_sym_downcast] = ACTIONS(3931),
    [anon_sym_COLON_GT] = ACTIONS(3929),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3929),
    [anon_sym_for] = ACTIONS(3931),
    [anon_sym_while] = ACTIONS(3931),
    [anon_sym_if] = ACTIONS(3931),
    [anon_sym_fun] = ACTIONS(3931),
    [anon_sym_DASH_GT] = ACTIONS(3931),
    [anon_sym_try] = ACTIONS(3931),
    [anon_sym_match] = ACTIONS(3931),
    [anon_sym_match_BANG] = ACTIONS(3929),
    [anon_sym_function] = ACTIONS(3931),
    [anon_sym_LT_DASH] = ACTIONS(3931),
    [anon_sym_DOT_LBRACK] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_use] = ACTIONS(3931),
    [anon_sym_use_BANG] = ACTIONS(3929),
    [anon_sym_do_BANG] = ACTIONS(3929),
    [anon_sym_DOT_DOT] = ACTIONS(3929),
    [anon_sym_begin] = ACTIONS(3931),
    [anon_sym_LPAREN2] = ACTIONS(3931),
    [anon_sym_or] = ACTIONS(3931),
    [aux_sym_char_token1] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3931),
    [anon_sym_DQUOTE] = ACTIONS(3931),
    [anon_sym_AT_DQUOTE] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [sym_bool] = ACTIONS(3931),
    [sym_unit] = ACTIONS(3929),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3931),
    [sym_op_identifier] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3931),
    [anon_sym_DASH] = ACTIONS(3931),
    [anon_sym_PLUS_DOT] = ACTIONS(3931),
    [anon_sym_DASH_DOT] = ACTIONS(3931),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_TILDE] = ACTIONS(3929),
    [aux_sym_prefix_op_token1] = ACTIONS(3931),
    [aux_sym_infix_op_token1] = ACTIONS(3929),
    [aux_sym_infix_op_token2] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_COLON_EQ] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3931),
    [sym_int] = ACTIONS(3931),
    [sym_xint] = ACTIONS(3929),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3929),
    [sym__newline] = ACTIONS(3929),
  },
  [3041] = {
    [sym_block_comment] = STATE(3041),
    [sym_compiler_directive_decl] = STATE(3041),
    [sym_fsi_directive_decl] = STATE(3041),
    [sym_preproc_line] = STATE(3041),
    [sym_identifier] = ACTIONS(3942),
    [anon_sym_EQ] = ACTIONS(3940),
    [anon_sym_COLON] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_let_BANG] = ACTIONS(3940),
    [anon_sym_LPAREN] = ACTIONS(3942),
    [anon_sym_COMMA] = ACTIONS(3940),
    [anon_sym_null] = ACTIONS(3942),
    [anon_sym_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3940),
    [anon_sym_LBRACE] = ACTIONS(3942),
    [anon_sym_LT_AT] = ACTIONS(3942),
    [anon_sym_LT_AT_AT] = ACTIONS(3942),
    [anon_sym_DOT] = ACTIONS(3942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3940),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_return_BANG] = ACTIONS(3940),
    [anon_sym_yield] = ACTIONS(3942),
    [anon_sym_yield_BANG] = ACTIONS(3940),
    [anon_sym_lazy] = ACTIONS(3942),
    [anon_sym_assert] = ACTIONS(3942),
    [anon_sym_upcast] = ACTIONS(3942),
    [anon_sym_downcast] = ACTIONS(3942),
    [anon_sym_COLON_GT] = ACTIONS(3940),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3940),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_fun] = ACTIONS(3942),
    [anon_sym_DASH_GT] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_match] = ACTIONS(3942),
    [anon_sym_match_BANG] = ACTIONS(3940),
    [anon_sym_function] = ACTIONS(3942),
    [anon_sym_LT_DASH] = ACTIONS(3942),
    [anon_sym_DOT_LBRACK] = ACTIONS(3940),
    [anon_sym_LT] = ACTIONS(3940),
    [anon_sym_use] = ACTIONS(3942),
    [anon_sym_use_BANG] = ACTIONS(3940),
    [anon_sym_do_BANG] = ACTIONS(3940),
    [anon_sym_DOT_DOT] = ACTIONS(3940),
    [anon_sym_begin] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3942),
    [anon_sym_or] = ACTIONS(3942),
    [aux_sym_char_token1] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3942),
    [anon_sym_DQUOTE] = ACTIONS(3942),
    [anon_sym_AT_DQUOTE] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [sym_bool] = ACTIONS(3942),
    [sym_unit] = ACTIONS(3940),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3942),
    [sym_op_identifier] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS_DOT] = ACTIONS(3942),
    [anon_sym_DASH_DOT] = ACTIONS(3942),
    [anon_sym_PERCENT] = ACTIONS(3942),
    [anon_sym_AMP_AMP] = ACTIONS(3942),
    [anon_sym_TILDE] = ACTIONS(3940),
    [aux_sym_prefix_op_token1] = ACTIONS(3942),
    [aux_sym_infix_op_token1] = ACTIONS(3940),
    [aux_sym_infix_op_token2] = ACTIONS(3942),
    [anon_sym_PIPE_PIPE] = ACTIONS(3942),
    [anon_sym_BANG_EQ] = ACTIONS(3942),
    [anon_sym_COLON_EQ] = ACTIONS(3940),
    [anon_sym_DOLLAR] = ACTIONS(3942),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3942),
    [sym_int] = ACTIONS(3942),
    [sym_xint] = ACTIONS(3940),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3940),
    [sym__newline] = ACTIONS(3940),
  },
  [3042] = {
    [sym_block_comment] = STATE(3042),
    [sym_compiler_directive_decl] = STATE(3042),
    [sym_fsi_directive_decl] = STATE(3042),
    [sym_preproc_line] = STATE(3042),
    [sym_identifier] = ACTIONS(3966),
    [anon_sym_EQ] = ACTIONS(3964),
    [anon_sym_COLON] = ACTIONS(3966),
    [anon_sym_return] = ACTIONS(3966),
    [anon_sym_do] = ACTIONS(3966),
    [anon_sym_let] = ACTIONS(3966),
    [anon_sym_let_BANG] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COMMA] = ACTIONS(3964),
    [anon_sym_null] = ACTIONS(3966),
    [anon_sym_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(3964),
    [anon_sym_AMP] = ACTIONS(3966),
    [anon_sym_LBRACK] = ACTIONS(3966),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3964),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_LT_AT] = ACTIONS(3966),
    [anon_sym_LT_AT_AT] = ACTIONS(3966),
    [anon_sym_DOT] = ACTIONS(3966),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3964),
    [anon_sym_new] = ACTIONS(3966),
    [anon_sym_return_BANG] = ACTIONS(3964),
    [anon_sym_yield] = ACTIONS(3966),
    [anon_sym_yield_BANG] = ACTIONS(3964),
    [anon_sym_lazy] = ACTIONS(3966),
    [anon_sym_assert] = ACTIONS(3966),
    [anon_sym_upcast] = ACTIONS(3966),
    [anon_sym_downcast] = ACTIONS(3966),
    [anon_sym_COLON_GT] = ACTIONS(3964),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3964),
    [anon_sym_for] = ACTIONS(3966),
    [anon_sym_while] = ACTIONS(3966),
    [anon_sym_if] = ACTIONS(3966),
    [anon_sym_fun] = ACTIONS(3966),
    [anon_sym_DASH_GT] = ACTIONS(3966),
    [anon_sym_try] = ACTIONS(3966),
    [anon_sym_match] = ACTIONS(3966),
    [anon_sym_match_BANG] = ACTIONS(3964),
    [anon_sym_function] = ACTIONS(3966),
    [anon_sym_LT_DASH] = ACTIONS(3966),
    [anon_sym_DOT_LBRACK] = ACTIONS(3964),
    [anon_sym_LT] = ACTIONS(3964),
    [anon_sym_use] = ACTIONS(3966),
    [anon_sym_use_BANG] = ACTIONS(3964),
    [anon_sym_do_BANG] = ACTIONS(3964),
    [anon_sym_DOT_DOT] = ACTIONS(3964),
    [anon_sym_begin] = ACTIONS(3966),
    [anon_sym_LPAREN2] = ACTIONS(3966),
    [anon_sym_or] = ACTIONS(3966),
    [aux_sym_char_token1] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3966),
    [anon_sym_DQUOTE] = ACTIONS(3966),
    [anon_sym_AT_DQUOTE] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [sym_bool] = ACTIONS(3966),
    [sym_unit] = ACTIONS(3964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3966),
    [sym_op_identifier] = ACTIONS(3966),
    [anon_sym_PLUS] = ACTIONS(3966),
    [anon_sym_DASH] = ACTIONS(3966),
    [anon_sym_PLUS_DOT] = ACTIONS(3966),
    [anon_sym_DASH_DOT] = ACTIONS(3966),
    [anon_sym_PERCENT] = ACTIONS(3966),
    [anon_sym_AMP_AMP] = ACTIONS(3966),
    [anon_sym_TILDE] = ACTIONS(3964),
    [aux_sym_prefix_op_token1] = ACTIONS(3966),
    [aux_sym_infix_op_token1] = ACTIONS(3964),
    [aux_sym_infix_op_token2] = ACTIONS(3966),
    [anon_sym_PIPE_PIPE] = ACTIONS(3966),
    [anon_sym_BANG_EQ] = ACTIONS(3966),
    [anon_sym_COLON_EQ] = ACTIONS(3964),
    [anon_sym_DOLLAR] = ACTIONS(3966),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3966),
    [sym_int] = ACTIONS(3966),
    [sym_xint] = ACTIONS(3964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3964),
    [sym__newline] = ACTIONS(3964),
  },
  [3043] = {
    [sym_block_comment] = STATE(3043),
    [sym_compiler_directive_decl] = STATE(3043),
    [sym_fsi_directive_decl] = STATE(3043),
    [sym_preproc_line] = STATE(3043),
    [sym_identifier] = ACTIONS(4130),
    [anon_sym_EQ] = ACTIONS(4128),
    [anon_sym_COLON] = ACTIONS(4130),
    [anon_sym_return] = ACTIONS(4130),
    [anon_sym_do] = ACTIONS(4130),
    [anon_sym_let] = ACTIONS(4130),
    [anon_sym_let_BANG] = ACTIONS(4128),
    [anon_sym_as] = ACTIONS(4130),
    [anon_sym_LPAREN] = ACTIONS(4130),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_null] = ACTIONS(4130),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_COLON] = ACTIONS(4128),
    [anon_sym_AMP] = ACTIONS(4130),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4128),
    [anon_sym_LBRACE] = ACTIONS(4130),
    [anon_sym_LT_AT] = ACTIONS(4130),
    [anon_sym_LT_AT_AT] = ACTIONS(4130),
    [anon_sym_DOT] = ACTIONS(4130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4128),
    [anon_sym_new] = ACTIONS(4130),
    [anon_sym_with] = ACTIONS(4130),
    [anon_sym_return_BANG] = ACTIONS(4128),
    [anon_sym_yield] = ACTIONS(4130),
    [anon_sym_yield_BANG] = ACTIONS(4128),
    [anon_sym_lazy] = ACTIONS(4130),
    [anon_sym_assert] = ACTIONS(4130),
    [anon_sym_upcast] = ACTIONS(4130),
    [anon_sym_downcast] = ACTIONS(4130),
    [anon_sym_COLON_GT] = ACTIONS(4128),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4128),
    [anon_sym_for] = ACTIONS(4130),
    [anon_sym_while] = ACTIONS(4130),
    [anon_sym_if] = ACTIONS(4130),
    [anon_sym_fun] = ACTIONS(4130),
    [anon_sym_try] = ACTIONS(4130),
    [anon_sym_match] = ACTIONS(4130),
    [anon_sym_match_BANG] = ACTIONS(4128),
    [anon_sym_function] = ACTIONS(4130),
    [anon_sym_LT_DASH] = ACTIONS(4130),
    [anon_sym_DOT_LBRACK] = ACTIONS(4128),
    [anon_sym_LT] = ACTIONS(4128),
    [anon_sym_use] = ACTIONS(4130),
    [anon_sym_use_BANG] = ACTIONS(4128),
    [anon_sym_do_BANG] = ACTIONS(4128),
    [anon_sym_begin] = ACTIONS(4130),
    [anon_sym_LPAREN2] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [aux_sym_char_token1] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4130),
    [anon_sym_DQUOTE] = ACTIONS(4130),
    [anon_sym_AT_DQUOTE] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [sym_bool] = ACTIONS(4130),
    [sym_unit] = ACTIONS(4128),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4130),
    [sym_op_identifier] = ACTIONS(4130),
    [anon_sym_PLUS] = ACTIONS(4130),
    [anon_sym_DASH] = ACTIONS(4130),
    [anon_sym_PLUS_DOT] = ACTIONS(4130),
    [anon_sym_DASH_DOT] = ACTIONS(4130),
    [anon_sym_PERCENT] = ACTIONS(4130),
    [anon_sym_AMP_AMP] = ACTIONS(4130),
    [anon_sym_TILDE] = ACTIONS(4128),
    [aux_sym_prefix_op_token1] = ACTIONS(4130),
    [aux_sym_infix_op_token1] = ACTIONS(4128),
    [aux_sym_infix_op_token2] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE] = ACTIONS(4130),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_COLON_EQ] = ACTIONS(4128),
    [anon_sym_DOLLAR] = ACTIONS(4130),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4130),
    [sym_int] = ACTIONS(4130),
    [sym_xint] = ACTIONS(4128),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4128),
    [sym__newline] = ACTIONS(4128),
  },
  [3044] = {
    [sym_block_comment] = STATE(3044),
    [sym_compiler_directive_decl] = STATE(3044),
    [sym_fsi_directive_decl] = STATE(3044),
    [sym_preproc_line] = STATE(3044),
    [sym_identifier] = ACTIONS(3885),
    [anon_sym_EQ] = ACTIONS(3883),
    [anon_sym_COLON] = ACTIONS(3885),
    [anon_sym_return] = ACTIONS(3885),
    [anon_sym_do] = ACTIONS(3885),
    [anon_sym_let] = ACTIONS(3885),
    [anon_sym_let_BANG] = ACTIONS(3883),
    [anon_sym_as] = ACTIONS(3885),
    [anon_sym_LPAREN] = ACTIONS(3885),
    [anon_sym_COMMA] = ACTIONS(3883),
    [anon_sym_null] = ACTIONS(3885),
    [anon_sym_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3883),
    [anon_sym_AMP] = ACTIONS(3885),
    [anon_sym_LBRACK] = ACTIONS(3885),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3883),
    [anon_sym_LBRACE] = ACTIONS(3885),
    [anon_sym_LT_AT] = ACTIONS(3885),
    [anon_sym_LT_AT_AT] = ACTIONS(3885),
    [anon_sym_DOT] = ACTIONS(3885),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3883),
    [anon_sym_new] = ACTIONS(3885),
    [anon_sym_with] = ACTIONS(3885),
    [anon_sym_return_BANG] = ACTIONS(3883),
    [anon_sym_yield] = ACTIONS(3885),
    [anon_sym_yield_BANG] = ACTIONS(3883),
    [anon_sym_lazy] = ACTIONS(3885),
    [anon_sym_assert] = ACTIONS(3885),
    [anon_sym_upcast] = ACTIONS(3885),
    [anon_sym_downcast] = ACTIONS(3885),
    [anon_sym_COLON_GT] = ACTIONS(3883),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3883),
    [anon_sym_for] = ACTIONS(3885),
    [anon_sym_while] = ACTIONS(3885),
    [anon_sym_if] = ACTIONS(3885),
    [anon_sym_fun] = ACTIONS(3885),
    [anon_sym_try] = ACTIONS(3885),
    [anon_sym_match] = ACTIONS(3885),
    [anon_sym_match_BANG] = ACTIONS(3883),
    [anon_sym_function] = ACTIONS(3885),
    [anon_sym_LT_DASH] = ACTIONS(3885),
    [anon_sym_DOT_LBRACK] = ACTIONS(3883),
    [anon_sym_LT] = ACTIONS(3883),
    [anon_sym_use] = ACTIONS(3885),
    [anon_sym_use_BANG] = ACTIONS(3883),
    [anon_sym_do_BANG] = ACTIONS(3883),
    [anon_sym_begin] = ACTIONS(3885),
    [anon_sym_LPAREN2] = ACTIONS(3885),
    [anon_sym_or] = ACTIONS(3885),
    [aux_sym_char_token1] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3885),
    [anon_sym_DQUOTE] = ACTIONS(3885),
    [anon_sym_AT_DQUOTE] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [sym_bool] = ACTIONS(3885),
    [sym_unit] = ACTIONS(3883),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3885),
    [sym_op_identifier] = ACTIONS(3885),
    [anon_sym_PLUS] = ACTIONS(3885),
    [anon_sym_DASH] = ACTIONS(3885),
    [anon_sym_PLUS_DOT] = ACTIONS(3885),
    [anon_sym_DASH_DOT] = ACTIONS(3885),
    [anon_sym_PERCENT] = ACTIONS(3885),
    [anon_sym_AMP_AMP] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3883),
    [aux_sym_prefix_op_token1] = ACTIONS(3885),
    [aux_sym_infix_op_token1] = ACTIONS(3883),
    [aux_sym_infix_op_token2] = ACTIONS(3885),
    [anon_sym_PIPE_PIPE] = ACTIONS(3885),
    [anon_sym_BANG_EQ] = ACTIONS(3885),
    [anon_sym_COLON_EQ] = ACTIONS(3883),
    [anon_sym_DOLLAR] = ACTIONS(3885),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3885),
    [sym_int] = ACTIONS(3885),
    [sym_xint] = ACTIONS(3883),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3883),
    [sym__newline] = ACTIONS(3883),
  },
  [3045] = {
    [sym_block_comment] = STATE(3045),
    [sym_compiler_directive_decl] = STATE(3045),
    [sym_fsi_directive_decl] = STATE(3045),
    [sym_preproc_line] = STATE(3045),
    [sym_identifier] = ACTIONS(3841),
    [anon_sym_EQ] = ACTIONS(3839),
    [anon_sym_COLON] = ACTIONS(3841),
    [anon_sym_return] = ACTIONS(3841),
    [anon_sym_do] = ACTIONS(3841),
    [anon_sym_let] = ACTIONS(3841),
    [anon_sym_let_BANG] = ACTIONS(3839),
    [anon_sym_LPAREN] = ACTIONS(3841),
    [anon_sym_COMMA] = ACTIONS(3839),
    [anon_sym_null] = ACTIONS(3841),
    [anon_sym_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_COLON] = ACTIONS(3839),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_AMP] = ACTIONS(3841),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(3841),
    [anon_sym_LT_AT] = ACTIONS(3841),
    [anon_sym_LT_AT_AT] = ACTIONS(3841),
    [anon_sym_AT_AT_GT] = ACTIONS(3841),
    [anon_sym_DOT] = ACTIONS(3841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3839),
    [anon_sym_new] = ACTIONS(3841),
    [anon_sym_return_BANG] = ACTIONS(3839),
    [anon_sym_yield] = ACTIONS(3841),
    [anon_sym_yield_BANG] = ACTIONS(3839),
    [anon_sym_lazy] = ACTIONS(3841),
    [anon_sym_assert] = ACTIONS(3841),
    [anon_sym_upcast] = ACTIONS(3841),
    [anon_sym_downcast] = ACTIONS(3841),
    [anon_sym_COLON_GT] = ACTIONS(3839),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3839),
    [anon_sym_for] = ACTIONS(3841),
    [anon_sym_while] = ACTIONS(3841),
    [anon_sym_if] = ACTIONS(3841),
    [anon_sym_fun] = ACTIONS(3841),
    [anon_sym_try] = ACTIONS(3841),
    [anon_sym_match] = ACTIONS(3841),
    [anon_sym_match_BANG] = ACTIONS(3839),
    [anon_sym_function] = ACTIONS(3841),
    [anon_sym_LT_DASH] = ACTIONS(3841),
    [anon_sym_DOT_LBRACK] = ACTIONS(3839),
    [anon_sym_LT] = ACTIONS(3839),
    [anon_sym_use] = ACTIONS(3841),
    [anon_sym_use_BANG] = ACTIONS(3839),
    [anon_sym_do_BANG] = ACTIONS(3839),
    [anon_sym_begin] = ACTIONS(3841),
    [anon_sym_LPAREN2] = ACTIONS(3841),
    [anon_sym_or] = ACTIONS(3841),
    [aux_sym_char_token1] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3841),
    [anon_sym_DQUOTE] = ACTIONS(3841),
    [anon_sym_AT_DQUOTE] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [sym_bool] = ACTIONS(3841),
    [sym_unit] = ACTIONS(3839),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3841),
    [sym_op_identifier] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_PLUS_DOT] = ACTIONS(3841),
    [anon_sym_DASH_DOT] = ACTIONS(3841),
    [anon_sym_PERCENT] = ACTIONS(3841),
    [anon_sym_AMP_AMP] = ACTIONS(3841),
    [anon_sym_TILDE] = ACTIONS(3839),
    [aux_sym_prefix_op_token1] = ACTIONS(3841),
    [aux_sym_infix_op_token1] = ACTIONS(3839),
    [aux_sym_infix_op_token2] = ACTIONS(3841),
    [anon_sym_PIPE_PIPE] = ACTIONS(3841),
    [anon_sym_BANG_EQ] = ACTIONS(3841),
    [anon_sym_COLON_EQ] = ACTIONS(3839),
    [anon_sym_DOLLAR] = ACTIONS(3841),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3841),
    [sym_int] = ACTIONS(3841),
    [sym_xint] = ACTIONS(3839),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3839),
    [sym__newline] = ACTIONS(3839),
  },
  [3046] = {
    [sym_block_comment] = STATE(3046),
    [sym_compiler_directive_decl] = STATE(3046),
    [sym_fsi_directive_decl] = STATE(3046),
    [sym_preproc_line] = STATE(3046),
    [sym_identifier] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3774),
    [anon_sym_do] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3774),
    [anon_sym_let_BANG] = ACTIONS(3772),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3772),
    [anon_sym_null] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_COLON] = ACTIONS(3772),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_LT_AT] = ACTIONS(3774),
    [anon_sym_LT_AT_AT] = ACTIONS(3774),
    [anon_sym_AT_AT_GT] = ACTIONS(3774),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3772),
    [anon_sym_new] = ACTIONS(3774),
    [anon_sym_return_BANG] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3774),
    [anon_sym_yield_BANG] = ACTIONS(3772),
    [anon_sym_lazy] = ACTIONS(3774),
    [anon_sym_assert] = ACTIONS(3774),
    [anon_sym_upcast] = ACTIONS(3774),
    [anon_sym_downcast] = ACTIONS(3774),
    [anon_sym_COLON_GT] = ACTIONS(3772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3774),
    [anon_sym_done] = ACTIONS(5647),
    [anon_sym_while] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3774),
    [anon_sym_fun] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3774),
    [anon_sym_match] = ACTIONS(3774),
    [anon_sym_match_BANG] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3774),
    [anon_sym_LT_DASH] = ACTIONS(3774),
    [anon_sym_DOT_LBRACK] = ACTIONS(3772),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_use] = ACTIONS(3774),
    [anon_sym_use_BANG] = ACTIONS(3772),
    [anon_sym_do_BANG] = ACTIONS(3772),
    [anon_sym_begin] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3774),
    [anon_sym_or] = ACTIONS(3774),
    [aux_sym_char_token1] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_AT_DQUOTE] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [sym_bool] = ACTIONS(3774),
    [sym_unit] = ACTIONS(3772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3774),
    [sym_op_identifier] = ACTIONS(3774),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_DOT] = ACTIONS(3774),
    [anon_sym_DASH_DOT] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3772),
    [aux_sym_prefix_op_token1] = ACTIONS(3774),
    [aux_sym_infix_op_token1] = ACTIONS(3772),
    [aux_sym_infix_op_token2] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3774),
    [anon_sym_COLON_EQ] = ACTIONS(3772),
    [anon_sym_DOLLAR] = ACTIONS(3774),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3774),
    [sym_int] = ACTIONS(3774),
    [sym_xint] = ACTIONS(3772),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3772),
    [sym__newline] = ACTIONS(3772),
  },
  [3047] = {
    [sym_block_comment] = STATE(3047),
    [sym_compiler_directive_decl] = STATE(3047),
    [sym_fsi_directive_decl] = STATE(3047),
    [sym_preproc_line] = STATE(3047),
    [sym_identifier] = ACTIONS(3980),
    [anon_sym_EQ] = ACTIONS(3978),
    [anon_sym_COLON] = ACTIONS(3980),
    [anon_sym_return] = ACTIONS(3980),
    [anon_sym_do] = ACTIONS(3980),
    [anon_sym_let] = ACTIONS(3980),
    [anon_sym_let_BANG] = ACTIONS(3978),
    [anon_sym_LPAREN] = ACTIONS(3980),
    [anon_sym_COMMA] = ACTIONS(3978),
    [anon_sym_null] = ACTIONS(3980),
    [anon_sym_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3978),
    [anon_sym_AMP] = ACTIONS(3980),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3978),
    [anon_sym_LBRACE] = ACTIONS(3980),
    [anon_sym_LT_AT] = ACTIONS(3980),
    [anon_sym_LT_AT_AT] = ACTIONS(3980),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3978),
    [anon_sym_new] = ACTIONS(3980),
    [anon_sym_return_BANG] = ACTIONS(3978),
    [anon_sym_yield] = ACTIONS(3980),
    [anon_sym_yield_BANG] = ACTIONS(3978),
    [anon_sym_lazy] = ACTIONS(3980),
    [anon_sym_assert] = ACTIONS(3980),
    [anon_sym_upcast] = ACTIONS(3980),
    [anon_sym_downcast] = ACTIONS(3980),
    [anon_sym_COLON_GT] = ACTIONS(3978),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3978),
    [anon_sym_for] = ACTIONS(3980),
    [anon_sym_while] = ACTIONS(3980),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_fun] = ACTIONS(3980),
    [anon_sym_DASH_GT] = ACTIONS(3980),
    [anon_sym_try] = ACTIONS(3980),
    [anon_sym_match] = ACTIONS(3980),
    [anon_sym_match_BANG] = ACTIONS(3978),
    [anon_sym_function] = ACTIONS(3980),
    [anon_sym_LT_DASH] = ACTIONS(3980),
    [anon_sym_DOT_LBRACK] = ACTIONS(3978),
    [anon_sym_LT] = ACTIONS(3978),
    [anon_sym_use] = ACTIONS(3980),
    [anon_sym_use_BANG] = ACTIONS(3978),
    [anon_sym_do_BANG] = ACTIONS(3978),
    [anon_sym_DOT_DOT] = ACTIONS(3978),
    [anon_sym_begin] = ACTIONS(3980),
    [anon_sym_LPAREN2] = ACTIONS(3980),
    [anon_sym_or] = ACTIONS(3980),
    [aux_sym_char_token1] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3980),
    [anon_sym_DQUOTE] = ACTIONS(3980),
    [anon_sym_AT_DQUOTE] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [sym_bool] = ACTIONS(3980),
    [sym_unit] = ACTIONS(3978),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3980),
    [sym_op_identifier] = ACTIONS(3980),
    [anon_sym_PLUS] = ACTIONS(3980),
    [anon_sym_DASH] = ACTIONS(3980),
    [anon_sym_PLUS_DOT] = ACTIONS(3980),
    [anon_sym_DASH_DOT] = ACTIONS(3980),
    [anon_sym_PERCENT] = ACTIONS(3980),
    [anon_sym_AMP_AMP] = ACTIONS(3980),
    [anon_sym_TILDE] = ACTIONS(3978),
    [aux_sym_prefix_op_token1] = ACTIONS(3980),
    [aux_sym_infix_op_token1] = ACTIONS(3978),
    [aux_sym_infix_op_token2] = ACTIONS(3980),
    [anon_sym_PIPE_PIPE] = ACTIONS(3980),
    [anon_sym_BANG_EQ] = ACTIONS(3980),
    [anon_sym_COLON_EQ] = ACTIONS(3978),
    [anon_sym_DOLLAR] = ACTIONS(3980),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3980),
    [sym_int] = ACTIONS(3980),
    [sym_xint] = ACTIONS(3978),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3978),
    [sym__newline] = ACTIONS(3978),
  },
  [3048] = {
    [sym_block_comment] = STATE(3048),
    [sym_compiler_directive_decl] = STATE(3048),
    [sym_fsi_directive_decl] = STATE(3048),
    [sym_preproc_line] = STATE(3048),
    [sym_identifier] = ACTIONS(4130),
    [anon_sym_EQ] = ACTIONS(4128),
    [anon_sym_COLON] = ACTIONS(4130),
    [anon_sym_return] = ACTIONS(4130),
    [anon_sym_do] = ACTIONS(4130),
    [anon_sym_let] = ACTIONS(4130),
    [anon_sym_let_BANG] = ACTIONS(4128),
    [anon_sym_LPAREN] = ACTIONS(4130),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_null] = ACTIONS(4130),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_COLON] = ACTIONS(4128),
    [anon_sym_AMP] = ACTIONS(4130),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4128),
    [anon_sym_LBRACE] = ACTIONS(4130),
    [anon_sym_LT_AT] = ACTIONS(4130),
    [anon_sym_LT_AT_AT] = ACTIONS(4130),
    [anon_sym_DOT] = ACTIONS(4130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4128),
    [anon_sym_new] = ACTIONS(4130),
    [anon_sym_return_BANG] = ACTIONS(4128),
    [anon_sym_yield] = ACTIONS(4130),
    [anon_sym_yield_BANG] = ACTIONS(4128),
    [anon_sym_lazy] = ACTIONS(4130),
    [anon_sym_assert] = ACTIONS(4130),
    [anon_sym_upcast] = ACTIONS(4130),
    [anon_sym_downcast] = ACTIONS(4130),
    [anon_sym_COLON_GT] = ACTIONS(4128),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4128),
    [anon_sym_for] = ACTIONS(4130),
    [anon_sym_while] = ACTIONS(4130),
    [anon_sym_if] = ACTIONS(4130),
    [anon_sym_fun] = ACTIONS(4130),
    [anon_sym_DASH_GT] = ACTIONS(4130),
    [anon_sym_try] = ACTIONS(4130),
    [anon_sym_match] = ACTIONS(4130),
    [anon_sym_match_BANG] = ACTIONS(4128),
    [anon_sym_function] = ACTIONS(4130),
    [anon_sym_LT_DASH] = ACTIONS(4130),
    [anon_sym_DOT_LBRACK] = ACTIONS(4128),
    [anon_sym_LT] = ACTIONS(4128),
    [anon_sym_use] = ACTIONS(4130),
    [anon_sym_use_BANG] = ACTIONS(4128),
    [anon_sym_do_BANG] = ACTIONS(4128),
    [anon_sym_DOT_DOT] = ACTIONS(4128),
    [anon_sym_begin] = ACTIONS(4130),
    [anon_sym_LPAREN2] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [aux_sym_char_token1] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4130),
    [anon_sym_DQUOTE] = ACTIONS(4130),
    [anon_sym_AT_DQUOTE] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [sym_bool] = ACTIONS(4130),
    [sym_unit] = ACTIONS(4128),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4130),
    [sym_op_identifier] = ACTIONS(4130),
    [anon_sym_PLUS] = ACTIONS(4130),
    [anon_sym_DASH] = ACTIONS(4130),
    [anon_sym_PLUS_DOT] = ACTIONS(4130),
    [anon_sym_DASH_DOT] = ACTIONS(4130),
    [anon_sym_PERCENT] = ACTIONS(4130),
    [anon_sym_AMP_AMP] = ACTIONS(4130),
    [anon_sym_TILDE] = ACTIONS(4128),
    [aux_sym_prefix_op_token1] = ACTIONS(4130),
    [aux_sym_infix_op_token1] = ACTIONS(4128),
    [aux_sym_infix_op_token2] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE] = ACTIONS(4130),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_COLON_EQ] = ACTIONS(4128),
    [anon_sym_DOLLAR] = ACTIONS(4130),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4130),
    [sym_int] = ACTIONS(4130),
    [sym_xint] = ACTIONS(4128),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4128),
    [sym__newline] = ACTIONS(4128),
  },
  [3049] = {
    [sym_block_comment] = STATE(3049),
    [sym_compiler_directive_decl] = STATE(3049),
    [sym_fsi_directive_decl] = STATE(3049),
    [sym_preproc_line] = STATE(3049),
    [sym_identifier] = ACTIONS(3885),
    [anon_sym_EQ] = ACTIONS(3883),
    [anon_sym_COLON] = ACTIONS(3885),
    [anon_sym_return] = ACTIONS(3885),
    [anon_sym_do] = ACTIONS(3885),
    [anon_sym_let] = ACTIONS(3885),
    [anon_sym_let_BANG] = ACTIONS(3883),
    [anon_sym_LPAREN] = ACTIONS(3885),
    [anon_sym_COMMA] = ACTIONS(3883),
    [anon_sym_null] = ACTIONS(3885),
    [anon_sym_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3883),
    [anon_sym_AMP] = ACTIONS(3885),
    [anon_sym_LBRACK] = ACTIONS(3885),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3883),
    [anon_sym_LBRACE] = ACTIONS(3885),
    [anon_sym_LT_AT] = ACTIONS(3885),
    [anon_sym_LT_AT_AT] = ACTIONS(3885),
    [anon_sym_DOT] = ACTIONS(3885),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3883),
    [anon_sym_new] = ACTIONS(3885),
    [anon_sym_return_BANG] = ACTIONS(3883),
    [anon_sym_yield] = ACTIONS(3885),
    [anon_sym_yield_BANG] = ACTIONS(3883),
    [anon_sym_lazy] = ACTIONS(3885),
    [anon_sym_assert] = ACTIONS(3885),
    [anon_sym_upcast] = ACTIONS(3885),
    [anon_sym_downcast] = ACTIONS(3885),
    [anon_sym_COLON_GT] = ACTIONS(3883),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3883),
    [anon_sym_for] = ACTIONS(3885),
    [anon_sym_while] = ACTIONS(3885),
    [anon_sym_if] = ACTIONS(3885),
    [anon_sym_fun] = ACTIONS(3885),
    [anon_sym_DASH_GT] = ACTIONS(3885),
    [anon_sym_try] = ACTIONS(3885),
    [anon_sym_match] = ACTIONS(3885),
    [anon_sym_match_BANG] = ACTIONS(3883),
    [anon_sym_function] = ACTIONS(3885),
    [anon_sym_LT_DASH] = ACTIONS(3885),
    [anon_sym_DOT_LBRACK] = ACTIONS(3883),
    [anon_sym_LT] = ACTIONS(3883),
    [anon_sym_use] = ACTIONS(3885),
    [anon_sym_use_BANG] = ACTIONS(3883),
    [anon_sym_do_BANG] = ACTIONS(3883),
    [anon_sym_DOT_DOT] = ACTIONS(3883),
    [anon_sym_begin] = ACTIONS(3885),
    [anon_sym_LPAREN2] = ACTIONS(3885),
    [anon_sym_or] = ACTIONS(3885),
    [aux_sym_char_token1] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3885),
    [anon_sym_DQUOTE] = ACTIONS(3885),
    [anon_sym_AT_DQUOTE] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [sym_bool] = ACTIONS(3885),
    [sym_unit] = ACTIONS(3883),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3885),
    [sym_op_identifier] = ACTIONS(3885),
    [anon_sym_PLUS] = ACTIONS(3885),
    [anon_sym_DASH] = ACTIONS(3885),
    [anon_sym_PLUS_DOT] = ACTIONS(3885),
    [anon_sym_DASH_DOT] = ACTIONS(3885),
    [anon_sym_PERCENT] = ACTIONS(3885),
    [anon_sym_AMP_AMP] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3883),
    [aux_sym_prefix_op_token1] = ACTIONS(3885),
    [aux_sym_infix_op_token1] = ACTIONS(3883),
    [aux_sym_infix_op_token2] = ACTIONS(3885),
    [anon_sym_PIPE_PIPE] = ACTIONS(3885),
    [anon_sym_BANG_EQ] = ACTIONS(3885),
    [anon_sym_COLON_EQ] = ACTIONS(3883),
    [anon_sym_DOLLAR] = ACTIONS(3885),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3885),
    [sym_int] = ACTIONS(3885),
    [sym_xint] = ACTIONS(3883),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3883),
    [sym__newline] = ACTIONS(3883),
  },
  [3050] = {
    [sym_block_comment] = STATE(3050),
    [sym_compiler_directive_decl] = STATE(3050),
    [sym_fsi_directive_decl] = STATE(3050),
    [sym_preproc_line] = STATE(3050),
    [sym_identifier] = ACTIONS(3935),
    [anon_sym_EQ] = ACTIONS(3933),
    [anon_sym_COLON] = ACTIONS(3935),
    [anon_sym_return] = ACTIONS(3935),
    [anon_sym_do] = ACTIONS(3935),
    [anon_sym_let] = ACTIONS(3935),
    [anon_sym_let_BANG] = ACTIONS(3933),
    [anon_sym_LPAREN] = ACTIONS(3935),
    [anon_sym_COMMA] = ACTIONS(3933),
    [anon_sym_null] = ACTIONS(3935),
    [anon_sym_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3935),
    [anon_sym_LBRACK] = ACTIONS(3935),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3933),
    [anon_sym_LBRACE] = ACTIONS(3935),
    [anon_sym_LT_AT] = ACTIONS(3935),
    [anon_sym_LT_AT_AT] = ACTIONS(3935),
    [anon_sym_DOT] = ACTIONS(3935),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3933),
    [anon_sym_new] = ACTIONS(3935),
    [anon_sym_return_BANG] = ACTIONS(3933),
    [anon_sym_yield] = ACTIONS(3935),
    [anon_sym_yield_BANG] = ACTIONS(3933),
    [anon_sym_lazy] = ACTIONS(3935),
    [anon_sym_assert] = ACTIONS(3935),
    [anon_sym_upcast] = ACTIONS(3935),
    [anon_sym_downcast] = ACTIONS(3935),
    [anon_sym_COLON_GT] = ACTIONS(3933),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3933),
    [anon_sym_for] = ACTIONS(3935),
    [anon_sym_while] = ACTIONS(3935),
    [anon_sym_if] = ACTIONS(3935),
    [anon_sym_fun] = ACTIONS(3935),
    [anon_sym_DASH_GT] = ACTIONS(3935),
    [anon_sym_try] = ACTIONS(3935),
    [anon_sym_match] = ACTIONS(3935),
    [anon_sym_match_BANG] = ACTIONS(3933),
    [anon_sym_function] = ACTIONS(3935),
    [anon_sym_LT_DASH] = ACTIONS(3935),
    [anon_sym_DOT_LBRACK] = ACTIONS(3933),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_use] = ACTIONS(3935),
    [anon_sym_use_BANG] = ACTIONS(3933),
    [anon_sym_do_BANG] = ACTIONS(3933),
    [anon_sym_DOT_DOT] = ACTIONS(3933),
    [anon_sym_begin] = ACTIONS(3935),
    [anon_sym_LPAREN2] = ACTIONS(3935),
    [anon_sym_or] = ACTIONS(3935),
    [aux_sym_char_token1] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3935),
    [anon_sym_DQUOTE] = ACTIONS(3935),
    [anon_sym_AT_DQUOTE] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [sym_bool] = ACTIONS(3935),
    [sym_unit] = ACTIONS(3933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3935),
    [sym_op_identifier] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(3935),
    [anon_sym_DASH] = ACTIONS(3935),
    [anon_sym_PLUS_DOT] = ACTIONS(3935),
    [anon_sym_DASH_DOT] = ACTIONS(3935),
    [anon_sym_PERCENT] = ACTIONS(3935),
    [anon_sym_AMP_AMP] = ACTIONS(3935),
    [anon_sym_TILDE] = ACTIONS(3933),
    [aux_sym_prefix_op_token1] = ACTIONS(3935),
    [aux_sym_infix_op_token1] = ACTIONS(3933),
    [aux_sym_infix_op_token2] = ACTIONS(3935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3935),
    [anon_sym_BANG_EQ] = ACTIONS(3935),
    [anon_sym_COLON_EQ] = ACTIONS(3933),
    [anon_sym_DOLLAR] = ACTIONS(3935),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3935),
    [sym_int] = ACTIONS(3935),
    [sym_xint] = ACTIONS(3933),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3933),
    [sym__newline] = ACTIONS(3933),
  },
  [3051] = {
    [sym_block_comment] = STATE(3051),
    [sym_compiler_directive_decl] = STATE(3051),
    [sym_fsi_directive_decl] = STATE(3051),
    [sym_preproc_line] = STATE(3051),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_EQ] = ACTIONS(3948),
    [anon_sym_COLON] = ACTIONS(3950),
    [anon_sym_return] = ACTIONS(3950),
    [anon_sym_do] = ACTIONS(3950),
    [anon_sym_let] = ACTIONS(3950),
    [anon_sym_let_BANG] = ACTIONS(3948),
    [anon_sym_LPAREN] = ACTIONS(3950),
    [anon_sym_COMMA] = ACTIONS(3948),
    [anon_sym_null] = ACTIONS(3950),
    [anon_sym_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_COLON] = ACTIONS(3948),
    [anon_sym_AMP] = ACTIONS(3950),
    [anon_sym_LBRACK] = ACTIONS(3950),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3948),
    [anon_sym_LBRACE] = ACTIONS(3950),
    [anon_sym_LT_AT] = ACTIONS(3950),
    [anon_sym_LT_AT_AT] = ACTIONS(3950),
    [anon_sym_DOT] = ACTIONS(3950),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3948),
    [anon_sym_new] = ACTIONS(3950),
    [anon_sym_return_BANG] = ACTIONS(3948),
    [anon_sym_yield] = ACTIONS(3950),
    [anon_sym_yield_BANG] = ACTIONS(3948),
    [anon_sym_lazy] = ACTIONS(3950),
    [anon_sym_assert] = ACTIONS(3950),
    [anon_sym_upcast] = ACTIONS(3950),
    [anon_sym_downcast] = ACTIONS(3950),
    [anon_sym_COLON_GT] = ACTIONS(3948),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3948),
    [anon_sym_for] = ACTIONS(3950),
    [anon_sym_while] = ACTIONS(3950),
    [anon_sym_if] = ACTIONS(3950),
    [anon_sym_fun] = ACTIONS(3950),
    [anon_sym_DASH_GT] = ACTIONS(3950),
    [anon_sym_try] = ACTIONS(3950),
    [anon_sym_match] = ACTIONS(3950),
    [anon_sym_match_BANG] = ACTIONS(3948),
    [anon_sym_function] = ACTIONS(3950),
    [anon_sym_LT_DASH] = ACTIONS(3950),
    [anon_sym_DOT_LBRACK] = ACTIONS(3948),
    [anon_sym_LT] = ACTIONS(3948),
    [anon_sym_use] = ACTIONS(3950),
    [anon_sym_use_BANG] = ACTIONS(3948),
    [anon_sym_do_BANG] = ACTIONS(3948),
    [anon_sym_DOT_DOT] = ACTIONS(3948),
    [anon_sym_begin] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3950),
    [anon_sym_or] = ACTIONS(3950),
    [aux_sym_char_token1] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3950),
    [anon_sym_DQUOTE] = ACTIONS(3950),
    [anon_sym_AT_DQUOTE] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [sym_bool] = ACTIONS(3950),
    [sym_unit] = ACTIONS(3948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3950),
    [sym_op_identifier] = ACTIONS(3950),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_DASH] = ACTIONS(3950),
    [anon_sym_PLUS_DOT] = ACTIONS(3950),
    [anon_sym_DASH_DOT] = ACTIONS(3950),
    [anon_sym_PERCENT] = ACTIONS(3950),
    [anon_sym_AMP_AMP] = ACTIONS(3950),
    [anon_sym_TILDE] = ACTIONS(3948),
    [aux_sym_prefix_op_token1] = ACTIONS(3950),
    [aux_sym_infix_op_token1] = ACTIONS(3948),
    [aux_sym_infix_op_token2] = ACTIONS(3950),
    [anon_sym_PIPE_PIPE] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3950),
    [anon_sym_COLON_EQ] = ACTIONS(3948),
    [anon_sym_DOLLAR] = ACTIONS(3950),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3950),
    [sym_int] = ACTIONS(3950),
    [sym_xint] = ACTIONS(3948),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3948),
    [sym__newline] = ACTIONS(3948),
  },
  [3052] = {
    [sym_block_comment] = STATE(3052),
    [sym_compiler_directive_decl] = STATE(3052),
    [sym_fsi_directive_decl] = STATE(3052),
    [sym_preproc_line] = STATE(3052),
    [sym_identifier] = ACTIONS(3935),
    [anon_sym_EQ] = ACTIONS(3933),
    [anon_sym_COLON] = ACTIONS(3935),
    [anon_sym_return] = ACTIONS(3935),
    [anon_sym_do] = ACTIONS(3935),
    [anon_sym_let] = ACTIONS(3935),
    [anon_sym_let_BANG] = ACTIONS(3933),
    [anon_sym_as] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3935),
    [anon_sym_COMMA] = ACTIONS(3933),
    [anon_sym_null] = ACTIONS(3935),
    [anon_sym_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3935),
    [anon_sym_LBRACK] = ACTIONS(3935),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3933),
    [anon_sym_LBRACE] = ACTIONS(3935),
    [anon_sym_LT_AT] = ACTIONS(3935),
    [anon_sym_LT_AT_AT] = ACTIONS(3935),
    [anon_sym_DOT] = ACTIONS(3935),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3933),
    [anon_sym_new] = ACTIONS(3935),
    [anon_sym_with] = ACTIONS(3935),
    [anon_sym_return_BANG] = ACTIONS(3933),
    [anon_sym_yield] = ACTIONS(3935),
    [anon_sym_yield_BANG] = ACTIONS(3933),
    [anon_sym_lazy] = ACTIONS(3935),
    [anon_sym_assert] = ACTIONS(3935),
    [anon_sym_upcast] = ACTIONS(3935),
    [anon_sym_downcast] = ACTIONS(3935),
    [anon_sym_COLON_GT] = ACTIONS(3933),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3933),
    [anon_sym_for] = ACTIONS(3935),
    [anon_sym_while] = ACTIONS(3935),
    [anon_sym_if] = ACTIONS(3935),
    [anon_sym_fun] = ACTIONS(3935),
    [anon_sym_try] = ACTIONS(3935),
    [anon_sym_match] = ACTIONS(3935),
    [anon_sym_match_BANG] = ACTIONS(3933),
    [anon_sym_function] = ACTIONS(3935),
    [anon_sym_LT_DASH] = ACTIONS(3935),
    [anon_sym_DOT_LBRACK] = ACTIONS(3933),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_use] = ACTIONS(3935),
    [anon_sym_use_BANG] = ACTIONS(3933),
    [anon_sym_do_BANG] = ACTIONS(3933),
    [anon_sym_begin] = ACTIONS(3935),
    [anon_sym_LPAREN2] = ACTIONS(3935),
    [anon_sym_or] = ACTIONS(3935),
    [aux_sym_char_token1] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3935),
    [anon_sym_DQUOTE] = ACTIONS(3935),
    [anon_sym_AT_DQUOTE] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [sym_bool] = ACTIONS(3935),
    [sym_unit] = ACTIONS(3933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3935),
    [sym_op_identifier] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(3935),
    [anon_sym_DASH] = ACTIONS(3935),
    [anon_sym_PLUS_DOT] = ACTIONS(3935),
    [anon_sym_DASH_DOT] = ACTIONS(3935),
    [anon_sym_PERCENT] = ACTIONS(3935),
    [anon_sym_AMP_AMP] = ACTIONS(3935),
    [anon_sym_TILDE] = ACTIONS(3933),
    [aux_sym_prefix_op_token1] = ACTIONS(3935),
    [aux_sym_infix_op_token1] = ACTIONS(3933),
    [aux_sym_infix_op_token2] = ACTIONS(3935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3935),
    [anon_sym_BANG_EQ] = ACTIONS(3935),
    [anon_sym_COLON_EQ] = ACTIONS(3933),
    [anon_sym_DOLLAR] = ACTIONS(3935),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3935),
    [sym_int] = ACTIONS(3935),
    [sym_xint] = ACTIONS(3933),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3933),
    [sym__newline] = ACTIONS(3933),
  },
  [3053] = {
    [sym_block_comment] = STATE(3053),
    [sym_compiler_directive_decl] = STATE(3053),
    [sym_fsi_directive_decl] = STATE(3053),
    [sym_preproc_line] = STATE(3053),
    [sym_identifier] = ACTIONS(3954),
    [anon_sym_EQ] = ACTIONS(3952),
    [anon_sym_COLON] = ACTIONS(3954),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_do] = ACTIONS(3954),
    [anon_sym_let] = ACTIONS(3954),
    [anon_sym_let_BANG] = ACTIONS(3952),
    [anon_sym_LPAREN] = ACTIONS(3954),
    [anon_sym_COMMA] = ACTIONS(3952),
    [anon_sym_null] = ACTIONS(3954),
    [anon_sym_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_COLON] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3954),
    [anon_sym_LBRACK] = ACTIONS(3954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(3954),
    [anon_sym_LT_AT] = ACTIONS(3954),
    [anon_sym_LT_AT_AT] = ACTIONS(3954),
    [anon_sym_DOT] = ACTIONS(3954),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3952),
    [anon_sym_new] = ACTIONS(3954),
    [anon_sym_return_BANG] = ACTIONS(3952),
    [anon_sym_yield] = ACTIONS(3954),
    [anon_sym_yield_BANG] = ACTIONS(3952),
    [anon_sym_lazy] = ACTIONS(3954),
    [anon_sym_assert] = ACTIONS(3954),
    [anon_sym_upcast] = ACTIONS(3954),
    [anon_sym_downcast] = ACTIONS(3954),
    [anon_sym_COLON_GT] = ACTIONS(3952),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3952),
    [anon_sym_for] = ACTIONS(3954),
    [anon_sym_while] = ACTIONS(3954),
    [anon_sym_if] = ACTIONS(3954),
    [anon_sym_fun] = ACTIONS(3954),
    [anon_sym_DASH_GT] = ACTIONS(3954),
    [anon_sym_try] = ACTIONS(3954),
    [anon_sym_match] = ACTIONS(3954),
    [anon_sym_match_BANG] = ACTIONS(3952),
    [anon_sym_function] = ACTIONS(3954),
    [anon_sym_LT_DASH] = ACTIONS(3954),
    [anon_sym_DOT_LBRACK] = ACTIONS(3952),
    [anon_sym_LT] = ACTIONS(3952),
    [anon_sym_use] = ACTIONS(3954),
    [anon_sym_use_BANG] = ACTIONS(3952),
    [anon_sym_do_BANG] = ACTIONS(3952),
    [anon_sym_DOT_DOT] = ACTIONS(3952),
    [anon_sym_begin] = ACTIONS(3954),
    [anon_sym_LPAREN2] = ACTIONS(3954),
    [anon_sym_or] = ACTIONS(3954),
    [aux_sym_char_token1] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3954),
    [anon_sym_DQUOTE] = ACTIONS(3954),
    [anon_sym_AT_DQUOTE] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [sym_bool] = ACTIONS(3954),
    [sym_unit] = ACTIONS(3952),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3954),
    [sym_op_identifier] = ACTIONS(3954),
    [anon_sym_PLUS] = ACTIONS(3954),
    [anon_sym_DASH] = ACTIONS(3954),
    [anon_sym_PLUS_DOT] = ACTIONS(3954),
    [anon_sym_DASH_DOT] = ACTIONS(3954),
    [anon_sym_PERCENT] = ACTIONS(3954),
    [anon_sym_AMP_AMP] = ACTIONS(3954),
    [anon_sym_TILDE] = ACTIONS(3952),
    [aux_sym_prefix_op_token1] = ACTIONS(3954),
    [aux_sym_infix_op_token1] = ACTIONS(3952),
    [aux_sym_infix_op_token2] = ACTIONS(3954),
    [anon_sym_PIPE_PIPE] = ACTIONS(3954),
    [anon_sym_BANG_EQ] = ACTIONS(3954),
    [anon_sym_COLON_EQ] = ACTIONS(3952),
    [anon_sym_DOLLAR] = ACTIONS(3954),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3954),
    [sym_int] = ACTIONS(3954),
    [sym_xint] = ACTIONS(3952),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3952),
    [sym__newline] = ACTIONS(3952),
  },
  [3054] = {
    [sym_block_comment] = STATE(3054),
    [sym_compiler_directive_decl] = STATE(3054),
    [sym_fsi_directive_decl] = STATE(3054),
    [sym_preproc_line] = STATE(3054),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_GT] = ACTIONS(3743),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_or] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [sym__newline] = ACTIONS(3741),
  },
  [3055] = {
    [sym_block_comment] = STATE(3055),
    [sym_compiler_directive_decl] = STATE(3055),
    [sym_fsi_directive_decl] = STATE(3055),
    [sym_preproc_line] = STATE(3055),
    [sym_identifier] = ACTIONS(3958),
    [anon_sym_EQ] = ACTIONS(3956),
    [anon_sym_COLON] = ACTIONS(3958),
    [anon_sym_return] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(3958),
    [anon_sym_let] = ACTIONS(3958),
    [anon_sym_let_BANG] = ACTIONS(3956),
    [anon_sym_LPAREN] = ACTIONS(3958),
    [anon_sym_COMMA] = ACTIONS(3956),
    [anon_sym_null] = ACTIONS(3958),
    [anon_sym_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_COLON] = ACTIONS(3956),
    [anon_sym_AMP] = ACTIONS(3958),
    [anon_sym_LBRACK] = ACTIONS(3958),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3956),
    [anon_sym_LBRACE] = ACTIONS(3958),
    [anon_sym_LT_AT] = ACTIONS(3958),
    [anon_sym_LT_AT_AT] = ACTIONS(3958),
    [anon_sym_DOT] = ACTIONS(3958),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3956),
    [anon_sym_new] = ACTIONS(3958),
    [anon_sym_return_BANG] = ACTIONS(3956),
    [anon_sym_yield] = ACTIONS(3958),
    [anon_sym_yield_BANG] = ACTIONS(3956),
    [anon_sym_lazy] = ACTIONS(3958),
    [anon_sym_assert] = ACTIONS(3958),
    [anon_sym_upcast] = ACTIONS(3958),
    [anon_sym_downcast] = ACTIONS(3958),
    [anon_sym_COLON_GT] = ACTIONS(3956),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3956),
    [anon_sym_for] = ACTIONS(3958),
    [anon_sym_while] = ACTIONS(3958),
    [anon_sym_if] = ACTIONS(3958),
    [anon_sym_fun] = ACTIONS(3958),
    [anon_sym_DASH_GT] = ACTIONS(3958),
    [anon_sym_try] = ACTIONS(3958),
    [anon_sym_match] = ACTIONS(3958),
    [anon_sym_match_BANG] = ACTIONS(3956),
    [anon_sym_function] = ACTIONS(3958),
    [anon_sym_LT_DASH] = ACTIONS(3958),
    [anon_sym_DOT_LBRACK] = ACTIONS(3956),
    [anon_sym_LT] = ACTIONS(3956),
    [anon_sym_use] = ACTIONS(3958),
    [anon_sym_use_BANG] = ACTIONS(3956),
    [anon_sym_do_BANG] = ACTIONS(3956),
    [anon_sym_DOT_DOT] = ACTIONS(3956),
    [anon_sym_begin] = ACTIONS(3958),
    [anon_sym_LPAREN2] = ACTIONS(3958),
    [anon_sym_or] = ACTIONS(3958),
    [aux_sym_char_token1] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [anon_sym_AT_DQUOTE] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [sym_bool] = ACTIONS(3958),
    [sym_unit] = ACTIONS(3956),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3958),
    [sym_op_identifier] = ACTIONS(3958),
    [anon_sym_PLUS] = ACTIONS(3958),
    [anon_sym_DASH] = ACTIONS(3958),
    [anon_sym_PLUS_DOT] = ACTIONS(3958),
    [anon_sym_DASH_DOT] = ACTIONS(3958),
    [anon_sym_PERCENT] = ACTIONS(3958),
    [anon_sym_AMP_AMP] = ACTIONS(3958),
    [anon_sym_TILDE] = ACTIONS(3956),
    [aux_sym_prefix_op_token1] = ACTIONS(3958),
    [aux_sym_infix_op_token1] = ACTIONS(3956),
    [aux_sym_infix_op_token2] = ACTIONS(3958),
    [anon_sym_PIPE_PIPE] = ACTIONS(3958),
    [anon_sym_BANG_EQ] = ACTIONS(3958),
    [anon_sym_COLON_EQ] = ACTIONS(3956),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3958),
    [sym_int] = ACTIONS(3958),
    [sym_xint] = ACTIONS(3956),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3956),
    [sym__newline] = ACTIONS(3956),
  },
  [3056] = {
    [sym_block_comment] = STATE(3056),
    [sym_compiler_directive_decl] = STATE(3056),
    [sym_fsi_directive_decl] = STATE(3056),
    [sym_preproc_line] = STATE(3056),
    [sym_identifier] = ACTIONS(3962),
    [anon_sym_EQ] = ACTIONS(3960),
    [anon_sym_COLON] = ACTIONS(3962),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_do] = ACTIONS(3962),
    [anon_sym_let] = ACTIONS(3962),
    [anon_sym_let_BANG] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_COMMA] = ACTIONS(3960),
    [anon_sym_null] = ACTIONS(3962),
    [anon_sym_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_COLON] = ACTIONS(3960),
    [anon_sym_AMP] = ACTIONS(3962),
    [anon_sym_LBRACK] = ACTIONS(3962),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_LT_AT] = ACTIONS(3962),
    [anon_sym_LT_AT_AT] = ACTIONS(3962),
    [anon_sym_DOT] = ACTIONS(3962),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3960),
    [anon_sym_new] = ACTIONS(3962),
    [anon_sym_return_BANG] = ACTIONS(3960),
    [anon_sym_yield] = ACTIONS(3962),
    [anon_sym_yield_BANG] = ACTIONS(3960),
    [anon_sym_lazy] = ACTIONS(3962),
    [anon_sym_assert] = ACTIONS(3962),
    [anon_sym_upcast] = ACTIONS(3962),
    [anon_sym_downcast] = ACTIONS(3962),
    [anon_sym_COLON_GT] = ACTIONS(3960),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3960),
    [anon_sym_for] = ACTIONS(3962),
    [anon_sym_while] = ACTIONS(3962),
    [anon_sym_if] = ACTIONS(3962),
    [anon_sym_fun] = ACTIONS(3962),
    [anon_sym_DASH_GT] = ACTIONS(3962),
    [anon_sym_try] = ACTIONS(3962),
    [anon_sym_match] = ACTIONS(3962),
    [anon_sym_match_BANG] = ACTIONS(3960),
    [anon_sym_function] = ACTIONS(3962),
    [anon_sym_LT_DASH] = ACTIONS(3962),
    [anon_sym_DOT_LBRACK] = ACTIONS(3960),
    [anon_sym_LT] = ACTIONS(3960),
    [anon_sym_use] = ACTIONS(3962),
    [anon_sym_use_BANG] = ACTIONS(3960),
    [anon_sym_do_BANG] = ACTIONS(3960),
    [anon_sym_DOT_DOT] = ACTIONS(3960),
    [anon_sym_begin] = ACTIONS(3962),
    [anon_sym_LPAREN2] = ACTIONS(3962),
    [anon_sym_or] = ACTIONS(3962),
    [aux_sym_char_token1] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3962),
    [anon_sym_DQUOTE] = ACTIONS(3962),
    [anon_sym_AT_DQUOTE] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [sym_bool] = ACTIONS(3962),
    [sym_unit] = ACTIONS(3960),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3962),
    [sym_op_identifier] = ACTIONS(3962),
    [anon_sym_PLUS] = ACTIONS(3962),
    [anon_sym_DASH] = ACTIONS(3962),
    [anon_sym_PLUS_DOT] = ACTIONS(3962),
    [anon_sym_DASH_DOT] = ACTIONS(3962),
    [anon_sym_PERCENT] = ACTIONS(3962),
    [anon_sym_AMP_AMP] = ACTIONS(3962),
    [anon_sym_TILDE] = ACTIONS(3960),
    [aux_sym_prefix_op_token1] = ACTIONS(3962),
    [aux_sym_infix_op_token1] = ACTIONS(3960),
    [aux_sym_infix_op_token2] = ACTIONS(3962),
    [anon_sym_PIPE_PIPE] = ACTIONS(3962),
    [anon_sym_BANG_EQ] = ACTIONS(3962),
    [anon_sym_COLON_EQ] = ACTIONS(3960),
    [anon_sym_DOLLAR] = ACTIONS(3962),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3962),
    [sym_int] = ACTIONS(3962),
    [sym_xint] = ACTIONS(3960),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3960),
    [sym__newline] = ACTIONS(3960),
  },
  [3057] = {
    [sym_block_comment] = STATE(3057),
    [sym_compiler_directive_decl] = STATE(3057),
    [sym_fsi_directive_decl] = STATE(3057),
    [sym_preproc_line] = STATE(3057),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_DOT_DOT] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [3058] = {
    [sym_block_comment] = STATE(3058),
    [sym_compiler_directive_decl] = STATE(3058),
    [sym_fsi_directive_decl] = STATE(3058),
    [sym_preproc_line] = STATE(3058),
    [sym_identifier] = ACTIONS(4232),
    [anon_sym_EQ] = ACTIONS(4230),
    [anon_sym_COLON] = ACTIONS(4232),
    [anon_sym_return] = ACTIONS(4232),
    [anon_sym_do] = ACTIONS(4232),
    [anon_sym_let] = ACTIONS(4232),
    [anon_sym_let_BANG] = ACTIONS(4230),
    [anon_sym_LPAREN] = ACTIONS(4232),
    [anon_sym_COMMA] = ACTIONS(4230),
    [anon_sym_null] = ACTIONS(4232),
    [anon_sym_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_COLON] = ACTIONS(4230),
    [anon_sym_AMP] = ACTIONS(4232),
    [anon_sym_LBRACK] = ACTIONS(4232),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4230),
    [anon_sym_LBRACE] = ACTIONS(4232),
    [anon_sym_LT_AT] = ACTIONS(4232),
    [anon_sym_LT_AT_AT] = ACTIONS(4232),
    [anon_sym_DOT] = ACTIONS(4232),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4230),
    [anon_sym_new] = ACTIONS(4232),
    [anon_sym_return_BANG] = ACTIONS(4230),
    [anon_sym_yield] = ACTIONS(4232),
    [anon_sym_yield_BANG] = ACTIONS(4230),
    [anon_sym_lazy] = ACTIONS(4232),
    [anon_sym_assert] = ACTIONS(4232),
    [anon_sym_upcast] = ACTIONS(4232),
    [anon_sym_downcast] = ACTIONS(4232),
    [anon_sym_COLON_GT] = ACTIONS(4230),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4230),
    [anon_sym_for] = ACTIONS(4232),
    [anon_sym_while] = ACTIONS(4232),
    [anon_sym_if] = ACTIONS(4232),
    [anon_sym_fun] = ACTIONS(4232),
    [anon_sym_DASH_GT] = ACTIONS(4232),
    [anon_sym_try] = ACTIONS(4232),
    [anon_sym_match] = ACTIONS(4232),
    [anon_sym_match_BANG] = ACTIONS(4230),
    [anon_sym_function] = ACTIONS(4232),
    [anon_sym_LT_DASH] = ACTIONS(4232),
    [anon_sym_DOT_LBRACK] = ACTIONS(4230),
    [anon_sym_LT] = ACTIONS(4230),
    [anon_sym_use] = ACTIONS(4232),
    [anon_sym_use_BANG] = ACTIONS(4230),
    [anon_sym_do_BANG] = ACTIONS(4230),
    [anon_sym_DOT_DOT] = ACTIONS(4230),
    [anon_sym_begin] = ACTIONS(4232),
    [anon_sym_LPAREN2] = ACTIONS(4232),
    [anon_sym_or] = ACTIONS(4232),
    [aux_sym_char_token1] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4232),
    [anon_sym_DQUOTE] = ACTIONS(4232),
    [anon_sym_AT_DQUOTE] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [sym_bool] = ACTIONS(4232),
    [sym_unit] = ACTIONS(4230),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4232),
    [sym_op_identifier] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4232),
    [anon_sym_DASH] = ACTIONS(4232),
    [anon_sym_PLUS_DOT] = ACTIONS(4232),
    [anon_sym_DASH_DOT] = ACTIONS(4232),
    [anon_sym_PERCENT] = ACTIONS(4232),
    [anon_sym_AMP_AMP] = ACTIONS(4232),
    [anon_sym_TILDE] = ACTIONS(4230),
    [aux_sym_prefix_op_token1] = ACTIONS(4232),
    [aux_sym_infix_op_token1] = ACTIONS(4230),
    [aux_sym_infix_op_token2] = ACTIONS(4232),
    [anon_sym_PIPE_PIPE] = ACTIONS(4232),
    [anon_sym_BANG_EQ] = ACTIONS(4232),
    [anon_sym_COLON_EQ] = ACTIONS(4230),
    [anon_sym_DOLLAR] = ACTIONS(4232),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4232),
    [sym_int] = ACTIONS(4232),
    [sym_xint] = ACTIONS(4230),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4230),
    [sym__newline] = ACTIONS(4230),
  },
  [3059] = {
    [sym_block_comment] = STATE(3059),
    [sym_compiler_directive_decl] = STATE(3059),
    [sym_fsi_directive_decl] = STATE(3059),
    [sym_preproc_line] = STATE(3059),
    [sym_identifier] = ACTIONS(4126),
    [anon_sym_EQ] = ACTIONS(4124),
    [anon_sym_COLON] = ACTIONS(4126),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_do] = ACTIONS(4126),
    [anon_sym_let] = ACTIONS(4126),
    [anon_sym_let_BANG] = ACTIONS(4124),
    [anon_sym_LPAREN] = ACTIONS(4126),
    [anon_sym_COMMA] = ACTIONS(4124),
    [anon_sym_null] = ACTIONS(4126),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_COLON] = ACTIONS(4124),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LBRACK] = ACTIONS(4126),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4126),
    [anon_sym_LT_AT] = ACTIONS(4126),
    [anon_sym_LT_AT_AT] = ACTIONS(4126),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4124),
    [anon_sym_new] = ACTIONS(4126),
    [anon_sym_return_BANG] = ACTIONS(4124),
    [anon_sym_yield] = ACTIONS(4126),
    [anon_sym_yield_BANG] = ACTIONS(4124),
    [anon_sym_lazy] = ACTIONS(4126),
    [anon_sym_assert] = ACTIONS(4126),
    [anon_sym_upcast] = ACTIONS(4126),
    [anon_sym_downcast] = ACTIONS(4126),
    [anon_sym_COLON_GT] = ACTIONS(4124),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4124),
    [anon_sym_for] = ACTIONS(4126),
    [anon_sym_while] = ACTIONS(4126),
    [anon_sym_if] = ACTIONS(4126),
    [anon_sym_fun] = ACTIONS(4126),
    [anon_sym_DASH_GT] = ACTIONS(4126),
    [anon_sym_try] = ACTIONS(4126),
    [anon_sym_match] = ACTIONS(4126),
    [anon_sym_match_BANG] = ACTIONS(4124),
    [anon_sym_function] = ACTIONS(4126),
    [anon_sym_LT_DASH] = ACTIONS(4126),
    [anon_sym_DOT_LBRACK] = ACTIONS(4124),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_use] = ACTIONS(4126),
    [anon_sym_use_BANG] = ACTIONS(4124),
    [anon_sym_do_BANG] = ACTIONS(4124),
    [anon_sym_DOT_DOT] = ACTIONS(4124),
    [anon_sym_begin] = ACTIONS(4126),
    [anon_sym_LPAREN2] = ACTIONS(4126),
    [anon_sym_or] = ACTIONS(4126),
    [aux_sym_char_token1] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4126),
    [anon_sym_DQUOTE] = ACTIONS(4126),
    [anon_sym_AT_DQUOTE] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [sym_bool] = ACTIONS(4126),
    [sym_unit] = ACTIONS(4124),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4126),
    [sym_op_identifier] = ACTIONS(4126),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_PLUS_DOT] = ACTIONS(4126),
    [anon_sym_DASH_DOT] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_AMP_AMP] = ACTIONS(4126),
    [anon_sym_TILDE] = ACTIONS(4124),
    [aux_sym_prefix_op_token1] = ACTIONS(4126),
    [aux_sym_infix_op_token1] = ACTIONS(4124),
    [aux_sym_infix_op_token2] = ACTIONS(4126),
    [anon_sym_PIPE_PIPE] = ACTIONS(4126),
    [anon_sym_BANG_EQ] = ACTIONS(4126),
    [anon_sym_COLON_EQ] = ACTIONS(4124),
    [anon_sym_DOLLAR] = ACTIONS(4126),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4126),
    [sym_int] = ACTIONS(4126),
    [sym_xint] = ACTIONS(4124),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4124),
    [sym__newline] = ACTIONS(4124),
  },
  [3060] = {
    [sym_block_comment] = STATE(3060),
    [sym_compiler_directive_decl] = STATE(3060),
    [sym_fsi_directive_decl] = STATE(3060),
    [sym_preproc_line] = STATE(3060),
    [sym_identifier] = ACTIONS(3800),
    [anon_sym_EQ] = ACTIONS(3798),
    [anon_sym_COLON] = ACTIONS(3800),
    [anon_sym_return] = ACTIONS(3800),
    [anon_sym_do] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_let_BANG] = ACTIONS(3798),
    [anon_sym_LPAREN] = ACTIONS(3800),
    [anon_sym_COMMA] = ACTIONS(3798),
    [anon_sym_null] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_COLON] = ACTIONS(3798),
    [anon_sym_PIPE] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3800),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3798),
    [anon_sym_LBRACE] = ACTIONS(3800),
    [anon_sym_LT_AT] = ACTIONS(3800),
    [anon_sym_LT_AT_AT] = ACTIONS(3800),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3798),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_return_BANG] = ACTIONS(3798),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_yield_BANG] = ACTIONS(3798),
    [anon_sym_lazy] = ACTIONS(3800),
    [anon_sym_assert] = ACTIONS(3800),
    [anon_sym_upcast] = ACTIONS(3800),
    [anon_sym_downcast] = ACTIONS(3800),
    [anon_sym_COLON_GT] = ACTIONS(3798),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3798),
    [anon_sym_for] = ACTIONS(3800),
    [anon_sym_while] = ACTIONS(3800),
    [anon_sym_if] = ACTIONS(3800),
    [anon_sym_fun] = ACTIONS(3800),
    [anon_sym_try] = ACTIONS(3800),
    [anon_sym_match] = ACTIONS(3800),
    [anon_sym_match_BANG] = ACTIONS(3798),
    [anon_sym_function] = ACTIONS(3800),
    [anon_sym_LT_DASH] = ACTIONS(3800),
    [anon_sym_DOT_LBRACK] = ACTIONS(3798),
    [anon_sym_LT] = ACTIONS(3798),
    [anon_sym_GT] = ACTIONS(3800),
    [anon_sym_use] = ACTIONS(3800),
    [anon_sym_use_BANG] = ACTIONS(3798),
    [anon_sym_do_BANG] = ACTIONS(3798),
    [anon_sym_begin] = ACTIONS(3800),
    [anon_sym_LPAREN2] = ACTIONS(3800),
    [anon_sym_or] = ACTIONS(3800),
    [aux_sym_char_token1] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3800),
    [anon_sym_DQUOTE] = ACTIONS(3800),
    [anon_sym_AT_DQUOTE] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [sym_bool] = ACTIONS(3800),
    [sym_unit] = ACTIONS(3798),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3800),
    [sym_op_identifier] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS_DOT] = ACTIONS(3800),
    [anon_sym_DASH_DOT] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3800),
    [anon_sym_AMP_AMP] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3798),
    [aux_sym_prefix_op_token1] = ACTIONS(3800),
    [aux_sym_infix_op_token1] = ACTIONS(3798),
    [aux_sym_infix_op_token2] = ACTIONS(3800),
    [anon_sym_PIPE_PIPE] = ACTIONS(3800),
    [anon_sym_BANG_EQ] = ACTIONS(3800),
    [anon_sym_COLON_EQ] = ACTIONS(3798),
    [anon_sym_DOLLAR] = ACTIONS(3800),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3800),
    [sym_int] = ACTIONS(3800),
    [sym_xint] = ACTIONS(3798),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3798),
    [sym__newline] = ACTIONS(3798),
  },
  [3061] = {
    [sym_block_comment] = STATE(3061),
    [sym_compiler_directive_decl] = STATE(3061),
    [sym_fsi_directive_decl] = STATE(3061),
    [sym_preproc_line] = STATE(3061),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_EQ] = ACTIONS(3948),
    [anon_sym_COLON] = ACTIONS(3950),
    [anon_sym_return] = ACTIONS(3950),
    [anon_sym_do] = ACTIONS(3950),
    [anon_sym_let] = ACTIONS(3950),
    [anon_sym_let_BANG] = ACTIONS(3948),
    [anon_sym_as] = ACTIONS(3950),
    [anon_sym_LPAREN] = ACTIONS(3950),
    [anon_sym_COMMA] = ACTIONS(3948),
    [anon_sym_null] = ACTIONS(3950),
    [anon_sym_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_COLON] = ACTIONS(3948),
    [anon_sym_AMP] = ACTIONS(3950),
    [anon_sym_LBRACK] = ACTIONS(3950),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3948),
    [anon_sym_LBRACE] = ACTIONS(3950),
    [anon_sym_LT_AT] = ACTIONS(3950),
    [anon_sym_LT_AT_AT] = ACTIONS(3950),
    [anon_sym_DOT] = ACTIONS(3950),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3948),
    [anon_sym_new] = ACTIONS(3950),
    [anon_sym_with] = ACTIONS(3950),
    [anon_sym_return_BANG] = ACTIONS(3948),
    [anon_sym_yield] = ACTIONS(3950),
    [anon_sym_yield_BANG] = ACTIONS(3948),
    [anon_sym_lazy] = ACTIONS(3950),
    [anon_sym_assert] = ACTIONS(3950),
    [anon_sym_upcast] = ACTIONS(3950),
    [anon_sym_downcast] = ACTIONS(3950),
    [anon_sym_COLON_GT] = ACTIONS(3948),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3948),
    [anon_sym_for] = ACTIONS(3950),
    [anon_sym_while] = ACTIONS(3950),
    [anon_sym_if] = ACTIONS(3950),
    [anon_sym_fun] = ACTIONS(3950),
    [anon_sym_try] = ACTIONS(3950),
    [anon_sym_match] = ACTIONS(3950),
    [anon_sym_match_BANG] = ACTIONS(3948),
    [anon_sym_function] = ACTIONS(3950),
    [anon_sym_LT_DASH] = ACTIONS(3950),
    [anon_sym_DOT_LBRACK] = ACTIONS(3948),
    [anon_sym_LT] = ACTIONS(3948),
    [anon_sym_use] = ACTIONS(3950),
    [anon_sym_use_BANG] = ACTIONS(3948),
    [anon_sym_do_BANG] = ACTIONS(3948),
    [anon_sym_begin] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3950),
    [anon_sym_or] = ACTIONS(3950),
    [aux_sym_char_token1] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3950),
    [anon_sym_DQUOTE] = ACTIONS(3950),
    [anon_sym_AT_DQUOTE] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [sym_bool] = ACTIONS(3950),
    [sym_unit] = ACTIONS(3948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3950),
    [sym_op_identifier] = ACTIONS(3950),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_DASH] = ACTIONS(3950),
    [anon_sym_PLUS_DOT] = ACTIONS(3950),
    [anon_sym_DASH_DOT] = ACTIONS(3950),
    [anon_sym_PERCENT] = ACTIONS(3950),
    [anon_sym_AMP_AMP] = ACTIONS(3950),
    [anon_sym_TILDE] = ACTIONS(3948),
    [aux_sym_prefix_op_token1] = ACTIONS(3950),
    [aux_sym_infix_op_token1] = ACTIONS(3948),
    [aux_sym_infix_op_token2] = ACTIONS(3950),
    [anon_sym_PIPE_PIPE] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3950),
    [anon_sym_COLON_EQ] = ACTIONS(3948),
    [anon_sym_DOLLAR] = ACTIONS(3950),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3950),
    [sym_int] = ACTIONS(3950),
    [sym_xint] = ACTIONS(3948),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3948),
    [sym__newline] = ACTIONS(3948),
  },
  [3062] = {
    [sym_block_comment] = STATE(3062),
    [sym_compiler_directive_decl] = STATE(3062),
    [sym_fsi_directive_decl] = STATE(3062),
    [sym_preproc_line] = STATE(3062),
    [sym_identifier] = ACTIONS(3984),
    [anon_sym_EQ] = ACTIONS(3982),
    [anon_sym_COLON] = ACTIONS(3984),
    [anon_sym_return] = ACTIONS(3984),
    [anon_sym_do] = ACTIONS(3984),
    [anon_sym_let] = ACTIONS(3984),
    [anon_sym_let_BANG] = ACTIONS(3982),
    [anon_sym_LPAREN] = ACTIONS(3984),
    [anon_sym_COMMA] = ACTIONS(3982),
    [anon_sym_null] = ACTIONS(3984),
    [anon_sym_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AMP] = ACTIONS(3984),
    [anon_sym_LBRACK] = ACTIONS(3984),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(3984),
    [anon_sym_LT_AT] = ACTIONS(3984),
    [anon_sym_LT_AT_AT] = ACTIONS(3984),
    [anon_sym_DOT] = ACTIONS(3984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3982),
    [anon_sym_new] = ACTIONS(3984),
    [anon_sym_return_BANG] = ACTIONS(3982),
    [anon_sym_yield] = ACTIONS(3984),
    [anon_sym_yield_BANG] = ACTIONS(3982),
    [anon_sym_lazy] = ACTIONS(3984),
    [anon_sym_assert] = ACTIONS(3984),
    [anon_sym_upcast] = ACTIONS(3984),
    [anon_sym_downcast] = ACTIONS(3984),
    [anon_sym_COLON_GT] = ACTIONS(3982),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3982),
    [anon_sym_for] = ACTIONS(3984),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_if] = ACTIONS(3984),
    [anon_sym_fun] = ACTIONS(3984),
    [anon_sym_DASH_GT] = ACTIONS(3984),
    [anon_sym_try] = ACTIONS(3984),
    [anon_sym_match] = ACTIONS(3984),
    [anon_sym_match_BANG] = ACTIONS(3982),
    [anon_sym_function] = ACTIONS(3984),
    [anon_sym_LT_DASH] = ACTIONS(3984),
    [anon_sym_DOT_LBRACK] = ACTIONS(3982),
    [anon_sym_LT] = ACTIONS(3982),
    [anon_sym_use] = ACTIONS(3984),
    [anon_sym_use_BANG] = ACTIONS(3982),
    [anon_sym_do_BANG] = ACTIONS(3982),
    [anon_sym_DOT_DOT] = ACTIONS(3982),
    [anon_sym_begin] = ACTIONS(3984),
    [anon_sym_LPAREN2] = ACTIONS(3984),
    [anon_sym_or] = ACTIONS(3984),
    [aux_sym_char_token1] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3984),
    [anon_sym_DQUOTE] = ACTIONS(3984),
    [anon_sym_AT_DQUOTE] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [sym_bool] = ACTIONS(3984),
    [sym_unit] = ACTIONS(3982),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3984),
    [sym_op_identifier] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3984),
    [anon_sym_DASH] = ACTIONS(3984),
    [anon_sym_PLUS_DOT] = ACTIONS(3984),
    [anon_sym_DASH_DOT] = ACTIONS(3984),
    [anon_sym_PERCENT] = ACTIONS(3984),
    [anon_sym_AMP_AMP] = ACTIONS(3984),
    [anon_sym_TILDE] = ACTIONS(3982),
    [aux_sym_prefix_op_token1] = ACTIONS(3984),
    [aux_sym_infix_op_token1] = ACTIONS(3982),
    [aux_sym_infix_op_token2] = ACTIONS(3984),
    [anon_sym_PIPE_PIPE] = ACTIONS(3984),
    [anon_sym_BANG_EQ] = ACTIONS(3984),
    [anon_sym_COLON_EQ] = ACTIONS(3982),
    [anon_sym_DOLLAR] = ACTIONS(3984),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3984),
    [sym_int] = ACTIONS(3984),
    [sym_xint] = ACTIONS(3982),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3982),
    [sym__newline] = ACTIONS(3982),
  },
  [3063] = {
    [sym_block_comment] = STATE(3063),
    [sym_compiler_directive_decl] = STATE(3063),
    [sym_fsi_directive_decl] = STATE(3063),
    [sym_preproc_line] = STATE(3063),
    [sym_identifier] = ACTIONS(3988),
    [anon_sym_EQ] = ACTIONS(3986),
    [anon_sym_COLON] = ACTIONS(3988),
    [anon_sym_return] = ACTIONS(3988),
    [anon_sym_do] = ACTIONS(3988),
    [anon_sym_let] = ACTIONS(3988),
    [anon_sym_let_BANG] = ACTIONS(3986),
    [anon_sym_LPAREN] = ACTIONS(3988),
    [anon_sym_COMMA] = ACTIONS(3986),
    [anon_sym_null] = ACTIONS(3988),
    [anon_sym_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_COLON] = ACTIONS(3986),
    [anon_sym_AMP] = ACTIONS(3988),
    [anon_sym_LBRACK] = ACTIONS(3988),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3986),
    [anon_sym_LBRACE] = ACTIONS(3988),
    [anon_sym_LT_AT] = ACTIONS(3988),
    [anon_sym_LT_AT_AT] = ACTIONS(3988),
    [anon_sym_DOT] = ACTIONS(3988),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3986),
    [anon_sym_new] = ACTIONS(3988),
    [anon_sym_return_BANG] = ACTIONS(3986),
    [anon_sym_yield] = ACTIONS(3988),
    [anon_sym_yield_BANG] = ACTIONS(3986),
    [anon_sym_lazy] = ACTIONS(3988),
    [anon_sym_assert] = ACTIONS(3988),
    [anon_sym_upcast] = ACTIONS(3988),
    [anon_sym_downcast] = ACTIONS(3988),
    [anon_sym_COLON_GT] = ACTIONS(3986),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_while] = ACTIONS(3988),
    [anon_sym_if] = ACTIONS(3988),
    [anon_sym_fun] = ACTIONS(3988),
    [anon_sym_DASH_GT] = ACTIONS(3988),
    [anon_sym_try] = ACTIONS(3988),
    [anon_sym_match] = ACTIONS(3988),
    [anon_sym_match_BANG] = ACTIONS(3986),
    [anon_sym_function] = ACTIONS(3988),
    [anon_sym_LT_DASH] = ACTIONS(3988),
    [anon_sym_DOT_LBRACK] = ACTIONS(3986),
    [anon_sym_LT] = ACTIONS(3986),
    [anon_sym_use] = ACTIONS(3988),
    [anon_sym_use_BANG] = ACTIONS(3986),
    [anon_sym_do_BANG] = ACTIONS(3986),
    [anon_sym_DOT_DOT] = ACTIONS(3986),
    [anon_sym_begin] = ACTIONS(3988),
    [anon_sym_LPAREN2] = ACTIONS(3988),
    [anon_sym_or] = ACTIONS(3988),
    [aux_sym_char_token1] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3988),
    [anon_sym_DQUOTE] = ACTIONS(3988),
    [anon_sym_AT_DQUOTE] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [sym_bool] = ACTIONS(3988),
    [sym_unit] = ACTIONS(3986),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3988),
    [sym_op_identifier] = ACTIONS(3988),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_PLUS_DOT] = ACTIONS(3988),
    [anon_sym_DASH_DOT] = ACTIONS(3988),
    [anon_sym_PERCENT] = ACTIONS(3988),
    [anon_sym_AMP_AMP] = ACTIONS(3988),
    [anon_sym_TILDE] = ACTIONS(3986),
    [aux_sym_prefix_op_token1] = ACTIONS(3988),
    [aux_sym_infix_op_token1] = ACTIONS(3986),
    [aux_sym_infix_op_token2] = ACTIONS(3988),
    [anon_sym_PIPE_PIPE] = ACTIONS(3988),
    [anon_sym_BANG_EQ] = ACTIONS(3988),
    [anon_sym_COLON_EQ] = ACTIONS(3986),
    [anon_sym_DOLLAR] = ACTIONS(3988),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3988),
    [sym_int] = ACTIONS(3988),
    [sym_xint] = ACTIONS(3986),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3986),
    [sym__newline] = ACTIONS(3986),
  },
  [3064] = {
    [sym_block_comment] = STATE(3064),
    [sym_compiler_directive_decl] = STATE(3064),
    [sym_fsi_directive_decl] = STATE(3064),
    [sym_preproc_line] = STATE(3064),
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_EQ] = ACTIONS(3990),
    [anon_sym_COLON] = ACTIONS(3992),
    [anon_sym_return] = ACTIONS(3992),
    [anon_sym_do] = ACTIONS(3992),
    [anon_sym_let] = ACTIONS(3992),
    [anon_sym_let_BANG] = ACTIONS(3990),
    [anon_sym_LPAREN] = ACTIONS(3992),
    [anon_sym_COMMA] = ACTIONS(3990),
    [anon_sym_null] = ACTIONS(3992),
    [anon_sym_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [anon_sym_AMP] = ACTIONS(3992),
    [anon_sym_LBRACK] = ACTIONS(3992),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3990),
    [anon_sym_LBRACE] = ACTIONS(3992),
    [anon_sym_LT_AT] = ACTIONS(3992),
    [anon_sym_LT_AT_AT] = ACTIONS(3992),
    [anon_sym_DOT] = ACTIONS(3992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3990),
    [anon_sym_new] = ACTIONS(3992),
    [anon_sym_return_BANG] = ACTIONS(3990),
    [anon_sym_yield] = ACTIONS(3992),
    [anon_sym_yield_BANG] = ACTIONS(3990),
    [anon_sym_lazy] = ACTIONS(3992),
    [anon_sym_assert] = ACTIONS(3992),
    [anon_sym_upcast] = ACTIONS(3992),
    [anon_sym_downcast] = ACTIONS(3992),
    [anon_sym_COLON_GT] = ACTIONS(3990),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3990),
    [anon_sym_for] = ACTIONS(3992),
    [anon_sym_while] = ACTIONS(3992),
    [anon_sym_if] = ACTIONS(3992),
    [anon_sym_fun] = ACTIONS(3992),
    [anon_sym_DASH_GT] = ACTIONS(3992),
    [anon_sym_try] = ACTIONS(3992),
    [anon_sym_match] = ACTIONS(3992),
    [anon_sym_match_BANG] = ACTIONS(3990),
    [anon_sym_function] = ACTIONS(3992),
    [anon_sym_LT_DASH] = ACTIONS(3992),
    [anon_sym_DOT_LBRACK] = ACTIONS(3990),
    [anon_sym_LT] = ACTIONS(3990),
    [anon_sym_use] = ACTIONS(3992),
    [anon_sym_use_BANG] = ACTIONS(3990),
    [anon_sym_do_BANG] = ACTIONS(3990),
    [anon_sym_DOT_DOT] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_LPAREN2] = ACTIONS(3992),
    [anon_sym_or] = ACTIONS(3992),
    [aux_sym_char_token1] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3992),
    [anon_sym_DQUOTE] = ACTIONS(3992),
    [anon_sym_AT_DQUOTE] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [sym_bool] = ACTIONS(3992),
    [sym_unit] = ACTIONS(3990),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3992),
    [sym_op_identifier] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3992),
    [anon_sym_DASH] = ACTIONS(3992),
    [anon_sym_PLUS_DOT] = ACTIONS(3992),
    [anon_sym_DASH_DOT] = ACTIONS(3992),
    [anon_sym_PERCENT] = ACTIONS(3992),
    [anon_sym_AMP_AMP] = ACTIONS(3992),
    [anon_sym_TILDE] = ACTIONS(3990),
    [aux_sym_prefix_op_token1] = ACTIONS(3992),
    [aux_sym_infix_op_token1] = ACTIONS(3990),
    [aux_sym_infix_op_token2] = ACTIONS(3992),
    [anon_sym_PIPE_PIPE] = ACTIONS(3992),
    [anon_sym_BANG_EQ] = ACTIONS(3992),
    [anon_sym_COLON_EQ] = ACTIONS(3990),
    [anon_sym_DOLLAR] = ACTIONS(3992),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3992),
    [sym_int] = ACTIONS(3992),
    [sym_xint] = ACTIONS(3990),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3990),
    [sym__newline] = ACTIONS(3990),
  },
  [3065] = {
    [sym_block_comment] = STATE(3065),
    [sym_compiler_directive_decl] = STATE(3065),
    [sym_fsi_directive_decl] = STATE(3065),
    [sym_preproc_line] = STATE(3065),
    [sym_identifier] = ACTIONS(4147),
    [anon_sym_EQ] = ACTIONS(4145),
    [anon_sym_COLON] = ACTIONS(4147),
    [anon_sym_return] = ACTIONS(4147),
    [anon_sym_do] = ACTIONS(4147),
    [anon_sym_let] = ACTIONS(4147),
    [anon_sym_let_BANG] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(4147),
    [anon_sym_COMMA] = ACTIONS(4145),
    [anon_sym_null] = ACTIONS(4147),
    [anon_sym_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_COLON] = ACTIONS(4145),
    [anon_sym_AMP] = ACTIONS(4147),
    [anon_sym_LBRACK] = ACTIONS(4147),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4145),
    [anon_sym_LBRACE] = ACTIONS(4147),
    [anon_sym_LT_AT] = ACTIONS(4147),
    [anon_sym_LT_AT_AT] = ACTIONS(4147),
    [anon_sym_DOT] = ACTIONS(4147),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4145),
    [anon_sym_new] = ACTIONS(4147),
    [anon_sym_return_BANG] = ACTIONS(4145),
    [anon_sym_yield] = ACTIONS(4147),
    [anon_sym_yield_BANG] = ACTIONS(4145),
    [anon_sym_lazy] = ACTIONS(4147),
    [anon_sym_assert] = ACTIONS(4147),
    [anon_sym_upcast] = ACTIONS(4147),
    [anon_sym_downcast] = ACTIONS(4147),
    [anon_sym_COLON_GT] = ACTIONS(4145),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4145),
    [anon_sym_for] = ACTIONS(4147),
    [anon_sym_while] = ACTIONS(4147),
    [anon_sym_if] = ACTIONS(4147),
    [anon_sym_fun] = ACTIONS(4147),
    [anon_sym_DASH_GT] = ACTIONS(4147),
    [anon_sym_try] = ACTIONS(4147),
    [anon_sym_match] = ACTIONS(4147),
    [anon_sym_match_BANG] = ACTIONS(4145),
    [anon_sym_function] = ACTIONS(4147),
    [anon_sym_LT_DASH] = ACTIONS(4147),
    [anon_sym_DOT_LBRACK] = ACTIONS(4145),
    [anon_sym_LT] = ACTIONS(4145),
    [anon_sym_use] = ACTIONS(4147),
    [anon_sym_use_BANG] = ACTIONS(4145),
    [anon_sym_do_BANG] = ACTIONS(4145),
    [anon_sym_DOT_DOT] = ACTIONS(4145),
    [anon_sym_begin] = ACTIONS(4147),
    [anon_sym_LPAREN2] = ACTIONS(4147),
    [anon_sym_or] = ACTIONS(4147),
    [aux_sym_char_token1] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4147),
    [anon_sym_DQUOTE] = ACTIONS(4147),
    [anon_sym_AT_DQUOTE] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [sym_bool] = ACTIONS(4147),
    [sym_unit] = ACTIONS(4145),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4147),
    [sym_op_identifier] = ACTIONS(4147),
    [anon_sym_PLUS] = ACTIONS(4147),
    [anon_sym_DASH] = ACTIONS(4147),
    [anon_sym_PLUS_DOT] = ACTIONS(4147),
    [anon_sym_DASH_DOT] = ACTIONS(4147),
    [anon_sym_PERCENT] = ACTIONS(4147),
    [anon_sym_AMP_AMP] = ACTIONS(4147),
    [anon_sym_TILDE] = ACTIONS(4145),
    [aux_sym_prefix_op_token1] = ACTIONS(4147),
    [aux_sym_infix_op_token1] = ACTIONS(4145),
    [aux_sym_infix_op_token2] = ACTIONS(4147),
    [anon_sym_PIPE_PIPE] = ACTIONS(4147),
    [anon_sym_BANG_EQ] = ACTIONS(4147),
    [anon_sym_COLON_EQ] = ACTIONS(4145),
    [anon_sym_DOLLAR] = ACTIONS(4147),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4147),
    [sym_int] = ACTIONS(4147),
    [sym_xint] = ACTIONS(4145),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4145),
    [sym__newline] = ACTIONS(4145),
  },
  [3066] = {
    [sym_block_comment] = STATE(3066),
    [sym_compiler_directive_decl] = STATE(3066),
    [sym_fsi_directive_decl] = STATE(3066),
    [sym_preproc_line] = STATE(3066),
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_EQ] = ACTIONS(4149),
    [anon_sym_COLON] = ACTIONS(4151),
    [anon_sym_return] = ACTIONS(4151),
    [anon_sym_do] = ACTIONS(4151),
    [anon_sym_let] = ACTIONS(4151),
    [anon_sym_let_BANG] = ACTIONS(4149),
    [anon_sym_LPAREN] = ACTIONS(4151),
    [anon_sym_COMMA] = ACTIONS(4149),
    [anon_sym_null] = ACTIONS(4151),
    [anon_sym_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_AMP] = ACTIONS(4151),
    [anon_sym_LBRACK] = ACTIONS(4151),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4149),
    [anon_sym_LBRACE] = ACTIONS(4151),
    [anon_sym_LT_AT] = ACTIONS(4151),
    [anon_sym_LT_AT_AT] = ACTIONS(4151),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4149),
    [anon_sym_new] = ACTIONS(4151),
    [anon_sym_return_BANG] = ACTIONS(4149),
    [anon_sym_yield] = ACTIONS(4151),
    [anon_sym_yield_BANG] = ACTIONS(4149),
    [anon_sym_lazy] = ACTIONS(4151),
    [anon_sym_assert] = ACTIONS(4151),
    [anon_sym_upcast] = ACTIONS(4151),
    [anon_sym_downcast] = ACTIONS(4151),
    [anon_sym_COLON_GT] = ACTIONS(4149),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4149),
    [anon_sym_for] = ACTIONS(4151),
    [anon_sym_while] = ACTIONS(4151),
    [anon_sym_if] = ACTIONS(4151),
    [anon_sym_fun] = ACTIONS(4151),
    [anon_sym_DASH_GT] = ACTIONS(4151),
    [anon_sym_try] = ACTIONS(4151),
    [anon_sym_match] = ACTIONS(4151),
    [anon_sym_match_BANG] = ACTIONS(4149),
    [anon_sym_function] = ACTIONS(4151),
    [anon_sym_LT_DASH] = ACTIONS(4151),
    [anon_sym_DOT_LBRACK] = ACTIONS(4149),
    [anon_sym_LT] = ACTIONS(4149),
    [anon_sym_use] = ACTIONS(4151),
    [anon_sym_use_BANG] = ACTIONS(4149),
    [anon_sym_do_BANG] = ACTIONS(4149),
    [anon_sym_DOT_DOT] = ACTIONS(4149),
    [anon_sym_begin] = ACTIONS(4151),
    [anon_sym_LPAREN2] = ACTIONS(4151),
    [anon_sym_or] = ACTIONS(4151),
    [aux_sym_char_token1] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4151),
    [anon_sym_DQUOTE] = ACTIONS(4151),
    [anon_sym_AT_DQUOTE] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [sym_bool] = ACTIONS(4151),
    [sym_unit] = ACTIONS(4149),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4151),
    [sym_op_identifier] = ACTIONS(4151),
    [anon_sym_PLUS] = ACTIONS(4151),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_PLUS_DOT] = ACTIONS(4151),
    [anon_sym_DASH_DOT] = ACTIONS(4151),
    [anon_sym_PERCENT] = ACTIONS(4151),
    [anon_sym_AMP_AMP] = ACTIONS(4151),
    [anon_sym_TILDE] = ACTIONS(4149),
    [aux_sym_prefix_op_token1] = ACTIONS(4151),
    [aux_sym_infix_op_token1] = ACTIONS(4149),
    [aux_sym_infix_op_token2] = ACTIONS(4151),
    [anon_sym_PIPE_PIPE] = ACTIONS(4151),
    [anon_sym_BANG_EQ] = ACTIONS(4151),
    [anon_sym_COLON_EQ] = ACTIONS(4149),
    [anon_sym_DOLLAR] = ACTIONS(4151),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4151),
    [sym_int] = ACTIONS(4151),
    [sym_xint] = ACTIONS(4149),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4149),
    [sym__newline] = ACTIONS(4149),
  },
  [3067] = {
    [sym_block_comment] = STATE(3067),
    [sym_compiler_directive_decl] = STATE(3067),
    [sym_fsi_directive_decl] = STATE(3067),
    [sym_preproc_line] = STATE(3067),
    [aux_sym_sequential_expression_repeat1] = STATE(2985),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_COLON] = ACTIONS(3759),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_let_BANG] = ACTIONS(3757),
    [anon_sym_LPAREN] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3757),
    [anon_sym_null] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3757),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_LT_AT] = ACTIONS(3759),
    [anon_sym_LT_AT_AT] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(3759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_return_BANG] = ACTIONS(3757),
    [anon_sym_yield] = ACTIONS(3759),
    [anon_sym_yield_BANG] = ACTIONS(3757),
    [anon_sym_lazy] = ACTIONS(3759),
    [anon_sym_assert] = ACTIONS(3759),
    [anon_sym_upcast] = ACTIONS(3759),
    [anon_sym_downcast] = ACTIONS(3759),
    [anon_sym_COLON_GT] = ACTIONS(3757),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3757),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_fun] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_match] = ACTIONS(3759),
    [anon_sym_match_BANG] = ACTIONS(3757),
    [anon_sym_function] = ACTIONS(3759),
    [anon_sym_LT_DASH] = ACTIONS(3759),
    [anon_sym_DOT_LBRACK] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_GT] = ACTIONS(3759),
    [anon_sym_use] = ACTIONS(3759),
    [anon_sym_use_BANG] = ACTIONS(3757),
    [anon_sym_do_BANG] = ACTIONS(3757),
    [anon_sym_begin] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_or] = ACTIONS(3759),
    [aux_sym_char_token1] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3759),
    [anon_sym_DQUOTE] = ACTIONS(3759),
    [anon_sym_AT_DQUOTE] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [sym_bool] = ACTIONS(3759),
    [sym_unit] = ACTIONS(3757),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3759),
    [sym_op_identifier] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS_DOT] = ACTIONS(3759),
    [anon_sym_DASH_DOT] = ACTIONS(3759),
    [anon_sym_PERCENT] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_TILDE] = ACTIONS(3757),
    [aux_sym_prefix_op_token1] = ACTIONS(3759),
    [aux_sym_infix_op_token1] = ACTIONS(3757),
    [aux_sym_infix_op_token2] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_COLON_EQ] = ACTIONS(3757),
    [anon_sym_DOLLAR] = ACTIONS(3759),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3759),
    [sym_int] = ACTIONS(3759),
    [sym_xint] = ACTIONS(3757),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3757),
    [sym__newline] = ACTIONS(3757),
  },
  [3068] = {
    [sym_block_comment] = STATE(3068),
    [sym_compiler_directive_decl] = STATE(3068),
    [sym_fsi_directive_decl] = STATE(3068),
    [sym_preproc_line] = STATE(3068),
    [sym_identifier] = ACTIONS(4122),
    [anon_sym_EQ] = ACTIONS(4120),
    [anon_sym_COLON] = ACTIONS(4122),
    [anon_sym_return] = ACTIONS(4122),
    [anon_sym_do] = ACTIONS(4122),
    [anon_sym_let] = ACTIONS(4122),
    [anon_sym_let_BANG] = ACTIONS(4120),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_COMMA] = ACTIONS(4120),
    [anon_sym_null] = ACTIONS(4122),
    [anon_sym_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_COLON] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_LT_AT] = ACTIONS(4122),
    [anon_sym_LT_AT_AT] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4122),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4120),
    [anon_sym_new] = ACTIONS(4122),
    [anon_sym_return_BANG] = ACTIONS(4120),
    [anon_sym_yield] = ACTIONS(4122),
    [anon_sym_yield_BANG] = ACTIONS(4120),
    [anon_sym_lazy] = ACTIONS(4122),
    [anon_sym_assert] = ACTIONS(4122),
    [anon_sym_upcast] = ACTIONS(4122),
    [anon_sym_downcast] = ACTIONS(4122),
    [anon_sym_COLON_GT] = ACTIONS(4120),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4120),
    [anon_sym_for] = ACTIONS(4122),
    [anon_sym_while] = ACTIONS(4122),
    [anon_sym_if] = ACTIONS(4122),
    [anon_sym_fun] = ACTIONS(4122),
    [anon_sym_DASH_GT] = ACTIONS(4122),
    [anon_sym_try] = ACTIONS(4122),
    [anon_sym_match] = ACTIONS(4122),
    [anon_sym_match_BANG] = ACTIONS(4120),
    [anon_sym_function] = ACTIONS(4122),
    [anon_sym_LT_DASH] = ACTIONS(4122),
    [anon_sym_DOT_LBRACK] = ACTIONS(4120),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_use] = ACTIONS(4122),
    [anon_sym_use_BANG] = ACTIONS(4120),
    [anon_sym_do_BANG] = ACTIONS(4120),
    [anon_sym_DOT_DOT] = ACTIONS(4120),
    [anon_sym_begin] = ACTIONS(4122),
    [anon_sym_LPAREN2] = ACTIONS(4122),
    [anon_sym_or] = ACTIONS(4122),
    [aux_sym_char_token1] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4122),
    [anon_sym_DQUOTE] = ACTIONS(4122),
    [anon_sym_AT_DQUOTE] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [sym_bool] = ACTIONS(4122),
    [sym_unit] = ACTIONS(4120),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4122),
    [sym_op_identifier] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4122),
    [anon_sym_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_DOT] = ACTIONS(4122),
    [anon_sym_DASH_DOT] = ACTIONS(4122),
    [anon_sym_PERCENT] = ACTIONS(4122),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_TILDE] = ACTIONS(4120),
    [aux_sym_prefix_op_token1] = ACTIONS(4122),
    [aux_sym_infix_op_token1] = ACTIONS(4120),
    [aux_sym_infix_op_token2] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_COLON_EQ] = ACTIONS(4120),
    [anon_sym_DOLLAR] = ACTIONS(4122),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4122),
    [sym_int] = ACTIONS(4122),
    [sym_xint] = ACTIONS(4120),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4120),
    [sym__newline] = ACTIONS(4120),
  },
  [3069] = {
    [sym_block_comment] = STATE(3069),
    [sym_compiler_directive_decl] = STATE(3069),
    [sym_fsi_directive_decl] = STATE(3069),
    [sym_preproc_line] = STATE(3069),
    [sym_identifier] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4078),
    [anon_sym_return] = ACTIONS(4078),
    [anon_sym_do] = ACTIONS(4078),
    [anon_sym_let] = ACTIONS(4078),
    [anon_sym_let_BANG] = ACTIONS(4076),
    [anon_sym_as] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_null] = ACTIONS(4078),
    [anon_sym_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(4076),
    [anon_sym_AMP] = ACTIONS(4078),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4078),
    [anon_sym_LT_AT] = ACTIONS(4078),
    [anon_sym_LT_AT_AT] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(4078),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4076),
    [anon_sym_new] = ACTIONS(4078),
    [anon_sym_with] = ACTIONS(4078),
    [anon_sym_return_BANG] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(4078),
    [anon_sym_yield_BANG] = ACTIONS(4076),
    [anon_sym_lazy] = ACTIONS(4078),
    [anon_sym_assert] = ACTIONS(4078),
    [anon_sym_upcast] = ACTIONS(4078),
    [anon_sym_downcast] = ACTIONS(4078),
    [anon_sym_COLON_GT] = ACTIONS(4076),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4076),
    [anon_sym_for] = ACTIONS(4078),
    [anon_sym_while] = ACTIONS(4078),
    [anon_sym_if] = ACTIONS(4078),
    [anon_sym_fun] = ACTIONS(4078),
    [anon_sym_try] = ACTIONS(4078),
    [anon_sym_match] = ACTIONS(4078),
    [anon_sym_match_BANG] = ACTIONS(4076),
    [anon_sym_function] = ACTIONS(4078),
    [anon_sym_LT_DASH] = ACTIONS(4078),
    [anon_sym_DOT_LBRACK] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4076),
    [anon_sym_use] = ACTIONS(4078),
    [anon_sym_use_BANG] = ACTIONS(4076),
    [anon_sym_do_BANG] = ACTIONS(4076),
    [anon_sym_begin] = ACTIONS(4078),
    [anon_sym_LPAREN2] = ACTIONS(4078),
    [anon_sym_or] = ACTIONS(4078),
    [aux_sym_char_token1] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4078),
    [anon_sym_DQUOTE] = ACTIONS(4078),
    [anon_sym_AT_DQUOTE] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [sym_bool] = ACTIONS(4078),
    [sym_unit] = ACTIONS(4076),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4078),
    [sym_op_identifier] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(4078),
    [anon_sym_PLUS_DOT] = ACTIONS(4078),
    [anon_sym_DASH_DOT] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [anon_sym_AMP_AMP] = ACTIONS(4078),
    [anon_sym_TILDE] = ACTIONS(4076),
    [aux_sym_prefix_op_token1] = ACTIONS(4078),
    [aux_sym_infix_op_token1] = ACTIONS(4076),
    [aux_sym_infix_op_token2] = ACTIONS(4078),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_BANG_EQ] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4076),
    [anon_sym_DOLLAR] = ACTIONS(4078),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4078),
    [sym_int] = ACTIONS(4078),
    [sym_xint] = ACTIONS(4076),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4076),
    [sym__newline] = ACTIONS(4076),
  },
  [3070] = {
    [sym_block_comment] = STATE(3070),
    [sym_compiler_directive_decl] = STATE(3070),
    [sym_fsi_directive_decl] = STATE(3070),
    [sym_preproc_line] = STATE(3070),
    [sym_identifier] = ACTIONS(4118),
    [anon_sym_EQ] = ACTIONS(4116),
    [anon_sym_COLON] = ACTIONS(4118),
    [anon_sym_return] = ACTIONS(4118),
    [anon_sym_do] = ACTIONS(4118),
    [anon_sym_let] = ACTIONS(4118),
    [anon_sym_let_BANG] = ACTIONS(4116),
    [anon_sym_LPAREN] = ACTIONS(4118),
    [anon_sym_COMMA] = ACTIONS(4116),
    [anon_sym_null] = ACTIONS(4118),
    [anon_sym_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_COLON] = ACTIONS(4116),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4118),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(4118),
    [anon_sym_LT_AT] = ACTIONS(4118),
    [anon_sym_LT_AT_AT] = ACTIONS(4118),
    [anon_sym_DOT] = ACTIONS(4118),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4116),
    [anon_sym_new] = ACTIONS(4118),
    [anon_sym_return_BANG] = ACTIONS(4116),
    [anon_sym_yield] = ACTIONS(4118),
    [anon_sym_yield_BANG] = ACTIONS(4116),
    [anon_sym_lazy] = ACTIONS(4118),
    [anon_sym_assert] = ACTIONS(4118),
    [anon_sym_upcast] = ACTIONS(4118),
    [anon_sym_downcast] = ACTIONS(4118),
    [anon_sym_COLON_GT] = ACTIONS(4116),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4116),
    [anon_sym_for] = ACTIONS(4118),
    [anon_sym_while] = ACTIONS(4118),
    [anon_sym_if] = ACTIONS(4118),
    [anon_sym_fun] = ACTIONS(4118),
    [anon_sym_DASH_GT] = ACTIONS(4118),
    [anon_sym_try] = ACTIONS(4118),
    [anon_sym_match] = ACTIONS(4118),
    [anon_sym_match_BANG] = ACTIONS(4116),
    [anon_sym_function] = ACTIONS(4118),
    [anon_sym_LT_DASH] = ACTIONS(4118),
    [anon_sym_DOT_LBRACK] = ACTIONS(4116),
    [anon_sym_LT] = ACTIONS(4116),
    [anon_sym_use] = ACTIONS(4118),
    [anon_sym_use_BANG] = ACTIONS(4116),
    [anon_sym_do_BANG] = ACTIONS(4116),
    [anon_sym_DOT_DOT] = ACTIONS(4116),
    [anon_sym_begin] = ACTIONS(4118),
    [anon_sym_LPAREN2] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [aux_sym_char_token1] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4118),
    [anon_sym_DQUOTE] = ACTIONS(4118),
    [anon_sym_AT_DQUOTE] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [sym_bool] = ACTIONS(4118),
    [sym_unit] = ACTIONS(4116),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4118),
    [sym_op_identifier] = ACTIONS(4118),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_PLUS_DOT] = ACTIONS(4118),
    [anon_sym_DASH_DOT] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_AMP_AMP] = ACTIONS(4118),
    [anon_sym_TILDE] = ACTIONS(4116),
    [aux_sym_prefix_op_token1] = ACTIONS(4118),
    [aux_sym_infix_op_token1] = ACTIONS(4116),
    [aux_sym_infix_op_token2] = ACTIONS(4118),
    [anon_sym_PIPE_PIPE] = ACTIONS(4118),
    [anon_sym_BANG_EQ] = ACTIONS(4118),
    [anon_sym_COLON_EQ] = ACTIONS(4116),
    [anon_sym_DOLLAR] = ACTIONS(4118),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4118),
    [sym_int] = ACTIONS(4118),
    [sym_xint] = ACTIONS(4116),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4116),
    [sym__newline] = ACTIONS(4116),
  },
  [3071] = {
    [sym_block_comment] = STATE(3071),
    [sym_compiler_directive_decl] = STATE(3071),
    [sym_fsi_directive_decl] = STATE(3071),
    [sym_preproc_line] = STATE(3071),
    [aux_sym_long_identifier_repeat1] = STATE(3037),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_AT_GT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(5649),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_or] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
  },
  [3072] = {
    [sym_block_comment] = STATE(3072),
    [sym_compiler_directive_decl] = STATE(3072),
    [sym_fsi_directive_decl] = STATE(3072),
    [sym_preproc_line] = STATE(3072),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4072),
    [anon_sym_COLON] = ACTIONS(4074),
    [anon_sym_return] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_let_BANG] = ACTIONS(4072),
    [anon_sym_as] = ACTIONS(4074),
    [anon_sym_LPAREN] = ACTIONS(4074),
    [anon_sym_COMMA] = ACTIONS(4072),
    [anon_sym_null] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_COLON] = ACTIONS(4072),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_LT_AT] = ACTIONS(4074),
    [anon_sym_LT_AT_AT] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4072),
    [anon_sym_new] = ACTIONS(4074),
    [anon_sym_with] = ACTIONS(4074),
    [anon_sym_return_BANG] = ACTIONS(4072),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_yield_BANG] = ACTIONS(4072),
    [anon_sym_lazy] = ACTIONS(4074),
    [anon_sym_assert] = ACTIONS(4074),
    [anon_sym_upcast] = ACTIONS(4074),
    [anon_sym_downcast] = ACTIONS(4074),
    [anon_sym_COLON_GT] = ACTIONS(4072),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4072),
    [anon_sym_for] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_fun] = ACTIONS(4074),
    [anon_sym_try] = ACTIONS(4074),
    [anon_sym_match] = ACTIONS(4074),
    [anon_sym_match_BANG] = ACTIONS(4072),
    [anon_sym_function] = ACTIONS(4074),
    [anon_sym_LT_DASH] = ACTIONS(4074),
    [anon_sym_DOT_LBRACK] = ACTIONS(4072),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_use] = ACTIONS(4074),
    [anon_sym_use_BANG] = ACTIONS(4072),
    [anon_sym_do_BANG] = ACTIONS(4072),
    [anon_sym_begin] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [aux_sym_char_token1] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4074),
    [anon_sym_DQUOTE] = ACTIONS(4074),
    [anon_sym_AT_DQUOTE] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [sym_bool] = ACTIONS(4074),
    [sym_unit] = ACTIONS(4072),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4074),
    [sym_op_identifier] = ACTIONS(4074),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_PLUS_DOT] = ACTIONS(4074),
    [anon_sym_DASH_DOT] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_TILDE] = ACTIONS(4072),
    [aux_sym_prefix_op_token1] = ACTIONS(4074),
    [aux_sym_infix_op_token1] = ACTIONS(4072),
    [aux_sym_infix_op_token2] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [anon_sym_BANG_EQ] = ACTIONS(4074),
    [anon_sym_COLON_EQ] = ACTIONS(4072),
    [anon_sym_DOLLAR] = ACTIONS(4074),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4074),
    [sym_int] = ACTIONS(4074),
    [sym_xint] = ACTIONS(4072),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4072),
    [sym__newline] = ACTIONS(4072),
  },
  [3073] = {
    [sym_block_comment] = STATE(3073),
    [sym_compiler_directive_decl] = STATE(3073),
    [sym_fsi_directive_decl] = STATE(3073),
    [sym_preproc_line] = STATE(3073),
    [sym_identifier] = ACTIONS(4022),
    [anon_sym_EQ] = ACTIONS(4020),
    [anon_sym_COLON] = ACTIONS(4022),
    [anon_sym_return] = ACTIONS(4022),
    [anon_sym_do] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_let_BANG] = ACTIONS(4020),
    [anon_sym_as] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(4022),
    [anon_sym_COMMA] = ACTIONS(4020),
    [anon_sym_null] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_COLON] = ACTIONS(4020),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4022),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(4022),
    [anon_sym_LT_AT] = ACTIONS(4022),
    [anon_sym_LT_AT_AT] = ACTIONS(4022),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4020),
    [anon_sym_new] = ACTIONS(4022),
    [anon_sym_with] = ACTIONS(4022),
    [anon_sym_return_BANG] = ACTIONS(4020),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_yield_BANG] = ACTIONS(4020),
    [anon_sym_lazy] = ACTIONS(4022),
    [anon_sym_assert] = ACTIONS(4022),
    [anon_sym_upcast] = ACTIONS(4022),
    [anon_sym_downcast] = ACTIONS(4022),
    [anon_sym_COLON_GT] = ACTIONS(4020),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4020),
    [anon_sym_for] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4022),
    [anon_sym_if] = ACTIONS(4022),
    [anon_sym_fun] = ACTIONS(4022),
    [anon_sym_try] = ACTIONS(4022),
    [anon_sym_match] = ACTIONS(4022),
    [anon_sym_match_BANG] = ACTIONS(4020),
    [anon_sym_function] = ACTIONS(4022),
    [anon_sym_LT_DASH] = ACTIONS(4022),
    [anon_sym_DOT_LBRACK] = ACTIONS(4020),
    [anon_sym_LT] = ACTIONS(4020),
    [anon_sym_use] = ACTIONS(4022),
    [anon_sym_use_BANG] = ACTIONS(4020),
    [anon_sym_do_BANG] = ACTIONS(4020),
    [anon_sym_begin] = ACTIONS(4022),
    [anon_sym_LPAREN2] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [aux_sym_char_token1] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4022),
    [anon_sym_DQUOTE] = ACTIONS(4022),
    [anon_sym_AT_DQUOTE] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [sym_bool] = ACTIONS(4022),
    [sym_unit] = ACTIONS(4020),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4022),
    [sym_op_identifier] = ACTIONS(4022),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_PLUS_DOT] = ACTIONS(4022),
    [anon_sym_DASH_DOT] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4022),
    [anon_sym_TILDE] = ACTIONS(4020),
    [aux_sym_prefix_op_token1] = ACTIONS(4022),
    [aux_sym_infix_op_token1] = ACTIONS(4020),
    [aux_sym_infix_op_token2] = ACTIONS(4022),
    [anon_sym_PIPE_PIPE] = ACTIONS(4022),
    [anon_sym_BANG_EQ] = ACTIONS(4022),
    [anon_sym_COLON_EQ] = ACTIONS(4020),
    [anon_sym_DOLLAR] = ACTIONS(4022),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4022),
    [sym_int] = ACTIONS(4022),
    [sym_xint] = ACTIONS(4020),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4020),
    [sym__newline] = ACTIONS(4020),
  },
  [3074] = {
    [sym_block_comment] = STATE(3074),
    [sym_compiler_directive_decl] = STATE(3074),
    [sym_fsi_directive_decl] = STATE(3074),
    [sym_preproc_line] = STATE(3074),
    [sym_identifier] = ACTIONS(4112),
    [anon_sym_EQ] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4112),
    [anon_sym_return] = ACTIONS(4112),
    [anon_sym_do] = ACTIONS(4112),
    [anon_sym_let] = ACTIONS(4112),
    [anon_sym_let_BANG] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_null] = ACTIONS(4112),
    [anon_sym_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_COLON] = ACTIONS(4110),
    [anon_sym_AMP] = ACTIONS(4112),
    [anon_sym_LBRACK] = ACTIONS(4112),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4110),
    [anon_sym_LBRACE] = ACTIONS(4112),
    [anon_sym_LT_AT] = ACTIONS(4112),
    [anon_sym_LT_AT_AT] = ACTIONS(4112),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4110),
    [anon_sym_new] = ACTIONS(4112),
    [anon_sym_return_BANG] = ACTIONS(4110),
    [anon_sym_yield] = ACTIONS(4112),
    [anon_sym_yield_BANG] = ACTIONS(4110),
    [anon_sym_lazy] = ACTIONS(4112),
    [anon_sym_assert] = ACTIONS(4112),
    [anon_sym_upcast] = ACTIONS(4112),
    [anon_sym_downcast] = ACTIONS(4112),
    [anon_sym_COLON_GT] = ACTIONS(4110),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4110),
    [anon_sym_for] = ACTIONS(4112),
    [anon_sym_while] = ACTIONS(4112),
    [anon_sym_if] = ACTIONS(4112),
    [anon_sym_fun] = ACTIONS(4112),
    [anon_sym_DASH_GT] = ACTIONS(4112),
    [anon_sym_try] = ACTIONS(4112),
    [anon_sym_match] = ACTIONS(4112),
    [anon_sym_match_BANG] = ACTIONS(4110),
    [anon_sym_function] = ACTIONS(4112),
    [anon_sym_LT_DASH] = ACTIONS(4112),
    [anon_sym_DOT_LBRACK] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(4110),
    [anon_sym_use] = ACTIONS(4112),
    [anon_sym_use_BANG] = ACTIONS(4110),
    [anon_sym_do_BANG] = ACTIONS(4110),
    [anon_sym_DOT_DOT] = ACTIONS(4110),
    [anon_sym_begin] = ACTIONS(4112),
    [anon_sym_LPAREN2] = ACTIONS(4112),
    [anon_sym_or] = ACTIONS(4112),
    [aux_sym_char_token1] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4112),
    [anon_sym_DQUOTE] = ACTIONS(4112),
    [anon_sym_AT_DQUOTE] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [sym_bool] = ACTIONS(4112),
    [sym_unit] = ACTIONS(4110),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4112),
    [sym_op_identifier] = ACTIONS(4112),
    [anon_sym_PLUS] = ACTIONS(4112),
    [anon_sym_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_DOT] = ACTIONS(4112),
    [anon_sym_DASH_DOT] = ACTIONS(4112),
    [anon_sym_PERCENT] = ACTIONS(4112),
    [anon_sym_AMP_AMP] = ACTIONS(4112),
    [anon_sym_TILDE] = ACTIONS(4110),
    [aux_sym_prefix_op_token1] = ACTIONS(4112),
    [aux_sym_infix_op_token1] = ACTIONS(4110),
    [aux_sym_infix_op_token2] = ACTIONS(4112),
    [anon_sym_PIPE_PIPE] = ACTIONS(4112),
    [anon_sym_BANG_EQ] = ACTIONS(4112),
    [anon_sym_COLON_EQ] = ACTIONS(4110),
    [anon_sym_DOLLAR] = ACTIONS(4112),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4112),
    [sym_int] = ACTIONS(4112),
    [sym_xint] = ACTIONS(4110),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4110),
    [sym__newline] = ACTIONS(4110),
  },
  [3075] = {
    [sym_block_comment] = STATE(3075),
    [sym_compiler_directive_decl] = STATE(3075),
    [sym_fsi_directive_decl] = STATE(3075),
    [sym_preproc_line] = STATE(3075),
    [sym_identifier] = ACTIONS(4108),
    [anon_sym_EQ] = ACTIONS(4106),
    [anon_sym_COLON] = ACTIONS(4108),
    [anon_sym_return] = ACTIONS(4108),
    [anon_sym_do] = ACTIONS(4108),
    [anon_sym_let] = ACTIONS(4108),
    [anon_sym_let_BANG] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(4108),
    [anon_sym_COMMA] = ACTIONS(4106),
    [anon_sym_null] = ACTIONS(4108),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_COLON] = ACTIONS(4106),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LBRACK] = ACTIONS(4108),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(4108),
    [anon_sym_LT_AT] = ACTIONS(4108),
    [anon_sym_LT_AT_AT] = ACTIONS(4108),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4106),
    [anon_sym_new] = ACTIONS(4108),
    [anon_sym_return_BANG] = ACTIONS(4106),
    [anon_sym_yield] = ACTIONS(4108),
    [anon_sym_yield_BANG] = ACTIONS(4106),
    [anon_sym_lazy] = ACTIONS(4108),
    [anon_sym_assert] = ACTIONS(4108),
    [anon_sym_upcast] = ACTIONS(4108),
    [anon_sym_downcast] = ACTIONS(4108),
    [anon_sym_COLON_GT] = ACTIONS(4106),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4106),
    [anon_sym_for] = ACTIONS(4108),
    [anon_sym_while] = ACTIONS(4108),
    [anon_sym_if] = ACTIONS(4108),
    [anon_sym_fun] = ACTIONS(4108),
    [anon_sym_DASH_GT] = ACTIONS(4108),
    [anon_sym_try] = ACTIONS(4108),
    [anon_sym_match] = ACTIONS(4108),
    [anon_sym_match_BANG] = ACTIONS(4106),
    [anon_sym_function] = ACTIONS(4108),
    [anon_sym_LT_DASH] = ACTIONS(4108),
    [anon_sym_DOT_LBRACK] = ACTIONS(4106),
    [anon_sym_LT] = ACTIONS(4106),
    [anon_sym_use] = ACTIONS(4108),
    [anon_sym_use_BANG] = ACTIONS(4106),
    [anon_sym_do_BANG] = ACTIONS(4106),
    [anon_sym_DOT_DOT] = ACTIONS(4106),
    [anon_sym_begin] = ACTIONS(4108),
    [anon_sym_LPAREN2] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [aux_sym_char_token1] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4108),
    [anon_sym_DQUOTE] = ACTIONS(4108),
    [anon_sym_AT_DQUOTE] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [sym_bool] = ACTIONS(4108),
    [sym_unit] = ACTIONS(4106),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4108),
    [sym_op_identifier] = ACTIONS(4108),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_PLUS_DOT] = ACTIONS(4108),
    [anon_sym_DASH_DOT] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_AMP_AMP] = ACTIONS(4108),
    [anon_sym_TILDE] = ACTIONS(4106),
    [aux_sym_prefix_op_token1] = ACTIONS(4108),
    [aux_sym_infix_op_token1] = ACTIONS(4106),
    [aux_sym_infix_op_token2] = ACTIONS(4108),
    [anon_sym_PIPE_PIPE] = ACTIONS(4108),
    [anon_sym_BANG_EQ] = ACTIONS(4108),
    [anon_sym_COLON_EQ] = ACTIONS(4106),
    [anon_sym_DOLLAR] = ACTIONS(4108),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4108),
    [sym_int] = ACTIONS(4108),
    [sym_xint] = ACTIONS(4106),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4106),
    [sym__newline] = ACTIONS(4106),
  },
  [3076] = {
    [sym_block_comment] = STATE(3076),
    [sym_compiler_directive_decl] = STATE(3076),
    [sym_fsi_directive_decl] = STATE(3076),
    [sym_preproc_line] = STATE(3076),
    [sym_identifier] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(4091),
    [anon_sym_COLON] = ACTIONS(4093),
    [anon_sym_return] = ACTIONS(4093),
    [anon_sym_do] = ACTIONS(4093),
    [anon_sym_let] = ACTIONS(4093),
    [anon_sym_let_BANG] = ACTIONS(4091),
    [anon_sym_LPAREN] = ACTIONS(4093),
    [anon_sym_COMMA] = ACTIONS(4091),
    [anon_sym_null] = ACTIONS(4093),
    [anon_sym_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_COLON] = ACTIONS(4091),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(4093),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4091),
    [anon_sym_LBRACE] = ACTIONS(4093),
    [anon_sym_LT_AT] = ACTIONS(4093),
    [anon_sym_LT_AT_AT] = ACTIONS(4093),
    [anon_sym_DOT] = ACTIONS(4093),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4091),
    [anon_sym_new] = ACTIONS(4093),
    [anon_sym_return_BANG] = ACTIONS(4091),
    [anon_sym_yield] = ACTIONS(4093),
    [anon_sym_yield_BANG] = ACTIONS(4091),
    [anon_sym_lazy] = ACTIONS(4093),
    [anon_sym_assert] = ACTIONS(4093),
    [anon_sym_upcast] = ACTIONS(4093),
    [anon_sym_downcast] = ACTIONS(4093),
    [anon_sym_COLON_GT] = ACTIONS(4091),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4091),
    [anon_sym_for] = ACTIONS(4093),
    [anon_sym_while] = ACTIONS(4093),
    [anon_sym_if] = ACTIONS(4093),
    [anon_sym_fun] = ACTIONS(4093),
    [anon_sym_DASH_GT] = ACTIONS(4093),
    [anon_sym_try] = ACTIONS(4093),
    [anon_sym_match] = ACTIONS(4093),
    [anon_sym_match_BANG] = ACTIONS(4091),
    [anon_sym_function] = ACTIONS(4093),
    [anon_sym_LT_DASH] = ACTIONS(4093),
    [anon_sym_DOT_LBRACK] = ACTIONS(4091),
    [anon_sym_LT] = ACTIONS(4091),
    [anon_sym_use] = ACTIONS(4093),
    [anon_sym_use_BANG] = ACTIONS(4091),
    [anon_sym_do_BANG] = ACTIONS(4091),
    [anon_sym_DOT_DOT] = ACTIONS(4091),
    [anon_sym_begin] = ACTIONS(4093),
    [anon_sym_LPAREN2] = ACTIONS(4093),
    [anon_sym_or] = ACTIONS(4093),
    [aux_sym_char_token1] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4093),
    [anon_sym_DQUOTE] = ACTIONS(4093),
    [anon_sym_AT_DQUOTE] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [sym_bool] = ACTIONS(4093),
    [sym_unit] = ACTIONS(4091),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4093),
    [sym_op_identifier] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS_DOT] = ACTIONS(4093),
    [anon_sym_DASH_DOT] = ACTIONS(4093),
    [anon_sym_PERCENT] = ACTIONS(4093),
    [anon_sym_AMP_AMP] = ACTIONS(4093),
    [anon_sym_TILDE] = ACTIONS(4091),
    [aux_sym_prefix_op_token1] = ACTIONS(4093),
    [aux_sym_infix_op_token1] = ACTIONS(4091),
    [aux_sym_infix_op_token2] = ACTIONS(4093),
    [anon_sym_PIPE_PIPE] = ACTIONS(4093),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_COLON_EQ] = ACTIONS(4091),
    [anon_sym_DOLLAR] = ACTIONS(4093),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4093),
    [sym_int] = ACTIONS(4093),
    [sym_xint] = ACTIONS(4091),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4091),
    [sym__newline] = ACTIONS(4091),
  },
  [3077] = {
    [sym_block_comment] = STATE(3077),
    [sym_compiler_directive_decl] = STATE(3077),
    [sym_fsi_directive_decl] = STATE(3077),
    [sym_preproc_line] = STATE(3077),
    [sym_identifier] = ACTIONS(4086),
    [anon_sym_EQ] = ACTIONS(4084),
    [anon_sym_COLON] = ACTIONS(4086),
    [anon_sym_return] = ACTIONS(4086),
    [anon_sym_do] = ACTIONS(4086),
    [anon_sym_let] = ACTIONS(4086),
    [anon_sym_let_BANG] = ACTIONS(4084),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_COMMA] = ACTIONS(4084),
    [anon_sym_null] = ACTIONS(4086),
    [anon_sym_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_COLON] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4084),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_LT_AT] = ACTIONS(4086),
    [anon_sym_LT_AT_AT] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4086),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4084),
    [anon_sym_new] = ACTIONS(4086),
    [anon_sym_return_BANG] = ACTIONS(4084),
    [anon_sym_yield] = ACTIONS(4086),
    [anon_sym_yield_BANG] = ACTIONS(4084),
    [anon_sym_lazy] = ACTIONS(4086),
    [anon_sym_assert] = ACTIONS(4086),
    [anon_sym_upcast] = ACTIONS(4086),
    [anon_sym_downcast] = ACTIONS(4086),
    [anon_sym_COLON_GT] = ACTIONS(4084),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4084),
    [anon_sym_for] = ACTIONS(4086),
    [anon_sym_while] = ACTIONS(4086),
    [anon_sym_if] = ACTIONS(4086),
    [anon_sym_fun] = ACTIONS(4086),
    [anon_sym_DASH_GT] = ACTIONS(4086),
    [anon_sym_try] = ACTIONS(4086),
    [anon_sym_match] = ACTIONS(4086),
    [anon_sym_match_BANG] = ACTIONS(4084),
    [anon_sym_function] = ACTIONS(4086),
    [anon_sym_LT_DASH] = ACTIONS(4086),
    [anon_sym_DOT_LBRACK] = ACTIONS(4084),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_use] = ACTIONS(4086),
    [anon_sym_use_BANG] = ACTIONS(4084),
    [anon_sym_do_BANG] = ACTIONS(4084),
    [anon_sym_DOT_DOT] = ACTIONS(4084),
    [anon_sym_begin] = ACTIONS(4086),
    [anon_sym_LPAREN2] = ACTIONS(4086),
    [anon_sym_or] = ACTIONS(4086),
    [aux_sym_char_token1] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4086),
    [anon_sym_DQUOTE] = ACTIONS(4086),
    [anon_sym_AT_DQUOTE] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [sym_bool] = ACTIONS(4086),
    [sym_unit] = ACTIONS(4084),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4086),
    [sym_op_identifier] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4086),
    [anon_sym_DASH] = ACTIONS(4086),
    [anon_sym_PLUS_DOT] = ACTIONS(4086),
    [anon_sym_DASH_DOT] = ACTIONS(4086),
    [anon_sym_PERCENT] = ACTIONS(4086),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_TILDE] = ACTIONS(4084),
    [aux_sym_prefix_op_token1] = ACTIONS(4086),
    [aux_sym_infix_op_token1] = ACTIONS(4084),
    [aux_sym_infix_op_token2] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_COLON_EQ] = ACTIONS(4084),
    [anon_sym_DOLLAR] = ACTIONS(4086),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4086),
    [sym_int] = ACTIONS(4086),
    [sym_xint] = ACTIONS(4084),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4084),
    [sym__newline] = ACTIONS(4084),
  },
  [3078] = {
    [sym_block_comment] = STATE(3078),
    [sym_compiler_directive_decl] = STATE(3078),
    [sym_fsi_directive_decl] = STATE(3078),
    [sym_preproc_line] = STATE(3078),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_COLON] = ACTIONS(4082),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_do] = ACTIONS(4082),
    [anon_sym_let] = ACTIONS(4082),
    [anon_sym_let_BANG] = ACTIONS(4080),
    [anon_sym_LPAREN] = ACTIONS(4082),
    [anon_sym_COMMA] = ACTIONS(4080),
    [anon_sym_null] = ACTIONS(4082),
    [anon_sym_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_COLON] = ACTIONS(4080),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_LBRACK] = ACTIONS(4082),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(4082),
    [anon_sym_LT_AT] = ACTIONS(4082),
    [anon_sym_LT_AT_AT] = ACTIONS(4082),
    [anon_sym_DOT] = ACTIONS(4082),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4080),
    [anon_sym_new] = ACTIONS(4082),
    [anon_sym_return_BANG] = ACTIONS(4080),
    [anon_sym_yield] = ACTIONS(4082),
    [anon_sym_yield_BANG] = ACTIONS(4080),
    [anon_sym_lazy] = ACTIONS(4082),
    [anon_sym_assert] = ACTIONS(4082),
    [anon_sym_upcast] = ACTIONS(4082),
    [anon_sym_downcast] = ACTIONS(4082),
    [anon_sym_COLON_GT] = ACTIONS(4080),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4080),
    [anon_sym_for] = ACTIONS(4082),
    [anon_sym_while] = ACTIONS(4082),
    [anon_sym_if] = ACTIONS(4082),
    [anon_sym_fun] = ACTIONS(4082),
    [anon_sym_DASH_GT] = ACTIONS(4082),
    [anon_sym_try] = ACTIONS(4082),
    [anon_sym_match] = ACTIONS(4082),
    [anon_sym_match_BANG] = ACTIONS(4080),
    [anon_sym_function] = ACTIONS(4082),
    [anon_sym_LT_DASH] = ACTIONS(4082),
    [anon_sym_DOT_LBRACK] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(4080),
    [anon_sym_use] = ACTIONS(4082),
    [anon_sym_use_BANG] = ACTIONS(4080),
    [anon_sym_do_BANG] = ACTIONS(4080),
    [anon_sym_DOT_DOT] = ACTIONS(4080),
    [anon_sym_begin] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4082),
    [anon_sym_or] = ACTIONS(4082),
    [aux_sym_char_token1] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4082),
    [anon_sym_DQUOTE] = ACTIONS(4082),
    [anon_sym_AT_DQUOTE] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [sym_bool] = ACTIONS(4082),
    [sym_unit] = ACTIONS(4080),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4082),
    [sym_op_identifier] = ACTIONS(4082),
    [anon_sym_PLUS] = ACTIONS(4082),
    [anon_sym_DASH] = ACTIONS(4082),
    [anon_sym_PLUS_DOT] = ACTIONS(4082),
    [anon_sym_DASH_DOT] = ACTIONS(4082),
    [anon_sym_PERCENT] = ACTIONS(4082),
    [anon_sym_AMP_AMP] = ACTIONS(4082),
    [anon_sym_TILDE] = ACTIONS(4080),
    [aux_sym_prefix_op_token1] = ACTIONS(4082),
    [aux_sym_infix_op_token1] = ACTIONS(4080),
    [aux_sym_infix_op_token2] = ACTIONS(4082),
    [anon_sym_PIPE_PIPE] = ACTIONS(4082),
    [anon_sym_BANG_EQ] = ACTIONS(4082),
    [anon_sym_COLON_EQ] = ACTIONS(4080),
    [anon_sym_DOLLAR] = ACTIONS(4082),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4082),
    [sym_int] = ACTIONS(4082),
    [sym_xint] = ACTIONS(4080),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4080),
    [sym__newline] = ACTIONS(4080),
  },
  [3079] = {
    [sym_block_comment] = STATE(3079),
    [sym_compiler_directive_decl] = STATE(3079),
    [sym_fsi_directive_decl] = STATE(3079),
    [sym_preproc_line] = STATE(3079),
    [sym_identifier] = ACTIONS(4054),
    [anon_sym_EQ] = ACTIONS(4052),
    [anon_sym_COLON] = ACTIONS(4054),
    [anon_sym_return] = ACTIONS(4054),
    [anon_sym_do] = ACTIONS(4054),
    [anon_sym_let] = ACTIONS(4054),
    [anon_sym_let_BANG] = ACTIONS(4052),
    [anon_sym_LPAREN] = ACTIONS(4054),
    [anon_sym_COMMA] = ACTIONS(4052),
    [anon_sym_null] = ACTIONS(4054),
    [anon_sym_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_COLON] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(4054),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4052),
    [anon_sym_LBRACE] = ACTIONS(4054),
    [anon_sym_LT_AT] = ACTIONS(4054),
    [anon_sym_LT_AT_AT] = ACTIONS(4054),
    [anon_sym_DOT] = ACTIONS(4054),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_return_BANG] = ACTIONS(4052),
    [anon_sym_yield] = ACTIONS(4054),
    [anon_sym_yield_BANG] = ACTIONS(4052),
    [anon_sym_lazy] = ACTIONS(4054),
    [anon_sym_assert] = ACTIONS(4054),
    [anon_sym_upcast] = ACTIONS(4054),
    [anon_sym_downcast] = ACTIONS(4054),
    [anon_sym_COLON_GT] = ACTIONS(4052),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4052),
    [anon_sym_for] = ACTIONS(4054),
    [anon_sym_while] = ACTIONS(4054),
    [anon_sym_if] = ACTIONS(4054),
    [anon_sym_fun] = ACTIONS(4054),
    [anon_sym_DASH_GT] = ACTIONS(4054),
    [anon_sym_try] = ACTIONS(4054),
    [anon_sym_match] = ACTIONS(4054),
    [anon_sym_match_BANG] = ACTIONS(4052),
    [anon_sym_function] = ACTIONS(4054),
    [anon_sym_LT_DASH] = ACTIONS(4054),
    [anon_sym_DOT_LBRACK] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_use] = ACTIONS(4054),
    [anon_sym_use_BANG] = ACTIONS(4052),
    [anon_sym_do_BANG] = ACTIONS(4052),
    [anon_sym_DOT_DOT] = ACTIONS(4052),
    [anon_sym_begin] = ACTIONS(4054),
    [anon_sym_LPAREN2] = ACTIONS(4054),
    [anon_sym_or] = ACTIONS(4054),
    [aux_sym_char_token1] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4054),
    [anon_sym_DQUOTE] = ACTIONS(4054),
    [anon_sym_AT_DQUOTE] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [sym_bool] = ACTIONS(4054),
    [sym_unit] = ACTIONS(4052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4054),
    [sym_op_identifier] = ACTIONS(4054),
    [anon_sym_PLUS] = ACTIONS(4054),
    [anon_sym_DASH] = ACTIONS(4054),
    [anon_sym_PLUS_DOT] = ACTIONS(4054),
    [anon_sym_DASH_DOT] = ACTIONS(4054),
    [anon_sym_PERCENT] = ACTIONS(4054),
    [anon_sym_AMP_AMP] = ACTIONS(4054),
    [anon_sym_TILDE] = ACTIONS(4052),
    [aux_sym_prefix_op_token1] = ACTIONS(4054),
    [aux_sym_infix_op_token1] = ACTIONS(4052),
    [aux_sym_infix_op_token2] = ACTIONS(4054),
    [anon_sym_PIPE_PIPE] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4054),
    [anon_sym_COLON_EQ] = ACTIONS(4052),
    [anon_sym_DOLLAR] = ACTIONS(4054),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4054),
    [sym_int] = ACTIONS(4054),
    [sym_xint] = ACTIONS(4052),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4052),
    [sym__newline] = ACTIONS(4052),
  },
  [3080] = {
    [sym_block_comment] = STATE(3080),
    [sym_compiler_directive_decl] = STATE(3080),
    [sym_fsi_directive_decl] = STATE(3080),
    [sym_preproc_line] = STATE(3080),
    [sym_identifier] = ACTIONS(4018),
    [anon_sym_EQ] = ACTIONS(4016),
    [anon_sym_COLON] = ACTIONS(4018),
    [anon_sym_return] = ACTIONS(4018),
    [anon_sym_do] = ACTIONS(4018),
    [anon_sym_let] = ACTIONS(4018),
    [anon_sym_let_BANG] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(4018),
    [anon_sym_COMMA] = ACTIONS(4016),
    [anon_sym_null] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_COLON] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4018),
    [anon_sym_LBRACK] = ACTIONS(4018),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4016),
    [anon_sym_LBRACE] = ACTIONS(4018),
    [anon_sym_LT_AT] = ACTIONS(4018),
    [anon_sym_LT_AT_AT] = ACTIONS(4018),
    [anon_sym_DOT] = ACTIONS(4018),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4016),
    [anon_sym_new] = ACTIONS(4018),
    [anon_sym_return_BANG] = ACTIONS(4016),
    [anon_sym_yield] = ACTIONS(4018),
    [anon_sym_yield_BANG] = ACTIONS(4016),
    [anon_sym_lazy] = ACTIONS(4018),
    [anon_sym_assert] = ACTIONS(4018),
    [anon_sym_upcast] = ACTIONS(4018),
    [anon_sym_downcast] = ACTIONS(4018),
    [anon_sym_COLON_GT] = ACTIONS(4016),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4016),
    [anon_sym_for] = ACTIONS(4018),
    [anon_sym_while] = ACTIONS(4018),
    [anon_sym_if] = ACTIONS(4018),
    [anon_sym_fun] = ACTIONS(4018),
    [anon_sym_DASH_GT] = ACTIONS(4018),
    [anon_sym_try] = ACTIONS(4018),
    [anon_sym_match] = ACTIONS(4018),
    [anon_sym_match_BANG] = ACTIONS(4016),
    [anon_sym_function] = ACTIONS(4018),
    [anon_sym_LT_DASH] = ACTIONS(4018),
    [anon_sym_DOT_LBRACK] = ACTIONS(4016),
    [anon_sym_LT] = ACTIONS(4016),
    [anon_sym_use] = ACTIONS(4018),
    [anon_sym_use_BANG] = ACTIONS(4016),
    [anon_sym_do_BANG] = ACTIONS(4016),
    [anon_sym_DOT_DOT] = ACTIONS(4016),
    [anon_sym_begin] = ACTIONS(4018),
    [anon_sym_LPAREN2] = ACTIONS(4018),
    [anon_sym_or] = ACTIONS(4018),
    [aux_sym_char_token1] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(4018),
    [anon_sym_AT_DQUOTE] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [sym_bool] = ACTIONS(4018),
    [sym_unit] = ACTIONS(4016),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4018),
    [sym_op_identifier] = ACTIONS(4018),
    [anon_sym_PLUS] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_PLUS_DOT] = ACTIONS(4018),
    [anon_sym_DASH_DOT] = ACTIONS(4018),
    [anon_sym_PERCENT] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4016),
    [aux_sym_prefix_op_token1] = ACTIONS(4018),
    [aux_sym_infix_op_token1] = ACTIONS(4016),
    [aux_sym_infix_op_token2] = ACTIONS(4018),
    [anon_sym_PIPE_PIPE] = ACTIONS(4018),
    [anon_sym_BANG_EQ] = ACTIONS(4018),
    [anon_sym_COLON_EQ] = ACTIONS(4016),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4018),
    [sym_int] = ACTIONS(4018),
    [sym_xint] = ACTIONS(4016),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4016),
    [sym__newline] = ACTIONS(4016),
  },
  [3081] = {
    [sym_block_comment] = STATE(3081),
    [sym_compiler_directive_decl] = STATE(3081),
    [sym_fsi_directive_decl] = STATE(3081),
    [sym_preproc_line] = STATE(3081),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3843),
    [anon_sym_COLON] = ACTIONS(3845),
    [anon_sym_return] = ACTIONS(3845),
    [anon_sym_do] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_let_BANG] = ACTIONS(3843),
    [anon_sym_LPAREN] = ACTIONS(3845),
    [anon_sym_COMMA] = ACTIONS(3843),
    [anon_sym_null] = ACTIONS(3845),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3843),
    [anon_sym_LBRACE] = ACTIONS(3845),
    [anon_sym_LT_AT] = ACTIONS(3845),
    [anon_sym_LT_AT_AT] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3843),
    [anon_sym_new] = ACTIONS(3845),
    [anon_sym_return_BANG] = ACTIONS(3843),
    [anon_sym_yield] = ACTIONS(3845),
    [anon_sym_yield_BANG] = ACTIONS(3843),
    [anon_sym_lazy] = ACTIONS(3845),
    [anon_sym_assert] = ACTIONS(3845),
    [anon_sym_upcast] = ACTIONS(3845),
    [anon_sym_downcast] = ACTIONS(3845),
    [anon_sym_COLON_GT] = ACTIONS(3843),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3843),
    [anon_sym_for] = ACTIONS(3845),
    [anon_sym_while] = ACTIONS(3845),
    [anon_sym_if] = ACTIONS(3845),
    [anon_sym_fun] = ACTIONS(3845),
    [anon_sym_DASH_GT] = ACTIONS(3845),
    [anon_sym_try] = ACTIONS(3845),
    [anon_sym_match] = ACTIONS(3845),
    [anon_sym_match_BANG] = ACTIONS(3843),
    [anon_sym_function] = ACTIONS(3845),
    [anon_sym_LT_DASH] = ACTIONS(3845),
    [anon_sym_DOT_LBRACK] = ACTIONS(3843),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_use] = ACTIONS(3845),
    [anon_sym_use_BANG] = ACTIONS(3843),
    [anon_sym_do_BANG] = ACTIONS(3843),
    [anon_sym_DOT_DOT] = ACTIONS(3843),
    [anon_sym_begin] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(3845),
    [anon_sym_or] = ACTIONS(3845),
    [aux_sym_char_token1] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3845),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_AT_DQUOTE] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [sym_bool] = ACTIONS(3845),
    [sym_unit] = ACTIONS(3843),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3845),
    [sym_op_identifier] = ACTIONS(3845),
    [anon_sym_PLUS] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_PLUS_DOT] = ACTIONS(3845),
    [anon_sym_DASH_DOT] = ACTIONS(3845),
    [anon_sym_PERCENT] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3845),
    [anon_sym_TILDE] = ACTIONS(3843),
    [aux_sym_prefix_op_token1] = ACTIONS(3845),
    [aux_sym_infix_op_token1] = ACTIONS(3843),
    [aux_sym_infix_op_token2] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(3845),
    [anon_sym_BANG_EQ] = ACTIONS(3845),
    [anon_sym_COLON_EQ] = ACTIONS(3843),
    [anon_sym_DOLLAR] = ACTIONS(3845),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3845),
    [sym_int] = ACTIONS(3845),
    [sym_xint] = ACTIONS(3843),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3843),
    [sym__newline] = ACTIONS(3843),
  },
  [3082] = {
    [sym_block_comment] = STATE(3082),
    [sym_compiler_directive_decl] = STATE(3082),
    [sym_fsi_directive_decl] = STATE(3082),
    [sym_preproc_line] = STATE(3082),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_EQ] = ACTIONS(4001),
    [anon_sym_COLON] = ACTIONS(4003),
    [anon_sym_return] = ACTIONS(4003),
    [anon_sym_do] = ACTIONS(4003),
    [anon_sym_let] = ACTIONS(4003),
    [anon_sym_let_BANG] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4003),
    [anon_sym_COMMA] = ACTIONS(4001),
    [anon_sym_null] = ACTIONS(4003),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_COLON] = ACTIONS(4001),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LBRACK] = ACTIONS(4003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4001),
    [anon_sym_LBRACE] = ACTIONS(4003),
    [anon_sym_LT_AT] = ACTIONS(4003),
    [anon_sym_LT_AT_AT] = ACTIONS(4003),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4001),
    [anon_sym_new] = ACTIONS(4003),
    [anon_sym_return_BANG] = ACTIONS(4001),
    [anon_sym_yield] = ACTIONS(4003),
    [anon_sym_yield_BANG] = ACTIONS(4001),
    [anon_sym_lazy] = ACTIONS(4003),
    [anon_sym_assert] = ACTIONS(4003),
    [anon_sym_upcast] = ACTIONS(4003),
    [anon_sym_downcast] = ACTIONS(4003),
    [anon_sym_COLON_GT] = ACTIONS(4001),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4001),
    [anon_sym_for] = ACTIONS(4003),
    [anon_sym_while] = ACTIONS(4003),
    [anon_sym_if] = ACTIONS(4003),
    [anon_sym_fun] = ACTIONS(4003),
    [anon_sym_DASH_GT] = ACTIONS(4003),
    [anon_sym_try] = ACTIONS(4003),
    [anon_sym_match] = ACTIONS(4003),
    [anon_sym_match_BANG] = ACTIONS(4001),
    [anon_sym_function] = ACTIONS(4003),
    [anon_sym_LT_DASH] = ACTIONS(4003),
    [anon_sym_DOT_LBRACK] = ACTIONS(4001),
    [anon_sym_LT] = ACTIONS(4001),
    [anon_sym_use] = ACTIONS(4003),
    [anon_sym_use_BANG] = ACTIONS(4001),
    [anon_sym_do_BANG] = ACTIONS(4001),
    [anon_sym_DOT_DOT] = ACTIONS(4001),
    [anon_sym_begin] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [aux_sym_char_token1] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4003),
    [anon_sym_DQUOTE] = ACTIONS(4003),
    [anon_sym_AT_DQUOTE] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [sym_bool] = ACTIONS(4003),
    [sym_unit] = ACTIONS(4001),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4003),
    [sym_op_identifier] = ACTIONS(4003),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_PLUS_DOT] = ACTIONS(4003),
    [anon_sym_DASH_DOT] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4003),
    [anon_sym_TILDE] = ACTIONS(4001),
    [aux_sym_prefix_op_token1] = ACTIONS(4003),
    [aux_sym_infix_op_token1] = ACTIONS(4001),
    [aux_sym_infix_op_token2] = ACTIONS(4003),
    [anon_sym_PIPE_PIPE] = ACTIONS(4003),
    [anon_sym_BANG_EQ] = ACTIONS(4003),
    [anon_sym_COLON_EQ] = ACTIONS(4001),
    [anon_sym_DOLLAR] = ACTIONS(4003),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4003),
    [sym_int] = ACTIONS(4003),
    [sym_xint] = ACTIONS(4001),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4001),
    [sym__newline] = ACTIONS(4001),
  },
  [3083] = {
    [sym_block_comment] = STATE(3083),
    [sym_compiler_directive_decl] = STATE(3083),
    [sym_fsi_directive_decl] = STATE(3083),
    [sym_preproc_line] = STATE(3083),
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_EQ] = ACTIONS(4149),
    [anon_sym_COLON] = ACTIONS(4151),
    [anon_sym_return] = ACTIONS(4151),
    [anon_sym_do] = ACTIONS(4151),
    [anon_sym_let] = ACTIONS(4151),
    [anon_sym_let_BANG] = ACTIONS(4149),
    [anon_sym_as] = ACTIONS(4151),
    [anon_sym_LPAREN] = ACTIONS(4151),
    [anon_sym_COMMA] = ACTIONS(4149),
    [anon_sym_null] = ACTIONS(4151),
    [anon_sym_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_AMP] = ACTIONS(4151),
    [anon_sym_LBRACK] = ACTIONS(4151),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4149),
    [anon_sym_LBRACE] = ACTIONS(4151),
    [anon_sym_LT_AT] = ACTIONS(4151),
    [anon_sym_LT_AT_AT] = ACTIONS(4151),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4149),
    [anon_sym_new] = ACTIONS(4151),
    [anon_sym_with] = ACTIONS(4151),
    [anon_sym_return_BANG] = ACTIONS(4149),
    [anon_sym_yield] = ACTIONS(4151),
    [anon_sym_yield_BANG] = ACTIONS(4149),
    [anon_sym_lazy] = ACTIONS(4151),
    [anon_sym_assert] = ACTIONS(4151),
    [anon_sym_upcast] = ACTIONS(4151),
    [anon_sym_downcast] = ACTIONS(4151),
    [anon_sym_COLON_GT] = ACTIONS(4149),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4149),
    [anon_sym_for] = ACTIONS(4151),
    [anon_sym_while] = ACTIONS(4151),
    [anon_sym_if] = ACTIONS(4151),
    [anon_sym_fun] = ACTIONS(4151),
    [anon_sym_try] = ACTIONS(4151),
    [anon_sym_match] = ACTIONS(4151),
    [anon_sym_match_BANG] = ACTIONS(4149),
    [anon_sym_function] = ACTIONS(4151),
    [anon_sym_LT_DASH] = ACTIONS(4151),
    [anon_sym_DOT_LBRACK] = ACTIONS(4149),
    [anon_sym_LT] = ACTIONS(4149),
    [anon_sym_use] = ACTIONS(4151),
    [anon_sym_use_BANG] = ACTIONS(4149),
    [anon_sym_do_BANG] = ACTIONS(4149),
    [anon_sym_begin] = ACTIONS(4151),
    [anon_sym_LPAREN2] = ACTIONS(4151),
    [anon_sym_or] = ACTIONS(4151),
    [aux_sym_char_token1] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4151),
    [anon_sym_DQUOTE] = ACTIONS(4151),
    [anon_sym_AT_DQUOTE] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [sym_bool] = ACTIONS(4151),
    [sym_unit] = ACTIONS(4149),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4151),
    [sym_op_identifier] = ACTIONS(4151),
    [anon_sym_PLUS] = ACTIONS(4151),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_PLUS_DOT] = ACTIONS(4151),
    [anon_sym_DASH_DOT] = ACTIONS(4151),
    [anon_sym_PERCENT] = ACTIONS(4151),
    [anon_sym_AMP_AMP] = ACTIONS(4151),
    [anon_sym_TILDE] = ACTIONS(4149),
    [aux_sym_prefix_op_token1] = ACTIONS(4151),
    [aux_sym_infix_op_token1] = ACTIONS(4149),
    [aux_sym_infix_op_token2] = ACTIONS(4151),
    [anon_sym_PIPE_PIPE] = ACTIONS(4151),
    [anon_sym_BANG_EQ] = ACTIONS(4151),
    [anon_sym_COLON_EQ] = ACTIONS(4149),
    [anon_sym_DOLLAR] = ACTIONS(4151),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4151),
    [sym_int] = ACTIONS(4151),
    [sym_xint] = ACTIONS(4149),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4149),
    [sym__newline] = ACTIONS(4149),
  },
  [3084] = {
    [sym_block_comment] = STATE(3084),
    [sym_compiler_directive_decl] = STATE(3084),
    [sym_fsi_directive_decl] = STATE(3084),
    [sym_preproc_line] = STATE(3084),
    [sym_identifier] = ACTIONS(4011),
    [anon_sym_EQ] = ACTIONS(4009),
    [anon_sym_COLON] = ACTIONS(4011),
    [anon_sym_return] = ACTIONS(4011),
    [anon_sym_do] = ACTIONS(4011),
    [anon_sym_let] = ACTIONS(4011),
    [anon_sym_let_BANG] = ACTIONS(4009),
    [anon_sym_as] = ACTIONS(4011),
    [anon_sym_LPAREN] = ACTIONS(4011),
    [anon_sym_COMMA] = ACTIONS(4009),
    [anon_sym_null] = ACTIONS(4011),
    [anon_sym_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(4011),
    [anon_sym_LBRACK] = ACTIONS(4011),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4009),
    [anon_sym_LBRACE] = ACTIONS(4011),
    [anon_sym_LT_AT] = ACTIONS(4011),
    [anon_sym_LT_AT_AT] = ACTIONS(4011),
    [anon_sym_DOT] = ACTIONS(4011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4009),
    [anon_sym_new] = ACTIONS(4011),
    [anon_sym_with] = ACTIONS(4011),
    [anon_sym_return_BANG] = ACTIONS(4009),
    [anon_sym_yield] = ACTIONS(4011),
    [anon_sym_yield_BANG] = ACTIONS(4009),
    [anon_sym_lazy] = ACTIONS(4011),
    [anon_sym_assert] = ACTIONS(4011),
    [anon_sym_upcast] = ACTIONS(4011),
    [anon_sym_downcast] = ACTIONS(4011),
    [anon_sym_COLON_GT] = ACTIONS(4009),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4009),
    [anon_sym_for] = ACTIONS(4011),
    [anon_sym_while] = ACTIONS(4011),
    [anon_sym_if] = ACTIONS(4011),
    [anon_sym_fun] = ACTIONS(4011),
    [anon_sym_try] = ACTIONS(4011),
    [anon_sym_match] = ACTIONS(4011),
    [anon_sym_match_BANG] = ACTIONS(4009),
    [anon_sym_function] = ACTIONS(4011),
    [anon_sym_LT_DASH] = ACTIONS(4011),
    [anon_sym_DOT_LBRACK] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(4009),
    [anon_sym_use] = ACTIONS(4011),
    [anon_sym_use_BANG] = ACTIONS(4009),
    [anon_sym_do_BANG] = ACTIONS(4009),
    [anon_sym_begin] = ACTIONS(4011),
    [anon_sym_LPAREN2] = ACTIONS(4011),
    [anon_sym_or] = ACTIONS(4011),
    [aux_sym_char_token1] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4011),
    [anon_sym_DQUOTE] = ACTIONS(4011),
    [anon_sym_AT_DQUOTE] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [sym_bool] = ACTIONS(4011),
    [sym_unit] = ACTIONS(4009),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4011),
    [sym_op_identifier] = ACTIONS(4011),
    [anon_sym_PLUS] = ACTIONS(4011),
    [anon_sym_DASH] = ACTIONS(4011),
    [anon_sym_PLUS_DOT] = ACTIONS(4011),
    [anon_sym_DASH_DOT] = ACTIONS(4011),
    [anon_sym_PERCENT] = ACTIONS(4011),
    [anon_sym_AMP_AMP] = ACTIONS(4011),
    [anon_sym_TILDE] = ACTIONS(4009),
    [aux_sym_prefix_op_token1] = ACTIONS(4011),
    [aux_sym_infix_op_token1] = ACTIONS(4009),
    [aux_sym_infix_op_token2] = ACTIONS(4011),
    [anon_sym_PIPE_PIPE] = ACTIONS(4011),
    [anon_sym_BANG_EQ] = ACTIONS(4011),
    [anon_sym_COLON_EQ] = ACTIONS(4009),
    [anon_sym_DOLLAR] = ACTIONS(4011),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4011),
    [sym_int] = ACTIONS(4011),
    [sym_xint] = ACTIONS(4009),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4009),
    [sym__newline] = ACTIONS(4009),
  },
  [3085] = {
    [sym_block_comment] = STATE(3085),
    [sym_compiler_directive_decl] = STATE(3085),
    [sym_fsi_directive_decl] = STATE(3085),
    [sym_preproc_line] = STATE(3085),
    [sym_identifier] = ACTIONS(3972),
    [anon_sym_EQ] = ACTIONS(3970),
    [anon_sym_COLON] = ACTIONS(3972),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_do] = ACTIONS(3972),
    [anon_sym_let] = ACTIONS(3972),
    [anon_sym_let_BANG] = ACTIONS(3970),
    [anon_sym_LPAREN] = ACTIONS(3972),
    [anon_sym_COMMA] = ACTIONS(3970),
    [anon_sym_null] = ACTIONS(3972),
    [anon_sym_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_COLON] = ACTIONS(3970),
    [anon_sym_AMP] = ACTIONS(3972),
    [anon_sym_LBRACK] = ACTIONS(3972),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3970),
    [anon_sym_LBRACE] = ACTIONS(3972),
    [anon_sym_LT_AT] = ACTIONS(3972),
    [anon_sym_LT_AT_AT] = ACTIONS(3972),
    [anon_sym_DOT] = ACTIONS(3972),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3970),
    [anon_sym_new] = ACTIONS(3972),
    [anon_sym_return_BANG] = ACTIONS(3970),
    [anon_sym_yield] = ACTIONS(3972),
    [anon_sym_yield_BANG] = ACTIONS(3970),
    [anon_sym_lazy] = ACTIONS(3972),
    [anon_sym_assert] = ACTIONS(3972),
    [anon_sym_upcast] = ACTIONS(3972),
    [anon_sym_downcast] = ACTIONS(3972),
    [anon_sym_COLON_GT] = ACTIONS(3970),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3970),
    [anon_sym_for] = ACTIONS(3972),
    [anon_sym_while] = ACTIONS(3972),
    [anon_sym_if] = ACTIONS(3972),
    [anon_sym_fun] = ACTIONS(3972),
    [anon_sym_DASH_GT] = ACTIONS(3972),
    [anon_sym_try] = ACTIONS(3972),
    [anon_sym_match] = ACTIONS(3972),
    [anon_sym_match_BANG] = ACTIONS(3970),
    [anon_sym_function] = ACTIONS(3972),
    [anon_sym_LT_DASH] = ACTIONS(3972),
    [anon_sym_DOT_LBRACK] = ACTIONS(3970),
    [anon_sym_LT] = ACTIONS(3970),
    [anon_sym_use] = ACTIONS(3972),
    [anon_sym_use_BANG] = ACTIONS(3970),
    [anon_sym_do_BANG] = ACTIONS(3970),
    [anon_sym_DOT_DOT] = ACTIONS(3970),
    [anon_sym_begin] = ACTIONS(3972),
    [anon_sym_LPAREN2] = ACTIONS(3972),
    [anon_sym_or] = ACTIONS(3972),
    [aux_sym_char_token1] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3972),
    [anon_sym_DQUOTE] = ACTIONS(3972),
    [anon_sym_AT_DQUOTE] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [sym_bool] = ACTIONS(3972),
    [sym_unit] = ACTIONS(3970),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3972),
    [sym_op_identifier] = ACTIONS(3972),
    [anon_sym_PLUS] = ACTIONS(3972),
    [anon_sym_DASH] = ACTIONS(3972),
    [anon_sym_PLUS_DOT] = ACTIONS(3972),
    [anon_sym_DASH_DOT] = ACTIONS(3972),
    [anon_sym_PERCENT] = ACTIONS(3972),
    [anon_sym_AMP_AMP] = ACTIONS(3972),
    [anon_sym_TILDE] = ACTIONS(3970),
    [aux_sym_prefix_op_token1] = ACTIONS(3972),
    [aux_sym_infix_op_token1] = ACTIONS(3970),
    [aux_sym_infix_op_token2] = ACTIONS(3972),
    [anon_sym_PIPE_PIPE] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3972),
    [anon_sym_COLON_EQ] = ACTIONS(3970),
    [anon_sym_DOLLAR] = ACTIONS(3972),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3972),
    [sym_int] = ACTIONS(3972),
    [sym_xint] = ACTIONS(3970),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3970),
    [sym__newline] = ACTIONS(3970),
  },
  [3086] = {
    [sym_block_comment] = STATE(3086),
    [sym_compiler_directive_decl] = STATE(3086),
    [sym_fsi_directive_decl] = STATE(3086),
    [sym_preproc_line] = STATE(3086),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_AT_GT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(5458),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
  },
  [3087] = {
    [sym_block_comment] = STATE(3087),
    [sym_compiler_directive_decl] = STATE(3087),
    [sym_fsi_directive_decl] = STATE(3087),
    [sym_preproc_line] = STATE(3087),
    [sym_identifier] = ACTIONS(4007),
    [anon_sym_EQ] = ACTIONS(4005),
    [anon_sym_COLON] = ACTIONS(4007),
    [anon_sym_return] = ACTIONS(4007),
    [anon_sym_do] = ACTIONS(4007),
    [anon_sym_let] = ACTIONS(4007),
    [anon_sym_let_BANG] = ACTIONS(4005),
    [anon_sym_as] = ACTIONS(4007),
    [anon_sym_LPAREN] = ACTIONS(4007),
    [anon_sym_COMMA] = ACTIONS(4005),
    [anon_sym_null] = ACTIONS(4007),
    [anon_sym_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_COLON] = ACTIONS(4005),
    [anon_sym_AMP] = ACTIONS(4007),
    [anon_sym_LBRACK] = ACTIONS(4007),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4005),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_LT_AT] = ACTIONS(4007),
    [anon_sym_LT_AT_AT] = ACTIONS(4007),
    [anon_sym_DOT] = ACTIONS(4007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4005),
    [anon_sym_new] = ACTIONS(4007),
    [anon_sym_with] = ACTIONS(4007),
    [anon_sym_return_BANG] = ACTIONS(4005),
    [anon_sym_yield] = ACTIONS(4007),
    [anon_sym_yield_BANG] = ACTIONS(4005),
    [anon_sym_lazy] = ACTIONS(4007),
    [anon_sym_assert] = ACTIONS(4007),
    [anon_sym_upcast] = ACTIONS(4007),
    [anon_sym_downcast] = ACTIONS(4007),
    [anon_sym_COLON_GT] = ACTIONS(4005),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4005),
    [anon_sym_for] = ACTIONS(4007),
    [anon_sym_while] = ACTIONS(4007),
    [anon_sym_if] = ACTIONS(4007),
    [anon_sym_fun] = ACTIONS(4007),
    [anon_sym_try] = ACTIONS(4007),
    [anon_sym_match] = ACTIONS(4007),
    [anon_sym_match_BANG] = ACTIONS(4005),
    [anon_sym_function] = ACTIONS(4007),
    [anon_sym_LT_DASH] = ACTIONS(4007),
    [anon_sym_DOT_LBRACK] = ACTIONS(4005),
    [anon_sym_LT] = ACTIONS(4005),
    [anon_sym_use] = ACTIONS(4007),
    [anon_sym_use_BANG] = ACTIONS(4005),
    [anon_sym_do_BANG] = ACTIONS(4005),
    [anon_sym_begin] = ACTIONS(4007),
    [anon_sym_LPAREN2] = ACTIONS(4007),
    [anon_sym_or] = ACTIONS(4007),
    [aux_sym_char_token1] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4007),
    [anon_sym_DQUOTE] = ACTIONS(4007),
    [anon_sym_AT_DQUOTE] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [sym_bool] = ACTIONS(4007),
    [sym_unit] = ACTIONS(4005),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4007),
    [sym_op_identifier] = ACTIONS(4007),
    [anon_sym_PLUS] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4007),
    [anon_sym_PLUS_DOT] = ACTIONS(4007),
    [anon_sym_DASH_DOT] = ACTIONS(4007),
    [anon_sym_PERCENT] = ACTIONS(4007),
    [anon_sym_AMP_AMP] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4005),
    [aux_sym_prefix_op_token1] = ACTIONS(4007),
    [aux_sym_infix_op_token1] = ACTIONS(4005),
    [aux_sym_infix_op_token2] = ACTIONS(4007),
    [anon_sym_PIPE_PIPE] = ACTIONS(4007),
    [anon_sym_BANG_EQ] = ACTIONS(4007),
    [anon_sym_COLON_EQ] = ACTIONS(4005),
    [anon_sym_DOLLAR] = ACTIONS(4007),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4007),
    [sym_int] = ACTIONS(4007),
    [sym_xint] = ACTIONS(4005),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4005),
    [sym__newline] = ACTIONS(4005),
  },
  [3088] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8130),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3088),
    [sym_compiler_directive_decl] = STATE(3088),
    [sym_fsi_directive_decl] = STATE(3088),
    [sym_preproc_line] = STATE(3088),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym_repeat_pattern_repeat1] = STATE(5058),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_COLON] = ACTIONS(5363),
    [anon_sym_as] = ACTIONS(5653),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_COMMA] = ACTIONS(5655),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_COLON_COLON] = ACTIONS(5661),
    [anon_sym_PIPE] = ACTIONS(5663),
    [anon_sym_AMP] = ACTIONS(5665),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [anon_sym_DASH_GT] = ACTIONS(5365),
    [anon_sym_when] = ACTIONS(5363),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3089] = {
    [sym_block_comment] = STATE(3089),
    [sym_compiler_directive_decl] = STATE(3089),
    [sym_fsi_directive_decl] = STATE(3089),
    [sym_preproc_line] = STATE(3089),
    [sym_identifier] = ACTIONS(4193),
    [anon_sym_EQ] = ACTIONS(4191),
    [anon_sym_COLON] = ACTIONS(4193),
    [anon_sym_return] = ACTIONS(4193),
    [anon_sym_do] = ACTIONS(4193),
    [anon_sym_let] = ACTIONS(4193),
    [anon_sym_let_BANG] = ACTIONS(4191),
    [anon_sym_LPAREN] = ACTIONS(4193),
    [anon_sym_COMMA] = ACTIONS(4191),
    [anon_sym_null] = ACTIONS(4193),
    [anon_sym_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_COLON] = ACTIONS(4191),
    [anon_sym_AMP] = ACTIONS(4193),
    [anon_sym_LBRACK] = ACTIONS(4193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4191),
    [anon_sym_LBRACE] = ACTIONS(4193),
    [anon_sym_LT_AT] = ACTIONS(4193),
    [anon_sym_LT_AT_AT] = ACTIONS(4193),
    [anon_sym_DOT] = ACTIONS(4193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4191),
    [anon_sym_new] = ACTIONS(4193),
    [anon_sym_return_BANG] = ACTIONS(4191),
    [anon_sym_yield] = ACTIONS(4193),
    [anon_sym_yield_BANG] = ACTIONS(4191),
    [anon_sym_lazy] = ACTIONS(4193),
    [anon_sym_assert] = ACTIONS(4193),
    [anon_sym_upcast] = ACTIONS(4193),
    [anon_sym_downcast] = ACTIONS(4193),
    [anon_sym_COLON_GT] = ACTIONS(4191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4191),
    [anon_sym_for] = ACTIONS(4193),
    [anon_sym_while] = ACTIONS(4193),
    [anon_sym_if] = ACTIONS(4193),
    [anon_sym_fun] = ACTIONS(4193),
    [anon_sym_DASH_GT] = ACTIONS(4193),
    [anon_sym_try] = ACTIONS(4193),
    [anon_sym_match] = ACTIONS(4193),
    [anon_sym_match_BANG] = ACTIONS(4191),
    [anon_sym_function] = ACTIONS(4193),
    [anon_sym_LT_DASH] = ACTIONS(4193),
    [anon_sym_DOT_LBRACK] = ACTIONS(4191),
    [anon_sym_LT] = ACTIONS(4191),
    [anon_sym_use] = ACTIONS(4193),
    [anon_sym_use_BANG] = ACTIONS(4191),
    [anon_sym_do_BANG] = ACTIONS(4191),
    [anon_sym_DOT_DOT] = ACTIONS(4191),
    [anon_sym_begin] = ACTIONS(4193),
    [anon_sym_LPAREN2] = ACTIONS(4193),
    [anon_sym_or] = ACTIONS(4193),
    [aux_sym_char_token1] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4193),
    [anon_sym_DQUOTE] = ACTIONS(4193),
    [anon_sym_AT_DQUOTE] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [sym_bool] = ACTIONS(4193),
    [sym_unit] = ACTIONS(4191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4193),
    [sym_op_identifier] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4193),
    [anon_sym_DASH] = ACTIONS(4193),
    [anon_sym_PLUS_DOT] = ACTIONS(4193),
    [anon_sym_DASH_DOT] = ACTIONS(4193),
    [anon_sym_PERCENT] = ACTIONS(4193),
    [anon_sym_AMP_AMP] = ACTIONS(4193),
    [anon_sym_TILDE] = ACTIONS(4191),
    [aux_sym_prefix_op_token1] = ACTIONS(4193),
    [aux_sym_infix_op_token1] = ACTIONS(4191),
    [aux_sym_infix_op_token2] = ACTIONS(4193),
    [anon_sym_PIPE_PIPE] = ACTIONS(4193),
    [anon_sym_BANG_EQ] = ACTIONS(4193),
    [anon_sym_COLON_EQ] = ACTIONS(4191),
    [anon_sym_DOLLAR] = ACTIONS(4193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4193),
    [sym_int] = ACTIONS(4193),
    [sym_xint] = ACTIONS(4191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4191),
    [sym__newline] = ACTIONS(4191),
  },
  [3090] = {
    [sym_block_comment] = STATE(3090),
    [sym_compiler_directive_decl] = STATE(3090),
    [sym_fsi_directive_decl] = STATE(3090),
    [sym_preproc_line] = STATE(3090),
    [sym_identifier] = ACTIONS(4197),
    [anon_sym_EQ] = ACTIONS(4195),
    [anon_sym_COLON] = ACTIONS(4197),
    [anon_sym_return] = ACTIONS(4197),
    [anon_sym_do] = ACTIONS(4197),
    [anon_sym_let] = ACTIONS(4197),
    [anon_sym_let_BANG] = ACTIONS(4195),
    [anon_sym_LPAREN] = ACTIONS(4197),
    [anon_sym_COMMA] = ACTIONS(4195),
    [anon_sym_null] = ACTIONS(4197),
    [anon_sym_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_COLON] = ACTIONS(4195),
    [anon_sym_AMP] = ACTIONS(4197),
    [anon_sym_LBRACK] = ACTIONS(4197),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4195),
    [anon_sym_LBRACE] = ACTIONS(4197),
    [anon_sym_LT_AT] = ACTIONS(4197),
    [anon_sym_LT_AT_AT] = ACTIONS(4197),
    [anon_sym_DOT] = ACTIONS(4197),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4195),
    [anon_sym_new] = ACTIONS(4197),
    [anon_sym_return_BANG] = ACTIONS(4195),
    [anon_sym_yield] = ACTIONS(4197),
    [anon_sym_yield_BANG] = ACTIONS(4195),
    [anon_sym_lazy] = ACTIONS(4197),
    [anon_sym_assert] = ACTIONS(4197),
    [anon_sym_upcast] = ACTIONS(4197),
    [anon_sym_downcast] = ACTIONS(4197),
    [anon_sym_COLON_GT] = ACTIONS(4195),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4195),
    [anon_sym_for] = ACTIONS(4197),
    [anon_sym_while] = ACTIONS(4197),
    [anon_sym_if] = ACTIONS(4197),
    [anon_sym_fun] = ACTIONS(4197),
    [anon_sym_DASH_GT] = ACTIONS(4197),
    [anon_sym_try] = ACTIONS(4197),
    [anon_sym_match] = ACTIONS(4197),
    [anon_sym_match_BANG] = ACTIONS(4195),
    [anon_sym_function] = ACTIONS(4197),
    [anon_sym_LT_DASH] = ACTIONS(4197),
    [anon_sym_DOT_LBRACK] = ACTIONS(4195),
    [anon_sym_LT] = ACTIONS(4195),
    [anon_sym_use] = ACTIONS(4197),
    [anon_sym_use_BANG] = ACTIONS(4195),
    [anon_sym_do_BANG] = ACTIONS(4195),
    [anon_sym_DOT_DOT] = ACTIONS(4195),
    [anon_sym_begin] = ACTIONS(4197),
    [anon_sym_LPAREN2] = ACTIONS(4197),
    [anon_sym_or] = ACTIONS(4197),
    [aux_sym_char_token1] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4197),
    [anon_sym_DQUOTE] = ACTIONS(4197),
    [anon_sym_AT_DQUOTE] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [sym_bool] = ACTIONS(4197),
    [sym_unit] = ACTIONS(4195),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4197),
    [sym_op_identifier] = ACTIONS(4197),
    [anon_sym_PLUS] = ACTIONS(4197),
    [anon_sym_DASH] = ACTIONS(4197),
    [anon_sym_PLUS_DOT] = ACTIONS(4197),
    [anon_sym_DASH_DOT] = ACTIONS(4197),
    [anon_sym_PERCENT] = ACTIONS(4197),
    [anon_sym_AMP_AMP] = ACTIONS(4197),
    [anon_sym_TILDE] = ACTIONS(4195),
    [aux_sym_prefix_op_token1] = ACTIONS(4197),
    [aux_sym_infix_op_token1] = ACTIONS(4195),
    [aux_sym_infix_op_token2] = ACTIONS(4197),
    [anon_sym_PIPE_PIPE] = ACTIONS(4197),
    [anon_sym_BANG_EQ] = ACTIONS(4197),
    [anon_sym_COLON_EQ] = ACTIONS(4195),
    [anon_sym_DOLLAR] = ACTIONS(4197),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4197),
    [sym_int] = ACTIONS(4197),
    [sym_xint] = ACTIONS(4195),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4195),
    [sym__newline] = ACTIONS(4195),
  },
  [3091] = {
    [sym_block_comment] = STATE(3091),
    [sym_compiler_directive_decl] = STATE(3091),
    [sym_fsi_directive_decl] = STATE(3091),
    [sym_preproc_line] = STATE(3091),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_EQ] = ACTIONS(4199),
    [anon_sym_COLON] = ACTIONS(4201),
    [anon_sym_return] = ACTIONS(4201),
    [anon_sym_do] = ACTIONS(4201),
    [anon_sym_let] = ACTIONS(4201),
    [anon_sym_let_BANG] = ACTIONS(4199),
    [anon_sym_LPAREN] = ACTIONS(4201),
    [anon_sym_COMMA] = ACTIONS(4199),
    [anon_sym_null] = ACTIONS(4201),
    [anon_sym_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(4199),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_LBRACK] = ACTIONS(4201),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4199),
    [anon_sym_LBRACE] = ACTIONS(4201),
    [anon_sym_LT_AT] = ACTIONS(4201),
    [anon_sym_LT_AT_AT] = ACTIONS(4201),
    [anon_sym_DOT] = ACTIONS(4201),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4199),
    [anon_sym_new] = ACTIONS(4201),
    [anon_sym_return_BANG] = ACTIONS(4199),
    [anon_sym_yield] = ACTIONS(4201),
    [anon_sym_yield_BANG] = ACTIONS(4199),
    [anon_sym_lazy] = ACTIONS(4201),
    [anon_sym_assert] = ACTIONS(4201),
    [anon_sym_upcast] = ACTIONS(4201),
    [anon_sym_downcast] = ACTIONS(4201),
    [anon_sym_COLON_GT] = ACTIONS(4199),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4199),
    [anon_sym_for] = ACTIONS(4201),
    [anon_sym_while] = ACTIONS(4201),
    [anon_sym_if] = ACTIONS(4201),
    [anon_sym_fun] = ACTIONS(4201),
    [anon_sym_DASH_GT] = ACTIONS(4201),
    [anon_sym_try] = ACTIONS(4201),
    [anon_sym_match] = ACTIONS(4201),
    [anon_sym_match_BANG] = ACTIONS(4199),
    [anon_sym_function] = ACTIONS(4201),
    [anon_sym_LT_DASH] = ACTIONS(4201),
    [anon_sym_DOT_LBRACK] = ACTIONS(4199),
    [anon_sym_LT] = ACTIONS(4199),
    [anon_sym_use] = ACTIONS(4201),
    [anon_sym_use_BANG] = ACTIONS(4199),
    [anon_sym_do_BANG] = ACTIONS(4199),
    [anon_sym_DOT_DOT] = ACTIONS(4199),
    [anon_sym_begin] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(4201),
    [anon_sym_or] = ACTIONS(4201),
    [aux_sym_char_token1] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4201),
    [anon_sym_DQUOTE] = ACTIONS(4201),
    [anon_sym_AT_DQUOTE] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [sym_bool] = ACTIONS(4201),
    [sym_unit] = ACTIONS(4199),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4201),
    [sym_op_identifier] = ACTIONS(4201),
    [anon_sym_PLUS] = ACTIONS(4201),
    [anon_sym_DASH] = ACTIONS(4201),
    [anon_sym_PLUS_DOT] = ACTIONS(4201),
    [anon_sym_DASH_DOT] = ACTIONS(4201),
    [anon_sym_PERCENT] = ACTIONS(4201),
    [anon_sym_AMP_AMP] = ACTIONS(4201),
    [anon_sym_TILDE] = ACTIONS(4199),
    [aux_sym_prefix_op_token1] = ACTIONS(4201),
    [aux_sym_infix_op_token1] = ACTIONS(4199),
    [aux_sym_infix_op_token2] = ACTIONS(4201),
    [anon_sym_PIPE_PIPE] = ACTIONS(4201),
    [anon_sym_BANG_EQ] = ACTIONS(4201),
    [anon_sym_COLON_EQ] = ACTIONS(4199),
    [anon_sym_DOLLAR] = ACTIONS(4201),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4201),
    [sym_int] = ACTIONS(4201),
    [sym_xint] = ACTIONS(4199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4199),
    [sym__newline] = ACTIONS(4199),
  },
  [3092] = {
    [sym_block_comment] = STATE(3092),
    [sym_compiler_directive_decl] = STATE(3092),
    [sym_fsi_directive_decl] = STATE(3092),
    [sym_preproc_line] = STATE(3092),
    [sym_identifier] = ACTIONS(4216),
    [anon_sym_EQ] = ACTIONS(4214),
    [anon_sym_COLON] = ACTIONS(4216),
    [anon_sym_return] = ACTIONS(4216),
    [anon_sym_do] = ACTIONS(4216),
    [anon_sym_let] = ACTIONS(4216),
    [anon_sym_let_BANG] = ACTIONS(4214),
    [anon_sym_LPAREN] = ACTIONS(4216),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_null] = ACTIONS(4216),
    [anon_sym_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_COLON] = ACTIONS(4214),
    [anon_sym_AMP] = ACTIONS(4216),
    [anon_sym_LBRACK] = ACTIONS(4216),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4214),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_LT_AT] = ACTIONS(4216),
    [anon_sym_LT_AT_AT] = ACTIONS(4216),
    [anon_sym_DOT] = ACTIONS(4216),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4214),
    [anon_sym_new] = ACTIONS(4216),
    [anon_sym_return_BANG] = ACTIONS(4214),
    [anon_sym_yield] = ACTIONS(4216),
    [anon_sym_yield_BANG] = ACTIONS(4214),
    [anon_sym_lazy] = ACTIONS(4216),
    [anon_sym_assert] = ACTIONS(4216),
    [anon_sym_upcast] = ACTIONS(4216),
    [anon_sym_downcast] = ACTIONS(4216),
    [anon_sym_COLON_GT] = ACTIONS(4214),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4214),
    [anon_sym_for] = ACTIONS(4216),
    [anon_sym_while] = ACTIONS(4216),
    [anon_sym_if] = ACTIONS(4216),
    [anon_sym_fun] = ACTIONS(4216),
    [anon_sym_DASH_GT] = ACTIONS(4216),
    [anon_sym_try] = ACTIONS(4216),
    [anon_sym_match] = ACTIONS(4216),
    [anon_sym_match_BANG] = ACTIONS(4214),
    [anon_sym_function] = ACTIONS(4216),
    [anon_sym_LT_DASH] = ACTIONS(4216),
    [anon_sym_DOT_LBRACK] = ACTIONS(4214),
    [anon_sym_LT] = ACTIONS(4214),
    [anon_sym_use] = ACTIONS(4216),
    [anon_sym_use_BANG] = ACTIONS(4214),
    [anon_sym_do_BANG] = ACTIONS(4214),
    [anon_sym_DOT_DOT] = ACTIONS(4214),
    [anon_sym_begin] = ACTIONS(4216),
    [anon_sym_LPAREN2] = ACTIONS(4216),
    [anon_sym_or] = ACTIONS(4216),
    [aux_sym_char_token1] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4216),
    [anon_sym_DQUOTE] = ACTIONS(4216),
    [anon_sym_AT_DQUOTE] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [sym_bool] = ACTIONS(4216),
    [sym_unit] = ACTIONS(4214),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4216),
    [sym_op_identifier] = ACTIONS(4216),
    [anon_sym_PLUS] = ACTIONS(4216),
    [anon_sym_DASH] = ACTIONS(4216),
    [anon_sym_PLUS_DOT] = ACTIONS(4216),
    [anon_sym_DASH_DOT] = ACTIONS(4216),
    [anon_sym_PERCENT] = ACTIONS(4216),
    [anon_sym_AMP_AMP] = ACTIONS(4216),
    [anon_sym_TILDE] = ACTIONS(4214),
    [aux_sym_prefix_op_token1] = ACTIONS(4216),
    [aux_sym_infix_op_token1] = ACTIONS(4214),
    [aux_sym_infix_op_token2] = ACTIONS(4216),
    [anon_sym_PIPE_PIPE] = ACTIONS(4216),
    [anon_sym_BANG_EQ] = ACTIONS(4216),
    [anon_sym_COLON_EQ] = ACTIONS(4214),
    [anon_sym_DOLLAR] = ACTIONS(4216),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4216),
    [sym_int] = ACTIONS(4216),
    [sym_xint] = ACTIONS(4214),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4214),
    [sym__newline] = ACTIONS(4214),
  },
  [3093] = {
    [sym_block_comment] = STATE(3093),
    [sym_compiler_directive_decl] = STATE(3093),
    [sym_fsi_directive_decl] = STATE(3093),
    [sym_preproc_line] = STATE(3093),
    [sym_identifier] = ACTIONS(4220),
    [anon_sym_EQ] = ACTIONS(4218),
    [anon_sym_COLON] = ACTIONS(4220),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_do] = ACTIONS(4220),
    [anon_sym_let] = ACTIONS(4220),
    [anon_sym_let_BANG] = ACTIONS(4218),
    [anon_sym_LPAREN] = ACTIONS(4220),
    [anon_sym_COMMA] = ACTIONS(4218),
    [anon_sym_null] = ACTIONS(4220),
    [anon_sym_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_COLON] = ACTIONS(4218),
    [anon_sym_AMP] = ACTIONS(4220),
    [anon_sym_LBRACK] = ACTIONS(4220),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(4220),
    [anon_sym_LT_AT] = ACTIONS(4220),
    [anon_sym_LT_AT_AT] = ACTIONS(4220),
    [anon_sym_DOT] = ACTIONS(4220),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4218),
    [anon_sym_new] = ACTIONS(4220),
    [anon_sym_return_BANG] = ACTIONS(4218),
    [anon_sym_yield] = ACTIONS(4220),
    [anon_sym_yield_BANG] = ACTIONS(4218),
    [anon_sym_lazy] = ACTIONS(4220),
    [anon_sym_assert] = ACTIONS(4220),
    [anon_sym_upcast] = ACTIONS(4220),
    [anon_sym_downcast] = ACTIONS(4220),
    [anon_sym_COLON_GT] = ACTIONS(4218),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4218),
    [anon_sym_for] = ACTIONS(4220),
    [anon_sym_while] = ACTIONS(4220),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_fun] = ACTIONS(4220),
    [anon_sym_DASH_GT] = ACTIONS(4220),
    [anon_sym_try] = ACTIONS(4220),
    [anon_sym_match] = ACTIONS(4220),
    [anon_sym_match_BANG] = ACTIONS(4218),
    [anon_sym_function] = ACTIONS(4220),
    [anon_sym_LT_DASH] = ACTIONS(4220),
    [anon_sym_DOT_LBRACK] = ACTIONS(4218),
    [anon_sym_LT] = ACTIONS(4218),
    [anon_sym_use] = ACTIONS(4220),
    [anon_sym_use_BANG] = ACTIONS(4218),
    [anon_sym_do_BANG] = ACTIONS(4218),
    [anon_sym_DOT_DOT] = ACTIONS(4218),
    [anon_sym_begin] = ACTIONS(4220),
    [anon_sym_LPAREN2] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(4220),
    [aux_sym_char_token1] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4220),
    [anon_sym_DQUOTE] = ACTIONS(4220),
    [anon_sym_AT_DQUOTE] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [sym_bool] = ACTIONS(4220),
    [sym_unit] = ACTIONS(4218),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4220),
    [sym_op_identifier] = ACTIONS(4220),
    [anon_sym_PLUS] = ACTIONS(4220),
    [anon_sym_DASH] = ACTIONS(4220),
    [anon_sym_PLUS_DOT] = ACTIONS(4220),
    [anon_sym_DASH_DOT] = ACTIONS(4220),
    [anon_sym_PERCENT] = ACTIONS(4220),
    [anon_sym_AMP_AMP] = ACTIONS(4220),
    [anon_sym_TILDE] = ACTIONS(4218),
    [aux_sym_prefix_op_token1] = ACTIONS(4220),
    [aux_sym_infix_op_token1] = ACTIONS(4218),
    [aux_sym_infix_op_token2] = ACTIONS(4220),
    [anon_sym_PIPE_PIPE] = ACTIONS(4220),
    [anon_sym_BANG_EQ] = ACTIONS(4220),
    [anon_sym_COLON_EQ] = ACTIONS(4218),
    [anon_sym_DOLLAR] = ACTIONS(4220),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4220),
    [sym_int] = ACTIONS(4220),
    [sym_xint] = ACTIONS(4218),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4218),
    [sym__newline] = ACTIONS(4218),
  },
  [3094] = {
    [sym_attributes] = STATE(3976),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(8306),
    [sym__pattern] = STATE(8163),
    [sym_optional_pattern] = STATE(8306),
    [sym_type_check_pattern] = STATE(8306),
    [sym_attribute_pattern] = STATE(8306),
    [sym_paren_pattern] = STATE(8306),
    [sym_as_pattern] = STATE(8306),
    [sym_cons_pattern] = STATE(8306),
    [sym_disjunct_pattern] = STATE(8306),
    [sym_conjunct_pattern] = STATE(8306),
    [sym_typed_pattern] = STATE(8306),
    [sym_list_pattern] = STATE(8306),
    [sym_array_pattern] = STATE(8306),
    [sym_record_pattern] = STATE(8306),
    [sym_named_field_pattern] = STATE(8306),
    [sym_identifier_pattern] = STATE(8306),
    [sym_long_identifier_or_op] = STATE(3457),
    [sym_char] = STATE(8299),
    [sym_format_string] = STATE(8384),
    [sym__string_literal] = STATE(8384),
    [sym_string] = STATE(8299),
    [sym_verbatim_string] = STATE(8299),
    [sym_bytearray] = STATE(8299),
    [sym_verbatim_bytearray] = STATE(8299),
    [sym_format_triple_quoted_string] = STATE(8395),
    [sym_triple_quoted_string] = STATE(8299),
    [sym_const] = STATE(8306),
    [sym_long_identifier] = STATE(4953),
    [sym_active_pattern] = STATE(5117),
    [sym__identifier_or_op] = STATE(5167),
    [sym_sbyte] = STATE(8299),
    [sym_byte] = STATE(8299),
    [sym_int16] = STATE(8299),
    [sym_uint16] = STATE(8299),
    [sym_int32] = STATE(8299),
    [sym_uint32] = STATE(8299),
    [sym_nativeint] = STATE(8299),
    [sym_unativeint] = STATE(8299),
    [sym_int64] = STATE(8299),
    [sym_uint64] = STATE(8299),
    [sym_ieee32] = STATE(8299),
    [sym_ieee64] = STATE(8299),
    [sym_bignum] = STATE(8299),
    [sym_decimal] = STATE(8299),
    [sym_float] = STATE(7864),
    [sym_block_comment] = STATE(3094),
    [sym_compiler_directive_decl] = STATE(3094),
    [sym_fsi_directive_decl] = STATE(3094),
    [sym_preproc_line] = STATE(3094),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym_repeat_pattern_repeat1] = STATE(5000),
    [sym_identifier] = ACTIONS(5671),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_COLON] = ACTIONS(5363),
    [anon_sym_as] = ACTIONS(5611),
    [anon_sym_LPAREN] = ACTIONS(5673),
    [anon_sym_COMMA] = ACTIONS(5613),
    [anon_sym_null] = ACTIONS(5675),
    [anon_sym__] = ACTIONS(5677),
    [anon_sym_QMARK] = ACTIONS(5679),
    [anon_sym_COLON_QMARK] = ACTIONS(5681),
    [anon_sym_COLON_COLON] = ACTIONS(5615),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_AMP] = ACTIONS(5619),
    [anon_sym_LBRACK] = ACTIONS(5683),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5685),
    [anon_sym_LBRACE] = ACTIONS(5687),
    [aux_sym_char_token1] = ACTIONS(5689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5691),
    [anon_sym_DQUOTE] = ACTIONS(5693),
    [anon_sym_AT_DQUOTE] = ACTIONS(5695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5699),
    [sym_bool] = ACTIONS(5701),
    [sym_unit] = ACTIONS(5703),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5705),
    [sym_op_identifier] = ACTIONS(5707),
    [sym_int] = ACTIONS(5709),
    [sym_xint] = ACTIONS(5711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [sym__newline] = ACTIONS(5365),
    [sym__dedent] = ACTIONS(5365),
  },
  [3095] = {
    [sym_block_comment] = STATE(3095),
    [sym_compiler_directive_decl] = STATE(3095),
    [sym_fsi_directive_decl] = STATE(3095),
    [sym_preproc_line] = STATE(3095),
    [sym_identifier] = ACTIONS(4236),
    [anon_sym_EQ] = ACTIONS(4234),
    [anon_sym_COLON] = ACTIONS(4236),
    [anon_sym_return] = ACTIONS(4236),
    [anon_sym_do] = ACTIONS(4236),
    [anon_sym_let] = ACTIONS(4236),
    [anon_sym_let_BANG] = ACTIONS(4234),
    [anon_sym_LPAREN] = ACTIONS(4236),
    [anon_sym_COMMA] = ACTIONS(4234),
    [anon_sym_null] = ACTIONS(4236),
    [anon_sym_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_COLON] = ACTIONS(4234),
    [anon_sym_AMP] = ACTIONS(4236),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4234),
    [anon_sym_LBRACE] = ACTIONS(4236),
    [anon_sym_LT_AT] = ACTIONS(4236),
    [anon_sym_LT_AT_AT] = ACTIONS(4236),
    [anon_sym_DOT] = ACTIONS(4236),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4234),
    [anon_sym_new] = ACTIONS(4236),
    [anon_sym_return_BANG] = ACTIONS(4234),
    [anon_sym_yield] = ACTIONS(4236),
    [anon_sym_yield_BANG] = ACTIONS(4234),
    [anon_sym_lazy] = ACTIONS(4236),
    [anon_sym_assert] = ACTIONS(4236),
    [anon_sym_upcast] = ACTIONS(4236),
    [anon_sym_downcast] = ACTIONS(4236),
    [anon_sym_COLON_GT] = ACTIONS(4234),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4234),
    [anon_sym_for] = ACTIONS(4236),
    [anon_sym_while] = ACTIONS(4236),
    [anon_sym_if] = ACTIONS(4236),
    [anon_sym_fun] = ACTIONS(4236),
    [anon_sym_DASH_GT] = ACTIONS(4236),
    [anon_sym_try] = ACTIONS(4236),
    [anon_sym_match] = ACTIONS(4236),
    [anon_sym_match_BANG] = ACTIONS(4234),
    [anon_sym_function] = ACTIONS(4236),
    [anon_sym_LT_DASH] = ACTIONS(4236),
    [anon_sym_DOT_LBRACK] = ACTIONS(4234),
    [anon_sym_LT] = ACTIONS(4234),
    [anon_sym_use] = ACTIONS(4236),
    [anon_sym_use_BANG] = ACTIONS(4234),
    [anon_sym_do_BANG] = ACTIONS(4234),
    [anon_sym_DOT_DOT] = ACTIONS(4234),
    [anon_sym_begin] = ACTIONS(4236),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_or] = ACTIONS(4236),
    [aux_sym_char_token1] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4236),
    [anon_sym_DQUOTE] = ACTIONS(4236),
    [anon_sym_AT_DQUOTE] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [sym_bool] = ACTIONS(4236),
    [sym_unit] = ACTIONS(4234),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4236),
    [sym_op_identifier] = ACTIONS(4236),
    [anon_sym_PLUS] = ACTIONS(4236),
    [anon_sym_DASH] = ACTIONS(4236),
    [anon_sym_PLUS_DOT] = ACTIONS(4236),
    [anon_sym_DASH_DOT] = ACTIONS(4236),
    [anon_sym_PERCENT] = ACTIONS(4236),
    [anon_sym_AMP_AMP] = ACTIONS(4236),
    [anon_sym_TILDE] = ACTIONS(4234),
    [aux_sym_prefix_op_token1] = ACTIONS(4236),
    [aux_sym_infix_op_token1] = ACTIONS(4234),
    [aux_sym_infix_op_token2] = ACTIONS(4236),
    [anon_sym_PIPE_PIPE] = ACTIONS(4236),
    [anon_sym_BANG_EQ] = ACTIONS(4236),
    [anon_sym_COLON_EQ] = ACTIONS(4234),
    [anon_sym_DOLLAR] = ACTIONS(4236),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4236),
    [sym_int] = ACTIONS(4236),
    [sym_xint] = ACTIONS(4234),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4234),
    [sym__newline] = ACTIONS(4234),
  },
  [3096] = {
    [sym_block_comment] = STATE(3096),
    [sym_compiler_directive_decl] = STATE(3096),
    [sym_fsi_directive_decl] = STATE(3096),
    [sym_preproc_line] = STATE(3096),
    [sym_identifier] = ACTIONS(4240),
    [anon_sym_EQ] = ACTIONS(4238),
    [anon_sym_COLON] = ACTIONS(4240),
    [anon_sym_return] = ACTIONS(4240),
    [anon_sym_do] = ACTIONS(4240),
    [anon_sym_let] = ACTIONS(4240),
    [anon_sym_let_BANG] = ACTIONS(4238),
    [anon_sym_LPAREN] = ACTIONS(4240),
    [anon_sym_COMMA] = ACTIONS(4238),
    [anon_sym_null] = ACTIONS(4240),
    [anon_sym_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_COLON] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4240),
    [anon_sym_LBRACK] = ACTIONS(4240),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4238),
    [anon_sym_LBRACE] = ACTIONS(4240),
    [anon_sym_LT_AT] = ACTIONS(4240),
    [anon_sym_LT_AT_AT] = ACTIONS(4240),
    [anon_sym_DOT] = ACTIONS(4240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4238),
    [anon_sym_new] = ACTIONS(4240),
    [anon_sym_return_BANG] = ACTIONS(4238),
    [anon_sym_yield] = ACTIONS(4240),
    [anon_sym_yield_BANG] = ACTIONS(4238),
    [anon_sym_lazy] = ACTIONS(4240),
    [anon_sym_assert] = ACTIONS(4240),
    [anon_sym_upcast] = ACTIONS(4240),
    [anon_sym_downcast] = ACTIONS(4240),
    [anon_sym_COLON_GT] = ACTIONS(4238),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4238),
    [anon_sym_for] = ACTIONS(4240),
    [anon_sym_while] = ACTIONS(4240),
    [anon_sym_if] = ACTIONS(4240),
    [anon_sym_fun] = ACTIONS(4240),
    [anon_sym_DASH_GT] = ACTIONS(4240),
    [anon_sym_try] = ACTIONS(4240),
    [anon_sym_match] = ACTIONS(4240),
    [anon_sym_match_BANG] = ACTIONS(4238),
    [anon_sym_function] = ACTIONS(4240),
    [anon_sym_LT_DASH] = ACTIONS(4240),
    [anon_sym_DOT_LBRACK] = ACTIONS(4238),
    [anon_sym_LT] = ACTIONS(4238),
    [anon_sym_use] = ACTIONS(4240),
    [anon_sym_use_BANG] = ACTIONS(4238),
    [anon_sym_do_BANG] = ACTIONS(4238),
    [anon_sym_DOT_DOT] = ACTIONS(4238),
    [anon_sym_begin] = ACTIONS(4240),
    [anon_sym_LPAREN2] = ACTIONS(4240),
    [anon_sym_or] = ACTIONS(4240),
    [aux_sym_char_token1] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4240),
    [anon_sym_DQUOTE] = ACTIONS(4240),
    [anon_sym_AT_DQUOTE] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [sym_bool] = ACTIONS(4240),
    [sym_unit] = ACTIONS(4238),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4240),
    [sym_op_identifier] = ACTIONS(4240),
    [anon_sym_PLUS] = ACTIONS(4240),
    [anon_sym_DASH] = ACTIONS(4240),
    [anon_sym_PLUS_DOT] = ACTIONS(4240),
    [anon_sym_DASH_DOT] = ACTIONS(4240),
    [anon_sym_PERCENT] = ACTIONS(4240),
    [anon_sym_AMP_AMP] = ACTIONS(4240),
    [anon_sym_TILDE] = ACTIONS(4238),
    [aux_sym_prefix_op_token1] = ACTIONS(4240),
    [aux_sym_infix_op_token1] = ACTIONS(4238),
    [aux_sym_infix_op_token2] = ACTIONS(4240),
    [anon_sym_PIPE_PIPE] = ACTIONS(4240),
    [anon_sym_BANG_EQ] = ACTIONS(4240),
    [anon_sym_COLON_EQ] = ACTIONS(4238),
    [anon_sym_DOLLAR] = ACTIONS(4240),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4240),
    [sym_int] = ACTIONS(4240),
    [sym_xint] = ACTIONS(4238),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4238),
    [sym__newline] = ACTIONS(4238),
  },
  [3097] = {
    [sym_block_comment] = STATE(3097),
    [sym_compiler_directive_decl] = STATE(3097),
    [sym_fsi_directive_decl] = STATE(3097),
    [sym_preproc_line] = STATE(3097),
    [aux_sym_long_identifier_repeat1] = STATE(3195),
    [sym_identifier] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3778),
    [anon_sym_COLON] = ACTIONS(3781),
    [anon_sym_return] = ACTIONS(3781),
    [anon_sym_do] = ACTIONS(3781),
    [anon_sym_let] = ACTIONS(3781),
    [anon_sym_let_BANG] = ACTIONS(3778),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3778),
    [anon_sym_null] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_QMARK] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(3781),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3778),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_LT_AT] = ACTIONS(3781),
    [anon_sym_LT_AT_AT] = ACTIONS(3781),
    [anon_sym_AT_AT_GT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(5713),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3778),
    [anon_sym_new] = ACTIONS(3781),
    [anon_sym_return_BANG] = ACTIONS(3778),
    [anon_sym_yield] = ACTIONS(3781),
    [anon_sym_yield_BANG] = ACTIONS(3778),
    [anon_sym_lazy] = ACTIONS(3781),
    [anon_sym_assert] = ACTIONS(3781),
    [anon_sym_upcast] = ACTIONS(3781),
    [anon_sym_downcast] = ACTIONS(3781),
    [anon_sym_COLON_GT] = ACTIONS(3778),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3778),
    [anon_sym_for] = ACTIONS(3781),
    [anon_sym_while] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_fun] = ACTIONS(3781),
    [anon_sym_try] = ACTIONS(3781),
    [anon_sym_match] = ACTIONS(3781),
    [anon_sym_match_BANG] = ACTIONS(3778),
    [anon_sym_function] = ACTIONS(3781),
    [anon_sym_LT_DASH] = ACTIONS(3781),
    [anon_sym_DOT_LBRACK] = ACTIONS(3778),
    [anon_sym_LT] = ACTIONS(3778),
    [anon_sym_use] = ACTIONS(3781),
    [anon_sym_use_BANG] = ACTIONS(3778),
    [anon_sym_do_BANG] = ACTIONS(3778),
    [anon_sym_begin] = ACTIONS(3781),
    [anon_sym_LPAREN2] = ACTIONS(3781),
    [anon_sym_or] = ACTIONS(3781),
    [aux_sym_char_token1] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3781),
    [anon_sym_DQUOTE] = ACTIONS(3781),
    [anon_sym_AT_DQUOTE] = ACTIONS(3778),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3778),
    [sym_bool] = ACTIONS(3781),
    [sym_unit] = ACTIONS(3778),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3781),
    [sym_op_identifier] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3781),
    [anon_sym_DASH] = ACTIONS(3781),
    [anon_sym_PLUS_DOT] = ACTIONS(3781),
    [anon_sym_DASH_DOT] = ACTIONS(3781),
    [anon_sym_PERCENT] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3781),
    [anon_sym_TILDE] = ACTIONS(3778),
    [aux_sym_prefix_op_token1] = ACTIONS(3781),
    [aux_sym_infix_op_token1] = ACTIONS(3778),
    [aux_sym_infix_op_token2] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_COLON_EQ] = ACTIONS(3778),
    [anon_sym_DOLLAR] = ACTIONS(3781),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3781),
    [sym_int] = ACTIONS(3781),
    [sym_xint] = ACTIONS(3778),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3778),
    [sym__newline] = ACTIONS(3778),
  },
  [3098] = {
    [sym_block_comment] = STATE(3098),
    [sym_compiler_directive_decl] = STATE(3098),
    [sym_fsi_directive_decl] = STATE(3098),
    [sym_preproc_line] = STATE(3098),
    [sym_identifier] = ACTIONS(4137),
    [anon_sym_EQ] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4137),
    [anon_sym_return] = ACTIONS(4137),
    [anon_sym_do] = ACTIONS(4137),
    [anon_sym_let] = ACTIONS(4137),
    [anon_sym_let_BANG] = ACTIONS(4135),
    [anon_sym_as] = ACTIONS(4137),
    [anon_sym_LPAREN] = ACTIONS(4137),
    [anon_sym_COMMA] = ACTIONS(4135),
    [anon_sym_null] = ACTIONS(4137),
    [anon_sym_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_COLON] = ACTIONS(4135),
    [anon_sym_AMP] = ACTIONS(4137),
    [anon_sym_LBRACK] = ACTIONS(4137),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4135),
    [anon_sym_LBRACE] = ACTIONS(4137),
    [anon_sym_LT_AT] = ACTIONS(4137),
    [anon_sym_LT_AT_AT] = ACTIONS(4137),
    [anon_sym_DOT] = ACTIONS(4137),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4135),
    [anon_sym_new] = ACTIONS(4137),
    [anon_sym_with] = ACTIONS(4137),
    [anon_sym_return_BANG] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_yield_BANG] = ACTIONS(4135),
    [anon_sym_lazy] = ACTIONS(4137),
    [anon_sym_assert] = ACTIONS(4137),
    [anon_sym_upcast] = ACTIONS(4137),
    [anon_sym_downcast] = ACTIONS(4137),
    [anon_sym_COLON_GT] = ACTIONS(4135),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4135),
    [anon_sym_for] = ACTIONS(4137),
    [anon_sym_while] = ACTIONS(4137),
    [anon_sym_if] = ACTIONS(4137),
    [anon_sym_fun] = ACTIONS(4137),
    [anon_sym_try] = ACTIONS(4137),
    [anon_sym_match] = ACTIONS(4137),
    [anon_sym_match_BANG] = ACTIONS(4135),
    [anon_sym_function] = ACTIONS(4137),
    [anon_sym_LT_DASH] = ACTIONS(4137),
    [anon_sym_DOT_LBRACK] = ACTIONS(4135),
    [anon_sym_LT] = ACTIONS(4135),
    [anon_sym_use] = ACTIONS(4137),
    [anon_sym_use_BANG] = ACTIONS(4135),
    [anon_sym_do_BANG] = ACTIONS(4135),
    [anon_sym_begin] = ACTIONS(4137),
    [anon_sym_LPAREN2] = ACTIONS(4137),
    [anon_sym_or] = ACTIONS(4137),
    [aux_sym_char_token1] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4137),
    [anon_sym_DQUOTE] = ACTIONS(4137),
    [anon_sym_AT_DQUOTE] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [sym_bool] = ACTIONS(4137),
    [sym_unit] = ACTIONS(4135),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4137),
    [sym_op_identifier] = ACTIONS(4137),
    [anon_sym_PLUS] = ACTIONS(4137),
    [anon_sym_DASH] = ACTIONS(4137),
    [anon_sym_PLUS_DOT] = ACTIONS(4137),
    [anon_sym_DASH_DOT] = ACTIONS(4137),
    [anon_sym_PERCENT] = ACTIONS(4137),
    [anon_sym_AMP_AMP] = ACTIONS(4137),
    [anon_sym_TILDE] = ACTIONS(4135),
    [aux_sym_prefix_op_token1] = ACTIONS(4137),
    [aux_sym_infix_op_token1] = ACTIONS(4135),
    [aux_sym_infix_op_token2] = ACTIONS(4137),
    [anon_sym_PIPE_PIPE] = ACTIONS(4137),
    [anon_sym_BANG_EQ] = ACTIONS(4137),
    [anon_sym_COLON_EQ] = ACTIONS(4135),
    [anon_sym_DOLLAR] = ACTIONS(4137),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4137),
    [sym_int] = ACTIONS(4137),
    [sym_xint] = ACTIONS(4135),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4135),
    [sym__newline] = ACTIONS(4135),
  },
  [3099] = {
    [sym_block_comment] = STATE(3099),
    [sym_compiler_directive_decl] = STATE(3099),
    [sym_fsi_directive_decl] = STATE(3099),
    [sym_preproc_line] = STATE(3099),
    [sym_identifier] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4242),
    [anon_sym_COLON] = ACTIONS(4244),
    [anon_sym_return] = ACTIONS(4244),
    [anon_sym_do] = ACTIONS(4244),
    [anon_sym_let] = ACTIONS(4244),
    [anon_sym_let_BANG] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_null] = ACTIONS(4244),
    [anon_sym_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_COLON] = ACTIONS(4242),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4244),
    [anon_sym_LT_AT] = ACTIONS(4244),
    [anon_sym_LT_AT_AT] = ACTIONS(4244),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4242),
    [anon_sym_new] = ACTIONS(4244),
    [anon_sym_return_BANG] = ACTIONS(4242),
    [anon_sym_yield] = ACTIONS(4244),
    [anon_sym_yield_BANG] = ACTIONS(4242),
    [anon_sym_lazy] = ACTIONS(4244),
    [anon_sym_assert] = ACTIONS(4244),
    [anon_sym_upcast] = ACTIONS(4244),
    [anon_sym_downcast] = ACTIONS(4244),
    [anon_sym_COLON_GT] = ACTIONS(4242),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4242),
    [anon_sym_for] = ACTIONS(4244),
    [anon_sym_while] = ACTIONS(4244),
    [anon_sym_if] = ACTIONS(4244),
    [anon_sym_fun] = ACTIONS(4244),
    [anon_sym_DASH_GT] = ACTIONS(4244),
    [anon_sym_try] = ACTIONS(4244),
    [anon_sym_match] = ACTIONS(4244),
    [anon_sym_match_BANG] = ACTIONS(4242),
    [anon_sym_function] = ACTIONS(4244),
    [anon_sym_LT_DASH] = ACTIONS(4244),
    [anon_sym_DOT_LBRACK] = ACTIONS(4242),
    [anon_sym_LT] = ACTIONS(4242),
    [anon_sym_use] = ACTIONS(4244),
    [anon_sym_use_BANG] = ACTIONS(4242),
    [anon_sym_do_BANG] = ACTIONS(4242),
    [anon_sym_DOT_DOT] = ACTIONS(4242),
    [anon_sym_begin] = ACTIONS(4244),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_or] = ACTIONS(4244),
    [aux_sym_char_token1] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4244),
    [anon_sym_DQUOTE] = ACTIONS(4244),
    [anon_sym_AT_DQUOTE] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [sym_bool] = ACTIONS(4244),
    [sym_unit] = ACTIONS(4242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4244),
    [sym_op_identifier] = ACTIONS(4244),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_DASH] = ACTIONS(4244),
    [anon_sym_PLUS_DOT] = ACTIONS(4244),
    [anon_sym_DASH_DOT] = ACTIONS(4244),
    [anon_sym_PERCENT] = ACTIONS(4244),
    [anon_sym_AMP_AMP] = ACTIONS(4244),
    [anon_sym_TILDE] = ACTIONS(4242),
    [aux_sym_prefix_op_token1] = ACTIONS(4244),
    [aux_sym_infix_op_token1] = ACTIONS(4242),
    [aux_sym_infix_op_token2] = ACTIONS(4244),
    [anon_sym_PIPE_PIPE] = ACTIONS(4244),
    [anon_sym_BANG_EQ] = ACTIONS(4244),
    [anon_sym_COLON_EQ] = ACTIONS(4242),
    [anon_sym_DOLLAR] = ACTIONS(4244),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4244),
    [sym_int] = ACTIONS(4244),
    [sym_xint] = ACTIONS(4242),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4242),
    [sym__newline] = ACTIONS(4242),
  },
  [3100] = {
    [sym_block_comment] = STATE(3100),
    [sym_compiler_directive_decl] = STATE(3100),
    [sym_fsi_directive_decl] = STATE(3100),
    [sym_preproc_line] = STATE(3100),
    [sym_identifier] = ACTIONS(3946),
    [anon_sym_EQ] = ACTIONS(3944),
    [anon_sym_COLON] = ACTIONS(3946),
    [anon_sym_return] = ACTIONS(3946),
    [anon_sym_do] = ACTIONS(3946),
    [anon_sym_let] = ACTIONS(3946),
    [anon_sym_let_BANG] = ACTIONS(3944),
    [anon_sym_LPAREN] = ACTIONS(3946),
    [anon_sym_COMMA] = ACTIONS(3944),
    [anon_sym_null] = ACTIONS(3946),
    [anon_sym_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LBRACK] = ACTIONS(3946),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3944),
    [anon_sym_LBRACE] = ACTIONS(3946),
    [anon_sym_LT_AT] = ACTIONS(3946),
    [anon_sym_LT_AT_AT] = ACTIONS(3946),
    [anon_sym_DOT] = ACTIONS(3946),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3944),
    [anon_sym_new] = ACTIONS(3946),
    [anon_sym_return_BANG] = ACTIONS(3944),
    [anon_sym_yield] = ACTIONS(3946),
    [anon_sym_yield_BANG] = ACTIONS(3944),
    [anon_sym_lazy] = ACTIONS(3946),
    [anon_sym_assert] = ACTIONS(3946),
    [anon_sym_upcast] = ACTIONS(3946),
    [anon_sym_downcast] = ACTIONS(3946),
    [anon_sym_COLON_GT] = ACTIONS(3944),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3944),
    [anon_sym_for] = ACTIONS(3946),
    [anon_sym_while] = ACTIONS(3946),
    [anon_sym_if] = ACTIONS(3946),
    [anon_sym_fun] = ACTIONS(3946),
    [anon_sym_DASH_GT] = ACTIONS(3946),
    [anon_sym_try] = ACTIONS(3946),
    [anon_sym_match] = ACTIONS(3946),
    [anon_sym_match_BANG] = ACTIONS(3944),
    [anon_sym_function] = ACTIONS(3946),
    [anon_sym_LT_DASH] = ACTIONS(3946),
    [anon_sym_DOT_LBRACK] = ACTIONS(3944),
    [anon_sym_LT] = ACTIONS(3944),
    [anon_sym_use] = ACTIONS(3946),
    [anon_sym_use_BANG] = ACTIONS(3944),
    [anon_sym_do_BANG] = ACTIONS(3944),
    [anon_sym_DOT_DOT] = ACTIONS(3944),
    [anon_sym_begin] = ACTIONS(3946),
    [anon_sym_LPAREN2] = ACTIONS(3946),
    [anon_sym_or] = ACTIONS(3946),
    [aux_sym_char_token1] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_AT_DQUOTE] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [sym_bool] = ACTIONS(3946),
    [sym_unit] = ACTIONS(3944),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3946),
    [sym_op_identifier] = ACTIONS(3946),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PLUS_DOT] = ACTIONS(3946),
    [anon_sym_DASH_DOT] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3946),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_TILDE] = ACTIONS(3944),
    [aux_sym_prefix_op_token1] = ACTIONS(3946),
    [aux_sym_infix_op_token1] = ACTIONS(3944),
    [aux_sym_infix_op_token2] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [anon_sym_BANG_EQ] = ACTIONS(3946),
    [anon_sym_COLON_EQ] = ACTIONS(3944),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3946),
    [sym_int] = ACTIONS(3946),
    [sym_xint] = ACTIONS(3944),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3944),
    [sym__newline] = ACTIONS(3944),
  },
  [3101] = {
    [sym_block_comment] = STATE(3101),
    [sym_compiler_directive_decl] = STATE(3101),
    [sym_fsi_directive_decl] = STATE(3101),
    [sym_preproc_line] = STATE(3101),
    [sym_identifier] = ACTIONS(3927),
    [anon_sym_EQ] = ACTIONS(3925),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_return] = ACTIONS(3927),
    [anon_sym_do] = ACTIONS(3927),
    [anon_sym_let] = ACTIONS(3927),
    [anon_sym_let_BANG] = ACTIONS(3925),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_COMMA] = ACTIONS(3925),
    [anon_sym_null] = ACTIONS(3927),
    [anon_sym_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_COLON] = ACTIONS(3925),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3925),
    [anon_sym_LBRACE] = ACTIONS(3927),
    [anon_sym_LT_AT] = ACTIONS(3927),
    [anon_sym_LT_AT_AT] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3925),
    [anon_sym_new] = ACTIONS(3927),
    [anon_sym_return_BANG] = ACTIONS(3925),
    [anon_sym_yield] = ACTIONS(3927),
    [anon_sym_yield_BANG] = ACTIONS(3925),
    [anon_sym_lazy] = ACTIONS(3927),
    [anon_sym_assert] = ACTIONS(3927),
    [anon_sym_upcast] = ACTIONS(3927),
    [anon_sym_downcast] = ACTIONS(3927),
    [anon_sym_COLON_GT] = ACTIONS(3925),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3925),
    [anon_sym_for] = ACTIONS(3927),
    [anon_sym_while] = ACTIONS(3927),
    [anon_sym_if] = ACTIONS(3927),
    [anon_sym_fun] = ACTIONS(3927),
    [anon_sym_DASH_GT] = ACTIONS(3927),
    [anon_sym_try] = ACTIONS(3927),
    [anon_sym_match] = ACTIONS(3927),
    [anon_sym_match_BANG] = ACTIONS(3925),
    [anon_sym_function] = ACTIONS(3927),
    [anon_sym_LT_DASH] = ACTIONS(3927),
    [anon_sym_DOT_LBRACK] = ACTIONS(3925),
    [anon_sym_LT] = ACTIONS(3925),
    [anon_sym_use] = ACTIONS(3927),
    [anon_sym_use_BANG] = ACTIONS(3925),
    [anon_sym_do_BANG] = ACTIONS(3925),
    [anon_sym_DOT_DOT] = ACTIONS(3925),
    [anon_sym_begin] = ACTIONS(3927),
    [anon_sym_LPAREN2] = ACTIONS(3927),
    [anon_sym_or] = ACTIONS(3927),
    [aux_sym_char_token1] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_AT_DQUOTE] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [sym_bool] = ACTIONS(3927),
    [sym_unit] = ACTIONS(3925),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3927),
    [sym_op_identifier] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3927),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_PLUS_DOT] = ACTIONS(3927),
    [anon_sym_DASH_DOT] = ACTIONS(3927),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_TILDE] = ACTIONS(3925),
    [aux_sym_prefix_op_token1] = ACTIONS(3927),
    [aux_sym_infix_op_token1] = ACTIONS(3925),
    [aux_sym_infix_op_token2] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_COLON_EQ] = ACTIONS(3925),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3927),
    [sym_int] = ACTIONS(3927),
    [sym_xint] = ACTIONS(3925),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3925),
    [sym__newline] = ACTIONS(3925),
  },
  [3102] = {
    [sym_block_comment] = STATE(3102),
    [sym_compiler_directive_decl] = STATE(3102),
    [sym_fsi_directive_decl] = STATE(3102),
    [sym_preproc_line] = STATE(3102),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [anon_sym_as] = ACTIONS(4228),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(5717),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_with] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
  },
  [3103] = {
    [sym_block_comment] = STATE(3103),
    [sym_compiler_directive_decl] = STATE(3103),
    [sym_fsi_directive_decl] = STATE(3103),
    [sym_preproc_line] = STATE(3103),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [anon_sym_as] = ACTIONS(4228),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_with] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
  },
  [3104] = {
    [sym_block_comment] = STATE(3104),
    [sym_compiler_directive_decl] = STATE(3104),
    [sym_fsi_directive_decl] = STATE(3104),
    [sym_preproc_line] = STATE(3104),
    [sym_identifier] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4246),
    [anon_sym_COLON] = ACTIONS(4248),
    [anon_sym_return] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4248),
    [anon_sym_let] = ACTIONS(4248),
    [anon_sym_let_BANG] = ACTIONS(4246),
    [anon_sym_LPAREN] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_null] = ACTIONS(4248),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4248),
    [anon_sym_LT_AT] = ACTIONS(4248),
    [anon_sym_LT_AT_AT] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4246),
    [anon_sym_new] = ACTIONS(4248),
    [anon_sym_return_BANG] = ACTIONS(4246),
    [anon_sym_yield] = ACTIONS(4248),
    [anon_sym_yield_BANG] = ACTIONS(4246),
    [anon_sym_lazy] = ACTIONS(4248),
    [anon_sym_assert] = ACTIONS(4248),
    [anon_sym_upcast] = ACTIONS(4248),
    [anon_sym_downcast] = ACTIONS(4248),
    [anon_sym_COLON_GT] = ACTIONS(4246),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4246),
    [anon_sym_for] = ACTIONS(4248),
    [anon_sym_while] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4248),
    [anon_sym_fun] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4248),
    [anon_sym_try] = ACTIONS(4248),
    [anon_sym_match] = ACTIONS(4248),
    [anon_sym_match_BANG] = ACTIONS(4246),
    [anon_sym_function] = ACTIONS(4248),
    [anon_sym_LT_DASH] = ACTIONS(4248),
    [anon_sym_DOT_LBRACK] = ACTIONS(4246),
    [anon_sym_LT] = ACTIONS(4246),
    [anon_sym_use] = ACTIONS(4248),
    [anon_sym_use_BANG] = ACTIONS(4246),
    [anon_sym_do_BANG] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4246),
    [anon_sym_begin] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4248),
    [aux_sym_char_token1] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4248),
    [anon_sym_DQUOTE] = ACTIONS(4248),
    [anon_sym_AT_DQUOTE] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [sym_bool] = ACTIONS(4248),
    [sym_unit] = ACTIONS(4246),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4248),
    [sym_op_identifier] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_DOT] = ACTIONS(4248),
    [anon_sym_DASH_DOT] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_TILDE] = ACTIONS(4246),
    [aux_sym_prefix_op_token1] = ACTIONS(4248),
    [aux_sym_infix_op_token1] = ACTIONS(4246),
    [aux_sym_infix_op_token2] = ACTIONS(4248),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_COLON_EQ] = ACTIONS(4246),
    [anon_sym_DOLLAR] = ACTIONS(4248),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4248),
    [sym_int] = ACTIONS(4248),
    [sym_xint] = ACTIONS(4246),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4246),
    [sym__newline] = ACTIONS(4246),
  },
  [3105] = {
    [sym_block_comment] = STATE(3105),
    [sym_compiler_directive_decl] = STATE(3105),
    [sym_fsi_directive_decl] = STATE(3105),
    [sym_preproc_line] = STATE(3105),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_DASH_GT] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_DOT_DOT] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [3106] = {
    [sym_block_comment] = STATE(3106),
    [sym_compiler_directive_decl] = STATE(3106),
    [sym_fsi_directive_decl] = STATE(3106),
    [sym_preproc_line] = STATE(3106),
    [sym_identifier] = ACTIONS(4104),
    [anon_sym_EQ] = ACTIONS(4102),
    [anon_sym_COLON] = ACTIONS(4104),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_do] = ACTIONS(4104),
    [anon_sym_let] = ACTIONS(4104),
    [anon_sym_let_BANG] = ACTIONS(4102),
    [anon_sym_LPAREN] = ACTIONS(4104),
    [anon_sym_COMMA] = ACTIONS(4102),
    [anon_sym_null] = ACTIONS(4104),
    [anon_sym_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_COLON] = ACTIONS(4102),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4104),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4102),
    [anon_sym_LBRACE] = ACTIONS(4104),
    [anon_sym_LT_AT] = ACTIONS(4104),
    [anon_sym_LT_AT_AT] = ACTIONS(4104),
    [anon_sym_DOT] = ACTIONS(4104),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4102),
    [anon_sym_new] = ACTIONS(4104),
    [anon_sym_return_BANG] = ACTIONS(4102),
    [anon_sym_yield] = ACTIONS(4104),
    [anon_sym_yield_BANG] = ACTIONS(4102),
    [anon_sym_lazy] = ACTIONS(4104),
    [anon_sym_assert] = ACTIONS(4104),
    [anon_sym_upcast] = ACTIONS(4104),
    [anon_sym_downcast] = ACTIONS(4104),
    [anon_sym_COLON_GT] = ACTIONS(4102),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4102),
    [anon_sym_for] = ACTIONS(4104),
    [anon_sym_while] = ACTIONS(4104),
    [anon_sym_if] = ACTIONS(4104),
    [anon_sym_fun] = ACTIONS(4104),
    [anon_sym_DASH_GT] = ACTIONS(4104),
    [anon_sym_try] = ACTIONS(4104),
    [anon_sym_match] = ACTIONS(4104),
    [anon_sym_match_BANG] = ACTIONS(4102),
    [anon_sym_function] = ACTIONS(4104),
    [anon_sym_LT_DASH] = ACTIONS(4104),
    [anon_sym_DOT_LBRACK] = ACTIONS(4102),
    [anon_sym_LT] = ACTIONS(4102),
    [anon_sym_use] = ACTIONS(4104),
    [anon_sym_use_BANG] = ACTIONS(4102),
    [anon_sym_do_BANG] = ACTIONS(4102),
    [anon_sym_DOT_DOT] = ACTIONS(4102),
    [anon_sym_begin] = ACTIONS(4104),
    [anon_sym_LPAREN2] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [aux_sym_char_token1] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4104),
    [anon_sym_DQUOTE] = ACTIONS(4104),
    [anon_sym_AT_DQUOTE] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [sym_bool] = ACTIONS(4104),
    [sym_unit] = ACTIONS(4102),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4104),
    [sym_op_identifier] = ACTIONS(4104),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_PLUS_DOT] = ACTIONS(4104),
    [anon_sym_DASH_DOT] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_AMP_AMP] = ACTIONS(4104),
    [anon_sym_TILDE] = ACTIONS(4102),
    [aux_sym_prefix_op_token1] = ACTIONS(4104),
    [aux_sym_infix_op_token1] = ACTIONS(4102),
    [aux_sym_infix_op_token2] = ACTIONS(4104),
    [anon_sym_PIPE_PIPE] = ACTIONS(4104),
    [anon_sym_BANG_EQ] = ACTIONS(4104),
    [anon_sym_COLON_EQ] = ACTIONS(4102),
    [anon_sym_DOLLAR] = ACTIONS(4104),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4104),
    [sym_int] = ACTIONS(4104),
    [sym_xint] = ACTIONS(4102),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4102),
    [sym__newline] = ACTIONS(4102),
  },
  [3107] = {
    [sym_block_comment] = STATE(3107),
    [sym_compiler_directive_decl] = STATE(3107),
    [sym_fsi_directive_decl] = STATE(3107),
    [sym_preproc_line] = STATE(3107),
    [sym_identifier] = ACTIONS(4104),
    [anon_sym_EQ] = ACTIONS(4102),
    [anon_sym_COLON] = ACTIONS(4104),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_do] = ACTIONS(4104),
    [anon_sym_let] = ACTIONS(4104),
    [anon_sym_let_BANG] = ACTIONS(4102),
    [anon_sym_as] = ACTIONS(4104),
    [anon_sym_LPAREN] = ACTIONS(4104),
    [anon_sym_COMMA] = ACTIONS(4102),
    [anon_sym_null] = ACTIONS(4104),
    [anon_sym_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_COLON] = ACTIONS(4102),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4104),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4102),
    [anon_sym_LBRACE] = ACTIONS(4104),
    [anon_sym_LT_AT] = ACTIONS(4104),
    [anon_sym_LT_AT_AT] = ACTIONS(4104),
    [anon_sym_DOT] = ACTIONS(4104),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4102),
    [anon_sym_new] = ACTIONS(4104),
    [anon_sym_with] = ACTIONS(4104),
    [anon_sym_return_BANG] = ACTIONS(4102),
    [anon_sym_yield] = ACTIONS(4104),
    [anon_sym_yield_BANG] = ACTIONS(4102),
    [anon_sym_lazy] = ACTIONS(4104),
    [anon_sym_assert] = ACTIONS(4104),
    [anon_sym_upcast] = ACTIONS(4104),
    [anon_sym_downcast] = ACTIONS(4104),
    [anon_sym_COLON_GT] = ACTIONS(4102),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4102),
    [anon_sym_for] = ACTIONS(4104),
    [anon_sym_while] = ACTIONS(4104),
    [anon_sym_if] = ACTIONS(4104),
    [anon_sym_fun] = ACTIONS(4104),
    [anon_sym_try] = ACTIONS(4104),
    [anon_sym_match] = ACTIONS(4104),
    [anon_sym_match_BANG] = ACTIONS(4102),
    [anon_sym_function] = ACTIONS(4104),
    [anon_sym_LT_DASH] = ACTIONS(4104),
    [anon_sym_DOT_LBRACK] = ACTIONS(4102),
    [anon_sym_LT] = ACTIONS(4102),
    [anon_sym_use] = ACTIONS(4104),
    [anon_sym_use_BANG] = ACTIONS(4102),
    [anon_sym_do_BANG] = ACTIONS(4102),
    [anon_sym_begin] = ACTIONS(4104),
    [anon_sym_LPAREN2] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [aux_sym_char_token1] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4104),
    [anon_sym_DQUOTE] = ACTIONS(4104),
    [anon_sym_AT_DQUOTE] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [sym_bool] = ACTIONS(4104),
    [sym_unit] = ACTIONS(4102),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4104),
    [sym_op_identifier] = ACTIONS(4104),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_PLUS_DOT] = ACTIONS(4104),
    [anon_sym_DASH_DOT] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_AMP_AMP] = ACTIONS(4104),
    [anon_sym_TILDE] = ACTIONS(4102),
    [aux_sym_prefix_op_token1] = ACTIONS(4104),
    [aux_sym_infix_op_token1] = ACTIONS(4102),
    [aux_sym_infix_op_token2] = ACTIONS(4104),
    [anon_sym_PIPE_PIPE] = ACTIONS(4104),
    [anon_sym_BANG_EQ] = ACTIONS(4104),
    [anon_sym_COLON_EQ] = ACTIONS(4102),
    [anon_sym_DOLLAR] = ACTIONS(4104),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4104),
    [sym_int] = ACTIONS(4104),
    [sym_xint] = ACTIONS(4102),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4102),
    [sym__newline] = ACTIONS(4102),
  },
  [3108] = {
    [sym_block_comment] = STATE(3108),
    [sym_compiler_directive_decl] = STATE(3108),
    [sym_fsi_directive_decl] = STATE(3108),
    [sym_preproc_line] = STATE(3108),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_as] = ACTIONS(3193),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [3109] = {
    [sym_block_comment] = STATE(3109),
    [sym_compiler_directive_decl] = STATE(3109),
    [sym_fsi_directive_decl] = STATE(3109),
    [sym_preproc_line] = STATE(3109),
    [sym_identifier] = ACTIONS(3958),
    [anon_sym_EQ] = ACTIONS(3956),
    [anon_sym_COLON] = ACTIONS(3958),
    [anon_sym_return] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(3958),
    [anon_sym_let] = ACTIONS(3958),
    [anon_sym_let_BANG] = ACTIONS(3956),
    [anon_sym_as] = ACTIONS(3958),
    [anon_sym_LPAREN] = ACTIONS(3958),
    [anon_sym_COMMA] = ACTIONS(3956),
    [anon_sym_null] = ACTIONS(3958),
    [anon_sym_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_COLON] = ACTIONS(3956),
    [anon_sym_AMP] = ACTIONS(3958),
    [anon_sym_LBRACK] = ACTIONS(3958),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3956),
    [anon_sym_LBRACE] = ACTIONS(3958),
    [anon_sym_LT_AT] = ACTIONS(3958),
    [anon_sym_LT_AT_AT] = ACTIONS(3958),
    [anon_sym_DOT] = ACTIONS(3958),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3956),
    [anon_sym_new] = ACTIONS(3958),
    [anon_sym_with] = ACTIONS(3958),
    [anon_sym_return_BANG] = ACTIONS(3956),
    [anon_sym_yield] = ACTIONS(3958),
    [anon_sym_yield_BANG] = ACTIONS(3956),
    [anon_sym_lazy] = ACTIONS(3958),
    [anon_sym_assert] = ACTIONS(3958),
    [anon_sym_upcast] = ACTIONS(3958),
    [anon_sym_downcast] = ACTIONS(3958),
    [anon_sym_COLON_GT] = ACTIONS(3956),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3956),
    [anon_sym_for] = ACTIONS(3958),
    [anon_sym_while] = ACTIONS(3958),
    [anon_sym_if] = ACTIONS(3958),
    [anon_sym_fun] = ACTIONS(3958),
    [anon_sym_try] = ACTIONS(3958),
    [anon_sym_match] = ACTIONS(3958),
    [anon_sym_match_BANG] = ACTIONS(3956),
    [anon_sym_function] = ACTIONS(3958),
    [anon_sym_LT_DASH] = ACTIONS(3958),
    [anon_sym_DOT_LBRACK] = ACTIONS(3956),
    [anon_sym_LT] = ACTIONS(3956),
    [anon_sym_use] = ACTIONS(3958),
    [anon_sym_use_BANG] = ACTIONS(3956),
    [anon_sym_do_BANG] = ACTIONS(3956),
    [anon_sym_begin] = ACTIONS(3958),
    [anon_sym_LPAREN2] = ACTIONS(3958),
    [anon_sym_or] = ACTIONS(3958),
    [aux_sym_char_token1] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [anon_sym_AT_DQUOTE] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [sym_bool] = ACTIONS(3958),
    [sym_unit] = ACTIONS(3956),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3958),
    [sym_op_identifier] = ACTIONS(3958),
    [anon_sym_PLUS] = ACTIONS(3958),
    [anon_sym_DASH] = ACTIONS(3958),
    [anon_sym_PLUS_DOT] = ACTIONS(3958),
    [anon_sym_DASH_DOT] = ACTIONS(3958),
    [anon_sym_PERCENT] = ACTIONS(3958),
    [anon_sym_AMP_AMP] = ACTIONS(3958),
    [anon_sym_TILDE] = ACTIONS(3956),
    [aux_sym_prefix_op_token1] = ACTIONS(3958),
    [aux_sym_infix_op_token1] = ACTIONS(3956),
    [aux_sym_infix_op_token2] = ACTIONS(3958),
    [anon_sym_PIPE_PIPE] = ACTIONS(3958),
    [anon_sym_BANG_EQ] = ACTIONS(3958),
    [anon_sym_COLON_EQ] = ACTIONS(3956),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3958),
    [sym_int] = ACTIONS(3958),
    [sym_xint] = ACTIONS(3956),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3956),
    [sym__newline] = ACTIONS(3956),
  },
  [3110] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(2911),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3110),
    [sym_compiler_directive_decl] = STATE(3110),
    [sym_fsi_directive_decl] = STATE(3110),
    [sym_preproc_line] = STATE(3110),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5558),
    [anon_sym_EQ] = ACTIONS(5562),
    [anon_sym_LBRACK_LT] = ACTIONS(5562),
    [anon_sym_COLON] = ACTIONS(5558),
    [anon_sym_as] = ACTIONS(5558),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_RPAREN] = ACTIONS(5562),
    [anon_sym_COMMA] = ACTIONS(5562),
    [anon_sym_null] = ACTIONS(5558),
    [anon_sym__] = ACTIONS(5558),
    [anon_sym_QMARK] = ACTIONS(5562),
    [anon_sym_COLON_QMARK] = ACTIONS(5562),
    [anon_sym_COLON_COLON] = ACTIONS(5562),
    [anon_sym_PIPE] = ACTIONS(5562),
    [anon_sym_AMP] = ACTIONS(5562),
    [anon_sym_LBRACK] = ACTIONS(5558),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5562),
    [anon_sym_LBRACE] = ACTIONS(5562),
    [anon_sym_LT2] = ACTIONS(5562),
    [aux_sym_char_token1] = ACTIONS(5562),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5558),
    [anon_sym_DQUOTE] = ACTIONS(5558),
    [anon_sym_AT_DQUOTE] = ACTIONS(5562),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5562),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5562),
    [sym_bool] = ACTIONS(5558),
    [sym_unit] = ACTIONS(5562),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5558),
    [sym_op_identifier] = ACTIONS(5562),
    [sym_int] = ACTIONS(5558),
    [sym_xint] = ACTIONS(5562),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3111] = {
    [sym_block_comment] = STATE(3111),
    [sym_compiler_directive_decl] = STATE(3111),
    [sym_fsi_directive_decl] = STATE(3111),
    [sym_preproc_line] = STATE(3111),
    [sym_identifier] = ACTIONS(4182),
    [anon_sym_EQ] = ACTIONS(3689),
    [anon_sym_COLON] = ACTIONS(4182),
    [anon_sym_return] = ACTIONS(4182),
    [anon_sym_do] = ACTIONS(4182),
    [anon_sym_let] = ACTIONS(4182),
    [anon_sym_let_BANG] = ACTIONS(3689),
    [anon_sym_LPAREN] = ACTIONS(4182),
    [anon_sym_COMMA] = ACTIONS(3689),
    [anon_sym_null] = ACTIONS(4182),
    [anon_sym_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3689),
    [anon_sym_LBRACE] = ACTIONS(4182),
    [anon_sym_LT_AT] = ACTIONS(4182),
    [anon_sym_LT_AT_AT] = ACTIONS(4182),
    [anon_sym_DOT] = ACTIONS(4182),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3689),
    [anon_sym_new] = ACTIONS(4182),
    [anon_sym_return_BANG] = ACTIONS(3689),
    [anon_sym_yield] = ACTIONS(4182),
    [anon_sym_yield_BANG] = ACTIONS(3689),
    [anon_sym_lazy] = ACTIONS(4182),
    [anon_sym_assert] = ACTIONS(4182),
    [anon_sym_upcast] = ACTIONS(4182),
    [anon_sym_downcast] = ACTIONS(4182),
    [anon_sym_COLON_GT] = ACTIONS(3689),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3689),
    [anon_sym_for] = ACTIONS(4182),
    [anon_sym_while] = ACTIONS(4182),
    [anon_sym_if] = ACTIONS(4182),
    [anon_sym_fun] = ACTIONS(4182),
    [anon_sym_try] = ACTIONS(4182),
    [anon_sym_match] = ACTIONS(4182),
    [anon_sym_match_BANG] = ACTIONS(3689),
    [anon_sym_function] = ACTIONS(4182),
    [anon_sym_LT_DASH] = ACTIONS(4182),
    [anon_sym_DOT_LBRACK] = ACTIONS(3689),
    [anon_sym_LT] = ACTIONS(3689),
    [anon_sym_use] = ACTIONS(4182),
    [anon_sym_use_BANG] = ACTIONS(3689),
    [anon_sym_do_BANG] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(4182),
    [anon_sym_LPAREN2] = ACTIONS(4182),
    [anon_sym_or] = ACTIONS(4182),
    [aux_sym_char_token1] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4182),
    [anon_sym_DQUOTE] = ACTIONS(4182),
    [anon_sym_AT_DQUOTE] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [sym_bool] = ACTIONS(4182),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4182),
    [sym_op_identifier] = ACTIONS(4182),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_PLUS_DOT] = ACTIONS(4182),
    [anon_sym_DASH_DOT] = ACTIONS(4182),
    [anon_sym_PERCENT] = ACTIONS(4182),
    [anon_sym_AMP_AMP] = ACTIONS(4182),
    [anon_sym_TILDE] = ACTIONS(3689),
    [aux_sym_prefix_op_token1] = ACTIONS(4182),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token2] = ACTIONS(4182),
    [anon_sym_PIPE_PIPE] = ACTIONS(4182),
    [anon_sym_BANG_EQ] = ACTIONS(4182),
    [anon_sym_COLON_EQ] = ACTIONS(3689),
    [anon_sym_DOLLAR] = ACTIONS(4182),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4182),
    [sym_int] = ACTIONS(4182),
    [sym_xint] = ACTIONS(3689),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3689),
    [anon_sym_POUNDendif] = ACTIONS(4973),
    [anon_sym_POUNDelse] = ACTIONS(4973),
    [sym__newline] = ACTIONS(3689),
  },
  [3112] = {
    [sym_block_comment] = STATE(3112),
    [sym_compiler_directive_decl] = STATE(3112),
    [sym_fsi_directive_decl] = STATE(3112),
    [sym_preproc_line] = STATE(3112),
    [sym_identifier] = ACTIONS(3962),
    [anon_sym_EQ] = ACTIONS(3960),
    [anon_sym_COLON] = ACTIONS(3962),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_do] = ACTIONS(3962),
    [anon_sym_let] = ACTIONS(3962),
    [anon_sym_let_BANG] = ACTIONS(3960),
    [anon_sym_as] = ACTIONS(3962),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_COMMA] = ACTIONS(3960),
    [anon_sym_null] = ACTIONS(3962),
    [anon_sym_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_COLON] = ACTIONS(3960),
    [anon_sym_AMP] = ACTIONS(3962),
    [anon_sym_LBRACK] = ACTIONS(3962),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_LT_AT] = ACTIONS(3962),
    [anon_sym_LT_AT_AT] = ACTIONS(3962),
    [anon_sym_DOT] = ACTIONS(3962),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3960),
    [anon_sym_new] = ACTIONS(3962),
    [anon_sym_with] = ACTIONS(3962),
    [anon_sym_return_BANG] = ACTIONS(3960),
    [anon_sym_yield] = ACTIONS(3962),
    [anon_sym_yield_BANG] = ACTIONS(3960),
    [anon_sym_lazy] = ACTIONS(3962),
    [anon_sym_assert] = ACTIONS(3962),
    [anon_sym_upcast] = ACTIONS(3962),
    [anon_sym_downcast] = ACTIONS(3962),
    [anon_sym_COLON_GT] = ACTIONS(3960),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3960),
    [anon_sym_for] = ACTIONS(3962),
    [anon_sym_while] = ACTIONS(3962),
    [anon_sym_if] = ACTIONS(3962),
    [anon_sym_fun] = ACTIONS(3962),
    [anon_sym_try] = ACTIONS(3962),
    [anon_sym_match] = ACTIONS(3962),
    [anon_sym_match_BANG] = ACTIONS(3960),
    [anon_sym_function] = ACTIONS(3962),
    [anon_sym_LT_DASH] = ACTIONS(3962),
    [anon_sym_DOT_LBRACK] = ACTIONS(3960),
    [anon_sym_LT] = ACTIONS(3960),
    [anon_sym_use] = ACTIONS(3962),
    [anon_sym_use_BANG] = ACTIONS(3960),
    [anon_sym_do_BANG] = ACTIONS(3960),
    [anon_sym_begin] = ACTIONS(3962),
    [anon_sym_LPAREN2] = ACTIONS(3962),
    [anon_sym_or] = ACTIONS(3962),
    [aux_sym_char_token1] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3962),
    [anon_sym_DQUOTE] = ACTIONS(3962),
    [anon_sym_AT_DQUOTE] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [sym_bool] = ACTIONS(3962),
    [sym_unit] = ACTIONS(3960),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3962),
    [sym_op_identifier] = ACTIONS(3962),
    [anon_sym_PLUS] = ACTIONS(3962),
    [anon_sym_DASH] = ACTIONS(3962),
    [anon_sym_PLUS_DOT] = ACTIONS(3962),
    [anon_sym_DASH_DOT] = ACTIONS(3962),
    [anon_sym_PERCENT] = ACTIONS(3962),
    [anon_sym_AMP_AMP] = ACTIONS(3962),
    [anon_sym_TILDE] = ACTIONS(3960),
    [aux_sym_prefix_op_token1] = ACTIONS(3962),
    [aux_sym_infix_op_token1] = ACTIONS(3960),
    [aux_sym_infix_op_token2] = ACTIONS(3962),
    [anon_sym_PIPE_PIPE] = ACTIONS(3962),
    [anon_sym_BANG_EQ] = ACTIONS(3962),
    [anon_sym_COLON_EQ] = ACTIONS(3960),
    [anon_sym_DOLLAR] = ACTIONS(3962),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3962),
    [sym_int] = ACTIONS(3962),
    [sym_xint] = ACTIONS(3960),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3960),
    [sym__newline] = ACTIONS(3960),
  },
  [3113] = {
    [sym_block_comment] = STATE(3113),
    [sym_compiler_directive_decl] = STATE(3113),
    [sym_fsi_directive_decl] = STATE(3113),
    [sym_preproc_line] = STATE(3113),
    [sym_identifier] = ACTIONS(4232),
    [anon_sym_EQ] = ACTIONS(4230),
    [anon_sym_COLON] = ACTIONS(4232),
    [anon_sym_return] = ACTIONS(4232),
    [anon_sym_do] = ACTIONS(4232),
    [anon_sym_let] = ACTIONS(4232),
    [anon_sym_let_BANG] = ACTIONS(4230),
    [anon_sym_as] = ACTIONS(4232),
    [anon_sym_LPAREN] = ACTIONS(4232),
    [anon_sym_COMMA] = ACTIONS(4230),
    [anon_sym_null] = ACTIONS(4232),
    [anon_sym_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_COLON] = ACTIONS(4230),
    [anon_sym_AMP] = ACTIONS(4232),
    [anon_sym_LBRACK] = ACTIONS(4232),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4230),
    [anon_sym_LBRACE] = ACTIONS(4232),
    [anon_sym_LT_AT] = ACTIONS(4232),
    [anon_sym_LT_AT_AT] = ACTIONS(4232),
    [anon_sym_DOT] = ACTIONS(4232),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4230),
    [anon_sym_new] = ACTIONS(4232),
    [anon_sym_with] = ACTIONS(4232),
    [anon_sym_return_BANG] = ACTIONS(4230),
    [anon_sym_yield] = ACTIONS(4232),
    [anon_sym_yield_BANG] = ACTIONS(4230),
    [anon_sym_lazy] = ACTIONS(4232),
    [anon_sym_assert] = ACTIONS(4232),
    [anon_sym_upcast] = ACTIONS(4232),
    [anon_sym_downcast] = ACTIONS(4232),
    [anon_sym_COLON_GT] = ACTIONS(4230),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4230),
    [anon_sym_for] = ACTIONS(4232),
    [anon_sym_while] = ACTIONS(4232),
    [anon_sym_if] = ACTIONS(4232),
    [anon_sym_fun] = ACTIONS(4232),
    [anon_sym_try] = ACTIONS(4232),
    [anon_sym_match] = ACTIONS(4232),
    [anon_sym_match_BANG] = ACTIONS(4230),
    [anon_sym_function] = ACTIONS(4232),
    [anon_sym_LT_DASH] = ACTIONS(4232),
    [anon_sym_DOT_LBRACK] = ACTIONS(4230),
    [anon_sym_LT] = ACTIONS(4230),
    [anon_sym_use] = ACTIONS(4232),
    [anon_sym_use_BANG] = ACTIONS(4230),
    [anon_sym_do_BANG] = ACTIONS(4230),
    [anon_sym_begin] = ACTIONS(4232),
    [anon_sym_LPAREN2] = ACTIONS(4232),
    [anon_sym_or] = ACTIONS(4232),
    [aux_sym_char_token1] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4232),
    [anon_sym_DQUOTE] = ACTIONS(4232),
    [anon_sym_AT_DQUOTE] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [sym_bool] = ACTIONS(4232),
    [sym_unit] = ACTIONS(4230),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4232),
    [sym_op_identifier] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4232),
    [anon_sym_DASH] = ACTIONS(4232),
    [anon_sym_PLUS_DOT] = ACTIONS(4232),
    [anon_sym_DASH_DOT] = ACTIONS(4232),
    [anon_sym_PERCENT] = ACTIONS(4232),
    [anon_sym_AMP_AMP] = ACTIONS(4232),
    [anon_sym_TILDE] = ACTIONS(4230),
    [aux_sym_prefix_op_token1] = ACTIONS(4232),
    [aux_sym_infix_op_token1] = ACTIONS(4230),
    [aux_sym_infix_op_token2] = ACTIONS(4232),
    [anon_sym_PIPE_PIPE] = ACTIONS(4232),
    [anon_sym_BANG_EQ] = ACTIONS(4232),
    [anon_sym_COLON_EQ] = ACTIONS(4230),
    [anon_sym_DOLLAR] = ACTIONS(4232),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4232),
    [sym_int] = ACTIONS(4232),
    [sym_xint] = ACTIONS(4230),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4230),
    [sym__newline] = ACTIONS(4230),
  },
  [3114] = {
    [sym_block_comment] = STATE(3114),
    [sym_compiler_directive_decl] = STATE(3114),
    [sym_fsi_directive_decl] = STATE(3114),
    [sym_preproc_line] = STATE(3114),
    [sym_identifier] = ACTIONS(3800),
    [anon_sym_EQ] = ACTIONS(3798),
    [anon_sym_COLON] = ACTIONS(3800),
    [anon_sym_return] = ACTIONS(3800),
    [anon_sym_do] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_let_BANG] = ACTIONS(3798),
    [anon_sym_LPAREN] = ACTIONS(3800),
    [anon_sym_COMMA] = ACTIONS(3798),
    [anon_sym_null] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_COLON] = ACTIONS(3798),
    [anon_sym_PIPE] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3800),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3798),
    [anon_sym_LBRACE] = ACTIONS(3800),
    [anon_sym_LT_AT] = ACTIONS(3800),
    [anon_sym_LT_AT_AT] = ACTIONS(3800),
    [anon_sym_AT_AT_GT] = ACTIONS(3800),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3798),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_return_BANG] = ACTIONS(3798),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_yield_BANG] = ACTIONS(3798),
    [anon_sym_lazy] = ACTIONS(3800),
    [anon_sym_assert] = ACTIONS(3800),
    [anon_sym_upcast] = ACTIONS(3800),
    [anon_sym_downcast] = ACTIONS(3800),
    [anon_sym_COLON_GT] = ACTIONS(3798),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3798),
    [anon_sym_for] = ACTIONS(3800),
    [anon_sym_while] = ACTIONS(3800),
    [anon_sym_if] = ACTIONS(3800),
    [anon_sym_fun] = ACTIONS(3800),
    [anon_sym_try] = ACTIONS(3800),
    [anon_sym_match] = ACTIONS(3800),
    [anon_sym_match_BANG] = ACTIONS(3798),
    [anon_sym_function] = ACTIONS(3800),
    [anon_sym_LT_DASH] = ACTIONS(3800),
    [anon_sym_DOT_LBRACK] = ACTIONS(3798),
    [anon_sym_LT] = ACTIONS(3798),
    [anon_sym_use] = ACTIONS(3800),
    [anon_sym_use_BANG] = ACTIONS(3798),
    [anon_sym_do_BANG] = ACTIONS(3798),
    [anon_sym_begin] = ACTIONS(3800),
    [anon_sym_LPAREN2] = ACTIONS(3800),
    [anon_sym_or] = ACTIONS(3800),
    [aux_sym_char_token1] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3800),
    [anon_sym_DQUOTE] = ACTIONS(3800),
    [anon_sym_AT_DQUOTE] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [sym_bool] = ACTIONS(3800),
    [sym_unit] = ACTIONS(3798),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3800),
    [sym_op_identifier] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS_DOT] = ACTIONS(3800),
    [anon_sym_DASH_DOT] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3800),
    [anon_sym_AMP_AMP] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3798),
    [aux_sym_prefix_op_token1] = ACTIONS(3800),
    [aux_sym_infix_op_token1] = ACTIONS(3798),
    [aux_sym_infix_op_token2] = ACTIONS(3800),
    [anon_sym_PIPE_PIPE] = ACTIONS(3800),
    [anon_sym_BANG_EQ] = ACTIONS(3800),
    [anon_sym_COLON_EQ] = ACTIONS(3798),
    [anon_sym_DOLLAR] = ACTIONS(3800),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3800),
    [sym_int] = ACTIONS(3800),
    [sym_xint] = ACTIONS(3798),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3798),
    [sym__newline] = ACTIONS(3798),
  },
  [3115] = {
    [sym_block_comment] = STATE(3115),
    [sym_compiler_directive_decl] = STATE(3115),
    [sym_fsi_directive_decl] = STATE(3115),
    [sym_preproc_line] = STATE(3115),
    [sym_identifier] = ACTIONS(4126),
    [anon_sym_EQ] = ACTIONS(4124),
    [anon_sym_COLON] = ACTIONS(4126),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_do] = ACTIONS(4126),
    [anon_sym_let] = ACTIONS(4126),
    [anon_sym_let_BANG] = ACTIONS(4124),
    [anon_sym_as] = ACTIONS(4126),
    [anon_sym_LPAREN] = ACTIONS(4126),
    [anon_sym_COMMA] = ACTIONS(4124),
    [anon_sym_null] = ACTIONS(4126),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_COLON] = ACTIONS(4124),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LBRACK] = ACTIONS(4126),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4126),
    [anon_sym_LT_AT] = ACTIONS(4126),
    [anon_sym_LT_AT_AT] = ACTIONS(4126),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4124),
    [anon_sym_new] = ACTIONS(4126),
    [anon_sym_with] = ACTIONS(4126),
    [anon_sym_return_BANG] = ACTIONS(4124),
    [anon_sym_yield] = ACTIONS(4126),
    [anon_sym_yield_BANG] = ACTIONS(4124),
    [anon_sym_lazy] = ACTIONS(4126),
    [anon_sym_assert] = ACTIONS(4126),
    [anon_sym_upcast] = ACTIONS(4126),
    [anon_sym_downcast] = ACTIONS(4126),
    [anon_sym_COLON_GT] = ACTIONS(4124),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4124),
    [anon_sym_for] = ACTIONS(4126),
    [anon_sym_while] = ACTIONS(4126),
    [anon_sym_if] = ACTIONS(4126),
    [anon_sym_fun] = ACTIONS(4126),
    [anon_sym_try] = ACTIONS(4126),
    [anon_sym_match] = ACTIONS(4126),
    [anon_sym_match_BANG] = ACTIONS(4124),
    [anon_sym_function] = ACTIONS(4126),
    [anon_sym_LT_DASH] = ACTIONS(4126),
    [anon_sym_DOT_LBRACK] = ACTIONS(4124),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_use] = ACTIONS(4126),
    [anon_sym_use_BANG] = ACTIONS(4124),
    [anon_sym_do_BANG] = ACTIONS(4124),
    [anon_sym_begin] = ACTIONS(4126),
    [anon_sym_LPAREN2] = ACTIONS(4126),
    [anon_sym_or] = ACTIONS(4126),
    [aux_sym_char_token1] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4126),
    [anon_sym_DQUOTE] = ACTIONS(4126),
    [anon_sym_AT_DQUOTE] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [sym_bool] = ACTIONS(4126),
    [sym_unit] = ACTIONS(4124),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4126),
    [sym_op_identifier] = ACTIONS(4126),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_PLUS_DOT] = ACTIONS(4126),
    [anon_sym_DASH_DOT] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_AMP_AMP] = ACTIONS(4126),
    [anon_sym_TILDE] = ACTIONS(4124),
    [aux_sym_prefix_op_token1] = ACTIONS(4126),
    [aux_sym_infix_op_token1] = ACTIONS(4124),
    [aux_sym_infix_op_token2] = ACTIONS(4126),
    [anon_sym_PIPE_PIPE] = ACTIONS(4126),
    [anon_sym_BANG_EQ] = ACTIONS(4126),
    [anon_sym_COLON_EQ] = ACTIONS(4124),
    [anon_sym_DOLLAR] = ACTIONS(4126),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4126),
    [sym_int] = ACTIONS(4126),
    [sym_xint] = ACTIONS(4124),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4124),
    [sym__newline] = ACTIONS(4124),
  },
  [3116] = {
    [sym_block_comment] = STATE(3116),
    [sym_compiler_directive_decl] = STATE(3116),
    [sym_fsi_directive_decl] = STATE(3116),
    [sym_preproc_line] = STATE(3116),
    [sym_identifier] = ACTIONS(4180),
    [anon_sym_EQ] = ACTIONS(4178),
    [anon_sym_COLON] = ACTIONS(4180),
    [anon_sym_return] = ACTIONS(4180),
    [anon_sym_do] = ACTIONS(4180),
    [anon_sym_let] = ACTIONS(4180),
    [anon_sym_let_BANG] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(4180),
    [anon_sym_COMMA] = ACTIONS(4178),
    [anon_sym_null] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_COLON] = ACTIONS(4178),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4180),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4180),
    [anon_sym_LT_AT] = ACTIONS(4180),
    [anon_sym_LT_AT_AT] = ACTIONS(4180),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4178),
    [anon_sym_new] = ACTIONS(4180),
    [anon_sym_return_BANG] = ACTIONS(4178),
    [anon_sym_yield] = ACTIONS(4180),
    [anon_sym_yield_BANG] = ACTIONS(4178),
    [anon_sym_lazy] = ACTIONS(4180),
    [anon_sym_assert] = ACTIONS(4180),
    [anon_sym_upcast] = ACTIONS(4180),
    [anon_sym_downcast] = ACTIONS(4180),
    [anon_sym_COLON_GT] = ACTIONS(4178),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4178),
    [anon_sym_for] = ACTIONS(4180),
    [anon_sym_while] = ACTIONS(4180),
    [anon_sym_if] = ACTIONS(4180),
    [anon_sym_fun] = ACTIONS(4180),
    [anon_sym_DASH_GT] = ACTIONS(4180),
    [anon_sym_try] = ACTIONS(4180),
    [anon_sym_match] = ACTIONS(4180),
    [anon_sym_match_BANG] = ACTIONS(4178),
    [anon_sym_function] = ACTIONS(4180),
    [anon_sym_LT_DASH] = ACTIONS(4180),
    [anon_sym_DOT_LBRACK] = ACTIONS(4178),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_use] = ACTIONS(4180),
    [anon_sym_use_BANG] = ACTIONS(4178),
    [anon_sym_do_BANG] = ACTIONS(4178),
    [anon_sym_DOT_DOT] = ACTIONS(4178),
    [anon_sym_begin] = ACTIONS(4180),
    [anon_sym_LPAREN2] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [aux_sym_char_token1] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4180),
    [anon_sym_DQUOTE] = ACTIONS(4180),
    [anon_sym_AT_DQUOTE] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [sym_bool] = ACTIONS(4180),
    [sym_unit] = ACTIONS(4178),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4180),
    [sym_op_identifier] = ACTIONS(4180),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_PLUS_DOT] = ACTIONS(4180),
    [anon_sym_DASH_DOT] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_TILDE] = ACTIONS(4178),
    [aux_sym_prefix_op_token1] = ACTIONS(4180),
    [aux_sym_infix_op_token1] = ACTIONS(4178),
    [aux_sym_infix_op_token2] = ACTIONS(4180),
    [anon_sym_PIPE_PIPE] = ACTIONS(4180),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_COLON_EQ] = ACTIONS(4178),
    [anon_sym_DOLLAR] = ACTIONS(4180),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4180),
    [sym_int] = ACTIONS(4180),
    [sym_xint] = ACTIONS(4178),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4178),
    [sym__newline] = ACTIONS(4178),
  },
  [3117] = {
    [sym_block_comment] = STATE(3117),
    [sym_compiler_directive_decl] = STATE(3117),
    [sym_fsi_directive_decl] = STATE(3117),
    [sym_preproc_line] = STATE(3117),
    [sym_identifier] = ACTIONS(4174),
    [anon_sym_EQ] = ACTIONS(4172),
    [anon_sym_COLON] = ACTIONS(4174),
    [anon_sym_return] = ACTIONS(4174),
    [anon_sym_do] = ACTIONS(4174),
    [anon_sym_let] = ACTIONS(4174),
    [anon_sym_let_BANG] = ACTIONS(4172),
    [anon_sym_LPAREN] = ACTIONS(4174),
    [anon_sym_COMMA] = ACTIONS(4172),
    [anon_sym_null] = ACTIONS(4174),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_COLON] = ACTIONS(4172),
    [anon_sym_AMP] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4174),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4172),
    [anon_sym_LBRACE] = ACTIONS(4174),
    [anon_sym_LT_AT] = ACTIONS(4174),
    [anon_sym_LT_AT_AT] = ACTIONS(4174),
    [anon_sym_DOT] = ACTIONS(4174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4172),
    [anon_sym_new] = ACTIONS(4174),
    [anon_sym_return_BANG] = ACTIONS(4172),
    [anon_sym_yield] = ACTIONS(4174),
    [anon_sym_yield_BANG] = ACTIONS(4172),
    [anon_sym_lazy] = ACTIONS(4174),
    [anon_sym_assert] = ACTIONS(4174),
    [anon_sym_upcast] = ACTIONS(4174),
    [anon_sym_downcast] = ACTIONS(4174),
    [anon_sym_COLON_GT] = ACTIONS(4172),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4172),
    [anon_sym_for] = ACTIONS(4174),
    [anon_sym_while] = ACTIONS(4174),
    [anon_sym_if] = ACTIONS(4174),
    [anon_sym_fun] = ACTIONS(4174),
    [anon_sym_DASH_GT] = ACTIONS(4174),
    [anon_sym_try] = ACTIONS(4174),
    [anon_sym_match] = ACTIONS(4174),
    [anon_sym_match_BANG] = ACTIONS(4172),
    [anon_sym_function] = ACTIONS(4174),
    [anon_sym_LT_DASH] = ACTIONS(4174),
    [anon_sym_DOT_LBRACK] = ACTIONS(4172),
    [anon_sym_LT] = ACTIONS(4172),
    [anon_sym_use] = ACTIONS(4174),
    [anon_sym_use_BANG] = ACTIONS(4172),
    [anon_sym_do_BANG] = ACTIONS(4172),
    [anon_sym_DOT_DOT] = ACTIONS(4172),
    [anon_sym_begin] = ACTIONS(4174),
    [anon_sym_LPAREN2] = ACTIONS(4174),
    [anon_sym_or] = ACTIONS(4174),
    [aux_sym_char_token1] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4174),
    [anon_sym_DQUOTE] = ACTIONS(4174),
    [anon_sym_AT_DQUOTE] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [sym_bool] = ACTIONS(4174),
    [sym_unit] = ACTIONS(4172),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4174),
    [sym_op_identifier] = ACTIONS(4174),
    [anon_sym_PLUS] = ACTIONS(4174),
    [anon_sym_DASH] = ACTIONS(4174),
    [anon_sym_PLUS_DOT] = ACTIONS(4174),
    [anon_sym_DASH_DOT] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [anon_sym_AMP_AMP] = ACTIONS(4174),
    [anon_sym_TILDE] = ACTIONS(4172),
    [aux_sym_prefix_op_token1] = ACTIONS(4174),
    [aux_sym_infix_op_token1] = ACTIONS(4172),
    [aux_sym_infix_op_token2] = ACTIONS(4174),
    [anon_sym_PIPE_PIPE] = ACTIONS(4174),
    [anon_sym_BANG_EQ] = ACTIONS(4174),
    [anon_sym_COLON_EQ] = ACTIONS(4172),
    [anon_sym_DOLLAR] = ACTIONS(4174),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4174),
    [sym_int] = ACTIONS(4174),
    [sym_xint] = ACTIONS(4172),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4172),
    [sym__newline] = ACTIONS(4172),
  },
  [3118] = {
    [sym_block_comment] = STATE(3118),
    [sym_compiler_directive_decl] = STATE(3118),
    [sym_fsi_directive_decl] = STATE(3118),
    [sym_preproc_line] = STATE(3118),
    [sym_identifier] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3919),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_return] = ACTIONS(3921),
    [anon_sym_do] = ACTIONS(3921),
    [anon_sym_let] = ACTIONS(3921),
    [anon_sym_let_BANG] = ACTIONS(3919),
    [anon_sym_as] = ACTIONS(3921),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3919),
    [anon_sym_null] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_COLON] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3919),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_LT_AT] = ACTIONS(3921),
    [anon_sym_LT_AT_AT] = ACTIONS(3921),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3919),
    [anon_sym_new] = ACTIONS(3921),
    [anon_sym_with] = ACTIONS(3921),
    [anon_sym_return_BANG] = ACTIONS(3919),
    [anon_sym_yield] = ACTIONS(3921),
    [anon_sym_yield_BANG] = ACTIONS(3919),
    [anon_sym_lazy] = ACTIONS(3921),
    [anon_sym_assert] = ACTIONS(3921),
    [anon_sym_upcast] = ACTIONS(3921),
    [anon_sym_downcast] = ACTIONS(3921),
    [anon_sym_COLON_GT] = ACTIONS(3919),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3919),
    [anon_sym_for] = ACTIONS(3921),
    [anon_sym_while] = ACTIONS(3921),
    [anon_sym_if] = ACTIONS(3921),
    [anon_sym_fun] = ACTIONS(3921),
    [anon_sym_try] = ACTIONS(3921),
    [anon_sym_match] = ACTIONS(3921),
    [anon_sym_match_BANG] = ACTIONS(3919),
    [anon_sym_function] = ACTIONS(3921),
    [anon_sym_LT_DASH] = ACTIONS(3921),
    [anon_sym_DOT_LBRACK] = ACTIONS(3919),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_use] = ACTIONS(3921),
    [anon_sym_use_BANG] = ACTIONS(3919),
    [anon_sym_do_BANG] = ACTIONS(3919),
    [anon_sym_begin] = ACTIONS(3921),
    [anon_sym_LPAREN2] = ACTIONS(3921),
    [anon_sym_or] = ACTIONS(3921),
    [aux_sym_char_token1] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_AT_DQUOTE] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [sym_bool] = ACTIONS(3921),
    [sym_unit] = ACTIONS(3919),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3921),
    [sym_op_identifier] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_DOT] = ACTIONS(3921),
    [anon_sym_DASH_DOT] = ACTIONS(3921),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3919),
    [aux_sym_prefix_op_token1] = ACTIONS(3921),
    [aux_sym_infix_op_token1] = ACTIONS(3919),
    [aux_sym_infix_op_token2] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_COLON_EQ] = ACTIONS(3919),
    [anon_sym_DOLLAR] = ACTIONS(3921),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3921),
    [sym_int] = ACTIONS(3921),
    [sym_xint] = ACTIONS(3919),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3919),
    [sym__newline] = ACTIONS(3919),
  },
  [3119] = {
    [sym_block_comment] = STATE(3119),
    [sym_compiler_directive_decl] = STATE(3119),
    [sym_fsi_directive_decl] = STATE(3119),
    [sym_preproc_line] = STATE(3119),
    [aux_sym_sequential_expression_repeat1] = STATE(3121),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_COLON] = ACTIONS(3759),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_let_BANG] = ACTIONS(3757),
    [anon_sym_LPAREN] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3757),
    [anon_sym_null] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3757),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_LT_AT] = ACTIONS(3759),
    [anon_sym_LT_AT_AT] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(3759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_return_BANG] = ACTIONS(3757),
    [anon_sym_yield] = ACTIONS(3759),
    [anon_sym_yield_BANG] = ACTIONS(3757),
    [anon_sym_lazy] = ACTIONS(3759),
    [anon_sym_assert] = ACTIONS(3759),
    [anon_sym_upcast] = ACTIONS(3759),
    [anon_sym_downcast] = ACTIONS(3759),
    [anon_sym_COLON_GT] = ACTIONS(3757),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3757),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_fun] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_match] = ACTIONS(3759),
    [anon_sym_match_BANG] = ACTIONS(3757),
    [anon_sym_function] = ACTIONS(3759),
    [anon_sym_LT_DASH] = ACTIONS(3759),
    [anon_sym_DOT_LBRACK] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_use] = ACTIONS(3759),
    [anon_sym_use_BANG] = ACTIONS(3757),
    [anon_sym_do_BANG] = ACTIONS(3757),
    [anon_sym_DOT_DOT] = ACTIONS(3757),
    [anon_sym_begin] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_or] = ACTIONS(3759),
    [aux_sym_char_token1] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3759),
    [anon_sym_DQUOTE] = ACTIONS(3759),
    [anon_sym_AT_DQUOTE] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [sym_bool] = ACTIONS(3759),
    [sym_unit] = ACTIONS(3757),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3759),
    [sym_op_identifier] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS_DOT] = ACTIONS(3759),
    [anon_sym_DASH_DOT] = ACTIONS(3759),
    [anon_sym_PERCENT] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_TILDE] = ACTIONS(3757),
    [aux_sym_prefix_op_token1] = ACTIONS(3759),
    [aux_sym_infix_op_token1] = ACTIONS(3757),
    [aux_sym_infix_op_token2] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_COLON_EQ] = ACTIONS(3757),
    [anon_sym_DOLLAR] = ACTIONS(3759),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3759),
    [sym_int] = ACTIONS(3759),
    [sym_xint] = ACTIONS(3757),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3757),
    [sym__newline] = ACTIONS(3757),
  },
  [3120] = {
    [sym_block_comment] = STATE(3120),
    [sym_compiler_directive_decl] = STATE(3120),
    [sym_fsi_directive_decl] = STATE(3120),
    [sym_preproc_line] = STATE(3120),
    [sym_identifier] = ACTIONS(4122),
    [anon_sym_EQ] = ACTIONS(4120),
    [anon_sym_COLON] = ACTIONS(4122),
    [anon_sym_return] = ACTIONS(4122),
    [anon_sym_do] = ACTIONS(4122),
    [anon_sym_let] = ACTIONS(4122),
    [anon_sym_let_BANG] = ACTIONS(4120),
    [anon_sym_as] = ACTIONS(4122),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_COMMA] = ACTIONS(4120),
    [anon_sym_null] = ACTIONS(4122),
    [anon_sym_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_COLON] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_LT_AT] = ACTIONS(4122),
    [anon_sym_LT_AT_AT] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4122),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4120),
    [anon_sym_new] = ACTIONS(4122),
    [anon_sym_with] = ACTIONS(4122),
    [anon_sym_return_BANG] = ACTIONS(4120),
    [anon_sym_yield] = ACTIONS(4122),
    [anon_sym_yield_BANG] = ACTIONS(4120),
    [anon_sym_lazy] = ACTIONS(4122),
    [anon_sym_assert] = ACTIONS(4122),
    [anon_sym_upcast] = ACTIONS(4122),
    [anon_sym_downcast] = ACTIONS(4122),
    [anon_sym_COLON_GT] = ACTIONS(4120),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4120),
    [anon_sym_for] = ACTIONS(4122),
    [anon_sym_while] = ACTIONS(4122),
    [anon_sym_if] = ACTIONS(4122),
    [anon_sym_fun] = ACTIONS(4122),
    [anon_sym_try] = ACTIONS(4122),
    [anon_sym_match] = ACTIONS(4122),
    [anon_sym_match_BANG] = ACTIONS(4120),
    [anon_sym_function] = ACTIONS(4122),
    [anon_sym_LT_DASH] = ACTIONS(4122),
    [anon_sym_DOT_LBRACK] = ACTIONS(4120),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_use] = ACTIONS(4122),
    [anon_sym_use_BANG] = ACTIONS(4120),
    [anon_sym_do_BANG] = ACTIONS(4120),
    [anon_sym_begin] = ACTIONS(4122),
    [anon_sym_LPAREN2] = ACTIONS(4122),
    [anon_sym_or] = ACTIONS(4122),
    [aux_sym_char_token1] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4122),
    [anon_sym_DQUOTE] = ACTIONS(4122),
    [anon_sym_AT_DQUOTE] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [sym_bool] = ACTIONS(4122),
    [sym_unit] = ACTIONS(4120),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4122),
    [sym_op_identifier] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4122),
    [anon_sym_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_DOT] = ACTIONS(4122),
    [anon_sym_DASH_DOT] = ACTIONS(4122),
    [anon_sym_PERCENT] = ACTIONS(4122),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_TILDE] = ACTIONS(4120),
    [aux_sym_prefix_op_token1] = ACTIONS(4122),
    [aux_sym_infix_op_token1] = ACTIONS(4120),
    [aux_sym_infix_op_token2] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_COLON_EQ] = ACTIONS(4120),
    [anon_sym_DOLLAR] = ACTIONS(4122),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4122),
    [sym_int] = ACTIONS(4122),
    [sym_xint] = ACTIONS(4120),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4120),
    [sym__newline] = ACTIONS(4120),
  },
  [3121] = {
    [sym_block_comment] = STATE(3121),
    [sym_compiler_directive_decl] = STATE(3121),
    [sym_fsi_directive_decl] = STATE(3121),
    [sym_preproc_line] = STATE(3121),
    [aux_sym_sequential_expression_repeat1] = STATE(3121),
    [sym_identifier] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3765),
    [anon_sym_COLON] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_let_BANG] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(3767),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_null] = ACTIONS(3767),
    [anon_sym_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3765),
    [anon_sym_LBRACE] = ACTIONS(3767),
    [anon_sym_LT_AT] = ACTIONS(3767),
    [anon_sym_LT_AT_AT] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3765),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_return_BANG] = ACTIONS(3765),
    [anon_sym_yield] = ACTIONS(3767),
    [anon_sym_yield_BANG] = ACTIONS(3765),
    [anon_sym_lazy] = ACTIONS(3767),
    [anon_sym_assert] = ACTIONS(3767),
    [anon_sym_upcast] = ACTIONS(3767),
    [anon_sym_downcast] = ACTIONS(3767),
    [anon_sym_COLON_GT] = ACTIONS(3765),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3765),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_fun] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_match] = ACTIONS(3767),
    [anon_sym_match_BANG] = ACTIONS(3765),
    [anon_sym_function] = ACTIONS(3767),
    [anon_sym_LT_DASH] = ACTIONS(3767),
    [anon_sym_DOT_LBRACK] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(3765),
    [anon_sym_use] = ACTIONS(3767),
    [anon_sym_use_BANG] = ACTIONS(3765),
    [anon_sym_do_BANG] = ACTIONS(3765),
    [anon_sym_DOT_DOT] = ACTIONS(3765),
    [anon_sym_begin] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3767),
    [anon_sym_or] = ACTIONS(3767),
    [aux_sym_char_token1] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3767),
    [anon_sym_DQUOTE] = ACTIONS(3767),
    [anon_sym_AT_DQUOTE] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [sym_bool] = ACTIONS(3767),
    [sym_unit] = ACTIONS(3765),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3767),
    [sym_op_identifier] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_PLUS_DOT] = ACTIONS(3767),
    [anon_sym_DASH_DOT] = ACTIONS(3767),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_AMP_AMP] = ACTIONS(3767),
    [anon_sym_TILDE] = ACTIONS(3765),
    [aux_sym_prefix_op_token1] = ACTIONS(3767),
    [aux_sym_infix_op_token1] = ACTIONS(3765),
    [aux_sym_infix_op_token2] = ACTIONS(3767),
    [anon_sym_PIPE_PIPE] = ACTIONS(3767),
    [anon_sym_BANG_EQ] = ACTIONS(3767),
    [anon_sym_COLON_EQ] = ACTIONS(3765),
    [anon_sym_DOLLAR] = ACTIONS(3767),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3767),
    [sym_int] = ACTIONS(3767),
    [sym_xint] = ACTIONS(3765),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3765),
    [sym__newline] = ACTIONS(5719),
  },
  [3122] = {
    [sym_block_comment] = STATE(3122),
    [sym_compiler_directive_decl] = STATE(3122),
    [sym_fsi_directive_decl] = STATE(3122),
    [sym_preproc_line] = STATE(3122),
    [aux_sym_sequential_expression_repeat1] = STATE(3122),
    [sym_identifier] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3765),
    [anon_sym_COLON] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_let_BANG] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(3767),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_null] = ACTIONS(3767),
    [anon_sym_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3765),
    [anon_sym_LBRACE] = ACTIONS(3767),
    [anon_sym_LT_AT] = ACTIONS(3767),
    [anon_sym_LT_AT_AT] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3765),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_return_BANG] = ACTIONS(3765),
    [anon_sym_yield] = ACTIONS(3767),
    [anon_sym_yield_BANG] = ACTIONS(3765),
    [anon_sym_lazy] = ACTIONS(3767),
    [anon_sym_assert] = ACTIONS(3767),
    [anon_sym_upcast] = ACTIONS(3767),
    [anon_sym_downcast] = ACTIONS(3767),
    [anon_sym_COLON_GT] = ACTIONS(3765),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3765),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_fun] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_match] = ACTIONS(3767),
    [anon_sym_match_BANG] = ACTIONS(3765),
    [anon_sym_function] = ACTIONS(3767),
    [anon_sym_LT_DASH] = ACTIONS(3767),
    [anon_sym_DOT_LBRACK] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(3765),
    [anon_sym_use] = ACTIONS(3767),
    [anon_sym_use_BANG] = ACTIONS(3765),
    [anon_sym_do_BANG] = ACTIONS(3765),
    [anon_sym_begin] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3767),
    [anon_sym_or] = ACTIONS(3767),
    [aux_sym_char_token1] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3767),
    [anon_sym_DQUOTE] = ACTIONS(3767),
    [anon_sym_AT_DQUOTE] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [sym_bool] = ACTIONS(3767),
    [sym_unit] = ACTIONS(3765),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3767),
    [sym_op_identifier] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_PLUS_DOT] = ACTIONS(3767),
    [anon_sym_DASH_DOT] = ACTIONS(3767),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_AMP_AMP] = ACTIONS(3767),
    [anon_sym_TILDE] = ACTIONS(3765),
    [aux_sym_prefix_op_token1] = ACTIONS(3767),
    [aux_sym_infix_op_token1] = ACTIONS(3765),
    [aux_sym_infix_op_token2] = ACTIONS(3767),
    [anon_sym_PIPE_PIPE] = ACTIONS(3767),
    [anon_sym_BANG_EQ] = ACTIONS(3767),
    [anon_sym_COLON_EQ] = ACTIONS(3765),
    [anon_sym_DOLLAR] = ACTIONS(3767),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3767),
    [sym_int] = ACTIONS(3767),
    [sym_xint] = ACTIONS(3765),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3765),
    [anon_sym_POUNDendif] = ACTIONS(3765),
    [sym__newline] = ACTIONS(5722),
  },
  [3123] = {
    [sym_block_comment] = STATE(3123),
    [sym_compiler_directive_decl] = STATE(3123),
    [sym_fsi_directive_decl] = STATE(3123),
    [sym_preproc_line] = STATE(3123),
    [sym_identifier] = ACTIONS(4170),
    [anon_sym_EQ] = ACTIONS(4168),
    [anon_sym_COLON] = ACTIONS(4170),
    [anon_sym_return] = ACTIONS(4170),
    [anon_sym_do] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_let_BANG] = ACTIONS(4168),
    [anon_sym_as] = ACTIONS(4170),
    [anon_sym_LPAREN] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4168),
    [anon_sym_null] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_COLON] = ACTIONS(4168),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4170),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4168),
    [anon_sym_LBRACE] = ACTIONS(4170),
    [anon_sym_LT_AT] = ACTIONS(4170),
    [anon_sym_LT_AT_AT] = ACTIONS(4170),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4168),
    [anon_sym_new] = ACTIONS(4170),
    [anon_sym_with] = ACTIONS(4170),
    [anon_sym_return_BANG] = ACTIONS(4168),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_yield_BANG] = ACTIONS(4168),
    [anon_sym_lazy] = ACTIONS(4170),
    [anon_sym_assert] = ACTIONS(4170),
    [anon_sym_upcast] = ACTIONS(4170),
    [anon_sym_downcast] = ACTIONS(4170),
    [anon_sym_COLON_GT] = ACTIONS(4168),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4168),
    [anon_sym_for] = ACTIONS(4170),
    [anon_sym_while] = ACTIONS(4170),
    [anon_sym_if] = ACTIONS(4170),
    [anon_sym_fun] = ACTIONS(4170),
    [anon_sym_try] = ACTIONS(4170),
    [anon_sym_match] = ACTIONS(4170),
    [anon_sym_match_BANG] = ACTIONS(4168),
    [anon_sym_function] = ACTIONS(4170),
    [anon_sym_LT_DASH] = ACTIONS(4170),
    [anon_sym_DOT_LBRACK] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4168),
    [anon_sym_use] = ACTIONS(4170),
    [anon_sym_use_BANG] = ACTIONS(4168),
    [anon_sym_do_BANG] = ACTIONS(4168),
    [anon_sym_begin] = ACTIONS(4170),
    [anon_sym_LPAREN2] = ACTIONS(4170),
    [anon_sym_or] = ACTIONS(4170),
    [aux_sym_char_token1] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4170),
    [anon_sym_DQUOTE] = ACTIONS(4170),
    [anon_sym_AT_DQUOTE] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [sym_bool] = ACTIONS(4170),
    [sym_unit] = ACTIONS(4168),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4170),
    [sym_op_identifier] = ACTIONS(4170),
    [anon_sym_PLUS] = ACTIONS(4170),
    [anon_sym_DASH] = ACTIONS(4170),
    [anon_sym_PLUS_DOT] = ACTIONS(4170),
    [anon_sym_DASH_DOT] = ACTIONS(4170),
    [anon_sym_PERCENT] = ACTIONS(4170),
    [anon_sym_AMP_AMP] = ACTIONS(4170),
    [anon_sym_TILDE] = ACTIONS(4168),
    [aux_sym_prefix_op_token1] = ACTIONS(4170),
    [aux_sym_infix_op_token1] = ACTIONS(4168),
    [aux_sym_infix_op_token2] = ACTIONS(4170),
    [anon_sym_PIPE_PIPE] = ACTIONS(4170),
    [anon_sym_BANG_EQ] = ACTIONS(4170),
    [anon_sym_COLON_EQ] = ACTIONS(4168),
    [anon_sym_DOLLAR] = ACTIONS(4170),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4170),
    [sym_int] = ACTIONS(4170),
    [sym_xint] = ACTIONS(4168),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4168),
    [sym__newline] = ACTIONS(4168),
  },
  [3124] = {
    [sym_block_comment] = STATE(3124),
    [sym_compiler_directive_decl] = STATE(3124),
    [sym_fsi_directive_decl] = STATE(3124),
    [sym_preproc_line] = STATE(3124),
    [sym_identifier] = ACTIONS(4118),
    [anon_sym_EQ] = ACTIONS(4116),
    [anon_sym_COLON] = ACTIONS(4118),
    [anon_sym_return] = ACTIONS(4118),
    [anon_sym_do] = ACTIONS(4118),
    [anon_sym_let] = ACTIONS(4118),
    [anon_sym_let_BANG] = ACTIONS(4116),
    [anon_sym_as] = ACTIONS(4118),
    [anon_sym_LPAREN] = ACTIONS(4118),
    [anon_sym_COMMA] = ACTIONS(4116),
    [anon_sym_null] = ACTIONS(4118),
    [anon_sym_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_COLON] = ACTIONS(4116),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4118),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(4118),
    [anon_sym_LT_AT] = ACTIONS(4118),
    [anon_sym_LT_AT_AT] = ACTIONS(4118),
    [anon_sym_DOT] = ACTIONS(4118),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4116),
    [anon_sym_new] = ACTIONS(4118),
    [anon_sym_with] = ACTIONS(4118),
    [anon_sym_return_BANG] = ACTIONS(4116),
    [anon_sym_yield] = ACTIONS(4118),
    [anon_sym_yield_BANG] = ACTIONS(4116),
    [anon_sym_lazy] = ACTIONS(4118),
    [anon_sym_assert] = ACTIONS(4118),
    [anon_sym_upcast] = ACTIONS(4118),
    [anon_sym_downcast] = ACTIONS(4118),
    [anon_sym_COLON_GT] = ACTIONS(4116),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4116),
    [anon_sym_for] = ACTIONS(4118),
    [anon_sym_while] = ACTIONS(4118),
    [anon_sym_if] = ACTIONS(4118),
    [anon_sym_fun] = ACTIONS(4118),
    [anon_sym_try] = ACTIONS(4118),
    [anon_sym_match] = ACTIONS(4118),
    [anon_sym_match_BANG] = ACTIONS(4116),
    [anon_sym_function] = ACTIONS(4118),
    [anon_sym_LT_DASH] = ACTIONS(4118),
    [anon_sym_DOT_LBRACK] = ACTIONS(4116),
    [anon_sym_LT] = ACTIONS(4116),
    [anon_sym_use] = ACTIONS(4118),
    [anon_sym_use_BANG] = ACTIONS(4116),
    [anon_sym_do_BANG] = ACTIONS(4116),
    [anon_sym_begin] = ACTIONS(4118),
    [anon_sym_LPAREN2] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [aux_sym_char_token1] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4118),
    [anon_sym_DQUOTE] = ACTIONS(4118),
    [anon_sym_AT_DQUOTE] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [sym_bool] = ACTIONS(4118),
    [sym_unit] = ACTIONS(4116),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4118),
    [sym_op_identifier] = ACTIONS(4118),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_PLUS_DOT] = ACTIONS(4118),
    [anon_sym_DASH_DOT] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_AMP_AMP] = ACTIONS(4118),
    [anon_sym_TILDE] = ACTIONS(4116),
    [aux_sym_prefix_op_token1] = ACTIONS(4118),
    [aux_sym_infix_op_token1] = ACTIONS(4116),
    [aux_sym_infix_op_token2] = ACTIONS(4118),
    [anon_sym_PIPE_PIPE] = ACTIONS(4118),
    [anon_sym_BANG_EQ] = ACTIONS(4118),
    [anon_sym_COLON_EQ] = ACTIONS(4116),
    [anon_sym_DOLLAR] = ACTIONS(4118),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4118),
    [sym_int] = ACTIONS(4118),
    [sym_xint] = ACTIONS(4116),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4116),
    [sym__newline] = ACTIONS(4116),
  },
  [3125] = {
    [sym_block_comment] = STATE(3125),
    [sym_compiler_directive_decl] = STATE(3125),
    [sym_fsi_directive_decl] = STATE(3125),
    [sym_preproc_line] = STATE(3125),
    [sym_identifier] = ACTIONS(4186),
    [anon_sym_EQ] = ACTIONS(4184),
    [anon_sym_COLON] = ACTIONS(4186),
    [anon_sym_return] = ACTIONS(4186),
    [anon_sym_do] = ACTIONS(4186),
    [anon_sym_let] = ACTIONS(4186),
    [anon_sym_let_BANG] = ACTIONS(4184),
    [anon_sym_as] = ACTIONS(4186),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_COMMA] = ACTIONS(4184),
    [anon_sym_null] = ACTIONS(4186),
    [anon_sym_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_COLON] = ACTIONS(4184),
    [anon_sym_AMP] = ACTIONS(4186),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4184),
    [anon_sym_LBRACE] = ACTIONS(4186),
    [anon_sym_LT_AT] = ACTIONS(4186),
    [anon_sym_LT_AT_AT] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4186),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4184),
    [anon_sym_new] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4186),
    [anon_sym_return_BANG] = ACTIONS(4184),
    [anon_sym_yield] = ACTIONS(4186),
    [anon_sym_yield_BANG] = ACTIONS(4184),
    [anon_sym_lazy] = ACTIONS(4186),
    [anon_sym_assert] = ACTIONS(4186),
    [anon_sym_upcast] = ACTIONS(4186),
    [anon_sym_downcast] = ACTIONS(4186),
    [anon_sym_COLON_GT] = ACTIONS(4184),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4184),
    [anon_sym_for] = ACTIONS(4186),
    [anon_sym_while] = ACTIONS(4186),
    [anon_sym_if] = ACTIONS(4186),
    [anon_sym_fun] = ACTIONS(4186),
    [anon_sym_try] = ACTIONS(4186),
    [anon_sym_match] = ACTIONS(4186),
    [anon_sym_match_BANG] = ACTIONS(4184),
    [anon_sym_function] = ACTIONS(4186),
    [anon_sym_LT_DASH] = ACTIONS(4186),
    [anon_sym_DOT_LBRACK] = ACTIONS(4184),
    [anon_sym_LT] = ACTIONS(4184),
    [anon_sym_use] = ACTIONS(4186),
    [anon_sym_use_BANG] = ACTIONS(4184),
    [anon_sym_do_BANG] = ACTIONS(4184),
    [anon_sym_begin] = ACTIONS(4186),
    [anon_sym_LPAREN2] = ACTIONS(4186),
    [anon_sym_or] = ACTIONS(4186),
    [aux_sym_char_token1] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4186),
    [anon_sym_DQUOTE] = ACTIONS(4186),
    [anon_sym_AT_DQUOTE] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [sym_bool] = ACTIONS(4186),
    [sym_unit] = ACTIONS(4184),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4186),
    [sym_op_identifier] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4186),
    [anon_sym_DASH] = ACTIONS(4186),
    [anon_sym_PLUS_DOT] = ACTIONS(4186),
    [anon_sym_DASH_DOT] = ACTIONS(4186),
    [anon_sym_PERCENT] = ACTIONS(4186),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_TILDE] = ACTIONS(4184),
    [aux_sym_prefix_op_token1] = ACTIONS(4186),
    [aux_sym_infix_op_token1] = ACTIONS(4184),
    [aux_sym_infix_op_token2] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_COLON_EQ] = ACTIONS(4184),
    [anon_sym_DOLLAR] = ACTIONS(4186),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4186),
    [sym_int] = ACTIONS(4186),
    [sym_xint] = ACTIONS(4184),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4184),
    [sym__newline] = ACTIONS(4184),
  },
  [3126] = {
    [sym_block_comment] = STATE(3126),
    [sym_compiler_directive_decl] = STATE(3126),
    [sym_fsi_directive_decl] = STATE(3126),
    [sym_preproc_line] = STATE(3126),
    [sym_identifier] = ACTIONS(4112),
    [anon_sym_EQ] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4112),
    [anon_sym_return] = ACTIONS(4112),
    [anon_sym_do] = ACTIONS(4112),
    [anon_sym_let] = ACTIONS(4112),
    [anon_sym_let_BANG] = ACTIONS(4110),
    [anon_sym_as] = ACTIONS(4112),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_null] = ACTIONS(4112),
    [anon_sym_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_COLON] = ACTIONS(4110),
    [anon_sym_AMP] = ACTIONS(4112),
    [anon_sym_LBRACK] = ACTIONS(4112),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4110),
    [anon_sym_LBRACE] = ACTIONS(4112),
    [anon_sym_LT_AT] = ACTIONS(4112),
    [anon_sym_LT_AT_AT] = ACTIONS(4112),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4110),
    [anon_sym_new] = ACTIONS(4112),
    [anon_sym_with] = ACTIONS(4112),
    [anon_sym_return_BANG] = ACTIONS(4110),
    [anon_sym_yield] = ACTIONS(4112),
    [anon_sym_yield_BANG] = ACTIONS(4110),
    [anon_sym_lazy] = ACTIONS(4112),
    [anon_sym_assert] = ACTIONS(4112),
    [anon_sym_upcast] = ACTIONS(4112),
    [anon_sym_downcast] = ACTIONS(4112),
    [anon_sym_COLON_GT] = ACTIONS(4110),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4110),
    [anon_sym_for] = ACTIONS(4112),
    [anon_sym_while] = ACTIONS(4112),
    [anon_sym_if] = ACTIONS(4112),
    [anon_sym_fun] = ACTIONS(4112),
    [anon_sym_try] = ACTIONS(4112),
    [anon_sym_match] = ACTIONS(4112),
    [anon_sym_match_BANG] = ACTIONS(4110),
    [anon_sym_function] = ACTIONS(4112),
    [anon_sym_LT_DASH] = ACTIONS(4112),
    [anon_sym_DOT_LBRACK] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(4110),
    [anon_sym_use] = ACTIONS(4112),
    [anon_sym_use_BANG] = ACTIONS(4110),
    [anon_sym_do_BANG] = ACTIONS(4110),
    [anon_sym_begin] = ACTIONS(4112),
    [anon_sym_LPAREN2] = ACTIONS(4112),
    [anon_sym_or] = ACTIONS(4112),
    [aux_sym_char_token1] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4112),
    [anon_sym_DQUOTE] = ACTIONS(4112),
    [anon_sym_AT_DQUOTE] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [sym_bool] = ACTIONS(4112),
    [sym_unit] = ACTIONS(4110),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4112),
    [sym_op_identifier] = ACTIONS(4112),
    [anon_sym_PLUS] = ACTIONS(4112),
    [anon_sym_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_DOT] = ACTIONS(4112),
    [anon_sym_DASH_DOT] = ACTIONS(4112),
    [anon_sym_PERCENT] = ACTIONS(4112),
    [anon_sym_AMP_AMP] = ACTIONS(4112),
    [anon_sym_TILDE] = ACTIONS(4110),
    [aux_sym_prefix_op_token1] = ACTIONS(4112),
    [aux_sym_infix_op_token1] = ACTIONS(4110),
    [aux_sym_infix_op_token2] = ACTIONS(4112),
    [anon_sym_PIPE_PIPE] = ACTIONS(4112),
    [anon_sym_BANG_EQ] = ACTIONS(4112),
    [anon_sym_COLON_EQ] = ACTIONS(4110),
    [anon_sym_DOLLAR] = ACTIONS(4112),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4112),
    [sym_int] = ACTIONS(4112),
    [sym_xint] = ACTIONS(4110),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4110),
    [sym__newline] = ACTIONS(4110),
  },
  [3127] = {
    [sym_block_comment] = STATE(3127),
    [sym_compiler_directive_decl] = STATE(3127),
    [sym_fsi_directive_decl] = STATE(3127),
    [sym_preproc_line] = STATE(3127),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4072),
    [anon_sym_COLON] = ACTIONS(4074),
    [anon_sym_return] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_let_BANG] = ACTIONS(4072),
    [anon_sym_LPAREN] = ACTIONS(4074),
    [anon_sym_COMMA] = ACTIONS(4072),
    [anon_sym_null] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_COLON] = ACTIONS(4072),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_LT_AT] = ACTIONS(4074),
    [anon_sym_LT_AT_AT] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4072),
    [anon_sym_new] = ACTIONS(4074),
    [anon_sym_return_BANG] = ACTIONS(4072),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_yield_BANG] = ACTIONS(4072),
    [anon_sym_lazy] = ACTIONS(4074),
    [anon_sym_assert] = ACTIONS(4074),
    [anon_sym_upcast] = ACTIONS(4074),
    [anon_sym_downcast] = ACTIONS(4074),
    [anon_sym_COLON_GT] = ACTIONS(4072),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4072),
    [anon_sym_for] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_fun] = ACTIONS(4074),
    [anon_sym_DASH_GT] = ACTIONS(4074),
    [anon_sym_try] = ACTIONS(4074),
    [anon_sym_match] = ACTIONS(4074),
    [anon_sym_match_BANG] = ACTIONS(4072),
    [anon_sym_function] = ACTIONS(4074),
    [anon_sym_LT_DASH] = ACTIONS(4074),
    [anon_sym_DOT_LBRACK] = ACTIONS(4072),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_use] = ACTIONS(4074),
    [anon_sym_use_BANG] = ACTIONS(4072),
    [anon_sym_do_BANG] = ACTIONS(4072),
    [anon_sym_DOT_DOT] = ACTIONS(4072),
    [anon_sym_begin] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [aux_sym_char_token1] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4074),
    [anon_sym_DQUOTE] = ACTIONS(4074),
    [anon_sym_AT_DQUOTE] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [sym_bool] = ACTIONS(4074),
    [sym_unit] = ACTIONS(4072),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4074),
    [sym_op_identifier] = ACTIONS(4074),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_PLUS_DOT] = ACTIONS(4074),
    [anon_sym_DASH_DOT] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_TILDE] = ACTIONS(4072),
    [aux_sym_prefix_op_token1] = ACTIONS(4074),
    [aux_sym_infix_op_token1] = ACTIONS(4072),
    [aux_sym_infix_op_token2] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [anon_sym_BANG_EQ] = ACTIONS(4074),
    [anon_sym_COLON_EQ] = ACTIONS(4072),
    [anon_sym_DOLLAR] = ACTIONS(4074),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4074),
    [sym_int] = ACTIONS(4074),
    [sym_xint] = ACTIONS(4072),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4072),
    [sym__newline] = ACTIONS(4072),
  },
  [3128] = {
    [sym_block_comment] = STATE(3128),
    [sym_compiler_directive_decl] = STATE(3128),
    [sym_fsi_directive_decl] = STATE(3128),
    [sym_preproc_line] = STATE(3128),
    [sym_identifier] = ACTIONS(4182),
    [anon_sym_EQ] = ACTIONS(3689),
    [anon_sym_COLON] = ACTIONS(4182),
    [anon_sym_return] = ACTIONS(4182),
    [anon_sym_do] = ACTIONS(4182),
    [anon_sym_let] = ACTIONS(4182),
    [anon_sym_let_BANG] = ACTIONS(3689),
    [anon_sym_as] = ACTIONS(4182),
    [anon_sym_LPAREN] = ACTIONS(4182),
    [anon_sym_COMMA] = ACTIONS(3689),
    [anon_sym_null] = ACTIONS(4182),
    [anon_sym_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3689),
    [anon_sym_LBRACE] = ACTIONS(4182),
    [anon_sym_LT_AT] = ACTIONS(4182),
    [anon_sym_LT_AT_AT] = ACTIONS(4182),
    [anon_sym_DOT] = ACTIONS(4182),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3689),
    [anon_sym_new] = ACTIONS(4182),
    [anon_sym_with] = ACTIONS(4182),
    [anon_sym_return_BANG] = ACTIONS(3689),
    [anon_sym_yield] = ACTIONS(4182),
    [anon_sym_yield_BANG] = ACTIONS(3689),
    [anon_sym_lazy] = ACTIONS(4182),
    [anon_sym_assert] = ACTIONS(4182),
    [anon_sym_upcast] = ACTIONS(4182),
    [anon_sym_downcast] = ACTIONS(4182),
    [anon_sym_COLON_GT] = ACTIONS(3689),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3689),
    [anon_sym_for] = ACTIONS(4182),
    [anon_sym_while] = ACTIONS(4182),
    [anon_sym_if] = ACTIONS(4182),
    [anon_sym_fun] = ACTIONS(4182),
    [anon_sym_try] = ACTIONS(4182),
    [anon_sym_match] = ACTIONS(4182),
    [anon_sym_match_BANG] = ACTIONS(3689),
    [anon_sym_function] = ACTIONS(4182),
    [anon_sym_LT_DASH] = ACTIONS(4182),
    [anon_sym_DOT_LBRACK] = ACTIONS(3689),
    [anon_sym_LT] = ACTIONS(3689),
    [anon_sym_use] = ACTIONS(4182),
    [anon_sym_use_BANG] = ACTIONS(3689),
    [anon_sym_do_BANG] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(4182),
    [anon_sym_LPAREN2] = ACTIONS(4182),
    [anon_sym_or] = ACTIONS(4182),
    [aux_sym_char_token1] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4182),
    [anon_sym_DQUOTE] = ACTIONS(4182),
    [anon_sym_AT_DQUOTE] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [sym_bool] = ACTIONS(4182),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4182),
    [sym_op_identifier] = ACTIONS(4182),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_PLUS_DOT] = ACTIONS(4182),
    [anon_sym_DASH_DOT] = ACTIONS(4182),
    [anon_sym_PERCENT] = ACTIONS(4182),
    [anon_sym_AMP_AMP] = ACTIONS(4182),
    [anon_sym_TILDE] = ACTIONS(3689),
    [aux_sym_prefix_op_token1] = ACTIONS(4182),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token2] = ACTIONS(4182),
    [anon_sym_PIPE_PIPE] = ACTIONS(4182),
    [anon_sym_BANG_EQ] = ACTIONS(4182),
    [anon_sym_COLON_EQ] = ACTIONS(3689),
    [anon_sym_DOLLAR] = ACTIONS(4182),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4182),
    [sym_int] = ACTIONS(4182),
    [sym_xint] = ACTIONS(3689),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3689),
    [sym__newline] = ACTIONS(3689),
  },
  [3129] = {
    [sym_block_comment] = STATE(3129),
    [sym_compiler_directive_decl] = STATE(3129),
    [sym_fsi_directive_decl] = STATE(3129),
    [sym_preproc_line] = STATE(3129),
    [sym_identifier] = ACTIONS(4022),
    [anon_sym_EQ] = ACTIONS(4020),
    [anon_sym_COLON] = ACTIONS(4022),
    [anon_sym_return] = ACTIONS(4022),
    [anon_sym_do] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_let_BANG] = ACTIONS(4020),
    [anon_sym_LPAREN] = ACTIONS(4022),
    [anon_sym_COMMA] = ACTIONS(4020),
    [anon_sym_null] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_COLON] = ACTIONS(4020),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4022),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(4022),
    [anon_sym_LT_AT] = ACTIONS(4022),
    [anon_sym_LT_AT_AT] = ACTIONS(4022),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4020),
    [anon_sym_new] = ACTIONS(4022),
    [anon_sym_return_BANG] = ACTIONS(4020),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_yield_BANG] = ACTIONS(4020),
    [anon_sym_lazy] = ACTIONS(4022),
    [anon_sym_assert] = ACTIONS(4022),
    [anon_sym_upcast] = ACTIONS(4022),
    [anon_sym_downcast] = ACTIONS(4022),
    [anon_sym_COLON_GT] = ACTIONS(4020),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4020),
    [anon_sym_for] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4022),
    [anon_sym_if] = ACTIONS(4022),
    [anon_sym_fun] = ACTIONS(4022),
    [anon_sym_DASH_GT] = ACTIONS(4022),
    [anon_sym_try] = ACTIONS(4022),
    [anon_sym_match] = ACTIONS(4022),
    [anon_sym_match_BANG] = ACTIONS(4020),
    [anon_sym_function] = ACTIONS(4022),
    [anon_sym_LT_DASH] = ACTIONS(4022),
    [anon_sym_DOT_LBRACK] = ACTIONS(4020),
    [anon_sym_LT] = ACTIONS(4020),
    [anon_sym_use] = ACTIONS(4022),
    [anon_sym_use_BANG] = ACTIONS(4020),
    [anon_sym_do_BANG] = ACTIONS(4020),
    [anon_sym_DOT_DOT] = ACTIONS(4020),
    [anon_sym_begin] = ACTIONS(4022),
    [anon_sym_LPAREN2] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [aux_sym_char_token1] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4022),
    [anon_sym_DQUOTE] = ACTIONS(4022),
    [anon_sym_AT_DQUOTE] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [sym_bool] = ACTIONS(4022),
    [sym_unit] = ACTIONS(4020),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4022),
    [sym_op_identifier] = ACTIONS(4022),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_PLUS_DOT] = ACTIONS(4022),
    [anon_sym_DASH_DOT] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4022),
    [anon_sym_TILDE] = ACTIONS(4020),
    [aux_sym_prefix_op_token1] = ACTIONS(4022),
    [aux_sym_infix_op_token1] = ACTIONS(4020),
    [aux_sym_infix_op_token2] = ACTIONS(4022),
    [anon_sym_PIPE_PIPE] = ACTIONS(4022),
    [anon_sym_BANG_EQ] = ACTIONS(4022),
    [anon_sym_COLON_EQ] = ACTIONS(4020),
    [anon_sym_DOLLAR] = ACTIONS(4022),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4022),
    [sym_int] = ACTIONS(4022),
    [sym_xint] = ACTIONS(4020),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4020),
    [sym__newline] = ACTIONS(4020),
  },
  [3130] = {
    [sym_block_comment] = STATE(3130),
    [sym_compiler_directive_decl] = STATE(3130),
    [sym_fsi_directive_decl] = STATE(3130),
    [sym_preproc_line] = STATE(3130),
    [sym_identifier] = ACTIONS(4011),
    [anon_sym_EQ] = ACTIONS(4009),
    [anon_sym_COLON] = ACTIONS(4011),
    [anon_sym_return] = ACTIONS(4011),
    [anon_sym_do] = ACTIONS(4011),
    [anon_sym_let] = ACTIONS(4011),
    [anon_sym_let_BANG] = ACTIONS(4009),
    [anon_sym_LPAREN] = ACTIONS(4011),
    [anon_sym_COMMA] = ACTIONS(4009),
    [anon_sym_null] = ACTIONS(4011),
    [anon_sym_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(4011),
    [anon_sym_LBRACK] = ACTIONS(4011),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4009),
    [anon_sym_LBRACE] = ACTIONS(4011),
    [anon_sym_LT_AT] = ACTIONS(4011),
    [anon_sym_LT_AT_AT] = ACTIONS(4011),
    [anon_sym_DOT] = ACTIONS(4011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4009),
    [anon_sym_new] = ACTIONS(4011),
    [anon_sym_return_BANG] = ACTIONS(4009),
    [anon_sym_yield] = ACTIONS(4011),
    [anon_sym_yield_BANG] = ACTIONS(4009),
    [anon_sym_lazy] = ACTIONS(4011),
    [anon_sym_assert] = ACTIONS(4011),
    [anon_sym_upcast] = ACTIONS(4011),
    [anon_sym_downcast] = ACTIONS(4011),
    [anon_sym_COLON_GT] = ACTIONS(4009),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4009),
    [anon_sym_for] = ACTIONS(4011),
    [anon_sym_while] = ACTIONS(4011),
    [anon_sym_if] = ACTIONS(4011),
    [anon_sym_fun] = ACTIONS(4011),
    [anon_sym_DASH_GT] = ACTIONS(4011),
    [anon_sym_try] = ACTIONS(4011),
    [anon_sym_match] = ACTIONS(4011),
    [anon_sym_match_BANG] = ACTIONS(4009),
    [anon_sym_function] = ACTIONS(4011),
    [anon_sym_LT_DASH] = ACTIONS(4011),
    [anon_sym_DOT_LBRACK] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(4009),
    [anon_sym_use] = ACTIONS(4011),
    [anon_sym_use_BANG] = ACTIONS(4009),
    [anon_sym_do_BANG] = ACTIONS(4009),
    [anon_sym_DOT_DOT] = ACTIONS(4009),
    [anon_sym_begin] = ACTIONS(4011),
    [anon_sym_LPAREN2] = ACTIONS(4011),
    [anon_sym_or] = ACTIONS(4011),
    [aux_sym_char_token1] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4011),
    [anon_sym_DQUOTE] = ACTIONS(4011),
    [anon_sym_AT_DQUOTE] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [sym_bool] = ACTIONS(4011),
    [sym_unit] = ACTIONS(4009),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4011),
    [sym_op_identifier] = ACTIONS(4011),
    [anon_sym_PLUS] = ACTIONS(4011),
    [anon_sym_DASH] = ACTIONS(4011),
    [anon_sym_PLUS_DOT] = ACTIONS(4011),
    [anon_sym_DASH_DOT] = ACTIONS(4011),
    [anon_sym_PERCENT] = ACTIONS(4011),
    [anon_sym_AMP_AMP] = ACTIONS(4011),
    [anon_sym_TILDE] = ACTIONS(4009),
    [aux_sym_prefix_op_token1] = ACTIONS(4011),
    [aux_sym_infix_op_token1] = ACTIONS(4009),
    [aux_sym_infix_op_token2] = ACTIONS(4011),
    [anon_sym_PIPE_PIPE] = ACTIONS(4011),
    [anon_sym_BANG_EQ] = ACTIONS(4011),
    [anon_sym_COLON_EQ] = ACTIONS(4009),
    [anon_sym_DOLLAR] = ACTIONS(4011),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4011),
    [sym_int] = ACTIONS(4011),
    [sym_xint] = ACTIONS(4009),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4009),
    [sym__newline] = ACTIONS(4009),
  },
  [3131] = {
    [sym_block_comment] = STATE(3131),
    [sym_compiler_directive_decl] = STATE(3131),
    [sym_fsi_directive_decl] = STATE(3131),
    [sym_preproc_line] = STATE(3131),
    [sym_identifier] = ACTIONS(4007),
    [anon_sym_EQ] = ACTIONS(4005),
    [anon_sym_COLON] = ACTIONS(4007),
    [anon_sym_return] = ACTIONS(4007),
    [anon_sym_do] = ACTIONS(4007),
    [anon_sym_let] = ACTIONS(4007),
    [anon_sym_let_BANG] = ACTIONS(4005),
    [anon_sym_LPAREN] = ACTIONS(4007),
    [anon_sym_COMMA] = ACTIONS(4005),
    [anon_sym_null] = ACTIONS(4007),
    [anon_sym_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_COLON] = ACTIONS(4005),
    [anon_sym_AMP] = ACTIONS(4007),
    [anon_sym_LBRACK] = ACTIONS(4007),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4005),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_LT_AT] = ACTIONS(4007),
    [anon_sym_LT_AT_AT] = ACTIONS(4007),
    [anon_sym_DOT] = ACTIONS(4007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4005),
    [anon_sym_new] = ACTIONS(4007),
    [anon_sym_return_BANG] = ACTIONS(4005),
    [anon_sym_yield] = ACTIONS(4007),
    [anon_sym_yield_BANG] = ACTIONS(4005),
    [anon_sym_lazy] = ACTIONS(4007),
    [anon_sym_assert] = ACTIONS(4007),
    [anon_sym_upcast] = ACTIONS(4007),
    [anon_sym_downcast] = ACTIONS(4007),
    [anon_sym_COLON_GT] = ACTIONS(4005),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4005),
    [anon_sym_for] = ACTIONS(4007),
    [anon_sym_while] = ACTIONS(4007),
    [anon_sym_if] = ACTIONS(4007),
    [anon_sym_fun] = ACTIONS(4007),
    [anon_sym_DASH_GT] = ACTIONS(4007),
    [anon_sym_try] = ACTIONS(4007),
    [anon_sym_match] = ACTIONS(4007),
    [anon_sym_match_BANG] = ACTIONS(4005),
    [anon_sym_function] = ACTIONS(4007),
    [anon_sym_LT_DASH] = ACTIONS(4007),
    [anon_sym_DOT_LBRACK] = ACTIONS(4005),
    [anon_sym_LT] = ACTIONS(4005),
    [anon_sym_use] = ACTIONS(4007),
    [anon_sym_use_BANG] = ACTIONS(4005),
    [anon_sym_do_BANG] = ACTIONS(4005),
    [anon_sym_DOT_DOT] = ACTIONS(4005),
    [anon_sym_begin] = ACTIONS(4007),
    [anon_sym_LPAREN2] = ACTIONS(4007),
    [anon_sym_or] = ACTIONS(4007),
    [aux_sym_char_token1] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4007),
    [anon_sym_DQUOTE] = ACTIONS(4007),
    [anon_sym_AT_DQUOTE] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [sym_bool] = ACTIONS(4007),
    [sym_unit] = ACTIONS(4005),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4007),
    [sym_op_identifier] = ACTIONS(4007),
    [anon_sym_PLUS] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4007),
    [anon_sym_PLUS_DOT] = ACTIONS(4007),
    [anon_sym_DASH_DOT] = ACTIONS(4007),
    [anon_sym_PERCENT] = ACTIONS(4007),
    [anon_sym_AMP_AMP] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4005),
    [aux_sym_prefix_op_token1] = ACTIONS(4007),
    [aux_sym_infix_op_token1] = ACTIONS(4005),
    [aux_sym_infix_op_token2] = ACTIONS(4007),
    [anon_sym_PIPE_PIPE] = ACTIONS(4007),
    [anon_sym_BANG_EQ] = ACTIONS(4007),
    [anon_sym_COLON_EQ] = ACTIONS(4005),
    [anon_sym_DOLLAR] = ACTIONS(4007),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4007),
    [sym_int] = ACTIONS(4007),
    [sym_xint] = ACTIONS(4005),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4005),
    [sym__newline] = ACTIONS(4005),
  },
  [3132] = {
    [sym_block_comment] = STATE(3132),
    [sym_compiler_directive_decl] = STATE(3132),
    [sym_fsi_directive_decl] = STATE(3132),
    [sym_preproc_line] = STATE(3132),
    [sym_identifier] = ACTIONS(4162),
    [anon_sym_EQ] = ACTIONS(4160),
    [anon_sym_COLON] = ACTIONS(4162),
    [anon_sym_return] = ACTIONS(4162),
    [anon_sym_do] = ACTIONS(4162),
    [anon_sym_let] = ACTIONS(4162),
    [anon_sym_let_BANG] = ACTIONS(4160),
    [anon_sym_as] = ACTIONS(4162),
    [anon_sym_LPAREN] = ACTIONS(4162),
    [anon_sym_COMMA] = ACTIONS(4160),
    [anon_sym_null] = ACTIONS(4162),
    [anon_sym_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4160),
    [anon_sym_AMP] = ACTIONS(4162),
    [anon_sym_LBRACK] = ACTIONS(4162),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4160),
    [anon_sym_LBRACE] = ACTIONS(4162),
    [anon_sym_LT_AT] = ACTIONS(4162),
    [anon_sym_LT_AT_AT] = ACTIONS(4162),
    [anon_sym_DOT] = ACTIONS(4162),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4160),
    [anon_sym_new] = ACTIONS(4162),
    [anon_sym_with] = ACTIONS(4162),
    [anon_sym_return_BANG] = ACTIONS(4160),
    [anon_sym_yield] = ACTIONS(4162),
    [anon_sym_yield_BANG] = ACTIONS(4160),
    [anon_sym_lazy] = ACTIONS(4162),
    [anon_sym_assert] = ACTIONS(4162),
    [anon_sym_upcast] = ACTIONS(4162),
    [anon_sym_downcast] = ACTIONS(4162),
    [anon_sym_COLON_GT] = ACTIONS(4160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4160),
    [anon_sym_for] = ACTIONS(4162),
    [anon_sym_while] = ACTIONS(4162),
    [anon_sym_if] = ACTIONS(4162),
    [anon_sym_fun] = ACTIONS(4162),
    [anon_sym_try] = ACTIONS(4162),
    [anon_sym_match] = ACTIONS(4162),
    [anon_sym_match_BANG] = ACTIONS(4160),
    [anon_sym_function] = ACTIONS(4162),
    [anon_sym_LT_DASH] = ACTIONS(4162),
    [anon_sym_DOT_LBRACK] = ACTIONS(4160),
    [anon_sym_LT] = ACTIONS(4160),
    [anon_sym_use] = ACTIONS(4162),
    [anon_sym_use_BANG] = ACTIONS(4160),
    [anon_sym_do_BANG] = ACTIONS(4160),
    [anon_sym_begin] = ACTIONS(4162),
    [anon_sym_LPAREN2] = ACTIONS(4162),
    [anon_sym_or] = ACTIONS(4162),
    [aux_sym_char_token1] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4162),
    [anon_sym_DQUOTE] = ACTIONS(4162),
    [anon_sym_AT_DQUOTE] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [sym_bool] = ACTIONS(4162),
    [sym_unit] = ACTIONS(4160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4162),
    [sym_op_identifier] = ACTIONS(4162),
    [anon_sym_PLUS] = ACTIONS(4162),
    [anon_sym_DASH] = ACTIONS(4162),
    [anon_sym_PLUS_DOT] = ACTIONS(4162),
    [anon_sym_DASH_DOT] = ACTIONS(4162),
    [anon_sym_PERCENT] = ACTIONS(4162),
    [anon_sym_AMP_AMP] = ACTIONS(4162),
    [anon_sym_TILDE] = ACTIONS(4160),
    [aux_sym_prefix_op_token1] = ACTIONS(4162),
    [aux_sym_infix_op_token1] = ACTIONS(4160),
    [aux_sym_infix_op_token2] = ACTIONS(4162),
    [anon_sym_PIPE_PIPE] = ACTIONS(4162),
    [anon_sym_BANG_EQ] = ACTIONS(4162),
    [anon_sym_COLON_EQ] = ACTIONS(4160),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4162),
    [sym_int] = ACTIONS(4162),
    [sym_xint] = ACTIONS(4160),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4160),
    [sym__newline] = ACTIONS(4160),
  },
  [3133] = {
    [sym_block_comment] = STATE(3133),
    [sym_compiler_directive_decl] = STATE(3133),
    [sym_fsi_directive_decl] = STATE(3133),
    [sym_preproc_line] = STATE(3133),
    [sym_identifier] = ACTIONS(4108),
    [anon_sym_EQ] = ACTIONS(4106),
    [anon_sym_COLON] = ACTIONS(4108),
    [anon_sym_return] = ACTIONS(4108),
    [anon_sym_do] = ACTIONS(4108),
    [anon_sym_let] = ACTIONS(4108),
    [anon_sym_let_BANG] = ACTIONS(4106),
    [anon_sym_as] = ACTIONS(4108),
    [anon_sym_LPAREN] = ACTIONS(4108),
    [anon_sym_COMMA] = ACTIONS(4106),
    [anon_sym_null] = ACTIONS(4108),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_COLON] = ACTIONS(4106),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LBRACK] = ACTIONS(4108),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(4108),
    [anon_sym_LT_AT] = ACTIONS(4108),
    [anon_sym_LT_AT_AT] = ACTIONS(4108),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4106),
    [anon_sym_new] = ACTIONS(4108),
    [anon_sym_with] = ACTIONS(4108),
    [anon_sym_return_BANG] = ACTIONS(4106),
    [anon_sym_yield] = ACTIONS(4108),
    [anon_sym_yield_BANG] = ACTIONS(4106),
    [anon_sym_lazy] = ACTIONS(4108),
    [anon_sym_assert] = ACTIONS(4108),
    [anon_sym_upcast] = ACTIONS(4108),
    [anon_sym_downcast] = ACTIONS(4108),
    [anon_sym_COLON_GT] = ACTIONS(4106),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4106),
    [anon_sym_for] = ACTIONS(4108),
    [anon_sym_while] = ACTIONS(4108),
    [anon_sym_if] = ACTIONS(4108),
    [anon_sym_fun] = ACTIONS(4108),
    [anon_sym_try] = ACTIONS(4108),
    [anon_sym_match] = ACTIONS(4108),
    [anon_sym_match_BANG] = ACTIONS(4106),
    [anon_sym_function] = ACTIONS(4108),
    [anon_sym_LT_DASH] = ACTIONS(4108),
    [anon_sym_DOT_LBRACK] = ACTIONS(4106),
    [anon_sym_LT] = ACTIONS(4106),
    [anon_sym_use] = ACTIONS(4108),
    [anon_sym_use_BANG] = ACTIONS(4106),
    [anon_sym_do_BANG] = ACTIONS(4106),
    [anon_sym_begin] = ACTIONS(4108),
    [anon_sym_LPAREN2] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [aux_sym_char_token1] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4108),
    [anon_sym_DQUOTE] = ACTIONS(4108),
    [anon_sym_AT_DQUOTE] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [sym_bool] = ACTIONS(4108),
    [sym_unit] = ACTIONS(4106),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4108),
    [sym_op_identifier] = ACTIONS(4108),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_PLUS_DOT] = ACTIONS(4108),
    [anon_sym_DASH_DOT] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_AMP_AMP] = ACTIONS(4108),
    [anon_sym_TILDE] = ACTIONS(4106),
    [aux_sym_prefix_op_token1] = ACTIONS(4108),
    [aux_sym_infix_op_token1] = ACTIONS(4106),
    [aux_sym_infix_op_token2] = ACTIONS(4108),
    [anon_sym_PIPE_PIPE] = ACTIONS(4108),
    [anon_sym_BANG_EQ] = ACTIONS(4108),
    [anon_sym_COLON_EQ] = ACTIONS(4106),
    [anon_sym_DOLLAR] = ACTIONS(4108),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4108),
    [sym_int] = ACTIONS(4108),
    [sym_xint] = ACTIONS(4106),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4106),
    [sym__newline] = ACTIONS(4106),
  },
  [3134] = {
    [sym_attributes] = STATE(3960),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(5177),
    [sym__pattern] = STATE(5031),
    [sym_optional_pattern] = STATE(5177),
    [sym_type_check_pattern] = STATE(5177),
    [sym_attribute_pattern] = STATE(5177),
    [sym_paren_pattern] = STATE(5177),
    [sym_as_pattern] = STATE(5177),
    [sym_cons_pattern] = STATE(5177),
    [sym_disjunct_pattern] = STATE(5177),
    [sym_conjunct_pattern] = STATE(5177),
    [sym_typed_pattern] = STATE(5177),
    [sym_list_pattern] = STATE(5177),
    [sym_array_pattern] = STATE(5177),
    [sym_record_pattern] = STATE(5177),
    [sym_named_field_pattern] = STATE(5177),
    [sym_identifier_pattern] = STATE(5177),
    [sym_long_identifier_or_op] = STATE(3306),
    [sym_char] = STATE(5226),
    [sym_format_string] = STATE(5239),
    [sym__string_literal] = STATE(5239),
    [sym_string] = STATE(5226),
    [sym_verbatim_string] = STATE(5226),
    [sym_bytearray] = STATE(5226),
    [sym_verbatim_bytearray] = STATE(5226),
    [sym_format_triple_quoted_string] = STATE(5238),
    [sym_triple_quoted_string] = STATE(5226),
    [sym_const] = STATE(5177),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(5226),
    [sym_byte] = STATE(5226),
    [sym_int16] = STATE(5226),
    [sym_uint16] = STATE(5226),
    [sym_int32] = STATE(5226),
    [sym_uint32] = STATE(5226),
    [sym_nativeint] = STATE(5226),
    [sym_unativeint] = STATE(5226),
    [sym_int64] = STATE(5226),
    [sym_uint64] = STATE(5226),
    [sym_ieee32] = STATE(5226),
    [sym_ieee64] = STATE(5226),
    [sym_bignum] = STATE(5226),
    [sym_decimal] = STATE(5226),
    [sym_float] = STATE(4814),
    [sym_block_comment] = STATE(3134),
    [sym_compiler_directive_decl] = STATE(3134),
    [sym_fsi_directive_decl] = STATE(3134),
    [sym_preproc_line] = STATE(3134),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym_repeat_pattern_repeat1] = STATE(5058),
    [sym_identifier] = ACTIONS(5363),
    [anon_sym_LBRACK_LT] = ACTIONS(5365),
    [anon_sym_COLON] = ACTIONS(5363),
    [anon_sym_as] = ACTIONS(5653),
    [anon_sym_LPAREN] = ACTIONS(5363),
    [anon_sym_COMMA] = ACTIONS(5655),
    [anon_sym_null] = ACTIONS(5363),
    [anon_sym__] = ACTIONS(5363),
    [anon_sym_QMARK] = ACTIONS(5365),
    [anon_sym_COLON_QMARK] = ACTIONS(5365),
    [anon_sym_COLON_COLON] = ACTIONS(5661),
    [anon_sym_PIPE] = ACTIONS(5663),
    [anon_sym_AMP] = ACTIONS(5665),
    [anon_sym_LBRACK] = ACTIONS(5363),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5365),
    [anon_sym_LBRACE] = ACTIONS(5365),
    [anon_sym_DASH_GT] = ACTIONS(5365),
    [anon_sym_when] = ACTIONS(5363),
    [aux_sym_char_token1] = ACTIONS(5365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5363),
    [anon_sym_DQUOTE] = ACTIONS(5363),
    [anon_sym_AT_DQUOTE] = ACTIONS(5365),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5365),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5365),
    [sym_bool] = ACTIONS(5363),
    [sym_unit] = ACTIONS(5365),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5363),
    [sym_op_identifier] = ACTIONS(5365),
    [sym_int] = ACTIONS(5363),
    [sym_xint] = ACTIONS(5365),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3135] = {
    [sym_block_comment] = STATE(3135),
    [sym_compiler_directive_decl] = STATE(3135),
    [sym_fsi_directive_decl] = STATE(3135),
    [sym_preproc_line] = STATE(3135),
    [sym_identifier] = ACTIONS(4186),
    [anon_sym_EQ] = ACTIONS(4184),
    [anon_sym_COLON] = ACTIONS(4186),
    [anon_sym_return] = ACTIONS(4186),
    [anon_sym_do] = ACTIONS(4186),
    [anon_sym_let] = ACTIONS(4186),
    [anon_sym_let_BANG] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_COMMA] = ACTIONS(4184),
    [anon_sym_null] = ACTIONS(4186),
    [anon_sym_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_COLON] = ACTIONS(4184),
    [anon_sym_AMP] = ACTIONS(4186),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4184),
    [anon_sym_LBRACE] = ACTIONS(4186),
    [anon_sym_LT_AT] = ACTIONS(4186),
    [anon_sym_LT_AT_AT] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4186),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4184),
    [anon_sym_new] = ACTIONS(4186),
    [anon_sym_return_BANG] = ACTIONS(4184),
    [anon_sym_yield] = ACTIONS(4186),
    [anon_sym_yield_BANG] = ACTIONS(4184),
    [anon_sym_lazy] = ACTIONS(4186),
    [anon_sym_assert] = ACTIONS(4186),
    [anon_sym_upcast] = ACTIONS(4186),
    [anon_sym_downcast] = ACTIONS(4186),
    [anon_sym_COLON_GT] = ACTIONS(4184),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4184),
    [anon_sym_for] = ACTIONS(4186),
    [anon_sym_while] = ACTIONS(4186),
    [anon_sym_if] = ACTIONS(4186),
    [anon_sym_fun] = ACTIONS(4186),
    [anon_sym_DASH_GT] = ACTIONS(4186),
    [anon_sym_try] = ACTIONS(4186),
    [anon_sym_match] = ACTIONS(4186),
    [anon_sym_match_BANG] = ACTIONS(4184),
    [anon_sym_function] = ACTIONS(4186),
    [anon_sym_LT_DASH] = ACTIONS(4186),
    [anon_sym_DOT_LBRACK] = ACTIONS(4184),
    [anon_sym_LT] = ACTIONS(4184),
    [anon_sym_use] = ACTIONS(4186),
    [anon_sym_use_BANG] = ACTIONS(4184),
    [anon_sym_do_BANG] = ACTIONS(4184),
    [anon_sym_DOT_DOT] = ACTIONS(4184),
    [anon_sym_begin] = ACTIONS(4186),
    [anon_sym_LPAREN2] = ACTIONS(4186),
    [anon_sym_or] = ACTIONS(4186),
    [aux_sym_char_token1] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4186),
    [anon_sym_DQUOTE] = ACTIONS(4186),
    [anon_sym_AT_DQUOTE] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [sym_bool] = ACTIONS(4186),
    [sym_unit] = ACTIONS(4184),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4186),
    [sym_op_identifier] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4186),
    [anon_sym_DASH] = ACTIONS(4186),
    [anon_sym_PLUS_DOT] = ACTIONS(4186),
    [anon_sym_DASH_DOT] = ACTIONS(4186),
    [anon_sym_PERCENT] = ACTIONS(4186),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_TILDE] = ACTIONS(4184),
    [aux_sym_prefix_op_token1] = ACTIONS(4186),
    [aux_sym_infix_op_token1] = ACTIONS(4184),
    [aux_sym_infix_op_token2] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_COLON_EQ] = ACTIONS(4184),
    [anon_sym_DOLLAR] = ACTIONS(4186),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4186),
    [sym_int] = ACTIONS(4186),
    [sym_xint] = ACTIONS(4184),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4184),
    [sym__newline] = ACTIONS(4184),
  },
  [3136] = {
    [sym_block_comment] = STATE(3136),
    [sym_compiler_directive_decl] = STATE(3136),
    [sym_fsi_directive_decl] = STATE(3136),
    [sym_preproc_line] = STATE(3136),
    [sym_identifier] = ACTIONS(4158),
    [anon_sym_EQ] = ACTIONS(4156),
    [anon_sym_COLON] = ACTIONS(4158),
    [anon_sym_return] = ACTIONS(4158),
    [anon_sym_do] = ACTIONS(4158),
    [anon_sym_let] = ACTIONS(4158),
    [anon_sym_let_BANG] = ACTIONS(4156),
    [anon_sym_as] = ACTIONS(4158),
    [anon_sym_LPAREN] = ACTIONS(4158),
    [anon_sym_COMMA] = ACTIONS(4156),
    [anon_sym_null] = ACTIONS(4158),
    [anon_sym_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_COLON] = ACTIONS(4156),
    [anon_sym_AMP] = ACTIONS(4158),
    [anon_sym_LBRACK] = ACTIONS(4158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(4158),
    [anon_sym_LT_AT] = ACTIONS(4158),
    [anon_sym_LT_AT_AT] = ACTIONS(4158),
    [anon_sym_DOT] = ACTIONS(4158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4156),
    [anon_sym_new] = ACTIONS(4158),
    [anon_sym_with] = ACTIONS(4158),
    [anon_sym_return_BANG] = ACTIONS(4156),
    [anon_sym_yield] = ACTIONS(4158),
    [anon_sym_yield_BANG] = ACTIONS(4156),
    [anon_sym_lazy] = ACTIONS(4158),
    [anon_sym_assert] = ACTIONS(4158),
    [anon_sym_upcast] = ACTIONS(4158),
    [anon_sym_downcast] = ACTIONS(4158),
    [anon_sym_COLON_GT] = ACTIONS(4156),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4156),
    [anon_sym_for] = ACTIONS(4158),
    [anon_sym_while] = ACTIONS(4158),
    [anon_sym_if] = ACTIONS(4158),
    [anon_sym_fun] = ACTIONS(4158),
    [anon_sym_try] = ACTIONS(4158),
    [anon_sym_match] = ACTIONS(4158),
    [anon_sym_match_BANG] = ACTIONS(4156),
    [anon_sym_function] = ACTIONS(4158),
    [anon_sym_LT_DASH] = ACTIONS(4158),
    [anon_sym_DOT_LBRACK] = ACTIONS(4156),
    [anon_sym_LT] = ACTIONS(4156),
    [anon_sym_use] = ACTIONS(4158),
    [anon_sym_use_BANG] = ACTIONS(4156),
    [anon_sym_do_BANG] = ACTIONS(4156),
    [anon_sym_begin] = ACTIONS(4158),
    [anon_sym_LPAREN2] = ACTIONS(4158),
    [anon_sym_or] = ACTIONS(4158),
    [aux_sym_char_token1] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4158),
    [anon_sym_DQUOTE] = ACTIONS(4158),
    [anon_sym_AT_DQUOTE] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [sym_bool] = ACTIONS(4158),
    [sym_unit] = ACTIONS(4156),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4158),
    [sym_op_identifier] = ACTIONS(4158),
    [anon_sym_PLUS] = ACTIONS(4158),
    [anon_sym_DASH] = ACTIONS(4158),
    [anon_sym_PLUS_DOT] = ACTIONS(4158),
    [anon_sym_DASH_DOT] = ACTIONS(4158),
    [anon_sym_PERCENT] = ACTIONS(4158),
    [anon_sym_AMP_AMP] = ACTIONS(4158),
    [anon_sym_TILDE] = ACTIONS(4156),
    [aux_sym_prefix_op_token1] = ACTIONS(4158),
    [aux_sym_infix_op_token1] = ACTIONS(4156),
    [aux_sym_infix_op_token2] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE] = ACTIONS(4158),
    [anon_sym_BANG_EQ] = ACTIONS(4158),
    [anon_sym_COLON_EQ] = ACTIONS(4156),
    [anon_sym_DOLLAR] = ACTIONS(4158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4158),
    [sym_int] = ACTIONS(4158),
    [sym_xint] = ACTIONS(4156),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4156),
    [sym__newline] = ACTIONS(4156),
  },
  [3137] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(2919),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3137),
    [sym_compiler_directive_decl] = STATE(3137),
    [sym_fsi_directive_decl] = STATE(3137),
    [sym_preproc_line] = STATE(3137),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(5562),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_COLON] = ACTIONS(5558),
    [anon_sym_as] = ACTIONS(5558),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_RPAREN] = ACTIONS(5562),
    [anon_sym_COMMA] = ACTIONS(5562),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_COLON_COLON] = ACTIONS(5562),
    [anon_sym_PIPE] = ACTIONS(5562),
    [anon_sym_AMP] = ACTIONS(5562),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [anon_sym_LT2] = ACTIONS(5562),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3138] = {
    [sym_block_comment] = STATE(3138),
    [sym_compiler_directive_decl] = STATE(3138),
    [sym_fsi_directive_decl] = STATE(3138),
    [sym_preproc_line] = STATE(3138),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3487),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [anon_sym_EQ2] = ACTIONS(3485),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [3139] = {
    [sym_block_comment] = STATE(3139),
    [sym_compiler_directive_decl] = STATE(3139),
    [sym_fsi_directive_decl] = STATE(3139),
    [sym_preproc_line] = STATE(3139),
    [sym_identifier] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(4091),
    [anon_sym_COLON] = ACTIONS(4093),
    [anon_sym_return] = ACTIONS(4093),
    [anon_sym_do] = ACTIONS(4093),
    [anon_sym_let] = ACTIONS(4093),
    [anon_sym_let_BANG] = ACTIONS(4091),
    [anon_sym_as] = ACTIONS(4093),
    [anon_sym_LPAREN] = ACTIONS(4093),
    [anon_sym_COMMA] = ACTIONS(4091),
    [anon_sym_null] = ACTIONS(4093),
    [anon_sym_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_COLON] = ACTIONS(4091),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(4093),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4091),
    [anon_sym_LBRACE] = ACTIONS(4093),
    [anon_sym_LT_AT] = ACTIONS(4093),
    [anon_sym_LT_AT_AT] = ACTIONS(4093),
    [anon_sym_DOT] = ACTIONS(4093),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4091),
    [anon_sym_new] = ACTIONS(4093),
    [anon_sym_with] = ACTIONS(4093),
    [anon_sym_return_BANG] = ACTIONS(4091),
    [anon_sym_yield] = ACTIONS(4093),
    [anon_sym_yield_BANG] = ACTIONS(4091),
    [anon_sym_lazy] = ACTIONS(4093),
    [anon_sym_assert] = ACTIONS(4093),
    [anon_sym_upcast] = ACTIONS(4093),
    [anon_sym_downcast] = ACTIONS(4093),
    [anon_sym_COLON_GT] = ACTIONS(4091),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4091),
    [anon_sym_for] = ACTIONS(4093),
    [anon_sym_while] = ACTIONS(4093),
    [anon_sym_if] = ACTIONS(4093),
    [anon_sym_fun] = ACTIONS(4093),
    [anon_sym_try] = ACTIONS(4093),
    [anon_sym_match] = ACTIONS(4093),
    [anon_sym_match_BANG] = ACTIONS(4091),
    [anon_sym_function] = ACTIONS(4093),
    [anon_sym_LT_DASH] = ACTIONS(4093),
    [anon_sym_DOT_LBRACK] = ACTIONS(4091),
    [anon_sym_LT] = ACTIONS(4091),
    [anon_sym_use] = ACTIONS(4093),
    [anon_sym_use_BANG] = ACTIONS(4091),
    [anon_sym_do_BANG] = ACTIONS(4091),
    [anon_sym_begin] = ACTIONS(4093),
    [anon_sym_LPAREN2] = ACTIONS(4093),
    [anon_sym_or] = ACTIONS(4093),
    [aux_sym_char_token1] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4093),
    [anon_sym_DQUOTE] = ACTIONS(4093),
    [anon_sym_AT_DQUOTE] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [sym_bool] = ACTIONS(4093),
    [sym_unit] = ACTIONS(4091),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4093),
    [sym_op_identifier] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS_DOT] = ACTIONS(4093),
    [anon_sym_DASH_DOT] = ACTIONS(4093),
    [anon_sym_PERCENT] = ACTIONS(4093),
    [anon_sym_AMP_AMP] = ACTIONS(4093),
    [anon_sym_TILDE] = ACTIONS(4091),
    [aux_sym_prefix_op_token1] = ACTIONS(4093),
    [aux_sym_infix_op_token1] = ACTIONS(4091),
    [aux_sym_infix_op_token2] = ACTIONS(4093),
    [anon_sym_PIPE_PIPE] = ACTIONS(4093),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_COLON_EQ] = ACTIONS(4091),
    [anon_sym_DOLLAR] = ACTIONS(4093),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4093),
    [sym_int] = ACTIONS(4093),
    [sym_xint] = ACTIONS(4091),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4091),
    [sym__newline] = ACTIONS(4091),
  },
  [3140] = {
    [sym_block_comment] = STATE(3140),
    [sym_compiler_directive_decl] = STATE(3140),
    [sym_fsi_directive_decl] = STATE(3140),
    [sym_preproc_line] = STATE(3140),
    [aux_sym_sequential_expression_repeat1] = STATE(3197),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_COLON] = ACTIONS(3759),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_let_BANG] = ACTIONS(3757),
    [anon_sym_LPAREN] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3757),
    [anon_sym_null] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3757),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_LT_AT] = ACTIONS(3759),
    [anon_sym_AT_GT] = ACTIONS(3759),
    [anon_sym_LT_AT_AT] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(3759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_return_BANG] = ACTIONS(3757),
    [anon_sym_yield] = ACTIONS(3759),
    [anon_sym_yield_BANG] = ACTIONS(3757),
    [anon_sym_lazy] = ACTIONS(3759),
    [anon_sym_assert] = ACTIONS(3759),
    [anon_sym_upcast] = ACTIONS(3759),
    [anon_sym_downcast] = ACTIONS(3759),
    [anon_sym_COLON_GT] = ACTIONS(3757),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3757),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_fun] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_match] = ACTIONS(3759),
    [anon_sym_match_BANG] = ACTIONS(3757),
    [anon_sym_function] = ACTIONS(3759),
    [anon_sym_LT_DASH] = ACTIONS(3759),
    [anon_sym_DOT_LBRACK] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_use] = ACTIONS(3759),
    [anon_sym_use_BANG] = ACTIONS(3757),
    [anon_sym_do_BANG] = ACTIONS(3757),
    [anon_sym_begin] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_or] = ACTIONS(3759),
    [aux_sym_char_token1] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3759),
    [anon_sym_DQUOTE] = ACTIONS(3759),
    [anon_sym_AT_DQUOTE] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [sym_bool] = ACTIONS(3759),
    [sym_unit] = ACTIONS(3757),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3759),
    [sym_op_identifier] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS_DOT] = ACTIONS(3759),
    [anon_sym_DASH_DOT] = ACTIONS(3759),
    [anon_sym_PERCENT] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_TILDE] = ACTIONS(3757),
    [aux_sym_prefix_op_token1] = ACTIONS(3759),
    [aux_sym_infix_op_token1] = ACTIONS(3757),
    [aux_sym_infix_op_token2] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_COLON_EQ] = ACTIONS(3757),
    [anon_sym_DOLLAR] = ACTIONS(3759),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3759),
    [sym_int] = ACTIONS(3759),
    [sym_xint] = ACTIONS(3757),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3757),
    [sym__newline] = ACTIONS(3757),
  },
  [3141] = {
    [sym_block_comment] = STATE(3141),
    [sym_compiler_directive_decl] = STATE(3141),
    [sym_fsi_directive_decl] = STATE(3141),
    [sym_preproc_line] = STATE(3141),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_COLON] = ACTIONS(3867),
    [anon_sym_return] = ACTIONS(3867),
    [anon_sym_do] = ACTIONS(3867),
    [anon_sym_let] = ACTIONS(3867),
    [anon_sym_let_BANG] = ACTIONS(3865),
    [anon_sym_as] = ACTIONS(3867),
    [anon_sym_LPAREN] = ACTIONS(3867),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_null] = ACTIONS(3867),
    [anon_sym_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_COLON] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3867),
    [anon_sym_LBRACK] = ACTIONS(3867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3867),
    [anon_sym_LT_AT] = ACTIONS(3867),
    [anon_sym_LT_AT_AT] = ACTIONS(3867),
    [anon_sym_DOT] = ACTIONS(3867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3867),
    [anon_sym_with] = ACTIONS(3867),
    [anon_sym_return_BANG] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3867),
    [anon_sym_yield_BANG] = ACTIONS(3865),
    [anon_sym_lazy] = ACTIONS(3867),
    [anon_sym_assert] = ACTIONS(3867),
    [anon_sym_upcast] = ACTIONS(3867),
    [anon_sym_downcast] = ACTIONS(3867),
    [anon_sym_COLON_GT] = ACTIONS(3865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3867),
    [anon_sym_while] = ACTIONS(3867),
    [anon_sym_if] = ACTIONS(3867),
    [anon_sym_fun] = ACTIONS(3867),
    [anon_sym_try] = ACTIONS(3867),
    [anon_sym_match] = ACTIONS(3867),
    [anon_sym_match_BANG] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(3867),
    [anon_sym_DOT_LBRACK] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_use] = ACTIONS(3867),
    [anon_sym_use_BANG] = ACTIONS(3865),
    [anon_sym_do_BANG] = ACTIONS(3865),
    [anon_sym_begin] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(3867),
    [anon_sym_or] = ACTIONS(3867),
    [aux_sym_char_token1] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3867),
    [anon_sym_DQUOTE] = ACTIONS(3867),
    [anon_sym_AT_DQUOTE] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [sym_bool] = ACTIONS(3867),
    [sym_unit] = ACTIONS(3865),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3867),
    [sym_op_identifier] = ACTIONS(3867),
    [anon_sym_PLUS] = ACTIONS(3867),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_PLUS_DOT] = ACTIONS(3867),
    [anon_sym_DASH_DOT] = ACTIONS(3867),
    [anon_sym_PERCENT] = ACTIONS(3867),
    [anon_sym_AMP_AMP] = ACTIONS(3867),
    [anon_sym_TILDE] = ACTIONS(3865),
    [aux_sym_prefix_op_token1] = ACTIONS(3867),
    [aux_sym_infix_op_token1] = ACTIONS(3865),
    [aux_sym_infix_op_token2] = ACTIONS(3867),
    [anon_sym_PIPE_PIPE] = ACTIONS(3867),
    [anon_sym_BANG_EQ] = ACTIONS(3867),
    [anon_sym_COLON_EQ] = ACTIONS(3865),
    [anon_sym_DOLLAR] = ACTIONS(3867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3867),
    [sym_int] = ACTIONS(3867),
    [sym_xint] = ACTIONS(3865),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3865),
    [sym__newline] = ACTIONS(3865),
  },
  [3142] = {
    [sym_block_comment] = STATE(3142),
    [sym_compiler_directive_decl] = STATE(3142),
    [sym_fsi_directive_decl] = STATE(3142),
    [sym_preproc_line] = STATE(3142),
    [aux_sym_sequential_expression_repeat1] = STATE(3198),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_COLON] = ACTIONS(3759),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_let_BANG] = ACTIONS(3757),
    [anon_sym_LPAREN] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3757),
    [anon_sym_null] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_QMARK] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3757),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_LT_AT] = ACTIONS(3759),
    [anon_sym_LT_AT_AT] = ACTIONS(3759),
    [anon_sym_DOT] = ACTIONS(3759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_return_BANG] = ACTIONS(3757),
    [anon_sym_yield] = ACTIONS(3759),
    [anon_sym_yield_BANG] = ACTIONS(3757),
    [anon_sym_lazy] = ACTIONS(3759),
    [anon_sym_assert] = ACTIONS(3759),
    [anon_sym_upcast] = ACTIONS(3759),
    [anon_sym_downcast] = ACTIONS(3759),
    [anon_sym_COLON_GT] = ACTIONS(3757),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3757),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_fun] = ACTIONS(3759),
    [anon_sym_DASH_GT] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_match] = ACTIONS(3759),
    [anon_sym_match_BANG] = ACTIONS(3757),
    [anon_sym_function] = ACTIONS(3759),
    [anon_sym_LT_DASH] = ACTIONS(3759),
    [anon_sym_DOT_LBRACK] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_use] = ACTIONS(3759),
    [anon_sym_use_BANG] = ACTIONS(3757),
    [anon_sym_do_BANG] = ACTIONS(3757),
    [anon_sym_begin] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3759),
    [anon_sym_or] = ACTIONS(3759),
    [aux_sym_char_token1] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3759),
    [anon_sym_DQUOTE] = ACTIONS(3759),
    [anon_sym_AT_DQUOTE] = ACTIONS(3757),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3757),
    [sym_bool] = ACTIONS(3759),
    [sym_unit] = ACTIONS(3757),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3759),
    [sym_op_identifier] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS_DOT] = ACTIONS(3759),
    [anon_sym_DASH_DOT] = ACTIONS(3759),
    [anon_sym_PERCENT] = ACTIONS(3759),
    [anon_sym_AMP_AMP] = ACTIONS(3759),
    [anon_sym_TILDE] = ACTIONS(3757),
    [aux_sym_prefix_op_token1] = ACTIONS(3759),
    [aux_sym_infix_op_token1] = ACTIONS(3757),
    [aux_sym_infix_op_token2] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3759),
    [anon_sym_BANG_EQ] = ACTIONS(3759),
    [anon_sym_COLON_EQ] = ACTIONS(3757),
    [anon_sym_DOLLAR] = ACTIONS(3759),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3759),
    [sym_int] = ACTIONS(3759),
    [sym_xint] = ACTIONS(3757),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3757),
    [sym__newline] = ACTIONS(3757),
  },
  [3143] = {
    [sym_block_comment] = STATE(3143),
    [sym_compiler_directive_decl] = STATE(3143),
    [sym_fsi_directive_decl] = STATE(3143),
    [sym_preproc_line] = STATE(3143),
    [sym_identifier] = ACTIONS(4086),
    [anon_sym_EQ] = ACTIONS(4084),
    [anon_sym_COLON] = ACTIONS(4086),
    [anon_sym_return] = ACTIONS(4086),
    [anon_sym_do] = ACTIONS(4086),
    [anon_sym_let] = ACTIONS(4086),
    [anon_sym_let_BANG] = ACTIONS(4084),
    [anon_sym_as] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_COMMA] = ACTIONS(4084),
    [anon_sym_null] = ACTIONS(4086),
    [anon_sym_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_COLON] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4084),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_LT_AT] = ACTIONS(4086),
    [anon_sym_LT_AT_AT] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4086),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4084),
    [anon_sym_new] = ACTIONS(4086),
    [anon_sym_with] = ACTIONS(4086),
    [anon_sym_return_BANG] = ACTIONS(4084),
    [anon_sym_yield] = ACTIONS(4086),
    [anon_sym_yield_BANG] = ACTIONS(4084),
    [anon_sym_lazy] = ACTIONS(4086),
    [anon_sym_assert] = ACTIONS(4086),
    [anon_sym_upcast] = ACTIONS(4086),
    [anon_sym_downcast] = ACTIONS(4086),
    [anon_sym_COLON_GT] = ACTIONS(4084),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4084),
    [anon_sym_for] = ACTIONS(4086),
    [anon_sym_while] = ACTIONS(4086),
    [anon_sym_if] = ACTIONS(4086),
    [anon_sym_fun] = ACTIONS(4086),
    [anon_sym_try] = ACTIONS(4086),
    [anon_sym_match] = ACTIONS(4086),
    [anon_sym_match_BANG] = ACTIONS(4084),
    [anon_sym_function] = ACTIONS(4086),
    [anon_sym_LT_DASH] = ACTIONS(4086),
    [anon_sym_DOT_LBRACK] = ACTIONS(4084),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_use] = ACTIONS(4086),
    [anon_sym_use_BANG] = ACTIONS(4084),
    [anon_sym_do_BANG] = ACTIONS(4084),
    [anon_sym_begin] = ACTIONS(4086),
    [anon_sym_LPAREN2] = ACTIONS(4086),
    [anon_sym_or] = ACTIONS(4086),
    [aux_sym_char_token1] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4086),
    [anon_sym_DQUOTE] = ACTIONS(4086),
    [anon_sym_AT_DQUOTE] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [sym_bool] = ACTIONS(4086),
    [sym_unit] = ACTIONS(4084),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4086),
    [sym_op_identifier] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4086),
    [anon_sym_DASH] = ACTIONS(4086),
    [anon_sym_PLUS_DOT] = ACTIONS(4086),
    [anon_sym_DASH_DOT] = ACTIONS(4086),
    [anon_sym_PERCENT] = ACTIONS(4086),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_TILDE] = ACTIONS(4084),
    [aux_sym_prefix_op_token1] = ACTIONS(4086),
    [aux_sym_infix_op_token1] = ACTIONS(4084),
    [aux_sym_infix_op_token2] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_COLON_EQ] = ACTIONS(4084),
    [anon_sym_DOLLAR] = ACTIONS(4086),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4086),
    [sym_int] = ACTIONS(4086),
    [sym_xint] = ACTIONS(4084),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4084),
    [sym__newline] = ACTIONS(4084),
  },
  [3144] = {
    [sym_block_comment] = STATE(3144),
    [sym_compiler_directive_decl] = STATE(3144),
    [sym_fsi_directive_decl] = STATE(3144),
    [sym_preproc_line] = STATE(3144),
    [sym_identifier] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3919),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_return] = ACTIONS(3921),
    [anon_sym_do] = ACTIONS(3921),
    [anon_sym_let] = ACTIONS(3921),
    [anon_sym_let_BANG] = ACTIONS(3919),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3919),
    [anon_sym_null] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_COLON] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3919),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_LT_AT] = ACTIONS(3921),
    [anon_sym_LT_AT_AT] = ACTIONS(3921),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3919),
    [anon_sym_new] = ACTIONS(3921),
    [anon_sym_return_BANG] = ACTIONS(3919),
    [anon_sym_yield] = ACTIONS(3921),
    [anon_sym_yield_BANG] = ACTIONS(3919),
    [anon_sym_lazy] = ACTIONS(3921),
    [anon_sym_assert] = ACTIONS(3921),
    [anon_sym_upcast] = ACTIONS(3921),
    [anon_sym_downcast] = ACTIONS(3921),
    [anon_sym_COLON_GT] = ACTIONS(3919),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3919),
    [anon_sym_for] = ACTIONS(3921),
    [anon_sym_while] = ACTIONS(3921),
    [anon_sym_if] = ACTIONS(3921),
    [anon_sym_fun] = ACTIONS(3921),
    [anon_sym_DASH_GT] = ACTIONS(3921),
    [anon_sym_try] = ACTIONS(3921),
    [anon_sym_match] = ACTIONS(3921),
    [anon_sym_match_BANG] = ACTIONS(3919),
    [anon_sym_function] = ACTIONS(3921),
    [anon_sym_LT_DASH] = ACTIONS(3921),
    [anon_sym_DOT_LBRACK] = ACTIONS(3919),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_use] = ACTIONS(3921),
    [anon_sym_use_BANG] = ACTIONS(3919),
    [anon_sym_do_BANG] = ACTIONS(3919),
    [anon_sym_DOT_DOT] = ACTIONS(3919),
    [anon_sym_begin] = ACTIONS(3921),
    [anon_sym_LPAREN2] = ACTIONS(3921),
    [anon_sym_or] = ACTIONS(3921),
    [aux_sym_char_token1] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_AT_DQUOTE] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [sym_bool] = ACTIONS(3921),
    [sym_unit] = ACTIONS(3919),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3921),
    [sym_op_identifier] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_DOT] = ACTIONS(3921),
    [anon_sym_DASH_DOT] = ACTIONS(3921),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3919),
    [aux_sym_prefix_op_token1] = ACTIONS(3921),
    [aux_sym_infix_op_token1] = ACTIONS(3919),
    [aux_sym_infix_op_token2] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_COLON_EQ] = ACTIONS(3919),
    [anon_sym_DOLLAR] = ACTIONS(3921),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3921),
    [sym_int] = ACTIONS(3921),
    [sym_xint] = ACTIONS(3919),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3919),
    [sym__newline] = ACTIONS(3919),
  },
  [3145] = {
    [sym_block_comment] = STATE(3145),
    [sym_compiler_directive_decl] = STATE(3145),
    [sym_fsi_directive_decl] = STATE(3145),
    [sym_preproc_line] = STATE(3145),
    [sym_identifier] = ACTIONS(3881),
    [anon_sym_EQ] = ACTIONS(3879),
    [anon_sym_COLON] = ACTIONS(3881),
    [anon_sym_return] = ACTIONS(3881),
    [anon_sym_do] = ACTIONS(3881),
    [anon_sym_let] = ACTIONS(3881),
    [anon_sym_let_BANG] = ACTIONS(3879),
    [anon_sym_as] = ACTIONS(3881),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3879),
    [anon_sym_null] = ACTIONS(3881),
    [anon_sym_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3879),
    [anon_sym_LBRACE] = ACTIONS(3881),
    [anon_sym_LT_AT] = ACTIONS(3881),
    [anon_sym_LT_AT_AT] = ACTIONS(3881),
    [anon_sym_DOT] = ACTIONS(3881),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3879),
    [anon_sym_new] = ACTIONS(3881),
    [anon_sym_with] = ACTIONS(3881),
    [anon_sym_return_BANG] = ACTIONS(3879),
    [anon_sym_yield] = ACTIONS(3881),
    [anon_sym_yield_BANG] = ACTIONS(3879),
    [anon_sym_lazy] = ACTIONS(3881),
    [anon_sym_assert] = ACTIONS(3881),
    [anon_sym_upcast] = ACTIONS(3881),
    [anon_sym_downcast] = ACTIONS(3881),
    [anon_sym_COLON_GT] = ACTIONS(3879),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3879),
    [anon_sym_for] = ACTIONS(3881),
    [anon_sym_while] = ACTIONS(3881),
    [anon_sym_if] = ACTIONS(3881),
    [anon_sym_fun] = ACTIONS(3881),
    [anon_sym_try] = ACTIONS(3881),
    [anon_sym_match] = ACTIONS(3881),
    [anon_sym_match_BANG] = ACTIONS(3879),
    [anon_sym_function] = ACTIONS(3881),
    [anon_sym_LT_DASH] = ACTIONS(3881),
    [anon_sym_DOT_LBRACK] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_use] = ACTIONS(3881),
    [anon_sym_use_BANG] = ACTIONS(3879),
    [anon_sym_do_BANG] = ACTIONS(3879),
    [anon_sym_begin] = ACTIONS(3881),
    [anon_sym_LPAREN2] = ACTIONS(3881),
    [anon_sym_or] = ACTIONS(3881),
    [aux_sym_char_token1] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3881),
    [anon_sym_DQUOTE] = ACTIONS(3881),
    [anon_sym_AT_DQUOTE] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [sym_bool] = ACTIONS(3881),
    [sym_unit] = ACTIONS(3879),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3881),
    [sym_op_identifier] = ACTIONS(3881),
    [anon_sym_PLUS] = ACTIONS(3881),
    [anon_sym_DASH] = ACTIONS(3881),
    [anon_sym_PLUS_DOT] = ACTIONS(3881),
    [anon_sym_DASH_DOT] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(3881),
    [anon_sym_AMP_AMP] = ACTIONS(3881),
    [anon_sym_TILDE] = ACTIONS(3879),
    [aux_sym_prefix_op_token1] = ACTIONS(3881),
    [aux_sym_infix_op_token1] = ACTIONS(3879),
    [aux_sym_infix_op_token2] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE] = ACTIONS(3881),
    [anon_sym_BANG_EQ] = ACTIONS(3881),
    [anon_sym_COLON_EQ] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3881),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3881),
    [sym_int] = ACTIONS(3881),
    [sym_xint] = ACTIONS(3879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3879),
    [sym__newline] = ACTIONS(3879),
  },
  [3146] = {
    [sym_block_comment] = STATE(3146),
    [sym_compiler_directive_decl] = STATE(3146),
    [sym_fsi_directive_decl] = STATE(3146),
    [sym_preproc_line] = STATE(3146),
    [sym_identifier] = ACTIONS(3800),
    [anon_sym_EQ] = ACTIONS(3798),
    [anon_sym_COLON] = ACTIONS(3800),
    [anon_sym_return] = ACTIONS(3800),
    [anon_sym_do] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_let_BANG] = ACTIONS(3798),
    [anon_sym_LPAREN] = ACTIONS(3800),
    [anon_sym_COMMA] = ACTIONS(3798),
    [anon_sym_null] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_COLON] = ACTIONS(3798),
    [anon_sym_PIPE] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3800),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3798),
    [anon_sym_LBRACE] = ACTIONS(3800),
    [anon_sym_LT_AT] = ACTIONS(3800),
    [anon_sym_AT_GT] = ACTIONS(3800),
    [anon_sym_LT_AT_AT] = ACTIONS(3800),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3798),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_return_BANG] = ACTIONS(3798),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_yield_BANG] = ACTIONS(3798),
    [anon_sym_lazy] = ACTIONS(3800),
    [anon_sym_assert] = ACTIONS(3800),
    [anon_sym_upcast] = ACTIONS(3800),
    [anon_sym_downcast] = ACTIONS(3800),
    [anon_sym_COLON_GT] = ACTIONS(3798),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3798),
    [anon_sym_for] = ACTIONS(3800),
    [anon_sym_while] = ACTIONS(3800),
    [anon_sym_if] = ACTIONS(3800),
    [anon_sym_fun] = ACTIONS(3800),
    [anon_sym_try] = ACTIONS(3800),
    [anon_sym_match] = ACTIONS(3800),
    [anon_sym_match_BANG] = ACTIONS(3798),
    [anon_sym_function] = ACTIONS(3800),
    [anon_sym_LT_DASH] = ACTIONS(3800),
    [anon_sym_DOT_LBRACK] = ACTIONS(3798),
    [anon_sym_LT] = ACTIONS(3798),
    [anon_sym_use] = ACTIONS(3800),
    [anon_sym_use_BANG] = ACTIONS(3798),
    [anon_sym_do_BANG] = ACTIONS(3798),
    [anon_sym_begin] = ACTIONS(3800),
    [anon_sym_LPAREN2] = ACTIONS(3800),
    [anon_sym_or] = ACTIONS(3800),
    [aux_sym_char_token1] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3800),
    [anon_sym_DQUOTE] = ACTIONS(3800),
    [anon_sym_AT_DQUOTE] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [sym_bool] = ACTIONS(3800),
    [sym_unit] = ACTIONS(3798),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3800),
    [sym_op_identifier] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS_DOT] = ACTIONS(3800),
    [anon_sym_DASH_DOT] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3800),
    [anon_sym_AMP_AMP] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3798),
    [aux_sym_prefix_op_token1] = ACTIONS(3800),
    [aux_sym_infix_op_token1] = ACTIONS(3798),
    [aux_sym_infix_op_token2] = ACTIONS(3800),
    [anon_sym_PIPE_PIPE] = ACTIONS(3800),
    [anon_sym_BANG_EQ] = ACTIONS(3800),
    [anon_sym_COLON_EQ] = ACTIONS(3798),
    [anon_sym_DOLLAR] = ACTIONS(3800),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3800),
    [sym_int] = ACTIONS(3800),
    [sym_xint] = ACTIONS(3798),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3798),
    [sym__newline] = ACTIONS(3798),
  },
  [3147] = {
    [sym_block_comment] = STATE(3147),
    [sym_compiler_directive_decl] = STATE(3147),
    [sym_fsi_directive_decl] = STATE(3147),
    [sym_preproc_line] = STATE(3147),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_AT_GT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_or] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [sym__newline] = ACTIONS(3741),
  },
  [3148] = {
    [sym_block_comment] = STATE(3148),
    [sym_compiler_directive_decl] = STATE(3148),
    [sym_fsi_directive_decl] = STATE(3148),
    [sym_preproc_line] = STATE(3148),
    [aux_sym_long_identifier_repeat1] = STATE(3148),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_AT_AT_GT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(5761),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [3149] = {
    [sym_block_comment] = STATE(3149),
    [sym_compiler_directive_decl] = STATE(3149),
    [sym_fsi_directive_decl] = STATE(3149),
    [sym_preproc_line] = STATE(3149),
    [sym_identifier] = ACTIONS(3841),
    [anon_sym_EQ] = ACTIONS(3839),
    [anon_sym_COLON] = ACTIONS(3841),
    [anon_sym_return] = ACTIONS(3841),
    [anon_sym_do] = ACTIONS(3841),
    [anon_sym_let] = ACTIONS(3841),
    [anon_sym_let_BANG] = ACTIONS(3839),
    [anon_sym_LPAREN] = ACTIONS(3841),
    [anon_sym_COMMA] = ACTIONS(3839),
    [anon_sym_null] = ACTIONS(3841),
    [anon_sym_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_COLON] = ACTIONS(3839),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_AMP] = ACTIONS(3841),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(3841),
    [anon_sym_LT_AT] = ACTIONS(3841),
    [anon_sym_LT_AT_AT] = ACTIONS(3841),
    [anon_sym_DOT] = ACTIONS(3841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3839),
    [anon_sym_new] = ACTIONS(3841),
    [anon_sym_return_BANG] = ACTIONS(3839),
    [anon_sym_yield] = ACTIONS(3841),
    [anon_sym_yield_BANG] = ACTIONS(3839),
    [anon_sym_lazy] = ACTIONS(3841),
    [anon_sym_assert] = ACTIONS(3841),
    [anon_sym_upcast] = ACTIONS(3841),
    [anon_sym_downcast] = ACTIONS(3841),
    [anon_sym_COLON_GT] = ACTIONS(3839),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3839),
    [anon_sym_for] = ACTIONS(3841),
    [anon_sym_while] = ACTIONS(3841),
    [anon_sym_if] = ACTIONS(3841),
    [anon_sym_fun] = ACTIONS(3841),
    [anon_sym_try] = ACTIONS(3841),
    [anon_sym_match] = ACTIONS(3841),
    [anon_sym_match_BANG] = ACTIONS(3839),
    [anon_sym_function] = ACTIONS(3841),
    [anon_sym_LT_DASH] = ACTIONS(3841),
    [anon_sym_DOT_LBRACK] = ACTIONS(3839),
    [anon_sym_LT] = ACTIONS(3839),
    [anon_sym_use] = ACTIONS(3841),
    [anon_sym_use_BANG] = ACTIONS(3839),
    [anon_sym_do_BANG] = ACTIONS(3839),
    [anon_sym_DOT_DOT] = ACTIONS(3839),
    [anon_sym_begin] = ACTIONS(3841),
    [anon_sym_LPAREN2] = ACTIONS(3841),
    [anon_sym_or] = ACTIONS(3841),
    [aux_sym_char_token1] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3841),
    [anon_sym_DQUOTE] = ACTIONS(3841),
    [anon_sym_AT_DQUOTE] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [sym_bool] = ACTIONS(3841),
    [sym_unit] = ACTIONS(3839),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3841),
    [sym_op_identifier] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_PLUS_DOT] = ACTIONS(3841),
    [anon_sym_DASH_DOT] = ACTIONS(3841),
    [anon_sym_PERCENT] = ACTIONS(3841),
    [anon_sym_AMP_AMP] = ACTIONS(3841),
    [anon_sym_TILDE] = ACTIONS(3839),
    [aux_sym_prefix_op_token1] = ACTIONS(3841),
    [aux_sym_infix_op_token1] = ACTIONS(3839),
    [aux_sym_infix_op_token2] = ACTIONS(3841),
    [anon_sym_PIPE_PIPE] = ACTIONS(3841),
    [anon_sym_BANG_EQ] = ACTIONS(3841),
    [anon_sym_COLON_EQ] = ACTIONS(3839),
    [anon_sym_DOLLAR] = ACTIONS(3841),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3841),
    [sym_int] = ACTIONS(3841),
    [sym_xint] = ACTIONS(3839),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3839),
    [sym__newline] = ACTIONS(3839),
  },
  [3150] = {
    [sym_block_comment] = STATE(3150),
    [sym_compiler_directive_decl] = STATE(3150),
    [sym_fsi_directive_decl] = STATE(3150),
    [sym_preproc_line] = STATE(3150),
    [sym_identifier] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3774),
    [anon_sym_do] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3774),
    [anon_sym_let_BANG] = ACTIONS(3772),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3772),
    [anon_sym_null] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_COLON] = ACTIONS(3772),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_LT_AT] = ACTIONS(3774),
    [anon_sym_LT_AT_AT] = ACTIONS(3774),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3772),
    [anon_sym_new] = ACTIONS(3774),
    [anon_sym_return_BANG] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3774),
    [anon_sym_yield_BANG] = ACTIONS(3772),
    [anon_sym_lazy] = ACTIONS(3774),
    [anon_sym_assert] = ACTIONS(3774),
    [anon_sym_upcast] = ACTIONS(3774),
    [anon_sym_downcast] = ACTIONS(3774),
    [anon_sym_COLON_GT] = ACTIONS(3772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3774),
    [anon_sym_done] = ACTIONS(5764),
    [anon_sym_while] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3774),
    [anon_sym_fun] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3774),
    [anon_sym_match] = ACTIONS(3774),
    [anon_sym_match_BANG] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3774),
    [anon_sym_LT_DASH] = ACTIONS(3774),
    [anon_sym_DOT_LBRACK] = ACTIONS(3772),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_use] = ACTIONS(3774),
    [anon_sym_use_BANG] = ACTIONS(3772),
    [anon_sym_do_BANG] = ACTIONS(3772),
    [anon_sym_DOT_DOT] = ACTIONS(3772),
    [anon_sym_begin] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3774),
    [anon_sym_or] = ACTIONS(3774),
    [aux_sym_char_token1] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_AT_DQUOTE] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [sym_bool] = ACTIONS(3774),
    [sym_unit] = ACTIONS(3772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3774),
    [sym_op_identifier] = ACTIONS(3774),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_DOT] = ACTIONS(3774),
    [anon_sym_DASH_DOT] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3772),
    [aux_sym_prefix_op_token1] = ACTIONS(3774),
    [aux_sym_infix_op_token1] = ACTIONS(3772),
    [aux_sym_infix_op_token2] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3774),
    [anon_sym_COLON_EQ] = ACTIONS(3772),
    [anon_sym_DOLLAR] = ACTIONS(3774),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3774),
    [sym_int] = ACTIONS(3774),
    [sym_xint] = ACTIONS(3772),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3772),
    [sym__newline] = ACTIONS(3772),
  },
  [3151] = {
    [sym_block_comment] = STATE(3151),
    [sym_compiler_directive_decl] = STATE(3151),
    [sym_fsi_directive_decl] = STATE(3151),
    [sym_preproc_line] = STATE(3151),
    [sym_identifier] = ACTIONS(3828),
    [anon_sym_EQ] = ACTIONS(3826),
    [anon_sym_COLON] = ACTIONS(3828),
    [anon_sym_return] = ACTIONS(3828),
    [anon_sym_do] = ACTIONS(3828),
    [anon_sym_let] = ACTIONS(3828),
    [anon_sym_let_BANG] = ACTIONS(3826),
    [anon_sym_LPAREN] = ACTIONS(3828),
    [anon_sym_COMMA] = ACTIONS(3826),
    [anon_sym_null] = ACTIONS(3828),
    [anon_sym_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_COLON] = ACTIONS(3826),
    [anon_sym_PIPE] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3828),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3826),
    [anon_sym_LBRACE] = ACTIONS(3828),
    [anon_sym_LT_AT] = ACTIONS(3828),
    [anon_sym_LT_AT_AT] = ACTIONS(3828),
    [anon_sym_DOT] = ACTIONS(3828),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3826),
    [anon_sym_new] = ACTIONS(3828),
    [anon_sym_return_BANG] = ACTIONS(3826),
    [anon_sym_yield] = ACTIONS(3828),
    [anon_sym_yield_BANG] = ACTIONS(3826),
    [anon_sym_lazy] = ACTIONS(3828),
    [anon_sym_assert] = ACTIONS(3828),
    [anon_sym_upcast] = ACTIONS(3828),
    [anon_sym_downcast] = ACTIONS(3828),
    [anon_sym_COLON_GT] = ACTIONS(3826),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3826),
    [anon_sym_for] = ACTIONS(3828),
    [anon_sym_while] = ACTIONS(3828),
    [anon_sym_if] = ACTIONS(3828),
    [anon_sym_fun] = ACTIONS(3828),
    [anon_sym_try] = ACTIONS(3828),
    [anon_sym_match] = ACTIONS(3828),
    [anon_sym_match_BANG] = ACTIONS(3826),
    [anon_sym_function] = ACTIONS(3828),
    [anon_sym_LT_DASH] = ACTIONS(3828),
    [anon_sym_DOT_LBRACK] = ACTIONS(3826),
    [anon_sym_LT] = ACTIONS(3826),
    [anon_sym_use] = ACTIONS(3828),
    [anon_sym_use_BANG] = ACTIONS(3826),
    [anon_sym_do_BANG] = ACTIONS(3826),
    [anon_sym_DOT_DOT] = ACTIONS(3826),
    [anon_sym_begin] = ACTIONS(3828),
    [anon_sym_LPAREN2] = ACTIONS(3828),
    [anon_sym_or] = ACTIONS(3828),
    [aux_sym_char_token1] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3828),
    [anon_sym_DQUOTE] = ACTIONS(3828),
    [anon_sym_AT_DQUOTE] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [sym_bool] = ACTIONS(3828),
    [sym_unit] = ACTIONS(3826),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3828),
    [sym_op_identifier] = ACTIONS(3828),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_DASH] = ACTIONS(3828),
    [anon_sym_PLUS_DOT] = ACTIONS(3828),
    [anon_sym_DASH_DOT] = ACTIONS(3828),
    [anon_sym_PERCENT] = ACTIONS(3828),
    [anon_sym_AMP_AMP] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3826),
    [aux_sym_prefix_op_token1] = ACTIONS(3828),
    [aux_sym_infix_op_token1] = ACTIONS(3826),
    [aux_sym_infix_op_token2] = ACTIONS(3828),
    [anon_sym_PIPE_PIPE] = ACTIONS(3828),
    [anon_sym_BANG_EQ] = ACTIONS(3828),
    [anon_sym_COLON_EQ] = ACTIONS(3826),
    [anon_sym_DOLLAR] = ACTIONS(3828),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3828),
    [sym_int] = ACTIONS(3828),
    [sym_xint] = ACTIONS(3826),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3826),
    [sym__newline] = ACTIONS(3826),
  },
  [3152] = {
    [sym_block_comment] = STATE(3152),
    [sym_compiler_directive_decl] = STATE(3152),
    [sym_fsi_directive_decl] = STATE(3152),
    [sym_preproc_line] = STATE(3152),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_COLON] = ACTIONS(4082),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_do] = ACTIONS(4082),
    [anon_sym_let] = ACTIONS(4082),
    [anon_sym_let_BANG] = ACTIONS(4080),
    [anon_sym_as] = ACTIONS(4082),
    [anon_sym_LPAREN] = ACTIONS(4082),
    [anon_sym_COMMA] = ACTIONS(4080),
    [anon_sym_null] = ACTIONS(4082),
    [anon_sym_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_COLON] = ACTIONS(4080),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_LBRACK] = ACTIONS(4082),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(4082),
    [anon_sym_LT_AT] = ACTIONS(4082),
    [anon_sym_LT_AT_AT] = ACTIONS(4082),
    [anon_sym_DOT] = ACTIONS(4082),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4080),
    [anon_sym_new] = ACTIONS(4082),
    [anon_sym_with] = ACTIONS(4082),
    [anon_sym_return_BANG] = ACTIONS(4080),
    [anon_sym_yield] = ACTIONS(4082),
    [anon_sym_yield_BANG] = ACTIONS(4080),
    [anon_sym_lazy] = ACTIONS(4082),
    [anon_sym_assert] = ACTIONS(4082),
    [anon_sym_upcast] = ACTIONS(4082),
    [anon_sym_downcast] = ACTIONS(4082),
    [anon_sym_COLON_GT] = ACTIONS(4080),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4080),
    [anon_sym_for] = ACTIONS(4082),
    [anon_sym_while] = ACTIONS(4082),
    [anon_sym_if] = ACTIONS(4082),
    [anon_sym_fun] = ACTIONS(4082),
    [anon_sym_try] = ACTIONS(4082),
    [anon_sym_match] = ACTIONS(4082),
    [anon_sym_match_BANG] = ACTIONS(4080),
    [anon_sym_function] = ACTIONS(4082),
    [anon_sym_LT_DASH] = ACTIONS(4082),
    [anon_sym_DOT_LBRACK] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(4080),
    [anon_sym_use] = ACTIONS(4082),
    [anon_sym_use_BANG] = ACTIONS(4080),
    [anon_sym_do_BANG] = ACTIONS(4080),
    [anon_sym_begin] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4082),
    [anon_sym_or] = ACTIONS(4082),
    [aux_sym_char_token1] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4082),
    [anon_sym_DQUOTE] = ACTIONS(4082),
    [anon_sym_AT_DQUOTE] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [sym_bool] = ACTIONS(4082),
    [sym_unit] = ACTIONS(4080),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4082),
    [sym_op_identifier] = ACTIONS(4082),
    [anon_sym_PLUS] = ACTIONS(4082),
    [anon_sym_DASH] = ACTIONS(4082),
    [anon_sym_PLUS_DOT] = ACTIONS(4082),
    [anon_sym_DASH_DOT] = ACTIONS(4082),
    [anon_sym_PERCENT] = ACTIONS(4082),
    [anon_sym_AMP_AMP] = ACTIONS(4082),
    [anon_sym_TILDE] = ACTIONS(4080),
    [aux_sym_prefix_op_token1] = ACTIONS(4082),
    [aux_sym_infix_op_token1] = ACTIONS(4080),
    [aux_sym_infix_op_token2] = ACTIONS(4082),
    [anon_sym_PIPE_PIPE] = ACTIONS(4082),
    [anon_sym_BANG_EQ] = ACTIONS(4082),
    [anon_sym_COLON_EQ] = ACTIONS(4080),
    [anon_sym_DOLLAR] = ACTIONS(4082),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4082),
    [sym_int] = ACTIONS(4082),
    [sym_xint] = ACTIONS(4080),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4080),
    [sym__newline] = ACTIONS(4080),
  },
  [3153] = {
    [sym_block_comment] = STATE(3153),
    [sym_compiler_directive_decl] = STATE(3153),
    [sym_fsi_directive_decl] = STATE(3153),
    [sym_preproc_line] = STATE(3153),
    [sym_identifier] = ACTIONS(4054),
    [anon_sym_EQ] = ACTIONS(4052),
    [anon_sym_COLON] = ACTIONS(4054),
    [anon_sym_return] = ACTIONS(4054),
    [anon_sym_do] = ACTIONS(4054),
    [anon_sym_let] = ACTIONS(4054),
    [anon_sym_let_BANG] = ACTIONS(4052),
    [anon_sym_as] = ACTIONS(4054),
    [anon_sym_LPAREN] = ACTIONS(4054),
    [anon_sym_COMMA] = ACTIONS(4052),
    [anon_sym_null] = ACTIONS(4054),
    [anon_sym_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_COLON] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(4054),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4052),
    [anon_sym_LBRACE] = ACTIONS(4054),
    [anon_sym_LT_AT] = ACTIONS(4054),
    [anon_sym_LT_AT_AT] = ACTIONS(4054),
    [anon_sym_DOT] = ACTIONS(4054),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_with] = ACTIONS(4054),
    [anon_sym_return_BANG] = ACTIONS(4052),
    [anon_sym_yield] = ACTIONS(4054),
    [anon_sym_yield_BANG] = ACTIONS(4052),
    [anon_sym_lazy] = ACTIONS(4054),
    [anon_sym_assert] = ACTIONS(4054),
    [anon_sym_upcast] = ACTIONS(4054),
    [anon_sym_downcast] = ACTIONS(4054),
    [anon_sym_COLON_GT] = ACTIONS(4052),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4052),
    [anon_sym_for] = ACTIONS(4054),
    [anon_sym_while] = ACTIONS(4054),
    [anon_sym_if] = ACTIONS(4054),
    [anon_sym_fun] = ACTIONS(4054),
    [anon_sym_try] = ACTIONS(4054),
    [anon_sym_match] = ACTIONS(4054),
    [anon_sym_match_BANG] = ACTIONS(4052),
    [anon_sym_function] = ACTIONS(4054),
    [anon_sym_LT_DASH] = ACTIONS(4054),
    [anon_sym_DOT_LBRACK] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_use] = ACTIONS(4054),
    [anon_sym_use_BANG] = ACTIONS(4052),
    [anon_sym_do_BANG] = ACTIONS(4052),
    [anon_sym_begin] = ACTIONS(4054),
    [anon_sym_LPAREN2] = ACTIONS(4054),
    [anon_sym_or] = ACTIONS(4054),
    [aux_sym_char_token1] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4054),
    [anon_sym_DQUOTE] = ACTIONS(4054),
    [anon_sym_AT_DQUOTE] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [sym_bool] = ACTIONS(4054),
    [sym_unit] = ACTIONS(4052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4054),
    [sym_op_identifier] = ACTIONS(4054),
    [anon_sym_PLUS] = ACTIONS(4054),
    [anon_sym_DASH] = ACTIONS(4054),
    [anon_sym_PLUS_DOT] = ACTIONS(4054),
    [anon_sym_DASH_DOT] = ACTIONS(4054),
    [anon_sym_PERCENT] = ACTIONS(4054),
    [anon_sym_AMP_AMP] = ACTIONS(4054),
    [anon_sym_TILDE] = ACTIONS(4052),
    [aux_sym_prefix_op_token1] = ACTIONS(4054),
    [aux_sym_infix_op_token1] = ACTIONS(4052),
    [aux_sym_infix_op_token2] = ACTIONS(4054),
    [anon_sym_PIPE_PIPE] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4054),
    [anon_sym_COLON_EQ] = ACTIONS(4052),
    [anon_sym_DOLLAR] = ACTIONS(4054),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4054),
    [sym_int] = ACTIONS(4054),
    [sym_xint] = ACTIONS(4052),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4052),
    [sym__newline] = ACTIONS(4052),
  },
  [3154] = {
    [sym_block_comment] = STATE(3154),
    [sym_compiler_directive_decl] = STATE(3154),
    [sym_fsi_directive_decl] = STATE(3154),
    [sym_preproc_line] = STATE(3154),
    [sym_identifier] = ACTIONS(4208),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_COLON] = ACTIONS(4208),
    [anon_sym_return] = ACTIONS(4208),
    [anon_sym_do] = ACTIONS(4208),
    [anon_sym_let] = ACTIONS(4208),
    [anon_sym_let_BANG] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(4206),
    [anon_sym_null] = ACTIONS(4208),
    [anon_sym_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_COLON] = ACTIONS(4206),
    [anon_sym_AMP] = ACTIONS(4208),
    [anon_sym_LBRACK] = ACTIONS(4208),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4206),
    [anon_sym_LBRACE] = ACTIONS(4208),
    [anon_sym_LT_AT] = ACTIONS(4208),
    [anon_sym_LT_AT_AT] = ACTIONS(4208),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4206),
    [anon_sym_new] = ACTIONS(4208),
    [anon_sym_return_BANG] = ACTIONS(4206),
    [anon_sym_yield] = ACTIONS(4208),
    [anon_sym_yield_BANG] = ACTIONS(4206),
    [anon_sym_lazy] = ACTIONS(4208),
    [anon_sym_assert] = ACTIONS(4208),
    [anon_sym_upcast] = ACTIONS(4208),
    [anon_sym_downcast] = ACTIONS(4208),
    [anon_sym_COLON_GT] = ACTIONS(4206),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4206),
    [anon_sym_for] = ACTIONS(4208),
    [anon_sym_while] = ACTIONS(4208),
    [anon_sym_if] = ACTIONS(4208),
    [anon_sym_fun] = ACTIONS(4208),
    [anon_sym_DASH_GT] = ACTIONS(4208),
    [anon_sym_try] = ACTIONS(4208),
    [anon_sym_match] = ACTIONS(4208),
    [anon_sym_match_BANG] = ACTIONS(4206),
    [anon_sym_function] = ACTIONS(4208),
    [anon_sym_LT_DASH] = ACTIONS(4208),
    [anon_sym_DOT_LBRACK] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(4206),
    [anon_sym_use] = ACTIONS(4208),
    [anon_sym_use_BANG] = ACTIONS(4206),
    [anon_sym_do_BANG] = ACTIONS(4206),
    [anon_sym_DOT_DOT] = ACTIONS(4206),
    [anon_sym_begin] = ACTIONS(4208),
    [anon_sym_LPAREN2] = ACTIONS(4208),
    [anon_sym_or] = ACTIONS(4208),
    [aux_sym_char_token1] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4208),
    [anon_sym_DQUOTE] = ACTIONS(4208),
    [anon_sym_AT_DQUOTE] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [sym_bool] = ACTIONS(4208),
    [sym_unit] = ACTIONS(4206),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4208),
    [sym_op_identifier] = ACTIONS(4208),
    [anon_sym_PLUS] = ACTIONS(4208),
    [anon_sym_DASH] = ACTIONS(4208),
    [anon_sym_PLUS_DOT] = ACTIONS(4208),
    [anon_sym_DASH_DOT] = ACTIONS(4208),
    [anon_sym_PERCENT] = ACTIONS(4208),
    [anon_sym_AMP_AMP] = ACTIONS(4208),
    [anon_sym_TILDE] = ACTIONS(4206),
    [aux_sym_prefix_op_token1] = ACTIONS(4208),
    [aux_sym_infix_op_token1] = ACTIONS(4206),
    [aux_sym_infix_op_token2] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(4208),
    [anon_sym_BANG_EQ] = ACTIONS(4208),
    [anon_sym_COLON_EQ] = ACTIONS(4206),
    [anon_sym_DOLLAR] = ACTIONS(4208),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4208),
    [sym_int] = ACTIONS(4208),
    [sym_xint] = ACTIONS(4206),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4206),
    [sym__newline] = ACTIONS(4206),
  },
  [3155] = {
    [sym_block_comment] = STATE(3155),
    [sym_compiler_directive_decl] = STATE(3155),
    [sym_fsi_directive_decl] = STATE(3155),
    [sym_preproc_line] = STATE(3155),
    [sym_identifier] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3774),
    [anon_sym_do] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3774),
    [anon_sym_let_BANG] = ACTIONS(3772),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3772),
    [anon_sym_null] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_COLON] = ACTIONS(3772),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_LT_AT] = ACTIONS(3774),
    [anon_sym_LT_AT_AT] = ACTIONS(3774),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3772),
    [anon_sym_new] = ACTIONS(3774),
    [anon_sym_return_BANG] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3774),
    [anon_sym_yield_BANG] = ACTIONS(3772),
    [anon_sym_lazy] = ACTIONS(3774),
    [anon_sym_assert] = ACTIONS(3774),
    [anon_sym_upcast] = ACTIONS(3774),
    [anon_sym_downcast] = ACTIONS(3774),
    [anon_sym_COLON_GT] = ACTIONS(3772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3774),
    [anon_sym_done] = ACTIONS(5766),
    [anon_sym_while] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3774),
    [anon_sym_fun] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3774),
    [anon_sym_match] = ACTIONS(3774),
    [anon_sym_match_BANG] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3774),
    [anon_sym_LT_DASH] = ACTIONS(3774),
    [anon_sym_DOT_LBRACK] = ACTIONS(3772),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_GT] = ACTIONS(3774),
    [anon_sym_use] = ACTIONS(3774),
    [anon_sym_use_BANG] = ACTIONS(3772),
    [anon_sym_do_BANG] = ACTIONS(3772),
    [anon_sym_begin] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3774),
    [anon_sym_or] = ACTIONS(3774),
    [aux_sym_char_token1] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_AT_DQUOTE] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [sym_bool] = ACTIONS(3774),
    [sym_unit] = ACTIONS(3772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3774),
    [sym_op_identifier] = ACTIONS(3774),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_DOT] = ACTIONS(3774),
    [anon_sym_DASH_DOT] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3772),
    [aux_sym_prefix_op_token1] = ACTIONS(3774),
    [aux_sym_infix_op_token1] = ACTIONS(3772),
    [aux_sym_infix_op_token2] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3774),
    [anon_sym_COLON_EQ] = ACTIONS(3772),
    [anon_sym_DOLLAR] = ACTIONS(3774),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3774),
    [sym_int] = ACTIONS(3774),
    [sym_xint] = ACTIONS(3772),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3772),
    [sym__newline] = ACTIONS(3772),
  },
  [3156] = {
    [sym_block_comment] = STATE(3156),
    [sym_compiler_directive_decl] = STATE(3156),
    [sym_fsi_directive_decl] = STATE(3156),
    [sym_preproc_line] = STATE(3156),
    [sym_identifier] = ACTIONS(4182),
    [anon_sym_EQ] = ACTIONS(3689),
    [anon_sym_COLON] = ACTIONS(4182),
    [anon_sym_return] = ACTIONS(4182),
    [anon_sym_do] = ACTIONS(4182),
    [anon_sym_let] = ACTIONS(4182),
    [anon_sym_let_BANG] = ACTIONS(3689),
    [anon_sym_LPAREN] = ACTIONS(4182),
    [anon_sym_COMMA] = ACTIONS(3689),
    [anon_sym_null] = ACTIONS(4182),
    [anon_sym_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3689),
    [anon_sym_LBRACE] = ACTIONS(4182),
    [anon_sym_LT_AT] = ACTIONS(4182),
    [anon_sym_LT_AT_AT] = ACTIONS(4182),
    [anon_sym_DOT] = ACTIONS(4182),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3689),
    [anon_sym_new] = ACTIONS(4182),
    [anon_sym_return_BANG] = ACTIONS(3689),
    [anon_sym_yield] = ACTIONS(4182),
    [anon_sym_yield_BANG] = ACTIONS(3689),
    [anon_sym_lazy] = ACTIONS(4182),
    [anon_sym_assert] = ACTIONS(4182),
    [anon_sym_upcast] = ACTIONS(4182),
    [anon_sym_downcast] = ACTIONS(4182),
    [anon_sym_COLON_GT] = ACTIONS(3689),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3689),
    [anon_sym_for] = ACTIONS(4182),
    [anon_sym_while] = ACTIONS(4182),
    [anon_sym_if] = ACTIONS(4182),
    [anon_sym_fun] = ACTIONS(4182),
    [anon_sym_DASH_GT] = ACTIONS(4182),
    [anon_sym_try] = ACTIONS(4182),
    [anon_sym_match] = ACTIONS(4182),
    [anon_sym_match_BANG] = ACTIONS(3689),
    [anon_sym_function] = ACTIONS(4182),
    [anon_sym_LT_DASH] = ACTIONS(4182),
    [anon_sym_DOT_LBRACK] = ACTIONS(3689),
    [anon_sym_LT] = ACTIONS(3689),
    [anon_sym_use] = ACTIONS(4182),
    [anon_sym_use_BANG] = ACTIONS(3689),
    [anon_sym_do_BANG] = ACTIONS(3689),
    [anon_sym_DOT_DOT] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(4182),
    [anon_sym_LPAREN2] = ACTIONS(4182),
    [anon_sym_or] = ACTIONS(4182),
    [aux_sym_char_token1] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4182),
    [anon_sym_DQUOTE] = ACTIONS(4182),
    [anon_sym_AT_DQUOTE] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [sym_bool] = ACTIONS(4182),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4182),
    [sym_op_identifier] = ACTIONS(4182),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_PLUS_DOT] = ACTIONS(4182),
    [anon_sym_DASH_DOT] = ACTIONS(4182),
    [anon_sym_PERCENT] = ACTIONS(4182),
    [anon_sym_AMP_AMP] = ACTIONS(4182),
    [anon_sym_TILDE] = ACTIONS(3689),
    [aux_sym_prefix_op_token1] = ACTIONS(4182),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token2] = ACTIONS(4182),
    [anon_sym_PIPE_PIPE] = ACTIONS(4182),
    [anon_sym_BANG_EQ] = ACTIONS(4182),
    [anon_sym_COLON_EQ] = ACTIONS(3689),
    [anon_sym_DOLLAR] = ACTIONS(4182),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4182),
    [sym_int] = ACTIONS(4182),
    [sym_xint] = ACTIONS(3689),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3689),
    [sym__newline] = ACTIONS(3689),
  },
  [3157] = {
    [sym_block_comment] = STATE(3157),
    [sym_compiler_directive_decl] = STATE(3157),
    [sym_fsi_directive_decl] = STATE(3157),
    [sym_preproc_line] = STATE(3157),
    [sym_identifier] = ACTIONS(4162),
    [anon_sym_EQ] = ACTIONS(4160),
    [anon_sym_COLON] = ACTIONS(4162),
    [anon_sym_return] = ACTIONS(4162),
    [anon_sym_do] = ACTIONS(4162),
    [anon_sym_let] = ACTIONS(4162),
    [anon_sym_let_BANG] = ACTIONS(4160),
    [anon_sym_LPAREN] = ACTIONS(4162),
    [anon_sym_COMMA] = ACTIONS(4160),
    [anon_sym_null] = ACTIONS(4162),
    [anon_sym_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4160),
    [anon_sym_AMP] = ACTIONS(4162),
    [anon_sym_LBRACK] = ACTIONS(4162),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4160),
    [anon_sym_LBRACE] = ACTIONS(4162),
    [anon_sym_LT_AT] = ACTIONS(4162),
    [anon_sym_LT_AT_AT] = ACTIONS(4162),
    [anon_sym_DOT] = ACTIONS(4162),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4160),
    [anon_sym_new] = ACTIONS(4162),
    [anon_sym_return_BANG] = ACTIONS(4160),
    [anon_sym_yield] = ACTIONS(4162),
    [anon_sym_yield_BANG] = ACTIONS(4160),
    [anon_sym_lazy] = ACTIONS(4162),
    [anon_sym_assert] = ACTIONS(4162),
    [anon_sym_upcast] = ACTIONS(4162),
    [anon_sym_downcast] = ACTIONS(4162),
    [anon_sym_COLON_GT] = ACTIONS(4160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4160),
    [anon_sym_for] = ACTIONS(4162),
    [anon_sym_while] = ACTIONS(4162),
    [anon_sym_if] = ACTIONS(4162),
    [anon_sym_fun] = ACTIONS(4162),
    [anon_sym_DASH_GT] = ACTIONS(4162),
    [anon_sym_try] = ACTIONS(4162),
    [anon_sym_match] = ACTIONS(4162),
    [anon_sym_match_BANG] = ACTIONS(4160),
    [anon_sym_function] = ACTIONS(4162),
    [anon_sym_LT_DASH] = ACTIONS(4162),
    [anon_sym_DOT_LBRACK] = ACTIONS(4160),
    [anon_sym_LT] = ACTIONS(4160),
    [anon_sym_use] = ACTIONS(4162),
    [anon_sym_use_BANG] = ACTIONS(4160),
    [anon_sym_do_BANG] = ACTIONS(4160),
    [anon_sym_DOT_DOT] = ACTIONS(4160),
    [anon_sym_begin] = ACTIONS(4162),
    [anon_sym_LPAREN2] = ACTIONS(4162),
    [anon_sym_or] = ACTIONS(4162),
    [aux_sym_char_token1] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4162),
    [anon_sym_DQUOTE] = ACTIONS(4162),
    [anon_sym_AT_DQUOTE] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [sym_bool] = ACTIONS(4162),
    [sym_unit] = ACTIONS(4160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4162),
    [sym_op_identifier] = ACTIONS(4162),
    [anon_sym_PLUS] = ACTIONS(4162),
    [anon_sym_DASH] = ACTIONS(4162),
    [anon_sym_PLUS_DOT] = ACTIONS(4162),
    [anon_sym_DASH_DOT] = ACTIONS(4162),
    [anon_sym_PERCENT] = ACTIONS(4162),
    [anon_sym_AMP_AMP] = ACTIONS(4162),
    [anon_sym_TILDE] = ACTIONS(4160),
    [aux_sym_prefix_op_token1] = ACTIONS(4162),
    [aux_sym_infix_op_token1] = ACTIONS(4160),
    [aux_sym_infix_op_token2] = ACTIONS(4162),
    [anon_sym_PIPE_PIPE] = ACTIONS(4162),
    [anon_sym_BANG_EQ] = ACTIONS(4162),
    [anon_sym_COLON_EQ] = ACTIONS(4160),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4162),
    [sym_int] = ACTIONS(4162),
    [sym_xint] = ACTIONS(4160),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4160),
    [sym__newline] = ACTIONS(4160),
  },
  [3158] = {
    [sym_block_comment] = STATE(3158),
    [sym_compiler_directive_decl] = STATE(3158),
    [sym_fsi_directive_decl] = STATE(3158),
    [sym_preproc_line] = STATE(3158),
    [sym_identifier] = ACTIONS(4158),
    [anon_sym_EQ] = ACTIONS(4156),
    [anon_sym_COLON] = ACTIONS(4158),
    [anon_sym_return] = ACTIONS(4158),
    [anon_sym_do] = ACTIONS(4158),
    [anon_sym_let] = ACTIONS(4158),
    [anon_sym_let_BANG] = ACTIONS(4156),
    [anon_sym_LPAREN] = ACTIONS(4158),
    [anon_sym_COMMA] = ACTIONS(4156),
    [anon_sym_null] = ACTIONS(4158),
    [anon_sym_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_COLON] = ACTIONS(4156),
    [anon_sym_AMP] = ACTIONS(4158),
    [anon_sym_LBRACK] = ACTIONS(4158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(4158),
    [anon_sym_LT_AT] = ACTIONS(4158),
    [anon_sym_LT_AT_AT] = ACTIONS(4158),
    [anon_sym_DOT] = ACTIONS(4158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4156),
    [anon_sym_new] = ACTIONS(4158),
    [anon_sym_return_BANG] = ACTIONS(4156),
    [anon_sym_yield] = ACTIONS(4158),
    [anon_sym_yield_BANG] = ACTIONS(4156),
    [anon_sym_lazy] = ACTIONS(4158),
    [anon_sym_assert] = ACTIONS(4158),
    [anon_sym_upcast] = ACTIONS(4158),
    [anon_sym_downcast] = ACTIONS(4158),
    [anon_sym_COLON_GT] = ACTIONS(4156),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4156),
    [anon_sym_for] = ACTIONS(4158),
    [anon_sym_while] = ACTIONS(4158),
    [anon_sym_if] = ACTIONS(4158),
    [anon_sym_fun] = ACTIONS(4158),
    [anon_sym_DASH_GT] = ACTIONS(4158),
    [anon_sym_try] = ACTIONS(4158),
    [anon_sym_match] = ACTIONS(4158),
    [anon_sym_match_BANG] = ACTIONS(4156),
    [anon_sym_function] = ACTIONS(4158),
    [anon_sym_LT_DASH] = ACTIONS(4158),
    [anon_sym_DOT_LBRACK] = ACTIONS(4156),
    [anon_sym_LT] = ACTIONS(4156),
    [anon_sym_use] = ACTIONS(4158),
    [anon_sym_use_BANG] = ACTIONS(4156),
    [anon_sym_do_BANG] = ACTIONS(4156),
    [anon_sym_DOT_DOT] = ACTIONS(4156),
    [anon_sym_begin] = ACTIONS(4158),
    [anon_sym_LPAREN2] = ACTIONS(4158),
    [anon_sym_or] = ACTIONS(4158),
    [aux_sym_char_token1] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4158),
    [anon_sym_DQUOTE] = ACTIONS(4158),
    [anon_sym_AT_DQUOTE] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [sym_bool] = ACTIONS(4158),
    [sym_unit] = ACTIONS(4156),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4158),
    [sym_op_identifier] = ACTIONS(4158),
    [anon_sym_PLUS] = ACTIONS(4158),
    [anon_sym_DASH] = ACTIONS(4158),
    [anon_sym_PLUS_DOT] = ACTIONS(4158),
    [anon_sym_DASH_DOT] = ACTIONS(4158),
    [anon_sym_PERCENT] = ACTIONS(4158),
    [anon_sym_AMP_AMP] = ACTIONS(4158),
    [anon_sym_TILDE] = ACTIONS(4156),
    [aux_sym_prefix_op_token1] = ACTIONS(4158),
    [aux_sym_infix_op_token1] = ACTIONS(4156),
    [aux_sym_infix_op_token2] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE] = ACTIONS(4158),
    [anon_sym_BANG_EQ] = ACTIONS(4158),
    [anon_sym_COLON_EQ] = ACTIONS(4156),
    [anon_sym_DOLLAR] = ACTIONS(4158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4158),
    [sym_int] = ACTIONS(4158),
    [sym_xint] = ACTIONS(4156),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4156),
    [sym__newline] = ACTIONS(4156),
  },
  [3159] = {
    [sym_block_comment] = STATE(3159),
    [sym_compiler_directive_decl] = STATE(3159),
    [sym_fsi_directive_decl] = STATE(3159),
    [sym_preproc_line] = STATE(3159),
    [sym_identifier] = ACTIONS(4018),
    [anon_sym_EQ] = ACTIONS(4016),
    [anon_sym_COLON] = ACTIONS(4018),
    [anon_sym_return] = ACTIONS(4018),
    [anon_sym_do] = ACTIONS(4018),
    [anon_sym_let] = ACTIONS(4018),
    [anon_sym_let_BANG] = ACTIONS(4016),
    [anon_sym_as] = ACTIONS(4018),
    [anon_sym_LPAREN] = ACTIONS(4018),
    [anon_sym_COMMA] = ACTIONS(4016),
    [anon_sym_null] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_COLON] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4018),
    [anon_sym_LBRACK] = ACTIONS(4018),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4016),
    [anon_sym_LBRACE] = ACTIONS(4018),
    [anon_sym_LT_AT] = ACTIONS(4018),
    [anon_sym_LT_AT_AT] = ACTIONS(4018),
    [anon_sym_DOT] = ACTIONS(4018),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4016),
    [anon_sym_new] = ACTIONS(4018),
    [anon_sym_with] = ACTIONS(4018),
    [anon_sym_return_BANG] = ACTIONS(4016),
    [anon_sym_yield] = ACTIONS(4018),
    [anon_sym_yield_BANG] = ACTIONS(4016),
    [anon_sym_lazy] = ACTIONS(4018),
    [anon_sym_assert] = ACTIONS(4018),
    [anon_sym_upcast] = ACTIONS(4018),
    [anon_sym_downcast] = ACTIONS(4018),
    [anon_sym_COLON_GT] = ACTIONS(4016),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4016),
    [anon_sym_for] = ACTIONS(4018),
    [anon_sym_while] = ACTIONS(4018),
    [anon_sym_if] = ACTIONS(4018),
    [anon_sym_fun] = ACTIONS(4018),
    [anon_sym_try] = ACTIONS(4018),
    [anon_sym_match] = ACTIONS(4018),
    [anon_sym_match_BANG] = ACTIONS(4016),
    [anon_sym_function] = ACTIONS(4018),
    [anon_sym_LT_DASH] = ACTIONS(4018),
    [anon_sym_DOT_LBRACK] = ACTIONS(4016),
    [anon_sym_LT] = ACTIONS(4016),
    [anon_sym_use] = ACTIONS(4018),
    [anon_sym_use_BANG] = ACTIONS(4016),
    [anon_sym_do_BANG] = ACTIONS(4016),
    [anon_sym_begin] = ACTIONS(4018),
    [anon_sym_LPAREN2] = ACTIONS(4018),
    [anon_sym_or] = ACTIONS(4018),
    [aux_sym_char_token1] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(4018),
    [anon_sym_AT_DQUOTE] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [sym_bool] = ACTIONS(4018),
    [sym_unit] = ACTIONS(4016),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4018),
    [sym_op_identifier] = ACTIONS(4018),
    [anon_sym_PLUS] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_PLUS_DOT] = ACTIONS(4018),
    [anon_sym_DASH_DOT] = ACTIONS(4018),
    [anon_sym_PERCENT] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4016),
    [aux_sym_prefix_op_token1] = ACTIONS(4018),
    [aux_sym_infix_op_token1] = ACTIONS(4016),
    [aux_sym_infix_op_token2] = ACTIONS(4018),
    [anon_sym_PIPE_PIPE] = ACTIONS(4018),
    [anon_sym_BANG_EQ] = ACTIONS(4018),
    [anon_sym_COLON_EQ] = ACTIONS(4016),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4018),
    [sym_int] = ACTIONS(4018),
    [sym_xint] = ACTIONS(4016),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4016),
    [sym__newline] = ACTIONS(4016),
  },
  [3160] = {
    [sym_block_comment] = STATE(3160),
    [sym_compiler_directive_decl] = STATE(3160),
    [sym_fsi_directive_decl] = STATE(3160),
    [sym_preproc_line] = STATE(3160),
    [aux_sym_type_argument_repeat1] = STATE(3173),
    [ts_builtin_sym_end] = ACTIONS(3474),
    [sym_identifier] = ACTIONS(3476),
    [anon_sym_namespace] = ACTIONS(3476),
    [anon_sym_module] = ACTIONS(3476),
    [anon_sym_open] = ACTIONS(3476),
    [anon_sym_LBRACK_LT] = ACTIONS(3474),
    [anon_sym_return] = ACTIONS(3476),
    [anon_sym_type] = ACTIONS(3476),
    [anon_sym_do] = ACTIONS(3476),
    [anon_sym_and] = ACTIONS(3476),
    [anon_sym_let] = ACTIONS(3476),
    [anon_sym_let_BANG] = ACTIONS(3474),
    [aux_sym_access_modifier_token1] = ACTIONS(3474),
    [anon_sym_LPAREN] = ACTIONS(3476),
    [anon_sym_null] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym_LBRACK] = ACTIONS(3476),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3474),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_LT_AT] = ACTIONS(3476),
    [anon_sym_LT_AT_AT] = ACTIONS(3474),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3474),
    [anon_sym_new] = ACTIONS(3476),
    [anon_sym_with] = ACTIONS(3476),
    [anon_sym_return_BANG] = ACTIONS(3474),
    [anon_sym_yield] = ACTIONS(3476),
    [anon_sym_yield_BANG] = ACTIONS(3474),
    [anon_sym_lazy] = ACTIONS(3476),
    [anon_sym_assert] = ACTIONS(3476),
    [anon_sym_upcast] = ACTIONS(3476),
    [anon_sym_downcast] = ACTIONS(3476),
    [anon_sym_COLON_GT] = ACTIONS(3474),
    [anon_sym_for] = ACTIONS(3476),
    [anon_sym_while] = ACTIONS(3476),
    [anon_sym_if] = ACTIONS(3476),
    [anon_sym_fun] = ACTIONS(3476),
    [anon_sym_DASH_GT] = ACTIONS(3474),
    [anon_sym_try] = ACTIONS(3476),
    [anon_sym_match] = ACTIONS(3476),
    [anon_sym_match_BANG] = ACTIONS(3474),
    [anon_sym_function] = ACTIONS(3476),
    [anon_sym_use] = ACTIONS(3476),
    [anon_sym_use_BANG] = ACTIONS(3474),
    [anon_sym_do_BANG] = ACTIONS(3474),
    [anon_sym_begin] = ACTIONS(3476),
    [anon_sym_STAR] = ACTIONS(3474),
    [anon_sym_LT2] = ACTIONS(3476),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3474),
    [anon_sym_default] = ACTIONS(3476),
    [anon_sym_or] = ACTIONS(5768),
    [anon_sym_static] = ACTIONS(3476),
    [anon_sym_member] = ACTIONS(3476),
    [anon_sym_interface] = ACTIONS(3476),
    [anon_sym_exception] = ACTIONS(3476),
    [anon_sym_abstract] = ACTIONS(3476),
    [anon_sym_val] = ACTIONS(3476),
    [anon_sym_override] = ACTIONS(3476),
    [aux_sym_char_token1] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3476),
    [anon_sym_DQUOTE] = ACTIONS(3476),
    [anon_sym_AT_DQUOTE] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [sym_bool] = ACTIONS(3476),
    [sym_unit] = ACTIONS(3474),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3476),
    [sym_op_identifier] = ACTIONS(3474),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3476),
    [anon_sym_PLUS_DOT] = ACTIONS(3474),
    [anon_sym_DASH_DOT] = ACTIONS(3474),
    [anon_sym_PERCENT] = ACTIONS(3474),
    [anon_sym_AMP_AMP] = ACTIONS(3474),
    [anon_sym_TILDE] = ACTIONS(3474),
    [aux_sym_prefix_op_token1] = ACTIONS(3474),
    [sym_int] = ACTIONS(3476),
    [sym_xint] = ACTIONS(3474),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3474),
    [anon_sym_POUNDload] = ACTIONS(3474),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3474),
  },
  [3161] = {
    [sym_block_comment] = STATE(3161),
    [sym_compiler_directive_decl] = STATE(3161),
    [sym_fsi_directive_decl] = STATE(3161),
    [sym_preproc_line] = STATE(3161),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_COLON] = ACTIONS(3867),
    [anon_sym_return] = ACTIONS(3867),
    [anon_sym_do] = ACTIONS(3867),
    [anon_sym_let] = ACTIONS(3867),
    [anon_sym_let_BANG] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(3867),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_null] = ACTIONS(3867),
    [anon_sym_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_COLON] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3867),
    [anon_sym_LBRACK] = ACTIONS(3867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3867),
    [anon_sym_LT_AT] = ACTIONS(3867),
    [anon_sym_LT_AT_AT] = ACTIONS(3867),
    [anon_sym_DOT] = ACTIONS(3867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3867),
    [anon_sym_return_BANG] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3867),
    [anon_sym_yield_BANG] = ACTIONS(3865),
    [anon_sym_lazy] = ACTIONS(3867),
    [anon_sym_assert] = ACTIONS(3867),
    [anon_sym_upcast] = ACTIONS(3867),
    [anon_sym_downcast] = ACTIONS(3867),
    [anon_sym_COLON_GT] = ACTIONS(3865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3867),
    [anon_sym_while] = ACTIONS(3867),
    [anon_sym_if] = ACTIONS(3867),
    [anon_sym_fun] = ACTIONS(3867),
    [anon_sym_DASH_GT] = ACTIONS(3867),
    [anon_sym_try] = ACTIONS(3867),
    [anon_sym_match] = ACTIONS(3867),
    [anon_sym_match_BANG] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(3867),
    [anon_sym_DOT_LBRACK] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_use] = ACTIONS(3867),
    [anon_sym_use_BANG] = ACTIONS(3865),
    [anon_sym_do_BANG] = ACTIONS(3865),
    [anon_sym_DOT_DOT] = ACTIONS(3865),
    [anon_sym_begin] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(3867),
    [anon_sym_or] = ACTIONS(3867),
    [aux_sym_char_token1] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3867),
    [anon_sym_DQUOTE] = ACTIONS(3867),
    [anon_sym_AT_DQUOTE] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [sym_bool] = ACTIONS(3867),
    [sym_unit] = ACTIONS(3865),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3867),
    [sym_op_identifier] = ACTIONS(3867),
    [anon_sym_PLUS] = ACTIONS(3867),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_PLUS_DOT] = ACTIONS(3867),
    [anon_sym_DASH_DOT] = ACTIONS(3867),
    [anon_sym_PERCENT] = ACTIONS(3867),
    [anon_sym_AMP_AMP] = ACTIONS(3867),
    [anon_sym_TILDE] = ACTIONS(3865),
    [aux_sym_prefix_op_token1] = ACTIONS(3867),
    [aux_sym_infix_op_token1] = ACTIONS(3865),
    [aux_sym_infix_op_token2] = ACTIONS(3867),
    [anon_sym_PIPE_PIPE] = ACTIONS(3867),
    [anon_sym_BANG_EQ] = ACTIONS(3867),
    [anon_sym_COLON_EQ] = ACTIONS(3865),
    [anon_sym_DOLLAR] = ACTIONS(3867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3867),
    [sym_int] = ACTIONS(3867),
    [sym_xint] = ACTIONS(3865),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3865),
    [sym__newline] = ACTIONS(3865),
  },
  [3162] = {
    [sym_block_comment] = STATE(3162),
    [sym_compiler_directive_decl] = STATE(3162),
    [sym_fsi_directive_decl] = STATE(3162),
    [sym_preproc_line] = STATE(3162),
    [sym_identifier] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_return] = ACTIONS(3774),
    [anon_sym_do] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3774),
    [anon_sym_let_BANG] = ACTIONS(3772),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3772),
    [anon_sym_null] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_COLON_COLON] = ACTIONS(3772),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_LT_AT] = ACTIONS(3774),
    [anon_sym_AT_GT] = ACTIONS(3774),
    [anon_sym_LT_AT_AT] = ACTIONS(3774),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3772),
    [anon_sym_new] = ACTIONS(3774),
    [anon_sym_return_BANG] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3774),
    [anon_sym_yield_BANG] = ACTIONS(3772),
    [anon_sym_lazy] = ACTIONS(3774),
    [anon_sym_assert] = ACTIONS(3774),
    [anon_sym_upcast] = ACTIONS(3774),
    [anon_sym_downcast] = ACTIONS(3774),
    [anon_sym_COLON_GT] = ACTIONS(3772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3772),
    [anon_sym_for] = ACTIONS(3774),
    [anon_sym_done] = ACTIONS(5770),
    [anon_sym_while] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3774),
    [anon_sym_fun] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3774),
    [anon_sym_match] = ACTIONS(3774),
    [anon_sym_match_BANG] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3774),
    [anon_sym_LT_DASH] = ACTIONS(3774),
    [anon_sym_DOT_LBRACK] = ACTIONS(3772),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_use] = ACTIONS(3774),
    [anon_sym_use_BANG] = ACTIONS(3772),
    [anon_sym_do_BANG] = ACTIONS(3772),
    [anon_sym_begin] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3774),
    [anon_sym_or] = ACTIONS(3774),
    [aux_sym_char_token1] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_AT_DQUOTE] = ACTIONS(3772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3772),
    [sym_bool] = ACTIONS(3774),
    [sym_unit] = ACTIONS(3772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3774),
    [sym_op_identifier] = ACTIONS(3774),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_PLUS_DOT] = ACTIONS(3774),
    [anon_sym_DASH_DOT] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3772),
    [aux_sym_prefix_op_token1] = ACTIONS(3774),
    [aux_sym_infix_op_token1] = ACTIONS(3772),
    [aux_sym_infix_op_token2] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3774),
    [anon_sym_COLON_EQ] = ACTIONS(3772),
    [anon_sym_DOLLAR] = ACTIONS(3774),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3774),
    [sym_int] = ACTIONS(3774),
    [sym_xint] = ACTIONS(3772),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3772),
    [sym__newline] = ACTIONS(3772),
  },
  [3163] = {
    [sym_block_comment] = STATE(3163),
    [sym_compiler_directive_decl] = STATE(3163),
    [sym_fsi_directive_decl] = STATE(3163),
    [sym_preproc_line] = STATE(3163),
    [sym_identifier] = ACTIONS(4212),
    [anon_sym_EQ] = ACTIONS(4210),
    [anon_sym_COLON] = ACTIONS(4212),
    [anon_sym_return] = ACTIONS(4212),
    [anon_sym_do] = ACTIONS(4212),
    [anon_sym_let] = ACTIONS(4212),
    [anon_sym_let_BANG] = ACTIONS(4210),
    [anon_sym_LPAREN] = ACTIONS(4212),
    [anon_sym_COMMA] = ACTIONS(4210),
    [anon_sym_null] = ACTIONS(4212),
    [anon_sym_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_COLON] = ACTIONS(4210),
    [anon_sym_AMP] = ACTIONS(4212),
    [anon_sym_LBRACK] = ACTIONS(4212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4210),
    [anon_sym_LBRACE] = ACTIONS(4212),
    [anon_sym_LT_AT] = ACTIONS(4212),
    [anon_sym_LT_AT_AT] = ACTIONS(4212),
    [anon_sym_DOT] = ACTIONS(4212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4210),
    [anon_sym_new] = ACTIONS(4212),
    [anon_sym_return_BANG] = ACTIONS(4210),
    [anon_sym_yield] = ACTIONS(4212),
    [anon_sym_yield_BANG] = ACTIONS(4210),
    [anon_sym_lazy] = ACTIONS(4212),
    [anon_sym_assert] = ACTIONS(4212),
    [anon_sym_upcast] = ACTIONS(4212),
    [anon_sym_downcast] = ACTIONS(4212),
    [anon_sym_COLON_GT] = ACTIONS(4210),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4210),
    [anon_sym_for] = ACTIONS(4212),
    [anon_sym_while] = ACTIONS(4212),
    [anon_sym_if] = ACTIONS(4212),
    [anon_sym_fun] = ACTIONS(4212),
    [anon_sym_DASH_GT] = ACTIONS(4212),
    [anon_sym_try] = ACTIONS(4212),
    [anon_sym_match] = ACTIONS(4212),
    [anon_sym_match_BANG] = ACTIONS(4210),
    [anon_sym_function] = ACTIONS(4212),
    [anon_sym_LT_DASH] = ACTIONS(4212),
    [anon_sym_DOT_LBRACK] = ACTIONS(4210),
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_use] = ACTIONS(4212),
    [anon_sym_use_BANG] = ACTIONS(4210),
    [anon_sym_do_BANG] = ACTIONS(4210),
    [anon_sym_DOT_DOT] = ACTIONS(4210),
    [anon_sym_begin] = ACTIONS(4212),
    [anon_sym_LPAREN2] = ACTIONS(4212),
    [anon_sym_or] = ACTIONS(4212),
    [aux_sym_char_token1] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4212),
    [anon_sym_DQUOTE] = ACTIONS(4212),
    [anon_sym_AT_DQUOTE] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [sym_bool] = ACTIONS(4212),
    [sym_unit] = ACTIONS(4210),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4212),
    [anon_sym_DASH] = ACTIONS(4212),
    [anon_sym_PLUS_DOT] = ACTIONS(4212),
    [anon_sym_DASH_DOT] = ACTIONS(4212),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_AMP_AMP] = ACTIONS(4212),
    [anon_sym_TILDE] = ACTIONS(4210),
    [aux_sym_prefix_op_token1] = ACTIONS(4212),
    [aux_sym_infix_op_token1] = ACTIONS(4210),
    [aux_sym_infix_op_token2] = ACTIONS(4212),
    [anon_sym_PIPE_PIPE] = ACTIONS(4212),
    [anon_sym_BANG_EQ] = ACTIONS(4212),
    [anon_sym_COLON_EQ] = ACTIONS(4210),
    [anon_sym_DOLLAR] = ACTIONS(4212),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4212),
    [sym_int] = ACTIONS(4212),
    [sym_xint] = ACTIONS(4210),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4210),
    [sym__newline] = ACTIONS(4210),
  },
  [3164] = {
    [sym_block_comment] = STATE(3164),
    [sym_compiler_directive_decl] = STATE(3164),
    [sym_fsi_directive_decl] = STATE(3164),
    [sym_preproc_line] = STATE(3164),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3843),
    [anon_sym_COLON] = ACTIONS(3845),
    [anon_sym_return] = ACTIONS(3845),
    [anon_sym_do] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_let_BANG] = ACTIONS(3843),
    [anon_sym_as] = ACTIONS(3845),
    [anon_sym_LPAREN] = ACTIONS(3845),
    [anon_sym_COMMA] = ACTIONS(3843),
    [anon_sym_null] = ACTIONS(3845),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3843),
    [anon_sym_LBRACE] = ACTIONS(3845),
    [anon_sym_LT_AT] = ACTIONS(3845),
    [anon_sym_LT_AT_AT] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3843),
    [anon_sym_new] = ACTIONS(3845),
    [anon_sym_with] = ACTIONS(3845),
    [anon_sym_return_BANG] = ACTIONS(3843),
    [anon_sym_yield] = ACTIONS(3845),
    [anon_sym_yield_BANG] = ACTIONS(3843),
    [anon_sym_lazy] = ACTIONS(3845),
    [anon_sym_assert] = ACTIONS(3845),
    [anon_sym_upcast] = ACTIONS(3845),
    [anon_sym_downcast] = ACTIONS(3845),
    [anon_sym_COLON_GT] = ACTIONS(3843),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3843),
    [anon_sym_for] = ACTIONS(3845),
    [anon_sym_while] = ACTIONS(3845),
    [anon_sym_if] = ACTIONS(3845),
    [anon_sym_fun] = ACTIONS(3845),
    [anon_sym_try] = ACTIONS(3845),
    [anon_sym_match] = ACTIONS(3845),
    [anon_sym_match_BANG] = ACTIONS(3843),
    [anon_sym_function] = ACTIONS(3845),
    [anon_sym_LT_DASH] = ACTIONS(3845),
    [anon_sym_DOT_LBRACK] = ACTIONS(3843),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_use] = ACTIONS(3845),
    [anon_sym_use_BANG] = ACTIONS(3843),
    [anon_sym_do_BANG] = ACTIONS(3843),
    [anon_sym_begin] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(3845),
    [anon_sym_or] = ACTIONS(3845),
    [aux_sym_char_token1] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3845),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_AT_DQUOTE] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [sym_bool] = ACTIONS(3845),
    [sym_unit] = ACTIONS(3843),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3845),
    [sym_op_identifier] = ACTIONS(3845),
    [anon_sym_PLUS] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_PLUS_DOT] = ACTIONS(3845),
    [anon_sym_DASH_DOT] = ACTIONS(3845),
    [anon_sym_PERCENT] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3845),
    [anon_sym_TILDE] = ACTIONS(3843),
    [aux_sym_prefix_op_token1] = ACTIONS(3845),
    [aux_sym_infix_op_token1] = ACTIONS(3843),
    [aux_sym_infix_op_token2] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(3845),
    [anon_sym_BANG_EQ] = ACTIONS(3845),
    [anon_sym_COLON_EQ] = ACTIONS(3843),
    [anon_sym_DOLLAR] = ACTIONS(3845),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3845),
    [sym_int] = ACTIONS(3845),
    [sym_xint] = ACTIONS(3843),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3843),
    [sym__newline] = ACTIONS(3843),
  },
  [3165] = {
    [sym_block_comment] = STATE(3165),
    [sym_compiler_directive_decl] = STATE(3165),
    [sym_fsi_directive_decl] = STATE(3165),
    [sym_preproc_line] = STATE(3165),
    [sym_identifier] = ACTIONS(3881),
    [anon_sym_EQ] = ACTIONS(3879),
    [anon_sym_COLON] = ACTIONS(3881),
    [anon_sym_return] = ACTIONS(3881),
    [anon_sym_do] = ACTIONS(3881),
    [anon_sym_let] = ACTIONS(3881),
    [anon_sym_let_BANG] = ACTIONS(3879),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3879),
    [anon_sym_null] = ACTIONS(3881),
    [anon_sym_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3879),
    [anon_sym_LBRACE] = ACTIONS(3881),
    [anon_sym_LT_AT] = ACTIONS(3881),
    [anon_sym_LT_AT_AT] = ACTIONS(3881),
    [anon_sym_DOT] = ACTIONS(3881),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3879),
    [anon_sym_new] = ACTIONS(3881),
    [anon_sym_return_BANG] = ACTIONS(3879),
    [anon_sym_yield] = ACTIONS(3881),
    [anon_sym_yield_BANG] = ACTIONS(3879),
    [anon_sym_lazy] = ACTIONS(3881),
    [anon_sym_assert] = ACTIONS(3881),
    [anon_sym_upcast] = ACTIONS(3881),
    [anon_sym_downcast] = ACTIONS(3881),
    [anon_sym_COLON_GT] = ACTIONS(3879),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3879),
    [anon_sym_for] = ACTIONS(3881),
    [anon_sym_while] = ACTIONS(3881),
    [anon_sym_if] = ACTIONS(3881),
    [anon_sym_fun] = ACTIONS(3881),
    [anon_sym_DASH_GT] = ACTIONS(3881),
    [anon_sym_try] = ACTIONS(3881),
    [anon_sym_match] = ACTIONS(3881),
    [anon_sym_match_BANG] = ACTIONS(3879),
    [anon_sym_function] = ACTIONS(3881),
    [anon_sym_LT_DASH] = ACTIONS(3881),
    [anon_sym_DOT_LBRACK] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_use] = ACTIONS(3881),
    [anon_sym_use_BANG] = ACTIONS(3879),
    [anon_sym_do_BANG] = ACTIONS(3879),
    [anon_sym_DOT_DOT] = ACTIONS(3879),
    [anon_sym_begin] = ACTIONS(3881),
    [anon_sym_LPAREN2] = ACTIONS(3881),
    [anon_sym_or] = ACTIONS(3881),
    [aux_sym_char_token1] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3881),
    [anon_sym_DQUOTE] = ACTIONS(3881),
    [anon_sym_AT_DQUOTE] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [sym_bool] = ACTIONS(3881),
    [sym_unit] = ACTIONS(3879),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3881),
    [sym_op_identifier] = ACTIONS(3881),
    [anon_sym_PLUS] = ACTIONS(3881),
    [anon_sym_DASH] = ACTIONS(3881),
    [anon_sym_PLUS_DOT] = ACTIONS(3881),
    [anon_sym_DASH_DOT] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(3881),
    [anon_sym_AMP_AMP] = ACTIONS(3881),
    [anon_sym_TILDE] = ACTIONS(3879),
    [aux_sym_prefix_op_token1] = ACTIONS(3881),
    [aux_sym_infix_op_token1] = ACTIONS(3879),
    [aux_sym_infix_op_token2] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE] = ACTIONS(3881),
    [anon_sym_BANG_EQ] = ACTIONS(3881),
    [anon_sym_COLON_EQ] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3881),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3881),
    [sym_int] = ACTIONS(3881),
    [sym_xint] = ACTIONS(3879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3879),
    [sym__newline] = ACTIONS(3879),
  },
  [3166] = {
    [sym_block_comment] = STATE(3166),
    [sym_compiler_directive_decl] = STATE(3166),
    [sym_fsi_directive_decl] = STATE(3166),
    [sym_preproc_line] = STATE(3166),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_AT_AT_GT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [3167] = {
    [sym_block_comment] = STATE(3167),
    [sym_compiler_directive_decl] = STATE(3167),
    [sym_fsi_directive_decl] = STATE(3167),
    [sym_preproc_line] = STATE(3167),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_AT_GT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [3168] = {
    [sym_block_comment] = STATE(3168),
    [sym_compiler_directive_decl] = STATE(3168),
    [sym_fsi_directive_decl] = STATE(3168),
    [sym_preproc_line] = STATE(3168),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(5635),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_DOT_DOT] = ACTIONS(3683),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
  },
  [3169] = {
    [sym_block_comment] = STATE(3169),
    [sym_compiler_directive_decl] = STATE(3169),
    [sym_fsi_directive_decl] = STATE(3169),
    [sym_preproc_line] = STATE(3169),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_EQ] = ACTIONS(4001),
    [anon_sym_COLON] = ACTIONS(4003),
    [anon_sym_return] = ACTIONS(4003),
    [anon_sym_do] = ACTIONS(4003),
    [anon_sym_let] = ACTIONS(4003),
    [anon_sym_let_BANG] = ACTIONS(4001),
    [anon_sym_as] = ACTIONS(4003),
    [anon_sym_LPAREN] = ACTIONS(4003),
    [anon_sym_COMMA] = ACTIONS(4001),
    [anon_sym_null] = ACTIONS(4003),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_COLON] = ACTIONS(4001),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LBRACK] = ACTIONS(4003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4001),
    [anon_sym_LBRACE] = ACTIONS(4003),
    [anon_sym_LT_AT] = ACTIONS(4003),
    [anon_sym_LT_AT_AT] = ACTIONS(4003),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4001),
    [anon_sym_new] = ACTIONS(4003),
    [anon_sym_with] = ACTIONS(4003),
    [anon_sym_return_BANG] = ACTIONS(4001),
    [anon_sym_yield] = ACTIONS(4003),
    [anon_sym_yield_BANG] = ACTIONS(4001),
    [anon_sym_lazy] = ACTIONS(4003),
    [anon_sym_assert] = ACTIONS(4003),
    [anon_sym_upcast] = ACTIONS(4003),
    [anon_sym_downcast] = ACTIONS(4003),
    [anon_sym_COLON_GT] = ACTIONS(4001),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4001),
    [anon_sym_for] = ACTIONS(4003),
    [anon_sym_while] = ACTIONS(4003),
    [anon_sym_if] = ACTIONS(4003),
    [anon_sym_fun] = ACTIONS(4003),
    [anon_sym_try] = ACTIONS(4003),
    [anon_sym_match] = ACTIONS(4003),
    [anon_sym_match_BANG] = ACTIONS(4001),
    [anon_sym_function] = ACTIONS(4003),
    [anon_sym_LT_DASH] = ACTIONS(4003),
    [anon_sym_DOT_LBRACK] = ACTIONS(4001),
    [anon_sym_LT] = ACTIONS(4001),
    [anon_sym_use] = ACTIONS(4003),
    [anon_sym_use_BANG] = ACTIONS(4001),
    [anon_sym_do_BANG] = ACTIONS(4001),
    [anon_sym_begin] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [aux_sym_char_token1] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4003),
    [anon_sym_DQUOTE] = ACTIONS(4003),
    [anon_sym_AT_DQUOTE] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [sym_bool] = ACTIONS(4003),
    [sym_unit] = ACTIONS(4001),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4003),
    [sym_op_identifier] = ACTIONS(4003),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_PLUS_DOT] = ACTIONS(4003),
    [anon_sym_DASH_DOT] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4003),
    [anon_sym_TILDE] = ACTIONS(4001),
    [aux_sym_prefix_op_token1] = ACTIONS(4003),
    [aux_sym_infix_op_token1] = ACTIONS(4001),
    [aux_sym_infix_op_token2] = ACTIONS(4003),
    [anon_sym_PIPE_PIPE] = ACTIONS(4003),
    [anon_sym_BANG_EQ] = ACTIONS(4003),
    [anon_sym_COLON_EQ] = ACTIONS(4001),
    [anon_sym_DOLLAR] = ACTIONS(4003),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4003),
    [sym_int] = ACTIONS(4003),
    [sym_xint] = ACTIONS(4001),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4001),
    [sym__newline] = ACTIONS(4001),
  },
  [3170] = {
    [sym_block_comment] = STATE(3170),
    [sym_compiler_directive_decl] = STATE(3170),
    [sym_fsi_directive_decl] = STATE(3170),
    [sym_preproc_line] = STATE(3170),
    [sym_identifier] = ACTIONS(3996),
    [anon_sym_EQ] = ACTIONS(3994),
    [anon_sym_COLON] = ACTIONS(3996),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_do] = ACTIONS(3996),
    [anon_sym_let] = ACTIONS(3996),
    [anon_sym_let_BANG] = ACTIONS(3994),
    [anon_sym_as] = ACTIONS(3996),
    [anon_sym_LPAREN] = ACTIONS(3996),
    [anon_sym_COMMA] = ACTIONS(3994),
    [anon_sym_null] = ACTIONS(3996),
    [anon_sym_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_COLON] = ACTIONS(3994),
    [anon_sym_AMP] = ACTIONS(3996),
    [anon_sym_LBRACK] = ACTIONS(3996),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3994),
    [anon_sym_LBRACE] = ACTIONS(3996),
    [anon_sym_LT_AT] = ACTIONS(3996),
    [anon_sym_LT_AT_AT] = ACTIONS(3996),
    [anon_sym_DOT] = ACTIONS(3996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3994),
    [anon_sym_new] = ACTIONS(3996),
    [anon_sym_with] = ACTIONS(3996),
    [anon_sym_return_BANG] = ACTIONS(3994),
    [anon_sym_yield] = ACTIONS(3996),
    [anon_sym_yield_BANG] = ACTIONS(3994),
    [anon_sym_lazy] = ACTIONS(3996),
    [anon_sym_assert] = ACTIONS(3996),
    [anon_sym_upcast] = ACTIONS(3996),
    [anon_sym_downcast] = ACTIONS(3996),
    [anon_sym_COLON_GT] = ACTIONS(3994),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3994),
    [anon_sym_for] = ACTIONS(3996),
    [anon_sym_while] = ACTIONS(3996),
    [anon_sym_if] = ACTIONS(3996),
    [anon_sym_fun] = ACTIONS(3996),
    [anon_sym_try] = ACTIONS(3996),
    [anon_sym_match] = ACTIONS(3996),
    [anon_sym_match_BANG] = ACTIONS(3994),
    [anon_sym_function] = ACTIONS(3996),
    [anon_sym_LT_DASH] = ACTIONS(3996),
    [anon_sym_DOT_LBRACK] = ACTIONS(3994),
    [anon_sym_LT] = ACTIONS(3994),
    [anon_sym_use] = ACTIONS(3996),
    [anon_sym_use_BANG] = ACTIONS(3994),
    [anon_sym_do_BANG] = ACTIONS(3994),
    [anon_sym_begin] = ACTIONS(3996),
    [anon_sym_LPAREN2] = ACTIONS(3996),
    [anon_sym_or] = ACTIONS(3996),
    [aux_sym_char_token1] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3996),
    [anon_sym_DQUOTE] = ACTIONS(3996),
    [anon_sym_AT_DQUOTE] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [sym_bool] = ACTIONS(3996),
    [sym_unit] = ACTIONS(3994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3996),
    [sym_op_identifier] = ACTIONS(3996),
    [anon_sym_PLUS] = ACTIONS(3996),
    [anon_sym_DASH] = ACTIONS(3996),
    [anon_sym_PLUS_DOT] = ACTIONS(3996),
    [anon_sym_DASH_DOT] = ACTIONS(3996),
    [anon_sym_PERCENT] = ACTIONS(3996),
    [anon_sym_AMP_AMP] = ACTIONS(3996),
    [anon_sym_TILDE] = ACTIONS(3994),
    [aux_sym_prefix_op_token1] = ACTIONS(3996),
    [aux_sym_infix_op_token1] = ACTIONS(3994),
    [aux_sym_infix_op_token2] = ACTIONS(3996),
    [anon_sym_PIPE_PIPE] = ACTIONS(3996),
    [anon_sym_BANG_EQ] = ACTIONS(3996),
    [anon_sym_COLON_EQ] = ACTIONS(3994),
    [anon_sym_DOLLAR] = ACTIONS(3996),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3996),
    [sym_int] = ACTIONS(3996),
    [sym_xint] = ACTIONS(3994),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3994),
    [sym__newline] = ACTIONS(3994),
  },
  [3171] = {
    [sym_block_comment] = STATE(3171),
    [sym_compiler_directive_decl] = STATE(3171),
    [sym_fsi_directive_decl] = STATE(3171),
    [sym_preproc_line] = STATE(3171),
    [aux_sym_long_identifier_repeat1] = STATE(3171),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(5772),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_GT] = ACTIONS(3487),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [3172] = {
    [sym_block_comment] = STATE(3172),
    [sym_compiler_directive_decl] = STATE(3172),
    [sym_fsi_directive_decl] = STATE(3172),
    [sym_preproc_line] = STATE(3172),
    [sym_identifier] = ACTIONS(4100),
    [anon_sym_EQ] = ACTIONS(4098),
    [anon_sym_COLON] = ACTIONS(4100),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_do] = ACTIONS(4100),
    [anon_sym_let] = ACTIONS(4100),
    [anon_sym_let_BANG] = ACTIONS(4098),
    [anon_sym_as] = ACTIONS(4100),
    [anon_sym_LPAREN] = ACTIONS(4100),
    [anon_sym_COMMA] = ACTIONS(4098),
    [anon_sym_null] = ACTIONS(4100),
    [anon_sym_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_COLON] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4100),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4098),
    [anon_sym_LBRACE] = ACTIONS(4100),
    [anon_sym_LT_AT] = ACTIONS(4100),
    [anon_sym_LT_AT_AT] = ACTIONS(4100),
    [anon_sym_DOT] = ACTIONS(4100),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4098),
    [anon_sym_new] = ACTIONS(4100),
    [anon_sym_with] = ACTIONS(4100),
    [anon_sym_return_BANG] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4100),
    [anon_sym_yield_BANG] = ACTIONS(4098),
    [anon_sym_lazy] = ACTIONS(4100),
    [anon_sym_assert] = ACTIONS(4100),
    [anon_sym_upcast] = ACTIONS(4100),
    [anon_sym_downcast] = ACTIONS(4100),
    [anon_sym_COLON_GT] = ACTIONS(4098),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4098),
    [anon_sym_for] = ACTIONS(4100),
    [anon_sym_while] = ACTIONS(4100),
    [anon_sym_if] = ACTIONS(4100),
    [anon_sym_fun] = ACTIONS(4100),
    [anon_sym_try] = ACTIONS(4100),
    [anon_sym_match] = ACTIONS(4100),
    [anon_sym_match_BANG] = ACTIONS(4098),
    [anon_sym_function] = ACTIONS(4100),
    [anon_sym_LT_DASH] = ACTIONS(4100),
    [anon_sym_DOT_LBRACK] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(4098),
    [anon_sym_use] = ACTIONS(4100),
    [anon_sym_use_BANG] = ACTIONS(4098),
    [anon_sym_do_BANG] = ACTIONS(4098),
    [anon_sym_begin] = ACTIONS(4100),
    [anon_sym_LPAREN2] = ACTIONS(4100),
    [anon_sym_or] = ACTIONS(4100),
    [aux_sym_char_token1] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4100),
    [anon_sym_DQUOTE] = ACTIONS(4100),
    [anon_sym_AT_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [sym_bool] = ACTIONS(4100),
    [sym_unit] = ACTIONS(4098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4100),
    [sym_op_identifier] = ACTIONS(4100),
    [anon_sym_PLUS] = ACTIONS(4100),
    [anon_sym_DASH] = ACTIONS(4100),
    [anon_sym_PLUS_DOT] = ACTIONS(4100),
    [anon_sym_DASH_DOT] = ACTIONS(4100),
    [anon_sym_PERCENT] = ACTIONS(4100),
    [anon_sym_AMP_AMP] = ACTIONS(4100),
    [anon_sym_TILDE] = ACTIONS(4098),
    [aux_sym_prefix_op_token1] = ACTIONS(4100),
    [aux_sym_infix_op_token1] = ACTIONS(4098),
    [aux_sym_infix_op_token2] = ACTIONS(4100),
    [anon_sym_PIPE_PIPE] = ACTIONS(4100),
    [anon_sym_BANG_EQ] = ACTIONS(4100),
    [anon_sym_COLON_EQ] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4100),
    [sym_int] = ACTIONS(4100),
    [sym_xint] = ACTIONS(4098),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4098),
    [sym__newline] = ACTIONS(4098),
  },
  [3173] = {
    [sym_block_comment] = STATE(3173),
    [sym_compiler_directive_decl] = STATE(3173),
    [sym_fsi_directive_decl] = STATE(3173),
    [sym_preproc_line] = STATE(3173),
    [aux_sym_type_argument_repeat1] = STATE(3173),
    [ts_builtin_sym_end] = ACTIONS(3478),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_namespace] = ACTIONS(3480),
    [anon_sym_module] = ACTIONS(3480),
    [anon_sym_open] = ACTIONS(3480),
    [anon_sym_LBRACK_LT] = ACTIONS(3478),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_type] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_and] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [aux_sym_access_modifier_token1] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3478),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_with] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3478),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3478),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_default] = ACTIONS(3480),
    [anon_sym_or] = ACTIONS(5775),
    [anon_sym_static] = ACTIONS(3480),
    [anon_sym_member] = ACTIONS(3480),
    [anon_sym_interface] = ACTIONS(3480),
    [anon_sym_exception] = ACTIONS(3480),
    [anon_sym_abstract] = ACTIONS(3480),
    [anon_sym_val] = ACTIONS(3480),
    [anon_sym_override] = ACTIONS(3480),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3478),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3478),
    [anon_sym_DASH_DOT] = ACTIONS(3478),
    [anon_sym_PERCENT] = ACTIONS(3478),
    [anon_sym_AMP_AMP] = ACTIONS(3478),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3478),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3478),
    [anon_sym_POUNDload] = ACTIONS(3478),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
  },
  [3174] = {
    [sym_block_comment] = STATE(3174),
    [sym_compiler_directive_decl] = STATE(3174),
    [sym_fsi_directive_decl] = STATE(3174),
    [sym_preproc_line] = STATE(3174),
    [aux_sym_type_argument_repeat1] = STATE(3160),
    [ts_builtin_sym_end] = ACTIONS(3496),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_namespace] = ACTIONS(3498),
    [anon_sym_module] = ACTIONS(3498),
    [anon_sym_open] = ACTIONS(3498),
    [anon_sym_LBRACK_LT] = ACTIONS(3496),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_type] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_and] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [aux_sym_access_modifier_token1] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3496),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_with] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3496),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3496),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_default] = ACTIONS(3498),
    [anon_sym_or] = ACTIONS(5768),
    [anon_sym_static] = ACTIONS(3498),
    [anon_sym_member] = ACTIONS(3498),
    [anon_sym_interface] = ACTIONS(3498),
    [anon_sym_exception] = ACTIONS(3498),
    [anon_sym_abstract] = ACTIONS(3498),
    [anon_sym_val] = ACTIONS(3498),
    [anon_sym_override] = ACTIONS(3498),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3496),
    [anon_sym_DASH_DOT] = ACTIONS(3496),
    [anon_sym_PERCENT] = ACTIONS(3496),
    [anon_sym_AMP_AMP] = ACTIONS(3496),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3496),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3496),
    [anon_sym_POUNDload] = ACTIONS(3496),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
  },
  [3175] = {
    [sym_block_comment] = STATE(3175),
    [sym_compiler_directive_decl] = STATE(3175),
    [sym_fsi_directive_decl] = STATE(3175),
    [sym_preproc_line] = STATE(3175),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_let_BANG] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_null] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_QMARK] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_LT_AT] = ACTIONS(3743),
    [anon_sym_LT_AT_AT] = ACTIONS(3743),
    [anon_sym_DOT] = ACTIONS(3743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_return_BANG] = ACTIONS(3741),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_yield_BANG] = ACTIONS(3741),
    [anon_sym_lazy] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_upcast] = ACTIONS(3743),
    [anon_sym_downcast] = ACTIONS(3743),
    [anon_sym_COLON_GT] = ACTIONS(3741),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_fun] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_match] = ACTIONS(3743),
    [anon_sym_match_BANG] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [anon_sym_LT_DASH] = ACTIONS(3743),
    [anon_sym_DOT_LBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3741),
    [anon_sym_use] = ACTIONS(3743),
    [anon_sym_use_BANG] = ACTIONS(3741),
    [anon_sym_do_BANG] = ACTIONS(3741),
    [anon_sym_DOT_DOT] = ACTIONS(3741),
    [anon_sym_begin] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3743),
    [anon_sym_or] = ACTIONS(3743),
    [aux_sym_char_token1] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3743),
    [anon_sym_AT_DQUOTE] = ACTIONS(3741),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3741),
    [sym_bool] = ACTIONS(3743),
    [sym_unit] = ACTIONS(3741),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3743),
    [sym_op_identifier] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS_DOT] = ACTIONS(3743),
    [anon_sym_DASH_DOT] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [aux_sym_prefix_op_token1] = ACTIONS(3743),
    [aux_sym_infix_op_token1] = ACTIONS(3741),
    [aux_sym_infix_op_token2] = ACTIONS(3743),
    [anon_sym_PIPE_PIPE] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_COLON_EQ] = ACTIONS(3741),
    [anon_sym_DOLLAR] = ACTIONS(3743),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3743),
    [sym_int] = ACTIONS(3743),
    [sym_xint] = ACTIONS(3741),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3741),
    [sym__newline] = ACTIONS(3741),
  },
  [3176] = {
    [sym_block_comment] = STATE(3176),
    [sym_compiler_directive_decl] = STATE(3176),
    [sym_fsi_directive_decl] = STATE(3176),
    [sym_preproc_line] = STATE(3176),
    [sym_identifier] = ACTIONS(3800),
    [anon_sym_EQ] = ACTIONS(3798),
    [anon_sym_COLON] = ACTIONS(3800),
    [anon_sym_return] = ACTIONS(3800),
    [anon_sym_do] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_let_BANG] = ACTIONS(3798),
    [anon_sym_LPAREN] = ACTIONS(3800),
    [anon_sym_COMMA] = ACTIONS(3798),
    [anon_sym_null] = ACTIONS(3800),
    [anon_sym_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_QMARK] = ACTIONS(3800),
    [anon_sym_COLON_COLON] = ACTIONS(3798),
    [anon_sym_PIPE] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3800),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3798),
    [anon_sym_LBRACE] = ACTIONS(3800),
    [anon_sym_LT_AT] = ACTIONS(3800),
    [anon_sym_LT_AT_AT] = ACTIONS(3800),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3798),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_return_BANG] = ACTIONS(3798),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_yield_BANG] = ACTIONS(3798),
    [anon_sym_lazy] = ACTIONS(3800),
    [anon_sym_assert] = ACTIONS(3800),
    [anon_sym_upcast] = ACTIONS(3800),
    [anon_sym_downcast] = ACTIONS(3800),
    [anon_sym_COLON_GT] = ACTIONS(3798),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3798),
    [anon_sym_for] = ACTIONS(3800),
    [anon_sym_while] = ACTIONS(3800),
    [anon_sym_if] = ACTIONS(3800),
    [anon_sym_fun] = ACTIONS(3800),
    [anon_sym_try] = ACTIONS(3800),
    [anon_sym_match] = ACTIONS(3800),
    [anon_sym_match_BANG] = ACTIONS(3798),
    [anon_sym_function] = ACTIONS(3800),
    [anon_sym_LT_DASH] = ACTIONS(3800),
    [anon_sym_DOT_LBRACK] = ACTIONS(3798),
    [anon_sym_LT] = ACTIONS(3798),
    [anon_sym_use] = ACTIONS(3800),
    [anon_sym_use_BANG] = ACTIONS(3798),
    [anon_sym_do_BANG] = ACTIONS(3798),
    [anon_sym_DOT_DOT] = ACTIONS(3798),
    [anon_sym_begin] = ACTIONS(3800),
    [anon_sym_LPAREN2] = ACTIONS(3800),
    [anon_sym_or] = ACTIONS(3800),
    [aux_sym_char_token1] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3800),
    [anon_sym_DQUOTE] = ACTIONS(3800),
    [anon_sym_AT_DQUOTE] = ACTIONS(3798),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3798),
    [sym_bool] = ACTIONS(3800),
    [sym_unit] = ACTIONS(3798),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3800),
    [sym_op_identifier] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS_DOT] = ACTIONS(3800),
    [anon_sym_DASH_DOT] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3800),
    [anon_sym_AMP_AMP] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3798),
    [aux_sym_prefix_op_token1] = ACTIONS(3800),
    [aux_sym_infix_op_token1] = ACTIONS(3798),
    [aux_sym_infix_op_token2] = ACTIONS(3800),
    [anon_sym_PIPE_PIPE] = ACTIONS(3800),
    [anon_sym_BANG_EQ] = ACTIONS(3800),
    [anon_sym_COLON_EQ] = ACTIONS(3798),
    [anon_sym_DOLLAR] = ACTIONS(3800),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3800),
    [sym_int] = ACTIONS(3800),
    [sym_xint] = ACTIONS(3798),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3798),
    [sym__newline] = ACTIONS(3798),
  },
  [3177] = {
    [sym_attributes] = STATE(3988),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4988),
    [sym__pattern] = STATE(2817),
    [sym_optional_pattern] = STATE(4988),
    [sym_type_check_pattern] = STATE(4988),
    [sym_attribute_pattern] = STATE(4988),
    [sym_paren_pattern] = STATE(4988),
    [sym_as_pattern] = STATE(4988),
    [sym_cons_pattern] = STATE(4988),
    [sym_disjunct_pattern] = STATE(4988),
    [sym_conjunct_pattern] = STATE(4988),
    [sym_typed_pattern] = STATE(4988),
    [sym_list_pattern] = STATE(4988),
    [sym_array_pattern] = STATE(4988),
    [sym_record_pattern] = STATE(4988),
    [sym_named_field_pattern] = STATE(4988),
    [sym_identifier_pattern] = STATE(4988),
    [sym_long_identifier_or_op] = STATE(3177),
    [sym_char] = STATE(5109),
    [sym_format_string] = STATE(5097),
    [sym__string_literal] = STATE(5097),
    [sym_string] = STATE(5109),
    [sym_verbatim_string] = STATE(5109),
    [sym_bytearray] = STATE(5109),
    [sym_verbatim_bytearray] = STATE(5109),
    [sym_format_triple_quoted_string] = STATE(5096),
    [sym_triple_quoted_string] = STATE(5109),
    [sym_const] = STATE(4988),
    [sym_long_identifier] = STATE(4907),
    [sym_active_pattern] = STATE(5059),
    [sym__identifier_or_op] = STATE(4927),
    [sym_sbyte] = STATE(5109),
    [sym_byte] = STATE(5109),
    [sym_int16] = STATE(5109),
    [sym_uint16] = STATE(5109),
    [sym_int32] = STATE(5109),
    [sym_uint32] = STATE(5109),
    [sym_nativeint] = STATE(5109),
    [sym_unativeint] = STATE(5109),
    [sym_int64] = STATE(5109),
    [sym_uint64] = STATE(5109),
    [sym_ieee32] = STATE(5109),
    [sym_ieee64] = STATE(5109),
    [sym_bignum] = STATE(5109),
    [sym_decimal] = STATE(5109),
    [sym_float] = STATE(4781),
    [sym_block_comment] = STATE(3177),
    [sym_compiler_directive_decl] = STATE(3177),
    [sym_fsi_directive_decl] = STATE(3177),
    [sym_preproc_line] = STATE(3177),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5558),
    [anon_sym_LBRACK_LT] = ACTIONS(5562),
    [anon_sym_COLON] = ACTIONS(5558),
    [anon_sym_as] = ACTIONS(5558),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_RPAREN] = ACTIONS(5562),
    [anon_sym_COMMA] = ACTIONS(5562),
    [anon_sym_null] = ACTIONS(5558),
    [anon_sym__] = ACTIONS(5558),
    [anon_sym_QMARK] = ACTIONS(5562),
    [anon_sym_COLON_QMARK] = ACTIONS(5562),
    [anon_sym_COLON_COLON] = ACTIONS(5562),
    [anon_sym_PIPE] = ACTIONS(5562),
    [anon_sym_AMP] = ACTIONS(5562),
    [anon_sym_LBRACK] = ACTIONS(5558),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5562),
    [anon_sym_LBRACE] = ACTIONS(5562),
    [anon_sym_RBRACE] = ACTIONS(5562),
    [aux_sym_char_token1] = ACTIONS(5562),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5558),
    [anon_sym_DQUOTE] = ACTIONS(5558),
    [anon_sym_AT_DQUOTE] = ACTIONS(5562),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5562),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5562),
    [sym_bool] = ACTIONS(5558),
    [sym_unit] = ACTIONS(5562),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5558),
    [sym_op_identifier] = ACTIONS(5562),
    [sym_int] = ACTIONS(5558),
    [sym_xint] = ACTIONS(5562),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [sym__newline] = ACTIONS(5562),
  },
  [3178] = {
    [sym_block_comment] = STATE(3178),
    [sym_compiler_directive_decl] = STATE(3178),
    [sym_fsi_directive_decl] = STATE(3178),
    [sym_preproc_line] = STATE(3178),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_GT] = ACTIONS(3700),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [3179] = {
    [sym_block_comment] = STATE(3179),
    [sym_compiler_directive_decl] = STATE(3179),
    [sym_fsi_directive_decl] = STATE(3179),
    [sym_preproc_line] = STATE(3179),
    [sym_identifier] = ACTIONS(3972),
    [anon_sym_EQ] = ACTIONS(3970),
    [anon_sym_COLON] = ACTIONS(3972),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_do] = ACTIONS(3972),
    [anon_sym_let] = ACTIONS(3972),
    [anon_sym_let_BANG] = ACTIONS(3970),
    [anon_sym_as] = ACTIONS(3972),
    [anon_sym_LPAREN] = ACTIONS(3972),
    [anon_sym_COMMA] = ACTIONS(3970),
    [anon_sym_null] = ACTIONS(3972),
    [anon_sym_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_COLON] = ACTIONS(3970),
    [anon_sym_AMP] = ACTIONS(3972),
    [anon_sym_LBRACK] = ACTIONS(3972),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3970),
    [anon_sym_LBRACE] = ACTIONS(3972),
    [anon_sym_LT_AT] = ACTIONS(3972),
    [anon_sym_LT_AT_AT] = ACTIONS(3972),
    [anon_sym_DOT] = ACTIONS(3972),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3970),
    [anon_sym_new] = ACTIONS(3972),
    [anon_sym_with] = ACTIONS(3972),
    [anon_sym_return_BANG] = ACTIONS(3970),
    [anon_sym_yield] = ACTIONS(3972),
    [anon_sym_yield_BANG] = ACTIONS(3970),
    [anon_sym_lazy] = ACTIONS(3972),
    [anon_sym_assert] = ACTIONS(3972),
    [anon_sym_upcast] = ACTIONS(3972),
    [anon_sym_downcast] = ACTIONS(3972),
    [anon_sym_COLON_GT] = ACTIONS(3970),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3970),
    [anon_sym_for] = ACTIONS(3972),
    [anon_sym_while] = ACTIONS(3972),
    [anon_sym_if] = ACTIONS(3972),
    [anon_sym_fun] = ACTIONS(3972),
    [anon_sym_try] = ACTIONS(3972),
    [anon_sym_match] = ACTIONS(3972),
    [anon_sym_match_BANG] = ACTIONS(3970),
    [anon_sym_function] = ACTIONS(3972),
    [anon_sym_LT_DASH] = ACTIONS(3972),
    [anon_sym_DOT_LBRACK] = ACTIONS(3970),
    [anon_sym_LT] = ACTIONS(3970),
    [anon_sym_use] = ACTIONS(3972),
    [anon_sym_use_BANG] = ACTIONS(3970),
    [anon_sym_do_BANG] = ACTIONS(3970),
    [anon_sym_begin] = ACTIONS(3972),
    [anon_sym_LPAREN2] = ACTIONS(3972),
    [anon_sym_or] = ACTIONS(3972),
    [aux_sym_char_token1] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3972),
    [anon_sym_DQUOTE] = ACTIONS(3972),
    [anon_sym_AT_DQUOTE] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [sym_bool] = ACTIONS(3972),
    [sym_unit] = ACTIONS(3970),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3972),
    [sym_op_identifier] = ACTIONS(3972),
    [anon_sym_PLUS] = ACTIONS(3972),
    [anon_sym_DASH] = ACTIONS(3972),
    [anon_sym_PLUS_DOT] = ACTIONS(3972),
    [anon_sym_DASH_DOT] = ACTIONS(3972),
    [anon_sym_PERCENT] = ACTIONS(3972),
    [anon_sym_AMP_AMP] = ACTIONS(3972),
    [anon_sym_TILDE] = ACTIONS(3970),
    [aux_sym_prefix_op_token1] = ACTIONS(3972),
    [aux_sym_infix_op_token1] = ACTIONS(3970),
    [aux_sym_infix_op_token2] = ACTIONS(3972),
    [anon_sym_PIPE_PIPE] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3972),
    [anon_sym_COLON_EQ] = ACTIONS(3970),
    [anon_sym_DOLLAR] = ACTIONS(3972),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3972),
    [sym_int] = ACTIONS(3972),
    [sym_xint] = ACTIONS(3970),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3970),
    [sym__newline] = ACTIONS(3970),
  },
  [3180] = {
    [sym_block_comment] = STATE(3180),
    [sym_compiler_directive_decl] = STATE(3180),
    [sym_fsi_directive_decl] = STATE(3180),
    [sym_preproc_line] = STATE(3180),
    [aux_sym_long_identifier_repeat1] = STATE(3180),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(5778),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_DOT_DOT] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [3181] = {
    [sym_block_comment] = STATE(3181),
    [sym_compiler_directive_decl] = STATE(3181),
    [sym_fsi_directive_decl] = STATE(3181),
    [sym_preproc_line] = STATE(3181),
    [aux_sym_long_identifier_repeat1] = STATE(3180),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(5781),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_DOT_DOT] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_or] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
  },
  [3182] = {
    [sym_block_comment] = STATE(3182),
    [sym_compiler_directive_decl] = STATE(3182),
    [sym_fsi_directive_decl] = STATE(3182),
    [sym_preproc_line] = STATE(3182),
    [aux_sym_long_identifier_repeat1] = STATE(3171),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(5783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_GT] = ACTIONS(3451),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_or] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
  },
  [3183] = {
    [sym_block_comment] = STATE(3183),
    [sym_compiler_directive_decl] = STATE(3183),
    [sym_fsi_directive_decl] = STATE(3183),
    [sym_preproc_line] = STATE(3183),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(5547),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_GT] = ACTIONS(3685),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
  },
  [3184] = {
    [sym_block_comment] = STATE(3184),
    [sym_compiler_directive_decl] = STATE(3184),
    [sym_fsi_directive_decl] = STATE(3184),
    [sym_preproc_line] = STATE(3184),
    [sym_identifier] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3685),
    [anon_sym_do] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3685),
    [anon_sym_let_BANG] = ACTIONS(3683),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_null] = ACTIONS(3685),
    [anon_sym_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_QMARK] = ACTIONS(3685),
    [anon_sym_COLON_COLON] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_LT_AT] = ACTIONS(3685),
    [anon_sym_LT_AT_AT] = ACTIONS(3685),
    [anon_sym_AT_AT_GT] = ACTIONS(3685),
    [anon_sym_DOT] = ACTIONS(3685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3685),
    [anon_sym_return_BANG] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3685),
    [anon_sym_yield_BANG] = ACTIONS(3683),
    [anon_sym_lazy] = ACTIONS(3685),
    [anon_sym_assert] = ACTIONS(3685),
    [anon_sym_upcast] = ACTIONS(3685),
    [anon_sym_downcast] = ACTIONS(3685),
    [anon_sym_COLON_GT] = ACTIONS(3683),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3685),
    [anon_sym_done] = ACTIONS(5348),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3685),
    [anon_sym_fun] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3685),
    [anon_sym_match] = ACTIONS(3685),
    [anon_sym_match_BANG] = ACTIONS(3683),
    [anon_sym_function] = ACTIONS(3685),
    [anon_sym_LT_DASH] = ACTIONS(3685),
    [anon_sym_DOT_LBRACK] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_use] = ACTIONS(3685),
    [anon_sym_use_BANG] = ACTIONS(3683),
    [anon_sym_do_BANG] = ACTIONS(3683),
    [anon_sym_begin] = ACTIONS(3685),
    [anon_sym_LPAREN2] = ACTIONS(3685),
    [anon_sym_or] = ACTIONS(3685),
    [aux_sym_char_token1] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_AT_DQUOTE] = ACTIONS(3683),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3683),
    [sym_bool] = ACTIONS(3685),
    [sym_unit] = ACTIONS(3683),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3685),
    [sym_op_identifier] = ACTIONS(3685),
    [anon_sym_PLUS] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3685),
    [anon_sym_PLUS_DOT] = ACTIONS(3685),
    [anon_sym_DASH_DOT] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3683),
    [aux_sym_prefix_op_token1] = ACTIONS(3685),
    [aux_sym_infix_op_token1] = ACTIONS(3683),
    [aux_sym_infix_op_token2] = ACTIONS(3685),
    [anon_sym_PIPE_PIPE] = ACTIONS(3685),
    [anon_sym_BANG_EQ] = ACTIONS(3685),
    [anon_sym_COLON_EQ] = ACTIONS(3683),
    [anon_sym_DOLLAR] = ACTIONS(3685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3685),
    [sym_int] = ACTIONS(3685),
    [sym_xint] = ACTIONS(3683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3683),
    [sym__newline] = ACTIONS(3683),
  },
  [3185] = {
    [sym_block_comment] = STATE(3185),
    [sym_compiler_directive_decl] = STATE(3185),
    [sym_fsi_directive_decl] = STATE(3185),
    [sym_preproc_line] = STATE(3185),
    [sym_identifier] = ACTIONS(3828),
    [anon_sym_EQ] = ACTIONS(3826),
    [anon_sym_COLON] = ACTIONS(3828),
    [anon_sym_return] = ACTIONS(3828),
    [anon_sym_do] = ACTIONS(3828),
    [anon_sym_let] = ACTIONS(3828),
    [anon_sym_let_BANG] = ACTIONS(3826),
    [anon_sym_LPAREN] = ACTIONS(3828),
    [anon_sym_COMMA] = ACTIONS(3826),
    [anon_sym_null] = ACTIONS(3828),
    [anon_sym_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_QMARK] = ACTIONS(3828),
    [anon_sym_COLON_COLON] = ACTIONS(3826),
    [anon_sym_PIPE] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3828),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3826),
    [anon_sym_LBRACE] = ACTIONS(3828),
    [anon_sym_LT_AT] = ACTIONS(3828),
    [anon_sym_AT_GT] = ACTIONS(3828),
    [anon_sym_LT_AT_AT] = ACTIONS(3828),
    [anon_sym_DOT] = ACTIONS(3828),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3826),
    [anon_sym_new] = ACTIONS(3828),
    [anon_sym_return_BANG] = ACTIONS(3826),
    [anon_sym_yield] = ACTIONS(3828),
    [anon_sym_yield_BANG] = ACTIONS(3826),
    [anon_sym_lazy] = ACTIONS(3828),
    [anon_sym_assert] = ACTIONS(3828),
    [anon_sym_upcast] = ACTIONS(3828),
    [anon_sym_downcast] = ACTIONS(3828),
    [anon_sym_COLON_GT] = ACTIONS(3826),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3826),
    [anon_sym_for] = ACTIONS(3828),
    [anon_sym_while] = ACTIONS(3828),
    [anon_sym_if] = ACTIONS(3828),
    [anon_sym_fun] = ACTIONS(3828),
    [anon_sym_try] = ACTIONS(3828),
    [anon_sym_match] = ACTIONS(3828),
    [anon_sym_match_BANG] = ACTIONS(3826),
    [anon_sym_function] = ACTIONS(3828),
    [anon_sym_LT_DASH] = ACTIONS(3828),
    [anon_sym_DOT_LBRACK] = ACTIONS(3826),
    [anon_sym_LT] = ACTIONS(3826),
    [anon_sym_use] = ACTIONS(3828),
    [anon_sym_use_BANG] = ACTIONS(3826),
    [anon_sym_do_BANG] = ACTIONS(3826),
    [anon_sym_begin] = ACTIONS(3828),
    [anon_sym_LPAREN2] = ACTIONS(3828),
    [anon_sym_or] = ACTIONS(3828),
    [aux_sym_char_token1] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3828),
    [anon_sym_DQUOTE] = ACTIONS(3828),
    [anon_sym_AT_DQUOTE] = ACTIONS(3826),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3826),
    [sym_bool] = ACTIONS(3828),
    [sym_unit] = ACTIONS(3826),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3828),
    [sym_op_identifier] = ACTIONS(3828),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_DASH] = ACTIONS(3828),
    [anon_sym_PLUS_DOT] = ACTIONS(3828),
    [anon_sym_DASH_DOT] = ACTIONS(3828),
    [anon_sym_PERCENT] = ACTIONS(3828),
    [anon_sym_AMP_AMP] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3826),
    [aux_sym_prefix_op_token1] = ACTIONS(3828),
    [aux_sym_infix_op_token1] = ACTIONS(3826),
    [aux_sym_infix_op_token2] = ACTIONS(3828),
    [anon_sym_PIPE_PIPE] = ACTIONS(3828),
    [anon_sym_BANG_EQ] = ACTIONS(3828),
    [anon_sym_COLON_EQ] = ACTIONS(3826),
    [anon_sym_DOLLAR] = ACTIONS(3828),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3828),
    [sym_int] = ACTIONS(3828),
    [sym_xint] = ACTIONS(3826),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3826),
    [sym__newline] = ACTIONS(3826),
  },
  [3186] = {
    [sym_block_comment] = STATE(3186),
    [sym_compiler_directive_decl] = STATE(3186),
    [sym_fsi_directive_decl] = STATE(3186),
    [sym_preproc_line] = STATE(3186),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_DASH_GT] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_DOT_DOT] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
  },
  [3187] = {
    [sym_block_comment] = STATE(3187),
    [sym_compiler_directive_decl] = STATE(3187),
    [sym_fsi_directive_decl] = STATE(3187),
    [sym_preproc_line] = STATE(3187),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(5785),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_DASH_GT] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_DOT_DOT] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
  },
  [3188] = {
    [sym_block_comment] = STATE(3188),
    [sym_compiler_directive_decl] = STATE(3188),
    [sym_fsi_directive_decl] = STATE(3188),
    [sym_preproc_line] = STATE(3188),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_COLON] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_COMMA] = ACTIONS(3698),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_QMARK] = ACTIONS(3700),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3700),
    [anon_sym_DOT] = ACTIONS(3700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_COLON_GT] = ACTIONS(3698),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3698),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_LT_DASH] = ACTIONS(3700),
    [anon_sym_DOT_LBRACK] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_DOT_DOT] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_LPAREN2] = ACTIONS(3700),
    [anon_sym_or] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3700),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3700),
    [anon_sym_DASH_DOT] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_AMP_AMP] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3700),
    [aux_sym_infix_op_token1] = ACTIONS(3698),
    [aux_sym_infix_op_token2] = ACTIONS(3700),
    [anon_sym_PIPE_PIPE] = ACTIONS(3700),
    [anon_sym_BANG_EQ] = ACTIONS(3700),
    [anon_sym_COLON_EQ] = ACTIONS(3698),
    [anon_sym_DOLLAR] = ACTIONS(3700),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3700),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
  },
  [3189] = {
    [sym_block_comment] = STATE(3189),
    [sym_compiler_directive_decl] = STATE(3189),
    [sym_fsi_directive_decl] = STATE(3189),
    [sym_preproc_line] = STATE(3189),
    [sym_identifier] = ACTIONS(3813),
    [anon_sym_EQ] = ACTIONS(3811),
    [anon_sym_COLON] = ACTIONS(3813),
    [anon_sym_return] = ACTIONS(3813),
    [anon_sym_do] = ACTIONS(3813),
    [anon_sym_let] = ACTIONS(3813),
    [anon_sym_let_BANG] = ACTIONS(3811),
    [anon_sym_LPAREN] = ACTIONS(3813),
    [anon_sym_COMMA] = ACTIONS(3811),
    [anon_sym_null] = ACTIONS(3813),
    [anon_sym_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_COLON] = ACTIONS(3811),
    [anon_sym_AMP] = ACTIONS(3813),
    [anon_sym_LBRACK] = ACTIONS(3813),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3811),
    [anon_sym_LBRACE] = ACTIONS(3813),
    [anon_sym_LT_AT] = ACTIONS(3813),
    [anon_sym_LT_AT_AT] = ACTIONS(3813),
    [anon_sym_DOT] = ACTIONS(3813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3811),
    [anon_sym_new] = ACTIONS(3813),
    [anon_sym_return_BANG] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_yield_BANG] = ACTIONS(3811),
    [anon_sym_lazy] = ACTIONS(3813),
    [anon_sym_assert] = ACTIONS(3813),
    [anon_sym_upcast] = ACTIONS(3813),
    [anon_sym_downcast] = ACTIONS(3813),
    [anon_sym_COLON_GT] = ACTIONS(3811),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3811),
    [anon_sym_for] = ACTIONS(3813),
    [anon_sym_done] = ACTIONS(5787),
    [anon_sym_while] = ACTIONS(3813),
    [anon_sym_if] = ACTIONS(3813),
    [anon_sym_fun] = ACTIONS(3813),
    [anon_sym_try] = ACTIONS(3813),
    [anon_sym_match] = ACTIONS(3813),
    [anon_sym_match_BANG] = ACTIONS(3811),
    [anon_sym_function] = ACTIONS(3813),
    [anon_sym_LT_DASH] = ACTIONS(3813),
    [anon_sym_DOT_LBRACK] = ACTIONS(3811),
    [anon_sym_LT] = ACTIONS(3811),
    [anon_sym_GT] = ACTIONS(3813),
    [anon_sym_use] = ACTIONS(3813),
    [anon_sym_use_BANG] = ACTIONS(3811),
    [anon_sym_do_BANG] = ACTIONS(3811),
    [anon_sym_begin] = ACTIONS(3813),
    [anon_sym_LPAREN2] = ACTIONS(3813),
    [anon_sym_or] = ACTIONS(3813),
    [aux_sym_char_token1] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3813),
    [anon_sym_DQUOTE] = ACTIONS(3813),
    [anon_sym_AT_DQUOTE] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [sym_bool] = ACTIONS(3813),
    [sym_unit] = ACTIONS(3811),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3813),
    [sym_op_identifier] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PLUS_DOT] = ACTIONS(3813),
    [anon_sym_DASH_DOT] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3813),
    [anon_sym_AMP_AMP] = ACTIONS(3813),
    [anon_sym_TILDE] = ACTIONS(3811),
    [aux_sym_prefix_op_token1] = ACTIONS(3813),
    [aux_sym_infix_op_token1] = ACTIONS(3811),
    [aux_sym_infix_op_token2] = ACTIONS(3813),
    [anon_sym_PIPE_PIPE] = ACTIONS(3813),
    [anon_sym_BANG_EQ] = ACTIONS(3813),
    [anon_sym_COLON_EQ] = ACTIONS(3811),
    [anon_sym_DOLLAR] = ACTIONS(3813),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3813),
    [sym_int] = ACTIONS(3813),
    [sym_xint] = ACTIONS(3811),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3811),
    [sym__newline] = ACTIONS(3811),
  },
  [3190] = {
    [sym_block_comment] = STATE(3190),
    [sym_compiler_directive_decl] = STATE(3190),
    [sym_fsi_directive_decl] = STATE(3190),
    [sym_preproc_line] = STATE(3190),
    [sym_identifier] = ACTIONS(4224),
    [anon_sym_EQ] = ACTIONS(4222),
    [anon_sym_COLON] = ACTIONS(4224),
    [anon_sym_return] = ACTIONS(4224),
    [anon_sym_do] = ACTIONS(4224),
    [anon_sym_let] = ACTIONS(4224),
    [anon_sym_let_BANG] = ACTIONS(4222),
    [anon_sym_LPAREN] = ACTIONS(4224),
    [anon_sym_COMMA] = ACTIONS(4222),
    [anon_sym_null] = ACTIONS(4224),
    [anon_sym_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_COLON] = ACTIONS(4222),
    [anon_sym_AMP] = ACTIONS(4224),
    [anon_sym_LBRACK] = ACTIONS(4224),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4222),
    [anon_sym_LBRACE] = ACTIONS(4224),
    [anon_sym_LT_AT] = ACTIONS(4224),
    [anon_sym_LT_AT_AT] = ACTIONS(4224),
    [anon_sym_DOT] = ACTIONS(4224),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4222),
    [anon_sym_new] = ACTIONS(4224),
    [anon_sym_return_BANG] = ACTIONS(4222),
    [anon_sym_yield] = ACTIONS(4224),
    [anon_sym_yield_BANG] = ACTIONS(4222),
    [anon_sym_lazy] = ACTIONS(4224),
    [anon_sym_assert] = ACTIONS(4224),
    [anon_sym_upcast] = ACTIONS(4224),
    [anon_sym_downcast] = ACTIONS(4224),
    [anon_sym_COLON_GT] = ACTIONS(4222),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4222),
    [anon_sym_for] = ACTIONS(4224),
    [anon_sym_while] = ACTIONS(4224),
    [anon_sym_if] = ACTIONS(4224),
    [anon_sym_fun] = ACTIONS(4224),
    [anon_sym_DASH_GT] = ACTIONS(4224),
    [anon_sym_try] = ACTIONS(4224),
    [anon_sym_match] = ACTIONS(4224),
    [anon_sym_match_BANG] = ACTIONS(4222),
    [anon_sym_function] = ACTIONS(4224),
    [anon_sym_LT_DASH] = ACTIONS(4224),
    [anon_sym_DOT_LBRACK] = ACTIONS(4222),
    [anon_sym_LT] = ACTIONS(4222),
    [anon_sym_use] = ACTIONS(4224),
    [anon_sym_use_BANG] = ACTIONS(4222),
    [anon_sym_do_BANG] = ACTIONS(4222),
    [anon_sym_DOT_DOT] = ACTIONS(4222),
    [anon_sym_begin] = ACTIONS(4224),
    [anon_sym_LPAREN2] = ACTIONS(4224),
    [anon_sym_or] = ACTIONS(4224),
    [aux_sym_char_token1] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4224),
    [anon_sym_DQUOTE] = ACTIONS(4224),
    [anon_sym_AT_DQUOTE] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [sym_bool] = ACTIONS(4224),
    [sym_unit] = ACTIONS(4222),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4224),
    [sym_op_identifier] = ACTIONS(4224),
    [anon_sym_PLUS] = ACTIONS(4224),
    [anon_sym_DASH] = ACTIONS(4224),
    [anon_sym_PLUS_DOT] = ACTIONS(4224),
    [anon_sym_DASH_DOT] = ACTIONS(4224),
    [anon_sym_PERCENT] = ACTIONS(4224),
    [anon_sym_AMP_AMP] = ACTIONS(4224),
    [anon_sym_TILDE] = ACTIONS(4222),
    [aux_sym_prefix_op_token1] = ACTIONS(4224),
    [aux_sym_infix_op_token1] = ACTIONS(4222),
    [aux_sym_infix_op_token2] = ACTIONS(4224),
    [anon_sym_PIPE_PIPE] = ACTIONS(4224),
    [anon_sym_BANG_EQ] = ACTIONS(4224),
    [anon_sym_COLON_EQ] = ACTIONS(4222),
    [anon_sym_DOLLAR] = ACTIONS(4224),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4224),
    [sym_int] = ACTIONS(4224),
    [sym_xint] = ACTIONS(4222),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4222),
    [sym__newline] = ACTIONS(4222),
  },
  [3191] = {
    [sym_block_comment] = STATE(3191),
    [sym_compiler_directive_decl] = STATE(3191),
    [sym_fsi_directive_decl] = STATE(3191),
    [sym_preproc_line] = STATE(3191),
    [sym_identifier] = ACTIONS(3813),
    [anon_sym_EQ] = ACTIONS(3811),
    [anon_sym_COLON] = ACTIONS(3813),
    [anon_sym_return] = ACTIONS(3813),
    [anon_sym_do] = ACTIONS(3813),
    [anon_sym_let] = ACTIONS(3813),
    [anon_sym_let_BANG] = ACTIONS(3811),
    [anon_sym_LPAREN] = ACTIONS(3813),
    [anon_sym_COMMA] = ACTIONS(3811),
    [anon_sym_null] = ACTIONS(3813),
    [anon_sym_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_COLON] = ACTIONS(3811),
    [anon_sym_AMP] = ACTIONS(3813),
    [anon_sym_LBRACK] = ACTIONS(3813),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3811),
    [anon_sym_LBRACE] = ACTIONS(3813),
    [anon_sym_LT_AT] = ACTIONS(3813),
    [anon_sym_LT_AT_AT] = ACTIONS(3813),
    [anon_sym_DOT] = ACTIONS(3813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3811),
    [anon_sym_new] = ACTIONS(3813),
    [anon_sym_return_BANG] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_yield_BANG] = ACTIONS(3811),
    [anon_sym_lazy] = ACTIONS(3813),
    [anon_sym_assert] = ACTIONS(3813),
    [anon_sym_upcast] = ACTIONS(3813),
    [anon_sym_downcast] = ACTIONS(3813),
    [anon_sym_COLON_GT] = ACTIONS(3811),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3811),
    [anon_sym_for] = ACTIONS(3813),
    [anon_sym_done] = ACTIONS(5789),
    [anon_sym_while] = ACTIONS(3813),
    [anon_sym_if] = ACTIONS(3813),
    [anon_sym_fun] = ACTIONS(3813),
    [anon_sym_try] = ACTIONS(3813),
    [anon_sym_match] = ACTIONS(3813),
    [anon_sym_match_BANG] = ACTIONS(3811),
    [anon_sym_function] = ACTIONS(3813),
    [anon_sym_LT_DASH] = ACTIONS(3813),
    [anon_sym_DOT_LBRACK] = ACTIONS(3811),
    [anon_sym_LT] = ACTIONS(3811),
    [anon_sym_use] = ACTIONS(3813),
    [anon_sym_use_BANG] = ACTIONS(3811),
    [anon_sym_do_BANG] = ACTIONS(3811),
    [anon_sym_DOT_DOT] = ACTIONS(3811),
    [anon_sym_begin] = ACTIONS(3813),
    [anon_sym_LPAREN2] = ACTIONS(3813),
    [anon_sym_or] = ACTIONS(3813),
    [aux_sym_char_token1] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3813),
    [anon_sym_DQUOTE] = ACTIONS(3813),
    [anon_sym_AT_DQUOTE] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [sym_bool] = ACTIONS(3813),
    [sym_unit] = ACTIONS(3811),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3813),
    [sym_op_identifier] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PLUS_DOT] = ACTIONS(3813),
    [anon_sym_DASH_DOT] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3813),
    [anon_sym_AMP_AMP] = ACTIONS(3813),
    [anon_sym_TILDE] = ACTIONS(3811),
    [aux_sym_prefix_op_token1] = ACTIONS(3813),
    [aux_sym_infix_op_token1] = ACTIONS(3811),
    [aux_sym_infix_op_token2] = ACTIONS(3813),
    [anon_sym_PIPE_PIPE] = ACTIONS(3813),
    [anon_sym_BANG_EQ] = ACTIONS(3813),
    [anon_sym_COLON_EQ] = ACTIONS(3811),
    [anon_sym_DOLLAR] = ACTIONS(3813),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3813),
    [sym_int] = ACTIONS(3813),
    [sym_xint] = ACTIONS(3811),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3811),
    [sym__newline] = ACTIONS(3811),
  },
  [3192] = {
    [sym_block_comment] = STATE(3192),
    [sym_compiler_directive_decl] = STATE(3192),
    [sym_fsi_directive_decl] = STATE(3192),
    [sym_preproc_line] = STATE(3192),
    [sym_identifier] = ACTIONS(3946),
    [anon_sym_EQ] = ACTIONS(3944),
    [anon_sym_COLON] = ACTIONS(3946),
    [anon_sym_return] = ACTIONS(3946),
    [anon_sym_do] = ACTIONS(3946),
    [anon_sym_let] = ACTIONS(3946),
    [anon_sym_let_BANG] = ACTIONS(3944),
    [anon_sym_as] = ACTIONS(3946),
    [anon_sym_LPAREN] = ACTIONS(3946),
    [anon_sym_COMMA] = ACTIONS(3944),
    [anon_sym_null] = ACTIONS(3946),
    [anon_sym_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LBRACK] = ACTIONS(3946),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3944),
    [anon_sym_LBRACE] = ACTIONS(3946),
    [anon_sym_LT_AT] = ACTIONS(3946),
    [anon_sym_LT_AT_AT] = ACTIONS(3946),
    [anon_sym_DOT] = ACTIONS(3946),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3944),
    [anon_sym_new] = ACTIONS(3946),
    [anon_sym_with] = ACTIONS(3946),
    [anon_sym_return_BANG] = ACTIONS(3944),
    [anon_sym_yield] = ACTIONS(3946),
    [anon_sym_yield_BANG] = ACTIONS(3944),
    [anon_sym_lazy] = ACTIONS(3946),
    [anon_sym_assert] = ACTIONS(3946),
    [anon_sym_upcast] = ACTIONS(3946),
    [anon_sym_downcast] = ACTIONS(3946),
    [anon_sym_COLON_GT] = ACTIONS(3944),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3944),
    [anon_sym_for] = ACTIONS(3946),
    [anon_sym_while] = ACTIONS(3946),
    [anon_sym_if] = ACTIONS(3946),
    [anon_sym_fun] = ACTIONS(3946),
    [anon_sym_try] = ACTIONS(3946),
    [anon_sym_match] = ACTIONS(3946),
    [anon_sym_match_BANG] = ACTIONS(3944),
    [anon_sym_function] = ACTIONS(3946),
    [anon_sym_LT_DASH] = ACTIONS(3946),
    [anon_sym_DOT_LBRACK] = ACTIONS(3944),
    [anon_sym_LT] = ACTIONS(3944),
    [anon_sym_use] = ACTIONS(3946),
    [anon_sym_use_BANG] = ACTIONS(3944),
    [anon_sym_do_BANG] = ACTIONS(3944),
    [anon_sym_begin] = ACTIONS(3946),
    [anon_sym_LPAREN2] = ACTIONS(3946),
    [anon_sym_or] = ACTIONS(3946),
    [aux_sym_char_token1] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_AT_DQUOTE] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [sym_bool] = ACTIONS(3946),
    [sym_unit] = ACTIONS(3944),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3946),
    [sym_op_identifier] = ACTIONS(3946),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PLUS_DOT] = ACTIONS(3946),
    [anon_sym_DASH_DOT] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3946),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_TILDE] = ACTIONS(3944),
    [aux_sym_prefix_op_token1] = ACTIONS(3946),
    [aux_sym_infix_op_token1] = ACTIONS(3944),
    [aux_sym_infix_op_token2] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [anon_sym_BANG_EQ] = ACTIONS(3946),
    [anon_sym_COLON_EQ] = ACTIONS(3944),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3946),
    [sym_int] = ACTIONS(3946),
    [sym_xint] = ACTIONS(3944),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3944),
    [sym__newline] = ACTIONS(3944),
  },
  [3193] = {
    [sym_block_comment] = STATE(3193),
    [sym_compiler_directive_decl] = STATE(3193),
    [sym_fsi_directive_decl] = STATE(3193),
    [sym_preproc_line] = STATE(3193),
    [sym_identifier] = ACTIONS(3927),
    [anon_sym_EQ] = ACTIONS(3925),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_return] = ACTIONS(3927),
    [anon_sym_do] = ACTIONS(3927),
    [anon_sym_let] = ACTIONS(3927),
    [anon_sym_let_BANG] = ACTIONS(3925),
    [anon_sym_as] = ACTIONS(3927),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_COMMA] = ACTIONS(3925),
    [anon_sym_null] = ACTIONS(3927),
    [anon_sym_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_COLON] = ACTIONS(3925),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3925),
    [anon_sym_LBRACE] = ACTIONS(3927),
    [anon_sym_LT_AT] = ACTIONS(3927),
    [anon_sym_LT_AT_AT] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3925),
    [anon_sym_new] = ACTIONS(3927),
    [anon_sym_with] = ACTIONS(3927),
    [anon_sym_return_BANG] = ACTIONS(3925),
    [anon_sym_yield] = ACTIONS(3927),
    [anon_sym_yield_BANG] = ACTIONS(3925),
    [anon_sym_lazy] = ACTIONS(3927),
    [anon_sym_assert] = ACTIONS(3927),
    [anon_sym_upcast] = ACTIONS(3927),
    [anon_sym_downcast] = ACTIONS(3927),
    [anon_sym_COLON_GT] = ACTIONS(3925),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3925),
    [anon_sym_for] = ACTIONS(3927),
    [anon_sym_while] = ACTIONS(3927),
    [anon_sym_if] = ACTIONS(3927),
    [anon_sym_fun] = ACTIONS(3927),
    [anon_sym_try] = ACTIONS(3927),
    [anon_sym_match] = ACTIONS(3927),
    [anon_sym_match_BANG] = ACTIONS(3925),
    [anon_sym_function] = ACTIONS(3927),
    [anon_sym_LT_DASH] = ACTIONS(3927),
    [anon_sym_DOT_LBRACK] = ACTIONS(3925),
    [anon_sym_LT] = ACTIONS(3925),
    [anon_sym_use] = ACTIONS(3927),
    [anon_sym_use_BANG] = ACTIONS(3925),
    [anon_sym_do_BANG] = ACTIONS(3925),
    [anon_sym_begin] = ACTIONS(3927),
    [anon_sym_LPAREN2] = ACTIONS(3927),
    [anon_sym_or] = ACTIONS(3927),
    [aux_sym_char_token1] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_AT_DQUOTE] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [sym_bool] = ACTIONS(3927),
    [sym_unit] = ACTIONS(3925),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3927),
    [sym_op_identifier] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3927),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_PLUS_DOT] = ACTIONS(3927),
    [anon_sym_DASH_DOT] = ACTIONS(3927),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_TILDE] = ACTIONS(3925),
    [aux_sym_prefix_op_token1] = ACTIONS(3927),
    [aux_sym_infix_op_token1] = ACTIONS(3925),
    [aux_sym_infix_op_token2] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_COLON_EQ] = ACTIONS(3925),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3927),
    [sym_int] = ACTIONS(3927),
    [sym_xint] = ACTIONS(3925),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3925),
    [sym__newline] = ACTIONS(3925),
  },
  [3194] = {
    [sym_block_comment] = STATE(3194),
    [sym_compiler_directive_decl] = STATE(3194),
    [sym_fsi_directive_decl] = STATE(3194),
    [sym_preproc_line] = STATE(3194),
    [sym_identifier] = ACTIONS(3841),
    [anon_sym_EQ] = ACTIONS(3839),
    [anon_sym_COLON] = ACTIONS(3841),
    [anon_sym_return] = ACTIONS(3841),
    [anon_sym_do] = ACTIONS(3841),
    [anon_sym_let] = ACTIONS(3841),
    [anon_sym_let_BANG] = ACTIONS(3839),
    [anon_sym_LPAREN] = ACTIONS(3841),
    [anon_sym_COMMA] = ACTIONS(3839),
    [anon_sym_null] = ACTIONS(3841),
    [anon_sym_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_COLON] = ACTIONS(3839),
    [anon_sym_PIPE] = ACTIONS(3841),
    [anon_sym_AMP] = ACTIONS(3841),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(3841),
    [anon_sym_LT_AT] = ACTIONS(3841),
    [anon_sym_AT_GT] = ACTIONS(3841),
    [anon_sym_LT_AT_AT] = ACTIONS(3841),
    [anon_sym_DOT] = ACTIONS(3841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3839),
    [anon_sym_new] = ACTIONS(3841),
    [anon_sym_return_BANG] = ACTIONS(3839),
    [anon_sym_yield] = ACTIONS(3841),
    [anon_sym_yield_BANG] = ACTIONS(3839),
    [anon_sym_lazy] = ACTIONS(3841),
    [anon_sym_assert] = ACTIONS(3841),
    [anon_sym_upcast] = ACTIONS(3841),
    [anon_sym_downcast] = ACTIONS(3841),
    [anon_sym_COLON_GT] = ACTIONS(3839),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3839),
    [anon_sym_for] = ACTIONS(3841),
    [anon_sym_while] = ACTIONS(3841),
    [anon_sym_if] = ACTIONS(3841),
    [anon_sym_fun] = ACTIONS(3841),
    [anon_sym_try] = ACTIONS(3841),
    [anon_sym_match] = ACTIONS(3841),
    [anon_sym_match_BANG] = ACTIONS(3839),
    [anon_sym_function] = ACTIONS(3841),
    [anon_sym_LT_DASH] = ACTIONS(3841),
    [anon_sym_DOT_LBRACK] = ACTIONS(3839),
    [anon_sym_LT] = ACTIONS(3839),
    [anon_sym_use] = ACTIONS(3841),
    [anon_sym_use_BANG] = ACTIONS(3839),
    [anon_sym_do_BANG] = ACTIONS(3839),
    [anon_sym_begin] = ACTIONS(3841),
    [anon_sym_LPAREN2] = ACTIONS(3841),
    [anon_sym_or] = ACTIONS(3841),
    [aux_sym_char_token1] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3841),
    [anon_sym_DQUOTE] = ACTIONS(3841),
    [anon_sym_AT_DQUOTE] = ACTIONS(3839),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [sym_bool] = ACTIONS(3841),
    [sym_unit] = ACTIONS(3839),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3841),
    [sym_op_identifier] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_PLUS_DOT] = ACTIONS(3841),
    [anon_sym_DASH_DOT] = ACTIONS(3841),
    [anon_sym_PERCENT] = ACTIONS(3841),
    [anon_sym_AMP_AMP] = ACTIONS(3841),
    [anon_sym_TILDE] = ACTIONS(3839),
    [aux_sym_prefix_op_token1] = ACTIONS(3841),
    [aux_sym_infix_op_token1] = ACTIONS(3839),
    [aux_sym_infix_op_token2] = ACTIONS(3841),
    [anon_sym_PIPE_PIPE] = ACTIONS(3841),
    [anon_sym_BANG_EQ] = ACTIONS(3841),
    [anon_sym_COLON_EQ] = ACTIONS(3839),
    [anon_sym_DOLLAR] = ACTIONS(3841),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3841),
    [sym_int] = ACTIONS(3841),
    [sym_xint] = ACTIONS(3839),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3839),
    [sym__newline] = ACTIONS(3839),
  },
  [3195] = {
    [sym_block_comment] = STATE(3195),
    [sym_compiler_directive_decl] = STATE(3195),
    [sym_fsi_directive_decl] = STATE(3195),
    [sym_preproc_line] = STATE(3195),
    [aux_sym_long_identifier_repeat1] = STATE(3148),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(3449),
    [anon_sym_COLON] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_COMMA] = ACTIONS(3449),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_QMARK] = ACTIONS(3451),
    [anon_sym_COLON_COLON] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3451),
    [anon_sym_AT_AT_GT] = ACTIONS(3451),
    [anon_sym_DOT] = ACTIONS(5791),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_COLON_GT] = ACTIONS(3449),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_LT_DASH] = ACTIONS(3451),
    [anon_sym_DOT_LBRACK] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_LPAREN2] = ACTIONS(3451),
    [anon_sym_or] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3451),
    [anon_sym_DASH_DOT] = ACTIONS(3451),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3451),
    [aux_sym_infix_op_token1] = ACTIONS(3449),
    [aux_sym_infix_op_token2] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3451),
    [anon_sym_COLON_EQ] = ACTIONS(3449),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3451),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
  },
  [3196] = {
    [sym_block_comment] = STATE(3196),
    [sym_compiler_directive_decl] = STATE(3196),
    [sym_fsi_directive_decl] = STATE(3196),
    [sym_preproc_line] = STATE(3196),
    [sym_identifier] = ACTIONS(3813),
    [anon_sym_EQ] = ACTIONS(3811),
    [anon_sym_COLON] = ACTIONS(3813),
    [anon_sym_return] = ACTIONS(3813),
    [anon_sym_do] = ACTIONS(3813),
    [anon_sym_let] = ACTIONS(3813),
    [anon_sym_let_BANG] = ACTIONS(3811),
    [anon_sym_LPAREN] = ACTIONS(3813),
    [anon_sym_COMMA] = ACTIONS(3811),
    [anon_sym_null] = ACTIONS(3813),
    [anon_sym_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_COLON] = ACTIONS(3811),
    [anon_sym_AMP] = ACTIONS(3813),
    [anon_sym_LBRACK] = ACTIONS(3813),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3811),
    [anon_sym_LBRACE] = ACTIONS(3813),
    [anon_sym_LT_AT] = ACTIONS(3813),
    [anon_sym_LT_AT_AT] = ACTIONS(3813),
    [anon_sym_AT_AT_GT] = ACTIONS(3813),
    [anon_sym_DOT] = ACTIONS(3813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3811),
    [anon_sym_new] = ACTIONS(3813),
    [anon_sym_return_BANG] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3813),
    [anon_sym_yield_BANG] = ACTIONS(3811),
    [anon_sym_lazy] = ACTIONS(3813),
    [anon_sym_assert] = ACTIONS(3813),
    [anon_sym_upcast] = ACTIONS(3813),
    [anon_sym_downcast] = ACTIONS(3813),
    [anon_sym_COLON_GT] = ACTIONS(3811),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3811),
    [anon_sym_for] = ACTIONS(3813),
    [anon_sym_done] = ACTIONS(5793),
    [anon_sym_while] = ACTIONS(3813),
    [anon_sym_if] = ACTIONS(3813),
    [anon_sym_fun] = ACTIONS(3813),
    [anon_sym_try] = ACTIONS(3813),
    [anon_sym_match] = ACTIONS(3813),
    [anon_sym_match_BANG] = ACTIONS(3811),
    [anon_sym_function] = ACTIONS(3813),
    [anon_sym_LT_DASH] = ACTIONS(3813),
    [anon_sym_DOT_LBRACK] = ACTIONS(3811),
    [anon_sym_LT] = ACTIONS(3811),
    [anon_sym_use] = ACTIONS(3813),
    [anon_sym_use_BANG] = ACTIONS(3811),
    [anon_sym_do_BANG] = ACTIONS(3811),
    [anon_sym_begin] = ACTIONS(3813),
    [anon_sym_LPAREN2] = ACTIONS(3813),
    [anon_sym_or] = ACTIONS(3813),
    [aux_sym_char_token1] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3813),
    [anon_sym_DQUOTE] = ACTIONS(3813),
    [anon_sym_AT_DQUOTE] = ACTIONS(3811),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3811),
    [sym_bool] = ACTIONS(3813),
    [sym_unit] = ACTIONS(3811),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3813),
    [sym_op_identifier] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_PLUS_DOT] = ACTIONS(3813),
    [anon_sym_DASH_DOT] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3813),
    [anon_sym_AMP_AMP] = ACTIONS(3813),
    [anon_sym_TILDE] = ACTIONS(3811),
    [aux_sym_prefix_op_token1] = ACTIONS(3813),
    [aux_sym_infix_op_token1] = ACTIONS(3811),
    [aux_sym_infix_op_token2] = ACTIONS(3813),
    [anon_sym_PIPE_PIPE] = ACTIONS(3813),
    [anon_sym_BANG_EQ] = ACTIONS(3813),
    [anon_sym_COLON_EQ] = ACTIONS(3811),
    [anon_sym_DOLLAR] = ACTIONS(3813),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3813),
    [sym_int] = ACTIONS(3813),
    [sym_xint] = ACTIONS(3811),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3811),
    [sym__newline] = ACTIONS(3811),
  },
  [3197] = {
    [sym_block_comment] = STATE(3197),
    [sym_compiler_directive_decl] = STATE(3197),
    [sym_fsi_directive_decl] = STATE(3197),
    [sym_preproc_line] = STATE(3197),
    [aux_sym_sequential_expression_repeat1] = STATE(3197),
    [sym_identifier] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3765),
    [anon_sym_COLON] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_let_BANG] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(3767),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_null] = ACTIONS(3767),
    [anon_sym_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3765),
    [anon_sym_LBRACE] = ACTIONS(3767),
    [anon_sym_LT_AT] = ACTIONS(3767),
    [anon_sym_AT_GT] = ACTIONS(3767),
    [anon_sym_LT_AT_AT] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3765),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_return_BANG] = ACTIONS(3765),
    [anon_sym_yield] = ACTIONS(3767),
    [anon_sym_yield_BANG] = ACTIONS(3765),
    [anon_sym_lazy] = ACTIONS(3767),
    [anon_sym_assert] = ACTIONS(3767),
    [anon_sym_upcast] = ACTIONS(3767),
    [anon_sym_downcast] = ACTIONS(3767),
    [anon_sym_COLON_GT] = ACTIONS(3765),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3765),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_fun] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_match] = ACTIONS(3767),
    [anon_sym_match_BANG] = ACTIONS(3765),
    [anon_sym_function] = ACTIONS(3767),
    [anon_sym_LT_DASH] = ACTIONS(3767),
    [anon_sym_DOT_LBRACK] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(3765),
    [anon_sym_use] = ACTIONS(3767),
    [anon_sym_use_BANG] = ACTIONS(3765),
    [anon_sym_do_BANG] = ACTIONS(3765),
    [anon_sym_begin] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3767),
    [anon_sym_or] = ACTIONS(3767),
    [aux_sym_char_token1] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3767),
    [anon_sym_DQUOTE] = ACTIONS(3767),
    [anon_sym_AT_DQUOTE] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [sym_bool] = ACTIONS(3767),
    [sym_unit] = ACTIONS(3765),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3767),
    [sym_op_identifier] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_PLUS_DOT] = ACTIONS(3767),
    [anon_sym_DASH_DOT] = ACTIONS(3767),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_AMP_AMP] = ACTIONS(3767),
    [anon_sym_TILDE] = ACTIONS(3765),
    [aux_sym_prefix_op_token1] = ACTIONS(3767),
    [aux_sym_infix_op_token1] = ACTIONS(3765),
    [aux_sym_infix_op_token2] = ACTIONS(3767),
    [anon_sym_PIPE_PIPE] = ACTIONS(3767),
    [anon_sym_BANG_EQ] = ACTIONS(3767),
    [anon_sym_COLON_EQ] = ACTIONS(3765),
    [anon_sym_DOLLAR] = ACTIONS(3767),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3767),
    [sym_int] = ACTIONS(3767),
    [sym_xint] = ACTIONS(3765),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3765),
    [sym__newline] = ACTIONS(5795),
  },
  [3198] = {
    [sym_block_comment] = STATE(3198),
    [sym_compiler_directive_decl] = STATE(3198),
    [sym_fsi_directive_decl] = STATE(3198),
    [sym_preproc_line] = STATE(3198),
    [aux_sym_sequential_expression_repeat1] = STATE(3198),
    [sym_identifier] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3765),
    [anon_sym_COLON] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_let_BANG] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(3767),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_null] = ACTIONS(3767),
    [anon_sym_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_QMARK] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3765),
    [anon_sym_LBRACE] = ACTIONS(3767),
    [anon_sym_LT_AT] = ACTIONS(3767),
    [anon_sym_LT_AT_AT] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3765),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_return_BANG] = ACTIONS(3765),
    [anon_sym_yield] = ACTIONS(3767),
    [anon_sym_yield_BANG] = ACTIONS(3765),
    [anon_sym_lazy] = ACTIONS(3767),
    [anon_sym_assert] = ACTIONS(3767),
    [anon_sym_upcast] = ACTIONS(3767),
    [anon_sym_downcast] = ACTIONS(3767),
    [anon_sym_COLON_GT] = ACTIONS(3765),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3765),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_fun] = ACTIONS(3767),
    [anon_sym_DASH_GT] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_match] = ACTIONS(3767),
    [anon_sym_match_BANG] = ACTIONS(3765),
    [anon_sym_function] = ACTIONS(3767),
    [anon_sym_LT_DASH] = ACTIONS(3767),
    [anon_sym_DOT_LBRACK] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(3765),
    [anon_sym_use] = ACTIONS(3767),
    [anon_sym_use_BANG] = ACTIONS(3765),
    [anon_sym_do_BANG] = ACTIONS(3765),
    [anon_sym_begin] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3767),
    [anon_sym_or] = ACTIONS(3767),
    [aux_sym_char_token1] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3767),
    [anon_sym_DQUOTE] = ACTIONS(3767),
    [anon_sym_AT_DQUOTE] = ACTIONS(3765),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3765),
    [sym_bool] = ACTIONS(3767),
    [sym_unit] = ACTIONS(3765),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3767),
    [sym_op_identifier] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_PLUS_DOT] = ACTIONS(3767),
    [anon_sym_DASH_DOT] = ACTIONS(3767),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_AMP_AMP] = ACTIONS(3767),
    [anon_sym_TILDE] = ACTIONS(3765),
    [aux_sym_prefix_op_token1] = ACTIONS(3767),
    [aux_sym_infix_op_token1] = ACTIONS(3765),
    [aux_sym_infix_op_token2] = ACTIONS(3767),
    [anon_sym_PIPE_PIPE] = ACTIONS(3767),
    [anon_sym_BANG_EQ] = ACTIONS(3767),
    [anon_sym_COLON_EQ] = ACTIONS(3765),
    [anon_sym_DOLLAR] = ACTIONS(3767),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3767),
    [sym_int] = ACTIONS(3767),
    [sym_xint] = ACTIONS(3765),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3765),
    [sym__newline] = ACTIONS(5798),
  },
  [3199] = {
    [sym_block_comment] = STATE(3199),
    [sym_compiler_directive_decl] = STATE(3199),
    [sym_fsi_directive_decl] = STATE(3199),
    [sym_preproc_line] = STATE(3199),
    [sym_identifier] = ACTIONS(3889),
    [anon_sym_EQ] = ACTIONS(3887),
    [anon_sym_COLON] = ACTIONS(3889),
    [anon_sym_return] = ACTIONS(3889),
    [anon_sym_do] = ACTIONS(3889),
    [anon_sym_let] = ACTIONS(3889),
    [anon_sym_let_BANG] = ACTIONS(3887),
    [anon_sym_as] = ACTIONS(3889),
    [anon_sym_LPAREN] = ACTIONS(3889),
    [anon_sym_COMMA] = ACTIONS(3887),
    [anon_sym_null] = ACTIONS(3889),
    [anon_sym_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_COLON] = ACTIONS(3887),
    [anon_sym_AMP] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3887),
    [anon_sym_LBRACE] = ACTIONS(3889),
    [anon_sym_LT_AT] = ACTIONS(3889),
    [anon_sym_LT_AT_AT] = ACTIONS(3889),
    [anon_sym_DOT] = ACTIONS(3889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [anon_sym_new] = ACTIONS(3889),
    [anon_sym_with] = ACTIONS(3889),
    [anon_sym_return_BANG] = ACTIONS(3887),
    [anon_sym_yield] = ACTIONS(3889),
    [anon_sym_yield_BANG] = ACTIONS(3887),
    [anon_sym_lazy] = ACTIONS(3889),
    [anon_sym_assert] = ACTIONS(3889),
    [anon_sym_upcast] = ACTIONS(3889),
    [anon_sym_downcast] = ACTIONS(3889),
    [anon_sym_COLON_GT] = ACTIONS(3887),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3887),
    [anon_sym_for] = ACTIONS(3889),
    [anon_sym_while] = ACTIONS(3889),
    [anon_sym_if] = ACTIONS(3889),
    [anon_sym_fun] = ACTIONS(3889),
    [anon_sym_try] = ACTIONS(3889),
    [anon_sym_match] = ACTIONS(3889),
    [anon_sym_match_BANG] = ACTIONS(3887),
    [anon_sym_function] = ACTIONS(3889),
    [anon_sym_LT_DASH] = ACTIONS(3889),
    [anon_sym_DOT_LBRACK] = ACTIONS(3887),
    [anon_sym_LT] = ACTIONS(3887),
    [anon_sym_use] = ACTIONS(3889),
    [anon_sym_use_BANG] = ACTIONS(3887),
    [anon_sym_do_BANG] = ACTIONS(3887),
    [anon_sym_begin] = ACTIONS(3889),
    [anon_sym_LPAREN2] = ACTIONS(3889),
    [anon_sym_or] = ACTIONS(3889),
    [aux_sym_char_token1] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3889),
    [anon_sym_DQUOTE] = ACTIONS(3889),
    [anon_sym_AT_DQUOTE] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [sym_bool] = ACTIONS(3889),
    [sym_unit] = ACTIONS(3887),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3889),
    [sym_op_identifier] = ACTIONS(3889),
    [anon_sym_PLUS] = ACTIONS(3889),
    [anon_sym_DASH] = ACTIONS(3889),
    [anon_sym_PLUS_DOT] = ACTIONS(3889),
    [anon_sym_DASH_DOT] = ACTIONS(3889),
    [anon_sym_PERCENT] = ACTIONS(3889),
    [anon_sym_AMP_AMP] = ACTIONS(3889),
    [anon_sym_TILDE] = ACTIONS(3887),
    [aux_sym_prefix_op_token1] = ACTIONS(3889),
    [aux_sym_infix_op_token1] = ACTIONS(3887),
    [aux_sym_infix_op_token2] = ACTIONS(3889),
    [anon_sym_PIPE_PIPE] = ACTIONS(3889),
    [anon_sym_BANG_EQ] = ACTIONS(3889),
    [anon_sym_COLON_EQ] = ACTIONS(3887),
    [anon_sym_DOLLAR] = ACTIONS(3889),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3889),
    [sym_int] = ACTIONS(3889),
    [sym_xint] = ACTIONS(3887),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3887),
    [sym__newline] = ACTIONS(3887),
  },
  [3200] = {
    [sym_block_comment] = STATE(3200),
    [sym_compiler_directive_decl] = STATE(3200),
    [sym_fsi_directive_decl] = STATE(3200),
    [sym_preproc_line] = STATE(3200),
    [sym_identifier] = ACTIONS(3931),
    [anon_sym_EQ] = ACTIONS(3929),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_do] = ACTIONS(3931),
    [anon_sym_let] = ACTIONS(3931),
    [anon_sym_let_BANG] = ACTIONS(3929),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_COMMA] = ACTIONS(3929),
    [anon_sym_null] = ACTIONS(3931),
    [anon_sym_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_COLON] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3931),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_LT_AT] = ACTIONS(3931),
    [anon_sym_LT_AT_AT] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3931),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3929),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_return_BANG] = ACTIONS(3929),
    [anon_sym_yield] = ACTIONS(3931),
    [anon_sym_yield_BANG] = ACTIONS(3929),
    [anon_sym_lazy] = ACTIONS(3931),
    [anon_sym_assert] = ACTIONS(3931),
    [anon_sym_upcast] = ACTIONS(3931),
    [anon_sym_downcast] = ACTIONS(3931),
    [anon_sym_COLON_GT] = ACTIONS(3929),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3929),
    [anon_sym_for] = ACTIONS(3931),
    [anon_sym_while] = ACTIONS(3931),
    [anon_sym_if] = ACTIONS(3931),
    [anon_sym_fun] = ACTIONS(3931),
    [anon_sym_try] = ACTIONS(3931),
    [anon_sym_match] = ACTIONS(3931),
    [anon_sym_match_BANG] = ACTIONS(3929),
    [anon_sym_function] = ACTIONS(3931),
    [anon_sym_LT_DASH] = ACTIONS(3931),
    [anon_sym_DOT_LBRACK] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3931),
    [anon_sym_use] = ACTIONS(3931),
    [anon_sym_use_BANG] = ACTIONS(3929),
    [anon_sym_do_BANG] = ACTIONS(3929),
    [anon_sym_begin] = ACTIONS(3931),
    [anon_sym_LPAREN2] = ACTIONS(3931),
    [anon_sym_or] = ACTIONS(3931),
    [aux_sym_char_token1] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3931),
    [anon_sym_DQUOTE] = ACTIONS(3931),
    [anon_sym_AT_DQUOTE] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [sym_bool] = ACTIONS(3931),
    [sym_unit] = ACTIONS(3929),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3931),
    [sym_op_identifier] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3931),
    [anon_sym_DASH] = ACTIONS(3931),
    [anon_sym_PLUS_DOT] = ACTIONS(3931),
    [anon_sym_DASH_DOT] = ACTIONS(3931),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_TILDE] = ACTIONS(3929),
    [aux_sym_prefix_op_token1] = ACTIONS(3931),
    [aux_sym_infix_op_token1] = ACTIONS(3929),
    [aux_sym_infix_op_token2] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_COLON_EQ] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3931),
    [sym_int] = ACTIONS(3931),
    [sym_xint] = ACTIONS(3929),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3929),
    [sym__newline] = ACTIONS(3929),
  },
  [3201] = {
    [sym_block_comment] = STATE(3201),
    [sym_compiler_directive_decl] = STATE(3201),
    [sym_fsi_directive_decl] = STATE(3201),
    [sym_preproc_line] = STATE(3201),
    [sym_identifier] = ACTIONS(4064),
    [anon_sym_EQ] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4064),
    [anon_sym_return] = ACTIONS(4064),
    [anon_sym_do] = ACTIONS(4064),
    [anon_sym_let] = ACTIONS(4064),
    [anon_sym_let_BANG] = ACTIONS(4062),
    [anon_sym_LPAREN] = ACTIONS(4064),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_null] = ACTIONS(4064),
    [anon_sym_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_COLON] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4062),
    [anon_sym_LBRACE] = ACTIONS(4064),
    [anon_sym_LT_AT] = ACTIONS(4064),
    [anon_sym_LT_AT_AT] = ACTIONS(4064),
    [anon_sym_AT_AT_GT] = ACTIONS(4064),
    [anon_sym_DOT] = ACTIONS(4064),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4062),
    [anon_sym_new] = ACTIONS(4064),
    [anon_sym_return_BANG] = ACTIONS(4062),
    [anon_sym_yield] = ACTIONS(4064),
    [anon_sym_yield_BANG] = ACTIONS(4062),
    [anon_sym_lazy] = ACTIONS(4064),
    [anon_sym_assert] = ACTIONS(4064),
    [anon_sym_upcast] = ACTIONS(4064),
    [anon_sym_downcast] = ACTIONS(4064),
    [anon_sym_COLON_GT] = ACTIONS(4062),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4062),
    [anon_sym_for] = ACTIONS(4064),
    [anon_sym_while] = ACTIONS(4064),
    [anon_sym_if] = ACTIONS(4064),
    [anon_sym_fun] = ACTIONS(4064),
    [anon_sym_try] = ACTIONS(4064),
    [anon_sym_match] = ACTIONS(4064),
    [anon_sym_match_BANG] = ACTIONS(4062),
    [anon_sym_function] = ACTIONS(4064),
    [anon_sym_LT_DASH] = ACTIONS(4064),
    [anon_sym_DOT_LBRACK] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(4062),
    [anon_sym_use] = ACTIONS(4064),
    [anon_sym_use_BANG] = ACTIONS(4062),
    [anon_sym_do_BANG] = ACTIONS(4062),
    [anon_sym_begin] = ACTIONS(4064),
    [anon_sym_LPAREN2] = ACTIONS(4064),
    [anon_sym_or] = ACTIONS(4064),
    [aux_sym_char_token1] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_AT_DQUOTE] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [sym_bool] = ACTIONS(4064),
    [sym_unit] = ACTIONS(4062),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4064),
    [sym_op_identifier] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4064),
    [anon_sym_DASH] = ACTIONS(4064),
    [anon_sym_PLUS_DOT] = ACTIONS(4064),
    [anon_sym_DASH_DOT] = ACTIONS(4064),
    [anon_sym_PERCENT] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_TILDE] = ACTIONS(4062),
    [aux_sym_prefix_op_token1] = ACTIONS(4064),
    [aux_sym_infix_op_token1] = ACTIONS(4062),
    [aux_sym_infix_op_token2] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_BANG_EQ] = ACTIONS(4064),
    [anon_sym_COLON_EQ] = ACTIONS(4062),
    [anon_sym_DOLLAR] = ACTIONS(4064),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4064),
    [sym_int] = ACTIONS(4064),
    [sym_xint] = ACTIONS(4062),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4062),
    [sym__newline] = ACTIONS(4062),
  },
  [3202] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defns] = STATE(4268),
    [sym__function_or_value_defn_body] = STATE(4214),
    [sym_function_declaration_left] = STATE(9405),
    [sym_value_declaration_left] = STATE(9405),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3202),
    [sym_compiler_directive_decl] = STATE(3202),
    [sym_fsi_directive_decl] = STATE(3202),
    [sym_preproc_line] = STATE(3202),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3203] = {
    [sym_block_comment] = STATE(3203),
    [sym_compiler_directive_decl] = STATE(3203),
    [sym_fsi_directive_decl] = STATE(3203),
    [sym_preproc_line] = STATE(3203),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(5801),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_GT] = ACTIONS(4228),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
  },
  [3204] = {
    [sym_block_comment] = STATE(3204),
    [sym_compiler_directive_decl] = STATE(3204),
    [sym_fsi_directive_decl] = STATE(3204),
    [sym_preproc_line] = STATE(3204),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_GT] = ACTIONS(3487),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [3205] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_type_arguments] = STATE(3866),
    [sym__method_defn] = STATE(6323),
    [sym__property_defn] = STATE(6332),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3205),
    [sym_compiler_directive_decl] = STATE(3205),
    [sym_fsi_directive_decl] = STATE(3205),
    [sym_preproc_line] = STATE(3205),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3746),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(5803),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_COLON] = ACTIONS(5805),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [anon_sym_with] = ACTIONS(5807),
    [anon_sym_LT2] = ACTIONS(5809),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3206] = {
    [sym_block_comment] = STATE(3206),
    [sym_compiler_directive_decl] = STATE(3206),
    [sym_fsi_directive_decl] = STATE(3206),
    [sym_preproc_line] = STATE(3206),
    [ts_builtin_sym_end] = ACTIONS(3478),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_namespace] = ACTIONS(3480),
    [anon_sym_module] = ACTIONS(3480),
    [anon_sym_open] = ACTIONS(3480),
    [anon_sym_LBRACK_LT] = ACTIONS(3478),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_type] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_and] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [aux_sym_access_modifier_token1] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3478),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_with] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3478),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3478),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_default] = ACTIONS(3480),
    [anon_sym_or] = ACTIONS(3480),
    [anon_sym_static] = ACTIONS(3480),
    [anon_sym_member] = ACTIONS(3480),
    [anon_sym_interface] = ACTIONS(3480),
    [anon_sym_exception] = ACTIONS(3480),
    [anon_sym_abstract] = ACTIONS(3480),
    [anon_sym_val] = ACTIONS(3480),
    [anon_sym_override] = ACTIONS(3480),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3478),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3478),
    [anon_sym_DASH_DOT] = ACTIONS(3478),
    [anon_sym_PERCENT] = ACTIONS(3478),
    [anon_sym_AMP_AMP] = ACTIONS(3478),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3478),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3478),
    [anon_sym_POUNDload] = ACTIONS(3478),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
  },
  [3207] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(4146),
    [sym_function_declaration_left] = STATE(9431),
    [sym_value_declaration_left] = STATE(9431),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3207),
    [sym_compiler_directive_decl] = STATE(3207),
    [sym_fsi_directive_decl] = STATE(3207),
    [sym_preproc_line] = STATE(3207),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_rec] = ACTIONS(5811),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3208] = {
    [sym_block_comment] = STATE(3208),
    [sym_compiler_directive_decl] = STATE(3208),
    [sym_fsi_directive_decl] = STATE(3208),
    [sym_preproc_line] = STATE(3208),
    [sym_identifier] = ACTIONS(4170),
    [anon_sym_EQ] = ACTIONS(4168),
    [anon_sym_COLON] = ACTIONS(4170),
    [anon_sym_return] = ACTIONS(4170),
    [anon_sym_do] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_let_BANG] = ACTIONS(4168),
    [anon_sym_LPAREN] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4168),
    [anon_sym_null] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_COLON] = ACTIONS(4168),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4170),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4168),
    [anon_sym_LBRACE] = ACTIONS(4170),
    [anon_sym_LT_AT] = ACTIONS(4170),
    [anon_sym_LT_AT_AT] = ACTIONS(4170),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4168),
    [anon_sym_new] = ACTIONS(4170),
    [anon_sym_return_BANG] = ACTIONS(4168),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_yield_BANG] = ACTIONS(4168),
    [anon_sym_lazy] = ACTIONS(4170),
    [anon_sym_assert] = ACTIONS(4170),
    [anon_sym_upcast] = ACTIONS(4170),
    [anon_sym_downcast] = ACTIONS(4170),
    [anon_sym_COLON_GT] = ACTIONS(4168),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4168),
    [anon_sym_for] = ACTIONS(4170),
    [anon_sym_while] = ACTIONS(4170),
    [anon_sym_if] = ACTIONS(4170),
    [anon_sym_fun] = ACTIONS(4170),
    [anon_sym_try] = ACTIONS(4170),
    [anon_sym_match] = ACTIONS(4170),
    [anon_sym_match_BANG] = ACTIONS(4168),
    [anon_sym_function] = ACTIONS(4170),
    [anon_sym_LT_DASH] = ACTIONS(4170),
    [anon_sym_DOT_LBRACK] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4168),
    [anon_sym_use] = ACTIONS(4170),
    [anon_sym_use_BANG] = ACTIONS(4168),
    [anon_sym_do_BANG] = ACTIONS(4168),
    [anon_sym_DOT_DOT] = ACTIONS(4168),
    [anon_sym_begin] = ACTIONS(4170),
    [anon_sym_LPAREN2] = ACTIONS(4170),
    [anon_sym_or] = ACTIONS(4170),
    [aux_sym_char_token1] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4170),
    [anon_sym_DQUOTE] = ACTIONS(4170),
    [anon_sym_AT_DQUOTE] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [sym_bool] = ACTIONS(4170),
    [sym_unit] = ACTIONS(4168),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4170),
    [sym_op_identifier] = ACTIONS(4170),
    [anon_sym_PLUS] = ACTIONS(4170),
    [anon_sym_DASH] = ACTIONS(4170),
    [anon_sym_PLUS_DOT] = ACTIONS(4170),
    [anon_sym_DASH_DOT] = ACTIONS(4170),
    [anon_sym_PERCENT] = ACTIONS(4170),
    [anon_sym_AMP_AMP] = ACTIONS(4170),
    [anon_sym_TILDE] = ACTIONS(4168),
    [aux_sym_prefix_op_token1] = ACTIONS(4170),
    [aux_sym_infix_op_token1] = ACTIONS(4168),
    [aux_sym_infix_op_token2] = ACTIONS(4170),
    [anon_sym_PIPE_PIPE] = ACTIONS(4170),
    [anon_sym_BANG_EQ] = ACTIONS(4170),
    [anon_sym_COLON_EQ] = ACTIONS(4168),
    [anon_sym_DOLLAR] = ACTIONS(4170),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4170),
    [sym_int] = ACTIONS(4170),
    [sym_xint] = ACTIONS(4168),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4168),
    [sym__newline] = ACTIONS(4168),
  },
  [3209] = {
    [sym_block_comment] = STATE(3209),
    [sym_compiler_directive_decl] = STATE(3209),
    [sym_fsi_directive_decl] = STATE(3209),
    [sym_preproc_line] = STATE(3209),
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_EQ] = ACTIONS(4149),
    [anon_sym_COLON] = ACTIONS(4151),
    [anon_sym_return] = ACTIONS(4151),
    [anon_sym_do] = ACTIONS(4151),
    [anon_sym_let] = ACTIONS(4151),
    [anon_sym_let_BANG] = ACTIONS(4149),
    [anon_sym_LPAREN] = ACTIONS(4151),
    [anon_sym_COMMA] = ACTIONS(4149),
    [anon_sym_null] = ACTIONS(4151),
    [anon_sym_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_AMP] = ACTIONS(4151),
    [anon_sym_LBRACK] = ACTIONS(4151),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4149),
    [anon_sym_LBRACE] = ACTIONS(4151),
    [anon_sym_LT_AT] = ACTIONS(4151),
    [anon_sym_LT_AT_AT] = ACTIONS(4151),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4149),
    [anon_sym_new] = ACTIONS(4151),
    [anon_sym_return_BANG] = ACTIONS(4149),
    [anon_sym_yield] = ACTIONS(4151),
    [anon_sym_yield_BANG] = ACTIONS(4149),
    [anon_sym_lazy] = ACTIONS(4151),
    [anon_sym_assert] = ACTIONS(4151),
    [anon_sym_upcast] = ACTIONS(4151),
    [anon_sym_downcast] = ACTIONS(4151),
    [anon_sym_COLON_GT] = ACTIONS(4149),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4149),
    [anon_sym_for] = ACTIONS(4151),
    [anon_sym_while] = ACTIONS(4151),
    [anon_sym_if] = ACTIONS(4151),
    [anon_sym_fun] = ACTIONS(4151),
    [anon_sym_try] = ACTIONS(4151),
    [anon_sym_match] = ACTIONS(4151),
    [anon_sym_match_BANG] = ACTIONS(4149),
    [anon_sym_function] = ACTIONS(4151),
    [anon_sym_LT_DASH] = ACTIONS(4151),
    [anon_sym_DOT_LBRACK] = ACTIONS(4149),
    [anon_sym_LT] = ACTIONS(4149),
    [anon_sym_GT] = ACTIONS(4151),
    [anon_sym_use] = ACTIONS(4151),
    [anon_sym_use_BANG] = ACTIONS(4149),
    [anon_sym_do_BANG] = ACTIONS(4149),
    [anon_sym_begin] = ACTIONS(4151),
    [anon_sym_LPAREN2] = ACTIONS(4151),
    [anon_sym_or] = ACTIONS(4151),
    [aux_sym_char_token1] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4151),
    [anon_sym_DQUOTE] = ACTIONS(4151),
    [anon_sym_AT_DQUOTE] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [sym_bool] = ACTIONS(4151),
    [sym_unit] = ACTIONS(4149),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4151),
    [sym_op_identifier] = ACTIONS(4151),
    [anon_sym_PLUS] = ACTIONS(4151),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_PLUS_DOT] = ACTIONS(4151),
    [anon_sym_DASH_DOT] = ACTIONS(4151),
    [anon_sym_PERCENT] = ACTIONS(4151),
    [anon_sym_AMP_AMP] = ACTIONS(4151),
    [anon_sym_TILDE] = ACTIONS(4149),
    [aux_sym_prefix_op_token1] = ACTIONS(4151),
    [aux_sym_infix_op_token1] = ACTIONS(4149),
    [aux_sym_infix_op_token2] = ACTIONS(4151),
    [anon_sym_PIPE_PIPE] = ACTIONS(4151),
    [anon_sym_BANG_EQ] = ACTIONS(4151),
    [anon_sym_COLON_EQ] = ACTIONS(4149),
    [anon_sym_DOLLAR] = ACTIONS(4151),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4151),
    [sym_int] = ACTIONS(4151),
    [sym_xint] = ACTIONS(4149),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4149),
    [sym__newline] = ACTIONS(4149),
  },
  [3210] = {
    [sym_block_comment] = STATE(3210),
    [sym_compiler_directive_decl] = STATE(3210),
    [sym_fsi_directive_decl] = STATE(3210),
    [sym_preproc_line] = STATE(3210),
    [sym_identifier] = ACTIONS(4147),
    [anon_sym_EQ] = ACTIONS(4145),
    [anon_sym_COLON] = ACTIONS(4147),
    [anon_sym_return] = ACTIONS(4147),
    [anon_sym_do] = ACTIONS(4147),
    [anon_sym_let] = ACTIONS(4147),
    [anon_sym_let_BANG] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(4147),
    [anon_sym_COMMA] = ACTIONS(4145),
    [anon_sym_null] = ACTIONS(4147),
    [anon_sym_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_COLON] = ACTIONS(4145),
    [anon_sym_AMP] = ACTIONS(4147),
    [anon_sym_LBRACK] = ACTIONS(4147),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4145),
    [anon_sym_LBRACE] = ACTIONS(4147),
    [anon_sym_LT_AT] = ACTIONS(4147),
    [anon_sym_LT_AT_AT] = ACTIONS(4147),
    [anon_sym_DOT] = ACTIONS(4147),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4145),
    [anon_sym_new] = ACTIONS(4147),
    [anon_sym_return_BANG] = ACTIONS(4145),
    [anon_sym_yield] = ACTIONS(4147),
    [anon_sym_yield_BANG] = ACTIONS(4145),
    [anon_sym_lazy] = ACTIONS(4147),
    [anon_sym_assert] = ACTIONS(4147),
    [anon_sym_upcast] = ACTIONS(4147),
    [anon_sym_downcast] = ACTIONS(4147),
    [anon_sym_COLON_GT] = ACTIONS(4145),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4145),
    [anon_sym_for] = ACTIONS(4147),
    [anon_sym_while] = ACTIONS(4147),
    [anon_sym_if] = ACTIONS(4147),
    [anon_sym_fun] = ACTIONS(4147),
    [anon_sym_try] = ACTIONS(4147),
    [anon_sym_match] = ACTIONS(4147),
    [anon_sym_match_BANG] = ACTIONS(4145),
    [anon_sym_function] = ACTIONS(4147),
    [anon_sym_LT_DASH] = ACTIONS(4147),
    [anon_sym_DOT_LBRACK] = ACTIONS(4145),
    [anon_sym_LT] = ACTIONS(4145),
    [anon_sym_GT] = ACTIONS(4147),
    [anon_sym_use] = ACTIONS(4147),
    [anon_sym_use_BANG] = ACTIONS(4145),
    [anon_sym_do_BANG] = ACTIONS(4145),
    [anon_sym_begin] = ACTIONS(4147),
    [anon_sym_LPAREN2] = ACTIONS(4147),
    [anon_sym_or] = ACTIONS(4147),
    [aux_sym_char_token1] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4147),
    [anon_sym_DQUOTE] = ACTIONS(4147),
    [anon_sym_AT_DQUOTE] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [sym_bool] = ACTIONS(4147),
    [sym_unit] = ACTIONS(4145),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4147),
    [sym_op_identifier] = ACTIONS(4147),
    [anon_sym_PLUS] = ACTIONS(4147),
    [anon_sym_DASH] = ACTIONS(4147),
    [anon_sym_PLUS_DOT] = ACTIONS(4147),
    [anon_sym_DASH_DOT] = ACTIONS(4147),
    [anon_sym_PERCENT] = ACTIONS(4147),
    [anon_sym_AMP_AMP] = ACTIONS(4147),
    [anon_sym_TILDE] = ACTIONS(4145),
    [aux_sym_prefix_op_token1] = ACTIONS(4147),
    [aux_sym_infix_op_token1] = ACTIONS(4145),
    [aux_sym_infix_op_token2] = ACTIONS(4147),
    [anon_sym_PIPE_PIPE] = ACTIONS(4147),
    [anon_sym_BANG_EQ] = ACTIONS(4147),
    [anon_sym_COLON_EQ] = ACTIONS(4145),
    [anon_sym_DOLLAR] = ACTIONS(4147),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4147),
    [sym_int] = ACTIONS(4147),
    [sym_xint] = ACTIONS(4145),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4145),
    [sym__newline] = ACTIONS(4145),
  },
  [3211] = {
    [sym_block_comment] = STATE(3211),
    [sym_compiler_directive_decl] = STATE(3211),
    [sym_fsi_directive_decl] = STATE(3211),
    [sym_preproc_line] = STATE(3211),
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_EQ] = ACTIONS(3990),
    [anon_sym_COLON] = ACTIONS(3992),
    [anon_sym_return] = ACTIONS(3992),
    [anon_sym_do] = ACTIONS(3992),
    [anon_sym_let] = ACTIONS(3992),
    [anon_sym_let_BANG] = ACTIONS(3990),
    [anon_sym_LPAREN] = ACTIONS(3992),
    [anon_sym_COMMA] = ACTIONS(3990),
    [anon_sym_null] = ACTIONS(3992),
    [anon_sym_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [anon_sym_AMP] = ACTIONS(3992),
    [anon_sym_LBRACK] = ACTIONS(3992),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3990),
    [anon_sym_LBRACE] = ACTIONS(3992),
    [anon_sym_LT_AT] = ACTIONS(3992),
    [anon_sym_LT_AT_AT] = ACTIONS(3992),
    [anon_sym_DOT] = ACTIONS(3992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3990),
    [anon_sym_new] = ACTIONS(3992),
    [anon_sym_return_BANG] = ACTIONS(3990),
    [anon_sym_yield] = ACTIONS(3992),
    [anon_sym_yield_BANG] = ACTIONS(3990),
    [anon_sym_lazy] = ACTIONS(3992),
    [anon_sym_assert] = ACTIONS(3992),
    [anon_sym_upcast] = ACTIONS(3992),
    [anon_sym_downcast] = ACTIONS(3992),
    [anon_sym_COLON_GT] = ACTIONS(3990),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3990),
    [anon_sym_for] = ACTIONS(3992),
    [anon_sym_while] = ACTIONS(3992),
    [anon_sym_if] = ACTIONS(3992),
    [anon_sym_fun] = ACTIONS(3992),
    [anon_sym_try] = ACTIONS(3992),
    [anon_sym_match] = ACTIONS(3992),
    [anon_sym_match_BANG] = ACTIONS(3990),
    [anon_sym_function] = ACTIONS(3992),
    [anon_sym_LT_DASH] = ACTIONS(3992),
    [anon_sym_DOT_LBRACK] = ACTIONS(3990),
    [anon_sym_LT] = ACTIONS(3990),
    [anon_sym_GT] = ACTIONS(3992),
    [anon_sym_use] = ACTIONS(3992),
    [anon_sym_use_BANG] = ACTIONS(3990),
    [anon_sym_do_BANG] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_LPAREN2] = ACTIONS(3992),
    [anon_sym_or] = ACTIONS(3992),
    [aux_sym_char_token1] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3992),
    [anon_sym_DQUOTE] = ACTIONS(3992),
    [anon_sym_AT_DQUOTE] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [sym_bool] = ACTIONS(3992),
    [sym_unit] = ACTIONS(3990),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3992),
    [sym_op_identifier] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3992),
    [anon_sym_DASH] = ACTIONS(3992),
    [anon_sym_PLUS_DOT] = ACTIONS(3992),
    [anon_sym_DASH_DOT] = ACTIONS(3992),
    [anon_sym_PERCENT] = ACTIONS(3992),
    [anon_sym_AMP_AMP] = ACTIONS(3992),
    [anon_sym_TILDE] = ACTIONS(3990),
    [aux_sym_prefix_op_token1] = ACTIONS(3992),
    [aux_sym_infix_op_token1] = ACTIONS(3990),
    [aux_sym_infix_op_token2] = ACTIONS(3992),
    [anon_sym_PIPE_PIPE] = ACTIONS(3992),
    [anon_sym_BANG_EQ] = ACTIONS(3992),
    [anon_sym_COLON_EQ] = ACTIONS(3990),
    [anon_sym_DOLLAR] = ACTIONS(3992),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3992),
    [sym_int] = ACTIONS(3992),
    [sym_xint] = ACTIONS(3990),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3990),
    [sym__newline] = ACTIONS(3990),
  },
  [3212] = {
    [sym_block_comment] = STATE(3212),
    [sym_compiler_directive_decl] = STATE(3212),
    [sym_fsi_directive_decl] = STATE(3212),
    [sym_preproc_line] = STATE(3212),
    [sym_identifier] = ACTIONS(3988),
    [anon_sym_EQ] = ACTIONS(3986),
    [anon_sym_COLON] = ACTIONS(3988),
    [anon_sym_return] = ACTIONS(3988),
    [anon_sym_do] = ACTIONS(3988),
    [anon_sym_let] = ACTIONS(3988),
    [anon_sym_let_BANG] = ACTIONS(3986),
    [anon_sym_LPAREN] = ACTIONS(3988),
    [anon_sym_COMMA] = ACTIONS(3986),
    [anon_sym_null] = ACTIONS(3988),
    [anon_sym_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_COLON] = ACTIONS(3986),
    [anon_sym_AMP] = ACTIONS(3988),
    [anon_sym_LBRACK] = ACTIONS(3988),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3986),
    [anon_sym_LBRACE] = ACTIONS(3988),
    [anon_sym_LT_AT] = ACTIONS(3988),
    [anon_sym_LT_AT_AT] = ACTIONS(3988),
    [anon_sym_DOT] = ACTIONS(3988),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3986),
    [anon_sym_new] = ACTIONS(3988),
    [anon_sym_return_BANG] = ACTIONS(3986),
    [anon_sym_yield] = ACTIONS(3988),
    [anon_sym_yield_BANG] = ACTIONS(3986),
    [anon_sym_lazy] = ACTIONS(3988),
    [anon_sym_assert] = ACTIONS(3988),
    [anon_sym_upcast] = ACTIONS(3988),
    [anon_sym_downcast] = ACTIONS(3988),
    [anon_sym_COLON_GT] = ACTIONS(3986),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_while] = ACTIONS(3988),
    [anon_sym_if] = ACTIONS(3988),
    [anon_sym_fun] = ACTIONS(3988),
    [anon_sym_try] = ACTIONS(3988),
    [anon_sym_match] = ACTIONS(3988),
    [anon_sym_match_BANG] = ACTIONS(3986),
    [anon_sym_function] = ACTIONS(3988),
    [anon_sym_LT_DASH] = ACTIONS(3988),
    [anon_sym_DOT_LBRACK] = ACTIONS(3986),
    [anon_sym_LT] = ACTIONS(3986),
    [anon_sym_GT] = ACTIONS(3988),
    [anon_sym_use] = ACTIONS(3988),
    [anon_sym_use_BANG] = ACTIONS(3986),
    [anon_sym_do_BANG] = ACTIONS(3986),
    [anon_sym_begin] = ACTIONS(3988),
    [anon_sym_LPAREN2] = ACTIONS(3988),
    [anon_sym_or] = ACTIONS(3988),
    [aux_sym_char_token1] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3988),
    [anon_sym_DQUOTE] = ACTIONS(3988),
    [anon_sym_AT_DQUOTE] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [sym_bool] = ACTIONS(3988),
    [sym_unit] = ACTIONS(3986),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3988),
    [sym_op_identifier] = ACTIONS(3988),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_PLUS_DOT] = ACTIONS(3988),
    [anon_sym_DASH_DOT] = ACTIONS(3988),
    [anon_sym_PERCENT] = ACTIONS(3988),
    [anon_sym_AMP_AMP] = ACTIONS(3988),
    [anon_sym_TILDE] = ACTIONS(3986),
    [aux_sym_prefix_op_token1] = ACTIONS(3988),
    [aux_sym_infix_op_token1] = ACTIONS(3986),
    [aux_sym_infix_op_token2] = ACTIONS(3988),
    [anon_sym_PIPE_PIPE] = ACTIONS(3988),
    [anon_sym_BANG_EQ] = ACTIONS(3988),
    [anon_sym_COLON_EQ] = ACTIONS(3986),
    [anon_sym_DOLLAR] = ACTIONS(3988),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3988),
    [sym_int] = ACTIONS(3988),
    [sym_xint] = ACTIONS(3986),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3986),
    [sym__newline] = ACTIONS(3986),
  },
  [3213] = {
    [sym_block_comment] = STATE(3213),
    [sym_compiler_directive_decl] = STATE(3213),
    [sym_fsi_directive_decl] = STATE(3213),
    [sym_preproc_line] = STATE(3213),
    [sym_identifier] = ACTIONS(3984),
    [anon_sym_EQ] = ACTIONS(3982),
    [anon_sym_COLON] = ACTIONS(3984),
    [anon_sym_return] = ACTIONS(3984),
    [anon_sym_do] = ACTIONS(3984),
    [anon_sym_let] = ACTIONS(3984),
    [anon_sym_let_BANG] = ACTIONS(3982),
    [anon_sym_LPAREN] = ACTIONS(3984),
    [anon_sym_COMMA] = ACTIONS(3982),
    [anon_sym_null] = ACTIONS(3984),
    [anon_sym_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AMP] = ACTIONS(3984),
    [anon_sym_LBRACK] = ACTIONS(3984),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(3984),
    [anon_sym_LT_AT] = ACTIONS(3984),
    [anon_sym_LT_AT_AT] = ACTIONS(3984),
    [anon_sym_DOT] = ACTIONS(3984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3982),
    [anon_sym_new] = ACTIONS(3984),
    [anon_sym_return_BANG] = ACTIONS(3982),
    [anon_sym_yield] = ACTIONS(3984),
    [anon_sym_yield_BANG] = ACTIONS(3982),
    [anon_sym_lazy] = ACTIONS(3984),
    [anon_sym_assert] = ACTIONS(3984),
    [anon_sym_upcast] = ACTIONS(3984),
    [anon_sym_downcast] = ACTIONS(3984),
    [anon_sym_COLON_GT] = ACTIONS(3982),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3982),
    [anon_sym_for] = ACTIONS(3984),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_if] = ACTIONS(3984),
    [anon_sym_fun] = ACTIONS(3984),
    [anon_sym_try] = ACTIONS(3984),
    [anon_sym_match] = ACTIONS(3984),
    [anon_sym_match_BANG] = ACTIONS(3982),
    [anon_sym_function] = ACTIONS(3984),
    [anon_sym_LT_DASH] = ACTIONS(3984),
    [anon_sym_DOT_LBRACK] = ACTIONS(3982),
    [anon_sym_LT] = ACTIONS(3982),
    [anon_sym_GT] = ACTIONS(3984),
    [anon_sym_use] = ACTIONS(3984),
    [anon_sym_use_BANG] = ACTIONS(3982),
    [anon_sym_do_BANG] = ACTIONS(3982),
    [anon_sym_begin] = ACTIONS(3984),
    [anon_sym_LPAREN2] = ACTIONS(3984),
    [anon_sym_or] = ACTIONS(3984),
    [aux_sym_char_token1] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3984),
    [anon_sym_DQUOTE] = ACTIONS(3984),
    [anon_sym_AT_DQUOTE] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [sym_bool] = ACTIONS(3984),
    [sym_unit] = ACTIONS(3982),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3984),
    [sym_op_identifier] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3984),
    [anon_sym_DASH] = ACTIONS(3984),
    [anon_sym_PLUS_DOT] = ACTIONS(3984),
    [anon_sym_DASH_DOT] = ACTIONS(3984),
    [anon_sym_PERCENT] = ACTIONS(3984),
    [anon_sym_AMP_AMP] = ACTIONS(3984),
    [anon_sym_TILDE] = ACTIONS(3982),
    [aux_sym_prefix_op_token1] = ACTIONS(3984),
    [aux_sym_infix_op_token1] = ACTIONS(3982),
    [aux_sym_infix_op_token2] = ACTIONS(3984),
    [anon_sym_PIPE_PIPE] = ACTIONS(3984),
    [anon_sym_BANG_EQ] = ACTIONS(3984),
    [anon_sym_COLON_EQ] = ACTIONS(3982),
    [anon_sym_DOLLAR] = ACTIONS(3984),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3984),
    [sym_int] = ACTIONS(3984),
    [sym_xint] = ACTIONS(3982),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3982),
    [sym__newline] = ACTIONS(3982),
  },
  [3214] = {
    [sym_block_comment] = STATE(3214),
    [sym_compiler_directive_decl] = STATE(3214),
    [sym_fsi_directive_decl] = STATE(3214),
    [sym_preproc_line] = STATE(3214),
    [sym_identifier] = ACTIONS(4170),
    [anon_sym_EQ] = ACTIONS(4168),
    [anon_sym_COLON] = ACTIONS(4170),
    [anon_sym_return] = ACTIONS(4170),
    [anon_sym_do] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_let_BANG] = ACTIONS(4168),
    [anon_sym_LPAREN] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4168),
    [anon_sym_null] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_COLON] = ACTIONS(4168),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4170),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4168),
    [anon_sym_LBRACE] = ACTIONS(4170),
    [anon_sym_LT_AT] = ACTIONS(4170),
    [anon_sym_AT_GT] = ACTIONS(4170),
    [anon_sym_LT_AT_AT] = ACTIONS(4170),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4168),
    [anon_sym_new] = ACTIONS(4170),
    [anon_sym_return_BANG] = ACTIONS(4168),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_yield_BANG] = ACTIONS(4168),
    [anon_sym_lazy] = ACTIONS(4170),
    [anon_sym_assert] = ACTIONS(4170),
    [anon_sym_upcast] = ACTIONS(4170),
    [anon_sym_downcast] = ACTIONS(4170),
    [anon_sym_COLON_GT] = ACTIONS(4168),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4168),
    [anon_sym_for] = ACTIONS(4170),
    [anon_sym_while] = ACTIONS(4170),
    [anon_sym_if] = ACTIONS(4170),
    [anon_sym_fun] = ACTIONS(4170),
    [anon_sym_try] = ACTIONS(4170),
    [anon_sym_match] = ACTIONS(4170),
    [anon_sym_match_BANG] = ACTIONS(4168),
    [anon_sym_function] = ACTIONS(4170),
    [anon_sym_LT_DASH] = ACTIONS(4170),
    [anon_sym_DOT_LBRACK] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4168),
    [anon_sym_use] = ACTIONS(4170),
    [anon_sym_use_BANG] = ACTIONS(4168),
    [anon_sym_do_BANG] = ACTIONS(4168),
    [anon_sym_begin] = ACTIONS(4170),
    [anon_sym_LPAREN2] = ACTIONS(4170),
    [anon_sym_or] = ACTIONS(4170),
    [aux_sym_char_token1] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4170),
    [anon_sym_DQUOTE] = ACTIONS(4170),
    [anon_sym_AT_DQUOTE] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [sym_bool] = ACTIONS(4170),
    [sym_unit] = ACTIONS(4168),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4170),
    [sym_op_identifier] = ACTIONS(4170),
    [anon_sym_PLUS] = ACTIONS(4170),
    [anon_sym_DASH] = ACTIONS(4170),
    [anon_sym_PLUS_DOT] = ACTIONS(4170),
    [anon_sym_DASH_DOT] = ACTIONS(4170),
    [anon_sym_PERCENT] = ACTIONS(4170),
    [anon_sym_AMP_AMP] = ACTIONS(4170),
    [anon_sym_TILDE] = ACTIONS(4168),
    [aux_sym_prefix_op_token1] = ACTIONS(4170),
    [aux_sym_infix_op_token1] = ACTIONS(4168),
    [aux_sym_infix_op_token2] = ACTIONS(4170),
    [anon_sym_PIPE_PIPE] = ACTIONS(4170),
    [anon_sym_BANG_EQ] = ACTIONS(4170),
    [anon_sym_COLON_EQ] = ACTIONS(4168),
    [anon_sym_DOLLAR] = ACTIONS(4170),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4170),
    [sym_int] = ACTIONS(4170),
    [sym_xint] = ACTIONS(4168),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4168),
    [sym__newline] = ACTIONS(4168),
  },
  [3215] = {
    [sym_attributes] = STATE(3953),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(5287),
    [sym__pattern] = STATE(5203),
    [sym_optional_pattern] = STATE(5287),
    [sym_type_check_pattern] = STATE(5287),
    [sym_attribute_pattern] = STATE(5287),
    [sym_paren_pattern] = STATE(5287),
    [sym_as_pattern] = STATE(5287),
    [sym_cons_pattern] = STATE(5287),
    [sym_disjunct_pattern] = STATE(5287),
    [sym_conjunct_pattern] = STATE(5287),
    [sym_typed_pattern] = STATE(5287),
    [sym_list_pattern] = STATE(5287),
    [sym_array_pattern] = STATE(5287),
    [sym_record_pattern] = STATE(5287),
    [sym_named_field_pattern] = STATE(5287),
    [sym_identifier_pattern] = STATE(5287),
    [sym_long_identifier_or_op] = STATE(3587),
    [sym_char] = STATE(5281),
    [sym_format_string] = STATE(5312),
    [sym__string_literal] = STATE(5312),
    [sym_string] = STATE(5281),
    [sym_verbatim_string] = STATE(5281),
    [sym_bytearray] = STATE(5281),
    [sym_verbatim_bytearray] = STATE(5281),
    [sym_format_triple_quoted_string] = STATE(5246),
    [sym_triple_quoted_string] = STATE(5281),
    [sym_const] = STATE(5287),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(5281),
    [sym_byte] = STATE(5281),
    [sym_int16] = STATE(5281),
    [sym_uint16] = STATE(5281),
    [sym_int32] = STATE(5281),
    [sym_uint32] = STATE(5281),
    [sym_nativeint] = STATE(5281),
    [sym_unativeint] = STATE(5281),
    [sym_int64] = STATE(5281),
    [sym_uint64] = STATE(5281),
    [sym_ieee32] = STATE(5281),
    [sym_ieee64] = STATE(5281),
    [sym_bignum] = STATE(5281),
    [sym_decimal] = STATE(5281),
    [sym_float] = STATE(4951),
    [sym_block_comment] = STATE(3215),
    [sym_compiler_directive_decl] = STATE(3215),
    [sym_fsi_directive_decl] = STATE(3215),
    [sym_preproc_line] = STATE(3215),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym_repeat_pattern_repeat1] = STATE(5188),
    [sym_identifier] = ACTIONS(5363),
    [anon_sym_LBRACK_LT] = ACTIONS(5365),
    [anon_sym_COLON] = ACTIONS(5363),
    [anon_sym_as] = ACTIONS(5813),
    [anon_sym_LPAREN] = ACTIONS(5363),
    [anon_sym_COMMA] = ACTIONS(5815),
    [anon_sym_null] = ACTIONS(5363),
    [anon_sym__] = ACTIONS(5363),
    [anon_sym_QMARK] = ACTIONS(5365),
    [anon_sym_COLON_QMARK] = ACTIONS(5365),
    [anon_sym_COLON_COLON] = ACTIONS(5817),
    [anon_sym_PIPE] = ACTIONS(5819),
    [anon_sym_AMP] = ACTIONS(5821),
    [anon_sym_LBRACK] = ACTIONS(5363),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5365),
    [anon_sym_LBRACE] = ACTIONS(5365),
    [anon_sym_in] = ACTIONS(5363),
    [aux_sym_char_token1] = ACTIONS(5365),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5363),
    [anon_sym_DQUOTE] = ACTIONS(5363),
    [anon_sym_AT_DQUOTE] = ACTIONS(5365),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5365),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5365),
    [sym_bool] = ACTIONS(5363),
    [sym_unit] = ACTIONS(5365),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5363),
    [sym_op_identifier] = ACTIONS(5365),
    [sym_int] = ACTIONS(5363),
    [sym_xint] = ACTIONS(5365),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3216] = {
    [sym_block_comment] = STATE(3216),
    [sym_compiler_directive_decl] = STATE(3216),
    [sym_fsi_directive_decl] = STATE(3216),
    [sym_preproc_line] = STATE(3216),
    [sym_identifier] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4078),
    [anon_sym_return] = ACTIONS(4078),
    [anon_sym_do] = ACTIONS(4078),
    [anon_sym_let] = ACTIONS(4078),
    [anon_sym_let_BANG] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_null] = ACTIONS(4078),
    [anon_sym_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(4076),
    [anon_sym_AMP] = ACTIONS(4078),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4078),
    [anon_sym_LT_AT] = ACTIONS(4078),
    [anon_sym_LT_AT_AT] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(4078),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4076),
    [anon_sym_new] = ACTIONS(4078),
    [anon_sym_return_BANG] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(4078),
    [anon_sym_yield_BANG] = ACTIONS(4076),
    [anon_sym_lazy] = ACTIONS(4078),
    [anon_sym_assert] = ACTIONS(4078),
    [anon_sym_upcast] = ACTIONS(4078),
    [anon_sym_downcast] = ACTIONS(4078),
    [anon_sym_COLON_GT] = ACTIONS(4076),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4076),
    [anon_sym_for] = ACTIONS(4078),
    [anon_sym_while] = ACTIONS(4078),
    [anon_sym_if] = ACTIONS(4078),
    [anon_sym_fun] = ACTIONS(4078),
    [anon_sym_try] = ACTIONS(4078),
    [anon_sym_match] = ACTIONS(4078),
    [anon_sym_match_BANG] = ACTIONS(4076),
    [anon_sym_function] = ACTIONS(4078),
    [anon_sym_LT_DASH] = ACTIONS(4078),
    [anon_sym_DOT_LBRACK] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4076),
    [anon_sym_use] = ACTIONS(4078),
    [anon_sym_use_BANG] = ACTIONS(4076),
    [anon_sym_do_BANG] = ACTIONS(4076),
    [anon_sym_DOT_DOT] = ACTIONS(4076),
    [anon_sym_begin] = ACTIONS(4078),
    [anon_sym_LPAREN2] = ACTIONS(4078),
    [anon_sym_or] = ACTIONS(4078),
    [aux_sym_char_token1] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4078),
    [anon_sym_DQUOTE] = ACTIONS(4078),
    [anon_sym_AT_DQUOTE] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [sym_bool] = ACTIONS(4078),
    [sym_unit] = ACTIONS(4076),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4078),
    [sym_op_identifier] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(4078),
    [anon_sym_PLUS_DOT] = ACTIONS(4078),
    [anon_sym_DASH_DOT] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [anon_sym_AMP_AMP] = ACTIONS(4078),
    [anon_sym_TILDE] = ACTIONS(4076),
    [aux_sym_prefix_op_token1] = ACTIONS(4078),
    [aux_sym_infix_op_token1] = ACTIONS(4076),
    [aux_sym_infix_op_token2] = ACTIONS(4078),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_BANG_EQ] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4076),
    [anon_sym_DOLLAR] = ACTIONS(4078),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4078),
    [sym_int] = ACTIONS(4078),
    [sym_xint] = ACTIONS(4076),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4076),
    [sym__newline] = ACTIONS(4076),
  },
  [3217] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(6816),
    [sym_function_declaration_left] = STATE(9789),
    [sym_value_declaration_left] = STATE(9789),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3217),
    [sym_compiler_directive_decl] = STATE(3217),
    [sym_fsi_directive_decl] = STATE(3217),
    [sym_preproc_line] = STATE(3217),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_rec] = ACTIONS(5823),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3218] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defns] = STATE(6815),
    [sym__function_or_value_defn_body] = STATE(6447),
    [sym_function_declaration_left] = STATE(9554),
    [sym_value_declaration_left] = STATE(9554),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3218),
    [sym_compiler_directive_decl] = STATE(3218),
    [sym_fsi_directive_decl] = STATE(3218),
    [sym_preproc_line] = STATE(3218),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3219] = {
    [sym_block_comment] = STATE(3219),
    [sym_compiler_directive_decl] = STATE(3219),
    [sym_fsi_directive_decl] = STATE(3219),
    [sym_preproc_line] = STATE(3219),
    [sym_identifier] = ACTIONS(3980),
    [anon_sym_EQ] = ACTIONS(3978),
    [anon_sym_COLON] = ACTIONS(3980),
    [anon_sym_return] = ACTIONS(3980),
    [anon_sym_do] = ACTIONS(3980),
    [anon_sym_let] = ACTIONS(3980),
    [anon_sym_let_BANG] = ACTIONS(3978),
    [anon_sym_LPAREN] = ACTIONS(3980),
    [anon_sym_COMMA] = ACTIONS(3978),
    [anon_sym_null] = ACTIONS(3980),
    [anon_sym_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3978),
    [anon_sym_AMP] = ACTIONS(3980),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3978),
    [anon_sym_LBRACE] = ACTIONS(3980),
    [anon_sym_LT_AT] = ACTIONS(3980),
    [anon_sym_LT_AT_AT] = ACTIONS(3980),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3978),
    [anon_sym_new] = ACTIONS(3980),
    [anon_sym_return_BANG] = ACTIONS(3978),
    [anon_sym_yield] = ACTIONS(3980),
    [anon_sym_yield_BANG] = ACTIONS(3978),
    [anon_sym_lazy] = ACTIONS(3980),
    [anon_sym_assert] = ACTIONS(3980),
    [anon_sym_upcast] = ACTIONS(3980),
    [anon_sym_downcast] = ACTIONS(3980),
    [anon_sym_COLON_GT] = ACTIONS(3978),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3978),
    [anon_sym_for] = ACTIONS(3980),
    [anon_sym_while] = ACTIONS(3980),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_fun] = ACTIONS(3980),
    [anon_sym_try] = ACTIONS(3980),
    [anon_sym_match] = ACTIONS(3980),
    [anon_sym_match_BANG] = ACTIONS(3978),
    [anon_sym_function] = ACTIONS(3980),
    [anon_sym_LT_DASH] = ACTIONS(3980),
    [anon_sym_DOT_LBRACK] = ACTIONS(3978),
    [anon_sym_LT] = ACTIONS(3978),
    [anon_sym_GT] = ACTIONS(3980),
    [anon_sym_use] = ACTIONS(3980),
    [anon_sym_use_BANG] = ACTIONS(3978),
    [anon_sym_do_BANG] = ACTIONS(3978),
    [anon_sym_begin] = ACTIONS(3980),
    [anon_sym_LPAREN2] = ACTIONS(3980),
    [anon_sym_or] = ACTIONS(3980),
    [aux_sym_char_token1] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3980),
    [anon_sym_DQUOTE] = ACTIONS(3980),
    [anon_sym_AT_DQUOTE] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [sym_bool] = ACTIONS(3980),
    [sym_unit] = ACTIONS(3978),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3980),
    [sym_op_identifier] = ACTIONS(3980),
    [anon_sym_PLUS] = ACTIONS(3980),
    [anon_sym_DASH] = ACTIONS(3980),
    [anon_sym_PLUS_DOT] = ACTIONS(3980),
    [anon_sym_DASH_DOT] = ACTIONS(3980),
    [anon_sym_PERCENT] = ACTIONS(3980),
    [anon_sym_AMP_AMP] = ACTIONS(3980),
    [anon_sym_TILDE] = ACTIONS(3978),
    [aux_sym_prefix_op_token1] = ACTIONS(3980),
    [aux_sym_infix_op_token1] = ACTIONS(3978),
    [aux_sym_infix_op_token2] = ACTIONS(3980),
    [anon_sym_PIPE_PIPE] = ACTIONS(3980),
    [anon_sym_BANG_EQ] = ACTIONS(3980),
    [anon_sym_COLON_EQ] = ACTIONS(3978),
    [anon_sym_DOLLAR] = ACTIONS(3980),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3980),
    [sym_int] = ACTIONS(3980),
    [sym_xint] = ACTIONS(3978),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3978),
    [sym__newline] = ACTIONS(3978),
  },
  [3220] = {
    [sym_block_comment] = STATE(3220),
    [sym_compiler_directive_decl] = STATE(3220),
    [sym_fsi_directive_decl] = STATE(3220),
    [sym_preproc_line] = STATE(3220),
    [sym_identifier] = ACTIONS(3966),
    [anon_sym_EQ] = ACTIONS(3964),
    [anon_sym_COLON] = ACTIONS(3966),
    [anon_sym_return] = ACTIONS(3966),
    [anon_sym_do] = ACTIONS(3966),
    [anon_sym_let] = ACTIONS(3966),
    [anon_sym_let_BANG] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COMMA] = ACTIONS(3964),
    [anon_sym_null] = ACTIONS(3966),
    [anon_sym_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(3964),
    [anon_sym_AMP] = ACTIONS(3966),
    [anon_sym_LBRACK] = ACTIONS(3966),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3964),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_LT_AT] = ACTIONS(3966),
    [anon_sym_LT_AT_AT] = ACTIONS(3966),
    [anon_sym_DOT] = ACTIONS(3966),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3964),
    [anon_sym_new] = ACTIONS(3966),
    [anon_sym_return_BANG] = ACTIONS(3964),
    [anon_sym_yield] = ACTIONS(3966),
    [anon_sym_yield_BANG] = ACTIONS(3964),
    [anon_sym_lazy] = ACTIONS(3966),
    [anon_sym_assert] = ACTIONS(3966),
    [anon_sym_upcast] = ACTIONS(3966),
    [anon_sym_downcast] = ACTIONS(3966),
    [anon_sym_COLON_GT] = ACTIONS(3964),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3964),
    [anon_sym_for] = ACTIONS(3966),
    [anon_sym_while] = ACTIONS(3966),
    [anon_sym_if] = ACTIONS(3966),
    [anon_sym_fun] = ACTIONS(3966),
    [anon_sym_try] = ACTIONS(3966),
    [anon_sym_match] = ACTIONS(3966),
    [anon_sym_match_BANG] = ACTIONS(3964),
    [anon_sym_function] = ACTIONS(3966),
    [anon_sym_LT_DASH] = ACTIONS(3966),
    [anon_sym_DOT_LBRACK] = ACTIONS(3964),
    [anon_sym_LT] = ACTIONS(3964),
    [anon_sym_GT] = ACTIONS(3966),
    [anon_sym_use] = ACTIONS(3966),
    [anon_sym_use_BANG] = ACTIONS(3964),
    [anon_sym_do_BANG] = ACTIONS(3964),
    [anon_sym_begin] = ACTIONS(3966),
    [anon_sym_LPAREN2] = ACTIONS(3966),
    [anon_sym_or] = ACTIONS(3966),
    [aux_sym_char_token1] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3966),
    [anon_sym_DQUOTE] = ACTIONS(3966),
    [anon_sym_AT_DQUOTE] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [sym_bool] = ACTIONS(3966),
    [sym_unit] = ACTIONS(3964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3966),
    [sym_op_identifier] = ACTIONS(3966),
    [anon_sym_PLUS] = ACTIONS(3966),
    [anon_sym_DASH] = ACTIONS(3966),
    [anon_sym_PLUS_DOT] = ACTIONS(3966),
    [anon_sym_DASH_DOT] = ACTIONS(3966),
    [anon_sym_PERCENT] = ACTIONS(3966),
    [anon_sym_AMP_AMP] = ACTIONS(3966),
    [anon_sym_TILDE] = ACTIONS(3964),
    [aux_sym_prefix_op_token1] = ACTIONS(3966),
    [aux_sym_infix_op_token1] = ACTIONS(3964),
    [aux_sym_infix_op_token2] = ACTIONS(3966),
    [anon_sym_PIPE_PIPE] = ACTIONS(3966),
    [anon_sym_BANG_EQ] = ACTIONS(3966),
    [anon_sym_COLON_EQ] = ACTIONS(3964),
    [anon_sym_DOLLAR] = ACTIONS(3966),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3966),
    [sym_int] = ACTIONS(3966),
    [sym_xint] = ACTIONS(3964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3964),
    [sym__newline] = ACTIONS(3964),
  },
  [3221] = {
    [sym_block_comment] = STATE(3221),
    [sym_compiler_directive_decl] = STATE(3221),
    [sym_fsi_directive_decl] = STATE(3221),
    [sym_preproc_line] = STATE(3221),
    [sym_identifier] = ACTIONS(3942),
    [anon_sym_EQ] = ACTIONS(3940),
    [anon_sym_COLON] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_let_BANG] = ACTIONS(3940),
    [anon_sym_LPAREN] = ACTIONS(3942),
    [anon_sym_COMMA] = ACTIONS(3940),
    [anon_sym_null] = ACTIONS(3942),
    [anon_sym_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3940),
    [anon_sym_LBRACE] = ACTIONS(3942),
    [anon_sym_LT_AT] = ACTIONS(3942),
    [anon_sym_LT_AT_AT] = ACTIONS(3942),
    [anon_sym_DOT] = ACTIONS(3942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3940),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_return_BANG] = ACTIONS(3940),
    [anon_sym_yield] = ACTIONS(3942),
    [anon_sym_yield_BANG] = ACTIONS(3940),
    [anon_sym_lazy] = ACTIONS(3942),
    [anon_sym_assert] = ACTIONS(3942),
    [anon_sym_upcast] = ACTIONS(3942),
    [anon_sym_downcast] = ACTIONS(3942),
    [anon_sym_COLON_GT] = ACTIONS(3940),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3940),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_fun] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_match] = ACTIONS(3942),
    [anon_sym_match_BANG] = ACTIONS(3940),
    [anon_sym_function] = ACTIONS(3942),
    [anon_sym_LT_DASH] = ACTIONS(3942),
    [anon_sym_DOT_LBRACK] = ACTIONS(3940),
    [anon_sym_LT] = ACTIONS(3940),
    [anon_sym_GT] = ACTIONS(3942),
    [anon_sym_use] = ACTIONS(3942),
    [anon_sym_use_BANG] = ACTIONS(3940),
    [anon_sym_do_BANG] = ACTIONS(3940),
    [anon_sym_begin] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3942),
    [anon_sym_or] = ACTIONS(3942),
    [aux_sym_char_token1] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3942),
    [anon_sym_DQUOTE] = ACTIONS(3942),
    [anon_sym_AT_DQUOTE] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [sym_bool] = ACTIONS(3942),
    [sym_unit] = ACTIONS(3940),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3942),
    [sym_op_identifier] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS_DOT] = ACTIONS(3942),
    [anon_sym_DASH_DOT] = ACTIONS(3942),
    [anon_sym_PERCENT] = ACTIONS(3942),
    [anon_sym_AMP_AMP] = ACTIONS(3942),
    [anon_sym_TILDE] = ACTIONS(3940),
    [aux_sym_prefix_op_token1] = ACTIONS(3942),
    [aux_sym_infix_op_token1] = ACTIONS(3940),
    [aux_sym_infix_op_token2] = ACTIONS(3942),
    [anon_sym_PIPE_PIPE] = ACTIONS(3942),
    [anon_sym_BANG_EQ] = ACTIONS(3942),
    [anon_sym_COLON_EQ] = ACTIONS(3940),
    [anon_sym_DOLLAR] = ACTIONS(3942),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3942),
    [sym_int] = ACTIONS(3942),
    [sym_xint] = ACTIONS(3940),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3940),
    [sym__newline] = ACTIONS(3940),
  },
  [3222] = {
    [sym_block_comment] = STATE(3222),
    [sym_compiler_directive_decl] = STATE(3222),
    [sym_fsi_directive_decl] = STATE(3222),
    [sym_preproc_line] = STATE(3222),
    [sym_identifier] = ACTIONS(3917),
    [anon_sym_EQ] = ACTIONS(3915),
    [anon_sym_COLON] = ACTIONS(3917),
    [anon_sym_return] = ACTIONS(3917),
    [anon_sym_do] = ACTIONS(3917),
    [anon_sym_let] = ACTIONS(3917),
    [anon_sym_let_BANG] = ACTIONS(3915),
    [anon_sym_LPAREN] = ACTIONS(3917),
    [anon_sym_COMMA] = ACTIONS(3915),
    [anon_sym_null] = ACTIONS(3917),
    [anon_sym_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_COLON] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(3917),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3915),
    [anon_sym_LBRACE] = ACTIONS(3917),
    [anon_sym_LT_AT] = ACTIONS(3917),
    [anon_sym_LT_AT_AT] = ACTIONS(3917),
    [anon_sym_DOT] = ACTIONS(3917),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3915),
    [anon_sym_new] = ACTIONS(3917),
    [anon_sym_return_BANG] = ACTIONS(3915),
    [anon_sym_yield] = ACTIONS(3917),
    [anon_sym_yield_BANG] = ACTIONS(3915),
    [anon_sym_lazy] = ACTIONS(3917),
    [anon_sym_assert] = ACTIONS(3917),
    [anon_sym_upcast] = ACTIONS(3917),
    [anon_sym_downcast] = ACTIONS(3917),
    [anon_sym_COLON_GT] = ACTIONS(3915),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3915),
    [anon_sym_for] = ACTIONS(3917),
    [anon_sym_while] = ACTIONS(3917),
    [anon_sym_if] = ACTIONS(3917),
    [anon_sym_fun] = ACTIONS(3917),
    [anon_sym_try] = ACTIONS(3917),
    [anon_sym_match] = ACTIONS(3917),
    [anon_sym_match_BANG] = ACTIONS(3915),
    [anon_sym_function] = ACTIONS(3917),
    [anon_sym_LT_DASH] = ACTIONS(3917),
    [anon_sym_DOT_LBRACK] = ACTIONS(3915),
    [anon_sym_LT] = ACTIONS(3915),
    [anon_sym_GT] = ACTIONS(3917),
    [anon_sym_use] = ACTIONS(3917),
    [anon_sym_use_BANG] = ACTIONS(3915),
    [anon_sym_do_BANG] = ACTIONS(3915),
    [anon_sym_begin] = ACTIONS(3917),
    [anon_sym_LPAREN2] = ACTIONS(3917),
    [anon_sym_or] = ACTIONS(3917),
    [aux_sym_char_token1] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_AT_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [sym_bool] = ACTIONS(3917),
    [sym_unit] = ACTIONS(3915),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3917),
    [sym_op_identifier] = ACTIONS(3917),
    [anon_sym_PLUS] = ACTIONS(3917),
    [anon_sym_DASH] = ACTIONS(3917),
    [anon_sym_PLUS_DOT] = ACTIONS(3917),
    [anon_sym_DASH_DOT] = ACTIONS(3917),
    [anon_sym_PERCENT] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_TILDE] = ACTIONS(3915),
    [aux_sym_prefix_op_token1] = ACTIONS(3917),
    [aux_sym_infix_op_token1] = ACTIONS(3915),
    [aux_sym_infix_op_token2] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_BANG_EQ] = ACTIONS(3917),
    [anon_sym_COLON_EQ] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3917),
    [sym_int] = ACTIONS(3917),
    [sym_xint] = ACTIONS(3915),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3915),
    [sym__newline] = ACTIONS(3915),
  },
  [3223] = {
    [sym_block_comment] = STATE(3223),
    [sym_compiler_directive_decl] = STATE(3223),
    [sym_fsi_directive_decl] = STATE(3223),
    [sym_preproc_line] = STATE(3223),
    [ts_builtin_sym_end] = ACTIONS(3509),
    [sym_identifier] = ACTIONS(3511),
    [anon_sym_namespace] = ACTIONS(3511),
    [anon_sym_module] = ACTIONS(3511),
    [anon_sym_open] = ACTIONS(3511),
    [anon_sym_LBRACK_LT] = ACTIONS(3509),
    [anon_sym_return] = ACTIONS(3511),
    [anon_sym_type] = ACTIONS(3511),
    [anon_sym_do] = ACTIONS(3511),
    [anon_sym_and] = ACTIONS(3511),
    [anon_sym_let] = ACTIONS(3511),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [aux_sym_access_modifier_token1] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3511),
    [anon_sym_null] = ACTIONS(3511),
    [anon_sym_AMP] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(3511),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_LT_AT] = ACTIONS(3511),
    [anon_sym_LT_AT_AT] = ACTIONS(3509),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3511),
    [anon_sym_with] = ACTIONS(3511),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3511),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3511),
    [anon_sym_assert] = ACTIONS(3511),
    [anon_sym_upcast] = ACTIONS(3511),
    [anon_sym_downcast] = ACTIONS(3511),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3511),
    [anon_sym_while] = ACTIONS(3511),
    [anon_sym_if] = ACTIONS(3511),
    [anon_sym_fun] = ACTIONS(3511),
    [anon_sym_DASH_GT] = ACTIONS(3509),
    [anon_sym_try] = ACTIONS(3511),
    [anon_sym_match] = ACTIONS(3511),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3511),
    [anon_sym_use] = ACTIONS(3511),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3511),
    [anon_sym_STAR] = ACTIONS(3509),
    [anon_sym_LT2] = ACTIONS(3511),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3509),
    [anon_sym_default] = ACTIONS(3511),
    [anon_sym_or] = ACTIONS(3511),
    [anon_sym_static] = ACTIONS(3511),
    [anon_sym_member] = ACTIONS(3511),
    [anon_sym_interface] = ACTIONS(3511),
    [anon_sym_exception] = ACTIONS(3511),
    [anon_sym_abstract] = ACTIONS(3511),
    [anon_sym_val] = ACTIONS(3511),
    [anon_sym_override] = ACTIONS(3511),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3511),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3511),
    [sym_unit] = ACTIONS(3509),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3511),
    [sym_op_identifier] = ACTIONS(3509),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3511),
    [anon_sym_PLUS_DOT] = ACTIONS(3509),
    [anon_sym_DASH_DOT] = ACTIONS(3509),
    [anon_sym_PERCENT] = ACTIONS(3509),
    [anon_sym_AMP_AMP] = ACTIONS(3509),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3509),
    [sym_int] = ACTIONS(3511),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3509),
    [anon_sym_POUNDload] = ACTIONS(3509),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3509),
  },
  [3224] = {
    [sym_block_comment] = STATE(3224),
    [sym_compiler_directive_decl] = STATE(3224),
    [sym_fsi_directive_decl] = STATE(3224),
    [sym_preproc_line] = STATE(3224),
    [sym_identifier] = ACTIONS(4130),
    [anon_sym_EQ] = ACTIONS(4128),
    [anon_sym_COLON] = ACTIONS(4130),
    [anon_sym_return] = ACTIONS(4130),
    [anon_sym_do] = ACTIONS(4130),
    [anon_sym_let] = ACTIONS(4130),
    [anon_sym_let_BANG] = ACTIONS(4128),
    [anon_sym_LPAREN] = ACTIONS(4130),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_null] = ACTIONS(4130),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_COLON] = ACTIONS(4128),
    [anon_sym_AMP] = ACTIONS(4130),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4128),
    [anon_sym_LBRACE] = ACTIONS(4130),
    [anon_sym_LT_AT] = ACTIONS(4130),
    [anon_sym_LT_AT_AT] = ACTIONS(4130),
    [anon_sym_DOT] = ACTIONS(4130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4128),
    [anon_sym_new] = ACTIONS(4130),
    [anon_sym_return_BANG] = ACTIONS(4128),
    [anon_sym_yield] = ACTIONS(4130),
    [anon_sym_yield_BANG] = ACTIONS(4128),
    [anon_sym_lazy] = ACTIONS(4130),
    [anon_sym_assert] = ACTIONS(4130),
    [anon_sym_upcast] = ACTIONS(4130),
    [anon_sym_downcast] = ACTIONS(4130),
    [anon_sym_COLON_GT] = ACTIONS(4128),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4128),
    [anon_sym_for] = ACTIONS(4130),
    [anon_sym_while] = ACTIONS(4130),
    [anon_sym_if] = ACTIONS(4130),
    [anon_sym_fun] = ACTIONS(4130),
    [anon_sym_try] = ACTIONS(4130),
    [anon_sym_match] = ACTIONS(4130),
    [anon_sym_match_BANG] = ACTIONS(4128),
    [anon_sym_function] = ACTIONS(4130),
    [anon_sym_LT_DASH] = ACTIONS(4130),
    [anon_sym_DOT_LBRACK] = ACTIONS(4128),
    [anon_sym_LT] = ACTIONS(4128),
    [anon_sym_GT] = ACTIONS(4130),
    [anon_sym_use] = ACTIONS(4130),
    [anon_sym_use_BANG] = ACTIONS(4128),
    [anon_sym_do_BANG] = ACTIONS(4128),
    [anon_sym_begin] = ACTIONS(4130),
    [anon_sym_LPAREN2] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [aux_sym_char_token1] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4130),
    [anon_sym_DQUOTE] = ACTIONS(4130),
    [anon_sym_AT_DQUOTE] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [sym_bool] = ACTIONS(4130),
    [sym_unit] = ACTIONS(4128),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4130),
    [sym_op_identifier] = ACTIONS(4130),
    [anon_sym_PLUS] = ACTIONS(4130),
    [anon_sym_DASH] = ACTIONS(4130),
    [anon_sym_PLUS_DOT] = ACTIONS(4130),
    [anon_sym_DASH_DOT] = ACTIONS(4130),
    [anon_sym_PERCENT] = ACTIONS(4130),
    [anon_sym_AMP_AMP] = ACTIONS(4130),
    [anon_sym_TILDE] = ACTIONS(4128),
    [aux_sym_prefix_op_token1] = ACTIONS(4130),
    [aux_sym_infix_op_token1] = ACTIONS(4128),
    [aux_sym_infix_op_token2] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE] = ACTIONS(4130),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_COLON_EQ] = ACTIONS(4128),
    [anon_sym_DOLLAR] = ACTIONS(4130),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4130),
    [sym_int] = ACTIONS(4130),
    [sym_xint] = ACTIONS(4128),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4128),
    [sym__newline] = ACTIONS(4128),
  },
  [3225] = {
    [sym_block_comment] = STATE(3225),
    [sym_compiler_directive_decl] = STATE(3225),
    [sym_fsi_directive_decl] = STATE(3225),
    [sym_preproc_line] = STATE(3225),
    [sym_identifier] = ACTIONS(3885),
    [anon_sym_EQ] = ACTIONS(3883),
    [anon_sym_COLON] = ACTIONS(3885),
    [anon_sym_return] = ACTIONS(3885),
    [anon_sym_do] = ACTIONS(3885),
    [anon_sym_let] = ACTIONS(3885),
    [anon_sym_let_BANG] = ACTIONS(3883),
    [anon_sym_LPAREN] = ACTIONS(3885),
    [anon_sym_COMMA] = ACTIONS(3883),
    [anon_sym_null] = ACTIONS(3885),
    [anon_sym_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3883),
    [anon_sym_AMP] = ACTIONS(3885),
    [anon_sym_LBRACK] = ACTIONS(3885),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3883),
    [anon_sym_LBRACE] = ACTIONS(3885),
    [anon_sym_LT_AT] = ACTIONS(3885),
    [anon_sym_LT_AT_AT] = ACTIONS(3885),
    [anon_sym_DOT] = ACTIONS(3885),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3883),
    [anon_sym_new] = ACTIONS(3885),
    [anon_sym_return_BANG] = ACTIONS(3883),
    [anon_sym_yield] = ACTIONS(3885),
    [anon_sym_yield_BANG] = ACTIONS(3883),
    [anon_sym_lazy] = ACTIONS(3885),
    [anon_sym_assert] = ACTIONS(3885),
    [anon_sym_upcast] = ACTIONS(3885),
    [anon_sym_downcast] = ACTIONS(3885),
    [anon_sym_COLON_GT] = ACTIONS(3883),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3883),
    [anon_sym_for] = ACTIONS(3885),
    [anon_sym_while] = ACTIONS(3885),
    [anon_sym_if] = ACTIONS(3885),
    [anon_sym_fun] = ACTIONS(3885),
    [anon_sym_try] = ACTIONS(3885),
    [anon_sym_match] = ACTIONS(3885),
    [anon_sym_match_BANG] = ACTIONS(3883),
    [anon_sym_function] = ACTIONS(3885),
    [anon_sym_LT_DASH] = ACTIONS(3885),
    [anon_sym_DOT_LBRACK] = ACTIONS(3883),
    [anon_sym_LT] = ACTIONS(3883),
    [anon_sym_GT] = ACTIONS(3885),
    [anon_sym_use] = ACTIONS(3885),
    [anon_sym_use_BANG] = ACTIONS(3883),
    [anon_sym_do_BANG] = ACTIONS(3883),
    [anon_sym_begin] = ACTIONS(3885),
    [anon_sym_LPAREN2] = ACTIONS(3885),
    [anon_sym_or] = ACTIONS(3885),
    [aux_sym_char_token1] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3885),
    [anon_sym_DQUOTE] = ACTIONS(3885),
    [anon_sym_AT_DQUOTE] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [sym_bool] = ACTIONS(3885),
    [sym_unit] = ACTIONS(3883),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3885),
    [sym_op_identifier] = ACTIONS(3885),
    [anon_sym_PLUS] = ACTIONS(3885),
    [anon_sym_DASH] = ACTIONS(3885),
    [anon_sym_PLUS_DOT] = ACTIONS(3885),
    [anon_sym_DASH_DOT] = ACTIONS(3885),
    [anon_sym_PERCENT] = ACTIONS(3885),
    [anon_sym_AMP_AMP] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3883),
    [aux_sym_prefix_op_token1] = ACTIONS(3885),
    [aux_sym_infix_op_token1] = ACTIONS(3883),
    [aux_sym_infix_op_token2] = ACTIONS(3885),
    [anon_sym_PIPE_PIPE] = ACTIONS(3885),
    [anon_sym_BANG_EQ] = ACTIONS(3885),
    [anon_sym_COLON_EQ] = ACTIONS(3883),
    [anon_sym_DOLLAR] = ACTIONS(3885),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3885),
    [sym_int] = ACTIONS(3885),
    [sym_xint] = ACTIONS(3883),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3883),
    [sym__newline] = ACTIONS(3883),
  },
  [3226] = {
    [sym_block_comment] = STATE(3226),
    [sym_compiler_directive_decl] = STATE(3226),
    [sym_fsi_directive_decl] = STATE(3226),
    [sym_preproc_line] = STATE(3226),
    [sym_identifier] = ACTIONS(3935),
    [anon_sym_EQ] = ACTIONS(3933),
    [anon_sym_COLON] = ACTIONS(3935),
    [anon_sym_return] = ACTIONS(3935),
    [anon_sym_do] = ACTIONS(3935),
    [anon_sym_let] = ACTIONS(3935),
    [anon_sym_let_BANG] = ACTIONS(3933),
    [anon_sym_LPAREN] = ACTIONS(3935),
    [anon_sym_COMMA] = ACTIONS(3933),
    [anon_sym_null] = ACTIONS(3935),
    [anon_sym_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3935),
    [anon_sym_LBRACK] = ACTIONS(3935),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3933),
    [anon_sym_LBRACE] = ACTIONS(3935),
    [anon_sym_LT_AT] = ACTIONS(3935),
    [anon_sym_LT_AT_AT] = ACTIONS(3935),
    [anon_sym_DOT] = ACTIONS(3935),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3933),
    [anon_sym_new] = ACTIONS(3935),
    [anon_sym_return_BANG] = ACTIONS(3933),
    [anon_sym_yield] = ACTIONS(3935),
    [anon_sym_yield_BANG] = ACTIONS(3933),
    [anon_sym_lazy] = ACTIONS(3935),
    [anon_sym_assert] = ACTIONS(3935),
    [anon_sym_upcast] = ACTIONS(3935),
    [anon_sym_downcast] = ACTIONS(3935),
    [anon_sym_COLON_GT] = ACTIONS(3933),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3933),
    [anon_sym_for] = ACTIONS(3935),
    [anon_sym_while] = ACTIONS(3935),
    [anon_sym_if] = ACTIONS(3935),
    [anon_sym_fun] = ACTIONS(3935),
    [anon_sym_try] = ACTIONS(3935),
    [anon_sym_match] = ACTIONS(3935),
    [anon_sym_match_BANG] = ACTIONS(3933),
    [anon_sym_function] = ACTIONS(3935),
    [anon_sym_LT_DASH] = ACTIONS(3935),
    [anon_sym_DOT_LBRACK] = ACTIONS(3933),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_GT] = ACTIONS(3935),
    [anon_sym_use] = ACTIONS(3935),
    [anon_sym_use_BANG] = ACTIONS(3933),
    [anon_sym_do_BANG] = ACTIONS(3933),
    [anon_sym_begin] = ACTIONS(3935),
    [anon_sym_LPAREN2] = ACTIONS(3935),
    [anon_sym_or] = ACTIONS(3935),
    [aux_sym_char_token1] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3935),
    [anon_sym_DQUOTE] = ACTIONS(3935),
    [anon_sym_AT_DQUOTE] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [sym_bool] = ACTIONS(3935),
    [sym_unit] = ACTIONS(3933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3935),
    [sym_op_identifier] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(3935),
    [anon_sym_DASH] = ACTIONS(3935),
    [anon_sym_PLUS_DOT] = ACTIONS(3935),
    [anon_sym_DASH_DOT] = ACTIONS(3935),
    [anon_sym_PERCENT] = ACTIONS(3935),
    [anon_sym_AMP_AMP] = ACTIONS(3935),
    [anon_sym_TILDE] = ACTIONS(3933),
    [aux_sym_prefix_op_token1] = ACTIONS(3935),
    [aux_sym_infix_op_token1] = ACTIONS(3933),
    [aux_sym_infix_op_token2] = ACTIONS(3935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3935),
    [anon_sym_BANG_EQ] = ACTIONS(3935),
    [anon_sym_COLON_EQ] = ACTIONS(3933),
    [anon_sym_DOLLAR] = ACTIONS(3935),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3935),
    [sym_int] = ACTIONS(3935),
    [sym_xint] = ACTIONS(3933),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3933),
    [sym__newline] = ACTIONS(3933),
  },
  [3227] = {
    [sym_block_comment] = STATE(3227),
    [sym_compiler_directive_decl] = STATE(3227),
    [sym_fsi_directive_decl] = STATE(3227),
    [sym_preproc_line] = STATE(3227),
    [sym_identifier] = ACTIONS(3976),
    [anon_sym_EQ] = ACTIONS(3974),
    [anon_sym_COLON] = ACTIONS(3976),
    [anon_sym_return] = ACTIONS(3976),
    [anon_sym_do] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_let_BANG] = ACTIONS(3974),
    [anon_sym_LPAREN] = ACTIONS(3976),
    [anon_sym_COMMA] = ACTIONS(3974),
    [anon_sym_null] = ACTIONS(3976),
    [anon_sym_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_COLON] = ACTIONS(3974),
    [anon_sym_AMP] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(3976),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3974),
    [anon_sym_LBRACE] = ACTIONS(3976),
    [anon_sym_LT_AT] = ACTIONS(3976),
    [anon_sym_LT_AT_AT] = ACTIONS(3976),
    [anon_sym_DOT] = ACTIONS(3976),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3974),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_return_BANG] = ACTIONS(3974),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_yield_BANG] = ACTIONS(3974),
    [anon_sym_lazy] = ACTIONS(3976),
    [anon_sym_assert] = ACTIONS(3976),
    [anon_sym_upcast] = ACTIONS(3976),
    [anon_sym_downcast] = ACTIONS(3976),
    [anon_sym_COLON_GT] = ACTIONS(3974),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3974),
    [anon_sym_for] = ACTIONS(3976),
    [anon_sym_while] = ACTIONS(3976),
    [anon_sym_if] = ACTIONS(3976),
    [anon_sym_fun] = ACTIONS(3976),
    [anon_sym_try] = ACTIONS(3976),
    [anon_sym_match] = ACTIONS(3976),
    [anon_sym_match_BANG] = ACTIONS(3974),
    [anon_sym_function] = ACTIONS(3976),
    [anon_sym_LT_DASH] = ACTIONS(3976),
    [anon_sym_DOT_LBRACK] = ACTIONS(3974),
    [anon_sym_LT] = ACTIONS(3974),
    [anon_sym_use] = ACTIONS(3976),
    [anon_sym_use_BANG] = ACTIONS(3974),
    [anon_sym_do_BANG] = ACTIONS(3974),
    [anon_sym_DOT_DOT] = ACTIONS(3974),
    [anon_sym_begin] = ACTIONS(3976),
    [anon_sym_LPAREN2] = ACTIONS(3976),
    [anon_sym_or] = ACTIONS(3976),
    [aux_sym_char_token1] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3976),
    [anon_sym_DQUOTE] = ACTIONS(3976),
    [anon_sym_AT_DQUOTE] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [sym_bool] = ACTIONS(3976),
    [sym_unit] = ACTIONS(3974),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3976),
    [sym_op_identifier] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3976),
    [anon_sym_DASH] = ACTIONS(3976),
    [anon_sym_PLUS_DOT] = ACTIONS(3976),
    [anon_sym_DASH_DOT] = ACTIONS(3976),
    [anon_sym_PERCENT] = ACTIONS(3976),
    [anon_sym_AMP_AMP] = ACTIONS(3976),
    [anon_sym_TILDE] = ACTIONS(3974),
    [aux_sym_prefix_op_token1] = ACTIONS(3976),
    [aux_sym_infix_op_token1] = ACTIONS(3974),
    [aux_sym_infix_op_token2] = ACTIONS(3976),
    [anon_sym_PIPE_PIPE] = ACTIONS(3976),
    [anon_sym_BANG_EQ] = ACTIONS(3976),
    [anon_sym_COLON_EQ] = ACTIONS(3974),
    [anon_sym_DOLLAR] = ACTIONS(3976),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3976),
    [sym_int] = ACTIONS(3976),
    [sym_xint] = ACTIONS(3974),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3974),
    [sym__newline] = ACTIONS(3974),
  },
  [3228] = {
    [sym_block_comment] = STATE(3228),
    [sym_compiler_directive_decl] = STATE(3228),
    [sym_fsi_directive_decl] = STATE(3228),
    [sym_preproc_line] = STATE(3228),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_EQ] = ACTIONS(3948),
    [anon_sym_COLON] = ACTIONS(3950),
    [anon_sym_return] = ACTIONS(3950),
    [anon_sym_do] = ACTIONS(3950),
    [anon_sym_let] = ACTIONS(3950),
    [anon_sym_let_BANG] = ACTIONS(3948),
    [anon_sym_LPAREN] = ACTIONS(3950),
    [anon_sym_COMMA] = ACTIONS(3948),
    [anon_sym_null] = ACTIONS(3950),
    [anon_sym_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_COLON] = ACTIONS(3948),
    [anon_sym_AMP] = ACTIONS(3950),
    [anon_sym_LBRACK] = ACTIONS(3950),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3948),
    [anon_sym_LBRACE] = ACTIONS(3950),
    [anon_sym_LT_AT] = ACTIONS(3950),
    [anon_sym_LT_AT_AT] = ACTIONS(3950),
    [anon_sym_DOT] = ACTIONS(3950),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3948),
    [anon_sym_new] = ACTIONS(3950),
    [anon_sym_return_BANG] = ACTIONS(3948),
    [anon_sym_yield] = ACTIONS(3950),
    [anon_sym_yield_BANG] = ACTIONS(3948),
    [anon_sym_lazy] = ACTIONS(3950),
    [anon_sym_assert] = ACTIONS(3950),
    [anon_sym_upcast] = ACTIONS(3950),
    [anon_sym_downcast] = ACTIONS(3950),
    [anon_sym_COLON_GT] = ACTIONS(3948),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3948),
    [anon_sym_for] = ACTIONS(3950),
    [anon_sym_while] = ACTIONS(3950),
    [anon_sym_if] = ACTIONS(3950),
    [anon_sym_fun] = ACTIONS(3950),
    [anon_sym_try] = ACTIONS(3950),
    [anon_sym_match] = ACTIONS(3950),
    [anon_sym_match_BANG] = ACTIONS(3948),
    [anon_sym_function] = ACTIONS(3950),
    [anon_sym_LT_DASH] = ACTIONS(3950),
    [anon_sym_DOT_LBRACK] = ACTIONS(3948),
    [anon_sym_LT] = ACTIONS(3948),
    [anon_sym_GT] = ACTIONS(3950),
    [anon_sym_use] = ACTIONS(3950),
    [anon_sym_use_BANG] = ACTIONS(3948),
    [anon_sym_do_BANG] = ACTIONS(3948),
    [anon_sym_begin] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3950),
    [anon_sym_or] = ACTIONS(3950),
    [aux_sym_char_token1] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3950),
    [anon_sym_DQUOTE] = ACTIONS(3950),
    [anon_sym_AT_DQUOTE] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [sym_bool] = ACTIONS(3950),
    [sym_unit] = ACTIONS(3948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3950),
    [sym_op_identifier] = ACTIONS(3950),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_DASH] = ACTIONS(3950),
    [anon_sym_PLUS_DOT] = ACTIONS(3950),
    [anon_sym_DASH_DOT] = ACTIONS(3950),
    [anon_sym_PERCENT] = ACTIONS(3950),
    [anon_sym_AMP_AMP] = ACTIONS(3950),
    [anon_sym_TILDE] = ACTIONS(3948),
    [aux_sym_prefix_op_token1] = ACTIONS(3950),
    [aux_sym_infix_op_token1] = ACTIONS(3948),
    [aux_sym_infix_op_token2] = ACTIONS(3950),
    [anon_sym_PIPE_PIPE] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3950),
    [anon_sym_COLON_EQ] = ACTIONS(3948),
    [anon_sym_DOLLAR] = ACTIONS(3950),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3950),
    [sym_int] = ACTIONS(3950),
    [sym_xint] = ACTIONS(3948),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3948),
    [sym__newline] = ACTIONS(3948),
  },
  [3229] = {
    [sym_block_comment] = STATE(3229),
    [sym_compiler_directive_decl] = STATE(3229),
    [sym_fsi_directive_decl] = STATE(3229),
    [sym_preproc_line] = STATE(3229),
    [sym_identifier] = ACTIONS(3954),
    [anon_sym_EQ] = ACTIONS(3952),
    [anon_sym_COLON] = ACTIONS(3954),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_do] = ACTIONS(3954),
    [anon_sym_let] = ACTIONS(3954),
    [anon_sym_let_BANG] = ACTIONS(3952),
    [anon_sym_LPAREN] = ACTIONS(3954),
    [anon_sym_COMMA] = ACTIONS(3952),
    [anon_sym_null] = ACTIONS(3954),
    [anon_sym_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_COLON] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3954),
    [anon_sym_LBRACK] = ACTIONS(3954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(3954),
    [anon_sym_LT_AT] = ACTIONS(3954),
    [anon_sym_LT_AT_AT] = ACTIONS(3954),
    [anon_sym_DOT] = ACTIONS(3954),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3952),
    [anon_sym_new] = ACTIONS(3954),
    [anon_sym_return_BANG] = ACTIONS(3952),
    [anon_sym_yield] = ACTIONS(3954),
    [anon_sym_yield_BANG] = ACTIONS(3952),
    [anon_sym_lazy] = ACTIONS(3954),
    [anon_sym_assert] = ACTIONS(3954),
    [anon_sym_upcast] = ACTIONS(3954),
    [anon_sym_downcast] = ACTIONS(3954),
    [anon_sym_COLON_GT] = ACTIONS(3952),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3952),
    [anon_sym_for] = ACTIONS(3954),
    [anon_sym_while] = ACTIONS(3954),
    [anon_sym_if] = ACTIONS(3954),
    [anon_sym_fun] = ACTIONS(3954),
    [anon_sym_try] = ACTIONS(3954),
    [anon_sym_match] = ACTIONS(3954),
    [anon_sym_match_BANG] = ACTIONS(3952),
    [anon_sym_function] = ACTIONS(3954),
    [anon_sym_LT_DASH] = ACTIONS(3954),
    [anon_sym_DOT_LBRACK] = ACTIONS(3952),
    [anon_sym_LT] = ACTIONS(3952),
    [anon_sym_GT] = ACTIONS(3954),
    [anon_sym_use] = ACTIONS(3954),
    [anon_sym_use_BANG] = ACTIONS(3952),
    [anon_sym_do_BANG] = ACTIONS(3952),
    [anon_sym_begin] = ACTIONS(3954),
    [anon_sym_LPAREN2] = ACTIONS(3954),
    [anon_sym_or] = ACTIONS(3954),
    [aux_sym_char_token1] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3954),
    [anon_sym_DQUOTE] = ACTIONS(3954),
    [anon_sym_AT_DQUOTE] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [sym_bool] = ACTIONS(3954),
    [sym_unit] = ACTIONS(3952),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3954),
    [sym_op_identifier] = ACTIONS(3954),
    [anon_sym_PLUS] = ACTIONS(3954),
    [anon_sym_DASH] = ACTIONS(3954),
    [anon_sym_PLUS_DOT] = ACTIONS(3954),
    [anon_sym_DASH_DOT] = ACTIONS(3954),
    [anon_sym_PERCENT] = ACTIONS(3954),
    [anon_sym_AMP_AMP] = ACTIONS(3954),
    [anon_sym_TILDE] = ACTIONS(3952),
    [aux_sym_prefix_op_token1] = ACTIONS(3954),
    [aux_sym_infix_op_token1] = ACTIONS(3952),
    [aux_sym_infix_op_token2] = ACTIONS(3954),
    [anon_sym_PIPE_PIPE] = ACTIONS(3954),
    [anon_sym_BANG_EQ] = ACTIONS(3954),
    [anon_sym_COLON_EQ] = ACTIONS(3952),
    [anon_sym_DOLLAR] = ACTIONS(3954),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3954),
    [sym_int] = ACTIONS(3954),
    [sym_xint] = ACTIONS(3952),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3952),
    [sym__newline] = ACTIONS(3952),
  },
  [3230] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_type_arguments] = STATE(3849),
    [sym__method_defn] = STATE(6595),
    [sym__property_defn] = STATE(6594),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3230),
    [sym_compiler_directive_decl] = STATE(3230),
    [sym_fsi_directive_decl] = STATE(3230),
    [sym_preproc_line] = STATE(3230),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3743),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(5825),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_COLON] = ACTIONS(5827),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [anon_sym_with] = ACTIONS(5829),
    [anon_sym_LT2] = ACTIONS(5809),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3231] = {
    [sym_block_comment] = STATE(3231),
    [sym_compiler_directive_decl] = STATE(3231),
    [sym_fsi_directive_decl] = STATE(3231),
    [sym_preproc_line] = STATE(3231),
    [sym_identifier] = ACTIONS(3958),
    [anon_sym_EQ] = ACTIONS(3956),
    [anon_sym_COLON] = ACTIONS(3958),
    [anon_sym_return] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(3958),
    [anon_sym_let] = ACTIONS(3958),
    [anon_sym_let_BANG] = ACTIONS(3956),
    [anon_sym_LPAREN] = ACTIONS(3958),
    [anon_sym_COMMA] = ACTIONS(3956),
    [anon_sym_null] = ACTIONS(3958),
    [anon_sym_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_COLON] = ACTIONS(3956),
    [anon_sym_AMP] = ACTIONS(3958),
    [anon_sym_LBRACK] = ACTIONS(3958),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3956),
    [anon_sym_LBRACE] = ACTIONS(3958),
    [anon_sym_LT_AT] = ACTIONS(3958),
    [anon_sym_LT_AT_AT] = ACTIONS(3958),
    [anon_sym_DOT] = ACTIONS(3958),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3956),
    [anon_sym_new] = ACTIONS(3958),
    [anon_sym_return_BANG] = ACTIONS(3956),
    [anon_sym_yield] = ACTIONS(3958),
    [anon_sym_yield_BANG] = ACTIONS(3956),
    [anon_sym_lazy] = ACTIONS(3958),
    [anon_sym_assert] = ACTIONS(3958),
    [anon_sym_upcast] = ACTIONS(3958),
    [anon_sym_downcast] = ACTIONS(3958),
    [anon_sym_COLON_GT] = ACTIONS(3956),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3956),
    [anon_sym_for] = ACTIONS(3958),
    [anon_sym_while] = ACTIONS(3958),
    [anon_sym_if] = ACTIONS(3958),
    [anon_sym_fun] = ACTIONS(3958),
    [anon_sym_try] = ACTIONS(3958),
    [anon_sym_match] = ACTIONS(3958),
    [anon_sym_match_BANG] = ACTIONS(3956),
    [anon_sym_function] = ACTIONS(3958),
    [anon_sym_LT_DASH] = ACTIONS(3958),
    [anon_sym_DOT_LBRACK] = ACTIONS(3956),
    [anon_sym_LT] = ACTIONS(3956),
    [anon_sym_GT] = ACTIONS(3958),
    [anon_sym_use] = ACTIONS(3958),
    [anon_sym_use_BANG] = ACTIONS(3956),
    [anon_sym_do_BANG] = ACTIONS(3956),
    [anon_sym_begin] = ACTIONS(3958),
    [anon_sym_LPAREN2] = ACTIONS(3958),
    [anon_sym_or] = ACTIONS(3958),
    [aux_sym_char_token1] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [anon_sym_AT_DQUOTE] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [sym_bool] = ACTIONS(3958),
    [sym_unit] = ACTIONS(3956),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3958),
    [sym_op_identifier] = ACTIONS(3958),
    [anon_sym_PLUS] = ACTIONS(3958),
    [anon_sym_DASH] = ACTIONS(3958),
    [anon_sym_PLUS_DOT] = ACTIONS(3958),
    [anon_sym_DASH_DOT] = ACTIONS(3958),
    [anon_sym_PERCENT] = ACTIONS(3958),
    [anon_sym_AMP_AMP] = ACTIONS(3958),
    [anon_sym_TILDE] = ACTIONS(3956),
    [aux_sym_prefix_op_token1] = ACTIONS(3958),
    [aux_sym_infix_op_token1] = ACTIONS(3956),
    [aux_sym_infix_op_token2] = ACTIONS(3958),
    [anon_sym_PIPE_PIPE] = ACTIONS(3958),
    [anon_sym_BANG_EQ] = ACTIONS(3958),
    [anon_sym_COLON_EQ] = ACTIONS(3956),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3958),
    [sym_int] = ACTIONS(3958),
    [sym_xint] = ACTIONS(3956),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3956),
    [sym__newline] = ACTIONS(3956),
  },
  [3232] = {
    [sym_block_comment] = STATE(3232),
    [sym_compiler_directive_decl] = STATE(3232),
    [sym_fsi_directive_decl] = STATE(3232),
    [sym_preproc_line] = STATE(3232),
    [sym_identifier] = ACTIONS(3962),
    [anon_sym_EQ] = ACTIONS(3960),
    [anon_sym_COLON] = ACTIONS(3962),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_do] = ACTIONS(3962),
    [anon_sym_let] = ACTIONS(3962),
    [anon_sym_let_BANG] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_COMMA] = ACTIONS(3960),
    [anon_sym_null] = ACTIONS(3962),
    [anon_sym_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_COLON] = ACTIONS(3960),
    [anon_sym_AMP] = ACTIONS(3962),
    [anon_sym_LBRACK] = ACTIONS(3962),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_LT_AT] = ACTIONS(3962),
    [anon_sym_LT_AT_AT] = ACTIONS(3962),
    [anon_sym_DOT] = ACTIONS(3962),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3960),
    [anon_sym_new] = ACTIONS(3962),
    [anon_sym_return_BANG] = ACTIONS(3960),
    [anon_sym_yield] = ACTIONS(3962),
    [anon_sym_yield_BANG] = ACTIONS(3960),
    [anon_sym_lazy] = ACTIONS(3962),
    [anon_sym_assert] = ACTIONS(3962),
    [anon_sym_upcast] = ACTIONS(3962),
    [anon_sym_downcast] = ACTIONS(3962),
    [anon_sym_COLON_GT] = ACTIONS(3960),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3960),
    [anon_sym_for] = ACTIONS(3962),
    [anon_sym_while] = ACTIONS(3962),
    [anon_sym_if] = ACTIONS(3962),
    [anon_sym_fun] = ACTIONS(3962),
    [anon_sym_try] = ACTIONS(3962),
    [anon_sym_match] = ACTIONS(3962),
    [anon_sym_match_BANG] = ACTIONS(3960),
    [anon_sym_function] = ACTIONS(3962),
    [anon_sym_LT_DASH] = ACTIONS(3962),
    [anon_sym_DOT_LBRACK] = ACTIONS(3960),
    [anon_sym_LT] = ACTIONS(3960),
    [anon_sym_GT] = ACTIONS(3962),
    [anon_sym_use] = ACTIONS(3962),
    [anon_sym_use_BANG] = ACTIONS(3960),
    [anon_sym_do_BANG] = ACTIONS(3960),
    [anon_sym_begin] = ACTIONS(3962),
    [anon_sym_LPAREN2] = ACTIONS(3962),
    [anon_sym_or] = ACTIONS(3962),
    [aux_sym_char_token1] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3962),
    [anon_sym_DQUOTE] = ACTIONS(3962),
    [anon_sym_AT_DQUOTE] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [sym_bool] = ACTIONS(3962),
    [sym_unit] = ACTIONS(3960),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3962),
    [sym_op_identifier] = ACTIONS(3962),
    [anon_sym_PLUS] = ACTIONS(3962),
    [anon_sym_DASH] = ACTIONS(3962),
    [anon_sym_PLUS_DOT] = ACTIONS(3962),
    [anon_sym_DASH_DOT] = ACTIONS(3962),
    [anon_sym_PERCENT] = ACTIONS(3962),
    [anon_sym_AMP_AMP] = ACTIONS(3962),
    [anon_sym_TILDE] = ACTIONS(3960),
    [aux_sym_prefix_op_token1] = ACTIONS(3962),
    [aux_sym_infix_op_token1] = ACTIONS(3960),
    [aux_sym_infix_op_token2] = ACTIONS(3962),
    [anon_sym_PIPE_PIPE] = ACTIONS(3962),
    [anon_sym_BANG_EQ] = ACTIONS(3962),
    [anon_sym_COLON_EQ] = ACTIONS(3960),
    [anon_sym_DOLLAR] = ACTIONS(3962),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3962),
    [sym_int] = ACTIONS(3962),
    [sym_xint] = ACTIONS(3960),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3960),
    [sym__newline] = ACTIONS(3960),
  },
  [3233] = {
    [sym_block_comment] = STATE(3233),
    [sym_compiler_directive_decl] = STATE(3233),
    [sym_fsi_directive_decl] = STATE(3233),
    [sym_preproc_line] = STATE(3233),
    [sym_identifier] = ACTIONS(4232),
    [anon_sym_EQ] = ACTIONS(4230),
    [anon_sym_COLON] = ACTIONS(4232),
    [anon_sym_return] = ACTIONS(4232),
    [anon_sym_do] = ACTIONS(4232),
    [anon_sym_let] = ACTIONS(4232),
    [anon_sym_let_BANG] = ACTIONS(4230),
    [anon_sym_LPAREN] = ACTIONS(4232),
    [anon_sym_COMMA] = ACTIONS(4230),
    [anon_sym_null] = ACTIONS(4232),
    [anon_sym_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_COLON] = ACTIONS(4230),
    [anon_sym_AMP] = ACTIONS(4232),
    [anon_sym_LBRACK] = ACTIONS(4232),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4230),
    [anon_sym_LBRACE] = ACTIONS(4232),
    [anon_sym_LT_AT] = ACTIONS(4232),
    [anon_sym_LT_AT_AT] = ACTIONS(4232),
    [anon_sym_DOT] = ACTIONS(4232),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4230),
    [anon_sym_new] = ACTIONS(4232),
    [anon_sym_return_BANG] = ACTIONS(4230),
    [anon_sym_yield] = ACTIONS(4232),
    [anon_sym_yield_BANG] = ACTIONS(4230),
    [anon_sym_lazy] = ACTIONS(4232),
    [anon_sym_assert] = ACTIONS(4232),
    [anon_sym_upcast] = ACTIONS(4232),
    [anon_sym_downcast] = ACTIONS(4232),
    [anon_sym_COLON_GT] = ACTIONS(4230),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4230),
    [anon_sym_for] = ACTIONS(4232),
    [anon_sym_while] = ACTIONS(4232),
    [anon_sym_if] = ACTIONS(4232),
    [anon_sym_fun] = ACTIONS(4232),
    [anon_sym_try] = ACTIONS(4232),
    [anon_sym_match] = ACTIONS(4232),
    [anon_sym_match_BANG] = ACTIONS(4230),
    [anon_sym_function] = ACTIONS(4232),
    [anon_sym_LT_DASH] = ACTIONS(4232),
    [anon_sym_DOT_LBRACK] = ACTIONS(4230),
    [anon_sym_LT] = ACTIONS(4230),
    [anon_sym_GT] = ACTIONS(4232),
    [anon_sym_use] = ACTIONS(4232),
    [anon_sym_use_BANG] = ACTIONS(4230),
    [anon_sym_do_BANG] = ACTIONS(4230),
    [anon_sym_begin] = ACTIONS(4232),
    [anon_sym_LPAREN2] = ACTIONS(4232),
    [anon_sym_or] = ACTIONS(4232),
    [aux_sym_char_token1] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4232),
    [anon_sym_DQUOTE] = ACTIONS(4232),
    [anon_sym_AT_DQUOTE] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [sym_bool] = ACTIONS(4232),
    [sym_unit] = ACTIONS(4230),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4232),
    [sym_op_identifier] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4232),
    [anon_sym_DASH] = ACTIONS(4232),
    [anon_sym_PLUS_DOT] = ACTIONS(4232),
    [anon_sym_DASH_DOT] = ACTIONS(4232),
    [anon_sym_PERCENT] = ACTIONS(4232),
    [anon_sym_AMP_AMP] = ACTIONS(4232),
    [anon_sym_TILDE] = ACTIONS(4230),
    [aux_sym_prefix_op_token1] = ACTIONS(4232),
    [aux_sym_infix_op_token1] = ACTIONS(4230),
    [aux_sym_infix_op_token2] = ACTIONS(4232),
    [anon_sym_PIPE_PIPE] = ACTIONS(4232),
    [anon_sym_BANG_EQ] = ACTIONS(4232),
    [anon_sym_COLON_EQ] = ACTIONS(4230),
    [anon_sym_DOLLAR] = ACTIONS(4232),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4232),
    [sym_int] = ACTIONS(4232),
    [sym_xint] = ACTIONS(4230),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4230),
    [sym__newline] = ACTIONS(4230),
  },
  [3234] = {
    [sym_block_comment] = STATE(3234),
    [sym_compiler_directive_decl] = STATE(3234),
    [sym_fsi_directive_decl] = STATE(3234),
    [sym_preproc_line] = STATE(3234),
    [sym_identifier] = ACTIONS(3907),
    [anon_sym_EQ] = ACTIONS(3905),
    [anon_sym_COLON] = ACTIONS(3907),
    [anon_sym_return] = ACTIONS(3907),
    [anon_sym_do] = ACTIONS(3907),
    [anon_sym_let] = ACTIONS(3907),
    [anon_sym_let_BANG] = ACTIONS(3905),
    [anon_sym_LPAREN] = ACTIONS(3907),
    [anon_sym_COMMA] = ACTIONS(3905),
    [anon_sym_null] = ACTIONS(3907),
    [anon_sym_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_COLON] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3907),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3905),
    [anon_sym_LBRACE] = ACTIONS(3907),
    [anon_sym_LT_AT] = ACTIONS(3907),
    [anon_sym_LT_AT_AT] = ACTIONS(3907),
    [anon_sym_DOT] = ACTIONS(3907),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3905),
    [anon_sym_new] = ACTIONS(3907),
    [anon_sym_return_BANG] = ACTIONS(3905),
    [anon_sym_yield] = ACTIONS(3907),
    [anon_sym_yield_BANG] = ACTIONS(3905),
    [anon_sym_lazy] = ACTIONS(3907),
    [anon_sym_assert] = ACTIONS(3907),
    [anon_sym_upcast] = ACTIONS(3907),
    [anon_sym_downcast] = ACTIONS(3907),
    [anon_sym_COLON_GT] = ACTIONS(3905),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3905),
    [anon_sym_for] = ACTIONS(3907),
    [anon_sym_while] = ACTIONS(3907),
    [anon_sym_if] = ACTIONS(3907),
    [anon_sym_fun] = ACTIONS(3907),
    [anon_sym_try] = ACTIONS(3907),
    [anon_sym_match] = ACTIONS(3907),
    [anon_sym_match_BANG] = ACTIONS(3905),
    [anon_sym_function] = ACTIONS(3907),
    [anon_sym_LT_DASH] = ACTIONS(3907),
    [anon_sym_DOT_LBRACK] = ACTIONS(3905),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3907),
    [anon_sym_use] = ACTIONS(3907),
    [anon_sym_use_BANG] = ACTIONS(3905),
    [anon_sym_do_BANG] = ACTIONS(3905),
    [anon_sym_begin] = ACTIONS(3907),
    [anon_sym_LPAREN2] = ACTIONS(3907),
    [anon_sym_or] = ACTIONS(3907),
    [aux_sym_char_token1] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3907),
    [anon_sym_DQUOTE] = ACTIONS(3907),
    [anon_sym_AT_DQUOTE] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [sym_bool] = ACTIONS(3907),
    [sym_unit] = ACTIONS(3905),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3907),
    [sym_op_identifier] = ACTIONS(3907),
    [anon_sym_PLUS] = ACTIONS(3907),
    [anon_sym_DASH] = ACTIONS(3907),
    [anon_sym_PLUS_DOT] = ACTIONS(3907),
    [anon_sym_DASH_DOT] = ACTIONS(3907),
    [anon_sym_PERCENT] = ACTIONS(3907),
    [anon_sym_AMP_AMP] = ACTIONS(3907),
    [anon_sym_TILDE] = ACTIONS(3905),
    [aux_sym_prefix_op_token1] = ACTIONS(3907),
    [aux_sym_infix_op_token1] = ACTIONS(3905),
    [aux_sym_infix_op_token2] = ACTIONS(3907),
    [anon_sym_PIPE_PIPE] = ACTIONS(3907),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_COLON_EQ] = ACTIONS(3905),
    [anon_sym_DOLLAR] = ACTIONS(3907),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3907),
    [sym_int] = ACTIONS(3907),
    [sym_xint] = ACTIONS(3905),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3905),
    [sym__newline] = ACTIONS(3905),
  },
  [3235] = {
    [sym_block_comment] = STATE(3235),
    [sym_compiler_directive_decl] = STATE(3235),
    [sym_fsi_directive_decl] = STATE(3235),
    [sym_preproc_line] = STATE(3235),
    [sym_identifier] = ACTIONS(3900),
    [anon_sym_EQ] = ACTIONS(3898),
    [anon_sym_COLON] = ACTIONS(3900),
    [anon_sym_return] = ACTIONS(3900),
    [anon_sym_do] = ACTIONS(3900),
    [anon_sym_let] = ACTIONS(3900),
    [anon_sym_let_BANG] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3898),
    [anon_sym_null] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_COLON] = ACTIONS(3898),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_LBRACK] = ACTIONS(3900),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3898),
    [anon_sym_LBRACE] = ACTIONS(3900),
    [anon_sym_LT_AT] = ACTIONS(3900),
    [anon_sym_LT_AT_AT] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(3900),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3898),
    [anon_sym_new] = ACTIONS(3900),
    [anon_sym_return_BANG] = ACTIONS(3898),
    [anon_sym_yield] = ACTIONS(3900),
    [anon_sym_yield_BANG] = ACTIONS(3898),
    [anon_sym_lazy] = ACTIONS(3900),
    [anon_sym_assert] = ACTIONS(3900),
    [anon_sym_upcast] = ACTIONS(3900),
    [anon_sym_downcast] = ACTIONS(3900),
    [anon_sym_COLON_GT] = ACTIONS(3898),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3898),
    [anon_sym_for] = ACTIONS(3900),
    [anon_sym_while] = ACTIONS(3900),
    [anon_sym_if] = ACTIONS(3900),
    [anon_sym_fun] = ACTIONS(3900),
    [anon_sym_try] = ACTIONS(3900),
    [anon_sym_match] = ACTIONS(3900),
    [anon_sym_match_BANG] = ACTIONS(3898),
    [anon_sym_function] = ACTIONS(3900),
    [anon_sym_LT_DASH] = ACTIONS(3900),
    [anon_sym_DOT_LBRACK] = ACTIONS(3898),
    [anon_sym_LT] = ACTIONS(3898),
    [anon_sym_GT] = ACTIONS(3900),
    [anon_sym_use] = ACTIONS(3900),
    [anon_sym_use_BANG] = ACTIONS(3898),
    [anon_sym_do_BANG] = ACTIONS(3898),
    [anon_sym_begin] = ACTIONS(3900),
    [anon_sym_LPAREN2] = ACTIONS(3900),
    [anon_sym_or] = ACTIONS(3900),
    [aux_sym_char_token1] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3900),
    [anon_sym_DQUOTE] = ACTIONS(3900),
    [anon_sym_AT_DQUOTE] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3898),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3900),
    [sym_op_identifier] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(3900),
    [anon_sym_DASH] = ACTIONS(3900),
    [anon_sym_PLUS_DOT] = ACTIONS(3900),
    [anon_sym_DASH_DOT] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(3900),
    [anon_sym_AMP_AMP] = ACTIONS(3900),
    [anon_sym_TILDE] = ACTIONS(3898),
    [aux_sym_prefix_op_token1] = ACTIONS(3900),
    [aux_sym_infix_op_token1] = ACTIONS(3898),
    [aux_sym_infix_op_token2] = ACTIONS(3900),
    [anon_sym_PIPE_PIPE] = ACTIONS(3900),
    [anon_sym_BANG_EQ] = ACTIONS(3900),
    [anon_sym_COLON_EQ] = ACTIONS(3898),
    [anon_sym_DOLLAR] = ACTIONS(3900),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3900),
    [sym_int] = ACTIONS(3900),
    [sym_xint] = ACTIONS(3898),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3898),
    [sym__newline] = ACTIONS(3898),
  },
  [3236] = {
    [sym_block_comment] = STATE(3236),
    [sym_compiler_directive_decl] = STATE(3236),
    [sym_fsi_directive_decl] = STATE(3236),
    [sym_preproc_line] = STATE(3236),
    [sym_identifier] = ACTIONS(4064),
    [anon_sym_EQ] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4064),
    [anon_sym_return] = ACTIONS(4064),
    [anon_sym_do] = ACTIONS(4064),
    [anon_sym_let] = ACTIONS(4064),
    [anon_sym_let_BANG] = ACTIONS(4062),
    [anon_sym_LPAREN] = ACTIONS(4064),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_null] = ACTIONS(4064),
    [anon_sym_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_COLON] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4062),
    [anon_sym_LBRACE] = ACTIONS(4064),
    [anon_sym_LT_AT] = ACTIONS(4064),
    [anon_sym_LT_AT_AT] = ACTIONS(4064),
    [anon_sym_DOT] = ACTIONS(4064),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4062),
    [anon_sym_new] = ACTIONS(4064),
    [anon_sym_return_BANG] = ACTIONS(4062),
    [anon_sym_yield] = ACTIONS(4064),
    [anon_sym_yield_BANG] = ACTIONS(4062),
    [anon_sym_lazy] = ACTIONS(4064),
    [anon_sym_assert] = ACTIONS(4064),
    [anon_sym_upcast] = ACTIONS(4064),
    [anon_sym_downcast] = ACTIONS(4064),
    [anon_sym_COLON_GT] = ACTIONS(4062),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4062),
    [anon_sym_for] = ACTIONS(4064),
    [anon_sym_while] = ACTIONS(4064),
    [anon_sym_if] = ACTIONS(4064),
    [anon_sym_fun] = ACTIONS(4064),
    [anon_sym_try] = ACTIONS(4064),
    [anon_sym_match] = ACTIONS(4064),
    [anon_sym_match_BANG] = ACTIONS(4062),
    [anon_sym_function] = ACTIONS(4064),
    [anon_sym_LT_DASH] = ACTIONS(4064),
    [anon_sym_DOT_LBRACK] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(4062),
    [anon_sym_use] = ACTIONS(4064),
    [anon_sym_use_BANG] = ACTIONS(4062),
    [anon_sym_do_BANG] = ACTIONS(4062),
    [anon_sym_DOT_DOT] = ACTIONS(4062),
    [anon_sym_begin] = ACTIONS(4064),
    [anon_sym_LPAREN2] = ACTIONS(4064),
    [anon_sym_or] = ACTIONS(4064),
    [aux_sym_char_token1] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_AT_DQUOTE] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [sym_bool] = ACTIONS(4064),
    [sym_unit] = ACTIONS(4062),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4064),
    [sym_op_identifier] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4064),
    [anon_sym_DASH] = ACTIONS(4064),
    [anon_sym_PLUS_DOT] = ACTIONS(4064),
    [anon_sym_DASH_DOT] = ACTIONS(4064),
    [anon_sym_PERCENT] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_TILDE] = ACTIONS(4062),
    [aux_sym_prefix_op_token1] = ACTIONS(4064),
    [aux_sym_infix_op_token1] = ACTIONS(4062),
    [aux_sym_infix_op_token2] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_BANG_EQ] = ACTIONS(4064),
    [anon_sym_COLON_EQ] = ACTIONS(4062),
    [anon_sym_DOLLAR] = ACTIONS(4064),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4064),
    [sym_int] = ACTIONS(4064),
    [sym_xint] = ACTIONS(4062),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4062),
    [sym__newline] = ACTIONS(4062),
  },
  [3237] = {
    [sym_block_comment] = STATE(3237),
    [sym_compiler_directive_decl] = STATE(3237),
    [sym_fsi_directive_decl] = STATE(3237),
    [sym_preproc_line] = STATE(3237),
    [sym_identifier] = ACTIONS(4126),
    [anon_sym_EQ] = ACTIONS(4124),
    [anon_sym_COLON] = ACTIONS(4126),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_do] = ACTIONS(4126),
    [anon_sym_let] = ACTIONS(4126),
    [anon_sym_let_BANG] = ACTIONS(4124),
    [anon_sym_LPAREN] = ACTIONS(4126),
    [anon_sym_COMMA] = ACTIONS(4124),
    [anon_sym_null] = ACTIONS(4126),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_COLON] = ACTIONS(4124),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LBRACK] = ACTIONS(4126),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4126),
    [anon_sym_LT_AT] = ACTIONS(4126),
    [anon_sym_LT_AT_AT] = ACTIONS(4126),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4124),
    [anon_sym_new] = ACTIONS(4126),
    [anon_sym_return_BANG] = ACTIONS(4124),
    [anon_sym_yield] = ACTIONS(4126),
    [anon_sym_yield_BANG] = ACTIONS(4124),
    [anon_sym_lazy] = ACTIONS(4126),
    [anon_sym_assert] = ACTIONS(4126),
    [anon_sym_upcast] = ACTIONS(4126),
    [anon_sym_downcast] = ACTIONS(4126),
    [anon_sym_COLON_GT] = ACTIONS(4124),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4124),
    [anon_sym_for] = ACTIONS(4126),
    [anon_sym_while] = ACTIONS(4126),
    [anon_sym_if] = ACTIONS(4126),
    [anon_sym_fun] = ACTIONS(4126),
    [anon_sym_try] = ACTIONS(4126),
    [anon_sym_match] = ACTIONS(4126),
    [anon_sym_match_BANG] = ACTIONS(4124),
    [anon_sym_function] = ACTIONS(4126),
    [anon_sym_LT_DASH] = ACTIONS(4126),
    [anon_sym_DOT_LBRACK] = ACTIONS(4124),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_GT] = ACTIONS(4126),
    [anon_sym_use] = ACTIONS(4126),
    [anon_sym_use_BANG] = ACTIONS(4124),
    [anon_sym_do_BANG] = ACTIONS(4124),
    [anon_sym_begin] = ACTIONS(4126),
    [anon_sym_LPAREN2] = ACTIONS(4126),
    [anon_sym_or] = ACTIONS(4126),
    [aux_sym_char_token1] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4126),
    [anon_sym_DQUOTE] = ACTIONS(4126),
    [anon_sym_AT_DQUOTE] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [sym_bool] = ACTIONS(4126),
    [sym_unit] = ACTIONS(4124),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4126),
    [sym_op_identifier] = ACTIONS(4126),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_PLUS_DOT] = ACTIONS(4126),
    [anon_sym_DASH_DOT] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_AMP_AMP] = ACTIONS(4126),
    [anon_sym_TILDE] = ACTIONS(4124),
    [aux_sym_prefix_op_token1] = ACTIONS(4126),
    [aux_sym_infix_op_token1] = ACTIONS(4124),
    [aux_sym_infix_op_token2] = ACTIONS(4126),
    [anon_sym_PIPE_PIPE] = ACTIONS(4126),
    [anon_sym_BANG_EQ] = ACTIONS(4126),
    [anon_sym_COLON_EQ] = ACTIONS(4124),
    [anon_sym_DOLLAR] = ACTIONS(4126),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4126),
    [sym_int] = ACTIONS(4126),
    [sym_xint] = ACTIONS(4124),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4124),
    [sym__newline] = ACTIONS(4124),
  },
  [3238] = {
    [sym_block_comment] = STATE(3238),
    [sym_compiler_directive_decl] = STATE(3238),
    [sym_fsi_directive_decl] = STATE(3238),
    [sym_preproc_line] = STATE(3238),
    [sym_identifier] = ACTIONS(3893),
    [anon_sym_EQ] = ACTIONS(3891),
    [anon_sym_COLON] = ACTIONS(3893),
    [anon_sym_return] = ACTIONS(3893),
    [anon_sym_do] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_let_BANG] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_COMMA] = ACTIONS(3891),
    [anon_sym_null] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_COLON] = ACTIONS(3891),
    [anon_sym_AMP] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3891),
    [anon_sym_LBRACE] = ACTIONS(3893),
    [anon_sym_LT_AT] = ACTIONS(3893),
    [anon_sym_LT_AT_AT] = ACTIONS(3893),
    [anon_sym_DOT] = ACTIONS(3893),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3891),
    [anon_sym_new] = ACTIONS(3893),
    [anon_sym_return_BANG] = ACTIONS(3891),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_yield_BANG] = ACTIONS(3891),
    [anon_sym_lazy] = ACTIONS(3893),
    [anon_sym_assert] = ACTIONS(3893),
    [anon_sym_upcast] = ACTIONS(3893),
    [anon_sym_downcast] = ACTIONS(3893),
    [anon_sym_COLON_GT] = ACTIONS(3891),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3891),
    [anon_sym_for] = ACTIONS(3893),
    [anon_sym_while] = ACTIONS(3893),
    [anon_sym_if] = ACTIONS(3893),
    [anon_sym_fun] = ACTIONS(3893),
    [anon_sym_try] = ACTIONS(3893),
    [anon_sym_match] = ACTIONS(3893),
    [anon_sym_match_BANG] = ACTIONS(3891),
    [anon_sym_function] = ACTIONS(3893),
    [anon_sym_LT_DASH] = ACTIONS(3893),
    [anon_sym_DOT_LBRACK] = ACTIONS(3891),
    [anon_sym_LT] = ACTIONS(3891),
    [anon_sym_GT] = ACTIONS(3893),
    [anon_sym_use] = ACTIONS(3893),
    [anon_sym_use_BANG] = ACTIONS(3891),
    [anon_sym_do_BANG] = ACTIONS(3891),
    [anon_sym_begin] = ACTIONS(3893),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_or] = ACTIONS(3893),
    [aux_sym_char_token1] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3893),
    [anon_sym_DQUOTE] = ACTIONS(3893),
    [anon_sym_AT_DQUOTE] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [sym_bool] = ACTIONS(3893),
    [sym_unit] = ACTIONS(3891),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3893),
    [sym_op_identifier] = ACTIONS(3893),
    [anon_sym_PLUS] = ACTIONS(3893),
    [anon_sym_DASH] = ACTIONS(3893),
    [anon_sym_PLUS_DOT] = ACTIONS(3893),
    [anon_sym_DASH_DOT] = ACTIONS(3893),
    [anon_sym_PERCENT] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_TILDE] = ACTIONS(3891),
    [aux_sym_prefix_op_token1] = ACTIONS(3893),
    [aux_sym_infix_op_token1] = ACTIONS(3891),
    [aux_sym_infix_op_token2] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [anon_sym_BANG_EQ] = ACTIONS(3893),
    [anon_sym_COLON_EQ] = ACTIONS(3891),
    [anon_sym_DOLLAR] = ACTIONS(3893),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3893),
    [sym_int] = ACTIONS(3893),
    [sym_xint] = ACTIONS(3891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3891),
    [sym__newline] = ACTIONS(3891),
  },
  [3239] = {
    [sym_block_comment] = STATE(3239),
    [sym_compiler_directive_decl] = STATE(3239),
    [sym_fsi_directive_decl] = STATE(3239),
    [sym_preproc_line] = STATE(3239),
    [sym_identifier] = ACTIONS(3875),
    [anon_sym_EQ] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(3875),
    [anon_sym_return] = ACTIONS(3875),
    [anon_sym_do] = ACTIONS(3875),
    [anon_sym_let] = ACTIONS(3875),
    [anon_sym_let_BANG] = ACTIONS(3873),
    [anon_sym_LPAREN] = ACTIONS(3875),
    [anon_sym_COMMA] = ACTIONS(3873),
    [anon_sym_null] = ACTIONS(3875),
    [anon_sym_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_COLON] = ACTIONS(3873),
    [anon_sym_AMP] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(3875),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3873),
    [anon_sym_LBRACE] = ACTIONS(3875),
    [anon_sym_LT_AT] = ACTIONS(3875),
    [anon_sym_LT_AT_AT] = ACTIONS(3875),
    [anon_sym_DOT] = ACTIONS(3875),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3873),
    [anon_sym_new] = ACTIONS(3875),
    [anon_sym_return_BANG] = ACTIONS(3873),
    [anon_sym_yield] = ACTIONS(3875),
    [anon_sym_yield_BANG] = ACTIONS(3873),
    [anon_sym_lazy] = ACTIONS(3875),
    [anon_sym_assert] = ACTIONS(3875),
    [anon_sym_upcast] = ACTIONS(3875),
    [anon_sym_downcast] = ACTIONS(3875),
    [anon_sym_COLON_GT] = ACTIONS(3873),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3873),
    [anon_sym_for] = ACTIONS(3875),
    [anon_sym_while] = ACTIONS(3875),
    [anon_sym_if] = ACTIONS(3875),
    [anon_sym_fun] = ACTIONS(3875),
    [anon_sym_try] = ACTIONS(3875),
    [anon_sym_match] = ACTIONS(3875),
    [anon_sym_match_BANG] = ACTIONS(3873),
    [anon_sym_function] = ACTIONS(3875),
    [anon_sym_LT_DASH] = ACTIONS(3875),
    [anon_sym_DOT_LBRACK] = ACTIONS(3873),
    [anon_sym_LT] = ACTIONS(3873),
    [anon_sym_GT] = ACTIONS(3875),
    [anon_sym_use] = ACTIONS(3875),
    [anon_sym_use_BANG] = ACTIONS(3873),
    [anon_sym_do_BANG] = ACTIONS(3873),
    [anon_sym_begin] = ACTIONS(3875),
    [anon_sym_LPAREN2] = ACTIONS(3875),
    [anon_sym_or] = ACTIONS(3875),
    [aux_sym_char_token1] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3875),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [anon_sym_AT_DQUOTE] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [sym_bool] = ACTIONS(3875),
    [sym_unit] = ACTIONS(3873),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3875),
    [sym_op_identifier] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS_DOT] = ACTIONS(3875),
    [anon_sym_DASH_DOT] = ACTIONS(3875),
    [anon_sym_PERCENT] = ACTIONS(3875),
    [anon_sym_AMP_AMP] = ACTIONS(3875),
    [anon_sym_TILDE] = ACTIONS(3873),
    [aux_sym_prefix_op_token1] = ACTIONS(3875),
    [aux_sym_infix_op_token1] = ACTIONS(3873),
    [aux_sym_infix_op_token2] = ACTIONS(3875),
    [anon_sym_PIPE_PIPE] = ACTIONS(3875),
    [anon_sym_BANG_EQ] = ACTIONS(3875),
    [anon_sym_COLON_EQ] = ACTIONS(3873),
    [anon_sym_DOLLAR] = ACTIONS(3875),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3875),
    [sym_int] = ACTIONS(3875),
    [sym_xint] = ACTIONS(3873),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3873),
    [sym__newline] = ACTIONS(3873),
  },
  [3240] = {
    [sym_block_comment] = STATE(3240),
    [sym_compiler_directive_decl] = STATE(3240),
    [sym_fsi_directive_decl] = STATE(3240),
    [sym_preproc_line] = STATE(3240),
    [sym_identifier] = ACTIONS(4122),
    [anon_sym_EQ] = ACTIONS(4120),
    [anon_sym_COLON] = ACTIONS(4122),
    [anon_sym_return] = ACTIONS(4122),
    [anon_sym_do] = ACTIONS(4122),
    [anon_sym_let] = ACTIONS(4122),
    [anon_sym_let_BANG] = ACTIONS(4120),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_COMMA] = ACTIONS(4120),
    [anon_sym_null] = ACTIONS(4122),
    [anon_sym_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_COLON] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_LT_AT] = ACTIONS(4122),
    [anon_sym_LT_AT_AT] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4122),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4120),
    [anon_sym_new] = ACTIONS(4122),
    [anon_sym_return_BANG] = ACTIONS(4120),
    [anon_sym_yield] = ACTIONS(4122),
    [anon_sym_yield_BANG] = ACTIONS(4120),
    [anon_sym_lazy] = ACTIONS(4122),
    [anon_sym_assert] = ACTIONS(4122),
    [anon_sym_upcast] = ACTIONS(4122),
    [anon_sym_downcast] = ACTIONS(4122),
    [anon_sym_COLON_GT] = ACTIONS(4120),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4120),
    [anon_sym_for] = ACTIONS(4122),
    [anon_sym_while] = ACTIONS(4122),
    [anon_sym_if] = ACTIONS(4122),
    [anon_sym_fun] = ACTIONS(4122),
    [anon_sym_try] = ACTIONS(4122),
    [anon_sym_match] = ACTIONS(4122),
    [anon_sym_match_BANG] = ACTIONS(4120),
    [anon_sym_function] = ACTIONS(4122),
    [anon_sym_LT_DASH] = ACTIONS(4122),
    [anon_sym_DOT_LBRACK] = ACTIONS(4120),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_GT] = ACTIONS(4122),
    [anon_sym_use] = ACTIONS(4122),
    [anon_sym_use_BANG] = ACTIONS(4120),
    [anon_sym_do_BANG] = ACTIONS(4120),
    [anon_sym_begin] = ACTIONS(4122),
    [anon_sym_LPAREN2] = ACTIONS(4122),
    [anon_sym_or] = ACTIONS(4122),
    [aux_sym_char_token1] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4122),
    [anon_sym_DQUOTE] = ACTIONS(4122),
    [anon_sym_AT_DQUOTE] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [sym_bool] = ACTIONS(4122),
    [sym_unit] = ACTIONS(4120),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4122),
    [sym_op_identifier] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4122),
    [anon_sym_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_DOT] = ACTIONS(4122),
    [anon_sym_DASH_DOT] = ACTIONS(4122),
    [anon_sym_PERCENT] = ACTIONS(4122),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_TILDE] = ACTIONS(4120),
    [aux_sym_prefix_op_token1] = ACTIONS(4122),
    [aux_sym_infix_op_token1] = ACTIONS(4120),
    [aux_sym_infix_op_token2] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_COLON_EQ] = ACTIONS(4120),
    [anon_sym_DOLLAR] = ACTIONS(4122),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4122),
    [sym_int] = ACTIONS(4122),
    [sym_xint] = ACTIONS(4120),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4120),
    [sym__newline] = ACTIONS(4120),
  },
  [3241] = {
    [sym_block_comment] = STATE(3241),
    [sym_compiler_directive_decl] = STATE(3241),
    [sym_fsi_directive_decl] = STATE(3241),
    [sym_preproc_line] = STATE(3241),
    [sym_identifier] = ACTIONS(4118),
    [anon_sym_EQ] = ACTIONS(4116),
    [anon_sym_COLON] = ACTIONS(4118),
    [anon_sym_return] = ACTIONS(4118),
    [anon_sym_do] = ACTIONS(4118),
    [anon_sym_let] = ACTIONS(4118),
    [anon_sym_let_BANG] = ACTIONS(4116),
    [anon_sym_LPAREN] = ACTIONS(4118),
    [anon_sym_COMMA] = ACTIONS(4116),
    [anon_sym_null] = ACTIONS(4118),
    [anon_sym_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_COLON] = ACTIONS(4116),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4118),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(4118),
    [anon_sym_LT_AT] = ACTIONS(4118),
    [anon_sym_LT_AT_AT] = ACTIONS(4118),
    [anon_sym_DOT] = ACTIONS(4118),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4116),
    [anon_sym_new] = ACTIONS(4118),
    [anon_sym_return_BANG] = ACTIONS(4116),
    [anon_sym_yield] = ACTIONS(4118),
    [anon_sym_yield_BANG] = ACTIONS(4116),
    [anon_sym_lazy] = ACTIONS(4118),
    [anon_sym_assert] = ACTIONS(4118),
    [anon_sym_upcast] = ACTIONS(4118),
    [anon_sym_downcast] = ACTIONS(4118),
    [anon_sym_COLON_GT] = ACTIONS(4116),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4116),
    [anon_sym_for] = ACTIONS(4118),
    [anon_sym_while] = ACTIONS(4118),
    [anon_sym_if] = ACTIONS(4118),
    [anon_sym_fun] = ACTIONS(4118),
    [anon_sym_try] = ACTIONS(4118),
    [anon_sym_match] = ACTIONS(4118),
    [anon_sym_match_BANG] = ACTIONS(4116),
    [anon_sym_function] = ACTIONS(4118),
    [anon_sym_LT_DASH] = ACTIONS(4118),
    [anon_sym_DOT_LBRACK] = ACTIONS(4116),
    [anon_sym_LT] = ACTIONS(4116),
    [anon_sym_GT] = ACTIONS(4118),
    [anon_sym_use] = ACTIONS(4118),
    [anon_sym_use_BANG] = ACTIONS(4116),
    [anon_sym_do_BANG] = ACTIONS(4116),
    [anon_sym_begin] = ACTIONS(4118),
    [anon_sym_LPAREN2] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [aux_sym_char_token1] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4118),
    [anon_sym_DQUOTE] = ACTIONS(4118),
    [anon_sym_AT_DQUOTE] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [sym_bool] = ACTIONS(4118),
    [sym_unit] = ACTIONS(4116),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4118),
    [sym_op_identifier] = ACTIONS(4118),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_PLUS_DOT] = ACTIONS(4118),
    [anon_sym_DASH_DOT] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_AMP_AMP] = ACTIONS(4118),
    [anon_sym_TILDE] = ACTIONS(4116),
    [aux_sym_prefix_op_token1] = ACTIONS(4118),
    [aux_sym_infix_op_token1] = ACTIONS(4116),
    [aux_sym_infix_op_token2] = ACTIONS(4118),
    [anon_sym_PIPE_PIPE] = ACTIONS(4118),
    [anon_sym_BANG_EQ] = ACTIONS(4118),
    [anon_sym_COLON_EQ] = ACTIONS(4116),
    [anon_sym_DOLLAR] = ACTIONS(4118),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4118),
    [sym_int] = ACTIONS(4118),
    [sym_xint] = ACTIONS(4116),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4116),
    [sym__newline] = ACTIONS(4116),
  },
  [3242] = {
    [sym_block_comment] = STATE(3242),
    [sym_compiler_directive_decl] = STATE(3242),
    [sym_fsi_directive_decl] = STATE(3242),
    [sym_preproc_line] = STATE(3242),
    [sym_identifier] = ACTIONS(4112),
    [anon_sym_EQ] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4112),
    [anon_sym_return] = ACTIONS(4112),
    [anon_sym_do] = ACTIONS(4112),
    [anon_sym_let] = ACTIONS(4112),
    [anon_sym_let_BANG] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_null] = ACTIONS(4112),
    [anon_sym_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_COLON] = ACTIONS(4110),
    [anon_sym_AMP] = ACTIONS(4112),
    [anon_sym_LBRACK] = ACTIONS(4112),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4110),
    [anon_sym_LBRACE] = ACTIONS(4112),
    [anon_sym_LT_AT] = ACTIONS(4112),
    [anon_sym_LT_AT_AT] = ACTIONS(4112),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4110),
    [anon_sym_new] = ACTIONS(4112),
    [anon_sym_return_BANG] = ACTIONS(4110),
    [anon_sym_yield] = ACTIONS(4112),
    [anon_sym_yield_BANG] = ACTIONS(4110),
    [anon_sym_lazy] = ACTIONS(4112),
    [anon_sym_assert] = ACTIONS(4112),
    [anon_sym_upcast] = ACTIONS(4112),
    [anon_sym_downcast] = ACTIONS(4112),
    [anon_sym_COLON_GT] = ACTIONS(4110),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4110),
    [anon_sym_for] = ACTIONS(4112),
    [anon_sym_while] = ACTIONS(4112),
    [anon_sym_if] = ACTIONS(4112),
    [anon_sym_fun] = ACTIONS(4112),
    [anon_sym_try] = ACTIONS(4112),
    [anon_sym_match] = ACTIONS(4112),
    [anon_sym_match_BANG] = ACTIONS(4110),
    [anon_sym_function] = ACTIONS(4112),
    [anon_sym_LT_DASH] = ACTIONS(4112),
    [anon_sym_DOT_LBRACK] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(4110),
    [anon_sym_GT] = ACTIONS(4112),
    [anon_sym_use] = ACTIONS(4112),
    [anon_sym_use_BANG] = ACTIONS(4110),
    [anon_sym_do_BANG] = ACTIONS(4110),
    [anon_sym_begin] = ACTIONS(4112),
    [anon_sym_LPAREN2] = ACTIONS(4112),
    [anon_sym_or] = ACTIONS(4112),
    [aux_sym_char_token1] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4112),
    [anon_sym_DQUOTE] = ACTIONS(4112),
    [anon_sym_AT_DQUOTE] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [sym_bool] = ACTIONS(4112),
    [sym_unit] = ACTIONS(4110),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4112),
    [sym_op_identifier] = ACTIONS(4112),
    [anon_sym_PLUS] = ACTIONS(4112),
    [anon_sym_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_DOT] = ACTIONS(4112),
    [anon_sym_DASH_DOT] = ACTIONS(4112),
    [anon_sym_PERCENT] = ACTIONS(4112),
    [anon_sym_AMP_AMP] = ACTIONS(4112),
    [anon_sym_TILDE] = ACTIONS(4110),
    [aux_sym_prefix_op_token1] = ACTIONS(4112),
    [aux_sym_infix_op_token1] = ACTIONS(4110),
    [aux_sym_infix_op_token2] = ACTIONS(4112),
    [anon_sym_PIPE_PIPE] = ACTIONS(4112),
    [anon_sym_BANG_EQ] = ACTIONS(4112),
    [anon_sym_COLON_EQ] = ACTIONS(4110),
    [anon_sym_DOLLAR] = ACTIONS(4112),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4112),
    [sym_int] = ACTIONS(4112),
    [sym_xint] = ACTIONS(4110),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4110),
    [sym__newline] = ACTIONS(4110),
  },
  [3243] = {
    [sym_block_comment] = STATE(3243),
    [sym_compiler_directive_decl] = STATE(3243),
    [sym_fsi_directive_decl] = STATE(3243),
    [sym_preproc_line] = STATE(3243),
    [sym_identifier] = ACTIONS(4108),
    [anon_sym_EQ] = ACTIONS(4106),
    [anon_sym_COLON] = ACTIONS(4108),
    [anon_sym_return] = ACTIONS(4108),
    [anon_sym_do] = ACTIONS(4108),
    [anon_sym_let] = ACTIONS(4108),
    [anon_sym_let_BANG] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(4108),
    [anon_sym_COMMA] = ACTIONS(4106),
    [anon_sym_null] = ACTIONS(4108),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_COLON] = ACTIONS(4106),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LBRACK] = ACTIONS(4108),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(4108),
    [anon_sym_LT_AT] = ACTIONS(4108),
    [anon_sym_LT_AT_AT] = ACTIONS(4108),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4106),
    [anon_sym_new] = ACTIONS(4108),
    [anon_sym_return_BANG] = ACTIONS(4106),
    [anon_sym_yield] = ACTIONS(4108),
    [anon_sym_yield_BANG] = ACTIONS(4106),
    [anon_sym_lazy] = ACTIONS(4108),
    [anon_sym_assert] = ACTIONS(4108),
    [anon_sym_upcast] = ACTIONS(4108),
    [anon_sym_downcast] = ACTIONS(4108),
    [anon_sym_COLON_GT] = ACTIONS(4106),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4106),
    [anon_sym_for] = ACTIONS(4108),
    [anon_sym_while] = ACTIONS(4108),
    [anon_sym_if] = ACTIONS(4108),
    [anon_sym_fun] = ACTIONS(4108),
    [anon_sym_try] = ACTIONS(4108),
    [anon_sym_match] = ACTIONS(4108),
    [anon_sym_match_BANG] = ACTIONS(4106),
    [anon_sym_function] = ACTIONS(4108),
    [anon_sym_LT_DASH] = ACTIONS(4108),
    [anon_sym_DOT_LBRACK] = ACTIONS(4106),
    [anon_sym_LT] = ACTIONS(4106),
    [anon_sym_GT] = ACTIONS(4108),
    [anon_sym_use] = ACTIONS(4108),
    [anon_sym_use_BANG] = ACTIONS(4106),
    [anon_sym_do_BANG] = ACTIONS(4106),
    [anon_sym_begin] = ACTIONS(4108),
    [anon_sym_LPAREN2] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [aux_sym_char_token1] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4108),
    [anon_sym_DQUOTE] = ACTIONS(4108),
    [anon_sym_AT_DQUOTE] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [sym_bool] = ACTIONS(4108),
    [sym_unit] = ACTIONS(4106),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4108),
    [sym_op_identifier] = ACTIONS(4108),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_PLUS_DOT] = ACTIONS(4108),
    [anon_sym_DASH_DOT] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_AMP_AMP] = ACTIONS(4108),
    [anon_sym_TILDE] = ACTIONS(4106),
    [aux_sym_prefix_op_token1] = ACTIONS(4108),
    [aux_sym_infix_op_token1] = ACTIONS(4106),
    [aux_sym_infix_op_token2] = ACTIONS(4108),
    [anon_sym_PIPE_PIPE] = ACTIONS(4108),
    [anon_sym_BANG_EQ] = ACTIONS(4108),
    [anon_sym_COLON_EQ] = ACTIONS(4106),
    [anon_sym_DOLLAR] = ACTIONS(4108),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4108),
    [sym_int] = ACTIONS(4108),
    [sym_xint] = ACTIONS(4106),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4106),
    [sym__newline] = ACTIONS(4106),
  },
  [3244] = {
    [sym_block_comment] = STATE(3244),
    [sym_compiler_directive_decl] = STATE(3244),
    [sym_fsi_directive_decl] = STATE(3244),
    [sym_preproc_line] = STATE(3244),
    [sym_identifier] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(4091),
    [anon_sym_COLON] = ACTIONS(4093),
    [anon_sym_return] = ACTIONS(4093),
    [anon_sym_do] = ACTIONS(4093),
    [anon_sym_let] = ACTIONS(4093),
    [anon_sym_let_BANG] = ACTIONS(4091),
    [anon_sym_LPAREN] = ACTIONS(4093),
    [anon_sym_COMMA] = ACTIONS(4091),
    [anon_sym_null] = ACTIONS(4093),
    [anon_sym_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_COLON] = ACTIONS(4091),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(4093),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4091),
    [anon_sym_LBRACE] = ACTIONS(4093),
    [anon_sym_LT_AT] = ACTIONS(4093),
    [anon_sym_LT_AT_AT] = ACTIONS(4093),
    [anon_sym_DOT] = ACTIONS(4093),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4091),
    [anon_sym_new] = ACTIONS(4093),
    [anon_sym_return_BANG] = ACTIONS(4091),
    [anon_sym_yield] = ACTIONS(4093),
    [anon_sym_yield_BANG] = ACTIONS(4091),
    [anon_sym_lazy] = ACTIONS(4093),
    [anon_sym_assert] = ACTIONS(4093),
    [anon_sym_upcast] = ACTIONS(4093),
    [anon_sym_downcast] = ACTIONS(4093),
    [anon_sym_COLON_GT] = ACTIONS(4091),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4091),
    [anon_sym_for] = ACTIONS(4093),
    [anon_sym_while] = ACTIONS(4093),
    [anon_sym_if] = ACTIONS(4093),
    [anon_sym_fun] = ACTIONS(4093),
    [anon_sym_try] = ACTIONS(4093),
    [anon_sym_match] = ACTIONS(4093),
    [anon_sym_match_BANG] = ACTIONS(4091),
    [anon_sym_function] = ACTIONS(4093),
    [anon_sym_LT_DASH] = ACTIONS(4093),
    [anon_sym_DOT_LBRACK] = ACTIONS(4091),
    [anon_sym_LT] = ACTIONS(4091),
    [anon_sym_GT] = ACTIONS(4093),
    [anon_sym_use] = ACTIONS(4093),
    [anon_sym_use_BANG] = ACTIONS(4091),
    [anon_sym_do_BANG] = ACTIONS(4091),
    [anon_sym_begin] = ACTIONS(4093),
    [anon_sym_LPAREN2] = ACTIONS(4093),
    [anon_sym_or] = ACTIONS(4093),
    [aux_sym_char_token1] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4093),
    [anon_sym_DQUOTE] = ACTIONS(4093),
    [anon_sym_AT_DQUOTE] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [sym_bool] = ACTIONS(4093),
    [sym_unit] = ACTIONS(4091),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4093),
    [sym_op_identifier] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS_DOT] = ACTIONS(4093),
    [anon_sym_DASH_DOT] = ACTIONS(4093),
    [anon_sym_PERCENT] = ACTIONS(4093),
    [anon_sym_AMP_AMP] = ACTIONS(4093),
    [anon_sym_TILDE] = ACTIONS(4091),
    [aux_sym_prefix_op_token1] = ACTIONS(4093),
    [aux_sym_infix_op_token1] = ACTIONS(4091),
    [aux_sym_infix_op_token2] = ACTIONS(4093),
    [anon_sym_PIPE_PIPE] = ACTIONS(4093),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_COLON_EQ] = ACTIONS(4091),
    [anon_sym_DOLLAR] = ACTIONS(4093),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4093),
    [sym_int] = ACTIONS(4093),
    [sym_xint] = ACTIONS(4091),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4091),
    [sym__newline] = ACTIONS(4091),
  },
  [3245] = {
    [sym_block_comment] = STATE(3245),
    [sym_compiler_directive_decl] = STATE(3245),
    [sym_fsi_directive_decl] = STATE(3245),
    [sym_preproc_line] = STATE(3245),
    [sym_identifier] = ACTIONS(4086),
    [anon_sym_EQ] = ACTIONS(4084),
    [anon_sym_COLON] = ACTIONS(4086),
    [anon_sym_return] = ACTIONS(4086),
    [anon_sym_do] = ACTIONS(4086),
    [anon_sym_let] = ACTIONS(4086),
    [anon_sym_let_BANG] = ACTIONS(4084),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_COMMA] = ACTIONS(4084),
    [anon_sym_null] = ACTIONS(4086),
    [anon_sym_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_COLON] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4084),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_LT_AT] = ACTIONS(4086),
    [anon_sym_LT_AT_AT] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4086),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4084),
    [anon_sym_new] = ACTIONS(4086),
    [anon_sym_return_BANG] = ACTIONS(4084),
    [anon_sym_yield] = ACTIONS(4086),
    [anon_sym_yield_BANG] = ACTIONS(4084),
    [anon_sym_lazy] = ACTIONS(4086),
    [anon_sym_assert] = ACTIONS(4086),
    [anon_sym_upcast] = ACTIONS(4086),
    [anon_sym_downcast] = ACTIONS(4086),
    [anon_sym_COLON_GT] = ACTIONS(4084),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4084),
    [anon_sym_for] = ACTIONS(4086),
    [anon_sym_while] = ACTIONS(4086),
    [anon_sym_if] = ACTIONS(4086),
    [anon_sym_fun] = ACTIONS(4086),
    [anon_sym_try] = ACTIONS(4086),
    [anon_sym_match] = ACTIONS(4086),
    [anon_sym_match_BANG] = ACTIONS(4084),
    [anon_sym_function] = ACTIONS(4086),
    [anon_sym_LT_DASH] = ACTIONS(4086),
    [anon_sym_DOT_LBRACK] = ACTIONS(4084),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_GT] = ACTIONS(4086),
    [anon_sym_use] = ACTIONS(4086),
    [anon_sym_use_BANG] = ACTIONS(4084),
    [anon_sym_do_BANG] = ACTIONS(4084),
    [anon_sym_begin] = ACTIONS(4086),
    [anon_sym_LPAREN2] = ACTIONS(4086),
    [anon_sym_or] = ACTIONS(4086),
    [aux_sym_char_token1] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4086),
    [anon_sym_DQUOTE] = ACTIONS(4086),
    [anon_sym_AT_DQUOTE] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [sym_bool] = ACTIONS(4086),
    [sym_unit] = ACTIONS(4084),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4086),
    [sym_op_identifier] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4086),
    [anon_sym_DASH] = ACTIONS(4086),
    [anon_sym_PLUS_DOT] = ACTIONS(4086),
    [anon_sym_DASH_DOT] = ACTIONS(4086),
    [anon_sym_PERCENT] = ACTIONS(4086),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_TILDE] = ACTIONS(4084),
    [aux_sym_prefix_op_token1] = ACTIONS(4086),
    [aux_sym_infix_op_token1] = ACTIONS(4084),
    [aux_sym_infix_op_token2] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_COLON_EQ] = ACTIONS(4084),
    [anon_sym_DOLLAR] = ACTIONS(4086),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4086),
    [sym_int] = ACTIONS(4086),
    [sym_xint] = ACTIONS(4084),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4084),
    [sym__newline] = ACTIONS(4084),
  },
  [3246] = {
    [sym_block_comment] = STATE(3246),
    [sym_compiler_directive_decl] = STATE(3246),
    [sym_fsi_directive_decl] = STATE(3246),
    [sym_preproc_line] = STATE(3246),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_COLON] = ACTIONS(4082),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_do] = ACTIONS(4082),
    [anon_sym_let] = ACTIONS(4082),
    [anon_sym_let_BANG] = ACTIONS(4080),
    [anon_sym_LPAREN] = ACTIONS(4082),
    [anon_sym_COMMA] = ACTIONS(4080),
    [anon_sym_null] = ACTIONS(4082),
    [anon_sym_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_COLON] = ACTIONS(4080),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_LBRACK] = ACTIONS(4082),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(4082),
    [anon_sym_LT_AT] = ACTIONS(4082),
    [anon_sym_LT_AT_AT] = ACTIONS(4082),
    [anon_sym_DOT] = ACTIONS(4082),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4080),
    [anon_sym_new] = ACTIONS(4082),
    [anon_sym_return_BANG] = ACTIONS(4080),
    [anon_sym_yield] = ACTIONS(4082),
    [anon_sym_yield_BANG] = ACTIONS(4080),
    [anon_sym_lazy] = ACTIONS(4082),
    [anon_sym_assert] = ACTIONS(4082),
    [anon_sym_upcast] = ACTIONS(4082),
    [anon_sym_downcast] = ACTIONS(4082),
    [anon_sym_COLON_GT] = ACTIONS(4080),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4080),
    [anon_sym_for] = ACTIONS(4082),
    [anon_sym_while] = ACTIONS(4082),
    [anon_sym_if] = ACTIONS(4082),
    [anon_sym_fun] = ACTIONS(4082),
    [anon_sym_try] = ACTIONS(4082),
    [anon_sym_match] = ACTIONS(4082),
    [anon_sym_match_BANG] = ACTIONS(4080),
    [anon_sym_function] = ACTIONS(4082),
    [anon_sym_LT_DASH] = ACTIONS(4082),
    [anon_sym_DOT_LBRACK] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(4080),
    [anon_sym_GT] = ACTIONS(4082),
    [anon_sym_use] = ACTIONS(4082),
    [anon_sym_use_BANG] = ACTIONS(4080),
    [anon_sym_do_BANG] = ACTIONS(4080),
    [anon_sym_begin] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4082),
    [anon_sym_or] = ACTIONS(4082),
    [aux_sym_char_token1] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4082),
    [anon_sym_DQUOTE] = ACTIONS(4082),
    [anon_sym_AT_DQUOTE] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [sym_bool] = ACTIONS(4082),
    [sym_unit] = ACTIONS(4080),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4082),
    [sym_op_identifier] = ACTIONS(4082),
    [anon_sym_PLUS] = ACTIONS(4082),
    [anon_sym_DASH] = ACTIONS(4082),
    [anon_sym_PLUS_DOT] = ACTIONS(4082),
    [anon_sym_DASH_DOT] = ACTIONS(4082),
    [anon_sym_PERCENT] = ACTIONS(4082),
    [anon_sym_AMP_AMP] = ACTIONS(4082),
    [anon_sym_TILDE] = ACTIONS(4080),
    [aux_sym_prefix_op_token1] = ACTIONS(4082),
    [aux_sym_infix_op_token1] = ACTIONS(4080),
    [aux_sym_infix_op_token2] = ACTIONS(4082),
    [anon_sym_PIPE_PIPE] = ACTIONS(4082),
    [anon_sym_BANG_EQ] = ACTIONS(4082),
    [anon_sym_COLON_EQ] = ACTIONS(4080),
    [anon_sym_DOLLAR] = ACTIONS(4082),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4082),
    [sym_int] = ACTIONS(4082),
    [sym_xint] = ACTIONS(4080),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4080),
    [sym__newline] = ACTIONS(4080),
  },
  [3247] = {
    [sym_block_comment] = STATE(3247),
    [sym_compiler_directive_decl] = STATE(3247),
    [sym_fsi_directive_decl] = STATE(3247),
    [sym_preproc_line] = STATE(3247),
    [sym_identifier] = ACTIONS(4054),
    [anon_sym_EQ] = ACTIONS(4052),
    [anon_sym_COLON] = ACTIONS(4054),
    [anon_sym_return] = ACTIONS(4054),
    [anon_sym_do] = ACTIONS(4054),
    [anon_sym_let] = ACTIONS(4054),
    [anon_sym_let_BANG] = ACTIONS(4052),
    [anon_sym_LPAREN] = ACTIONS(4054),
    [anon_sym_COMMA] = ACTIONS(4052),
    [anon_sym_null] = ACTIONS(4054),
    [anon_sym_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_COLON] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(4054),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4052),
    [anon_sym_LBRACE] = ACTIONS(4054),
    [anon_sym_LT_AT] = ACTIONS(4054),
    [anon_sym_LT_AT_AT] = ACTIONS(4054),
    [anon_sym_DOT] = ACTIONS(4054),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_return_BANG] = ACTIONS(4052),
    [anon_sym_yield] = ACTIONS(4054),
    [anon_sym_yield_BANG] = ACTIONS(4052),
    [anon_sym_lazy] = ACTIONS(4054),
    [anon_sym_assert] = ACTIONS(4054),
    [anon_sym_upcast] = ACTIONS(4054),
    [anon_sym_downcast] = ACTIONS(4054),
    [anon_sym_COLON_GT] = ACTIONS(4052),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4052),
    [anon_sym_for] = ACTIONS(4054),
    [anon_sym_while] = ACTIONS(4054),
    [anon_sym_if] = ACTIONS(4054),
    [anon_sym_fun] = ACTIONS(4054),
    [anon_sym_try] = ACTIONS(4054),
    [anon_sym_match] = ACTIONS(4054),
    [anon_sym_match_BANG] = ACTIONS(4052),
    [anon_sym_function] = ACTIONS(4054),
    [anon_sym_LT_DASH] = ACTIONS(4054),
    [anon_sym_DOT_LBRACK] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4054),
    [anon_sym_use] = ACTIONS(4054),
    [anon_sym_use_BANG] = ACTIONS(4052),
    [anon_sym_do_BANG] = ACTIONS(4052),
    [anon_sym_begin] = ACTIONS(4054),
    [anon_sym_LPAREN2] = ACTIONS(4054),
    [anon_sym_or] = ACTIONS(4054),
    [aux_sym_char_token1] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4054),
    [anon_sym_DQUOTE] = ACTIONS(4054),
    [anon_sym_AT_DQUOTE] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [sym_bool] = ACTIONS(4054),
    [sym_unit] = ACTIONS(4052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4054),
    [sym_op_identifier] = ACTIONS(4054),
    [anon_sym_PLUS] = ACTIONS(4054),
    [anon_sym_DASH] = ACTIONS(4054),
    [anon_sym_PLUS_DOT] = ACTIONS(4054),
    [anon_sym_DASH_DOT] = ACTIONS(4054),
    [anon_sym_PERCENT] = ACTIONS(4054),
    [anon_sym_AMP_AMP] = ACTIONS(4054),
    [anon_sym_TILDE] = ACTIONS(4052),
    [aux_sym_prefix_op_token1] = ACTIONS(4054),
    [aux_sym_infix_op_token1] = ACTIONS(4052),
    [aux_sym_infix_op_token2] = ACTIONS(4054),
    [anon_sym_PIPE_PIPE] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4054),
    [anon_sym_COLON_EQ] = ACTIONS(4052),
    [anon_sym_DOLLAR] = ACTIONS(4054),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4054),
    [sym_int] = ACTIONS(4054),
    [sym_xint] = ACTIONS(4052),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4052),
    [sym__newline] = ACTIONS(4052),
  },
  [3248] = {
    [sym_block_comment] = STATE(3248),
    [sym_compiler_directive_decl] = STATE(3248),
    [sym_fsi_directive_decl] = STATE(3248),
    [sym_preproc_line] = STATE(3248),
    [sym_identifier] = ACTIONS(4018),
    [anon_sym_EQ] = ACTIONS(4016),
    [anon_sym_COLON] = ACTIONS(4018),
    [anon_sym_return] = ACTIONS(4018),
    [anon_sym_do] = ACTIONS(4018),
    [anon_sym_let] = ACTIONS(4018),
    [anon_sym_let_BANG] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(4018),
    [anon_sym_COMMA] = ACTIONS(4016),
    [anon_sym_null] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_COLON] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4018),
    [anon_sym_LBRACK] = ACTIONS(4018),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4016),
    [anon_sym_LBRACE] = ACTIONS(4018),
    [anon_sym_LT_AT] = ACTIONS(4018),
    [anon_sym_LT_AT_AT] = ACTIONS(4018),
    [anon_sym_DOT] = ACTIONS(4018),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4016),
    [anon_sym_new] = ACTIONS(4018),
    [anon_sym_return_BANG] = ACTIONS(4016),
    [anon_sym_yield] = ACTIONS(4018),
    [anon_sym_yield_BANG] = ACTIONS(4016),
    [anon_sym_lazy] = ACTIONS(4018),
    [anon_sym_assert] = ACTIONS(4018),
    [anon_sym_upcast] = ACTIONS(4018),
    [anon_sym_downcast] = ACTIONS(4018),
    [anon_sym_COLON_GT] = ACTIONS(4016),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4016),
    [anon_sym_for] = ACTIONS(4018),
    [anon_sym_while] = ACTIONS(4018),
    [anon_sym_if] = ACTIONS(4018),
    [anon_sym_fun] = ACTIONS(4018),
    [anon_sym_try] = ACTIONS(4018),
    [anon_sym_match] = ACTIONS(4018),
    [anon_sym_match_BANG] = ACTIONS(4016),
    [anon_sym_function] = ACTIONS(4018),
    [anon_sym_LT_DASH] = ACTIONS(4018),
    [anon_sym_DOT_LBRACK] = ACTIONS(4016),
    [anon_sym_LT] = ACTIONS(4016),
    [anon_sym_GT] = ACTIONS(4018),
    [anon_sym_use] = ACTIONS(4018),
    [anon_sym_use_BANG] = ACTIONS(4016),
    [anon_sym_do_BANG] = ACTIONS(4016),
    [anon_sym_begin] = ACTIONS(4018),
    [anon_sym_LPAREN2] = ACTIONS(4018),
    [anon_sym_or] = ACTIONS(4018),
    [aux_sym_char_token1] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(4018),
    [anon_sym_AT_DQUOTE] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [sym_bool] = ACTIONS(4018),
    [sym_unit] = ACTIONS(4016),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4018),
    [sym_op_identifier] = ACTIONS(4018),
    [anon_sym_PLUS] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_PLUS_DOT] = ACTIONS(4018),
    [anon_sym_DASH_DOT] = ACTIONS(4018),
    [anon_sym_PERCENT] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4016),
    [aux_sym_prefix_op_token1] = ACTIONS(4018),
    [aux_sym_infix_op_token1] = ACTIONS(4016),
    [aux_sym_infix_op_token2] = ACTIONS(4018),
    [anon_sym_PIPE_PIPE] = ACTIONS(4018),
    [anon_sym_BANG_EQ] = ACTIONS(4018),
    [anon_sym_COLON_EQ] = ACTIONS(4016),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4018),
    [sym_int] = ACTIONS(4018),
    [sym_xint] = ACTIONS(4016),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4016),
    [sym__newline] = ACTIONS(4016),
  },
  [3249] = {
    [sym_block_comment] = STATE(3249),
    [sym_compiler_directive_decl] = STATE(3249),
    [sym_fsi_directive_decl] = STATE(3249),
    [sym_preproc_line] = STATE(3249),
    [sym_identifier] = ACTIONS(3863),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_let] = ACTIONS(3863),
    [anon_sym_let_BANG] = ACTIONS(3861),
    [anon_sym_LPAREN] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3861),
    [anon_sym_null] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_COLON] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_LT_AT] = ACTIONS(3863),
    [anon_sym_LT_AT_AT] = ACTIONS(3863),
    [anon_sym_DOT] = ACTIONS(3863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3861),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_return_BANG] = ACTIONS(3861),
    [anon_sym_yield] = ACTIONS(3863),
    [anon_sym_yield_BANG] = ACTIONS(3861),
    [anon_sym_lazy] = ACTIONS(3863),
    [anon_sym_assert] = ACTIONS(3863),
    [anon_sym_upcast] = ACTIONS(3863),
    [anon_sym_downcast] = ACTIONS(3863),
    [anon_sym_COLON_GT] = ACTIONS(3861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_fun] = ACTIONS(3863),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_match] = ACTIONS(3863),
    [anon_sym_match_BANG] = ACTIONS(3861),
    [anon_sym_function] = ACTIONS(3863),
    [anon_sym_LT_DASH] = ACTIONS(3863),
    [anon_sym_DOT_LBRACK] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_GT] = ACTIONS(3863),
    [anon_sym_use] = ACTIONS(3863),
    [anon_sym_use_BANG] = ACTIONS(3861),
    [anon_sym_do_BANG] = ACTIONS(3861),
    [anon_sym_begin] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(3863),
    [anon_sym_or] = ACTIONS(3863),
    [aux_sym_char_token1] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [anon_sym_AT_DQUOTE] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [sym_bool] = ACTIONS(3863),
    [sym_unit] = ACTIONS(3861),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3863),
    [sym_op_identifier] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_DOT] = ACTIONS(3863),
    [anon_sym_DASH_DOT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3861),
    [aux_sym_prefix_op_token1] = ACTIONS(3863),
    [aux_sym_infix_op_token1] = ACTIONS(3861),
    [aux_sym_infix_op_token2] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_COLON_EQ] = ACTIONS(3861),
    [anon_sym_DOLLAR] = ACTIONS(3863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3863),
    [sym_int] = ACTIONS(3863),
    [sym_xint] = ACTIONS(3861),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3861),
    [sym__newline] = ACTIONS(3861),
  },
  [3250] = {
    [sym_block_comment] = STATE(3250),
    [sym_compiler_directive_decl] = STATE(3250),
    [sym_fsi_directive_decl] = STATE(3250),
    [sym_preproc_line] = STATE(3250),
    [sym_identifier] = ACTIONS(3856),
    [anon_sym_EQ] = ACTIONS(3854),
    [anon_sym_COLON] = ACTIONS(3856),
    [anon_sym_return] = ACTIONS(3856),
    [anon_sym_do] = ACTIONS(3856),
    [anon_sym_let] = ACTIONS(3856),
    [anon_sym_let_BANG] = ACTIONS(3854),
    [anon_sym_LPAREN] = ACTIONS(3856),
    [anon_sym_COMMA] = ACTIONS(3854),
    [anon_sym_null] = ACTIONS(3856),
    [anon_sym_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_AMP] = ACTIONS(3856),
    [anon_sym_LBRACK] = ACTIONS(3856),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3854),
    [anon_sym_LBRACE] = ACTIONS(3856),
    [anon_sym_LT_AT] = ACTIONS(3856),
    [anon_sym_LT_AT_AT] = ACTIONS(3856),
    [anon_sym_DOT] = ACTIONS(3856),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3854),
    [anon_sym_new] = ACTIONS(3856),
    [anon_sym_return_BANG] = ACTIONS(3854),
    [anon_sym_yield] = ACTIONS(3856),
    [anon_sym_yield_BANG] = ACTIONS(3854),
    [anon_sym_lazy] = ACTIONS(3856),
    [anon_sym_assert] = ACTIONS(3856),
    [anon_sym_upcast] = ACTIONS(3856),
    [anon_sym_downcast] = ACTIONS(3856),
    [anon_sym_COLON_GT] = ACTIONS(3854),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3854),
    [anon_sym_for] = ACTIONS(3856),
    [anon_sym_while] = ACTIONS(3856),
    [anon_sym_if] = ACTIONS(3856),
    [anon_sym_fun] = ACTIONS(3856),
    [anon_sym_try] = ACTIONS(3856),
    [anon_sym_match] = ACTIONS(3856),
    [anon_sym_match_BANG] = ACTIONS(3854),
    [anon_sym_function] = ACTIONS(3856),
    [anon_sym_LT_DASH] = ACTIONS(3856),
    [anon_sym_DOT_LBRACK] = ACTIONS(3854),
    [anon_sym_LT] = ACTIONS(3854),
    [anon_sym_GT] = ACTIONS(3856),
    [anon_sym_use] = ACTIONS(3856),
    [anon_sym_use_BANG] = ACTIONS(3854),
    [anon_sym_do_BANG] = ACTIONS(3854),
    [anon_sym_begin] = ACTIONS(3856),
    [anon_sym_LPAREN2] = ACTIONS(3856),
    [anon_sym_or] = ACTIONS(3856),
    [aux_sym_char_token1] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3856),
    [anon_sym_DQUOTE] = ACTIONS(3856),
    [anon_sym_AT_DQUOTE] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [sym_bool] = ACTIONS(3856),
    [sym_unit] = ACTIONS(3854),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3856),
    [sym_op_identifier] = ACTIONS(3856),
    [anon_sym_PLUS] = ACTIONS(3856),
    [anon_sym_DASH] = ACTIONS(3856),
    [anon_sym_PLUS_DOT] = ACTIONS(3856),
    [anon_sym_DASH_DOT] = ACTIONS(3856),
    [anon_sym_PERCENT] = ACTIONS(3856),
    [anon_sym_AMP_AMP] = ACTIONS(3856),
    [anon_sym_TILDE] = ACTIONS(3854),
    [aux_sym_prefix_op_token1] = ACTIONS(3856),
    [aux_sym_infix_op_token1] = ACTIONS(3854),
    [aux_sym_infix_op_token2] = ACTIONS(3856),
    [anon_sym_PIPE_PIPE] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3856),
    [anon_sym_COLON_EQ] = ACTIONS(3854),
    [anon_sym_DOLLAR] = ACTIONS(3856),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3856),
    [sym_int] = ACTIONS(3856),
    [sym_xint] = ACTIONS(3854),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3854),
    [sym__newline] = ACTIONS(3854),
  },
  [3251] = {
    [sym_block_comment] = STATE(3251),
    [sym_compiler_directive_decl] = STATE(3251),
    [sym_fsi_directive_decl] = STATE(3251),
    [sym_preproc_line] = STATE(3251),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3843),
    [anon_sym_COLON] = ACTIONS(3845),
    [anon_sym_return] = ACTIONS(3845),
    [anon_sym_do] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_let_BANG] = ACTIONS(3843),
    [anon_sym_LPAREN] = ACTIONS(3845),
    [anon_sym_COMMA] = ACTIONS(3843),
    [anon_sym_null] = ACTIONS(3845),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3843),
    [anon_sym_LBRACE] = ACTIONS(3845),
    [anon_sym_LT_AT] = ACTIONS(3845),
    [anon_sym_LT_AT_AT] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3843),
    [anon_sym_new] = ACTIONS(3845),
    [anon_sym_return_BANG] = ACTIONS(3843),
    [anon_sym_yield] = ACTIONS(3845),
    [anon_sym_yield_BANG] = ACTIONS(3843),
    [anon_sym_lazy] = ACTIONS(3845),
    [anon_sym_assert] = ACTIONS(3845),
    [anon_sym_upcast] = ACTIONS(3845),
    [anon_sym_downcast] = ACTIONS(3845),
    [anon_sym_COLON_GT] = ACTIONS(3843),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3843),
    [anon_sym_for] = ACTIONS(3845),
    [anon_sym_while] = ACTIONS(3845),
    [anon_sym_if] = ACTIONS(3845),
    [anon_sym_fun] = ACTIONS(3845),
    [anon_sym_try] = ACTIONS(3845),
    [anon_sym_match] = ACTIONS(3845),
    [anon_sym_match_BANG] = ACTIONS(3843),
    [anon_sym_function] = ACTIONS(3845),
    [anon_sym_LT_DASH] = ACTIONS(3845),
    [anon_sym_DOT_LBRACK] = ACTIONS(3843),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3845),
    [anon_sym_use] = ACTIONS(3845),
    [anon_sym_use_BANG] = ACTIONS(3843),
    [anon_sym_do_BANG] = ACTIONS(3843),
    [anon_sym_begin] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(3845),
    [anon_sym_or] = ACTIONS(3845),
    [aux_sym_char_token1] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3845),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_AT_DQUOTE] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [sym_bool] = ACTIONS(3845),
    [sym_unit] = ACTIONS(3843),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3845),
    [sym_op_identifier] = ACTIONS(3845),
    [anon_sym_PLUS] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_PLUS_DOT] = ACTIONS(3845),
    [anon_sym_DASH_DOT] = ACTIONS(3845),
    [anon_sym_PERCENT] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3845),
    [anon_sym_TILDE] = ACTIONS(3843),
    [aux_sym_prefix_op_token1] = ACTIONS(3845),
    [aux_sym_infix_op_token1] = ACTIONS(3843),
    [aux_sym_infix_op_token2] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(3845),
    [anon_sym_BANG_EQ] = ACTIONS(3845),
    [anon_sym_COLON_EQ] = ACTIONS(3843),
    [anon_sym_DOLLAR] = ACTIONS(3845),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3845),
    [sym_int] = ACTIONS(3845),
    [sym_xint] = ACTIONS(3843),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3843),
    [sym__newline] = ACTIONS(3843),
  },
  [3252] = {
    [sym_block_comment] = STATE(3252),
    [sym_compiler_directive_decl] = STATE(3252),
    [sym_fsi_directive_decl] = STATE(3252),
    [sym_preproc_line] = STATE(3252),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_EQ] = ACTIONS(4001),
    [anon_sym_COLON] = ACTIONS(4003),
    [anon_sym_return] = ACTIONS(4003),
    [anon_sym_do] = ACTIONS(4003),
    [anon_sym_let] = ACTIONS(4003),
    [anon_sym_let_BANG] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4003),
    [anon_sym_COMMA] = ACTIONS(4001),
    [anon_sym_null] = ACTIONS(4003),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_COLON] = ACTIONS(4001),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LBRACK] = ACTIONS(4003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4001),
    [anon_sym_LBRACE] = ACTIONS(4003),
    [anon_sym_LT_AT] = ACTIONS(4003),
    [anon_sym_LT_AT_AT] = ACTIONS(4003),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4001),
    [anon_sym_new] = ACTIONS(4003),
    [anon_sym_return_BANG] = ACTIONS(4001),
    [anon_sym_yield] = ACTIONS(4003),
    [anon_sym_yield_BANG] = ACTIONS(4001),
    [anon_sym_lazy] = ACTIONS(4003),
    [anon_sym_assert] = ACTIONS(4003),
    [anon_sym_upcast] = ACTIONS(4003),
    [anon_sym_downcast] = ACTIONS(4003),
    [anon_sym_COLON_GT] = ACTIONS(4001),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4001),
    [anon_sym_for] = ACTIONS(4003),
    [anon_sym_while] = ACTIONS(4003),
    [anon_sym_if] = ACTIONS(4003),
    [anon_sym_fun] = ACTIONS(4003),
    [anon_sym_try] = ACTIONS(4003),
    [anon_sym_match] = ACTIONS(4003),
    [anon_sym_match_BANG] = ACTIONS(4001),
    [anon_sym_function] = ACTIONS(4003),
    [anon_sym_LT_DASH] = ACTIONS(4003),
    [anon_sym_DOT_LBRACK] = ACTIONS(4001),
    [anon_sym_LT] = ACTIONS(4001),
    [anon_sym_GT] = ACTIONS(4003),
    [anon_sym_use] = ACTIONS(4003),
    [anon_sym_use_BANG] = ACTIONS(4001),
    [anon_sym_do_BANG] = ACTIONS(4001),
    [anon_sym_begin] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [aux_sym_char_token1] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4003),
    [anon_sym_DQUOTE] = ACTIONS(4003),
    [anon_sym_AT_DQUOTE] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [sym_bool] = ACTIONS(4003),
    [sym_unit] = ACTIONS(4001),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4003),
    [sym_op_identifier] = ACTIONS(4003),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_PLUS_DOT] = ACTIONS(4003),
    [anon_sym_DASH_DOT] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4003),
    [anon_sym_TILDE] = ACTIONS(4001),
    [aux_sym_prefix_op_token1] = ACTIONS(4003),
    [aux_sym_infix_op_token1] = ACTIONS(4001),
    [aux_sym_infix_op_token2] = ACTIONS(4003),
    [anon_sym_PIPE_PIPE] = ACTIONS(4003),
    [anon_sym_BANG_EQ] = ACTIONS(4003),
    [anon_sym_COLON_EQ] = ACTIONS(4001),
    [anon_sym_DOLLAR] = ACTIONS(4003),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4003),
    [sym_int] = ACTIONS(4003),
    [sym_xint] = ACTIONS(4001),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4001),
    [sym__newline] = ACTIONS(4001),
  },
  [3253] = {
    [sym_block_comment] = STATE(3253),
    [sym_compiler_directive_decl] = STATE(3253),
    [sym_fsi_directive_decl] = STATE(3253),
    [sym_preproc_line] = STATE(3253),
    [sym_identifier] = ACTIONS(4180),
    [anon_sym_EQ] = ACTIONS(4178),
    [anon_sym_COLON] = ACTIONS(4180),
    [anon_sym_return] = ACTIONS(4180),
    [anon_sym_do] = ACTIONS(4180),
    [anon_sym_let] = ACTIONS(4180),
    [anon_sym_let_BANG] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(4180),
    [anon_sym_COMMA] = ACTIONS(4178),
    [anon_sym_null] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_COLON] = ACTIONS(4178),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4180),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4180),
    [anon_sym_LT_AT] = ACTIONS(4180),
    [anon_sym_AT_GT] = ACTIONS(4180),
    [anon_sym_LT_AT_AT] = ACTIONS(4180),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4178),
    [anon_sym_new] = ACTIONS(4180),
    [anon_sym_return_BANG] = ACTIONS(4178),
    [anon_sym_yield] = ACTIONS(4180),
    [anon_sym_yield_BANG] = ACTIONS(4178),
    [anon_sym_lazy] = ACTIONS(4180),
    [anon_sym_assert] = ACTIONS(4180),
    [anon_sym_upcast] = ACTIONS(4180),
    [anon_sym_downcast] = ACTIONS(4180),
    [anon_sym_COLON_GT] = ACTIONS(4178),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4178),
    [anon_sym_for] = ACTIONS(4180),
    [anon_sym_while] = ACTIONS(4180),
    [anon_sym_if] = ACTIONS(4180),
    [anon_sym_fun] = ACTIONS(4180),
    [anon_sym_try] = ACTIONS(4180),
    [anon_sym_match] = ACTIONS(4180),
    [anon_sym_match_BANG] = ACTIONS(4178),
    [anon_sym_function] = ACTIONS(4180),
    [anon_sym_LT_DASH] = ACTIONS(4180),
    [anon_sym_DOT_LBRACK] = ACTIONS(4178),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_use] = ACTIONS(4180),
    [anon_sym_use_BANG] = ACTIONS(4178),
    [anon_sym_do_BANG] = ACTIONS(4178),
    [anon_sym_begin] = ACTIONS(4180),
    [anon_sym_LPAREN2] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [aux_sym_char_token1] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4180),
    [anon_sym_DQUOTE] = ACTIONS(4180),
    [anon_sym_AT_DQUOTE] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [sym_bool] = ACTIONS(4180),
    [sym_unit] = ACTIONS(4178),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4180),
    [sym_op_identifier] = ACTIONS(4180),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_PLUS_DOT] = ACTIONS(4180),
    [anon_sym_DASH_DOT] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_TILDE] = ACTIONS(4178),
    [aux_sym_prefix_op_token1] = ACTIONS(4180),
    [aux_sym_infix_op_token1] = ACTIONS(4178),
    [aux_sym_infix_op_token2] = ACTIONS(4180),
    [anon_sym_PIPE_PIPE] = ACTIONS(4180),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_COLON_EQ] = ACTIONS(4178),
    [anon_sym_DOLLAR] = ACTIONS(4180),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4180),
    [sym_int] = ACTIONS(4180),
    [sym_xint] = ACTIONS(4178),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4178),
    [sym__newline] = ACTIONS(4178),
  },
  [3254] = {
    [sym_block_comment] = STATE(3254),
    [sym_compiler_directive_decl] = STATE(3254),
    [sym_fsi_directive_decl] = STATE(3254),
    [sym_preproc_line] = STATE(3254),
    [sym_identifier] = ACTIONS(3996),
    [anon_sym_EQ] = ACTIONS(3994),
    [anon_sym_COLON] = ACTIONS(3996),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_do] = ACTIONS(3996),
    [anon_sym_let] = ACTIONS(3996),
    [anon_sym_let_BANG] = ACTIONS(3994),
    [anon_sym_LPAREN] = ACTIONS(3996),
    [anon_sym_COMMA] = ACTIONS(3994),
    [anon_sym_null] = ACTIONS(3996),
    [anon_sym_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_COLON] = ACTIONS(3994),
    [anon_sym_AMP] = ACTIONS(3996),
    [anon_sym_LBRACK] = ACTIONS(3996),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3994),
    [anon_sym_LBRACE] = ACTIONS(3996),
    [anon_sym_LT_AT] = ACTIONS(3996),
    [anon_sym_LT_AT_AT] = ACTIONS(3996),
    [anon_sym_DOT] = ACTIONS(3996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3994),
    [anon_sym_new] = ACTIONS(3996),
    [anon_sym_return_BANG] = ACTIONS(3994),
    [anon_sym_yield] = ACTIONS(3996),
    [anon_sym_yield_BANG] = ACTIONS(3994),
    [anon_sym_lazy] = ACTIONS(3996),
    [anon_sym_assert] = ACTIONS(3996),
    [anon_sym_upcast] = ACTIONS(3996),
    [anon_sym_downcast] = ACTIONS(3996),
    [anon_sym_COLON_GT] = ACTIONS(3994),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3994),
    [anon_sym_for] = ACTIONS(3996),
    [anon_sym_while] = ACTIONS(3996),
    [anon_sym_if] = ACTIONS(3996),
    [anon_sym_fun] = ACTIONS(3996),
    [anon_sym_try] = ACTIONS(3996),
    [anon_sym_match] = ACTIONS(3996),
    [anon_sym_match_BANG] = ACTIONS(3994),
    [anon_sym_function] = ACTIONS(3996),
    [anon_sym_LT_DASH] = ACTIONS(3996),
    [anon_sym_DOT_LBRACK] = ACTIONS(3994),
    [anon_sym_LT] = ACTIONS(3994),
    [anon_sym_GT] = ACTIONS(3996),
    [anon_sym_use] = ACTIONS(3996),
    [anon_sym_use_BANG] = ACTIONS(3994),
    [anon_sym_do_BANG] = ACTIONS(3994),
    [anon_sym_begin] = ACTIONS(3996),
    [anon_sym_LPAREN2] = ACTIONS(3996),
    [anon_sym_or] = ACTIONS(3996),
    [aux_sym_char_token1] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3996),
    [anon_sym_DQUOTE] = ACTIONS(3996),
    [anon_sym_AT_DQUOTE] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [sym_bool] = ACTIONS(3996),
    [sym_unit] = ACTIONS(3994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3996),
    [sym_op_identifier] = ACTIONS(3996),
    [anon_sym_PLUS] = ACTIONS(3996),
    [anon_sym_DASH] = ACTIONS(3996),
    [anon_sym_PLUS_DOT] = ACTIONS(3996),
    [anon_sym_DASH_DOT] = ACTIONS(3996),
    [anon_sym_PERCENT] = ACTIONS(3996),
    [anon_sym_AMP_AMP] = ACTIONS(3996),
    [anon_sym_TILDE] = ACTIONS(3994),
    [aux_sym_prefix_op_token1] = ACTIONS(3996),
    [aux_sym_infix_op_token1] = ACTIONS(3994),
    [aux_sym_infix_op_token2] = ACTIONS(3996),
    [anon_sym_PIPE_PIPE] = ACTIONS(3996),
    [anon_sym_BANG_EQ] = ACTIONS(3996),
    [anon_sym_COLON_EQ] = ACTIONS(3994),
    [anon_sym_DOLLAR] = ACTIONS(3996),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3996),
    [sym_int] = ACTIONS(3996),
    [sym_xint] = ACTIONS(3994),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3994),
    [sym__newline] = ACTIONS(3994),
  },
  [3255] = {
    [sym_block_comment] = STATE(3255),
    [sym_compiler_directive_decl] = STATE(3255),
    [sym_fsi_directive_decl] = STATE(3255),
    [sym_preproc_line] = STATE(3255),
    [sym_identifier] = ACTIONS(3972),
    [anon_sym_EQ] = ACTIONS(3970),
    [anon_sym_COLON] = ACTIONS(3972),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_do] = ACTIONS(3972),
    [anon_sym_let] = ACTIONS(3972),
    [anon_sym_let_BANG] = ACTIONS(3970),
    [anon_sym_LPAREN] = ACTIONS(3972),
    [anon_sym_COMMA] = ACTIONS(3970),
    [anon_sym_null] = ACTIONS(3972),
    [anon_sym_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_COLON] = ACTIONS(3970),
    [anon_sym_AMP] = ACTIONS(3972),
    [anon_sym_LBRACK] = ACTIONS(3972),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3970),
    [anon_sym_LBRACE] = ACTIONS(3972),
    [anon_sym_LT_AT] = ACTIONS(3972),
    [anon_sym_LT_AT_AT] = ACTIONS(3972),
    [anon_sym_DOT] = ACTIONS(3972),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3970),
    [anon_sym_new] = ACTIONS(3972),
    [anon_sym_return_BANG] = ACTIONS(3970),
    [anon_sym_yield] = ACTIONS(3972),
    [anon_sym_yield_BANG] = ACTIONS(3970),
    [anon_sym_lazy] = ACTIONS(3972),
    [anon_sym_assert] = ACTIONS(3972),
    [anon_sym_upcast] = ACTIONS(3972),
    [anon_sym_downcast] = ACTIONS(3972),
    [anon_sym_COLON_GT] = ACTIONS(3970),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3970),
    [anon_sym_for] = ACTIONS(3972),
    [anon_sym_while] = ACTIONS(3972),
    [anon_sym_if] = ACTIONS(3972),
    [anon_sym_fun] = ACTIONS(3972),
    [anon_sym_try] = ACTIONS(3972),
    [anon_sym_match] = ACTIONS(3972),
    [anon_sym_match_BANG] = ACTIONS(3970),
    [anon_sym_function] = ACTIONS(3972),
    [anon_sym_LT_DASH] = ACTIONS(3972),
    [anon_sym_DOT_LBRACK] = ACTIONS(3970),
    [anon_sym_LT] = ACTIONS(3970),
    [anon_sym_GT] = ACTIONS(3972),
    [anon_sym_use] = ACTIONS(3972),
    [anon_sym_use_BANG] = ACTIONS(3970),
    [anon_sym_do_BANG] = ACTIONS(3970),
    [anon_sym_begin] = ACTIONS(3972),
    [anon_sym_LPAREN2] = ACTIONS(3972),
    [anon_sym_or] = ACTIONS(3972),
    [aux_sym_char_token1] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3972),
    [anon_sym_DQUOTE] = ACTIONS(3972),
    [anon_sym_AT_DQUOTE] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [sym_bool] = ACTIONS(3972),
    [sym_unit] = ACTIONS(3970),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3972),
    [sym_op_identifier] = ACTIONS(3972),
    [anon_sym_PLUS] = ACTIONS(3972),
    [anon_sym_DASH] = ACTIONS(3972),
    [anon_sym_PLUS_DOT] = ACTIONS(3972),
    [anon_sym_DASH_DOT] = ACTIONS(3972),
    [anon_sym_PERCENT] = ACTIONS(3972),
    [anon_sym_AMP_AMP] = ACTIONS(3972),
    [anon_sym_TILDE] = ACTIONS(3970),
    [aux_sym_prefix_op_token1] = ACTIONS(3972),
    [aux_sym_infix_op_token1] = ACTIONS(3970),
    [aux_sym_infix_op_token2] = ACTIONS(3972),
    [anon_sym_PIPE_PIPE] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3972),
    [anon_sym_COLON_EQ] = ACTIONS(3970),
    [anon_sym_DOLLAR] = ACTIONS(3972),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3972),
    [sym_int] = ACTIONS(3972),
    [sym_xint] = ACTIONS(3970),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3970),
    [sym__newline] = ACTIONS(3970),
  },
  [3256] = {
    [sym_block_comment] = STATE(3256),
    [sym_compiler_directive_decl] = STATE(3256),
    [sym_fsi_directive_decl] = STATE(3256),
    [sym_preproc_line] = STATE(3256),
    [sym_identifier] = ACTIONS(4174),
    [anon_sym_EQ] = ACTIONS(4172),
    [anon_sym_COLON] = ACTIONS(4174),
    [anon_sym_return] = ACTIONS(4174),
    [anon_sym_do] = ACTIONS(4174),
    [anon_sym_let] = ACTIONS(4174),
    [anon_sym_let_BANG] = ACTIONS(4172),
    [anon_sym_LPAREN] = ACTIONS(4174),
    [anon_sym_COMMA] = ACTIONS(4172),
    [anon_sym_null] = ACTIONS(4174),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_COLON] = ACTIONS(4172),
    [anon_sym_AMP] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4174),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4172),
    [anon_sym_LBRACE] = ACTIONS(4174),
    [anon_sym_LT_AT] = ACTIONS(4174),
    [anon_sym_AT_GT] = ACTIONS(4174),
    [anon_sym_LT_AT_AT] = ACTIONS(4174),
    [anon_sym_DOT] = ACTIONS(4174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4172),
    [anon_sym_new] = ACTIONS(4174),
    [anon_sym_return_BANG] = ACTIONS(4172),
    [anon_sym_yield] = ACTIONS(4174),
    [anon_sym_yield_BANG] = ACTIONS(4172),
    [anon_sym_lazy] = ACTIONS(4174),
    [anon_sym_assert] = ACTIONS(4174),
    [anon_sym_upcast] = ACTIONS(4174),
    [anon_sym_downcast] = ACTIONS(4174),
    [anon_sym_COLON_GT] = ACTIONS(4172),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4172),
    [anon_sym_for] = ACTIONS(4174),
    [anon_sym_while] = ACTIONS(4174),
    [anon_sym_if] = ACTIONS(4174),
    [anon_sym_fun] = ACTIONS(4174),
    [anon_sym_try] = ACTIONS(4174),
    [anon_sym_match] = ACTIONS(4174),
    [anon_sym_match_BANG] = ACTIONS(4172),
    [anon_sym_function] = ACTIONS(4174),
    [anon_sym_LT_DASH] = ACTIONS(4174),
    [anon_sym_DOT_LBRACK] = ACTIONS(4172),
    [anon_sym_LT] = ACTIONS(4172),
    [anon_sym_use] = ACTIONS(4174),
    [anon_sym_use_BANG] = ACTIONS(4172),
    [anon_sym_do_BANG] = ACTIONS(4172),
    [anon_sym_begin] = ACTIONS(4174),
    [anon_sym_LPAREN2] = ACTIONS(4174),
    [anon_sym_or] = ACTIONS(4174),
    [aux_sym_char_token1] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4174),
    [anon_sym_DQUOTE] = ACTIONS(4174),
    [anon_sym_AT_DQUOTE] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [sym_bool] = ACTIONS(4174),
    [sym_unit] = ACTIONS(4172),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4174),
    [sym_op_identifier] = ACTIONS(4174),
    [anon_sym_PLUS] = ACTIONS(4174),
    [anon_sym_DASH] = ACTIONS(4174),
    [anon_sym_PLUS_DOT] = ACTIONS(4174),
    [anon_sym_DASH_DOT] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [anon_sym_AMP_AMP] = ACTIONS(4174),
    [anon_sym_TILDE] = ACTIONS(4172),
    [aux_sym_prefix_op_token1] = ACTIONS(4174),
    [aux_sym_infix_op_token1] = ACTIONS(4172),
    [aux_sym_infix_op_token2] = ACTIONS(4174),
    [anon_sym_PIPE_PIPE] = ACTIONS(4174),
    [anon_sym_BANG_EQ] = ACTIONS(4174),
    [anon_sym_COLON_EQ] = ACTIONS(4172),
    [anon_sym_DOLLAR] = ACTIONS(4174),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4174),
    [sym_int] = ACTIONS(4174),
    [sym_xint] = ACTIONS(4172),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4172),
    [sym__newline] = ACTIONS(4172),
  },
  [3257] = {
    [sym_block_comment] = STATE(3257),
    [sym_compiler_directive_decl] = STATE(3257),
    [sym_fsi_directive_decl] = STATE(3257),
    [sym_preproc_line] = STATE(3257),
    [sym_identifier] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4078),
    [anon_sym_return] = ACTIONS(4078),
    [anon_sym_do] = ACTIONS(4078),
    [anon_sym_let] = ACTIONS(4078),
    [anon_sym_let_BANG] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_null] = ACTIONS(4078),
    [anon_sym_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(4076),
    [anon_sym_AMP] = ACTIONS(4078),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4078),
    [anon_sym_LT_AT] = ACTIONS(4078),
    [anon_sym_AT_GT] = ACTIONS(4078),
    [anon_sym_LT_AT_AT] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(4078),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4076),
    [anon_sym_new] = ACTIONS(4078),
    [anon_sym_return_BANG] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(4078),
    [anon_sym_yield_BANG] = ACTIONS(4076),
    [anon_sym_lazy] = ACTIONS(4078),
    [anon_sym_assert] = ACTIONS(4078),
    [anon_sym_upcast] = ACTIONS(4078),
    [anon_sym_downcast] = ACTIONS(4078),
    [anon_sym_COLON_GT] = ACTIONS(4076),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4076),
    [anon_sym_for] = ACTIONS(4078),
    [anon_sym_while] = ACTIONS(4078),
    [anon_sym_if] = ACTIONS(4078),
    [anon_sym_fun] = ACTIONS(4078),
    [anon_sym_try] = ACTIONS(4078),
    [anon_sym_match] = ACTIONS(4078),
    [anon_sym_match_BANG] = ACTIONS(4076),
    [anon_sym_function] = ACTIONS(4078),
    [anon_sym_LT_DASH] = ACTIONS(4078),
    [anon_sym_DOT_LBRACK] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4076),
    [anon_sym_use] = ACTIONS(4078),
    [anon_sym_use_BANG] = ACTIONS(4076),
    [anon_sym_do_BANG] = ACTIONS(4076),
    [anon_sym_begin] = ACTIONS(4078),
    [anon_sym_LPAREN2] = ACTIONS(4078),
    [anon_sym_or] = ACTIONS(4078),
    [aux_sym_char_token1] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4078),
    [anon_sym_DQUOTE] = ACTIONS(4078),
    [anon_sym_AT_DQUOTE] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [sym_bool] = ACTIONS(4078),
    [sym_unit] = ACTIONS(4076),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4078),
    [sym_op_identifier] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(4078),
    [anon_sym_PLUS_DOT] = ACTIONS(4078),
    [anon_sym_DASH_DOT] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [anon_sym_AMP_AMP] = ACTIONS(4078),
    [anon_sym_TILDE] = ACTIONS(4076),
    [aux_sym_prefix_op_token1] = ACTIONS(4078),
    [aux_sym_infix_op_token1] = ACTIONS(4076),
    [aux_sym_infix_op_token2] = ACTIONS(4078),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_BANG_EQ] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4076),
    [anon_sym_DOLLAR] = ACTIONS(4078),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4078),
    [sym_int] = ACTIONS(4078),
    [sym_xint] = ACTIONS(4076),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4076),
    [sym__newline] = ACTIONS(4076),
  },
  [3258] = {
    [sym_block_comment] = STATE(3258),
    [sym_compiler_directive_decl] = STATE(3258),
    [sym_fsi_directive_decl] = STATE(3258),
    [sym_preproc_line] = STATE(3258),
    [sym_identifier] = ACTIONS(4130),
    [anon_sym_EQ] = ACTIONS(4128),
    [anon_sym_COLON] = ACTIONS(4130),
    [anon_sym_return] = ACTIONS(4130),
    [anon_sym_do] = ACTIONS(4130),
    [anon_sym_let] = ACTIONS(4130),
    [anon_sym_let_BANG] = ACTIONS(4128),
    [anon_sym_LPAREN] = ACTIONS(4130),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_null] = ACTIONS(4130),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_COLON] = ACTIONS(4128),
    [anon_sym_AMP] = ACTIONS(4130),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4128),
    [anon_sym_LBRACE] = ACTIONS(4130),
    [anon_sym_LT_AT] = ACTIONS(4130),
    [anon_sym_LT_AT_AT] = ACTIONS(4130),
    [anon_sym_DOT] = ACTIONS(4130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4128),
    [anon_sym_new] = ACTIONS(4130),
    [anon_sym_return_BANG] = ACTIONS(4128),
    [anon_sym_yield] = ACTIONS(4130),
    [anon_sym_yield_BANG] = ACTIONS(4128),
    [anon_sym_lazy] = ACTIONS(4130),
    [anon_sym_assert] = ACTIONS(4130),
    [anon_sym_upcast] = ACTIONS(4130),
    [anon_sym_downcast] = ACTIONS(4130),
    [anon_sym_COLON_GT] = ACTIONS(4128),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4128),
    [anon_sym_for] = ACTIONS(4130),
    [anon_sym_while] = ACTIONS(4130),
    [anon_sym_if] = ACTIONS(4130),
    [anon_sym_fun] = ACTIONS(4130),
    [anon_sym_try] = ACTIONS(4130),
    [anon_sym_match] = ACTIONS(4130),
    [anon_sym_match_BANG] = ACTIONS(4128),
    [anon_sym_function] = ACTIONS(4130),
    [anon_sym_LT_DASH] = ACTIONS(4130),
    [anon_sym_DOT_LBRACK] = ACTIONS(4128),
    [anon_sym_LT] = ACTIONS(4128),
    [anon_sym_use] = ACTIONS(4130),
    [anon_sym_use_BANG] = ACTIONS(4128),
    [anon_sym_do_BANG] = ACTIONS(4128),
    [anon_sym_DOT_DOT] = ACTIONS(4128),
    [anon_sym_begin] = ACTIONS(4130),
    [anon_sym_LPAREN2] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [aux_sym_char_token1] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4130),
    [anon_sym_DQUOTE] = ACTIONS(4130),
    [anon_sym_AT_DQUOTE] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [sym_bool] = ACTIONS(4130),
    [sym_unit] = ACTIONS(4128),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4130),
    [sym_op_identifier] = ACTIONS(4130),
    [anon_sym_PLUS] = ACTIONS(4130),
    [anon_sym_DASH] = ACTIONS(4130),
    [anon_sym_PLUS_DOT] = ACTIONS(4130),
    [anon_sym_DASH_DOT] = ACTIONS(4130),
    [anon_sym_PERCENT] = ACTIONS(4130),
    [anon_sym_AMP_AMP] = ACTIONS(4130),
    [anon_sym_TILDE] = ACTIONS(4128),
    [aux_sym_prefix_op_token1] = ACTIONS(4130),
    [aux_sym_infix_op_token1] = ACTIONS(4128),
    [aux_sym_infix_op_token2] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE] = ACTIONS(4130),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_COLON_EQ] = ACTIONS(4128),
    [anon_sym_DOLLAR] = ACTIONS(4130),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4130),
    [sym_int] = ACTIONS(4130),
    [sym_xint] = ACTIONS(4128),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4128),
    [sym__newline] = ACTIONS(4128),
  },
  [3259] = {
    [sym_block_comment] = STATE(3259),
    [sym_compiler_directive_decl] = STATE(3259),
    [sym_fsi_directive_decl] = STATE(3259),
    [sym_preproc_line] = STATE(3259),
    [sym_identifier] = ACTIONS(3885),
    [anon_sym_EQ] = ACTIONS(3883),
    [anon_sym_COLON] = ACTIONS(3885),
    [anon_sym_return] = ACTIONS(3885),
    [anon_sym_do] = ACTIONS(3885),
    [anon_sym_let] = ACTIONS(3885),
    [anon_sym_let_BANG] = ACTIONS(3883),
    [anon_sym_LPAREN] = ACTIONS(3885),
    [anon_sym_COMMA] = ACTIONS(3883),
    [anon_sym_null] = ACTIONS(3885),
    [anon_sym_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3883),
    [anon_sym_AMP] = ACTIONS(3885),
    [anon_sym_LBRACK] = ACTIONS(3885),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3883),
    [anon_sym_LBRACE] = ACTIONS(3885),
    [anon_sym_LT_AT] = ACTIONS(3885),
    [anon_sym_LT_AT_AT] = ACTIONS(3885),
    [anon_sym_DOT] = ACTIONS(3885),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3883),
    [anon_sym_new] = ACTIONS(3885),
    [anon_sym_return_BANG] = ACTIONS(3883),
    [anon_sym_yield] = ACTIONS(3885),
    [anon_sym_yield_BANG] = ACTIONS(3883),
    [anon_sym_lazy] = ACTIONS(3885),
    [anon_sym_assert] = ACTIONS(3885),
    [anon_sym_upcast] = ACTIONS(3885),
    [anon_sym_downcast] = ACTIONS(3885),
    [anon_sym_COLON_GT] = ACTIONS(3883),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3883),
    [anon_sym_for] = ACTIONS(3885),
    [anon_sym_while] = ACTIONS(3885),
    [anon_sym_if] = ACTIONS(3885),
    [anon_sym_fun] = ACTIONS(3885),
    [anon_sym_try] = ACTIONS(3885),
    [anon_sym_match] = ACTIONS(3885),
    [anon_sym_match_BANG] = ACTIONS(3883),
    [anon_sym_function] = ACTIONS(3885),
    [anon_sym_LT_DASH] = ACTIONS(3885),
    [anon_sym_DOT_LBRACK] = ACTIONS(3883),
    [anon_sym_LT] = ACTIONS(3883),
    [anon_sym_use] = ACTIONS(3885),
    [anon_sym_use_BANG] = ACTIONS(3883),
    [anon_sym_do_BANG] = ACTIONS(3883),
    [anon_sym_DOT_DOT] = ACTIONS(3883),
    [anon_sym_begin] = ACTIONS(3885),
    [anon_sym_LPAREN2] = ACTIONS(3885),
    [anon_sym_or] = ACTIONS(3885),
    [aux_sym_char_token1] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3885),
    [anon_sym_DQUOTE] = ACTIONS(3885),
    [anon_sym_AT_DQUOTE] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [sym_bool] = ACTIONS(3885),
    [sym_unit] = ACTIONS(3883),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3885),
    [sym_op_identifier] = ACTIONS(3885),
    [anon_sym_PLUS] = ACTIONS(3885),
    [anon_sym_DASH] = ACTIONS(3885),
    [anon_sym_PLUS_DOT] = ACTIONS(3885),
    [anon_sym_DASH_DOT] = ACTIONS(3885),
    [anon_sym_PERCENT] = ACTIONS(3885),
    [anon_sym_AMP_AMP] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3883),
    [aux_sym_prefix_op_token1] = ACTIONS(3885),
    [aux_sym_infix_op_token1] = ACTIONS(3883),
    [aux_sym_infix_op_token2] = ACTIONS(3885),
    [anon_sym_PIPE_PIPE] = ACTIONS(3885),
    [anon_sym_BANG_EQ] = ACTIONS(3885),
    [anon_sym_COLON_EQ] = ACTIONS(3883),
    [anon_sym_DOLLAR] = ACTIONS(3885),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3885),
    [sym_int] = ACTIONS(3885),
    [sym_xint] = ACTIONS(3883),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3883),
    [sym__newline] = ACTIONS(3883),
  },
  [3260] = {
    [sym_block_comment] = STATE(3260),
    [sym_compiler_directive_decl] = STATE(3260),
    [sym_fsi_directive_decl] = STATE(3260),
    [sym_preproc_line] = STATE(3260),
    [sym_identifier] = ACTIONS(3946),
    [anon_sym_EQ] = ACTIONS(3944),
    [anon_sym_COLON] = ACTIONS(3946),
    [anon_sym_return] = ACTIONS(3946),
    [anon_sym_do] = ACTIONS(3946),
    [anon_sym_let] = ACTIONS(3946),
    [anon_sym_let_BANG] = ACTIONS(3944),
    [anon_sym_LPAREN] = ACTIONS(3946),
    [anon_sym_COMMA] = ACTIONS(3944),
    [anon_sym_null] = ACTIONS(3946),
    [anon_sym_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LBRACK] = ACTIONS(3946),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3944),
    [anon_sym_LBRACE] = ACTIONS(3946),
    [anon_sym_LT_AT] = ACTIONS(3946),
    [anon_sym_LT_AT_AT] = ACTIONS(3946),
    [anon_sym_DOT] = ACTIONS(3946),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3944),
    [anon_sym_new] = ACTIONS(3946),
    [anon_sym_return_BANG] = ACTIONS(3944),
    [anon_sym_yield] = ACTIONS(3946),
    [anon_sym_yield_BANG] = ACTIONS(3944),
    [anon_sym_lazy] = ACTIONS(3946),
    [anon_sym_assert] = ACTIONS(3946),
    [anon_sym_upcast] = ACTIONS(3946),
    [anon_sym_downcast] = ACTIONS(3946),
    [anon_sym_COLON_GT] = ACTIONS(3944),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3944),
    [anon_sym_for] = ACTIONS(3946),
    [anon_sym_while] = ACTIONS(3946),
    [anon_sym_if] = ACTIONS(3946),
    [anon_sym_fun] = ACTIONS(3946),
    [anon_sym_try] = ACTIONS(3946),
    [anon_sym_match] = ACTIONS(3946),
    [anon_sym_match_BANG] = ACTIONS(3944),
    [anon_sym_function] = ACTIONS(3946),
    [anon_sym_LT_DASH] = ACTIONS(3946),
    [anon_sym_DOT_LBRACK] = ACTIONS(3944),
    [anon_sym_LT] = ACTIONS(3944),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_use] = ACTIONS(3946),
    [anon_sym_use_BANG] = ACTIONS(3944),
    [anon_sym_do_BANG] = ACTIONS(3944),
    [anon_sym_begin] = ACTIONS(3946),
    [anon_sym_LPAREN2] = ACTIONS(3946),
    [anon_sym_or] = ACTIONS(3946),
    [aux_sym_char_token1] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_AT_DQUOTE] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [sym_bool] = ACTIONS(3946),
    [sym_unit] = ACTIONS(3944),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3946),
    [sym_op_identifier] = ACTIONS(3946),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PLUS_DOT] = ACTIONS(3946),
    [anon_sym_DASH_DOT] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3946),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_TILDE] = ACTIONS(3944),
    [aux_sym_prefix_op_token1] = ACTIONS(3946),
    [aux_sym_infix_op_token1] = ACTIONS(3944),
    [aux_sym_infix_op_token2] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [anon_sym_BANG_EQ] = ACTIONS(3946),
    [anon_sym_COLON_EQ] = ACTIONS(3944),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3946),
    [sym_int] = ACTIONS(3946),
    [sym_xint] = ACTIONS(3944),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3944),
    [sym__newline] = ACTIONS(3944),
  },
  [3261] = {
    [sym_block_comment] = STATE(3261),
    [sym_compiler_directive_decl] = STATE(3261),
    [sym_fsi_directive_decl] = STATE(3261),
    [sym_preproc_line] = STATE(3261),
    [sym_identifier] = ACTIONS(3927),
    [anon_sym_EQ] = ACTIONS(3925),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_return] = ACTIONS(3927),
    [anon_sym_do] = ACTIONS(3927),
    [anon_sym_let] = ACTIONS(3927),
    [anon_sym_let_BANG] = ACTIONS(3925),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_COMMA] = ACTIONS(3925),
    [anon_sym_null] = ACTIONS(3927),
    [anon_sym_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_COLON] = ACTIONS(3925),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3925),
    [anon_sym_LBRACE] = ACTIONS(3927),
    [anon_sym_LT_AT] = ACTIONS(3927),
    [anon_sym_LT_AT_AT] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3925),
    [anon_sym_new] = ACTIONS(3927),
    [anon_sym_return_BANG] = ACTIONS(3925),
    [anon_sym_yield] = ACTIONS(3927),
    [anon_sym_yield_BANG] = ACTIONS(3925),
    [anon_sym_lazy] = ACTIONS(3927),
    [anon_sym_assert] = ACTIONS(3927),
    [anon_sym_upcast] = ACTIONS(3927),
    [anon_sym_downcast] = ACTIONS(3927),
    [anon_sym_COLON_GT] = ACTIONS(3925),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3925),
    [anon_sym_for] = ACTIONS(3927),
    [anon_sym_while] = ACTIONS(3927),
    [anon_sym_if] = ACTIONS(3927),
    [anon_sym_fun] = ACTIONS(3927),
    [anon_sym_try] = ACTIONS(3927),
    [anon_sym_match] = ACTIONS(3927),
    [anon_sym_match_BANG] = ACTIONS(3925),
    [anon_sym_function] = ACTIONS(3927),
    [anon_sym_LT_DASH] = ACTIONS(3927),
    [anon_sym_DOT_LBRACK] = ACTIONS(3925),
    [anon_sym_LT] = ACTIONS(3925),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_use] = ACTIONS(3927),
    [anon_sym_use_BANG] = ACTIONS(3925),
    [anon_sym_do_BANG] = ACTIONS(3925),
    [anon_sym_begin] = ACTIONS(3927),
    [anon_sym_LPAREN2] = ACTIONS(3927),
    [anon_sym_or] = ACTIONS(3927),
    [aux_sym_char_token1] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_AT_DQUOTE] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [sym_bool] = ACTIONS(3927),
    [sym_unit] = ACTIONS(3925),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3927),
    [sym_op_identifier] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3927),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_PLUS_DOT] = ACTIONS(3927),
    [anon_sym_DASH_DOT] = ACTIONS(3927),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_TILDE] = ACTIONS(3925),
    [aux_sym_prefix_op_token1] = ACTIONS(3927),
    [aux_sym_infix_op_token1] = ACTIONS(3925),
    [aux_sym_infix_op_token2] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_COLON_EQ] = ACTIONS(3925),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3927),
    [sym_int] = ACTIONS(3927),
    [sym_xint] = ACTIONS(3925),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3925),
    [sym__newline] = ACTIONS(3925),
  },
  [3262] = {
    [sym_block_comment] = STATE(3262),
    [sym_compiler_directive_decl] = STATE(3262),
    [sym_fsi_directive_decl] = STATE(3262),
    [sym_preproc_line] = STATE(3262),
    [sym_identifier] = ACTIONS(3935),
    [anon_sym_EQ] = ACTIONS(3933),
    [anon_sym_COLON] = ACTIONS(3935),
    [anon_sym_return] = ACTIONS(3935),
    [anon_sym_do] = ACTIONS(3935),
    [anon_sym_let] = ACTIONS(3935),
    [anon_sym_let_BANG] = ACTIONS(3933),
    [anon_sym_LPAREN] = ACTIONS(3935),
    [anon_sym_COMMA] = ACTIONS(3933),
    [anon_sym_null] = ACTIONS(3935),
    [anon_sym_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3935),
    [anon_sym_LBRACK] = ACTIONS(3935),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3933),
    [anon_sym_LBRACE] = ACTIONS(3935),
    [anon_sym_LT_AT] = ACTIONS(3935),
    [anon_sym_LT_AT_AT] = ACTIONS(3935),
    [anon_sym_DOT] = ACTIONS(3935),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3933),
    [anon_sym_new] = ACTIONS(3935),
    [anon_sym_return_BANG] = ACTIONS(3933),
    [anon_sym_yield] = ACTIONS(3935),
    [anon_sym_yield_BANG] = ACTIONS(3933),
    [anon_sym_lazy] = ACTIONS(3935),
    [anon_sym_assert] = ACTIONS(3935),
    [anon_sym_upcast] = ACTIONS(3935),
    [anon_sym_downcast] = ACTIONS(3935),
    [anon_sym_COLON_GT] = ACTIONS(3933),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3933),
    [anon_sym_for] = ACTIONS(3935),
    [anon_sym_while] = ACTIONS(3935),
    [anon_sym_if] = ACTIONS(3935),
    [anon_sym_fun] = ACTIONS(3935),
    [anon_sym_try] = ACTIONS(3935),
    [anon_sym_match] = ACTIONS(3935),
    [anon_sym_match_BANG] = ACTIONS(3933),
    [anon_sym_function] = ACTIONS(3935),
    [anon_sym_LT_DASH] = ACTIONS(3935),
    [anon_sym_DOT_LBRACK] = ACTIONS(3933),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_use] = ACTIONS(3935),
    [anon_sym_use_BANG] = ACTIONS(3933),
    [anon_sym_do_BANG] = ACTIONS(3933),
    [anon_sym_DOT_DOT] = ACTIONS(3933),
    [anon_sym_begin] = ACTIONS(3935),
    [anon_sym_LPAREN2] = ACTIONS(3935),
    [anon_sym_or] = ACTIONS(3935),
    [aux_sym_char_token1] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3935),
    [anon_sym_DQUOTE] = ACTIONS(3935),
    [anon_sym_AT_DQUOTE] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [sym_bool] = ACTIONS(3935),
    [sym_unit] = ACTIONS(3933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3935),
    [sym_op_identifier] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(3935),
    [anon_sym_DASH] = ACTIONS(3935),
    [anon_sym_PLUS_DOT] = ACTIONS(3935),
    [anon_sym_DASH_DOT] = ACTIONS(3935),
    [anon_sym_PERCENT] = ACTIONS(3935),
    [anon_sym_AMP_AMP] = ACTIONS(3935),
    [anon_sym_TILDE] = ACTIONS(3933),
    [aux_sym_prefix_op_token1] = ACTIONS(3935),
    [aux_sym_infix_op_token1] = ACTIONS(3933),
    [aux_sym_infix_op_token2] = ACTIONS(3935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3935),
    [anon_sym_BANG_EQ] = ACTIONS(3935),
    [anon_sym_COLON_EQ] = ACTIONS(3933),
    [anon_sym_DOLLAR] = ACTIONS(3935),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3935),
    [sym_int] = ACTIONS(3935),
    [sym_xint] = ACTIONS(3933),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3933),
    [sym__newline] = ACTIONS(3933),
  },
  [3263] = {
    [sym_block_comment] = STATE(3263),
    [sym_compiler_directive_decl] = STATE(3263),
    [sym_fsi_directive_decl] = STATE(3263),
    [sym_preproc_line] = STATE(3263),
    [sym_identifier] = ACTIONS(4022),
    [anon_sym_EQ] = ACTIONS(4020),
    [anon_sym_COLON] = ACTIONS(4022),
    [anon_sym_return] = ACTIONS(4022),
    [anon_sym_do] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_let_BANG] = ACTIONS(4020),
    [anon_sym_LPAREN] = ACTIONS(4022),
    [anon_sym_COMMA] = ACTIONS(4020),
    [anon_sym_null] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_COLON] = ACTIONS(4020),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4022),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(4022),
    [anon_sym_LT_AT] = ACTIONS(4022),
    [anon_sym_AT_GT] = ACTIONS(4022),
    [anon_sym_LT_AT_AT] = ACTIONS(4022),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4020),
    [anon_sym_new] = ACTIONS(4022),
    [anon_sym_return_BANG] = ACTIONS(4020),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_yield_BANG] = ACTIONS(4020),
    [anon_sym_lazy] = ACTIONS(4022),
    [anon_sym_assert] = ACTIONS(4022),
    [anon_sym_upcast] = ACTIONS(4022),
    [anon_sym_downcast] = ACTIONS(4022),
    [anon_sym_COLON_GT] = ACTIONS(4020),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4020),
    [anon_sym_for] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4022),
    [anon_sym_if] = ACTIONS(4022),
    [anon_sym_fun] = ACTIONS(4022),
    [anon_sym_try] = ACTIONS(4022),
    [anon_sym_match] = ACTIONS(4022),
    [anon_sym_match_BANG] = ACTIONS(4020),
    [anon_sym_function] = ACTIONS(4022),
    [anon_sym_LT_DASH] = ACTIONS(4022),
    [anon_sym_DOT_LBRACK] = ACTIONS(4020),
    [anon_sym_LT] = ACTIONS(4020),
    [anon_sym_use] = ACTIONS(4022),
    [anon_sym_use_BANG] = ACTIONS(4020),
    [anon_sym_do_BANG] = ACTIONS(4020),
    [anon_sym_begin] = ACTIONS(4022),
    [anon_sym_LPAREN2] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [aux_sym_char_token1] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4022),
    [anon_sym_DQUOTE] = ACTIONS(4022),
    [anon_sym_AT_DQUOTE] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [sym_bool] = ACTIONS(4022),
    [sym_unit] = ACTIONS(4020),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4022),
    [sym_op_identifier] = ACTIONS(4022),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_PLUS_DOT] = ACTIONS(4022),
    [anon_sym_DASH_DOT] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4022),
    [anon_sym_TILDE] = ACTIONS(4020),
    [aux_sym_prefix_op_token1] = ACTIONS(4022),
    [aux_sym_infix_op_token1] = ACTIONS(4020),
    [aux_sym_infix_op_token2] = ACTIONS(4022),
    [anon_sym_PIPE_PIPE] = ACTIONS(4022),
    [anon_sym_BANG_EQ] = ACTIONS(4022),
    [anon_sym_COLON_EQ] = ACTIONS(4020),
    [anon_sym_DOLLAR] = ACTIONS(4022),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4022),
    [sym_int] = ACTIONS(4022),
    [sym_xint] = ACTIONS(4020),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4020),
    [sym__newline] = ACTIONS(4020),
  },
  [3264] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defns] = STATE(4150),
    [sym__function_or_value_defn_body] = STATE(3751),
    [sym_function_declaration_left] = STATE(10099),
    [sym_value_declaration_left] = STATE(10099),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3264),
    [sym_compiler_directive_decl] = STATE(3264),
    [sym_fsi_directive_decl] = STATE(3264),
    [sym_preproc_line] = STATE(3264),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3265] = {
    [sym_block_comment] = STATE(3265),
    [sym_compiler_directive_decl] = STATE(3265),
    [sym_fsi_directive_decl] = STATE(3265),
    [sym_preproc_line] = STATE(3265),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_GT] = ACTIONS(3193),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [3266] = {
    [sym_block_comment] = STATE(3266),
    [sym_compiler_directive_decl] = STATE(3266),
    [sym_fsi_directive_decl] = STATE(3266),
    [sym_preproc_line] = STATE(3266),
    [sym_identifier] = ACTIONS(4104),
    [anon_sym_EQ] = ACTIONS(4102),
    [anon_sym_COLON] = ACTIONS(4104),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_do] = ACTIONS(4104),
    [anon_sym_let] = ACTIONS(4104),
    [anon_sym_let_BANG] = ACTIONS(4102),
    [anon_sym_LPAREN] = ACTIONS(4104),
    [anon_sym_COMMA] = ACTIONS(4102),
    [anon_sym_null] = ACTIONS(4104),
    [anon_sym_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_COLON] = ACTIONS(4102),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4104),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4102),
    [anon_sym_LBRACE] = ACTIONS(4104),
    [anon_sym_LT_AT] = ACTIONS(4104),
    [anon_sym_LT_AT_AT] = ACTIONS(4104),
    [anon_sym_DOT] = ACTIONS(4104),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4102),
    [anon_sym_new] = ACTIONS(4104),
    [anon_sym_return_BANG] = ACTIONS(4102),
    [anon_sym_yield] = ACTIONS(4104),
    [anon_sym_yield_BANG] = ACTIONS(4102),
    [anon_sym_lazy] = ACTIONS(4104),
    [anon_sym_assert] = ACTIONS(4104),
    [anon_sym_upcast] = ACTIONS(4104),
    [anon_sym_downcast] = ACTIONS(4104),
    [anon_sym_COLON_GT] = ACTIONS(4102),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4102),
    [anon_sym_for] = ACTIONS(4104),
    [anon_sym_while] = ACTIONS(4104),
    [anon_sym_if] = ACTIONS(4104),
    [anon_sym_fun] = ACTIONS(4104),
    [anon_sym_try] = ACTIONS(4104),
    [anon_sym_match] = ACTIONS(4104),
    [anon_sym_match_BANG] = ACTIONS(4102),
    [anon_sym_function] = ACTIONS(4104),
    [anon_sym_LT_DASH] = ACTIONS(4104),
    [anon_sym_DOT_LBRACK] = ACTIONS(4102),
    [anon_sym_LT] = ACTIONS(4102),
    [anon_sym_GT] = ACTIONS(4104),
    [anon_sym_use] = ACTIONS(4104),
    [anon_sym_use_BANG] = ACTIONS(4102),
    [anon_sym_do_BANG] = ACTIONS(4102),
    [anon_sym_begin] = ACTIONS(4104),
    [anon_sym_LPAREN2] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [aux_sym_char_token1] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4104),
    [anon_sym_DQUOTE] = ACTIONS(4104),
    [anon_sym_AT_DQUOTE] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [sym_bool] = ACTIONS(4104),
    [sym_unit] = ACTIONS(4102),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4104),
    [sym_op_identifier] = ACTIONS(4104),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_PLUS_DOT] = ACTIONS(4104),
    [anon_sym_DASH_DOT] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_AMP_AMP] = ACTIONS(4104),
    [anon_sym_TILDE] = ACTIONS(4102),
    [aux_sym_prefix_op_token1] = ACTIONS(4104),
    [aux_sym_infix_op_token1] = ACTIONS(4102),
    [aux_sym_infix_op_token2] = ACTIONS(4104),
    [anon_sym_PIPE_PIPE] = ACTIONS(4104),
    [anon_sym_BANG_EQ] = ACTIONS(4104),
    [anon_sym_COLON_EQ] = ACTIONS(4102),
    [anon_sym_DOLLAR] = ACTIONS(4104),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4104),
    [sym_int] = ACTIONS(4104),
    [sym_xint] = ACTIONS(4102),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4102),
    [sym__newline] = ACTIONS(4102),
  },
  [3267] = {
    [sym_block_comment] = STATE(3267),
    [sym_compiler_directive_decl] = STATE(3267),
    [sym_fsi_directive_decl] = STATE(3267),
    [sym_preproc_line] = STATE(3267),
    [sym_identifier] = ACTIONS(4137),
    [anon_sym_EQ] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4137),
    [anon_sym_return] = ACTIONS(4137),
    [anon_sym_do] = ACTIONS(4137),
    [anon_sym_let] = ACTIONS(4137),
    [anon_sym_let_BANG] = ACTIONS(4135),
    [anon_sym_LPAREN] = ACTIONS(4137),
    [anon_sym_COMMA] = ACTIONS(4135),
    [anon_sym_null] = ACTIONS(4137),
    [anon_sym_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_COLON] = ACTIONS(4135),
    [anon_sym_AMP] = ACTIONS(4137),
    [anon_sym_LBRACK] = ACTIONS(4137),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4135),
    [anon_sym_LBRACE] = ACTIONS(4137),
    [anon_sym_LT_AT] = ACTIONS(4137),
    [anon_sym_LT_AT_AT] = ACTIONS(4137),
    [anon_sym_DOT] = ACTIONS(4137),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4135),
    [anon_sym_new] = ACTIONS(4137),
    [anon_sym_return_BANG] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_yield_BANG] = ACTIONS(4135),
    [anon_sym_lazy] = ACTIONS(4137),
    [anon_sym_assert] = ACTIONS(4137),
    [anon_sym_upcast] = ACTIONS(4137),
    [anon_sym_downcast] = ACTIONS(4137),
    [anon_sym_COLON_GT] = ACTIONS(4135),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4135),
    [anon_sym_for] = ACTIONS(4137),
    [anon_sym_while] = ACTIONS(4137),
    [anon_sym_if] = ACTIONS(4137),
    [anon_sym_fun] = ACTIONS(4137),
    [anon_sym_try] = ACTIONS(4137),
    [anon_sym_match] = ACTIONS(4137),
    [anon_sym_match_BANG] = ACTIONS(4135),
    [anon_sym_function] = ACTIONS(4137),
    [anon_sym_LT_DASH] = ACTIONS(4137),
    [anon_sym_DOT_LBRACK] = ACTIONS(4135),
    [anon_sym_LT] = ACTIONS(4135),
    [anon_sym_use] = ACTIONS(4137),
    [anon_sym_use_BANG] = ACTIONS(4135),
    [anon_sym_do_BANG] = ACTIONS(4135),
    [anon_sym_DOT_DOT] = ACTIONS(4135),
    [anon_sym_begin] = ACTIONS(4137),
    [anon_sym_LPAREN2] = ACTIONS(4137),
    [anon_sym_or] = ACTIONS(4137),
    [aux_sym_char_token1] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4137),
    [anon_sym_DQUOTE] = ACTIONS(4137),
    [anon_sym_AT_DQUOTE] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [sym_bool] = ACTIONS(4137),
    [sym_unit] = ACTIONS(4135),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4137),
    [sym_op_identifier] = ACTIONS(4137),
    [anon_sym_PLUS] = ACTIONS(4137),
    [anon_sym_DASH] = ACTIONS(4137),
    [anon_sym_PLUS_DOT] = ACTIONS(4137),
    [anon_sym_DASH_DOT] = ACTIONS(4137),
    [anon_sym_PERCENT] = ACTIONS(4137),
    [anon_sym_AMP_AMP] = ACTIONS(4137),
    [anon_sym_TILDE] = ACTIONS(4135),
    [aux_sym_prefix_op_token1] = ACTIONS(4137),
    [aux_sym_infix_op_token1] = ACTIONS(4135),
    [aux_sym_infix_op_token2] = ACTIONS(4137),
    [anon_sym_PIPE_PIPE] = ACTIONS(4137),
    [anon_sym_BANG_EQ] = ACTIONS(4137),
    [anon_sym_COLON_EQ] = ACTIONS(4135),
    [anon_sym_DOLLAR] = ACTIONS(4137),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4137),
    [sym_int] = ACTIONS(4137),
    [sym_xint] = ACTIONS(4135),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4135),
    [sym__newline] = ACTIONS(4135),
  },
  [3268] = {
    [sym_block_comment] = STATE(3268),
    [sym_compiler_directive_decl] = STATE(3268),
    [sym_fsi_directive_decl] = STATE(3268),
    [sym_preproc_line] = STATE(3268),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_EQ] = ACTIONS(3948),
    [anon_sym_COLON] = ACTIONS(3950),
    [anon_sym_return] = ACTIONS(3950),
    [anon_sym_do] = ACTIONS(3950),
    [anon_sym_let] = ACTIONS(3950),
    [anon_sym_let_BANG] = ACTIONS(3948),
    [anon_sym_LPAREN] = ACTIONS(3950),
    [anon_sym_COMMA] = ACTIONS(3948),
    [anon_sym_null] = ACTIONS(3950),
    [anon_sym_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_COLON] = ACTIONS(3948),
    [anon_sym_AMP] = ACTIONS(3950),
    [anon_sym_LBRACK] = ACTIONS(3950),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3948),
    [anon_sym_LBRACE] = ACTIONS(3950),
    [anon_sym_LT_AT] = ACTIONS(3950),
    [anon_sym_LT_AT_AT] = ACTIONS(3950),
    [anon_sym_DOT] = ACTIONS(3950),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3948),
    [anon_sym_new] = ACTIONS(3950),
    [anon_sym_return_BANG] = ACTIONS(3948),
    [anon_sym_yield] = ACTIONS(3950),
    [anon_sym_yield_BANG] = ACTIONS(3948),
    [anon_sym_lazy] = ACTIONS(3950),
    [anon_sym_assert] = ACTIONS(3950),
    [anon_sym_upcast] = ACTIONS(3950),
    [anon_sym_downcast] = ACTIONS(3950),
    [anon_sym_COLON_GT] = ACTIONS(3948),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3948),
    [anon_sym_for] = ACTIONS(3950),
    [anon_sym_while] = ACTIONS(3950),
    [anon_sym_if] = ACTIONS(3950),
    [anon_sym_fun] = ACTIONS(3950),
    [anon_sym_try] = ACTIONS(3950),
    [anon_sym_match] = ACTIONS(3950),
    [anon_sym_match_BANG] = ACTIONS(3948),
    [anon_sym_function] = ACTIONS(3950),
    [anon_sym_LT_DASH] = ACTIONS(3950),
    [anon_sym_DOT_LBRACK] = ACTIONS(3948),
    [anon_sym_LT] = ACTIONS(3948),
    [anon_sym_use] = ACTIONS(3950),
    [anon_sym_use_BANG] = ACTIONS(3948),
    [anon_sym_do_BANG] = ACTIONS(3948),
    [anon_sym_DOT_DOT] = ACTIONS(3948),
    [anon_sym_begin] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3950),
    [anon_sym_or] = ACTIONS(3950),
    [aux_sym_char_token1] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3950),
    [anon_sym_DQUOTE] = ACTIONS(3950),
    [anon_sym_AT_DQUOTE] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [sym_bool] = ACTIONS(3950),
    [sym_unit] = ACTIONS(3948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3950),
    [sym_op_identifier] = ACTIONS(3950),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_DASH] = ACTIONS(3950),
    [anon_sym_PLUS_DOT] = ACTIONS(3950),
    [anon_sym_DASH_DOT] = ACTIONS(3950),
    [anon_sym_PERCENT] = ACTIONS(3950),
    [anon_sym_AMP_AMP] = ACTIONS(3950),
    [anon_sym_TILDE] = ACTIONS(3948),
    [aux_sym_prefix_op_token1] = ACTIONS(3950),
    [aux_sym_infix_op_token1] = ACTIONS(3948),
    [aux_sym_infix_op_token2] = ACTIONS(3950),
    [anon_sym_PIPE_PIPE] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3950),
    [anon_sym_COLON_EQ] = ACTIONS(3948),
    [anon_sym_DOLLAR] = ACTIONS(3950),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3950),
    [sym_int] = ACTIONS(3950),
    [sym_xint] = ACTIONS(3948),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3948),
    [sym__newline] = ACTIONS(3948),
  },
  [3269] = {
    [sym_block_comment] = STATE(3269),
    [sym_compiler_directive_decl] = STATE(3269),
    [sym_fsi_directive_decl] = STATE(3269),
    [sym_preproc_line] = STATE(3269),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4072),
    [anon_sym_COLON] = ACTIONS(4074),
    [anon_sym_return] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_let_BANG] = ACTIONS(4072),
    [anon_sym_LPAREN] = ACTIONS(4074),
    [anon_sym_COMMA] = ACTIONS(4072),
    [anon_sym_null] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_COLON] = ACTIONS(4072),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_LT_AT] = ACTIONS(4074),
    [anon_sym_AT_GT] = ACTIONS(4074),
    [anon_sym_LT_AT_AT] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4072),
    [anon_sym_new] = ACTIONS(4074),
    [anon_sym_return_BANG] = ACTIONS(4072),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_yield_BANG] = ACTIONS(4072),
    [anon_sym_lazy] = ACTIONS(4074),
    [anon_sym_assert] = ACTIONS(4074),
    [anon_sym_upcast] = ACTIONS(4074),
    [anon_sym_downcast] = ACTIONS(4074),
    [anon_sym_COLON_GT] = ACTIONS(4072),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4072),
    [anon_sym_for] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_fun] = ACTIONS(4074),
    [anon_sym_try] = ACTIONS(4074),
    [anon_sym_match] = ACTIONS(4074),
    [anon_sym_match_BANG] = ACTIONS(4072),
    [anon_sym_function] = ACTIONS(4074),
    [anon_sym_LT_DASH] = ACTIONS(4074),
    [anon_sym_DOT_LBRACK] = ACTIONS(4072),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_use] = ACTIONS(4074),
    [anon_sym_use_BANG] = ACTIONS(4072),
    [anon_sym_do_BANG] = ACTIONS(4072),
    [anon_sym_begin] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [aux_sym_char_token1] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4074),
    [anon_sym_DQUOTE] = ACTIONS(4074),
    [anon_sym_AT_DQUOTE] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [sym_bool] = ACTIONS(4074),
    [sym_unit] = ACTIONS(4072),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4074),
    [sym_op_identifier] = ACTIONS(4074),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_PLUS_DOT] = ACTIONS(4074),
    [anon_sym_DASH_DOT] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_TILDE] = ACTIONS(4072),
    [aux_sym_prefix_op_token1] = ACTIONS(4074),
    [aux_sym_infix_op_token1] = ACTIONS(4072),
    [aux_sym_infix_op_token2] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [anon_sym_BANG_EQ] = ACTIONS(4074),
    [anon_sym_COLON_EQ] = ACTIONS(4072),
    [anon_sym_DOLLAR] = ACTIONS(4074),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4074),
    [sym_int] = ACTIONS(4074),
    [sym_xint] = ACTIONS(4072),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4072),
    [sym__newline] = ACTIONS(4072),
  },
  [3270] = {
    [sym_block_comment] = STATE(3270),
    [sym_compiler_directive_decl] = STATE(3270),
    [sym_fsi_directive_decl] = STATE(3270),
    [sym_preproc_line] = STATE(3270),
    [sym_identifier] = ACTIONS(4137),
    [anon_sym_EQ] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4137),
    [anon_sym_return] = ACTIONS(4137),
    [anon_sym_do] = ACTIONS(4137),
    [anon_sym_let] = ACTIONS(4137),
    [anon_sym_let_BANG] = ACTIONS(4135),
    [anon_sym_LPAREN] = ACTIONS(4137),
    [anon_sym_COMMA] = ACTIONS(4135),
    [anon_sym_null] = ACTIONS(4137),
    [anon_sym_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_COLON] = ACTIONS(4135),
    [anon_sym_AMP] = ACTIONS(4137),
    [anon_sym_LBRACK] = ACTIONS(4137),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4135),
    [anon_sym_LBRACE] = ACTIONS(4137),
    [anon_sym_LT_AT] = ACTIONS(4137),
    [anon_sym_LT_AT_AT] = ACTIONS(4137),
    [anon_sym_DOT] = ACTIONS(4137),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4135),
    [anon_sym_new] = ACTIONS(4137),
    [anon_sym_return_BANG] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_yield_BANG] = ACTIONS(4135),
    [anon_sym_lazy] = ACTIONS(4137),
    [anon_sym_assert] = ACTIONS(4137),
    [anon_sym_upcast] = ACTIONS(4137),
    [anon_sym_downcast] = ACTIONS(4137),
    [anon_sym_COLON_GT] = ACTIONS(4135),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4135),
    [anon_sym_for] = ACTIONS(4137),
    [anon_sym_while] = ACTIONS(4137),
    [anon_sym_if] = ACTIONS(4137),
    [anon_sym_fun] = ACTIONS(4137),
    [anon_sym_try] = ACTIONS(4137),
    [anon_sym_match] = ACTIONS(4137),
    [anon_sym_match_BANG] = ACTIONS(4135),
    [anon_sym_function] = ACTIONS(4137),
    [anon_sym_LT_DASH] = ACTIONS(4137),
    [anon_sym_DOT_LBRACK] = ACTIONS(4135),
    [anon_sym_LT] = ACTIONS(4135),
    [anon_sym_GT] = ACTIONS(4137),
    [anon_sym_use] = ACTIONS(4137),
    [anon_sym_use_BANG] = ACTIONS(4135),
    [anon_sym_do_BANG] = ACTIONS(4135),
    [anon_sym_begin] = ACTIONS(4137),
    [anon_sym_LPAREN2] = ACTIONS(4137),
    [anon_sym_or] = ACTIONS(4137),
    [aux_sym_char_token1] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4137),
    [anon_sym_DQUOTE] = ACTIONS(4137),
    [anon_sym_AT_DQUOTE] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [sym_bool] = ACTIONS(4137),
    [sym_unit] = ACTIONS(4135),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4137),
    [sym_op_identifier] = ACTIONS(4137),
    [anon_sym_PLUS] = ACTIONS(4137),
    [anon_sym_DASH] = ACTIONS(4137),
    [anon_sym_PLUS_DOT] = ACTIONS(4137),
    [anon_sym_DASH_DOT] = ACTIONS(4137),
    [anon_sym_PERCENT] = ACTIONS(4137),
    [anon_sym_AMP_AMP] = ACTIONS(4137),
    [anon_sym_TILDE] = ACTIONS(4135),
    [aux_sym_prefix_op_token1] = ACTIONS(4137),
    [aux_sym_infix_op_token1] = ACTIONS(4135),
    [aux_sym_infix_op_token2] = ACTIONS(4137),
    [anon_sym_PIPE_PIPE] = ACTIONS(4137),
    [anon_sym_BANG_EQ] = ACTIONS(4137),
    [anon_sym_COLON_EQ] = ACTIONS(4135),
    [anon_sym_DOLLAR] = ACTIONS(4137),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4137),
    [sym_int] = ACTIONS(4137),
    [sym_xint] = ACTIONS(4135),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4135),
    [sym__newline] = ACTIONS(4135),
  },
  [3271] = {
    [sym_block_comment] = STATE(3271),
    [sym_compiler_directive_decl] = STATE(3271),
    [sym_fsi_directive_decl] = STATE(3271),
    [sym_preproc_line] = STATE(3271),
    [sym_identifier] = ACTIONS(3856),
    [anon_sym_EQ] = ACTIONS(3854),
    [anon_sym_COLON] = ACTIONS(3856),
    [anon_sym_return] = ACTIONS(3856),
    [anon_sym_do] = ACTIONS(3856),
    [anon_sym_let] = ACTIONS(3856),
    [anon_sym_let_BANG] = ACTIONS(3854),
    [anon_sym_LPAREN] = ACTIONS(3856),
    [anon_sym_COMMA] = ACTIONS(3854),
    [anon_sym_null] = ACTIONS(3856),
    [anon_sym_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_AMP] = ACTIONS(3856),
    [anon_sym_LBRACK] = ACTIONS(3856),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3854),
    [anon_sym_LBRACE] = ACTIONS(3856),
    [anon_sym_LT_AT] = ACTIONS(3856),
    [anon_sym_LT_AT_AT] = ACTIONS(3856),
    [anon_sym_DOT] = ACTIONS(3856),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3854),
    [anon_sym_new] = ACTIONS(3856),
    [anon_sym_return_BANG] = ACTIONS(3854),
    [anon_sym_yield] = ACTIONS(3856),
    [anon_sym_yield_BANG] = ACTIONS(3854),
    [anon_sym_lazy] = ACTIONS(3856),
    [anon_sym_assert] = ACTIONS(3856),
    [anon_sym_upcast] = ACTIONS(3856),
    [anon_sym_downcast] = ACTIONS(3856),
    [anon_sym_COLON_GT] = ACTIONS(3854),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3854),
    [anon_sym_for] = ACTIONS(3856),
    [anon_sym_while] = ACTIONS(3856),
    [anon_sym_if] = ACTIONS(3856),
    [anon_sym_fun] = ACTIONS(3856),
    [anon_sym_try] = ACTIONS(3856),
    [anon_sym_match] = ACTIONS(3856),
    [anon_sym_match_BANG] = ACTIONS(3854),
    [anon_sym_function] = ACTIONS(3856),
    [anon_sym_LT_DASH] = ACTIONS(3856),
    [anon_sym_DOT_LBRACK] = ACTIONS(3854),
    [anon_sym_LT] = ACTIONS(3854),
    [anon_sym_use] = ACTIONS(3856),
    [anon_sym_use_BANG] = ACTIONS(3854),
    [anon_sym_do_BANG] = ACTIONS(3854),
    [anon_sym_DOT_DOT] = ACTIONS(3854),
    [anon_sym_begin] = ACTIONS(3856),
    [anon_sym_LPAREN2] = ACTIONS(3856),
    [anon_sym_or] = ACTIONS(3856),
    [aux_sym_char_token1] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3856),
    [anon_sym_DQUOTE] = ACTIONS(3856),
    [anon_sym_AT_DQUOTE] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [sym_bool] = ACTIONS(3856),
    [sym_unit] = ACTIONS(3854),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3856),
    [sym_op_identifier] = ACTIONS(3856),
    [anon_sym_PLUS] = ACTIONS(3856),
    [anon_sym_DASH] = ACTIONS(3856),
    [anon_sym_PLUS_DOT] = ACTIONS(3856),
    [anon_sym_DASH_DOT] = ACTIONS(3856),
    [anon_sym_PERCENT] = ACTIONS(3856),
    [anon_sym_AMP_AMP] = ACTIONS(3856),
    [anon_sym_TILDE] = ACTIONS(3854),
    [aux_sym_prefix_op_token1] = ACTIONS(3856),
    [aux_sym_infix_op_token1] = ACTIONS(3854),
    [aux_sym_infix_op_token2] = ACTIONS(3856),
    [anon_sym_PIPE_PIPE] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3856),
    [anon_sym_COLON_EQ] = ACTIONS(3854),
    [anon_sym_DOLLAR] = ACTIONS(3856),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3856),
    [sym_int] = ACTIONS(3856),
    [sym_xint] = ACTIONS(3854),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3854),
    [sym__newline] = ACTIONS(3854),
  },
  [3272] = {
    [sym_block_comment] = STATE(3272),
    [sym_compiler_directive_decl] = STATE(3272),
    [sym_fsi_directive_decl] = STATE(3272),
    [sym_preproc_line] = STATE(3272),
    [sym_identifier] = ACTIONS(3863),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_let] = ACTIONS(3863),
    [anon_sym_let_BANG] = ACTIONS(3861),
    [anon_sym_LPAREN] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3861),
    [anon_sym_null] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_COLON] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_LT_AT] = ACTIONS(3863),
    [anon_sym_LT_AT_AT] = ACTIONS(3863),
    [anon_sym_DOT] = ACTIONS(3863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3861),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_return_BANG] = ACTIONS(3861),
    [anon_sym_yield] = ACTIONS(3863),
    [anon_sym_yield_BANG] = ACTIONS(3861),
    [anon_sym_lazy] = ACTIONS(3863),
    [anon_sym_assert] = ACTIONS(3863),
    [anon_sym_upcast] = ACTIONS(3863),
    [anon_sym_downcast] = ACTIONS(3863),
    [anon_sym_COLON_GT] = ACTIONS(3861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_fun] = ACTIONS(3863),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_match] = ACTIONS(3863),
    [anon_sym_match_BANG] = ACTIONS(3861),
    [anon_sym_function] = ACTIONS(3863),
    [anon_sym_LT_DASH] = ACTIONS(3863),
    [anon_sym_DOT_LBRACK] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_use] = ACTIONS(3863),
    [anon_sym_use_BANG] = ACTIONS(3861),
    [anon_sym_do_BANG] = ACTIONS(3861),
    [anon_sym_DOT_DOT] = ACTIONS(3861),
    [anon_sym_begin] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(3863),
    [anon_sym_or] = ACTIONS(3863),
    [aux_sym_char_token1] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [anon_sym_AT_DQUOTE] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [sym_bool] = ACTIONS(3863),
    [sym_unit] = ACTIONS(3861),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3863),
    [sym_op_identifier] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_DOT] = ACTIONS(3863),
    [anon_sym_DASH_DOT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3861),
    [aux_sym_prefix_op_token1] = ACTIONS(3863),
    [aux_sym_infix_op_token1] = ACTIONS(3861),
    [aux_sym_infix_op_token2] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_COLON_EQ] = ACTIONS(3861),
    [anon_sym_DOLLAR] = ACTIONS(3863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3863),
    [sym_int] = ACTIONS(3863),
    [sym_xint] = ACTIONS(3861),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3861),
    [sym__newline] = ACTIONS(3861),
  },
  [3273] = {
    [sym_block_comment] = STATE(3273),
    [sym_compiler_directive_decl] = STATE(3273),
    [sym_fsi_directive_decl] = STATE(3273),
    [sym_preproc_line] = STATE(3273),
    [sym_identifier] = ACTIONS(3875),
    [anon_sym_EQ] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(3875),
    [anon_sym_return] = ACTIONS(3875),
    [anon_sym_do] = ACTIONS(3875),
    [anon_sym_let] = ACTIONS(3875),
    [anon_sym_let_BANG] = ACTIONS(3873),
    [anon_sym_LPAREN] = ACTIONS(3875),
    [anon_sym_COMMA] = ACTIONS(3873),
    [anon_sym_null] = ACTIONS(3875),
    [anon_sym_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_COLON] = ACTIONS(3873),
    [anon_sym_AMP] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(3875),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3873),
    [anon_sym_LBRACE] = ACTIONS(3875),
    [anon_sym_LT_AT] = ACTIONS(3875),
    [anon_sym_LT_AT_AT] = ACTIONS(3875),
    [anon_sym_DOT] = ACTIONS(3875),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3873),
    [anon_sym_new] = ACTIONS(3875),
    [anon_sym_return_BANG] = ACTIONS(3873),
    [anon_sym_yield] = ACTIONS(3875),
    [anon_sym_yield_BANG] = ACTIONS(3873),
    [anon_sym_lazy] = ACTIONS(3875),
    [anon_sym_assert] = ACTIONS(3875),
    [anon_sym_upcast] = ACTIONS(3875),
    [anon_sym_downcast] = ACTIONS(3875),
    [anon_sym_COLON_GT] = ACTIONS(3873),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3873),
    [anon_sym_for] = ACTIONS(3875),
    [anon_sym_while] = ACTIONS(3875),
    [anon_sym_if] = ACTIONS(3875),
    [anon_sym_fun] = ACTIONS(3875),
    [anon_sym_try] = ACTIONS(3875),
    [anon_sym_match] = ACTIONS(3875),
    [anon_sym_match_BANG] = ACTIONS(3873),
    [anon_sym_function] = ACTIONS(3875),
    [anon_sym_LT_DASH] = ACTIONS(3875),
    [anon_sym_DOT_LBRACK] = ACTIONS(3873),
    [anon_sym_LT] = ACTIONS(3873),
    [anon_sym_use] = ACTIONS(3875),
    [anon_sym_use_BANG] = ACTIONS(3873),
    [anon_sym_do_BANG] = ACTIONS(3873),
    [anon_sym_DOT_DOT] = ACTIONS(3873),
    [anon_sym_begin] = ACTIONS(3875),
    [anon_sym_LPAREN2] = ACTIONS(3875),
    [anon_sym_or] = ACTIONS(3875),
    [aux_sym_char_token1] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3875),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [anon_sym_AT_DQUOTE] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [sym_bool] = ACTIONS(3875),
    [sym_unit] = ACTIONS(3873),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3875),
    [sym_op_identifier] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS_DOT] = ACTIONS(3875),
    [anon_sym_DASH_DOT] = ACTIONS(3875),
    [anon_sym_PERCENT] = ACTIONS(3875),
    [anon_sym_AMP_AMP] = ACTIONS(3875),
    [anon_sym_TILDE] = ACTIONS(3873),
    [aux_sym_prefix_op_token1] = ACTIONS(3875),
    [aux_sym_infix_op_token1] = ACTIONS(3873),
    [aux_sym_infix_op_token2] = ACTIONS(3875),
    [anon_sym_PIPE_PIPE] = ACTIONS(3875),
    [anon_sym_BANG_EQ] = ACTIONS(3875),
    [anon_sym_COLON_EQ] = ACTIONS(3873),
    [anon_sym_DOLLAR] = ACTIONS(3875),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3875),
    [sym_int] = ACTIONS(3875),
    [sym_xint] = ACTIONS(3873),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3873),
    [sym__newline] = ACTIONS(3873),
  },
  [3274] = {
    [sym_block_comment] = STATE(3274),
    [sym_compiler_directive_decl] = STATE(3274),
    [sym_fsi_directive_decl] = STATE(3274),
    [sym_preproc_line] = STATE(3274),
    [sym_identifier] = ACTIONS(3893),
    [anon_sym_EQ] = ACTIONS(3891),
    [anon_sym_COLON] = ACTIONS(3893),
    [anon_sym_return] = ACTIONS(3893),
    [anon_sym_do] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_let_BANG] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_COMMA] = ACTIONS(3891),
    [anon_sym_null] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_COLON] = ACTIONS(3891),
    [anon_sym_AMP] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3891),
    [anon_sym_LBRACE] = ACTIONS(3893),
    [anon_sym_LT_AT] = ACTIONS(3893),
    [anon_sym_LT_AT_AT] = ACTIONS(3893),
    [anon_sym_DOT] = ACTIONS(3893),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3891),
    [anon_sym_new] = ACTIONS(3893),
    [anon_sym_return_BANG] = ACTIONS(3891),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_yield_BANG] = ACTIONS(3891),
    [anon_sym_lazy] = ACTIONS(3893),
    [anon_sym_assert] = ACTIONS(3893),
    [anon_sym_upcast] = ACTIONS(3893),
    [anon_sym_downcast] = ACTIONS(3893),
    [anon_sym_COLON_GT] = ACTIONS(3891),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3891),
    [anon_sym_for] = ACTIONS(3893),
    [anon_sym_while] = ACTIONS(3893),
    [anon_sym_if] = ACTIONS(3893),
    [anon_sym_fun] = ACTIONS(3893),
    [anon_sym_try] = ACTIONS(3893),
    [anon_sym_match] = ACTIONS(3893),
    [anon_sym_match_BANG] = ACTIONS(3891),
    [anon_sym_function] = ACTIONS(3893),
    [anon_sym_LT_DASH] = ACTIONS(3893),
    [anon_sym_DOT_LBRACK] = ACTIONS(3891),
    [anon_sym_LT] = ACTIONS(3891),
    [anon_sym_use] = ACTIONS(3893),
    [anon_sym_use_BANG] = ACTIONS(3891),
    [anon_sym_do_BANG] = ACTIONS(3891),
    [anon_sym_DOT_DOT] = ACTIONS(3891),
    [anon_sym_begin] = ACTIONS(3893),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_or] = ACTIONS(3893),
    [aux_sym_char_token1] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3893),
    [anon_sym_DQUOTE] = ACTIONS(3893),
    [anon_sym_AT_DQUOTE] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [sym_bool] = ACTIONS(3893),
    [sym_unit] = ACTIONS(3891),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3893),
    [sym_op_identifier] = ACTIONS(3893),
    [anon_sym_PLUS] = ACTIONS(3893),
    [anon_sym_DASH] = ACTIONS(3893),
    [anon_sym_PLUS_DOT] = ACTIONS(3893),
    [anon_sym_DASH_DOT] = ACTIONS(3893),
    [anon_sym_PERCENT] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_TILDE] = ACTIONS(3891),
    [aux_sym_prefix_op_token1] = ACTIONS(3893),
    [aux_sym_infix_op_token1] = ACTIONS(3891),
    [aux_sym_infix_op_token2] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [anon_sym_BANG_EQ] = ACTIONS(3893),
    [anon_sym_COLON_EQ] = ACTIONS(3891),
    [anon_sym_DOLLAR] = ACTIONS(3893),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3893),
    [sym_int] = ACTIONS(3893),
    [sym_xint] = ACTIONS(3891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3891),
    [sym__newline] = ACTIONS(3891),
  },
  [3275] = {
    [sym_block_comment] = STATE(3275),
    [sym_compiler_directive_decl] = STATE(3275),
    [sym_fsi_directive_decl] = STATE(3275),
    [sym_preproc_line] = STATE(3275),
    [sym_identifier] = ACTIONS(3900),
    [anon_sym_EQ] = ACTIONS(3898),
    [anon_sym_COLON] = ACTIONS(3900),
    [anon_sym_return] = ACTIONS(3900),
    [anon_sym_do] = ACTIONS(3900),
    [anon_sym_let] = ACTIONS(3900),
    [anon_sym_let_BANG] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3898),
    [anon_sym_null] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_COLON] = ACTIONS(3898),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_LBRACK] = ACTIONS(3900),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3898),
    [anon_sym_LBRACE] = ACTIONS(3900),
    [anon_sym_LT_AT] = ACTIONS(3900),
    [anon_sym_LT_AT_AT] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(3900),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3898),
    [anon_sym_new] = ACTIONS(3900),
    [anon_sym_return_BANG] = ACTIONS(3898),
    [anon_sym_yield] = ACTIONS(3900),
    [anon_sym_yield_BANG] = ACTIONS(3898),
    [anon_sym_lazy] = ACTIONS(3900),
    [anon_sym_assert] = ACTIONS(3900),
    [anon_sym_upcast] = ACTIONS(3900),
    [anon_sym_downcast] = ACTIONS(3900),
    [anon_sym_COLON_GT] = ACTIONS(3898),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3898),
    [anon_sym_for] = ACTIONS(3900),
    [anon_sym_while] = ACTIONS(3900),
    [anon_sym_if] = ACTIONS(3900),
    [anon_sym_fun] = ACTIONS(3900),
    [anon_sym_try] = ACTIONS(3900),
    [anon_sym_match] = ACTIONS(3900),
    [anon_sym_match_BANG] = ACTIONS(3898),
    [anon_sym_function] = ACTIONS(3900),
    [anon_sym_LT_DASH] = ACTIONS(3900),
    [anon_sym_DOT_LBRACK] = ACTIONS(3898),
    [anon_sym_LT] = ACTIONS(3898),
    [anon_sym_use] = ACTIONS(3900),
    [anon_sym_use_BANG] = ACTIONS(3898),
    [anon_sym_do_BANG] = ACTIONS(3898),
    [anon_sym_DOT_DOT] = ACTIONS(3898),
    [anon_sym_begin] = ACTIONS(3900),
    [anon_sym_LPAREN2] = ACTIONS(3900),
    [anon_sym_or] = ACTIONS(3900),
    [aux_sym_char_token1] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3900),
    [anon_sym_DQUOTE] = ACTIONS(3900),
    [anon_sym_AT_DQUOTE] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3898),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3900),
    [sym_op_identifier] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(3900),
    [anon_sym_DASH] = ACTIONS(3900),
    [anon_sym_PLUS_DOT] = ACTIONS(3900),
    [anon_sym_DASH_DOT] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(3900),
    [anon_sym_AMP_AMP] = ACTIONS(3900),
    [anon_sym_TILDE] = ACTIONS(3898),
    [aux_sym_prefix_op_token1] = ACTIONS(3900),
    [aux_sym_infix_op_token1] = ACTIONS(3898),
    [aux_sym_infix_op_token2] = ACTIONS(3900),
    [anon_sym_PIPE_PIPE] = ACTIONS(3900),
    [anon_sym_BANG_EQ] = ACTIONS(3900),
    [anon_sym_COLON_EQ] = ACTIONS(3898),
    [anon_sym_DOLLAR] = ACTIONS(3900),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3900),
    [sym_int] = ACTIONS(3900),
    [sym_xint] = ACTIONS(3898),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3898),
    [sym__newline] = ACTIONS(3898),
  },
  [3276] = {
    [sym_block_comment] = STATE(3276),
    [sym_compiler_directive_decl] = STATE(3276),
    [sym_fsi_directive_decl] = STATE(3276),
    [sym_preproc_line] = STATE(3276),
    [sym_identifier] = ACTIONS(3907),
    [anon_sym_EQ] = ACTIONS(3905),
    [anon_sym_COLON] = ACTIONS(3907),
    [anon_sym_return] = ACTIONS(3907),
    [anon_sym_do] = ACTIONS(3907),
    [anon_sym_let] = ACTIONS(3907),
    [anon_sym_let_BANG] = ACTIONS(3905),
    [anon_sym_LPAREN] = ACTIONS(3907),
    [anon_sym_COMMA] = ACTIONS(3905),
    [anon_sym_null] = ACTIONS(3907),
    [anon_sym_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_COLON] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3907),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3905),
    [anon_sym_LBRACE] = ACTIONS(3907),
    [anon_sym_LT_AT] = ACTIONS(3907),
    [anon_sym_LT_AT_AT] = ACTIONS(3907),
    [anon_sym_DOT] = ACTIONS(3907),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3905),
    [anon_sym_new] = ACTIONS(3907),
    [anon_sym_return_BANG] = ACTIONS(3905),
    [anon_sym_yield] = ACTIONS(3907),
    [anon_sym_yield_BANG] = ACTIONS(3905),
    [anon_sym_lazy] = ACTIONS(3907),
    [anon_sym_assert] = ACTIONS(3907),
    [anon_sym_upcast] = ACTIONS(3907),
    [anon_sym_downcast] = ACTIONS(3907),
    [anon_sym_COLON_GT] = ACTIONS(3905),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3905),
    [anon_sym_for] = ACTIONS(3907),
    [anon_sym_while] = ACTIONS(3907),
    [anon_sym_if] = ACTIONS(3907),
    [anon_sym_fun] = ACTIONS(3907),
    [anon_sym_try] = ACTIONS(3907),
    [anon_sym_match] = ACTIONS(3907),
    [anon_sym_match_BANG] = ACTIONS(3905),
    [anon_sym_function] = ACTIONS(3907),
    [anon_sym_LT_DASH] = ACTIONS(3907),
    [anon_sym_DOT_LBRACK] = ACTIONS(3905),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_use] = ACTIONS(3907),
    [anon_sym_use_BANG] = ACTIONS(3905),
    [anon_sym_do_BANG] = ACTIONS(3905),
    [anon_sym_DOT_DOT] = ACTIONS(3905),
    [anon_sym_begin] = ACTIONS(3907),
    [anon_sym_LPAREN2] = ACTIONS(3907),
    [anon_sym_or] = ACTIONS(3907),
    [aux_sym_char_token1] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3907),
    [anon_sym_DQUOTE] = ACTIONS(3907),
    [anon_sym_AT_DQUOTE] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [sym_bool] = ACTIONS(3907),
    [sym_unit] = ACTIONS(3905),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3907),
    [sym_op_identifier] = ACTIONS(3907),
    [anon_sym_PLUS] = ACTIONS(3907),
    [anon_sym_DASH] = ACTIONS(3907),
    [anon_sym_PLUS_DOT] = ACTIONS(3907),
    [anon_sym_DASH_DOT] = ACTIONS(3907),
    [anon_sym_PERCENT] = ACTIONS(3907),
    [anon_sym_AMP_AMP] = ACTIONS(3907),
    [anon_sym_TILDE] = ACTIONS(3905),
    [aux_sym_prefix_op_token1] = ACTIONS(3907),
    [aux_sym_infix_op_token1] = ACTIONS(3905),
    [aux_sym_infix_op_token2] = ACTIONS(3907),
    [anon_sym_PIPE_PIPE] = ACTIONS(3907),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_COLON_EQ] = ACTIONS(3905),
    [anon_sym_DOLLAR] = ACTIONS(3907),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3907),
    [sym_int] = ACTIONS(3907),
    [sym_xint] = ACTIONS(3905),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3905),
    [sym__newline] = ACTIONS(3905),
  },
  [3277] = {
    [sym_block_comment] = STATE(3277),
    [sym_compiler_directive_decl] = STATE(3277),
    [sym_fsi_directive_decl] = STATE(3277),
    [sym_preproc_line] = STATE(3277),
    [sym_identifier] = ACTIONS(3954),
    [anon_sym_EQ] = ACTIONS(3952),
    [anon_sym_COLON] = ACTIONS(3954),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_do] = ACTIONS(3954),
    [anon_sym_let] = ACTIONS(3954),
    [anon_sym_let_BANG] = ACTIONS(3952),
    [anon_sym_LPAREN] = ACTIONS(3954),
    [anon_sym_COMMA] = ACTIONS(3952),
    [anon_sym_null] = ACTIONS(3954),
    [anon_sym_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_COLON] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3954),
    [anon_sym_LBRACK] = ACTIONS(3954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(3954),
    [anon_sym_LT_AT] = ACTIONS(3954),
    [anon_sym_LT_AT_AT] = ACTIONS(3954),
    [anon_sym_DOT] = ACTIONS(3954),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3952),
    [anon_sym_new] = ACTIONS(3954),
    [anon_sym_return_BANG] = ACTIONS(3952),
    [anon_sym_yield] = ACTIONS(3954),
    [anon_sym_yield_BANG] = ACTIONS(3952),
    [anon_sym_lazy] = ACTIONS(3954),
    [anon_sym_assert] = ACTIONS(3954),
    [anon_sym_upcast] = ACTIONS(3954),
    [anon_sym_downcast] = ACTIONS(3954),
    [anon_sym_COLON_GT] = ACTIONS(3952),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3952),
    [anon_sym_for] = ACTIONS(3954),
    [anon_sym_while] = ACTIONS(3954),
    [anon_sym_if] = ACTIONS(3954),
    [anon_sym_fun] = ACTIONS(3954),
    [anon_sym_try] = ACTIONS(3954),
    [anon_sym_match] = ACTIONS(3954),
    [anon_sym_match_BANG] = ACTIONS(3952),
    [anon_sym_function] = ACTIONS(3954),
    [anon_sym_LT_DASH] = ACTIONS(3954),
    [anon_sym_DOT_LBRACK] = ACTIONS(3952),
    [anon_sym_LT] = ACTIONS(3952),
    [anon_sym_use] = ACTIONS(3954),
    [anon_sym_use_BANG] = ACTIONS(3952),
    [anon_sym_do_BANG] = ACTIONS(3952),
    [anon_sym_DOT_DOT] = ACTIONS(3952),
    [anon_sym_begin] = ACTIONS(3954),
    [anon_sym_LPAREN2] = ACTIONS(3954),
    [anon_sym_or] = ACTIONS(3954),
    [aux_sym_char_token1] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3954),
    [anon_sym_DQUOTE] = ACTIONS(3954),
    [anon_sym_AT_DQUOTE] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [sym_bool] = ACTIONS(3954),
    [sym_unit] = ACTIONS(3952),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3954),
    [sym_op_identifier] = ACTIONS(3954),
    [anon_sym_PLUS] = ACTIONS(3954),
    [anon_sym_DASH] = ACTIONS(3954),
    [anon_sym_PLUS_DOT] = ACTIONS(3954),
    [anon_sym_DASH_DOT] = ACTIONS(3954),
    [anon_sym_PERCENT] = ACTIONS(3954),
    [anon_sym_AMP_AMP] = ACTIONS(3954),
    [anon_sym_TILDE] = ACTIONS(3952),
    [aux_sym_prefix_op_token1] = ACTIONS(3954),
    [aux_sym_infix_op_token1] = ACTIONS(3952),
    [aux_sym_infix_op_token2] = ACTIONS(3954),
    [anon_sym_PIPE_PIPE] = ACTIONS(3954),
    [anon_sym_BANG_EQ] = ACTIONS(3954),
    [anon_sym_COLON_EQ] = ACTIONS(3952),
    [anon_sym_DOLLAR] = ACTIONS(3954),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3954),
    [sym_int] = ACTIONS(3954),
    [sym_xint] = ACTIONS(3952),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3952),
    [sym__newline] = ACTIONS(3952),
  },
  [3278] = {
    [sym_block_comment] = STATE(3278),
    [sym_compiler_directive_decl] = STATE(3278),
    [sym_fsi_directive_decl] = STATE(3278),
    [sym_preproc_line] = STATE(3278),
    [sym_identifier] = ACTIONS(4197),
    [anon_sym_EQ] = ACTIONS(4195),
    [anon_sym_COLON] = ACTIONS(4197),
    [anon_sym_return] = ACTIONS(4197),
    [anon_sym_do] = ACTIONS(4197),
    [anon_sym_let] = ACTIONS(4197),
    [anon_sym_let_BANG] = ACTIONS(4195),
    [anon_sym_LPAREN] = ACTIONS(4197),
    [anon_sym_COMMA] = ACTIONS(4195),
    [anon_sym_null] = ACTIONS(4197),
    [anon_sym_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_COLON] = ACTIONS(4195),
    [anon_sym_AMP] = ACTIONS(4197),
    [anon_sym_LBRACK] = ACTIONS(4197),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4195),
    [anon_sym_LBRACE] = ACTIONS(4197),
    [anon_sym_LT_AT] = ACTIONS(4197),
    [anon_sym_LT_AT_AT] = ACTIONS(4197),
    [anon_sym_DOT] = ACTIONS(4197),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4195),
    [anon_sym_new] = ACTIONS(4197),
    [anon_sym_return_BANG] = ACTIONS(4195),
    [anon_sym_yield] = ACTIONS(4197),
    [anon_sym_yield_BANG] = ACTIONS(4195),
    [anon_sym_lazy] = ACTIONS(4197),
    [anon_sym_assert] = ACTIONS(4197),
    [anon_sym_upcast] = ACTIONS(4197),
    [anon_sym_downcast] = ACTIONS(4197),
    [anon_sym_COLON_GT] = ACTIONS(4195),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4195),
    [anon_sym_for] = ACTIONS(4197),
    [anon_sym_while] = ACTIONS(4197),
    [anon_sym_if] = ACTIONS(4197),
    [anon_sym_fun] = ACTIONS(4197),
    [anon_sym_try] = ACTIONS(4197),
    [anon_sym_match] = ACTIONS(4197),
    [anon_sym_match_BANG] = ACTIONS(4195),
    [anon_sym_function] = ACTIONS(4197),
    [anon_sym_LT_DASH] = ACTIONS(4197),
    [anon_sym_DOT_LBRACK] = ACTIONS(4195),
    [anon_sym_LT] = ACTIONS(4195),
    [anon_sym_GT] = ACTIONS(4197),
    [anon_sym_use] = ACTIONS(4197),
    [anon_sym_use_BANG] = ACTIONS(4195),
    [anon_sym_do_BANG] = ACTIONS(4195),
    [anon_sym_begin] = ACTIONS(4197),
    [anon_sym_LPAREN2] = ACTIONS(4197),
    [anon_sym_or] = ACTIONS(4197),
    [aux_sym_char_token1] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4197),
    [anon_sym_DQUOTE] = ACTIONS(4197),
    [anon_sym_AT_DQUOTE] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [sym_bool] = ACTIONS(4197),
    [sym_unit] = ACTIONS(4195),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4197),
    [sym_op_identifier] = ACTIONS(4197),
    [anon_sym_PLUS] = ACTIONS(4197),
    [anon_sym_DASH] = ACTIONS(4197),
    [anon_sym_PLUS_DOT] = ACTIONS(4197),
    [anon_sym_DASH_DOT] = ACTIONS(4197),
    [anon_sym_PERCENT] = ACTIONS(4197),
    [anon_sym_AMP_AMP] = ACTIONS(4197),
    [anon_sym_TILDE] = ACTIONS(4195),
    [aux_sym_prefix_op_token1] = ACTIONS(4197),
    [aux_sym_infix_op_token1] = ACTIONS(4195),
    [aux_sym_infix_op_token2] = ACTIONS(4197),
    [anon_sym_PIPE_PIPE] = ACTIONS(4197),
    [anon_sym_BANG_EQ] = ACTIONS(4197),
    [anon_sym_COLON_EQ] = ACTIONS(4195),
    [anon_sym_DOLLAR] = ACTIONS(4197),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4197),
    [sym_int] = ACTIONS(4197),
    [sym_xint] = ACTIONS(4195),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4195),
    [sym__newline] = ACTIONS(4195),
  },
  [3279] = {
    [sym_block_comment] = STATE(3279),
    [sym_compiler_directive_decl] = STATE(3279),
    [sym_fsi_directive_decl] = STATE(3279),
    [sym_preproc_line] = STATE(3279),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_EQ] = ACTIONS(4199),
    [anon_sym_COLON] = ACTIONS(4201),
    [anon_sym_return] = ACTIONS(4201),
    [anon_sym_do] = ACTIONS(4201),
    [anon_sym_let] = ACTIONS(4201),
    [anon_sym_let_BANG] = ACTIONS(4199),
    [anon_sym_LPAREN] = ACTIONS(4201),
    [anon_sym_COMMA] = ACTIONS(4199),
    [anon_sym_null] = ACTIONS(4201),
    [anon_sym_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(4199),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_LBRACK] = ACTIONS(4201),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4199),
    [anon_sym_LBRACE] = ACTIONS(4201),
    [anon_sym_LT_AT] = ACTIONS(4201),
    [anon_sym_LT_AT_AT] = ACTIONS(4201),
    [anon_sym_DOT] = ACTIONS(4201),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4199),
    [anon_sym_new] = ACTIONS(4201),
    [anon_sym_return_BANG] = ACTIONS(4199),
    [anon_sym_yield] = ACTIONS(4201),
    [anon_sym_yield_BANG] = ACTIONS(4199),
    [anon_sym_lazy] = ACTIONS(4201),
    [anon_sym_assert] = ACTIONS(4201),
    [anon_sym_upcast] = ACTIONS(4201),
    [anon_sym_downcast] = ACTIONS(4201),
    [anon_sym_COLON_GT] = ACTIONS(4199),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4199),
    [anon_sym_for] = ACTIONS(4201),
    [anon_sym_while] = ACTIONS(4201),
    [anon_sym_if] = ACTIONS(4201),
    [anon_sym_fun] = ACTIONS(4201),
    [anon_sym_try] = ACTIONS(4201),
    [anon_sym_match] = ACTIONS(4201),
    [anon_sym_match_BANG] = ACTIONS(4199),
    [anon_sym_function] = ACTIONS(4201),
    [anon_sym_LT_DASH] = ACTIONS(4201),
    [anon_sym_DOT_LBRACK] = ACTIONS(4199),
    [anon_sym_LT] = ACTIONS(4199),
    [anon_sym_GT] = ACTIONS(4201),
    [anon_sym_use] = ACTIONS(4201),
    [anon_sym_use_BANG] = ACTIONS(4199),
    [anon_sym_do_BANG] = ACTIONS(4199),
    [anon_sym_begin] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(4201),
    [anon_sym_or] = ACTIONS(4201),
    [aux_sym_char_token1] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4201),
    [anon_sym_DQUOTE] = ACTIONS(4201),
    [anon_sym_AT_DQUOTE] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [sym_bool] = ACTIONS(4201),
    [sym_unit] = ACTIONS(4199),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4201),
    [sym_op_identifier] = ACTIONS(4201),
    [anon_sym_PLUS] = ACTIONS(4201),
    [anon_sym_DASH] = ACTIONS(4201),
    [anon_sym_PLUS_DOT] = ACTIONS(4201),
    [anon_sym_DASH_DOT] = ACTIONS(4201),
    [anon_sym_PERCENT] = ACTIONS(4201),
    [anon_sym_AMP_AMP] = ACTIONS(4201),
    [anon_sym_TILDE] = ACTIONS(4199),
    [aux_sym_prefix_op_token1] = ACTIONS(4201),
    [aux_sym_infix_op_token1] = ACTIONS(4199),
    [aux_sym_infix_op_token2] = ACTIONS(4201),
    [anon_sym_PIPE_PIPE] = ACTIONS(4201),
    [anon_sym_BANG_EQ] = ACTIONS(4201),
    [anon_sym_COLON_EQ] = ACTIONS(4199),
    [anon_sym_DOLLAR] = ACTIONS(4201),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4201),
    [sym_int] = ACTIONS(4201),
    [sym_xint] = ACTIONS(4199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4199),
    [sym__newline] = ACTIONS(4199),
  },
  [3280] = {
    [sym_block_comment] = STATE(3280),
    [sym_compiler_directive_decl] = STATE(3280),
    [sym_fsi_directive_decl] = STATE(3280),
    [sym_preproc_line] = STATE(3280),
    [sym_identifier] = ACTIONS(3917),
    [anon_sym_EQ] = ACTIONS(3915),
    [anon_sym_COLON] = ACTIONS(3917),
    [anon_sym_return] = ACTIONS(3917),
    [anon_sym_do] = ACTIONS(3917),
    [anon_sym_let] = ACTIONS(3917),
    [anon_sym_let_BANG] = ACTIONS(3915),
    [anon_sym_LPAREN] = ACTIONS(3917),
    [anon_sym_COMMA] = ACTIONS(3915),
    [anon_sym_null] = ACTIONS(3917),
    [anon_sym_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_COLON] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(3917),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3915),
    [anon_sym_LBRACE] = ACTIONS(3917),
    [anon_sym_LT_AT] = ACTIONS(3917),
    [anon_sym_LT_AT_AT] = ACTIONS(3917),
    [anon_sym_DOT] = ACTIONS(3917),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3915),
    [anon_sym_new] = ACTIONS(3917),
    [anon_sym_return_BANG] = ACTIONS(3915),
    [anon_sym_yield] = ACTIONS(3917),
    [anon_sym_yield_BANG] = ACTIONS(3915),
    [anon_sym_lazy] = ACTIONS(3917),
    [anon_sym_assert] = ACTIONS(3917),
    [anon_sym_upcast] = ACTIONS(3917),
    [anon_sym_downcast] = ACTIONS(3917),
    [anon_sym_COLON_GT] = ACTIONS(3915),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3915),
    [anon_sym_for] = ACTIONS(3917),
    [anon_sym_while] = ACTIONS(3917),
    [anon_sym_if] = ACTIONS(3917),
    [anon_sym_fun] = ACTIONS(3917),
    [anon_sym_try] = ACTIONS(3917),
    [anon_sym_match] = ACTIONS(3917),
    [anon_sym_match_BANG] = ACTIONS(3915),
    [anon_sym_function] = ACTIONS(3917),
    [anon_sym_LT_DASH] = ACTIONS(3917),
    [anon_sym_DOT_LBRACK] = ACTIONS(3915),
    [anon_sym_LT] = ACTIONS(3915),
    [anon_sym_use] = ACTIONS(3917),
    [anon_sym_use_BANG] = ACTIONS(3915),
    [anon_sym_do_BANG] = ACTIONS(3915),
    [anon_sym_DOT_DOT] = ACTIONS(3915),
    [anon_sym_begin] = ACTIONS(3917),
    [anon_sym_LPAREN2] = ACTIONS(3917),
    [anon_sym_or] = ACTIONS(3917),
    [aux_sym_char_token1] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_AT_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [sym_bool] = ACTIONS(3917),
    [sym_unit] = ACTIONS(3915),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3917),
    [sym_op_identifier] = ACTIONS(3917),
    [anon_sym_PLUS] = ACTIONS(3917),
    [anon_sym_DASH] = ACTIONS(3917),
    [anon_sym_PLUS_DOT] = ACTIONS(3917),
    [anon_sym_DASH_DOT] = ACTIONS(3917),
    [anon_sym_PERCENT] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_TILDE] = ACTIONS(3915),
    [aux_sym_prefix_op_token1] = ACTIONS(3917),
    [aux_sym_infix_op_token1] = ACTIONS(3915),
    [aux_sym_infix_op_token2] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_BANG_EQ] = ACTIONS(3917),
    [anon_sym_COLON_EQ] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3917),
    [sym_int] = ACTIONS(3917),
    [sym_xint] = ACTIONS(3915),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3915),
    [sym__newline] = ACTIONS(3915),
  },
  [3281] = {
    [sym_block_comment] = STATE(3281),
    [sym_compiler_directive_decl] = STATE(3281),
    [sym_fsi_directive_decl] = STATE(3281),
    [sym_preproc_line] = STATE(3281),
    [sym_identifier] = ACTIONS(3931),
    [anon_sym_EQ] = ACTIONS(3929),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_do] = ACTIONS(3931),
    [anon_sym_let] = ACTIONS(3931),
    [anon_sym_let_BANG] = ACTIONS(3929),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_COMMA] = ACTIONS(3929),
    [anon_sym_null] = ACTIONS(3931),
    [anon_sym_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_COLON] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3931),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_LT_AT] = ACTIONS(3931),
    [anon_sym_LT_AT_AT] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3931),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3929),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_return_BANG] = ACTIONS(3929),
    [anon_sym_yield] = ACTIONS(3931),
    [anon_sym_yield_BANG] = ACTIONS(3929),
    [anon_sym_lazy] = ACTIONS(3931),
    [anon_sym_assert] = ACTIONS(3931),
    [anon_sym_upcast] = ACTIONS(3931),
    [anon_sym_downcast] = ACTIONS(3931),
    [anon_sym_COLON_GT] = ACTIONS(3929),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3929),
    [anon_sym_for] = ACTIONS(3931),
    [anon_sym_while] = ACTIONS(3931),
    [anon_sym_if] = ACTIONS(3931),
    [anon_sym_fun] = ACTIONS(3931),
    [anon_sym_try] = ACTIONS(3931),
    [anon_sym_match] = ACTIONS(3931),
    [anon_sym_match_BANG] = ACTIONS(3929),
    [anon_sym_function] = ACTIONS(3931),
    [anon_sym_LT_DASH] = ACTIONS(3931),
    [anon_sym_DOT_LBRACK] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_use] = ACTIONS(3931),
    [anon_sym_use_BANG] = ACTIONS(3929),
    [anon_sym_do_BANG] = ACTIONS(3929),
    [anon_sym_DOT_DOT] = ACTIONS(3929),
    [anon_sym_begin] = ACTIONS(3931),
    [anon_sym_LPAREN2] = ACTIONS(3931),
    [anon_sym_or] = ACTIONS(3931),
    [aux_sym_char_token1] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3931),
    [anon_sym_DQUOTE] = ACTIONS(3931),
    [anon_sym_AT_DQUOTE] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [sym_bool] = ACTIONS(3931),
    [sym_unit] = ACTIONS(3929),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3931),
    [sym_op_identifier] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3931),
    [anon_sym_DASH] = ACTIONS(3931),
    [anon_sym_PLUS_DOT] = ACTIONS(3931),
    [anon_sym_DASH_DOT] = ACTIONS(3931),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_TILDE] = ACTIONS(3929),
    [aux_sym_prefix_op_token1] = ACTIONS(3931),
    [aux_sym_infix_op_token1] = ACTIONS(3929),
    [aux_sym_infix_op_token2] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_COLON_EQ] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3931),
    [sym_int] = ACTIONS(3931),
    [sym_xint] = ACTIONS(3929),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3929),
    [sym__newline] = ACTIONS(3929),
  },
  [3282] = {
    [sym_block_comment] = STATE(3282),
    [sym_compiler_directive_decl] = STATE(3282),
    [sym_fsi_directive_decl] = STATE(3282),
    [sym_preproc_line] = STATE(3282),
    [sym_identifier] = ACTIONS(4216),
    [anon_sym_EQ] = ACTIONS(4214),
    [anon_sym_COLON] = ACTIONS(4216),
    [anon_sym_return] = ACTIONS(4216),
    [anon_sym_do] = ACTIONS(4216),
    [anon_sym_let] = ACTIONS(4216),
    [anon_sym_let_BANG] = ACTIONS(4214),
    [anon_sym_LPAREN] = ACTIONS(4216),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_null] = ACTIONS(4216),
    [anon_sym_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_COLON] = ACTIONS(4214),
    [anon_sym_AMP] = ACTIONS(4216),
    [anon_sym_LBRACK] = ACTIONS(4216),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4214),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_LT_AT] = ACTIONS(4216),
    [anon_sym_LT_AT_AT] = ACTIONS(4216),
    [anon_sym_DOT] = ACTIONS(4216),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4214),
    [anon_sym_new] = ACTIONS(4216),
    [anon_sym_return_BANG] = ACTIONS(4214),
    [anon_sym_yield] = ACTIONS(4216),
    [anon_sym_yield_BANG] = ACTIONS(4214),
    [anon_sym_lazy] = ACTIONS(4216),
    [anon_sym_assert] = ACTIONS(4216),
    [anon_sym_upcast] = ACTIONS(4216),
    [anon_sym_downcast] = ACTIONS(4216),
    [anon_sym_COLON_GT] = ACTIONS(4214),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4214),
    [anon_sym_for] = ACTIONS(4216),
    [anon_sym_while] = ACTIONS(4216),
    [anon_sym_if] = ACTIONS(4216),
    [anon_sym_fun] = ACTIONS(4216),
    [anon_sym_try] = ACTIONS(4216),
    [anon_sym_match] = ACTIONS(4216),
    [anon_sym_match_BANG] = ACTIONS(4214),
    [anon_sym_function] = ACTIONS(4216),
    [anon_sym_LT_DASH] = ACTIONS(4216),
    [anon_sym_DOT_LBRACK] = ACTIONS(4214),
    [anon_sym_LT] = ACTIONS(4214),
    [anon_sym_GT] = ACTIONS(4216),
    [anon_sym_use] = ACTIONS(4216),
    [anon_sym_use_BANG] = ACTIONS(4214),
    [anon_sym_do_BANG] = ACTIONS(4214),
    [anon_sym_begin] = ACTIONS(4216),
    [anon_sym_LPAREN2] = ACTIONS(4216),
    [anon_sym_or] = ACTIONS(4216),
    [aux_sym_char_token1] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4216),
    [anon_sym_DQUOTE] = ACTIONS(4216),
    [anon_sym_AT_DQUOTE] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [sym_bool] = ACTIONS(4216),
    [sym_unit] = ACTIONS(4214),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4216),
    [sym_op_identifier] = ACTIONS(4216),
    [anon_sym_PLUS] = ACTIONS(4216),
    [anon_sym_DASH] = ACTIONS(4216),
    [anon_sym_PLUS_DOT] = ACTIONS(4216),
    [anon_sym_DASH_DOT] = ACTIONS(4216),
    [anon_sym_PERCENT] = ACTIONS(4216),
    [anon_sym_AMP_AMP] = ACTIONS(4216),
    [anon_sym_TILDE] = ACTIONS(4214),
    [aux_sym_prefix_op_token1] = ACTIONS(4216),
    [aux_sym_infix_op_token1] = ACTIONS(4214),
    [aux_sym_infix_op_token2] = ACTIONS(4216),
    [anon_sym_PIPE_PIPE] = ACTIONS(4216),
    [anon_sym_BANG_EQ] = ACTIONS(4216),
    [anon_sym_COLON_EQ] = ACTIONS(4214),
    [anon_sym_DOLLAR] = ACTIONS(4216),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4216),
    [sym_int] = ACTIONS(4216),
    [sym_xint] = ACTIONS(4214),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4214),
    [sym__newline] = ACTIONS(4214),
  },
  [3283] = {
    [sym_block_comment] = STATE(3283),
    [sym_compiler_directive_decl] = STATE(3283),
    [sym_fsi_directive_decl] = STATE(3283),
    [sym_preproc_line] = STATE(3283),
    [sym_identifier] = ACTIONS(3942),
    [anon_sym_EQ] = ACTIONS(3940),
    [anon_sym_COLON] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_let_BANG] = ACTIONS(3940),
    [anon_sym_LPAREN] = ACTIONS(3942),
    [anon_sym_COMMA] = ACTIONS(3940),
    [anon_sym_null] = ACTIONS(3942),
    [anon_sym_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3940),
    [anon_sym_LBRACE] = ACTIONS(3942),
    [anon_sym_LT_AT] = ACTIONS(3942),
    [anon_sym_LT_AT_AT] = ACTIONS(3942),
    [anon_sym_DOT] = ACTIONS(3942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3940),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_return_BANG] = ACTIONS(3940),
    [anon_sym_yield] = ACTIONS(3942),
    [anon_sym_yield_BANG] = ACTIONS(3940),
    [anon_sym_lazy] = ACTIONS(3942),
    [anon_sym_assert] = ACTIONS(3942),
    [anon_sym_upcast] = ACTIONS(3942),
    [anon_sym_downcast] = ACTIONS(3942),
    [anon_sym_COLON_GT] = ACTIONS(3940),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3940),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_fun] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_match] = ACTIONS(3942),
    [anon_sym_match_BANG] = ACTIONS(3940),
    [anon_sym_function] = ACTIONS(3942),
    [anon_sym_LT_DASH] = ACTIONS(3942),
    [anon_sym_DOT_LBRACK] = ACTIONS(3940),
    [anon_sym_LT] = ACTIONS(3940),
    [anon_sym_use] = ACTIONS(3942),
    [anon_sym_use_BANG] = ACTIONS(3940),
    [anon_sym_do_BANG] = ACTIONS(3940),
    [anon_sym_DOT_DOT] = ACTIONS(3940),
    [anon_sym_begin] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3942),
    [anon_sym_or] = ACTIONS(3942),
    [aux_sym_char_token1] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3942),
    [anon_sym_DQUOTE] = ACTIONS(3942),
    [anon_sym_AT_DQUOTE] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [sym_bool] = ACTIONS(3942),
    [sym_unit] = ACTIONS(3940),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3942),
    [sym_op_identifier] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS_DOT] = ACTIONS(3942),
    [anon_sym_DASH_DOT] = ACTIONS(3942),
    [anon_sym_PERCENT] = ACTIONS(3942),
    [anon_sym_AMP_AMP] = ACTIONS(3942),
    [anon_sym_TILDE] = ACTIONS(3940),
    [aux_sym_prefix_op_token1] = ACTIONS(3942),
    [aux_sym_infix_op_token1] = ACTIONS(3940),
    [aux_sym_infix_op_token2] = ACTIONS(3942),
    [anon_sym_PIPE_PIPE] = ACTIONS(3942),
    [anon_sym_BANG_EQ] = ACTIONS(3942),
    [anon_sym_COLON_EQ] = ACTIONS(3940),
    [anon_sym_DOLLAR] = ACTIONS(3942),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3942),
    [sym_int] = ACTIONS(3942),
    [sym_xint] = ACTIONS(3940),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3940),
    [sym__newline] = ACTIONS(3940),
  },
  [3284] = {
    [sym_block_comment] = STATE(3284),
    [sym_compiler_directive_decl] = STATE(3284),
    [sym_fsi_directive_decl] = STATE(3284),
    [sym_preproc_line] = STATE(3284),
    [sym_identifier] = ACTIONS(3966),
    [anon_sym_EQ] = ACTIONS(3964),
    [anon_sym_COLON] = ACTIONS(3966),
    [anon_sym_return] = ACTIONS(3966),
    [anon_sym_do] = ACTIONS(3966),
    [anon_sym_let] = ACTIONS(3966),
    [anon_sym_let_BANG] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COMMA] = ACTIONS(3964),
    [anon_sym_null] = ACTIONS(3966),
    [anon_sym_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(3964),
    [anon_sym_AMP] = ACTIONS(3966),
    [anon_sym_LBRACK] = ACTIONS(3966),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3964),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_LT_AT] = ACTIONS(3966),
    [anon_sym_LT_AT_AT] = ACTIONS(3966),
    [anon_sym_DOT] = ACTIONS(3966),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3964),
    [anon_sym_new] = ACTIONS(3966),
    [anon_sym_return_BANG] = ACTIONS(3964),
    [anon_sym_yield] = ACTIONS(3966),
    [anon_sym_yield_BANG] = ACTIONS(3964),
    [anon_sym_lazy] = ACTIONS(3966),
    [anon_sym_assert] = ACTIONS(3966),
    [anon_sym_upcast] = ACTIONS(3966),
    [anon_sym_downcast] = ACTIONS(3966),
    [anon_sym_COLON_GT] = ACTIONS(3964),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3964),
    [anon_sym_for] = ACTIONS(3966),
    [anon_sym_while] = ACTIONS(3966),
    [anon_sym_if] = ACTIONS(3966),
    [anon_sym_fun] = ACTIONS(3966),
    [anon_sym_try] = ACTIONS(3966),
    [anon_sym_match] = ACTIONS(3966),
    [anon_sym_match_BANG] = ACTIONS(3964),
    [anon_sym_function] = ACTIONS(3966),
    [anon_sym_LT_DASH] = ACTIONS(3966),
    [anon_sym_DOT_LBRACK] = ACTIONS(3964),
    [anon_sym_LT] = ACTIONS(3964),
    [anon_sym_use] = ACTIONS(3966),
    [anon_sym_use_BANG] = ACTIONS(3964),
    [anon_sym_do_BANG] = ACTIONS(3964),
    [anon_sym_DOT_DOT] = ACTIONS(3964),
    [anon_sym_begin] = ACTIONS(3966),
    [anon_sym_LPAREN2] = ACTIONS(3966),
    [anon_sym_or] = ACTIONS(3966),
    [aux_sym_char_token1] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3966),
    [anon_sym_DQUOTE] = ACTIONS(3966),
    [anon_sym_AT_DQUOTE] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [sym_bool] = ACTIONS(3966),
    [sym_unit] = ACTIONS(3964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3966),
    [sym_op_identifier] = ACTIONS(3966),
    [anon_sym_PLUS] = ACTIONS(3966),
    [anon_sym_DASH] = ACTIONS(3966),
    [anon_sym_PLUS_DOT] = ACTIONS(3966),
    [anon_sym_DASH_DOT] = ACTIONS(3966),
    [anon_sym_PERCENT] = ACTIONS(3966),
    [anon_sym_AMP_AMP] = ACTIONS(3966),
    [anon_sym_TILDE] = ACTIONS(3964),
    [aux_sym_prefix_op_token1] = ACTIONS(3966),
    [aux_sym_infix_op_token1] = ACTIONS(3964),
    [aux_sym_infix_op_token2] = ACTIONS(3966),
    [anon_sym_PIPE_PIPE] = ACTIONS(3966),
    [anon_sym_BANG_EQ] = ACTIONS(3966),
    [anon_sym_COLON_EQ] = ACTIONS(3964),
    [anon_sym_DOLLAR] = ACTIONS(3966),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3966),
    [sym_int] = ACTIONS(3966),
    [sym_xint] = ACTIONS(3964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3964),
    [sym__newline] = ACTIONS(3964),
  },
  [3285] = {
    [sym_block_comment] = STATE(3285),
    [sym_compiler_directive_decl] = STATE(3285),
    [sym_fsi_directive_decl] = STATE(3285),
    [sym_preproc_line] = STATE(3285),
    [sym_identifier] = ACTIONS(4220),
    [anon_sym_EQ] = ACTIONS(4218),
    [anon_sym_COLON] = ACTIONS(4220),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_do] = ACTIONS(4220),
    [anon_sym_let] = ACTIONS(4220),
    [anon_sym_let_BANG] = ACTIONS(4218),
    [anon_sym_LPAREN] = ACTIONS(4220),
    [anon_sym_COMMA] = ACTIONS(4218),
    [anon_sym_null] = ACTIONS(4220),
    [anon_sym_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_COLON] = ACTIONS(4218),
    [anon_sym_AMP] = ACTIONS(4220),
    [anon_sym_LBRACK] = ACTIONS(4220),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(4220),
    [anon_sym_LT_AT] = ACTIONS(4220),
    [anon_sym_LT_AT_AT] = ACTIONS(4220),
    [anon_sym_DOT] = ACTIONS(4220),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4218),
    [anon_sym_new] = ACTIONS(4220),
    [anon_sym_return_BANG] = ACTIONS(4218),
    [anon_sym_yield] = ACTIONS(4220),
    [anon_sym_yield_BANG] = ACTIONS(4218),
    [anon_sym_lazy] = ACTIONS(4220),
    [anon_sym_assert] = ACTIONS(4220),
    [anon_sym_upcast] = ACTIONS(4220),
    [anon_sym_downcast] = ACTIONS(4220),
    [anon_sym_COLON_GT] = ACTIONS(4218),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4218),
    [anon_sym_for] = ACTIONS(4220),
    [anon_sym_while] = ACTIONS(4220),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_fun] = ACTIONS(4220),
    [anon_sym_try] = ACTIONS(4220),
    [anon_sym_match] = ACTIONS(4220),
    [anon_sym_match_BANG] = ACTIONS(4218),
    [anon_sym_function] = ACTIONS(4220),
    [anon_sym_LT_DASH] = ACTIONS(4220),
    [anon_sym_DOT_LBRACK] = ACTIONS(4218),
    [anon_sym_LT] = ACTIONS(4218),
    [anon_sym_GT] = ACTIONS(4220),
    [anon_sym_use] = ACTIONS(4220),
    [anon_sym_use_BANG] = ACTIONS(4218),
    [anon_sym_do_BANG] = ACTIONS(4218),
    [anon_sym_begin] = ACTIONS(4220),
    [anon_sym_LPAREN2] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(4220),
    [aux_sym_char_token1] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4220),
    [anon_sym_DQUOTE] = ACTIONS(4220),
    [anon_sym_AT_DQUOTE] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [sym_bool] = ACTIONS(4220),
    [sym_unit] = ACTIONS(4218),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4220),
    [sym_op_identifier] = ACTIONS(4220),
    [anon_sym_PLUS] = ACTIONS(4220),
    [anon_sym_DASH] = ACTIONS(4220),
    [anon_sym_PLUS_DOT] = ACTIONS(4220),
    [anon_sym_DASH_DOT] = ACTIONS(4220),
    [anon_sym_PERCENT] = ACTIONS(4220),
    [anon_sym_AMP_AMP] = ACTIONS(4220),
    [anon_sym_TILDE] = ACTIONS(4218),
    [aux_sym_prefix_op_token1] = ACTIONS(4220),
    [aux_sym_infix_op_token1] = ACTIONS(4218),
    [aux_sym_infix_op_token2] = ACTIONS(4220),
    [anon_sym_PIPE_PIPE] = ACTIONS(4220),
    [anon_sym_BANG_EQ] = ACTIONS(4220),
    [anon_sym_COLON_EQ] = ACTIONS(4218),
    [anon_sym_DOLLAR] = ACTIONS(4220),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4220),
    [sym_int] = ACTIONS(4220),
    [sym_xint] = ACTIONS(4218),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4218),
    [sym__newline] = ACTIONS(4218),
  },
  [3286] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(4261),
    [sym_function_declaration_left] = STATE(9897),
    [sym_value_declaration_left] = STATE(9897),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3286),
    [sym_compiler_directive_decl] = STATE(3286),
    [sym_fsi_directive_decl] = STATE(3286),
    [sym_preproc_line] = STATE(3286),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_rec] = ACTIONS(5831),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3287] = {
    [sym_block_comment] = STATE(3287),
    [sym_compiler_directive_decl] = STATE(3287),
    [sym_fsi_directive_decl] = STATE(3287),
    [sym_preproc_line] = STATE(3287),
    [sym_identifier] = ACTIONS(3980),
    [anon_sym_EQ] = ACTIONS(3978),
    [anon_sym_COLON] = ACTIONS(3980),
    [anon_sym_return] = ACTIONS(3980),
    [anon_sym_do] = ACTIONS(3980),
    [anon_sym_let] = ACTIONS(3980),
    [anon_sym_let_BANG] = ACTIONS(3978),
    [anon_sym_LPAREN] = ACTIONS(3980),
    [anon_sym_COMMA] = ACTIONS(3978),
    [anon_sym_null] = ACTIONS(3980),
    [anon_sym_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3978),
    [anon_sym_AMP] = ACTIONS(3980),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3978),
    [anon_sym_LBRACE] = ACTIONS(3980),
    [anon_sym_LT_AT] = ACTIONS(3980),
    [anon_sym_LT_AT_AT] = ACTIONS(3980),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3978),
    [anon_sym_new] = ACTIONS(3980),
    [anon_sym_return_BANG] = ACTIONS(3978),
    [anon_sym_yield] = ACTIONS(3980),
    [anon_sym_yield_BANG] = ACTIONS(3978),
    [anon_sym_lazy] = ACTIONS(3980),
    [anon_sym_assert] = ACTIONS(3980),
    [anon_sym_upcast] = ACTIONS(3980),
    [anon_sym_downcast] = ACTIONS(3980),
    [anon_sym_COLON_GT] = ACTIONS(3978),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3978),
    [anon_sym_for] = ACTIONS(3980),
    [anon_sym_while] = ACTIONS(3980),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_fun] = ACTIONS(3980),
    [anon_sym_try] = ACTIONS(3980),
    [anon_sym_match] = ACTIONS(3980),
    [anon_sym_match_BANG] = ACTIONS(3978),
    [anon_sym_function] = ACTIONS(3980),
    [anon_sym_LT_DASH] = ACTIONS(3980),
    [anon_sym_DOT_LBRACK] = ACTIONS(3978),
    [anon_sym_LT] = ACTIONS(3978),
    [anon_sym_use] = ACTIONS(3980),
    [anon_sym_use_BANG] = ACTIONS(3978),
    [anon_sym_do_BANG] = ACTIONS(3978),
    [anon_sym_DOT_DOT] = ACTIONS(3978),
    [anon_sym_begin] = ACTIONS(3980),
    [anon_sym_LPAREN2] = ACTIONS(3980),
    [anon_sym_or] = ACTIONS(3980),
    [aux_sym_char_token1] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3980),
    [anon_sym_DQUOTE] = ACTIONS(3980),
    [anon_sym_AT_DQUOTE] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [sym_bool] = ACTIONS(3980),
    [sym_unit] = ACTIONS(3978),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3980),
    [sym_op_identifier] = ACTIONS(3980),
    [anon_sym_PLUS] = ACTIONS(3980),
    [anon_sym_DASH] = ACTIONS(3980),
    [anon_sym_PLUS_DOT] = ACTIONS(3980),
    [anon_sym_DASH_DOT] = ACTIONS(3980),
    [anon_sym_PERCENT] = ACTIONS(3980),
    [anon_sym_AMP_AMP] = ACTIONS(3980),
    [anon_sym_TILDE] = ACTIONS(3978),
    [aux_sym_prefix_op_token1] = ACTIONS(3980),
    [aux_sym_infix_op_token1] = ACTIONS(3978),
    [aux_sym_infix_op_token2] = ACTIONS(3980),
    [anon_sym_PIPE_PIPE] = ACTIONS(3980),
    [anon_sym_BANG_EQ] = ACTIONS(3980),
    [anon_sym_COLON_EQ] = ACTIONS(3978),
    [anon_sym_DOLLAR] = ACTIONS(3980),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3980),
    [sym_int] = ACTIONS(3980),
    [sym_xint] = ACTIONS(3978),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3978),
    [sym__newline] = ACTIONS(3978),
  },
  [3288] = {
    [sym_block_comment] = STATE(3288),
    [sym_compiler_directive_decl] = STATE(3288),
    [sym_fsi_directive_decl] = STATE(3288),
    [sym_preproc_line] = STATE(3288),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_COLON] = ACTIONS(3867),
    [anon_sym_return] = ACTIONS(3867),
    [anon_sym_do] = ACTIONS(3867),
    [anon_sym_let] = ACTIONS(3867),
    [anon_sym_let_BANG] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(3867),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_null] = ACTIONS(3867),
    [anon_sym_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_COLON] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3867),
    [anon_sym_LBRACK] = ACTIONS(3867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3867),
    [anon_sym_LT_AT] = ACTIONS(3867),
    [anon_sym_AT_GT] = ACTIONS(3867),
    [anon_sym_LT_AT_AT] = ACTIONS(3867),
    [anon_sym_DOT] = ACTIONS(3867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3867),
    [anon_sym_return_BANG] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3867),
    [anon_sym_yield_BANG] = ACTIONS(3865),
    [anon_sym_lazy] = ACTIONS(3867),
    [anon_sym_assert] = ACTIONS(3867),
    [anon_sym_upcast] = ACTIONS(3867),
    [anon_sym_downcast] = ACTIONS(3867),
    [anon_sym_COLON_GT] = ACTIONS(3865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3867),
    [anon_sym_while] = ACTIONS(3867),
    [anon_sym_if] = ACTIONS(3867),
    [anon_sym_fun] = ACTIONS(3867),
    [anon_sym_try] = ACTIONS(3867),
    [anon_sym_match] = ACTIONS(3867),
    [anon_sym_match_BANG] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(3867),
    [anon_sym_DOT_LBRACK] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_use] = ACTIONS(3867),
    [anon_sym_use_BANG] = ACTIONS(3865),
    [anon_sym_do_BANG] = ACTIONS(3865),
    [anon_sym_begin] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(3867),
    [anon_sym_or] = ACTIONS(3867),
    [aux_sym_char_token1] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3867),
    [anon_sym_DQUOTE] = ACTIONS(3867),
    [anon_sym_AT_DQUOTE] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [sym_bool] = ACTIONS(3867),
    [sym_unit] = ACTIONS(3865),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3867),
    [sym_op_identifier] = ACTIONS(3867),
    [anon_sym_PLUS] = ACTIONS(3867),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_PLUS_DOT] = ACTIONS(3867),
    [anon_sym_DASH_DOT] = ACTIONS(3867),
    [anon_sym_PERCENT] = ACTIONS(3867),
    [anon_sym_AMP_AMP] = ACTIONS(3867),
    [anon_sym_TILDE] = ACTIONS(3865),
    [aux_sym_prefix_op_token1] = ACTIONS(3867),
    [aux_sym_infix_op_token1] = ACTIONS(3865),
    [aux_sym_infix_op_token2] = ACTIONS(3867),
    [anon_sym_PIPE_PIPE] = ACTIONS(3867),
    [anon_sym_BANG_EQ] = ACTIONS(3867),
    [anon_sym_COLON_EQ] = ACTIONS(3865),
    [anon_sym_DOLLAR] = ACTIONS(3867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3867),
    [sym_int] = ACTIONS(3867),
    [sym_xint] = ACTIONS(3865),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3865),
    [sym__newline] = ACTIONS(3865),
  },
  [3289] = {
    [sym_block_comment] = STATE(3289),
    [sym_compiler_directive_decl] = STATE(3289),
    [sym_fsi_directive_decl] = STATE(3289),
    [sym_preproc_line] = STATE(3289),
    [sym_identifier] = ACTIONS(4011),
    [anon_sym_EQ] = ACTIONS(4009),
    [anon_sym_COLON] = ACTIONS(4011),
    [anon_sym_return] = ACTIONS(4011),
    [anon_sym_do] = ACTIONS(4011),
    [anon_sym_let] = ACTIONS(4011),
    [anon_sym_let_BANG] = ACTIONS(4009),
    [anon_sym_LPAREN] = ACTIONS(4011),
    [anon_sym_COMMA] = ACTIONS(4009),
    [anon_sym_null] = ACTIONS(4011),
    [anon_sym_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(4011),
    [anon_sym_LBRACK] = ACTIONS(4011),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4009),
    [anon_sym_LBRACE] = ACTIONS(4011),
    [anon_sym_LT_AT] = ACTIONS(4011),
    [anon_sym_AT_GT] = ACTIONS(4011),
    [anon_sym_LT_AT_AT] = ACTIONS(4011),
    [anon_sym_DOT] = ACTIONS(4011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4009),
    [anon_sym_new] = ACTIONS(4011),
    [anon_sym_return_BANG] = ACTIONS(4009),
    [anon_sym_yield] = ACTIONS(4011),
    [anon_sym_yield_BANG] = ACTIONS(4009),
    [anon_sym_lazy] = ACTIONS(4011),
    [anon_sym_assert] = ACTIONS(4011),
    [anon_sym_upcast] = ACTIONS(4011),
    [anon_sym_downcast] = ACTIONS(4011),
    [anon_sym_COLON_GT] = ACTIONS(4009),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4009),
    [anon_sym_for] = ACTIONS(4011),
    [anon_sym_while] = ACTIONS(4011),
    [anon_sym_if] = ACTIONS(4011),
    [anon_sym_fun] = ACTIONS(4011),
    [anon_sym_try] = ACTIONS(4011),
    [anon_sym_match] = ACTIONS(4011),
    [anon_sym_match_BANG] = ACTIONS(4009),
    [anon_sym_function] = ACTIONS(4011),
    [anon_sym_LT_DASH] = ACTIONS(4011),
    [anon_sym_DOT_LBRACK] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(4009),
    [anon_sym_use] = ACTIONS(4011),
    [anon_sym_use_BANG] = ACTIONS(4009),
    [anon_sym_do_BANG] = ACTIONS(4009),
    [anon_sym_begin] = ACTIONS(4011),
    [anon_sym_LPAREN2] = ACTIONS(4011),
    [anon_sym_or] = ACTIONS(4011),
    [aux_sym_char_token1] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4011),
    [anon_sym_DQUOTE] = ACTIONS(4011),
    [anon_sym_AT_DQUOTE] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [sym_bool] = ACTIONS(4011),
    [sym_unit] = ACTIONS(4009),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4011),
    [sym_op_identifier] = ACTIONS(4011),
    [anon_sym_PLUS] = ACTIONS(4011),
    [anon_sym_DASH] = ACTIONS(4011),
    [anon_sym_PLUS_DOT] = ACTIONS(4011),
    [anon_sym_DASH_DOT] = ACTIONS(4011),
    [anon_sym_PERCENT] = ACTIONS(4011),
    [anon_sym_AMP_AMP] = ACTIONS(4011),
    [anon_sym_TILDE] = ACTIONS(4009),
    [aux_sym_prefix_op_token1] = ACTIONS(4011),
    [aux_sym_infix_op_token1] = ACTIONS(4009),
    [aux_sym_infix_op_token2] = ACTIONS(4011),
    [anon_sym_PIPE_PIPE] = ACTIONS(4011),
    [anon_sym_BANG_EQ] = ACTIONS(4011),
    [anon_sym_COLON_EQ] = ACTIONS(4009),
    [anon_sym_DOLLAR] = ACTIONS(4011),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4011),
    [sym_int] = ACTIONS(4011),
    [sym_xint] = ACTIONS(4009),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4009),
    [sym__newline] = ACTIONS(4009),
  },
  [3290] = {
    [sym_block_comment] = STATE(3290),
    [sym_compiler_directive_decl] = STATE(3290),
    [sym_fsi_directive_decl] = STATE(3290),
    [sym_preproc_line] = STATE(3290),
    [sym_identifier] = ACTIONS(4236),
    [anon_sym_EQ] = ACTIONS(4234),
    [anon_sym_COLON] = ACTIONS(4236),
    [anon_sym_return] = ACTIONS(4236),
    [anon_sym_do] = ACTIONS(4236),
    [anon_sym_let] = ACTIONS(4236),
    [anon_sym_let_BANG] = ACTIONS(4234),
    [anon_sym_LPAREN] = ACTIONS(4236),
    [anon_sym_COMMA] = ACTIONS(4234),
    [anon_sym_null] = ACTIONS(4236),
    [anon_sym_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_COLON] = ACTIONS(4234),
    [anon_sym_AMP] = ACTIONS(4236),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4234),
    [anon_sym_LBRACE] = ACTIONS(4236),
    [anon_sym_LT_AT] = ACTIONS(4236),
    [anon_sym_LT_AT_AT] = ACTIONS(4236),
    [anon_sym_DOT] = ACTIONS(4236),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4234),
    [anon_sym_new] = ACTIONS(4236),
    [anon_sym_return_BANG] = ACTIONS(4234),
    [anon_sym_yield] = ACTIONS(4236),
    [anon_sym_yield_BANG] = ACTIONS(4234),
    [anon_sym_lazy] = ACTIONS(4236),
    [anon_sym_assert] = ACTIONS(4236),
    [anon_sym_upcast] = ACTIONS(4236),
    [anon_sym_downcast] = ACTIONS(4236),
    [anon_sym_COLON_GT] = ACTIONS(4234),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4234),
    [anon_sym_for] = ACTIONS(4236),
    [anon_sym_while] = ACTIONS(4236),
    [anon_sym_if] = ACTIONS(4236),
    [anon_sym_fun] = ACTIONS(4236),
    [anon_sym_try] = ACTIONS(4236),
    [anon_sym_match] = ACTIONS(4236),
    [anon_sym_match_BANG] = ACTIONS(4234),
    [anon_sym_function] = ACTIONS(4236),
    [anon_sym_LT_DASH] = ACTIONS(4236),
    [anon_sym_DOT_LBRACK] = ACTIONS(4234),
    [anon_sym_LT] = ACTIONS(4234),
    [anon_sym_GT] = ACTIONS(4236),
    [anon_sym_use] = ACTIONS(4236),
    [anon_sym_use_BANG] = ACTIONS(4234),
    [anon_sym_do_BANG] = ACTIONS(4234),
    [anon_sym_begin] = ACTIONS(4236),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_or] = ACTIONS(4236),
    [aux_sym_char_token1] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4236),
    [anon_sym_DQUOTE] = ACTIONS(4236),
    [anon_sym_AT_DQUOTE] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [sym_bool] = ACTIONS(4236),
    [sym_unit] = ACTIONS(4234),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4236),
    [sym_op_identifier] = ACTIONS(4236),
    [anon_sym_PLUS] = ACTIONS(4236),
    [anon_sym_DASH] = ACTIONS(4236),
    [anon_sym_PLUS_DOT] = ACTIONS(4236),
    [anon_sym_DASH_DOT] = ACTIONS(4236),
    [anon_sym_PERCENT] = ACTIONS(4236),
    [anon_sym_AMP_AMP] = ACTIONS(4236),
    [anon_sym_TILDE] = ACTIONS(4234),
    [aux_sym_prefix_op_token1] = ACTIONS(4236),
    [aux_sym_infix_op_token1] = ACTIONS(4234),
    [aux_sym_infix_op_token2] = ACTIONS(4236),
    [anon_sym_PIPE_PIPE] = ACTIONS(4236),
    [anon_sym_BANG_EQ] = ACTIONS(4236),
    [anon_sym_COLON_EQ] = ACTIONS(4234),
    [anon_sym_DOLLAR] = ACTIONS(4236),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4236),
    [sym_int] = ACTIONS(4236),
    [sym_xint] = ACTIONS(4234),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4234),
    [sym__newline] = ACTIONS(4234),
  },
  [3291] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(6991),
    [sym_function_declaration_left] = STATE(9671),
    [sym_value_declaration_left] = STATE(9671),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3291),
    [sym_compiler_directive_decl] = STATE(3291),
    [sym_fsi_directive_decl] = STATE(3291),
    [sym_preproc_line] = STATE(3291),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_rec] = ACTIONS(5833),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3292] = {
    [sym_block_comment] = STATE(3292),
    [sym_compiler_directive_decl] = STATE(3292),
    [sym_fsi_directive_decl] = STATE(3292),
    [sym_preproc_line] = STATE(3292),
    [sym_identifier] = ACTIONS(4007),
    [anon_sym_EQ] = ACTIONS(4005),
    [anon_sym_COLON] = ACTIONS(4007),
    [anon_sym_return] = ACTIONS(4007),
    [anon_sym_do] = ACTIONS(4007),
    [anon_sym_let] = ACTIONS(4007),
    [anon_sym_let_BANG] = ACTIONS(4005),
    [anon_sym_LPAREN] = ACTIONS(4007),
    [anon_sym_COMMA] = ACTIONS(4005),
    [anon_sym_null] = ACTIONS(4007),
    [anon_sym_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_COLON] = ACTIONS(4005),
    [anon_sym_AMP] = ACTIONS(4007),
    [anon_sym_LBRACK] = ACTIONS(4007),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4005),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_LT_AT] = ACTIONS(4007),
    [anon_sym_AT_GT] = ACTIONS(4007),
    [anon_sym_LT_AT_AT] = ACTIONS(4007),
    [anon_sym_DOT] = ACTIONS(4007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4005),
    [anon_sym_new] = ACTIONS(4007),
    [anon_sym_return_BANG] = ACTIONS(4005),
    [anon_sym_yield] = ACTIONS(4007),
    [anon_sym_yield_BANG] = ACTIONS(4005),
    [anon_sym_lazy] = ACTIONS(4007),
    [anon_sym_assert] = ACTIONS(4007),
    [anon_sym_upcast] = ACTIONS(4007),
    [anon_sym_downcast] = ACTIONS(4007),
    [anon_sym_COLON_GT] = ACTIONS(4005),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4005),
    [anon_sym_for] = ACTIONS(4007),
    [anon_sym_while] = ACTIONS(4007),
    [anon_sym_if] = ACTIONS(4007),
    [anon_sym_fun] = ACTIONS(4007),
    [anon_sym_try] = ACTIONS(4007),
    [anon_sym_match] = ACTIONS(4007),
    [anon_sym_match_BANG] = ACTIONS(4005),
    [anon_sym_function] = ACTIONS(4007),
    [anon_sym_LT_DASH] = ACTIONS(4007),
    [anon_sym_DOT_LBRACK] = ACTIONS(4005),
    [anon_sym_LT] = ACTIONS(4005),
    [anon_sym_use] = ACTIONS(4007),
    [anon_sym_use_BANG] = ACTIONS(4005),
    [anon_sym_do_BANG] = ACTIONS(4005),
    [anon_sym_begin] = ACTIONS(4007),
    [anon_sym_LPAREN2] = ACTIONS(4007),
    [anon_sym_or] = ACTIONS(4007),
    [aux_sym_char_token1] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4007),
    [anon_sym_DQUOTE] = ACTIONS(4007),
    [anon_sym_AT_DQUOTE] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [sym_bool] = ACTIONS(4007),
    [sym_unit] = ACTIONS(4005),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4007),
    [sym_op_identifier] = ACTIONS(4007),
    [anon_sym_PLUS] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4007),
    [anon_sym_PLUS_DOT] = ACTIONS(4007),
    [anon_sym_DASH_DOT] = ACTIONS(4007),
    [anon_sym_PERCENT] = ACTIONS(4007),
    [anon_sym_AMP_AMP] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4005),
    [aux_sym_prefix_op_token1] = ACTIONS(4007),
    [aux_sym_infix_op_token1] = ACTIONS(4005),
    [aux_sym_infix_op_token2] = ACTIONS(4007),
    [anon_sym_PIPE_PIPE] = ACTIONS(4007),
    [anon_sym_BANG_EQ] = ACTIONS(4007),
    [anon_sym_COLON_EQ] = ACTIONS(4005),
    [anon_sym_DOLLAR] = ACTIONS(4007),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4007),
    [sym_int] = ACTIONS(4007),
    [sym_xint] = ACTIONS(4005),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4005),
    [sym__newline] = ACTIONS(4005),
  },
  [3293] = {
    [sym_attributes] = STATE(3966),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8350),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3594),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3293),
    [sym_compiler_directive_decl] = STATE(3293),
    [sym_fsi_directive_decl] = STATE(3293),
    [sym_preproc_line] = STATE(3293),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym_repeat_pattern_repeat1] = STATE(5188),
    [sym_identifier] = ACTIONS(5835),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_COLON] = ACTIONS(5363),
    [anon_sym_as] = ACTIONS(5813),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_COMMA] = ACTIONS(5815),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5837),
    [anon_sym_COLON_QMARK] = ACTIONS(5839),
    [anon_sym_COLON_COLON] = ACTIONS(5817),
    [anon_sym_PIPE] = ACTIONS(5819),
    [anon_sym_AMP] = ACTIONS(5821),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [anon_sym_in] = ACTIONS(5363),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3294] = {
    [sym_block_comment] = STATE(3294),
    [sym_compiler_directive_decl] = STATE(3294),
    [sym_fsi_directive_decl] = STATE(3294),
    [sym_preproc_line] = STATE(3294),
    [sym_identifier] = ACTIONS(3984),
    [anon_sym_EQ] = ACTIONS(3982),
    [anon_sym_COLON] = ACTIONS(3984),
    [anon_sym_return] = ACTIONS(3984),
    [anon_sym_do] = ACTIONS(3984),
    [anon_sym_let] = ACTIONS(3984),
    [anon_sym_let_BANG] = ACTIONS(3982),
    [anon_sym_LPAREN] = ACTIONS(3984),
    [anon_sym_COMMA] = ACTIONS(3982),
    [anon_sym_null] = ACTIONS(3984),
    [anon_sym_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AMP] = ACTIONS(3984),
    [anon_sym_LBRACK] = ACTIONS(3984),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(3984),
    [anon_sym_LT_AT] = ACTIONS(3984),
    [anon_sym_LT_AT_AT] = ACTIONS(3984),
    [anon_sym_DOT] = ACTIONS(3984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3982),
    [anon_sym_new] = ACTIONS(3984),
    [anon_sym_return_BANG] = ACTIONS(3982),
    [anon_sym_yield] = ACTIONS(3984),
    [anon_sym_yield_BANG] = ACTIONS(3982),
    [anon_sym_lazy] = ACTIONS(3984),
    [anon_sym_assert] = ACTIONS(3984),
    [anon_sym_upcast] = ACTIONS(3984),
    [anon_sym_downcast] = ACTIONS(3984),
    [anon_sym_COLON_GT] = ACTIONS(3982),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3982),
    [anon_sym_for] = ACTIONS(3984),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_if] = ACTIONS(3984),
    [anon_sym_fun] = ACTIONS(3984),
    [anon_sym_try] = ACTIONS(3984),
    [anon_sym_match] = ACTIONS(3984),
    [anon_sym_match_BANG] = ACTIONS(3982),
    [anon_sym_function] = ACTIONS(3984),
    [anon_sym_LT_DASH] = ACTIONS(3984),
    [anon_sym_DOT_LBRACK] = ACTIONS(3982),
    [anon_sym_LT] = ACTIONS(3982),
    [anon_sym_use] = ACTIONS(3984),
    [anon_sym_use_BANG] = ACTIONS(3982),
    [anon_sym_do_BANG] = ACTIONS(3982),
    [anon_sym_DOT_DOT] = ACTIONS(3982),
    [anon_sym_begin] = ACTIONS(3984),
    [anon_sym_LPAREN2] = ACTIONS(3984),
    [anon_sym_or] = ACTIONS(3984),
    [aux_sym_char_token1] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3984),
    [anon_sym_DQUOTE] = ACTIONS(3984),
    [anon_sym_AT_DQUOTE] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [sym_bool] = ACTIONS(3984),
    [sym_unit] = ACTIONS(3982),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3984),
    [sym_op_identifier] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3984),
    [anon_sym_DASH] = ACTIONS(3984),
    [anon_sym_PLUS_DOT] = ACTIONS(3984),
    [anon_sym_DASH_DOT] = ACTIONS(3984),
    [anon_sym_PERCENT] = ACTIONS(3984),
    [anon_sym_AMP_AMP] = ACTIONS(3984),
    [anon_sym_TILDE] = ACTIONS(3982),
    [aux_sym_prefix_op_token1] = ACTIONS(3984),
    [aux_sym_infix_op_token1] = ACTIONS(3982),
    [aux_sym_infix_op_token2] = ACTIONS(3984),
    [anon_sym_PIPE_PIPE] = ACTIONS(3984),
    [anon_sym_BANG_EQ] = ACTIONS(3984),
    [anon_sym_COLON_EQ] = ACTIONS(3982),
    [anon_sym_DOLLAR] = ACTIONS(3984),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3984),
    [sym_int] = ACTIONS(3984),
    [sym_xint] = ACTIONS(3982),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3982),
    [sym__newline] = ACTIONS(3982),
  },
  [3295] = {
    [sym_block_comment] = STATE(3295),
    [sym_compiler_directive_decl] = STATE(3295),
    [sym_fsi_directive_decl] = STATE(3295),
    [sym_preproc_line] = STATE(3295),
    [sym_identifier] = ACTIONS(3988),
    [anon_sym_EQ] = ACTIONS(3986),
    [anon_sym_COLON] = ACTIONS(3988),
    [anon_sym_return] = ACTIONS(3988),
    [anon_sym_do] = ACTIONS(3988),
    [anon_sym_let] = ACTIONS(3988),
    [anon_sym_let_BANG] = ACTIONS(3986),
    [anon_sym_LPAREN] = ACTIONS(3988),
    [anon_sym_COMMA] = ACTIONS(3986),
    [anon_sym_null] = ACTIONS(3988),
    [anon_sym_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_COLON] = ACTIONS(3986),
    [anon_sym_AMP] = ACTIONS(3988),
    [anon_sym_LBRACK] = ACTIONS(3988),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3986),
    [anon_sym_LBRACE] = ACTIONS(3988),
    [anon_sym_LT_AT] = ACTIONS(3988),
    [anon_sym_LT_AT_AT] = ACTIONS(3988),
    [anon_sym_DOT] = ACTIONS(3988),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3986),
    [anon_sym_new] = ACTIONS(3988),
    [anon_sym_return_BANG] = ACTIONS(3986),
    [anon_sym_yield] = ACTIONS(3988),
    [anon_sym_yield_BANG] = ACTIONS(3986),
    [anon_sym_lazy] = ACTIONS(3988),
    [anon_sym_assert] = ACTIONS(3988),
    [anon_sym_upcast] = ACTIONS(3988),
    [anon_sym_downcast] = ACTIONS(3988),
    [anon_sym_COLON_GT] = ACTIONS(3986),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_while] = ACTIONS(3988),
    [anon_sym_if] = ACTIONS(3988),
    [anon_sym_fun] = ACTIONS(3988),
    [anon_sym_try] = ACTIONS(3988),
    [anon_sym_match] = ACTIONS(3988),
    [anon_sym_match_BANG] = ACTIONS(3986),
    [anon_sym_function] = ACTIONS(3988),
    [anon_sym_LT_DASH] = ACTIONS(3988),
    [anon_sym_DOT_LBRACK] = ACTIONS(3986),
    [anon_sym_LT] = ACTIONS(3986),
    [anon_sym_use] = ACTIONS(3988),
    [anon_sym_use_BANG] = ACTIONS(3986),
    [anon_sym_do_BANG] = ACTIONS(3986),
    [anon_sym_DOT_DOT] = ACTIONS(3986),
    [anon_sym_begin] = ACTIONS(3988),
    [anon_sym_LPAREN2] = ACTIONS(3988),
    [anon_sym_or] = ACTIONS(3988),
    [aux_sym_char_token1] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3988),
    [anon_sym_DQUOTE] = ACTIONS(3988),
    [anon_sym_AT_DQUOTE] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [sym_bool] = ACTIONS(3988),
    [sym_unit] = ACTIONS(3986),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3988),
    [sym_op_identifier] = ACTIONS(3988),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_PLUS_DOT] = ACTIONS(3988),
    [anon_sym_DASH_DOT] = ACTIONS(3988),
    [anon_sym_PERCENT] = ACTIONS(3988),
    [anon_sym_AMP_AMP] = ACTIONS(3988),
    [anon_sym_TILDE] = ACTIONS(3986),
    [aux_sym_prefix_op_token1] = ACTIONS(3988),
    [aux_sym_infix_op_token1] = ACTIONS(3986),
    [aux_sym_infix_op_token2] = ACTIONS(3988),
    [anon_sym_PIPE_PIPE] = ACTIONS(3988),
    [anon_sym_BANG_EQ] = ACTIONS(3988),
    [anon_sym_COLON_EQ] = ACTIONS(3986),
    [anon_sym_DOLLAR] = ACTIONS(3988),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3988),
    [sym_int] = ACTIONS(3988),
    [sym_xint] = ACTIONS(3986),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3986),
    [sym__newline] = ACTIONS(3986),
  },
  [3296] = {
    [sym_block_comment] = STATE(3296),
    [sym_compiler_directive_decl] = STATE(3296),
    [sym_fsi_directive_decl] = STATE(3296),
    [sym_preproc_line] = STATE(3296),
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_EQ] = ACTIONS(3990),
    [anon_sym_COLON] = ACTIONS(3992),
    [anon_sym_return] = ACTIONS(3992),
    [anon_sym_do] = ACTIONS(3992),
    [anon_sym_let] = ACTIONS(3992),
    [anon_sym_let_BANG] = ACTIONS(3990),
    [anon_sym_LPAREN] = ACTIONS(3992),
    [anon_sym_COMMA] = ACTIONS(3990),
    [anon_sym_null] = ACTIONS(3992),
    [anon_sym_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [anon_sym_AMP] = ACTIONS(3992),
    [anon_sym_LBRACK] = ACTIONS(3992),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3990),
    [anon_sym_LBRACE] = ACTIONS(3992),
    [anon_sym_LT_AT] = ACTIONS(3992),
    [anon_sym_LT_AT_AT] = ACTIONS(3992),
    [anon_sym_DOT] = ACTIONS(3992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3990),
    [anon_sym_new] = ACTIONS(3992),
    [anon_sym_return_BANG] = ACTIONS(3990),
    [anon_sym_yield] = ACTIONS(3992),
    [anon_sym_yield_BANG] = ACTIONS(3990),
    [anon_sym_lazy] = ACTIONS(3992),
    [anon_sym_assert] = ACTIONS(3992),
    [anon_sym_upcast] = ACTIONS(3992),
    [anon_sym_downcast] = ACTIONS(3992),
    [anon_sym_COLON_GT] = ACTIONS(3990),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3990),
    [anon_sym_for] = ACTIONS(3992),
    [anon_sym_while] = ACTIONS(3992),
    [anon_sym_if] = ACTIONS(3992),
    [anon_sym_fun] = ACTIONS(3992),
    [anon_sym_try] = ACTIONS(3992),
    [anon_sym_match] = ACTIONS(3992),
    [anon_sym_match_BANG] = ACTIONS(3990),
    [anon_sym_function] = ACTIONS(3992),
    [anon_sym_LT_DASH] = ACTIONS(3992),
    [anon_sym_DOT_LBRACK] = ACTIONS(3990),
    [anon_sym_LT] = ACTIONS(3990),
    [anon_sym_use] = ACTIONS(3992),
    [anon_sym_use_BANG] = ACTIONS(3990),
    [anon_sym_do_BANG] = ACTIONS(3990),
    [anon_sym_DOT_DOT] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_LPAREN2] = ACTIONS(3992),
    [anon_sym_or] = ACTIONS(3992),
    [aux_sym_char_token1] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3992),
    [anon_sym_DQUOTE] = ACTIONS(3992),
    [anon_sym_AT_DQUOTE] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [sym_bool] = ACTIONS(3992),
    [sym_unit] = ACTIONS(3990),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3992),
    [sym_op_identifier] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3992),
    [anon_sym_DASH] = ACTIONS(3992),
    [anon_sym_PLUS_DOT] = ACTIONS(3992),
    [anon_sym_DASH_DOT] = ACTIONS(3992),
    [anon_sym_PERCENT] = ACTIONS(3992),
    [anon_sym_AMP_AMP] = ACTIONS(3992),
    [anon_sym_TILDE] = ACTIONS(3990),
    [aux_sym_prefix_op_token1] = ACTIONS(3992),
    [aux_sym_infix_op_token1] = ACTIONS(3990),
    [aux_sym_infix_op_token2] = ACTIONS(3992),
    [anon_sym_PIPE_PIPE] = ACTIONS(3992),
    [anon_sym_BANG_EQ] = ACTIONS(3992),
    [anon_sym_COLON_EQ] = ACTIONS(3990),
    [anon_sym_DOLLAR] = ACTIONS(3992),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3992),
    [sym_int] = ACTIONS(3992),
    [sym_xint] = ACTIONS(3990),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3990),
    [sym__newline] = ACTIONS(3990),
  },
  [3297] = {
    [sym_block_comment] = STATE(3297),
    [sym_compiler_directive_decl] = STATE(3297),
    [sym_fsi_directive_decl] = STATE(3297),
    [sym_preproc_line] = STATE(3297),
    [sym_identifier] = ACTIONS(4147),
    [anon_sym_EQ] = ACTIONS(4145),
    [anon_sym_COLON] = ACTIONS(4147),
    [anon_sym_return] = ACTIONS(4147),
    [anon_sym_do] = ACTIONS(4147),
    [anon_sym_let] = ACTIONS(4147),
    [anon_sym_let_BANG] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(4147),
    [anon_sym_COMMA] = ACTIONS(4145),
    [anon_sym_null] = ACTIONS(4147),
    [anon_sym_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_COLON] = ACTIONS(4145),
    [anon_sym_AMP] = ACTIONS(4147),
    [anon_sym_LBRACK] = ACTIONS(4147),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4145),
    [anon_sym_LBRACE] = ACTIONS(4147),
    [anon_sym_LT_AT] = ACTIONS(4147),
    [anon_sym_LT_AT_AT] = ACTIONS(4147),
    [anon_sym_DOT] = ACTIONS(4147),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4145),
    [anon_sym_new] = ACTIONS(4147),
    [anon_sym_return_BANG] = ACTIONS(4145),
    [anon_sym_yield] = ACTIONS(4147),
    [anon_sym_yield_BANG] = ACTIONS(4145),
    [anon_sym_lazy] = ACTIONS(4147),
    [anon_sym_assert] = ACTIONS(4147),
    [anon_sym_upcast] = ACTIONS(4147),
    [anon_sym_downcast] = ACTIONS(4147),
    [anon_sym_COLON_GT] = ACTIONS(4145),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4145),
    [anon_sym_for] = ACTIONS(4147),
    [anon_sym_while] = ACTIONS(4147),
    [anon_sym_if] = ACTIONS(4147),
    [anon_sym_fun] = ACTIONS(4147),
    [anon_sym_try] = ACTIONS(4147),
    [anon_sym_match] = ACTIONS(4147),
    [anon_sym_match_BANG] = ACTIONS(4145),
    [anon_sym_function] = ACTIONS(4147),
    [anon_sym_LT_DASH] = ACTIONS(4147),
    [anon_sym_DOT_LBRACK] = ACTIONS(4145),
    [anon_sym_LT] = ACTIONS(4145),
    [anon_sym_use] = ACTIONS(4147),
    [anon_sym_use_BANG] = ACTIONS(4145),
    [anon_sym_do_BANG] = ACTIONS(4145),
    [anon_sym_DOT_DOT] = ACTIONS(4145),
    [anon_sym_begin] = ACTIONS(4147),
    [anon_sym_LPAREN2] = ACTIONS(4147),
    [anon_sym_or] = ACTIONS(4147),
    [aux_sym_char_token1] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4147),
    [anon_sym_DQUOTE] = ACTIONS(4147),
    [anon_sym_AT_DQUOTE] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [sym_bool] = ACTIONS(4147),
    [sym_unit] = ACTIONS(4145),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4147),
    [sym_op_identifier] = ACTIONS(4147),
    [anon_sym_PLUS] = ACTIONS(4147),
    [anon_sym_DASH] = ACTIONS(4147),
    [anon_sym_PLUS_DOT] = ACTIONS(4147),
    [anon_sym_DASH_DOT] = ACTIONS(4147),
    [anon_sym_PERCENT] = ACTIONS(4147),
    [anon_sym_AMP_AMP] = ACTIONS(4147),
    [anon_sym_TILDE] = ACTIONS(4145),
    [aux_sym_prefix_op_token1] = ACTIONS(4147),
    [aux_sym_infix_op_token1] = ACTIONS(4145),
    [aux_sym_infix_op_token2] = ACTIONS(4147),
    [anon_sym_PIPE_PIPE] = ACTIONS(4147),
    [anon_sym_BANG_EQ] = ACTIONS(4147),
    [anon_sym_COLON_EQ] = ACTIONS(4145),
    [anon_sym_DOLLAR] = ACTIONS(4147),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4147),
    [sym_int] = ACTIONS(4147),
    [sym_xint] = ACTIONS(4145),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4145),
    [sym__newline] = ACTIONS(4145),
  },
  [3298] = {
    [sym_block_comment] = STATE(3298),
    [sym_compiler_directive_decl] = STATE(3298),
    [sym_fsi_directive_decl] = STATE(3298),
    [sym_preproc_line] = STATE(3298),
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_EQ] = ACTIONS(4149),
    [anon_sym_COLON] = ACTIONS(4151),
    [anon_sym_return] = ACTIONS(4151),
    [anon_sym_do] = ACTIONS(4151),
    [anon_sym_let] = ACTIONS(4151),
    [anon_sym_let_BANG] = ACTIONS(4149),
    [anon_sym_LPAREN] = ACTIONS(4151),
    [anon_sym_COMMA] = ACTIONS(4149),
    [anon_sym_null] = ACTIONS(4151),
    [anon_sym_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_AMP] = ACTIONS(4151),
    [anon_sym_LBRACK] = ACTIONS(4151),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4149),
    [anon_sym_LBRACE] = ACTIONS(4151),
    [anon_sym_LT_AT] = ACTIONS(4151),
    [anon_sym_LT_AT_AT] = ACTIONS(4151),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4149),
    [anon_sym_new] = ACTIONS(4151),
    [anon_sym_return_BANG] = ACTIONS(4149),
    [anon_sym_yield] = ACTIONS(4151),
    [anon_sym_yield_BANG] = ACTIONS(4149),
    [anon_sym_lazy] = ACTIONS(4151),
    [anon_sym_assert] = ACTIONS(4151),
    [anon_sym_upcast] = ACTIONS(4151),
    [anon_sym_downcast] = ACTIONS(4151),
    [anon_sym_COLON_GT] = ACTIONS(4149),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4149),
    [anon_sym_for] = ACTIONS(4151),
    [anon_sym_while] = ACTIONS(4151),
    [anon_sym_if] = ACTIONS(4151),
    [anon_sym_fun] = ACTIONS(4151),
    [anon_sym_try] = ACTIONS(4151),
    [anon_sym_match] = ACTIONS(4151),
    [anon_sym_match_BANG] = ACTIONS(4149),
    [anon_sym_function] = ACTIONS(4151),
    [anon_sym_LT_DASH] = ACTIONS(4151),
    [anon_sym_DOT_LBRACK] = ACTIONS(4149),
    [anon_sym_LT] = ACTIONS(4149),
    [anon_sym_use] = ACTIONS(4151),
    [anon_sym_use_BANG] = ACTIONS(4149),
    [anon_sym_do_BANG] = ACTIONS(4149),
    [anon_sym_DOT_DOT] = ACTIONS(4149),
    [anon_sym_begin] = ACTIONS(4151),
    [anon_sym_LPAREN2] = ACTIONS(4151),
    [anon_sym_or] = ACTIONS(4151),
    [aux_sym_char_token1] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4151),
    [anon_sym_DQUOTE] = ACTIONS(4151),
    [anon_sym_AT_DQUOTE] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [sym_bool] = ACTIONS(4151),
    [sym_unit] = ACTIONS(4149),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4151),
    [sym_op_identifier] = ACTIONS(4151),
    [anon_sym_PLUS] = ACTIONS(4151),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_PLUS_DOT] = ACTIONS(4151),
    [anon_sym_DASH_DOT] = ACTIONS(4151),
    [anon_sym_PERCENT] = ACTIONS(4151),
    [anon_sym_AMP_AMP] = ACTIONS(4151),
    [anon_sym_TILDE] = ACTIONS(4149),
    [aux_sym_prefix_op_token1] = ACTIONS(4151),
    [aux_sym_infix_op_token1] = ACTIONS(4149),
    [aux_sym_infix_op_token2] = ACTIONS(4151),
    [anon_sym_PIPE_PIPE] = ACTIONS(4151),
    [anon_sym_BANG_EQ] = ACTIONS(4151),
    [anon_sym_COLON_EQ] = ACTIONS(4149),
    [anon_sym_DOLLAR] = ACTIONS(4151),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4151),
    [sym_int] = ACTIONS(4151),
    [sym_xint] = ACTIONS(4149),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4149),
    [sym__newline] = ACTIONS(4149),
  },
  [3299] = {
    [sym_block_comment] = STATE(3299),
    [sym_compiler_directive_decl] = STATE(3299),
    [sym_fsi_directive_decl] = STATE(3299),
    [sym_preproc_line] = STATE(3299),
    [sym_identifier] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4246),
    [anon_sym_COLON] = ACTIONS(4248),
    [anon_sym_return] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4248),
    [anon_sym_let] = ACTIONS(4248),
    [anon_sym_let_BANG] = ACTIONS(4246),
    [anon_sym_LPAREN] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_null] = ACTIONS(4248),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4248),
    [anon_sym_LT_AT] = ACTIONS(4248),
    [anon_sym_AT_GT] = ACTIONS(4248),
    [anon_sym_LT_AT_AT] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4246),
    [anon_sym_new] = ACTIONS(4248),
    [anon_sym_return_BANG] = ACTIONS(4246),
    [anon_sym_yield] = ACTIONS(4248),
    [anon_sym_yield_BANG] = ACTIONS(4246),
    [anon_sym_lazy] = ACTIONS(4248),
    [anon_sym_assert] = ACTIONS(4248),
    [anon_sym_upcast] = ACTIONS(4248),
    [anon_sym_downcast] = ACTIONS(4248),
    [anon_sym_COLON_GT] = ACTIONS(4246),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4246),
    [anon_sym_for] = ACTIONS(4248),
    [anon_sym_while] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4248),
    [anon_sym_fun] = ACTIONS(4248),
    [anon_sym_try] = ACTIONS(4248),
    [anon_sym_match] = ACTIONS(4248),
    [anon_sym_match_BANG] = ACTIONS(4246),
    [anon_sym_function] = ACTIONS(4248),
    [anon_sym_LT_DASH] = ACTIONS(4248),
    [anon_sym_DOT_LBRACK] = ACTIONS(4246),
    [anon_sym_LT] = ACTIONS(4246),
    [anon_sym_use] = ACTIONS(4248),
    [anon_sym_use_BANG] = ACTIONS(4246),
    [anon_sym_do_BANG] = ACTIONS(4246),
    [anon_sym_begin] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4248),
    [aux_sym_char_token1] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4248),
    [anon_sym_DQUOTE] = ACTIONS(4248),
    [anon_sym_AT_DQUOTE] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [sym_bool] = ACTIONS(4248),
    [sym_unit] = ACTIONS(4246),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4248),
    [sym_op_identifier] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_DOT] = ACTIONS(4248),
    [anon_sym_DASH_DOT] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_TILDE] = ACTIONS(4246),
    [aux_sym_prefix_op_token1] = ACTIONS(4248),
    [aux_sym_infix_op_token1] = ACTIONS(4246),
    [aux_sym_infix_op_token2] = ACTIONS(4248),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_COLON_EQ] = ACTIONS(4246),
    [anon_sym_DOLLAR] = ACTIONS(4248),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4248),
    [sym_int] = ACTIONS(4248),
    [sym_xint] = ACTIONS(4246),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4246),
    [sym__newline] = ACTIONS(4246),
  },
  [3300] = {
    [sym_block_comment] = STATE(3300),
    [sym_compiler_directive_decl] = STATE(3300),
    [sym_fsi_directive_decl] = STATE(3300),
    [sym_preproc_line] = STATE(3300),
    [sym_identifier] = ACTIONS(4240),
    [anon_sym_EQ] = ACTIONS(4238),
    [anon_sym_COLON] = ACTIONS(4240),
    [anon_sym_return] = ACTIONS(4240),
    [anon_sym_do] = ACTIONS(4240),
    [anon_sym_let] = ACTIONS(4240),
    [anon_sym_let_BANG] = ACTIONS(4238),
    [anon_sym_LPAREN] = ACTIONS(4240),
    [anon_sym_COMMA] = ACTIONS(4238),
    [anon_sym_null] = ACTIONS(4240),
    [anon_sym_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_COLON] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4240),
    [anon_sym_LBRACK] = ACTIONS(4240),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4238),
    [anon_sym_LBRACE] = ACTIONS(4240),
    [anon_sym_LT_AT] = ACTIONS(4240),
    [anon_sym_LT_AT_AT] = ACTIONS(4240),
    [anon_sym_DOT] = ACTIONS(4240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4238),
    [anon_sym_new] = ACTIONS(4240),
    [anon_sym_return_BANG] = ACTIONS(4238),
    [anon_sym_yield] = ACTIONS(4240),
    [anon_sym_yield_BANG] = ACTIONS(4238),
    [anon_sym_lazy] = ACTIONS(4240),
    [anon_sym_assert] = ACTIONS(4240),
    [anon_sym_upcast] = ACTIONS(4240),
    [anon_sym_downcast] = ACTIONS(4240),
    [anon_sym_COLON_GT] = ACTIONS(4238),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4238),
    [anon_sym_for] = ACTIONS(4240),
    [anon_sym_while] = ACTIONS(4240),
    [anon_sym_if] = ACTIONS(4240),
    [anon_sym_fun] = ACTIONS(4240),
    [anon_sym_try] = ACTIONS(4240),
    [anon_sym_match] = ACTIONS(4240),
    [anon_sym_match_BANG] = ACTIONS(4238),
    [anon_sym_function] = ACTIONS(4240),
    [anon_sym_LT_DASH] = ACTIONS(4240),
    [anon_sym_DOT_LBRACK] = ACTIONS(4238),
    [anon_sym_LT] = ACTIONS(4238),
    [anon_sym_GT] = ACTIONS(4240),
    [anon_sym_use] = ACTIONS(4240),
    [anon_sym_use_BANG] = ACTIONS(4238),
    [anon_sym_do_BANG] = ACTIONS(4238),
    [anon_sym_begin] = ACTIONS(4240),
    [anon_sym_LPAREN2] = ACTIONS(4240),
    [anon_sym_or] = ACTIONS(4240),
    [aux_sym_char_token1] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4240),
    [anon_sym_DQUOTE] = ACTIONS(4240),
    [anon_sym_AT_DQUOTE] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [sym_bool] = ACTIONS(4240),
    [sym_unit] = ACTIONS(4238),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4240),
    [sym_op_identifier] = ACTIONS(4240),
    [anon_sym_PLUS] = ACTIONS(4240),
    [anon_sym_DASH] = ACTIONS(4240),
    [anon_sym_PLUS_DOT] = ACTIONS(4240),
    [anon_sym_DASH_DOT] = ACTIONS(4240),
    [anon_sym_PERCENT] = ACTIONS(4240),
    [anon_sym_AMP_AMP] = ACTIONS(4240),
    [anon_sym_TILDE] = ACTIONS(4238),
    [aux_sym_prefix_op_token1] = ACTIONS(4240),
    [aux_sym_infix_op_token1] = ACTIONS(4238),
    [aux_sym_infix_op_token2] = ACTIONS(4240),
    [anon_sym_PIPE_PIPE] = ACTIONS(4240),
    [anon_sym_BANG_EQ] = ACTIONS(4240),
    [anon_sym_COLON_EQ] = ACTIONS(4238),
    [anon_sym_DOLLAR] = ACTIONS(4240),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4240),
    [sym_int] = ACTIONS(4240),
    [sym_xint] = ACTIONS(4238),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4238),
    [sym__newline] = ACTIONS(4238),
  },
  [3301] = {
    [sym_block_comment] = STATE(3301),
    [sym_compiler_directive_decl] = STATE(3301),
    [sym_fsi_directive_decl] = STATE(3301),
    [sym_preproc_line] = STATE(3301),
    [sym_identifier] = ACTIONS(4193),
    [anon_sym_EQ] = ACTIONS(4191),
    [anon_sym_COLON] = ACTIONS(4193),
    [anon_sym_return] = ACTIONS(4193),
    [anon_sym_do] = ACTIONS(4193),
    [anon_sym_let] = ACTIONS(4193),
    [anon_sym_let_BANG] = ACTIONS(4191),
    [anon_sym_LPAREN] = ACTIONS(4193),
    [anon_sym_COMMA] = ACTIONS(4191),
    [anon_sym_null] = ACTIONS(4193),
    [anon_sym_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_COLON] = ACTIONS(4191),
    [anon_sym_AMP] = ACTIONS(4193),
    [anon_sym_LBRACK] = ACTIONS(4193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4191),
    [anon_sym_LBRACE] = ACTIONS(4193),
    [anon_sym_LT_AT] = ACTIONS(4193),
    [anon_sym_LT_AT_AT] = ACTIONS(4193),
    [anon_sym_DOT] = ACTIONS(4193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4191),
    [anon_sym_new] = ACTIONS(4193),
    [anon_sym_return_BANG] = ACTIONS(4191),
    [anon_sym_yield] = ACTIONS(4193),
    [anon_sym_yield_BANG] = ACTIONS(4191),
    [anon_sym_lazy] = ACTIONS(4193),
    [anon_sym_assert] = ACTIONS(4193),
    [anon_sym_upcast] = ACTIONS(4193),
    [anon_sym_downcast] = ACTIONS(4193),
    [anon_sym_COLON_GT] = ACTIONS(4191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4191),
    [anon_sym_for] = ACTIONS(4193),
    [anon_sym_while] = ACTIONS(4193),
    [anon_sym_if] = ACTIONS(4193),
    [anon_sym_fun] = ACTIONS(4193),
    [anon_sym_try] = ACTIONS(4193),
    [anon_sym_match] = ACTIONS(4193),
    [anon_sym_match_BANG] = ACTIONS(4191),
    [anon_sym_function] = ACTIONS(4193),
    [anon_sym_LT_DASH] = ACTIONS(4193),
    [anon_sym_DOT_LBRACK] = ACTIONS(4191),
    [anon_sym_LT] = ACTIONS(4191),
    [anon_sym_use] = ACTIONS(4193),
    [anon_sym_use_BANG] = ACTIONS(4191),
    [anon_sym_do_BANG] = ACTIONS(4191),
    [anon_sym_DOT_DOT] = ACTIONS(4191),
    [anon_sym_begin] = ACTIONS(4193),
    [anon_sym_LPAREN2] = ACTIONS(4193),
    [anon_sym_or] = ACTIONS(4193),
    [aux_sym_char_token1] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4193),
    [anon_sym_DQUOTE] = ACTIONS(4193),
    [anon_sym_AT_DQUOTE] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [sym_bool] = ACTIONS(4193),
    [sym_unit] = ACTIONS(4191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4193),
    [sym_op_identifier] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4193),
    [anon_sym_DASH] = ACTIONS(4193),
    [anon_sym_PLUS_DOT] = ACTIONS(4193),
    [anon_sym_DASH_DOT] = ACTIONS(4193),
    [anon_sym_PERCENT] = ACTIONS(4193),
    [anon_sym_AMP_AMP] = ACTIONS(4193),
    [anon_sym_TILDE] = ACTIONS(4191),
    [aux_sym_prefix_op_token1] = ACTIONS(4193),
    [aux_sym_infix_op_token1] = ACTIONS(4191),
    [aux_sym_infix_op_token2] = ACTIONS(4193),
    [anon_sym_PIPE_PIPE] = ACTIONS(4193),
    [anon_sym_BANG_EQ] = ACTIONS(4193),
    [anon_sym_COLON_EQ] = ACTIONS(4191),
    [anon_sym_DOLLAR] = ACTIONS(4193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4193),
    [sym_int] = ACTIONS(4193),
    [sym_xint] = ACTIONS(4191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4191),
    [sym__newline] = ACTIONS(4191),
  },
  [3302] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defns] = STATE(6976),
    [sym__function_or_value_defn_body] = STATE(6696),
    [sym_function_declaration_left] = STATE(9667),
    [sym_value_declaration_left] = STATE(9667),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3302),
    [sym_compiler_directive_decl] = STATE(3302),
    [sym_fsi_directive_decl] = STATE(3302),
    [sym_preproc_line] = STATE(3302),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3303] = {
    [sym_attributes] = STATE(3960),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(5177),
    [sym__pattern] = STATE(3088),
    [sym_optional_pattern] = STATE(5177),
    [sym_type_check_pattern] = STATE(5177),
    [sym_attribute_pattern] = STATE(5177),
    [sym_paren_pattern] = STATE(5177),
    [sym_as_pattern] = STATE(5177),
    [sym_cons_pattern] = STATE(5177),
    [sym_disjunct_pattern] = STATE(5177),
    [sym_conjunct_pattern] = STATE(5177),
    [sym_typed_pattern] = STATE(5177),
    [sym_list_pattern] = STATE(5177),
    [sym_array_pattern] = STATE(5177),
    [sym_record_pattern] = STATE(5177),
    [sym_named_field_pattern] = STATE(5177),
    [sym_identifier_pattern] = STATE(5177),
    [sym_long_identifier_or_op] = STATE(3306),
    [sym_char] = STATE(5226),
    [sym_format_string] = STATE(5239),
    [sym__string_literal] = STATE(5239),
    [sym_string] = STATE(5226),
    [sym_verbatim_string] = STATE(5226),
    [sym_bytearray] = STATE(5226),
    [sym_verbatim_bytearray] = STATE(5226),
    [sym_format_triple_quoted_string] = STATE(5238),
    [sym_triple_quoted_string] = STATE(5226),
    [sym_const] = STATE(5177),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(5226),
    [sym_byte] = STATE(5226),
    [sym_int16] = STATE(5226),
    [sym_uint16] = STATE(5226),
    [sym_int32] = STATE(5226),
    [sym_uint32] = STATE(5226),
    [sym_nativeint] = STATE(5226),
    [sym_unativeint] = STATE(5226),
    [sym_int64] = STATE(5226),
    [sym_uint64] = STATE(5226),
    [sym_ieee32] = STATE(5226),
    [sym_ieee64] = STATE(5226),
    [sym_bignum] = STATE(5226),
    [sym_decimal] = STATE(5226),
    [sym_float] = STATE(4814),
    [sym_block_comment] = STATE(3303),
    [sym_compiler_directive_decl] = STATE(3303),
    [sym_fsi_directive_decl] = STATE(3303),
    [sym_preproc_line] = STATE(3303),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_COLON] = ACTIONS(5558),
    [anon_sym_as] = ACTIONS(5558),
    [anon_sym_LPAREN] = ACTIONS(5845),
    [anon_sym_COMMA] = ACTIONS(5562),
    [anon_sym_null] = ACTIONS(5847),
    [anon_sym__] = ACTIONS(5849),
    [anon_sym_QMARK] = ACTIONS(5851),
    [anon_sym_COLON_QMARK] = ACTIONS(5853),
    [anon_sym_COLON_COLON] = ACTIONS(5562),
    [anon_sym_PIPE] = ACTIONS(5562),
    [anon_sym_AMP] = ACTIONS(5562),
    [anon_sym_LBRACK] = ACTIONS(5855),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5857),
    [anon_sym_LBRACE] = ACTIONS(5859),
    [anon_sym_DASH_GT] = ACTIONS(5562),
    [anon_sym_when] = ACTIONS(5558),
    [aux_sym_char_token1] = ACTIONS(5861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5863),
    [anon_sym_DQUOTE] = ACTIONS(5865),
    [anon_sym_AT_DQUOTE] = ACTIONS(5867),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5871),
    [sym_bool] = ACTIONS(5873),
    [sym_unit] = ACTIONS(5875),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5877),
    [sym_xint] = ACTIONS(5879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3304] = {
    [sym_block_comment] = STATE(3304),
    [sym_compiler_directive_decl] = STATE(3304),
    [sym_fsi_directive_decl] = STATE(3304),
    [sym_preproc_line] = STATE(3304),
    [sym_identifier] = ACTIONS(4197),
    [anon_sym_EQ] = ACTIONS(4195),
    [anon_sym_COLON] = ACTIONS(4197),
    [anon_sym_return] = ACTIONS(4197),
    [anon_sym_do] = ACTIONS(4197),
    [anon_sym_let] = ACTIONS(4197),
    [anon_sym_let_BANG] = ACTIONS(4195),
    [anon_sym_LPAREN] = ACTIONS(4197),
    [anon_sym_COMMA] = ACTIONS(4195),
    [anon_sym_null] = ACTIONS(4197),
    [anon_sym_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_COLON] = ACTIONS(4195),
    [anon_sym_AMP] = ACTIONS(4197),
    [anon_sym_LBRACK] = ACTIONS(4197),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4195),
    [anon_sym_LBRACE] = ACTIONS(4197),
    [anon_sym_LT_AT] = ACTIONS(4197),
    [anon_sym_LT_AT_AT] = ACTIONS(4197),
    [anon_sym_DOT] = ACTIONS(4197),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4195),
    [anon_sym_new] = ACTIONS(4197),
    [anon_sym_return_BANG] = ACTIONS(4195),
    [anon_sym_yield] = ACTIONS(4197),
    [anon_sym_yield_BANG] = ACTIONS(4195),
    [anon_sym_lazy] = ACTIONS(4197),
    [anon_sym_assert] = ACTIONS(4197),
    [anon_sym_upcast] = ACTIONS(4197),
    [anon_sym_downcast] = ACTIONS(4197),
    [anon_sym_COLON_GT] = ACTIONS(4195),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4195),
    [anon_sym_for] = ACTIONS(4197),
    [anon_sym_while] = ACTIONS(4197),
    [anon_sym_if] = ACTIONS(4197),
    [anon_sym_fun] = ACTIONS(4197),
    [anon_sym_try] = ACTIONS(4197),
    [anon_sym_match] = ACTIONS(4197),
    [anon_sym_match_BANG] = ACTIONS(4195),
    [anon_sym_function] = ACTIONS(4197),
    [anon_sym_LT_DASH] = ACTIONS(4197),
    [anon_sym_DOT_LBRACK] = ACTIONS(4195),
    [anon_sym_LT] = ACTIONS(4195),
    [anon_sym_use] = ACTIONS(4197),
    [anon_sym_use_BANG] = ACTIONS(4195),
    [anon_sym_do_BANG] = ACTIONS(4195),
    [anon_sym_DOT_DOT] = ACTIONS(4195),
    [anon_sym_begin] = ACTIONS(4197),
    [anon_sym_LPAREN2] = ACTIONS(4197),
    [anon_sym_or] = ACTIONS(4197),
    [aux_sym_char_token1] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4197),
    [anon_sym_DQUOTE] = ACTIONS(4197),
    [anon_sym_AT_DQUOTE] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [sym_bool] = ACTIONS(4197),
    [sym_unit] = ACTIONS(4195),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4197),
    [sym_op_identifier] = ACTIONS(4197),
    [anon_sym_PLUS] = ACTIONS(4197),
    [anon_sym_DASH] = ACTIONS(4197),
    [anon_sym_PLUS_DOT] = ACTIONS(4197),
    [anon_sym_DASH_DOT] = ACTIONS(4197),
    [anon_sym_PERCENT] = ACTIONS(4197),
    [anon_sym_AMP_AMP] = ACTIONS(4197),
    [anon_sym_TILDE] = ACTIONS(4195),
    [aux_sym_prefix_op_token1] = ACTIONS(4197),
    [aux_sym_infix_op_token1] = ACTIONS(4195),
    [aux_sym_infix_op_token2] = ACTIONS(4197),
    [anon_sym_PIPE_PIPE] = ACTIONS(4197),
    [anon_sym_BANG_EQ] = ACTIONS(4197),
    [anon_sym_COLON_EQ] = ACTIONS(4195),
    [anon_sym_DOLLAR] = ACTIONS(4197),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4197),
    [sym_int] = ACTIONS(4197),
    [sym_xint] = ACTIONS(4195),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4195),
    [sym__newline] = ACTIONS(4195),
  },
  [3305] = {
    [sym_block_comment] = STATE(3305),
    [sym_compiler_directive_decl] = STATE(3305),
    [sym_fsi_directive_decl] = STATE(3305),
    [sym_preproc_line] = STATE(3305),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_EQ] = ACTIONS(4199),
    [anon_sym_COLON] = ACTIONS(4201),
    [anon_sym_return] = ACTIONS(4201),
    [anon_sym_do] = ACTIONS(4201),
    [anon_sym_let] = ACTIONS(4201),
    [anon_sym_let_BANG] = ACTIONS(4199),
    [anon_sym_LPAREN] = ACTIONS(4201),
    [anon_sym_COMMA] = ACTIONS(4199),
    [anon_sym_null] = ACTIONS(4201),
    [anon_sym_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(4199),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_LBRACK] = ACTIONS(4201),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4199),
    [anon_sym_LBRACE] = ACTIONS(4201),
    [anon_sym_LT_AT] = ACTIONS(4201),
    [anon_sym_LT_AT_AT] = ACTIONS(4201),
    [anon_sym_DOT] = ACTIONS(4201),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4199),
    [anon_sym_new] = ACTIONS(4201),
    [anon_sym_return_BANG] = ACTIONS(4199),
    [anon_sym_yield] = ACTIONS(4201),
    [anon_sym_yield_BANG] = ACTIONS(4199),
    [anon_sym_lazy] = ACTIONS(4201),
    [anon_sym_assert] = ACTIONS(4201),
    [anon_sym_upcast] = ACTIONS(4201),
    [anon_sym_downcast] = ACTIONS(4201),
    [anon_sym_COLON_GT] = ACTIONS(4199),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4199),
    [anon_sym_for] = ACTIONS(4201),
    [anon_sym_while] = ACTIONS(4201),
    [anon_sym_if] = ACTIONS(4201),
    [anon_sym_fun] = ACTIONS(4201),
    [anon_sym_try] = ACTIONS(4201),
    [anon_sym_match] = ACTIONS(4201),
    [anon_sym_match_BANG] = ACTIONS(4199),
    [anon_sym_function] = ACTIONS(4201),
    [anon_sym_LT_DASH] = ACTIONS(4201),
    [anon_sym_DOT_LBRACK] = ACTIONS(4199),
    [anon_sym_LT] = ACTIONS(4199),
    [anon_sym_use] = ACTIONS(4201),
    [anon_sym_use_BANG] = ACTIONS(4199),
    [anon_sym_do_BANG] = ACTIONS(4199),
    [anon_sym_DOT_DOT] = ACTIONS(4199),
    [anon_sym_begin] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(4201),
    [anon_sym_or] = ACTIONS(4201),
    [aux_sym_char_token1] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4201),
    [anon_sym_DQUOTE] = ACTIONS(4201),
    [anon_sym_AT_DQUOTE] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [sym_bool] = ACTIONS(4201),
    [sym_unit] = ACTIONS(4199),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4201),
    [sym_op_identifier] = ACTIONS(4201),
    [anon_sym_PLUS] = ACTIONS(4201),
    [anon_sym_DASH] = ACTIONS(4201),
    [anon_sym_PLUS_DOT] = ACTIONS(4201),
    [anon_sym_DASH_DOT] = ACTIONS(4201),
    [anon_sym_PERCENT] = ACTIONS(4201),
    [anon_sym_AMP_AMP] = ACTIONS(4201),
    [anon_sym_TILDE] = ACTIONS(4199),
    [aux_sym_prefix_op_token1] = ACTIONS(4201),
    [aux_sym_infix_op_token1] = ACTIONS(4199),
    [aux_sym_infix_op_token2] = ACTIONS(4201),
    [anon_sym_PIPE_PIPE] = ACTIONS(4201),
    [anon_sym_BANG_EQ] = ACTIONS(4201),
    [anon_sym_COLON_EQ] = ACTIONS(4199),
    [anon_sym_DOLLAR] = ACTIONS(4201),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4201),
    [sym_int] = ACTIONS(4201),
    [sym_xint] = ACTIONS(4199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4199),
    [sym__newline] = ACTIONS(4199),
  },
  [3306] = {
    [sym_attributes] = STATE(3960),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(5177),
    [sym__pattern] = STATE(3134),
    [sym_optional_pattern] = STATE(5177),
    [sym_type_check_pattern] = STATE(5177),
    [sym_attribute_pattern] = STATE(5177),
    [sym_paren_pattern] = STATE(5177),
    [sym_as_pattern] = STATE(5177),
    [sym_cons_pattern] = STATE(5177),
    [sym_disjunct_pattern] = STATE(5177),
    [sym_conjunct_pattern] = STATE(5177),
    [sym_typed_pattern] = STATE(5177),
    [sym_list_pattern] = STATE(5177),
    [sym_array_pattern] = STATE(5177),
    [sym_record_pattern] = STATE(5177),
    [sym_named_field_pattern] = STATE(5177),
    [sym_identifier_pattern] = STATE(5177),
    [sym_long_identifier_or_op] = STATE(3306),
    [sym_char] = STATE(5226),
    [sym_format_string] = STATE(5239),
    [sym__string_literal] = STATE(5239),
    [sym_string] = STATE(5226),
    [sym_verbatim_string] = STATE(5226),
    [sym_bytearray] = STATE(5226),
    [sym_verbatim_bytearray] = STATE(5226),
    [sym_format_triple_quoted_string] = STATE(5238),
    [sym_triple_quoted_string] = STATE(5226),
    [sym_const] = STATE(5177),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(5226),
    [sym_byte] = STATE(5226),
    [sym_int16] = STATE(5226),
    [sym_uint16] = STATE(5226),
    [sym_int32] = STATE(5226),
    [sym_uint32] = STATE(5226),
    [sym_nativeint] = STATE(5226),
    [sym_unativeint] = STATE(5226),
    [sym_int64] = STATE(5226),
    [sym_uint64] = STATE(5226),
    [sym_ieee32] = STATE(5226),
    [sym_ieee64] = STATE(5226),
    [sym_bignum] = STATE(5226),
    [sym_decimal] = STATE(5226),
    [sym_float] = STATE(4814),
    [sym_block_comment] = STATE(3306),
    [sym_compiler_directive_decl] = STATE(3306),
    [sym_fsi_directive_decl] = STATE(3306),
    [sym_preproc_line] = STATE(3306),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5558),
    [anon_sym_LBRACK_LT] = ACTIONS(5562),
    [anon_sym_COLON] = ACTIONS(5558),
    [anon_sym_as] = ACTIONS(5558),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_COMMA] = ACTIONS(5562),
    [anon_sym_null] = ACTIONS(5558),
    [anon_sym__] = ACTIONS(5558),
    [anon_sym_QMARK] = ACTIONS(5562),
    [anon_sym_COLON_QMARK] = ACTIONS(5562),
    [anon_sym_COLON_COLON] = ACTIONS(5562),
    [anon_sym_PIPE] = ACTIONS(5562),
    [anon_sym_AMP] = ACTIONS(5562),
    [anon_sym_LBRACK] = ACTIONS(5558),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5562),
    [anon_sym_LBRACE] = ACTIONS(5562),
    [anon_sym_DASH_GT] = ACTIONS(5562),
    [anon_sym_when] = ACTIONS(5558),
    [aux_sym_char_token1] = ACTIONS(5562),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5558),
    [anon_sym_DQUOTE] = ACTIONS(5558),
    [anon_sym_AT_DQUOTE] = ACTIONS(5562),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5562),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5562),
    [sym_bool] = ACTIONS(5558),
    [sym_unit] = ACTIONS(5562),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5558),
    [sym_op_identifier] = ACTIONS(5562),
    [sym_int] = ACTIONS(5558),
    [sym_xint] = ACTIONS(5562),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3307] = {
    [sym_block_comment] = STATE(3307),
    [sym_compiler_directive_decl] = STATE(3307),
    [sym_fsi_directive_decl] = STATE(3307),
    [sym_preproc_line] = STATE(3307),
    [sym_identifier] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4242),
    [anon_sym_COLON] = ACTIONS(4244),
    [anon_sym_return] = ACTIONS(4244),
    [anon_sym_do] = ACTIONS(4244),
    [anon_sym_let] = ACTIONS(4244),
    [anon_sym_let_BANG] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_null] = ACTIONS(4244),
    [anon_sym_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_COLON] = ACTIONS(4242),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4244),
    [anon_sym_LT_AT] = ACTIONS(4244),
    [anon_sym_AT_GT] = ACTIONS(4244),
    [anon_sym_LT_AT_AT] = ACTIONS(4244),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4242),
    [anon_sym_new] = ACTIONS(4244),
    [anon_sym_return_BANG] = ACTIONS(4242),
    [anon_sym_yield] = ACTIONS(4244),
    [anon_sym_yield_BANG] = ACTIONS(4242),
    [anon_sym_lazy] = ACTIONS(4244),
    [anon_sym_assert] = ACTIONS(4244),
    [anon_sym_upcast] = ACTIONS(4244),
    [anon_sym_downcast] = ACTIONS(4244),
    [anon_sym_COLON_GT] = ACTIONS(4242),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4242),
    [anon_sym_for] = ACTIONS(4244),
    [anon_sym_while] = ACTIONS(4244),
    [anon_sym_if] = ACTIONS(4244),
    [anon_sym_fun] = ACTIONS(4244),
    [anon_sym_try] = ACTIONS(4244),
    [anon_sym_match] = ACTIONS(4244),
    [anon_sym_match_BANG] = ACTIONS(4242),
    [anon_sym_function] = ACTIONS(4244),
    [anon_sym_LT_DASH] = ACTIONS(4244),
    [anon_sym_DOT_LBRACK] = ACTIONS(4242),
    [anon_sym_LT] = ACTIONS(4242),
    [anon_sym_use] = ACTIONS(4244),
    [anon_sym_use_BANG] = ACTIONS(4242),
    [anon_sym_do_BANG] = ACTIONS(4242),
    [anon_sym_begin] = ACTIONS(4244),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_or] = ACTIONS(4244),
    [aux_sym_char_token1] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4244),
    [anon_sym_DQUOTE] = ACTIONS(4244),
    [anon_sym_AT_DQUOTE] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [sym_bool] = ACTIONS(4244),
    [sym_unit] = ACTIONS(4242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4244),
    [sym_op_identifier] = ACTIONS(4244),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_DASH] = ACTIONS(4244),
    [anon_sym_PLUS_DOT] = ACTIONS(4244),
    [anon_sym_DASH_DOT] = ACTIONS(4244),
    [anon_sym_PERCENT] = ACTIONS(4244),
    [anon_sym_AMP_AMP] = ACTIONS(4244),
    [anon_sym_TILDE] = ACTIONS(4242),
    [aux_sym_prefix_op_token1] = ACTIONS(4244),
    [aux_sym_infix_op_token1] = ACTIONS(4242),
    [aux_sym_infix_op_token2] = ACTIONS(4244),
    [anon_sym_PIPE_PIPE] = ACTIONS(4244),
    [anon_sym_BANG_EQ] = ACTIONS(4244),
    [anon_sym_COLON_EQ] = ACTIONS(4242),
    [anon_sym_DOLLAR] = ACTIONS(4244),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4244),
    [sym_int] = ACTIONS(4244),
    [sym_xint] = ACTIONS(4242),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4242),
    [sym__newline] = ACTIONS(4242),
  },
  [3308] = {
    [sym_block_comment] = STATE(3308),
    [sym_compiler_directive_decl] = STATE(3308),
    [sym_fsi_directive_decl] = STATE(3308),
    [sym_preproc_line] = STATE(3308),
    [sym_identifier] = ACTIONS(4240),
    [anon_sym_EQ] = ACTIONS(4238),
    [anon_sym_COLON] = ACTIONS(4240),
    [anon_sym_return] = ACTIONS(4240),
    [anon_sym_do] = ACTIONS(4240),
    [anon_sym_let] = ACTIONS(4240),
    [anon_sym_let_BANG] = ACTIONS(4238),
    [anon_sym_LPAREN] = ACTIONS(4240),
    [anon_sym_COMMA] = ACTIONS(4238),
    [anon_sym_null] = ACTIONS(4240),
    [anon_sym_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_COLON] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4240),
    [anon_sym_LBRACK] = ACTIONS(4240),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4238),
    [anon_sym_LBRACE] = ACTIONS(4240),
    [anon_sym_LT_AT] = ACTIONS(4240),
    [anon_sym_AT_GT] = ACTIONS(4240),
    [anon_sym_LT_AT_AT] = ACTIONS(4240),
    [anon_sym_DOT] = ACTIONS(4240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4238),
    [anon_sym_new] = ACTIONS(4240),
    [anon_sym_return_BANG] = ACTIONS(4238),
    [anon_sym_yield] = ACTIONS(4240),
    [anon_sym_yield_BANG] = ACTIONS(4238),
    [anon_sym_lazy] = ACTIONS(4240),
    [anon_sym_assert] = ACTIONS(4240),
    [anon_sym_upcast] = ACTIONS(4240),
    [anon_sym_downcast] = ACTIONS(4240),
    [anon_sym_COLON_GT] = ACTIONS(4238),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4238),
    [anon_sym_for] = ACTIONS(4240),
    [anon_sym_while] = ACTIONS(4240),
    [anon_sym_if] = ACTIONS(4240),
    [anon_sym_fun] = ACTIONS(4240),
    [anon_sym_try] = ACTIONS(4240),
    [anon_sym_match] = ACTIONS(4240),
    [anon_sym_match_BANG] = ACTIONS(4238),
    [anon_sym_function] = ACTIONS(4240),
    [anon_sym_LT_DASH] = ACTIONS(4240),
    [anon_sym_DOT_LBRACK] = ACTIONS(4238),
    [anon_sym_LT] = ACTIONS(4238),
    [anon_sym_use] = ACTIONS(4240),
    [anon_sym_use_BANG] = ACTIONS(4238),
    [anon_sym_do_BANG] = ACTIONS(4238),
    [anon_sym_begin] = ACTIONS(4240),
    [anon_sym_LPAREN2] = ACTIONS(4240),
    [anon_sym_or] = ACTIONS(4240),
    [aux_sym_char_token1] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4240),
    [anon_sym_DQUOTE] = ACTIONS(4240),
    [anon_sym_AT_DQUOTE] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [sym_bool] = ACTIONS(4240),
    [sym_unit] = ACTIONS(4238),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4240),
    [sym_op_identifier] = ACTIONS(4240),
    [anon_sym_PLUS] = ACTIONS(4240),
    [anon_sym_DASH] = ACTIONS(4240),
    [anon_sym_PLUS_DOT] = ACTIONS(4240),
    [anon_sym_DASH_DOT] = ACTIONS(4240),
    [anon_sym_PERCENT] = ACTIONS(4240),
    [anon_sym_AMP_AMP] = ACTIONS(4240),
    [anon_sym_TILDE] = ACTIONS(4238),
    [aux_sym_prefix_op_token1] = ACTIONS(4240),
    [aux_sym_infix_op_token1] = ACTIONS(4238),
    [aux_sym_infix_op_token2] = ACTIONS(4240),
    [anon_sym_PIPE_PIPE] = ACTIONS(4240),
    [anon_sym_BANG_EQ] = ACTIONS(4240),
    [anon_sym_COLON_EQ] = ACTIONS(4238),
    [anon_sym_DOLLAR] = ACTIONS(4240),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4240),
    [sym_int] = ACTIONS(4240),
    [sym_xint] = ACTIONS(4238),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4238),
    [sym__newline] = ACTIONS(4238),
  },
  [3309] = {
    [sym_block_comment] = STATE(3309),
    [sym_compiler_directive_decl] = STATE(3309),
    [sym_fsi_directive_decl] = STATE(3309),
    [sym_preproc_line] = STATE(3309),
    [sym_identifier] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4242),
    [anon_sym_COLON] = ACTIONS(4244),
    [anon_sym_return] = ACTIONS(4244),
    [anon_sym_do] = ACTIONS(4244),
    [anon_sym_let] = ACTIONS(4244),
    [anon_sym_let_BANG] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_null] = ACTIONS(4244),
    [anon_sym_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_COLON] = ACTIONS(4242),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4244),
    [anon_sym_LT_AT] = ACTIONS(4244),
    [anon_sym_LT_AT_AT] = ACTIONS(4244),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4242),
    [anon_sym_new] = ACTIONS(4244),
    [anon_sym_return_BANG] = ACTIONS(4242),
    [anon_sym_yield] = ACTIONS(4244),
    [anon_sym_yield_BANG] = ACTIONS(4242),
    [anon_sym_lazy] = ACTIONS(4244),
    [anon_sym_assert] = ACTIONS(4244),
    [anon_sym_upcast] = ACTIONS(4244),
    [anon_sym_downcast] = ACTIONS(4244),
    [anon_sym_COLON_GT] = ACTIONS(4242),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4242),
    [anon_sym_for] = ACTIONS(4244),
    [anon_sym_while] = ACTIONS(4244),
    [anon_sym_if] = ACTIONS(4244),
    [anon_sym_fun] = ACTIONS(4244),
    [anon_sym_try] = ACTIONS(4244),
    [anon_sym_match] = ACTIONS(4244),
    [anon_sym_match_BANG] = ACTIONS(4242),
    [anon_sym_function] = ACTIONS(4244),
    [anon_sym_LT_DASH] = ACTIONS(4244),
    [anon_sym_DOT_LBRACK] = ACTIONS(4242),
    [anon_sym_LT] = ACTIONS(4242),
    [anon_sym_GT] = ACTIONS(4244),
    [anon_sym_use] = ACTIONS(4244),
    [anon_sym_use_BANG] = ACTIONS(4242),
    [anon_sym_do_BANG] = ACTIONS(4242),
    [anon_sym_begin] = ACTIONS(4244),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_or] = ACTIONS(4244),
    [aux_sym_char_token1] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4244),
    [anon_sym_DQUOTE] = ACTIONS(4244),
    [anon_sym_AT_DQUOTE] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [sym_bool] = ACTIONS(4244),
    [sym_unit] = ACTIONS(4242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4244),
    [sym_op_identifier] = ACTIONS(4244),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_DASH] = ACTIONS(4244),
    [anon_sym_PLUS_DOT] = ACTIONS(4244),
    [anon_sym_DASH_DOT] = ACTIONS(4244),
    [anon_sym_PERCENT] = ACTIONS(4244),
    [anon_sym_AMP_AMP] = ACTIONS(4244),
    [anon_sym_TILDE] = ACTIONS(4242),
    [aux_sym_prefix_op_token1] = ACTIONS(4244),
    [aux_sym_infix_op_token1] = ACTIONS(4242),
    [aux_sym_infix_op_token2] = ACTIONS(4244),
    [anon_sym_PIPE_PIPE] = ACTIONS(4244),
    [anon_sym_BANG_EQ] = ACTIONS(4244),
    [anon_sym_COLON_EQ] = ACTIONS(4242),
    [anon_sym_DOLLAR] = ACTIONS(4244),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4244),
    [sym_int] = ACTIONS(4244),
    [sym_xint] = ACTIONS(4242),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4242),
    [sym__newline] = ACTIONS(4242),
  },
  [3310] = {
    [sym_block_comment] = STATE(3310),
    [sym_compiler_directive_decl] = STATE(3310),
    [sym_fsi_directive_decl] = STATE(3310),
    [sym_preproc_line] = STATE(3310),
    [sym_identifier] = ACTIONS(4216),
    [anon_sym_EQ] = ACTIONS(4214),
    [anon_sym_COLON] = ACTIONS(4216),
    [anon_sym_return] = ACTIONS(4216),
    [anon_sym_do] = ACTIONS(4216),
    [anon_sym_let] = ACTIONS(4216),
    [anon_sym_let_BANG] = ACTIONS(4214),
    [anon_sym_LPAREN] = ACTIONS(4216),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_null] = ACTIONS(4216),
    [anon_sym_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_COLON] = ACTIONS(4214),
    [anon_sym_AMP] = ACTIONS(4216),
    [anon_sym_LBRACK] = ACTIONS(4216),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4214),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_LT_AT] = ACTIONS(4216),
    [anon_sym_LT_AT_AT] = ACTIONS(4216),
    [anon_sym_DOT] = ACTIONS(4216),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4214),
    [anon_sym_new] = ACTIONS(4216),
    [anon_sym_return_BANG] = ACTIONS(4214),
    [anon_sym_yield] = ACTIONS(4216),
    [anon_sym_yield_BANG] = ACTIONS(4214),
    [anon_sym_lazy] = ACTIONS(4216),
    [anon_sym_assert] = ACTIONS(4216),
    [anon_sym_upcast] = ACTIONS(4216),
    [anon_sym_downcast] = ACTIONS(4216),
    [anon_sym_COLON_GT] = ACTIONS(4214),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4214),
    [anon_sym_for] = ACTIONS(4216),
    [anon_sym_while] = ACTIONS(4216),
    [anon_sym_if] = ACTIONS(4216),
    [anon_sym_fun] = ACTIONS(4216),
    [anon_sym_try] = ACTIONS(4216),
    [anon_sym_match] = ACTIONS(4216),
    [anon_sym_match_BANG] = ACTIONS(4214),
    [anon_sym_function] = ACTIONS(4216),
    [anon_sym_LT_DASH] = ACTIONS(4216),
    [anon_sym_DOT_LBRACK] = ACTIONS(4214),
    [anon_sym_LT] = ACTIONS(4214),
    [anon_sym_use] = ACTIONS(4216),
    [anon_sym_use_BANG] = ACTIONS(4214),
    [anon_sym_do_BANG] = ACTIONS(4214),
    [anon_sym_DOT_DOT] = ACTIONS(4214),
    [anon_sym_begin] = ACTIONS(4216),
    [anon_sym_LPAREN2] = ACTIONS(4216),
    [anon_sym_or] = ACTIONS(4216),
    [aux_sym_char_token1] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4216),
    [anon_sym_DQUOTE] = ACTIONS(4216),
    [anon_sym_AT_DQUOTE] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [sym_bool] = ACTIONS(4216),
    [sym_unit] = ACTIONS(4214),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4216),
    [sym_op_identifier] = ACTIONS(4216),
    [anon_sym_PLUS] = ACTIONS(4216),
    [anon_sym_DASH] = ACTIONS(4216),
    [anon_sym_PLUS_DOT] = ACTIONS(4216),
    [anon_sym_DASH_DOT] = ACTIONS(4216),
    [anon_sym_PERCENT] = ACTIONS(4216),
    [anon_sym_AMP_AMP] = ACTIONS(4216),
    [anon_sym_TILDE] = ACTIONS(4214),
    [aux_sym_prefix_op_token1] = ACTIONS(4216),
    [aux_sym_infix_op_token1] = ACTIONS(4214),
    [aux_sym_infix_op_token2] = ACTIONS(4216),
    [anon_sym_PIPE_PIPE] = ACTIONS(4216),
    [anon_sym_BANG_EQ] = ACTIONS(4216),
    [anon_sym_COLON_EQ] = ACTIONS(4214),
    [anon_sym_DOLLAR] = ACTIONS(4216),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4216),
    [sym_int] = ACTIONS(4216),
    [sym_xint] = ACTIONS(4214),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4214),
    [sym__newline] = ACTIONS(4214),
  },
  [3311] = {
    [sym_block_comment] = STATE(3311),
    [sym_compiler_directive_decl] = STATE(3311),
    [sym_fsi_directive_decl] = STATE(3311),
    [sym_preproc_line] = STATE(3311),
    [sym_identifier] = ACTIONS(3958),
    [anon_sym_EQ] = ACTIONS(3956),
    [anon_sym_COLON] = ACTIONS(3958),
    [anon_sym_return] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(3958),
    [anon_sym_let] = ACTIONS(3958),
    [anon_sym_let_BANG] = ACTIONS(3956),
    [anon_sym_LPAREN] = ACTIONS(3958),
    [anon_sym_COMMA] = ACTIONS(3956),
    [anon_sym_null] = ACTIONS(3958),
    [anon_sym_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_COLON] = ACTIONS(3956),
    [anon_sym_AMP] = ACTIONS(3958),
    [anon_sym_LBRACK] = ACTIONS(3958),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3956),
    [anon_sym_LBRACE] = ACTIONS(3958),
    [anon_sym_LT_AT] = ACTIONS(3958),
    [anon_sym_LT_AT_AT] = ACTIONS(3958),
    [anon_sym_DOT] = ACTIONS(3958),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3956),
    [anon_sym_new] = ACTIONS(3958),
    [anon_sym_return_BANG] = ACTIONS(3956),
    [anon_sym_yield] = ACTIONS(3958),
    [anon_sym_yield_BANG] = ACTIONS(3956),
    [anon_sym_lazy] = ACTIONS(3958),
    [anon_sym_assert] = ACTIONS(3958),
    [anon_sym_upcast] = ACTIONS(3958),
    [anon_sym_downcast] = ACTIONS(3958),
    [anon_sym_COLON_GT] = ACTIONS(3956),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3956),
    [anon_sym_for] = ACTIONS(3958),
    [anon_sym_while] = ACTIONS(3958),
    [anon_sym_if] = ACTIONS(3958),
    [anon_sym_fun] = ACTIONS(3958),
    [anon_sym_try] = ACTIONS(3958),
    [anon_sym_match] = ACTIONS(3958),
    [anon_sym_match_BANG] = ACTIONS(3956),
    [anon_sym_function] = ACTIONS(3958),
    [anon_sym_LT_DASH] = ACTIONS(3958),
    [anon_sym_DOT_LBRACK] = ACTIONS(3956),
    [anon_sym_LT] = ACTIONS(3956),
    [anon_sym_use] = ACTIONS(3958),
    [anon_sym_use_BANG] = ACTIONS(3956),
    [anon_sym_do_BANG] = ACTIONS(3956),
    [anon_sym_DOT_DOT] = ACTIONS(3956),
    [anon_sym_begin] = ACTIONS(3958),
    [anon_sym_LPAREN2] = ACTIONS(3958),
    [anon_sym_or] = ACTIONS(3958),
    [aux_sym_char_token1] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [anon_sym_AT_DQUOTE] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [sym_bool] = ACTIONS(3958),
    [sym_unit] = ACTIONS(3956),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3958),
    [sym_op_identifier] = ACTIONS(3958),
    [anon_sym_PLUS] = ACTIONS(3958),
    [anon_sym_DASH] = ACTIONS(3958),
    [anon_sym_PLUS_DOT] = ACTIONS(3958),
    [anon_sym_DASH_DOT] = ACTIONS(3958),
    [anon_sym_PERCENT] = ACTIONS(3958),
    [anon_sym_AMP_AMP] = ACTIONS(3958),
    [anon_sym_TILDE] = ACTIONS(3956),
    [aux_sym_prefix_op_token1] = ACTIONS(3958),
    [aux_sym_infix_op_token1] = ACTIONS(3956),
    [aux_sym_infix_op_token2] = ACTIONS(3958),
    [anon_sym_PIPE_PIPE] = ACTIONS(3958),
    [anon_sym_BANG_EQ] = ACTIONS(3958),
    [anon_sym_COLON_EQ] = ACTIONS(3956),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3958),
    [sym_int] = ACTIONS(3958),
    [sym_xint] = ACTIONS(3956),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3956),
    [sym__newline] = ACTIONS(3956),
  },
  [3312] = {
    [sym_block_comment] = STATE(3312),
    [sym_compiler_directive_decl] = STATE(3312),
    [sym_fsi_directive_decl] = STATE(3312),
    [sym_preproc_line] = STATE(3312),
    [sym_identifier] = ACTIONS(4220),
    [anon_sym_EQ] = ACTIONS(4218),
    [anon_sym_COLON] = ACTIONS(4220),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_do] = ACTIONS(4220),
    [anon_sym_let] = ACTIONS(4220),
    [anon_sym_let_BANG] = ACTIONS(4218),
    [anon_sym_LPAREN] = ACTIONS(4220),
    [anon_sym_COMMA] = ACTIONS(4218),
    [anon_sym_null] = ACTIONS(4220),
    [anon_sym_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_COLON] = ACTIONS(4218),
    [anon_sym_AMP] = ACTIONS(4220),
    [anon_sym_LBRACK] = ACTIONS(4220),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(4220),
    [anon_sym_LT_AT] = ACTIONS(4220),
    [anon_sym_LT_AT_AT] = ACTIONS(4220),
    [anon_sym_DOT] = ACTIONS(4220),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4218),
    [anon_sym_new] = ACTIONS(4220),
    [anon_sym_return_BANG] = ACTIONS(4218),
    [anon_sym_yield] = ACTIONS(4220),
    [anon_sym_yield_BANG] = ACTIONS(4218),
    [anon_sym_lazy] = ACTIONS(4220),
    [anon_sym_assert] = ACTIONS(4220),
    [anon_sym_upcast] = ACTIONS(4220),
    [anon_sym_downcast] = ACTIONS(4220),
    [anon_sym_COLON_GT] = ACTIONS(4218),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4218),
    [anon_sym_for] = ACTIONS(4220),
    [anon_sym_while] = ACTIONS(4220),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_fun] = ACTIONS(4220),
    [anon_sym_try] = ACTIONS(4220),
    [anon_sym_match] = ACTIONS(4220),
    [anon_sym_match_BANG] = ACTIONS(4218),
    [anon_sym_function] = ACTIONS(4220),
    [anon_sym_LT_DASH] = ACTIONS(4220),
    [anon_sym_DOT_LBRACK] = ACTIONS(4218),
    [anon_sym_LT] = ACTIONS(4218),
    [anon_sym_use] = ACTIONS(4220),
    [anon_sym_use_BANG] = ACTIONS(4218),
    [anon_sym_do_BANG] = ACTIONS(4218),
    [anon_sym_DOT_DOT] = ACTIONS(4218),
    [anon_sym_begin] = ACTIONS(4220),
    [anon_sym_LPAREN2] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(4220),
    [aux_sym_char_token1] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4220),
    [anon_sym_DQUOTE] = ACTIONS(4220),
    [anon_sym_AT_DQUOTE] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [sym_bool] = ACTIONS(4220),
    [sym_unit] = ACTIONS(4218),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4220),
    [sym_op_identifier] = ACTIONS(4220),
    [anon_sym_PLUS] = ACTIONS(4220),
    [anon_sym_DASH] = ACTIONS(4220),
    [anon_sym_PLUS_DOT] = ACTIONS(4220),
    [anon_sym_DASH_DOT] = ACTIONS(4220),
    [anon_sym_PERCENT] = ACTIONS(4220),
    [anon_sym_AMP_AMP] = ACTIONS(4220),
    [anon_sym_TILDE] = ACTIONS(4218),
    [aux_sym_prefix_op_token1] = ACTIONS(4220),
    [aux_sym_infix_op_token1] = ACTIONS(4218),
    [aux_sym_infix_op_token2] = ACTIONS(4220),
    [anon_sym_PIPE_PIPE] = ACTIONS(4220),
    [anon_sym_BANG_EQ] = ACTIONS(4220),
    [anon_sym_COLON_EQ] = ACTIONS(4218),
    [anon_sym_DOLLAR] = ACTIONS(4220),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4220),
    [sym_int] = ACTIONS(4220),
    [sym_xint] = ACTIONS(4218),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4218),
    [sym__newline] = ACTIONS(4218),
  },
  [3313] = {
    [sym_block_comment] = STATE(3313),
    [sym_compiler_directive_decl] = STATE(3313),
    [sym_fsi_directive_decl] = STATE(3313),
    [sym_preproc_line] = STATE(3313),
    [sym_identifier] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4078),
    [anon_sym_return] = ACTIONS(4078),
    [anon_sym_do] = ACTIONS(4078),
    [anon_sym_let] = ACTIONS(4078),
    [anon_sym_let_BANG] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_null] = ACTIONS(4078),
    [anon_sym_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(4076),
    [anon_sym_AMP] = ACTIONS(4078),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4078),
    [anon_sym_LT_AT] = ACTIONS(4078),
    [anon_sym_LT_AT_AT] = ACTIONS(4078),
    [anon_sym_AT_AT_GT] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(4078),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4076),
    [anon_sym_new] = ACTIONS(4078),
    [anon_sym_return_BANG] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(4078),
    [anon_sym_yield_BANG] = ACTIONS(4076),
    [anon_sym_lazy] = ACTIONS(4078),
    [anon_sym_assert] = ACTIONS(4078),
    [anon_sym_upcast] = ACTIONS(4078),
    [anon_sym_downcast] = ACTIONS(4078),
    [anon_sym_COLON_GT] = ACTIONS(4076),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4076),
    [anon_sym_for] = ACTIONS(4078),
    [anon_sym_while] = ACTIONS(4078),
    [anon_sym_if] = ACTIONS(4078),
    [anon_sym_fun] = ACTIONS(4078),
    [anon_sym_try] = ACTIONS(4078),
    [anon_sym_match] = ACTIONS(4078),
    [anon_sym_match_BANG] = ACTIONS(4076),
    [anon_sym_function] = ACTIONS(4078),
    [anon_sym_LT_DASH] = ACTIONS(4078),
    [anon_sym_DOT_LBRACK] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4076),
    [anon_sym_use] = ACTIONS(4078),
    [anon_sym_use_BANG] = ACTIONS(4076),
    [anon_sym_do_BANG] = ACTIONS(4076),
    [anon_sym_begin] = ACTIONS(4078),
    [anon_sym_LPAREN2] = ACTIONS(4078),
    [anon_sym_or] = ACTIONS(4078),
    [aux_sym_char_token1] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4078),
    [anon_sym_DQUOTE] = ACTIONS(4078),
    [anon_sym_AT_DQUOTE] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [sym_bool] = ACTIONS(4078),
    [sym_unit] = ACTIONS(4076),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4078),
    [sym_op_identifier] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(4078),
    [anon_sym_PLUS_DOT] = ACTIONS(4078),
    [anon_sym_DASH_DOT] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [anon_sym_AMP_AMP] = ACTIONS(4078),
    [anon_sym_TILDE] = ACTIONS(4076),
    [aux_sym_prefix_op_token1] = ACTIONS(4078),
    [aux_sym_infix_op_token1] = ACTIONS(4076),
    [aux_sym_infix_op_token2] = ACTIONS(4078),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_BANG_EQ] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4076),
    [anon_sym_DOLLAR] = ACTIONS(4078),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4078),
    [sym_int] = ACTIONS(4078),
    [sym_xint] = ACTIONS(4076),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4076),
    [sym__newline] = ACTIONS(4076),
  },
  [3314] = {
    [sym_block_comment] = STATE(3314),
    [sym_compiler_directive_decl] = STATE(3314),
    [sym_fsi_directive_decl] = STATE(3314),
    [sym_preproc_line] = STATE(3314),
    [sym_identifier] = ACTIONS(4236),
    [anon_sym_EQ] = ACTIONS(4234),
    [anon_sym_COLON] = ACTIONS(4236),
    [anon_sym_return] = ACTIONS(4236),
    [anon_sym_do] = ACTIONS(4236),
    [anon_sym_let] = ACTIONS(4236),
    [anon_sym_let_BANG] = ACTIONS(4234),
    [anon_sym_LPAREN] = ACTIONS(4236),
    [anon_sym_COMMA] = ACTIONS(4234),
    [anon_sym_null] = ACTIONS(4236),
    [anon_sym_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_COLON] = ACTIONS(4234),
    [anon_sym_AMP] = ACTIONS(4236),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4234),
    [anon_sym_LBRACE] = ACTIONS(4236),
    [anon_sym_LT_AT] = ACTIONS(4236),
    [anon_sym_LT_AT_AT] = ACTIONS(4236),
    [anon_sym_DOT] = ACTIONS(4236),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4234),
    [anon_sym_new] = ACTIONS(4236),
    [anon_sym_return_BANG] = ACTIONS(4234),
    [anon_sym_yield] = ACTIONS(4236),
    [anon_sym_yield_BANG] = ACTIONS(4234),
    [anon_sym_lazy] = ACTIONS(4236),
    [anon_sym_assert] = ACTIONS(4236),
    [anon_sym_upcast] = ACTIONS(4236),
    [anon_sym_downcast] = ACTIONS(4236),
    [anon_sym_COLON_GT] = ACTIONS(4234),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4234),
    [anon_sym_for] = ACTIONS(4236),
    [anon_sym_while] = ACTIONS(4236),
    [anon_sym_if] = ACTIONS(4236),
    [anon_sym_fun] = ACTIONS(4236),
    [anon_sym_try] = ACTIONS(4236),
    [anon_sym_match] = ACTIONS(4236),
    [anon_sym_match_BANG] = ACTIONS(4234),
    [anon_sym_function] = ACTIONS(4236),
    [anon_sym_LT_DASH] = ACTIONS(4236),
    [anon_sym_DOT_LBRACK] = ACTIONS(4234),
    [anon_sym_LT] = ACTIONS(4234),
    [anon_sym_use] = ACTIONS(4236),
    [anon_sym_use_BANG] = ACTIONS(4234),
    [anon_sym_do_BANG] = ACTIONS(4234),
    [anon_sym_DOT_DOT] = ACTIONS(4234),
    [anon_sym_begin] = ACTIONS(4236),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_or] = ACTIONS(4236),
    [aux_sym_char_token1] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4236),
    [anon_sym_DQUOTE] = ACTIONS(4236),
    [anon_sym_AT_DQUOTE] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [sym_bool] = ACTIONS(4236),
    [sym_unit] = ACTIONS(4234),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4236),
    [sym_op_identifier] = ACTIONS(4236),
    [anon_sym_PLUS] = ACTIONS(4236),
    [anon_sym_DASH] = ACTIONS(4236),
    [anon_sym_PLUS_DOT] = ACTIONS(4236),
    [anon_sym_DASH_DOT] = ACTIONS(4236),
    [anon_sym_PERCENT] = ACTIONS(4236),
    [anon_sym_AMP_AMP] = ACTIONS(4236),
    [anon_sym_TILDE] = ACTIONS(4234),
    [aux_sym_prefix_op_token1] = ACTIONS(4236),
    [aux_sym_infix_op_token1] = ACTIONS(4234),
    [aux_sym_infix_op_token2] = ACTIONS(4236),
    [anon_sym_PIPE_PIPE] = ACTIONS(4236),
    [anon_sym_BANG_EQ] = ACTIONS(4236),
    [anon_sym_COLON_EQ] = ACTIONS(4234),
    [anon_sym_DOLLAR] = ACTIONS(4236),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4236),
    [sym_int] = ACTIONS(4236),
    [sym_xint] = ACTIONS(4234),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4234),
    [sym__newline] = ACTIONS(4234),
  },
  [3315] = {
    [sym_block_comment] = STATE(3315),
    [sym_compiler_directive_decl] = STATE(3315),
    [sym_fsi_directive_decl] = STATE(3315),
    [sym_preproc_line] = STATE(3315),
    [sym_identifier] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4246),
    [anon_sym_COLON] = ACTIONS(4248),
    [anon_sym_return] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4248),
    [anon_sym_let] = ACTIONS(4248),
    [anon_sym_let_BANG] = ACTIONS(4246),
    [anon_sym_LPAREN] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_null] = ACTIONS(4248),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4248),
    [anon_sym_LT_AT] = ACTIONS(4248),
    [anon_sym_LT_AT_AT] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4246),
    [anon_sym_new] = ACTIONS(4248),
    [anon_sym_return_BANG] = ACTIONS(4246),
    [anon_sym_yield] = ACTIONS(4248),
    [anon_sym_yield_BANG] = ACTIONS(4246),
    [anon_sym_lazy] = ACTIONS(4248),
    [anon_sym_assert] = ACTIONS(4248),
    [anon_sym_upcast] = ACTIONS(4248),
    [anon_sym_downcast] = ACTIONS(4248),
    [anon_sym_COLON_GT] = ACTIONS(4246),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4246),
    [anon_sym_for] = ACTIONS(4248),
    [anon_sym_while] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4248),
    [anon_sym_fun] = ACTIONS(4248),
    [anon_sym_try] = ACTIONS(4248),
    [anon_sym_match] = ACTIONS(4248),
    [anon_sym_match_BANG] = ACTIONS(4246),
    [anon_sym_function] = ACTIONS(4248),
    [anon_sym_LT_DASH] = ACTIONS(4248),
    [anon_sym_DOT_LBRACK] = ACTIONS(4246),
    [anon_sym_LT] = ACTIONS(4246),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_use] = ACTIONS(4248),
    [anon_sym_use_BANG] = ACTIONS(4246),
    [anon_sym_do_BANG] = ACTIONS(4246),
    [anon_sym_begin] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4248),
    [aux_sym_char_token1] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4248),
    [anon_sym_DQUOTE] = ACTIONS(4248),
    [anon_sym_AT_DQUOTE] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [sym_bool] = ACTIONS(4248),
    [sym_unit] = ACTIONS(4246),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4248),
    [sym_op_identifier] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_DOT] = ACTIONS(4248),
    [anon_sym_DASH_DOT] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_TILDE] = ACTIONS(4246),
    [aux_sym_prefix_op_token1] = ACTIONS(4248),
    [aux_sym_infix_op_token1] = ACTIONS(4246),
    [aux_sym_infix_op_token2] = ACTIONS(4248),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_COLON_EQ] = ACTIONS(4246),
    [anon_sym_DOLLAR] = ACTIONS(4248),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4248),
    [sym_int] = ACTIONS(4248),
    [sym_xint] = ACTIONS(4246),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4246),
    [sym__newline] = ACTIONS(4246),
  },
  [3316] = {
    [sym_block_comment] = STATE(3316),
    [sym_compiler_directive_decl] = STATE(3316),
    [sym_fsi_directive_decl] = STATE(3316),
    [sym_preproc_line] = STATE(3316),
    [sym_identifier] = ACTIONS(4240),
    [anon_sym_EQ] = ACTIONS(4238),
    [anon_sym_COLON] = ACTIONS(4240),
    [anon_sym_return] = ACTIONS(4240),
    [anon_sym_do] = ACTIONS(4240),
    [anon_sym_let] = ACTIONS(4240),
    [anon_sym_let_BANG] = ACTIONS(4238),
    [anon_sym_LPAREN] = ACTIONS(4240),
    [anon_sym_COMMA] = ACTIONS(4238),
    [anon_sym_null] = ACTIONS(4240),
    [anon_sym_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_COLON] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4240),
    [anon_sym_LBRACK] = ACTIONS(4240),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4238),
    [anon_sym_LBRACE] = ACTIONS(4240),
    [anon_sym_LT_AT] = ACTIONS(4240),
    [anon_sym_LT_AT_AT] = ACTIONS(4240),
    [anon_sym_DOT] = ACTIONS(4240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4238),
    [anon_sym_new] = ACTIONS(4240),
    [anon_sym_return_BANG] = ACTIONS(4238),
    [anon_sym_yield] = ACTIONS(4240),
    [anon_sym_yield_BANG] = ACTIONS(4238),
    [anon_sym_lazy] = ACTIONS(4240),
    [anon_sym_assert] = ACTIONS(4240),
    [anon_sym_upcast] = ACTIONS(4240),
    [anon_sym_downcast] = ACTIONS(4240),
    [anon_sym_COLON_GT] = ACTIONS(4238),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4238),
    [anon_sym_for] = ACTIONS(4240),
    [anon_sym_while] = ACTIONS(4240),
    [anon_sym_if] = ACTIONS(4240),
    [anon_sym_fun] = ACTIONS(4240),
    [anon_sym_try] = ACTIONS(4240),
    [anon_sym_match] = ACTIONS(4240),
    [anon_sym_match_BANG] = ACTIONS(4238),
    [anon_sym_function] = ACTIONS(4240),
    [anon_sym_LT_DASH] = ACTIONS(4240),
    [anon_sym_DOT_LBRACK] = ACTIONS(4238),
    [anon_sym_LT] = ACTIONS(4238),
    [anon_sym_use] = ACTIONS(4240),
    [anon_sym_use_BANG] = ACTIONS(4238),
    [anon_sym_do_BANG] = ACTIONS(4238),
    [anon_sym_DOT_DOT] = ACTIONS(4238),
    [anon_sym_begin] = ACTIONS(4240),
    [anon_sym_LPAREN2] = ACTIONS(4240),
    [anon_sym_or] = ACTIONS(4240),
    [aux_sym_char_token1] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4240),
    [anon_sym_DQUOTE] = ACTIONS(4240),
    [anon_sym_AT_DQUOTE] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [sym_bool] = ACTIONS(4240),
    [sym_unit] = ACTIONS(4238),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4240),
    [sym_op_identifier] = ACTIONS(4240),
    [anon_sym_PLUS] = ACTIONS(4240),
    [anon_sym_DASH] = ACTIONS(4240),
    [anon_sym_PLUS_DOT] = ACTIONS(4240),
    [anon_sym_DASH_DOT] = ACTIONS(4240),
    [anon_sym_PERCENT] = ACTIONS(4240),
    [anon_sym_AMP_AMP] = ACTIONS(4240),
    [anon_sym_TILDE] = ACTIONS(4238),
    [aux_sym_prefix_op_token1] = ACTIONS(4240),
    [aux_sym_infix_op_token1] = ACTIONS(4238),
    [aux_sym_infix_op_token2] = ACTIONS(4240),
    [anon_sym_PIPE_PIPE] = ACTIONS(4240),
    [anon_sym_BANG_EQ] = ACTIONS(4240),
    [anon_sym_COLON_EQ] = ACTIONS(4238),
    [anon_sym_DOLLAR] = ACTIONS(4240),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4240),
    [sym_int] = ACTIONS(4240),
    [sym_xint] = ACTIONS(4238),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4238),
    [sym__newline] = ACTIONS(4238),
  },
  [3317] = {
    [sym_block_comment] = STATE(3317),
    [sym_compiler_directive_decl] = STATE(3317),
    [sym_fsi_directive_decl] = STATE(3317),
    [sym_preproc_line] = STATE(3317),
    [sym_identifier] = ACTIONS(3962),
    [anon_sym_EQ] = ACTIONS(3960),
    [anon_sym_COLON] = ACTIONS(3962),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_do] = ACTIONS(3962),
    [anon_sym_let] = ACTIONS(3962),
    [anon_sym_let_BANG] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_COMMA] = ACTIONS(3960),
    [anon_sym_null] = ACTIONS(3962),
    [anon_sym_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_COLON] = ACTIONS(3960),
    [anon_sym_AMP] = ACTIONS(3962),
    [anon_sym_LBRACK] = ACTIONS(3962),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_LT_AT] = ACTIONS(3962),
    [anon_sym_LT_AT_AT] = ACTIONS(3962),
    [anon_sym_DOT] = ACTIONS(3962),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3960),
    [anon_sym_new] = ACTIONS(3962),
    [anon_sym_return_BANG] = ACTIONS(3960),
    [anon_sym_yield] = ACTIONS(3962),
    [anon_sym_yield_BANG] = ACTIONS(3960),
    [anon_sym_lazy] = ACTIONS(3962),
    [anon_sym_assert] = ACTIONS(3962),
    [anon_sym_upcast] = ACTIONS(3962),
    [anon_sym_downcast] = ACTIONS(3962),
    [anon_sym_COLON_GT] = ACTIONS(3960),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3960),
    [anon_sym_for] = ACTIONS(3962),
    [anon_sym_while] = ACTIONS(3962),
    [anon_sym_if] = ACTIONS(3962),
    [anon_sym_fun] = ACTIONS(3962),
    [anon_sym_try] = ACTIONS(3962),
    [anon_sym_match] = ACTIONS(3962),
    [anon_sym_match_BANG] = ACTIONS(3960),
    [anon_sym_function] = ACTIONS(3962),
    [anon_sym_LT_DASH] = ACTIONS(3962),
    [anon_sym_DOT_LBRACK] = ACTIONS(3960),
    [anon_sym_LT] = ACTIONS(3960),
    [anon_sym_use] = ACTIONS(3962),
    [anon_sym_use_BANG] = ACTIONS(3960),
    [anon_sym_do_BANG] = ACTIONS(3960),
    [anon_sym_DOT_DOT] = ACTIONS(3960),
    [anon_sym_begin] = ACTIONS(3962),
    [anon_sym_LPAREN2] = ACTIONS(3962),
    [anon_sym_or] = ACTIONS(3962),
    [aux_sym_char_token1] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3962),
    [anon_sym_DQUOTE] = ACTIONS(3962),
    [anon_sym_AT_DQUOTE] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [sym_bool] = ACTIONS(3962),
    [sym_unit] = ACTIONS(3960),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3962),
    [sym_op_identifier] = ACTIONS(3962),
    [anon_sym_PLUS] = ACTIONS(3962),
    [anon_sym_DASH] = ACTIONS(3962),
    [anon_sym_PLUS_DOT] = ACTIONS(3962),
    [anon_sym_DASH_DOT] = ACTIONS(3962),
    [anon_sym_PERCENT] = ACTIONS(3962),
    [anon_sym_AMP_AMP] = ACTIONS(3962),
    [anon_sym_TILDE] = ACTIONS(3960),
    [aux_sym_prefix_op_token1] = ACTIONS(3962),
    [aux_sym_infix_op_token1] = ACTIONS(3960),
    [aux_sym_infix_op_token2] = ACTIONS(3962),
    [anon_sym_PIPE_PIPE] = ACTIONS(3962),
    [anon_sym_BANG_EQ] = ACTIONS(3962),
    [anon_sym_COLON_EQ] = ACTIONS(3960),
    [anon_sym_DOLLAR] = ACTIONS(3962),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3962),
    [sym_int] = ACTIONS(3962),
    [sym_xint] = ACTIONS(3960),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3960),
    [sym__newline] = ACTIONS(3960),
  },
  [3318] = {
    [sym_block_comment] = STATE(3318),
    [sym_compiler_directive_decl] = STATE(3318),
    [sym_fsi_directive_decl] = STATE(3318),
    [sym_preproc_line] = STATE(3318),
    [sym_identifier] = ACTIONS(4232),
    [anon_sym_EQ] = ACTIONS(4230),
    [anon_sym_COLON] = ACTIONS(4232),
    [anon_sym_return] = ACTIONS(4232),
    [anon_sym_do] = ACTIONS(4232),
    [anon_sym_let] = ACTIONS(4232),
    [anon_sym_let_BANG] = ACTIONS(4230),
    [anon_sym_LPAREN] = ACTIONS(4232),
    [anon_sym_COMMA] = ACTIONS(4230),
    [anon_sym_null] = ACTIONS(4232),
    [anon_sym_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_COLON] = ACTIONS(4230),
    [anon_sym_AMP] = ACTIONS(4232),
    [anon_sym_LBRACK] = ACTIONS(4232),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4230),
    [anon_sym_LBRACE] = ACTIONS(4232),
    [anon_sym_LT_AT] = ACTIONS(4232),
    [anon_sym_LT_AT_AT] = ACTIONS(4232),
    [anon_sym_DOT] = ACTIONS(4232),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4230),
    [anon_sym_new] = ACTIONS(4232),
    [anon_sym_return_BANG] = ACTIONS(4230),
    [anon_sym_yield] = ACTIONS(4232),
    [anon_sym_yield_BANG] = ACTIONS(4230),
    [anon_sym_lazy] = ACTIONS(4232),
    [anon_sym_assert] = ACTIONS(4232),
    [anon_sym_upcast] = ACTIONS(4232),
    [anon_sym_downcast] = ACTIONS(4232),
    [anon_sym_COLON_GT] = ACTIONS(4230),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4230),
    [anon_sym_for] = ACTIONS(4232),
    [anon_sym_while] = ACTIONS(4232),
    [anon_sym_if] = ACTIONS(4232),
    [anon_sym_fun] = ACTIONS(4232),
    [anon_sym_try] = ACTIONS(4232),
    [anon_sym_match] = ACTIONS(4232),
    [anon_sym_match_BANG] = ACTIONS(4230),
    [anon_sym_function] = ACTIONS(4232),
    [anon_sym_LT_DASH] = ACTIONS(4232),
    [anon_sym_DOT_LBRACK] = ACTIONS(4230),
    [anon_sym_LT] = ACTIONS(4230),
    [anon_sym_use] = ACTIONS(4232),
    [anon_sym_use_BANG] = ACTIONS(4230),
    [anon_sym_do_BANG] = ACTIONS(4230),
    [anon_sym_DOT_DOT] = ACTIONS(4230),
    [anon_sym_begin] = ACTIONS(4232),
    [anon_sym_LPAREN2] = ACTIONS(4232),
    [anon_sym_or] = ACTIONS(4232),
    [aux_sym_char_token1] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4232),
    [anon_sym_DQUOTE] = ACTIONS(4232),
    [anon_sym_AT_DQUOTE] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [sym_bool] = ACTIONS(4232),
    [sym_unit] = ACTIONS(4230),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4232),
    [sym_op_identifier] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4232),
    [anon_sym_DASH] = ACTIONS(4232),
    [anon_sym_PLUS_DOT] = ACTIONS(4232),
    [anon_sym_DASH_DOT] = ACTIONS(4232),
    [anon_sym_PERCENT] = ACTIONS(4232),
    [anon_sym_AMP_AMP] = ACTIONS(4232),
    [anon_sym_TILDE] = ACTIONS(4230),
    [aux_sym_prefix_op_token1] = ACTIONS(4232),
    [aux_sym_infix_op_token1] = ACTIONS(4230),
    [aux_sym_infix_op_token2] = ACTIONS(4232),
    [anon_sym_PIPE_PIPE] = ACTIONS(4232),
    [anon_sym_BANG_EQ] = ACTIONS(4232),
    [anon_sym_COLON_EQ] = ACTIONS(4230),
    [anon_sym_DOLLAR] = ACTIONS(4232),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4232),
    [sym_int] = ACTIONS(4232),
    [sym_xint] = ACTIONS(4230),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4230),
    [sym__newline] = ACTIONS(4230),
  },
  [3319] = {
    [sym_block_comment] = STATE(3319),
    [sym_compiler_directive_decl] = STATE(3319),
    [sym_fsi_directive_decl] = STATE(3319),
    [sym_preproc_line] = STATE(3319),
    [sym_identifier] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4242),
    [anon_sym_COLON] = ACTIONS(4244),
    [anon_sym_return] = ACTIONS(4244),
    [anon_sym_do] = ACTIONS(4244),
    [anon_sym_let] = ACTIONS(4244),
    [anon_sym_let_BANG] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_null] = ACTIONS(4244),
    [anon_sym_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_COLON] = ACTIONS(4242),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4244),
    [anon_sym_LT_AT] = ACTIONS(4244),
    [anon_sym_LT_AT_AT] = ACTIONS(4244),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4242),
    [anon_sym_new] = ACTIONS(4244),
    [anon_sym_return_BANG] = ACTIONS(4242),
    [anon_sym_yield] = ACTIONS(4244),
    [anon_sym_yield_BANG] = ACTIONS(4242),
    [anon_sym_lazy] = ACTIONS(4244),
    [anon_sym_assert] = ACTIONS(4244),
    [anon_sym_upcast] = ACTIONS(4244),
    [anon_sym_downcast] = ACTIONS(4244),
    [anon_sym_COLON_GT] = ACTIONS(4242),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4242),
    [anon_sym_for] = ACTIONS(4244),
    [anon_sym_while] = ACTIONS(4244),
    [anon_sym_if] = ACTIONS(4244),
    [anon_sym_fun] = ACTIONS(4244),
    [anon_sym_try] = ACTIONS(4244),
    [anon_sym_match] = ACTIONS(4244),
    [anon_sym_match_BANG] = ACTIONS(4242),
    [anon_sym_function] = ACTIONS(4244),
    [anon_sym_LT_DASH] = ACTIONS(4244),
    [anon_sym_DOT_LBRACK] = ACTIONS(4242),
    [anon_sym_LT] = ACTIONS(4242),
    [anon_sym_use] = ACTIONS(4244),
    [anon_sym_use_BANG] = ACTIONS(4242),
    [anon_sym_do_BANG] = ACTIONS(4242),
    [anon_sym_DOT_DOT] = ACTIONS(4242),
    [anon_sym_begin] = ACTIONS(4244),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_or] = ACTIONS(4244),
    [aux_sym_char_token1] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4244),
    [anon_sym_DQUOTE] = ACTIONS(4244),
    [anon_sym_AT_DQUOTE] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [sym_bool] = ACTIONS(4244),
    [sym_unit] = ACTIONS(4242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4244),
    [sym_op_identifier] = ACTIONS(4244),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_DASH] = ACTIONS(4244),
    [anon_sym_PLUS_DOT] = ACTIONS(4244),
    [anon_sym_DASH_DOT] = ACTIONS(4244),
    [anon_sym_PERCENT] = ACTIONS(4244),
    [anon_sym_AMP_AMP] = ACTIONS(4244),
    [anon_sym_TILDE] = ACTIONS(4242),
    [aux_sym_prefix_op_token1] = ACTIONS(4244),
    [aux_sym_infix_op_token1] = ACTIONS(4242),
    [aux_sym_infix_op_token2] = ACTIONS(4244),
    [anon_sym_PIPE_PIPE] = ACTIONS(4244),
    [anon_sym_BANG_EQ] = ACTIONS(4244),
    [anon_sym_COLON_EQ] = ACTIONS(4242),
    [anon_sym_DOLLAR] = ACTIONS(4244),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4244),
    [sym_int] = ACTIONS(4244),
    [sym_xint] = ACTIONS(4242),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4242),
    [sym__newline] = ACTIONS(4242),
  },
  [3320] = {
    [sym_block_comment] = STATE(3320),
    [sym_compiler_directive_decl] = STATE(3320),
    [sym_fsi_directive_decl] = STATE(3320),
    [sym_preproc_line] = STATE(3320),
    [sym_identifier] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4246),
    [anon_sym_COLON] = ACTIONS(4248),
    [anon_sym_return] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4248),
    [anon_sym_let] = ACTIONS(4248),
    [anon_sym_let_BANG] = ACTIONS(4246),
    [anon_sym_LPAREN] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_null] = ACTIONS(4248),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4248),
    [anon_sym_LT_AT] = ACTIONS(4248),
    [anon_sym_LT_AT_AT] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4246),
    [anon_sym_new] = ACTIONS(4248),
    [anon_sym_return_BANG] = ACTIONS(4246),
    [anon_sym_yield] = ACTIONS(4248),
    [anon_sym_yield_BANG] = ACTIONS(4246),
    [anon_sym_lazy] = ACTIONS(4248),
    [anon_sym_assert] = ACTIONS(4248),
    [anon_sym_upcast] = ACTIONS(4248),
    [anon_sym_downcast] = ACTIONS(4248),
    [anon_sym_COLON_GT] = ACTIONS(4246),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4246),
    [anon_sym_for] = ACTIONS(4248),
    [anon_sym_while] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4248),
    [anon_sym_fun] = ACTIONS(4248),
    [anon_sym_try] = ACTIONS(4248),
    [anon_sym_match] = ACTIONS(4248),
    [anon_sym_match_BANG] = ACTIONS(4246),
    [anon_sym_function] = ACTIONS(4248),
    [anon_sym_LT_DASH] = ACTIONS(4248),
    [anon_sym_DOT_LBRACK] = ACTIONS(4246),
    [anon_sym_LT] = ACTIONS(4246),
    [anon_sym_use] = ACTIONS(4248),
    [anon_sym_use_BANG] = ACTIONS(4246),
    [anon_sym_do_BANG] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4246),
    [anon_sym_begin] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4248),
    [aux_sym_char_token1] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4248),
    [anon_sym_DQUOTE] = ACTIONS(4248),
    [anon_sym_AT_DQUOTE] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [sym_bool] = ACTIONS(4248),
    [sym_unit] = ACTIONS(4246),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4248),
    [sym_op_identifier] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_DOT] = ACTIONS(4248),
    [anon_sym_DASH_DOT] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_TILDE] = ACTIONS(4246),
    [aux_sym_prefix_op_token1] = ACTIONS(4248),
    [aux_sym_infix_op_token1] = ACTIONS(4246),
    [aux_sym_infix_op_token2] = ACTIONS(4248),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_COLON_EQ] = ACTIONS(4246),
    [anon_sym_DOLLAR] = ACTIONS(4248),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4248),
    [sym_int] = ACTIONS(4248),
    [sym_xint] = ACTIONS(4246),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4246),
    [sym__newline] = ACTIONS(4246),
  },
  [3321] = {
    [sym_block_comment] = STATE(3321),
    [sym_compiler_directive_decl] = STATE(3321),
    [sym_fsi_directive_decl] = STATE(3321),
    [sym_preproc_line] = STATE(3321),
    [sym_identifier] = ACTIONS(4236),
    [anon_sym_EQ] = ACTIONS(4234),
    [anon_sym_COLON] = ACTIONS(4236),
    [anon_sym_return] = ACTIONS(4236),
    [anon_sym_do] = ACTIONS(4236),
    [anon_sym_let] = ACTIONS(4236),
    [anon_sym_let_BANG] = ACTIONS(4234),
    [anon_sym_LPAREN] = ACTIONS(4236),
    [anon_sym_COMMA] = ACTIONS(4234),
    [anon_sym_null] = ACTIONS(4236),
    [anon_sym_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_COLON] = ACTIONS(4234),
    [anon_sym_AMP] = ACTIONS(4236),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4234),
    [anon_sym_LBRACE] = ACTIONS(4236),
    [anon_sym_LT_AT] = ACTIONS(4236),
    [anon_sym_AT_GT] = ACTIONS(4236),
    [anon_sym_LT_AT_AT] = ACTIONS(4236),
    [anon_sym_DOT] = ACTIONS(4236),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4234),
    [anon_sym_new] = ACTIONS(4236),
    [anon_sym_return_BANG] = ACTIONS(4234),
    [anon_sym_yield] = ACTIONS(4236),
    [anon_sym_yield_BANG] = ACTIONS(4234),
    [anon_sym_lazy] = ACTIONS(4236),
    [anon_sym_assert] = ACTIONS(4236),
    [anon_sym_upcast] = ACTIONS(4236),
    [anon_sym_downcast] = ACTIONS(4236),
    [anon_sym_COLON_GT] = ACTIONS(4234),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4234),
    [anon_sym_for] = ACTIONS(4236),
    [anon_sym_while] = ACTIONS(4236),
    [anon_sym_if] = ACTIONS(4236),
    [anon_sym_fun] = ACTIONS(4236),
    [anon_sym_try] = ACTIONS(4236),
    [anon_sym_match] = ACTIONS(4236),
    [anon_sym_match_BANG] = ACTIONS(4234),
    [anon_sym_function] = ACTIONS(4236),
    [anon_sym_LT_DASH] = ACTIONS(4236),
    [anon_sym_DOT_LBRACK] = ACTIONS(4234),
    [anon_sym_LT] = ACTIONS(4234),
    [anon_sym_use] = ACTIONS(4236),
    [anon_sym_use_BANG] = ACTIONS(4234),
    [anon_sym_do_BANG] = ACTIONS(4234),
    [anon_sym_begin] = ACTIONS(4236),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_or] = ACTIONS(4236),
    [aux_sym_char_token1] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4236),
    [anon_sym_DQUOTE] = ACTIONS(4236),
    [anon_sym_AT_DQUOTE] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [sym_bool] = ACTIONS(4236),
    [sym_unit] = ACTIONS(4234),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4236),
    [sym_op_identifier] = ACTIONS(4236),
    [anon_sym_PLUS] = ACTIONS(4236),
    [anon_sym_DASH] = ACTIONS(4236),
    [anon_sym_PLUS_DOT] = ACTIONS(4236),
    [anon_sym_DASH_DOT] = ACTIONS(4236),
    [anon_sym_PERCENT] = ACTIONS(4236),
    [anon_sym_AMP_AMP] = ACTIONS(4236),
    [anon_sym_TILDE] = ACTIONS(4234),
    [aux_sym_prefix_op_token1] = ACTIONS(4236),
    [aux_sym_infix_op_token1] = ACTIONS(4234),
    [aux_sym_infix_op_token2] = ACTIONS(4236),
    [anon_sym_PIPE_PIPE] = ACTIONS(4236),
    [anon_sym_BANG_EQ] = ACTIONS(4236),
    [anon_sym_COLON_EQ] = ACTIONS(4234),
    [anon_sym_DOLLAR] = ACTIONS(4236),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4236),
    [sym_int] = ACTIONS(4236),
    [sym_xint] = ACTIONS(4234),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4234),
    [sym__newline] = ACTIONS(4234),
  },
  [3322] = {
    [sym_block_comment] = STATE(3322),
    [sym_compiler_directive_decl] = STATE(3322),
    [sym_fsi_directive_decl] = STATE(3322),
    [sym_preproc_line] = STATE(3322),
    [sym_identifier] = ACTIONS(4126),
    [anon_sym_EQ] = ACTIONS(4124),
    [anon_sym_COLON] = ACTIONS(4126),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_do] = ACTIONS(4126),
    [anon_sym_let] = ACTIONS(4126),
    [anon_sym_let_BANG] = ACTIONS(4124),
    [anon_sym_LPAREN] = ACTIONS(4126),
    [anon_sym_COMMA] = ACTIONS(4124),
    [anon_sym_null] = ACTIONS(4126),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_COLON] = ACTIONS(4124),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LBRACK] = ACTIONS(4126),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4126),
    [anon_sym_LT_AT] = ACTIONS(4126),
    [anon_sym_LT_AT_AT] = ACTIONS(4126),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4124),
    [anon_sym_new] = ACTIONS(4126),
    [anon_sym_return_BANG] = ACTIONS(4124),
    [anon_sym_yield] = ACTIONS(4126),
    [anon_sym_yield_BANG] = ACTIONS(4124),
    [anon_sym_lazy] = ACTIONS(4126),
    [anon_sym_assert] = ACTIONS(4126),
    [anon_sym_upcast] = ACTIONS(4126),
    [anon_sym_downcast] = ACTIONS(4126),
    [anon_sym_COLON_GT] = ACTIONS(4124),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4124),
    [anon_sym_for] = ACTIONS(4126),
    [anon_sym_while] = ACTIONS(4126),
    [anon_sym_if] = ACTIONS(4126),
    [anon_sym_fun] = ACTIONS(4126),
    [anon_sym_try] = ACTIONS(4126),
    [anon_sym_match] = ACTIONS(4126),
    [anon_sym_match_BANG] = ACTIONS(4124),
    [anon_sym_function] = ACTIONS(4126),
    [anon_sym_LT_DASH] = ACTIONS(4126),
    [anon_sym_DOT_LBRACK] = ACTIONS(4124),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_use] = ACTIONS(4126),
    [anon_sym_use_BANG] = ACTIONS(4124),
    [anon_sym_do_BANG] = ACTIONS(4124),
    [anon_sym_DOT_DOT] = ACTIONS(4124),
    [anon_sym_begin] = ACTIONS(4126),
    [anon_sym_LPAREN2] = ACTIONS(4126),
    [anon_sym_or] = ACTIONS(4126),
    [aux_sym_char_token1] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4126),
    [anon_sym_DQUOTE] = ACTIONS(4126),
    [anon_sym_AT_DQUOTE] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [sym_bool] = ACTIONS(4126),
    [sym_unit] = ACTIONS(4124),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4126),
    [sym_op_identifier] = ACTIONS(4126),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_PLUS_DOT] = ACTIONS(4126),
    [anon_sym_DASH_DOT] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_AMP_AMP] = ACTIONS(4126),
    [anon_sym_TILDE] = ACTIONS(4124),
    [aux_sym_prefix_op_token1] = ACTIONS(4126),
    [aux_sym_infix_op_token1] = ACTIONS(4124),
    [aux_sym_infix_op_token2] = ACTIONS(4126),
    [anon_sym_PIPE_PIPE] = ACTIONS(4126),
    [anon_sym_BANG_EQ] = ACTIONS(4126),
    [anon_sym_COLON_EQ] = ACTIONS(4124),
    [anon_sym_DOLLAR] = ACTIONS(4126),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4126),
    [sym_int] = ACTIONS(4126),
    [sym_xint] = ACTIONS(4124),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4124),
    [sym__newline] = ACTIONS(4124),
  },
  [3323] = {
    [sym_block_comment] = STATE(3323),
    [sym_compiler_directive_decl] = STATE(3323),
    [sym_fsi_directive_decl] = STATE(3323),
    [sym_preproc_line] = STATE(3323),
    [sym_identifier] = ACTIONS(4122),
    [anon_sym_EQ] = ACTIONS(4120),
    [anon_sym_COLON] = ACTIONS(4122),
    [anon_sym_return] = ACTIONS(4122),
    [anon_sym_do] = ACTIONS(4122),
    [anon_sym_let] = ACTIONS(4122),
    [anon_sym_let_BANG] = ACTIONS(4120),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_COMMA] = ACTIONS(4120),
    [anon_sym_null] = ACTIONS(4122),
    [anon_sym_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_COLON] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_LT_AT] = ACTIONS(4122),
    [anon_sym_LT_AT_AT] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4122),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4120),
    [anon_sym_new] = ACTIONS(4122),
    [anon_sym_return_BANG] = ACTIONS(4120),
    [anon_sym_yield] = ACTIONS(4122),
    [anon_sym_yield_BANG] = ACTIONS(4120),
    [anon_sym_lazy] = ACTIONS(4122),
    [anon_sym_assert] = ACTIONS(4122),
    [anon_sym_upcast] = ACTIONS(4122),
    [anon_sym_downcast] = ACTIONS(4122),
    [anon_sym_COLON_GT] = ACTIONS(4120),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4120),
    [anon_sym_for] = ACTIONS(4122),
    [anon_sym_while] = ACTIONS(4122),
    [anon_sym_if] = ACTIONS(4122),
    [anon_sym_fun] = ACTIONS(4122),
    [anon_sym_try] = ACTIONS(4122),
    [anon_sym_match] = ACTIONS(4122),
    [anon_sym_match_BANG] = ACTIONS(4120),
    [anon_sym_function] = ACTIONS(4122),
    [anon_sym_LT_DASH] = ACTIONS(4122),
    [anon_sym_DOT_LBRACK] = ACTIONS(4120),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_use] = ACTIONS(4122),
    [anon_sym_use_BANG] = ACTIONS(4120),
    [anon_sym_do_BANG] = ACTIONS(4120),
    [anon_sym_DOT_DOT] = ACTIONS(4120),
    [anon_sym_begin] = ACTIONS(4122),
    [anon_sym_LPAREN2] = ACTIONS(4122),
    [anon_sym_or] = ACTIONS(4122),
    [aux_sym_char_token1] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4122),
    [anon_sym_DQUOTE] = ACTIONS(4122),
    [anon_sym_AT_DQUOTE] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [sym_bool] = ACTIONS(4122),
    [sym_unit] = ACTIONS(4120),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4122),
    [sym_op_identifier] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4122),
    [anon_sym_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_DOT] = ACTIONS(4122),
    [anon_sym_DASH_DOT] = ACTIONS(4122),
    [anon_sym_PERCENT] = ACTIONS(4122),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_TILDE] = ACTIONS(4120),
    [aux_sym_prefix_op_token1] = ACTIONS(4122),
    [aux_sym_infix_op_token1] = ACTIONS(4120),
    [aux_sym_infix_op_token2] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_COLON_EQ] = ACTIONS(4120),
    [anon_sym_DOLLAR] = ACTIONS(4122),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4122),
    [sym_int] = ACTIONS(4122),
    [sym_xint] = ACTIONS(4120),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4120),
    [sym__newline] = ACTIONS(4120),
  },
  [3324] = {
    [sym_block_comment] = STATE(3324),
    [sym_compiler_directive_decl] = STATE(3324),
    [sym_fsi_directive_decl] = STATE(3324),
    [sym_preproc_line] = STATE(3324),
    [sym_identifier] = ACTIONS(4118),
    [anon_sym_EQ] = ACTIONS(4116),
    [anon_sym_COLON] = ACTIONS(4118),
    [anon_sym_return] = ACTIONS(4118),
    [anon_sym_do] = ACTIONS(4118),
    [anon_sym_let] = ACTIONS(4118),
    [anon_sym_let_BANG] = ACTIONS(4116),
    [anon_sym_LPAREN] = ACTIONS(4118),
    [anon_sym_COMMA] = ACTIONS(4116),
    [anon_sym_null] = ACTIONS(4118),
    [anon_sym_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_COLON] = ACTIONS(4116),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4118),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(4118),
    [anon_sym_LT_AT] = ACTIONS(4118),
    [anon_sym_LT_AT_AT] = ACTIONS(4118),
    [anon_sym_DOT] = ACTIONS(4118),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4116),
    [anon_sym_new] = ACTIONS(4118),
    [anon_sym_return_BANG] = ACTIONS(4116),
    [anon_sym_yield] = ACTIONS(4118),
    [anon_sym_yield_BANG] = ACTIONS(4116),
    [anon_sym_lazy] = ACTIONS(4118),
    [anon_sym_assert] = ACTIONS(4118),
    [anon_sym_upcast] = ACTIONS(4118),
    [anon_sym_downcast] = ACTIONS(4118),
    [anon_sym_COLON_GT] = ACTIONS(4116),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4116),
    [anon_sym_for] = ACTIONS(4118),
    [anon_sym_while] = ACTIONS(4118),
    [anon_sym_if] = ACTIONS(4118),
    [anon_sym_fun] = ACTIONS(4118),
    [anon_sym_try] = ACTIONS(4118),
    [anon_sym_match] = ACTIONS(4118),
    [anon_sym_match_BANG] = ACTIONS(4116),
    [anon_sym_function] = ACTIONS(4118),
    [anon_sym_LT_DASH] = ACTIONS(4118),
    [anon_sym_DOT_LBRACK] = ACTIONS(4116),
    [anon_sym_LT] = ACTIONS(4116),
    [anon_sym_use] = ACTIONS(4118),
    [anon_sym_use_BANG] = ACTIONS(4116),
    [anon_sym_do_BANG] = ACTIONS(4116),
    [anon_sym_DOT_DOT] = ACTIONS(4116),
    [anon_sym_begin] = ACTIONS(4118),
    [anon_sym_LPAREN2] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [aux_sym_char_token1] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4118),
    [anon_sym_DQUOTE] = ACTIONS(4118),
    [anon_sym_AT_DQUOTE] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [sym_bool] = ACTIONS(4118),
    [sym_unit] = ACTIONS(4116),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4118),
    [sym_op_identifier] = ACTIONS(4118),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_PLUS_DOT] = ACTIONS(4118),
    [anon_sym_DASH_DOT] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_AMP_AMP] = ACTIONS(4118),
    [anon_sym_TILDE] = ACTIONS(4116),
    [aux_sym_prefix_op_token1] = ACTIONS(4118),
    [aux_sym_infix_op_token1] = ACTIONS(4116),
    [aux_sym_infix_op_token2] = ACTIONS(4118),
    [anon_sym_PIPE_PIPE] = ACTIONS(4118),
    [anon_sym_BANG_EQ] = ACTIONS(4118),
    [anon_sym_COLON_EQ] = ACTIONS(4116),
    [anon_sym_DOLLAR] = ACTIONS(4118),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4118),
    [sym_int] = ACTIONS(4118),
    [sym_xint] = ACTIONS(4116),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4116),
    [sym__newline] = ACTIONS(4116),
  },
  [3325] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defns] = STATE(4278),
    [sym__function_or_value_defn_body] = STATE(4216),
    [sym_function_declaration_left] = STATE(9566),
    [sym_value_declaration_left] = STATE(9566),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3325),
    [sym_compiler_directive_decl] = STATE(3325),
    [sym_fsi_directive_decl] = STATE(3325),
    [sym_preproc_line] = STATE(3325),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3326] = {
    [sym_block_comment] = STATE(3326),
    [sym_compiler_directive_decl] = STATE(3326),
    [sym_fsi_directive_decl] = STATE(3326),
    [sym_preproc_line] = STATE(3326),
    [sym_identifier] = ACTIONS(4216),
    [anon_sym_EQ] = ACTIONS(4214),
    [anon_sym_COLON] = ACTIONS(4216),
    [anon_sym_return] = ACTIONS(4216),
    [anon_sym_do] = ACTIONS(4216),
    [anon_sym_let] = ACTIONS(4216),
    [anon_sym_let_BANG] = ACTIONS(4214),
    [anon_sym_LPAREN] = ACTIONS(4216),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_null] = ACTIONS(4216),
    [anon_sym_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_COLON] = ACTIONS(4214),
    [anon_sym_AMP] = ACTIONS(4216),
    [anon_sym_LBRACK] = ACTIONS(4216),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4214),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_LT_AT] = ACTIONS(4216),
    [anon_sym_AT_GT] = ACTIONS(4216),
    [anon_sym_LT_AT_AT] = ACTIONS(4216),
    [anon_sym_DOT] = ACTIONS(4216),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4214),
    [anon_sym_new] = ACTIONS(4216),
    [anon_sym_return_BANG] = ACTIONS(4214),
    [anon_sym_yield] = ACTIONS(4216),
    [anon_sym_yield_BANG] = ACTIONS(4214),
    [anon_sym_lazy] = ACTIONS(4216),
    [anon_sym_assert] = ACTIONS(4216),
    [anon_sym_upcast] = ACTIONS(4216),
    [anon_sym_downcast] = ACTIONS(4216),
    [anon_sym_COLON_GT] = ACTIONS(4214),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4214),
    [anon_sym_for] = ACTIONS(4216),
    [anon_sym_while] = ACTIONS(4216),
    [anon_sym_if] = ACTIONS(4216),
    [anon_sym_fun] = ACTIONS(4216),
    [anon_sym_try] = ACTIONS(4216),
    [anon_sym_match] = ACTIONS(4216),
    [anon_sym_match_BANG] = ACTIONS(4214),
    [anon_sym_function] = ACTIONS(4216),
    [anon_sym_LT_DASH] = ACTIONS(4216),
    [anon_sym_DOT_LBRACK] = ACTIONS(4214),
    [anon_sym_LT] = ACTIONS(4214),
    [anon_sym_use] = ACTIONS(4216),
    [anon_sym_use_BANG] = ACTIONS(4214),
    [anon_sym_do_BANG] = ACTIONS(4214),
    [anon_sym_begin] = ACTIONS(4216),
    [anon_sym_LPAREN2] = ACTIONS(4216),
    [anon_sym_or] = ACTIONS(4216),
    [aux_sym_char_token1] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4216),
    [anon_sym_DQUOTE] = ACTIONS(4216),
    [anon_sym_AT_DQUOTE] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [sym_bool] = ACTIONS(4216),
    [sym_unit] = ACTIONS(4214),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4216),
    [sym_op_identifier] = ACTIONS(4216),
    [anon_sym_PLUS] = ACTIONS(4216),
    [anon_sym_DASH] = ACTIONS(4216),
    [anon_sym_PLUS_DOT] = ACTIONS(4216),
    [anon_sym_DASH_DOT] = ACTIONS(4216),
    [anon_sym_PERCENT] = ACTIONS(4216),
    [anon_sym_AMP_AMP] = ACTIONS(4216),
    [anon_sym_TILDE] = ACTIONS(4214),
    [aux_sym_prefix_op_token1] = ACTIONS(4216),
    [aux_sym_infix_op_token1] = ACTIONS(4214),
    [aux_sym_infix_op_token2] = ACTIONS(4216),
    [anon_sym_PIPE_PIPE] = ACTIONS(4216),
    [anon_sym_BANG_EQ] = ACTIONS(4216),
    [anon_sym_COLON_EQ] = ACTIONS(4214),
    [anon_sym_DOLLAR] = ACTIONS(4216),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4216),
    [sym_int] = ACTIONS(4216),
    [sym_xint] = ACTIONS(4214),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4214),
    [sym__newline] = ACTIONS(4214),
  },
  [3327] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_type_arguments] = STATE(3858),
    [sym__method_defn] = STATE(6567),
    [sym__property_defn] = STATE(6569),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3327),
    [sym_compiler_directive_decl] = STATE(3327),
    [sym_fsi_directive_decl] = STATE(3327),
    [sym_preproc_line] = STATE(3327),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3724),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(5881),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_COLON] = ACTIONS(5883),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [anon_sym_with] = ACTIONS(5885),
    [anon_sym_LT2] = ACTIONS(5809),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3328] = {
    [sym_block_comment] = STATE(3328),
    [sym_compiler_directive_decl] = STATE(3328),
    [sym_fsi_directive_decl] = STATE(3328),
    [sym_preproc_line] = STATE(3328),
    [sym_identifier] = ACTIONS(4112),
    [anon_sym_EQ] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4112),
    [anon_sym_return] = ACTIONS(4112),
    [anon_sym_do] = ACTIONS(4112),
    [anon_sym_let] = ACTIONS(4112),
    [anon_sym_let_BANG] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_null] = ACTIONS(4112),
    [anon_sym_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_COLON] = ACTIONS(4110),
    [anon_sym_AMP] = ACTIONS(4112),
    [anon_sym_LBRACK] = ACTIONS(4112),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4110),
    [anon_sym_LBRACE] = ACTIONS(4112),
    [anon_sym_LT_AT] = ACTIONS(4112),
    [anon_sym_LT_AT_AT] = ACTIONS(4112),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4110),
    [anon_sym_new] = ACTIONS(4112),
    [anon_sym_return_BANG] = ACTIONS(4110),
    [anon_sym_yield] = ACTIONS(4112),
    [anon_sym_yield_BANG] = ACTIONS(4110),
    [anon_sym_lazy] = ACTIONS(4112),
    [anon_sym_assert] = ACTIONS(4112),
    [anon_sym_upcast] = ACTIONS(4112),
    [anon_sym_downcast] = ACTIONS(4112),
    [anon_sym_COLON_GT] = ACTIONS(4110),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4110),
    [anon_sym_for] = ACTIONS(4112),
    [anon_sym_while] = ACTIONS(4112),
    [anon_sym_if] = ACTIONS(4112),
    [anon_sym_fun] = ACTIONS(4112),
    [anon_sym_try] = ACTIONS(4112),
    [anon_sym_match] = ACTIONS(4112),
    [anon_sym_match_BANG] = ACTIONS(4110),
    [anon_sym_function] = ACTIONS(4112),
    [anon_sym_LT_DASH] = ACTIONS(4112),
    [anon_sym_DOT_LBRACK] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(4110),
    [anon_sym_use] = ACTIONS(4112),
    [anon_sym_use_BANG] = ACTIONS(4110),
    [anon_sym_do_BANG] = ACTIONS(4110),
    [anon_sym_DOT_DOT] = ACTIONS(4110),
    [anon_sym_begin] = ACTIONS(4112),
    [anon_sym_LPAREN2] = ACTIONS(4112),
    [anon_sym_or] = ACTIONS(4112),
    [aux_sym_char_token1] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4112),
    [anon_sym_DQUOTE] = ACTIONS(4112),
    [anon_sym_AT_DQUOTE] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [sym_bool] = ACTIONS(4112),
    [sym_unit] = ACTIONS(4110),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4112),
    [sym_op_identifier] = ACTIONS(4112),
    [anon_sym_PLUS] = ACTIONS(4112),
    [anon_sym_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_DOT] = ACTIONS(4112),
    [anon_sym_DASH_DOT] = ACTIONS(4112),
    [anon_sym_PERCENT] = ACTIONS(4112),
    [anon_sym_AMP_AMP] = ACTIONS(4112),
    [anon_sym_TILDE] = ACTIONS(4110),
    [aux_sym_prefix_op_token1] = ACTIONS(4112),
    [aux_sym_infix_op_token1] = ACTIONS(4110),
    [aux_sym_infix_op_token2] = ACTIONS(4112),
    [anon_sym_PIPE_PIPE] = ACTIONS(4112),
    [anon_sym_BANG_EQ] = ACTIONS(4112),
    [anon_sym_COLON_EQ] = ACTIONS(4110),
    [anon_sym_DOLLAR] = ACTIONS(4112),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4112),
    [sym_int] = ACTIONS(4112),
    [sym_xint] = ACTIONS(4110),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4110),
    [sym__newline] = ACTIONS(4110),
  },
  [3329] = {
    [sym_block_comment] = STATE(3329),
    [sym_compiler_directive_decl] = STATE(3329),
    [sym_fsi_directive_decl] = STATE(3329),
    [sym_preproc_line] = STATE(3329),
    [sym_identifier] = ACTIONS(4180),
    [anon_sym_EQ] = ACTIONS(4178),
    [anon_sym_COLON] = ACTIONS(4180),
    [anon_sym_return] = ACTIONS(4180),
    [anon_sym_do] = ACTIONS(4180),
    [anon_sym_let] = ACTIONS(4180),
    [anon_sym_let_BANG] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(4180),
    [anon_sym_COMMA] = ACTIONS(4178),
    [anon_sym_null] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_COLON] = ACTIONS(4178),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4180),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4180),
    [anon_sym_LT_AT] = ACTIONS(4180),
    [anon_sym_LT_AT_AT] = ACTIONS(4180),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4178),
    [anon_sym_new] = ACTIONS(4180),
    [anon_sym_return_BANG] = ACTIONS(4178),
    [anon_sym_yield] = ACTIONS(4180),
    [anon_sym_yield_BANG] = ACTIONS(4178),
    [anon_sym_lazy] = ACTIONS(4180),
    [anon_sym_assert] = ACTIONS(4180),
    [anon_sym_upcast] = ACTIONS(4180),
    [anon_sym_downcast] = ACTIONS(4180),
    [anon_sym_COLON_GT] = ACTIONS(4178),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4178),
    [anon_sym_for] = ACTIONS(4180),
    [anon_sym_while] = ACTIONS(4180),
    [anon_sym_if] = ACTIONS(4180),
    [anon_sym_fun] = ACTIONS(4180),
    [anon_sym_try] = ACTIONS(4180),
    [anon_sym_match] = ACTIONS(4180),
    [anon_sym_match_BANG] = ACTIONS(4178),
    [anon_sym_function] = ACTIONS(4180),
    [anon_sym_LT_DASH] = ACTIONS(4180),
    [anon_sym_DOT_LBRACK] = ACTIONS(4178),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_use] = ACTIONS(4180),
    [anon_sym_use_BANG] = ACTIONS(4178),
    [anon_sym_do_BANG] = ACTIONS(4178),
    [anon_sym_DOT_DOT] = ACTIONS(4178),
    [anon_sym_begin] = ACTIONS(4180),
    [anon_sym_LPAREN2] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [aux_sym_char_token1] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4180),
    [anon_sym_DQUOTE] = ACTIONS(4180),
    [anon_sym_AT_DQUOTE] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [sym_bool] = ACTIONS(4180),
    [sym_unit] = ACTIONS(4178),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4180),
    [sym_op_identifier] = ACTIONS(4180),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_PLUS_DOT] = ACTIONS(4180),
    [anon_sym_DASH_DOT] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_TILDE] = ACTIONS(4178),
    [aux_sym_prefix_op_token1] = ACTIONS(4180),
    [aux_sym_infix_op_token1] = ACTIONS(4178),
    [aux_sym_infix_op_token2] = ACTIONS(4180),
    [anon_sym_PIPE_PIPE] = ACTIONS(4180),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_COLON_EQ] = ACTIONS(4178),
    [anon_sym_DOLLAR] = ACTIONS(4180),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4180),
    [sym_int] = ACTIONS(4180),
    [sym_xint] = ACTIONS(4178),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4178),
    [sym__newline] = ACTIONS(4178),
  },
  [3330] = {
    [sym_block_comment] = STATE(3330),
    [sym_compiler_directive_decl] = STATE(3330),
    [sym_fsi_directive_decl] = STATE(3330),
    [sym_preproc_line] = STATE(3330),
    [sym_identifier] = ACTIONS(4108),
    [anon_sym_EQ] = ACTIONS(4106),
    [anon_sym_COLON] = ACTIONS(4108),
    [anon_sym_return] = ACTIONS(4108),
    [anon_sym_do] = ACTIONS(4108),
    [anon_sym_let] = ACTIONS(4108),
    [anon_sym_let_BANG] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(4108),
    [anon_sym_COMMA] = ACTIONS(4106),
    [anon_sym_null] = ACTIONS(4108),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_COLON] = ACTIONS(4106),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LBRACK] = ACTIONS(4108),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(4108),
    [anon_sym_LT_AT] = ACTIONS(4108),
    [anon_sym_LT_AT_AT] = ACTIONS(4108),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4106),
    [anon_sym_new] = ACTIONS(4108),
    [anon_sym_return_BANG] = ACTIONS(4106),
    [anon_sym_yield] = ACTIONS(4108),
    [anon_sym_yield_BANG] = ACTIONS(4106),
    [anon_sym_lazy] = ACTIONS(4108),
    [anon_sym_assert] = ACTIONS(4108),
    [anon_sym_upcast] = ACTIONS(4108),
    [anon_sym_downcast] = ACTIONS(4108),
    [anon_sym_COLON_GT] = ACTIONS(4106),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4106),
    [anon_sym_for] = ACTIONS(4108),
    [anon_sym_while] = ACTIONS(4108),
    [anon_sym_if] = ACTIONS(4108),
    [anon_sym_fun] = ACTIONS(4108),
    [anon_sym_try] = ACTIONS(4108),
    [anon_sym_match] = ACTIONS(4108),
    [anon_sym_match_BANG] = ACTIONS(4106),
    [anon_sym_function] = ACTIONS(4108),
    [anon_sym_LT_DASH] = ACTIONS(4108),
    [anon_sym_DOT_LBRACK] = ACTIONS(4106),
    [anon_sym_LT] = ACTIONS(4106),
    [anon_sym_use] = ACTIONS(4108),
    [anon_sym_use_BANG] = ACTIONS(4106),
    [anon_sym_do_BANG] = ACTIONS(4106),
    [anon_sym_DOT_DOT] = ACTIONS(4106),
    [anon_sym_begin] = ACTIONS(4108),
    [anon_sym_LPAREN2] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [aux_sym_char_token1] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4108),
    [anon_sym_DQUOTE] = ACTIONS(4108),
    [anon_sym_AT_DQUOTE] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [sym_bool] = ACTIONS(4108),
    [sym_unit] = ACTIONS(4106),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4108),
    [sym_op_identifier] = ACTIONS(4108),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_PLUS_DOT] = ACTIONS(4108),
    [anon_sym_DASH_DOT] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_AMP_AMP] = ACTIONS(4108),
    [anon_sym_TILDE] = ACTIONS(4106),
    [aux_sym_prefix_op_token1] = ACTIONS(4108),
    [aux_sym_infix_op_token1] = ACTIONS(4106),
    [aux_sym_infix_op_token2] = ACTIONS(4108),
    [anon_sym_PIPE_PIPE] = ACTIONS(4108),
    [anon_sym_BANG_EQ] = ACTIONS(4108),
    [anon_sym_COLON_EQ] = ACTIONS(4106),
    [anon_sym_DOLLAR] = ACTIONS(4108),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4108),
    [sym_int] = ACTIONS(4108),
    [sym_xint] = ACTIONS(4106),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4106),
    [sym__newline] = ACTIONS(4106),
  },
  [3331] = {
    [sym_block_comment] = STATE(3331),
    [sym_compiler_directive_decl] = STATE(3331),
    [sym_fsi_directive_decl] = STATE(3331),
    [sym_preproc_line] = STATE(3331),
    [sym_identifier] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(4091),
    [anon_sym_COLON] = ACTIONS(4093),
    [anon_sym_return] = ACTIONS(4093),
    [anon_sym_do] = ACTIONS(4093),
    [anon_sym_let] = ACTIONS(4093),
    [anon_sym_let_BANG] = ACTIONS(4091),
    [anon_sym_LPAREN] = ACTIONS(4093),
    [anon_sym_COMMA] = ACTIONS(4091),
    [anon_sym_null] = ACTIONS(4093),
    [anon_sym_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_COLON] = ACTIONS(4091),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(4093),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4091),
    [anon_sym_LBRACE] = ACTIONS(4093),
    [anon_sym_LT_AT] = ACTIONS(4093),
    [anon_sym_LT_AT_AT] = ACTIONS(4093),
    [anon_sym_DOT] = ACTIONS(4093),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4091),
    [anon_sym_new] = ACTIONS(4093),
    [anon_sym_return_BANG] = ACTIONS(4091),
    [anon_sym_yield] = ACTIONS(4093),
    [anon_sym_yield_BANG] = ACTIONS(4091),
    [anon_sym_lazy] = ACTIONS(4093),
    [anon_sym_assert] = ACTIONS(4093),
    [anon_sym_upcast] = ACTIONS(4093),
    [anon_sym_downcast] = ACTIONS(4093),
    [anon_sym_COLON_GT] = ACTIONS(4091),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4091),
    [anon_sym_for] = ACTIONS(4093),
    [anon_sym_while] = ACTIONS(4093),
    [anon_sym_if] = ACTIONS(4093),
    [anon_sym_fun] = ACTIONS(4093),
    [anon_sym_try] = ACTIONS(4093),
    [anon_sym_match] = ACTIONS(4093),
    [anon_sym_match_BANG] = ACTIONS(4091),
    [anon_sym_function] = ACTIONS(4093),
    [anon_sym_LT_DASH] = ACTIONS(4093),
    [anon_sym_DOT_LBRACK] = ACTIONS(4091),
    [anon_sym_LT] = ACTIONS(4091),
    [anon_sym_use] = ACTIONS(4093),
    [anon_sym_use_BANG] = ACTIONS(4091),
    [anon_sym_do_BANG] = ACTIONS(4091),
    [anon_sym_DOT_DOT] = ACTIONS(4091),
    [anon_sym_begin] = ACTIONS(4093),
    [anon_sym_LPAREN2] = ACTIONS(4093),
    [anon_sym_or] = ACTIONS(4093),
    [aux_sym_char_token1] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4093),
    [anon_sym_DQUOTE] = ACTIONS(4093),
    [anon_sym_AT_DQUOTE] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [sym_bool] = ACTIONS(4093),
    [sym_unit] = ACTIONS(4091),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4093),
    [sym_op_identifier] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS_DOT] = ACTIONS(4093),
    [anon_sym_DASH_DOT] = ACTIONS(4093),
    [anon_sym_PERCENT] = ACTIONS(4093),
    [anon_sym_AMP_AMP] = ACTIONS(4093),
    [anon_sym_TILDE] = ACTIONS(4091),
    [aux_sym_prefix_op_token1] = ACTIONS(4093),
    [aux_sym_infix_op_token1] = ACTIONS(4091),
    [aux_sym_infix_op_token2] = ACTIONS(4093),
    [anon_sym_PIPE_PIPE] = ACTIONS(4093),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_COLON_EQ] = ACTIONS(4091),
    [anon_sym_DOLLAR] = ACTIONS(4093),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4093),
    [sym_int] = ACTIONS(4093),
    [sym_xint] = ACTIONS(4091),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4091),
    [sym__newline] = ACTIONS(4091),
  },
  [3332] = {
    [sym_block_comment] = STATE(3332),
    [sym_compiler_directive_decl] = STATE(3332),
    [sym_fsi_directive_decl] = STATE(3332),
    [sym_preproc_line] = STATE(3332),
    [sym_identifier] = ACTIONS(4174),
    [anon_sym_EQ] = ACTIONS(4172),
    [anon_sym_COLON] = ACTIONS(4174),
    [anon_sym_return] = ACTIONS(4174),
    [anon_sym_do] = ACTIONS(4174),
    [anon_sym_let] = ACTIONS(4174),
    [anon_sym_let_BANG] = ACTIONS(4172),
    [anon_sym_LPAREN] = ACTIONS(4174),
    [anon_sym_COMMA] = ACTIONS(4172),
    [anon_sym_null] = ACTIONS(4174),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_COLON] = ACTIONS(4172),
    [anon_sym_AMP] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4174),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4172),
    [anon_sym_LBRACE] = ACTIONS(4174),
    [anon_sym_LT_AT] = ACTIONS(4174),
    [anon_sym_LT_AT_AT] = ACTIONS(4174),
    [anon_sym_DOT] = ACTIONS(4174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4172),
    [anon_sym_new] = ACTIONS(4174),
    [anon_sym_return_BANG] = ACTIONS(4172),
    [anon_sym_yield] = ACTIONS(4174),
    [anon_sym_yield_BANG] = ACTIONS(4172),
    [anon_sym_lazy] = ACTIONS(4174),
    [anon_sym_assert] = ACTIONS(4174),
    [anon_sym_upcast] = ACTIONS(4174),
    [anon_sym_downcast] = ACTIONS(4174),
    [anon_sym_COLON_GT] = ACTIONS(4172),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4172),
    [anon_sym_for] = ACTIONS(4174),
    [anon_sym_while] = ACTIONS(4174),
    [anon_sym_if] = ACTIONS(4174),
    [anon_sym_fun] = ACTIONS(4174),
    [anon_sym_try] = ACTIONS(4174),
    [anon_sym_match] = ACTIONS(4174),
    [anon_sym_match_BANG] = ACTIONS(4172),
    [anon_sym_function] = ACTIONS(4174),
    [anon_sym_LT_DASH] = ACTIONS(4174),
    [anon_sym_DOT_LBRACK] = ACTIONS(4172),
    [anon_sym_LT] = ACTIONS(4172),
    [anon_sym_use] = ACTIONS(4174),
    [anon_sym_use_BANG] = ACTIONS(4172),
    [anon_sym_do_BANG] = ACTIONS(4172),
    [anon_sym_DOT_DOT] = ACTIONS(4172),
    [anon_sym_begin] = ACTIONS(4174),
    [anon_sym_LPAREN2] = ACTIONS(4174),
    [anon_sym_or] = ACTIONS(4174),
    [aux_sym_char_token1] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4174),
    [anon_sym_DQUOTE] = ACTIONS(4174),
    [anon_sym_AT_DQUOTE] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [sym_bool] = ACTIONS(4174),
    [sym_unit] = ACTIONS(4172),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4174),
    [sym_op_identifier] = ACTIONS(4174),
    [anon_sym_PLUS] = ACTIONS(4174),
    [anon_sym_DASH] = ACTIONS(4174),
    [anon_sym_PLUS_DOT] = ACTIONS(4174),
    [anon_sym_DASH_DOT] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [anon_sym_AMP_AMP] = ACTIONS(4174),
    [anon_sym_TILDE] = ACTIONS(4172),
    [aux_sym_prefix_op_token1] = ACTIONS(4174),
    [aux_sym_infix_op_token1] = ACTIONS(4172),
    [aux_sym_infix_op_token2] = ACTIONS(4174),
    [anon_sym_PIPE_PIPE] = ACTIONS(4174),
    [anon_sym_BANG_EQ] = ACTIONS(4174),
    [anon_sym_COLON_EQ] = ACTIONS(4172),
    [anon_sym_DOLLAR] = ACTIONS(4174),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4174),
    [sym_int] = ACTIONS(4174),
    [sym_xint] = ACTIONS(4172),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4172),
    [sym__newline] = ACTIONS(4172),
  },
  [3333] = {
    [sym_block_comment] = STATE(3333),
    [sym_compiler_directive_decl] = STATE(3333),
    [sym_fsi_directive_decl] = STATE(3333),
    [sym_preproc_line] = STATE(3333),
    [sym_identifier] = ACTIONS(4086),
    [anon_sym_EQ] = ACTIONS(4084),
    [anon_sym_COLON] = ACTIONS(4086),
    [anon_sym_return] = ACTIONS(4086),
    [anon_sym_do] = ACTIONS(4086),
    [anon_sym_let] = ACTIONS(4086),
    [anon_sym_let_BANG] = ACTIONS(4084),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_COMMA] = ACTIONS(4084),
    [anon_sym_null] = ACTIONS(4086),
    [anon_sym_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_COLON] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4084),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_LT_AT] = ACTIONS(4086),
    [anon_sym_LT_AT_AT] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4086),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4084),
    [anon_sym_new] = ACTIONS(4086),
    [anon_sym_return_BANG] = ACTIONS(4084),
    [anon_sym_yield] = ACTIONS(4086),
    [anon_sym_yield_BANG] = ACTIONS(4084),
    [anon_sym_lazy] = ACTIONS(4086),
    [anon_sym_assert] = ACTIONS(4086),
    [anon_sym_upcast] = ACTIONS(4086),
    [anon_sym_downcast] = ACTIONS(4086),
    [anon_sym_COLON_GT] = ACTIONS(4084),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4084),
    [anon_sym_for] = ACTIONS(4086),
    [anon_sym_while] = ACTIONS(4086),
    [anon_sym_if] = ACTIONS(4086),
    [anon_sym_fun] = ACTIONS(4086),
    [anon_sym_try] = ACTIONS(4086),
    [anon_sym_match] = ACTIONS(4086),
    [anon_sym_match_BANG] = ACTIONS(4084),
    [anon_sym_function] = ACTIONS(4086),
    [anon_sym_LT_DASH] = ACTIONS(4086),
    [anon_sym_DOT_LBRACK] = ACTIONS(4084),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_use] = ACTIONS(4086),
    [anon_sym_use_BANG] = ACTIONS(4084),
    [anon_sym_do_BANG] = ACTIONS(4084),
    [anon_sym_DOT_DOT] = ACTIONS(4084),
    [anon_sym_begin] = ACTIONS(4086),
    [anon_sym_LPAREN2] = ACTIONS(4086),
    [anon_sym_or] = ACTIONS(4086),
    [aux_sym_char_token1] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4086),
    [anon_sym_DQUOTE] = ACTIONS(4086),
    [anon_sym_AT_DQUOTE] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [sym_bool] = ACTIONS(4086),
    [sym_unit] = ACTIONS(4084),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4086),
    [sym_op_identifier] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4086),
    [anon_sym_DASH] = ACTIONS(4086),
    [anon_sym_PLUS_DOT] = ACTIONS(4086),
    [anon_sym_DASH_DOT] = ACTIONS(4086),
    [anon_sym_PERCENT] = ACTIONS(4086),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_TILDE] = ACTIONS(4084),
    [aux_sym_prefix_op_token1] = ACTIONS(4086),
    [aux_sym_infix_op_token1] = ACTIONS(4084),
    [aux_sym_infix_op_token2] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_COLON_EQ] = ACTIONS(4084),
    [anon_sym_DOLLAR] = ACTIONS(4086),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4086),
    [sym_int] = ACTIONS(4086),
    [sym_xint] = ACTIONS(4084),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4084),
    [sym__newline] = ACTIONS(4084),
  },
  [3334] = {
    [sym_block_comment] = STATE(3334),
    [sym_compiler_directive_decl] = STATE(3334),
    [sym_fsi_directive_decl] = STATE(3334),
    [sym_preproc_line] = STATE(3334),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_COLON] = ACTIONS(4082),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_do] = ACTIONS(4082),
    [anon_sym_let] = ACTIONS(4082),
    [anon_sym_let_BANG] = ACTIONS(4080),
    [anon_sym_LPAREN] = ACTIONS(4082),
    [anon_sym_COMMA] = ACTIONS(4080),
    [anon_sym_null] = ACTIONS(4082),
    [anon_sym_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_COLON] = ACTIONS(4080),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_LBRACK] = ACTIONS(4082),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(4082),
    [anon_sym_LT_AT] = ACTIONS(4082),
    [anon_sym_LT_AT_AT] = ACTIONS(4082),
    [anon_sym_DOT] = ACTIONS(4082),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4080),
    [anon_sym_new] = ACTIONS(4082),
    [anon_sym_return_BANG] = ACTIONS(4080),
    [anon_sym_yield] = ACTIONS(4082),
    [anon_sym_yield_BANG] = ACTIONS(4080),
    [anon_sym_lazy] = ACTIONS(4082),
    [anon_sym_assert] = ACTIONS(4082),
    [anon_sym_upcast] = ACTIONS(4082),
    [anon_sym_downcast] = ACTIONS(4082),
    [anon_sym_COLON_GT] = ACTIONS(4080),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4080),
    [anon_sym_for] = ACTIONS(4082),
    [anon_sym_while] = ACTIONS(4082),
    [anon_sym_if] = ACTIONS(4082),
    [anon_sym_fun] = ACTIONS(4082),
    [anon_sym_try] = ACTIONS(4082),
    [anon_sym_match] = ACTIONS(4082),
    [anon_sym_match_BANG] = ACTIONS(4080),
    [anon_sym_function] = ACTIONS(4082),
    [anon_sym_LT_DASH] = ACTIONS(4082),
    [anon_sym_DOT_LBRACK] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(4080),
    [anon_sym_use] = ACTIONS(4082),
    [anon_sym_use_BANG] = ACTIONS(4080),
    [anon_sym_do_BANG] = ACTIONS(4080),
    [anon_sym_DOT_DOT] = ACTIONS(4080),
    [anon_sym_begin] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4082),
    [anon_sym_or] = ACTIONS(4082),
    [aux_sym_char_token1] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4082),
    [anon_sym_DQUOTE] = ACTIONS(4082),
    [anon_sym_AT_DQUOTE] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [sym_bool] = ACTIONS(4082),
    [sym_unit] = ACTIONS(4080),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4082),
    [sym_op_identifier] = ACTIONS(4082),
    [anon_sym_PLUS] = ACTIONS(4082),
    [anon_sym_DASH] = ACTIONS(4082),
    [anon_sym_PLUS_DOT] = ACTIONS(4082),
    [anon_sym_DASH_DOT] = ACTIONS(4082),
    [anon_sym_PERCENT] = ACTIONS(4082),
    [anon_sym_AMP_AMP] = ACTIONS(4082),
    [anon_sym_TILDE] = ACTIONS(4080),
    [aux_sym_prefix_op_token1] = ACTIONS(4082),
    [aux_sym_infix_op_token1] = ACTIONS(4080),
    [aux_sym_infix_op_token2] = ACTIONS(4082),
    [anon_sym_PIPE_PIPE] = ACTIONS(4082),
    [anon_sym_BANG_EQ] = ACTIONS(4082),
    [anon_sym_COLON_EQ] = ACTIONS(4080),
    [anon_sym_DOLLAR] = ACTIONS(4082),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4082),
    [sym_int] = ACTIONS(4082),
    [sym_xint] = ACTIONS(4080),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4080),
    [sym__newline] = ACTIONS(4080),
  },
  [3335] = {
    [sym_block_comment] = STATE(3335),
    [sym_compiler_directive_decl] = STATE(3335),
    [sym_fsi_directive_decl] = STATE(3335),
    [sym_preproc_line] = STATE(3335),
    [sym_identifier] = ACTIONS(4054),
    [anon_sym_EQ] = ACTIONS(4052),
    [anon_sym_COLON] = ACTIONS(4054),
    [anon_sym_return] = ACTIONS(4054),
    [anon_sym_do] = ACTIONS(4054),
    [anon_sym_let] = ACTIONS(4054),
    [anon_sym_let_BANG] = ACTIONS(4052),
    [anon_sym_LPAREN] = ACTIONS(4054),
    [anon_sym_COMMA] = ACTIONS(4052),
    [anon_sym_null] = ACTIONS(4054),
    [anon_sym_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_COLON] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(4054),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4052),
    [anon_sym_LBRACE] = ACTIONS(4054),
    [anon_sym_LT_AT] = ACTIONS(4054),
    [anon_sym_LT_AT_AT] = ACTIONS(4054),
    [anon_sym_DOT] = ACTIONS(4054),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_return_BANG] = ACTIONS(4052),
    [anon_sym_yield] = ACTIONS(4054),
    [anon_sym_yield_BANG] = ACTIONS(4052),
    [anon_sym_lazy] = ACTIONS(4054),
    [anon_sym_assert] = ACTIONS(4054),
    [anon_sym_upcast] = ACTIONS(4054),
    [anon_sym_downcast] = ACTIONS(4054),
    [anon_sym_COLON_GT] = ACTIONS(4052),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4052),
    [anon_sym_for] = ACTIONS(4054),
    [anon_sym_while] = ACTIONS(4054),
    [anon_sym_if] = ACTIONS(4054),
    [anon_sym_fun] = ACTIONS(4054),
    [anon_sym_try] = ACTIONS(4054),
    [anon_sym_match] = ACTIONS(4054),
    [anon_sym_match_BANG] = ACTIONS(4052),
    [anon_sym_function] = ACTIONS(4054),
    [anon_sym_LT_DASH] = ACTIONS(4054),
    [anon_sym_DOT_LBRACK] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_use] = ACTIONS(4054),
    [anon_sym_use_BANG] = ACTIONS(4052),
    [anon_sym_do_BANG] = ACTIONS(4052),
    [anon_sym_DOT_DOT] = ACTIONS(4052),
    [anon_sym_begin] = ACTIONS(4054),
    [anon_sym_LPAREN2] = ACTIONS(4054),
    [anon_sym_or] = ACTIONS(4054),
    [aux_sym_char_token1] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4054),
    [anon_sym_DQUOTE] = ACTIONS(4054),
    [anon_sym_AT_DQUOTE] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [sym_bool] = ACTIONS(4054),
    [sym_unit] = ACTIONS(4052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4054),
    [sym_op_identifier] = ACTIONS(4054),
    [anon_sym_PLUS] = ACTIONS(4054),
    [anon_sym_DASH] = ACTIONS(4054),
    [anon_sym_PLUS_DOT] = ACTIONS(4054),
    [anon_sym_DASH_DOT] = ACTIONS(4054),
    [anon_sym_PERCENT] = ACTIONS(4054),
    [anon_sym_AMP_AMP] = ACTIONS(4054),
    [anon_sym_TILDE] = ACTIONS(4052),
    [aux_sym_prefix_op_token1] = ACTIONS(4054),
    [aux_sym_infix_op_token1] = ACTIONS(4052),
    [aux_sym_infix_op_token2] = ACTIONS(4054),
    [anon_sym_PIPE_PIPE] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4054),
    [anon_sym_COLON_EQ] = ACTIONS(4052),
    [anon_sym_DOLLAR] = ACTIONS(4054),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4054),
    [sym_int] = ACTIONS(4054),
    [sym_xint] = ACTIONS(4052),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4052),
    [sym__newline] = ACTIONS(4052),
  },
  [3336] = {
    [sym_block_comment] = STATE(3336),
    [sym_compiler_directive_decl] = STATE(3336),
    [sym_fsi_directive_decl] = STATE(3336),
    [sym_preproc_line] = STATE(3336),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_EQ] = ACTIONS(4199),
    [anon_sym_COLON] = ACTIONS(4201),
    [anon_sym_return] = ACTIONS(4201),
    [anon_sym_do] = ACTIONS(4201),
    [anon_sym_let] = ACTIONS(4201),
    [anon_sym_let_BANG] = ACTIONS(4199),
    [anon_sym_LPAREN] = ACTIONS(4201),
    [anon_sym_COMMA] = ACTIONS(4199),
    [anon_sym_null] = ACTIONS(4201),
    [anon_sym_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(4199),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_LBRACK] = ACTIONS(4201),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4199),
    [anon_sym_LBRACE] = ACTIONS(4201),
    [anon_sym_LT_AT] = ACTIONS(4201),
    [anon_sym_AT_GT] = ACTIONS(4201),
    [anon_sym_LT_AT_AT] = ACTIONS(4201),
    [anon_sym_DOT] = ACTIONS(4201),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4199),
    [anon_sym_new] = ACTIONS(4201),
    [anon_sym_return_BANG] = ACTIONS(4199),
    [anon_sym_yield] = ACTIONS(4201),
    [anon_sym_yield_BANG] = ACTIONS(4199),
    [anon_sym_lazy] = ACTIONS(4201),
    [anon_sym_assert] = ACTIONS(4201),
    [anon_sym_upcast] = ACTIONS(4201),
    [anon_sym_downcast] = ACTIONS(4201),
    [anon_sym_COLON_GT] = ACTIONS(4199),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4199),
    [anon_sym_for] = ACTIONS(4201),
    [anon_sym_while] = ACTIONS(4201),
    [anon_sym_if] = ACTIONS(4201),
    [anon_sym_fun] = ACTIONS(4201),
    [anon_sym_try] = ACTIONS(4201),
    [anon_sym_match] = ACTIONS(4201),
    [anon_sym_match_BANG] = ACTIONS(4199),
    [anon_sym_function] = ACTIONS(4201),
    [anon_sym_LT_DASH] = ACTIONS(4201),
    [anon_sym_DOT_LBRACK] = ACTIONS(4199),
    [anon_sym_LT] = ACTIONS(4199),
    [anon_sym_use] = ACTIONS(4201),
    [anon_sym_use_BANG] = ACTIONS(4199),
    [anon_sym_do_BANG] = ACTIONS(4199),
    [anon_sym_begin] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(4201),
    [anon_sym_or] = ACTIONS(4201),
    [aux_sym_char_token1] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4201),
    [anon_sym_DQUOTE] = ACTIONS(4201),
    [anon_sym_AT_DQUOTE] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [sym_bool] = ACTIONS(4201),
    [sym_unit] = ACTIONS(4199),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4201),
    [sym_op_identifier] = ACTIONS(4201),
    [anon_sym_PLUS] = ACTIONS(4201),
    [anon_sym_DASH] = ACTIONS(4201),
    [anon_sym_PLUS_DOT] = ACTIONS(4201),
    [anon_sym_DASH_DOT] = ACTIONS(4201),
    [anon_sym_PERCENT] = ACTIONS(4201),
    [anon_sym_AMP_AMP] = ACTIONS(4201),
    [anon_sym_TILDE] = ACTIONS(4199),
    [aux_sym_prefix_op_token1] = ACTIONS(4201),
    [aux_sym_infix_op_token1] = ACTIONS(4199),
    [aux_sym_infix_op_token2] = ACTIONS(4201),
    [anon_sym_PIPE_PIPE] = ACTIONS(4201),
    [anon_sym_BANG_EQ] = ACTIONS(4201),
    [anon_sym_COLON_EQ] = ACTIONS(4199),
    [anon_sym_DOLLAR] = ACTIONS(4201),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4201),
    [sym_int] = ACTIONS(4201),
    [sym_xint] = ACTIONS(4199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4199),
    [sym__newline] = ACTIONS(4199),
  },
  [3337] = {
    [sym_block_comment] = STATE(3337),
    [sym_compiler_directive_decl] = STATE(3337),
    [sym_fsi_directive_decl] = STATE(3337),
    [sym_preproc_line] = STATE(3337),
    [sym_identifier] = ACTIONS(4197),
    [anon_sym_EQ] = ACTIONS(4195),
    [anon_sym_COLON] = ACTIONS(4197),
    [anon_sym_return] = ACTIONS(4197),
    [anon_sym_do] = ACTIONS(4197),
    [anon_sym_let] = ACTIONS(4197),
    [anon_sym_let_BANG] = ACTIONS(4195),
    [anon_sym_LPAREN] = ACTIONS(4197),
    [anon_sym_COMMA] = ACTIONS(4195),
    [anon_sym_null] = ACTIONS(4197),
    [anon_sym_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_COLON] = ACTIONS(4195),
    [anon_sym_AMP] = ACTIONS(4197),
    [anon_sym_LBRACK] = ACTIONS(4197),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4195),
    [anon_sym_LBRACE] = ACTIONS(4197),
    [anon_sym_LT_AT] = ACTIONS(4197),
    [anon_sym_AT_GT] = ACTIONS(4197),
    [anon_sym_LT_AT_AT] = ACTIONS(4197),
    [anon_sym_DOT] = ACTIONS(4197),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4195),
    [anon_sym_new] = ACTIONS(4197),
    [anon_sym_return_BANG] = ACTIONS(4195),
    [anon_sym_yield] = ACTIONS(4197),
    [anon_sym_yield_BANG] = ACTIONS(4195),
    [anon_sym_lazy] = ACTIONS(4197),
    [anon_sym_assert] = ACTIONS(4197),
    [anon_sym_upcast] = ACTIONS(4197),
    [anon_sym_downcast] = ACTIONS(4197),
    [anon_sym_COLON_GT] = ACTIONS(4195),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4195),
    [anon_sym_for] = ACTIONS(4197),
    [anon_sym_while] = ACTIONS(4197),
    [anon_sym_if] = ACTIONS(4197),
    [anon_sym_fun] = ACTIONS(4197),
    [anon_sym_try] = ACTIONS(4197),
    [anon_sym_match] = ACTIONS(4197),
    [anon_sym_match_BANG] = ACTIONS(4195),
    [anon_sym_function] = ACTIONS(4197),
    [anon_sym_LT_DASH] = ACTIONS(4197),
    [anon_sym_DOT_LBRACK] = ACTIONS(4195),
    [anon_sym_LT] = ACTIONS(4195),
    [anon_sym_use] = ACTIONS(4197),
    [anon_sym_use_BANG] = ACTIONS(4195),
    [anon_sym_do_BANG] = ACTIONS(4195),
    [anon_sym_begin] = ACTIONS(4197),
    [anon_sym_LPAREN2] = ACTIONS(4197),
    [anon_sym_or] = ACTIONS(4197),
    [aux_sym_char_token1] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4197),
    [anon_sym_DQUOTE] = ACTIONS(4197),
    [anon_sym_AT_DQUOTE] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [sym_bool] = ACTIONS(4197),
    [sym_unit] = ACTIONS(4195),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4197),
    [sym_op_identifier] = ACTIONS(4197),
    [anon_sym_PLUS] = ACTIONS(4197),
    [anon_sym_DASH] = ACTIONS(4197),
    [anon_sym_PLUS_DOT] = ACTIONS(4197),
    [anon_sym_DASH_DOT] = ACTIONS(4197),
    [anon_sym_PERCENT] = ACTIONS(4197),
    [anon_sym_AMP_AMP] = ACTIONS(4197),
    [anon_sym_TILDE] = ACTIONS(4195),
    [aux_sym_prefix_op_token1] = ACTIONS(4197),
    [aux_sym_infix_op_token1] = ACTIONS(4195),
    [aux_sym_infix_op_token2] = ACTIONS(4197),
    [anon_sym_PIPE_PIPE] = ACTIONS(4197),
    [anon_sym_BANG_EQ] = ACTIONS(4197),
    [anon_sym_COLON_EQ] = ACTIONS(4195),
    [anon_sym_DOLLAR] = ACTIONS(4197),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4197),
    [sym_int] = ACTIONS(4197),
    [sym_xint] = ACTIONS(4195),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4195),
    [sym__newline] = ACTIONS(4195),
  },
  [3338] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(10158),
    [sym_function_declaration_left] = STATE(9479),
    [sym_value_declaration_left] = STATE(9479),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3338),
    [sym_compiler_directive_decl] = STATE(3338),
    [sym_fsi_directive_decl] = STATE(3338),
    [sym_preproc_line] = STATE(3338),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_rec] = ACTIONS(5887),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3339] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defns] = STATE(10163),
    [sym__function_or_value_defn_body] = STATE(8909),
    [sym_function_declaration_left] = STATE(10066),
    [sym_value_declaration_left] = STATE(10066),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3339),
    [sym_compiler_directive_decl] = STATE(3339),
    [sym_fsi_directive_decl] = STATE(3339),
    [sym_preproc_line] = STATE(3339),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3340] = {
    [sym_block_comment] = STATE(3340),
    [sym_compiler_directive_decl] = STATE(3340),
    [sym_fsi_directive_decl] = STATE(3340),
    [sym_preproc_line] = STATE(3340),
    [sym_identifier] = ACTIONS(4193),
    [anon_sym_EQ] = ACTIONS(4191),
    [anon_sym_COLON] = ACTIONS(4193),
    [anon_sym_return] = ACTIONS(4193),
    [anon_sym_do] = ACTIONS(4193),
    [anon_sym_let] = ACTIONS(4193),
    [anon_sym_let_BANG] = ACTIONS(4191),
    [anon_sym_LPAREN] = ACTIONS(4193),
    [anon_sym_COMMA] = ACTIONS(4191),
    [anon_sym_null] = ACTIONS(4193),
    [anon_sym_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_COLON] = ACTIONS(4191),
    [anon_sym_AMP] = ACTIONS(4193),
    [anon_sym_LBRACK] = ACTIONS(4193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4191),
    [anon_sym_LBRACE] = ACTIONS(4193),
    [anon_sym_LT_AT] = ACTIONS(4193),
    [anon_sym_AT_GT] = ACTIONS(4193),
    [anon_sym_LT_AT_AT] = ACTIONS(4193),
    [anon_sym_DOT] = ACTIONS(4193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4191),
    [anon_sym_new] = ACTIONS(4193),
    [anon_sym_return_BANG] = ACTIONS(4191),
    [anon_sym_yield] = ACTIONS(4193),
    [anon_sym_yield_BANG] = ACTIONS(4191),
    [anon_sym_lazy] = ACTIONS(4193),
    [anon_sym_assert] = ACTIONS(4193),
    [anon_sym_upcast] = ACTIONS(4193),
    [anon_sym_downcast] = ACTIONS(4193),
    [anon_sym_COLON_GT] = ACTIONS(4191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4191),
    [anon_sym_for] = ACTIONS(4193),
    [anon_sym_while] = ACTIONS(4193),
    [anon_sym_if] = ACTIONS(4193),
    [anon_sym_fun] = ACTIONS(4193),
    [anon_sym_try] = ACTIONS(4193),
    [anon_sym_match] = ACTIONS(4193),
    [anon_sym_match_BANG] = ACTIONS(4191),
    [anon_sym_function] = ACTIONS(4193),
    [anon_sym_LT_DASH] = ACTIONS(4193),
    [anon_sym_DOT_LBRACK] = ACTIONS(4191),
    [anon_sym_LT] = ACTIONS(4191),
    [anon_sym_use] = ACTIONS(4193),
    [anon_sym_use_BANG] = ACTIONS(4191),
    [anon_sym_do_BANG] = ACTIONS(4191),
    [anon_sym_begin] = ACTIONS(4193),
    [anon_sym_LPAREN2] = ACTIONS(4193),
    [anon_sym_or] = ACTIONS(4193),
    [aux_sym_char_token1] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4193),
    [anon_sym_DQUOTE] = ACTIONS(4193),
    [anon_sym_AT_DQUOTE] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [sym_bool] = ACTIONS(4193),
    [sym_unit] = ACTIONS(4191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4193),
    [sym_op_identifier] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4193),
    [anon_sym_DASH] = ACTIONS(4193),
    [anon_sym_PLUS_DOT] = ACTIONS(4193),
    [anon_sym_DASH_DOT] = ACTIONS(4193),
    [anon_sym_PERCENT] = ACTIONS(4193),
    [anon_sym_AMP_AMP] = ACTIONS(4193),
    [anon_sym_TILDE] = ACTIONS(4191),
    [aux_sym_prefix_op_token1] = ACTIONS(4193),
    [aux_sym_infix_op_token1] = ACTIONS(4191),
    [aux_sym_infix_op_token2] = ACTIONS(4193),
    [anon_sym_PIPE_PIPE] = ACTIONS(4193),
    [anon_sym_BANG_EQ] = ACTIONS(4193),
    [anon_sym_COLON_EQ] = ACTIONS(4191),
    [anon_sym_DOLLAR] = ACTIONS(4193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4193),
    [sym_int] = ACTIONS(4193),
    [sym_xint] = ACTIONS(4191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4191),
    [sym__newline] = ACTIONS(4191),
  },
  [3341] = {
    [sym_block_comment] = STATE(3341),
    [sym_compiler_directive_decl] = STATE(3341),
    [sym_fsi_directive_decl] = STATE(3341),
    [sym_preproc_line] = STATE(3341),
    [sym_identifier] = ACTIONS(4018),
    [anon_sym_EQ] = ACTIONS(4016),
    [anon_sym_COLON] = ACTIONS(4018),
    [anon_sym_return] = ACTIONS(4018),
    [anon_sym_do] = ACTIONS(4018),
    [anon_sym_let] = ACTIONS(4018),
    [anon_sym_let_BANG] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(4018),
    [anon_sym_COMMA] = ACTIONS(4016),
    [anon_sym_null] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_COLON] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4018),
    [anon_sym_LBRACK] = ACTIONS(4018),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4016),
    [anon_sym_LBRACE] = ACTIONS(4018),
    [anon_sym_LT_AT] = ACTIONS(4018),
    [anon_sym_LT_AT_AT] = ACTIONS(4018),
    [anon_sym_DOT] = ACTIONS(4018),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4016),
    [anon_sym_new] = ACTIONS(4018),
    [anon_sym_return_BANG] = ACTIONS(4016),
    [anon_sym_yield] = ACTIONS(4018),
    [anon_sym_yield_BANG] = ACTIONS(4016),
    [anon_sym_lazy] = ACTIONS(4018),
    [anon_sym_assert] = ACTIONS(4018),
    [anon_sym_upcast] = ACTIONS(4018),
    [anon_sym_downcast] = ACTIONS(4018),
    [anon_sym_COLON_GT] = ACTIONS(4016),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4016),
    [anon_sym_for] = ACTIONS(4018),
    [anon_sym_while] = ACTIONS(4018),
    [anon_sym_if] = ACTIONS(4018),
    [anon_sym_fun] = ACTIONS(4018),
    [anon_sym_try] = ACTIONS(4018),
    [anon_sym_match] = ACTIONS(4018),
    [anon_sym_match_BANG] = ACTIONS(4016),
    [anon_sym_function] = ACTIONS(4018),
    [anon_sym_LT_DASH] = ACTIONS(4018),
    [anon_sym_DOT_LBRACK] = ACTIONS(4016),
    [anon_sym_LT] = ACTIONS(4016),
    [anon_sym_use] = ACTIONS(4018),
    [anon_sym_use_BANG] = ACTIONS(4016),
    [anon_sym_do_BANG] = ACTIONS(4016),
    [anon_sym_DOT_DOT] = ACTIONS(4016),
    [anon_sym_begin] = ACTIONS(4018),
    [anon_sym_LPAREN2] = ACTIONS(4018),
    [anon_sym_or] = ACTIONS(4018),
    [aux_sym_char_token1] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(4018),
    [anon_sym_AT_DQUOTE] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [sym_bool] = ACTIONS(4018),
    [sym_unit] = ACTIONS(4016),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4018),
    [sym_op_identifier] = ACTIONS(4018),
    [anon_sym_PLUS] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_PLUS_DOT] = ACTIONS(4018),
    [anon_sym_DASH_DOT] = ACTIONS(4018),
    [anon_sym_PERCENT] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4016),
    [aux_sym_prefix_op_token1] = ACTIONS(4018),
    [aux_sym_infix_op_token1] = ACTIONS(4016),
    [aux_sym_infix_op_token2] = ACTIONS(4018),
    [anon_sym_PIPE_PIPE] = ACTIONS(4018),
    [anon_sym_BANG_EQ] = ACTIONS(4018),
    [anon_sym_COLON_EQ] = ACTIONS(4016),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4018),
    [sym_int] = ACTIONS(4018),
    [sym_xint] = ACTIONS(4016),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4016),
    [sym__newline] = ACTIONS(4016),
  },
  [3342] = {
    [sym_block_comment] = STATE(3342),
    [sym_compiler_directive_decl] = STATE(3342),
    [sym_fsi_directive_decl] = STATE(3342),
    [sym_preproc_line] = STATE(3342),
    [sym_identifier] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3919),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_return] = ACTIONS(3921),
    [anon_sym_do] = ACTIONS(3921),
    [anon_sym_let] = ACTIONS(3921),
    [anon_sym_let_BANG] = ACTIONS(3919),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3919),
    [anon_sym_null] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_COLON] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3919),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_LT_AT] = ACTIONS(3921),
    [anon_sym_AT_GT] = ACTIONS(3921),
    [anon_sym_LT_AT_AT] = ACTIONS(3921),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3919),
    [anon_sym_new] = ACTIONS(3921),
    [anon_sym_return_BANG] = ACTIONS(3919),
    [anon_sym_yield] = ACTIONS(3921),
    [anon_sym_yield_BANG] = ACTIONS(3919),
    [anon_sym_lazy] = ACTIONS(3921),
    [anon_sym_assert] = ACTIONS(3921),
    [anon_sym_upcast] = ACTIONS(3921),
    [anon_sym_downcast] = ACTIONS(3921),
    [anon_sym_COLON_GT] = ACTIONS(3919),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3919),
    [anon_sym_for] = ACTIONS(3921),
    [anon_sym_while] = ACTIONS(3921),
    [anon_sym_if] = ACTIONS(3921),
    [anon_sym_fun] = ACTIONS(3921),
    [anon_sym_try] = ACTIONS(3921),
    [anon_sym_match] = ACTIONS(3921),
    [anon_sym_match_BANG] = ACTIONS(3919),
    [anon_sym_function] = ACTIONS(3921),
    [anon_sym_LT_DASH] = ACTIONS(3921),
    [anon_sym_DOT_LBRACK] = ACTIONS(3919),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_use] = ACTIONS(3921),
    [anon_sym_use_BANG] = ACTIONS(3919),
    [anon_sym_do_BANG] = ACTIONS(3919),
    [anon_sym_begin] = ACTIONS(3921),
    [anon_sym_LPAREN2] = ACTIONS(3921),
    [anon_sym_or] = ACTIONS(3921),
    [aux_sym_char_token1] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_AT_DQUOTE] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [sym_bool] = ACTIONS(3921),
    [sym_unit] = ACTIONS(3919),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3921),
    [sym_op_identifier] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_DOT] = ACTIONS(3921),
    [anon_sym_DASH_DOT] = ACTIONS(3921),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3919),
    [aux_sym_prefix_op_token1] = ACTIONS(3921),
    [aux_sym_infix_op_token1] = ACTIONS(3919),
    [aux_sym_infix_op_token2] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_COLON_EQ] = ACTIONS(3919),
    [anon_sym_DOLLAR] = ACTIONS(3921),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3921),
    [sym_int] = ACTIONS(3921),
    [sym_xint] = ACTIONS(3919),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3919),
    [sym__newline] = ACTIONS(3919),
  },
  [3343] = {
    [sym_block_comment] = STATE(3343),
    [sym_compiler_directive_decl] = STATE(3343),
    [sym_fsi_directive_decl] = STATE(3343),
    [sym_preproc_line] = STATE(3343),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3843),
    [anon_sym_COLON] = ACTIONS(3845),
    [anon_sym_return] = ACTIONS(3845),
    [anon_sym_do] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_let_BANG] = ACTIONS(3843),
    [anon_sym_LPAREN] = ACTIONS(3845),
    [anon_sym_COMMA] = ACTIONS(3843),
    [anon_sym_null] = ACTIONS(3845),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3843),
    [anon_sym_LBRACE] = ACTIONS(3845),
    [anon_sym_LT_AT] = ACTIONS(3845),
    [anon_sym_LT_AT_AT] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3843),
    [anon_sym_new] = ACTIONS(3845),
    [anon_sym_return_BANG] = ACTIONS(3843),
    [anon_sym_yield] = ACTIONS(3845),
    [anon_sym_yield_BANG] = ACTIONS(3843),
    [anon_sym_lazy] = ACTIONS(3845),
    [anon_sym_assert] = ACTIONS(3845),
    [anon_sym_upcast] = ACTIONS(3845),
    [anon_sym_downcast] = ACTIONS(3845),
    [anon_sym_COLON_GT] = ACTIONS(3843),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3843),
    [anon_sym_for] = ACTIONS(3845),
    [anon_sym_while] = ACTIONS(3845),
    [anon_sym_if] = ACTIONS(3845),
    [anon_sym_fun] = ACTIONS(3845),
    [anon_sym_try] = ACTIONS(3845),
    [anon_sym_match] = ACTIONS(3845),
    [anon_sym_match_BANG] = ACTIONS(3843),
    [anon_sym_function] = ACTIONS(3845),
    [anon_sym_LT_DASH] = ACTIONS(3845),
    [anon_sym_DOT_LBRACK] = ACTIONS(3843),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_use] = ACTIONS(3845),
    [anon_sym_use_BANG] = ACTIONS(3843),
    [anon_sym_do_BANG] = ACTIONS(3843),
    [anon_sym_DOT_DOT] = ACTIONS(3843),
    [anon_sym_begin] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(3845),
    [anon_sym_or] = ACTIONS(3845),
    [aux_sym_char_token1] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3845),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_AT_DQUOTE] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [sym_bool] = ACTIONS(3845),
    [sym_unit] = ACTIONS(3843),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3845),
    [sym_op_identifier] = ACTIONS(3845),
    [anon_sym_PLUS] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_PLUS_DOT] = ACTIONS(3845),
    [anon_sym_DASH_DOT] = ACTIONS(3845),
    [anon_sym_PERCENT] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3845),
    [anon_sym_TILDE] = ACTIONS(3843),
    [aux_sym_prefix_op_token1] = ACTIONS(3845),
    [aux_sym_infix_op_token1] = ACTIONS(3843),
    [aux_sym_infix_op_token2] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(3845),
    [anon_sym_BANG_EQ] = ACTIONS(3845),
    [anon_sym_COLON_EQ] = ACTIONS(3843),
    [anon_sym_DOLLAR] = ACTIONS(3845),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3845),
    [sym_int] = ACTIONS(3845),
    [sym_xint] = ACTIONS(3843),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3843),
    [sym__newline] = ACTIONS(3843),
  },
  [3344] = {
    [sym_block_comment] = STATE(3344),
    [sym_compiler_directive_decl] = STATE(3344),
    [sym_fsi_directive_decl] = STATE(3344),
    [sym_preproc_line] = STATE(3344),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4739),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
    [sym__dedent] = ACTIONS(5889),
  },
  [3345] = {
    [sym_block_comment] = STATE(3345),
    [sym_compiler_directive_decl] = STATE(3345),
    [sym_fsi_directive_decl] = STATE(3345),
    [sym_preproc_line] = STATE(3345),
    [sym_identifier] = ACTIONS(4064),
    [anon_sym_EQ] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4064),
    [anon_sym_return] = ACTIONS(4064),
    [anon_sym_do] = ACTIONS(4064),
    [anon_sym_let] = ACTIONS(4064),
    [anon_sym_let_BANG] = ACTIONS(4062),
    [anon_sym_LPAREN] = ACTIONS(4064),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_null] = ACTIONS(4064),
    [anon_sym_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_COLON] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4062),
    [anon_sym_LBRACE] = ACTIONS(4064),
    [anon_sym_LT_AT] = ACTIONS(4064),
    [anon_sym_LT_AT_AT] = ACTIONS(4064),
    [anon_sym_DOT] = ACTIONS(4064),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4062),
    [anon_sym_new] = ACTIONS(4064),
    [anon_sym_return_BANG] = ACTIONS(4062),
    [anon_sym_yield] = ACTIONS(4064),
    [anon_sym_yield_BANG] = ACTIONS(4062),
    [anon_sym_lazy] = ACTIONS(4064),
    [anon_sym_assert] = ACTIONS(4064),
    [anon_sym_upcast] = ACTIONS(4064),
    [anon_sym_downcast] = ACTIONS(4064),
    [anon_sym_COLON_GT] = ACTIONS(4062),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4062),
    [anon_sym_for] = ACTIONS(4064),
    [anon_sym_while] = ACTIONS(4064),
    [anon_sym_if] = ACTIONS(4064),
    [anon_sym_fun] = ACTIONS(4064),
    [anon_sym_try] = ACTIONS(4064),
    [anon_sym_match] = ACTIONS(4064),
    [anon_sym_match_BANG] = ACTIONS(4062),
    [anon_sym_function] = ACTIONS(4064),
    [anon_sym_LT_DASH] = ACTIONS(4064),
    [anon_sym_DOT_LBRACK] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(4062),
    [anon_sym_GT] = ACTIONS(4064),
    [anon_sym_use] = ACTIONS(4064),
    [anon_sym_use_BANG] = ACTIONS(4062),
    [anon_sym_do_BANG] = ACTIONS(4062),
    [anon_sym_begin] = ACTIONS(4064),
    [anon_sym_LPAREN2] = ACTIONS(4064),
    [anon_sym_or] = ACTIONS(4064),
    [aux_sym_char_token1] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_AT_DQUOTE] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [sym_bool] = ACTIONS(4064),
    [sym_unit] = ACTIONS(4062),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4064),
    [sym_op_identifier] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4064),
    [anon_sym_DASH] = ACTIONS(4064),
    [anon_sym_PLUS_DOT] = ACTIONS(4064),
    [anon_sym_DASH_DOT] = ACTIONS(4064),
    [anon_sym_PERCENT] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_TILDE] = ACTIONS(4062),
    [aux_sym_prefix_op_token1] = ACTIONS(4064),
    [aux_sym_infix_op_token1] = ACTIONS(4062),
    [aux_sym_infix_op_token2] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_BANG_EQ] = ACTIONS(4064),
    [anon_sym_COLON_EQ] = ACTIONS(4062),
    [anon_sym_DOLLAR] = ACTIONS(4064),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4064),
    [sym_int] = ACTIONS(4064),
    [sym_xint] = ACTIONS(4062),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4062),
    [sym__newline] = ACTIONS(4062),
  },
  [3346] = {
    [sym_block_comment] = STATE(3346),
    [sym_compiler_directive_decl] = STATE(3346),
    [sym_fsi_directive_decl] = STATE(3346),
    [sym_preproc_line] = STATE(3346),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_EQ] = ACTIONS(4001),
    [anon_sym_COLON] = ACTIONS(4003),
    [anon_sym_return] = ACTIONS(4003),
    [anon_sym_do] = ACTIONS(4003),
    [anon_sym_let] = ACTIONS(4003),
    [anon_sym_let_BANG] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4003),
    [anon_sym_COMMA] = ACTIONS(4001),
    [anon_sym_null] = ACTIONS(4003),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_COLON] = ACTIONS(4001),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LBRACK] = ACTIONS(4003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4001),
    [anon_sym_LBRACE] = ACTIONS(4003),
    [anon_sym_LT_AT] = ACTIONS(4003),
    [anon_sym_LT_AT_AT] = ACTIONS(4003),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4001),
    [anon_sym_new] = ACTIONS(4003),
    [anon_sym_return_BANG] = ACTIONS(4001),
    [anon_sym_yield] = ACTIONS(4003),
    [anon_sym_yield_BANG] = ACTIONS(4001),
    [anon_sym_lazy] = ACTIONS(4003),
    [anon_sym_assert] = ACTIONS(4003),
    [anon_sym_upcast] = ACTIONS(4003),
    [anon_sym_downcast] = ACTIONS(4003),
    [anon_sym_COLON_GT] = ACTIONS(4001),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4001),
    [anon_sym_for] = ACTIONS(4003),
    [anon_sym_while] = ACTIONS(4003),
    [anon_sym_if] = ACTIONS(4003),
    [anon_sym_fun] = ACTIONS(4003),
    [anon_sym_try] = ACTIONS(4003),
    [anon_sym_match] = ACTIONS(4003),
    [anon_sym_match_BANG] = ACTIONS(4001),
    [anon_sym_function] = ACTIONS(4003),
    [anon_sym_LT_DASH] = ACTIONS(4003),
    [anon_sym_DOT_LBRACK] = ACTIONS(4001),
    [anon_sym_LT] = ACTIONS(4001),
    [anon_sym_use] = ACTIONS(4003),
    [anon_sym_use_BANG] = ACTIONS(4001),
    [anon_sym_do_BANG] = ACTIONS(4001),
    [anon_sym_DOT_DOT] = ACTIONS(4001),
    [anon_sym_begin] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [aux_sym_char_token1] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4003),
    [anon_sym_DQUOTE] = ACTIONS(4003),
    [anon_sym_AT_DQUOTE] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [sym_bool] = ACTIONS(4003),
    [sym_unit] = ACTIONS(4001),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4003),
    [sym_op_identifier] = ACTIONS(4003),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_PLUS_DOT] = ACTIONS(4003),
    [anon_sym_DASH_DOT] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4003),
    [anon_sym_TILDE] = ACTIONS(4001),
    [aux_sym_prefix_op_token1] = ACTIONS(4003),
    [aux_sym_infix_op_token1] = ACTIONS(4001),
    [aux_sym_infix_op_token2] = ACTIONS(4003),
    [anon_sym_PIPE_PIPE] = ACTIONS(4003),
    [anon_sym_BANG_EQ] = ACTIONS(4003),
    [anon_sym_COLON_EQ] = ACTIONS(4001),
    [anon_sym_DOLLAR] = ACTIONS(4003),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4003),
    [sym_int] = ACTIONS(4003),
    [sym_xint] = ACTIONS(4001),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4001),
    [sym__newline] = ACTIONS(4001),
  },
  [3347] = {
    [sym_block_comment] = STATE(3347),
    [sym_compiler_directive_decl] = STATE(3347),
    [sym_fsi_directive_decl] = STATE(3347),
    [sym_preproc_line] = STATE(3347),
    [sym_identifier] = ACTIONS(3996),
    [anon_sym_EQ] = ACTIONS(3994),
    [anon_sym_COLON] = ACTIONS(3996),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_do] = ACTIONS(3996),
    [anon_sym_let] = ACTIONS(3996),
    [anon_sym_let_BANG] = ACTIONS(3994),
    [anon_sym_LPAREN] = ACTIONS(3996),
    [anon_sym_COMMA] = ACTIONS(3994),
    [anon_sym_null] = ACTIONS(3996),
    [anon_sym_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_COLON] = ACTIONS(3994),
    [anon_sym_AMP] = ACTIONS(3996),
    [anon_sym_LBRACK] = ACTIONS(3996),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3994),
    [anon_sym_LBRACE] = ACTIONS(3996),
    [anon_sym_LT_AT] = ACTIONS(3996),
    [anon_sym_LT_AT_AT] = ACTIONS(3996),
    [anon_sym_DOT] = ACTIONS(3996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3994),
    [anon_sym_new] = ACTIONS(3996),
    [anon_sym_return_BANG] = ACTIONS(3994),
    [anon_sym_yield] = ACTIONS(3996),
    [anon_sym_yield_BANG] = ACTIONS(3994),
    [anon_sym_lazy] = ACTIONS(3996),
    [anon_sym_assert] = ACTIONS(3996),
    [anon_sym_upcast] = ACTIONS(3996),
    [anon_sym_downcast] = ACTIONS(3996),
    [anon_sym_COLON_GT] = ACTIONS(3994),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3994),
    [anon_sym_for] = ACTIONS(3996),
    [anon_sym_while] = ACTIONS(3996),
    [anon_sym_if] = ACTIONS(3996),
    [anon_sym_fun] = ACTIONS(3996),
    [anon_sym_try] = ACTIONS(3996),
    [anon_sym_match] = ACTIONS(3996),
    [anon_sym_match_BANG] = ACTIONS(3994),
    [anon_sym_function] = ACTIONS(3996),
    [anon_sym_LT_DASH] = ACTIONS(3996),
    [anon_sym_DOT_LBRACK] = ACTIONS(3994),
    [anon_sym_LT] = ACTIONS(3994),
    [anon_sym_use] = ACTIONS(3996),
    [anon_sym_use_BANG] = ACTIONS(3994),
    [anon_sym_do_BANG] = ACTIONS(3994),
    [anon_sym_DOT_DOT] = ACTIONS(3994),
    [anon_sym_begin] = ACTIONS(3996),
    [anon_sym_LPAREN2] = ACTIONS(3996),
    [anon_sym_or] = ACTIONS(3996),
    [aux_sym_char_token1] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3996),
    [anon_sym_DQUOTE] = ACTIONS(3996),
    [anon_sym_AT_DQUOTE] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [sym_bool] = ACTIONS(3996),
    [sym_unit] = ACTIONS(3994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3996),
    [sym_op_identifier] = ACTIONS(3996),
    [anon_sym_PLUS] = ACTIONS(3996),
    [anon_sym_DASH] = ACTIONS(3996),
    [anon_sym_PLUS_DOT] = ACTIONS(3996),
    [anon_sym_DASH_DOT] = ACTIONS(3996),
    [anon_sym_PERCENT] = ACTIONS(3996),
    [anon_sym_AMP_AMP] = ACTIONS(3996),
    [anon_sym_TILDE] = ACTIONS(3994),
    [aux_sym_prefix_op_token1] = ACTIONS(3996),
    [aux_sym_infix_op_token1] = ACTIONS(3994),
    [aux_sym_infix_op_token2] = ACTIONS(3996),
    [anon_sym_PIPE_PIPE] = ACTIONS(3996),
    [anon_sym_BANG_EQ] = ACTIONS(3996),
    [anon_sym_COLON_EQ] = ACTIONS(3994),
    [anon_sym_DOLLAR] = ACTIONS(3996),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3996),
    [sym_int] = ACTIONS(3996),
    [sym_xint] = ACTIONS(3994),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3994),
    [sym__newline] = ACTIONS(3994),
  },
  [3348] = {
    [sym_block_comment] = STATE(3348),
    [sym_compiler_directive_decl] = STATE(3348),
    [sym_fsi_directive_decl] = STATE(3348),
    [sym_preproc_line] = STATE(3348),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4739),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
    [sym__dedent] = ACTIONS(5891),
  },
  [3349] = {
    [sym_block_comment] = STATE(3349),
    [sym_compiler_directive_decl] = STATE(3349),
    [sym_fsi_directive_decl] = STATE(3349),
    [sym_preproc_line] = STATE(3349),
    [sym_identifier] = ACTIONS(3972),
    [anon_sym_EQ] = ACTIONS(3970),
    [anon_sym_COLON] = ACTIONS(3972),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_do] = ACTIONS(3972),
    [anon_sym_let] = ACTIONS(3972),
    [anon_sym_let_BANG] = ACTIONS(3970),
    [anon_sym_LPAREN] = ACTIONS(3972),
    [anon_sym_COMMA] = ACTIONS(3970),
    [anon_sym_null] = ACTIONS(3972),
    [anon_sym_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_COLON] = ACTIONS(3970),
    [anon_sym_AMP] = ACTIONS(3972),
    [anon_sym_LBRACK] = ACTIONS(3972),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3970),
    [anon_sym_LBRACE] = ACTIONS(3972),
    [anon_sym_LT_AT] = ACTIONS(3972),
    [anon_sym_LT_AT_AT] = ACTIONS(3972),
    [anon_sym_DOT] = ACTIONS(3972),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3970),
    [anon_sym_new] = ACTIONS(3972),
    [anon_sym_return_BANG] = ACTIONS(3970),
    [anon_sym_yield] = ACTIONS(3972),
    [anon_sym_yield_BANG] = ACTIONS(3970),
    [anon_sym_lazy] = ACTIONS(3972),
    [anon_sym_assert] = ACTIONS(3972),
    [anon_sym_upcast] = ACTIONS(3972),
    [anon_sym_downcast] = ACTIONS(3972),
    [anon_sym_COLON_GT] = ACTIONS(3970),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3970),
    [anon_sym_for] = ACTIONS(3972),
    [anon_sym_while] = ACTIONS(3972),
    [anon_sym_if] = ACTIONS(3972),
    [anon_sym_fun] = ACTIONS(3972),
    [anon_sym_try] = ACTIONS(3972),
    [anon_sym_match] = ACTIONS(3972),
    [anon_sym_match_BANG] = ACTIONS(3970),
    [anon_sym_function] = ACTIONS(3972),
    [anon_sym_LT_DASH] = ACTIONS(3972),
    [anon_sym_DOT_LBRACK] = ACTIONS(3970),
    [anon_sym_LT] = ACTIONS(3970),
    [anon_sym_use] = ACTIONS(3972),
    [anon_sym_use_BANG] = ACTIONS(3970),
    [anon_sym_do_BANG] = ACTIONS(3970),
    [anon_sym_DOT_DOT] = ACTIONS(3970),
    [anon_sym_begin] = ACTIONS(3972),
    [anon_sym_LPAREN2] = ACTIONS(3972),
    [anon_sym_or] = ACTIONS(3972),
    [aux_sym_char_token1] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3972),
    [anon_sym_DQUOTE] = ACTIONS(3972),
    [anon_sym_AT_DQUOTE] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [sym_bool] = ACTIONS(3972),
    [sym_unit] = ACTIONS(3970),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3972),
    [sym_op_identifier] = ACTIONS(3972),
    [anon_sym_PLUS] = ACTIONS(3972),
    [anon_sym_DASH] = ACTIONS(3972),
    [anon_sym_PLUS_DOT] = ACTIONS(3972),
    [anon_sym_DASH_DOT] = ACTIONS(3972),
    [anon_sym_PERCENT] = ACTIONS(3972),
    [anon_sym_AMP_AMP] = ACTIONS(3972),
    [anon_sym_TILDE] = ACTIONS(3970),
    [aux_sym_prefix_op_token1] = ACTIONS(3972),
    [aux_sym_infix_op_token1] = ACTIONS(3970),
    [aux_sym_infix_op_token2] = ACTIONS(3972),
    [anon_sym_PIPE_PIPE] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3972),
    [anon_sym_COLON_EQ] = ACTIONS(3970),
    [anon_sym_DOLLAR] = ACTIONS(3972),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3972),
    [sym_int] = ACTIONS(3972),
    [sym_xint] = ACTIONS(3970),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3970),
    [sym__newline] = ACTIONS(3970),
  },
  [3350] = {
    [sym_block_comment] = STATE(3350),
    [sym_compiler_directive_decl] = STATE(3350),
    [sym_fsi_directive_decl] = STATE(3350),
    [sym_preproc_line] = STATE(3350),
    [sym_identifier] = ACTIONS(3927),
    [anon_sym_EQ] = ACTIONS(3925),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_return] = ACTIONS(3927),
    [anon_sym_do] = ACTIONS(3927),
    [anon_sym_let] = ACTIONS(3927),
    [anon_sym_let_BANG] = ACTIONS(3925),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_COMMA] = ACTIONS(3925),
    [anon_sym_null] = ACTIONS(3927),
    [anon_sym_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_COLON] = ACTIONS(3925),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3925),
    [anon_sym_LBRACE] = ACTIONS(3927),
    [anon_sym_LT_AT] = ACTIONS(3927),
    [anon_sym_LT_AT_AT] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3925),
    [anon_sym_new] = ACTIONS(3927),
    [anon_sym_return_BANG] = ACTIONS(3925),
    [anon_sym_yield] = ACTIONS(3927),
    [anon_sym_yield_BANG] = ACTIONS(3925),
    [anon_sym_lazy] = ACTIONS(3927),
    [anon_sym_assert] = ACTIONS(3927),
    [anon_sym_upcast] = ACTIONS(3927),
    [anon_sym_downcast] = ACTIONS(3927),
    [anon_sym_COLON_GT] = ACTIONS(3925),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3925),
    [anon_sym_for] = ACTIONS(3927),
    [anon_sym_while] = ACTIONS(3927),
    [anon_sym_if] = ACTIONS(3927),
    [anon_sym_fun] = ACTIONS(3927),
    [anon_sym_try] = ACTIONS(3927),
    [anon_sym_match] = ACTIONS(3927),
    [anon_sym_match_BANG] = ACTIONS(3925),
    [anon_sym_function] = ACTIONS(3927),
    [anon_sym_LT_DASH] = ACTIONS(3927),
    [anon_sym_DOT_LBRACK] = ACTIONS(3925),
    [anon_sym_LT] = ACTIONS(3925),
    [anon_sym_use] = ACTIONS(3927),
    [anon_sym_use_BANG] = ACTIONS(3925),
    [anon_sym_do_BANG] = ACTIONS(3925),
    [anon_sym_DOT_DOT] = ACTIONS(3925),
    [anon_sym_begin] = ACTIONS(3927),
    [anon_sym_LPAREN2] = ACTIONS(3927),
    [anon_sym_or] = ACTIONS(3927),
    [aux_sym_char_token1] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_AT_DQUOTE] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [sym_bool] = ACTIONS(3927),
    [sym_unit] = ACTIONS(3925),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3927),
    [sym_op_identifier] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3927),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_PLUS_DOT] = ACTIONS(3927),
    [anon_sym_DASH_DOT] = ACTIONS(3927),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_TILDE] = ACTIONS(3925),
    [aux_sym_prefix_op_token1] = ACTIONS(3927),
    [aux_sym_infix_op_token1] = ACTIONS(3925),
    [aux_sym_infix_op_token2] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_COLON_EQ] = ACTIONS(3925),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3927),
    [sym_int] = ACTIONS(3927),
    [sym_xint] = ACTIONS(3925),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3925),
    [sym__newline] = ACTIONS(3925),
  },
  [3351] = {
    [sym_block_comment] = STATE(3351),
    [sym_compiler_directive_decl] = STATE(3351),
    [sym_fsi_directive_decl] = STATE(3351),
    [sym_preproc_line] = STATE(3351),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_DOT_DOT] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [3352] = {
    [sym_block_comment] = STATE(3352),
    [sym_compiler_directive_decl] = STATE(3352),
    [sym_fsi_directive_decl] = STATE(3352),
    [sym_preproc_line] = STATE(3352),
    [sym_identifier] = ACTIONS(4104),
    [anon_sym_EQ] = ACTIONS(4102),
    [anon_sym_COLON] = ACTIONS(4104),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_do] = ACTIONS(4104),
    [anon_sym_let] = ACTIONS(4104),
    [anon_sym_let_BANG] = ACTIONS(4102),
    [anon_sym_LPAREN] = ACTIONS(4104),
    [anon_sym_COMMA] = ACTIONS(4102),
    [anon_sym_null] = ACTIONS(4104),
    [anon_sym_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_COLON] = ACTIONS(4102),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4104),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4102),
    [anon_sym_LBRACE] = ACTIONS(4104),
    [anon_sym_LT_AT] = ACTIONS(4104),
    [anon_sym_LT_AT_AT] = ACTIONS(4104),
    [anon_sym_DOT] = ACTIONS(4104),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4102),
    [anon_sym_new] = ACTIONS(4104),
    [anon_sym_return_BANG] = ACTIONS(4102),
    [anon_sym_yield] = ACTIONS(4104),
    [anon_sym_yield_BANG] = ACTIONS(4102),
    [anon_sym_lazy] = ACTIONS(4104),
    [anon_sym_assert] = ACTIONS(4104),
    [anon_sym_upcast] = ACTIONS(4104),
    [anon_sym_downcast] = ACTIONS(4104),
    [anon_sym_COLON_GT] = ACTIONS(4102),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4102),
    [anon_sym_for] = ACTIONS(4104),
    [anon_sym_while] = ACTIONS(4104),
    [anon_sym_if] = ACTIONS(4104),
    [anon_sym_fun] = ACTIONS(4104),
    [anon_sym_try] = ACTIONS(4104),
    [anon_sym_match] = ACTIONS(4104),
    [anon_sym_match_BANG] = ACTIONS(4102),
    [anon_sym_function] = ACTIONS(4104),
    [anon_sym_LT_DASH] = ACTIONS(4104),
    [anon_sym_DOT_LBRACK] = ACTIONS(4102),
    [anon_sym_LT] = ACTIONS(4102),
    [anon_sym_use] = ACTIONS(4104),
    [anon_sym_use_BANG] = ACTIONS(4102),
    [anon_sym_do_BANG] = ACTIONS(4102),
    [anon_sym_DOT_DOT] = ACTIONS(4102),
    [anon_sym_begin] = ACTIONS(4104),
    [anon_sym_LPAREN2] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [aux_sym_char_token1] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4104),
    [anon_sym_DQUOTE] = ACTIONS(4104),
    [anon_sym_AT_DQUOTE] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [sym_bool] = ACTIONS(4104),
    [sym_unit] = ACTIONS(4102),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4104),
    [sym_op_identifier] = ACTIONS(4104),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_PLUS_DOT] = ACTIONS(4104),
    [anon_sym_DASH_DOT] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_AMP_AMP] = ACTIONS(4104),
    [anon_sym_TILDE] = ACTIONS(4102),
    [aux_sym_prefix_op_token1] = ACTIONS(4104),
    [aux_sym_infix_op_token1] = ACTIONS(4102),
    [aux_sym_infix_op_token2] = ACTIONS(4104),
    [anon_sym_PIPE_PIPE] = ACTIONS(4104),
    [anon_sym_BANG_EQ] = ACTIONS(4104),
    [anon_sym_COLON_EQ] = ACTIONS(4102),
    [anon_sym_DOLLAR] = ACTIONS(4104),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4104),
    [sym_int] = ACTIONS(4104),
    [sym_xint] = ACTIONS(4102),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4102),
    [sym__newline] = ACTIONS(4102),
  },
  [3353] = {
    [sym_block_comment] = STATE(3353),
    [sym_compiler_directive_decl] = STATE(3353),
    [sym_fsi_directive_decl] = STATE(3353),
    [sym_preproc_line] = STATE(3353),
    [sym_identifier] = ACTIONS(3889),
    [anon_sym_EQ] = ACTIONS(3887),
    [anon_sym_COLON] = ACTIONS(3889),
    [anon_sym_return] = ACTIONS(3889),
    [anon_sym_do] = ACTIONS(3889),
    [anon_sym_let] = ACTIONS(3889),
    [anon_sym_let_BANG] = ACTIONS(3887),
    [anon_sym_LPAREN] = ACTIONS(3889),
    [anon_sym_COMMA] = ACTIONS(3887),
    [anon_sym_null] = ACTIONS(3889),
    [anon_sym_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_COLON] = ACTIONS(3887),
    [anon_sym_AMP] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3887),
    [anon_sym_LBRACE] = ACTIONS(3889),
    [anon_sym_LT_AT] = ACTIONS(3889),
    [anon_sym_LT_AT_AT] = ACTIONS(3889),
    [anon_sym_DOT] = ACTIONS(3889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [anon_sym_new] = ACTIONS(3889),
    [anon_sym_return_BANG] = ACTIONS(3887),
    [anon_sym_yield] = ACTIONS(3889),
    [anon_sym_yield_BANG] = ACTIONS(3887),
    [anon_sym_lazy] = ACTIONS(3889),
    [anon_sym_assert] = ACTIONS(3889),
    [anon_sym_upcast] = ACTIONS(3889),
    [anon_sym_downcast] = ACTIONS(3889),
    [anon_sym_COLON_GT] = ACTIONS(3887),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3887),
    [anon_sym_for] = ACTIONS(3889),
    [anon_sym_while] = ACTIONS(3889),
    [anon_sym_if] = ACTIONS(3889),
    [anon_sym_fun] = ACTIONS(3889),
    [anon_sym_try] = ACTIONS(3889),
    [anon_sym_match] = ACTIONS(3889),
    [anon_sym_match_BANG] = ACTIONS(3887),
    [anon_sym_function] = ACTIONS(3889),
    [anon_sym_LT_DASH] = ACTIONS(3889),
    [anon_sym_DOT_LBRACK] = ACTIONS(3887),
    [anon_sym_LT] = ACTIONS(3887),
    [anon_sym_GT] = ACTIONS(3889),
    [anon_sym_use] = ACTIONS(3889),
    [anon_sym_use_BANG] = ACTIONS(3887),
    [anon_sym_do_BANG] = ACTIONS(3887),
    [anon_sym_begin] = ACTIONS(3889),
    [anon_sym_LPAREN2] = ACTIONS(3889),
    [anon_sym_or] = ACTIONS(3889),
    [aux_sym_char_token1] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3889),
    [anon_sym_DQUOTE] = ACTIONS(3889),
    [anon_sym_AT_DQUOTE] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [sym_bool] = ACTIONS(3889),
    [sym_unit] = ACTIONS(3887),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3889),
    [sym_op_identifier] = ACTIONS(3889),
    [anon_sym_PLUS] = ACTIONS(3889),
    [anon_sym_DASH] = ACTIONS(3889),
    [anon_sym_PLUS_DOT] = ACTIONS(3889),
    [anon_sym_DASH_DOT] = ACTIONS(3889),
    [anon_sym_PERCENT] = ACTIONS(3889),
    [anon_sym_AMP_AMP] = ACTIONS(3889),
    [anon_sym_TILDE] = ACTIONS(3887),
    [aux_sym_prefix_op_token1] = ACTIONS(3889),
    [aux_sym_infix_op_token1] = ACTIONS(3887),
    [aux_sym_infix_op_token2] = ACTIONS(3889),
    [anon_sym_PIPE_PIPE] = ACTIONS(3889),
    [anon_sym_BANG_EQ] = ACTIONS(3889),
    [anon_sym_COLON_EQ] = ACTIONS(3887),
    [anon_sym_DOLLAR] = ACTIONS(3889),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3889),
    [sym_int] = ACTIONS(3889),
    [sym_xint] = ACTIONS(3887),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3887),
    [sym__newline] = ACTIONS(3887),
  },
  [3354] = {
    [sym_block_comment] = STATE(3354),
    [sym_compiler_directive_decl] = STATE(3354),
    [sym_fsi_directive_decl] = STATE(3354),
    [sym_preproc_line] = STATE(3354),
    [sym_identifier] = ACTIONS(3976),
    [anon_sym_EQ] = ACTIONS(3974),
    [anon_sym_COLON] = ACTIONS(3976),
    [anon_sym_return] = ACTIONS(3976),
    [anon_sym_do] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_let_BANG] = ACTIONS(3974),
    [anon_sym_LPAREN] = ACTIONS(3976),
    [anon_sym_COMMA] = ACTIONS(3974),
    [anon_sym_null] = ACTIONS(3976),
    [anon_sym_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_COLON] = ACTIONS(3974),
    [anon_sym_AMP] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(3976),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3974),
    [anon_sym_LBRACE] = ACTIONS(3976),
    [anon_sym_LT_AT] = ACTIONS(3976),
    [anon_sym_LT_AT_AT] = ACTIONS(3976),
    [anon_sym_DOT] = ACTIONS(3976),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3974),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_return_BANG] = ACTIONS(3974),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_yield_BANG] = ACTIONS(3974),
    [anon_sym_lazy] = ACTIONS(3976),
    [anon_sym_assert] = ACTIONS(3976),
    [anon_sym_upcast] = ACTIONS(3976),
    [anon_sym_downcast] = ACTIONS(3976),
    [anon_sym_COLON_GT] = ACTIONS(3974),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3974),
    [anon_sym_for] = ACTIONS(3976),
    [anon_sym_while] = ACTIONS(3976),
    [anon_sym_if] = ACTIONS(3976),
    [anon_sym_fun] = ACTIONS(3976),
    [anon_sym_try] = ACTIONS(3976),
    [anon_sym_match] = ACTIONS(3976),
    [anon_sym_match_BANG] = ACTIONS(3974),
    [anon_sym_function] = ACTIONS(3976),
    [anon_sym_LT_DASH] = ACTIONS(3976),
    [anon_sym_DOT_LBRACK] = ACTIONS(3974),
    [anon_sym_LT] = ACTIONS(3974),
    [anon_sym_GT] = ACTIONS(3976),
    [anon_sym_use] = ACTIONS(3976),
    [anon_sym_use_BANG] = ACTIONS(3974),
    [anon_sym_do_BANG] = ACTIONS(3974),
    [anon_sym_begin] = ACTIONS(3976),
    [anon_sym_LPAREN2] = ACTIONS(3976),
    [anon_sym_or] = ACTIONS(3976),
    [aux_sym_char_token1] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3976),
    [anon_sym_DQUOTE] = ACTIONS(3976),
    [anon_sym_AT_DQUOTE] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [sym_bool] = ACTIONS(3976),
    [sym_unit] = ACTIONS(3974),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3976),
    [sym_op_identifier] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3976),
    [anon_sym_DASH] = ACTIONS(3976),
    [anon_sym_PLUS_DOT] = ACTIONS(3976),
    [anon_sym_DASH_DOT] = ACTIONS(3976),
    [anon_sym_PERCENT] = ACTIONS(3976),
    [anon_sym_AMP_AMP] = ACTIONS(3976),
    [anon_sym_TILDE] = ACTIONS(3974),
    [aux_sym_prefix_op_token1] = ACTIONS(3976),
    [aux_sym_infix_op_token1] = ACTIONS(3974),
    [aux_sym_infix_op_token2] = ACTIONS(3976),
    [anon_sym_PIPE_PIPE] = ACTIONS(3976),
    [anon_sym_BANG_EQ] = ACTIONS(3976),
    [anon_sym_COLON_EQ] = ACTIONS(3974),
    [anon_sym_DOLLAR] = ACTIONS(3976),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3976),
    [sym_int] = ACTIONS(3976),
    [sym_xint] = ACTIONS(3974),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3974),
    [sym__newline] = ACTIONS(3974),
  },
  [3355] = {
    [sym_block_comment] = STATE(3355),
    [sym_compiler_directive_decl] = STATE(3355),
    [sym_fsi_directive_decl] = STATE(3355),
    [sym_preproc_line] = STATE(3355),
    [sym_identifier] = ACTIONS(4170),
    [anon_sym_EQ] = ACTIONS(4168),
    [anon_sym_COLON] = ACTIONS(4170),
    [anon_sym_return] = ACTIONS(4170),
    [anon_sym_do] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_let_BANG] = ACTIONS(4168),
    [anon_sym_LPAREN] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4168),
    [anon_sym_null] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_COLON] = ACTIONS(4168),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4170),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4168),
    [anon_sym_LBRACE] = ACTIONS(4170),
    [anon_sym_LT_AT] = ACTIONS(4170),
    [anon_sym_LT_AT_AT] = ACTIONS(4170),
    [anon_sym_AT_AT_GT] = ACTIONS(4170),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4168),
    [anon_sym_new] = ACTIONS(4170),
    [anon_sym_return_BANG] = ACTIONS(4168),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_yield_BANG] = ACTIONS(4168),
    [anon_sym_lazy] = ACTIONS(4170),
    [anon_sym_assert] = ACTIONS(4170),
    [anon_sym_upcast] = ACTIONS(4170),
    [anon_sym_downcast] = ACTIONS(4170),
    [anon_sym_COLON_GT] = ACTIONS(4168),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4168),
    [anon_sym_for] = ACTIONS(4170),
    [anon_sym_while] = ACTIONS(4170),
    [anon_sym_if] = ACTIONS(4170),
    [anon_sym_fun] = ACTIONS(4170),
    [anon_sym_try] = ACTIONS(4170),
    [anon_sym_match] = ACTIONS(4170),
    [anon_sym_match_BANG] = ACTIONS(4168),
    [anon_sym_function] = ACTIONS(4170),
    [anon_sym_LT_DASH] = ACTIONS(4170),
    [anon_sym_DOT_LBRACK] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4168),
    [anon_sym_use] = ACTIONS(4170),
    [anon_sym_use_BANG] = ACTIONS(4168),
    [anon_sym_do_BANG] = ACTIONS(4168),
    [anon_sym_begin] = ACTIONS(4170),
    [anon_sym_LPAREN2] = ACTIONS(4170),
    [anon_sym_or] = ACTIONS(4170),
    [aux_sym_char_token1] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4170),
    [anon_sym_DQUOTE] = ACTIONS(4170),
    [anon_sym_AT_DQUOTE] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [sym_bool] = ACTIONS(4170),
    [sym_unit] = ACTIONS(4168),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4170),
    [sym_op_identifier] = ACTIONS(4170),
    [anon_sym_PLUS] = ACTIONS(4170),
    [anon_sym_DASH] = ACTIONS(4170),
    [anon_sym_PLUS_DOT] = ACTIONS(4170),
    [anon_sym_DASH_DOT] = ACTIONS(4170),
    [anon_sym_PERCENT] = ACTIONS(4170),
    [anon_sym_AMP_AMP] = ACTIONS(4170),
    [anon_sym_TILDE] = ACTIONS(4168),
    [aux_sym_prefix_op_token1] = ACTIONS(4170),
    [aux_sym_infix_op_token1] = ACTIONS(4168),
    [aux_sym_infix_op_token2] = ACTIONS(4170),
    [anon_sym_PIPE_PIPE] = ACTIONS(4170),
    [anon_sym_BANG_EQ] = ACTIONS(4170),
    [anon_sym_COLON_EQ] = ACTIONS(4168),
    [anon_sym_DOLLAR] = ACTIONS(4170),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4170),
    [sym_int] = ACTIONS(4170),
    [sym_xint] = ACTIONS(4168),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4168),
    [sym__newline] = ACTIONS(4168),
  },
  [3356] = {
    [sym_block_comment] = STATE(3356),
    [sym_compiler_directive_decl] = STATE(3356),
    [sym_fsi_directive_decl] = STATE(3356),
    [sym_preproc_line] = STATE(3356),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_AT_GT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [3357] = {
    [sym_block_comment] = STATE(3357),
    [sym_compiler_directive_decl] = STATE(3357),
    [sym_fsi_directive_decl] = STATE(3357),
    [sym_preproc_line] = STATE(3357),
    [sym_identifier] = ACTIONS(3946),
    [anon_sym_EQ] = ACTIONS(3944),
    [anon_sym_COLON] = ACTIONS(3946),
    [anon_sym_return] = ACTIONS(3946),
    [anon_sym_do] = ACTIONS(3946),
    [anon_sym_let] = ACTIONS(3946),
    [anon_sym_let_BANG] = ACTIONS(3944),
    [anon_sym_LPAREN] = ACTIONS(3946),
    [anon_sym_COMMA] = ACTIONS(3944),
    [anon_sym_null] = ACTIONS(3946),
    [anon_sym_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LBRACK] = ACTIONS(3946),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3944),
    [anon_sym_LBRACE] = ACTIONS(3946),
    [anon_sym_LT_AT] = ACTIONS(3946),
    [anon_sym_LT_AT_AT] = ACTIONS(3946),
    [anon_sym_DOT] = ACTIONS(3946),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3944),
    [anon_sym_new] = ACTIONS(3946),
    [anon_sym_return_BANG] = ACTIONS(3944),
    [anon_sym_yield] = ACTIONS(3946),
    [anon_sym_yield_BANG] = ACTIONS(3944),
    [anon_sym_lazy] = ACTIONS(3946),
    [anon_sym_assert] = ACTIONS(3946),
    [anon_sym_upcast] = ACTIONS(3946),
    [anon_sym_downcast] = ACTIONS(3946),
    [anon_sym_COLON_GT] = ACTIONS(3944),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3944),
    [anon_sym_for] = ACTIONS(3946),
    [anon_sym_while] = ACTIONS(3946),
    [anon_sym_if] = ACTIONS(3946),
    [anon_sym_fun] = ACTIONS(3946),
    [anon_sym_try] = ACTIONS(3946),
    [anon_sym_match] = ACTIONS(3946),
    [anon_sym_match_BANG] = ACTIONS(3944),
    [anon_sym_function] = ACTIONS(3946),
    [anon_sym_LT_DASH] = ACTIONS(3946),
    [anon_sym_DOT_LBRACK] = ACTIONS(3944),
    [anon_sym_LT] = ACTIONS(3944),
    [anon_sym_use] = ACTIONS(3946),
    [anon_sym_use_BANG] = ACTIONS(3944),
    [anon_sym_do_BANG] = ACTIONS(3944),
    [anon_sym_DOT_DOT] = ACTIONS(3944),
    [anon_sym_begin] = ACTIONS(3946),
    [anon_sym_LPAREN2] = ACTIONS(3946),
    [anon_sym_or] = ACTIONS(3946),
    [aux_sym_char_token1] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_AT_DQUOTE] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [sym_bool] = ACTIONS(3946),
    [sym_unit] = ACTIONS(3944),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3946),
    [sym_op_identifier] = ACTIONS(3946),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PLUS_DOT] = ACTIONS(3946),
    [anon_sym_DASH_DOT] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3946),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_TILDE] = ACTIONS(3944),
    [aux_sym_prefix_op_token1] = ACTIONS(3946),
    [aux_sym_infix_op_token1] = ACTIONS(3944),
    [aux_sym_infix_op_token2] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [anon_sym_BANG_EQ] = ACTIONS(3946),
    [anon_sym_COLON_EQ] = ACTIONS(3944),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3946),
    [sym_int] = ACTIONS(3946),
    [sym_xint] = ACTIONS(3944),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3944),
    [sym__newline] = ACTIONS(3944),
  },
  [3358] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_type_arguments] = STATE(3868),
    [sym__method_defn] = STATE(7586),
    [sym__property_defn] = STATE(7598),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3358),
    [sym_compiler_directive_decl] = STATE(3358),
    [sym_fsi_directive_decl] = STATE(3358),
    [sym_preproc_line] = STATE(3358),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3748),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_COLON] = ACTIONS(5895),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [anon_sym_with] = ACTIONS(5897),
    [anon_sym_LT2] = ACTIONS(5809),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3359] = {
    [sym_block_comment] = STATE(3359),
    [sym_compiler_directive_decl] = STATE(3359),
    [sym_fsi_directive_decl] = STATE(3359),
    [sym_preproc_line] = STATE(3359),
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_EQ] = ACTIONS(4149),
    [anon_sym_COLON] = ACTIONS(4151),
    [anon_sym_return] = ACTIONS(4151),
    [anon_sym_do] = ACTIONS(4151),
    [anon_sym_let] = ACTIONS(4151),
    [anon_sym_let_BANG] = ACTIONS(4149),
    [anon_sym_LPAREN] = ACTIONS(4151),
    [anon_sym_COMMA] = ACTIONS(4149),
    [anon_sym_null] = ACTIONS(4151),
    [anon_sym_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_AMP] = ACTIONS(4151),
    [anon_sym_LBRACK] = ACTIONS(4151),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4149),
    [anon_sym_LBRACE] = ACTIONS(4151),
    [anon_sym_LT_AT] = ACTIONS(4151),
    [anon_sym_AT_GT] = ACTIONS(4151),
    [anon_sym_LT_AT_AT] = ACTIONS(4151),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4149),
    [anon_sym_new] = ACTIONS(4151),
    [anon_sym_return_BANG] = ACTIONS(4149),
    [anon_sym_yield] = ACTIONS(4151),
    [anon_sym_yield_BANG] = ACTIONS(4149),
    [anon_sym_lazy] = ACTIONS(4151),
    [anon_sym_assert] = ACTIONS(4151),
    [anon_sym_upcast] = ACTIONS(4151),
    [anon_sym_downcast] = ACTIONS(4151),
    [anon_sym_COLON_GT] = ACTIONS(4149),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4149),
    [anon_sym_for] = ACTIONS(4151),
    [anon_sym_while] = ACTIONS(4151),
    [anon_sym_if] = ACTIONS(4151),
    [anon_sym_fun] = ACTIONS(4151),
    [anon_sym_try] = ACTIONS(4151),
    [anon_sym_match] = ACTIONS(4151),
    [anon_sym_match_BANG] = ACTIONS(4149),
    [anon_sym_function] = ACTIONS(4151),
    [anon_sym_LT_DASH] = ACTIONS(4151),
    [anon_sym_DOT_LBRACK] = ACTIONS(4149),
    [anon_sym_LT] = ACTIONS(4149),
    [anon_sym_use] = ACTIONS(4151),
    [anon_sym_use_BANG] = ACTIONS(4149),
    [anon_sym_do_BANG] = ACTIONS(4149),
    [anon_sym_begin] = ACTIONS(4151),
    [anon_sym_LPAREN2] = ACTIONS(4151),
    [anon_sym_or] = ACTIONS(4151),
    [aux_sym_char_token1] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4151),
    [anon_sym_DQUOTE] = ACTIONS(4151),
    [anon_sym_AT_DQUOTE] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [sym_bool] = ACTIONS(4151),
    [sym_unit] = ACTIONS(4149),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4151),
    [sym_op_identifier] = ACTIONS(4151),
    [anon_sym_PLUS] = ACTIONS(4151),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_PLUS_DOT] = ACTIONS(4151),
    [anon_sym_DASH_DOT] = ACTIONS(4151),
    [anon_sym_PERCENT] = ACTIONS(4151),
    [anon_sym_AMP_AMP] = ACTIONS(4151),
    [anon_sym_TILDE] = ACTIONS(4149),
    [aux_sym_prefix_op_token1] = ACTIONS(4151),
    [aux_sym_infix_op_token1] = ACTIONS(4149),
    [aux_sym_infix_op_token2] = ACTIONS(4151),
    [anon_sym_PIPE_PIPE] = ACTIONS(4151),
    [anon_sym_BANG_EQ] = ACTIONS(4151),
    [anon_sym_COLON_EQ] = ACTIONS(4149),
    [anon_sym_DOLLAR] = ACTIONS(4151),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4151),
    [sym_int] = ACTIONS(4151),
    [sym_xint] = ACTIONS(4149),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4149),
    [sym__newline] = ACTIONS(4149),
  },
  [3360] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_type_arguments] = STATE(3842),
    [sym__method_defn] = STATE(7623),
    [sym__property_defn] = STATE(7622),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3360),
    [sym_compiler_directive_decl] = STATE(3360),
    [sym_fsi_directive_decl] = STATE(3360),
    [sym_preproc_line] = STATE(3360),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3736),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(5899),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_COLON] = ACTIONS(5901),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [anon_sym_with] = ACTIONS(5903),
    [anon_sym_LT2] = ACTIONS(5809),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3361] = {
    [sym_block_comment] = STATE(3361),
    [sym_compiler_directive_decl] = STATE(3361),
    [sym_fsi_directive_decl] = STATE(3361),
    [sym_preproc_line] = STATE(3361),
    [sym_identifier] = ACTIONS(4212),
    [anon_sym_EQ] = ACTIONS(4210),
    [anon_sym_COLON] = ACTIONS(4212),
    [anon_sym_return] = ACTIONS(4212),
    [anon_sym_do] = ACTIONS(4212),
    [anon_sym_let] = ACTIONS(4212),
    [anon_sym_let_BANG] = ACTIONS(4210),
    [anon_sym_LPAREN] = ACTIONS(4212),
    [anon_sym_COMMA] = ACTIONS(4210),
    [anon_sym_null] = ACTIONS(4212),
    [anon_sym_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_COLON] = ACTIONS(4210),
    [anon_sym_AMP] = ACTIONS(4212),
    [anon_sym_LBRACK] = ACTIONS(4212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4210),
    [anon_sym_LBRACE] = ACTIONS(4212),
    [anon_sym_LT_AT] = ACTIONS(4212),
    [anon_sym_LT_AT_AT] = ACTIONS(4212),
    [anon_sym_AT_AT_GT] = ACTIONS(4212),
    [anon_sym_DOT] = ACTIONS(4212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4210),
    [anon_sym_new] = ACTIONS(4212),
    [anon_sym_return_BANG] = ACTIONS(4210),
    [anon_sym_yield] = ACTIONS(4212),
    [anon_sym_yield_BANG] = ACTIONS(4210),
    [anon_sym_lazy] = ACTIONS(4212),
    [anon_sym_assert] = ACTIONS(4212),
    [anon_sym_upcast] = ACTIONS(4212),
    [anon_sym_downcast] = ACTIONS(4212),
    [anon_sym_COLON_GT] = ACTIONS(4210),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4210),
    [anon_sym_for] = ACTIONS(4212),
    [anon_sym_while] = ACTIONS(4212),
    [anon_sym_if] = ACTIONS(4212),
    [anon_sym_fun] = ACTIONS(4212),
    [anon_sym_try] = ACTIONS(4212),
    [anon_sym_match] = ACTIONS(4212),
    [anon_sym_match_BANG] = ACTIONS(4210),
    [anon_sym_function] = ACTIONS(4212),
    [anon_sym_LT_DASH] = ACTIONS(4212),
    [anon_sym_DOT_LBRACK] = ACTIONS(4210),
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_use] = ACTIONS(4212),
    [anon_sym_use_BANG] = ACTIONS(4210),
    [anon_sym_do_BANG] = ACTIONS(4210),
    [anon_sym_begin] = ACTIONS(4212),
    [anon_sym_LPAREN2] = ACTIONS(4212),
    [anon_sym_or] = ACTIONS(4212),
    [aux_sym_char_token1] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4212),
    [anon_sym_DQUOTE] = ACTIONS(4212),
    [anon_sym_AT_DQUOTE] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [sym_bool] = ACTIONS(4212),
    [sym_unit] = ACTIONS(4210),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4212),
    [anon_sym_DASH] = ACTIONS(4212),
    [anon_sym_PLUS_DOT] = ACTIONS(4212),
    [anon_sym_DASH_DOT] = ACTIONS(4212),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_AMP_AMP] = ACTIONS(4212),
    [anon_sym_TILDE] = ACTIONS(4210),
    [aux_sym_prefix_op_token1] = ACTIONS(4212),
    [aux_sym_infix_op_token1] = ACTIONS(4210),
    [aux_sym_infix_op_token2] = ACTIONS(4212),
    [anon_sym_PIPE_PIPE] = ACTIONS(4212),
    [anon_sym_BANG_EQ] = ACTIONS(4212),
    [anon_sym_COLON_EQ] = ACTIONS(4210),
    [anon_sym_DOLLAR] = ACTIONS(4212),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4212),
    [sym_int] = ACTIONS(4212),
    [sym_xint] = ACTIONS(4210),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4210),
    [sym__newline] = ACTIONS(4210),
  },
  [3362] = {
    [sym_block_comment] = STATE(3362),
    [sym_compiler_directive_decl] = STATE(3362),
    [sym_fsi_directive_decl] = STATE(3362),
    [sym_preproc_line] = STATE(3362),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_GT] = ACTIONS(4228),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
  },
  [3363] = {
    [sym_block_comment] = STATE(3363),
    [sym_compiler_directive_decl] = STATE(3363),
    [sym_fsi_directive_decl] = STATE(3363),
    [sym_preproc_line] = STATE(3363),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4072),
    [anon_sym_COLON] = ACTIONS(4074),
    [anon_sym_return] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_let_BANG] = ACTIONS(4072),
    [anon_sym_LPAREN] = ACTIONS(4074),
    [anon_sym_COMMA] = ACTIONS(4072),
    [anon_sym_null] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_COLON] = ACTIONS(4072),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_LT_AT] = ACTIONS(4074),
    [anon_sym_LT_AT_AT] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4072),
    [anon_sym_new] = ACTIONS(4074),
    [anon_sym_return_BANG] = ACTIONS(4072),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_yield_BANG] = ACTIONS(4072),
    [anon_sym_lazy] = ACTIONS(4074),
    [anon_sym_assert] = ACTIONS(4074),
    [anon_sym_upcast] = ACTIONS(4074),
    [anon_sym_downcast] = ACTIONS(4074),
    [anon_sym_COLON_GT] = ACTIONS(4072),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4072),
    [anon_sym_for] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_fun] = ACTIONS(4074),
    [anon_sym_try] = ACTIONS(4074),
    [anon_sym_match] = ACTIONS(4074),
    [anon_sym_match_BANG] = ACTIONS(4072),
    [anon_sym_function] = ACTIONS(4074),
    [anon_sym_LT_DASH] = ACTIONS(4074),
    [anon_sym_DOT_LBRACK] = ACTIONS(4072),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_use] = ACTIONS(4074),
    [anon_sym_use_BANG] = ACTIONS(4072),
    [anon_sym_do_BANG] = ACTIONS(4072),
    [anon_sym_DOT_DOT] = ACTIONS(4072),
    [anon_sym_begin] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [aux_sym_char_token1] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4074),
    [anon_sym_DQUOTE] = ACTIONS(4074),
    [anon_sym_AT_DQUOTE] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [sym_bool] = ACTIONS(4074),
    [sym_unit] = ACTIONS(4072),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4074),
    [sym_op_identifier] = ACTIONS(4074),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_PLUS_DOT] = ACTIONS(4074),
    [anon_sym_DASH_DOT] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_TILDE] = ACTIONS(4072),
    [aux_sym_prefix_op_token1] = ACTIONS(4074),
    [aux_sym_infix_op_token1] = ACTIONS(4072),
    [aux_sym_infix_op_token2] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [anon_sym_BANG_EQ] = ACTIONS(4074),
    [anon_sym_COLON_EQ] = ACTIONS(4072),
    [anon_sym_DOLLAR] = ACTIONS(4074),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4074),
    [sym_int] = ACTIONS(4074),
    [sym_xint] = ACTIONS(4072),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4072),
    [sym__newline] = ACTIONS(4072),
  },
  [3364] = {
    [sym_block_comment] = STATE(3364),
    [sym_compiler_directive_decl] = STATE(3364),
    [sym_fsi_directive_decl] = STATE(3364),
    [sym_preproc_line] = STATE(3364),
    [sym_identifier] = ACTIONS(4022),
    [anon_sym_EQ] = ACTIONS(4020),
    [anon_sym_COLON] = ACTIONS(4022),
    [anon_sym_return] = ACTIONS(4022),
    [anon_sym_do] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_let_BANG] = ACTIONS(4020),
    [anon_sym_LPAREN] = ACTIONS(4022),
    [anon_sym_COMMA] = ACTIONS(4020),
    [anon_sym_null] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_COLON] = ACTIONS(4020),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4022),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(4022),
    [anon_sym_LT_AT] = ACTIONS(4022),
    [anon_sym_LT_AT_AT] = ACTIONS(4022),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4020),
    [anon_sym_new] = ACTIONS(4022),
    [anon_sym_return_BANG] = ACTIONS(4020),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_yield_BANG] = ACTIONS(4020),
    [anon_sym_lazy] = ACTIONS(4022),
    [anon_sym_assert] = ACTIONS(4022),
    [anon_sym_upcast] = ACTIONS(4022),
    [anon_sym_downcast] = ACTIONS(4022),
    [anon_sym_COLON_GT] = ACTIONS(4020),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4020),
    [anon_sym_for] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4022),
    [anon_sym_if] = ACTIONS(4022),
    [anon_sym_fun] = ACTIONS(4022),
    [anon_sym_try] = ACTIONS(4022),
    [anon_sym_match] = ACTIONS(4022),
    [anon_sym_match_BANG] = ACTIONS(4020),
    [anon_sym_function] = ACTIONS(4022),
    [anon_sym_LT_DASH] = ACTIONS(4022),
    [anon_sym_DOT_LBRACK] = ACTIONS(4020),
    [anon_sym_LT] = ACTIONS(4020),
    [anon_sym_use] = ACTIONS(4022),
    [anon_sym_use_BANG] = ACTIONS(4020),
    [anon_sym_do_BANG] = ACTIONS(4020),
    [anon_sym_DOT_DOT] = ACTIONS(4020),
    [anon_sym_begin] = ACTIONS(4022),
    [anon_sym_LPAREN2] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [aux_sym_char_token1] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4022),
    [anon_sym_DQUOTE] = ACTIONS(4022),
    [anon_sym_AT_DQUOTE] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [sym_bool] = ACTIONS(4022),
    [sym_unit] = ACTIONS(4020),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4022),
    [sym_op_identifier] = ACTIONS(4022),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_PLUS_DOT] = ACTIONS(4022),
    [anon_sym_DASH_DOT] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4022),
    [anon_sym_TILDE] = ACTIONS(4020),
    [aux_sym_prefix_op_token1] = ACTIONS(4022),
    [aux_sym_infix_op_token1] = ACTIONS(4020),
    [aux_sym_infix_op_token2] = ACTIONS(4022),
    [anon_sym_PIPE_PIPE] = ACTIONS(4022),
    [anon_sym_BANG_EQ] = ACTIONS(4022),
    [anon_sym_COLON_EQ] = ACTIONS(4020),
    [anon_sym_DOLLAR] = ACTIONS(4022),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4022),
    [sym_int] = ACTIONS(4022),
    [sym_xint] = ACTIONS(4020),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4020),
    [sym__newline] = ACTIONS(4020),
  },
  [3365] = {
    [sym_block_comment] = STATE(3365),
    [sym_compiler_directive_decl] = STATE(3365),
    [sym_fsi_directive_decl] = STATE(3365),
    [sym_preproc_line] = STATE(3365),
    [sym_identifier] = ACTIONS(4011),
    [anon_sym_EQ] = ACTIONS(4009),
    [anon_sym_COLON] = ACTIONS(4011),
    [anon_sym_return] = ACTIONS(4011),
    [anon_sym_do] = ACTIONS(4011),
    [anon_sym_let] = ACTIONS(4011),
    [anon_sym_let_BANG] = ACTIONS(4009),
    [anon_sym_LPAREN] = ACTIONS(4011),
    [anon_sym_COMMA] = ACTIONS(4009),
    [anon_sym_null] = ACTIONS(4011),
    [anon_sym_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(4011),
    [anon_sym_LBRACK] = ACTIONS(4011),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4009),
    [anon_sym_LBRACE] = ACTIONS(4011),
    [anon_sym_LT_AT] = ACTIONS(4011),
    [anon_sym_LT_AT_AT] = ACTIONS(4011),
    [anon_sym_DOT] = ACTIONS(4011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4009),
    [anon_sym_new] = ACTIONS(4011),
    [anon_sym_return_BANG] = ACTIONS(4009),
    [anon_sym_yield] = ACTIONS(4011),
    [anon_sym_yield_BANG] = ACTIONS(4009),
    [anon_sym_lazy] = ACTIONS(4011),
    [anon_sym_assert] = ACTIONS(4011),
    [anon_sym_upcast] = ACTIONS(4011),
    [anon_sym_downcast] = ACTIONS(4011),
    [anon_sym_COLON_GT] = ACTIONS(4009),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4009),
    [anon_sym_for] = ACTIONS(4011),
    [anon_sym_while] = ACTIONS(4011),
    [anon_sym_if] = ACTIONS(4011),
    [anon_sym_fun] = ACTIONS(4011),
    [anon_sym_try] = ACTIONS(4011),
    [anon_sym_match] = ACTIONS(4011),
    [anon_sym_match_BANG] = ACTIONS(4009),
    [anon_sym_function] = ACTIONS(4011),
    [anon_sym_LT_DASH] = ACTIONS(4011),
    [anon_sym_DOT_LBRACK] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(4009),
    [anon_sym_use] = ACTIONS(4011),
    [anon_sym_use_BANG] = ACTIONS(4009),
    [anon_sym_do_BANG] = ACTIONS(4009),
    [anon_sym_DOT_DOT] = ACTIONS(4009),
    [anon_sym_begin] = ACTIONS(4011),
    [anon_sym_LPAREN2] = ACTIONS(4011),
    [anon_sym_or] = ACTIONS(4011),
    [aux_sym_char_token1] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4011),
    [anon_sym_DQUOTE] = ACTIONS(4011),
    [anon_sym_AT_DQUOTE] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [sym_bool] = ACTIONS(4011),
    [sym_unit] = ACTIONS(4009),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4011),
    [sym_op_identifier] = ACTIONS(4011),
    [anon_sym_PLUS] = ACTIONS(4011),
    [anon_sym_DASH] = ACTIONS(4011),
    [anon_sym_PLUS_DOT] = ACTIONS(4011),
    [anon_sym_DASH_DOT] = ACTIONS(4011),
    [anon_sym_PERCENT] = ACTIONS(4011),
    [anon_sym_AMP_AMP] = ACTIONS(4011),
    [anon_sym_TILDE] = ACTIONS(4009),
    [aux_sym_prefix_op_token1] = ACTIONS(4011),
    [aux_sym_infix_op_token1] = ACTIONS(4009),
    [aux_sym_infix_op_token2] = ACTIONS(4011),
    [anon_sym_PIPE_PIPE] = ACTIONS(4011),
    [anon_sym_BANG_EQ] = ACTIONS(4011),
    [anon_sym_COLON_EQ] = ACTIONS(4009),
    [anon_sym_DOLLAR] = ACTIONS(4011),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4011),
    [sym_int] = ACTIONS(4011),
    [sym_xint] = ACTIONS(4009),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4009),
    [sym__newline] = ACTIONS(4009),
  },
  [3366] = {
    [sym_block_comment] = STATE(3366),
    [sym_compiler_directive_decl] = STATE(3366),
    [sym_fsi_directive_decl] = STATE(3366),
    [sym_preproc_line] = STATE(3366),
    [sym_identifier] = ACTIONS(4007),
    [anon_sym_EQ] = ACTIONS(4005),
    [anon_sym_COLON] = ACTIONS(4007),
    [anon_sym_return] = ACTIONS(4007),
    [anon_sym_do] = ACTIONS(4007),
    [anon_sym_let] = ACTIONS(4007),
    [anon_sym_let_BANG] = ACTIONS(4005),
    [anon_sym_LPAREN] = ACTIONS(4007),
    [anon_sym_COMMA] = ACTIONS(4005),
    [anon_sym_null] = ACTIONS(4007),
    [anon_sym_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_COLON] = ACTIONS(4005),
    [anon_sym_AMP] = ACTIONS(4007),
    [anon_sym_LBRACK] = ACTIONS(4007),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4005),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_LT_AT] = ACTIONS(4007),
    [anon_sym_LT_AT_AT] = ACTIONS(4007),
    [anon_sym_DOT] = ACTIONS(4007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4005),
    [anon_sym_new] = ACTIONS(4007),
    [anon_sym_return_BANG] = ACTIONS(4005),
    [anon_sym_yield] = ACTIONS(4007),
    [anon_sym_yield_BANG] = ACTIONS(4005),
    [anon_sym_lazy] = ACTIONS(4007),
    [anon_sym_assert] = ACTIONS(4007),
    [anon_sym_upcast] = ACTIONS(4007),
    [anon_sym_downcast] = ACTIONS(4007),
    [anon_sym_COLON_GT] = ACTIONS(4005),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4005),
    [anon_sym_for] = ACTIONS(4007),
    [anon_sym_while] = ACTIONS(4007),
    [anon_sym_if] = ACTIONS(4007),
    [anon_sym_fun] = ACTIONS(4007),
    [anon_sym_try] = ACTIONS(4007),
    [anon_sym_match] = ACTIONS(4007),
    [anon_sym_match_BANG] = ACTIONS(4005),
    [anon_sym_function] = ACTIONS(4007),
    [anon_sym_LT_DASH] = ACTIONS(4007),
    [anon_sym_DOT_LBRACK] = ACTIONS(4005),
    [anon_sym_LT] = ACTIONS(4005),
    [anon_sym_use] = ACTIONS(4007),
    [anon_sym_use_BANG] = ACTIONS(4005),
    [anon_sym_do_BANG] = ACTIONS(4005),
    [anon_sym_DOT_DOT] = ACTIONS(4005),
    [anon_sym_begin] = ACTIONS(4007),
    [anon_sym_LPAREN2] = ACTIONS(4007),
    [anon_sym_or] = ACTIONS(4007),
    [aux_sym_char_token1] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4007),
    [anon_sym_DQUOTE] = ACTIONS(4007),
    [anon_sym_AT_DQUOTE] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [sym_bool] = ACTIONS(4007),
    [sym_unit] = ACTIONS(4005),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4007),
    [sym_op_identifier] = ACTIONS(4007),
    [anon_sym_PLUS] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4007),
    [anon_sym_PLUS_DOT] = ACTIONS(4007),
    [anon_sym_DASH_DOT] = ACTIONS(4007),
    [anon_sym_PERCENT] = ACTIONS(4007),
    [anon_sym_AMP_AMP] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4005),
    [aux_sym_prefix_op_token1] = ACTIONS(4007),
    [aux_sym_infix_op_token1] = ACTIONS(4005),
    [aux_sym_infix_op_token2] = ACTIONS(4007),
    [anon_sym_PIPE_PIPE] = ACTIONS(4007),
    [anon_sym_BANG_EQ] = ACTIONS(4007),
    [anon_sym_COLON_EQ] = ACTIONS(4005),
    [anon_sym_DOLLAR] = ACTIONS(4007),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4007),
    [sym_int] = ACTIONS(4007),
    [sym_xint] = ACTIONS(4005),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4005),
    [sym__newline] = ACTIONS(4005),
  },
  [3367] = {
    [sym_block_comment] = STATE(3367),
    [sym_compiler_directive_decl] = STATE(3367),
    [sym_fsi_directive_decl] = STATE(3367),
    [sym_preproc_line] = STATE(3367),
    [sym_identifier] = ACTIONS(4208),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_COLON] = ACTIONS(4208),
    [anon_sym_return] = ACTIONS(4208),
    [anon_sym_do] = ACTIONS(4208),
    [anon_sym_let] = ACTIONS(4208),
    [anon_sym_let_BANG] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(4206),
    [anon_sym_null] = ACTIONS(4208),
    [anon_sym_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_COLON] = ACTIONS(4206),
    [anon_sym_AMP] = ACTIONS(4208),
    [anon_sym_LBRACK] = ACTIONS(4208),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4206),
    [anon_sym_LBRACE] = ACTIONS(4208),
    [anon_sym_LT_AT] = ACTIONS(4208),
    [anon_sym_LT_AT_AT] = ACTIONS(4208),
    [anon_sym_AT_AT_GT] = ACTIONS(4208),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4206),
    [anon_sym_new] = ACTIONS(4208),
    [anon_sym_return_BANG] = ACTIONS(4206),
    [anon_sym_yield] = ACTIONS(4208),
    [anon_sym_yield_BANG] = ACTIONS(4206),
    [anon_sym_lazy] = ACTIONS(4208),
    [anon_sym_assert] = ACTIONS(4208),
    [anon_sym_upcast] = ACTIONS(4208),
    [anon_sym_downcast] = ACTIONS(4208),
    [anon_sym_COLON_GT] = ACTIONS(4206),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4206),
    [anon_sym_for] = ACTIONS(4208),
    [anon_sym_while] = ACTIONS(4208),
    [anon_sym_if] = ACTIONS(4208),
    [anon_sym_fun] = ACTIONS(4208),
    [anon_sym_try] = ACTIONS(4208),
    [anon_sym_match] = ACTIONS(4208),
    [anon_sym_match_BANG] = ACTIONS(4206),
    [anon_sym_function] = ACTIONS(4208),
    [anon_sym_LT_DASH] = ACTIONS(4208),
    [anon_sym_DOT_LBRACK] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(4206),
    [anon_sym_use] = ACTIONS(4208),
    [anon_sym_use_BANG] = ACTIONS(4206),
    [anon_sym_do_BANG] = ACTIONS(4206),
    [anon_sym_begin] = ACTIONS(4208),
    [anon_sym_LPAREN2] = ACTIONS(4208),
    [anon_sym_or] = ACTIONS(4208),
    [aux_sym_char_token1] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4208),
    [anon_sym_DQUOTE] = ACTIONS(4208),
    [anon_sym_AT_DQUOTE] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [sym_bool] = ACTIONS(4208),
    [sym_unit] = ACTIONS(4206),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4208),
    [sym_op_identifier] = ACTIONS(4208),
    [anon_sym_PLUS] = ACTIONS(4208),
    [anon_sym_DASH] = ACTIONS(4208),
    [anon_sym_PLUS_DOT] = ACTIONS(4208),
    [anon_sym_DASH_DOT] = ACTIONS(4208),
    [anon_sym_PERCENT] = ACTIONS(4208),
    [anon_sym_AMP_AMP] = ACTIONS(4208),
    [anon_sym_TILDE] = ACTIONS(4206),
    [aux_sym_prefix_op_token1] = ACTIONS(4208),
    [aux_sym_infix_op_token1] = ACTIONS(4206),
    [aux_sym_infix_op_token2] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(4208),
    [anon_sym_BANG_EQ] = ACTIONS(4208),
    [anon_sym_COLON_EQ] = ACTIONS(4206),
    [anon_sym_DOLLAR] = ACTIONS(4208),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4208),
    [sym_int] = ACTIONS(4208),
    [sym_xint] = ACTIONS(4206),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4206),
    [sym__newline] = ACTIONS(4206),
  },
  [3368] = {
    [sym_block_comment] = STATE(3368),
    [sym_compiler_directive_decl] = STATE(3368),
    [sym_fsi_directive_decl] = STATE(3368),
    [sym_preproc_line] = STATE(3368),
    [sym_identifier] = ACTIONS(4224),
    [anon_sym_EQ] = ACTIONS(4222),
    [anon_sym_COLON] = ACTIONS(4224),
    [anon_sym_return] = ACTIONS(4224),
    [anon_sym_do] = ACTIONS(4224),
    [anon_sym_let] = ACTIONS(4224),
    [anon_sym_let_BANG] = ACTIONS(4222),
    [anon_sym_LPAREN] = ACTIONS(4224),
    [anon_sym_COMMA] = ACTIONS(4222),
    [anon_sym_null] = ACTIONS(4224),
    [anon_sym_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_COLON] = ACTIONS(4222),
    [anon_sym_AMP] = ACTIONS(4224),
    [anon_sym_LBRACK] = ACTIONS(4224),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4222),
    [anon_sym_LBRACE] = ACTIONS(4224),
    [anon_sym_LT_AT] = ACTIONS(4224),
    [anon_sym_LT_AT_AT] = ACTIONS(4224),
    [anon_sym_AT_AT_GT] = ACTIONS(4224),
    [anon_sym_DOT] = ACTIONS(4224),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4222),
    [anon_sym_new] = ACTIONS(4224),
    [anon_sym_return_BANG] = ACTIONS(4222),
    [anon_sym_yield] = ACTIONS(4224),
    [anon_sym_yield_BANG] = ACTIONS(4222),
    [anon_sym_lazy] = ACTIONS(4224),
    [anon_sym_assert] = ACTIONS(4224),
    [anon_sym_upcast] = ACTIONS(4224),
    [anon_sym_downcast] = ACTIONS(4224),
    [anon_sym_COLON_GT] = ACTIONS(4222),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4222),
    [anon_sym_for] = ACTIONS(4224),
    [anon_sym_while] = ACTIONS(4224),
    [anon_sym_if] = ACTIONS(4224),
    [anon_sym_fun] = ACTIONS(4224),
    [anon_sym_try] = ACTIONS(4224),
    [anon_sym_match] = ACTIONS(4224),
    [anon_sym_match_BANG] = ACTIONS(4222),
    [anon_sym_function] = ACTIONS(4224),
    [anon_sym_LT_DASH] = ACTIONS(4224),
    [anon_sym_DOT_LBRACK] = ACTIONS(4222),
    [anon_sym_LT] = ACTIONS(4222),
    [anon_sym_use] = ACTIONS(4224),
    [anon_sym_use_BANG] = ACTIONS(4222),
    [anon_sym_do_BANG] = ACTIONS(4222),
    [anon_sym_begin] = ACTIONS(4224),
    [anon_sym_LPAREN2] = ACTIONS(4224),
    [anon_sym_or] = ACTIONS(4224),
    [aux_sym_char_token1] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4224),
    [anon_sym_DQUOTE] = ACTIONS(4224),
    [anon_sym_AT_DQUOTE] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [sym_bool] = ACTIONS(4224),
    [sym_unit] = ACTIONS(4222),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4224),
    [sym_op_identifier] = ACTIONS(4224),
    [anon_sym_PLUS] = ACTIONS(4224),
    [anon_sym_DASH] = ACTIONS(4224),
    [anon_sym_PLUS_DOT] = ACTIONS(4224),
    [anon_sym_DASH_DOT] = ACTIONS(4224),
    [anon_sym_PERCENT] = ACTIONS(4224),
    [anon_sym_AMP_AMP] = ACTIONS(4224),
    [anon_sym_TILDE] = ACTIONS(4222),
    [aux_sym_prefix_op_token1] = ACTIONS(4224),
    [aux_sym_infix_op_token1] = ACTIONS(4222),
    [aux_sym_infix_op_token2] = ACTIONS(4224),
    [anon_sym_PIPE_PIPE] = ACTIONS(4224),
    [anon_sym_BANG_EQ] = ACTIONS(4224),
    [anon_sym_COLON_EQ] = ACTIONS(4222),
    [anon_sym_DOLLAR] = ACTIONS(4224),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4224),
    [sym_int] = ACTIONS(4224),
    [sym_xint] = ACTIONS(4222),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4222),
    [sym__newline] = ACTIONS(4222),
  },
  [3369] = {
    [sym_block_comment] = STATE(3369),
    [sym_compiler_directive_decl] = STATE(3369),
    [sym_fsi_directive_decl] = STATE(3369),
    [sym_preproc_line] = STATE(3369),
    [sym_identifier] = ACTIONS(4147),
    [anon_sym_EQ] = ACTIONS(4145),
    [anon_sym_COLON] = ACTIONS(4147),
    [anon_sym_return] = ACTIONS(4147),
    [anon_sym_do] = ACTIONS(4147),
    [anon_sym_let] = ACTIONS(4147),
    [anon_sym_let_BANG] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(4147),
    [anon_sym_COMMA] = ACTIONS(4145),
    [anon_sym_null] = ACTIONS(4147),
    [anon_sym_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_COLON] = ACTIONS(4145),
    [anon_sym_AMP] = ACTIONS(4147),
    [anon_sym_LBRACK] = ACTIONS(4147),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4145),
    [anon_sym_LBRACE] = ACTIONS(4147),
    [anon_sym_LT_AT] = ACTIONS(4147),
    [anon_sym_AT_GT] = ACTIONS(4147),
    [anon_sym_LT_AT_AT] = ACTIONS(4147),
    [anon_sym_DOT] = ACTIONS(4147),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4145),
    [anon_sym_new] = ACTIONS(4147),
    [anon_sym_return_BANG] = ACTIONS(4145),
    [anon_sym_yield] = ACTIONS(4147),
    [anon_sym_yield_BANG] = ACTIONS(4145),
    [anon_sym_lazy] = ACTIONS(4147),
    [anon_sym_assert] = ACTIONS(4147),
    [anon_sym_upcast] = ACTIONS(4147),
    [anon_sym_downcast] = ACTIONS(4147),
    [anon_sym_COLON_GT] = ACTIONS(4145),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4145),
    [anon_sym_for] = ACTIONS(4147),
    [anon_sym_while] = ACTIONS(4147),
    [anon_sym_if] = ACTIONS(4147),
    [anon_sym_fun] = ACTIONS(4147),
    [anon_sym_try] = ACTIONS(4147),
    [anon_sym_match] = ACTIONS(4147),
    [anon_sym_match_BANG] = ACTIONS(4145),
    [anon_sym_function] = ACTIONS(4147),
    [anon_sym_LT_DASH] = ACTIONS(4147),
    [anon_sym_DOT_LBRACK] = ACTIONS(4145),
    [anon_sym_LT] = ACTIONS(4145),
    [anon_sym_use] = ACTIONS(4147),
    [anon_sym_use_BANG] = ACTIONS(4145),
    [anon_sym_do_BANG] = ACTIONS(4145),
    [anon_sym_begin] = ACTIONS(4147),
    [anon_sym_LPAREN2] = ACTIONS(4147),
    [anon_sym_or] = ACTIONS(4147),
    [aux_sym_char_token1] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4147),
    [anon_sym_DQUOTE] = ACTIONS(4147),
    [anon_sym_AT_DQUOTE] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [sym_bool] = ACTIONS(4147),
    [sym_unit] = ACTIONS(4145),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4147),
    [sym_op_identifier] = ACTIONS(4147),
    [anon_sym_PLUS] = ACTIONS(4147),
    [anon_sym_DASH] = ACTIONS(4147),
    [anon_sym_PLUS_DOT] = ACTIONS(4147),
    [anon_sym_DASH_DOT] = ACTIONS(4147),
    [anon_sym_PERCENT] = ACTIONS(4147),
    [anon_sym_AMP_AMP] = ACTIONS(4147),
    [anon_sym_TILDE] = ACTIONS(4145),
    [aux_sym_prefix_op_token1] = ACTIONS(4147),
    [aux_sym_infix_op_token1] = ACTIONS(4145),
    [aux_sym_infix_op_token2] = ACTIONS(4147),
    [anon_sym_PIPE_PIPE] = ACTIONS(4147),
    [anon_sym_BANG_EQ] = ACTIONS(4147),
    [anon_sym_COLON_EQ] = ACTIONS(4145),
    [anon_sym_DOLLAR] = ACTIONS(4147),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4147),
    [sym_int] = ACTIONS(4147),
    [sym_xint] = ACTIONS(4145),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4145),
    [sym__newline] = ACTIONS(4145),
  },
  [3370] = {
    [sym_block_comment] = STATE(3370),
    [sym_compiler_directive_decl] = STATE(3370),
    [sym_fsi_directive_decl] = STATE(3370),
    [sym_preproc_line] = STATE(3370),
    [sym_identifier] = ACTIONS(3889),
    [anon_sym_EQ] = ACTIONS(3887),
    [anon_sym_COLON] = ACTIONS(3889),
    [anon_sym_return] = ACTIONS(3889),
    [anon_sym_do] = ACTIONS(3889),
    [anon_sym_let] = ACTIONS(3889),
    [anon_sym_let_BANG] = ACTIONS(3887),
    [anon_sym_LPAREN] = ACTIONS(3889),
    [anon_sym_COMMA] = ACTIONS(3887),
    [anon_sym_null] = ACTIONS(3889),
    [anon_sym_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_COLON] = ACTIONS(3887),
    [anon_sym_AMP] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3887),
    [anon_sym_LBRACE] = ACTIONS(3889),
    [anon_sym_LT_AT] = ACTIONS(3889),
    [anon_sym_LT_AT_AT] = ACTIONS(3889),
    [anon_sym_AT_AT_GT] = ACTIONS(3889),
    [anon_sym_DOT] = ACTIONS(3889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [anon_sym_new] = ACTIONS(3889),
    [anon_sym_return_BANG] = ACTIONS(3887),
    [anon_sym_yield] = ACTIONS(3889),
    [anon_sym_yield_BANG] = ACTIONS(3887),
    [anon_sym_lazy] = ACTIONS(3889),
    [anon_sym_assert] = ACTIONS(3889),
    [anon_sym_upcast] = ACTIONS(3889),
    [anon_sym_downcast] = ACTIONS(3889),
    [anon_sym_COLON_GT] = ACTIONS(3887),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3887),
    [anon_sym_for] = ACTIONS(3889),
    [anon_sym_while] = ACTIONS(3889),
    [anon_sym_if] = ACTIONS(3889),
    [anon_sym_fun] = ACTIONS(3889),
    [anon_sym_try] = ACTIONS(3889),
    [anon_sym_match] = ACTIONS(3889),
    [anon_sym_match_BANG] = ACTIONS(3887),
    [anon_sym_function] = ACTIONS(3889),
    [anon_sym_LT_DASH] = ACTIONS(3889),
    [anon_sym_DOT_LBRACK] = ACTIONS(3887),
    [anon_sym_LT] = ACTIONS(3887),
    [anon_sym_use] = ACTIONS(3889),
    [anon_sym_use_BANG] = ACTIONS(3887),
    [anon_sym_do_BANG] = ACTIONS(3887),
    [anon_sym_begin] = ACTIONS(3889),
    [anon_sym_LPAREN2] = ACTIONS(3889),
    [anon_sym_or] = ACTIONS(3889),
    [aux_sym_char_token1] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3889),
    [anon_sym_DQUOTE] = ACTIONS(3889),
    [anon_sym_AT_DQUOTE] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [sym_bool] = ACTIONS(3889),
    [sym_unit] = ACTIONS(3887),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3889),
    [sym_op_identifier] = ACTIONS(3889),
    [anon_sym_PLUS] = ACTIONS(3889),
    [anon_sym_DASH] = ACTIONS(3889),
    [anon_sym_PLUS_DOT] = ACTIONS(3889),
    [anon_sym_DASH_DOT] = ACTIONS(3889),
    [anon_sym_PERCENT] = ACTIONS(3889),
    [anon_sym_AMP_AMP] = ACTIONS(3889),
    [anon_sym_TILDE] = ACTIONS(3887),
    [aux_sym_prefix_op_token1] = ACTIONS(3889),
    [aux_sym_infix_op_token1] = ACTIONS(3887),
    [aux_sym_infix_op_token2] = ACTIONS(3889),
    [anon_sym_PIPE_PIPE] = ACTIONS(3889),
    [anon_sym_BANG_EQ] = ACTIONS(3889),
    [anon_sym_COLON_EQ] = ACTIONS(3887),
    [anon_sym_DOLLAR] = ACTIONS(3889),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3889),
    [sym_int] = ACTIONS(3889),
    [sym_xint] = ACTIONS(3887),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3887),
    [sym__newline] = ACTIONS(3887),
  },
  [3371] = {
    [sym_block_comment] = STATE(3371),
    [sym_compiler_directive_decl] = STATE(3371),
    [sym_fsi_directive_decl] = STATE(3371),
    [sym_preproc_line] = STATE(3371),
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_EQ] = ACTIONS(3990),
    [anon_sym_COLON] = ACTIONS(3992),
    [anon_sym_return] = ACTIONS(3992),
    [anon_sym_do] = ACTIONS(3992),
    [anon_sym_let] = ACTIONS(3992),
    [anon_sym_let_BANG] = ACTIONS(3990),
    [anon_sym_LPAREN] = ACTIONS(3992),
    [anon_sym_COMMA] = ACTIONS(3990),
    [anon_sym_null] = ACTIONS(3992),
    [anon_sym_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [anon_sym_AMP] = ACTIONS(3992),
    [anon_sym_LBRACK] = ACTIONS(3992),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3990),
    [anon_sym_LBRACE] = ACTIONS(3992),
    [anon_sym_LT_AT] = ACTIONS(3992),
    [anon_sym_AT_GT] = ACTIONS(3992),
    [anon_sym_LT_AT_AT] = ACTIONS(3992),
    [anon_sym_DOT] = ACTIONS(3992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3990),
    [anon_sym_new] = ACTIONS(3992),
    [anon_sym_return_BANG] = ACTIONS(3990),
    [anon_sym_yield] = ACTIONS(3992),
    [anon_sym_yield_BANG] = ACTIONS(3990),
    [anon_sym_lazy] = ACTIONS(3992),
    [anon_sym_assert] = ACTIONS(3992),
    [anon_sym_upcast] = ACTIONS(3992),
    [anon_sym_downcast] = ACTIONS(3992),
    [anon_sym_COLON_GT] = ACTIONS(3990),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3990),
    [anon_sym_for] = ACTIONS(3992),
    [anon_sym_while] = ACTIONS(3992),
    [anon_sym_if] = ACTIONS(3992),
    [anon_sym_fun] = ACTIONS(3992),
    [anon_sym_try] = ACTIONS(3992),
    [anon_sym_match] = ACTIONS(3992),
    [anon_sym_match_BANG] = ACTIONS(3990),
    [anon_sym_function] = ACTIONS(3992),
    [anon_sym_LT_DASH] = ACTIONS(3992),
    [anon_sym_DOT_LBRACK] = ACTIONS(3990),
    [anon_sym_LT] = ACTIONS(3990),
    [anon_sym_use] = ACTIONS(3992),
    [anon_sym_use_BANG] = ACTIONS(3990),
    [anon_sym_do_BANG] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_LPAREN2] = ACTIONS(3992),
    [anon_sym_or] = ACTIONS(3992),
    [aux_sym_char_token1] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3992),
    [anon_sym_DQUOTE] = ACTIONS(3992),
    [anon_sym_AT_DQUOTE] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [sym_bool] = ACTIONS(3992),
    [sym_unit] = ACTIONS(3990),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3992),
    [sym_op_identifier] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3992),
    [anon_sym_DASH] = ACTIONS(3992),
    [anon_sym_PLUS_DOT] = ACTIONS(3992),
    [anon_sym_DASH_DOT] = ACTIONS(3992),
    [anon_sym_PERCENT] = ACTIONS(3992),
    [anon_sym_AMP_AMP] = ACTIONS(3992),
    [anon_sym_TILDE] = ACTIONS(3990),
    [aux_sym_prefix_op_token1] = ACTIONS(3992),
    [aux_sym_infix_op_token1] = ACTIONS(3990),
    [aux_sym_infix_op_token2] = ACTIONS(3992),
    [anon_sym_PIPE_PIPE] = ACTIONS(3992),
    [anon_sym_BANG_EQ] = ACTIONS(3992),
    [anon_sym_COLON_EQ] = ACTIONS(3990),
    [anon_sym_DOLLAR] = ACTIONS(3992),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3992),
    [sym_int] = ACTIONS(3992),
    [sym_xint] = ACTIONS(3990),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3990),
    [sym__newline] = ACTIONS(3990),
  },
  [3372] = {
    [sym_block_comment] = STATE(3372),
    [sym_compiler_directive_decl] = STATE(3372),
    [sym_fsi_directive_decl] = STATE(3372),
    [sym_preproc_line] = STATE(3372),
    [sym_identifier] = ACTIONS(4186),
    [anon_sym_EQ] = ACTIONS(4184),
    [anon_sym_COLON] = ACTIONS(4186),
    [anon_sym_return] = ACTIONS(4186),
    [anon_sym_do] = ACTIONS(4186),
    [anon_sym_let] = ACTIONS(4186),
    [anon_sym_let_BANG] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_COMMA] = ACTIONS(4184),
    [anon_sym_null] = ACTIONS(4186),
    [anon_sym_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_COLON] = ACTIONS(4184),
    [anon_sym_AMP] = ACTIONS(4186),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4184),
    [anon_sym_LBRACE] = ACTIONS(4186),
    [anon_sym_LT_AT] = ACTIONS(4186),
    [anon_sym_LT_AT_AT] = ACTIONS(4186),
    [anon_sym_AT_AT_GT] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4186),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4184),
    [anon_sym_new] = ACTIONS(4186),
    [anon_sym_return_BANG] = ACTIONS(4184),
    [anon_sym_yield] = ACTIONS(4186),
    [anon_sym_yield_BANG] = ACTIONS(4184),
    [anon_sym_lazy] = ACTIONS(4186),
    [anon_sym_assert] = ACTIONS(4186),
    [anon_sym_upcast] = ACTIONS(4186),
    [anon_sym_downcast] = ACTIONS(4186),
    [anon_sym_COLON_GT] = ACTIONS(4184),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4184),
    [anon_sym_for] = ACTIONS(4186),
    [anon_sym_while] = ACTIONS(4186),
    [anon_sym_if] = ACTIONS(4186),
    [anon_sym_fun] = ACTIONS(4186),
    [anon_sym_try] = ACTIONS(4186),
    [anon_sym_match] = ACTIONS(4186),
    [anon_sym_match_BANG] = ACTIONS(4184),
    [anon_sym_function] = ACTIONS(4186),
    [anon_sym_LT_DASH] = ACTIONS(4186),
    [anon_sym_DOT_LBRACK] = ACTIONS(4184),
    [anon_sym_LT] = ACTIONS(4184),
    [anon_sym_use] = ACTIONS(4186),
    [anon_sym_use_BANG] = ACTIONS(4184),
    [anon_sym_do_BANG] = ACTIONS(4184),
    [anon_sym_begin] = ACTIONS(4186),
    [anon_sym_LPAREN2] = ACTIONS(4186),
    [anon_sym_or] = ACTIONS(4186),
    [aux_sym_char_token1] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4186),
    [anon_sym_DQUOTE] = ACTIONS(4186),
    [anon_sym_AT_DQUOTE] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [sym_bool] = ACTIONS(4186),
    [sym_unit] = ACTIONS(4184),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4186),
    [sym_op_identifier] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4186),
    [anon_sym_DASH] = ACTIONS(4186),
    [anon_sym_PLUS_DOT] = ACTIONS(4186),
    [anon_sym_DASH_DOT] = ACTIONS(4186),
    [anon_sym_PERCENT] = ACTIONS(4186),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_TILDE] = ACTIONS(4184),
    [aux_sym_prefix_op_token1] = ACTIONS(4186),
    [aux_sym_infix_op_token1] = ACTIONS(4184),
    [aux_sym_infix_op_token2] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_COLON_EQ] = ACTIONS(4184),
    [anon_sym_DOLLAR] = ACTIONS(4186),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4186),
    [sym_int] = ACTIONS(4186),
    [sym_xint] = ACTIONS(4184),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4184),
    [sym__newline] = ACTIONS(4184),
  },
  [3373] = {
    [sym_block_comment] = STATE(3373),
    [sym_compiler_directive_decl] = STATE(3373),
    [sym_fsi_directive_decl] = STATE(3373),
    [sym_preproc_line] = STATE(3373),
    [sym_identifier] = ACTIONS(4180),
    [anon_sym_EQ] = ACTIONS(4178),
    [anon_sym_COLON] = ACTIONS(4180),
    [anon_sym_return] = ACTIONS(4180),
    [anon_sym_do] = ACTIONS(4180),
    [anon_sym_let] = ACTIONS(4180),
    [anon_sym_let_BANG] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(4180),
    [anon_sym_COMMA] = ACTIONS(4178),
    [anon_sym_null] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_COLON] = ACTIONS(4178),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4180),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4180),
    [anon_sym_LT_AT] = ACTIONS(4180),
    [anon_sym_LT_AT_AT] = ACTIONS(4180),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4178),
    [anon_sym_new] = ACTIONS(4180),
    [anon_sym_return_BANG] = ACTIONS(4178),
    [anon_sym_yield] = ACTIONS(4180),
    [anon_sym_yield_BANG] = ACTIONS(4178),
    [anon_sym_lazy] = ACTIONS(4180),
    [anon_sym_assert] = ACTIONS(4180),
    [anon_sym_upcast] = ACTIONS(4180),
    [anon_sym_downcast] = ACTIONS(4180),
    [anon_sym_COLON_GT] = ACTIONS(4178),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4178),
    [anon_sym_for] = ACTIONS(4180),
    [anon_sym_while] = ACTIONS(4180),
    [anon_sym_if] = ACTIONS(4180),
    [anon_sym_fun] = ACTIONS(4180),
    [anon_sym_try] = ACTIONS(4180),
    [anon_sym_match] = ACTIONS(4180),
    [anon_sym_match_BANG] = ACTIONS(4178),
    [anon_sym_function] = ACTIONS(4180),
    [anon_sym_LT_DASH] = ACTIONS(4180),
    [anon_sym_DOT_LBRACK] = ACTIONS(4178),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_GT] = ACTIONS(4180),
    [anon_sym_use] = ACTIONS(4180),
    [anon_sym_use_BANG] = ACTIONS(4178),
    [anon_sym_do_BANG] = ACTIONS(4178),
    [anon_sym_begin] = ACTIONS(4180),
    [anon_sym_LPAREN2] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [aux_sym_char_token1] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4180),
    [anon_sym_DQUOTE] = ACTIONS(4180),
    [anon_sym_AT_DQUOTE] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [sym_bool] = ACTIONS(4180),
    [sym_unit] = ACTIONS(4178),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4180),
    [sym_op_identifier] = ACTIONS(4180),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_PLUS_DOT] = ACTIONS(4180),
    [anon_sym_DASH_DOT] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_TILDE] = ACTIONS(4178),
    [aux_sym_prefix_op_token1] = ACTIONS(4180),
    [aux_sym_infix_op_token1] = ACTIONS(4178),
    [aux_sym_infix_op_token2] = ACTIONS(4180),
    [anon_sym_PIPE_PIPE] = ACTIONS(4180),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_COLON_EQ] = ACTIONS(4178),
    [anon_sym_DOLLAR] = ACTIONS(4180),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4180),
    [sym_int] = ACTIONS(4180),
    [sym_xint] = ACTIONS(4178),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4178),
    [sym__newline] = ACTIONS(4178),
  },
  [3374] = {
    [sym_block_comment] = STATE(3374),
    [sym_compiler_directive_decl] = STATE(3374),
    [sym_fsi_directive_decl] = STATE(3374),
    [sym_preproc_line] = STATE(3374),
    [sym_identifier] = ACTIONS(4130),
    [anon_sym_EQ] = ACTIONS(4128),
    [anon_sym_COLON] = ACTIONS(4130),
    [anon_sym_return] = ACTIONS(4130),
    [anon_sym_do] = ACTIONS(4130),
    [anon_sym_let] = ACTIONS(4130),
    [anon_sym_let_BANG] = ACTIONS(4128),
    [anon_sym_LPAREN] = ACTIONS(4130),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_null] = ACTIONS(4130),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_COLON] = ACTIONS(4128),
    [anon_sym_AMP] = ACTIONS(4130),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4128),
    [anon_sym_LBRACE] = ACTIONS(4130),
    [anon_sym_LT_AT] = ACTIONS(4130),
    [anon_sym_LT_AT_AT] = ACTIONS(4130),
    [anon_sym_AT_AT_GT] = ACTIONS(4130),
    [anon_sym_DOT] = ACTIONS(4130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4128),
    [anon_sym_new] = ACTIONS(4130),
    [anon_sym_return_BANG] = ACTIONS(4128),
    [anon_sym_yield] = ACTIONS(4130),
    [anon_sym_yield_BANG] = ACTIONS(4128),
    [anon_sym_lazy] = ACTIONS(4130),
    [anon_sym_assert] = ACTIONS(4130),
    [anon_sym_upcast] = ACTIONS(4130),
    [anon_sym_downcast] = ACTIONS(4130),
    [anon_sym_COLON_GT] = ACTIONS(4128),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4128),
    [anon_sym_for] = ACTIONS(4130),
    [anon_sym_while] = ACTIONS(4130),
    [anon_sym_if] = ACTIONS(4130),
    [anon_sym_fun] = ACTIONS(4130),
    [anon_sym_try] = ACTIONS(4130),
    [anon_sym_match] = ACTIONS(4130),
    [anon_sym_match_BANG] = ACTIONS(4128),
    [anon_sym_function] = ACTIONS(4130),
    [anon_sym_LT_DASH] = ACTIONS(4130),
    [anon_sym_DOT_LBRACK] = ACTIONS(4128),
    [anon_sym_LT] = ACTIONS(4128),
    [anon_sym_use] = ACTIONS(4130),
    [anon_sym_use_BANG] = ACTIONS(4128),
    [anon_sym_do_BANG] = ACTIONS(4128),
    [anon_sym_begin] = ACTIONS(4130),
    [anon_sym_LPAREN2] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [aux_sym_char_token1] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4130),
    [anon_sym_DQUOTE] = ACTIONS(4130),
    [anon_sym_AT_DQUOTE] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [sym_bool] = ACTIONS(4130),
    [sym_unit] = ACTIONS(4128),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4130),
    [sym_op_identifier] = ACTIONS(4130),
    [anon_sym_PLUS] = ACTIONS(4130),
    [anon_sym_DASH] = ACTIONS(4130),
    [anon_sym_PLUS_DOT] = ACTIONS(4130),
    [anon_sym_DASH_DOT] = ACTIONS(4130),
    [anon_sym_PERCENT] = ACTIONS(4130),
    [anon_sym_AMP_AMP] = ACTIONS(4130),
    [anon_sym_TILDE] = ACTIONS(4128),
    [aux_sym_prefix_op_token1] = ACTIONS(4130),
    [aux_sym_infix_op_token1] = ACTIONS(4128),
    [aux_sym_infix_op_token2] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE] = ACTIONS(4130),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_COLON_EQ] = ACTIONS(4128),
    [anon_sym_DOLLAR] = ACTIONS(4130),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4130),
    [sym_int] = ACTIONS(4130),
    [sym_xint] = ACTIONS(4128),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4128),
    [sym__newline] = ACTIONS(4128),
  },
  [3375] = {
    [sym_block_comment] = STATE(3375),
    [sym_compiler_directive_decl] = STATE(3375),
    [sym_fsi_directive_decl] = STATE(3375),
    [sym_preproc_line] = STATE(3375),
    [sym_identifier] = ACTIONS(3885),
    [anon_sym_EQ] = ACTIONS(3883),
    [anon_sym_COLON] = ACTIONS(3885),
    [anon_sym_return] = ACTIONS(3885),
    [anon_sym_do] = ACTIONS(3885),
    [anon_sym_let] = ACTIONS(3885),
    [anon_sym_let_BANG] = ACTIONS(3883),
    [anon_sym_LPAREN] = ACTIONS(3885),
    [anon_sym_COMMA] = ACTIONS(3883),
    [anon_sym_null] = ACTIONS(3885),
    [anon_sym_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3883),
    [anon_sym_AMP] = ACTIONS(3885),
    [anon_sym_LBRACK] = ACTIONS(3885),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3883),
    [anon_sym_LBRACE] = ACTIONS(3885),
    [anon_sym_LT_AT] = ACTIONS(3885),
    [anon_sym_LT_AT_AT] = ACTIONS(3885),
    [anon_sym_AT_AT_GT] = ACTIONS(3885),
    [anon_sym_DOT] = ACTIONS(3885),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3883),
    [anon_sym_new] = ACTIONS(3885),
    [anon_sym_return_BANG] = ACTIONS(3883),
    [anon_sym_yield] = ACTIONS(3885),
    [anon_sym_yield_BANG] = ACTIONS(3883),
    [anon_sym_lazy] = ACTIONS(3885),
    [anon_sym_assert] = ACTIONS(3885),
    [anon_sym_upcast] = ACTIONS(3885),
    [anon_sym_downcast] = ACTIONS(3885),
    [anon_sym_COLON_GT] = ACTIONS(3883),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3883),
    [anon_sym_for] = ACTIONS(3885),
    [anon_sym_while] = ACTIONS(3885),
    [anon_sym_if] = ACTIONS(3885),
    [anon_sym_fun] = ACTIONS(3885),
    [anon_sym_try] = ACTIONS(3885),
    [anon_sym_match] = ACTIONS(3885),
    [anon_sym_match_BANG] = ACTIONS(3883),
    [anon_sym_function] = ACTIONS(3885),
    [anon_sym_LT_DASH] = ACTIONS(3885),
    [anon_sym_DOT_LBRACK] = ACTIONS(3883),
    [anon_sym_LT] = ACTIONS(3883),
    [anon_sym_use] = ACTIONS(3885),
    [anon_sym_use_BANG] = ACTIONS(3883),
    [anon_sym_do_BANG] = ACTIONS(3883),
    [anon_sym_begin] = ACTIONS(3885),
    [anon_sym_LPAREN2] = ACTIONS(3885),
    [anon_sym_or] = ACTIONS(3885),
    [aux_sym_char_token1] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3885),
    [anon_sym_DQUOTE] = ACTIONS(3885),
    [anon_sym_AT_DQUOTE] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [sym_bool] = ACTIONS(3885),
    [sym_unit] = ACTIONS(3883),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3885),
    [sym_op_identifier] = ACTIONS(3885),
    [anon_sym_PLUS] = ACTIONS(3885),
    [anon_sym_DASH] = ACTIONS(3885),
    [anon_sym_PLUS_DOT] = ACTIONS(3885),
    [anon_sym_DASH_DOT] = ACTIONS(3885),
    [anon_sym_PERCENT] = ACTIONS(3885),
    [anon_sym_AMP_AMP] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3883),
    [aux_sym_prefix_op_token1] = ACTIONS(3885),
    [aux_sym_infix_op_token1] = ACTIONS(3883),
    [aux_sym_infix_op_token2] = ACTIONS(3885),
    [anon_sym_PIPE_PIPE] = ACTIONS(3885),
    [anon_sym_BANG_EQ] = ACTIONS(3885),
    [anon_sym_COLON_EQ] = ACTIONS(3883),
    [anon_sym_DOLLAR] = ACTIONS(3885),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3885),
    [sym_int] = ACTIONS(3885),
    [sym_xint] = ACTIONS(3883),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3883),
    [sym__newline] = ACTIONS(3883),
  },
  [3376] = {
    [sym_block_comment] = STATE(3376),
    [sym_compiler_directive_decl] = STATE(3376),
    [sym_fsi_directive_decl] = STATE(3376),
    [sym_preproc_line] = STATE(3376),
    [sym_identifier] = ACTIONS(3988),
    [anon_sym_EQ] = ACTIONS(3986),
    [anon_sym_COLON] = ACTIONS(3988),
    [anon_sym_return] = ACTIONS(3988),
    [anon_sym_do] = ACTIONS(3988),
    [anon_sym_let] = ACTIONS(3988),
    [anon_sym_let_BANG] = ACTIONS(3986),
    [anon_sym_LPAREN] = ACTIONS(3988),
    [anon_sym_COMMA] = ACTIONS(3986),
    [anon_sym_null] = ACTIONS(3988),
    [anon_sym_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_COLON] = ACTIONS(3986),
    [anon_sym_AMP] = ACTIONS(3988),
    [anon_sym_LBRACK] = ACTIONS(3988),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3986),
    [anon_sym_LBRACE] = ACTIONS(3988),
    [anon_sym_LT_AT] = ACTIONS(3988),
    [anon_sym_AT_GT] = ACTIONS(3988),
    [anon_sym_LT_AT_AT] = ACTIONS(3988),
    [anon_sym_DOT] = ACTIONS(3988),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3986),
    [anon_sym_new] = ACTIONS(3988),
    [anon_sym_return_BANG] = ACTIONS(3986),
    [anon_sym_yield] = ACTIONS(3988),
    [anon_sym_yield_BANG] = ACTIONS(3986),
    [anon_sym_lazy] = ACTIONS(3988),
    [anon_sym_assert] = ACTIONS(3988),
    [anon_sym_upcast] = ACTIONS(3988),
    [anon_sym_downcast] = ACTIONS(3988),
    [anon_sym_COLON_GT] = ACTIONS(3986),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_while] = ACTIONS(3988),
    [anon_sym_if] = ACTIONS(3988),
    [anon_sym_fun] = ACTIONS(3988),
    [anon_sym_try] = ACTIONS(3988),
    [anon_sym_match] = ACTIONS(3988),
    [anon_sym_match_BANG] = ACTIONS(3986),
    [anon_sym_function] = ACTIONS(3988),
    [anon_sym_LT_DASH] = ACTIONS(3988),
    [anon_sym_DOT_LBRACK] = ACTIONS(3986),
    [anon_sym_LT] = ACTIONS(3986),
    [anon_sym_use] = ACTIONS(3988),
    [anon_sym_use_BANG] = ACTIONS(3986),
    [anon_sym_do_BANG] = ACTIONS(3986),
    [anon_sym_begin] = ACTIONS(3988),
    [anon_sym_LPAREN2] = ACTIONS(3988),
    [anon_sym_or] = ACTIONS(3988),
    [aux_sym_char_token1] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3988),
    [anon_sym_DQUOTE] = ACTIONS(3988),
    [anon_sym_AT_DQUOTE] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [sym_bool] = ACTIONS(3988),
    [sym_unit] = ACTIONS(3986),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3988),
    [sym_op_identifier] = ACTIONS(3988),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_PLUS_DOT] = ACTIONS(3988),
    [anon_sym_DASH_DOT] = ACTIONS(3988),
    [anon_sym_PERCENT] = ACTIONS(3988),
    [anon_sym_AMP_AMP] = ACTIONS(3988),
    [anon_sym_TILDE] = ACTIONS(3986),
    [aux_sym_prefix_op_token1] = ACTIONS(3988),
    [aux_sym_infix_op_token1] = ACTIONS(3986),
    [aux_sym_infix_op_token2] = ACTIONS(3988),
    [anon_sym_PIPE_PIPE] = ACTIONS(3988),
    [anon_sym_BANG_EQ] = ACTIONS(3988),
    [anon_sym_COLON_EQ] = ACTIONS(3986),
    [anon_sym_DOLLAR] = ACTIONS(3988),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3988),
    [sym_int] = ACTIONS(3988),
    [sym_xint] = ACTIONS(3986),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3986),
    [sym__newline] = ACTIONS(3986),
  },
  [3377] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(7518),
    [sym_function_declaration_left] = STATE(9423),
    [sym_value_declaration_left] = STATE(9423),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3377),
    [sym_compiler_directive_decl] = STATE(3377),
    [sym_fsi_directive_decl] = STATE(3377),
    [sym_preproc_line] = STATE(3377),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_rec] = ACTIONS(5905),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3378] = {
    [sym_block_comment] = STATE(3378),
    [sym_compiler_directive_decl] = STATE(3378),
    [sym_fsi_directive_decl] = STATE(3378),
    [sym_preproc_line] = STATE(3378),
    [sym_identifier] = ACTIONS(4174),
    [anon_sym_EQ] = ACTIONS(4172),
    [anon_sym_COLON] = ACTIONS(4174),
    [anon_sym_return] = ACTIONS(4174),
    [anon_sym_do] = ACTIONS(4174),
    [anon_sym_let] = ACTIONS(4174),
    [anon_sym_let_BANG] = ACTIONS(4172),
    [anon_sym_LPAREN] = ACTIONS(4174),
    [anon_sym_COMMA] = ACTIONS(4172),
    [anon_sym_null] = ACTIONS(4174),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_COLON] = ACTIONS(4172),
    [anon_sym_AMP] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4174),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4172),
    [anon_sym_LBRACE] = ACTIONS(4174),
    [anon_sym_LT_AT] = ACTIONS(4174),
    [anon_sym_LT_AT_AT] = ACTIONS(4174),
    [anon_sym_DOT] = ACTIONS(4174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4172),
    [anon_sym_new] = ACTIONS(4174),
    [anon_sym_return_BANG] = ACTIONS(4172),
    [anon_sym_yield] = ACTIONS(4174),
    [anon_sym_yield_BANG] = ACTIONS(4172),
    [anon_sym_lazy] = ACTIONS(4174),
    [anon_sym_assert] = ACTIONS(4174),
    [anon_sym_upcast] = ACTIONS(4174),
    [anon_sym_downcast] = ACTIONS(4174),
    [anon_sym_COLON_GT] = ACTIONS(4172),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4172),
    [anon_sym_for] = ACTIONS(4174),
    [anon_sym_while] = ACTIONS(4174),
    [anon_sym_if] = ACTIONS(4174),
    [anon_sym_fun] = ACTIONS(4174),
    [anon_sym_try] = ACTIONS(4174),
    [anon_sym_match] = ACTIONS(4174),
    [anon_sym_match_BANG] = ACTIONS(4172),
    [anon_sym_function] = ACTIONS(4174),
    [anon_sym_LT_DASH] = ACTIONS(4174),
    [anon_sym_DOT_LBRACK] = ACTIONS(4172),
    [anon_sym_LT] = ACTIONS(4172),
    [anon_sym_GT] = ACTIONS(4174),
    [anon_sym_use] = ACTIONS(4174),
    [anon_sym_use_BANG] = ACTIONS(4172),
    [anon_sym_do_BANG] = ACTIONS(4172),
    [anon_sym_begin] = ACTIONS(4174),
    [anon_sym_LPAREN2] = ACTIONS(4174),
    [anon_sym_or] = ACTIONS(4174),
    [aux_sym_char_token1] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4174),
    [anon_sym_DQUOTE] = ACTIONS(4174),
    [anon_sym_AT_DQUOTE] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [sym_bool] = ACTIONS(4174),
    [sym_unit] = ACTIONS(4172),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4174),
    [sym_op_identifier] = ACTIONS(4174),
    [anon_sym_PLUS] = ACTIONS(4174),
    [anon_sym_DASH] = ACTIONS(4174),
    [anon_sym_PLUS_DOT] = ACTIONS(4174),
    [anon_sym_DASH_DOT] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [anon_sym_AMP_AMP] = ACTIONS(4174),
    [anon_sym_TILDE] = ACTIONS(4172),
    [aux_sym_prefix_op_token1] = ACTIONS(4174),
    [aux_sym_infix_op_token1] = ACTIONS(4172),
    [aux_sym_infix_op_token2] = ACTIONS(4174),
    [anon_sym_PIPE_PIPE] = ACTIONS(4174),
    [anon_sym_BANG_EQ] = ACTIONS(4174),
    [anon_sym_COLON_EQ] = ACTIONS(4172),
    [anon_sym_DOLLAR] = ACTIONS(4174),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4174),
    [sym_int] = ACTIONS(4174),
    [sym_xint] = ACTIONS(4172),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4172),
    [sym__newline] = ACTIONS(4172),
  },
  [3379] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defns] = STATE(7550),
    [sym__function_or_value_defn_body] = STATE(7241),
    [sym_function_declaration_left] = STATE(10151),
    [sym_value_declaration_left] = STATE(10151),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3379),
    [sym_compiler_directive_decl] = STATE(3379),
    [sym_fsi_directive_decl] = STATE(3379),
    [sym_preproc_line] = STATE(3379),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3380] = {
    [sym_block_comment] = STATE(3380),
    [sym_compiler_directive_decl] = STATE(3380),
    [sym_fsi_directive_decl] = STATE(3380),
    [sym_preproc_line] = STATE(3380),
    [sym_identifier] = ACTIONS(3984),
    [anon_sym_EQ] = ACTIONS(3982),
    [anon_sym_COLON] = ACTIONS(3984),
    [anon_sym_return] = ACTIONS(3984),
    [anon_sym_do] = ACTIONS(3984),
    [anon_sym_let] = ACTIONS(3984),
    [anon_sym_let_BANG] = ACTIONS(3982),
    [anon_sym_LPAREN] = ACTIONS(3984),
    [anon_sym_COMMA] = ACTIONS(3982),
    [anon_sym_null] = ACTIONS(3984),
    [anon_sym_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AMP] = ACTIONS(3984),
    [anon_sym_LBRACK] = ACTIONS(3984),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(3984),
    [anon_sym_LT_AT] = ACTIONS(3984),
    [anon_sym_AT_GT] = ACTIONS(3984),
    [anon_sym_LT_AT_AT] = ACTIONS(3984),
    [anon_sym_DOT] = ACTIONS(3984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3982),
    [anon_sym_new] = ACTIONS(3984),
    [anon_sym_return_BANG] = ACTIONS(3982),
    [anon_sym_yield] = ACTIONS(3984),
    [anon_sym_yield_BANG] = ACTIONS(3982),
    [anon_sym_lazy] = ACTIONS(3984),
    [anon_sym_assert] = ACTIONS(3984),
    [anon_sym_upcast] = ACTIONS(3984),
    [anon_sym_downcast] = ACTIONS(3984),
    [anon_sym_COLON_GT] = ACTIONS(3982),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3982),
    [anon_sym_for] = ACTIONS(3984),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_if] = ACTIONS(3984),
    [anon_sym_fun] = ACTIONS(3984),
    [anon_sym_try] = ACTIONS(3984),
    [anon_sym_match] = ACTIONS(3984),
    [anon_sym_match_BANG] = ACTIONS(3982),
    [anon_sym_function] = ACTIONS(3984),
    [anon_sym_LT_DASH] = ACTIONS(3984),
    [anon_sym_DOT_LBRACK] = ACTIONS(3982),
    [anon_sym_LT] = ACTIONS(3982),
    [anon_sym_use] = ACTIONS(3984),
    [anon_sym_use_BANG] = ACTIONS(3982),
    [anon_sym_do_BANG] = ACTIONS(3982),
    [anon_sym_begin] = ACTIONS(3984),
    [anon_sym_LPAREN2] = ACTIONS(3984),
    [anon_sym_or] = ACTIONS(3984),
    [aux_sym_char_token1] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3984),
    [anon_sym_DQUOTE] = ACTIONS(3984),
    [anon_sym_AT_DQUOTE] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [sym_bool] = ACTIONS(3984),
    [sym_unit] = ACTIONS(3982),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3984),
    [sym_op_identifier] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3984),
    [anon_sym_DASH] = ACTIONS(3984),
    [anon_sym_PLUS_DOT] = ACTIONS(3984),
    [anon_sym_DASH_DOT] = ACTIONS(3984),
    [anon_sym_PERCENT] = ACTIONS(3984),
    [anon_sym_AMP_AMP] = ACTIONS(3984),
    [anon_sym_TILDE] = ACTIONS(3982),
    [aux_sym_prefix_op_token1] = ACTIONS(3984),
    [aux_sym_infix_op_token1] = ACTIONS(3982),
    [aux_sym_infix_op_token2] = ACTIONS(3984),
    [anon_sym_PIPE_PIPE] = ACTIONS(3984),
    [anon_sym_BANG_EQ] = ACTIONS(3984),
    [anon_sym_COLON_EQ] = ACTIONS(3982),
    [anon_sym_DOLLAR] = ACTIONS(3984),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3984),
    [sym_int] = ACTIONS(3984),
    [sym_xint] = ACTIONS(3982),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3982),
    [sym__newline] = ACTIONS(3982),
  },
  [3381] = {
    [sym_block_comment] = STATE(3381),
    [sym_compiler_directive_decl] = STATE(3381),
    [sym_fsi_directive_decl] = STATE(3381),
    [sym_preproc_line] = STATE(3381),
    [sym_identifier] = ACTIONS(3980),
    [anon_sym_EQ] = ACTIONS(3978),
    [anon_sym_COLON] = ACTIONS(3980),
    [anon_sym_return] = ACTIONS(3980),
    [anon_sym_do] = ACTIONS(3980),
    [anon_sym_let] = ACTIONS(3980),
    [anon_sym_let_BANG] = ACTIONS(3978),
    [anon_sym_LPAREN] = ACTIONS(3980),
    [anon_sym_COMMA] = ACTIONS(3978),
    [anon_sym_null] = ACTIONS(3980),
    [anon_sym_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3978),
    [anon_sym_AMP] = ACTIONS(3980),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3978),
    [anon_sym_LBRACE] = ACTIONS(3980),
    [anon_sym_LT_AT] = ACTIONS(3980),
    [anon_sym_AT_GT] = ACTIONS(3980),
    [anon_sym_LT_AT_AT] = ACTIONS(3980),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3978),
    [anon_sym_new] = ACTIONS(3980),
    [anon_sym_return_BANG] = ACTIONS(3978),
    [anon_sym_yield] = ACTIONS(3980),
    [anon_sym_yield_BANG] = ACTIONS(3978),
    [anon_sym_lazy] = ACTIONS(3980),
    [anon_sym_assert] = ACTIONS(3980),
    [anon_sym_upcast] = ACTIONS(3980),
    [anon_sym_downcast] = ACTIONS(3980),
    [anon_sym_COLON_GT] = ACTIONS(3978),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3978),
    [anon_sym_for] = ACTIONS(3980),
    [anon_sym_while] = ACTIONS(3980),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_fun] = ACTIONS(3980),
    [anon_sym_try] = ACTIONS(3980),
    [anon_sym_match] = ACTIONS(3980),
    [anon_sym_match_BANG] = ACTIONS(3978),
    [anon_sym_function] = ACTIONS(3980),
    [anon_sym_LT_DASH] = ACTIONS(3980),
    [anon_sym_DOT_LBRACK] = ACTIONS(3978),
    [anon_sym_LT] = ACTIONS(3978),
    [anon_sym_use] = ACTIONS(3980),
    [anon_sym_use_BANG] = ACTIONS(3978),
    [anon_sym_do_BANG] = ACTIONS(3978),
    [anon_sym_begin] = ACTIONS(3980),
    [anon_sym_LPAREN2] = ACTIONS(3980),
    [anon_sym_or] = ACTIONS(3980),
    [aux_sym_char_token1] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3980),
    [anon_sym_DQUOTE] = ACTIONS(3980),
    [anon_sym_AT_DQUOTE] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [sym_bool] = ACTIONS(3980),
    [sym_unit] = ACTIONS(3978),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3980),
    [sym_op_identifier] = ACTIONS(3980),
    [anon_sym_PLUS] = ACTIONS(3980),
    [anon_sym_DASH] = ACTIONS(3980),
    [anon_sym_PLUS_DOT] = ACTIONS(3980),
    [anon_sym_DASH_DOT] = ACTIONS(3980),
    [anon_sym_PERCENT] = ACTIONS(3980),
    [anon_sym_AMP_AMP] = ACTIONS(3980),
    [anon_sym_TILDE] = ACTIONS(3978),
    [aux_sym_prefix_op_token1] = ACTIONS(3980),
    [aux_sym_infix_op_token1] = ACTIONS(3978),
    [aux_sym_infix_op_token2] = ACTIONS(3980),
    [anon_sym_PIPE_PIPE] = ACTIONS(3980),
    [anon_sym_BANG_EQ] = ACTIONS(3980),
    [anon_sym_COLON_EQ] = ACTIONS(3978),
    [anon_sym_DOLLAR] = ACTIONS(3980),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3980),
    [sym_int] = ACTIONS(3980),
    [sym_xint] = ACTIONS(3978),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3978),
    [sym__newline] = ACTIONS(3978),
  },
  [3382] = {
    [sym_block_comment] = STATE(3382),
    [sym_compiler_directive_decl] = STATE(3382),
    [sym_fsi_directive_decl] = STATE(3382),
    [sym_preproc_line] = STATE(3382),
    [sym_identifier] = ACTIONS(4182),
    [anon_sym_EQ] = ACTIONS(3689),
    [anon_sym_COLON] = ACTIONS(4182),
    [anon_sym_return] = ACTIONS(4182),
    [anon_sym_do] = ACTIONS(4182),
    [anon_sym_let] = ACTIONS(4182),
    [anon_sym_let_BANG] = ACTIONS(3689),
    [anon_sym_LPAREN] = ACTIONS(4182),
    [anon_sym_COMMA] = ACTIONS(3689),
    [anon_sym_null] = ACTIONS(4182),
    [anon_sym_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3689),
    [anon_sym_LBRACE] = ACTIONS(4182),
    [anon_sym_LT_AT] = ACTIONS(4182),
    [anon_sym_AT_GT] = ACTIONS(4182),
    [anon_sym_LT_AT_AT] = ACTIONS(4182),
    [anon_sym_DOT] = ACTIONS(4182),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3689),
    [anon_sym_new] = ACTIONS(4182),
    [anon_sym_return_BANG] = ACTIONS(3689),
    [anon_sym_yield] = ACTIONS(4182),
    [anon_sym_yield_BANG] = ACTIONS(3689),
    [anon_sym_lazy] = ACTIONS(4182),
    [anon_sym_assert] = ACTIONS(4182),
    [anon_sym_upcast] = ACTIONS(4182),
    [anon_sym_downcast] = ACTIONS(4182),
    [anon_sym_COLON_GT] = ACTIONS(3689),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3689),
    [anon_sym_for] = ACTIONS(4182),
    [anon_sym_while] = ACTIONS(4182),
    [anon_sym_if] = ACTIONS(4182),
    [anon_sym_fun] = ACTIONS(4182),
    [anon_sym_try] = ACTIONS(4182),
    [anon_sym_match] = ACTIONS(4182),
    [anon_sym_match_BANG] = ACTIONS(3689),
    [anon_sym_function] = ACTIONS(4182),
    [anon_sym_LT_DASH] = ACTIONS(4182),
    [anon_sym_DOT_LBRACK] = ACTIONS(3689),
    [anon_sym_LT] = ACTIONS(3689),
    [anon_sym_use] = ACTIONS(4182),
    [anon_sym_use_BANG] = ACTIONS(3689),
    [anon_sym_do_BANG] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(4182),
    [anon_sym_LPAREN2] = ACTIONS(4182),
    [anon_sym_or] = ACTIONS(4182),
    [aux_sym_char_token1] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4182),
    [anon_sym_DQUOTE] = ACTIONS(4182),
    [anon_sym_AT_DQUOTE] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [sym_bool] = ACTIONS(4182),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4182),
    [sym_op_identifier] = ACTIONS(4182),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_PLUS_DOT] = ACTIONS(4182),
    [anon_sym_DASH_DOT] = ACTIONS(4182),
    [anon_sym_PERCENT] = ACTIONS(4182),
    [anon_sym_AMP_AMP] = ACTIONS(4182),
    [anon_sym_TILDE] = ACTIONS(3689),
    [aux_sym_prefix_op_token1] = ACTIONS(4182),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token2] = ACTIONS(4182),
    [anon_sym_PIPE_PIPE] = ACTIONS(4182),
    [anon_sym_BANG_EQ] = ACTIONS(4182),
    [anon_sym_COLON_EQ] = ACTIONS(3689),
    [anon_sym_DOLLAR] = ACTIONS(4182),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4182),
    [sym_int] = ACTIONS(4182),
    [sym_xint] = ACTIONS(3689),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3689),
    [sym__newline] = ACTIONS(3689),
  },
  [3383] = {
    [sym_block_comment] = STATE(3383),
    [sym_compiler_directive_decl] = STATE(3383),
    [sym_fsi_directive_decl] = STATE(3383),
    [sym_preproc_line] = STATE(3383),
    [sym_identifier] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3919),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_return] = ACTIONS(3921),
    [anon_sym_do] = ACTIONS(3921),
    [anon_sym_let] = ACTIONS(3921),
    [anon_sym_let_BANG] = ACTIONS(3919),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3919),
    [anon_sym_null] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_COLON] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3919),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_LT_AT] = ACTIONS(3921),
    [anon_sym_LT_AT_AT] = ACTIONS(3921),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3919),
    [anon_sym_new] = ACTIONS(3921),
    [anon_sym_return_BANG] = ACTIONS(3919),
    [anon_sym_yield] = ACTIONS(3921),
    [anon_sym_yield_BANG] = ACTIONS(3919),
    [anon_sym_lazy] = ACTIONS(3921),
    [anon_sym_assert] = ACTIONS(3921),
    [anon_sym_upcast] = ACTIONS(3921),
    [anon_sym_downcast] = ACTIONS(3921),
    [anon_sym_COLON_GT] = ACTIONS(3919),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3919),
    [anon_sym_for] = ACTIONS(3921),
    [anon_sym_while] = ACTIONS(3921),
    [anon_sym_if] = ACTIONS(3921),
    [anon_sym_fun] = ACTIONS(3921),
    [anon_sym_try] = ACTIONS(3921),
    [anon_sym_match] = ACTIONS(3921),
    [anon_sym_match_BANG] = ACTIONS(3919),
    [anon_sym_function] = ACTIONS(3921),
    [anon_sym_LT_DASH] = ACTIONS(3921),
    [anon_sym_DOT_LBRACK] = ACTIONS(3919),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_use] = ACTIONS(3921),
    [anon_sym_use_BANG] = ACTIONS(3919),
    [anon_sym_do_BANG] = ACTIONS(3919),
    [anon_sym_DOT_DOT] = ACTIONS(3919),
    [anon_sym_begin] = ACTIONS(3921),
    [anon_sym_LPAREN2] = ACTIONS(3921),
    [anon_sym_or] = ACTIONS(3921),
    [aux_sym_char_token1] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_AT_DQUOTE] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [sym_bool] = ACTIONS(3921),
    [sym_unit] = ACTIONS(3919),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3921),
    [sym_op_identifier] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_DOT] = ACTIONS(3921),
    [anon_sym_DASH_DOT] = ACTIONS(3921),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3919),
    [aux_sym_prefix_op_token1] = ACTIONS(3921),
    [aux_sym_infix_op_token1] = ACTIONS(3919),
    [aux_sym_infix_op_token2] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_COLON_EQ] = ACTIONS(3919),
    [anon_sym_DOLLAR] = ACTIONS(3921),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3921),
    [sym_int] = ACTIONS(3921),
    [sym_xint] = ACTIONS(3919),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3919),
    [sym__newline] = ACTIONS(3919),
  },
  [3384] = {
    [sym_block_comment] = STATE(3384),
    [sym_compiler_directive_decl] = STATE(3384),
    [sym_fsi_directive_decl] = STATE(3384),
    [sym_preproc_line] = STATE(3384),
    [sym_identifier] = ACTIONS(4162),
    [anon_sym_EQ] = ACTIONS(4160),
    [anon_sym_COLON] = ACTIONS(4162),
    [anon_sym_return] = ACTIONS(4162),
    [anon_sym_do] = ACTIONS(4162),
    [anon_sym_let] = ACTIONS(4162),
    [anon_sym_let_BANG] = ACTIONS(4160),
    [anon_sym_LPAREN] = ACTIONS(4162),
    [anon_sym_COMMA] = ACTIONS(4160),
    [anon_sym_null] = ACTIONS(4162),
    [anon_sym_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4160),
    [anon_sym_AMP] = ACTIONS(4162),
    [anon_sym_LBRACK] = ACTIONS(4162),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4160),
    [anon_sym_LBRACE] = ACTIONS(4162),
    [anon_sym_LT_AT] = ACTIONS(4162),
    [anon_sym_AT_GT] = ACTIONS(4162),
    [anon_sym_LT_AT_AT] = ACTIONS(4162),
    [anon_sym_DOT] = ACTIONS(4162),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4160),
    [anon_sym_new] = ACTIONS(4162),
    [anon_sym_return_BANG] = ACTIONS(4160),
    [anon_sym_yield] = ACTIONS(4162),
    [anon_sym_yield_BANG] = ACTIONS(4160),
    [anon_sym_lazy] = ACTIONS(4162),
    [anon_sym_assert] = ACTIONS(4162),
    [anon_sym_upcast] = ACTIONS(4162),
    [anon_sym_downcast] = ACTIONS(4162),
    [anon_sym_COLON_GT] = ACTIONS(4160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4160),
    [anon_sym_for] = ACTIONS(4162),
    [anon_sym_while] = ACTIONS(4162),
    [anon_sym_if] = ACTIONS(4162),
    [anon_sym_fun] = ACTIONS(4162),
    [anon_sym_try] = ACTIONS(4162),
    [anon_sym_match] = ACTIONS(4162),
    [anon_sym_match_BANG] = ACTIONS(4160),
    [anon_sym_function] = ACTIONS(4162),
    [anon_sym_LT_DASH] = ACTIONS(4162),
    [anon_sym_DOT_LBRACK] = ACTIONS(4160),
    [anon_sym_LT] = ACTIONS(4160),
    [anon_sym_use] = ACTIONS(4162),
    [anon_sym_use_BANG] = ACTIONS(4160),
    [anon_sym_do_BANG] = ACTIONS(4160),
    [anon_sym_begin] = ACTIONS(4162),
    [anon_sym_LPAREN2] = ACTIONS(4162),
    [anon_sym_or] = ACTIONS(4162),
    [aux_sym_char_token1] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4162),
    [anon_sym_DQUOTE] = ACTIONS(4162),
    [anon_sym_AT_DQUOTE] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [sym_bool] = ACTIONS(4162),
    [sym_unit] = ACTIONS(4160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4162),
    [sym_op_identifier] = ACTIONS(4162),
    [anon_sym_PLUS] = ACTIONS(4162),
    [anon_sym_DASH] = ACTIONS(4162),
    [anon_sym_PLUS_DOT] = ACTIONS(4162),
    [anon_sym_DASH_DOT] = ACTIONS(4162),
    [anon_sym_PERCENT] = ACTIONS(4162),
    [anon_sym_AMP_AMP] = ACTIONS(4162),
    [anon_sym_TILDE] = ACTIONS(4160),
    [aux_sym_prefix_op_token1] = ACTIONS(4162),
    [aux_sym_infix_op_token1] = ACTIONS(4160),
    [aux_sym_infix_op_token2] = ACTIONS(4162),
    [anon_sym_PIPE_PIPE] = ACTIONS(4162),
    [anon_sym_BANG_EQ] = ACTIONS(4162),
    [anon_sym_COLON_EQ] = ACTIONS(4160),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4162),
    [sym_int] = ACTIONS(4162),
    [sym_xint] = ACTIONS(4160),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4160),
    [sym__newline] = ACTIONS(4160),
  },
  [3385] = {
    [sym_block_comment] = STATE(3385),
    [sym_compiler_directive_decl] = STATE(3385),
    [sym_fsi_directive_decl] = STATE(3385),
    [sym_preproc_line] = STATE(3385),
    [sym_identifier] = ACTIONS(3935),
    [anon_sym_EQ] = ACTIONS(3933),
    [anon_sym_COLON] = ACTIONS(3935),
    [anon_sym_return] = ACTIONS(3935),
    [anon_sym_do] = ACTIONS(3935),
    [anon_sym_let] = ACTIONS(3935),
    [anon_sym_let_BANG] = ACTIONS(3933),
    [anon_sym_LPAREN] = ACTIONS(3935),
    [anon_sym_COMMA] = ACTIONS(3933),
    [anon_sym_null] = ACTIONS(3935),
    [anon_sym_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3935),
    [anon_sym_LBRACK] = ACTIONS(3935),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3933),
    [anon_sym_LBRACE] = ACTIONS(3935),
    [anon_sym_LT_AT] = ACTIONS(3935),
    [anon_sym_LT_AT_AT] = ACTIONS(3935),
    [anon_sym_AT_AT_GT] = ACTIONS(3935),
    [anon_sym_DOT] = ACTIONS(3935),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3933),
    [anon_sym_new] = ACTIONS(3935),
    [anon_sym_return_BANG] = ACTIONS(3933),
    [anon_sym_yield] = ACTIONS(3935),
    [anon_sym_yield_BANG] = ACTIONS(3933),
    [anon_sym_lazy] = ACTIONS(3935),
    [anon_sym_assert] = ACTIONS(3935),
    [anon_sym_upcast] = ACTIONS(3935),
    [anon_sym_downcast] = ACTIONS(3935),
    [anon_sym_COLON_GT] = ACTIONS(3933),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3933),
    [anon_sym_for] = ACTIONS(3935),
    [anon_sym_while] = ACTIONS(3935),
    [anon_sym_if] = ACTIONS(3935),
    [anon_sym_fun] = ACTIONS(3935),
    [anon_sym_try] = ACTIONS(3935),
    [anon_sym_match] = ACTIONS(3935),
    [anon_sym_match_BANG] = ACTIONS(3933),
    [anon_sym_function] = ACTIONS(3935),
    [anon_sym_LT_DASH] = ACTIONS(3935),
    [anon_sym_DOT_LBRACK] = ACTIONS(3933),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_use] = ACTIONS(3935),
    [anon_sym_use_BANG] = ACTIONS(3933),
    [anon_sym_do_BANG] = ACTIONS(3933),
    [anon_sym_begin] = ACTIONS(3935),
    [anon_sym_LPAREN2] = ACTIONS(3935),
    [anon_sym_or] = ACTIONS(3935),
    [aux_sym_char_token1] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3935),
    [anon_sym_DQUOTE] = ACTIONS(3935),
    [anon_sym_AT_DQUOTE] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [sym_bool] = ACTIONS(3935),
    [sym_unit] = ACTIONS(3933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3935),
    [sym_op_identifier] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(3935),
    [anon_sym_DASH] = ACTIONS(3935),
    [anon_sym_PLUS_DOT] = ACTIONS(3935),
    [anon_sym_DASH_DOT] = ACTIONS(3935),
    [anon_sym_PERCENT] = ACTIONS(3935),
    [anon_sym_AMP_AMP] = ACTIONS(3935),
    [anon_sym_TILDE] = ACTIONS(3933),
    [aux_sym_prefix_op_token1] = ACTIONS(3935),
    [aux_sym_infix_op_token1] = ACTIONS(3933),
    [aux_sym_infix_op_token2] = ACTIONS(3935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3935),
    [anon_sym_BANG_EQ] = ACTIONS(3935),
    [anon_sym_COLON_EQ] = ACTIONS(3933),
    [anon_sym_DOLLAR] = ACTIONS(3935),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3935),
    [sym_int] = ACTIONS(3935),
    [sym_xint] = ACTIONS(3933),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3933),
    [sym__newline] = ACTIONS(3933),
  },
  [3386] = {
    [sym_block_comment] = STATE(3386),
    [sym_compiler_directive_decl] = STATE(3386),
    [sym_fsi_directive_decl] = STATE(3386),
    [sym_preproc_line] = STATE(3386),
    [sym_identifier] = ACTIONS(4158),
    [anon_sym_EQ] = ACTIONS(4156),
    [anon_sym_COLON] = ACTIONS(4158),
    [anon_sym_return] = ACTIONS(4158),
    [anon_sym_do] = ACTIONS(4158),
    [anon_sym_let] = ACTIONS(4158),
    [anon_sym_let_BANG] = ACTIONS(4156),
    [anon_sym_LPAREN] = ACTIONS(4158),
    [anon_sym_COMMA] = ACTIONS(4156),
    [anon_sym_null] = ACTIONS(4158),
    [anon_sym_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_COLON] = ACTIONS(4156),
    [anon_sym_AMP] = ACTIONS(4158),
    [anon_sym_LBRACK] = ACTIONS(4158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(4158),
    [anon_sym_LT_AT] = ACTIONS(4158),
    [anon_sym_AT_GT] = ACTIONS(4158),
    [anon_sym_LT_AT_AT] = ACTIONS(4158),
    [anon_sym_DOT] = ACTIONS(4158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4156),
    [anon_sym_new] = ACTIONS(4158),
    [anon_sym_return_BANG] = ACTIONS(4156),
    [anon_sym_yield] = ACTIONS(4158),
    [anon_sym_yield_BANG] = ACTIONS(4156),
    [anon_sym_lazy] = ACTIONS(4158),
    [anon_sym_assert] = ACTIONS(4158),
    [anon_sym_upcast] = ACTIONS(4158),
    [anon_sym_downcast] = ACTIONS(4158),
    [anon_sym_COLON_GT] = ACTIONS(4156),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4156),
    [anon_sym_for] = ACTIONS(4158),
    [anon_sym_while] = ACTIONS(4158),
    [anon_sym_if] = ACTIONS(4158),
    [anon_sym_fun] = ACTIONS(4158),
    [anon_sym_try] = ACTIONS(4158),
    [anon_sym_match] = ACTIONS(4158),
    [anon_sym_match_BANG] = ACTIONS(4156),
    [anon_sym_function] = ACTIONS(4158),
    [anon_sym_LT_DASH] = ACTIONS(4158),
    [anon_sym_DOT_LBRACK] = ACTIONS(4156),
    [anon_sym_LT] = ACTIONS(4156),
    [anon_sym_use] = ACTIONS(4158),
    [anon_sym_use_BANG] = ACTIONS(4156),
    [anon_sym_do_BANG] = ACTIONS(4156),
    [anon_sym_begin] = ACTIONS(4158),
    [anon_sym_LPAREN2] = ACTIONS(4158),
    [anon_sym_or] = ACTIONS(4158),
    [aux_sym_char_token1] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4158),
    [anon_sym_DQUOTE] = ACTIONS(4158),
    [anon_sym_AT_DQUOTE] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [sym_bool] = ACTIONS(4158),
    [sym_unit] = ACTIONS(4156),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4158),
    [sym_op_identifier] = ACTIONS(4158),
    [anon_sym_PLUS] = ACTIONS(4158),
    [anon_sym_DASH] = ACTIONS(4158),
    [anon_sym_PLUS_DOT] = ACTIONS(4158),
    [anon_sym_DASH_DOT] = ACTIONS(4158),
    [anon_sym_PERCENT] = ACTIONS(4158),
    [anon_sym_AMP_AMP] = ACTIONS(4158),
    [anon_sym_TILDE] = ACTIONS(4156),
    [aux_sym_prefix_op_token1] = ACTIONS(4158),
    [aux_sym_infix_op_token1] = ACTIONS(4156),
    [aux_sym_infix_op_token2] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE] = ACTIONS(4158),
    [anon_sym_BANG_EQ] = ACTIONS(4158),
    [anon_sym_COLON_EQ] = ACTIONS(4156),
    [anon_sym_DOLLAR] = ACTIONS(4158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4158),
    [sym_int] = ACTIONS(4158),
    [sym_xint] = ACTIONS(4156),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4156),
    [sym__newline] = ACTIONS(4156),
  },
  [3387] = {
    [sym_block_comment] = STATE(3387),
    [sym_compiler_directive_decl] = STATE(3387),
    [sym_fsi_directive_decl] = STATE(3387),
    [sym_preproc_line] = STATE(3387),
    [sym_identifier] = ACTIONS(3976),
    [anon_sym_EQ] = ACTIONS(3974),
    [anon_sym_COLON] = ACTIONS(3976),
    [anon_sym_return] = ACTIONS(3976),
    [anon_sym_do] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_let_BANG] = ACTIONS(3974),
    [anon_sym_LPAREN] = ACTIONS(3976),
    [anon_sym_COMMA] = ACTIONS(3974),
    [anon_sym_null] = ACTIONS(3976),
    [anon_sym_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_COLON] = ACTIONS(3974),
    [anon_sym_AMP] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(3976),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3974),
    [anon_sym_LBRACE] = ACTIONS(3976),
    [anon_sym_LT_AT] = ACTIONS(3976),
    [anon_sym_LT_AT_AT] = ACTIONS(3976),
    [anon_sym_AT_AT_GT] = ACTIONS(3976),
    [anon_sym_DOT] = ACTIONS(3976),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3974),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_return_BANG] = ACTIONS(3974),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_yield_BANG] = ACTIONS(3974),
    [anon_sym_lazy] = ACTIONS(3976),
    [anon_sym_assert] = ACTIONS(3976),
    [anon_sym_upcast] = ACTIONS(3976),
    [anon_sym_downcast] = ACTIONS(3976),
    [anon_sym_COLON_GT] = ACTIONS(3974),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3974),
    [anon_sym_for] = ACTIONS(3976),
    [anon_sym_while] = ACTIONS(3976),
    [anon_sym_if] = ACTIONS(3976),
    [anon_sym_fun] = ACTIONS(3976),
    [anon_sym_try] = ACTIONS(3976),
    [anon_sym_match] = ACTIONS(3976),
    [anon_sym_match_BANG] = ACTIONS(3974),
    [anon_sym_function] = ACTIONS(3976),
    [anon_sym_LT_DASH] = ACTIONS(3976),
    [anon_sym_DOT_LBRACK] = ACTIONS(3974),
    [anon_sym_LT] = ACTIONS(3974),
    [anon_sym_use] = ACTIONS(3976),
    [anon_sym_use_BANG] = ACTIONS(3974),
    [anon_sym_do_BANG] = ACTIONS(3974),
    [anon_sym_begin] = ACTIONS(3976),
    [anon_sym_LPAREN2] = ACTIONS(3976),
    [anon_sym_or] = ACTIONS(3976),
    [aux_sym_char_token1] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3976),
    [anon_sym_DQUOTE] = ACTIONS(3976),
    [anon_sym_AT_DQUOTE] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [sym_bool] = ACTIONS(3976),
    [sym_unit] = ACTIONS(3974),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3976),
    [sym_op_identifier] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3976),
    [anon_sym_DASH] = ACTIONS(3976),
    [anon_sym_PLUS_DOT] = ACTIONS(3976),
    [anon_sym_DASH_DOT] = ACTIONS(3976),
    [anon_sym_PERCENT] = ACTIONS(3976),
    [anon_sym_AMP_AMP] = ACTIONS(3976),
    [anon_sym_TILDE] = ACTIONS(3974),
    [aux_sym_prefix_op_token1] = ACTIONS(3976),
    [aux_sym_infix_op_token1] = ACTIONS(3974),
    [aux_sym_infix_op_token2] = ACTIONS(3976),
    [anon_sym_PIPE_PIPE] = ACTIONS(3976),
    [anon_sym_BANG_EQ] = ACTIONS(3976),
    [anon_sym_COLON_EQ] = ACTIONS(3974),
    [anon_sym_DOLLAR] = ACTIONS(3976),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3976),
    [sym_int] = ACTIONS(3976),
    [sym_xint] = ACTIONS(3974),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3974),
    [sym__newline] = ACTIONS(3974),
  },
  [3388] = {
    [sym_block_comment] = STATE(3388),
    [sym_compiler_directive_decl] = STATE(3388),
    [sym_fsi_directive_decl] = STATE(3388),
    [sym_preproc_line] = STATE(3388),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_EQ] = ACTIONS(3948),
    [anon_sym_COLON] = ACTIONS(3950),
    [anon_sym_return] = ACTIONS(3950),
    [anon_sym_do] = ACTIONS(3950),
    [anon_sym_let] = ACTIONS(3950),
    [anon_sym_let_BANG] = ACTIONS(3948),
    [anon_sym_LPAREN] = ACTIONS(3950),
    [anon_sym_COMMA] = ACTIONS(3948),
    [anon_sym_null] = ACTIONS(3950),
    [anon_sym_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_COLON] = ACTIONS(3948),
    [anon_sym_AMP] = ACTIONS(3950),
    [anon_sym_LBRACK] = ACTIONS(3950),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3948),
    [anon_sym_LBRACE] = ACTIONS(3950),
    [anon_sym_LT_AT] = ACTIONS(3950),
    [anon_sym_LT_AT_AT] = ACTIONS(3950),
    [anon_sym_AT_AT_GT] = ACTIONS(3950),
    [anon_sym_DOT] = ACTIONS(3950),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3948),
    [anon_sym_new] = ACTIONS(3950),
    [anon_sym_return_BANG] = ACTIONS(3948),
    [anon_sym_yield] = ACTIONS(3950),
    [anon_sym_yield_BANG] = ACTIONS(3948),
    [anon_sym_lazy] = ACTIONS(3950),
    [anon_sym_assert] = ACTIONS(3950),
    [anon_sym_upcast] = ACTIONS(3950),
    [anon_sym_downcast] = ACTIONS(3950),
    [anon_sym_COLON_GT] = ACTIONS(3948),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3948),
    [anon_sym_for] = ACTIONS(3950),
    [anon_sym_while] = ACTIONS(3950),
    [anon_sym_if] = ACTIONS(3950),
    [anon_sym_fun] = ACTIONS(3950),
    [anon_sym_try] = ACTIONS(3950),
    [anon_sym_match] = ACTIONS(3950),
    [anon_sym_match_BANG] = ACTIONS(3948),
    [anon_sym_function] = ACTIONS(3950),
    [anon_sym_LT_DASH] = ACTIONS(3950),
    [anon_sym_DOT_LBRACK] = ACTIONS(3948),
    [anon_sym_LT] = ACTIONS(3948),
    [anon_sym_use] = ACTIONS(3950),
    [anon_sym_use_BANG] = ACTIONS(3948),
    [anon_sym_do_BANG] = ACTIONS(3948),
    [anon_sym_begin] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3950),
    [anon_sym_or] = ACTIONS(3950),
    [aux_sym_char_token1] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3950),
    [anon_sym_DQUOTE] = ACTIONS(3950),
    [anon_sym_AT_DQUOTE] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [sym_bool] = ACTIONS(3950),
    [sym_unit] = ACTIONS(3948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3950),
    [sym_op_identifier] = ACTIONS(3950),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_DASH] = ACTIONS(3950),
    [anon_sym_PLUS_DOT] = ACTIONS(3950),
    [anon_sym_DASH_DOT] = ACTIONS(3950),
    [anon_sym_PERCENT] = ACTIONS(3950),
    [anon_sym_AMP_AMP] = ACTIONS(3950),
    [anon_sym_TILDE] = ACTIONS(3948),
    [aux_sym_prefix_op_token1] = ACTIONS(3950),
    [aux_sym_infix_op_token1] = ACTIONS(3948),
    [aux_sym_infix_op_token2] = ACTIONS(3950),
    [anon_sym_PIPE_PIPE] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3950),
    [anon_sym_COLON_EQ] = ACTIONS(3948),
    [anon_sym_DOLLAR] = ACTIONS(3950),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3950),
    [sym_int] = ACTIONS(3950),
    [sym_xint] = ACTIONS(3948),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3948),
    [sym__newline] = ACTIONS(3948),
  },
  [3389] = {
    [sym_block_comment] = STATE(3389),
    [sym_compiler_directive_decl] = STATE(3389),
    [sym_fsi_directive_decl] = STATE(3389),
    [sym_preproc_line] = STATE(3389),
    [sym_identifier] = ACTIONS(3954),
    [anon_sym_EQ] = ACTIONS(3952),
    [anon_sym_COLON] = ACTIONS(3954),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_do] = ACTIONS(3954),
    [anon_sym_let] = ACTIONS(3954),
    [anon_sym_let_BANG] = ACTIONS(3952),
    [anon_sym_LPAREN] = ACTIONS(3954),
    [anon_sym_COMMA] = ACTIONS(3952),
    [anon_sym_null] = ACTIONS(3954),
    [anon_sym_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_COLON] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3954),
    [anon_sym_LBRACK] = ACTIONS(3954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(3954),
    [anon_sym_LT_AT] = ACTIONS(3954),
    [anon_sym_LT_AT_AT] = ACTIONS(3954),
    [anon_sym_AT_AT_GT] = ACTIONS(3954),
    [anon_sym_DOT] = ACTIONS(3954),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3952),
    [anon_sym_new] = ACTIONS(3954),
    [anon_sym_return_BANG] = ACTIONS(3952),
    [anon_sym_yield] = ACTIONS(3954),
    [anon_sym_yield_BANG] = ACTIONS(3952),
    [anon_sym_lazy] = ACTIONS(3954),
    [anon_sym_assert] = ACTIONS(3954),
    [anon_sym_upcast] = ACTIONS(3954),
    [anon_sym_downcast] = ACTIONS(3954),
    [anon_sym_COLON_GT] = ACTIONS(3952),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3952),
    [anon_sym_for] = ACTIONS(3954),
    [anon_sym_while] = ACTIONS(3954),
    [anon_sym_if] = ACTIONS(3954),
    [anon_sym_fun] = ACTIONS(3954),
    [anon_sym_try] = ACTIONS(3954),
    [anon_sym_match] = ACTIONS(3954),
    [anon_sym_match_BANG] = ACTIONS(3952),
    [anon_sym_function] = ACTIONS(3954),
    [anon_sym_LT_DASH] = ACTIONS(3954),
    [anon_sym_DOT_LBRACK] = ACTIONS(3952),
    [anon_sym_LT] = ACTIONS(3952),
    [anon_sym_use] = ACTIONS(3954),
    [anon_sym_use_BANG] = ACTIONS(3952),
    [anon_sym_do_BANG] = ACTIONS(3952),
    [anon_sym_begin] = ACTIONS(3954),
    [anon_sym_LPAREN2] = ACTIONS(3954),
    [anon_sym_or] = ACTIONS(3954),
    [aux_sym_char_token1] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3954),
    [anon_sym_DQUOTE] = ACTIONS(3954),
    [anon_sym_AT_DQUOTE] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [sym_bool] = ACTIONS(3954),
    [sym_unit] = ACTIONS(3952),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3954),
    [sym_op_identifier] = ACTIONS(3954),
    [anon_sym_PLUS] = ACTIONS(3954),
    [anon_sym_DASH] = ACTIONS(3954),
    [anon_sym_PLUS_DOT] = ACTIONS(3954),
    [anon_sym_DASH_DOT] = ACTIONS(3954),
    [anon_sym_PERCENT] = ACTIONS(3954),
    [anon_sym_AMP_AMP] = ACTIONS(3954),
    [anon_sym_TILDE] = ACTIONS(3952),
    [aux_sym_prefix_op_token1] = ACTIONS(3954),
    [aux_sym_infix_op_token1] = ACTIONS(3952),
    [aux_sym_infix_op_token2] = ACTIONS(3954),
    [anon_sym_PIPE_PIPE] = ACTIONS(3954),
    [anon_sym_BANG_EQ] = ACTIONS(3954),
    [anon_sym_COLON_EQ] = ACTIONS(3952),
    [anon_sym_DOLLAR] = ACTIONS(3954),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3954),
    [sym_int] = ACTIONS(3954),
    [sym_xint] = ACTIONS(3952),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3952),
    [sym__newline] = ACTIONS(3952),
  },
  [3390] = {
    [sym_block_comment] = STATE(3390),
    [sym_compiler_directive_decl] = STATE(3390),
    [sym_fsi_directive_decl] = STATE(3390),
    [sym_preproc_line] = STATE(3390),
    [sym_identifier] = ACTIONS(3927),
    [anon_sym_EQ] = ACTIONS(3925),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_return] = ACTIONS(3927),
    [anon_sym_do] = ACTIONS(3927),
    [anon_sym_let] = ACTIONS(3927),
    [anon_sym_let_BANG] = ACTIONS(3925),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_COMMA] = ACTIONS(3925),
    [anon_sym_null] = ACTIONS(3927),
    [anon_sym_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_COLON] = ACTIONS(3925),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3925),
    [anon_sym_LBRACE] = ACTIONS(3927),
    [anon_sym_LT_AT] = ACTIONS(3927),
    [anon_sym_LT_AT_AT] = ACTIONS(3927),
    [anon_sym_AT_AT_GT] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3925),
    [anon_sym_new] = ACTIONS(3927),
    [anon_sym_return_BANG] = ACTIONS(3925),
    [anon_sym_yield] = ACTIONS(3927),
    [anon_sym_yield_BANG] = ACTIONS(3925),
    [anon_sym_lazy] = ACTIONS(3927),
    [anon_sym_assert] = ACTIONS(3927),
    [anon_sym_upcast] = ACTIONS(3927),
    [anon_sym_downcast] = ACTIONS(3927),
    [anon_sym_COLON_GT] = ACTIONS(3925),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3925),
    [anon_sym_for] = ACTIONS(3927),
    [anon_sym_while] = ACTIONS(3927),
    [anon_sym_if] = ACTIONS(3927),
    [anon_sym_fun] = ACTIONS(3927),
    [anon_sym_try] = ACTIONS(3927),
    [anon_sym_match] = ACTIONS(3927),
    [anon_sym_match_BANG] = ACTIONS(3925),
    [anon_sym_function] = ACTIONS(3927),
    [anon_sym_LT_DASH] = ACTIONS(3927),
    [anon_sym_DOT_LBRACK] = ACTIONS(3925),
    [anon_sym_LT] = ACTIONS(3925),
    [anon_sym_use] = ACTIONS(3927),
    [anon_sym_use_BANG] = ACTIONS(3925),
    [anon_sym_do_BANG] = ACTIONS(3925),
    [anon_sym_begin] = ACTIONS(3927),
    [anon_sym_LPAREN2] = ACTIONS(3927),
    [anon_sym_or] = ACTIONS(3927),
    [aux_sym_char_token1] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_AT_DQUOTE] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [sym_bool] = ACTIONS(3927),
    [sym_unit] = ACTIONS(3925),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3927),
    [sym_op_identifier] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3927),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_PLUS_DOT] = ACTIONS(3927),
    [anon_sym_DASH_DOT] = ACTIONS(3927),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_TILDE] = ACTIONS(3925),
    [aux_sym_prefix_op_token1] = ACTIONS(3927),
    [aux_sym_infix_op_token1] = ACTIONS(3925),
    [aux_sym_infix_op_token2] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_COLON_EQ] = ACTIONS(3925),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3927),
    [sym_int] = ACTIONS(3927),
    [sym_xint] = ACTIONS(3925),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3925),
    [sym__newline] = ACTIONS(3925),
  },
  [3391] = {
    [sym_block_comment] = STATE(3391),
    [sym_compiler_directive_decl] = STATE(3391),
    [sym_fsi_directive_decl] = STATE(3391),
    [sym_preproc_line] = STATE(3391),
    [sym_identifier] = ACTIONS(3958),
    [anon_sym_EQ] = ACTIONS(3956),
    [anon_sym_COLON] = ACTIONS(3958),
    [anon_sym_return] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(3958),
    [anon_sym_let] = ACTIONS(3958),
    [anon_sym_let_BANG] = ACTIONS(3956),
    [anon_sym_LPAREN] = ACTIONS(3958),
    [anon_sym_COMMA] = ACTIONS(3956),
    [anon_sym_null] = ACTIONS(3958),
    [anon_sym_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_COLON] = ACTIONS(3956),
    [anon_sym_AMP] = ACTIONS(3958),
    [anon_sym_LBRACK] = ACTIONS(3958),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3956),
    [anon_sym_LBRACE] = ACTIONS(3958),
    [anon_sym_LT_AT] = ACTIONS(3958),
    [anon_sym_LT_AT_AT] = ACTIONS(3958),
    [anon_sym_AT_AT_GT] = ACTIONS(3958),
    [anon_sym_DOT] = ACTIONS(3958),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3956),
    [anon_sym_new] = ACTIONS(3958),
    [anon_sym_return_BANG] = ACTIONS(3956),
    [anon_sym_yield] = ACTIONS(3958),
    [anon_sym_yield_BANG] = ACTIONS(3956),
    [anon_sym_lazy] = ACTIONS(3958),
    [anon_sym_assert] = ACTIONS(3958),
    [anon_sym_upcast] = ACTIONS(3958),
    [anon_sym_downcast] = ACTIONS(3958),
    [anon_sym_COLON_GT] = ACTIONS(3956),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3956),
    [anon_sym_for] = ACTIONS(3958),
    [anon_sym_while] = ACTIONS(3958),
    [anon_sym_if] = ACTIONS(3958),
    [anon_sym_fun] = ACTIONS(3958),
    [anon_sym_try] = ACTIONS(3958),
    [anon_sym_match] = ACTIONS(3958),
    [anon_sym_match_BANG] = ACTIONS(3956),
    [anon_sym_function] = ACTIONS(3958),
    [anon_sym_LT_DASH] = ACTIONS(3958),
    [anon_sym_DOT_LBRACK] = ACTIONS(3956),
    [anon_sym_LT] = ACTIONS(3956),
    [anon_sym_use] = ACTIONS(3958),
    [anon_sym_use_BANG] = ACTIONS(3956),
    [anon_sym_do_BANG] = ACTIONS(3956),
    [anon_sym_begin] = ACTIONS(3958),
    [anon_sym_LPAREN2] = ACTIONS(3958),
    [anon_sym_or] = ACTIONS(3958),
    [aux_sym_char_token1] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [anon_sym_AT_DQUOTE] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [sym_bool] = ACTIONS(3958),
    [sym_unit] = ACTIONS(3956),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3958),
    [sym_op_identifier] = ACTIONS(3958),
    [anon_sym_PLUS] = ACTIONS(3958),
    [anon_sym_DASH] = ACTIONS(3958),
    [anon_sym_PLUS_DOT] = ACTIONS(3958),
    [anon_sym_DASH_DOT] = ACTIONS(3958),
    [anon_sym_PERCENT] = ACTIONS(3958),
    [anon_sym_AMP_AMP] = ACTIONS(3958),
    [anon_sym_TILDE] = ACTIONS(3956),
    [aux_sym_prefix_op_token1] = ACTIONS(3958),
    [aux_sym_infix_op_token1] = ACTIONS(3956),
    [aux_sym_infix_op_token2] = ACTIONS(3958),
    [anon_sym_PIPE_PIPE] = ACTIONS(3958),
    [anon_sym_BANG_EQ] = ACTIONS(3958),
    [anon_sym_COLON_EQ] = ACTIONS(3956),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3958),
    [sym_int] = ACTIONS(3958),
    [sym_xint] = ACTIONS(3956),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3956),
    [sym__newline] = ACTIONS(3956),
  },
  [3392] = {
    [sym_block_comment] = STATE(3392),
    [sym_compiler_directive_decl] = STATE(3392),
    [sym_fsi_directive_decl] = STATE(3392),
    [sym_preproc_line] = STATE(3392),
    [sym_identifier] = ACTIONS(3966),
    [anon_sym_EQ] = ACTIONS(3964),
    [anon_sym_COLON] = ACTIONS(3966),
    [anon_sym_return] = ACTIONS(3966),
    [anon_sym_do] = ACTIONS(3966),
    [anon_sym_let] = ACTIONS(3966),
    [anon_sym_let_BANG] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COMMA] = ACTIONS(3964),
    [anon_sym_null] = ACTIONS(3966),
    [anon_sym_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(3964),
    [anon_sym_AMP] = ACTIONS(3966),
    [anon_sym_LBRACK] = ACTIONS(3966),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3964),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_LT_AT] = ACTIONS(3966),
    [anon_sym_AT_GT] = ACTIONS(3966),
    [anon_sym_LT_AT_AT] = ACTIONS(3966),
    [anon_sym_DOT] = ACTIONS(3966),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3964),
    [anon_sym_new] = ACTIONS(3966),
    [anon_sym_return_BANG] = ACTIONS(3964),
    [anon_sym_yield] = ACTIONS(3966),
    [anon_sym_yield_BANG] = ACTIONS(3964),
    [anon_sym_lazy] = ACTIONS(3966),
    [anon_sym_assert] = ACTIONS(3966),
    [anon_sym_upcast] = ACTIONS(3966),
    [anon_sym_downcast] = ACTIONS(3966),
    [anon_sym_COLON_GT] = ACTIONS(3964),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3964),
    [anon_sym_for] = ACTIONS(3966),
    [anon_sym_while] = ACTIONS(3966),
    [anon_sym_if] = ACTIONS(3966),
    [anon_sym_fun] = ACTIONS(3966),
    [anon_sym_try] = ACTIONS(3966),
    [anon_sym_match] = ACTIONS(3966),
    [anon_sym_match_BANG] = ACTIONS(3964),
    [anon_sym_function] = ACTIONS(3966),
    [anon_sym_LT_DASH] = ACTIONS(3966),
    [anon_sym_DOT_LBRACK] = ACTIONS(3964),
    [anon_sym_LT] = ACTIONS(3964),
    [anon_sym_use] = ACTIONS(3966),
    [anon_sym_use_BANG] = ACTIONS(3964),
    [anon_sym_do_BANG] = ACTIONS(3964),
    [anon_sym_begin] = ACTIONS(3966),
    [anon_sym_LPAREN2] = ACTIONS(3966),
    [anon_sym_or] = ACTIONS(3966),
    [aux_sym_char_token1] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3966),
    [anon_sym_DQUOTE] = ACTIONS(3966),
    [anon_sym_AT_DQUOTE] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [sym_bool] = ACTIONS(3966),
    [sym_unit] = ACTIONS(3964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3966),
    [sym_op_identifier] = ACTIONS(3966),
    [anon_sym_PLUS] = ACTIONS(3966),
    [anon_sym_DASH] = ACTIONS(3966),
    [anon_sym_PLUS_DOT] = ACTIONS(3966),
    [anon_sym_DASH_DOT] = ACTIONS(3966),
    [anon_sym_PERCENT] = ACTIONS(3966),
    [anon_sym_AMP_AMP] = ACTIONS(3966),
    [anon_sym_TILDE] = ACTIONS(3964),
    [aux_sym_prefix_op_token1] = ACTIONS(3966),
    [aux_sym_infix_op_token1] = ACTIONS(3964),
    [aux_sym_infix_op_token2] = ACTIONS(3966),
    [anon_sym_PIPE_PIPE] = ACTIONS(3966),
    [anon_sym_BANG_EQ] = ACTIONS(3966),
    [anon_sym_COLON_EQ] = ACTIONS(3964),
    [anon_sym_DOLLAR] = ACTIONS(3966),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3966),
    [sym_int] = ACTIONS(3966),
    [sym_xint] = ACTIONS(3964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3964),
    [sym__newline] = ACTIONS(3964),
  },
  [3393] = {
    [sym_block_comment] = STATE(3393),
    [sym_compiler_directive_decl] = STATE(3393),
    [sym_fsi_directive_decl] = STATE(3393),
    [sym_preproc_line] = STATE(3393),
    [sym_identifier] = ACTIONS(3962),
    [anon_sym_EQ] = ACTIONS(3960),
    [anon_sym_COLON] = ACTIONS(3962),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_do] = ACTIONS(3962),
    [anon_sym_let] = ACTIONS(3962),
    [anon_sym_let_BANG] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_COMMA] = ACTIONS(3960),
    [anon_sym_null] = ACTIONS(3962),
    [anon_sym_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_COLON] = ACTIONS(3960),
    [anon_sym_AMP] = ACTIONS(3962),
    [anon_sym_LBRACK] = ACTIONS(3962),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_LT_AT] = ACTIONS(3962),
    [anon_sym_LT_AT_AT] = ACTIONS(3962),
    [anon_sym_AT_AT_GT] = ACTIONS(3962),
    [anon_sym_DOT] = ACTIONS(3962),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3960),
    [anon_sym_new] = ACTIONS(3962),
    [anon_sym_return_BANG] = ACTIONS(3960),
    [anon_sym_yield] = ACTIONS(3962),
    [anon_sym_yield_BANG] = ACTIONS(3960),
    [anon_sym_lazy] = ACTIONS(3962),
    [anon_sym_assert] = ACTIONS(3962),
    [anon_sym_upcast] = ACTIONS(3962),
    [anon_sym_downcast] = ACTIONS(3962),
    [anon_sym_COLON_GT] = ACTIONS(3960),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3960),
    [anon_sym_for] = ACTIONS(3962),
    [anon_sym_while] = ACTIONS(3962),
    [anon_sym_if] = ACTIONS(3962),
    [anon_sym_fun] = ACTIONS(3962),
    [anon_sym_try] = ACTIONS(3962),
    [anon_sym_match] = ACTIONS(3962),
    [anon_sym_match_BANG] = ACTIONS(3960),
    [anon_sym_function] = ACTIONS(3962),
    [anon_sym_LT_DASH] = ACTIONS(3962),
    [anon_sym_DOT_LBRACK] = ACTIONS(3960),
    [anon_sym_LT] = ACTIONS(3960),
    [anon_sym_use] = ACTIONS(3962),
    [anon_sym_use_BANG] = ACTIONS(3960),
    [anon_sym_do_BANG] = ACTIONS(3960),
    [anon_sym_begin] = ACTIONS(3962),
    [anon_sym_LPAREN2] = ACTIONS(3962),
    [anon_sym_or] = ACTIONS(3962),
    [aux_sym_char_token1] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3962),
    [anon_sym_DQUOTE] = ACTIONS(3962),
    [anon_sym_AT_DQUOTE] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [sym_bool] = ACTIONS(3962),
    [sym_unit] = ACTIONS(3960),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3962),
    [sym_op_identifier] = ACTIONS(3962),
    [anon_sym_PLUS] = ACTIONS(3962),
    [anon_sym_DASH] = ACTIONS(3962),
    [anon_sym_PLUS_DOT] = ACTIONS(3962),
    [anon_sym_DASH_DOT] = ACTIONS(3962),
    [anon_sym_PERCENT] = ACTIONS(3962),
    [anon_sym_AMP_AMP] = ACTIONS(3962),
    [anon_sym_TILDE] = ACTIONS(3960),
    [aux_sym_prefix_op_token1] = ACTIONS(3962),
    [aux_sym_infix_op_token1] = ACTIONS(3960),
    [aux_sym_infix_op_token2] = ACTIONS(3962),
    [anon_sym_PIPE_PIPE] = ACTIONS(3962),
    [anon_sym_BANG_EQ] = ACTIONS(3962),
    [anon_sym_COLON_EQ] = ACTIONS(3960),
    [anon_sym_DOLLAR] = ACTIONS(3962),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3962),
    [sym_int] = ACTIONS(3962),
    [sym_xint] = ACTIONS(3960),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3960),
    [sym__newline] = ACTIONS(3960),
  },
  [3394] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_type_arguments] = STATE(3841),
    [sym__method_defn] = STATE(6490),
    [sym__property_defn] = STATE(6491),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3394),
    [sym_compiler_directive_decl] = STATE(3394),
    [sym_fsi_directive_decl] = STATE(3394),
    [sym_preproc_line] = STATE(3394),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3731),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(5907),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_COLON] = ACTIONS(5909),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [anon_sym_with] = ACTIONS(5911),
    [anon_sym_LT2] = ACTIONS(5809),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3395] = {
    [sym_block_comment] = STATE(3395),
    [sym_compiler_directive_decl] = STATE(3395),
    [sym_fsi_directive_decl] = STATE(3395),
    [sym_preproc_line] = STATE(3395),
    [sym_identifier] = ACTIONS(4232),
    [anon_sym_EQ] = ACTIONS(4230),
    [anon_sym_COLON] = ACTIONS(4232),
    [anon_sym_return] = ACTIONS(4232),
    [anon_sym_do] = ACTIONS(4232),
    [anon_sym_let] = ACTIONS(4232),
    [anon_sym_let_BANG] = ACTIONS(4230),
    [anon_sym_LPAREN] = ACTIONS(4232),
    [anon_sym_COMMA] = ACTIONS(4230),
    [anon_sym_null] = ACTIONS(4232),
    [anon_sym_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_COLON] = ACTIONS(4230),
    [anon_sym_AMP] = ACTIONS(4232),
    [anon_sym_LBRACK] = ACTIONS(4232),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4230),
    [anon_sym_LBRACE] = ACTIONS(4232),
    [anon_sym_LT_AT] = ACTIONS(4232),
    [anon_sym_LT_AT_AT] = ACTIONS(4232),
    [anon_sym_AT_AT_GT] = ACTIONS(4232),
    [anon_sym_DOT] = ACTIONS(4232),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4230),
    [anon_sym_new] = ACTIONS(4232),
    [anon_sym_return_BANG] = ACTIONS(4230),
    [anon_sym_yield] = ACTIONS(4232),
    [anon_sym_yield_BANG] = ACTIONS(4230),
    [anon_sym_lazy] = ACTIONS(4232),
    [anon_sym_assert] = ACTIONS(4232),
    [anon_sym_upcast] = ACTIONS(4232),
    [anon_sym_downcast] = ACTIONS(4232),
    [anon_sym_COLON_GT] = ACTIONS(4230),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4230),
    [anon_sym_for] = ACTIONS(4232),
    [anon_sym_while] = ACTIONS(4232),
    [anon_sym_if] = ACTIONS(4232),
    [anon_sym_fun] = ACTIONS(4232),
    [anon_sym_try] = ACTIONS(4232),
    [anon_sym_match] = ACTIONS(4232),
    [anon_sym_match_BANG] = ACTIONS(4230),
    [anon_sym_function] = ACTIONS(4232),
    [anon_sym_LT_DASH] = ACTIONS(4232),
    [anon_sym_DOT_LBRACK] = ACTIONS(4230),
    [anon_sym_LT] = ACTIONS(4230),
    [anon_sym_use] = ACTIONS(4232),
    [anon_sym_use_BANG] = ACTIONS(4230),
    [anon_sym_do_BANG] = ACTIONS(4230),
    [anon_sym_begin] = ACTIONS(4232),
    [anon_sym_LPAREN2] = ACTIONS(4232),
    [anon_sym_or] = ACTIONS(4232),
    [aux_sym_char_token1] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4232),
    [anon_sym_DQUOTE] = ACTIONS(4232),
    [anon_sym_AT_DQUOTE] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [sym_bool] = ACTIONS(4232),
    [sym_unit] = ACTIONS(4230),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4232),
    [sym_op_identifier] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4232),
    [anon_sym_DASH] = ACTIONS(4232),
    [anon_sym_PLUS_DOT] = ACTIONS(4232),
    [anon_sym_DASH_DOT] = ACTIONS(4232),
    [anon_sym_PERCENT] = ACTIONS(4232),
    [anon_sym_AMP_AMP] = ACTIONS(4232),
    [anon_sym_TILDE] = ACTIONS(4230),
    [aux_sym_prefix_op_token1] = ACTIONS(4232),
    [aux_sym_infix_op_token1] = ACTIONS(4230),
    [aux_sym_infix_op_token2] = ACTIONS(4232),
    [anon_sym_PIPE_PIPE] = ACTIONS(4232),
    [anon_sym_BANG_EQ] = ACTIONS(4232),
    [anon_sym_COLON_EQ] = ACTIONS(4230),
    [anon_sym_DOLLAR] = ACTIONS(4232),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4232),
    [sym_int] = ACTIONS(4232),
    [sym_xint] = ACTIONS(4230),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4230),
    [sym__newline] = ACTIONS(4230),
  },
  [3396] = {
    [sym_block_comment] = STATE(3396),
    [sym_compiler_directive_decl] = STATE(3396),
    [sym_fsi_directive_decl] = STATE(3396),
    [sym_preproc_line] = STATE(3396),
    [sym_identifier] = ACTIONS(4126),
    [anon_sym_EQ] = ACTIONS(4124),
    [anon_sym_COLON] = ACTIONS(4126),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_do] = ACTIONS(4126),
    [anon_sym_let] = ACTIONS(4126),
    [anon_sym_let_BANG] = ACTIONS(4124),
    [anon_sym_LPAREN] = ACTIONS(4126),
    [anon_sym_COMMA] = ACTIONS(4124),
    [anon_sym_null] = ACTIONS(4126),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_COLON] = ACTIONS(4124),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LBRACK] = ACTIONS(4126),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4126),
    [anon_sym_LT_AT] = ACTIONS(4126),
    [anon_sym_LT_AT_AT] = ACTIONS(4126),
    [anon_sym_AT_AT_GT] = ACTIONS(4126),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4124),
    [anon_sym_new] = ACTIONS(4126),
    [anon_sym_return_BANG] = ACTIONS(4124),
    [anon_sym_yield] = ACTIONS(4126),
    [anon_sym_yield_BANG] = ACTIONS(4124),
    [anon_sym_lazy] = ACTIONS(4126),
    [anon_sym_assert] = ACTIONS(4126),
    [anon_sym_upcast] = ACTIONS(4126),
    [anon_sym_downcast] = ACTIONS(4126),
    [anon_sym_COLON_GT] = ACTIONS(4124),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4124),
    [anon_sym_for] = ACTIONS(4126),
    [anon_sym_while] = ACTIONS(4126),
    [anon_sym_if] = ACTIONS(4126),
    [anon_sym_fun] = ACTIONS(4126),
    [anon_sym_try] = ACTIONS(4126),
    [anon_sym_match] = ACTIONS(4126),
    [anon_sym_match_BANG] = ACTIONS(4124),
    [anon_sym_function] = ACTIONS(4126),
    [anon_sym_LT_DASH] = ACTIONS(4126),
    [anon_sym_DOT_LBRACK] = ACTIONS(4124),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_use] = ACTIONS(4126),
    [anon_sym_use_BANG] = ACTIONS(4124),
    [anon_sym_do_BANG] = ACTIONS(4124),
    [anon_sym_begin] = ACTIONS(4126),
    [anon_sym_LPAREN2] = ACTIONS(4126),
    [anon_sym_or] = ACTIONS(4126),
    [aux_sym_char_token1] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4126),
    [anon_sym_DQUOTE] = ACTIONS(4126),
    [anon_sym_AT_DQUOTE] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [sym_bool] = ACTIONS(4126),
    [sym_unit] = ACTIONS(4124),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4126),
    [sym_op_identifier] = ACTIONS(4126),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_PLUS_DOT] = ACTIONS(4126),
    [anon_sym_DASH_DOT] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_AMP_AMP] = ACTIONS(4126),
    [anon_sym_TILDE] = ACTIONS(4124),
    [aux_sym_prefix_op_token1] = ACTIONS(4126),
    [aux_sym_infix_op_token1] = ACTIONS(4124),
    [aux_sym_infix_op_token2] = ACTIONS(4126),
    [anon_sym_PIPE_PIPE] = ACTIONS(4126),
    [anon_sym_BANG_EQ] = ACTIONS(4126),
    [anon_sym_COLON_EQ] = ACTIONS(4124),
    [anon_sym_DOLLAR] = ACTIONS(4126),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4126),
    [sym_int] = ACTIONS(4126),
    [sym_xint] = ACTIONS(4124),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4124),
    [sym__newline] = ACTIONS(4124),
  },
  [3397] = {
    [sym_block_comment] = STATE(3397),
    [sym_compiler_directive_decl] = STATE(3397),
    [sym_fsi_directive_decl] = STATE(3397),
    [sym_preproc_line] = STATE(3397),
    [sym_identifier] = ACTIONS(4122),
    [anon_sym_EQ] = ACTIONS(4120),
    [anon_sym_COLON] = ACTIONS(4122),
    [anon_sym_return] = ACTIONS(4122),
    [anon_sym_do] = ACTIONS(4122),
    [anon_sym_let] = ACTIONS(4122),
    [anon_sym_let_BANG] = ACTIONS(4120),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_COMMA] = ACTIONS(4120),
    [anon_sym_null] = ACTIONS(4122),
    [anon_sym_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_COLON] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_LT_AT] = ACTIONS(4122),
    [anon_sym_LT_AT_AT] = ACTIONS(4122),
    [anon_sym_AT_AT_GT] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4122),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4120),
    [anon_sym_new] = ACTIONS(4122),
    [anon_sym_return_BANG] = ACTIONS(4120),
    [anon_sym_yield] = ACTIONS(4122),
    [anon_sym_yield_BANG] = ACTIONS(4120),
    [anon_sym_lazy] = ACTIONS(4122),
    [anon_sym_assert] = ACTIONS(4122),
    [anon_sym_upcast] = ACTIONS(4122),
    [anon_sym_downcast] = ACTIONS(4122),
    [anon_sym_COLON_GT] = ACTIONS(4120),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4120),
    [anon_sym_for] = ACTIONS(4122),
    [anon_sym_while] = ACTIONS(4122),
    [anon_sym_if] = ACTIONS(4122),
    [anon_sym_fun] = ACTIONS(4122),
    [anon_sym_try] = ACTIONS(4122),
    [anon_sym_match] = ACTIONS(4122),
    [anon_sym_match_BANG] = ACTIONS(4120),
    [anon_sym_function] = ACTIONS(4122),
    [anon_sym_LT_DASH] = ACTIONS(4122),
    [anon_sym_DOT_LBRACK] = ACTIONS(4120),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_use] = ACTIONS(4122),
    [anon_sym_use_BANG] = ACTIONS(4120),
    [anon_sym_do_BANG] = ACTIONS(4120),
    [anon_sym_begin] = ACTIONS(4122),
    [anon_sym_LPAREN2] = ACTIONS(4122),
    [anon_sym_or] = ACTIONS(4122),
    [aux_sym_char_token1] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4122),
    [anon_sym_DQUOTE] = ACTIONS(4122),
    [anon_sym_AT_DQUOTE] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [sym_bool] = ACTIONS(4122),
    [sym_unit] = ACTIONS(4120),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4122),
    [sym_op_identifier] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4122),
    [anon_sym_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_DOT] = ACTIONS(4122),
    [anon_sym_DASH_DOT] = ACTIONS(4122),
    [anon_sym_PERCENT] = ACTIONS(4122),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_TILDE] = ACTIONS(4120),
    [aux_sym_prefix_op_token1] = ACTIONS(4122),
    [aux_sym_infix_op_token1] = ACTIONS(4120),
    [aux_sym_infix_op_token2] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_COLON_EQ] = ACTIONS(4120),
    [anon_sym_DOLLAR] = ACTIONS(4122),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4122),
    [sym_int] = ACTIONS(4122),
    [sym_xint] = ACTIONS(4120),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4120),
    [sym__newline] = ACTIONS(4120),
  },
  [3398] = {
    [sym_block_comment] = STATE(3398),
    [sym_compiler_directive_decl] = STATE(3398),
    [sym_fsi_directive_decl] = STATE(3398),
    [sym_preproc_line] = STATE(3398),
    [sym_identifier] = ACTIONS(4118),
    [anon_sym_EQ] = ACTIONS(4116),
    [anon_sym_COLON] = ACTIONS(4118),
    [anon_sym_return] = ACTIONS(4118),
    [anon_sym_do] = ACTIONS(4118),
    [anon_sym_let] = ACTIONS(4118),
    [anon_sym_let_BANG] = ACTIONS(4116),
    [anon_sym_LPAREN] = ACTIONS(4118),
    [anon_sym_COMMA] = ACTIONS(4116),
    [anon_sym_null] = ACTIONS(4118),
    [anon_sym_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_COLON] = ACTIONS(4116),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4118),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(4118),
    [anon_sym_LT_AT] = ACTIONS(4118),
    [anon_sym_LT_AT_AT] = ACTIONS(4118),
    [anon_sym_AT_AT_GT] = ACTIONS(4118),
    [anon_sym_DOT] = ACTIONS(4118),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4116),
    [anon_sym_new] = ACTIONS(4118),
    [anon_sym_return_BANG] = ACTIONS(4116),
    [anon_sym_yield] = ACTIONS(4118),
    [anon_sym_yield_BANG] = ACTIONS(4116),
    [anon_sym_lazy] = ACTIONS(4118),
    [anon_sym_assert] = ACTIONS(4118),
    [anon_sym_upcast] = ACTIONS(4118),
    [anon_sym_downcast] = ACTIONS(4118),
    [anon_sym_COLON_GT] = ACTIONS(4116),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4116),
    [anon_sym_for] = ACTIONS(4118),
    [anon_sym_while] = ACTIONS(4118),
    [anon_sym_if] = ACTIONS(4118),
    [anon_sym_fun] = ACTIONS(4118),
    [anon_sym_try] = ACTIONS(4118),
    [anon_sym_match] = ACTIONS(4118),
    [anon_sym_match_BANG] = ACTIONS(4116),
    [anon_sym_function] = ACTIONS(4118),
    [anon_sym_LT_DASH] = ACTIONS(4118),
    [anon_sym_DOT_LBRACK] = ACTIONS(4116),
    [anon_sym_LT] = ACTIONS(4116),
    [anon_sym_use] = ACTIONS(4118),
    [anon_sym_use_BANG] = ACTIONS(4116),
    [anon_sym_do_BANG] = ACTIONS(4116),
    [anon_sym_begin] = ACTIONS(4118),
    [anon_sym_LPAREN2] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [aux_sym_char_token1] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4118),
    [anon_sym_DQUOTE] = ACTIONS(4118),
    [anon_sym_AT_DQUOTE] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [sym_bool] = ACTIONS(4118),
    [sym_unit] = ACTIONS(4116),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4118),
    [sym_op_identifier] = ACTIONS(4118),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_PLUS_DOT] = ACTIONS(4118),
    [anon_sym_DASH_DOT] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_AMP_AMP] = ACTIONS(4118),
    [anon_sym_TILDE] = ACTIONS(4116),
    [aux_sym_prefix_op_token1] = ACTIONS(4118),
    [aux_sym_infix_op_token1] = ACTIONS(4116),
    [aux_sym_infix_op_token2] = ACTIONS(4118),
    [anon_sym_PIPE_PIPE] = ACTIONS(4118),
    [anon_sym_BANG_EQ] = ACTIONS(4118),
    [anon_sym_COLON_EQ] = ACTIONS(4116),
    [anon_sym_DOLLAR] = ACTIONS(4118),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4118),
    [sym_int] = ACTIONS(4118),
    [sym_xint] = ACTIONS(4116),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4116),
    [sym__newline] = ACTIONS(4116),
  },
  [3399] = {
    [sym_block_comment] = STATE(3399),
    [sym_compiler_directive_decl] = STATE(3399),
    [sym_fsi_directive_decl] = STATE(3399),
    [sym_preproc_line] = STATE(3399),
    [sym_identifier] = ACTIONS(4112),
    [anon_sym_EQ] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4112),
    [anon_sym_return] = ACTIONS(4112),
    [anon_sym_do] = ACTIONS(4112),
    [anon_sym_let] = ACTIONS(4112),
    [anon_sym_let_BANG] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_null] = ACTIONS(4112),
    [anon_sym_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_COLON] = ACTIONS(4110),
    [anon_sym_AMP] = ACTIONS(4112),
    [anon_sym_LBRACK] = ACTIONS(4112),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4110),
    [anon_sym_LBRACE] = ACTIONS(4112),
    [anon_sym_LT_AT] = ACTIONS(4112),
    [anon_sym_LT_AT_AT] = ACTIONS(4112),
    [anon_sym_AT_AT_GT] = ACTIONS(4112),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4110),
    [anon_sym_new] = ACTIONS(4112),
    [anon_sym_return_BANG] = ACTIONS(4110),
    [anon_sym_yield] = ACTIONS(4112),
    [anon_sym_yield_BANG] = ACTIONS(4110),
    [anon_sym_lazy] = ACTIONS(4112),
    [anon_sym_assert] = ACTIONS(4112),
    [anon_sym_upcast] = ACTIONS(4112),
    [anon_sym_downcast] = ACTIONS(4112),
    [anon_sym_COLON_GT] = ACTIONS(4110),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4110),
    [anon_sym_for] = ACTIONS(4112),
    [anon_sym_while] = ACTIONS(4112),
    [anon_sym_if] = ACTIONS(4112),
    [anon_sym_fun] = ACTIONS(4112),
    [anon_sym_try] = ACTIONS(4112),
    [anon_sym_match] = ACTIONS(4112),
    [anon_sym_match_BANG] = ACTIONS(4110),
    [anon_sym_function] = ACTIONS(4112),
    [anon_sym_LT_DASH] = ACTIONS(4112),
    [anon_sym_DOT_LBRACK] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(4110),
    [anon_sym_use] = ACTIONS(4112),
    [anon_sym_use_BANG] = ACTIONS(4110),
    [anon_sym_do_BANG] = ACTIONS(4110),
    [anon_sym_begin] = ACTIONS(4112),
    [anon_sym_LPAREN2] = ACTIONS(4112),
    [anon_sym_or] = ACTIONS(4112),
    [aux_sym_char_token1] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4112),
    [anon_sym_DQUOTE] = ACTIONS(4112),
    [anon_sym_AT_DQUOTE] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [sym_bool] = ACTIONS(4112),
    [sym_unit] = ACTIONS(4110),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4112),
    [sym_op_identifier] = ACTIONS(4112),
    [anon_sym_PLUS] = ACTIONS(4112),
    [anon_sym_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_DOT] = ACTIONS(4112),
    [anon_sym_DASH_DOT] = ACTIONS(4112),
    [anon_sym_PERCENT] = ACTIONS(4112),
    [anon_sym_AMP_AMP] = ACTIONS(4112),
    [anon_sym_TILDE] = ACTIONS(4110),
    [aux_sym_prefix_op_token1] = ACTIONS(4112),
    [aux_sym_infix_op_token1] = ACTIONS(4110),
    [aux_sym_infix_op_token2] = ACTIONS(4112),
    [anon_sym_PIPE_PIPE] = ACTIONS(4112),
    [anon_sym_BANG_EQ] = ACTIONS(4112),
    [anon_sym_COLON_EQ] = ACTIONS(4110),
    [anon_sym_DOLLAR] = ACTIONS(4112),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4112),
    [sym_int] = ACTIONS(4112),
    [sym_xint] = ACTIONS(4110),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4110),
    [sym__newline] = ACTIONS(4110),
  },
  [3400] = {
    [sym_block_comment] = STATE(3400),
    [sym_compiler_directive_decl] = STATE(3400),
    [sym_fsi_directive_decl] = STATE(3400),
    [sym_preproc_line] = STATE(3400),
    [sym_identifier] = ACTIONS(4108),
    [anon_sym_EQ] = ACTIONS(4106),
    [anon_sym_COLON] = ACTIONS(4108),
    [anon_sym_return] = ACTIONS(4108),
    [anon_sym_do] = ACTIONS(4108),
    [anon_sym_let] = ACTIONS(4108),
    [anon_sym_let_BANG] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(4108),
    [anon_sym_COMMA] = ACTIONS(4106),
    [anon_sym_null] = ACTIONS(4108),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_COLON] = ACTIONS(4106),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LBRACK] = ACTIONS(4108),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(4108),
    [anon_sym_LT_AT] = ACTIONS(4108),
    [anon_sym_LT_AT_AT] = ACTIONS(4108),
    [anon_sym_AT_AT_GT] = ACTIONS(4108),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4106),
    [anon_sym_new] = ACTIONS(4108),
    [anon_sym_return_BANG] = ACTIONS(4106),
    [anon_sym_yield] = ACTIONS(4108),
    [anon_sym_yield_BANG] = ACTIONS(4106),
    [anon_sym_lazy] = ACTIONS(4108),
    [anon_sym_assert] = ACTIONS(4108),
    [anon_sym_upcast] = ACTIONS(4108),
    [anon_sym_downcast] = ACTIONS(4108),
    [anon_sym_COLON_GT] = ACTIONS(4106),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4106),
    [anon_sym_for] = ACTIONS(4108),
    [anon_sym_while] = ACTIONS(4108),
    [anon_sym_if] = ACTIONS(4108),
    [anon_sym_fun] = ACTIONS(4108),
    [anon_sym_try] = ACTIONS(4108),
    [anon_sym_match] = ACTIONS(4108),
    [anon_sym_match_BANG] = ACTIONS(4106),
    [anon_sym_function] = ACTIONS(4108),
    [anon_sym_LT_DASH] = ACTIONS(4108),
    [anon_sym_DOT_LBRACK] = ACTIONS(4106),
    [anon_sym_LT] = ACTIONS(4106),
    [anon_sym_use] = ACTIONS(4108),
    [anon_sym_use_BANG] = ACTIONS(4106),
    [anon_sym_do_BANG] = ACTIONS(4106),
    [anon_sym_begin] = ACTIONS(4108),
    [anon_sym_LPAREN2] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [aux_sym_char_token1] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4108),
    [anon_sym_DQUOTE] = ACTIONS(4108),
    [anon_sym_AT_DQUOTE] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [sym_bool] = ACTIONS(4108),
    [sym_unit] = ACTIONS(4106),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4108),
    [sym_op_identifier] = ACTIONS(4108),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_PLUS_DOT] = ACTIONS(4108),
    [anon_sym_DASH_DOT] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_AMP_AMP] = ACTIONS(4108),
    [anon_sym_TILDE] = ACTIONS(4106),
    [aux_sym_prefix_op_token1] = ACTIONS(4108),
    [aux_sym_infix_op_token1] = ACTIONS(4106),
    [aux_sym_infix_op_token2] = ACTIONS(4108),
    [anon_sym_PIPE_PIPE] = ACTIONS(4108),
    [anon_sym_BANG_EQ] = ACTIONS(4108),
    [anon_sym_COLON_EQ] = ACTIONS(4106),
    [anon_sym_DOLLAR] = ACTIONS(4108),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4108),
    [sym_int] = ACTIONS(4108),
    [sym_xint] = ACTIONS(4106),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4106),
    [sym__newline] = ACTIONS(4106),
  },
  [3401] = {
    [sym_block_comment] = STATE(3401),
    [sym_compiler_directive_decl] = STATE(3401),
    [sym_fsi_directive_decl] = STATE(3401),
    [sym_preproc_line] = STATE(3401),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_AT_GT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
  },
  [3402] = {
    [sym_block_comment] = STATE(3402),
    [sym_compiler_directive_decl] = STATE(3402),
    [sym_fsi_directive_decl] = STATE(3402),
    [sym_preproc_line] = STATE(3402),
    [sym_identifier] = ACTIONS(3942),
    [anon_sym_EQ] = ACTIONS(3940),
    [anon_sym_COLON] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_let_BANG] = ACTIONS(3940),
    [anon_sym_LPAREN] = ACTIONS(3942),
    [anon_sym_COMMA] = ACTIONS(3940),
    [anon_sym_null] = ACTIONS(3942),
    [anon_sym_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3940),
    [anon_sym_LBRACE] = ACTIONS(3942),
    [anon_sym_LT_AT] = ACTIONS(3942),
    [anon_sym_AT_GT] = ACTIONS(3942),
    [anon_sym_LT_AT_AT] = ACTIONS(3942),
    [anon_sym_DOT] = ACTIONS(3942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3940),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_return_BANG] = ACTIONS(3940),
    [anon_sym_yield] = ACTIONS(3942),
    [anon_sym_yield_BANG] = ACTIONS(3940),
    [anon_sym_lazy] = ACTIONS(3942),
    [anon_sym_assert] = ACTIONS(3942),
    [anon_sym_upcast] = ACTIONS(3942),
    [anon_sym_downcast] = ACTIONS(3942),
    [anon_sym_COLON_GT] = ACTIONS(3940),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3940),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_fun] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_match] = ACTIONS(3942),
    [anon_sym_match_BANG] = ACTIONS(3940),
    [anon_sym_function] = ACTIONS(3942),
    [anon_sym_LT_DASH] = ACTIONS(3942),
    [anon_sym_DOT_LBRACK] = ACTIONS(3940),
    [anon_sym_LT] = ACTIONS(3940),
    [anon_sym_use] = ACTIONS(3942),
    [anon_sym_use_BANG] = ACTIONS(3940),
    [anon_sym_do_BANG] = ACTIONS(3940),
    [anon_sym_begin] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3942),
    [anon_sym_or] = ACTIONS(3942),
    [aux_sym_char_token1] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3942),
    [anon_sym_DQUOTE] = ACTIONS(3942),
    [anon_sym_AT_DQUOTE] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [sym_bool] = ACTIONS(3942),
    [sym_unit] = ACTIONS(3940),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3942),
    [sym_op_identifier] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS_DOT] = ACTIONS(3942),
    [anon_sym_DASH_DOT] = ACTIONS(3942),
    [anon_sym_PERCENT] = ACTIONS(3942),
    [anon_sym_AMP_AMP] = ACTIONS(3942),
    [anon_sym_TILDE] = ACTIONS(3940),
    [aux_sym_prefix_op_token1] = ACTIONS(3942),
    [aux_sym_infix_op_token1] = ACTIONS(3940),
    [aux_sym_infix_op_token2] = ACTIONS(3942),
    [anon_sym_PIPE_PIPE] = ACTIONS(3942),
    [anon_sym_BANG_EQ] = ACTIONS(3942),
    [anon_sym_COLON_EQ] = ACTIONS(3940),
    [anon_sym_DOLLAR] = ACTIONS(3942),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3942),
    [sym_int] = ACTIONS(3942),
    [sym_xint] = ACTIONS(3940),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3940),
    [sym__newline] = ACTIONS(3940),
  },
  [3403] = {
    [sym_block_comment] = STATE(3403),
    [sym_compiler_directive_decl] = STATE(3403),
    [sym_fsi_directive_decl] = STATE(3403),
    [sym_preproc_line] = STATE(3403),
    [sym_identifier] = ACTIONS(3931),
    [anon_sym_EQ] = ACTIONS(3929),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_do] = ACTIONS(3931),
    [anon_sym_let] = ACTIONS(3931),
    [anon_sym_let_BANG] = ACTIONS(3929),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_COMMA] = ACTIONS(3929),
    [anon_sym_null] = ACTIONS(3931),
    [anon_sym_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_COLON] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3931),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_LT_AT] = ACTIONS(3931),
    [anon_sym_AT_GT] = ACTIONS(3931),
    [anon_sym_LT_AT_AT] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3931),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3929),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_return_BANG] = ACTIONS(3929),
    [anon_sym_yield] = ACTIONS(3931),
    [anon_sym_yield_BANG] = ACTIONS(3929),
    [anon_sym_lazy] = ACTIONS(3931),
    [anon_sym_assert] = ACTIONS(3931),
    [anon_sym_upcast] = ACTIONS(3931),
    [anon_sym_downcast] = ACTIONS(3931),
    [anon_sym_COLON_GT] = ACTIONS(3929),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3929),
    [anon_sym_for] = ACTIONS(3931),
    [anon_sym_while] = ACTIONS(3931),
    [anon_sym_if] = ACTIONS(3931),
    [anon_sym_fun] = ACTIONS(3931),
    [anon_sym_try] = ACTIONS(3931),
    [anon_sym_match] = ACTIONS(3931),
    [anon_sym_match_BANG] = ACTIONS(3929),
    [anon_sym_function] = ACTIONS(3931),
    [anon_sym_LT_DASH] = ACTIONS(3931),
    [anon_sym_DOT_LBRACK] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_use] = ACTIONS(3931),
    [anon_sym_use_BANG] = ACTIONS(3929),
    [anon_sym_do_BANG] = ACTIONS(3929),
    [anon_sym_begin] = ACTIONS(3931),
    [anon_sym_LPAREN2] = ACTIONS(3931),
    [anon_sym_or] = ACTIONS(3931),
    [aux_sym_char_token1] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3931),
    [anon_sym_DQUOTE] = ACTIONS(3931),
    [anon_sym_AT_DQUOTE] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [sym_bool] = ACTIONS(3931),
    [sym_unit] = ACTIONS(3929),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3931),
    [sym_op_identifier] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3931),
    [anon_sym_DASH] = ACTIONS(3931),
    [anon_sym_PLUS_DOT] = ACTIONS(3931),
    [anon_sym_DASH_DOT] = ACTIONS(3931),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_TILDE] = ACTIONS(3929),
    [aux_sym_prefix_op_token1] = ACTIONS(3931),
    [aux_sym_infix_op_token1] = ACTIONS(3929),
    [aux_sym_infix_op_token2] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_COLON_EQ] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3931),
    [sym_int] = ACTIONS(3931),
    [sym_xint] = ACTIONS(3929),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3929),
    [sym__newline] = ACTIONS(3929),
  },
  [3404] = {
    [sym_block_comment] = STATE(3404),
    [sym_compiler_directive_decl] = STATE(3404),
    [sym_fsi_directive_decl] = STATE(3404),
    [sym_preproc_line] = STATE(3404),
    [sym_identifier] = ACTIONS(3917),
    [anon_sym_EQ] = ACTIONS(3915),
    [anon_sym_COLON] = ACTIONS(3917),
    [anon_sym_return] = ACTIONS(3917),
    [anon_sym_do] = ACTIONS(3917),
    [anon_sym_let] = ACTIONS(3917),
    [anon_sym_let_BANG] = ACTIONS(3915),
    [anon_sym_LPAREN] = ACTIONS(3917),
    [anon_sym_COMMA] = ACTIONS(3915),
    [anon_sym_null] = ACTIONS(3917),
    [anon_sym_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_COLON] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(3917),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3915),
    [anon_sym_LBRACE] = ACTIONS(3917),
    [anon_sym_LT_AT] = ACTIONS(3917),
    [anon_sym_AT_GT] = ACTIONS(3917),
    [anon_sym_LT_AT_AT] = ACTIONS(3917),
    [anon_sym_DOT] = ACTIONS(3917),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3915),
    [anon_sym_new] = ACTIONS(3917),
    [anon_sym_return_BANG] = ACTIONS(3915),
    [anon_sym_yield] = ACTIONS(3917),
    [anon_sym_yield_BANG] = ACTIONS(3915),
    [anon_sym_lazy] = ACTIONS(3917),
    [anon_sym_assert] = ACTIONS(3917),
    [anon_sym_upcast] = ACTIONS(3917),
    [anon_sym_downcast] = ACTIONS(3917),
    [anon_sym_COLON_GT] = ACTIONS(3915),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3915),
    [anon_sym_for] = ACTIONS(3917),
    [anon_sym_while] = ACTIONS(3917),
    [anon_sym_if] = ACTIONS(3917),
    [anon_sym_fun] = ACTIONS(3917),
    [anon_sym_try] = ACTIONS(3917),
    [anon_sym_match] = ACTIONS(3917),
    [anon_sym_match_BANG] = ACTIONS(3915),
    [anon_sym_function] = ACTIONS(3917),
    [anon_sym_LT_DASH] = ACTIONS(3917),
    [anon_sym_DOT_LBRACK] = ACTIONS(3915),
    [anon_sym_LT] = ACTIONS(3915),
    [anon_sym_use] = ACTIONS(3917),
    [anon_sym_use_BANG] = ACTIONS(3915),
    [anon_sym_do_BANG] = ACTIONS(3915),
    [anon_sym_begin] = ACTIONS(3917),
    [anon_sym_LPAREN2] = ACTIONS(3917),
    [anon_sym_or] = ACTIONS(3917),
    [aux_sym_char_token1] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_AT_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [sym_bool] = ACTIONS(3917),
    [sym_unit] = ACTIONS(3915),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3917),
    [sym_op_identifier] = ACTIONS(3917),
    [anon_sym_PLUS] = ACTIONS(3917),
    [anon_sym_DASH] = ACTIONS(3917),
    [anon_sym_PLUS_DOT] = ACTIONS(3917),
    [anon_sym_DASH_DOT] = ACTIONS(3917),
    [anon_sym_PERCENT] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_TILDE] = ACTIONS(3915),
    [aux_sym_prefix_op_token1] = ACTIONS(3917),
    [aux_sym_infix_op_token1] = ACTIONS(3915),
    [aux_sym_infix_op_token2] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_BANG_EQ] = ACTIONS(3917),
    [anon_sym_COLON_EQ] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3917),
    [sym_int] = ACTIONS(3917),
    [sym_xint] = ACTIONS(3915),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3915),
    [sym__newline] = ACTIONS(3915),
  },
  [3405] = {
    [sym_block_comment] = STATE(3405),
    [sym_compiler_directive_decl] = STATE(3405),
    [sym_fsi_directive_decl] = STATE(3405),
    [sym_preproc_line] = STATE(3405),
    [sym_identifier] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(4091),
    [anon_sym_COLON] = ACTIONS(4093),
    [anon_sym_return] = ACTIONS(4093),
    [anon_sym_do] = ACTIONS(4093),
    [anon_sym_let] = ACTIONS(4093),
    [anon_sym_let_BANG] = ACTIONS(4091),
    [anon_sym_LPAREN] = ACTIONS(4093),
    [anon_sym_COMMA] = ACTIONS(4091),
    [anon_sym_null] = ACTIONS(4093),
    [anon_sym_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_COLON] = ACTIONS(4091),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(4093),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4091),
    [anon_sym_LBRACE] = ACTIONS(4093),
    [anon_sym_LT_AT] = ACTIONS(4093),
    [anon_sym_LT_AT_AT] = ACTIONS(4093),
    [anon_sym_AT_AT_GT] = ACTIONS(4093),
    [anon_sym_DOT] = ACTIONS(4093),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4091),
    [anon_sym_new] = ACTIONS(4093),
    [anon_sym_return_BANG] = ACTIONS(4091),
    [anon_sym_yield] = ACTIONS(4093),
    [anon_sym_yield_BANG] = ACTIONS(4091),
    [anon_sym_lazy] = ACTIONS(4093),
    [anon_sym_assert] = ACTIONS(4093),
    [anon_sym_upcast] = ACTIONS(4093),
    [anon_sym_downcast] = ACTIONS(4093),
    [anon_sym_COLON_GT] = ACTIONS(4091),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4091),
    [anon_sym_for] = ACTIONS(4093),
    [anon_sym_while] = ACTIONS(4093),
    [anon_sym_if] = ACTIONS(4093),
    [anon_sym_fun] = ACTIONS(4093),
    [anon_sym_try] = ACTIONS(4093),
    [anon_sym_match] = ACTIONS(4093),
    [anon_sym_match_BANG] = ACTIONS(4091),
    [anon_sym_function] = ACTIONS(4093),
    [anon_sym_LT_DASH] = ACTIONS(4093),
    [anon_sym_DOT_LBRACK] = ACTIONS(4091),
    [anon_sym_LT] = ACTIONS(4091),
    [anon_sym_use] = ACTIONS(4093),
    [anon_sym_use_BANG] = ACTIONS(4091),
    [anon_sym_do_BANG] = ACTIONS(4091),
    [anon_sym_begin] = ACTIONS(4093),
    [anon_sym_LPAREN2] = ACTIONS(4093),
    [anon_sym_or] = ACTIONS(4093),
    [aux_sym_char_token1] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4093),
    [anon_sym_DQUOTE] = ACTIONS(4093),
    [anon_sym_AT_DQUOTE] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [sym_bool] = ACTIONS(4093),
    [sym_unit] = ACTIONS(4091),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4093),
    [sym_op_identifier] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS_DOT] = ACTIONS(4093),
    [anon_sym_DASH_DOT] = ACTIONS(4093),
    [anon_sym_PERCENT] = ACTIONS(4093),
    [anon_sym_AMP_AMP] = ACTIONS(4093),
    [anon_sym_TILDE] = ACTIONS(4091),
    [aux_sym_prefix_op_token1] = ACTIONS(4093),
    [aux_sym_infix_op_token1] = ACTIONS(4091),
    [aux_sym_infix_op_token2] = ACTIONS(4093),
    [anon_sym_PIPE_PIPE] = ACTIONS(4093),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_COLON_EQ] = ACTIONS(4091),
    [anon_sym_DOLLAR] = ACTIONS(4093),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4093),
    [sym_int] = ACTIONS(4093),
    [sym_xint] = ACTIONS(4091),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4091),
    [sym__newline] = ACTIONS(4091),
  },
  [3406] = {
    [sym_block_comment] = STATE(3406),
    [sym_compiler_directive_decl] = STATE(3406),
    [sym_fsi_directive_decl] = STATE(3406),
    [sym_preproc_line] = STATE(3406),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4072),
    [anon_sym_COLON] = ACTIONS(4074),
    [anon_sym_return] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_let_BANG] = ACTIONS(4072),
    [anon_sym_LPAREN] = ACTIONS(4074),
    [anon_sym_COMMA] = ACTIONS(4072),
    [anon_sym_null] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_COLON] = ACTIONS(4072),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_LT_AT] = ACTIONS(4074),
    [anon_sym_LT_AT_AT] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4072),
    [anon_sym_new] = ACTIONS(4074),
    [anon_sym_return_BANG] = ACTIONS(4072),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_yield_BANG] = ACTIONS(4072),
    [anon_sym_lazy] = ACTIONS(4074),
    [anon_sym_assert] = ACTIONS(4074),
    [anon_sym_upcast] = ACTIONS(4074),
    [anon_sym_downcast] = ACTIONS(4074),
    [anon_sym_COLON_GT] = ACTIONS(4072),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4072),
    [anon_sym_for] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_fun] = ACTIONS(4074),
    [anon_sym_try] = ACTIONS(4074),
    [anon_sym_match] = ACTIONS(4074),
    [anon_sym_match_BANG] = ACTIONS(4072),
    [anon_sym_function] = ACTIONS(4074),
    [anon_sym_LT_DASH] = ACTIONS(4074),
    [anon_sym_DOT_LBRACK] = ACTIONS(4072),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_use] = ACTIONS(4074),
    [anon_sym_use_BANG] = ACTIONS(4072),
    [anon_sym_do_BANG] = ACTIONS(4072),
    [anon_sym_begin] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [aux_sym_char_token1] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4074),
    [anon_sym_DQUOTE] = ACTIONS(4074),
    [anon_sym_AT_DQUOTE] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [sym_bool] = ACTIONS(4074),
    [sym_unit] = ACTIONS(4072),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4074),
    [sym_op_identifier] = ACTIONS(4074),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_PLUS_DOT] = ACTIONS(4074),
    [anon_sym_DASH_DOT] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_TILDE] = ACTIONS(4072),
    [aux_sym_prefix_op_token1] = ACTIONS(4074),
    [aux_sym_infix_op_token1] = ACTIONS(4072),
    [aux_sym_infix_op_token2] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [anon_sym_BANG_EQ] = ACTIONS(4074),
    [anon_sym_COLON_EQ] = ACTIONS(4072),
    [anon_sym_DOLLAR] = ACTIONS(4074),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4074),
    [sym_int] = ACTIONS(4074),
    [sym_xint] = ACTIONS(4072),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4072),
    [sym__newline] = ACTIONS(4072),
  },
  [3407] = {
    [sym_block_comment] = STATE(3407),
    [sym_compiler_directive_decl] = STATE(3407),
    [sym_fsi_directive_decl] = STATE(3407),
    [sym_preproc_line] = STATE(3407),
    [sym_identifier] = ACTIONS(4022),
    [anon_sym_EQ] = ACTIONS(4020),
    [anon_sym_COLON] = ACTIONS(4022),
    [anon_sym_return] = ACTIONS(4022),
    [anon_sym_do] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_let_BANG] = ACTIONS(4020),
    [anon_sym_LPAREN] = ACTIONS(4022),
    [anon_sym_COMMA] = ACTIONS(4020),
    [anon_sym_null] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_COLON] = ACTIONS(4020),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4022),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(4022),
    [anon_sym_LT_AT] = ACTIONS(4022),
    [anon_sym_LT_AT_AT] = ACTIONS(4022),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4020),
    [anon_sym_new] = ACTIONS(4022),
    [anon_sym_return_BANG] = ACTIONS(4020),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_yield_BANG] = ACTIONS(4020),
    [anon_sym_lazy] = ACTIONS(4022),
    [anon_sym_assert] = ACTIONS(4022),
    [anon_sym_upcast] = ACTIONS(4022),
    [anon_sym_downcast] = ACTIONS(4022),
    [anon_sym_COLON_GT] = ACTIONS(4020),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4020),
    [anon_sym_for] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4022),
    [anon_sym_if] = ACTIONS(4022),
    [anon_sym_fun] = ACTIONS(4022),
    [anon_sym_try] = ACTIONS(4022),
    [anon_sym_match] = ACTIONS(4022),
    [anon_sym_match_BANG] = ACTIONS(4020),
    [anon_sym_function] = ACTIONS(4022),
    [anon_sym_LT_DASH] = ACTIONS(4022),
    [anon_sym_DOT_LBRACK] = ACTIONS(4020),
    [anon_sym_LT] = ACTIONS(4020),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_use] = ACTIONS(4022),
    [anon_sym_use_BANG] = ACTIONS(4020),
    [anon_sym_do_BANG] = ACTIONS(4020),
    [anon_sym_begin] = ACTIONS(4022),
    [anon_sym_LPAREN2] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [aux_sym_char_token1] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4022),
    [anon_sym_DQUOTE] = ACTIONS(4022),
    [anon_sym_AT_DQUOTE] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [sym_bool] = ACTIONS(4022),
    [sym_unit] = ACTIONS(4020),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4022),
    [sym_op_identifier] = ACTIONS(4022),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_PLUS_DOT] = ACTIONS(4022),
    [anon_sym_DASH_DOT] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4022),
    [anon_sym_TILDE] = ACTIONS(4020),
    [aux_sym_prefix_op_token1] = ACTIONS(4022),
    [aux_sym_infix_op_token1] = ACTIONS(4020),
    [aux_sym_infix_op_token2] = ACTIONS(4022),
    [anon_sym_PIPE_PIPE] = ACTIONS(4022),
    [anon_sym_BANG_EQ] = ACTIONS(4022),
    [anon_sym_COLON_EQ] = ACTIONS(4020),
    [anon_sym_DOLLAR] = ACTIONS(4022),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4022),
    [sym_int] = ACTIONS(4022),
    [sym_xint] = ACTIONS(4020),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4020),
    [sym__newline] = ACTIONS(4020),
  },
  [3408] = {
    [sym_block_comment] = STATE(3408),
    [sym_compiler_directive_decl] = STATE(3408),
    [sym_fsi_directive_decl] = STATE(3408),
    [sym_preproc_line] = STATE(3408),
    [sym_identifier] = ACTIONS(4086),
    [anon_sym_EQ] = ACTIONS(4084),
    [anon_sym_COLON] = ACTIONS(4086),
    [anon_sym_return] = ACTIONS(4086),
    [anon_sym_do] = ACTIONS(4086),
    [anon_sym_let] = ACTIONS(4086),
    [anon_sym_let_BANG] = ACTIONS(4084),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_COMMA] = ACTIONS(4084),
    [anon_sym_null] = ACTIONS(4086),
    [anon_sym_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_COLON] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4084),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_LT_AT] = ACTIONS(4086),
    [anon_sym_LT_AT_AT] = ACTIONS(4086),
    [anon_sym_AT_AT_GT] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4086),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4084),
    [anon_sym_new] = ACTIONS(4086),
    [anon_sym_return_BANG] = ACTIONS(4084),
    [anon_sym_yield] = ACTIONS(4086),
    [anon_sym_yield_BANG] = ACTIONS(4084),
    [anon_sym_lazy] = ACTIONS(4086),
    [anon_sym_assert] = ACTIONS(4086),
    [anon_sym_upcast] = ACTIONS(4086),
    [anon_sym_downcast] = ACTIONS(4086),
    [anon_sym_COLON_GT] = ACTIONS(4084),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4084),
    [anon_sym_for] = ACTIONS(4086),
    [anon_sym_while] = ACTIONS(4086),
    [anon_sym_if] = ACTIONS(4086),
    [anon_sym_fun] = ACTIONS(4086),
    [anon_sym_try] = ACTIONS(4086),
    [anon_sym_match] = ACTIONS(4086),
    [anon_sym_match_BANG] = ACTIONS(4084),
    [anon_sym_function] = ACTIONS(4086),
    [anon_sym_LT_DASH] = ACTIONS(4086),
    [anon_sym_DOT_LBRACK] = ACTIONS(4084),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_use] = ACTIONS(4086),
    [anon_sym_use_BANG] = ACTIONS(4084),
    [anon_sym_do_BANG] = ACTIONS(4084),
    [anon_sym_begin] = ACTIONS(4086),
    [anon_sym_LPAREN2] = ACTIONS(4086),
    [anon_sym_or] = ACTIONS(4086),
    [aux_sym_char_token1] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4086),
    [anon_sym_DQUOTE] = ACTIONS(4086),
    [anon_sym_AT_DQUOTE] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [sym_bool] = ACTIONS(4086),
    [sym_unit] = ACTIONS(4084),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4086),
    [sym_op_identifier] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4086),
    [anon_sym_DASH] = ACTIONS(4086),
    [anon_sym_PLUS_DOT] = ACTIONS(4086),
    [anon_sym_DASH_DOT] = ACTIONS(4086),
    [anon_sym_PERCENT] = ACTIONS(4086),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_TILDE] = ACTIONS(4084),
    [aux_sym_prefix_op_token1] = ACTIONS(4086),
    [aux_sym_infix_op_token1] = ACTIONS(4084),
    [aux_sym_infix_op_token2] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_COLON_EQ] = ACTIONS(4084),
    [anon_sym_DOLLAR] = ACTIONS(4086),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4086),
    [sym_int] = ACTIONS(4086),
    [sym_xint] = ACTIONS(4084),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4084),
    [sym__newline] = ACTIONS(4084),
  },
  [3409] = {
    [sym_block_comment] = STATE(3409),
    [sym_compiler_directive_decl] = STATE(3409),
    [sym_fsi_directive_decl] = STATE(3409),
    [sym_preproc_line] = STATE(3409),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_COLON] = ACTIONS(4082),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_do] = ACTIONS(4082),
    [anon_sym_let] = ACTIONS(4082),
    [anon_sym_let_BANG] = ACTIONS(4080),
    [anon_sym_LPAREN] = ACTIONS(4082),
    [anon_sym_COMMA] = ACTIONS(4080),
    [anon_sym_null] = ACTIONS(4082),
    [anon_sym_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_COLON] = ACTIONS(4080),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_LBRACK] = ACTIONS(4082),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(4082),
    [anon_sym_LT_AT] = ACTIONS(4082),
    [anon_sym_LT_AT_AT] = ACTIONS(4082),
    [anon_sym_AT_AT_GT] = ACTIONS(4082),
    [anon_sym_DOT] = ACTIONS(4082),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4080),
    [anon_sym_new] = ACTIONS(4082),
    [anon_sym_return_BANG] = ACTIONS(4080),
    [anon_sym_yield] = ACTIONS(4082),
    [anon_sym_yield_BANG] = ACTIONS(4080),
    [anon_sym_lazy] = ACTIONS(4082),
    [anon_sym_assert] = ACTIONS(4082),
    [anon_sym_upcast] = ACTIONS(4082),
    [anon_sym_downcast] = ACTIONS(4082),
    [anon_sym_COLON_GT] = ACTIONS(4080),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4080),
    [anon_sym_for] = ACTIONS(4082),
    [anon_sym_while] = ACTIONS(4082),
    [anon_sym_if] = ACTIONS(4082),
    [anon_sym_fun] = ACTIONS(4082),
    [anon_sym_try] = ACTIONS(4082),
    [anon_sym_match] = ACTIONS(4082),
    [anon_sym_match_BANG] = ACTIONS(4080),
    [anon_sym_function] = ACTIONS(4082),
    [anon_sym_LT_DASH] = ACTIONS(4082),
    [anon_sym_DOT_LBRACK] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(4080),
    [anon_sym_use] = ACTIONS(4082),
    [anon_sym_use_BANG] = ACTIONS(4080),
    [anon_sym_do_BANG] = ACTIONS(4080),
    [anon_sym_begin] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4082),
    [anon_sym_or] = ACTIONS(4082),
    [aux_sym_char_token1] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4082),
    [anon_sym_DQUOTE] = ACTIONS(4082),
    [anon_sym_AT_DQUOTE] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [sym_bool] = ACTIONS(4082),
    [sym_unit] = ACTIONS(4080),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4082),
    [sym_op_identifier] = ACTIONS(4082),
    [anon_sym_PLUS] = ACTIONS(4082),
    [anon_sym_DASH] = ACTIONS(4082),
    [anon_sym_PLUS_DOT] = ACTIONS(4082),
    [anon_sym_DASH_DOT] = ACTIONS(4082),
    [anon_sym_PERCENT] = ACTIONS(4082),
    [anon_sym_AMP_AMP] = ACTIONS(4082),
    [anon_sym_TILDE] = ACTIONS(4080),
    [aux_sym_prefix_op_token1] = ACTIONS(4082),
    [aux_sym_infix_op_token1] = ACTIONS(4080),
    [aux_sym_infix_op_token2] = ACTIONS(4082),
    [anon_sym_PIPE_PIPE] = ACTIONS(4082),
    [anon_sym_BANG_EQ] = ACTIONS(4082),
    [anon_sym_COLON_EQ] = ACTIONS(4080),
    [anon_sym_DOLLAR] = ACTIONS(4082),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4082),
    [sym_int] = ACTIONS(4082),
    [sym_xint] = ACTIONS(4080),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4080),
    [sym__newline] = ACTIONS(4080),
  },
  [3410] = {
    [sym_block_comment] = STATE(3410),
    [sym_compiler_directive_decl] = STATE(3410),
    [sym_fsi_directive_decl] = STATE(3410),
    [sym_preproc_line] = STATE(3410),
    [sym_identifier] = ACTIONS(4011),
    [anon_sym_EQ] = ACTIONS(4009),
    [anon_sym_COLON] = ACTIONS(4011),
    [anon_sym_return] = ACTIONS(4011),
    [anon_sym_do] = ACTIONS(4011),
    [anon_sym_let] = ACTIONS(4011),
    [anon_sym_let_BANG] = ACTIONS(4009),
    [anon_sym_LPAREN] = ACTIONS(4011),
    [anon_sym_COMMA] = ACTIONS(4009),
    [anon_sym_null] = ACTIONS(4011),
    [anon_sym_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(4011),
    [anon_sym_LBRACK] = ACTIONS(4011),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4009),
    [anon_sym_LBRACE] = ACTIONS(4011),
    [anon_sym_LT_AT] = ACTIONS(4011),
    [anon_sym_LT_AT_AT] = ACTIONS(4011),
    [anon_sym_DOT] = ACTIONS(4011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4009),
    [anon_sym_new] = ACTIONS(4011),
    [anon_sym_return_BANG] = ACTIONS(4009),
    [anon_sym_yield] = ACTIONS(4011),
    [anon_sym_yield_BANG] = ACTIONS(4009),
    [anon_sym_lazy] = ACTIONS(4011),
    [anon_sym_assert] = ACTIONS(4011),
    [anon_sym_upcast] = ACTIONS(4011),
    [anon_sym_downcast] = ACTIONS(4011),
    [anon_sym_COLON_GT] = ACTIONS(4009),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4009),
    [anon_sym_for] = ACTIONS(4011),
    [anon_sym_while] = ACTIONS(4011),
    [anon_sym_if] = ACTIONS(4011),
    [anon_sym_fun] = ACTIONS(4011),
    [anon_sym_try] = ACTIONS(4011),
    [anon_sym_match] = ACTIONS(4011),
    [anon_sym_match_BANG] = ACTIONS(4009),
    [anon_sym_function] = ACTIONS(4011),
    [anon_sym_LT_DASH] = ACTIONS(4011),
    [anon_sym_DOT_LBRACK] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(4009),
    [anon_sym_GT] = ACTIONS(4011),
    [anon_sym_use] = ACTIONS(4011),
    [anon_sym_use_BANG] = ACTIONS(4009),
    [anon_sym_do_BANG] = ACTIONS(4009),
    [anon_sym_begin] = ACTIONS(4011),
    [anon_sym_LPAREN2] = ACTIONS(4011),
    [anon_sym_or] = ACTIONS(4011),
    [aux_sym_char_token1] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4011),
    [anon_sym_DQUOTE] = ACTIONS(4011),
    [anon_sym_AT_DQUOTE] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [sym_bool] = ACTIONS(4011),
    [sym_unit] = ACTIONS(4009),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4011),
    [sym_op_identifier] = ACTIONS(4011),
    [anon_sym_PLUS] = ACTIONS(4011),
    [anon_sym_DASH] = ACTIONS(4011),
    [anon_sym_PLUS_DOT] = ACTIONS(4011),
    [anon_sym_DASH_DOT] = ACTIONS(4011),
    [anon_sym_PERCENT] = ACTIONS(4011),
    [anon_sym_AMP_AMP] = ACTIONS(4011),
    [anon_sym_TILDE] = ACTIONS(4009),
    [aux_sym_prefix_op_token1] = ACTIONS(4011),
    [aux_sym_infix_op_token1] = ACTIONS(4009),
    [aux_sym_infix_op_token2] = ACTIONS(4011),
    [anon_sym_PIPE_PIPE] = ACTIONS(4011),
    [anon_sym_BANG_EQ] = ACTIONS(4011),
    [anon_sym_COLON_EQ] = ACTIONS(4009),
    [anon_sym_DOLLAR] = ACTIONS(4011),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4011),
    [sym_int] = ACTIONS(4011),
    [sym_xint] = ACTIONS(4009),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4009),
    [sym__newline] = ACTIONS(4009),
  },
  [3411] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(6319),
    [sym_function_declaration_left] = STATE(9899),
    [sym_value_declaration_left] = STATE(9899),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3411),
    [sym_compiler_directive_decl] = STATE(3411),
    [sym_fsi_directive_decl] = STATE(3411),
    [sym_preproc_line] = STATE(3411),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_rec] = ACTIONS(5913),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3412] = {
    [sym_block_comment] = STATE(3412),
    [sym_compiler_directive_decl] = STATE(3412),
    [sym_fsi_directive_decl] = STATE(3412),
    [sym_preproc_line] = STATE(3412),
    [sym_identifier] = ACTIONS(4007),
    [anon_sym_EQ] = ACTIONS(4005),
    [anon_sym_COLON] = ACTIONS(4007),
    [anon_sym_return] = ACTIONS(4007),
    [anon_sym_do] = ACTIONS(4007),
    [anon_sym_let] = ACTIONS(4007),
    [anon_sym_let_BANG] = ACTIONS(4005),
    [anon_sym_LPAREN] = ACTIONS(4007),
    [anon_sym_COMMA] = ACTIONS(4005),
    [anon_sym_null] = ACTIONS(4007),
    [anon_sym_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_COLON] = ACTIONS(4005),
    [anon_sym_AMP] = ACTIONS(4007),
    [anon_sym_LBRACK] = ACTIONS(4007),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4005),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_LT_AT] = ACTIONS(4007),
    [anon_sym_LT_AT_AT] = ACTIONS(4007),
    [anon_sym_DOT] = ACTIONS(4007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4005),
    [anon_sym_new] = ACTIONS(4007),
    [anon_sym_return_BANG] = ACTIONS(4005),
    [anon_sym_yield] = ACTIONS(4007),
    [anon_sym_yield_BANG] = ACTIONS(4005),
    [anon_sym_lazy] = ACTIONS(4007),
    [anon_sym_assert] = ACTIONS(4007),
    [anon_sym_upcast] = ACTIONS(4007),
    [anon_sym_downcast] = ACTIONS(4007),
    [anon_sym_COLON_GT] = ACTIONS(4005),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4005),
    [anon_sym_for] = ACTIONS(4007),
    [anon_sym_while] = ACTIONS(4007),
    [anon_sym_if] = ACTIONS(4007),
    [anon_sym_fun] = ACTIONS(4007),
    [anon_sym_try] = ACTIONS(4007),
    [anon_sym_match] = ACTIONS(4007),
    [anon_sym_match_BANG] = ACTIONS(4005),
    [anon_sym_function] = ACTIONS(4007),
    [anon_sym_LT_DASH] = ACTIONS(4007),
    [anon_sym_DOT_LBRACK] = ACTIONS(4005),
    [anon_sym_LT] = ACTIONS(4005),
    [anon_sym_GT] = ACTIONS(4007),
    [anon_sym_use] = ACTIONS(4007),
    [anon_sym_use_BANG] = ACTIONS(4005),
    [anon_sym_do_BANG] = ACTIONS(4005),
    [anon_sym_begin] = ACTIONS(4007),
    [anon_sym_LPAREN2] = ACTIONS(4007),
    [anon_sym_or] = ACTIONS(4007),
    [aux_sym_char_token1] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4007),
    [anon_sym_DQUOTE] = ACTIONS(4007),
    [anon_sym_AT_DQUOTE] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [sym_bool] = ACTIONS(4007),
    [sym_unit] = ACTIONS(4005),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4007),
    [sym_op_identifier] = ACTIONS(4007),
    [anon_sym_PLUS] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4007),
    [anon_sym_PLUS_DOT] = ACTIONS(4007),
    [anon_sym_DASH_DOT] = ACTIONS(4007),
    [anon_sym_PERCENT] = ACTIONS(4007),
    [anon_sym_AMP_AMP] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4005),
    [aux_sym_prefix_op_token1] = ACTIONS(4007),
    [aux_sym_infix_op_token1] = ACTIONS(4005),
    [aux_sym_infix_op_token2] = ACTIONS(4007),
    [anon_sym_PIPE_PIPE] = ACTIONS(4007),
    [anon_sym_BANG_EQ] = ACTIONS(4007),
    [anon_sym_COLON_EQ] = ACTIONS(4005),
    [anon_sym_DOLLAR] = ACTIONS(4007),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4007),
    [sym_int] = ACTIONS(4007),
    [sym_xint] = ACTIONS(4005),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4005),
    [sym__newline] = ACTIONS(4005),
  },
  [3413] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(4259),
    [sym_function_declaration_left] = STATE(9977),
    [sym_value_declaration_left] = STATE(9977),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3413),
    [sym_compiler_directive_decl] = STATE(3413),
    [sym_fsi_directive_decl] = STATE(3413),
    [sym_preproc_line] = STATE(3413),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_rec] = ACTIONS(5915),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3414] = {
    [sym_block_comment] = STATE(3414),
    [sym_compiler_directive_decl] = STATE(3414),
    [sym_fsi_directive_decl] = STATE(3414),
    [sym_preproc_line] = STATE(3414),
    [sym_identifier] = ACTIONS(4054),
    [anon_sym_EQ] = ACTIONS(4052),
    [anon_sym_COLON] = ACTIONS(4054),
    [anon_sym_return] = ACTIONS(4054),
    [anon_sym_do] = ACTIONS(4054),
    [anon_sym_let] = ACTIONS(4054),
    [anon_sym_let_BANG] = ACTIONS(4052),
    [anon_sym_LPAREN] = ACTIONS(4054),
    [anon_sym_COMMA] = ACTIONS(4052),
    [anon_sym_null] = ACTIONS(4054),
    [anon_sym_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_COLON] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(4054),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4052),
    [anon_sym_LBRACE] = ACTIONS(4054),
    [anon_sym_LT_AT] = ACTIONS(4054),
    [anon_sym_LT_AT_AT] = ACTIONS(4054),
    [anon_sym_AT_AT_GT] = ACTIONS(4054),
    [anon_sym_DOT] = ACTIONS(4054),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_return_BANG] = ACTIONS(4052),
    [anon_sym_yield] = ACTIONS(4054),
    [anon_sym_yield_BANG] = ACTIONS(4052),
    [anon_sym_lazy] = ACTIONS(4054),
    [anon_sym_assert] = ACTIONS(4054),
    [anon_sym_upcast] = ACTIONS(4054),
    [anon_sym_downcast] = ACTIONS(4054),
    [anon_sym_COLON_GT] = ACTIONS(4052),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4052),
    [anon_sym_for] = ACTIONS(4054),
    [anon_sym_while] = ACTIONS(4054),
    [anon_sym_if] = ACTIONS(4054),
    [anon_sym_fun] = ACTIONS(4054),
    [anon_sym_try] = ACTIONS(4054),
    [anon_sym_match] = ACTIONS(4054),
    [anon_sym_match_BANG] = ACTIONS(4052),
    [anon_sym_function] = ACTIONS(4054),
    [anon_sym_LT_DASH] = ACTIONS(4054),
    [anon_sym_DOT_LBRACK] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_use] = ACTIONS(4054),
    [anon_sym_use_BANG] = ACTIONS(4052),
    [anon_sym_do_BANG] = ACTIONS(4052),
    [anon_sym_begin] = ACTIONS(4054),
    [anon_sym_LPAREN2] = ACTIONS(4054),
    [anon_sym_or] = ACTIONS(4054),
    [aux_sym_char_token1] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4054),
    [anon_sym_DQUOTE] = ACTIONS(4054),
    [anon_sym_AT_DQUOTE] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [sym_bool] = ACTIONS(4054),
    [sym_unit] = ACTIONS(4052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4054),
    [sym_op_identifier] = ACTIONS(4054),
    [anon_sym_PLUS] = ACTIONS(4054),
    [anon_sym_DASH] = ACTIONS(4054),
    [anon_sym_PLUS_DOT] = ACTIONS(4054),
    [anon_sym_DASH_DOT] = ACTIONS(4054),
    [anon_sym_PERCENT] = ACTIONS(4054),
    [anon_sym_AMP_AMP] = ACTIONS(4054),
    [anon_sym_TILDE] = ACTIONS(4052),
    [aux_sym_prefix_op_token1] = ACTIONS(4054),
    [aux_sym_infix_op_token1] = ACTIONS(4052),
    [aux_sym_infix_op_token2] = ACTIONS(4054),
    [anon_sym_PIPE_PIPE] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4054),
    [anon_sym_COLON_EQ] = ACTIONS(4052),
    [anon_sym_DOLLAR] = ACTIONS(4054),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4054),
    [sym_int] = ACTIONS(4054),
    [sym_xint] = ACTIONS(4052),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4052),
    [sym__newline] = ACTIONS(4052),
  },
  [3415] = {
    [sym_block_comment] = STATE(3415),
    [sym_compiler_directive_decl] = STATE(3415),
    [sym_fsi_directive_decl] = STATE(3415),
    [sym_preproc_line] = STATE(3415),
    [sym_identifier] = ACTIONS(4018),
    [anon_sym_EQ] = ACTIONS(4016),
    [anon_sym_COLON] = ACTIONS(4018),
    [anon_sym_return] = ACTIONS(4018),
    [anon_sym_do] = ACTIONS(4018),
    [anon_sym_let] = ACTIONS(4018),
    [anon_sym_let_BANG] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(4018),
    [anon_sym_COMMA] = ACTIONS(4016),
    [anon_sym_null] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_COLON] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4018),
    [anon_sym_LBRACK] = ACTIONS(4018),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4016),
    [anon_sym_LBRACE] = ACTIONS(4018),
    [anon_sym_LT_AT] = ACTIONS(4018),
    [anon_sym_LT_AT_AT] = ACTIONS(4018),
    [anon_sym_AT_AT_GT] = ACTIONS(4018),
    [anon_sym_DOT] = ACTIONS(4018),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4016),
    [anon_sym_new] = ACTIONS(4018),
    [anon_sym_return_BANG] = ACTIONS(4016),
    [anon_sym_yield] = ACTIONS(4018),
    [anon_sym_yield_BANG] = ACTIONS(4016),
    [anon_sym_lazy] = ACTIONS(4018),
    [anon_sym_assert] = ACTIONS(4018),
    [anon_sym_upcast] = ACTIONS(4018),
    [anon_sym_downcast] = ACTIONS(4018),
    [anon_sym_COLON_GT] = ACTIONS(4016),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4016),
    [anon_sym_for] = ACTIONS(4018),
    [anon_sym_while] = ACTIONS(4018),
    [anon_sym_if] = ACTIONS(4018),
    [anon_sym_fun] = ACTIONS(4018),
    [anon_sym_try] = ACTIONS(4018),
    [anon_sym_match] = ACTIONS(4018),
    [anon_sym_match_BANG] = ACTIONS(4016),
    [anon_sym_function] = ACTIONS(4018),
    [anon_sym_LT_DASH] = ACTIONS(4018),
    [anon_sym_DOT_LBRACK] = ACTIONS(4016),
    [anon_sym_LT] = ACTIONS(4016),
    [anon_sym_use] = ACTIONS(4018),
    [anon_sym_use_BANG] = ACTIONS(4016),
    [anon_sym_do_BANG] = ACTIONS(4016),
    [anon_sym_begin] = ACTIONS(4018),
    [anon_sym_LPAREN2] = ACTIONS(4018),
    [anon_sym_or] = ACTIONS(4018),
    [aux_sym_char_token1] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(4018),
    [anon_sym_AT_DQUOTE] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [sym_bool] = ACTIONS(4018),
    [sym_unit] = ACTIONS(4016),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4018),
    [sym_op_identifier] = ACTIONS(4018),
    [anon_sym_PLUS] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_PLUS_DOT] = ACTIONS(4018),
    [anon_sym_DASH_DOT] = ACTIONS(4018),
    [anon_sym_PERCENT] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4016),
    [aux_sym_prefix_op_token1] = ACTIONS(4018),
    [aux_sym_infix_op_token1] = ACTIONS(4016),
    [aux_sym_infix_op_token2] = ACTIONS(4018),
    [anon_sym_PIPE_PIPE] = ACTIONS(4018),
    [anon_sym_BANG_EQ] = ACTIONS(4018),
    [anon_sym_COLON_EQ] = ACTIONS(4016),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4018),
    [sym_int] = ACTIONS(4018),
    [sym_xint] = ACTIONS(4016),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4016),
    [sym__newline] = ACTIONS(4016),
  },
  [3416] = {
    [sym_block_comment] = STATE(3416),
    [sym_compiler_directive_decl] = STATE(3416),
    [sym_fsi_directive_decl] = STATE(3416),
    [sym_preproc_line] = STATE(3416),
    [sym_identifier] = ACTIONS(4224),
    [anon_sym_EQ] = ACTIONS(4222),
    [anon_sym_COLON] = ACTIONS(4224),
    [anon_sym_return] = ACTIONS(4224),
    [anon_sym_do] = ACTIONS(4224),
    [anon_sym_let] = ACTIONS(4224),
    [anon_sym_let_BANG] = ACTIONS(4222),
    [anon_sym_LPAREN] = ACTIONS(4224),
    [anon_sym_COMMA] = ACTIONS(4222),
    [anon_sym_null] = ACTIONS(4224),
    [anon_sym_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_COLON] = ACTIONS(4222),
    [anon_sym_AMP] = ACTIONS(4224),
    [anon_sym_LBRACK] = ACTIONS(4224),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4222),
    [anon_sym_LBRACE] = ACTIONS(4224),
    [anon_sym_LT_AT] = ACTIONS(4224),
    [anon_sym_LT_AT_AT] = ACTIONS(4224),
    [anon_sym_DOT] = ACTIONS(4224),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4222),
    [anon_sym_new] = ACTIONS(4224),
    [anon_sym_return_BANG] = ACTIONS(4222),
    [anon_sym_yield] = ACTIONS(4224),
    [anon_sym_yield_BANG] = ACTIONS(4222),
    [anon_sym_lazy] = ACTIONS(4224),
    [anon_sym_assert] = ACTIONS(4224),
    [anon_sym_upcast] = ACTIONS(4224),
    [anon_sym_downcast] = ACTIONS(4224),
    [anon_sym_COLON_GT] = ACTIONS(4222),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4222),
    [anon_sym_for] = ACTIONS(4224),
    [anon_sym_while] = ACTIONS(4224),
    [anon_sym_if] = ACTIONS(4224),
    [anon_sym_fun] = ACTIONS(4224),
    [anon_sym_try] = ACTIONS(4224),
    [anon_sym_match] = ACTIONS(4224),
    [anon_sym_match_BANG] = ACTIONS(4222),
    [anon_sym_function] = ACTIONS(4224),
    [anon_sym_LT_DASH] = ACTIONS(4224),
    [anon_sym_DOT_LBRACK] = ACTIONS(4222),
    [anon_sym_LT] = ACTIONS(4222),
    [anon_sym_use] = ACTIONS(4224),
    [anon_sym_use_BANG] = ACTIONS(4222),
    [anon_sym_do_BANG] = ACTIONS(4222),
    [anon_sym_DOT_DOT] = ACTIONS(4222),
    [anon_sym_begin] = ACTIONS(4224),
    [anon_sym_LPAREN2] = ACTIONS(4224),
    [anon_sym_or] = ACTIONS(4224),
    [aux_sym_char_token1] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4224),
    [anon_sym_DQUOTE] = ACTIONS(4224),
    [anon_sym_AT_DQUOTE] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [sym_bool] = ACTIONS(4224),
    [sym_unit] = ACTIONS(4222),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4224),
    [sym_op_identifier] = ACTIONS(4224),
    [anon_sym_PLUS] = ACTIONS(4224),
    [anon_sym_DASH] = ACTIONS(4224),
    [anon_sym_PLUS_DOT] = ACTIONS(4224),
    [anon_sym_DASH_DOT] = ACTIONS(4224),
    [anon_sym_PERCENT] = ACTIONS(4224),
    [anon_sym_AMP_AMP] = ACTIONS(4224),
    [anon_sym_TILDE] = ACTIONS(4222),
    [aux_sym_prefix_op_token1] = ACTIONS(4224),
    [aux_sym_infix_op_token1] = ACTIONS(4222),
    [aux_sym_infix_op_token2] = ACTIONS(4224),
    [anon_sym_PIPE_PIPE] = ACTIONS(4224),
    [anon_sym_BANG_EQ] = ACTIONS(4224),
    [anon_sym_COLON_EQ] = ACTIONS(4222),
    [anon_sym_DOLLAR] = ACTIONS(4224),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4224),
    [sym_int] = ACTIONS(4224),
    [sym_xint] = ACTIONS(4222),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4222),
    [sym__newline] = ACTIONS(4222),
  },
  [3417] = {
    [sym_block_comment] = STATE(3417),
    [sym_compiler_directive_decl] = STATE(3417),
    [sym_fsi_directive_decl] = STATE(3417),
    [sym_preproc_line] = STATE(3417),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3843),
    [anon_sym_COLON] = ACTIONS(3845),
    [anon_sym_return] = ACTIONS(3845),
    [anon_sym_do] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_let_BANG] = ACTIONS(3843),
    [anon_sym_LPAREN] = ACTIONS(3845),
    [anon_sym_COMMA] = ACTIONS(3843),
    [anon_sym_null] = ACTIONS(3845),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3843),
    [anon_sym_LBRACE] = ACTIONS(3845),
    [anon_sym_LT_AT] = ACTIONS(3845),
    [anon_sym_LT_AT_AT] = ACTIONS(3845),
    [anon_sym_AT_AT_GT] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3843),
    [anon_sym_new] = ACTIONS(3845),
    [anon_sym_return_BANG] = ACTIONS(3843),
    [anon_sym_yield] = ACTIONS(3845),
    [anon_sym_yield_BANG] = ACTIONS(3843),
    [anon_sym_lazy] = ACTIONS(3845),
    [anon_sym_assert] = ACTIONS(3845),
    [anon_sym_upcast] = ACTIONS(3845),
    [anon_sym_downcast] = ACTIONS(3845),
    [anon_sym_COLON_GT] = ACTIONS(3843),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3843),
    [anon_sym_for] = ACTIONS(3845),
    [anon_sym_while] = ACTIONS(3845),
    [anon_sym_if] = ACTIONS(3845),
    [anon_sym_fun] = ACTIONS(3845),
    [anon_sym_try] = ACTIONS(3845),
    [anon_sym_match] = ACTIONS(3845),
    [anon_sym_match_BANG] = ACTIONS(3843),
    [anon_sym_function] = ACTIONS(3845),
    [anon_sym_LT_DASH] = ACTIONS(3845),
    [anon_sym_DOT_LBRACK] = ACTIONS(3843),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_use] = ACTIONS(3845),
    [anon_sym_use_BANG] = ACTIONS(3843),
    [anon_sym_do_BANG] = ACTIONS(3843),
    [anon_sym_begin] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(3845),
    [anon_sym_or] = ACTIONS(3845),
    [aux_sym_char_token1] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3845),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_AT_DQUOTE] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [sym_bool] = ACTIONS(3845),
    [sym_unit] = ACTIONS(3843),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3845),
    [sym_op_identifier] = ACTIONS(3845),
    [anon_sym_PLUS] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_PLUS_DOT] = ACTIONS(3845),
    [anon_sym_DASH_DOT] = ACTIONS(3845),
    [anon_sym_PERCENT] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3845),
    [anon_sym_TILDE] = ACTIONS(3843),
    [aux_sym_prefix_op_token1] = ACTIONS(3845),
    [aux_sym_infix_op_token1] = ACTIONS(3843),
    [aux_sym_infix_op_token2] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(3845),
    [anon_sym_BANG_EQ] = ACTIONS(3845),
    [anon_sym_COLON_EQ] = ACTIONS(3843),
    [anon_sym_DOLLAR] = ACTIONS(3845),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3845),
    [sym_int] = ACTIONS(3845),
    [sym_xint] = ACTIONS(3843),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3843),
    [sym__newline] = ACTIONS(3843),
  },
  [3418] = {
    [sym_block_comment] = STATE(3418),
    [sym_compiler_directive_decl] = STATE(3418),
    [sym_fsi_directive_decl] = STATE(3418),
    [sym_preproc_line] = STATE(3418),
    [sym_identifier] = ACTIONS(4220),
    [anon_sym_EQ] = ACTIONS(4218),
    [anon_sym_COLON] = ACTIONS(4220),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_do] = ACTIONS(4220),
    [anon_sym_let] = ACTIONS(4220),
    [anon_sym_let_BANG] = ACTIONS(4218),
    [anon_sym_LPAREN] = ACTIONS(4220),
    [anon_sym_COMMA] = ACTIONS(4218),
    [anon_sym_null] = ACTIONS(4220),
    [anon_sym_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_COLON] = ACTIONS(4218),
    [anon_sym_AMP] = ACTIONS(4220),
    [anon_sym_LBRACK] = ACTIONS(4220),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(4220),
    [anon_sym_LT_AT] = ACTIONS(4220),
    [anon_sym_AT_GT] = ACTIONS(4220),
    [anon_sym_LT_AT_AT] = ACTIONS(4220),
    [anon_sym_DOT] = ACTIONS(4220),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4218),
    [anon_sym_new] = ACTIONS(4220),
    [anon_sym_return_BANG] = ACTIONS(4218),
    [anon_sym_yield] = ACTIONS(4220),
    [anon_sym_yield_BANG] = ACTIONS(4218),
    [anon_sym_lazy] = ACTIONS(4220),
    [anon_sym_assert] = ACTIONS(4220),
    [anon_sym_upcast] = ACTIONS(4220),
    [anon_sym_downcast] = ACTIONS(4220),
    [anon_sym_COLON_GT] = ACTIONS(4218),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4218),
    [anon_sym_for] = ACTIONS(4220),
    [anon_sym_while] = ACTIONS(4220),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_fun] = ACTIONS(4220),
    [anon_sym_try] = ACTIONS(4220),
    [anon_sym_match] = ACTIONS(4220),
    [anon_sym_match_BANG] = ACTIONS(4218),
    [anon_sym_function] = ACTIONS(4220),
    [anon_sym_LT_DASH] = ACTIONS(4220),
    [anon_sym_DOT_LBRACK] = ACTIONS(4218),
    [anon_sym_LT] = ACTIONS(4218),
    [anon_sym_use] = ACTIONS(4220),
    [anon_sym_use_BANG] = ACTIONS(4218),
    [anon_sym_do_BANG] = ACTIONS(4218),
    [anon_sym_begin] = ACTIONS(4220),
    [anon_sym_LPAREN2] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(4220),
    [aux_sym_char_token1] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4220),
    [anon_sym_DQUOTE] = ACTIONS(4220),
    [anon_sym_AT_DQUOTE] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [sym_bool] = ACTIONS(4220),
    [sym_unit] = ACTIONS(4218),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4220),
    [sym_op_identifier] = ACTIONS(4220),
    [anon_sym_PLUS] = ACTIONS(4220),
    [anon_sym_DASH] = ACTIONS(4220),
    [anon_sym_PLUS_DOT] = ACTIONS(4220),
    [anon_sym_DASH_DOT] = ACTIONS(4220),
    [anon_sym_PERCENT] = ACTIONS(4220),
    [anon_sym_AMP_AMP] = ACTIONS(4220),
    [anon_sym_TILDE] = ACTIONS(4218),
    [aux_sym_prefix_op_token1] = ACTIONS(4220),
    [aux_sym_infix_op_token1] = ACTIONS(4218),
    [aux_sym_infix_op_token2] = ACTIONS(4220),
    [anon_sym_PIPE_PIPE] = ACTIONS(4220),
    [anon_sym_BANG_EQ] = ACTIONS(4220),
    [anon_sym_COLON_EQ] = ACTIONS(4218),
    [anon_sym_DOLLAR] = ACTIONS(4220),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4220),
    [sym_int] = ACTIONS(4220),
    [sym_xint] = ACTIONS(4218),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4218),
    [sym__newline] = ACTIONS(4218),
  },
  [3419] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defns] = STATE(6390),
    [sym__function_or_value_defn_body] = STATE(6198),
    [sym_function_declaration_left] = STATE(10056),
    [sym_value_declaration_left] = STATE(10056),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3419),
    [sym_compiler_directive_decl] = STATE(3419),
    [sym_fsi_directive_decl] = STATE(3419),
    [sym_preproc_line] = STATE(3419),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3420] = {
    [sym_block_comment] = STATE(3420),
    [sym_compiler_directive_decl] = STATE(3420),
    [sym_fsi_directive_decl] = STATE(3420),
    [sym_preproc_line] = STATE(3420),
    [sym_identifier] = ACTIONS(3881),
    [anon_sym_EQ] = ACTIONS(3879),
    [anon_sym_COLON] = ACTIONS(3881),
    [anon_sym_return] = ACTIONS(3881),
    [anon_sym_do] = ACTIONS(3881),
    [anon_sym_let] = ACTIONS(3881),
    [anon_sym_let_BANG] = ACTIONS(3879),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3879),
    [anon_sym_null] = ACTIONS(3881),
    [anon_sym_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3879),
    [anon_sym_LBRACE] = ACTIONS(3881),
    [anon_sym_LT_AT] = ACTIONS(3881),
    [anon_sym_AT_GT] = ACTIONS(3881),
    [anon_sym_LT_AT_AT] = ACTIONS(3881),
    [anon_sym_DOT] = ACTIONS(3881),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3879),
    [anon_sym_new] = ACTIONS(3881),
    [anon_sym_return_BANG] = ACTIONS(3879),
    [anon_sym_yield] = ACTIONS(3881),
    [anon_sym_yield_BANG] = ACTIONS(3879),
    [anon_sym_lazy] = ACTIONS(3881),
    [anon_sym_assert] = ACTIONS(3881),
    [anon_sym_upcast] = ACTIONS(3881),
    [anon_sym_downcast] = ACTIONS(3881),
    [anon_sym_COLON_GT] = ACTIONS(3879),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3879),
    [anon_sym_for] = ACTIONS(3881),
    [anon_sym_while] = ACTIONS(3881),
    [anon_sym_if] = ACTIONS(3881),
    [anon_sym_fun] = ACTIONS(3881),
    [anon_sym_try] = ACTIONS(3881),
    [anon_sym_match] = ACTIONS(3881),
    [anon_sym_match_BANG] = ACTIONS(3879),
    [anon_sym_function] = ACTIONS(3881),
    [anon_sym_LT_DASH] = ACTIONS(3881),
    [anon_sym_DOT_LBRACK] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_use] = ACTIONS(3881),
    [anon_sym_use_BANG] = ACTIONS(3879),
    [anon_sym_do_BANG] = ACTIONS(3879),
    [anon_sym_begin] = ACTIONS(3881),
    [anon_sym_LPAREN2] = ACTIONS(3881),
    [anon_sym_or] = ACTIONS(3881),
    [aux_sym_char_token1] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3881),
    [anon_sym_DQUOTE] = ACTIONS(3881),
    [anon_sym_AT_DQUOTE] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [sym_bool] = ACTIONS(3881),
    [sym_unit] = ACTIONS(3879),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3881),
    [sym_op_identifier] = ACTIONS(3881),
    [anon_sym_PLUS] = ACTIONS(3881),
    [anon_sym_DASH] = ACTIONS(3881),
    [anon_sym_PLUS_DOT] = ACTIONS(3881),
    [anon_sym_DASH_DOT] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(3881),
    [anon_sym_AMP_AMP] = ACTIONS(3881),
    [anon_sym_TILDE] = ACTIONS(3879),
    [aux_sym_prefix_op_token1] = ACTIONS(3881),
    [aux_sym_infix_op_token1] = ACTIONS(3879),
    [aux_sym_infix_op_token2] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE] = ACTIONS(3881),
    [anon_sym_BANG_EQ] = ACTIONS(3881),
    [anon_sym_COLON_EQ] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3881),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3881),
    [sym_int] = ACTIONS(3881),
    [sym_xint] = ACTIONS(3879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3879),
    [sym__newline] = ACTIONS(3879),
  },
  [3421] = {
    [sym_block_comment] = STATE(3421),
    [sym_compiler_directive_decl] = STATE(3421),
    [sym_fsi_directive_decl] = STATE(3421),
    [sym_preproc_line] = STATE(3421),
    [sym_identifier] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(4076),
    [anon_sym_COLON] = ACTIONS(4078),
    [anon_sym_return] = ACTIONS(4078),
    [anon_sym_do] = ACTIONS(4078),
    [anon_sym_let] = ACTIONS(4078),
    [anon_sym_let_BANG] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_null] = ACTIONS(4078),
    [anon_sym_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_QMARK] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(4076),
    [anon_sym_AMP] = ACTIONS(4078),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4078),
    [anon_sym_LT_AT] = ACTIONS(4078),
    [anon_sym_LT_AT_AT] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(4078),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4076),
    [anon_sym_new] = ACTIONS(4078),
    [anon_sym_return_BANG] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(4078),
    [anon_sym_yield_BANG] = ACTIONS(4076),
    [anon_sym_lazy] = ACTIONS(4078),
    [anon_sym_assert] = ACTIONS(4078),
    [anon_sym_upcast] = ACTIONS(4078),
    [anon_sym_downcast] = ACTIONS(4078),
    [anon_sym_COLON_GT] = ACTIONS(4076),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4076),
    [anon_sym_for] = ACTIONS(4078),
    [anon_sym_while] = ACTIONS(4078),
    [anon_sym_if] = ACTIONS(4078),
    [anon_sym_fun] = ACTIONS(4078),
    [anon_sym_try] = ACTIONS(4078),
    [anon_sym_match] = ACTIONS(4078),
    [anon_sym_match_BANG] = ACTIONS(4076),
    [anon_sym_function] = ACTIONS(4078),
    [anon_sym_LT_DASH] = ACTIONS(4078),
    [anon_sym_DOT_LBRACK] = ACTIONS(4076),
    [anon_sym_LT] = ACTIONS(4076),
    [anon_sym_GT] = ACTIONS(4078),
    [anon_sym_use] = ACTIONS(4078),
    [anon_sym_use_BANG] = ACTIONS(4076),
    [anon_sym_do_BANG] = ACTIONS(4076),
    [anon_sym_begin] = ACTIONS(4078),
    [anon_sym_LPAREN2] = ACTIONS(4078),
    [anon_sym_or] = ACTIONS(4078),
    [aux_sym_char_token1] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4078),
    [anon_sym_DQUOTE] = ACTIONS(4078),
    [anon_sym_AT_DQUOTE] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [sym_bool] = ACTIONS(4078),
    [sym_unit] = ACTIONS(4076),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4078),
    [sym_op_identifier] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(4078),
    [anon_sym_PLUS_DOT] = ACTIONS(4078),
    [anon_sym_DASH_DOT] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [anon_sym_AMP_AMP] = ACTIONS(4078),
    [anon_sym_TILDE] = ACTIONS(4076),
    [aux_sym_prefix_op_token1] = ACTIONS(4078),
    [aux_sym_infix_op_token1] = ACTIONS(4076),
    [aux_sym_infix_op_token2] = ACTIONS(4078),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_BANG_EQ] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4076),
    [anon_sym_DOLLAR] = ACTIONS(4078),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4078),
    [sym_int] = ACTIONS(4078),
    [sym_xint] = ACTIONS(4076),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4076),
    [sym__newline] = ACTIONS(4076),
  },
  [3422] = {
    [sym_block_comment] = STATE(3422),
    [sym_compiler_directive_decl] = STATE(3422),
    [sym_fsi_directive_decl] = STATE(3422),
    [sym_preproc_line] = STATE(3422),
    [sym_identifier] = ACTIONS(4212),
    [anon_sym_EQ] = ACTIONS(4210),
    [anon_sym_COLON] = ACTIONS(4212),
    [anon_sym_return] = ACTIONS(4212),
    [anon_sym_do] = ACTIONS(4212),
    [anon_sym_let] = ACTIONS(4212),
    [anon_sym_let_BANG] = ACTIONS(4210),
    [anon_sym_LPAREN] = ACTIONS(4212),
    [anon_sym_COMMA] = ACTIONS(4210),
    [anon_sym_null] = ACTIONS(4212),
    [anon_sym_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_COLON] = ACTIONS(4210),
    [anon_sym_AMP] = ACTIONS(4212),
    [anon_sym_LBRACK] = ACTIONS(4212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4210),
    [anon_sym_LBRACE] = ACTIONS(4212),
    [anon_sym_LT_AT] = ACTIONS(4212),
    [anon_sym_LT_AT_AT] = ACTIONS(4212),
    [anon_sym_DOT] = ACTIONS(4212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4210),
    [anon_sym_new] = ACTIONS(4212),
    [anon_sym_return_BANG] = ACTIONS(4210),
    [anon_sym_yield] = ACTIONS(4212),
    [anon_sym_yield_BANG] = ACTIONS(4210),
    [anon_sym_lazy] = ACTIONS(4212),
    [anon_sym_assert] = ACTIONS(4212),
    [anon_sym_upcast] = ACTIONS(4212),
    [anon_sym_downcast] = ACTIONS(4212),
    [anon_sym_COLON_GT] = ACTIONS(4210),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4210),
    [anon_sym_for] = ACTIONS(4212),
    [anon_sym_while] = ACTIONS(4212),
    [anon_sym_if] = ACTIONS(4212),
    [anon_sym_fun] = ACTIONS(4212),
    [anon_sym_try] = ACTIONS(4212),
    [anon_sym_match] = ACTIONS(4212),
    [anon_sym_match_BANG] = ACTIONS(4210),
    [anon_sym_function] = ACTIONS(4212),
    [anon_sym_LT_DASH] = ACTIONS(4212),
    [anon_sym_DOT_LBRACK] = ACTIONS(4210),
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_use] = ACTIONS(4212),
    [anon_sym_use_BANG] = ACTIONS(4210),
    [anon_sym_do_BANG] = ACTIONS(4210),
    [anon_sym_DOT_DOT] = ACTIONS(4210),
    [anon_sym_begin] = ACTIONS(4212),
    [anon_sym_LPAREN2] = ACTIONS(4212),
    [anon_sym_or] = ACTIONS(4212),
    [aux_sym_char_token1] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4212),
    [anon_sym_DQUOTE] = ACTIONS(4212),
    [anon_sym_AT_DQUOTE] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [sym_bool] = ACTIONS(4212),
    [sym_unit] = ACTIONS(4210),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4212),
    [anon_sym_DASH] = ACTIONS(4212),
    [anon_sym_PLUS_DOT] = ACTIONS(4212),
    [anon_sym_DASH_DOT] = ACTIONS(4212),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_AMP_AMP] = ACTIONS(4212),
    [anon_sym_TILDE] = ACTIONS(4210),
    [aux_sym_prefix_op_token1] = ACTIONS(4212),
    [aux_sym_infix_op_token1] = ACTIONS(4210),
    [aux_sym_infix_op_token2] = ACTIONS(4212),
    [anon_sym_PIPE_PIPE] = ACTIONS(4212),
    [anon_sym_BANG_EQ] = ACTIONS(4212),
    [anon_sym_COLON_EQ] = ACTIONS(4210),
    [anon_sym_DOLLAR] = ACTIONS(4212),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4212),
    [sym_int] = ACTIONS(4212),
    [sym_xint] = ACTIONS(4210),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4210),
    [sym__newline] = ACTIONS(4210),
  },
  [3423] = {
    [sym_block_comment] = STATE(3423),
    [sym_compiler_directive_decl] = STATE(3423),
    [sym_fsi_directive_decl] = STATE(3423),
    [sym_preproc_line] = STATE(3423),
    [sym_identifier] = ACTIONS(4182),
    [anon_sym_EQ] = ACTIONS(3689),
    [anon_sym_COLON] = ACTIONS(4182),
    [anon_sym_return] = ACTIONS(4182),
    [anon_sym_do] = ACTIONS(4182),
    [anon_sym_let] = ACTIONS(4182),
    [anon_sym_let_BANG] = ACTIONS(3689),
    [anon_sym_LPAREN] = ACTIONS(4182),
    [anon_sym_COMMA] = ACTIONS(3689),
    [anon_sym_null] = ACTIONS(4182),
    [anon_sym_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3689),
    [anon_sym_LBRACE] = ACTIONS(4182),
    [anon_sym_LT_AT] = ACTIONS(4182),
    [anon_sym_LT_AT_AT] = ACTIONS(4182),
    [anon_sym_DOT] = ACTIONS(4182),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3689),
    [anon_sym_new] = ACTIONS(4182),
    [anon_sym_return_BANG] = ACTIONS(3689),
    [anon_sym_yield] = ACTIONS(4182),
    [anon_sym_yield_BANG] = ACTIONS(3689),
    [anon_sym_lazy] = ACTIONS(4182),
    [anon_sym_assert] = ACTIONS(4182),
    [anon_sym_upcast] = ACTIONS(4182),
    [anon_sym_downcast] = ACTIONS(4182),
    [anon_sym_COLON_GT] = ACTIONS(3689),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3689),
    [anon_sym_for] = ACTIONS(4182),
    [anon_sym_while] = ACTIONS(4182),
    [anon_sym_if] = ACTIONS(4182),
    [anon_sym_fun] = ACTIONS(4182),
    [anon_sym_try] = ACTIONS(4182),
    [anon_sym_match] = ACTIONS(4182),
    [anon_sym_match_BANG] = ACTIONS(3689),
    [anon_sym_function] = ACTIONS(4182),
    [anon_sym_LT_DASH] = ACTIONS(4182),
    [anon_sym_DOT_LBRACK] = ACTIONS(3689),
    [anon_sym_LT] = ACTIONS(3689),
    [anon_sym_use] = ACTIONS(4182),
    [anon_sym_use_BANG] = ACTIONS(3689),
    [anon_sym_do_BANG] = ACTIONS(3689),
    [anon_sym_DOT_DOT] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(4182),
    [anon_sym_LPAREN2] = ACTIONS(4182),
    [anon_sym_or] = ACTIONS(4182),
    [aux_sym_char_token1] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4182),
    [anon_sym_DQUOTE] = ACTIONS(4182),
    [anon_sym_AT_DQUOTE] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [sym_bool] = ACTIONS(4182),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4182),
    [sym_op_identifier] = ACTIONS(4182),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_PLUS_DOT] = ACTIONS(4182),
    [anon_sym_DASH_DOT] = ACTIONS(4182),
    [anon_sym_PERCENT] = ACTIONS(4182),
    [anon_sym_AMP_AMP] = ACTIONS(4182),
    [anon_sym_TILDE] = ACTIONS(3689),
    [aux_sym_prefix_op_token1] = ACTIONS(4182),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token2] = ACTIONS(4182),
    [anon_sym_PIPE_PIPE] = ACTIONS(4182),
    [anon_sym_BANG_EQ] = ACTIONS(4182),
    [anon_sym_COLON_EQ] = ACTIONS(3689),
    [anon_sym_DOLLAR] = ACTIONS(4182),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4182),
    [sym_int] = ACTIONS(4182),
    [sym_xint] = ACTIONS(3689),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3689),
    [sym__newline] = ACTIONS(3689),
  },
  [3424] = {
    [sym_block_comment] = STATE(3424),
    [sym_compiler_directive_decl] = STATE(3424),
    [sym_fsi_directive_decl] = STATE(3424),
    [sym_preproc_line] = STATE(3424),
    [sym_identifier] = ACTIONS(4162),
    [anon_sym_EQ] = ACTIONS(4160),
    [anon_sym_COLON] = ACTIONS(4162),
    [anon_sym_return] = ACTIONS(4162),
    [anon_sym_do] = ACTIONS(4162),
    [anon_sym_let] = ACTIONS(4162),
    [anon_sym_let_BANG] = ACTIONS(4160),
    [anon_sym_LPAREN] = ACTIONS(4162),
    [anon_sym_COMMA] = ACTIONS(4160),
    [anon_sym_null] = ACTIONS(4162),
    [anon_sym_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4160),
    [anon_sym_AMP] = ACTIONS(4162),
    [anon_sym_LBRACK] = ACTIONS(4162),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4160),
    [anon_sym_LBRACE] = ACTIONS(4162),
    [anon_sym_LT_AT] = ACTIONS(4162),
    [anon_sym_LT_AT_AT] = ACTIONS(4162),
    [anon_sym_DOT] = ACTIONS(4162),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4160),
    [anon_sym_new] = ACTIONS(4162),
    [anon_sym_return_BANG] = ACTIONS(4160),
    [anon_sym_yield] = ACTIONS(4162),
    [anon_sym_yield_BANG] = ACTIONS(4160),
    [anon_sym_lazy] = ACTIONS(4162),
    [anon_sym_assert] = ACTIONS(4162),
    [anon_sym_upcast] = ACTIONS(4162),
    [anon_sym_downcast] = ACTIONS(4162),
    [anon_sym_COLON_GT] = ACTIONS(4160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4160),
    [anon_sym_for] = ACTIONS(4162),
    [anon_sym_while] = ACTIONS(4162),
    [anon_sym_if] = ACTIONS(4162),
    [anon_sym_fun] = ACTIONS(4162),
    [anon_sym_try] = ACTIONS(4162),
    [anon_sym_match] = ACTIONS(4162),
    [anon_sym_match_BANG] = ACTIONS(4160),
    [anon_sym_function] = ACTIONS(4162),
    [anon_sym_LT_DASH] = ACTIONS(4162),
    [anon_sym_DOT_LBRACK] = ACTIONS(4160),
    [anon_sym_LT] = ACTIONS(4160),
    [anon_sym_use] = ACTIONS(4162),
    [anon_sym_use_BANG] = ACTIONS(4160),
    [anon_sym_do_BANG] = ACTIONS(4160),
    [anon_sym_DOT_DOT] = ACTIONS(4160),
    [anon_sym_begin] = ACTIONS(4162),
    [anon_sym_LPAREN2] = ACTIONS(4162),
    [anon_sym_or] = ACTIONS(4162),
    [aux_sym_char_token1] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4162),
    [anon_sym_DQUOTE] = ACTIONS(4162),
    [anon_sym_AT_DQUOTE] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [sym_bool] = ACTIONS(4162),
    [sym_unit] = ACTIONS(4160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4162),
    [sym_op_identifier] = ACTIONS(4162),
    [anon_sym_PLUS] = ACTIONS(4162),
    [anon_sym_DASH] = ACTIONS(4162),
    [anon_sym_PLUS_DOT] = ACTIONS(4162),
    [anon_sym_DASH_DOT] = ACTIONS(4162),
    [anon_sym_PERCENT] = ACTIONS(4162),
    [anon_sym_AMP_AMP] = ACTIONS(4162),
    [anon_sym_TILDE] = ACTIONS(4160),
    [aux_sym_prefix_op_token1] = ACTIONS(4162),
    [aux_sym_infix_op_token1] = ACTIONS(4160),
    [aux_sym_infix_op_token2] = ACTIONS(4162),
    [anon_sym_PIPE_PIPE] = ACTIONS(4162),
    [anon_sym_BANG_EQ] = ACTIONS(4162),
    [anon_sym_COLON_EQ] = ACTIONS(4160),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4162),
    [sym_int] = ACTIONS(4162),
    [sym_xint] = ACTIONS(4160),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4160),
    [sym__newline] = ACTIONS(4160),
  },
  [3425] = {
    [sym_block_comment] = STATE(3425),
    [sym_compiler_directive_decl] = STATE(3425),
    [sym_fsi_directive_decl] = STATE(3425),
    [sym_preproc_line] = STATE(3425),
    [sym_identifier] = ACTIONS(4158),
    [anon_sym_EQ] = ACTIONS(4156),
    [anon_sym_COLON] = ACTIONS(4158),
    [anon_sym_return] = ACTIONS(4158),
    [anon_sym_do] = ACTIONS(4158),
    [anon_sym_let] = ACTIONS(4158),
    [anon_sym_let_BANG] = ACTIONS(4156),
    [anon_sym_LPAREN] = ACTIONS(4158),
    [anon_sym_COMMA] = ACTIONS(4156),
    [anon_sym_null] = ACTIONS(4158),
    [anon_sym_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_COLON] = ACTIONS(4156),
    [anon_sym_AMP] = ACTIONS(4158),
    [anon_sym_LBRACK] = ACTIONS(4158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(4158),
    [anon_sym_LT_AT] = ACTIONS(4158),
    [anon_sym_LT_AT_AT] = ACTIONS(4158),
    [anon_sym_DOT] = ACTIONS(4158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4156),
    [anon_sym_new] = ACTIONS(4158),
    [anon_sym_return_BANG] = ACTIONS(4156),
    [anon_sym_yield] = ACTIONS(4158),
    [anon_sym_yield_BANG] = ACTIONS(4156),
    [anon_sym_lazy] = ACTIONS(4158),
    [anon_sym_assert] = ACTIONS(4158),
    [anon_sym_upcast] = ACTIONS(4158),
    [anon_sym_downcast] = ACTIONS(4158),
    [anon_sym_COLON_GT] = ACTIONS(4156),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4156),
    [anon_sym_for] = ACTIONS(4158),
    [anon_sym_while] = ACTIONS(4158),
    [anon_sym_if] = ACTIONS(4158),
    [anon_sym_fun] = ACTIONS(4158),
    [anon_sym_try] = ACTIONS(4158),
    [anon_sym_match] = ACTIONS(4158),
    [anon_sym_match_BANG] = ACTIONS(4156),
    [anon_sym_function] = ACTIONS(4158),
    [anon_sym_LT_DASH] = ACTIONS(4158),
    [anon_sym_DOT_LBRACK] = ACTIONS(4156),
    [anon_sym_LT] = ACTIONS(4156),
    [anon_sym_use] = ACTIONS(4158),
    [anon_sym_use_BANG] = ACTIONS(4156),
    [anon_sym_do_BANG] = ACTIONS(4156),
    [anon_sym_DOT_DOT] = ACTIONS(4156),
    [anon_sym_begin] = ACTIONS(4158),
    [anon_sym_LPAREN2] = ACTIONS(4158),
    [anon_sym_or] = ACTIONS(4158),
    [aux_sym_char_token1] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4158),
    [anon_sym_DQUOTE] = ACTIONS(4158),
    [anon_sym_AT_DQUOTE] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [sym_bool] = ACTIONS(4158),
    [sym_unit] = ACTIONS(4156),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4158),
    [sym_op_identifier] = ACTIONS(4158),
    [anon_sym_PLUS] = ACTIONS(4158),
    [anon_sym_DASH] = ACTIONS(4158),
    [anon_sym_PLUS_DOT] = ACTIONS(4158),
    [anon_sym_DASH_DOT] = ACTIONS(4158),
    [anon_sym_PERCENT] = ACTIONS(4158),
    [anon_sym_AMP_AMP] = ACTIONS(4158),
    [anon_sym_TILDE] = ACTIONS(4156),
    [aux_sym_prefix_op_token1] = ACTIONS(4158),
    [aux_sym_infix_op_token1] = ACTIONS(4156),
    [aux_sym_infix_op_token2] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE] = ACTIONS(4158),
    [anon_sym_BANG_EQ] = ACTIONS(4158),
    [anon_sym_COLON_EQ] = ACTIONS(4156),
    [anon_sym_DOLLAR] = ACTIONS(4158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4158),
    [sym_int] = ACTIONS(4158),
    [sym_xint] = ACTIONS(4156),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4156),
    [sym__newline] = ACTIONS(4156),
  },
  [3426] = {
    [sym_block_comment] = STATE(3426),
    [sym_compiler_directive_decl] = STATE(3426),
    [sym_fsi_directive_decl] = STATE(3426),
    [sym_preproc_line] = STATE(3426),
    [sym_identifier] = ACTIONS(4208),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_COLON] = ACTIONS(4208),
    [anon_sym_return] = ACTIONS(4208),
    [anon_sym_do] = ACTIONS(4208),
    [anon_sym_let] = ACTIONS(4208),
    [anon_sym_let_BANG] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(4206),
    [anon_sym_null] = ACTIONS(4208),
    [anon_sym_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_COLON] = ACTIONS(4206),
    [anon_sym_AMP] = ACTIONS(4208),
    [anon_sym_LBRACK] = ACTIONS(4208),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4206),
    [anon_sym_LBRACE] = ACTIONS(4208),
    [anon_sym_LT_AT] = ACTIONS(4208),
    [anon_sym_LT_AT_AT] = ACTIONS(4208),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4206),
    [anon_sym_new] = ACTIONS(4208),
    [anon_sym_return_BANG] = ACTIONS(4206),
    [anon_sym_yield] = ACTIONS(4208),
    [anon_sym_yield_BANG] = ACTIONS(4206),
    [anon_sym_lazy] = ACTIONS(4208),
    [anon_sym_assert] = ACTIONS(4208),
    [anon_sym_upcast] = ACTIONS(4208),
    [anon_sym_downcast] = ACTIONS(4208),
    [anon_sym_COLON_GT] = ACTIONS(4206),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4206),
    [anon_sym_for] = ACTIONS(4208),
    [anon_sym_while] = ACTIONS(4208),
    [anon_sym_if] = ACTIONS(4208),
    [anon_sym_fun] = ACTIONS(4208),
    [anon_sym_try] = ACTIONS(4208),
    [anon_sym_match] = ACTIONS(4208),
    [anon_sym_match_BANG] = ACTIONS(4206),
    [anon_sym_function] = ACTIONS(4208),
    [anon_sym_LT_DASH] = ACTIONS(4208),
    [anon_sym_DOT_LBRACK] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(4206),
    [anon_sym_use] = ACTIONS(4208),
    [anon_sym_use_BANG] = ACTIONS(4206),
    [anon_sym_do_BANG] = ACTIONS(4206),
    [anon_sym_DOT_DOT] = ACTIONS(4206),
    [anon_sym_begin] = ACTIONS(4208),
    [anon_sym_LPAREN2] = ACTIONS(4208),
    [anon_sym_or] = ACTIONS(4208),
    [aux_sym_char_token1] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4208),
    [anon_sym_DQUOTE] = ACTIONS(4208),
    [anon_sym_AT_DQUOTE] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [sym_bool] = ACTIONS(4208),
    [sym_unit] = ACTIONS(4206),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4208),
    [sym_op_identifier] = ACTIONS(4208),
    [anon_sym_PLUS] = ACTIONS(4208),
    [anon_sym_DASH] = ACTIONS(4208),
    [anon_sym_PLUS_DOT] = ACTIONS(4208),
    [anon_sym_DASH_DOT] = ACTIONS(4208),
    [anon_sym_PERCENT] = ACTIONS(4208),
    [anon_sym_AMP_AMP] = ACTIONS(4208),
    [anon_sym_TILDE] = ACTIONS(4206),
    [aux_sym_prefix_op_token1] = ACTIONS(4208),
    [aux_sym_infix_op_token1] = ACTIONS(4206),
    [aux_sym_infix_op_token2] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(4208),
    [anon_sym_BANG_EQ] = ACTIONS(4208),
    [anon_sym_COLON_EQ] = ACTIONS(4206),
    [anon_sym_DOLLAR] = ACTIONS(4208),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4208),
    [sym_int] = ACTIONS(4208),
    [sym_xint] = ACTIONS(4206),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4206),
    [sym__newline] = ACTIONS(4206),
  },
  [3427] = {
    [sym_block_comment] = STATE(3427),
    [sym_compiler_directive_decl] = STATE(3427),
    [sym_fsi_directive_decl] = STATE(3427),
    [sym_preproc_line] = STATE(3427),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_EQ] = ACTIONS(4001),
    [anon_sym_COLON] = ACTIONS(4003),
    [anon_sym_return] = ACTIONS(4003),
    [anon_sym_do] = ACTIONS(4003),
    [anon_sym_let] = ACTIONS(4003),
    [anon_sym_let_BANG] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4003),
    [anon_sym_COMMA] = ACTIONS(4001),
    [anon_sym_null] = ACTIONS(4003),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_COLON] = ACTIONS(4001),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LBRACK] = ACTIONS(4003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4001),
    [anon_sym_LBRACE] = ACTIONS(4003),
    [anon_sym_LT_AT] = ACTIONS(4003),
    [anon_sym_LT_AT_AT] = ACTIONS(4003),
    [anon_sym_AT_AT_GT] = ACTIONS(4003),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4001),
    [anon_sym_new] = ACTIONS(4003),
    [anon_sym_return_BANG] = ACTIONS(4001),
    [anon_sym_yield] = ACTIONS(4003),
    [anon_sym_yield_BANG] = ACTIONS(4001),
    [anon_sym_lazy] = ACTIONS(4003),
    [anon_sym_assert] = ACTIONS(4003),
    [anon_sym_upcast] = ACTIONS(4003),
    [anon_sym_downcast] = ACTIONS(4003),
    [anon_sym_COLON_GT] = ACTIONS(4001),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4001),
    [anon_sym_for] = ACTIONS(4003),
    [anon_sym_while] = ACTIONS(4003),
    [anon_sym_if] = ACTIONS(4003),
    [anon_sym_fun] = ACTIONS(4003),
    [anon_sym_try] = ACTIONS(4003),
    [anon_sym_match] = ACTIONS(4003),
    [anon_sym_match_BANG] = ACTIONS(4001),
    [anon_sym_function] = ACTIONS(4003),
    [anon_sym_LT_DASH] = ACTIONS(4003),
    [anon_sym_DOT_LBRACK] = ACTIONS(4001),
    [anon_sym_LT] = ACTIONS(4001),
    [anon_sym_use] = ACTIONS(4003),
    [anon_sym_use_BANG] = ACTIONS(4001),
    [anon_sym_do_BANG] = ACTIONS(4001),
    [anon_sym_begin] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [aux_sym_char_token1] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4003),
    [anon_sym_DQUOTE] = ACTIONS(4003),
    [anon_sym_AT_DQUOTE] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [sym_bool] = ACTIONS(4003),
    [sym_unit] = ACTIONS(4001),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4003),
    [sym_op_identifier] = ACTIONS(4003),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_PLUS_DOT] = ACTIONS(4003),
    [anon_sym_DASH_DOT] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4003),
    [anon_sym_TILDE] = ACTIONS(4001),
    [aux_sym_prefix_op_token1] = ACTIONS(4003),
    [aux_sym_infix_op_token1] = ACTIONS(4001),
    [aux_sym_infix_op_token2] = ACTIONS(4003),
    [anon_sym_PIPE_PIPE] = ACTIONS(4003),
    [anon_sym_BANG_EQ] = ACTIONS(4003),
    [anon_sym_COLON_EQ] = ACTIONS(4001),
    [anon_sym_DOLLAR] = ACTIONS(4003),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4003),
    [sym_int] = ACTIONS(4003),
    [sym_xint] = ACTIONS(4001),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4001),
    [sym__newline] = ACTIONS(4001),
  },
  [3428] = {
    [sym_block_comment] = STATE(3428),
    [sym_compiler_directive_decl] = STATE(3428),
    [sym_fsi_directive_decl] = STATE(3428),
    [sym_preproc_line] = STATE(3428),
    [sym_identifier] = ACTIONS(3907),
    [anon_sym_EQ] = ACTIONS(3905),
    [anon_sym_COLON] = ACTIONS(3907),
    [anon_sym_return] = ACTIONS(3907),
    [anon_sym_do] = ACTIONS(3907),
    [anon_sym_let] = ACTIONS(3907),
    [anon_sym_let_BANG] = ACTIONS(3905),
    [anon_sym_LPAREN] = ACTIONS(3907),
    [anon_sym_COMMA] = ACTIONS(3905),
    [anon_sym_null] = ACTIONS(3907),
    [anon_sym_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_COLON] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3907),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3905),
    [anon_sym_LBRACE] = ACTIONS(3907),
    [anon_sym_LT_AT] = ACTIONS(3907),
    [anon_sym_AT_GT] = ACTIONS(3907),
    [anon_sym_LT_AT_AT] = ACTIONS(3907),
    [anon_sym_DOT] = ACTIONS(3907),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3905),
    [anon_sym_new] = ACTIONS(3907),
    [anon_sym_return_BANG] = ACTIONS(3905),
    [anon_sym_yield] = ACTIONS(3907),
    [anon_sym_yield_BANG] = ACTIONS(3905),
    [anon_sym_lazy] = ACTIONS(3907),
    [anon_sym_assert] = ACTIONS(3907),
    [anon_sym_upcast] = ACTIONS(3907),
    [anon_sym_downcast] = ACTIONS(3907),
    [anon_sym_COLON_GT] = ACTIONS(3905),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3905),
    [anon_sym_for] = ACTIONS(3907),
    [anon_sym_while] = ACTIONS(3907),
    [anon_sym_if] = ACTIONS(3907),
    [anon_sym_fun] = ACTIONS(3907),
    [anon_sym_try] = ACTIONS(3907),
    [anon_sym_match] = ACTIONS(3907),
    [anon_sym_match_BANG] = ACTIONS(3905),
    [anon_sym_function] = ACTIONS(3907),
    [anon_sym_LT_DASH] = ACTIONS(3907),
    [anon_sym_DOT_LBRACK] = ACTIONS(3905),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_use] = ACTIONS(3907),
    [anon_sym_use_BANG] = ACTIONS(3905),
    [anon_sym_do_BANG] = ACTIONS(3905),
    [anon_sym_begin] = ACTIONS(3907),
    [anon_sym_LPAREN2] = ACTIONS(3907),
    [anon_sym_or] = ACTIONS(3907),
    [aux_sym_char_token1] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3907),
    [anon_sym_DQUOTE] = ACTIONS(3907),
    [anon_sym_AT_DQUOTE] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [sym_bool] = ACTIONS(3907),
    [sym_unit] = ACTIONS(3905),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3907),
    [sym_op_identifier] = ACTIONS(3907),
    [anon_sym_PLUS] = ACTIONS(3907),
    [anon_sym_DASH] = ACTIONS(3907),
    [anon_sym_PLUS_DOT] = ACTIONS(3907),
    [anon_sym_DASH_DOT] = ACTIONS(3907),
    [anon_sym_PERCENT] = ACTIONS(3907),
    [anon_sym_AMP_AMP] = ACTIONS(3907),
    [anon_sym_TILDE] = ACTIONS(3905),
    [aux_sym_prefix_op_token1] = ACTIONS(3907),
    [aux_sym_infix_op_token1] = ACTIONS(3905),
    [aux_sym_infix_op_token2] = ACTIONS(3907),
    [anon_sym_PIPE_PIPE] = ACTIONS(3907),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_COLON_EQ] = ACTIONS(3905),
    [anon_sym_DOLLAR] = ACTIONS(3907),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3907),
    [sym_int] = ACTIONS(3907),
    [sym_xint] = ACTIONS(3905),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3905),
    [sym__newline] = ACTIONS(3905),
  },
  [3429] = {
    [sym_block_comment] = STATE(3429),
    [sym_compiler_directive_decl] = STATE(3429),
    [sym_fsi_directive_decl] = STATE(3429),
    [sym_preproc_line] = STATE(3429),
    [sym_identifier] = ACTIONS(3900),
    [anon_sym_EQ] = ACTIONS(3898),
    [anon_sym_COLON] = ACTIONS(3900),
    [anon_sym_return] = ACTIONS(3900),
    [anon_sym_do] = ACTIONS(3900),
    [anon_sym_let] = ACTIONS(3900),
    [anon_sym_let_BANG] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3898),
    [anon_sym_null] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_COLON] = ACTIONS(3898),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_LBRACK] = ACTIONS(3900),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3898),
    [anon_sym_LBRACE] = ACTIONS(3900),
    [anon_sym_LT_AT] = ACTIONS(3900),
    [anon_sym_AT_GT] = ACTIONS(3900),
    [anon_sym_LT_AT_AT] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(3900),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3898),
    [anon_sym_new] = ACTIONS(3900),
    [anon_sym_return_BANG] = ACTIONS(3898),
    [anon_sym_yield] = ACTIONS(3900),
    [anon_sym_yield_BANG] = ACTIONS(3898),
    [anon_sym_lazy] = ACTIONS(3900),
    [anon_sym_assert] = ACTIONS(3900),
    [anon_sym_upcast] = ACTIONS(3900),
    [anon_sym_downcast] = ACTIONS(3900),
    [anon_sym_COLON_GT] = ACTIONS(3898),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3898),
    [anon_sym_for] = ACTIONS(3900),
    [anon_sym_while] = ACTIONS(3900),
    [anon_sym_if] = ACTIONS(3900),
    [anon_sym_fun] = ACTIONS(3900),
    [anon_sym_try] = ACTIONS(3900),
    [anon_sym_match] = ACTIONS(3900),
    [anon_sym_match_BANG] = ACTIONS(3898),
    [anon_sym_function] = ACTIONS(3900),
    [anon_sym_LT_DASH] = ACTIONS(3900),
    [anon_sym_DOT_LBRACK] = ACTIONS(3898),
    [anon_sym_LT] = ACTIONS(3898),
    [anon_sym_use] = ACTIONS(3900),
    [anon_sym_use_BANG] = ACTIONS(3898),
    [anon_sym_do_BANG] = ACTIONS(3898),
    [anon_sym_begin] = ACTIONS(3900),
    [anon_sym_LPAREN2] = ACTIONS(3900),
    [anon_sym_or] = ACTIONS(3900),
    [aux_sym_char_token1] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3900),
    [anon_sym_DQUOTE] = ACTIONS(3900),
    [anon_sym_AT_DQUOTE] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3898),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3900),
    [sym_op_identifier] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(3900),
    [anon_sym_DASH] = ACTIONS(3900),
    [anon_sym_PLUS_DOT] = ACTIONS(3900),
    [anon_sym_DASH_DOT] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(3900),
    [anon_sym_AMP_AMP] = ACTIONS(3900),
    [anon_sym_TILDE] = ACTIONS(3898),
    [aux_sym_prefix_op_token1] = ACTIONS(3900),
    [aux_sym_infix_op_token1] = ACTIONS(3898),
    [aux_sym_infix_op_token2] = ACTIONS(3900),
    [anon_sym_PIPE_PIPE] = ACTIONS(3900),
    [anon_sym_BANG_EQ] = ACTIONS(3900),
    [anon_sym_COLON_EQ] = ACTIONS(3898),
    [anon_sym_DOLLAR] = ACTIONS(3900),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3900),
    [sym_int] = ACTIONS(3900),
    [sym_xint] = ACTIONS(3898),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3898),
    [sym__newline] = ACTIONS(3898),
  },
  [3430] = {
    [sym_block_comment] = STATE(3430),
    [sym_compiler_directive_decl] = STATE(3430),
    [sym_fsi_directive_decl] = STATE(3430),
    [sym_preproc_line] = STATE(3430),
    [sym_identifier] = ACTIONS(3893),
    [anon_sym_EQ] = ACTIONS(3891),
    [anon_sym_COLON] = ACTIONS(3893),
    [anon_sym_return] = ACTIONS(3893),
    [anon_sym_do] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_let_BANG] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_COMMA] = ACTIONS(3891),
    [anon_sym_null] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_COLON] = ACTIONS(3891),
    [anon_sym_AMP] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3891),
    [anon_sym_LBRACE] = ACTIONS(3893),
    [anon_sym_LT_AT] = ACTIONS(3893),
    [anon_sym_AT_GT] = ACTIONS(3893),
    [anon_sym_LT_AT_AT] = ACTIONS(3893),
    [anon_sym_DOT] = ACTIONS(3893),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3891),
    [anon_sym_new] = ACTIONS(3893),
    [anon_sym_return_BANG] = ACTIONS(3891),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_yield_BANG] = ACTIONS(3891),
    [anon_sym_lazy] = ACTIONS(3893),
    [anon_sym_assert] = ACTIONS(3893),
    [anon_sym_upcast] = ACTIONS(3893),
    [anon_sym_downcast] = ACTIONS(3893),
    [anon_sym_COLON_GT] = ACTIONS(3891),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3891),
    [anon_sym_for] = ACTIONS(3893),
    [anon_sym_while] = ACTIONS(3893),
    [anon_sym_if] = ACTIONS(3893),
    [anon_sym_fun] = ACTIONS(3893),
    [anon_sym_try] = ACTIONS(3893),
    [anon_sym_match] = ACTIONS(3893),
    [anon_sym_match_BANG] = ACTIONS(3891),
    [anon_sym_function] = ACTIONS(3893),
    [anon_sym_LT_DASH] = ACTIONS(3893),
    [anon_sym_DOT_LBRACK] = ACTIONS(3891),
    [anon_sym_LT] = ACTIONS(3891),
    [anon_sym_use] = ACTIONS(3893),
    [anon_sym_use_BANG] = ACTIONS(3891),
    [anon_sym_do_BANG] = ACTIONS(3891),
    [anon_sym_begin] = ACTIONS(3893),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_or] = ACTIONS(3893),
    [aux_sym_char_token1] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3893),
    [anon_sym_DQUOTE] = ACTIONS(3893),
    [anon_sym_AT_DQUOTE] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [sym_bool] = ACTIONS(3893),
    [sym_unit] = ACTIONS(3891),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3893),
    [sym_op_identifier] = ACTIONS(3893),
    [anon_sym_PLUS] = ACTIONS(3893),
    [anon_sym_DASH] = ACTIONS(3893),
    [anon_sym_PLUS_DOT] = ACTIONS(3893),
    [anon_sym_DASH_DOT] = ACTIONS(3893),
    [anon_sym_PERCENT] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_TILDE] = ACTIONS(3891),
    [aux_sym_prefix_op_token1] = ACTIONS(3893),
    [aux_sym_infix_op_token1] = ACTIONS(3891),
    [aux_sym_infix_op_token2] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [anon_sym_BANG_EQ] = ACTIONS(3893),
    [anon_sym_COLON_EQ] = ACTIONS(3891),
    [anon_sym_DOLLAR] = ACTIONS(3893),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3893),
    [sym_int] = ACTIONS(3893),
    [sym_xint] = ACTIONS(3891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3891),
    [sym__newline] = ACTIONS(3891),
  },
  [3431] = {
    [sym_block_comment] = STATE(3431),
    [sym_compiler_directive_decl] = STATE(3431),
    [sym_fsi_directive_decl] = STATE(3431),
    [sym_preproc_line] = STATE(3431),
    [sym_identifier] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3919),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_return] = ACTIONS(3921),
    [anon_sym_do] = ACTIONS(3921),
    [anon_sym_let] = ACTIONS(3921),
    [anon_sym_let_BANG] = ACTIONS(3919),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3919),
    [anon_sym_null] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_COLON] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3919),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_LT_AT] = ACTIONS(3921),
    [anon_sym_LT_AT_AT] = ACTIONS(3921),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3919),
    [anon_sym_new] = ACTIONS(3921),
    [anon_sym_return_BANG] = ACTIONS(3919),
    [anon_sym_yield] = ACTIONS(3921),
    [anon_sym_yield_BANG] = ACTIONS(3919),
    [anon_sym_lazy] = ACTIONS(3921),
    [anon_sym_assert] = ACTIONS(3921),
    [anon_sym_upcast] = ACTIONS(3921),
    [anon_sym_downcast] = ACTIONS(3921),
    [anon_sym_COLON_GT] = ACTIONS(3919),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3919),
    [anon_sym_for] = ACTIONS(3921),
    [anon_sym_while] = ACTIONS(3921),
    [anon_sym_if] = ACTIONS(3921),
    [anon_sym_fun] = ACTIONS(3921),
    [anon_sym_try] = ACTIONS(3921),
    [anon_sym_match] = ACTIONS(3921),
    [anon_sym_match_BANG] = ACTIONS(3919),
    [anon_sym_function] = ACTIONS(3921),
    [anon_sym_LT_DASH] = ACTIONS(3921),
    [anon_sym_DOT_LBRACK] = ACTIONS(3919),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_GT] = ACTIONS(3921),
    [anon_sym_use] = ACTIONS(3921),
    [anon_sym_use_BANG] = ACTIONS(3919),
    [anon_sym_do_BANG] = ACTIONS(3919),
    [anon_sym_begin] = ACTIONS(3921),
    [anon_sym_LPAREN2] = ACTIONS(3921),
    [anon_sym_or] = ACTIONS(3921),
    [aux_sym_char_token1] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_AT_DQUOTE] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [sym_bool] = ACTIONS(3921),
    [sym_unit] = ACTIONS(3919),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3921),
    [sym_op_identifier] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_DOT] = ACTIONS(3921),
    [anon_sym_DASH_DOT] = ACTIONS(3921),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3919),
    [aux_sym_prefix_op_token1] = ACTIONS(3921),
    [aux_sym_infix_op_token1] = ACTIONS(3919),
    [aux_sym_infix_op_token2] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_COLON_EQ] = ACTIONS(3919),
    [anon_sym_DOLLAR] = ACTIONS(3921),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3921),
    [sym_int] = ACTIONS(3921),
    [sym_xint] = ACTIONS(3919),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3919),
    [sym__newline] = ACTIONS(3919),
  },
  [3432] = {
    [sym_block_comment] = STATE(3432),
    [sym_compiler_directive_decl] = STATE(3432),
    [sym_fsi_directive_decl] = STATE(3432),
    [sym_preproc_line] = STATE(3432),
    [sym_identifier] = ACTIONS(3875),
    [anon_sym_EQ] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(3875),
    [anon_sym_return] = ACTIONS(3875),
    [anon_sym_do] = ACTIONS(3875),
    [anon_sym_let] = ACTIONS(3875),
    [anon_sym_let_BANG] = ACTIONS(3873),
    [anon_sym_LPAREN] = ACTIONS(3875),
    [anon_sym_COMMA] = ACTIONS(3873),
    [anon_sym_null] = ACTIONS(3875),
    [anon_sym_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_COLON] = ACTIONS(3873),
    [anon_sym_AMP] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(3875),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3873),
    [anon_sym_LBRACE] = ACTIONS(3875),
    [anon_sym_LT_AT] = ACTIONS(3875),
    [anon_sym_AT_GT] = ACTIONS(3875),
    [anon_sym_LT_AT_AT] = ACTIONS(3875),
    [anon_sym_DOT] = ACTIONS(3875),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3873),
    [anon_sym_new] = ACTIONS(3875),
    [anon_sym_return_BANG] = ACTIONS(3873),
    [anon_sym_yield] = ACTIONS(3875),
    [anon_sym_yield_BANG] = ACTIONS(3873),
    [anon_sym_lazy] = ACTIONS(3875),
    [anon_sym_assert] = ACTIONS(3875),
    [anon_sym_upcast] = ACTIONS(3875),
    [anon_sym_downcast] = ACTIONS(3875),
    [anon_sym_COLON_GT] = ACTIONS(3873),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3873),
    [anon_sym_for] = ACTIONS(3875),
    [anon_sym_while] = ACTIONS(3875),
    [anon_sym_if] = ACTIONS(3875),
    [anon_sym_fun] = ACTIONS(3875),
    [anon_sym_try] = ACTIONS(3875),
    [anon_sym_match] = ACTIONS(3875),
    [anon_sym_match_BANG] = ACTIONS(3873),
    [anon_sym_function] = ACTIONS(3875),
    [anon_sym_LT_DASH] = ACTIONS(3875),
    [anon_sym_DOT_LBRACK] = ACTIONS(3873),
    [anon_sym_LT] = ACTIONS(3873),
    [anon_sym_use] = ACTIONS(3875),
    [anon_sym_use_BANG] = ACTIONS(3873),
    [anon_sym_do_BANG] = ACTIONS(3873),
    [anon_sym_begin] = ACTIONS(3875),
    [anon_sym_LPAREN2] = ACTIONS(3875),
    [anon_sym_or] = ACTIONS(3875),
    [aux_sym_char_token1] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3875),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [anon_sym_AT_DQUOTE] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [sym_bool] = ACTIONS(3875),
    [sym_unit] = ACTIONS(3873),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3875),
    [sym_op_identifier] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS_DOT] = ACTIONS(3875),
    [anon_sym_DASH_DOT] = ACTIONS(3875),
    [anon_sym_PERCENT] = ACTIONS(3875),
    [anon_sym_AMP_AMP] = ACTIONS(3875),
    [anon_sym_TILDE] = ACTIONS(3873),
    [aux_sym_prefix_op_token1] = ACTIONS(3875),
    [aux_sym_infix_op_token1] = ACTIONS(3873),
    [aux_sym_infix_op_token2] = ACTIONS(3875),
    [anon_sym_PIPE_PIPE] = ACTIONS(3875),
    [anon_sym_BANG_EQ] = ACTIONS(3875),
    [anon_sym_COLON_EQ] = ACTIONS(3873),
    [anon_sym_DOLLAR] = ACTIONS(3875),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3875),
    [sym_int] = ACTIONS(3875),
    [sym_xint] = ACTIONS(3873),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3873),
    [sym__newline] = ACTIONS(3873),
  },
  [3433] = {
    [sym_block_comment] = STATE(3433),
    [sym_compiler_directive_decl] = STATE(3433),
    [sym_fsi_directive_decl] = STATE(3433),
    [sym_preproc_line] = STATE(3433),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4739),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
    [sym__dedent] = ACTIONS(5917),
  },
  [3434] = {
    [sym_block_comment] = STATE(3434),
    [sym_compiler_directive_decl] = STATE(3434),
    [sym_fsi_directive_decl] = STATE(3434),
    [sym_preproc_line] = STATE(3434),
    [sym_identifier] = ACTIONS(4193),
    [anon_sym_EQ] = ACTIONS(4191),
    [anon_sym_COLON] = ACTIONS(4193),
    [anon_sym_return] = ACTIONS(4193),
    [anon_sym_do] = ACTIONS(4193),
    [anon_sym_let] = ACTIONS(4193),
    [anon_sym_let_BANG] = ACTIONS(4191),
    [anon_sym_LPAREN] = ACTIONS(4193),
    [anon_sym_COMMA] = ACTIONS(4191),
    [anon_sym_null] = ACTIONS(4193),
    [anon_sym_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_COLON] = ACTIONS(4191),
    [anon_sym_AMP] = ACTIONS(4193),
    [anon_sym_LBRACK] = ACTIONS(4193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4191),
    [anon_sym_LBRACE] = ACTIONS(4193),
    [anon_sym_LT_AT] = ACTIONS(4193),
    [anon_sym_LT_AT_AT] = ACTIONS(4193),
    [anon_sym_DOT] = ACTIONS(4193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4191),
    [anon_sym_new] = ACTIONS(4193),
    [anon_sym_return_BANG] = ACTIONS(4191),
    [anon_sym_yield] = ACTIONS(4193),
    [anon_sym_yield_BANG] = ACTIONS(4191),
    [anon_sym_lazy] = ACTIONS(4193),
    [anon_sym_assert] = ACTIONS(4193),
    [anon_sym_upcast] = ACTIONS(4193),
    [anon_sym_downcast] = ACTIONS(4193),
    [anon_sym_COLON_GT] = ACTIONS(4191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4191),
    [anon_sym_for] = ACTIONS(4193),
    [anon_sym_while] = ACTIONS(4193),
    [anon_sym_if] = ACTIONS(4193),
    [anon_sym_fun] = ACTIONS(4193),
    [anon_sym_try] = ACTIONS(4193),
    [anon_sym_match] = ACTIONS(4193),
    [anon_sym_match_BANG] = ACTIONS(4191),
    [anon_sym_function] = ACTIONS(4193),
    [anon_sym_LT_DASH] = ACTIONS(4193),
    [anon_sym_DOT_LBRACK] = ACTIONS(4191),
    [anon_sym_LT] = ACTIONS(4191),
    [anon_sym_GT] = ACTIONS(4193),
    [anon_sym_use] = ACTIONS(4193),
    [anon_sym_use_BANG] = ACTIONS(4191),
    [anon_sym_do_BANG] = ACTIONS(4191),
    [anon_sym_begin] = ACTIONS(4193),
    [anon_sym_LPAREN2] = ACTIONS(4193),
    [anon_sym_or] = ACTIONS(4193),
    [aux_sym_char_token1] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4193),
    [anon_sym_DQUOTE] = ACTIONS(4193),
    [anon_sym_AT_DQUOTE] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [sym_bool] = ACTIONS(4193),
    [sym_unit] = ACTIONS(4191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4193),
    [sym_op_identifier] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4193),
    [anon_sym_DASH] = ACTIONS(4193),
    [anon_sym_PLUS_DOT] = ACTIONS(4193),
    [anon_sym_DASH_DOT] = ACTIONS(4193),
    [anon_sym_PERCENT] = ACTIONS(4193),
    [anon_sym_AMP_AMP] = ACTIONS(4193),
    [anon_sym_TILDE] = ACTIONS(4191),
    [aux_sym_prefix_op_token1] = ACTIONS(4193),
    [aux_sym_infix_op_token1] = ACTIONS(4191),
    [aux_sym_infix_op_token2] = ACTIONS(4193),
    [anon_sym_PIPE_PIPE] = ACTIONS(4193),
    [anon_sym_BANG_EQ] = ACTIONS(4193),
    [anon_sym_COLON_EQ] = ACTIONS(4191),
    [anon_sym_DOLLAR] = ACTIONS(4193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4193),
    [sym_int] = ACTIONS(4193),
    [sym_xint] = ACTIONS(4191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4191),
    [sym__newline] = ACTIONS(4191),
  },
  [3435] = {
    [sym_block_comment] = STATE(3435),
    [sym_compiler_directive_decl] = STATE(3435),
    [sym_fsi_directive_decl] = STATE(3435),
    [sym_preproc_line] = STATE(3435),
    [sym_identifier] = ACTIONS(4186),
    [anon_sym_EQ] = ACTIONS(4184),
    [anon_sym_COLON] = ACTIONS(4186),
    [anon_sym_return] = ACTIONS(4186),
    [anon_sym_do] = ACTIONS(4186),
    [anon_sym_let] = ACTIONS(4186),
    [anon_sym_let_BANG] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_COMMA] = ACTIONS(4184),
    [anon_sym_null] = ACTIONS(4186),
    [anon_sym_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_COLON] = ACTIONS(4184),
    [anon_sym_AMP] = ACTIONS(4186),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4184),
    [anon_sym_LBRACE] = ACTIONS(4186),
    [anon_sym_LT_AT] = ACTIONS(4186),
    [anon_sym_LT_AT_AT] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4186),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4184),
    [anon_sym_new] = ACTIONS(4186),
    [anon_sym_return_BANG] = ACTIONS(4184),
    [anon_sym_yield] = ACTIONS(4186),
    [anon_sym_yield_BANG] = ACTIONS(4184),
    [anon_sym_lazy] = ACTIONS(4186),
    [anon_sym_assert] = ACTIONS(4186),
    [anon_sym_upcast] = ACTIONS(4186),
    [anon_sym_downcast] = ACTIONS(4186),
    [anon_sym_COLON_GT] = ACTIONS(4184),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4184),
    [anon_sym_for] = ACTIONS(4186),
    [anon_sym_while] = ACTIONS(4186),
    [anon_sym_if] = ACTIONS(4186),
    [anon_sym_fun] = ACTIONS(4186),
    [anon_sym_try] = ACTIONS(4186),
    [anon_sym_match] = ACTIONS(4186),
    [anon_sym_match_BANG] = ACTIONS(4184),
    [anon_sym_function] = ACTIONS(4186),
    [anon_sym_LT_DASH] = ACTIONS(4186),
    [anon_sym_DOT_LBRACK] = ACTIONS(4184),
    [anon_sym_LT] = ACTIONS(4184),
    [anon_sym_use] = ACTIONS(4186),
    [anon_sym_use_BANG] = ACTIONS(4184),
    [anon_sym_do_BANG] = ACTIONS(4184),
    [anon_sym_DOT_DOT] = ACTIONS(4184),
    [anon_sym_begin] = ACTIONS(4186),
    [anon_sym_LPAREN2] = ACTIONS(4186),
    [anon_sym_or] = ACTIONS(4186),
    [aux_sym_char_token1] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4186),
    [anon_sym_DQUOTE] = ACTIONS(4186),
    [anon_sym_AT_DQUOTE] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [sym_bool] = ACTIONS(4186),
    [sym_unit] = ACTIONS(4184),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4186),
    [sym_op_identifier] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4186),
    [anon_sym_DASH] = ACTIONS(4186),
    [anon_sym_PLUS_DOT] = ACTIONS(4186),
    [anon_sym_DASH_DOT] = ACTIONS(4186),
    [anon_sym_PERCENT] = ACTIONS(4186),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_TILDE] = ACTIONS(4184),
    [aux_sym_prefix_op_token1] = ACTIONS(4186),
    [aux_sym_infix_op_token1] = ACTIONS(4184),
    [aux_sym_infix_op_token2] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_COLON_EQ] = ACTIONS(4184),
    [anon_sym_DOLLAR] = ACTIONS(4186),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4186),
    [sym_int] = ACTIONS(4186),
    [sym_xint] = ACTIONS(4184),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4184),
    [sym__newline] = ACTIONS(4184),
  },
  [3436] = {
    [sym_block_comment] = STATE(3436),
    [sym_compiler_directive_decl] = STATE(3436),
    [sym_fsi_directive_decl] = STATE(3436),
    [sym_preproc_line] = STATE(3436),
    [aux_sym_long_identifier_repeat1] = STATE(3441),
    [ts_builtin_sym_end] = ACTIONS(3449),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_namespace] = ACTIONS(3451),
    [anon_sym_module] = ACTIONS(3451),
    [anon_sym_open] = ACTIONS(3451),
    [anon_sym_LBRACK_LT] = ACTIONS(3449),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_type] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_and] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [aux_sym_access_modifier_token1] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3449),
    [anon_sym_DOT] = ACTIONS(5603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_DASH_GT] = ACTIONS(3449),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_STAR] = ACTIONS(3449),
    [anon_sym_LT2] = ACTIONS(3451),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3449),
    [anon_sym_default] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_member] = ACTIONS(3451),
    [anon_sym_interface] = ACTIONS(3451),
    [anon_sym_exception] = ACTIONS(3451),
    [anon_sym_abstract] = ACTIONS(3451),
    [anon_sym_val] = ACTIONS(3451),
    [anon_sym_override] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3449),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3449),
    [anon_sym_DASH_DOT] = ACTIONS(3449),
    [anon_sym_PERCENT] = ACTIONS(3449),
    [anon_sym_AMP_AMP] = ACTIONS(3449),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3449),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3449),
    [anon_sym_POUNDload] = ACTIONS(3449),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
  },
  [3437] = {
    [sym_block_comment] = STATE(3437),
    [sym_compiler_directive_decl] = STATE(3437),
    [sym_fsi_directive_decl] = STATE(3437),
    [sym_preproc_line] = STATE(3437),
    [sym_identifier] = ACTIONS(3996),
    [anon_sym_EQ] = ACTIONS(3994),
    [anon_sym_COLON] = ACTIONS(3996),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_do] = ACTIONS(3996),
    [anon_sym_let] = ACTIONS(3996),
    [anon_sym_let_BANG] = ACTIONS(3994),
    [anon_sym_LPAREN] = ACTIONS(3996),
    [anon_sym_COMMA] = ACTIONS(3994),
    [anon_sym_null] = ACTIONS(3996),
    [anon_sym_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_COLON] = ACTIONS(3994),
    [anon_sym_AMP] = ACTIONS(3996),
    [anon_sym_LBRACK] = ACTIONS(3996),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3994),
    [anon_sym_LBRACE] = ACTIONS(3996),
    [anon_sym_LT_AT] = ACTIONS(3996),
    [anon_sym_LT_AT_AT] = ACTIONS(3996),
    [anon_sym_AT_AT_GT] = ACTIONS(3996),
    [anon_sym_DOT] = ACTIONS(3996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3994),
    [anon_sym_new] = ACTIONS(3996),
    [anon_sym_return_BANG] = ACTIONS(3994),
    [anon_sym_yield] = ACTIONS(3996),
    [anon_sym_yield_BANG] = ACTIONS(3994),
    [anon_sym_lazy] = ACTIONS(3996),
    [anon_sym_assert] = ACTIONS(3996),
    [anon_sym_upcast] = ACTIONS(3996),
    [anon_sym_downcast] = ACTIONS(3996),
    [anon_sym_COLON_GT] = ACTIONS(3994),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3994),
    [anon_sym_for] = ACTIONS(3996),
    [anon_sym_while] = ACTIONS(3996),
    [anon_sym_if] = ACTIONS(3996),
    [anon_sym_fun] = ACTIONS(3996),
    [anon_sym_try] = ACTIONS(3996),
    [anon_sym_match] = ACTIONS(3996),
    [anon_sym_match_BANG] = ACTIONS(3994),
    [anon_sym_function] = ACTIONS(3996),
    [anon_sym_LT_DASH] = ACTIONS(3996),
    [anon_sym_DOT_LBRACK] = ACTIONS(3994),
    [anon_sym_LT] = ACTIONS(3994),
    [anon_sym_use] = ACTIONS(3996),
    [anon_sym_use_BANG] = ACTIONS(3994),
    [anon_sym_do_BANG] = ACTIONS(3994),
    [anon_sym_begin] = ACTIONS(3996),
    [anon_sym_LPAREN2] = ACTIONS(3996),
    [anon_sym_or] = ACTIONS(3996),
    [aux_sym_char_token1] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3996),
    [anon_sym_DQUOTE] = ACTIONS(3996),
    [anon_sym_AT_DQUOTE] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [sym_bool] = ACTIONS(3996),
    [sym_unit] = ACTIONS(3994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3996),
    [sym_op_identifier] = ACTIONS(3996),
    [anon_sym_PLUS] = ACTIONS(3996),
    [anon_sym_DASH] = ACTIONS(3996),
    [anon_sym_PLUS_DOT] = ACTIONS(3996),
    [anon_sym_DASH_DOT] = ACTIONS(3996),
    [anon_sym_PERCENT] = ACTIONS(3996),
    [anon_sym_AMP_AMP] = ACTIONS(3996),
    [anon_sym_TILDE] = ACTIONS(3994),
    [aux_sym_prefix_op_token1] = ACTIONS(3996),
    [aux_sym_infix_op_token1] = ACTIONS(3994),
    [aux_sym_infix_op_token2] = ACTIONS(3996),
    [anon_sym_PIPE_PIPE] = ACTIONS(3996),
    [anon_sym_BANG_EQ] = ACTIONS(3996),
    [anon_sym_COLON_EQ] = ACTIONS(3994),
    [anon_sym_DOLLAR] = ACTIONS(3996),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3996),
    [sym_int] = ACTIONS(3996),
    [sym_xint] = ACTIONS(3994),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3994),
    [sym__newline] = ACTIONS(3994),
  },
  [3438] = {
    [sym_block_comment] = STATE(3438),
    [sym_compiler_directive_decl] = STATE(3438),
    [sym_fsi_directive_decl] = STATE(3438),
    [sym_preproc_line] = STATE(3438),
    [sym_identifier] = ACTIONS(4170),
    [anon_sym_EQ] = ACTIONS(4168),
    [anon_sym_COLON] = ACTIONS(4170),
    [anon_sym_return] = ACTIONS(4170),
    [anon_sym_do] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_let_BANG] = ACTIONS(4168),
    [anon_sym_LPAREN] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4168),
    [anon_sym_null] = ACTIONS(4170),
    [anon_sym_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_QMARK] = ACTIONS(4170),
    [anon_sym_COLON_COLON] = ACTIONS(4168),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4170),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4168),
    [anon_sym_LBRACE] = ACTIONS(4170),
    [anon_sym_LT_AT] = ACTIONS(4170),
    [anon_sym_LT_AT_AT] = ACTIONS(4170),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4168),
    [anon_sym_new] = ACTIONS(4170),
    [anon_sym_return_BANG] = ACTIONS(4168),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_yield_BANG] = ACTIONS(4168),
    [anon_sym_lazy] = ACTIONS(4170),
    [anon_sym_assert] = ACTIONS(4170),
    [anon_sym_upcast] = ACTIONS(4170),
    [anon_sym_downcast] = ACTIONS(4170),
    [anon_sym_COLON_GT] = ACTIONS(4168),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4168),
    [anon_sym_for] = ACTIONS(4170),
    [anon_sym_while] = ACTIONS(4170),
    [anon_sym_if] = ACTIONS(4170),
    [anon_sym_fun] = ACTIONS(4170),
    [anon_sym_try] = ACTIONS(4170),
    [anon_sym_match] = ACTIONS(4170),
    [anon_sym_match_BANG] = ACTIONS(4168),
    [anon_sym_function] = ACTIONS(4170),
    [anon_sym_LT_DASH] = ACTIONS(4170),
    [anon_sym_DOT_LBRACK] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4168),
    [anon_sym_GT] = ACTIONS(4170),
    [anon_sym_use] = ACTIONS(4170),
    [anon_sym_use_BANG] = ACTIONS(4168),
    [anon_sym_do_BANG] = ACTIONS(4168),
    [anon_sym_begin] = ACTIONS(4170),
    [anon_sym_LPAREN2] = ACTIONS(4170),
    [anon_sym_or] = ACTIONS(4170),
    [aux_sym_char_token1] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4170),
    [anon_sym_DQUOTE] = ACTIONS(4170),
    [anon_sym_AT_DQUOTE] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [sym_bool] = ACTIONS(4170),
    [sym_unit] = ACTIONS(4168),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4170),
    [sym_op_identifier] = ACTIONS(4170),
    [anon_sym_PLUS] = ACTIONS(4170),
    [anon_sym_DASH] = ACTIONS(4170),
    [anon_sym_PLUS_DOT] = ACTIONS(4170),
    [anon_sym_DASH_DOT] = ACTIONS(4170),
    [anon_sym_PERCENT] = ACTIONS(4170),
    [anon_sym_AMP_AMP] = ACTIONS(4170),
    [anon_sym_TILDE] = ACTIONS(4168),
    [aux_sym_prefix_op_token1] = ACTIONS(4170),
    [aux_sym_infix_op_token1] = ACTIONS(4168),
    [aux_sym_infix_op_token2] = ACTIONS(4170),
    [anon_sym_PIPE_PIPE] = ACTIONS(4170),
    [anon_sym_BANG_EQ] = ACTIONS(4170),
    [anon_sym_COLON_EQ] = ACTIONS(4168),
    [anon_sym_DOLLAR] = ACTIONS(4170),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4170),
    [sym_int] = ACTIONS(4170),
    [sym_xint] = ACTIONS(4168),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4168),
    [sym__newline] = ACTIONS(4168),
  },
  [3439] = {
    [sym_block_comment] = STATE(3439),
    [sym_compiler_directive_decl] = STATE(3439),
    [sym_fsi_directive_decl] = STATE(3439),
    [sym_preproc_line] = STATE(3439),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4739),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
    [sym__dedent] = ACTIONS(5919),
  },
  [3440] = {
    [sym_block_comment] = STATE(3440),
    [sym_compiler_directive_decl] = STATE(3440),
    [sym_fsi_directive_decl] = STATE(3440),
    [sym_preproc_line] = STATE(3440),
    [sym_identifier] = ACTIONS(3972),
    [anon_sym_EQ] = ACTIONS(3970),
    [anon_sym_COLON] = ACTIONS(3972),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_do] = ACTIONS(3972),
    [anon_sym_let] = ACTIONS(3972),
    [anon_sym_let_BANG] = ACTIONS(3970),
    [anon_sym_LPAREN] = ACTIONS(3972),
    [anon_sym_COMMA] = ACTIONS(3970),
    [anon_sym_null] = ACTIONS(3972),
    [anon_sym_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_COLON] = ACTIONS(3970),
    [anon_sym_AMP] = ACTIONS(3972),
    [anon_sym_LBRACK] = ACTIONS(3972),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3970),
    [anon_sym_LBRACE] = ACTIONS(3972),
    [anon_sym_LT_AT] = ACTIONS(3972),
    [anon_sym_LT_AT_AT] = ACTIONS(3972),
    [anon_sym_AT_AT_GT] = ACTIONS(3972),
    [anon_sym_DOT] = ACTIONS(3972),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3970),
    [anon_sym_new] = ACTIONS(3972),
    [anon_sym_return_BANG] = ACTIONS(3970),
    [anon_sym_yield] = ACTIONS(3972),
    [anon_sym_yield_BANG] = ACTIONS(3970),
    [anon_sym_lazy] = ACTIONS(3972),
    [anon_sym_assert] = ACTIONS(3972),
    [anon_sym_upcast] = ACTIONS(3972),
    [anon_sym_downcast] = ACTIONS(3972),
    [anon_sym_COLON_GT] = ACTIONS(3970),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3970),
    [anon_sym_for] = ACTIONS(3972),
    [anon_sym_while] = ACTIONS(3972),
    [anon_sym_if] = ACTIONS(3972),
    [anon_sym_fun] = ACTIONS(3972),
    [anon_sym_try] = ACTIONS(3972),
    [anon_sym_match] = ACTIONS(3972),
    [anon_sym_match_BANG] = ACTIONS(3970),
    [anon_sym_function] = ACTIONS(3972),
    [anon_sym_LT_DASH] = ACTIONS(3972),
    [anon_sym_DOT_LBRACK] = ACTIONS(3970),
    [anon_sym_LT] = ACTIONS(3970),
    [anon_sym_use] = ACTIONS(3972),
    [anon_sym_use_BANG] = ACTIONS(3970),
    [anon_sym_do_BANG] = ACTIONS(3970),
    [anon_sym_begin] = ACTIONS(3972),
    [anon_sym_LPAREN2] = ACTIONS(3972),
    [anon_sym_or] = ACTIONS(3972),
    [aux_sym_char_token1] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3972),
    [anon_sym_DQUOTE] = ACTIONS(3972),
    [anon_sym_AT_DQUOTE] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [sym_bool] = ACTIONS(3972),
    [sym_unit] = ACTIONS(3970),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3972),
    [sym_op_identifier] = ACTIONS(3972),
    [anon_sym_PLUS] = ACTIONS(3972),
    [anon_sym_DASH] = ACTIONS(3972),
    [anon_sym_PLUS_DOT] = ACTIONS(3972),
    [anon_sym_DASH_DOT] = ACTIONS(3972),
    [anon_sym_PERCENT] = ACTIONS(3972),
    [anon_sym_AMP_AMP] = ACTIONS(3972),
    [anon_sym_TILDE] = ACTIONS(3970),
    [aux_sym_prefix_op_token1] = ACTIONS(3972),
    [aux_sym_infix_op_token1] = ACTIONS(3970),
    [aux_sym_infix_op_token2] = ACTIONS(3972),
    [anon_sym_PIPE_PIPE] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3972),
    [anon_sym_COLON_EQ] = ACTIONS(3970),
    [anon_sym_DOLLAR] = ACTIONS(3972),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3972),
    [sym_int] = ACTIONS(3972),
    [sym_xint] = ACTIONS(3970),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3970),
    [sym__newline] = ACTIONS(3970),
  },
  [3441] = {
    [sym_block_comment] = STATE(3441),
    [sym_compiler_directive_decl] = STATE(3441),
    [sym_fsi_directive_decl] = STATE(3441),
    [sym_preproc_line] = STATE(3441),
    [aux_sym_long_identifier_repeat1] = STATE(3441),
    [ts_builtin_sym_end] = ACTIONS(3485),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_namespace] = ACTIONS(3487),
    [anon_sym_module] = ACTIONS(3487),
    [anon_sym_open] = ACTIONS(3487),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_type] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_and] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [aux_sym_access_modifier_token1] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3485),
    [anon_sym_DOT] = ACTIONS(5921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3485),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3485),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_member] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_exception] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_val] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3485),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3485),
    [anon_sym_DASH_DOT] = ACTIONS(3485),
    [anon_sym_PERCENT] = ACTIONS(3485),
    [anon_sym_AMP_AMP] = ACTIONS(3485),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3485),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3485),
    [anon_sym_POUNDload] = ACTIONS(3485),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
  },
  [3442] = {
    [sym_block_comment] = STATE(3442),
    [sym_compiler_directive_decl] = STATE(3442),
    [sym_fsi_directive_decl] = STATE(3442),
    [sym_preproc_line] = STATE(3442),
    [sym_identifier] = ACTIONS(4182),
    [anon_sym_EQ] = ACTIONS(3689),
    [anon_sym_COLON] = ACTIONS(4182),
    [anon_sym_return] = ACTIONS(4182),
    [anon_sym_do] = ACTIONS(4182),
    [anon_sym_let] = ACTIONS(4182),
    [anon_sym_let_BANG] = ACTIONS(3689),
    [anon_sym_LPAREN] = ACTIONS(4182),
    [anon_sym_COMMA] = ACTIONS(3689),
    [anon_sym_null] = ACTIONS(4182),
    [anon_sym_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3689),
    [anon_sym_LBRACE] = ACTIONS(4182),
    [anon_sym_LT_AT] = ACTIONS(4182),
    [anon_sym_LT_AT_AT] = ACTIONS(4182),
    [anon_sym_DOT] = ACTIONS(4182),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3689),
    [anon_sym_new] = ACTIONS(4182),
    [anon_sym_return_BANG] = ACTIONS(3689),
    [anon_sym_yield] = ACTIONS(4182),
    [anon_sym_yield_BANG] = ACTIONS(3689),
    [anon_sym_lazy] = ACTIONS(4182),
    [anon_sym_assert] = ACTIONS(4182),
    [anon_sym_upcast] = ACTIONS(4182),
    [anon_sym_downcast] = ACTIONS(4182),
    [anon_sym_COLON_GT] = ACTIONS(3689),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3689),
    [anon_sym_for] = ACTIONS(4182),
    [anon_sym_while] = ACTIONS(4182),
    [anon_sym_if] = ACTIONS(4182),
    [anon_sym_fun] = ACTIONS(4182),
    [anon_sym_try] = ACTIONS(4182),
    [anon_sym_match] = ACTIONS(4182),
    [anon_sym_match_BANG] = ACTIONS(3689),
    [anon_sym_function] = ACTIONS(4182),
    [anon_sym_LT_DASH] = ACTIONS(4182),
    [anon_sym_DOT_LBRACK] = ACTIONS(3689),
    [anon_sym_LT] = ACTIONS(3689),
    [anon_sym_use] = ACTIONS(4182),
    [anon_sym_use_BANG] = ACTIONS(3689),
    [anon_sym_do_BANG] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(4182),
    [anon_sym_LPAREN2] = ACTIONS(4182),
    [anon_sym_or] = ACTIONS(4182),
    [aux_sym_char_token1] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4182),
    [anon_sym_DQUOTE] = ACTIONS(4182),
    [anon_sym_AT_DQUOTE] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [sym_bool] = ACTIONS(4182),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4182),
    [sym_op_identifier] = ACTIONS(4182),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_PLUS_DOT] = ACTIONS(4182),
    [anon_sym_DASH_DOT] = ACTIONS(4182),
    [anon_sym_PERCENT] = ACTIONS(4182),
    [anon_sym_AMP_AMP] = ACTIONS(4182),
    [anon_sym_TILDE] = ACTIONS(3689),
    [aux_sym_prefix_op_token1] = ACTIONS(4182),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token2] = ACTIONS(4182),
    [anon_sym_PIPE_PIPE] = ACTIONS(4182),
    [anon_sym_BANG_EQ] = ACTIONS(4182),
    [anon_sym_COLON_EQ] = ACTIONS(3689),
    [anon_sym_DOLLAR] = ACTIONS(4182),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4182),
    [sym_int] = ACTIONS(4182),
    [sym_xint] = ACTIONS(3689),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3689),
    [anon_sym_POUNDendif] = ACTIONS(4973),
    [sym__newline] = ACTIONS(3689),
  },
  [3443] = {
    [sym_block_comment] = STATE(3443),
    [sym_compiler_directive_decl] = STATE(3443),
    [sym_fsi_directive_decl] = STATE(3443),
    [sym_preproc_line] = STATE(3443),
    [aux_sym_long_identifier_repeat1] = STATE(3436),
    [ts_builtin_sym_end] = ACTIONS(3492),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_namespace] = ACTIONS(3494),
    [anon_sym_module] = ACTIONS(3494),
    [anon_sym_open] = ACTIONS(3494),
    [anon_sym_LBRACK_LT] = ACTIONS(3492),
    [anon_sym_return] = ACTIONS(3494),
    [anon_sym_type] = ACTIONS(3494),
    [anon_sym_do] = ACTIONS(3494),
    [anon_sym_and] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_let_BANG] = ACTIONS(3492),
    [aux_sym_access_modifier_token1] = ACTIONS(3492),
    [anon_sym_LPAREN] = ACTIONS(3494),
    [anon_sym_null] = ACTIONS(3494),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3492),
    [anon_sym_LBRACE] = ACTIONS(3494),
    [anon_sym_LT_AT] = ACTIONS(3494),
    [anon_sym_LT_AT_AT] = ACTIONS(3492),
    [anon_sym_DOT] = ACTIONS(5603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3492),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_with] = ACTIONS(3494),
    [anon_sym_return_BANG] = ACTIONS(3492),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_yield_BANG] = ACTIONS(3492),
    [anon_sym_lazy] = ACTIONS(3494),
    [anon_sym_assert] = ACTIONS(3494),
    [anon_sym_upcast] = ACTIONS(3494),
    [anon_sym_downcast] = ACTIONS(3494),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_while] = ACTIONS(3494),
    [anon_sym_if] = ACTIONS(3494),
    [anon_sym_fun] = ACTIONS(3494),
    [anon_sym_DASH_GT] = ACTIONS(3492),
    [anon_sym_try] = ACTIONS(3494),
    [anon_sym_match] = ACTIONS(3494),
    [anon_sym_match_BANG] = ACTIONS(3492),
    [anon_sym_function] = ACTIONS(3494),
    [anon_sym_use] = ACTIONS(3494),
    [anon_sym_use_BANG] = ACTIONS(3492),
    [anon_sym_do_BANG] = ACTIONS(3492),
    [anon_sym_begin] = ACTIONS(3494),
    [anon_sym_STAR] = ACTIONS(3492),
    [anon_sym_LT2] = ACTIONS(3494),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3492),
    [anon_sym_default] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_member] = ACTIONS(3494),
    [anon_sym_interface] = ACTIONS(3494),
    [anon_sym_exception] = ACTIONS(3494),
    [anon_sym_abstract] = ACTIONS(3494),
    [anon_sym_val] = ACTIONS(3494),
    [anon_sym_override] = ACTIONS(3494),
    [aux_sym_char_token1] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3494),
    [anon_sym_DQUOTE] = ACTIONS(3494),
    [anon_sym_AT_DQUOTE] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [sym_bool] = ACTIONS(3494),
    [sym_unit] = ACTIONS(3492),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3494),
    [sym_op_identifier] = ACTIONS(3492),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_PLUS_DOT] = ACTIONS(3492),
    [anon_sym_DASH_DOT] = ACTIONS(3492),
    [anon_sym_PERCENT] = ACTIONS(3492),
    [anon_sym_AMP_AMP] = ACTIONS(3492),
    [anon_sym_TILDE] = ACTIONS(3492),
    [aux_sym_prefix_op_token1] = ACTIONS(3492),
    [sym_int] = ACTIONS(3494),
    [sym_xint] = ACTIONS(3492),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3492),
    [anon_sym_POUNDload] = ACTIONS(3492),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3492),
  },
  [3444] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_type_arguments] = STATE(3812),
    [sym__method_defn] = STATE(3759),
    [sym__property_defn] = STATE(3819),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3444),
    [sym_compiler_directive_decl] = STATE(3444),
    [sym_fsi_directive_decl] = STATE(3444),
    [sym_preproc_line] = STATE(3444),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3737),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(5924),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_COLON] = ACTIONS(5926),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [anon_sym_with] = ACTIONS(5928),
    [anon_sym_LT2] = ACTIONS(5809),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3445] = {
    [sym_block_comment] = STATE(3445),
    [sym_compiler_directive_decl] = STATE(3445),
    [sym_fsi_directive_decl] = STATE(3445),
    [sym_preproc_line] = STATE(3445),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_AT_AT_GT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(5930),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
  },
  [3446] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_type_arguments] = STATE(3877),
    [sym__method_defn] = STATE(6975),
    [sym__property_defn] = STATE(7073),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3446),
    [sym_compiler_directive_decl] = STATE(3446),
    [sym_fsi_directive_decl] = STATE(3446),
    [sym_preproc_line] = STATE(3446),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3752),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(5932),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_COLON] = ACTIONS(5934),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [anon_sym_with] = ACTIONS(5936),
    [anon_sym_LT2] = ACTIONS(5809),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3447] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_type_arguments] = STATE(3839),
    [sym__method_defn] = STATE(6927),
    [sym__property_defn] = STATE(6933),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3447),
    [sym_compiler_directive_decl] = STATE(3447),
    [sym_fsi_directive_decl] = STATE(3447),
    [sym_preproc_line] = STATE(3447),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3727),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(5938),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_COLON] = ACTIONS(5940),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [anon_sym_with] = ACTIONS(5942),
    [anon_sym_LT2] = ACTIONS(5809),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3448] = {
    [sym_block_comment] = STATE(3448),
    [sym_compiler_directive_decl] = STATE(3448),
    [sym_fsi_directive_decl] = STATE(3448),
    [sym_preproc_line] = STATE(3448),
    [sym_identifier] = ACTIONS(3946),
    [anon_sym_EQ] = ACTIONS(3944),
    [anon_sym_COLON] = ACTIONS(3946),
    [anon_sym_return] = ACTIONS(3946),
    [anon_sym_do] = ACTIONS(3946),
    [anon_sym_let] = ACTIONS(3946),
    [anon_sym_let_BANG] = ACTIONS(3944),
    [anon_sym_LPAREN] = ACTIONS(3946),
    [anon_sym_COMMA] = ACTIONS(3944),
    [anon_sym_null] = ACTIONS(3946),
    [anon_sym_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LBRACK] = ACTIONS(3946),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3944),
    [anon_sym_LBRACE] = ACTIONS(3946),
    [anon_sym_LT_AT] = ACTIONS(3946),
    [anon_sym_LT_AT_AT] = ACTIONS(3946),
    [anon_sym_AT_AT_GT] = ACTIONS(3946),
    [anon_sym_DOT] = ACTIONS(3946),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3944),
    [anon_sym_new] = ACTIONS(3946),
    [anon_sym_return_BANG] = ACTIONS(3944),
    [anon_sym_yield] = ACTIONS(3946),
    [anon_sym_yield_BANG] = ACTIONS(3944),
    [anon_sym_lazy] = ACTIONS(3946),
    [anon_sym_assert] = ACTIONS(3946),
    [anon_sym_upcast] = ACTIONS(3946),
    [anon_sym_downcast] = ACTIONS(3946),
    [anon_sym_COLON_GT] = ACTIONS(3944),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3944),
    [anon_sym_for] = ACTIONS(3946),
    [anon_sym_while] = ACTIONS(3946),
    [anon_sym_if] = ACTIONS(3946),
    [anon_sym_fun] = ACTIONS(3946),
    [anon_sym_try] = ACTIONS(3946),
    [anon_sym_match] = ACTIONS(3946),
    [anon_sym_match_BANG] = ACTIONS(3944),
    [anon_sym_function] = ACTIONS(3946),
    [anon_sym_LT_DASH] = ACTIONS(3946),
    [anon_sym_DOT_LBRACK] = ACTIONS(3944),
    [anon_sym_LT] = ACTIONS(3944),
    [anon_sym_use] = ACTIONS(3946),
    [anon_sym_use_BANG] = ACTIONS(3944),
    [anon_sym_do_BANG] = ACTIONS(3944),
    [anon_sym_begin] = ACTIONS(3946),
    [anon_sym_LPAREN2] = ACTIONS(3946),
    [anon_sym_or] = ACTIONS(3946),
    [aux_sym_char_token1] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_AT_DQUOTE] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [sym_bool] = ACTIONS(3946),
    [sym_unit] = ACTIONS(3944),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3946),
    [sym_op_identifier] = ACTIONS(3946),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PLUS_DOT] = ACTIONS(3946),
    [anon_sym_DASH_DOT] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3946),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_TILDE] = ACTIONS(3944),
    [aux_sym_prefix_op_token1] = ACTIONS(3946),
    [aux_sym_infix_op_token1] = ACTIONS(3944),
    [aux_sym_infix_op_token2] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [anon_sym_BANG_EQ] = ACTIONS(3946),
    [anon_sym_COLON_EQ] = ACTIONS(3944),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3946),
    [sym_int] = ACTIONS(3946),
    [sym_xint] = ACTIONS(3944),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3944),
    [sym__newline] = ACTIONS(3944),
  },
  [3449] = {
    [sym_block_comment] = STATE(3449),
    [sym_compiler_directive_decl] = STATE(3449),
    [sym_fsi_directive_decl] = STATE(3449),
    [sym_preproc_line] = STATE(3449),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_AT_AT_GT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [3450] = {
    [sym_block_comment] = STATE(3450),
    [sym_compiler_directive_decl] = STATE(3450),
    [sym_fsi_directive_decl] = STATE(3450),
    [sym_preproc_line] = STATE(3450),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_COLON] = ACTIONS(3867),
    [anon_sym_return] = ACTIONS(3867),
    [anon_sym_do] = ACTIONS(3867),
    [anon_sym_let] = ACTIONS(3867),
    [anon_sym_let_BANG] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(3867),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_null] = ACTIONS(3867),
    [anon_sym_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_COLON] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3867),
    [anon_sym_LBRACK] = ACTIONS(3867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3867),
    [anon_sym_LT_AT] = ACTIONS(3867),
    [anon_sym_LT_AT_AT] = ACTIONS(3867),
    [anon_sym_DOT] = ACTIONS(3867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3867),
    [anon_sym_return_BANG] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3867),
    [anon_sym_yield_BANG] = ACTIONS(3865),
    [anon_sym_lazy] = ACTIONS(3867),
    [anon_sym_assert] = ACTIONS(3867),
    [anon_sym_upcast] = ACTIONS(3867),
    [anon_sym_downcast] = ACTIONS(3867),
    [anon_sym_COLON_GT] = ACTIONS(3865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3867),
    [anon_sym_while] = ACTIONS(3867),
    [anon_sym_if] = ACTIONS(3867),
    [anon_sym_fun] = ACTIONS(3867),
    [anon_sym_try] = ACTIONS(3867),
    [anon_sym_match] = ACTIONS(3867),
    [anon_sym_match_BANG] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(3867),
    [anon_sym_DOT_LBRACK] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_use] = ACTIONS(3867),
    [anon_sym_use_BANG] = ACTIONS(3865),
    [anon_sym_do_BANG] = ACTIONS(3865),
    [anon_sym_DOT_DOT] = ACTIONS(3865),
    [anon_sym_begin] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(3867),
    [anon_sym_or] = ACTIONS(3867),
    [aux_sym_char_token1] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3867),
    [anon_sym_DQUOTE] = ACTIONS(3867),
    [anon_sym_AT_DQUOTE] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [sym_bool] = ACTIONS(3867),
    [sym_unit] = ACTIONS(3865),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3867),
    [sym_op_identifier] = ACTIONS(3867),
    [anon_sym_PLUS] = ACTIONS(3867),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_PLUS_DOT] = ACTIONS(3867),
    [anon_sym_DASH_DOT] = ACTIONS(3867),
    [anon_sym_PERCENT] = ACTIONS(3867),
    [anon_sym_AMP_AMP] = ACTIONS(3867),
    [anon_sym_TILDE] = ACTIONS(3865),
    [aux_sym_prefix_op_token1] = ACTIONS(3867),
    [aux_sym_infix_op_token1] = ACTIONS(3865),
    [aux_sym_infix_op_token2] = ACTIONS(3867),
    [anon_sym_PIPE_PIPE] = ACTIONS(3867),
    [anon_sym_BANG_EQ] = ACTIONS(3867),
    [anon_sym_COLON_EQ] = ACTIONS(3865),
    [anon_sym_DOLLAR] = ACTIONS(3867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3867),
    [sym_int] = ACTIONS(3867),
    [sym_xint] = ACTIONS(3865),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3865),
    [sym__newline] = ACTIONS(3865),
  },
  [3451] = {
    [sym_block_comment] = STATE(3451),
    [sym_compiler_directive_decl] = STATE(3451),
    [sym_fsi_directive_decl] = STATE(3451),
    [sym_preproc_line] = STATE(3451),
    [sym_identifier] = ACTIONS(4182),
    [anon_sym_EQ] = ACTIONS(3689),
    [anon_sym_COLON] = ACTIONS(4182),
    [anon_sym_return] = ACTIONS(4182),
    [anon_sym_do] = ACTIONS(4182),
    [anon_sym_let] = ACTIONS(4182),
    [anon_sym_let_BANG] = ACTIONS(3689),
    [anon_sym_LPAREN] = ACTIONS(4182),
    [anon_sym_COMMA] = ACTIONS(3689),
    [anon_sym_null] = ACTIONS(4182),
    [anon_sym_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3689),
    [anon_sym_LBRACE] = ACTIONS(4182),
    [anon_sym_LT_AT] = ACTIONS(4182),
    [anon_sym_LT_AT_AT] = ACTIONS(4182),
    [anon_sym_DOT] = ACTIONS(4182),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3689),
    [anon_sym_new] = ACTIONS(4182),
    [anon_sym_return_BANG] = ACTIONS(3689),
    [anon_sym_yield] = ACTIONS(4182),
    [anon_sym_yield_BANG] = ACTIONS(3689),
    [anon_sym_lazy] = ACTIONS(4182),
    [anon_sym_assert] = ACTIONS(4182),
    [anon_sym_upcast] = ACTIONS(4182),
    [anon_sym_downcast] = ACTIONS(4182),
    [anon_sym_COLON_GT] = ACTIONS(3689),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3689),
    [anon_sym_for] = ACTIONS(4182),
    [anon_sym_while] = ACTIONS(4182),
    [anon_sym_if] = ACTIONS(4182),
    [anon_sym_fun] = ACTIONS(4182),
    [anon_sym_try] = ACTIONS(4182),
    [anon_sym_match] = ACTIONS(4182),
    [anon_sym_match_BANG] = ACTIONS(3689),
    [anon_sym_function] = ACTIONS(4182),
    [anon_sym_LT_DASH] = ACTIONS(4182),
    [anon_sym_DOT_LBRACK] = ACTIONS(3689),
    [anon_sym_LT] = ACTIONS(3689),
    [anon_sym_GT] = ACTIONS(4182),
    [anon_sym_use] = ACTIONS(4182),
    [anon_sym_use_BANG] = ACTIONS(3689),
    [anon_sym_do_BANG] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(4182),
    [anon_sym_LPAREN2] = ACTIONS(4182),
    [anon_sym_or] = ACTIONS(4182),
    [aux_sym_char_token1] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4182),
    [anon_sym_DQUOTE] = ACTIONS(4182),
    [anon_sym_AT_DQUOTE] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [sym_bool] = ACTIONS(4182),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4182),
    [sym_op_identifier] = ACTIONS(4182),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_PLUS_DOT] = ACTIONS(4182),
    [anon_sym_DASH_DOT] = ACTIONS(4182),
    [anon_sym_PERCENT] = ACTIONS(4182),
    [anon_sym_AMP_AMP] = ACTIONS(4182),
    [anon_sym_TILDE] = ACTIONS(3689),
    [aux_sym_prefix_op_token1] = ACTIONS(4182),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token2] = ACTIONS(4182),
    [anon_sym_PIPE_PIPE] = ACTIONS(4182),
    [anon_sym_BANG_EQ] = ACTIONS(4182),
    [anon_sym_COLON_EQ] = ACTIONS(3689),
    [anon_sym_DOLLAR] = ACTIONS(4182),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4182),
    [sym_int] = ACTIONS(4182),
    [sym_xint] = ACTIONS(3689),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3689),
    [sym__newline] = ACTIONS(3689),
  },
  [3452] = {
    [sym_block_comment] = STATE(3452),
    [sym_compiler_directive_decl] = STATE(3452),
    [sym_fsi_directive_decl] = STATE(3452),
    [sym_preproc_line] = STATE(3452),
    [sym_identifier] = ACTIONS(4162),
    [anon_sym_EQ] = ACTIONS(4160),
    [anon_sym_COLON] = ACTIONS(4162),
    [anon_sym_return] = ACTIONS(4162),
    [anon_sym_do] = ACTIONS(4162),
    [anon_sym_let] = ACTIONS(4162),
    [anon_sym_let_BANG] = ACTIONS(4160),
    [anon_sym_LPAREN] = ACTIONS(4162),
    [anon_sym_COMMA] = ACTIONS(4160),
    [anon_sym_null] = ACTIONS(4162),
    [anon_sym_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4160),
    [anon_sym_AMP] = ACTIONS(4162),
    [anon_sym_LBRACK] = ACTIONS(4162),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4160),
    [anon_sym_LBRACE] = ACTIONS(4162),
    [anon_sym_LT_AT] = ACTIONS(4162),
    [anon_sym_LT_AT_AT] = ACTIONS(4162),
    [anon_sym_DOT] = ACTIONS(4162),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4160),
    [anon_sym_new] = ACTIONS(4162),
    [anon_sym_return_BANG] = ACTIONS(4160),
    [anon_sym_yield] = ACTIONS(4162),
    [anon_sym_yield_BANG] = ACTIONS(4160),
    [anon_sym_lazy] = ACTIONS(4162),
    [anon_sym_assert] = ACTIONS(4162),
    [anon_sym_upcast] = ACTIONS(4162),
    [anon_sym_downcast] = ACTIONS(4162),
    [anon_sym_COLON_GT] = ACTIONS(4160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4160),
    [anon_sym_for] = ACTIONS(4162),
    [anon_sym_while] = ACTIONS(4162),
    [anon_sym_if] = ACTIONS(4162),
    [anon_sym_fun] = ACTIONS(4162),
    [anon_sym_try] = ACTIONS(4162),
    [anon_sym_match] = ACTIONS(4162),
    [anon_sym_match_BANG] = ACTIONS(4160),
    [anon_sym_function] = ACTIONS(4162),
    [anon_sym_LT_DASH] = ACTIONS(4162),
    [anon_sym_DOT_LBRACK] = ACTIONS(4160),
    [anon_sym_LT] = ACTIONS(4160),
    [anon_sym_GT] = ACTIONS(4162),
    [anon_sym_use] = ACTIONS(4162),
    [anon_sym_use_BANG] = ACTIONS(4160),
    [anon_sym_do_BANG] = ACTIONS(4160),
    [anon_sym_begin] = ACTIONS(4162),
    [anon_sym_LPAREN2] = ACTIONS(4162),
    [anon_sym_or] = ACTIONS(4162),
    [aux_sym_char_token1] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4162),
    [anon_sym_DQUOTE] = ACTIONS(4162),
    [anon_sym_AT_DQUOTE] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [sym_bool] = ACTIONS(4162),
    [sym_unit] = ACTIONS(4160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4162),
    [sym_op_identifier] = ACTIONS(4162),
    [anon_sym_PLUS] = ACTIONS(4162),
    [anon_sym_DASH] = ACTIONS(4162),
    [anon_sym_PLUS_DOT] = ACTIONS(4162),
    [anon_sym_DASH_DOT] = ACTIONS(4162),
    [anon_sym_PERCENT] = ACTIONS(4162),
    [anon_sym_AMP_AMP] = ACTIONS(4162),
    [anon_sym_TILDE] = ACTIONS(4160),
    [aux_sym_prefix_op_token1] = ACTIONS(4162),
    [aux_sym_infix_op_token1] = ACTIONS(4160),
    [aux_sym_infix_op_token2] = ACTIONS(4162),
    [anon_sym_PIPE_PIPE] = ACTIONS(4162),
    [anon_sym_BANG_EQ] = ACTIONS(4162),
    [anon_sym_COLON_EQ] = ACTIONS(4160),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4162),
    [sym_int] = ACTIONS(4162),
    [sym_xint] = ACTIONS(4160),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4160),
    [sym__newline] = ACTIONS(4160),
  },
  [3453] = {
    [sym_block_comment] = STATE(3453),
    [sym_compiler_directive_decl] = STATE(3453),
    [sym_fsi_directive_decl] = STATE(3453),
    [sym_preproc_line] = STATE(3453),
    [sym_identifier] = ACTIONS(4104),
    [anon_sym_EQ] = ACTIONS(4102),
    [anon_sym_COLON] = ACTIONS(4104),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_do] = ACTIONS(4104),
    [anon_sym_let] = ACTIONS(4104),
    [anon_sym_let_BANG] = ACTIONS(4102),
    [anon_sym_LPAREN] = ACTIONS(4104),
    [anon_sym_COMMA] = ACTIONS(4102),
    [anon_sym_null] = ACTIONS(4104),
    [anon_sym_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_COLON] = ACTIONS(4102),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4104),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4102),
    [anon_sym_LBRACE] = ACTIONS(4104),
    [anon_sym_LT_AT] = ACTIONS(4104),
    [anon_sym_LT_AT_AT] = ACTIONS(4104),
    [anon_sym_AT_AT_GT] = ACTIONS(4104),
    [anon_sym_DOT] = ACTIONS(4104),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4102),
    [anon_sym_new] = ACTIONS(4104),
    [anon_sym_return_BANG] = ACTIONS(4102),
    [anon_sym_yield] = ACTIONS(4104),
    [anon_sym_yield_BANG] = ACTIONS(4102),
    [anon_sym_lazy] = ACTIONS(4104),
    [anon_sym_assert] = ACTIONS(4104),
    [anon_sym_upcast] = ACTIONS(4104),
    [anon_sym_downcast] = ACTIONS(4104),
    [anon_sym_COLON_GT] = ACTIONS(4102),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4102),
    [anon_sym_for] = ACTIONS(4104),
    [anon_sym_while] = ACTIONS(4104),
    [anon_sym_if] = ACTIONS(4104),
    [anon_sym_fun] = ACTIONS(4104),
    [anon_sym_try] = ACTIONS(4104),
    [anon_sym_match] = ACTIONS(4104),
    [anon_sym_match_BANG] = ACTIONS(4102),
    [anon_sym_function] = ACTIONS(4104),
    [anon_sym_LT_DASH] = ACTIONS(4104),
    [anon_sym_DOT_LBRACK] = ACTIONS(4102),
    [anon_sym_LT] = ACTIONS(4102),
    [anon_sym_use] = ACTIONS(4104),
    [anon_sym_use_BANG] = ACTIONS(4102),
    [anon_sym_do_BANG] = ACTIONS(4102),
    [anon_sym_begin] = ACTIONS(4104),
    [anon_sym_LPAREN2] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [aux_sym_char_token1] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4104),
    [anon_sym_DQUOTE] = ACTIONS(4104),
    [anon_sym_AT_DQUOTE] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [sym_bool] = ACTIONS(4104),
    [sym_unit] = ACTIONS(4102),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4104),
    [sym_op_identifier] = ACTIONS(4104),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_PLUS_DOT] = ACTIONS(4104),
    [anon_sym_DASH_DOT] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_AMP_AMP] = ACTIONS(4104),
    [anon_sym_TILDE] = ACTIONS(4102),
    [aux_sym_prefix_op_token1] = ACTIONS(4104),
    [aux_sym_infix_op_token1] = ACTIONS(4102),
    [aux_sym_infix_op_token2] = ACTIONS(4104),
    [anon_sym_PIPE_PIPE] = ACTIONS(4104),
    [anon_sym_BANG_EQ] = ACTIONS(4104),
    [anon_sym_COLON_EQ] = ACTIONS(4102),
    [anon_sym_DOLLAR] = ACTIONS(4104),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4104),
    [sym_int] = ACTIONS(4104),
    [sym_xint] = ACTIONS(4102),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4102),
    [sym__newline] = ACTIONS(4102),
  },
  [3454] = {
    [sym_block_comment] = STATE(3454),
    [sym_compiler_directive_decl] = STATE(3454),
    [sym_fsi_directive_decl] = STATE(3454),
    [sym_preproc_line] = STATE(3454),
    [sym_identifier] = ACTIONS(4137),
    [anon_sym_EQ] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4137),
    [anon_sym_return] = ACTIONS(4137),
    [anon_sym_do] = ACTIONS(4137),
    [anon_sym_let] = ACTIONS(4137),
    [anon_sym_let_BANG] = ACTIONS(4135),
    [anon_sym_LPAREN] = ACTIONS(4137),
    [anon_sym_COMMA] = ACTIONS(4135),
    [anon_sym_null] = ACTIONS(4137),
    [anon_sym_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_COLON] = ACTIONS(4135),
    [anon_sym_AMP] = ACTIONS(4137),
    [anon_sym_LBRACK] = ACTIONS(4137),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4135),
    [anon_sym_LBRACE] = ACTIONS(4137),
    [anon_sym_LT_AT] = ACTIONS(4137),
    [anon_sym_LT_AT_AT] = ACTIONS(4137),
    [anon_sym_AT_AT_GT] = ACTIONS(4137),
    [anon_sym_DOT] = ACTIONS(4137),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4135),
    [anon_sym_new] = ACTIONS(4137),
    [anon_sym_return_BANG] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_yield_BANG] = ACTIONS(4135),
    [anon_sym_lazy] = ACTIONS(4137),
    [anon_sym_assert] = ACTIONS(4137),
    [anon_sym_upcast] = ACTIONS(4137),
    [anon_sym_downcast] = ACTIONS(4137),
    [anon_sym_COLON_GT] = ACTIONS(4135),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4135),
    [anon_sym_for] = ACTIONS(4137),
    [anon_sym_while] = ACTIONS(4137),
    [anon_sym_if] = ACTIONS(4137),
    [anon_sym_fun] = ACTIONS(4137),
    [anon_sym_try] = ACTIONS(4137),
    [anon_sym_match] = ACTIONS(4137),
    [anon_sym_match_BANG] = ACTIONS(4135),
    [anon_sym_function] = ACTIONS(4137),
    [anon_sym_LT_DASH] = ACTIONS(4137),
    [anon_sym_DOT_LBRACK] = ACTIONS(4135),
    [anon_sym_LT] = ACTIONS(4135),
    [anon_sym_use] = ACTIONS(4137),
    [anon_sym_use_BANG] = ACTIONS(4135),
    [anon_sym_do_BANG] = ACTIONS(4135),
    [anon_sym_begin] = ACTIONS(4137),
    [anon_sym_LPAREN2] = ACTIONS(4137),
    [anon_sym_or] = ACTIONS(4137),
    [aux_sym_char_token1] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4137),
    [anon_sym_DQUOTE] = ACTIONS(4137),
    [anon_sym_AT_DQUOTE] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [sym_bool] = ACTIONS(4137),
    [sym_unit] = ACTIONS(4135),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4137),
    [sym_op_identifier] = ACTIONS(4137),
    [anon_sym_PLUS] = ACTIONS(4137),
    [anon_sym_DASH] = ACTIONS(4137),
    [anon_sym_PLUS_DOT] = ACTIONS(4137),
    [anon_sym_DASH_DOT] = ACTIONS(4137),
    [anon_sym_PERCENT] = ACTIONS(4137),
    [anon_sym_AMP_AMP] = ACTIONS(4137),
    [anon_sym_TILDE] = ACTIONS(4135),
    [aux_sym_prefix_op_token1] = ACTIONS(4137),
    [aux_sym_infix_op_token1] = ACTIONS(4135),
    [aux_sym_infix_op_token2] = ACTIONS(4137),
    [anon_sym_PIPE_PIPE] = ACTIONS(4137),
    [anon_sym_BANG_EQ] = ACTIONS(4137),
    [anon_sym_COLON_EQ] = ACTIONS(4135),
    [anon_sym_DOLLAR] = ACTIONS(4137),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4137),
    [sym_int] = ACTIONS(4137),
    [sym_xint] = ACTIONS(4135),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4135),
    [sym__newline] = ACTIONS(4135),
  },
  [3455] = {
    [sym_block_comment] = STATE(3455),
    [sym_compiler_directive_decl] = STATE(3455),
    [sym_fsi_directive_decl] = STATE(3455),
    [sym_preproc_line] = STATE(3455),
    [sym_identifier] = ACTIONS(3881),
    [anon_sym_EQ] = ACTIONS(3879),
    [anon_sym_COLON] = ACTIONS(3881),
    [anon_sym_return] = ACTIONS(3881),
    [anon_sym_do] = ACTIONS(3881),
    [anon_sym_let] = ACTIONS(3881),
    [anon_sym_let_BANG] = ACTIONS(3879),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3879),
    [anon_sym_null] = ACTIONS(3881),
    [anon_sym_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3879),
    [anon_sym_LBRACE] = ACTIONS(3881),
    [anon_sym_LT_AT] = ACTIONS(3881),
    [anon_sym_LT_AT_AT] = ACTIONS(3881),
    [anon_sym_DOT] = ACTIONS(3881),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3879),
    [anon_sym_new] = ACTIONS(3881),
    [anon_sym_return_BANG] = ACTIONS(3879),
    [anon_sym_yield] = ACTIONS(3881),
    [anon_sym_yield_BANG] = ACTIONS(3879),
    [anon_sym_lazy] = ACTIONS(3881),
    [anon_sym_assert] = ACTIONS(3881),
    [anon_sym_upcast] = ACTIONS(3881),
    [anon_sym_downcast] = ACTIONS(3881),
    [anon_sym_COLON_GT] = ACTIONS(3879),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3879),
    [anon_sym_for] = ACTIONS(3881),
    [anon_sym_while] = ACTIONS(3881),
    [anon_sym_if] = ACTIONS(3881),
    [anon_sym_fun] = ACTIONS(3881),
    [anon_sym_try] = ACTIONS(3881),
    [anon_sym_match] = ACTIONS(3881),
    [anon_sym_match_BANG] = ACTIONS(3879),
    [anon_sym_function] = ACTIONS(3881),
    [anon_sym_LT_DASH] = ACTIONS(3881),
    [anon_sym_DOT_LBRACK] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_use] = ACTIONS(3881),
    [anon_sym_use_BANG] = ACTIONS(3879),
    [anon_sym_do_BANG] = ACTIONS(3879),
    [anon_sym_DOT_DOT] = ACTIONS(3879),
    [anon_sym_begin] = ACTIONS(3881),
    [anon_sym_LPAREN2] = ACTIONS(3881),
    [anon_sym_or] = ACTIONS(3881),
    [aux_sym_char_token1] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3881),
    [anon_sym_DQUOTE] = ACTIONS(3881),
    [anon_sym_AT_DQUOTE] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [sym_bool] = ACTIONS(3881),
    [sym_unit] = ACTIONS(3879),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3881),
    [sym_op_identifier] = ACTIONS(3881),
    [anon_sym_PLUS] = ACTIONS(3881),
    [anon_sym_DASH] = ACTIONS(3881),
    [anon_sym_PLUS_DOT] = ACTIONS(3881),
    [anon_sym_DASH_DOT] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(3881),
    [anon_sym_AMP_AMP] = ACTIONS(3881),
    [anon_sym_TILDE] = ACTIONS(3879),
    [aux_sym_prefix_op_token1] = ACTIONS(3881),
    [aux_sym_infix_op_token1] = ACTIONS(3879),
    [aux_sym_infix_op_token2] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE] = ACTIONS(3881),
    [anon_sym_BANG_EQ] = ACTIONS(3881),
    [anon_sym_COLON_EQ] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3881),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3881),
    [sym_int] = ACTIONS(3881),
    [sym_xint] = ACTIONS(3879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3879),
    [sym__newline] = ACTIONS(3879),
  },
  [3456] = {
    [sym_block_comment] = STATE(3456),
    [sym_compiler_directive_decl] = STATE(3456),
    [sym_fsi_directive_decl] = STATE(3456),
    [sym_preproc_line] = STATE(3456),
    [sym_identifier] = ACTIONS(4158),
    [anon_sym_EQ] = ACTIONS(4156),
    [anon_sym_COLON] = ACTIONS(4158),
    [anon_sym_return] = ACTIONS(4158),
    [anon_sym_do] = ACTIONS(4158),
    [anon_sym_let] = ACTIONS(4158),
    [anon_sym_let_BANG] = ACTIONS(4156),
    [anon_sym_LPAREN] = ACTIONS(4158),
    [anon_sym_COMMA] = ACTIONS(4156),
    [anon_sym_null] = ACTIONS(4158),
    [anon_sym_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_COLON] = ACTIONS(4156),
    [anon_sym_AMP] = ACTIONS(4158),
    [anon_sym_LBRACK] = ACTIONS(4158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(4158),
    [anon_sym_LT_AT] = ACTIONS(4158),
    [anon_sym_LT_AT_AT] = ACTIONS(4158),
    [anon_sym_DOT] = ACTIONS(4158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4156),
    [anon_sym_new] = ACTIONS(4158),
    [anon_sym_return_BANG] = ACTIONS(4156),
    [anon_sym_yield] = ACTIONS(4158),
    [anon_sym_yield_BANG] = ACTIONS(4156),
    [anon_sym_lazy] = ACTIONS(4158),
    [anon_sym_assert] = ACTIONS(4158),
    [anon_sym_upcast] = ACTIONS(4158),
    [anon_sym_downcast] = ACTIONS(4158),
    [anon_sym_COLON_GT] = ACTIONS(4156),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4156),
    [anon_sym_for] = ACTIONS(4158),
    [anon_sym_while] = ACTIONS(4158),
    [anon_sym_if] = ACTIONS(4158),
    [anon_sym_fun] = ACTIONS(4158),
    [anon_sym_try] = ACTIONS(4158),
    [anon_sym_match] = ACTIONS(4158),
    [anon_sym_match_BANG] = ACTIONS(4156),
    [anon_sym_function] = ACTIONS(4158),
    [anon_sym_LT_DASH] = ACTIONS(4158),
    [anon_sym_DOT_LBRACK] = ACTIONS(4156),
    [anon_sym_LT] = ACTIONS(4156),
    [anon_sym_GT] = ACTIONS(4158),
    [anon_sym_use] = ACTIONS(4158),
    [anon_sym_use_BANG] = ACTIONS(4156),
    [anon_sym_do_BANG] = ACTIONS(4156),
    [anon_sym_begin] = ACTIONS(4158),
    [anon_sym_LPAREN2] = ACTIONS(4158),
    [anon_sym_or] = ACTIONS(4158),
    [aux_sym_char_token1] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4158),
    [anon_sym_DQUOTE] = ACTIONS(4158),
    [anon_sym_AT_DQUOTE] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [sym_bool] = ACTIONS(4158),
    [sym_unit] = ACTIONS(4156),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4158),
    [sym_op_identifier] = ACTIONS(4158),
    [anon_sym_PLUS] = ACTIONS(4158),
    [anon_sym_DASH] = ACTIONS(4158),
    [anon_sym_PLUS_DOT] = ACTIONS(4158),
    [anon_sym_DASH_DOT] = ACTIONS(4158),
    [anon_sym_PERCENT] = ACTIONS(4158),
    [anon_sym_AMP_AMP] = ACTIONS(4158),
    [anon_sym_TILDE] = ACTIONS(4156),
    [aux_sym_prefix_op_token1] = ACTIONS(4158),
    [aux_sym_infix_op_token1] = ACTIONS(4156),
    [aux_sym_infix_op_token2] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE] = ACTIONS(4158),
    [anon_sym_BANG_EQ] = ACTIONS(4158),
    [anon_sym_COLON_EQ] = ACTIONS(4156),
    [anon_sym_DOLLAR] = ACTIONS(4158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4158),
    [sym_int] = ACTIONS(4158),
    [sym_xint] = ACTIONS(4156),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4156),
    [sym__newline] = ACTIONS(4156),
  },
  [3457] = {
    [sym_attributes] = STATE(3968),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(5183),
    [sym__pattern] = STATE(3094),
    [sym_optional_pattern] = STATE(5183),
    [sym_type_check_pattern] = STATE(5183),
    [sym_attribute_pattern] = STATE(5183),
    [sym_paren_pattern] = STATE(5183),
    [sym_as_pattern] = STATE(5183),
    [sym_cons_pattern] = STATE(5183),
    [sym_disjunct_pattern] = STATE(5183),
    [sym_conjunct_pattern] = STATE(5183),
    [sym_typed_pattern] = STATE(5183),
    [sym_list_pattern] = STATE(5183),
    [sym_array_pattern] = STATE(5183),
    [sym_record_pattern] = STATE(5183),
    [sym_named_field_pattern] = STATE(5183),
    [sym_identifier_pattern] = STATE(5183),
    [sym_long_identifier_or_op] = STATE(3528),
    [sym_char] = STATE(5133),
    [sym_format_string] = STATE(5135),
    [sym__string_literal] = STATE(5135),
    [sym_string] = STATE(5133),
    [sym_verbatim_string] = STATE(5133),
    [sym_bytearray] = STATE(5133),
    [sym_verbatim_bytearray] = STATE(5133),
    [sym_format_triple_quoted_string] = STATE(5136),
    [sym_triple_quoted_string] = STATE(5133),
    [sym_const] = STATE(5183),
    [sym_long_identifier] = STATE(4953),
    [sym_active_pattern] = STATE(5117),
    [sym__identifier_or_op] = STATE(5167),
    [sym_sbyte] = STATE(5133),
    [sym_byte] = STATE(5133),
    [sym_int16] = STATE(5133),
    [sym_uint16] = STATE(5133),
    [sym_int32] = STATE(5133),
    [sym_uint32] = STATE(5133),
    [sym_nativeint] = STATE(5133),
    [sym_unativeint] = STATE(5133),
    [sym_int64] = STATE(5133),
    [sym_uint64] = STATE(5133),
    [sym_ieee32] = STATE(5133),
    [sym_ieee64] = STATE(5133),
    [sym_bignum] = STATE(5133),
    [sym_decimal] = STATE(5133),
    [sym_float] = STATE(4916),
    [sym_block_comment] = STATE(3457),
    [sym_compiler_directive_decl] = STATE(3457),
    [sym_fsi_directive_decl] = STATE(3457),
    [sym_preproc_line] = STATE(3457),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5671),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_COLON] = ACTIONS(5558),
    [anon_sym_as] = ACTIONS(5558),
    [anon_sym_LPAREN] = ACTIONS(5944),
    [anon_sym_COMMA] = ACTIONS(5562),
    [anon_sym_null] = ACTIONS(5946),
    [anon_sym__] = ACTIONS(5948),
    [anon_sym_QMARK] = ACTIONS(5950),
    [anon_sym_COLON_QMARK] = ACTIONS(5952),
    [anon_sym_COLON_COLON] = ACTIONS(5562),
    [anon_sym_PIPE] = ACTIONS(5562),
    [anon_sym_AMP] = ACTIONS(5562),
    [anon_sym_LBRACK] = ACTIONS(5954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5956),
    [anon_sym_LBRACE] = ACTIONS(5958),
    [aux_sym_char_token1] = ACTIONS(5960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5962),
    [anon_sym_DQUOTE] = ACTIONS(5964),
    [anon_sym_AT_DQUOTE] = ACTIONS(5966),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5968),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5970),
    [sym_bool] = ACTIONS(5972),
    [sym_unit] = ACTIONS(5974),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5705),
    [sym_op_identifier] = ACTIONS(5707),
    [sym_int] = ACTIONS(5976),
    [sym_xint] = ACTIONS(5978),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [sym__newline] = ACTIONS(5562),
    [sym__dedent] = ACTIONS(5562),
  },
  [3458] = {
    [sym_block_comment] = STATE(3458),
    [sym_compiler_directive_decl] = STATE(3458),
    [sym_fsi_directive_decl] = STATE(3458),
    [sym_preproc_line] = STATE(3458),
    [sym_identifier] = ACTIONS(3863),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_let] = ACTIONS(3863),
    [anon_sym_let_BANG] = ACTIONS(3861),
    [anon_sym_LPAREN] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3861),
    [anon_sym_null] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_COLON] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_LT_AT] = ACTIONS(3863),
    [anon_sym_AT_GT] = ACTIONS(3863),
    [anon_sym_LT_AT_AT] = ACTIONS(3863),
    [anon_sym_DOT] = ACTIONS(3863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3861),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_return_BANG] = ACTIONS(3861),
    [anon_sym_yield] = ACTIONS(3863),
    [anon_sym_yield_BANG] = ACTIONS(3861),
    [anon_sym_lazy] = ACTIONS(3863),
    [anon_sym_assert] = ACTIONS(3863),
    [anon_sym_upcast] = ACTIONS(3863),
    [anon_sym_downcast] = ACTIONS(3863),
    [anon_sym_COLON_GT] = ACTIONS(3861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_fun] = ACTIONS(3863),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_match] = ACTIONS(3863),
    [anon_sym_match_BANG] = ACTIONS(3861),
    [anon_sym_function] = ACTIONS(3863),
    [anon_sym_LT_DASH] = ACTIONS(3863),
    [anon_sym_DOT_LBRACK] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_use] = ACTIONS(3863),
    [anon_sym_use_BANG] = ACTIONS(3861),
    [anon_sym_do_BANG] = ACTIONS(3861),
    [anon_sym_begin] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(3863),
    [anon_sym_or] = ACTIONS(3863),
    [aux_sym_char_token1] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [anon_sym_AT_DQUOTE] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [sym_bool] = ACTIONS(3863),
    [sym_unit] = ACTIONS(3861),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3863),
    [sym_op_identifier] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_DOT] = ACTIONS(3863),
    [anon_sym_DASH_DOT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3861),
    [aux_sym_prefix_op_token1] = ACTIONS(3863),
    [aux_sym_infix_op_token1] = ACTIONS(3861),
    [aux_sym_infix_op_token2] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_COLON_EQ] = ACTIONS(3861),
    [anon_sym_DOLLAR] = ACTIONS(3863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3863),
    [sym_int] = ACTIONS(3863),
    [sym_xint] = ACTIONS(3861),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3861),
    [sym__newline] = ACTIONS(3861),
  },
  [3459] = {
    [sym_block_comment] = STATE(3459),
    [sym_compiler_directive_decl] = STATE(3459),
    [sym_fsi_directive_decl] = STATE(3459),
    [sym_preproc_line] = STATE(3459),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4739),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
    [sym__dedent] = ACTIONS(5980),
  },
  [3460] = {
    [sym_block_comment] = STATE(3460),
    [sym_compiler_directive_decl] = STATE(3460),
    [sym_fsi_directive_decl] = STATE(3460),
    [sym_preproc_line] = STATE(3460),
    [sym_identifier] = ACTIONS(3856),
    [anon_sym_EQ] = ACTIONS(3854),
    [anon_sym_COLON] = ACTIONS(3856),
    [anon_sym_return] = ACTIONS(3856),
    [anon_sym_do] = ACTIONS(3856),
    [anon_sym_let] = ACTIONS(3856),
    [anon_sym_let_BANG] = ACTIONS(3854),
    [anon_sym_LPAREN] = ACTIONS(3856),
    [anon_sym_COMMA] = ACTIONS(3854),
    [anon_sym_null] = ACTIONS(3856),
    [anon_sym_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_AMP] = ACTIONS(3856),
    [anon_sym_LBRACK] = ACTIONS(3856),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3854),
    [anon_sym_LBRACE] = ACTIONS(3856),
    [anon_sym_LT_AT] = ACTIONS(3856),
    [anon_sym_LT_AT_AT] = ACTIONS(3856),
    [anon_sym_AT_AT_GT] = ACTIONS(3856),
    [anon_sym_DOT] = ACTIONS(3856),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3854),
    [anon_sym_new] = ACTIONS(3856),
    [anon_sym_return_BANG] = ACTIONS(3854),
    [anon_sym_yield] = ACTIONS(3856),
    [anon_sym_yield_BANG] = ACTIONS(3854),
    [anon_sym_lazy] = ACTIONS(3856),
    [anon_sym_assert] = ACTIONS(3856),
    [anon_sym_upcast] = ACTIONS(3856),
    [anon_sym_downcast] = ACTIONS(3856),
    [anon_sym_COLON_GT] = ACTIONS(3854),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3854),
    [anon_sym_for] = ACTIONS(3856),
    [anon_sym_while] = ACTIONS(3856),
    [anon_sym_if] = ACTIONS(3856),
    [anon_sym_fun] = ACTIONS(3856),
    [anon_sym_try] = ACTIONS(3856),
    [anon_sym_match] = ACTIONS(3856),
    [anon_sym_match_BANG] = ACTIONS(3854),
    [anon_sym_function] = ACTIONS(3856),
    [anon_sym_LT_DASH] = ACTIONS(3856),
    [anon_sym_DOT_LBRACK] = ACTIONS(3854),
    [anon_sym_LT] = ACTIONS(3854),
    [anon_sym_use] = ACTIONS(3856),
    [anon_sym_use_BANG] = ACTIONS(3854),
    [anon_sym_do_BANG] = ACTIONS(3854),
    [anon_sym_begin] = ACTIONS(3856),
    [anon_sym_LPAREN2] = ACTIONS(3856),
    [anon_sym_or] = ACTIONS(3856),
    [aux_sym_char_token1] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3856),
    [anon_sym_DQUOTE] = ACTIONS(3856),
    [anon_sym_AT_DQUOTE] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [sym_bool] = ACTIONS(3856),
    [sym_unit] = ACTIONS(3854),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3856),
    [sym_op_identifier] = ACTIONS(3856),
    [anon_sym_PLUS] = ACTIONS(3856),
    [anon_sym_DASH] = ACTIONS(3856),
    [anon_sym_PLUS_DOT] = ACTIONS(3856),
    [anon_sym_DASH_DOT] = ACTIONS(3856),
    [anon_sym_PERCENT] = ACTIONS(3856),
    [anon_sym_AMP_AMP] = ACTIONS(3856),
    [anon_sym_TILDE] = ACTIONS(3854),
    [aux_sym_prefix_op_token1] = ACTIONS(3856),
    [aux_sym_infix_op_token1] = ACTIONS(3854),
    [aux_sym_infix_op_token2] = ACTIONS(3856),
    [anon_sym_PIPE_PIPE] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3856),
    [anon_sym_COLON_EQ] = ACTIONS(3854),
    [anon_sym_DOLLAR] = ACTIONS(3856),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3856),
    [sym_int] = ACTIONS(3856),
    [sym_xint] = ACTIONS(3854),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3854),
    [sym__newline] = ACTIONS(3854),
  },
  [3461] = {
    [sym_block_comment] = STATE(3461),
    [sym_compiler_directive_decl] = STATE(3461),
    [sym_fsi_directive_decl] = STATE(3461),
    [sym_preproc_line] = STATE(3461),
    [sym_identifier] = ACTIONS(3863),
    [anon_sym_EQ] = ACTIONS(3861),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_let] = ACTIONS(3863),
    [anon_sym_let_BANG] = ACTIONS(3861),
    [anon_sym_LPAREN] = ACTIONS(3863),
    [anon_sym_COMMA] = ACTIONS(3861),
    [anon_sym_null] = ACTIONS(3863),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_COLON_COLON] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_LT_AT] = ACTIONS(3863),
    [anon_sym_LT_AT_AT] = ACTIONS(3863),
    [anon_sym_AT_AT_GT] = ACTIONS(3863),
    [anon_sym_DOT] = ACTIONS(3863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3861),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_return_BANG] = ACTIONS(3861),
    [anon_sym_yield] = ACTIONS(3863),
    [anon_sym_yield_BANG] = ACTIONS(3861),
    [anon_sym_lazy] = ACTIONS(3863),
    [anon_sym_assert] = ACTIONS(3863),
    [anon_sym_upcast] = ACTIONS(3863),
    [anon_sym_downcast] = ACTIONS(3863),
    [anon_sym_COLON_GT] = ACTIONS(3861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_if] = ACTIONS(3863),
    [anon_sym_fun] = ACTIONS(3863),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_match] = ACTIONS(3863),
    [anon_sym_match_BANG] = ACTIONS(3861),
    [anon_sym_function] = ACTIONS(3863),
    [anon_sym_LT_DASH] = ACTIONS(3863),
    [anon_sym_DOT_LBRACK] = ACTIONS(3861),
    [anon_sym_LT] = ACTIONS(3861),
    [anon_sym_use] = ACTIONS(3863),
    [anon_sym_use_BANG] = ACTIONS(3861),
    [anon_sym_do_BANG] = ACTIONS(3861),
    [anon_sym_begin] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(3863),
    [anon_sym_or] = ACTIONS(3863),
    [aux_sym_char_token1] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [anon_sym_AT_DQUOTE] = ACTIONS(3861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3861),
    [sym_bool] = ACTIONS(3863),
    [sym_unit] = ACTIONS(3861),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3863),
    [sym_op_identifier] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_DOT] = ACTIONS(3863),
    [anon_sym_DASH_DOT] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3861),
    [aux_sym_prefix_op_token1] = ACTIONS(3863),
    [aux_sym_infix_op_token1] = ACTIONS(3861),
    [aux_sym_infix_op_token2] = ACTIONS(3863),
    [anon_sym_PIPE_PIPE] = ACTIONS(3863),
    [anon_sym_BANG_EQ] = ACTIONS(3863),
    [anon_sym_COLON_EQ] = ACTIONS(3861),
    [anon_sym_DOLLAR] = ACTIONS(3863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3863),
    [sym_int] = ACTIONS(3863),
    [sym_xint] = ACTIONS(3861),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3861),
    [sym__newline] = ACTIONS(3861),
  },
  [3462] = {
    [sym_block_comment] = STATE(3462),
    [sym_compiler_directive_decl] = STATE(3462),
    [sym_fsi_directive_decl] = STATE(3462),
    [sym_preproc_line] = STATE(3462),
    [sym_identifier] = ACTIONS(3856),
    [anon_sym_EQ] = ACTIONS(3854),
    [anon_sym_COLON] = ACTIONS(3856),
    [anon_sym_return] = ACTIONS(3856),
    [anon_sym_do] = ACTIONS(3856),
    [anon_sym_let] = ACTIONS(3856),
    [anon_sym_let_BANG] = ACTIONS(3854),
    [anon_sym_LPAREN] = ACTIONS(3856),
    [anon_sym_COMMA] = ACTIONS(3854),
    [anon_sym_null] = ACTIONS(3856),
    [anon_sym_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_AMP] = ACTIONS(3856),
    [anon_sym_LBRACK] = ACTIONS(3856),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3854),
    [anon_sym_LBRACE] = ACTIONS(3856),
    [anon_sym_LT_AT] = ACTIONS(3856),
    [anon_sym_AT_GT] = ACTIONS(3856),
    [anon_sym_LT_AT_AT] = ACTIONS(3856),
    [anon_sym_DOT] = ACTIONS(3856),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3854),
    [anon_sym_new] = ACTIONS(3856),
    [anon_sym_return_BANG] = ACTIONS(3854),
    [anon_sym_yield] = ACTIONS(3856),
    [anon_sym_yield_BANG] = ACTIONS(3854),
    [anon_sym_lazy] = ACTIONS(3856),
    [anon_sym_assert] = ACTIONS(3856),
    [anon_sym_upcast] = ACTIONS(3856),
    [anon_sym_downcast] = ACTIONS(3856),
    [anon_sym_COLON_GT] = ACTIONS(3854),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3854),
    [anon_sym_for] = ACTIONS(3856),
    [anon_sym_while] = ACTIONS(3856),
    [anon_sym_if] = ACTIONS(3856),
    [anon_sym_fun] = ACTIONS(3856),
    [anon_sym_try] = ACTIONS(3856),
    [anon_sym_match] = ACTIONS(3856),
    [anon_sym_match_BANG] = ACTIONS(3854),
    [anon_sym_function] = ACTIONS(3856),
    [anon_sym_LT_DASH] = ACTIONS(3856),
    [anon_sym_DOT_LBRACK] = ACTIONS(3854),
    [anon_sym_LT] = ACTIONS(3854),
    [anon_sym_use] = ACTIONS(3856),
    [anon_sym_use_BANG] = ACTIONS(3854),
    [anon_sym_do_BANG] = ACTIONS(3854),
    [anon_sym_begin] = ACTIONS(3856),
    [anon_sym_LPAREN2] = ACTIONS(3856),
    [anon_sym_or] = ACTIONS(3856),
    [aux_sym_char_token1] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3856),
    [anon_sym_DQUOTE] = ACTIONS(3856),
    [anon_sym_AT_DQUOTE] = ACTIONS(3854),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3854),
    [sym_bool] = ACTIONS(3856),
    [sym_unit] = ACTIONS(3854),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3856),
    [sym_op_identifier] = ACTIONS(3856),
    [anon_sym_PLUS] = ACTIONS(3856),
    [anon_sym_DASH] = ACTIONS(3856),
    [anon_sym_PLUS_DOT] = ACTIONS(3856),
    [anon_sym_DASH_DOT] = ACTIONS(3856),
    [anon_sym_PERCENT] = ACTIONS(3856),
    [anon_sym_AMP_AMP] = ACTIONS(3856),
    [anon_sym_TILDE] = ACTIONS(3854),
    [aux_sym_prefix_op_token1] = ACTIONS(3856),
    [aux_sym_infix_op_token1] = ACTIONS(3854),
    [aux_sym_infix_op_token2] = ACTIONS(3856),
    [anon_sym_PIPE_PIPE] = ACTIONS(3856),
    [anon_sym_BANG_EQ] = ACTIONS(3856),
    [anon_sym_COLON_EQ] = ACTIONS(3854),
    [anon_sym_DOLLAR] = ACTIONS(3856),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3856),
    [sym_int] = ACTIONS(3856),
    [sym_xint] = ACTIONS(3854),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3854),
    [sym__newline] = ACTIONS(3854),
  },
  [3463] = {
    [sym_block_comment] = STATE(3463),
    [sym_compiler_directive_decl] = STATE(3463),
    [sym_fsi_directive_decl] = STATE(3463),
    [sym_preproc_line] = STATE(3463),
    [sym_identifier] = ACTIONS(3875),
    [anon_sym_EQ] = ACTIONS(3873),
    [anon_sym_COLON] = ACTIONS(3875),
    [anon_sym_return] = ACTIONS(3875),
    [anon_sym_do] = ACTIONS(3875),
    [anon_sym_let] = ACTIONS(3875),
    [anon_sym_let_BANG] = ACTIONS(3873),
    [anon_sym_LPAREN] = ACTIONS(3875),
    [anon_sym_COMMA] = ACTIONS(3873),
    [anon_sym_null] = ACTIONS(3875),
    [anon_sym_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_COLON] = ACTIONS(3873),
    [anon_sym_AMP] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(3875),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3873),
    [anon_sym_LBRACE] = ACTIONS(3875),
    [anon_sym_LT_AT] = ACTIONS(3875),
    [anon_sym_LT_AT_AT] = ACTIONS(3875),
    [anon_sym_AT_AT_GT] = ACTIONS(3875),
    [anon_sym_DOT] = ACTIONS(3875),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3873),
    [anon_sym_new] = ACTIONS(3875),
    [anon_sym_return_BANG] = ACTIONS(3873),
    [anon_sym_yield] = ACTIONS(3875),
    [anon_sym_yield_BANG] = ACTIONS(3873),
    [anon_sym_lazy] = ACTIONS(3875),
    [anon_sym_assert] = ACTIONS(3875),
    [anon_sym_upcast] = ACTIONS(3875),
    [anon_sym_downcast] = ACTIONS(3875),
    [anon_sym_COLON_GT] = ACTIONS(3873),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3873),
    [anon_sym_for] = ACTIONS(3875),
    [anon_sym_while] = ACTIONS(3875),
    [anon_sym_if] = ACTIONS(3875),
    [anon_sym_fun] = ACTIONS(3875),
    [anon_sym_try] = ACTIONS(3875),
    [anon_sym_match] = ACTIONS(3875),
    [anon_sym_match_BANG] = ACTIONS(3873),
    [anon_sym_function] = ACTIONS(3875),
    [anon_sym_LT_DASH] = ACTIONS(3875),
    [anon_sym_DOT_LBRACK] = ACTIONS(3873),
    [anon_sym_LT] = ACTIONS(3873),
    [anon_sym_use] = ACTIONS(3875),
    [anon_sym_use_BANG] = ACTIONS(3873),
    [anon_sym_do_BANG] = ACTIONS(3873),
    [anon_sym_begin] = ACTIONS(3875),
    [anon_sym_LPAREN2] = ACTIONS(3875),
    [anon_sym_or] = ACTIONS(3875),
    [aux_sym_char_token1] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3875),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [anon_sym_AT_DQUOTE] = ACTIONS(3873),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3873),
    [sym_bool] = ACTIONS(3875),
    [sym_unit] = ACTIONS(3873),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3875),
    [sym_op_identifier] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_PLUS_DOT] = ACTIONS(3875),
    [anon_sym_DASH_DOT] = ACTIONS(3875),
    [anon_sym_PERCENT] = ACTIONS(3875),
    [anon_sym_AMP_AMP] = ACTIONS(3875),
    [anon_sym_TILDE] = ACTIONS(3873),
    [aux_sym_prefix_op_token1] = ACTIONS(3875),
    [aux_sym_infix_op_token1] = ACTIONS(3873),
    [aux_sym_infix_op_token2] = ACTIONS(3875),
    [anon_sym_PIPE_PIPE] = ACTIONS(3875),
    [anon_sym_BANG_EQ] = ACTIONS(3875),
    [anon_sym_COLON_EQ] = ACTIONS(3873),
    [anon_sym_DOLLAR] = ACTIONS(3875),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3875),
    [sym_int] = ACTIONS(3875),
    [sym_xint] = ACTIONS(3873),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3873),
    [sym__newline] = ACTIONS(3873),
  },
  [3464] = {
    [sym_block_comment] = STATE(3464),
    [sym_compiler_directive_decl] = STATE(3464),
    [sym_fsi_directive_decl] = STATE(3464),
    [sym_preproc_line] = STATE(3464),
    [sym_identifier] = ACTIONS(3893),
    [anon_sym_EQ] = ACTIONS(3891),
    [anon_sym_COLON] = ACTIONS(3893),
    [anon_sym_return] = ACTIONS(3893),
    [anon_sym_do] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_let_BANG] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_COMMA] = ACTIONS(3891),
    [anon_sym_null] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_QMARK] = ACTIONS(3893),
    [anon_sym_COLON_COLON] = ACTIONS(3891),
    [anon_sym_AMP] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3891),
    [anon_sym_LBRACE] = ACTIONS(3893),
    [anon_sym_LT_AT] = ACTIONS(3893),
    [anon_sym_LT_AT_AT] = ACTIONS(3893),
    [anon_sym_AT_AT_GT] = ACTIONS(3893),
    [anon_sym_DOT] = ACTIONS(3893),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3891),
    [anon_sym_new] = ACTIONS(3893),
    [anon_sym_return_BANG] = ACTIONS(3891),
    [anon_sym_yield] = ACTIONS(3893),
    [anon_sym_yield_BANG] = ACTIONS(3891),
    [anon_sym_lazy] = ACTIONS(3893),
    [anon_sym_assert] = ACTIONS(3893),
    [anon_sym_upcast] = ACTIONS(3893),
    [anon_sym_downcast] = ACTIONS(3893),
    [anon_sym_COLON_GT] = ACTIONS(3891),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3891),
    [anon_sym_for] = ACTIONS(3893),
    [anon_sym_while] = ACTIONS(3893),
    [anon_sym_if] = ACTIONS(3893),
    [anon_sym_fun] = ACTIONS(3893),
    [anon_sym_try] = ACTIONS(3893),
    [anon_sym_match] = ACTIONS(3893),
    [anon_sym_match_BANG] = ACTIONS(3891),
    [anon_sym_function] = ACTIONS(3893),
    [anon_sym_LT_DASH] = ACTIONS(3893),
    [anon_sym_DOT_LBRACK] = ACTIONS(3891),
    [anon_sym_LT] = ACTIONS(3891),
    [anon_sym_use] = ACTIONS(3893),
    [anon_sym_use_BANG] = ACTIONS(3891),
    [anon_sym_do_BANG] = ACTIONS(3891),
    [anon_sym_begin] = ACTIONS(3893),
    [anon_sym_LPAREN2] = ACTIONS(3893),
    [anon_sym_or] = ACTIONS(3893),
    [aux_sym_char_token1] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3893),
    [anon_sym_DQUOTE] = ACTIONS(3893),
    [anon_sym_AT_DQUOTE] = ACTIONS(3891),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3891),
    [sym_bool] = ACTIONS(3893),
    [sym_unit] = ACTIONS(3891),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3893),
    [sym_op_identifier] = ACTIONS(3893),
    [anon_sym_PLUS] = ACTIONS(3893),
    [anon_sym_DASH] = ACTIONS(3893),
    [anon_sym_PLUS_DOT] = ACTIONS(3893),
    [anon_sym_DASH_DOT] = ACTIONS(3893),
    [anon_sym_PERCENT] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_TILDE] = ACTIONS(3891),
    [aux_sym_prefix_op_token1] = ACTIONS(3893),
    [aux_sym_infix_op_token1] = ACTIONS(3891),
    [aux_sym_infix_op_token2] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [anon_sym_BANG_EQ] = ACTIONS(3893),
    [anon_sym_COLON_EQ] = ACTIONS(3891),
    [anon_sym_DOLLAR] = ACTIONS(3893),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3893),
    [sym_int] = ACTIONS(3893),
    [sym_xint] = ACTIONS(3891),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3891),
    [sym__newline] = ACTIONS(3891),
  },
  [3465] = {
    [sym_block_comment] = STATE(3465),
    [sym_compiler_directive_decl] = STATE(3465),
    [sym_fsi_directive_decl] = STATE(3465),
    [sym_preproc_line] = STATE(3465),
    [sym_identifier] = ACTIONS(4224),
    [anon_sym_EQ] = ACTIONS(4222),
    [anon_sym_COLON] = ACTIONS(4224),
    [anon_sym_return] = ACTIONS(4224),
    [anon_sym_do] = ACTIONS(4224),
    [anon_sym_let] = ACTIONS(4224),
    [anon_sym_let_BANG] = ACTIONS(4222),
    [anon_sym_LPAREN] = ACTIONS(4224),
    [anon_sym_COMMA] = ACTIONS(4222),
    [anon_sym_null] = ACTIONS(4224),
    [anon_sym_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_COLON] = ACTIONS(4222),
    [anon_sym_AMP] = ACTIONS(4224),
    [anon_sym_LBRACK] = ACTIONS(4224),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4222),
    [anon_sym_LBRACE] = ACTIONS(4224),
    [anon_sym_LT_AT] = ACTIONS(4224),
    [anon_sym_AT_GT] = ACTIONS(4224),
    [anon_sym_LT_AT_AT] = ACTIONS(4224),
    [anon_sym_DOT] = ACTIONS(4224),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4222),
    [anon_sym_new] = ACTIONS(4224),
    [anon_sym_return_BANG] = ACTIONS(4222),
    [anon_sym_yield] = ACTIONS(4224),
    [anon_sym_yield_BANG] = ACTIONS(4222),
    [anon_sym_lazy] = ACTIONS(4224),
    [anon_sym_assert] = ACTIONS(4224),
    [anon_sym_upcast] = ACTIONS(4224),
    [anon_sym_downcast] = ACTIONS(4224),
    [anon_sym_COLON_GT] = ACTIONS(4222),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4222),
    [anon_sym_for] = ACTIONS(4224),
    [anon_sym_while] = ACTIONS(4224),
    [anon_sym_if] = ACTIONS(4224),
    [anon_sym_fun] = ACTIONS(4224),
    [anon_sym_try] = ACTIONS(4224),
    [anon_sym_match] = ACTIONS(4224),
    [anon_sym_match_BANG] = ACTIONS(4222),
    [anon_sym_function] = ACTIONS(4224),
    [anon_sym_LT_DASH] = ACTIONS(4224),
    [anon_sym_DOT_LBRACK] = ACTIONS(4222),
    [anon_sym_LT] = ACTIONS(4222),
    [anon_sym_use] = ACTIONS(4224),
    [anon_sym_use_BANG] = ACTIONS(4222),
    [anon_sym_do_BANG] = ACTIONS(4222),
    [anon_sym_begin] = ACTIONS(4224),
    [anon_sym_LPAREN2] = ACTIONS(4224),
    [anon_sym_or] = ACTIONS(4224),
    [aux_sym_char_token1] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4224),
    [anon_sym_DQUOTE] = ACTIONS(4224),
    [anon_sym_AT_DQUOTE] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [sym_bool] = ACTIONS(4224),
    [sym_unit] = ACTIONS(4222),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4224),
    [sym_op_identifier] = ACTIONS(4224),
    [anon_sym_PLUS] = ACTIONS(4224),
    [anon_sym_DASH] = ACTIONS(4224),
    [anon_sym_PLUS_DOT] = ACTIONS(4224),
    [anon_sym_DASH_DOT] = ACTIONS(4224),
    [anon_sym_PERCENT] = ACTIONS(4224),
    [anon_sym_AMP_AMP] = ACTIONS(4224),
    [anon_sym_TILDE] = ACTIONS(4222),
    [aux_sym_prefix_op_token1] = ACTIONS(4224),
    [aux_sym_infix_op_token1] = ACTIONS(4222),
    [aux_sym_infix_op_token2] = ACTIONS(4224),
    [anon_sym_PIPE_PIPE] = ACTIONS(4224),
    [anon_sym_BANG_EQ] = ACTIONS(4224),
    [anon_sym_COLON_EQ] = ACTIONS(4222),
    [anon_sym_DOLLAR] = ACTIONS(4224),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4224),
    [sym_int] = ACTIONS(4224),
    [sym_xint] = ACTIONS(4222),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4222),
    [sym__newline] = ACTIONS(4222),
  },
  [3466] = {
    [sym_block_comment] = STATE(3466),
    [sym_compiler_directive_decl] = STATE(3466),
    [sym_fsi_directive_decl] = STATE(3466),
    [sym_preproc_line] = STATE(3466),
    [sym_identifier] = ACTIONS(4100),
    [anon_sym_EQ] = ACTIONS(4098),
    [anon_sym_COLON] = ACTIONS(4100),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_do] = ACTIONS(4100),
    [anon_sym_let] = ACTIONS(4100),
    [anon_sym_let_BANG] = ACTIONS(4098),
    [anon_sym_LPAREN] = ACTIONS(4100),
    [anon_sym_COMMA] = ACTIONS(4098),
    [anon_sym_null] = ACTIONS(4100),
    [anon_sym_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_COLON] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4100),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4098),
    [anon_sym_LBRACE] = ACTIONS(4100),
    [anon_sym_LT_AT] = ACTIONS(4100),
    [anon_sym_LT_AT_AT] = ACTIONS(4100),
    [anon_sym_AT_AT_GT] = ACTIONS(4100),
    [anon_sym_DOT] = ACTIONS(4100),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4098),
    [anon_sym_new] = ACTIONS(4100),
    [anon_sym_return_BANG] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4100),
    [anon_sym_yield_BANG] = ACTIONS(4098),
    [anon_sym_lazy] = ACTIONS(4100),
    [anon_sym_assert] = ACTIONS(4100),
    [anon_sym_upcast] = ACTIONS(4100),
    [anon_sym_downcast] = ACTIONS(4100),
    [anon_sym_COLON_GT] = ACTIONS(4098),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4098),
    [anon_sym_for] = ACTIONS(4100),
    [anon_sym_while] = ACTIONS(4100),
    [anon_sym_if] = ACTIONS(4100),
    [anon_sym_fun] = ACTIONS(4100),
    [anon_sym_try] = ACTIONS(4100),
    [anon_sym_match] = ACTIONS(4100),
    [anon_sym_match_BANG] = ACTIONS(4098),
    [anon_sym_function] = ACTIONS(4100),
    [anon_sym_LT_DASH] = ACTIONS(4100),
    [anon_sym_DOT_LBRACK] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(4098),
    [anon_sym_use] = ACTIONS(4100),
    [anon_sym_use_BANG] = ACTIONS(4098),
    [anon_sym_do_BANG] = ACTIONS(4098),
    [anon_sym_begin] = ACTIONS(4100),
    [anon_sym_LPAREN2] = ACTIONS(4100),
    [anon_sym_or] = ACTIONS(4100),
    [aux_sym_char_token1] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4100),
    [anon_sym_DQUOTE] = ACTIONS(4100),
    [anon_sym_AT_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [sym_bool] = ACTIONS(4100),
    [sym_unit] = ACTIONS(4098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4100),
    [sym_op_identifier] = ACTIONS(4100),
    [anon_sym_PLUS] = ACTIONS(4100),
    [anon_sym_DASH] = ACTIONS(4100),
    [anon_sym_PLUS_DOT] = ACTIONS(4100),
    [anon_sym_DASH_DOT] = ACTIONS(4100),
    [anon_sym_PERCENT] = ACTIONS(4100),
    [anon_sym_AMP_AMP] = ACTIONS(4100),
    [anon_sym_TILDE] = ACTIONS(4098),
    [aux_sym_prefix_op_token1] = ACTIONS(4100),
    [aux_sym_infix_op_token1] = ACTIONS(4098),
    [aux_sym_infix_op_token2] = ACTIONS(4100),
    [anon_sym_PIPE_PIPE] = ACTIONS(4100),
    [anon_sym_BANG_EQ] = ACTIONS(4100),
    [anon_sym_COLON_EQ] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4100),
    [sym_int] = ACTIONS(4100),
    [sym_xint] = ACTIONS(4098),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4098),
    [sym__newline] = ACTIONS(4098),
  },
  [3467] = {
    [sym_block_comment] = STATE(3467),
    [sym_compiler_directive_decl] = STATE(3467),
    [sym_fsi_directive_decl] = STATE(3467),
    [sym_preproc_line] = STATE(3467),
    [sym_identifier] = ACTIONS(3907),
    [anon_sym_EQ] = ACTIONS(3905),
    [anon_sym_COLON] = ACTIONS(3907),
    [anon_sym_return] = ACTIONS(3907),
    [anon_sym_do] = ACTIONS(3907),
    [anon_sym_let] = ACTIONS(3907),
    [anon_sym_let_BANG] = ACTIONS(3905),
    [anon_sym_LPAREN] = ACTIONS(3907),
    [anon_sym_COMMA] = ACTIONS(3905),
    [anon_sym_null] = ACTIONS(3907),
    [anon_sym_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_QMARK] = ACTIONS(3907),
    [anon_sym_COLON_COLON] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3907),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3905),
    [anon_sym_LBRACE] = ACTIONS(3907),
    [anon_sym_LT_AT] = ACTIONS(3907),
    [anon_sym_LT_AT_AT] = ACTIONS(3907),
    [anon_sym_AT_AT_GT] = ACTIONS(3907),
    [anon_sym_DOT] = ACTIONS(3907),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3905),
    [anon_sym_new] = ACTIONS(3907),
    [anon_sym_return_BANG] = ACTIONS(3905),
    [anon_sym_yield] = ACTIONS(3907),
    [anon_sym_yield_BANG] = ACTIONS(3905),
    [anon_sym_lazy] = ACTIONS(3907),
    [anon_sym_assert] = ACTIONS(3907),
    [anon_sym_upcast] = ACTIONS(3907),
    [anon_sym_downcast] = ACTIONS(3907),
    [anon_sym_COLON_GT] = ACTIONS(3905),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3905),
    [anon_sym_for] = ACTIONS(3907),
    [anon_sym_while] = ACTIONS(3907),
    [anon_sym_if] = ACTIONS(3907),
    [anon_sym_fun] = ACTIONS(3907),
    [anon_sym_try] = ACTIONS(3907),
    [anon_sym_match] = ACTIONS(3907),
    [anon_sym_match_BANG] = ACTIONS(3905),
    [anon_sym_function] = ACTIONS(3907),
    [anon_sym_LT_DASH] = ACTIONS(3907),
    [anon_sym_DOT_LBRACK] = ACTIONS(3905),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_use] = ACTIONS(3907),
    [anon_sym_use_BANG] = ACTIONS(3905),
    [anon_sym_do_BANG] = ACTIONS(3905),
    [anon_sym_begin] = ACTIONS(3907),
    [anon_sym_LPAREN2] = ACTIONS(3907),
    [anon_sym_or] = ACTIONS(3907),
    [aux_sym_char_token1] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3907),
    [anon_sym_DQUOTE] = ACTIONS(3907),
    [anon_sym_AT_DQUOTE] = ACTIONS(3905),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3905),
    [sym_bool] = ACTIONS(3907),
    [sym_unit] = ACTIONS(3905),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3907),
    [sym_op_identifier] = ACTIONS(3907),
    [anon_sym_PLUS] = ACTIONS(3907),
    [anon_sym_DASH] = ACTIONS(3907),
    [anon_sym_PLUS_DOT] = ACTIONS(3907),
    [anon_sym_DASH_DOT] = ACTIONS(3907),
    [anon_sym_PERCENT] = ACTIONS(3907),
    [anon_sym_AMP_AMP] = ACTIONS(3907),
    [anon_sym_TILDE] = ACTIONS(3905),
    [aux_sym_prefix_op_token1] = ACTIONS(3907),
    [aux_sym_infix_op_token1] = ACTIONS(3905),
    [aux_sym_infix_op_token2] = ACTIONS(3907),
    [anon_sym_PIPE_PIPE] = ACTIONS(3907),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_COLON_EQ] = ACTIONS(3905),
    [anon_sym_DOLLAR] = ACTIONS(3907),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3907),
    [sym_int] = ACTIONS(3907),
    [sym_xint] = ACTIONS(3905),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3905),
    [sym__newline] = ACTIONS(3905),
  },
  [3468] = {
    [sym_block_comment] = STATE(3468),
    [sym_compiler_directive_decl] = STATE(3468),
    [sym_fsi_directive_decl] = STATE(3468),
    [sym_preproc_line] = STATE(3468),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_DOT_DOT] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [3469] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(4299),
    [sym_function_declaration_left] = STATE(9984),
    [sym_value_declaration_left] = STATE(9984),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3469),
    [sym_compiler_directive_decl] = STATE(3469),
    [sym_fsi_directive_decl] = STATE(3469),
    [sym_preproc_line] = STATE(3469),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_rec] = ACTIONS(5982),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3470] = {
    [sym_type_arguments] = STATE(3605),
    [sym_long_identifier] = STATE(3604),
    [sym_block_comment] = STATE(3470),
    [sym_compiler_directive_decl] = STATE(3470),
    [sym_fsi_directive_decl] = STATE(3470),
    [sym_preproc_line] = STATE(3470),
    [aux_sym_compound_type_repeat1] = STATE(3597),
    [ts_builtin_sym_end] = ACTIONS(5984),
    [sym_identifier] = ACTIONS(5986),
    [anon_sym_namespace] = ACTIONS(5986),
    [anon_sym_module] = ACTIONS(5986),
    [anon_sym_open] = ACTIONS(5986),
    [anon_sym_LBRACK_LT] = ACTIONS(5984),
    [anon_sym_return] = ACTIONS(5986),
    [anon_sym_type] = ACTIONS(5986),
    [anon_sym_do] = ACTIONS(5986),
    [anon_sym_and] = ACTIONS(5986),
    [anon_sym_let] = ACTIONS(5986),
    [anon_sym_let_BANG] = ACTIONS(5984),
    [aux_sym_access_modifier_token1] = ACTIONS(5984),
    [anon_sym_LPAREN] = ACTIONS(5986),
    [anon_sym_null] = ACTIONS(5986),
    [anon_sym_AMP] = ACTIONS(5986),
    [anon_sym_LBRACK] = ACTIONS(5986),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5984),
    [anon_sym_LBRACE] = ACTIONS(5986),
    [anon_sym_LT_AT] = ACTIONS(5986),
    [anon_sym_LT_AT_AT] = ACTIONS(5984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5984),
    [anon_sym_new] = ACTIONS(5986),
    [anon_sym_return_BANG] = ACTIONS(5984),
    [anon_sym_yield] = ACTIONS(5986),
    [anon_sym_yield_BANG] = ACTIONS(5984),
    [anon_sym_lazy] = ACTIONS(5986),
    [anon_sym_assert] = ACTIONS(5986),
    [anon_sym_upcast] = ACTIONS(5986),
    [anon_sym_downcast] = ACTIONS(5986),
    [anon_sym_for] = ACTIONS(5986),
    [anon_sym_while] = ACTIONS(5986),
    [anon_sym_if] = ACTIONS(5986),
    [anon_sym_fun] = ACTIONS(5986),
    [anon_sym_DASH_GT] = ACTIONS(5385),
    [anon_sym_try] = ACTIONS(5986),
    [anon_sym_match] = ACTIONS(5986),
    [anon_sym_match_BANG] = ACTIONS(5984),
    [anon_sym_function] = ACTIONS(5986),
    [anon_sym_use] = ACTIONS(5986),
    [anon_sym_use_BANG] = ACTIONS(5984),
    [anon_sym_do_BANG] = ACTIONS(5984),
    [anon_sym_begin] = ACTIONS(5986),
    [anon_sym_STAR] = ACTIONS(5387),
    [anon_sym_LT2] = ACTIONS(5389),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5391),
    [anon_sym_default] = ACTIONS(5986),
    [anon_sym_static] = ACTIONS(5986),
    [anon_sym_member] = ACTIONS(5986),
    [anon_sym_interface] = ACTIONS(5986),
    [anon_sym_exception] = ACTIONS(5986),
    [anon_sym_abstract] = ACTIONS(5986),
    [anon_sym_val] = ACTIONS(5986),
    [anon_sym_override] = ACTIONS(5986),
    [aux_sym_char_token1] = ACTIONS(5984),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5986),
    [anon_sym_DQUOTE] = ACTIONS(5986),
    [anon_sym_AT_DQUOTE] = ACTIONS(5984),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5984),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5984),
    [sym_bool] = ACTIONS(5986),
    [sym_unit] = ACTIONS(5984),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5986),
    [sym_op_identifier] = ACTIONS(5984),
    [anon_sym_PLUS] = ACTIONS(5986),
    [anon_sym_DASH] = ACTIONS(5986),
    [anon_sym_PLUS_DOT] = ACTIONS(5984),
    [anon_sym_DASH_DOT] = ACTIONS(5984),
    [anon_sym_PERCENT] = ACTIONS(5984),
    [anon_sym_AMP_AMP] = ACTIONS(5984),
    [anon_sym_TILDE] = ACTIONS(5984),
    [aux_sym_prefix_op_token1] = ACTIONS(5984),
    [sym_int] = ACTIONS(5986),
    [sym_xint] = ACTIONS(5984),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5984),
    [anon_sym_POUNDload] = ACTIONS(5984),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(5984),
  },
  [3471] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defns] = STATE(4297),
    [sym__function_or_value_defn_body] = STATE(4233),
    [sym_function_declaration_left] = STATE(10184),
    [sym_value_declaration_left] = STATE(10184),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3471),
    [sym_compiler_directive_decl] = STATE(3471),
    [sym_fsi_directive_decl] = STATE(3471),
    [sym_preproc_line] = STATE(3471),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3472] = {
    [sym_block_comment] = STATE(3472),
    [sym_compiler_directive_decl] = STATE(3472),
    [sym_fsi_directive_decl] = STATE(3472),
    [sym_preproc_line] = STATE(3472),
    [sym_identifier] = ACTIONS(3917),
    [anon_sym_EQ] = ACTIONS(3915),
    [anon_sym_COLON] = ACTIONS(3917),
    [anon_sym_return] = ACTIONS(3917),
    [anon_sym_do] = ACTIONS(3917),
    [anon_sym_let] = ACTIONS(3917),
    [anon_sym_let_BANG] = ACTIONS(3915),
    [anon_sym_LPAREN] = ACTIONS(3917),
    [anon_sym_COMMA] = ACTIONS(3915),
    [anon_sym_null] = ACTIONS(3917),
    [anon_sym_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_COLON] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(3917),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3915),
    [anon_sym_LBRACE] = ACTIONS(3917),
    [anon_sym_LT_AT] = ACTIONS(3917),
    [anon_sym_LT_AT_AT] = ACTIONS(3917),
    [anon_sym_AT_AT_GT] = ACTIONS(3917),
    [anon_sym_DOT] = ACTIONS(3917),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3915),
    [anon_sym_new] = ACTIONS(3917),
    [anon_sym_return_BANG] = ACTIONS(3915),
    [anon_sym_yield] = ACTIONS(3917),
    [anon_sym_yield_BANG] = ACTIONS(3915),
    [anon_sym_lazy] = ACTIONS(3917),
    [anon_sym_assert] = ACTIONS(3917),
    [anon_sym_upcast] = ACTIONS(3917),
    [anon_sym_downcast] = ACTIONS(3917),
    [anon_sym_COLON_GT] = ACTIONS(3915),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3915),
    [anon_sym_for] = ACTIONS(3917),
    [anon_sym_while] = ACTIONS(3917),
    [anon_sym_if] = ACTIONS(3917),
    [anon_sym_fun] = ACTIONS(3917),
    [anon_sym_try] = ACTIONS(3917),
    [anon_sym_match] = ACTIONS(3917),
    [anon_sym_match_BANG] = ACTIONS(3915),
    [anon_sym_function] = ACTIONS(3917),
    [anon_sym_LT_DASH] = ACTIONS(3917),
    [anon_sym_DOT_LBRACK] = ACTIONS(3915),
    [anon_sym_LT] = ACTIONS(3915),
    [anon_sym_use] = ACTIONS(3917),
    [anon_sym_use_BANG] = ACTIONS(3915),
    [anon_sym_do_BANG] = ACTIONS(3915),
    [anon_sym_begin] = ACTIONS(3917),
    [anon_sym_LPAREN2] = ACTIONS(3917),
    [anon_sym_or] = ACTIONS(3917),
    [aux_sym_char_token1] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_AT_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3915),
    [sym_bool] = ACTIONS(3917),
    [sym_unit] = ACTIONS(3915),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3917),
    [sym_op_identifier] = ACTIONS(3917),
    [anon_sym_PLUS] = ACTIONS(3917),
    [anon_sym_DASH] = ACTIONS(3917),
    [anon_sym_PLUS_DOT] = ACTIONS(3917),
    [anon_sym_DASH_DOT] = ACTIONS(3917),
    [anon_sym_PERCENT] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_TILDE] = ACTIONS(3915),
    [aux_sym_prefix_op_token1] = ACTIONS(3917),
    [aux_sym_infix_op_token1] = ACTIONS(3915),
    [aux_sym_infix_op_token2] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_BANG_EQ] = ACTIONS(3917),
    [anon_sym_COLON_EQ] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3917),
    [sym_int] = ACTIONS(3917),
    [sym_xint] = ACTIONS(3915),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3915),
    [sym__newline] = ACTIONS(3915),
  },
  [3473] = {
    [sym_block_comment] = STATE(3473),
    [sym_compiler_directive_decl] = STATE(3473),
    [sym_fsi_directive_decl] = STATE(3473),
    [sym_preproc_line] = STATE(3473),
    [sym_identifier] = ACTIONS(4137),
    [anon_sym_EQ] = ACTIONS(4135),
    [anon_sym_COLON] = ACTIONS(4137),
    [anon_sym_return] = ACTIONS(4137),
    [anon_sym_do] = ACTIONS(4137),
    [anon_sym_let] = ACTIONS(4137),
    [anon_sym_let_BANG] = ACTIONS(4135),
    [anon_sym_LPAREN] = ACTIONS(4137),
    [anon_sym_COMMA] = ACTIONS(4135),
    [anon_sym_null] = ACTIONS(4137),
    [anon_sym_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_QMARK] = ACTIONS(4137),
    [anon_sym_COLON_COLON] = ACTIONS(4135),
    [anon_sym_AMP] = ACTIONS(4137),
    [anon_sym_LBRACK] = ACTIONS(4137),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4135),
    [anon_sym_LBRACE] = ACTIONS(4137),
    [anon_sym_LT_AT] = ACTIONS(4137),
    [anon_sym_AT_GT] = ACTIONS(4137),
    [anon_sym_LT_AT_AT] = ACTIONS(4137),
    [anon_sym_DOT] = ACTIONS(4137),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4135),
    [anon_sym_new] = ACTIONS(4137),
    [anon_sym_return_BANG] = ACTIONS(4135),
    [anon_sym_yield] = ACTIONS(4137),
    [anon_sym_yield_BANG] = ACTIONS(4135),
    [anon_sym_lazy] = ACTIONS(4137),
    [anon_sym_assert] = ACTIONS(4137),
    [anon_sym_upcast] = ACTIONS(4137),
    [anon_sym_downcast] = ACTIONS(4137),
    [anon_sym_COLON_GT] = ACTIONS(4135),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4135),
    [anon_sym_for] = ACTIONS(4137),
    [anon_sym_while] = ACTIONS(4137),
    [anon_sym_if] = ACTIONS(4137),
    [anon_sym_fun] = ACTIONS(4137),
    [anon_sym_try] = ACTIONS(4137),
    [anon_sym_match] = ACTIONS(4137),
    [anon_sym_match_BANG] = ACTIONS(4135),
    [anon_sym_function] = ACTIONS(4137),
    [anon_sym_LT_DASH] = ACTIONS(4137),
    [anon_sym_DOT_LBRACK] = ACTIONS(4135),
    [anon_sym_LT] = ACTIONS(4135),
    [anon_sym_use] = ACTIONS(4137),
    [anon_sym_use_BANG] = ACTIONS(4135),
    [anon_sym_do_BANG] = ACTIONS(4135),
    [anon_sym_begin] = ACTIONS(4137),
    [anon_sym_LPAREN2] = ACTIONS(4137),
    [anon_sym_or] = ACTIONS(4137),
    [aux_sym_char_token1] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4137),
    [anon_sym_DQUOTE] = ACTIONS(4137),
    [anon_sym_AT_DQUOTE] = ACTIONS(4135),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4135),
    [sym_bool] = ACTIONS(4137),
    [sym_unit] = ACTIONS(4135),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4137),
    [sym_op_identifier] = ACTIONS(4137),
    [anon_sym_PLUS] = ACTIONS(4137),
    [anon_sym_DASH] = ACTIONS(4137),
    [anon_sym_PLUS_DOT] = ACTIONS(4137),
    [anon_sym_DASH_DOT] = ACTIONS(4137),
    [anon_sym_PERCENT] = ACTIONS(4137),
    [anon_sym_AMP_AMP] = ACTIONS(4137),
    [anon_sym_TILDE] = ACTIONS(4135),
    [aux_sym_prefix_op_token1] = ACTIONS(4137),
    [aux_sym_infix_op_token1] = ACTIONS(4135),
    [aux_sym_infix_op_token2] = ACTIONS(4137),
    [anon_sym_PIPE_PIPE] = ACTIONS(4137),
    [anon_sym_BANG_EQ] = ACTIONS(4137),
    [anon_sym_COLON_EQ] = ACTIONS(4135),
    [anon_sym_DOLLAR] = ACTIONS(4137),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4137),
    [sym_int] = ACTIONS(4137),
    [sym_xint] = ACTIONS(4135),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4135),
    [sym__newline] = ACTIONS(4135),
  },
  [3474] = {
    [sym_block_comment] = STATE(3474),
    [sym_compiler_directive_decl] = STATE(3474),
    [sym_fsi_directive_decl] = STATE(3474),
    [sym_preproc_line] = STATE(3474),
    [sym_identifier] = ACTIONS(3931),
    [anon_sym_EQ] = ACTIONS(3929),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_do] = ACTIONS(3931),
    [anon_sym_let] = ACTIONS(3931),
    [anon_sym_let_BANG] = ACTIONS(3929),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_COMMA] = ACTIONS(3929),
    [anon_sym_null] = ACTIONS(3931),
    [anon_sym_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_QMARK] = ACTIONS(3931),
    [anon_sym_COLON_COLON] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3931),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_LT_AT] = ACTIONS(3931),
    [anon_sym_LT_AT_AT] = ACTIONS(3931),
    [anon_sym_AT_AT_GT] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3931),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3929),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_return_BANG] = ACTIONS(3929),
    [anon_sym_yield] = ACTIONS(3931),
    [anon_sym_yield_BANG] = ACTIONS(3929),
    [anon_sym_lazy] = ACTIONS(3931),
    [anon_sym_assert] = ACTIONS(3931),
    [anon_sym_upcast] = ACTIONS(3931),
    [anon_sym_downcast] = ACTIONS(3931),
    [anon_sym_COLON_GT] = ACTIONS(3929),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3929),
    [anon_sym_for] = ACTIONS(3931),
    [anon_sym_while] = ACTIONS(3931),
    [anon_sym_if] = ACTIONS(3931),
    [anon_sym_fun] = ACTIONS(3931),
    [anon_sym_try] = ACTIONS(3931),
    [anon_sym_match] = ACTIONS(3931),
    [anon_sym_match_BANG] = ACTIONS(3929),
    [anon_sym_function] = ACTIONS(3931),
    [anon_sym_LT_DASH] = ACTIONS(3931),
    [anon_sym_DOT_LBRACK] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3929),
    [anon_sym_use] = ACTIONS(3931),
    [anon_sym_use_BANG] = ACTIONS(3929),
    [anon_sym_do_BANG] = ACTIONS(3929),
    [anon_sym_begin] = ACTIONS(3931),
    [anon_sym_LPAREN2] = ACTIONS(3931),
    [anon_sym_or] = ACTIONS(3931),
    [aux_sym_char_token1] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3931),
    [anon_sym_DQUOTE] = ACTIONS(3931),
    [anon_sym_AT_DQUOTE] = ACTIONS(3929),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3929),
    [sym_bool] = ACTIONS(3931),
    [sym_unit] = ACTIONS(3929),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3931),
    [sym_op_identifier] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3931),
    [anon_sym_DASH] = ACTIONS(3931),
    [anon_sym_PLUS_DOT] = ACTIONS(3931),
    [anon_sym_DASH_DOT] = ACTIONS(3931),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_TILDE] = ACTIONS(3929),
    [aux_sym_prefix_op_token1] = ACTIONS(3931),
    [aux_sym_infix_op_token1] = ACTIONS(3929),
    [aux_sym_infix_op_token2] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3931),
    [anon_sym_COLON_EQ] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3931),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3931),
    [sym_int] = ACTIONS(3931),
    [sym_xint] = ACTIONS(3929),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3929),
    [sym__newline] = ACTIONS(3929),
  },
  [3475] = {
    [sym_block_comment] = STATE(3475),
    [sym_compiler_directive_decl] = STATE(3475),
    [sym_fsi_directive_decl] = STATE(3475),
    [sym_preproc_line] = STATE(3475),
    [sym_identifier] = ACTIONS(3942),
    [anon_sym_EQ] = ACTIONS(3940),
    [anon_sym_COLON] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_let_BANG] = ACTIONS(3940),
    [anon_sym_LPAREN] = ACTIONS(3942),
    [anon_sym_COMMA] = ACTIONS(3940),
    [anon_sym_null] = ACTIONS(3942),
    [anon_sym_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3940),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3940),
    [anon_sym_LBRACE] = ACTIONS(3942),
    [anon_sym_LT_AT] = ACTIONS(3942),
    [anon_sym_LT_AT_AT] = ACTIONS(3942),
    [anon_sym_AT_AT_GT] = ACTIONS(3942),
    [anon_sym_DOT] = ACTIONS(3942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3940),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_return_BANG] = ACTIONS(3940),
    [anon_sym_yield] = ACTIONS(3942),
    [anon_sym_yield_BANG] = ACTIONS(3940),
    [anon_sym_lazy] = ACTIONS(3942),
    [anon_sym_assert] = ACTIONS(3942),
    [anon_sym_upcast] = ACTIONS(3942),
    [anon_sym_downcast] = ACTIONS(3942),
    [anon_sym_COLON_GT] = ACTIONS(3940),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3940),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_fun] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_match] = ACTIONS(3942),
    [anon_sym_match_BANG] = ACTIONS(3940),
    [anon_sym_function] = ACTIONS(3942),
    [anon_sym_LT_DASH] = ACTIONS(3942),
    [anon_sym_DOT_LBRACK] = ACTIONS(3940),
    [anon_sym_LT] = ACTIONS(3940),
    [anon_sym_use] = ACTIONS(3942),
    [anon_sym_use_BANG] = ACTIONS(3940),
    [anon_sym_do_BANG] = ACTIONS(3940),
    [anon_sym_begin] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3942),
    [anon_sym_or] = ACTIONS(3942),
    [aux_sym_char_token1] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3942),
    [anon_sym_DQUOTE] = ACTIONS(3942),
    [anon_sym_AT_DQUOTE] = ACTIONS(3940),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3940),
    [sym_bool] = ACTIONS(3942),
    [sym_unit] = ACTIONS(3940),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3942),
    [sym_op_identifier] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS_DOT] = ACTIONS(3942),
    [anon_sym_DASH_DOT] = ACTIONS(3942),
    [anon_sym_PERCENT] = ACTIONS(3942),
    [anon_sym_AMP_AMP] = ACTIONS(3942),
    [anon_sym_TILDE] = ACTIONS(3940),
    [aux_sym_prefix_op_token1] = ACTIONS(3942),
    [aux_sym_infix_op_token1] = ACTIONS(3940),
    [aux_sym_infix_op_token2] = ACTIONS(3942),
    [anon_sym_PIPE_PIPE] = ACTIONS(3942),
    [anon_sym_BANG_EQ] = ACTIONS(3942),
    [anon_sym_COLON_EQ] = ACTIONS(3940),
    [anon_sym_DOLLAR] = ACTIONS(3942),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3942),
    [sym_int] = ACTIONS(3942),
    [sym_xint] = ACTIONS(3940),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3940),
    [sym__newline] = ACTIONS(3940),
  },
  [3476] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(6634),
    [sym_function_declaration_left] = STATE(10001),
    [sym_value_declaration_left] = STATE(10001),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3476),
    [sym_compiler_directive_decl] = STATE(3476),
    [sym_fsi_directive_decl] = STATE(3476),
    [sym_preproc_line] = STATE(3476),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_rec] = ACTIONS(5988),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3477] = {
    [sym_block_comment] = STATE(3477),
    [sym_compiler_directive_decl] = STATE(3477),
    [sym_fsi_directive_decl] = STATE(3477),
    [sym_preproc_line] = STATE(3477),
    [sym_identifier] = ACTIONS(4224),
    [anon_sym_EQ] = ACTIONS(4222),
    [anon_sym_COLON] = ACTIONS(4224),
    [anon_sym_return] = ACTIONS(4224),
    [anon_sym_do] = ACTIONS(4224),
    [anon_sym_let] = ACTIONS(4224),
    [anon_sym_let_BANG] = ACTIONS(4222),
    [anon_sym_LPAREN] = ACTIONS(4224),
    [anon_sym_COMMA] = ACTIONS(4222),
    [anon_sym_null] = ACTIONS(4224),
    [anon_sym_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_COLON] = ACTIONS(4222),
    [anon_sym_AMP] = ACTIONS(4224),
    [anon_sym_LBRACK] = ACTIONS(4224),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4222),
    [anon_sym_LBRACE] = ACTIONS(4224),
    [anon_sym_LT_AT] = ACTIONS(4224),
    [anon_sym_LT_AT_AT] = ACTIONS(4224),
    [anon_sym_DOT] = ACTIONS(4224),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4222),
    [anon_sym_new] = ACTIONS(4224),
    [anon_sym_return_BANG] = ACTIONS(4222),
    [anon_sym_yield] = ACTIONS(4224),
    [anon_sym_yield_BANG] = ACTIONS(4222),
    [anon_sym_lazy] = ACTIONS(4224),
    [anon_sym_assert] = ACTIONS(4224),
    [anon_sym_upcast] = ACTIONS(4224),
    [anon_sym_downcast] = ACTIONS(4224),
    [anon_sym_COLON_GT] = ACTIONS(4222),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4222),
    [anon_sym_for] = ACTIONS(4224),
    [anon_sym_while] = ACTIONS(4224),
    [anon_sym_if] = ACTIONS(4224),
    [anon_sym_fun] = ACTIONS(4224),
    [anon_sym_try] = ACTIONS(4224),
    [anon_sym_match] = ACTIONS(4224),
    [anon_sym_match_BANG] = ACTIONS(4222),
    [anon_sym_function] = ACTIONS(4224),
    [anon_sym_LT_DASH] = ACTIONS(4224),
    [anon_sym_DOT_LBRACK] = ACTIONS(4222),
    [anon_sym_LT] = ACTIONS(4222),
    [anon_sym_GT] = ACTIONS(4224),
    [anon_sym_use] = ACTIONS(4224),
    [anon_sym_use_BANG] = ACTIONS(4222),
    [anon_sym_do_BANG] = ACTIONS(4222),
    [anon_sym_begin] = ACTIONS(4224),
    [anon_sym_LPAREN2] = ACTIONS(4224),
    [anon_sym_or] = ACTIONS(4224),
    [aux_sym_char_token1] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4224),
    [anon_sym_DQUOTE] = ACTIONS(4224),
    [anon_sym_AT_DQUOTE] = ACTIONS(4222),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4222),
    [sym_bool] = ACTIONS(4224),
    [sym_unit] = ACTIONS(4222),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4224),
    [sym_op_identifier] = ACTIONS(4224),
    [anon_sym_PLUS] = ACTIONS(4224),
    [anon_sym_DASH] = ACTIONS(4224),
    [anon_sym_PLUS_DOT] = ACTIONS(4224),
    [anon_sym_DASH_DOT] = ACTIONS(4224),
    [anon_sym_PERCENT] = ACTIONS(4224),
    [anon_sym_AMP_AMP] = ACTIONS(4224),
    [anon_sym_TILDE] = ACTIONS(4222),
    [aux_sym_prefix_op_token1] = ACTIONS(4224),
    [aux_sym_infix_op_token1] = ACTIONS(4222),
    [aux_sym_infix_op_token2] = ACTIONS(4224),
    [anon_sym_PIPE_PIPE] = ACTIONS(4224),
    [anon_sym_BANG_EQ] = ACTIONS(4224),
    [anon_sym_COLON_EQ] = ACTIONS(4222),
    [anon_sym_DOLLAR] = ACTIONS(4224),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4224),
    [sym_int] = ACTIONS(4224),
    [sym_xint] = ACTIONS(4222),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4222),
    [sym__newline] = ACTIONS(4222),
  },
  [3478] = {
    [sym_block_comment] = STATE(3478),
    [sym_compiler_directive_decl] = STATE(3478),
    [sym_fsi_directive_decl] = STATE(3478),
    [sym_preproc_line] = STATE(3478),
    [sym_identifier] = ACTIONS(3966),
    [anon_sym_EQ] = ACTIONS(3964),
    [anon_sym_COLON] = ACTIONS(3966),
    [anon_sym_return] = ACTIONS(3966),
    [anon_sym_do] = ACTIONS(3966),
    [anon_sym_let] = ACTIONS(3966),
    [anon_sym_let_BANG] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COMMA] = ACTIONS(3964),
    [anon_sym_null] = ACTIONS(3966),
    [anon_sym_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_QMARK] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(3964),
    [anon_sym_AMP] = ACTIONS(3966),
    [anon_sym_LBRACK] = ACTIONS(3966),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3964),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_LT_AT] = ACTIONS(3966),
    [anon_sym_LT_AT_AT] = ACTIONS(3966),
    [anon_sym_AT_AT_GT] = ACTIONS(3966),
    [anon_sym_DOT] = ACTIONS(3966),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3964),
    [anon_sym_new] = ACTIONS(3966),
    [anon_sym_return_BANG] = ACTIONS(3964),
    [anon_sym_yield] = ACTIONS(3966),
    [anon_sym_yield_BANG] = ACTIONS(3964),
    [anon_sym_lazy] = ACTIONS(3966),
    [anon_sym_assert] = ACTIONS(3966),
    [anon_sym_upcast] = ACTIONS(3966),
    [anon_sym_downcast] = ACTIONS(3966),
    [anon_sym_COLON_GT] = ACTIONS(3964),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3964),
    [anon_sym_for] = ACTIONS(3966),
    [anon_sym_while] = ACTIONS(3966),
    [anon_sym_if] = ACTIONS(3966),
    [anon_sym_fun] = ACTIONS(3966),
    [anon_sym_try] = ACTIONS(3966),
    [anon_sym_match] = ACTIONS(3966),
    [anon_sym_match_BANG] = ACTIONS(3964),
    [anon_sym_function] = ACTIONS(3966),
    [anon_sym_LT_DASH] = ACTIONS(3966),
    [anon_sym_DOT_LBRACK] = ACTIONS(3964),
    [anon_sym_LT] = ACTIONS(3964),
    [anon_sym_use] = ACTIONS(3966),
    [anon_sym_use_BANG] = ACTIONS(3964),
    [anon_sym_do_BANG] = ACTIONS(3964),
    [anon_sym_begin] = ACTIONS(3966),
    [anon_sym_LPAREN2] = ACTIONS(3966),
    [anon_sym_or] = ACTIONS(3966),
    [aux_sym_char_token1] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3966),
    [anon_sym_DQUOTE] = ACTIONS(3966),
    [anon_sym_AT_DQUOTE] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [sym_bool] = ACTIONS(3966),
    [sym_unit] = ACTIONS(3964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3966),
    [sym_op_identifier] = ACTIONS(3966),
    [anon_sym_PLUS] = ACTIONS(3966),
    [anon_sym_DASH] = ACTIONS(3966),
    [anon_sym_PLUS_DOT] = ACTIONS(3966),
    [anon_sym_DASH_DOT] = ACTIONS(3966),
    [anon_sym_PERCENT] = ACTIONS(3966),
    [anon_sym_AMP_AMP] = ACTIONS(3966),
    [anon_sym_TILDE] = ACTIONS(3964),
    [aux_sym_prefix_op_token1] = ACTIONS(3966),
    [aux_sym_infix_op_token1] = ACTIONS(3964),
    [aux_sym_infix_op_token2] = ACTIONS(3966),
    [anon_sym_PIPE_PIPE] = ACTIONS(3966),
    [anon_sym_BANG_EQ] = ACTIONS(3966),
    [anon_sym_COLON_EQ] = ACTIONS(3964),
    [anon_sym_DOLLAR] = ACTIONS(3966),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3966),
    [sym_int] = ACTIONS(3966),
    [sym_xint] = ACTIONS(3964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3964),
    [sym__newline] = ACTIONS(3964),
  },
  [3479] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defns] = STATE(6643),
    [sym__function_or_value_defn_body] = STATE(6526),
    [sym_function_declaration_left] = STATE(10001),
    [sym_value_declaration_left] = STATE(10001),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3479),
    [sym_compiler_directive_decl] = STATE(3479),
    [sym_fsi_directive_decl] = STATE(3479),
    [sym_preproc_line] = STATE(3479),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3480] = {
    [sym_block_comment] = STATE(3480),
    [sym_compiler_directive_decl] = STATE(3480),
    [sym_fsi_directive_decl] = STATE(3480),
    [sym_preproc_line] = STATE(3480),
    [sym_identifier] = ACTIONS(4212),
    [anon_sym_EQ] = ACTIONS(4210),
    [anon_sym_COLON] = ACTIONS(4212),
    [anon_sym_return] = ACTIONS(4212),
    [anon_sym_do] = ACTIONS(4212),
    [anon_sym_let] = ACTIONS(4212),
    [anon_sym_let_BANG] = ACTIONS(4210),
    [anon_sym_LPAREN] = ACTIONS(4212),
    [anon_sym_COMMA] = ACTIONS(4210),
    [anon_sym_null] = ACTIONS(4212),
    [anon_sym_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_COLON] = ACTIONS(4210),
    [anon_sym_AMP] = ACTIONS(4212),
    [anon_sym_LBRACK] = ACTIONS(4212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4210),
    [anon_sym_LBRACE] = ACTIONS(4212),
    [anon_sym_LT_AT] = ACTIONS(4212),
    [anon_sym_AT_GT] = ACTIONS(4212),
    [anon_sym_LT_AT_AT] = ACTIONS(4212),
    [anon_sym_DOT] = ACTIONS(4212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4210),
    [anon_sym_new] = ACTIONS(4212),
    [anon_sym_return_BANG] = ACTIONS(4210),
    [anon_sym_yield] = ACTIONS(4212),
    [anon_sym_yield_BANG] = ACTIONS(4210),
    [anon_sym_lazy] = ACTIONS(4212),
    [anon_sym_assert] = ACTIONS(4212),
    [anon_sym_upcast] = ACTIONS(4212),
    [anon_sym_downcast] = ACTIONS(4212),
    [anon_sym_COLON_GT] = ACTIONS(4210),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4210),
    [anon_sym_for] = ACTIONS(4212),
    [anon_sym_while] = ACTIONS(4212),
    [anon_sym_if] = ACTIONS(4212),
    [anon_sym_fun] = ACTIONS(4212),
    [anon_sym_try] = ACTIONS(4212),
    [anon_sym_match] = ACTIONS(4212),
    [anon_sym_match_BANG] = ACTIONS(4210),
    [anon_sym_function] = ACTIONS(4212),
    [anon_sym_LT_DASH] = ACTIONS(4212),
    [anon_sym_DOT_LBRACK] = ACTIONS(4210),
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_use] = ACTIONS(4212),
    [anon_sym_use_BANG] = ACTIONS(4210),
    [anon_sym_do_BANG] = ACTIONS(4210),
    [anon_sym_begin] = ACTIONS(4212),
    [anon_sym_LPAREN2] = ACTIONS(4212),
    [anon_sym_or] = ACTIONS(4212),
    [aux_sym_char_token1] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4212),
    [anon_sym_DQUOTE] = ACTIONS(4212),
    [anon_sym_AT_DQUOTE] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [sym_bool] = ACTIONS(4212),
    [sym_unit] = ACTIONS(4210),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4212),
    [anon_sym_DASH] = ACTIONS(4212),
    [anon_sym_PLUS_DOT] = ACTIONS(4212),
    [anon_sym_DASH_DOT] = ACTIONS(4212),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_AMP_AMP] = ACTIONS(4212),
    [anon_sym_TILDE] = ACTIONS(4210),
    [aux_sym_prefix_op_token1] = ACTIONS(4212),
    [aux_sym_infix_op_token1] = ACTIONS(4210),
    [aux_sym_infix_op_token2] = ACTIONS(4212),
    [anon_sym_PIPE_PIPE] = ACTIONS(4212),
    [anon_sym_BANG_EQ] = ACTIONS(4212),
    [anon_sym_COLON_EQ] = ACTIONS(4210),
    [anon_sym_DOLLAR] = ACTIONS(4212),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4212),
    [sym_int] = ACTIONS(4212),
    [sym_xint] = ACTIONS(4210),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4210),
    [sym__newline] = ACTIONS(4210),
  },
  [3481] = {
    [sym_block_comment] = STATE(3481),
    [sym_compiler_directive_decl] = STATE(3481),
    [sym_fsi_directive_decl] = STATE(3481),
    [sym_preproc_line] = STATE(3481),
    [sym_identifier] = ACTIONS(3980),
    [anon_sym_EQ] = ACTIONS(3978),
    [anon_sym_COLON] = ACTIONS(3980),
    [anon_sym_return] = ACTIONS(3980),
    [anon_sym_do] = ACTIONS(3980),
    [anon_sym_let] = ACTIONS(3980),
    [anon_sym_let_BANG] = ACTIONS(3978),
    [anon_sym_LPAREN] = ACTIONS(3980),
    [anon_sym_COMMA] = ACTIONS(3978),
    [anon_sym_null] = ACTIONS(3980),
    [anon_sym_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_QMARK] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3978),
    [anon_sym_AMP] = ACTIONS(3980),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3978),
    [anon_sym_LBRACE] = ACTIONS(3980),
    [anon_sym_LT_AT] = ACTIONS(3980),
    [anon_sym_LT_AT_AT] = ACTIONS(3980),
    [anon_sym_AT_AT_GT] = ACTIONS(3980),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3978),
    [anon_sym_new] = ACTIONS(3980),
    [anon_sym_return_BANG] = ACTIONS(3978),
    [anon_sym_yield] = ACTIONS(3980),
    [anon_sym_yield_BANG] = ACTIONS(3978),
    [anon_sym_lazy] = ACTIONS(3980),
    [anon_sym_assert] = ACTIONS(3980),
    [anon_sym_upcast] = ACTIONS(3980),
    [anon_sym_downcast] = ACTIONS(3980),
    [anon_sym_COLON_GT] = ACTIONS(3978),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3978),
    [anon_sym_for] = ACTIONS(3980),
    [anon_sym_while] = ACTIONS(3980),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_fun] = ACTIONS(3980),
    [anon_sym_try] = ACTIONS(3980),
    [anon_sym_match] = ACTIONS(3980),
    [anon_sym_match_BANG] = ACTIONS(3978),
    [anon_sym_function] = ACTIONS(3980),
    [anon_sym_LT_DASH] = ACTIONS(3980),
    [anon_sym_DOT_LBRACK] = ACTIONS(3978),
    [anon_sym_LT] = ACTIONS(3978),
    [anon_sym_use] = ACTIONS(3980),
    [anon_sym_use_BANG] = ACTIONS(3978),
    [anon_sym_do_BANG] = ACTIONS(3978),
    [anon_sym_begin] = ACTIONS(3980),
    [anon_sym_LPAREN2] = ACTIONS(3980),
    [anon_sym_or] = ACTIONS(3980),
    [aux_sym_char_token1] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3980),
    [anon_sym_DQUOTE] = ACTIONS(3980),
    [anon_sym_AT_DQUOTE] = ACTIONS(3978),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3978),
    [sym_bool] = ACTIONS(3980),
    [sym_unit] = ACTIONS(3978),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3980),
    [sym_op_identifier] = ACTIONS(3980),
    [anon_sym_PLUS] = ACTIONS(3980),
    [anon_sym_DASH] = ACTIONS(3980),
    [anon_sym_PLUS_DOT] = ACTIONS(3980),
    [anon_sym_DASH_DOT] = ACTIONS(3980),
    [anon_sym_PERCENT] = ACTIONS(3980),
    [anon_sym_AMP_AMP] = ACTIONS(3980),
    [anon_sym_TILDE] = ACTIONS(3978),
    [aux_sym_prefix_op_token1] = ACTIONS(3980),
    [aux_sym_infix_op_token1] = ACTIONS(3978),
    [aux_sym_infix_op_token2] = ACTIONS(3980),
    [anon_sym_PIPE_PIPE] = ACTIONS(3980),
    [anon_sym_BANG_EQ] = ACTIONS(3980),
    [anon_sym_COLON_EQ] = ACTIONS(3978),
    [anon_sym_DOLLAR] = ACTIONS(3980),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3980),
    [sym_int] = ACTIONS(3980),
    [sym_xint] = ACTIONS(3978),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3978),
    [sym__newline] = ACTIONS(3978),
  },
  [3482] = {
    [sym_block_comment] = STATE(3482),
    [sym_compiler_directive_decl] = STATE(3482),
    [sym_fsi_directive_decl] = STATE(3482),
    [sym_preproc_line] = STATE(3482),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_EQ] = ACTIONS(3485),
    [anon_sym_COLON] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_COMMA] = ACTIONS(3485),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_QMARK] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3487),
    [anon_sym_AT_AT_GT] = ACTIONS(3487),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_COLON_GT] = ACTIONS(3485),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3485),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_LT_DASH] = ACTIONS(3487),
    [anon_sym_DOT_LBRACK] = ACTIONS(3485),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_LPAREN2] = ACTIONS(3487),
    [anon_sym_or] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3487),
    [anon_sym_DASH_DOT] = ACTIONS(3487),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3487),
    [aux_sym_infix_op_token1] = ACTIONS(3485),
    [aux_sym_infix_op_token2] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3487),
    [anon_sym_COLON_EQ] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(3487),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3487),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [3483] = {
    [sym_block_comment] = STATE(3483),
    [sym_compiler_directive_decl] = STATE(3483),
    [sym_fsi_directive_decl] = STATE(3483),
    [sym_preproc_line] = STATE(3483),
    [sym_identifier] = ACTIONS(3984),
    [anon_sym_EQ] = ACTIONS(3982),
    [anon_sym_COLON] = ACTIONS(3984),
    [anon_sym_return] = ACTIONS(3984),
    [anon_sym_do] = ACTIONS(3984),
    [anon_sym_let] = ACTIONS(3984),
    [anon_sym_let_BANG] = ACTIONS(3982),
    [anon_sym_LPAREN] = ACTIONS(3984),
    [anon_sym_COMMA] = ACTIONS(3982),
    [anon_sym_null] = ACTIONS(3984),
    [anon_sym_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_QMARK] = ACTIONS(3984),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AMP] = ACTIONS(3984),
    [anon_sym_LBRACK] = ACTIONS(3984),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(3984),
    [anon_sym_LT_AT] = ACTIONS(3984),
    [anon_sym_LT_AT_AT] = ACTIONS(3984),
    [anon_sym_AT_AT_GT] = ACTIONS(3984),
    [anon_sym_DOT] = ACTIONS(3984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3982),
    [anon_sym_new] = ACTIONS(3984),
    [anon_sym_return_BANG] = ACTIONS(3982),
    [anon_sym_yield] = ACTIONS(3984),
    [anon_sym_yield_BANG] = ACTIONS(3982),
    [anon_sym_lazy] = ACTIONS(3984),
    [anon_sym_assert] = ACTIONS(3984),
    [anon_sym_upcast] = ACTIONS(3984),
    [anon_sym_downcast] = ACTIONS(3984),
    [anon_sym_COLON_GT] = ACTIONS(3982),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3982),
    [anon_sym_for] = ACTIONS(3984),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_if] = ACTIONS(3984),
    [anon_sym_fun] = ACTIONS(3984),
    [anon_sym_try] = ACTIONS(3984),
    [anon_sym_match] = ACTIONS(3984),
    [anon_sym_match_BANG] = ACTIONS(3982),
    [anon_sym_function] = ACTIONS(3984),
    [anon_sym_LT_DASH] = ACTIONS(3984),
    [anon_sym_DOT_LBRACK] = ACTIONS(3982),
    [anon_sym_LT] = ACTIONS(3982),
    [anon_sym_use] = ACTIONS(3984),
    [anon_sym_use_BANG] = ACTIONS(3982),
    [anon_sym_do_BANG] = ACTIONS(3982),
    [anon_sym_begin] = ACTIONS(3984),
    [anon_sym_LPAREN2] = ACTIONS(3984),
    [anon_sym_or] = ACTIONS(3984),
    [aux_sym_char_token1] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3984),
    [anon_sym_DQUOTE] = ACTIONS(3984),
    [anon_sym_AT_DQUOTE] = ACTIONS(3982),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3982),
    [sym_bool] = ACTIONS(3984),
    [sym_unit] = ACTIONS(3982),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3984),
    [sym_op_identifier] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3984),
    [anon_sym_DASH] = ACTIONS(3984),
    [anon_sym_PLUS_DOT] = ACTIONS(3984),
    [anon_sym_DASH_DOT] = ACTIONS(3984),
    [anon_sym_PERCENT] = ACTIONS(3984),
    [anon_sym_AMP_AMP] = ACTIONS(3984),
    [anon_sym_TILDE] = ACTIONS(3982),
    [aux_sym_prefix_op_token1] = ACTIONS(3984),
    [aux_sym_infix_op_token1] = ACTIONS(3982),
    [aux_sym_infix_op_token2] = ACTIONS(3984),
    [anon_sym_PIPE_PIPE] = ACTIONS(3984),
    [anon_sym_BANG_EQ] = ACTIONS(3984),
    [anon_sym_COLON_EQ] = ACTIONS(3982),
    [anon_sym_DOLLAR] = ACTIONS(3984),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3984),
    [sym_int] = ACTIONS(3984),
    [sym_xint] = ACTIONS(3982),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3982),
    [sym__newline] = ACTIONS(3982),
  },
  [3484] = {
    [sym_block_comment] = STATE(3484),
    [sym_compiler_directive_decl] = STATE(3484),
    [sym_fsi_directive_decl] = STATE(3484),
    [sym_preproc_line] = STATE(3484),
    [sym_identifier] = ACTIONS(3988),
    [anon_sym_EQ] = ACTIONS(3986),
    [anon_sym_COLON] = ACTIONS(3988),
    [anon_sym_return] = ACTIONS(3988),
    [anon_sym_do] = ACTIONS(3988),
    [anon_sym_let] = ACTIONS(3988),
    [anon_sym_let_BANG] = ACTIONS(3986),
    [anon_sym_LPAREN] = ACTIONS(3988),
    [anon_sym_COMMA] = ACTIONS(3986),
    [anon_sym_null] = ACTIONS(3988),
    [anon_sym_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_QMARK] = ACTIONS(3988),
    [anon_sym_COLON_COLON] = ACTIONS(3986),
    [anon_sym_AMP] = ACTIONS(3988),
    [anon_sym_LBRACK] = ACTIONS(3988),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3986),
    [anon_sym_LBRACE] = ACTIONS(3988),
    [anon_sym_LT_AT] = ACTIONS(3988),
    [anon_sym_LT_AT_AT] = ACTIONS(3988),
    [anon_sym_AT_AT_GT] = ACTIONS(3988),
    [anon_sym_DOT] = ACTIONS(3988),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3986),
    [anon_sym_new] = ACTIONS(3988),
    [anon_sym_return_BANG] = ACTIONS(3986),
    [anon_sym_yield] = ACTIONS(3988),
    [anon_sym_yield_BANG] = ACTIONS(3986),
    [anon_sym_lazy] = ACTIONS(3988),
    [anon_sym_assert] = ACTIONS(3988),
    [anon_sym_upcast] = ACTIONS(3988),
    [anon_sym_downcast] = ACTIONS(3988),
    [anon_sym_COLON_GT] = ACTIONS(3986),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_while] = ACTIONS(3988),
    [anon_sym_if] = ACTIONS(3988),
    [anon_sym_fun] = ACTIONS(3988),
    [anon_sym_try] = ACTIONS(3988),
    [anon_sym_match] = ACTIONS(3988),
    [anon_sym_match_BANG] = ACTIONS(3986),
    [anon_sym_function] = ACTIONS(3988),
    [anon_sym_LT_DASH] = ACTIONS(3988),
    [anon_sym_DOT_LBRACK] = ACTIONS(3986),
    [anon_sym_LT] = ACTIONS(3986),
    [anon_sym_use] = ACTIONS(3988),
    [anon_sym_use_BANG] = ACTIONS(3986),
    [anon_sym_do_BANG] = ACTIONS(3986),
    [anon_sym_begin] = ACTIONS(3988),
    [anon_sym_LPAREN2] = ACTIONS(3988),
    [anon_sym_or] = ACTIONS(3988),
    [aux_sym_char_token1] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3988),
    [anon_sym_DQUOTE] = ACTIONS(3988),
    [anon_sym_AT_DQUOTE] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3986),
    [sym_bool] = ACTIONS(3988),
    [sym_unit] = ACTIONS(3986),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3988),
    [sym_op_identifier] = ACTIONS(3988),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_PLUS_DOT] = ACTIONS(3988),
    [anon_sym_DASH_DOT] = ACTIONS(3988),
    [anon_sym_PERCENT] = ACTIONS(3988),
    [anon_sym_AMP_AMP] = ACTIONS(3988),
    [anon_sym_TILDE] = ACTIONS(3986),
    [aux_sym_prefix_op_token1] = ACTIONS(3988),
    [aux_sym_infix_op_token1] = ACTIONS(3986),
    [aux_sym_infix_op_token2] = ACTIONS(3988),
    [anon_sym_PIPE_PIPE] = ACTIONS(3988),
    [anon_sym_BANG_EQ] = ACTIONS(3988),
    [anon_sym_COLON_EQ] = ACTIONS(3986),
    [anon_sym_DOLLAR] = ACTIONS(3988),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3988),
    [sym_int] = ACTIONS(3988),
    [sym_xint] = ACTIONS(3986),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3986),
    [sym__newline] = ACTIONS(3986),
  },
  [3485] = {
    [sym_block_comment] = STATE(3485),
    [sym_compiler_directive_decl] = STATE(3485),
    [sym_fsi_directive_decl] = STATE(3485),
    [sym_preproc_line] = STATE(3485),
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_EQ] = ACTIONS(3990),
    [anon_sym_COLON] = ACTIONS(3992),
    [anon_sym_return] = ACTIONS(3992),
    [anon_sym_do] = ACTIONS(3992),
    [anon_sym_let] = ACTIONS(3992),
    [anon_sym_let_BANG] = ACTIONS(3990),
    [anon_sym_LPAREN] = ACTIONS(3992),
    [anon_sym_COMMA] = ACTIONS(3990),
    [anon_sym_null] = ACTIONS(3992),
    [anon_sym_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_QMARK] = ACTIONS(3992),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [anon_sym_AMP] = ACTIONS(3992),
    [anon_sym_LBRACK] = ACTIONS(3992),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3990),
    [anon_sym_LBRACE] = ACTIONS(3992),
    [anon_sym_LT_AT] = ACTIONS(3992),
    [anon_sym_LT_AT_AT] = ACTIONS(3992),
    [anon_sym_AT_AT_GT] = ACTIONS(3992),
    [anon_sym_DOT] = ACTIONS(3992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3990),
    [anon_sym_new] = ACTIONS(3992),
    [anon_sym_return_BANG] = ACTIONS(3990),
    [anon_sym_yield] = ACTIONS(3992),
    [anon_sym_yield_BANG] = ACTIONS(3990),
    [anon_sym_lazy] = ACTIONS(3992),
    [anon_sym_assert] = ACTIONS(3992),
    [anon_sym_upcast] = ACTIONS(3992),
    [anon_sym_downcast] = ACTIONS(3992),
    [anon_sym_COLON_GT] = ACTIONS(3990),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3990),
    [anon_sym_for] = ACTIONS(3992),
    [anon_sym_while] = ACTIONS(3992),
    [anon_sym_if] = ACTIONS(3992),
    [anon_sym_fun] = ACTIONS(3992),
    [anon_sym_try] = ACTIONS(3992),
    [anon_sym_match] = ACTIONS(3992),
    [anon_sym_match_BANG] = ACTIONS(3990),
    [anon_sym_function] = ACTIONS(3992),
    [anon_sym_LT_DASH] = ACTIONS(3992),
    [anon_sym_DOT_LBRACK] = ACTIONS(3990),
    [anon_sym_LT] = ACTIONS(3990),
    [anon_sym_use] = ACTIONS(3992),
    [anon_sym_use_BANG] = ACTIONS(3990),
    [anon_sym_do_BANG] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_LPAREN2] = ACTIONS(3992),
    [anon_sym_or] = ACTIONS(3992),
    [aux_sym_char_token1] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3992),
    [anon_sym_DQUOTE] = ACTIONS(3992),
    [anon_sym_AT_DQUOTE] = ACTIONS(3990),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [sym_bool] = ACTIONS(3992),
    [sym_unit] = ACTIONS(3990),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3992),
    [sym_op_identifier] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3992),
    [anon_sym_DASH] = ACTIONS(3992),
    [anon_sym_PLUS_DOT] = ACTIONS(3992),
    [anon_sym_DASH_DOT] = ACTIONS(3992),
    [anon_sym_PERCENT] = ACTIONS(3992),
    [anon_sym_AMP_AMP] = ACTIONS(3992),
    [anon_sym_TILDE] = ACTIONS(3990),
    [aux_sym_prefix_op_token1] = ACTIONS(3992),
    [aux_sym_infix_op_token1] = ACTIONS(3990),
    [aux_sym_infix_op_token2] = ACTIONS(3992),
    [anon_sym_PIPE_PIPE] = ACTIONS(3992),
    [anon_sym_BANG_EQ] = ACTIONS(3992),
    [anon_sym_COLON_EQ] = ACTIONS(3990),
    [anon_sym_DOLLAR] = ACTIONS(3992),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3992),
    [sym_int] = ACTIONS(3992),
    [sym_xint] = ACTIONS(3990),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3990),
    [sym__newline] = ACTIONS(3990),
  },
  [3486] = {
    [sym_block_comment] = STATE(3486),
    [sym_compiler_directive_decl] = STATE(3486),
    [sym_fsi_directive_decl] = STATE(3486),
    [sym_preproc_line] = STATE(3486),
    [sym_identifier] = ACTIONS(4147),
    [anon_sym_EQ] = ACTIONS(4145),
    [anon_sym_COLON] = ACTIONS(4147),
    [anon_sym_return] = ACTIONS(4147),
    [anon_sym_do] = ACTIONS(4147),
    [anon_sym_let] = ACTIONS(4147),
    [anon_sym_let_BANG] = ACTIONS(4145),
    [anon_sym_LPAREN] = ACTIONS(4147),
    [anon_sym_COMMA] = ACTIONS(4145),
    [anon_sym_null] = ACTIONS(4147),
    [anon_sym_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_COLON] = ACTIONS(4145),
    [anon_sym_AMP] = ACTIONS(4147),
    [anon_sym_LBRACK] = ACTIONS(4147),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4145),
    [anon_sym_LBRACE] = ACTIONS(4147),
    [anon_sym_LT_AT] = ACTIONS(4147),
    [anon_sym_LT_AT_AT] = ACTIONS(4147),
    [anon_sym_AT_AT_GT] = ACTIONS(4147),
    [anon_sym_DOT] = ACTIONS(4147),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4145),
    [anon_sym_new] = ACTIONS(4147),
    [anon_sym_return_BANG] = ACTIONS(4145),
    [anon_sym_yield] = ACTIONS(4147),
    [anon_sym_yield_BANG] = ACTIONS(4145),
    [anon_sym_lazy] = ACTIONS(4147),
    [anon_sym_assert] = ACTIONS(4147),
    [anon_sym_upcast] = ACTIONS(4147),
    [anon_sym_downcast] = ACTIONS(4147),
    [anon_sym_COLON_GT] = ACTIONS(4145),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4145),
    [anon_sym_for] = ACTIONS(4147),
    [anon_sym_while] = ACTIONS(4147),
    [anon_sym_if] = ACTIONS(4147),
    [anon_sym_fun] = ACTIONS(4147),
    [anon_sym_try] = ACTIONS(4147),
    [anon_sym_match] = ACTIONS(4147),
    [anon_sym_match_BANG] = ACTIONS(4145),
    [anon_sym_function] = ACTIONS(4147),
    [anon_sym_LT_DASH] = ACTIONS(4147),
    [anon_sym_DOT_LBRACK] = ACTIONS(4145),
    [anon_sym_LT] = ACTIONS(4145),
    [anon_sym_use] = ACTIONS(4147),
    [anon_sym_use_BANG] = ACTIONS(4145),
    [anon_sym_do_BANG] = ACTIONS(4145),
    [anon_sym_begin] = ACTIONS(4147),
    [anon_sym_LPAREN2] = ACTIONS(4147),
    [anon_sym_or] = ACTIONS(4147),
    [aux_sym_char_token1] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4147),
    [anon_sym_DQUOTE] = ACTIONS(4147),
    [anon_sym_AT_DQUOTE] = ACTIONS(4145),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [sym_bool] = ACTIONS(4147),
    [sym_unit] = ACTIONS(4145),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4147),
    [sym_op_identifier] = ACTIONS(4147),
    [anon_sym_PLUS] = ACTIONS(4147),
    [anon_sym_DASH] = ACTIONS(4147),
    [anon_sym_PLUS_DOT] = ACTIONS(4147),
    [anon_sym_DASH_DOT] = ACTIONS(4147),
    [anon_sym_PERCENT] = ACTIONS(4147),
    [anon_sym_AMP_AMP] = ACTIONS(4147),
    [anon_sym_TILDE] = ACTIONS(4145),
    [aux_sym_prefix_op_token1] = ACTIONS(4147),
    [aux_sym_infix_op_token1] = ACTIONS(4145),
    [aux_sym_infix_op_token2] = ACTIONS(4147),
    [anon_sym_PIPE_PIPE] = ACTIONS(4147),
    [anon_sym_BANG_EQ] = ACTIONS(4147),
    [anon_sym_COLON_EQ] = ACTIONS(4145),
    [anon_sym_DOLLAR] = ACTIONS(4147),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4147),
    [sym_int] = ACTIONS(4147),
    [sym_xint] = ACTIONS(4145),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4145),
    [sym__newline] = ACTIONS(4145),
  },
  [3487] = {
    [sym_block_comment] = STATE(3487),
    [sym_compiler_directive_decl] = STATE(3487),
    [sym_fsi_directive_decl] = STATE(3487),
    [sym_preproc_line] = STATE(3487),
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_EQ] = ACTIONS(4149),
    [anon_sym_COLON] = ACTIONS(4151),
    [anon_sym_return] = ACTIONS(4151),
    [anon_sym_do] = ACTIONS(4151),
    [anon_sym_let] = ACTIONS(4151),
    [anon_sym_let_BANG] = ACTIONS(4149),
    [anon_sym_LPAREN] = ACTIONS(4151),
    [anon_sym_COMMA] = ACTIONS(4149),
    [anon_sym_null] = ACTIONS(4151),
    [anon_sym_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_QMARK] = ACTIONS(4151),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_AMP] = ACTIONS(4151),
    [anon_sym_LBRACK] = ACTIONS(4151),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4149),
    [anon_sym_LBRACE] = ACTIONS(4151),
    [anon_sym_LT_AT] = ACTIONS(4151),
    [anon_sym_LT_AT_AT] = ACTIONS(4151),
    [anon_sym_AT_AT_GT] = ACTIONS(4151),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4149),
    [anon_sym_new] = ACTIONS(4151),
    [anon_sym_return_BANG] = ACTIONS(4149),
    [anon_sym_yield] = ACTIONS(4151),
    [anon_sym_yield_BANG] = ACTIONS(4149),
    [anon_sym_lazy] = ACTIONS(4151),
    [anon_sym_assert] = ACTIONS(4151),
    [anon_sym_upcast] = ACTIONS(4151),
    [anon_sym_downcast] = ACTIONS(4151),
    [anon_sym_COLON_GT] = ACTIONS(4149),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4149),
    [anon_sym_for] = ACTIONS(4151),
    [anon_sym_while] = ACTIONS(4151),
    [anon_sym_if] = ACTIONS(4151),
    [anon_sym_fun] = ACTIONS(4151),
    [anon_sym_try] = ACTIONS(4151),
    [anon_sym_match] = ACTIONS(4151),
    [anon_sym_match_BANG] = ACTIONS(4149),
    [anon_sym_function] = ACTIONS(4151),
    [anon_sym_LT_DASH] = ACTIONS(4151),
    [anon_sym_DOT_LBRACK] = ACTIONS(4149),
    [anon_sym_LT] = ACTIONS(4149),
    [anon_sym_use] = ACTIONS(4151),
    [anon_sym_use_BANG] = ACTIONS(4149),
    [anon_sym_do_BANG] = ACTIONS(4149),
    [anon_sym_begin] = ACTIONS(4151),
    [anon_sym_LPAREN2] = ACTIONS(4151),
    [anon_sym_or] = ACTIONS(4151),
    [aux_sym_char_token1] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4151),
    [anon_sym_DQUOTE] = ACTIONS(4151),
    [anon_sym_AT_DQUOTE] = ACTIONS(4149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4149),
    [sym_bool] = ACTIONS(4151),
    [sym_unit] = ACTIONS(4149),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4151),
    [sym_op_identifier] = ACTIONS(4151),
    [anon_sym_PLUS] = ACTIONS(4151),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_PLUS_DOT] = ACTIONS(4151),
    [anon_sym_DASH_DOT] = ACTIONS(4151),
    [anon_sym_PERCENT] = ACTIONS(4151),
    [anon_sym_AMP_AMP] = ACTIONS(4151),
    [anon_sym_TILDE] = ACTIONS(4149),
    [aux_sym_prefix_op_token1] = ACTIONS(4151),
    [aux_sym_infix_op_token1] = ACTIONS(4149),
    [aux_sym_infix_op_token2] = ACTIONS(4151),
    [anon_sym_PIPE_PIPE] = ACTIONS(4151),
    [anon_sym_BANG_EQ] = ACTIONS(4151),
    [anon_sym_COLON_EQ] = ACTIONS(4149),
    [anon_sym_DOLLAR] = ACTIONS(4151),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4151),
    [sym_int] = ACTIONS(4151),
    [sym_xint] = ACTIONS(4149),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4149),
    [sym__newline] = ACTIONS(4149),
  },
  [3488] = {
    [sym_block_comment] = STATE(3488),
    [sym_compiler_directive_decl] = STATE(3488),
    [sym_fsi_directive_decl] = STATE(3488),
    [sym_preproc_line] = STATE(3488),
    [sym_identifier] = ACTIONS(4100),
    [anon_sym_EQ] = ACTIONS(4098),
    [anon_sym_COLON] = ACTIONS(4100),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_do] = ACTIONS(4100),
    [anon_sym_let] = ACTIONS(4100),
    [anon_sym_let_BANG] = ACTIONS(4098),
    [anon_sym_LPAREN] = ACTIONS(4100),
    [anon_sym_COMMA] = ACTIONS(4098),
    [anon_sym_null] = ACTIONS(4100),
    [anon_sym_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_COLON] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4100),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4098),
    [anon_sym_LBRACE] = ACTIONS(4100),
    [anon_sym_LT_AT] = ACTIONS(4100),
    [anon_sym_LT_AT_AT] = ACTIONS(4100),
    [anon_sym_DOT] = ACTIONS(4100),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4098),
    [anon_sym_new] = ACTIONS(4100),
    [anon_sym_return_BANG] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4100),
    [anon_sym_yield_BANG] = ACTIONS(4098),
    [anon_sym_lazy] = ACTIONS(4100),
    [anon_sym_assert] = ACTIONS(4100),
    [anon_sym_upcast] = ACTIONS(4100),
    [anon_sym_downcast] = ACTIONS(4100),
    [anon_sym_COLON_GT] = ACTIONS(4098),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4098),
    [anon_sym_for] = ACTIONS(4100),
    [anon_sym_while] = ACTIONS(4100),
    [anon_sym_if] = ACTIONS(4100),
    [anon_sym_fun] = ACTIONS(4100),
    [anon_sym_try] = ACTIONS(4100),
    [anon_sym_match] = ACTIONS(4100),
    [anon_sym_match_BANG] = ACTIONS(4098),
    [anon_sym_function] = ACTIONS(4100),
    [anon_sym_LT_DASH] = ACTIONS(4100),
    [anon_sym_DOT_LBRACK] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(4098),
    [anon_sym_use] = ACTIONS(4100),
    [anon_sym_use_BANG] = ACTIONS(4098),
    [anon_sym_do_BANG] = ACTIONS(4098),
    [anon_sym_DOT_DOT] = ACTIONS(4098),
    [anon_sym_begin] = ACTIONS(4100),
    [anon_sym_LPAREN2] = ACTIONS(4100),
    [anon_sym_or] = ACTIONS(4100),
    [aux_sym_char_token1] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4100),
    [anon_sym_DQUOTE] = ACTIONS(4100),
    [anon_sym_AT_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [sym_bool] = ACTIONS(4100),
    [sym_unit] = ACTIONS(4098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4100),
    [sym_op_identifier] = ACTIONS(4100),
    [anon_sym_PLUS] = ACTIONS(4100),
    [anon_sym_DASH] = ACTIONS(4100),
    [anon_sym_PLUS_DOT] = ACTIONS(4100),
    [anon_sym_DASH_DOT] = ACTIONS(4100),
    [anon_sym_PERCENT] = ACTIONS(4100),
    [anon_sym_AMP_AMP] = ACTIONS(4100),
    [anon_sym_TILDE] = ACTIONS(4098),
    [aux_sym_prefix_op_token1] = ACTIONS(4100),
    [aux_sym_infix_op_token1] = ACTIONS(4098),
    [aux_sym_infix_op_token2] = ACTIONS(4100),
    [anon_sym_PIPE_PIPE] = ACTIONS(4100),
    [anon_sym_BANG_EQ] = ACTIONS(4100),
    [anon_sym_COLON_EQ] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4100),
    [sym_int] = ACTIONS(4100),
    [sym_xint] = ACTIONS(4098),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4098),
    [sym__newline] = ACTIONS(4098),
  },
  [3489] = {
    [sym_block_comment] = STATE(3489),
    [sym_compiler_directive_decl] = STATE(3489),
    [sym_fsi_directive_decl] = STATE(3489),
    [sym_preproc_line] = STATE(3489),
    [sym_identifier] = ACTIONS(4212),
    [anon_sym_EQ] = ACTIONS(4210),
    [anon_sym_COLON] = ACTIONS(4212),
    [anon_sym_return] = ACTIONS(4212),
    [anon_sym_do] = ACTIONS(4212),
    [anon_sym_let] = ACTIONS(4212),
    [anon_sym_let_BANG] = ACTIONS(4210),
    [anon_sym_LPAREN] = ACTIONS(4212),
    [anon_sym_COMMA] = ACTIONS(4210),
    [anon_sym_null] = ACTIONS(4212),
    [anon_sym_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_QMARK] = ACTIONS(4212),
    [anon_sym_COLON_COLON] = ACTIONS(4210),
    [anon_sym_AMP] = ACTIONS(4212),
    [anon_sym_LBRACK] = ACTIONS(4212),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4210),
    [anon_sym_LBRACE] = ACTIONS(4212),
    [anon_sym_LT_AT] = ACTIONS(4212),
    [anon_sym_LT_AT_AT] = ACTIONS(4212),
    [anon_sym_DOT] = ACTIONS(4212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4210),
    [anon_sym_new] = ACTIONS(4212),
    [anon_sym_return_BANG] = ACTIONS(4210),
    [anon_sym_yield] = ACTIONS(4212),
    [anon_sym_yield_BANG] = ACTIONS(4210),
    [anon_sym_lazy] = ACTIONS(4212),
    [anon_sym_assert] = ACTIONS(4212),
    [anon_sym_upcast] = ACTIONS(4212),
    [anon_sym_downcast] = ACTIONS(4212),
    [anon_sym_COLON_GT] = ACTIONS(4210),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4210),
    [anon_sym_for] = ACTIONS(4212),
    [anon_sym_while] = ACTIONS(4212),
    [anon_sym_if] = ACTIONS(4212),
    [anon_sym_fun] = ACTIONS(4212),
    [anon_sym_try] = ACTIONS(4212),
    [anon_sym_match] = ACTIONS(4212),
    [anon_sym_match_BANG] = ACTIONS(4210),
    [anon_sym_function] = ACTIONS(4212),
    [anon_sym_LT_DASH] = ACTIONS(4212),
    [anon_sym_DOT_LBRACK] = ACTIONS(4210),
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_GT] = ACTIONS(4212),
    [anon_sym_use] = ACTIONS(4212),
    [anon_sym_use_BANG] = ACTIONS(4210),
    [anon_sym_do_BANG] = ACTIONS(4210),
    [anon_sym_begin] = ACTIONS(4212),
    [anon_sym_LPAREN2] = ACTIONS(4212),
    [anon_sym_or] = ACTIONS(4212),
    [aux_sym_char_token1] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4212),
    [anon_sym_DQUOTE] = ACTIONS(4212),
    [anon_sym_AT_DQUOTE] = ACTIONS(4210),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4210),
    [sym_bool] = ACTIONS(4212),
    [sym_unit] = ACTIONS(4210),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4212),
    [anon_sym_DASH] = ACTIONS(4212),
    [anon_sym_PLUS_DOT] = ACTIONS(4212),
    [anon_sym_DASH_DOT] = ACTIONS(4212),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_AMP_AMP] = ACTIONS(4212),
    [anon_sym_TILDE] = ACTIONS(4210),
    [aux_sym_prefix_op_token1] = ACTIONS(4212),
    [aux_sym_infix_op_token1] = ACTIONS(4210),
    [aux_sym_infix_op_token2] = ACTIONS(4212),
    [anon_sym_PIPE_PIPE] = ACTIONS(4212),
    [anon_sym_BANG_EQ] = ACTIONS(4212),
    [anon_sym_COLON_EQ] = ACTIONS(4210),
    [anon_sym_DOLLAR] = ACTIONS(4212),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4212),
    [sym_int] = ACTIONS(4212),
    [sym_xint] = ACTIONS(4210),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4210),
    [sym__newline] = ACTIONS(4210),
  },
  [3490] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_type_arguments] = STATE(3876),
    [sym__method_defn] = STATE(6769),
    [sym__property_defn] = STATE(6759),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3490),
    [sym_compiler_directive_decl] = STATE(3490),
    [sym_fsi_directive_decl] = STATE(3490),
    [sym_preproc_line] = STATE(3490),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3754),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(5990),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_COLON] = ACTIONS(5992),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [anon_sym_with] = ACTIONS(5994),
    [anon_sym_LT2] = ACTIONS(5809),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3491] = {
    [sym_block_comment] = STATE(3491),
    [sym_compiler_directive_decl] = STATE(3491),
    [sym_fsi_directive_decl] = STATE(3491),
    [sym_preproc_line] = STATE(3491),
    [sym_identifier] = ACTIONS(4193),
    [anon_sym_EQ] = ACTIONS(4191),
    [anon_sym_COLON] = ACTIONS(4193),
    [anon_sym_return] = ACTIONS(4193),
    [anon_sym_do] = ACTIONS(4193),
    [anon_sym_let] = ACTIONS(4193),
    [anon_sym_let_BANG] = ACTIONS(4191),
    [anon_sym_LPAREN] = ACTIONS(4193),
    [anon_sym_COMMA] = ACTIONS(4191),
    [anon_sym_null] = ACTIONS(4193),
    [anon_sym_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_QMARK] = ACTIONS(4193),
    [anon_sym_COLON_COLON] = ACTIONS(4191),
    [anon_sym_AMP] = ACTIONS(4193),
    [anon_sym_LBRACK] = ACTIONS(4193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4191),
    [anon_sym_LBRACE] = ACTIONS(4193),
    [anon_sym_LT_AT] = ACTIONS(4193),
    [anon_sym_LT_AT_AT] = ACTIONS(4193),
    [anon_sym_AT_AT_GT] = ACTIONS(4193),
    [anon_sym_DOT] = ACTIONS(4193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4191),
    [anon_sym_new] = ACTIONS(4193),
    [anon_sym_return_BANG] = ACTIONS(4191),
    [anon_sym_yield] = ACTIONS(4193),
    [anon_sym_yield_BANG] = ACTIONS(4191),
    [anon_sym_lazy] = ACTIONS(4193),
    [anon_sym_assert] = ACTIONS(4193),
    [anon_sym_upcast] = ACTIONS(4193),
    [anon_sym_downcast] = ACTIONS(4193),
    [anon_sym_COLON_GT] = ACTIONS(4191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4191),
    [anon_sym_for] = ACTIONS(4193),
    [anon_sym_while] = ACTIONS(4193),
    [anon_sym_if] = ACTIONS(4193),
    [anon_sym_fun] = ACTIONS(4193),
    [anon_sym_try] = ACTIONS(4193),
    [anon_sym_match] = ACTIONS(4193),
    [anon_sym_match_BANG] = ACTIONS(4191),
    [anon_sym_function] = ACTIONS(4193),
    [anon_sym_LT_DASH] = ACTIONS(4193),
    [anon_sym_DOT_LBRACK] = ACTIONS(4191),
    [anon_sym_LT] = ACTIONS(4191),
    [anon_sym_use] = ACTIONS(4193),
    [anon_sym_use_BANG] = ACTIONS(4191),
    [anon_sym_do_BANG] = ACTIONS(4191),
    [anon_sym_begin] = ACTIONS(4193),
    [anon_sym_LPAREN2] = ACTIONS(4193),
    [anon_sym_or] = ACTIONS(4193),
    [aux_sym_char_token1] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4193),
    [anon_sym_DQUOTE] = ACTIONS(4193),
    [anon_sym_AT_DQUOTE] = ACTIONS(4191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4191),
    [sym_bool] = ACTIONS(4193),
    [sym_unit] = ACTIONS(4191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4193),
    [sym_op_identifier] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(4193),
    [anon_sym_DASH] = ACTIONS(4193),
    [anon_sym_PLUS_DOT] = ACTIONS(4193),
    [anon_sym_DASH_DOT] = ACTIONS(4193),
    [anon_sym_PERCENT] = ACTIONS(4193),
    [anon_sym_AMP_AMP] = ACTIONS(4193),
    [anon_sym_TILDE] = ACTIONS(4191),
    [aux_sym_prefix_op_token1] = ACTIONS(4193),
    [aux_sym_infix_op_token1] = ACTIONS(4191),
    [aux_sym_infix_op_token2] = ACTIONS(4193),
    [anon_sym_PIPE_PIPE] = ACTIONS(4193),
    [anon_sym_BANG_EQ] = ACTIONS(4193),
    [anon_sym_COLON_EQ] = ACTIONS(4191),
    [anon_sym_DOLLAR] = ACTIONS(4193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4193),
    [sym_int] = ACTIONS(4193),
    [sym_xint] = ACTIONS(4191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4191),
    [sym__newline] = ACTIONS(4191),
  },
  [3492] = {
    [sym_block_comment] = STATE(3492),
    [sym_compiler_directive_decl] = STATE(3492),
    [sym_fsi_directive_decl] = STATE(3492),
    [sym_preproc_line] = STATE(3492),
    [sym_identifier] = ACTIONS(4197),
    [anon_sym_EQ] = ACTIONS(4195),
    [anon_sym_COLON] = ACTIONS(4197),
    [anon_sym_return] = ACTIONS(4197),
    [anon_sym_do] = ACTIONS(4197),
    [anon_sym_let] = ACTIONS(4197),
    [anon_sym_let_BANG] = ACTIONS(4195),
    [anon_sym_LPAREN] = ACTIONS(4197),
    [anon_sym_COMMA] = ACTIONS(4195),
    [anon_sym_null] = ACTIONS(4197),
    [anon_sym_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_QMARK] = ACTIONS(4197),
    [anon_sym_COLON_COLON] = ACTIONS(4195),
    [anon_sym_AMP] = ACTIONS(4197),
    [anon_sym_LBRACK] = ACTIONS(4197),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4195),
    [anon_sym_LBRACE] = ACTIONS(4197),
    [anon_sym_LT_AT] = ACTIONS(4197),
    [anon_sym_LT_AT_AT] = ACTIONS(4197),
    [anon_sym_AT_AT_GT] = ACTIONS(4197),
    [anon_sym_DOT] = ACTIONS(4197),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4195),
    [anon_sym_new] = ACTIONS(4197),
    [anon_sym_return_BANG] = ACTIONS(4195),
    [anon_sym_yield] = ACTIONS(4197),
    [anon_sym_yield_BANG] = ACTIONS(4195),
    [anon_sym_lazy] = ACTIONS(4197),
    [anon_sym_assert] = ACTIONS(4197),
    [anon_sym_upcast] = ACTIONS(4197),
    [anon_sym_downcast] = ACTIONS(4197),
    [anon_sym_COLON_GT] = ACTIONS(4195),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4195),
    [anon_sym_for] = ACTIONS(4197),
    [anon_sym_while] = ACTIONS(4197),
    [anon_sym_if] = ACTIONS(4197),
    [anon_sym_fun] = ACTIONS(4197),
    [anon_sym_try] = ACTIONS(4197),
    [anon_sym_match] = ACTIONS(4197),
    [anon_sym_match_BANG] = ACTIONS(4195),
    [anon_sym_function] = ACTIONS(4197),
    [anon_sym_LT_DASH] = ACTIONS(4197),
    [anon_sym_DOT_LBRACK] = ACTIONS(4195),
    [anon_sym_LT] = ACTIONS(4195),
    [anon_sym_use] = ACTIONS(4197),
    [anon_sym_use_BANG] = ACTIONS(4195),
    [anon_sym_do_BANG] = ACTIONS(4195),
    [anon_sym_begin] = ACTIONS(4197),
    [anon_sym_LPAREN2] = ACTIONS(4197),
    [anon_sym_or] = ACTIONS(4197),
    [aux_sym_char_token1] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4197),
    [anon_sym_DQUOTE] = ACTIONS(4197),
    [anon_sym_AT_DQUOTE] = ACTIONS(4195),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4195),
    [sym_bool] = ACTIONS(4197),
    [sym_unit] = ACTIONS(4195),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4197),
    [sym_op_identifier] = ACTIONS(4197),
    [anon_sym_PLUS] = ACTIONS(4197),
    [anon_sym_DASH] = ACTIONS(4197),
    [anon_sym_PLUS_DOT] = ACTIONS(4197),
    [anon_sym_DASH_DOT] = ACTIONS(4197),
    [anon_sym_PERCENT] = ACTIONS(4197),
    [anon_sym_AMP_AMP] = ACTIONS(4197),
    [anon_sym_TILDE] = ACTIONS(4195),
    [aux_sym_prefix_op_token1] = ACTIONS(4197),
    [aux_sym_infix_op_token1] = ACTIONS(4195),
    [aux_sym_infix_op_token2] = ACTIONS(4197),
    [anon_sym_PIPE_PIPE] = ACTIONS(4197),
    [anon_sym_BANG_EQ] = ACTIONS(4197),
    [anon_sym_COLON_EQ] = ACTIONS(4195),
    [anon_sym_DOLLAR] = ACTIONS(4197),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4197),
    [sym_int] = ACTIONS(4197),
    [sym_xint] = ACTIONS(4195),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4195),
    [sym__newline] = ACTIONS(4195),
  },
  [3493] = {
    [sym_block_comment] = STATE(3493),
    [sym_compiler_directive_decl] = STATE(3493),
    [sym_fsi_directive_decl] = STATE(3493),
    [sym_preproc_line] = STATE(3493),
    [sym_identifier] = ACTIONS(4201),
    [anon_sym_EQ] = ACTIONS(4199),
    [anon_sym_COLON] = ACTIONS(4201),
    [anon_sym_return] = ACTIONS(4201),
    [anon_sym_do] = ACTIONS(4201),
    [anon_sym_let] = ACTIONS(4201),
    [anon_sym_let_BANG] = ACTIONS(4199),
    [anon_sym_LPAREN] = ACTIONS(4201),
    [anon_sym_COMMA] = ACTIONS(4199),
    [anon_sym_null] = ACTIONS(4201),
    [anon_sym_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_QMARK] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(4199),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_LBRACK] = ACTIONS(4201),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4199),
    [anon_sym_LBRACE] = ACTIONS(4201),
    [anon_sym_LT_AT] = ACTIONS(4201),
    [anon_sym_LT_AT_AT] = ACTIONS(4201),
    [anon_sym_AT_AT_GT] = ACTIONS(4201),
    [anon_sym_DOT] = ACTIONS(4201),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4199),
    [anon_sym_new] = ACTIONS(4201),
    [anon_sym_return_BANG] = ACTIONS(4199),
    [anon_sym_yield] = ACTIONS(4201),
    [anon_sym_yield_BANG] = ACTIONS(4199),
    [anon_sym_lazy] = ACTIONS(4201),
    [anon_sym_assert] = ACTIONS(4201),
    [anon_sym_upcast] = ACTIONS(4201),
    [anon_sym_downcast] = ACTIONS(4201),
    [anon_sym_COLON_GT] = ACTIONS(4199),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4199),
    [anon_sym_for] = ACTIONS(4201),
    [anon_sym_while] = ACTIONS(4201),
    [anon_sym_if] = ACTIONS(4201),
    [anon_sym_fun] = ACTIONS(4201),
    [anon_sym_try] = ACTIONS(4201),
    [anon_sym_match] = ACTIONS(4201),
    [anon_sym_match_BANG] = ACTIONS(4199),
    [anon_sym_function] = ACTIONS(4201),
    [anon_sym_LT_DASH] = ACTIONS(4201),
    [anon_sym_DOT_LBRACK] = ACTIONS(4199),
    [anon_sym_LT] = ACTIONS(4199),
    [anon_sym_use] = ACTIONS(4201),
    [anon_sym_use_BANG] = ACTIONS(4199),
    [anon_sym_do_BANG] = ACTIONS(4199),
    [anon_sym_begin] = ACTIONS(4201),
    [anon_sym_LPAREN2] = ACTIONS(4201),
    [anon_sym_or] = ACTIONS(4201),
    [aux_sym_char_token1] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4201),
    [anon_sym_DQUOTE] = ACTIONS(4201),
    [anon_sym_AT_DQUOTE] = ACTIONS(4199),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4199),
    [sym_bool] = ACTIONS(4201),
    [sym_unit] = ACTIONS(4199),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4201),
    [sym_op_identifier] = ACTIONS(4201),
    [anon_sym_PLUS] = ACTIONS(4201),
    [anon_sym_DASH] = ACTIONS(4201),
    [anon_sym_PLUS_DOT] = ACTIONS(4201),
    [anon_sym_DASH_DOT] = ACTIONS(4201),
    [anon_sym_PERCENT] = ACTIONS(4201),
    [anon_sym_AMP_AMP] = ACTIONS(4201),
    [anon_sym_TILDE] = ACTIONS(4199),
    [aux_sym_prefix_op_token1] = ACTIONS(4201),
    [aux_sym_infix_op_token1] = ACTIONS(4199),
    [aux_sym_infix_op_token2] = ACTIONS(4201),
    [anon_sym_PIPE_PIPE] = ACTIONS(4201),
    [anon_sym_BANG_EQ] = ACTIONS(4201),
    [anon_sym_COLON_EQ] = ACTIONS(4199),
    [anon_sym_DOLLAR] = ACTIONS(4201),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4201),
    [sym_int] = ACTIONS(4201),
    [sym_xint] = ACTIONS(4199),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4199),
    [sym__newline] = ACTIONS(4199),
  },
  [3494] = {
    [sym_block_comment] = STATE(3494),
    [sym_compiler_directive_decl] = STATE(3494),
    [sym_fsi_directive_decl] = STATE(3494),
    [sym_preproc_line] = STATE(3494),
    [sym_identifier] = ACTIONS(4216),
    [anon_sym_EQ] = ACTIONS(4214),
    [anon_sym_COLON] = ACTIONS(4216),
    [anon_sym_return] = ACTIONS(4216),
    [anon_sym_do] = ACTIONS(4216),
    [anon_sym_let] = ACTIONS(4216),
    [anon_sym_let_BANG] = ACTIONS(4214),
    [anon_sym_LPAREN] = ACTIONS(4216),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_null] = ACTIONS(4216),
    [anon_sym_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_QMARK] = ACTIONS(4216),
    [anon_sym_COLON_COLON] = ACTIONS(4214),
    [anon_sym_AMP] = ACTIONS(4216),
    [anon_sym_LBRACK] = ACTIONS(4216),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4214),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_LT_AT] = ACTIONS(4216),
    [anon_sym_LT_AT_AT] = ACTIONS(4216),
    [anon_sym_AT_AT_GT] = ACTIONS(4216),
    [anon_sym_DOT] = ACTIONS(4216),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4214),
    [anon_sym_new] = ACTIONS(4216),
    [anon_sym_return_BANG] = ACTIONS(4214),
    [anon_sym_yield] = ACTIONS(4216),
    [anon_sym_yield_BANG] = ACTIONS(4214),
    [anon_sym_lazy] = ACTIONS(4216),
    [anon_sym_assert] = ACTIONS(4216),
    [anon_sym_upcast] = ACTIONS(4216),
    [anon_sym_downcast] = ACTIONS(4216),
    [anon_sym_COLON_GT] = ACTIONS(4214),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4214),
    [anon_sym_for] = ACTIONS(4216),
    [anon_sym_while] = ACTIONS(4216),
    [anon_sym_if] = ACTIONS(4216),
    [anon_sym_fun] = ACTIONS(4216),
    [anon_sym_try] = ACTIONS(4216),
    [anon_sym_match] = ACTIONS(4216),
    [anon_sym_match_BANG] = ACTIONS(4214),
    [anon_sym_function] = ACTIONS(4216),
    [anon_sym_LT_DASH] = ACTIONS(4216),
    [anon_sym_DOT_LBRACK] = ACTIONS(4214),
    [anon_sym_LT] = ACTIONS(4214),
    [anon_sym_use] = ACTIONS(4216),
    [anon_sym_use_BANG] = ACTIONS(4214),
    [anon_sym_do_BANG] = ACTIONS(4214),
    [anon_sym_begin] = ACTIONS(4216),
    [anon_sym_LPAREN2] = ACTIONS(4216),
    [anon_sym_or] = ACTIONS(4216),
    [aux_sym_char_token1] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4216),
    [anon_sym_DQUOTE] = ACTIONS(4216),
    [anon_sym_AT_DQUOTE] = ACTIONS(4214),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [sym_bool] = ACTIONS(4216),
    [sym_unit] = ACTIONS(4214),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4216),
    [sym_op_identifier] = ACTIONS(4216),
    [anon_sym_PLUS] = ACTIONS(4216),
    [anon_sym_DASH] = ACTIONS(4216),
    [anon_sym_PLUS_DOT] = ACTIONS(4216),
    [anon_sym_DASH_DOT] = ACTIONS(4216),
    [anon_sym_PERCENT] = ACTIONS(4216),
    [anon_sym_AMP_AMP] = ACTIONS(4216),
    [anon_sym_TILDE] = ACTIONS(4214),
    [aux_sym_prefix_op_token1] = ACTIONS(4216),
    [aux_sym_infix_op_token1] = ACTIONS(4214),
    [aux_sym_infix_op_token2] = ACTIONS(4216),
    [anon_sym_PIPE_PIPE] = ACTIONS(4216),
    [anon_sym_BANG_EQ] = ACTIONS(4216),
    [anon_sym_COLON_EQ] = ACTIONS(4214),
    [anon_sym_DOLLAR] = ACTIONS(4216),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4216),
    [sym_int] = ACTIONS(4216),
    [sym_xint] = ACTIONS(4214),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4214),
    [sym__newline] = ACTIONS(4214),
  },
  [3495] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defns] = STATE(3879),
    [sym__function_or_value_defn_body] = STATE(3751),
    [sym_function_declaration_left] = STATE(10099),
    [sym_value_declaration_left] = STATE(10099),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3495),
    [sym_compiler_directive_decl] = STATE(3495),
    [sym_fsi_directive_decl] = STATE(3495),
    [sym_preproc_line] = STATE(3495),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3496] = {
    [sym_type_arguments] = STATE(3605),
    [sym_long_identifier] = STATE(3604),
    [sym_block_comment] = STATE(3496),
    [sym_compiler_directive_decl] = STATE(3496),
    [sym_fsi_directive_decl] = STATE(3496),
    [sym_preproc_line] = STATE(3496),
    [aux_sym_compound_type_repeat1] = STATE(3597),
    [ts_builtin_sym_end] = ACTIONS(5996),
    [sym_identifier] = ACTIONS(5998),
    [anon_sym_namespace] = ACTIONS(5998),
    [anon_sym_module] = ACTIONS(5998),
    [anon_sym_open] = ACTIONS(5998),
    [anon_sym_LBRACK_LT] = ACTIONS(5996),
    [anon_sym_return] = ACTIONS(5998),
    [anon_sym_type] = ACTIONS(5998),
    [anon_sym_do] = ACTIONS(5998),
    [anon_sym_and] = ACTIONS(5998),
    [anon_sym_let] = ACTIONS(5998),
    [anon_sym_let_BANG] = ACTIONS(5996),
    [aux_sym_access_modifier_token1] = ACTIONS(5996),
    [anon_sym_LPAREN] = ACTIONS(5998),
    [anon_sym_null] = ACTIONS(5998),
    [anon_sym_AMP] = ACTIONS(5998),
    [anon_sym_LBRACK] = ACTIONS(5998),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5996),
    [anon_sym_LBRACE] = ACTIONS(5998),
    [anon_sym_LT_AT] = ACTIONS(5998),
    [anon_sym_LT_AT_AT] = ACTIONS(5996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5996),
    [anon_sym_new] = ACTIONS(5998),
    [anon_sym_return_BANG] = ACTIONS(5996),
    [anon_sym_yield] = ACTIONS(5998),
    [anon_sym_yield_BANG] = ACTIONS(5996),
    [anon_sym_lazy] = ACTIONS(5998),
    [anon_sym_assert] = ACTIONS(5998),
    [anon_sym_upcast] = ACTIONS(5998),
    [anon_sym_downcast] = ACTIONS(5998),
    [anon_sym_for] = ACTIONS(5998),
    [anon_sym_while] = ACTIONS(5998),
    [anon_sym_if] = ACTIONS(5998),
    [anon_sym_fun] = ACTIONS(5998),
    [anon_sym_DASH_GT] = ACTIONS(5385),
    [anon_sym_try] = ACTIONS(5998),
    [anon_sym_match] = ACTIONS(5998),
    [anon_sym_match_BANG] = ACTIONS(5996),
    [anon_sym_function] = ACTIONS(5998),
    [anon_sym_use] = ACTIONS(5998),
    [anon_sym_use_BANG] = ACTIONS(5996),
    [anon_sym_do_BANG] = ACTIONS(5996),
    [anon_sym_begin] = ACTIONS(5998),
    [anon_sym_STAR] = ACTIONS(5387),
    [anon_sym_LT2] = ACTIONS(5389),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5391),
    [anon_sym_default] = ACTIONS(5998),
    [anon_sym_static] = ACTIONS(5998),
    [anon_sym_member] = ACTIONS(5998),
    [anon_sym_interface] = ACTIONS(5998),
    [anon_sym_exception] = ACTIONS(5998),
    [anon_sym_abstract] = ACTIONS(5998),
    [anon_sym_val] = ACTIONS(5998),
    [anon_sym_override] = ACTIONS(5998),
    [aux_sym_char_token1] = ACTIONS(5996),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5998),
    [anon_sym_DQUOTE] = ACTIONS(5998),
    [anon_sym_AT_DQUOTE] = ACTIONS(5996),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5996),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5996),
    [sym_bool] = ACTIONS(5998),
    [sym_unit] = ACTIONS(5996),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5998),
    [sym_op_identifier] = ACTIONS(5996),
    [anon_sym_PLUS] = ACTIONS(5998),
    [anon_sym_DASH] = ACTIONS(5998),
    [anon_sym_PLUS_DOT] = ACTIONS(5996),
    [anon_sym_DASH_DOT] = ACTIONS(5996),
    [anon_sym_PERCENT] = ACTIONS(5996),
    [anon_sym_AMP_AMP] = ACTIONS(5996),
    [anon_sym_TILDE] = ACTIONS(5996),
    [aux_sym_prefix_op_token1] = ACTIONS(5996),
    [sym_int] = ACTIONS(5998),
    [sym_xint] = ACTIONS(5996),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(5996),
    [anon_sym_POUNDload] = ACTIONS(5996),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(5996),
  },
  [3497] = {
    [sym_block_comment] = STATE(3497),
    [sym_compiler_directive_decl] = STATE(3497),
    [sym_fsi_directive_decl] = STATE(3497),
    [sym_preproc_line] = STATE(3497),
    [sym_identifier] = ACTIONS(4220),
    [anon_sym_EQ] = ACTIONS(4218),
    [anon_sym_COLON] = ACTIONS(4220),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_do] = ACTIONS(4220),
    [anon_sym_let] = ACTIONS(4220),
    [anon_sym_let_BANG] = ACTIONS(4218),
    [anon_sym_LPAREN] = ACTIONS(4220),
    [anon_sym_COMMA] = ACTIONS(4218),
    [anon_sym_null] = ACTIONS(4220),
    [anon_sym_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_QMARK] = ACTIONS(4220),
    [anon_sym_COLON_COLON] = ACTIONS(4218),
    [anon_sym_AMP] = ACTIONS(4220),
    [anon_sym_LBRACK] = ACTIONS(4220),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(4220),
    [anon_sym_LT_AT] = ACTIONS(4220),
    [anon_sym_LT_AT_AT] = ACTIONS(4220),
    [anon_sym_AT_AT_GT] = ACTIONS(4220),
    [anon_sym_DOT] = ACTIONS(4220),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4218),
    [anon_sym_new] = ACTIONS(4220),
    [anon_sym_return_BANG] = ACTIONS(4218),
    [anon_sym_yield] = ACTIONS(4220),
    [anon_sym_yield_BANG] = ACTIONS(4218),
    [anon_sym_lazy] = ACTIONS(4220),
    [anon_sym_assert] = ACTIONS(4220),
    [anon_sym_upcast] = ACTIONS(4220),
    [anon_sym_downcast] = ACTIONS(4220),
    [anon_sym_COLON_GT] = ACTIONS(4218),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4218),
    [anon_sym_for] = ACTIONS(4220),
    [anon_sym_while] = ACTIONS(4220),
    [anon_sym_if] = ACTIONS(4220),
    [anon_sym_fun] = ACTIONS(4220),
    [anon_sym_try] = ACTIONS(4220),
    [anon_sym_match] = ACTIONS(4220),
    [anon_sym_match_BANG] = ACTIONS(4218),
    [anon_sym_function] = ACTIONS(4220),
    [anon_sym_LT_DASH] = ACTIONS(4220),
    [anon_sym_DOT_LBRACK] = ACTIONS(4218),
    [anon_sym_LT] = ACTIONS(4218),
    [anon_sym_use] = ACTIONS(4220),
    [anon_sym_use_BANG] = ACTIONS(4218),
    [anon_sym_do_BANG] = ACTIONS(4218),
    [anon_sym_begin] = ACTIONS(4220),
    [anon_sym_LPAREN2] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(4220),
    [aux_sym_char_token1] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4220),
    [anon_sym_DQUOTE] = ACTIONS(4220),
    [anon_sym_AT_DQUOTE] = ACTIONS(4218),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4218),
    [sym_bool] = ACTIONS(4220),
    [sym_unit] = ACTIONS(4218),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4220),
    [sym_op_identifier] = ACTIONS(4220),
    [anon_sym_PLUS] = ACTIONS(4220),
    [anon_sym_DASH] = ACTIONS(4220),
    [anon_sym_PLUS_DOT] = ACTIONS(4220),
    [anon_sym_DASH_DOT] = ACTIONS(4220),
    [anon_sym_PERCENT] = ACTIONS(4220),
    [anon_sym_AMP_AMP] = ACTIONS(4220),
    [anon_sym_TILDE] = ACTIONS(4218),
    [aux_sym_prefix_op_token1] = ACTIONS(4220),
    [aux_sym_infix_op_token1] = ACTIONS(4218),
    [aux_sym_infix_op_token2] = ACTIONS(4220),
    [anon_sym_PIPE_PIPE] = ACTIONS(4220),
    [anon_sym_BANG_EQ] = ACTIONS(4220),
    [anon_sym_COLON_EQ] = ACTIONS(4218),
    [anon_sym_DOLLAR] = ACTIONS(4220),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4220),
    [sym_int] = ACTIONS(4220),
    [sym_xint] = ACTIONS(4218),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4218),
    [sym__newline] = ACTIONS(4218),
  },
  [3498] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(4289),
    [sym_function_declaration_left] = STATE(10031),
    [sym_value_declaration_left] = STATE(10031),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3498),
    [sym_compiler_directive_decl] = STATE(3498),
    [sym_fsi_directive_decl] = STATE(3498),
    [sym_preproc_line] = STATE(3498),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_rec] = ACTIONS(6000),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3499] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defns] = STATE(4283),
    [sym__function_or_value_defn_body] = STATE(4229),
    [sym_function_declaration_left] = STATE(9839),
    [sym_value_declaration_left] = STATE(9839),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3499),
    [sym_compiler_directive_decl] = STATE(3499),
    [sym_fsi_directive_decl] = STATE(3499),
    [sym_preproc_line] = STATE(3499),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3500] = {
    [sym_block_comment] = STATE(3500),
    [sym_compiler_directive_decl] = STATE(3500),
    [sym_fsi_directive_decl] = STATE(3500),
    [sym_preproc_line] = STATE(3500),
    [sym_identifier] = ACTIONS(4236),
    [anon_sym_EQ] = ACTIONS(4234),
    [anon_sym_COLON] = ACTIONS(4236),
    [anon_sym_return] = ACTIONS(4236),
    [anon_sym_do] = ACTIONS(4236),
    [anon_sym_let] = ACTIONS(4236),
    [anon_sym_let_BANG] = ACTIONS(4234),
    [anon_sym_LPAREN] = ACTIONS(4236),
    [anon_sym_COMMA] = ACTIONS(4234),
    [anon_sym_null] = ACTIONS(4236),
    [anon_sym_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_QMARK] = ACTIONS(4236),
    [anon_sym_COLON_COLON] = ACTIONS(4234),
    [anon_sym_AMP] = ACTIONS(4236),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4234),
    [anon_sym_LBRACE] = ACTIONS(4236),
    [anon_sym_LT_AT] = ACTIONS(4236),
    [anon_sym_LT_AT_AT] = ACTIONS(4236),
    [anon_sym_AT_AT_GT] = ACTIONS(4236),
    [anon_sym_DOT] = ACTIONS(4236),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4234),
    [anon_sym_new] = ACTIONS(4236),
    [anon_sym_return_BANG] = ACTIONS(4234),
    [anon_sym_yield] = ACTIONS(4236),
    [anon_sym_yield_BANG] = ACTIONS(4234),
    [anon_sym_lazy] = ACTIONS(4236),
    [anon_sym_assert] = ACTIONS(4236),
    [anon_sym_upcast] = ACTIONS(4236),
    [anon_sym_downcast] = ACTIONS(4236),
    [anon_sym_COLON_GT] = ACTIONS(4234),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4234),
    [anon_sym_for] = ACTIONS(4236),
    [anon_sym_while] = ACTIONS(4236),
    [anon_sym_if] = ACTIONS(4236),
    [anon_sym_fun] = ACTIONS(4236),
    [anon_sym_try] = ACTIONS(4236),
    [anon_sym_match] = ACTIONS(4236),
    [anon_sym_match_BANG] = ACTIONS(4234),
    [anon_sym_function] = ACTIONS(4236),
    [anon_sym_LT_DASH] = ACTIONS(4236),
    [anon_sym_DOT_LBRACK] = ACTIONS(4234),
    [anon_sym_LT] = ACTIONS(4234),
    [anon_sym_use] = ACTIONS(4236),
    [anon_sym_use_BANG] = ACTIONS(4234),
    [anon_sym_do_BANG] = ACTIONS(4234),
    [anon_sym_begin] = ACTIONS(4236),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_or] = ACTIONS(4236),
    [aux_sym_char_token1] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4236),
    [anon_sym_DQUOTE] = ACTIONS(4236),
    [anon_sym_AT_DQUOTE] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4234),
    [sym_bool] = ACTIONS(4236),
    [sym_unit] = ACTIONS(4234),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4236),
    [sym_op_identifier] = ACTIONS(4236),
    [anon_sym_PLUS] = ACTIONS(4236),
    [anon_sym_DASH] = ACTIONS(4236),
    [anon_sym_PLUS_DOT] = ACTIONS(4236),
    [anon_sym_DASH_DOT] = ACTIONS(4236),
    [anon_sym_PERCENT] = ACTIONS(4236),
    [anon_sym_AMP_AMP] = ACTIONS(4236),
    [anon_sym_TILDE] = ACTIONS(4234),
    [aux_sym_prefix_op_token1] = ACTIONS(4236),
    [aux_sym_infix_op_token1] = ACTIONS(4234),
    [aux_sym_infix_op_token2] = ACTIONS(4236),
    [anon_sym_PIPE_PIPE] = ACTIONS(4236),
    [anon_sym_BANG_EQ] = ACTIONS(4236),
    [anon_sym_COLON_EQ] = ACTIONS(4234),
    [anon_sym_DOLLAR] = ACTIONS(4236),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4236),
    [sym_int] = ACTIONS(4236),
    [sym_xint] = ACTIONS(4234),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4234),
    [sym__newline] = ACTIONS(4234),
  },
  [3501] = {
    [sym_block_comment] = STATE(3501),
    [sym_compiler_directive_decl] = STATE(3501),
    [sym_fsi_directive_decl] = STATE(3501),
    [sym_preproc_line] = STATE(3501),
    [sym_identifier] = ACTIONS(4208),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_COLON] = ACTIONS(4208),
    [anon_sym_return] = ACTIONS(4208),
    [anon_sym_do] = ACTIONS(4208),
    [anon_sym_let] = ACTIONS(4208),
    [anon_sym_let_BANG] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(4206),
    [anon_sym_null] = ACTIONS(4208),
    [anon_sym_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_COLON] = ACTIONS(4206),
    [anon_sym_AMP] = ACTIONS(4208),
    [anon_sym_LBRACK] = ACTIONS(4208),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4206),
    [anon_sym_LBRACE] = ACTIONS(4208),
    [anon_sym_LT_AT] = ACTIONS(4208),
    [anon_sym_AT_GT] = ACTIONS(4208),
    [anon_sym_LT_AT_AT] = ACTIONS(4208),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4206),
    [anon_sym_new] = ACTIONS(4208),
    [anon_sym_return_BANG] = ACTIONS(4206),
    [anon_sym_yield] = ACTIONS(4208),
    [anon_sym_yield_BANG] = ACTIONS(4206),
    [anon_sym_lazy] = ACTIONS(4208),
    [anon_sym_assert] = ACTIONS(4208),
    [anon_sym_upcast] = ACTIONS(4208),
    [anon_sym_downcast] = ACTIONS(4208),
    [anon_sym_COLON_GT] = ACTIONS(4206),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4206),
    [anon_sym_for] = ACTIONS(4208),
    [anon_sym_while] = ACTIONS(4208),
    [anon_sym_if] = ACTIONS(4208),
    [anon_sym_fun] = ACTIONS(4208),
    [anon_sym_try] = ACTIONS(4208),
    [anon_sym_match] = ACTIONS(4208),
    [anon_sym_match_BANG] = ACTIONS(4206),
    [anon_sym_function] = ACTIONS(4208),
    [anon_sym_LT_DASH] = ACTIONS(4208),
    [anon_sym_DOT_LBRACK] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(4206),
    [anon_sym_use] = ACTIONS(4208),
    [anon_sym_use_BANG] = ACTIONS(4206),
    [anon_sym_do_BANG] = ACTIONS(4206),
    [anon_sym_begin] = ACTIONS(4208),
    [anon_sym_LPAREN2] = ACTIONS(4208),
    [anon_sym_or] = ACTIONS(4208),
    [aux_sym_char_token1] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4208),
    [anon_sym_DQUOTE] = ACTIONS(4208),
    [anon_sym_AT_DQUOTE] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [sym_bool] = ACTIONS(4208),
    [sym_unit] = ACTIONS(4206),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4208),
    [sym_op_identifier] = ACTIONS(4208),
    [anon_sym_PLUS] = ACTIONS(4208),
    [anon_sym_DASH] = ACTIONS(4208),
    [anon_sym_PLUS_DOT] = ACTIONS(4208),
    [anon_sym_DASH_DOT] = ACTIONS(4208),
    [anon_sym_PERCENT] = ACTIONS(4208),
    [anon_sym_AMP_AMP] = ACTIONS(4208),
    [anon_sym_TILDE] = ACTIONS(4206),
    [aux_sym_prefix_op_token1] = ACTIONS(4208),
    [aux_sym_infix_op_token1] = ACTIONS(4206),
    [aux_sym_infix_op_token2] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(4208),
    [anon_sym_BANG_EQ] = ACTIONS(4208),
    [anon_sym_COLON_EQ] = ACTIONS(4206),
    [anon_sym_DOLLAR] = ACTIONS(4208),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4208),
    [sym_int] = ACTIONS(4208),
    [sym_xint] = ACTIONS(4206),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4206),
    [sym__newline] = ACTIONS(4206),
  },
  [3502] = {
    [sym_block_comment] = STATE(3502),
    [sym_compiler_directive_decl] = STATE(3502),
    [sym_fsi_directive_decl] = STATE(3502),
    [sym_preproc_line] = STATE(3502),
    [sym_identifier] = ACTIONS(4240),
    [anon_sym_EQ] = ACTIONS(4238),
    [anon_sym_COLON] = ACTIONS(4240),
    [anon_sym_return] = ACTIONS(4240),
    [anon_sym_do] = ACTIONS(4240),
    [anon_sym_let] = ACTIONS(4240),
    [anon_sym_let_BANG] = ACTIONS(4238),
    [anon_sym_LPAREN] = ACTIONS(4240),
    [anon_sym_COMMA] = ACTIONS(4238),
    [anon_sym_null] = ACTIONS(4240),
    [anon_sym_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_QMARK] = ACTIONS(4240),
    [anon_sym_COLON_COLON] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4240),
    [anon_sym_LBRACK] = ACTIONS(4240),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4238),
    [anon_sym_LBRACE] = ACTIONS(4240),
    [anon_sym_LT_AT] = ACTIONS(4240),
    [anon_sym_LT_AT_AT] = ACTIONS(4240),
    [anon_sym_AT_AT_GT] = ACTIONS(4240),
    [anon_sym_DOT] = ACTIONS(4240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4238),
    [anon_sym_new] = ACTIONS(4240),
    [anon_sym_return_BANG] = ACTIONS(4238),
    [anon_sym_yield] = ACTIONS(4240),
    [anon_sym_yield_BANG] = ACTIONS(4238),
    [anon_sym_lazy] = ACTIONS(4240),
    [anon_sym_assert] = ACTIONS(4240),
    [anon_sym_upcast] = ACTIONS(4240),
    [anon_sym_downcast] = ACTIONS(4240),
    [anon_sym_COLON_GT] = ACTIONS(4238),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4238),
    [anon_sym_for] = ACTIONS(4240),
    [anon_sym_while] = ACTIONS(4240),
    [anon_sym_if] = ACTIONS(4240),
    [anon_sym_fun] = ACTIONS(4240),
    [anon_sym_try] = ACTIONS(4240),
    [anon_sym_match] = ACTIONS(4240),
    [anon_sym_match_BANG] = ACTIONS(4238),
    [anon_sym_function] = ACTIONS(4240),
    [anon_sym_LT_DASH] = ACTIONS(4240),
    [anon_sym_DOT_LBRACK] = ACTIONS(4238),
    [anon_sym_LT] = ACTIONS(4238),
    [anon_sym_use] = ACTIONS(4240),
    [anon_sym_use_BANG] = ACTIONS(4238),
    [anon_sym_do_BANG] = ACTIONS(4238),
    [anon_sym_begin] = ACTIONS(4240),
    [anon_sym_LPAREN2] = ACTIONS(4240),
    [anon_sym_or] = ACTIONS(4240),
    [aux_sym_char_token1] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4240),
    [anon_sym_DQUOTE] = ACTIONS(4240),
    [anon_sym_AT_DQUOTE] = ACTIONS(4238),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4238),
    [sym_bool] = ACTIONS(4240),
    [sym_unit] = ACTIONS(4238),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4240),
    [sym_op_identifier] = ACTIONS(4240),
    [anon_sym_PLUS] = ACTIONS(4240),
    [anon_sym_DASH] = ACTIONS(4240),
    [anon_sym_PLUS_DOT] = ACTIONS(4240),
    [anon_sym_DASH_DOT] = ACTIONS(4240),
    [anon_sym_PERCENT] = ACTIONS(4240),
    [anon_sym_AMP_AMP] = ACTIONS(4240),
    [anon_sym_TILDE] = ACTIONS(4238),
    [aux_sym_prefix_op_token1] = ACTIONS(4240),
    [aux_sym_infix_op_token1] = ACTIONS(4238),
    [aux_sym_infix_op_token2] = ACTIONS(4240),
    [anon_sym_PIPE_PIPE] = ACTIONS(4240),
    [anon_sym_BANG_EQ] = ACTIONS(4240),
    [anon_sym_COLON_EQ] = ACTIONS(4238),
    [anon_sym_DOLLAR] = ACTIONS(4240),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4240),
    [sym_int] = ACTIONS(4240),
    [sym_xint] = ACTIONS(4238),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4238),
    [sym__newline] = ACTIONS(4238),
  },
  [3503] = {
    [sym_block_comment] = STATE(3503),
    [sym_compiler_directive_decl] = STATE(3503),
    [sym_fsi_directive_decl] = STATE(3503),
    [sym_preproc_line] = STATE(3503),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4739),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
    [sym__dedent] = ACTIONS(6002),
  },
  [3504] = {
    [sym_block_comment] = STATE(3504),
    [sym_compiler_directive_decl] = STATE(3504),
    [sym_fsi_directive_decl] = STATE(3504),
    [sym_preproc_line] = STATE(3504),
    [sym_identifier] = ACTIONS(3889),
    [anon_sym_EQ] = ACTIONS(3887),
    [anon_sym_COLON] = ACTIONS(3889),
    [anon_sym_return] = ACTIONS(3889),
    [anon_sym_do] = ACTIONS(3889),
    [anon_sym_let] = ACTIONS(3889),
    [anon_sym_let_BANG] = ACTIONS(3887),
    [anon_sym_LPAREN] = ACTIONS(3889),
    [anon_sym_COMMA] = ACTIONS(3887),
    [anon_sym_null] = ACTIONS(3889),
    [anon_sym_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_COLON] = ACTIONS(3887),
    [anon_sym_AMP] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3887),
    [anon_sym_LBRACE] = ACTIONS(3889),
    [anon_sym_LT_AT] = ACTIONS(3889),
    [anon_sym_LT_AT_AT] = ACTIONS(3889),
    [anon_sym_DOT] = ACTIONS(3889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [anon_sym_new] = ACTIONS(3889),
    [anon_sym_return_BANG] = ACTIONS(3887),
    [anon_sym_yield] = ACTIONS(3889),
    [anon_sym_yield_BANG] = ACTIONS(3887),
    [anon_sym_lazy] = ACTIONS(3889),
    [anon_sym_assert] = ACTIONS(3889),
    [anon_sym_upcast] = ACTIONS(3889),
    [anon_sym_downcast] = ACTIONS(3889),
    [anon_sym_COLON_GT] = ACTIONS(3887),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3887),
    [anon_sym_for] = ACTIONS(3889),
    [anon_sym_while] = ACTIONS(3889),
    [anon_sym_if] = ACTIONS(3889),
    [anon_sym_fun] = ACTIONS(3889),
    [anon_sym_try] = ACTIONS(3889),
    [anon_sym_match] = ACTIONS(3889),
    [anon_sym_match_BANG] = ACTIONS(3887),
    [anon_sym_function] = ACTIONS(3889),
    [anon_sym_LT_DASH] = ACTIONS(3889),
    [anon_sym_DOT_LBRACK] = ACTIONS(3887),
    [anon_sym_LT] = ACTIONS(3887),
    [anon_sym_use] = ACTIONS(3889),
    [anon_sym_use_BANG] = ACTIONS(3887),
    [anon_sym_do_BANG] = ACTIONS(3887),
    [anon_sym_DOT_DOT] = ACTIONS(3887),
    [anon_sym_begin] = ACTIONS(3889),
    [anon_sym_LPAREN2] = ACTIONS(3889),
    [anon_sym_or] = ACTIONS(3889),
    [aux_sym_char_token1] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3889),
    [anon_sym_DQUOTE] = ACTIONS(3889),
    [anon_sym_AT_DQUOTE] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [sym_bool] = ACTIONS(3889),
    [sym_unit] = ACTIONS(3887),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3889),
    [sym_op_identifier] = ACTIONS(3889),
    [anon_sym_PLUS] = ACTIONS(3889),
    [anon_sym_DASH] = ACTIONS(3889),
    [anon_sym_PLUS_DOT] = ACTIONS(3889),
    [anon_sym_DASH_DOT] = ACTIONS(3889),
    [anon_sym_PERCENT] = ACTIONS(3889),
    [anon_sym_AMP_AMP] = ACTIONS(3889),
    [anon_sym_TILDE] = ACTIONS(3887),
    [aux_sym_prefix_op_token1] = ACTIONS(3889),
    [aux_sym_infix_op_token1] = ACTIONS(3887),
    [aux_sym_infix_op_token2] = ACTIONS(3889),
    [anon_sym_PIPE_PIPE] = ACTIONS(3889),
    [anon_sym_BANG_EQ] = ACTIONS(3889),
    [anon_sym_COLON_EQ] = ACTIONS(3887),
    [anon_sym_DOLLAR] = ACTIONS(3889),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3889),
    [sym_int] = ACTIONS(3889),
    [sym_xint] = ACTIONS(3887),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3887),
    [sym__newline] = ACTIONS(3887),
  },
  [3505] = {
    [sym_block_comment] = STATE(3505),
    [sym_compiler_directive_decl] = STATE(3505),
    [sym_fsi_directive_decl] = STATE(3505),
    [sym_preproc_line] = STATE(3505),
    [sym_identifier] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4242),
    [anon_sym_COLON] = ACTIONS(4244),
    [anon_sym_return] = ACTIONS(4244),
    [anon_sym_do] = ACTIONS(4244),
    [anon_sym_let] = ACTIONS(4244),
    [anon_sym_let_BANG] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_null] = ACTIONS(4244),
    [anon_sym_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_QMARK] = ACTIONS(4244),
    [anon_sym_COLON_COLON] = ACTIONS(4242),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4244),
    [anon_sym_LT_AT] = ACTIONS(4244),
    [anon_sym_LT_AT_AT] = ACTIONS(4244),
    [anon_sym_AT_AT_GT] = ACTIONS(4244),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4242),
    [anon_sym_new] = ACTIONS(4244),
    [anon_sym_return_BANG] = ACTIONS(4242),
    [anon_sym_yield] = ACTIONS(4244),
    [anon_sym_yield_BANG] = ACTIONS(4242),
    [anon_sym_lazy] = ACTIONS(4244),
    [anon_sym_assert] = ACTIONS(4244),
    [anon_sym_upcast] = ACTIONS(4244),
    [anon_sym_downcast] = ACTIONS(4244),
    [anon_sym_COLON_GT] = ACTIONS(4242),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4242),
    [anon_sym_for] = ACTIONS(4244),
    [anon_sym_while] = ACTIONS(4244),
    [anon_sym_if] = ACTIONS(4244),
    [anon_sym_fun] = ACTIONS(4244),
    [anon_sym_try] = ACTIONS(4244),
    [anon_sym_match] = ACTIONS(4244),
    [anon_sym_match_BANG] = ACTIONS(4242),
    [anon_sym_function] = ACTIONS(4244),
    [anon_sym_LT_DASH] = ACTIONS(4244),
    [anon_sym_DOT_LBRACK] = ACTIONS(4242),
    [anon_sym_LT] = ACTIONS(4242),
    [anon_sym_use] = ACTIONS(4244),
    [anon_sym_use_BANG] = ACTIONS(4242),
    [anon_sym_do_BANG] = ACTIONS(4242),
    [anon_sym_begin] = ACTIONS(4244),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_or] = ACTIONS(4244),
    [aux_sym_char_token1] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4244),
    [anon_sym_DQUOTE] = ACTIONS(4244),
    [anon_sym_AT_DQUOTE] = ACTIONS(4242),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [sym_bool] = ACTIONS(4244),
    [sym_unit] = ACTIONS(4242),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4244),
    [sym_op_identifier] = ACTIONS(4244),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_DASH] = ACTIONS(4244),
    [anon_sym_PLUS_DOT] = ACTIONS(4244),
    [anon_sym_DASH_DOT] = ACTIONS(4244),
    [anon_sym_PERCENT] = ACTIONS(4244),
    [anon_sym_AMP_AMP] = ACTIONS(4244),
    [anon_sym_TILDE] = ACTIONS(4242),
    [aux_sym_prefix_op_token1] = ACTIONS(4244),
    [aux_sym_infix_op_token1] = ACTIONS(4242),
    [aux_sym_infix_op_token2] = ACTIONS(4244),
    [anon_sym_PIPE_PIPE] = ACTIONS(4244),
    [anon_sym_BANG_EQ] = ACTIONS(4244),
    [anon_sym_COLON_EQ] = ACTIONS(4242),
    [anon_sym_DOLLAR] = ACTIONS(4244),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4244),
    [sym_int] = ACTIONS(4244),
    [sym_xint] = ACTIONS(4242),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4242),
    [sym__newline] = ACTIONS(4242),
  },
  [3506] = {
    [sym_block_comment] = STATE(3506),
    [sym_compiler_directive_decl] = STATE(3506),
    [sym_fsi_directive_decl] = STATE(3506),
    [sym_preproc_line] = STATE(3506),
    [sym_identifier] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4246),
    [anon_sym_COLON] = ACTIONS(4248),
    [anon_sym_return] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4248),
    [anon_sym_let] = ACTIONS(4248),
    [anon_sym_let_BANG] = ACTIONS(4246),
    [anon_sym_LPAREN] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_null] = ACTIONS(4248),
    [anon_sym_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_QMARK] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4248),
    [anon_sym_LT_AT] = ACTIONS(4248),
    [anon_sym_LT_AT_AT] = ACTIONS(4248),
    [anon_sym_AT_AT_GT] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4246),
    [anon_sym_new] = ACTIONS(4248),
    [anon_sym_return_BANG] = ACTIONS(4246),
    [anon_sym_yield] = ACTIONS(4248),
    [anon_sym_yield_BANG] = ACTIONS(4246),
    [anon_sym_lazy] = ACTIONS(4248),
    [anon_sym_assert] = ACTIONS(4248),
    [anon_sym_upcast] = ACTIONS(4248),
    [anon_sym_downcast] = ACTIONS(4248),
    [anon_sym_COLON_GT] = ACTIONS(4246),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4246),
    [anon_sym_for] = ACTIONS(4248),
    [anon_sym_while] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4248),
    [anon_sym_fun] = ACTIONS(4248),
    [anon_sym_try] = ACTIONS(4248),
    [anon_sym_match] = ACTIONS(4248),
    [anon_sym_match_BANG] = ACTIONS(4246),
    [anon_sym_function] = ACTIONS(4248),
    [anon_sym_LT_DASH] = ACTIONS(4248),
    [anon_sym_DOT_LBRACK] = ACTIONS(4246),
    [anon_sym_LT] = ACTIONS(4246),
    [anon_sym_use] = ACTIONS(4248),
    [anon_sym_use_BANG] = ACTIONS(4246),
    [anon_sym_do_BANG] = ACTIONS(4246),
    [anon_sym_begin] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_or] = ACTIONS(4248),
    [aux_sym_char_token1] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4248),
    [anon_sym_DQUOTE] = ACTIONS(4248),
    [anon_sym_AT_DQUOTE] = ACTIONS(4246),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4246),
    [sym_bool] = ACTIONS(4248),
    [sym_unit] = ACTIONS(4246),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4248),
    [sym_op_identifier] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_DASH] = ACTIONS(4248),
    [anon_sym_PLUS_DOT] = ACTIONS(4248),
    [anon_sym_DASH_DOT] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_TILDE] = ACTIONS(4246),
    [aux_sym_prefix_op_token1] = ACTIONS(4248),
    [aux_sym_infix_op_token1] = ACTIONS(4246),
    [aux_sym_infix_op_token2] = ACTIONS(4248),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4248),
    [anon_sym_COLON_EQ] = ACTIONS(4246),
    [anon_sym_DOLLAR] = ACTIONS(4248),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4248),
    [sym_int] = ACTIONS(4248),
    [sym_xint] = ACTIONS(4246),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4246),
    [sym__newline] = ACTIONS(4246),
  },
  [3507] = {
    [sym_block_comment] = STATE(3507),
    [sym_compiler_directive_decl] = STATE(3507),
    [sym_fsi_directive_decl] = STATE(3507),
    [sym_preproc_line] = STATE(3507),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4739),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
    [sym__dedent] = ACTIONS(6004),
  },
  [3508] = {
    [sym_block_comment] = STATE(3508),
    [sym_compiler_directive_decl] = STATE(3508),
    [sym_fsi_directive_decl] = STATE(3508),
    [sym_preproc_line] = STATE(3508),
    [sym_identifier] = ACTIONS(4174),
    [anon_sym_EQ] = ACTIONS(4172),
    [anon_sym_COLON] = ACTIONS(4174),
    [anon_sym_return] = ACTIONS(4174),
    [anon_sym_do] = ACTIONS(4174),
    [anon_sym_let] = ACTIONS(4174),
    [anon_sym_let_BANG] = ACTIONS(4172),
    [anon_sym_LPAREN] = ACTIONS(4174),
    [anon_sym_COMMA] = ACTIONS(4172),
    [anon_sym_null] = ACTIONS(4174),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_QMARK] = ACTIONS(4174),
    [anon_sym_COLON_COLON] = ACTIONS(4172),
    [anon_sym_AMP] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4174),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4172),
    [anon_sym_LBRACE] = ACTIONS(4174),
    [anon_sym_LT_AT] = ACTIONS(4174),
    [anon_sym_LT_AT_AT] = ACTIONS(4174),
    [anon_sym_AT_AT_GT] = ACTIONS(4174),
    [anon_sym_DOT] = ACTIONS(4174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4172),
    [anon_sym_new] = ACTIONS(4174),
    [anon_sym_return_BANG] = ACTIONS(4172),
    [anon_sym_yield] = ACTIONS(4174),
    [anon_sym_yield_BANG] = ACTIONS(4172),
    [anon_sym_lazy] = ACTIONS(4174),
    [anon_sym_assert] = ACTIONS(4174),
    [anon_sym_upcast] = ACTIONS(4174),
    [anon_sym_downcast] = ACTIONS(4174),
    [anon_sym_COLON_GT] = ACTIONS(4172),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4172),
    [anon_sym_for] = ACTIONS(4174),
    [anon_sym_while] = ACTIONS(4174),
    [anon_sym_if] = ACTIONS(4174),
    [anon_sym_fun] = ACTIONS(4174),
    [anon_sym_try] = ACTIONS(4174),
    [anon_sym_match] = ACTIONS(4174),
    [anon_sym_match_BANG] = ACTIONS(4172),
    [anon_sym_function] = ACTIONS(4174),
    [anon_sym_LT_DASH] = ACTIONS(4174),
    [anon_sym_DOT_LBRACK] = ACTIONS(4172),
    [anon_sym_LT] = ACTIONS(4172),
    [anon_sym_use] = ACTIONS(4174),
    [anon_sym_use_BANG] = ACTIONS(4172),
    [anon_sym_do_BANG] = ACTIONS(4172),
    [anon_sym_begin] = ACTIONS(4174),
    [anon_sym_LPAREN2] = ACTIONS(4174),
    [anon_sym_or] = ACTIONS(4174),
    [aux_sym_char_token1] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4174),
    [anon_sym_DQUOTE] = ACTIONS(4174),
    [anon_sym_AT_DQUOTE] = ACTIONS(4172),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4172),
    [sym_bool] = ACTIONS(4174),
    [sym_unit] = ACTIONS(4172),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4174),
    [sym_op_identifier] = ACTIONS(4174),
    [anon_sym_PLUS] = ACTIONS(4174),
    [anon_sym_DASH] = ACTIONS(4174),
    [anon_sym_PLUS_DOT] = ACTIONS(4174),
    [anon_sym_DASH_DOT] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [anon_sym_AMP_AMP] = ACTIONS(4174),
    [anon_sym_TILDE] = ACTIONS(4172),
    [aux_sym_prefix_op_token1] = ACTIONS(4174),
    [aux_sym_infix_op_token1] = ACTIONS(4172),
    [aux_sym_infix_op_token2] = ACTIONS(4174),
    [anon_sym_PIPE_PIPE] = ACTIONS(4174),
    [anon_sym_BANG_EQ] = ACTIONS(4174),
    [anon_sym_COLON_EQ] = ACTIONS(4172),
    [anon_sym_DOLLAR] = ACTIONS(4174),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4174),
    [sym_int] = ACTIONS(4174),
    [sym_xint] = ACTIONS(4172),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4172),
    [sym__newline] = ACTIONS(4172),
  },
  [3509] = {
    [sym_block_comment] = STATE(3509),
    [sym_compiler_directive_decl] = STATE(3509),
    [sym_fsi_directive_decl] = STATE(3509),
    [sym_preproc_line] = STATE(3509),
    [sym_identifier] = ACTIONS(3889),
    [anon_sym_EQ] = ACTIONS(3887),
    [anon_sym_COLON] = ACTIONS(3889),
    [anon_sym_return] = ACTIONS(3889),
    [anon_sym_do] = ACTIONS(3889),
    [anon_sym_let] = ACTIONS(3889),
    [anon_sym_let_BANG] = ACTIONS(3887),
    [anon_sym_LPAREN] = ACTIONS(3889),
    [anon_sym_COMMA] = ACTIONS(3887),
    [anon_sym_null] = ACTIONS(3889),
    [anon_sym_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_QMARK] = ACTIONS(3889),
    [anon_sym_COLON_COLON] = ACTIONS(3887),
    [anon_sym_AMP] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3887),
    [anon_sym_LBRACE] = ACTIONS(3889),
    [anon_sym_LT_AT] = ACTIONS(3889),
    [anon_sym_AT_GT] = ACTIONS(3889),
    [anon_sym_LT_AT_AT] = ACTIONS(3889),
    [anon_sym_DOT] = ACTIONS(3889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [anon_sym_new] = ACTIONS(3889),
    [anon_sym_return_BANG] = ACTIONS(3887),
    [anon_sym_yield] = ACTIONS(3889),
    [anon_sym_yield_BANG] = ACTIONS(3887),
    [anon_sym_lazy] = ACTIONS(3889),
    [anon_sym_assert] = ACTIONS(3889),
    [anon_sym_upcast] = ACTIONS(3889),
    [anon_sym_downcast] = ACTIONS(3889),
    [anon_sym_COLON_GT] = ACTIONS(3887),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3887),
    [anon_sym_for] = ACTIONS(3889),
    [anon_sym_while] = ACTIONS(3889),
    [anon_sym_if] = ACTIONS(3889),
    [anon_sym_fun] = ACTIONS(3889),
    [anon_sym_try] = ACTIONS(3889),
    [anon_sym_match] = ACTIONS(3889),
    [anon_sym_match_BANG] = ACTIONS(3887),
    [anon_sym_function] = ACTIONS(3889),
    [anon_sym_LT_DASH] = ACTIONS(3889),
    [anon_sym_DOT_LBRACK] = ACTIONS(3887),
    [anon_sym_LT] = ACTIONS(3887),
    [anon_sym_use] = ACTIONS(3889),
    [anon_sym_use_BANG] = ACTIONS(3887),
    [anon_sym_do_BANG] = ACTIONS(3887),
    [anon_sym_begin] = ACTIONS(3889),
    [anon_sym_LPAREN2] = ACTIONS(3889),
    [anon_sym_or] = ACTIONS(3889),
    [aux_sym_char_token1] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3889),
    [anon_sym_DQUOTE] = ACTIONS(3889),
    [anon_sym_AT_DQUOTE] = ACTIONS(3887),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3887),
    [sym_bool] = ACTIONS(3889),
    [sym_unit] = ACTIONS(3887),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3889),
    [sym_op_identifier] = ACTIONS(3889),
    [anon_sym_PLUS] = ACTIONS(3889),
    [anon_sym_DASH] = ACTIONS(3889),
    [anon_sym_PLUS_DOT] = ACTIONS(3889),
    [anon_sym_DASH_DOT] = ACTIONS(3889),
    [anon_sym_PERCENT] = ACTIONS(3889),
    [anon_sym_AMP_AMP] = ACTIONS(3889),
    [anon_sym_TILDE] = ACTIONS(3887),
    [aux_sym_prefix_op_token1] = ACTIONS(3889),
    [aux_sym_infix_op_token1] = ACTIONS(3887),
    [aux_sym_infix_op_token2] = ACTIONS(3889),
    [anon_sym_PIPE_PIPE] = ACTIONS(3889),
    [anon_sym_BANG_EQ] = ACTIONS(3889),
    [anon_sym_COLON_EQ] = ACTIONS(3887),
    [anon_sym_DOLLAR] = ACTIONS(3889),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3889),
    [sym_int] = ACTIONS(3889),
    [sym_xint] = ACTIONS(3887),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3887),
    [sym__newline] = ACTIONS(3887),
  },
  [3510] = {
    [sym_block_comment] = STATE(3510),
    [sym_compiler_directive_decl] = STATE(3510),
    [sym_fsi_directive_decl] = STATE(3510),
    [sym_preproc_line] = STATE(3510),
    [sym_identifier] = ACTIONS(4180),
    [anon_sym_EQ] = ACTIONS(4178),
    [anon_sym_COLON] = ACTIONS(4180),
    [anon_sym_return] = ACTIONS(4180),
    [anon_sym_do] = ACTIONS(4180),
    [anon_sym_let] = ACTIONS(4180),
    [anon_sym_let_BANG] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(4180),
    [anon_sym_COMMA] = ACTIONS(4178),
    [anon_sym_null] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_QMARK] = ACTIONS(4180),
    [anon_sym_COLON_COLON] = ACTIONS(4178),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4180),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4180),
    [anon_sym_LT_AT] = ACTIONS(4180),
    [anon_sym_LT_AT_AT] = ACTIONS(4180),
    [anon_sym_AT_AT_GT] = ACTIONS(4180),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4178),
    [anon_sym_new] = ACTIONS(4180),
    [anon_sym_return_BANG] = ACTIONS(4178),
    [anon_sym_yield] = ACTIONS(4180),
    [anon_sym_yield_BANG] = ACTIONS(4178),
    [anon_sym_lazy] = ACTIONS(4180),
    [anon_sym_assert] = ACTIONS(4180),
    [anon_sym_upcast] = ACTIONS(4180),
    [anon_sym_downcast] = ACTIONS(4180),
    [anon_sym_COLON_GT] = ACTIONS(4178),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4178),
    [anon_sym_for] = ACTIONS(4180),
    [anon_sym_while] = ACTIONS(4180),
    [anon_sym_if] = ACTIONS(4180),
    [anon_sym_fun] = ACTIONS(4180),
    [anon_sym_try] = ACTIONS(4180),
    [anon_sym_match] = ACTIONS(4180),
    [anon_sym_match_BANG] = ACTIONS(4178),
    [anon_sym_function] = ACTIONS(4180),
    [anon_sym_LT_DASH] = ACTIONS(4180),
    [anon_sym_DOT_LBRACK] = ACTIONS(4178),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_use] = ACTIONS(4180),
    [anon_sym_use_BANG] = ACTIONS(4178),
    [anon_sym_do_BANG] = ACTIONS(4178),
    [anon_sym_begin] = ACTIONS(4180),
    [anon_sym_LPAREN2] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [aux_sym_char_token1] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4180),
    [anon_sym_DQUOTE] = ACTIONS(4180),
    [anon_sym_AT_DQUOTE] = ACTIONS(4178),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4178),
    [sym_bool] = ACTIONS(4180),
    [sym_unit] = ACTIONS(4178),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4180),
    [sym_op_identifier] = ACTIONS(4180),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_PLUS_DOT] = ACTIONS(4180),
    [anon_sym_DASH_DOT] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_TILDE] = ACTIONS(4178),
    [aux_sym_prefix_op_token1] = ACTIONS(4180),
    [aux_sym_infix_op_token1] = ACTIONS(4178),
    [aux_sym_infix_op_token2] = ACTIONS(4180),
    [anon_sym_PIPE_PIPE] = ACTIONS(4180),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_COLON_EQ] = ACTIONS(4178),
    [anon_sym_DOLLAR] = ACTIONS(4180),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4180),
    [sym_int] = ACTIONS(4180),
    [sym_xint] = ACTIONS(4178),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4178),
    [sym__newline] = ACTIONS(4178),
  },
  [3511] = {
    [sym_block_comment] = STATE(3511),
    [sym_compiler_directive_decl] = STATE(3511),
    [sym_fsi_directive_decl] = STATE(3511),
    [sym_preproc_line] = STATE(3511),
    [sym_identifier] = ACTIONS(4182),
    [anon_sym_EQ] = ACTIONS(3689),
    [anon_sym_COLON] = ACTIONS(4182),
    [anon_sym_return] = ACTIONS(4182),
    [anon_sym_do] = ACTIONS(4182),
    [anon_sym_let] = ACTIONS(4182),
    [anon_sym_let_BANG] = ACTIONS(3689),
    [anon_sym_LPAREN] = ACTIONS(4182),
    [anon_sym_COMMA] = ACTIONS(3689),
    [anon_sym_null] = ACTIONS(4182),
    [anon_sym_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3689),
    [anon_sym_LBRACE] = ACTIONS(4182),
    [anon_sym_LT_AT] = ACTIONS(4182),
    [anon_sym_LT_AT_AT] = ACTIONS(4182),
    [anon_sym_DOT] = ACTIONS(4182),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3689),
    [anon_sym_new] = ACTIONS(4182),
    [anon_sym_return_BANG] = ACTIONS(3689),
    [anon_sym_yield] = ACTIONS(4182),
    [anon_sym_yield_BANG] = ACTIONS(3689),
    [anon_sym_lazy] = ACTIONS(4182),
    [anon_sym_assert] = ACTIONS(4182),
    [anon_sym_upcast] = ACTIONS(4182),
    [anon_sym_downcast] = ACTIONS(4182),
    [anon_sym_COLON_GT] = ACTIONS(3689),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3689),
    [anon_sym_for] = ACTIONS(4182),
    [anon_sym_while] = ACTIONS(4182),
    [anon_sym_if] = ACTIONS(4182),
    [anon_sym_fun] = ACTIONS(4182),
    [anon_sym_try] = ACTIONS(4182),
    [anon_sym_match] = ACTIONS(4182),
    [anon_sym_match_BANG] = ACTIONS(3689),
    [anon_sym_function] = ACTIONS(4182),
    [anon_sym_LT_DASH] = ACTIONS(4182),
    [anon_sym_DOT_LBRACK] = ACTIONS(3689),
    [anon_sym_LT] = ACTIONS(3689),
    [anon_sym_use] = ACTIONS(4182),
    [anon_sym_use_BANG] = ACTIONS(3689),
    [anon_sym_do_BANG] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(4182),
    [anon_sym_LPAREN2] = ACTIONS(4182),
    [anon_sym_or] = ACTIONS(4182),
    [aux_sym_char_token1] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4182),
    [anon_sym_DQUOTE] = ACTIONS(4182),
    [anon_sym_AT_DQUOTE] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [sym_bool] = ACTIONS(4182),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4182),
    [sym_op_identifier] = ACTIONS(4182),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_PLUS_DOT] = ACTIONS(4182),
    [anon_sym_DASH_DOT] = ACTIONS(4182),
    [anon_sym_PERCENT] = ACTIONS(4182),
    [anon_sym_AMP_AMP] = ACTIONS(4182),
    [anon_sym_TILDE] = ACTIONS(3689),
    [aux_sym_prefix_op_token1] = ACTIONS(4182),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token2] = ACTIONS(4182),
    [anon_sym_PIPE_PIPE] = ACTIONS(4182),
    [anon_sym_BANG_EQ] = ACTIONS(4182),
    [anon_sym_COLON_EQ] = ACTIONS(3689),
    [anon_sym_DOLLAR] = ACTIONS(4182),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4182),
    [sym_int] = ACTIONS(4182),
    [sym_xint] = ACTIONS(3689),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3689),
    [sym__newline] = ACTIONS(4973),
    [sym__dedent] = ACTIONS(4973),
  },
  [3512] = {
    [sym_block_comment] = STATE(3512),
    [sym_compiler_directive_decl] = STATE(3512),
    [sym_fsi_directive_decl] = STATE(3512),
    [sym_preproc_line] = STATE(3512),
    [sym_identifier] = ACTIONS(3900),
    [anon_sym_EQ] = ACTIONS(3898),
    [anon_sym_COLON] = ACTIONS(3900),
    [anon_sym_return] = ACTIONS(3900),
    [anon_sym_do] = ACTIONS(3900),
    [anon_sym_let] = ACTIONS(3900),
    [anon_sym_let_BANG] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(3900),
    [anon_sym_COMMA] = ACTIONS(3898),
    [anon_sym_null] = ACTIONS(3900),
    [anon_sym_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_QMARK] = ACTIONS(3900),
    [anon_sym_COLON_COLON] = ACTIONS(3898),
    [anon_sym_AMP] = ACTIONS(3900),
    [anon_sym_LBRACK] = ACTIONS(3900),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3898),
    [anon_sym_LBRACE] = ACTIONS(3900),
    [anon_sym_LT_AT] = ACTIONS(3900),
    [anon_sym_LT_AT_AT] = ACTIONS(3900),
    [anon_sym_AT_AT_GT] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(3900),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3898),
    [anon_sym_new] = ACTIONS(3900),
    [anon_sym_return_BANG] = ACTIONS(3898),
    [anon_sym_yield] = ACTIONS(3900),
    [anon_sym_yield_BANG] = ACTIONS(3898),
    [anon_sym_lazy] = ACTIONS(3900),
    [anon_sym_assert] = ACTIONS(3900),
    [anon_sym_upcast] = ACTIONS(3900),
    [anon_sym_downcast] = ACTIONS(3900),
    [anon_sym_COLON_GT] = ACTIONS(3898),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3898),
    [anon_sym_for] = ACTIONS(3900),
    [anon_sym_while] = ACTIONS(3900),
    [anon_sym_if] = ACTIONS(3900),
    [anon_sym_fun] = ACTIONS(3900),
    [anon_sym_try] = ACTIONS(3900),
    [anon_sym_match] = ACTIONS(3900),
    [anon_sym_match_BANG] = ACTIONS(3898),
    [anon_sym_function] = ACTIONS(3900),
    [anon_sym_LT_DASH] = ACTIONS(3900),
    [anon_sym_DOT_LBRACK] = ACTIONS(3898),
    [anon_sym_LT] = ACTIONS(3898),
    [anon_sym_use] = ACTIONS(3900),
    [anon_sym_use_BANG] = ACTIONS(3898),
    [anon_sym_do_BANG] = ACTIONS(3898),
    [anon_sym_begin] = ACTIONS(3900),
    [anon_sym_LPAREN2] = ACTIONS(3900),
    [anon_sym_or] = ACTIONS(3900),
    [aux_sym_char_token1] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3900),
    [anon_sym_DQUOTE] = ACTIONS(3900),
    [anon_sym_AT_DQUOTE] = ACTIONS(3898),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3898),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3900),
    [sym_op_identifier] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(3900),
    [anon_sym_DASH] = ACTIONS(3900),
    [anon_sym_PLUS_DOT] = ACTIONS(3900),
    [anon_sym_DASH_DOT] = ACTIONS(3900),
    [anon_sym_PERCENT] = ACTIONS(3900),
    [anon_sym_AMP_AMP] = ACTIONS(3900),
    [anon_sym_TILDE] = ACTIONS(3898),
    [aux_sym_prefix_op_token1] = ACTIONS(3900),
    [aux_sym_infix_op_token1] = ACTIONS(3898),
    [aux_sym_infix_op_token2] = ACTIONS(3900),
    [anon_sym_PIPE_PIPE] = ACTIONS(3900),
    [anon_sym_BANG_EQ] = ACTIONS(3900),
    [anon_sym_COLON_EQ] = ACTIONS(3898),
    [anon_sym_DOLLAR] = ACTIONS(3900),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3900),
    [sym_int] = ACTIONS(3900),
    [sym_xint] = ACTIONS(3898),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3898),
    [sym__newline] = ACTIONS(3898),
  },
  [3513] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(6615),
    [sym_function_declaration_left] = STATE(9554),
    [sym_value_declaration_left] = STATE(9554),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3513),
    [sym_compiler_directive_decl] = STATE(3513),
    [sym_fsi_directive_decl] = STATE(3513),
    [sym_preproc_line] = STATE(3513),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_rec] = ACTIONS(6006),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3514] = {
    [sym_block_comment] = STATE(3514),
    [sym_compiler_directive_decl] = STATE(3514),
    [sym_fsi_directive_decl] = STATE(3514),
    [sym_preproc_line] = STATE(3514),
    [sym_identifier] = ACTIONS(4208),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_COLON] = ACTIONS(4208),
    [anon_sym_return] = ACTIONS(4208),
    [anon_sym_do] = ACTIONS(4208),
    [anon_sym_let] = ACTIONS(4208),
    [anon_sym_let_BANG] = ACTIONS(4206),
    [anon_sym_LPAREN] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(4206),
    [anon_sym_null] = ACTIONS(4208),
    [anon_sym_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_QMARK] = ACTIONS(4208),
    [anon_sym_COLON_COLON] = ACTIONS(4206),
    [anon_sym_AMP] = ACTIONS(4208),
    [anon_sym_LBRACK] = ACTIONS(4208),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4206),
    [anon_sym_LBRACE] = ACTIONS(4208),
    [anon_sym_LT_AT] = ACTIONS(4208),
    [anon_sym_LT_AT_AT] = ACTIONS(4208),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4206),
    [anon_sym_new] = ACTIONS(4208),
    [anon_sym_return_BANG] = ACTIONS(4206),
    [anon_sym_yield] = ACTIONS(4208),
    [anon_sym_yield_BANG] = ACTIONS(4206),
    [anon_sym_lazy] = ACTIONS(4208),
    [anon_sym_assert] = ACTIONS(4208),
    [anon_sym_upcast] = ACTIONS(4208),
    [anon_sym_downcast] = ACTIONS(4208),
    [anon_sym_COLON_GT] = ACTIONS(4206),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4206),
    [anon_sym_for] = ACTIONS(4208),
    [anon_sym_while] = ACTIONS(4208),
    [anon_sym_if] = ACTIONS(4208),
    [anon_sym_fun] = ACTIONS(4208),
    [anon_sym_try] = ACTIONS(4208),
    [anon_sym_match] = ACTIONS(4208),
    [anon_sym_match_BANG] = ACTIONS(4206),
    [anon_sym_function] = ACTIONS(4208),
    [anon_sym_LT_DASH] = ACTIONS(4208),
    [anon_sym_DOT_LBRACK] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(4206),
    [anon_sym_GT] = ACTIONS(4208),
    [anon_sym_use] = ACTIONS(4208),
    [anon_sym_use_BANG] = ACTIONS(4206),
    [anon_sym_do_BANG] = ACTIONS(4206),
    [anon_sym_begin] = ACTIONS(4208),
    [anon_sym_LPAREN2] = ACTIONS(4208),
    [anon_sym_or] = ACTIONS(4208),
    [aux_sym_char_token1] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4208),
    [anon_sym_DQUOTE] = ACTIONS(4208),
    [anon_sym_AT_DQUOTE] = ACTIONS(4206),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4206),
    [sym_bool] = ACTIONS(4208),
    [sym_unit] = ACTIONS(4206),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4208),
    [sym_op_identifier] = ACTIONS(4208),
    [anon_sym_PLUS] = ACTIONS(4208),
    [anon_sym_DASH] = ACTIONS(4208),
    [anon_sym_PLUS_DOT] = ACTIONS(4208),
    [anon_sym_DASH_DOT] = ACTIONS(4208),
    [anon_sym_PERCENT] = ACTIONS(4208),
    [anon_sym_AMP_AMP] = ACTIONS(4208),
    [anon_sym_TILDE] = ACTIONS(4206),
    [aux_sym_prefix_op_token1] = ACTIONS(4208),
    [aux_sym_infix_op_token1] = ACTIONS(4206),
    [aux_sym_infix_op_token2] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(4208),
    [anon_sym_BANG_EQ] = ACTIONS(4208),
    [anon_sym_COLON_EQ] = ACTIONS(4206),
    [anon_sym_DOLLAR] = ACTIONS(4208),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4208),
    [sym_int] = ACTIONS(4208),
    [sym_xint] = ACTIONS(4206),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4206),
    [sym__newline] = ACTIONS(4206),
  },
  [3515] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defns] = STATE(6719),
    [sym__function_or_value_defn_body] = STATE(6447),
    [sym_function_declaration_left] = STATE(9554),
    [sym_value_declaration_left] = STATE(9554),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3515),
    [sym_compiler_directive_decl] = STATE(3515),
    [sym_fsi_directive_decl] = STATE(3515),
    [sym_preproc_line] = STATE(3515),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3516] = {
    [sym_type_arguments] = STATE(3605),
    [sym_long_identifier] = STATE(3604),
    [sym_block_comment] = STATE(3516),
    [sym_compiler_directive_decl] = STATE(3516),
    [sym_fsi_directive_decl] = STATE(3516),
    [sym_preproc_line] = STATE(3516),
    [aux_sym_compound_type_repeat1] = STATE(3597),
    [ts_builtin_sym_end] = ACTIONS(6008),
    [sym_identifier] = ACTIONS(6010),
    [anon_sym_namespace] = ACTIONS(6010),
    [anon_sym_module] = ACTIONS(6010),
    [anon_sym_open] = ACTIONS(6010),
    [anon_sym_LBRACK_LT] = ACTIONS(6008),
    [anon_sym_return] = ACTIONS(6010),
    [anon_sym_type] = ACTIONS(6010),
    [anon_sym_do] = ACTIONS(6010),
    [anon_sym_and] = ACTIONS(6010),
    [anon_sym_let] = ACTIONS(6010),
    [anon_sym_let_BANG] = ACTIONS(6008),
    [aux_sym_access_modifier_token1] = ACTIONS(6008),
    [anon_sym_LPAREN] = ACTIONS(6010),
    [anon_sym_null] = ACTIONS(6010),
    [anon_sym_AMP] = ACTIONS(6010),
    [anon_sym_LBRACK] = ACTIONS(6010),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6008),
    [anon_sym_LBRACE] = ACTIONS(6010),
    [anon_sym_LT_AT] = ACTIONS(6010),
    [anon_sym_LT_AT_AT] = ACTIONS(6008),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6008),
    [anon_sym_new] = ACTIONS(6010),
    [anon_sym_return_BANG] = ACTIONS(6008),
    [anon_sym_yield] = ACTIONS(6010),
    [anon_sym_yield_BANG] = ACTIONS(6008),
    [anon_sym_lazy] = ACTIONS(6010),
    [anon_sym_assert] = ACTIONS(6010),
    [anon_sym_upcast] = ACTIONS(6010),
    [anon_sym_downcast] = ACTIONS(6010),
    [anon_sym_for] = ACTIONS(6010),
    [anon_sym_while] = ACTIONS(6010),
    [anon_sym_if] = ACTIONS(6010),
    [anon_sym_fun] = ACTIONS(6010),
    [anon_sym_DASH_GT] = ACTIONS(5385),
    [anon_sym_try] = ACTIONS(6010),
    [anon_sym_match] = ACTIONS(6010),
    [anon_sym_match_BANG] = ACTIONS(6008),
    [anon_sym_function] = ACTIONS(6010),
    [anon_sym_use] = ACTIONS(6010),
    [anon_sym_use_BANG] = ACTIONS(6008),
    [anon_sym_do_BANG] = ACTIONS(6008),
    [anon_sym_begin] = ACTIONS(6010),
    [anon_sym_STAR] = ACTIONS(5387),
    [anon_sym_LT2] = ACTIONS(5389),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5391),
    [anon_sym_default] = ACTIONS(6010),
    [anon_sym_static] = ACTIONS(6010),
    [anon_sym_member] = ACTIONS(6010),
    [anon_sym_interface] = ACTIONS(6010),
    [anon_sym_exception] = ACTIONS(6010),
    [anon_sym_abstract] = ACTIONS(6010),
    [anon_sym_val] = ACTIONS(6010),
    [anon_sym_override] = ACTIONS(6010),
    [aux_sym_char_token1] = ACTIONS(6008),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6010),
    [anon_sym_DQUOTE] = ACTIONS(6010),
    [anon_sym_AT_DQUOTE] = ACTIONS(6008),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6008),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6008),
    [sym_bool] = ACTIONS(6010),
    [sym_unit] = ACTIONS(6008),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6010),
    [sym_op_identifier] = ACTIONS(6008),
    [anon_sym_PLUS] = ACTIONS(6010),
    [anon_sym_DASH] = ACTIONS(6010),
    [anon_sym_PLUS_DOT] = ACTIONS(6008),
    [anon_sym_DASH_DOT] = ACTIONS(6008),
    [anon_sym_PERCENT] = ACTIONS(6008),
    [anon_sym_AMP_AMP] = ACTIONS(6008),
    [anon_sym_TILDE] = ACTIONS(6008),
    [aux_sym_prefix_op_token1] = ACTIONS(6008),
    [sym_int] = ACTIONS(6010),
    [sym_xint] = ACTIONS(6008),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6008),
    [anon_sym_POUNDload] = ACTIONS(6008),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6008),
  },
  [3517] = {
    [sym_block_comment] = STATE(3517),
    [sym_compiler_directive_decl] = STATE(3517),
    [sym_fsi_directive_decl] = STATE(3517),
    [sym_preproc_line] = STATE(3517),
    [sym_identifier] = ACTIONS(4130),
    [anon_sym_EQ] = ACTIONS(4128),
    [anon_sym_COLON] = ACTIONS(4130),
    [anon_sym_return] = ACTIONS(4130),
    [anon_sym_do] = ACTIONS(4130),
    [anon_sym_let] = ACTIONS(4130),
    [anon_sym_let_BANG] = ACTIONS(4128),
    [anon_sym_LPAREN] = ACTIONS(4130),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_null] = ACTIONS(4130),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_QMARK] = ACTIONS(4130),
    [anon_sym_COLON_COLON] = ACTIONS(4128),
    [anon_sym_AMP] = ACTIONS(4130),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4128),
    [anon_sym_LBRACE] = ACTIONS(4130),
    [anon_sym_LT_AT] = ACTIONS(4130),
    [anon_sym_AT_GT] = ACTIONS(4130),
    [anon_sym_LT_AT_AT] = ACTIONS(4130),
    [anon_sym_DOT] = ACTIONS(4130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4128),
    [anon_sym_new] = ACTIONS(4130),
    [anon_sym_return_BANG] = ACTIONS(4128),
    [anon_sym_yield] = ACTIONS(4130),
    [anon_sym_yield_BANG] = ACTIONS(4128),
    [anon_sym_lazy] = ACTIONS(4130),
    [anon_sym_assert] = ACTIONS(4130),
    [anon_sym_upcast] = ACTIONS(4130),
    [anon_sym_downcast] = ACTIONS(4130),
    [anon_sym_COLON_GT] = ACTIONS(4128),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4128),
    [anon_sym_for] = ACTIONS(4130),
    [anon_sym_while] = ACTIONS(4130),
    [anon_sym_if] = ACTIONS(4130),
    [anon_sym_fun] = ACTIONS(4130),
    [anon_sym_try] = ACTIONS(4130),
    [anon_sym_match] = ACTIONS(4130),
    [anon_sym_match_BANG] = ACTIONS(4128),
    [anon_sym_function] = ACTIONS(4130),
    [anon_sym_LT_DASH] = ACTIONS(4130),
    [anon_sym_DOT_LBRACK] = ACTIONS(4128),
    [anon_sym_LT] = ACTIONS(4128),
    [anon_sym_use] = ACTIONS(4130),
    [anon_sym_use_BANG] = ACTIONS(4128),
    [anon_sym_do_BANG] = ACTIONS(4128),
    [anon_sym_begin] = ACTIONS(4130),
    [anon_sym_LPAREN2] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [aux_sym_char_token1] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4130),
    [anon_sym_DQUOTE] = ACTIONS(4130),
    [anon_sym_AT_DQUOTE] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [sym_bool] = ACTIONS(4130),
    [sym_unit] = ACTIONS(4128),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4130),
    [sym_op_identifier] = ACTIONS(4130),
    [anon_sym_PLUS] = ACTIONS(4130),
    [anon_sym_DASH] = ACTIONS(4130),
    [anon_sym_PLUS_DOT] = ACTIONS(4130),
    [anon_sym_DASH_DOT] = ACTIONS(4130),
    [anon_sym_PERCENT] = ACTIONS(4130),
    [anon_sym_AMP_AMP] = ACTIONS(4130),
    [anon_sym_TILDE] = ACTIONS(4128),
    [aux_sym_prefix_op_token1] = ACTIONS(4130),
    [aux_sym_infix_op_token1] = ACTIONS(4128),
    [aux_sym_infix_op_token2] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE] = ACTIONS(4130),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_COLON_EQ] = ACTIONS(4128),
    [anon_sym_DOLLAR] = ACTIONS(4130),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4130),
    [sym_int] = ACTIONS(4130),
    [sym_xint] = ACTIONS(4128),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4128),
    [sym__newline] = ACTIONS(4128),
  },
  [3518] = {
    [sym_block_comment] = STATE(3518),
    [sym_compiler_directive_decl] = STATE(3518),
    [sym_fsi_directive_decl] = STATE(3518),
    [sym_preproc_line] = STATE(3518),
    [sym_identifier] = ACTIONS(3885),
    [anon_sym_EQ] = ACTIONS(3883),
    [anon_sym_COLON] = ACTIONS(3885),
    [anon_sym_return] = ACTIONS(3885),
    [anon_sym_do] = ACTIONS(3885),
    [anon_sym_let] = ACTIONS(3885),
    [anon_sym_let_BANG] = ACTIONS(3883),
    [anon_sym_LPAREN] = ACTIONS(3885),
    [anon_sym_COMMA] = ACTIONS(3883),
    [anon_sym_null] = ACTIONS(3885),
    [anon_sym_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_QMARK] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3883),
    [anon_sym_AMP] = ACTIONS(3885),
    [anon_sym_LBRACK] = ACTIONS(3885),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3883),
    [anon_sym_LBRACE] = ACTIONS(3885),
    [anon_sym_LT_AT] = ACTIONS(3885),
    [anon_sym_AT_GT] = ACTIONS(3885),
    [anon_sym_LT_AT_AT] = ACTIONS(3885),
    [anon_sym_DOT] = ACTIONS(3885),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3883),
    [anon_sym_new] = ACTIONS(3885),
    [anon_sym_return_BANG] = ACTIONS(3883),
    [anon_sym_yield] = ACTIONS(3885),
    [anon_sym_yield_BANG] = ACTIONS(3883),
    [anon_sym_lazy] = ACTIONS(3885),
    [anon_sym_assert] = ACTIONS(3885),
    [anon_sym_upcast] = ACTIONS(3885),
    [anon_sym_downcast] = ACTIONS(3885),
    [anon_sym_COLON_GT] = ACTIONS(3883),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3883),
    [anon_sym_for] = ACTIONS(3885),
    [anon_sym_while] = ACTIONS(3885),
    [anon_sym_if] = ACTIONS(3885),
    [anon_sym_fun] = ACTIONS(3885),
    [anon_sym_try] = ACTIONS(3885),
    [anon_sym_match] = ACTIONS(3885),
    [anon_sym_match_BANG] = ACTIONS(3883),
    [anon_sym_function] = ACTIONS(3885),
    [anon_sym_LT_DASH] = ACTIONS(3885),
    [anon_sym_DOT_LBRACK] = ACTIONS(3883),
    [anon_sym_LT] = ACTIONS(3883),
    [anon_sym_use] = ACTIONS(3885),
    [anon_sym_use_BANG] = ACTIONS(3883),
    [anon_sym_do_BANG] = ACTIONS(3883),
    [anon_sym_begin] = ACTIONS(3885),
    [anon_sym_LPAREN2] = ACTIONS(3885),
    [anon_sym_or] = ACTIONS(3885),
    [aux_sym_char_token1] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3885),
    [anon_sym_DQUOTE] = ACTIONS(3885),
    [anon_sym_AT_DQUOTE] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [sym_bool] = ACTIONS(3885),
    [sym_unit] = ACTIONS(3883),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3885),
    [sym_op_identifier] = ACTIONS(3885),
    [anon_sym_PLUS] = ACTIONS(3885),
    [anon_sym_DASH] = ACTIONS(3885),
    [anon_sym_PLUS_DOT] = ACTIONS(3885),
    [anon_sym_DASH_DOT] = ACTIONS(3885),
    [anon_sym_PERCENT] = ACTIONS(3885),
    [anon_sym_AMP_AMP] = ACTIONS(3885),
    [anon_sym_TILDE] = ACTIONS(3883),
    [aux_sym_prefix_op_token1] = ACTIONS(3885),
    [aux_sym_infix_op_token1] = ACTIONS(3883),
    [aux_sym_infix_op_token2] = ACTIONS(3885),
    [anon_sym_PIPE_PIPE] = ACTIONS(3885),
    [anon_sym_BANG_EQ] = ACTIONS(3885),
    [anon_sym_COLON_EQ] = ACTIONS(3883),
    [anon_sym_DOLLAR] = ACTIONS(3885),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3885),
    [sym_int] = ACTIONS(3885),
    [sym_xint] = ACTIONS(3883),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3883),
    [sym__newline] = ACTIONS(3883),
  },
  [3519] = {
    [sym_block_comment] = STATE(3519),
    [sym_compiler_directive_decl] = STATE(3519),
    [sym_fsi_directive_decl] = STATE(3519),
    [sym_preproc_line] = STATE(3519),
    [sym_identifier] = ACTIONS(3935),
    [anon_sym_EQ] = ACTIONS(3933),
    [anon_sym_COLON] = ACTIONS(3935),
    [anon_sym_return] = ACTIONS(3935),
    [anon_sym_do] = ACTIONS(3935),
    [anon_sym_let] = ACTIONS(3935),
    [anon_sym_let_BANG] = ACTIONS(3933),
    [anon_sym_LPAREN] = ACTIONS(3935),
    [anon_sym_COMMA] = ACTIONS(3933),
    [anon_sym_null] = ACTIONS(3935),
    [anon_sym_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_QMARK] = ACTIONS(3935),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3935),
    [anon_sym_LBRACK] = ACTIONS(3935),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3933),
    [anon_sym_LBRACE] = ACTIONS(3935),
    [anon_sym_LT_AT] = ACTIONS(3935),
    [anon_sym_AT_GT] = ACTIONS(3935),
    [anon_sym_LT_AT_AT] = ACTIONS(3935),
    [anon_sym_DOT] = ACTIONS(3935),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3933),
    [anon_sym_new] = ACTIONS(3935),
    [anon_sym_return_BANG] = ACTIONS(3933),
    [anon_sym_yield] = ACTIONS(3935),
    [anon_sym_yield_BANG] = ACTIONS(3933),
    [anon_sym_lazy] = ACTIONS(3935),
    [anon_sym_assert] = ACTIONS(3935),
    [anon_sym_upcast] = ACTIONS(3935),
    [anon_sym_downcast] = ACTIONS(3935),
    [anon_sym_COLON_GT] = ACTIONS(3933),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3933),
    [anon_sym_for] = ACTIONS(3935),
    [anon_sym_while] = ACTIONS(3935),
    [anon_sym_if] = ACTIONS(3935),
    [anon_sym_fun] = ACTIONS(3935),
    [anon_sym_try] = ACTIONS(3935),
    [anon_sym_match] = ACTIONS(3935),
    [anon_sym_match_BANG] = ACTIONS(3933),
    [anon_sym_function] = ACTIONS(3935),
    [anon_sym_LT_DASH] = ACTIONS(3935),
    [anon_sym_DOT_LBRACK] = ACTIONS(3933),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_use] = ACTIONS(3935),
    [anon_sym_use_BANG] = ACTIONS(3933),
    [anon_sym_do_BANG] = ACTIONS(3933),
    [anon_sym_begin] = ACTIONS(3935),
    [anon_sym_LPAREN2] = ACTIONS(3935),
    [anon_sym_or] = ACTIONS(3935),
    [aux_sym_char_token1] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3935),
    [anon_sym_DQUOTE] = ACTIONS(3935),
    [anon_sym_AT_DQUOTE] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [sym_bool] = ACTIONS(3935),
    [sym_unit] = ACTIONS(3933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3935),
    [sym_op_identifier] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(3935),
    [anon_sym_DASH] = ACTIONS(3935),
    [anon_sym_PLUS_DOT] = ACTIONS(3935),
    [anon_sym_DASH_DOT] = ACTIONS(3935),
    [anon_sym_PERCENT] = ACTIONS(3935),
    [anon_sym_AMP_AMP] = ACTIONS(3935),
    [anon_sym_TILDE] = ACTIONS(3933),
    [aux_sym_prefix_op_token1] = ACTIONS(3935),
    [aux_sym_infix_op_token1] = ACTIONS(3933),
    [aux_sym_infix_op_token2] = ACTIONS(3935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3935),
    [anon_sym_BANG_EQ] = ACTIONS(3935),
    [anon_sym_COLON_EQ] = ACTIONS(3933),
    [anon_sym_DOLLAR] = ACTIONS(3935),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3935),
    [sym_int] = ACTIONS(3935),
    [sym_xint] = ACTIONS(3933),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3933),
    [sym__newline] = ACTIONS(3933),
  },
  [3520] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(3778),
    [sym_function_declaration_left] = STATE(10099),
    [sym_value_declaration_left] = STATE(10099),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3520),
    [sym_compiler_directive_decl] = STATE(3520),
    [sym_fsi_directive_decl] = STATE(3520),
    [sym_preproc_line] = STATE(3520),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_rec] = ACTIONS(6012),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3521] = {
    [sym_block_comment] = STATE(3521),
    [sym_compiler_directive_decl] = STATE(3521),
    [sym_fsi_directive_decl] = STATE(3521),
    [sym_preproc_line] = STATE(3521),
    [sym_identifier] = ACTIONS(3976),
    [anon_sym_EQ] = ACTIONS(3974),
    [anon_sym_COLON] = ACTIONS(3976),
    [anon_sym_return] = ACTIONS(3976),
    [anon_sym_do] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_let_BANG] = ACTIONS(3974),
    [anon_sym_LPAREN] = ACTIONS(3976),
    [anon_sym_COMMA] = ACTIONS(3974),
    [anon_sym_null] = ACTIONS(3976),
    [anon_sym_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_QMARK] = ACTIONS(3976),
    [anon_sym_COLON_COLON] = ACTIONS(3974),
    [anon_sym_AMP] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(3976),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3974),
    [anon_sym_LBRACE] = ACTIONS(3976),
    [anon_sym_LT_AT] = ACTIONS(3976),
    [anon_sym_AT_GT] = ACTIONS(3976),
    [anon_sym_LT_AT_AT] = ACTIONS(3976),
    [anon_sym_DOT] = ACTIONS(3976),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3974),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_return_BANG] = ACTIONS(3974),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_yield_BANG] = ACTIONS(3974),
    [anon_sym_lazy] = ACTIONS(3976),
    [anon_sym_assert] = ACTIONS(3976),
    [anon_sym_upcast] = ACTIONS(3976),
    [anon_sym_downcast] = ACTIONS(3976),
    [anon_sym_COLON_GT] = ACTIONS(3974),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3974),
    [anon_sym_for] = ACTIONS(3976),
    [anon_sym_while] = ACTIONS(3976),
    [anon_sym_if] = ACTIONS(3976),
    [anon_sym_fun] = ACTIONS(3976),
    [anon_sym_try] = ACTIONS(3976),
    [anon_sym_match] = ACTIONS(3976),
    [anon_sym_match_BANG] = ACTIONS(3974),
    [anon_sym_function] = ACTIONS(3976),
    [anon_sym_LT_DASH] = ACTIONS(3976),
    [anon_sym_DOT_LBRACK] = ACTIONS(3974),
    [anon_sym_LT] = ACTIONS(3974),
    [anon_sym_use] = ACTIONS(3976),
    [anon_sym_use_BANG] = ACTIONS(3974),
    [anon_sym_do_BANG] = ACTIONS(3974),
    [anon_sym_begin] = ACTIONS(3976),
    [anon_sym_LPAREN2] = ACTIONS(3976),
    [anon_sym_or] = ACTIONS(3976),
    [aux_sym_char_token1] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3976),
    [anon_sym_DQUOTE] = ACTIONS(3976),
    [anon_sym_AT_DQUOTE] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [sym_bool] = ACTIONS(3976),
    [sym_unit] = ACTIONS(3974),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3976),
    [sym_op_identifier] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3976),
    [anon_sym_DASH] = ACTIONS(3976),
    [anon_sym_PLUS_DOT] = ACTIONS(3976),
    [anon_sym_DASH_DOT] = ACTIONS(3976),
    [anon_sym_PERCENT] = ACTIONS(3976),
    [anon_sym_AMP_AMP] = ACTIONS(3976),
    [anon_sym_TILDE] = ACTIONS(3974),
    [aux_sym_prefix_op_token1] = ACTIONS(3976),
    [aux_sym_infix_op_token1] = ACTIONS(3974),
    [aux_sym_infix_op_token2] = ACTIONS(3976),
    [anon_sym_PIPE_PIPE] = ACTIONS(3976),
    [anon_sym_BANG_EQ] = ACTIONS(3976),
    [anon_sym_COLON_EQ] = ACTIONS(3974),
    [anon_sym_DOLLAR] = ACTIONS(3976),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3976),
    [sym_int] = ACTIONS(3976),
    [sym_xint] = ACTIONS(3974),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3974),
    [sym__newline] = ACTIONS(3974),
  },
  [3522] = {
    [sym_block_comment] = STATE(3522),
    [sym_compiler_directive_decl] = STATE(3522),
    [sym_fsi_directive_decl] = STATE(3522),
    [sym_preproc_line] = STATE(3522),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_EQ] = ACTIONS(3948),
    [anon_sym_COLON] = ACTIONS(3950),
    [anon_sym_return] = ACTIONS(3950),
    [anon_sym_do] = ACTIONS(3950),
    [anon_sym_let] = ACTIONS(3950),
    [anon_sym_let_BANG] = ACTIONS(3948),
    [anon_sym_LPAREN] = ACTIONS(3950),
    [anon_sym_COMMA] = ACTIONS(3948),
    [anon_sym_null] = ACTIONS(3950),
    [anon_sym_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_QMARK] = ACTIONS(3950),
    [anon_sym_COLON_COLON] = ACTIONS(3948),
    [anon_sym_AMP] = ACTIONS(3950),
    [anon_sym_LBRACK] = ACTIONS(3950),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3948),
    [anon_sym_LBRACE] = ACTIONS(3950),
    [anon_sym_LT_AT] = ACTIONS(3950),
    [anon_sym_AT_GT] = ACTIONS(3950),
    [anon_sym_LT_AT_AT] = ACTIONS(3950),
    [anon_sym_DOT] = ACTIONS(3950),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3948),
    [anon_sym_new] = ACTIONS(3950),
    [anon_sym_return_BANG] = ACTIONS(3948),
    [anon_sym_yield] = ACTIONS(3950),
    [anon_sym_yield_BANG] = ACTIONS(3948),
    [anon_sym_lazy] = ACTIONS(3950),
    [anon_sym_assert] = ACTIONS(3950),
    [anon_sym_upcast] = ACTIONS(3950),
    [anon_sym_downcast] = ACTIONS(3950),
    [anon_sym_COLON_GT] = ACTIONS(3948),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3948),
    [anon_sym_for] = ACTIONS(3950),
    [anon_sym_while] = ACTIONS(3950),
    [anon_sym_if] = ACTIONS(3950),
    [anon_sym_fun] = ACTIONS(3950),
    [anon_sym_try] = ACTIONS(3950),
    [anon_sym_match] = ACTIONS(3950),
    [anon_sym_match_BANG] = ACTIONS(3948),
    [anon_sym_function] = ACTIONS(3950),
    [anon_sym_LT_DASH] = ACTIONS(3950),
    [anon_sym_DOT_LBRACK] = ACTIONS(3948),
    [anon_sym_LT] = ACTIONS(3948),
    [anon_sym_use] = ACTIONS(3950),
    [anon_sym_use_BANG] = ACTIONS(3948),
    [anon_sym_do_BANG] = ACTIONS(3948),
    [anon_sym_begin] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3950),
    [anon_sym_or] = ACTIONS(3950),
    [aux_sym_char_token1] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3950),
    [anon_sym_DQUOTE] = ACTIONS(3950),
    [anon_sym_AT_DQUOTE] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [sym_bool] = ACTIONS(3950),
    [sym_unit] = ACTIONS(3948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3950),
    [sym_op_identifier] = ACTIONS(3950),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_DASH] = ACTIONS(3950),
    [anon_sym_PLUS_DOT] = ACTIONS(3950),
    [anon_sym_DASH_DOT] = ACTIONS(3950),
    [anon_sym_PERCENT] = ACTIONS(3950),
    [anon_sym_AMP_AMP] = ACTIONS(3950),
    [anon_sym_TILDE] = ACTIONS(3948),
    [aux_sym_prefix_op_token1] = ACTIONS(3950),
    [aux_sym_infix_op_token1] = ACTIONS(3948),
    [aux_sym_infix_op_token2] = ACTIONS(3950),
    [anon_sym_PIPE_PIPE] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3950),
    [anon_sym_COLON_EQ] = ACTIONS(3948),
    [anon_sym_DOLLAR] = ACTIONS(3950),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3950),
    [sym_int] = ACTIONS(3950),
    [sym_xint] = ACTIONS(3948),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3948),
    [sym__newline] = ACTIONS(3948),
  },
  [3523] = {
    [sym_block_comment] = STATE(3523),
    [sym_compiler_directive_decl] = STATE(3523),
    [sym_fsi_directive_decl] = STATE(3523),
    [sym_preproc_line] = STATE(3523),
    [sym_identifier] = ACTIONS(3954),
    [anon_sym_EQ] = ACTIONS(3952),
    [anon_sym_COLON] = ACTIONS(3954),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_do] = ACTIONS(3954),
    [anon_sym_let] = ACTIONS(3954),
    [anon_sym_let_BANG] = ACTIONS(3952),
    [anon_sym_LPAREN] = ACTIONS(3954),
    [anon_sym_COMMA] = ACTIONS(3952),
    [anon_sym_null] = ACTIONS(3954),
    [anon_sym_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_QMARK] = ACTIONS(3954),
    [anon_sym_COLON_COLON] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3954),
    [anon_sym_LBRACK] = ACTIONS(3954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(3954),
    [anon_sym_LT_AT] = ACTIONS(3954),
    [anon_sym_AT_GT] = ACTIONS(3954),
    [anon_sym_LT_AT_AT] = ACTIONS(3954),
    [anon_sym_DOT] = ACTIONS(3954),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3952),
    [anon_sym_new] = ACTIONS(3954),
    [anon_sym_return_BANG] = ACTIONS(3952),
    [anon_sym_yield] = ACTIONS(3954),
    [anon_sym_yield_BANG] = ACTIONS(3952),
    [anon_sym_lazy] = ACTIONS(3954),
    [anon_sym_assert] = ACTIONS(3954),
    [anon_sym_upcast] = ACTIONS(3954),
    [anon_sym_downcast] = ACTIONS(3954),
    [anon_sym_COLON_GT] = ACTIONS(3952),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3952),
    [anon_sym_for] = ACTIONS(3954),
    [anon_sym_while] = ACTIONS(3954),
    [anon_sym_if] = ACTIONS(3954),
    [anon_sym_fun] = ACTIONS(3954),
    [anon_sym_try] = ACTIONS(3954),
    [anon_sym_match] = ACTIONS(3954),
    [anon_sym_match_BANG] = ACTIONS(3952),
    [anon_sym_function] = ACTIONS(3954),
    [anon_sym_LT_DASH] = ACTIONS(3954),
    [anon_sym_DOT_LBRACK] = ACTIONS(3952),
    [anon_sym_LT] = ACTIONS(3952),
    [anon_sym_use] = ACTIONS(3954),
    [anon_sym_use_BANG] = ACTIONS(3952),
    [anon_sym_do_BANG] = ACTIONS(3952),
    [anon_sym_begin] = ACTIONS(3954),
    [anon_sym_LPAREN2] = ACTIONS(3954),
    [anon_sym_or] = ACTIONS(3954),
    [aux_sym_char_token1] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3954),
    [anon_sym_DQUOTE] = ACTIONS(3954),
    [anon_sym_AT_DQUOTE] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [sym_bool] = ACTIONS(3954),
    [sym_unit] = ACTIONS(3952),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3954),
    [sym_op_identifier] = ACTIONS(3954),
    [anon_sym_PLUS] = ACTIONS(3954),
    [anon_sym_DASH] = ACTIONS(3954),
    [anon_sym_PLUS_DOT] = ACTIONS(3954),
    [anon_sym_DASH_DOT] = ACTIONS(3954),
    [anon_sym_PERCENT] = ACTIONS(3954),
    [anon_sym_AMP_AMP] = ACTIONS(3954),
    [anon_sym_TILDE] = ACTIONS(3952),
    [aux_sym_prefix_op_token1] = ACTIONS(3954),
    [aux_sym_infix_op_token1] = ACTIONS(3952),
    [aux_sym_infix_op_token2] = ACTIONS(3954),
    [anon_sym_PIPE_PIPE] = ACTIONS(3954),
    [anon_sym_BANG_EQ] = ACTIONS(3954),
    [anon_sym_COLON_EQ] = ACTIONS(3952),
    [anon_sym_DOLLAR] = ACTIONS(3954),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3954),
    [sym_int] = ACTIONS(3954),
    [sym_xint] = ACTIONS(3952),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3952),
    [sym__newline] = ACTIONS(3952),
  },
  [3524] = {
    [sym_block_comment] = STATE(3524),
    [sym_compiler_directive_decl] = STATE(3524),
    [sym_fsi_directive_decl] = STATE(3524),
    [sym_preproc_line] = STATE(3524),
    [sym_identifier] = ACTIONS(4186),
    [anon_sym_EQ] = ACTIONS(4184),
    [anon_sym_COLON] = ACTIONS(4186),
    [anon_sym_return] = ACTIONS(4186),
    [anon_sym_do] = ACTIONS(4186),
    [anon_sym_let] = ACTIONS(4186),
    [anon_sym_let_BANG] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_COMMA] = ACTIONS(4184),
    [anon_sym_null] = ACTIONS(4186),
    [anon_sym_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_COLON] = ACTIONS(4184),
    [anon_sym_AMP] = ACTIONS(4186),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4184),
    [anon_sym_LBRACE] = ACTIONS(4186),
    [anon_sym_LT_AT] = ACTIONS(4186),
    [anon_sym_AT_GT] = ACTIONS(4186),
    [anon_sym_LT_AT_AT] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4186),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4184),
    [anon_sym_new] = ACTIONS(4186),
    [anon_sym_return_BANG] = ACTIONS(4184),
    [anon_sym_yield] = ACTIONS(4186),
    [anon_sym_yield_BANG] = ACTIONS(4184),
    [anon_sym_lazy] = ACTIONS(4186),
    [anon_sym_assert] = ACTIONS(4186),
    [anon_sym_upcast] = ACTIONS(4186),
    [anon_sym_downcast] = ACTIONS(4186),
    [anon_sym_COLON_GT] = ACTIONS(4184),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4184),
    [anon_sym_for] = ACTIONS(4186),
    [anon_sym_while] = ACTIONS(4186),
    [anon_sym_if] = ACTIONS(4186),
    [anon_sym_fun] = ACTIONS(4186),
    [anon_sym_try] = ACTIONS(4186),
    [anon_sym_match] = ACTIONS(4186),
    [anon_sym_match_BANG] = ACTIONS(4184),
    [anon_sym_function] = ACTIONS(4186),
    [anon_sym_LT_DASH] = ACTIONS(4186),
    [anon_sym_DOT_LBRACK] = ACTIONS(4184),
    [anon_sym_LT] = ACTIONS(4184),
    [anon_sym_use] = ACTIONS(4186),
    [anon_sym_use_BANG] = ACTIONS(4184),
    [anon_sym_do_BANG] = ACTIONS(4184),
    [anon_sym_begin] = ACTIONS(4186),
    [anon_sym_LPAREN2] = ACTIONS(4186),
    [anon_sym_or] = ACTIONS(4186),
    [aux_sym_char_token1] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4186),
    [anon_sym_DQUOTE] = ACTIONS(4186),
    [anon_sym_AT_DQUOTE] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [sym_bool] = ACTIONS(4186),
    [sym_unit] = ACTIONS(4184),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4186),
    [sym_op_identifier] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4186),
    [anon_sym_DASH] = ACTIONS(4186),
    [anon_sym_PLUS_DOT] = ACTIONS(4186),
    [anon_sym_DASH_DOT] = ACTIONS(4186),
    [anon_sym_PERCENT] = ACTIONS(4186),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_TILDE] = ACTIONS(4184),
    [aux_sym_prefix_op_token1] = ACTIONS(4186),
    [aux_sym_infix_op_token1] = ACTIONS(4184),
    [aux_sym_infix_op_token2] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_COLON_EQ] = ACTIONS(4184),
    [anon_sym_DOLLAR] = ACTIONS(4186),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4186),
    [sym_int] = ACTIONS(4186),
    [sym_xint] = ACTIONS(4184),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4184),
    [sym__newline] = ACTIONS(4184),
  },
  [3525] = {
    [sym_block_comment] = STATE(3525),
    [sym_compiler_directive_decl] = STATE(3525),
    [sym_fsi_directive_decl] = STATE(3525),
    [sym_preproc_line] = STATE(3525),
    [sym_identifier] = ACTIONS(4022),
    [anon_sym_EQ] = ACTIONS(4020),
    [anon_sym_COLON] = ACTIONS(4022),
    [anon_sym_return] = ACTIONS(4022),
    [anon_sym_do] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_let_BANG] = ACTIONS(4020),
    [anon_sym_LPAREN] = ACTIONS(4022),
    [anon_sym_COMMA] = ACTIONS(4020),
    [anon_sym_null] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_COLON] = ACTIONS(4020),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4022),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(4022),
    [anon_sym_LT_AT] = ACTIONS(4022),
    [anon_sym_LT_AT_AT] = ACTIONS(4022),
    [anon_sym_AT_AT_GT] = ACTIONS(4022),
    [anon_sym_DOT] = ACTIONS(4022),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4020),
    [anon_sym_new] = ACTIONS(4022),
    [anon_sym_return_BANG] = ACTIONS(4020),
    [anon_sym_yield] = ACTIONS(4022),
    [anon_sym_yield_BANG] = ACTIONS(4020),
    [anon_sym_lazy] = ACTIONS(4022),
    [anon_sym_assert] = ACTIONS(4022),
    [anon_sym_upcast] = ACTIONS(4022),
    [anon_sym_downcast] = ACTIONS(4022),
    [anon_sym_COLON_GT] = ACTIONS(4020),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4020),
    [anon_sym_for] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4022),
    [anon_sym_if] = ACTIONS(4022),
    [anon_sym_fun] = ACTIONS(4022),
    [anon_sym_try] = ACTIONS(4022),
    [anon_sym_match] = ACTIONS(4022),
    [anon_sym_match_BANG] = ACTIONS(4020),
    [anon_sym_function] = ACTIONS(4022),
    [anon_sym_LT_DASH] = ACTIONS(4022),
    [anon_sym_DOT_LBRACK] = ACTIONS(4020),
    [anon_sym_LT] = ACTIONS(4020),
    [anon_sym_use] = ACTIONS(4022),
    [anon_sym_use_BANG] = ACTIONS(4020),
    [anon_sym_do_BANG] = ACTIONS(4020),
    [anon_sym_begin] = ACTIONS(4022),
    [anon_sym_LPAREN2] = ACTIONS(4022),
    [anon_sym_or] = ACTIONS(4022),
    [aux_sym_char_token1] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4022),
    [anon_sym_DQUOTE] = ACTIONS(4022),
    [anon_sym_AT_DQUOTE] = ACTIONS(4020),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4020),
    [sym_bool] = ACTIONS(4022),
    [sym_unit] = ACTIONS(4020),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4022),
    [sym_op_identifier] = ACTIONS(4022),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_PLUS_DOT] = ACTIONS(4022),
    [anon_sym_DASH_DOT] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4022),
    [anon_sym_TILDE] = ACTIONS(4020),
    [aux_sym_prefix_op_token1] = ACTIONS(4022),
    [aux_sym_infix_op_token1] = ACTIONS(4020),
    [aux_sym_infix_op_token2] = ACTIONS(4022),
    [anon_sym_PIPE_PIPE] = ACTIONS(4022),
    [anon_sym_BANG_EQ] = ACTIONS(4022),
    [anon_sym_COLON_EQ] = ACTIONS(4020),
    [anon_sym_DOLLAR] = ACTIONS(4022),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4022),
    [sym_int] = ACTIONS(4022),
    [sym_xint] = ACTIONS(4020),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4020),
    [sym__newline] = ACTIONS(4020),
  },
  [3526] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defns] = STATE(7561),
    [sym__function_or_value_defn_body] = STATE(7291),
    [sym_function_declaration_left] = STATE(9771),
    [sym_value_declaration_left] = STATE(9771),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3526),
    [sym_compiler_directive_decl] = STATE(3526),
    [sym_fsi_directive_decl] = STATE(3526),
    [sym_preproc_line] = STATE(3526),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3527] = {
    [sym_block_comment] = STATE(3527),
    [sym_compiler_directive_decl] = STATE(3527),
    [sym_fsi_directive_decl] = STATE(3527),
    [sym_preproc_line] = STATE(3527),
    [sym_identifier] = ACTIONS(4011),
    [anon_sym_EQ] = ACTIONS(4009),
    [anon_sym_COLON] = ACTIONS(4011),
    [anon_sym_return] = ACTIONS(4011),
    [anon_sym_do] = ACTIONS(4011),
    [anon_sym_let] = ACTIONS(4011),
    [anon_sym_let_BANG] = ACTIONS(4009),
    [anon_sym_LPAREN] = ACTIONS(4011),
    [anon_sym_COMMA] = ACTIONS(4009),
    [anon_sym_null] = ACTIONS(4011),
    [anon_sym_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_QMARK] = ACTIONS(4011),
    [anon_sym_COLON_COLON] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(4011),
    [anon_sym_LBRACK] = ACTIONS(4011),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4009),
    [anon_sym_LBRACE] = ACTIONS(4011),
    [anon_sym_LT_AT] = ACTIONS(4011),
    [anon_sym_LT_AT_AT] = ACTIONS(4011),
    [anon_sym_AT_AT_GT] = ACTIONS(4011),
    [anon_sym_DOT] = ACTIONS(4011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4009),
    [anon_sym_new] = ACTIONS(4011),
    [anon_sym_return_BANG] = ACTIONS(4009),
    [anon_sym_yield] = ACTIONS(4011),
    [anon_sym_yield_BANG] = ACTIONS(4009),
    [anon_sym_lazy] = ACTIONS(4011),
    [anon_sym_assert] = ACTIONS(4011),
    [anon_sym_upcast] = ACTIONS(4011),
    [anon_sym_downcast] = ACTIONS(4011),
    [anon_sym_COLON_GT] = ACTIONS(4009),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4009),
    [anon_sym_for] = ACTIONS(4011),
    [anon_sym_while] = ACTIONS(4011),
    [anon_sym_if] = ACTIONS(4011),
    [anon_sym_fun] = ACTIONS(4011),
    [anon_sym_try] = ACTIONS(4011),
    [anon_sym_match] = ACTIONS(4011),
    [anon_sym_match_BANG] = ACTIONS(4009),
    [anon_sym_function] = ACTIONS(4011),
    [anon_sym_LT_DASH] = ACTIONS(4011),
    [anon_sym_DOT_LBRACK] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(4009),
    [anon_sym_use] = ACTIONS(4011),
    [anon_sym_use_BANG] = ACTIONS(4009),
    [anon_sym_do_BANG] = ACTIONS(4009),
    [anon_sym_begin] = ACTIONS(4011),
    [anon_sym_LPAREN2] = ACTIONS(4011),
    [anon_sym_or] = ACTIONS(4011),
    [aux_sym_char_token1] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4011),
    [anon_sym_DQUOTE] = ACTIONS(4011),
    [anon_sym_AT_DQUOTE] = ACTIONS(4009),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4009),
    [sym_bool] = ACTIONS(4011),
    [sym_unit] = ACTIONS(4009),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4011),
    [sym_op_identifier] = ACTIONS(4011),
    [anon_sym_PLUS] = ACTIONS(4011),
    [anon_sym_DASH] = ACTIONS(4011),
    [anon_sym_PLUS_DOT] = ACTIONS(4011),
    [anon_sym_DASH_DOT] = ACTIONS(4011),
    [anon_sym_PERCENT] = ACTIONS(4011),
    [anon_sym_AMP_AMP] = ACTIONS(4011),
    [anon_sym_TILDE] = ACTIONS(4009),
    [aux_sym_prefix_op_token1] = ACTIONS(4011),
    [aux_sym_infix_op_token1] = ACTIONS(4009),
    [aux_sym_infix_op_token2] = ACTIONS(4011),
    [anon_sym_PIPE_PIPE] = ACTIONS(4011),
    [anon_sym_BANG_EQ] = ACTIONS(4011),
    [anon_sym_COLON_EQ] = ACTIONS(4009),
    [anon_sym_DOLLAR] = ACTIONS(4011),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4011),
    [sym_int] = ACTIONS(4011),
    [sym_xint] = ACTIONS(4009),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4009),
    [sym__newline] = ACTIONS(4009),
  },
  [3528] = {
    [sym_attributes] = STATE(3968),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(5183),
    [sym__pattern] = STATE(2997),
    [sym_optional_pattern] = STATE(5183),
    [sym_type_check_pattern] = STATE(5183),
    [sym_attribute_pattern] = STATE(5183),
    [sym_paren_pattern] = STATE(5183),
    [sym_as_pattern] = STATE(5183),
    [sym_cons_pattern] = STATE(5183),
    [sym_disjunct_pattern] = STATE(5183),
    [sym_conjunct_pattern] = STATE(5183),
    [sym_typed_pattern] = STATE(5183),
    [sym_list_pattern] = STATE(5183),
    [sym_array_pattern] = STATE(5183),
    [sym_record_pattern] = STATE(5183),
    [sym_named_field_pattern] = STATE(5183),
    [sym_identifier_pattern] = STATE(5183),
    [sym_long_identifier_or_op] = STATE(3528),
    [sym_char] = STATE(5133),
    [sym_format_string] = STATE(5135),
    [sym__string_literal] = STATE(5135),
    [sym_string] = STATE(5133),
    [sym_verbatim_string] = STATE(5133),
    [sym_bytearray] = STATE(5133),
    [sym_verbatim_bytearray] = STATE(5133),
    [sym_format_triple_quoted_string] = STATE(5136),
    [sym_triple_quoted_string] = STATE(5133),
    [sym_const] = STATE(5183),
    [sym_long_identifier] = STATE(4953),
    [sym_active_pattern] = STATE(5117),
    [sym__identifier_or_op] = STATE(5167),
    [sym_sbyte] = STATE(5133),
    [sym_byte] = STATE(5133),
    [sym_int16] = STATE(5133),
    [sym_uint16] = STATE(5133),
    [sym_int32] = STATE(5133),
    [sym_uint32] = STATE(5133),
    [sym_nativeint] = STATE(5133),
    [sym_unativeint] = STATE(5133),
    [sym_int64] = STATE(5133),
    [sym_uint64] = STATE(5133),
    [sym_ieee32] = STATE(5133),
    [sym_ieee64] = STATE(5133),
    [sym_bignum] = STATE(5133),
    [sym_decimal] = STATE(5133),
    [sym_float] = STATE(4916),
    [sym_block_comment] = STATE(3528),
    [sym_compiler_directive_decl] = STATE(3528),
    [sym_fsi_directive_decl] = STATE(3528),
    [sym_preproc_line] = STATE(3528),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5558),
    [anon_sym_LBRACK_LT] = ACTIONS(5562),
    [anon_sym_COLON] = ACTIONS(5558),
    [anon_sym_as] = ACTIONS(5558),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_COMMA] = ACTIONS(5562),
    [anon_sym_null] = ACTIONS(5558),
    [anon_sym__] = ACTIONS(5558),
    [anon_sym_QMARK] = ACTIONS(5562),
    [anon_sym_COLON_QMARK] = ACTIONS(5562),
    [anon_sym_COLON_COLON] = ACTIONS(5562),
    [anon_sym_PIPE] = ACTIONS(5562),
    [anon_sym_AMP] = ACTIONS(5562),
    [anon_sym_LBRACK] = ACTIONS(5558),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5562),
    [anon_sym_LBRACE] = ACTIONS(5562),
    [aux_sym_char_token1] = ACTIONS(5562),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5558),
    [anon_sym_DQUOTE] = ACTIONS(5558),
    [anon_sym_AT_DQUOTE] = ACTIONS(5562),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5562),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5562),
    [sym_bool] = ACTIONS(5558),
    [sym_unit] = ACTIONS(5562),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5558),
    [sym_op_identifier] = ACTIONS(5562),
    [sym_int] = ACTIONS(5558),
    [sym_xint] = ACTIONS(5562),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [sym__newline] = ACTIONS(5562),
    [sym__dedent] = ACTIONS(5562),
  },
  [3529] = {
    [sym_block_comment] = STATE(3529),
    [sym_compiler_directive_decl] = STATE(3529),
    [sym_fsi_directive_decl] = STATE(3529),
    [sym_preproc_line] = STATE(3529),
    [sym_identifier] = ACTIONS(4007),
    [anon_sym_EQ] = ACTIONS(4005),
    [anon_sym_COLON] = ACTIONS(4007),
    [anon_sym_return] = ACTIONS(4007),
    [anon_sym_do] = ACTIONS(4007),
    [anon_sym_let] = ACTIONS(4007),
    [anon_sym_let_BANG] = ACTIONS(4005),
    [anon_sym_LPAREN] = ACTIONS(4007),
    [anon_sym_COMMA] = ACTIONS(4005),
    [anon_sym_null] = ACTIONS(4007),
    [anon_sym_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_QMARK] = ACTIONS(4007),
    [anon_sym_COLON_COLON] = ACTIONS(4005),
    [anon_sym_AMP] = ACTIONS(4007),
    [anon_sym_LBRACK] = ACTIONS(4007),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4005),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_LT_AT] = ACTIONS(4007),
    [anon_sym_LT_AT_AT] = ACTIONS(4007),
    [anon_sym_AT_AT_GT] = ACTIONS(4007),
    [anon_sym_DOT] = ACTIONS(4007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4005),
    [anon_sym_new] = ACTIONS(4007),
    [anon_sym_return_BANG] = ACTIONS(4005),
    [anon_sym_yield] = ACTIONS(4007),
    [anon_sym_yield_BANG] = ACTIONS(4005),
    [anon_sym_lazy] = ACTIONS(4007),
    [anon_sym_assert] = ACTIONS(4007),
    [anon_sym_upcast] = ACTIONS(4007),
    [anon_sym_downcast] = ACTIONS(4007),
    [anon_sym_COLON_GT] = ACTIONS(4005),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4005),
    [anon_sym_for] = ACTIONS(4007),
    [anon_sym_while] = ACTIONS(4007),
    [anon_sym_if] = ACTIONS(4007),
    [anon_sym_fun] = ACTIONS(4007),
    [anon_sym_try] = ACTIONS(4007),
    [anon_sym_match] = ACTIONS(4007),
    [anon_sym_match_BANG] = ACTIONS(4005),
    [anon_sym_function] = ACTIONS(4007),
    [anon_sym_LT_DASH] = ACTIONS(4007),
    [anon_sym_DOT_LBRACK] = ACTIONS(4005),
    [anon_sym_LT] = ACTIONS(4005),
    [anon_sym_use] = ACTIONS(4007),
    [anon_sym_use_BANG] = ACTIONS(4005),
    [anon_sym_do_BANG] = ACTIONS(4005),
    [anon_sym_begin] = ACTIONS(4007),
    [anon_sym_LPAREN2] = ACTIONS(4007),
    [anon_sym_or] = ACTIONS(4007),
    [aux_sym_char_token1] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4007),
    [anon_sym_DQUOTE] = ACTIONS(4007),
    [anon_sym_AT_DQUOTE] = ACTIONS(4005),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4005),
    [sym_bool] = ACTIONS(4007),
    [sym_unit] = ACTIONS(4005),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4007),
    [sym_op_identifier] = ACTIONS(4007),
    [anon_sym_PLUS] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4007),
    [anon_sym_PLUS_DOT] = ACTIONS(4007),
    [anon_sym_DASH_DOT] = ACTIONS(4007),
    [anon_sym_PERCENT] = ACTIONS(4007),
    [anon_sym_AMP_AMP] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4005),
    [aux_sym_prefix_op_token1] = ACTIONS(4007),
    [aux_sym_infix_op_token1] = ACTIONS(4005),
    [aux_sym_infix_op_token2] = ACTIONS(4007),
    [anon_sym_PIPE_PIPE] = ACTIONS(4007),
    [anon_sym_BANG_EQ] = ACTIONS(4007),
    [anon_sym_COLON_EQ] = ACTIONS(4005),
    [anon_sym_DOLLAR] = ACTIONS(4007),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4007),
    [sym_int] = ACTIONS(4007),
    [sym_xint] = ACTIONS(4005),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4005),
    [sym__newline] = ACTIONS(4005),
  },
  [3530] = {
    [sym_block_comment] = STATE(3530),
    [sym_compiler_directive_decl] = STATE(3530),
    [sym_fsi_directive_decl] = STATE(3530),
    [sym_preproc_line] = STATE(3530),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_DOT_DOT] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
  },
  [3531] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(7542),
    [sym_function_declaration_left] = STATE(10174),
    [sym_value_declaration_left] = STATE(10174),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3531),
    [sym_compiler_directive_decl] = STATE(3531),
    [sym_fsi_directive_decl] = STATE(3531),
    [sym_preproc_line] = STATE(3531),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_rec] = ACTIONS(6014),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3532] = {
    [sym_block_comment] = STATE(3532),
    [sym_compiler_directive_decl] = STATE(3532),
    [sym_fsi_directive_decl] = STATE(3532),
    [sym_preproc_line] = STATE(3532),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_COLON] = ACTIONS(3867),
    [anon_sym_return] = ACTIONS(3867),
    [anon_sym_do] = ACTIONS(3867),
    [anon_sym_let] = ACTIONS(3867),
    [anon_sym_let_BANG] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(3867),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_null] = ACTIONS(3867),
    [anon_sym_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_COLON] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3867),
    [anon_sym_LBRACK] = ACTIONS(3867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3867),
    [anon_sym_LT_AT] = ACTIONS(3867),
    [anon_sym_LT_AT_AT] = ACTIONS(3867),
    [anon_sym_DOT] = ACTIONS(3867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3867),
    [anon_sym_return_BANG] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3867),
    [anon_sym_yield_BANG] = ACTIONS(3865),
    [anon_sym_lazy] = ACTIONS(3867),
    [anon_sym_assert] = ACTIONS(3867),
    [anon_sym_upcast] = ACTIONS(3867),
    [anon_sym_downcast] = ACTIONS(3867),
    [anon_sym_COLON_GT] = ACTIONS(3865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3867),
    [anon_sym_while] = ACTIONS(3867),
    [anon_sym_if] = ACTIONS(3867),
    [anon_sym_fun] = ACTIONS(3867),
    [anon_sym_try] = ACTIONS(3867),
    [anon_sym_match] = ACTIONS(3867),
    [anon_sym_match_BANG] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(3867),
    [anon_sym_DOT_LBRACK] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_GT] = ACTIONS(3867),
    [anon_sym_use] = ACTIONS(3867),
    [anon_sym_use_BANG] = ACTIONS(3865),
    [anon_sym_do_BANG] = ACTIONS(3865),
    [anon_sym_begin] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(3867),
    [anon_sym_or] = ACTIONS(3867),
    [aux_sym_char_token1] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3867),
    [anon_sym_DQUOTE] = ACTIONS(3867),
    [anon_sym_AT_DQUOTE] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [sym_bool] = ACTIONS(3867),
    [sym_unit] = ACTIONS(3865),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3867),
    [sym_op_identifier] = ACTIONS(3867),
    [anon_sym_PLUS] = ACTIONS(3867),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_PLUS_DOT] = ACTIONS(3867),
    [anon_sym_DASH_DOT] = ACTIONS(3867),
    [anon_sym_PERCENT] = ACTIONS(3867),
    [anon_sym_AMP_AMP] = ACTIONS(3867),
    [anon_sym_TILDE] = ACTIONS(3865),
    [aux_sym_prefix_op_token1] = ACTIONS(3867),
    [aux_sym_infix_op_token1] = ACTIONS(3865),
    [aux_sym_infix_op_token2] = ACTIONS(3867),
    [anon_sym_PIPE_PIPE] = ACTIONS(3867),
    [anon_sym_BANG_EQ] = ACTIONS(3867),
    [anon_sym_COLON_EQ] = ACTIONS(3865),
    [anon_sym_DOLLAR] = ACTIONS(3867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3867),
    [sym_int] = ACTIONS(3867),
    [sym_xint] = ACTIONS(3865),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3865),
    [sym__newline] = ACTIONS(3865),
  },
  [3533] = {
    [sym_block_comment] = STATE(3533),
    [sym_compiler_directive_decl] = STATE(3533),
    [sym_fsi_directive_decl] = STATE(3533),
    [sym_preproc_line] = STATE(3533),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_EQ] = ACTIONS(4072),
    [anon_sym_COLON] = ACTIONS(4074),
    [anon_sym_return] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_let_BANG] = ACTIONS(4072),
    [anon_sym_LPAREN] = ACTIONS(4074),
    [anon_sym_COMMA] = ACTIONS(4072),
    [anon_sym_null] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_QMARK] = ACTIONS(4074),
    [anon_sym_COLON_COLON] = ACTIONS(4072),
    [anon_sym_AMP] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_LT_AT] = ACTIONS(4074),
    [anon_sym_LT_AT_AT] = ACTIONS(4074),
    [anon_sym_AT_AT_GT] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4074),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4072),
    [anon_sym_new] = ACTIONS(4074),
    [anon_sym_return_BANG] = ACTIONS(4072),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_yield_BANG] = ACTIONS(4072),
    [anon_sym_lazy] = ACTIONS(4074),
    [anon_sym_assert] = ACTIONS(4074),
    [anon_sym_upcast] = ACTIONS(4074),
    [anon_sym_downcast] = ACTIONS(4074),
    [anon_sym_COLON_GT] = ACTIONS(4072),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4072),
    [anon_sym_for] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_fun] = ACTIONS(4074),
    [anon_sym_try] = ACTIONS(4074),
    [anon_sym_match] = ACTIONS(4074),
    [anon_sym_match_BANG] = ACTIONS(4072),
    [anon_sym_function] = ACTIONS(4074),
    [anon_sym_LT_DASH] = ACTIONS(4074),
    [anon_sym_DOT_LBRACK] = ACTIONS(4072),
    [anon_sym_LT] = ACTIONS(4072),
    [anon_sym_use] = ACTIONS(4074),
    [anon_sym_use_BANG] = ACTIONS(4072),
    [anon_sym_do_BANG] = ACTIONS(4072),
    [anon_sym_begin] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [aux_sym_char_token1] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4074),
    [anon_sym_DQUOTE] = ACTIONS(4074),
    [anon_sym_AT_DQUOTE] = ACTIONS(4072),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4072),
    [sym_bool] = ACTIONS(4074),
    [sym_unit] = ACTIONS(4072),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4074),
    [sym_op_identifier] = ACTIONS(4074),
    [anon_sym_PLUS] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [anon_sym_PLUS_DOT] = ACTIONS(4074),
    [anon_sym_DASH_DOT] = ACTIONS(4074),
    [anon_sym_PERCENT] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_TILDE] = ACTIONS(4072),
    [aux_sym_prefix_op_token1] = ACTIONS(4074),
    [aux_sym_infix_op_token1] = ACTIONS(4072),
    [aux_sym_infix_op_token2] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [anon_sym_BANG_EQ] = ACTIONS(4074),
    [anon_sym_COLON_EQ] = ACTIONS(4072),
    [anon_sym_DOLLAR] = ACTIONS(4074),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4074),
    [sym_int] = ACTIONS(4074),
    [sym_xint] = ACTIONS(4072),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4072),
    [sym__newline] = ACTIONS(4072),
  },
  [3534] = {
    [sym_block_comment] = STATE(3534),
    [sym_compiler_directive_decl] = STATE(3534),
    [sym_fsi_directive_decl] = STATE(3534),
    [sym_preproc_line] = STATE(3534),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(6016),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_DOT_DOT] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
  },
  [3535] = {
    [sym_block_comment] = STATE(3535),
    [sym_compiler_directive_decl] = STATE(3535),
    [sym_fsi_directive_decl] = STATE(3535),
    [sym_preproc_line] = STATE(3535),
    [sym_identifier] = ACTIONS(3921),
    [anon_sym_EQ] = ACTIONS(3919),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_return] = ACTIONS(3921),
    [anon_sym_do] = ACTIONS(3921),
    [anon_sym_let] = ACTIONS(3921),
    [anon_sym_let_BANG] = ACTIONS(3919),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3919),
    [anon_sym_null] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_QMARK] = ACTIONS(3921),
    [anon_sym_COLON_COLON] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3919),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_LT_AT] = ACTIONS(3921),
    [anon_sym_LT_AT_AT] = ACTIONS(3921),
    [anon_sym_AT_AT_GT] = ACTIONS(3921),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3919),
    [anon_sym_new] = ACTIONS(3921),
    [anon_sym_return_BANG] = ACTIONS(3919),
    [anon_sym_yield] = ACTIONS(3921),
    [anon_sym_yield_BANG] = ACTIONS(3919),
    [anon_sym_lazy] = ACTIONS(3921),
    [anon_sym_assert] = ACTIONS(3921),
    [anon_sym_upcast] = ACTIONS(3921),
    [anon_sym_downcast] = ACTIONS(3921),
    [anon_sym_COLON_GT] = ACTIONS(3919),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3919),
    [anon_sym_for] = ACTIONS(3921),
    [anon_sym_while] = ACTIONS(3921),
    [anon_sym_if] = ACTIONS(3921),
    [anon_sym_fun] = ACTIONS(3921),
    [anon_sym_try] = ACTIONS(3921),
    [anon_sym_match] = ACTIONS(3921),
    [anon_sym_match_BANG] = ACTIONS(3919),
    [anon_sym_function] = ACTIONS(3921),
    [anon_sym_LT_DASH] = ACTIONS(3921),
    [anon_sym_DOT_LBRACK] = ACTIONS(3919),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_use] = ACTIONS(3921),
    [anon_sym_use_BANG] = ACTIONS(3919),
    [anon_sym_do_BANG] = ACTIONS(3919),
    [anon_sym_begin] = ACTIONS(3921),
    [anon_sym_LPAREN2] = ACTIONS(3921),
    [anon_sym_or] = ACTIONS(3921),
    [aux_sym_char_token1] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [anon_sym_AT_DQUOTE] = ACTIONS(3919),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3919),
    [sym_bool] = ACTIONS(3921),
    [sym_unit] = ACTIONS(3919),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3921),
    [sym_op_identifier] = ACTIONS(3921),
    [anon_sym_PLUS] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_DOT] = ACTIONS(3921),
    [anon_sym_DASH_DOT] = ACTIONS(3921),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3919),
    [aux_sym_prefix_op_token1] = ACTIONS(3921),
    [aux_sym_infix_op_token1] = ACTIONS(3919),
    [aux_sym_infix_op_token2] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3921),
    [anon_sym_COLON_EQ] = ACTIONS(3919),
    [anon_sym_DOLLAR] = ACTIONS(3921),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3921),
    [sym_int] = ACTIONS(3921),
    [sym_xint] = ACTIONS(3919),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3919),
    [sym__newline] = ACTIONS(3919),
  },
  [3536] = {
    [sym_block_comment] = STATE(3536),
    [sym_compiler_directive_decl] = STATE(3536),
    [sym_fsi_directive_decl] = STATE(3536),
    [sym_preproc_line] = STATE(3536),
    [sym_identifier] = ACTIONS(3958),
    [anon_sym_EQ] = ACTIONS(3956),
    [anon_sym_COLON] = ACTIONS(3958),
    [anon_sym_return] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(3958),
    [anon_sym_let] = ACTIONS(3958),
    [anon_sym_let_BANG] = ACTIONS(3956),
    [anon_sym_LPAREN] = ACTIONS(3958),
    [anon_sym_COMMA] = ACTIONS(3956),
    [anon_sym_null] = ACTIONS(3958),
    [anon_sym_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_QMARK] = ACTIONS(3958),
    [anon_sym_COLON_COLON] = ACTIONS(3956),
    [anon_sym_AMP] = ACTIONS(3958),
    [anon_sym_LBRACK] = ACTIONS(3958),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3956),
    [anon_sym_LBRACE] = ACTIONS(3958),
    [anon_sym_LT_AT] = ACTIONS(3958),
    [anon_sym_AT_GT] = ACTIONS(3958),
    [anon_sym_LT_AT_AT] = ACTIONS(3958),
    [anon_sym_DOT] = ACTIONS(3958),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3956),
    [anon_sym_new] = ACTIONS(3958),
    [anon_sym_return_BANG] = ACTIONS(3956),
    [anon_sym_yield] = ACTIONS(3958),
    [anon_sym_yield_BANG] = ACTIONS(3956),
    [anon_sym_lazy] = ACTIONS(3958),
    [anon_sym_assert] = ACTIONS(3958),
    [anon_sym_upcast] = ACTIONS(3958),
    [anon_sym_downcast] = ACTIONS(3958),
    [anon_sym_COLON_GT] = ACTIONS(3956),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3956),
    [anon_sym_for] = ACTIONS(3958),
    [anon_sym_while] = ACTIONS(3958),
    [anon_sym_if] = ACTIONS(3958),
    [anon_sym_fun] = ACTIONS(3958),
    [anon_sym_try] = ACTIONS(3958),
    [anon_sym_match] = ACTIONS(3958),
    [anon_sym_match_BANG] = ACTIONS(3956),
    [anon_sym_function] = ACTIONS(3958),
    [anon_sym_LT_DASH] = ACTIONS(3958),
    [anon_sym_DOT_LBRACK] = ACTIONS(3956),
    [anon_sym_LT] = ACTIONS(3956),
    [anon_sym_use] = ACTIONS(3958),
    [anon_sym_use_BANG] = ACTIONS(3956),
    [anon_sym_do_BANG] = ACTIONS(3956),
    [anon_sym_begin] = ACTIONS(3958),
    [anon_sym_LPAREN2] = ACTIONS(3958),
    [anon_sym_or] = ACTIONS(3958),
    [aux_sym_char_token1] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [anon_sym_AT_DQUOTE] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [sym_bool] = ACTIONS(3958),
    [sym_unit] = ACTIONS(3956),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3958),
    [sym_op_identifier] = ACTIONS(3958),
    [anon_sym_PLUS] = ACTIONS(3958),
    [anon_sym_DASH] = ACTIONS(3958),
    [anon_sym_PLUS_DOT] = ACTIONS(3958),
    [anon_sym_DASH_DOT] = ACTIONS(3958),
    [anon_sym_PERCENT] = ACTIONS(3958),
    [anon_sym_AMP_AMP] = ACTIONS(3958),
    [anon_sym_TILDE] = ACTIONS(3956),
    [aux_sym_prefix_op_token1] = ACTIONS(3958),
    [aux_sym_infix_op_token1] = ACTIONS(3956),
    [aux_sym_infix_op_token2] = ACTIONS(3958),
    [anon_sym_PIPE_PIPE] = ACTIONS(3958),
    [anon_sym_BANG_EQ] = ACTIONS(3958),
    [anon_sym_COLON_EQ] = ACTIONS(3956),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3958),
    [sym_int] = ACTIONS(3958),
    [sym_xint] = ACTIONS(3956),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3956),
    [sym__newline] = ACTIONS(3956),
  },
  [3537] = {
    [sym_block_comment] = STATE(3537),
    [sym_compiler_directive_decl] = STATE(3537),
    [sym_fsi_directive_decl] = STATE(3537),
    [sym_preproc_line] = STATE(3537),
    [sym_identifier] = ACTIONS(3962),
    [anon_sym_EQ] = ACTIONS(3960),
    [anon_sym_COLON] = ACTIONS(3962),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_do] = ACTIONS(3962),
    [anon_sym_let] = ACTIONS(3962),
    [anon_sym_let_BANG] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_COMMA] = ACTIONS(3960),
    [anon_sym_null] = ACTIONS(3962),
    [anon_sym_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_COLON] = ACTIONS(3960),
    [anon_sym_AMP] = ACTIONS(3962),
    [anon_sym_LBRACK] = ACTIONS(3962),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_LT_AT] = ACTIONS(3962),
    [anon_sym_AT_GT] = ACTIONS(3962),
    [anon_sym_LT_AT_AT] = ACTIONS(3962),
    [anon_sym_DOT] = ACTIONS(3962),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3960),
    [anon_sym_new] = ACTIONS(3962),
    [anon_sym_return_BANG] = ACTIONS(3960),
    [anon_sym_yield] = ACTIONS(3962),
    [anon_sym_yield_BANG] = ACTIONS(3960),
    [anon_sym_lazy] = ACTIONS(3962),
    [anon_sym_assert] = ACTIONS(3962),
    [anon_sym_upcast] = ACTIONS(3962),
    [anon_sym_downcast] = ACTIONS(3962),
    [anon_sym_COLON_GT] = ACTIONS(3960),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3960),
    [anon_sym_for] = ACTIONS(3962),
    [anon_sym_while] = ACTIONS(3962),
    [anon_sym_if] = ACTIONS(3962),
    [anon_sym_fun] = ACTIONS(3962),
    [anon_sym_try] = ACTIONS(3962),
    [anon_sym_match] = ACTIONS(3962),
    [anon_sym_match_BANG] = ACTIONS(3960),
    [anon_sym_function] = ACTIONS(3962),
    [anon_sym_LT_DASH] = ACTIONS(3962),
    [anon_sym_DOT_LBRACK] = ACTIONS(3960),
    [anon_sym_LT] = ACTIONS(3960),
    [anon_sym_use] = ACTIONS(3962),
    [anon_sym_use_BANG] = ACTIONS(3960),
    [anon_sym_do_BANG] = ACTIONS(3960),
    [anon_sym_begin] = ACTIONS(3962),
    [anon_sym_LPAREN2] = ACTIONS(3962),
    [anon_sym_or] = ACTIONS(3962),
    [aux_sym_char_token1] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3962),
    [anon_sym_DQUOTE] = ACTIONS(3962),
    [anon_sym_AT_DQUOTE] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [sym_bool] = ACTIONS(3962),
    [sym_unit] = ACTIONS(3960),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3962),
    [sym_op_identifier] = ACTIONS(3962),
    [anon_sym_PLUS] = ACTIONS(3962),
    [anon_sym_DASH] = ACTIONS(3962),
    [anon_sym_PLUS_DOT] = ACTIONS(3962),
    [anon_sym_DASH_DOT] = ACTIONS(3962),
    [anon_sym_PERCENT] = ACTIONS(3962),
    [anon_sym_AMP_AMP] = ACTIONS(3962),
    [anon_sym_TILDE] = ACTIONS(3960),
    [aux_sym_prefix_op_token1] = ACTIONS(3962),
    [aux_sym_infix_op_token1] = ACTIONS(3960),
    [aux_sym_infix_op_token2] = ACTIONS(3962),
    [anon_sym_PIPE_PIPE] = ACTIONS(3962),
    [anon_sym_BANG_EQ] = ACTIONS(3962),
    [anon_sym_COLON_EQ] = ACTIONS(3960),
    [anon_sym_DOLLAR] = ACTIONS(3962),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3962),
    [sym_int] = ACTIONS(3962),
    [sym_xint] = ACTIONS(3960),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3960),
    [sym__newline] = ACTIONS(3960),
  },
  [3538] = {
    [sym_block_comment] = STATE(3538),
    [sym_compiler_directive_decl] = STATE(3538),
    [sym_fsi_directive_decl] = STATE(3538),
    [sym_preproc_line] = STATE(3538),
    [sym_identifier] = ACTIONS(4232),
    [anon_sym_EQ] = ACTIONS(4230),
    [anon_sym_COLON] = ACTIONS(4232),
    [anon_sym_return] = ACTIONS(4232),
    [anon_sym_do] = ACTIONS(4232),
    [anon_sym_let] = ACTIONS(4232),
    [anon_sym_let_BANG] = ACTIONS(4230),
    [anon_sym_LPAREN] = ACTIONS(4232),
    [anon_sym_COMMA] = ACTIONS(4230),
    [anon_sym_null] = ACTIONS(4232),
    [anon_sym_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_COLON] = ACTIONS(4230),
    [anon_sym_AMP] = ACTIONS(4232),
    [anon_sym_LBRACK] = ACTIONS(4232),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4230),
    [anon_sym_LBRACE] = ACTIONS(4232),
    [anon_sym_LT_AT] = ACTIONS(4232),
    [anon_sym_AT_GT] = ACTIONS(4232),
    [anon_sym_LT_AT_AT] = ACTIONS(4232),
    [anon_sym_DOT] = ACTIONS(4232),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4230),
    [anon_sym_new] = ACTIONS(4232),
    [anon_sym_return_BANG] = ACTIONS(4230),
    [anon_sym_yield] = ACTIONS(4232),
    [anon_sym_yield_BANG] = ACTIONS(4230),
    [anon_sym_lazy] = ACTIONS(4232),
    [anon_sym_assert] = ACTIONS(4232),
    [anon_sym_upcast] = ACTIONS(4232),
    [anon_sym_downcast] = ACTIONS(4232),
    [anon_sym_COLON_GT] = ACTIONS(4230),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4230),
    [anon_sym_for] = ACTIONS(4232),
    [anon_sym_while] = ACTIONS(4232),
    [anon_sym_if] = ACTIONS(4232),
    [anon_sym_fun] = ACTIONS(4232),
    [anon_sym_try] = ACTIONS(4232),
    [anon_sym_match] = ACTIONS(4232),
    [anon_sym_match_BANG] = ACTIONS(4230),
    [anon_sym_function] = ACTIONS(4232),
    [anon_sym_LT_DASH] = ACTIONS(4232),
    [anon_sym_DOT_LBRACK] = ACTIONS(4230),
    [anon_sym_LT] = ACTIONS(4230),
    [anon_sym_use] = ACTIONS(4232),
    [anon_sym_use_BANG] = ACTIONS(4230),
    [anon_sym_do_BANG] = ACTIONS(4230),
    [anon_sym_begin] = ACTIONS(4232),
    [anon_sym_LPAREN2] = ACTIONS(4232),
    [anon_sym_or] = ACTIONS(4232),
    [aux_sym_char_token1] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4232),
    [anon_sym_DQUOTE] = ACTIONS(4232),
    [anon_sym_AT_DQUOTE] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [sym_bool] = ACTIONS(4232),
    [sym_unit] = ACTIONS(4230),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4232),
    [sym_op_identifier] = ACTIONS(4232),
    [anon_sym_PLUS] = ACTIONS(4232),
    [anon_sym_DASH] = ACTIONS(4232),
    [anon_sym_PLUS_DOT] = ACTIONS(4232),
    [anon_sym_DASH_DOT] = ACTIONS(4232),
    [anon_sym_PERCENT] = ACTIONS(4232),
    [anon_sym_AMP_AMP] = ACTIONS(4232),
    [anon_sym_TILDE] = ACTIONS(4230),
    [aux_sym_prefix_op_token1] = ACTIONS(4232),
    [aux_sym_infix_op_token1] = ACTIONS(4230),
    [aux_sym_infix_op_token2] = ACTIONS(4232),
    [anon_sym_PIPE_PIPE] = ACTIONS(4232),
    [anon_sym_BANG_EQ] = ACTIONS(4232),
    [anon_sym_COLON_EQ] = ACTIONS(4230),
    [anon_sym_DOLLAR] = ACTIONS(4232),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4232),
    [sym_int] = ACTIONS(4232),
    [sym_xint] = ACTIONS(4230),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4230),
    [sym__newline] = ACTIONS(4230),
  },
  [3539] = {
    [sym_block_comment] = STATE(3539),
    [sym_compiler_directive_decl] = STATE(3539),
    [sym_fsi_directive_decl] = STATE(3539),
    [sym_preproc_line] = STATE(3539),
    [sym_identifier] = ACTIONS(4126),
    [anon_sym_EQ] = ACTIONS(4124),
    [anon_sym_COLON] = ACTIONS(4126),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_do] = ACTIONS(4126),
    [anon_sym_let] = ACTIONS(4126),
    [anon_sym_let_BANG] = ACTIONS(4124),
    [anon_sym_LPAREN] = ACTIONS(4126),
    [anon_sym_COMMA] = ACTIONS(4124),
    [anon_sym_null] = ACTIONS(4126),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_QMARK] = ACTIONS(4126),
    [anon_sym_COLON_COLON] = ACTIONS(4124),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LBRACK] = ACTIONS(4126),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4126),
    [anon_sym_LT_AT] = ACTIONS(4126),
    [anon_sym_AT_GT] = ACTIONS(4126),
    [anon_sym_LT_AT_AT] = ACTIONS(4126),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4124),
    [anon_sym_new] = ACTIONS(4126),
    [anon_sym_return_BANG] = ACTIONS(4124),
    [anon_sym_yield] = ACTIONS(4126),
    [anon_sym_yield_BANG] = ACTIONS(4124),
    [anon_sym_lazy] = ACTIONS(4126),
    [anon_sym_assert] = ACTIONS(4126),
    [anon_sym_upcast] = ACTIONS(4126),
    [anon_sym_downcast] = ACTIONS(4126),
    [anon_sym_COLON_GT] = ACTIONS(4124),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4124),
    [anon_sym_for] = ACTIONS(4126),
    [anon_sym_while] = ACTIONS(4126),
    [anon_sym_if] = ACTIONS(4126),
    [anon_sym_fun] = ACTIONS(4126),
    [anon_sym_try] = ACTIONS(4126),
    [anon_sym_match] = ACTIONS(4126),
    [anon_sym_match_BANG] = ACTIONS(4124),
    [anon_sym_function] = ACTIONS(4126),
    [anon_sym_LT_DASH] = ACTIONS(4126),
    [anon_sym_DOT_LBRACK] = ACTIONS(4124),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_use] = ACTIONS(4126),
    [anon_sym_use_BANG] = ACTIONS(4124),
    [anon_sym_do_BANG] = ACTIONS(4124),
    [anon_sym_begin] = ACTIONS(4126),
    [anon_sym_LPAREN2] = ACTIONS(4126),
    [anon_sym_or] = ACTIONS(4126),
    [aux_sym_char_token1] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4126),
    [anon_sym_DQUOTE] = ACTIONS(4126),
    [anon_sym_AT_DQUOTE] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [sym_bool] = ACTIONS(4126),
    [sym_unit] = ACTIONS(4124),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4126),
    [sym_op_identifier] = ACTIONS(4126),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_PLUS_DOT] = ACTIONS(4126),
    [anon_sym_DASH_DOT] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_AMP_AMP] = ACTIONS(4126),
    [anon_sym_TILDE] = ACTIONS(4124),
    [aux_sym_prefix_op_token1] = ACTIONS(4126),
    [aux_sym_infix_op_token1] = ACTIONS(4124),
    [aux_sym_infix_op_token2] = ACTIONS(4126),
    [anon_sym_PIPE_PIPE] = ACTIONS(4126),
    [anon_sym_BANG_EQ] = ACTIONS(4126),
    [anon_sym_COLON_EQ] = ACTIONS(4124),
    [anon_sym_DOLLAR] = ACTIONS(4126),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4126),
    [sym_int] = ACTIONS(4126),
    [sym_xint] = ACTIONS(4124),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4124),
    [sym__newline] = ACTIONS(4124),
  },
  [3540] = {
    [sym_block_comment] = STATE(3540),
    [sym_compiler_directive_decl] = STATE(3540),
    [sym_fsi_directive_decl] = STATE(3540),
    [sym_preproc_line] = STATE(3540),
    [sym_identifier] = ACTIONS(4186),
    [anon_sym_EQ] = ACTIONS(4184),
    [anon_sym_COLON] = ACTIONS(4186),
    [anon_sym_return] = ACTIONS(4186),
    [anon_sym_do] = ACTIONS(4186),
    [anon_sym_let] = ACTIONS(4186),
    [anon_sym_let_BANG] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_COMMA] = ACTIONS(4184),
    [anon_sym_null] = ACTIONS(4186),
    [anon_sym_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_QMARK] = ACTIONS(4186),
    [anon_sym_COLON_COLON] = ACTIONS(4184),
    [anon_sym_AMP] = ACTIONS(4186),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4184),
    [anon_sym_LBRACE] = ACTIONS(4186),
    [anon_sym_LT_AT] = ACTIONS(4186),
    [anon_sym_LT_AT_AT] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4186),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4184),
    [anon_sym_new] = ACTIONS(4186),
    [anon_sym_return_BANG] = ACTIONS(4184),
    [anon_sym_yield] = ACTIONS(4186),
    [anon_sym_yield_BANG] = ACTIONS(4184),
    [anon_sym_lazy] = ACTIONS(4186),
    [anon_sym_assert] = ACTIONS(4186),
    [anon_sym_upcast] = ACTIONS(4186),
    [anon_sym_downcast] = ACTIONS(4186),
    [anon_sym_COLON_GT] = ACTIONS(4184),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4184),
    [anon_sym_for] = ACTIONS(4186),
    [anon_sym_while] = ACTIONS(4186),
    [anon_sym_if] = ACTIONS(4186),
    [anon_sym_fun] = ACTIONS(4186),
    [anon_sym_try] = ACTIONS(4186),
    [anon_sym_match] = ACTIONS(4186),
    [anon_sym_match_BANG] = ACTIONS(4184),
    [anon_sym_function] = ACTIONS(4186),
    [anon_sym_LT_DASH] = ACTIONS(4186),
    [anon_sym_DOT_LBRACK] = ACTIONS(4184),
    [anon_sym_LT] = ACTIONS(4184),
    [anon_sym_GT] = ACTIONS(4186),
    [anon_sym_use] = ACTIONS(4186),
    [anon_sym_use_BANG] = ACTIONS(4184),
    [anon_sym_do_BANG] = ACTIONS(4184),
    [anon_sym_begin] = ACTIONS(4186),
    [anon_sym_LPAREN2] = ACTIONS(4186),
    [anon_sym_or] = ACTIONS(4186),
    [aux_sym_char_token1] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4186),
    [anon_sym_DQUOTE] = ACTIONS(4186),
    [anon_sym_AT_DQUOTE] = ACTIONS(4184),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4184),
    [sym_bool] = ACTIONS(4186),
    [sym_unit] = ACTIONS(4184),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4186),
    [sym_op_identifier] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4186),
    [anon_sym_DASH] = ACTIONS(4186),
    [anon_sym_PLUS_DOT] = ACTIONS(4186),
    [anon_sym_DASH_DOT] = ACTIONS(4186),
    [anon_sym_PERCENT] = ACTIONS(4186),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_TILDE] = ACTIONS(4184),
    [aux_sym_prefix_op_token1] = ACTIONS(4186),
    [aux_sym_infix_op_token1] = ACTIONS(4184),
    [aux_sym_infix_op_token2] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_COLON_EQ] = ACTIONS(4184),
    [anon_sym_DOLLAR] = ACTIONS(4186),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4186),
    [sym_int] = ACTIONS(4186),
    [sym_xint] = ACTIONS(4184),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4184),
    [sym__newline] = ACTIONS(4184),
  },
  [3541] = {
    [sym_block_comment] = STATE(3541),
    [sym_compiler_directive_decl] = STATE(3541),
    [sym_fsi_directive_decl] = STATE(3541),
    [sym_preproc_line] = STATE(3541),
    [sym_identifier] = ACTIONS(3881),
    [anon_sym_EQ] = ACTIONS(3879),
    [anon_sym_COLON] = ACTIONS(3881),
    [anon_sym_return] = ACTIONS(3881),
    [anon_sym_do] = ACTIONS(3881),
    [anon_sym_let] = ACTIONS(3881),
    [anon_sym_let_BANG] = ACTIONS(3879),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3879),
    [anon_sym_null] = ACTIONS(3881),
    [anon_sym_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3879),
    [anon_sym_LBRACE] = ACTIONS(3881),
    [anon_sym_LT_AT] = ACTIONS(3881),
    [anon_sym_LT_AT_AT] = ACTIONS(3881),
    [anon_sym_AT_AT_GT] = ACTIONS(3881),
    [anon_sym_DOT] = ACTIONS(3881),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3879),
    [anon_sym_new] = ACTIONS(3881),
    [anon_sym_return_BANG] = ACTIONS(3879),
    [anon_sym_yield] = ACTIONS(3881),
    [anon_sym_yield_BANG] = ACTIONS(3879),
    [anon_sym_lazy] = ACTIONS(3881),
    [anon_sym_assert] = ACTIONS(3881),
    [anon_sym_upcast] = ACTIONS(3881),
    [anon_sym_downcast] = ACTIONS(3881),
    [anon_sym_COLON_GT] = ACTIONS(3879),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3879),
    [anon_sym_for] = ACTIONS(3881),
    [anon_sym_while] = ACTIONS(3881),
    [anon_sym_if] = ACTIONS(3881),
    [anon_sym_fun] = ACTIONS(3881),
    [anon_sym_try] = ACTIONS(3881),
    [anon_sym_match] = ACTIONS(3881),
    [anon_sym_match_BANG] = ACTIONS(3879),
    [anon_sym_function] = ACTIONS(3881),
    [anon_sym_LT_DASH] = ACTIONS(3881),
    [anon_sym_DOT_LBRACK] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_use] = ACTIONS(3881),
    [anon_sym_use_BANG] = ACTIONS(3879),
    [anon_sym_do_BANG] = ACTIONS(3879),
    [anon_sym_begin] = ACTIONS(3881),
    [anon_sym_LPAREN2] = ACTIONS(3881),
    [anon_sym_or] = ACTIONS(3881),
    [aux_sym_char_token1] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3881),
    [anon_sym_DQUOTE] = ACTIONS(3881),
    [anon_sym_AT_DQUOTE] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [sym_bool] = ACTIONS(3881),
    [sym_unit] = ACTIONS(3879),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3881),
    [sym_op_identifier] = ACTIONS(3881),
    [anon_sym_PLUS] = ACTIONS(3881),
    [anon_sym_DASH] = ACTIONS(3881),
    [anon_sym_PLUS_DOT] = ACTIONS(3881),
    [anon_sym_DASH_DOT] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(3881),
    [anon_sym_AMP_AMP] = ACTIONS(3881),
    [anon_sym_TILDE] = ACTIONS(3879),
    [aux_sym_prefix_op_token1] = ACTIONS(3881),
    [aux_sym_infix_op_token1] = ACTIONS(3879),
    [aux_sym_infix_op_token2] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE] = ACTIONS(3881),
    [anon_sym_BANG_EQ] = ACTIONS(3881),
    [anon_sym_COLON_EQ] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3881),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3881),
    [sym_int] = ACTIONS(3881),
    [sym_xint] = ACTIONS(3879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3879),
    [sym__newline] = ACTIONS(3879),
  },
  [3542] = {
    [sym_block_comment] = STATE(3542),
    [sym_compiler_directive_decl] = STATE(3542),
    [sym_fsi_directive_decl] = STATE(3542),
    [sym_preproc_line] = STATE(3542),
    [sym_identifier] = ACTIONS(4122),
    [anon_sym_EQ] = ACTIONS(4120),
    [anon_sym_COLON] = ACTIONS(4122),
    [anon_sym_return] = ACTIONS(4122),
    [anon_sym_do] = ACTIONS(4122),
    [anon_sym_let] = ACTIONS(4122),
    [anon_sym_let_BANG] = ACTIONS(4120),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_COMMA] = ACTIONS(4120),
    [anon_sym_null] = ACTIONS(4122),
    [anon_sym_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_QMARK] = ACTIONS(4122),
    [anon_sym_COLON_COLON] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_LT_AT] = ACTIONS(4122),
    [anon_sym_AT_GT] = ACTIONS(4122),
    [anon_sym_LT_AT_AT] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4122),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4120),
    [anon_sym_new] = ACTIONS(4122),
    [anon_sym_return_BANG] = ACTIONS(4120),
    [anon_sym_yield] = ACTIONS(4122),
    [anon_sym_yield_BANG] = ACTIONS(4120),
    [anon_sym_lazy] = ACTIONS(4122),
    [anon_sym_assert] = ACTIONS(4122),
    [anon_sym_upcast] = ACTIONS(4122),
    [anon_sym_downcast] = ACTIONS(4122),
    [anon_sym_COLON_GT] = ACTIONS(4120),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4120),
    [anon_sym_for] = ACTIONS(4122),
    [anon_sym_while] = ACTIONS(4122),
    [anon_sym_if] = ACTIONS(4122),
    [anon_sym_fun] = ACTIONS(4122),
    [anon_sym_try] = ACTIONS(4122),
    [anon_sym_match] = ACTIONS(4122),
    [anon_sym_match_BANG] = ACTIONS(4120),
    [anon_sym_function] = ACTIONS(4122),
    [anon_sym_LT_DASH] = ACTIONS(4122),
    [anon_sym_DOT_LBRACK] = ACTIONS(4120),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_use] = ACTIONS(4122),
    [anon_sym_use_BANG] = ACTIONS(4120),
    [anon_sym_do_BANG] = ACTIONS(4120),
    [anon_sym_begin] = ACTIONS(4122),
    [anon_sym_LPAREN2] = ACTIONS(4122),
    [anon_sym_or] = ACTIONS(4122),
    [aux_sym_char_token1] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4122),
    [anon_sym_DQUOTE] = ACTIONS(4122),
    [anon_sym_AT_DQUOTE] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [sym_bool] = ACTIONS(4122),
    [sym_unit] = ACTIONS(4120),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4122),
    [sym_op_identifier] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4122),
    [anon_sym_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_DOT] = ACTIONS(4122),
    [anon_sym_DASH_DOT] = ACTIONS(4122),
    [anon_sym_PERCENT] = ACTIONS(4122),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_TILDE] = ACTIONS(4120),
    [aux_sym_prefix_op_token1] = ACTIONS(4122),
    [aux_sym_infix_op_token1] = ACTIONS(4120),
    [aux_sym_infix_op_token2] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_COLON_EQ] = ACTIONS(4120),
    [anon_sym_DOLLAR] = ACTIONS(4122),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4122),
    [sym_int] = ACTIONS(4122),
    [sym_xint] = ACTIONS(4120),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4120),
    [sym__newline] = ACTIONS(4120),
  },
  [3543] = {
    [sym_block_comment] = STATE(3543),
    [sym_compiler_directive_decl] = STATE(3543),
    [sym_fsi_directive_decl] = STATE(3543),
    [sym_preproc_line] = STATE(3543),
    [sym_identifier] = ACTIONS(4118),
    [anon_sym_EQ] = ACTIONS(4116),
    [anon_sym_COLON] = ACTIONS(4118),
    [anon_sym_return] = ACTIONS(4118),
    [anon_sym_do] = ACTIONS(4118),
    [anon_sym_let] = ACTIONS(4118),
    [anon_sym_let_BANG] = ACTIONS(4116),
    [anon_sym_LPAREN] = ACTIONS(4118),
    [anon_sym_COMMA] = ACTIONS(4116),
    [anon_sym_null] = ACTIONS(4118),
    [anon_sym_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_QMARK] = ACTIONS(4118),
    [anon_sym_COLON_COLON] = ACTIONS(4116),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4118),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(4118),
    [anon_sym_LT_AT] = ACTIONS(4118),
    [anon_sym_AT_GT] = ACTIONS(4118),
    [anon_sym_LT_AT_AT] = ACTIONS(4118),
    [anon_sym_DOT] = ACTIONS(4118),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4116),
    [anon_sym_new] = ACTIONS(4118),
    [anon_sym_return_BANG] = ACTIONS(4116),
    [anon_sym_yield] = ACTIONS(4118),
    [anon_sym_yield_BANG] = ACTIONS(4116),
    [anon_sym_lazy] = ACTIONS(4118),
    [anon_sym_assert] = ACTIONS(4118),
    [anon_sym_upcast] = ACTIONS(4118),
    [anon_sym_downcast] = ACTIONS(4118),
    [anon_sym_COLON_GT] = ACTIONS(4116),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4116),
    [anon_sym_for] = ACTIONS(4118),
    [anon_sym_while] = ACTIONS(4118),
    [anon_sym_if] = ACTIONS(4118),
    [anon_sym_fun] = ACTIONS(4118),
    [anon_sym_try] = ACTIONS(4118),
    [anon_sym_match] = ACTIONS(4118),
    [anon_sym_match_BANG] = ACTIONS(4116),
    [anon_sym_function] = ACTIONS(4118),
    [anon_sym_LT_DASH] = ACTIONS(4118),
    [anon_sym_DOT_LBRACK] = ACTIONS(4116),
    [anon_sym_LT] = ACTIONS(4116),
    [anon_sym_use] = ACTIONS(4118),
    [anon_sym_use_BANG] = ACTIONS(4116),
    [anon_sym_do_BANG] = ACTIONS(4116),
    [anon_sym_begin] = ACTIONS(4118),
    [anon_sym_LPAREN2] = ACTIONS(4118),
    [anon_sym_or] = ACTIONS(4118),
    [aux_sym_char_token1] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4118),
    [anon_sym_DQUOTE] = ACTIONS(4118),
    [anon_sym_AT_DQUOTE] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [sym_bool] = ACTIONS(4118),
    [sym_unit] = ACTIONS(4116),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4118),
    [sym_op_identifier] = ACTIONS(4118),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_PLUS_DOT] = ACTIONS(4118),
    [anon_sym_DASH_DOT] = ACTIONS(4118),
    [anon_sym_PERCENT] = ACTIONS(4118),
    [anon_sym_AMP_AMP] = ACTIONS(4118),
    [anon_sym_TILDE] = ACTIONS(4116),
    [aux_sym_prefix_op_token1] = ACTIONS(4118),
    [aux_sym_infix_op_token1] = ACTIONS(4116),
    [aux_sym_infix_op_token2] = ACTIONS(4118),
    [anon_sym_PIPE_PIPE] = ACTIONS(4118),
    [anon_sym_BANG_EQ] = ACTIONS(4118),
    [anon_sym_COLON_EQ] = ACTIONS(4116),
    [anon_sym_DOLLAR] = ACTIONS(4118),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4118),
    [sym_int] = ACTIONS(4118),
    [sym_xint] = ACTIONS(4116),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4116),
    [sym__newline] = ACTIONS(4116),
  },
  [3544] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(6505),
    [sym_function_declaration_left] = STATE(10033),
    [sym_value_declaration_left] = STATE(10033),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3544),
    [sym_compiler_directive_decl] = STATE(3544),
    [sym_fsi_directive_decl] = STATE(3544),
    [sym_preproc_line] = STATE(3544),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_rec] = ACTIONS(6018),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3545] = {
    [sym_block_comment] = STATE(3545),
    [sym_compiler_directive_decl] = STATE(3545),
    [sym_fsi_directive_decl] = STATE(3545),
    [sym_preproc_line] = STATE(3545),
    [sym_identifier] = ACTIONS(4104),
    [anon_sym_EQ] = ACTIONS(4102),
    [anon_sym_COLON] = ACTIONS(4104),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_do] = ACTIONS(4104),
    [anon_sym_let] = ACTIONS(4104),
    [anon_sym_let_BANG] = ACTIONS(4102),
    [anon_sym_LPAREN] = ACTIONS(4104),
    [anon_sym_COMMA] = ACTIONS(4102),
    [anon_sym_null] = ACTIONS(4104),
    [anon_sym_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_QMARK] = ACTIONS(4104),
    [anon_sym_COLON_COLON] = ACTIONS(4102),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4104),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4102),
    [anon_sym_LBRACE] = ACTIONS(4104),
    [anon_sym_LT_AT] = ACTIONS(4104),
    [anon_sym_AT_GT] = ACTIONS(4104),
    [anon_sym_LT_AT_AT] = ACTIONS(4104),
    [anon_sym_DOT] = ACTIONS(4104),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4102),
    [anon_sym_new] = ACTIONS(4104),
    [anon_sym_return_BANG] = ACTIONS(4102),
    [anon_sym_yield] = ACTIONS(4104),
    [anon_sym_yield_BANG] = ACTIONS(4102),
    [anon_sym_lazy] = ACTIONS(4104),
    [anon_sym_assert] = ACTIONS(4104),
    [anon_sym_upcast] = ACTIONS(4104),
    [anon_sym_downcast] = ACTIONS(4104),
    [anon_sym_COLON_GT] = ACTIONS(4102),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4102),
    [anon_sym_for] = ACTIONS(4104),
    [anon_sym_while] = ACTIONS(4104),
    [anon_sym_if] = ACTIONS(4104),
    [anon_sym_fun] = ACTIONS(4104),
    [anon_sym_try] = ACTIONS(4104),
    [anon_sym_match] = ACTIONS(4104),
    [anon_sym_match_BANG] = ACTIONS(4102),
    [anon_sym_function] = ACTIONS(4104),
    [anon_sym_LT_DASH] = ACTIONS(4104),
    [anon_sym_DOT_LBRACK] = ACTIONS(4102),
    [anon_sym_LT] = ACTIONS(4102),
    [anon_sym_use] = ACTIONS(4104),
    [anon_sym_use_BANG] = ACTIONS(4102),
    [anon_sym_do_BANG] = ACTIONS(4102),
    [anon_sym_begin] = ACTIONS(4104),
    [anon_sym_LPAREN2] = ACTIONS(4104),
    [anon_sym_or] = ACTIONS(4104),
    [aux_sym_char_token1] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4104),
    [anon_sym_DQUOTE] = ACTIONS(4104),
    [anon_sym_AT_DQUOTE] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [sym_bool] = ACTIONS(4104),
    [sym_unit] = ACTIONS(4102),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4104),
    [sym_op_identifier] = ACTIONS(4104),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_PLUS_DOT] = ACTIONS(4104),
    [anon_sym_DASH_DOT] = ACTIONS(4104),
    [anon_sym_PERCENT] = ACTIONS(4104),
    [anon_sym_AMP_AMP] = ACTIONS(4104),
    [anon_sym_TILDE] = ACTIONS(4102),
    [aux_sym_prefix_op_token1] = ACTIONS(4104),
    [aux_sym_infix_op_token1] = ACTIONS(4102),
    [aux_sym_infix_op_token2] = ACTIONS(4104),
    [anon_sym_PIPE_PIPE] = ACTIONS(4104),
    [anon_sym_BANG_EQ] = ACTIONS(4104),
    [anon_sym_COLON_EQ] = ACTIONS(4102),
    [anon_sym_DOLLAR] = ACTIONS(4104),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4104),
    [sym_int] = ACTIONS(4104),
    [sym_xint] = ACTIONS(4102),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4102),
    [sym__newline] = ACTIONS(4102),
  },
  [3546] = {
    [sym_block_comment] = STATE(3546),
    [sym_compiler_directive_decl] = STATE(3546),
    [sym_fsi_directive_decl] = STATE(3546),
    [sym_preproc_line] = STATE(3546),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3191),
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_QMARK] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_AT_GT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3193),
    [anon_sym_DOT] = ACTIONS(3193),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_COLON_GT] = ACTIONS(3191),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_LT_DASH] = ACTIONS(3193),
    [anon_sym_DOT_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_LPAREN2] = ACTIONS(3193),
    [anon_sym_or] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3193),
    [anon_sym_DASH_DOT] = ACTIONS(3193),
    [anon_sym_PERCENT] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3193),
    [aux_sym_infix_op_token1] = ACTIONS(3191),
    [aux_sym_infix_op_token2] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_BANG_EQ] = ACTIONS(3193),
    [anon_sym_COLON_EQ] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3193),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
    [sym__newline] = ACTIONS(3191),
  },
  [3547] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defns] = STATE(6507),
    [sym__function_or_value_defn_body] = STATE(6246),
    [sym_function_declaration_left] = STATE(9685),
    [sym_value_declaration_left] = STATE(9685),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3547),
    [sym_compiler_directive_decl] = STATE(3547),
    [sym_fsi_directive_decl] = STATE(3547),
    [sym_preproc_line] = STATE(3547),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3548] = {
    [sym_block_comment] = STATE(3548),
    [sym_compiler_directive_decl] = STATE(3548),
    [sym_fsi_directive_decl] = STATE(3548),
    [sym_preproc_line] = STATE(3548),
    [sym_identifier] = ACTIONS(4112),
    [anon_sym_EQ] = ACTIONS(4110),
    [anon_sym_COLON] = ACTIONS(4112),
    [anon_sym_return] = ACTIONS(4112),
    [anon_sym_do] = ACTIONS(4112),
    [anon_sym_let] = ACTIONS(4112),
    [anon_sym_let_BANG] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_null] = ACTIONS(4112),
    [anon_sym_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_QMARK] = ACTIONS(4112),
    [anon_sym_COLON_COLON] = ACTIONS(4110),
    [anon_sym_AMP] = ACTIONS(4112),
    [anon_sym_LBRACK] = ACTIONS(4112),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4110),
    [anon_sym_LBRACE] = ACTIONS(4112),
    [anon_sym_LT_AT] = ACTIONS(4112),
    [anon_sym_AT_GT] = ACTIONS(4112),
    [anon_sym_LT_AT_AT] = ACTIONS(4112),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4110),
    [anon_sym_new] = ACTIONS(4112),
    [anon_sym_return_BANG] = ACTIONS(4110),
    [anon_sym_yield] = ACTIONS(4112),
    [anon_sym_yield_BANG] = ACTIONS(4110),
    [anon_sym_lazy] = ACTIONS(4112),
    [anon_sym_assert] = ACTIONS(4112),
    [anon_sym_upcast] = ACTIONS(4112),
    [anon_sym_downcast] = ACTIONS(4112),
    [anon_sym_COLON_GT] = ACTIONS(4110),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4110),
    [anon_sym_for] = ACTIONS(4112),
    [anon_sym_while] = ACTIONS(4112),
    [anon_sym_if] = ACTIONS(4112),
    [anon_sym_fun] = ACTIONS(4112),
    [anon_sym_try] = ACTIONS(4112),
    [anon_sym_match] = ACTIONS(4112),
    [anon_sym_match_BANG] = ACTIONS(4110),
    [anon_sym_function] = ACTIONS(4112),
    [anon_sym_LT_DASH] = ACTIONS(4112),
    [anon_sym_DOT_LBRACK] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(4110),
    [anon_sym_use] = ACTIONS(4112),
    [anon_sym_use_BANG] = ACTIONS(4110),
    [anon_sym_do_BANG] = ACTIONS(4110),
    [anon_sym_begin] = ACTIONS(4112),
    [anon_sym_LPAREN2] = ACTIONS(4112),
    [anon_sym_or] = ACTIONS(4112),
    [aux_sym_char_token1] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4112),
    [anon_sym_DQUOTE] = ACTIONS(4112),
    [anon_sym_AT_DQUOTE] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [sym_bool] = ACTIONS(4112),
    [sym_unit] = ACTIONS(4110),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4112),
    [sym_op_identifier] = ACTIONS(4112),
    [anon_sym_PLUS] = ACTIONS(4112),
    [anon_sym_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_DOT] = ACTIONS(4112),
    [anon_sym_DASH_DOT] = ACTIONS(4112),
    [anon_sym_PERCENT] = ACTIONS(4112),
    [anon_sym_AMP_AMP] = ACTIONS(4112),
    [anon_sym_TILDE] = ACTIONS(4110),
    [aux_sym_prefix_op_token1] = ACTIONS(4112),
    [aux_sym_infix_op_token1] = ACTIONS(4110),
    [aux_sym_infix_op_token2] = ACTIONS(4112),
    [anon_sym_PIPE_PIPE] = ACTIONS(4112),
    [anon_sym_BANG_EQ] = ACTIONS(4112),
    [anon_sym_COLON_EQ] = ACTIONS(4110),
    [anon_sym_DOLLAR] = ACTIONS(4112),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4112),
    [sym_int] = ACTIONS(4112),
    [sym_xint] = ACTIONS(4110),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4110),
    [sym__newline] = ACTIONS(4110),
  },
  [3549] = {
    [sym_block_comment] = STATE(3549),
    [sym_compiler_directive_decl] = STATE(3549),
    [sym_fsi_directive_decl] = STATE(3549),
    [sym_preproc_line] = STATE(3549),
    [sym_identifier] = ACTIONS(4108),
    [anon_sym_EQ] = ACTIONS(4106),
    [anon_sym_COLON] = ACTIONS(4108),
    [anon_sym_return] = ACTIONS(4108),
    [anon_sym_do] = ACTIONS(4108),
    [anon_sym_let] = ACTIONS(4108),
    [anon_sym_let_BANG] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(4108),
    [anon_sym_COMMA] = ACTIONS(4106),
    [anon_sym_null] = ACTIONS(4108),
    [anon_sym_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_QMARK] = ACTIONS(4108),
    [anon_sym_COLON_COLON] = ACTIONS(4106),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LBRACK] = ACTIONS(4108),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(4108),
    [anon_sym_LT_AT] = ACTIONS(4108),
    [anon_sym_AT_GT] = ACTIONS(4108),
    [anon_sym_LT_AT_AT] = ACTIONS(4108),
    [anon_sym_DOT] = ACTIONS(4108),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4106),
    [anon_sym_new] = ACTIONS(4108),
    [anon_sym_return_BANG] = ACTIONS(4106),
    [anon_sym_yield] = ACTIONS(4108),
    [anon_sym_yield_BANG] = ACTIONS(4106),
    [anon_sym_lazy] = ACTIONS(4108),
    [anon_sym_assert] = ACTIONS(4108),
    [anon_sym_upcast] = ACTIONS(4108),
    [anon_sym_downcast] = ACTIONS(4108),
    [anon_sym_COLON_GT] = ACTIONS(4106),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4106),
    [anon_sym_for] = ACTIONS(4108),
    [anon_sym_while] = ACTIONS(4108),
    [anon_sym_if] = ACTIONS(4108),
    [anon_sym_fun] = ACTIONS(4108),
    [anon_sym_try] = ACTIONS(4108),
    [anon_sym_match] = ACTIONS(4108),
    [anon_sym_match_BANG] = ACTIONS(4106),
    [anon_sym_function] = ACTIONS(4108),
    [anon_sym_LT_DASH] = ACTIONS(4108),
    [anon_sym_DOT_LBRACK] = ACTIONS(4106),
    [anon_sym_LT] = ACTIONS(4106),
    [anon_sym_use] = ACTIONS(4108),
    [anon_sym_use_BANG] = ACTIONS(4106),
    [anon_sym_do_BANG] = ACTIONS(4106),
    [anon_sym_begin] = ACTIONS(4108),
    [anon_sym_LPAREN2] = ACTIONS(4108),
    [anon_sym_or] = ACTIONS(4108),
    [aux_sym_char_token1] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4108),
    [anon_sym_DQUOTE] = ACTIONS(4108),
    [anon_sym_AT_DQUOTE] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [sym_bool] = ACTIONS(4108),
    [sym_unit] = ACTIONS(4106),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4108),
    [sym_op_identifier] = ACTIONS(4108),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_PLUS_DOT] = ACTIONS(4108),
    [anon_sym_DASH_DOT] = ACTIONS(4108),
    [anon_sym_PERCENT] = ACTIONS(4108),
    [anon_sym_AMP_AMP] = ACTIONS(4108),
    [anon_sym_TILDE] = ACTIONS(4106),
    [aux_sym_prefix_op_token1] = ACTIONS(4108),
    [aux_sym_infix_op_token1] = ACTIONS(4106),
    [aux_sym_infix_op_token2] = ACTIONS(4108),
    [anon_sym_PIPE_PIPE] = ACTIONS(4108),
    [anon_sym_BANG_EQ] = ACTIONS(4108),
    [anon_sym_COLON_EQ] = ACTIONS(4106),
    [anon_sym_DOLLAR] = ACTIONS(4108),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4108),
    [sym_int] = ACTIONS(4108),
    [sym_xint] = ACTIONS(4106),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4106),
    [sym__newline] = ACTIONS(4106),
  },
  [3550] = {
    [sym_block_comment] = STATE(3550),
    [sym_compiler_directive_decl] = STATE(3550),
    [sym_fsi_directive_decl] = STATE(3550),
    [sym_preproc_line] = STATE(3550),
    [sym_identifier] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(4091),
    [anon_sym_COLON] = ACTIONS(4093),
    [anon_sym_return] = ACTIONS(4093),
    [anon_sym_do] = ACTIONS(4093),
    [anon_sym_let] = ACTIONS(4093),
    [anon_sym_let_BANG] = ACTIONS(4091),
    [anon_sym_LPAREN] = ACTIONS(4093),
    [anon_sym_COMMA] = ACTIONS(4091),
    [anon_sym_null] = ACTIONS(4093),
    [anon_sym_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_QMARK] = ACTIONS(4093),
    [anon_sym_COLON_COLON] = ACTIONS(4091),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(4093),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4091),
    [anon_sym_LBRACE] = ACTIONS(4093),
    [anon_sym_LT_AT] = ACTIONS(4093),
    [anon_sym_AT_GT] = ACTIONS(4093),
    [anon_sym_LT_AT_AT] = ACTIONS(4093),
    [anon_sym_DOT] = ACTIONS(4093),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4091),
    [anon_sym_new] = ACTIONS(4093),
    [anon_sym_return_BANG] = ACTIONS(4091),
    [anon_sym_yield] = ACTIONS(4093),
    [anon_sym_yield_BANG] = ACTIONS(4091),
    [anon_sym_lazy] = ACTIONS(4093),
    [anon_sym_assert] = ACTIONS(4093),
    [anon_sym_upcast] = ACTIONS(4093),
    [anon_sym_downcast] = ACTIONS(4093),
    [anon_sym_COLON_GT] = ACTIONS(4091),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4091),
    [anon_sym_for] = ACTIONS(4093),
    [anon_sym_while] = ACTIONS(4093),
    [anon_sym_if] = ACTIONS(4093),
    [anon_sym_fun] = ACTIONS(4093),
    [anon_sym_try] = ACTIONS(4093),
    [anon_sym_match] = ACTIONS(4093),
    [anon_sym_match_BANG] = ACTIONS(4091),
    [anon_sym_function] = ACTIONS(4093),
    [anon_sym_LT_DASH] = ACTIONS(4093),
    [anon_sym_DOT_LBRACK] = ACTIONS(4091),
    [anon_sym_LT] = ACTIONS(4091),
    [anon_sym_use] = ACTIONS(4093),
    [anon_sym_use_BANG] = ACTIONS(4091),
    [anon_sym_do_BANG] = ACTIONS(4091),
    [anon_sym_begin] = ACTIONS(4093),
    [anon_sym_LPAREN2] = ACTIONS(4093),
    [anon_sym_or] = ACTIONS(4093),
    [aux_sym_char_token1] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4093),
    [anon_sym_DQUOTE] = ACTIONS(4093),
    [anon_sym_AT_DQUOTE] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [sym_bool] = ACTIONS(4093),
    [sym_unit] = ACTIONS(4091),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4093),
    [sym_op_identifier] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS_DOT] = ACTIONS(4093),
    [anon_sym_DASH_DOT] = ACTIONS(4093),
    [anon_sym_PERCENT] = ACTIONS(4093),
    [anon_sym_AMP_AMP] = ACTIONS(4093),
    [anon_sym_TILDE] = ACTIONS(4091),
    [aux_sym_prefix_op_token1] = ACTIONS(4093),
    [aux_sym_infix_op_token1] = ACTIONS(4091),
    [aux_sym_infix_op_token2] = ACTIONS(4093),
    [anon_sym_PIPE_PIPE] = ACTIONS(4093),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_COLON_EQ] = ACTIONS(4091),
    [anon_sym_DOLLAR] = ACTIONS(4093),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4093),
    [sym_int] = ACTIONS(4093),
    [sym_xint] = ACTIONS(4091),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4091),
    [sym__newline] = ACTIONS(4091),
  },
  [3551] = {
    [sym_block_comment] = STATE(3551),
    [sym_compiler_directive_decl] = STATE(3551),
    [sym_fsi_directive_decl] = STATE(3551),
    [sym_preproc_line] = STATE(3551),
    [sym_identifier] = ACTIONS(4086),
    [anon_sym_EQ] = ACTIONS(4084),
    [anon_sym_COLON] = ACTIONS(4086),
    [anon_sym_return] = ACTIONS(4086),
    [anon_sym_do] = ACTIONS(4086),
    [anon_sym_let] = ACTIONS(4086),
    [anon_sym_let_BANG] = ACTIONS(4084),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_COMMA] = ACTIONS(4084),
    [anon_sym_null] = ACTIONS(4086),
    [anon_sym_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_QMARK] = ACTIONS(4086),
    [anon_sym_COLON_COLON] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4084),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_LT_AT] = ACTIONS(4086),
    [anon_sym_AT_GT] = ACTIONS(4086),
    [anon_sym_LT_AT_AT] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4086),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4084),
    [anon_sym_new] = ACTIONS(4086),
    [anon_sym_return_BANG] = ACTIONS(4084),
    [anon_sym_yield] = ACTIONS(4086),
    [anon_sym_yield_BANG] = ACTIONS(4084),
    [anon_sym_lazy] = ACTIONS(4086),
    [anon_sym_assert] = ACTIONS(4086),
    [anon_sym_upcast] = ACTIONS(4086),
    [anon_sym_downcast] = ACTIONS(4086),
    [anon_sym_COLON_GT] = ACTIONS(4084),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4084),
    [anon_sym_for] = ACTIONS(4086),
    [anon_sym_while] = ACTIONS(4086),
    [anon_sym_if] = ACTIONS(4086),
    [anon_sym_fun] = ACTIONS(4086),
    [anon_sym_try] = ACTIONS(4086),
    [anon_sym_match] = ACTIONS(4086),
    [anon_sym_match_BANG] = ACTIONS(4084),
    [anon_sym_function] = ACTIONS(4086),
    [anon_sym_LT_DASH] = ACTIONS(4086),
    [anon_sym_DOT_LBRACK] = ACTIONS(4084),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_use] = ACTIONS(4086),
    [anon_sym_use_BANG] = ACTIONS(4084),
    [anon_sym_do_BANG] = ACTIONS(4084),
    [anon_sym_begin] = ACTIONS(4086),
    [anon_sym_LPAREN2] = ACTIONS(4086),
    [anon_sym_or] = ACTIONS(4086),
    [aux_sym_char_token1] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4086),
    [anon_sym_DQUOTE] = ACTIONS(4086),
    [anon_sym_AT_DQUOTE] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [sym_bool] = ACTIONS(4086),
    [sym_unit] = ACTIONS(4084),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4086),
    [sym_op_identifier] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4086),
    [anon_sym_DASH] = ACTIONS(4086),
    [anon_sym_PLUS_DOT] = ACTIONS(4086),
    [anon_sym_DASH_DOT] = ACTIONS(4086),
    [anon_sym_PERCENT] = ACTIONS(4086),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_TILDE] = ACTIONS(4084),
    [aux_sym_prefix_op_token1] = ACTIONS(4086),
    [aux_sym_infix_op_token1] = ACTIONS(4084),
    [aux_sym_infix_op_token2] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_COLON_EQ] = ACTIONS(4084),
    [anon_sym_DOLLAR] = ACTIONS(4086),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4086),
    [sym_int] = ACTIONS(4086),
    [sym_xint] = ACTIONS(4084),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4084),
    [sym__newline] = ACTIONS(4084),
  },
  [3552] = {
    [sym_block_comment] = STATE(3552),
    [sym_compiler_directive_decl] = STATE(3552),
    [sym_fsi_directive_decl] = STATE(3552),
    [sym_preproc_line] = STATE(3552),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_COLON] = ACTIONS(4082),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_do] = ACTIONS(4082),
    [anon_sym_let] = ACTIONS(4082),
    [anon_sym_let_BANG] = ACTIONS(4080),
    [anon_sym_LPAREN] = ACTIONS(4082),
    [anon_sym_COMMA] = ACTIONS(4080),
    [anon_sym_null] = ACTIONS(4082),
    [anon_sym_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_COLON] = ACTIONS(4080),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_LBRACK] = ACTIONS(4082),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(4082),
    [anon_sym_LT_AT] = ACTIONS(4082),
    [anon_sym_AT_GT] = ACTIONS(4082),
    [anon_sym_LT_AT_AT] = ACTIONS(4082),
    [anon_sym_DOT] = ACTIONS(4082),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4080),
    [anon_sym_new] = ACTIONS(4082),
    [anon_sym_return_BANG] = ACTIONS(4080),
    [anon_sym_yield] = ACTIONS(4082),
    [anon_sym_yield_BANG] = ACTIONS(4080),
    [anon_sym_lazy] = ACTIONS(4082),
    [anon_sym_assert] = ACTIONS(4082),
    [anon_sym_upcast] = ACTIONS(4082),
    [anon_sym_downcast] = ACTIONS(4082),
    [anon_sym_COLON_GT] = ACTIONS(4080),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4080),
    [anon_sym_for] = ACTIONS(4082),
    [anon_sym_while] = ACTIONS(4082),
    [anon_sym_if] = ACTIONS(4082),
    [anon_sym_fun] = ACTIONS(4082),
    [anon_sym_try] = ACTIONS(4082),
    [anon_sym_match] = ACTIONS(4082),
    [anon_sym_match_BANG] = ACTIONS(4080),
    [anon_sym_function] = ACTIONS(4082),
    [anon_sym_LT_DASH] = ACTIONS(4082),
    [anon_sym_DOT_LBRACK] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(4080),
    [anon_sym_use] = ACTIONS(4082),
    [anon_sym_use_BANG] = ACTIONS(4080),
    [anon_sym_do_BANG] = ACTIONS(4080),
    [anon_sym_begin] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4082),
    [anon_sym_or] = ACTIONS(4082),
    [aux_sym_char_token1] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4082),
    [anon_sym_DQUOTE] = ACTIONS(4082),
    [anon_sym_AT_DQUOTE] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [sym_bool] = ACTIONS(4082),
    [sym_unit] = ACTIONS(4080),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4082),
    [sym_op_identifier] = ACTIONS(4082),
    [anon_sym_PLUS] = ACTIONS(4082),
    [anon_sym_DASH] = ACTIONS(4082),
    [anon_sym_PLUS_DOT] = ACTIONS(4082),
    [anon_sym_DASH_DOT] = ACTIONS(4082),
    [anon_sym_PERCENT] = ACTIONS(4082),
    [anon_sym_AMP_AMP] = ACTIONS(4082),
    [anon_sym_TILDE] = ACTIONS(4080),
    [aux_sym_prefix_op_token1] = ACTIONS(4082),
    [aux_sym_infix_op_token1] = ACTIONS(4080),
    [aux_sym_infix_op_token2] = ACTIONS(4082),
    [anon_sym_PIPE_PIPE] = ACTIONS(4082),
    [anon_sym_BANG_EQ] = ACTIONS(4082),
    [anon_sym_COLON_EQ] = ACTIONS(4080),
    [anon_sym_DOLLAR] = ACTIONS(4082),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4082),
    [sym_int] = ACTIONS(4082),
    [sym_xint] = ACTIONS(4080),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4080),
    [sym__newline] = ACTIONS(4080),
  },
  [3553] = {
    [sym_block_comment] = STATE(3553),
    [sym_compiler_directive_decl] = STATE(3553),
    [sym_fsi_directive_decl] = STATE(3553),
    [sym_preproc_line] = STATE(3553),
    [sym_identifier] = ACTIONS(3881),
    [anon_sym_EQ] = ACTIONS(3879),
    [anon_sym_COLON] = ACTIONS(3881),
    [anon_sym_return] = ACTIONS(3881),
    [anon_sym_do] = ACTIONS(3881),
    [anon_sym_let] = ACTIONS(3881),
    [anon_sym_let_BANG] = ACTIONS(3879),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [anon_sym_COMMA] = ACTIONS(3879),
    [anon_sym_null] = ACTIONS(3881),
    [anon_sym_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3879),
    [anon_sym_LBRACE] = ACTIONS(3881),
    [anon_sym_LT_AT] = ACTIONS(3881),
    [anon_sym_LT_AT_AT] = ACTIONS(3881),
    [anon_sym_DOT] = ACTIONS(3881),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3879),
    [anon_sym_new] = ACTIONS(3881),
    [anon_sym_return_BANG] = ACTIONS(3879),
    [anon_sym_yield] = ACTIONS(3881),
    [anon_sym_yield_BANG] = ACTIONS(3879),
    [anon_sym_lazy] = ACTIONS(3881),
    [anon_sym_assert] = ACTIONS(3881),
    [anon_sym_upcast] = ACTIONS(3881),
    [anon_sym_downcast] = ACTIONS(3881),
    [anon_sym_COLON_GT] = ACTIONS(3879),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3879),
    [anon_sym_for] = ACTIONS(3881),
    [anon_sym_while] = ACTIONS(3881),
    [anon_sym_if] = ACTIONS(3881),
    [anon_sym_fun] = ACTIONS(3881),
    [anon_sym_try] = ACTIONS(3881),
    [anon_sym_match] = ACTIONS(3881),
    [anon_sym_match_BANG] = ACTIONS(3879),
    [anon_sym_function] = ACTIONS(3881),
    [anon_sym_LT_DASH] = ACTIONS(3881),
    [anon_sym_DOT_LBRACK] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_GT] = ACTIONS(3881),
    [anon_sym_use] = ACTIONS(3881),
    [anon_sym_use_BANG] = ACTIONS(3879),
    [anon_sym_do_BANG] = ACTIONS(3879),
    [anon_sym_begin] = ACTIONS(3881),
    [anon_sym_LPAREN2] = ACTIONS(3881),
    [anon_sym_or] = ACTIONS(3881),
    [aux_sym_char_token1] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3881),
    [anon_sym_DQUOTE] = ACTIONS(3881),
    [anon_sym_AT_DQUOTE] = ACTIONS(3879),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3879),
    [sym_bool] = ACTIONS(3881),
    [sym_unit] = ACTIONS(3879),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3881),
    [sym_op_identifier] = ACTIONS(3881),
    [anon_sym_PLUS] = ACTIONS(3881),
    [anon_sym_DASH] = ACTIONS(3881),
    [anon_sym_PLUS_DOT] = ACTIONS(3881),
    [anon_sym_DASH_DOT] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(3881),
    [anon_sym_AMP_AMP] = ACTIONS(3881),
    [anon_sym_TILDE] = ACTIONS(3879),
    [aux_sym_prefix_op_token1] = ACTIONS(3881),
    [aux_sym_infix_op_token1] = ACTIONS(3879),
    [aux_sym_infix_op_token2] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE] = ACTIONS(3881),
    [anon_sym_BANG_EQ] = ACTIONS(3881),
    [anon_sym_COLON_EQ] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3881),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3881),
    [sym_int] = ACTIONS(3881),
    [sym_xint] = ACTIONS(3879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3879),
    [sym__newline] = ACTIONS(3879),
  },
  [3554] = {
    [sym_block_comment] = STATE(3554),
    [sym_compiler_directive_decl] = STATE(3554),
    [sym_fsi_directive_decl] = STATE(3554),
    [sym_preproc_line] = STATE(3554),
    [sym_identifier] = ACTIONS(4054),
    [anon_sym_EQ] = ACTIONS(4052),
    [anon_sym_COLON] = ACTIONS(4054),
    [anon_sym_return] = ACTIONS(4054),
    [anon_sym_do] = ACTIONS(4054),
    [anon_sym_let] = ACTIONS(4054),
    [anon_sym_let_BANG] = ACTIONS(4052),
    [anon_sym_LPAREN] = ACTIONS(4054),
    [anon_sym_COMMA] = ACTIONS(4052),
    [anon_sym_null] = ACTIONS(4054),
    [anon_sym_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_COLON] = ACTIONS(4052),
    [anon_sym_AMP] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(4054),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4052),
    [anon_sym_LBRACE] = ACTIONS(4054),
    [anon_sym_LT_AT] = ACTIONS(4054),
    [anon_sym_AT_GT] = ACTIONS(4054),
    [anon_sym_LT_AT_AT] = ACTIONS(4054),
    [anon_sym_DOT] = ACTIONS(4054),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_return_BANG] = ACTIONS(4052),
    [anon_sym_yield] = ACTIONS(4054),
    [anon_sym_yield_BANG] = ACTIONS(4052),
    [anon_sym_lazy] = ACTIONS(4054),
    [anon_sym_assert] = ACTIONS(4054),
    [anon_sym_upcast] = ACTIONS(4054),
    [anon_sym_downcast] = ACTIONS(4054),
    [anon_sym_COLON_GT] = ACTIONS(4052),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4052),
    [anon_sym_for] = ACTIONS(4054),
    [anon_sym_while] = ACTIONS(4054),
    [anon_sym_if] = ACTIONS(4054),
    [anon_sym_fun] = ACTIONS(4054),
    [anon_sym_try] = ACTIONS(4054),
    [anon_sym_match] = ACTIONS(4054),
    [anon_sym_match_BANG] = ACTIONS(4052),
    [anon_sym_function] = ACTIONS(4054),
    [anon_sym_LT_DASH] = ACTIONS(4054),
    [anon_sym_DOT_LBRACK] = ACTIONS(4052),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_use] = ACTIONS(4054),
    [anon_sym_use_BANG] = ACTIONS(4052),
    [anon_sym_do_BANG] = ACTIONS(4052),
    [anon_sym_begin] = ACTIONS(4054),
    [anon_sym_LPAREN2] = ACTIONS(4054),
    [anon_sym_or] = ACTIONS(4054),
    [aux_sym_char_token1] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4054),
    [anon_sym_DQUOTE] = ACTIONS(4054),
    [anon_sym_AT_DQUOTE] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [sym_bool] = ACTIONS(4054),
    [sym_unit] = ACTIONS(4052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4054),
    [sym_op_identifier] = ACTIONS(4054),
    [anon_sym_PLUS] = ACTIONS(4054),
    [anon_sym_DASH] = ACTIONS(4054),
    [anon_sym_PLUS_DOT] = ACTIONS(4054),
    [anon_sym_DASH_DOT] = ACTIONS(4054),
    [anon_sym_PERCENT] = ACTIONS(4054),
    [anon_sym_AMP_AMP] = ACTIONS(4054),
    [anon_sym_TILDE] = ACTIONS(4052),
    [aux_sym_prefix_op_token1] = ACTIONS(4054),
    [aux_sym_infix_op_token1] = ACTIONS(4052),
    [aux_sym_infix_op_token2] = ACTIONS(4054),
    [anon_sym_PIPE_PIPE] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4054),
    [anon_sym_COLON_EQ] = ACTIONS(4052),
    [anon_sym_DOLLAR] = ACTIONS(4054),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4054),
    [sym_int] = ACTIONS(4054),
    [sym_xint] = ACTIONS(4052),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4052),
    [sym__newline] = ACTIONS(4052),
  },
  [3555] = {
    [sym_block_comment] = STATE(3555),
    [sym_compiler_directive_decl] = STATE(3555),
    [sym_fsi_directive_decl] = STATE(3555),
    [sym_preproc_line] = STATE(3555),
    [sym_identifier] = ACTIONS(4018),
    [anon_sym_EQ] = ACTIONS(4016),
    [anon_sym_COLON] = ACTIONS(4018),
    [anon_sym_return] = ACTIONS(4018),
    [anon_sym_do] = ACTIONS(4018),
    [anon_sym_let] = ACTIONS(4018),
    [anon_sym_let_BANG] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(4018),
    [anon_sym_COMMA] = ACTIONS(4016),
    [anon_sym_null] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_COLON] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4018),
    [anon_sym_LBRACK] = ACTIONS(4018),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4016),
    [anon_sym_LBRACE] = ACTIONS(4018),
    [anon_sym_LT_AT] = ACTIONS(4018),
    [anon_sym_AT_GT] = ACTIONS(4018),
    [anon_sym_LT_AT_AT] = ACTIONS(4018),
    [anon_sym_DOT] = ACTIONS(4018),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4016),
    [anon_sym_new] = ACTIONS(4018),
    [anon_sym_return_BANG] = ACTIONS(4016),
    [anon_sym_yield] = ACTIONS(4018),
    [anon_sym_yield_BANG] = ACTIONS(4016),
    [anon_sym_lazy] = ACTIONS(4018),
    [anon_sym_assert] = ACTIONS(4018),
    [anon_sym_upcast] = ACTIONS(4018),
    [anon_sym_downcast] = ACTIONS(4018),
    [anon_sym_COLON_GT] = ACTIONS(4016),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4016),
    [anon_sym_for] = ACTIONS(4018),
    [anon_sym_while] = ACTIONS(4018),
    [anon_sym_if] = ACTIONS(4018),
    [anon_sym_fun] = ACTIONS(4018),
    [anon_sym_try] = ACTIONS(4018),
    [anon_sym_match] = ACTIONS(4018),
    [anon_sym_match_BANG] = ACTIONS(4016),
    [anon_sym_function] = ACTIONS(4018),
    [anon_sym_LT_DASH] = ACTIONS(4018),
    [anon_sym_DOT_LBRACK] = ACTIONS(4016),
    [anon_sym_LT] = ACTIONS(4016),
    [anon_sym_use] = ACTIONS(4018),
    [anon_sym_use_BANG] = ACTIONS(4016),
    [anon_sym_do_BANG] = ACTIONS(4016),
    [anon_sym_begin] = ACTIONS(4018),
    [anon_sym_LPAREN2] = ACTIONS(4018),
    [anon_sym_or] = ACTIONS(4018),
    [aux_sym_char_token1] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(4018),
    [anon_sym_AT_DQUOTE] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [sym_bool] = ACTIONS(4018),
    [sym_unit] = ACTIONS(4016),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4018),
    [sym_op_identifier] = ACTIONS(4018),
    [anon_sym_PLUS] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_PLUS_DOT] = ACTIONS(4018),
    [anon_sym_DASH_DOT] = ACTIONS(4018),
    [anon_sym_PERCENT] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4016),
    [aux_sym_prefix_op_token1] = ACTIONS(4018),
    [aux_sym_infix_op_token1] = ACTIONS(4016),
    [aux_sym_infix_op_token2] = ACTIONS(4018),
    [anon_sym_PIPE_PIPE] = ACTIONS(4018),
    [anon_sym_BANG_EQ] = ACTIONS(4018),
    [anon_sym_COLON_EQ] = ACTIONS(4016),
    [anon_sym_DOLLAR] = ACTIONS(4018),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4018),
    [sym_int] = ACTIONS(4018),
    [sym_xint] = ACTIONS(4016),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4016),
    [sym__newline] = ACTIONS(4016),
  },
  [3556] = {
    [sym_block_comment] = STATE(3556),
    [sym_compiler_directive_decl] = STATE(3556),
    [sym_fsi_directive_decl] = STATE(3556),
    [sym_preproc_line] = STATE(3556),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3843),
    [anon_sym_COLON] = ACTIONS(3845),
    [anon_sym_return] = ACTIONS(3845),
    [anon_sym_do] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_let_BANG] = ACTIONS(3843),
    [anon_sym_LPAREN] = ACTIONS(3845),
    [anon_sym_COMMA] = ACTIONS(3843),
    [anon_sym_null] = ACTIONS(3845),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_QMARK] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3843),
    [anon_sym_LBRACE] = ACTIONS(3845),
    [anon_sym_LT_AT] = ACTIONS(3845),
    [anon_sym_AT_GT] = ACTIONS(3845),
    [anon_sym_LT_AT_AT] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3843),
    [anon_sym_new] = ACTIONS(3845),
    [anon_sym_return_BANG] = ACTIONS(3843),
    [anon_sym_yield] = ACTIONS(3845),
    [anon_sym_yield_BANG] = ACTIONS(3843),
    [anon_sym_lazy] = ACTIONS(3845),
    [anon_sym_assert] = ACTIONS(3845),
    [anon_sym_upcast] = ACTIONS(3845),
    [anon_sym_downcast] = ACTIONS(3845),
    [anon_sym_COLON_GT] = ACTIONS(3843),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3843),
    [anon_sym_for] = ACTIONS(3845),
    [anon_sym_while] = ACTIONS(3845),
    [anon_sym_if] = ACTIONS(3845),
    [anon_sym_fun] = ACTIONS(3845),
    [anon_sym_try] = ACTIONS(3845),
    [anon_sym_match] = ACTIONS(3845),
    [anon_sym_match_BANG] = ACTIONS(3843),
    [anon_sym_function] = ACTIONS(3845),
    [anon_sym_LT_DASH] = ACTIONS(3845),
    [anon_sym_DOT_LBRACK] = ACTIONS(3843),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_use] = ACTIONS(3845),
    [anon_sym_use_BANG] = ACTIONS(3843),
    [anon_sym_do_BANG] = ACTIONS(3843),
    [anon_sym_begin] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(3845),
    [anon_sym_or] = ACTIONS(3845),
    [aux_sym_char_token1] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3845),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_AT_DQUOTE] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [sym_bool] = ACTIONS(3845),
    [sym_unit] = ACTIONS(3843),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3845),
    [sym_op_identifier] = ACTIONS(3845),
    [anon_sym_PLUS] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_PLUS_DOT] = ACTIONS(3845),
    [anon_sym_DASH_DOT] = ACTIONS(3845),
    [anon_sym_PERCENT] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3845),
    [anon_sym_TILDE] = ACTIONS(3843),
    [aux_sym_prefix_op_token1] = ACTIONS(3845),
    [aux_sym_infix_op_token1] = ACTIONS(3843),
    [aux_sym_infix_op_token2] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(3845),
    [anon_sym_BANG_EQ] = ACTIONS(3845),
    [anon_sym_COLON_EQ] = ACTIONS(3843),
    [anon_sym_DOLLAR] = ACTIONS(3845),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3845),
    [sym_int] = ACTIONS(3845),
    [sym_xint] = ACTIONS(3843),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3843),
    [sym__newline] = ACTIONS(3843),
  },
  [3557] = {
    [sym_block_comment] = STATE(3557),
    [sym_compiler_directive_decl] = STATE(3557),
    [sym_fsi_directive_decl] = STATE(3557),
    [sym_preproc_line] = STATE(3557),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_EQ] = ACTIONS(4001),
    [anon_sym_COLON] = ACTIONS(4003),
    [anon_sym_return] = ACTIONS(4003),
    [anon_sym_do] = ACTIONS(4003),
    [anon_sym_let] = ACTIONS(4003),
    [anon_sym_let_BANG] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4003),
    [anon_sym_COMMA] = ACTIONS(4001),
    [anon_sym_null] = ACTIONS(4003),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_COLON] = ACTIONS(4001),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LBRACK] = ACTIONS(4003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4001),
    [anon_sym_LBRACE] = ACTIONS(4003),
    [anon_sym_LT_AT] = ACTIONS(4003),
    [anon_sym_AT_GT] = ACTIONS(4003),
    [anon_sym_LT_AT_AT] = ACTIONS(4003),
    [anon_sym_DOT] = ACTIONS(4003),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4001),
    [anon_sym_new] = ACTIONS(4003),
    [anon_sym_return_BANG] = ACTIONS(4001),
    [anon_sym_yield] = ACTIONS(4003),
    [anon_sym_yield_BANG] = ACTIONS(4001),
    [anon_sym_lazy] = ACTIONS(4003),
    [anon_sym_assert] = ACTIONS(4003),
    [anon_sym_upcast] = ACTIONS(4003),
    [anon_sym_downcast] = ACTIONS(4003),
    [anon_sym_COLON_GT] = ACTIONS(4001),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4001),
    [anon_sym_for] = ACTIONS(4003),
    [anon_sym_while] = ACTIONS(4003),
    [anon_sym_if] = ACTIONS(4003),
    [anon_sym_fun] = ACTIONS(4003),
    [anon_sym_try] = ACTIONS(4003),
    [anon_sym_match] = ACTIONS(4003),
    [anon_sym_match_BANG] = ACTIONS(4001),
    [anon_sym_function] = ACTIONS(4003),
    [anon_sym_LT_DASH] = ACTIONS(4003),
    [anon_sym_DOT_LBRACK] = ACTIONS(4001),
    [anon_sym_LT] = ACTIONS(4001),
    [anon_sym_use] = ACTIONS(4003),
    [anon_sym_use_BANG] = ACTIONS(4001),
    [anon_sym_do_BANG] = ACTIONS(4001),
    [anon_sym_begin] = ACTIONS(4003),
    [anon_sym_LPAREN2] = ACTIONS(4003),
    [anon_sym_or] = ACTIONS(4003),
    [aux_sym_char_token1] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4003),
    [anon_sym_DQUOTE] = ACTIONS(4003),
    [anon_sym_AT_DQUOTE] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [sym_bool] = ACTIONS(4003),
    [sym_unit] = ACTIONS(4001),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4003),
    [sym_op_identifier] = ACTIONS(4003),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_PLUS_DOT] = ACTIONS(4003),
    [anon_sym_DASH_DOT] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4003),
    [anon_sym_AMP_AMP] = ACTIONS(4003),
    [anon_sym_TILDE] = ACTIONS(4001),
    [aux_sym_prefix_op_token1] = ACTIONS(4003),
    [aux_sym_infix_op_token1] = ACTIONS(4001),
    [aux_sym_infix_op_token2] = ACTIONS(4003),
    [anon_sym_PIPE_PIPE] = ACTIONS(4003),
    [anon_sym_BANG_EQ] = ACTIONS(4003),
    [anon_sym_COLON_EQ] = ACTIONS(4001),
    [anon_sym_DOLLAR] = ACTIONS(4003),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4003),
    [sym_int] = ACTIONS(4003),
    [sym_xint] = ACTIONS(4001),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4001),
    [sym__newline] = ACTIONS(4001),
  },
  [3558] = {
    [sym_block_comment] = STATE(3558),
    [sym_compiler_directive_decl] = STATE(3558),
    [sym_fsi_directive_decl] = STATE(3558),
    [sym_preproc_line] = STATE(3558),
    [sym_identifier] = ACTIONS(4064),
    [anon_sym_EQ] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4064),
    [anon_sym_return] = ACTIONS(4064),
    [anon_sym_do] = ACTIONS(4064),
    [anon_sym_let] = ACTIONS(4064),
    [anon_sym_let_BANG] = ACTIONS(4062),
    [anon_sym_LPAREN] = ACTIONS(4064),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_null] = ACTIONS(4064),
    [anon_sym_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_QMARK] = ACTIONS(4064),
    [anon_sym_COLON_COLON] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4062),
    [anon_sym_LBRACE] = ACTIONS(4064),
    [anon_sym_LT_AT] = ACTIONS(4064),
    [anon_sym_AT_GT] = ACTIONS(4064),
    [anon_sym_LT_AT_AT] = ACTIONS(4064),
    [anon_sym_DOT] = ACTIONS(4064),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4062),
    [anon_sym_new] = ACTIONS(4064),
    [anon_sym_return_BANG] = ACTIONS(4062),
    [anon_sym_yield] = ACTIONS(4064),
    [anon_sym_yield_BANG] = ACTIONS(4062),
    [anon_sym_lazy] = ACTIONS(4064),
    [anon_sym_assert] = ACTIONS(4064),
    [anon_sym_upcast] = ACTIONS(4064),
    [anon_sym_downcast] = ACTIONS(4064),
    [anon_sym_COLON_GT] = ACTIONS(4062),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4062),
    [anon_sym_for] = ACTIONS(4064),
    [anon_sym_while] = ACTIONS(4064),
    [anon_sym_if] = ACTIONS(4064),
    [anon_sym_fun] = ACTIONS(4064),
    [anon_sym_try] = ACTIONS(4064),
    [anon_sym_match] = ACTIONS(4064),
    [anon_sym_match_BANG] = ACTIONS(4062),
    [anon_sym_function] = ACTIONS(4064),
    [anon_sym_LT_DASH] = ACTIONS(4064),
    [anon_sym_DOT_LBRACK] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(4062),
    [anon_sym_use] = ACTIONS(4064),
    [anon_sym_use_BANG] = ACTIONS(4062),
    [anon_sym_do_BANG] = ACTIONS(4062),
    [anon_sym_begin] = ACTIONS(4064),
    [anon_sym_LPAREN2] = ACTIONS(4064),
    [anon_sym_or] = ACTIONS(4064),
    [aux_sym_char_token1] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_AT_DQUOTE] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [sym_bool] = ACTIONS(4064),
    [sym_unit] = ACTIONS(4062),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4064),
    [sym_op_identifier] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4064),
    [anon_sym_DASH] = ACTIONS(4064),
    [anon_sym_PLUS_DOT] = ACTIONS(4064),
    [anon_sym_DASH_DOT] = ACTIONS(4064),
    [anon_sym_PERCENT] = ACTIONS(4064),
    [anon_sym_AMP_AMP] = ACTIONS(4064),
    [anon_sym_TILDE] = ACTIONS(4062),
    [aux_sym_prefix_op_token1] = ACTIONS(4064),
    [aux_sym_infix_op_token1] = ACTIONS(4062),
    [aux_sym_infix_op_token2] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4064),
    [anon_sym_BANG_EQ] = ACTIONS(4064),
    [anon_sym_COLON_EQ] = ACTIONS(4062),
    [anon_sym_DOLLAR] = ACTIONS(4064),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4064),
    [sym_int] = ACTIONS(4064),
    [sym_xint] = ACTIONS(4062),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4062),
    [sym__newline] = ACTIONS(4062),
  },
  [3559] = {
    [sym_block_comment] = STATE(3559),
    [sym_compiler_directive_decl] = STATE(3559),
    [sym_fsi_directive_decl] = STATE(3559),
    [sym_preproc_line] = STATE(3559),
    [sym_identifier] = ACTIONS(3996),
    [anon_sym_EQ] = ACTIONS(3994),
    [anon_sym_COLON] = ACTIONS(3996),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_do] = ACTIONS(3996),
    [anon_sym_let] = ACTIONS(3996),
    [anon_sym_let_BANG] = ACTIONS(3994),
    [anon_sym_LPAREN] = ACTIONS(3996),
    [anon_sym_COMMA] = ACTIONS(3994),
    [anon_sym_null] = ACTIONS(3996),
    [anon_sym_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_QMARK] = ACTIONS(3996),
    [anon_sym_COLON_COLON] = ACTIONS(3994),
    [anon_sym_AMP] = ACTIONS(3996),
    [anon_sym_LBRACK] = ACTIONS(3996),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3994),
    [anon_sym_LBRACE] = ACTIONS(3996),
    [anon_sym_LT_AT] = ACTIONS(3996),
    [anon_sym_AT_GT] = ACTIONS(3996),
    [anon_sym_LT_AT_AT] = ACTIONS(3996),
    [anon_sym_DOT] = ACTIONS(3996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3994),
    [anon_sym_new] = ACTIONS(3996),
    [anon_sym_return_BANG] = ACTIONS(3994),
    [anon_sym_yield] = ACTIONS(3996),
    [anon_sym_yield_BANG] = ACTIONS(3994),
    [anon_sym_lazy] = ACTIONS(3996),
    [anon_sym_assert] = ACTIONS(3996),
    [anon_sym_upcast] = ACTIONS(3996),
    [anon_sym_downcast] = ACTIONS(3996),
    [anon_sym_COLON_GT] = ACTIONS(3994),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3994),
    [anon_sym_for] = ACTIONS(3996),
    [anon_sym_while] = ACTIONS(3996),
    [anon_sym_if] = ACTIONS(3996),
    [anon_sym_fun] = ACTIONS(3996),
    [anon_sym_try] = ACTIONS(3996),
    [anon_sym_match] = ACTIONS(3996),
    [anon_sym_match_BANG] = ACTIONS(3994),
    [anon_sym_function] = ACTIONS(3996),
    [anon_sym_LT_DASH] = ACTIONS(3996),
    [anon_sym_DOT_LBRACK] = ACTIONS(3994),
    [anon_sym_LT] = ACTIONS(3994),
    [anon_sym_use] = ACTIONS(3996),
    [anon_sym_use_BANG] = ACTIONS(3994),
    [anon_sym_do_BANG] = ACTIONS(3994),
    [anon_sym_begin] = ACTIONS(3996),
    [anon_sym_LPAREN2] = ACTIONS(3996),
    [anon_sym_or] = ACTIONS(3996),
    [aux_sym_char_token1] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3996),
    [anon_sym_DQUOTE] = ACTIONS(3996),
    [anon_sym_AT_DQUOTE] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [sym_bool] = ACTIONS(3996),
    [sym_unit] = ACTIONS(3994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3996),
    [sym_op_identifier] = ACTIONS(3996),
    [anon_sym_PLUS] = ACTIONS(3996),
    [anon_sym_DASH] = ACTIONS(3996),
    [anon_sym_PLUS_DOT] = ACTIONS(3996),
    [anon_sym_DASH_DOT] = ACTIONS(3996),
    [anon_sym_PERCENT] = ACTIONS(3996),
    [anon_sym_AMP_AMP] = ACTIONS(3996),
    [anon_sym_TILDE] = ACTIONS(3994),
    [aux_sym_prefix_op_token1] = ACTIONS(3996),
    [aux_sym_infix_op_token1] = ACTIONS(3994),
    [aux_sym_infix_op_token2] = ACTIONS(3996),
    [anon_sym_PIPE_PIPE] = ACTIONS(3996),
    [anon_sym_BANG_EQ] = ACTIONS(3996),
    [anon_sym_COLON_EQ] = ACTIONS(3994),
    [anon_sym_DOLLAR] = ACTIONS(3996),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3996),
    [sym_int] = ACTIONS(3996),
    [sym_xint] = ACTIONS(3994),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3994),
    [sym__newline] = ACTIONS(3994),
  },
  [3560] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(11204),
    [sym_function_declaration_left] = STATE(9757),
    [sym_value_declaration_left] = STATE(9757),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3560),
    [sym_compiler_directive_decl] = STATE(3560),
    [sym_fsi_directive_decl] = STATE(3560),
    [sym_preproc_line] = STATE(3560),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_rec] = ACTIONS(6020),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3561] = {
    [sym_block_comment] = STATE(3561),
    [sym_compiler_directive_decl] = STATE(3561),
    [sym_fsi_directive_decl] = STATE(3561),
    [sym_preproc_line] = STATE(3561),
    [sym_identifier] = ACTIONS(3972),
    [anon_sym_EQ] = ACTIONS(3970),
    [anon_sym_COLON] = ACTIONS(3972),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_do] = ACTIONS(3972),
    [anon_sym_let] = ACTIONS(3972),
    [anon_sym_let_BANG] = ACTIONS(3970),
    [anon_sym_LPAREN] = ACTIONS(3972),
    [anon_sym_COMMA] = ACTIONS(3970),
    [anon_sym_null] = ACTIONS(3972),
    [anon_sym_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_COLON] = ACTIONS(3970),
    [anon_sym_AMP] = ACTIONS(3972),
    [anon_sym_LBRACK] = ACTIONS(3972),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3970),
    [anon_sym_LBRACE] = ACTIONS(3972),
    [anon_sym_LT_AT] = ACTIONS(3972),
    [anon_sym_AT_GT] = ACTIONS(3972),
    [anon_sym_LT_AT_AT] = ACTIONS(3972),
    [anon_sym_DOT] = ACTIONS(3972),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3970),
    [anon_sym_new] = ACTIONS(3972),
    [anon_sym_return_BANG] = ACTIONS(3970),
    [anon_sym_yield] = ACTIONS(3972),
    [anon_sym_yield_BANG] = ACTIONS(3970),
    [anon_sym_lazy] = ACTIONS(3972),
    [anon_sym_assert] = ACTIONS(3972),
    [anon_sym_upcast] = ACTIONS(3972),
    [anon_sym_downcast] = ACTIONS(3972),
    [anon_sym_COLON_GT] = ACTIONS(3970),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3970),
    [anon_sym_for] = ACTIONS(3972),
    [anon_sym_while] = ACTIONS(3972),
    [anon_sym_if] = ACTIONS(3972),
    [anon_sym_fun] = ACTIONS(3972),
    [anon_sym_try] = ACTIONS(3972),
    [anon_sym_match] = ACTIONS(3972),
    [anon_sym_match_BANG] = ACTIONS(3970),
    [anon_sym_function] = ACTIONS(3972),
    [anon_sym_LT_DASH] = ACTIONS(3972),
    [anon_sym_DOT_LBRACK] = ACTIONS(3970),
    [anon_sym_LT] = ACTIONS(3970),
    [anon_sym_use] = ACTIONS(3972),
    [anon_sym_use_BANG] = ACTIONS(3970),
    [anon_sym_do_BANG] = ACTIONS(3970),
    [anon_sym_begin] = ACTIONS(3972),
    [anon_sym_LPAREN2] = ACTIONS(3972),
    [anon_sym_or] = ACTIONS(3972),
    [aux_sym_char_token1] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3972),
    [anon_sym_DQUOTE] = ACTIONS(3972),
    [anon_sym_AT_DQUOTE] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [sym_bool] = ACTIONS(3972),
    [sym_unit] = ACTIONS(3970),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3972),
    [sym_op_identifier] = ACTIONS(3972),
    [anon_sym_PLUS] = ACTIONS(3972),
    [anon_sym_DASH] = ACTIONS(3972),
    [anon_sym_PLUS_DOT] = ACTIONS(3972),
    [anon_sym_DASH_DOT] = ACTIONS(3972),
    [anon_sym_PERCENT] = ACTIONS(3972),
    [anon_sym_AMP_AMP] = ACTIONS(3972),
    [anon_sym_TILDE] = ACTIONS(3970),
    [aux_sym_prefix_op_token1] = ACTIONS(3972),
    [aux_sym_infix_op_token1] = ACTIONS(3970),
    [aux_sym_infix_op_token2] = ACTIONS(3972),
    [anon_sym_PIPE_PIPE] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3972),
    [anon_sym_COLON_EQ] = ACTIONS(3970),
    [anon_sym_DOLLAR] = ACTIONS(3972),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3972),
    [sym_int] = ACTIONS(3972),
    [sym_xint] = ACTIONS(3970),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3970),
    [sym__newline] = ACTIONS(3970),
  },
  [3562] = {
    [sym_block_comment] = STATE(3562),
    [sym_compiler_directive_decl] = STATE(3562),
    [sym_fsi_directive_decl] = STATE(3562),
    [sym_preproc_line] = STATE(3562),
    [sym_identifier] = ACTIONS(4100),
    [anon_sym_EQ] = ACTIONS(4098),
    [anon_sym_COLON] = ACTIONS(4100),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_do] = ACTIONS(4100),
    [anon_sym_let] = ACTIONS(4100),
    [anon_sym_let_BANG] = ACTIONS(4098),
    [anon_sym_LPAREN] = ACTIONS(4100),
    [anon_sym_COMMA] = ACTIONS(4098),
    [anon_sym_null] = ACTIONS(4100),
    [anon_sym_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_COLON] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4100),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4098),
    [anon_sym_LBRACE] = ACTIONS(4100),
    [anon_sym_LT_AT] = ACTIONS(4100),
    [anon_sym_AT_GT] = ACTIONS(4100),
    [anon_sym_LT_AT_AT] = ACTIONS(4100),
    [anon_sym_DOT] = ACTIONS(4100),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4098),
    [anon_sym_new] = ACTIONS(4100),
    [anon_sym_return_BANG] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4100),
    [anon_sym_yield_BANG] = ACTIONS(4098),
    [anon_sym_lazy] = ACTIONS(4100),
    [anon_sym_assert] = ACTIONS(4100),
    [anon_sym_upcast] = ACTIONS(4100),
    [anon_sym_downcast] = ACTIONS(4100),
    [anon_sym_COLON_GT] = ACTIONS(4098),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4098),
    [anon_sym_for] = ACTIONS(4100),
    [anon_sym_while] = ACTIONS(4100),
    [anon_sym_if] = ACTIONS(4100),
    [anon_sym_fun] = ACTIONS(4100),
    [anon_sym_try] = ACTIONS(4100),
    [anon_sym_match] = ACTIONS(4100),
    [anon_sym_match_BANG] = ACTIONS(4098),
    [anon_sym_function] = ACTIONS(4100),
    [anon_sym_LT_DASH] = ACTIONS(4100),
    [anon_sym_DOT_LBRACK] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(4098),
    [anon_sym_use] = ACTIONS(4100),
    [anon_sym_use_BANG] = ACTIONS(4098),
    [anon_sym_do_BANG] = ACTIONS(4098),
    [anon_sym_begin] = ACTIONS(4100),
    [anon_sym_LPAREN2] = ACTIONS(4100),
    [anon_sym_or] = ACTIONS(4100),
    [aux_sym_char_token1] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4100),
    [anon_sym_DQUOTE] = ACTIONS(4100),
    [anon_sym_AT_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [sym_bool] = ACTIONS(4100),
    [sym_unit] = ACTIONS(4098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4100),
    [sym_op_identifier] = ACTIONS(4100),
    [anon_sym_PLUS] = ACTIONS(4100),
    [anon_sym_DASH] = ACTIONS(4100),
    [anon_sym_PLUS_DOT] = ACTIONS(4100),
    [anon_sym_DASH_DOT] = ACTIONS(4100),
    [anon_sym_PERCENT] = ACTIONS(4100),
    [anon_sym_AMP_AMP] = ACTIONS(4100),
    [anon_sym_TILDE] = ACTIONS(4098),
    [aux_sym_prefix_op_token1] = ACTIONS(4100),
    [aux_sym_infix_op_token1] = ACTIONS(4098),
    [aux_sym_infix_op_token2] = ACTIONS(4100),
    [anon_sym_PIPE_PIPE] = ACTIONS(4100),
    [anon_sym_BANG_EQ] = ACTIONS(4100),
    [anon_sym_COLON_EQ] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4100),
    [sym_int] = ACTIONS(4100),
    [sym_xint] = ACTIONS(4098),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4098),
    [sym__newline] = ACTIONS(4098),
  },
  [3563] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defns] = STATE(11203),
    [sym__function_or_value_defn_body] = STATE(8938),
    [sym_function_declaration_left] = STATE(9536),
    [sym_value_declaration_left] = STATE(9536),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3563),
    [sym_compiler_directive_decl] = STATE(3563),
    [sym_fsi_directive_decl] = STATE(3563),
    [sym_preproc_line] = STATE(3563),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3564] = {
    [sym_block_comment] = STATE(3564),
    [sym_compiler_directive_decl] = STATE(3564),
    [sym_fsi_directive_decl] = STATE(3564),
    [sym_preproc_line] = STATE(3564),
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_COLON] = ACTIONS(3867),
    [anon_sym_return] = ACTIONS(3867),
    [anon_sym_do] = ACTIONS(3867),
    [anon_sym_let] = ACTIONS(3867),
    [anon_sym_let_BANG] = ACTIONS(3865),
    [anon_sym_LPAREN] = ACTIONS(3867),
    [anon_sym_COMMA] = ACTIONS(3865),
    [anon_sym_null] = ACTIONS(3867),
    [anon_sym_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_QMARK] = ACTIONS(3867),
    [anon_sym_COLON_COLON] = ACTIONS(3865),
    [anon_sym_AMP] = ACTIONS(3867),
    [anon_sym_LBRACK] = ACTIONS(3867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3867),
    [anon_sym_LT_AT] = ACTIONS(3867),
    [anon_sym_LT_AT_AT] = ACTIONS(3867),
    [anon_sym_AT_AT_GT] = ACTIONS(3867),
    [anon_sym_DOT] = ACTIONS(3867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3867),
    [anon_sym_return_BANG] = ACTIONS(3865),
    [anon_sym_yield] = ACTIONS(3867),
    [anon_sym_yield_BANG] = ACTIONS(3865),
    [anon_sym_lazy] = ACTIONS(3867),
    [anon_sym_assert] = ACTIONS(3867),
    [anon_sym_upcast] = ACTIONS(3867),
    [anon_sym_downcast] = ACTIONS(3867),
    [anon_sym_COLON_GT] = ACTIONS(3865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3867),
    [anon_sym_while] = ACTIONS(3867),
    [anon_sym_if] = ACTIONS(3867),
    [anon_sym_fun] = ACTIONS(3867),
    [anon_sym_try] = ACTIONS(3867),
    [anon_sym_match] = ACTIONS(3867),
    [anon_sym_match_BANG] = ACTIONS(3865),
    [anon_sym_function] = ACTIONS(3867),
    [anon_sym_LT_DASH] = ACTIONS(3867),
    [anon_sym_DOT_LBRACK] = ACTIONS(3865),
    [anon_sym_LT] = ACTIONS(3865),
    [anon_sym_use] = ACTIONS(3867),
    [anon_sym_use_BANG] = ACTIONS(3865),
    [anon_sym_do_BANG] = ACTIONS(3865),
    [anon_sym_begin] = ACTIONS(3867),
    [anon_sym_LPAREN2] = ACTIONS(3867),
    [anon_sym_or] = ACTIONS(3867),
    [aux_sym_char_token1] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3867),
    [anon_sym_DQUOTE] = ACTIONS(3867),
    [anon_sym_AT_DQUOTE] = ACTIONS(3865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3865),
    [sym_bool] = ACTIONS(3867),
    [sym_unit] = ACTIONS(3865),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3867),
    [sym_op_identifier] = ACTIONS(3867),
    [anon_sym_PLUS] = ACTIONS(3867),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_PLUS_DOT] = ACTIONS(3867),
    [anon_sym_DASH_DOT] = ACTIONS(3867),
    [anon_sym_PERCENT] = ACTIONS(3867),
    [anon_sym_AMP_AMP] = ACTIONS(3867),
    [anon_sym_TILDE] = ACTIONS(3865),
    [aux_sym_prefix_op_token1] = ACTIONS(3867),
    [aux_sym_infix_op_token1] = ACTIONS(3865),
    [aux_sym_infix_op_token2] = ACTIONS(3867),
    [anon_sym_PIPE_PIPE] = ACTIONS(3867),
    [anon_sym_BANG_EQ] = ACTIONS(3867),
    [anon_sym_COLON_EQ] = ACTIONS(3865),
    [anon_sym_DOLLAR] = ACTIONS(3867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3867),
    [sym_int] = ACTIONS(3867),
    [sym_xint] = ACTIONS(3865),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3865),
    [sym__newline] = ACTIONS(3865),
  },
  [3565] = {
    [sym_block_comment] = STATE(3565),
    [sym_compiler_directive_decl] = STATE(3565),
    [sym_fsi_directive_decl] = STATE(3565),
    [sym_preproc_line] = STATE(3565),
    [sym_identifier] = ACTIONS(3927),
    [anon_sym_EQ] = ACTIONS(3925),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_return] = ACTIONS(3927),
    [anon_sym_do] = ACTIONS(3927),
    [anon_sym_let] = ACTIONS(3927),
    [anon_sym_let_BANG] = ACTIONS(3925),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_COMMA] = ACTIONS(3925),
    [anon_sym_null] = ACTIONS(3927),
    [anon_sym_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_COLON] = ACTIONS(3925),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3925),
    [anon_sym_LBRACE] = ACTIONS(3927),
    [anon_sym_LT_AT] = ACTIONS(3927),
    [anon_sym_AT_GT] = ACTIONS(3927),
    [anon_sym_LT_AT_AT] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3925),
    [anon_sym_new] = ACTIONS(3927),
    [anon_sym_return_BANG] = ACTIONS(3925),
    [anon_sym_yield] = ACTIONS(3927),
    [anon_sym_yield_BANG] = ACTIONS(3925),
    [anon_sym_lazy] = ACTIONS(3927),
    [anon_sym_assert] = ACTIONS(3927),
    [anon_sym_upcast] = ACTIONS(3927),
    [anon_sym_downcast] = ACTIONS(3927),
    [anon_sym_COLON_GT] = ACTIONS(3925),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3925),
    [anon_sym_for] = ACTIONS(3927),
    [anon_sym_while] = ACTIONS(3927),
    [anon_sym_if] = ACTIONS(3927),
    [anon_sym_fun] = ACTIONS(3927),
    [anon_sym_try] = ACTIONS(3927),
    [anon_sym_match] = ACTIONS(3927),
    [anon_sym_match_BANG] = ACTIONS(3925),
    [anon_sym_function] = ACTIONS(3927),
    [anon_sym_LT_DASH] = ACTIONS(3927),
    [anon_sym_DOT_LBRACK] = ACTIONS(3925),
    [anon_sym_LT] = ACTIONS(3925),
    [anon_sym_use] = ACTIONS(3927),
    [anon_sym_use_BANG] = ACTIONS(3925),
    [anon_sym_do_BANG] = ACTIONS(3925),
    [anon_sym_begin] = ACTIONS(3927),
    [anon_sym_LPAREN2] = ACTIONS(3927),
    [anon_sym_or] = ACTIONS(3927),
    [aux_sym_char_token1] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_AT_DQUOTE] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [sym_bool] = ACTIONS(3927),
    [sym_unit] = ACTIONS(3925),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3927),
    [sym_op_identifier] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3927),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_PLUS_DOT] = ACTIONS(3927),
    [anon_sym_DASH_DOT] = ACTIONS(3927),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_TILDE] = ACTIONS(3925),
    [aux_sym_prefix_op_token1] = ACTIONS(3927),
    [aux_sym_infix_op_token1] = ACTIONS(3925),
    [aux_sym_infix_op_token2] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_COLON_EQ] = ACTIONS(3925),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3927),
    [sym_int] = ACTIONS(3927),
    [sym_xint] = ACTIONS(3925),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3925),
    [sym__newline] = ACTIONS(3925),
  },
  [3566] = {
    [sym_block_comment] = STATE(3566),
    [sym_compiler_directive_decl] = STATE(3566),
    [sym_fsi_directive_decl] = STATE(3566),
    [sym_preproc_line] = STATE(3566),
    [sym_identifier] = ACTIONS(4182),
    [anon_sym_EQ] = ACTIONS(3689),
    [anon_sym_COLON] = ACTIONS(4182),
    [anon_sym_return] = ACTIONS(4182),
    [anon_sym_do] = ACTIONS(4182),
    [anon_sym_let] = ACTIONS(4182),
    [anon_sym_let_BANG] = ACTIONS(3689),
    [anon_sym_LPAREN] = ACTIONS(4182),
    [anon_sym_COMMA] = ACTIONS(3689),
    [anon_sym_null] = ACTIONS(4182),
    [anon_sym_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_QMARK] = ACTIONS(4182),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3689),
    [anon_sym_LBRACE] = ACTIONS(4182),
    [anon_sym_LT_AT] = ACTIONS(4182),
    [anon_sym_LT_AT_AT] = ACTIONS(4182),
    [anon_sym_AT_AT_GT] = ACTIONS(4182),
    [anon_sym_DOT] = ACTIONS(4182),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3689),
    [anon_sym_new] = ACTIONS(4182),
    [anon_sym_return_BANG] = ACTIONS(3689),
    [anon_sym_yield] = ACTIONS(4182),
    [anon_sym_yield_BANG] = ACTIONS(3689),
    [anon_sym_lazy] = ACTIONS(4182),
    [anon_sym_assert] = ACTIONS(4182),
    [anon_sym_upcast] = ACTIONS(4182),
    [anon_sym_downcast] = ACTIONS(4182),
    [anon_sym_COLON_GT] = ACTIONS(3689),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3689),
    [anon_sym_for] = ACTIONS(4182),
    [anon_sym_while] = ACTIONS(4182),
    [anon_sym_if] = ACTIONS(4182),
    [anon_sym_fun] = ACTIONS(4182),
    [anon_sym_try] = ACTIONS(4182),
    [anon_sym_match] = ACTIONS(4182),
    [anon_sym_match_BANG] = ACTIONS(3689),
    [anon_sym_function] = ACTIONS(4182),
    [anon_sym_LT_DASH] = ACTIONS(4182),
    [anon_sym_DOT_LBRACK] = ACTIONS(3689),
    [anon_sym_LT] = ACTIONS(3689),
    [anon_sym_use] = ACTIONS(4182),
    [anon_sym_use_BANG] = ACTIONS(3689),
    [anon_sym_do_BANG] = ACTIONS(3689),
    [anon_sym_begin] = ACTIONS(4182),
    [anon_sym_LPAREN2] = ACTIONS(4182),
    [anon_sym_or] = ACTIONS(4182),
    [aux_sym_char_token1] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4182),
    [anon_sym_DQUOTE] = ACTIONS(4182),
    [anon_sym_AT_DQUOTE] = ACTIONS(3689),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3689),
    [sym_bool] = ACTIONS(4182),
    [sym_unit] = ACTIONS(3689),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4182),
    [sym_op_identifier] = ACTIONS(4182),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_PLUS_DOT] = ACTIONS(4182),
    [anon_sym_DASH_DOT] = ACTIONS(4182),
    [anon_sym_PERCENT] = ACTIONS(4182),
    [anon_sym_AMP_AMP] = ACTIONS(4182),
    [anon_sym_TILDE] = ACTIONS(3689),
    [aux_sym_prefix_op_token1] = ACTIONS(4182),
    [aux_sym_infix_op_token1] = ACTIONS(3689),
    [aux_sym_infix_op_token2] = ACTIONS(4182),
    [anon_sym_PIPE_PIPE] = ACTIONS(4182),
    [anon_sym_BANG_EQ] = ACTIONS(4182),
    [anon_sym_COLON_EQ] = ACTIONS(3689),
    [anon_sym_DOLLAR] = ACTIONS(4182),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4182),
    [sym_int] = ACTIONS(4182),
    [sym_xint] = ACTIONS(3689),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3689),
    [sym__newline] = ACTIONS(3689),
  },
  [3567] = {
    [sym_block_comment] = STATE(3567),
    [sym_compiler_directive_decl] = STATE(3567),
    [sym_fsi_directive_decl] = STATE(3567),
    [sym_preproc_line] = STATE(3567),
    [sym_identifier] = ACTIONS(4162),
    [anon_sym_EQ] = ACTIONS(4160),
    [anon_sym_COLON] = ACTIONS(4162),
    [anon_sym_return] = ACTIONS(4162),
    [anon_sym_do] = ACTIONS(4162),
    [anon_sym_let] = ACTIONS(4162),
    [anon_sym_let_BANG] = ACTIONS(4160),
    [anon_sym_LPAREN] = ACTIONS(4162),
    [anon_sym_COMMA] = ACTIONS(4160),
    [anon_sym_null] = ACTIONS(4162),
    [anon_sym_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_QMARK] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4160),
    [anon_sym_AMP] = ACTIONS(4162),
    [anon_sym_LBRACK] = ACTIONS(4162),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4160),
    [anon_sym_LBRACE] = ACTIONS(4162),
    [anon_sym_LT_AT] = ACTIONS(4162),
    [anon_sym_LT_AT_AT] = ACTIONS(4162),
    [anon_sym_AT_AT_GT] = ACTIONS(4162),
    [anon_sym_DOT] = ACTIONS(4162),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4160),
    [anon_sym_new] = ACTIONS(4162),
    [anon_sym_return_BANG] = ACTIONS(4160),
    [anon_sym_yield] = ACTIONS(4162),
    [anon_sym_yield_BANG] = ACTIONS(4160),
    [anon_sym_lazy] = ACTIONS(4162),
    [anon_sym_assert] = ACTIONS(4162),
    [anon_sym_upcast] = ACTIONS(4162),
    [anon_sym_downcast] = ACTIONS(4162),
    [anon_sym_COLON_GT] = ACTIONS(4160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4160),
    [anon_sym_for] = ACTIONS(4162),
    [anon_sym_while] = ACTIONS(4162),
    [anon_sym_if] = ACTIONS(4162),
    [anon_sym_fun] = ACTIONS(4162),
    [anon_sym_try] = ACTIONS(4162),
    [anon_sym_match] = ACTIONS(4162),
    [anon_sym_match_BANG] = ACTIONS(4160),
    [anon_sym_function] = ACTIONS(4162),
    [anon_sym_LT_DASH] = ACTIONS(4162),
    [anon_sym_DOT_LBRACK] = ACTIONS(4160),
    [anon_sym_LT] = ACTIONS(4160),
    [anon_sym_use] = ACTIONS(4162),
    [anon_sym_use_BANG] = ACTIONS(4160),
    [anon_sym_do_BANG] = ACTIONS(4160),
    [anon_sym_begin] = ACTIONS(4162),
    [anon_sym_LPAREN2] = ACTIONS(4162),
    [anon_sym_or] = ACTIONS(4162),
    [aux_sym_char_token1] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4162),
    [anon_sym_DQUOTE] = ACTIONS(4162),
    [anon_sym_AT_DQUOTE] = ACTIONS(4160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4160),
    [sym_bool] = ACTIONS(4162),
    [sym_unit] = ACTIONS(4160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4162),
    [sym_op_identifier] = ACTIONS(4162),
    [anon_sym_PLUS] = ACTIONS(4162),
    [anon_sym_DASH] = ACTIONS(4162),
    [anon_sym_PLUS_DOT] = ACTIONS(4162),
    [anon_sym_DASH_DOT] = ACTIONS(4162),
    [anon_sym_PERCENT] = ACTIONS(4162),
    [anon_sym_AMP_AMP] = ACTIONS(4162),
    [anon_sym_TILDE] = ACTIONS(4160),
    [aux_sym_prefix_op_token1] = ACTIONS(4162),
    [aux_sym_infix_op_token1] = ACTIONS(4160),
    [aux_sym_infix_op_token2] = ACTIONS(4162),
    [anon_sym_PIPE_PIPE] = ACTIONS(4162),
    [anon_sym_BANG_EQ] = ACTIONS(4162),
    [anon_sym_COLON_EQ] = ACTIONS(4160),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4162),
    [sym_int] = ACTIONS(4162),
    [sym_xint] = ACTIONS(4160),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4160),
    [sym__newline] = ACTIONS(4160),
  },
  [3568] = {
    [sym_block_comment] = STATE(3568),
    [sym_compiler_directive_decl] = STATE(3568),
    [sym_fsi_directive_decl] = STATE(3568),
    [sym_preproc_line] = STATE(3568),
    [sym_identifier] = ACTIONS(3946),
    [anon_sym_EQ] = ACTIONS(3944),
    [anon_sym_COLON] = ACTIONS(3946),
    [anon_sym_return] = ACTIONS(3946),
    [anon_sym_do] = ACTIONS(3946),
    [anon_sym_let] = ACTIONS(3946),
    [anon_sym_let_BANG] = ACTIONS(3944),
    [anon_sym_LPAREN] = ACTIONS(3946),
    [anon_sym_COMMA] = ACTIONS(3944),
    [anon_sym_null] = ACTIONS(3946),
    [anon_sym_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_QMARK] = ACTIONS(3946),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LBRACK] = ACTIONS(3946),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3944),
    [anon_sym_LBRACE] = ACTIONS(3946),
    [anon_sym_LT_AT] = ACTIONS(3946),
    [anon_sym_AT_GT] = ACTIONS(3946),
    [anon_sym_LT_AT_AT] = ACTIONS(3946),
    [anon_sym_DOT] = ACTIONS(3946),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3944),
    [anon_sym_new] = ACTIONS(3946),
    [anon_sym_return_BANG] = ACTIONS(3944),
    [anon_sym_yield] = ACTIONS(3946),
    [anon_sym_yield_BANG] = ACTIONS(3944),
    [anon_sym_lazy] = ACTIONS(3946),
    [anon_sym_assert] = ACTIONS(3946),
    [anon_sym_upcast] = ACTIONS(3946),
    [anon_sym_downcast] = ACTIONS(3946),
    [anon_sym_COLON_GT] = ACTIONS(3944),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3944),
    [anon_sym_for] = ACTIONS(3946),
    [anon_sym_while] = ACTIONS(3946),
    [anon_sym_if] = ACTIONS(3946),
    [anon_sym_fun] = ACTIONS(3946),
    [anon_sym_try] = ACTIONS(3946),
    [anon_sym_match] = ACTIONS(3946),
    [anon_sym_match_BANG] = ACTIONS(3944),
    [anon_sym_function] = ACTIONS(3946),
    [anon_sym_LT_DASH] = ACTIONS(3946),
    [anon_sym_DOT_LBRACK] = ACTIONS(3944),
    [anon_sym_LT] = ACTIONS(3944),
    [anon_sym_use] = ACTIONS(3946),
    [anon_sym_use_BANG] = ACTIONS(3944),
    [anon_sym_do_BANG] = ACTIONS(3944),
    [anon_sym_begin] = ACTIONS(3946),
    [anon_sym_LPAREN2] = ACTIONS(3946),
    [anon_sym_or] = ACTIONS(3946),
    [aux_sym_char_token1] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_AT_DQUOTE] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [sym_bool] = ACTIONS(3946),
    [sym_unit] = ACTIONS(3944),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3946),
    [sym_op_identifier] = ACTIONS(3946),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PLUS_DOT] = ACTIONS(3946),
    [anon_sym_DASH_DOT] = ACTIONS(3946),
    [anon_sym_PERCENT] = ACTIONS(3946),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_TILDE] = ACTIONS(3944),
    [aux_sym_prefix_op_token1] = ACTIONS(3946),
    [aux_sym_infix_op_token1] = ACTIONS(3944),
    [aux_sym_infix_op_token2] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [anon_sym_BANG_EQ] = ACTIONS(3946),
    [anon_sym_COLON_EQ] = ACTIONS(3944),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3946),
    [sym_int] = ACTIONS(3946),
    [sym_xint] = ACTIONS(3944),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3944),
    [sym__newline] = ACTIONS(3944),
  },
  [3569] = {
    [sym_type_arguments] = STATE(3605),
    [sym_long_identifier] = STATE(3604),
    [sym_block_comment] = STATE(3569),
    [sym_compiler_directive_decl] = STATE(3569),
    [sym_fsi_directive_decl] = STATE(3569),
    [sym_preproc_line] = STATE(3569),
    [aux_sym_compound_type_repeat1] = STATE(3597),
    [ts_builtin_sym_end] = ACTIONS(6022),
    [sym_identifier] = ACTIONS(6024),
    [anon_sym_namespace] = ACTIONS(6024),
    [anon_sym_module] = ACTIONS(6024),
    [anon_sym_open] = ACTIONS(6024),
    [anon_sym_LBRACK_LT] = ACTIONS(6022),
    [anon_sym_return] = ACTIONS(6024),
    [anon_sym_type] = ACTIONS(6024),
    [anon_sym_do] = ACTIONS(6024),
    [anon_sym_and] = ACTIONS(6024),
    [anon_sym_let] = ACTIONS(6024),
    [anon_sym_let_BANG] = ACTIONS(6022),
    [aux_sym_access_modifier_token1] = ACTIONS(6022),
    [anon_sym_LPAREN] = ACTIONS(6024),
    [anon_sym_null] = ACTIONS(6024),
    [anon_sym_AMP] = ACTIONS(6024),
    [anon_sym_LBRACK] = ACTIONS(6024),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6022),
    [anon_sym_LBRACE] = ACTIONS(6024),
    [anon_sym_LT_AT] = ACTIONS(6024),
    [anon_sym_LT_AT_AT] = ACTIONS(6022),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6022),
    [anon_sym_new] = ACTIONS(6024),
    [anon_sym_return_BANG] = ACTIONS(6022),
    [anon_sym_yield] = ACTIONS(6024),
    [anon_sym_yield_BANG] = ACTIONS(6022),
    [anon_sym_lazy] = ACTIONS(6024),
    [anon_sym_assert] = ACTIONS(6024),
    [anon_sym_upcast] = ACTIONS(6024),
    [anon_sym_downcast] = ACTIONS(6024),
    [anon_sym_for] = ACTIONS(6024),
    [anon_sym_while] = ACTIONS(6024),
    [anon_sym_if] = ACTIONS(6024),
    [anon_sym_fun] = ACTIONS(6024),
    [anon_sym_DASH_GT] = ACTIONS(5385),
    [anon_sym_try] = ACTIONS(6024),
    [anon_sym_match] = ACTIONS(6024),
    [anon_sym_match_BANG] = ACTIONS(6022),
    [anon_sym_function] = ACTIONS(6024),
    [anon_sym_use] = ACTIONS(6024),
    [anon_sym_use_BANG] = ACTIONS(6022),
    [anon_sym_do_BANG] = ACTIONS(6022),
    [anon_sym_begin] = ACTIONS(6024),
    [anon_sym_STAR] = ACTIONS(5387),
    [anon_sym_LT2] = ACTIONS(5389),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5391),
    [anon_sym_default] = ACTIONS(6024),
    [anon_sym_static] = ACTIONS(6024),
    [anon_sym_member] = ACTIONS(6024),
    [anon_sym_interface] = ACTIONS(6024),
    [anon_sym_exception] = ACTIONS(6024),
    [anon_sym_abstract] = ACTIONS(6024),
    [anon_sym_val] = ACTIONS(6024),
    [anon_sym_override] = ACTIONS(6024),
    [aux_sym_char_token1] = ACTIONS(6022),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6024),
    [anon_sym_DQUOTE] = ACTIONS(6024),
    [anon_sym_AT_DQUOTE] = ACTIONS(6022),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6022),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6022),
    [sym_bool] = ACTIONS(6024),
    [sym_unit] = ACTIONS(6022),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6024),
    [sym_op_identifier] = ACTIONS(6022),
    [anon_sym_PLUS] = ACTIONS(6024),
    [anon_sym_DASH] = ACTIONS(6024),
    [anon_sym_PLUS_DOT] = ACTIONS(6022),
    [anon_sym_DASH_DOT] = ACTIONS(6022),
    [anon_sym_PERCENT] = ACTIONS(6022),
    [anon_sym_AMP_AMP] = ACTIONS(6022),
    [anon_sym_TILDE] = ACTIONS(6022),
    [aux_sym_prefix_op_token1] = ACTIONS(6022),
    [sym_int] = ACTIONS(6024),
    [sym_xint] = ACTIONS(6022),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6022),
    [anon_sym_POUNDload] = ACTIONS(6022),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6022),
  },
  [3570] = {
    [sym_block_comment] = STATE(3570),
    [sym_compiler_directive_decl] = STATE(3570),
    [sym_fsi_directive_decl] = STATE(3570),
    [sym_preproc_line] = STATE(3570),
    [sym_identifier] = ACTIONS(4158),
    [anon_sym_EQ] = ACTIONS(4156),
    [anon_sym_COLON] = ACTIONS(4158),
    [anon_sym_return] = ACTIONS(4158),
    [anon_sym_do] = ACTIONS(4158),
    [anon_sym_let] = ACTIONS(4158),
    [anon_sym_let_BANG] = ACTIONS(4156),
    [anon_sym_LPAREN] = ACTIONS(4158),
    [anon_sym_COMMA] = ACTIONS(4156),
    [anon_sym_null] = ACTIONS(4158),
    [anon_sym_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_QMARK] = ACTIONS(4158),
    [anon_sym_COLON_COLON] = ACTIONS(4156),
    [anon_sym_AMP] = ACTIONS(4158),
    [anon_sym_LBRACK] = ACTIONS(4158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(4158),
    [anon_sym_LT_AT] = ACTIONS(4158),
    [anon_sym_LT_AT_AT] = ACTIONS(4158),
    [anon_sym_AT_AT_GT] = ACTIONS(4158),
    [anon_sym_DOT] = ACTIONS(4158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4156),
    [anon_sym_new] = ACTIONS(4158),
    [anon_sym_return_BANG] = ACTIONS(4156),
    [anon_sym_yield] = ACTIONS(4158),
    [anon_sym_yield_BANG] = ACTIONS(4156),
    [anon_sym_lazy] = ACTIONS(4158),
    [anon_sym_assert] = ACTIONS(4158),
    [anon_sym_upcast] = ACTIONS(4158),
    [anon_sym_downcast] = ACTIONS(4158),
    [anon_sym_COLON_GT] = ACTIONS(4156),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4156),
    [anon_sym_for] = ACTIONS(4158),
    [anon_sym_while] = ACTIONS(4158),
    [anon_sym_if] = ACTIONS(4158),
    [anon_sym_fun] = ACTIONS(4158),
    [anon_sym_try] = ACTIONS(4158),
    [anon_sym_match] = ACTIONS(4158),
    [anon_sym_match_BANG] = ACTIONS(4156),
    [anon_sym_function] = ACTIONS(4158),
    [anon_sym_LT_DASH] = ACTIONS(4158),
    [anon_sym_DOT_LBRACK] = ACTIONS(4156),
    [anon_sym_LT] = ACTIONS(4156),
    [anon_sym_use] = ACTIONS(4158),
    [anon_sym_use_BANG] = ACTIONS(4156),
    [anon_sym_do_BANG] = ACTIONS(4156),
    [anon_sym_begin] = ACTIONS(4158),
    [anon_sym_LPAREN2] = ACTIONS(4158),
    [anon_sym_or] = ACTIONS(4158),
    [aux_sym_char_token1] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4158),
    [anon_sym_DQUOTE] = ACTIONS(4158),
    [anon_sym_AT_DQUOTE] = ACTIONS(4156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4156),
    [sym_bool] = ACTIONS(4158),
    [sym_unit] = ACTIONS(4156),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4158),
    [sym_op_identifier] = ACTIONS(4158),
    [anon_sym_PLUS] = ACTIONS(4158),
    [anon_sym_DASH] = ACTIONS(4158),
    [anon_sym_PLUS_DOT] = ACTIONS(4158),
    [anon_sym_DASH_DOT] = ACTIONS(4158),
    [anon_sym_PERCENT] = ACTIONS(4158),
    [anon_sym_AMP_AMP] = ACTIONS(4158),
    [anon_sym_TILDE] = ACTIONS(4156),
    [aux_sym_prefix_op_token1] = ACTIONS(4158),
    [aux_sym_infix_op_token1] = ACTIONS(4156),
    [aux_sym_infix_op_token2] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE] = ACTIONS(4158),
    [anon_sym_BANG_EQ] = ACTIONS(4158),
    [anon_sym_COLON_EQ] = ACTIONS(4156),
    [anon_sym_DOLLAR] = ACTIONS(4158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4158),
    [sym_int] = ACTIONS(4158),
    [sym_xint] = ACTIONS(4156),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4156),
    [sym__newline] = ACTIONS(4156),
  },
  [3571] = {
    [sym_block_comment] = STATE(3571),
    [sym_compiler_directive_decl] = STATE(3571),
    [sym_fsi_directive_decl] = STATE(3571),
    [sym_preproc_line] = STATE(3571),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4739),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
    [sym__dedent] = ACTIONS(6026),
  },
  [3572] = {
    [sym_block_comment] = STATE(3572),
    [sym_compiler_directive_decl] = STATE(3572),
    [sym_fsi_directive_decl] = STATE(3572),
    [sym_preproc_line] = STATE(3572),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_AT_GT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(6028),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
  },
  [3573] = {
    [sym_type_arguments] = STATE(3605),
    [sym_long_identifier] = STATE(3604),
    [sym_block_comment] = STATE(3573),
    [sym_compiler_directive_decl] = STATE(3573),
    [sym_fsi_directive_decl] = STATE(3573),
    [sym_preproc_line] = STATE(3573),
    [aux_sym_compound_type_repeat1] = STATE(3597),
    [ts_builtin_sym_end] = ACTIONS(6030),
    [sym_identifier] = ACTIONS(6032),
    [anon_sym_namespace] = ACTIONS(6032),
    [anon_sym_module] = ACTIONS(6032),
    [anon_sym_open] = ACTIONS(6032),
    [anon_sym_LBRACK_LT] = ACTIONS(6030),
    [anon_sym_return] = ACTIONS(6032),
    [anon_sym_type] = ACTIONS(6032),
    [anon_sym_do] = ACTIONS(6032),
    [anon_sym_and] = ACTIONS(6032),
    [anon_sym_let] = ACTIONS(6032),
    [anon_sym_let_BANG] = ACTIONS(6030),
    [aux_sym_access_modifier_token1] = ACTIONS(6030),
    [anon_sym_LPAREN] = ACTIONS(6032),
    [anon_sym_null] = ACTIONS(6032),
    [anon_sym_AMP] = ACTIONS(6032),
    [anon_sym_LBRACK] = ACTIONS(6032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6030),
    [anon_sym_LBRACE] = ACTIONS(6032),
    [anon_sym_LT_AT] = ACTIONS(6032),
    [anon_sym_LT_AT_AT] = ACTIONS(6030),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6030),
    [anon_sym_new] = ACTIONS(6032),
    [anon_sym_return_BANG] = ACTIONS(6030),
    [anon_sym_yield] = ACTIONS(6032),
    [anon_sym_yield_BANG] = ACTIONS(6030),
    [anon_sym_lazy] = ACTIONS(6032),
    [anon_sym_assert] = ACTIONS(6032),
    [anon_sym_upcast] = ACTIONS(6032),
    [anon_sym_downcast] = ACTIONS(6032),
    [anon_sym_for] = ACTIONS(6032),
    [anon_sym_while] = ACTIONS(6032),
    [anon_sym_if] = ACTIONS(6032),
    [anon_sym_fun] = ACTIONS(6032),
    [anon_sym_DASH_GT] = ACTIONS(5385),
    [anon_sym_try] = ACTIONS(6032),
    [anon_sym_match] = ACTIONS(6032),
    [anon_sym_match_BANG] = ACTIONS(6030),
    [anon_sym_function] = ACTIONS(6032),
    [anon_sym_use] = ACTIONS(6032),
    [anon_sym_use_BANG] = ACTIONS(6030),
    [anon_sym_do_BANG] = ACTIONS(6030),
    [anon_sym_begin] = ACTIONS(6032),
    [anon_sym_STAR] = ACTIONS(5387),
    [anon_sym_LT2] = ACTIONS(5389),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5391),
    [anon_sym_default] = ACTIONS(6032),
    [anon_sym_static] = ACTIONS(6032),
    [anon_sym_member] = ACTIONS(6032),
    [anon_sym_interface] = ACTIONS(6032),
    [anon_sym_exception] = ACTIONS(6032),
    [anon_sym_abstract] = ACTIONS(6032),
    [anon_sym_val] = ACTIONS(6032),
    [anon_sym_override] = ACTIONS(6032),
    [aux_sym_char_token1] = ACTIONS(6030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6032),
    [anon_sym_DQUOTE] = ACTIONS(6032),
    [anon_sym_AT_DQUOTE] = ACTIONS(6030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6030),
    [sym_bool] = ACTIONS(6032),
    [sym_unit] = ACTIONS(6030),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6032),
    [sym_op_identifier] = ACTIONS(6030),
    [anon_sym_PLUS] = ACTIONS(6032),
    [anon_sym_DASH] = ACTIONS(6032),
    [anon_sym_PLUS_DOT] = ACTIONS(6030),
    [anon_sym_DASH_DOT] = ACTIONS(6030),
    [anon_sym_PERCENT] = ACTIONS(6030),
    [anon_sym_AMP_AMP] = ACTIONS(6030),
    [anon_sym_TILDE] = ACTIONS(6030),
    [aux_sym_prefix_op_token1] = ACTIONS(6030),
    [sym_int] = ACTIONS(6032),
    [sym_xint] = ACTIONS(6030),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6030),
    [anon_sym_POUNDload] = ACTIONS(6030),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6030),
  },
  [3574] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defns] = STATE(6879),
    [sym__function_or_value_defn_body] = STATE(6579),
    [sym_function_declaration_left] = STATE(9616),
    [sym_value_declaration_left] = STATE(9616),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3574),
    [sym_compiler_directive_decl] = STATE(3574),
    [sym_fsi_directive_decl] = STATE(3574),
    [sym_preproc_line] = STATE(3574),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3575] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(6783),
    [sym_function_declaration_left] = STATE(9616),
    [sym_value_declaration_left] = STATE(9616),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3575),
    [sym_compiler_directive_decl] = STATE(3575),
    [sym_fsi_directive_decl] = STATE(3575),
    [sym_preproc_line] = STATE(3575),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_rec] = ACTIONS(6034),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3576] = {
    [sym_block_comment] = STATE(3576),
    [sym_compiler_directive_decl] = STATE(3576),
    [sym_fsi_directive_decl] = STATE(3576),
    [sym_preproc_line] = STATE(3576),
    [sym_identifier] = ACTIONS(4100),
    [anon_sym_EQ] = ACTIONS(4098),
    [anon_sym_COLON] = ACTIONS(4100),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_do] = ACTIONS(4100),
    [anon_sym_let] = ACTIONS(4100),
    [anon_sym_let_BANG] = ACTIONS(4098),
    [anon_sym_LPAREN] = ACTIONS(4100),
    [anon_sym_COMMA] = ACTIONS(4098),
    [anon_sym_null] = ACTIONS(4100),
    [anon_sym_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_QMARK] = ACTIONS(4100),
    [anon_sym_COLON_COLON] = ACTIONS(4098),
    [anon_sym_AMP] = ACTIONS(4100),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4098),
    [anon_sym_LBRACE] = ACTIONS(4100),
    [anon_sym_LT_AT] = ACTIONS(4100),
    [anon_sym_LT_AT_AT] = ACTIONS(4100),
    [anon_sym_DOT] = ACTIONS(4100),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4098),
    [anon_sym_new] = ACTIONS(4100),
    [anon_sym_return_BANG] = ACTIONS(4098),
    [anon_sym_yield] = ACTIONS(4100),
    [anon_sym_yield_BANG] = ACTIONS(4098),
    [anon_sym_lazy] = ACTIONS(4100),
    [anon_sym_assert] = ACTIONS(4100),
    [anon_sym_upcast] = ACTIONS(4100),
    [anon_sym_downcast] = ACTIONS(4100),
    [anon_sym_COLON_GT] = ACTIONS(4098),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4098),
    [anon_sym_for] = ACTIONS(4100),
    [anon_sym_while] = ACTIONS(4100),
    [anon_sym_if] = ACTIONS(4100),
    [anon_sym_fun] = ACTIONS(4100),
    [anon_sym_try] = ACTIONS(4100),
    [anon_sym_match] = ACTIONS(4100),
    [anon_sym_match_BANG] = ACTIONS(4098),
    [anon_sym_function] = ACTIONS(4100),
    [anon_sym_LT_DASH] = ACTIONS(4100),
    [anon_sym_DOT_LBRACK] = ACTIONS(4098),
    [anon_sym_LT] = ACTIONS(4098),
    [anon_sym_GT] = ACTIONS(4100),
    [anon_sym_use] = ACTIONS(4100),
    [anon_sym_use_BANG] = ACTIONS(4098),
    [anon_sym_do_BANG] = ACTIONS(4098),
    [anon_sym_begin] = ACTIONS(4100),
    [anon_sym_LPAREN2] = ACTIONS(4100),
    [anon_sym_or] = ACTIONS(4100),
    [aux_sym_char_token1] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4100),
    [anon_sym_DQUOTE] = ACTIONS(4100),
    [anon_sym_AT_DQUOTE] = ACTIONS(4098),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4098),
    [sym_bool] = ACTIONS(4100),
    [sym_unit] = ACTIONS(4098),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4100),
    [sym_op_identifier] = ACTIONS(4100),
    [anon_sym_PLUS] = ACTIONS(4100),
    [anon_sym_DASH] = ACTIONS(4100),
    [anon_sym_PLUS_DOT] = ACTIONS(4100),
    [anon_sym_DASH_DOT] = ACTIONS(4100),
    [anon_sym_PERCENT] = ACTIONS(4100),
    [anon_sym_AMP_AMP] = ACTIONS(4100),
    [anon_sym_TILDE] = ACTIONS(4098),
    [aux_sym_prefix_op_token1] = ACTIONS(4100),
    [aux_sym_infix_op_token1] = ACTIONS(4098),
    [aux_sym_infix_op_token2] = ACTIONS(4100),
    [anon_sym_PIPE_PIPE] = ACTIONS(4100),
    [anon_sym_BANG_EQ] = ACTIONS(4100),
    [anon_sym_COLON_EQ] = ACTIONS(4098),
    [anon_sym_DOLLAR] = ACTIONS(4100),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4100),
    [sym_int] = ACTIONS(4100),
    [sym_xint] = ACTIONS(4098),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4098),
    [sym__newline] = ACTIONS(4098),
  },
  [3577] = {
    [sym_block_comment] = STATE(3577),
    [sym_compiler_directive_decl] = STATE(3577),
    [sym_fsi_directive_decl] = STATE(3577),
    [sym_preproc_line] = STATE(3577),
    [sym_identifier] = ACTIONS(4228),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(4228),
    [anon_sym_do] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_let_BANG] = ACTIONS(4226),
    [anon_sym_LPAREN] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(4228),
    [anon_sym_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_QMARK] = ACTIONS(4228),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4226),
    [anon_sym_LBRACE] = ACTIONS(4228),
    [anon_sym_LT_AT] = ACTIONS(4228),
    [anon_sym_LT_AT_AT] = ACTIONS(4228),
    [anon_sym_AT_AT_GT] = ACTIONS(4228),
    [anon_sym_DOT] = ACTIONS(4228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4226),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_return_BANG] = ACTIONS(4226),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_yield_BANG] = ACTIONS(4226),
    [anon_sym_lazy] = ACTIONS(4228),
    [anon_sym_assert] = ACTIONS(4228),
    [anon_sym_upcast] = ACTIONS(4228),
    [anon_sym_downcast] = ACTIONS(4228),
    [anon_sym_COLON_GT] = ACTIONS(4226),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(4228),
    [anon_sym_while] = ACTIONS(4228),
    [anon_sym_if] = ACTIONS(4228),
    [anon_sym_fun] = ACTIONS(4228),
    [anon_sym_try] = ACTIONS(4228),
    [anon_sym_match] = ACTIONS(4228),
    [anon_sym_match_BANG] = ACTIONS(4226),
    [anon_sym_function] = ACTIONS(4228),
    [anon_sym_LT_DASH] = ACTIONS(4228),
    [anon_sym_DOT_LBRACK] = ACTIONS(4226),
    [anon_sym_LT] = ACTIONS(4226),
    [anon_sym_use] = ACTIONS(4228),
    [anon_sym_use_BANG] = ACTIONS(4226),
    [anon_sym_do_BANG] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4228),
    [anon_sym_LPAREN2] = ACTIONS(4228),
    [anon_sym_or] = ACTIONS(4228),
    [aux_sym_char_token1] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4228),
    [anon_sym_DQUOTE] = ACTIONS(4228),
    [anon_sym_AT_DQUOTE] = ACTIONS(4226),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4226),
    [sym_bool] = ACTIONS(4228),
    [sym_unit] = ACTIONS(4226),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4228),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_DASH] = ACTIONS(4228),
    [anon_sym_PLUS_DOT] = ACTIONS(4228),
    [anon_sym_DASH_DOT] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4228),
    [anon_sym_AMP_AMP] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4226),
    [aux_sym_prefix_op_token1] = ACTIONS(4228),
    [aux_sym_infix_op_token1] = ACTIONS(4226),
    [aux_sym_infix_op_token2] = ACTIONS(4228),
    [anon_sym_PIPE_PIPE] = ACTIONS(4228),
    [anon_sym_BANG_EQ] = ACTIONS(4228),
    [anon_sym_COLON_EQ] = ACTIONS(4226),
    [anon_sym_DOLLAR] = ACTIONS(4228),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(4228),
    [sym_int] = ACTIONS(4228),
    [sym_xint] = ACTIONS(4226),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(219),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4226),
    [sym__newline] = ACTIONS(4226),
  },
  [3578] = {
    [sym_block_comment] = STATE(3578),
    [sym_compiler_directive_decl] = STATE(3578),
    [sym_fsi_directive_decl] = STATE(3578),
    [sym_preproc_line] = STATE(3578),
    [aux_sym_compound_type_repeat1] = STATE(3578),
    [ts_builtin_sym_end] = ACTIONS(3425),
    [sym_identifier] = ACTIONS(3427),
    [anon_sym_namespace] = ACTIONS(3427),
    [anon_sym_module] = ACTIONS(3427),
    [anon_sym_open] = ACTIONS(3427),
    [anon_sym_LBRACK_LT] = ACTIONS(3425),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_type] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_and] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [aux_sym_access_modifier_token1] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3425),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_with] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(3425),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(6036),
    [anon_sym_LT2] = ACTIONS(3427),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3425),
    [anon_sym_default] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_member] = ACTIONS(3427),
    [anon_sym_interface] = ACTIONS(3427),
    [anon_sym_exception] = ACTIONS(3427),
    [anon_sym_abstract] = ACTIONS(3427),
    [anon_sym_val] = ACTIONS(3427),
    [anon_sym_override] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3425),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3425),
    [anon_sym_DASH_DOT] = ACTIONS(3425),
    [anon_sym_PERCENT] = ACTIONS(3425),
    [anon_sym_AMP_AMP] = ACTIONS(3425),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3425),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3425),
    [anon_sym_POUNDload] = ACTIONS(3425),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
  },
  [3579] = {
    [sym_block_comment] = STATE(3579),
    [sym_compiler_directive_decl] = STATE(3579),
    [sym_fsi_directive_decl] = STATE(3579),
    [sym_preproc_line] = STATE(3579),
    [ts_builtin_sym_end] = ACTIONS(3513),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_namespace] = ACTIONS(3515),
    [anon_sym_module] = ACTIONS(3515),
    [anon_sym_open] = ACTIONS(3515),
    [anon_sym_LBRACK_LT] = ACTIONS(3513),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_type] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_and] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [aux_sym_access_modifier_token1] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_with] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(6039),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3513),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3513),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3515),
    [anon_sym_static] = ACTIONS(3515),
    [anon_sym_member] = ACTIONS(3515),
    [anon_sym_interface] = ACTIONS(3515),
    [anon_sym_exception] = ACTIONS(3515),
    [anon_sym_abstract] = ACTIONS(3515),
    [anon_sym_val] = ACTIONS(3515),
    [anon_sym_override] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3513),
    [anon_sym_DASH_DOT] = ACTIONS(3513),
    [anon_sym_PERCENT] = ACTIONS(3513),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3513),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3513),
    [anon_sym_POUNDload] = ACTIONS(3513),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
  },
  [3580] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(6540),
    [sym_function_declaration_left] = STATE(9554),
    [sym_value_declaration_left] = STATE(9554),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3580),
    [sym_compiler_directive_decl] = STATE(3580),
    [sym_fsi_directive_decl] = STATE(3580),
    [sym_preproc_line] = STATE(3580),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3581] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(6662),
    [sym_function_declaration_left] = STATE(10001),
    [sym_value_declaration_left] = STATE(10001),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3581),
    [sym_compiler_directive_decl] = STATE(3581),
    [sym_fsi_directive_decl] = STATE(3581),
    [sym_preproc_line] = STATE(3581),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3582] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(4264),
    [sym_function_declaration_left] = STATE(9839),
    [sym_value_declaration_left] = STATE(9839),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3582),
    [sym_compiler_directive_decl] = STATE(3582),
    [sym_fsi_directive_decl] = STATE(3582),
    [sym_preproc_line] = STATE(3582),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3583] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(3853),
    [sym_function_declaration_left] = STATE(10099),
    [sym_value_declaration_left] = STATE(10099),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3583),
    [sym_compiler_directive_decl] = STATE(3583),
    [sym_fsi_directive_decl] = STATE(3583),
    [sym_preproc_line] = STATE(3583),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3584] = {
    [sym_block_comment] = STATE(3584),
    [sym_compiler_directive_decl] = STATE(3584),
    [sym_fsi_directive_decl] = STATE(3584),
    [sym_preproc_line] = STATE(3584),
    [ts_builtin_sym_end] = ACTIONS(3496),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_namespace] = ACTIONS(3498),
    [anon_sym_module] = ACTIONS(3498),
    [anon_sym_open] = ACTIONS(3498),
    [anon_sym_LBRACK_LT] = ACTIONS(3496),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_type] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_and] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [aux_sym_access_modifier_token1] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3496),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_with] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3496),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3496),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_default] = ACTIONS(3498),
    [anon_sym_static] = ACTIONS(3498),
    [anon_sym_member] = ACTIONS(3498),
    [anon_sym_interface] = ACTIONS(3498),
    [anon_sym_exception] = ACTIONS(3498),
    [anon_sym_abstract] = ACTIONS(3498),
    [anon_sym_val] = ACTIONS(3498),
    [anon_sym_override] = ACTIONS(3498),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3496),
    [anon_sym_DASH_DOT] = ACTIONS(3496),
    [anon_sym_PERCENT] = ACTIONS(3496),
    [anon_sym_AMP_AMP] = ACTIONS(3496),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3496),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3496),
    [anon_sym_POUNDload] = ACTIONS(3496),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
  },
  [3585] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(6266),
    [sym_function_declaration_left] = STATE(10056),
    [sym_value_declaration_left] = STATE(10056),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3585),
    [sym_compiler_directive_decl] = STATE(3585),
    [sym_fsi_directive_decl] = STATE(3585),
    [sym_preproc_line] = STATE(3585),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3586] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(6912),
    [sym_function_declaration_left] = STATE(9667),
    [sym_value_declaration_left] = STATE(9667),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3586),
    [sym_compiler_directive_decl] = STATE(3586),
    [sym_fsi_directive_decl] = STATE(3586),
    [sym_preproc_line] = STATE(3586),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3587] = {
    [sym_attributes] = STATE(3953),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(5287),
    [sym__pattern] = STATE(3215),
    [sym_optional_pattern] = STATE(5287),
    [sym_type_check_pattern] = STATE(5287),
    [sym_attribute_pattern] = STATE(5287),
    [sym_paren_pattern] = STATE(5287),
    [sym_as_pattern] = STATE(5287),
    [sym_cons_pattern] = STATE(5287),
    [sym_disjunct_pattern] = STATE(5287),
    [sym_conjunct_pattern] = STATE(5287),
    [sym_typed_pattern] = STATE(5287),
    [sym_list_pattern] = STATE(5287),
    [sym_array_pattern] = STATE(5287),
    [sym_record_pattern] = STATE(5287),
    [sym_named_field_pattern] = STATE(5287),
    [sym_identifier_pattern] = STATE(5287),
    [sym_long_identifier_or_op] = STATE(3587),
    [sym_char] = STATE(5281),
    [sym_format_string] = STATE(5312),
    [sym__string_literal] = STATE(5312),
    [sym_string] = STATE(5281),
    [sym_verbatim_string] = STATE(5281),
    [sym_bytearray] = STATE(5281),
    [sym_verbatim_bytearray] = STATE(5281),
    [sym_format_triple_quoted_string] = STATE(5246),
    [sym_triple_quoted_string] = STATE(5281),
    [sym_const] = STATE(5287),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(5281),
    [sym_byte] = STATE(5281),
    [sym_int16] = STATE(5281),
    [sym_uint16] = STATE(5281),
    [sym_int32] = STATE(5281),
    [sym_uint32] = STATE(5281),
    [sym_nativeint] = STATE(5281),
    [sym_unativeint] = STATE(5281),
    [sym_int64] = STATE(5281),
    [sym_uint64] = STATE(5281),
    [sym_ieee32] = STATE(5281),
    [sym_ieee64] = STATE(5281),
    [sym_bignum] = STATE(5281),
    [sym_decimal] = STATE(5281),
    [sym_float] = STATE(4951),
    [sym_block_comment] = STATE(3587),
    [sym_compiler_directive_decl] = STATE(3587),
    [sym_fsi_directive_decl] = STATE(3587),
    [sym_preproc_line] = STATE(3587),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5558),
    [anon_sym_LBRACK_LT] = ACTIONS(5562),
    [anon_sym_COLON] = ACTIONS(5558),
    [anon_sym_as] = ACTIONS(5558),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_COMMA] = ACTIONS(5562),
    [anon_sym_null] = ACTIONS(5558),
    [anon_sym__] = ACTIONS(5558),
    [anon_sym_QMARK] = ACTIONS(5562),
    [anon_sym_COLON_QMARK] = ACTIONS(5562),
    [anon_sym_COLON_COLON] = ACTIONS(5562),
    [anon_sym_PIPE] = ACTIONS(5562),
    [anon_sym_AMP] = ACTIONS(5562),
    [anon_sym_LBRACK] = ACTIONS(5558),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5562),
    [anon_sym_LBRACE] = ACTIONS(5562),
    [anon_sym_in] = ACTIONS(5558),
    [aux_sym_char_token1] = ACTIONS(5562),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5558),
    [anon_sym_DQUOTE] = ACTIONS(5558),
    [anon_sym_AT_DQUOTE] = ACTIONS(5562),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5562),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5562),
    [sym_bool] = ACTIONS(5558),
    [sym_unit] = ACTIONS(5562),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5558),
    [sym_op_identifier] = ACTIONS(5562),
    [sym_int] = ACTIONS(5558),
    [sym_xint] = ACTIONS(5562),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3588] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(4286),
    [sym_function_declaration_left] = STATE(10184),
    [sym_value_declaration_left] = STATE(10184),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3588),
    [sym_compiler_directive_decl] = STATE(3588),
    [sym_fsi_directive_decl] = STATE(3588),
    [sym_preproc_line] = STATE(3588),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3589] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(7377),
    [sym_function_declaration_left] = STATE(9771),
    [sym_value_declaration_left] = STATE(9771),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3589),
    [sym_compiler_directive_decl] = STATE(3589),
    [sym_fsi_directive_decl] = STATE(3589),
    [sym_preproc_line] = STATE(3589),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3590] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(4232),
    [sym_function_declaration_left] = STATE(9566),
    [sym_value_declaration_left] = STATE(9566),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3590),
    [sym_compiler_directive_decl] = STATE(3590),
    [sym_fsi_directive_decl] = STATE(3590),
    [sym_preproc_line] = STATE(3590),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3591] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(4222),
    [sym_function_declaration_left] = STATE(9405),
    [sym_value_declaration_left] = STATE(9405),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3591),
    [sym_compiler_directive_decl] = STATE(3591),
    [sym_fsi_directive_decl] = STATE(3591),
    [sym_preproc_line] = STATE(3591),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3592] = {
    [sym_block_comment] = STATE(3592),
    [sym_compiler_directive_decl] = STATE(3592),
    [sym_fsi_directive_decl] = STATE(3592),
    [sym_preproc_line] = STATE(3592),
    [ts_builtin_sym_end] = ACTIONS(3485),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_namespace] = ACTIONS(3487),
    [anon_sym_module] = ACTIONS(3487),
    [anon_sym_open] = ACTIONS(3487),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_type] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_and] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [aux_sym_access_modifier_token1] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3485),
    [anon_sym_DOT] = ACTIONS(3485),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_with] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3485),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3485),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_member] = ACTIONS(3487),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_exception] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_val] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3485),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3485),
    [anon_sym_DASH_DOT] = ACTIONS(3485),
    [anon_sym_PERCENT] = ACTIONS(3485),
    [anon_sym_AMP_AMP] = ACTIONS(3485),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3485),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3485),
    [anon_sym_POUNDload] = ACTIONS(3485),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
  },
  [3593] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(7385),
    [sym_function_declaration_left] = STATE(10151),
    [sym_value_declaration_left] = STATE(10151),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3593),
    [sym_compiler_directive_decl] = STATE(3593),
    [sym_fsi_directive_decl] = STATE(3593),
    [sym_preproc_line] = STATE(3593),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3594] = {
    [sym_attributes] = STATE(3953),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(5287),
    [sym__pattern] = STATE(3293),
    [sym_optional_pattern] = STATE(5287),
    [sym_type_check_pattern] = STATE(5287),
    [sym_attribute_pattern] = STATE(5287),
    [sym_paren_pattern] = STATE(5287),
    [sym_as_pattern] = STATE(5287),
    [sym_cons_pattern] = STATE(5287),
    [sym_disjunct_pattern] = STATE(5287),
    [sym_conjunct_pattern] = STATE(5287),
    [sym_typed_pattern] = STATE(5287),
    [sym_list_pattern] = STATE(5287),
    [sym_array_pattern] = STATE(5287),
    [sym_record_pattern] = STATE(5287),
    [sym_named_field_pattern] = STATE(5287),
    [sym_identifier_pattern] = STATE(5287),
    [sym_long_identifier_or_op] = STATE(3587),
    [sym_char] = STATE(5281),
    [sym_format_string] = STATE(5312),
    [sym__string_literal] = STATE(5312),
    [sym_string] = STATE(5281),
    [sym_verbatim_string] = STATE(5281),
    [sym_bytearray] = STATE(5281),
    [sym_verbatim_bytearray] = STATE(5281),
    [sym_format_triple_quoted_string] = STATE(5246),
    [sym_triple_quoted_string] = STATE(5281),
    [sym_const] = STATE(5287),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(5281),
    [sym_byte] = STATE(5281),
    [sym_int16] = STATE(5281),
    [sym_uint16] = STATE(5281),
    [sym_int32] = STATE(5281),
    [sym_uint32] = STATE(5281),
    [sym_nativeint] = STATE(5281),
    [sym_unativeint] = STATE(5281),
    [sym_int64] = STATE(5281),
    [sym_uint64] = STATE(5281),
    [sym_ieee32] = STATE(5281),
    [sym_ieee64] = STATE(5281),
    [sym_bignum] = STATE(5281),
    [sym_decimal] = STATE(5281),
    [sym_float] = STATE(4951),
    [sym_block_comment] = STATE(3594),
    [sym_compiler_directive_decl] = STATE(3594),
    [sym_fsi_directive_decl] = STATE(3594),
    [sym_preproc_line] = STATE(3594),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5835),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_COLON] = ACTIONS(5558),
    [anon_sym_as] = ACTIONS(5558),
    [anon_sym_LPAREN] = ACTIONS(6041),
    [anon_sym_COMMA] = ACTIONS(5562),
    [anon_sym_null] = ACTIONS(6043),
    [anon_sym__] = ACTIONS(6045),
    [anon_sym_QMARK] = ACTIONS(6047),
    [anon_sym_COLON_QMARK] = ACTIONS(6049),
    [anon_sym_COLON_COLON] = ACTIONS(5562),
    [anon_sym_PIPE] = ACTIONS(5562),
    [anon_sym_AMP] = ACTIONS(5562),
    [anon_sym_LBRACK] = ACTIONS(6051),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6053),
    [anon_sym_LBRACE] = ACTIONS(6055),
    [anon_sym_in] = ACTIONS(5558),
    [aux_sym_char_token1] = ACTIONS(6057),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6059),
    [anon_sym_DQUOTE] = ACTIONS(6061),
    [anon_sym_AT_DQUOTE] = ACTIONS(6063),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6065),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6067),
    [sym_bool] = ACTIONS(6069),
    [sym_unit] = ACTIONS(6071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(6073),
    [sym_xint] = ACTIONS(6075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3595] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(6811),
    [sym_function_declaration_left] = STATE(9616),
    [sym_value_declaration_left] = STATE(9616),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3595),
    [sym_compiler_directive_decl] = STATE(3595),
    [sym_fsi_directive_decl] = STATE(3595),
    [sym_preproc_line] = STATE(3595),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3596] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(6348),
    [sym_function_declaration_left] = STATE(9685),
    [sym_value_declaration_left] = STATE(9685),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3596),
    [sym_compiler_directive_decl] = STATE(3596),
    [sym_fsi_directive_decl] = STATE(3596),
    [sym_preproc_line] = STATE(3596),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3597] = {
    [sym_block_comment] = STATE(3597),
    [sym_compiler_directive_decl] = STATE(3597),
    [sym_fsi_directive_decl] = STATE(3597),
    [sym_preproc_line] = STATE(3597),
    [aux_sym_compound_type_repeat1] = STATE(3578),
    [ts_builtin_sym_end] = ACTIONS(3466),
    [sym_identifier] = ACTIONS(3468),
    [anon_sym_namespace] = ACTIONS(3468),
    [anon_sym_module] = ACTIONS(3468),
    [anon_sym_open] = ACTIONS(3468),
    [anon_sym_LBRACK_LT] = ACTIONS(3466),
    [anon_sym_return] = ACTIONS(3468),
    [anon_sym_type] = ACTIONS(3468),
    [anon_sym_do] = ACTIONS(3468),
    [anon_sym_and] = ACTIONS(3468),
    [anon_sym_let] = ACTIONS(3468),
    [anon_sym_let_BANG] = ACTIONS(3466),
    [aux_sym_access_modifier_token1] = ACTIONS(3466),
    [anon_sym_LPAREN] = ACTIONS(3468),
    [anon_sym_null] = ACTIONS(3468),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LBRACK] = ACTIONS(3468),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3466),
    [anon_sym_LBRACE] = ACTIONS(3468),
    [anon_sym_LT_AT] = ACTIONS(3468),
    [anon_sym_LT_AT_AT] = ACTIONS(3466),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3466),
    [anon_sym_new] = ACTIONS(3468),
    [anon_sym_with] = ACTIONS(3468),
    [anon_sym_return_BANG] = ACTIONS(3466),
    [anon_sym_yield] = ACTIONS(3468),
    [anon_sym_yield_BANG] = ACTIONS(3466),
    [anon_sym_lazy] = ACTIONS(3468),
    [anon_sym_assert] = ACTIONS(3468),
    [anon_sym_upcast] = ACTIONS(3468),
    [anon_sym_downcast] = ACTIONS(3468),
    [anon_sym_for] = ACTIONS(3468),
    [anon_sym_while] = ACTIONS(3468),
    [anon_sym_if] = ACTIONS(3468),
    [anon_sym_fun] = ACTIONS(3468),
    [anon_sym_DASH_GT] = ACTIONS(3466),
    [anon_sym_try] = ACTIONS(3468),
    [anon_sym_match] = ACTIONS(3468),
    [anon_sym_match_BANG] = ACTIONS(3466),
    [anon_sym_function] = ACTIONS(3468),
    [anon_sym_use] = ACTIONS(3468),
    [anon_sym_use_BANG] = ACTIONS(3466),
    [anon_sym_do_BANG] = ACTIONS(3466),
    [anon_sym_begin] = ACTIONS(3468),
    [anon_sym_STAR] = ACTIONS(5387),
    [anon_sym_LT2] = ACTIONS(3468),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3466),
    [anon_sym_default] = ACTIONS(3468),
    [anon_sym_static] = ACTIONS(3468),
    [anon_sym_member] = ACTIONS(3468),
    [anon_sym_interface] = ACTIONS(3468),
    [anon_sym_exception] = ACTIONS(3468),
    [anon_sym_abstract] = ACTIONS(3468),
    [anon_sym_val] = ACTIONS(3468),
    [anon_sym_override] = ACTIONS(3468),
    [aux_sym_char_token1] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3468),
    [anon_sym_DQUOTE] = ACTIONS(3468),
    [anon_sym_AT_DQUOTE] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [sym_bool] = ACTIONS(3468),
    [sym_unit] = ACTIONS(3466),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3468),
    [sym_op_identifier] = ACTIONS(3466),
    [anon_sym_PLUS] = ACTIONS(3468),
    [anon_sym_DASH] = ACTIONS(3468),
    [anon_sym_PLUS_DOT] = ACTIONS(3466),
    [anon_sym_DASH_DOT] = ACTIONS(3466),
    [anon_sym_PERCENT] = ACTIONS(3466),
    [anon_sym_AMP_AMP] = ACTIONS(3466),
    [anon_sym_TILDE] = ACTIONS(3466),
    [aux_sym_prefix_op_token1] = ACTIONS(3466),
    [sym_int] = ACTIONS(3468),
    [sym_xint] = ACTIONS(3466),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3466),
    [anon_sym_POUNDload] = ACTIONS(3466),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3466),
  },
  [3598] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(8940),
    [sym_function_declaration_left] = STATE(10066),
    [sym_value_declaration_left] = STATE(10066),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3598),
    [sym_compiler_directive_decl] = STATE(3598),
    [sym_fsi_directive_decl] = STATE(3598),
    [sym_preproc_line] = STATE(3598),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3599] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym__function_or_value_defn_body] = STATE(10177),
    [sym_function_declaration_left] = STATE(9536),
    [sym_value_declaration_left] = STATE(9536),
    [sym_access_modifier] = STATE(3982),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7696),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4103),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3599),
    [sym_compiler_directive_decl] = STATE(3599),
    [sym_fsi_directive_decl] = STATE(3599),
    [sym_preproc_line] = STATE(3599),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_inline] = ACTIONS(5211),
    [anon_sym_mutable] = ACTIONS(5213),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3600] = {
    [sym_block_comment] = STATE(3600),
    [sym_compiler_directive_decl] = STATE(3600),
    [sym_fsi_directive_decl] = STATE(3600),
    [sym_preproc_line] = STATE(3600),
    [ts_builtin_sym_end] = ACTIONS(3549),
    [sym_identifier] = ACTIONS(3551),
    [anon_sym_namespace] = ACTIONS(3551),
    [anon_sym_module] = ACTIONS(3551),
    [anon_sym_open] = ACTIONS(3551),
    [anon_sym_LBRACK_LT] = ACTIONS(3549),
    [anon_sym_return] = ACTIONS(3551),
    [anon_sym_type] = ACTIONS(3551),
    [anon_sym_do] = ACTIONS(3551),
    [anon_sym_and] = ACTIONS(3551),
    [anon_sym_let] = ACTIONS(3551),
    [anon_sym_let_BANG] = ACTIONS(3549),
    [aux_sym_access_modifier_token1] = ACTIONS(3549),
    [anon_sym_LPAREN] = ACTIONS(3551),
    [anon_sym_null] = ACTIONS(3551),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(3551),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3549),
    [anon_sym_LBRACE] = ACTIONS(3551),
    [anon_sym_LT_AT] = ACTIONS(3551),
    [anon_sym_LT_AT_AT] = ACTIONS(3549),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3549),
    [anon_sym_new] = ACTIONS(3551),
    [anon_sym_with] = ACTIONS(3551),
    [anon_sym_return_BANG] = ACTIONS(3549),
    [anon_sym_yield] = ACTIONS(3551),
    [anon_sym_yield_BANG] = ACTIONS(3549),
    [anon_sym_lazy] = ACTIONS(3551),
    [anon_sym_assert] = ACTIONS(3551),
    [anon_sym_upcast] = ACTIONS(3551),
    [anon_sym_downcast] = ACTIONS(3551),
    [anon_sym_for] = ACTIONS(3551),
    [anon_sym_while] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(3551),
    [anon_sym_fun] = ACTIONS(3551),
    [anon_sym_DASH_GT] = ACTIONS(3549),
    [anon_sym_try] = ACTIONS(3551),
    [anon_sym_match] = ACTIONS(3551),
    [anon_sym_match_BANG] = ACTIONS(3549),
    [anon_sym_function] = ACTIONS(3551),
    [anon_sym_use] = ACTIONS(3551),
    [anon_sym_use_BANG] = ACTIONS(3549),
    [anon_sym_do_BANG] = ACTIONS(3549),
    [anon_sym_begin] = ACTIONS(3551),
    [anon_sym_STAR] = ACTIONS(3549),
    [anon_sym_LT2] = ACTIONS(3551),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3549),
    [anon_sym_default] = ACTIONS(3551),
    [anon_sym_static] = ACTIONS(3551),
    [anon_sym_member] = ACTIONS(3551),
    [anon_sym_interface] = ACTIONS(3551),
    [anon_sym_exception] = ACTIONS(3551),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_val] = ACTIONS(3551),
    [anon_sym_override] = ACTIONS(3551),
    [aux_sym_char_token1] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [anon_sym_AT_DQUOTE] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [sym_bool] = ACTIONS(3551),
    [sym_unit] = ACTIONS(3549),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3551),
    [sym_op_identifier] = ACTIONS(3549),
    [anon_sym_PLUS] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(3551),
    [anon_sym_PLUS_DOT] = ACTIONS(3549),
    [anon_sym_DASH_DOT] = ACTIONS(3549),
    [anon_sym_PERCENT] = ACTIONS(3549),
    [anon_sym_AMP_AMP] = ACTIONS(3549),
    [anon_sym_TILDE] = ACTIONS(3549),
    [aux_sym_prefix_op_token1] = ACTIONS(3549),
    [sym_int] = ACTIONS(3551),
    [sym_xint] = ACTIONS(3549),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3549),
    [anon_sym_POUNDload] = ACTIONS(3549),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3549),
  },
  [3601] = {
    [sym_block_comment] = STATE(3601),
    [sym_compiler_directive_decl] = STATE(3601),
    [sym_fsi_directive_decl] = STATE(3601),
    [sym_preproc_line] = STATE(3601),
    [ts_builtin_sym_end] = ACTIONS(3541),
    [sym_identifier] = ACTIONS(3543),
    [anon_sym_namespace] = ACTIONS(3543),
    [anon_sym_module] = ACTIONS(3543),
    [anon_sym_open] = ACTIONS(3543),
    [anon_sym_LBRACK_LT] = ACTIONS(3541),
    [anon_sym_return] = ACTIONS(3543),
    [anon_sym_type] = ACTIONS(3543),
    [anon_sym_do] = ACTIONS(3543),
    [anon_sym_and] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3543),
    [anon_sym_let_BANG] = ACTIONS(3541),
    [aux_sym_access_modifier_token1] = ACTIONS(3541),
    [anon_sym_LPAREN] = ACTIONS(3543),
    [anon_sym_null] = ACTIONS(3543),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3543),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3541),
    [anon_sym_LBRACE] = ACTIONS(3543),
    [anon_sym_LT_AT] = ACTIONS(3543),
    [anon_sym_LT_AT_AT] = ACTIONS(3541),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3541),
    [anon_sym_new] = ACTIONS(3543),
    [anon_sym_with] = ACTIONS(3543),
    [anon_sym_return_BANG] = ACTIONS(3541),
    [anon_sym_yield] = ACTIONS(3543),
    [anon_sym_yield_BANG] = ACTIONS(3541),
    [anon_sym_lazy] = ACTIONS(3543),
    [anon_sym_assert] = ACTIONS(3543),
    [anon_sym_upcast] = ACTIONS(3543),
    [anon_sym_downcast] = ACTIONS(3543),
    [anon_sym_for] = ACTIONS(3543),
    [anon_sym_while] = ACTIONS(3543),
    [anon_sym_if] = ACTIONS(3543),
    [anon_sym_fun] = ACTIONS(3543),
    [anon_sym_DASH_GT] = ACTIONS(3541),
    [anon_sym_try] = ACTIONS(3543),
    [anon_sym_match] = ACTIONS(3543),
    [anon_sym_match_BANG] = ACTIONS(3541),
    [anon_sym_function] = ACTIONS(3543),
    [anon_sym_use] = ACTIONS(3543),
    [anon_sym_use_BANG] = ACTIONS(3541),
    [anon_sym_do_BANG] = ACTIONS(3541),
    [anon_sym_begin] = ACTIONS(3543),
    [anon_sym_STAR] = ACTIONS(3541),
    [anon_sym_LT2] = ACTIONS(3543),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_default] = ACTIONS(3543),
    [anon_sym_static] = ACTIONS(3543),
    [anon_sym_member] = ACTIONS(3543),
    [anon_sym_interface] = ACTIONS(3543),
    [anon_sym_exception] = ACTIONS(3543),
    [anon_sym_abstract] = ACTIONS(3543),
    [anon_sym_val] = ACTIONS(3543),
    [anon_sym_override] = ACTIONS(3543),
    [aux_sym_char_token1] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3543),
    [anon_sym_DQUOTE] = ACTIONS(3543),
    [anon_sym_AT_DQUOTE] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [sym_bool] = ACTIONS(3543),
    [sym_unit] = ACTIONS(3541),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3543),
    [sym_op_identifier] = ACTIONS(3541),
    [anon_sym_PLUS] = ACTIONS(3543),
    [anon_sym_DASH] = ACTIONS(3543),
    [anon_sym_PLUS_DOT] = ACTIONS(3541),
    [anon_sym_DASH_DOT] = ACTIONS(3541),
    [anon_sym_PERCENT] = ACTIONS(3541),
    [anon_sym_AMP_AMP] = ACTIONS(3541),
    [anon_sym_TILDE] = ACTIONS(3541),
    [aux_sym_prefix_op_token1] = ACTIONS(3541),
    [sym_int] = ACTIONS(3543),
    [sym_xint] = ACTIONS(3541),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3541),
    [anon_sym_POUNDload] = ACTIONS(3541),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3541),
  },
  [3602] = {
    [sym_block_comment] = STATE(3602),
    [sym_compiler_directive_decl] = STATE(3602),
    [sym_fsi_directive_decl] = STATE(3602),
    [sym_preproc_line] = STATE(3602),
    [ts_builtin_sym_end] = ACTIONS(3525),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_namespace] = ACTIONS(3527),
    [anon_sym_module] = ACTIONS(3527),
    [anon_sym_open] = ACTIONS(3527),
    [anon_sym_LBRACK_LT] = ACTIONS(3525),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_type] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_and] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [aux_sym_access_modifier_token1] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3525),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_with] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_DASH_GT] = ACTIONS(3525),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_STAR] = ACTIONS(3525),
    [anon_sym_LT2] = ACTIONS(3527),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_default] = ACTIONS(3527),
    [anon_sym_static] = ACTIONS(3527),
    [anon_sym_member] = ACTIONS(3527),
    [anon_sym_interface] = ACTIONS(3527),
    [anon_sym_exception] = ACTIONS(3527),
    [anon_sym_abstract] = ACTIONS(3527),
    [anon_sym_val] = ACTIONS(3527),
    [anon_sym_override] = ACTIONS(3527),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3525),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3525),
    [anon_sym_DASH_DOT] = ACTIONS(3525),
    [anon_sym_PERCENT] = ACTIONS(3525),
    [anon_sym_AMP_AMP] = ACTIONS(3525),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3525),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3525),
    [anon_sym_POUNDload] = ACTIONS(3525),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3525),
  },
  [3603] = {
    [sym_block_comment] = STATE(3603),
    [sym_compiler_directive_decl] = STATE(3603),
    [sym_fsi_directive_decl] = STATE(3603),
    [sym_preproc_line] = STATE(3603),
    [ts_builtin_sym_end] = ACTIONS(3545),
    [sym_identifier] = ACTIONS(3547),
    [anon_sym_namespace] = ACTIONS(3547),
    [anon_sym_module] = ACTIONS(3547),
    [anon_sym_open] = ACTIONS(3547),
    [anon_sym_LBRACK_LT] = ACTIONS(3545),
    [anon_sym_return] = ACTIONS(3547),
    [anon_sym_type] = ACTIONS(3547),
    [anon_sym_do] = ACTIONS(3547),
    [anon_sym_and] = ACTIONS(3547),
    [anon_sym_let] = ACTIONS(3547),
    [anon_sym_let_BANG] = ACTIONS(3545),
    [aux_sym_access_modifier_token1] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(3547),
    [anon_sym_null] = ACTIONS(3547),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3545),
    [anon_sym_LBRACE] = ACTIONS(3547),
    [anon_sym_LT_AT] = ACTIONS(3547),
    [anon_sym_LT_AT_AT] = ACTIONS(3545),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3545),
    [anon_sym_new] = ACTIONS(3547),
    [anon_sym_with] = ACTIONS(3547),
    [anon_sym_return_BANG] = ACTIONS(3545),
    [anon_sym_yield] = ACTIONS(3547),
    [anon_sym_yield_BANG] = ACTIONS(3545),
    [anon_sym_lazy] = ACTIONS(3547),
    [anon_sym_assert] = ACTIONS(3547),
    [anon_sym_upcast] = ACTIONS(3547),
    [anon_sym_downcast] = ACTIONS(3547),
    [anon_sym_for] = ACTIONS(3547),
    [anon_sym_while] = ACTIONS(3547),
    [anon_sym_if] = ACTIONS(3547),
    [anon_sym_fun] = ACTIONS(3547),
    [anon_sym_DASH_GT] = ACTIONS(3545),
    [anon_sym_try] = ACTIONS(3547),
    [anon_sym_match] = ACTIONS(3547),
    [anon_sym_match_BANG] = ACTIONS(3545),
    [anon_sym_function] = ACTIONS(3547),
    [anon_sym_use] = ACTIONS(3547),
    [anon_sym_use_BANG] = ACTIONS(3545),
    [anon_sym_do_BANG] = ACTIONS(3545),
    [anon_sym_begin] = ACTIONS(3547),
    [anon_sym_STAR] = ACTIONS(3545),
    [anon_sym_LT2] = ACTIONS(3547),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_default] = ACTIONS(3547),
    [anon_sym_static] = ACTIONS(3547),
    [anon_sym_member] = ACTIONS(3547),
    [anon_sym_interface] = ACTIONS(3547),
    [anon_sym_exception] = ACTIONS(3547),
    [anon_sym_abstract] = ACTIONS(3547),
    [anon_sym_val] = ACTIONS(3547),
    [anon_sym_override] = ACTIONS(3547),
    [aux_sym_char_token1] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3547),
    [anon_sym_DQUOTE] = ACTIONS(3547),
    [anon_sym_AT_DQUOTE] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [sym_bool] = ACTIONS(3547),
    [sym_unit] = ACTIONS(3545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3547),
    [sym_op_identifier] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PLUS_DOT] = ACTIONS(3545),
    [anon_sym_DASH_DOT] = ACTIONS(3545),
    [anon_sym_PERCENT] = ACTIONS(3545),
    [anon_sym_AMP_AMP] = ACTIONS(3545),
    [anon_sym_TILDE] = ACTIONS(3545),
    [aux_sym_prefix_op_token1] = ACTIONS(3545),
    [sym_int] = ACTIONS(3547),
    [sym_xint] = ACTIONS(3545),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3545),
    [anon_sym_POUNDload] = ACTIONS(3545),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3545),
  },
  [3604] = {
    [sym_block_comment] = STATE(3604),
    [sym_compiler_directive_decl] = STATE(3604),
    [sym_fsi_directive_decl] = STATE(3604),
    [sym_preproc_line] = STATE(3604),
    [ts_builtin_sym_end] = ACTIONS(3529),
    [sym_identifier] = ACTIONS(3531),
    [anon_sym_namespace] = ACTIONS(3531),
    [anon_sym_module] = ACTIONS(3531),
    [anon_sym_open] = ACTIONS(3531),
    [anon_sym_LBRACK_LT] = ACTIONS(3529),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_type] = ACTIONS(3531),
    [anon_sym_do] = ACTIONS(3531),
    [anon_sym_and] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [aux_sym_access_modifier_token1] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_null] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3531),
    [anon_sym_LT_AT] = ACTIONS(3531),
    [anon_sym_LT_AT_AT] = ACTIONS(3529),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3531),
    [anon_sym_with] = ACTIONS(3531),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3531),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3531),
    [anon_sym_assert] = ACTIONS(3531),
    [anon_sym_upcast] = ACTIONS(3531),
    [anon_sym_downcast] = ACTIONS(3531),
    [anon_sym_for] = ACTIONS(3531),
    [anon_sym_while] = ACTIONS(3531),
    [anon_sym_if] = ACTIONS(3531),
    [anon_sym_fun] = ACTIONS(3531),
    [anon_sym_DASH_GT] = ACTIONS(3529),
    [anon_sym_try] = ACTIONS(3531),
    [anon_sym_match] = ACTIONS(3531),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3531),
    [anon_sym_use] = ACTIONS(3531),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3531),
    [anon_sym_STAR] = ACTIONS(3529),
    [anon_sym_LT2] = ACTIONS(3531),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_default] = ACTIONS(3531),
    [anon_sym_static] = ACTIONS(3531),
    [anon_sym_member] = ACTIONS(3531),
    [anon_sym_interface] = ACTIONS(3531),
    [anon_sym_exception] = ACTIONS(3531),
    [anon_sym_abstract] = ACTIONS(3531),
    [anon_sym_val] = ACTIONS(3531),
    [anon_sym_override] = ACTIONS(3531),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3531),
    [anon_sym_DQUOTE] = ACTIONS(3531),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3531),
    [sym_unit] = ACTIONS(3529),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3531),
    [sym_op_identifier] = ACTIONS(3529),
    [anon_sym_PLUS] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(3531),
    [anon_sym_PLUS_DOT] = ACTIONS(3529),
    [anon_sym_DASH_DOT] = ACTIONS(3529),
    [anon_sym_PERCENT] = ACTIONS(3529),
    [anon_sym_AMP_AMP] = ACTIONS(3529),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3529),
    [sym_int] = ACTIONS(3531),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3529),
    [anon_sym_POUNDload] = ACTIONS(3529),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3529),
  },
  [3605] = {
    [sym_block_comment] = STATE(3605),
    [sym_compiler_directive_decl] = STATE(3605),
    [sym_fsi_directive_decl] = STATE(3605),
    [sym_preproc_line] = STATE(3605),
    [ts_builtin_sym_end] = ACTIONS(3560),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_namespace] = ACTIONS(3562),
    [anon_sym_module] = ACTIONS(3562),
    [anon_sym_open] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3560),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_type] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_and] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_let_BANG] = ACTIONS(3560),
    [aux_sym_access_modifier_token1] = ACTIONS(3560),
    [anon_sym_LPAREN] = ACTIONS(3562),
    [anon_sym_null] = ACTIONS(3562),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3560),
    [anon_sym_LBRACE] = ACTIONS(3562),
    [anon_sym_LT_AT] = ACTIONS(3562),
    [anon_sym_LT_AT_AT] = ACTIONS(3560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3560),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_with] = ACTIONS(3562),
    [anon_sym_return_BANG] = ACTIONS(3560),
    [anon_sym_yield] = ACTIONS(3562),
    [anon_sym_yield_BANG] = ACTIONS(3560),
    [anon_sym_lazy] = ACTIONS(3562),
    [anon_sym_assert] = ACTIONS(3562),
    [anon_sym_upcast] = ACTIONS(3562),
    [anon_sym_downcast] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_fun] = ACTIONS(3562),
    [anon_sym_DASH_GT] = ACTIONS(3560),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_match] = ACTIONS(3562),
    [anon_sym_match_BANG] = ACTIONS(3560),
    [anon_sym_function] = ACTIONS(3562),
    [anon_sym_use] = ACTIONS(3562),
    [anon_sym_use_BANG] = ACTIONS(3560),
    [anon_sym_do_BANG] = ACTIONS(3560),
    [anon_sym_begin] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_LT2] = ACTIONS(3562),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3560),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_member] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_exception] = ACTIONS(3562),
    [anon_sym_abstract] = ACTIONS(3562),
    [anon_sym_val] = ACTIONS(3562),
    [anon_sym_override] = ACTIONS(3562),
    [aux_sym_char_token1] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(3562),
    [anon_sym_AT_DQUOTE] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [sym_bool] = ACTIONS(3562),
    [sym_unit] = ACTIONS(3560),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3562),
    [sym_op_identifier] = ACTIONS(3560),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS_DOT] = ACTIONS(3560),
    [anon_sym_DASH_DOT] = ACTIONS(3560),
    [anon_sym_PERCENT] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [aux_sym_prefix_op_token1] = ACTIONS(3560),
    [sym_int] = ACTIONS(3562),
    [sym_xint] = ACTIONS(3560),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3560),
    [anon_sym_POUNDload] = ACTIONS(3560),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3560),
  },
  [3606] = {
    [sym_block_comment] = STATE(3606),
    [sym_compiler_directive_decl] = STATE(3606),
    [sym_fsi_directive_decl] = STATE(3606),
    [sym_preproc_line] = STATE(3606),
    [ts_builtin_sym_end] = ACTIONS(3503),
    [sym_identifier] = ACTIONS(3505),
    [anon_sym_namespace] = ACTIONS(3505),
    [anon_sym_module] = ACTIONS(3505),
    [anon_sym_open] = ACTIONS(3505),
    [anon_sym_LBRACK_LT] = ACTIONS(3503),
    [anon_sym_return] = ACTIONS(3505),
    [anon_sym_type] = ACTIONS(3505),
    [anon_sym_do] = ACTIONS(3505),
    [anon_sym_and] = ACTIONS(3505),
    [anon_sym_let] = ACTIONS(3505),
    [anon_sym_let_BANG] = ACTIONS(3503),
    [aux_sym_access_modifier_token1] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3505),
    [anon_sym_null] = ACTIONS(3505),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3503),
    [anon_sym_LBRACE] = ACTIONS(3505),
    [anon_sym_LT_AT] = ACTIONS(3505),
    [anon_sym_LT_AT_AT] = ACTIONS(3503),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3503),
    [anon_sym_new] = ACTIONS(3505),
    [anon_sym_with] = ACTIONS(3505),
    [anon_sym_return_BANG] = ACTIONS(3503),
    [anon_sym_yield] = ACTIONS(3505),
    [anon_sym_yield_BANG] = ACTIONS(3503),
    [anon_sym_lazy] = ACTIONS(3505),
    [anon_sym_assert] = ACTIONS(3505),
    [anon_sym_upcast] = ACTIONS(3505),
    [anon_sym_downcast] = ACTIONS(3505),
    [anon_sym_for] = ACTIONS(3505),
    [anon_sym_while] = ACTIONS(3505),
    [anon_sym_if] = ACTIONS(3505),
    [anon_sym_fun] = ACTIONS(3505),
    [anon_sym_DASH_GT] = ACTIONS(3503),
    [anon_sym_try] = ACTIONS(3505),
    [anon_sym_match] = ACTIONS(3505),
    [anon_sym_match_BANG] = ACTIONS(3503),
    [anon_sym_function] = ACTIONS(3505),
    [anon_sym_use] = ACTIONS(3505),
    [anon_sym_use_BANG] = ACTIONS(3503),
    [anon_sym_do_BANG] = ACTIONS(3503),
    [anon_sym_begin] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3503),
    [anon_sym_LT2] = ACTIONS(6077),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_default] = ACTIONS(3505),
    [anon_sym_static] = ACTIONS(3505),
    [anon_sym_member] = ACTIONS(3505),
    [anon_sym_interface] = ACTIONS(3505),
    [anon_sym_exception] = ACTIONS(3505),
    [anon_sym_abstract] = ACTIONS(3505),
    [anon_sym_val] = ACTIONS(3505),
    [anon_sym_override] = ACTIONS(3505),
    [aux_sym_char_token1] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3505),
    [anon_sym_DQUOTE] = ACTIONS(3505),
    [anon_sym_AT_DQUOTE] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [sym_bool] = ACTIONS(3505),
    [sym_unit] = ACTIONS(3503),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3505),
    [sym_op_identifier] = ACTIONS(3503),
    [anon_sym_PLUS] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3505),
    [anon_sym_PLUS_DOT] = ACTIONS(3503),
    [anon_sym_DASH_DOT] = ACTIONS(3503),
    [anon_sym_PERCENT] = ACTIONS(3503),
    [anon_sym_AMP_AMP] = ACTIONS(3503),
    [anon_sym_TILDE] = ACTIONS(3503),
    [aux_sym_prefix_op_token1] = ACTIONS(3503),
    [sym_int] = ACTIONS(3505),
    [sym_xint] = ACTIONS(3503),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3503),
    [anon_sym_POUNDload] = ACTIONS(3503),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3503),
  },
  [3607] = {
    [sym_block_comment] = STATE(3607),
    [sym_compiler_directive_decl] = STATE(3607),
    [sym_fsi_directive_decl] = STATE(3607),
    [sym_preproc_line] = STATE(3607),
    [ts_builtin_sym_end] = ACTIONS(3521),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_namespace] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3523),
    [anon_sym_open] = ACTIONS(3523),
    [anon_sym_LBRACK_LT] = ACTIONS(3521),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_type] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_and] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3521),
    [aux_sym_access_modifier_token1] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3521),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_with] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3521),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3521),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_DASH_GT] = ACTIONS(3521),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3521),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3521),
    [anon_sym_do_BANG] = ACTIONS(3521),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_STAR] = ACTIONS(3521),
    [anon_sym_LT2] = ACTIONS(3523),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3521),
    [anon_sym_default] = ACTIONS(3523),
    [anon_sym_static] = ACTIONS(3523),
    [anon_sym_member] = ACTIONS(3523),
    [anon_sym_interface] = ACTIONS(3523),
    [anon_sym_exception] = ACTIONS(3523),
    [anon_sym_abstract] = ACTIONS(3523),
    [anon_sym_val] = ACTIONS(3523),
    [anon_sym_override] = ACTIONS(3523),
    [aux_sym_char_token1] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3521),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3521),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3521),
    [anon_sym_DASH_DOT] = ACTIONS(3521),
    [anon_sym_PERCENT] = ACTIONS(3521),
    [anon_sym_AMP_AMP] = ACTIONS(3521),
    [anon_sym_TILDE] = ACTIONS(3521),
    [aux_sym_prefix_op_token1] = ACTIONS(3521),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3521),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3521),
    [anon_sym_POUNDload] = ACTIONS(3521),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3521),
  },
  [3608] = {
    [sym_block_comment] = STATE(3608),
    [sym_compiler_directive_decl] = STATE(3608),
    [sym_fsi_directive_decl] = STATE(3608),
    [sym_preproc_line] = STATE(3608),
    [ts_builtin_sym_end] = ACTIONS(3517),
    [sym_identifier] = ACTIONS(3519),
    [anon_sym_namespace] = ACTIONS(3519),
    [anon_sym_module] = ACTIONS(3519),
    [anon_sym_open] = ACTIONS(3519),
    [anon_sym_LBRACK_LT] = ACTIONS(3517),
    [anon_sym_return] = ACTIONS(3519),
    [anon_sym_type] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(3519),
    [anon_sym_and] = ACTIONS(3519),
    [anon_sym_let] = ACTIONS(3519),
    [anon_sym_let_BANG] = ACTIONS(3517),
    [aux_sym_access_modifier_token1] = ACTIONS(3517),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [anon_sym_null] = ACTIONS(3519),
    [anon_sym_AMP] = ACTIONS(3519),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_LT_AT] = ACTIONS(3519),
    [anon_sym_LT_AT_AT] = ACTIONS(3517),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3519),
    [anon_sym_with] = ACTIONS(3519),
    [anon_sym_return_BANG] = ACTIONS(3517),
    [anon_sym_yield] = ACTIONS(3519),
    [anon_sym_yield_BANG] = ACTIONS(3517),
    [anon_sym_lazy] = ACTIONS(3519),
    [anon_sym_assert] = ACTIONS(3519),
    [anon_sym_upcast] = ACTIONS(3519),
    [anon_sym_downcast] = ACTIONS(3519),
    [anon_sym_for] = ACTIONS(3519),
    [anon_sym_while] = ACTIONS(3519),
    [anon_sym_if] = ACTIONS(3519),
    [anon_sym_fun] = ACTIONS(3519),
    [anon_sym_DASH_GT] = ACTIONS(3517),
    [anon_sym_try] = ACTIONS(3519),
    [anon_sym_match] = ACTIONS(3519),
    [anon_sym_match_BANG] = ACTIONS(3517),
    [anon_sym_function] = ACTIONS(3519),
    [anon_sym_use] = ACTIONS(3519),
    [anon_sym_use_BANG] = ACTIONS(3517),
    [anon_sym_do_BANG] = ACTIONS(3517),
    [anon_sym_begin] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3517),
    [anon_sym_LT2] = ACTIONS(3519),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3517),
    [anon_sym_default] = ACTIONS(3519),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_member] = ACTIONS(3519),
    [anon_sym_interface] = ACTIONS(3519),
    [anon_sym_exception] = ACTIONS(3519),
    [anon_sym_abstract] = ACTIONS(3519),
    [anon_sym_val] = ACTIONS(3519),
    [anon_sym_override] = ACTIONS(3519),
    [aux_sym_char_token1] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [anon_sym_AT_DQUOTE] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [sym_bool] = ACTIONS(3519),
    [sym_unit] = ACTIONS(3517),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3519),
    [sym_op_identifier] = ACTIONS(3517),
    [anon_sym_PLUS] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_DOT] = ACTIONS(3517),
    [anon_sym_DASH_DOT] = ACTIONS(3517),
    [anon_sym_PERCENT] = ACTIONS(3517),
    [anon_sym_AMP_AMP] = ACTIONS(3517),
    [anon_sym_TILDE] = ACTIONS(3517),
    [aux_sym_prefix_op_token1] = ACTIONS(3517),
    [sym_int] = ACTIONS(3519),
    [sym_xint] = ACTIONS(3517),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3517),
    [anon_sym_POUNDload] = ACTIONS(3517),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3517),
  },
  [3609] = {
    [sym_block_comment] = STATE(3609),
    [sym_compiler_directive_decl] = STATE(3609),
    [sym_fsi_directive_decl] = STATE(3609),
    [sym_preproc_line] = STATE(3609),
    [ts_builtin_sym_end] = ACTIONS(3537),
    [sym_identifier] = ACTIONS(3539),
    [anon_sym_namespace] = ACTIONS(3539),
    [anon_sym_module] = ACTIONS(3539),
    [anon_sym_open] = ACTIONS(3539),
    [anon_sym_LBRACK_LT] = ACTIONS(3537),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_type] = ACTIONS(3539),
    [anon_sym_do] = ACTIONS(3539),
    [anon_sym_and] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3539),
    [anon_sym_let_BANG] = ACTIONS(3537),
    [aux_sym_access_modifier_token1] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_null] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3537),
    [anon_sym_LBRACE] = ACTIONS(3539),
    [anon_sym_LT_AT] = ACTIONS(3539),
    [anon_sym_LT_AT_AT] = ACTIONS(3537),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3537),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_with] = ACTIONS(3539),
    [anon_sym_return_BANG] = ACTIONS(3537),
    [anon_sym_yield] = ACTIONS(3539),
    [anon_sym_yield_BANG] = ACTIONS(3537),
    [anon_sym_lazy] = ACTIONS(3539),
    [anon_sym_assert] = ACTIONS(3539),
    [anon_sym_upcast] = ACTIONS(3539),
    [anon_sym_downcast] = ACTIONS(3539),
    [anon_sym_for] = ACTIONS(3539),
    [anon_sym_while] = ACTIONS(3539),
    [anon_sym_if] = ACTIONS(3539),
    [anon_sym_fun] = ACTIONS(3539),
    [anon_sym_DASH_GT] = ACTIONS(3537),
    [anon_sym_try] = ACTIONS(3539),
    [anon_sym_match] = ACTIONS(3539),
    [anon_sym_match_BANG] = ACTIONS(3537),
    [anon_sym_function] = ACTIONS(3539),
    [anon_sym_use] = ACTIONS(3539),
    [anon_sym_use_BANG] = ACTIONS(3537),
    [anon_sym_do_BANG] = ACTIONS(3537),
    [anon_sym_begin] = ACTIONS(3539),
    [anon_sym_STAR] = ACTIONS(3537),
    [anon_sym_LT2] = ACTIONS(3539),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_default] = ACTIONS(3539),
    [anon_sym_static] = ACTIONS(3539),
    [anon_sym_member] = ACTIONS(3539),
    [anon_sym_interface] = ACTIONS(3539),
    [anon_sym_exception] = ACTIONS(3539),
    [anon_sym_abstract] = ACTIONS(3539),
    [anon_sym_val] = ACTIONS(3539),
    [anon_sym_override] = ACTIONS(3539),
    [aux_sym_char_token1] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3539),
    [anon_sym_DQUOTE] = ACTIONS(3539),
    [anon_sym_AT_DQUOTE] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [sym_bool] = ACTIONS(3539),
    [sym_unit] = ACTIONS(3537),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3539),
    [sym_op_identifier] = ACTIONS(3537),
    [anon_sym_PLUS] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(3539),
    [anon_sym_PLUS_DOT] = ACTIONS(3537),
    [anon_sym_DASH_DOT] = ACTIONS(3537),
    [anon_sym_PERCENT] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [aux_sym_prefix_op_token1] = ACTIONS(3537),
    [sym_int] = ACTIONS(3539),
    [sym_xint] = ACTIONS(3537),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3537),
    [anon_sym_POUNDload] = ACTIONS(3537),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3537),
  },
  [3610] = {
    [sym_block_comment] = STATE(3610),
    [sym_compiler_directive_decl] = STATE(3610),
    [sym_fsi_directive_decl] = STATE(3610),
    [sym_preproc_line] = STATE(3610),
    [ts_builtin_sym_end] = ACTIONS(3533),
    [sym_identifier] = ACTIONS(3535),
    [anon_sym_namespace] = ACTIONS(3535),
    [anon_sym_module] = ACTIONS(3535),
    [anon_sym_open] = ACTIONS(3535),
    [anon_sym_LBRACK_LT] = ACTIONS(3533),
    [anon_sym_return] = ACTIONS(3535),
    [anon_sym_type] = ACTIONS(3535),
    [anon_sym_do] = ACTIONS(3535),
    [anon_sym_and] = ACTIONS(3535),
    [anon_sym_let] = ACTIONS(3535),
    [anon_sym_let_BANG] = ACTIONS(3533),
    [aux_sym_access_modifier_token1] = ACTIONS(3533),
    [anon_sym_LPAREN] = ACTIONS(3535),
    [anon_sym_null] = ACTIONS(3535),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3533),
    [anon_sym_LBRACE] = ACTIONS(3535),
    [anon_sym_LT_AT] = ACTIONS(3535),
    [anon_sym_LT_AT_AT] = ACTIONS(3533),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3533),
    [anon_sym_new] = ACTIONS(3535),
    [anon_sym_with] = ACTIONS(3535),
    [anon_sym_return_BANG] = ACTIONS(3533),
    [anon_sym_yield] = ACTIONS(3535),
    [anon_sym_yield_BANG] = ACTIONS(3533),
    [anon_sym_lazy] = ACTIONS(3535),
    [anon_sym_assert] = ACTIONS(3535),
    [anon_sym_upcast] = ACTIONS(3535),
    [anon_sym_downcast] = ACTIONS(3535),
    [anon_sym_for] = ACTIONS(3535),
    [anon_sym_while] = ACTIONS(3535),
    [anon_sym_if] = ACTIONS(3535),
    [anon_sym_fun] = ACTIONS(3535),
    [anon_sym_DASH_GT] = ACTIONS(3533),
    [anon_sym_try] = ACTIONS(3535),
    [anon_sym_match] = ACTIONS(3535),
    [anon_sym_match_BANG] = ACTIONS(3533),
    [anon_sym_function] = ACTIONS(3535),
    [anon_sym_use] = ACTIONS(3535),
    [anon_sym_use_BANG] = ACTIONS(3533),
    [anon_sym_do_BANG] = ACTIONS(3533),
    [anon_sym_begin] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(3533),
    [anon_sym_LT2] = ACTIONS(3535),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3533),
    [anon_sym_default] = ACTIONS(3535),
    [anon_sym_static] = ACTIONS(3535),
    [anon_sym_member] = ACTIONS(3535),
    [anon_sym_interface] = ACTIONS(3535),
    [anon_sym_exception] = ACTIONS(3535),
    [anon_sym_abstract] = ACTIONS(3535),
    [anon_sym_val] = ACTIONS(3535),
    [anon_sym_override] = ACTIONS(3535),
    [aux_sym_char_token1] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE] = ACTIONS(3535),
    [anon_sym_AT_DQUOTE] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [sym_bool] = ACTIONS(3535),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3535),
    [sym_op_identifier] = ACTIONS(3533),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS_DOT] = ACTIONS(3533),
    [anon_sym_DASH_DOT] = ACTIONS(3533),
    [anon_sym_PERCENT] = ACTIONS(3533),
    [anon_sym_AMP_AMP] = ACTIONS(3533),
    [anon_sym_TILDE] = ACTIONS(3533),
    [aux_sym_prefix_op_token1] = ACTIONS(3533),
    [sym_int] = ACTIONS(3535),
    [sym_xint] = ACTIONS(3533),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3533),
    [anon_sym_POUNDload] = ACTIONS(3533),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3533),
  },
  [3611] = {
    [sym_block_comment] = STATE(3611),
    [sym_compiler_directive_decl] = STATE(3611),
    [sym_fsi_directive_decl] = STATE(3611),
    [sym_preproc_line] = STATE(3611),
    [ts_builtin_sym_end] = ACTIONS(3513),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_namespace] = ACTIONS(3515),
    [anon_sym_module] = ACTIONS(3515),
    [anon_sym_open] = ACTIONS(3515),
    [anon_sym_LBRACK_LT] = ACTIONS(3513),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_type] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_and] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [aux_sym_access_modifier_token1] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_with] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3513),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3513),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3515),
    [anon_sym_static] = ACTIONS(3515),
    [anon_sym_member] = ACTIONS(3515),
    [anon_sym_interface] = ACTIONS(3515),
    [anon_sym_exception] = ACTIONS(3515),
    [anon_sym_abstract] = ACTIONS(3515),
    [anon_sym_val] = ACTIONS(3515),
    [anon_sym_override] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3513),
    [anon_sym_DASH_DOT] = ACTIONS(3513),
    [anon_sym_PERCENT] = ACTIONS(3513),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3513),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3513),
    [anon_sym_POUNDload] = ACTIONS(3513),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
  },
  [3612] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8234),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2840),
    [sym_rules] = STATE(3309),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3612),
    [sym_compiler_directive_decl] = STATE(3612),
    [sym_fsi_directive_decl] = STATE(3612),
    [sym_preproc_line] = STATE(3612),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6079),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3613] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(10953),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3613),
    [sym_compiler_directive_decl] = STATE(3613),
    [sym_fsi_directive_decl] = STATE(3613),
    [sym_preproc_line] = STATE(3613),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3614] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8251),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2792),
    [sym_rules] = STATE(3319),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3614),
    [sym_compiler_directive_decl] = STATE(3614),
    [sym_fsi_directive_decl] = STATE(3614),
    [sym_preproc_line] = STATE(3614),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6083),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3615] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7980),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1623),
    [sym_rules] = STATE(2137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3615),
    [sym_compiler_directive_decl] = STATE(3615),
    [sym_fsi_directive_decl] = STATE(3615),
    [sym_preproc_line] = STATE(3615),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6085),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3616] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(12081),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3616),
    [sym_compiler_directive_decl] = STATE(3616),
    [sym_fsi_directive_decl] = STATE(3616),
    [sym_preproc_line] = STATE(3616),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3617] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7980),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1623),
    [sym_rules] = STATE(2141),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3617),
    [sym_compiler_directive_decl] = STATE(3617),
    [sym_fsi_directive_decl] = STATE(3617),
    [sym_preproc_line] = STATE(3617),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6085),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3618] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(10313),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3618),
    [sym_compiler_directive_decl] = STATE(3618),
    [sym_fsi_directive_decl] = STATE(3618),
    [sym_preproc_line] = STATE(3618),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3619] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8251),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2792),
    [sym_rules] = STATE(3295),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3619),
    [sym_compiler_directive_decl] = STATE(3619),
    [sym_fsi_directive_decl] = STATE(3619),
    [sym_preproc_line] = STATE(3619),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6083),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3620] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8251),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2792),
    [sym_rules] = STATE(3294),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3620),
    [sym_compiler_directive_decl] = STATE(3620),
    [sym_fsi_directive_decl] = STATE(3620),
    [sym_preproc_line] = STATE(3620),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6083),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3621] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11991),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3621),
    [sym_compiler_directive_decl] = STATE(3621),
    [sym_fsi_directive_decl] = STATE(3621),
    [sym_preproc_line] = STATE(3621),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3622] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8251),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2792),
    [sym_rules] = STATE(3276),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3622),
    [sym_compiler_directive_decl] = STATE(3622),
    [sym_fsi_directive_decl] = STATE(3622),
    [sym_preproc_line] = STATE(3622),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6083),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3623] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8055),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1581),
    [sym_rules] = STATE(1805),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3623),
    [sym_compiler_directive_decl] = STATE(3623),
    [sym_fsi_directive_decl] = STATE(3623),
    [sym_preproc_line] = STATE(3623),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6087),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3624] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8190),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2276),
    [sym_rules] = STATE(2537),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3624),
    [sym_compiler_directive_decl] = STATE(3624),
    [sym_fsi_directive_decl] = STATE(3624),
    [sym_preproc_line] = STATE(3624),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6089),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3625] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11034),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3625),
    [sym_compiler_directive_decl] = STATE(3625),
    [sym_fsi_directive_decl] = STATE(3625),
    [sym_preproc_line] = STATE(3625),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3626] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8061),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1560),
    [sym_rules] = STATE(1689),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3626),
    [sym_compiler_directive_decl] = STATE(3626),
    [sym_fsi_directive_decl] = STATE(3626),
    [sym_preproc_line] = STATE(3626),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6091),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3627] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11955),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3627),
    [sym_compiler_directive_decl] = STATE(3627),
    [sym_fsi_directive_decl] = STATE(3627),
    [sym_preproc_line] = STATE(3627),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3628] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8190),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2276),
    [sym_rules] = STATE(2519),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3628),
    [sym_compiler_directive_decl] = STATE(3628),
    [sym_fsi_directive_decl] = STATE(3628),
    [sym_preproc_line] = STATE(3628),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6089),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3629] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8055),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1581),
    [sym_rules] = STATE(1777),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3629),
    [sym_compiler_directive_decl] = STATE(3629),
    [sym_fsi_directive_decl] = STATE(3629),
    [sym_preproc_line] = STATE(3629),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6087),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3630] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11087),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3630),
    [sym_compiler_directive_decl] = STATE(3630),
    [sym_fsi_directive_decl] = STATE(3630),
    [sym_preproc_line] = STATE(3630),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3631] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8055),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1581),
    [sym_rules] = STATE(1776),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3631),
    [sym_compiler_directive_decl] = STATE(3631),
    [sym_fsi_directive_decl] = STATE(3631),
    [sym_preproc_line] = STATE(3631),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6087),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3632] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8190),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2276),
    [sym_rules] = STATE(2517),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3632),
    [sym_compiler_directive_decl] = STATE(3632),
    [sym_fsi_directive_decl] = STATE(3632),
    [sym_preproc_line] = STATE(3632),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6089),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3633] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8055),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1581),
    [sym_rules] = STATE(1757),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3633),
    [sym_compiler_directive_decl] = STATE(3633),
    [sym_fsi_directive_decl] = STATE(3633),
    [sym_preproc_line] = STATE(3633),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6087),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3634] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11861),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3634),
    [sym_compiler_directive_decl] = STATE(3634),
    [sym_fsi_directive_decl] = STATE(3634),
    [sym_preproc_line] = STATE(3634),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3635] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11832),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3635),
    [sym_compiler_directive_decl] = STATE(3635),
    [sym_fsi_directive_decl] = STATE(3635),
    [sym_preproc_line] = STATE(3635),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3636] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11042),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3636),
    [sym_compiler_directive_decl] = STATE(3636),
    [sym_fsi_directive_decl] = STATE(3636),
    [sym_preproc_line] = STATE(3636),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3637] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11821),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3637),
    [sym_compiler_directive_decl] = STATE(3637),
    [sym_fsi_directive_decl] = STATE(3637),
    [sym_preproc_line] = STATE(3637),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3638] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11062),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3638),
    [sym_compiler_directive_decl] = STATE(3638),
    [sym_fsi_directive_decl] = STATE(3638),
    [sym_preproc_line] = STATE(3638),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3639] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8091),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2922),
    [sym_rules] = STATE(3307),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3639),
    [sym_compiler_directive_decl] = STATE(3639),
    [sym_fsi_directive_decl] = STATE(3639),
    [sym_preproc_line] = STATE(3639),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6093),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3640] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11783),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3640),
    [sym_compiler_directive_decl] = STATE(3640),
    [sym_fsi_directive_decl] = STATE(3640),
    [sym_preproc_line] = STATE(3640),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3641] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11756),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3641),
    [sym_compiler_directive_decl] = STATE(3641),
    [sym_fsi_directive_decl] = STATE(3641),
    [sym_preproc_line] = STATE(3641),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3642] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8242),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2913),
    [sym_rules] = STATE(3505),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3642),
    [sym_compiler_directive_decl] = STATE(3642),
    [sym_fsi_directive_decl] = STATE(3642),
    [sym_preproc_line] = STATE(3642),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6095),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3643] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8272),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1600),
    [sym_rules] = STATE(2188),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3643),
    [sym_compiler_directive_decl] = STATE(3643),
    [sym_fsi_directive_decl] = STATE(3643),
    [sym_preproc_line] = STATE(3643),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6097),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3644] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8272),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1600),
    [sym_rules] = STATE(2133),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3644),
    [sym_compiler_directive_decl] = STATE(3644),
    [sym_fsi_directive_decl] = STATE(3644),
    [sym_preproc_line] = STATE(3644),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6097),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3645] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8272),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1600),
    [sym_rules] = STATE(2129),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3645),
    [sym_compiler_directive_decl] = STATE(3645),
    [sym_fsi_directive_decl] = STATE(3645),
    [sym_preproc_line] = STATE(3645),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6097),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3646] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8061),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1560),
    [sym_rules] = STATE(1724),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3646),
    [sym_compiler_directive_decl] = STATE(3646),
    [sym_fsi_directive_decl] = STATE(3646),
    [sym_preproc_line] = STATE(3646),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6091),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3647] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11015),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3647),
    [sym_compiler_directive_decl] = STATE(3647),
    [sym_fsi_directive_decl] = STATE(3647),
    [sym_preproc_line] = STATE(3647),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3648] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8272),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1600),
    [sym_rules] = STATE(2039),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3648),
    [sym_compiler_directive_decl] = STATE(3648),
    [sym_fsi_directive_decl] = STATE(3648),
    [sym_preproc_line] = STATE(3648),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6097),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3649] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8278),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2279),
    [sym_rules] = STATE(2368),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3649),
    [sym_compiler_directive_decl] = STATE(3649),
    [sym_fsi_directive_decl] = STATE(3649),
    [sym_preproc_line] = STATE(3649),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6099),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3650] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8061),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1560),
    [sym_rules] = STATE(1725),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3650),
    [sym_compiler_directive_decl] = STATE(3650),
    [sym_fsi_directive_decl] = STATE(3650),
    [sym_preproc_line] = STATE(3650),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6091),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3651] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8061),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1560),
    [sym_rules] = STATE(1744),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3651),
    [sym_compiler_directive_decl] = STATE(3651),
    [sym_fsi_directive_decl] = STATE(3651),
    [sym_preproc_line] = STATE(3651),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6091),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3652] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11682),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3652),
    [sym_compiler_directive_decl] = STATE(3652),
    [sym_fsi_directive_decl] = STATE(3652),
    [sym_preproc_line] = STATE(3652),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3653] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8190),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2276),
    [sym_rules] = STATE(2446),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3653),
    [sym_compiler_directive_decl] = STATE(3653),
    [sym_fsi_directive_decl] = STATE(3653),
    [sym_preproc_line] = STATE(3653),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6089),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3654] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(10434),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3654),
    [sym_compiler_directive_decl] = STATE(3654),
    [sym_fsi_directive_decl] = STATE(3654),
    [sym_preproc_line] = STATE(3654),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3655] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8278),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2279),
    [sym_rules] = STATE(2473),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3655),
    [sym_compiler_directive_decl] = STATE(3655),
    [sym_fsi_directive_decl] = STATE(3655),
    [sym_preproc_line] = STATE(3655),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6099),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3656] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8245),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1276),
    [sym_rules] = STATE(1338),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3656),
    [sym_compiler_directive_decl] = STATE(3656),
    [sym_fsi_directive_decl] = STATE(3656),
    [sym_preproc_line] = STATE(3656),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6101),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3657] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8245),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1276),
    [sym_rules] = STATE(1371),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3657),
    [sym_compiler_directive_decl] = STATE(3657),
    [sym_fsi_directive_decl] = STATE(3657),
    [sym_preproc_line] = STATE(3657),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6101),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3658] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11661),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3658),
    [sym_compiler_directive_decl] = STATE(3658),
    [sym_fsi_directive_decl] = STATE(3658),
    [sym_preproc_line] = STATE(3658),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3659] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11102),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3659),
    [sym_compiler_directive_decl] = STATE(3659),
    [sym_fsi_directive_decl] = STATE(3659),
    [sym_preproc_line] = STATE(3659),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3660] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11650),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3660),
    [sym_compiler_directive_decl] = STATE(3660),
    [sym_fsi_directive_decl] = STATE(3660),
    [sym_preproc_line] = STATE(3660),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3661] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11338),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3661),
    [sym_compiler_directive_decl] = STATE(3661),
    [sym_fsi_directive_decl] = STATE(3661),
    [sym_preproc_line] = STATE(3661),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3662] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8204),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1632),
    [sym_rules] = STATE(2015),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3662),
    [sym_compiler_directive_decl] = STATE(3662),
    [sym_fsi_directive_decl] = STATE(3662),
    [sym_preproc_line] = STATE(3662),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6103),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3663] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8278),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2279),
    [sym_rules] = STATE(2417),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3663),
    [sym_compiler_directive_decl] = STATE(3663),
    [sym_fsi_directive_decl] = STATE(3663),
    [sym_preproc_line] = STATE(3663),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6099),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3664] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11275),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3664),
    [sym_compiler_directive_decl] = STATE(3664),
    [sym_fsi_directive_decl] = STATE(3664),
    [sym_preproc_line] = STATE(3664),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3665] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11604),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3665),
    [sym_compiler_directive_decl] = STATE(3665),
    [sym_fsi_directive_decl] = STATE(3665),
    [sym_preproc_line] = STATE(3665),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3666] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11582),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3666),
    [sym_compiler_directive_decl] = STATE(3666),
    [sym_fsi_directive_decl] = STATE(3666),
    [sym_preproc_line] = STATE(3666),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3667] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8204),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1632),
    [sym_rules] = STATE(1905),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3667),
    [sym_compiler_directive_decl] = STATE(3667),
    [sym_fsi_directive_decl] = STATE(3667),
    [sym_preproc_line] = STATE(3667),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6103),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3668] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11122),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3668),
    [sym_compiler_directive_decl] = STATE(3668),
    [sym_fsi_directive_decl] = STATE(3668),
    [sym_preproc_line] = STATE(3668),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3669] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8278),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2279),
    [sym_rules] = STATE(2418),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3669),
    [sym_compiler_directive_decl] = STATE(3669),
    [sym_fsi_directive_decl] = STATE(3669),
    [sym_preproc_line] = STATE(3669),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6099),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3670] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11571),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3670),
    [sym_compiler_directive_decl] = STATE(3670),
    [sym_fsi_directive_decl] = STATE(3670),
    [sym_preproc_line] = STATE(3670),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3671] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8098),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1619),
    [sym_rules] = STATE(1991),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3671),
    [sym_compiler_directive_decl] = STATE(3671),
    [sym_fsi_directive_decl] = STATE(3671),
    [sym_preproc_line] = STATE(3671),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6105),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3672] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11130),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3672),
    [sym_compiler_directive_decl] = STATE(3672),
    [sym_fsi_directive_decl] = STATE(3672),
    [sym_preproc_line] = STATE(3672),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3673] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8245),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1276),
    [sym_rules] = STATE(1465),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3673),
    [sym_compiler_directive_decl] = STATE(3673),
    [sym_fsi_directive_decl] = STATE(3673),
    [sym_preproc_line] = STATE(3673),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6101),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3674] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8234),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2840),
    [sym_rules] = STATE(3212),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3674),
    [sym_compiler_directive_decl] = STATE(3674),
    [sym_fsi_directive_decl] = STATE(3674),
    [sym_preproc_line] = STATE(3674),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6079),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3675] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11529),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3675),
    [sym_compiler_directive_decl] = STATE(3675),
    [sym_fsi_directive_decl] = STATE(3675),
    [sym_preproc_line] = STATE(3675),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3676] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8091),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2922),
    [sym_rules] = STATE(3376),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3676),
    [sym_compiler_directive_decl] = STATE(3676),
    [sym_fsi_directive_decl] = STATE(3676),
    [sym_preproc_line] = STATE(3676),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6093),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3677] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8234),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2840),
    [sym_rules] = STATE(3213),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3677),
    [sym_compiler_directive_decl] = STATE(3677),
    [sym_fsi_directive_decl] = STATE(3677),
    [sym_preproc_line] = STATE(3677),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6079),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3678] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8234),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2840),
    [sym_rules] = STATE(3234),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3678),
    [sym_compiler_directive_decl] = STATE(3678),
    [sym_fsi_directive_decl] = STATE(3678),
    [sym_preproc_line] = STATE(3678),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6079),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3679] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8245),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1276),
    [sym_rules] = STATE(1369),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3679),
    [sym_compiler_directive_decl] = STATE(3679),
    [sym_fsi_directive_decl] = STATE(3679),
    [sym_preproc_line] = STATE(3679),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6101),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3680] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11504),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3680),
    [sym_compiler_directive_decl] = STATE(3680),
    [sym_fsi_directive_decl] = STATE(3680),
    [sym_preproc_line] = STATE(3680),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3681] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8091),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2922),
    [sym_rules] = STATE(3380),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3681),
    [sym_compiler_directive_decl] = STATE(3681),
    [sym_fsi_directive_decl] = STATE(3681),
    [sym_preproc_line] = STATE(3681),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6093),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3682] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8166),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2777),
    [sym_rules] = STATE(3099),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3682),
    [sym_compiler_directive_decl] = STATE(3682),
    [sym_fsi_directive_decl] = STATE(3682),
    [sym_preproc_line] = STATE(3682),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6107),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3683] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11491),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3683),
    [sym_compiler_directive_decl] = STATE(3683),
    [sym_fsi_directive_decl] = STATE(3683),
    [sym_preproc_line] = STATE(3683),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3684] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8242),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2913),
    [sym_rules] = STATE(3467),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3684),
    [sym_compiler_directive_decl] = STATE(3684),
    [sym_fsi_directive_decl] = STATE(3684),
    [sym_preproc_line] = STATE(3684),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6095),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3685] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7980),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1623),
    [sym_rules] = STATE(2169),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3685),
    [sym_compiler_directive_decl] = STATE(3685),
    [sym_fsi_directive_decl] = STATE(3685),
    [sym_preproc_line] = STATE(3685),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6085),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3686] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8166),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2777),
    [sym_rules] = STATE(3031),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3686),
    [sym_compiler_directive_decl] = STATE(3686),
    [sym_fsi_directive_decl] = STATE(3686),
    [sym_preproc_line] = STATE(3686),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6107),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3687] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8242),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2913),
    [sym_rules] = STATE(3483),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3687),
    [sym_compiler_directive_decl] = STATE(3687),
    [sym_fsi_directive_decl] = STATE(3687),
    [sym_preproc_line] = STATE(3687),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6095),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3688] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8005),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2717),
    [sym_rules] = STATE(3009),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3688),
    [sym_compiler_directive_decl] = STATE(3688),
    [sym_fsi_directive_decl] = STATE(3688),
    [sym_preproc_line] = STATE(3688),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6109),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3689] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8098),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1619),
    [sym_rules] = STATE(1990),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3689),
    [sym_compiler_directive_decl] = STATE(3689),
    [sym_fsi_directive_decl] = STATE(3689),
    [sym_preproc_line] = STATE(3689),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6105),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3690] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11449),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3690),
    [sym_compiler_directive_decl] = STATE(3690),
    [sym_fsi_directive_decl] = STATE(3690),
    [sym_preproc_line] = STATE(3690),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3691] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11430),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3691),
    [sym_compiler_directive_decl] = STATE(3691),
    [sym_fsi_directive_decl] = STATE(3691),
    [sym_preproc_line] = STATE(3691),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3692] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11737),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3692),
    [sym_compiler_directive_decl] = STATE(3692),
    [sym_fsi_directive_decl] = STATE(3692),
    [sym_preproc_line] = STATE(3692),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3693] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7980),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1623),
    [sym_rules] = STATE(2115),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3693),
    [sym_compiler_directive_decl] = STATE(3693),
    [sym_fsi_directive_decl] = STATE(3693),
    [sym_preproc_line] = STATE(3693),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6085),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3694] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8242),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2913),
    [sym_rules] = STATE(3484),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3694),
    [sym_compiler_directive_decl] = STATE(3694),
    [sym_fsi_directive_decl] = STATE(3694),
    [sym_preproc_line] = STATE(3694),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6095),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3695] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8005),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2717),
    [sym_rules] = STATE(2975),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3695),
    [sym_compiler_directive_decl] = STATE(3695),
    [sym_fsi_directive_decl] = STATE(3695),
    [sym_preproc_line] = STATE(3695),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6109),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3696] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8005),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2717),
    [sym_rules] = STATE(2978),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3696),
    [sym_compiler_directive_decl] = STATE(3696),
    [sym_fsi_directive_decl] = STATE(3696),
    [sym_preproc_line] = STATE(3696),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6109),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3697] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11079),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3697),
    [sym_compiler_directive_decl] = STATE(3697),
    [sym_fsi_directive_decl] = STATE(3697),
    [sym_preproc_line] = STATE(3697),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3698] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11416),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3698),
    [sym_compiler_directive_decl] = STATE(3698),
    [sym_fsi_directive_decl] = STATE(3698),
    [sym_preproc_line] = STATE(3698),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3699] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8005),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2717),
    [sym_rules] = STATE(2993),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3699),
    [sym_compiler_directive_decl] = STATE(3699),
    [sym_fsi_directive_decl] = STATE(3699),
    [sym_preproc_line] = STATE(3699),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6109),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3700] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8166),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2777),
    [sym_rules] = STATE(3063),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3700),
    [sym_compiler_directive_decl] = STATE(3700),
    [sym_fsi_directive_decl] = STATE(3700),
    [sym_preproc_line] = STATE(3700),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6107),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3701] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8204),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1632),
    [sym_rules] = STATE(2087),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3701),
    [sym_compiler_directive_decl] = STATE(3701),
    [sym_fsi_directive_decl] = STATE(3701),
    [sym_preproc_line] = STATE(3701),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6103),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3702] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8098),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1619),
    [sym_rules] = STATE(1977),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3702),
    [sym_compiler_directive_decl] = STATE(3702),
    [sym_fsi_directive_decl] = STATE(3702),
    [sym_preproc_line] = STATE(3702),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6105),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3703] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11365),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3703),
    [sym_compiler_directive_decl] = STATE(3703),
    [sym_fsi_directive_decl] = STATE(3703),
    [sym_preproc_line] = STATE(3703),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3704] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(10984),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3704),
    [sym_compiler_directive_decl] = STATE(3704),
    [sym_fsi_directive_decl] = STATE(3704),
    [sym_preproc_line] = STATE(3704),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3705] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11154),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3705),
    [sym_compiler_directive_decl] = STATE(3705),
    [sym_fsi_directive_decl] = STATE(3705),
    [sym_preproc_line] = STATE(3705),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3706] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11325),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3706),
    [sym_compiler_directive_decl] = STATE(3706),
    [sym_fsi_directive_decl] = STATE(3706),
    [sym_preproc_line] = STATE(3706),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3707] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8182),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2709),
    [sym_rules] = STATE(2824),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3707),
    [sym_compiler_directive_decl] = STATE(3707),
    [sym_fsi_directive_decl] = STATE(3707),
    [sym_preproc_line] = STATE(3707),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6111),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3708] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8204),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1632),
    [sym_rules] = STATE(1904),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3708),
    [sym_compiler_directive_decl] = STATE(3708),
    [sym_fsi_directive_decl] = STATE(3708),
    [sym_preproc_line] = STATE(3708),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6103),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3709] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11286),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3709),
    [sym_compiler_directive_decl] = STATE(3709),
    [sym_fsi_directive_decl] = STATE(3709),
    [sym_preproc_line] = STATE(3709),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3710] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11259),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3710),
    [sym_compiler_directive_decl] = STATE(3710),
    [sym_fsi_directive_decl] = STATE(3710),
    [sym_preproc_line] = STATE(3710),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3711] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8182),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2709),
    [sym_rules] = STATE(2866),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3711),
    [sym_compiler_directive_decl] = STATE(3711),
    [sym_fsi_directive_decl] = STATE(3711),
    [sym_preproc_line] = STATE(3711),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6111),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3712] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11249),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3712),
    [sym_compiler_directive_decl] = STATE(3712),
    [sym_fsi_directive_decl] = STATE(3712),
    [sym_preproc_line] = STATE(3712),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3713] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11170),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3713),
    [sym_compiler_directive_decl] = STATE(3713),
    [sym_fsi_directive_decl] = STATE(3713),
    [sym_preproc_line] = STATE(3713),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3714] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8182),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2709),
    [sym_rules] = STATE(2867),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3714),
    [sym_compiler_directive_decl] = STATE(3714),
    [sym_fsi_directive_decl] = STATE(3714),
    [sym_preproc_line] = STATE(3714),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6111),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3715] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8166),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2777),
    [sym_rules] = STATE(3062),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3715),
    [sym_compiler_directive_decl] = STATE(3715),
    [sym_fsi_directive_decl] = STATE(3715),
    [sym_preproc_line] = STATE(3715),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6107),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3716] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(10921),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3716),
    [sym_compiler_directive_decl] = STATE(3716),
    [sym_fsi_directive_decl] = STATE(3716),
    [sym_preproc_line] = STATE(3716),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3717] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(10934),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3717),
    [sym_compiler_directive_decl] = STATE(3717),
    [sym_fsi_directive_decl] = STATE(3717),
    [sym_preproc_line] = STATE(3717),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3718] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8091),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2922),
    [sym_rules] = STATE(3428),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3718),
    [sym_compiler_directive_decl] = STATE(3718),
    [sym_fsi_directive_decl] = STATE(3718),
    [sym_preproc_line] = STATE(3718),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6093),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3719] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(10959),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3719),
    [sym_compiler_directive_decl] = STATE(3719),
    [sym_fsi_directive_decl] = STATE(3719),
    [sym_preproc_line] = STATE(3719),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3720] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8182),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2709),
    [sym_rules] = STATE(2889),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3720),
    [sym_compiler_directive_decl] = STATE(3720),
    [sym_fsi_directive_decl] = STATE(3720),
    [sym_preproc_line] = STATE(3720),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6111),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3721] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11177),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3721),
    [sym_compiler_directive_decl] = STATE(3721),
    [sym_fsi_directive_decl] = STATE(3721),
    [sym_preproc_line] = STATE(3721),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3722] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8098),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1619),
    [sym_rules] = STATE(2005),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3722),
    [sym_compiler_directive_decl] = STATE(3722),
    [sym_fsi_directive_decl] = STATE(3722),
    [sym_preproc_line] = STATE(3722),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6105),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3723] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8906),
    [sym_rules] = STATE(11198),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3723),
    [sym_compiler_directive_decl] = STATE(3723),
    [sym_fsi_directive_decl] = STATE(3723),
    [sym_preproc_line] = STATE(3723),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3724] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3724),
    [sym_compiler_directive_decl] = STATE(3724),
    [sym_fsi_directive_decl] = STATE(3724),
    [sym_preproc_line] = STATE(3724),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3757),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(6113),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3725] = {
    [sym_block_comment] = STATE(3725),
    [sym_compiler_directive_decl] = STATE(3725),
    [sym_fsi_directive_decl] = STATE(3725),
    [sym_preproc_line] = STATE(3725),
    [aux_sym__function_or_value_defns_repeat1] = STATE(3725),
    [ts_builtin_sym_end] = ACTIONS(6115),
    [sym_identifier] = ACTIONS(6117),
    [anon_sym_namespace] = ACTIONS(6117),
    [anon_sym_module] = ACTIONS(6117),
    [anon_sym_open] = ACTIONS(6117),
    [anon_sym_LBRACK_LT] = ACTIONS(6115),
    [anon_sym_return] = ACTIONS(6117),
    [anon_sym_type] = ACTIONS(6117),
    [anon_sym_do] = ACTIONS(6117),
    [anon_sym_and] = ACTIONS(6119),
    [anon_sym_let] = ACTIONS(6117),
    [anon_sym_let_BANG] = ACTIONS(6115),
    [aux_sym_access_modifier_token1] = ACTIONS(6115),
    [anon_sym_LPAREN] = ACTIONS(6117),
    [anon_sym_null] = ACTIONS(6117),
    [anon_sym_AMP] = ACTIONS(6117),
    [anon_sym_LBRACK] = ACTIONS(6117),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6115),
    [anon_sym_LBRACE] = ACTIONS(6117),
    [anon_sym_LT_AT] = ACTIONS(6117),
    [anon_sym_LT_AT_AT] = ACTIONS(6115),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6115),
    [anon_sym_new] = ACTIONS(6117),
    [anon_sym_return_BANG] = ACTIONS(6115),
    [anon_sym_yield] = ACTIONS(6117),
    [anon_sym_yield_BANG] = ACTIONS(6115),
    [anon_sym_lazy] = ACTIONS(6117),
    [anon_sym_assert] = ACTIONS(6117),
    [anon_sym_upcast] = ACTIONS(6117),
    [anon_sym_downcast] = ACTIONS(6117),
    [anon_sym_for] = ACTIONS(6117),
    [anon_sym_while] = ACTIONS(6117),
    [anon_sym_if] = ACTIONS(6117),
    [anon_sym_fun] = ACTIONS(6117),
    [anon_sym_try] = ACTIONS(6117),
    [anon_sym_match] = ACTIONS(6117),
    [anon_sym_match_BANG] = ACTIONS(6115),
    [anon_sym_function] = ACTIONS(6117),
    [anon_sym_use] = ACTIONS(6117),
    [anon_sym_use_BANG] = ACTIONS(6115),
    [anon_sym_do_BANG] = ACTIONS(6115),
    [anon_sym_begin] = ACTIONS(6117),
    [anon_sym_default] = ACTIONS(6117),
    [anon_sym_static] = ACTIONS(6117),
    [anon_sym_member] = ACTIONS(6117),
    [anon_sym_interface] = ACTIONS(6117),
    [anon_sym_exception] = ACTIONS(6117),
    [anon_sym_abstract] = ACTIONS(6117),
    [anon_sym_val] = ACTIONS(6117),
    [anon_sym_override] = ACTIONS(6117),
    [aux_sym_char_token1] = ACTIONS(6115),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6117),
    [anon_sym_DQUOTE] = ACTIONS(6117),
    [anon_sym_AT_DQUOTE] = ACTIONS(6115),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6115),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6115),
    [sym_bool] = ACTIONS(6117),
    [sym_unit] = ACTIONS(6115),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6117),
    [sym_op_identifier] = ACTIONS(6115),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_PLUS_DOT] = ACTIONS(6115),
    [anon_sym_DASH_DOT] = ACTIONS(6115),
    [anon_sym_PERCENT] = ACTIONS(6115),
    [anon_sym_AMP_AMP] = ACTIONS(6115),
    [anon_sym_TILDE] = ACTIONS(6115),
    [aux_sym_prefix_op_token1] = ACTIONS(6115),
    [sym_int] = ACTIONS(6117),
    [sym_xint] = ACTIONS(6115),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6115),
    [anon_sym_POUNDload] = ACTIONS(6115),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6115),
  },
  [3726] = {
    [sym_block_comment] = STATE(3726),
    [sym_compiler_directive_decl] = STATE(3726),
    [sym_fsi_directive_decl] = STATE(3726),
    [sym_preproc_line] = STATE(3726),
    [ts_builtin_sym_end] = ACTIONS(6122),
    [sym_identifier] = ACTIONS(6124),
    [anon_sym_namespace] = ACTIONS(6124),
    [anon_sym_module] = ACTIONS(6124),
    [anon_sym_open] = ACTIONS(6124),
    [anon_sym_LBRACK_LT] = ACTIONS(6122),
    [anon_sym_return] = ACTIONS(6124),
    [anon_sym_type] = ACTIONS(6124),
    [anon_sym_do] = ACTIONS(6124),
    [anon_sym_and] = ACTIONS(6124),
    [anon_sym_let] = ACTIONS(6124),
    [anon_sym_let_BANG] = ACTIONS(6122),
    [aux_sym_access_modifier_token1] = ACTIONS(6122),
    [anon_sym_LPAREN] = ACTIONS(6124),
    [anon_sym_COMMA] = ACTIONS(6126),
    [anon_sym_null] = ACTIONS(6124),
    [anon_sym_AMP] = ACTIONS(6124),
    [anon_sym_LBRACK] = ACTIONS(6124),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6122),
    [anon_sym_LBRACE] = ACTIONS(6124),
    [anon_sym_LT_AT] = ACTIONS(6124),
    [anon_sym_LT_AT_AT] = ACTIONS(6122),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6122),
    [anon_sym_new] = ACTIONS(6124),
    [anon_sym_return_BANG] = ACTIONS(6122),
    [anon_sym_yield] = ACTIONS(6124),
    [anon_sym_yield_BANG] = ACTIONS(6122),
    [anon_sym_lazy] = ACTIONS(6124),
    [anon_sym_assert] = ACTIONS(6124),
    [anon_sym_upcast] = ACTIONS(6124),
    [anon_sym_downcast] = ACTIONS(6124),
    [anon_sym_for] = ACTIONS(6124),
    [anon_sym_while] = ACTIONS(6124),
    [anon_sym_if] = ACTIONS(6124),
    [anon_sym_fun] = ACTIONS(6124),
    [anon_sym_try] = ACTIONS(6124),
    [anon_sym_match] = ACTIONS(6124),
    [anon_sym_match_BANG] = ACTIONS(6122),
    [anon_sym_function] = ACTIONS(6124),
    [anon_sym_use] = ACTIONS(6124),
    [anon_sym_use_BANG] = ACTIONS(6122),
    [anon_sym_do_BANG] = ACTIONS(6122),
    [anon_sym_begin] = ACTIONS(6124),
    [anon_sym_default] = ACTIONS(6124),
    [anon_sym_static] = ACTIONS(6124),
    [anon_sym_member] = ACTIONS(6124),
    [anon_sym_interface] = ACTIONS(6124),
    [anon_sym_exception] = ACTIONS(6124),
    [anon_sym_abstract] = ACTIONS(6124),
    [anon_sym_val] = ACTIONS(6124),
    [anon_sym_override] = ACTIONS(6124),
    [aux_sym_char_token1] = ACTIONS(6122),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6124),
    [anon_sym_DQUOTE] = ACTIONS(6124),
    [anon_sym_AT_DQUOTE] = ACTIONS(6122),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6122),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6122),
    [sym_bool] = ACTIONS(6124),
    [sym_unit] = ACTIONS(6122),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6124),
    [sym_op_identifier] = ACTIONS(6122),
    [anon_sym_PLUS] = ACTIONS(6124),
    [anon_sym_DASH] = ACTIONS(6124),
    [anon_sym_PLUS_DOT] = ACTIONS(6122),
    [anon_sym_DASH_DOT] = ACTIONS(6122),
    [anon_sym_PERCENT] = ACTIONS(6122),
    [anon_sym_AMP_AMP] = ACTIONS(6122),
    [anon_sym_TILDE] = ACTIONS(6122),
    [aux_sym_prefix_op_token1] = ACTIONS(6122),
    [sym_int] = ACTIONS(6124),
    [sym_xint] = ACTIONS(6122),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6122),
    [anon_sym_POUNDload] = ACTIONS(6122),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6122),
  },
  [3727] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3727),
    [sym_compiler_directive_decl] = STATE(3727),
    [sym_fsi_directive_decl] = STATE(3727),
    [sym_preproc_line] = STATE(3727),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3757),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(6128),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3728] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3728),
    [sym_compiler_directive_decl] = STATE(3728),
    [sym_fsi_directive_decl] = STATE(3728),
    [sym_preproc_line] = STATE(3728),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3757),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(6130),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3729] = {
    [sym_block_comment] = STATE(3729),
    [sym_compiler_directive_decl] = STATE(3729),
    [sym_fsi_directive_decl] = STATE(3729),
    [sym_preproc_line] = STATE(3729),
    [ts_builtin_sym_end] = ACTIONS(6132),
    [sym_identifier] = ACTIONS(6134),
    [anon_sym_namespace] = ACTIONS(6134),
    [anon_sym_module] = ACTIONS(6134),
    [anon_sym_open] = ACTIONS(6134),
    [anon_sym_LBRACK_LT] = ACTIONS(6132),
    [anon_sym_return] = ACTIONS(6134),
    [anon_sym_type] = ACTIONS(6134),
    [anon_sym_do] = ACTIONS(6134),
    [anon_sym_and] = ACTIONS(6134),
    [anon_sym_let] = ACTIONS(6134),
    [anon_sym_let_BANG] = ACTIONS(6132),
    [aux_sym_access_modifier_token1] = ACTIONS(6132),
    [anon_sym_LPAREN] = ACTIONS(6134),
    [anon_sym_COMMA] = ACTIONS(6136),
    [anon_sym_null] = ACTIONS(6134),
    [anon_sym_AMP] = ACTIONS(6134),
    [anon_sym_LBRACK] = ACTIONS(6134),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6132),
    [anon_sym_LBRACE] = ACTIONS(6134),
    [anon_sym_LT_AT] = ACTIONS(6134),
    [anon_sym_LT_AT_AT] = ACTIONS(6132),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6132),
    [anon_sym_new] = ACTIONS(6134),
    [anon_sym_return_BANG] = ACTIONS(6132),
    [anon_sym_yield] = ACTIONS(6134),
    [anon_sym_yield_BANG] = ACTIONS(6132),
    [anon_sym_lazy] = ACTIONS(6134),
    [anon_sym_assert] = ACTIONS(6134),
    [anon_sym_upcast] = ACTIONS(6134),
    [anon_sym_downcast] = ACTIONS(6134),
    [anon_sym_for] = ACTIONS(6134),
    [anon_sym_while] = ACTIONS(6134),
    [anon_sym_if] = ACTIONS(6134),
    [anon_sym_fun] = ACTIONS(6134),
    [anon_sym_try] = ACTIONS(6134),
    [anon_sym_match] = ACTIONS(6134),
    [anon_sym_match_BANG] = ACTIONS(6132),
    [anon_sym_function] = ACTIONS(6134),
    [anon_sym_use] = ACTIONS(6134),
    [anon_sym_use_BANG] = ACTIONS(6132),
    [anon_sym_do_BANG] = ACTIONS(6132),
    [anon_sym_begin] = ACTIONS(6134),
    [anon_sym_default] = ACTIONS(6134),
    [anon_sym_static] = ACTIONS(6134),
    [anon_sym_member] = ACTIONS(6134),
    [anon_sym_interface] = ACTIONS(6134),
    [anon_sym_exception] = ACTIONS(6134),
    [anon_sym_abstract] = ACTIONS(6134),
    [anon_sym_val] = ACTIONS(6134),
    [anon_sym_override] = ACTIONS(6134),
    [aux_sym_char_token1] = ACTIONS(6132),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6134),
    [anon_sym_DQUOTE] = ACTIONS(6134),
    [anon_sym_AT_DQUOTE] = ACTIONS(6132),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6132),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6132),
    [sym_bool] = ACTIONS(6134),
    [sym_unit] = ACTIONS(6132),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6134),
    [sym_op_identifier] = ACTIONS(6132),
    [anon_sym_PLUS] = ACTIONS(6134),
    [anon_sym_DASH] = ACTIONS(6134),
    [anon_sym_PLUS_DOT] = ACTIONS(6132),
    [anon_sym_DASH_DOT] = ACTIONS(6132),
    [anon_sym_PERCENT] = ACTIONS(6132),
    [anon_sym_AMP_AMP] = ACTIONS(6132),
    [anon_sym_TILDE] = ACTIONS(6132),
    [aux_sym_prefix_op_token1] = ACTIONS(6132),
    [sym_int] = ACTIONS(6134),
    [sym_xint] = ACTIONS(6132),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6132),
    [anon_sym_POUNDload] = ACTIONS(6132),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6132),
  },
  [3730] = {
    [sym_block_comment] = STATE(3730),
    [sym_compiler_directive_decl] = STATE(3730),
    [sym_fsi_directive_decl] = STATE(3730),
    [sym_preproc_line] = STATE(3730),
    [ts_builtin_sym_end] = ACTIONS(6122),
    [sym_identifier] = ACTIONS(6124),
    [anon_sym_namespace] = ACTIONS(6124),
    [anon_sym_module] = ACTIONS(6124),
    [anon_sym_open] = ACTIONS(6124),
    [anon_sym_LBRACK_LT] = ACTIONS(6122),
    [anon_sym_return] = ACTIONS(6124),
    [anon_sym_type] = ACTIONS(6124),
    [anon_sym_do] = ACTIONS(6124),
    [anon_sym_and] = ACTIONS(6124),
    [anon_sym_let] = ACTIONS(6124),
    [anon_sym_let_BANG] = ACTIONS(6122),
    [aux_sym_access_modifier_token1] = ACTIONS(6122),
    [anon_sym_LPAREN] = ACTIONS(6124),
    [anon_sym_COMMA] = ACTIONS(6138),
    [anon_sym_null] = ACTIONS(6124),
    [anon_sym_AMP] = ACTIONS(6124),
    [anon_sym_LBRACK] = ACTIONS(6124),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6122),
    [anon_sym_LBRACE] = ACTIONS(6124),
    [anon_sym_LT_AT] = ACTIONS(6124),
    [anon_sym_LT_AT_AT] = ACTIONS(6122),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6122),
    [anon_sym_new] = ACTIONS(6124),
    [anon_sym_return_BANG] = ACTIONS(6122),
    [anon_sym_yield] = ACTIONS(6124),
    [anon_sym_yield_BANG] = ACTIONS(6122),
    [anon_sym_lazy] = ACTIONS(6124),
    [anon_sym_assert] = ACTIONS(6124),
    [anon_sym_upcast] = ACTIONS(6124),
    [anon_sym_downcast] = ACTIONS(6124),
    [anon_sym_for] = ACTIONS(6124),
    [anon_sym_while] = ACTIONS(6124),
    [anon_sym_if] = ACTIONS(6124),
    [anon_sym_fun] = ACTIONS(6124),
    [anon_sym_try] = ACTIONS(6124),
    [anon_sym_match] = ACTIONS(6124),
    [anon_sym_match_BANG] = ACTIONS(6122),
    [anon_sym_function] = ACTIONS(6124),
    [anon_sym_use] = ACTIONS(6124),
    [anon_sym_use_BANG] = ACTIONS(6122),
    [anon_sym_do_BANG] = ACTIONS(6122),
    [anon_sym_begin] = ACTIONS(6124),
    [anon_sym_default] = ACTIONS(6124),
    [anon_sym_static] = ACTIONS(6124),
    [anon_sym_member] = ACTIONS(6124),
    [anon_sym_interface] = ACTIONS(6124),
    [anon_sym_exception] = ACTIONS(6124),
    [anon_sym_abstract] = ACTIONS(6124),
    [anon_sym_val] = ACTIONS(6124),
    [anon_sym_override] = ACTIONS(6124),
    [aux_sym_char_token1] = ACTIONS(6122),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6124),
    [anon_sym_DQUOTE] = ACTIONS(6124),
    [anon_sym_AT_DQUOTE] = ACTIONS(6122),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6122),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6122),
    [sym_bool] = ACTIONS(6124),
    [sym_unit] = ACTIONS(6122),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6124),
    [sym_op_identifier] = ACTIONS(6122),
    [anon_sym_PLUS] = ACTIONS(6124),
    [anon_sym_DASH] = ACTIONS(6124),
    [anon_sym_PLUS_DOT] = ACTIONS(6122),
    [anon_sym_DASH_DOT] = ACTIONS(6122),
    [anon_sym_PERCENT] = ACTIONS(6122),
    [anon_sym_AMP_AMP] = ACTIONS(6122),
    [anon_sym_TILDE] = ACTIONS(6122),
    [aux_sym_prefix_op_token1] = ACTIONS(6122),
    [sym_int] = ACTIONS(6124),
    [sym_xint] = ACTIONS(6122),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6122),
    [anon_sym_POUNDload] = ACTIONS(6122),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6122),
  },
  [3731] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3731),
    [sym_compiler_directive_decl] = STATE(3731),
    [sym_fsi_directive_decl] = STATE(3731),
    [sym_preproc_line] = STATE(3731),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3757),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(6140),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3732] = {
    [sym_block_comment] = STATE(3732),
    [sym_compiler_directive_decl] = STATE(3732),
    [sym_fsi_directive_decl] = STATE(3732),
    [sym_preproc_line] = STATE(3732),
    [ts_builtin_sym_end] = ACTIONS(6132),
    [sym_identifier] = ACTIONS(6134),
    [anon_sym_namespace] = ACTIONS(6134),
    [anon_sym_module] = ACTIONS(6134),
    [anon_sym_open] = ACTIONS(6134),
    [anon_sym_LBRACK_LT] = ACTIONS(6132),
    [anon_sym_return] = ACTIONS(6134),
    [anon_sym_type] = ACTIONS(6134),
    [anon_sym_do] = ACTIONS(6134),
    [anon_sym_and] = ACTIONS(6134),
    [anon_sym_let] = ACTIONS(6134),
    [anon_sym_let_BANG] = ACTIONS(6132),
    [aux_sym_access_modifier_token1] = ACTIONS(6132),
    [anon_sym_LPAREN] = ACTIONS(6134),
    [anon_sym_COMMA] = ACTIONS(6142),
    [anon_sym_null] = ACTIONS(6134),
    [anon_sym_AMP] = ACTIONS(6134),
    [anon_sym_LBRACK] = ACTIONS(6134),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6132),
    [anon_sym_LBRACE] = ACTIONS(6134),
    [anon_sym_LT_AT] = ACTIONS(6134),
    [anon_sym_LT_AT_AT] = ACTIONS(6132),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6132),
    [anon_sym_new] = ACTIONS(6134),
    [anon_sym_return_BANG] = ACTIONS(6132),
    [anon_sym_yield] = ACTIONS(6134),
    [anon_sym_yield_BANG] = ACTIONS(6132),
    [anon_sym_lazy] = ACTIONS(6134),
    [anon_sym_assert] = ACTIONS(6134),
    [anon_sym_upcast] = ACTIONS(6134),
    [anon_sym_downcast] = ACTIONS(6134),
    [anon_sym_for] = ACTIONS(6134),
    [anon_sym_while] = ACTIONS(6134),
    [anon_sym_if] = ACTIONS(6134),
    [anon_sym_fun] = ACTIONS(6134),
    [anon_sym_try] = ACTIONS(6134),
    [anon_sym_match] = ACTIONS(6134),
    [anon_sym_match_BANG] = ACTIONS(6132),
    [anon_sym_function] = ACTIONS(6134),
    [anon_sym_use] = ACTIONS(6134),
    [anon_sym_use_BANG] = ACTIONS(6132),
    [anon_sym_do_BANG] = ACTIONS(6132),
    [anon_sym_begin] = ACTIONS(6134),
    [anon_sym_default] = ACTIONS(6134),
    [anon_sym_static] = ACTIONS(6134),
    [anon_sym_member] = ACTIONS(6134),
    [anon_sym_interface] = ACTIONS(6134),
    [anon_sym_exception] = ACTIONS(6134),
    [anon_sym_abstract] = ACTIONS(6134),
    [anon_sym_val] = ACTIONS(6134),
    [anon_sym_override] = ACTIONS(6134),
    [aux_sym_char_token1] = ACTIONS(6132),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6134),
    [anon_sym_DQUOTE] = ACTIONS(6134),
    [anon_sym_AT_DQUOTE] = ACTIONS(6132),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6132),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6132),
    [sym_bool] = ACTIONS(6134),
    [sym_unit] = ACTIONS(6132),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6134),
    [sym_op_identifier] = ACTIONS(6132),
    [anon_sym_PLUS] = ACTIONS(6134),
    [anon_sym_DASH] = ACTIONS(6134),
    [anon_sym_PLUS_DOT] = ACTIONS(6132),
    [anon_sym_DASH_DOT] = ACTIONS(6132),
    [anon_sym_PERCENT] = ACTIONS(6132),
    [anon_sym_AMP_AMP] = ACTIONS(6132),
    [anon_sym_TILDE] = ACTIONS(6132),
    [aux_sym_prefix_op_token1] = ACTIONS(6132),
    [sym_int] = ACTIONS(6134),
    [sym_xint] = ACTIONS(6132),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6132),
    [anon_sym_POUNDload] = ACTIONS(6132),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6132),
  },
  [3733] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3733),
    [sym_compiler_directive_decl] = STATE(3733),
    [sym_fsi_directive_decl] = STATE(3733),
    [sym_preproc_line] = STATE(3733),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3757),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(6144),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3734] = {
    [sym_block_comment] = STATE(3734),
    [sym_compiler_directive_decl] = STATE(3734),
    [sym_fsi_directive_decl] = STATE(3734),
    [sym_preproc_line] = STATE(3734),
    [ts_builtin_sym_end] = ACTIONS(237),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_module] = ACTIONS(239),
    [anon_sym_open] = ACTIONS(239),
    [anon_sym_LBRACK_LT] = ACTIONS(237),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_type] = ACTIONS(239),
    [anon_sym_do] = ACTIONS(239),
    [anon_sym_and] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(239),
    [anon_sym_let_BANG] = ACTIONS(237),
    [aux_sym_access_modifier_token1] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(6146),
    [anon_sym_null] = ACTIONS(239),
    [anon_sym_AMP] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_LBRACK_PIPE] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LT_AT] = ACTIONS(239),
    [anon_sym_LT_AT_AT] = ACTIONS(237),
    [anon_sym_LBRACE_PIPE] = ACTIONS(237),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_return_BANG] = ACTIONS(237),
    [anon_sym_yield] = ACTIONS(239),
    [anon_sym_yield_BANG] = ACTIONS(237),
    [anon_sym_lazy] = ACTIONS(239),
    [anon_sym_assert] = ACTIONS(239),
    [anon_sym_upcast] = ACTIONS(239),
    [anon_sym_downcast] = ACTIONS(239),
    [anon_sym_for] = ACTIONS(239),
    [anon_sym_while] = ACTIONS(239),
    [anon_sym_if] = ACTIONS(239),
    [anon_sym_fun] = ACTIONS(239),
    [anon_sym_try] = ACTIONS(239),
    [anon_sym_match] = ACTIONS(239),
    [anon_sym_match_BANG] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(239),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(237),
    [anon_sym_do_BANG] = ACTIONS(237),
    [anon_sym_begin] = ACTIONS(239),
    [anon_sym_default] = ACTIONS(239),
    [anon_sym_static] = ACTIONS(239),
    [anon_sym_member] = ACTIONS(239),
    [anon_sym_interface] = ACTIONS(239),
    [anon_sym_exception] = ACTIONS(239),
    [anon_sym_abstract] = ACTIONS(239),
    [anon_sym_val] = ACTIONS(239),
    [anon_sym_override] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [anon_sym_AT_DQUOTE] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [sym_bool] = ACTIONS(239),
    [sym_unit] = ACTIONS(237),
    [anon_sym_LPAREN_PIPE] = ACTIONS(239),
    [sym_op_identifier] = ACTIONS(237),
    [anon_sym_PLUS] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_PLUS_DOT] = ACTIONS(237),
    [anon_sym_DASH_DOT] = ACTIONS(237),
    [anon_sym_PERCENT] = ACTIONS(237),
    [anon_sym_AMP_AMP] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(237),
    [aux_sym_prefix_op_token1] = ACTIONS(237),
    [sym_int] = ACTIONS(239),
    [sym_xint] = ACTIONS(237),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(237),
    [anon_sym_POUNDload] = ACTIONS(237),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(237),
  },
  [3735] = {
    [sym_block_comment] = STATE(3735),
    [sym_compiler_directive_decl] = STATE(3735),
    [sym_fsi_directive_decl] = STATE(3735),
    [sym_preproc_line] = STATE(3735),
    [ts_builtin_sym_end] = ACTIONS(237),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_module] = ACTIONS(239),
    [anon_sym_open] = ACTIONS(239),
    [anon_sym_LBRACK_LT] = ACTIONS(237),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_type] = ACTIONS(239),
    [anon_sym_do] = ACTIONS(239),
    [anon_sym_and] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(239),
    [anon_sym_let_BANG] = ACTIONS(237),
    [aux_sym_access_modifier_token1] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(6148),
    [anon_sym_null] = ACTIONS(239),
    [anon_sym_AMP] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_LBRACK_PIPE] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LT_AT] = ACTIONS(239),
    [anon_sym_LT_AT_AT] = ACTIONS(237),
    [anon_sym_LBRACE_PIPE] = ACTIONS(237),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_return_BANG] = ACTIONS(237),
    [anon_sym_yield] = ACTIONS(239),
    [anon_sym_yield_BANG] = ACTIONS(237),
    [anon_sym_lazy] = ACTIONS(239),
    [anon_sym_assert] = ACTIONS(239),
    [anon_sym_upcast] = ACTIONS(239),
    [anon_sym_downcast] = ACTIONS(239),
    [anon_sym_for] = ACTIONS(239),
    [anon_sym_while] = ACTIONS(239),
    [anon_sym_if] = ACTIONS(239),
    [anon_sym_fun] = ACTIONS(239),
    [anon_sym_try] = ACTIONS(239),
    [anon_sym_match] = ACTIONS(239),
    [anon_sym_match_BANG] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(239),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(237),
    [anon_sym_do_BANG] = ACTIONS(237),
    [anon_sym_begin] = ACTIONS(239),
    [anon_sym_default] = ACTIONS(239),
    [anon_sym_static] = ACTIONS(239),
    [anon_sym_member] = ACTIONS(239),
    [anon_sym_interface] = ACTIONS(239),
    [anon_sym_exception] = ACTIONS(239),
    [anon_sym_abstract] = ACTIONS(239),
    [anon_sym_val] = ACTIONS(239),
    [anon_sym_override] = ACTIONS(239),
    [aux_sym_char_token1] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [anon_sym_AT_DQUOTE] = ACTIONS(237),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(237),
    [sym_bool] = ACTIONS(239),
    [sym_unit] = ACTIONS(237),
    [anon_sym_LPAREN_PIPE] = ACTIONS(239),
    [sym_op_identifier] = ACTIONS(237),
    [anon_sym_PLUS] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_PLUS_DOT] = ACTIONS(237),
    [anon_sym_DASH_DOT] = ACTIONS(237),
    [anon_sym_PERCENT] = ACTIONS(237),
    [anon_sym_AMP_AMP] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(237),
    [aux_sym_prefix_op_token1] = ACTIONS(237),
    [sym_int] = ACTIONS(239),
    [sym_xint] = ACTIONS(237),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(237),
    [anon_sym_POUNDload] = ACTIONS(237),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(237),
  },
  [3736] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3736),
    [sym_compiler_directive_decl] = STATE(3736),
    [sym_fsi_directive_decl] = STATE(3736),
    [sym_preproc_line] = STATE(3736),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3757),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(6150),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3737] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3737),
    [sym_compiler_directive_decl] = STATE(3737),
    [sym_fsi_directive_decl] = STATE(3737),
    [sym_preproc_line] = STATE(3737),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3757),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(6152),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3738] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_access_modifier] = STATE(3909),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7898),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3738),
    [sym_compiler_directive_decl] = STATE(3738),
    [sym_fsi_directive_decl] = STATE(3738),
    [sym_preproc_line] = STATE(3738),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [aux_sym_access_modifier_token1] = ACTIONS(5215),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3739] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3739),
    [sym_compiler_directive_decl] = STATE(3739),
    [sym_fsi_directive_decl] = STATE(3739),
    [sym_preproc_line] = STATE(3739),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3757),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(6154),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3740] = {
    [sym_block_comment] = STATE(3740),
    [sym_compiler_directive_decl] = STATE(3740),
    [sym_fsi_directive_decl] = STATE(3740),
    [sym_preproc_line] = STATE(3740),
    [aux_sym__function_or_value_defns_repeat1] = STATE(3725),
    [ts_builtin_sym_end] = ACTIONS(6156),
    [sym_identifier] = ACTIONS(6158),
    [anon_sym_namespace] = ACTIONS(6158),
    [anon_sym_module] = ACTIONS(6158),
    [anon_sym_open] = ACTIONS(6158),
    [anon_sym_LBRACK_LT] = ACTIONS(6156),
    [anon_sym_return] = ACTIONS(6158),
    [anon_sym_type] = ACTIONS(6158),
    [anon_sym_do] = ACTIONS(6158),
    [anon_sym_and] = ACTIONS(6160),
    [anon_sym_let] = ACTIONS(6158),
    [anon_sym_let_BANG] = ACTIONS(6156),
    [aux_sym_access_modifier_token1] = ACTIONS(6156),
    [anon_sym_LPAREN] = ACTIONS(6158),
    [anon_sym_null] = ACTIONS(6158),
    [anon_sym_AMP] = ACTIONS(6158),
    [anon_sym_LBRACK] = ACTIONS(6158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6156),
    [anon_sym_LBRACE] = ACTIONS(6158),
    [anon_sym_LT_AT] = ACTIONS(6158),
    [anon_sym_LT_AT_AT] = ACTIONS(6156),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6156),
    [anon_sym_new] = ACTIONS(6158),
    [anon_sym_return_BANG] = ACTIONS(6156),
    [anon_sym_yield] = ACTIONS(6158),
    [anon_sym_yield_BANG] = ACTIONS(6156),
    [anon_sym_lazy] = ACTIONS(6158),
    [anon_sym_assert] = ACTIONS(6158),
    [anon_sym_upcast] = ACTIONS(6158),
    [anon_sym_downcast] = ACTIONS(6158),
    [anon_sym_for] = ACTIONS(6158),
    [anon_sym_while] = ACTIONS(6158),
    [anon_sym_if] = ACTIONS(6158),
    [anon_sym_fun] = ACTIONS(6158),
    [anon_sym_try] = ACTIONS(6158),
    [anon_sym_match] = ACTIONS(6158),
    [anon_sym_match_BANG] = ACTIONS(6156),
    [anon_sym_function] = ACTIONS(6158),
    [anon_sym_use] = ACTIONS(6158),
    [anon_sym_use_BANG] = ACTIONS(6156),
    [anon_sym_do_BANG] = ACTIONS(6156),
    [anon_sym_begin] = ACTIONS(6158),
    [anon_sym_default] = ACTIONS(6158),
    [anon_sym_static] = ACTIONS(6158),
    [anon_sym_member] = ACTIONS(6158),
    [anon_sym_interface] = ACTIONS(6158),
    [anon_sym_exception] = ACTIONS(6158),
    [anon_sym_abstract] = ACTIONS(6158),
    [anon_sym_val] = ACTIONS(6158),
    [anon_sym_override] = ACTIONS(6158),
    [aux_sym_char_token1] = ACTIONS(6156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6158),
    [anon_sym_DQUOTE] = ACTIONS(6158),
    [anon_sym_AT_DQUOTE] = ACTIONS(6156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6156),
    [sym_bool] = ACTIONS(6158),
    [sym_unit] = ACTIONS(6156),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6158),
    [sym_op_identifier] = ACTIONS(6156),
    [anon_sym_PLUS] = ACTIONS(6158),
    [anon_sym_DASH] = ACTIONS(6158),
    [anon_sym_PLUS_DOT] = ACTIONS(6156),
    [anon_sym_DASH_DOT] = ACTIONS(6156),
    [anon_sym_PERCENT] = ACTIONS(6156),
    [anon_sym_AMP_AMP] = ACTIONS(6156),
    [anon_sym_TILDE] = ACTIONS(6156),
    [aux_sym_prefix_op_token1] = ACTIONS(6156),
    [sym_int] = ACTIONS(6158),
    [sym_xint] = ACTIONS(6156),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6156),
    [anon_sym_POUNDload] = ACTIONS(6156),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6156),
  },
  [3741] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3741),
    [sym_compiler_directive_decl] = STATE(3741),
    [sym_fsi_directive_decl] = STATE(3741),
    [sym_preproc_line] = STATE(3741),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3757),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(6162),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3742] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3742),
    [sym_compiler_directive_decl] = STATE(3742),
    [sym_fsi_directive_decl] = STATE(3742),
    [sym_preproc_line] = STATE(3742),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3757),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(6164),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3743] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3743),
    [sym_compiler_directive_decl] = STATE(3743),
    [sym_fsi_directive_decl] = STATE(3743),
    [sym_preproc_line] = STATE(3743),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3757),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(6166),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3744] = {
    [sym_block_comment] = STATE(3744),
    [sym_compiler_directive_decl] = STATE(3744),
    [sym_fsi_directive_decl] = STATE(3744),
    [sym_preproc_line] = STATE(3744),
    [ts_builtin_sym_end] = ACTIONS(6168),
    [sym_identifier] = ACTIONS(6170),
    [anon_sym_namespace] = ACTIONS(6170),
    [anon_sym_module] = ACTIONS(6170),
    [anon_sym_open] = ACTIONS(6170),
    [anon_sym_LBRACK_LT] = ACTIONS(6168),
    [anon_sym_return] = ACTIONS(6170),
    [anon_sym_type] = ACTIONS(6170),
    [anon_sym_do] = ACTIONS(6170),
    [anon_sym_and] = ACTIONS(6170),
    [anon_sym_let] = ACTIONS(6170),
    [anon_sym_let_BANG] = ACTIONS(6168),
    [aux_sym_access_modifier_token1] = ACTIONS(6168),
    [anon_sym_LPAREN] = ACTIONS(6170),
    [anon_sym_null] = ACTIONS(6170),
    [anon_sym_AMP] = ACTIONS(6170),
    [anon_sym_LBRACK] = ACTIONS(6170),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6168),
    [anon_sym_LBRACE] = ACTIONS(6170),
    [anon_sym_LT_AT] = ACTIONS(6170),
    [anon_sym_LT_AT_AT] = ACTIONS(6168),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6168),
    [anon_sym_new] = ACTIONS(6170),
    [anon_sym_with] = ACTIONS(6172),
    [anon_sym_return_BANG] = ACTIONS(6168),
    [anon_sym_yield] = ACTIONS(6170),
    [anon_sym_yield_BANG] = ACTIONS(6168),
    [anon_sym_lazy] = ACTIONS(6170),
    [anon_sym_assert] = ACTIONS(6170),
    [anon_sym_upcast] = ACTIONS(6170),
    [anon_sym_downcast] = ACTIONS(6170),
    [anon_sym_for] = ACTIONS(6170),
    [anon_sym_while] = ACTIONS(6170),
    [anon_sym_if] = ACTIONS(6170),
    [anon_sym_fun] = ACTIONS(6170),
    [anon_sym_try] = ACTIONS(6170),
    [anon_sym_match] = ACTIONS(6170),
    [anon_sym_match_BANG] = ACTIONS(6168),
    [anon_sym_function] = ACTIONS(6170),
    [anon_sym_use] = ACTIONS(6170),
    [anon_sym_use_BANG] = ACTIONS(6168),
    [anon_sym_do_BANG] = ACTIONS(6168),
    [anon_sym_begin] = ACTIONS(6170),
    [anon_sym_default] = ACTIONS(6170),
    [anon_sym_static] = ACTIONS(6170),
    [anon_sym_member] = ACTIONS(6170),
    [anon_sym_interface] = ACTIONS(6170),
    [anon_sym_exception] = ACTIONS(6170),
    [anon_sym_abstract] = ACTIONS(6170),
    [anon_sym_val] = ACTIONS(6170),
    [anon_sym_override] = ACTIONS(6170),
    [aux_sym_char_token1] = ACTIONS(6168),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6170),
    [anon_sym_DQUOTE] = ACTIONS(6170),
    [anon_sym_AT_DQUOTE] = ACTIONS(6168),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6168),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6168),
    [sym_bool] = ACTIONS(6170),
    [sym_unit] = ACTIONS(6168),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6170),
    [sym_op_identifier] = ACTIONS(6168),
    [anon_sym_PLUS] = ACTIONS(6170),
    [anon_sym_DASH] = ACTIONS(6170),
    [anon_sym_PLUS_DOT] = ACTIONS(6168),
    [anon_sym_DASH_DOT] = ACTIONS(6168),
    [anon_sym_PERCENT] = ACTIONS(6168),
    [anon_sym_AMP_AMP] = ACTIONS(6168),
    [anon_sym_TILDE] = ACTIONS(6168),
    [aux_sym_prefix_op_token1] = ACTIONS(6168),
    [sym_int] = ACTIONS(6170),
    [sym_xint] = ACTIONS(6168),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6168),
    [anon_sym_POUNDload] = ACTIONS(6168),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6168),
  },
  [3745] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3745),
    [sym_compiler_directive_decl] = STATE(3745),
    [sym_fsi_directive_decl] = STATE(3745),
    [sym_preproc_line] = STATE(3745),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3757),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(6174),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3746] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3746),
    [sym_compiler_directive_decl] = STATE(3746),
    [sym_fsi_directive_decl] = STATE(3746),
    [sym_preproc_line] = STATE(3746),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3757),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(6176),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3747] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3747),
    [sym_compiler_directive_decl] = STATE(3747),
    [sym_fsi_directive_decl] = STATE(3747),
    [sym_preproc_line] = STATE(3747),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3757),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(6178),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3748] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3748),
    [sym_compiler_directive_decl] = STATE(3748),
    [sym_fsi_directive_decl] = STATE(3748),
    [sym_preproc_line] = STATE(3748),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3757),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(6180),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3749] = {
    [sym_block_comment] = STATE(3749),
    [sym_compiler_directive_decl] = STATE(3749),
    [sym_fsi_directive_decl] = STATE(3749),
    [sym_preproc_line] = STATE(3749),
    [ts_builtin_sym_end] = ACTIONS(6182),
    [sym_identifier] = ACTIONS(6184),
    [anon_sym_namespace] = ACTIONS(6184),
    [anon_sym_module] = ACTIONS(6184),
    [anon_sym_open] = ACTIONS(6184),
    [anon_sym_LBRACK_LT] = ACTIONS(6182),
    [anon_sym_return] = ACTIONS(6184),
    [anon_sym_type] = ACTIONS(6184),
    [anon_sym_do] = ACTIONS(6184),
    [anon_sym_and] = ACTIONS(6184),
    [anon_sym_let] = ACTIONS(6184),
    [anon_sym_let_BANG] = ACTIONS(6182),
    [aux_sym_access_modifier_token1] = ACTIONS(6182),
    [anon_sym_LPAREN] = ACTIONS(6184),
    [anon_sym_COMMA] = ACTIONS(6186),
    [anon_sym_null] = ACTIONS(6184),
    [anon_sym_AMP] = ACTIONS(6184),
    [anon_sym_LBRACK] = ACTIONS(6184),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6182),
    [anon_sym_LBRACE] = ACTIONS(6184),
    [anon_sym_LT_AT] = ACTIONS(6184),
    [anon_sym_LT_AT_AT] = ACTIONS(6182),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6182),
    [anon_sym_new] = ACTIONS(6184),
    [anon_sym_return_BANG] = ACTIONS(6182),
    [anon_sym_yield] = ACTIONS(6184),
    [anon_sym_yield_BANG] = ACTIONS(6182),
    [anon_sym_lazy] = ACTIONS(6184),
    [anon_sym_assert] = ACTIONS(6184),
    [anon_sym_upcast] = ACTIONS(6184),
    [anon_sym_downcast] = ACTIONS(6184),
    [anon_sym_for] = ACTIONS(6184),
    [anon_sym_while] = ACTIONS(6184),
    [anon_sym_if] = ACTIONS(6184),
    [anon_sym_fun] = ACTIONS(6184),
    [anon_sym_try] = ACTIONS(6184),
    [anon_sym_match] = ACTIONS(6184),
    [anon_sym_match_BANG] = ACTIONS(6182),
    [anon_sym_function] = ACTIONS(6184),
    [anon_sym_use] = ACTIONS(6184),
    [anon_sym_use_BANG] = ACTIONS(6182),
    [anon_sym_do_BANG] = ACTIONS(6182),
    [anon_sym_begin] = ACTIONS(6184),
    [anon_sym_default] = ACTIONS(6184),
    [anon_sym_static] = ACTIONS(6184),
    [anon_sym_member] = ACTIONS(6184),
    [anon_sym_interface] = ACTIONS(6184),
    [anon_sym_exception] = ACTIONS(6184),
    [anon_sym_abstract] = ACTIONS(6184),
    [anon_sym_val] = ACTIONS(6184),
    [anon_sym_override] = ACTIONS(6184),
    [aux_sym_char_token1] = ACTIONS(6182),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6184),
    [anon_sym_DQUOTE] = ACTIONS(6184),
    [anon_sym_AT_DQUOTE] = ACTIONS(6182),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6182),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6182),
    [sym_bool] = ACTIONS(6184),
    [sym_unit] = ACTIONS(6182),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6184),
    [sym_op_identifier] = ACTIONS(6182),
    [anon_sym_PLUS] = ACTIONS(6184),
    [anon_sym_DASH] = ACTIONS(6184),
    [anon_sym_PLUS_DOT] = ACTIONS(6182),
    [anon_sym_DASH_DOT] = ACTIONS(6182),
    [anon_sym_PERCENT] = ACTIONS(6182),
    [anon_sym_AMP_AMP] = ACTIONS(6182),
    [anon_sym_TILDE] = ACTIONS(6182),
    [aux_sym_prefix_op_token1] = ACTIONS(6182),
    [sym_int] = ACTIONS(6184),
    [sym_xint] = ACTIONS(6182),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6182),
    [anon_sym_POUNDload] = ACTIONS(6182),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6182),
  },
  [3750] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3750),
    [sym_compiler_directive_decl] = STATE(3750),
    [sym_fsi_directive_decl] = STATE(3750),
    [sym_preproc_line] = STATE(3750),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3757),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(6188),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3751] = {
    [sym_block_comment] = STATE(3751),
    [sym_compiler_directive_decl] = STATE(3751),
    [sym_fsi_directive_decl] = STATE(3751),
    [sym_preproc_line] = STATE(3751),
    [aux_sym__function_or_value_defns_repeat1] = STATE(3740),
    [ts_builtin_sym_end] = ACTIONS(6190),
    [sym_identifier] = ACTIONS(6192),
    [anon_sym_namespace] = ACTIONS(6192),
    [anon_sym_module] = ACTIONS(6192),
    [anon_sym_open] = ACTIONS(6192),
    [anon_sym_LBRACK_LT] = ACTIONS(6190),
    [anon_sym_return] = ACTIONS(6192),
    [anon_sym_type] = ACTIONS(6192),
    [anon_sym_do] = ACTIONS(6192),
    [anon_sym_and] = ACTIONS(6160),
    [anon_sym_let] = ACTIONS(6192),
    [anon_sym_let_BANG] = ACTIONS(6190),
    [aux_sym_access_modifier_token1] = ACTIONS(6190),
    [anon_sym_LPAREN] = ACTIONS(6192),
    [anon_sym_null] = ACTIONS(6192),
    [anon_sym_AMP] = ACTIONS(6192),
    [anon_sym_LBRACK] = ACTIONS(6192),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6190),
    [anon_sym_LBRACE] = ACTIONS(6192),
    [anon_sym_LT_AT] = ACTIONS(6192),
    [anon_sym_LT_AT_AT] = ACTIONS(6190),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6190),
    [anon_sym_new] = ACTIONS(6192),
    [anon_sym_return_BANG] = ACTIONS(6190),
    [anon_sym_yield] = ACTIONS(6192),
    [anon_sym_yield_BANG] = ACTIONS(6190),
    [anon_sym_lazy] = ACTIONS(6192),
    [anon_sym_assert] = ACTIONS(6192),
    [anon_sym_upcast] = ACTIONS(6192),
    [anon_sym_downcast] = ACTIONS(6192),
    [anon_sym_for] = ACTIONS(6192),
    [anon_sym_while] = ACTIONS(6192),
    [anon_sym_if] = ACTIONS(6192),
    [anon_sym_fun] = ACTIONS(6192),
    [anon_sym_try] = ACTIONS(6192),
    [anon_sym_match] = ACTIONS(6192),
    [anon_sym_match_BANG] = ACTIONS(6190),
    [anon_sym_function] = ACTIONS(6192),
    [anon_sym_use] = ACTIONS(6192),
    [anon_sym_use_BANG] = ACTIONS(6190),
    [anon_sym_do_BANG] = ACTIONS(6190),
    [anon_sym_begin] = ACTIONS(6192),
    [anon_sym_default] = ACTIONS(6192),
    [anon_sym_static] = ACTIONS(6192),
    [anon_sym_member] = ACTIONS(6192),
    [anon_sym_interface] = ACTIONS(6192),
    [anon_sym_exception] = ACTIONS(6192),
    [anon_sym_abstract] = ACTIONS(6192),
    [anon_sym_val] = ACTIONS(6192),
    [anon_sym_override] = ACTIONS(6192),
    [aux_sym_char_token1] = ACTIONS(6190),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6192),
    [anon_sym_DQUOTE] = ACTIONS(6192),
    [anon_sym_AT_DQUOTE] = ACTIONS(6190),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6190),
    [sym_bool] = ACTIONS(6192),
    [sym_unit] = ACTIONS(6190),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6192),
    [sym_op_identifier] = ACTIONS(6190),
    [anon_sym_PLUS] = ACTIONS(6192),
    [anon_sym_DASH] = ACTIONS(6192),
    [anon_sym_PLUS_DOT] = ACTIONS(6190),
    [anon_sym_DASH_DOT] = ACTIONS(6190),
    [anon_sym_PERCENT] = ACTIONS(6190),
    [anon_sym_AMP_AMP] = ACTIONS(6190),
    [anon_sym_TILDE] = ACTIONS(6190),
    [aux_sym_prefix_op_token1] = ACTIONS(6190),
    [sym_int] = ACTIONS(6192),
    [sym_xint] = ACTIONS(6190),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6190),
    [anon_sym_POUNDload] = ACTIONS(6190),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6190),
  },
  [3752] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3752),
    [sym_compiler_directive_decl] = STATE(3752),
    [sym_fsi_directive_decl] = STATE(3752),
    [sym_preproc_line] = STATE(3752),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3757),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(6194),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3753] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3753),
    [sym_compiler_directive_decl] = STATE(3753),
    [sym_fsi_directive_decl] = STATE(3753),
    [sym_preproc_line] = STATE(3753),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3757),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(6196),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3754] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3754),
    [sym_compiler_directive_decl] = STATE(3754),
    [sym_fsi_directive_decl] = STATE(3754),
    [sym_preproc_line] = STATE(3754),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3757),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(6198),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3755] = {
    [sym_block_comment] = STATE(3755),
    [sym_compiler_directive_decl] = STATE(3755),
    [sym_fsi_directive_decl] = STATE(3755),
    [sym_preproc_line] = STATE(3755),
    [ts_builtin_sym_end] = ACTIONS(6182),
    [sym_identifier] = ACTIONS(6184),
    [anon_sym_namespace] = ACTIONS(6184),
    [anon_sym_module] = ACTIONS(6184),
    [anon_sym_open] = ACTIONS(6184),
    [anon_sym_LBRACK_LT] = ACTIONS(6182),
    [anon_sym_return] = ACTIONS(6184),
    [anon_sym_type] = ACTIONS(6184),
    [anon_sym_do] = ACTIONS(6184),
    [anon_sym_and] = ACTIONS(6184),
    [anon_sym_let] = ACTIONS(6184),
    [anon_sym_let_BANG] = ACTIONS(6182),
    [aux_sym_access_modifier_token1] = ACTIONS(6182),
    [anon_sym_LPAREN] = ACTIONS(6184),
    [anon_sym_COMMA] = ACTIONS(6200),
    [anon_sym_null] = ACTIONS(6184),
    [anon_sym_AMP] = ACTIONS(6184),
    [anon_sym_LBRACK] = ACTIONS(6184),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6182),
    [anon_sym_LBRACE] = ACTIONS(6184),
    [anon_sym_LT_AT] = ACTIONS(6184),
    [anon_sym_LT_AT_AT] = ACTIONS(6182),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6182),
    [anon_sym_new] = ACTIONS(6184),
    [anon_sym_return_BANG] = ACTIONS(6182),
    [anon_sym_yield] = ACTIONS(6184),
    [anon_sym_yield_BANG] = ACTIONS(6182),
    [anon_sym_lazy] = ACTIONS(6184),
    [anon_sym_assert] = ACTIONS(6184),
    [anon_sym_upcast] = ACTIONS(6184),
    [anon_sym_downcast] = ACTIONS(6184),
    [anon_sym_for] = ACTIONS(6184),
    [anon_sym_while] = ACTIONS(6184),
    [anon_sym_if] = ACTIONS(6184),
    [anon_sym_fun] = ACTIONS(6184),
    [anon_sym_try] = ACTIONS(6184),
    [anon_sym_match] = ACTIONS(6184),
    [anon_sym_match_BANG] = ACTIONS(6182),
    [anon_sym_function] = ACTIONS(6184),
    [anon_sym_use] = ACTIONS(6184),
    [anon_sym_use_BANG] = ACTIONS(6182),
    [anon_sym_do_BANG] = ACTIONS(6182),
    [anon_sym_begin] = ACTIONS(6184),
    [anon_sym_default] = ACTIONS(6184),
    [anon_sym_static] = ACTIONS(6184),
    [anon_sym_member] = ACTIONS(6184),
    [anon_sym_interface] = ACTIONS(6184),
    [anon_sym_exception] = ACTIONS(6184),
    [anon_sym_abstract] = ACTIONS(6184),
    [anon_sym_val] = ACTIONS(6184),
    [anon_sym_override] = ACTIONS(6184),
    [aux_sym_char_token1] = ACTIONS(6182),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6184),
    [anon_sym_DQUOTE] = ACTIONS(6184),
    [anon_sym_AT_DQUOTE] = ACTIONS(6182),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6182),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6182),
    [sym_bool] = ACTIONS(6184),
    [sym_unit] = ACTIONS(6182),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6184),
    [sym_op_identifier] = ACTIONS(6182),
    [anon_sym_PLUS] = ACTIONS(6184),
    [anon_sym_DASH] = ACTIONS(6184),
    [anon_sym_PLUS_DOT] = ACTIONS(6182),
    [anon_sym_DASH_DOT] = ACTIONS(6182),
    [anon_sym_PERCENT] = ACTIONS(6182),
    [anon_sym_AMP_AMP] = ACTIONS(6182),
    [anon_sym_TILDE] = ACTIONS(6182),
    [aux_sym_prefix_op_token1] = ACTIONS(6182),
    [sym_int] = ACTIONS(6184),
    [sym_xint] = ACTIONS(6182),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6182),
    [anon_sym_POUNDload] = ACTIONS(6182),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6182),
  },
  [3756] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3756),
    [sym_compiler_directive_decl] = STATE(3756),
    [sym_fsi_directive_decl] = STATE(3756),
    [sym_preproc_line] = STATE(3756),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3757),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_EQ] = ACTIONS(6202),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3757] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3757),
    [sym_compiler_directive_decl] = STATE(3757),
    [sym_fsi_directive_decl] = STATE(3757),
    [sym_preproc_line] = STATE(3757),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3757),
    [sym_identifier] = ACTIONS(6204),
    [anon_sym_EQ] = ACTIONS(6207),
    [anon_sym_LBRACK_LT] = ACTIONS(6209),
    [anon_sym_LPAREN] = ACTIONS(6212),
    [anon_sym_null] = ACTIONS(6215),
    [anon_sym__] = ACTIONS(6218),
    [anon_sym_QMARK] = ACTIONS(6221),
    [anon_sym_COLON_QMARK] = ACTIONS(6224),
    [anon_sym_LBRACK] = ACTIONS(6227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6230),
    [anon_sym_LBRACE] = ACTIONS(6233),
    [aux_sym_char_token1] = ACTIONS(6236),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6239),
    [anon_sym_DQUOTE] = ACTIONS(6242),
    [anon_sym_AT_DQUOTE] = ACTIONS(6245),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6251),
    [sym_bool] = ACTIONS(6254),
    [sym_unit] = ACTIONS(6257),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6260),
    [sym_op_identifier] = ACTIONS(6263),
    [sym_int] = ACTIONS(6266),
    [sym_xint] = ACTIONS(6269),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3758] = {
    [sym_block_comment] = STATE(3758),
    [sym_compiler_directive_decl] = STATE(3758),
    [sym_fsi_directive_decl] = STATE(3758),
    [sym_preproc_line] = STATE(3758),
    [ts_builtin_sym_end] = ACTIONS(6272),
    [sym_identifier] = ACTIONS(6274),
    [anon_sym_namespace] = ACTIONS(6274),
    [anon_sym_module] = ACTIONS(6274),
    [anon_sym_open] = ACTIONS(6274),
    [anon_sym_LBRACK_LT] = ACTIONS(6272),
    [anon_sym_return] = ACTIONS(6274),
    [anon_sym_type] = ACTIONS(6274),
    [anon_sym_do] = ACTIONS(6274),
    [anon_sym_and] = ACTIONS(6274),
    [anon_sym_let] = ACTIONS(6274),
    [anon_sym_let_BANG] = ACTIONS(6272),
    [aux_sym_access_modifier_token1] = ACTIONS(6272),
    [anon_sym_LPAREN] = ACTIONS(6274),
    [anon_sym_null] = ACTIONS(6274),
    [anon_sym_AMP] = ACTIONS(6274),
    [anon_sym_LBRACK] = ACTIONS(6274),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6272),
    [anon_sym_LBRACE] = ACTIONS(6274),
    [anon_sym_LT_AT] = ACTIONS(6274),
    [anon_sym_LT_AT_AT] = ACTIONS(6272),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6272),
    [anon_sym_new] = ACTIONS(6274),
    [anon_sym_with] = ACTIONS(6276),
    [anon_sym_return_BANG] = ACTIONS(6272),
    [anon_sym_yield] = ACTIONS(6274),
    [anon_sym_yield_BANG] = ACTIONS(6272),
    [anon_sym_lazy] = ACTIONS(6274),
    [anon_sym_assert] = ACTIONS(6274),
    [anon_sym_upcast] = ACTIONS(6274),
    [anon_sym_downcast] = ACTIONS(6274),
    [anon_sym_for] = ACTIONS(6274),
    [anon_sym_while] = ACTIONS(6274),
    [anon_sym_if] = ACTIONS(6274),
    [anon_sym_fun] = ACTIONS(6274),
    [anon_sym_try] = ACTIONS(6274),
    [anon_sym_match] = ACTIONS(6274),
    [anon_sym_match_BANG] = ACTIONS(6272),
    [anon_sym_function] = ACTIONS(6274),
    [anon_sym_use] = ACTIONS(6274),
    [anon_sym_use_BANG] = ACTIONS(6272),
    [anon_sym_do_BANG] = ACTIONS(6272),
    [anon_sym_begin] = ACTIONS(6274),
    [anon_sym_default] = ACTIONS(6274),
    [anon_sym_static] = ACTIONS(6274),
    [anon_sym_member] = ACTIONS(6274),
    [anon_sym_interface] = ACTIONS(6274),
    [anon_sym_exception] = ACTIONS(6274),
    [anon_sym_abstract] = ACTIONS(6274),
    [anon_sym_val] = ACTIONS(6274),
    [anon_sym_override] = ACTIONS(6274),
    [aux_sym_char_token1] = ACTIONS(6272),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6274),
    [anon_sym_DQUOTE] = ACTIONS(6274),
    [anon_sym_AT_DQUOTE] = ACTIONS(6272),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6272),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6272),
    [sym_bool] = ACTIONS(6274),
    [sym_unit] = ACTIONS(6272),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6274),
    [sym_op_identifier] = ACTIONS(6272),
    [anon_sym_PLUS] = ACTIONS(6274),
    [anon_sym_DASH] = ACTIONS(6274),
    [anon_sym_PLUS_DOT] = ACTIONS(6272),
    [anon_sym_DASH_DOT] = ACTIONS(6272),
    [anon_sym_PERCENT] = ACTIONS(6272),
    [anon_sym_AMP_AMP] = ACTIONS(6272),
    [anon_sym_TILDE] = ACTIONS(6272),
    [aux_sym_prefix_op_token1] = ACTIONS(6272),
    [sym_int] = ACTIONS(6274),
    [sym_xint] = ACTIONS(6272),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6272),
    [anon_sym_POUNDload] = ACTIONS(6272),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6272),
  },
  [3759] = {
    [sym_block_comment] = STATE(3759),
    [sym_compiler_directive_decl] = STATE(3759),
    [sym_fsi_directive_decl] = STATE(3759),
    [sym_preproc_line] = STATE(3759),
    [ts_builtin_sym_end] = ACTIONS(6278),
    [sym_identifier] = ACTIONS(6280),
    [anon_sym_namespace] = ACTIONS(6280),
    [anon_sym_module] = ACTIONS(6280),
    [anon_sym_open] = ACTIONS(6280),
    [anon_sym_LBRACK_LT] = ACTIONS(6278),
    [anon_sym_return] = ACTIONS(6280),
    [anon_sym_type] = ACTIONS(6280),
    [anon_sym_do] = ACTIONS(6280),
    [anon_sym_and] = ACTIONS(6280),
    [anon_sym_let] = ACTIONS(6280),
    [anon_sym_let_BANG] = ACTIONS(6278),
    [aux_sym_access_modifier_token1] = ACTIONS(6278),
    [anon_sym_LPAREN] = ACTIONS(6280),
    [anon_sym_null] = ACTIONS(6280),
    [anon_sym_AMP] = ACTIONS(6280),
    [anon_sym_LBRACK] = ACTIONS(6280),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6278),
    [anon_sym_LBRACE] = ACTIONS(6280),
    [anon_sym_LT_AT] = ACTIONS(6280),
    [anon_sym_LT_AT_AT] = ACTIONS(6278),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6278),
    [anon_sym_new] = ACTIONS(6280),
    [anon_sym_return_BANG] = ACTIONS(6278),
    [anon_sym_yield] = ACTIONS(6280),
    [anon_sym_yield_BANG] = ACTIONS(6278),
    [anon_sym_lazy] = ACTIONS(6280),
    [anon_sym_assert] = ACTIONS(6280),
    [anon_sym_upcast] = ACTIONS(6280),
    [anon_sym_downcast] = ACTIONS(6280),
    [anon_sym_for] = ACTIONS(6280),
    [anon_sym_while] = ACTIONS(6280),
    [anon_sym_if] = ACTIONS(6280),
    [anon_sym_fun] = ACTIONS(6280),
    [anon_sym_try] = ACTIONS(6280),
    [anon_sym_match] = ACTIONS(6280),
    [anon_sym_match_BANG] = ACTIONS(6278),
    [anon_sym_function] = ACTIONS(6280),
    [anon_sym_use] = ACTIONS(6280),
    [anon_sym_use_BANG] = ACTIONS(6278),
    [anon_sym_do_BANG] = ACTIONS(6278),
    [anon_sym_begin] = ACTIONS(6280),
    [anon_sym_default] = ACTIONS(6280),
    [anon_sym_static] = ACTIONS(6280),
    [anon_sym_member] = ACTIONS(6280),
    [anon_sym_interface] = ACTIONS(6280),
    [anon_sym_exception] = ACTIONS(6280),
    [anon_sym_abstract] = ACTIONS(6280),
    [anon_sym_val] = ACTIONS(6280),
    [anon_sym_override] = ACTIONS(6280),
    [aux_sym_char_token1] = ACTIONS(6278),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6280),
    [anon_sym_DQUOTE] = ACTIONS(6280),
    [anon_sym_AT_DQUOTE] = ACTIONS(6278),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6278),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6278),
    [sym_bool] = ACTIONS(6280),
    [sym_unit] = ACTIONS(6278),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6280),
    [sym_op_identifier] = ACTIONS(6278),
    [anon_sym_PLUS] = ACTIONS(6280),
    [anon_sym_DASH] = ACTIONS(6280),
    [anon_sym_PLUS_DOT] = ACTIONS(6278),
    [anon_sym_DASH_DOT] = ACTIONS(6278),
    [anon_sym_PERCENT] = ACTIONS(6278),
    [anon_sym_AMP_AMP] = ACTIONS(6278),
    [anon_sym_TILDE] = ACTIONS(6278),
    [aux_sym_prefix_op_token1] = ACTIONS(6278),
    [sym_int] = ACTIONS(6280),
    [sym_xint] = ACTIONS(6278),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6278),
    [anon_sym_POUNDload] = ACTIONS(6278),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6278),
  },
  [3760] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(9146),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3760),
    [sym_compiler_directive_decl] = STATE(3760),
    [sym_fsi_directive_decl] = STATE(3760),
    [sym_preproc_line] = STATE(3760),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3761] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8166),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2914),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3761),
    [sym_compiler_directive_decl] = STATE(3761),
    [sym_fsi_directive_decl] = STATE(3761),
    [sym_preproc_line] = STATE(3761),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3762] = {
    [sym_block_comment] = STATE(3762),
    [sym_compiler_directive_decl] = STATE(3762),
    [sym_fsi_directive_decl] = STATE(3762),
    [sym_preproc_line] = STATE(3762),
    [ts_builtin_sym_end] = ACTIONS(6030),
    [sym_identifier] = ACTIONS(6032),
    [anon_sym_namespace] = ACTIONS(6032),
    [anon_sym_module] = ACTIONS(6032),
    [anon_sym_open] = ACTIONS(6032),
    [anon_sym_LBRACK_LT] = ACTIONS(6030),
    [anon_sym_return] = ACTIONS(6032),
    [anon_sym_type] = ACTIONS(6032),
    [anon_sym_do] = ACTIONS(6032),
    [anon_sym_and] = ACTIONS(6032),
    [anon_sym_let] = ACTIONS(6032),
    [anon_sym_let_BANG] = ACTIONS(6030),
    [aux_sym_access_modifier_token1] = ACTIONS(6030),
    [anon_sym_LPAREN] = ACTIONS(6032),
    [anon_sym_null] = ACTIONS(6032),
    [anon_sym_AMP] = ACTIONS(6032),
    [anon_sym_LBRACK] = ACTIONS(6032),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6030),
    [anon_sym_LBRACE] = ACTIONS(6032),
    [anon_sym_LT_AT] = ACTIONS(6032),
    [anon_sym_LT_AT_AT] = ACTIONS(6030),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6030),
    [anon_sym_new] = ACTIONS(6032),
    [anon_sym_return_BANG] = ACTIONS(6030),
    [anon_sym_yield] = ACTIONS(6032),
    [anon_sym_yield_BANG] = ACTIONS(6030),
    [anon_sym_lazy] = ACTIONS(6032),
    [anon_sym_assert] = ACTIONS(6032),
    [anon_sym_upcast] = ACTIONS(6032),
    [anon_sym_downcast] = ACTIONS(6032),
    [anon_sym_for] = ACTIONS(6032),
    [anon_sym_while] = ACTIONS(6032),
    [anon_sym_if] = ACTIONS(6032),
    [anon_sym_fun] = ACTIONS(6032),
    [anon_sym_try] = ACTIONS(6032),
    [anon_sym_match] = ACTIONS(6032),
    [anon_sym_match_BANG] = ACTIONS(6030),
    [anon_sym_function] = ACTIONS(6032),
    [anon_sym_use] = ACTIONS(6032),
    [anon_sym_use_BANG] = ACTIONS(6030),
    [anon_sym_do_BANG] = ACTIONS(6030),
    [anon_sym_begin] = ACTIONS(6032),
    [anon_sym_default] = ACTIONS(6032),
    [anon_sym_static] = ACTIONS(6032),
    [anon_sym_member] = ACTIONS(6032),
    [anon_sym_interface] = ACTIONS(6032),
    [anon_sym_exception] = ACTIONS(6032),
    [anon_sym_abstract] = ACTIONS(6032),
    [anon_sym_val] = ACTIONS(6032),
    [anon_sym_override] = ACTIONS(6032),
    [aux_sym_char_token1] = ACTIONS(6030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6032),
    [anon_sym_DQUOTE] = ACTIONS(6032),
    [anon_sym_AT_DQUOTE] = ACTIONS(6030),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6030),
    [sym_bool] = ACTIONS(6032),
    [sym_unit] = ACTIONS(6030),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6032),
    [sym_op_identifier] = ACTIONS(6030),
    [anon_sym_PLUS] = ACTIONS(6032),
    [anon_sym_DASH] = ACTIONS(6032),
    [anon_sym_PLUS_DOT] = ACTIONS(6030),
    [anon_sym_DASH_DOT] = ACTIONS(6030),
    [anon_sym_PERCENT] = ACTIONS(6030),
    [anon_sym_AMP_AMP] = ACTIONS(6030),
    [anon_sym_TILDE] = ACTIONS(6030),
    [aux_sym_prefix_op_token1] = ACTIONS(6030),
    [sym_int] = ACTIONS(6032),
    [sym_xint] = ACTIONS(6030),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6030),
    [anon_sym_POUNDload] = ACTIONS(6030),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6030),
  },
  [3763] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8190),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2296),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3763),
    [sym_compiler_directive_decl] = STATE(3763),
    [sym_fsi_directive_decl] = STATE(3763),
    [sym_preproc_line] = STATE(3763),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3764] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8166),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2944),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3764),
    [sym_compiler_directive_decl] = STATE(3764),
    [sym_fsi_directive_decl] = STATE(3764),
    [sym_preproc_line] = STATE(3764),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3765] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8055),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1617),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3765),
    [sym_compiler_directive_decl] = STATE(3765),
    [sym_fsi_directive_decl] = STATE(3765),
    [sym_preproc_line] = STATE(3765),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3766] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8278),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2284),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3766),
    [sym_compiler_directive_decl] = STATE(3766),
    [sym_fsi_directive_decl] = STATE(3766),
    [sym_preproc_line] = STATE(3766),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3767] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8098),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1676),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3767),
    [sym_compiler_directive_decl] = STATE(3767),
    [sym_fsi_directive_decl] = STATE(3767),
    [sym_preproc_line] = STATE(3767),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3768] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8098),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1889),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3768),
    [sym_compiler_directive_decl] = STATE(3768),
    [sym_fsi_directive_decl] = STATE(3768),
    [sym_preproc_line] = STATE(3768),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3769] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8190),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2359),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3769),
    [sym_compiler_directive_decl] = STATE(3769),
    [sym_fsi_directive_decl] = STATE(3769),
    [sym_preproc_line] = STATE(3769),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3770] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8098),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1888),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3770),
    [sym_compiler_directive_decl] = STATE(3770),
    [sym_fsi_directive_decl] = STATE(3770),
    [sym_preproc_line] = STATE(3770),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3771] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8190),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2334),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3771),
    [sym_compiler_directive_decl] = STATE(3771),
    [sym_fsi_directive_decl] = STATE(3771),
    [sym_preproc_line] = STATE(3771),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3772] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8204),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1666),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3772),
    [sym_compiler_directive_decl] = STATE(3772),
    [sym_fsi_directive_decl] = STATE(3772),
    [sym_preproc_line] = STATE(3772),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3773] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8166),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2763),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3773),
    [sym_compiler_directive_decl] = STATE(3773),
    [sym_fsi_directive_decl] = STATE(3773),
    [sym_preproc_line] = STATE(3773),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3774] = {
    [sym_block_comment] = STATE(3774),
    [sym_compiler_directive_decl] = STATE(3774),
    [sym_fsi_directive_decl] = STATE(3774),
    [sym_preproc_line] = STATE(3774),
    [ts_builtin_sym_end] = ACTIONS(6282),
    [sym_identifier] = ACTIONS(6284),
    [anon_sym_namespace] = ACTIONS(6284),
    [anon_sym_module] = ACTIONS(6284),
    [anon_sym_open] = ACTIONS(6284),
    [anon_sym_LBRACK_LT] = ACTIONS(6282),
    [anon_sym_return] = ACTIONS(6284),
    [anon_sym_type] = ACTIONS(6284),
    [anon_sym_do] = ACTIONS(6284),
    [anon_sym_and] = ACTIONS(6284),
    [anon_sym_let] = ACTIONS(6284),
    [anon_sym_let_BANG] = ACTIONS(6282),
    [aux_sym_access_modifier_token1] = ACTIONS(6282),
    [anon_sym_LPAREN] = ACTIONS(6284),
    [anon_sym_null] = ACTIONS(6284),
    [anon_sym_AMP] = ACTIONS(6284),
    [anon_sym_LBRACK] = ACTIONS(6284),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6282),
    [anon_sym_LBRACE] = ACTIONS(6284),
    [anon_sym_LT_AT] = ACTIONS(6284),
    [anon_sym_LT_AT_AT] = ACTIONS(6282),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6282),
    [anon_sym_new] = ACTIONS(6284),
    [anon_sym_return_BANG] = ACTIONS(6282),
    [anon_sym_yield] = ACTIONS(6284),
    [anon_sym_yield_BANG] = ACTIONS(6282),
    [anon_sym_lazy] = ACTIONS(6284),
    [anon_sym_assert] = ACTIONS(6284),
    [anon_sym_upcast] = ACTIONS(6284),
    [anon_sym_downcast] = ACTIONS(6284),
    [anon_sym_for] = ACTIONS(6284),
    [anon_sym_while] = ACTIONS(6284),
    [anon_sym_if] = ACTIONS(6284),
    [anon_sym_fun] = ACTIONS(6284),
    [anon_sym_try] = ACTIONS(6284),
    [anon_sym_match] = ACTIONS(6284),
    [anon_sym_match_BANG] = ACTIONS(6282),
    [anon_sym_function] = ACTIONS(6284),
    [anon_sym_use] = ACTIONS(6284),
    [anon_sym_use_BANG] = ACTIONS(6282),
    [anon_sym_do_BANG] = ACTIONS(6282),
    [anon_sym_begin] = ACTIONS(6284),
    [anon_sym_default] = ACTIONS(6284),
    [anon_sym_static] = ACTIONS(6284),
    [anon_sym_member] = ACTIONS(6284),
    [anon_sym_interface] = ACTIONS(6284),
    [anon_sym_exception] = ACTIONS(6284),
    [anon_sym_abstract] = ACTIONS(6284),
    [anon_sym_val] = ACTIONS(6284),
    [anon_sym_override] = ACTIONS(6284),
    [aux_sym_char_token1] = ACTIONS(6282),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6284),
    [anon_sym_DQUOTE] = ACTIONS(6284),
    [anon_sym_AT_DQUOTE] = ACTIONS(6282),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6282),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6282),
    [sym_bool] = ACTIONS(6284),
    [sym_unit] = ACTIONS(6282),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6284),
    [sym_op_identifier] = ACTIONS(6282),
    [anon_sym_PLUS] = ACTIONS(6284),
    [anon_sym_DASH] = ACTIONS(6284),
    [anon_sym_PLUS_DOT] = ACTIONS(6282),
    [anon_sym_DASH_DOT] = ACTIONS(6282),
    [anon_sym_PERCENT] = ACTIONS(6282),
    [anon_sym_AMP_AMP] = ACTIONS(6282),
    [anon_sym_TILDE] = ACTIONS(6282),
    [aux_sym_prefix_op_token1] = ACTIONS(6282),
    [sym_int] = ACTIONS(6284),
    [sym_xint] = ACTIONS(6282),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6282),
    [anon_sym_POUNDload] = ACTIONS(6282),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6282),
  },
  [3775] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8055),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1625),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3775),
    [sym_compiler_directive_decl] = STATE(3775),
    [sym_fsi_directive_decl] = STATE(3775),
    [sym_preproc_line] = STATE(3775),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3776] = {
    [sym_block_comment] = STATE(3776),
    [sym_compiler_directive_decl] = STATE(3776),
    [sym_fsi_directive_decl] = STATE(3776),
    [sym_preproc_line] = STATE(3776),
    [ts_builtin_sym_end] = ACTIONS(4973),
    [sym_identifier] = ACTIONS(4975),
    [anon_sym_namespace] = ACTIONS(4975),
    [anon_sym_module] = ACTIONS(4975),
    [anon_sym_open] = ACTIONS(4975),
    [anon_sym_LBRACK_LT] = ACTIONS(4973),
    [anon_sym_return] = ACTIONS(4975),
    [anon_sym_type] = ACTIONS(4975),
    [anon_sym_do] = ACTIONS(4975),
    [anon_sym_and] = ACTIONS(4975),
    [anon_sym_let] = ACTIONS(4975),
    [anon_sym_let_BANG] = ACTIONS(4973),
    [aux_sym_access_modifier_token1] = ACTIONS(4973),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [anon_sym_null] = ACTIONS(4975),
    [anon_sym_AMP] = ACTIONS(4975),
    [anon_sym_LBRACK] = ACTIONS(4975),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4973),
    [anon_sym_LBRACE] = ACTIONS(4975),
    [anon_sym_LT_AT] = ACTIONS(4975),
    [anon_sym_LT_AT_AT] = ACTIONS(4973),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4973),
    [anon_sym_new] = ACTIONS(4975),
    [anon_sym_return_BANG] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_yield_BANG] = ACTIONS(4973),
    [anon_sym_lazy] = ACTIONS(4975),
    [anon_sym_assert] = ACTIONS(4975),
    [anon_sym_upcast] = ACTIONS(4975),
    [anon_sym_downcast] = ACTIONS(4975),
    [anon_sym_for] = ACTIONS(4975),
    [anon_sym_while] = ACTIONS(4975),
    [anon_sym_if] = ACTIONS(4975),
    [anon_sym_fun] = ACTIONS(4975),
    [anon_sym_try] = ACTIONS(4975),
    [anon_sym_match] = ACTIONS(4975),
    [anon_sym_match_BANG] = ACTIONS(4973),
    [anon_sym_function] = ACTIONS(4975),
    [anon_sym_use] = ACTIONS(4975),
    [anon_sym_use_BANG] = ACTIONS(4973),
    [anon_sym_do_BANG] = ACTIONS(4973),
    [anon_sym_begin] = ACTIONS(4975),
    [anon_sym_default] = ACTIONS(4975),
    [anon_sym_static] = ACTIONS(4975),
    [anon_sym_member] = ACTIONS(4975),
    [anon_sym_interface] = ACTIONS(4975),
    [anon_sym_exception] = ACTIONS(4975),
    [anon_sym_abstract] = ACTIONS(4975),
    [anon_sym_val] = ACTIONS(4975),
    [anon_sym_override] = ACTIONS(4975),
    [aux_sym_char_token1] = ACTIONS(4973),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4975),
    [anon_sym_DQUOTE] = ACTIONS(4975),
    [anon_sym_AT_DQUOTE] = ACTIONS(4973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4973),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4973),
    [sym_bool] = ACTIONS(4975),
    [sym_unit] = ACTIONS(4973),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4975),
    [sym_op_identifier] = ACTIONS(4973),
    [anon_sym_PLUS] = ACTIONS(4975),
    [anon_sym_DASH] = ACTIONS(4975),
    [anon_sym_PLUS_DOT] = ACTIONS(4973),
    [anon_sym_DASH_DOT] = ACTIONS(4973),
    [anon_sym_PERCENT] = ACTIONS(4973),
    [anon_sym_AMP_AMP] = ACTIONS(4973),
    [anon_sym_TILDE] = ACTIONS(4973),
    [aux_sym_prefix_op_token1] = ACTIONS(4973),
    [sym_int] = ACTIONS(4975),
    [sym_xint] = ACTIONS(4973),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4973),
    [anon_sym_POUNDload] = ACTIONS(4973),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4973),
  },
  [3777] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(9035),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3777),
    [sym_compiler_directive_decl] = STATE(3777),
    [sym_fsi_directive_decl] = STATE(3777),
    [sym_preproc_line] = STATE(3777),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3778] = {
    [sym_block_comment] = STATE(3778),
    [sym_compiler_directive_decl] = STATE(3778),
    [sym_fsi_directive_decl] = STATE(3778),
    [sym_preproc_line] = STATE(3778),
    [ts_builtin_sym_end] = ACTIONS(6286),
    [sym_identifier] = ACTIONS(6288),
    [anon_sym_namespace] = ACTIONS(6288),
    [anon_sym_module] = ACTIONS(6288),
    [anon_sym_open] = ACTIONS(6288),
    [anon_sym_LBRACK_LT] = ACTIONS(6286),
    [anon_sym_return] = ACTIONS(6288),
    [anon_sym_type] = ACTIONS(6288),
    [anon_sym_do] = ACTIONS(6288),
    [anon_sym_and] = ACTIONS(6288),
    [anon_sym_let] = ACTIONS(6288),
    [anon_sym_let_BANG] = ACTIONS(6286),
    [aux_sym_access_modifier_token1] = ACTIONS(6286),
    [anon_sym_LPAREN] = ACTIONS(6288),
    [anon_sym_null] = ACTIONS(6288),
    [anon_sym_AMP] = ACTIONS(6288),
    [anon_sym_LBRACK] = ACTIONS(6288),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6286),
    [anon_sym_LBRACE] = ACTIONS(6288),
    [anon_sym_LT_AT] = ACTIONS(6288),
    [anon_sym_LT_AT_AT] = ACTIONS(6286),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6286),
    [anon_sym_new] = ACTIONS(6288),
    [anon_sym_return_BANG] = ACTIONS(6286),
    [anon_sym_yield] = ACTIONS(6288),
    [anon_sym_yield_BANG] = ACTIONS(6286),
    [anon_sym_lazy] = ACTIONS(6288),
    [anon_sym_assert] = ACTIONS(6288),
    [anon_sym_upcast] = ACTIONS(6288),
    [anon_sym_downcast] = ACTIONS(6288),
    [anon_sym_for] = ACTIONS(6288),
    [anon_sym_while] = ACTIONS(6288),
    [anon_sym_if] = ACTIONS(6288),
    [anon_sym_fun] = ACTIONS(6288),
    [anon_sym_try] = ACTIONS(6288),
    [anon_sym_match] = ACTIONS(6288),
    [anon_sym_match_BANG] = ACTIONS(6286),
    [anon_sym_function] = ACTIONS(6288),
    [anon_sym_use] = ACTIONS(6288),
    [anon_sym_use_BANG] = ACTIONS(6286),
    [anon_sym_do_BANG] = ACTIONS(6286),
    [anon_sym_begin] = ACTIONS(6288),
    [anon_sym_default] = ACTIONS(6288),
    [anon_sym_static] = ACTIONS(6288),
    [anon_sym_member] = ACTIONS(6288),
    [anon_sym_interface] = ACTIONS(6288),
    [anon_sym_exception] = ACTIONS(6288),
    [anon_sym_abstract] = ACTIONS(6288),
    [anon_sym_val] = ACTIONS(6288),
    [anon_sym_override] = ACTIONS(6288),
    [aux_sym_char_token1] = ACTIONS(6286),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6288),
    [anon_sym_DQUOTE] = ACTIONS(6288),
    [anon_sym_AT_DQUOTE] = ACTIONS(6286),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6286),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6286),
    [sym_bool] = ACTIONS(6288),
    [sym_unit] = ACTIONS(6286),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6288),
    [sym_op_identifier] = ACTIONS(6286),
    [anon_sym_PLUS] = ACTIONS(6288),
    [anon_sym_DASH] = ACTIONS(6288),
    [anon_sym_PLUS_DOT] = ACTIONS(6286),
    [anon_sym_DASH_DOT] = ACTIONS(6286),
    [anon_sym_PERCENT] = ACTIONS(6286),
    [anon_sym_AMP_AMP] = ACTIONS(6286),
    [anon_sym_TILDE] = ACTIONS(6286),
    [aux_sym_prefix_op_token1] = ACTIONS(6286),
    [sym_int] = ACTIONS(6288),
    [sym_xint] = ACTIONS(6286),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6286),
    [anon_sym_POUNDload] = ACTIONS(6286),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6286),
  },
  [3779] = {
    [sym_block_comment] = STATE(3779),
    [sym_compiler_directive_decl] = STATE(3779),
    [sym_fsi_directive_decl] = STATE(3779),
    [sym_preproc_line] = STATE(3779),
    [ts_builtin_sym_end] = ACTIONS(4973),
    [sym_identifier] = ACTIONS(4975),
    [anon_sym_namespace] = ACTIONS(4975),
    [anon_sym_module] = ACTIONS(4975),
    [anon_sym_open] = ACTIONS(4975),
    [anon_sym_LBRACK_LT] = ACTIONS(4973),
    [anon_sym_return] = ACTIONS(4975),
    [anon_sym_type] = ACTIONS(4975),
    [anon_sym_do] = ACTIONS(4975),
    [anon_sym_and] = ACTIONS(4975),
    [anon_sym_let] = ACTIONS(4975),
    [anon_sym_let_BANG] = ACTIONS(4973),
    [aux_sym_access_modifier_token1] = ACTIONS(4973),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [anon_sym_null] = ACTIONS(4975),
    [anon_sym_AMP] = ACTIONS(4975),
    [anon_sym_LBRACK] = ACTIONS(4975),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4973),
    [anon_sym_LBRACE] = ACTIONS(4975),
    [anon_sym_LT_AT] = ACTIONS(4975),
    [anon_sym_LT_AT_AT] = ACTIONS(4973),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4973),
    [anon_sym_new] = ACTIONS(4975),
    [anon_sym_return_BANG] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_yield_BANG] = ACTIONS(4973),
    [anon_sym_lazy] = ACTIONS(4975),
    [anon_sym_assert] = ACTIONS(4975),
    [anon_sym_upcast] = ACTIONS(4975),
    [anon_sym_downcast] = ACTIONS(4975),
    [anon_sym_for] = ACTIONS(4975),
    [anon_sym_while] = ACTIONS(4975),
    [anon_sym_if] = ACTIONS(4975),
    [anon_sym_fun] = ACTIONS(4975),
    [anon_sym_try] = ACTIONS(4975),
    [anon_sym_match] = ACTIONS(4975),
    [anon_sym_match_BANG] = ACTIONS(4973),
    [anon_sym_function] = ACTIONS(4975),
    [anon_sym_use] = ACTIONS(4975),
    [anon_sym_use_BANG] = ACTIONS(4973),
    [anon_sym_do_BANG] = ACTIONS(4973),
    [anon_sym_begin] = ACTIONS(4975),
    [anon_sym_default] = ACTIONS(4975),
    [anon_sym_static] = ACTIONS(4975),
    [anon_sym_member] = ACTIONS(4975),
    [anon_sym_interface] = ACTIONS(4975),
    [anon_sym_exception] = ACTIONS(4975),
    [anon_sym_abstract] = ACTIONS(4975),
    [anon_sym_val] = ACTIONS(4975),
    [anon_sym_override] = ACTIONS(4975),
    [aux_sym_char_token1] = ACTIONS(4973),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4975),
    [anon_sym_DQUOTE] = ACTIONS(4975),
    [anon_sym_AT_DQUOTE] = ACTIONS(4973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4973),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4973),
    [sym_bool] = ACTIONS(4975),
    [sym_unit] = ACTIONS(4973),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4975),
    [sym_op_identifier] = ACTIONS(4973),
    [anon_sym_PLUS] = ACTIONS(4975),
    [anon_sym_DASH] = ACTIONS(4975),
    [anon_sym_PLUS_DOT] = ACTIONS(4973),
    [anon_sym_DASH_DOT] = ACTIONS(4973),
    [anon_sym_PERCENT] = ACTIONS(4973),
    [anon_sym_AMP_AMP] = ACTIONS(4973),
    [anon_sym_TILDE] = ACTIONS(4973),
    [aux_sym_prefix_op_token1] = ACTIONS(4973),
    [sym_int] = ACTIONS(4975),
    [sym_xint] = ACTIONS(4973),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4973),
    [anon_sym_POUNDload] = ACTIONS(4973),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4973),
  },
  [3780] = {
    [sym_block_comment] = STATE(3780),
    [sym_compiler_directive_decl] = STATE(3780),
    [sym_fsi_directive_decl] = STATE(3780),
    [sym_preproc_line] = STATE(3780),
    [ts_builtin_sym_end] = ACTIONS(6290),
    [sym_identifier] = ACTIONS(6292),
    [anon_sym_namespace] = ACTIONS(6292),
    [anon_sym_module] = ACTIONS(6292),
    [anon_sym_open] = ACTIONS(6292),
    [anon_sym_LBRACK_LT] = ACTIONS(6290),
    [anon_sym_return] = ACTIONS(6292),
    [anon_sym_type] = ACTIONS(6292),
    [anon_sym_do] = ACTIONS(6292),
    [anon_sym_and] = ACTIONS(6292),
    [anon_sym_let] = ACTIONS(6292),
    [anon_sym_let_BANG] = ACTIONS(6290),
    [aux_sym_access_modifier_token1] = ACTIONS(6290),
    [anon_sym_LPAREN] = ACTIONS(6292),
    [anon_sym_null] = ACTIONS(6292),
    [anon_sym_AMP] = ACTIONS(6292),
    [anon_sym_LBRACK] = ACTIONS(6292),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6290),
    [anon_sym_LBRACE] = ACTIONS(6292),
    [anon_sym_LT_AT] = ACTIONS(6292),
    [anon_sym_LT_AT_AT] = ACTIONS(6290),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6290),
    [anon_sym_new] = ACTIONS(6292),
    [anon_sym_return_BANG] = ACTIONS(6290),
    [anon_sym_yield] = ACTIONS(6292),
    [anon_sym_yield_BANG] = ACTIONS(6290),
    [anon_sym_lazy] = ACTIONS(6292),
    [anon_sym_assert] = ACTIONS(6292),
    [anon_sym_upcast] = ACTIONS(6292),
    [anon_sym_downcast] = ACTIONS(6292),
    [anon_sym_for] = ACTIONS(6292),
    [anon_sym_while] = ACTIONS(6292),
    [anon_sym_if] = ACTIONS(6292),
    [anon_sym_fun] = ACTIONS(6292),
    [anon_sym_try] = ACTIONS(6292),
    [anon_sym_match] = ACTIONS(6292),
    [anon_sym_match_BANG] = ACTIONS(6290),
    [anon_sym_function] = ACTIONS(6292),
    [anon_sym_use] = ACTIONS(6292),
    [anon_sym_use_BANG] = ACTIONS(6290),
    [anon_sym_do_BANG] = ACTIONS(6290),
    [anon_sym_begin] = ACTIONS(6292),
    [anon_sym_default] = ACTIONS(6292),
    [anon_sym_static] = ACTIONS(6292),
    [anon_sym_member] = ACTIONS(6292),
    [anon_sym_interface] = ACTIONS(6292),
    [anon_sym_exception] = ACTIONS(6292),
    [anon_sym_abstract] = ACTIONS(6292),
    [anon_sym_val] = ACTIONS(6292),
    [anon_sym_override] = ACTIONS(6292),
    [aux_sym_char_token1] = ACTIONS(6290),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6292),
    [anon_sym_DQUOTE] = ACTIONS(6292),
    [anon_sym_AT_DQUOTE] = ACTIONS(6290),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6290),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6290),
    [sym_bool] = ACTIONS(6292),
    [sym_unit] = ACTIONS(6290),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6292),
    [sym_op_identifier] = ACTIONS(6290),
    [anon_sym_PLUS] = ACTIONS(6292),
    [anon_sym_DASH] = ACTIONS(6292),
    [anon_sym_PLUS_DOT] = ACTIONS(6290),
    [anon_sym_DASH_DOT] = ACTIONS(6290),
    [anon_sym_PERCENT] = ACTIONS(6290),
    [anon_sym_AMP_AMP] = ACTIONS(6290),
    [anon_sym_TILDE] = ACTIONS(6290),
    [aux_sym_prefix_op_token1] = ACTIONS(6290),
    [sym_int] = ACTIONS(6292),
    [sym_xint] = ACTIONS(6290),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6290),
    [anon_sym_POUNDload] = ACTIONS(6290),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6290),
  },
  [3781] = {
    [sym_block_comment] = STATE(3781),
    [sym_compiler_directive_decl] = STATE(3781),
    [sym_fsi_directive_decl] = STATE(3781),
    [sym_preproc_line] = STATE(3781),
    [ts_builtin_sym_end] = ACTIONS(6294),
    [sym_identifier] = ACTIONS(6296),
    [anon_sym_namespace] = ACTIONS(6296),
    [anon_sym_module] = ACTIONS(6296),
    [anon_sym_open] = ACTIONS(6296),
    [anon_sym_LBRACK_LT] = ACTIONS(6294),
    [anon_sym_return] = ACTIONS(6296),
    [anon_sym_type] = ACTIONS(6296),
    [anon_sym_do] = ACTIONS(6296),
    [anon_sym_and] = ACTIONS(6296),
    [anon_sym_let] = ACTIONS(6296),
    [anon_sym_let_BANG] = ACTIONS(6294),
    [aux_sym_access_modifier_token1] = ACTIONS(6294),
    [anon_sym_LPAREN] = ACTIONS(6296),
    [anon_sym_null] = ACTIONS(6296),
    [anon_sym_AMP] = ACTIONS(6296),
    [anon_sym_LBRACK] = ACTIONS(6296),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6294),
    [anon_sym_LBRACE] = ACTIONS(6296),
    [anon_sym_LT_AT] = ACTIONS(6296),
    [anon_sym_LT_AT_AT] = ACTIONS(6294),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6294),
    [anon_sym_new] = ACTIONS(6296),
    [anon_sym_return_BANG] = ACTIONS(6294),
    [anon_sym_yield] = ACTIONS(6296),
    [anon_sym_yield_BANG] = ACTIONS(6294),
    [anon_sym_lazy] = ACTIONS(6296),
    [anon_sym_assert] = ACTIONS(6296),
    [anon_sym_upcast] = ACTIONS(6296),
    [anon_sym_downcast] = ACTIONS(6296),
    [anon_sym_for] = ACTIONS(6296),
    [anon_sym_while] = ACTIONS(6296),
    [anon_sym_if] = ACTIONS(6296),
    [anon_sym_fun] = ACTIONS(6296),
    [anon_sym_try] = ACTIONS(6296),
    [anon_sym_match] = ACTIONS(6296),
    [anon_sym_match_BANG] = ACTIONS(6294),
    [anon_sym_function] = ACTIONS(6296),
    [anon_sym_use] = ACTIONS(6296),
    [anon_sym_use_BANG] = ACTIONS(6294),
    [anon_sym_do_BANG] = ACTIONS(6294),
    [anon_sym_begin] = ACTIONS(6296),
    [anon_sym_default] = ACTIONS(6296),
    [anon_sym_static] = ACTIONS(6296),
    [anon_sym_member] = ACTIONS(6296),
    [anon_sym_interface] = ACTIONS(6296),
    [anon_sym_exception] = ACTIONS(6296),
    [anon_sym_abstract] = ACTIONS(6296),
    [anon_sym_val] = ACTIONS(6296),
    [anon_sym_override] = ACTIONS(6296),
    [aux_sym_char_token1] = ACTIONS(6294),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6296),
    [anon_sym_DQUOTE] = ACTIONS(6296),
    [anon_sym_AT_DQUOTE] = ACTIONS(6294),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6294),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6294),
    [sym_bool] = ACTIONS(6296),
    [sym_unit] = ACTIONS(6294),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6296),
    [sym_op_identifier] = ACTIONS(6294),
    [anon_sym_PLUS] = ACTIONS(6296),
    [anon_sym_DASH] = ACTIONS(6296),
    [anon_sym_PLUS_DOT] = ACTIONS(6294),
    [anon_sym_DASH_DOT] = ACTIONS(6294),
    [anon_sym_PERCENT] = ACTIONS(6294),
    [anon_sym_AMP_AMP] = ACTIONS(6294),
    [anon_sym_TILDE] = ACTIONS(6294),
    [aux_sym_prefix_op_token1] = ACTIONS(6294),
    [sym_int] = ACTIONS(6296),
    [sym_xint] = ACTIONS(6294),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6294),
    [anon_sym_POUNDload] = ACTIONS(6294),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6294),
  },
  [3782] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8055),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1580),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3782),
    [sym_compiler_directive_decl] = STATE(3782),
    [sym_fsi_directive_decl] = STATE(3782),
    [sym_preproc_line] = STATE(3782),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3783] = {
    [sym_attributes] = STATE(3905),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(8258),
    [sym__pattern] = STATE(8049),
    [sym_optional_pattern] = STATE(8258),
    [sym_type_check_pattern] = STATE(8258),
    [sym_attribute_pattern] = STATE(8258),
    [sym_paren_pattern] = STATE(8258),
    [sym_as_pattern] = STATE(8258),
    [sym_cons_pattern] = STATE(8258),
    [sym_disjunct_pattern] = STATE(8258),
    [sym_conjunct_pattern] = STATE(8258),
    [sym_typed_pattern] = STATE(8258),
    [sym_list_pattern] = STATE(8258),
    [sym_array_pattern] = STATE(8258),
    [sym_record_pattern] = STATE(8258),
    [sym_named_field] = STATE(9330),
    [sym_named_field_pattern] = STATE(8258),
    [sym_identifier_pattern] = STATE(8258),
    [sym_long_identifier_or_op] = STATE(2968),
    [sym_char] = STATE(8017),
    [sym_format_string] = STATE(8065),
    [sym__string_literal] = STATE(8065),
    [sym_string] = STATE(8017),
    [sym_verbatim_string] = STATE(8017),
    [sym_bytearray] = STATE(8017),
    [sym_verbatim_bytearray] = STATE(8017),
    [sym_format_triple_quoted_string] = STATE(8066),
    [sym_triple_quoted_string] = STATE(8017),
    [sym_const] = STATE(8258),
    [sym_long_identifier] = STATE(4907),
    [sym_active_pattern] = STATE(5059),
    [sym__identifier_or_op] = STATE(4927),
    [sym_sbyte] = STATE(8017),
    [sym_byte] = STATE(8017),
    [sym_int16] = STATE(8017),
    [sym_uint16] = STATE(8017),
    [sym_int32] = STATE(8017),
    [sym_uint32] = STATE(8017),
    [sym_nativeint] = STATE(8017),
    [sym_unativeint] = STATE(8017),
    [sym_int64] = STATE(8017),
    [sym_uint64] = STATE(8017),
    [sym_ieee32] = STATE(8017),
    [sym_ieee64] = STATE(8017),
    [sym_bignum] = STATE(8017),
    [sym_decimal] = STATE(8017),
    [sym_float] = STATE(7544),
    [sym_block_comment] = STATE(3783),
    [sym_compiler_directive_decl] = STATE(3783),
    [sym_fsi_directive_decl] = STATE(3783),
    [sym_preproc_line] = STATE(3783),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(6298),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5492),
    [anon_sym_null] = ACTIONS(5494),
    [anon_sym__] = ACTIONS(5496),
    [anon_sym_QMARK] = ACTIONS(5498),
    [anon_sym_COLON_QMARK] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5502),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5504),
    [anon_sym_LBRACE] = ACTIONS(5506),
    [aux_sym_char_token1] = ACTIONS(5508),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5510),
    [anon_sym_DQUOTE] = ACTIONS(5512),
    [anon_sym_AT_DQUOTE] = ACTIONS(5514),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5516),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5518),
    [sym_bool] = ACTIONS(5520),
    [sym_unit] = ACTIONS(5522),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5524),
    [sym_op_identifier] = ACTIONS(5526),
    [sym_int] = ACTIONS(5528),
    [sym_xint] = ACTIONS(5530),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3784] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8204),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1864),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3784),
    [sym_compiler_directive_decl] = STATE(3784),
    [sym_fsi_directive_decl] = STATE(3784),
    [sym_preproc_line] = STATE(3784),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3785] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8234),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(3029),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3785),
    [sym_compiler_directive_decl] = STATE(3785),
    [sym_fsi_directive_decl] = STATE(3785),
    [sym_preproc_line] = STATE(3785),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3786] = {
    [sym_block_comment] = STATE(3786),
    [sym_compiler_directive_decl] = STATE(3786),
    [sym_fsi_directive_decl] = STATE(3786),
    [sym_preproc_line] = STATE(3786),
    [ts_builtin_sym_end] = ACTIONS(6300),
    [sym_identifier] = ACTIONS(6302),
    [anon_sym_namespace] = ACTIONS(6302),
    [anon_sym_module] = ACTIONS(6302),
    [anon_sym_open] = ACTIONS(6302),
    [anon_sym_LBRACK_LT] = ACTIONS(6300),
    [anon_sym_return] = ACTIONS(6302),
    [anon_sym_type] = ACTIONS(6302),
    [anon_sym_do] = ACTIONS(6302),
    [anon_sym_and] = ACTIONS(6302),
    [anon_sym_let] = ACTIONS(6302),
    [anon_sym_let_BANG] = ACTIONS(6300),
    [aux_sym_access_modifier_token1] = ACTIONS(6300),
    [anon_sym_LPAREN] = ACTIONS(6302),
    [anon_sym_null] = ACTIONS(6302),
    [anon_sym_AMP] = ACTIONS(6302),
    [anon_sym_LBRACK] = ACTIONS(6302),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6300),
    [anon_sym_LBRACE] = ACTIONS(6302),
    [anon_sym_LT_AT] = ACTIONS(6302),
    [anon_sym_LT_AT_AT] = ACTIONS(6300),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6300),
    [anon_sym_new] = ACTIONS(6302),
    [anon_sym_return_BANG] = ACTIONS(6300),
    [anon_sym_yield] = ACTIONS(6302),
    [anon_sym_yield_BANG] = ACTIONS(6300),
    [anon_sym_lazy] = ACTIONS(6302),
    [anon_sym_assert] = ACTIONS(6302),
    [anon_sym_upcast] = ACTIONS(6302),
    [anon_sym_downcast] = ACTIONS(6302),
    [anon_sym_for] = ACTIONS(6302),
    [anon_sym_while] = ACTIONS(6302),
    [anon_sym_if] = ACTIONS(6302),
    [anon_sym_fun] = ACTIONS(6302),
    [anon_sym_try] = ACTIONS(6302),
    [anon_sym_match] = ACTIONS(6302),
    [anon_sym_match_BANG] = ACTIONS(6300),
    [anon_sym_function] = ACTIONS(6302),
    [anon_sym_use] = ACTIONS(6302),
    [anon_sym_use_BANG] = ACTIONS(6300),
    [anon_sym_do_BANG] = ACTIONS(6300),
    [anon_sym_begin] = ACTIONS(6302),
    [anon_sym_default] = ACTIONS(6302),
    [anon_sym_static] = ACTIONS(6302),
    [anon_sym_member] = ACTIONS(6302),
    [anon_sym_interface] = ACTIONS(6302),
    [anon_sym_exception] = ACTIONS(6302),
    [anon_sym_abstract] = ACTIONS(6302),
    [anon_sym_val] = ACTIONS(6302),
    [anon_sym_override] = ACTIONS(6302),
    [aux_sym_char_token1] = ACTIONS(6300),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6302),
    [anon_sym_DQUOTE] = ACTIONS(6302),
    [anon_sym_AT_DQUOTE] = ACTIONS(6300),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6300),
    [sym_bool] = ACTIONS(6302),
    [sym_unit] = ACTIONS(6300),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6302),
    [sym_op_identifier] = ACTIONS(6300),
    [anon_sym_PLUS] = ACTIONS(6302),
    [anon_sym_DASH] = ACTIONS(6302),
    [anon_sym_PLUS_DOT] = ACTIONS(6300),
    [anon_sym_DASH_DOT] = ACTIONS(6300),
    [anon_sym_PERCENT] = ACTIONS(6300),
    [anon_sym_AMP_AMP] = ACTIONS(6300),
    [anon_sym_TILDE] = ACTIONS(6300),
    [aux_sym_prefix_op_token1] = ACTIONS(6300),
    [sym_int] = ACTIONS(6302),
    [sym_xint] = ACTIONS(6300),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6300),
    [anon_sym_POUNDload] = ACTIONS(6300),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6300),
  },
  [3787] = {
    [sym_attributes] = STATE(3905),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(8258),
    [sym__pattern] = STATE(8270),
    [sym_optional_pattern] = STATE(8258),
    [sym_type_check_pattern] = STATE(8258),
    [sym_attribute_pattern] = STATE(8258),
    [sym_paren_pattern] = STATE(8258),
    [sym_as_pattern] = STATE(8258),
    [sym_cons_pattern] = STATE(8258),
    [sym_disjunct_pattern] = STATE(8258),
    [sym_conjunct_pattern] = STATE(8258),
    [sym_typed_pattern] = STATE(8258),
    [sym_list_pattern] = STATE(8258),
    [sym_array_pattern] = STATE(8258),
    [sym_record_pattern] = STATE(8258),
    [sym_named_field] = STATE(9111),
    [sym_named_field_pattern] = STATE(8258),
    [sym_identifier_pattern] = STATE(8258),
    [sym_long_identifier_or_op] = STATE(2968),
    [sym_char] = STATE(8017),
    [sym_format_string] = STATE(8065),
    [sym__string_literal] = STATE(8065),
    [sym_string] = STATE(8017),
    [sym_verbatim_string] = STATE(8017),
    [sym_bytearray] = STATE(8017),
    [sym_verbatim_bytearray] = STATE(8017),
    [sym_format_triple_quoted_string] = STATE(8066),
    [sym_triple_quoted_string] = STATE(8017),
    [sym_const] = STATE(8258),
    [sym_long_identifier] = STATE(4907),
    [sym_active_pattern] = STATE(5059),
    [sym__identifier_or_op] = STATE(4927),
    [sym_sbyte] = STATE(8017),
    [sym_byte] = STATE(8017),
    [sym_int16] = STATE(8017),
    [sym_uint16] = STATE(8017),
    [sym_int32] = STATE(8017),
    [sym_uint32] = STATE(8017),
    [sym_nativeint] = STATE(8017),
    [sym_unativeint] = STATE(8017),
    [sym_int64] = STATE(8017),
    [sym_uint64] = STATE(8017),
    [sym_ieee32] = STATE(8017),
    [sym_ieee64] = STATE(8017),
    [sym_bignum] = STATE(8017),
    [sym_decimal] = STATE(8017),
    [sym_float] = STATE(7544),
    [sym_block_comment] = STATE(3787),
    [sym_compiler_directive_decl] = STATE(3787),
    [sym_fsi_directive_decl] = STATE(3787),
    [sym_preproc_line] = STATE(3787),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(6298),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5492),
    [anon_sym_null] = ACTIONS(5494),
    [anon_sym__] = ACTIONS(5496),
    [anon_sym_QMARK] = ACTIONS(5498),
    [anon_sym_COLON_QMARK] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5502),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5504),
    [anon_sym_LBRACE] = ACTIONS(5506),
    [aux_sym_char_token1] = ACTIONS(5508),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5510),
    [anon_sym_DQUOTE] = ACTIONS(5512),
    [anon_sym_AT_DQUOTE] = ACTIONS(5514),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5516),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5518),
    [sym_bool] = ACTIONS(5520),
    [sym_unit] = ACTIONS(5522),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5524),
    [sym_op_identifier] = ACTIONS(5526),
    [sym_int] = ACTIONS(5528),
    [sym_xint] = ACTIONS(5530),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3788] = {
    [sym_block_comment] = STATE(3788),
    [sym_compiler_directive_decl] = STATE(3788),
    [sym_fsi_directive_decl] = STATE(3788),
    [sym_preproc_line] = STATE(3788),
    [ts_builtin_sym_end] = ACTIONS(6304),
    [sym_identifier] = ACTIONS(6306),
    [anon_sym_namespace] = ACTIONS(6306),
    [anon_sym_module] = ACTIONS(6306),
    [anon_sym_open] = ACTIONS(6306),
    [anon_sym_LBRACK_LT] = ACTIONS(6304),
    [anon_sym_return] = ACTIONS(6306),
    [anon_sym_type] = ACTIONS(6306),
    [anon_sym_do] = ACTIONS(6306),
    [anon_sym_and] = ACTIONS(6306),
    [anon_sym_let] = ACTIONS(6306),
    [anon_sym_let_BANG] = ACTIONS(6304),
    [aux_sym_access_modifier_token1] = ACTIONS(6304),
    [anon_sym_LPAREN] = ACTIONS(6306),
    [anon_sym_null] = ACTIONS(6306),
    [anon_sym_AMP] = ACTIONS(6306),
    [anon_sym_LBRACK] = ACTIONS(6306),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6304),
    [anon_sym_LBRACE] = ACTIONS(6306),
    [anon_sym_LT_AT] = ACTIONS(6306),
    [anon_sym_LT_AT_AT] = ACTIONS(6304),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6304),
    [anon_sym_new] = ACTIONS(6306),
    [anon_sym_return_BANG] = ACTIONS(6304),
    [anon_sym_yield] = ACTIONS(6306),
    [anon_sym_yield_BANG] = ACTIONS(6304),
    [anon_sym_lazy] = ACTIONS(6306),
    [anon_sym_assert] = ACTIONS(6306),
    [anon_sym_upcast] = ACTIONS(6306),
    [anon_sym_downcast] = ACTIONS(6306),
    [anon_sym_for] = ACTIONS(6306),
    [anon_sym_while] = ACTIONS(6306),
    [anon_sym_if] = ACTIONS(6306),
    [anon_sym_fun] = ACTIONS(6306),
    [anon_sym_try] = ACTIONS(6306),
    [anon_sym_match] = ACTIONS(6306),
    [anon_sym_match_BANG] = ACTIONS(6304),
    [anon_sym_function] = ACTIONS(6306),
    [anon_sym_use] = ACTIONS(6306),
    [anon_sym_use_BANG] = ACTIONS(6304),
    [anon_sym_do_BANG] = ACTIONS(6304),
    [anon_sym_begin] = ACTIONS(6306),
    [anon_sym_default] = ACTIONS(6306),
    [anon_sym_static] = ACTIONS(6306),
    [anon_sym_member] = ACTIONS(6306),
    [anon_sym_interface] = ACTIONS(6306),
    [anon_sym_exception] = ACTIONS(6306),
    [anon_sym_abstract] = ACTIONS(6306),
    [anon_sym_val] = ACTIONS(6306),
    [anon_sym_override] = ACTIONS(6306),
    [aux_sym_char_token1] = ACTIONS(6304),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6306),
    [anon_sym_DQUOTE] = ACTIONS(6306),
    [anon_sym_AT_DQUOTE] = ACTIONS(6304),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6304),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6304),
    [sym_bool] = ACTIONS(6306),
    [sym_unit] = ACTIONS(6304),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6306),
    [sym_op_identifier] = ACTIONS(6304),
    [anon_sym_PLUS] = ACTIONS(6306),
    [anon_sym_DASH] = ACTIONS(6306),
    [anon_sym_PLUS_DOT] = ACTIONS(6304),
    [anon_sym_DASH_DOT] = ACTIONS(6304),
    [anon_sym_PERCENT] = ACTIONS(6304),
    [anon_sym_AMP_AMP] = ACTIONS(6304),
    [anon_sym_TILDE] = ACTIONS(6304),
    [aux_sym_prefix_op_token1] = ACTIONS(6304),
    [sym_int] = ACTIONS(6306),
    [sym_xint] = ACTIONS(6304),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6304),
    [anon_sym_POUNDload] = ACTIONS(6304),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6304),
  },
  [3789] = {
    [sym_block_comment] = STATE(3789),
    [sym_compiler_directive_decl] = STATE(3789),
    [sym_fsi_directive_decl] = STATE(3789),
    [sym_preproc_line] = STATE(3789),
    [ts_builtin_sym_end] = ACTIONS(6132),
    [sym_identifier] = ACTIONS(6134),
    [anon_sym_namespace] = ACTIONS(6134),
    [anon_sym_module] = ACTIONS(6134),
    [anon_sym_open] = ACTIONS(6134),
    [anon_sym_LBRACK_LT] = ACTIONS(6132),
    [anon_sym_return] = ACTIONS(6134),
    [anon_sym_type] = ACTIONS(6134),
    [anon_sym_do] = ACTIONS(6134),
    [anon_sym_and] = ACTIONS(6134),
    [anon_sym_let] = ACTIONS(6134),
    [anon_sym_let_BANG] = ACTIONS(6132),
    [aux_sym_access_modifier_token1] = ACTIONS(6132),
    [anon_sym_LPAREN] = ACTIONS(6134),
    [anon_sym_null] = ACTIONS(6134),
    [anon_sym_AMP] = ACTIONS(6134),
    [anon_sym_LBRACK] = ACTIONS(6134),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6132),
    [anon_sym_LBRACE] = ACTIONS(6134),
    [anon_sym_LT_AT] = ACTIONS(6134),
    [anon_sym_LT_AT_AT] = ACTIONS(6132),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6132),
    [anon_sym_new] = ACTIONS(6134),
    [anon_sym_return_BANG] = ACTIONS(6132),
    [anon_sym_yield] = ACTIONS(6134),
    [anon_sym_yield_BANG] = ACTIONS(6132),
    [anon_sym_lazy] = ACTIONS(6134),
    [anon_sym_assert] = ACTIONS(6134),
    [anon_sym_upcast] = ACTIONS(6134),
    [anon_sym_downcast] = ACTIONS(6134),
    [anon_sym_for] = ACTIONS(6134),
    [anon_sym_while] = ACTIONS(6134),
    [anon_sym_if] = ACTIONS(6134),
    [anon_sym_fun] = ACTIONS(6134),
    [anon_sym_try] = ACTIONS(6134),
    [anon_sym_match] = ACTIONS(6134),
    [anon_sym_match_BANG] = ACTIONS(6132),
    [anon_sym_function] = ACTIONS(6134),
    [anon_sym_use] = ACTIONS(6134),
    [anon_sym_use_BANG] = ACTIONS(6132),
    [anon_sym_do_BANG] = ACTIONS(6132),
    [anon_sym_begin] = ACTIONS(6134),
    [anon_sym_default] = ACTIONS(6134),
    [anon_sym_static] = ACTIONS(6134),
    [anon_sym_member] = ACTIONS(6134),
    [anon_sym_interface] = ACTIONS(6134),
    [anon_sym_exception] = ACTIONS(6134),
    [anon_sym_abstract] = ACTIONS(6134),
    [anon_sym_val] = ACTIONS(6134),
    [anon_sym_override] = ACTIONS(6134),
    [aux_sym_char_token1] = ACTIONS(6132),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6134),
    [anon_sym_DQUOTE] = ACTIONS(6134),
    [anon_sym_AT_DQUOTE] = ACTIONS(6132),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6132),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6132),
    [sym_bool] = ACTIONS(6134),
    [sym_unit] = ACTIONS(6132),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6134),
    [sym_op_identifier] = ACTIONS(6132),
    [anon_sym_PLUS] = ACTIONS(6134),
    [anon_sym_DASH] = ACTIONS(6134),
    [anon_sym_PLUS_DOT] = ACTIONS(6132),
    [anon_sym_DASH_DOT] = ACTIONS(6132),
    [anon_sym_PERCENT] = ACTIONS(6132),
    [anon_sym_AMP_AMP] = ACTIONS(6132),
    [anon_sym_TILDE] = ACTIONS(6132),
    [aux_sym_prefix_op_token1] = ACTIONS(6132),
    [sym_int] = ACTIONS(6134),
    [sym_xint] = ACTIONS(6132),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6132),
    [anon_sym_POUNDload] = ACTIONS(6132),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6132),
  },
  [3790] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7980),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1712),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3790),
    [sym_compiler_directive_decl] = STATE(3790),
    [sym_fsi_directive_decl] = STATE(3790),
    [sym_preproc_line] = STATE(3790),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3791] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8278),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2330),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3791),
    [sym_compiler_directive_decl] = STATE(3791),
    [sym_fsi_directive_decl] = STATE(3791),
    [sym_preproc_line] = STATE(3791),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3792] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8091),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2877),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3792),
    [sym_compiler_directive_decl] = STATE(3792),
    [sym_fsi_directive_decl] = STATE(3792),
    [sym_preproc_line] = STATE(3792),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3793] = {
    [sym_block_comment] = STATE(3793),
    [sym_compiler_directive_decl] = STATE(3793),
    [sym_fsi_directive_decl] = STATE(3793),
    [sym_preproc_line] = STATE(3793),
    [ts_builtin_sym_end] = ACTIONS(6308),
    [sym_identifier] = ACTIONS(6310),
    [anon_sym_namespace] = ACTIONS(6310),
    [anon_sym_module] = ACTIONS(6310),
    [anon_sym_open] = ACTIONS(6310),
    [anon_sym_LBRACK_LT] = ACTIONS(6308),
    [anon_sym_return] = ACTIONS(6310),
    [anon_sym_type] = ACTIONS(6310),
    [anon_sym_do] = ACTIONS(6310),
    [anon_sym_and] = ACTIONS(6310),
    [anon_sym_let] = ACTIONS(6310),
    [anon_sym_let_BANG] = ACTIONS(6308),
    [aux_sym_access_modifier_token1] = ACTIONS(6308),
    [anon_sym_LPAREN] = ACTIONS(6310),
    [anon_sym_null] = ACTIONS(6310),
    [anon_sym_AMP] = ACTIONS(6310),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6308),
    [anon_sym_LBRACE] = ACTIONS(6310),
    [anon_sym_LT_AT] = ACTIONS(6310),
    [anon_sym_LT_AT_AT] = ACTIONS(6308),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6308),
    [anon_sym_new] = ACTIONS(6310),
    [anon_sym_return_BANG] = ACTIONS(6308),
    [anon_sym_yield] = ACTIONS(6310),
    [anon_sym_yield_BANG] = ACTIONS(6308),
    [anon_sym_lazy] = ACTIONS(6310),
    [anon_sym_assert] = ACTIONS(6310),
    [anon_sym_upcast] = ACTIONS(6310),
    [anon_sym_downcast] = ACTIONS(6310),
    [anon_sym_for] = ACTIONS(6310),
    [anon_sym_while] = ACTIONS(6310),
    [anon_sym_if] = ACTIONS(6310),
    [anon_sym_fun] = ACTIONS(6310),
    [anon_sym_try] = ACTIONS(6310),
    [anon_sym_match] = ACTIONS(6310),
    [anon_sym_match_BANG] = ACTIONS(6308),
    [anon_sym_function] = ACTIONS(6310),
    [anon_sym_use] = ACTIONS(6310),
    [anon_sym_use_BANG] = ACTIONS(6308),
    [anon_sym_do_BANG] = ACTIONS(6308),
    [anon_sym_begin] = ACTIONS(6310),
    [anon_sym_default] = ACTIONS(6310),
    [anon_sym_static] = ACTIONS(6310),
    [anon_sym_member] = ACTIONS(6310),
    [anon_sym_interface] = ACTIONS(6310),
    [anon_sym_exception] = ACTIONS(6310),
    [anon_sym_abstract] = ACTIONS(6310),
    [anon_sym_val] = ACTIONS(6310),
    [anon_sym_override] = ACTIONS(6310),
    [aux_sym_char_token1] = ACTIONS(6308),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6310),
    [anon_sym_DQUOTE] = ACTIONS(6310),
    [anon_sym_AT_DQUOTE] = ACTIONS(6308),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6308),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6308),
    [sym_bool] = ACTIONS(6310),
    [sym_unit] = ACTIONS(6308),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6310),
    [sym_op_identifier] = ACTIONS(6308),
    [anon_sym_PLUS] = ACTIONS(6310),
    [anon_sym_DASH] = ACTIONS(6310),
    [anon_sym_PLUS_DOT] = ACTIONS(6308),
    [anon_sym_DASH_DOT] = ACTIONS(6308),
    [anon_sym_PERCENT] = ACTIONS(6308),
    [anon_sym_AMP_AMP] = ACTIONS(6308),
    [anon_sym_TILDE] = ACTIONS(6308),
    [aux_sym_prefix_op_token1] = ACTIONS(6308),
    [sym_int] = ACTIONS(6310),
    [sym_xint] = ACTIONS(6308),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6308),
    [anon_sym_POUNDload] = ACTIONS(6308),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6308),
  },
  [3794] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7980),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1629),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3794),
    [sym_compiler_directive_decl] = STATE(3794),
    [sym_fsi_directive_decl] = STATE(3794),
    [sym_preproc_line] = STATE(3794),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3795] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8204),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1840),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3795),
    [sym_compiler_directive_decl] = STATE(3795),
    [sym_fsi_directive_decl] = STATE(3795),
    [sym_preproc_line] = STATE(3795),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3796] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7980),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1714),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3796),
    [sym_compiler_directive_decl] = STATE(3796),
    [sym_fsi_directive_decl] = STATE(3796),
    [sym_preproc_line] = STATE(3796),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3797] = {
    [sym_attributes] = STATE(3905),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(8258),
    [sym__pattern] = STATE(8114),
    [sym_optional_pattern] = STATE(8258),
    [sym_type_check_pattern] = STATE(8258),
    [sym_attribute_pattern] = STATE(8258),
    [sym_paren_pattern] = STATE(8258),
    [sym_as_pattern] = STATE(8258),
    [sym_cons_pattern] = STATE(8258),
    [sym_disjunct_pattern] = STATE(8258),
    [sym_conjunct_pattern] = STATE(8258),
    [sym_typed_pattern] = STATE(8258),
    [sym_list_pattern] = STATE(8258),
    [sym_array_pattern] = STATE(8258),
    [sym_record_pattern] = STATE(8258),
    [sym_named_field] = STATE(9799),
    [sym_named_field_pattern] = STATE(8258),
    [sym_identifier_pattern] = STATE(8258),
    [sym_long_identifier_or_op] = STATE(2968),
    [sym_char] = STATE(8017),
    [sym_format_string] = STATE(8065),
    [sym__string_literal] = STATE(8065),
    [sym_string] = STATE(8017),
    [sym_verbatim_string] = STATE(8017),
    [sym_bytearray] = STATE(8017),
    [sym_verbatim_bytearray] = STATE(8017),
    [sym_format_triple_quoted_string] = STATE(8066),
    [sym_triple_quoted_string] = STATE(8017),
    [sym_const] = STATE(8258),
    [sym_long_identifier] = STATE(4907),
    [sym_active_pattern] = STATE(5059),
    [sym__identifier_or_op] = STATE(4927),
    [sym_sbyte] = STATE(8017),
    [sym_byte] = STATE(8017),
    [sym_int16] = STATE(8017),
    [sym_uint16] = STATE(8017),
    [sym_int32] = STATE(8017),
    [sym_uint32] = STATE(8017),
    [sym_nativeint] = STATE(8017),
    [sym_unativeint] = STATE(8017),
    [sym_int64] = STATE(8017),
    [sym_uint64] = STATE(8017),
    [sym_ieee32] = STATE(8017),
    [sym_ieee64] = STATE(8017),
    [sym_bignum] = STATE(8017),
    [sym_decimal] = STATE(8017),
    [sym_float] = STATE(7544),
    [sym_block_comment] = STATE(3797),
    [sym_compiler_directive_decl] = STATE(3797),
    [sym_fsi_directive_decl] = STATE(3797),
    [sym_preproc_line] = STATE(3797),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(6298),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5492),
    [anon_sym_null] = ACTIONS(5494),
    [anon_sym__] = ACTIONS(5496),
    [anon_sym_QMARK] = ACTIONS(5498),
    [anon_sym_COLON_QMARK] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5502),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5504),
    [anon_sym_LBRACE] = ACTIONS(5506),
    [aux_sym_char_token1] = ACTIONS(5508),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5510),
    [anon_sym_DQUOTE] = ACTIONS(5512),
    [anon_sym_AT_DQUOTE] = ACTIONS(5514),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5516),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5518),
    [sym_bool] = ACTIONS(5520),
    [sym_unit] = ACTIONS(5522),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5524),
    [sym_op_identifier] = ACTIONS(5526),
    [sym_int] = ACTIONS(5528),
    [sym_xint] = ACTIONS(5530),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3798] = {
    [sym_block_comment] = STATE(3798),
    [sym_compiler_directive_decl] = STATE(3798),
    [sym_fsi_directive_decl] = STATE(3798),
    [sym_preproc_line] = STATE(3798),
    [ts_builtin_sym_end] = ACTIONS(6022),
    [sym_identifier] = ACTIONS(6024),
    [anon_sym_namespace] = ACTIONS(6024),
    [anon_sym_module] = ACTIONS(6024),
    [anon_sym_open] = ACTIONS(6024),
    [anon_sym_LBRACK_LT] = ACTIONS(6022),
    [anon_sym_return] = ACTIONS(6024),
    [anon_sym_type] = ACTIONS(6024),
    [anon_sym_do] = ACTIONS(6024),
    [anon_sym_and] = ACTIONS(6024),
    [anon_sym_let] = ACTIONS(6024),
    [anon_sym_let_BANG] = ACTIONS(6022),
    [aux_sym_access_modifier_token1] = ACTIONS(6022),
    [anon_sym_LPAREN] = ACTIONS(6024),
    [anon_sym_null] = ACTIONS(6024),
    [anon_sym_AMP] = ACTIONS(6024),
    [anon_sym_LBRACK] = ACTIONS(6024),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6022),
    [anon_sym_LBRACE] = ACTIONS(6024),
    [anon_sym_LT_AT] = ACTIONS(6024),
    [anon_sym_LT_AT_AT] = ACTIONS(6022),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6022),
    [anon_sym_new] = ACTIONS(6024),
    [anon_sym_return_BANG] = ACTIONS(6022),
    [anon_sym_yield] = ACTIONS(6024),
    [anon_sym_yield_BANG] = ACTIONS(6022),
    [anon_sym_lazy] = ACTIONS(6024),
    [anon_sym_assert] = ACTIONS(6024),
    [anon_sym_upcast] = ACTIONS(6024),
    [anon_sym_downcast] = ACTIONS(6024),
    [anon_sym_for] = ACTIONS(6024),
    [anon_sym_while] = ACTIONS(6024),
    [anon_sym_if] = ACTIONS(6024),
    [anon_sym_fun] = ACTIONS(6024),
    [anon_sym_try] = ACTIONS(6024),
    [anon_sym_match] = ACTIONS(6024),
    [anon_sym_match_BANG] = ACTIONS(6022),
    [anon_sym_function] = ACTIONS(6024),
    [anon_sym_use] = ACTIONS(6024),
    [anon_sym_use_BANG] = ACTIONS(6022),
    [anon_sym_do_BANG] = ACTIONS(6022),
    [anon_sym_begin] = ACTIONS(6024),
    [anon_sym_default] = ACTIONS(6024),
    [anon_sym_static] = ACTIONS(6024),
    [anon_sym_member] = ACTIONS(6024),
    [anon_sym_interface] = ACTIONS(6024),
    [anon_sym_exception] = ACTIONS(6024),
    [anon_sym_abstract] = ACTIONS(6024),
    [anon_sym_val] = ACTIONS(6024),
    [anon_sym_override] = ACTIONS(6024),
    [aux_sym_char_token1] = ACTIONS(6022),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6024),
    [anon_sym_DQUOTE] = ACTIONS(6024),
    [anon_sym_AT_DQUOTE] = ACTIONS(6022),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6022),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6022),
    [sym_bool] = ACTIONS(6024),
    [sym_unit] = ACTIONS(6022),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6024),
    [sym_op_identifier] = ACTIONS(6022),
    [anon_sym_PLUS] = ACTIONS(6024),
    [anon_sym_DASH] = ACTIONS(6024),
    [anon_sym_PLUS_DOT] = ACTIONS(6022),
    [anon_sym_DASH_DOT] = ACTIONS(6022),
    [anon_sym_PERCENT] = ACTIONS(6022),
    [anon_sym_AMP_AMP] = ACTIONS(6022),
    [anon_sym_TILDE] = ACTIONS(6022),
    [aux_sym_prefix_op_token1] = ACTIONS(6022),
    [sym_int] = ACTIONS(6024),
    [sym_xint] = ACTIONS(6022),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6022),
    [anon_sym_POUNDload] = ACTIONS(6022),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6022),
  },
  [3799] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8005),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2720),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3799),
    [sym_compiler_directive_decl] = STATE(3799),
    [sym_fsi_directive_decl] = STATE(3799),
    [sym_preproc_line] = STATE(3799),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3800] = {
    [sym_block_comment] = STATE(3800),
    [sym_compiler_directive_decl] = STATE(3800),
    [sym_fsi_directive_decl] = STATE(3800),
    [sym_preproc_line] = STATE(3800),
    [ts_builtin_sym_end] = ACTIONS(6312),
    [sym_identifier] = ACTIONS(6314),
    [anon_sym_namespace] = ACTIONS(6314),
    [anon_sym_module] = ACTIONS(6314),
    [anon_sym_open] = ACTIONS(6314),
    [anon_sym_LBRACK_LT] = ACTIONS(6312),
    [anon_sym_return] = ACTIONS(6314),
    [anon_sym_type] = ACTIONS(6314),
    [anon_sym_do] = ACTIONS(6314),
    [anon_sym_and] = ACTIONS(6314),
    [anon_sym_let] = ACTIONS(6314),
    [anon_sym_let_BANG] = ACTIONS(6312),
    [aux_sym_access_modifier_token1] = ACTIONS(6312),
    [anon_sym_LPAREN] = ACTIONS(6314),
    [anon_sym_null] = ACTIONS(6314),
    [anon_sym_AMP] = ACTIONS(6314),
    [anon_sym_LBRACK] = ACTIONS(6314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6312),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_LT_AT] = ACTIONS(6314),
    [anon_sym_LT_AT_AT] = ACTIONS(6312),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6312),
    [anon_sym_new] = ACTIONS(6314),
    [anon_sym_return_BANG] = ACTIONS(6312),
    [anon_sym_yield] = ACTIONS(6314),
    [anon_sym_yield_BANG] = ACTIONS(6312),
    [anon_sym_lazy] = ACTIONS(6314),
    [anon_sym_assert] = ACTIONS(6314),
    [anon_sym_upcast] = ACTIONS(6314),
    [anon_sym_downcast] = ACTIONS(6314),
    [anon_sym_for] = ACTIONS(6314),
    [anon_sym_while] = ACTIONS(6314),
    [anon_sym_if] = ACTIONS(6314),
    [anon_sym_fun] = ACTIONS(6314),
    [anon_sym_try] = ACTIONS(6314),
    [anon_sym_match] = ACTIONS(6314),
    [anon_sym_match_BANG] = ACTIONS(6312),
    [anon_sym_function] = ACTIONS(6314),
    [anon_sym_use] = ACTIONS(6314),
    [anon_sym_use_BANG] = ACTIONS(6312),
    [anon_sym_do_BANG] = ACTIONS(6312),
    [anon_sym_begin] = ACTIONS(6314),
    [anon_sym_default] = ACTIONS(6314),
    [anon_sym_static] = ACTIONS(6314),
    [anon_sym_member] = ACTIONS(6314),
    [anon_sym_interface] = ACTIONS(6314),
    [anon_sym_exception] = ACTIONS(6314),
    [anon_sym_abstract] = ACTIONS(6314),
    [anon_sym_val] = ACTIONS(6314),
    [anon_sym_override] = ACTIONS(6314),
    [aux_sym_char_token1] = ACTIONS(6312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6314),
    [anon_sym_DQUOTE] = ACTIONS(6314),
    [anon_sym_AT_DQUOTE] = ACTIONS(6312),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6312),
    [sym_bool] = ACTIONS(6314),
    [sym_unit] = ACTIONS(6312),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6314),
    [sym_op_identifier] = ACTIONS(6312),
    [anon_sym_PLUS] = ACTIONS(6314),
    [anon_sym_DASH] = ACTIONS(6314),
    [anon_sym_PLUS_DOT] = ACTIONS(6312),
    [anon_sym_DASH_DOT] = ACTIONS(6312),
    [anon_sym_PERCENT] = ACTIONS(6312),
    [anon_sym_AMP_AMP] = ACTIONS(6312),
    [anon_sym_TILDE] = ACTIONS(6312),
    [aux_sym_prefix_op_token1] = ACTIONS(6312),
    [sym_int] = ACTIONS(6314),
    [sym_xint] = ACTIONS(6312),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6312),
    [anon_sym_POUNDload] = ACTIONS(6312),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6312),
  },
  [3801] = {
    [sym_block_comment] = STATE(3801),
    [sym_compiler_directive_decl] = STATE(3801),
    [sym_fsi_directive_decl] = STATE(3801),
    [sym_preproc_line] = STATE(3801),
    [ts_builtin_sym_end] = ACTIONS(6008),
    [sym_identifier] = ACTIONS(6010),
    [anon_sym_namespace] = ACTIONS(6010),
    [anon_sym_module] = ACTIONS(6010),
    [anon_sym_open] = ACTIONS(6010),
    [anon_sym_LBRACK_LT] = ACTIONS(6008),
    [anon_sym_return] = ACTIONS(6010),
    [anon_sym_type] = ACTIONS(6010),
    [anon_sym_do] = ACTIONS(6010),
    [anon_sym_and] = ACTIONS(6010),
    [anon_sym_let] = ACTIONS(6010),
    [anon_sym_let_BANG] = ACTIONS(6008),
    [aux_sym_access_modifier_token1] = ACTIONS(6008),
    [anon_sym_LPAREN] = ACTIONS(6010),
    [anon_sym_null] = ACTIONS(6010),
    [anon_sym_AMP] = ACTIONS(6010),
    [anon_sym_LBRACK] = ACTIONS(6010),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6008),
    [anon_sym_LBRACE] = ACTIONS(6010),
    [anon_sym_LT_AT] = ACTIONS(6010),
    [anon_sym_LT_AT_AT] = ACTIONS(6008),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6008),
    [anon_sym_new] = ACTIONS(6010),
    [anon_sym_return_BANG] = ACTIONS(6008),
    [anon_sym_yield] = ACTIONS(6010),
    [anon_sym_yield_BANG] = ACTIONS(6008),
    [anon_sym_lazy] = ACTIONS(6010),
    [anon_sym_assert] = ACTIONS(6010),
    [anon_sym_upcast] = ACTIONS(6010),
    [anon_sym_downcast] = ACTIONS(6010),
    [anon_sym_for] = ACTIONS(6010),
    [anon_sym_while] = ACTIONS(6010),
    [anon_sym_if] = ACTIONS(6010),
    [anon_sym_fun] = ACTIONS(6010),
    [anon_sym_try] = ACTIONS(6010),
    [anon_sym_match] = ACTIONS(6010),
    [anon_sym_match_BANG] = ACTIONS(6008),
    [anon_sym_function] = ACTIONS(6010),
    [anon_sym_use] = ACTIONS(6010),
    [anon_sym_use_BANG] = ACTIONS(6008),
    [anon_sym_do_BANG] = ACTIONS(6008),
    [anon_sym_begin] = ACTIONS(6010),
    [anon_sym_default] = ACTIONS(6010),
    [anon_sym_static] = ACTIONS(6010),
    [anon_sym_member] = ACTIONS(6010),
    [anon_sym_interface] = ACTIONS(6010),
    [anon_sym_exception] = ACTIONS(6010),
    [anon_sym_abstract] = ACTIONS(6010),
    [anon_sym_val] = ACTIONS(6010),
    [anon_sym_override] = ACTIONS(6010),
    [aux_sym_char_token1] = ACTIONS(6008),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6010),
    [anon_sym_DQUOTE] = ACTIONS(6010),
    [anon_sym_AT_DQUOTE] = ACTIONS(6008),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6008),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6008),
    [sym_bool] = ACTIONS(6010),
    [sym_unit] = ACTIONS(6008),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6010),
    [sym_op_identifier] = ACTIONS(6008),
    [anon_sym_PLUS] = ACTIONS(6010),
    [anon_sym_DASH] = ACTIONS(6010),
    [anon_sym_PLUS_DOT] = ACTIONS(6008),
    [anon_sym_DASH_DOT] = ACTIONS(6008),
    [anon_sym_PERCENT] = ACTIONS(6008),
    [anon_sym_AMP_AMP] = ACTIONS(6008),
    [anon_sym_TILDE] = ACTIONS(6008),
    [aux_sym_prefix_op_token1] = ACTIONS(6008),
    [sym_int] = ACTIONS(6010),
    [sym_xint] = ACTIONS(6008),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6008),
    [anon_sym_POUNDload] = ACTIONS(6008),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6008),
  },
  [3802] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8234),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(3054),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3802),
    [sym_compiler_directive_decl] = STATE(3802),
    [sym_fsi_directive_decl] = STATE(3802),
    [sym_preproc_line] = STATE(3802),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3803] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8278),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2317),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3803),
    [sym_compiler_directive_decl] = STATE(3803),
    [sym_fsi_directive_decl] = STATE(3803),
    [sym_preproc_line] = STATE(3803),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3804] = {
    [sym_block_comment] = STATE(3804),
    [sym_compiler_directive_decl] = STATE(3804),
    [sym_fsi_directive_decl] = STATE(3804),
    [sym_preproc_line] = STATE(3804),
    [ts_builtin_sym_end] = ACTIONS(6316),
    [sym_identifier] = ACTIONS(6318),
    [anon_sym_namespace] = ACTIONS(6318),
    [anon_sym_module] = ACTIONS(6318),
    [anon_sym_open] = ACTIONS(6318),
    [anon_sym_LBRACK_LT] = ACTIONS(6316),
    [anon_sym_return] = ACTIONS(6318),
    [anon_sym_type] = ACTIONS(6318),
    [anon_sym_do] = ACTIONS(6318),
    [anon_sym_and] = ACTIONS(6318),
    [anon_sym_let] = ACTIONS(6318),
    [anon_sym_let_BANG] = ACTIONS(6316),
    [aux_sym_access_modifier_token1] = ACTIONS(6316),
    [anon_sym_LPAREN] = ACTIONS(6318),
    [anon_sym_null] = ACTIONS(6318),
    [anon_sym_AMP] = ACTIONS(6318),
    [anon_sym_LBRACK] = ACTIONS(6318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6316),
    [anon_sym_LBRACE] = ACTIONS(6318),
    [anon_sym_LT_AT] = ACTIONS(6318),
    [anon_sym_LT_AT_AT] = ACTIONS(6316),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6316),
    [anon_sym_new] = ACTIONS(6318),
    [anon_sym_return_BANG] = ACTIONS(6316),
    [anon_sym_yield] = ACTIONS(6318),
    [anon_sym_yield_BANG] = ACTIONS(6316),
    [anon_sym_lazy] = ACTIONS(6318),
    [anon_sym_assert] = ACTIONS(6318),
    [anon_sym_upcast] = ACTIONS(6318),
    [anon_sym_downcast] = ACTIONS(6318),
    [anon_sym_for] = ACTIONS(6318),
    [anon_sym_while] = ACTIONS(6318),
    [anon_sym_if] = ACTIONS(6318),
    [anon_sym_fun] = ACTIONS(6318),
    [anon_sym_try] = ACTIONS(6318),
    [anon_sym_match] = ACTIONS(6318),
    [anon_sym_match_BANG] = ACTIONS(6316),
    [anon_sym_function] = ACTIONS(6318),
    [anon_sym_use] = ACTIONS(6318),
    [anon_sym_use_BANG] = ACTIONS(6316),
    [anon_sym_do_BANG] = ACTIONS(6316),
    [anon_sym_begin] = ACTIONS(6318),
    [anon_sym_default] = ACTIONS(6318),
    [anon_sym_static] = ACTIONS(6318),
    [anon_sym_member] = ACTIONS(6318),
    [anon_sym_interface] = ACTIONS(6318),
    [anon_sym_exception] = ACTIONS(6318),
    [anon_sym_abstract] = ACTIONS(6318),
    [anon_sym_val] = ACTIONS(6318),
    [anon_sym_override] = ACTIONS(6318),
    [aux_sym_char_token1] = ACTIONS(6316),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6318),
    [anon_sym_DQUOTE] = ACTIONS(6318),
    [anon_sym_AT_DQUOTE] = ACTIONS(6316),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6316),
    [sym_bool] = ACTIONS(6318),
    [sym_unit] = ACTIONS(6316),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6318),
    [sym_op_identifier] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6318),
    [anon_sym_DASH] = ACTIONS(6318),
    [anon_sym_PLUS_DOT] = ACTIONS(6316),
    [anon_sym_DASH_DOT] = ACTIONS(6316),
    [anon_sym_PERCENT] = ACTIONS(6316),
    [anon_sym_AMP_AMP] = ACTIONS(6316),
    [anon_sym_TILDE] = ACTIONS(6316),
    [aux_sym_prefix_op_token1] = ACTIONS(6316),
    [sym_int] = ACTIONS(6318),
    [sym_xint] = ACTIONS(6316),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6316),
    [anon_sym_POUNDload] = ACTIONS(6316),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6316),
  },
  [3805] = {
    [sym_block_comment] = STATE(3805),
    [sym_compiler_directive_decl] = STATE(3805),
    [sym_fsi_directive_decl] = STATE(3805),
    [sym_preproc_line] = STATE(3805),
    [ts_builtin_sym_end] = ACTIONS(6320),
    [sym_identifier] = ACTIONS(6322),
    [anon_sym_namespace] = ACTIONS(6322),
    [anon_sym_module] = ACTIONS(6322),
    [anon_sym_open] = ACTIONS(6322),
    [anon_sym_LBRACK_LT] = ACTIONS(6320),
    [anon_sym_return] = ACTIONS(6322),
    [anon_sym_type] = ACTIONS(6322),
    [anon_sym_do] = ACTIONS(6322),
    [anon_sym_and] = ACTIONS(6322),
    [anon_sym_let] = ACTIONS(6322),
    [anon_sym_let_BANG] = ACTIONS(6320),
    [aux_sym_access_modifier_token1] = ACTIONS(6320),
    [anon_sym_LPAREN] = ACTIONS(6322),
    [anon_sym_null] = ACTIONS(6322),
    [anon_sym_AMP] = ACTIONS(6322),
    [anon_sym_LBRACK] = ACTIONS(6322),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6320),
    [anon_sym_LBRACE] = ACTIONS(6322),
    [anon_sym_LT_AT] = ACTIONS(6322),
    [anon_sym_LT_AT_AT] = ACTIONS(6320),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6320),
    [anon_sym_new] = ACTIONS(6322),
    [anon_sym_return_BANG] = ACTIONS(6320),
    [anon_sym_yield] = ACTIONS(6322),
    [anon_sym_yield_BANG] = ACTIONS(6320),
    [anon_sym_lazy] = ACTIONS(6322),
    [anon_sym_assert] = ACTIONS(6322),
    [anon_sym_upcast] = ACTIONS(6322),
    [anon_sym_downcast] = ACTIONS(6322),
    [anon_sym_for] = ACTIONS(6322),
    [anon_sym_while] = ACTIONS(6322),
    [anon_sym_if] = ACTIONS(6322),
    [anon_sym_fun] = ACTIONS(6322),
    [anon_sym_try] = ACTIONS(6322),
    [anon_sym_match] = ACTIONS(6322),
    [anon_sym_match_BANG] = ACTIONS(6320),
    [anon_sym_function] = ACTIONS(6322),
    [anon_sym_use] = ACTIONS(6322),
    [anon_sym_use_BANG] = ACTIONS(6320),
    [anon_sym_do_BANG] = ACTIONS(6320),
    [anon_sym_begin] = ACTIONS(6322),
    [anon_sym_default] = ACTIONS(6322),
    [anon_sym_static] = ACTIONS(6322),
    [anon_sym_member] = ACTIONS(6322),
    [anon_sym_interface] = ACTIONS(6322),
    [anon_sym_exception] = ACTIONS(6322),
    [anon_sym_abstract] = ACTIONS(6322),
    [anon_sym_val] = ACTIONS(6322),
    [anon_sym_override] = ACTIONS(6322),
    [aux_sym_char_token1] = ACTIONS(6320),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6322),
    [anon_sym_DQUOTE] = ACTIONS(6322),
    [anon_sym_AT_DQUOTE] = ACTIONS(6320),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6320),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6320),
    [sym_bool] = ACTIONS(6322),
    [sym_unit] = ACTIONS(6320),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6322),
    [sym_op_identifier] = ACTIONS(6320),
    [anon_sym_PLUS] = ACTIONS(6322),
    [anon_sym_DASH] = ACTIONS(6322),
    [anon_sym_PLUS_DOT] = ACTIONS(6320),
    [anon_sym_DASH_DOT] = ACTIONS(6320),
    [anon_sym_PERCENT] = ACTIONS(6320),
    [anon_sym_AMP_AMP] = ACTIONS(6320),
    [anon_sym_TILDE] = ACTIONS(6320),
    [aux_sym_prefix_op_token1] = ACTIONS(6320),
    [sym_int] = ACTIONS(6322),
    [sym_xint] = ACTIONS(6320),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6320),
    [anon_sym_POUNDload] = ACTIONS(6320),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6320),
  },
  [3806] = {
    [sym_attributes] = STATE(3905),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(8258),
    [sym__pattern] = STATE(8232),
    [sym_optional_pattern] = STATE(8258),
    [sym_type_check_pattern] = STATE(8258),
    [sym_attribute_pattern] = STATE(8258),
    [sym_paren_pattern] = STATE(8258),
    [sym_as_pattern] = STATE(8258),
    [sym_cons_pattern] = STATE(8258),
    [sym_disjunct_pattern] = STATE(8258),
    [sym_conjunct_pattern] = STATE(8258),
    [sym_typed_pattern] = STATE(8258),
    [sym_list_pattern] = STATE(8258),
    [sym_array_pattern] = STATE(8258),
    [sym_record_pattern] = STATE(8258),
    [sym_named_field] = STATE(9228),
    [sym_named_field_pattern] = STATE(8258),
    [sym_identifier_pattern] = STATE(8258),
    [sym_long_identifier_or_op] = STATE(2968),
    [sym_char] = STATE(8017),
    [sym_format_string] = STATE(8065),
    [sym__string_literal] = STATE(8065),
    [sym_string] = STATE(8017),
    [sym_verbatim_string] = STATE(8017),
    [sym_bytearray] = STATE(8017),
    [sym_verbatim_bytearray] = STATE(8017),
    [sym_format_triple_quoted_string] = STATE(8066),
    [sym_triple_quoted_string] = STATE(8017),
    [sym_const] = STATE(8258),
    [sym_long_identifier] = STATE(4907),
    [sym_active_pattern] = STATE(5059),
    [sym__identifier_or_op] = STATE(4927),
    [sym_sbyte] = STATE(8017),
    [sym_byte] = STATE(8017),
    [sym_int16] = STATE(8017),
    [sym_uint16] = STATE(8017),
    [sym_int32] = STATE(8017),
    [sym_uint32] = STATE(8017),
    [sym_nativeint] = STATE(8017),
    [sym_unativeint] = STATE(8017),
    [sym_int64] = STATE(8017),
    [sym_uint64] = STATE(8017),
    [sym_ieee32] = STATE(8017),
    [sym_ieee64] = STATE(8017),
    [sym_bignum] = STATE(8017),
    [sym_decimal] = STATE(8017),
    [sym_float] = STATE(7544),
    [sym_block_comment] = STATE(3806),
    [sym_compiler_directive_decl] = STATE(3806),
    [sym_fsi_directive_decl] = STATE(3806),
    [sym_preproc_line] = STATE(3806),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(6298),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5492),
    [anon_sym_null] = ACTIONS(5494),
    [anon_sym__] = ACTIONS(5496),
    [anon_sym_QMARK] = ACTIONS(5498),
    [anon_sym_COLON_QMARK] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5502),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5504),
    [anon_sym_LBRACE] = ACTIONS(5506),
    [aux_sym_char_token1] = ACTIONS(5508),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5510),
    [anon_sym_DQUOTE] = ACTIONS(5512),
    [anon_sym_AT_DQUOTE] = ACTIONS(5514),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5516),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5518),
    [sym_bool] = ACTIONS(5520),
    [sym_unit] = ACTIONS(5522),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5524),
    [sym_op_identifier] = ACTIONS(5526),
    [sym_int] = ACTIONS(5528),
    [sym_xint] = ACTIONS(5530),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3807] = {
    [sym_block_comment] = STATE(3807),
    [sym_compiler_directive_decl] = STATE(3807),
    [sym_fsi_directive_decl] = STATE(3807),
    [sym_preproc_line] = STATE(3807),
    [ts_builtin_sym_end] = ACTIONS(6324),
    [sym_identifier] = ACTIONS(6326),
    [anon_sym_namespace] = ACTIONS(6326),
    [anon_sym_module] = ACTIONS(6326),
    [anon_sym_open] = ACTIONS(6326),
    [anon_sym_LBRACK_LT] = ACTIONS(6324),
    [anon_sym_return] = ACTIONS(6326),
    [anon_sym_type] = ACTIONS(6326),
    [anon_sym_do] = ACTIONS(6326),
    [anon_sym_and] = ACTIONS(6326),
    [anon_sym_let] = ACTIONS(6326),
    [anon_sym_let_BANG] = ACTIONS(6324),
    [aux_sym_access_modifier_token1] = ACTIONS(6324),
    [anon_sym_LPAREN] = ACTIONS(6326),
    [anon_sym_null] = ACTIONS(6326),
    [anon_sym_AMP] = ACTIONS(6326),
    [anon_sym_LBRACK] = ACTIONS(6326),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6324),
    [anon_sym_LBRACE] = ACTIONS(6326),
    [anon_sym_LT_AT] = ACTIONS(6326),
    [anon_sym_LT_AT_AT] = ACTIONS(6324),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6324),
    [anon_sym_new] = ACTIONS(6326),
    [anon_sym_return_BANG] = ACTIONS(6324),
    [anon_sym_yield] = ACTIONS(6326),
    [anon_sym_yield_BANG] = ACTIONS(6324),
    [anon_sym_lazy] = ACTIONS(6326),
    [anon_sym_assert] = ACTIONS(6326),
    [anon_sym_upcast] = ACTIONS(6326),
    [anon_sym_downcast] = ACTIONS(6326),
    [anon_sym_for] = ACTIONS(6326),
    [anon_sym_while] = ACTIONS(6326),
    [anon_sym_if] = ACTIONS(6326),
    [anon_sym_fun] = ACTIONS(6326),
    [anon_sym_try] = ACTIONS(6326),
    [anon_sym_match] = ACTIONS(6326),
    [anon_sym_match_BANG] = ACTIONS(6324),
    [anon_sym_function] = ACTIONS(6326),
    [anon_sym_use] = ACTIONS(6326),
    [anon_sym_use_BANG] = ACTIONS(6324),
    [anon_sym_do_BANG] = ACTIONS(6324),
    [anon_sym_begin] = ACTIONS(6326),
    [anon_sym_default] = ACTIONS(6326),
    [anon_sym_static] = ACTIONS(6326),
    [anon_sym_member] = ACTIONS(6326),
    [anon_sym_interface] = ACTIONS(6326),
    [anon_sym_exception] = ACTIONS(6326),
    [anon_sym_abstract] = ACTIONS(6326),
    [anon_sym_val] = ACTIONS(6326),
    [anon_sym_override] = ACTIONS(6326),
    [aux_sym_char_token1] = ACTIONS(6324),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6326),
    [anon_sym_DQUOTE] = ACTIONS(6326),
    [anon_sym_AT_DQUOTE] = ACTIONS(6324),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6324),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6324),
    [sym_bool] = ACTIONS(6326),
    [sym_unit] = ACTIONS(6324),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6326),
    [sym_op_identifier] = ACTIONS(6324),
    [anon_sym_PLUS] = ACTIONS(6326),
    [anon_sym_DASH] = ACTIONS(6326),
    [anon_sym_PLUS_DOT] = ACTIONS(6324),
    [anon_sym_DASH_DOT] = ACTIONS(6324),
    [anon_sym_PERCENT] = ACTIONS(6324),
    [anon_sym_AMP_AMP] = ACTIONS(6324),
    [anon_sym_TILDE] = ACTIONS(6324),
    [aux_sym_prefix_op_token1] = ACTIONS(6324),
    [sym_int] = ACTIONS(6326),
    [sym_xint] = ACTIONS(6324),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6324),
    [anon_sym_POUNDload] = ACTIONS(6324),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6324),
  },
  [3808] = {
    [sym_block_comment] = STATE(3808),
    [sym_compiler_directive_decl] = STATE(3808),
    [sym_fsi_directive_decl] = STATE(3808),
    [sym_preproc_line] = STATE(3808),
    [ts_builtin_sym_end] = ACTIONS(6328),
    [sym_identifier] = ACTIONS(6330),
    [anon_sym_namespace] = ACTIONS(6330),
    [anon_sym_module] = ACTIONS(6330),
    [anon_sym_open] = ACTIONS(6330),
    [anon_sym_LBRACK_LT] = ACTIONS(6328),
    [anon_sym_return] = ACTIONS(6330),
    [anon_sym_type] = ACTIONS(6330),
    [anon_sym_do] = ACTIONS(6330),
    [anon_sym_and] = ACTIONS(6330),
    [anon_sym_let] = ACTIONS(6330),
    [anon_sym_let_BANG] = ACTIONS(6328),
    [aux_sym_access_modifier_token1] = ACTIONS(6328),
    [anon_sym_LPAREN] = ACTIONS(6330),
    [anon_sym_null] = ACTIONS(6330),
    [anon_sym_AMP] = ACTIONS(6330),
    [anon_sym_LBRACK] = ACTIONS(6330),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6328),
    [anon_sym_LBRACE] = ACTIONS(6330),
    [anon_sym_LT_AT] = ACTIONS(6330),
    [anon_sym_LT_AT_AT] = ACTIONS(6328),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6328),
    [anon_sym_new] = ACTIONS(6330),
    [anon_sym_return_BANG] = ACTIONS(6328),
    [anon_sym_yield] = ACTIONS(6330),
    [anon_sym_yield_BANG] = ACTIONS(6328),
    [anon_sym_lazy] = ACTIONS(6330),
    [anon_sym_assert] = ACTIONS(6330),
    [anon_sym_upcast] = ACTIONS(6330),
    [anon_sym_downcast] = ACTIONS(6330),
    [anon_sym_for] = ACTIONS(6330),
    [anon_sym_while] = ACTIONS(6330),
    [anon_sym_if] = ACTIONS(6330),
    [anon_sym_fun] = ACTIONS(6330),
    [anon_sym_try] = ACTIONS(6330),
    [anon_sym_match] = ACTIONS(6330),
    [anon_sym_match_BANG] = ACTIONS(6328),
    [anon_sym_function] = ACTIONS(6330),
    [anon_sym_use] = ACTIONS(6330),
    [anon_sym_use_BANG] = ACTIONS(6328),
    [anon_sym_do_BANG] = ACTIONS(6328),
    [anon_sym_begin] = ACTIONS(6330),
    [anon_sym_default] = ACTIONS(6330),
    [anon_sym_static] = ACTIONS(6330),
    [anon_sym_member] = ACTIONS(6330),
    [anon_sym_interface] = ACTIONS(6330),
    [anon_sym_exception] = ACTIONS(6330),
    [anon_sym_abstract] = ACTIONS(6330),
    [anon_sym_val] = ACTIONS(6330),
    [anon_sym_override] = ACTIONS(6330),
    [aux_sym_char_token1] = ACTIONS(6328),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6330),
    [anon_sym_DQUOTE] = ACTIONS(6330),
    [anon_sym_AT_DQUOTE] = ACTIONS(6328),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6328),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6328),
    [sym_bool] = ACTIONS(6330),
    [sym_unit] = ACTIONS(6328),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6330),
    [sym_op_identifier] = ACTIONS(6328),
    [anon_sym_PLUS] = ACTIONS(6330),
    [anon_sym_DASH] = ACTIONS(6330),
    [anon_sym_PLUS_DOT] = ACTIONS(6328),
    [anon_sym_DASH_DOT] = ACTIONS(6328),
    [anon_sym_PERCENT] = ACTIONS(6328),
    [anon_sym_AMP_AMP] = ACTIONS(6328),
    [anon_sym_TILDE] = ACTIONS(6328),
    [aux_sym_prefix_op_token1] = ACTIONS(6328),
    [sym_int] = ACTIONS(6330),
    [sym_xint] = ACTIONS(6328),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6328),
    [anon_sym_POUNDload] = ACTIONS(6328),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6328),
  },
  [3809] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8364),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3809),
    [sym_compiler_directive_decl] = STATE(3809),
    [sym_fsi_directive_decl] = STATE(3809),
    [sym_preproc_line] = STATE(3809),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_RPAREN] = ACTIONS(6332),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3810] = {
    [sym_block_comment] = STATE(3810),
    [sym_compiler_directive_decl] = STATE(3810),
    [sym_fsi_directive_decl] = STATE(3810),
    [sym_preproc_line] = STATE(3810),
    [ts_builtin_sym_end] = ACTIONS(6334),
    [sym_identifier] = ACTIONS(6336),
    [anon_sym_namespace] = ACTIONS(6336),
    [anon_sym_module] = ACTIONS(6336),
    [anon_sym_open] = ACTIONS(6336),
    [anon_sym_LBRACK_LT] = ACTIONS(6334),
    [anon_sym_return] = ACTIONS(6336),
    [anon_sym_type] = ACTIONS(6336),
    [anon_sym_do] = ACTIONS(6336),
    [anon_sym_and] = ACTIONS(6336),
    [anon_sym_let] = ACTIONS(6336),
    [anon_sym_let_BANG] = ACTIONS(6334),
    [aux_sym_access_modifier_token1] = ACTIONS(6334),
    [anon_sym_LPAREN] = ACTIONS(6336),
    [anon_sym_null] = ACTIONS(6336),
    [anon_sym_AMP] = ACTIONS(6336),
    [anon_sym_LBRACK] = ACTIONS(6336),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6334),
    [anon_sym_LBRACE] = ACTIONS(6336),
    [anon_sym_LT_AT] = ACTIONS(6336),
    [anon_sym_LT_AT_AT] = ACTIONS(6334),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6334),
    [anon_sym_new] = ACTIONS(6336),
    [anon_sym_return_BANG] = ACTIONS(6334),
    [anon_sym_yield] = ACTIONS(6336),
    [anon_sym_yield_BANG] = ACTIONS(6334),
    [anon_sym_lazy] = ACTIONS(6336),
    [anon_sym_assert] = ACTIONS(6336),
    [anon_sym_upcast] = ACTIONS(6336),
    [anon_sym_downcast] = ACTIONS(6336),
    [anon_sym_for] = ACTIONS(6336),
    [anon_sym_while] = ACTIONS(6336),
    [anon_sym_if] = ACTIONS(6336),
    [anon_sym_fun] = ACTIONS(6336),
    [anon_sym_try] = ACTIONS(6336),
    [anon_sym_match] = ACTIONS(6336),
    [anon_sym_match_BANG] = ACTIONS(6334),
    [anon_sym_function] = ACTIONS(6336),
    [anon_sym_use] = ACTIONS(6336),
    [anon_sym_use_BANG] = ACTIONS(6334),
    [anon_sym_do_BANG] = ACTIONS(6334),
    [anon_sym_begin] = ACTIONS(6336),
    [anon_sym_default] = ACTIONS(6336),
    [anon_sym_static] = ACTIONS(6336),
    [anon_sym_member] = ACTIONS(6336),
    [anon_sym_interface] = ACTIONS(6336),
    [anon_sym_exception] = ACTIONS(6336),
    [anon_sym_abstract] = ACTIONS(6336),
    [anon_sym_val] = ACTIONS(6336),
    [anon_sym_override] = ACTIONS(6336),
    [aux_sym_char_token1] = ACTIONS(6334),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6336),
    [anon_sym_DQUOTE] = ACTIONS(6336),
    [anon_sym_AT_DQUOTE] = ACTIONS(6334),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6334),
    [sym_bool] = ACTIONS(6336),
    [sym_unit] = ACTIONS(6334),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6336),
    [sym_op_identifier] = ACTIONS(6334),
    [anon_sym_PLUS] = ACTIONS(6336),
    [anon_sym_DASH] = ACTIONS(6336),
    [anon_sym_PLUS_DOT] = ACTIONS(6334),
    [anon_sym_DASH_DOT] = ACTIONS(6334),
    [anon_sym_PERCENT] = ACTIONS(6334),
    [anon_sym_AMP_AMP] = ACTIONS(6334),
    [anon_sym_TILDE] = ACTIONS(6334),
    [aux_sym_prefix_op_token1] = ACTIONS(6334),
    [sym_int] = ACTIONS(6336),
    [sym_xint] = ACTIONS(6334),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6334),
    [anon_sym_POUNDload] = ACTIONS(6334),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6334),
  },
  [3811] = {
    [sym_block_comment] = STATE(3811),
    [sym_compiler_directive_decl] = STATE(3811),
    [sym_fsi_directive_decl] = STATE(3811),
    [sym_preproc_line] = STATE(3811),
    [ts_builtin_sym_end] = ACTIONS(6338),
    [sym_identifier] = ACTIONS(6340),
    [anon_sym_namespace] = ACTIONS(6340),
    [anon_sym_module] = ACTIONS(6340),
    [anon_sym_open] = ACTIONS(6340),
    [anon_sym_LBRACK_LT] = ACTIONS(6338),
    [anon_sym_return] = ACTIONS(6340),
    [anon_sym_type] = ACTIONS(6340),
    [anon_sym_do] = ACTIONS(6340),
    [anon_sym_and] = ACTIONS(6340),
    [anon_sym_let] = ACTIONS(6340),
    [anon_sym_let_BANG] = ACTIONS(6338),
    [aux_sym_access_modifier_token1] = ACTIONS(6338),
    [anon_sym_LPAREN] = ACTIONS(6340),
    [anon_sym_null] = ACTIONS(6340),
    [anon_sym_AMP] = ACTIONS(6340),
    [anon_sym_LBRACK] = ACTIONS(6340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6338),
    [anon_sym_LBRACE] = ACTIONS(6340),
    [anon_sym_LT_AT] = ACTIONS(6340),
    [anon_sym_LT_AT_AT] = ACTIONS(6338),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6338),
    [anon_sym_new] = ACTIONS(6340),
    [anon_sym_return_BANG] = ACTIONS(6338),
    [anon_sym_yield] = ACTIONS(6340),
    [anon_sym_yield_BANG] = ACTIONS(6338),
    [anon_sym_lazy] = ACTIONS(6340),
    [anon_sym_assert] = ACTIONS(6340),
    [anon_sym_upcast] = ACTIONS(6340),
    [anon_sym_downcast] = ACTIONS(6340),
    [anon_sym_for] = ACTIONS(6340),
    [anon_sym_while] = ACTIONS(6340),
    [anon_sym_if] = ACTIONS(6340),
    [anon_sym_fun] = ACTIONS(6340),
    [anon_sym_try] = ACTIONS(6340),
    [anon_sym_match] = ACTIONS(6340),
    [anon_sym_match_BANG] = ACTIONS(6338),
    [anon_sym_function] = ACTIONS(6340),
    [anon_sym_use] = ACTIONS(6340),
    [anon_sym_use_BANG] = ACTIONS(6338),
    [anon_sym_do_BANG] = ACTIONS(6338),
    [anon_sym_begin] = ACTIONS(6340),
    [anon_sym_default] = ACTIONS(6340),
    [anon_sym_static] = ACTIONS(6340),
    [anon_sym_member] = ACTIONS(6340),
    [anon_sym_interface] = ACTIONS(6340),
    [anon_sym_exception] = ACTIONS(6340),
    [anon_sym_abstract] = ACTIONS(6340),
    [anon_sym_val] = ACTIONS(6340),
    [anon_sym_override] = ACTIONS(6340),
    [aux_sym_char_token1] = ACTIONS(6338),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6340),
    [anon_sym_DQUOTE] = ACTIONS(6340),
    [anon_sym_AT_DQUOTE] = ACTIONS(6338),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6338),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6338),
    [sym_bool] = ACTIONS(6340),
    [sym_unit] = ACTIONS(6338),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6340),
    [sym_op_identifier] = ACTIONS(6338),
    [anon_sym_PLUS] = ACTIONS(6340),
    [anon_sym_DASH] = ACTIONS(6340),
    [anon_sym_PLUS_DOT] = ACTIONS(6338),
    [anon_sym_DASH_DOT] = ACTIONS(6338),
    [anon_sym_PERCENT] = ACTIONS(6338),
    [anon_sym_AMP_AMP] = ACTIONS(6338),
    [anon_sym_TILDE] = ACTIONS(6338),
    [aux_sym_prefix_op_token1] = ACTIONS(6338),
    [sym_int] = ACTIONS(6340),
    [sym_xint] = ACTIONS(6338),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6338),
    [anon_sym_POUNDload] = ACTIONS(6338),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6338),
  },
  [3812] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3812),
    [sym_compiler_directive_decl] = STATE(3812),
    [sym_fsi_directive_decl] = STATE(3812),
    [sym_preproc_line] = STATE(3812),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3756),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3813] = {
    [sym_block_comment] = STATE(3813),
    [sym_compiler_directive_decl] = STATE(3813),
    [sym_fsi_directive_decl] = STATE(3813),
    [sym_preproc_line] = STATE(3813),
    [ts_builtin_sym_end] = ACTIONS(2690),
    [sym_identifier] = ACTIONS(2692),
    [anon_sym_namespace] = ACTIONS(2692),
    [anon_sym_module] = ACTIONS(2692),
    [anon_sym_open] = ACTIONS(2692),
    [anon_sym_LBRACK_LT] = ACTIONS(2690),
    [anon_sym_return] = ACTIONS(2692),
    [anon_sym_type] = ACTIONS(2692),
    [anon_sym_do] = ACTIONS(2692),
    [anon_sym_and] = ACTIONS(2692),
    [anon_sym_let] = ACTIONS(2692),
    [anon_sym_let_BANG] = ACTIONS(2690),
    [aux_sym_access_modifier_token1] = ACTIONS(2690),
    [anon_sym_LPAREN] = ACTIONS(2692),
    [anon_sym_null] = ACTIONS(2692),
    [anon_sym_AMP] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2692),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2690),
    [anon_sym_LBRACE] = ACTIONS(2692),
    [anon_sym_LT_AT] = ACTIONS(2692),
    [anon_sym_LT_AT_AT] = ACTIONS(2690),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2690),
    [anon_sym_new] = ACTIONS(2692),
    [anon_sym_return_BANG] = ACTIONS(2690),
    [anon_sym_yield] = ACTIONS(2692),
    [anon_sym_yield_BANG] = ACTIONS(2690),
    [anon_sym_lazy] = ACTIONS(2692),
    [anon_sym_assert] = ACTIONS(2692),
    [anon_sym_upcast] = ACTIONS(2692),
    [anon_sym_downcast] = ACTIONS(2692),
    [anon_sym_for] = ACTIONS(2692),
    [anon_sym_while] = ACTIONS(2692),
    [anon_sym_if] = ACTIONS(2692),
    [anon_sym_fun] = ACTIONS(2692),
    [anon_sym_try] = ACTIONS(2692),
    [anon_sym_match] = ACTIONS(2692),
    [anon_sym_match_BANG] = ACTIONS(2690),
    [anon_sym_function] = ACTIONS(2692),
    [anon_sym_use] = ACTIONS(2692),
    [anon_sym_use_BANG] = ACTIONS(2690),
    [anon_sym_do_BANG] = ACTIONS(2690),
    [anon_sym_begin] = ACTIONS(2692),
    [anon_sym_default] = ACTIONS(2692),
    [anon_sym_static] = ACTIONS(2692),
    [anon_sym_member] = ACTIONS(2692),
    [anon_sym_interface] = ACTIONS(2692),
    [anon_sym_exception] = ACTIONS(2692),
    [anon_sym_abstract] = ACTIONS(2692),
    [anon_sym_val] = ACTIONS(2692),
    [anon_sym_override] = ACTIONS(2692),
    [aux_sym_char_token1] = ACTIONS(2690),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2692),
    [anon_sym_DQUOTE] = ACTIONS(2692),
    [anon_sym_AT_DQUOTE] = ACTIONS(2690),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2690),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2690),
    [sym_bool] = ACTIONS(2692),
    [sym_unit] = ACTIONS(2690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2692),
    [sym_op_identifier] = ACTIONS(2690),
    [anon_sym_PLUS] = ACTIONS(2692),
    [anon_sym_DASH] = ACTIONS(2692),
    [anon_sym_PLUS_DOT] = ACTIONS(2690),
    [anon_sym_DASH_DOT] = ACTIONS(2690),
    [anon_sym_PERCENT] = ACTIONS(2690),
    [anon_sym_AMP_AMP] = ACTIONS(2690),
    [anon_sym_TILDE] = ACTIONS(2690),
    [aux_sym_prefix_op_token1] = ACTIONS(2690),
    [sym_int] = ACTIONS(2692),
    [sym_xint] = ACTIONS(2690),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2690),
    [anon_sym_POUNDload] = ACTIONS(2690),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2690),
  },
  [3814] = {
    [sym_block_comment] = STATE(3814),
    [sym_compiler_directive_decl] = STATE(3814),
    [sym_fsi_directive_decl] = STATE(3814),
    [sym_preproc_line] = STATE(3814),
    [ts_builtin_sym_end] = ACTIONS(6342),
    [sym_identifier] = ACTIONS(6344),
    [anon_sym_namespace] = ACTIONS(6344),
    [anon_sym_module] = ACTIONS(6344),
    [anon_sym_open] = ACTIONS(6344),
    [anon_sym_LBRACK_LT] = ACTIONS(6342),
    [anon_sym_return] = ACTIONS(6344),
    [anon_sym_type] = ACTIONS(6344),
    [anon_sym_do] = ACTIONS(6344),
    [anon_sym_and] = ACTIONS(6344),
    [anon_sym_let] = ACTIONS(6344),
    [anon_sym_let_BANG] = ACTIONS(6342),
    [aux_sym_access_modifier_token1] = ACTIONS(6342),
    [anon_sym_LPAREN] = ACTIONS(6344),
    [anon_sym_null] = ACTIONS(6344),
    [anon_sym_AMP] = ACTIONS(6344),
    [anon_sym_LBRACK] = ACTIONS(6344),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6342),
    [anon_sym_LBRACE] = ACTIONS(6344),
    [anon_sym_LT_AT] = ACTIONS(6344),
    [anon_sym_LT_AT_AT] = ACTIONS(6342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6342),
    [anon_sym_new] = ACTIONS(6344),
    [anon_sym_return_BANG] = ACTIONS(6342),
    [anon_sym_yield] = ACTIONS(6344),
    [anon_sym_yield_BANG] = ACTIONS(6342),
    [anon_sym_lazy] = ACTIONS(6344),
    [anon_sym_assert] = ACTIONS(6344),
    [anon_sym_upcast] = ACTIONS(6344),
    [anon_sym_downcast] = ACTIONS(6344),
    [anon_sym_for] = ACTIONS(6344),
    [anon_sym_while] = ACTIONS(6344),
    [anon_sym_if] = ACTIONS(6344),
    [anon_sym_fun] = ACTIONS(6344),
    [anon_sym_try] = ACTIONS(6344),
    [anon_sym_match] = ACTIONS(6344),
    [anon_sym_match_BANG] = ACTIONS(6342),
    [anon_sym_function] = ACTIONS(6344),
    [anon_sym_use] = ACTIONS(6344),
    [anon_sym_use_BANG] = ACTIONS(6342),
    [anon_sym_do_BANG] = ACTIONS(6342),
    [anon_sym_begin] = ACTIONS(6344),
    [anon_sym_default] = ACTIONS(6344),
    [anon_sym_static] = ACTIONS(6344),
    [anon_sym_member] = ACTIONS(6344),
    [anon_sym_interface] = ACTIONS(6344),
    [anon_sym_exception] = ACTIONS(6344),
    [anon_sym_abstract] = ACTIONS(6344),
    [anon_sym_val] = ACTIONS(6344),
    [anon_sym_override] = ACTIONS(6344),
    [aux_sym_char_token1] = ACTIONS(6342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6344),
    [anon_sym_DQUOTE] = ACTIONS(6344),
    [anon_sym_AT_DQUOTE] = ACTIONS(6342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6342),
    [sym_bool] = ACTIONS(6344),
    [sym_unit] = ACTIONS(6342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6344),
    [sym_op_identifier] = ACTIONS(6342),
    [anon_sym_PLUS] = ACTIONS(6344),
    [anon_sym_DASH] = ACTIONS(6344),
    [anon_sym_PLUS_DOT] = ACTIONS(6342),
    [anon_sym_DASH_DOT] = ACTIONS(6342),
    [anon_sym_PERCENT] = ACTIONS(6342),
    [anon_sym_AMP_AMP] = ACTIONS(6342),
    [anon_sym_TILDE] = ACTIONS(6342),
    [aux_sym_prefix_op_token1] = ACTIONS(6342),
    [sym_int] = ACTIONS(6344),
    [sym_xint] = ACTIONS(6342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6342),
    [anon_sym_POUNDload] = ACTIONS(6342),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6342),
  },
  [3815] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8272),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1801),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3815),
    [sym_compiler_directive_decl] = STATE(3815),
    [sym_fsi_directive_decl] = STATE(3815),
    [sym_preproc_line] = STATE(3815),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3816] = {
    [sym_block_comment] = STATE(3816),
    [sym_compiler_directive_decl] = STATE(3816),
    [sym_fsi_directive_decl] = STATE(3816),
    [sym_preproc_line] = STATE(3816),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3191),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_GT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3191),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3191),
    [anon_sym_DASH_DOT] = ACTIONS(3191),
    [anon_sym_PERCENT] = ACTIONS(3191),
    [anon_sym_AMP_AMP] = ACTIONS(3191),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3191),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(6346),
    [anon_sym_uy] = ACTIONS(6348),
    [anon_sym_s] = ACTIONS(6350),
    [anon_sym_us] = ACTIONS(6352),
    [anon_sym_l] = ACTIONS(6354),
    [aux_sym_uint32_token1] = ACTIONS(6356),
    [anon_sym_n] = ACTIONS(6358),
    [anon_sym_un] = ACTIONS(6360),
    [anon_sym_L] = ACTIONS(6362),
    [aux_sym_uint64_token1] = ACTIONS(6364),
    [aux_sym_bignum_token1] = ACTIONS(6366),
    [aux_sym_decimal_token1] = ACTIONS(6368),
    [anon_sym_DOT2] = ACTIONS(6370),
    [aux_sym_float_token1] = ACTIONS(6372),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
  },
  [3817] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8005),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2918),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3817),
    [sym_compiler_directive_decl] = STATE(3817),
    [sym_fsi_directive_decl] = STATE(3817),
    [sym_preproc_line] = STATE(3817),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3818] = {
    [sym_block_comment] = STATE(3818),
    [sym_compiler_directive_decl] = STATE(3818),
    [sym_fsi_directive_decl] = STATE(3818),
    [sym_preproc_line] = STATE(3818),
    [ts_builtin_sym_end] = ACTIONS(6374),
    [sym_identifier] = ACTIONS(6376),
    [anon_sym_namespace] = ACTIONS(6376),
    [anon_sym_module] = ACTIONS(6376),
    [anon_sym_open] = ACTIONS(6376),
    [anon_sym_LBRACK_LT] = ACTIONS(6374),
    [anon_sym_return] = ACTIONS(6376),
    [anon_sym_type] = ACTIONS(6376),
    [anon_sym_do] = ACTIONS(6376),
    [anon_sym_and] = ACTIONS(6376),
    [anon_sym_let] = ACTIONS(6376),
    [anon_sym_let_BANG] = ACTIONS(6374),
    [aux_sym_access_modifier_token1] = ACTIONS(6374),
    [anon_sym_LPAREN] = ACTIONS(6376),
    [anon_sym_null] = ACTIONS(6376),
    [anon_sym_AMP] = ACTIONS(6376),
    [anon_sym_LBRACK] = ACTIONS(6376),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6374),
    [anon_sym_LBRACE] = ACTIONS(6376),
    [anon_sym_LT_AT] = ACTIONS(6376),
    [anon_sym_LT_AT_AT] = ACTIONS(6374),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6374),
    [anon_sym_new] = ACTIONS(6376),
    [anon_sym_return_BANG] = ACTIONS(6374),
    [anon_sym_yield] = ACTIONS(6376),
    [anon_sym_yield_BANG] = ACTIONS(6374),
    [anon_sym_lazy] = ACTIONS(6376),
    [anon_sym_assert] = ACTIONS(6376),
    [anon_sym_upcast] = ACTIONS(6376),
    [anon_sym_downcast] = ACTIONS(6376),
    [anon_sym_for] = ACTIONS(6376),
    [anon_sym_while] = ACTIONS(6376),
    [anon_sym_if] = ACTIONS(6376),
    [anon_sym_fun] = ACTIONS(6376),
    [anon_sym_try] = ACTIONS(6376),
    [anon_sym_match] = ACTIONS(6376),
    [anon_sym_match_BANG] = ACTIONS(6374),
    [anon_sym_function] = ACTIONS(6376),
    [anon_sym_use] = ACTIONS(6376),
    [anon_sym_use_BANG] = ACTIONS(6374),
    [anon_sym_do_BANG] = ACTIONS(6374),
    [anon_sym_begin] = ACTIONS(6376),
    [anon_sym_default] = ACTIONS(6376),
    [anon_sym_static] = ACTIONS(6376),
    [anon_sym_member] = ACTIONS(6376),
    [anon_sym_interface] = ACTIONS(6376),
    [anon_sym_exception] = ACTIONS(6376),
    [anon_sym_abstract] = ACTIONS(6376),
    [anon_sym_val] = ACTIONS(6376),
    [anon_sym_override] = ACTIONS(6376),
    [aux_sym_char_token1] = ACTIONS(6374),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6376),
    [anon_sym_DQUOTE] = ACTIONS(6376),
    [anon_sym_AT_DQUOTE] = ACTIONS(6374),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6374),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6374),
    [sym_bool] = ACTIONS(6376),
    [sym_unit] = ACTIONS(6374),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6376),
    [sym_op_identifier] = ACTIONS(6374),
    [anon_sym_PLUS] = ACTIONS(6376),
    [anon_sym_DASH] = ACTIONS(6376),
    [anon_sym_PLUS_DOT] = ACTIONS(6374),
    [anon_sym_DASH_DOT] = ACTIONS(6374),
    [anon_sym_PERCENT] = ACTIONS(6374),
    [anon_sym_AMP_AMP] = ACTIONS(6374),
    [anon_sym_TILDE] = ACTIONS(6374),
    [aux_sym_prefix_op_token1] = ACTIONS(6374),
    [sym_int] = ACTIONS(6376),
    [sym_xint] = ACTIONS(6374),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6374),
    [anon_sym_POUNDload] = ACTIONS(6374),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6374),
  },
  [3819] = {
    [sym_block_comment] = STATE(3819),
    [sym_compiler_directive_decl] = STATE(3819),
    [sym_fsi_directive_decl] = STATE(3819),
    [sym_preproc_line] = STATE(3819),
    [ts_builtin_sym_end] = ACTIONS(6378),
    [sym_identifier] = ACTIONS(6380),
    [anon_sym_namespace] = ACTIONS(6380),
    [anon_sym_module] = ACTIONS(6380),
    [anon_sym_open] = ACTIONS(6380),
    [anon_sym_LBRACK_LT] = ACTIONS(6378),
    [anon_sym_return] = ACTIONS(6380),
    [anon_sym_type] = ACTIONS(6380),
    [anon_sym_do] = ACTIONS(6380),
    [anon_sym_and] = ACTIONS(6380),
    [anon_sym_let] = ACTIONS(6380),
    [anon_sym_let_BANG] = ACTIONS(6378),
    [aux_sym_access_modifier_token1] = ACTIONS(6378),
    [anon_sym_LPAREN] = ACTIONS(6380),
    [anon_sym_null] = ACTIONS(6380),
    [anon_sym_AMP] = ACTIONS(6380),
    [anon_sym_LBRACK] = ACTIONS(6380),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6378),
    [anon_sym_LBRACE] = ACTIONS(6380),
    [anon_sym_LT_AT] = ACTIONS(6380),
    [anon_sym_LT_AT_AT] = ACTIONS(6378),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6378),
    [anon_sym_new] = ACTIONS(6380),
    [anon_sym_return_BANG] = ACTIONS(6378),
    [anon_sym_yield] = ACTIONS(6380),
    [anon_sym_yield_BANG] = ACTIONS(6378),
    [anon_sym_lazy] = ACTIONS(6380),
    [anon_sym_assert] = ACTIONS(6380),
    [anon_sym_upcast] = ACTIONS(6380),
    [anon_sym_downcast] = ACTIONS(6380),
    [anon_sym_for] = ACTIONS(6380),
    [anon_sym_while] = ACTIONS(6380),
    [anon_sym_if] = ACTIONS(6380),
    [anon_sym_fun] = ACTIONS(6380),
    [anon_sym_try] = ACTIONS(6380),
    [anon_sym_match] = ACTIONS(6380),
    [anon_sym_match_BANG] = ACTIONS(6378),
    [anon_sym_function] = ACTIONS(6380),
    [anon_sym_use] = ACTIONS(6380),
    [anon_sym_use_BANG] = ACTIONS(6378),
    [anon_sym_do_BANG] = ACTIONS(6378),
    [anon_sym_begin] = ACTIONS(6380),
    [anon_sym_default] = ACTIONS(6380),
    [anon_sym_static] = ACTIONS(6380),
    [anon_sym_member] = ACTIONS(6380),
    [anon_sym_interface] = ACTIONS(6380),
    [anon_sym_exception] = ACTIONS(6380),
    [anon_sym_abstract] = ACTIONS(6380),
    [anon_sym_val] = ACTIONS(6380),
    [anon_sym_override] = ACTIONS(6380),
    [aux_sym_char_token1] = ACTIONS(6378),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6380),
    [anon_sym_DQUOTE] = ACTIONS(6380),
    [anon_sym_AT_DQUOTE] = ACTIONS(6378),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6378),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6378),
    [sym_bool] = ACTIONS(6380),
    [sym_unit] = ACTIONS(6378),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6380),
    [sym_op_identifier] = ACTIONS(6378),
    [anon_sym_PLUS] = ACTIONS(6380),
    [anon_sym_DASH] = ACTIONS(6380),
    [anon_sym_PLUS_DOT] = ACTIONS(6378),
    [anon_sym_DASH_DOT] = ACTIONS(6378),
    [anon_sym_PERCENT] = ACTIONS(6378),
    [anon_sym_AMP_AMP] = ACTIONS(6378),
    [anon_sym_TILDE] = ACTIONS(6378),
    [aux_sym_prefix_op_token1] = ACTIONS(6378),
    [sym_int] = ACTIONS(6380),
    [sym_xint] = ACTIONS(6378),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6378),
    [anon_sym_POUNDload] = ACTIONS(6378),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6378),
  },
  [3820] = {
    [sym_block_comment] = STATE(3820),
    [sym_compiler_directive_decl] = STATE(3820),
    [sym_fsi_directive_decl] = STATE(3820),
    [sym_preproc_line] = STATE(3820),
    [ts_builtin_sym_end] = ACTIONS(6382),
    [sym_identifier] = ACTIONS(6384),
    [anon_sym_namespace] = ACTIONS(6384),
    [anon_sym_module] = ACTIONS(6384),
    [anon_sym_open] = ACTIONS(6384),
    [anon_sym_LBRACK_LT] = ACTIONS(6382),
    [anon_sym_return] = ACTIONS(6384),
    [anon_sym_type] = ACTIONS(6384),
    [anon_sym_do] = ACTIONS(6384),
    [anon_sym_and] = ACTIONS(6384),
    [anon_sym_let] = ACTIONS(6384),
    [anon_sym_let_BANG] = ACTIONS(6382),
    [aux_sym_access_modifier_token1] = ACTIONS(6382),
    [anon_sym_LPAREN] = ACTIONS(6384),
    [anon_sym_null] = ACTIONS(6384),
    [anon_sym_AMP] = ACTIONS(6384),
    [anon_sym_LBRACK] = ACTIONS(6384),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6382),
    [anon_sym_LBRACE] = ACTIONS(6384),
    [anon_sym_LT_AT] = ACTIONS(6384),
    [anon_sym_LT_AT_AT] = ACTIONS(6382),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6382),
    [anon_sym_new] = ACTIONS(6384),
    [anon_sym_return_BANG] = ACTIONS(6382),
    [anon_sym_yield] = ACTIONS(6384),
    [anon_sym_yield_BANG] = ACTIONS(6382),
    [anon_sym_lazy] = ACTIONS(6384),
    [anon_sym_assert] = ACTIONS(6384),
    [anon_sym_upcast] = ACTIONS(6384),
    [anon_sym_downcast] = ACTIONS(6384),
    [anon_sym_for] = ACTIONS(6384),
    [anon_sym_while] = ACTIONS(6384),
    [anon_sym_if] = ACTIONS(6384),
    [anon_sym_fun] = ACTIONS(6384),
    [anon_sym_try] = ACTIONS(6384),
    [anon_sym_match] = ACTIONS(6384),
    [anon_sym_match_BANG] = ACTIONS(6382),
    [anon_sym_function] = ACTIONS(6384),
    [anon_sym_use] = ACTIONS(6384),
    [anon_sym_use_BANG] = ACTIONS(6382),
    [anon_sym_do_BANG] = ACTIONS(6382),
    [anon_sym_begin] = ACTIONS(6384),
    [anon_sym_default] = ACTIONS(6384),
    [anon_sym_static] = ACTIONS(6384),
    [anon_sym_member] = ACTIONS(6384),
    [anon_sym_interface] = ACTIONS(6384),
    [anon_sym_exception] = ACTIONS(6384),
    [anon_sym_abstract] = ACTIONS(6384),
    [anon_sym_val] = ACTIONS(6384),
    [anon_sym_override] = ACTIONS(6384),
    [aux_sym_char_token1] = ACTIONS(6382),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6384),
    [anon_sym_DQUOTE] = ACTIONS(6384),
    [anon_sym_AT_DQUOTE] = ACTIONS(6382),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6382),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6382),
    [sym_bool] = ACTIONS(6384),
    [sym_unit] = ACTIONS(6382),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6384),
    [sym_op_identifier] = ACTIONS(6382),
    [anon_sym_PLUS] = ACTIONS(6384),
    [anon_sym_DASH] = ACTIONS(6384),
    [anon_sym_PLUS_DOT] = ACTIONS(6382),
    [anon_sym_DASH_DOT] = ACTIONS(6382),
    [anon_sym_PERCENT] = ACTIONS(6382),
    [anon_sym_AMP_AMP] = ACTIONS(6382),
    [anon_sym_TILDE] = ACTIONS(6382),
    [aux_sym_prefix_op_token1] = ACTIONS(6382),
    [sym_int] = ACTIONS(6384),
    [sym_xint] = ACTIONS(6382),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6382),
    [anon_sym_POUNDload] = ACTIONS(6382),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6382),
  },
  [3821] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8005),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2946),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3821),
    [sym_compiler_directive_decl] = STATE(3821),
    [sym_fsi_directive_decl] = STATE(3821),
    [sym_preproc_line] = STATE(3821),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3822] = {
    [sym_block_comment] = STATE(3822),
    [sym_compiler_directive_decl] = STATE(3822),
    [sym_fsi_directive_decl] = STATE(3822),
    [sym_preproc_line] = STATE(3822),
    [ts_builtin_sym_end] = ACTIONS(4973),
    [sym_identifier] = ACTIONS(4975),
    [anon_sym_namespace] = ACTIONS(4975),
    [anon_sym_module] = ACTIONS(4975),
    [anon_sym_open] = ACTIONS(4975),
    [anon_sym_LBRACK_LT] = ACTIONS(4973),
    [anon_sym_return] = ACTIONS(4975),
    [anon_sym_type] = ACTIONS(4975),
    [anon_sym_do] = ACTIONS(4975),
    [anon_sym_and] = ACTIONS(4975),
    [anon_sym_let] = ACTIONS(4975),
    [anon_sym_let_BANG] = ACTIONS(4973),
    [aux_sym_access_modifier_token1] = ACTIONS(4973),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [anon_sym_null] = ACTIONS(4975),
    [anon_sym_AMP] = ACTIONS(4975),
    [anon_sym_LBRACK] = ACTIONS(4975),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4973),
    [anon_sym_LBRACE] = ACTIONS(4975),
    [anon_sym_LT_AT] = ACTIONS(4975),
    [anon_sym_LT_AT_AT] = ACTIONS(4973),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4973),
    [anon_sym_new] = ACTIONS(4975),
    [anon_sym_return_BANG] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_yield_BANG] = ACTIONS(4973),
    [anon_sym_lazy] = ACTIONS(4975),
    [anon_sym_assert] = ACTIONS(4975),
    [anon_sym_upcast] = ACTIONS(4975),
    [anon_sym_downcast] = ACTIONS(4975),
    [anon_sym_for] = ACTIONS(4975),
    [anon_sym_while] = ACTIONS(4975),
    [anon_sym_if] = ACTIONS(4975),
    [anon_sym_fun] = ACTIONS(4975),
    [anon_sym_try] = ACTIONS(4975),
    [anon_sym_match] = ACTIONS(4975),
    [anon_sym_match_BANG] = ACTIONS(4973),
    [anon_sym_function] = ACTIONS(4975),
    [anon_sym_use] = ACTIONS(4975),
    [anon_sym_use_BANG] = ACTIONS(4973),
    [anon_sym_do_BANG] = ACTIONS(4973),
    [anon_sym_begin] = ACTIONS(4975),
    [anon_sym_default] = ACTIONS(4975),
    [anon_sym_static] = ACTIONS(4975),
    [anon_sym_member] = ACTIONS(4975),
    [anon_sym_interface] = ACTIONS(4975),
    [anon_sym_exception] = ACTIONS(4975),
    [anon_sym_abstract] = ACTIONS(4975),
    [anon_sym_val] = ACTIONS(4975),
    [anon_sym_override] = ACTIONS(4975),
    [aux_sym_char_token1] = ACTIONS(4973),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4975),
    [anon_sym_DQUOTE] = ACTIONS(4975),
    [anon_sym_AT_DQUOTE] = ACTIONS(4973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4973),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4973),
    [sym_bool] = ACTIONS(4975),
    [sym_unit] = ACTIONS(4973),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4975),
    [sym_op_identifier] = ACTIONS(4973),
    [anon_sym_PLUS] = ACTIONS(4975),
    [anon_sym_DASH] = ACTIONS(4975),
    [anon_sym_PLUS_DOT] = ACTIONS(4973),
    [anon_sym_DASH_DOT] = ACTIONS(4973),
    [anon_sym_PERCENT] = ACTIONS(4973),
    [anon_sym_AMP_AMP] = ACTIONS(4973),
    [anon_sym_TILDE] = ACTIONS(4973),
    [aux_sym_prefix_op_token1] = ACTIONS(4973),
    [sym_int] = ACTIONS(4975),
    [sym_xint] = ACTIONS(4973),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4973),
    [anon_sym_POUNDload] = ACTIONS(4973),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4973),
  },
  [3823] = {
    [sym_block_comment] = STATE(3823),
    [sym_compiler_directive_decl] = STATE(3823),
    [sym_fsi_directive_decl] = STATE(3823),
    [sym_preproc_line] = STATE(3823),
    [ts_builtin_sym_end] = ACTIONS(6386),
    [sym_identifier] = ACTIONS(6388),
    [anon_sym_namespace] = ACTIONS(6388),
    [anon_sym_module] = ACTIONS(6388),
    [anon_sym_open] = ACTIONS(6388),
    [anon_sym_LBRACK_LT] = ACTIONS(6386),
    [anon_sym_return] = ACTIONS(6388),
    [anon_sym_type] = ACTIONS(6388),
    [anon_sym_do] = ACTIONS(6388),
    [anon_sym_and] = ACTIONS(6388),
    [anon_sym_let] = ACTIONS(6388),
    [anon_sym_let_BANG] = ACTIONS(6386),
    [aux_sym_access_modifier_token1] = ACTIONS(6386),
    [anon_sym_LPAREN] = ACTIONS(6388),
    [anon_sym_null] = ACTIONS(6388),
    [anon_sym_AMP] = ACTIONS(6388),
    [anon_sym_LBRACK] = ACTIONS(6388),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6386),
    [anon_sym_LBRACE] = ACTIONS(6388),
    [anon_sym_LT_AT] = ACTIONS(6388),
    [anon_sym_LT_AT_AT] = ACTIONS(6386),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6386),
    [anon_sym_new] = ACTIONS(6388),
    [anon_sym_return_BANG] = ACTIONS(6386),
    [anon_sym_yield] = ACTIONS(6388),
    [anon_sym_yield_BANG] = ACTIONS(6386),
    [anon_sym_lazy] = ACTIONS(6388),
    [anon_sym_assert] = ACTIONS(6388),
    [anon_sym_upcast] = ACTIONS(6388),
    [anon_sym_downcast] = ACTIONS(6388),
    [anon_sym_for] = ACTIONS(6388),
    [anon_sym_while] = ACTIONS(6388),
    [anon_sym_if] = ACTIONS(6388),
    [anon_sym_fun] = ACTIONS(6388),
    [anon_sym_try] = ACTIONS(6388),
    [anon_sym_match] = ACTIONS(6388),
    [anon_sym_match_BANG] = ACTIONS(6386),
    [anon_sym_function] = ACTIONS(6388),
    [anon_sym_use] = ACTIONS(6388),
    [anon_sym_use_BANG] = ACTIONS(6386),
    [anon_sym_do_BANG] = ACTIONS(6386),
    [anon_sym_begin] = ACTIONS(6388),
    [anon_sym_default] = ACTIONS(6388),
    [anon_sym_static] = ACTIONS(6388),
    [anon_sym_member] = ACTIONS(6388),
    [anon_sym_interface] = ACTIONS(6388),
    [anon_sym_exception] = ACTIONS(6388),
    [anon_sym_abstract] = ACTIONS(6388),
    [anon_sym_val] = ACTIONS(6388),
    [anon_sym_override] = ACTIONS(6388),
    [aux_sym_char_token1] = ACTIONS(6386),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6388),
    [anon_sym_DQUOTE] = ACTIONS(6388),
    [anon_sym_AT_DQUOTE] = ACTIONS(6386),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6386),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6386),
    [sym_bool] = ACTIONS(6388),
    [sym_unit] = ACTIONS(6386),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6388),
    [sym_op_identifier] = ACTIONS(6386),
    [anon_sym_PLUS] = ACTIONS(6388),
    [anon_sym_DASH] = ACTIONS(6388),
    [anon_sym_PLUS_DOT] = ACTIONS(6386),
    [anon_sym_DASH_DOT] = ACTIONS(6386),
    [anon_sym_PERCENT] = ACTIONS(6386),
    [anon_sym_AMP_AMP] = ACTIONS(6386),
    [anon_sym_TILDE] = ACTIONS(6386),
    [aux_sym_prefix_op_token1] = ACTIONS(6386),
    [sym_int] = ACTIONS(6388),
    [sym_xint] = ACTIONS(6386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6386),
    [anon_sym_POUNDload] = ACTIONS(6386),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6386),
  },
  [3824] = {
    [sym_block_comment] = STATE(3824),
    [sym_compiler_directive_decl] = STATE(3824),
    [sym_fsi_directive_decl] = STATE(3824),
    [sym_preproc_line] = STATE(3824),
    [ts_builtin_sym_end] = ACTIONS(6390),
    [sym_identifier] = ACTIONS(6392),
    [anon_sym_namespace] = ACTIONS(6392),
    [anon_sym_module] = ACTIONS(6392),
    [anon_sym_open] = ACTIONS(6392),
    [anon_sym_LBRACK_LT] = ACTIONS(6390),
    [anon_sym_return] = ACTIONS(6392),
    [anon_sym_type] = ACTIONS(6392),
    [anon_sym_do] = ACTIONS(6392),
    [anon_sym_and] = ACTIONS(6392),
    [anon_sym_let] = ACTIONS(6392),
    [anon_sym_let_BANG] = ACTIONS(6390),
    [aux_sym_access_modifier_token1] = ACTIONS(6390),
    [anon_sym_LPAREN] = ACTIONS(6392),
    [anon_sym_null] = ACTIONS(6392),
    [anon_sym_AMP] = ACTIONS(6392),
    [anon_sym_LBRACK] = ACTIONS(6392),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6390),
    [anon_sym_LBRACE] = ACTIONS(6392),
    [anon_sym_LT_AT] = ACTIONS(6392),
    [anon_sym_LT_AT_AT] = ACTIONS(6390),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6390),
    [anon_sym_new] = ACTIONS(6392),
    [anon_sym_return_BANG] = ACTIONS(6390),
    [anon_sym_yield] = ACTIONS(6392),
    [anon_sym_yield_BANG] = ACTIONS(6390),
    [anon_sym_lazy] = ACTIONS(6392),
    [anon_sym_assert] = ACTIONS(6392),
    [anon_sym_upcast] = ACTIONS(6392),
    [anon_sym_downcast] = ACTIONS(6392),
    [anon_sym_for] = ACTIONS(6392),
    [anon_sym_while] = ACTIONS(6392),
    [anon_sym_if] = ACTIONS(6392),
    [anon_sym_fun] = ACTIONS(6392),
    [anon_sym_try] = ACTIONS(6392),
    [anon_sym_match] = ACTIONS(6392),
    [anon_sym_match_BANG] = ACTIONS(6390),
    [anon_sym_function] = ACTIONS(6392),
    [anon_sym_use] = ACTIONS(6392),
    [anon_sym_use_BANG] = ACTIONS(6390),
    [anon_sym_do_BANG] = ACTIONS(6390),
    [anon_sym_begin] = ACTIONS(6392),
    [anon_sym_default] = ACTIONS(6392),
    [anon_sym_static] = ACTIONS(6392),
    [anon_sym_member] = ACTIONS(6392),
    [anon_sym_interface] = ACTIONS(6392),
    [anon_sym_exception] = ACTIONS(6392),
    [anon_sym_abstract] = ACTIONS(6392),
    [anon_sym_val] = ACTIONS(6392),
    [anon_sym_override] = ACTIONS(6392),
    [aux_sym_char_token1] = ACTIONS(6390),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6392),
    [anon_sym_DQUOTE] = ACTIONS(6392),
    [anon_sym_AT_DQUOTE] = ACTIONS(6390),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6390),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6390),
    [sym_bool] = ACTIONS(6392),
    [sym_unit] = ACTIONS(6390),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6392),
    [sym_op_identifier] = ACTIONS(6390),
    [anon_sym_PLUS] = ACTIONS(6392),
    [anon_sym_DASH] = ACTIONS(6392),
    [anon_sym_PLUS_DOT] = ACTIONS(6390),
    [anon_sym_DASH_DOT] = ACTIONS(6390),
    [anon_sym_PERCENT] = ACTIONS(6390),
    [anon_sym_AMP_AMP] = ACTIONS(6390),
    [anon_sym_TILDE] = ACTIONS(6390),
    [aux_sym_prefix_op_token1] = ACTIONS(6390),
    [sym_int] = ACTIONS(6392),
    [sym_xint] = ACTIONS(6390),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6390),
    [anon_sym_POUNDload] = ACTIONS(6390),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6390),
  },
  [3825] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8242),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(3024),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3825),
    [sym_compiler_directive_decl] = STATE(3825),
    [sym_fsi_directive_decl] = STATE(3825),
    [sym_preproc_line] = STATE(3825),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3826] = {
    [sym_attributes] = STATE(3905),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(8258),
    [sym__pattern] = STATE(8064),
    [sym_optional_pattern] = STATE(8258),
    [sym_type_check_pattern] = STATE(8258),
    [sym_attribute_pattern] = STATE(8258),
    [sym_paren_pattern] = STATE(8258),
    [sym_as_pattern] = STATE(8258),
    [sym_cons_pattern] = STATE(8258),
    [sym_disjunct_pattern] = STATE(8258),
    [sym_conjunct_pattern] = STATE(8258),
    [sym_typed_pattern] = STATE(8258),
    [sym_list_pattern] = STATE(8258),
    [sym_array_pattern] = STATE(8258),
    [sym_record_pattern] = STATE(8258),
    [sym_named_field] = STATE(9351),
    [sym_named_field_pattern] = STATE(8258),
    [sym_identifier_pattern] = STATE(8258),
    [sym_long_identifier_or_op] = STATE(2968),
    [sym_char] = STATE(8017),
    [sym_format_string] = STATE(8065),
    [sym__string_literal] = STATE(8065),
    [sym_string] = STATE(8017),
    [sym_verbatim_string] = STATE(8017),
    [sym_bytearray] = STATE(8017),
    [sym_verbatim_bytearray] = STATE(8017),
    [sym_format_triple_quoted_string] = STATE(8066),
    [sym_triple_quoted_string] = STATE(8017),
    [sym_const] = STATE(8258),
    [sym_long_identifier] = STATE(4907),
    [sym_active_pattern] = STATE(5059),
    [sym__identifier_or_op] = STATE(4927),
    [sym_sbyte] = STATE(8017),
    [sym_byte] = STATE(8017),
    [sym_int16] = STATE(8017),
    [sym_uint16] = STATE(8017),
    [sym_int32] = STATE(8017),
    [sym_uint32] = STATE(8017),
    [sym_nativeint] = STATE(8017),
    [sym_unativeint] = STATE(8017),
    [sym_int64] = STATE(8017),
    [sym_uint64] = STATE(8017),
    [sym_ieee32] = STATE(8017),
    [sym_ieee64] = STATE(8017),
    [sym_bignum] = STATE(8017),
    [sym_decimal] = STATE(8017),
    [sym_float] = STATE(7544),
    [sym_block_comment] = STATE(3826),
    [sym_compiler_directive_decl] = STATE(3826),
    [sym_fsi_directive_decl] = STATE(3826),
    [sym_preproc_line] = STATE(3826),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(6298),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5492),
    [anon_sym_null] = ACTIONS(5494),
    [anon_sym__] = ACTIONS(5496),
    [anon_sym_QMARK] = ACTIONS(5498),
    [anon_sym_COLON_QMARK] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5502),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5504),
    [anon_sym_LBRACE] = ACTIONS(5506),
    [aux_sym_char_token1] = ACTIONS(5508),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5510),
    [anon_sym_DQUOTE] = ACTIONS(5512),
    [anon_sym_AT_DQUOTE] = ACTIONS(5514),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5516),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5518),
    [sym_bool] = ACTIONS(5520),
    [sym_unit] = ACTIONS(5522),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5524),
    [sym_op_identifier] = ACTIONS(5526),
    [sym_int] = ACTIONS(5528),
    [sym_xint] = ACTIONS(5530),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3827] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8091),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(3147),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3827),
    [sym_compiler_directive_decl] = STATE(3827),
    [sym_fsi_directive_decl] = STATE(3827),
    [sym_preproc_line] = STATE(3827),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3828] = {
    [sym_block_comment] = STATE(3828),
    [sym_compiler_directive_decl] = STATE(3828),
    [sym_fsi_directive_decl] = STATE(3828),
    [sym_preproc_line] = STATE(3828),
    [ts_builtin_sym_end] = ACTIONS(6394),
    [sym_identifier] = ACTIONS(6396),
    [anon_sym_namespace] = ACTIONS(6396),
    [anon_sym_module] = ACTIONS(6396),
    [anon_sym_open] = ACTIONS(6396),
    [anon_sym_LBRACK_LT] = ACTIONS(6394),
    [anon_sym_return] = ACTIONS(6396),
    [anon_sym_type] = ACTIONS(6396),
    [anon_sym_do] = ACTIONS(6396),
    [anon_sym_and] = ACTIONS(6396),
    [anon_sym_let] = ACTIONS(6396),
    [anon_sym_let_BANG] = ACTIONS(6394),
    [aux_sym_access_modifier_token1] = ACTIONS(6394),
    [anon_sym_LPAREN] = ACTIONS(6396),
    [anon_sym_null] = ACTIONS(6396),
    [anon_sym_AMP] = ACTIONS(6396),
    [anon_sym_LBRACK] = ACTIONS(6396),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6394),
    [anon_sym_LBRACE] = ACTIONS(6396),
    [anon_sym_LT_AT] = ACTIONS(6396),
    [anon_sym_LT_AT_AT] = ACTIONS(6394),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6394),
    [anon_sym_new] = ACTIONS(6396),
    [anon_sym_return_BANG] = ACTIONS(6394),
    [anon_sym_yield] = ACTIONS(6396),
    [anon_sym_yield_BANG] = ACTIONS(6394),
    [anon_sym_lazy] = ACTIONS(6396),
    [anon_sym_assert] = ACTIONS(6396),
    [anon_sym_upcast] = ACTIONS(6396),
    [anon_sym_downcast] = ACTIONS(6396),
    [anon_sym_for] = ACTIONS(6396),
    [anon_sym_while] = ACTIONS(6396),
    [anon_sym_if] = ACTIONS(6396),
    [anon_sym_fun] = ACTIONS(6396),
    [anon_sym_try] = ACTIONS(6396),
    [anon_sym_match] = ACTIONS(6396),
    [anon_sym_match_BANG] = ACTIONS(6394),
    [anon_sym_function] = ACTIONS(6396),
    [anon_sym_use] = ACTIONS(6396),
    [anon_sym_use_BANG] = ACTIONS(6394),
    [anon_sym_do_BANG] = ACTIONS(6394),
    [anon_sym_begin] = ACTIONS(6396),
    [anon_sym_default] = ACTIONS(6396),
    [anon_sym_static] = ACTIONS(6396),
    [anon_sym_member] = ACTIONS(6396),
    [anon_sym_interface] = ACTIONS(6396),
    [anon_sym_exception] = ACTIONS(6396),
    [anon_sym_abstract] = ACTIONS(6396),
    [anon_sym_val] = ACTIONS(6396),
    [anon_sym_override] = ACTIONS(6396),
    [aux_sym_char_token1] = ACTIONS(6394),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6396),
    [anon_sym_DQUOTE] = ACTIONS(6396),
    [anon_sym_AT_DQUOTE] = ACTIONS(6394),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6394),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6394),
    [sym_bool] = ACTIONS(6396),
    [sym_unit] = ACTIONS(6394),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6396),
    [sym_op_identifier] = ACTIONS(6394),
    [anon_sym_PLUS] = ACTIONS(6396),
    [anon_sym_DASH] = ACTIONS(6396),
    [anon_sym_PLUS_DOT] = ACTIONS(6394),
    [anon_sym_DASH_DOT] = ACTIONS(6394),
    [anon_sym_PERCENT] = ACTIONS(6394),
    [anon_sym_AMP_AMP] = ACTIONS(6394),
    [anon_sym_TILDE] = ACTIONS(6394),
    [aux_sym_prefix_op_token1] = ACTIONS(6394),
    [sym_int] = ACTIONS(6396),
    [sym_xint] = ACTIONS(6394),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6394),
    [anon_sym_POUNDload] = ACTIONS(6394),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6394),
  },
  [3829] = {
    [sym_block_comment] = STATE(3829),
    [sym_compiler_directive_decl] = STATE(3829),
    [sym_fsi_directive_decl] = STATE(3829),
    [sym_preproc_line] = STATE(3829),
    [ts_builtin_sym_end] = ACTIONS(6386),
    [sym_identifier] = ACTIONS(6388),
    [anon_sym_namespace] = ACTIONS(6388),
    [anon_sym_module] = ACTIONS(6388),
    [anon_sym_open] = ACTIONS(6388),
    [anon_sym_LBRACK_LT] = ACTIONS(6386),
    [anon_sym_return] = ACTIONS(6388),
    [anon_sym_type] = ACTIONS(6388),
    [anon_sym_do] = ACTIONS(6388),
    [anon_sym_and] = ACTIONS(6388),
    [anon_sym_let] = ACTIONS(6388),
    [anon_sym_let_BANG] = ACTIONS(6386),
    [aux_sym_access_modifier_token1] = ACTIONS(6386),
    [anon_sym_LPAREN] = ACTIONS(6388),
    [anon_sym_null] = ACTIONS(6388),
    [anon_sym_AMP] = ACTIONS(6388),
    [anon_sym_LBRACK] = ACTIONS(6388),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6386),
    [anon_sym_LBRACE] = ACTIONS(6388),
    [anon_sym_LT_AT] = ACTIONS(6388),
    [anon_sym_LT_AT_AT] = ACTIONS(6386),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6386),
    [anon_sym_new] = ACTIONS(6388),
    [anon_sym_return_BANG] = ACTIONS(6386),
    [anon_sym_yield] = ACTIONS(6388),
    [anon_sym_yield_BANG] = ACTIONS(6386),
    [anon_sym_lazy] = ACTIONS(6388),
    [anon_sym_assert] = ACTIONS(6388),
    [anon_sym_upcast] = ACTIONS(6388),
    [anon_sym_downcast] = ACTIONS(6388),
    [anon_sym_for] = ACTIONS(6388),
    [anon_sym_while] = ACTIONS(6388),
    [anon_sym_if] = ACTIONS(6388),
    [anon_sym_fun] = ACTIONS(6388),
    [anon_sym_try] = ACTIONS(6388),
    [anon_sym_match] = ACTIONS(6388),
    [anon_sym_match_BANG] = ACTIONS(6386),
    [anon_sym_function] = ACTIONS(6388),
    [anon_sym_use] = ACTIONS(6388),
    [anon_sym_use_BANG] = ACTIONS(6386),
    [anon_sym_do_BANG] = ACTIONS(6386),
    [anon_sym_begin] = ACTIONS(6388),
    [anon_sym_default] = ACTIONS(6388),
    [anon_sym_static] = ACTIONS(6388),
    [anon_sym_member] = ACTIONS(6388),
    [anon_sym_interface] = ACTIONS(6388),
    [anon_sym_exception] = ACTIONS(6388),
    [anon_sym_abstract] = ACTIONS(6388),
    [anon_sym_val] = ACTIONS(6388),
    [anon_sym_override] = ACTIONS(6388),
    [aux_sym_char_token1] = ACTIONS(6386),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6388),
    [anon_sym_DQUOTE] = ACTIONS(6388),
    [anon_sym_AT_DQUOTE] = ACTIONS(6386),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6386),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6386),
    [sym_bool] = ACTIONS(6388),
    [sym_unit] = ACTIONS(6386),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6388),
    [sym_op_identifier] = ACTIONS(6386),
    [anon_sym_PLUS] = ACTIONS(6388),
    [anon_sym_DASH] = ACTIONS(6388),
    [anon_sym_PLUS_DOT] = ACTIONS(6386),
    [anon_sym_DASH_DOT] = ACTIONS(6386),
    [anon_sym_PERCENT] = ACTIONS(6386),
    [anon_sym_AMP_AMP] = ACTIONS(6386),
    [anon_sym_TILDE] = ACTIONS(6386),
    [aux_sym_prefix_op_token1] = ACTIONS(6386),
    [sym_int] = ACTIONS(6388),
    [sym_xint] = ACTIONS(6386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6386),
    [anon_sym_POUNDload] = ACTIONS(6386),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6386),
  },
  [3830] = {
    [sym_block_comment] = STATE(3830),
    [sym_compiler_directive_decl] = STATE(3830),
    [sym_fsi_directive_decl] = STATE(3830),
    [sym_preproc_line] = STATE(3830),
    [ts_builtin_sym_end] = ACTIONS(6398),
    [sym_identifier] = ACTIONS(6400),
    [anon_sym_namespace] = ACTIONS(6400),
    [anon_sym_module] = ACTIONS(6400),
    [anon_sym_open] = ACTIONS(6400),
    [anon_sym_LBRACK_LT] = ACTIONS(6398),
    [anon_sym_return] = ACTIONS(6400),
    [anon_sym_type] = ACTIONS(6400),
    [anon_sym_do] = ACTIONS(6400),
    [anon_sym_and] = ACTIONS(6400),
    [anon_sym_let] = ACTIONS(6400),
    [anon_sym_let_BANG] = ACTIONS(6398),
    [aux_sym_access_modifier_token1] = ACTIONS(6398),
    [anon_sym_LPAREN] = ACTIONS(6400),
    [anon_sym_null] = ACTIONS(6400),
    [anon_sym_AMP] = ACTIONS(6400),
    [anon_sym_LBRACK] = ACTIONS(6400),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6398),
    [anon_sym_LBRACE] = ACTIONS(6400),
    [anon_sym_LT_AT] = ACTIONS(6400),
    [anon_sym_LT_AT_AT] = ACTIONS(6398),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6398),
    [anon_sym_new] = ACTIONS(6400),
    [anon_sym_return_BANG] = ACTIONS(6398),
    [anon_sym_yield] = ACTIONS(6400),
    [anon_sym_yield_BANG] = ACTIONS(6398),
    [anon_sym_lazy] = ACTIONS(6400),
    [anon_sym_assert] = ACTIONS(6400),
    [anon_sym_upcast] = ACTIONS(6400),
    [anon_sym_downcast] = ACTIONS(6400),
    [anon_sym_for] = ACTIONS(6400),
    [anon_sym_while] = ACTIONS(6400),
    [anon_sym_if] = ACTIONS(6400),
    [anon_sym_fun] = ACTIONS(6400),
    [anon_sym_try] = ACTIONS(6400),
    [anon_sym_match] = ACTIONS(6400),
    [anon_sym_match_BANG] = ACTIONS(6398),
    [anon_sym_function] = ACTIONS(6400),
    [anon_sym_use] = ACTIONS(6400),
    [anon_sym_use_BANG] = ACTIONS(6398),
    [anon_sym_do_BANG] = ACTIONS(6398),
    [anon_sym_begin] = ACTIONS(6400),
    [anon_sym_default] = ACTIONS(6400),
    [anon_sym_static] = ACTIONS(6400),
    [anon_sym_member] = ACTIONS(6400),
    [anon_sym_interface] = ACTIONS(6400),
    [anon_sym_exception] = ACTIONS(6400),
    [anon_sym_abstract] = ACTIONS(6400),
    [anon_sym_val] = ACTIONS(6400),
    [anon_sym_override] = ACTIONS(6400),
    [aux_sym_char_token1] = ACTIONS(6398),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6400),
    [anon_sym_DQUOTE] = ACTIONS(6400),
    [anon_sym_AT_DQUOTE] = ACTIONS(6398),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6398),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6398),
    [sym_bool] = ACTIONS(6400),
    [sym_unit] = ACTIONS(6398),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6400),
    [sym_op_identifier] = ACTIONS(6398),
    [anon_sym_PLUS] = ACTIONS(6400),
    [anon_sym_DASH] = ACTIONS(6400),
    [anon_sym_PLUS_DOT] = ACTIONS(6398),
    [anon_sym_DASH_DOT] = ACTIONS(6398),
    [anon_sym_PERCENT] = ACTIONS(6398),
    [anon_sym_AMP_AMP] = ACTIONS(6398),
    [anon_sym_TILDE] = ACTIONS(6398),
    [aux_sym_prefix_op_token1] = ACTIONS(6398),
    [sym_int] = ACTIONS(6400),
    [sym_xint] = ACTIONS(6398),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6398),
    [anon_sym_POUNDload] = ACTIONS(6398),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6398),
  },
  [3831] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8234),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2870),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3831),
    [sym_compiler_directive_decl] = STATE(3831),
    [sym_fsi_directive_decl] = STATE(3831),
    [sym_preproc_line] = STATE(3831),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3832] = {
    [sym_block_comment] = STATE(3832),
    [sym_compiler_directive_decl] = STATE(3832),
    [sym_fsi_directive_decl] = STATE(3832),
    [sym_preproc_line] = STATE(3832),
    [ts_builtin_sym_end] = ACTIONS(3698),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_namespace] = ACTIONS(3700),
    [anon_sym_module] = ACTIONS(3700),
    [anon_sym_open] = ACTIONS(3700),
    [anon_sym_LBRACK_LT] = ACTIONS(3698),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_type] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_and] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [aux_sym_access_modifier_token1] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_default] = ACTIONS(3700),
    [anon_sym_static] = ACTIONS(3700),
    [anon_sym_member] = ACTIONS(3700),
    [anon_sym_interface] = ACTIONS(3700),
    [anon_sym_exception] = ACTIONS(3700),
    [anon_sym_abstract] = ACTIONS(3700),
    [anon_sym_val] = ACTIONS(3700),
    [anon_sym_override] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3698),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3698),
    [anon_sym_DASH_DOT] = ACTIONS(3698),
    [anon_sym_PERCENT] = ACTIONS(3698),
    [anon_sym_AMP_AMP] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3698),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3698),
    [anon_sym_POUNDload] = ACTIONS(3698),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
  },
  [3833] = {
    [sym_block_comment] = STATE(3833),
    [sym_compiler_directive_decl] = STATE(3833),
    [sym_fsi_directive_decl] = STATE(3833),
    [sym_preproc_line] = STATE(3833),
    [ts_builtin_sym_end] = ACTIONS(6402),
    [sym_identifier] = ACTIONS(6404),
    [anon_sym_namespace] = ACTIONS(6404),
    [anon_sym_module] = ACTIONS(6404),
    [anon_sym_open] = ACTIONS(6404),
    [anon_sym_LBRACK_LT] = ACTIONS(6402),
    [anon_sym_return] = ACTIONS(6404),
    [anon_sym_type] = ACTIONS(6404),
    [anon_sym_do] = ACTIONS(6404),
    [anon_sym_and] = ACTIONS(6404),
    [anon_sym_let] = ACTIONS(6404),
    [anon_sym_let_BANG] = ACTIONS(6402),
    [aux_sym_access_modifier_token1] = ACTIONS(6402),
    [anon_sym_LPAREN] = ACTIONS(6404),
    [anon_sym_null] = ACTIONS(6404),
    [anon_sym_AMP] = ACTIONS(6404),
    [anon_sym_LBRACK] = ACTIONS(6404),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6402),
    [anon_sym_LBRACE] = ACTIONS(6404),
    [anon_sym_LT_AT] = ACTIONS(6404),
    [anon_sym_LT_AT_AT] = ACTIONS(6402),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6402),
    [anon_sym_new] = ACTIONS(6404),
    [anon_sym_return_BANG] = ACTIONS(6402),
    [anon_sym_yield] = ACTIONS(6404),
    [anon_sym_yield_BANG] = ACTIONS(6402),
    [anon_sym_lazy] = ACTIONS(6404),
    [anon_sym_assert] = ACTIONS(6404),
    [anon_sym_upcast] = ACTIONS(6404),
    [anon_sym_downcast] = ACTIONS(6404),
    [anon_sym_for] = ACTIONS(6404),
    [anon_sym_while] = ACTIONS(6404),
    [anon_sym_if] = ACTIONS(6404),
    [anon_sym_fun] = ACTIONS(6404),
    [anon_sym_try] = ACTIONS(6404),
    [anon_sym_match] = ACTIONS(6404),
    [anon_sym_match_BANG] = ACTIONS(6402),
    [anon_sym_function] = ACTIONS(6404),
    [anon_sym_use] = ACTIONS(6404),
    [anon_sym_use_BANG] = ACTIONS(6402),
    [anon_sym_do_BANG] = ACTIONS(6402),
    [anon_sym_begin] = ACTIONS(6404),
    [anon_sym_default] = ACTIONS(6404),
    [anon_sym_static] = ACTIONS(6404),
    [anon_sym_member] = ACTIONS(6404),
    [anon_sym_interface] = ACTIONS(6404),
    [anon_sym_exception] = ACTIONS(6404),
    [anon_sym_abstract] = ACTIONS(6404),
    [anon_sym_val] = ACTIONS(6404),
    [anon_sym_override] = ACTIONS(6404),
    [aux_sym_char_token1] = ACTIONS(6402),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6404),
    [anon_sym_DQUOTE] = ACTIONS(6404),
    [anon_sym_AT_DQUOTE] = ACTIONS(6402),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6402),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6402),
    [sym_bool] = ACTIONS(6404),
    [sym_unit] = ACTIONS(6402),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6404),
    [sym_op_identifier] = ACTIONS(6402),
    [anon_sym_PLUS] = ACTIONS(6404),
    [anon_sym_DASH] = ACTIONS(6404),
    [anon_sym_PLUS_DOT] = ACTIONS(6402),
    [anon_sym_DASH_DOT] = ACTIONS(6402),
    [anon_sym_PERCENT] = ACTIONS(6402),
    [anon_sym_AMP_AMP] = ACTIONS(6402),
    [anon_sym_TILDE] = ACTIONS(6402),
    [aux_sym_prefix_op_token1] = ACTIONS(6402),
    [sym_int] = ACTIONS(6404),
    [sym_xint] = ACTIONS(6402),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6402),
    [anon_sym_POUNDload] = ACTIONS(6402),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6402),
  },
  [3834] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8272),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1779),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3834),
    [sym_compiler_directive_decl] = STATE(3834),
    [sym_fsi_directive_decl] = STATE(3834),
    [sym_preproc_line] = STATE(3834),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3835] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8091),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(3185),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3835),
    [sym_compiler_directive_decl] = STATE(3835),
    [sym_fsi_directive_decl] = STATE(3835),
    [sym_preproc_line] = STATE(3835),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3836] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8251),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2804),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3836),
    [sym_compiler_directive_decl] = STATE(3836),
    [sym_fsi_directive_decl] = STATE(3836),
    [sym_preproc_line] = STATE(3836),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3837] = {
    [sym_block_comment] = STATE(3837),
    [sym_compiler_directive_decl] = STATE(3837),
    [sym_fsi_directive_decl] = STATE(3837),
    [sym_preproc_line] = STATE(3837),
    [ts_builtin_sym_end] = ACTIONS(6406),
    [sym_identifier] = ACTIONS(6408),
    [anon_sym_namespace] = ACTIONS(6408),
    [anon_sym_module] = ACTIONS(6408),
    [anon_sym_open] = ACTIONS(6408),
    [anon_sym_LBRACK_LT] = ACTIONS(6406),
    [anon_sym_return] = ACTIONS(6408),
    [anon_sym_type] = ACTIONS(6408),
    [anon_sym_do] = ACTIONS(6408),
    [anon_sym_and] = ACTIONS(6408),
    [anon_sym_let] = ACTIONS(6408),
    [anon_sym_let_BANG] = ACTIONS(6406),
    [aux_sym_access_modifier_token1] = ACTIONS(6406),
    [anon_sym_LPAREN] = ACTIONS(6408),
    [anon_sym_null] = ACTIONS(6408),
    [anon_sym_AMP] = ACTIONS(6408),
    [anon_sym_LBRACK] = ACTIONS(6408),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6406),
    [anon_sym_LBRACE] = ACTIONS(6408),
    [anon_sym_LT_AT] = ACTIONS(6408),
    [anon_sym_LT_AT_AT] = ACTIONS(6406),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6406),
    [anon_sym_new] = ACTIONS(6408),
    [anon_sym_return_BANG] = ACTIONS(6406),
    [anon_sym_yield] = ACTIONS(6408),
    [anon_sym_yield_BANG] = ACTIONS(6406),
    [anon_sym_lazy] = ACTIONS(6408),
    [anon_sym_assert] = ACTIONS(6408),
    [anon_sym_upcast] = ACTIONS(6408),
    [anon_sym_downcast] = ACTIONS(6408),
    [anon_sym_for] = ACTIONS(6408),
    [anon_sym_while] = ACTIONS(6408),
    [anon_sym_if] = ACTIONS(6408),
    [anon_sym_fun] = ACTIONS(6408),
    [anon_sym_try] = ACTIONS(6408),
    [anon_sym_match] = ACTIONS(6408),
    [anon_sym_match_BANG] = ACTIONS(6406),
    [anon_sym_function] = ACTIONS(6408),
    [anon_sym_use] = ACTIONS(6408),
    [anon_sym_use_BANG] = ACTIONS(6406),
    [anon_sym_do_BANG] = ACTIONS(6406),
    [anon_sym_begin] = ACTIONS(6408),
    [anon_sym_default] = ACTIONS(6408),
    [anon_sym_static] = ACTIONS(6408),
    [anon_sym_member] = ACTIONS(6408),
    [anon_sym_interface] = ACTIONS(6408),
    [anon_sym_exception] = ACTIONS(6408),
    [anon_sym_abstract] = ACTIONS(6408),
    [anon_sym_val] = ACTIONS(6408),
    [anon_sym_override] = ACTIONS(6408),
    [aux_sym_char_token1] = ACTIONS(6406),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6408),
    [anon_sym_DQUOTE] = ACTIONS(6408),
    [anon_sym_AT_DQUOTE] = ACTIONS(6406),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6406),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6406),
    [sym_bool] = ACTIONS(6408),
    [sym_unit] = ACTIONS(6406),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6408),
    [sym_op_identifier] = ACTIONS(6406),
    [anon_sym_PLUS] = ACTIONS(6408),
    [anon_sym_DASH] = ACTIONS(6408),
    [anon_sym_PLUS_DOT] = ACTIONS(6406),
    [anon_sym_DASH_DOT] = ACTIONS(6406),
    [anon_sym_PERCENT] = ACTIONS(6406),
    [anon_sym_AMP_AMP] = ACTIONS(6406),
    [anon_sym_TILDE] = ACTIONS(6406),
    [aux_sym_prefix_op_token1] = ACTIONS(6406),
    [sym_int] = ACTIONS(6408),
    [sym_xint] = ACTIONS(6406),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6406),
    [anon_sym_POUNDload] = ACTIONS(6406),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6406),
  },
  [3838] = {
    [sym_block_comment] = STATE(3838),
    [sym_compiler_directive_decl] = STATE(3838),
    [sym_fsi_directive_decl] = STATE(3838),
    [sym_preproc_line] = STATE(3838),
    [ts_builtin_sym_end] = ACTIONS(6410),
    [sym_identifier] = ACTIONS(6412),
    [anon_sym_namespace] = ACTIONS(6412),
    [anon_sym_module] = ACTIONS(6412),
    [anon_sym_open] = ACTIONS(6412),
    [anon_sym_LBRACK_LT] = ACTIONS(6410),
    [anon_sym_return] = ACTIONS(6412),
    [anon_sym_type] = ACTIONS(6412),
    [anon_sym_do] = ACTIONS(6412),
    [anon_sym_and] = ACTIONS(6412),
    [anon_sym_let] = ACTIONS(6412),
    [anon_sym_let_BANG] = ACTIONS(6410),
    [aux_sym_access_modifier_token1] = ACTIONS(6410),
    [anon_sym_LPAREN] = ACTIONS(6412),
    [anon_sym_null] = ACTIONS(6412),
    [anon_sym_AMP] = ACTIONS(6412),
    [anon_sym_LBRACK] = ACTIONS(6412),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6410),
    [anon_sym_LBRACE] = ACTIONS(6412),
    [anon_sym_LT_AT] = ACTIONS(6412),
    [anon_sym_LT_AT_AT] = ACTIONS(6410),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6410),
    [anon_sym_new] = ACTIONS(6412),
    [anon_sym_return_BANG] = ACTIONS(6410),
    [anon_sym_yield] = ACTIONS(6412),
    [anon_sym_yield_BANG] = ACTIONS(6410),
    [anon_sym_lazy] = ACTIONS(6412),
    [anon_sym_assert] = ACTIONS(6412),
    [anon_sym_upcast] = ACTIONS(6412),
    [anon_sym_downcast] = ACTIONS(6412),
    [anon_sym_for] = ACTIONS(6412),
    [anon_sym_while] = ACTIONS(6412),
    [anon_sym_if] = ACTIONS(6412),
    [anon_sym_fun] = ACTIONS(6412),
    [anon_sym_try] = ACTIONS(6412),
    [anon_sym_match] = ACTIONS(6412),
    [anon_sym_match_BANG] = ACTIONS(6410),
    [anon_sym_function] = ACTIONS(6412),
    [anon_sym_use] = ACTIONS(6412),
    [anon_sym_use_BANG] = ACTIONS(6410),
    [anon_sym_do_BANG] = ACTIONS(6410),
    [anon_sym_begin] = ACTIONS(6412),
    [anon_sym_default] = ACTIONS(6412),
    [anon_sym_static] = ACTIONS(6412),
    [anon_sym_member] = ACTIONS(6412),
    [anon_sym_interface] = ACTIONS(6412),
    [anon_sym_exception] = ACTIONS(6412),
    [anon_sym_abstract] = ACTIONS(6412),
    [anon_sym_val] = ACTIONS(6412),
    [anon_sym_override] = ACTIONS(6412),
    [aux_sym_char_token1] = ACTIONS(6410),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6412),
    [anon_sym_DQUOTE] = ACTIONS(6412),
    [anon_sym_AT_DQUOTE] = ACTIONS(6410),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6410),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6410),
    [sym_bool] = ACTIONS(6412),
    [sym_unit] = ACTIONS(6410),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6412),
    [sym_op_identifier] = ACTIONS(6410),
    [anon_sym_PLUS] = ACTIONS(6412),
    [anon_sym_DASH] = ACTIONS(6412),
    [anon_sym_PLUS_DOT] = ACTIONS(6410),
    [anon_sym_DASH_DOT] = ACTIONS(6410),
    [anon_sym_PERCENT] = ACTIONS(6410),
    [anon_sym_AMP_AMP] = ACTIONS(6410),
    [anon_sym_TILDE] = ACTIONS(6410),
    [aux_sym_prefix_op_token1] = ACTIONS(6410),
    [sym_int] = ACTIONS(6412),
    [sym_xint] = ACTIONS(6410),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6410),
    [anon_sym_POUNDload] = ACTIONS(6410),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6410),
  },
  [3839] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3839),
    [sym_compiler_directive_decl] = STATE(3839),
    [sym_fsi_directive_decl] = STATE(3839),
    [sym_preproc_line] = STATE(3839),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3741),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3840] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8242),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(3005),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3840),
    [sym_compiler_directive_decl] = STATE(3840),
    [sym_fsi_directive_decl] = STATE(3840),
    [sym_preproc_line] = STATE(3840),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3841] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3841),
    [sym_compiler_directive_decl] = STATE(3841),
    [sym_fsi_directive_decl] = STATE(3841),
    [sym_preproc_line] = STATE(3841),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3728),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3842] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3842),
    [sym_compiler_directive_decl] = STATE(3842),
    [sym_fsi_directive_decl] = STATE(3842),
    [sym_preproc_line] = STATE(3842),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3733),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3843] = {
    [sym_block_comment] = STATE(3843),
    [sym_compiler_directive_decl] = STATE(3843),
    [sym_fsi_directive_decl] = STATE(3843),
    [sym_preproc_line] = STATE(3843),
    [ts_builtin_sym_end] = ACTIONS(2690),
    [sym_identifier] = ACTIONS(2692),
    [anon_sym_namespace] = ACTIONS(2692),
    [anon_sym_module] = ACTIONS(2692),
    [anon_sym_open] = ACTIONS(2692),
    [anon_sym_LBRACK_LT] = ACTIONS(2690),
    [anon_sym_return] = ACTIONS(2692),
    [anon_sym_type] = ACTIONS(2692),
    [anon_sym_do] = ACTIONS(2692),
    [anon_sym_and] = ACTIONS(2692),
    [anon_sym_let] = ACTIONS(2692),
    [anon_sym_let_BANG] = ACTIONS(2690),
    [aux_sym_access_modifier_token1] = ACTIONS(2690),
    [anon_sym_LPAREN] = ACTIONS(2692),
    [anon_sym_null] = ACTIONS(2692),
    [anon_sym_AMP] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2692),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2690),
    [anon_sym_LBRACE] = ACTIONS(2692),
    [anon_sym_LT_AT] = ACTIONS(2692),
    [anon_sym_LT_AT_AT] = ACTIONS(2690),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2690),
    [anon_sym_new] = ACTIONS(2692),
    [anon_sym_return_BANG] = ACTIONS(2690),
    [anon_sym_yield] = ACTIONS(2692),
    [anon_sym_yield_BANG] = ACTIONS(2690),
    [anon_sym_lazy] = ACTIONS(2692),
    [anon_sym_assert] = ACTIONS(2692),
    [anon_sym_upcast] = ACTIONS(2692),
    [anon_sym_downcast] = ACTIONS(2692),
    [anon_sym_for] = ACTIONS(2692),
    [anon_sym_while] = ACTIONS(2692),
    [anon_sym_if] = ACTIONS(2692),
    [anon_sym_fun] = ACTIONS(2692),
    [anon_sym_try] = ACTIONS(2692),
    [anon_sym_match] = ACTIONS(2692),
    [anon_sym_match_BANG] = ACTIONS(2690),
    [anon_sym_function] = ACTIONS(2692),
    [anon_sym_use] = ACTIONS(2692),
    [anon_sym_use_BANG] = ACTIONS(2690),
    [anon_sym_do_BANG] = ACTIONS(2690),
    [anon_sym_begin] = ACTIONS(2692),
    [anon_sym_default] = ACTIONS(2692),
    [anon_sym_static] = ACTIONS(2692),
    [anon_sym_member] = ACTIONS(2692),
    [anon_sym_interface] = ACTIONS(2692),
    [anon_sym_exception] = ACTIONS(2692),
    [anon_sym_abstract] = ACTIONS(2692),
    [anon_sym_val] = ACTIONS(2692),
    [anon_sym_override] = ACTIONS(2692),
    [aux_sym_char_token1] = ACTIONS(2690),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2692),
    [anon_sym_DQUOTE] = ACTIONS(2692),
    [anon_sym_AT_DQUOTE] = ACTIONS(2690),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2690),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2690),
    [sym_bool] = ACTIONS(2692),
    [sym_unit] = ACTIONS(2690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2692),
    [sym_op_identifier] = ACTIONS(2690),
    [anon_sym_PLUS] = ACTIONS(2692),
    [anon_sym_DASH] = ACTIONS(2692),
    [anon_sym_PLUS_DOT] = ACTIONS(2690),
    [anon_sym_DASH_DOT] = ACTIONS(2690),
    [anon_sym_PERCENT] = ACTIONS(2690),
    [anon_sym_AMP_AMP] = ACTIONS(2690),
    [anon_sym_TILDE] = ACTIONS(2690),
    [aux_sym_prefix_op_token1] = ACTIONS(2690),
    [sym_int] = ACTIONS(2692),
    [sym_xint] = ACTIONS(2690),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2690),
    [anon_sym_POUNDload] = ACTIONS(2690),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2690),
  },
  [3844] = {
    [sym_block_comment] = STATE(3844),
    [sym_compiler_directive_decl] = STATE(3844),
    [sym_fsi_directive_decl] = STATE(3844),
    [sym_preproc_line] = STATE(3844),
    [ts_builtin_sym_end] = ACTIONS(6414),
    [sym_identifier] = ACTIONS(6416),
    [anon_sym_namespace] = ACTIONS(6416),
    [anon_sym_module] = ACTIONS(6416),
    [anon_sym_open] = ACTIONS(6416),
    [anon_sym_LBRACK_LT] = ACTIONS(6414),
    [anon_sym_return] = ACTIONS(6416),
    [anon_sym_type] = ACTIONS(6416),
    [anon_sym_do] = ACTIONS(6416),
    [anon_sym_and] = ACTIONS(6416),
    [anon_sym_let] = ACTIONS(6416),
    [anon_sym_let_BANG] = ACTIONS(6414),
    [aux_sym_access_modifier_token1] = ACTIONS(6414),
    [anon_sym_LPAREN] = ACTIONS(6416),
    [anon_sym_null] = ACTIONS(6416),
    [anon_sym_AMP] = ACTIONS(6416),
    [anon_sym_LBRACK] = ACTIONS(6416),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6414),
    [anon_sym_LBRACE] = ACTIONS(6416),
    [anon_sym_LT_AT] = ACTIONS(6416),
    [anon_sym_LT_AT_AT] = ACTIONS(6414),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6414),
    [anon_sym_new] = ACTIONS(6416),
    [anon_sym_return_BANG] = ACTIONS(6414),
    [anon_sym_yield] = ACTIONS(6416),
    [anon_sym_yield_BANG] = ACTIONS(6414),
    [anon_sym_lazy] = ACTIONS(6416),
    [anon_sym_assert] = ACTIONS(6416),
    [anon_sym_upcast] = ACTIONS(6416),
    [anon_sym_downcast] = ACTIONS(6416),
    [anon_sym_for] = ACTIONS(6416),
    [anon_sym_while] = ACTIONS(6416),
    [anon_sym_if] = ACTIONS(6416),
    [anon_sym_fun] = ACTIONS(6416),
    [anon_sym_try] = ACTIONS(6416),
    [anon_sym_match] = ACTIONS(6416),
    [anon_sym_match_BANG] = ACTIONS(6414),
    [anon_sym_function] = ACTIONS(6416),
    [anon_sym_use] = ACTIONS(6416),
    [anon_sym_use_BANG] = ACTIONS(6414),
    [anon_sym_do_BANG] = ACTIONS(6414),
    [anon_sym_begin] = ACTIONS(6416),
    [anon_sym_default] = ACTIONS(6416),
    [anon_sym_static] = ACTIONS(6416),
    [anon_sym_member] = ACTIONS(6416),
    [anon_sym_interface] = ACTIONS(6416),
    [anon_sym_exception] = ACTIONS(6416),
    [anon_sym_abstract] = ACTIONS(6416),
    [anon_sym_val] = ACTIONS(6416),
    [anon_sym_override] = ACTIONS(6416),
    [aux_sym_char_token1] = ACTIONS(6414),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6416),
    [anon_sym_DQUOTE] = ACTIONS(6416),
    [anon_sym_AT_DQUOTE] = ACTIONS(6414),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6414),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6414),
    [sym_bool] = ACTIONS(6416),
    [sym_unit] = ACTIONS(6414),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6416),
    [sym_op_identifier] = ACTIONS(6414),
    [anon_sym_PLUS] = ACTIONS(6416),
    [anon_sym_DASH] = ACTIONS(6416),
    [anon_sym_PLUS_DOT] = ACTIONS(6414),
    [anon_sym_DASH_DOT] = ACTIONS(6414),
    [anon_sym_PERCENT] = ACTIONS(6414),
    [anon_sym_AMP_AMP] = ACTIONS(6414),
    [anon_sym_TILDE] = ACTIONS(6414),
    [aux_sym_prefix_op_token1] = ACTIONS(6414),
    [sym_int] = ACTIONS(6416),
    [sym_xint] = ACTIONS(6414),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6414),
    [anon_sym_POUNDload] = ACTIONS(6414),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6414),
  },
  [3845] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8272),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1638),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3845),
    [sym_compiler_directive_decl] = STATE(3845),
    [sym_fsi_directive_decl] = STATE(3845),
    [sym_preproc_line] = STATE(3845),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3846] = {
    [sym_block_comment] = STATE(3846),
    [sym_compiler_directive_decl] = STATE(3846),
    [sym_fsi_directive_decl] = STATE(3846),
    [sym_preproc_line] = STATE(3846),
    [ts_builtin_sym_end] = ACTIONS(6418),
    [sym_identifier] = ACTIONS(6420),
    [anon_sym_namespace] = ACTIONS(6420),
    [anon_sym_module] = ACTIONS(6420),
    [anon_sym_open] = ACTIONS(6420),
    [anon_sym_LBRACK_LT] = ACTIONS(6418),
    [anon_sym_return] = ACTIONS(6420),
    [anon_sym_type] = ACTIONS(6420),
    [anon_sym_do] = ACTIONS(6420),
    [anon_sym_and] = ACTIONS(6420),
    [anon_sym_let] = ACTIONS(6420),
    [anon_sym_let_BANG] = ACTIONS(6418),
    [aux_sym_access_modifier_token1] = ACTIONS(6418),
    [anon_sym_LPAREN] = ACTIONS(6420),
    [anon_sym_null] = ACTIONS(6420),
    [anon_sym_AMP] = ACTIONS(6420),
    [anon_sym_LBRACK] = ACTIONS(6420),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6418),
    [anon_sym_LBRACE] = ACTIONS(6420),
    [anon_sym_LT_AT] = ACTIONS(6420),
    [anon_sym_LT_AT_AT] = ACTIONS(6418),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6418),
    [anon_sym_new] = ACTIONS(6420),
    [anon_sym_return_BANG] = ACTIONS(6418),
    [anon_sym_yield] = ACTIONS(6420),
    [anon_sym_yield_BANG] = ACTIONS(6418),
    [anon_sym_lazy] = ACTIONS(6420),
    [anon_sym_assert] = ACTIONS(6420),
    [anon_sym_upcast] = ACTIONS(6420),
    [anon_sym_downcast] = ACTIONS(6420),
    [anon_sym_for] = ACTIONS(6420),
    [anon_sym_while] = ACTIONS(6420),
    [anon_sym_if] = ACTIONS(6420),
    [anon_sym_fun] = ACTIONS(6420),
    [anon_sym_try] = ACTIONS(6420),
    [anon_sym_match] = ACTIONS(6420),
    [anon_sym_match_BANG] = ACTIONS(6418),
    [anon_sym_function] = ACTIONS(6420),
    [anon_sym_use] = ACTIONS(6420),
    [anon_sym_use_BANG] = ACTIONS(6418),
    [anon_sym_do_BANG] = ACTIONS(6418),
    [anon_sym_begin] = ACTIONS(6420),
    [anon_sym_default] = ACTIONS(6420),
    [anon_sym_static] = ACTIONS(6420),
    [anon_sym_member] = ACTIONS(6420),
    [anon_sym_interface] = ACTIONS(6420),
    [anon_sym_exception] = ACTIONS(6420),
    [anon_sym_abstract] = ACTIONS(6420),
    [anon_sym_val] = ACTIONS(6420),
    [anon_sym_override] = ACTIONS(6420),
    [aux_sym_char_token1] = ACTIONS(6418),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6420),
    [anon_sym_DQUOTE] = ACTIONS(6420),
    [anon_sym_AT_DQUOTE] = ACTIONS(6418),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6418),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6418),
    [sym_bool] = ACTIONS(6420),
    [sym_unit] = ACTIONS(6418),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6420),
    [sym_op_identifier] = ACTIONS(6418),
    [anon_sym_PLUS] = ACTIONS(6420),
    [anon_sym_DASH] = ACTIONS(6420),
    [anon_sym_PLUS_DOT] = ACTIONS(6418),
    [anon_sym_DASH_DOT] = ACTIONS(6418),
    [anon_sym_PERCENT] = ACTIONS(6418),
    [anon_sym_AMP_AMP] = ACTIONS(6418),
    [anon_sym_TILDE] = ACTIONS(6418),
    [aux_sym_prefix_op_token1] = ACTIONS(6418),
    [sym_int] = ACTIONS(6420),
    [sym_xint] = ACTIONS(6418),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6418),
    [anon_sym_POUNDload] = ACTIONS(6418),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6418),
  },
  [3847] = {
    [sym_block_comment] = STATE(3847),
    [sym_compiler_directive_decl] = STATE(3847),
    [sym_fsi_directive_decl] = STATE(3847),
    [sym_preproc_line] = STATE(3847),
    [ts_builtin_sym_end] = ACTIONS(2690),
    [sym_identifier] = ACTIONS(2692),
    [anon_sym_namespace] = ACTIONS(2692),
    [anon_sym_module] = ACTIONS(2692),
    [anon_sym_open] = ACTIONS(2692),
    [anon_sym_LBRACK_LT] = ACTIONS(2690),
    [anon_sym_return] = ACTIONS(2692),
    [anon_sym_type] = ACTIONS(2692),
    [anon_sym_do] = ACTIONS(2692),
    [anon_sym_and] = ACTIONS(2692),
    [anon_sym_let] = ACTIONS(2692),
    [anon_sym_let_BANG] = ACTIONS(2690),
    [aux_sym_access_modifier_token1] = ACTIONS(2690),
    [anon_sym_LPAREN] = ACTIONS(2692),
    [anon_sym_null] = ACTIONS(2692),
    [anon_sym_AMP] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2692),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2690),
    [anon_sym_LBRACE] = ACTIONS(2692),
    [anon_sym_LT_AT] = ACTIONS(2692),
    [anon_sym_LT_AT_AT] = ACTIONS(2690),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2690),
    [anon_sym_new] = ACTIONS(2692),
    [anon_sym_return_BANG] = ACTIONS(2690),
    [anon_sym_yield] = ACTIONS(2692),
    [anon_sym_yield_BANG] = ACTIONS(2690),
    [anon_sym_lazy] = ACTIONS(2692),
    [anon_sym_assert] = ACTIONS(2692),
    [anon_sym_upcast] = ACTIONS(2692),
    [anon_sym_downcast] = ACTIONS(2692),
    [anon_sym_for] = ACTIONS(2692),
    [anon_sym_while] = ACTIONS(2692),
    [anon_sym_if] = ACTIONS(2692),
    [anon_sym_fun] = ACTIONS(2692),
    [anon_sym_try] = ACTIONS(2692),
    [anon_sym_match] = ACTIONS(2692),
    [anon_sym_match_BANG] = ACTIONS(2690),
    [anon_sym_function] = ACTIONS(2692),
    [anon_sym_use] = ACTIONS(2692),
    [anon_sym_use_BANG] = ACTIONS(2690),
    [anon_sym_do_BANG] = ACTIONS(2690),
    [anon_sym_begin] = ACTIONS(2692),
    [anon_sym_default] = ACTIONS(2692),
    [anon_sym_static] = ACTIONS(2692),
    [anon_sym_member] = ACTIONS(2692),
    [anon_sym_interface] = ACTIONS(2692),
    [anon_sym_exception] = ACTIONS(2692),
    [anon_sym_abstract] = ACTIONS(2692),
    [anon_sym_val] = ACTIONS(2692),
    [anon_sym_override] = ACTIONS(2692),
    [aux_sym_char_token1] = ACTIONS(2690),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2692),
    [anon_sym_DQUOTE] = ACTIONS(2692),
    [anon_sym_AT_DQUOTE] = ACTIONS(2690),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2690),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2690),
    [sym_bool] = ACTIONS(2692),
    [sym_unit] = ACTIONS(2690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2692),
    [sym_op_identifier] = ACTIONS(2690),
    [anon_sym_PLUS] = ACTIONS(2692),
    [anon_sym_DASH] = ACTIONS(2692),
    [anon_sym_PLUS_DOT] = ACTIONS(2690),
    [anon_sym_DASH_DOT] = ACTIONS(2690),
    [anon_sym_PERCENT] = ACTIONS(2690),
    [anon_sym_AMP_AMP] = ACTIONS(2690),
    [anon_sym_TILDE] = ACTIONS(2690),
    [aux_sym_prefix_op_token1] = ACTIONS(2690),
    [sym_int] = ACTIONS(2692),
    [sym_xint] = ACTIONS(2690),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2690),
    [anon_sym_POUNDload] = ACTIONS(2690),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2690),
  },
  [3848] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8378),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3848),
    [sym_compiler_directive_decl] = STATE(3848),
    [sym_fsi_directive_decl] = STATE(3848),
    [sym_preproc_line] = STATE(3848),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_RPAREN] = ACTIONS(6422),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3849] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3849),
    [sym_compiler_directive_decl] = STATE(3849),
    [sym_fsi_directive_decl] = STATE(3849),
    [sym_preproc_line] = STATE(3849),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3742),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3850] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8061),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1660),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3850),
    [sym_compiler_directive_decl] = STATE(3850),
    [sym_fsi_directive_decl] = STATE(3850),
    [sym_preproc_line] = STATE(3850),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3851] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8409),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3851),
    [sym_compiler_directive_decl] = STATE(3851),
    [sym_fsi_directive_decl] = STATE(3851),
    [sym_preproc_line] = STATE(3851),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_RPAREN] = ACTIONS(6424),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3852] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8061),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1641),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3852),
    [sym_compiler_directive_decl] = STATE(3852),
    [sym_fsi_directive_decl] = STATE(3852),
    [sym_preproc_line] = STATE(3852),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3853] = {
    [sym_block_comment] = STATE(3853),
    [sym_compiler_directive_decl] = STATE(3853),
    [sym_fsi_directive_decl] = STATE(3853),
    [sym_preproc_line] = STATE(3853),
    [ts_builtin_sym_end] = ACTIONS(6426),
    [sym_identifier] = ACTIONS(6428),
    [anon_sym_namespace] = ACTIONS(6428),
    [anon_sym_module] = ACTIONS(6428),
    [anon_sym_open] = ACTIONS(6428),
    [anon_sym_LBRACK_LT] = ACTIONS(6426),
    [anon_sym_return] = ACTIONS(6428),
    [anon_sym_type] = ACTIONS(6428),
    [anon_sym_do] = ACTIONS(6428),
    [anon_sym_and] = ACTIONS(6428),
    [anon_sym_let] = ACTIONS(6428),
    [anon_sym_let_BANG] = ACTIONS(6426),
    [aux_sym_access_modifier_token1] = ACTIONS(6426),
    [anon_sym_LPAREN] = ACTIONS(6428),
    [anon_sym_null] = ACTIONS(6428),
    [anon_sym_AMP] = ACTIONS(6428),
    [anon_sym_LBRACK] = ACTIONS(6428),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6426),
    [anon_sym_LBRACE] = ACTIONS(6428),
    [anon_sym_LT_AT] = ACTIONS(6428),
    [anon_sym_LT_AT_AT] = ACTIONS(6426),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6426),
    [anon_sym_new] = ACTIONS(6428),
    [anon_sym_return_BANG] = ACTIONS(6426),
    [anon_sym_yield] = ACTIONS(6428),
    [anon_sym_yield_BANG] = ACTIONS(6426),
    [anon_sym_lazy] = ACTIONS(6428),
    [anon_sym_assert] = ACTIONS(6428),
    [anon_sym_upcast] = ACTIONS(6428),
    [anon_sym_downcast] = ACTIONS(6428),
    [anon_sym_for] = ACTIONS(6428),
    [anon_sym_while] = ACTIONS(6428),
    [anon_sym_if] = ACTIONS(6428),
    [anon_sym_fun] = ACTIONS(6428),
    [anon_sym_try] = ACTIONS(6428),
    [anon_sym_match] = ACTIONS(6428),
    [anon_sym_match_BANG] = ACTIONS(6426),
    [anon_sym_function] = ACTIONS(6428),
    [anon_sym_use] = ACTIONS(6428),
    [anon_sym_use_BANG] = ACTIONS(6426),
    [anon_sym_do_BANG] = ACTIONS(6426),
    [anon_sym_begin] = ACTIONS(6428),
    [anon_sym_default] = ACTIONS(6428),
    [anon_sym_static] = ACTIONS(6428),
    [anon_sym_member] = ACTIONS(6428),
    [anon_sym_interface] = ACTIONS(6428),
    [anon_sym_exception] = ACTIONS(6428),
    [anon_sym_abstract] = ACTIONS(6428),
    [anon_sym_val] = ACTIONS(6428),
    [anon_sym_override] = ACTIONS(6428),
    [aux_sym_char_token1] = ACTIONS(6426),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6428),
    [anon_sym_DQUOTE] = ACTIONS(6428),
    [anon_sym_AT_DQUOTE] = ACTIONS(6426),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6426),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6426),
    [sym_bool] = ACTIONS(6428),
    [sym_unit] = ACTIONS(6426),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6428),
    [sym_op_identifier] = ACTIONS(6426),
    [anon_sym_PLUS] = ACTIONS(6428),
    [anon_sym_DASH] = ACTIONS(6428),
    [anon_sym_PLUS_DOT] = ACTIONS(6426),
    [anon_sym_DASH_DOT] = ACTIONS(6426),
    [anon_sym_PERCENT] = ACTIONS(6426),
    [anon_sym_AMP_AMP] = ACTIONS(6426),
    [anon_sym_TILDE] = ACTIONS(6426),
    [aux_sym_prefix_op_token1] = ACTIONS(6426),
    [sym_int] = ACTIONS(6428),
    [sym_xint] = ACTIONS(6426),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6426),
    [anon_sym_POUNDload] = ACTIONS(6426),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6426),
  },
  [3854] = {
    [sym_block_comment] = STATE(3854),
    [sym_compiler_directive_decl] = STATE(3854),
    [sym_fsi_directive_decl] = STATE(3854),
    [sym_preproc_line] = STATE(3854),
    [ts_builtin_sym_end] = ACTIONS(6430),
    [sym_identifier] = ACTIONS(6432),
    [anon_sym_namespace] = ACTIONS(6432),
    [anon_sym_module] = ACTIONS(6432),
    [anon_sym_open] = ACTIONS(6432),
    [anon_sym_LBRACK_LT] = ACTIONS(6430),
    [anon_sym_return] = ACTIONS(6432),
    [anon_sym_type] = ACTIONS(6432),
    [anon_sym_do] = ACTIONS(6432),
    [anon_sym_and] = ACTIONS(6432),
    [anon_sym_let] = ACTIONS(6432),
    [anon_sym_let_BANG] = ACTIONS(6430),
    [aux_sym_access_modifier_token1] = ACTIONS(6430),
    [anon_sym_LPAREN] = ACTIONS(6432),
    [anon_sym_null] = ACTIONS(6432),
    [anon_sym_AMP] = ACTIONS(6432),
    [anon_sym_LBRACK] = ACTIONS(6432),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6430),
    [anon_sym_LBRACE] = ACTIONS(6432),
    [anon_sym_LT_AT] = ACTIONS(6432),
    [anon_sym_LT_AT_AT] = ACTIONS(6430),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6430),
    [anon_sym_new] = ACTIONS(6432),
    [anon_sym_return_BANG] = ACTIONS(6430),
    [anon_sym_yield] = ACTIONS(6432),
    [anon_sym_yield_BANG] = ACTIONS(6430),
    [anon_sym_lazy] = ACTIONS(6432),
    [anon_sym_assert] = ACTIONS(6432),
    [anon_sym_upcast] = ACTIONS(6432),
    [anon_sym_downcast] = ACTIONS(6432),
    [anon_sym_for] = ACTIONS(6432),
    [anon_sym_while] = ACTIONS(6432),
    [anon_sym_if] = ACTIONS(6432),
    [anon_sym_fun] = ACTIONS(6432),
    [anon_sym_try] = ACTIONS(6432),
    [anon_sym_match] = ACTIONS(6432),
    [anon_sym_match_BANG] = ACTIONS(6430),
    [anon_sym_function] = ACTIONS(6432),
    [anon_sym_use] = ACTIONS(6432),
    [anon_sym_use_BANG] = ACTIONS(6430),
    [anon_sym_do_BANG] = ACTIONS(6430),
    [anon_sym_begin] = ACTIONS(6432),
    [anon_sym_default] = ACTIONS(6432),
    [anon_sym_static] = ACTIONS(6432),
    [anon_sym_member] = ACTIONS(6432),
    [anon_sym_interface] = ACTIONS(6432),
    [anon_sym_exception] = ACTIONS(6432),
    [anon_sym_abstract] = ACTIONS(6432),
    [anon_sym_val] = ACTIONS(6432),
    [anon_sym_override] = ACTIONS(6432),
    [aux_sym_char_token1] = ACTIONS(6430),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6432),
    [anon_sym_DQUOTE] = ACTIONS(6432),
    [anon_sym_AT_DQUOTE] = ACTIONS(6430),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6430),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6430),
    [sym_bool] = ACTIONS(6432),
    [sym_unit] = ACTIONS(6430),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6432),
    [sym_op_identifier] = ACTIONS(6430),
    [anon_sym_PLUS] = ACTIONS(6432),
    [anon_sym_DASH] = ACTIONS(6432),
    [anon_sym_PLUS_DOT] = ACTIONS(6430),
    [anon_sym_DASH_DOT] = ACTIONS(6430),
    [anon_sym_PERCENT] = ACTIONS(6430),
    [anon_sym_AMP_AMP] = ACTIONS(6430),
    [anon_sym_TILDE] = ACTIONS(6430),
    [aux_sym_prefix_op_token1] = ACTIONS(6430),
    [sym_int] = ACTIONS(6432),
    [sym_xint] = ACTIONS(6430),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6430),
    [anon_sym_POUNDload] = ACTIONS(6430),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6430),
  },
  [3855] = {
    [sym_attributes] = STATE(3905),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(8258),
    [sym__pattern] = STATE(8070),
    [sym_optional_pattern] = STATE(8258),
    [sym_type_check_pattern] = STATE(8258),
    [sym_attribute_pattern] = STATE(8258),
    [sym_paren_pattern] = STATE(8258),
    [sym_as_pattern] = STATE(8258),
    [sym_cons_pattern] = STATE(8258),
    [sym_disjunct_pattern] = STATE(8258),
    [sym_conjunct_pattern] = STATE(8258),
    [sym_typed_pattern] = STATE(8258),
    [sym_list_pattern] = STATE(8258),
    [sym_array_pattern] = STATE(8258),
    [sym_record_pattern] = STATE(8258),
    [sym_named_field] = STATE(8987),
    [sym_named_field_pattern] = STATE(8258),
    [sym_identifier_pattern] = STATE(8258),
    [sym_long_identifier_or_op] = STATE(2968),
    [sym_char] = STATE(8017),
    [sym_format_string] = STATE(8065),
    [sym__string_literal] = STATE(8065),
    [sym_string] = STATE(8017),
    [sym_verbatim_string] = STATE(8017),
    [sym_bytearray] = STATE(8017),
    [sym_verbatim_bytearray] = STATE(8017),
    [sym_format_triple_quoted_string] = STATE(8066),
    [sym_triple_quoted_string] = STATE(8017),
    [sym_const] = STATE(8258),
    [sym_long_identifier] = STATE(4907),
    [sym_active_pattern] = STATE(5059),
    [sym__identifier_or_op] = STATE(4927),
    [sym_sbyte] = STATE(8017),
    [sym_byte] = STATE(8017),
    [sym_int16] = STATE(8017),
    [sym_uint16] = STATE(8017),
    [sym_int32] = STATE(8017),
    [sym_uint32] = STATE(8017),
    [sym_nativeint] = STATE(8017),
    [sym_unativeint] = STATE(8017),
    [sym_int64] = STATE(8017),
    [sym_uint64] = STATE(8017),
    [sym_ieee32] = STATE(8017),
    [sym_ieee64] = STATE(8017),
    [sym_bignum] = STATE(8017),
    [sym_decimal] = STATE(8017),
    [sym_float] = STATE(7544),
    [sym_block_comment] = STATE(3855),
    [sym_compiler_directive_decl] = STATE(3855),
    [sym_fsi_directive_decl] = STATE(3855),
    [sym_preproc_line] = STATE(3855),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(6298),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5492),
    [anon_sym_null] = ACTIONS(5494),
    [anon_sym__] = ACTIONS(5496),
    [anon_sym_QMARK] = ACTIONS(5498),
    [anon_sym_COLON_QMARK] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5502),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5504),
    [anon_sym_LBRACE] = ACTIONS(5506),
    [aux_sym_char_token1] = ACTIONS(5508),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5510),
    [anon_sym_DQUOTE] = ACTIONS(5512),
    [anon_sym_AT_DQUOTE] = ACTIONS(5514),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5516),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5518),
    [sym_bool] = ACTIONS(5520),
    [sym_unit] = ACTIONS(5522),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5524),
    [sym_op_identifier] = ACTIONS(5526),
    [sym_int] = ACTIONS(5528),
    [sym_xint] = ACTIONS(5530),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3856] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8061),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1590),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3856),
    [sym_compiler_directive_decl] = STATE(3856),
    [sym_fsi_directive_decl] = STATE(3856),
    [sym_preproc_line] = STATE(3856),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3857] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8182),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2630),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3857),
    [sym_compiler_directive_decl] = STATE(3857),
    [sym_fsi_directive_decl] = STATE(3857),
    [sym_preproc_line] = STATE(3857),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3858] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3858),
    [sym_compiler_directive_decl] = STATE(3858),
    [sym_fsi_directive_decl] = STATE(3858),
    [sym_preproc_line] = STATE(3858),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3739),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3859] = {
    [sym_block_comment] = STATE(3859),
    [sym_compiler_directive_decl] = STATE(3859),
    [sym_fsi_directive_decl] = STATE(3859),
    [sym_preproc_line] = STATE(3859),
    [ts_builtin_sym_end] = ACTIONS(6434),
    [sym_identifier] = ACTIONS(6436),
    [anon_sym_namespace] = ACTIONS(6436),
    [anon_sym_module] = ACTIONS(6436),
    [anon_sym_open] = ACTIONS(6436),
    [anon_sym_LBRACK_LT] = ACTIONS(6434),
    [anon_sym_return] = ACTIONS(6436),
    [anon_sym_type] = ACTIONS(6436),
    [anon_sym_do] = ACTIONS(6436),
    [anon_sym_and] = ACTIONS(6436),
    [anon_sym_let] = ACTIONS(6436),
    [anon_sym_let_BANG] = ACTIONS(6434),
    [aux_sym_access_modifier_token1] = ACTIONS(6434),
    [anon_sym_LPAREN] = ACTIONS(6436),
    [anon_sym_null] = ACTIONS(6436),
    [anon_sym_AMP] = ACTIONS(6436),
    [anon_sym_LBRACK] = ACTIONS(6436),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6434),
    [anon_sym_LBRACE] = ACTIONS(6436),
    [anon_sym_LT_AT] = ACTIONS(6436),
    [anon_sym_LT_AT_AT] = ACTIONS(6434),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6434),
    [anon_sym_new] = ACTIONS(6436),
    [anon_sym_return_BANG] = ACTIONS(6434),
    [anon_sym_yield] = ACTIONS(6436),
    [anon_sym_yield_BANG] = ACTIONS(6434),
    [anon_sym_lazy] = ACTIONS(6436),
    [anon_sym_assert] = ACTIONS(6436),
    [anon_sym_upcast] = ACTIONS(6436),
    [anon_sym_downcast] = ACTIONS(6436),
    [anon_sym_for] = ACTIONS(6436),
    [anon_sym_while] = ACTIONS(6436),
    [anon_sym_if] = ACTIONS(6436),
    [anon_sym_fun] = ACTIONS(6436),
    [anon_sym_try] = ACTIONS(6436),
    [anon_sym_match] = ACTIONS(6436),
    [anon_sym_match_BANG] = ACTIONS(6434),
    [anon_sym_function] = ACTIONS(6436),
    [anon_sym_use] = ACTIONS(6436),
    [anon_sym_use_BANG] = ACTIONS(6434),
    [anon_sym_do_BANG] = ACTIONS(6434),
    [anon_sym_begin] = ACTIONS(6436),
    [anon_sym_default] = ACTIONS(6436),
    [anon_sym_static] = ACTIONS(6436),
    [anon_sym_member] = ACTIONS(6436),
    [anon_sym_interface] = ACTIONS(6436),
    [anon_sym_exception] = ACTIONS(6436),
    [anon_sym_abstract] = ACTIONS(6436),
    [anon_sym_val] = ACTIONS(6436),
    [anon_sym_override] = ACTIONS(6436),
    [aux_sym_char_token1] = ACTIONS(6434),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6436),
    [anon_sym_DQUOTE] = ACTIONS(6436),
    [anon_sym_AT_DQUOTE] = ACTIONS(6434),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6434),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6434),
    [sym_bool] = ACTIONS(6436),
    [sym_unit] = ACTIONS(6434),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6436),
    [sym_op_identifier] = ACTIONS(6434),
    [anon_sym_PLUS] = ACTIONS(6436),
    [anon_sym_DASH] = ACTIONS(6436),
    [anon_sym_PLUS_DOT] = ACTIONS(6434),
    [anon_sym_DASH_DOT] = ACTIONS(6434),
    [anon_sym_PERCENT] = ACTIONS(6434),
    [anon_sym_AMP_AMP] = ACTIONS(6434),
    [anon_sym_TILDE] = ACTIONS(6434),
    [aux_sym_prefix_op_token1] = ACTIONS(6434),
    [sym_int] = ACTIONS(6436),
    [sym_xint] = ACTIONS(6434),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6434),
    [anon_sym_POUNDload] = ACTIONS(6434),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6434),
  },
  [3860] = {
    [sym_block_comment] = STATE(3860),
    [sym_compiler_directive_decl] = STATE(3860),
    [sym_fsi_directive_decl] = STATE(3860),
    [sym_preproc_line] = STATE(3860),
    [ts_builtin_sym_end] = ACTIONS(6438),
    [sym_identifier] = ACTIONS(6440),
    [anon_sym_namespace] = ACTIONS(6440),
    [anon_sym_module] = ACTIONS(6440),
    [anon_sym_open] = ACTIONS(6440),
    [anon_sym_LBRACK_LT] = ACTIONS(6438),
    [anon_sym_return] = ACTIONS(6440),
    [anon_sym_type] = ACTIONS(6440),
    [anon_sym_do] = ACTIONS(6440),
    [anon_sym_and] = ACTIONS(6440),
    [anon_sym_let] = ACTIONS(6440),
    [anon_sym_let_BANG] = ACTIONS(6438),
    [aux_sym_access_modifier_token1] = ACTIONS(6438),
    [anon_sym_LPAREN] = ACTIONS(6440),
    [anon_sym_null] = ACTIONS(6440),
    [anon_sym_AMP] = ACTIONS(6440),
    [anon_sym_LBRACK] = ACTIONS(6440),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6438),
    [anon_sym_LBRACE] = ACTIONS(6440),
    [anon_sym_LT_AT] = ACTIONS(6440),
    [anon_sym_LT_AT_AT] = ACTIONS(6438),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6438),
    [anon_sym_new] = ACTIONS(6440),
    [anon_sym_return_BANG] = ACTIONS(6438),
    [anon_sym_yield] = ACTIONS(6440),
    [anon_sym_yield_BANG] = ACTIONS(6438),
    [anon_sym_lazy] = ACTIONS(6440),
    [anon_sym_assert] = ACTIONS(6440),
    [anon_sym_upcast] = ACTIONS(6440),
    [anon_sym_downcast] = ACTIONS(6440),
    [anon_sym_for] = ACTIONS(6440),
    [anon_sym_while] = ACTIONS(6440),
    [anon_sym_if] = ACTIONS(6440),
    [anon_sym_fun] = ACTIONS(6440),
    [anon_sym_try] = ACTIONS(6440),
    [anon_sym_match] = ACTIONS(6440),
    [anon_sym_match_BANG] = ACTIONS(6438),
    [anon_sym_function] = ACTIONS(6440),
    [anon_sym_use] = ACTIONS(6440),
    [anon_sym_use_BANG] = ACTIONS(6438),
    [anon_sym_do_BANG] = ACTIONS(6438),
    [anon_sym_begin] = ACTIONS(6440),
    [anon_sym_default] = ACTIONS(6440),
    [anon_sym_static] = ACTIONS(6440),
    [anon_sym_member] = ACTIONS(6440),
    [anon_sym_interface] = ACTIONS(6440),
    [anon_sym_exception] = ACTIONS(6440),
    [anon_sym_abstract] = ACTIONS(6440),
    [anon_sym_val] = ACTIONS(6440),
    [anon_sym_override] = ACTIONS(6440),
    [aux_sym_char_token1] = ACTIONS(6438),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6440),
    [anon_sym_DQUOTE] = ACTIONS(6440),
    [anon_sym_AT_DQUOTE] = ACTIONS(6438),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6438),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6438),
    [sym_bool] = ACTIONS(6440),
    [sym_unit] = ACTIONS(6438),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6440),
    [sym_op_identifier] = ACTIONS(6438),
    [anon_sym_PLUS] = ACTIONS(6440),
    [anon_sym_DASH] = ACTIONS(6440),
    [anon_sym_PLUS_DOT] = ACTIONS(6438),
    [anon_sym_DASH_DOT] = ACTIONS(6438),
    [anon_sym_PERCENT] = ACTIONS(6438),
    [anon_sym_AMP_AMP] = ACTIONS(6438),
    [anon_sym_TILDE] = ACTIONS(6438),
    [aux_sym_prefix_op_token1] = ACTIONS(6438),
    [sym_int] = ACTIONS(6440),
    [sym_xint] = ACTIONS(6438),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6438),
    [anon_sym_POUNDload] = ACTIONS(6438),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6438),
  },
  [3861] = {
    [sym_attributes] = STATE(3905),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(8258),
    [sym__pattern] = STATE(8236),
    [sym_optional_pattern] = STATE(8258),
    [sym_type_check_pattern] = STATE(8258),
    [sym_attribute_pattern] = STATE(8258),
    [sym_paren_pattern] = STATE(8258),
    [sym_as_pattern] = STATE(8258),
    [sym_cons_pattern] = STATE(8258),
    [sym_disjunct_pattern] = STATE(8258),
    [sym_conjunct_pattern] = STATE(8258),
    [sym_typed_pattern] = STATE(8258),
    [sym_list_pattern] = STATE(8258),
    [sym_array_pattern] = STATE(8258),
    [sym_record_pattern] = STATE(8258),
    [sym_named_field] = STATE(9154),
    [sym_named_field_pattern] = STATE(8258),
    [sym_identifier_pattern] = STATE(8258),
    [sym_long_identifier_or_op] = STATE(2968),
    [sym_char] = STATE(8017),
    [sym_format_string] = STATE(8065),
    [sym__string_literal] = STATE(8065),
    [sym_string] = STATE(8017),
    [sym_verbatim_string] = STATE(8017),
    [sym_bytearray] = STATE(8017),
    [sym_verbatim_bytearray] = STATE(8017),
    [sym_format_triple_quoted_string] = STATE(8066),
    [sym_triple_quoted_string] = STATE(8017),
    [sym_const] = STATE(8258),
    [sym_long_identifier] = STATE(4907),
    [sym_active_pattern] = STATE(5059),
    [sym__identifier_or_op] = STATE(4927),
    [sym_sbyte] = STATE(8017),
    [sym_byte] = STATE(8017),
    [sym_int16] = STATE(8017),
    [sym_uint16] = STATE(8017),
    [sym_int32] = STATE(8017),
    [sym_uint32] = STATE(8017),
    [sym_nativeint] = STATE(8017),
    [sym_unativeint] = STATE(8017),
    [sym_int64] = STATE(8017),
    [sym_uint64] = STATE(8017),
    [sym_ieee32] = STATE(8017),
    [sym_ieee64] = STATE(8017),
    [sym_bignum] = STATE(8017),
    [sym_decimal] = STATE(8017),
    [sym_float] = STATE(7544),
    [sym_block_comment] = STATE(3861),
    [sym_compiler_directive_decl] = STATE(3861),
    [sym_fsi_directive_decl] = STATE(3861),
    [sym_preproc_line] = STATE(3861),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(6298),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5492),
    [anon_sym_null] = ACTIONS(5494),
    [anon_sym__] = ACTIONS(5496),
    [anon_sym_QMARK] = ACTIONS(5498),
    [anon_sym_COLON_QMARK] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5502),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5504),
    [anon_sym_LBRACE] = ACTIONS(5506),
    [aux_sym_char_token1] = ACTIONS(5508),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5510),
    [anon_sym_DQUOTE] = ACTIONS(5512),
    [anon_sym_AT_DQUOTE] = ACTIONS(5514),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5516),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5518),
    [sym_bool] = ACTIONS(5520),
    [sym_unit] = ACTIONS(5522),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5524),
    [sym_op_identifier] = ACTIONS(5526),
    [sym_int] = ACTIONS(5528),
    [sym_xint] = ACTIONS(5530),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3862] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8245),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1306),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3862),
    [sym_compiler_directive_decl] = STATE(3862),
    [sym_fsi_directive_decl] = STATE(3862),
    [sym_preproc_line] = STATE(3862),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3863] = {
    [sym_block_comment] = STATE(3863),
    [sym_compiler_directive_decl] = STATE(3863),
    [sym_fsi_directive_decl] = STATE(3863),
    [sym_preproc_line] = STATE(3863),
    [ts_builtin_sym_end] = ACTIONS(6442),
    [sym_identifier] = ACTIONS(6444),
    [anon_sym_namespace] = ACTIONS(6444),
    [anon_sym_module] = ACTIONS(6444),
    [anon_sym_open] = ACTIONS(6444),
    [anon_sym_LBRACK_LT] = ACTIONS(6442),
    [anon_sym_return] = ACTIONS(6444),
    [anon_sym_type] = ACTIONS(6444),
    [anon_sym_do] = ACTIONS(6444),
    [anon_sym_and] = ACTIONS(6444),
    [anon_sym_let] = ACTIONS(6444),
    [anon_sym_let_BANG] = ACTIONS(6442),
    [aux_sym_access_modifier_token1] = ACTIONS(6442),
    [anon_sym_LPAREN] = ACTIONS(6444),
    [anon_sym_null] = ACTIONS(6444),
    [anon_sym_AMP] = ACTIONS(6444),
    [anon_sym_LBRACK] = ACTIONS(6444),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6442),
    [anon_sym_LBRACE] = ACTIONS(6444),
    [anon_sym_LT_AT] = ACTIONS(6444),
    [anon_sym_LT_AT_AT] = ACTIONS(6442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6442),
    [anon_sym_new] = ACTIONS(6444),
    [anon_sym_return_BANG] = ACTIONS(6442),
    [anon_sym_yield] = ACTIONS(6444),
    [anon_sym_yield_BANG] = ACTIONS(6442),
    [anon_sym_lazy] = ACTIONS(6444),
    [anon_sym_assert] = ACTIONS(6444),
    [anon_sym_upcast] = ACTIONS(6444),
    [anon_sym_downcast] = ACTIONS(6444),
    [anon_sym_for] = ACTIONS(6444),
    [anon_sym_while] = ACTIONS(6444),
    [anon_sym_if] = ACTIONS(6444),
    [anon_sym_fun] = ACTIONS(6444),
    [anon_sym_try] = ACTIONS(6444),
    [anon_sym_match] = ACTIONS(6444),
    [anon_sym_match_BANG] = ACTIONS(6442),
    [anon_sym_function] = ACTIONS(6444),
    [anon_sym_use] = ACTIONS(6444),
    [anon_sym_use_BANG] = ACTIONS(6442),
    [anon_sym_do_BANG] = ACTIONS(6442),
    [anon_sym_begin] = ACTIONS(6444),
    [anon_sym_default] = ACTIONS(6444),
    [anon_sym_static] = ACTIONS(6444),
    [anon_sym_member] = ACTIONS(6444),
    [anon_sym_interface] = ACTIONS(6444),
    [anon_sym_exception] = ACTIONS(6444),
    [anon_sym_abstract] = ACTIONS(6444),
    [anon_sym_val] = ACTIONS(6444),
    [anon_sym_override] = ACTIONS(6444),
    [aux_sym_char_token1] = ACTIONS(6442),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6444),
    [anon_sym_DQUOTE] = ACTIONS(6444),
    [anon_sym_AT_DQUOTE] = ACTIONS(6442),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6442),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6442),
    [sym_bool] = ACTIONS(6444),
    [sym_unit] = ACTIONS(6442),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6444),
    [sym_op_identifier] = ACTIONS(6442),
    [anon_sym_PLUS] = ACTIONS(6444),
    [anon_sym_DASH] = ACTIONS(6444),
    [anon_sym_PLUS_DOT] = ACTIONS(6442),
    [anon_sym_DASH_DOT] = ACTIONS(6442),
    [anon_sym_PERCENT] = ACTIONS(6442),
    [anon_sym_AMP_AMP] = ACTIONS(6442),
    [anon_sym_TILDE] = ACTIONS(6442),
    [aux_sym_prefix_op_token1] = ACTIONS(6442),
    [sym_int] = ACTIONS(6444),
    [sym_xint] = ACTIONS(6442),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6442),
    [anon_sym_POUNDload] = ACTIONS(6442),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6442),
  },
  [3864] = {
    [sym_block_comment] = STATE(3864),
    [sym_compiler_directive_decl] = STATE(3864),
    [sym_fsi_directive_decl] = STATE(3864),
    [sym_preproc_line] = STATE(3864),
    [ts_builtin_sym_end] = ACTIONS(6446),
    [sym_identifier] = ACTIONS(6448),
    [anon_sym_namespace] = ACTIONS(6448),
    [anon_sym_module] = ACTIONS(6448),
    [anon_sym_open] = ACTIONS(6448),
    [anon_sym_LBRACK_LT] = ACTIONS(6446),
    [anon_sym_return] = ACTIONS(6448),
    [anon_sym_type] = ACTIONS(6448),
    [anon_sym_do] = ACTIONS(6448),
    [anon_sym_and] = ACTIONS(6448),
    [anon_sym_let] = ACTIONS(6448),
    [anon_sym_let_BANG] = ACTIONS(6446),
    [aux_sym_access_modifier_token1] = ACTIONS(6446),
    [anon_sym_LPAREN] = ACTIONS(6448),
    [anon_sym_null] = ACTIONS(6448),
    [anon_sym_AMP] = ACTIONS(6448),
    [anon_sym_LBRACK] = ACTIONS(6448),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6446),
    [anon_sym_LBRACE] = ACTIONS(6448),
    [anon_sym_LT_AT] = ACTIONS(6448),
    [anon_sym_LT_AT_AT] = ACTIONS(6446),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6446),
    [anon_sym_new] = ACTIONS(6448),
    [anon_sym_return_BANG] = ACTIONS(6446),
    [anon_sym_yield] = ACTIONS(6448),
    [anon_sym_yield_BANG] = ACTIONS(6446),
    [anon_sym_lazy] = ACTIONS(6448),
    [anon_sym_assert] = ACTIONS(6448),
    [anon_sym_upcast] = ACTIONS(6448),
    [anon_sym_downcast] = ACTIONS(6448),
    [anon_sym_for] = ACTIONS(6448),
    [anon_sym_while] = ACTIONS(6448),
    [anon_sym_if] = ACTIONS(6448),
    [anon_sym_fun] = ACTIONS(6448),
    [anon_sym_try] = ACTIONS(6448),
    [anon_sym_match] = ACTIONS(6448),
    [anon_sym_match_BANG] = ACTIONS(6446),
    [anon_sym_function] = ACTIONS(6448),
    [anon_sym_use] = ACTIONS(6448),
    [anon_sym_use_BANG] = ACTIONS(6446),
    [anon_sym_do_BANG] = ACTIONS(6446),
    [anon_sym_begin] = ACTIONS(6448),
    [anon_sym_default] = ACTIONS(6448),
    [anon_sym_static] = ACTIONS(6448),
    [anon_sym_member] = ACTIONS(6448),
    [anon_sym_interface] = ACTIONS(6448),
    [anon_sym_exception] = ACTIONS(6448),
    [anon_sym_abstract] = ACTIONS(6448),
    [anon_sym_val] = ACTIONS(6448),
    [anon_sym_override] = ACTIONS(6448),
    [aux_sym_char_token1] = ACTIONS(6446),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6448),
    [anon_sym_DQUOTE] = ACTIONS(6448),
    [anon_sym_AT_DQUOTE] = ACTIONS(6446),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6446),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6446),
    [sym_bool] = ACTIONS(6448),
    [sym_unit] = ACTIONS(6446),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6448),
    [sym_op_identifier] = ACTIONS(6446),
    [anon_sym_PLUS] = ACTIONS(6448),
    [anon_sym_DASH] = ACTIONS(6448),
    [anon_sym_PLUS_DOT] = ACTIONS(6446),
    [anon_sym_DASH_DOT] = ACTIONS(6446),
    [anon_sym_PERCENT] = ACTIONS(6446),
    [anon_sym_AMP_AMP] = ACTIONS(6446),
    [anon_sym_TILDE] = ACTIONS(6446),
    [aux_sym_prefix_op_token1] = ACTIONS(6446),
    [sym_int] = ACTIONS(6448),
    [sym_xint] = ACTIONS(6446),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6446),
    [anon_sym_POUNDload] = ACTIONS(6446),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6446),
  },
  [3865] = {
    [sym_attributes] = STATE(3905),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(8258),
    [sym__pattern] = STATE(8229),
    [sym_optional_pattern] = STATE(8258),
    [sym_type_check_pattern] = STATE(8258),
    [sym_attribute_pattern] = STATE(8258),
    [sym_paren_pattern] = STATE(8258),
    [sym_as_pattern] = STATE(8258),
    [sym_cons_pattern] = STATE(8258),
    [sym_disjunct_pattern] = STATE(8258),
    [sym_conjunct_pattern] = STATE(8258),
    [sym_typed_pattern] = STATE(8258),
    [sym_list_pattern] = STATE(8258),
    [sym_array_pattern] = STATE(8258),
    [sym_record_pattern] = STATE(8258),
    [sym_named_field] = STATE(9307),
    [sym_named_field_pattern] = STATE(8258),
    [sym_identifier_pattern] = STATE(8258),
    [sym_long_identifier_or_op] = STATE(2968),
    [sym_char] = STATE(8017),
    [sym_format_string] = STATE(8065),
    [sym__string_literal] = STATE(8065),
    [sym_string] = STATE(8017),
    [sym_verbatim_string] = STATE(8017),
    [sym_bytearray] = STATE(8017),
    [sym_verbatim_bytearray] = STATE(8017),
    [sym_format_triple_quoted_string] = STATE(8066),
    [sym_triple_quoted_string] = STATE(8017),
    [sym_const] = STATE(8258),
    [sym_long_identifier] = STATE(4907),
    [sym_active_pattern] = STATE(5059),
    [sym__identifier_or_op] = STATE(4927),
    [sym_sbyte] = STATE(8017),
    [sym_byte] = STATE(8017),
    [sym_int16] = STATE(8017),
    [sym_uint16] = STATE(8017),
    [sym_int32] = STATE(8017),
    [sym_uint32] = STATE(8017),
    [sym_nativeint] = STATE(8017),
    [sym_unativeint] = STATE(8017),
    [sym_int64] = STATE(8017),
    [sym_uint64] = STATE(8017),
    [sym_ieee32] = STATE(8017),
    [sym_ieee64] = STATE(8017),
    [sym_bignum] = STATE(8017),
    [sym_decimal] = STATE(8017),
    [sym_float] = STATE(7544),
    [sym_block_comment] = STATE(3865),
    [sym_compiler_directive_decl] = STATE(3865),
    [sym_fsi_directive_decl] = STATE(3865),
    [sym_preproc_line] = STATE(3865),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(6298),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5492),
    [anon_sym_null] = ACTIONS(5494),
    [anon_sym__] = ACTIONS(5496),
    [anon_sym_QMARK] = ACTIONS(5498),
    [anon_sym_COLON_QMARK] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5502),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5504),
    [anon_sym_LBRACE] = ACTIONS(5506),
    [aux_sym_char_token1] = ACTIONS(5508),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5510),
    [anon_sym_DQUOTE] = ACTIONS(5512),
    [anon_sym_AT_DQUOTE] = ACTIONS(5514),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5516),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5518),
    [sym_bool] = ACTIONS(5520),
    [sym_unit] = ACTIONS(5522),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5524),
    [sym_op_identifier] = ACTIONS(5526),
    [sym_int] = ACTIONS(5528),
    [sym_xint] = ACTIONS(5530),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3866] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3866),
    [sym_compiler_directive_decl] = STATE(3866),
    [sym_fsi_directive_decl] = STATE(3866),
    [sym_preproc_line] = STATE(3866),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3745),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3867] = {
    [sym_attributes] = STATE(3976),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(8306),
    [sym__pattern] = STATE(7763),
    [sym_optional_pattern] = STATE(8306),
    [sym_type_check_pattern] = STATE(8306),
    [sym_attribute_pattern] = STATE(8306),
    [sym_paren_pattern] = STATE(8306),
    [sym_as_pattern] = STATE(8306),
    [sym_cons_pattern] = STATE(8306),
    [sym_disjunct_pattern] = STATE(8306),
    [sym_conjunct_pattern] = STATE(8306),
    [sym_typed_pattern] = STATE(8306),
    [sym_list_pattern] = STATE(8306),
    [sym_array_pattern] = STATE(8306),
    [sym_record_pattern] = STATE(8306),
    [sym_named_field_pattern] = STATE(8306),
    [sym_identifier_pattern] = STATE(8306),
    [sym_long_identifier_or_op] = STATE(3457),
    [sym_char] = STATE(8299),
    [sym_format_string] = STATE(8384),
    [sym__string_literal] = STATE(8384),
    [sym_string] = STATE(8299),
    [sym_verbatim_string] = STATE(8299),
    [sym_bytearray] = STATE(8299),
    [sym_verbatim_bytearray] = STATE(8299),
    [sym_format_triple_quoted_string] = STATE(8395),
    [sym_triple_quoted_string] = STATE(8299),
    [sym_const] = STATE(8306),
    [sym_long_identifier] = STATE(4953),
    [sym_active_pattern] = STATE(5117),
    [sym__identifier_or_op] = STATE(5167),
    [sym_sbyte] = STATE(8299),
    [sym_byte] = STATE(8299),
    [sym_int16] = STATE(8299),
    [sym_uint16] = STATE(8299),
    [sym_int32] = STATE(8299),
    [sym_uint32] = STATE(8299),
    [sym_nativeint] = STATE(8299),
    [sym_unativeint] = STATE(8299),
    [sym_int64] = STATE(8299),
    [sym_uint64] = STATE(8299),
    [sym_ieee32] = STATE(8299),
    [sym_ieee64] = STATE(8299),
    [sym_bignum] = STATE(8299),
    [sym_decimal] = STATE(8299),
    [sym_float] = STATE(7864),
    [sym_block_comment] = STATE(3867),
    [sym_compiler_directive_decl] = STATE(3867),
    [sym_fsi_directive_decl] = STATE(3867),
    [sym_preproc_line] = STATE(3867),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5671),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5673),
    [anon_sym_null] = ACTIONS(5675),
    [anon_sym__] = ACTIONS(5677),
    [anon_sym_QMARK] = ACTIONS(5679),
    [anon_sym_COLON_QMARK] = ACTIONS(5681),
    [anon_sym_LBRACK] = ACTIONS(5683),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5685),
    [anon_sym_LBRACE] = ACTIONS(5687),
    [aux_sym_char_token1] = ACTIONS(5689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5691),
    [anon_sym_DQUOTE] = ACTIONS(5693),
    [anon_sym_AT_DQUOTE] = ACTIONS(5695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5699),
    [sym_bool] = ACTIONS(5701),
    [sym_unit] = ACTIONS(5703),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5705),
    [sym_op_identifier] = ACTIONS(5707),
    [sym_int] = ACTIONS(5709),
    [sym_xint] = ACTIONS(5711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [sym__newline] = ACTIONS(6450),
  },
  [3868] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3868),
    [sym_compiler_directive_decl] = STATE(3868),
    [sym_fsi_directive_decl] = STATE(3868),
    [sym_preproc_line] = STATE(3868),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3747),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3869] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8182),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2757),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3869),
    [sym_compiler_directive_decl] = STATE(3869),
    [sym_fsi_directive_decl] = STATE(3869),
    [sym_preproc_line] = STATE(3869),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3870] = {
    [sym_block_comment] = STATE(3870),
    [sym_compiler_directive_decl] = STATE(3870),
    [sym_fsi_directive_decl] = STATE(3870),
    [sym_preproc_line] = STATE(3870),
    [ts_builtin_sym_end] = ACTIONS(6452),
    [sym_identifier] = ACTIONS(6454),
    [anon_sym_namespace] = ACTIONS(6454),
    [anon_sym_module] = ACTIONS(6454),
    [anon_sym_open] = ACTIONS(6454),
    [anon_sym_LBRACK_LT] = ACTIONS(6452),
    [anon_sym_return] = ACTIONS(6454),
    [anon_sym_type] = ACTIONS(6454),
    [anon_sym_do] = ACTIONS(6454),
    [anon_sym_and] = ACTIONS(6454),
    [anon_sym_let] = ACTIONS(6454),
    [anon_sym_let_BANG] = ACTIONS(6452),
    [aux_sym_access_modifier_token1] = ACTIONS(6452),
    [anon_sym_LPAREN] = ACTIONS(6454),
    [anon_sym_null] = ACTIONS(6454),
    [anon_sym_AMP] = ACTIONS(6454),
    [anon_sym_LBRACK] = ACTIONS(6454),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6452),
    [anon_sym_LBRACE] = ACTIONS(6454),
    [anon_sym_LT_AT] = ACTIONS(6454),
    [anon_sym_LT_AT_AT] = ACTIONS(6452),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6452),
    [anon_sym_new] = ACTIONS(6454),
    [anon_sym_return_BANG] = ACTIONS(6452),
    [anon_sym_yield] = ACTIONS(6454),
    [anon_sym_yield_BANG] = ACTIONS(6452),
    [anon_sym_lazy] = ACTIONS(6454),
    [anon_sym_assert] = ACTIONS(6454),
    [anon_sym_upcast] = ACTIONS(6454),
    [anon_sym_downcast] = ACTIONS(6454),
    [anon_sym_for] = ACTIONS(6454),
    [anon_sym_while] = ACTIONS(6454),
    [anon_sym_if] = ACTIONS(6454),
    [anon_sym_fun] = ACTIONS(6454),
    [anon_sym_try] = ACTIONS(6454),
    [anon_sym_match] = ACTIONS(6454),
    [anon_sym_match_BANG] = ACTIONS(6452),
    [anon_sym_function] = ACTIONS(6454),
    [anon_sym_use] = ACTIONS(6454),
    [anon_sym_use_BANG] = ACTIONS(6452),
    [anon_sym_do_BANG] = ACTIONS(6452),
    [anon_sym_begin] = ACTIONS(6454),
    [anon_sym_default] = ACTIONS(6454),
    [anon_sym_static] = ACTIONS(6454),
    [anon_sym_member] = ACTIONS(6454),
    [anon_sym_interface] = ACTIONS(6454),
    [anon_sym_exception] = ACTIONS(6454),
    [anon_sym_abstract] = ACTIONS(6454),
    [anon_sym_val] = ACTIONS(6454),
    [anon_sym_override] = ACTIONS(6454),
    [aux_sym_char_token1] = ACTIONS(6452),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6454),
    [anon_sym_DQUOTE] = ACTIONS(6454),
    [anon_sym_AT_DQUOTE] = ACTIONS(6452),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6452),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6452),
    [sym_bool] = ACTIONS(6454),
    [sym_unit] = ACTIONS(6452),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6454),
    [sym_op_identifier] = ACTIONS(6452),
    [anon_sym_PLUS] = ACTIONS(6454),
    [anon_sym_DASH] = ACTIONS(6454),
    [anon_sym_PLUS_DOT] = ACTIONS(6452),
    [anon_sym_DASH_DOT] = ACTIONS(6452),
    [anon_sym_PERCENT] = ACTIONS(6452),
    [anon_sym_AMP_AMP] = ACTIONS(6452),
    [anon_sym_TILDE] = ACTIONS(6452),
    [aux_sym_prefix_op_token1] = ACTIONS(6452),
    [sym_int] = ACTIONS(6454),
    [sym_xint] = ACTIONS(6452),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6452),
    [anon_sym_POUNDload] = ACTIONS(6452),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6452),
  },
  [3871] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8242),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2963),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3871),
    [sym_compiler_directive_decl] = STATE(3871),
    [sym_fsi_directive_decl] = STATE(3871),
    [sym_preproc_line] = STATE(3871),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3872] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8251),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(3151),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3872),
    [sym_compiler_directive_decl] = STATE(3872),
    [sym_fsi_directive_decl] = STATE(3872),
    [sym_preproc_line] = STATE(3872),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3873] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8245),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1285),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3873),
    [sym_compiler_directive_decl] = STATE(3873),
    [sym_fsi_directive_decl] = STATE(3873),
    [sym_preproc_line] = STATE(3873),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3874] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8251),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(3175),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3874),
    [sym_compiler_directive_decl] = STATE(3874),
    [sym_fsi_directive_decl] = STATE(3874),
    [sym_preproc_line] = STATE(3874),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3875] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8245),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(1252),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3875),
    [sym_compiler_directive_decl] = STATE(3875),
    [sym_fsi_directive_decl] = STATE(3875),
    [sym_preproc_line] = STATE(3875),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3876] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3876),
    [sym_compiler_directive_decl] = STATE(3876),
    [sym_fsi_directive_decl] = STATE(3876),
    [sym_preproc_line] = STATE(3876),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3753),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3877] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(5215),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3877),
    [sym_compiler_directive_decl] = STATE(3877),
    [sym_fsi_directive_decl] = STATE(3877),
    [sym_preproc_line] = STATE(3877),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [aux_sym__method_defn_repeat1] = STATE(3750),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3878] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7989),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(8848),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3878),
    [sym_compiler_directive_decl] = STATE(3878),
    [sym_fsi_directive_decl] = STATE(3878),
    [sym_preproc_line] = STATE(3878),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3879] = {
    [sym_block_comment] = STATE(3879),
    [sym_compiler_directive_decl] = STATE(3879),
    [sym_fsi_directive_decl] = STATE(3879),
    [sym_preproc_line] = STATE(3879),
    [ts_builtin_sym_end] = ACTIONS(6456),
    [sym_identifier] = ACTIONS(6458),
    [anon_sym_namespace] = ACTIONS(6458),
    [anon_sym_module] = ACTIONS(6458),
    [anon_sym_open] = ACTIONS(6458),
    [anon_sym_LBRACK_LT] = ACTIONS(6456),
    [anon_sym_return] = ACTIONS(6458),
    [anon_sym_type] = ACTIONS(6458),
    [anon_sym_do] = ACTIONS(6458),
    [anon_sym_and] = ACTIONS(6458),
    [anon_sym_let] = ACTIONS(6458),
    [anon_sym_let_BANG] = ACTIONS(6456),
    [aux_sym_access_modifier_token1] = ACTIONS(6456),
    [anon_sym_LPAREN] = ACTIONS(6458),
    [anon_sym_null] = ACTIONS(6458),
    [anon_sym_AMP] = ACTIONS(6458),
    [anon_sym_LBRACK] = ACTIONS(6458),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6456),
    [anon_sym_LBRACE] = ACTIONS(6458),
    [anon_sym_LT_AT] = ACTIONS(6458),
    [anon_sym_LT_AT_AT] = ACTIONS(6456),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6456),
    [anon_sym_new] = ACTIONS(6458),
    [anon_sym_return_BANG] = ACTIONS(6456),
    [anon_sym_yield] = ACTIONS(6458),
    [anon_sym_yield_BANG] = ACTIONS(6456),
    [anon_sym_lazy] = ACTIONS(6458),
    [anon_sym_assert] = ACTIONS(6458),
    [anon_sym_upcast] = ACTIONS(6458),
    [anon_sym_downcast] = ACTIONS(6458),
    [anon_sym_for] = ACTIONS(6458),
    [anon_sym_while] = ACTIONS(6458),
    [anon_sym_if] = ACTIONS(6458),
    [anon_sym_fun] = ACTIONS(6458),
    [anon_sym_try] = ACTIONS(6458),
    [anon_sym_match] = ACTIONS(6458),
    [anon_sym_match_BANG] = ACTIONS(6456),
    [anon_sym_function] = ACTIONS(6458),
    [anon_sym_use] = ACTIONS(6458),
    [anon_sym_use_BANG] = ACTIONS(6456),
    [anon_sym_do_BANG] = ACTIONS(6456),
    [anon_sym_begin] = ACTIONS(6458),
    [anon_sym_default] = ACTIONS(6458),
    [anon_sym_static] = ACTIONS(6458),
    [anon_sym_member] = ACTIONS(6458),
    [anon_sym_interface] = ACTIONS(6458),
    [anon_sym_exception] = ACTIONS(6458),
    [anon_sym_abstract] = ACTIONS(6458),
    [anon_sym_val] = ACTIONS(6458),
    [anon_sym_override] = ACTIONS(6458),
    [aux_sym_char_token1] = ACTIONS(6456),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6458),
    [anon_sym_DQUOTE] = ACTIONS(6458),
    [anon_sym_AT_DQUOTE] = ACTIONS(6456),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6456),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6456),
    [sym_bool] = ACTIONS(6458),
    [sym_unit] = ACTIONS(6456),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6458),
    [sym_op_identifier] = ACTIONS(6456),
    [anon_sym_PLUS] = ACTIONS(6458),
    [anon_sym_DASH] = ACTIONS(6458),
    [anon_sym_PLUS_DOT] = ACTIONS(6456),
    [anon_sym_DASH_DOT] = ACTIONS(6456),
    [anon_sym_PERCENT] = ACTIONS(6456),
    [anon_sym_AMP_AMP] = ACTIONS(6456),
    [anon_sym_TILDE] = ACTIONS(6456),
    [aux_sym_prefix_op_token1] = ACTIONS(6456),
    [sym_int] = ACTIONS(6458),
    [sym_xint] = ACTIONS(6456),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6456),
    [anon_sym_POUNDload] = ACTIONS(6456),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6456),
  },
  [3880] = {
    [sym_attributes] = STATE(3905),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(8258),
    [sym__pattern] = STATE(7991),
    [sym_optional_pattern] = STATE(8258),
    [sym_type_check_pattern] = STATE(8258),
    [sym_attribute_pattern] = STATE(8258),
    [sym_paren_pattern] = STATE(8258),
    [sym_as_pattern] = STATE(8258),
    [sym_cons_pattern] = STATE(8258),
    [sym_disjunct_pattern] = STATE(8258),
    [sym_conjunct_pattern] = STATE(8258),
    [sym_typed_pattern] = STATE(8258),
    [sym_list_pattern] = STATE(8258),
    [sym_array_pattern] = STATE(8258),
    [sym_record_pattern] = STATE(8258),
    [sym_named_field] = STATE(9334),
    [sym_named_field_pattern] = STATE(8258),
    [sym_identifier_pattern] = STATE(8258),
    [sym_long_identifier_or_op] = STATE(2968),
    [sym_char] = STATE(8017),
    [sym_format_string] = STATE(8065),
    [sym__string_literal] = STATE(8065),
    [sym_string] = STATE(8017),
    [sym_verbatim_string] = STATE(8017),
    [sym_bytearray] = STATE(8017),
    [sym_verbatim_bytearray] = STATE(8017),
    [sym_format_triple_quoted_string] = STATE(8066),
    [sym_triple_quoted_string] = STATE(8017),
    [sym_const] = STATE(8258),
    [sym_long_identifier] = STATE(4907),
    [sym_active_pattern] = STATE(5059),
    [sym__identifier_or_op] = STATE(4927),
    [sym_sbyte] = STATE(8017),
    [sym_byte] = STATE(8017),
    [sym_int16] = STATE(8017),
    [sym_uint16] = STATE(8017),
    [sym_int32] = STATE(8017),
    [sym_uint32] = STATE(8017),
    [sym_nativeint] = STATE(8017),
    [sym_unativeint] = STATE(8017),
    [sym_int64] = STATE(8017),
    [sym_uint64] = STATE(8017),
    [sym_ieee32] = STATE(8017),
    [sym_ieee64] = STATE(8017),
    [sym_bignum] = STATE(8017),
    [sym_decimal] = STATE(8017),
    [sym_float] = STATE(7544),
    [sym_block_comment] = STATE(3880),
    [sym_compiler_directive_decl] = STATE(3880),
    [sym_fsi_directive_decl] = STATE(3880),
    [sym_preproc_line] = STATE(3880),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(6298),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5492),
    [anon_sym_null] = ACTIONS(5494),
    [anon_sym__] = ACTIONS(5496),
    [anon_sym_QMARK] = ACTIONS(5498),
    [anon_sym_COLON_QMARK] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5502),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5504),
    [anon_sym_LBRACE] = ACTIONS(5506),
    [aux_sym_char_token1] = ACTIONS(5508),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5510),
    [anon_sym_DQUOTE] = ACTIONS(5512),
    [anon_sym_AT_DQUOTE] = ACTIONS(5514),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5516),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5518),
    [sym_bool] = ACTIONS(5520),
    [sym_unit] = ACTIONS(5522),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5524),
    [sym_op_identifier] = ACTIONS(5526),
    [sym_int] = ACTIONS(5528),
    [sym_xint] = ACTIONS(5530),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3881] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8182),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_rule] = STATE(2736),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3881),
    [sym_compiler_directive_decl] = STATE(3881),
    [sym_fsi_directive_decl] = STATE(3881),
    [sym_preproc_line] = STATE(3881),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3882] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8406),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3882),
    [sym_compiler_directive_decl] = STATE(3882),
    [sym_fsi_directive_decl] = STATE(3882),
    [sym_preproc_line] = STATE(3882),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3883] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8418),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3883),
    [sym_compiler_directive_decl] = STATE(3883),
    [sym_fsi_directive_decl] = STATE(3883),
    [sym_preproc_line] = STATE(3883),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3884] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8322),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3884),
    [sym_compiler_directive_decl] = STATE(3884),
    [sym_fsi_directive_decl] = STATE(3884),
    [sym_preproc_line] = STATE(3884),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3885] = {
    [sym_attributes] = STATE(3966),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8382),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3594),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3885),
    [sym_compiler_directive_decl] = STATE(3885),
    [sym_fsi_directive_decl] = STATE(3885),
    [sym_preproc_line] = STATE(3885),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(6460),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5837),
    [anon_sym_COLON_QMARK] = ACTIONS(5839),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3886] = {
    [sym_attributes] = STATE(3966),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8412),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3594),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3886),
    [sym_compiler_directive_decl] = STATE(3886),
    [sym_fsi_directive_decl] = STATE(3886),
    [sym_preproc_line] = STATE(3886),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(6462),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5837),
    [anon_sym_COLON_QMARK] = ACTIONS(5839),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3887] = {
    [sym_attributes] = STATE(3988),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4988),
    [sym__pattern] = STATE(4906),
    [sym_optional_pattern] = STATE(4988),
    [sym_type_check_pattern] = STATE(4988),
    [sym_attribute_pattern] = STATE(4988),
    [sym_paren_pattern] = STATE(4988),
    [sym_as_pattern] = STATE(4988),
    [sym_cons_pattern] = STATE(4988),
    [sym_disjunct_pattern] = STATE(4988),
    [sym_conjunct_pattern] = STATE(4988),
    [sym_typed_pattern] = STATE(4988),
    [sym_list_pattern] = STATE(4988),
    [sym_array_pattern] = STATE(4988),
    [sym_record_pattern] = STATE(4988),
    [sym_named_field_pattern] = STATE(4988),
    [sym_identifier_pattern] = STATE(4988),
    [sym_long_identifier_or_op] = STATE(3177),
    [sym_char] = STATE(5109),
    [sym_format_string] = STATE(5097),
    [sym__string_literal] = STATE(5097),
    [sym_string] = STATE(5109),
    [sym_verbatim_string] = STATE(5109),
    [sym_bytearray] = STATE(5109),
    [sym_verbatim_bytearray] = STATE(5109),
    [sym_format_triple_quoted_string] = STATE(5096),
    [sym_triple_quoted_string] = STATE(5109),
    [sym_const] = STATE(4988),
    [sym_long_identifier] = STATE(4907),
    [sym_active_pattern] = STATE(5059),
    [sym__identifier_or_op] = STATE(4927),
    [sym_sbyte] = STATE(5109),
    [sym_byte] = STATE(5109),
    [sym_int16] = STATE(5109),
    [sym_uint16] = STATE(5109),
    [sym_int32] = STATE(5109),
    [sym_uint32] = STATE(5109),
    [sym_nativeint] = STATE(5109),
    [sym_unativeint] = STATE(5109),
    [sym_int64] = STATE(5109),
    [sym_uint64] = STATE(5109),
    [sym_ieee32] = STATE(5109),
    [sym_ieee64] = STATE(5109),
    [sym_bignum] = STATE(5109),
    [sym_decimal] = STATE(5109),
    [sym_float] = STATE(4781),
    [sym_block_comment] = STATE(3887),
    [sym_compiler_directive_decl] = STATE(3887),
    [sym_fsi_directive_decl] = STATE(3887),
    [sym_preproc_line] = STATE(3887),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5490),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5560),
    [anon_sym_null] = ACTIONS(5564),
    [anon_sym__] = ACTIONS(5566),
    [anon_sym_QMARK] = ACTIONS(5568),
    [anon_sym_COLON_QMARK] = ACTIONS(5570),
    [anon_sym_LBRACK] = ACTIONS(5572),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5574),
    [anon_sym_LBRACE] = ACTIONS(5576),
    [aux_sym_char_token1] = ACTIONS(5578),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5580),
    [anon_sym_DQUOTE] = ACTIONS(5582),
    [anon_sym_AT_DQUOTE] = ACTIONS(5584),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5586),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5588),
    [sym_bool] = ACTIONS(5590),
    [sym_unit] = ACTIONS(5592),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5524),
    [sym_op_identifier] = ACTIONS(5526),
    [sym_int] = ACTIONS(5594),
    [sym_xint] = ACTIONS(5596),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3888] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8394),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3888),
    [sym_compiler_directive_decl] = STATE(3888),
    [sym_fsi_directive_decl] = STATE(3888),
    [sym_preproc_line] = STATE(3888),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3889] = {
    [sym_attributes] = STATE(3966),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8370),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3594),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3889),
    [sym_compiler_directive_decl] = STATE(3889),
    [sym_fsi_directive_decl] = STATE(3889),
    [sym_preproc_line] = STATE(3889),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(6460),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5837),
    [anon_sym_COLON_QMARK] = ACTIONS(5839),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3890] = {
    [sym_attributes] = STATE(3966),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8372),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3594),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3890),
    [sym_compiler_directive_decl] = STATE(3890),
    [sym_fsi_directive_decl] = STATE(3890),
    [sym_preproc_line] = STATE(3890),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(6464),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5837),
    [anon_sym_COLON_QMARK] = ACTIONS(5839),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3891] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8208),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3891),
    [sym_compiler_directive_decl] = STATE(3891),
    [sym_fsi_directive_decl] = STATE(3891),
    [sym_preproc_line] = STATE(3891),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3892] = {
    [sym_attributes] = STATE(3966),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8375),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3594),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3892),
    [sym_compiler_directive_decl] = STATE(3892),
    [sym_fsi_directive_decl] = STATE(3892),
    [sym_preproc_line] = STATE(3892),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(6466),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5837),
    [anon_sym_COLON_QMARK] = ACTIONS(5839),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3893] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(4924),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3893),
    [sym_compiler_directive_decl] = STATE(3893),
    [sym_fsi_directive_decl] = STATE(3893),
    [sym_preproc_line] = STATE(3893),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3894] = {
    [sym_attributes] = STATE(3966),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8376),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3594),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3894),
    [sym_compiler_directive_decl] = STATE(3894),
    [sym_fsi_directive_decl] = STATE(3894),
    [sym_preproc_line] = STATE(3894),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(6468),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5837),
    [anon_sym_COLON_QMARK] = ACTIONS(5839),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3895] = {
    [sym_attributes] = STATE(3966),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8345),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3594),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3895),
    [sym_compiler_directive_decl] = STATE(3895),
    [sym_fsi_directive_decl] = STATE(3895),
    [sym_preproc_line] = STATE(3895),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5835),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5837),
    [anon_sym_COLON_QMARK] = ACTIONS(5839),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3896] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(4889),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3896),
    [sym_compiler_directive_decl] = STATE(3896),
    [sym_fsi_directive_decl] = STATE(3896),
    [sym_preproc_line] = STATE(3896),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3897] = {
    [sym_attributes] = STATE(3966),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8369),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3594),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3897),
    [sym_compiler_directive_decl] = STATE(3897),
    [sym_fsi_directive_decl] = STATE(3897),
    [sym_preproc_line] = STATE(3897),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(6470),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5837),
    [anon_sym_COLON_QMARK] = ACTIONS(5839),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3898] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7679),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3898),
    [sym_compiler_directive_decl] = STATE(3898),
    [sym_fsi_directive_decl] = STATE(3898),
    [sym_preproc_line] = STATE(3898),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3899] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7681),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3899),
    [sym_compiler_directive_decl] = STATE(3899),
    [sym_fsi_directive_decl] = STATE(3899),
    [sym_preproc_line] = STATE(3899),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3900] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7684),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3900),
    [sym_compiler_directive_decl] = STATE(3900),
    [sym_fsi_directive_decl] = STATE(3900),
    [sym_preproc_line] = STATE(3900),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3901] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7707),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3901),
    [sym_compiler_directive_decl] = STATE(3901),
    [sym_fsi_directive_decl] = STATE(3901),
    [sym_preproc_line] = STATE(3901),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3902] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(4892),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3902),
    [sym_compiler_directive_decl] = STATE(3902),
    [sym_fsi_directive_decl] = STATE(3902),
    [sym_preproc_line] = STATE(3902),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3903] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8420),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3903),
    [sym_compiler_directive_decl] = STATE(3903),
    [sym_fsi_directive_decl] = STATE(3903),
    [sym_preproc_line] = STATE(3903),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3904] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(4897),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3904),
    [sym_compiler_directive_decl] = STATE(3904),
    [sym_fsi_directive_decl] = STATE(3904),
    [sym_preproc_line] = STATE(3904),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3905] = {
    [sym_attributes] = STATE(3905),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(8258),
    [sym__pattern] = STATE(7855),
    [sym_optional_pattern] = STATE(8258),
    [sym_type_check_pattern] = STATE(8258),
    [sym_attribute_pattern] = STATE(8258),
    [sym_paren_pattern] = STATE(8258),
    [sym_as_pattern] = STATE(8258),
    [sym_cons_pattern] = STATE(8258),
    [sym_disjunct_pattern] = STATE(8258),
    [sym_conjunct_pattern] = STATE(8258),
    [sym_typed_pattern] = STATE(8258),
    [sym_list_pattern] = STATE(8258),
    [sym_array_pattern] = STATE(8258),
    [sym_record_pattern] = STATE(8258),
    [sym_named_field_pattern] = STATE(8258),
    [sym_identifier_pattern] = STATE(8258),
    [sym_long_identifier_or_op] = STATE(2968),
    [sym_char] = STATE(8017),
    [sym_format_string] = STATE(8065),
    [sym__string_literal] = STATE(8065),
    [sym_string] = STATE(8017),
    [sym_verbatim_string] = STATE(8017),
    [sym_bytearray] = STATE(8017),
    [sym_verbatim_bytearray] = STATE(8017),
    [sym_format_triple_quoted_string] = STATE(8066),
    [sym_triple_quoted_string] = STATE(8017),
    [sym_const] = STATE(8258),
    [sym_long_identifier] = STATE(4907),
    [sym_active_pattern] = STATE(5059),
    [sym__identifier_or_op] = STATE(4927),
    [sym_sbyte] = STATE(8017),
    [sym_byte] = STATE(8017),
    [sym_int16] = STATE(8017),
    [sym_uint16] = STATE(8017),
    [sym_int32] = STATE(8017),
    [sym_uint32] = STATE(8017),
    [sym_nativeint] = STATE(8017),
    [sym_unativeint] = STATE(8017),
    [sym_int64] = STATE(8017),
    [sym_uint64] = STATE(8017),
    [sym_ieee32] = STATE(8017),
    [sym_ieee64] = STATE(8017),
    [sym_bignum] = STATE(8017),
    [sym_decimal] = STATE(8017),
    [sym_float] = STATE(7544),
    [sym_block_comment] = STATE(3905),
    [sym_compiler_directive_decl] = STATE(3905),
    [sym_fsi_directive_decl] = STATE(3905),
    [sym_preproc_line] = STATE(3905),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5490),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5492),
    [anon_sym_null] = ACTIONS(5494),
    [anon_sym__] = ACTIONS(5496),
    [anon_sym_QMARK] = ACTIONS(5498),
    [anon_sym_COLON_QMARK] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5502),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5504),
    [anon_sym_LBRACE] = ACTIONS(5506),
    [aux_sym_char_token1] = ACTIONS(5508),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5510),
    [anon_sym_DQUOTE] = ACTIONS(5512),
    [anon_sym_AT_DQUOTE] = ACTIONS(5514),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5516),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5518),
    [sym_bool] = ACTIONS(5520),
    [sym_unit] = ACTIONS(5522),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5524),
    [sym_op_identifier] = ACTIONS(5526),
    [sym_int] = ACTIONS(5528),
    [sym_xint] = ACTIONS(5530),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3906] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8407),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3906),
    [sym_compiler_directive_decl] = STATE(3906),
    [sym_fsi_directive_decl] = STATE(3906),
    [sym_preproc_line] = STATE(3906),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3907] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8405),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3907),
    [sym_compiler_directive_decl] = STATE(3907),
    [sym_fsi_directive_decl] = STATE(3907),
    [sym_preproc_line] = STATE(3907),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3908] = {
    [sym_attributes] = STATE(3966),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8408),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3594),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3908),
    [sym_compiler_directive_decl] = STATE(3908),
    [sym_fsi_directive_decl] = STATE(3908),
    [sym_preproc_line] = STATE(3908),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(6472),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5837),
    [anon_sym_COLON_QMARK] = ACTIONS(5839),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3909] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7839),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3909),
    [sym_compiler_directive_decl] = STATE(3909),
    [sym_fsi_directive_decl] = STATE(3909),
    [sym_preproc_line] = STATE(3909),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3910] = {
    [sym_attributes] = STATE(3953),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(5287),
    [sym__pattern] = STATE(5207),
    [sym_optional_pattern] = STATE(5287),
    [sym_type_check_pattern] = STATE(5287),
    [sym_attribute_pattern] = STATE(5287),
    [sym_paren_pattern] = STATE(5287),
    [sym_as_pattern] = STATE(5287),
    [sym_cons_pattern] = STATE(5287),
    [sym_disjunct_pattern] = STATE(5287),
    [sym_conjunct_pattern] = STATE(5287),
    [sym_typed_pattern] = STATE(5287),
    [sym_list_pattern] = STATE(5287),
    [sym_array_pattern] = STATE(5287),
    [sym_record_pattern] = STATE(5287),
    [sym_named_field_pattern] = STATE(5287),
    [sym_identifier_pattern] = STATE(5287),
    [sym_long_identifier_or_op] = STATE(3587),
    [sym_char] = STATE(5281),
    [sym_format_string] = STATE(5312),
    [sym__string_literal] = STATE(5312),
    [sym_string] = STATE(5281),
    [sym_verbatim_string] = STATE(5281),
    [sym_bytearray] = STATE(5281),
    [sym_verbatim_bytearray] = STATE(5281),
    [sym_format_triple_quoted_string] = STATE(5246),
    [sym_triple_quoted_string] = STATE(5281),
    [sym_const] = STATE(5287),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(5281),
    [sym_byte] = STATE(5281),
    [sym_int16] = STATE(5281),
    [sym_uint16] = STATE(5281),
    [sym_int32] = STATE(5281),
    [sym_uint32] = STATE(5281),
    [sym_nativeint] = STATE(5281),
    [sym_unativeint] = STATE(5281),
    [sym_int64] = STATE(5281),
    [sym_uint64] = STATE(5281),
    [sym_ieee32] = STATE(5281),
    [sym_ieee64] = STATE(5281),
    [sym_bignum] = STATE(5281),
    [sym_decimal] = STATE(5281),
    [sym_float] = STATE(4951),
    [sym_block_comment] = STATE(3910),
    [sym_compiler_directive_decl] = STATE(3910),
    [sym_fsi_directive_decl] = STATE(3910),
    [sym_preproc_line] = STATE(3910),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5835),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(6041),
    [anon_sym_null] = ACTIONS(6043),
    [anon_sym__] = ACTIONS(6045),
    [anon_sym_QMARK] = ACTIONS(6047),
    [anon_sym_COLON_QMARK] = ACTIONS(6049),
    [anon_sym_LBRACK] = ACTIONS(6051),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6053),
    [anon_sym_LBRACE] = ACTIONS(6055),
    [aux_sym_char_token1] = ACTIONS(6057),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6059),
    [anon_sym_DQUOTE] = ACTIONS(6061),
    [anon_sym_AT_DQUOTE] = ACTIONS(6063),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6065),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6067),
    [sym_bool] = ACTIONS(6069),
    [sym_unit] = ACTIONS(6071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(6073),
    [sym_xint] = ACTIONS(6075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3911] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8328),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3911),
    [sym_compiler_directive_decl] = STATE(3911),
    [sym_fsi_directive_decl] = STATE(3911),
    [sym_preproc_line] = STATE(3911),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3912] = {
    [sym_attributes] = STATE(3953),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(5287),
    [sym__pattern] = STATE(5209),
    [sym_optional_pattern] = STATE(5287),
    [sym_type_check_pattern] = STATE(5287),
    [sym_attribute_pattern] = STATE(5287),
    [sym_paren_pattern] = STATE(5287),
    [sym_as_pattern] = STATE(5287),
    [sym_cons_pattern] = STATE(5287),
    [sym_disjunct_pattern] = STATE(5287),
    [sym_conjunct_pattern] = STATE(5287),
    [sym_typed_pattern] = STATE(5287),
    [sym_list_pattern] = STATE(5287),
    [sym_array_pattern] = STATE(5287),
    [sym_record_pattern] = STATE(5287),
    [sym_named_field_pattern] = STATE(5287),
    [sym_identifier_pattern] = STATE(5287),
    [sym_long_identifier_or_op] = STATE(3587),
    [sym_char] = STATE(5281),
    [sym_format_string] = STATE(5312),
    [sym__string_literal] = STATE(5312),
    [sym_string] = STATE(5281),
    [sym_verbatim_string] = STATE(5281),
    [sym_bytearray] = STATE(5281),
    [sym_verbatim_bytearray] = STATE(5281),
    [sym_format_triple_quoted_string] = STATE(5246),
    [sym_triple_quoted_string] = STATE(5281),
    [sym_const] = STATE(5287),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(5281),
    [sym_byte] = STATE(5281),
    [sym_int16] = STATE(5281),
    [sym_uint16] = STATE(5281),
    [sym_int32] = STATE(5281),
    [sym_uint32] = STATE(5281),
    [sym_nativeint] = STATE(5281),
    [sym_unativeint] = STATE(5281),
    [sym_int64] = STATE(5281),
    [sym_uint64] = STATE(5281),
    [sym_ieee32] = STATE(5281),
    [sym_ieee64] = STATE(5281),
    [sym_bignum] = STATE(5281),
    [sym_decimal] = STATE(5281),
    [sym_float] = STATE(4951),
    [sym_block_comment] = STATE(3912),
    [sym_compiler_directive_decl] = STATE(3912),
    [sym_fsi_directive_decl] = STATE(3912),
    [sym_preproc_line] = STATE(3912),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5835),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(6041),
    [anon_sym_null] = ACTIONS(6043),
    [anon_sym__] = ACTIONS(6045),
    [anon_sym_QMARK] = ACTIONS(6047),
    [anon_sym_COLON_QMARK] = ACTIONS(6049),
    [anon_sym_LBRACK] = ACTIONS(6051),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6053),
    [anon_sym_LBRACE] = ACTIONS(6055),
    [aux_sym_char_token1] = ACTIONS(6057),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6059),
    [anon_sym_DQUOTE] = ACTIONS(6061),
    [anon_sym_AT_DQUOTE] = ACTIONS(6063),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6065),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6067),
    [sym_bool] = ACTIONS(6069),
    [sym_unit] = ACTIONS(6071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(6073),
    [sym_xint] = ACTIONS(6075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3913] = {
    [sym_attributes] = STATE(3953),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(5287),
    [sym__pattern] = STATE(5211),
    [sym_optional_pattern] = STATE(5287),
    [sym_type_check_pattern] = STATE(5287),
    [sym_attribute_pattern] = STATE(5287),
    [sym_paren_pattern] = STATE(5287),
    [sym_as_pattern] = STATE(5287),
    [sym_cons_pattern] = STATE(5287),
    [sym_disjunct_pattern] = STATE(5287),
    [sym_conjunct_pattern] = STATE(5287),
    [sym_typed_pattern] = STATE(5287),
    [sym_list_pattern] = STATE(5287),
    [sym_array_pattern] = STATE(5287),
    [sym_record_pattern] = STATE(5287),
    [sym_named_field_pattern] = STATE(5287),
    [sym_identifier_pattern] = STATE(5287),
    [sym_long_identifier_or_op] = STATE(3587),
    [sym_char] = STATE(5281),
    [sym_format_string] = STATE(5312),
    [sym__string_literal] = STATE(5312),
    [sym_string] = STATE(5281),
    [sym_verbatim_string] = STATE(5281),
    [sym_bytearray] = STATE(5281),
    [sym_verbatim_bytearray] = STATE(5281),
    [sym_format_triple_quoted_string] = STATE(5246),
    [sym_triple_quoted_string] = STATE(5281),
    [sym_const] = STATE(5287),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(5281),
    [sym_byte] = STATE(5281),
    [sym_int16] = STATE(5281),
    [sym_uint16] = STATE(5281),
    [sym_int32] = STATE(5281),
    [sym_uint32] = STATE(5281),
    [sym_nativeint] = STATE(5281),
    [sym_unativeint] = STATE(5281),
    [sym_int64] = STATE(5281),
    [sym_uint64] = STATE(5281),
    [sym_ieee32] = STATE(5281),
    [sym_ieee64] = STATE(5281),
    [sym_bignum] = STATE(5281),
    [sym_decimal] = STATE(5281),
    [sym_float] = STATE(4951),
    [sym_block_comment] = STATE(3913),
    [sym_compiler_directive_decl] = STATE(3913),
    [sym_fsi_directive_decl] = STATE(3913),
    [sym_preproc_line] = STATE(3913),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5835),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(6041),
    [anon_sym_null] = ACTIONS(6043),
    [anon_sym__] = ACTIONS(6045),
    [anon_sym_QMARK] = ACTIONS(6047),
    [anon_sym_COLON_QMARK] = ACTIONS(6049),
    [anon_sym_LBRACK] = ACTIONS(6051),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6053),
    [anon_sym_LBRACE] = ACTIONS(6055),
    [aux_sym_char_token1] = ACTIONS(6057),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6059),
    [anon_sym_DQUOTE] = ACTIONS(6061),
    [anon_sym_AT_DQUOTE] = ACTIONS(6063),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6065),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6067),
    [sym_bool] = ACTIONS(6069),
    [sym_unit] = ACTIONS(6071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(6073),
    [sym_xint] = ACTIONS(6075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3914] = {
    [sym_attributes] = STATE(3953),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(5287),
    [sym__pattern] = STATE(5213),
    [sym_optional_pattern] = STATE(5287),
    [sym_type_check_pattern] = STATE(5287),
    [sym_attribute_pattern] = STATE(5287),
    [sym_paren_pattern] = STATE(5287),
    [sym_as_pattern] = STATE(5287),
    [sym_cons_pattern] = STATE(5287),
    [sym_disjunct_pattern] = STATE(5287),
    [sym_conjunct_pattern] = STATE(5287),
    [sym_typed_pattern] = STATE(5287),
    [sym_list_pattern] = STATE(5287),
    [sym_array_pattern] = STATE(5287),
    [sym_record_pattern] = STATE(5287),
    [sym_named_field_pattern] = STATE(5287),
    [sym_identifier_pattern] = STATE(5287),
    [sym_long_identifier_or_op] = STATE(3587),
    [sym_char] = STATE(5281),
    [sym_format_string] = STATE(5312),
    [sym__string_literal] = STATE(5312),
    [sym_string] = STATE(5281),
    [sym_verbatim_string] = STATE(5281),
    [sym_bytearray] = STATE(5281),
    [sym_verbatim_bytearray] = STATE(5281),
    [sym_format_triple_quoted_string] = STATE(5246),
    [sym_triple_quoted_string] = STATE(5281),
    [sym_const] = STATE(5287),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(5281),
    [sym_byte] = STATE(5281),
    [sym_int16] = STATE(5281),
    [sym_uint16] = STATE(5281),
    [sym_int32] = STATE(5281),
    [sym_uint32] = STATE(5281),
    [sym_nativeint] = STATE(5281),
    [sym_unativeint] = STATE(5281),
    [sym_int64] = STATE(5281),
    [sym_uint64] = STATE(5281),
    [sym_ieee32] = STATE(5281),
    [sym_ieee64] = STATE(5281),
    [sym_bignum] = STATE(5281),
    [sym_decimal] = STATE(5281),
    [sym_float] = STATE(4951),
    [sym_block_comment] = STATE(3914),
    [sym_compiler_directive_decl] = STATE(3914),
    [sym_fsi_directive_decl] = STATE(3914),
    [sym_preproc_line] = STATE(3914),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5835),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(6041),
    [anon_sym_null] = ACTIONS(6043),
    [anon_sym__] = ACTIONS(6045),
    [anon_sym_QMARK] = ACTIONS(6047),
    [anon_sym_COLON_QMARK] = ACTIONS(6049),
    [anon_sym_LBRACK] = ACTIONS(6051),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6053),
    [anon_sym_LBRACE] = ACTIONS(6055),
    [aux_sym_char_token1] = ACTIONS(6057),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6059),
    [anon_sym_DQUOTE] = ACTIONS(6061),
    [anon_sym_AT_DQUOTE] = ACTIONS(6063),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6065),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6067),
    [sym_bool] = ACTIONS(6069),
    [sym_unit] = ACTIONS(6071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(6073),
    [sym_xint] = ACTIONS(6075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3915] = {
    [sym_attributes] = STATE(3905),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(8258),
    [sym__pattern] = STATE(7902),
    [sym_optional_pattern] = STATE(8258),
    [sym_type_check_pattern] = STATE(8258),
    [sym_attribute_pattern] = STATE(8258),
    [sym_paren_pattern] = STATE(8258),
    [sym_as_pattern] = STATE(8258),
    [sym_cons_pattern] = STATE(8258),
    [sym_disjunct_pattern] = STATE(8258),
    [sym_conjunct_pattern] = STATE(8258),
    [sym_typed_pattern] = STATE(8258),
    [sym_list_pattern] = STATE(8258),
    [sym_array_pattern] = STATE(8258),
    [sym_record_pattern] = STATE(8258),
    [sym_named_field_pattern] = STATE(8258),
    [sym_identifier_pattern] = STATE(8258),
    [sym_long_identifier_or_op] = STATE(2968),
    [sym_char] = STATE(8017),
    [sym_format_string] = STATE(8065),
    [sym__string_literal] = STATE(8065),
    [sym_string] = STATE(8017),
    [sym_verbatim_string] = STATE(8017),
    [sym_bytearray] = STATE(8017),
    [sym_verbatim_bytearray] = STATE(8017),
    [sym_format_triple_quoted_string] = STATE(8066),
    [sym_triple_quoted_string] = STATE(8017),
    [sym_const] = STATE(8258),
    [sym_long_identifier] = STATE(4907),
    [sym_active_pattern] = STATE(5059),
    [sym__identifier_or_op] = STATE(4927),
    [sym_sbyte] = STATE(8017),
    [sym_byte] = STATE(8017),
    [sym_int16] = STATE(8017),
    [sym_uint16] = STATE(8017),
    [sym_int32] = STATE(8017),
    [sym_uint32] = STATE(8017),
    [sym_nativeint] = STATE(8017),
    [sym_unativeint] = STATE(8017),
    [sym_int64] = STATE(8017),
    [sym_uint64] = STATE(8017),
    [sym_ieee32] = STATE(8017),
    [sym_ieee64] = STATE(8017),
    [sym_bignum] = STATE(8017),
    [sym_decimal] = STATE(8017),
    [sym_float] = STATE(7544),
    [sym_block_comment] = STATE(3915),
    [sym_compiler_directive_decl] = STATE(3915),
    [sym_fsi_directive_decl] = STATE(3915),
    [sym_preproc_line] = STATE(3915),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5490),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5492),
    [anon_sym_null] = ACTIONS(5494),
    [anon_sym__] = ACTIONS(5496),
    [anon_sym_QMARK] = ACTIONS(5498),
    [anon_sym_COLON_QMARK] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5502),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5504),
    [anon_sym_LBRACE] = ACTIONS(5506),
    [aux_sym_char_token1] = ACTIONS(5508),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5510),
    [anon_sym_DQUOTE] = ACTIONS(5512),
    [anon_sym_AT_DQUOTE] = ACTIONS(5514),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5516),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5518),
    [sym_bool] = ACTIONS(5520),
    [sym_unit] = ACTIONS(5522),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5524),
    [sym_op_identifier] = ACTIONS(5526),
    [sym_int] = ACTIONS(5528),
    [sym_xint] = ACTIONS(5530),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3916] = {
    [sym_attributes] = STATE(3976),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(8306),
    [sym__pattern] = STATE(8122),
    [sym_optional_pattern] = STATE(8306),
    [sym_type_check_pattern] = STATE(8306),
    [sym_attribute_pattern] = STATE(8306),
    [sym_paren_pattern] = STATE(8306),
    [sym_as_pattern] = STATE(8306),
    [sym_cons_pattern] = STATE(8306),
    [sym_disjunct_pattern] = STATE(8306),
    [sym_conjunct_pattern] = STATE(8306),
    [sym_typed_pattern] = STATE(8306),
    [sym_list_pattern] = STATE(8306),
    [sym_array_pattern] = STATE(8306),
    [sym_record_pattern] = STATE(8306),
    [sym_named_field_pattern] = STATE(8306),
    [sym_identifier_pattern] = STATE(8306),
    [sym_long_identifier_or_op] = STATE(3457),
    [sym_char] = STATE(8299),
    [sym_format_string] = STATE(8384),
    [sym__string_literal] = STATE(8384),
    [sym_string] = STATE(8299),
    [sym_verbatim_string] = STATE(8299),
    [sym_bytearray] = STATE(8299),
    [sym_verbatim_bytearray] = STATE(8299),
    [sym_format_triple_quoted_string] = STATE(8395),
    [sym_triple_quoted_string] = STATE(8299),
    [sym_const] = STATE(8306),
    [sym_long_identifier] = STATE(4953),
    [sym_active_pattern] = STATE(5117),
    [sym__identifier_or_op] = STATE(5167),
    [sym_sbyte] = STATE(8299),
    [sym_byte] = STATE(8299),
    [sym_int16] = STATE(8299),
    [sym_uint16] = STATE(8299),
    [sym_int32] = STATE(8299),
    [sym_uint32] = STATE(8299),
    [sym_nativeint] = STATE(8299),
    [sym_unativeint] = STATE(8299),
    [sym_int64] = STATE(8299),
    [sym_uint64] = STATE(8299),
    [sym_ieee32] = STATE(8299),
    [sym_ieee64] = STATE(8299),
    [sym_bignum] = STATE(8299),
    [sym_decimal] = STATE(8299),
    [sym_float] = STATE(7864),
    [sym_block_comment] = STATE(3916),
    [sym_compiler_directive_decl] = STATE(3916),
    [sym_fsi_directive_decl] = STATE(3916),
    [sym_preproc_line] = STATE(3916),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5671),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5673),
    [anon_sym_null] = ACTIONS(5675),
    [anon_sym__] = ACTIONS(5677),
    [anon_sym_QMARK] = ACTIONS(5679),
    [anon_sym_COLON_QMARK] = ACTIONS(5681),
    [anon_sym_LBRACK] = ACTIONS(5683),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5685),
    [anon_sym_LBRACE] = ACTIONS(5687),
    [aux_sym_char_token1] = ACTIONS(5689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5691),
    [anon_sym_DQUOTE] = ACTIONS(5693),
    [anon_sym_AT_DQUOTE] = ACTIONS(5695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5699),
    [sym_bool] = ACTIONS(5701),
    [sym_unit] = ACTIONS(5703),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5705),
    [sym_op_identifier] = ACTIONS(5707),
    [sym_int] = ACTIONS(5709),
    [sym_xint] = ACTIONS(5711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3917] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8380),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3917),
    [sym_compiler_directive_decl] = STATE(3917),
    [sym_fsi_directive_decl] = STATE(3917),
    [sym_preproc_line] = STATE(3917),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3918] = {
    [sym_attributes] = STATE(3966),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8411),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3594),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3918),
    [sym_compiler_directive_decl] = STATE(3918),
    [sym_fsi_directive_decl] = STATE(3918),
    [sym_preproc_line] = STATE(3918),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(6474),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5837),
    [anon_sym_COLON_QMARK] = ACTIONS(5839),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3919] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8424),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3919),
    [sym_compiler_directive_decl] = STATE(3919),
    [sym_fsi_directive_decl] = STATE(3919),
    [sym_preproc_line] = STATE(3919),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3920] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8381),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3920),
    [sym_compiler_directive_decl] = STATE(3920),
    [sym_fsi_directive_decl] = STATE(3920),
    [sym_preproc_line] = STATE(3920),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3921] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8062),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3921),
    [sym_compiler_directive_decl] = STATE(3921),
    [sym_fsi_directive_decl] = STATE(3921),
    [sym_preproc_line] = STATE(3921),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3922] = {
    [sym_attributes] = STATE(3966),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8403),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3594),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3922),
    [sym_compiler_directive_decl] = STATE(3922),
    [sym_fsi_directive_decl] = STATE(3922),
    [sym_preproc_line] = STATE(3922),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5835),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5837),
    [anon_sym_COLON_QMARK] = ACTIONS(5839),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3923] = {
    [sym_attributes] = STATE(3966),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8413),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3594),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3923),
    [sym_compiler_directive_decl] = STATE(3923),
    [sym_fsi_directive_decl] = STATE(3923),
    [sym_preproc_line] = STATE(3923),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(6476),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5837),
    [anon_sym_COLON_QMARK] = ACTIONS(5839),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3924] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8416),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3924),
    [sym_compiler_directive_decl] = STATE(3924),
    [sym_fsi_directive_decl] = STATE(3924),
    [sym_preproc_line] = STATE(3924),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3925] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8392),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3925),
    [sym_compiler_directive_decl] = STATE(3925),
    [sym_fsi_directive_decl] = STATE(3925),
    [sym_preproc_line] = STATE(3925),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3926] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8300),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3926),
    [sym_compiler_directive_decl] = STATE(3926),
    [sym_fsi_directive_decl] = STATE(3926),
    [sym_preproc_line] = STATE(3926),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3927] = {
    [sym_attributes] = STATE(3966),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8414),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3594),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3927),
    [sym_compiler_directive_decl] = STATE(3927),
    [sym_fsi_directive_decl] = STATE(3927),
    [sym_preproc_line] = STATE(3927),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(6472),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5837),
    [anon_sym_COLON_QMARK] = ACTIONS(5839),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3928] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8181),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3928),
    [sym_compiler_directive_decl] = STATE(3928),
    [sym_fsi_directive_decl] = STATE(3928),
    [sym_preproc_line] = STATE(3928),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3929] = {
    [sym_attributes] = STATE(3966),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8415),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3594),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3929),
    [sym_compiler_directive_decl] = STATE(3929),
    [sym_fsi_directive_decl] = STATE(3929),
    [sym_preproc_line] = STATE(3929),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(6478),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5837),
    [anon_sym_COLON_QMARK] = ACTIONS(5839),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3930] = {
    [sym_attributes] = STATE(3966),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8309),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3594),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3930),
    [sym_compiler_directive_decl] = STATE(3930),
    [sym_fsi_directive_decl] = STATE(3930),
    [sym_preproc_line] = STATE(3930),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(6480),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5837),
    [anon_sym_COLON_QMARK] = ACTIONS(5839),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3931] = {
    [sym_attributes] = STATE(3966),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8421),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3594),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3931),
    [sym_compiler_directive_decl] = STATE(3931),
    [sym_fsi_directive_decl] = STATE(3931),
    [sym_preproc_line] = STATE(3931),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(6482),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5837),
    [anon_sym_COLON_QMARK] = ACTIONS(5839),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3932] = {
    [sym_attributes] = STATE(3966),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8343),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3594),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3932),
    [sym_compiler_directive_decl] = STATE(3932),
    [sym_fsi_directive_decl] = STATE(3932),
    [sym_preproc_line] = STATE(3932),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5835),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5837),
    [anon_sym_COLON_QMARK] = ACTIONS(5839),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3933] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8401),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3933),
    [sym_compiler_directive_decl] = STATE(3933),
    [sym_fsi_directive_decl] = STATE(3933),
    [sym_preproc_line] = STATE(3933),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3934] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8303),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3934),
    [sym_compiler_directive_decl] = STATE(3934),
    [sym_fsi_directive_decl] = STATE(3934),
    [sym_preproc_line] = STATE(3934),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3935] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8386),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3935),
    [sym_compiler_directive_decl] = STATE(3935),
    [sym_fsi_directive_decl] = STATE(3935),
    [sym_preproc_line] = STATE(3935),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3936] = {
    [sym_attributes] = STATE(3966),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8429),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3594),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3936),
    [sym_compiler_directive_decl] = STATE(3936),
    [sym_fsi_directive_decl] = STATE(3936),
    [sym_preproc_line] = STATE(3936),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(6484),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5837),
    [anon_sym_COLON_QMARK] = ACTIONS(5839),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3937] = {
    [sym_attributes] = STATE(3966),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8431),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3594),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3937),
    [sym_compiler_directive_decl] = STATE(3937),
    [sym_fsi_directive_decl] = STATE(3937),
    [sym_preproc_line] = STATE(3937),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(6486),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5837),
    [anon_sym_COLON_QMARK] = ACTIONS(5839),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3938] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8318),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3938),
    [sym_compiler_directive_decl] = STATE(3938),
    [sym_fsi_directive_decl] = STATE(3938),
    [sym_preproc_line] = STATE(3938),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3939] = {
    [sym_attributes] = STATE(3968),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(5183),
    [sym__pattern] = STATE(5069),
    [sym_optional_pattern] = STATE(5183),
    [sym_type_check_pattern] = STATE(5183),
    [sym_attribute_pattern] = STATE(5183),
    [sym_paren_pattern] = STATE(5183),
    [sym_as_pattern] = STATE(5183),
    [sym_cons_pattern] = STATE(5183),
    [sym_disjunct_pattern] = STATE(5183),
    [sym_conjunct_pattern] = STATE(5183),
    [sym_typed_pattern] = STATE(5183),
    [sym_list_pattern] = STATE(5183),
    [sym_array_pattern] = STATE(5183),
    [sym_record_pattern] = STATE(5183),
    [sym_named_field_pattern] = STATE(5183),
    [sym_identifier_pattern] = STATE(5183),
    [sym_long_identifier_or_op] = STATE(3528),
    [sym_char] = STATE(5133),
    [sym_format_string] = STATE(5135),
    [sym__string_literal] = STATE(5135),
    [sym_string] = STATE(5133),
    [sym_verbatim_string] = STATE(5133),
    [sym_bytearray] = STATE(5133),
    [sym_verbatim_bytearray] = STATE(5133),
    [sym_format_triple_quoted_string] = STATE(5136),
    [sym_triple_quoted_string] = STATE(5133),
    [sym_const] = STATE(5183),
    [sym_long_identifier] = STATE(4953),
    [sym_active_pattern] = STATE(5117),
    [sym__identifier_or_op] = STATE(5167),
    [sym_sbyte] = STATE(5133),
    [sym_byte] = STATE(5133),
    [sym_int16] = STATE(5133),
    [sym_uint16] = STATE(5133),
    [sym_int32] = STATE(5133),
    [sym_uint32] = STATE(5133),
    [sym_nativeint] = STATE(5133),
    [sym_unativeint] = STATE(5133),
    [sym_int64] = STATE(5133),
    [sym_uint64] = STATE(5133),
    [sym_ieee32] = STATE(5133),
    [sym_ieee64] = STATE(5133),
    [sym_bignum] = STATE(5133),
    [sym_decimal] = STATE(5133),
    [sym_float] = STATE(4916),
    [sym_block_comment] = STATE(3939),
    [sym_compiler_directive_decl] = STATE(3939),
    [sym_fsi_directive_decl] = STATE(3939),
    [sym_preproc_line] = STATE(3939),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5671),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5944),
    [anon_sym_null] = ACTIONS(5946),
    [anon_sym__] = ACTIONS(5948),
    [anon_sym_QMARK] = ACTIONS(5950),
    [anon_sym_COLON_QMARK] = ACTIONS(5952),
    [anon_sym_LBRACK] = ACTIONS(5954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5956),
    [anon_sym_LBRACE] = ACTIONS(5958),
    [aux_sym_char_token1] = ACTIONS(5960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5962),
    [anon_sym_DQUOTE] = ACTIONS(5964),
    [anon_sym_AT_DQUOTE] = ACTIONS(5966),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5968),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5970),
    [sym_bool] = ACTIONS(5972),
    [sym_unit] = ACTIONS(5974),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5705),
    [sym_op_identifier] = ACTIONS(5707),
    [sym_int] = ACTIONS(5976),
    [sym_xint] = ACTIONS(5978),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3940] = {
    [sym_attributes] = STATE(3976),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(8306),
    [sym__pattern] = STATE(8125),
    [sym_optional_pattern] = STATE(8306),
    [sym_type_check_pattern] = STATE(8306),
    [sym_attribute_pattern] = STATE(8306),
    [sym_paren_pattern] = STATE(8306),
    [sym_as_pattern] = STATE(8306),
    [sym_cons_pattern] = STATE(8306),
    [sym_disjunct_pattern] = STATE(8306),
    [sym_conjunct_pattern] = STATE(8306),
    [sym_typed_pattern] = STATE(8306),
    [sym_list_pattern] = STATE(8306),
    [sym_array_pattern] = STATE(8306),
    [sym_record_pattern] = STATE(8306),
    [sym_named_field_pattern] = STATE(8306),
    [sym_identifier_pattern] = STATE(8306),
    [sym_long_identifier_or_op] = STATE(3457),
    [sym_char] = STATE(8299),
    [sym_format_string] = STATE(8384),
    [sym__string_literal] = STATE(8384),
    [sym_string] = STATE(8299),
    [sym_verbatim_string] = STATE(8299),
    [sym_bytearray] = STATE(8299),
    [sym_verbatim_bytearray] = STATE(8299),
    [sym_format_triple_quoted_string] = STATE(8395),
    [sym_triple_quoted_string] = STATE(8299),
    [sym_const] = STATE(8306),
    [sym_long_identifier] = STATE(4953),
    [sym_active_pattern] = STATE(5117),
    [sym__identifier_or_op] = STATE(5167),
    [sym_sbyte] = STATE(8299),
    [sym_byte] = STATE(8299),
    [sym_int16] = STATE(8299),
    [sym_uint16] = STATE(8299),
    [sym_int32] = STATE(8299),
    [sym_uint32] = STATE(8299),
    [sym_nativeint] = STATE(8299),
    [sym_unativeint] = STATE(8299),
    [sym_int64] = STATE(8299),
    [sym_uint64] = STATE(8299),
    [sym_ieee32] = STATE(8299),
    [sym_ieee64] = STATE(8299),
    [sym_bignum] = STATE(8299),
    [sym_decimal] = STATE(8299),
    [sym_float] = STATE(7864),
    [sym_block_comment] = STATE(3940),
    [sym_compiler_directive_decl] = STATE(3940),
    [sym_fsi_directive_decl] = STATE(3940),
    [sym_preproc_line] = STATE(3940),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5671),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5673),
    [anon_sym_null] = ACTIONS(5675),
    [anon_sym__] = ACTIONS(5677),
    [anon_sym_QMARK] = ACTIONS(5679),
    [anon_sym_COLON_QMARK] = ACTIONS(5681),
    [anon_sym_LBRACK] = ACTIONS(5683),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5685),
    [anon_sym_LBRACE] = ACTIONS(5687),
    [aux_sym_char_token1] = ACTIONS(5689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5691),
    [anon_sym_DQUOTE] = ACTIONS(5693),
    [anon_sym_AT_DQUOTE] = ACTIONS(5695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5699),
    [sym_bool] = ACTIONS(5701),
    [sym_unit] = ACTIONS(5703),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5705),
    [sym_op_identifier] = ACTIONS(5707),
    [sym_int] = ACTIONS(5709),
    [sym_xint] = ACTIONS(5711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3941] = {
    [sym_attributes] = STATE(3966),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8320),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3594),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3941),
    [sym_compiler_directive_decl] = STATE(3941),
    [sym_fsi_directive_decl] = STATE(3941),
    [sym_preproc_line] = STATE(3941),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(6488),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5837),
    [anon_sym_COLON_QMARK] = ACTIONS(5839),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3942] = {
    [sym_attributes] = STATE(3976),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(8306),
    [sym__pattern] = STATE(8119),
    [sym_optional_pattern] = STATE(8306),
    [sym_type_check_pattern] = STATE(8306),
    [sym_attribute_pattern] = STATE(8306),
    [sym_paren_pattern] = STATE(8306),
    [sym_as_pattern] = STATE(8306),
    [sym_cons_pattern] = STATE(8306),
    [sym_disjunct_pattern] = STATE(8306),
    [sym_conjunct_pattern] = STATE(8306),
    [sym_typed_pattern] = STATE(8306),
    [sym_list_pattern] = STATE(8306),
    [sym_array_pattern] = STATE(8306),
    [sym_record_pattern] = STATE(8306),
    [sym_named_field_pattern] = STATE(8306),
    [sym_identifier_pattern] = STATE(8306),
    [sym_long_identifier_or_op] = STATE(3457),
    [sym_char] = STATE(8299),
    [sym_format_string] = STATE(8384),
    [sym__string_literal] = STATE(8384),
    [sym_string] = STATE(8299),
    [sym_verbatim_string] = STATE(8299),
    [sym_bytearray] = STATE(8299),
    [sym_verbatim_bytearray] = STATE(8299),
    [sym_format_triple_quoted_string] = STATE(8395),
    [sym_triple_quoted_string] = STATE(8299),
    [sym_const] = STATE(8306),
    [sym_long_identifier] = STATE(4953),
    [sym_active_pattern] = STATE(5117),
    [sym__identifier_or_op] = STATE(5167),
    [sym_sbyte] = STATE(8299),
    [sym_byte] = STATE(8299),
    [sym_int16] = STATE(8299),
    [sym_uint16] = STATE(8299),
    [sym_int32] = STATE(8299),
    [sym_uint32] = STATE(8299),
    [sym_nativeint] = STATE(8299),
    [sym_unativeint] = STATE(8299),
    [sym_int64] = STATE(8299),
    [sym_uint64] = STATE(8299),
    [sym_ieee32] = STATE(8299),
    [sym_ieee64] = STATE(8299),
    [sym_bignum] = STATE(8299),
    [sym_decimal] = STATE(8299),
    [sym_float] = STATE(7864),
    [sym_block_comment] = STATE(3942),
    [sym_compiler_directive_decl] = STATE(3942),
    [sym_fsi_directive_decl] = STATE(3942),
    [sym_preproc_line] = STATE(3942),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5671),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5673),
    [anon_sym_null] = ACTIONS(5675),
    [anon_sym__] = ACTIONS(5677),
    [anon_sym_QMARK] = ACTIONS(5679),
    [anon_sym_COLON_QMARK] = ACTIONS(5681),
    [anon_sym_LBRACK] = ACTIONS(5683),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5685),
    [anon_sym_LBRACE] = ACTIONS(5687),
    [aux_sym_char_token1] = ACTIONS(5689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5691),
    [anon_sym_DQUOTE] = ACTIONS(5693),
    [anon_sym_AT_DQUOTE] = ACTIONS(5695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5699),
    [sym_bool] = ACTIONS(5701),
    [sym_unit] = ACTIONS(5703),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5705),
    [sym_op_identifier] = ACTIONS(5707),
    [sym_int] = ACTIONS(5709),
    [sym_xint] = ACTIONS(5711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3943] = {
    [sym_attributes] = STATE(3968),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(5183),
    [sym__pattern] = STATE(5068),
    [sym_optional_pattern] = STATE(5183),
    [sym_type_check_pattern] = STATE(5183),
    [sym_attribute_pattern] = STATE(5183),
    [sym_paren_pattern] = STATE(5183),
    [sym_as_pattern] = STATE(5183),
    [sym_cons_pattern] = STATE(5183),
    [sym_disjunct_pattern] = STATE(5183),
    [sym_conjunct_pattern] = STATE(5183),
    [sym_typed_pattern] = STATE(5183),
    [sym_list_pattern] = STATE(5183),
    [sym_array_pattern] = STATE(5183),
    [sym_record_pattern] = STATE(5183),
    [sym_named_field_pattern] = STATE(5183),
    [sym_identifier_pattern] = STATE(5183),
    [sym_long_identifier_or_op] = STATE(3528),
    [sym_char] = STATE(5133),
    [sym_format_string] = STATE(5135),
    [sym__string_literal] = STATE(5135),
    [sym_string] = STATE(5133),
    [sym_verbatim_string] = STATE(5133),
    [sym_bytearray] = STATE(5133),
    [sym_verbatim_bytearray] = STATE(5133),
    [sym_format_triple_quoted_string] = STATE(5136),
    [sym_triple_quoted_string] = STATE(5133),
    [sym_const] = STATE(5183),
    [sym_long_identifier] = STATE(4953),
    [sym_active_pattern] = STATE(5117),
    [sym__identifier_or_op] = STATE(5167),
    [sym_sbyte] = STATE(5133),
    [sym_byte] = STATE(5133),
    [sym_int16] = STATE(5133),
    [sym_uint16] = STATE(5133),
    [sym_int32] = STATE(5133),
    [sym_uint32] = STATE(5133),
    [sym_nativeint] = STATE(5133),
    [sym_unativeint] = STATE(5133),
    [sym_int64] = STATE(5133),
    [sym_uint64] = STATE(5133),
    [sym_ieee32] = STATE(5133),
    [sym_ieee64] = STATE(5133),
    [sym_bignum] = STATE(5133),
    [sym_decimal] = STATE(5133),
    [sym_float] = STATE(4916),
    [sym_block_comment] = STATE(3943),
    [sym_compiler_directive_decl] = STATE(3943),
    [sym_fsi_directive_decl] = STATE(3943),
    [sym_preproc_line] = STATE(3943),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5671),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5944),
    [anon_sym_null] = ACTIONS(5946),
    [anon_sym__] = ACTIONS(5948),
    [anon_sym_QMARK] = ACTIONS(5950),
    [anon_sym_COLON_QMARK] = ACTIONS(5952),
    [anon_sym_LBRACK] = ACTIONS(5954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5956),
    [anon_sym_LBRACE] = ACTIONS(5958),
    [aux_sym_char_token1] = ACTIONS(5960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5962),
    [anon_sym_DQUOTE] = ACTIONS(5964),
    [anon_sym_AT_DQUOTE] = ACTIONS(5966),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5968),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5970),
    [sym_bool] = ACTIONS(5972),
    [sym_unit] = ACTIONS(5974),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5705),
    [sym_op_identifier] = ACTIONS(5707),
    [sym_int] = ACTIONS(5976),
    [sym_xint] = ACTIONS(5978),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3944] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8356),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3944),
    [sym_compiler_directive_decl] = STATE(3944),
    [sym_fsi_directive_decl] = STATE(3944),
    [sym_preproc_line] = STATE(3944),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3945] = {
    [sym_attributes] = STATE(3976),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(8306),
    [sym__pattern] = STATE(8113),
    [sym_optional_pattern] = STATE(8306),
    [sym_type_check_pattern] = STATE(8306),
    [sym_attribute_pattern] = STATE(8306),
    [sym_paren_pattern] = STATE(8306),
    [sym_as_pattern] = STATE(8306),
    [sym_cons_pattern] = STATE(8306),
    [sym_disjunct_pattern] = STATE(8306),
    [sym_conjunct_pattern] = STATE(8306),
    [sym_typed_pattern] = STATE(8306),
    [sym_list_pattern] = STATE(8306),
    [sym_array_pattern] = STATE(8306),
    [sym_record_pattern] = STATE(8306),
    [sym_named_field_pattern] = STATE(8306),
    [sym_identifier_pattern] = STATE(8306),
    [sym_long_identifier_or_op] = STATE(3457),
    [sym_char] = STATE(8299),
    [sym_format_string] = STATE(8384),
    [sym__string_literal] = STATE(8384),
    [sym_string] = STATE(8299),
    [sym_verbatim_string] = STATE(8299),
    [sym_bytearray] = STATE(8299),
    [sym_verbatim_bytearray] = STATE(8299),
    [sym_format_triple_quoted_string] = STATE(8395),
    [sym_triple_quoted_string] = STATE(8299),
    [sym_const] = STATE(8306),
    [sym_long_identifier] = STATE(4953),
    [sym_active_pattern] = STATE(5117),
    [sym__identifier_or_op] = STATE(5167),
    [sym_sbyte] = STATE(8299),
    [sym_byte] = STATE(8299),
    [sym_int16] = STATE(8299),
    [sym_uint16] = STATE(8299),
    [sym_int32] = STATE(8299),
    [sym_uint32] = STATE(8299),
    [sym_nativeint] = STATE(8299),
    [sym_unativeint] = STATE(8299),
    [sym_int64] = STATE(8299),
    [sym_uint64] = STATE(8299),
    [sym_ieee32] = STATE(8299),
    [sym_ieee64] = STATE(8299),
    [sym_bignum] = STATE(8299),
    [sym_decimal] = STATE(8299),
    [sym_float] = STATE(7864),
    [sym_block_comment] = STATE(3945),
    [sym_compiler_directive_decl] = STATE(3945),
    [sym_fsi_directive_decl] = STATE(3945),
    [sym_preproc_line] = STATE(3945),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5671),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5673),
    [anon_sym_null] = ACTIONS(5675),
    [anon_sym__] = ACTIONS(5677),
    [anon_sym_QMARK] = ACTIONS(5679),
    [anon_sym_COLON_QMARK] = ACTIONS(5681),
    [anon_sym_LBRACK] = ACTIONS(5683),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5685),
    [anon_sym_LBRACE] = ACTIONS(5687),
    [aux_sym_char_token1] = ACTIONS(5689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5691),
    [anon_sym_DQUOTE] = ACTIONS(5693),
    [anon_sym_AT_DQUOTE] = ACTIONS(5695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5699),
    [sym_bool] = ACTIONS(5701),
    [sym_unit] = ACTIONS(5703),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5705),
    [sym_op_identifier] = ACTIONS(5707),
    [sym_int] = ACTIONS(5709),
    [sym_xint] = ACTIONS(5711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3946] = {
    [sym_attributes] = STATE(3968),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(5183),
    [sym__pattern] = STATE(5067),
    [sym_optional_pattern] = STATE(5183),
    [sym_type_check_pattern] = STATE(5183),
    [sym_attribute_pattern] = STATE(5183),
    [sym_paren_pattern] = STATE(5183),
    [sym_as_pattern] = STATE(5183),
    [sym_cons_pattern] = STATE(5183),
    [sym_disjunct_pattern] = STATE(5183),
    [sym_conjunct_pattern] = STATE(5183),
    [sym_typed_pattern] = STATE(5183),
    [sym_list_pattern] = STATE(5183),
    [sym_array_pattern] = STATE(5183),
    [sym_record_pattern] = STATE(5183),
    [sym_named_field_pattern] = STATE(5183),
    [sym_identifier_pattern] = STATE(5183),
    [sym_long_identifier_or_op] = STATE(3528),
    [sym_char] = STATE(5133),
    [sym_format_string] = STATE(5135),
    [sym__string_literal] = STATE(5135),
    [sym_string] = STATE(5133),
    [sym_verbatim_string] = STATE(5133),
    [sym_bytearray] = STATE(5133),
    [sym_verbatim_bytearray] = STATE(5133),
    [sym_format_triple_quoted_string] = STATE(5136),
    [sym_triple_quoted_string] = STATE(5133),
    [sym_const] = STATE(5183),
    [sym_long_identifier] = STATE(4953),
    [sym_active_pattern] = STATE(5117),
    [sym__identifier_or_op] = STATE(5167),
    [sym_sbyte] = STATE(5133),
    [sym_byte] = STATE(5133),
    [sym_int16] = STATE(5133),
    [sym_uint16] = STATE(5133),
    [sym_int32] = STATE(5133),
    [sym_uint32] = STATE(5133),
    [sym_nativeint] = STATE(5133),
    [sym_unativeint] = STATE(5133),
    [sym_int64] = STATE(5133),
    [sym_uint64] = STATE(5133),
    [sym_ieee32] = STATE(5133),
    [sym_ieee64] = STATE(5133),
    [sym_bignum] = STATE(5133),
    [sym_decimal] = STATE(5133),
    [sym_float] = STATE(4916),
    [sym_block_comment] = STATE(3946),
    [sym_compiler_directive_decl] = STATE(3946),
    [sym_fsi_directive_decl] = STATE(3946),
    [sym_preproc_line] = STATE(3946),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5671),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5944),
    [anon_sym_null] = ACTIONS(5946),
    [anon_sym__] = ACTIONS(5948),
    [anon_sym_QMARK] = ACTIONS(5950),
    [anon_sym_COLON_QMARK] = ACTIONS(5952),
    [anon_sym_LBRACK] = ACTIONS(5954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5956),
    [anon_sym_LBRACE] = ACTIONS(5958),
    [aux_sym_char_token1] = ACTIONS(5960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5962),
    [anon_sym_DQUOTE] = ACTIONS(5964),
    [anon_sym_AT_DQUOTE] = ACTIONS(5966),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5968),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5970),
    [sym_bool] = ACTIONS(5972),
    [sym_unit] = ACTIONS(5974),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5705),
    [sym_op_identifier] = ACTIONS(5707),
    [sym_int] = ACTIONS(5976),
    [sym_xint] = ACTIONS(5978),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3947] = {
    [sym_attributes] = STATE(3976),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(8306),
    [sym__pattern] = STATE(8108),
    [sym_optional_pattern] = STATE(8306),
    [sym_type_check_pattern] = STATE(8306),
    [sym_attribute_pattern] = STATE(8306),
    [sym_paren_pattern] = STATE(8306),
    [sym_as_pattern] = STATE(8306),
    [sym_cons_pattern] = STATE(8306),
    [sym_disjunct_pattern] = STATE(8306),
    [sym_conjunct_pattern] = STATE(8306),
    [sym_typed_pattern] = STATE(8306),
    [sym_list_pattern] = STATE(8306),
    [sym_array_pattern] = STATE(8306),
    [sym_record_pattern] = STATE(8306),
    [sym_named_field_pattern] = STATE(8306),
    [sym_identifier_pattern] = STATE(8306),
    [sym_long_identifier_or_op] = STATE(3457),
    [sym_char] = STATE(8299),
    [sym_format_string] = STATE(8384),
    [sym__string_literal] = STATE(8384),
    [sym_string] = STATE(8299),
    [sym_verbatim_string] = STATE(8299),
    [sym_bytearray] = STATE(8299),
    [sym_verbatim_bytearray] = STATE(8299),
    [sym_format_triple_quoted_string] = STATE(8395),
    [sym_triple_quoted_string] = STATE(8299),
    [sym_const] = STATE(8306),
    [sym_long_identifier] = STATE(4953),
    [sym_active_pattern] = STATE(5117),
    [sym__identifier_or_op] = STATE(5167),
    [sym_sbyte] = STATE(8299),
    [sym_byte] = STATE(8299),
    [sym_int16] = STATE(8299),
    [sym_uint16] = STATE(8299),
    [sym_int32] = STATE(8299),
    [sym_uint32] = STATE(8299),
    [sym_nativeint] = STATE(8299),
    [sym_unativeint] = STATE(8299),
    [sym_int64] = STATE(8299),
    [sym_uint64] = STATE(8299),
    [sym_ieee32] = STATE(8299),
    [sym_ieee64] = STATE(8299),
    [sym_bignum] = STATE(8299),
    [sym_decimal] = STATE(8299),
    [sym_float] = STATE(7864),
    [sym_block_comment] = STATE(3947),
    [sym_compiler_directive_decl] = STATE(3947),
    [sym_fsi_directive_decl] = STATE(3947),
    [sym_preproc_line] = STATE(3947),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5671),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5673),
    [anon_sym_null] = ACTIONS(5675),
    [anon_sym__] = ACTIONS(5677),
    [anon_sym_QMARK] = ACTIONS(5679),
    [anon_sym_COLON_QMARK] = ACTIONS(5681),
    [anon_sym_LBRACK] = ACTIONS(5683),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5685),
    [anon_sym_LBRACE] = ACTIONS(5687),
    [aux_sym_char_token1] = ACTIONS(5689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5691),
    [anon_sym_DQUOTE] = ACTIONS(5693),
    [anon_sym_AT_DQUOTE] = ACTIONS(5695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5699),
    [sym_bool] = ACTIONS(5701),
    [sym_unit] = ACTIONS(5703),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5705),
    [sym_op_identifier] = ACTIONS(5707),
    [sym_int] = ACTIONS(5709),
    [sym_xint] = ACTIONS(5711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3948] = {
    [sym_attributes] = STATE(3968),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(5183),
    [sym__pattern] = STATE(5064),
    [sym_optional_pattern] = STATE(5183),
    [sym_type_check_pattern] = STATE(5183),
    [sym_attribute_pattern] = STATE(5183),
    [sym_paren_pattern] = STATE(5183),
    [sym_as_pattern] = STATE(5183),
    [sym_cons_pattern] = STATE(5183),
    [sym_disjunct_pattern] = STATE(5183),
    [sym_conjunct_pattern] = STATE(5183),
    [sym_typed_pattern] = STATE(5183),
    [sym_list_pattern] = STATE(5183),
    [sym_array_pattern] = STATE(5183),
    [sym_record_pattern] = STATE(5183),
    [sym_named_field_pattern] = STATE(5183),
    [sym_identifier_pattern] = STATE(5183),
    [sym_long_identifier_or_op] = STATE(3528),
    [sym_char] = STATE(5133),
    [sym_format_string] = STATE(5135),
    [sym__string_literal] = STATE(5135),
    [sym_string] = STATE(5133),
    [sym_verbatim_string] = STATE(5133),
    [sym_bytearray] = STATE(5133),
    [sym_verbatim_bytearray] = STATE(5133),
    [sym_format_triple_quoted_string] = STATE(5136),
    [sym_triple_quoted_string] = STATE(5133),
    [sym_const] = STATE(5183),
    [sym_long_identifier] = STATE(4953),
    [sym_active_pattern] = STATE(5117),
    [sym__identifier_or_op] = STATE(5167),
    [sym_sbyte] = STATE(5133),
    [sym_byte] = STATE(5133),
    [sym_int16] = STATE(5133),
    [sym_uint16] = STATE(5133),
    [sym_int32] = STATE(5133),
    [sym_uint32] = STATE(5133),
    [sym_nativeint] = STATE(5133),
    [sym_unativeint] = STATE(5133),
    [sym_int64] = STATE(5133),
    [sym_uint64] = STATE(5133),
    [sym_ieee32] = STATE(5133),
    [sym_ieee64] = STATE(5133),
    [sym_bignum] = STATE(5133),
    [sym_decimal] = STATE(5133),
    [sym_float] = STATE(4916),
    [sym_block_comment] = STATE(3948),
    [sym_compiler_directive_decl] = STATE(3948),
    [sym_fsi_directive_decl] = STATE(3948),
    [sym_preproc_line] = STATE(3948),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5671),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5944),
    [anon_sym_null] = ACTIONS(5946),
    [anon_sym__] = ACTIONS(5948),
    [anon_sym_QMARK] = ACTIONS(5950),
    [anon_sym_COLON_QMARK] = ACTIONS(5952),
    [anon_sym_LBRACK] = ACTIONS(5954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5956),
    [anon_sym_LBRACE] = ACTIONS(5958),
    [aux_sym_char_token1] = ACTIONS(5960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5962),
    [anon_sym_DQUOTE] = ACTIONS(5964),
    [anon_sym_AT_DQUOTE] = ACTIONS(5966),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5968),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5970),
    [sym_bool] = ACTIONS(5972),
    [sym_unit] = ACTIONS(5974),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5705),
    [sym_op_identifier] = ACTIONS(5707),
    [sym_int] = ACTIONS(5976),
    [sym_xint] = ACTIONS(5978),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3949] = {
    [sym_attributes] = STATE(3966),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8433),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3594),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3949),
    [sym_compiler_directive_decl] = STATE(3949),
    [sym_fsi_directive_decl] = STATE(3949),
    [sym_preproc_line] = STATE(3949),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(6460),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5837),
    [anon_sym_COLON_QMARK] = ACTIONS(5839),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3950] = {
    [sym_attributes] = STATE(3966),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8341),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3594),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3950),
    [sym_compiler_directive_decl] = STATE(3950),
    [sym_fsi_directive_decl] = STATE(3950),
    [sym_preproc_line] = STATE(3950),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5835),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5837),
    [anon_sym_COLON_QMARK] = ACTIONS(5839),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3951] = {
    [sym_attributes] = STATE(3966),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8434),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3594),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3951),
    [sym_compiler_directive_decl] = STATE(3951),
    [sym_fsi_directive_decl] = STATE(3951),
    [sym_preproc_line] = STATE(3951),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(6490),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5837),
    [anon_sym_COLON_QMARK] = ACTIONS(5839),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3952] = {
    [sym_attributes] = STATE(3966),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8437),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3594),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3952),
    [sym_compiler_directive_decl] = STATE(3952),
    [sym_fsi_directive_decl] = STATE(3952),
    [sym_preproc_line] = STATE(3952),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(6460),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5837),
    [anon_sym_COLON_QMARK] = ACTIONS(5839),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3953] = {
    [sym_attributes] = STATE(3953),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(5287),
    [sym__pattern] = STATE(5169),
    [sym_optional_pattern] = STATE(5287),
    [sym_type_check_pattern] = STATE(5287),
    [sym_attribute_pattern] = STATE(5287),
    [sym_paren_pattern] = STATE(5287),
    [sym_as_pattern] = STATE(5287),
    [sym_cons_pattern] = STATE(5287),
    [sym_disjunct_pattern] = STATE(5287),
    [sym_conjunct_pattern] = STATE(5287),
    [sym_typed_pattern] = STATE(5287),
    [sym_list_pattern] = STATE(5287),
    [sym_array_pattern] = STATE(5287),
    [sym_record_pattern] = STATE(5287),
    [sym_named_field_pattern] = STATE(5287),
    [sym_identifier_pattern] = STATE(5287),
    [sym_long_identifier_or_op] = STATE(3587),
    [sym_char] = STATE(5281),
    [sym_format_string] = STATE(5312),
    [sym__string_literal] = STATE(5312),
    [sym_string] = STATE(5281),
    [sym_verbatim_string] = STATE(5281),
    [sym_bytearray] = STATE(5281),
    [sym_verbatim_bytearray] = STATE(5281),
    [sym_format_triple_quoted_string] = STATE(5246),
    [sym_triple_quoted_string] = STATE(5281),
    [sym_const] = STATE(5287),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(5281),
    [sym_byte] = STATE(5281),
    [sym_int16] = STATE(5281),
    [sym_uint16] = STATE(5281),
    [sym_int32] = STATE(5281),
    [sym_uint32] = STATE(5281),
    [sym_nativeint] = STATE(5281),
    [sym_unativeint] = STATE(5281),
    [sym_int64] = STATE(5281),
    [sym_uint64] = STATE(5281),
    [sym_ieee32] = STATE(5281),
    [sym_ieee64] = STATE(5281),
    [sym_bignum] = STATE(5281),
    [sym_decimal] = STATE(5281),
    [sym_float] = STATE(4951),
    [sym_block_comment] = STATE(3953),
    [sym_compiler_directive_decl] = STATE(3953),
    [sym_fsi_directive_decl] = STATE(3953),
    [sym_preproc_line] = STATE(3953),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5835),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(6041),
    [anon_sym_null] = ACTIONS(6043),
    [anon_sym__] = ACTIONS(6045),
    [anon_sym_QMARK] = ACTIONS(6047),
    [anon_sym_COLON_QMARK] = ACTIONS(6049),
    [anon_sym_LBRACK] = ACTIONS(6051),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6053),
    [anon_sym_LBRACE] = ACTIONS(6055),
    [aux_sym_char_token1] = ACTIONS(6057),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6059),
    [anon_sym_DQUOTE] = ACTIONS(6061),
    [anon_sym_AT_DQUOTE] = ACTIONS(6063),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6065),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6067),
    [sym_bool] = ACTIONS(6069),
    [sym_unit] = ACTIONS(6071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(6073),
    [sym_xint] = ACTIONS(6075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3954] = {
    [sym_attributes] = STATE(3953),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(5287),
    [sym__pattern] = STATE(5125),
    [sym_optional_pattern] = STATE(5287),
    [sym_type_check_pattern] = STATE(5287),
    [sym_attribute_pattern] = STATE(5287),
    [sym_paren_pattern] = STATE(5287),
    [sym_as_pattern] = STATE(5287),
    [sym_cons_pattern] = STATE(5287),
    [sym_disjunct_pattern] = STATE(5287),
    [sym_conjunct_pattern] = STATE(5287),
    [sym_typed_pattern] = STATE(5287),
    [sym_list_pattern] = STATE(5287),
    [sym_array_pattern] = STATE(5287),
    [sym_record_pattern] = STATE(5287),
    [sym_named_field_pattern] = STATE(5287),
    [sym_identifier_pattern] = STATE(5287),
    [sym_long_identifier_or_op] = STATE(3587),
    [sym_char] = STATE(5281),
    [sym_format_string] = STATE(5312),
    [sym__string_literal] = STATE(5312),
    [sym_string] = STATE(5281),
    [sym_verbatim_string] = STATE(5281),
    [sym_bytearray] = STATE(5281),
    [sym_verbatim_bytearray] = STATE(5281),
    [sym_format_triple_quoted_string] = STATE(5246),
    [sym_triple_quoted_string] = STATE(5281),
    [sym_const] = STATE(5287),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(5281),
    [sym_byte] = STATE(5281),
    [sym_int16] = STATE(5281),
    [sym_uint16] = STATE(5281),
    [sym_int32] = STATE(5281),
    [sym_uint32] = STATE(5281),
    [sym_nativeint] = STATE(5281),
    [sym_unativeint] = STATE(5281),
    [sym_int64] = STATE(5281),
    [sym_uint64] = STATE(5281),
    [sym_ieee32] = STATE(5281),
    [sym_ieee64] = STATE(5281),
    [sym_bignum] = STATE(5281),
    [sym_decimal] = STATE(5281),
    [sym_float] = STATE(4951),
    [sym_block_comment] = STATE(3954),
    [sym_compiler_directive_decl] = STATE(3954),
    [sym_fsi_directive_decl] = STATE(3954),
    [sym_preproc_line] = STATE(3954),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5835),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(6041),
    [anon_sym_null] = ACTIONS(6043),
    [anon_sym__] = ACTIONS(6045),
    [anon_sym_QMARK] = ACTIONS(6047),
    [anon_sym_COLON_QMARK] = ACTIONS(6049),
    [anon_sym_LBRACK] = ACTIONS(6051),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6053),
    [anon_sym_LBRACE] = ACTIONS(6055),
    [aux_sym_char_token1] = ACTIONS(6057),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6059),
    [anon_sym_DQUOTE] = ACTIONS(6061),
    [anon_sym_AT_DQUOTE] = ACTIONS(6063),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6065),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6067),
    [sym_bool] = ACTIONS(6069),
    [sym_unit] = ACTIONS(6071),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(6073),
    [sym_xint] = ACTIONS(6075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3955] = {
    [sym_attributes] = STATE(3966),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8371),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3594),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3955),
    [sym_compiler_directive_decl] = STATE(3955),
    [sym_fsi_directive_decl] = STATE(3955),
    [sym_preproc_line] = STATE(3955),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(6490),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5837),
    [anon_sym_COLON_QMARK] = ACTIONS(5839),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3956] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7987),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3956),
    [sym_compiler_directive_decl] = STATE(3956),
    [sym_fsi_directive_decl] = STATE(3956),
    [sym_preproc_line] = STATE(3956),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3957] = {
    [sym_attributes] = STATE(3988),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4988),
    [sym__pattern] = STATE(4903),
    [sym_optional_pattern] = STATE(4988),
    [sym_type_check_pattern] = STATE(4988),
    [sym_attribute_pattern] = STATE(4988),
    [sym_paren_pattern] = STATE(4988),
    [sym_as_pattern] = STATE(4988),
    [sym_cons_pattern] = STATE(4988),
    [sym_disjunct_pattern] = STATE(4988),
    [sym_conjunct_pattern] = STATE(4988),
    [sym_typed_pattern] = STATE(4988),
    [sym_list_pattern] = STATE(4988),
    [sym_array_pattern] = STATE(4988),
    [sym_record_pattern] = STATE(4988),
    [sym_named_field_pattern] = STATE(4988),
    [sym_identifier_pattern] = STATE(4988),
    [sym_long_identifier_or_op] = STATE(3177),
    [sym_char] = STATE(5109),
    [sym_format_string] = STATE(5097),
    [sym__string_literal] = STATE(5097),
    [sym_string] = STATE(5109),
    [sym_verbatim_string] = STATE(5109),
    [sym_bytearray] = STATE(5109),
    [sym_verbatim_bytearray] = STATE(5109),
    [sym_format_triple_quoted_string] = STATE(5096),
    [sym_triple_quoted_string] = STATE(5109),
    [sym_const] = STATE(4988),
    [sym_long_identifier] = STATE(4907),
    [sym_active_pattern] = STATE(5059),
    [sym__identifier_or_op] = STATE(4927),
    [sym_sbyte] = STATE(5109),
    [sym_byte] = STATE(5109),
    [sym_int16] = STATE(5109),
    [sym_uint16] = STATE(5109),
    [sym_int32] = STATE(5109),
    [sym_uint32] = STATE(5109),
    [sym_nativeint] = STATE(5109),
    [sym_unativeint] = STATE(5109),
    [sym_int64] = STATE(5109),
    [sym_uint64] = STATE(5109),
    [sym_ieee32] = STATE(5109),
    [sym_ieee64] = STATE(5109),
    [sym_bignum] = STATE(5109),
    [sym_decimal] = STATE(5109),
    [sym_float] = STATE(4781),
    [sym_block_comment] = STATE(3957),
    [sym_compiler_directive_decl] = STATE(3957),
    [sym_fsi_directive_decl] = STATE(3957),
    [sym_preproc_line] = STATE(3957),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5490),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5560),
    [anon_sym_null] = ACTIONS(5564),
    [anon_sym__] = ACTIONS(5566),
    [anon_sym_QMARK] = ACTIONS(5568),
    [anon_sym_COLON_QMARK] = ACTIONS(5570),
    [anon_sym_LBRACK] = ACTIONS(5572),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5574),
    [anon_sym_LBRACE] = ACTIONS(5576),
    [aux_sym_char_token1] = ACTIONS(5578),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5580),
    [anon_sym_DQUOTE] = ACTIONS(5582),
    [anon_sym_AT_DQUOTE] = ACTIONS(5584),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5586),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5588),
    [sym_bool] = ACTIONS(5590),
    [sym_unit] = ACTIONS(5592),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5524),
    [sym_op_identifier] = ACTIONS(5526),
    [sym_int] = ACTIONS(5594),
    [sym_xint] = ACTIONS(5596),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3958] = {
    [sym_attributes] = STATE(3988),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4988),
    [sym__pattern] = STATE(4904),
    [sym_optional_pattern] = STATE(4988),
    [sym_type_check_pattern] = STATE(4988),
    [sym_attribute_pattern] = STATE(4988),
    [sym_paren_pattern] = STATE(4988),
    [sym_as_pattern] = STATE(4988),
    [sym_cons_pattern] = STATE(4988),
    [sym_disjunct_pattern] = STATE(4988),
    [sym_conjunct_pattern] = STATE(4988),
    [sym_typed_pattern] = STATE(4988),
    [sym_list_pattern] = STATE(4988),
    [sym_array_pattern] = STATE(4988),
    [sym_record_pattern] = STATE(4988),
    [sym_named_field_pattern] = STATE(4988),
    [sym_identifier_pattern] = STATE(4988),
    [sym_long_identifier_or_op] = STATE(3177),
    [sym_char] = STATE(5109),
    [sym_format_string] = STATE(5097),
    [sym__string_literal] = STATE(5097),
    [sym_string] = STATE(5109),
    [sym_verbatim_string] = STATE(5109),
    [sym_bytearray] = STATE(5109),
    [sym_verbatim_bytearray] = STATE(5109),
    [sym_format_triple_quoted_string] = STATE(5096),
    [sym_triple_quoted_string] = STATE(5109),
    [sym_const] = STATE(4988),
    [sym_long_identifier] = STATE(4907),
    [sym_active_pattern] = STATE(5059),
    [sym__identifier_or_op] = STATE(4927),
    [sym_sbyte] = STATE(5109),
    [sym_byte] = STATE(5109),
    [sym_int16] = STATE(5109),
    [sym_uint16] = STATE(5109),
    [sym_int32] = STATE(5109),
    [sym_uint32] = STATE(5109),
    [sym_nativeint] = STATE(5109),
    [sym_unativeint] = STATE(5109),
    [sym_int64] = STATE(5109),
    [sym_uint64] = STATE(5109),
    [sym_ieee32] = STATE(5109),
    [sym_ieee64] = STATE(5109),
    [sym_bignum] = STATE(5109),
    [sym_decimal] = STATE(5109),
    [sym_float] = STATE(4781),
    [sym_block_comment] = STATE(3958),
    [sym_compiler_directive_decl] = STATE(3958),
    [sym_fsi_directive_decl] = STATE(3958),
    [sym_preproc_line] = STATE(3958),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5490),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5560),
    [anon_sym_null] = ACTIONS(5564),
    [anon_sym__] = ACTIONS(5566),
    [anon_sym_QMARK] = ACTIONS(5568),
    [anon_sym_COLON_QMARK] = ACTIONS(5570),
    [anon_sym_LBRACK] = ACTIONS(5572),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5574),
    [anon_sym_LBRACE] = ACTIONS(5576),
    [aux_sym_char_token1] = ACTIONS(5578),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5580),
    [anon_sym_DQUOTE] = ACTIONS(5582),
    [anon_sym_AT_DQUOTE] = ACTIONS(5584),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5586),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5588),
    [sym_bool] = ACTIONS(5590),
    [sym_unit] = ACTIONS(5592),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5524),
    [sym_op_identifier] = ACTIONS(5526),
    [sym_int] = ACTIONS(5594),
    [sym_xint] = ACTIONS(5596),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3959] = {
    [sym_attributes] = STATE(3960),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(5177),
    [sym__pattern] = STATE(5045),
    [sym_optional_pattern] = STATE(5177),
    [sym_type_check_pattern] = STATE(5177),
    [sym_attribute_pattern] = STATE(5177),
    [sym_paren_pattern] = STATE(5177),
    [sym_as_pattern] = STATE(5177),
    [sym_cons_pattern] = STATE(5177),
    [sym_disjunct_pattern] = STATE(5177),
    [sym_conjunct_pattern] = STATE(5177),
    [sym_typed_pattern] = STATE(5177),
    [sym_list_pattern] = STATE(5177),
    [sym_array_pattern] = STATE(5177),
    [sym_record_pattern] = STATE(5177),
    [sym_named_field_pattern] = STATE(5177),
    [sym_identifier_pattern] = STATE(5177),
    [sym_long_identifier_or_op] = STATE(3306),
    [sym_char] = STATE(5226),
    [sym_format_string] = STATE(5239),
    [sym__string_literal] = STATE(5239),
    [sym_string] = STATE(5226),
    [sym_verbatim_string] = STATE(5226),
    [sym_bytearray] = STATE(5226),
    [sym_verbatim_bytearray] = STATE(5226),
    [sym_format_triple_quoted_string] = STATE(5238),
    [sym_triple_quoted_string] = STATE(5226),
    [sym_const] = STATE(5177),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(5226),
    [sym_byte] = STATE(5226),
    [sym_int16] = STATE(5226),
    [sym_uint16] = STATE(5226),
    [sym_int32] = STATE(5226),
    [sym_uint32] = STATE(5226),
    [sym_nativeint] = STATE(5226),
    [sym_unativeint] = STATE(5226),
    [sym_int64] = STATE(5226),
    [sym_uint64] = STATE(5226),
    [sym_ieee32] = STATE(5226),
    [sym_ieee64] = STATE(5226),
    [sym_bignum] = STATE(5226),
    [sym_decimal] = STATE(5226),
    [sym_float] = STATE(4814),
    [sym_block_comment] = STATE(3959),
    [sym_compiler_directive_decl] = STATE(3959),
    [sym_fsi_directive_decl] = STATE(3959),
    [sym_preproc_line] = STATE(3959),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5845),
    [anon_sym_null] = ACTIONS(5847),
    [anon_sym__] = ACTIONS(5849),
    [anon_sym_QMARK] = ACTIONS(5851),
    [anon_sym_COLON_QMARK] = ACTIONS(5853),
    [anon_sym_LBRACK] = ACTIONS(5855),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5857),
    [anon_sym_LBRACE] = ACTIONS(5859),
    [aux_sym_char_token1] = ACTIONS(5861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5863),
    [anon_sym_DQUOTE] = ACTIONS(5865),
    [anon_sym_AT_DQUOTE] = ACTIONS(5867),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5871),
    [sym_bool] = ACTIONS(5873),
    [sym_unit] = ACTIONS(5875),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5877),
    [sym_xint] = ACTIONS(5879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3960] = {
    [sym_attributes] = STATE(3960),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(5177),
    [sym__pattern] = STATE(5056),
    [sym_optional_pattern] = STATE(5177),
    [sym_type_check_pattern] = STATE(5177),
    [sym_attribute_pattern] = STATE(5177),
    [sym_paren_pattern] = STATE(5177),
    [sym_as_pattern] = STATE(5177),
    [sym_cons_pattern] = STATE(5177),
    [sym_disjunct_pattern] = STATE(5177),
    [sym_conjunct_pattern] = STATE(5177),
    [sym_typed_pattern] = STATE(5177),
    [sym_list_pattern] = STATE(5177),
    [sym_array_pattern] = STATE(5177),
    [sym_record_pattern] = STATE(5177),
    [sym_named_field_pattern] = STATE(5177),
    [sym_identifier_pattern] = STATE(5177),
    [sym_long_identifier_or_op] = STATE(3306),
    [sym_char] = STATE(5226),
    [sym_format_string] = STATE(5239),
    [sym__string_literal] = STATE(5239),
    [sym_string] = STATE(5226),
    [sym_verbatim_string] = STATE(5226),
    [sym_bytearray] = STATE(5226),
    [sym_verbatim_bytearray] = STATE(5226),
    [sym_format_triple_quoted_string] = STATE(5238),
    [sym_triple_quoted_string] = STATE(5226),
    [sym_const] = STATE(5177),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(5226),
    [sym_byte] = STATE(5226),
    [sym_int16] = STATE(5226),
    [sym_uint16] = STATE(5226),
    [sym_int32] = STATE(5226),
    [sym_uint32] = STATE(5226),
    [sym_nativeint] = STATE(5226),
    [sym_unativeint] = STATE(5226),
    [sym_int64] = STATE(5226),
    [sym_uint64] = STATE(5226),
    [sym_ieee32] = STATE(5226),
    [sym_ieee64] = STATE(5226),
    [sym_bignum] = STATE(5226),
    [sym_decimal] = STATE(5226),
    [sym_float] = STATE(4814),
    [sym_block_comment] = STATE(3960),
    [sym_compiler_directive_decl] = STATE(3960),
    [sym_fsi_directive_decl] = STATE(3960),
    [sym_preproc_line] = STATE(3960),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5845),
    [anon_sym_null] = ACTIONS(5847),
    [anon_sym__] = ACTIONS(5849),
    [anon_sym_QMARK] = ACTIONS(5851),
    [anon_sym_COLON_QMARK] = ACTIONS(5853),
    [anon_sym_LBRACK] = ACTIONS(5855),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5857),
    [anon_sym_LBRACE] = ACTIONS(5859),
    [aux_sym_char_token1] = ACTIONS(5861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5863),
    [anon_sym_DQUOTE] = ACTIONS(5865),
    [anon_sym_AT_DQUOTE] = ACTIONS(5867),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5871),
    [sym_bool] = ACTIONS(5873),
    [sym_unit] = ACTIONS(5875),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5877),
    [sym_xint] = ACTIONS(5879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3961] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8161),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3961),
    [sym_compiler_directive_decl] = STATE(3961),
    [sym_fsi_directive_decl] = STATE(3961),
    [sym_preproc_line] = STATE(3961),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3962] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8417),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3962),
    [sym_compiler_directive_decl] = STATE(3962),
    [sym_fsi_directive_decl] = STATE(3962),
    [sym_preproc_line] = STATE(3962),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3963] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(4887),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3963),
    [sym_compiler_directive_decl] = STATE(3963),
    [sym_fsi_directive_decl] = STATE(3963),
    [sym_preproc_line] = STATE(3963),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3964] = {
    [sym_attributes] = STATE(3988),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4988),
    [sym__pattern] = STATE(4905),
    [sym_optional_pattern] = STATE(4988),
    [sym_type_check_pattern] = STATE(4988),
    [sym_attribute_pattern] = STATE(4988),
    [sym_paren_pattern] = STATE(4988),
    [sym_as_pattern] = STATE(4988),
    [sym_cons_pattern] = STATE(4988),
    [sym_disjunct_pattern] = STATE(4988),
    [sym_conjunct_pattern] = STATE(4988),
    [sym_typed_pattern] = STATE(4988),
    [sym_list_pattern] = STATE(4988),
    [sym_array_pattern] = STATE(4988),
    [sym_record_pattern] = STATE(4988),
    [sym_named_field_pattern] = STATE(4988),
    [sym_identifier_pattern] = STATE(4988),
    [sym_long_identifier_or_op] = STATE(3177),
    [sym_char] = STATE(5109),
    [sym_format_string] = STATE(5097),
    [sym__string_literal] = STATE(5097),
    [sym_string] = STATE(5109),
    [sym_verbatim_string] = STATE(5109),
    [sym_bytearray] = STATE(5109),
    [sym_verbatim_bytearray] = STATE(5109),
    [sym_format_triple_quoted_string] = STATE(5096),
    [sym_triple_quoted_string] = STATE(5109),
    [sym_const] = STATE(4988),
    [sym_long_identifier] = STATE(4907),
    [sym_active_pattern] = STATE(5059),
    [sym__identifier_or_op] = STATE(4927),
    [sym_sbyte] = STATE(5109),
    [sym_byte] = STATE(5109),
    [sym_int16] = STATE(5109),
    [sym_uint16] = STATE(5109),
    [sym_int32] = STATE(5109),
    [sym_uint32] = STATE(5109),
    [sym_nativeint] = STATE(5109),
    [sym_unativeint] = STATE(5109),
    [sym_int64] = STATE(5109),
    [sym_uint64] = STATE(5109),
    [sym_ieee32] = STATE(5109),
    [sym_ieee64] = STATE(5109),
    [sym_bignum] = STATE(5109),
    [sym_decimal] = STATE(5109),
    [sym_float] = STATE(4781),
    [sym_block_comment] = STATE(3964),
    [sym_compiler_directive_decl] = STATE(3964),
    [sym_fsi_directive_decl] = STATE(3964),
    [sym_preproc_line] = STATE(3964),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5490),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5560),
    [anon_sym_null] = ACTIONS(5564),
    [anon_sym__] = ACTIONS(5566),
    [anon_sym_QMARK] = ACTIONS(5568),
    [anon_sym_COLON_QMARK] = ACTIONS(5570),
    [anon_sym_LBRACK] = ACTIONS(5572),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5574),
    [anon_sym_LBRACE] = ACTIONS(5576),
    [aux_sym_char_token1] = ACTIONS(5578),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5580),
    [anon_sym_DQUOTE] = ACTIONS(5582),
    [anon_sym_AT_DQUOTE] = ACTIONS(5584),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5586),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5588),
    [sym_bool] = ACTIONS(5590),
    [sym_unit] = ACTIONS(5592),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5524),
    [sym_op_identifier] = ACTIONS(5526),
    [sym_int] = ACTIONS(5594),
    [sym_xint] = ACTIONS(5596),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3965] = {
    [sym_attributes] = STATE(3891),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8170),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3303),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3965),
    [sym_compiler_directive_decl] = STATE(3965),
    [sym_fsi_directive_decl] = STATE(3965),
    [sym_preproc_line] = STATE(3965),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5657),
    [anon_sym_COLON_QMARK] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3966] = {
    [sym_attributes] = STATE(3966),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8330),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3594),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3966),
    [sym_compiler_directive_decl] = STATE(3966),
    [sym_fsi_directive_decl] = STATE(3966),
    [sym_preproc_line] = STATE(3966),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5835),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5837),
    [anon_sym_COLON_QMARK] = ACTIONS(5839),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3967] = {
    [sym_attributes] = STATE(3967),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4926),
    [sym__pattern] = STATE(4841),
    [sym_optional_pattern] = STATE(4926),
    [sym_type_check_pattern] = STATE(4926),
    [sym_attribute_pattern] = STATE(4926),
    [sym_paren_pattern] = STATE(4926),
    [sym_as_pattern] = STATE(4926),
    [sym_cons_pattern] = STATE(4926),
    [sym_disjunct_pattern] = STATE(4926),
    [sym_conjunct_pattern] = STATE(4926),
    [sym_typed_pattern] = STATE(4926),
    [sym_list_pattern] = STATE(4926),
    [sym_array_pattern] = STATE(4926),
    [sym_record_pattern] = STATE(4926),
    [sym_named_field_pattern] = STATE(4926),
    [sym_identifier_pattern] = STATE(4926),
    [sym_long_identifier_or_op] = STATE(3110),
    [sym_char] = STATE(5061),
    [sym_format_string] = STATE(5054),
    [sym__string_literal] = STATE(5054),
    [sym_string] = STATE(5061),
    [sym_verbatim_string] = STATE(5061),
    [sym_bytearray] = STATE(5061),
    [sym_verbatim_bytearray] = STATE(5061),
    [sym_format_triple_quoted_string] = STATE(5044),
    [sym_triple_quoted_string] = STATE(5061),
    [sym_const] = STATE(4926),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(5061),
    [sym_byte] = STATE(5061),
    [sym_int16] = STATE(5061),
    [sym_uint16] = STATE(5061),
    [sym_int32] = STATE(5061),
    [sym_uint32] = STATE(5061),
    [sym_nativeint] = STATE(5061),
    [sym_unativeint] = STATE(5061),
    [sym_int64] = STATE(5061),
    [sym_uint64] = STATE(5061),
    [sym_ieee32] = STATE(5061),
    [sym_ieee64] = STATE(5061),
    [sym_bignum] = STATE(5061),
    [sym_decimal] = STATE(5061),
    [sym_float] = STATE(4788),
    [sym_block_comment] = STATE(3967),
    [sym_compiler_directive_decl] = STATE(3967),
    [sym_fsi_directive_decl] = STATE(3967),
    [sym_preproc_line] = STATE(3967),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [anon_sym_null] = ACTIONS(5727),
    [anon_sym__] = ACTIONS(5729),
    [anon_sym_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5735),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5737),
    [anon_sym_LBRACE] = ACTIONS(5739),
    [aux_sym_char_token1] = ACTIONS(5741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5743),
    [anon_sym_DQUOTE] = ACTIONS(5745),
    [anon_sym_AT_DQUOTE] = ACTIONS(5747),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5751),
    [sym_bool] = ACTIONS(5753),
    [sym_unit] = ACTIONS(5755),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5757),
    [sym_xint] = ACTIONS(5759),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3968] = {
    [sym_attributes] = STATE(3968),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(5183),
    [sym__pattern] = STATE(4956),
    [sym_optional_pattern] = STATE(5183),
    [sym_type_check_pattern] = STATE(5183),
    [sym_attribute_pattern] = STATE(5183),
    [sym_paren_pattern] = STATE(5183),
    [sym_as_pattern] = STATE(5183),
    [sym_cons_pattern] = STATE(5183),
    [sym_disjunct_pattern] = STATE(5183),
    [sym_conjunct_pattern] = STATE(5183),
    [sym_typed_pattern] = STATE(5183),
    [sym_list_pattern] = STATE(5183),
    [sym_array_pattern] = STATE(5183),
    [sym_record_pattern] = STATE(5183),
    [sym_named_field_pattern] = STATE(5183),
    [sym_identifier_pattern] = STATE(5183),
    [sym_long_identifier_or_op] = STATE(3528),
    [sym_char] = STATE(5133),
    [sym_format_string] = STATE(5135),
    [sym__string_literal] = STATE(5135),
    [sym_string] = STATE(5133),
    [sym_verbatim_string] = STATE(5133),
    [sym_bytearray] = STATE(5133),
    [sym_verbatim_bytearray] = STATE(5133),
    [sym_format_triple_quoted_string] = STATE(5136),
    [sym_triple_quoted_string] = STATE(5133),
    [sym_const] = STATE(5183),
    [sym_long_identifier] = STATE(4953),
    [sym_active_pattern] = STATE(5117),
    [sym__identifier_or_op] = STATE(5167),
    [sym_sbyte] = STATE(5133),
    [sym_byte] = STATE(5133),
    [sym_int16] = STATE(5133),
    [sym_uint16] = STATE(5133),
    [sym_int32] = STATE(5133),
    [sym_uint32] = STATE(5133),
    [sym_nativeint] = STATE(5133),
    [sym_unativeint] = STATE(5133),
    [sym_int64] = STATE(5133),
    [sym_uint64] = STATE(5133),
    [sym_ieee32] = STATE(5133),
    [sym_ieee64] = STATE(5133),
    [sym_bignum] = STATE(5133),
    [sym_decimal] = STATE(5133),
    [sym_float] = STATE(4916),
    [sym_block_comment] = STATE(3968),
    [sym_compiler_directive_decl] = STATE(3968),
    [sym_fsi_directive_decl] = STATE(3968),
    [sym_preproc_line] = STATE(3968),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5671),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5944),
    [anon_sym_null] = ACTIONS(5946),
    [anon_sym__] = ACTIONS(5948),
    [anon_sym_QMARK] = ACTIONS(5950),
    [anon_sym_COLON_QMARK] = ACTIONS(5952),
    [anon_sym_LBRACK] = ACTIONS(5954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5956),
    [anon_sym_LBRACE] = ACTIONS(5958),
    [aux_sym_char_token1] = ACTIONS(5960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5962),
    [anon_sym_DQUOTE] = ACTIONS(5964),
    [anon_sym_AT_DQUOTE] = ACTIONS(5966),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5968),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5970),
    [sym_bool] = ACTIONS(5972),
    [sym_unit] = ACTIONS(5974),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5705),
    [sym_op_identifier] = ACTIONS(5707),
    [sym_int] = ACTIONS(5976),
    [sym_xint] = ACTIONS(5978),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3969] = {
    [sym_attributes] = STATE(3966),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8337),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3594),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(5228),
    [sym_active_pattern] = STATE(5254),
    [sym__identifier_or_op] = STATE(5252),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3969),
    [sym_compiler_directive_decl] = STATE(3969),
    [sym_fsi_directive_decl] = STATE(3969),
    [sym_preproc_line] = STATE(3969),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5835),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5837),
    [anon_sym_COLON_QMARK] = ACTIONS(5839),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5841),
    [sym_op_identifier] = ACTIONS(5843),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3970] = {
    [sym_attributes] = STATE(3905),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(8258),
    [sym__pattern] = STATE(8102),
    [sym_optional_pattern] = STATE(8258),
    [sym_type_check_pattern] = STATE(8258),
    [sym_attribute_pattern] = STATE(8258),
    [sym_paren_pattern] = STATE(8258),
    [sym_as_pattern] = STATE(8258),
    [sym_cons_pattern] = STATE(8258),
    [sym_disjunct_pattern] = STATE(8258),
    [sym_conjunct_pattern] = STATE(8258),
    [sym_typed_pattern] = STATE(8258),
    [sym_list_pattern] = STATE(8258),
    [sym_array_pattern] = STATE(8258),
    [sym_record_pattern] = STATE(8258),
    [sym_named_field_pattern] = STATE(8258),
    [sym_identifier_pattern] = STATE(8258),
    [sym_long_identifier_or_op] = STATE(2968),
    [sym_char] = STATE(8017),
    [sym_format_string] = STATE(8065),
    [sym__string_literal] = STATE(8065),
    [sym_string] = STATE(8017),
    [sym_verbatim_string] = STATE(8017),
    [sym_bytearray] = STATE(8017),
    [sym_verbatim_bytearray] = STATE(8017),
    [sym_format_triple_quoted_string] = STATE(8066),
    [sym_triple_quoted_string] = STATE(8017),
    [sym_const] = STATE(8258),
    [sym_long_identifier] = STATE(4907),
    [sym_active_pattern] = STATE(5059),
    [sym__identifier_or_op] = STATE(4927),
    [sym_sbyte] = STATE(8017),
    [sym_byte] = STATE(8017),
    [sym_int16] = STATE(8017),
    [sym_uint16] = STATE(8017),
    [sym_int32] = STATE(8017),
    [sym_uint32] = STATE(8017),
    [sym_nativeint] = STATE(8017),
    [sym_unativeint] = STATE(8017),
    [sym_int64] = STATE(8017),
    [sym_uint64] = STATE(8017),
    [sym_ieee32] = STATE(8017),
    [sym_ieee64] = STATE(8017),
    [sym_bignum] = STATE(8017),
    [sym_decimal] = STATE(8017),
    [sym_float] = STATE(7544),
    [sym_block_comment] = STATE(3970),
    [sym_compiler_directive_decl] = STATE(3970),
    [sym_fsi_directive_decl] = STATE(3970),
    [sym_preproc_line] = STATE(3970),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5490),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5492),
    [anon_sym_null] = ACTIONS(5494),
    [anon_sym__] = ACTIONS(5496),
    [anon_sym_QMARK] = ACTIONS(5498),
    [anon_sym_COLON_QMARK] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5502),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5504),
    [anon_sym_LBRACE] = ACTIONS(5506),
    [aux_sym_char_token1] = ACTIONS(5508),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5510),
    [anon_sym_DQUOTE] = ACTIONS(5512),
    [anon_sym_AT_DQUOTE] = ACTIONS(5514),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5516),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5518),
    [sym_bool] = ACTIONS(5520),
    [sym_unit] = ACTIONS(5522),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5524),
    [sym_op_identifier] = ACTIONS(5526),
    [sym_int] = ACTIONS(5528),
    [sym_xint] = ACTIONS(5530),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3971] = {
    [sym_attributes] = STATE(3905),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(8258),
    [sym__pattern] = STATE(7932),
    [sym_optional_pattern] = STATE(8258),
    [sym_type_check_pattern] = STATE(8258),
    [sym_attribute_pattern] = STATE(8258),
    [sym_paren_pattern] = STATE(8258),
    [sym_as_pattern] = STATE(8258),
    [sym_cons_pattern] = STATE(8258),
    [sym_disjunct_pattern] = STATE(8258),
    [sym_conjunct_pattern] = STATE(8258),
    [sym_typed_pattern] = STATE(8258),
    [sym_list_pattern] = STATE(8258),
    [sym_array_pattern] = STATE(8258),
    [sym_record_pattern] = STATE(8258),
    [sym_named_field_pattern] = STATE(8258),
    [sym_identifier_pattern] = STATE(8258),
    [sym_long_identifier_or_op] = STATE(2968),
    [sym_char] = STATE(8017),
    [sym_format_string] = STATE(8065),
    [sym__string_literal] = STATE(8065),
    [sym_string] = STATE(8017),
    [sym_verbatim_string] = STATE(8017),
    [sym_bytearray] = STATE(8017),
    [sym_verbatim_bytearray] = STATE(8017),
    [sym_format_triple_quoted_string] = STATE(8066),
    [sym_triple_quoted_string] = STATE(8017),
    [sym_const] = STATE(8258),
    [sym_long_identifier] = STATE(4907),
    [sym_active_pattern] = STATE(5059),
    [sym__identifier_or_op] = STATE(4927),
    [sym_sbyte] = STATE(8017),
    [sym_byte] = STATE(8017),
    [sym_int16] = STATE(8017),
    [sym_uint16] = STATE(8017),
    [sym_int32] = STATE(8017),
    [sym_uint32] = STATE(8017),
    [sym_nativeint] = STATE(8017),
    [sym_unativeint] = STATE(8017),
    [sym_int64] = STATE(8017),
    [sym_uint64] = STATE(8017),
    [sym_ieee32] = STATE(8017),
    [sym_ieee64] = STATE(8017),
    [sym_bignum] = STATE(8017),
    [sym_decimal] = STATE(8017),
    [sym_float] = STATE(7544),
    [sym_block_comment] = STATE(3971),
    [sym_compiler_directive_decl] = STATE(3971),
    [sym_fsi_directive_decl] = STATE(3971),
    [sym_preproc_line] = STATE(3971),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5490),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5492),
    [anon_sym_null] = ACTIONS(5494),
    [anon_sym__] = ACTIONS(5496),
    [anon_sym_QMARK] = ACTIONS(5498),
    [anon_sym_COLON_QMARK] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5502),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5504),
    [anon_sym_LBRACE] = ACTIONS(5506),
    [aux_sym_char_token1] = ACTIONS(5508),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5510),
    [anon_sym_DQUOTE] = ACTIONS(5512),
    [anon_sym_AT_DQUOTE] = ACTIONS(5514),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5516),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5518),
    [sym_bool] = ACTIONS(5520),
    [sym_unit] = ACTIONS(5522),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5524),
    [sym_op_identifier] = ACTIONS(5526),
    [sym_int] = ACTIONS(5528),
    [sym_xint] = ACTIONS(5530),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3972] = {
    [sym_attributes] = STATE(3905),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(8258),
    [sym__pattern] = STATE(7939),
    [sym_optional_pattern] = STATE(8258),
    [sym_type_check_pattern] = STATE(8258),
    [sym_attribute_pattern] = STATE(8258),
    [sym_paren_pattern] = STATE(8258),
    [sym_as_pattern] = STATE(8258),
    [sym_cons_pattern] = STATE(8258),
    [sym_disjunct_pattern] = STATE(8258),
    [sym_conjunct_pattern] = STATE(8258),
    [sym_typed_pattern] = STATE(8258),
    [sym_list_pattern] = STATE(8258),
    [sym_array_pattern] = STATE(8258),
    [sym_record_pattern] = STATE(8258),
    [sym_named_field_pattern] = STATE(8258),
    [sym_identifier_pattern] = STATE(8258),
    [sym_long_identifier_or_op] = STATE(2968),
    [sym_char] = STATE(8017),
    [sym_format_string] = STATE(8065),
    [sym__string_literal] = STATE(8065),
    [sym_string] = STATE(8017),
    [sym_verbatim_string] = STATE(8017),
    [sym_bytearray] = STATE(8017),
    [sym_verbatim_bytearray] = STATE(8017),
    [sym_format_triple_quoted_string] = STATE(8066),
    [sym_triple_quoted_string] = STATE(8017),
    [sym_const] = STATE(8258),
    [sym_long_identifier] = STATE(4907),
    [sym_active_pattern] = STATE(5059),
    [sym__identifier_or_op] = STATE(4927),
    [sym_sbyte] = STATE(8017),
    [sym_byte] = STATE(8017),
    [sym_int16] = STATE(8017),
    [sym_uint16] = STATE(8017),
    [sym_int32] = STATE(8017),
    [sym_uint32] = STATE(8017),
    [sym_nativeint] = STATE(8017),
    [sym_unativeint] = STATE(8017),
    [sym_int64] = STATE(8017),
    [sym_uint64] = STATE(8017),
    [sym_ieee32] = STATE(8017),
    [sym_ieee64] = STATE(8017),
    [sym_bignum] = STATE(8017),
    [sym_decimal] = STATE(8017),
    [sym_float] = STATE(7544),
    [sym_block_comment] = STATE(3972),
    [sym_compiler_directive_decl] = STATE(3972),
    [sym_fsi_directive_decl] = STATE(3972),
    [sym_preproc_line] = STATE(3972),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5490),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5492),
    [anon_sym_null] = ACTIONS(5494),
    [anon_sym__] = ACTIONS(5496),
    [anon_sym_QMARK] = ACTIONS(5498),
    [anon_sym_COLON_QMARK] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5502),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5504),
    [anon_sym_LBRACE] = ACTIONS(5506),
    [aux_sym_char_token1] = ACTIONS(5508),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5510),
    [anon_sym_DQUOTE] = ACTIONS(5512),
    [anon_sym_AT_DQUOTE] = ACTIONS(5514),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5516),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5518),
    [sym_bool] = ACTIONS(5520),
    [sym_unit] = ACTIONS(5522),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5524),
    [sym_op_identifier] = ACTIONS(5526),
    [sym_int] = ACTIONS(5528),
    [sym_xint] = ACTIONS(5530),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3973] = {
    [sym_attributes] = STATE(3905),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(8258),
    [sym__pattern] = STATE(7944),
    [sym_optional_pattern] = STATE(8258),
    [sym_type_check_pattern] = STATE(8258),
    [sym_attribute_pattern] = STATE(8258),
    [sym_paren_pattern] = STATE(8258),
    [sym_as_pattern] = STATE(8258),
    [sym_cons_pattern] = STATE(8258),
    [sym_disjunct_pattern] = STATE(8258),
    [sym_conjunct_pattern] = STATE(8258),
    [sym_typed_pattern] = STATE(8258),
    [sym_list_pattern] = STATE(8258),
    [sym_array_pattern] = STATE(8258),
    [sym_record_pattern] = STATE(8258),
    [sym_named_field_pattern] = STATE(8258),
    [sym_identifier_pattern] = STATE(8258),
    [sym_long_identifier_or_op] = STATE(2968),
    [sym_char] = STATE(8017),
    [sym_format_string] = STATE(8065),
    [sym__string_literal] = STATE(8065),
    [sym_string] = STATE(8017),
    [sym_verbatim_string] = STATE(8017),
    [sym_bytearray] = STATE(8017),
    [sym_verbatim_bytearray] = STATE(8017),
    [sym_format_triple_quoted_string] = STATE(8066),
    [sym_triple_quoted_string] = STATE(8017),
    [sym_const] = STATE(8258),
    [sym_long_identifier] = STATE(4907),
    [sym_active_pattern] = STATE(5059),
    [sym__identifier_or_op] = STATE(4927),
    [sym_sbyte] = STATE(8017),
    [sym_byte] = STATE(8017),
    [sym_int16] = STATE(8017),
    [sym_uint16] = STATE(8017),
    [sym_int32] = STATE(8017),
    [sym_uint32] = STATE(8017),
    [sym_nativeint] = STATE(8017),
    [sym_unativeint] = STATE(8017),
    [sym_int64] = STATE(8017),
    [sym_uint64] = STATE(8017),
    [sym_ieee32] = STATE(8017),
    [sym_ieee64] = STATE(8017),
    [sym_bignum] = STATE(8017),
    [sym_decimal] = STATE(8017),
    [sym_float] = STATE(7544),
    [sym_block_comment] = STATE(3973),
    [sym_compiler_directive_decl] = STATE(3973),
    [sym_fsi_directive_decl] = STATE(3973),
    [sym_preproc_line] = STATE(3973),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5490),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5492),
    [anon_sym_null] = ACTIONS(5494),
    [anon_sym__] = ACTIONS(5496),
    [anon_sym_QMARK] = ACTIONS(5498),
    [anon_sym_COLON_QMARK] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5502),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5504),
    [anon_sym_LBRACE] = ACTIONS(5506),
    [aux_sym_char_token1] = ACTIONS(5508),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5510),
    [anon_sym_DQUOTE] = ACTIONS(5512),
    [anon_sym_AT_DQUOTE] = ACTIONS(5514),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5516),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5518),
    [sym_bool] = ACTIONS(5520),
    [sym_unit] = ACTIONS(5522),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5524),
    [sym_op_identifier] = ACTIONS(5526),
    [sym_int] = ACTIONS(5528),
    [sym_xint] = ACTIONS(5530),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3974] = {
    [sym_attributes] = STATE(3905),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(8258),
    [sym__pattern] = STATE(7674),
    [sym_optional_pattern] = STATE(8258),
    [sym_type_check_pattern] = STATE(8258),
    [sym_attribute_pattern] = STATE(8258),
    [sym_paren_pattern] = STATE(8258),
    [sym_as_pattern] = STATE(8258),
    [sym_cons_pattern] = STATE(8258),
    [sym_disjunct_pattern] = STATE(8258),
    [sym_conjunct_pattern] = STATE(8258),
    [sym_typed_pattern] = STATE(8258),
    [sym_list_pattern] = STATE(8258),
    [sym_array_pattern] = STATE(8258),
    [sym_record_pattern] = STATE(8258),
    [sym_named_field_pattern] = STATE(8258),
    [sym_identifier_pattern] = STATE(8258),
    [sym_long_identifier_or_op] = STATE(2968),
    [sym_char] = STATE(8017),
    [sym_format_string] = STATE(8065),
    [sym__string_literal] = STATE(8065),
    [sym_string] = STATE(8017),
    [sym_verbatim_string] = STATE(8017),
    [sym_bytearray] = STATE(8017),
    [sym_verbatim_bytearray] = STATE(8017),
    [sym_format_triple_quoted_string] = STATE(8066),
    [sym_triple_quoted_string] = STATE(8017),
    [sym_const] = STATE(8258),
    [sym_long_identifier] = STATE(4907),
    [sym_active_pattern] = STATE(5059),
    [sym__identifier_or_op] = STATE(4927),
    [sym_sbyte] = STATE(8017),
    [sym_byte] = STATE(8017),
    [sym_int16] = STATE(8017),
    [sym_uint16] = STATE(8017),
    [sym_int32] = STATE(8017),
    [sym_uint32] = STATE(8017),
    [sym_nativeint] = STATE(8017),
    [sym_unativeint] = STATE(8017),
    [sym_int64] = STATE(8017),
    [sym_uint64] = STATE(8017),
    [sym_ieee32] = STATE(8017),
    [sym_ieee64] = STATE(8017),
    [sym_bignum] = STATE(8017),
    [sym_decimal] = STATE(8017),
    [sym_float] = STATE(7544),
    [sym_block_comment] = STATE(3974),
    [sym_compiler_directive_decl] = STATE(3974),
    [sym_fsi_directive_decl] = STATE(3974),
    [sym_preproc_line] = STATE(3974),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5490),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5492),
    [anon_sym_null] = ACTIONS(5494),
    [anon_sym__] = ACTIONS(5496),
    [anon_sym_QMARK] = ACTIONS(5498),
    [anon_sym_COLON_QMARK] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5502),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5504),
    [anon_sym_LBRACE] = ACTIONS(5506),
    [aux_sym_char_token1] = ACTIONS(5508),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5510),
    [anon_sym_DQUOTE] = ACTIONS(5512),
    [anon_sym_AT_DQUOTE] = ACTIONS(5514),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5516),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5518),
    [sym_bool] = ACTIONS(5520),
    [sym_unit] = ACTIONS(5522),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5524),
    [sym_op_identifier] = ACTIONS(5526),
    [sym_int] = ACTIONS(5528),
    [sym_xint] = ACTIONS(5530),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3975] = {
    [sym_attributes] = STATE(3968),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(5183),
    [sym__pattern] = STATE(4925),
    [sym_optional_pattern] = STATE(5183),
    [sym_type_check_pattern] = STATE(5183),
    [sym_attribute_pattern] = STATE(5183),
    [sym_paren_pattern] = STATE(5183),
    [sym_as_pattern] = STATE(5183),
    [sym_cons_pattern] = STATE(5183),
    [sym_disjunct_pattern] = STATE(5183),
    [sym_conjunct_pattern] = STATE(5183),
    [sym_typed_pattern] = STATE(5183),
    [sym_list_pattern] = STATE(5183),
    [sym_array_pattern] = STATE(5183),
    [sym_record_pattern] = STATE(5183),
    [sym_named_field_pattern] = STATE(5183),
    [sym_identifier_pattern] = STATE(5183),
    [sym_long_identifier_or_op] = STATE(3528),
    [sym_char] = STATE(5133),
    [sym_format_string] = STATE(5135),
    [sym__string_literal] = STATE(5135),
    [sym_string] = STATE(5133),
    [sym_verbatim_string] = STATE(5133),
    [sym_bytearray] = STATE(5133),
    [sym_verbatim_bytearray] = STATE(5133),
    [sym_format_triple_quoted_string] = STATE(5136),
    [sym_triple_quoted_string] = STATE(5133),
    [sym_const] = STATE(5183),
    [sym_long_identifier] = STATE(4953),
    [sym_active_pattern] = STATE(5117),
    [sym__identifier_or_op] = STATE(5167),
    [sym_sbyte] = STATE(5133),
    [sym_byte] = STATE(5133),
    [sym_int16] = STATE(5133),
    [sym_uint16] = STATE(5133),
    [sym_int32] = STATE(5133),
    [sym_uint32] = STATE(5133),
    [sym_nativeint] = STATE(5133),
    [sym_unativeint] = STATE(5133),
    [sym_int64] = STATE(5133),
    [sym_uint64] = STATE(5133),
    [sym_ieee32] = STATE(5133),
    [sym_ieee64] = STATE(5133),
    [sym_bignum] = STATE(5133),
    [sym_decimal] = STATE(5133),
    [sym_float] = STATE(4916),
    [sym_block_comment] = STATE(3975),
    [sym_compiler_directive_decl] = STATE(3975),
    [sym_fsi_directive_decl] = STATE(3975),
    [sym_preproc_line] = STATE(3975),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5671),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5944),
    [anon_sym_null] = ACTIONS(5946),
    [anon_sym__] = ACTIONS(5948),
    [anon_sym_QMARK] = ACTIONS(5950),
    [anon_sym_COLON_QMARK] = ACTIONS(5952),
    [anon_sym_LBRACK] = ACTIONS(5954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5956),
    [anon_sym_LBRACE] = ACTIONS(5958),
    [aux_sym_char_token1] = ACTIONS(5960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5962),
    [anon_sym_DQUOTE] = ACTIONS(5964),
    [anon_sym_AT_DQUOTE] = ACTIONS(5966),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5968),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5970),
    [sym_bool] = ACTIONS(5972),
    [sym_unit] = ACTIONS(5974),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5705),
    [sym_op_identifier] = ACTIONS(5707),
    [sym_int] = ACTIONS(5976),
    [sym_xint] = ACTIONS(5978),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3976] = {
    [sym_attributes] = STATE(3976),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(8306),
    [sym__pattern] = STATE(7996),
    [sym_optional_pattern] = STATE(8306),
    [sym_type_check_pattern] = STATE(8306),
    [sym_attribute_pattern] = STATE(8306),
    [sym_paren_pattern] = STATE(8306),
    [sym_as_pattern] = STATE(8306),
    [sym_cons_pattern] = STATE(8306),
    [sym_disjunct_pattern] = STATE(8306),
    [sym_conjunct_pattern] = STATE(8306),
    [sym_typed_pattern] = STATE(8306),
    [sym_list_pattern] = STATE(8306),
    [sym_array_pattern] = STATE(8306),
    [sym_record_pattern] = STATE(8306),
    [sym_named_field_pattern] = STATE(8306),
    [sym_identifier_pattern] = STATE(8306),
    [sym_long_identifier_or_op] = STATE(3457),
    [sym_char] = STATE(8299),
    [sym_format_string] = STATE(8384),
    [sym__string_literal] = STATE(8384),
    [sym_string] = STATE(8299),
    [sym_verbatim_string] = STATE(8299),
    [sym_bytearray] = STATE(8299),
    [sym_verbatim_bytearray] = STATE(8299),
    [sym_format_triple_quoted_string] = STATE(8395),
    [sym_triple_quoted_string] = STATE(8299),
    [sym_const] = STATE(8306),
    [sym_long_identifier] = STATE(4953),
    [sym_active_pattern] = STATE(5117),
    [sym__identifier_or_op] = STATE(5167),
    [sym_sbyte] = STATE(8299),
    [sym_byte] = STATE(8299),
    [sym_int16] = STATE(8299),
    [sym_uint16] = STATE(8299),
    [sym_int32] = STATE(8299),
    [sym_uint32] = STATE(8299),
    [sym_nativeint] = STATE(8299),
    [sym_unativeint] = STATE(8299),
    [sym_int64] = STATE(8299),
    [sym_uint64] = STATE(8299),
    [sym_ieee32] = STATE(8299),
    [sym_ieee64] = STATE(8299),
    [sym_bignum] = STATE(8299),
    [sym_decimal] = STATE(8299),
    [sym_float] = STATE(7864),
    [sym_block_comment] = STATE(3976),
    [sym_compiler_directive_decl] = STATE(3976),
    [sym_fsi_directive_decl] = STATE(3976),
    [sym_preproc_line] = STATE(3976),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5671),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5673),
    [anon_sym_null] = ACTIONS(5675),
    [anon_sym__] = ACTIONS(5677),
    [anon_sym_QMARK] = ACTIONS(5679),
    [anon_sym_COLON_QMARK] = ACTIONS(5681),
    [anon_sym_LBRACK] = ACTIONS(5683),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5685),
    [anon_sym_LBRACE] = ACTIONS(5687),
    [aux_sym_char_token1] = ACTIONS(5689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5691),
    [anon_sym_DQUOTE] = ACTIONS(5693),
    [anon_sym_AT_DQUOTE] = ACTIONS(5695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5699),
    [sym_bool] = ACTIONS(5701),
    [sym_unit] = ACTIONS(5703),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5705),
    [sym_op_identifier] = ACTIONS(5707),
    [sym_int] = ACTIONS(5709),
    [sym_xint] = ACTIONS(5711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3977] = {
    [sym_attributes] = STATE(3976),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(8306),
    [sym__pattern] = STATE(8016),
    [sym_optional_pattern] = STATE(8306),
    [sym_type_check_pattern] = STATE(8306),
    [sym_attribute_pattern] = STATE(8306),
    [sym_paren_pattern] = STATE(8306),
    [sym_as_pattern] = STATE(8306),
    [sym_cons_pattern] = STATE(8306),
    [sym_disjunct_pattern] = STATE(8306),
    [sym_conjunct_pattern] = STATE(8306),
    [sym_typed_pattern] = STATE(8306),
    [sym_list_pattern] = STATE(8306),
    [sym_array_pattern] = STATE(8306),
    [sym_record_pattern] = STATE(8306),
    [sym_named_field_pattern] = STATE(8306),
    [sym_identifier_pattern] = STATE(8306),
    [sym_long_identifier_or_op] = STATE(3457),
    [sym_char] = STATE(8299),
    [sym_format_string] = STATE(8384),
    [sym__string_literal] = STATE(8384),
    [sym_string] = STATE(8299),
    [sym_verbatim_string] = STATE(8299),
    [sym_bytearray] = STATE(8299),
    [sym_verbatim_bytearray] = STATE(8299),
    [sym_format_triple_quoted_string] = STATE(8395),
    [sym_triple_quoted_string] = STATE(8299),
    [sym_const] = STATE(8306),
    [sym_long_identifier] = STATE(4953),
    [sym_active_pattern] = STATE(5117),
    [sym__identifier_or_op] = STATE(5167),
    [sym_sbyte] = STATE(8299),
    [sym_byte] = STATE(8299),
    [sym_int16] = STATE(8299),
    [sym_uint16] = STATE(8299),
    [sym_int32] = STATE(8299),
    [sym_uint32] = STATE(8299),
    [sym_nativeint] = STATE(8299),
    [sym_unativeint] = STATE(8299),
    [sym_int64] = STATE(8299),
    [sym_uint64] = STATE(8299),
    [sym_ieee32] = STATE(8299),
    [sym_ieee64] = STATE(8299),
    [sym_bignum] = STATE(8299),
    [sym_decimal] = STATE(8299),
    [sym_float] = STATE(7864),
    [sym_block_comment] = STATE(3977),
    [sym_compiler_directive_decl] = STATE(3977),
    [sym_fsi_directive_decl] = STATE(3977),
    [sym_preproc_line] = STATE(3977),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5671),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5673),
    [anon_sym_null] = ACTIONS(5675),
    [anon_sym__] = ACTIONS(5677),
    [anon_sym_QMARK] = ACTIONS(5679),
    [anon_sym_COLON_QMARK] = ACTIONS(5681),
    [anon_sym_LBRACK] = ACTIONS(5683),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5685),
    [anon_sym_LBRACE] = ACTIONS(5687),
    [aux_sym_char_token1] = ACTIONS(5689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5691),
    [anon_sym_DQUOTE] = ACTIONS(5693),
    [anon_sym_AT_DQUOTE] = ACTIONS(5695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5699),
    [sym_bool] = ACTIONS(5701),
    [sym_unit] = ACTIONS(5703),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5705),
    [sym_op_identifier] = ACTIONS(5707),
    [sym_int] = ACTIONS(5709),
    [sym_xint] = ACTIONS(5711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3978] = {
    [sym_attributes] = STATE(3976),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(8306),
    [sym__pattern] = STATE(7727),
    [sym_optional_pattern] = STATE(8306),
    [sym_type_check_pattern] = STATE(8306),
    [sym_attribute_pattern] = STATE(8306),
    [sym_paren_pattern] = STATE(8306),
    [sym_as_pattern] = STATE(8306),
    [sym_cons_pattern] = STATE(8306),
    [sym_disjunct_pattern] = STATE(8306),
    [sym_conjunct_pattern] = STATE(8306),
    [sym_typed_pattern] = STATE(8306),
    [sym_list_pattern] = STATE(8306),
    [sym_array_pattern] = STATE(8306),
    [sym_record_pattern] = STATE(8306),
    [sym_named_field_pattern] = STATE(8306),
    [sym_identifier_pattern] = STATE(8306),
    [sym_long_identifier_or_op] = STATE(3457),
    [sym_char] = STATE(8299),
    [sym_format_string] = STATE(8384),
    [sym__string_literal] = STATE(8384),
    [sym_string] = STATE(8299),
    [sym_verbatim_string] = STATE(8299),
    [sym_bytearray] = STATE(8299),
    [sym_verbatim_bytearray] = STATE(8299),
    [sym_format_triple_quoted_string] = STATE(8395),
    [sym_triple_quoted_string] = STATE(8299),
    [sym_const] = STATE(8306),
    [sym_long_identifier] = STATE(4953),
    [sym_active_pattern] = STATE(5117),
    [sym__identifier_or_op] = STATE(5167),
    [sym_sbyte] = STATE(8299),
    [sym_byte] = STATE(8299),
    [sym_int16] = STATE(8299),
    [sym_uint16] = STATE(8299),
    [sym_int32] = STATE(8299),
    [sym_uint32] = STATE(8299),
    [sym_nativeint] = STATE(8299),
    [sym_unativeint] = STATE(8299),
    [sym_int64] = STATE(8299),
    [sym_uint64] = STATE(8299),
    [sym_ieee32] = STATE(8299),
    [sym_ieee64] = STATE(8299),
    [sym_bignum] = STATE(8299),
    [sym_decimal] = STATE(8299),
    [sym_float] = STATE(7864),
    [sym_block_comment] = STATE(3978),
    [sym_compiler_directive_decl] = STATE(3978),
    [sym_fsi_directive_decl] = STATE(3978),
    [sym_preproc_line] = STATE(3978),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5671),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5673),
    [anon_sym_null] = ACTIONS(5675),
    [anon_sym__] = ACTIONS(5677),
    [anon_sym_QMARK] = ACTIONS(5679),
    [anon_sym_COLON_QMARK] = ACTIONS(5681),
    [anon_sym_LBRACK] = ACTIONS(5683),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5685),
    [anon_sym_LBRACE] = ACTIONS(5687),
    [aux_sym_char_token1] = ACTIONS(5689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5691),
    [anon_sym_DQUOTE] = ACTIONS(5693),
    [anon_sym_AT_DQUOTE] = ACTIONS(5695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5699),
    [sym_bool] = ACTIONS(5701),
    [sym_unit] = ACTIONS(5703),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5705),
    [sym_op_identifier] = ACTIONS(5707),
    [sym_int] = ACTIONS(5709),
    [sym_xint] = ACTIONS(5711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3979] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(8377),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3979),
    [sym_compiler_directive_decl] = STATE(3979),
    [sym_fsi_directive_decl] = STATE(3979),
    [sym_preproc_line] = STATE(3979),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3980] = {
    [sym_attributes] = STATE(3905),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(8258),
    [sym__pattern] = STATE(8175),
    [sym_optional_pattern] = STATE(8258),
    [sym_type_check_pattern] = STATE(8258),
    [sym_attribute_pattern] = STATE(8258),
    [sym_paren_pattern] = STATE(8258),
    [sym_as_pattern] = STATE(8258),
    [sym_cons_pattern] = STATE(8258),
    [sym_disjunct_pattern] = STATE(8258),
    [sym_conjunct_pattern] = STATE(8258),
    [sym_typed_pattern] = STATE(8258),
    [sym_list_pattern] = STATE(8258),
    [sym_array_pattern] = STATE(8258),
    [sym_record_pattern] = STATE(8258),
    [sym_named_field_pattern] = STATE(8258),
    [sym_identifier_pattern] = STATE(8258),
    [sym_long_identifier_or_op] = STATE(2968),
    [sym_char] = STATE(8017),
    [sym_format_string] = STATE(8065),
    [sym__string_literal] = STATE(8065),
    [sym_string] = STATE(8017),
    [sym_verbatim_string] = STATE(8017),
    [sym_bytearray] = STATE(8017),
    [sym_verbatim_bytearray] = STATE(8017),
    [sym_format_triple_quoted_string] = STATE(8066),
    [sym_triple_quoted_string] = STATE(8017),
    [sym_const] = STATE(8258),
    [sym_long_identifier] = STATE(4907),
    [sym_active_pattern] = STATE(5059),
    [sym__identifier_or_op] = STATE(4927),
    [sym_sbyte] = STATE(8017),
    [sym_byte] = STATE(8017),
    [sym_int16] = STATE(8017),
    [sym_uint16] = STATE(8017),
    [sym_int32] = STATE(8017),
    [sym_uint32] = STATE(8017),
    [sym_nativeint] = STATE(8017),
    [sym_unativeint] = STATE(8017),
    [sym_int64] = STATE(8017),
    [sym_uint64] = STATE(8017),
    [sym_ieee32] = STATE(8017),
    [sym_ieee64] = STATE(8017),
    [sym_bignum] = STATE(8017),
    [sym_decimal] = STATE(8017),
    [sym_float] = STATE(7544),
    [sym_block_comment] = STATE(3980),
    [sym_compiler_directive_decl] = STATE(3980),
    [sym_fsi_directive_decl] = STATE(3980),
    [sym_preproc_line] = STATE(3980),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5490),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5492),
    [anon_sym_null] = ACTIONS(5494),
    [anon_sym__] = ACTIONS(5496),
    [anon_sym_QMARK] = ACTIONS(5498),
    [anon_sym_COLON_QMARK] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5502),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5504),
    [anon_sym_LBRACE] = ACTIONS(5506),
    [aux_sym_char_token1] = ACTIONS(5508),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5510),
    [anon_sym_DQUOTE] = ACTIONS(5512),
    [anon_sym_AT_DQUOTE] = ACTIONS(5514),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5516),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5518),
    [sym_bool] = ACTIONS(5520),
    [sym_unit] = ACTIONS(5522),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5524),
    [sym_op_identifier] = ACTIONS(5526),
    [sym_int] = ACTIONS(5528),
    [sym_xint] = ACTIONS(5530),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3981] = {
    [sym_attributes] = STATE(3988),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4988),
    [sym__pattern] = STATE(4819),
    [sym_optional_pattern] = STATE(4988),
    [sym_type_check_pattern] = STATE(4988),
    [sym_attribute_pattern] = STATE(4988),
    [sym_paren_pattern] = STATE(4988),
    [sym_as_pattern] = STATE(4988),
    [sym_cons_pattern] = STATE(4988),
    [sym_disjunct_pattern] = STATE(4988),
    [sym_conjunct_pattern] = STATE(4988),
    [sym_typed_pattern] = STATE(4988),
    [sym_list_pattern] = STATE(4988),
    [sym_array_pattern] = STATE(4988),
    [sym_record_pattern] = STATE(4988),
    [sym_named_field_pattern] = STATE(4988),
    [sym_identifier_pattern] = STATE(4988),
    [sym_long_identifier_or_op] = STATE(3177),
    [sym_char] = STATE(5109),
    [sym_format_string] = STATE(5097),
    [sym__string_literal] = STATE(5097),
    [sym_string] = STATE(5109),
    [sym_verbatim_string] = STATE(5109),
    [sym_bytearray] = STATE(5109),
    [sym_verbatim_bytearray] = STATE(5109),
    [sym_format_triple_quoted_string] = STATE(5096),
    [sym_triple_quoted_string] = STATE(5109),
    [sym_const] = STATE(4988),
    [sym_long_identifier] = STATE(4907),
    [sym_active_pattern] = STATE(5059),
    [sym__identifier_or_op] = STATE(4927),
    [sym_sbyte] = STATE(5109),
    [sym_byte] = STATE(5109),
    [sym_int16] = STATE(5109),
    [sym_uint16] = STATE(5109),
    [sym_int32] = STATE(5109),
    [sym_uint32] = STATE(5109),
    [sym_nativeint] = STATE(5109),
    [sym_unativeint] = STATE(5109),
    [sym_int64] = STATE(5109),
    [sym_uint64] = STATE(5109),
    [sym_ieee32] = STATE(5109),
    [sym_ieee64] = STATE(5109),
    [sym_bignum] = STATE(5109),
    [sym_decimal] = STATE(5109),
    [sym_float] = STATE(4781),
    [sym_block_comment] = STATE(3981),
    [sym_compiler_directive_decl] = STATE(3981),
    [sym_fsi_directive_decl] = STATE(3981),
    [sym_preproc_line] = STATE(3981),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5490),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5560),
    [anon_sym_null] = ACTIONS(5564),
    [anon_sym__] = ACTIONS(5566),
    [anon_sym_QMARK] = ACTIONS(5568),
    [anon_sym_COLON_QMARK] = ACTIONS(5570),
    [anon_sym_LBRACK] = ACTIONS(5572),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5574),
    [anon_sym_LBRACE] = ACTIONS(5576),
    [aux_sym_char_token1] = ACTIONS(5578),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5580),
    [anon_sym_DQUOTE] = ACTIONS(5582),
    [anon_sym_AT_DQUOTE] = ACTIONS(5584),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5586),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5588),
    [sym_bool] = ACTIONS(5590),
    [sym_unit] = ACTIONS(5592),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5524),
    [sym_op_identifier] = ACTIONS(5526),
    [sym_int] = ACTIONS(5594),
    [sym_xint] = ACTIONS(5596),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3982] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7898),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(4090),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3982),
    [sym_compiler_directive_decl] = STATE(3982),
    [sym_fsi_directive_decl] = STATE(3982),
    [sym_preproc_line] = STATE(3982),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3983] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7777),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3983),
    [sym_compiler_directive_decl] = STATE(3983),
    [sym_fsi_directive_decl] = STATE(3983),
    [sym_preproc_line] = STATE(3983),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3984] = {
    [sym_attributes] = STATE(3983),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(7351),
    [sym__pattern] = STATE(7842),
    [sym_optional_pattern] = STATE(7351),
    [sym_type_check_pattern] = STATE(7351),
    [sym_attribute_pattern] = STATE(7351),
    [sym_paren_pattern] = STATE(7351),
    [sym_as_pattern] = STATE(7351),
    [sym_cons_pattern] = STATE(7351),
    [sym_disjunct_pattern] = STATE(7351),
    [sym_conjunct_pattern] = STATE(7351),
    [sym_typed_pattern] = STATE(7351),
    [sym_list_pattern] = STATE(7351),
    [sym_array_pattern] = STATE(7351),
    [sym_record_pattern] = STATE(7351),
    [sym_named_field_pattern] = STATE(7351),
    [sym_identifier_pattern] = STATE(7351),
    [sym_long_identifier_or_op] = STATE(3137),
    [sym_char] = STATE(7365),
    [sym_format_string] = STATE(7370),
    [sym__string_literal] = STATE(7370),
    [sym_string] = STATE(7365),
    [sym_verbatim_string] = STATE(7365),
    [sym_bytearray] = STATE(7365),
    [sym_verbatim_bytearray] = STATE(7365),
    [sym_format_triple_quoted_string] = STATE(7371),
    [sym_triple_quoted_string] = STATE(7365),
    [sym_const] = STATE(7351),
    [sym_long_identifier] = STATE(4918),
    [sym_active_pattern] = STATE(4932),
    [sym__identifier_or_op] = STATE(5022),
    [sym_sbyte] = STATE(7365),
    [sym_byte] = STATE(7365),
    [sym_int16] = STATE(7365),
    [sym_uint16] = STATE(7365),
    [sym_int32] = STATE(7365),
    [sym_uint32] = STATE(7365),
    [sym_nativeint] = STATE(7365),
    [sym_unativeint] = STATE(7365),
    [sym_int64] = STATE(7365),
    [sym_uint64] = STATE(7365),
    [sym_ieee32] = STATE(7365),
    [sym_ieee64] = STATE(7365),
    [sym_bignum] = STATE(7365),
    [sym_decimal] = STATE(7365),
    [sym_float] = STATE(7114),
    [sym_block_comment] = STATE(3984),
    [sym_compiler_directive_decl] = STATE(3984),
    [sym_fsi_directive_decl] = STATE(3984),
    [sym_preproc_line] = STATE(3984),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_null] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5223),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_LBRACK] = ACTIONS(5227),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5229),
    [anon_sym_LBRACE] = ACTIONS(5231),
    [aux_sym_char_token1] = ACTIONS(5235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(5239),
    [anon_sym_AT_DQUOTE] = ACTIONS(5241),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5243),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5245),
    [sym_bool] = ACTIONS(5247),
    [sym_unit] = ACTIONS(5249),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5251),
    [sym_op_identifier] = ACTIONS(5253),
    [sym_int] = ACTIONS(5255),
    [sym_xint] = ACTIONS(5257),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3985] = {
    [sym_attributes] = STATE(3960),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(5177),
    [sym__pattern] = STATE(5051),
    [sym_optional_pattern] = STATE(5177),
    [sym_type_check_pattern] = STATE(5177),
    [sym_attribute_pattern] = STATE(5177),
    [sym_paren_pattern] = STATE(5177),
    [sym_as_pattern] = STATE(5177),
    [sym_cons_pattern] = STATE(5177),
    [sym_disjunct_pattern] = STATE(5177),
    [sym_conjunct_pattern] = STATE(5177),
    [sym_typed_pattern] = STATE(5177),
    [sym_list_pattern] = STATE(5177),
    [sym_array_pattern] = STATE(5177),
    [sym_record_pattern] = STATE(5177),
    [sym_named_field_pattern] = STATE(5177),
    [sym_identifier_pattern] = STATE(5177),
    [sym_long_identifier_or_op] = STATE(3306),
    [sym_char] = STATE(5226),
    [sym_format_string] = STATE(5239),
    [sym__string_literal] = STATE(5239),
    [sym_string] = STATE(5226),
    [sym_verbatim_string] = STATE(5226),
    [sym_bytearray] = STATE(5226),
    [sym_verbatim_bytearray] = STATE(5226),
    [sym_format_triple_quoted_string] = STATE(5238),
    [sym_triple_quoted_string] = STATE(5226),
    [sym_const] = STATE(5177),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(5226),
    [sym_byte] = STATE(5226),
    [sym_int16] = STATE(5226),
    [sym_uint16] = STATE(5226),
    [sym_int32] = STATE(5226),
    [sym_uint32] = STATE(5226),
    [sym_nativeint] = STATE(5226),
    [sym_unativeint] = STATE(5226),
    [sym_int64] = STATE(5226),
    [sym_uint64] = STATE(5226),
    [sym_ieee32] = STATE(5226),
    [sym_ieee64] = STATE(5226),
    [sym_bignum] = STATE(5226),
    [sym_decimal] = STATE(5226),
    [sym_float] = STATE(4814),
    [sym_block_comment] = STATE(3985),
    [sym_compiler_directive_decl] = STATE(3985),
    [sym_fsi_directive_decl] = STATE(3985),
    [sym_preproc_line] = STATE(3985),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5845),
    [anon_sym_null] = ACTIONS(5847),
    [anon_sym__] = ACTIONS(5849),
    [anon_sym_QMARK] = ACTIONS(5851),
    [anon_sym_COLON_QMARK] = ACTIONS(5853),
    [anon_sym_LBRACK] = ACTIONS(5855),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5857),
    [anon_sym_LBRACE] = ACTIONS(5859),
    [aux_sym_char_token1] = ACTIONS(5861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5863),
    [anon_sym_DQUOTE] = ACTIONS(5865),
    [anon_sym_AT_DQUOTE] = ACTIONS(5867),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5871),
    [sym_bool] = ACTIONS(5873),
    [sym_unit] = ACTIONS(5875),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5877),
    [sym_xint] = ACTIONS(5879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3986] = {
    [sym_attributes] = STATE(3960),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(5177),
    [sym__pattern] = STATE(5050),
    [sym_optional_pattern] = STATE(5177),
    [sym_type_check_pattern] = STATE(5177),
    [sym_attribute_pattern] = STATE(5177),
    [sym_paren_pattern] = STATE(5177),
    [sym_as_pattern] = STATE(5177),
    [sym_cons_pattern] = STATE(5177),
    [sym_disjunct_pattern] = STATE(5177),
    [sym_conjunct_pattern] = STATE(5177),
    [sym_typed_pattern] = STATE(5177),
    [sym_list_pattern] = STATE(5177),
    [sym_array_pattern] = STATE(5177),
    [sym_record_pattern] = STATE(5177),
    [sym_named_field_pattern] = STATE(5177),
    [sym_identifier_pattern] = STATE(5177),
    [sym_long_identifier_or_op] = STATE(3306),
    [sym_char] = STATE(5226),
    [sym_format_string] = STATE(5239),
    [sym__string_literal] = STATE(5239),
    [sym_string] = STATE(5226),
    [sym_verbatim_string] = STATE(5226),
    [sym_bytearray] = STATE(5226),
    [sym_verbatim_bytearray] = STATE(5226),
    [sym_format_triple_quoted_string] = STATE(5238),
    [sym_triple_quoted_string] = STATE(5226),
    [sym_const] = STATE(5177),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(5226),
    [sym_byte] = STATE(5226),
    [sym_int16] = STATE(5226),
    [sym_uint16] = STATE(5226),
    [sym_int32] = STATE(5226),
    [sym_uint32] = STATE(5226),
    [sym_nativeint] = STATE(5226),
    [sym_unativeint] = STATE(5226),
    [sym_int64] = STATE(5226),
    [sym_uint64] = STATE(5226),
    [sym_ieee32] = STATE(5226),
    [sym_ieee64] = STATE(5226),
    [sym_bignum] = STATE(5226),
    [sym_decimal] = STATE(5226),
    [sym_float] = STATE(4814),
    [sym_block_comment] = STATE(3986),
    [sym_compiler_directive_decl] = STATE(3986),
    [sym_fsi_directive_decl] = STATE(3986),
    [sym_preproc_line] = STATE(3986),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5845),
    [anon_sym_null] = ACTIONS(5847),
    [anon_sym__] = ACTIONS(5849),
    [anon_sym_QMARK] = ACTIONS(5851),
    [anon_sym_COLON_QMARK] = ACTIONS(5853),
    [anon_sym_LBRACK] = ACTIONS(5855),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5857),
    [anon_sym_LBRACE] = ACTIONS(5859),
    [aux_sym_char_token1] = ACTIONS(5861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5863),
    [anon_sym_DQUOTE] = ACTIONS(5865),
    [anon_sym_AT_DQUOTE] = ACTIONS(5867),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5871),
    [sym_bool] = ACTIONS(5873),
    [sym_unit] = ACTIONS(5875),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5877),
    [sym_xint] = ACTIONS(5879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3987] = {
    [sym_attributes] = STATE(3960),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(5177),
    [sym__pattern] = STATE(5047),
    [sym_optional_pattern] = STATE(5177),
    [sym_type_check_pattern] = STATE(5177),
    [sym_attribute_pattern] = STATE(5177),
    [sym_paren_pattern] = STATE(5177),
    [sym_as_pattern] = STATE(5177),
    [sym_cons_pattern] = STATE(5177),
    [sym_disjunct_pattern] = STATE(5177),
    [sym_conjunct_pattern] = STATE(5177),
    [sym_typed_pattern] = STATE(5177),
    [sym_list_pattern] = STATE(5177),
    [sym_array_pattern] = STATE(5177),
    [sym_record_pattern] = STATE(5177),
    [sym_named_field_pattern] = STATE(5177),
    [sym_identifier_pattern] = STATE(5177),
    [sym_long_identifier_or_op] = STATE(3306),
    [sym_char] = STATE(5226),
    [sym_format_string] = STATE(5239),
    [sym__string_literal] = STATE(5239),
    [sym_string] = STATE(5226),
    [sym_verbatim_string] = STATE(5226),
    [sym_bytearray] = STATE(5226),
    [sym_verbatim_bytearray] = STATE(5226),
    [sym_format_triple_quoted_string] = STATE(5238),
    [sym_triple_quoted_string] = STATE(5226),
    [sym_const] = STATE(5177),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(5226),
    [sym_byte] = STATE(5226),
    [sym_int16] = STATE(5226),
    [sym_uint16] = STATE(5226),
    [sym_int32] = STATE(5226),
    [sym_uint32] = STATE(5226),
    [sym_nativeint] = STATE(5226),
    [sym_unativeint] = STATE(5226),
    [sym_int64] = STATE(5226),
    [sym_uint64] = STATE(5226),
    [sym_ieee32] = STATE(5226),
    [sym_ieee64] = STATE(5226),
    [sym_bignum] = STATE(5226),
    [sym_decimal] = STATE(5226),
    [sym_float] = STATE(4814),
    [sym_block_comment] = STATE(3987),
    [sym_compiler_directive_decl] = STATE(3987),
    [sym_fsi_directive_decl] = STATE(3987),
    [sym_preproc_line] = STATE(3987),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5845),
    [anon_sym_null] = ACTIONS(5847),
    [anon_sym__] = ACTIONS(5849),
    [anon_sym_QMARK] = ACTIONS(5851),
    [anon_sym_COLON_QMARK] = ACTIONS(5853),
    [anon_sym_LBRACK] = ACTIONS(5855),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5857),
    [anon_sym_LBRACE] = ACTIONS(5859),
    [aux_sym_char_token1] = ACTIONS(5861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5863),
    [anon_sym_DQUOTE] = ACTIONS(5865),
    [anon_sym_AT_DQUOTE] = ACTIONS(5867),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5871),
    [sym_bool] = ACTIONS(5873),
    [sym_unit] = ACTIONS(5875),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5877),
    [sym_xint] = ACTIONS(5879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3988] = {
    [sym_attributes] = STATE(3988),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(4988),
    [sym__pattern] = STATE(4825),
    [sym_optional_pattern] = STATE(4988),
    [sym_type_check_pattern] = STATE(4988),
    [sym_attribute_pattern] = STATE(4988),
    [sym_paren_pattern] = STATE(4988),
    [sym_as_pattern] = STATE(4988),
    [sym_cons_pattern] = STATE(4988),
    [sym_disjunct_pattern] = STATE(4988),
    [sym_conjunct_pattern] = STATE(4988),
    [sym_typed_pattern] = STATE(4988),
    [sym_list_pattern] = STATE(4988),
    [sym_array_pattern] = STATE(4988),
    [sym_record_pattern] = STATE(4988),
    [sym_named_field_pattern] = STATE(4988),
    [sym_identifier_pattern] = STATE(4988),
    [sym_long_identifier_or_op] = STATE(3177),
    [sym_char] = STATE(5109),
    [sym_format_string] = STATE(5097),
    [sym__string_literal] = STATE(5097),
    [sym_string] = STATE(5109),
    [sym_verbatim_string] = STATE(5109),
    [sym_bytearray] = STATE(5109),
    [sym_verbatim_bytearray] = STATE(5109),
    [sym_format_triple_quoted_string] = STATE(5096),
    [sym_triple_quoted_string] = STATE(5109),
    [sym_const] = STATE(4988),
    [sym_long_identifier] = STATE(4907),
    [sym_active_pattern] = STATE(5059),
    [sym__identifier_or_op] = STATE(4927),
    [sym_sbyte] = STATE(5109),
    [sym_byte] = STATE(5109),
    [sym_int16] = STATE(5109),
    [sym_uint16] = STATE(5109),
    [sym_int32] = STATE(5109),
    [sym_uint32] = STATE(5109),
    [sym_nativeint] = STATE(5109),
    [sym_unativeint] = STATE(5109),
    [sym_int64] = STATE(5109),
    [sym_uint64] = STATE(5109),
    [sym_ieee32] = STATE(5109),
    [sym_ieee64] = STATE(5109),
    [sym_bignum] = STATE(5109),
    [sym_decimal] = STATE(5109),
    [sym_float] = STATE(4781),
    [sym_block_comment] = STATE(3988),
    [sym_compiler_directive_decl] = STATE(3988),
    [sym_fsi_directive_decl] = STATE(3988),
    [sym_preproc_line] = STATE(3988),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5490),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5560),
    [anon_sym_null] = ACTIONS(5564),
    [anon_sym__] = ACTIONS(5566),
    [anon_sym_QMARK] = ACTIONS(5568),
    [anon_sym_COLON_QMARK] = ACTIONS(5570),
    [anon_sym_LBRACK] = ACTIONS(5572),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5574),
    [anon_sym_LBRACE] = ACTIONS(5576),
    [aux_sym_char_token1] = ACTIONS(5578),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5580),
    [anon_sym_DQUOTE] = ACTIONS(5582),
    [anon_sym_AT_DQUOTE] = ACTIONS(5584),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5586),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5588),
    [sym_bool] = ACTIONS(5590),
    [sym_unit] = ACTIONS(5592),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5524),
    [sym_op_identifier] = ACTIONS(5526),
    [sym_int] = ACTIONS(5594),
    [sym_xint] = ACTIONS(5596),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3989] = {
    [sym_attributes] = STATE(3960),
    [sym__attribute_set] = STATE(5816),
    [sym_repeat_pattern] = STATE(5177),
    [sym__pattern] = STATE(5035),
    [sym_optional_pattern] = STATE(5177),
    [sym_type_check_pattern] = STATE(5177),
    [sym_attribute_pattern] = STATE(5177),
    [sym_paren_pattern] = STATE(5177),
    [sym_as_pattern] = STATE(5177),
    [sym_cons_pattern] = STATE(5177),
    [sym_disjunct_pattern] = STATE(5177),
    [sym_conjunct_pattern] = STATE(5177),
    [sym_typed_pattern] = STATE(5177),
    [sym_list_pattern] = STATE(5177),
    [sym_array_pattern] = STATE(5177),
    [sym_record_pattern] = STATE(5177),
    [sym_named_field_pattern] = STATE(5177),
    [sym_identifier_pattern] = STATE(5177),
    [sym_long_identifier_or_op] = STATE(3306),
    [sym_char] = STATE(5226),
    [sym_format_string] = STATE(5239),
    [sym__string_literal] = STATE(5239),
    [sym_string] = STATE(5226),
    [sym_verbatim_string] = STATE(5226),
    [sym_bytearray] = STATE(5226),
    [sym_verbatim_bytearray] = STATE(5226),
    [sym_format_triple_quoted_string] = STATE(5238),
    [sym_triple_quoted_string] = STATE(5226),
    [sym_const] = STATE(5177),
    [sym_long_identifier] = STATE(5042),
    [sym_active_pattern] = STATE(5175),
    [sym__identifier_or_op] = STATE(5162),
    [sym_sbyte] = STATE(5226),
    [sym_byte] = STATE(5226),
    [sym_int16] = STATE(5226),
    [sym_uint16] = STATE(5226),
    [sym_int32] = STATE(5226),
    [sym_uint32] = STATE(5226),
    [sym_nativeint] = STATE(5226),
    [sym_unativeint] = STATE(5226),
    [sym_int64] = STATE(5226),
    [sym_uint64] = STATE(5226),
    [sym_ieee32] = STATE(5226),
    [sym_ieee64] = STATE(5226),
    [sym_bignum] = STATE(5226),
    [sym_decimal] = STATE(5226),
    [sym_float] = STATE(4814),
    [sym_block_comment] = STATE(3989),
    [sym_compiler_directive_decl] = STATE(3989),
    [sym_fsi_directive_decl] = STATE(3989),
    [sym_preproc_line] = STATE(3989),
    [aux_sym_attributes_repeat1] = STATE(5511),
    [sym_identifier] = ACTIONS(5651),
    [anon_sym_LBRACK_LT] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5845),
    [anon_sym_null] = ACTIONS(5847),
    [anon_sym__] = ACTIONS(5849),
    [anon_sym_QMARK] = ACTIONS(5851),
    [anon_sym_COLON_QMARK] = ACTIONS(5853),
    [anon_sym_LBRACK] = ACTIONS(5855),
    [anon_sym_LBRACK_PIPE] = ACTIONS(5857),
    [anon_sym_LBRACE] = ACTIONS(5859),
    [aux_sym_char_token1] = ACTIONS(5861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(5863),
    [anon_sym_DQUOTE] = ACTIONS(5865),
    [anon_sym_AT_DQUOTE] = ACTIONS(5867),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5871),
    [sym_bool] = ACTIONS(5873),
    [sym_unit] = ACTIONS(5875),
    [anon_sym_LPAREN_PIPE] = ACTIONS(5667),
    [sym_op_identifier] = ACTIONS(5669),
    [sym_int] = ACTIONS(5877),
    [sym_xint] = ACTIONS(5879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [3990] = {
    [sym_type_arguments] = STATE(4027),
    [sym_long_identifier] = STATE(4023),
    [sym_block_comment] = STATE(3990),
    [sym_compiler_directive_decl] = STATE(3990),
    [sym_fsi_directive_decl] = STATE(3990),
    [sym_preproc_line] = STATE(3990),
    [aux_sym_compound_type_repeat1] = STATE(4007),
    [ts_builtin_sym_end] = ACTIONS(3429),
    [sym_identifier] = ACTIONS(6492),
    [anon_sym_namespace] = ACTIONS(3431),
    [anon_sym_module] = ACTIONS(3431),
    [anon_sym_open] = ACTIONS(3431),
    [anon_sym_LBRACK_LT] = ACTIONS(3429),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_type] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_let] = ACTIONS(3431),
    [anon_sym_let_BANG] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(3431),
    [anon_sym_null] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_LT_AT] = ACTIONS(3431),
    [anon_sym_LT_AT_AT] = ACTIONS(3429),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_return_BANG] = ACTIONS(3429),
    [anon_sym_yield] = ACTIONS(3431),
    [anon_sym_yield_BANG] = ACTIONS(3429),
    [anon_sym_lazy] = ACTIONS(3431),
    [anon_sym_assert] = ACTIONS(3431),
    [anon_sym_upcast] = ACTIONS(3431),
    [anon_sym_downcast] = ACTIONS(3431),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_fun] = ACTIONS(3431),
    [anon_sym_DASH_GT] = ACTIONS(6494),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_match] = ACTIONS(3431),
    [anon_sym_match_BANG] = ACTIONS(3429),
    [anon_sym_function] = ACTIONS(3431),
    [anon_sym_use] = ACTIONS(3431),
    [anon_sym_use_BANG] = ACTIONS(3429),
    [anon_sym_do_BANG] = ACTIONS(3429),
    [anon_sym_begin] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(6496),
    [anon_sym_LT2] = ACTIONS(6498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(6500),
    [anon_sym_exception] = ACTIONS(3431),
    [aux_sym_char_token1] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [anon_sym_AT_DQUOTE] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [sym_bool] = ACTIONS(3431),
    [sym_unit] = ACTIONS(3429),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3431),
    [sym_op_identifier] = ACTIONS(3429),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_DOT] = ACTIONS(3429),
    [anon_sym_DASH_DOT] = ACTIONS(3429),
    [anon_sym_PERCENT] = ACTIONS(3429),
    [anon_sym_AMP_AMP] = ACTIONS(3429),
    [anon_sym_TILDE] = ACTIONS(3429),
    [aux_sym_prefix_op_token1] = ACTIONS(3429),
    [sym_int] = ACTIONS(3431),
    [sym_xint] = ACTIONS(3429),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3429),
    [anon_sym_POUNDload] = ACTIONS(3429),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3429),
  },
  [3991] = {
    [sym_block_comment] = STATE(3991),
    [sym_compiler_directive_decl] = STATE(3991),
    [sym_fsi_directive_decl] = STATE(3991),
    [sym_preproc_line] = STATE(3991),
    [aux_sym_type_argument_repeat1] = STATE(3991),
    [ts_builtin_sym_end] = ACTIONS(3478),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_namespace] = ACTIONS(3480),
    [anon_sym_module] = ACTIONS(3480),
    [anon_sym_open] = ACTIONS(3480),
    [anon_sym_LBRACK_LT] = ACTIONS(3478),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_type] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3478),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3478),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3478),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_or] = ACTIONS(6502),
    [anon_sym_exception] = ACTIONS(3480),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3478),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3478),
    [anon_sym_DASH_DOT] = ACTIONS(3478),
    [anon_sym_PERCENT] = ACTIONS(3478),
    [anon_sym_AMP_AMP] = ACTIONS(3478),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3478),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3478),
    [anon_sym_POUNDload] = ACTIONS(3478),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
  },
  [3992] = {
    [sym_type_arguments] = STATE(4027),
    [sym_long_identifier] = STATE(4023),
    [sym_block_comment] = STATE(3992),
    [sym_compiler_directive_decl] = STATE(3992),
    [sym_fsi_directive_decl] = STATE(3992),
    [sym_preproc_line] = STATE(3992),
    [aux_sym_compound_type_repeat1] = STATE(4007),
    [ts_builtin_sym_end] = ACTIONS(3425),
    [sym_identifier] = ACTIONS(6492),
    [anon_sym_namespace] = ACTIONS(3427),
    [anon_sym_module] = ACTIONS(3427),
    [anon_sym_open] = ACTIONS(3427),
    [anon_sym_LBRACK_LT] = ACTIONS(3425),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_type] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3425),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(6494),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(6496),
    [anon_sym_LT2] = ACTIONS(6498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(6500),
    [anon_sym_exception] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3425),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3425),
    [anon_sym_DASH_DOT] = ACTIONS(3425),
    [anon_sym_PERCENT] = ACTIONS(3425),
    [anon_sym_AMP_AMP] = ACTIONS(3425),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3425),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3425),
    [anon_sym_POUNDload] = ACTIONS(3425),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
  },
  [3993] = {
    [sym_type_arguments] = STATE(4027),
    [sym_long_identifier] = STATE(4023),
    [sym_block_comment] = STATE(3993),
    [sym_compiler_directive_decl] = STATE(3993),
    [sym_fsi_directive_decl] = STATE(3993),
    [sym_preproc_line] = STATE(3993),
    [aux_sym_compound_type_repeat1] = STATE(4007),
    [ts_builtin_sym_end] = ACTIONS(3403),
    [sym_identifier] = ACTIONS(6492),
    [anon_sym_namespace] = ACTIONS(3407),
    [anon_sym_module] = ACTIONS(3407),
    [anon_sym_open] = ACTIONS(3407),
    [anon_sym_LBRACK_LT] = ACTIONS(3403),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_type] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_let_BANG] = ACTIONS(3403),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_null] = ACTIONS(3407),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3407),
    [anon_sym_LT_AT] = ACTIONS(3407),
    [anon_sym_LT_AT_AT] = ACTIONS(3403),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_return_BANG] = ACTIONS(3403),
    [anon_sym_yield] = ACTIONS(3407),
    [anon_sym_yield_BANG] = ACTIONS(3403),
    [anon_sym_lazy] = ACTIONS(3407),
    [anon_sym_assert] = ACTIONS(3407),
    [anon_sym_upcast] = ACTIONS(3407),
    [anon_sym_downcast] = ACTIONS(3407),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_fun] = ACTIONS(3407),
    [anon_sym_DASH_GT] = ACTIONS(6494),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_match] = ACTIONS(3407),
    [anon_sym_match_BANG] = ACTIONS(3403),
    [anon_sym_function] = ACTIONS(3407),
    [anon_sym_use] = ACTIONS(3407),
    [anon_sym_use_BANG] = ACTIONS(3403),
    [anon_sym_do_BANG] = ACTIONS(3403),
    [anon_sym_begin] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(6496),
    [anon_sym_LT2] = ACTIONS(6498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(6500),
    [anon_sym_exception] = ACTIONS(3407),
    [aux_sym_char_token1] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3407),
    [anon_sym_DQUOTE] = ACTIONS(3407),
    [anon_sym_AT_DQUOTE] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [sym_bool] = ACTIONS(3407),
    [sym_unit] = ACTIONS(3403),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3407),
    [sym_op_identifier] = ACTIONS(3403),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_PLUS_DOT] = ACTIONS(3403),
    [anon_sym_DASH_DOT] = ACTIONS(3403),
    [anon_sym_PERCENT] = ACTIONS(3403),
    [anon_sym_AMP_AMP] = ACTIONS(3403),
    [anon_sym_TILDE] = ACTIONS(3403),
    [aux_sym_prefix_op_token1] = ACTIONS(3403),
    [sym_int] = ACTIONS(3407),
    [sym_xint] = ACTIONS(3403),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3403),
    [anon_sym_POUNDload] = ACTIONS(3403),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3403),
  },
  [3994] = {
    [sym_type_arguments] = STATE(4027),
    [sym_long_identifier] = STATE(4023),
    [sym_block_comment] = STATE(3994),
    [sym_compiler_directive_decl] = STATE(3994),
    [sym_fsi_directive_decl] = STATE(3994),
    [sym_preproc_line] = STATE(3994),
    [aux_sym_compound_type_repeat1] = STATE(4007),
    [ts_builtin_sym_end] = ACTIONS(3417),
    [sym_identifier] = ACTIONS(6492),
    [anon_sym_namespace] = ACTIONS(3419),
    [anon_sym_module] = ACTIONS(3419),
    [anon_sym_open] = ACTIONS(3419),
    [anon_sym_LBRACK_LT] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_type] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_let] = ACTIONS(3419),
    [anon_sym_let_BANG] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(3419),
    [anon_sym_null] = ACTIONS(3419),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_LT_AT] = ACTIONS(3419),
    [anon_sym_LT_AT_AT] = ACTIONS(3417),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_return_BANG] = ACTIONS(3417),
    [anon_sym_yield] = ACTIONS(3419),
    [anon_sym_yield_BANG] = ACTIONS(3417),
    [anon_sym_lazy] = ACTIONS(3419),
    [anon_sym_assert] = ACTIONS(3419),
    [anon_sym_upcast] = ACTIONS(3419),
    [anon_sym_downcast] = ACTIONS(3419),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_fun] = ACTIONS(3419),
    [anon_sym_DASH_GT] = ACTIONS(6494),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_match] = ACTIONS(3419),
    [anon_sym_match_BANG] = ACTIONS(3417),
    [anon_sym_function] = ACTIONS(3419),
    [anon_sym_use] = ACTIONS(3419),
    [anon_sym_use_BANG] = ACTIONS(3417),
    [anon_sym_do_BANG] = ACTIONS(3417),
    [anon_sym_begin] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(6496),
    [anon_sym_LT2] = ACTIONS(6498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(6500),
    [anon_sym_exception] = ACTIONS(3419),
    [aux_sym_char_token1] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3419),
    [anon_sym_AT_DQUOTE] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [sym_bool] = ACTIONS(3419),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3419),
    [sym_op_identifier] = ACTIONS(3417),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_PLUS_DOT] = ACTIONS(3417),
    [anon_sym_DASH_DOT] = ACTIONS(3417),
    [anon_sym_PERCENT] = ACTIONS(3417),
    [anon_sym_AMP_AMP] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3417),
    [aux_sym_prefix_op_token1] = ACTIONS(3417),
    [sym_int] = ACTIONS(3419),
    [sym_xint] = ACTIONS(3417),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3417),
    [anon_sym_POUNDload] = ACTIONS(3417),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3417),
  },
  [3995] = {
    [sym_block_comment] = STATE(3995),
    [sym_compiler_directive_decl] = STATE(3995),
    [sym_fsi_directive_decl] = STATE(3995),
    [sym_preproc_line] = STATE(3995),
    [aux_sym_type_argument_repeat1] = STATE(3997),
    [ts_builtin_sym_end] = ACTIONS(3496),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_namespace] = ACTIONS(3498),
    [anon_sym_module] = ACTIONS(3498),
    [anon_sym_open] = ACTIONS(3498),
    [anon_sym_LBRACK_LT] = ACTIONS(3496),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_type] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3496),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3496),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3496),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_or] = ACTIONS(6505),
    [anon_sym_exception] = ACTIONS(3498),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3496),
    [anon_sym_DASH_DOT] = ACTIONS(3496),
    [anon_sym_PERCENT] = ACTIONS(3496),
    [anon_sym_AMP_AMP] = ACTIONS(3496),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3496),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3496),
    [anon_sym_POUNDload] = ACTIONS(3496),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
  },
  [3996] = {
    [sym_type_arguments] = STATE(4027),
    [sym_long_identifier] = STATE(4023),
    [sym_block_comment] = STATE(3996),
    [sym_compiler_directive_decl] = STATE(3996),
    [sym_fsi_directive_decl] = STATE(3996),
    [sym_preproc_line] = STATE(3996),
    [aux_sym_compound_type_repeat1] = STATE(4007),
    [ts_builtin_sym_end] = ACTIONS(6507),
    [sym_identifier] = ACTIONS(6492),
    [anon_sym_namespace] = ACTIONS(6509),
    [anon_sym_module] = ACTIONS(6509),
    [anon_sym_open] = ACTIONS(6509),
    [anon_sym_LBRACK_LT] = ACTIONS(6507),
    [anon_sym_return] = ACTIONS(6509),
    [anon_sym_type] = ACTIONS(6509),
    [anon_sym_do] = ACTIONS(6509),
    [anon_sym_let] = ACTIONS(6509),
    [anon_sym_let_BANG] = ACTIONS(6507),
    [anon_sym_LPAREN] = ACTIONS(6509),
    [anon_sym_null] = ACTIONS(6509),
    [anon_sym_AMP] = ACTIONS(6509),
    [anon_sym_LBRACK] = ACTIONS(6509),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6507),
    [anon_sym_LBRACE] = ACTIONS(6509),
    [anon_sym_LT_AT] = ACTIONS(6509),
    [anon_sym_LT_AT_AT] = ACTIONS(6507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6507),
    [anon_sym_new] = ACTIONS(6509),
    [anon_sym_return_BANG] = ACTIONS(6507),
    [anon_sym_yield] = ACTIONS(6509),
    [anon_sym_yield_BANG] = ACTIONS(6507),
    [anon_sym_lazy] = ACTIONS(6509),
    [anon_sym_assert] = ACTIONS(6509),
    [anon_sym_upcast] = ACTIONS(6509),
    [anon_sym_downcast] = ACTIONS(6509),
    [anon_sym_for] = ACTIONS(6509),
    [anon_sym_while] = ACTIONS(6509),
    [anon_sym_if] = ACTIONS(6509),
    [anon_sym_fun] = ACTIONS(6509),
    [anon_sym_DASH_GT] = ACTIONS(6494),
    [anon_sym_try] = ACTIONS(6509),
    [anon_sym_match] = ACTIONS(6509),
    [anon_sym_match_BANG] = ACTIONS(6507),
    [anon_sym_function] = ACTIONS(6509),
    [anon_sym_use] = ACTIONS(6509),
    [anon_sym_use_BANG] = ACTIONS(6507),
    [anon_sym_do_BANG] = ACTIONS(6507),
    [anon_sym_begin] = ACTIONS(6509),
    [anon_sym_STAR] = ACTIONS(6496),
    [anon_sym_LT2] = ACTIONS(6498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(6500),
    [anon_sym_exception] = ACTIONS(6509),
    [aux_sym_char_token1] = ACTIONS(6507),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6509),
    [anon_sym_DQUOTE] = ACTIONS(6509),
    [anon_sym_AT_DQUOTE] = ACTIONS(6507),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6507),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6507),
    [sym_bool] = ACTIONS(6509),
    [sym_unit] = ACTIONS(6507),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6509),
    [sym_op_identifier] = ACTIONS(6507),
    [anon_sym_PLUS] = ACTIONS(6509),
    [anon_sym_DASH] = ACTIONS(6509),
    [anon_sym_PLUS_DOT] = ACTIONS(6507),
    [anon_sym_DASH_DOT] = ACTIONS(6507),
    [anon_sym_PERCENT] = ACTIONS(6507),
    [anon_sym_AMP_AMP] = ACTIONS(6507),
    [anon_sym_TILDE] = ACTIONS(6507),
    [aux_sym_prefix_op_token1] = ACTIONS(6507),
    [sym_int] = ACTIONS(6509),
    [sym_xint] = ACTIONS(6507),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6507),
    [anon_sym_POUNDload] = ACTIONS(6507),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6507),
  },
  [3997] = {
    [sym_block_comment] = STATE(3997),
    [sym_compiler_directive_decl] = STATE(3997),
    [sym_fsi_directive_decl] = STATE(3997),
    [sym_preproc_line] = STATE(3997),
    [aux_sym_type_argument_repeat1] = STATE(3991),
    [ts_builtin_sym_end] = ACTIONS(3474),
    [sym_identifier] = ACTIONS(3476),
    [anon_sym_namespace] = ACTIONS(3476),
    [anon_sym_module] = ACTIONS(3476),
    [anon_sym_open] = ACTIONS(3476),
    [anon_sym_LBRACK_LT] = ACTIONS(3474),
    [anon_sym_return] = ACTIONS(3476),
    [anon_sym_type] = ACTIONS(3476),
    [anon_sym_do] = ACTIONS(3476),
    [anon_sym_let] = ACTIONS(3476),
    [anon_sym_let_BANG] = ACTIONS(3474),
    [anon_sym_LPAREN] = ACTIONS(3476),
    [anon_sym_null] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym_LBRACK] = ACTIONS(3476),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3474),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_LT_AT] = ACTIONS(3476),
    [anon_sym_LT_AT_AT] = ACTIONS(3474),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3474),
    [anon_sym_new] = ACTIONS(3476),
    [anon_sym_return_BANG] = ACTIONS(3474),
    [anon_sym_yield] = ACTIONS(3476),
    [anon_sym_yield_BANG] = ACTIONS(3474),
    [anon_sym_lazy] = ACTIONS(3476),
    [anon_sym_assert] = ACTIONS(3476),
    [anon_sym_upcast] = ACTIONS(3476),
    [anon_sym_downcast] = ACTIONS(3476),
    [anon_sym_COLON_GT] = ACTIONS(3474),
    [anon_sym_for] = ACTIONS(3476),
    [anon_sym_while] = ACTIONS(3476),
    [anon_sym_if] = ACTIONS(3476),
    [anon_sym_fun] = ACTIONS(3476),
    [anon_sym_DASH_GT] = ACTIONS(3474),
    [anon_sym_try] = ACTIONS(3476),
    [anon_sym_match] = ACTIONS(3476),
    [anon_sym_match_BANG] = ACTIONS(3474),
    [anon_sym_function] = ACTIONS(3476),
    [anon_sym_use] = ACTIONS(3476),
    [anon_sym_use_BANG] = ACTIONS(3474),
    [anon_sym_do_BANG] = ACTIONS(3474),
    [anon_sym_begin] = ACTIONS(3476),
    [anon_sym_STAR] = ACTIONS(3474),
    [anon_sym_LT2] = ACTIONS(3476),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3474),
    [anon_sym_or] = ACTIONS(6505),
    [anon_sym_exception] = ACTIONS(3476),
    [aux_sym_char_token1] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3476),
    [anon_sym_DQUOTE] = ACTIONS(3476),
    [anon_sym_AT_DQUOTE] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [sym_bool] = ACTIONS(3476),
    [sym_unit] = ACTIONS(3474),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3476),
    [sym_op_identifier] = ACTIONS(3474),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3476),
    [anon_sym_PLUS_DOT] = ACTIONS(3474),
    [anon_sym_DASH_DOT] = ACTIONS(3474),
    [anon_sym_PERCENT] = ACTIONS(3474),
    [anon_sym_AMP_AMP] = ACTIONS(3474),
    [anon_sym_TILDE] = ACTIONS(3474),
    [aux_sym_prefix_op_token1] = ACTIONS(3474),
    [sym_int] = ACTIONS(3476),
    [sym_xint] = ACTIONS(3474),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3474),
    [anon_sym_POUNDload] = ACTIONS(3474),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3474),
  },
  [3998] = {
    [sym_type_arguments] = STATE(4027),
    [sym_long_identifier] = STATE(4023),
    [sym_block_comment] = STATE(3998),
    [sym_compiler_directive_decl] = STATE(3998),
    [sym_fsi_directive_decl] = STATE(3998),
    [sym_preproc_line] = STATE(3998),
    [aux_sym_compound_type_repeat1] = STATE(4007),
    [ts_builtin_sym_end] = ACTIONS(6511),
    [sym_identifier] = ACTIONS(6492),
    [anon_sym_namespace] = ACTIONS(6513),
    [anon_sym_module] = ACTIONS(6513),
    [anon_sym_open] = ACTIONS(6513),
    [anon_sym_LBRACK_LT] = ACTIONS(6511),
    [anon_sym_return] = ACTIONS(6513),
    [anon_sym_type] = ACTIONS(6513),
    [anon_sym_do] = ACTIONS(6513),
    [anon_sym_let] = ACTIONS(6513),
    [anon_sym_let_BANG] = ACTIONS(6511),
    [anon_sym_LPAREN] = ACTIONS(6513),
    [anon_sym_null] = ACTIONS(6513),
    [anon_sym_AMP] = ACTIONS(6513),
    [anon_sym_LBRACK] = ACTIONS(6513),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6511),
    [anon_sym_LBRACE] = ACTIONS(6513),
    [anon_sym_LT_AT] = ACTIONS(6513),
    [anon_sym_LT_AT_AT] = ACTIONS(6511),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6511),
    [anon_sym_new] = ACTIONS(6513),
    [anon_sym_return_BANG] = ACTIONS(6511),
    [anon_sym_yield] = ACTIONS(6513),
    [anon_sym_yield_BANG] = ACTIONS(6511),
    [anon_sym_lazy] = ACTIONS(6513),
    [anon_sym_assert] = ACTIONS(6513),
    [anon_sym_upcast] = ACTIONS(6513),
    [anon_sym_downcast] = ACTIONS(6513),
    [anon_sym_for] = ACTIONS(6513),
    [anon_sym_while] = ACTIONS(6513),
    [anon_sym_if] = ACTIONS(6513),
    [anon_sym_fun] = ACTIONS(6513),
    [anon_sym_DASH_GT] = ACTIONS(6494),
    [anon_sym_try] = ACTIONS(6513),
    [anon_sym_match] = ACTIONS(6513),
    [anon_sym_match_BANG] = ACTIONS(6511),
    [anon_sym_function] = ACTIONS(6513),
    [anon_sym_use] = ACTIONS(6513),
    [anon_sym_use_BANG] = ACTIONS(6511),
    [anon_sym_do_BANG] = ACTIONS(6511),
    [anon_sym_begin] = ACTIONS(6513),
    [anon_sym_STAR] = ACTIONS(6496),
    [anon_sym_LT2] = ACTIONS(6498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(6500),
    [anon_sym_exception] = ACTIONS(6513),
    [aux_sym_char_token1] = ACTIONS(6511),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6513),
    [anon_sym_DQUOTE] = ACTIONS(6513),
    [anon_sym_AT_DQUOTE] = ACTIONS(6511),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6511),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6511),
    [sym_bool] = ACTIONS(6513),
    [sym_unit] = ACTIONS(6511),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6513),
    [sym_op_identifier] = ACTIONS(6511),
    [anon_sym_PLUS] = ACTIONS(6513),
    [anon_sym_DASH] = ACTIONS(6513),
    [anon_sym_PLUS_DOT] = ACTIONS(6511),
    [anon_sym_DASH_DOT] = ACTIONS(6511),
    [anon_sym_PERCENT] = ACTIONS(6511),
    [anon_sym_AMP_AMP] = ACTIONS(6511),
    [anon_sym_TILDE] = ACTIONS(6511),
    [aux_sym_prefix_op_token1] = ACTIONS(6511),
    [sym_int] = ACTIONS(6513),
    [sym_xint] = ACTIONS(6511),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6511),
    [anon_sym_POUNDload] = ACTIONS(6511),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6511),
  },
  [3999] = {
    [sym_block_comment] = STATE(3999),
    [sym_compiler_directive_decl] = STATE(3999),
    [sym_fsi_directive_decl] = STATE(3999),
    [sym_preproc_line] = STATE(3999),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3191),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_GT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3191),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3191),
    [anon_sym_DASH_DOT] = ACTIONS(3191),
    [anon_sym_PERCENT] = ACTIONS(3191),
    [anon_sym_AMP_AMP] = ACTIONS(3191),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3191),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_y] = ACTIONS(6346),
    [anon_sym_uy] = ACTIONS(6348),
    [anon_sym_s] = ACTIONS(6350),
    [anon_sym_us] = ACTIONS(6352),
    [anon_sym_l] = ACTIONS(6354),
    [aux_sym_uint32_token1] = ACTIONS(6356),
    [anon_sym_n] = ACTIONS(6358),
    [anon_sym_un] = ACTIONS(6360),
    [anon_sym_L] = ACTIONS(6362),
    [aux_sym_uint64_token1] = ACTIONS(6364),
    [anon_sym_lf] = ACTIONS(6515),
    [anon_sym_LF] = ACTIONS(6517),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
  },
  [4000] = {
    [sym_block_comment] = STATE(4000),
    [sym_compiler_directive_decl] = STATE(4000),
    [sym_fsi_directive_decl] = STATE(4000),
    [sym_preproc_line] = STATE(4000),
    [ts_builtin_sym_end] = ACTIONS(3478),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_namespace] = ACTIONS(3480),
    [anon_sym_module] = ACTIONS(3480),
    [anon_sym_open] = ACTIONS(3480),
    [anon_sym_LBRACK_LT] = ACTIONS(3478),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_type] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3478),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3478),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3478),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_or] = ACTIONS(3480),
    [anon_sym_exception] = ACTIONS(3480),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3478),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3478),
    [anon_sym_DASH_DOT] = ACTIONS(3478),
    [anon_sym_PERCENT] = ACTIONS(3478),
    [anon_sym_AMP_AMP] = ACTIONS(3478),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3478),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3478),
    [anon_sym_POUNDload] = ACTIONS(3478),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
  },
  [4001] = {
    [sym_block_comment] = STATE(4001),
    [sym_compiler_directive_decl] = STATE(4001),
    [sym_fsi_directive_decl] = STATE(4001),
    [sym_preproc_line] = STATE(4001),
    [aux_sym_long_identifier_repeat1] = STATE(4001),
    [ts_builtin_sym_end] = ACTIONS(3485),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_namespace] = ACTIONS(3487),
    [anon_sym_module] = ACTIONS(3487),
    [anon_sym_open] = ACTIONS(3487),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_type] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3485),
    [anon_sym_DOT] = ACTIONS(6519),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3485),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3485),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_exception] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3485),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3485),
    [anon_sym_DASH_DOT] = ACTIONS(3485),
    [anon_sym_PERCENT] = ACTIONS(3485),
    [anon_sym_AMP_AMP] = ACTIONS(3485),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3485),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3485),
    [anon_sym_POUNDload] = ACTIONS(3485),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
  },
  [4002] = {
    [sym_block_comment] = STATE(4002),
    [sym_compiler_directive_decl] = STATE(4002),
    [sym_fsi_directive_decl] = STATE(4002),
    [sym_preproc_line] = STATE(4002),
    [aux_sym_long_identifier_repeat1] = STATE(4001),
    [ts_builtin_sym_end] = ACTIONS(3449),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_namespace] = ACTIONS(3451),
    [anon_sym_module] = ACTIONS(3451),
    [anon_sym_open] = ACTIONS(3451),
    [anon_sym_LBRACK_LT] = ACTIONS(3449),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_type] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3449),
    [anon_sym_DOT] = ACTIONS(6522),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_DASH_GT] = ACTIONS(3449),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_STAR] = ACTIONS(3449),
    [anon_sym_LT2] = ACTIONS(3451),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3449),
    [anon_sym_exception] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3449),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3449),
    [anon_sym_DASH_DOT] = ACTIONS(3449),
    [anon_sym_PERCENT] = ACTIONS(3449),
    [anon_sym_AMP_AMP] = ACTIONS(3449),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3449),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3449),
    [anon_sym_POUNDload] = ACTIONS(3449),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
  },
  [4003] = {
    [sym_block_comment] = STATE(4003),
    [sym_compiler_directive_decl] = STATE(4003),
    [sym_fsi_directive_decl] = STATE(4003),
    [sym_preproc_line] = STATE(4003),
    [aux_sym_long_identifier_repeat1] = STATE(4002),
    [ts_builtin_sym_end] = ACTIONS(3492),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_namespace] = ACTIONS(3494),
    [anon_sym_module] = ACTIONS(3494),
    [anon_sym_open] = ACTIONS(3494),
    [anon_sym_LBRACK_LT] = ACTIONS(3492),
    [anon_sym_return] = ACTIONS(3494),
    [anon_sym_type] = ACTIONS(3494),
    [anon_sym_do] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_let_BANG] = ACTIONS(3492),
    [anon_sym_LPAREN] = ACTIONS(3494),
    [anon_sym_null] = ACTIONS(3494),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3492),
    [anon_sym_LBRACE] = ACTIONS(3494),
    [anon_sym_LT_AT] = ACTIONS(3494),
    [anon_sym_LT_AT_AT] = ACTIONS(3492),
    [anon_sym_DOT] = ACTIONS(6522),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3492),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_return_BANG] = ACTIONS(3492),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_yield_BANG] = ACTIONS(3492),
    [anon_sym_lazy] = ACTIONS(3494),
    [anon_sym_assert] = ACTIONS(3494),
    [anon_sym_upcast] = ACTIONS(3494),
    [anon_sym_downcast] = ACTIONS(3494),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_while] = ACTIONS(3494),
    [anon_sym_if] = ACTIONS(3494),
    [anon_sym_fun] = ACTIONS(3494),
    [anon_sym_DASH_GT] = ACTIONS(3492),
    [anon_sym_try] = ACTIONS(3494),
    [anon_sym_match] = ACTIONS(3494),
    [anon_sym_match_BANG] = ACTIONS(3492),
    [anon_sym_function] = ACTIONS(3494),
    [anon_sym_use] = ACTIONS(3494),
    [anon_sym_use_BANG] = ACTIONS(3492),
    [anon_sym_do_BANG] = ACTIONS(3492),
    [anon_sym_begin] = ACTIONS(3494),
    [anon_sym_STAR] = ACTIONS(3492),
    [anon_sym_LT2] = ACTIONS(3494),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3492),
    [anon_sym_exception] = ACTIONS(3494),
    [aux_sym_char_token1] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3494),
    [anon_sym_DQUOTE] = ACTIONS(3494),
    [anon_sym_AT_DQUOTE] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [sym_bool] = ACTIONS(3494),
    [sym_unit] = ACTIONS(3492),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3494),
    [sym_op_identifier] = ACTIONS(3492),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_PLUS_DOT] = ACTIONS(3492),
    [anon_sym_DASH_DOT] = ACTIONS(3492),
    [anon_sym_PERCENT] = ACTIONS(3492),
    [anon_sym_AMP_AMP] = ACTIONS(3492),
    [anon_sym_TILDE] = ACTIONS(3492),
    [aux_sym_prefix_op_token1] = ACTIONS(3492),
    [sym_int] = ACTIONS(3494),
    [sym_xint] = ACTIONS(3492),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3492),
    [anon_sym_POUNDload] = ACTIONS(3492),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3492),
  },
  [4004] = {
    [sym_block_comment] = STATE(4004),
    [sym_compiler_directive_decl] = STATE(4004),
    [sym_fsi_directive_decl] = STATE(4004),
    [sym_preproc_line] = STATE(4004),
    [ts_builtin_sym_end] = ACTIONS(3509),
    [sym_identifier] = ACTIONS(3511),
    [anon_sym_namespace] = ACTIONS(3511),
    [anon_sym_module] = ACTIONS(3511),
    [anon_sym_open] = ACTIONS(3511),
    [anon_sym_LBRACK_LT] = ACTIONS(3509),
    [anon_sym_return] = ACTIONS(3511),
    [anon_sym_type] = ACTIONS(3511),
    [anon_sym_do] = ACTIONS(3511),
    [anon_sym_let] = ACTIONS(3511),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3511),
    [anon_sym_null] = ACTIONS(3511),
    [anon_sym_AMP] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(3511),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_LT_AT] = ACTIONS(3511),
    [anon_sym_LT_AT_AT] = ACTIONS(3509),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3511),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3511),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3511),
    [anon_sym_assert] = ACTIONS(3511),
    [anon_sym_upcast] = ACTIONS(3511),
    [anon_sym_downcast] = ACTIONS(3511),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3511),
    [anon_sym_while] = ACTIONS(3511),
    [anon_sym_if] = ACTIONS(3511),
    [anon_sym_fun] = ACTIONS(3511),
    [anon_sym_DASH_GT] = ACTIONS(3509),
    [anon_sym_try] = ACTIONS(3511),
    [anon_sym_match] = ACTIONS(3511),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3511),
    [anon_sym_use] = ACTIONS(3511),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3511),
    [anon_sym_STAR] = ACTIONS(3509),
    [anon_sym_LT2] = ACTIONS(3511),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3511),
    [anon_sym_exception] = ACTIONS(3511),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3511),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3511),
    [sym_unit] = ACTIONS(3509),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3511),
    [sym_op_identifier] = ACTIONS(3509),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3511),
    [anon_sym_PLUS_DOT] = ACTIONS(3509),
    [anon_sym_DASH_DOT] = ACTIONS(3509),
    [anon_sym_PERCENT] = ACTIONS(3509),
    [anon_sym_AMP_AMP] = ACTIONS(3509),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3509),
    [sym_int] = ACTIONS(3511),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3509),
    [anon_sym_POUNDload] = ACTIONS(3509),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3509),
  },
  [4005] = {
    [sym_attributes] = STATE(12111),
    [sym__attribute_set] = STATE(9964),
    [sym_block_comment] = STATE(4005),
    [sym_compiler_directive_decl] = STATE(4005),
    [sym_fsi_directive_decl] = STATE(4005),
    [sym_preproc_line] = STATE(4005),
    [aux_sym_attributes_repeat1] = STATE(8813),
    [aux_sym_type_definition_repeat1] = STATE(4010),
    [ts_builtin_sym_end] = ACTIONS(6524),
    [sym_identifier] = ACTIONS(6526),
    [anon_sym_namespace] = ACTIONS(6526),
    [anon_sym_module] = ACTIONS(6526),
    [anon_sym_open] = ACTIONS(6526),
    [anon_sym_LBRACK_LT] = ACTIONS(6524),
    [anon_sym_return] = ACTIONS(6526),
    [anon_sym_type] = ACTIONS(6526),
    [anon_sym_do] = ACTIONS(6526),
    [anon_sym_and] = ACTIONS(6528),
    [anon_sym_let] = ACTIONS(6526),
    [anon_sym_let_BANG] = ACTIONS(6524),
    [anon_sym_LPAREN] = ACTIONS(6526),
    [anon_sym_null] = ACTIONS(6526),
    [anon_sym_AMP] = ACTIONS(6526),
    [anon_sym_LBRACK] = ACTIONS(6526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6524),
    [anon_sym_LBRACE] = ACTIONS(6526),
    [anon_sym_LT_AT] = ACTIONS(6526),
    [anon_sym_LT_AT_AT] = ACTIONS(6524),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6524),
    [anon_sym_new] = ACTIONS(6526),
    [anon_sym_return_BANG] = ACTIONS(6524),
    [anon_sym_yield] = ACTIONS(6526),
    [anon_sym_yield_BANG] = ACTIONS(6524),
    [anon_sym_lazy] = ACTIONS(6526),
    [anon_sym_assert] = ACTIONS(6526),
    [anon_sym_upcast] = ACTIONS(6526),
    [anon_sym_downcast] = ACTIONS(6526),
    [anon_sym_for] = ACTIONS(6526),
    [anon_sym_while] = ACTIONS(6526),
    [anon_sym_if] = ACTIONS(6526),
    [anon_sym_fun] = ACTIONS(6526),
    [anon_sym_try] = ACTIONS(6526),
    [anon_sym_match] = ACTIONS(6526),
    [anon_sym_match_BANG] = ACTIONS(6524),
    [anon_sym_function] = ACTIONS(6526),
    [anon_sym_use] = ACTIONS(6526),
    [anon_sym_use_BANG] = ACTIONS(6524),
    [anon_sym_do_BANG] = ACTIONS(6524),
    [anon_sym_begin] = ACTIONS(6526),
    [anon_sym_exception] = ACTIONS(6526),
    [aux_sym_char_token1] = ACTIONS(6524),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6526),
    [anon_sym_DQUOTE] = ACTIONS(6526),
    [anon_sym_AT_DQUOTE] = ACTIONS(6524),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6524),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6524),
    [sym_bool] = ACTIONS(6526),
    [sym_unit] = ACTIONS(6524),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6526),
    [sym_op_identifier] = ACTIONS(6524),
    [anon_sym_PLUS] = ACTIONS(6526),
    [anon_sym_DASH] = ACTIONS(6526),
    [anon_sym_PLUS_DOT] = ACTIONS(6524),
    [anon_sym_DASH_DOT] = ACTIONS(6524),
    [anon_sym_PERCENT] = ACTIONS(6524),
    [anon_sym_AMP_AMP] = ACTIONS(6524),
    [anon_sym_TILDE] = ACTIONS(6524),
    [aux_sym_prefix_op_token1] = ACTIONS(6524),
    [sym_int] = ACTIONS(6526),
    [sym_xint] = ACTIONS(6524),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6524),
    [anon_sym_POUNDload] = ACTIONS(6524),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6524),
  },
  [4006] = {
    [sym_block_comment] = STATE(4006),
    [sym_compiler_directive_decl] = STATE(4006),
    [sym_fsi_directive_decl] = STATE(4006),
    [sym_preproc_line] = STATE(4006),
    [ts_builtin_sym_end] = ACTIONS(3485),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_namespace] = ACTIONS(3487),
    [anon_sym_module] = ACTIONS(3487),
    [anon_sym_open] = ACTIONS(3487),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_type] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3485),
    [anon_sym_DOT] = ACTIONS(3485),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3485),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3485),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [anon_sym_exception] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3485),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3485),
    [anon_sym_DASH_DOT] = ACTIONS(3485),
    [anon_sym_PERCENT] = ACTIONS(3485),
    [anon_sym_AMP_AMP] = ACTIONS(3485),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3485),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3485),
    [anon_sym_POUNDload] = ACTIONS(3485),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
  },
  [4007] = {
    [sym_block_comment] = STATE(4007),
    [sym_compiler_directive_decl] = STATE(4007),
    [sym_fsi_directive_decl] = STATE(4007),
    [sym_preproc_line] = STATE(4007),
    [aux_sym_compound_type_repeat1] = STATE(4011),
    [ts_builtin_sym_end] = ACTIONS(3466),
    [sym_identifier] = ACTIONS(3468),
    [anon_sym_namespace] = ACTIONS(3468),
    [anon_sym_module] = ACTIONS(3468),
    [anon_sym_open] = ACTIONS(3468),
    [anon_sym_LBRACK_LT] = ACTIONS(3466),
    [anon_sym_return] = ACTIONS(3468),
    [anon_sym_type] = ACTIONS(3468),
    [anon_sym_do] = ACTIONS(3468),
    [anon_sym_let] = ACTIONS(3468),
    [anon_sym_let_BANG] = ACTIONS(3466),
    [anon_sym_LPAREN] = ACTIONS(3468),
    [anon_sym_null] = ACTIONS(3468),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LBRACK] = ACTIONS(3468),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3466),
    [anon_sym_LBRACE] = ACTIONS(3468),
    [anon_sym_LT_AT] = ACTIONS(3468),
    [anon_sym_LT_AT_AT] = ACTIONS(3466),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3466),
    [anon_sym_new] = ACTIONS(3468),
    [anon_sym_return_BANG] = ACTIONS(3466),
    [anon_sym_yield] = ACTIONS(3468),
    [anon_sym_yield_BANG] = ACTIONS(3466),
    [anon_sym_lazy] = ACTIONS(3468),
    [anon_sym_assert] = ACTIONS(3468),
    [anon_sym_upcast] = ACTIONS(3468),
    [anon_sym_downcast] = ACTIONS(3468),
    [anon_sym_for] = ACTIONS(3468),
    [anon_sym_while] = ACTIONS(3468),
    [anon_sym_if] = ACTIONS(3468),
    [anon_sym_fun] = ACTIONS(3468),
    [anon_sym_DASH_GT] = ACTIONS(3466),
    [anon_sym_try] = ACTIONS(3468),
    [anon_sym_match] = ACTIONS(3468),
    [anon_sym_match_BANG] = ACTIONS(3466),
    [anon_sym_function] = ACTIONS(3468),
    [anon_sym_use] = ACTIONS(3468),
    [anon_sym_use_BANG] = ACTIONS(3466),
    [anon_sym_do_BANG] = ACTIONS(3466),
    [anon_sym_begin] = ACTIONS(3468),
    [anon_sym_STAR] = ACTIONS(6496),
    [anon_sym_LT2] = ACTIONS(3468),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3466),
    [anon_sym_exception] = ACTIONS(3468),
    [aux_sym_char_token1] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3468),
    [anon_sym_DQUOTE] = ACTIONS(3468),
    [anon_sym_AT_DQUOTE] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [sym_bool] = ACTIONS(3468),
    [sym_unit] = ACTIONS(3466),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3468),
    [sym_op_identifier] = ACTIONS(3466),
    [anon_sym_PLUS] = ACTIONS(3468),
    [anon_sym_DASH] = ACTIONS(3468),
    [anon_sym_PLUS_DOT] = ACTIONS(3466),
    [anon_sym_DASH_DOT] = ACTIONS(3466),
    [anon_sym_PERCENT] = ACTIONS(3466),
    [anon_sym_AMP_AMP] = ACTIONS(3466),
    [anon_sym_TILDE] = ACTIONS(3466),
    [aux_sym_prefix_op_token1] = ACTIONS(3466),
    [sym_int] = ACTIONS(3468),
    [sym_xint] = ACTIONS(3466),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3466),
    [anon_sym_POUNDload] = ACTIONS(3466),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3466),
  },
  [4008] = {
    [sym_block_comment] = STATE(4008),
    [sym_compiler_directive_decl] = STATE(4008),
    [sym_fsi_directive_decl] = STATE(4008),
    [sym_preproc_line] = STATE(4008),
    [ts_builtin_sym_end] = ACTIONS(3496),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_namespace] = ACTIONS(3498),
    [anon_sym_module] = ACTIONS(3498),
    [anon_sym_open] = ACTIONS(3498),
    [anon_sym_LBRACK_LT] = ACTIONS(3496),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_type] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3496),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3496),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3496),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_exception] = ACTIONS(3498),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3496),
    [anon_sym_DASH_DOT] = ACTIONS(3496),
    [anon_sym_PERCENT] = ACTIONS(3496),
    [anon_sym_AMP_AMP] = ACTIONS(3496),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3496),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3496),
    [anon_sym_POUNDload] = ACTIONS(3496),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
  },
  [4009] = {
    [sym_block_comment] = STATE(4009),
    [sym_compiler_directive_decl] = STATE(4009),
    [sym_fsi_directive_decl] = STATE(4009),
    [sym_preproc_line] = STATE(4009),
    [ts_builtin_sym_end] = ACTIONS(3513),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_namespace] = ACTIONS(3515),
    [anon_sym_module] = ACTIONS(3515),
    [anon_sym_open] = ACTIONS(3515),
    [anon_sym_LBRACK_LT] = ACTIONS(3513),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_type] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(6530),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3513),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3513),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_exception] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3513),
    [anon_sym_DASH_DOT] = ACTIONS(3513),
    [anon_sym_PERCENT] = ACTIONS(3513),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3513),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3513),
    [anon_sym_POUNDload] = ACTIONS(3513),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
  },
  [4010] = {
    [sym_attributes] = STATE(12111),
    [sym__attribute_set] = STATE(9964),
    [sym_block_comment] = STATE(4010),
    [sym_compiler_directive_decl] = STATE(4010),
    [sym_fsi_directive_decl] = STATE(4010),
    [sym_preproc_line] = STATE(4010),
    [aux_sym_attributes_repeat1] = STATE(8813),
    [aux_sym_type_definition_repeat1] = STATE(4013),
    [ts_builtin_sym_end] = ACTIONS(6532),
    [sym_identifier] = ACTIONS(6534),
    [anon_sym_namespace] = ACTIONS(6534),
    [anon_sym_module] = ACTIONS(6534),
    [anon_sym_open] = ACTIONS(6534),
    [anon_sym_LBRACK_LT] = ACTIONS(6532),
    [anon_sym_return] = ACTIONS(6534),
    [anon_sym_type] = ACTIONS(6534),
    [anon_sym_do] = ACTIONS(6534),
    [anon_sym_and] = ACTIONS(6528),
    [anon_sym_let] = ACTIONS(6534),
    [anon_sym_let_BANG] = ACTIONS(6532),
    [anon_sym_LPAREN] = ACTIONS(6534),
    [anon_sym_null] = ACTIONS(6534),
    [anon_sym_AMP] = ACTIONS(6534),
    [anon_sym_LBRACK] = ACTIONS(6534),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6532),
    [anon_sym_LBRACE] = ACTIONS(6534),
    [anon_sym_LT_AT] = ACTIONS(6534),
    [anon_sym_LT_AT_AT] = ACTIONS(6532),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6532),
    [anon_sym_new] = ACTIONS(6534),
    [anon_sym_return_BANG] = ACTIONS(6532),
    [anon_sym_yield] = ACTIONS(6534),
    [anon_sym_yield_BANG] = ACTIONS(6532),
    [anon_sym_lazy] = ACTIONS(6534),
    [anon_sym_assert] = ACTIONS(6534),
    [anon_sym_upcast] = ACTIONS(6534),
    [anon_sym_downcast] = ACTIONS(6534),
    [anon_sym_for] = ACTIONS(6534),
    [anon_sym_while] = ACTIONS(6534),
    [anon_sym_if] = ACTIONS(6534),
    [anon_sym_fun] = ACTIONS(6534),
    [anon_sym_try] = ACTIONS(6534),
    [anon_sym_match] = ACTIONS(6534),
    [anon_sym_match_BANG] = ACTIONS(6532),
    [anon_sym_function] = ACTIONS(6534),
    [anon_sym_use] = ACTIONS(6534),
    [anon_sym_use_BANG] = ACTIONS(6532),
    [anon_sym_do_BANG] = ACTIONS(6532),
    [anon_sym_begin] = ACTIONS(6534),
    [anon_sym_exception] = ACTIONS(6534),
    [aux_sym_char_token1] = ACTIONS(6532),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6534),
    [anon_sym_DQUOTE] = ACTIONS(6534),
    [anon_sym_AT_DQUOTE] = ACTIONS(6532),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6532),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6532),
    [sym_bool] = ACTIONS(6534),
    [sym_unit] = ACTIONS(6532),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6534),
    [sym_op_identifier] = ACTIONS(6532),
    [anon_sym_PLUS] = ACTIONS(6534),
    [anon_sym_DASH] = ACTIONS(6534),
    [anon_sym_PLUS_DOT] = ACTIONS(6532),
    [anon_sym_DASH_DOT] = ACTIONS(6532),
    [anon_sym_PERCENT] = ACTIONS(6532),
    [anon_sym_AMP_AMP] = ACTIONS(6532),
    [anon_sym_TILDE] = ACTIONS(6532),
    [aux_sym_prefix_op_token1] = ACTIONS(6532),
    [sym_int] = ACTIONS(6534),
    [sym_xint] = ACTIONS(6532),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6532),
    [anon_sym_POUNDload] = ACTIONS(6532),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6532),
  },
  [4011] = {
    [sym_block_comment] = STATE(4011),
    [sym_compiler_directive_decl] = STATE(4011),
    [sym_fsi_directive_decl] = STATE(4011),
    [sym_preproc_line] = STATE(4011),
    [aux_sym_compound_type_repeat1] = STATE(4011),
    [ts_builtin_sym_end] = ACTIONS(3425),
    [sym_identifier] = ACTIONS(3427),
    [anon_sym_namespace] = ACTIONS(3427),
    [anon_sym_module] = ACTIONS(3427),
    [anon_sym_open] = ACTIONS(3427),
    [anon_sym_LBRACK_LT] = ACTIONS(3425),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_type] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3425),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(3425),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(6536),
    [anon_sym_LT2] = ACTIONS(3427),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3425),
    [anon_sym_exception] = ACTIONS(3427),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3425),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3425),
    [anon_sym_DASH_DOT] = ACTIONS(3425),
    [anon_sym_PERCENT] = ACTIONS(3425),
    [anon_sym_AMP_AMP] = ACTIONS(3425),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3425),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3425),
    [anon_sym_POUNDload] = ACTIONS(3425),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
  },
  [4012] = {
    [sym_attributes] = STATE(12111),
    [sym__attribute_set] = STATE(9964),
    [sym_block_comment] = STATE(4012),
    [sym_compiler_directive_decl] = STATE(4012),
    [sym_fsi_directive_decl] = STATE(4012),
    [sym_preproc_line] = STATE(4012),
    [aux_sym_attributes_repeat1] = STATE(8813),
    [aux_sym_type_definition_repeat1] = STATE(4014),
    [ts_builtin_sym_end] = ACTIONS(6532),
    [sym_identifier] = ACTIONS(6534),
    [anon_sym_namespace] = ACTIONS(6534),
    [anon_sym_module] = ACTIONS(6534),
    [anon_sym_open] = ACTIONS(6534),
    [anon_sym_LBRACK_LT] = ACTIONS(6532),
    [anon_sym_return] = ACTIONS(6534),
    [anon_sym_type] = ACTIONS(6534),
    [anon_sym_do] = ACTIONS(6534),
    [anon_sym_and] = ACTIONS(6528),
    [anon_sym_let] = ACTIONS(6534),
    [anon_sym_let_BANG] = ACTIONS(6532),
    [anon_sym_LPAREN] = ACTIONS(6534),
    [anon_sym_null] = ACTIONS(6534),
    [anon_sym_AMP] = ACTIONS(6534),
    [anon_sym_LBRACK] = ACTIONS(6534),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6532),
    [anon_sym_LBRACE] = ACTIONS(6534),
    [anon_sym_LT_AT] = ACTIONS(6534),
    [anon_sym_LT_AT_AT] = ACTIONS(6532),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6532),
    [anon_sym_new] = ACTIONS(6534),
    [anon_sym_return_BANG] = ACTIONS(6532),
    [anon_sym_yield] = ACTIONS(6534),
    [anon_sym_yield_BANG] = ACTIONS(6532),
    [anon_sym_lazy] = ACTIONS(6534),
    [anon_sym_assert] = ACTIONS(6534),
    [anon_sym_upcast] = ACTIONS(6534),
    [anon_sym_downcast] = ACTIONS(6534),
    [anon_sym_for] = ACTIONS(6534),
    [anon_sym_while] = ACTIONS(6534),
    [anon_sym_if] = ACTIONS(6534),
    [anon_sym_fun] = ACTIONS(6534),
    [anon_sym_try] = ACTIONS(6534),
    [anon_sym_match] = ACTIONS(6534),
    [anon_sym_match_BANG] = ACTIONS(6532),
    [anon_sym_function] = ACTIONS(6534),
    [anon_sym_use] = ACTIONS(6534),
    [anon_sym_use_BANG] = ACTIONS(6532),
    [anon_sym_do_BANG] = ACTIONS(6532),
    [anon_sym_begin] = ACTIONS(6534),
    [anon_sym_exception] = ACTIONS(6534),
    [aux_sym_char_token1] = ACTIONS(6532),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6534),
    [anon_sym_DQUOTE] = ACTIONS(6534),
    [anon_sym_AT_DQUOTE] = ACTIONS(6532),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6532),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6532),
    [sym_bool] = ACTIONS(6534),
    [sym_unit] = ACTIONS(6532),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6534),
    [sym_op_identifier] = ACTIONS(6532),
    [anon_sym_PLUS] = ACTIONS(6534),
    [anon_sym_DASH] = ACTIONS(6534),
    [anon_sym_PLUS_DOT] = ACTIONS(6532),
    [anon_sym_DASH_DOT] = ACTIONS(6532),
    [anon_sym_PERCENT] = ACTIONS(6532),
    [anon_sym_AMP_AMP] = ACTIONS(6532),
    [anon_sym_TILDE] = ACTIONS(6532),
    [aux_sym_prefix_op_token1] = ACTIONS(6532),
    [sym_int] = ACTIONS(6534),
    [sym_xint] = ACTIONS(6532),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6532),
    [anon_sym_POUNDload] = ACTIONS(6532),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6532),
  },
  [4013] = {
    [sym_attributes] = STATE(12111),
    [sym__attribute_set] = STATE(9964),
    [sym_block_comment] = STATE(4013),
    [sym_compiler_directive_decl] = STATE(4013),
    [sym_fsi_directive_decl] = STATE(4013),
    [sym_preproc_line] = STATE(4013),
    [aux_sym_attributes_repeat1] = STATE(8813),
    [aux_sym_type_definition_repeat1] = STATE(4013),
    [ts_builtin_sym_end] = ACTIONS(6539),
    [sym_identifier] = ACTIONS(6541),
    [anon_sym_namespace] = ACTIONS(6541),
    [anon_sym_module] = ACTIONS(6541),
    [anon_sym_open] = ACTIONS(6541),
    [anon_sym_LBRACK_LT] = ACTIONS(6543),
    [anon_sym_return] = ACTIONS(6541),
    [anon_sym_type] = ACTIONS(6541),
    [anon_sym_do] = ACTIONS(6541),
    [anon_sym_and] = ACTIONS(6546),
    [anon_sym_let] = ACTIONS(6541),
    [anon_sym_let_BANG] = ACTIONS(6539),
    [anon_sym_LPAREN] = ACTIONS(6541),
    [anon_sym_null] = ACTIONS(6541),
    [anon_sym_AMP] = ACTIONS(6541),
    [anon_sym_LBRACK] = ACTIONS(6541),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6539),
    [anon_sym_LBRACE] = ACTIONS(6541),
    [anon_sym_LT_AT] = ACTIONS(6541),
    [anon_sym_LT_AT_AT] = ACTIONS(6539),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6539),
    [anon_sym_new] = ACTIONS(6541),
    [anon_sym_return_BANG] = ACTIONS(6539),
    [anon_sym_yield] = ACTIONS(6541),
    [anon_sym_yield_BANG] = ACTIONS(6539),
    [anon_sym_lazy] = ACTIONS(6541),
    [anon_sym_assert] = ACTIONS(6541),
    [anon_sym_upcast] = ACTIONS(6541),
    [anon_sym_downcast] = ACTIONS(6541),
    [anon_sym_for] = ACTIONS(6541),
    [anon_sym_while] = ACTIONS(6541),
    [anon_sym_if] = ACTIONS(6541),
    [anon_sym_fun] = ACTIONS(6541),
    [anon_sym_try] = ACTIONS(6541),
    [anon_sym_match] = ACTIONS(6541),
    [anon_sym_match_BANG] = ACTIONS(6539),
    [anon_sym_function] = ACTIONS(6541),
    [anon_sym_use] = ACTIONS(6541),
    [anon_sym_use_BANG] = ACTIONS(6539),
    [anon_sym_do_BANG] = ACTIONS(6539),
    [anon_sym_begin] = ACTIONS(6541),
    [anon_sym_exception] = ACTIONS(6541),
    [aux_sym_char_token1] = ACTIONS(6539),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6541),
    [anon_sym_DQUOTE] = ACTIONS(6541),
    [anon_sym_AT_DQUOTE] = ACTIONS(6539),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6539),
    [sym_bool] = ACTIONS(6541),
    [sym_unit] = ACTIONS(6539),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6541),
    [sym_op_identifier] = ACTIONS(6539),
    [anon_sym_PLUS] = ACTIONS(6541),
    [anon_sym_DASH] = ACTIONS(6541),
    [anon_sym_PLUS_DOT] = ACTIONS(6539),
    [anon_sym_DASH_DOT] = ACTIONS(6539),
    [anon_sym_PERCENT] = ACTIONS(6539),
    [anon_sym_AMP_AMP] = ACTIONS(6539),
    [anon_sym_TILDE] = ACTIONS(6539),
    [aux_sym_prefix_op_token1] = ACTIONS(6539),
    [sym_int] = ACTIONS(6541),
    [sym_xint] = ACTIONS(6539),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6539),
    [anon_sym_POUNDload] = ACTIONS(6539),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6539),
  },
  [4014] = {
    [sym_attributes] = STATE(12111),
    [sym__attribute_set] = STATE(9964),
    [sym_block_comment] = STATE(4014),
    [sym_compiler_directive_decl] = STATE(4014),
    [sym_fsi_directive_decl] = STATE(4014),
    [sym_preproc_line] = STATE(4014),
    [aux_sym_attributes_repeat1] = STATE(8813),
    [aux_sym_type_definition_repeat1] = STATE(4013),
    [ts_builtin_sym_end] = ACTIONS(6549),
    [sym_identifier] = ACTIONS(6551),
    [anon_sym_namespace] = ACTIONS(6551),
    [anon_sym_module] = ACTIONS(6551),
    [anon_sym_open] = ACTIONS(6551),
    [anon_sym_LBRACK_LT] = ACTIONS(6549),
    [anon_sym_return] = ACTIONS(6551),
    [anon_sym_type] = ACTIONS(6551),
    [anon_sym_do] = ACTIONS(6551),
    [anon_sym_and] = ACTIONS(6528),
    [anon_sym_let] = ACTIONS(6551),
    [anon_sym_let_BANG] = ACTIONS(6549),
    [anon_sym_LPAREN] = ACTIONS(6551),
    [anon_sym_null] = ACTIONS(6551),
    [anon_sym_AMP] = ACTIONS(6551),
    [anon_sym_LBRACK] = ACTIONS(6551),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6549),
    [anon_sym_LBRACE] = ACTIONS(6551),
    [anon_sym_LT_AT] = ACTIONS(6551),
    [anon_sym_LT_AT_AT] = ACTIONS(6549),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6549),
    [anon_sym_new] = ACTIONS(6551),
    [anon_sym_return_BANG] = ACTIONS(6549),
    [anon_sym_yield] = ACTIONS(6551),
    [anon_sym_yield_BANG] = ACTIONS(6549),
    [anon_sym_lazy] = ACTIONS(6551),
    [anon_sym_assert] = ACTIONS(6551),
    [anon_sym_upcast] = ACTIONS(6551),
    [anon_sym_downcast] = ACTIONS(6551),
    [anon_sym_for] = ACTIONS(6551),
    [anon_sym_while] = ACTIONS(6551),
    [anon_sym_if] = ACTIONS(6551),
    [anon_sym_fun] = ACTIONS(6551),
    [anon_sym_try] = ACTIONS(6551),
    [anon_sym_match] = ACTIONS(6551),
    [anon_sym_match_BANG] = ACTIONS(6549),
    [anon_sym_function] = ACTIONS(6551),
    [anon_sym_use] = ACTIONS(6551),
    [anon_sym_use_BANG] = ACTIONS(6549),
    [anon_sym_do_BANG] = ACTIONS(6549),
    [anon_sym_begin] = ACTIONS(6551),
    [anon_sym_exception] = ACTIONS(6551),
    [aux_sym_char_token1] = ACTIONS(6549),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6551),
    [anon_sym_DQUOTE] = ACTIONS(6551),
    [anon_sym_AT_DQUOTE] = ACTIONS(6549),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6549),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6549),
    [sym_bool] = ACTIONS(6551),
    [sym_unit] = ACTIONS(6549),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6551),
    [sym_op_identifier] = ACTIONS(6549),
    [anon_sym_PLUS] = ACTIONS(6551),
    [anon_sym_DASH] = ACTIONS(6551),
    [anon_sym_PLUS_DOT] = ACTIONS(6549),
    [anon_sym_DASH_DOT] = ACTIONS(6549),
    [anon_sym_PERCENT] = ACTIONS(6549),
    [anon_sym_AMP_AMP] = ACTIONS(6549),
    [anon_sym_TILDE] = ACTIONS(6549),
    [aux_sym_prefix_op_token1] = ACTIONS(6549),
    [sym_int] = ACTIONS(6551),
    [sym_xint] = ACTIONS(6549),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6549),
    [anon_sym_POUNDload] = ACTIONS(6549),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6549),
  },
  [4015] = {
    [sym_block_comment] = STATE(4015),
    [sym_compiler_directive_decl] = STATE(4015),
    [sym_fsi_directive_decl] = STATE(4015),
    [sym_preproc_line] = STATE(4015),
    [ts_builtin_sym_end] = ACTIONS(3503),
    [sym_identifier] = ACTIONS(3505),
    [anon_sym_namespace] = ACTIONS(3505),
    [anon_sym_module] = ACTIONS(3505),
    [anon_sym_open] = ACTIONS(3505),
    [anon_sym_LBRACK_LT] = ACTIONS(3503),
    [anon_sym_return] = ACTIONS(3505),
    [anon_sym_type] = ACTIONS(3505),
    [anon_sym_do] = ACTIONS(3505),
    [anon_sym_let] = ACTIONS(3505),
    [anon_sym_let_BANG] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3505),
    [anon_sym_null] = ACTIONS(3505),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3503),
    [anon_sym_LBRACE] = ACTIONS(3505),
    [anon_sym_LT_AT] = ACTIONS(3505),
    [anon_sym_LT_AT_AT] = ACTIONS(3503),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3503),
    [anon_sym_new] = ACTIONS(3505),
    [anon_sym_return_BANG] = ACTIONS(3503),
    [anon_sym_yield] = ACTIONS(3505),
    [anon_sym_yield_BANG] = ACTIONS(3503),
    [anon_sym_lazy] = ACTIONS(3505),
    [anon_sym_assert] = ACTIONS(3505),
    [anon_sym_upcast] = ACTIONS(3505),
    [anon_sym_downcast] = ACTIONS(3505),
    [anon_sym_for] = ACTIONS(3505),
    [anon_sym_while] = ACTIONS(3505),
    [anon_sym_if] = ACTIONS(3505),
    [anon_sym_fun] = ACTIONS(3505),
    [anon_sym_DASH_GT] = ACTIONS(3503),
    [anon_sym_try] = ACTIONS(3505),
    [anon_sym_match] = ACTIONS(3505),
    [anon_sym_match_BANG] = ACTIONS(3503),
    [anon_sym_function] = ACTIONS(3505),
    [anon_sym_use] = ACTIONS(3505),
    [anon_sym_use_BANG] = ACTIONS(3503),
    [anon_sym_do_BANG] = ACTIONS(3503),
    [anon_sym_begin] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3503),
    [anon_sym_LT2] = ACTIONS(6553),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_exception] = ACTIONS(3505),
    [aux_sym_char_token1] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3505),
    [anon_sym_DQUOTE] = ACTIONS(3505),
    [anon_sym_AT_DQUOTE] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [sym_bool] = ACTIONS(3505),
    [sym_unit] = ACTIONS(3503),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3505),
    [sym_op_identifier] = ACTIONS(3503),
    [anon_sym_PLUS] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3505),
    [anon_sym_PLUS_DOT] = ACTIONS(3503),
    [anon_sym_DASH_DOT] = ACTIONS(3503),
    [anon_sym_PERCENT] = ACTIONS(3503),
    [anon_sym_AMP_AMP] = ACTIONS(3503),
    [anon_sym_TILDE] = ACTIONS(3503),
    [aux_sym_prefix_op_token1] = ACTIONS(3503),
    [sym_int] = ACTIONS(3505),
    [sym_xint] = ACTIONS(3503),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3503),
    [anon_sym_POUNDload] = ACTIONS(3503),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3503),
  },
  [4016] = {
    [sym_block_comment] = STATE(4016),
    [sym_compiler_directive_decl] = STATE(4016),
    [sym_fsi_directive_decl] = STATE(4016),
    [sym_preproc_line] = STATE(4016),
    [ts_builtin_sym_end] = ACTIONS(3521),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_namespace] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3523),
    [anon_sym_open] = ACTIONS(3523),
    [anon_sym_LBRACK_LT] = ACTIONS(3521),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_type] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3521),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3521),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3521),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_DASH_GT] = ACTIONS(3521),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3521),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3521),
    [anon_sym_do_BANG] = ACTIONS(3521),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_STAR] = ACTIONS(3521),
    [anon_sym_LT2] = ACTIONS(3523),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3521),
    [anon_sym_exception] = ACTIONS(3523),
    [aux_sym_char_token1] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3521),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3521),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3521),
    [anon_sym_DASH_DOT] = ACTIONS(3521),
    [anon_sym_PERCENT] = ACTIONS(3521),
    [anon_sym_AMP_AMP] = ACTIONS(3521),
    [anon_sym_TILDE] = ACTIONS(3521),
    [aux_sym_prefix_op_token1] = ACTIONS(3521),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3521),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3521),
    [anon_sym_POUNDload] = ACTIONS(3521),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3521),
  },
  [4017] = {
    [sym_block_comment] = STATE(4017),
    [sym_compiler_directive_decl] = STATE(4017),
    [sym_fsi_directive_decl] = STATE(4017),
    [sym_preproc_line] = STATE(4017),
    [ts_builtin_sym_end] = ACTIONS(3533),
    [sym_identifier] = ACTIONS(3535),
    [anon_sym_namespace] = ACTIONS(3535),
    [anon_sym_module] = ACTIONS(3535),
    [anon_sym_open] = ACTIONS(3535),
    [anon_sym_LBRACK_LT] = ACTIONS(3533),
    [anon_sym_return] = ACTIONS(3535),
    [anon_sym_type] = ACTIONS(3535),
    [anon_sym_do] = ACTIONS(3535),
    [anon_sym_let] = ACTIONS(3535),
    [anon_sym_let_BANG] = ACTIONS(3533),
    [anon_sym_LPAREN] = ACTIONS(3535),
    [anon_sym_null] = ACTIONS(3535),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3533),
    [anon_sym_LBRACE] = ACTIONS(3535),
    [anon_sym_LT_AT] = ACTIONS(3535),
    [anon_sym_LT_AT_AT] = ACTIONS(3533),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3533),
    [anon_sym_new] = ACTIONS(3535),
    [anon_sym_return_BANG] = ACTIONS(3533),
    [anon_sym_yield] = ACTIONS(3535),
    [anon_sym_yield_BANG] = ACTIONS(3533),
    [anon_sym_lazy] = ACTIONS(3535),
    [anon_sym_assert] = ACTIONS(3535),
    [anon_sym_upcast] = ACTIONS(3535),
    [anon_sym_downcast] = ACTIONS(3535),
    [anon_sym_for] = ACTIONS(3535),
    [anon_sym_while] = ACTIONS(3535),
    [anon_sym_if] = ACTIONS(3535),
    [anon_sym_fun] = ACTIONS(3535),
    [anon_sym_DASH_GT] = ACTIONS(3533),
    [anon_sym_try] = ACTIONS(3535),
    [anon_sym_match] = ACTIONS(3535),
    [anon_sym_match_BANG] = ACTIONS(3533),
    [anon_sym_function] = ACTIONS(3535),
    [anon_sym_use] = ACTIONS(3535),
    [anon_sym_use_BANG] = ACTIONS(3533),
    [anon_sym_do_BANG] = ACTIONS(3533),
    [anon_sym_begin] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(3533),
    [anon_sym_LT2] = ACTIONS(3535),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3533),
    [anon_sym_exception] = ACTIONS(3535),
    [aux_sym_char_token1] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE] = ACTIONS(3535),
    [anon_sym_AT_DQUOTE] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [sym_bool] = ACTIONS(3535),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3535),
    [sym_op_identifier] = ACTIONS(3533),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS_DOT] = ACTIONS(3533),
    [anon_sym_DASH_DOT] = ACTIONS(3533),
    [anon_sym_PERCENT] = ACTIONS(3533),
    [anon_sym_AMP_AMP] = ACTIONS(3533),
    [anon_sym_TILDE] = ACTIONS(3533),
    [aux_sym_prefix_op_token1] = ACTIONS(3533),
    [sym_int] = ACTIONS(3535),
    [sym_xint] = ACTIONS(3533),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3533),
    [anon_sym_POUNDload] = ACTIONS(3533),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3533),
  },
  [4018] = {
    [sym_attributes] = STATE(11521),
    [sym__attribute_set] = STATE(9964),
    [sym_block_comment] = STATE(4018),
    [sym_compiler_directive_decl] = STATE(4018),
    [sym_fsi_directive_decl] = STATE(4018),
    [sym_preproc_line] = STATE(4018),
    [aux_sym_attributes_repeat1] = STATE(8813),
    [aux_sym_type_definition_repeat1] = STATE(4018),
    [ts_builtin_sym_end] = ACTIONS(6539),
    [sym_identifier] = ACTIONS(6541),
    [anon_sym_module] = ACTIONS(6541),
    [anon_sym_open] = ACTIONS(6541),
    [anon_sym_LBRACK_LT] = ACTIONS(6543),
    [anon_sym_return] = ACTIONS(6541),
    [anon_sym_type] = ACTIONS(6541),
    [anon_sym_do] = ACTIONS(6541),
    [anon_sym_and] = ACTIONS(6555),
    [anon_sym_let] = ACTIONS(6541),
    [anon_sym_let_BANG] = ACTIONS(6539),
    [anon_sym_LPAREN] = ACTIONS(6541),
    [anon_sym_null] = ACTIONS(6541),
    [anon_sym_AMP] = ACTIONS(6541),
    [anon_sym_LBRACK] = ACTIONS(6541),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6539),
    [anon_sym_LBRACE] = ACTIONS(6541),
    [anon_sym_LT_AT] = ACTIONS(6541),
    [anon_sym_LT_AT_AT] = ACTIONS(6539),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6539),
    [anon_sym_new] = ACTIONS(6541),
    [anon_sym_return_BANG] = ACTIONS(6539),
    [anon_sym_yield] = ACTIONS(6541),
    [anon_sym_yield_BANG] = ACTIONS(6539),
    [anon_sym_lazy] = ACTIONS(6541),
    [anon_sym_assert] = ACTIONS(6541),
    [anon_sym_upcast] = ACTIONS(6541),
    [anon_sym_downcast] = ACTIONS(6541),
    [anon_sym_for] = ACTIONS(6541),
    [anon_sym_while] = ACTIONS(6541),
    [anon_sym_if] = ACTIONS(6541),
    [anon_sym_fun] = ACTIONS(6541),
    [anon_sym_try] = ACTIONS(6541),
    [anon_sym_match] = ACTIONS(6541),
    [anon_sym_match_BANG] = ACTIONS(6539),
    [anon_sym_function] = ACTIONS(6541),
    [anon_sym_use] = ACTIONS(6541),
    [anon_sym_use_BANG] = ACTIONS(6539),
    [anon_sym_do_BANG] = ACTIONS(6539),
    [anon_sym_begin] = ACTIONS(6541),
    [anon_sym_exception] = ACTIONS(6541),
    [aux_sym_char_token1] = ACTIONS(6539),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6541),
    [anon_sym_DQUOTE] = ACTIONS(6541),
    [anon_sym_AT_DQUOTE] = ACTIONS(6539),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6539),
    [sym_bool] = ACTIONS(6541),
    [sym_unit] = ACTIONS(6539),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6541),
    [sym_op_identifier] = ACTIONS(6539),
    [anon_sym_PLUS] = ACTIONS(6541),
    [anon_sym_DASH] = ACTIONS(6541),
    [anon_sym_PLUS_DOT] = ACTIONS(6539),
    [anon_sym_DASH_DOT] = ACTIONS(6539),
    [anon_sym_PERCENT] = ACTIONS(6539),
    [anon_sym_AMP_AMP] = ACTIONS(6539),
    [anon_sym_TILDE] = ACTIONS(6539),
    [aux_sym_prefix_op_token1] = ACTIONS(6539),
    [sym_int] = ACTIONS(6541),
    [sym_xint] = ACTIONS(6539),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6539),
    [anon_sym_POUNDload] = ACTIONS(6539),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6539),
  },
  [4019] = {
    [sym_block_comment] = STATE(4019),
    [sym_compiler_directive_decl] = STATE(4019),
    [sym_fsi_directive_decl] = STATE(4019),
    [sym_preproc_line] = STATE(4019),
    [ts_builtin_sym_end] = ACTIONS(3537),
    [sym_identifier] = ACTIONS(3539),
    [anon_sym_namespace] = ACTIONS(3539),
    [anon_sym_module] = ACTIONS(3539),
    [anon_sym_open] = ACTIONS(3539),
    [anon_sym_LBRACK_LT] = ACTIONS(3537),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_type] = ACTIONS(3539),
    [anon_sym_do] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3539),
    [anon_sym_let_BANG] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_null] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3537),
    [anon_sym_LBRACE] = ACTIONS(3539),
    [anon_sym_LT_AT] = ACTIONS(3539),
    [anon_sym_LT_AT_AT] = ACTIONS(3537),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3537),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_return_BANG] = ACTIONS(3537),
    [anon_sym_yield] = ACTIONS(3539),
    [anon_sym_yield_BANG] = ACTIONS(3537),
    [anon_sym_lazy] = ACTIONS(3539),
    [anon_sym_assert] = ACTIONS(3539),
    [anon_sym_upcast] = ACTIONS(3539),
    [anon_sym_downcast] = ACTIONS(3539),
    [anon_sym_for] = ACTIONS(3539),
    [anon_sym_while] = ACTIONS(3539),
    [anon_sym_if] = ACTIONS(3539),
    [anon_sym_fun] = ACTIONS(3539),
    [anon_sym_DASH_GT] = ACTIONS(3537),
    [anon_sym_try] = ACTIONS(3539),
    [anon_sym_match] = ACTIONS(3539),
    [anon_sym_match_BANG] = ACTIONS(3537),
    [anon_sym_function] = ACTIONS(3539),
    [anon_sym_use] = ACTIONS(3539),
    [anon_sym_use_BANG] = ACTIONS(3537),
    [anon_sym_do_BANG] = ACTIONS(3537),
    [anon_sym_begin] = ACTIONS(3539),
    [anon_sym_STAR] = ACTIONS(3537),
    [anon_sym_LT2] = ACTIONS(3539),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_exception] = ACTIONS(3539),
    [aux_sym_char_token1] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3539),
    [anon_sym_DQUOTE] = ACTIONS(3539),
    [anon_sym_AT_DQUOTE] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [sym_bool] = ACTIONS(3539),
    [sym_unit] = ACTIONS(3537),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3539),
    [sym_op_identifier] = ACTIONS(3537),
    [anon_sym_PLUS] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(3539),
    [anon_sym_PLUS_DOT] = ACTIONS(3537),
    [anon_sym_DASH_DOT] = ACTIONS(3537),
    [anon_sym_PERCENT] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [aux_sym_prefix_op_token1] = ACTIONS(3537),
    [sym_int] = ACTIONS(3539),
    [sym_xint] = ACTIONS(3537),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3537),
    [anon_sym_POUNDload] = ACTIONS(3537),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3537),
  },
  [4020] = {
    [sym_block_comment] = STATE(4020),
    [sym_compiler_directive_decl] = STATE(4020),
    [sym_fsi_directive_decl] = STATE(4020),
    [sym_preproc_line] = STATE(4020),
    [ts_builtin_sym_end] = ACTIONS(3517),
    [sym_identifier] = ACTIONS(3519),
    [anon_sym_namespace] = ACTIONS(3519),
    [anon_sym_module] = ACTIONS(3519),
    [anon_sym_open] = ACTIONS(3519),
    [anon_sym_LBRACK_LT] = ACTIONS(3517),
    [anon_sym_return] = ACTIONS(3519),
    [anon_sym_type] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(3519),
    [anon_sym_let] = ACTIONS(3519),
    [anon_sym_let_BANG] = ACTIONS(3517),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [anon_sym_null] = ACTIONS(3519),
    [anon_sym_AMP] = ACTIONS(3519),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_LT_AT] = ACTIONS(3519),
    [anon_sym_LT_AT_AT] = ACTIONS(3517),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3519),
    [anon_sym_return_BANG] = ACTIONS(3517),
    [anon_sym_yield] = ACTIONS(3519),
    [anon_sym_yield_BANG] = ACTIONS(3517),
    [anon_sym_lazy] = ACTIONS(3519),
    [anon_sym_assert] = ACTIONS(3519),
    [anon_sym_upcast] = ACTIONS(3519),
    [anon_sym_downcast] = ACTIONS(3519),
    [anon_sym_for] = ACTIONS(3519),
    [anon_sym_while] = ACTIONS(3519),
    [anon_sym_if] = ACTIONS(3519),
    [anon_sym_fun] = ACTIONS(3519),
    [anon_sym_DASH_GT] = ACTIONS(3517),
    [anon_sym_try] = ACTIONS(3519),
    [anon_sym_match] = ACTIONS(3519),
    [anon_sym_match_BANG] = ACTIONS(3517),
    [anon_sym_function] = ACTIONS(3519),
    [anon_sym_use] = ACTIONS(3519),
    [anon_sym_use_BANG] = ACTIONS(3517),
    [anon_sym_do_BANG] = ACTIONS(3517),
    [anon_sym_begin] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3517),
    [anon_sym_LT2] = ACTIONS(3519),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3517),
    [anon_sym_exception] = ACTIONS(3519),
    [aux_sym_char_token1] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [anon_sym_AT_DQUOTE] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [sym_bool] = ACTIONS(3519),
    [sym_unit] = ACTIONS(3517),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3519),
    [sym_op_identifier] = ACTIONS(3517),
    [anon_sym_PLUS] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_DOT] = ACTIONS(3517),
    [anon_sym_DASH_DOT] = ACTIONS(3517),
    [anon_sym_PERCENT] = ACTIONS(3517),
    [anon_sym_AMP_AMP] = ACTIONS(3517),
    [anon_sym_TILDE] = ACTIONS(3517),
    [aux_sym_prefix_op_token1] = ACTIONS(3517),
    [sym_int] = ACTIONS(3519),
    [sym_xint] = ACTIONS(3517),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3517),
    [anon_sym_POUNDload] = ACTIONS(3517),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3517),
  },
  [4021] = {
    [sym_block_comment] = STATE(4021),
    [sym_compiler_directive_decl] = STATE(4021),
    [sym_fsi_directive_decl] = STATE(4021),
    [sym_preproc_line] = STATE(4021),
    [ts_builtin_sym_end] = ACTIONS(3513),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_namespace] = ACTIONS(3515),
    [anon_sym_module] = ACTIONS(3515),
    [anon_sym_open] = ACTIONS(3515),
    [anon_sym_LBRACK_LT] = ACTIONS(3513),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_type] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3513),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3513),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [anon_sym_exception] = ACTIONS(3515),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3513),
    [anon_sym_DASH_DOT] = ACTIONS(3513),
    [anon_sym_PERCENT] = ACTIONS(3513),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3513),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3513),
    [anon_sym_POUNDload] = ACTIONS(3513),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
  },
  [4022] = {
    [sym_block_comment] = STATE(4022),
    [sym_compiler_directive_decl] = STATE(4022),
    [sym_fsi_directive_decl] = STATE(4022),
    [sym_preproc_line] = STATE(4022),
    [ts_builtin_sym_end] = ACTIONS(3541),
    [sym_identifier] = ACTIONS(3543),
    [anon_sym_namespace] = ACTIONS(3543),
    [anon_sym_module] = ACTIONS(3543),
    [anon_sym_open] = ACTIONS(3543),
    [anon_sym_LBRACK_LT] = ACTIONS(3541),
    [anon_sym_return] = ACTIONS(3543),
    [anon_sym_type] = ACTIONS(3543),
    [anon_sym_do] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3543),
    [anon_sym_let_BANG] = ACTIONS(3541),
    [anon_sym_LPAREN] = ACTIONS(3543),
    [anon_sym_null] = ACTIONS(3543),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3543),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3541),
    [anon_sym_LBRACE] = ACTIONS(3543),
    [anon_sym_LT_AT] = ACTIONS(3543),
    [anon_sym_LT_AT_AT] = ACTIONS(3541),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3541),
    [anon_sym_new] = ACTIONS(3543),
    [anon_sym_return_BANG] = ACTIONS(3541),
    [anon_sym_yield] = ACTIONS(3543),
    [anon_sym_yield_BANG] = ACTIONS(3541),
    [anon_sym_lazy] = ACTIONS(3543),
    [anon_sym_assert] = ACTIONS(3543),
    [anon_sym_upcast] = ACTIONS(3543),
    [anon_sym_downcast] = ACTIONS(3543),
    [anon_sym_for] = ACTIONS(3543),
    [anon_sym_while] = ACTIONS(3543),
    [anon_sym_if] = ACTIONS(3543),
    [anon_sym_fun] = ACTIONS(3543),
    [anon_sym_DASH_GT] = ACTIONS(3541),
    [anon_sym_try] = ACTIONS(3543),
    [anon_sym_match] = ACTIONS(3543),
    [anon_sym_match_BANG] = ACTIONS(3541),
    [anon_sym_function] = ACTIONS(3543),
    [anon_sym_use] = ACTIONS(3543),
    [anon_sym_use_BANG] = ACTIONS(3541),
    [anon_sym_do_BANG] = ACTIONS(3541),
    [anon_sym_begin] = ACTIONS(3543),
    [anon_sym_STAR] = ACTIONS(3541),
    [anon_sym_LT2] = ACTIONS(3543),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_exception] = ACTIONS(3543),
    [aux_sym_char_token1] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3543),
    [anon_sym_DQUOTE] = ACTIONS(3543),
    [anon_sym_AT_DQUOTE] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [sym_bool] = ACTIONS(3543),
    [sym_unit] = ACTIONS(3541),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3543),
    [sym_op_identifier] = ACTIONS(3541),
    [anon_sym_PLUS] = ACTIONS(3543),
    [anon_sym_DASH] = ACTIONS(3543),
    [anon_sym_PLUS_DOT] = ACTIONS(3541),
    [anon_sym_DASH_DOT] = ACTIONS(3541),
    [anon_sym_PERCENT] = ACTIONS(3541),
    [anon_sym_AMP_AMP] = ACTIONS(3541),
    [anon_sym_TILDE] = ACTIONS(3541),
    [aux_sym_prefix_op_token1] = ACTIONS(3541),
    [sym_int] = ACTIONS(3543),
    [sym_xint] = ACTIONS(3541),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3541),
    [anon_sym_POUNDload] = ACTIONS(3541),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3541),
  },
  [4023] = {
    [sym_block_comment] = STATE(4023),
    [sym_compiler_directive_decl] = STATE(4023),
    [sym_fsi_directive_decl] = STATE(4023),
    [sym_preproc_line] = STATE(4023),
    [ts_builtin_sym_end] = ACTIONS(3529),
    [sym_identifier] = ACTIONS(3531),
    [anon_sym_namespace] = ACTIONS(3531),
    [anon_sym_module] = ACTIONS(3531),
    [anon_sym_open] = ACTIONS(3531),
    [anon_sym_LBRACK_LT] = ACTIONS(3529),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_type] = ACTIONS(3531),
    [anon_sym_do] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_null] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3531),
    [anon_sym_LT_AT] = ACTIONS(3531),
    [anon_sym_LT_AT_AT] = ACTIONS(3529),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3531),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3531),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3531),
    [anon_sym_assert] = ACTIONS(3531),
    [anon_sym_upcast] = ACTIONS(3531),
    [anon_sym_downcast] = ACTIONS(3531),
    [anon_sym_for] = ACTIONS(3531),
    [anon_sym_while] = ACTIONS(3531),
    [anon_sym_if] = ACTIONS(3531),
    [anon_sym_fun] = ACTIONS(3531),
    [anon_sym_DASH_GT] = ACTIONS(3529),
    [anon_sym_try] = ACTIONS(3531),
    [anon_sym_match] = ACTIONS(3531),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3531),
    [anon_sym_use] = ACTIONS(3531),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3531),
    [anon_sym_STAR] = ACTIONS(3529),
    [anon_sym_LT2] = ACTIONS(3531),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_exception] = ACTIONS(3531),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3531),
    [anon_sym_DQUOTE] = ACTIONS(3531),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3531),
    [sym_unit] = ACTIONS(3529),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3531),
    [sym_op_identifier] = ACTIONS(3529),
    [anon_sym_PLUS] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(3531),
    [anon_sym_PLUS_DOT] = ACTIONS(3529),
    [anon_sym_DASH_DOT] = ACTIONS(3529),
    [anon_sym_PERCENT] = ACTIONS(3529),
    [anon_sym_AMP_AMP] = ACTIONS(3529),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3529),
    [sym_int] = ACTIONS(3531),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3529),
    [anon_sym_POUNDload] = ACTIONS(3529),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3529),
  },
  [4024] = {
    [sym_attributes] = STATE(11521),
    [sym__attribute_set] = STATE(9964),
    [sym_block_comment] = STATE(4024),
    [sym_compiler_directive_decl] = STATE(4024),
    [sym_fsi_directive_decl] = STATE(4024),
    [sym_preproc_line] = STATE(4024),
    [aux_sym_attributes_repeat1] = STATE(8813),
    [aux_sym_type_definition_repeat1] = STATE(4018),
    [ts_builtin_sym_end] = ACTIONS(6549),
    [sym_identifier] = ACTIONS(6551),
    [anon_sym_module] = ACTIONS(6551),
    [anon_sym_open] = ACTIONS(6551),
    [anon_sym_LBRACK_LT] = ACTIONS(6549),
    [anon_sym_return] = ACTIONS(6551),
    [anon_sym_type] = ACTIONS(6551),
    [anon_sym_do] = ACTIONS(6551),
    [anon_sym_and] = ACTIONS(6558),
    [anon_sym_let] = ACTIONS(6551),
    [anon_sym_let_BANG] = ACTIONS(6549),
    [anon_sym_LPAREN] = ACTIONS(6551),
    [anon_sym_null] = ACTIONS(6551),
    [anon_sym_AMP] = ACTIONS(6551),
    [anon_sym_LBRACK] = ACTIONS(6551),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6549),
    [anon_sym_LBRACE] = ACTIONS(6551),
    [anon_sym_LT_AT] = ACTIONS(6551),
    [anon_sym_LT_AT_AT] = ACTIONS(6549),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6549),
    [anon_sym_new] = ACTIONS(6551),
    [anon_sym_return_BANG] = ACTIONS(6549),
    [anon_sym_yield] = ACTIONS(6551),
    [anon_sym_yield_BANG] = ACTIONS(6549),
    [anon_sym_lazy] = ACTIONS(6551),
    [anon_sym_assert] = ACTIONS(6551),
    [anon_sym_upcast] = ACTIONS(6551),
    [anon_sym_downcast] = ACTIONS(6551),
    [anon_sym_for] = ACTIONS(6551),
    [anon_sym_while] = ACTIONS(6551),
    [anon_sym_if] = ACTIONS(6551),
    [anon_sym_fun] = ACTIONS(6551),
    [anon_sym_try] = ACTIONS(6551),
    [anon_sym_match] = ACTIONS(6551),
    [anon_sym_match_BANG] = ACTIONS(6549),
    [anon_sym_function] = ACTIONS(6551),
    [anon_sym_use] = ACTIONS(6551),
    [anon_sym_use_BANG] = ACTIONS(6549),
    [anon_sym_do_BANG] = ACTIONS(6549),
    [anon_sym_begin] = ACTIONS(6551),
    [anon_sym_exception] = ACTIONS(6551),
    [aux_sym_char_token1] = ACTIONS(6549),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6551),
    [anon_sym_DQUOTE] = ACTIONS(6551),
    [anon_sym_AT_DQUOTE] = ACTIONS(6549),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6549),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6549),
    [sym_bool] = ACTIONS(6551),
    [sym_unit] = ACTIONS(6549),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6551),
    [sym_op_identifier] = ACTIONS(6549),
    [anon_sym_PLUS] = ACTIONS(6551),
    [anon_sym_DASH] = ACTIONS(6551),
    [anon_sym_PLUS_DOT] = ACTIONS(6549),
    [anon_sym_DASH_DOT] = ACTIONS(6549),
    [anon_sym_PERCENT] = ACTIONS(6549),
    [anon_sym_AMP_AMP] = ACTIONS(6549),
    [anon_sym_TILDE] = ACTIONS(6549),
    [aux_sym_prefix_op_token1] = ACTIONS(6549),
    [sym_int] = ACTIONS(6551),
    [sym_xint] = ACTIONS(6549),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6549),
    [anon_sym_POUNDload] = ACTIONS(6549),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6549),
  },
  [4025] = {
    [sym_block_comment] = STATE(4025),
    [sym_compiler_directive_decl] = STATE(4025),
    [sym_fsi_directive_decl] = STATE(4025),
    [sym_preproc_line] = STATE(4025),
    [ts_builtin_sym_end] = ACTIONS(3545),
    [sym_identifier] = ACTIONS(3547),
    [anon_sym_namespace] = ACTIONS(3547),
    [anon_sym_module] = ACTIONS(3547),
    [anon_sym_open] = ACTIONS(3547),
    [anon_sym_LBRACK_LT] = ACTIONS(3545),
    [anon_sym_return] = ACTIONS(3547),
    [anon_sym_type] = ACTIONS(3547),
    [anon_sym_do] = ACTIONS(3547),
    [anon_sym_let] = ACTIONS(3547),
    [anon_sym_let_BANG] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(3547),
    [anon_sym_null] = ACTIONS(3547),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3545),
    [anon_sym_LBRACE] = ACTIONS(3547),
    [anon_sym_LT_AT] = ACTIONS(3547),
    [anon_sym_LT_AT_AT] = ACTIONS(3545),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3545),
    [anon_sym_new] = ACTIONS(3547),
    [anon_sym_return_BANG] = ACTIONS(3545),
    [anon_sym_yield] = ACTIONS(3547),
    [anon_sym_yield_BANG] = ACTIONS(3545),
    [anon_sym_lazy] = ACTIONS(3547),
    [anon_sym_assert] = ACTIONS(3547),
    [anon_sym_upcast] = ACTIONS(3547),
    [anon_sym_downcast] = ACTIONS(3547),
    [anon_sym_for] = ACTIONS(3547),
    [anon_sym_while] = ACTIONS(3547),
    [anon_sym_if] = ACTIONS(3547),
    [anon_sym_fun] = ACTIONS(3547),
    [anon_sym_DASH_GT] = ACTIONS(3545),
    [anon_sym_try] = ACTIONS(3547),
    [anon_sym_match] = ACTIONS(3547),
    [anon_sym_match_BANG] = ACTIONS(3545),
    [anon_sym_function] = ACTIONS(3547),
    [anon_sym_use] = ACTIONS(3547),
    [anon_sym_use_BANG] = ACTIONS(3545),
    [anon_sym_do_BANG] = ACTIONS(3545),
    [anon_sym_begin] = ACTIONS(3547),
    [anon_sym_STAR] = ACTIONS(3545),
    [anon_sym_LT2] = ACTIONS(3547),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_exception] = ACTIONS(3547),
    [aux_sym_char_token1] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3547),
    [anon_sym_DQUOTE] = ACTIONS(3547),
    [anon_sym_AT_DQUOTE] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [sym_bool] = ACTIONS(3547),
    [sym_unit] = ACTIONS(3545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3547),
    [sym_op_identifier] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PLUS_DOT] = ACTIONS(3545),
    [anon_sym_DASH_DOT] = ACTIONS(3545),
    [anon_sym_PERCENT] = ACTIONS(3545),
    [anon_sym_AMP_AMP] = ACTIONS(3545),
    [anon_sym_TILDE] = ACTIONS(3545),
    [aux_sym_prefix_op_token1] = ACTIONS(3545),
    [sym_int] = ACTIONS(3547),
    [sym_xint] = ACTIONS(3545),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3545),
    [anon_sym_POUNDload] = ACTIONS(3545),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3545),
  },
  [4026] = {
    [sym_block_comment] = STATE(4026),
    [sym_compiler_directive_decl] = STATE(4026),
    [sym_fsi_directive_decl] = STATE(4026),
    [sym_preproc_line] = STATE(4026),
    [ts_builtin_sym_end] = ACTIONS(3525),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_namespace] = ACTIONS(3527),
    [anon_sym_module] = ACTIONS(3527),
    [anon_sym_open] = ACTIONS(3527),
    [anon_sym_LBRACK_LT] = ACTIONS(3525),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_type] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3525),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_DASH_GT] = ACTIONS(3525),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_STAR] = ACTIONS(3525),
    [anon_sym_LT2] = ACTIONS(3527),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_exception] = ACTIONS(3527),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3525),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3525),
    [anon_sym_DASH_DOT] = ACTIONS(3525),
    [anon_sym_PERCENT] = ACTIONS(3525),
    [anon_sym_AMP_AMP] = ACTIONS(3525),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3525),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3525),
    [anon_sym_POUNDload] = ACTIONS(3525),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3525),
  },
  [4027] = {
    [sym_block_comment] = STATE(4027),
    [sym_compiler_directive_decl] = STATE(4027),
    [sym_fsi_directive_decl] = STATE(4027),
    [sym_preproc_line] = STATE(4027),
    [ts_builtin_sym_end] = ACTIONS(3560),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_namespace] = ACTIONS(3562),
    [anon_sym_module] = ACTIONS(3562),
    [anon_sym_open] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3560),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_type] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_let_BANG] = ACTIONS(3560),
    [anon_sym_LPAREN] = ACTIONS(3562),
    [anon_sym_null] = ACTIONS(3562),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3560),
    [anon_sym_LBRACE] = ACTIONS(3562),
    [anon_sym_LT_AT] = ACTIONS(3562),
    [anon_sym_LT_AT_AT] = ACTIONS(3560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3560),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_return_BANG] = ACTIONS(3560),
    [anon_sym_yield] = ACTIONS(3562),
    [anon_sym_yield_BANG] = ACTIONS(3560),
    [anon_sym_lazy] = ACTIONS(3562),
    [anon_sym_assert] = ACTIONS(3562),
    [anon_sym_upcast] = ACTIONS(3562),
    [anon_sym_downcast] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_fun] = ACTIONS(3562),
    [anon_sym_DASH_GT] = ACTIONS(3560),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_match] = ACTIONS(3562),
    [anon_sym_match_BANG] = ACTIONS(3560),
    [anon_sym_function] = ACTIONS(3562),
    [anon_sym_use] = ACTIONS(3562),
    [anon_sym_use_BANG] = ACTIONS(3560),
    [anon_sym_do_BANG] = ACTIONS(3560),
    [anon_sym_begin] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_LT2] = ACTIONS(3562),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3560),
    [anon_sym_exception] = ACTIONS(3562),
    [aux_sym_char_token1] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(3562),
    [anon_sym_AT_DQUOTE] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [sym_bool] = ACTIONS(3562),
    [sym_unit] = ACTIONS(3560),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3562),
    [sym_op_identifier] = ACTIONS(3560),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS_DOT] = ACTIONS(3560),
    [anon_sym_DASH_DOT] = ACTIONS(3560),
    [anon_sym_PERCENT] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [aux_sym_prefix_op_token1] = ACTIONS(3560),
    [sym_int] = ACTIONS(3562),
    [sym_xint] = ACTIONS(3560),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3560),
    [anon_sym_POUNDload] = ACTIONS(3560),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3560),
  },
  [4028] = {
    [sym_block_comment] = STATE(4028),
    [sym_compiler_directive_decl] = STATE(4028),
    [sym_fsi_directive_decl] = STATE(4028),
    [sym_preproc_line] = STATE(4028),
    [ts_builtin_sym_end] = ACTIONS(3549),
    [sym_identifier] = ACTIONS(3551),
    [anon_sym_namespace] = ACTIONS(3551),
    [anon_sym_module] = ACTIONS(3551),
    [anon_sym_open] = ACTIONS(3551),
    [anon_sym_LBRACK_LT] = ACTIONS(3549),
    [anon_sym_return] = ACTIONS(3551),
    [anon_sym_type] = ACTIONS(3551),
    [anon_sym_do] = ACTIONS(3551),
    [anon_sym_let] = ACTIONS(3551),
    [anon_sym_let_BANG] = ACTIONS(3549),
    [anon_sym_LPAREN] = ACTIONS(3551),
    [anon_sym_null] = ACTIONS(3551),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(3551),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3549),
    [anon_sym_LBRACE] = ACTIONS(3551),
    [anon_sym_LT_AT] = ACTIONS(3551),
    [anon_sym_LT_AT_AT] = ACTIONS(3549),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3549),
    [anon_sym_new] = ACTIONS(3551),
    [anon_sym_return_BANG] = ACTIONS(3549),
    [anon_sym_yield] = ACTIONS(3551),
    [anon_sym_yield_BANG] = ACTIONS(3549),
    [anon_sym_lazy] = ACTIONS(3551),
    [anon_sym_assert] = ACTIONS(3551),
    [anon_sym_upcast] = ACTIONS(3551),
    [anon_sym_downcast] = ACTIONS(3551),
    [anon_sym_for] = ACTIONS(3551),
    [anon_sym_while] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(3551),
    [anon_sym_fun] = ACTIONS(3551),
    [anon_sym_DASH_GT] = ACTIONS(3549),
    [anon_sym_try] = ACTIONS(3551),
    [anon_sym_match] = ACTIONS(3551),
    [anon_sym_match_BANG] = ACTIONS(3549),
    [anon_sym_function] = ACTIONS(3551),
    [anon_sym_use] = ACTIONS(3551),
    [anon_sym_use_BANG] = ACTIONS(3549),
    [anon_sym_do_BANG] = ACTIONS(3549),
    [anon_sym_begin] = ACTIONS(3551),
    [anon_sym_STAR] = ACTIONS(3549),
    [anon_sym_LT2] = ACTIONS(3551),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3549),
    [anon_sym_exception] = ACTIONS(3551),
    [aux_sym_char_token1] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [anon_sym_AT_DQUOTE] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [sym_bool] = ACTIONS(3551),
    [sym_unit] = ACTIONS(3549),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3551),
    [sym_op_identifier] = ACTIONS(3549),
    [anon_sym_PLUS] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(3551),
    [anon_sym_PLUS_DOT] = ACTIONS(3549),
    [anon_sym_DASH_DOT] = ACTIONS(3549),
    [anon_sym_PERCENT] = ACTIONS(3549),
    [anon_sym_AMP_AMP] = ACTIONS(3549),
    [anon_sym_TILDE] = ACTIONS(3549),
    [aux_sym_prefix_op_token1] = ACTIONS(3549),
    [sym_int] = ACTIONS(3551),
    [sym_xint] = ACTIONS(3549),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3549),
    [anon_sym_POUNDload] = ACTIONS(3549),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3549),
  },
  [4029] = {
    [sym_attributes] = STATE(11521),
    [sym__attribute_set] = STATE(9964),
    [sym_block_comment] = STATE(4029),
    [sym_compiler_directive_decl] = STATE(4029),
    [sym_fsi_directive_decl] = STATE(4029),
    [sym_preproc_line] = STATE(4029),
    [aux_sym_attributes_repeat1] = STATE(8813),
    [aux_sym_type_definition_repeat1] = STATE(4024),
    [ts_builtin_sym_end] = ACTIONS(6532),
    [sym_identifier] = ACTIONS(6534),
    [anon_sym_module] = ACTIONS(6534),
    [anon_sym_open] = ACTIONS(6534),
    [anon_sym_LBRACK_LT] = ACTIONS(6532),
    [anon_sym_return] = ACTIONS(6534),
    [anon_sym_type] = ACTIONS(6534),
    [anon_sym_do] = ACTIONS(6534),
    [anon_sym_and] = ACTIONS(6558),
    [anon_sym_let] = ACTIONS(6534),
    [anon_sym_let_BANG] = ACTIONS(6532),
    [anon_sym_LPAREN] = ACTIONS(6534),
    [anon_sym_null] = ACTIONS(6534),
    [anon_sym_AMP] = ACTIONS(6534),
    [anon_sym_LBRACK] = ACTIONS(6534),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6532),
    [anon_sym_LBRACE] = ACTIONS(6534),
    [anon_sym_LT_AT] = ACTIONS(6534),
    [anon_sym_LT_AT_AT] = ACTIONS(6532),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6532),
    [anon_sym_new] = ACTIONS(6534),
    [anon_sym_return_BANG] = ACTIONS(6532),
    [anon_sym_yield] = ACTIONS(6534),
    [anon_sym_yield_BANG] = ACTIONS(6532),
    [anon_sym_lazy] = ACTIONS(6534),
    [anon_sym_assert] = ACTIONS(6534),
    [anon_sym_upcast] = ACTIONS(6534),
    [anon_sym_downcast] = ACTIONS(6534),
    [anon_sym_for] = ACTIONS(6534),
    [anon_sym_while] = ACTIONS(6534),
    [anon_sym_if] = ACTIONS(6534),
    [anon_sym_fun] = ACTIONS(6534),
    [anon_sym_try] = ACTIONS(6534),
    [anon_sym_match] = ACTIONS(6534),
    [anon_sym_match_BANG] = ACTIONS(6532),
    [anon_sym_function] = ACTIONS(6534),
    [anon_sym_use] = ACTIONS(6534),
    [anon_sym_use_BANG] = ACTIONS(6532),
    [anon_sym_do_BANG] = ACTIONS(6532),
    [anon_sym_begin] = ACTIONS(6534),
    [anon_sym_exception] = ACTIONS(6534),
    [aux_sym_char_token1] = ACTIONS(6532),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6534),
    [anon_sym_DQUOTE] = ACTIONS(6534),
    [anon_sym_AT_DQUOTE] = ACTIONS(6532),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6532),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6532),
    [sym_bool] = ACTIONS(6534),
    [sym_unit] = ACTIONS(6532),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6534),
    [sym_op_identifier] = ACTIONS(6532),
    [anon_sym_PLUS] = ACTIONS(6534),
    [anon_sym_DASH] = ACTIONS(6534),
    [anon_sym_PLUS_DOT] = ACTIONS(6532),
    [anon_sym_DASH_DOT] = ACTIONS(6532),
    [anon_sym_PERCENT] = ACTIONS(6532),
    [anon_sym_AMP_AMP] = ACTIONS(6532),
    [anon_sym_TILDE] = ACTIONS(6532),
    [aux_sym_prefix_op_token1] = ACTIONS(6532),
    [sym_int] = ACTIONS(6534),
    [sym_xint] = ACTIONS(6532),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6532),
    [anon_sym_POUNDload] = ACTIONS(6532),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6532),
  },
  [4030] = {
    [sym_attributes] = STATE(11521),
    [sym__attribute_set] = STATE(9964),
    [sym_block_comment] = STATE(4030),
    [sym_compiler_directive_decl] = STATE(4030),
    [sym_fsi_directive_decl] = STATE(4030),
    [sym_preproc_line] = STATE(4030),
    [aux_sym_attributes_repeat1] = STATE(8813),
    [aux_sym_type_definition_repeat1] = STATE(4031),
    [ts_builtin_sym_end] = ACTIONS(6524),
    [sym_identifier] = ACTIONS(6526),
    [anon_sym_module] = ACTIONS(6526),
    [anon_sym_open] = ACTIONS(6526),
    [anon_sym_LBRACK_LT] = ACTIONS(6524),
    [anon_sym_return] = ACTIONS(6526),
    [anon_sym_type] = ACTIONS(6526),
    [anon_sym_do] = ACTIONS(6526),
    [anon_sym_and] = ACTIONS(6558),
    [anon_sym_let] = ACTIONS(6526),
    [anon_sym_let_BANG] = ACTIONS(6524),
    [anon_sym_LPAREN] = ACTIONS(6526),
    [anon_sym_null] = ACTIONS(6526),
    [anon_sym_AMP] = ACTIONS(6526),
    [anon_sym_LBRACK] = ACTIONS(6526),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6524),
    [anon_sym_LBRACE] = ACTIONS(6526),
    [anon_sym_LT_AT] = ACTIONS(6526),
    [anon_sym_LT_AT_AT] = ACTIONS(6524),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6524),
    [anon_sym_new] = ACTIONS(6526),
    [anon_sym_return_BANG] = ACTIONS(6524),
    [anon_sym_yield] = ACTIONS(6526),
    [anon_sym_yield_BANG] = ACTIONS(6524),
    [anon_sym_lazy] = ACTIONS(6526),
    [anon_sym_assert] = ACTIONS(6526),
    [anon_sym_upcast] = ACTIONS(6526),
    [anon_sym_downcast] = ACTIONS(6526),
    [anon_sym_for] = ACTIONS(6526),
    [anon_sym_while] = ACTIONS(6526),
    [anon_sym_if] = ACTIONS(6526),
    [anon_sym_fun] = ACTIONS(6526),
    [anon_sym_try] = ACTIONS(6526),
    [anon_sym_match] = ACTIONS(6526),
    [anon_sym_match_BANG] = ACTIONS(6524),
    [anon_sym_function] = ACTIONS(6526),
    [anon_sym_use] = ACTIONS(6526),
    [anon_sym_use_BANG] = ACTIONS(6524),
    [anon_sym_do_BANG] = ACTIONS(6524),
    [anon_sym_begin] = ACTIONS(6526),
    [anon_sym_exception] = ACTIONS(6526),
    [aux_sym_char_token1] = ACTIONS(6524),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6526),
    [anon_sym_DQUOTE] = ACTIONS(6526),
    [anon_sym_AT_DQUOTE] = ACTIONS(6524),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6524),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6524),
    [sym_bool] = ACTIONS(6526),
    [sym_unit] = ACTIONS(6524),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6526),
    [sym_op_identifier] = ACTIONS(6524),
    [anon_sym_PLUS] = ACTIONS(6526),
    [anon_sym_DASH] = ACTIONS(6526),
    [anon_sym_PLUS_DOT] = ACTIONS(6524),
    [anon_sym_DASH_DOT] = ACTIONS(6524),
    [anon_sym_PERCENT] = ACTIONS(6524),
    [anon_sym_AMP_AMP] = ACTIONS(6524),
    [anon_sym_TILDE] = ACTIONS(6524),
    [aux_sym_prefix_op_token1] = ACTIONS(6524),
    [sym_int] = ACTIONS(6526),
    [sym_xint] = ACTIONS(6524),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6524),
    [anon_sym_POUNDload] = ACTIONS(6524),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6524),
  },
  [4031] = {
    [sym_attributes] = STATE(11521),
    [sym__attribute_set] = STATE(9964),
    [sym_block_comment] = STATE(4031),
    [sym_compiler_directive_decl] = STATE(4031),
    [sym_fsi_directive_decl] = STATE(4031),
    [sym_preproc_line] = STATE(4031),
    [aux_sym_attributes_repeat1] = STATE(8813),
    [aux_sym_type_definition_repeat1] = STATE(4018),
    [ts_builtin_sym_end] = ACTIONS(6532),
    [sym_identifier] = ACTIONS(6534),
    [anon_sym_module] = ACTIONS(6534),
    [anon_sym_open] = ACTIONS(6534),
    [anon_sym_LBRACK_LT] = ACTIONS(6532),
    [anon_sym_return] = ACTIONS(6534),
    [anon_sym_type] = ACTIONS(6534),
    [anon_sym_do] = ACTIONS(6534),
    [anon_sym_and] = ACTIONS(6558),
    [anon_sym_let] = ACTIONS(6534),
    [anon_sym_let_BANG] = ACTIONS(6532),
    [anon_sym_LPAREN] = ACTIONS(6534),
    [anon_sym_null] = ACTIONS(6534),
    [anon_sym_AMP] = ACTIONS(6534),
    [anon_sym_LBRACK] = ACTIONS(6534),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6532),
    [anon_sym_LBRACE] = ACTIONS(6534),
    [anon_sym_LT_AT] = ACTIONS(6534),
    [anon_sym_LT_AT_AT] = ACTIONS(6532),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6532),
    [anon_sym_new] = ACTIONS(6534),
    [anon_sym_return_BANG] = ACTIONS(6532),
    [anon_sym_yield] = ACTIONS(6534),
    [anon_sym_yield_BANG] = ACTIONS(6532),
    [anon_sym_lazy] = ACTIONS(6534),
    [anon_sym_assert] = ACTIONS(6534),
    [anon_sym_upcast] = ACTIONS(6534),
    [anon_sym_downcast] = ACTIONS(6534),
    [anon_sym_for] = ACTIONS(6534),
    [anon_sym_while] = ACTIONS(6534),
    [anon_sym_if] = ACTIONS(6534),
    [anon_sym_fun] = ACTIONS(6534),
    [anon_sym_try] = ACTIONS(6534),
    [anon_sym_match] = ACTIONS(6534),
    [anon_sym_match_BANG] = ACTIONS(6532),
    [anon_sym_function] = ACTIONS(6534),
    [anon_sym_use] = ACTIONS(6534),
    [anon_sym_use_BANG] = ACTIONS(6532),
    [anon_sym_do_BANG] = ACTIONS(6532),
    [anon_sym_begin] = ACTIONS(6534),
    [anon_sym_exception] = ACTIONS(6534),
    [aux_sym_char_token1] = ACTIONS(6532),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6534),
    [anon_sym_DQUOTE] = ACTIONS(6534),
    [anon_sym_AT_DQUOTE] = ACTIONS(6532),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6532),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6532),
    [sym_bool] = ACTIONS(6534),
    [sym_unit] = ACTIONS(6532),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6534),
    [sym_op_identifier] = ACTIONS(6532),
    [anon_sym_PLUS] = ACTIONS(6534),
    [anon_sym_DASH] = ACTIONS(6534),
    [anon_sym_PLUS_DOT] = ACTIONS(6532),
    [anon_sym_DASH_DOT] = ACTIONS(6532),
    [anon_sym_PERCENT] = ACTIONS(6532),
    [anon_sym_AMP_AMP] = ACTIONS(6532),
    [anon_sym_TILDE] = ACTIONS(6532),
    [aux_sym_prefix_op_token1] = ACTIONS(6532),
    [sym_int] = ACTIONS(6534),
    [sym_xint] = ACTIONS(6532),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6532),
    [anon_sym_POUNDload] = ACTIONS(6532),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6532),
  },
  [4032] = {
    [sym_type_arguments] = STATE(4193),
    [sym_long_identifier] = STATE(4189),
    [sym_block_comment] = STATE(4032),
    [sym_compiler_directive_decl] = STATE(4032),
    [sym_fsi_directive_decl] = STATE(4032),
    [sym_preproc_line] = STATE(4032),
    [aux_sym_compound_type_repeat1] = STATE(4157),
    [sym_identifier] = ACTIONS(6560),
    [anon_sym_GT_RBRACK] = ACTIONS(3425),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3425),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(2666),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(2668),
    [anon_sym_LT2] = ACTIONS(2670),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2672),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3425),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3425),
    [anon_sym_DASH_DOT] = ACTIONS(3425),
    [anon_sym_PERCENT] = ACTIONS(3425),
    [anon_sym_AMP_AMP] = ACTIONS(3425),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3425),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
  },
  [4033] = {
    [sym_block_comment] = STATE(4033),
    [sym_compiler_directive_decl] = STATE(4033),
    [sym_fsi_directive_decl] = STATE(4033),
    [sym_preproc_line] = STATE(4033),
    [aux_sym_long_identifier_repeat1] = STATE(4037),
    [ts_builtin_sym_end] = ACTIONS(3492),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_module] = ACTIONS(3494),
    [anon_sym_EQ] = ACTIONS(6562),
    [anon_sym_open] = ACTIONS(3494),
    [anon_sym_LBRACK_LT] = ACTIONS(3492),
    [anon_sym_return] = ACTIONS(3494),
    [anon_sym_type] = ACTIONS(3494),
    [anon_sym_do] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_let_BANG] = ACTIONS(3492),
    [anon_sym_LPAREN] = ACTIONS(3494),
    [anon_sym_null] = ACTIONS(3494),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3492),
    [anon_sym_LBRACE] = ACTIONS(3494),
    [anon_sym_LT_AT] = ACTIONS(3494),
    [anon_sym_LT_AT_AT] = ACTIONS(3492),
    [anon_sym_DOT] = ACTIONS(6564),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3492),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_return_BANG] = ACTIONS(3492),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_yield_BANG] = ACTIONS(3492),
    [anon_sym_lazy] = ACTIONS(3494),
    [anon_sym_assert] = ACTIONS(3494),
    [anon_sym_upcast] = ACTIONS(3494),
    [anon_sym_downcast] = ACTIONS(3494),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_while] = ACTIONS(3494),
    [anon_sym_if] = ACTIONS(3494),
    [anon_sym_fun] = ACTIONS(3494),
    [anon_sym_try] = ACTIONS(3494),
    [anon_sym_match] = ACTIONS(3494),
    [anon_sym_match_BANG] = ACTIONS(3492),
    [anon_sym_function] = ACTIONS(3494),
    [anon_sym_use] = ACTIONS(3494),
    [anon_sym_use_BANG] = ACTIONS(3492),
    [anon_sym_do_BANG] = ACTIONS(3492),
    [anon_sym_begin] = ACTIONS(3494),
    [anon_sym_exception] = ACTIONS(3494),
    [aux_sym_char_token1] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3494),
    [anon_sym_DQUOTE] = ACTIONS(3494),
    [anon_sym_AT_DQUOTE] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [sym_bool] = ACTIONS(3494),
    [sym_unit] = ACTIONS(3492),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3494),
    [sym_op_identifier] = ACTIONS(3492),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_PLUS_DOT] = ACTIONS(3492),
    [anon_sym_DASH_DOT] = ACTIONS(3492),
    [anon_sym_PERCENT] = ACTIONS(3492),
    [anon_sym_AMP_AMP] = ACTIONS(3492),
    [anon_sym_TILDE] = ACTIONS(3492),
    [aux_sym_prefix_op_token1] = ACTIONS(3492),
    [sym_int] = ACTIONS(3494),
    [sym_xint] = ACTIONS(3492),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3492),
    [anon_sym_POUNDload] = ACTIONS(3492),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3492),
  },
  [4034] = {
    [sym_block_comment] = STATE(4034),
    [sym_compiler_directive_decl] = STATE(4034),
    [sym_fsi_directive_decl] = STATE(4034),
    [sym_preproc_line] = STATE(4034),
    [aux_sym_type_argument_repeat1] = STATE(4040),
    [sym_identifier] = ACTIONS(3476),
    [anon_sym_GT_RBRACK] = ACTIONS(3474),
    [anon_sym_return] = ACTIONS(3476),
    [anon_sym_do] = ACTIONS(3476),
    [anon_sym_let] = ACTIONS(3476),
    [anon_sym_let_BANG] = ACTIONS(3474),
    [anon_sym_LPAREN] = ACTIONS(3476),
    [anon_sym_null] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym_LBRACK] = ACTIONS(3476),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3474),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_LT_AT] = ACTIONS(3476),
    [anon_sym_LT_AT_AT] = ACTIONS(3474),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3474),
    [anon_sym_new] = ACTIONS(3476),
    [anon_sym_return_BANG] = ACTIONS(3474),
    [anon_sym_yield] = ACTIONS(3476),
    [anon_sym_yield_BANG] = ACTIONS(3474),
    [anon_sym_lazy] = ACTIONS(3476),
    [anon_sym_assert] = ACTIONS(3476),
    [anon_sym_upcast] = ACTIONS(3476),
    [anon_sym_downcast] = ACTIONS(3476),
    [anon_sym_COLON_GT] = ACTIONS(3474),
    [anon_sym_for] = ACTIONS(3476),
    [anon_sym_while] = ACTIONS(3476),
    [anon_sym_if] = ACTIONS(3476),
    [anon_sym_fun] = ACTIONS(3476),
    [anon_sym_DASH_GT] = ACTIONS(3474),
    [anon_sym_try] = ACTIONS(3476),
    [anon_sym_match] = ACTIONS(3476),
    [anon_sym_match_BANG] = ACTIONS(3474),
    [anon_sym_function] = ACTIONS(3476),
    [anon_sym_use] = ACTIONS(3476),
    [anon_sym_use_BANG] = ACTIONS(3474),
    [anon_sym_do_BANG] = ACTIONS(3474),
    [anon_sym_begin] = ACTIONS(3476),
    [anon_sym_STAR] = ACTIONS(3474),
    [anon_sym_LT2] = ACTIONS(3476),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3474),
    [anon_sym_or] = ACTIONS(6566),
    [aux_sym_char_token1] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3476),
    [anon_sym_DQUOTE] = ACTIONS(3476),
    [anon_sym_AT_DQUOTE] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [sym_bool] = ACTIONS(3476),
    [sym_unit] = ACTIONS(3474),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3476),
    [sym_op_identifier] = ACTIONS(3474),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3476),
    [anon_sym_PLUS_DOT] = ACTIONS(3474),
    [anon_sym_DASH_DOT] = ACTIONS(3474),
    [anon_sym_PERCENT] = ACTIONS(3474),
    [anon_sym_AMP_AMP] = ACTIONS(3474),
    [anon_sym_TILDE] = ACTIONS(3474),
    [aux_sym_prefix_op_token1] = ACTIONS(3474),
    [sym_int] = ACTIONS(3476),
    [sym_xint] = ACTIONS(3474),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3474),
    [sym__newline] = ACTIONS(3474),
  },
  [4035] = {
    [sym_type_arguments] = STATE(4193),
    [sym_long_identifier] = STATE(4189),
    [sym_block_comment] = STATE(4035),
    [sym_compiler_directive_decl] = STATE(4035),
    [sym_fsi_directive_decl] = STATE(4035),
    [sym_preproc_line] = STATE(4035),
    [aux_sym_compound_type_repeat1] = STATE(4157),
    [sym_identifier] = ACTIONS(6560),
    [anon_sym_GT_RBRACK] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_let] = ACTIONS(3419),
    [anon_sym_let_BANG] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(3419),
    [anon_sym_null] = ACTIONS(3419),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_LT_AT] = ACTIONS(3419),
    [anon_sym_LT_AT_AT] = ACTIONS(3417),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_return_BANG] = ACTIONS(3417),
    [anon_sym_yield] = ACTIONS(3419),
    [anon_sym_yield_BANG] = ACTIONS(3417),
    [anon_sym_lazy] = ACTIONS(3419),
    [anon_sym_assert] = ACTIONS(3419),
    [anon_sym_upcast] = ACTIONS(3419),
    [anon_sym_downcast] = ACTIONS(3419),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_fun] = ACTIONS(3419),
    [anon_sym_DASH_GT] = ACTIONS(2666),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_match] = ACTIONS(3419),
    [anon_sym_match_BANG] = ACTIONS(3417),
    [anon_sym_function] = ACTIONS(3419),
    [anon_sym_use] = ACTIONS(3419),
    [anon_sym_use_BANG] = ACTIONS(3417),
    [anon_sym_do_BANG] = ACTIONS(3417),
    [anon_sym_begin] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(2668),
    [anon_sym_LT2] = ACTIONS(2670),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2672),
    [aux_sym_char_token1] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3419),
    [anon_sym_AT_DQUOTE] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [sym_bool] = ACTIONS(3419),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3419),
    [sym_op_identifier] = ACTIONS(3417),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_PLUS_DOT] = ACTIONS(3417),
    [anon_sym_DASH_DOT] = ACTIONS(3417),
    [anon_sym_PERCENT] = ACTIONS(3417),
    [anon_sym_AMP_AMP] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3417),
    [aux_sym_prefix_op_token1] = ACTIONS(3417),
    [sym_int] = ACTIONS(3419),
    [sym_xint] = ACTIONS(3417),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3417),
    [sym__newline] = ACTIONS(3417),
  },
  [4036] = {
    [sym_block_comment] = STATE(4036),
    [sym_compiler_directive_decl] = STATE(4036),
    [sym_fsi_directive_decl] = STATE(4036),
    [sym_preproc_line] = STATE(4036),
    [aux_sym_long_identifier_repeat1] = STATE(4037),
    [ts_builtin_sym_end] = ACTIONS(3492),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_module] = ACTIONS(3494),
    [anon_sym_EQ] = ACTIONS(6568),
    [anon_sym_open] = ACTIONS(3494),
    [anon_sym_LBRACK_LT] = ACTIONS(3492),
    [anon_sym_return] = ACTIONS(3494),
    [anon_sym_type] = ACTIONS(3494),
    [anon_sym_do] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_let_BANG] = ACTIONS(3492),
    [anon_sym_LPAREN] = ACTIONS(3494),
    [anon_sym_null] = ACTIONS(3494),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3492),
    [anon_sym_LBRACE] = ACTIONS(3494),
    [anon_sym_LT_AT] = ACTIONS(3494),
    [anon_sym_LT_AT_AT] = ACTIONS(3492),
    [anon_sym_DOT] = ACTIONS(6564),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3492),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_return_BANG] = ACTIONS(3492),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_yield_BANG] = ACTIONS(3492),
    [anon_sym_lazy] = ACTIONS(3494),
    [anon_sym_assert] = ACTIONS(3494),
    [anon_sym_upcast] = ACTIONS(3494),
    [anon_sym_downcast] = ACTIONS(3494),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_while] = ACTIONS(3494),
    [anon_sym_if] = ACTIONS(3494),
    [anon_sym_fun] = ACTIONS(3494),
    [anon_sym_try] = ACTIONS(3494),
    [anon_sym_match] = ACTIONS(3494),
    [anon_sym_match_BANG] = ACTIONS(3492),
    [anon_sym_function] = ACTIONS(3494),
    [anon_sym_use] = ACTIONS(3494),
    [anon_sym_use_BANG] = ACTIONS(3492),
    [anon_sym_do_BANG] = ACTIONS(3492),
    [anon_sym_begin] = ACTIONS(3494),
    [anon_sym_exception] = ACTIONS(3494),
    [aux_sym_char_token1] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3494),
    [anon_sym_DQUOTE] = ACTIONS(3494),
    [anon_sym_AT_DQUOTE] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [sym_bool] = ACTIONS(3494),
    [sym_unit] = ACTIONS(3492),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3494),
    [sym_op_identifier] = ACTIONS(3492),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_PLUS_DOT] = ACTIONS(3492),
    [anon_sym_DASH_DOT] = ACTIONS(3492),
    [anon_sym_PERCENT] = ACTIONS(3492),
    [anon_sym_AMP_AMP] = ACTIONS(3492),
    [anon_sym_TILDE] = ACTIONS(3492),
    [aux_sym_prefix_op_token1] = ACTIONS(3492),
    [sym_int] = ACTIONS(3494),
    [sym_xint] = ACTIONS(3492),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3492),
    [anon_sym_POUNDload] = ACTIONS(3492),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3492),
  },
  [4037] = {
    [sym_block_comment] = STATE(4037),
    [sym_compiler_directive_decl] = STATE(4037),
    [sym_fsi_directive_decl] = STATE(4037),
    [sym_preproc_line] = STATE(4037),
    [aux_sym_long_identifier_repeat1] = STATE(4042),
    [ts_builtin_sym_end] = ACTIONS(3449),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_namespace] = ACTIONS(3451),
    [anon_sym_module] = ACTIONS(3451),
    [anon_sym_open] = ACTIONS(3451),
    [anon_sym_LBRACK_LT] = ACTIONS(3449),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_type] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3449),
    [anon_sym_DOT] = ACTIONS(6564),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_exception] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3449),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3449),
    [anon_sym_DASH_DOT] = ACTIONS(3449),
    [anon_sym_PERCENT] = ACTIONS(3449),
    [anon_sym_AMP_AMP] = ACTIONS(3449),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3449),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3449),
    [anon_sym_POUNDload] = ACTIONS(3449),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
  },
  [4038] = {
    [sym_block_comment] = STATE(4038),
    [sym_compiler_directive_decl] = STATE(4038),
    [sym_fsi_directive_decl] = STATE(4038),
    [sym_preproc_line] = STATE(4038),
    [aux_sym_type_argument_repeat1] = STATE(4034),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_GT_RBRACK] = ACTIONS(3496),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3496),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3496),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3496),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_or] = ACTIONS(6566),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3496),
    [anon_sym_DASH_DOT] = ACTIONS(3496),
    [anon_sym_PERCENT] = ACTIONS(3496),
    [anon_sym_AMP_AMP] = ACTIONS(3496),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3496),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
  },
  [4039] = {
    [sym_type_arguments] = STATE(4193),
    [sym_long_identifier] = STATE(4189),
    [sym_block_comment] = STATE(4039),
    [sym_compiler_directive_decl] = STATE(4039),
    [sym_fsi_directive_decl] = STATE(4039),
    [sym_preproc_line] = STATE(4039),
    [aux_sym_compound_type_repeat1] = STATE(4157),
    [sym_identifier] = ACTIONS(6560),
    [anon_sym_GT_RBRACK] = ACTIONS(3403),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_let_BANG] = ACTIONS(3403),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_null] = ACTIONS(3407),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3407),
    [anon_sym_LT_AT] = ACTIONS(3407),
    [anon_sym_LT_AT_AT] = ACTIONS(3403),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_return_BANG] = ACTIONS(3403),
    [anon_sym_yield] = ACTIONS(3407),
    [anon_sym_yield_BANG] = ACTIONS(3403),
    [anon_sym_lazy] = ACTIONS(3407),
    [anon_sym_assert] = ACTIONS(3407),
    [anon_sym_upcast] = ACTIONS(3407),
    [anon_sym_downcast] = ACTIONS(3407),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_fun] = ACTIONS(3407),
    [anon_sym_DASH_GT] = ACTIONS(2666),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_match] = ACTIONS(3407),
    [anon_sym_match_BANG] = ACTIONS(3403),
    [anon_sym_function] = ACTIONS(3407),
    [anon_sym_use] = ACTIONS(3407),
    [anon_sym_use_BANG] = ACTIONS(3403),
    [anon_sym_do_BANG] = ACTIONS(3403),
    [anon_sym_begin] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(2668),
    [anon_sym_LT2] = ACTIONS(2670),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2672),
    [aux_sym_char_token1] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3407),
    [anon_sym_DQUOTE] = ACTIONS(3407),
    [anon_sym_AT_DQUOTE] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [sym_bool] = ACTIONS(3407),
    [sym_unit] = ACTIONS(3403),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3407),
    [sym_op_identifier] = ACTIONS(3403),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_PLUS_DOT] = ACTIONS(3403),
    [anon_sym_DASH_DOT] = ACTIONS(3403),
    [anon_sym_PERCENT] = ACTIONS(3403),
    [anon_sym_AMP_AMP] = ACTIONS(3403),
    [anon_sym_TILDE] = ACTIONS(3403),
    [aux_sym_prefix_op_token1] = ACTIONS(3403),
    [sym_int] = ACTIONS(3407),
    [sym_xint] = ACTIONS(3403),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3403),
    [sym__newline] = ACTIONS(3403),
  },
  [4040] = {
    [sym_block_comment] = STATE(4040),
    [sym_compiler_directive_decl] = STATE(4040),
    [sym_fsi_directive_decl] = STATE(4040),
    [sym_preproc_line] = STATE(4040),
    [aux_sym_type_argument_repeat1] = STATE(4040),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_GT_RBRACK] = ACTIONS(3478),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3478),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3478),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3478),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_or] = ACTIONS(6570),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3478),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3478),
    [anon_sym_DASH_DOT] = ACTIONS(3478),
    [anon_sym_PERCENT] = ACTIONS(3478),
    [anon_sym_AMP_AMP] = ACTIONS(3478),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3478),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
  },
  [4041] = {
    [sym_type_arguments] = STATE(4193),
    [sym_long_identifier] = STATE(4189),
    [sym_block_comment] = STATE(4041),
    [sym_compiler_directive_decl] = STATE(4041),
    [sym_fsi_directive_decl] = STATE(4041),
    [sym_preproc_line] = STATE(4041),
    [aux_sym_compound_type_repeat1] = STATE(4157),
    [sym_identifier] = ACTIONS(6560),
    [anon_sym_GT_RBRACK] = ACTIONS(3429),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_let] = ACTIONS(3431),
    [anon_sym_let_BANG] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(3431),
    [anon_sym_null] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_LT_AT] = ACTIONS(3431),
    [anon_sym_LT_AT_AT] = ACTIONS(3429),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_return_BANG] = ACTIONS(3429),
    [anon_sym_yield] = ACTIONS(3431),
    [anon_sym_yield_BANG] = ACTIONS(3429),
    [anon_sym_lazy] = ACTIONS(3431),
    [anon_sym_assert] = ACTIONS(3431),
    [anon_sym_upcast] = ACTIONS(3431),
    [anon_sym_downcast] = ACTIONS(3431),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_fun] = ACTIONS(3431),
    [anon_sym_DASH_GT] = ACTIONS(2666),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_match] = ACTIONS(3431),
    [anon_sym_match_BANG] = ACTIONS(3429),
    [anon_sym_function] = ACTIONS(3431),
    [anon_sym_use] = ACTIONS(3431),
    [anon_sym_use_BANG] = ACTIONS(3429),
    [anon_sym_do_BANG] = ACTIONS(3429),
    [anon_sym_begin] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(2668),
    [anon_sym_LT2] = ACTIONS(2670),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2672),
    [aux_sym_char_token1] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [anon_sym_AT_DQUOTE] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [sym_bool] = ACTIONS(3431),
    [sym_unit] = ACTIONS(3429),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3431),
    [sym_op_identifier] = ACTIONS(3429),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_DOT] = ACTIONS(3429),
    [anon_sym_DASH_DOT] = ACTIONS(3429),
    [anon_sym_PERCENT] = ACTIONS(3429),
    [anon_sym_AMP_AMP] = ACTIONS(3429),
    [anon_sym_TILDE] = ACTIONS(3429),
    [aux_sym_prefix_op_token1] = ACTIONS(3429),
    [sym_int] = ACTIONS(3431),
    [sym_xint] = ACTIONS(3429),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3429),
    [sym__newline] = ACTIONS(3429),
  },
  [4042] = {
    [sym_block_comment] = STATE(4042),
    [sym_compiler_directive_decl] = STATE(4042),
    [sym_fsi_directive_decl] = STATE(4042),
    [sym_preproc_line] = STATE(4042),
    [aux_sym_long_identifier_repeat1] = STATE(4042),
    [ts_builtin_sym_end] = ACTIONS(3485),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_namespace] = ACTIONS(3487),
    [anon_sym_module] = ACTIONS(3487),
    [anon_sym_open] = ACTIONS(3487),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_type] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3485),
    [anon_sym_DOT] = ACTIONS(6573),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_exception] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3485),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3485),
    [anon_sym_DASH_DOT] = ACTIONS(3485),
    [anon_sym_PERCENT] = ACTIONS(3485),
    [anon_sym_AMP_AMP] = ACTIONS(3485),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3485),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3485),
    [anon_sym_POUNDload] = ACTIONS(3485),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
  },
  [4043] = {
    [sym_block_comment] = STATE(4043),
    [sym_compiler_directive_decl] = STATE(4043),
    [sym_fsi_directive_decl] = STATE(4043),
    [sym_preproc_line] = STATE(4043),
    [aux_sym_long_identifier_repeat1] = STATE(4037),
    [ts_builtin_sym_end] = ACTIONS(3492),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_namespace] = ACTIONS(3494),
    [anon_sym_module] = ACTIONS(3494),
    [anon_sym_open] = ACTIONS(3494),
    [anon_sym_LBRACK_LT] = ACTIONS(3492),
    [anon_sym_return] = ACTIONS(3494),
    [anon_sym_type] = ACTIONS(3494),
    [anon_sym_do] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_let_BANG] = ACTIONS(3492),
    [anon_sym_LPAREN] = ACTIONS(3494),
    [anon_sym_null] = ACTIONS(3494),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3492),
    [anon_sym_LBRACE] = ACTIONS(3494),
    [anon_sym_LT_AT] = ACTIONS(3494),
    [anon_sym_LT_AT_AT] = ACTIONS(3492),
    [anon_sym_DOT] = ACTIONS(6564),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3492),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_return_BANG] = ACTIONS(3492),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_yield_BANG] = ACTIONS(3492),
    [anon_sym_lazy] = ACTIONS(3494),
    [anon_sym_assert] = ACTIONS(3494),
    [anon_sym_upcast] = ACTIONS(3494),
    [anon_sym_downcast] = ACTIONS(3494),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_while] = ACTIONS(3494),
    [anon_sym_if] = ACTIONS(3494),
    [anon_sym_fun] = ACTIONS(3494),
    [anon_sym_try] = ACTIONS(3494),
    [anon_sym_match] = ACTIONS(3494),
    [anon_sym_match_BANG] = ACTIONS(3492),
    [anon_sym_function] = ACTIONS(3494),
    [anon_sym_use] = ACTIONS(3494),
    [anon_sym_use_BANG] = ACTIONS(3492),
    [anon_sym_do_BANG] = ACTIONS(3492),
    [anon_sym_begin] = ACTIONS(3494),
    [anon_sym_exception] = ACTIONS(3494),
    [aux_sym_char_token1] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3494),
    [anon_sym_DQUOTE] = ACTIONS(3494),
    [anon_sym_AT_DQUOTE] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [sym_bool] = ACTIONS(3494),
    [sym_unit] = ACTIONS(3492),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3494),
    [sym_op_identifier] = ACTIONS(3492),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_PLUS_DOT] = ACTIONS(3492),
    [anon_sym_DASH_DOT] = ACTIONS(3492),
    [anon_sym_PERCENT] = ACTIONS(3492),
    [anon_sym_AMP_AMP] = ACTIONS(3492),
    [anon_sym_TILDE] = ACTIONS(3492),
    [aux_sym_prefix_op_token1] = ACTIONS(3492),
    [sym_int] = ACTIONS(3494),
    [sym_xint] = ACTIONS(3492),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3492),
    [anon_sym_POUNDload] = ACTIONS(3492),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3492),
  },
  [4044] = {
    [sym_block_comment] = STATE(4044),
    [sym_compiler_directive_decl] = STATE(4044),
    [sym_fsi_directive_decl] = STATE(4044),
    [sym_preproc_line] = STATE(4044),
    [aux_sym_long_identifier_repeat1] = STATE(4037),
    [ts_builtin_sym_end] = ACTIONS(3492),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_module] = ACTIONS(3494),
    [anon_sym_EQ] = ACTIONS(6576),
    [anon_sym_open] = ACTIONS(3494),
    [anon_sym_LBRACK_LT] = ACTIONS(3492),
    [anon_sym_return] = ACTIONS(3494),
    [anon_sym_type] = ACTIONS(3494),
    [anon_sym_do] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_let_BANG] = ACTIONS(3492),
    [anon_sym_LPAREN] = ACTIONS(3494),
    [anon_sym_null] = ACTIONS(3494),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3492),
    [anon_sym_LBRACE] = ACTIONS(3494),
    [anon_sym_LT_AT] = ACTIONS(3494),
    [anon_sym_LT_AT_AT] = ACTIONS(3492),
    [anon_sym_DOT] = ACTIONS(6564),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3492),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_return_BANG] = ACTIONS(3492),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_yield_BANG] = ACTIONS(3492),
    [anon_sym_lazy] = ACTIONS(3494),
    [anon_sym_assert] = ACTIONS(3494),
    [anon_sym_upcast] = ACTIONS(3494),
    [anon_sym_downcast] = ACTIONS(3494),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_while] = ACTIONS(3494),
    [anon_sym_if] = ACTIONS(3494),
    [anon_sym_fun] = ACTIONS(3494),
    [anon_sym_try] = ACTIONS(3494),
    [anon_sym_match] = ACTIONS(3494),
    [anon_sym_match_BANG] = ACTIONS(3492),
    [anon_sym_function] = ACTIONS(3494),
    [anon_sym_use] = ACTIONS(3494),
    [anon_sym_use_BANG] = ACTIONS(3492),
    [anon_sym_do_BANG] = ACTIONS(3492),
    [anon_sym_begin] = ACTIONS(3494),
    [anon_sym_exception] = ACTIONS(3494),
    [aux_sym_char_token1] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3494),
    [anon_sym_DQUOTE] = ACTIONS(3494),
    [anon_sym_AT_DQUOTE] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [sym_bool] = ACTIONS(3494),
    [sym_unit] = ACTIONS(3492),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3494),
    [sym_op_identifier] = ACTIONS(3492),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_PLUS_DOT] = ACTIONS(3492),
    [anon_sym_DASH_DOT] = ACTIONS(3492),
    [anon_sym_PERCENT] = ACTIONS(3492),
    [anon_sym_AMP_AMP] = ACTIONS(3492),
    [anon_sym_TILDE] = ACTIONS(3492),
    [aux_sym_prefix_op_token1] = ACTIONS(3492),
    [sym_int] = ACTIONS(3494),
    [sym_xint] = ACTIONS(3492),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3492),
    [anon_sym_POUNDload] = ACTIONS(3492),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3492),
  },
  [4045] = {
    [sym_block_comment] = STATE(4045),
    [sym_compiler_directive_decl] = STATE(4045),
    [sym_fsi_directive_decl] = STATE(4045),
    [sym_preproc_line] = STATE(4045),
    [aux_sym_long_identifier_repeat1] = STATE(4037),
    [ts_builtin_sym_end] = ACTIONS(3492),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_module] = ACTIONS(3494),
    [anon_sym_EQ] = ACTIONS(6578),
    [anon_sym_open] = ACTIONS(3494),
    [anon_sym_LBRACK_LT] = ACTIONS(3492),
    [anon_sym_return] = ACTIONS(3494),
    [anon_sym_type] = ACTIONS(3494),
    [anon_sym_do] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_let_BANG] = ACTIONS(3492),
    [anon_sym_LPAREN] = ACTIONS(3494),
    [anon_sym_null] = ACTIONS(3494),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3492),
    [anon_sym_LBRACE] = ACTIONS(3494),
    [anon_sym_LT_AT] = ACTIONS(3494),
    [anon_sym_LT_AT_AT] = ACTIONS(3492),
    [anon_sym_DOT] = ACTIONS(6564),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3492),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_return_BANG] = ACTIONS(3492),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_yield_BANG] = ACTIONS(3492),
    [anon_sym_lazy] = ACTIONS(3494),
    [anon_sym_assert] = ACTIONS(3494),
    [anon_sym_upcast] = ACTIONS(3494),
    [anon_sym_downcast] = ACTIONS(3494),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_while] = ACTIONS(3494),
    [anon_sym_if] = ACTIONS(3494),
    [anon_sym_fun] = ACTIONS(3494),
    [anon_sym_try] = ACTIONS(3494),
    [anon_sym_match] = ACTIONS(3494),
    [anon_sym_match_BANG] = ACTIONS(3492),
    [anon_sym_function] = ACTIONS(3494),
    [anon_sym_use] = ACTIONS(3494),
    [anon_sym_use_BANG] = ACTIONS(3492),
    [anon_sym_do_BANG] = ACTIONS(3492),
    [anon_sym_begin] = ACTIONS(3494),
    [anon_sym_exception] = ACTIONS(3494),
    [aux_sym_char_token1] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3494),
    [anon_sym_DQUOTE] = ACTIONS(3494),
    [anon_sym_AT_DQUOTE] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [sym_bool] = ACTIONS(3494),
    [sym_unit] = ACTIONS(3492),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3494),
    [sym_op_identifier] = ACTIONS(3492),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_PLUS_DOT] = ACTIONS(3492),
    [anon_sym_DASH_DOT] = ACTIONS(3492),
    [anon_sym_PERCENT] = ACTIONS(3492),
    [anon_sym_AMP_AMP] = ACTIONS(3492),
    [anon_sym_TILDE] = ACTIONS(3492),
    [aux_sym_prefix_op_token1] = ACTIONS(3492),
    [sym_int] = ACTIONS(3494),
    [sym_xint] = ACTIONS(3492),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3492),
    [anon_sym_POUNDload] = ACTIONS(3492),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3492),
  },
  [4046] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10886),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4046),
    [sym_compiler_directive_decl] = STATE(4046),
    [sym_fsi_directive_decl] = STATE(4046),
    [sym_preproc_line] = STATE(4046),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6588),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4047] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10583),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4047),
    [sym_compiler_directive_decl] = STATE(4047),
    [sym_fsi_directive_decl] = STATE(4047),
    [sym_preproc_line] = STATE(4047),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6616),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4048] = {
    [sym_block_comment] = STATE(4048),
    [sym_compiler_directive_decl] = STATE(4048),
    [sym_fsi_directive_decl] = STATE(4048),
    [sym_preproc_line] = STATE(4048),
    [ts_builtin_sym_end] = ACTIONS(3485),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_namespace] = ACTIONS(3487),
    [anon_sym_module] = ACTIONS(3487),
    [anon_sym_open] = ACTIONS(3487),
    [anon_sym_LBRACK_LT] = ACTIONS(3485),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_type] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3485),
    [anon_sym_DOT] = ACTIONS(3485),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_exception] = ACTIONS(3487),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3485),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3485),
    [anon_sym_DASH_DOT] = ACTIONS(3485),
    [anon_sym_PERCENT] = ACTIONS(3485),
    [anon_sym_AMP_AMP] = ACTIONS(3485),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3485),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3485),
    [anon_sym_POUNDload] = ACTIONS(3485),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
  },
  [4049] = {
    [sym_block_comment] = STATE(4049),
    [sym_compiler_directive_decl] = STATE(4049),
    [sym_fsi_directive_decl] = STATE(4049),
    [sym_preproc_line] = STATE(4049),
    [ts_builtin_sym_end] = ACTIONS(6618),
    [sym_identifier] = ACTIONS(6620),
    [anon_sym_namespace] = ACTIONS(6620),
    [anon_sym_module] = ACTIONS(6620),
    [anon_sym_open] = ACTIONS(6620),
    [anon_sym_LBRACK_LT] = ACTIONS(6618),
    [anon_sym_return] = ACTIONS(6620),
    [anon_sym_type] = ACTIONS(6620),
    [anon_sym_do] = ACTIONS(6620),
    [anon_sym_and] = ACTIONS(6620),
    [anon_sym_let] = ACTIONS(6620),
    [anon_sym_let_BANG] = ACTIONS(6618),
    [anon_sym_LPAREN] = ACTIONS(6620),
    [anon_sym_null] = ACTIONS(6620),
    [anon_sym_AMP] = ACTIONS(6620),
    [anon_sym_LBRACK] = ACTIONS(6620),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6618),
    [anon_sym_LBRACE] = ACTIONS(6620),
    [anon_sym_LT_AT] = ACTIONS(6620),
    [anon_sym_LT_AT_AT] = ACTIONS(6618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6618),
    [anon_sym_new] = ACTIONS(6620),
    [anon_sym_return_BANG] = ACTIONS(6618),
    [anon_sym_yield] = ACTIONS(6620),
    [anon_sym_yield_BANG] = ACTIONS(6618),
    [anon_sym_lazy] = ACTIONS(6620),
    [anon_sym_assert] = ACTIONS(6620),
    [anon_sym_upcast] = ACTIONS(6620),
    [anon_sym_downcast] = ACTIONS(6620),
    [anon_sym_for] = ACTIONS(6620),
    [anon_sym_while] = ACTIONS(6620),
    [anon_sym_if] = ACTIONS(6620),
    [anon_sym_fun] = ACTIONS(6620),
    [anon_sym_try] = ACTIONS(6620),
    [anon_sym_match] = ACTIONS(6620),
    [anon_sym_match_BANG] = ACTIONS(6618),
    [anon_sym_function] = ACTIONS(6620),
    [anon_sym_use] = ACTIONS(6620),
    [anon_sym_use_BANG] = ACTIONS(6618),
    [anon_sym_do_BANG] = ACTIONS(6618),
    [anon_sym_begin] = ACTIONS(6620),
    [anon_sym_exception] = ACTIONS(6620),
    [aux_sym_char_token1] = ACTIONS(6618),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6620),
    [anon_sym_DQUOTE] = ACTIONS(6620),
    [anon_sym_AT_DQUOTE] = ACTIONS(6618),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6618),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6618),
    [sym_bool] = ACTIONS(6620),
    [sym_unit] = ACTIONS(6618),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6620),
    [sym_op_identifier] = ACTIONS(6618),
    [anon_sym_PLUS] = ACTIONS(6620),
    [anon_sym_DASH] = ACTIONS(6620),
    [anon_sym_PLUS_DOT] = ACTIONS(6618),
    [anon_sym_DASH_DOT] = ACTIONS(6618),
    [anon_sym_PERCENT] = ACTIONS(6618),
    [anon_sym_AMP_AMP] = ACTIONS(6618),
    [anon_sym_TILDE] = ACTIONS(6618),
    [aux_sym_prefix_op_token1] = ACTIONS(6618),
    [sym_int] = ACTIONS(6620),
    [sym_xint] = ACTIONS(6618),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6618),
    [anon_sym_POUNDload] = ACTIONS(6618),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6618),
  },
  [4050] = {
    [sym_block_comment] = STATE(4050),
    [sym_compiler_directive_decl] = STATE(4050),
    [sym_fsi_directive_decl] = STATE(4050),
    [sym_preproc_line] = STATE(4050),
    [ts_builtin_sym_end] = ACTIONS(6622),
    [sym_identifier] = ACTIONS(6624),
    [anon_sym_namespace] = ACTIONS(6624),
    [anon_sym_module] = ACTIONS(6624),
    [anon_sym_open] = ACTIONS(6624),
    [anon_sym_LBRACK_LT] = ACTIONS(6622),
    [anon_sym_return] = ACTIONS(6624),
    [anon_sym_type] = ACTIONS(6624),
    [anon_sym_do] = ACTIONS(6624),
    [anon_sym_and] = ACTIONS(6624),
    [anon_sym_let] = ACTIONS(6624),
    [anon_sym_let_BANG] = ACTIONS(6622),
    [anon_sym_LPAREN] = ACTIONS(6624),
    [anon_sym_null] = ACTIONS(6624),
    [anon_sym_AMP] = ACTIONS(6624),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6622),
    [anon_sym_LBRACE] = ACTIONS(6624),
    [anon_sym_LT_AT] = ACTIONS(6624),
    [anon_sym_LT_AT_AT] = ACTIONS(6622),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6622),
    [anon_sym_new] = ACTIONS(6624),
    [anon_sym_return_BANG] = ACTIONS(6622),
    [anon_sym_yield] = ACTIONS(6624),
    [anon_sym_yield_BANG] = ACTIONS(6622),
    [anon_sym_lazy] = ACTIONS(6624),
    [anon_sym_assert] = ACTIONS(6624),
    [anon_sym_upcast] = ACTIONS(6624),
    [anon_sym_downcast] = ACTIONS(6624),
    [anon_sym_for] = ACTIONS(6624),
    [anon_sym_while] = ACTIONS(6624),
    [anon_sym_if] = ACTIONS(6624),
    [anon_sym_fun] = ACTIONS(6624),
    [anon_sym_try] = ACTIONS(6624),
    [anon_sym_match] = ACTIONS(6624),
    [anon_sym_match_BANG] = ACTIONS(6622),
    [anon_sym_function] = ACTIONS(6624),
    [anon_sym_use] = ACTIONS(6624),
    [anon_sym_use_BANG] = ACTIONS(6622),
    [anon_sym_do_BANG] = ACTIONS(6622),
    [anon_sym_begin] = ACTIONS(6624),
    [anon_sym_exception] = ACTIONS(6624),
    [aux_sym_char_token1] = ACTIONS(6622),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6624),
    [anon_sym_DQUOTE] = ACTIONS(6624),
    [anon_sym_AT_DQUOTE] = ACTIONS(6622),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6622),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6622),
    [sym_bool] = ACTIONS(6624),
    [sym_unit] = ACTIONS(6622),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6624),
    [sym_op_identifier] = ACTIONS(6622),
    [anon_sym_PLUS] = ACTIONS(6624),
    [anon_sym_DASH] = ACTIONS(6624),
    [anon_sym_PLUS_DOT] = ACTIONS(6622),
    [anon_sym_DASH_DOT] = ACTIONS(6622),
    [anon_sym_PERCENT] = ACTIONS(6622),
    [anon_sym_AMP_AMP] = ACTIONS(6622),
    [anon_sym_TILDE] = ACTIONS(6622),
    [aux_sym_prefix_op_token1] = ACTIONS(6622),
    [sym_int] = ACTIONS(6624),
    [sym_xint] = ACTIONS(6622),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6622),
    [anon_sym_POUNDload] = ACTIONS(6622),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6622),
  },
  [4051] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10395),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4051),
    [sym_compiler_directive_decl] = STATE(4051),
    [sym_fsi_directive_decl] = STATE(4051),
    [sym_preproc_line] = STATE(4051),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6626),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4052] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(12062),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4052),
    [sym_compiler_directive_decl] = STATE(4052),
    [sym_fsi_directive_decl] = STATE(4052),
    [sym_preproc_line] = STATE(4052),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6628),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4053] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(11282),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4053),
    [sym_compiler_directive_decl] = STATE(4053),
    [sym_fsi_directive_decl] = STATE(4053),
    [sym_preproc_line] = STATE(4053),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6630),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4054] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10404),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4054),
    [sym_compiler_directive_decl] = STATE(4054),
    [sym_fsi_directive_decl] = STATE(4054),
    [sym_preproc_line] = STATE(4054),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6632),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4055] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(11522),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4055),
    [sym_compiler_directive_decl] = STATE(4055),
    [sym_fsi_directive_decl] = STATE(4055),
    [sym_preproc_line] = STATE(4055),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6634),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4056] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10413),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4056),
    [sym_compiler_directive_decl] = STATE(4056),
    [sym_fsi_directive_decl] = STATE(4056),
    [sym_preproc_line] = STATE(4056),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6636),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4057] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10386),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4057),
    [sym_compiler_directive_decl] = STATE(4057),
    [sym_fsi_directive_decl] = STATE(4057),
    [sym_preproc_line] = STATE(4057),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6638),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4058] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(11598),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4058),
    [sym_compiler_directive_decl] = STATE(4058),
    [sym_fsi_directive_decl] = STATE(4058),
    [sym_preproc_line] = STATE(4058),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6640),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4059] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10423),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4059),
    [sym_compiler_directive_decl] = STATE(4059),
    [sym_fsi_directive_decl] = STATE(4059),
    [sym_preproc_line] = STATE(4059),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6642),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4060] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10379),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4060),
    [sym_compiler_directive_decl] = STATE(4060),
    [sym_fsi_directive_decl] = STATE(4060),
    [sym_preproc_line] = STATE(4060),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6644),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4061] = {
    [sym_block_comment] = STATE(4061),
    [sym_compiler_directive_decl] = STATE(4061),
    [sym_fsi_directive_decl] = STATE(4061),
    [sym_preproc_line] = STATE(4061),
    [ts_builtin_sym_end] = ACTIONS(6646),
    [sym_identifier] = ACTIONS(6648),
    [anon_sym_namespace] = ACTIONS(6648),
    [anon_sym_module] = ACTIONS(6648),
    [anon_sym_open] = ACTIONS(6648),
    [anon_sym_LBRACK_LT] = ACTIONS(6646),
    [anon_sym_return] = ACTIONS(6648),
    [anon_sym_type] = ACTIONS(6648),
    [anon_sym_do] = ACTIONS(6648),
    [anon_sym_and] = ACTIONS(6648),
    [anon_sym_let] = ACTIONS(6648),
    [anon_sym_let_BANG] = ACTIONS(6646),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [anon_sym_null] = ACTIONS(6648),
    [anon_sym_AMP] = ACTIONS(6648),
    [anon_sym_LBRACK] = ACTIONS(6648),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6646),
    [anon_sym_LBRACE] = ACTIONS(6648),
    [anon_sym_LT_AT] = ACTIONS(6648),
    [anon_sym_LT_AT_AT] = ACTIONS(6646),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6646),
    [anon_sym_new] = ACTIONS(6648),
    [anon_sym_return_BANG] = ACTIONS(6646),
    [anon_sym_yield] = ACTIONS(6648),
    [anon_sym_yield_BANG] = ACTIONS(6646),
    [anon_sym_lazy] = ACTIONS(6648),
    [anon_sym_assert] = ACTIONS(6648),
    [anon_sym_upcast] = ACTIONS(6648),
    [anon_sym_downcast] = ACTIONS(6648),
    [anon_sym_for] = ACTIONS(6648),
    [anon_sym_while] = ACTIONS(6648),
    [anon_sym_if] = ACTIONS(6648),
    [anon_sym_fun] = ACTIONS(6648),
    [anon_sym_try] = ACTIONS(6648),
    [anon_sym_match] = ACTIONS(6648),
    [anon_sym_match_BANG] = ACTIONS(6646),
    [anon_sym_function] = ACTIONS(6648),
    [anon_sym_use] = ACTIONS(6648),
    [anon_sym_use_BANG] = ACTIONS(6646),
    [anon_sym_do_BANG] = ACTIONS(6646),
    [anon_sym_begin] = ACTIONS(6648),
    [anon_sym_exception] = ACTIONS(6648),
    [aux_sym_char_token1] = ACTIONS(6646),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6648),
    [anon_sym_DQUOTE] = ACTIONS(6648),
    [anon_sym_AT_DQUOTE] = ACTIONS(6646),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6646),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6646),
    [sym_bool] = ACTIONS(6648),
    [sym_unit] = ACTIONS(6646),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6648),
    [sym_op_identifier] = ACTIONS(6646),
    [anon_sym_PLUS] = ACTIONS(6648),
    [anon_sym_DASH] = ACTIONS(6648),
    [anon_sym_PLUS_DOT] = ACTIONS(6646),
    [anon_sym_DASH_DOT] = ACTIONS(6646),
    [anon_sym_PERCENT] = ACTIONS(6646),
    [anon_sym_AMP_AMP] = ACTIONS(6646),
    [anon_sym_TILDE] = ACTIONS(6646),
    [aux_sym_prefix_op_token1] = ACTIONS(6646),
    [sym_int] = ACTIONS(6648),
    [sym_xint] = ACTIONS(6646),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6646),
    [anon_sym_POUNDload] = ACTIONS(6646),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6646),
  },
  [4062] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10433),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4062),
    [sym_compiler_directive_decl] = STATE(4062),
    [sym_fsi_directive_decl] = STATE(4062),
    [sym_preproc_line] = STATE(4062),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6650),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4063] = {
    [sym_block_comment] = STATE(4063),
    [sym_compiler_directive_decl] = STATE(4063),
    [sym_fsi_directive_decl] = STATE(4063),
    [sym_preproc_line] = STATE(4063),
    [ts_builtin_sym_end] = ACTIONS(6652),
    [sym_identifier] = ACTIONS(6654),
    [anon_sym_namespace] = ACTIONS(6654),
    [anon_sym_module] = ACTIONS(6654),
    [anon_sym_open] = ACTIONS(6654),
    [anon_sym_LBRACK_LT] = ACTIONS(6652),
    [anon_sym_return] = ACTIONS(6654),
    [anon_sym_type] = ACTIONS(6654),
    [anon_sym_do] = ACTIONS(6654),
    [anon_sym_and] = ACTIONS(6654),
    [anon_sym_let] = ACTIONS(6654),
    [anon_sym_let_BANG] = ACTIONS(6652),
    [anon_sym_LPAREN] = ACTIONS(6654),
    [anon_sym_null] = ACTIONS(6654),
    [anon_sym_AMP] = ACTIONS(6654),
    [anon_sym_LBRACK] = ACTIONS(6654),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6652),
    [anon_sym_LBRACE] = ACTIONS(6654),
    [anon_sym_LT_AT] = ACTIONS(6654),
    [anon_sym_LT_AT_AT] = ACTIONS(6652),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6652),
    [anon_sym_new] = ACTIONS(6654),
    [anon_sym_return_BANG] = ACTIONS(6652),
    [anon_sym_yield] = ACTIONS(6654),
    [anon_sym_yield_BANG] = ACTIONS(6652),
    [anon_sym_lazy] = ACTIONS(6654),
    [anon_sym_assert] = ACTIONS(6654),
    [anon_sym_upcast] = ACTIONS(6654),
    [anon_sym_downcast] = ACTIONS(6654),
    [anon_sym_for] = ACTIONS(6654),
    [anon_sym_while] = ACTIONS(6654),
    [anon_sym_if] = ACTIONS(6654),
    [anon_sym_fun] = ACTIONS(6654),
    [anon_sym_try] = ACTIONS(6654),
    [anon_sym_match] = ACTIONS(6654),
    [anon_sym_match_BANG] = ACTIONS(6652),
    [anon_sym_function] = ACTIONS(6654),
    [anon_sym_use] = ACTIONS(6654),
    [anon_sym_use_BANG] = ACTIONS(6652),
    [anon_sym_do_BANG] = ACTIONS(6652),
    [anon_sym_begin] = ACTIONS(6654),
    [anon_sym_exception] = ACTIONS(6654),
    [aux_sym_char_token1] = ACTIONS(6652),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6654),
    [anon_sym_DQUOTE] = ACTIONS(6654),
    [anon_sym_AT_DQUOTE] = ACTIONS(6652),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6652),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6652),
    [sym_bool] = ACTIONS(6654),
    [sym_unit] = ACTIONS(6652),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6654),
    [sym_op_identifier] = ACTIONS(6652),
    [anon_sym_PLUS] = ACTIONS(6654),
    [anon_sym_DASH] = ACTIONS(6654),
    [anon_sym_PLUS_DOT] = ACTIONS(6652),
    [anon_sym_DASH_DOT] = ACTIONS(6652),
    [anon_sym_PERCENT] = ACTIONS(6652),
    [anon_sym_AMP_AMP] = ACTIONS(6652),
    [anon_sym_TILDE] = ACTIONS(6652),
    [aux_sym_prefix_op_token1] = ACTIONS(6652),
    [sym_int] = ACTIONS(6654),
    [sym_xint] = ACTIONS(6652),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6652),
    [anon_sym_POUNDload] = ACTIONS(6652),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6652),
  },
  [4064] = {
    [sym_block_comment] = STATE(4064),
    [sym_compiler_directive_decl] = STATE(4064),
    [sym_fsi_directive_decl] = STATE(4064),
    [sym_preproc_line] = STATE(4064),
    [sym_identifier] = ACTIONS(3511),
    [anon_sym_GT_RBRACK] = ACTIONS(3509),
    [anon_sym_return] = ACTIONS(3511),
    [anon_sym_do] = ACTIONS(3511),
    [anon_sym_let] = ACTIONS(3511),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3511),
    [anon_sym_null] = ACTIONS(3511),
    [anon_sym_AMP] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(3511),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_LT_AT] = ACTIONS(3511),
    [anon_sym_LT_AT_AT] = ACTIONS(3509),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3511),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3511),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3511),
    [anon_sym_assert] = ACTIONS(3511),
    [anon_sym_upcast] = ACTIONS(3511),
    [anon_sym_downcast] = ACTIONS(3511),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3511),
    [anon_sym_while] = ACTIONS(3511),
    [anon_sym_if] = ACTIONS(3511),
    [anon_sym_fun] = ACTIONS(3511),
    [anon_sym_DASH_GT] = ACTIONS(3509),
    [anon_sym_try] = ACTIONS(3511),
    [anon_sym_match] = ACTIONS(3511),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3511),
    [anon_sym_use] = ACTIONS(3511),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3511),
    [anon_sym_STAR] = ACTIONS(3509),
    [anon_sym_LT2] = ACTIONS(3511),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3511),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3511),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3511),
    [sym_unit] = ACTIONS(3509),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3511),
    [sym_op_identifier] = ACTIONS(3509),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3511),
    [anon_sym_PLUS_DOT] = ACTIONS(3509),
    [anon_sym_DASH_DOT] = ACTIONS(3509),
    [anon_sym_PERCENT] = ACTIONS(3509),
    [anon_sym_AMP_AMP] = ACTIONS(3509),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3509),
    [sym_int] = ACTIONS(3511),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__newline] = ACTIONS(3509),
  },
  [4065] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10848),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4065),
    [sym_compiler_directive_decl] = STATE(4065),
    [sym_fsi_directive_decl] = STATE(4065),
    [sym_preproc_line] = STATE(4065),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6656),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4066] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10442),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4066),
    [sym_compiler_directive_decl] = STATE(4066),
    [sym_fsi_directive_decl] = STATE(4066),
    [sym_preproc_line] = STATE(4066),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6658),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4067] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10951),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4067),
    [sym_compiler_directive_decl] = STATE(4067),
    [sym_fsi_directive_decl] = STATE(4067),
    [sym_preproc_line] = STATE(4067),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6660),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4068] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10869),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4068),
    [sym_compiler_directive_decl] = STATE(4068),
    [sym_fsi_directive_decl] = STATE(4068),
    [sym_preproc_line] = STATE(4068),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6662),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4069] = {
    [sym_block_comment] = STATE(4069),
    [sym_compiler_directive_decl] = STATE(4069),
    [sym_fsi_directive_decl] = STATE(4069),
    [sym_preproc_line] = STATE(4069),
    [aux_sym_long_identifier_repeat1] = STATE(4100),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_GT_RBRACK] = ACTIONS(3492),
    [anon_sym_return] = ACTIONS(3494),
    [anon_sym_do] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_let_BANG] = ACTIONS(3492),
    [anon_sym_LPAREN] = ACTIONS(3494),
    [anon_sym_null] = ACTIONS(3494),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3492),
    [anon_sym_LBRACE] = ACTIONS(3494),
    [anon_sym_LT_AT] = ACTIONS(3494),
    [anon_sym_LT_AT_AT] = ACTIONS(3492),
    [anon_sym_DOT] = ACTIONS(6664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3492),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_return_BANG] = ACTIONS(3492),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_yield_BANG] = ACTIONS(3492),
    [anon_sym_lazy] = ACTIONS(3494),
    [anon_sym_assert] = ACTIONS(3494),
    [anon_sym_upcast] = ACTIONS(3494),
    [anon_sym_downcast] = ACTIONS(3494),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_while] = ACTIONS(3494),
    [anon_sym_if] = ACTIONS(3494),
    [anon_sym_fun] = ACTIONS(3494),
    [anon_sym_DASH_GT] = ACTIONS(3492),
    [anon_sym_try] = ACTIONS(3494),
    [anon_sym_match] = ACTIONS(3494),
    [anon_sym_match_BANG] = ACTIONS(3492),
    [anon_sym_function] = ACTIONS(3494),
    [anon_sym_use] = ACTIONS(3494),
    [anon_sym_use_BANG] = ACTIONS(3492),
    [anon_sym_do_BANG] = ACTIONS(3492),
    [anon_sym_begin] = ACTIONS(3494),
    [anon_sym_STAR] = ACTIONS(3492),
    [anon_sym_LT2] = ACTIONS(3494),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3492),
    [aux_sym_char_token1] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3494),
    [anon_sym_DQUOTE] = ACTIONS(3494),
    [anon_sym_AT_DQUOTE] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [sym_bool] = ACTIONS(3494),
    [sym_unit] = ACTIONS(3492),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3494),
    [sym_op_identifier] = ACTIONS(3492),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_PLUS_DOT] = ACTIONS(3492),
    [anon_sym_DASH_DOT] = ACTIONS(3492),
    [anon_sym_PERCENT] = ACTIONS(3492),
    [anon_sym_AMP_AMP] = ACTIONS(3492),
    [anon_sym_TILDE] = ACTIONS(3492),
    [aux_sym_prefix_op_token1] = ACTIONS(3492),
    [sym_int] = ACTIONS(3494),
    [sym_xint] = ACTIONS(3492),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3492),
    [sym__newline] = ACTIONS(3492),
  },
  [4070] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(11192),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4070),
    [sym_compiler_directive_decl] = STATE(4070),
    [sym_fsi_directive_decl] = STATE(4070),
    [sym_preproc_line] = STATE(4070),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6666),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4071] = {
    [sym_block_comment] = STATE(4071),
    [sym_compiler_directive_decl] = STATE(4071),
    [sym_fsi_directive_decl] = STATE(4071),
    [sym_preproc_line] = STATE(4071),
    [ts_builtin_sym_end] = ACTIONS(6668),
    [sym_identifier] = ACTIONS(6670),
    [anon_sym_namespace] = ACTIONS(6670),
    [anon_sym_module] = ACTIONS(6670),
    [anon_sym_open] = ACTIONS(6670),
    [anon_sym_LBRACK_LT] = ACTIONS(6668),
    [anon_sym_return] = ACTIONS(6670),
    [anon_sym_type] = ACTIONS(6670),
    [anon_sym_do] = ACTIONS(6670),
    [anon_sym_and] = ACTIONS(6670),
    [anon_sym_let] = ACTIONS(6670),
    [anon_sym_let_BANG] = ACTIONS(6668),
    [anon_sym_LPAREN] = ACTIONS(6670),
    [anon_sym_null] = ACTIONS(6670),
    [anon_sym_AMP] = ACTIONS(6670),
    [anon_sym_LBRACK] = ACTIONS(6670),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6668),
    [anon_sym_LBRACE] = ACTIONS(6670),
    [anon_sym_LT_AT] = ACTIONS(6670),
    [anon_sym_LT_AT_AT] = ACTIONS(6668),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6668),
    [anon_sym_new] = ACTIONS(6670),
    [anon_sym_return_BANG] = ACTIONS(6668),
    [anon_sym_yield] = ACTIONS(6670),
    [anon_sym_yield_BANG] = ACTIONS(6668),
    [anon_sym_lazy] = ACTIONS(6670),
    [anon_sym_assert] = ACTIONS(6670),
    [anon_sym_upcast] = ACTIONS(6670),
    [anon_sym_downcast] = ACTIONS(6670),
    [anon_sym_for] = ACTIONS(6670),
    [anon_sym_while] = ACTIONS(6670),
    [anon_sym_if] = ACTIONS(6670),
    [anon_sym_fun] = ACTIONS(6670),
    [anon_sym_try] = ACTIONS(6670),
    [anon_sym_match] = ACTIONS(6670),
    [anon_sym_match_BANG] = ACTIONS(6668),
    [anon_sym_function] = ACTIONS(6670),
    [anon_sym_use] = ACTIONS(6670),
    [anon_sym_use_BANG] = ACTIONS(6668),
    [anon_sym_do_BANG] = ACTIONS(6668),
    [anon_sym_begin] = ACTIONS(6670),
    [anon_sym_exception] = ACTIONS(6670),
    [aux_sym_char_token1] = ACTIONS(6668),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6670),
    [anon_sym_DQUOTE] = ACTIONS(6670),
    [anon_sym_AT_DQUOTE] = ACTIONS(6668),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6668),
    [sym_bool] = ACTIONS(6670),
    [sym_unit] = ACTIONS(6668),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6670),
    [sym_op_identifier] = ACTIONS(6668),
    [anon_sym_PLUS] = ACTIONS(6670),
    [anon_sym_DASH] = ACTIONS(6670),
    [anon_sym_PLUS_DOT] = ACTIONS(6668),
    [anon_sym_DASH_DOT] = ACTIONS(6668),
    [anon_sym_PERCENT] = ACTIONS(6668),
    [anon_sym_AMP_AMP] = ACTIONS(6668),
    [anon_sym_TILDE] = ACTIONS(6668),
    [aux_sym_prefix_op_token1] = ACTIONS(6668),
    [sym_int] = ACTIONS(6670),
    [sym_xint] = ACTIONS(6668),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6668),
    [anon_sym_POUNDload] = ACTIONS(6668),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6668),
  },
  [4072] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10911),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4072),
    [sym_compiler_directive_decl] = STATE(4072),
    [sym_fsi_directive_decl] = STATE(4072),
    [sym_preproc_line] = STATE(4072),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6672),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4073] = {
    [sym_block_comment] = STATE(4073),
    [sym_compiler_directive_decl] = STATE(4073),
    [sym_fsi_directive_decl] = STATE(4073),
    [sym_preproc_line] = STATE(4073),
    [ts_builtin_sym_end] = ACTIONS(6674),
    [sym_identifier] = ACTIONS(6676),
    [anon_sym_namespace] = ACTIONS(6676),
    [anon_sym_module] = ACTIONS(6676),
    [anon_sym_open] = ACTIONS(6676),
    [anon_sym_LBRACK_LT] = ACTIONS(6674),
    [anon_sym_return] = ACTIONS(6676),
    [anon_sym_type] = ACTIONS(6676),
    [anon_sym_do] = ACTIONS(6676),
    [anon_sym_and] = ACTIONS(6676),
    [anon_sym_let] = ACTIONS(6676),
    [anon_sym_let_BANG] = ACTIONS(6674),
    [anon_sym_LPAREN] = ACTIONS(6676),
    [anon_sym_null] = ACTIONS(6676),
    [anon_sym_AMP] = ACTIONS(6676),
    [anon_sym_LBRACK] = ACTIONS(6676),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6674),
    [anon_sym_LBRACE] = ACTIONS(6676),
    [anon_sym_LT_AT] = ACTIONS(6676),
    [anon_sym_LT_AT_AT] = ACTIONS(6674),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6674),
    [anon_sym_new] = ACTIONS(6676),
    [anon_sym_return_BANG] = ACTIONS(6674),
    [anon_sym_yield] = ACTIONS(6676),
    [anon_sym_yield_BANG] = ACTIONS(6674),
    [anon_sym_lazy] = ACTIONS(6676),
    [anon_sym_assert] = ACTIONS(6676),
    [anon_sym_upcast] = ACTIONS(6676),
    [anon_sym_downcast] = ACTIONS(6676),
    [anon_sym_for] = ACTIONS(6676),
    [anon_sym_while] = ACTIONS(6676),
    [anon_sym_if] = ACTIONS(6676),
    [anon_sym_fun] = ACTIONS(6676),
    [anon_sym_try] = ACTIONS(6676),
    [anon_sym_match] = ACTIONS(6676),
    [anon_sym_match_BANG] = ACTIONS(6674),
    [anon_sym_function] = ACTIONS(6676),
    [anon_sym_use] = ACTIONS(6676),
    [anon_sym_use_BANG] = ACTIONS(6674),
    [anon_sym_do_BANG] = ACTIONS(6674),
    [anon_sym_begin] = ACTIONS(6676),
    [anon_sym_exception] = ACTIONS(6676),
    [aux_sym_char_token1] = ACTIONS(6674),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6676),
    [anon_sym_DQUOTE] = ACTIONS(6676),
    [anon_sym_AT_DQUOTE] = ACTIONS(6674),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6674),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6674),
    [sym_bool] = ACTIONS(6676),
    [sym_unit] = ACTIONS(6674),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6676),
    [sym_op_identifier] = ACTIONS(6674),
    [anon_sym_PLUS] = ACTIONS(6676),
    [anon_sym_DASH] = ACTIONS(6676),
    [anon_sym_PLUS_DOT] = ACTIONS(6674),
    [anon_sym_DASH_DOT] = ACTIONS(6674),
    [anon_sym_PERCENT] = ACTIONS(6674),
    [anon_sym_AMP_AMP] = ACTIONS(6674),
    [anon_sym_TILDE] = ACTIONS(6674),
    [aux_sym_prefix_op_token1] = ACTIONS(6674),
    [sym_int] = ACTIONS(6676),
    [sym_xint] = ACTIONS(6674),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6674),
    [anon_sym_POUNDload] = ACTIONS(6674),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6674),
  },
  [4074] = {
    [sym_block_comment] = STATE(4074),
    [sym_compiler_directive_decl] = STATE(4074),
    [sym_fsi_directive_decl] = STATE(4074),
    [sym_preproc_line] = STATE(4074),
    [ts_builtin_sym_end] = ACTIONS(6678),
    [sym_identifier] = ACTIONS(6680),
    [anon_sym_namespace] = ACTIONS(6680),
    [anon_sym_module] = ACTIONS(6680),
    [anon_sym_open] = ACTIONS(6680),
    [anon_sym_LBRACK_LT] = ACTIONS(6678),
    [anon_sym_return] = ACTIONS(6680),
    [anon_sym_type] = ACTIONS(6680),
    [anon_sym_do] = ACTIONS(6680),
    [anon_sym_and] = ACTIONS(6680),
    [anon_sym_let] = ACTIONS(6680),
    [anon_sym_let_BANG] = ACTIONS(6678),
    [anon_sym_LPAREN] = ACTIONS(6680),
    [anon_sym_null] = ACTIONS(6680),
    [anon_sym_AMP] = ACTIONS(6680),
    [anon_sym_LBRACK] = ACTIONS(6680),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6678),
    [anon_sym_LBRACE] = ACTIONS(6680),
    [anon_sym_LT_AT] = ACTIONS(6680),
    [anon_sym_LT_AT_AT] = ACTIONS(6678),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6678),
    [anon_sym_new] = ACTIONS(6680),
    [anon_sym_return_BANG] = ACTIONS(6678),
    [anon_sym_yield] = ACTIONS(6680),
    [anon_sym_yield_BANG] = ACTIONS(6678),
    [anon_sym_lazy] = ACTIONS(6680),
    [anon_sym_assert] = ACTIONS(6680),
    [anon_sym_upcast] = ACTIONS(6680),
    [anon_sym_downcast] = ACTIONS(6680),
    [anon_sym_for] = ACTIONS(6680),
    [anon_sym_while] = ACTIONS(6680),
    [anon_sym_if] = ACTIONS(6680),
    [anon_sym_fun] = ACTIONS(6680),
    [anon_sym_try] = ACTIONS(6680),
    [anon_sym_match] = ACTIONS(6680),
    [anon_sym_match_BANG] = ACTIONS(6678),
    [anon_sym_function] = ACTIONS(6680),
    [anon_sym_use] = ACTIONS(6680),
    [anon_sym_use_BANG] = ACTIONS(6678),
    [anon_sym_do_BANG] = ACTIONS(6678),
    [anon_sym_begin] = ACTIONS(6680),
    [anon_sym_exception] = ACTIONS(6680),
    [aux_sym_char_token1] = ACTIONS(6678),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6680),
    [anon_sym_DQUOTE] = ACTIONS(6680),
    [anon_sym_AT_DQUOTE] = ACTIONS(6678),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6678),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6678),
    [sym_bool] = ACTIONS(6680),
    [sym_unit] = ACTIONS(6678),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6680),
    [sym_op_identifier] = ACTIONS(6678),
    [anon_sym_PLUS] = ACTIONS(6680),
    [anon_sym_DASH] = ACTIONS(6680),
    [anon_sym_PLUS_DOT] = ACTIONS(6678),
    [anon_sym_DASH_DOT] = ACTIONS(6678),
    [anon_sym_PERCENT] = ACTIONS(6678),
    [anon_sym_AMP_AMP] = ACTIONS(6678),
    [anon_sym_TILDE] = ACTIONS(6678),
    [aux_sym_prefix_op_token1] = ACTIONS(6678),
    [sym_int] = ACTIONS(6680),
    [sym_xint] = ACTIONS(6678),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6678),
    [anon_sym_POUNDload] = ACTIONS(6678),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6678),
  },
  [4075] = {
    [sym_block_comment] = STATE(4075),
    [sym_compiler_directive_decl] = STATE(4075),
    [sym_fsi_directive_decl] = STATE(4075),
    [sym_preproc_line] = STATE(4075),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_GT_RBRACK] = ACTIONS(3478),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3478),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3478),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3478),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_or] = ACTIONS(3480),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3478),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3478),
    [anon_sym_DASH_DOT] = ACTIONS(3478),
    [anon_sym_PERCENT] = ACTIONS(3478),
    [anon_sym_AMP_AMP] = ACTIONS(3478),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3478),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [sym__newline] = ACTIONS(3478),
  },
  [4076] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10831),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4076),
    [sym_compiler_directive_decl] = STATE(4076),
    [sym_fsi_directive_decl] = STATE(4076),
    [sym_preproc_line] = STATE(4076),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6682),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4077] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10805),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4077),
    [sym_compiler_directive_decl] = STATE(4077),
    [sym_fsi_directive_decl] = STATE(4077),
    [sym_preproc_line] = STATE(4077),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6684),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4078] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10454),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4078),
    [sym_compiler_directive_decl] = STATE(4078),
    [sym_fsi_directive_decl] = STATE(4078),
    [sym_preproc_line] = STATE(4078),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6686),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4079] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(11008),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4079),
    [sym_compiler_directive_decl] = STATE(4079),
    [sym_fsi_directive_decl] = STATE(4079),
    [sym_preproc_line] = STATE(4079),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6688),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4080] = {
    [sym_block_comment] = STATE(4080),
    [sym_compiler_directive_decl] = STATE(4080),
    [sym_fsi_directive_decl] = STATE(4080),
    [sym_preproc_line] = STATE(4080),
    [ts_builtin_sym_end] = ACTIONS(6690),
    [sym_identifier] = ACTIONS(6692),
    [anon_sym_namespace] = ACTIONS(6692),
    [anon_sym_module] = ACTIONS(6692),
    [anon_sym_open] = ACTIONS(6692),
    [anon_sym_LBRACK_LT] = ACTIONS(6690),
    [anon_sym_return] = ACTIONS(6692),
    [anon_sym_type] = ACTIONS(6692),
    [anon_sym_do] = ACTIONS(6692),
    [anon_sym_and] = ACTIONS(6692),
    [anon_sym_let] = ACTIONS(6692),
    [anon_sym_let_BANG] = ACTIONS(6690),
    [anon_sym_LPAREN] = ACTIONS(6692),
    [anon_sym_null] = ACTIONS(6692),
    [anon_sym_AMP] = ACTIONS(6692),
    [anon_sym_LBRACK] = ACTIONS(6692),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6690),
    [anon_sym_LBRACE] = ACTIONS(6692),
    [anon_sym_LT_AT] = ACTIONS(6692),
    [anon_sym_LT_AT_AT] = ACTIONS(6690),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6690),
    [anon_sym_new] = ACTIONS(6692),
    [anon_sym_return_BANG] = ACTIONS(6690),
    [anon_sym_yield] = ACTIONS(6692),
    [anon_sym_yield_BANG] = ACTIONS(6690),
    [anon_sym_lazy] = ACTIONS(6692),
    [anon_sym_assert] = ACTIONS(6692),
    [anon_sym_upcast] = ACTIONS(6692),
    [anon_sym_downcast] = ACTIONS(6692),
    [anon_sym_for] = ACTIONS(6692),
    [anon_sym_while] = ACTIONS(6692),
    [anon_sym_if] = ACTIONS(6692),
    [anon_sym_fun] = ACTIONS(6692),
    [anon_sym_try] = ACTIONS(6692),
    [anon_sym_match] = ACTIONS(6692),
    [anon_sym_match_BANG] = ACTIONS(6690),
    [anon_sym_function] = ACTIONS(6692),
    [anon_sym_use] = ACTIONS(6692),
    [anon_sym_use_BANG] = ACTIONS(6690),
    [anon_sym_do_BANG] = ACTIONS(6690),
    [anon_sym_begin] = ACTIONS(6692),
    [anon_sym_exception] = ACTIONS(6692),
    [aux_sym_char_token1] = ACTIONS(6690),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6692),
    [anon_sym_DQUOTE] = ACTIONS(6692),
    [anon_sym_AT_DQUOTE] = ACTIONS(6690),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6690),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6690),
    [sym_bool] = ACTIONS(6692),
    [sym_unit] = ACTIONS(6690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6692),
    [sym_op_identifier] = ACTIONS(6690),
    [anon_sym_PLUS] = ACTIONS(6692),
    [anon_sym_DASH] = ACTIONS(6692),
    [anon_sym_PLUS_DOT] = ACTIONS(6690),
    [anon_sym_DASH_DOT] = ACTIONS(6690),
    [anon_sym_PERCENT] = ACTIONS(6690),
    [anon_sym_AMP_AMP] = ACTIONS(6690),
    [anon_sym_TILDE] = ACTIONS(6690),
    [aux_sym_prefix_op_token1] = ACTIONS(6690),
    [sym_int] = ACTIONS(6692),
    [sym_xint] = ACTIONS(6690),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6690),
    [anon_sym_POUNDload] = ACTIONS(6690),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6690),
  },
  [4081] = {
    [sym_block_comment] = STATE(4081),
    [sym_compiler_directive_decl] = STATE(4081),
    [sym_fsi_directive_decl] = STATE(4081),
    [sym_preproc_line] = STATE(4081),
    [ts_builtin_sym_end] = ACTIONS(6694),
    [sym_identifier] = ACTIONS(6696),
    [anon_sym_namespace] = ACTIONS(6696),
    [anon_sym_module] = ACTIONS(6696),
    [anon_sym_open] = ACTIONS(6696),
    [anon_sym_LBRACK_LT] = ACTIONS(6694),
    [anon_sym_return] = ACTIONS(6696),
    [anon_sym_type] = ACTIONS(6696),
    [anon_sym_do] = ACTIONS(6696),
    [anon_sym_and] = ACTIONS(6696),
    [anon_sym_let] = ACTIONS(6696),
    [anon_sym_let_BANG] = ACTIONS(6694),
    [anon_sym_LPAREN] = ACTIONS(6696),
    [anon_sym_null] = ACTIONS(6696),
    [anon_sym_AMP] = ACTIONS(6696),
    [anon_sym_LBRACK] = ACTIONS(6696),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6694),
    [anon_sym_LBRACE] = ACTIONS(6696),
    [anon_sym_LT_AT] = ACTIONS(6696),
    [anon_sym_LT_AT_AT] = ACTIONS(6694),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6694),
    [anon_sym_new] = ACTIONS(6696),
    [anon_sym_return_BANG] = ACTIONS(6694),
    [anon_sym_yield] = ACTIONS(6696),
    [anon_sym_yield_BANG] = ACTIONS(6694),
    [anon_sym_lazy] = ACTIONS(6696),
    [anon_sym_assert] = ACTIONS(6696),
    [anon_sym_upcast] = ACTIONS(6696),
    [anon_sym_downcast] = ACTIONS(6696),
    [anon_sym_for] = ACTIONS(6696),
    [anon_sym_while] = ACTIONS(6696),
    [anon_sym_if] = ACTIONS(6696),
    [anon_sym_fun] = ACTIONS(6696),
    [anon_sym_try] = ACTIONS(6696),
    [anon_sym_match] = ACTIONS(6696),
    [anon_sym_match_BANG] = ACTIONS(6694),
    [anon_sym_function] = ACTIONS(6696),
    [anon_sym_use] = ACTIONS(6696),
    [anon_sym_use_BANG] = ACTIONS(6694),
    [anon_sym_do_BANG] = ACTIONS(6694),
    [anon_sym_begin] = ACTIONS(6696),
    [anon_sym_exception] = ACTIONS(6696),
    [aux_sym_char_token1] = ACTIONS(6694),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6696),
    [anon_sym_DQUOTE] = ACTIONS(6696),
    [anon_sym_AT_DQUOTE] = ACTIONS(6694),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6694),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6694),
    [sym_bool] = ACTIONS(6696),
    [sym_unit] = ACTIONS(6694),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6696),
    [sym_op_identifier] = ACTIONS(6694),
    [anon_sym_PLUS] = ACTIONS(6696),
    [anon_sym_DASH] = ACTIONS(6696),
    [anon_sym_PLUS_DOT] = ACTIONS(6694),
    [anon_sym_DASH_DOT] = ACTIONS(6694),
    [anon_sym_PERCENT] = ACTIONS(6694),
    [anon_sym_AMP_AMP] = ACTIONS(6694),
    [anon_sym_TILDE] = ACTIONS(6694),
    [aux_sym_prefix_op_token1] = ACTIONS(6694),
    [sym_int] = ACTIONS(6696),
    [sym_xint] = ACTIONS(6694),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6694),
    [anon_sym_POUNDload] = ACTIONS(6694),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6694),
  },
  [4082] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10786),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4082),
    [sym_compiler_directive_decl] = STATE(4082),
    [sym_fsi_directive_decl] = STATE(4082),
    [sym_preproc_line] = STATE(4082),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6698),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4083] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10762),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4083),
    [sym_compiler_directive_decl] = STATE(4083),
    [sym_fsi_directive_decl] = STATE(4083),
    [sym_preproc_line] = STATE(4083),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6700),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4084] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10744),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4084),
    [sym_compiler_directive_decl] = STATE(4084),
    [sym_fsi_directive_decl] = STATE(4084),
    [sym_preproc_line] = STATE(4084),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6702),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4085] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10464),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4085),
    [sym_compiler_directive_decl] = STATE(4085),
    [sym_fsi_directive_decl] = STATE(4085),
    [sym_preproc_line] = STATE(4085),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6704),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4086] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(11146),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4086),
    [sym_compiler_directive_decl] = STATE(4086),
    [sym_fsi_directive_decl] = STATE(4086),
    [sym_preproc_line] = STATE(4086),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6706),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4087] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(11675),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4087),
    [sym_compiler_directive_decl] = STATE(4087),
    [sym_fsi_directive_decl] = STATE(4087),
    [sym_preproc_line] = STATE(4087),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6708),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4088] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(11359),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4088),
    [sym_compiler_directive_decl] = STATE(4088),
    [sym_fsi_directive_decl] = STATE(4088),
    [sym_preproc_line] = STATE(4088),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6710),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4089] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10722),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4089),
    [sym_compiler_directive_decl] = STATE(4089),
    [sym_fsi_directive_decl] = STATE(4089),
    [sym_preproc_line] = STATE(4089),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6712),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4090] = {
    [sym_argument_patterns] = STATE(9998),
    [sym__atomic_pattern] = STATE(6294),
    [sym_list_pattern] = STATE(6228),
    [sym_array_pattern] = STATE(6228),
    [sym_record_pattern] = STATE(6228),
    [sym_type_arguments] = STATE(4311),
    [sym_char] = STATE(6237),
    [sym_format_string] = STATE(6238),
    [sym__string_literal] = STATE(6238),
    [sym_string] = STATE(6237),
    [sym_verbatim_string] = STATE(6237),
    [sym_bytearray] = STATE(6237),
    [sym_verbatim_bytearray] = STATE(6237),
    [sym_format_triple_quoted_string] = STATE(6239),
    [sym_triple_quoted_string] = STATE(6237),
    [sym_const] = STATE(6228),
    [sym_long_identifier] = STATE(6228),
    [sym_sbyte] = STATE(6237),
    [sym_byte] = STATE(6237),
    [sym_int16] = STATE(6237),
    [sym_uint16] = STATE(6237),
    [sym_int32] = STATE(6237),
    [sym_uint32] = STATE(6237),
    [sym_nativeint] = STATE(6237),
    [sym_unativeint] = STATE(6237),
    [sym_int64] = STATE(6237),
    [sym_uint64] = STATE(6237),
    [sym_ieee32] = STATE(6237),
    [sym_ieee64] = STATE(6237),
    [sym_bignum] = STATE(6237),
    [sym_decimal] = STATE(6237),
    [sym_float] = STATE(5738),
    [sym_block_comment] = STATE(4090),
    [sym_compiler_directive_decl] = STATE(4090),
    [sym_fsi_directive_decl] = STATE(4090),
    [sym_preproc_line] = STATE(4090),
    [aux_sym_argument_patterns_repeat1] = STATE(4301),
    [sym_identifier] = ACTIONS(6714),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_LBRACK_LT] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_as] = ACTIONS(4228),
    [anon_sym_LPAREN] = ACTIONS(6716),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(6718),
    [anon_sym__] = ACTIONS(6718),
    [anon_sym_QMARK] = ACTIONS(4226),
    [anon_sym_COLON_QMARK] = ACTIONS(4226),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_PIPE] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4226),
    [anon_sym_LBRACK] = ACTIONS(6720),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6722),
    [anon_sym_LBRACE] = ACTIONS(6724),
    [anon_sym_LT2] = ACTIONS(6726),
    [aux_sym_char_token1] = ACTIONS(6728),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6730),
    [anon_sym_DQUOTE] = ACTIONS(6732),
    [anon_sym_AT_DQUOTE] = ACTIONS(6734),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6738),
    [sym_bool] = ACTIONS(6740),
    [sym_unit] = ACTIONS(6742),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4226),
    [sym_int] = ACTIONS(6744),
    [sym_xint] = ACTIONS(6746),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4091] = {
    [sym_block_comment] = STATE(4091),
    [sym_compiler_directive_decl] = STATE(4091),
    [sym_fsi_directive_decl] = STATE(4091),
    [sym_preproc_line] = STATE(4091),
    [ts_builtin_sym_end] = ACTIONS(6748),
    [sym_identifier] = ACTIONS(6750),
    [anon_sym_namespace] = ACTIONS(6750),
    [anon_sym_module] = ACTIONS(6750),
    [anon_sym_open] = ACTIONS(6750),
    [anon_sym_LBRACK_LT] = ACTIONS(6748),
    [anon_sym_return] = ACTIONS(6750),
    [anon_sym_type] = ACTIONS(6750),
    [anon_sym_do] = ACTIONS(6750),
    [anon_sym_and] = ACTIONS(6750),
    [anon_sym_let] = ACTIONS(6750),
    [anon_sym_let_BANG] = ACTIONS(6748),
    [anon_sym_LPAREN] = ACTIONS(6750),
    [anon_sym_null] = ACTIONS(6750),
    [anon_sym_AMP] = ACTIONS(6750),
    [anon_sym_LBRACK] = ACTIONS(6750),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6748),
    [anon_sym_LBRACE] = ACTIONS(6750),
    [anon_sym_LT_AT] = ACTIONS(6750),
    [anon_sym_LT_AT_AT] = ACTIONS(6748),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6748),
    [anon_sym_new] = ACTIONS(6750),
    [anon_sym_return_BANG] = ACTIONS(6748),
    [anon_sym_yield] = ACTIONS(6750),
    [anon_sym_yield_BANG] = ACTIONS(6748),
    [anon_sym_lazy] = ACTIONS(6750),
    [anon_sym_assert] = ACTIONS(6750),
    [anon_sym_upcast] = ACTIONS(6750),
    [anon_sym_downcast] = ACTIONS(6750),
    [anon_sym_for] = ACTIONS(6750),
    [anon_sym_while] = ACTIONS(6750),
    [anon_sym_if] = ACTIONS(6750),
    [anon_sym_fun] = ACTIONS(6750),
    [anon_sym_try] = ACTIONS(6750),
    [anon_sym_match] = ACTIONS(6750),
    [anon_sym_match_BANG] = ACTIONS(6748),
    [anon_sym_function] = ACTIONS(6750),
    [anon_sym_use] = ACTIONS(6750),
    [anon_sym_use_BANG] = ACTIONS(6748),
    [anon_sym_do_BANG] = ACTIONS(6748),
    [anon_sym_begin] = ACTIONS(6750),
    [anon_sym_exception] = ACTIONS(6750),
    [aux_sym_char_token1] = ACTIONS(6748),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6750),
    [anon_sym_DQUOTE] = ACTIONS(6750),
    [anon_sym_AT_DQUOTE] = ACTIONS(6748),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6748),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6748),
    [sym_bool] = ACTIONS(6750),
    [sym_unit] = ACTIONS(6748),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6750),
    [sym_op_identifier] = ACTIONS(6748),
    [anon_sym_PLUS] = ACTIONS(6750),
    [anon_sym_DASH] = ACTIONS(6750),
    [anon_sym_PLUS_DOT] = ACTIONS(6748),
    [anon_sym_DASH_DOT] = ACTIONS(6748),
    [anon_sym_PERCENT] = ACTIONS(6748),
    [anon_sym_AMP_AMP] = ACTIONS(6748),
    [anon_sym_TILDE] = ACTIONS(6748),
    [aux_sym_prefix_op_token1] = ACTIONS(6748),
    [sym_int] = ACTIONS(6750),
    [sym_xint] = ACTIONS(6748),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6748),
    [anon_sym_POUNDload] = ACTIONS(6748),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6748),
  },
  [4092] = {
    [sym_block_comment] = STATE(4092),
    [sym_compiler_directive_decl] = STATE(4092),
    [sym_fsi_directive_decl] = STATE(4092),
    [sym_preproc_line] = STATE(4092),
    [ts_builtin_sym_end] = ACTIONS(6752),
    [sym_identifier] = ACTIONS(6754),
    [anon_sym_namespace] = ACTIONS(6754),
    [anon_sym_module] = ACTIONS(6754),
    [anon_sym_open] = ACTIONS(6754),
    [anon_sym_LBRACK_LT] = ACTIONS(6752),
    [anon_sym_return] = ACTIONS(6754),
    [anon_sym_type] = ACTIONS(6754),
    [anon_sym_do] = ACTIONS(6754),
    [anon_sym_and] = ACTIONS(6754),
    [anon_sym_let] = ACTIONS(6754),
    [anon_sym_let_BANG] = ACTIONS(6752),
    [anon_sym_LPAREN] = ACTIONS(6754),
    [anon_sym_null] = ACTIONS(6754),
    [anon_sym_AMP] = ACTIONS(6754),
    [anon_sym_LBRACK] = ACTIONS(6754),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6752),
    [anon_sym_LBRACE] = ACTIONS(6754),
    [anon_sym_LT_AT] = ACTIONS(6754),
    [anon_sym_LT_AT_AT] = ACTIONS(6752),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6752),
    [anon_sym_new] = ACTIONS(6754),
    [anon_sym_return_BANG] = ACTIONS(6752),
    [anon_sym_yield] = ACTIONS(6754),
    [anon_sym_yield_BANG] = ACTIONS(6752),
    [anon_sym_lazy] = ACTIONS(6754),
    [anon_sym_assert] = ACTIONS(6754),
    [anon_sym_upcast] = ACTIONS(6754),
    [anon_sym_downcast] = ACTIONS(6754),
    [anon_sym_for] = ACTIONS(6754),
    [anon_sym_while] = ACTIONS(6754),
    [anon_sym_if] = ACTIONS(6754),
    [anon_sym_fun] = ACTIONS(6754),
    [anon_sym_try] = ACTIONS(6754),
    [anon_sym_match] = ACTIONS(6754),
    [anon_sym_match_BANG] = ACTIONS(6752),
    [anon_sym_function] = ACTIONS(6754),
    [anon_sym_use] = ACTIONS(6754),
    [anon_sym_use_BANG] = ACTIONS(6752),
    [anon_sym_do_BANG] = ACTIONS(6752),
    [anon_sym_begin] = ACTIONS(6754),
    [anon_sym_exception] = ACTIONS(6754),
    [aux_sym_char_token1] = ACTIONS(6752),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6754),
    [anon_sym_DQUOTE] = ACTIONS(6754),
    [anon_sym_AT_DQUOTE] = ACTIONS(6752),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6752),
    [sym_bool] = ACTIONS(6754),
    [sym_unit] = ACTIONS(6752),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6754),
    [sym_op_identifier] = ACTIONS(6752),
    [anon_sym_PLUS] = ACTIONS(6754),
    [anon_sym_DASH] = ACTIONS(6754),
    [anon_sym_PLUS_DOT] = ACTIONS(6752),
    [anon_sym_DASH_DOT] = ACTIONS(6752),
    [anon_sym_PERCENT] = ACTIONS(6752),
    [anon_sym_AMP_AMP] = ACTIONS(6752),
    [anon_sym_TILDE] = ACTIONS(6752),
    [aux_sym_prefix_op_token1] = ACTIONS(6752),
    [sym_int] = ACTIONS(6754),
    [sym_xint] = ACTIONS(6752),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6752),
    [anon_sym_POUNDload] = ACTIONS(6752),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6752),
  },
  [4093] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10473),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4093),
    [sym_compiler_directive_decl] = STATE(4093),
    [sym_fsi_directive_decl] = STATE(4093),
    [sym_preproc_line] = STATE(4093),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6756),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4094] = {
    [sym_block_comment] = STATE(4094),
    [sym_compiler_directive_decl] = STATE(4094),
    [sym_fsi_directive_decl] = STATE(4094),
    [sym_preproc_line] = STATE(4094),
    [aux_sym_long_identifier_repeat1] = STATE(4094),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_GT_RBRACK] = ACTIONS(3485),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3485),
    [anon_sym_DOT] = ACTIONS(6758),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3485),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3485),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3485),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3485),
    [anon_sym_DASH_DOT] = ACTIONS(3485),
    [anon_sym_PERCENT] = ACTIONS(3485),
    [anon_sym_AMP_AMP] = ACTIONS(3485),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3485),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [4095] = {
    [sym_block_comment] = STATE(4095),
    [sym_compiler_directive_decl] = STATE(4095),
    [sym_fsi_directive_decl] = STATE(4095),
    [sym_preproc_line] = STATE(4095),
    [ts_builtin_sym_end] = ACTIONS(6761),
    [sym_identifier] = ACTIONS(6763),
    [anon_sym_namespace] = ACTIONS(6763),
    [anon_sym_module] = ACTIONS(6763),
    [anon_sym_open] = ACTIONS(6763),
    [anon_sym_LBRACK_LT] = ACTIONS(6761),
    [anon_sym_return] = ACTIONS(6763),
    [anon_sym_type] = ACTIONS(6763),
    [anon_sym_do] = ACTIONS(6763),
    [anon_sym_and] = ACTIONS(6763),
    [anon_sym_let] = ACTIONS(6763),
    [anon_sym_let_BANG] = ACTIONS(6761),
    [anon_sym_LPAREN] = ACTIONS(6763),
    [anon_sym_null] = ACTIONS(6763),
    [anon_sym_AMP] = ACTIONS(6763),
    [anon_sym_LBRACK] = ACTIONS(6763),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6761),
    [anon_sym_LBRACE] = ACTIONS(6763),
    [anon_sym_LT_AT] = ACTIONS(6763),
    [anon_sym_LT_AT_AT] = ACTIONS(6761),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6761),
    [anon_sym_new] = ACTIONS(6763),
    [anon_sym_return_BANG] = ACTIONS(6761),
    [anon_sym_yield] = ACTIONS(6763),
    [anon_sym_yield_BANG] = ACTIONS(6761),
    [anon_sym_lazy] = ACTIONS(6763),
    [anon_sym_assert] = ACTIONS(6763),
    [anon_sym_upcast] = ACTIONS(6763),
    [anon_sym_downcast] = ACTIONS(6763),
    [anon_sym_for] = ACTIONS(6763),
    [anon_sym_while] = ACTIONS(6763),
    [anon_sym_if] = ACTIONS(6763),
    [anon_sym_fun] = ACTIONS(6763),
    [anon_sym_try] = ACTIONS(6763),
    [anon_sym_match] = ACTIONS(6763),
    [anon_sym_match_BANG] = ACTIONS(6761),
    [anon_sym_function] = ACTIONS(6763),
    [anon_sym_use] = ACTIONS(6763),
    [anon_sym_use_BANG] = ACTIONS(6761),
    [anon_sym_do_BANG] = ACTIONS(6761),
    [anon_sym_begin] = ACTIONS(6763),
    [anon_sym_exception] = ACTIONS(6763),
    [aux_sym_char_token1] = ACTIONS(6761),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6763),
    [anon_sym_DQUOTE] = ACTIONS(6763),
    [anon_sym_AT_DQUOTE] = ACTIONS(6761),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6761),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6761),
    [sym_bool] = ACTIONS(6763),
    [sym_unit] = ACTIONS(6761),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6763),
    [sym_op_identifier] = ACTIONS(6761),
    [anon_sym_PLUS] = ACTIONS(6763),
    [anon_sym_DASH] = ACTIONS(6763),
    [anon_sym_PLUS_DOT] = ACTIONS(6761),
    [anon_sym_DASH_DOT] = ACTIONS(6761),
    [anon_sym_PERCENT] = ACTIONS(6761),
    [anon_sym_AMP_AMP] = ACTIONS(6761),
    [anon_sym_TILDE] = ACTIONS(6761),
    [aux_sym_prefix_op_token1] = ACTIONS(6761),
    [sym_int] = ACTIONS(6763),
    [sym_xint] = ACTIONS(6761),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6761),
    [anon_sym_POUNDload] = ACTIONS(6761),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6761),
  },
  [4096] = {
    [sym_type_arguments] = STATE(4201),
    [sym_long_identifier] = STATE(4208),
    [sym_block_comment] = STATE(4096),
    [sym_compiler_directive_decl] = STATE(4096),
    [sym_fsi_directive_decl] = STATE(4096),
    [sym_preproc_line] = STATE(4096),
    [aux_sym_compound_type_repeat1] = STATE(4185),
    [sym_identifier] = ACTIONS(6765),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_let] = ACTIONS(3419),
    [anon_sym_let_BANG] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(3419),
    [anon_sym_null] = ACTIONS(3419),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_LT_AT] = ACTIONS(3419),
    [anon_sym_LT_AT_AT] = ACTIONS(3417),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_return_BANG] = ACTIONS(3417),
    [anon_sym_yield] = ACTIONS(3419),
    [anon_sym_yield_BANG] = ACTIONS(3417),
    [anon_sym_lazy] = ACTIONS(3419),
    [anon_sym_assert] = ACTIONS(3419),
    [anon_sym_upcast] = ACTIONS(3419),
    [anon_sym_downcast] = ACTIONS(3419),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_fun] = ACTIONS(3419),
    [anon_sym_DASH_GT] = ACTIONS(2680),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_match] = ACTIONS(3419),
    [anon_sym_match_BANG] = ACTIONS(3417),
    [anon_sym_function] = ACTIONS(3419),
    [anon_sym_use] = ACTIONS(3419),
    [anon_sym_use_BANG] = ACTIONS(3417),
    [anon_sym_do_BANG] = ACTIONS(3417),
    [anon_sym_begin] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(2682),
    [anon_sym_LT2] = ACTIONS(2684),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2686),
    [aux_sym_char_token1] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3419),
    [anon_sym_AT_DQUOTE] = ACTIONS(3417),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3417),
    [sym_bool] = ACTIONS(3419),
    [sym_unit] = ACTIONS(3417),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3419),
    [sym_op_identifier] = ACTIONS(3417),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_PLUS_DOT] = ACTIONS(3417),
    [anon_sym_DASH_DOT] = ACTIONS(3417),
    [anon_sym_PERCENT] = ACTIONS(3417),
    [anon_sym_AMP_AMP] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3417),
    [aux_sym_prefix_op_token1] = ACTIONS(3417),
    [sym_int] = ACTIONS(3419),
    [sym_xint] = ACTIONS(3417),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3417),
    [sym__dedent] = ACTIONS(3417),
  },
  [4097] = {
    [sym_block_comment] = STATE(4097),
    [sym_compiler_directive_decl] = STATE(4097),
    [sym_fsi_directive_decl] = STATE(4097),
    [sym_preproc_line] = STATE(4097),
    [ts_builtin_sym_end] = ACTIONS(6767),
    [sym_identifier] = ACTIONS(6769),
    [anon_sym_namespace] = ACTIONS(6769),
    [anon_sym_module] = ACTIONS(6769),
    [anon_sym_open] = ACTIONS(6769),
    [anon_sym_LBRACK_LT] = ACTIONS(6767),
    [anon_sym_return] = ACTIONS(6769),
    [anon_sym_type] = ACTIONS(6769),
    [anon_sym_do] = ACTIONS(6769),
    [anon_sym_and] = ACTIONS(6769),
    [anon_sym_let] = ACTIONS(6769),
    [anon_sym_let_BANG] = ACTIONS(6767),
    [anon_sym_LPAREN] = ACTIONS(6769),
    [anon_sym_null] = ACTIONS(6769),
    [anon_sym_AMP] = ACTIONS(6769),
    [anon_sym_LBRACK] = ACTIONS(6769),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6767),
    [anon_sym_LBRACE] = ACTIONS(6769),
    [anon_sym_LT_AT] = ACTIONS(6769),
    [anon_sym_LT_AT_AT] = ACTIONS(6767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6767),
    [anon_sym_new] = ACTIONS(6769),
    [anon_sym_return_BANG] = ACTIONS(6767),
    [anon_sym_yield] = ACTIONS(6769),
    [anon_sym_yield_BANG] = ACTIONS(6767),
    [anon_sym_lazy] = ACTIONS(6769),
    [anon_sym_assert] = ACTIONS(6769),
    [anon_sym_upcast] = ACTIONS(6769),
    [anon_sym_downcast] = ACTIONS(6769),
    [anon_sym_for] = ACTIONS(6769),
    [anon_sym_while] = ACTIONS(6769),
    [anon_sym_if] = ACTIONS(6769),
    [anon_sym_fun] = ACTIONS(6769),
    [anon_sym_try] = ACTIONS(6769),
    [anon_sym_match] = ACTIONS(6769),
    [anon_sym_match_BANG] = ACTIONS(6767),
    [anon_sym_function] = ACTIONS(6769),
    [anon_sym_use] = ACTIONS(6769),
    [anon_sym_use_BANG] = ACTIONS(6767),
    [anon_sym_do_BANG] = ACTIONS(6767),
    [anon_sym_begin] = ACTIONS(6769),
    [anon_sym_exception] = ACTIONS(6769),
    [aux_sym_char_token1] = ACTIONS(6767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6769),
    [anon_sym_DQUOTE] = ACTIONS(6769),
    [anon_sym_AT_DQUOTE] = ACTIONS(6767),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6767),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6767),
    [sym_bool] = ACTIONS(6769),
    [sym_unit] = ACTIONS(6767),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6769),
    [sym_op_identifier] = ACTIONS(6767),
    [anon_sym_PLUS] = ACTIONS(6769),
    [anon_sym_DASH] = ACTIONS(6769),
    [anon_sym_PLUS_DOT] = ACTIONS(6767),
    [anon_sym_DASH_DOT] = ACTIONS(6767),
    [anon_sym_PERCENT] = ACTIONS(6767),
    [anon_sym_AMP_AMP] = ACTIONS(6767),
    [anon_sym_TILDE] = ACTIONS(6767),
    [aux_sym_prefix_op_token1] = ACTIONS(6767),
    [sym_int] = ACTIONS(6769),
    [sym_xint] = ACTIONS(6767),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6767),
    [anon_sym_POUNDload] = ACTIONS(6767),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6767),
  },
  [4098] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10481),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4098),
    [sym_compiler_directive_decl] = STATE(4098),
    [sym_fsi_directive_decl] = STATE(4098),
    [sym_preproc_line] = STATE(4098),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6771),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4099] = {
    [sym_block_comment] = STATE(4099),
    [sym_compiler_directive_decl] = STATE(4099),
    [sym_fsi_directive_decl] = STATE(4099),
    [sym_preproc_line] = STATE(4099),
    [ts_builtin_sym_end] = ACTIONS(6539),
    [sym_identifier] = ACTIONS(6541),
    [anon_sym_namespace] = ACTIONS(6541),
    [anon_sym_module] = ACTIONS(6541),
    [anon_sym_open] = ACTIONS(6541),
    [anon_sym_LBRACK_LT] = ACTIONS(6539),
    [anon_sym_return] = ACTIONS(6541),
    [anon_sym_type] = ACTIONS(6541),
    [anon_sym_do] = ACTIONS(6541),
    [anon_sym_and] = ACTIONS(6541),
    [anon_sym_let] = ACTIONS(6541),
    [anon_sym_let_BANG] = ACTIONS(6539),
    [anon_sym_LPAREN] = ACTIONS(6541),
    [anon_sym_null] = ACTIONS(6541),
    [anon_sym_AMP] = ACTIONS(6541),
    [anon_sym_LBRACK] = ACTIONS(6541),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6539),
    [anon_sym_LBRACE] = ACTIONS(6541),
    [anon_sym_LT_AT] = ACTIONS(6541),
    [anon_sym_LT_AT_AT] = ACTIONS(6539),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6539),
    [anon_sym_new] = ACTIONS(6541),
    [anon_sym_return_BANG] = ACTIONS(6539),
    [anon_sym_yield] = ACTIONS(6541),
    [anon_sym_yield_BANG] = ACTIONS(6539),
    [anon_sym_lazy] = ACTIONS(6541),
    [anon_sym_assert] = ACTIONS(6541),
    [anon_sym_upcast] = ACTIONS(6541),
    [anon_sym_downcast] = ACTIONS(6541),
    [anon_sym_for] = ACTIONS(6541),
    [anon_sym_while] = ACTIONS(6541),
    [anon_sym_if] = ACTIONS(6541),
    [anon_sym_fun] = ACTIONS(6541),
    [anon_sym_try] = ACTIONS(6541),
    [anon_sym_match] = ACTIONS(6541),
    [anon_sym_match_BANG] = ACTIONS(6539),
    [anon_sym_function] = ACTIONS(6541),
    [anon_sym_use] = ACTIONS(6541),
    [anon_sym_use_BANG] = ACTIONS(6539),
    [anon_sym_do_BANG] = ACTIONS(6539),
    [anon_sym_begin] = ACTIONS(6541),
    [anon_sym_exception] = ACTIONS(6541),
    [aux_sym_char_token1] = ACTIONS(6539),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6541),
    [anon_sym_DQUOTE] = ACTIONS(6541),
    [anon_sym_AT_DQUOTE] = ACTIONS(6539),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6539),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6539),
    [sym_bool] = ACTIONS(6541),
    [sym_unit] = ACTIONS(6539),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6541),
    [sym_op_identifier] = ACTIONS(6539),
    [anon_sym_PLUS] = ACTIONS(6541),
    [anon_sym_DASH] = ACTIONS(6541),
    [anon_sym_PLUS_DOT] = ACTIONS(6539),
    [anon_sym_DASH_DOT] = ACTIONS(6539),
    [anon_sym_PERCENT] = ACTIONS(6539),
    [anon_sym_AMP_AMP] = ACTIONS(6539),
    [anon_sym_TILDE] = ACTIONS(6539),
    [aux_sym_prefix_op_token1] = ACTIONS(6539),
    [sym_int] = ACTIONS(6541),
    [sym_xint] = ACTIONS(6539),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6539),
    [anon_sym_POUNDload] = ACTIONS(6539),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6539),
  },
  [4100] = {
    [sym_block_comment] = STATE(4100),
    [sym_compiler_directive_decl] = STATE(4100),
    [sym_fsi_directive_decl] = STATE(4100),
    [sym_preproc_line] = STATE(4100),
    [aux_sym_long_identifier_repeat1] = STATE(4094),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_GT_RBRACK] = ACTIONS(3449),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3449),
    [anon_sym_DOT] = ACTIONS(6664),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_DASH_GT] = ACTIONS(3449),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_STAR] = ACTIONS(3449),
    [anon_sym_LT2] = ACTIONS(3451),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3449),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3449),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3449),
    [anon_sym_DASH_DOT] = ACTIONS(3449),
    [anon_sym_PERCENT] = ACTIONS(3449),
    [anon_sym_AMP_AMP] = ACTIONS(3449),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3449),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [sym__newline] = ACTIONS(3449),
  },
  [4101] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10490),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4101),
    [sym_compiler_directive_decl] = STATE(4101),
    [sym_fsi_directive_decl] = STATE(4101),
    [sym_preproc_line] = STATE(4101),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6773),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4102] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10701),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4102),
    [sym_compiler_directive_decl] = STATE(4102),
    [sym_fsi_directive_decl] = STATE(4102),
    [sym_preproc_line] = STATE(4102),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6775),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4103] = {
    [sym_argument_patterns] = STATE(9800),
    [sym__atomic_pattern] = STATE(6294),
    [sym_list_pattern] = STATE(6228),
    [sym_array_pattern] = STATE(6228),
    [sym_record_pattern] = STATE(6228),
    [sym_type_arguments] = STATE(4318),
    [sym_char] = STATE(6237),
    [sym_format_string] = STATE(6238),
    [sym__string_literal] = STATE(6238),
    [sym_string] = STATE(6237),
    [sym_verbatim_string] = STATE(6237),
    [sym_bytearray] = STATE(6237),
    [sym_verbatim_bytearray] = STATE(6237),
    [sym_format_triple_quoted_string] = STATE(6239),
    [sym_triple_quoted_string] = STATE(6237),
    [sym_const] = STATE(6228),
    [sym_long_identifier] = STATE(6228),
    [sym_sbyte] = STATE(6237),
    [sym_byte] = STATE(6237),
    [sym_int16] = STATE(6237),
    [sym_uint16] = STATE(6237),
    [sym_int32] = STATE(6237),
    [sym_uint32] = STATE(6237),
    [sym_nativeint] = STATE(6237),
    [sym_unativeint] = STATE(6237),
    [sym_int64] = STATE(6237),
    [sym_uint64] = STATE(6237),
    [sym_ieee32] = STATE(6237),
    [sym_ieee64] = STATE(6237),
    [sym_bignum] = STATE(6237),
    [sym_decimal] = STATE(6237),
    [sym_float] = STATE(5738),
    [sym_block_comment] = STATE(4103),
    [sym_compiler_directive_decl] = STATE(4103),
    [sym_fsi_directive_decl] = STATE(4103),
    [sym_preproc_line] = STATE(4103),
    [aux_sym_argument_patterns_repeat1] = STATE(4301),
    [sym_identifier] = ACTIONS(6714),
    [anon_sym_EQ] = ACTIONS(4226),
    [anon_sym_LBRACK_LT] = ACTIONS(4226),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_as] = ACTIONS(4228),
    [anon_sym_LPAREN] = ACTIONS(6716),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_null] = ACTIONS(6718),
    [anon_sym__] = ACTIONS(6718),
    [anon_sym_QMARK] = ACTIONS(4226),
    [anon_sym_COLON_QMARK] = ACTIONS(4226),
    [anon_sym_COLON_COLON] = ACTIONS(4226),
    [anon_sym_PIPE] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4226),
    [anon_sym_LBRACK] = ACTIONS(6720),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6722),
    [anon_sym_LBRACE] = ACTIONS(6724),
    [anon_sym_LT2] = ACTIONS(6726),
    [aux_sym_char_token1] = ACTIONS(6728),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6730),
    [anon_sym_DQUOTE] = ACTIONS(6732),
    [anon_sym_AT_DQUOTE] = ACTIONS(6734),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6738),
    [sym_bool] = ACTIONS(6740),
    [sym_unit] = ACTIONS(6742),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4228),
    [sym_op_identifier] = ACTIONS(4226),
    [sym_int] = ACTIONS(6744),
    [sym_xint] = ACTIONS(6746),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4104] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10688),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4104),
    [sym_compiler_directive_decl] = STATE(4104),
    [sym_fsi_directive_decl] = STATE(4104),
    [sym_preproc_line] = STATE(4104),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6777),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4105] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10501),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4105),
    [sym_compiler_directive_decl] = STATE(4105),
    [sym_fsi_directive_decl] = STATE(4105),
    [sym_preproc_line] = STATE(4105),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6779),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4106] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(11857),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4106),
    [sym_compiler_directive_decl] = STATE(4106),
    [sym_fsi_directive_decl] = STATE(4106),
    [sym_preproc_line] = STATE(4106),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6781),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4107] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10671),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4107),
    [sym_compiler_directive_decl] = STATE(4107),
    [sym_fsi_directive_decl] = STATE(4107),
    [sym_preproc_line] = STATE(4107),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6783),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4108] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(11101),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4108),
    [sym_compiler_directive_decl] = STATE(4108),
    [sym_fsi_directive_decl] = STATE(4108),
    [sym_preproc_line] = STATE(4108),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6785),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4109] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10510),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4109),
    [sym_compiler_directive_decl] = STATE(4109),
    [sym_fsi_directive_decl] = STATE(4109),
    [sym_preproc_line] = STATE(4109),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6787),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4110] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10520),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4110),
    [sym_compiler_directive_decl] = STATE(4110),
    [sym_fsi_directive_decl] = STATE(4110),
    [sym_preproc_line] = STATE(4110),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6789),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4111] = {
    [sym_block_comment] = STATE(4111),
    [sym_compiler_directive_decl] = STATE(4111),
    [sym_fsi_directive_decl] = STATE(4111),
    [sym_preproc_line] = STATE(4111),
    [ts_builtin_sym_end] = ACTIONS(6791),
    [sym_identifier] = ACTIONS(6793),
    [anon_sym_namespace] = ACTIONS(6793),
    [anon_sym_module] = ACTIONS(6793),
    [anon_sym_open] = ACTIONS(6793),
    [anon_sym_LBRACK_LT] = ACTIONS(6791),
    [anon_sym_return] = ACTIONS(6793),
    [anon_sym_type] = ACTIONS(6793),
    [anon_sym_do] = ACTIONS(6793),
    [anon_sym_and] = ACTIONS(6793),
    [anon_sym_let] = ACTIONS(6793),
    [anon_sym_let_BANG] = ACTIONS(6791),
    [anon_sym_LPAREN] = ACTIONS(6793),
    [anon_sym_null] = ACTIONS(6793),
    [anon_sym_AMP] = ACTIONS(6793),
    [anon_sym_LBRACK] = ACTIONS(6793),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6791),
    [anon_sym_LBRACE] = ACTIONS(6793),
    [anon_sym_LT_AT] = ACTIONS(6793),
    [anon_sym_LT_AT_AT] = ACTIONS(6791),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6791),
    [anon_sym_new] = ACTIONS(6793),
    [anon_sym_return_BANG] = ACTIONS(6791),
    [anon_sym_yield] = ACTIONS(6793),
    [anon_sym_yield_BANG] = ACTIONS(6791),
    [anon_sym_lazy] = ACTIONS(6793),
    [anon_sym_assert] = ACTIONS(6793),
    [anon_sym_upcast] = ACTIONS(6793),
    [anon_sym_downcast] = ACTIONS(6793),
    [anon_sym_for] = ACTIONS(6793),
    [anon_sym_while] = ACTIONS(6793),
    [anon_sym_if] = ACTIONS(6793),
    [anon_sym_fun] = ACTIONS(6793),
    [anon_sym_try] = ACTIONS(6793),
    [anon_sym_match] = ACTIONS(6793),
    [anon_sym_match_BANG] = ACTIONS(6791),
    [anon_sym_function] = ACTIONS(6793),
    [anon_sym_use] = ACTIONS(6793),
    [anon_sym_use_BANG] = ACTIONS(6791),
    [anon_sym_do_BANG] = ACTIONS(6791),
    [anon_sym_begin] = ACTIONS(6793),
    [anon_sym_exception] = ACTIONS(6793),
    [aux_sym_char_token1] = ACTIONS(6791),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6793),
    [anon_sym_DQUOTE] = ACTIONS(6793),
    [anon_sym_AT_DQUOTE] = ACTIONS(6791),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6791),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6791),
    [sym_bool] = ACTIONS(6793),
    [sym_unit] = ACTIONS(6791),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6793),
    [sym_op_identifier] = ACTIONS(6791),
    [anon_sym_PLUS] = ACTIONS(6793),
    [anon_sym_DASH] = ACTIONS(6793),
    [anon_sym_PLUS_DOT] = ACTIONS(6791),
    [anon_sym_DASH_DOT] = ACTIONS(6791),
    [anon_sym_PERCENT] = ACTIONS(6791),
    [anon_sym_AMP_AMP] = ACTIONS(6791),
    [anon_sym_TILDE] = ACTIONS(6791),
    [aux_sym_prefix_op_token1] = ACTIONS(6791),
    [sym_int] = ACTIONS(6793),
    [sym_xint] = ACTIONS(6791),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6791),
    [anon_sym_POUNDload] = ACTIONS(6791),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6791),
  },
  [4112] = {
    [sym_block_comment] = STATE(4112),
    [sym_compiler_directive_decl] = STATE(4112),
    [sym_fsi_directive_decl] = STATE(4112),
    [sym_preproc_line] = STATE(4112),
    [aux_sym_type_argument_repeat1] = STATE(4123),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3496),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3496),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3496),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [anon_sym_or] = ACTIONS(6795),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3496),
    [anon_sym_DASH_DOT] = ACTIONS(3496),
    [anon_sym_PERCENT] = ACTIONS(3496),
    [anon_sym_AMP_AMP] = ACTIONS(3496),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3496),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [sym__dedent] = ACTIONS(3496),
  },
  [4113] = {
    [sym_block_comment] = STATE(4113),
    [sym_compiler_directive_decl] = STATE(4113),
    [sym_fsi_directive_decl] = STATE(4113),
    [sym_preproc_line] = STATE(4113),
    [ts_builtin_sym_end] = ACTIONS(6797),
    [sym_identifier] = ACTIONS(6799),
    [anon_sym_namespace] = ACTIONS(6799),
    [anon_sym_module] = ACTIONS(6799),
    [anon_sym_open] = ACTIONS(6799),
    [anon_sym_LBRACK_LT] = ACTIONS(6797),
    [anon_sym_return] = ACTIONS(6799),
    [anon_sym_type] = ACTIONS(6799),
    [anon_sym_do] = ACTIONS(6799),
    [anon_sym_and] = ACTIONS(6799),
    [anon_sym_let] = ACTIONS(6799),
    [anon_sym_let_BANG] = ACTIONS(6797),
    [anon_sym_LPAREN] = ACTIONS(6799),
    [anon_sym_null] = ACTIONS(6799),
    [anon_sym_AMP] = ACTIONS(6799),
    [anon_sym_LBRACK] = ACTIONS(6799),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6797),
    [anon_sym_LBRACE] = ACTIONS(6799),
    [anon_sym_LT_AT] = ACTIONS(6799),
    [anon_sym_LT_AT_AT] = ACTIONS(6797),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6797),
    [anon_sym_new] = ACTIONS(6799),
    [anon_sym_return_BANG] = ACTIONS(6797),
    [anon_sym_yield] = ACTIONS(6799),
    [anon_sym_yield_BANG] = ACTIONS(6797),
    [anon_sym_lazy] = ACTIONS(6799),
    [anon_sym_assert] = ACTIONS(6799),
    [anon_sym_upcast] = ACTIONS(6799),
    [anon_sym_downcast] = ACTIONS(6799),
    [anon_sym_for] = ACTIONS(6799),
    [anon_sym_while] = ACTIONS(6799),
    [anon_sym_if] = ACTIONS(6799),
    [anon_sym_fun] = ACTIONS(6799),
    [anon_sym_try] = ACTIONS(6799),
    [anon_sym_match] = ACTIONS(6799),
    [anon_sym_match_BANG] = ACTIONS(6797),
    [anon_sym_function] = ACTIONS(6799),
    [anon_sym_use] = ACTIONS(6799),
    [anon_sym_use_BANG] = ACTIONS(6797),
    [anon_sym_do_BANG] = ACTIONS(6797),
    [anon_sym_begin] = ACTIONS(6799),
    [anon_sym_exception] = ACTIONS(6799),
    [aux_sym_char_token1] = ACTIONS(6797),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6799),
    [anon_sym_DQUOTE] = ACTIONS(6799),
    [anon_sym_AT_DQUOTE] = ACTIONS(6797),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6797),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6797),
    [sym_bool] = ACTIONS(6799),
    [sym_unit] = ACTIONS(6797),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6799),
    [sym_op_identifier] = ACTIONS(6797),
    [anon_sym_PLUS] = ACTIONS(6799),
    [anon_sym_DASH] = ACTIONS(6799),
    [anon_sym_PLUS_DOT] = ACTIONS(6797),
    [anon_sym_DASH_DOT] = ACTIONS(6797),
    [anon_sym_PERCENT] = ACTIONS(6797),
    [anon_sym_AMP_AMP] = ACTIONS(6797),
    [anon_sym_TILDE] = ACTIONS(6797),
    [aux_sym_prefix_op_token1] = ACTIONS(6797),
    [sym_int] = ACTIONS(6799),
    [sym_xint] = ACTIONS(6797),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6797),
    [anon_sym_POUNDload] = ACTIONS(6797),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6797),
  },
  [4114] = {
    [sym_block_comment] = STATE(4114),
    [sym_compiler_directive_decl] = STATE(4114),
    [sym_fsi_directive_decl] = STATE(4114),
    [sym_preproc_line] = STATE(4114),
    [ts_builtin_sym_end] = ACTIONS(6801),
    [sym_identifier] = ACTIONS(6803),
    [anon_sym_namespace] = ACTIONS(6803),
    [anon_sym_module] = ACTIONS(6803),
    [anon_sym_open] = ACTIONS(6803),
    [anon_sym_LBRACK_LT] = ACTIONS(6801),
    [anon_sym_return] = ACTIONS(6803),
    [anon_sym_type] = ACTIONS(6803),
    [anon_sym_do] = ACTIONS(6803),
    [anon_sym_and] = ACTIONS(6803),
    [anon_sym_let] = ACTIONS(6803),
    [anon_sym_let_BANG] = ACTIONS(6801),
    [anon_sym_LPAREN] = ACTIONS(6803),
    [anon_sym_null] = ACTIONS(6803),
    [anon_sym_AMP] = ACTIONS(6803),
    [anon_sym_LBRACK] = ACTIONS(6803),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6801),
    [anon_sym_LBRACE] = ACTIONS(6803),
    [anon_sym_LT_AT] = ACTIONS(6803),
    [anon_sym_LT_AT_AT] = ACTIONS(6801),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6801),
    [anon_sym_new] = ACTIONS(6803),
    [anon_sym_return_BANG] = ACTIONS(6801),
    [anon_sym_yield] = ACTIONS(6803),
    [anon_sym_yield_BANG] = ACTIONS(6801),
    [anon_sym_lazy] = ACTIONS(6803),
    [anon_sym_assert] = ACTIONS(6803),
    [anon_sym_upcast] = ACTIONS(6803),
    [anon_sym_downcast] = ACTIONS(6803),
    [anon_sym_for] = ACTIONS(6803),
    [anon_sym_while] = ACTIONS(6803),
    [anon_sym_if] = ACTIONS(6803),
    [anon_sym_fun] = ACTIONS(6803),
    [anon_sym_try] = ACTIONS(6803),
    [anon_sym_match] = ACTIONS(6803),
    [anon_sym_match_BANG] = ACTIONS(6801),
    [anon_sym_function] = ACTIONS(6803),
    [anon_sym_use] = ACTIONS(6803),
    [anon_sym_use_BANG] = ACTIONS(6801),
    [anon_sym_do_BANG] = ACTIONS(6801),
    [anon_sym_begin] = ACTIONS(6803),
    [anon_sym_exception] = ACTIONS(6803),
    [aux_sym_char_token1] = ACTIONS(6801),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6803),
    [anon_sym_DQUOTE] = ACTIONS(6803),
    [anon_sym_AT_DQUOTE] = ACTIONS(6801),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6801),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6801),
    [sym_bool] = ACTIONS(6803),
    [sym_unit] = ACTIONS(6801),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6803),
    [sym_op_identifier] = ACTIONS(6801),
    [anon_sym_PLUS] = ACTIONS(6803),
    [anon_sym_DASH] = ACTIONS(6803),
    [anon_sym_PLUS_DOT] = ACTIONS(6801),
    [anon_sym_DASH_DOT] = ACTIONS(6801),
    [anon_sym_PERCENT] = ACTIONS(6801),
    [anon_sym_AMP_AMP] = ACTIONS(6801),
    [anon_sym_TILDE] = ACTIONS(6801),
    [aux_sym_prefix_op_token1] = ACTIONS(6801),
    [sym_int] = ACTIONS(6803),
    [sym_xint] = ACTIONS(6801),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6801),
    [anon_sym_POUNDload] = ACTIONS(6801),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6801),
  },
  [4115] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10462),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4115),
    [sym_compiler_directive_decl] = STATE(4115),
    [sym_fsi_directive_decl] = STATE(4115),
    [sym_preproc_line] = STATE(4115),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6805),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4116] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(11150),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4116),
    [sym_compiler_directive_decl] = STATE(4116),
    [sym_fsi_directive_decl] = STATE(4116),
    [sym_preproc_line] = STATE(4116),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6807),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4117] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10541),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4117),
    [sym_compiler_directive_decl] = STATE(4117),
    [sym_fsi_directive_decl] = STATE(4117),
    [sym_preproc_line] = STATE(4117),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6809),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4118] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10550),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4118),
    [sym_compiler_directive_decl] = STATE(4118),
    [sym_fsi_directive_decl] = STATE(4118),
    [sym_preproc_line] = STATE(4118),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6811),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4119] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10561),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4119),
    [sym_compiler_directive_decl] = STATE(4119),
    [sym_fsi_directive_decl] = STATE(4119),
    [sym_preproc_line] = STATE(4119),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6813),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4120] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10571),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4120),
    [sym_compiler_directive_decl] = STATE(4120),
    [sym_fsi_directive_decl] = STATE(4120),
    [sym_preproc_line] = STATE(4120),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6815),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4121] = {
    [sym_type_arguments] = STATE(4201),
    [sym_long_identifier] = STATE(4208),
    [sym_block_comment] = STATE(4121),
    [sym_compiler_directive_decl] = STATE(4121),
    [sym_fsi_directive_decl] = STATE(4121),
    [sym_preproc_line] = STATE(4121),
    [aux_sym_compound_type_repeat1] = STATE(4185),
    [sym_identifier] = ACTIONS(6765),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_let] = ACTIONS(3431),
    [anon_sym_let_BANG] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(3431),
    [anon_sym_null] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_LT_AT] = ACTIONS(3431),
    [anon_sym_LT_AT_AT] = ACTIONS(3429),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_return_BANG] = ACTIONS(3429),
    [anon_sym_yield] = ACTIONS(3431),
    [anon_sym_yield_BANG] = ACTIONS(3429),
    [anon_sym_lazy] = ACTIONS(3431),
    [anon_sym_assert] = ACTIONS(3431),
    [anon_sym_upcast] = ACTIONS(3431),
    [anon_sym_downcast] = ACTIONS(3431),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_fun] = ACTIONS(3431),
    [anon_sym_DASH_GT] = ACTIONS(2680),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_match] = ACTIONS(3431),
    [anon_sym_match_BANG] = ACTIONS(3429),
    [anon_sym_function] = ACTIONS(3431),
    [anon_sym_use] = ACTIONS(3431),
    [anon_sym_use_BANG] = ACTIONS(3429),
    [anon_sym_do_BANG] = ACTIONS(3429),
    [anon_sym_begin] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(2682),
    [anon_sym_LT2] = ACTIONS(2684),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2686),
    [aux_sym_char_token1] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [anon_sym_AT_DQUOTE] = ACTIONS(3429),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3429),
    [sym_bool] = ACTIONS(3431),
    [sym_unit] = ACTIONS(3429),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3431),
    [sym_op_identifier] = ACTIONS(3429),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_PLUS_DOT] = ACTIONS(3429),
    [anon_sym_DASH_DOT] = ACTIONS(3429),
    [anon_sym_PERCENT] = ACTIONS(3429),
    [anon_sym_AMP_AMP] = ACTIONS(3429),
    [anon_sym_TILDE] = ACTIONS(3429),
    [aux_sym_prefix_op_token1] = ACTIONS(3429),
    [sym_int] = ACTIONS(3431),
    [sym_xint] = ACTIONS(3429),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3429),
    [sym__dedent] = ACTIONS(3429),
  },
  [4122] = {
    [sym_block_comment] = STATE(4122),
    [sym_compiler_directive_decl] = STATE(4122),
    [sym_fsi_directive_decl] = STATE(4122),
    [sym_preproc_line] = STATE(4122),
    [ts_builtin_sym_end] = ACTIONS(6817),
    [sym_identifier] = ACTIONS(6819),
    [anon_sym_namespace] = ACTIONS(6819),
    [anon_sym_module] = ACTIONS(6819),
    [anon_sym_open] = ACTIONS(6819),
    [anon_sym_LBRACK_LT] = ACTIONS(6817),
    [anon_sym_return] = ACTIONS(6819),
    [anon_sym_type] = ACTIONS(6819),
    [anon_sym_do] = ACTIONS(6819),
    [anon_sym_and] = ACTIONS(6819),
    [anon_sym_let] = ACTIONS(6819),
    [anon_sym_let_BANG] = ACTIONS(6817),
    [anon_sym_LPAREN] = ACTIONS(6819),
    [anon_sym_null] = ACTIONS(6819),
    [anon_sym_AMP] = ACTIONS(6819),
    [anon_sym_LBRACK] = ACTIONS(6819),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6817),
    [anon_sym_LBRACE] = ACTIONS(6819),
    [anon_sym_LT_AT] = ACTIONS(6819),
    [anon_sym_LT_AT_AT] = ACTIONS(6817),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6817),
    [anon_sym_new] = ACTIONS(6819),
    [anon_sym_return_BANG] = ACTIONS(6817),
    [anon_sym_yield] = ACTIONS(6819),
    [anon_sym_yield_BANG] = ACTIONS(6817),
    [anon_sym_lazy] = ACTIONS(6819),
    [anon_sym_assert] = ACTIONS(6819),
    [anon_sym_upcast] = ACTIONS(6819),
    [anon_sym_downcast] = ACTIONS(6819),
    [anon_sym_for] = ACTIONS(6819),
    [anon_sym_while] = ACTIONS(6819),
    [anon_sym_if] = ACTIONS(6819),
    [anon_sym_fun] = ACTIONS(6819),
    [anon_sym_try] = ACTIONS(6819),
    [anon_sym_match] = ACTIONS(6819),
    [anon_sym_match_BANG] = ACTIONS(6817),
    [anon_sym_function] = ACTIONS(6819),
    [anon_sym_use] = ACTIONS(6819),
    [anon_sym_use_BANG] = ACTIONS(6817),
    [anon_sym_do_BANG] = ACTIONS(6817),
    [anon_sym_begin] = ACTIONS(6819),
    [anon_sym_exception] = ACTIONS(6819),
    [aux_sym_char_token1] = ACTIONS(6817),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6819),
    [anon_sym_DQUOTE] = ACTIONS(6819),
    [anon_sym_AT_DQUOTE] = ACTIONS(6817),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6817),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6817),
    [sym_bool] = ACTIONS(6819),
    [sym_unit] = ACTIONS(6817),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6819),
    [sym_op_identifier] = ACTIONS(6817),
    [anon_sym_PLUS] = ACTIONS(6819),
    [anon_sym_DASH] = ACTIONS(6819),
    [anon_sym_PLUS_DOT] = ACTIONS(6817),
    [anon_sym_DASH_DOT] = ACTIONS(6817),
    [anon_sym_PERCENT] = ACTIONS(6817),
    [anon_sym_AMP_AMP] = ACTIONS(6817),
    [anon_sym_TILDE] = ACTIONS(6817),
    [aux_sym_prefix_op_token1] = ACTIONS(6817),
    [sym_int] = ACTIONS(6819),
    [sym_xint] = ACTIONS(6817),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6817),
    [anon_sym_POUNDload] = ACTIONS(6817),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6817),
  },
  [4123] = {
    [sym_block_comment] = STATE(4123),
    [sym_compiler_directive_decl] = STATE(4123),
    [sym_fsi_directive_decl] = STATE(4123),
    [sym_preproc_line] = STATE(4123),
    [aux_sym_type_argument_repeat1] = STATE(4125),
    [sym_identifier] = ACTIONS(3476),
    [anon_sym_return] = ACTIONS(3476),
    [anon_sym_do] = ACTIONS(3476),
    [anon_sym_let] = ACTIONS(3476),
    [anon_sym_let_BANG] = ACTIONS(3474),
    [anon_sym_LPAREN] = ACTIONS(3476),
    [anon_sym_null] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym_LBRACK] = ACTIONS(3476),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3474),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_LT_AT] = ACTIONS(3476),
    [anon_sym_LT_AT_AT] = ACTIONS(3474),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3474),
    [anon_sym_new] = ACTIONS(3476),
    [anon_sym_return_BANG] = ACTIONS(3474),
    [anon_sym_yield] = ACTIONS(3476),
    [anon_sym_yield_BANG] = ACTIONS(3474),
    [anon_sym_lazy] = ACTIONS(3476),
    [anon_sym_assert] = ACTIONS(3476),
    [anon_sym_upcast] = ACTIONS(3476),
    [anon_sym_downcast] = ACTIONS(3476),
    [anon_sym_COLON_GT] = ACTIONS(3474),
    [anon_sym_for] = ACTIONS(3476),
    [anon_sym_while] = ACTIONS(3476),
    [anon_sym_if] = ACTIONS(3476),
    [anon_sym_fun] = ACTIONS(3476),
    [anon_sym_DASH_GT] = ACTIONS(3474),
    [anon_sym_try] = ACTIONS(3476),
    [anon_sym_match] = ACTIONS(3476),
    [anon_sym_match_BANG] = ACTIONS(3474),
    [anon_sym_function] = ACTIONS(3476),
    [anon_sym_use] = ACTIONS(3476),
    [anon_sym_use_BANG] = ACTIONS(3474),
    [anon_sym_do_BANG] = ACTIONS(3474),
    [anon_sym_begin] = ACTIONS(3476),
    [anon_sym_STAR] = ACTIONS(3474),
    [anon_sym_LT2] = ACTIONS(3476),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3474),
    [anon_sym_or] = ACTIONS(6795),
    [aux_sym_char_token1] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3476),
    [anon_sym_DQUOTE] = ACTIONS(3476),
    [anon_sym_AT_DQUOTE] = ACTIONS(3474),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3474),
    [sym_bool] = ACTIONS(3476),
    [sym_unit] = ACTIONS(3474),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3476),
    [sym_op_identifier] = ACTIONS(3474),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3476),
    [anon_sym_PLUS_DOT] = ACTIONS(3474),
    [anon_sym_DASH_DOT] = ACTIONS(3474),
    [anon_sym_PERCENT] = ACTIONS(3474),
    [anon_sym_AMP_AMP] = ACTIONS(3474),
    [anon_sym_TILDE] = ACTIONS(3474),
    [aux_sym_prefix_op_token1] = ACTIONS(3474),
    [sym_int] = ACTIONS(3476),
    [sym_xint] = ACTIONS(3474),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3474),
    [sym__dedent] = ACTIONS(3474),
  },
  [4124] = {
    [sym_block_comment] = STATE(4124),
    [sym_compiler_directive_decl] = STATE(4124),
    [sym_fsi_directive_decl] = STATE(4124),
    [sym_preproc_line] = STATE(4124),
    [ts_builtin_sym_end] = ACTIONS(6821),
    [sym_identifier] = ACTIONS(6823),
    [anon_sym_namespace] = ACTIONS(6823),
    [anon_sym_module] = ACTIONS(6823),
    [anon_sym_open] = ACTIONS(6823),
    [anon_sym_LBRACK_LT] = ACTIONS(6821),
    [anon_sym_return] = ACTIONS(6823),
    [anon_sym_type] = ACTIONS(6823),
    [anon_sym_do] = ACTIONS(6823),
    [anon_sym_and] = ACTIONS(6823),
    [anon_sym_let] = ACTIONS(6823),
    [anon_sym_let_BANG] = ACTIONS(6821),
    [anon_sym_LPAREN] = ACTIONS(6823),
    [anon_sym_null] = ACTIONS(6823),
    [anon_sym_AMP] = ACTIONS(6823),
    [anon_sym_LBRACK] = ACTIONS(6823),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6821),
    [anon_sym_LBRACE] = ACTIONS(6823),
    [anon_sym_LT_AT] = ACTIONS(6823),
    [anon_sym_LT_AT_AT] = ACTIONS(6821),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6821),
    [anon_sym_new] = ACTIONS(6823),
    [anon_sym_return_BANG] = ACTIONS(6821),
    [anon_sym_yield] = ACTIONS(6823),
    [anon_sym_yield_BANG] = ACTIONS(6821),
    [anon_sym_lazy] = ACTIONS(6823),
    [anon_sym_assert] = ACTIONS(6823),
    [anon_sym_upcast] = ACTIONS(6823),
    [anon_sym_downcast] = ACTIONS(6823),
    [anon_sym_for] = ACTIONS(6823),
    [anon_sym_while] = ACTIONS(6823),
    [anon_sym_if] = ACTIONS(6823),
    [anon_sym_fun] = ACTIONS(6823),
    [anon_sym_try] = ACTIONS(6823),
    [anon_sym_match] = ACTIONS(6823),
    [anon_sym_match_BANG] = ACTIONS(6821),
    [anon_sym_function] = ACTIONS(6823),
    [anon_sym_use] = ACTIONS(6823),
    [anon_sym_use_BANG] = ACTIONS(6821),
    [anon_sym_do_BANG] = ACTIONS(6821),
    [anon_sym_begin] = ACTIONS(6823),
    [anon_sym_exception] = ACTIONS(6823),
    [aux_sym_char_token1] = ACTIONS(6821),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6823),
    [anon_sym_DQUOTE] = ACTIONS(6823),
    [anon_sym_AT_DQUOTE] = ACTIONS(6821),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6821),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6821),
    [sym_bool] = ACTIONS(6823),
    [sym_unit] = ACTIONS(6821),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6823),
    [sym_op_identifier] = ACTIONS(6821),
    [anon_sym_PLUS] = ACTIONS(6823),
    [anon_sym_DASH] = ACTIONS(6823),
    [anon_sym_PLUS_DOT] = ACTIONS(6821),
    [anon_sym_DASH_DOT] = ACTIONS(6821),
    [anon_sym_PERCENT] = ACTIONS(6821),
    [anon_sym_AMP_AMP] = ACTIONS(6821),
    [anon_sym_TILDE] = ACTIONS(6821),
    [aux_sym_prefix_op_token1] = ACTIONS(6821),
    [sym_int] = ACTIONS(6823),
    [sym_xint] = ACTIONS(6821),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6821),
    [anon_sym_POUNDload] = ACTIONS(6821),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6821),
  },
  [4125] = {
    [sym_block_comment] = STATE(4125),
    [sym_compiler_directive_decl] = STATE(4125),
    [sym_fsi_directive_decl] = STATE(4125),
    [sym_preproc_line] = STATE(4125),
    [aux_sym_type_argument_repeat1] = STATE(4125),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3478),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3478),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3478),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_or] = ACTIONS(6825),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3478),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3478),
    [anon_sym_DASH_DOT] = ACTIONS(3478),
    [anon_sym_PERCENT] = ACTIONS(3478),
    [anon_sym_AMP_AMP] = ACTIONS(3478),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3478),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [sym__dedent] = ACTIONS(3478),
  },
  [4126] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10530),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4126),
    [sym_compiler_directive_decl] = STATE(4126),
    [sym_fsi_directive_decl] = STATE(4126),
    [sym_preproc_line] = STATE(4126),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6828),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4127] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(11445),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4127),
    [sym_compiler_directive_decl] = STATE(4127),
    [sym_fsi_directive_decl] = STATE(4127),
    [sym_preproc_line] = STATE(4127),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6830),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4128] = {
    [sym_type_arguments] = STATE(4201),
    [sym_long_identifier] = STATE(4208),
    [sym_block_comment] = STATE(4128),
    [sym_compiler_directive_decl] = STATE(4128),
    [sym_fsi_directive_decl] = STATE(4128),
    [sym_preproc_line] = STATE(4128),
    [aux_sym_compound_type_repeat1] = STATE(4185),
    [sym_identifier] = ACTIONS(6765),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3425),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(2680),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(2682),
    [anon_sym_LT2] = ACTIONS(2684),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2686),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3425),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3425),
    [anon_sym_DASH_DOT] = ACTIONS(3425),
    [anon_sym_PERCENT] = ACTIONS(3425),
    [anon_sym_AMP_AMP] = ACTIONS(3425),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3425),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [sym__dedent] = ACTIONS(3425),
  },
  [4129] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10598),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4129),
    [sym_compiler_directive_decl] = STATE(4129),
    [sym_fsi_directive_decl] = STATE(4129),
    [sym_preproc_line] = STATE(4129),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6832),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4130] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10590),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4130),
    [sym_compiler_directive_decl] = STATE(4130),
    [sym_fsi_directive_decl] = STATE(4130),
    [sym_preproc_line] = STATE(4130),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6834),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4131] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(11777),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4131),
    [sym_compiler_directive_decl] = STATE(4131),
    [sym_fsi_directive_decl] = STATE(4131),
    [sym_preproc_line] = STATE(4131),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6836),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4132] = {
    [sym_type_arguments] = STATE(4201),
    [sym_long_identifier] = STATE(4208),
    [sym_block_comment] = STATE(4132),
    [sym_compiler_directive_decl] = STATE(4132),
    [sym_fsi_directive_decl] = STATE(4132),
    [sym_preproc_line] = STATE(4132),
    [aux_sym_compound_type_repeat1] = STATE(4185),
    [sym_identifier] = ACTIONS(6765),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_let_BANG] = ACTIONS(3403),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_null] = ACTIONS(3407),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3407),
    [anon_sym_LT_AT] = ACTIONS(3407),
    [anon_sym_LT_AT_AT] = ACTIONS(3403),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_return_BANG] = ACTIONS(3403),
    [anon_sym_yield] = ACTIONS(3407),
    [anon_sym_yield_BANG] = ACTIONS(3403),
    [anon_sym_lazy] = ACTIONS(3407),
    [anon_sym_assert] = ACTIONS(3407),
    [anon_sym_upcast] = ACTIONS(3407),
    [anon_sym_downcast] = ACTIONS(3407),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_fun] = ACTIONS(3407),
    [anon_sym_DASH_GT] = ACTIONS(2680),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_match] = ACTIONS(3407),
    [anon_sym_match_BANG] = ACTIONS(3403),
    [anon_sym_function] = ACTIONS(3407),
    [anon_sym_use] = ACTIONS(3407),
    [anon_sym_use_BANG] = ACTIONS(3403),
    [anon_sym_do_BANG] = ACTIONS(3403),
    [anon_sym_begin] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(2682),
    [anon_sym_LT2] = ACTIONS(2684),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2686),
    [aux_sym_char_token1] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3407),
    [anon_sym_DQUOTE] = ACTIONS(3407),
    [anon_sym_AT_DQUOTE] = ACTIONS(3403),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3403),
    [sym_bool] = ACTIONS(3407),
    [sym_unit] = ACTIONS(3403),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3407),
    [sym_op_identifier] = ACTIONS(3403),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_PLUS_DOT] = ACTIONS(3403),
    [anon_sym_DASH_DOT] = ACTIONS(3403),
    [anon_sym_PERCENT] = ACTIONS(3403),
    [anon_sym_AMP_AMP] = ACTIONS(3403),
    [anon_sym_TILDE] = ACTIONS(3403),
    [aux_sym_prefix_op_token1] = ACTIONS(3403),
    [sym_int] = ACTIONS(3407),
    [sym_xint] = ACTIONS(3403),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3403),
    [sym__dedent] = ACTIONS(3403),
  },
  [4133] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10622),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4133),
    [sym_compiler_directive_decl] = STATE(4133),
    [sym_fsi_directive_decl] = STATE(4133),
    [sym_preproc_line] = STATE(4133),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6838),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4134] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10633),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4134),
    [sym_compiler_directive_decl] = STATE(4134),
    [sym_fsi_directive_decl] = STATE(4134),
    [sym_preproc_line] = STATE(4134),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6840),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4135] = {
    [sym_block_comment] = STATE(4135),
    [sym_compiler_directive_decl] = STATE(4135),
    [sym_fsi_directive_decl] = STATE(4135),
    [sym_preproc_line] = STATE(4135),
    [ts_builtin_sym_end] = ACTIONS(6842),
    [sym_identifier] = ACTIONS(6844),
    [anon_sym_namespace] = ACTIONS(6844),
    [anon_sym_module] = ACTIONS(6844),
    [anon_sym_open] = ACTIONS(6844),
    [anon_sym_LBRACK_LT] = ACTIONS(6842),
    [anon_sym_return] = ACTIONS(6844),
    [anon_sym_type] = ACTIONS(6844),
    [anon_sym_do] = ACTIONS(6844),
    [anon_sym_and] = ACTIONS(6844),
    [anon_sym_let] = ACTIONS(6844),
    [anon_sym_let_BANG] = ACTIONS(6842),
    [anon_sym_LPAREN] = ACTIONS(6844),
    [anon_sym_null] = ACTIONS(6844),
    [anon_sym_AMP] = ACTIONS(6844),
    [anon_sym_LBRACK] = ACTIONS(6844),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6842),
    [anon_sym_LBRACE] = ACTIONS(6844),
    [anon_sym_LT_AT] = ACTIONS(6844),
    [anon_sym_LT_AT_AT] = ACTIONS(6842),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6842),
    [anon_sym_new] = ACTIONS(6844),
    [anon_sym_return_BANG] = ACTIONS(6842),
    [anon_sym_yield] = ACTIONS(6844),
    [anon_sym_yield_BANG] = ACTIONS(6842),
    [anon_sym_lazy] = ACTIONS(6844),
    [anon_sym_assert] = ACTIONS(6844),
    [anon_sym_upcast] = ACTIONS(6844),
    [anon_sym_downcast] = ACTIONS(6844),
    [anon_sym_for] = ACTIONS(6844),
    [anon_sym_while] = ACTIONS(6844),
    [anon_sym_if] = ACTIONS(6844),
    [anon_sym_fun] = ACTIONS(6844),
    [anon_sym_try] = ACTIONS(6844),
    [anon_sym_match] = ACTIONS(6844),
    [anon_sym_match_BANG] = ACTIONS(6842),
    [anon_sym_function] = ACTIONS(6844),
    [anon_sym_use] = ACTIONS(6844),
    [anon_sym_use_BANG] = ACTIONS(6842),
    [anon_sym_do_BANG] = ACTIONS(6842),
    [anon_sym_begin] = ACTIONS(6844),
    [anon_sym_exception] = ACTIONS(6844),
    [aux_sym_char_token1] = ACTIONS(6842),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6844),
    [anon_sym_DQUOTE] = ACTIONS(6844),
    [anon_sym_AT_DQUOTE] = ACTIONS(6842),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6842),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6842),
    [sym_bool] = ACTIONS(6844),
    [sym_unit] = ACTIONS(6842),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6844),
    [sym_op_identifier] = ACTIONS(6842),
    [anon_sym_PLUS] = ACTIONS(6844),
    [anon_sym_DASH] = ACTIONS(6844),
    [anon_sym_PLUS_DOT] = ACTIONS(6842),
    [anon_sym_DASH_DOT] = ACTIONS(6842),
    [anon_sym_PERCENT] = ACTIONS(6842),
    [anon_sym_AMP_AMP] = ACTIONS(6842),
    [anon_sym_TILDE] = ACTIONS(6842),
    [aux_sym_prefix_op_token1] = ACTIONS(6842),
    [sym_int] = ACTIONS(6844),
    [sym_xint] = ACTIONS(6842),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6842),
    [anon_sym_POUNDload] = ACTIONS(6842),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6842),
  },
  [4136] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10647),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4136),
    [sym_compiler_directive_decl] = STATE(4136),
    [sym_fsi_directive_decl] = STATE(4136),
    [sym_preproc_line] = STATE(4136),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6846),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4137] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10661),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4137),
    [sym_compiler_directive_decl] = STATE(4137),
    [sym_fsi_directive_decl] = STATE(4137),
    [sym_preproc_line] = STATE(4137),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6848),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4138] = {
    [sym_block_comment] = STATE(4138),
    [sym_compiler_directive_decl] = STATE(4138),
    [sym_fsi_directive_decl] = STATE(4138),
    [sym_preproc_line] = STATE(4138),
    [ts_builtin_sym_end] = ACTIONS(6850),
    [sym_identifier] = ACTIONS(6852),
    [anon_sym_namespace] = ACTIONS(6852),
    [anon_sym_module] = ACTIONS(6852),
    [anon_sym_open] = ACTIONS(6852),
    [anon_sym_LBRACK_LT] = ACTIONS(6850),
    [anon_sym_return] = ACTIONS(6852),
    [anon_sym_type] = ACTIONS(6852),
    [anon_sym_do] = ACTIONS(6852),
    [anon_sym_and] = ACTIONS(6852),
    [anon_sym_let] = ACTIONS(6852),
    [anon_sym_let_BANG] = ACTIONS(6850),
    [anon_sym_LPAREN] = ACTIONS(6852),
    [anon_sym_null] = ACTIONS(6852),
    [anon_sym_AMP] = ACTIONS(6852),
    [anon_sym_LBRACK] = ACTIONS(6852),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6850),
    [anon_sym_LBRACE] = ACTIONS(6852),
    [anon_sym_LT_AT] = ACTIONS(6852),
    [anon_sym_LT_AT_AT] = ACTIONS(6850),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6850),
    [anon_sym_new] = ACTIONS(6852),
    [anon_sym_return_BANG] = ACTIONS(6850),
    [anon_sym_yield] = ACTIONS(6852),
    [anon_sym_yield_BANG] = ACTIONS(6850),
    [anon_sym_lazy] = ACTIONS(6852),
    [anon_sym_assert] = ACTIONS(6852),
    [anon_sym_upcast] = ACTIONS(6852),
    [anon_sym_downcast] = ACTIONS(6852),
    [anon_sym_for] = ACTIONS(6852),
    [anon_sym_while] = ACTIONS(6852),
    [anon_sym_if] = ACTIONS(6852),
    [anon_sym_fun] = ACTIONS(6852),
    [anon_sym_try] = ACTIONS(6852),
    [anon_sym_match] = ACTIONS(6852),
    [anon_sym_match_BANG] = ACTIONS(6850),
    [anon_sym_function] = ACTIONS(6852),
    [anon_sym_use] = ACTIONS(6852),
    [anon_sym_use_BANG] = ACTIONS(6850),
    [anon_sym_do_BANG] = ACTIONS(6850),
    [anon_sym_begin] = ACTIONS(6852),
    [anon_sym_exception] = ACTIONS(6852),
    [aux_sym_char_token1] = ACTIONS(6850),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6852),
    [anon_sym_DQUOTE] = ACTIONS(6852),
    [anon_sym_AT_DQUOTE] = ACTIONS(6850),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6850),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6850),
    [sym_bool] = ACTIONS(6852),
    [sym_unit] = ACTIONS(6850),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6852),
    [sym_op_identifier] = ACTIONS(6850),
    [anon_sym_PLUS] = ACTIONS(6852),
    [anon_sym_DASH] = ACTIONS(6852),
    [anon_sym_PLUS_DOT] = ACTIONS(6850),
    [anon_sym_DASH_DOT] = ACTIONS(6850),
    [anon_sym_PERCENT] = ACTIONS(6850),
    [anon_sym_AMP_AMP] = ACTIONS(6850),
    [anon_sym_TILDE] = ACTIONS(6850),
    [aux_sym_prefix_op_token1] = ACTIONS(6850),
    [sym_int] = ACTIONS(6852),
    [sym_xint] = ACTIONS(6850),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6850),
    [anon_sym_POUNDload] = ACTIONS(6850),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6850),
  },
  [4139] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(11056),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4139),
    [sym_compiler_directive_decl] = STATE(4139),
    [sym_fsi_directive_decl] = STATE(4139),
    [sym_preproc_line] = STATE(4139),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6854),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4140] = {
    [sym_block_comment] = STATE(4140),
    [sym_compiler_directive_decl] = STATE(4140),
    [sym_fsi_directive_decl] = STATE(4140),
    [sym_preproc_line] = STATE(4140),
    [ts_builtin_sym_end] = ACTIONS(6300),
    [sym_identifier] = ACTIONS(6302),
    [anon_sym_namespace] = ACTIONS(6302),
    [anon_sym_module] = ACTIONS(6302),
    [anon_sym_open] = ACTIONS(6302),
    [anon_sym_LBRACK_LT] = ACTIONS(6300),
    [anon_sym_return] = ACTIONS(6302),
    [anon_sym_type] = ACTIONS(6302),
    [anon_sym_do] = ACTIONS(6302),
    [anon_sym_let] = ACTIONS(6302),
    [anon_sym_let_BANG] = ACTIONS(6300),
    [anon_sym_LPAREN] = ACTIONS(6302),
    [anon_sym_null] = ACTIONS(6302),
    [anon_sym_AMP] = ACTIONS(6302),
    [anon_sym_LBRACK] = ACTIONS(6302),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6300),
    [anon_sym_LBRACE] = ACTIONS(6302),
    [anon_sym_LT_AT] = ACTIONS(6302),
    [anon_sym_LT_AT_AT] = ACTIONS(6300),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6300),
    [anon_sym_new] = ACTIONS(6302),
    [anon_sym_return_BANG] = ACTIONS(6300),
    [anon_sym_yield] = ACTIONS(6302),
    [anon_sym_yield_BANG] = ACTIONS(6300),
    [anon_sym_lazy] = ACTIONS(6302),
    [anon_sym_assert] = ACTIONS(6302),
    [anon_sym_upcast] = ACTIONS(6302),
    [anon_sym_downcast] = ACTIONS(6302),
    [anon_sym_for] = ACTIONS(6302),
    [anon_sym_while] = ACTIONS(6302),
    [anon_sym_if] = ACTIONS(6302),
    [anon_sym_fun] = ACTIONS(6302),
    [anon_sym_try] = ACTIONS(6302),
    [anon_sym_match] = ACTIONS(6302),
    [anon_sym_match_BANG] = ACTIONS(6300),
    [anon_sym_function] = ACTIONS(6302),
    [anon_sym_use] = ACTIONS(6302),
    [anon_sym_use_BANG] = ACTIONS(6300),
    [anon_sym_do_BANG] = ACTIONS(6300),
    [anon_sym_begin] = ACTIONS(6302),
    [anon_sym_exception] = ACTIONS(6302),
    [aux_sym_char_token1] = ACTIONS(6300),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6302),
    [anon_sym_DQUOTE] = ACTIONS(6302),
    [anon_sym_AT_DQUOTE] = ACTIONS(6300),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6300),
    [sym_bool] = ACTIONS(6302),
    [sym_unit] = ACTIONS(6300),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6302),
    [sym_op_identifier] = ACTIONS(6300),
    [anon_sym_PLUS] = ACTIONS(6302),
    [anon_sym_DASH] = ACTIONS(6302),
    [anon_sym_PLUS_DOT] = ACTIONS(6300),
    [anon_sym_DASH_DOT] = ACTIONS(6300),
    [anon_sym_PERCENT] = ACTIONS(6300),
    [anon_sym_AMP_AMP] = ACTIONS(6300),
    [anon_sym_TILDE] = ACTIONS(6300),
    [aux_sym_prefix_op_token1] = ACTIONS(6300),
    [sym_int] = ACTIONS(6302),
    [sym_xint] = ACTIONS(6300),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6300),
    [anon_sym_POUNDload] = ACTIONS(6300),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6300),
  },
  [4141] = {
    [sym_attributes] = STATE(6985),
    [sym__attribute_set] = STATE(7246),
    [sym_function_or_value_defn] = STATE(6835),
    [sym_access_modifier] = STATE(7815),
    [sym__type] = STATE(8127),
    [sym_simple_type] = STATE(6550),
    [sym_generic_type] = STATE(6550),
    [sym_paren_type] = STATE(6550),
    [sym_function_type] = STATE(6550),
    [sym_compound_type] = STATE(6550),
    [sym_postfix_type] = STATE(6550),
    [sym_list_type] = STATE(6550),
    [sym_static_type] = STATE(6550),
    [sym_constrained_type] = STATE(6550),
    [sym_flexible_type] = STATE(6550),
    [sym_anon_record_type] = STATE(6550),
    [sym__static_type_identifier] = STATE(6214),
    [sym_type_argument] = STATE(6488),
    [sym_delegate_signature] = STATE(12044),
    [sym__class_type_body_inner] = STATE(9306),
    [sym__class_type_body] = STATE(12004),
    [sym_enum_type_cases] = STATE(12002),
    [sym_enum_type_case] = STATE(10606),
    [sym_union_type_cases] = STATE(5311),
    [sym_union_type_case] = STATE(6531),
    [sym__class_function_or_value_defn] = STATE(6840),
    [aux_sym__type_extension_inner] = STATE(5324),
    [sym_type_extension_elements] = STATE(9527),
    [sym__type_defn_elements] = STATE(6840),
    [sym_interface_implementation] = STATE(6862),
    [sym_member_defn] = STATE(6862),
    [sym_additional_constr_defn] = STATE(6864),
    [sym_class_inherits_decl] = STATE(9527),
    [sym_long_identifier] = STATE(6600),
    [sym_block_comment] = STATE(4141),
    [sym_compiler_directive_decl] = STATE(4141),
    [sym_fsi_directive_decl] = STATE(4141),
    [sym_preproc_line] = STATE(4141),
    [sym_preproc_if_in_class_definition] = STATE(6840),
    [aux_sym_attributes_repeat1] = STATE(7077),
    [sym_identifier] = ACTIONS(6856),
    [anon_sym_LBRACK_LT] = ACTIONS(6858),
    [anon_sym_do] = ACTIONS(6860),
    [anon_sym_let] = ACTIONS(6862),
    [anon_sym_let_BANG] = ACTIONS(6864),
    [aux_sym_access_modifier_token1] = ACTIONS(5109),
    [anon_sym_LPAREN] = ACTIONS(6866),
    [anon_sym__] = ACTIONS(6868),
    [anon_sym_PIPE] = ACTIONS(6870),
    [anon_sym_LBRACE] = ACTIONS(6872),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6874),
    [anon_sym_new] = ACTIONS(6876),
    [anon_sym_with] = ACTIONS(6878),
    [anon_sym_POUND] = ACTIONS(6880),
    [anon_sym_CARET] = ACTIONS(6882),
    [anon_sym_SQUOTE] = ACTIONS(6882),
    [anon_sym_delegate] = ACTIONS(6884),
    [anon_sym_default] = ACTIONS(6886),
    [anon_sym_static] = ACTIONS(6888),
    [anon_sym_member] = ACTIONS(6890),
    [anon_sym_interface] = ACTIONS(6892),
    [anon_sym_abstract] = ACTIONS(6894),
    [anon_sym_val] = ACTIONS(6896),
    [anon_sym_override] = ACTIONS(6886),
    [anon_sym_inherit] = ACTIONS(6898),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6900),
  },
  [4142] = {
    [sym_block_comment] = STATE(4142),
    [sym_compiler_directive_decl] = STATE(4142),
    [sym_fsi_directive_decl] = STATE(4142),
    [sym_preproc_line] = STATE(4142),
    [ts_builtin_sym_end] = ACTIONS(6902),
    [sym_identifier] = ACTIONS(6904),
    [anon_sym_namespace] = ACTIONS(6904),
    [anon_sym_module] = ACTIONS(6904),
    [anon_sym_open] = ACTIONS(6904),
    [anon_sym_LBRACK_LT] = ACTIONS(6902),
    [anon_sym_return] = ACTIONS(6904),
    [anon_sym_type] = ACTIONS(6904),
    [anon_sym_do] = ACTIONS(6904),
    [anon_sym_let] = ACTIONS(6904),
    [anon_sym_let_BANG] = ACTIONS(6902),
    [anon_sym_LPAREN] = ACTIONS(6904),
    [anon_sym_null] = ACTIONS(6904),
    [anon_sym_AMP] = ACTIONS(6904),
    [anon_sym_LBRACK] = ACTIONS(6904),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6902),
    [anon_sym_LBRACE] = ACTIONS(6904),
    [anon_sym_LT_AT] = ACTIONS(6904),
    [anon_sym_LT_AT_AT] = ACTIONS(6902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6902),
    [anon_sym_new] = ACTIONS(6904),
    [anon_sym_return_BANG] = ACTIONS(6902),
    [anon_sym_yield] = ACTIONS(6904),
    [anon_sym_yield_BANG] = ACTIONS(6902),
    [anon_sym_lazy] = ACTIONS(6904),
    [anon_sym_assert] = ACTIONS(6904),
    [anon_sym_upcast] = ACTIONS(6904),
    [anon_sym_downcast] = ACTIONS(6904),
    [anon_sym_for] = ACTIONS(6904),
    [anon_sym_while] = ACTIONS(6904),
    [anon_sym_if] = ACTIONS(6904),
    [anon_sym_fun] = ACTIONS(6904),
    [anon_sym_try] = ACTIONS(6904),
    [anon_sym_match] = ACTIONS(6904),
    [anon_sym_match_BANG] = ACTIONS(6902),
    [anon_sym_function] = ACTIONS(6904),
    [anon_sym_use] = ACTIONS(6904),
    [anon_sym_use_BANG] = ACTIONS(6902),
    [anon_sym_do_BANG] = ACTIONS(6902),
    [anon_sym_begin] = ACTIONS(6904),
    [anon_sym_exception] = ACTIONS(6904),
    [aux_sym_char_token1] = ACTIONS(6902),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6904),
    [anon_sym_DQUOTE] = ACTIONS(6904),
    [anon_sym_AT_DQUOTE] = ACTIONS(6902),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6902),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6902),
    [sym_bool] = ACTIONS(6904),
    [sym_unit] = ACTIONS(6902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6904),
    [sym_op_identifier] = ACTIONS(6902),
    [anon_sym_PLUS] = ACTIONS(6904),
    [anon_sym_DASH] = ACTIONS(6904),
    [anon_sym_PLUS_DOT] = ACTIONS(6902),
    [anon_sym_DASH_DOT] = ACTIONS(6902),
    [anon_sym_PERCENT] = ACTIONS(6902),
    [anon_sym_AMP_AMP] = ACTIONS(6902),
    [anon_sym_TILDE] = ACTIONS(6902),
    [aux_sym_prefix_op_token1] = ACTIONS(6902),
    [sym_int] = ACTIONS(6904),
    [sym_xint] = ACTIONS(6902),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6902),
    [anon_sym_POUNDload] = ACTIONS(6902),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6902),
  },
  [4143] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(11583),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4143),
    [sym_compiler_directive_decl] = STATE(4143),
    [sym_fsi_directive_decl] = STATE(4143),
    [sym_preproc_line] = STATE(4143),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4144] = {
    [sym_block_comment] = STATE(4144),
    [sym_compiler_directive_decl] = STATE(4144),
    [sym_fsi_directive_decl] = STATE(4144),
    [sym_preproc_line] = STATE(4144),
    [ts_builtin_sym_end] = ACTIONS(3698),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_namespace] = ACTIONS(3700),
    [anon_sym_module] = ACTIONS(3700),
    [anon_sym_open] = ACTIONS(3700),
    [anon_sym_LBRACK_LT] = ACTIONS(3698),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_type] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [anon_sym_exception] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3698),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3698),
    [anon_sym_DASH_DOT] = ACTIONS(3698),
    [anon_sym_PERCENT] = ACTIONS(3698),
    [anon_sym_AMP_AMP] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3698),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(3698),
    [anon_sym_POUNDload] = ACTIONS(3698),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
  },
  [4145] = {
    [sym_block_comment] = STATE(4145),
    [sym_compiler_directive_decl] = STATE(4145),
    [sym_fsi_directive_decl] = STATE(4145),
    [sym_preproc_line] = STATE(4145),
    [sym_identifier] = ACTIONS(3480),
    [anon_sym_return] = ACTIONS(3480),
    [anon_sym_do] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_let_BANG] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_null] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_LT_AT] = ACTIONS(3480),
    [anon_sym_LT_AT_AT] = ACTIONS(3478),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_return_BANG] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3480),
    [anon_sym_yield_BANG] = ACTIONS(3478),
    [anon_sym_lazy] = ACTIONS(3480),
    [anon_sym_assert] = ACTIONS(3480),
    [anon_sym_upcast] = ACTIONS(3480),
    [anon_sym_downcast] = ACTIONS(3480),
    [anon_sym_COLON_GT] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3480),
    [anon_sym_fun] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3478),
    [anon_sym_try] = ACTIONS(3480),
    [anon_sym_match] = ACTIONS(3480),
    [anon_sym_match_BANG] = ACTIONS(3478),
    [anon_sym_function] = ACTIONS(3480),
    [anon_sym_use] = ACTIONS(3480),
    [anon_sym_use_BANG] = ACTIONS(3478),
    [anon_sym_do_BANG] = ACTIONS(3478),
    [anon_sym_begin] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3478),
    [anon_sym_LT2] = ACTIONS(3480),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3478),
    [anon_sym_or] = ACTIONS(3480),
    [aux_sym_char_token1] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_AT_DQUOTE] = ACTIONS(3478),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3478),
    [sym_bool] = ACTIONS(3480),
    [sym_unit] = ACTIONS(3478),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3480),
    [sym_op_identifier] = ACTIONS(3478),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_DOT] = ACTIONS(3478),
    [anon_sym_DASH_DOT] = ACTIONS(3478),
    [anon_sym_PERCENT] = ACTIONS(3478),
    [anon_sym_AMP_AMP] = ACTIONS(3478),
    [anon_sym_TILDE] = ACTIONS(3478),
    [aux_sym_prefix_op_token1] = ACTIONS(3478),
    [sym_int] = ACTIONS(3480),
    [sym_xint] = ACTIONS(3478),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3478),
    [sym__dedent] = ACTIONS(3478),
  },
  [4146] = {
    [sym_block_comment] = STATE(4146),
    [sym_compiler_directive_decl] = STATE(4146),
    [sym_fsi_directive_decl] = STATE(4146),
    [sym_preproc_line] = STATE(4146),
    [ts_builtin_sym_end] = ACTIONS(6286),
    [sym_identifier] = ACTIONS(6288),
    [anon_sym_namespace] = ACTIONS(6288),
    [anon_sym_module] = ACTIONS(6288),
    [anon_sym_open] = ACTIONS(6288),
    [anon_sym_LBRACK_LT] = ACTIONS(6286),
    [anon_sym_return] = ACTIONS(6288),
    [anon_sym_type] = ACTIONS(6288),
    [anon_sym_do] = ACTIONS(6288),
    [anon_sym_let] = ACTIONS(6288),
    [anon_sym_let_BANG] = ACTIONS(6286),
    [anon_sym_LPAREN] = ACTIONS(6288),
    [anon_sym_null] = ACTIONS(6288),
    [anon_sym_AMP] = ACTIONS(6288),
    [anon_sym_LBRACK] = ACTIONS(6288),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6286),
    [anon_sym_LBRACE] = ACTIONS(6288),
    [anon_sym_LT_AT] = ACTIONS(6288),
    [anon_sym_LT_AT_AT] = ACTIONS(6286),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6286),
    [anon_sym_new] = ACTIONS(6288),
    [anon_sym_return_BANG] = ACTIONS(6286),
    [anon_sym_yield] = ACTIONS(6288),
    [anon_sym_yield_BANG] = ACTIONS(6286),
    [anon_sym_lazy] = ACTIONS(6288),
    [anon_sym_assert] = ACTIONS(6288),
    [anon_sym_upcast] = ACTIONS(6288),
    [anon_sym_downcast] = ACTIONS(6288),
    [anon_sym_for] = ACTIONS(6288),
    [anon_sym_while] = ACTIONS(6288),
    [anon_sym_if] = ACTIONS(6288),
    [anon_sym_fun] = ACTIONS(6288),
    [anon_sym_try] = ACTIONS(6288),
    [anon_sym_match] = ACTIONS(6288),
    [anon_sym_match_BANG] = ACTIONS(6286),
    [anon_sym_function] = ACTIONS(6288),
    [anon_sym_use] = ACTIONS(6288),
    [anon_sym_use_BANG] = ACTIONS(6286),
    [anon_sym_do_BANG] = ACTIONS(6286),
    [anon_sym_begin] = ACTIONS(6288),
    [anon_sym_exception] = ACTIONS(6288),
    [aux_sym_char_token1] = ACTIONS(6286),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6288),
    [anon_sym_DQUOTE] = ACTIONS(6288),
    [anon_sym_AT_DQUOTE] = ACTIONS(6286),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6286),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6286),
    [sym_bool] = ACTIONS(6288),
    [sym_unit] = ACTIONS(6286),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6288),
    [sym_op_identifier] = ACTIONS(6286),
    [anon_sym_PLUS] = ACTIONS(6288),
    [anon_sym_DASH] = ACTIONS(6288),
    [anon_sym_PLUS_DOT] = ACTIONS(6286),
    [anon_sym_DASH_DOT] = ACTIONS(6286),
    [anon_sym_PERCENT] = ACTIONS(6286),
    [anon_sym_AMP_AMP] = ACTIONS(6286),
    [anon_sym_TILDE] = ACTIONS(6286),
    [aux_sym_prefix_op_token1] = ACTIONS(6286),
    [sym_int] = ACTIONS(6288),
    [sym_xint] = ACTIONS(6286),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6286),
    [anon_sym_POUNDload] = ACTIONS(6286),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6286),
  },
  [4147] = {
    [sym_attributes] = STATE(6985),
    [sym__attribute_set] = STATE(7246),
    [sym_function_or_value_defn] = STATE(6835),
    [sym_access_modifier] = STATE(7760),
    [sym__type] = STATE(8056),
    [sym_simple_type] = STATE(6550),
    [sym_generic_type] = STATE(6550),
    [sym_paren_type] = STATE(6550),
    [sym_function_type] = STATE(6550),
    [sym_compound_type] = STATE(6550),
    [sym_postfix_type] = STATE(6550),
    [sym_list_type] = STATE(6550),
    [sym_static_type] = STATE(6550),
    [sym_constrained_type] = STATE(6550),
    [sym_flexible_type] = STATE(6550),
    [sym_anon_record_type] = STATE(6550),
    [sym__static_type_identifier] = STATE(6214),
    [sym_type_argument] = STATE(6488),
    [sym_delegate_signature] = STATE(11762),
    [sym__class_type_body_inner] = STATE(9306),
    [sym__class_type_body] = STATE(11761),
    [sym_enum_type_cases] = STATE(11760),
    [sym_enum_type_case] = STATE(10606),
    [sym_union_type_cases] = STATE(5302),
    [sym_union_type_case] = STATE(6531),
    [sym__class_function_or_value_defn] = STATE(6840),
    [aux_sym__type_extension_inner] = STATE(5324),
    [sym_type_extension_elements] = STATE(9527),
    [sym__type_defn_elements] = STATE(6840),
    [sym_interface_implementation] = STATE(6862),
    [sym_member_defn] = STATE(6862),
    [sym_additional_constr_defn] = STATE(6864),
    [sym_class_inherits_decl] = STATE(9527),
    [sym_long_identifier] = STATE(6600),
    [sym_block_comment] = STATE(4147),
    [sym_compiler_directive_decl] = STATE(4147),
    [sym_fsi_directive_decl] = STATE(4147),
    [sym_preproc_line] = STATE(4147),
    [sym_preproc_if_in_class_definition] = STATE(6840),
    [aux_sym_attributes_repeat1] = STATE(7077),
    [sym_identifier] = ACTIONS(6856),
    [anon_sym_LBRACK_LT] = ACTIONS(6858),
    [anon_sym_do] = ACTIONS(6860),
    [anon_sym_let] = ACTIONS(6862),
    [anon_sym_let_BANG] = ACTIONS(6864),
    [aux_sym_access_modifier_token1] = ACTIONS(5109),
    [anon_sym_LPAREN] = ACTIONS(6866),
    [anon_sym__] = ACTIONS(6868),
    [anon_sym_PIPE] = ACTIONS(6870),
    [anon_sym_LBRACE] = ACTIONS(6906),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6874),
    [anon_sym_new] = ACTIONS(6876),
    [anon_sym_with] = ACTIONS(6878),
    [anon_sym_POUND] = ACTIONS(6880),
    [anon_sym_CARET] = ACTIONS(6882),
    [anon_sym_SQUOTE] = ACTIONS(6882),
    [anon_sym_delegate] = ACTIONS(6884),
    [anon_sym_default] = ACTIONS(6886),
    [anon_sym_static] = ACTIONS(6888),
    [anon_sym_member] = ACTIONS(6890),
    [anon_sym_interface] = ACTIONS(6892),
    [anon_sym_abstract] = ACTIONS(6894),
    [anon_sym_val] = ACTIONS(6896),
    [anon_sym_override] = ACTIONS(6886),
    [anon_sym_inherit] = ACTIONS(6898),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6900),
  },
  [4148] = {
    [sym_block_comment] = STATE(4148),
    [sym_compiler_directive_decl] = STATE(4148),
    [sym_fsi_directive_decl] = STATE(4148),
    [sym_preproc_line] = STATE(4148),
    [aux_sym_long_identifier_repeat1] = STATE(4148),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3485),
    [anon_sym_DOT] = ACTIONS(6908),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3485),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3485),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3485),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3485),
    [anon_sym_DASH_DOT] = ACTIONS(3485),
    [anon_sym_PERCENT] = ACTIONS(3485),
    [anon_sym_AMP_AMP] = ACTIONS(3485),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3485),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__dedent] = ACTIONS(3485),
  },
  [4149] = {
    [sym_block_comment] = STATE(4149),
    [sym_compiler_directive_decl] = STATE(4149),
    [sym_fsi_directive_decl] = STATE(4149),
    [sym_preproc_line] = STATE(4149),
    [ts_builtin_sym_end] = ACTIONS(6911),
    [sym_identifier] = ACTIONS(6913),
    [anon_sym_namespace] = ACTIONS(6913),
    [anon_sym_module] = ACTIONS(6913),
    [anon_sym_open] = ACTIONS(6913),
    [anon_sym_LBRACK_LT] = ACTIONS(6911),
    [anon_sym_return] = ACTIONS(6913),
    [anon_sym_type] = ACTIONS(6913),
    [anon_sym_do] = ACTIONS(6913),
    [anon_sym_let] = ACTIONS(6913),
    [anon_sym_let_BANG] = ACTIONS(6911),
    [anon_sym_LPAREN] = ACTIONS(6913),
    [anon_sym_null] = ACTIONS(6913),
    [anon_sym_AMP] = ACTIONS(6913),
    [anon_sym_LBRACK] = ACTIONS(6913),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6911),
    [anon_sym_LBRACE] = ACTIONS(6913),
    [anon_sym_LT_AT] = ACTIONS(6913),
    [anon_sym_LT_AT_AT] = ACTIONS(6911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6911),
    [anon_sym_new] = ACTIONS(6913),
    [anon_sym_return_BANG] = ACTIONS(6911),
    [anon_sym_yield] = ACTIONS(6913),
    [anon_sym_yield_BANG] = ACTIONS(6911),
    [anon_sym_lazy] = ACTIONS(6913),
    [anon_sym_assert] = ACTIONS(6913),
    [anon_sym_upcast] = ACTIONS(6913),
    [anon_sym_downcast] = ACTIONS(6913),
    [anon_sym_for] = ACTIONS(6913),
    [anon_sym_while] = ACTIONS(6913),
    [anon_sym_if] = ACTIONS(6913),
    [anon_sym_fun] = ACTIONS(6913),
    [anon_sym_try] = ACTIONS(6913),
    [anon_sym_match] = ACTIONS(6913),
    [anon_sym_match_BANG] = ACTIONS(6911),
    [anon_sym_function] = ACTIONS(6913),
    [anon_sym_use] = ACTIONS(6913),
    [anon_sym_use_BANG] = ACTIONS(6911),
    [anon_sym_do_BANG] = ACTIONS(6911),
    [anon_sym_begin] = ACTIONS(6913),
    [anon_sym_exception] = ACTIONS(6913),
    [aux_sym_char_token1] = ACTIONS(6911),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6913),
    [anon_sym_DQUOTE] = ACTIONS(6913),
    [anon_sym_AT_DQUOTE] = ACTIONS(6911),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6911),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6911),
    [sym_bool] = ACTIONS(6913),
    [sym_unit] = ACTIONS(6911),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6913),
    [sym_op_identifier] = ACTIONS(6911),
    [anon_sym_PLUS] = ACTIONS(6913),
    [anon_sym_DASH] = ACTIONS(6913),
    [anon_sym_PLUS_DOT] = ACTIONS(6911),
    [anon_sym_DASH_DOT] = ACTIONS(6911),
    [anon_sym_PERCENT] = ACTIONS(6911),
    [anon_sym_AMP_AMP] = ACTIONS(6911),
    [anon_sym_TILDE] = ACTIONS(6911),
    [aux_sym_prefix_op_token1] = ACTIONS(6911),
    [sym_int] = ACTIONS(6913),
    [sym_xint] = ACTIONS(6911),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6911),
    [anon_sym_POUNDload] = ACTIONS(6911),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6911),
  },
  [4150] = {
    [sym_block_comment] = STATE(4150),
    [sym_compiler_directive_decl] = STATE(4150),
    [sym_fsi_directive_decl] = STATE(4150),
    [sym_preproc_line] = STATE(4150),
    [ts_builtin_sym_end] = ACTIONS(6456),
    [sym_identifier] = ACTIONS(6458),
    [anon_sym_namespace] = ACTIONS(6458),
    [anon_sym_module] = ACTIONS(6458),
    [anon_sym_open] = ACTIONS(6458),
    [anon_sym_LBRACK_LT] = ACTIONS(6456),
    [anon_sym_return] = ACTIONS(6458),
    [anon_sym_type] = ACTIONS(6458),
    [anon_sym_do] = ACTIONS(6458),
    [anon_sym_let] = ACTIONS(6458),
    [anon_sym_let_BANG] = ACTIONS(6456),
    [anon_sym_LPAREN] = ACTIONS(6458),
    [anon_sym_null] = ACTIONS(6458),
    [anon_sym_AMP] = ACTIONS(6458),
    [anon_sym_LBRACK] = ACTIONS(6458),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6456),
    [anon_sym_LBRACE] = ACTIONS(6458),
    [anon_sym_LT_AT] = ACTIONS(6458),
    [anon_sym_LT_AT_AT] = ACTIONS(6456),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6456),
    [anon_sym_new] = ACTIONS(6458),
    [anon_sym_return_BANG] = ACTIONS(6456),
    [anon_sym_yield] = ACTIONS(6458),
    [anon_sym_yield_BANG] = ACTIONS(6456),
    [anon_sym_lazy] = ACTIONS(6458),
    [anon_sym_assert] = ACTIONS(6458),
    [anon_sym_upcast] = ACTIONS(6458),
    [anon_sym_downcast] = ACTIONS(6458),
    [anon_sym_for] = ACTIONS(6458),
    [anon_sym_while] = ACTIONS(6458),
    [anon_sym_if] = ACTIONS(6458),
    [anon_sym_fun] = ACTIONS(6458),
    [anon_sym_try] = ACTIONS(6458),
    [anon_sym_match] = ACTIONS(6458),
    [anon_sym_match_BANG] = ACTIONS(6456),
    [anon_sym_function] = ACTIONS(6458),
    [anon_sym_use] = ACTIONS(6458),
    [anon_sym_use_BANG] = ACTIONS(6456),
    [anon_sym_do_BANG] = ACTIONS(6456),
    [anon_sym_begin] = ACTIONS(6458),
    [anon_sym_exception] = ACTIONS(6458),
    [aux_sym_char_token1] = ACTIONS(6456),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6458),
    [anon_sym_DQUOTE] = ACTIONS(6458),
    [anon_sym_AT_DQUOTE] = ACTIONS(6456),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6456),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6456),
    [sym_bool] = ACTIONS(6458),
    [sym_unit] = ACTIONS(6456),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6458),
    [sym_op_identifier] = ACTIONS(6456),
    [anon_sym_PLUS] = ACTIONS(6458),
    [anon_sym_DASH] = ACTIONS(6458),
    [anon_sym_PLUS_DOT] = ACTIONS(6456),
    [anon_sym_DASH_DOT] = ACTIONS(6456),
    [anon_sym_PERCENT] = ACTIONS(6456),
    [anon_sym_AMP_AMP] = ACTIONS(6456),
    [anon_sym_TILDE] = ACTIONS(6456),
    [aux_sym_prefix_op_token1] = ACTIONS(6456),
    [sym_int] = ACTIONS(6458),
    [sym_xint] = ACTIONS(6456),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6456),
    [anon_sym_POUNDload] = ACTIONS(6456),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6456),
  },
  [4151] = {
    [sym_block_comment] = STATE(4151),
    [sym_compiler_directive_decl] = STATE(4151),
    [sym_fsi_directive_decl] = STATE(4151),
    [sym_preproc_line] = STATE(4151),
    [ts_builtin_sym_end] = ACTIONS(6915),
    [sym_identifier] = ACTIONS(6917),
    [anon_sym_namespace] = ACTIONS(6917),
    [anon_sym_module] = ACTIONS(6917),
    [anon_sym_open] = ACTIONS(6917),
    [anon_sym_LBRACK_LT] = ACTIONS(6915),
    [anon_sym_return] = ACTIONS(6917),
    [anon_sym_type] = ACTIONS(6917),
    [anon_sym_do] = ACTIONS(6917),
    [anon_sym_let] = ACTIONS(6917),
    [anon_sym_let_BANG] = ACTIONS(6915),
    [anon_sym_LPAREN] = ACTIONS(6917),
    [anon_sym_null] = ACTIONS(6917),
    [anon_sym_AMP] = ACTIONS(6917),
    [anon_sym_LBRACK] = ACTIONS(6917),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6915),
    [anon_sym_LBRACE] = ACTIONS(6917),
    [anon_sym_LT_AT] = ACTIONS(6917),
    [anon_sym_LT_AT_AT] = ACTIONS(6915),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6915),
    [anon_sym_new] = ACTIONS(6917),
    [anon_sym_return_BANG] = ACTIONS(6915),
    [anon_sym_yield] = ACTIONS(6917),
    [anon_sym_yield_BANG] = ACTIONS(6915),
    [anon_sym_lazy] = ACTIONS(6917),
    [anon_sym_assert] = ACTIONS(6917),
    [anon_sym_upcast] = ACTIONS(6917),
    [anon_sym_downcast] = ACTIONS(6917),
    [anon_sym_for] = ACTIONS(6917),
    [anon_sym_while] = ACTIONS(6917),
    [anon_sym_if] = ACTIONS(6917),
    [anon_sym_fun] = ACTIONS(6917),
    [anon_sym_try] = ACTIONS(6917),
    [anon_sym_match] = ACTIONS(6917),
    [anon_sym_match_BANG] = ACTIONS(6915),
    [anon_sym_function] = ACTIONS(6917),
    [anon_sym_use] = ACTIONS(6917),
    [anon_sym_use_BANG] = ACTIONS(6915),
    [anon_sym_do_BANG] = ACTIONS(6915),
    [anon_sym_begin] = ACTIONS(6917),
    [anon_sym_exception] = ACTIONS(6917),
    [aux_sym_char_token1] = ACTIONS(6915),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6917),
    [anon_sym_DQUOTE] = ACTIONS(6917),
    [anon_sym_AT_DQUOTE] = ACTIONS(6915),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6915),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6915),
    [sym_bool] = ACTIONS(6917),
    [sym_unit] = ACTIONS(6915),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6917),
    [sym_op_identifier] = ACTIONS(6915),
    [anon_sym_PLUS] = ACTIONS(6917),
    [anon_sym_DASH] = ACTIONS(6917),
    [anon_sym_PLUS_DOT] = ACTIONS(6915),
    [anon_sym_DASH_DOT] = ACTIONS(6915),
    [anon_sym_PERCENT] = ACTIONS(6915),
    [anon_sym_AMP_AMP] = ACTIONS(6915),
    [anon_sym_TILDE] = ACTIONS(6915),
    [aux_sym_prefix_op_token1] = ACTIONS(6915),
    [sym_int] = ACTIONS(6917),
    [sym_xint] = ACTIONS(6915),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6915),
    [anon_sym_POUNDload] = ACTIONS(6915),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6915),
  },
  [4152] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(11431),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4152),
    [sym_compiler_directive_decl] = STATE(4152),
    [sym_fsi_directive_decl] = STATE(4152),
    [sym_preproc_line] = STATE(4152),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4153] = {
    [sym_block_comment] = STATE(4153),
    [sym_compiler_directive_decl] = STATE(4153),
    [sym_fsi_directive_decl] = STATE(4153),
    [sym_preproc_line] = STATE(4153),
    [ts_builtin_sym_end] = ACTIONS(6919),
    [sym_identifier] = ACTIONS(6921),
    [anon_sym_namespace] = ACTIONS(6921),
    [anon_sym_module] = ACTIONS(6921),
    [anon_sym_open] = ACTIONS(6921),
    [anon_sym_LBRACK_LT] = ACTIONS(6919),
    [anon_sym_return] = ACTIONS(6921),
    [anon_sym_type] = ACTIONS(6921),
    [anon_sym_do] = ACTIONS(6921),
    [anon_sym_let] = ACTIONS(6921),
    [anon_sym_let_BANG] = ACTIONS(6919),
    [anon_sym_LPAREN] = ACTIONS(6921),
    [anon_sym_null] = ACTIONS(6921),
    [anon_sym_AMP] = ACTIONS(6921),
    [anon_sym_LBRACK] = ACTIONS(6921),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6919),
    [anon_sym_LBRACE] = ACTIONS(6921),
    [anon_sym_LT_AT] = ACTIONS(6921),
    [anon_sym_LT_AT_AT] = ACTIONS(6919),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6919),
    [anon_sym_new] = ACTIONS(6921),
    [anon_sym_return_BANG] = ACTIONS(6919),
    [anon_sym_yield] = ACTIONS(6921),
    [anon_sym_yield_BANG] = ACTIONS(6919),
    [anon_sym_lazy] = ACTIONS(6921),
    [anon_sym_assert] = ACTIONS(6921),
    [anon_sym_upcast] = ACTIONS(6921),
    [anon_sym_downcast] = ACTIONS(6921),
    [anon_sym_for] = ACTIONS(6921),
    [anon_sym_while] = ACTIONS(6921),
    [anon_sym_if] = ACTIONS(6921),
    [anon_sym_fun] = ACTIONS(6921),
    [anon_sym_try] = ACTIONS(6921),
    [anon_sym_match] = ACTIONS(6921),
    [anon_sym_match_BANG] = ACTIONS(6919),
    [anon_sym_function] = ACTIONS(6921),
    [anon_sym_use] = ACTIONS(6921),
    [anon_sym_use_BANG] = ACTIONS(6919),
    [anon_sym_do_BANG] = ACTIONS(6919),
    [anon_sym_begin] = ACTIONS(6921),
    [anon_sym_exception] = ACTIONS(6921),
    [aux_sym_char_token1] = ACTIONS(6919),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6921),
    [anon_sym_DQUOTE] = ACTIONS(6921),
    [anon_sym_AT_DQUOTE] = ACTIONS(6919),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6919),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6919),
    [sym_bool] = ACTIONS(6921),
    [sym_unit] = ACTIONS(6919),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6921),
    [sym_op_identifier] = ACTIONS(6919),
    [anon_sym_PLUS] = ACTIONS(6921),
    [anon_sym_DASH] = ACTIONS(6921),
    [anon_sym_PLUS_DOT] = ACTIONS(6919),
    [anon_sym_DASH_DOT] = ACTIONS(6919),
    [anon_sym_PERCENT] = ACTIONS(6919),
    [anon_sym_AMP_AMP] = ACTIONS(6919),
    [anon_sym_TILDE] = ACTIONS(6919),
    [aux_sym_prefix_op_token1] = ACTIONS(6919),
    [sym_int] = ACTIONS(6921),
    [sym_xint] = ACTIONS(6919),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6919),
    [anon_sym_POUNDload] = ACTIONS(6919),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6919),
  },
  [4154] = {
    [sym_block_comment] = STATE(4154),
    [sym_compiler_directive_decl] = STATE(4154),
    [sym_fsi_directive_decl] = STATE(4154),
    [sym_preproc_line] = STATE(4154),
    [ts_builtin_sym_end] = ACTIONS(897),
    [sym_identifier] = ACTIONS(899),
    [anon_sym_namespace] = ACTIONS(899),
    [anon_sym_module] = ACTIONS(899),
    [anon_sym_open] = ACTIONS(899),
    [anon_sym_LBRACK_LT] = ACTIONS(897),
    [anon_sym_return] = ACTIONS(899),
    [anon_sym_type] = ACTIONS(899),
    [anon_sym_do] = ACTIONS(899),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_let_BANG] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(899),
    [anon_sym_null] = ACTIONS(899),
    [anon_sym_AMP] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(899),
    [anon_sym_LBRACK_PIPE] = ACTIONS(897),
    [anon_sym_LBRACE] = ACTIONS(899),
    [anon_sym_LT_AT] = ACTIONS(899),
    [anon_sym_LT_AT_AT] = ACTIONS(897),
    [anon_sym_LBRACE_PIPE] = ACTIONS(897),
    [anon_sym_new] = ACTIONS(899),
    [anon_sym_return_BANG] = ACTIONS(897),
    [anon_sym_yield] = ACTIONS(899),
    [anon_sym_yield_BANG] = ACTIONS(897),
    [anon_sym_lazy] = ACTIONS(899),
    [anon_sym_assert] = ACTIONS(899),
    [anon_sym_upcast] = ACTIONS(899),
    [anon_sym_downcast] = ACTIONS(899),
    [anon_sym_for] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(899),
    [anon_sym_fun] = ACTIONS(899),
    [anon_sym_try] = ACTIONS(899),
    [anon_sym_match] = ACTIONS(899),
    [anon_sym_match_BANG] = ACTIONS(897),
    [anon_sym_function] = ACTIONS(899),
    [anon_sym_use] = ACTIONS(899),
    [anon_sym_use_BANG] = ACTIONS(897),
    [anon_sym_do_BANG] = ACTIONS(897),
    [anon_sym_begin] = ACTIONS(899),
    [anon_sym_exception] = ACTIONS(899),
    [aux_sym_char_token1] = ACTIONS(897),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(899),
    [anon_sym_DQUOTE] = ACTIONS(899),
    [anon_sym_AT_DQUOTE] = ACTIONS(897),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(897),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(897),
    [sym_bool] = ACTIONS(899),
    [sym_unit] = ACTIONS(897),
    [anon_sym_LPAREN_PIPE] = ACTIONS(899),
    [sym_op_identifier] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_PLUS_DOT] = ACTIONS(897),
    [anon_sym_DASH_DOT] = ACTIONS(897),
    [anon_sym_PERCENT] = ACTIONS(897),
    [anon_sym_AMP_AMP] = ACTIONS(897),
    [anon_sym_TILDE] = ACTIONS(897),
    [aux_sym_prefix_op_token1] = ACTIONS(897),
    [sym_int] = ACTIONS(899),
    [sym_xint] = ACTIONS(897),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(897),
    [anon_sym_POUNDload] = ACTIONS(897),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(897),
  },
  [4155] = {
    [sym_block_comment] = STATE(4155),
    [sym_compiler_directive_decl] = STATE(4155),
    [sym_fsi_directive_decl] = STATE(4155),
    [sym_preproc_line] = STATE(4155),
    [ts_builtin_sym_end] = ACTIONS(2690),
    [sym_identifier] = ACTIONS(2692),
    [anon_sym_namespace] = ACTIONS(2692),
    [anon_sym_module] = ACTIONS(2692),
    [anon_sym_open] = ACTIONS(2692),
    [anon_sym_LBRACK_LT] = ACTIONS(2690),
    [anon_sym_return] = ACTIONS(2692),
    [anon_sym_type] = ACTIONS(2692),
    [anon_sym_do] = ACTIONS(2692),
    [anon_sym_let] = ACTIONS(2692),
    [anon_sym_let_BANG] = ACTIONS(2690),
    [anon_sym_LPAREN] = ACTIONS(2692),
    [anon_sym_null] = ACTIONS(2692),
    [anon_sym_AMP] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2692),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2690),
    [anon_sym_LBRACE] = ACTIONS(2692),
    [anon_sym_LT_AT] = ACTIONS(2692),
    [anon_sym_LT_AT_AT] = ACTIONS(2690),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2690),
    [anon_sym_new] = ACTIONS(2692),
    [anon_sym_return_BANG] = ACTIONS(2690),
    [anon_sym_yield] = ACTIONS(2692),
    [anon_sym_yield_BANG] = ACTIONS(2690),
    [anon_sym_lazy] = ACTIONS(2692),
    [anon_sym_assert] = ACTIONS(2692),
    [anon_sym_upcast] = ACTIONS(2692),
    [anon_sym_downcast] = ACTIONS(2692),
    [anon_sym_for] = ACTIONS(2692),
    [anon_sym_while] = ACTIONS(2692),
    [anon_sym_if] = ACTIONS(2692),
    [anon_sym_fun] = ACTIONS(2692),
    [anon_sym_try] = ACTIONS(2692),
    [anon_sym_match] = ACTIONS(2692),
    [anon_sym_match_BANG] = ACTIONS(2690),
    [anon_sym_function] = ACTIONS(2692),
    [anon_sym_use] = ACTIONS(2692),
    [anon_sym_use_BANG] = ACTIONS(2690),
    [anon_sym_do_BANG] = ACTIONS(2690),
    [anon_sym_begin] = ACTIONS(2692),
    [anon_sym_exception] = ACTIONS(2692),
    [aux_sym_char_token1] = ACTIONS(2690),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2692),
    [anon_sym_DQUOTE] = ACTIONS(2692),
    [anon_sym_AT_DQUOTE] = ACTIONS(2690),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2690),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2690),
    [sym_bool] = ACTIONS(2692),
    [sym_unit] = ACTIONS(2690),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2692),
    [sym_op_identifier] = ACTIONS(2690),
    [anon_sym_PLUS] = ACTIONS(2692),
    [anon_sym_DASH] = ACTIONS(2692),
    [anon_sym_PLUS_DOT] = ACTIONS(2690),
    [anon_sym_DASH_DOT] = ACTIONS(2690),
    [anon_sym_PERCENT] = ACTIONS(2690),
    [anon_sym_AMP_AMP] = ACTIONS(2690),
    [anon_sym_TILDE] = ACTIONS(2690),
    [aux_sym_prefix_op_token1] = ACTIONS(2690),
    [sym_int] = ACTIONS(2692),
    [sym_xint] = ACTIONS(2690),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(2690),
    [anon_sym_POUNDload] = ACTIONS(2690),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2690),
  },
  [4156] = {
    [sym_block_comment] = STATE(4156),
    [sym_compiler_directive_decl] = STATE(4156),
    [sym_fsi_directive_decl] = STATE(4156),
    [sym_preproc_line] = STATE(4156),
    [sym_identifier] = ACTIONS(3511),
    [anon_sym_return] = ACTIONS(3511),
    [anon_sym_do] = ACTIONS(3511),
    [anon_sym_let] = ACTIONS(3511),
    [anon_sym_let_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3511),
    [anon_sym_null] = ACTIONS(3511),
    [anon_sym_AMP] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(3511),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_LT_AT] = ACTIONS(3511),
    [anon_sym_LT_AT_AT] = ACTIONS(3509),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3509),
    [anon_sym_new] = ACTIONS(3511),
    [anon_sym_return_BANG] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(3511),
    [anon_sym_yield_BANG] = ACTIONS(3509),
    [anon_sym_lazy] = ACTIONS(3511),
    [anon_sym_assert] = ACTIONS(3511),
    [anon_sym_upcast] = ACTIONS(3511),
    [anon_sym_downcast] = ACTIONS(3511),
    [anon_sym_COLON_GT] = ACTIONS(3509),
    [anon_sym_for] = ACTIONS(3511),
    [anon_sym_while] = ACTIONS(3511),
    [anon_sym_if] = ACTIONS(3511),
    [anon_sym_fun] = ACTIONS(3511),
    [anon_sym_DASH_GT] = ACTIONS(3509),
    [anon_sym_try] = ACTIONS(3511),
    [anon_sym_match] = ACTIONS(3511),
    [anon_sym_match_BANG] = ACTIONS(3509),
    [anon_sym_function] = ACTIONS(3511),
    [anon_sym_use] = ACTIONS(3511),
    [anon_sym_use_BANG] = ACTIONS(3509),
    [anon_sym_do_BANG] = ACTIONS(3509),
    [anon_sym_begin] = ACTIONS(3511),
    [anon_sym_STAR] = ACTIONS(3509),
    [anon_sym_LT2] = ACTIONS(3511),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3509),
    [anon_sym_or] = ACTIONS(3511),
    [aux_sym_char_token1] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3511),
    [anon_sym_AT_DQUOTE] = ACTIONS(3509),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3509),
    [sym_bool] = ACTIONS(3511),
    [sym_unit] = ACTIONS(3509),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3511),
    [sym_op_identifier] = ACTIONS(3509),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3511),
    [anon_sym_PLUS_DOT] = ACTIONS(3509),
    [anon_sym_DASH_DOT] = ACTIONS(3509),
    [anon_sym_PERCENT] = ACTIONS(3509),
    [anon_sym_AMP_AMP] = ACTIONS(3509),
    [anon_sym_TILDE] = ACTIONS(3509),
    [aux_sym_prefix_op_token1] = ACTIONS(3509),
    [sym_int] = ACTIONS(3511),
    [sym_xint] = ACTIONS(3509),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3509),
    [sym__dedent] = ACTIONS(3509),
  },
  [4157] = {
    [sym_block_comment] = STATE(4157),
    [sym_compiler_directive_decl] = STATE(4157),
    [sym_fsi_directive_decl] = STATE(4157),
    [sym_preproc_line] = STATE(4157),
    [aux_sym_compound_type_repeat1] = STATE(4175),
    [sym_identifier] = ACTIONS(3468),
    [anon_sym_GT_RBRACK] = ACTIONS(3466),
    [anon_sym_return] = ACTIONS(3468),
    [anon_sym_do] = ACTIONS(3468),
    [anon_sym_let] = ACTIONS(3468),
    [anon_sym_let_BANG] = ACTIONS(3466),
    [anon_sym_LPAREN] = ACTIONS(3468),
    [anon_sym_null] = ACTIONS(3468),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LBRACK] = ACTIONS(3468),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3466),
    [anon_sym_LBRACE] = ACTIONS(3468),
    [anon_sym_LT_AT] = ACTIONS(3468),
    [anon_sym_LT_AT_AT] = ACTIONS(3466),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3466),
    [anon_sym_new] = ACTIONS(3468),
    [anon_sym_return_BANG] = ACTIONS(3466),
    [anon_sym_yield] = ACTIONS(3468),
    [anon_sym_yield_BANG] = ACTIONS(3466),
    [anon_sym_lazy] = ACTIONS(3468),
    [anon_sym_assert] = ACTIONS(3468),
    [anon_sym_upcast] = ACTIONS(3468),
    [anon_sym_downcast] = ACTIONS(3468),
    [anon_sym_for] = ACTIONS(3468),
    [anon_sym_while] = ACTIONS(3468),
    [anon_sym_if] = ACTIONS(3468),
    [anon_sym_fun] = ACTIONS(3468),
    [anon_sym_DASH_GT] = ACTIONS(3466),
    [anon_sym_try] = ACTIONS(3468),
    [anon_sym_match] = ACTIONS(3468),
    [anon_sym_match_BANG] = ACTIONS(3466),
    [anon_sym_function] = ACTIONS(3468),
    [anon_sym_use] = ACTIONS(3468),
    [anon_sym_use_BANG] = ACTIONS(3466),
    [anon_sym_do_BANG] = ACTIONS(3466),
    [anon_sym_begin] = ACTIONS(3468),
    [anon_sym_STAR] = ACTIONS(2668),
    [anon_sym_LT2] = ACTIONS(3468),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3466),
    [aux_sym_char_token1] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3468),
    [anon_sym_DQUOTE] = ACTIONS(3468),
    [anon_sym_AT_DQUOTE] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [sym_bool] = ACTIONS(3468),
    [sym_unit] = ACTIONS(3466),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3468),
    [sym_op_identifier] = ACTIONS(3466),
    [anon_sym_PLUS] = ACTIONS(3468),
    [anon_sym_DASH] = ACTIONS(3468),
    [anon_sym_PLUS_DOT] = ACTIONS(3466),
    [anon_sym_DASH_DOT] = ACTIONS(3466),
    [anon_sym_PERCENT] = ACTIONS(3466),
    [anon_sym_AMP_AMP] = ACTIONS(3466),
    [anon_sym_TILDE] = ACTIONS(3466),
    [aux_sym_prefix_op_token1] = ACTIONS(3466),
    [sym_int] = ACTIONS(3468),
    [sym_xint] = ACTIONS(3466),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3466),
    [sym__newline] = ACTIONS(3466),
  },
  [4158] = {
    [sym_attributes] = STATE(6985),
    [sym__attribute_set] = STATE(7246),
    [sym_function_or_value_defn] = STATE(6835),
    [sym_access_modifier] = STATE(7698),
    [sym__type] = STATE(8291),
    [sym_simple_type] = STATE(6550),
    [sym_generic_type] = STATE(6550),
    [sym_paren_type] = STATE(6550),
    [sym_function_type] = STATE(6550),
    [sym_compound_type] = STATE(6550),
    [sym_postfix_type] = STATE(6550),
    [sym_list_type] = STATE(6550),
    [sym_static_type] = STATE(6550),
    [sym_constrained_type] = STATE(6550),
    [sym_flexible_type] = STATE(6550),
    [sym_anon_record_type] = STATE(6550),
    [sym__static_type_identifier] = STATE(6214),
    [sym_type_argument] = STATE(6488),
    [sym_delegate_signature] = STATE(10615),
    [sym__class_type_body_inner] = STATE(9306),
    [sym__class_type_body] = STATE(10611),
    [sym_enum_type_cases] = STATE(10607),
    [sym_enum_type_case] = STATE(10606),
    [sym_union_type_cases] = STATE(5269),
    [sym_union_type_case] = STATE(6531),
    [sym__class_function_or_value_defn] = STATE(6840),
    [aux_sym__type_extension_inner] = STATE(5324),
    [sym_type_extension_elements] = STATE(9527),
    [sym__type_defn_elements] = STATE(6840),
    [sym_interface_implementation] = STATE(6862),
    [sym_member_defn] = STATE(6862),
    [sym_additional_constr_defn] = STATE(6864),
    [sym_class_inherits_decl] = STATE(9527),
    [sym_long_identifier] = STATE(6600),
    [sym_block_comment] = STATE(4158),
    [sym_compiler_directive_decl] = STATE(4158),
    [sym_fsi_directive_decl] = STATE(4158),
    [sym_preproc_line] = STATE(4158),
    [sym_preproc_if_in_class_definition] = STATE(6840),
    [aux_sym_attributes_repeat1] = STATE(7077),
    [sym_identifier] = ACTIONS(6856),
    [anon_sym_LBRACK_LT] = ACTIONS(6858),
    [anon_sym_do] = ACTIONS(6860),
    [anon_sym_let] = ACTIONS(6862),
    [anon_sym_let_BANG] = ACTIONS(6864),
    [aux_sym_access_modifier_token1] = ACTIONS(5109),
    [anon_sym_LPAREN] = ACTIONS(6866),
    [anon_sym__] = ACTIONS(6868),
    [anon_sym_PIPE] = ACTIONS(6870),
    [anon_sym_LBRACE] = ACTIONS(6923),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6874),
    [anon_sym_new] = ACTIONS(6876),
    [anon_sym_with] = ACTIONS(6878),
    [anon_sym_POUND] = ACTIONS(6880),
    [anon_sym_CARET] = ACTIONS(6882),
    [anon_sym_SQUOTE] = ACTIONS(6882),
    [anon_sym_delegate] = ACTIONS(6884),
    [anon_sym_default] = ACTIONS(6886),
    [anon_sym_static] = ACTIONS(6888),
    [anon_sym_member] = ACTIONS(6890),
    [anon_sym_interface] = ACTIONS(6892),
    [anon_sym_abstract] = ACTIONS(6894),
    [anon_sym_val] = ACTIONS(6896),
    [anon_sym_override] = ACTIONS(6886),
    [anon_sym_inherit] = ACTIONS(6898),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6900),
  },
  [4159] = {
    [sym_block_comment] = STATE(4159),
    [sym_compiler_directive_decl] = STATE(4159),
    [sym_fsi_directive_decl] = STATE(4159),
    [sym_preproc_line] = STATE(4159),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_GT_RBRACK] = ACTIONS(3513),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(6925),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3513),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3513),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3513),
    [anon_sym_DASH_DOT] = ACTIONS(3513),
    [anon_sym_PERCENT] = ACTIONS(3513),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3513),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
  },
  [4160] = {
    [sym_block_comment] = STATE(4160),
    [sym_compiler_directive_decl] = STATE(4160),
    [sym_fsi_directive_decl] = STATE(4160),
    [sym_preproc_line] = STATE(4160),
    [ts_builtin_sym_end] = ACTIONS(4973),
    [sym_identifier] = ACTIONS(4975),
    [anon_sym_namespace] = ACTIONS(4975),
    [anon_sym_module] = ACTIONS(4975),
    [anon_sym_open] = ACTIONS(4975),
    [anon_sym_LBRACK_LT] = ACTIONS(4973),
    [anon_sym_return] = ACTIONS(4975),
    [anon_sym_type] = ACTIONS(4975),
    [anon_sym_do] = ACTIONS(4975),
    [anon_sym_let] = ACTIONS(4975),
    [anon_sym_let_BANG] = ACTIONS(4973),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [anon_sym_null] = ACTIONS(4975),
    [anon_sym_AMP] = ACTIONS(4975),
    [anon_sym_LBRACK] = ACTIONS(4975),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4973),
    [anon_sym_LBRACE] = ACTIONS(4975),
    [anon_sym_LT_AT] = ACTIONS(4975),
    [anon_sym_LT_AT_AT] = ACTIONS(4973),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4973),
    [anon_sym_new] = ACTIONS(4975),
    [anon_sym_return_BANG] = ACTIONS(4973),
    [anon_sym_yield] = ACTIONS(4975),
    [anon_sym_yield_BANG] = ACTIONS(4973),
    [anon_sym_lazy] = ACTIONS(4975),
    [anon_sym_assert] = ACTIONS(4975),
    [anon_sym_upcast] = ACTIONS(4975),
    [anon_sym_downcast] = ACTIONS(4975),
    [anon_sym_for] = ACTIONS(4975),
    [anon_sym_while] = ACTIONS(4975),
    [anon_sym_if] = ACTIONS(4975),
    [anon_sym_fun] = ACTIONS(4975),
    [anon_sym_try] = ACTIONS(4975),
    [anon_sym_match] = ACTIONS(4975),
    [anon_sym_match_BANG] = ACTIONS(4973),
    [anon_sym_function] = ACTIONS(4975),
    [anon_sym_use] = ACTIONS(4975),
    [anon_sym_use_BANG] = ACTIONS(4973),
    [anon_sym_do_BANG] = ACTIONS(4973),
    [anon_sym_begin] = ACTIONS(4975),
    [anon_sym_exception] = ACTIONS(4975),
    [aux_sym_char_token1] = ACTIONS(4973),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4975),
    [anon_sym_DQUOTE] = ACTIONS(4975),
    [anon_sym_AT_DQUOTE] = ACTIONS(4973),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4973),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4973),
    [sym_bool] = ACTIONS(4975),
    [sym_unit] = ACTIONS(4973),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4975),
    [sym_op_identifier] = ACTIONS(4973),
    [anon_sym_PLUS] = ACTIONS(4975),
    [anon_sym_DASH] = ACTIONS(4975),
    [anon_sym_PLUS_DOT] = ACTIONS(4973),
    [anon_sym_DASH_DOT] = ACTIONS(4973),
    [anon_sym_PERCENT] = ACTIONS(4973),
    [anon_sym_AMP_AMP] = ACTIONS(4973),
    [anon_sym_TILDE] = ACTIONS(4973),
    [aux_sym_prefix_op_token1] = ACTIONS(4973),
    [sym_int] = ACTIONS(4975),
    [sym_xint] = ACTIONS(4973),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(4973),
    [anon_sym_POUNDload] = ACTIONS(4973),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4973),
  },
  [4161] = {
    [sym_attributes] = STATE(6985),
    [sym__attribute_set] = STATE(7246),
    [sym_function_or_value_defn] = STATE(6835),
    [sym_access_modifier] = STATE(7740),
    [sym__type] = STATE(8045),
    [sym_simple_type] = STATE(6550),
    [sym_generic_type] = STATE(6550),
    [sym_paren_type] = STATE(6550),
    [sym_function_type] = STATE(6550),
    [sym_compound_type] = STATE(6550),
    [sym_postfix_type] = STATE(6550),
    [sym_list_type] = STATE(6550),
    [sym_static_type] = STATE(6550),
    [sym_constrained_type] = STATE(6550),
    [sym_flexible_type] = STATE(6550),
    [sym_anon_record_type] = STATE(6550),
    [sym__static_type_identifier] = STATE(6214),
    [sym_type_argument] = STATE(6488),
    [sym_delegate_signature] = STATE(11841),
    [sym__class_type_body_inner] = STATE(9306),
    [sym__class_type_body] = STATE(11840),
    [sym_enum_type_cases] = STATE(11839),
    [sym_enum_type_case] = STATE(10606),
    [sym_union_type_cases] = STATE(5263),
    [sym_union_type_case] = STATE(6531),
    [sym__class_function_or_value_defn] = STATE(6840),
    [aux_sym__type_extension_inner] = STATE(5324),
    [sym_type_extension_elements] = STATE(9527),
    [sym__type_defn_elements] = STATE(6840),
    [sym_interface_implementation] = STATE(6862),
    [sym_member_defn] = STATE(6862),
    [sym_additional_constr_defn] = STATE(6864),
    [sym_class_inherits_decl] = STATE(9527),
    [sym_long_identifier] = STATE(6600),
    [sym_block_comment] = STATE(4161),
    [sym_compiler_directive_decl] = STATE(4161),
    [sym_fsi_directive_decl] = STATE(4161),
    [sym_preproc_line] = STATE(4161),
    [sym_preproc_if_in_class_definition] = STATE(6840),
    [aux_sym_attributes_repeat1] = STATE(7077),
    [sym_identifier] = ACTIONS(6856),
    [anon_sym_LBRACK_LT] = ACTIONS(6858),
    [anon_sym_do] = ACTIONS(6860),
    [anon_sym_let] = ACTIONS(6862),
    [anon_sym_let_BANG] = ACTIONS(6864),
    [aux_sym_access_modifier_token1] = ACTIONS(5109),
    [anon_sym_LPAREN] = ACTIONS(6866),
    [anon_sym__] = ACTIONS(6868),
    [anon_sym_PIPE] = ACTIONS(6870),
    [anon_sym_LBRACE] = ACTIONS(6927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6874),
    [anon_sym_new] = ACTIONS(6876),
    [anon_sym_with] = ACTIONS(6878),
    [anon_sym_POUND] = ACTIONS(6880),
    [anon_sym_CARET] = ACTIONS(6882),
    [anon_sym_SQUOTE] = ACTIONS(6882),
    [anon_sym_delegate] = ACTIONS(6884),
    [anon_sym_default] = ACTIONS(6886),
    [anon_sym_static] = ACTIONS(6888),
    [anon_sym_member] = ACTIONS(6890),
    [anon_sym_interface] = ACTIONS(6892),
    [anon_sym_abstract] = ACTIONS(6894),
    [anon_sym_val] = ACTIONS(6896),
    [anon_sym_override] = ACTIONS(6886),
    [anon_sym_inherit] = ACTIONS(6898),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6900),
  },
  [4162] = {
    [sym_block_comment] = STATE(4162),
    [sym_compiler_directive_decl] = STATE(4162),
    [sym_fsi_directive_decl] = STATE(4162),
    [sym_preproc_line] = STATE(4162),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_GT_RBRACK] = ACTIONS(3485),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3485),
    [anon_sym_DOT] = ACTIONS(3485),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3485),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3485),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3485),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3485),
    [anon_sym_DASH_DOT] = ACTIONS(3485),
    [anon_sym_PERCENT] = ACTIONS(3485),
    [anon_sym_AMP_AMP] = ACTIONS(3485),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3485),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__newline] = ACTIONS(3485),
  },
  [4163] = {
    [sym_block_comment] = STATE(4163),
    [sym_compiler_directive_decl] = STATE(4163),
    [sym_fsi_directive_decl] = STATE(4163),
    [sym_preproc_line] = STATE(4163),
    [ts_builtin_sym_end] = ACTIONS(6929),
    [sym_identifier] = ACTIONS(6931),
    [anon_sym_namespace] = ACTIONS(6931),
    [anon_sym_module] = ACTIONS(6931),
    [anon_sym_open] = ACTIONS(6931),
    [anon_sym_LBRACK_LT] = ACTIONS(6929),
    [anon_sym_return] = ACTIONS(6931),
    [anon_sym_type] = ACTIONS(6931),
    [anon_sym_do] = ACTIONS(6931),
    [anon_sym_let] = ACTIONS(6931),
    [anon_sym_let_BANG] = ACTIONS(6929),
    [anon_sym_LPAREN] = ACTIONS(6931),
    [anon_sym_null] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6931),
    [anon_sym_LBRACK] = ACTIONS(6931),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6929),
    [anon_sym_LBRACE] = ACTIONS(6931),
    [anon_sym_LT_AT] = ACTIONS(6931),
    [anon_sym_LT_AT_AT] = ACTIONS(6929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6929),
    [anon_sym_new] = ACTIONS(6931),
    [anon_sym_return_BANG] = ACTIONS(6929),
    [anon_sym_yield] = ACTIONS(6931),
    [anon_sym_yield_BANG] = ACTIONS(6929),
    [anon_sym_lazy] = ACTIONS(6931),
    [anon_sym_assert] = ACTIONS(6931),
    [anon_sym_upcast] = ACTIONS(6931),
    [anon_sym_downcast] = ACTIONS(6931),
    [anon_sym_for] = ACTIONS(6931),
    [anon_sym_while] = ACTIONS(6931),
    [anon_sym_if] = ACTIONS(6931),
    [anon_sym_fun] = ACTIONS(6931),
    [anon_sym_try] = ACTIONS(6931),
    [anon_sym_match] = ACTIONS(6931),
    [anon_sym_match_BANG] = ACTIONS(6929),
    [anon_sym_function] = ACTIONS(6931),
    [anon_sym_use] = ACTIONS(6931),
    [anon_sym_use_BANG] = ACTIONS(6929),
    [anon_sym_do_BANG] = ACTIONS(6929),
    [anon_sym_begin] = ACTIONS(6931),
    [anon_sym_exception] = ACTIONS(6931),
    [aux_sym_char_token1] = ACTIONS(6929),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6931),
    [anon_sym_DQUOTE] = ACTIONS(6931),
    [anon_sym_AT_DQUOTE] = ACTIONS(6929),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6929),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6929),
    [sym_bool] = ACTIONS(6931),
    [sym_unit] = ACTIONS(6929),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6931),
    [sym_op_identifier] = ACTIONS(6929),
    [anon_sym_PLUS] = ACTIONS(6931),
    [anon_sym_DASH] = ACTIONS(6931),
    [anon_sym_PLUS_DOT] = ACTIONS(6929),
    [anon_sym_DASH_DOT] = ACTIONS(6929),
    [anon_sym_PERCENT] = ACTIONS(6929),
    [anon_sym_AMP_AMP] = ACTIONS(6929),
    [anon_sym_TILDE] = ACTIONS(6929),
    [aux_sym_prefix_op_token1] = ACTIONS(6929),
    [sym_int] = ACTIONS(6931),
    [sym_xint] = ACTIONS(6929),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6929),
    [anon_sym_POUNDload] = ACTIONS(6929),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6929),
  },
  [4164] = {
    [sym_block_comment] = STATE(4164),
    [sym_compiler_directive_decl] = STATE(4164),
    [sym_fsi_directive_decl] = STATE(4164),
    [sym_preproc_line] = STATE(4164),
    [ts_builtin_sym_end] = ACTIONS(6316),
    [sym_identifier] = ACTIONS(6318),
    [anon_sym_namespace] = ACTIONS(6318),
    [anon_sym_module] = ACTIONS(6318),
    [anon_sym_open] = ACTIONS(6318),
    [anon_sym_LBRACK_LT] = ACTIONS(6316),
    [anon_sym_return] = ACTIONS(6318),
    [anon_sym_type] = ACTIONS(6318),
    [anon_sym_do] = ACTIONS(6318),
    [anon_sym_let] = ACTIONS(6318),
    [anon_sym_let_BANG] = ACTIONS(6316),
    [anon_sym_LPAREN] = ACTIONS(6318),
    [anon_sym_null] = ACTIONS(6318),
    [anon_sym_AMP] = ACTIONS(6318),
    [anon_sym_LBRACK] = ACTIONS(6318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6316),
    [anon_sym_LBRACE] = ACTIONS(6318),
    [anon_sym_LT_AT] = ACTIONS(6318),
    [anon_sym_LT_AT_AT] = ACTIONS(6316),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6316),
    [anon_sym_new] = ACTIONS(6318),
    [anon_sym_return_BANG] = ACTIONS(6316),
    [anon_sym_yield] = ACTIONS(6318),
    [anon_sym_yield_BANG] = ACTIONS(6316),
    [anon_sym_lazy] = ACTIONS(6318),
    [anon_sym_assert] = ACTIONS(6318),
    [anon_sym_upcast] = ACTIONS(6318),
    [anon_sym_downcast] = ACTIONS(6318),
    [anon_sym_for] = ACTIONS(6318),
    [anon_sym_while] = ACTIONS(6318),
    [anon_sym_if] = ACTIONS(6318),
    [anon_sym_fun] = ACTIONS(6318),
    [anon_sym_try] = ACTIONS(6318),
    [anon_sym_match] = ACTIONS(6318),
    [anon_sym_match_BANG] = ACTIONS(6316),
    [anon_sym_function] = ACTIONS(6318),
    [anon_sym_use] = ACTIONS(6318),
    [anon_sym_use_BANG] = ACTIONS(6316),
    [anon_sym_do_BANG] = ACTIONS(6316),
    [anon_sym_begin] = ACTIONS(6318),
    [anon_sym_exception] = ACTIONS(6318),
    [aux_sym_char_token1] = ACTIONS(6316),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6318),
    [anon_sym_DQUOTE] = ACTIONS(6318),
    [anon_sym_AT_DQUOTE] = ACTIONS(6316),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6316),
    [sym_bool] = ACTIONS(6318),
    [sym_unit] = ACTIONS(6316),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6318),
    [sym_op_identifier] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6318),
    [anon_sym_DASH] = ACTIONS(6318),
    [anon_sym_PLUS_DOT] = ACTIONS(6316),
    [anon_sym_DASH_DOT] = ACTIONS(6316),
    [anon_sym_PERCENT] = ACTIONS(6316),
    [anon_sym_AMP_AMP] = ACTIONS(6316),
    [anon_sym_TILDE] = ACTIONS(6316),
    [aux_sym_prefix_op_token1] = ACTIONS(6316),
    [sym_int] = ACTIONS(6318),
    [sym_xint] = ACTIONS(6316),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6316),
    [anon_sym_POUNDload] = ACTIONS(6316),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6316),
  },
  [4165] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(11757),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4165),
    [sym_compiler_directive_decl] = STATE(4165),
    [sym_fsi_directive_decl] = STATE(4165),
    [sym_preproc_line] = STATE(4165),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4166] = {
    [sym_block_comment] = STATE(4166),
    [sym_compiler_directive_decl] = STATE(4166),
    [sym_fsi_directive_decl] = STATE(4166),
    [sym_preproc_line] = STATE(4166),
    [ts_builtin_sym_end] = ACTIONS(6933),
    [sym_identifier] = ACTIONS(6935),
    [anon_sym_namespace] = ACTIONS(6935),
    [anon_sym_module] = ACTIONS(6935),
    [anon_sym_open] = ACTIONS(6935),
    [anon_sym_LBRACK_LT] = ACTIONS(6933),
    [anon_sym_return] = ACTIONS(6935),
    [anon_sym_type] = ACTIONS(6935),
    [anon_sym_do] = ACTIONS(6935),
    [anon_sym_let] = ACTIONS(6935),
    [anon_sym_let_BANG] = ACTIONS(6933),
    [anon_sym_LPAREN] = ACTIONS(6935),
    [anon_sym_null] = ACTIONS(6935),
    [anon_sym_AMP] = ACTIONS(6935),
    [anon_sym_LBRACK] = ACTIONS(6935),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6933),
    [anon_sym_LBRACE] = ACTIONS(6935),
    [anon_sym_LT_AT] = ACTIONS(6935),
    [anon_sym_LT_AT_AT] = ACTIONS(6933),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6933),
    [anon_sym_new] = ACTIONS(6935),
    [anon_sym_return_BANG] = ACTIONS(6933),
    [anon_sym_yield] = ACTIONS(6935),
    [anon_sym_yield_BANG] = ACTIONS(6933),
    [anon_sym_lazy] = ACTIONS(6935),
    [anon_sym_assert] = ACTIONS(6935),
    [anon_sym_upcast] = ACTIONS(6935),
    [anon_sym_downcast] = ACTIONS(6935),
    [anon_sym_for] = ACTIONS(6935),
    [anon_sym_while] = ACTIONS(6935),
    [anon_sym_if] = ACTIONS(6935),
    [anon_sym_fun] = ACTIONS(6935),
    [anon_sym_try] = ACTIONS(6935),
    [anon_sym_match] = ACTIONS(6935),
    [anon_sym_match_BANG] = ACTIONS(6933),
    [anon_sym_function] = ACTIONS(6935),
    [anon_sym_use] = ACTIONS(6935),
    [anon_sym_use_BANG] = ACTIONS(6933),
    [anon_sym_do_BANG] = ACTIONS(6933),
    [anon_sym_begin] = ACTIONS(6935),
    [anon_sym_exception] = ACTIONS(6935),
    [aux_sym_char_token1] = ACTIONS(6933),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6935),
    [anon_sym_DQUOTE] = ACTIONS(6935),
    [anon_sym_AT_DQUOTE] = ACTIONS(6933),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6933),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6933),
    [sym_bool] = ACTIONS(6935),
    [sym_unit] = ACTIONS(6933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6935),
    [sym_op_identifier] = ACTIONS(6933),
    [anon_sym_PLUS] = ACTIONS(6935),
    [anon_sym_DASH] = ACTIONS(6935),
    [anon_sym_PLUS_DOT] = ACTIONS(6933),
    [anon_sym_DASH_DOT] = ACTIONS(6933),
    [anon_sym_PERCENT] = ACTIONS(6933),
    [anon_sym_AMP_AMP] = ACTIONS(6933),
    [anon_sym_TILDE] = ACTIONS(6933),
    [aux_sym_prefix_op_token1] = ACTIONS(6933),
    [sym_int] = ACTIONS(6935),
    [sym_xint] = ACTIONS(6933),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6933),
    [anon_sym_POUNDload] = ACTIONS(6933),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6933),
  },
  [4167] = {
    [sym_block_comment] = STATE(4167),
    [sym_compiler_directive_decl] = STATE(4167),
    [sym_fsi_directive_decl] = STATE(4167),
    [sym_preproc_line] = STATE(4167),
    [ts_builtin_sym_end] = ACTIONS(6386),
    [sym_identifier] = ACTIONS(6388),
    [anon_sym_namespace] = ACTIONS(6388),
    [anon_sym_module] = ACTIONS(6388),
    [anon_sym_open] = ACTIONS(6388),
    [anon_sym_LBRACK_LT] = ACTIONS(6386),
    [anon_sym_return] = ACTIONS(6388),
    [anon_sym_type] = ACTIONS(6388),
    [anon_sym_do] = ACTIONS(6388),
    [anon_sym_let] = ACTIONS(6388),
    [anon_sym_let_BANG] = ACTIONS(6386),
    [anon_sym_LPAREN] = ACTIONS(6388),
    [anon_sym_null] = ACTIONS(6388),
    [anon_sym_AMP] = ACTIONS(6388),
    [anon_sym_LBRACK] = ACTIONS(6388),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6386),
    [anon_sym_LBRACE] = ACTIONS(6388),
    [anon_sym_LT_AT] = ACTIONS(6388),
    [anon_sym_LT_AT_AT] = ACTIONS(6386),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6386),
    [anon_sym_new] = ACTIONS(6388),
    [anon_sym_return_BANG] = ACTIONS(6386),
    [anon_sym_yield] = ACTIONS(6388),
    [anon_sym_yield_BANG] = ACTIONS(6386),
    [anon_sym_lazy] = ACTIONS(6388),
    [anon_sym_assert] = ACTIONS(6388),
    [anon_sym_upcast] = ACTIONS(6388),
    [anon_sym_downcast] = ACTIONS(6388),
    [anon_sym_for] = ACTIONS(6388),
    [anon_sym_while] = ACTIONS(6388),
    [anon_sym_if] = ACTIONS(6388),
    [anon_sym_fun] = ACTIONS(6388),
    [anon_sym_try] = ACTIONS(6388),
    [anon_sym_match] = ACTIONS(6388),
    [anon_sym_match_BANG] = ACTIONS(6386),
    [anon_sym_function] = ACTIONS(6388),
    [anon_sym_use] = ACTIONS(6388),
    [anon_sym_use_BANG] = ACTIONS(6386),
    [anon_sym_do_BANG] = ACTIONS(6386),
    [anon_sym_begin] = ACTIONS(6388),
    [anon_sym_exception] = ACTIONS(6388),
    [aux_sym_char_token1] = ACTIONS(6386),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6388),
    [anon_sym_DQUOTE] = ACTIONS(6388),
    [anon_sym_AT_DQUOTE] = ACTIONS(6386),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6386),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6386),
    [sym_bool] = ACTIONS(6388),
    [sym_unit] = ACTIONS(6386),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6388),
    [sym_op_identifier] = ACTIONS(6386),
    [anon_sym_PLUS] = ACTIONS(6388),
    [anon_sym_DASH] = ACTIONS(6388),
    [anon_sym_PLUS_DOT] = ACTIONS(6386),
    [anon_sym_DASH_DOT] = ACTIONS(6386),
    [anon_sym_PERCENT] = ACTIONS(6386),
    [anon_sym_AMP_AMP] = ACTIONS(6386),
    [anon_sym_TILDE] = ACTIONS(6386),
    [aux_sym_prefix_op_token1] = ACTIONS(6386),
    [sym_int] = ACTIONS(6388),
    [sym_xint] = ACTIONS(6386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6386),
    [anon_sym_POUNDload] = ACTIONS(6386),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6386),
  },
  [4168] = {
    [sym_block_comment] = STATE(4168),
    [sym_compiler_directive_decl] = STATE(4168),
    [sym_fsi_directive_decl] = STATE(4168),
    [sym_preproc_line] = STATE(4168),
    [ts_builtin_sym_end] = ACTIONS(6937),
    [sym_identifier] = ACTIONS(6939),
    [anon_sym_namespace] = ACTIONS(6939),
    [anon_sym_module] = ACTIONS(6939),
    [anon_sym_open] = ACTIONS(6939),
    [anon_sym_LBRACK_LT] = ACTIONS(6937),
    [anon_sym_return] = ACTIONS(6939),
    [anon_sym_type] = ACTIONS(6939),
    [anon_sym_do] = ACTIONS(6939),
    [anon_sym_let] = ACTIONS(6939),
    [anon_sym_let_BANG] = ACTIONS(6937),
    [anon_sym_LPAREN] = ACTIONS(6939),
    [anon_sym_null] = ACTIONS(6939),
    [anon_sym_AMP] = ACTIONS(6939),
    [anon_sym_LBRACK] = ACTIONS(6939),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6937),
    [anon_sym_LBRACE] = ACTIONS(6939),
    [anon_sym_LT_AT] = ACTIONS(6939),
    [anon_sym_LT_AT_AT] = ACTIONS(6937),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6937),
    [anon_sym_new] = ACTIONS(6939),
    [anon_sym_return_BANG] = ACTIONS(6937),
    [anon_sym_yield] = ACTIONS(6939),
    [anon_sym_yield_BANG] = ACTIONS(6937),
    [anon_sym_lazy] = ACTIONS(6939),
    [anon_sym_assert] = ACTIONS(6939),
    [anon_sym_upcast] = ACTIONS(6939),
    [anon_sym_downcast] = ACTIONS(6939),
    [anon_sym_for] = ACTIONS(6939),
    [anon_sym_while] = ACTIONS(6939),
    [anon_sym_if] = ACTIONS(6939),
    [anon_sym_fun] = ACTIONS(6939),
    [anon_sym_try] = ACTIONS(6939),
    [anon_sym_match] = ACTIONS(6939),
    [anon_sym_match_BANG] = ACTIONS(6937),
    [anon_sym_function] = ACTIONS(6939),
    [anon_sym_use] = ACTIONS(6939),
    [anon_sym_use_BANG] = ACTIONS(6937),
    [anon_sym_do_BANG] = ACTIONS(6937),
    [anon_sym_begin] = ACTIONS(6939),
    [anon_sym_exception] = ACTIONS(6939),
    [aux_sym_char_token1] = ACTIONS(6937),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6939),
    [anon_sym_DQUOTE] = ACTIONS(6939),
    [anon_sym_AT_DQUOTE] = ACTIONS(6937),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6937),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6937),
    [sym_bool] = ACTIONS(6939),
    [sym_unit] = ACTIONS(6937),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6939),
    [sym_op_identifier] = ACTIONS(6937),
    [anon_sym_PLUS] = ACTIONS(6939),
    [anon_sym_DASH] = ACTIONS(6939),
    [anon_sym_PLUS_DOT] = ACTIONS(6937),
    [anon_sym_DASH_DOT] = ACTIONS(6937),
    [anon_sym_PERCENT] = ACTIONS(6937),
    [anon_sym_AMP_AMP] = ACTIONS(6937),
    [anon_sym_TILDE] = ACTIONS(6937),
    [aux_sym_prefix_op_token1] = ACTIONS(6937),
    [sym_int] = ACTIONS(6939),
    [sym_xint] = ACTIONS(6937),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6937),
    [anon_sym_POUNDload] = ACTIONS(6937),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6937),
  },
  [4169] = {
    [sym_block_comment] = STATE(4169),
    [sym_compiler_directive_decl] = STATE(4169),
    [sym_fsi_directive_decl] = STATE(4169),
    [sym_preproc_line] = STATE(4169),
    [aux_sym_long_identifier_repeat1] = STATE(4148),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_let_BANG] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_null] = ACTIONS(3451),
    [anon_sym_AMP] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_LT_AT] = ACTIONS(3451),
    [anon_sym_LT_AT_AT] = ACTIONS(3449),
    [anon_sym_DOT] = ACTIONS(6941),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_return_BANG] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_yield_BANG] = ACTIONS(3449),
    [anon_sym_lazy] = ACTIONS(3451),
    [anon_sym_assert] = ACTIONS(3451),
    [anon_sym_upcast] = ACTIONS(3451),
    [anon_sym_downcast] = ACTIONS(3451),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_fun] = ACTIONS(3451),
    [anon_sym_DASH_GT] = ACTIONS(3449),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_match] = ACTIONS(3451),
    [anon_sym_match_BANG] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_use] = ACTIONS(3451),
    [anon_sym_use_BANG] = ACTIONS(3449),
    [anon_sym_do_BANG] = ACTIONS(3449),
    [anon_sym_begin] = ACTIONS(3451),
    [anon_sym_STAR] = ACTIONS(3449),
    [anon_sym_LT2] = ACTIONS(3451),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3449),
    [aux_sym_char_token1] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_AT_DQUOTE] = ACTIONS(3449),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3449),
    [sym_bool] = ACTIONS(3451),
    [sym_unit] = ACTIONS(3449),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3451),
    [sym_op_identifier] = ACTIONS(3449),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_PLUS_DOT] = ACTIONS(3449),
    [anon_sym_DASH_DOT] = ACTIONS(3449),
    [anon_sym_PERCENT] = ACTIONS(3449),
    [anon_sym_AMP_AMP] = ACTIONS(3449),
    [anon_sym_TILDE] = ACTIONS(3449),
    [aux_sym_prefix_op_token1] = ACTIONS(3449),
    [sym_int] = ACTIONS(3451),
    [sym_xint] = ACTIONS(3449),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3449),
    [sym__dedent] = ACTIONS(3449),
  },
  [4170] = {
    [sym_block_comment] = STATE(4170),
    [sym_compiler_directive_decl] = STATE(4170),
    [sym_fsi_directive_decl] = STATE(4170),
    [sym_preproc_line] = STATE(4170),
    [aux_sym_long_identifier_repeat1] = STATE(4169),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_return] = ACTIONS(3494),
    [anon_sym_do] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_let_BANG] = ACTIONS(3492),
    [anon_sym_LPAREN] = ACTIONS(3494),
    [anon_sym_null] = ACTIONS(3494),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3492),
    [anon_sym_LBRACE] = ACTIONS(3494),
    [anon_sym_LT_AT] = ACTIONS(3494),
    [anon_sym_LT_AT_AT] = ACTIONS(3492),
    [anon_sym_DOT] = ACTIONS(6941),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3492),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_return_BANG] = ACTIONS(3492),
    [anon_sym_yield] = ACTIONS(3494),
    [anon_sym_yield_BANG] = ACTIONS(3492),
    [anon_sym_lazy] = ACTIONS(3494),
    [anon_sym_assert] = ACTIONS(3494),
    [anon_sym_upcast] = ACTIONS(3494),
    [anon_sym_downcast] = ACTIONS(3494),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_while] = ACTIONS(3494),
    [anon_sym_if] = ACTIONS(3494),
    [anon_sym_fun] = ACTIONS(3494),
    [anon_sym_DASH_GT] = ACTIONS(3492),
    [anon_sym_try] = ACTIONS(3494),
    [anon_sym_match] = ACTIONS(3494),
    [anon_sym_match_BANG] = ACTIONS(3492),
    [anon_sym_function] = ACTIONS(3494),
    [anon_sym_use] = ACTIONS(3494),
    [anon_sym_use_BANG] = ACTIONS(3492),
    [anon_sym_do_BANG] = ACTIONS(3492),
    [anon_sym_begin] = ACTIONS(3494),
    [anon_sym_STAR] = ACTIONS(3492),
    [anon_sym_LT2] = ACTIONS(3494),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3492),
    [aux_sym_char_token1] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3494),
    [anon_sym_DQUOTE] = ACTIONS(3494),
    [anon_sym_AT_DQUOTE] = ACTIONS(3492),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3492),
    [sym_bool] = ACTIONS(3494),
    [sym_unit] = ACTIONS(3492),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3494),
    [sym_op_identifier] = ACTIONS(3492),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_PLUS_DOT] = ACTIONS(3492),
    [anon_sym_DASH_DOT] = ACTIONS(3492),
    [anon_sym_PERCENT] = ACTIONS(3492),
    [anon_sym_AMP_AMP] = ACTIONS(3492),
    [anon_sym_TILDE] = ACTIONS(3492),
    [aux_sym_prefix_op_token1] = ACTIONS(3492),
    [sym_int] = ACTIONS(3494),
    [sym_xint] = ACTIONS(3492),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3492),
    [sym__dedent] = ACTIONS(3492),
  },
  [4171] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(11505),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4171),
    [sym_compiler_directive_decl] = STATE(4171),
    [sym_fsi_directive_decl] = STATE(4171),
    [sym_preproc_line] = STATE(4171),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4172] = {
    [sym_block_comment] = STATE(4172),
    [sym_compiler_directive_decl] = STATE(4172),
    [sym_fsi_directive_decl] = STATE(4172),
    [sym_preproc_line] = STATE(4172),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_GT_RBRACK] = ACTIONS(3496),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3496),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3496),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3496),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3496),
    [anon_sym_DASH_DOT] = ACTIONS(3496),
    [anon_sym_PERCENT] = ACTIONS(3496),
    [anon_sym_AMP_AMP] = ACTIONS(3496),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3496),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [sym__newline] = ACTIONS(3496),
  },
  [4173] = {
    [sym_block_comment] = STATE(4173),
    [sym_compiler_directive_decl] = STATE(4173),
    [sym_fsi_directive_decl] = STATE(4173),
    [sym_preproc_line] = STATE(4173),
    [ts_builtin_sym_end] = ACTIONS(6943),
    [sym_identifier] = ACTIONS(6945),
    [anon_sym_namespace] = ACTIONS(6945),
    [anon_sym_module] = ACTIONS(6945),
    [anon_sym_open] = ACTIONS(6945),
    [anon_sym_LBRACK_LT] = ACTIONS(6943),
    [anon_sym_return] = ACTIONS(6945),
    [anon_sym_type] = ACTIONS(6945),
    [anon_sym_do] = ACTIONS(6945),
    [anon_sym_let] = ACTIONS(6945),
    [anon_sym_let_BANG] = ACTIONS(6943),
    [anon_sym_LPAREN] = ACTIONS(6945),
    [anon_sym_null] = ACTIONS(6945),
    [anon_sym_AMP] = ACTIONS(6945),
    [anon_sym_LBRACK] = ACTIONS(6945),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6943),
    [anon_sym_LBRACE] = ACTIONS(6945),
    [anon_sym_LT_AT] = ACTIONS(6945),
    [anon_sym_LT_AT_AT] = ACTIONS(6943),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6943),
    [anon_sym_new] = ACTIONS(6945),
    [anon_sym_return_BANG] = ACTIONS(6943),
    [anon_sym_yield] = ACTIONS(6945),
    [anon_sym_yield_BANG] = ACTIONS(6943),
    [anon_sym_lazy] = ACTIONS(6945),
    [anon_sym_assert] = ACTIONS(6945),
    [anon_sym_upcast] = ACTIONS(6945),
    [anon_sym_downcast] = ACTIONS(6945),
    [anon_sym_for] = ACTIONS(6945),
    [anon_sym_while] = ACTIONS(6945),
    [anon_sym_if] = ACTIONS(6945),
    [anon_sym_fun] = ACTIONS(6945),
    [anon_sym_try] = ACTIONS(6945),
    [anon_sym_match] = ACTIONS(6945),
    [anon_sym_match_BANG] = ACTIONS(6943),
    [anon_sym_function] = ACTIONS(6945),
    [anon_sym_use] = ACTIONS(6945),
    [anon_sym_use_BANG] = ACTIONS(6943),
    [anon_sym_do_BANG] = ACTIONS(6943),
    [anon_sym_begin] = ACTIONS(6945),
    [anon_sym_exception] = ACTIONS(6945),
    [aux_sym_char_token1] = ACTIONS(6943),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6945),
    [anon_sym_DQUOTE] = ACTIONS(6945),
    [anon_sym_AT_DQUOTE] = ACTIONS(6943),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6943),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6943),
    [sym_bool] = ACTIONS(6945),
    [sym_unit] = ACTIONS(6943),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6945),
    [sym_op_identifier] = ACTIONS(6943),
    [anon_sym_PLUS] = ACTIONS(6945),
    [anon_sym_DASH] = ACTIONS(6945),
    [anon_sym_PLUS_DOT] = ACTIONS(6943),
    [anon_sym_DASH_DOT] = ACTIONS(6943),
    [anon_sym_PERCENT] = ACTIONS(6943),
    [anon_sym_AMP_AMP] = ACTIONS(6943),
    [anon_sym_TILDE] = ACTIONS(6943),
    [aux_sym_prefix_op_token1] = ACTIONS(6943),
    [sym_int] = ACTIONS(6945),
    [sym_xint] = ACTIONS(6943),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6943),
    [anon_sym_POUNDload] = ACTIONS(6943),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6943),
  },
  [4174] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(11835),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4174),
    [sym_compiler_directive_decl] = STATE(4174),
    [sym_fsi_directive_decl] = STATE(4174),
    [sym_preproc_line] = STATE(4174),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4175] = {
    [sym_block_comment] = STATE(4175),
    [sym_compiler_directive_decl] = STATE(4175),
    [sym_fsi_directive_decl] = STATE(4175),
    [sym_preproc_line] = STATE(4175),
    [aux_sym_compound_type_repeat1] = STATE(4175),
    [sym_identifier] = ACTIONS(3427),
    [anon_sym_GT_RBRACK] = ACTIONS(3425),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3425),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(3425),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(6947),
    [anon_sym_LT2] = ACTIONS(3427),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3425),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3425),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3425),
    [anon_sym_DASH_DOT] = ACTIONS(3425),
    [anon_sym_PERCENT] = ACTIONS(3425),
    [anon_sym_AMP_AMP] = ACTIONS(3425),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3425),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [sym__newline] = ACTIONS(3425),
  },
  [4176] = {
    [sym_block_comment] = STATE(4176),
    [sym_compiler_directive_decl] = STATE(4176),
    [sym_fsi_directive_decl] = STATE(4176),
    [sym_preproc_line] = STATE(4176),
    [ts_builtin_sym_end] = ACTIONS(6950),
    [sym_identifier] = ACTIONS(6952),
    [anon_sym_namespace] = ACTIONS(6952),
    [anon_sym_module] = ACTIONS(6952),
    [anon_sym_open] = ACTIONS(6952),
    [anon_sym_LBRACK_LT] = ACTIONS(6950),
    [anon_sym_return] = ACTIONS(6952),
    [anon_sym_type] = ACTIONS(6952),
    [anon_sym_do] = ACTIONS(6952),
    [anon_sym_let] = ACTIONS(6952),
    [anon_sym_let_BANG] = ACTIONS(6950),
    [anon_sym_LPAREN] = ACTIONS(6952),
    [anon_sym_null] = ACTIONS(6952),
    [anon_sym_AMP] = ACTIONS(6952),
    [anon_sym_LBRACK] = ACTIONS(6952),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6950),
    [anon_sym_LBRACE] = ACTIONS(6952),
    [anon_sym_LT_AT] = ACTIONS(6952),
    [anon_sym_LT_AT_AT] = ACTIONS(6950),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6950),
    [anon_sym_new] = ACTIONS(6952),
    [anon_sym_return_BANG] = ACTIONS(6950),
    [anon_sym_yield] = ACTIONS(6952),
    [anon_sym_yield_BANG] = ACTIONS(6950),
    [anon_sym_lazy] = ACTIONS(6952),
    [anon_sym_assert] = ACTIONS(6952),
    [anon_sym_upcast] = ACTIONS(6952),
    [anon_sym_downcast] = ACTIONS(6952),
    [anon_sym_for] = ACTIONS(6952),
    [anon_sym_while] = ACTIONS(6952),
    [anon_sym_if] = ACTIONS(6952),
    [anon_sym_fun] = ACTIONS(6952),
    [anon_sym_try] = ACTIONS(6952),
    [anon_sym_match] = ACTIONS(6952),
    [anon_sym_match_BANG] = ACTIONS(6950),
    [anon_sym_function] = ACTIONS(6952),
    [anon_sym_use] = ACTIONS(6952),
    [anon_sym_use_BANG] = ACTIONS(6950),
    [anon_sym_do_BANG] = ACTIONS(6950),
    [anon_sym_begin] = ACTIONS(6952),
    [anon_sym_exception] = ACTIONS(6952),
    [aux_sym_char_token1] = ACTIONS(6950),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6952),
    [anon_sym_DQUOTE] = ACTIONS(6952),
    [anon_sym_AT_DQUOTE] = ACTIONS(6950),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6950),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6950),
    [sym_bool] = ACTIONS(6952),
    [sym_unit] = ACTIONS(6950),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6952),
    [sym_op_identifier] = ACTIONS(6950),
    [anon_sym_PLUS] = ACTIONS(6952),
    [anon_sym_DASH] = ACTIONS(6952),
    [anon_sym_PLUS_DOT] = ACTIONS(6950),
    [anon_sym_DASH_DOT] = ACTIONS(6950),
    [anon_sym_PERCENT] = ACTIONS(6950),
    [anon_sym_AMP_AMP] = ACTIONS(6950),
    [anon_sym_TILDE] = ACTIONS(6950),
    [aux_sym_prefix_op_token1] = ACTIONS(6950),
    [sym_int] = ACTIONS(6952),
    [sym_xint] = ACTIONS(6950),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6950),
    [anon_sym_POUNDload] = ACTIONS(6950),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6950),
  },
  [4177] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(11662),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4177),
    [sym_compiler_directive_decl] = STATE(4177),
    [sym_fsi_directive_decl] = STATE(4177),
    [sym_preproc_line] = STATE(4177),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4178] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(10405),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4178),
    [sym_compiler_directive_decl] = STATE(4178),
    [sym_fsi_directive_decl] = STATE(4178),
    [sym_preproc_line] = STATE(4178),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4179] = {
    [sym_block_comment] = STATE(4179),
    [sym_compiler_directive_decl] = STATE(4179),
    [sym_fsi_directive_decl] = STATE(4179),
    [sym_preproc_line] = STATE(4179),
    [ts_builtin_sym_end] = ACTIONS(6386),
    [sym_identifier] = ACTIONS(6388),
    [anon_sym_namespace] = ACTIONS(6388),
    [anon_sym_module] = ACTIONS(6388),
    [anon_sym_open] = ACTIONS(6388),
    [anon_sym_LBRACK_LT] = ACTIONS(6386),
    [anon_sym_return] = ACTIONS(6388),
    [anon_sym_type] = ACTIONS(6388),
    [anon_sym_do] = ACTIONS(6388),
    [anon_sym_let] = ACTIONS(6388),
    [anon_sym_let_BANG] = ACTIONS(6386),
    [anon_sym_LPAREN] = ACTIONS(6388),
    [anon_sym_null] = ACTIONS(6388),
    [anon_sym_AMP] = ACTIONS(6388),
    [anon_sym_LBRACK] = ACTIONS(6388),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6386),
    [anon_sym_LBRACE] = ACTIONS(6388),
    [anon_sym_LT_AT] = ACTIONS(6388),
    [anon_sym_LT_AT_AT] = ACTIONS(6386),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6386),
    [anon_sym_new] = ACTIONS(6388),
    [anon_sym_return_BANG] = ACTIONS(6386),
    [anon_sym_yield] = ACTIONS(6388),
    [anon_sym_yield_BANG] = ACTIONS(6386),
    [anon_sym_lazy] = ACTIONS(6388),
    [anon_sym_assert] = ACTIONS(6388),
    [anon_sym_upcast] = ACTIONS(6388),
    [anon_sym_downcast] = ACTIONS(6388),
    [anon_sym_for] = ACTIONS(6388),
    [anon_sym_while] = ACTIONS(6388),
    [anon_sym_if] = ACTIONS(6388),
    [anon_sym_fun] = ACTIONS(6388),
    [anon_sym_try] = ACTIONS(6388),
    [anon_sym_match] = ACTIONS(6388),
    [anon_sym_match_BANG] = ACTIONS(6386),
    [anon_sym_function] = ACTIONS(6388),
    [anon_sym_use] = ACTIONS(6388),
    [anon_sym_use_BANG] = ACTIONS(6386),
    [anon_sym_do_BANG] = ACTIONS(6386),
    [anon_sym_begin] = ACTIONS(6388),
    [anon_sym_exception] = ACTIONS(6388),
    [aux_sym_char_token1] = ACTIONS(6386),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6388),
    [anon_sym_DQUOTE] = ACTIONS(6388),
    [anon_sym_AT_DQUOTE] = ACTIONS(6386),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6386),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6386),
    [sym_bool] = ACTIONS(6388),
    [sym_unit] = ACTIONS(6386),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6388),
    [sym_op_identifier] = ACTIONS(6386),
    [anon_sym_PLUS] = ACTIONS(6388),
    [anon_sym_DASH] = ACTIONS(6388),
    [anon_sym_PLUS_DOT] = ACTIONS(6386),
    [anon_sym_DASH_DOT] = ACTIONS(6386),
    [anon_sym_PERCENT] = ACTIONS(6386),
    [anon_sym_AMP_AMP] = ACTIONS(6386),
    [anon_sym_TILDE] = ACTIONS(6386),
    [aux_sym_prefix_op_token1] = ACTIONS(6386),
    [sym_int] = ACTIONS(6388),
    [sym_xint] = ACTIONS(6386),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(6386),
    [anon_sym_POUNDload] = ACTIONS(6386),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6386),
  },
  [4180] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(9159),
    [sym_type_attributes] = STATE(11997),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4180),
    [sym_compiler_directive_decl] = STATE(4180),
    [sym_fsi_directive_decl] = STATE(4180),
    [sym_preproc_line] = STATE(4180),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4181] = {
    [sym_block_comment] = STATE(4181),
    [sym_compiler_directive_decl] = STATE(4181),
    [sym_fsi_directive_decl] = STATE(4181),
    [sym_preproc_line] = STATE(4181),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_COLON_GT] = ACTIONS(6954),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3513),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3513),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3513),
    [anon_sym_DASH_DOT] = ACTIONS(3513),
    [anon_sym_PERCENT] = ACTIONS(3513),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3513),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [sym__dedent] = ACTIONS(3513),
  },
  [4182] = {
    [sym_block_comment] = STATE(4182),
    [sym_compiler_directive_decl] = STATE(4182),
    [sym_fsi_directive_decl] = STATE(4182),
    [sym_preproc_line] = STATE(4182),
    [aux_sym_compound_type_repeat1] = STATE(4182),
    [sym_identifier] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_let_BANG] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_null] = ACTIONS(3427),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_LT_AT] = ACTIONS(3427),
    [anon_sym_LT_AT_AT] = ACTIONS(3425),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_return_BANG] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_yield_BANG] = ACTIONS(3425),
    [anon_sym_lazy] = ACTIONS(3427),
    [anon_sym_assert] = ACTIONS(3427),
    [anon_sym_upcast] = ACTIONS(3427),
    [anon_sym_downcast] = ACTIONS(3427),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_fun] = ACTIONS(3427),
    [anon_sym_DASH_GT] = ACTIONS(3425),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_match] = ACTIONS(3427),
    [anon_sym_match_BANG] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_use] = ACTIONS(3427),
    [anon_sym_use_BANG] = ACTIONS(3425),
    [anon_sym_do_BANG] = ACTIONS(3425),
    [anon_sym_begin] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(6956),
    [anon_sym_LT2] = ACTIONS(3427),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3425),
    [aux_sym_char_token1] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_AT_DQUOTE] = ACTIONS(3425),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3425),
    [sym_bool] = ACTIONS(3427),
    [sym_unit] = ACTIONS(3425),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3427),
    [sym_op_identifier] = ACTIONS(3425),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_PLUS_DOT] = ACTIONS(3425),
    [anon_sym_DASH_DOT] = ACTIONS(3425),
    [anon_sym_PERCENT] = ACTIONS(3425),
    [anon_sym_AMP_AMP] = ACTIONS(3425),
    [anon_sym_TILDE] = ACTIONS(3425),
    [aux_sym_prefix_op_token1] = ACTIONS(3425),
    [sym_int] = ACTIONS(3427),
    [sym_xint] = ACTIONS(3425),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3425),
    [sym__dedent] = ACTIONS(3425),
  },
  [4183] = {
    [sym_block_comment] = STATE(4183),
    [sym_compiler_directive_decl] = STATE(4183),
    [sym_fsi_directive_decl] = STATE(4183),
    [sym_preproc_line] = STATE(4183),
    [sym_identifier] = ACTIONS(3535),
    [anon_sym_GT_RBRACK] = ACTIONS(3533),
    [anon_sym_return] = ACTIONS(3535),
    [anon_sym_do] = ACTIONS(3535),
    [anon_sym_let] = ACTIONS(3535),
    [anon_sym_let_BANG] = ACTIONS(3533),
    [anon_sym_LPAREN] = ACTIONS(3535),
    [anon_sym_null] = ACTIONS(3535),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3533),
    [anon_sym_LBRACE] = ACTIONS(3535),
    [anon_sym_LT_AT] = ACTIONS(3535),
    [anon_sym_LT_AT_AT] = ACTIONS(3533),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3533),
    [anon_sym_new] = ACTIONS(3535),
    [anon_sym_return_BANG] = ACTIONS(3533),
    [anon_sym_yield] = ACTIONS(3535),
    [anon_sym_yield_BANG] = ACTIONS(3533),
    [anon_sym_lazy] = ACTIONS(3535),
    [anon_sym_assert] = ACTIONS(3535),
    [anon_sym_upcast] = ACTIONS(3535),
    [anon_sym_downcast] = ACTIONS(3535),
    [anon_sym_for] = ACTIONS(3535),
    [anon_sym_while] = ACTIONS(3535),
    [anon_sym_if] = ACTIONS(3535),
    [anon_sym_fun] = ACTIONS(3535),
    [anon_sym_DASH_GT] = ACTIONS(3533),
    [anon_sym_try] = ACTIONS(3535),
    [anon_sym_match] = ACTIONS(3535),
    [anon_sym_match_BANG] = ACTIONS(3533),
    [anon_sym_function] = ACTIONS(3535),
    [anon_sym_use] = ACTIONS(3535),
    [anon_sym_use_BANG] = ACTIONS(3533),
    [anon_sym_do_BANG] = ACTIONS(3533),
    [anon_sym_begin] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(3533),
    [anon_sym_LT2] = ACTIONS(3535),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3533),
    [aux_sym_char_token1] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE] = ACTIONS(3535),
    [anon_sym_AT_DQUOTE] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [sym_bool] = ACTIONS(3535),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3535),
    [sym_op_identifier] = ACTIONS(3533),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS_DOT] = ACTIONS(3533),
    [anon_sym_DASH_DOT] = ACTIONS(3533),
    [anon_sym_PERCENT] = ACTIONS(3533),
    [anon_sym_AMP_AMP] = ACTIONS(3533),
    [anon_sym_TILDE] = ACTIONS(3533),
    [aux_sym_prefix_op_token1] = ACTIONS(3533),
    [sym_int] = ACTIONS(3535),
    [sym_xint] = ACTIONS(3533),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3533),
    [sym__newline] = ACTIONS(3533),
  },
  [4184] = {
    [sym_block_comment] = STATE(4184),
    [sym_compiler_directive_decl] = STATE(4184),
    [sym_fsi_directive_decl] = STATE(4184),
    [sym_preproc_line] = STATE(4184),
    [sym_identifier] = ACTIONS(3551),
    [anon_sym_GT_RBRACK] = ACTIONS(3549),
    [anon_sym_return] = ACTIONS(3551),
    [anon_sym_do] = ACTIONS(3551),
    [anon_sym_let] = ACTIONS(3551),
    [anon_sym_let_BANG] = ACTIONS(3549),
    [anon_sym_LPAREN] = ACTIONS(3551),
    [anon_sym_null] = ACTIONS(3551),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(3551),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3549),
    [anon_sym_LBRACE] = ACTIONS(3551),
    [anon_sym_LT_AT] = ACTIONS(3551),
    [anon_sym_LT_AT_AT] = ACTIONS(3549),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3549),
    [anon_sym_new] = ACTIONS(3551),
    [anon_sym_return_BANG] = ACTIONS(3549),
    [anon_sym_yield] = ACTIONS(3551),
    [anon_sym_yield_BANG] = ACTIONS(3549),
    [anon_sym_lazy] = ACTIONS(3551),
    [anon_sym_assert] = ACTIONS(3551),
    [anon_sym_upcast] = ACTIONS(3551),
    [anon_sym_downcast] = ACTIONS(3551),
    [anon_sym_for] = ACTIONS(3551),
    [anon_sym_while] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(3551),
    [anon_sym_fun] = ACTIONS(3551),
    [anon_sym_DASH_GT] = ACTIONS(3549),
    [anon_sym_try] = ACTIONS(3551),
    [anon_sym_match] = ACTIONS(3551),
    [anon_sym_match_BANG] = ACTIONS(3549),
    [anon_sym_function] = ACTIONS(3551),
    [anon_sym_use] = ACTIONS(3551),
    [anon_sym_use_BANG] = ACTIONS(3549),
    [anon_sym_do_BANG] = ACTIONS(3549),
    [anon_sym_begin] = ACTIONS(3551),
    [anon_sym_STAR] = ACTIONS(3549),
    [anon_sym_LT2] = ACTIONS(3551),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3549),
    [aux_sym_char_token1] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [anon_sym_AT_DQUOTE] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [sym_bool] = ACTIONS(3551),
    [sym_unit] = ACTIONS(3549),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3551),
    [sym_op_identifier] = ACTIONS(3549),
    [anon_sym_PLUS] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(3551),
    [anon_sym_PLUS_DOT] = ACTIONS(3549),
    [anon_sym_DASH_DOT] = ACTIONS(3549),
    [anon_sym_PERCENT] = ACTIONS(3549),
    [anon_sym_AMP_AMP] = ACTIONS(3549),
    [anon_sym_TILDE] = ACTIONS(3549),
    [aux_sym_prefix_op_token1] = ACTIONS(3549),
    [sym_int] = ACTIONS(3551),
    [sym_xint] = ACTIONS(3549),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3549),
    [sym__newline] = ACTIONS(3549),
  },
  [4185] = {
    [sym_block_comment] = STATE(4185),
    [sym_compiler_directive_decl] = STATE(4185),
    [sym_fsi_directive_decl] = STATE(4185),
    [sym_preproc_line] = STATE(4185),
    [aux_sym_compound_type_repeat1] = STATE(4182),
    [sym_identifier] = ACTIONS(3468),
    [anon_sym_return] = ACTIONS(3468),
    [anon_sym_do] = ACTIONS(3468),
    [anon_sym_let] = ACTIONS(3468),
    [anon_sym_let_BANG] = ACTIONS(3466),
    [anon_sym_LPAREN] = ACTIONS(3468),
    [anon_sym_null] = ACTIONS(3468),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LBRACK] = ACTIONS(3468),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3466),
    [anon_sym_LBRACE] = ACTIONS(3468),
    [anon_sym_LT_AT] = ACTIONS(3468),
    [anon_sym_LT_AT_AT] = ACTIONS(3466),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3466),
    [anon_sym_new] = ACTIONS(3468),
    [anon_sym_return_BANG] = ACTIONS(3466),
    [anon_sym_yield] = ACTIONS(3468),
    [anon_sym_yield_BANG] = ACTIONS(3466),
    [anon_sym_lazy] = ACTIONS(3468),
    [anon_sym_assert] = ACTIONS(3468),
    [anon_sym_upcast] = ACTIONS(3468),
    [anon_sym_downcast] = ACTIONS(3468),
    [anon_sym_for] = ACTIONS(3468),
    [anon_sym_while] = ACTIONS(3468),
    [anon_sym_if] = ACTIONS(3468),
    [anon_sym_fun] = ACTIONS(3468),
    [anon_sym_DASH_GT] = ACTIONS(3466),
    [anon_sym_try] = ACTIONS(3468),
    [anon_sym_match] = ACTIONS(3468),
    [anon_sym_match_BANG] = ACTIONS(3466),
    [anon_sym_function] = ACTIONS(3468),
    [anon_sym_use] = ACTIONS(3468),
    [anon_sym_use_BANG] = ACTIONS(3466),
    [anon_sym_do_BANG] = ACTIONS(3466),
    [anon_sym_begin] = ACTIONS(3468),
    [anon_sym_STAR] = ACTIONS(2682),
    [anon_sym_LT2] = ACTIONS(3468),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3466),
    [aux_sym_char_token1] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3468),
    [anon_sym_DQUOTE] = ACTIONS(3468),
    [anon_sym_AT_DQUOTE] = ACTIONS(3466),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3466),
    [sym_bool] = ACTIONS(3468),
    [sym_unit] = ACTIONS(3466),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3468),
    [sym_op_identifier] = ACTIONS(3466),
    [anon_sym_PLUS] = ACTIONS(3468),
    [anon_sym_DASH] = ACTIONS(3468),
    [anon_sym_PLUS_DOT] = ACTIONS(3466),
    [anon_sym_DASH_DOT] = ACTIONS(3466),
    [anon_sym_PERCENT] = ACTIONS(3466),
    [anon_sym_AMP_AMP] = ACTIONS(3466),
    [anon_sym_TILDE] = ACTIONS(3466),
    [aux_sym_prefix_op_token1] = ACTIONS(3466),
    [sym_int] = ACTIONS(3468),
    [sym_xint] = ACTIONS(3466),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3466),
    [sym__dedent] = ACTIONS(3466),
  },
  [4186] = {
    [sym_block_comment] = STATE(4186),
    [sym_compiler_directive_decl] = STATE(4186),
    [sym_fsi_directive_decl] = STATE(4186),
    [sym_preproc_line] = STATE(4186),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_GT_RBRACK] = ACTIONS(3525),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3525),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_DASH_GT] = ACTIONS(3525),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_STAR] = ACTIONS(3525),
    [anon_sym_LT2] = ACTIONS(3527),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3525),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3525),
    [anon_sym_DASH_DOT] = ACTIONS(3525),
    [anon_sym_PERCENT] = ACTIONS(3525),
    [anon_sym_AMP_AMP] = ACTIONS(3525),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3525),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3525),
    [sym__newline] = ACTIONS(3525),
  },
  [4187] = {
    [sym_block_comment] = STATE(4187),
    [sym_compiler_directive_decl] = STATE(4187),
    [sym_fsi_directive_decl] = STATE(4187),
    [sym_preproc_line] = STATE(4187),
    [sym_identifier] = ACTIONS(3547),
    [anon_sym_GT_RBRACK] = ACTIONS(3545),
    [anon_sym_return] = ACTIONS(3547),
    [anon_sym_do] = ACTIONS(3547),
    [anon_sym_let] = ACTIONS(3547),
    [anon_sym_let_BANG] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(3547),
    [anon_sym_null] = ACTIONS(3547),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3545),
    [anon_sym_LBRACE] = ACTIONS(3547),
    [anon_sym_LT_AT] = ACTIONS(3547),
    [anon_sym_LT_AT_AT] = ACTIONS(3545),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3545),
    [anon_sym_new] = ACTIONS(3547),
    [anon_sym_return_BANG] = ACTIONS(3545),
    [anon_sym_yield] = ACTIONS(3547),
    [anon_sym_yield_BANG] = ACTIONS(3545),
    [anon_sym_lazy] = ACTIONS(3547),
    [anon_sym_assert] = ACTIONS(3547),
    [anon_sym_upcast] = ACTIONS(3547),
    [anon_sym_downcast] = ACTIONS(3547),
    [anon_sym_for] = ACTIONS(3547),
    [anon_sym_while] = ACTIONS(3547),
    [anon_sym_if] = ACTIONS(3547),
    [anon_sym_fun] = ACTIONS(3547),
    [anon_sym_DASH_GT] = ACTIONS(3545),
    [anon_sym_try] = ACTIONS(3547),
    [anon_sym_match] = ACTIONS(3547),
    [anon_sym_match_BANG] = ACTIONS(3545),
    [anon_sym_function] = ACTIONS(3547),
    [anon_sym_use] = ACTIONS(3547),
    [anon_sym_use_BANG] = ACTIONS(3545),
    [anon_sym_do_BANG] = ACTIONS(3545),
    [anon_sym_begin] = ACTIONS(3547),
    [anon_sym_STAR] = ACTIONS(3545),
    [anon_sym_LT2] = ACTIONS(3547),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [aux_sym_char_token1] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3547),
    [anon_sym_DQUOTE] = ACTIONS(3547),
    [anon_sym_AT_DQUOTE] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [sym_bool] = ACTIONS(3547),
    [sym_unit] = ACTIONS(3545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3547),
    [sym_op_identifier] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PLUS_DOT] = ACTIONS(3545),
    [anon_sym_DASH_DOT] = ACTIONS(3545),
    [anon_sym_PERCENT] = ACTIONS(3545),
    [anon_sym_AMP_AMP] = ACTIONS(3545),
    [anon_sym_TILDE] = ACTIONS(3545),
    [aux_sym_prefix_op_token1] = ACTIONS(3545),
    [sym_int] = ACTIONS(3547),
    [sym_xint] = ACTIONS(3545),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3545),
    [sym__newline] = ACTIONS(3545),
  },
  [4188] = {
    [sym_block_comment] = STATE(4188),
    [sym_compiler_directive_decl] = STATE(4188),
    [sym_fsi_directive_decl] = STATE(4188),
    [sym_preproc_line] = STATE(4188),
    [sym_identifier] = ACTIONS(3519),
    [anon_sym_GT_RBRACK] = ACTIONS(3517),
    [anon_sym_return] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(3519),
    [anon_sym_let] = ACTIONS(3519),
    [anon_sym_let_BANG] = ACTIONS(3517),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [anon_sym_null] = ACTIONS(3519),
    [anon_sym_AMP] = ACTIONS(3519),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_LT_AT] = ACTIONS(3519),
    [anon_sym_LT_AT_AT] = ACTIONS(3517),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3519),
    [anon_sym_return_BANG] = ACTIONS(3517),
    [anon_sym_yield] = ACTIONS(3519),
    [anon_sym_yield_BANG] = ACTIONS(3517),
    [anon_sym_lazy] = ACTIONS(3519),
    [anon_sym_assert] = ACTIONS(3519),
    [anon_sym_upcast] = ACTIONS(3519),
    [anon_sym_downcast] = ACTIONS(3519),
    [anon_sym_for] = ACTIONS(3519),
    [anon_sym_while] = ACTIONS(3519),
    [anon_sym_if] = ACTIONS(3519),
    [anon_sym_fun] = ACTIONS(3519),
    [anon_sym_DASH_GT] = ACTIONS(3517),
    [anon_sym_try] = ACTIONS(3519),
    [anon_sym_match] = ACTIONS(3519),
    [anon_sym_match_BANG] = ACTIONS(3517),
    [anon_sym_function] = ACTIONS(3519),
    [anon_sym_use] = ACTIONS(3519),
    [anon_sym_use_BANG] = ACTIONS(3517),
    [anon_sym_do_BANG] = ACTIONS(3517),
    [anon_sym_begin] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3517),
    [anon_sym_LT2] = ACTIONS(3519),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3517),
    [aux_sym_char_token1] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [anon_sym_AT_DQUOTE] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [sym_bool] = ACTIONS(3519),
    [sym_unit] = ACTIONS(3517),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3519),
    [sym_op_identifier] = ACTIONS(3517),
    [anon_sym_PLUS] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_DOT] = ACTIONS(3517),
    [anon_sym_DASH_DOT] = ACTIONS(3517),
    [anon_sym_PERCENT] = ACTIONS(3517),
    [anon_sym_AMP_AMP] = ACTIONS(3517),
    [anon_sym_TILDE] = ACTIONS(3517),
    [aux_sym_prefix_op_token1] = ACTIONS(3517),
    [sym_int] = ACTIONS(3519),
    [sym_xint] = ACTIONS(3517),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3517),
    [sym__newline] = ACTIONS(3517),
  },
  [4189] = {
    [sym_block_comment] = STATE(4189),
    [sym_compiler_directive_decl] = STATE(4189),
    [sym_fsi_directive_decl] = STATE(4189),
    [sym_preproc_line] = STATE(4189),
    [sym_identifier] = ACTIONS(3531),
    [anon_sym_GT_RBRACK] = ACTIONS(3529),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_do] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_null] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3531),
    [anon_sym_LT_AT] = ACTIONS(3531),
    [anon_sym_LT_AT_AT] = ACTIONS(3529),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3531),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3531),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3531),
    [anon_sym_assert] = ACTIONS(3531),
    [anon_sym_upcast] = ACTIONS(3531),
    [anon_sym_downcast] = ACTIONS(3531),
    [anon_sym_for] = ACTIONS(3531),
    [anon_sym_while] = ACTIONS(3531),
    [anon_sym_if] = ACTIONS(3531),
    [anon_sym_fun] = ACTIONS(3531),
    [anon_sym_DASH_GT] = ACTIONS(3529),
    [anon_sym_try] = ACTIONS(3531),
    [anon_sym_match] = ACTIONS(3531),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3531),
    [anon_sym_use] = ACTIONS(3531),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3531),
    [anon_sym_STAR] = ACTIONS(3529),
    [anon_sym_LT2] = ACTIONS(3531),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3531),
    [anon_sym_DQUOTE] = ACTIONS(3531),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3531),
    [sym_unit] = ACTIONS(3529),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3531),
    [sym_op_identifier] = ACTIONS(3529),
    [anon_sym_PLUS] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(3531),
    [anon_sym_PLUS_DOT] = ACTIONS(3529),
    [anon_sym_DASH_DOT] = ACTIONS(3529),
    [anon_sym_PERCENT] = ACTIONS(3529),
    [anon_sym_AMP_AMP] = ACTIONS(3529),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3529),
    [sym_int] = ACTIONS(3531),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [sym__newline] = ACTIONS(3529),
  },
  [4190] = {
    [sym_block_comment] = STATE(4190),
    [sym_compiler_directive_decl] = STATE(4190),
    [sym_fsi_directive_decl] = STATE(4190),
    [sym_preproc_line] = STATE(4190),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_GT_RBRACK] = ACTIONS(3513),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3513),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3513),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3513),
    [anon_sym_DASH_DOT] = ACTIONS(3513),
    [anon_sym_PERCENT] = ACTIONS(3513),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3513),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [sym__newline] = ACTIONS(3513),
  },
  [4191] = {
    [sym_block_comment] = STATE(4191),
    [sym_compiler_directive_decl] = STATE(4191),
    [sym_fsi_directive_decl] = STATE(4191),
    [sym_preproc_line] = STATE(4191),
    [sym_identifier] = ACTIONS(3498),
    [anon_sym_return] = ACTIONS(3498),
    [anon_sym_do] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_let_BANG] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_null] = ACTIONS(3498),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3496),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LT_AT] = ACTIONS(3498),
    [anon_sym_LT_AT_AT] = ACTIONS(3496),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3496),
    [anon_sym_new] = ACTIONS(3498),
    [anon_sym_return_BANG] = ACTIONS(3496),
    [anon_sym_yield] = ACTIONS(3498),
    [anon_sym_yield_BANG] = ACTIONS(3496),
    [anon_sym_lazy] = ACTIONS(3498),
    [anon_sym_assert] = ACTIONS(3498),
    [anon_sym_upcast] = ACTIONS(3498),
    [anon_sym_downcast] = ACTIONS(3498),
    [anon_sym_COLON_GT] = ACTIONS(3496),
    [anon_sym_for] = ACTIONS(3498),
    [anon_sym_while] = ACTIONS(3498),
    [anon_sym_if] = ACTIONS(3498),
    [anon_sym_fun] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3496),
    [anon_sym_try] = ACTIONS(3498),
    [anon_sym_match] = ACTIONS(3498),
    [anon_sym_match_BANG] = ACTIONS(3496),
    [anon_sym_function] = ACTIONS(3498),
    [anon_sym_use] = ACTIONS(3498),
    [anon_sym_use_BANG] = ACTIONS(3496),
    [anon_sym_do_BANG] = ACTIONS(3496),
    [anon_sym_begin] = ACTIONS(3498),
    [anon_sym_STAR] = ACTIONS(3496),
    [anon_sym_LT2] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3496),
    [aux_sym_char_token1] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [anon_sym_AT_DQUOTE] = ACTIONS(3496),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3496),
    [sym_bool] = ACTIONS(3498),
    [sym_unit] = ACTIONS(3496),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3498),
    [sym_op_identifier] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_DOT] = ACTIONS(3496),
    [anon_sym_DASH_DOT] = ACTIONS(3496),
    [anon_sym_PERCENT] = ACTIONS(3496),
    [anon_sym_AMP_AMP] = ACTIONS(3496),
    [anon_sym_TILDE] = ACTIONS(3496),
    [aux_sym_prefix_op_token1] = ACTIONS(3496),
    [sym_int] = ACTIONS(3498),
    [sym_xint] = ACTIONS(3496),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3496),
    [sym__dedent] = ACTIONS(3496),
  },
  [4192] = {
    [sym_block_comment] = STATE(4192),
    [sym_compiler_directive_decl] = STATE(4192),
    [sym_fsi_directive_decl] = STATE(4192),
    [sym_preproc_line] = STATE(4192),
    [sym_identifier] = ACTIONS(3505),
    [anon_sym_GT_RBRACK] = ACTIONS(3503),
    [anon_sym_return] = ACTIONS(3505),
    [anon_sym_do] = ACTIONS(3505),
    [anon_sym_let] = ACTIONS(3505),
    [anon_sym_let_BANG] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3505),
    [anon_sym_null] = ACTIONS(3505),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3503),
    [anon_sym_LBRACE] = ACTIONS(3505),
    [anon_sym_LT_AT] = ACTIONS(3505),
    [anon_sym_LT_AT_AT] = ACTIONS(3503),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3503),
    [anon_sym_new] = ACTIONS(3505),
    [anon_sym_return_BANG] = ACTIONS(3503),
    [anon_sym_yield] = ACTIONS(3505),
    [anon_sym_yield_BANG] = ACTIONS(3503),
    [anon_sym_lazy] = ACTIONS(3505),
    [anon_sym_assert] = ACTIONS(3505),
    [anon_sym_upcast] = ACTIONS(3505),
    [anon_sym_downcast] = ACTIONS(3505),
    [anon_sym_for] = ACTIONS(3505),
    [anon_sym_while] = ACTIONS(3505),
    [anon_sym_if] = ACTIONS(3505),
    [anon_sym_fun] = ACTIONS(3505),
    [anon_sym_DASH_GT] = ACTIONS(3503),
    [anon_sym_try] = ACTIONS(3505),
    [anon_sym_match] = ACTIONS(3505),
    [anon_sym_match_BANG] = ACTIONS(3503),
    [anon_sym_function] = ACTIONS(3505),
    [anon_sym_use] = ACTIONS(3505),
    [anon_sym_use_BANG] = ACTIONS(3503),
    [anon_sym_do_BANG] = ACTIONS(3503),
    [anon_sym_begin] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3503),
    [anon_sym_LT2] = ACTIONS(6959),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [aux_sym_char_token1] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3505),
    [anon_sym_DQUOTE] = ACTIONS(3505),
    [anon_sym_AT_DQUOTE] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [sym_bool] = ACTIONS(3505),
    [sym_unit] = ACTIONS(3503),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3505),
    [sym_op_identifier] = ACTIONS(3503),
    [anon_sym_PLUS] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3505),
    [anon_sym_PLUS_DOT] = ACTIONS(3503),
    [anon_sym_DASH_DOT] = ACTIONS(3503),
    [anon_sym_PERCENT] = ACTIONS(3503),
    [anon_sym_AMP_AMP] = ACTIONS(3503),
    [anon_sym_TILDE] = ACTIONS(3503),
    [aux_sym_prefix_op_token1] = ACTIONS(3503),
    [sym_int] = ACTIONS(3505),
    [sym_xint] = ACTIONS(3503),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3503),
    [sym__newline] = ACTIONS(3503),
  },
  [4193] = {
    [sym_block_comment] = STATE(4193),
    [sym_compiler_directive_decl] = STATE(4193),
    [sym_fsi_directive_decl] = STATE(4193),
    [sym_preproc_line] = STATE(4193),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_GT_RBRACK] = ACTIONS(3560),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_let_BANG] = ACTIONS(3560),
    [anon_sym_LPAREN] = ACTIONS(3562),
    [anon_sym_null] = ACTIONS(3562),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3560),
    [anon_sym_LBRACE] = ACTIONS(3562),
    [anon_sym_LT_AT] = ACTIONS(3562),
    [anon_sym_LT_AT_AT] = ACTIONS(3560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3560),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_return_BANG] = ACTIONS(3560),
    [anon_sym_yield] = ACTIONS(3562),
    [anon_sym_yield_BANG] = ACTIONS(3560),
    [anon_sym_lazy] = ACTIONS(3562),
    [anon_sym_assert] = ACTIONS(3562),
    [anon_sym_upcast] = ACTIONS(3562),
    [anon_sym_downcast] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_fun] = ACTIONS(3562),
    [anon_sym_DASH_GT] = ACTIONS(3560),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_match] = ACTIONS(3562),
    [anon_sym_match_BANG] = ACTIONS(3560),
    [anon_sym_function] = ACTIONS(3562),
    [anon_sym_use] = ACTIONS(3562),
    [anon_sym_use_BANG] = ACTIONS(3560),
    [anon_sym_do_BANG] = ACTIONS(3560),
    [anon_sym_begin] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_LT2] = ACTIONS(3562),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3560),
    [aux_sym_char_token1] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(3562),
    [anon_sym_AT_DQUOTE] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [sym_bool] = ACTIONS(3562),
    [sym_unit] = ACTIONS(3560),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3562),
    [sym_op_identifier] = ACTIONS(3560),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS_DOT] = ACTIONS(3560),
    [anon_sym_DASH_DOT] = ACTIONS(3560),
    [anon_sym_PERCENT] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [aux_sym_prefix_op_token1] = ACTIONS(3560),
    [sym_int] = ACTIONS(3562),
    [sym_xint] = ACTIONS(3560),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3560),
    [sym__newline] = ACTIONS(3560),
  },
  [4194] = {
    [sym_block_comment] = STATE(4194),
    [sym_compiler_directive_decl] = STATE(4194),
    [sym_fsi_directive_decl] = STATE(4194),
    [sym_preproc_line] = STATE(4194),
    [sym_identifier] = ACTIONS(3487),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_let_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_null] = ACTIONS(3487),
    [anon_sym_AMP] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3487),
    [anon_sym_LT_AT] = ACTIONS(3487),
    [anon_sym_LT_AT_AT] = ACTIONS(3485),
    [anon_sym_DOT] = ACTIONS(3485),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3485),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_return_BANG] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_yield_BANG] = ACTIONS(3485),
    [anon_sym_lazy] = ACTIONS(3487),
    [anon_sym_assert] = ACTIONS(3487),
    [anon_sym_upcast] = ACTIONS(3487),
    [anon_sym_downcast] = ACTIONS(3487),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_fun] = ACTIONS(3487),
    [anon_sym_DASH_GT] = ACTIONS(3485),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_match] = ACTIONS(3487),
    [anon_sym_match_BANG] = ACTIONS(3485),
    [anon_sym_function] = ACTIONS(3487),
    [anon_sym_use] = ACTIONS(3487),
    [anon_sym_use_BANG] = ACTIONS(3485),
    [anon_sym_do_BANG] = ACTIONS(3485),
    [anon_sym_begin] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3485),
    [anon_sym_LT2] = ACTIONS(3487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3485),
    [aux_sym_char_token1] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_AT_DQUOTE] = ACTIONS(3485),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3485),
    [sym_bool] = ACTIONS(3487),
    [sym_unit] = ACTIONS(3485),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3487),
    [sym_op_identifier] = ACTIONS(3485),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_PLUS_DOT] = ACTIONS(3485),
    [anon_sym_DASH_DOT] = ACTIONS(3485),
    [anon_sym_PERCENT] = ACTIONS(3485),
    [anon_sym_AMP_AMP] = ACTIONS(3485),
    [anon_sym_TILDE] = ACTIONS(3485),
    [aux_sym_prefix_op_token1] = ACTIONS(3485),
    [sym_int] = ACTIONS(3487),
    [sym_xint] = ACTIONS(3485),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3485),
    [sym__dedent] = ACTIONS(3485),
  },
  [4195] = {
    [sym_block_comment] = STATE(4195),
    [sym_compiler_directive_decl] = STATE(4195),
    [sym_fsi_directive_decl] = STATE(4195),
    [sym_preproc_line] = STATE(4195),
    [sym_identifier] = ACTIONS(3539),
    [anon_sym_GT_RBRACK] = ACTIONS(3537),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_do] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3539),
    [anon_sym_let_BANG] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_null] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3537),
    [anon_sym_LBRACE] = ACTIONS(3539),
    [anon_sym_LT_AT] = ACTIONS(3539),
    [anon_sym_LT_AT_AT] = ACTIONS(3537),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3537),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_return_BANG] = ACTIONS(3537),
    [anon_sym_yield] = ACTIONS(3539),
    [anon_sym_yield_BANG] = ACTIONS(3537),
    [anon_sym_lazy] = ACTIONS(3539),
    [anon_sym_assert] = ACTIONS(3539),
    [anon_sym_upcast] = ACTIONS(3539),
    [anon_sym_downcast] = ACTIONS(3539),
    [anon_sym_for] = ACTIONS(3539),
    [anon_sym_while] = ACTIONS(3539),
    [anon_sym_if] = ACTIONS(3539),
    [anon_sym_fun] = ACTIONS(3539),
    [anon_sym_DASH_GT] = ACTIONS(3537),
    [anon_sym_try] = ACTIONS(3539),
    [anon_sym_match] = ACTIONS(3539),
    [anon_sym_match_BANG] = ACTIONS(3537),
    [anon_sym_function] = ACTIONS(3539),
    [anon_sym_use] = ACTIONS(3539),
    [anon_sym_use_BANG] = ACTIONS(3537),
    [anon_sym_do_BANG] = ACTIONS(3537),
    [anon_sym_begin] = ACTIONS(3539),
    [anon_sym_STAR] = ACTIONS(3537),
    [anon_sym_LT2] = ACTIONS(3539),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [aux_sym_char_token1] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3539),
    [anon_sym_DQUOTE] = ACTIONS(3539),
    [anon_sym_AT_DQUOTE] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [sym_bool] = ACTIONS(3539),
    [sym_unit] = ACTIONS(3537),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3539),
    [sym_op_identifier] = ACTIONS(3537),
    [anon_sym_PLUS] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(3539),
    [anon_sym_PLUS_DOT] = ACTIONS(3537),
    [anon_sym_DASH_DOT] = ACTIONS(3537),
    [anon_sym_PERCENT] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [aux_sym_prefix_op_token1] = ACTIONS(3537),
    [sym_int] = ACTIONS(3539),
    [sym_xint] = ACTIONS(3537),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3537),
    [sym__newline] = ACTIONS(3537),
  },
  [4196] = {
    [sym_block_comment] = STATE(4196),
    [sym_compiler_directive_decl] = STATE(4196),
    [sym_fsi_directive_decl] = STATE(4196),
    [sym_preproc_line] = STATE(4196),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_GT_RBRACK] = ACTIONS(3521),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3521),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3521),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3521),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_DASH_GT] = ACTIONS(3521),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3521),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3521),
    [anon_sym_do_BANG] = ACTIONS(3521),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_STAR] = ACTIONS(3521),
    [anon_sym_LT2] = ACTIONS(3523),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3521),
    [aux_sym_char_token1] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3521),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3521),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3521),
    [anon_sym_DASH_DOT] = ACTIONS(3521),
    [anon_sym_PERCENT] = ACTIONS(3521),
    [anon_sym_AMP_AMP] = ACTIONS(3521),
    [anon_sym_TILDE] = ACTIONS(3521),
    [aux_sym_prefix_op_token1] = ACTIONS(3521),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3521),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3521),
    [sym__newline] = ACTIONS(3521),
  },
  [4197] = {
    [sym_block_comment] = STATE(4197),
    [sym_compiler_directive_decl] = STATE(4197),
    [sym_fsi_directive_decl] = STATE(4197),
    [sym_preproc_line] = STATE(4197),
    [sym_identifier] = ACTIONS(3543),
    [anon_sym_GT_RBRACK] = ACTIONS(3541),
    [anon_sym_return] = ACTIONS(3543),
    [anon_sym_do] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3543),
    [anon_sym_let_BANG] = ACTIONS(3541),
    [anon_sym_LPAREN] = ACTIONS(3543),
    [anon_sym_null] = ACTIONS(3543),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3543),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3541),
    [anon_sym_LBRACE] = ACTIONS(3543),
    [anon_sym_LT_AT] = ACTIONS(3543),
    [anon_sym_LT_AT_AT] = ACTIONS(3541),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3541),
    [anon_sym_new] = ACTIONS(3543),
    [anon_sym_return_BANG] = ACTIONS(3541),
    [anon_sym_yield] = ACTIONS(3543),
    [anon_sym_yield_BANG] = ACTIONS(3541),
    [anon_sym_lazy] = ACTIONS(3543),
    [anon_sym_assert] = ACTIONS(3543),
    [anon_sym_upcast] = ACTIONS(3543),
    [anon_sym_downcast] = ACTIONS(3543),
    [anon_sym_for] = ACTIONS(3543),
    [anon_sym_while] = ACTIONS(3543),
    [anon_sym_if] = ACTIONS(3543),
    [anon_sym_fun] = ACTIONS(3543),
    [anon_sym_DASH_GT] = ACTIONS(3541),
    [anon_sym_try] = ACTIONS(3543),
    [anon_sym_match] = ACTIONS(3543),
    [anon_sym_match_BANG] = ACTIONS(3541),
    [anon_sym_function] = ACTIONS(3543),
    [anon_sym_use] = ACTIONS(3543),
    [anon_sym_use_BANG] = ACTIONS(3541),
    [anon_sym_do_BANG] = ACTIONS(3541),
    [anon_sym_begin] = ACTIONS(3543),
    [anon_sym_STAR] = ACTIONS(3541),
    [anon_sym_LT2] = ACTIONS(3543),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [aux_sym_char_token1] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3543),
    [anon_sym_DQUOTE] = ACTIONS(3543),
    [anon_sym_AT_DQUOTE] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [sym_bool] = ACTIONS(3543),
    [sym_unit] = ACTIONS(3541),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3543),
    [sym_op_identifier] = ACTIONS(3541),
    [anon_sym_PLUS] = ACTIONS(3543),
    [anon_sym_DASH] = ACTIONS(3543),
    [anon_sym_PLUS_DOT] = ACTIONS(3541),
    [anon_sym_DASH_DOT] = ACTIONS(3541),
    [anon_sym_PERCENT] = ACTIONS(3541),
    [anon_sym_AMP_AMP] = ACTIONS(3541),
    [anon_sym_TILDE] = ACTIONS(3541),
    [aux_sym_prefix_op_token1] = ACTIONS(3541),
    [sym_int] = ACTIONS(3543),
    [sym_xint] = ACTIONS(3541),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3541),
    [sym__newline] = ACTIONS(3541),
  },
  [4198] = {
    [sym__type] = STATE(7715),
    [sym_simple_type] = STATE(7701),
    [sym_generic_type] = STATE(7701),
    [sym_paren_type] = STATE(7701),
    [sym_function_type] = STATE(7701),
    [sym_compound_type] = STATE(7701),
    [sym_postfix_type] = STATE(7701),
    [sym_list_type] = STATE(7701),
    [sym_static_type] = STATE(7701),
    [sym_constrained_type] = STATE(7701),
    [sym_flexible_type] = STATE(7701),
    [sym_anon_record_type] = STATE(7701),
    [sym__static_type_identifier] = STATE(7287),
    [sym__static_parameter] = STATE(9802),
    [sym_named_static_parameter] = STATE(9670),
    [sym_type_attribute] = STATE(10152),
    [sym_type_argument] = STATE(7584),
    [sym_static_parameter_value] = STATE(9670),
    [sym_char] = STATE(4234),
    [sym_format_string] = STATE(4266),
    [sym__string_literal] = STATE(4266),
    [sym_string] = STATE(4234),
    [sym_verbatim_string] = STATE(4234),
    [sym_bytearray] = STATE(4234),
    [sym_verbatim_bytearray] = STATE(4234),
    [sym_format_triple_quoted_string] = STATE(4265),
    [sym_triple_quoted_string] = STATE(4234),
    [sym_const] = STATE(688),
    [sym_long_identifier] = STATE(7708),
    [sym_sbyte] = STATE(4234),
    [sym_byte] = STATE(4234),
    [sym_int16] = STATE(4234),
    [sym_uint16] = STATE(4234),
    [sym_int32] = STATE(4234),
    [sym_uint32] = STATE(4234),
    [sym_nativeint] = STATE(4234),
    [sym_unativeint] = STATE(4234),
    [sym_int64] = STATE(4234),
    [sym_uint64] = STATE(4234),
    [sym_ieee32] = STATE(4234),
    [sym_ieee64] = STATE(4234),
    [sym_bignum] = STATE(4234),
    [sym_decimal] = STATE(4234),
    [sym_float] = STATE(4220),
    [sym_block_comment] = STATE(4198),
    [sym_compiler_directive_decl] = STATE(4198),
    [sym_fsi_directive_decl] = STATE(4198),
    [sym_preproc_line] = STATE(4198),
    [sym_identifier] = ACTIONS(6580),
    [anon_sym_LPAREN] = ACTIONS(6582),
    [anon_sym__] = ACTIONS(6584),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6586),
    [anon_sym_POUND] = ACTIONS(6590),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_SQUOTE] = ACTIONS(6592),
    [aux_sym_char_token1] = ACTIONS(6594),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6596),
    [anon_sym_DQUOTE] = ACTIONS(6598),
    [anon_sym_AT_DQUOTE] = ACTIONS(6600),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6604),
    [sym_bool] = ACTIONS(6606),
    [sym_unit] = ACTIONS(6608),
    [sym_int] = ACTIONS(6610),
    [sym_xint] = ACTIONS(6612),
    [anon_sym_LPAREN_STAR] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [4199] = {
    [sym_block_comment] = STATE(4199),
    [sym_compiler_directive_decl] = STATE(4199),
    [sym_fsi_directive_decl] = STATE(4199),
    [sym_preproc_line] = STATE(4199),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3602),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_GT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3602),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3602),
    [anon_sym_DASH_DOT] = ACTIONS(3602),
    [anon_sym_PERCENT] = ACTIONS(3602),
    [anon_sym_AMP_AMP] = ACTIONS(3602),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3602),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [aux_sym_float_token1] = ACTIONS(6961),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
  },
  [4200] = {
    [sym_block_comment] = STATE(4200),
    [sym_compiler_directive_decl] = STATE(4200),
    [sym_fsi_directive_decl] = STATE(4200),
    [sym_preproc_line] = STATE(4200),
    [sym_identifier] = ACTIONS(3505),
    [anon_sym_return] = ACTIONS(3505),
    [anon_sym_do] = ACTIONS(3505),
    [anon_sym_let] = ACTIONS(3505),
    [anon_sym_let_BANG] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3505),
    [anon_sym_null] = ACTIONS(3505),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3503),
    [anon_sym_LBRACE] = ACTIONS(3505),
    [anon_sym_LT_AT] = ACTIONS(3505),
    [anon_sym_LT_AT_AT] = ACTIONS(3503),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3503),
    [anon_sym_new] = ACTIONS(3505),
    [anon_sym_return_BANG] = ACTIONS(3503),
    [anon_sym_yield] = ACTIONS(3505),
    [anon_sym_yield_BANG] = ACTIONS(3503),
    [anon_sym_lazy] = ACTIONS(3505),
    [anon_sym_assert] = ACTIONS(3505),
    [anon_sym_upcast] = ACTIONS(3505),
    [anon_sym_downcast] = ACTIONS(3505),
    [anon_sym_for] = ACTIONS(3505),
    [anon_sym_while] = ACTIONS(3505),
    [anon_sym_if] = ACTIONS(3505),
    [anon_sym_fun] = ACTIONS(3505),
    [anon_sym_DASH_GT] = ACTIONS(3503),
    [anon_sym_try] = ACTIONS(3505),
    [anon_sym_match] = ACTIONS(3505),
    [anon_sym_match_BANG] = ACTIONS(3503),
    [anon_sym_function] = ACTIONS(3505),
    [anon_sym_use] = ACTIONS(3505),
    [anon_sym_use_BANG] = ACTIONS(3503),
    [anon_sym_do_BANG] = ACTIONS(3503),
    [anon_sym_begin] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3503),
    [anon_sym_LT2] = ACTIONS(6963),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [aux_sym_char_token1] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3505),
    [anon_sym_DQUOTE] = ACTIONS(3505),
    [anon_sym_AT_DQUOTE] = ACTIONS(3503),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3503),
    [sym_bool] = ACTIONS(3505),
    [sym_unit] = ACTIONS(3503),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3505),
    [sym_op_identifier] = ACTIONS(3503),
    [anon_sym_PLUS] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3505),
    [anon_sym_PLUS_DOT] = ACTIONS(3503),
    [anon_sym_DASH_DOT] = ACTIONS(3503),
    [anon_sym_PERCENT] = ACTIONS(3503),
    [anon_sym_AMP_AMP] = ACTIONS(3503),
    [anon_sym_TILDE] = ACTIONS(3503),
    [aux_sym_prefix_op_token1] = ACTIONS(3503),
    [sym_int] = ACTIONS(3505),
    [sym_xint] = ACTIONS(3503),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3503),
    [sym__dedent] = ACTIONS(3503),
  },
  [4201] = {
    [sym_block_comment] = STATE(4201),
    [sym_compiler_directive_decl] = STATE(4201),
    [sym_fsi_directive_decl] = STATE(4201),
    [sym_preproc_line] = STATE(4201),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_let_BANG] = ACTIONS(3560),
    [anon_sym_LPAREN] = ACTIONS(3562),
    [anon_sym_null] = ACTIONS(3562),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3560),
    [anon_sym_LBRACE] = ACTIONS(3562),
    [anon_sym_LT_AT] = ACTIONS(3562),
    [anon_sym_LT_AT_AT] = ACTIONS(3560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3560),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_return_BANG] = ACTIONS(3560),
    [anon_sym_yield] = ACTIONS(3562),
    [anon_sym_yield_BANG] = ACTIONS(3560),
    [anon_sym_lazy] = ACTIONS(3562),
    [anon_sym_assert] = ACTIONS(3562),
    [anon_sym_upcast] = ACTIONS(3562),
    [anon_sym_downcast] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_fun] = ACTIONS(3562),
    [anon_sym_DASH_GT] = ACTIONS(3560),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_match] = ACTIONS(3562),
    [anon_sym_match_BANG] = ACTIONS(3560),
    [anon_sym_function] = ACTIONS(3562),
    [anon_sym_use] = ACTIONS(3562),
    [anon_sym_use_BANG] = ACTIONS(3560),
    [anon_sym_do_BANG] = ACTIONS(3560),
    [anon_sym_begin] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_LT2] = ACTIONS(3562),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3560),
    [aux_sym_char_token1] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(3562),
    [anon_sym_AT_DQUOTE] = ACTIONS(3560),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3560),
    [sym_bool] = ACTIONS(3562),
    [sym_unit] = ACTIONS(3560),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3562),
    [sym_op_identifier] = ACTIONS(3560),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS_DOT] = ACTIONS(3560),
    [anon_sym_DASH_DOT] = ACTIONS(3560),
    [anon_sym_PERCENT] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [aux_sym_prefix_op_token1] = ACTIONS(3560),
    [sym_int] = ACTIONS(3562),
    [sym_xint] = ACTIONS(3560),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3560),
    [sym__dedent] = ACTIONS(3560),
  },
  [4202] = {
    [sym_block_comment] = STATE(4202),
    [sym_compiler_directive_decl] = STATE(4202),
    [sym_fsi_directive_decl] = STATE(4202),
    [sym_preproc_line] = STATE(4202),
    [sym_identifier] = ACTIONS(3551),
    [anon_sym_return] = ACTIONS(3551),
    [anon_sym_do] = ACTIONS(3551),
    [anon_sym_let] = ACTIONS(3551),
    [anon_sym_let_BANG] = ACTIONS(3549),
    [anon_sym_LPAREN] = ACTIONS(3551),
    [anon_sym_null] = ACTIONS(3551),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(3551),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3549),
    [anon_sym_LBRACE] = ACTIONS(3551),
    [anon_sym_LT_AT] = ACTIONS(3551),
    [anon_sym_LT_AT_AT] = ACTIONS(3549),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3549),
    [anon_sym_new] = ACTIONS(3551),
    [anon_sym_return_BANG] = ACTIONS(3549),
    [anon_sym_yield] = ACTIONS(3551),
    [anon_sym_yield_BANG] = ACTIONS(3549),
    [anon_sym_lazy] = ACTIONS(3551),
    [anon_sym_assert] = ACTIONS(3551),
    [anon_sym_upcast] = ACTIONS(3551),
    [anon_sym_downcast] = ACTIONS(3551),
    [anon_sym_for] = ACTIONS(3551),
    [anon_sym_while] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(3551),
    [anon_sym_fun] = ACTIONS(3551),
    [anon_sym_DASH_GT] = ACTIONS(3549),
    [anon_sym_try] = ACTIONS(3551),
    [anon_sym_match] = ACTIONS(3551),
    [anon_sym_match_BANG] = ACTIONS(3549),
    [anon_sym_function] = ACTIONS(3551),
    [anon_sym_use] = ACTIONS(3551),
    [anon_sym_use_BANG] = ACTIONS(3549),
    [anon_sym_do_BANG] = ACTIONS(3549),
    [anon_sym_begin] = ACTIONS(3551),
    [anon_sym_STAR] = ACTIONS(3549),
    [anon_sym_LT2] = ACTIONS(3551),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3549),
    [aux_sym_char_token1] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [anon_sym_AT_DQUOTE] = ACTIONS(3549),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3549),
    [sym_bool] = ACTIONS(3551),
    [sym_unit] = ACTIONS(3549),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3551),
    [sym_op_identifier] = ACTIONS(3549),
    [anon_sym_PLUS] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(3551),
    [anon_sym_PLUS_DOT] = ACTIONS(3549),
    [anon_sym_DASH_DOT] = ACTIONS(3549),
    [anon_sym_PERCENT] = ACTIONS(3549),
    [anon_sym_AMP_AMP] = ACTIONS(3549),
    [anon_sym_TILDE] = ACTIONS(3549),
    [aux_sym_prefix_op_token1] = ACTIONS(3549),
    [sym_int] = ACTIONS(3551),
    [sym_xint] = ACTIONS(3549),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3549),
    [sym__dedent] = ACTIONS(3549),
  },
  [4203] = {
    [sym_block_comment] = STATE(4203),
    [sym_compiler_directive_decl] = STATE(4203),
    [sym_fsi_directive_decl] = STATE(4203),
    [sym_preproc_line] = STATE(4203),
    [sym_identifier] = ACTIONS(3539),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_do] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3539),
    [anon_sym_let_BANG] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_null] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3537),
    [anon_sym_LBRACE] = ACTIONS(3539),
    [anon_sym_LT_AT] = ACTIONS(3539),
    [anon_sym_LT_AT_AT] = ACTIONS(3537),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3537),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_return_BANG] = ACTIONS(3537),
    [anon_sym_yield] = ACTIONS(3539),
    [anon_sym_yield_BANG] = ACTIONS(3537),
    [anon_sym_lazy] = ACTIONS(3539),
    [anon_sym_assert] = ACTIONS(3539),
    [anon_sym_upcast] = ACTIONS(3539),
    [anon_sym_downcast] = ACTIONS(3539),
    [anon_sym_for] = ACTIONS(3539),
    [anon_sym_while] = ACTIONS(3539),
    [anon_sym_if] = ACTIONS(3539),
    [anon_sym_fun] = ACTIONS(3539),
    [anon_sym_DASH_GT] = ACTIONS(3537),
    [anon_sym_try] = ACTIONS(3539),
    [anon_sym_match] = ACTIONS(3539),
    [anon_sym_match_BANG] = ACTIONS(3537),
    [anon_sym_function] = ACTIONS(3539),
    [anon_sym_use] = ACTIONS(3539),
    [anon_sym_use_BANG] = ACTIONS(3537),
    [anon_sym_do_BANG] = ACTIONS(3537),
    [anon_sym_begin] = ACTIONS(3539),
    [anon_sym_STAR] = ACTIONS(3537),
    [anon_sym_LT2] = ACTIONS(3539),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [aux_sym_char_token1] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3539),
    [anon_sym_DQUOTE] = ACTIONS(3539),
    [anon_sym_AT_DQUOTE] = ACTIONS(3537),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3537),
    [sym_bool] = ACTIONS(3539),
    [sym_unit] = ACTIONS(3537),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3539),
    [sym_op_identifier] = ACTIONS(3537),
    [anon_sym_PLUS] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(3539),
    [anon_sym_PLUS_DOT] = ACTIONS(3537),
    [anon_sym_DASH_DOT] = ACTIONS(3537),
    [anon_sym_PERCENT] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [aux_sym_prefix_op_token1] = ACTIONS(3537),
    [sym_int] = ACTIONS(3539),
    [sym_xint] = ACTIONS(3537),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3537),
    [sym__dedent] = ACTIONS(3537),
  },
  [4204] = {
    [sym_block_comment] = STATE(4204),
    [sym_compiler_directive_decl] = STATE(4204),
    [sym_fsi_directive_decl] = STATE(4204),
    [sym_preproc_line] = STATE(4204),
    [sym_identifier] = ACTIONS(3543),
    [anon_sym_return] = ACTIONS(3543),
    [anon_sym_do] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3543),
    [anon_sym_let_BANG] = ACTIONS(3541),
    [anon_sym_LPAREN] = ACTIONS(3543),
    [anon_sym_null] = ACTIONS(3543),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3543),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3541),
    [anon_sym_LBRACE] = ACTIONS(3543),
    [anon_sym_LT_AT] = ACTIONS(3543),
    [anon_sym_LT_AT_AT] = ACTIONS(3541),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3541),
    [anon_sym_new] = ACTIONS(3543),
    [anon_sym_return_BANG] = ACTIONS(3541),
    [anon_sym_yield] = ACTIONS(3543),
    [anon_sym_yield_BANG] = ACTIONS(3541),
    [anon_sym_lazy] = ACTIONS(3543),
    [anon_sym_assert] = ACTIONS(3543),
    [anon_sym_upcast] = ACTIONS(3543),
    [anon_sym_downcast] = ACTIONS(3543),
    [anon_sym_for] = ACTIONS(3543),
    [anon_sym_while] = ACTIONS(3543),
    [anon_sym_if] = ACTIONS(3543),
    [anon_sym_fun] = ACTIONS(3543),
    [anon_sym_DASH_GT] = ACTIONS(3541),
    [anon_sym_try] = ACTIONS(3543),
    [anon_sym_match] = ACTIONS(3543),
    [anon_sym_match_BANG] = ACTIONS(3541),
    [anon_sym_function] = ACTIONS(3543),
    [anon_sym_use] = ACTIONS(3543),
    [anon_sym_use_BANG] = ACTIONS(3541),
    [anon_sym_do_BANG] = ACTIONS(3541),
    [anon_sym_begin] = ACTIONS(3543),
    [anon_sym_STAR] = ACTIONS(3541),
    [anon_sym_LT2] = ACTIONS(3543),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [aux_sym_char_token1] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3543),
    [anon_sym_DQUOTE] = ACTIONS(3543),
    [anon_sym_AT_DQUOTE] = ACTIONS(3541),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3541),
    [sym_bool] = ACTIONS(3543),
    [sym_unit] = ACTIONS(3541),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3543),
    [sym_op_identifier] = ACTIONS(3541),
    [anon_sym_PLUS] = ACTIONS(3543),
    [anon_sym_DASH] = ACTIONS(3543),
    [anon_sym_PLUS_DOT] = ACTIONS(3541),
    [anon_sym_DASH_DOT] = ACTIONS(3541),
    [anon_sym_PERCENT] = ACTIONS(3541),
    [anon_sym_AMP_AMP] = ACTIONS(3541),
    [anon_sym_TILDE] = ACTIONS(3541),
    [aux_sym_prefix_op_token1] = ACTIONS(3541),
    [sym_int] = ACTIONS(3543),
    [sym_xint] = ACTIONS(3541),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3541),
    [sym__dedent] = ACTIONS(3541),
  },
  [4205] = {
    [sym_block_comment] = STATE(4205),
    [sym_compiler_directive_decl] = STATE(4205),
    [sym_fsi_directive_decl] = STATE(4205),
    [sym_preproc_line] = STATE(4205),
    [sym_identifier] = ACTIONS(3523),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_let_BANG] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_null] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_LT_AT] = ACTIONS(3523),
    [anon_sym_LT_AT_AT] = ACTIONS(3521),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3521),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_return_BANG] = ACTIONS(3521),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_yield_BANG] = ACTIONS(3521),
    [anon_sym_lazy] = ACTIONS(3523),
    [anon_sym_assert] = ACTIONS(3523),
    [anon_sym_upcast] = ACTIONS(3523),
    [anon_sym_downcast] = ACTIONS(3523),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_fun] = ACTIONS(3523),
    [anon_sym_DASH_GT] = ACTIONS(3521),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_match] = ACTIONS(3523),
    [anon_sym_match_BANG] = ACTIONS(3521),
    [anon_sym_function] = ACTIONS(3523),
    [anon_sym_use] = ACTIONS(3523),
    [anon_sym_use_BANG] = ACTIONS(3521),
    [anon_sym_do_BANG] = ACTIONS(3521),
    [anon_sym_begin] = ACTIONS(3523),
    [anon_sym_STAR] = ACTIONS(3521),
    [anon_sym_LT2] = ACTIONS(3523),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3521),
    [aux_sym_char_token1] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_AT_DQUOTE] = ACTIONS(3521),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3521),
    [sym_bool] = ACTIONS(3523),
    [sym_unit] = ACTIONS(3521),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3523),
    [sym_op_identifier] = ACTIONS(3521),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_PLUS_DOT] = ACTIONS(3521),
    [anon_sym_DASH_DOT] = ACTIONS(3521),
    [anon_sym_PERCENT] = ACTIONS(3521),
    [anon_sym_AMP_AMP] = ACTIONS(3521),
    [anon_sym_TILDE] = ACTIONS(3521),
    [aux_sym_prefix_op_token1] = ACTIONS(3521),
    [sym_int] = ACTIONS(3523),
    [sym_xint] = ACTIONS(3521),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3521),
    [sym__dedent] = ACTIONS(3521),
  },
  [4206] = {
    [sym_block_comment] = STATE(4206),
    [sym_compiler_directive_decl] = STATE(4206),
    [sym_fsi_directive_decl] = STATE(4206),
    [sym_preproc_line] = STATE(4206),
    [sym_identifier] = ACTIONS(3547),
    [anon_sym_return] = ACTIONS(3547),
    [anon_sym_do] = ACTIONS(3547),
    [anon_sym_let] = ACTIONS(3547),
    [anon_sym_let_BANG] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(3547),
    [anon_sym_null] = ACTIONS(3547),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3545),
    [anon_sym_LBRACE] = ACTIONS(3547),
    [anon_sym_LT_AT] = ACTIONS(3547),
    [anon_sym_LT_AT_AT] = ACTIONS(3545),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3545),
    [anon_sym_new] = ACTIONS(3547),
    [anon_sym_return_BANG] = ACTIONS(3545),
    [anon_sym_yield] = ACTIONS(3547),
    [anon_sym_yield_BANG] = ACTIONS(3545),
    [anon_sym_lazy] = ACTIONS(3547),
    [anon_sym_assert] = ACTIONS(3547),
    [anon_sym_upcast] = ACTIONS(3547),
    [anon_sym_downcast] = ACTIONS(3547),
    [anon_sym_for] = ACTIONS(3547),
    [anon_sym_while] = ACTIONS(3547),
    [anon_sym_if] = ACTIONS(3547),
    [anon_sym_fun] = ACTIONS(3547),
    [anon_sym_DASH_GT] = ACTIONS(3545),
    [anon_sym_try] = ACTIONS(3547),
    [anon_sym_match] = ACTIONS(3547),
    [anon_sym_match_BANG] = ACTIONS(3545),
    [anon_sym_function] = ACTIONS(3547),
    [anon_sym_use] = ACTIONS(3547),
    [anon_sym_use_BANG] = ACTIONS(3545),
    [anon_sym_do_BANG] = ACTIONS(3545),
    [anon_sym_begin] = ACTIONS(3547),
    [anon_sym_STAR] = ACTIONS(3545),
    [anon_sym_LT2] = ACTIONS(3547),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [aux_sym_char_token1] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3547),
    [anon_sym_DQUOTE] = ACTIONS(3547),
    [anon_sym_AT_DQUOTE] = ACTIONS(3545),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3545),
    [sym_bool] = ACTIONS(3547),
    [sym_unit] = ACTIONS(3545),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3547),
    [sym_op_identifier] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PLUS_DOT] = ACTIONS(3545),
    [anon_sym_DASH_DOT] = ACTIONS(3545),
    [anon_sym_PERCENT] = ACTIONS(3545),
    [anon_sym_AMP_AMP] = ACTIONS(3545),
    [anon_sym_TILDE] = ACTIONS(3545),
    [aux_sym_prefix_op_token1] = ACTIONS(3545),
    [sym_int] = ACTIONS(3547),
    [sym_xint] = ACTIONS(3545),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3545),
    [sym__dedent] = ACTIONS(3545),
  },
  [4207] = {
    [sym_block_comment] = STATE(4207),
    [sym_compiler_directive_decl] = STATE(4207),
    [sym_fsi_directive_decl] = STATE(4207),
    [sym_preproc_line] = STATE(4207),
    [sym_identifier] = ACTIONS(3535),
    [anon_sym_return] = ACTIONS(3535),
    [anon_sym_do] = ACTIONS(3535),
    [anon_sym_let] = ACTIONS(3535),
    [anon_sym_let_BANG] = ACTIONS(3533),
    [anon_sym_LPAREN] = ACTIONS(3535),
    [anon_sym_null] = ACTIONS(3535),
    [anon_sym_AMP] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3533),
    [anon_sym_LBRACE] = ACTIONS(3535),
    [anon_sym_LT_AT] = ACTIONS(3535),
    [anon_sym_LT_AT_AT] = ACTIONS(3533),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3533),
    [anon_sym_new] = ACTIONS(3535),
    [anon_sym_return_BANG] = ACTIONS(3533),
    [anon_sym_yield] = ACTIONS(3535),
    [anon_sym_yield_BANG] = ACTIONS(3533),
    [anon_sym_lazy] = ACTIONS(3535),
    [anon_sym_assert] = ACTIONS(3535),
    [anon_sym_upcast] = ACTIONS(3535),
    [anon_sym_downcast] = ACTIONS(3535),
    [anon_sym_for] = ACTIONS(3535),
    [anon_sym_while] = ACTIONS(3535),
    [anon_sym_if] = ACTIONS(3535),
    [anon_sym_fun] = ACTIONS(3535),
    [anon_sym_DASH_GT] = ACTIONS(3533),
    [anon_sym_try] = ACTIONS(3535),
    [anon_sym_match] = ACTIONS(3535),
    [anon_sym_match_BANG] = ACTIONS(3533),
    [anon_sym_function] = ACTIONS(3535),
    [anon_sym_use] = ACTIONS(3535),
    [anon_sym_use_BANG] = ACTIONS(3533),
    [anon_sym_do_BANG] = ACTIONS(3533),
    [anon_sym_begin] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(3533),
    [anon_sym_LT2] = ACTIONS(3535),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3533),
    [aux_sym_char_token1] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3535),
    [anon_sym_DQUOTE] = ACTIONS(3535),
    [anon_sym_AT_DQUOTE] = ACTIONS(3533),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3533),
    [sym_bool] = ACTIONS(3535),
    [sym_unit] = ACTIONS(3533),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3535),
    [sym_op_identifier] = ACTIONS(3533),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_PLUS_DOT] = ACTIONS(3533),
    [anon_sym_DASH_DOT] = ACTIONS(3533),
    [anon_sym_PERCENT] = ACTIONS(3533),
    [anon_sym_AMP_AMP] = ACTIONS(3533),
    [anon_sym_TILDE] = ACTIONS(3533),
    [aux_sym_prefix_op_token1] = ACTIONS(3533),
    [sym_int] = ACTIONS(3535),
    [sym_xint] = ACTIONS(3533),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3533),
    [sym__dedent] = ACTIONS(3533),
  },
  [4208] = {
    [sym_block_comment] = STATE(4208),
    [sym_compiler_directive_decl] = STATE(4208),
    [sym_fsi_directive_decl] = STATE(4208),
    [sym_preproc_line] = STATE(4208),
    [sym_identifier] = ACTIONS(3531),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_do] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_let_BANG] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_null] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3531),
    [anon_sym_LT_AT] = ACTIONS(3531),
    [anon_sym_LT_AT_AT] = ACTIONS(3529),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3531),
    [anon_sym_return_BANG] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3531),
    [anon_sym_yield_BANG] = ACTIONS(3529),
    [anon_sym_lazy] = ACTIONS(3531),
    [anon_sym_assert] = ACTIONS(3531),
    [anon_sym_upcast] = ACTIONS(3531),
    [anon_sym_downcast] = ACTIONS(3531),
    [anon_sym_for] = ACTIONS(3531),
    [anon_sym_while] = ACTIONS(3531),
    [anon_sym_if] = ACTIONS(3531),
    [anon_sym_fun] = ACTIONS(3531),
    [anon_sym_DASH_GT] = ACTIONS(3529),
    [anon_sym_try] = ACTIONS(3531),
    [anon_sym_match] = ACTIONS(3531),
    [anon_sym_match_BANG] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3531),
    [anon_sym_use] = ACTIONS(3531),
    [anon_sym_use_BANG] = ACTIONS(3529),
    [anon_sym_do_BANG] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3531),
    [anon_sym_STAR] = ACTIONS(3529),
    [anon_sym_LT2] = ACTIONS(3531),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [aux_sym_char_token1] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3531),
    [anon_sym_DQUOTE] = ACTIONS(3531),
    [anon_sym_AT_DQUOTE] = ACTIONS(3529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3529),
    [sym_bool] = ACTIONS(3531),
    [sym_unit] = ACTIONS(3529),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3531),
    [sym_op_identifier] = ACTIONS(3529),
    [anon_sym_PLUS] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(3531),
    [anon_sym_PLUS_DOT] = ACTIONS(3529),
    [anon_sym_DASH_DOT] = ACTIONS(3529),
    [anon_sym_PERCENT] = ACTIONS(3529),
    [anon_sym_AMP_AMP] = ACTIONS(3529),
    [anon_sym_TILDE] = ACTIONS(3529),
    [aux_sym_prefix_op_token1] = ACTIONS(3529),
    [sym_int] = ACTIONS(3531),
    [sym_xint] = ACTIONS(3529),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3529),
    [sym__dedent] = ACTIONS(3529),
  },
  [4209] = {
    [sym_block_comment] = STATE(4209),
    [sym_compiler_directive_decl] = STATE(4209),
    [sym_fsi_directive_decl] = STATE(4209),
    [sym_preproc_line] = STATE(4209),
    [sym_identifier] = ACTIONS(3515),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_let_BANG] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_null] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_LT_AT] = ACTIONS(3515),
    [anon_sym_LT_AT_AT] = ACTIONS(3513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_return_BANG] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_yield_BANG] = ACTIONS(3513),
    [anon_sym_lazy] = ACTIONS(3515),
    [anon_sym_assert] = ACTIONS(3515),
    [anon_sym_upcast] = ACTIONS(3515),
    [anon_sym_downcast] = ACTIONS(3515),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_fun] = ACTIONS(3515),
    [anon_sym_DASH_GT] = ACTIONS(3513),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_match] = ACTIONS(3515),
    [anon_sym_match_BANG] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3515),
    [anon_sym_use] = ACTIONS(3515),
    [anon_sym_use_BANG] = ACTIONS(3513),
    [anon_sym_do_BANG] = ACTIONS(3513),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3513),
    [anon_sym_LT2] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3513),
    [aux_sym_char_token1] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_AT_DQUOTE] = ACTIONS(3513),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3513),
    [sym_bool] = ACTIONS(3515),
    [sym_unit] = ACTIONS(3513),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3515),
    [sym_op_identifier] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_PLUS_DOT] = ACTIONS(3513),
    [anon_sym_DASH_DOT] = ACTIONS(3513),
    [anon_sym_PERCENT] = ACTIONS(3513),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_TILDE] = ACTIONS(3513),
    [aux_sym_prefix_op_token1] = ACTIONS(3513),
    [sym_int] = ACTIONS(3515),
    [sym_xint] = ACTIONS(3513),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3513),
    [sym__dedent] = ACTIONS(3513),
  },
  [4210] = {
    [sym_block_comment] = STATE(4210),
    [sym_compiler_directive_decl] = STATE(4210),
    [sym_fsi_directive_decl] = STATE(4210),
    [sym_preproc_line] = STATE(4210),
    [sym_identifier] = ACTIONS(3519),
    [anon_sym_return] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(3519),
    [anon_sym_let] = ACTIONS(3519),
    [anon_sym_let_BANG] = ACTIONS(3517),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [anon_sym_null] = ACTIONS(3519),
    [anon_sym_AMP] = ACTIONS(3519),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_LT_AT] = ACTIONS(3519),
    [anon_sym_LT_AT_AT] = ACTIONS(3517),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3519),
    [anon_sym_return_BANG] = ACTIONS(3517),
    [anon_sym_yield] = ACTIONS(3519),
    [anon_sym_yield_BANG] = ACTIONS(3517),
    [anon_sym_lazy] = ACTIONS(3519),
    [anon_sym_assert] = ACTIONS(3519),
    [anon_sym_upcast] = ACTIONS(3519),
    [anon_sym_downcast] = ACTIONS(3519),
    [anon_sym_for] = ACTIONS(3519),
    [anon_sym_while] = ACTIONS(3519),
    [anon_sym_if] = ACTIONS(3519),
    [anon_sym_fun] = ACTIONS(3519),
    [anon_sym_DASH_GT] = ACTIONS(3517),
    [anon_sym_try] = ACTIONS(3519),
    [anon_sym_match] = ACTIONS(3519),
    [anon_sym_match_BANG] = ACTIONS(3517),
    [anon_sym_function] = ACTIONS(3519),
    [anon_sym_use] = ACTIONS(3519),
    [anon_sym_use_BANG] = ACTIONS(3517),
    [anon_sym_do_BANG] = ACTIONS(3517),
    [anon_sym_begin] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3517),
    [anon_sym_LT2] = ACTIONS(3519),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3517),
    [aux_sym_char_token1] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [anon_sym_AT_DQUOTE] = ACTIONS(3517),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3517),
    [sym_bool] = ACTIONS(3519),
    [sym_unit] = ACTIONS(3517),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3519),
    [sym_op_identifier] = ACTIONS(3517),
    [anon_sym_PLUS] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3519),
    [anon_sym_PLUS_DOT] = ACTIONS(3517),
    [anon_sym_DASH_DOT] = ACTIONS(3517),
    [anon_sym_PERCENT] = ACTIONS(3517),
    [anon_sym_AMP_AMP] = ACTIONS(3517),
    [anon_sym_TILDE] = ACTIONS(3517),
    [aux_sym_prefix_op_token1] = ACTIONS(3517),
    [sym_int] = ACTIONS(3519),
    [sym_xint] = ACTIONS(3517),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3517),
    [sym__dedent] = ACTIONS(3517),
  },
  [4211] = {
    [sym_block_comment] = STATE(4211),
    [sym_compiler_directive_decl] = STATE(4211),
    [sym_fsi_directive_decl] = STATE(4211),
    [sym_preproc_line] = STATE(4211),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_let_BANG] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_null] = ACTIONS(3527),
    [anon_sym_AMP] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_LT_AT] = ACTIONS(3527),
    [anon_sym_LT_AT_AT] = ACTIONS(3525),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_return_BANG] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_yield_BANG] = ACTIONS(3525),
    [anon_sym_lazy] = ACTIONS(3527),
    [anon_sym_assert] = ACTIONS(3527),
    [anon_sym_upcast] = ACTIONS(3527),
    [anon_sym_downcast] = ACTIONS(3527),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_fun] = ACTIONS(3527),
    [anon_sym_DASH_GT] = ACTIONS(3525),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_match] = ACTIONS(3527),
    [anon_sym_match_BANG] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3527),
    [anon_sym_use] = ACTIONS(3527),
    [anon_sym_use_BANG] = ACTIONS(3525),
    [anon_sym_do_BANG] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3527),
    [anon_sym_STAR] = ACTIONS(3525),
    [anon_sym_LT2] = ACTIONS(3527),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [aux_sym_char_token1] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_AT_DQUOTE] = ACTIONS(3525),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3525),
    [sym_bool] = ACTIONS(3527),
    [sym_unit] = ACTIONS(3525),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3527),
    [sym_op_identifier] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_PLUS_DOT] = ACTIONS(3525),
    [anon_sym_DASH_DOT] = ACTIONS(3525),
    [anon_sym_PERCENT] = ACTIONS(3525),
    [anon_sym_AMP_AMP] = ACTIONS(3525),
    [anon_sym_TILDE] = ACTIONS(3525),
    [aux_sym_prefix_op_token1] = ACTIONS(3525),
    [sym_int] = ACTIONS(3527),
    [sym_xint] = ACTIONS(3525),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3525),
    [sym__dedent] = ACTIONS(3525),
  },
  [4212] = {
    [sym_block_comment] = STATE(4212),
    [sym_compiler_directive_decl] = STATE(4212),
    [sym_fsi_directive_decl] = STATE(4212),
    [sym_preproc_line] = STATE(4212),
    [sym_identifier] = ACTIONS(3728),
    [anon_sym_return] = ACTIONS(3728),
    [anon_sym_do] = ACTIONS(3728),
    [anon_sym_let] = ACTIONS(3728),
    [anon_sym_let_BANG] = ACTIONS(3726),
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_COMMA] = ACTIONS(3726),
    [anon_sym_null] = ACTIONS(3728),
    [anon_sym_AMP] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3726),
    [anon_sym_LBRACE] = ACTIONS(3728),
    [anon_sym_LT_AT] = ACTIONS(3728),
    [anon_sym_LT_AT_AT] = ACTIONS(3726),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3726),
    [anon_sym_new] = ACTIONS(3728),
    [anon_sym_return_BANG] = ACTIONS(3726),
    [anon_sym_yield] = ACTIONS(3728),
    [anon_sym_yield_BANG] = ACTIONS(3726),
    [anon_sym_lazy] = ACTIONS(3728),
    [anon_sym_assert] = ACTIONS(3728),
    [anon_sym_upcast] = ACTIONS(3728),
    [anon_sym_downcast] = ACTIONS(3728),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_fun] = ACTIONS(3728),
    [anon_sym_try] = ACTIONS(3728),
    [anon_sym_match] = ACTIONS(3728),
    [anon_sym_match_BANG] = ACTIONS(3726),
    [anon_sym_function] = ACTIONS(3728),
    [anon_sym_GT] = ACTIONS(3726),
    [anon_sym_use] = ACTIONS(3728),
    [anon_sym_use_BANG] = ACTIONS(3726),
    [anon_sym_do_BANG] = ACTIONS(3726),
    [anon_sym_begin] = ACTIONS(3728),
    [aux_sym_char_token1] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3728),
    [anon_sym_AT_DQUOTE] = ACTIONS(3726),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3726),
    [sym_bool] = ACTIONS(3728),
    [sym_unit] = ACTIONS(3726),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3728),
    [sym_op_identifier] = ACTIONS(3726),
    [anon_sym_PLUS] = ACTIONS(3728),
    [anon_sym_DASH] = ACTIONS(3728),
    [anon_sym_PLUS_DOT] = ACTIONS(3726),
    [anon_sym_DASH_DOT] = ACTIONS(3726),
    [anon_sym_PERCENT] = ACTIONS(3726),
    [anon_sym_AMP_AMP] = ACTIONS(3726),
    [anon_sym_TILDE] = ACTIONS(3726),
    [aux_sym_prefix_op_token1] = ACTIONS(3726),
    [sym_int] = ACTIONS(3728),
    [sym_xint] = ACTIONS(3726),
    [anon_sym_f] = ACTIONS(3728),
    [aux_sym_decimal_token1] = ACTIONS(3728),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3726),
  },
  [4213] = {
    [sym_block_comment] = STATE(4213),
    [sym_compiler_directive_decl] = STATE(4213),
    [sym_fsi_directive_decl] = STATE(4213),
    [sym_preproc_line] = STATE(4213),
    [aux_sym__function_or_value_defns_repeat1] = STATE(4213),
    [sym_identifier] = ACTIONS(6117),
    [anon_sym_return] = ACTIONS(6117),
    [anon_sym_do] = ACTIONS(6117),
    [anon_sym_and] = ACTIONS(6965),
    [anon_sym_let] = ACTIONS(6117),
    [anon_sym_let_BANG] = ACTIONS(6115),
    [anon_sym_LPAREN] = ACTIONS(6117),
    [anon_sym_null] = ACTIONS(6117),
    [anon_sym_AMP] = ACTIONS(6117),
    [anon_sym_LBRACK] = ACTIONS(6117),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6115),
    [anon_sym_LBRACE] = ACTIONS(6117),
    [anon_sym_LT_AT] = ACTIONS(6117),
    [anon_sym_LT_AT_AT] = ACTIONS(6115),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6115),
    [anon_sym_new] = ACTIONS(6117),
    [anon_sym_return_BANG] = ACTIONS(6115),
    [anon_sym_yield] = ACTIONS(6117),
    [anon_sym_yield_BANG] = ACTIONS(6115),
    [anon_sym_lazy] = ACTIONS(6117),
    [anon_sym_assert] = ACTIONS(6117),
    [anon_sym_upcast] = ACTIONS(6117),
    [anon_sym_downcast] = ACTIONS(6117),
    [anon_sym_for] = ACTIONS(6117),
    [anon_sym_while] = ACTIONS(6117),
    [anon_sym_if] = ACTIONS(6117),
    [anon_sym_fun] = ACTIONS(6117),
    [anon_sym_try] = ACTIONS(6117),
    [anon_sym_match] = ACTIONS(6117),
    [anon_sym_match_BANG] = ACTIONS(6115),
    [anon_sym_function] = ACTIONS(6117),
    [anon_sym_use] = ACTIONS(6117),
    [anon_sym_use_BANG] = ACTIONS(6115),
    [anon_sym_do_BANG] = ACTIONS(6115),
    [anon_sym_begin] = ACTIONS(6117),
    [aux_sym_char_token1] = ACTIONS(6115),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6117),
    [anon_sym_DQUOTE] = ACTIONS(6117),
    [anon_sym_AT_DQUOTE] = ACTIONS(6115),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6115),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6115),
    [sym_bool] = ACTIONS(6117),
    [sym_unit] = ACTIONS(6115),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6117),
    [sym_op_identifier] = ACTIONS(6115),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_PLUS_DOT] = ACTIONS(6115),
    [anon_sym_DASH_DOT] = ACTIONS(6115),
    [anon_sym_PERCENT] = ACTIONS(6115),
    [anon_sym_AMP_AMP] = ACTIONS(6115),
    [anon_sym_TILDE] = ACTIONS(6115),
    [aux_sym_prefix_op_token1] = ACTIONS(6115),
    [sym_int] = ACTIONS(6117),
    [sym_xint] = ACTIONS(6115),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6115),
    [sym__newline] = ACTIONS(6115),
    [sym__dedent] = ACTIONS(6115),
  },
  [4214] = {
    [sym_block_comment] = STATE(4214),
    [sym_compiler_directive_decl] = STATE(4214),
    [sym_fsi_directive_decl] = STATE(4214),
    [sym_preproc_line] = STATE(4214),
    [aux_sym__function_or_value_defns_repeat1] = STATE(4221),
    [sym_identifier] = ACTIONS(6192),
    [anon_sym_return] = ACTIONS(6192),
    [anon_sym_do] = ACTIONS(6192),
    [anon_sym_and] = ACTIONS(6968),
    [anon_sym_let] = ACTIONS(6192),
    [anon_sym_let_BANG] = ACTIONS(6190),
    [anon_sym_LPAREN] = ACTIONS(6192),
    [anon_sym_null] = ACTIONS(6192),
    [anon_sym_AMP] = ACTIONS(6192),
    [anon_sym_LBRACK] = ACTIONS(6192),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6190),
    [anon_sym_LBRACE] = ACTIONS(6192),
    [anon_sym_LT_AT] = ACTIONS(6192),
    [anon_sym_LT_AT_AT] = ACTIONS(6190),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6190),
    [anon_sym_new] = ACTIONS(6192),
    [anon_sym_return_BANG] = ACTIONS(6190),
    [anon_sym_yield] = ACTIONS(6192),
    [anon_sym_yield_BANG] = ACTIONS(6190),
    [anon_sym_lazy] = ACTIONS(6192),
    [anon_sym_assert] = ACTIONS(6192),
    [anon_sym_upcast] = ACTIONS(6192),
    [anon_sym_downcast] = ACTIONS(6192),
    [anon_sym_for] = ACTIONS(6192),
    [anon_sym_while] = ACTIONS(6192),
    [anon_sym_if] = ACTIONS(6192),
    [anon_sym_fun] = ACTIONS(6192),
    [anon_sym_try] = ACTIONS(6192),
    [anon_sym_match] = ACTIONS(6192),
    [anon_sym_match_BANG] = ACTIONS(6190),
    [anon_sym_function] = ACTIONS(6192),
    [anon_sym_use] = ACTIONS(6192),
    [anon_sym_use_BANG] = ACTIONS(6190),
    [anon_sym_do_BANG] = ACTIONS(6190),
    [anon_sym_begin] = ACTIONS(6192),
    [aux_sym_char_token1] = ACTIONS(6190),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6192),
    [anon_sym_DQUOTE] = ACTIONS(6192),
    [anon_sym_AT_DQUOTE] = ACTIONS(6190),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6190),
    [sym_bool] = ACTIONS(6192),
    [sym_unit] = ACTIONS(6190),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6192),
    [sym_op_identifier] = ACTIONS(6190),
    [anon_sym_PLUS] = ACTIONS(6192),
    [anon_sym_DASH] = ACTIONS(6192),
    [anon_sym_PLUS_DOT] = ACTIONS(6190),
    [anon_sym_DASH_DOT] = ACTIONS(6190),
    [anon_sym_PERCENT] = ACTIONS(6190),
    [anon_sym_AMP_AMP] = ACTIONS(6190),
    [anon_sym_TILDE] = ACTIONS(6190),
    [aux_sym_prefix_op_token1] = ACTIONS(6190),
    [sym_int] = ACTIONS(6192),
    [sym_xint] = ACTIONS(6190),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6190),
    [sym__newline] = ACTIONS(6190),
    [sym__dedent] = ACTIONS(6190),
  },
  [4215] = {
    [sym_block_comment] = STATE(4215),
    [sym_compiler_directive_decl] = STATE(4215),
    [sym_fsi_directive_decl] = STATE(4215),
    [sym_preproc_line] = STATE(4215),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_do] = ACTIONS(3604),
    [anon_sym_let] = ACTIONS(3604),
    [anon_sym_let_BANG] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3604),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_null] = ACTIONS(3604),
    [anon_sym_AMP] = ACTIONS(3604),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3602),
    [anon_sym_LBRACE] = ACTIONS(3604),
    [anon_sym_LT_AT] = ACTIONS(3604),
    [anon_sym_LT_AT_AT] = ACTIONS(3602),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3604),
    [anon_sym_return_BANG] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3604),
    [anon_sym_yield_BANG] = ACTIONS(3602),
    [anon_sym_lazy] = ACTIONS(3604),
    [anon_sym_assert] = ACTIONS(3604),
    [anon_sym_upcast] = ACTIONS(3604),
    [anon_sym_downcast] = ACTIONS(3604),
    [anon_sym_for] = ACTIONS(3604),
    [anon_sym_while] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(3604),
    [anon_sym_fun] = ACTIONS(3604),
    [anon_sym_try] = ACTIONS(3604),
    [anon_sym_match] = ACTIONS(3604),
    [anon_sym_match_BANG] = ACTIONS(3602),
    [anon_sym_function] = ACTIONS(3604),
    [anon_sym_GT] = ACTIONS(3602),
    [anon_sym_use] = ACTIONS(3604),
    [anon_sym_use_BANG] = ACTIONS(3602),
    [anon_sym_do_BANG] = ACTIONS(3602),
    [anon_sym_begin] = ACTIONS(3604),
    [aux_sym_char_token1] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(3604),
    [anon_sym_AT_DQUOTE] = ACTIONS(3602),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3602),
    [sym_bool] = ACTIONS(3604),
    [sym_unit] = ACTIONS(3602),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3604),
    [sym_op_identifier] = ACTIONS(3602),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [anon_sym_PLUS_DOT] = ACTIONS(3602),
    [anon_sym_DASH_DOT] = ACTIONS(3602),
    [anon_sym_PERCENT] = ACTIONS(3602),
    [anon_sym_AMP_AMP] = ACTIONS(3602),
    [anon_sym_TILDE] = ACTIONS(3602),
    [aux_sym_prefix_op_token1] = ACTIONS(3602),
    [sym_int] = ACTIONS(3604),
    [sym_xint] = ACTIONS(3602),
    [anon_sym_f] = ACTIONS(3604),
    [aux_sym_decimal_token1] = ACTIONS(3604),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3602),
  },
  [4216] = {
    [sym_block_comment] = STATE(4216),
    [sym_compiler_directive_decl] = STATE(4216),
    [sym_fsi_directive_decl] = STATE(4216),
    [sym_preproc_line] = STATE(4216),
    [aux_sym__function_or_value_defns_repeat1] = STATE(4217),
    [sym_identifier] = ACTIONS(6192),
    [anon_sym_return] = ACTIONS(6192),
    [anon_sym_do] = ACTIONS(6192),
    [anon_sym_and] = ACTIONS(6970),
    [anon_sym_let] = ACTIONS(6192),
    [anon_sym_let_BANG] = ACTIONS(6190),
    [anon_sym_LPAREN] = ACTIONS(6192),
    [anon_sym_null] = ACTIONS(6192),
    [anon_sym_AMP] = ACTIONS(6192),
    [anon_sym_LBRACK] = ACTIONS(6192),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6190),
    [anon_sym_LBRACE] = ACTIONS(6192),
    [anon_sym_LT_AT] = ACTIONS(6192),
    [anon_sym_LT_AT_AT] = ACTIONS(6190),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6190),
    [anon_sym_new] = ACTIONS(6192),
    [anon_sym_return_BANG] = ACTIONS(6190),
    [anon_sym_yield] = ACTIONS(6192),
    [anon_sym_yield_BANG] = ACTIONS(6190),
    [anon_sym_lazy] = ACTIONS(6192),
    [anon_sym_assert] = ACTIONS(6192),
    [anon_sym_upcast] = ACTIONS(6192),
    [anon_sym_downcast] = ACTIONS(6192),
    [anon_sym_for] = ACTIONS(6192),
    [anon_sym_while] = ACTIONS(6192),
    [anon_sym_if] = ACTIONS(6192),
    [anon_sym_fun] = ACTIONS(6192),
    [anon_sym_try] = ACTIONS(6192),
    [anon_sym_match] = ACTIONS(6192),
    [anon_sym_match_BANG] = ACTIONS(6190),
    [anon_sym_function] = ACTIONS(6192),
    [anon_sym_use] = ACTIONS(6192),
    [anon_sym_use_BANG] = ACTIONS(6190),
    [anon_sym_do_BANG] = ACTIONS(6190),
    [anon_sym_begin] = ACTIONS(6192),
    [aux_sym_char_token1] = ACTIONS(6190),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6192),
    [anon_sym_DQUOTE] = ACTIONS(6192),
    [anon_sym_AT_DQUOTE] = ACTIONS(6190),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6190),
    [sym_bool] = ACTIONS(6192),
    [sym_unit] = ACTIONS(6190),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6192),
    [sym_op_identifier] = ACTIONS(6190),
    [anon_sym_PLUS] = ACTIONS(6192),
    [anon_sym_DASH] = ACTIONS(6192),
    [anon_sym_PLUS_DOT] = ACTIONS(6190),
    [anon_sym_DASH_DOT] = ACTIONS(6190),
    [anon_sym_PERCENT] = ACTIONS(6190),
    [anon_sym_AMP_AMP] = ACTIONS(6190),
    [anon_sym_TILDE] = ACTIONS(6190),
    [aux_sym_prefix_op_token1] = ACTIONS(6190),
    [sym_int] = ACTIONS(6192),
    [sym_xint] = ACTIONS(6190),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6190),
    [anon_sym_POUNDendif] = ACTIONS(6190),
    [anon_sym_POUNDelse] = ACTIONS(6190),
  },
  [4217] = {
    [sym_block_comment] = STATE(4217),
    [sym_compiler_directive_decl] = STATE(4217),
    [sym_fsi_directive_decl] = STATE(4217),
    [sym_preproc_line] = STATE(4217),
    [aux_sym__function_or_value_defns_repeat1] = STATE(4218),
    [sym_identifier] = ACTIONS(6158),
    [anon_sym_return] = ACTIONS(6158),
    [anon_sym_do] = ACTIONS(6158),
    [anon_sym_and] = ACTIONS(6970),
    [anon_sym_let] = ACTIONS(6158),
    [anon_sym_let_BANG] = ACTIONS(6156),
    [anon_sym_LPAREN] = ACTIONS(6158),
    [anon_sym_null] = ACTIONS(6158),
    [anon_sym_AMP] = ACTIONS(6158),
    [anon_sym_LBRACK] = ACTIONS(6158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6156),
    [anon_sym_LBRACE] = ACTIONS(6158),
    [anon_sym_LT_AT] = ACTIONS(6158),
    [anon_sym_LT_AT_AT] = ACTIONS(6156),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6156),
    [anon_sym_new] = ACTIONS(6158),
    [anon_sym_return_BANG] = ACTIONS(6156),
    [anon_sym_yield] = ACTIONS(6158),
    [anon_sym_yield_BANG] = ACTIONS(6156),
    [anon_sym_lazy] = ACTIONS(6158),
    [anon_sym_assert] = ACTIONS(6158),
    [anon_sym_upcast] = ACTIONS(6158),
    [anon_sym_downcast] = ACTIONS(6158),
    [anon_sym_for] = ACTIONS(6158),
    [anon_sym_while] = ACTIONS(6158),
    [anon_sym_if] = ACTIONS(6158),
    [anon_sym_fun] = ACTIONS(6158),
    [anon_sym_try] = ACTIONS(6158),
    [anon_sym_match] = ACTIONS(6158),
    [anon_sym_match_BANG] = ACTIONS(6156),
    [anon_sym_function] = ACTIONS(6158),
    [anon_sym_use] = ACTIONS(6158),
    [anon_sym_use_BANG] = ACTIONS(6156),
    [anon_sym_do_BANG] = ACTIONS(6156),
    [anon_sym_begin] = ACTIONS(6158),
    [aux_sym_char_token1] = ACTIONS(6156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6158),
    [anon_sym_DQUOTE] = ACTIONS(6158),
    [anon_sym_AT_DQUOTE] = ACTIONS(6156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6156),
    [sym_bool] = ACTIONS(6158),
    [sym_unit] = ACTIONS(6156),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6158),
    [sym_op_identifier] = ACTIONS(6156),
    [anon_sym_PLUS] = ACTIONS(6158),
    [anon_sym_DASH] = ACTIONS(6158),
    [anon_sym_PLUS_DOT] = ACTIONS(6156),
    [anon_sym_DASH_DOT] = ACTIONS(6156),
    [anon_sym_PERCENT] = ACTIONS(6156),
    [anon_sym_AMP_AMP] = ACTIONS(6156),
    [anon_sym_TILDE] = ACTIONS(6156),
    [aux_sym_prefix_op_token1] = ACTIONS(6156),
    [sym_int] = ACTIONS(6158),
    [sym_xint] = ACTIONS(6156),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6156),
    [anon_sym_POUNDendif] = ACTIONS(6156),
    [anon_sym_POUNDelse] = ACTIONS(6156),
  },
  [4218] = {
    [sym_block_comment] = STATE(4218),
    [sym_compiler_directive_decl] = STATE(4218),
    [sym_fsi_directive_decl] = STATE(4218),
    [sym_preproc_line] = STATE(4218),
    [aux_sym__function_or_value_defns_repeat1] = STATE(4218),
    [sym_identifier] = ACTIONS(6117),
    [anon_sym_return] = ACTIONS(6117),
    [anon_sym_do] = ACTIONS(6117),
    [anon_sym_and] = ACTIONS(6972),
    [anon_sym_let] = ACTIONS(6117),
    [anon_sym_let_BANG] = ACTIONS(6115),
    [anon_sym_LPAREN] = ACTIONS(6117),
    [anon_sym_null] = ACTIONS(6117),
    [anon_sym_AMP] = ACTIONS(6117),
    [anon_sym_LBRACK] = ACTIONS(6117),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6115),
    [anon_sym_LBRACE] = ACTIONS(6117),
    [anon_sym_LT_AT] = ACTIONS(6117),
    [anon_sym_LT_AT_AT] = ACTIONS(6115),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6115),
    [anon_sym_new] = ACTIONS(6117),
    [anon_sym_return_BANG] = ACTIONS(6115),
    [anon_sym_yield] = ACTIONS(6117),
    [anon_sym_yield_BANG] = ACTIONS(6115),
    [anon_sym_lazy] = ACTIONS(6117),
    [anon_sym_assert] = ACTIONS(6117),
    [anon_sym_upcast] = ACTIONS(6117),
    [anon_sym_downcast] = ACTIONS(6117),
    [anon_sym_for] = ACTIONS(6117),
    [anon_sym_while] = ACTIONS(6117),
    [anon_sym_if] = ACTIONS(6117),
    [anon_sym_fun] = ACTIONS(6117),
    [anon_sym_try] = ACTIONS(6117),
    [anon_sym_match] = ACTIONS(6117),
    [anon_sym_match_BANG] = ACTIONS(6115),
    [anon_sym_function] = ACTIONS(6117),
    [anon_sym_use] = ACTIONS(6117),
    [anon_sym_use_BANG] = ACTIONS(6115),
    [anon_sym_do_BANG] = ACTIONS(6115),
    [anon_sym_begin] = ACTIONS(6117),
    [aux_sym_char_token1] = ACTIONS(6115),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6117),
    [anon_sym_DQUOTE] = ACTIONS(6117),
    [anon_sym_AT_DQUOTE] = ACTIONS(6115),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6115),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6115),
    [sym_bool] = ACTIONS(6117),
    [sym_unit] = ACTIONS(6115),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6117),
    [sym_op_identifier] = ACTIONS(6115),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_PLUS_DOT] = ACTIONS(6115),
    [anon_sym_DASH_DOT] = ACTIONS(6115),
    [anon_sym_PERCENT] = ACTIONS(6115),
    [anon_sym_AMP_AMP] = ACTIONS(6115),
    [anon_sym_TILDE] = ACTIONS(6115),
    [aux_sym_prefix_op_token1] = ACTIONS(6115),
    [sym_int] = ACTIONS(6117),
    [sym_xint] = ACTIONS(6115),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6115),
    [anon_sym_POUNDendif] = ACTIONS(6115),
    [anon_sym_POUNDelse] = ACTIONS(6115),
  },
  [4219] = {
    [sym_block_comment] = STATE(4219),
    [sym_compiler_directive_decl] = STATE(4219),
    [sym_fsi_directive_decl] = STATE(4219),
    [sym_preproc_line] = STATE(4219),
    [sym_identifier] = ACTIONS(3753),
    [anon_sym_return] = ACTIONS(3753),
    [anon_sym_do] = ACTIONS(3753),
    [anon_sym_let] = ACTIONS(3753),
    [anon_sym_let_BANG] = ACTIONS(3751),
    [anon_sym_LPAREN] = ACTIONS(3753),
    [anon_sym_COMMA] = ACTIONS(3751),
    [anon_sym_null] = ACTIONS(3753),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3751),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_LT_AT] = ACTIONS(3753),
    [anon_sym_LT_AT_AT] = ACTIONS(3751),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3751),
    [anon_sym_new] = ACTIONS(3753),
    [anon_sym_return_BANG] = ACTIONS(3751),
    [anon_sym_yield] = ACTIONS(3753),
    [anon_sym_yield_BANG] = ACTIONS(3751),
    [anon_sym_lazy] = ACTIONS(3753),
    [anon_sym_assert] = ACTIONS(3753),
    [anon_sym_upcast] = ACTIONS(3753),
    [anon_sym_downcast] = ACTIONS(3753),
    [anon_sym_for] = ACTIONS(3753),
    [anon_sym_while] = ACTIONS(3753),
    [anon_sym_if] = ACTIONS(3753),
    [anon_sym_fun] = ACTIONS(3753),
    [anon_sym_try] = ACTIONS(3753),
    [anon_sym_match] = ACTIONS(3753),
    [anon_sym_match_BANG] = ACTIONS(3751),
    [anon_sym_function] = ACTIONS(3753),
    [anon_sym_GT] = ACTIONS(3751),
    [anon_sym_use] = ACTIONS(3753),
    [anon_sym_use_BANG] = ACTIONS(3751),
    [anon_sym_do_BANG] = ACTIONS(3751),
    [anon_sym_begin] = ACTIONS(3753),
    [aux_sym_char_token1] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3753),
    [anon_sym_AT_DQUOTE] = ACTIONS(3751),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3751),
    [sym_bool] = ACTIONS(3753),
    [sym_unit] = ACTIONS(3751),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3753),
    [sym_op_identifier] = ACTIONS(3751),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PLUS_DOT] = ACTIONS(3751),
    [anon_sym_DASH_DOT] = ACTIONS(3751),
    [anon_sym_PERCENT] = ACTIONS(3751),
    [anon_sym_AMP_AMP] = ACTIONS(3751),
    [anon_sym_TILDE] = ACTIONS(3751),
    [aux_sym_prefix_op_token1] = ACTIONS(3751),
    [sym_int] = ACTIONS(6975),
    [sym_xint] = ACTIONS(3751),
    [anon_sym_f] = ACTIONS(3753),
    [aux_sym_decimal_token1] = ACTIONS(3753),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3751),
  },
  [4220] = {
    [sym_block_comment] = STATE(4220),
    [sym_compiler_directive_decl] = STATE(4220),
    [sym_fsi_directive_decl] = STATE(4220),
    [sym_preproc_line] = STATE(4220),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3191),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_GT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3191),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3191),
    [anon_sym_DASH_DOT] = ACTIONS(3191),
    [anon_sym_PERCENT] = ACTIONS(3191),
    [anon_sym_AMP_AMP] = ACTIONS(3191),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3191),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_f] = ACTIONS(6515),
    [aux_sym_decimal_token1] = ACTIONS(6368),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
  },
  [4221] = {
    [sym_block_comment] = STATE(4221),
    [sym_compiler_directive_decl] = STATE(4221),
    [sym_fsi_directive_decl] = STATE(4221),
    [sym_preproc_line] = STATE(4221),
    [aux_sym__function_or_value_defns_repeat1] = STATE(4213),
    [sym_identifier] = ACTIONS(6158),
    [anon_sym_return] = ACTIONS(6158),
    [anon_sym_do] = ACTIONS(6158),
    [anon_sym_and] = ACTIONS(6968),
    [anon_sym_let] = ACTIONS(6158),
    [anon_sym_let_BANG] = ACTIONS(6156),
    [anon_sym_LPAREN] = ACTIONS(6158),
    [anon_sym_null] = ACTIONS(6158),
    [anon_sym_AMP] = ACTIONS(6158),
    [anon_sym_LBRACK] = ACTIONS(6158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6156),
    [anon_sym_LBRACE] = ACTIONS(6158),
    [anon_sym_LT_AT] = ACTIONS(6158),
    [anon_sym_LT_AT_AT] = ACTIONS(6156),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6156),
    [anon_sym_new] = ACTIONS(6158),
    [anon_sym_return_BANG] = ACTIONS(6156),
    [anon_sym_yield] = ACTIONS(6158),
    [anon_sym_yield_BANG] = ACTIONS(6156),
    [anon_sym_lazy] = ACTIONS(6158),
    [anon_sym_assert] = ACTIONS(6158),
    [anon_sym_upcast] = ACTIONS(6158),
    [anon_sym_downcast] = ACTIONS(6158),
    [anon_sym_for] = ACTIONS(6158),
    [anon_sym_while] = ACTIONS(6158),
    [anon_sym_if] = ACTIONS(6158),
    [anon_sym_fun] = ACTIONS(6158),
    [anon_sym_try] = ACTIONS(6158),
    [anon_sym_match] = ACTIONS(6158),
    [anon_sym_match_BANG] = ACTIONS(6156),
    [anon_sym_function] = ACTIONS(6158),
    [anon_sym_use] = ACTIONS(6158),
    [anon_sym_use_BANG] = ACTIONS(6156),
    [anon_sym_do_BANG] = ACTIONS(6156),
    [anon_sym_begin] = ACTIONS(6158),
    [aux_sym_char_token1] = ACTIONS(6156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6158),
    [anon_sym_DQUOTE] = ACTIONS(6158),
    [anon_sym_AT_DQUOTE] = ACTIONS(6156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6156),
    [sym_bool] = ACTIONS(6158),
    [sym_unit] = ACTIONS(6156),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6158),
    [sym_op_identifier] = ACTIONS(6156),
    [anon_sym_PLUS] = ACTIONS(6158),
    [anon_sym_DASH] = ACTIONS(6158),
    [anon_sym_PLUS_DOT] = ACTIONS(6156),
    [anon_sym_DASH_DOT] = ACTIONS(6156),
    [anon_sym_PERCENT] = ACTIONS(6156),
    [anon_sym_AMP_AMP] = ACTIONS(6156),
    [anon_sym_TILDE] = ACTIONS(6156),
    [aux_sym_prefix_op_token1] = ACTIONS(6156),
    [sym_int] = ACTIONS(6158),
    [sym_xint] = ACTIONS(6156),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6156),
    [sym__newline] = ACTIONS(6156),
    [sym__dedent] = ACTIONS(6156),
  },
  [4222] = {
    [sym_block_comment] = STATE(4222),
    [sym_compiler_directive_decl] = STATE(4222),
    [sym_fsi_directive_decl] = STATE(4222),
    [sym_preproc_line] = STATE(4222),
    [sym_identifier] = ACTIONS(6428),
    [anon_sym_return] = ACTIONS(6428),
    [anon_sym_do] = ACTIONS(6428),
    [anon_sym_and] = ACTIONS(6428),
    [anon_sym_let] = ACTIONS(6428),
    [anon_sym_let_BANG] = ACTIONS(6426),
    [anon_sym_LPAREN] = ACTIONS(6428),
    [anon_sym_null] = ACTIONS(6428),
    [anon_sym_AMP] = ACTIONS(6428),
    [anon_sym_LBRACK] = ACTIONS(6428),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6426),
    [anon_sym_LBRACE] = ACTIONS(6428),
    [anon_sym_LT_AT] = ACTIONS(6428),
    [anon_sym_LT_AT_AT] = ACTIONS(6426),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6426),
    [anon_sym_new] = ACTIONS(6428),
    [anon_sym_return_BANG] = ACTIONS(6426),
    [anon_sym_yield] = ACTIONS(6428),
    [anon_sym_yield_BANG] = ACTIONS(6426),
    [anon_sym_lazy] = ACTIONS(6428),
    [anon_sym_assert] = ACTIONS(6428),
    [anon_sym_upcast] = ACTIONS(6428),
    [anon_sym_downcast] = ACTIONS(6428),
    [anon_sym_for] = ACTIONS(6428),
    [anon_sym_while] = ACTIONS(6428),
    [anon_sym_if] = ACTIONS(6428),
    [anon_sym_fun] = ACTIONS(6428),
    [anon_sym_try] = ACTIONS(6428),
    [anon_sym_match] = ACTIONS(6428),
    [anon_sym_match_BANG] = ACTIONS(6426),
    [anon_sym_function] = ACTIONS(6428),
    [anon_sym_use] = ACTIONS(6428),
    [anon_sym_use_BANG] = ACTIONS(6426),
    [anon_sym_do_BANG] = ACTIONS(6426),
    [anon_sym_begin] = ACTIONS(6428),
    [aux_sym_char_token1] = ACTIONS(6426),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6428),
    [anon_sym_DQUOTE] = ACTIONS(6428),
    [anon_sym_AT_DQUOTE] = ACTIONS(6426),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6426),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6426),
    [sym_bool] = ACTIONS(6428),
    [sym_unit] = ACTIONS(6426),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6428),
    [sym_op_identifier] = ACTIONS(6426),
    [anon_sym_PLUS] = ACTIONS(6428),
    [anon_sym_DASH] = ACTIONS(6428),
    [anon_sym_PLUS_DOT] = ACTIONS(6426),
    [anon_sym_DASH_DOT] = ACTIONS(6426),
    [anon_sym_PERCENT] = ACTIONS(6426),
    [anon_sym_AMP_AMP] = ACTIONS(6426),
    [anon_sym_TILDE] = ACTIONS(6426),
    [aux_sym_prefix_op_token1] = ACTIONS(6426),
    [sym_int] = ACTIONS(6428),
    [sym_xint] = ACTIONS(6426),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6426),
    [sym__newline] = ACTIONS(6426),
    [sym__dedent] = ACTIONS(6426),
  },
  [4223] = {
    [sym_block_comment] = STATE(4223),
    [sym_compiler_directive_decl] = STATE(4223),
    [sym_fsi_directive_decl] = STATE(4223),
    [sym_preproc_line] = STATE(4223),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_and] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3698),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3698),
    [anon_sym_DASH_DOT] = ACTIONS(3698),
    [anon_sym_PERCENT] = ACTIONS(3698),
    [anon_sym_AMP_AMP] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3698),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
    [sym__dedent] = ACTIONS(3698),
  },
  [4224] = {
    [sym_block_comment] = STATE(4224),
    [sym_compiler_directive_decl] = STATE(4224),
    [sym_fsi_directive_decl] = STATE(4224),
    [sym_preproc_line] = STATE(4224),
    [sym_identifier] = ACTIONS(6318),
    [anon_sym_return] = ACTIONS(6318),
    [anon_sym_do] = ACTIONS(6318),
    [anon_sym_and] = ACTIONS(6318),
    [anon_sym_let] = ACTIONS(6318),
    [anon_sym_let_BANG] = ACTIONS(6316),
    [anon_sym_LPAREN] = ACTIONS(6318),
    [anon_sym_null] = ACTIONS(6318),
    [anon_sym_AMP] = ACTIONS(6318),
    [anon_sym_LBRACK] = ACTIONS(6318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6316),
    [anon_sym_LBRACE] = ACTIONS(6318),
    [anon_sym_LT_AT] = ACTIONS(6318),
    [anon_sym_LT_AT_AT] = ACTIONS(6316),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6316),
    [anon_sym_new] = ACTIONS(6318),
    [anon_sym_return_BANG] = ACTIONS(6316),
    [anon_sym_yield] = ACTIONS(6318),
    [anon_sym_yield_BANG] = ACTIONS(6316),
    [anon_sym_lazy] = ACTIONS(6318),
    [anon_sym_assert] = ACTIONS(6318),
    [anon_sym_upcast] = ACTIONS(6318),
    [anon_sym_downcast] = ACTIONS(6318),
    [anon_sym_for] = ACTIONS(6318),
    [anon_sym_while] = ACTIONS(6318),
    [anon_sym_if] = ACTIONS(6318),
    [anon_sym_fun] = ACTIONS(6318),
    [anon_sym_try] = ACTIONS(6318),
    [anon_sym_match] = ACTIONS(6318),
    [anon_sym_match_BANG] = ACTIONS(6316),
    [anon_sym_function] = ACTIONS(6318),
    [anon_sym_use] = ACTIONS(6318),
    [anon_sym_use_BANG] = ACTIONS(6316),
    [anon_sym_do_BANG] = ACTIONS(6316),
    [anon_sym_begin] = ACTIONS(6318),
    [aux_sym_char_token1] = ACTIONS(6316),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6318),
    [anon_sym_DQUOTE] = ACTIONS(6318),
    [anon_sym_AT_DQUOTE] = ACTIONS(6316),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6316),
    [sym_bool] = ACTIONS(6318),
    [sym_unit] = ACTIONS(6316),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6318),
    [sym_op_identifier] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6318),
    [anon_sym_DASH] = ACTIONS(6318),
    [anon_sym_PLUS_DOT] = ACTIONS(6316),
    [anon_sym_DASH_DOT] = ACTIONS(6316),
    [anon_sym_PERCENT] = ACTIONS(6316),
    [anon_sym_AMP_AMP] = ACTIONS(6316),
    [anon_sym_TILDE] = ACTIONS(6316),
    [aux_sym_prefix_op_token1] = ACTIONS(6316),
    [sym_int] = ACTIONS(6318),
    [sym_xint] = ACTIONS(6316),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6316),
    [sym__newline] = ACTIONS(6316),
    [sym__dedent] = ACTIONS(6316),
  },
  [4225] = {
    [sym_block_comment] = STATE(4225),
    [sym_compiler_directive_decl] = STATE(4225),
    [sym_fsi_directive_decl] = STATE(4225),
    [sym_preproc_line] = STATE(4225),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_and] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3698),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3698),
    [anon_sym_DASH_DOT] = ACTIONS(3698),
    [anon_sym_PERCENT] = ACTIONS(3698),
    [anon_sym_AMP_AMP] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3698),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [anon_sym_POUNDendif] = ACTIONS(3698),
    [anon_sym_POUNDelse] = ACTIONS(3698),
  },
  [4226] = {
    [sym_block_comment] = STATE(4226),
    [sym_compiler_directive_decl] = STATE(4226),
    [sym_fsi_directive_decl] = STATE(4226),
    [sym_preproc_line] = STATE(4226),
    [sym_identifier] = ACTIONS(6302),
    [anon_sym_return] = ACTIONS(6302),
    [anon_sym_do] = ACTIONS(6302),
    [anon_sym_and] = ACTIONS(6302),
    [anon_sym_let] = ACTIONS(6302),
    [anon_sym_let_BANG] = ACTIONS(6300),
    [anon_sym_LPAREN] = ACTIONS(6302),
    [anon_sym_null] = ACTIONS(6302),
    [anon_sym_AMP] = ACTIONS(6302),
    [anon_sym_LBRACK] = ACTIONS(6302),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6300),
    [anon_sym_LBRACE] = ACTIONS(6302),
    [anon_sym_LT_AT] = ACTIONS(6302),
    [anon_sym_LT_AT_AT] = ACTIONS(6300),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6300),
    [anon_sym_new] = ACTIONS(6302),
    [anon_sym_return_BANG] = ACTIONS(6300),
    [anon_sym_yield] = ACTIONS(6302),
    [anon_sym_yield_BANG] = ACTIONS(6300),
    [anon_sym_lazy] = ACTIONS(6302),
    [anon_sym_assert] = ACTIONS(6302),
    [anon_sym_upcast] = ACTIONS(6302),
    [anon_sym_downcast] = ACTIONS(6302),
    [anon_sym_for] = ACTIONS(6302),
    [anon_sym_while] = ACTIONS(6302),
    [anon_sym_if] = ACTIONS(6302),
    [anon_sym_fun] = ACTIONS(6302),
    [anon_sym_try] = ACTIONS(6302),
    [anon_sym_match] = ACTIONS(6302),
    [anon_sym_match_BANG] = ACTIONS(6300),
    [anon_sym_function] = ACTIONS(6302),
    [anon_sym_use] = ACTIONS(6302),
    [anon_sym_use_BANG] = ACTIONS(6300),
    [anon_sym_do_BANG] = ACTIONS(6300),
    [anon_sym_begin] = ACTIONS(6302),
    [aux_sym_char_token1] = ACTIONS(6300),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6302),
    [anon_sym_DQUOTE] = ACTIONS(6302),
    [anon_sym_AT_DQUOTE] = ACTIONS(6300),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6300),
    [sym_bool] = ACTIONS(6302),
    [sym_unit] = ACTIONS(6300),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6302),
    [sym_op_identifier] = ACTIONS(6300),
    [anon_sym_PLUS] = ACTIONS(6302),
    [anon_sym_DASH] = ACTIONS(6302),
    [anon_sym_PLUS_DOT] = ACTIONS(6300),
    [anon_sym_DASH_DOT] = ACTIONS(6300),
    [anon_sym_PERCENT] = ACTIONS(6300),
    [anon_sym_AMP_AMP] = ACTIONS(6300),
    [anon_sym_TILDE] = ACTIONS(6300),
    [aux_sym_prefix_op_token1] = ACTIONS(6300),
    [sym_int] = ACTIONS(6302),
    [sym_xint] = ACTIONS(6300),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6300),
    [anon_sym_POUNDendif] = ACTIONS(6300),
    [anon_sym_POUNDelse] = ACTIONS(6300),
  },
  [4227] = {
    [sym_block_comment] = STATE(4227),
    [sym_compiler_directive_decl] = STATE(4227),
    [sym_fsi_directive_decl] = STATE(4227),
    [sym_preproc_line] = STATE(4227),
    [sym_identifier] = ACTIONS(6302),
    [anon_sym_return] = ACTIONS(6302),
    [anon_sym_do] = ACTIONS(6302),
    [anon_sym_and] = ACTIONS(6302),
    [anon_sym_let] = ACTIONS(6302),
    [anon_sym_let_BANG] = ACTIONS(6300),
    [anon_sym_LPAREN] = ACTIONS(6302),
    [anon_sym_null] = ACTIONS(6302),
    [anon_sym_AMP] = ACTIONS(6302),
    [anon_sym_LBRACK] = ACTIONS(6302),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6300),
    [anon_sym_LBRACE] = ACTIONS(6302),
    [anon_sym_LT_AT] = ACTIONS(6302),
    [anon_sym_LT_AT_AT] = ACTIONS(6300),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6300),
    [anon_sym_new] = ACTIONS(6302),
    [anon_sym_return_BANG] = ACTIONS(6300),
    [anon_sym_yield] = ACTIONS(6302),
    [anon_sym_yield_BANG] = ACTIONS(6300),
    [anon_sym_lazy] = ACTIONS(6302),
    [anon_sym_assert] = ACTIONS(6302),
    [anon_sym_upcast] = ACTIONS(6302),
    [anon_sym_downcast] = ACTIONS(6302),
    [anon_sym_for] = ACTIONS(6302),
    [anon_sym_while] = ACTIONS(6302),
    [anon_sym_if] = ACTIONS(6302),
    [anon_sym_fun] = ACTIONS(6302),
    [anon_sym_try] = ACTIONS(6302),
    [anon_sym_match] = ACTIONS(6302),
    [anon_sym_match_BANG] = ACTIONS(6300),
    [anon_sym_function] = ACTIONS(6302),
    [anon_sym_use] = ACTIONS(6302),
    [anon_sym_use_BANG] = ACTIONS(6300),
    [anon_sym_do_BANG] = ACTIONS(6300),
    [anon_sym_begin] = ACTIONS(6302),
    [aux_sym_char_token1] = ACTIONS(6300),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6302),
    [anon_sym_DQUOTE] = ACTIONS(6302),
    [anon_sym_AT_DQUOTE] = ACTIONS(6300),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6300),
    [sym_bool] = ACTIONS(6302),
    [sym_unit] = ACTIONS(6300),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6302),
    [sym_op_identifier] = ACTIONS(6300),
    [anon_sym_PLUS] = ACTIONS(6302),
    [anon_sym_DASH] = ACTIONS(6302),
    [anon_sym_PLUS_DOT] = ACTIONS(6300),
    [anon_sym_DASH_DOT] = ACTIONS(6300),
    [anon_sym_PERCENT] = ACTIONS(6300),
    [anon_sym_AMP_AMP] = ACTIONS(6300),
    [anon_sym_TILDE] = ACTIONS(6300),
    [aux_sym_prefix_op_token1] = ACTIONS(6300),
    [sym_int] = ACTIONS(6302),
    [sym_xint] = ACTIONS(6300),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6300),
    [sym__newline] = ACTIONS(6300),
    [sym__dedent] = ACTIONS(6300),
  },
  [4228] = {
    [sym_block_comment] = STATE(4228),
    [sym_compiler_directive_decl] = STATE(4228),
    [sym_fsi_directive_decl] = STATE(4228),
    [sym_preproc_line] = STATE(4228),
    [aux_sym__function_or_value_defns_repeat1] = STATE(4228),
    [sym_identifier] = ACTIONS(6117),
    [anon_sym_return] = ACTIONS(6117),
    [anon_sym_do] = ACTIONS(6117),
    [anon_sym_and] = ACTIONS(6977),
    [anon_sym_let] = ACTIONS(6117),
    [anon_sym_let_BANG] = ACTIONS(6115),
    [anon_sym_LPAREN] = ACTIONS(6117),
    [anon_sym_null] = ACTIONS(6117),
    [anon_sym_AMP] = ACTIONS(6117),
    [anon_sym_LBRACK] = ACTIONS(6117),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6115),
    [anon_sym_LBRACE] = ACTIONS(6117),
    [anon_sym_LT_AT] = ACTIONS(6117),
    [anon_sym_LT_AT_AT] = ACTIONS(6115),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6115),
    [anon_sym_new] = ACTIONS(6117),
    [anon_sym_return_BANG] = ACTIONS(6115),
    [anon_sym_yield] = ACTIONS(6117),
    [anon_sym_yield_BANG] = ACTIONS(6115),
    [anon_sym_lazy] = ACTIONS(6117),
    [anon_sym_assert] = ACTIONS(6117),
    [anon_sym_upcast] = ACTIONS(6117),
    [anon_sym_downcast] = ACTIONS(6117),
    [anon_sym_for] = ACTIONS(6117),
    [anon_sym_while] = ACTIONS(6117),
    [anon_sym_if] = ACTIONS(6117),
    [anon_sym_fun] = ACTIONS(6117),
    [anon_sym_try] = ACTIONS(6117),
    [anon_sym_match] = ACTIONS(6117),
    [anon_sym_match_BANG] = ACTIONS(6115),
    [anon_sym_function] = ACTIONS(6117),
    [anon_sym_use] = ACTIONS(6117),
    [anon_sym_use_BANG] = ACTIONS(6115),
    [anon_sym_do_BANG] = ACTIONS(6115),
    [anon_sym_begin] = ACTIONS(6117),
    [aux_sym_char_token1] = ACTIONS(6115),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6117),
    [anon_sym_DQUOTE] = ACTIONS(6117),
    [anon_sym_AT_DQUOTE] = ACTIONS(6115),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6115),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6115),
    [sym_bool] = ACTIONS(6117),
    [sym_unit] = ACTIONS(6115),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6117),
    [sym_op_identifier] = ACTIONS(6115),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_PLUS_DOT] = ACTIONS(6115),
    [anon_sym_DASH_DOT] = ACTIONS(6115),
    [anon_sym_PERCENT] = ACTIONS(6115),
    [anon_sym_AMP_AMP] = ACTIONS(6115),
    [anon_sym_TILDE] = ACTIONS(6115),
    [aux_sym_prefix_op_token1] = ACTIONS(6115),
    [sym_int] = ACTIONS(6117),
    [sym_xint] = ACTIONS(6115),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6115),
    [anon_sym_POUNDendif] = ACTIONS(6115),
  },
  [4229] = {
    [sym_block_comment] = STATE(4229),
    [sym_compiler_directive_decl] = STATE(4229),
    [sym_fsi_directive_decl] = STATE(4229),
    [sym_preproc_line] = STATE(4229),
    [aux_sym__function_or_value_defns_repeat1] = STATE(4231),
    [sym_identifier] = ACTIONS(6192),
    [anon_sym_return] = ACTIONS(6192),
    [anon_sym_do] = ACTIONS(6192),
    [anon_sym_and] = ACTIONS(6980),
    [anon_sym_let] = ACTIONS(6192),
    [anon_sym_let_BANG] = ACTIONS(6190),
    [anon_sym_LPAREN] = ACTIONS(6192),
    [anon_sym_null] = ACTIONS(6192),
    [anon_sym_AMP] = ACTIONS(6192),
    [anon_sym_LBRACK] = ACTIONS(6192),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6190),
    [anon_sym_LBRACE] = ACTIONS(6192),
    [anon_sym_LT_AT] = ACTIONS(6192),
    [anon_sym_LT_AT_AT] = ACTIONS(6190),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6190),
    [anon_sym_new] = ACTIONS(6192),
    [anon_sym_return_BANG] = ACTIONS(6190),
    [anon_sym_yield] = ACTIONS(6192),
    [anon_sym_yield_BANG] = ACTIONS(6190),
    [anon_sym_lazy] = ACTIONS(6192),
    [anon_sym_assert] = ACTIONS(6192),
    [anon_sym_upcast] = ACTIONS(6192),
    [anon_sym_downcast] = ACTIONS(6192),
    [anon_sym_for] = ACTIONS(6192),
    [anon_sym_while] = ACTIONS(6192),
    [anon_sym_if] = ACTIONS(6192),
    [anon_sym_fun] = ACTIONS(6192),
    [anon_sym_try] = ACTIONS(6192),
    [anon_sym_match] = ACTIONS(6192),
    [anon_sym_match_BANG] = ACTIONS(6190),
    [anon_sym_function] = ACTIONS(6192),
    [anon_sym_use] = ACTIONS(6192),
    [anon_sym_use_BANG] = ACTIONS(6190),
    [anon_sym_do_BANG] = ACTIONS(6190),
    [anon_sym_begin] = ACTIONS(6192),
    [aux_sym_char_token1] = ACTIONS(6190),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6192),
    [anon_sym_DQUOTE] = ACTIONS(6192),
    [anon_sym_AT_DQUOTE] = ACTIONS(6190),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6190),
    [sym_bool] = ACTIONS(6192),
    [sym_unit] = ACTIONS(6190),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6192),
    [sym_op_identifier] = ACTIONS(6190),
    [anon_sym_PLUS] = ACTIONS(6192),
    [anon_sym_DASH] = ACTIONS(6192),
    [anon_sym_PLUS_DOT] = ACTIONS(6190),
    [anon_sym_DASH_DOT] = ACTIONS(6190),
    [anon_sym_PERCENT] = ACTIONS(6190),
    [anon_sym_AMP_AMP] = ACTIONS(6190),
    [anon_sym_TILDE] = ACTIONS(6190),
    [aux_sym_prefix_op_token1] = ACTIONS(6190),
    [sym_int] = ACTIONS(6192),
    [sym_xint] = ACTIONS(6190),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6190),
    [anon_sym_POUNDendif] = ACTIONS(6190),
  },
  [4230] = {
    [sym_block_comment] = STATE(4230),
    [sym_compiler_directive_decl] = STATE(4230),
    [sym_fsi_directive_decl] = STATE(4230),
    [sym_preproc_line] = STATE(4230),
    [sym_identifier] = ACTIONS(6318),
    [anon_sym_return] = ACTIONS(6318),
    [anon_sym_do] = ACTIONS(6318),
    [anon_sym_and] = ACTIONS(6318),
    [anon_sym_let] = ACTIONS(6318),
    [anon_sym_let_BANG] = ACTIONS(6316),
    [anon_sym_LPAREN] = ACTIONS(6318),
    [anon_sym_null] = ACTIONS(6318),
    [anon_sym_AMP] = ACTIONS(6318),
    [anon_sym_LBRACK] = ACTIONS(6318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6316),
    [anon_sym_LBRACE] = ACTIONS(6318),
    [anon_sym_LT_AT] = ACTIONS(6318),
    [anon_sym_LT_AT_AT] = ACTIONS(6316),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6316),
    [anon_sym_new] = ACTIONS(6318),
    [anon_sym_return_BANG] = ACTIONS(6316),
    [anon_sym_yield] = ACTIONS(6318),
    [anon_sym_yield_BANG] = ACTIONS(6316),
    [anon_sym_lazy] = ACTIONS(6318),
    [anon_sym_assert] = ACTIONS(6318),
    [anon_sym_upcast] = ACTIONS(6318),
    [anon_sym_downcast] = ACTIONS(6318),
    [anon_sym_for] = ACTIONS(6318),
    [anon_sym_while] = ACTIONS(6318),
    [anon_sym_if] = ACTIONS(6318),
    [anon_sym_fun] = ACTIONS(6318),
    [anon_sym_try] = ACTIONS(6318),
    [anon_sym_match] = ACTIONS(6318),
    [anon_sym_match_BANG] = ACTIONS(6316),
    [anon_sym_function] = ACTIONS(6318),
    [anon_sym_use] = ACTIONS(6318),
    [anon_sym_use_BANG] = ACTIONS(6316),
    [anon_sym_do_BANG] = ACTIONS(6316),
    [anon_sym_begin] = ACTIONS(6318),
    [aux_sym_char_token1] = ACTIONS(6316),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6318),
    [anon_sym_DQUOTE] = ACTIONS(6318),
    [anon_sym_AT_DQUOTE] = ACTIONS(6316),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6316),
    [sym_bool] = ACTIONS(6318),
    [sym_unit] = ACTIONS(6316),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6318),
    [sym_op_identifier] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6318),
    [anon_sym_DASH] = ACTIONS(6318),
    [anon_sym_PLUS_DOT] = ACTIONS(6316),
    [anon_sym_DASH_DOT] = ACTIONS(6316),
    [anon_sym_PERCENT] = ACTIONS(6316),
    [anon_sym_AMP_AMP] = ACTIONS(6316),
    [anon_sym_TILDE] = ACTIONS(6316),
    [aux_sym_prefix_op_token1] = ACTIONS(6316),
    [sym_int] = ACTIONS(6318),
    [sym_xint] = ACTIONS(6316),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6316),
    [anon_sym_POUNDendif] = ACTIONS(6316),
    [anon_sym_POUNDelse] = ACTIONS(6316),
  },
  [4231] = {
    [sym_block_comment] = STATE(4231),
    [sym_compiler_directive_decl] = STATE(4231),
    [sym_fsi_directive_decl] = STATE(4231),
    [sym_preproc_line] = STATE(4231),
    [aux_sym__function_or_value_defns_repeat1] = STATE(4228),
    [sym_identifier] = ACTIONS(6158),
    [anon_sym_return] = ACTIONS(6158),
    [anon_sym_do] = ACTIONS(6158),
    [anon_sym_and] = ACTIONS(6980),
    [anon_sym_let] = ACTIONS(6158),
    [anon_sym_let_BANG] = ACTIONS(6156),
    [anon_sym_LPAREN] = ACTIONS(6158),
    [anon_sym_null] = ACTIONS(6158),
    [anon_sym_AMP] = ACTIONS(6158),
    [anon_sym_LBRACK] = ACTIONS(6158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6156),
    [anon_sym_LBRACE] = ACTIONS(6158),
    [anon_sym_LT_AT] = ACTIONS(6158),
    [anon_sym_LT_AT_AT] = ACTIONS(6156),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6156),
    [anon_sym_new] = ACTIONS(6158),
    [anon_sym_return_BANG] = ACTIONS(6156),
    [anon_sym_yield] = ACTIONS(6158),
    [anon_sym_yield_BANG] = ACTIONS(6156),
    [anon_sym_lazy] = ACTIONS(6158),
    [anon_sym_assert] = ACTIONS(6158),
    [anon_sym_upcast] = ACTIONS(6158),
    [anon_sym_downcast] = ACTIONS(6158),
    [anon_sym_for] = ACTIONS(6158),
    [anon_sym_while] = ACTIONS(6158),
    [anon_sym_if] = ACTIONS(6158),
    [anon_sym_fun] = ACTIONS(6158),
    [anon_sym_try] = ACTIONS(6158),
    [anon_sym_match] = ACTIONS(6158),
    [anon_sym_match_BANG] = ACTIONS(6156),
    [anon_sym_function] = ACTIONS(6158),
    [anon_sym_use] = ACTIONS(6158),
    [anon_sym_use_BANG] = ACTIONS(6156),
    [anon_sym_do_BANG] = ACTIONS(6156),
    [anon_sym_begin] = ACTIONS(6158),
    [aux_sym_char_token1] = ACTIONS(6156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6158),
    [anon_sym_DQUOTE] = ACTIONS(6158),
    [anon_sym_AT_DQUOTE] = ACTIONS(6156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6156),
    [sym_bool] = ACTIONS(6158),
    [sym_unit] = ACTIONS(6156),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6158),
    [sym_op_identifier] = ACTIONS(6156),
    [anon_sym_PLUS] = ACTIONS(6158),
    [anon_sym_DASH] = ACTIONS(6158),
    [anon_sym_PLUS_DOT] = ACTIONS(6156),
    [anon_sym_DASH_DOT] = ACTIONS(6156),
    [anon_sym_PERCENT] = ACTIONS(6156),
    [anon_sym_AMP_AMP] = ACTIONS(6156),
    [anon_sym_TILDE] = ACTIONS(6156),
    [aux_sym_prefix_op_token1] = ACTIONS(6156),
    [sym_int] = ACTIONS(6158),
    [sym_xint] = ACTIONS(6156),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6156),
    [anon_sym_POUNDendif] = ACTIONS(6156),
  },
  [4232] = {
    [sym_block_comment] = STATE(4232),
    [sym_compiler_directive_decl] = STATE(4232),
    [sym_fsi_directive_decl] = STATE(4232),
    [sym_preproc_line] = STATE(4232),
    [sym_identifier] = ACTIONS(6428),
    [anon_sym_return] = ACTIONS(6428),
    [anon_sym_do] = ACTIONS(6428),
    [anon_sym_and] = ACTIONS(6428),
    [anon_sym_let] = ACTIONS(6428),
    [anon_sym_let_BANG] = ACTIONS(6426),
    [anon_sym_LPAREN] = ACTIONS(6428),
    [anon_sym_null] = ACTIONS(6428),
    [anon_sym_AMP] = ACTIONS(6428),
    [anon_sym_LBRACK] = ACTIONS(6428),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6426),
    [anon_sym_LBRACE] = ACTIONS(6428),
    [anon_sym_LT_AT] = ACTIONS(6428),
    [anon_sym_LT_AT_AT] = ACTIONS(6426),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6426),
    [anon_sym_new] = ACTIONS(6428),
    [anon_sym_return_BANG] = ACTIONS(6426),
    [anon_sym_yield] = ACTIONS(6428),
    [anon_sym_yield_BANG] = ACTIONS(6426),
    [anon_sym_lazy] = ACTIONS(6428),
    [anon_sym_assert] = ACTIONS(6428),
    [anon_sym_upcast] = ACTIONS(6428),
    [anon_sym_downcast] = ACTIONS(6428),
    [anon_sym_for] = ACTIONS(6428),
    [anon_sym_while] = ACTIONS(6428),
    [anon_sym_if] = ACTIONS(6428),
    [anon_sym_fun] = ACTIONS(6428),
    [anon_sym_try] = ACTIONS(6428),
    [anon_sym_match] = ACTIONS(6428),
    [anon_sym_match_BANG] = ACTIONS(6426),
    [anon_sym_function] = ACTIONS(6428),
    [anon_sym_use] = ACTIONS(6428),
    [anon_sym_use_BANG] = ACTIONS(6426),
    [anon_sym_do_BANG] = ACTIONS(6426),
    [anon_sym_begin] = ACTIONS(6428),
    [aux_sym_char_token1] = ACTIONS(6426),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6428),
    [anon_sym_DQUOTE] = ACTIONS(6428),
    [anon_sym_AT_DQUOTE] = ACTIONS(6426),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6426),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6426),
    [sym_bool] = ACTIONS(6428),
    [sym_unit] = ACTIONS(6426),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6428),
    [sym_op_identifier] = ACTIONS(6426),
    [anon_sym_PLUS] = ACTIONS(6428),
    [anon_sym_DASH] = ACTIONS(6428),
    [anon_sym_PLUS_DOT] = ACTIONS(6426),
    [anon_sym_DASH_DOT] = ACTIONS(6426),
    [anon_sym_PERCENT] = ACTIONS(6426),
    [anon_sym_AMP_AMP] = ACTIONS(6426),
    [anon_sym_TILDE] = ACTIONS(6426),
    [aux_sym_prefix_op_token1] = ACTIONS(6426),
    [sym_int] = ACTIONS(6428),
    [sym_xint] = ACTIONS(6426),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6426),
    [anon_sym_POUNDendif] = ACTIONS(6426),
    [anon_sym_POUNDelse] = ACTIONS(6426),
  },
  [4233] = {
    [sym_block_comment] = STATE(4233),
    [sym_compiler_directive_decl] = STATE(4233),
    [sym_fsi_directive_decl] = STATE(4233),
    [sym_preproc_line] = STATE(4233),
    [aux_sym__function_or_value_defns_repeat1] = STATE(4237),
    [sym_identifier] = ACTIONS(6192),
    [anon_sym_return] = ACTIONS(6192),
    [anon_sym_do] = ACTIONS(6192),
    [anon_sym_and] = ACTIONS(6982),
    [anon_sym_let] = ACTIONS(6192),
    [anon_sym_let_BANG] = ACTIONS(6190),
    [anon_sym_LPAREN] = ACTIONS(6192),
    [anon_sym_null] = ACTIONS(6192),
    [anon_sym_AMP] = ACTIONS(6192),
    [anon_sym_LBRACK] = ACTIONS(6192),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6190),
    [anon_sym_LBRACE] = ACTIONS(6192),
    [anon_sym_LT_AT] = ACTIONS(6192),
    [anon_sym_LT_AT_AT] = ACTIONS(6190),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6190),
    [anon_sym_new] = ACTIONS(6192),
    [anon_sym_return_BANG] = ACTIONS(6190),
    [anon_sym_yield] = ACTIONS(6192),
    [anon_sym_yield_BANG] = ACTIONS(6190),
    [anon_sym_lazy] = ACTIONS(6192),
    [anon_sym_assert] = ACTIONS(6192),
    [anon_sym_upcast] = ACTIONS(6192),
    [anon_sym_downcast] = ACTIONS(6192),
    [anon_sym_for] = ACTIONS(6192),
    [anon_sym_while] = ACTIONS(6192),
    [anon_sym_if] = ACTIONS(6192),
    [anon_sym_fun] = ACTIONS(6192),
    [anon_sym_try] = ACTIONS(6192),
    [anon_sym_match] = ACTIONS(6192),
    [anon_sym_match_BANG] = ACTIONS(6190),
    [anon_sym_function] = ACTIONS(6192),
    [anon_sym_use] = ACTIONS(6192),
    [anon_sym_use_BANG] = ACTIONS(6190),
    [anon_sym_do_BANG] = ACTIONS(6190),
    [anon_sym_begin] = ACTIONS(6192),
    [aux_sym_char_token1] = ACTIONS(6190),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6192),
    [anon_sym_DQUOTE] = ACTIONS(6192),
    [anon_sym_AT_DQUOTE] = ACTIONS(6190),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6190),
    [sym_bool] = ACTIONS(6192),
    [sym_unit] = ACTIONS(6190),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6192),
    [sym_op_identifier] = ACTIONS(6190),
    [anon_sym_PLUS] = ACTIONS(6192),
    [anon_sym_DASH] = ACTIONS(6192),
    [anon_sym_PLUS_DOT] = ACTIONS(6190),
    [anon_sym_DASH_DOT] = ACTIONS(6190),
    [anon_sym_PERCENT] = ACTIONS(6190),
    [anon_sym_AMP_AMP] = ACTIONS(6190),
    [anon_sym_TILDE] = ACTIONS(6190),
    [aux_sym_prefix_op_token1] = ACTIONS(6190),
    [sym_int] = ACTIONS(6192),
    [sym_xint] = ACTIONS(6190),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6190),
  },
  [4234] = {
    [sym_block_comment] = STATE(4234),
    [sym_compiler_directive_decl] = STATE(4234),
    [sym_fsi_directive_decl] = STATE(4234),
    [sym_preproc_line] = STATE(4234),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_let_BANG] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_null] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3193),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3193),
    [anon_sym_LT_AT] = ACTIONS(3193),
    [anon_sym_LT_AT_AT] = ACTIONS(3191),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_return_BANG] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_yield_BANG] = ACTIONS(3191),
    [anon_sym_lazy] = ACTIONS(3193),
    [anon_sym_assert] = ACTIONS(3193),
    [anon_sym_upcast] = ACTIONS(3193),
    [anon_sym_downcast] = ACTIONS(3193),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_fun] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_match] = ACTIONS(3193),
    [anon_sym_match_BANG] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_GT] = ACTIONS(3191),
    [anon_sym_use] = ACTIONS(3193),
    [anon_sym_use_BANG] = ACTIONS(3191),
    [anon_sym_do_BANG] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3193),
    [aux_sym_char_token1] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3193),
    [anon_sym_AT_DQUOTE] = ACTIONS(3191),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3191),
    [sym_bool] = ACTIONS(3193),
    [sym_unit] = ACTIONS(3191),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3193),
    [sym_op_identifier] = ACTIONS(3191),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_PLUS_DOT] = ACTIONS(3191),
    [anon_sym_DASH_DOT] = ACTIONS(3191),
    [anon_sym_PERCENT] = ACTIONS(3191),
    [anon_sym_AMP_AMP] = ACTIONS(3191),
    [anon_sym_TILDE] = ACTIONS(3191),
    [aux_sym_prefix_op_token1] = ACTIONS(3191),
    [sym_int] = ACTIONS(3193),
    [sym_xint] = ACTIONS(3191),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3191),
  },
  [4235] = {
    [sym_block_comment] = STATE(4235),
    [sym_compiler_directive_decl] = STATE(4235),
    [sym_fsi_directive_decl] = STATE(4235),
    [sym_preproc_line] = STATE(4235),
    [sym_identifier] = ACTIONS(4170),
    [anon_sym_return] = ACTIONS(4170),
    [anon_sym_do] = ACTIONS(4170),
    [anon_sym_let] = ACTIONS(4170),
    [anon_sym_let_BANG] = ACTIONS(4168),
    [anon_sym_LPAREN] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4168),
    [anon_sym_null] = ACTIONS(4170),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(4170),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4168),
    [anon_sym_LBRACE] = ACTIONS(4170),
    [anon_sym_LT_AT] = ACTIONS(4170),
    [anon_sym_LT_AT_AT] = ACTIONS(4168),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4168),
    [anon_sym_new] = ACTIONS(4170),
    [anon_sym_return_BANG] = ACTIONS(4168),
    [anon_sym_yield] = ACTIONS(4170),
    [anon_sym_yield_BANG] = ACTIONS(4168),
    [anon_sym_lazy] = ACTIONS(4170),
    [anon_sym_assert] = ACTIONS(4170),
    [anon_sym_upcast] = ACTIONS(4170),
    [anon_sym_downcast] = ACTIONS(4170),
    [anon_sym_for] = ACTIONS(4170),
    [anon_sym_while] = ACTIONS(4170),
    [anon_sym_if] = ACTIONS(4170),
    [anon_sym_fun] = ACTIONS(4170),
    [anon_sym_try] = ACTIONS(4170),
    [anon_sym_match] = ACTIONS(4170),
    [anon_sym_match_BANG] = ACTIONS(4168),
    [anon_sym_function] = ACTIONS(4170),
    [anon_sym_GT] = ACTIONS(4168),
    [anon_sym_use] = ACTIONS(4170),
    [anon_sym_use_BANG] = ACTIONS(4168),
    [anon_sym_do_BANG] = ACTIONS(4168),
    [anon_sym_begin] = ACTIONS(4170),
    [aux_sym_char_token1] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4170),
    [anon_sym_DQUOTE] = ACTIONS(4170),
    [anon_sym_AT_DQUOTE] = ACTIONS(4168),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4168),
    [sym_bool] = ACTIONS(4170),
    [sym_unit] = ACTIONS(4168),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4170),
    [sym_op_identifier] = ACTIONS(4168),
    [anon_sym_PLUS] = ACTIONS(4170),
    [anon_sym_DASH] = ACTIONS(4170),
    [anon_sym_PLUS_DOT] = ACTIONS(4168),
    [anon_sym_DASH_DOT] = ACTIONS(4168),
    [anon_sym_PERCENT] = ACTIONS(4168),
    [anon_sym_AMP_AMP] = ACTIONS(4168),
    [anon_sym_TILDE] = ACTIONS(4168),
    [aux_sym_prefix_op_token1] = ACTIONS(4168),
    [sym_int] = ACTIONS(4170),
    [sym_xint] = ACTIONS(4168),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4168),
  },
  [4236] = {
    [sym_block_comment] = STATE(4236),
    [sym_compiler_directive_decl] = STATE(4236),
    [sym_fsi_directive_decl] = STATE(4236),
    [sym_preproc_line] = STATE(4236),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_return] = ACTIONS(3950),
    [anon_sym_do] = ACTIONS(3950),
    [anon_sym_let] = ACTIONS(3950),
    [anon_sym_let_BANG] = ACTIONS(3948),
    [anon_sym_LPAREN] = ACTIONS(3950),
    [anon_sym_COMMA] = ACTIONS(3948),
    [anon_sym_null] = ACTIONS(3950),
    [anon_sym_AMP] = ACTIONS(3950),
    [anon_sym_LBRACK] = ACTIONS(3950),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3948),
    [anon_sym_LBRACE] = ACTIONS(3950),
    [anon_sym_LT_AT] = ACTIONS(3950),
    [anon_sym_LT_AT_AT] = ACTIONS(3948),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3948),
    [anon_sym_new] = ACTIONS(3950),
    [anon_sym_return_BANG] = ACTIONS(3948),
    [anon_sym_yield] = ACTIONS(3950),
    [anon_sym_yield_BANG] = ACTIONS(3948),
    [anon_sym_lazy] = ACTIONS(3950),
    [anon_sym_assert] = ACTIONS(3950),
    [anon_sym_upcast] = ACTIONS(3950),
    [anon_sym_downcast] = ACTIONS(3950),
    [anon_sym_for] = ACTIONS(3950),
    [anon_sym_while] = ACTIONS(3950),
    [anon_sym_if] = ACTIONS(3950),
    [anon_sym_fun] = ACTIONS(3950),
    [anon_sym_try] = ACTIONS(3950),
    [anon_sym_match] = ACTIONS(3950),
    [anon_sym_match_BANG] = ACTIONS(3948),
    [anon_sym_function] = ACTIONS(3950),
    [anon_sym_GT] = ACTIONS(3948),
    [anon_sym_use] = ACTIONS(3950),
    [anon_sym_use_BANG] = ACTIONS(3948),
    [anon_sym_do_BANG] = ACTIONS(3948),
    [anon_sym_begin] = ACTIONS(3950),
    [aux_sym_char_token1] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3950),
    [anon_sym_DQUOTE] = ACTIONS(3950),
    [anon_sym_AT_DQUOTE] = ACTIONS(3948),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3948),
    [sym_bool] = ACTIONS(3950),
    [sym_unit] = ACTIONS(3948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3950),
    [sym_op_identifier] = ACTIONS(3948),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_DASH] = ACTIONS(3950),
    [anon_sym_PLUS_DOT] = ACTIONS(3948),
    [anon_sym_DASH_DOT] = ACTIONS(3948),
    [anon_sym_PERCENT] = ACTIONS(3948),
    [anon_sym_AMP_AMP] = ACTIONS(3948),
    [anon_sym_TILDE] = ACTIONS(3948),
    [aux_sym_prefix_op_token1] = ACTIONS(3948),
    [sym_int] = ACTIONS(3950),
    [sym_xint] = ACTIONS(3948),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3948),
  },
  [4237] = {
    [sym_block_comment] = STATE(4237),
    [sym_compiler_directive_decl] = STATE(4237),
    [sym_fsi_directive_decl] = STATE(4237),
    [sym_preproc_line] = STATE(4237),
    [aux_sym__function_or_value_defns_repeat1] = STATE(4240),
    [sym_identifier] = ACTIONS(6158),
    [anon_sym_return] = ACTIONS(6158),
    [anon_sym_do] = ACTIONS(6158),
    [anon_sym_and] = ACTIONS(6982),
    [anon_sym_let] = ACTIONS(6158),
    [anon_sym_let_BANG] = ACTIONS(6156),
    [anon_sym_LPAREN] = ACTIONS(6158),
    [anon_sym_null] = ACTIONS(6158),
    [anon_sym_AMP] = ACTIONS(6158),
    [anon_sym_LBRACK] = ACTIONS(6158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6156),
    [anon_sym_LBRACE] = ACTIONS(6158),
    [anon_sym_LT_AT] = ACTIONS(6158),
    [anon_sym_LT_AT_AT] = ACTIONS(6156),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6156),
    [anon_sym_new] = ACTIONS(6158),
    [anon_sym_return_BANG] = ACTIONS(6156),
    [anon_sym_yield] = ACTIONS(6158),
    [anon_sym_yield_BANG] = ACTIONS(6156),
    [anon_sym_lazy] = ACTIONS(6158),
    [anon_sym_assert] = ACTIONS(6158),
    [anon_sym_upcast] = ACTIONS(6158),
    [anon_sym_downcast] = ACTIONS(6158),
    [anon_sym_for] = ACTIONS(6158),
    [anon_sym_while] = ACTIONS(6158),
    [anon_sym_if] = ACTIONS(6158),
    [anon_sym_fun] = ACTIONS(6158),
    [anon_sym_try] = ACTIONS(6158),
    [anon_sym_match] = ACTIONS(6158),
    [anon_sym_match_BANG] = ACTIONS(6156),
    [anon_sym_function] = ACTIONS(6158),
    [anon_sym_use] = ACTIONS(6158),
    [anon_sym_use_BANG] = ACTIONS(6156),
    [anon_sym_do_BANG] = ACTIONS(6156),
    [anon_sym_begin] = ACTIONS(6158),
    [aux_sym_char_token1] = ACTIONS(6156),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6158),
    [anon_sym_DQUOTE] = ACTIONS(6158),
    [anon_sym_AT_DQUOTE] = ACTIONS(6156),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6156),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6156),
    [sym_bool] = ACTIONS(6158),
    [sym_unit] = ACTIONS(6156),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6158),
    [sym_op_identifier] = ACTIONS(6156),
    [anon_sym_PLUS] = ACTIONS(6158),
    [anon_sym_DASH] = ACTIONS(6158),
    [anon_sym_PLUS_DOT] = ACTIONS(6156),
    [anon_sym_DASH_DOT] = ACTIONS(6156),
    [anon_sym_PERCENT] = ACTIONS(6156),
    [anon_sym_AMP_AMP] = ACTIONS(6156),
    [anon_sym_TILDE] = ACTIONS(6156),
    [aux_sym_prefix_op_token1] = ACTIONS(6156),
    [sym_int] = ACTIONS(6158),
    [sym_xint] = ACTIONS(6156),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6156),
  },
  [4238] = {
    [sym_block_comment] = STATE(4238),
    [sym_compiler_directive_decl] = STATE(4238),
    [sym_fsi_directive_decl] = STATE(4238),
    [sym_preproc_line] = STATE(4238),
    [sym_identifier] = ACTIONS(3954),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_do] = ACTIONS(3954),
    [anon_sym_let] = ACTIONS(3954),
    [anon_sym_let_BANG] = ACTIONS(3952),
    [anon_sym_LPAREN] = ACTIONS(3954),
    [anon_sym_COMMA] = ACTIONS(3952),
    [anon_sym_null] = ACTIONS(3954),
    [anon_sym_AMP] = ACTIONS(3954),
    [anon_sym_LBRACK] = ACTIONS(3954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(3954),
    [anon_sym_LT_AT] = ACTIONS(3954),
    [anon_sym_LT_AT_AT] = ACTIONS(3952),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3952),
    [anon_sym_new] = ACTIONS(3954),
    [anon_sym_return_BANG] = ACTIONS(3952),
    [anon_sym_yield] = ACTIONS(3954),
    [anon_sym_yield_BANG] = ACTIONS(3952),
    [anon_sym_lazy] = ACTIONS(3954),
    [anon_sym_assert] = ACTIONS(3954),
    [anon_sym_upcast] = ACTIONS(3954),
    [anon_sym_downcast] = ACTIONS(3954),
    [anon_sym_for] = ACTIONS(3954),
    [anon_sym_while] = ACTIONS(3954),
    [anon_sym_if] = ACTIONS(3954),
    [anon_sym_fun] = ACTIONS(3954),
    [anon_sym_try] = ACTIONS(3954),
    [anon_sym_match] = ACTIONS(3954),
    [anon_sym_match_BANG] = ACTIONS(3952),
    [anon_sym_function] = ACTIONS(3954),
    [anon_sym_GT] = ACTIONS(3952),
    [anon_sym_use] = ACTIONS(3954),
    [anon_sym_use_BANG] = ACTIONS(3952),
    [anon_sym_do_BANG] = ACTIONS(3952),
    [anon_sym_begin] = ACTIONS(3954),
    [aux_sym_char_token1] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3954),
    [anon_sym_DQUOTE] = ACTIONS(3954),
    [anon_sym_AT_DQUOTE] = ACTIONS(3952),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3952),
    [sym_bool] = ACTIONS(3954),
    [sym_unit] = ACTIONS(3952),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3954),
    [sym_op_identifier] = ACTIONS(3952),
    [anon_sym_PLUS] = ACTIONS(3954),
    [anon_sym_DASH] = ACTIONS(3954),
    [anon_sym_PLUS_DOT] = ACTIONS(3952),
    [anon_sym_DASH_DOT] = ACTIONS(3952),
    [anon_sym_PERCENT] = ACTIONS(3952),
    [anon_sym_AMP_AMP] = ACTIONS(3952),
    [anon_sym_TILDE] = ACTIONS(3952),
    [aux_sym_prefix_op_token1] = ACTIONS(3952),
    [sym_int] = ACTIONS(3954),
    [sym_xint] = ACTIONS(3952),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3952),
  },
  [4239] = {
    [sym_block_comment] = STATE(4239),
    [sym_compiler_directive_decl] = STATE(4239),
    [sym_fsi_directive_decl] = STATE(4239),
    [sym_preproc_line] = STATE(4239),
    [sym_identifier] = ACTIONS(6318),
    [anon_sym_return] = ACTIONS(6318),
    [anon_sym_do] = ACTIONS(6318),
    [anon_sym_let] = ACTIONS(6318),
    [anon_sym_let_BANG] = ACTIONS(6316),
    [anon_sym_LPAREN] = ACTIONS(6318),
    [anon_sym_null] = ACTIONS(6318),
    [anon_sym_AMP] = ACTIONS(6318),
    [anon_sym_LBRACK] = ACTIONS(6318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6316),
    [anon_sym_LBRACE] = ACTIONS(6318),
    [anon_sym_LT_AT] = ACTIONS(6318),
    [anon_sym_LT_AT_AT] = ACTIONS(6316),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6316),
    [anon_sym_new] = ACTIONS(6318),
    [anon_sym_return_BANG] = ACTIONS(6316),
    [anon_sym_yield] = ACTIONS(6318),
    [anon_sym_yield_BANG] = ACTIONS(6316),
    [anon_sym_lazy] = ACTIONS(6318),
    [anon_sym_assert] = ACTIONS(6318),
    [anon_sym_upcast] = ACTIONS(6318),
    [anon_sym_downcast] = ACTIONS(6318),
    [anon_sym_for] = ACTIONS(6318),
    [anon_sym_while] = ACTIONS(6318),
    [anon_sym_if] = ACTIONS(6318),
    [anon_sym_fun] = ACTIONS(6318),
    [anon_sym_try] = ACTIONS(6318),
    [anon_sym_match] = ACTIONS(6318),
    [anon_sym_match_BANG] = ACTIONS(6316),
    [anon_sym_function] = ACTIONS(6318),
    [anon_sym_use] = ACTIONS(6318),
    [anon_sym_use_BANG] = ACTIONS(6316),
    [anon_sym_do_BANG] = ACTIONS(6316),
    [anon_sym_begin] = ACTIONS(6318),
    [aux_sym_char_token1] = ACTIONS(6316),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6318),
    [anon_sym_DQUOTE] = ACTIONS(6318),
    [anon_sym_AT_DQUOTE] = ACTIONS(6316),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6316),
    [sym_bool] = ACTIONS(6318),
    [sym_unit] = ACTIONS(6316),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6318),
    [sym_op_identifier] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6318),
    [anon_sym_DASH] = ACTIONS(6318),
    [anon_sym_PLUS_DOT] = ACTIONS(6316),
    [anon_sym_DASH_DOT] = ACTIONS(6316),
    [anon_sym_PERCENT] = ACTIONS(6316),
    [anon_sym_AMP_AMP] = ACTIONS(6316),
    [anon_sym_TILDE] = ACTIONS(6316),
    [aux_sym_prefix_op_token1] = ACTIONS(6316),
    [sym_int] = ACTIONS(6318),
    [sym_xint] = ACTIONS(6316),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6316),
    [sym__newline] = ACTIONS(6316),
    [sym__dedent] = ACTIONS(6316),
  },
  [4240] = {
    [sym_block_comment] = STATE(4240),
    [sym_compiler_directive_decl] = STATE(4240),
    [sym_fsi_directive_decl] = STATE(4240),
    [sym_preproc_line] = STATE(4240),
    [aux_sym__function_or_value_defns_repeat1] = STATE(4240),
    [sym_identifier] = ACTIONS(6117),
    [anon_sym_return] = ACTIONS(6117),
    [anon_sym_do] = ACTIONS(6117),
    [anon_sym_and] = ACTIONS(6984),
    [anon_sym_let] = ACTIONS(6117),
    [anon_sym_let_BANG] = ACTIONS(6115),
    [anon_sym_LPAREN] = ACTIONS(6117),
    [anon_sym_null] = ACTIONS(6117),
    [anon_sym_AMP] = ACTIONS(6117),
    [anon_sym_LBRACK] = ACTIONS(6117),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6115),
    [anon_sym_LBRACE] = ACTIONS(6117),
    [anon_sym_LT_AT] = ACTIONS(6117),
    [anon_sym_LT_AT_AT] = ACTIONS(6115),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6115),
    [anon_sym_new] = ACTIONS(6117),
    [anon_sym_return_BANG] = ACTIONS(6115),
    [anon_sym_yield] = ACTIONS(6117),
    [anon_sym_yield_BANG] = ACTIONS(6115),
    [anon_sym_lazy] = ACTIONS(6117),
    [anon_sym_assert] = ACTIONS(6117),
    [anon_sym_upcast] = ACTIONS(6117),
    [anon_sym_downcast] = ACTIONS(6117),
    [anon_sym_for] = ACTIONS(6117),
    [anon_sym_while] = ACTIONS(6117),
    [anon_sym_if] = ACTIONS(6117),
    [anon_sym_fun] = ACTIONS(6117),
    [anon_sym_try] = ACTIONS(6117),
    [anon_sym_match] = ACTIONS(6117),
    [anon_sym_match_BANG] = ACTIONS(6115),
    [anon_sym_function] = ACTIONS(6117),
    [anon_sym_use] = ACTIONS(6117),
    [anon_sym_use_BANG] = ACTIONS(6115),
    [anon_sym_do_BANG] = ACTIONS(6115),
    [anon_sym_begin] = ACTIONS(6117),
    [aux_sym_char_token1] = ACTIONS(6115),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6117),
    [anon_sym_DQUOTE] = ACTIONS(6117),
    [anon_sym_AT_DQUOTE] = ACTIONS(6115),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6115),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6115),
    [sym_bool] = ACTIONS(6117),
    [sym_unit] = ACTIONS(6115),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6117),
    [sym_op_identifier] = ACTIONS(6115),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_PLUS_DOT] = ACTIONS(6115),
    [anon_sym_DASH_DOT] = ACTIONS(6115),
    [anon_sym_PERCENT] = ACTIONS(6115),
    [anon_sym_AMP_AMP] = ACTIONS(6115),
    [anon_sym_TILDE] = ACTIONS(6115),
    [aux_sym_prefix_op_token1] = ACTIONS(6115),
    [sym_int] = ACTIONS(6117),
    [sym_xint] = ACTIONS(6115),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6115),
  },
  [4241] = {
    [sym_block_comment] = STATE(4241),
    [sym_compiler_directive_decl] = STATE(4241),
    [sym_fsi_directive_decl] = STATE(4241),
    [sym_preproc_line] = STATE(4241),
    [sym_identifier] = ACTIONS(6302),
    [anon_sym_return] = ACTIONS(6302),
    [anon_sym_do] = ACTIONS(6302),
    [anon_sym_let] = ACTIONS(6302),
    [anon_sym_let_BANG] = ACTIONS(6300),
    [anon_sym_LPAREN] = ACTIONS(6302),
    [anon_sym_null] = ACTIONS(6302),
    [anon_sym_AMP] = ACTIONS(6302),
    [anon_sym_LBRACK] = ACTIONS(6302),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6300),
    [anon_sym_LBRACE] = ACTIONS(6302),
    [anon_sym_LT_AT] = ACTIONS(6302),
    [anon_sym_LT_AT_AT] = ACTIONS(6300),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6300),
    [anon_sym_new] = ACTIONS(6302),
    [anon_sym_return_BANG] = ACTIONS(6300),
    [anon_sym_yield] = ACTIONS(6302),
    [anon_sym_yield_BANG] = ACTIONS(6300),
    [anon_sym_lazy] = ACTIONS(6302),
    [anon_sym_assert] = ACTIONS(6302),
    [anon_sym_upcast] = ACTIONS(6302),
    [anon_sym_downcast] = ACTIONS(6302),
    [anon_sym_for] = ACTIONS(6302),
    [anon_sym_while] = ACTIONS(6302),
    [anon_sym_if] = ACTIONS(6302),
    [anon_sym_fun] = ACTIONS(6302),
    [anon_sym_try] = ACTIONS(6302),
    [anon_sym_match] = ACTIONS(6302),
    [anon_sym_match_BANG] = ACTIONS(6300),
    [anon_sym_function] = ACTIONS(6302),
    [anon_sym_use] = ACTIONS(6302),
    [anon_sym_use_BANG] = ACTIONS(6300),
    [anon_sym_do_BANG] = ACTIONS(6300),
    [anon_sym_begin] = ACTIONS(6302),
    [aux_sym_char_token1] = ACTIONS(6300),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6302),
    [anon_sym_DQUOTE] = ACTIONS(6302),
    [anon_sym_AT_DQUOTE] = ACTIONS(6300),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6300),
    [sym_bool] = ACTIONS(6302),
    [sym_unit] = ACTIONS(6300),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6302),
    [sym_op_identifier] = ACTIONS(6300),
    [anon_sym_PLUS] = ACTIONS(6302),
    [anon_sym_DASH] = ACTIONS(6302),
    [anon_sym_PLUS_DOT] = ACTIONS(6300),
    [anon_sym_DASH_DOT] = ACTIONS(6300),
    [anon_sym_PERCENT] = ACTIONS(6300),
    [anon_sym_AMP_AMP] = ACTIONS(6300),
    [anon_sym_TILDE] = ACTIONS(6300),
    [aux_sym_prefix_op_token1] = ACTIONS(6300),
    [sym_int] = ACTIONS(6302),
    [sym_xint] = ACTIONS(6300),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6300),
    [anon_sym_POUNDendif] = ACTIONS(6300),
    [anon_sym_POUNDelse] = ACTIONS(6300),
  },
  [4242] = {
    [sym_block_comment] = STATE(4242),
    [sym_compiler_directive_decl] = STATE(4242),
    [sym_fsi_directive_decl] = STATE(4242),
    [sym_preproc_line] = STATE(4242),
    [sym_identifier] = ACTIONS(3885),
    [anon_sym_return] = ACTIONS(3885),
    [anon_sym_do] = ACTIONS(3885),
    [anon_sym_let] = ACTIONS(3885),
    [anon_sym_let_BANG] = ACTIONS(3883),
    [anon_sym_LPAREN] = ACTIONS(3885),
    [anon_sym_COMMA] = ACTIONS(3883),
    [anon_sym_null] = ACTIONS(3885),
    [anon_sym_AMP] = ACTIONS(3885),
    [anon_sym_LBRACK] = ACTIONS(3885),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3883),
    [anon_sym_LBRACE] = ACTIONS(3885),
    [anon_sym_LT_AT] = ACTIONS(3885),
    [anon_sym_LT_AT_AT] = ACTIONS(3883),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3883),
    [anon_sym_new] = ACTIONS(3885),
    [anon_sym_return_BANG] = ACTIONS(3883),
    [anon_sym_yield] = ACTIONS(3885),
    [anon_sym_yield_BANG] = ACTIONS(3883),
    [anon_sym_lazy] = ACTIONS(3885),
    [anon_sym_assert] = ACTIONS(3885),
    [anon_sym_upcast] = ACTIONS(3885),
    [anon_sym_downcast] = ACTIONS(3885),
    [anon_sym_for] = ACTIONS(3885),
    [anon_sym_while] = ACTIONS(3885),
    [anon_sym_if] = ACTIONS(3885),
    [anon_sym_fun] = ACTIONS(3885),
    [anon_sym_try] = ACTIONS(3885),
    [anon_sym_match] = ACTIONS(3885),
    [anon_sym_match_BANG] = ACTIONS(3883),
    [anon_sym_function] = ACTIONS(3885),
    [anon_sym_GT] = ACTIONS(3883),
    [anon_sym_use] = ACTIONS(3885),
    [anon_sym_use_BANG] = ACTIONS(3883),
    [anon_sym_do_BANG] = ACTIONS(3883),
    [anon_sym_begin] = ACTIONS(3885),
    [aux_sym_char_token1] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3885),
    [anon_sym_DQUOTE] = ACTIONS(3885),
    [anon_sym_AT_DQUOTE] = ACTIONS(3883),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3883),
    [sym_bool] = ACTIONS(3885),
    [sym_unit] = ACTIONS(3883),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3885),
    [sym_op_identifier] = ACTIONS(3883),
    [anon_sym_PLUS] = ACTIONS(3885),
    [anon_sym_DASH] = ACTIONS(3885),
    [anon_sym_PLUS_DOT] = ACTIONS(3883),
    [anon_sym_DASH_DOT] = ACTIONS(3883),
    [anon_sym_PERCENT] = ACTIONS(3883),
    [anon_sym_AMP_AMP] = ACTIONS(3883),
    [anon_sym_TILDE] = ACTIONS(3883),
    [aux_sym_prefix_op_token1] = ACTIONS(3883),
    [sym_int] = ACTIONS(3885),
    [sym_xint] = ACTIONS(3883),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3883),
  },
  [4243] = {
    [sym_block_comment] = STATE(4243),
    [sym_compiler_directive_decl] = STATE(4243),
    [sym_fsi_directive_decl] = STATE(4243),
    [sym_preproc_line] = STATE(4243),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3698),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3698),
    [anon_sym_DASH_DOT] = ACTIONS(3698),
    [anon_sym_PERCENT] = ACTIONS(3698),
    [anon_sym_AMP_AMP] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3698),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [anon_sym_POUNDendif] = ACTIONS(3698),
    [anon_sym_POUNDelse] = ACTIONS(3698),
  },
  [4244] = {
    [sym_block_comment] = STATE(4244),
    [sym_compiler_directive_decl] = STATE(4244),
    [sym_fsi_directive_decl] = STATE(4244),
    [sym_preproc_line] = STATE(4244),
    [sym_identifier] = ACTIONS(3958),
    [anon_sym_return] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(3958),
    [anon_sym_let] = ACTIONS(3958),
    [anon_sym_let_BANG] = ACTIONS(3956),
    [anon_sym_LPAREN] = ACTIONS(3958),
    [anon_sym_COMMA] = ACTIONS(3956),
    [anon_sym_null] = ACTIONS(3958),
    [anon_sym_AMP] = ACTIONS(3958),
    [anon_sym_LBRACK] = ACTIONS(3958),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3956),
    [anon_sym_LBRACE] = ACTIONS(3958),
    [anon_sym_LT_AT] = ACTIONS(3958),
    [anon_sym_LT_AT_AT] = ACTIONS(3956),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3956),
    [anon_sym_new] = ACTIONS(3958),
    [anon_sym_return_BANG] = ACTIONS(3956),
    [anon_sym_yield] = ACTIONS(3958),
    [anon_sym_yield_BANG] = ACTIONS(3956),
    [anon_sym_lazy] = ACTIONS(3958),
    [anon_sym_assert] = ACTIONS(3958),
    [anon_sym_upcast] = ACTIONS(3958),
    [anon_sym_downcast] = ACTIONS(3958),
    [anon_sym_for] = ACTIONS(3958),
    [anon_sym_while] = ACTIONS(3958),
    [anon_sym_if] = ACTIONS(3958),
    [anon_sym_fun] = ACTIONS(3958),
    [anon_sym_try] = ACTIONS(3958),
    [anon_sym_match] = ACTIONS(3958),
    [anon_sym_match_BANG] = ACTIONS(3956),
    [anon_sym_function] = ACTIONS(3958),
    [anon_sym_GT] = ACTIONS(3956),
    [anon_sym_use] = ACTIONS(3958),
    [anon_sym_use_BANG] = ACTIONS(3956),
    [anon_sym_do_BANG] = ACTIONS(3956),
    [anon_sym_begin] = ACTIONS(3958),
    [aux_sym_char_token1] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3958),
    [anon_sym_DQUOTE] = ACTIONS(3958),
    [anon_sym_AT_DQUOTE] = ACTIONS(3956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3956),
    [sym_bool] = ACTIONS(3958),
    [sym_unit] = ACTIONS(3956),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3958),
    [sym_op_identifier] = ACTIONS(3956),
    [anon_sym_PLUS] = ACTIONS(3958),
    [anon_sym_DASH] = ACTIONS(3958),
    [anon_sym_PLUS_DOT] = ACTIONS(3956),
    [anon_sym_DASH_DOT] = ACTIONS(3956),
    [anon_sym_PERCENT] = ACTIONS(3956),
    [anon_sym_AMP_AMP] = ACTIONS(3956),
    [anon_sym_TILDE] = ACTIONS(3956),
    [aux_sym_prefix_op_token1] = ACTIONS(3956),
    [sym_int] = ACTIONS(3958),
    [sym_xint] = ACTIONS(3956),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3956),
  },
  [4245] = {
    [sym_block_comment] = STATE(4245),
    [sym_compiler_directive_decl] = STATE(4245),
    [sym_fsi_directive_decl] = STATE(4245),
    [sym_preproc_line] = STATE(4245),
    [sym_identifier] = ACTIONS(3962),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_do] = ACTIONS(3962),
    [anon_sym_let] = ACTIONS(3962),
    [anon_sym_let_BANG] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_COMMA] = ACTIONS(3960),
    [anon_sym_null] = ACTIONS(3962),
    [anon_sym_AMP] = ACTIONS(3962),
    [anon_sym_LBRACK] = ACTIONS(3962),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_LT_AT] = ACTIONS(3962),
    [anon_sym_LT_AT_AT] = ACTIONS(3960),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3960),
    [anon_sym_new] = ACTIONS(3962),
    [anon_sym_return_BANG] = ACTIONS(3960),
    [anon_sym_yield] = ACTIONS(3962),
    [anon_sym_yield_BANG] = ACTIONS(3960),
    [anon_sym_lazy] = ACTIONS(3962),
    [anon_sym_assert] = ACTIONS(3962),
    [anon_sym_upcast] = ACTIONS(3962),
    [anon_sym_downcast] = ACTIONS(3962),
    [anon_sym_for] = ACTIONS(3962),
    [anon_sym_while] = ACTIONS(3962),
    [anon_sym_if] = ACTIONS(3962),
    [anon_sym_fun] = ACTIONS(3962),
    [anon_sym_try] = ACTIONS(3962),
    [anon_sym_match] = ACTIONS(3962),
    [anon_sym_match_BANG] = ACTIONS(3960),
    [anon_sym_function] = ACTIONS(3962),
    [anon_sym_GT] = ACTIONS(3960),
    [anon_sym_use] = ACTIONS(3962),
    [anon_sym_use_BANG] = ACTIONS(3960),
    [anon_sym_do_BANG] = ACTIONS(3960),
    [anon_sym_begin] = ACTIONS(3962),
    [aux_sym_char_token1] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3962),
    [anon_sym_DQUOTE] = ACTIONS(3962),
    [anon_sym_AT_DQUOTE] = ACTIONS(3960),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3960),
    [sym_bool] = ACTIONS(3962),
    [sym_unit] = ACTIONS(3960),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3962),
    [sym_op_identifier] = ACTIONS(3960),
    [anon_sym_PLUS] = ACTIONS(3962),
    [anon_sym_DASH] = ACTIONS(3962),
    [anon_sym_PLUS_DOT] = ACTIONS(3960),
    [anon_sym_DASH_DOT] = ACTIONS(3960),
    [anon_sym_PERCENT] = ACTIONS(3960),
    [anon_sym_AMP_AMP] = ACTIONS(3960),
    [anon_sym_TILDE] = ACTIONS(3960),
    [aux_sym_prefix_op_token1] = ACTIONS(3960),
    [sym_int] = ACTIONS(3962),
    [sym_xint] = ACTIONS(3960),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3960),
  },
  [4246] = {
    [sym_block_comment] = STATE(4246),
    [sym_compiler_directive_decl] = STATE(4246),
    [sym_fsi_directive_decl] = STATE(4246),
    [sym_preproc_line] = STATE(4246),
    [sym_identifier] = ACTIONS(4232),
    [anon_sym_return] = ACTIONS(4232),
    [anon_sym_do] = ACTIONS(4232),
    [anon_sym_let] = ACTIONS(4232),
    [anon_sym_let_BANG] = ACTIONS(4230),
    [anon_sym_LPAREN] = ACTIONS(4232),
    [anon_sym_COMMA] = ACTIONS(4230),
    [anon_sym_null] = ACTIONS(4232),
    [anon_sym_AMP] = ACTIONS(4232),
    [anon_sym_LBRACK] = ACTIONS(4232),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4230),
    [anon_sym_LBRACE] = ACTIONS(4232),
    [anon_sym_LT_AT] = ACTIONS(4232),
    [anon_sym_LT_AT_AT] = ACTIONS(4230),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4230),
    [anon_sym_new] = ACTIONS(4232),
    [anon_sym_return_BANG] = ACTIONS(4230),
    [anon_sym_yield] = ACTIONS(4232),
    [anon_sym_yield_BANG] = ACTIONS(4230),
    [anon_sym_lazy] = ACTIONS(4232),
    [anon_sym_assert] = ACTIONS(4232),
    [anon_sym_upcast] = ACTIONS(4232),
    [anon_sym_downcast] = ACTIONS(4232),
    [anon_sym_for] = ACTIONS(4232),
    [anon_sym_while] = ACTIONS(4232),
    [anon_sym_if] = ACTIONS(4232),
    [anon_sym_fun] = ACTIONS(4232),
    [anon_sym_try] = ACTIONS(4232),
    [anon_sym_match] = ACTIONS(4232),
    [anon_sym_match_BANG] = ACTIONS(4230),
    [anon_sym_function] = ACTIONS(4232),
    [anon_sym_GT] = ACTIONS(4230),
    [anon_sym_use] = ACTIONS(4232),
    [anon_sym_use_BANG] = ACTIONS(4230),
    [anon_sym_do_BANG] = ACTIONS(4230),
    [anon_sym_begin] = ACTIONS(4232),
    [aux_sym_char_token1] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4232),
    [anon_sym_DQUOTE] = ACTIONS(4232),
    [anon_sym_AT_DQUOTE] = ACTIONS(4230),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4230),
    [sym_bool] = ACTIONS(4232),
    [sym_unit] = ACTIONS(4230),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4232),
    [sym_op_identifier] = ACTIONS(4230),
    [anon_sym_PLUS] = ACTIONS(4232),
    [anon_sym_DASH] = ACTIONS(4232),
    [anon_sym_PLUS_DOT] = ACTIONS(4230),
    [anon_sym_DASH_DOT] = ACTIONS(4230),
    [anon_sym_PERCENT] = ACTIONS(4230),
    [anon_sym_AMP_AMP] = ACTIONS(4230),
    [anon_sym_TILDE] = ACTIONS(4230),
    [aux_sym_prefix_op_token1] = ACTIONS(4230),
    [sym_int] = ACTIONS(4232),
    [sym_xint] = ACTIONS(4230),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4230),
  },
  [4247] = {
    [sym_block_comment] = STATE(4247),
    [sym_compiler_directive_decl] = STATE(4247),
    [sym_fsi_directive_decl] = STATE(4247),
    [sym_preproc_line] = STATE(4247),
    [sym_identifier] = ACTIONS(4126),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_do] = ACTIONS(4126),
    [anon_sym_let] = ACTIONS(4126),
    [anon_sym_let_BANG] = ACTIONS(4124),
    [anon_sym_LPAREN] = ACTIONS(4126),
    [anon_sym_COMMA] = ACTIONS(4124),
    [anon_sym_null] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LBRACK] = ACTIONS(4126),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4126),
    [anon_sym_LT_AT] = ACTIONS(4126),
    [anon_sym_LT_AT_AT] = ACTIONS(4124),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4124),
    [anon_sym_new] = ACTIONS(4126),
    [anon_sym_return_BANG] = ACTIONS(4124),
    [anon_sym_yield] = ACTIONS(4126),
    [anon_sym_yield_BANG] = ACTIONS(4124),
    [anon_sym_lazy] = ACTIONS(4126),
    [anon_sym_assert] = ACTIONS(4126),
    [anon_sym_upcast] = ACTIONS(4126),
    [anon_sym_downcast] = ACTIONS(4126),
    [anon_sym_for] = ACTIONS(4126),
    [anon_sym_while] = ACTIONS(4126),
    [anon_sym_if] = ACTIONS(4126),
    [anon_sym_fun] = ACTIONS(4126),
    [anon_sym_try] = ACTIONS(4126),
    [anon_sym_match] = ACTIONS(4126),
    [anon_sym_match_BANG] = ACTIONS(4124),
    [anon_sym_function] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4124),
    [anon_sym_use] = ACTIONS(4126),
    [anon_sym_use_BANG] = ACTIONS(4124),
    [anon_sym_do_BANG] = ACTIONS(4124),
    [anon_sym_begin] = ACTIONS(4126),
    [aux_sym_char_token1] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4126),
    [anon_sym_DQUOTE] = ACTIONS(4126),
    [anon_sym_AT_DQUOTE] = ACTIONS(4124),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4124),
    [sym_bool] = ACTIONS(4126),
    [sym_unit] = ACTIONS(4124),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4126),
    [sym_op_identifier] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_PLUS_DOT] = ACTIONS(4124),
    [anon_sym_DASH_DOT] = ACTIONS(4124),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_AMP_AMP] = ACTIONS(4124),
    [anon_sym_TILDE] = ACTIONS(4124),
    [aux_sym_prefix_op_token1] = ACTIONS(4124),
    [sym_int] = ACTIONS(4126),
    [sym_xint] = ACTIONS(4124),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4124),
  },
  [4248] = {
    [sym_block_comment] = STATE(4248),
    [sym_compiler_directive_decl] = STATE(4248),
    [sym_fsi_directive_decl] = STATE(4248),
    [sym_preproc_line] = STATE(4248),
    [sym_identifier] = ACTIONS(4122),
    [anon_sym_return] = ACTIONS(4122),
    [anon_sym_do] = ACTIONS(4122),
    [anon_sym_let] = ACTIONS(4122),
    [anon_sym_let_BANG] = ACTIONS(4120),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_COMMA] = ACTIONS(4120),
    [anon_sym_null] = ACTIONS(4122),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4120),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_LT_AT] = ACTIONS(4122),
    [anon_sym_LT_AT_AT] = ACTIONS(4120),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4120),
    [anon_sym_new] = ACTIONS(4122),
    [anon_sym_return_BANG] = ACTIONS(4120),
    [anon_sym_yield] = ACTIONS(4122),
    [anon_sym_yield_BANG] = ACTIONS(4120),
    [anon_sym_lazy] = ACTIONS(4122),
    [anon_sym_assert] = ACTIONS(4122),
    [anon_sym_upcast] = ACTIONS(4122),
    [anon_sym_downcast] = ACTIONS(4122),
    [anon_sym_for] = ACTIONS(4122),
    [anon_sym_while] = ACTIONS(4122),
    [anon_sym_if] = ACTIONS(4122),
    [anon_sym_fun] = ACTIONS(4122),
    [anon_sym_try] = ACTIONS(4122),
    [anon_sym_match] = ACTIONS(4122),
    [anon_sym_match_BANG] = ACTIONS(4120),
    [anon_sym_function] = ACTIONS(4122),
    [anon_sym_GT] = ACTIONS(4120),
    [anon_sym_use] = ACTIONS(4122),
    [anon_sym_use_BANG] = ACTIONS(4120),
    [anon_sym_do_BANG] = ACTIONS(4120),
    [anon_sym_begin] = ACTIONS(4122),
    [aux_sym_char_token1] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4122),
    [anon_sym_DQUOTE] = ACTIONS(4122),
    [anon_sym_AT_DQUOTE] = ACTIONS(4120),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4120),
    [sym_bool] = ACTIONS(4122),
    [sym_unit] = ACTIONS(4120),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4122),
    [sym_op_identifier] = ACTIONS(4120),
    [anon_sym_PLUS] = ACTIONS(4122),
    [anon_sym_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_DOT] = ACTIONS(4120),
    [anon_sym_DASH_DOT] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [anon_sym_AMP_AMP] = ACTIONS(4120),
    [anon_sym_TILDE] = ACTIONS(4120),
    [aux_sym_prefix_op_token1] = ACTIONS(4120),
    [sym_int] = ACTIONS(4122),
    [sym_xint] = ACTIONS(4120),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4120),
  },
  [4249] = {
    [sym_block_comment] = STATE(4249),
    [sym_compiler_directive_decl] = STATE(4249),
    [sym_fsi_directive_decl] = STATE(4249),
    [sym_preproc_line] = STATE(4249),
    [sym_identifier] = ACTIONS(4118),
    [anon_sym_return] = ACTIONS(4118),
    [anon_sym_do] = ACTIONS(4118),
    [anon_sym_let] = ACTIONS(4118),
    [anon_sym_let_BANG] = ACTIONS(4116),
    [anon_sym_LPAREN] = ACTIONS(4118),
    [anon_sym_COMMA] = ACTIONS(4116),
    [anon_sym_null] = ACTIONS(4118),
    [anon_sym_AMP] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4118),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(4118),
    [anon_sym_LT_AT] = ACTIONS(4118),
    [anon_sym_LT_AT_AT] = ACTIONS(4116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4116),
    [anon_sym_new] = ACTIONS(4118),
    [anon_sym_return_BANG] = ACTIONS(4116),
    [anon_sym_yield] = ACTIONS(4118),
    [anon_sym_yield_BANG] = ACTIONS(4116),
    [anon_sym_lazy] = ACTIONS(4118),
    [anon_sym_assert] = ACTIONS(4118),
    [anon_sym_upcast] = ACTIONS(4118),
    [anon_sym_downcast] = ACTIONS(4118),
    [anon_sym_for] = ACTIONS(4118),
    [anon_sym_while] = ACTIONS(4118),
    [anon_sym_if] = ACTIONS(4118),
    [anon_sym_fun] = ACTIONS(4118),
    [anon_sym_try] = ACTIONS(4118),
    [anon_sym_match] = ACTIONS(4118),
    [anon_sym_match_BANG] = ACTIONS(4116),
    [anon_sym_function] = ACTIONS(4118),
    [anon_sym_GT] = ACTIONS(4116),
    [anon_sym_use] = ACTIONS(4118),
    [anon_sym_use_BANG] = ACTIONS(4116),
    [anon_sym_do_BANG] = ACTIONS(4116),
    [anon_sym_begin] = ACTIONS(4118),
    [aux_sym_char_token1] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4118),
    [anon_sym_DQUOTE] = ACTIONS(4118),
    [anon_sym_AT_DQUOTE] = ACTIONS(4116),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4116),
    [sym_bool] = ACTIONS(4118),
    [sym_unit] = ACTIONS(4116),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4118),
    [sym_op_identifier] = ACTIONS(4116),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_PLUS_DOT] = ACTIONS(4116),
    [anon_sym_DASH_DOT] = ACTIONS(4116),
    [anon_sym_PERCENT] = ACTIONS(4116),
    [anon_sym_AMP_AMP] = ACTIONS(4116),
    [anon_sym_TILDE] = ACTIONS(4116),
    [aux_sym_prefix_op_token1] = ACTIONS(4116),
    [sym_int] = ACTIONS(4118),
    [sym_xint] = ACTIONS(4116),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4116),
  },
  [4250] = {
    [sym_block_comment] = STATE(4250),
    [sym_compiler_directive_decl] = STATE(4250),
    [sym_fsi_directive_decl] = STATE(4250),
    [sym_preproc_line] = STATE(4250),
    [sym_identifier] = ACTIONS(4112),
    [anon_sym_return] = ACTIONS(4112),
    [anon_sym_do] = ACTIONS(4112),
    [anon_sym_let] = ACTIONS(4112),
    [anon_sym_let_BANG] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_null] = ACTIONS(4112),
    [anon_sym_AMP] = ACTIONS(4112),
    [anon_sym_LBRACK] = ACTIONS(4112),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4110),
    [anon_sym_LBRACE] = ACTIONS(4112),
    [anon_sym_LT_AT] = ACTIONS(4112),
    [anon_sym_LT_AT_AT] = ACTIONS(4110),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4110),
    [anon_sym_new] = ACTIONS(4112),
    [anon_sym_return_BANG] = ACTIONS(4110),
    [anon_sym_yield] = ACTIONS(4112),
    [anon_sym_yield_BANG] = ACTIONS(4110),
    [anon_sym_lazy] = ACTIONS(4112),
    [anon_sym_assert] = ACTIONS(4112),
    [anon_sym_upcast] = ACTIONS(4112),
    [anon_sym_downcast] = ACTIONS(4112),
    [anon_sym_for] = ACTIONS(4112),
    [anon_sym_while] = ACTIONS(4112),
    [anon_sym_if] = ACTIONS(4112),
    [anon_sym_fun] = ACTIONS(4112),
    [anon_sym_try] = ACTIONS(4112),
    [anon_sym_match] = ACTIONS(4112),
    [anon_sym_match_BANG] = ACTIONS(4110),
    [anon_sym_function] = ACTIONS(4112),
    [anon_sym_GT] = ACTIONS(4110),
    [anon_sym_use] = ACTIONS(4112),
    [anon_sym_use_BANG] = ACTIONS(4110),
    [anon_sym_do_BANG] = ACTIONS(4110),
    [anon_sym_begin] = ACTIONS(4112),
    [aux_sym_char_token1] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4112),
    [anon_sym_DQUOTE] = ACTIONS(4112),
    [anon_sym_AT_DQUOTE] = ACTIONS(4110),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4110),
    [sym_bool] = ACTIONS(4112),
    [sym_unit] = ACTIONS(4110),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4112),
    [sym_op_identifier] = ACTIONS(4110),
    [anon_sym_PLUS] = ACTIONS(4112),
    [anon_sym_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_DOT] = ACTIONS(4110),
    [anon_sym_DASH_DOT] = ACTIONS(4110),
    [anon_sym_PERCENT] = ACTIONS(4110),
    [anon_sym_AMP_AMP] = ACTIONS(4110),
    [anon_sym_TILDE] = ACTIONS(4110),
    [aux_sym_prefix_op_token1] = ACTIONS(4110),
    [sym_int] = ACTIONS(4112),
    [sym_xint] = ACTIONS(4110),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4110),
  },
  [4251] = {
    [sym_block_comment] = STATE(4251),
    [sym_compiler_directive_decl] = STATE(4251),
    [sym_fsi_directive_decl] = STATE(4251),
    [sym_preproc_line] = STATE(4251),
    [sym_identifier] = ACTIONS(4108),
    [anon_sym_return] = ACTIONS(4108),
    [anon_sym_do] = ACTIONS(4108),
    [anon_sym_let] = ACTIONS(4108),
    [anon_sym_let_BANG] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(4108),
    [anon_sym_COMMA] = ACTIONS(4106),
    [anon_sym_null] = ACTIONS(4108),
    [anon_sym_AMP] = ACTIONS(4108),
    [anon_sym_LBRACK] = ACTIONS(4108),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(4108),
    [anon_sym_LT_AT] = ACTIONS(4108),
    [anon_sym_LT_AT_AT] = ACTIONS(4106),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4106),
    [anon_sym_new] = ACTIONS(4108),
    [anon_sym_return_BANG] = ACTIONS(4106),
    [anon_sym_yield] = ACTIONS(4108),
    [anon_sym_yield_BANG] = ACTIONS(4106),
    [anon_sym_lazy] = ACTIONS(4108),
    [anon_sym_assert] = ACTIONS(4108),
    [anon_sym_upcast] = ACTIONS(4108),
    [anon_sym_downcast] = ACTIONS(4108),
    [anon_sym_for] = ACTIONS(4108),
    [anon_sym_while] = ACTIONS(4108),
    [anon_sym_if] = ACTIONS(4108),
    [anon_sym_fun] = ACTIONS(4108),
    [anon_sym_try] = ACTIONS(4108),
    [anon_sym_match] = ACTIONS(4108),
    [anon_sym_match_BANG] = ACTIONS(4106),
    [anon_sym_function] = ACTIONS(4108),
    [anon_sym_GT] = ACTIONS(4106),
    [anon_sym_use] = ACTIONS(4108),
    [anon_sym_use_BANG] = ACTIONS(4106),
    [anon_sym_do_BANG] = ACTIONS(4106),
    [anon_sym_begin] = ACTIONS(4108),
    [aux_sym_char_token1] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4108),
    [anon_sym_DQUOTE] = ACTIONS(4108),
    [anon_sym_AT_DQUOTE] = ACTIONS(4106),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4106),
    [sym_bool] = ACTIONS(4108),
    [sym_unit] = ACTIONS(4106),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4108),
    [sym_op_identifier] = ACTIONS(4106),
    [anon_sym_PLUS] = ACTIONS(4108),
    [anon_sym_DASH] = ACTIONS(4108),
    [anon_sym_PLUS_DOT] = ACTIONS(4106),
    [anon_sym_DASH_DOT] = ACTIONS(4106),
    [anon_sym_PERCENT] = ACTIONS(4106),
    [anon_sym_AMP_AMP] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(4106),
    [aux_sym_prefix_op_token1] = ACTIONS(4106),
    [sym_int] = ACTIONS(4108),
    [sym_xint] = ACTIONS(4106),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4106),
  },
  [4252] = {
    [sym_block_comment] = STATE(4252),
    [sym_compiler_directive_decl] = STATE(4252),
    [sym_fsi_directive_decl] = STATE(4252),
    [sym_preproc_line] = STATE(4252),
    [sym_identifier] = ACTIONS(4093),
    [anon_sym_return] = ACTIONS(4093),
    [anon_sym_do] = ACTIONS(4093),
    [anon_sym_let] = ACTIONS(4093),
    [anon_sym_let_BANG] = ACTIONS(4091),
    [anon_sym_LPAREN] = ACTIONS(4093),
    [anon_sym_COMMA] = ACTIONS(4091),
    [anon_sym_null] = ACTIONS(4093),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(4093),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4091),
    [anon_sym_LBRACE] = ACTIONS(4093),
    [anon_sym_LT_AT] = ACTIONS(4093),
    [anon_sym_LT_AT_AT] = ACTIONS(4091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4091),
    [anon_sym_new] = ACTIONS(4093),
    [anon_sym_return_BANG] = ACTIONS(4091),
    [anon_sym_yield] = ACTIONS(4093),
    [anon_sym_yield_BANG] = ACTIONS(4091),
    [anon_sym_lazy] = ACTIONS(4093),
    [anon_sym_assert] = ACTIONS(4093),
    [anon_sym_upcast] = ACTIONS(4093),
    [anon_sym_downcast] = ACTIONS(4093),
    [anon_sym_for] = ACTIONS(4093),
    [anon_sym_while] = ACTIONS(4093),
    [anon_sym_if] = ACTIONS(4093),
    [anon_sym_fun] = ACTIONS(4093),
    [anon_sym_try] = ACTIONS(4093),
    [anon_sym_match] = ACTIONS(4093),
    [anon_sym_match_BANG] = ACTIONS(4091),
    [anon_sym_function] = ACTIONS(4093),
    [anon_sym_GT] = ACTIONS(4091),
    [anon_sym_use] = ACTIONS(4093),
    [anon_sym_use_BANG] = ACTIONS(4091),
    [anon_sym_do_BANG] = ACTIONS(4091),
    [anon_sym_begin] = ACTIONS(4093),
    [aux_sym_char_token1] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4093),
    [anon_sym_DQUOTE] = ACTIONS(4093),
    [anon_sym_AT_DQUOTE] = ACTIONS(4091),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4091),
    [sym_bool] = ACTIONS(4093),
    [sym_unit] = ACTIONS(4091),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4093),
    [sym_op_identifier] = ACTIONS(4091),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS_DOT] = ACTIONS(4091),
    [anon_sym_DASH_DOT] = ACTIONS(4091),
    [anon_sym_PERCENT] = ACTIONS(4091),
    [anon_sym_AMP_AMP] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [aux_sym_prefix_op_token1] = ACTIONS(4091),
    [sym_int] = ACTIONS(4093),
    [sym_xint] = ACTIONS(4091),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4091),
  },
  [4253] = {
    [sym_block_comment] = STATE(4253),
    [sym_compiler_directive_decl] = STATE(4253),
    [sym_fsi_directive_decl] = STATE(4253),
    [sym_preproc_line] = STATE(4253),
    [sym_identifier] = ACTIONS(4086),
    [anon_sym_return] = ACTIONS(4086),
    [anon_sym_do] = ACTIONS(4086),
    [anon_sym_let] = ACTIONS(4086),
    [anon_sym_let_BANG] = ACTIONS(4084),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_COMMA] = ACTIONS(4084),
    [anon_sym_null] = ACTIONS(4086),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4084),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_LT_AT] = ACTIONS(4086),
    [anon_sym_LT_AT_AT] = ACTIONS(4084),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4084),
    [anon_sym_new] = ACTIONS(4086),
    [anon_sym_return_BANG] = ACTIONS(4084),
    [anon_sym_yield] = ACTIONS(4086),
    [anon_sym_yield_BANG] = ACTIONS(4084),
    [anon_sym_lazy] = ACTIONS(4086),
    [anon_sym_assert] = ACTIONS(4086),
    [anon_sym_upcast] = ACTIONS(4086),
    [anon_sym_downcast] = ACTIONS(4086),
    [anon_sym_for] = ACTIONS(4086),
    [anon_sym_while] = ACTIONS(4086),
    [anon_sym_if] = ACTIONS(4086),
    [anon_sym_fun] = ACTIONS(4086),
    [anon_sym_try] = ACTIONS(4086),
    [anon_sym_match] = ACTIONS(4086),
    [anon_sym_match_BANG] = ACTIONS(4084),
    [anon_sym_function] = ACTIONS(4086),
    [anon_sym_GT] = ACTIONS(4084),
    [anon_sym_use] = ACTIONS(4086),
    [anon_sym_use_BANG] = ACTIONS(4084),
    [anon_sym_do_BANG] = ACTIONS(4084),
    [anon_sym_begin] = ACTIONS(4086),
    [aux_sym_char_token1] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4086),
    [anon_sym_DQUOTE] = ACTIONS(4086),
    [anon_sym_AT_DQUOTE] = ACTIONS(4084),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4084),
    [sym_bool] = ACTIONS(4086),
    [sym_unit] = ACTIONS(4084),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4086),
    [sym_op_identifier] = ACTIONS(4084),
    [anon_sym_PLUS] = ACTIONS(4086),
    [anon_sym_DASH] = ACTIONS(4086),
    [anon_sym_PLUS_DOT] = ACTIONS(4084),
    [anon_sym_DASH_DOT] = ACTIONS(4084),
    [anon_sym_PERCENT] = ACTIONS(4084),
    [anon_sym_AMP_AMP] = ACTIONS(4084),
    [anon_sym_TILDE] = ACTIONS(4084),
    [aux_sym_prefix_op_token1] = ACTIONS(4084),
    [sym_int] = ACTIONS(4086),
    [sym_xint] = ACTIONS(4084),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4084),
  },
  [4254] = {
    [sym_block_comment] = STATE(4254),
    [sym_compiler_directive_decl] = STATE(4254),
    [sym_fsi_directive_decl] = STATE(4254),
    [sym_preproc_line] = STATE(4254),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_do] = ACTIONS(4082),
    [anon_sym_let] = ACTIONS(4082),
    [anon_sym_let_BANG] = ACTIONS(4080),
    [anon_sym_LPAREN] = ACTIONS(4082),
    [anon_sym_COMMA] = ACTIONS(4080),
    [anon_sym_null] = ACTIONS(4082),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_LBRACK] = ACTIONS(4082),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(4082),
    [anon_sym_LT_AT] = ACTIONS(4082),
    [anon_sym_LT_AT_AT] = ACTIONS(4080),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4080),
    [anon_sym_new] = ACTIONS(4082),
    [anon_sym_return_BANG] = ACTIONS(4080),
    [anon_sym_yield] = ACTIONS(4082),
    [anon_sym_yield_BANG] = ACTIONS(4080),
    [anon_sym_lazy] = ACTIONS(4082),
    [anon_sym_assert] = ACTIONS(4082),
    [anon_sym_upcast] = ACTIONS(4082),
    [anon_sym_downcast] = ACTIONS(4082),
    [anon_sym_for] = ACTIONS(4082),
    [anon_sym_while] = ACTIONS(4082),
    [anon_sym_if] = ACTIONS(4082),
    [anon_sym_fun] = ACTIONS(4082),
    [anon_sym_try] = ACTIONS(4082),
    [anon_sym_match] = ACTIONS(4082),
    [anon_sym_match_BANG] = ACTIONS(4080),
    [anon_sym_function] = ACTIONS(4082),
    [anon_sym_GT] = ACTIONS(4080),
    [anon_sym_use] = ACTIONS(4082),
    [anon_sym_use_BANG] = ACTIONS(4080),
    [anon_sym_do_BANG] = ACTIONS(4080),
    [anon_sym_begin] = ACTIONS(4082),
    [aux_sym_char_token1] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4082),
    [anon_sym_DQUOTE] = ACTIONS(4082),
    [anon_sym_AT_DQUOTE] = ACTIONS(4080),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4080),
    [sym_bool] = ACTIONS(4082),
    [sym_unit] = ACTIONS(4080),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4082),
    [sym_op_identifier] = ACTIONS(4080),
    [anon_sym_PLUS] = ACTIONS(4082),
    [anon_sym_DASH] = ACTIONS(4082),
    [anon_sym_PLUS_DOT] = ACTIONS(4080),
    [anon_sym_DASH_DOT] = ACTIONS(4080),
    [anon_sym_PERCENT] = ACTIONS(4080),
    [anon_sym_AMP_AMP] = ACTIONS(4080),
    [anon_sym_TILDE] = ACTIONS(4080),
    [aux_sym_prefix_op_token1] = ACTIONS(4080),
    [sym_int] = ACTIONS(4082),
    [sym_xint] = ACTIONS(4080),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4080),
  },
  [4255] = {
    [sym_block_comment] = STATE(4255),
    [sym_compiler_directive_decl] = STATE(4255),
    [sym_fsi_directive_decl] = STATE(4255),
    [sym_preproc_line] = STATE(4255),
    [sym_identifier] = ACTIONS(4054),
    [anon_sym_return] = ACTIONS(4054),
    [anon_sym_do] = ACTIONS(4054),
    [anon_sym_let] = ACTIONS(4054),
    [anon_sym_let_BANG] = ACTIONS(4052),
    [anon_sym_LPAREN] = ACTIONS(4054),
    [anon_sym_COMMA] = ACTIONS(4052),
    [anon_sym_null] = ACTIONS(4054),
    [anon_sym_AMP] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(4054),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4052),
    [anon_sym_LBRACE] = ACTIONS(4054),
    [anon_sym_LT_AT] = ACTIONS(4054),
    [anon_sym_LT_AT_AT] = ACTIONS(4052),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_return_BANG] = ACTIONS(4052),
    [anon_sym_yield] = ACTIONS(4054),
    [anon_sym_yield_BANG] = ACTIONS(4052),
    [anon_sym_lazy] = ACTIONS(4054),
    [anon_sym_assert] = ACTIONS(4054),
    [anon_sym_upcast] = ACTIONS(4054),
    [anon_sym_downcast] = ACTIONS(4054),
    [anon_sym_for] = ACTIONS(4054),
    [anon_sym_while] = ACTIONS(4054),
    [anon_sym_if] = ACTIONS(4054),
    [anon_sym_fun] = ACTIONS(4054),
    [anon_sym_try] = ACTIONS(4054),
    [anon_sym_match] = ACTIONS(4054),
    [anon_sym_match_BANG] = ACTIONS(4052),
    [anon_sym_function] = ACTIONS(4054),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_use] = ACTIONS(4054),
    [anon_sym_use_BANG] = ACTIONS(4052),
    [anon_sym_do_BANG] = ACTIONS(4052),
    [anon_sym_begin] = ACTIONS(4054),
    [aux_sym_char_token1] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4054),
    [anon_sym_DQUOTE] = ACTIONS(4054),
    [anon_sym_AT_DQUOTE] = ACTIONS(4052),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4052),
    [sym_bool] = ACTIONS(4054),
    [sym_unit] = ACTIONS(4052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4054),
    [sym_op_identifier] = ACTIONS(4052),
    [anon_sym_PLUS] = ACTIONS(4054),
    [anon_sym_DASH] = ACTIONS(4054),
    [anon_sym_PLUS_DOT] = ACTIONS(4052),
    [anon_sym_DASH_DOT] = ACTIONS(4052),
    [anon_sym_PERCENT] = ACTIONS(4052),
    [anon_sym_AMP_AMP] = ACTIONS(4052),
    [anon_sym_TILDE] = ACTIONS(4052),
    [aux_sym_prefix_op_token1] = ACTIONS(4052),
    [sym_int] = ACTIONS(4054),
    [sym_xint] = ACTIONS(4052),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4052),
  },
  [4256] = {
    [sym_block_comment] = STATE(4256),
    [sym_compiler_directive_decl] = STATE(4256),
    [sym_fsi_directive_decl] = STATE(4256),
    [sym_preproc_line] = STATE(4256),
    [sym_identifier] = ACTIONS(4018),
    [anon_sym_return] = ACTIONS(4018),
    [anon_sym_do] = ACTIONS(4018),
    [anon_sym_let] = ACTIONS(4018),
    [anon_sym_let_BANG] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(4018),
    [anon_sym_COMMA] = ACTIONS(4016),
    [anon_sym_null] = ACTIONS(4018),
    [anon_sym_AMP] = ACTIONS(4018),
    [anon_sym_LBRACK] = ACTIONS(4018),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4016),
    [anon_sym_LBRACE] = ACTIONS(4018),
    [anon_sym_LT_AT] = ACTIONS(4018),
    [anon_sym_LT_AT_AT] = ACTIONS(4016),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4016),
    [anon_sym_new] = ACTIONS(4018),
    [anon_sym_return_BANG] = ACTIONS(4016),
    [anon_sym_yield] = ACTIONS(4018),
    [anon_sym_yield_BANG] = ACTIONS(4016),
    [anon_sym_lazy] = ACTIONS(4018),
    [anon_sym_assert] = ACTIONS(4018),
    [anon_sym_upcast] = ACTIONS(4018),
    [anon_sym_downcast] = ACTIONS(4018),
    [anon_sym_for] = ACTIONS(4018),
    [anon_sym_while] = ACTIONS(4018),
    [anon_sym_if] = ACTIONS(4018),
    [anon_sym_fun] = ACTIONS(4018),
    [anon_sym_try] = ACTIONS(4018),
    [anon_sym_match] = ACTIONS(4018),
    [anon_sym_match_BANG] = ACTIONS(4016),
    [anon_sym_function] = ACTIONS(4018),
    [anon_sym_GT] = ACTIONS(4016),
    [anon_sym_use] = ACTIONS(4018),
    [anon_sym_use_BANG] = ACTIONS(4016),
    [anon_sym_do_BANG] = ACTIONS(4016),
    [anon_sym_begin] = ACTIONS(4018),
    [aux_sym_char_token1] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(4018),
    [anon_sym_AT_DQUOTE] = ACTIONS(4016),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4016),
    [sym_bool] = ACTIONS(4018),
    [sym_unit] = ACTIONS(4016),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4018),
    [sym_op_identifier] = ACTIONS(4016),
    [anon_sym_PLUS] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_PLUS_DOT] = ACTIONS(4016),
    [anon_sym_DASH_DOT] = ACTIONS(4016),
    [anon_sym_PERCENT] = ACTIONS(4016),
    [anon_sym_AMP_AMP] = ACTIONS(4016),
    [anon_sym_TILDE] = ACTIONS(4016),
    [aux_sym_prefix_op_token1] = ACTIONS(4016),
    [sym_int] = ACTIONS(4018),
    [sym_xint] = ACTIONS(4016),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4016),
  },
  [4257] = {
    [sym_block_comment] = STATE(4257),
    [sym_compiler_directive_decl] = STATE(4257),
    [sym_fsi_directive_decl] = STATE(4257),
    [sym_preproc_line] = STATE(4257),
    [sym_identifier] = ACTIONS(3845),
    [anon_sym_return] = ACTIONS(3845),
    [anon_sym_do] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_let_BANG] = ACTIONS(3843),
    [anon_sym_LPAREN] = ACTIONS(3845),
    [anon_sym_COMMA] = ACTIONS(3843),
    [anon_sym_null] = ACTIONS(3845),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3843),
    [anon_sym_LBRACE] = ACTIONS(3845),
    [anon_sym_LT_AT] = ACTIONS(3845),
    [anon_sym_LT_AT_AT] = ACTIONS(3843),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3843),
    [anon_sym_new] = ACTIONS(3845),
    [anon_sym_return_BANG] = ACTIONS(3843),
    [anon_sym_yield] = ACTIONS(3845),
    [anon_sym_yield_BANG] = ACTIONS(3843),
    [anon_sym_lazy] = ACTIONS(3845),
    [anon_sym_assert] = ACTIONS(3845),
    [anon_sym_upcast] = ACTIONS(3845),
    [anon_sym_downcast] = ACTIONS(3845),
    [anon_sym_for] = ACTIONS(3845),
    [anon_sym_while] = ACTIONS(3845),
    [anon_sym_if] = ACTIONS(3845),
    [anon_sym_fun] = ACTIONS(3845),
    [anon_sym_try] = ACTIONS(3845),
    [anon_sym_match] = ACTIONS(3845),
    [anon_sym_match_BANG] = ACTIONS(3843),
    [anon_sym_function] = ACTIONS(3845),
    [anon_sym_GT] = ACTIONS(3843),
    [anon_sym_use] = ACTIONS(3845),
    [anon_sym_use_BANG] = ACTIONS(3843),
    [anon_sym_do_BANG] = ACTIONS(3843),
    [anon_sym_begin] = ACTIONS(3845),
    [aux_sym_char_token1] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3845),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_AT_DQUOTE] = ACTIONS(3843),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3843),
    [sym_bool] = ACTIONS(3845),
    [sym_unit] = ACTIONS(3843),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3845),
    [sym_op_identifier] = ACTIONS(3843),
    [anon_sym_PLUS] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_PLUS_DOT] = ACTIONS(3843),
    [anon_sym_DASH_DOT] = ACTIONS(3843),
    [anon_sym_PERCENT] = ACTIONS(3843),
    [anon_sym_AMP_AMP] = ACTIONS(3843),
    [anon_sym_TILDE] = ACTIONS(3843),
    [aux_sym_prefix_op_token1] = ACTIONS(3843),
    [sym_int] = ACTIONS(3845),
    [sym_xint] = ACTIONS(3843),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3843),
  },
  [4258] = {
    [sym_block_comment] = STATE(4258),
    [sym_compiler_directive_decl] = STATE(4258),
    [sym_fsi_directive_decl] = STATE(4258),
    [sym_preproc_line] = STATE(4258),
    [sym_identifier] = ACTIONS(4003),
    [anon_sym_return] = ACTIONS(4003),
    [anon_sym_do] = ACTIONS(4003),
    [anon_sym_let] = ACTIONS(4003),
    [anon_sym_let_BANG] = ACTIONS(4001),
    [anon_sym_LPAREN] = ACTIONS(4003),
    [anon_sym_COMMA] = ACTIONS(4001),
    [anon_sym_null] = ACTIONS(4003),
    [anon_sym_AMP] = ACTIONS(4003),
    [anon_sym_LBRACK] = ACTIONS(4003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4001),
    [anon_sym_LBRACE] = ACTIONS(4003),
    [anon_sym_LT_AT] = ACTIONS(4003),
    [anon_sym_LT_AT_AT] = ACTIONS(4001),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4001),
    [anon_sym_new] = ACTIONS(4003),
    [anon_sym_return_BANG] = ACTIONS(4001),
    [anon_sym_yield] = ACTIONS(4003),
    [anon_sym_yield_BANG] = ACTIONS(4001),
    [anon_sym_lazy] = ACTIONS(4003),
    [anon_sym_assert] = ACTIONS(4003),
    [anon_sym_upcast] = ACTIONS(4003),
    [anon_sym_downcast] = ACTIONS(4003),
    [anon_sym_for] = ACTIONS(4003),
    [anon_sym_while] = ACTIONS(4003),
    [anon_sym_if] = ACTIONS(4003),
    [anon_sym_fun] = ACTIONS(4003),
    [anon_sym_try] = ACTIONS(4003),
    [anon_sym_match] = ACTIONS(4003),
    [anon_sym_match_BANG] = ACTIONS(4001),
    [anon_sym_function] = ACTIONS(4003),
    [anon_sym_GT] = ACTIONS(4001),
    [anon_sym_use] = ACTIONS(4003),
    [anon_sym_use_BANG] = ACTIONS(4001),
    [anon_sym_do_BANG] = ACTIONS(4001),
    [anon_sym_begin] = ACTIONS(4003),
    [aux_sym_char_token1] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4003),
    [anon_sym_DQUOTE] = ACTIONS(4003),
    [anon_sym_AT_DQUOTE] = ACTIONS(4001),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4001),
    [sym_bool] = ACTIONS(4003),
    [sym_unit] = ACTIONS(4001),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4003),
    [sym_op_identifier] = ACTIONS(4001),
    [anon_sym_PLUS] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [anon_sym_PLUS_DOT] = ACTIONS(4001),
    [anon_sym_DASH_DOT] = ACTIONS(4001),
    [anon_sym_PERCENT] = ACTIONS(4001),
    [anon_sym_AMP_AMP] = ACTIONS(4001),
    [anon_sym_TILDE] = ACTIONS(4001),
    [aux_sym_prefix_op_token1] = ACTIONS(4001),
    [sym_int] = ACTIONS(4003),
    [sym_xint] = ACTIONS(4001),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4001),
  },
  [4259] = {
    [sym_block_comment] = STATE(4259),
    [sym_compiler_directive_decl] = STATE(4259),
    [sym_fsi_directive_decl] = STATE(4259),
    [sym_preproc_line] = STATE(4259),
    [sym_identifier] = ACTIONS(6288),
    [anon_sym_return] = ACTIONS(6288),
    [anon_sym_do] = ACTIONS(6288),
    [anon_sym_let] = ACTIONS(6288),
    [anon_sym_let_BANG] = ACTIONS(6286),
    [anon_sym_LPAREN] = ACTIONS(6288),
    [anon_sym_null] = ACTIONS(6288),
    [anon_sym_AMP] = ACTIONS(6288),
    [anon_sym_LBRACK] = ACTIONS(6288),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6286),
    [anon_sym_LBRACE] = ACTIONS(6288),
    [anon_sym_LT_AT] = ACTIONS(6288),
    [anon_sym_LT_AT_AT] = ACTIONS(6286),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6286),
    [anon_sym_new] = ACTIONS(6288),
    [anon_sym_return_BANG] = ACTIONS(6286),
    [anon_sym_yield] = ACTIONS(6288),
    [anon_sym_yield_BANG] = ACTIONS(6286),
    [anon_sym_lazy] = ACTIONS(6288),
    [anon_sym_assert] = ACTIONS(6288),
    [anon_sym_upcast] = ACTIONS(6288),
    [anon_sym_downcast] = ACTIONS(6288),
    [anon_sym_for] = ACTIONS(6288),
    [anon_sym_while] = ACTIONS(6288),
    [anon_sym_if] = ACTIONS(6288),
    [anon_sym_fun] = ACTIONS(6288),
    [anon_sym_try] = ACTIONS(6288),
    [anon_sym_match] = ACTIONS(6288),
    [anon_sym_match_BANG] = ACTIONS(6286),
    [anon_sym_function] = ACTIONS(6288),
    [anon_sym_use] = ACTIONS(6288),
    [anon_sym_use_BANG] = ACTIONS(6286),
    [anon_sym_do_BANG] = ACTIONS(6286),
    [anon_sym_begin] = ACTIONS(6288),
    [aux_sym_char_token1] = ACTIONS(6286),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6288),
    [anon_sym_DQUOTE] = ACTIONS(6288),
    [anon_sym_AT_DQUOTE] = ACTIONS(6286),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6286),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6286),
    [sym_bool] = ACTIONS(6288),
    [sym_unit] = ACTIONS(6286),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6288),
    [sym_op_identifier] = ACTIONS(6286),
    [anon_sym_PLUS] = ACTIONS(6288),
    [anon_sym_DASH] = ACTIONS(6288),
    [anon_sym_PLUS_DOT] = ACTIONS(6286),
    [anon_sym_DASH_DOT] = ACTIONS(6286),
    [anon_sym_PERCENT] = ACTIONS(6286),
    [anon_sym_AMP_AMP] = ACTIONS(6286),
    [anon_sym_TILDE] = ACTIONS(6286),
    [aux_sym_prefix_op_token1] = ACTIONS(6286),
    [sym_int] = ACTIONS(6288),
    [sym_xint] = ACTIONS(6286),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6286),
    [anon_sym_POUNDendif] = ACTIONS(6286),
    [anon_sym_POUNDelse] = ACTIONS(6286),
  },
  [4260] = {
    [sym_block_comment] = STATE(4260),
    [sym_compiler_directive_decl] = STATE(4260),
    [sym_fsi_directive_decl] = STATE(4260),
    [sym_preproc_line] = STATE(4260),
    [sym_identifier] = ACTIONS(3996),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_do] = ACTIONS(3996),
    [anon_sym_let] = ACTIONS(3996),
    [anon_sym_let_BANG] = ACTIONS(3994),
    [anon_sym_LPAREN] = ACTIONS(3996),
    [anon_sym_COMMA] = ACTIONS(3994),
    [anon_sym_null] = ACTIONS(3996),
    [anon_sym_AMP] = ACTIONS(3996),
    [anon_sym_LBRACK] = ACTIONS(3996),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3994),
    [anon_sym_LBRACE] = ACTIONS(3996),
    [anon_sym_LT_AT] = ACTIONS(3996),
    [anon_sym_LT_AT_AT] = ACTIONS(3994),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3994),
    [anon_sym_new] = ACTIONS(3996),
    [anon_sym_return_BANG] = ACTIONS(3994),
    [anon_sym_yield] = ACTIONS(3996),
    [anon_sym_yield_BANG] = ACTIONS(3994),
    [anon_sym_lazy] = ACTIONS(3996),
    [anon_sym_assert] = ACTIONS(3996),
    [anon_sym_upcast] = ACTIONS(3996),
    [anon_sym_downcast] = ACTIONS(3996),
    [anon_sym_for] = ACTIONS(3996),
    [anon_sym_while] = ACTIONS(3996),
    [anon_sym_if] = ACTIONS(3996),
    [anon_sym_fun] = ACTIONS(3996),
    [anon_sym_try] = ACTIONS(3996),
    [anon_sym_match] = ACTIONS(3996),
    [anon_sym_match_BANG] = ACTIONS(3994),
    [anon_sym_function] = ACTIONS(3996),
    [anon_sym_GT] = ACTIONS(3994),
    [anon_sym_use] = ACTIONS(3996),
    [anon_sym_use_BANG] = ACTIONS(3994),
    [anon_sym_do_BANG] = ACTIONS(3994),
    [anon_sym_begin] = ACTIONS(3996),
    [aux_sym_char_token1] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3996),
    [anon_sym_DQUOTE] = ACTIONS(3996),
    [anon_sym_AT_DQUOTE] = ACTIONS(3994),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3994),
    [sym_bool] = ACTIONS(3996),
    [sym_unit] = ACTIONS(3994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3996),
    [sym_op_identifier] = ACTIONS(3994),
    [anon_sym_PLUS] = ACTIONS(3996),
    [anon_sym_DASH] = ACTIONS(3996),
    [anon_sym_PLUS_DOT] = ACTIONS(3994),
    [anon_sym_DASH_DOT] = ACTIONS(3994),
    [anon_sym_PERCENT] = ACTIONS(3994),
    [anon_sym_AMP_AMP] = ACTIONS(3994),
    [anon_sym_TILDE] = ACTIONS(3994),
    [aux_sym_prefix_op_token1] = ACTIONS(3994),
    [sym_int] = ACTIONS(3996),
    [sym_xint] = ACTIONS(3994),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3994),
  },
  [4261] = {
    [sym_block_comment] = STATE(4261),
    [sym_compiler_directive_decl] = STATE(4261),
    [sym_fsi_directive_decl] = STATE(4261),
    [sym_preproc_line] = STATE(4261),
    [sym_identifier] = ACTIONS(6288),
    [anon_sym_return] = ACTIONS(6288),
    [anon_sym_do] = ACTIONS(6288),
    [anon_sym_let] = ACTIONS(6288),
    [anon_sym_let_BANG] = ACTIONS(6286),
    [anon_sym_LPAREN] = ACTIONS(6288),
    [anon_sym_null] = ACTIONS(6288),
    [anon_sym_AMP] = ACTIONS(6288),
    [anon_sym_LBRACK] = ACTIONS(6288),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6286),
    [anon_sym_LBRACE] = ACTIONS(6288),
    [anon_sym_LT_AT] = ACTIONS(6288),
    [anon_sym_LT_AT_AT] = ACTIONS(6286),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6286),
    [anon_sym_new] = ACTIONS(6288),
    [anon_sym_return_BANG] = ACTIONS(6286),
    [anon_sym_yield] = ACTIONS(6288),
    [anon_sym_yield_BANG] = ACTIONS(6286),
    [anon_sym_lazy] = ACTIONS(6288),
    [anon_sym_assert] = ACTIONS(6288),
    [anon_sym_upcast] = ACTIONS(6288),
    [anon_sym_downcast] = ACTIONS(6288),
    [anon_sym_for] = ACTIONS(6288),
    [anon_sym_while] = ACTIONS(6288),
    [anon_sym_if] = ACTIONS(6288),
    [anon_sym_fun] = ACTIONS(6288),
    [anon_sym_try] = ACTIONS(6288),
    [anon_sym_match] = ACTIONS(6288),
    [anon_sym_match_BANG] = ACTIONS(6286),
    [anon_sym_function] = ACTIONS(6288),
    [anon_sym_use] = ACTIONS(6288),
    [anon_sym_use_BANG] = ACTIONS(6286),
    [anon_sym_do_BANG] = ACTIONS(6286),
    [anon_sym_begin] = ACTIONS(6288),
    [aux_sym_char_token1] = ACTIONS(6286),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6288),
    [anon_sym_DQUOTE] = ACTIONS(6288),
    [anon_sym_AT_DQUOTE] = ACTIONS(6286),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6286),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6286),
    [sym_bool] = ACTIONS(6288),
    [sym_unit] = ACTIONS(6286),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6288),
    [sym_op_identifier] = ACTIONS(6286),
    [anon_sym_PLUS] = ACTIONS(6288),
    [anon_sym_DASH] = ACTIONS(6288),
    [anon_sym_PLUS_DOT] = ACTIONS(6286),
    [anon_sym_DASH_DOT] = ACTIONS(6286),
    [anon_sym_PERCENT] = ACTIONS(6286),
    [anon_sym_AMP_AMP] = ACTIONS(6286),
    [anon_sym_TILDE] = ACTIONS(6286),
    [aux_sym_prefix_op_token1] = ACTIONS(6286),
    [sym_int] = ACTIONS(6288),
    [sym_xint] = ACTIONS(6286),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6286),
    [sym__newline] = ACTIONS(6286),
    [sym__dedent] = ACTIONS(6286),
  },
  [4262] = {
    [sym_block_comment] = STATE(4262),
    [sym_compiler_directive_decl] = STATE(4262),
    [sym_fsi_directive_decl] = STATE(4262),
    [sym_preproc_line] = STATE(4262),
    [sym_identifier] = ACTIONS(3935),
    [anon_sym_return] = ACTIONS(3935),
    [anon_sym_do] = ACTIONS(3935),
    [anon_sym_let] = ACTIONS(3935),
    [anon_sym_let_BANG] = ACTIONS(3933),
    [anon_sym_LPAREN] = ACTIONS(3935),
    [anon_sym_COMMA] = ACTIONS(3933),
    [anon_sym_null] = ACTIONS(3935),
    [anon_sym_AMP] = ACTIONS(3935),
    [anon_sym_LBRACK] = ACTIONS(3935),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3933),
    [anon_sym_LBRACE] = ACTIONS(3935),
    [anon_sym_LT_AT] = ACTIONS(3935),
    [anon_sym_LT_AT_AT] = ACTIONS(3933),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3933),
    [anon_sym_new] = ACTIONS(3935),
    [anon_sym_return_BANG] = ACTIONS(3933),
    [anon_sym_yield] = ACTIONS(3935),
    [anon_sym_yield_BANG] = ACTIONS(3933),
    [anon_sym_lazy] = ACTIONS(3935),
    [anon_sym_assert] = ACTIONS(3935),
    [anon_sym_upcast] = ACTIONS(3935),
    [anon_sym_downcast] = ACTIONS(3935),
    [anon_sym_for] = ACTIONS(3935),
    [anon_sym_while] = ACTIONS(3935),
    [anon_sym_if] = ACTIONS(3935),
    [anon_sym_fun] = ACTIONS(3935),
    [anon_sym_try] = ACTIONS(3935),
    [anon_sym_match] = ACTIONS(3935),
    [anon_sym_match_BANG] = ACTIONS(3933),
    [anon_sym_function] = ACTIONS(3935),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_use] = ACTIONS(3935),
    [anon_sym_use_BANG] = ACTIONS(3933),
    [anon_sym_do_BANG] = ACTIONS(3933),
    [anon_sym_begin] = ACTIONS(3935),
    [aux_sym_char_token1] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3935),
    [anon_sym_DQUOTE] = ACTIONS(3935),
    [anon_sym_AT_DQUOTE] = ACTIONS(3933),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3933),
    [sym_bool] = ACTIONS(3935),
    [sym_unit] = ACTIONS(3933),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3935),
    [sym_op_identifier] = ACTIONS(3933),
    [anon_sym_PLUS] = ACTIONS(3935),
    [anon_sym_DASH] = ACTIONS(3935),
    [anon_sym_PLUS_DOT] = ACTIONS(3933),
    [anon_sym_DASH_DOT] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3933),
    [anon_sym_TILDE] = ACTIONS(3933),
    [aux_sym_prefix_op_token1] = ACTIONS(3933),
    [sym_int] = ACTIONS(3935),
    [sym_xint] = ACTIONS(3933),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3933),
  },
  [4263] = {
    [sym_block_comment] = STATE(4263),
    [sym_compiler_directive_decl] = STATE(4263),
    [sym_fsi_directive_decl] = STATE(4263),
    [sym_preproc_line] = STATE(4263),
    [sym_identifier] = ACTIONS(3972),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_do] = ACTIONS(3972),
    [anon_sym_let] = ACTIONS(3972),
    [anon_sym_let_BANG] = ACTIONS(3970),
    [anon_sym_LPAREN] = ACTIONS(3972),
    [anon_sym_COMMA] = ACTIONS(3970),
    [anon_sym_null] = ACTIONS(3972),
    [anon_sym_AMP] = ACTIONS(3972),
    [anon_sym_LBRACK] = ACTIONS(3972),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3970),
    [anon_sym_LBRACE] = ACTIONS(3972),
    [anon_sym_LT_AT] = ACTIONS(3972),
    [anon_sym_LT_AT_AT] = ACTIONS(3970),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3970),
    [anon_sym_new] = ACTIONS(3972),
    [anon_sym_return_BANG] = ACTIONS(3970),
    [anon_sym_yield] = ACTIONS(3972),
    [anon_sym_yield_BANG] = ACTIONS(3970),
    [anon_sym_lazy] = ACTIONS(3972),
    [anon_sym_assert] = ACTIONS(3972),
    [anon_sym_upcast] = ACTIONS(3972),
    [anon_sym_downcast] = ACTIONS(3972),
    [anon_sym_for] = ACTIONS(3972),
    [anon_sym_while] = ACTIONS(3972),
    [anon_sym_if] = ACTIONS(3972),
    [anon_sym_fun] = ACTIONS(3972),
    [anon_sym_try] = ACTIONS(3972),
    [anon_sym_match] = ACTIONS(3972),
    [anon_sym_match_BANG] = ACTIONS(3970),
    [anon_sym_function] = ACTIONS(3972),
    [anon_sym_GT] = ACTIONS(3970),
    [anon_sym_use] = ACTIONS(3972),
    [anon_sym_use_BANG] = ACTIONS(3970),
    [anon_sym_do_BANG] = ACTIONS(3970),
    [anon_sym_begin] = ACTIONS(3972),
    [aux_sym_char_token1] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3972),
    [anon_sym_DQUOTE] = ACTIONS(3972),
    [anon_sym_AT_DQUOTE] = ACTIONS(3970),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3970),
    [sym_bool] = ACTIONS(3972),
    [sym_unit] = ACTIONS(3970),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3972),
    [sym_op_identifier] = ACTIONS(3970),
    [anon_sym_PLUS] = ACTIONS(3972),
    [anon_sym_DASH] = ACTIONS(3972),
    [anon_sym_PLUS_DOT] = ACTIONS(3970),
    [anon_sym_DASH_DOT] = ACTIONS(3970),
    [anon_sym_PERCENT] = ACTIONS(3970),
    [anon_sym_AMP_AMP] = ACTIONS(3970),
    [anon_sym_TILDE] = ACTIONS(3970),
    [aux_sym_prefix_op_token1] = ACTIONS(3970),
    [sym_int] = ACTIONS(3972),
    [sym_xint] = ACTIONS(3970),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3970),
  },
  [4264] = {
    [sym_block_comment] = STATE(4264),
    [sym_compiler_directive_decl] = STATE(4264),
    [sym_fsi_directive_decl] = STATE(4264),
    [sym_preproc_line] = STATE(4264),
    [sym_identifier] = ACTIONS(6428),
    [anon_sym_return] = ACTIONS(6428),
    [anon_sym_do] = ACTIONS(6428),
    [anon_sym_and] = ACTIONS(6428),
    [anon_sym_let] = ACTIONS(6428),
    [anon_sym_let_BANG] = ACTIONS(6426),
    [anon_sym_LPAREN] = ACTIONS(6428),
    [anon_sym_null] = ACTIONS(6428),
    [anon_sym_AMP] = ACTIONS(6428),
    [anon_sym_LBRACK] = ACTIONS(6428),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6426),
    [anon_sym_LBRACE] = ACTIONS(6428),
    [anon_sym_LT_AT] = ACTIONS(6428),
    [anon_sym_LT_AT_AT] = ACTIONS(6426),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6426),
    [anon_sym_new] = ACTIONS(6428),
    [anon_sym_return_BANG] = ACTIONS(6426),
    [anon_sym_yield] = ACTIONS(6428),
    [anon_sym_yield_BANG] = ACTIONS(6426),
    [anon_sym_lazy] = ACTIONS(6428),
    [anon_sym_assert] = ACTIONS(6428),
    [anon_sym_upcast] = ACTIONS(6428),
    [anon_sym_downcast] = ACTIONS(6428),
    [anon_sym_for] = ACTIONS(6428),
    [anon_sym_while] = ACTIONS(6428),
    [anon_sym_if] = ACTIONS(6428),
    [anon_sym_fun] = ACTIONS(6428),
    [anon_sym_try] = ACTIONS(6428),
    [anon_sym_match] = ACTIONS(6428),
    [anon_sym_match_BANG] = ACTIONS(6426),
    [anon_sym_function] = ACTIONS(6428),
    [anon_sym_use] = ACTIONS(6428),
    [anon_sym_use_BANG] = ACTIONS(6426),
    [anon_sym_do_BANG] = ACTIONS(6426),
    [anon_sym_begin] = ACTIONS(6428),
    [aux_sym_char_token1] = ACTIONS(6426),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6428),
    [anon_sym_DQUOTE] = ACTIONS(6428),
    [anon_sym_AT_DQUOTE] = ACTIONS(6426),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6426),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6426),
    [sym_bool] = ACTIONS(6428),
    [sym_unit] = ACTIONS(6426),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6428),
    [sym_op_identifier] = ACTIONS(6426),
    [anon_sym_PLUS] = ACTIONS(6428),
    [anon_sym_DASH] = ACTIONS(6428),
    [anon_sym_PLUS_DOT] = ACTIONS(6426),
    [anon_sym_DASH_DOT] = ACTIONS(6426),
    [anon_sym_PERCENT] = ACTIONS(6426),
    [anon_sym_AMP_AMP] = ACTIONS(6426),
    [anon_sym_TILDE] = ACTIONS(6426),
    [aux_sym_prefix_op_token1] = ACTIONS(6426),
    [sym_int] = ACTIONS(6428),
    [sym_xint] = ACTIONS(6426),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6426),
    [anon_sym_POUNDendif] = ACTIONS(6426),
  },
  [4265] = {
    [sym_block_comment] = STATE(4265),
    [sym_compiler_directive_decl] = STATE(4265),
    [sym_fsi_directive_decl] = STATE(4265),
    [sym_preproc_line] = STATE(4265),
    [sym_identifier] = ACTIONS(3946),
    [anon_sym_return] = ACTIONS(3946),
    [anon_sym_do] = ACTIONS(3946),
    [anon_sym_let] = ACTIONS(3946),
    [anon_sym_let_BANG] = ACTIONS(3944),
    [anon_sym_LPAREN] = ACTIONS(3946),
    [anon_sym_COMMA] = ACTIONS(3944),
    [anon_sym_null] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LBRACK] = ACTIONS(3946),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3944),
    [anon_sym_LBRACE] = ACTIONS(3946),
    [anon_sym_LT_AT] = ACTIONS(3946),
    [anon_sym_LT_AT_AT] = ACTIONS(3944),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3944),
    [anon_sym_new] = ACTIONS(3946),
    [anon_sym_return_BANG] = ACTIONS(3944),
    [anon_sym_yield] = ACTIONS(3946),
    [anon_sym_yield_BANG] = ACTIONS(3944),
    [anon_sym_lazy] = ACTIONS(3946),
    [anon_sym_assert] = ACTIONS(3946),
    [anon_sym_upcast] = ACTIONS(3946),
    [anon_sym_downcast] = ACTIONS(3946),
    [anon_sym_for] = ACTIONS(3946),
    [anon_sym_while] = ACTIONS(3946),
    [anon_sym_if] = ACTIONS(3946),
    [anon_sym_fun] = ACTIONS(3946),
    [anon_sym_try] = ACTIONS(3946),
    [anon_sym_match] = ACTIONS(3946),
    [anon_sym_match_BANG] = ACTIONS(3944),
    [anon_sym_function] = ACTIONS(3946),
    [anon_sym_GT] = ACTIONS(3944),
    [anon_sym_use] = ACTIONS(3946),
    [anon_sym_use_BANG] = ACTIONS(3944),
    [anon_sym_do_BANG] = ACTIONS(3944),
    [anon_sym_begin] = ACTIONS(3946),
    [aux_sym_char_token1] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_AT_DQUOTE] = ACTIONS(3944),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3944),
    [sym_bool] = ACTIONS(3946),
    [sym_unit] = ACTIONS(3944),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3946),
    [sym_op_identifier] = ACTIONS(3944),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_PLUS_DOT] = ACTIONS(3944),
    [anon_sym_DASH_DOT] = ACTIONS(3944),
    [anon_sym_PERCENT] = ACTIONS(3944),
    [anon_sym_AMP_AMP] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(3944),
    [aux_sym_prefix_op_token1] = ACTIONS(3944),
    [sym_int] = ACTIONS(3946),
    [sym_xint] = ACTIONS(3944),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3944),
  },
  [4266] = {
    [sym_block_comment] = STATE(4266),
    [sym_compiler_directive_decl] = STATE(4266),
    [sym_fsi_directive_decl] = STATE(4266),
    [sym_preproc_line] = STATE(4266),
    [sym_identifier] = ACTIONS(3927),
    [anon_sym_return] = ACTIONS(3927),
    [anon_sym_do] = ACTIONS(3927),
    [anon_sym_let] = ACTIONS(3927),
    [anon_sym_let_BANG] = ACTIONS(3925),
    [anon_sym_LPAREN] = ACTIONS(3927),
    [anon_sym_COMMA] = ACTIONS(3925),
    [anon_sym_null] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3925),
    [anon_sym_LBRACE] = ACTIONS(3927),
    [anon_sym_LT_AT] = ACTIONS(3927),
    [anon_sym_LT_AT_AT] = ACTIONS(3925),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3925),
    [anon_sym_new] = ACTIONS(3927),
    [anon_sym_return_BANG] = ACTIONS(3925),
    [anon_sym_yield] = ACTIONS(3927),
    [anon_sym_yield_BANG] = ACTIONS(3925),
    [anon_sym_lazy] = ACTIONS(3927),
    [anon_sym_assert] = ACTIONS(3927),
    [anon_sym_upcast] = ACTIONS(3927),
    [anon_sym_downcast] = ACTIONS(3927),
    [anon_sym_for] = ACTIONS(3927),
    [anon_sym_while] = ACTIONS(3927),
    [anon_sym_if] = ACTIONS(3927),
    [anon_sym_fun] = ACTIONS(3927),
    [anon_sym_try] = ACTIONS(3927),
    [anon_sym_match] = ACTIONS(3927),
    [anon_sym_match_BANG] = ACTIONS(3925),
    [anon_sym_function] = ACTIONS(3927),
    [anon_sym_GT] = ACTIONS(3925),
    [anon_sym_use] = ACTIONS(3927),
    [anon_sym_use_BANG] = ACTIONS(3925),
    [anon_sym_do_BANG] = ACTIONS(3925),
    [anon_sym_begin] = ACTIONS(3927),
    [aux_sym_char_token1] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_AT_DQUOTE] = ACTIONS(3925),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3925),
    [sym_bool] = ACTIONS(3927),
    [sym_unit] = ACTIONS(3925),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3927),
    [sym_op_identifier] = ACTIONS(3925),
    [anon_sym_PLUS] = ACTIONS(3927),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_PLUS_DOT] = ACTIONS(3925),
    [anon_sym_DASH_DOT] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_TILDE] = ACTIONS(3925),
    [aux_sym_prefix_op_token1] = ACTIONS(3925),
    [sym_int] = ACTIONS(3927),
    [sym_xint] = ACTIONS(3925),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3925),
  },
  [4267] = {
    [sym_block_comment] = STATE(4267),
    [sym_compiler_directive_decl] = STATE(4267),
    [sym_fsi_directive_decl] = STATE(4267),
    [sym_preproc_line] = STATE(4267),
    [sym_identifier] = ACTIONS(6318),
    [anon_sym_return] = ACTIONS(6318),
    [anon_sym_do] = ACTIONS(6318),
    [anon_sym_and] = ACTIONS(6318),
    [anon_sym_let] = ACTIONS(6318),
    [anon_sym_let_BANG] = ACTIONS(6316),
    [anon_sym_LPAREN] = ACTIONS(6318),
    [anon_sym_null] = ACTIONS(6318),
    [anon_sym_AMP] = ACTIONS(6318),
    [anon_sym_LBRACK] = ACTIONS(6318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6316),
    [anon_sym_LBRACE] = ACTIONS(6318),
    [anon_sym_LT_AT] = ACTIONS(6318),
    [anon_sym_LT_AT_AT] = ACTIONS(6316),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6316),
    [anon_sym_new] = ACTIONS(6318),
    [anon_sym_return_BANG] = ACTIONS(6316),
    [anon_sym_yield] = ACTIONS(6318),
    [anon_sym_yield_BANG] = ACTIONS(6316),
    [anon_sym_lazy] = ACTIONS(6318),
    [anon_sym_assert] = ACTIONS(6318),
    [anon_sym_upcast] = ACTIONS(6318),
    [anon_sym_downcast] = ACTIONS(6318),
    [anon_sym_for] = ACTIONS(6318),
    [anon_sym_while] = ACTIONS(6318),
    [anon_sym_if] = ACTIONS(6318),
    [anon_sym_fun] = ACTIONS(6318),
    [anon_sym_try] = ACTIONS(6318),
    [anon_sym_match] = ACTIONS(6318),
    [anon_sym_match_BANG] = ACTIONS(6316),
    [anon_sym_function] = ACTIONS(6318),
    [anon_sym_use] = ACTIONS(6318),
    [anon_sym_use_BANG] = ACTIONS(6316),
    [anon_sym_do_BANG] = ACTIONS(6316),
    [anon_sym_begin] = ACTIONS(6318),
    [aux_sym_char_token1] = ACTIONS(6316),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6318),
    [anon_sym_DQUOTE] = ACTIONS(6318),
    [anon_sym_AT_DQUOTE] = ACTIONS(6316),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6316),
    [sym_bool] = ACTIONS(6318),
    [sym_unit] = ACTIONS(6316),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6318),
    [sym_op_identifier] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6318),
    [anon_sym_DASH] = ACTIONS(6318),
    [anon_sym_PLUS_DOT] = ACTIONS(6316),
    [anon_sym_DASH_DOT] = ACTIONS(6316),
    [anon_sym_PERCENT] = ACTIONS(6316),
    [anon_sym_AMP_AMP] = ACTIONS(6316),
    [anon_sym_TILDE] = ACTIONS(6316),
    [aux_sym_prefix_op_token1] = ACTIONS(6316),
    [sym_int] = ACTIONS(6318),
    [sym_xint] = ACTIONS(6316),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6316),
    [anon_sym_POUNDendif] = ACTIONS(6316),
  },
  [4268] = {
    [sym_block_comment] = STATE(4268),
    [sym_compiler_directive_decl] = STATE(4268),
    [sym_fsi_directive_decl] = STATE(4268),
    [sym_preproc_line] = STATE(4268),
    [sym_identifier] = ACTIONS(6458),
    [anon_sym_return] = ACTIONS(6458),
    [anon_sym_do] = ACTIONS(6458),
    [anon_sym_let] = ACTIONS(6458),
    [anon_sym_let_BANG] = ACTIONS(6456),
    [anon_sym_LPAREN] = ACTIONS(6458),
    [anon_sym_null] = ACTIONS(6458),
    [anon_sym_AMP] = ACTIONS(6458),
    [anon_sym_LBRACK] = ACTIONS(6458),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6456),
    [anon_sym_LBRACE] = ACTIONS(6458),
    [anon_sym_LT_AT] = ACTIONS(6458),
    [anon_sym_LT_AT_AT] = ACTIONS(6456),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6456),
    [anon_sym_new] = ACTIONS(6458),
    [anon_sym_return_BANG] = ACTIONS(6456),
    [anon_sym_yield] = ACTIONS(6458),
    [anon_sym_yield_BANG] = ACTIONS(6456),
    [anon_sym_lazy] = ACTIONS(6458),
    [anon_sym_assert] = ACTIONS(6458),
    [anon_sym_upcast] = ACTIONS(6458),
    [anon_sym_downcast] = ACTIONS(6458),
    [anon_sym_for] = ACTIONS(6458),
    [anon_sym_while] = ACTIONS(6458),
    [anon_sym_if] = ACTIONS(6458),
    [anon_sym_fun] = ACTIONS(6458),
    [anon_sym_try] = ACTIONS(6458),
    [anon_sym_match] = ACTIONS(6458),
    [anon_sym_match_BANG] = ACTIONS(6456),
    [anon_sym_function] = ACTIONS(6458),
    [anon_sym_use] = ACTIONS(6458),
    [anon_sym_use_BANG] = ACTIONS(6456),
    [anon_sym_do_BANG] = ACTIONS(6456),
    [anon_sym_begin] = ACTIONS(6458),
    [aux_sym_char_token1] = ACTIONS(6456),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6458),
    [anon_sym_DQUOTE] = ACTIONS(6458),
    [anon_sym_AT_DQUOTE] = ACTIONS(6456),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6456),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6456),
    [sym_bool] = ACTIONS(6458),
    [sym_unit] = ACTIONS(6456),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6458),
    [sym_op_identifier] = ACTIONS(6456),
    [anon_sym_PLUS] = ACTIONS(6458),
    [anon_sym_DASH] = ACTIONS(6458),
    [anon_sym_PLUS_DOT] = ACTIONS(6456),
    [anon_sym_DASH_DOT] = ACTIONS(6456),
    [anon_sym_PERCENT] = ACTIONS(6456),
    [anon_sym_AMP_AMP] = ACTIONS(6456),
    [anon_sym_TILDE] = ACTIONS(6456),
    [aux_sym_prefix_op_token1] = ACTIONS(6456),
    [sym_int] = ACTIONS(6458),
    [sym_xint] = ACTIONS(6456),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6456),
    [sym__newline] = ACTIONS(6456),
    [sym__dedent] = ACTIONS(6456),
  },
  [4269] = {
    [sym_block_comment] = STATE(4269),
    [sym_compiler_directive_decl] = STATE(4269),
    [sym_fsi_directive_decl] = STATE(4269),
    [sym_preproc_line] = STATE(4269),
    [sym_identifier] = ACTIONS(3976),
    [anon_sym_return] = ACTIONS(3976),
    [anon_sym_do] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3976),
    [anon_sym_let_BANG] = ACTIONS(3974),
    [anon_sym_LPAREN] = ACTIONS(3976),
    [anon_sym_COMMA] = ACTIONS(3974),
    [anon_sym_null] = ACTIONS(3976),
    [anon_sym_AMP] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(3976),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3974),
    [anon_sym_LBRACE] = ACTIONS(3976),
    [anon_sym_LT_AT] = ACTIONS(3976),
    [anon_sym_LT_AT_AT] = ACTIONS(3974),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3974),
    [anon_sym_new] = ACTIONS(3976),
    [anon_sym_return_BANG] = ACTIONS(3974),
    [anon_sym_yield] = ACTIONS(3976),
    [anon_sym_yield_BANG] = ACTIONS(3974),
    [anon_sym_lazy] = ACTIONS(3976),
    [anon_sym_assert] = ACTIONS(3976),
    [anon_sym_upcast] = ACTIONS(3976),
    [anon_sym_downcast] = ACTIONS(3976),
    [anon_sym_for] = ACTIONS(3976),
    [anon_sym_while] = ACTIONS(3976),
    [anon_sym_if] = ACTIONS(3976),
    [anon_sym_fun] = ACTIONS(3976),
    [anon_sym_try] = ACTIONS(3976),
    [anon_sym_match] = ACTIONS(3976),
    [anon_sym_match_BANG] = ACTIONS(3974),
    [anon_sym_function] = ACTIONS(3976),
    [anon_sym_GT] = ACTIONS(3974),
    [anon_sym_use] = ACTIONS(3976),
    [anon_sym_use_BANG] = ACTIONS(3974),
    [anon_sym_do_BANG] = ACTIONS(3974),
    [anon_sym_begin] = ACTIONS(3976),
    [aux_sym_char_token1] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3976),
    [anon_sym_DQUOTE] = ACTIONS(3976),
    [anon_sym_AT_DQUOTE] = ACTIONS(3974),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3974),
    [sym_bool] = ACTIONS(3976),
    [sym_unit] = ACTIONS(3974),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3976),
    [sym_op_identifier] = ACTIONS(3974),
    [anon_sym_PLUS] = ACTIONS(3976),
    [anon_sym_DASH] = ACTIONS(3976),
    [anon_sym_PLUS_DOT] = ACTIONS(3974),
    [anon_sym_DASH_DOT] = ACTIONS(3974),
    [anon_sym_PERCENT] = ACTIONS(3974),
    [anon_sym_AMP_AMP] = ACTIONS(3974),
    [anon_sym_TILDE] = ACTIONS(3974),
    [aux_sym_prefix_op_token1] = ACTIONS(3974),
    [sym_int] = ACTIONS(3976),
    [sym_xint] = ACTIONS(3974),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3974),
  },
  [4270] = {
    [sym_block_comment] = STATE(4270),
    [sym_compiler_directive_decl] = STATE(4270),
    [sym_fsi_directive_decl] = STATE(4270),
    [sym_preproc_line] = STATE(4270),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_and] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3698),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3698),
    [anon_sym_DASH_DOT] = ACTIONS(3698),
    [anon_sym_PERCENT] = ACTIONS(3698),
    [anon_sym_AMP_AMP] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3698),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [anon_sym_POUNDendif] = ACTIONS(3698),
  },
  [4271] = {
    [sym_block_comment] = STATE(4271),
    [sym_compiler_directive_decl] = STATE(4271),
    [sym_fsi_directive_decl] = STATE(4271),
    [sym_preproc_line] = STATE(4271),
    [sym_identifier] = ACTIONS(6302),
    [anon_sym_return] = ACTIONS(6302),
    [anon_sym_do] = ACTIONS(6302),
    [anon_sym_let] = ACTIONS(6302),
    [anon_sym_let_BANG] = ACTIONS(6300),
    [anon_sym_LPAREN] = ACTIONS(6302),
    [anon_sym_null] = ACTIONS(6302),
    [anon_sym_AMP] = ACTIONS(6302),
    [anon_sym_LBRACK] = ACTIONS(6302),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6300),
    [anon_sym_LBRACE] = ACTIONS(6302),
    [anon_sym_LT_AT] = ACTIONS(6302),
    [anon_sym_LT_AT_AT] = ACTIONS(6300),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6300),
    [anon_sym_new] = ACTIONS(6302),
    [anon_sym_return_BANG] = ACTIONS(6300),
    [anon_sym_yield] = ACTIONS(6302),
    [anon_sym_yield_BANG] = ACTIONS(6300),
    [anon_sym_lazy] = ACTIONS(6302),
    [anon_sym_assert] = ACTIONS(6302),
    [anon_sym_upcast] = ACTIONS(6302),
    [anon_sym_downcast] = ACTIONS(6302),
    [anon_sym_for] = ACTIONS(6302),
    [anon_sym_while] = ACTIONS(6302),
    [anon_sym_if] = ACTIONS(6302),
    [anon_sym_fun] = ACTIONS(6302),
    [anon_sym_try] = ACTIONS(6302),
    [anon_sym_match] = ACTIONS(6302),
    [anon_sym_match_BANG] = ACTIONS(6300),
    [anon_sym_function] = ACTIONS(6302),
    [anon_sym_use] = ACTIONS(6302),
    [anon_sym_use_BANG] = ACTIONS(6300),
    [anon_sym_do_BANG] = ACTIONS(6300),
    [anon_sym_begin] = ACTIONS(6302),
    [aux_sym_char_token1] = ACTIONS(6300),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6302),
    [anon_sym_DQUOTE] = ACTIONS(6302),
    [anon_sym_AT_DQUOTE] = ACTIONS(6300),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6300),
    [sym_bool] = ACTIONS(6302),
    [sym_unit] = ACTIONS(6300),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6302),
    [sym_op_identifier] = ACTIONS(6300),
    [anon_sym_PLUS] = ACTIONS(6302),
    [anon_sym_DASH] = ACTIONS(6302),
    [anon_sym_PLUS_DOT] = ACTIONS(6300),
    [anon_sym_DASH_DOT] = ACTIONS(6300),
    [anon_sym_PERCENT] = ACTIONS(6300),
    [anon_sym_AMP_AMP] = ACTIONS(6300),
    [anon_sym_TILDE] = ACTIONS(6300),
    [aux_sym_prefix_op_token1] = ACTIONS(6300),
    [sym_int] = ACTIONS(6302),
    [sym_xint] = ACTIONS(6300),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6300),
    [sym__newline] = ACTIONS(6300),
    [sym__dedent] = ACTIONS(6300),
  },
  [4272] = {
    [sym_block_comment] = STATE(4272),
    [sym_compiler_directive_decl] = STATE(4272),
    [sym_fsi_directive_decl] = STATE(4272),
    [sym_preproc_line] = STATE(4272),
    [sym_identifier] = ACTIONS(4104),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_do] = ACTIONS(4104),
    [anon_sym_let] = ACTIONS(4104),
    [anon_sym_let_BANG] = ACTIONS(4102),
    [anon_sym_LPAREN] = ACTIONS(4104),
    [anon_sym_COMMA] = ACTIONS(4102),
    [anon_sym_null] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4104),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4102),
    [anon_sym_LBRACE] = ACTIONS(4104),
    [anon_sym_LT_AT] = ACTIONS(4104),
    [anon_sym_LT_AT_AT] = ACTIONS(4102),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4102),
    [anon_sym_new] = ACTIONS(4104),
    [anon_sym_return_BANG] = ACTIONS(4102),
    [anon_sym_yield] = ACTIONS(4104),
    [anon_sym_yield_BANG] = ACTIONS(4102),
    [anon_sym_lazy] = ACTIONS(4104),
    [anon_sym_assert] = ACTIONS(4104),
    [anon_sym_upcast] = ACTIONS(4104),
    [anon_sym_downcast] = ACTIONS(4104),
    [anon_sym_for] = ACTIONS(4104),
    [anon_sym_while] = ACTIONS(4104),
    [anon_sym_if] = ACTIONS(4104),
    [anon_sym_fun] = ACTIONS(4104),
    [anon_sym_try] = ACTIONS(4104),
    [anon_sym_match] = ACTIONS(4104),
    [anon_sym_match_BANG] = ACTIONS(4102),
    [anon_sym_function] = ACTIONS(4104),
    [anon_sym_GT] = ACTIONS(4102),
    [anon_sym_use] = ACTIONS(4104),
    [anon_sym_use_BANG] = ACTIONS(4102),
    [anon_sym_do_BANG] = ACTIONS(4102),
    [anon_sym_begin] = ACTIONS(4104),
    [aux_sym_char_token1] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4104),
    [anon_sym_DQUOTE] = ACTIONS(4104),
    [anon_sym_AT_DQUOTE] = ACTIONS(4102),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4102),
    [sym_bool] = ACTIONS(4104),
    [sym_unit] = ACTIONS(4102),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4104),
    [sym_op_identifier] = ACTIONS(4102),
    [anon_sym_PLUS] = ACTIONS(4104),
    [anon_sym_DASH] = ACTIONS(4104),
    [anon_sym_PLUS_DOT] = ACTIONS(4102),
    [anon_sym_DASH_DOT] = ACTIONS(4102),
    [anon_sym_PERCENT] = ACTIONS(4102),
    [anon_sym_AMP_AMP] = ACTIONS(4102),
    [anon_sym_TILDE] = ACTIONS(4102),
    [aux_sym_prefix_op_token1] = ACTIONS(4102),
    [sym_int] = ACTIONS(4104),
    [sym_xint] = ACTIONS(4102),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4102),
  },
  [4273] = {
    [sym_block_comment] = STATE(4273),
    [sym_compiler_directive_decl] = STATE(4273),
    [sym_fsi_directive_decl] = STATE(4273),
    [sym_preproc_line] = STATE(4273),
    [sym_identifier] = ACTIONS(6318),
    [anon_sym_return] = ACTIONS(6318),
    [anon_sym_do] = ACTIONS(6318),
    [anon_sym_let] = ACTIONS(6318),
    [anon_sym_let_BANG] = ACTIONS(6316),
    [anon_sym_LPAREN] = ACTIONS(6318),
    [anon_sym_null] = ACTIONS(6318),
    [anon_sym_AMP] = ACTIONS(6318),
    [anon_sym_LBRACK] = ACTIONS(6318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6316),
    [anon_sym_LBRACE] = ACTIONS(6318),
    [anon_sym_LT_AT] = ACTIONS(6318),
    [anon_sym_LT_AT_AT] = ACTIONS(6316),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6316),
    [anon_sym_new] = ACTIONS(6318),
    [anon_sym_return_BANG] = ACTIONS(6316),
    [anon_sym_yield] = ACTIONS(6318),
    [anon_sym_yield_BANG] = ACTIONS(6316),
    [anon_sym_lazy] = ACTIONS(6318),
    [anon_sym_assert] = ACTIONS(6318),
    [anon_sym_upcast] = ACTIONS(6318),
    [anon_sym_downcast] = ACTIONS(6318),
    [anon_sym_for] = ACTIONS(6318),
    [anon_sym_while] = ACTIONS(6318),
    [anon_sym_if] = ACTIONS(6318),
    [anon_sym_fun] = ACTIONS(6318),
    [anon_sym_try] = ACTIONS(6318),
    [anon_sym_match] = ACTIONS(6318),
    [anon_sym_match_BANG] = ACTIONS(6316),
    [anon_sym_function] = ACTIONS(6318),
    [anon_sym_use] = ACTIONS(6318),
    [anon_sym_use_BANG] = ACTIONS(6316),
    [anon_sym_do_BANG] = ACTIONS(6316),
    [anon_sym_begin] = ACTIONS(6318),
    [aux_sym_char_token1] = ACTIONS(6316),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6318),
    [anon_sym_DQUOTE] = ACTIONS(6318),
    [anon_sym_AT_DQUOTE] = ACTIONS(6316),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6316),
    [sym_bool] = ACTIONS(6318),
    [sym_unit] = ACTIONS(6316),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6318),
    [sym_op_identifier] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6318),
    [anon_sym_DASH] = ACTIONS(6318),
    [anon_sym_PLUS_DOT] = ACTIONS(6316),
    [anon_sym_DASH_DOT] = ACTIONS(6316),
    [anon_sym_PERCENT] = ACTIONS(6316),
    [anon_sym_AMP_AMP] = ACTIONS(6316),
    [anon_sym_TILDE] = ACTIONS(6316),
    [aux_sym_prefix_op_token1] = ACTIONS(6316),
    [sym_int] = ACTIONS(6318),
    [sym_xint] = ACTIONS(6316),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6316),
    [anon_sym_POUNDendif] = ACTIONS(6316),
    [anon_sym_POUNDelse] = ACTIONS(6316),
  },
  [4274] = {
    [sym_block_comment] = STATE(4274),
    [sym_compiler_directive_decl] = STATE(4274),
    [sym_fsi_directive_decl] = STATE(4274),
    [sym_preproc_line] = STATE(4274),
    [sym_identifier] = ACTIONS(4064),
    [anon_sym_return] = ACTIONS(4064),
    [anon_sym_do] = ACTIONS(4064),
    [anon_sym_let] = ACTIONS(4064),
    [anon_sym_let_BANG] = ACTIONS(4062),
    [anon_sym_LPAREN] = ACTIONS(4064),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_null] = ACTIONS(4064),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4062),
    [anon_sym_LBRACE] = ACTIONS(4064),
    [anon_sym_LT_AT] = ACTIONS(4064),
    [anon_sym_LT_AT_AT] = ACTIONS(4062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4062),
    [anon_sym_new] = ACTIONS(4064),
    [anon_sym_return_BANG] = ACTIONS(4062),
    [anon_sym_yield] = ACTIONS(4064),
    [anon_sym_yield_BANG] = ACTIONS(4062),
    [anon_sym_lazy] = ACTIONS(4064),
    [anon_sym_assert] = ACTIONS(4064),
    [anon_sym_upcast] = ACTIONS(4064),
    [anon_sym_downcast] = ACTIONS(4064),
    [anon_sym_for] = ACTIONS(4064),
    [anon_sym_while] = ACTIONS(4064),
    [anon_sym_if] = ACTIONS(4064),
    [anon_sym_fun] = ACTIONS(4064),
    [anon_sym_try] = ACTIONS(4064),
    [anon_sym_match] = ACTIONS(4064),
    [anon_sym_match_BANG] = ACTIONS(4062),
    [anon_sym_function] = ACTIONS(4064),
    [anon_sym_GT] = ACTIONS(4062),
    [anon_sym_use] = ACTIONS(4064),
    [anon_sym_use_BANG] = ACTIONS(4062),
    [anon_sym_do_BANG] = ACTIONS(4062),
    [anon_sym_begin] = ACTIONS(4064),
    [aux_sym_char_token1] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_AT_DQUOTE] = ACTIONS(4062),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4062),
    [sym_bool] = ACTIONS(4064),
    [sym_unit] = ACTIONS(4062),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4064),
    [sym_op_identifier] = ACTIONS(4062),
    [anon_sym_PLUS] = ACTIONS(4064),
    [anon_sym_DASH] = ACTIONS(4064),
    [anon_sym_PLUS_DOT] = ACTIONS(4062),
    [anon_sym_DASH_DOT] = ACTIONS(4062),
    [anon_sym_PERCENT] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_TILDE] = ACTIONS(4062),
    [aux_sym_prefix_op_token1] = ACTIONS(4062),
    [sym_int] = ACTIONS(4064),
    [sym_xint] = ACTIONS(4062),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4062),
  },
  [4275] = {
    [sym_block_comment] = STATE(4275),
    [sym_compiler_directive_decl] = STATE(4275),
    [sym_fsi_directive_decl] = STATE(4275),
    [sym_preproc_line] = STATE(4275),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3698),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3698),
    [anon_sym_DASH_DOT] = ACTIONS(3698),
    [anon_sym_PERCENT] = ACTIONS(3698),
    [anon_sym_AMP_AMP] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3698),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [sym__newline] = ACTIONS(3698),
    [sym__dedent] = ACTIONS(3698),
  },
  [4276] = {
    [sym_block_comment] = STATE(4276),
    [sym_compiler_directive_decl] = STATE(4276),
    [sym_fsi_directive_decl] = STATE(4276),
    [sym_preproc_line] = STATE(4276),
    [sym_identifier] = ACTIONS(6302),
    [anon_sym_return] = ACTIONS(6302),
    [anon_sym_do] = ACTIONS(6302),
    [anon_sym_and] = ACTIONS(6302),
    [anon_sym_let] = ACTIONS(6302),
    [anon_sym_let_BANG] = ACTIONS(6300),
    [anon_sym_LPAREN] = ACTIONS(6302),
    [anon_sym_null] = ACTIONS(6302),
    [anon_sym_AMP] = ACTIONS(6302),
    [anon_sym_LBRACK] = ACTIONS(6302),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6300),
    [anon_sym_LBRACE] = ACTIONS(6302),
    [anon_sym_LT_AT] = ACTIONS(6302),
    [anon_sym_LT_AT_AT] = ACTIONS(6300),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6300),
    [anon_sym_new] = ACTIONS(6302),
    [anon_sym_return_BANG] = ACTIONS(6300),
    [anon_sym_yield] = ACTIONS(6302),
    [anon_sym_yield_BANG] = ACTIONS(6300),
    [anon_sym_lazy] = ACTIONS(6302),
    [anon_sym_assert] = ACTIONS(6302),
    [anon_sym_upcast] = ACTIONS(6302),
    [anon_sym_downcast] = ACTIONS(6302),
    [anon_sym_for] = ACTIONS(6302),
    [anon_sym_while] = ACTIONS(6302),
    [anon_sym_if] = ACTIONS(6302),
    [anon_sym_fun] = ACTIONS(6302),
    [anon_sym_try] = ACTIONS(6302),
    [anon_sym_match] = ACTIONS(6302),
    [anon_sym_match_BANG] = ACTIONS(6300),
    [anon_sym_function] = ACTIONS(6302),
    [anon_sym_use] = ACTIONS(6302),
    [anon_sym_use_BANG] = ACTIONS(6300),
    [anon_sym_do_BANG] = ACTIONS(6300),
    [anon_sym_begin] = ACTIONS(6302),
    [aux_sym_char_token1] = ACTIONS(6300),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6302),
    [anon_sym_DQUOTE] = ACTIONS(6302),
    [anon_sym_AT_DQUOTE] = ACTIONS(6300),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6300),
    [sym_bool] = ACTIONS(6302),
    [sym_unit] = ACTIONS(6300),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6302),
    [sym_op_identifier] = ACTIONS(6300),
    [anon_sym_PLUS] = ACTIONS(6302),
    [anon_sym_DASH] = ACTIONS(6302),
    [anon_sym_PLUS_DOT] = ACTIONS(6300),
    [anon_sym_DASH_DOT] = ACTIONS(6300),
    [anon_sym_PERCENT] = ACTIONS(6300),
    [anon_sym_AMP_AMP] = ACTIONS(6300),
    [anon_sym_TILDE] = ACTIONS(6300),
    [aux_sym_prefix_op_token1] = ACTIONS(6300),
    [sym_int] = ACTIONS(6302),
    [sym_xint] = ACTIONS(6300),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6300),
    [anon_sym_POUNDendif] = ACTIONS(6300),
  },
  [4277] = {
    [sym_block_comment] = STATE(4277),
    [sym_compiler_directive_decl] = STATE(4277),
    [sym_fsi_directive_decl] = STATE(4277),
    [sym_preproc_line] = STATE(4277),
    [sym_identifier] = ACTIONS(4130),
    [anon_sym_return] = ACTIONS(4130),
    [anon_sym_do] = ACTIONS(4130),
    [anon_sym_let] = ACTIONS(4130),
    [anon_sym_let_BANG] = ACTIONS(4128),
    [anon_sym_LPAREN] = ACTIONS(4130),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_null] = ACTIONS(4130),
    [anon_sym_AMP] = ACTIONS(4130),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4128),
    [anon_sym_LBRACE] = ACTIONS(4130),
    [anon_sym_LT_AT] = ACTIONS(4130),
    [anon_sym_LT_AT_AT] = ACTIONS(4128),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4128),
    [anon_sym_new] = ACTIONS(4130),
    [anon_sym_return_BANG] = ACTIONS(4128),
    [anon_sym_yield] = ACTIONS(4130),
    [anon_sym_yield_BANG] = ACTIONS(4128),
    [anon_sym_lazy] = ACTIONS(4130),
    [anon_sym_assert] = ACTIONS(4130),
    [anon_sym_upcast] = ACTIONS(4130),
    [anon_sym_downcast] = ACTIONS(4130),
    [anon_sym_for] = ACTIONS(4130),
    [anon_sym_while] = ACTIONS(4130),
    [anon_sym_if] = ACTIONS(4130),
    [anon_sym_fun] = ACTIONS(4130),
    [anon_sym_try] = ACTIONS(4130),
    [anon_sym_match] = ACTIONS(4130),
    [anon_sym_match_BANG] = ACTIONS(4128),
    [anon_sym_function] = ACTIONS(4130),
    [anon_sym_GT] = ACTIONS(4128),
    [anon_sym_use] = ACTIONS(4130),
    [anon_sym_use_BANG] = ACTIONS(4128),
    [anon_sym_do_BANG] = ACTIONS(4128),
    [anon_sym_begin] = ACTIONS(4130),
    [aux_sym_char_token1] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4130),
    [anon_sym_DQUOTE] = ACTIONS(4130),
    [anon_sym_AT_DQUOTE] = ACTIONS(4128),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4128),
    [sym_bool] = ACTIONS(4130),
    [sym_unit] = ACTIONS(4128),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4130),
    [sym_op_identifier] = ACTIONS(4128),
    [anon_sym_PLUS] = ACTIONS(4130),
    [anon_sym_DASH] = ACTIONS(4130),
    [anon_sym_PLUS_DOT] = ACTIONS(4128),
    [anon_sym_DASH_DOT] = ACTIONS(4128),
    [anon_sym_PERCENT] = ACTIONS(4128),
    [anon_sym_AMP_AMP] = ACTIONS(4128),
    [anon_sym_TILDE] = ACTIONS(4128),
    [aux_sym_prefix_op_token1] = ACTIONS(4128),
    [sym_int] = ACTIONS(4130),
    [sym_xint] = ACTIONS(4128),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4128),
  },
  [4278] = {
    [sym_block_comment] = STATE(4278),
    [sym_compiler_directive_decl] = STATE(4278),
    [sym_fsi_directive_decl] = STATE(4278),
    [sym_preproc_line] = STATE(4278),
    [sym_identifier] = ACTIONS(6458),
    [anon_sym_return] = ACTIONS(6458),
    [anon_sym_do] = ACTIONS(6458),
    [anon_sym_let] = ACTIONS(6458),
    [anon_sym_let_BANG] = ACTIONS(6456),
    [anon_sym_LPAREN] = ACTIONS(6458),
    [anon_sym_null] = ACTIONS(6458),
    [anon_sym_AMP] = ACTIONS(6458),
    [anon_sym_LBRACK] = ACTIONS(6458),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6456),
    [anon_sym_LBRACE] = ACTIONS(6458),
    [anon_sym_LT_AT] = ACTIONS(6458),
    [anon_sym_LT_AT_AT] = ACTIONS(6456),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6456),
    [anon_sym_new] = ACTIONS(6458),
    [anon_sym_return_BANG] = ACTIONS(6456),
    [anon_sym_yield] = ACTIONS(6458),
    [anon_sym_yield_BANG] = ACTIONS(6456),
    [anon_sym_lazy] = ACTIONS(6458),
    [anon_sym_assert] = ACTIONS(6458),
    [anon_sym_upcast] = ACTIONS(6458),
    [anon_sym_downcast] = ACTIONS(6458),
    [anon_sym_for] = ACTIONS(6458),
    [anon_sym_while] = ACTIONS(6458),
    [anon_sym_if] = ACTIONS(6458),
    [anon_sym_fun] = ACTIONS(6458),
    [anon_sym_try] = ACTIONS(6458),
    [anon_sym_match] = ACTIONS(6458),
    [anon_sym_match_BANG] = ACTIONS(6456),
    [anon_sym_function] = ACTIONS(6458),
    [anon_sym_use] = ACTIONS(6458),
    [anon_sym_use_BANG] = ACTIONS(6456),
    [anon_sym_do_BANG] = ACTIONS(6456),
    [anon_sym_begin] = ACTIONS(6458),
    [aux_sym_char_token1] = ACTIONS(6456),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6458),
    [anon_sym_DQUOTE] = ACTIONS(6458),
    [anon_sym_AT_DQUOTE] = ACTIONS(6456),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6456),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6456),
    [sym_bool] = ACTIONS(6458),
    [sym_unit] = ACTIONS(6456),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6458),
    [sym_op_identifier] = ACTIONS(6456),
    [anon_sym_PLUS] = ACTIONS(6458),
    [anon_sym_DASH] = ACTIONS(6458),
    [anon_sym_PLUS_DOT] = ACTIONS(6456),
    [anon_sym_DASH_DOT] = ACTIONS(6456),
    [anon_sym_PERCENT] = ACTIONS(6456),
    [anon_sym_AMP_AMP] = ACTIONS(6456),
    [anon_sym_TILDE] = ACTIONS(6456),
    [aux_sym_prefix_op_token1] = ACTIONS(6456),
    [sym_int] = ACTIONS(6458),
    [sym_xint] = ACTIONS(6456),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6456),
    [anon_sym_POUNDendif] = ACTIONS(6456),
    [anon_sym_POUNDelse] = ACTIONS(6456),
  },
  [4279] = {
    [sym_block_comment] = STATE(4279),
    [sym_compiler_directive_decl] = STATE(4279),
    [sym_fsi_directive_decl] = STATE(4279),
    [sym_preproc_line] = STATE(4279),
    [sym_identifier] = ACTIONS(4078),
    [anon_sym_return] = ACTIONS(4078),
    [anon_sym_do] = ACTIONS(4078),
    [anon_sym_let] = ACTIONS(4078),
    [anon_sym_let_BANG] = ACTIONS(4076),
    [anon_sym_LPAREN] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(4076),
    [anon_sym_null] = ACTIONS(4078),
    [anon_sym_AMP] = ACTIONS(4078),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(4078),
    [anon_sym_LT_AT] = ACTIONS(4078),
    [anon_sym_LT_AT_AT] = ACTIONS(4076),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4076),
    [anon_sym_new] = ACTIONS(4078),
    [anon_sym_return_BANG] = ACTIONS(4076),
    [anon_sym_yield] = ACTIONS(4078),
    [anon_sym_yield_BANG] = ACTIONS(4076),
    [anon_sym_lazy] = ACTIONS(4078),
    [anon_sym_assert] = ACTIONS(4078),
    [anon_sym_upcast] = ACTIONS(4078),
    [anon_sym_downcast] = ACTIONS(4078),
    [anon_sym_for] = ACTIONS(4078),
    [anon_sym_while] = ACTIONS(4078),
    [anon_sym_if] = ACTIONS(4078),
    [anon_sym_fun] = ACTIONS(4078),
    [anon_sym_try] = ACTIONS(4078),
    [anon_sym_match] = ACTIONS(4078),
    [anon_sym_match_BANG] = ACTIONS(4076),
    [anon_sym_function] = ACTIONS(4078),
    [anon_sym_GT] = ACTIONS(4076),
    [anon_sym_use] = ACTIONS(4078),
    [anon_sym_use_BANG] = ACTIONS(4076),
    [anon_sym_do_BANG] = ACTIONS(4076),
    [anon_sym_begin] = ACTIONS(4078),
    [aux_sym_char_token1] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4078),
    [anon_sym_DQUOTE] = ACTIONS(4078),
    [anon_sym_AT_DQUOTE] = ACTIONS(4076),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4076),
    [sym_bool] = ACTIONS(4078),
    [sym_unit] = ACTIONS(4076),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4078),
    [sym_op_identifier] = ACTIONS(4076),
    [anon_sym_PLUS] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(4078),
    [anon_sym_PLUS_DOT] = ACTIONS(4076),
    [anon_sym_DASH_DOT] = ACTIONS(4076),
    [anon_sym_PERCENT] = ACTIONS(4076),
    [anon_sym_AMP_AMP] = ACTIONS(4076),
    [anon_sym_TILDE] = ACTIONS(4076),
    [aux_sym_prefix_op_token1] = ACTIONS(4076),
    [sym_int] = ACTIONS(4078),
    [sym_xint] = ACTIONS(4076),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4076),
  },
  [4280] = {
    [sym_block_comment] = STATE(4280),
    [sym_compiler_directive_decl] = STATE(4280),
    [sym_fsi_directive_decl] = STATE(4280),
    [sym_preproc_line] = STATE(4280),
    [aux_sym_prefix_op_repeat1] = STATE(4287),
    [sym_identifier] = ACTIONS(6987),
    [anon_sym_return] = ACTIONS(6987),
    [anon_sym_do] = ACTIONS(6987),
    [anon_sym_let] = ACTIONS(6987),
    [anon_sym_let_BANG] = ACTIONS(6989),
    [anon_sym_LPAREN] = ACTIONS(6987),
    [anon_sym_null] = ACTIONS(6987),
    [anon_sym_AMP] = ACTIONS(6987),
    [anon_sym_LBRACK] = ACTIONS(6987),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6989),
    [anon_sym_LBRACE] = ACTIONS(6987),
    [anon_sym_LT_AT] = ACTIONS(6987),
    [anon_sym_LT_AT_AT] = ACTIONS(6989),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6989),
    [anon_sym_new] = ACTIONS(6987),
    [anon_sym_return_BANG] = ACTIONS(6989),
    [anon_sym_yield] = ACTIONS(6987),
    [anon_sym_yield_BANG] = ACTIONS(6989),
    [anon_sym_lazy] = ACTIONS(6987),
    [anon_sym_assert] = ACTIONS(6987),
    [anon_sym_upcast] = ACTIONS(6987),
    [anon_sym_downcast] = ACTIONS(6987),
    [anon_sym_for] = ACTIONS(6987),
    [anon_sym_while] = ACTIONS(6987),
    [anon_sym_if] = ACTIONS(6987),
    [anon_sym_fun] = ACTIONS(6987),
    [anon_sym_try] = ACTIONS(6987),
    [anon_sym_match] = ACTIONS(6987),
    [anon_sym_match_BANG] = ACTIONS(6989),
    [anon_sym_function] = ACTIONS(6987),
    [anon_sym_use] = ACTIONS(6987),
    [anon_sym_use_BANG] = ACTIONS(6989),
    [anon_sym_do_BANG] = ACTIONS(6989),
    [anon_sym_begin] = ACTIONS(6987),
    [aux_sym_char_token1] = ACTIONS(6989),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6987),
    [anon_sym_DQUOTE] = ACTIONS(6987),
    [anon_sym_AT_DQUOTE] = ACTIONS(6989),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6989),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6989),
    [sym_bool] = ACTIONS(6987),
    [sym_unit] = ACTIONS(6989),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6987),
    [sym_op_identifier] = ACTIONS(6989),
    [anon_sym_PLUS] = ACTIONS(6987),
    [anon_sym_DASH] = ACTIONS(6987),
    [anon_sym_PLUS_DOT] = ACTIONS(6989),
    [anon_sym_DASH_DOT] = ACTIONS(6989),
    [anon_sym_PERCENT] = ACTIONS(6989),
    [anon_sym_AMP_AMP] = ACTIONS(6989),
    [anon_sym_TILDE] = ACTIONS(6989),
    [aux_sym_prefix_op_token1] = ACTIONS(6989),
    [sym_int] = ACTIONS(6987),
    [sym_xint] = ACTIONS(6989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6989),
  },
  [4281] = {
    [sym_block_comment] = STATE(4281),
    [sym_compiler_directive_decl] = STATE(4281),
    [sym_fsi_directive_decl] = STATE(4281),
    [sym_preproc_line] = STATE(4281),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_and] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3698),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3698),
    [anon_sym_DASH_DOT] = ACTIONS(3698),
    [anon_sym_PERCENT] = ACTIONS(3698),
    [anon_sym_AMP_AMP] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3698),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
  },
  [4282] = {
    [sym_block_comment] = STATE(4282),
    [sym_compiler_directive_decl] = STATE(4282),
    [sym_fsi_directive_decl] = STATE(4282),
    [sym_preproc_line] = STATE(4282),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3698),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3698),
    [anon_sym_DASH_DOT] = ACTIONS(3698),
    [anon_sym_PERCENT] = ACTIONS(3698),
    [anon_sym_AMP_AMP] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3698),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
    [anon_sym_POUNDendif] = ACTIONS(3698),
  },
  [4283] = {
    [sym_block_comment] = STATE(4283),
    [sym_compiler_directive_decl] = STATE(4283),
    [sym_fsi_directive_decl] = STATE(4283),
    [sym_preproc_line] = STATE(4283),
    [sym_identifier] = ACTIONS(6458),
    [anon_sym_return] = ACTIONS(6458),
    [anon_sym_do] = ACTIONS(6458),
    [anon_sym_let] = ACTIONS(6458),
    [anon_sym_let_BANG] = ACTIONS(6456),
    [anon_sym_LPAREN] = ACTIONS(6458),
    [anon_sym_null] = ACTIONS(6458),
    [anon_sym_AMP] = ACTIONS(6458),
    [anon_sym_LBRACK] = ACTIONS(6458),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6456),
    [anon_sym_LBRACE] = ACTIONS(6458),
    [anon_sym_LT_AT] = ACTIONS(6458),
    [anon_sym_LT_AT_AT] = ACTIONS(6456),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6456),
    [anon_sym_new] = ACTIONS(6458),
    [anon_sym_return_BANG] = ACTIONS(6456),
    [anon_sym_yield] = ACTIONS(6458),
    [anon_sym_yield_BANG] = ACTIONS(6456),
    [anon_sym_lazy] = ACTIONS(6458),
    [anon_sym_assert] = ACTIONS(6458),
    [anon_sym_upcast] = ACTIONS(6458),
    [anon_sym_downcast] = ACTIONS(6458),
    [anon_sym_for] = ACTIONS(6458),
    [anon_sym_while] = ACTIONS(6458),
    [anon_sym_if] = ACTIONS(6458),
    [anon_sym_fun] = ACTIONS(6458),
    [anon_sym_try] = ACTIONS(6458),
    [anon_sym_match] = ACTIONS(6458),
    [anon_sym_match_BANG] = ACTIONS(6456),
    [anon_sym_function] = ACTIONS(6458),
    [anon_sym_use] = ACTIONS(6458),
    [anon_sym_use_BANG] = ACTIONS(6456),
    [anon_sym_do_BANG] = ACTIONS(6456),
    [anon_sym_begin] = ACTIONS(6458),
    [aux_sym_char_token1] = ACTIONS(6456),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6458),
    [anon_sym_DQUOTE] = ACTIONS(6458),
    [anon_sym_AT_DQUOTE] = ACTIONS(6456),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6456),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6456),
    [sym_bool] = ACTIONS(6458),
    [sym_unit] = ACTIONS(6456),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6458),
    [sym_op_identifier] = ACTIONS(6456),
    [anon_sym_PLUS] = ACTIONS(6458),
    [anon_sym_DASH] = ACTIONS(6458),
    [anon_sym_PLUS_DOT] = ACTIONS(6456),
    [anon_sym_DASH_DOT] = ACTIONS(6456),
    [anon_sym_PERCENT] = ACTIONS(6456),
    [anon_sym_AMP_AMP] = ACTIONS(6456),
    [anon_sym_TILDE] = ACTIONS(6456),
    [aux_sym_prefix_op_token1] = ACTIONS(6456),
    [sym_int] = ACTIONS(6458),
    [sym_xint] = ACTIONS(6456),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6456),
    [anon_sym_POUNDendif] = ACTIONS(6456),
  },
  [4284] = {
    [sym_block_comment] = STATE(4284),
    [sym_compiler_directive_decl] = STATE(4284),
    [sym_fsi_directive_decl] = STATE(4284),
    [sym_preproc_line] = STATE(4284),
    [sym_identifier] = ACTIONS(6302),
    [anon_sym_return] = ACTIONS(6302),
    [anon_sym_do] = ACTIONS(6302),
    [anon_sym_let] = ACTIONS(6302),
    [anon_sym_let_BANG] = ACTIONS(6300),
    [anon_sym_LPAREN] = ACTIONS(6302),
    [anon_sym_null] = ACTIONS(6302),
    [anon_sym_AMP] = ACTIONS(6302),
    [anon_sym_LBRACK] = ACTIONS(6302),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6300),
    [anon_sym_LBRACE] = ACTIONS(6302),
    [anon_sym_LT_AT] = ACTIONS(6302),
    [anon_sym_LT_AT_AT] = ACTIONS(6300),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6300),
    [anon_sym_new] = ACTIONS(6302),
    [anon_sym_return_BANG] = ACTIONS(6300),
    [anon_sym_yield] = ACTIONS(6302),
    [anon_sym_yield_BANG] = ACTIONS(6300),
    [anon_sym_lazy] = ACTIONS(6302),
    [anon_sym_assert] = ACTIONS(6302),
    [anon_sym_upcast] = ACTIONS(6302),
    [anon_sym_downcast] = ACTIONS(6302),
    [anon_sym_for] = ACTIONS(6302),
    [anon_sym_while] = ACTIONS(6302),
    [anon_sym_if] = ACTIONS(6302),
    [anon_sym_fun] = ACTIONS(6302),
    [anon_sym_try] = ACTIONS(6302),
    [anon_sym_match] = ACTIONS(6302),
    [anon_sym_match_BANG] = ACTIONS(6300),
    [anon_sym_function] = ACTIONS(6302),
    [anon_sym_use] = ACTIONS(6302),
    [anon_sym_use_BANG] = ACTIONS(6300),
    [anon_sym_do_BANG] = ACTIONS(6300),
    [anon_sym_begin] = ACTIONS(6302),
    [aux_sym_char_token1] = ACTIONS(6300),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6302),
    [anon_sym_DQUOTE] = ACTIONS(6302),
    [anon_sym_AT_DQUOTE] = ACTIONS(6300),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6300),
    [sym_bool] = ACTIONS(6302),
    [sym_unit] = ACTIONS(6300),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6302),
    [sym_op_identifier] = ACTIONS(6300),
    [anon_sym_PLUS] = ACTIONS(6302),
    [anon_sym_DASH] = ACTIONS(6302),
    [anon_sym_PLUS_DOT] = ACTIONS(6300),
    [anon_sym_DASH_DOT] = ACTIONS(6300),
    [anon_sym_PERCENT] = ACTIONS(6300),
    [anon_sym_AMP_AMP] = ACTIONS(6300),
    [anon_sym_TILDE] = ACTIONS(6300),
    [aux_sym_prefix_op_token1] = ACTIONS(6300),
    [sym_int] = ACTIONS(6302),
    [sym_xint] = ACTIONS(6300),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6300),
    [anon_sym_POUNDendif] = ACTIONS(6300),
  },
  [4285] = {
    [sym_block_comment] = STATE(4285),
    [sym_compiler_directive_decl] = STATE(4285),
    [sym_fsi_directive_decl] = STATE(4285),
    [sym_preproc_line] = STATE(4285),
    [sym_identifier] = ACTIONS(6318),
    [anon_sym_return] = ACTIONS(6318),
    [anon_sym_do] = ACTIONS(6318),
    [anon_sym_and] = ACTIONS(6318),
    [anon_sym_let] = ACTIONS(6318),
    [anon_sym_let_BANG] = ACTIONS(6316),
    [anon_sym_LPAREN] = ACTIONS(6318),
    [anon_sym_null] = ACTIONS(6318),
    [anon_sym_AMP] = ACTIONS(6318),
    [anon_sym_LBRACK] = ACTIONS(6318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6316),
    [anon_sym_LBRACE] = ACTIONS(6318),
    [anon_sym_LT_AT] = ACTIONS(6318),
    [anon_sym_LT_AT_AT] = ACTIONS(6316),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6316),
    [anon_sym_new] = ACTIONS(6318),
    [anon_sym_return_BANG] = ACTIONS(6316),
    [anon_sym_yield] = ACTIONS(6318),
    [anon_sym_yield_BANG] = ACTIONS(6316),
    [anon_sym_lazy] = ACTIONS(6318),
    [anon_sym_assert] = ACTIONS(6318),
    [anon_sym_upcast] = ACTIONS(6318),
    [anon_sym_downcast] = ACTIONS(6318),
    [anon_sym_for] = ACTIONS(6318),
    [anon_sym_while] = ACTIONS(6318),
    [anon_sym_if] = ACTIONS(6318),
    [anon_sym_fun] = ACTIONS(6318),
    [anon_sym_try] = ACTIONS(6318),
    [anon_sym_match] = ACTIONS(6318),
    [anon_sym_match_BANG] = ACTIONS(6316),
    [anon_sym_function] = ACTIONS(6318),
    [anon_sym_use] = ACTIONS(6318),
    [anon_sym_use_BANG] = ACTIONS(6316),
    [anon_sym_do_BANG] = ACTIONS(6316),
    [anon_sym_begin] = ACTIONS(6318),
    [aux_sym_char_token1] = ACTIONS(6316),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6318),
    [anon_sym_DQUOTE] = ACTIONS(6318),
    [anon_sym_AT_DQUOTE] = ACTIONS(6316),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6316),
    [sym_bool] = ACTIONS(6318),
    [sym_unit] = ACTIONS(6316),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6318),
    [sym_op_identifier] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6318),
    [anon_sym_DASH] = ACTIONS(6318),
    [anon_sym_PLUS_DOT] = ACTIONS(6316),
    [anon_sym_DASH_DOT] = ACTIONS(6316),
    [anon_sym_PERCENT] = ACTIONS(6316),
    [anon_sym_AMP_AMP] = ACTIONS(6316),
    [anon_sym_TILDE] = ACTIONS(6316),
    [aux_sym_prefix_op_token1] = ACTIONS(6316),
    [sym_int] = ACTIONS(6318),
    [sym_xint] = ACTIONS(6316),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6316),
  },
  [4286] = {
    [sym_block_comment] = STATE(4286),
    [sym_compiler_directive_decl] = STATE(4286),
    [sym_fsi_directive_decl] = STATE(4286),
    [sym_preproc_line] = STATE(4286),
    [sym_identifier] = ACTIONS(6428),
    [anon_sym_return] = ACTIONS(6428),
    [anon_sym_do] = ACTIONS(6428),
    [anon_sym_and] = ACTIONS(6428),
    [anon_sym_let] = ACTIONS(6428),
    [anon_sym_let_BANG] = ACTIONS(6426),
    [anon_sym_LPAREN] = ACTIONS(6428),
    [anon_sym_null] = ACTIONS(6428),
    [anon_sym_AMP] = ACTIONS(6428),
    [anon_sym_LBRACK] = ACTIONS(6428),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6426),
    [anon_sym_LBRACE] = ACTIONS(6428),
    [anon_sym_LT_AT] = ACTIONS(6428),
    [anon_sym_LT_AT_AT] = ACTIONS(6426),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6426),
    [anon_sym_new] = ACTIONS(6428),
    [anon_sym_return_BANG] = ACTIONS(6426),
    [anon_sym_yield] = ACTIONS(6428),
    [anon_sym_yield_BANG] = ACTIONS(6426),
    [anon_sym_lazy] = ACTIONS(6428),
    [anon_sym_assert] = ACTIONS(6428),
    [anon_sym_upcast] = ACTIONS(6428),
    [anon_sym_downcast] = ACTIONS(6428),
    [anon_sym_for] = ACTIONS(6428),
    [anon_sym_while] = ACTIONS(6428),
    [anon_sym_if] = ACTIONS(6428),
    [anon_sym_fun] = ACTIONS(6428),
    [anon_sym_try] = ACTIONS(6428),
    [anon_sym_match] = ACTIONS(6428),
    [anon_sym_match_BANG] = ACTIONS(6426),
    [anon_sym_function] = ACTIONS(6428),
    [anon_sym_use] = ACTIONS(6428),
    [anon_sym_use_BANG] = ACTIONS(6426),
    [anon_sym_do_BANG] = ACTIONS(6426),
    [anon_sym_begin] = ACTIONS(6428),
    [aux_sym_char_token1] = ACTIONS(6426),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6428),
    [anon_sym_DQUOTE] = ACTIONS(6428),
    [anon_sym_AT_DQUOTE] = ACTIONS(6426),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6426),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6426),
    [sym_bool] = ACTIONS(6428),
    [sym_unit] = ACTIONS(6426),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6428),
    [sym_op_identifier] = ACTIONS(6426),
    [anon_sym_PLUS] = ACTIONS(6428),
    [anon_sym_DASH] = ACTIONS(6428),
    [anon_sym_PLUS_DOT] = ACTIONS(6426),
    [anon_sym_DASH_DOT] = ACTIONS(6426),
    [anon_sym_PERCENT] = ACTIONS(6426),
    [anon_sym_AMP_AMP] = ACTIONS(6426),
    [anon_sym_TILDE] = ACTIONS(6426),
    [aux_sym_prefix_op_token1] = ACTIONS(6426),
    [sym_int] = ACTIONS(6428),
    [sym_xint] = ACTIONS(6426),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6426),
  },
  [4287] = {
    [sym_block_comment] = STATE(4287),
    [sym_compiler_directive_decl] = STATE(4287),
    [sym_fsi_directive_decl] = STATE(4287),
    [sym_preproc_line] = STATE(4287),
    [aux_sym_prefix_op_repeat1] = STATE(4287),
    [sym_identifier] = ACTIONS(6991),
    [anon_sym_return] = ACTIONS(6991),
    [anon_sym_do] = ACTIONS(6991),
    [anon_sym_let] = ACTIONS(6991),
    [anon_sym_let_BANG] = ACTIONS(6993),
    [anon_sym_LPAREN] = ACTIONS(6991),
    [anon_sym_null] = ACTIONS(6991),
    [anon_sym_AMP] = ACTIONS(6991),
    [anon_sym_LBRACK] = ACTIONS(6991),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6993),
    [anon_sym_LBRACE] = ACTIONS(6991),
    [anon_sym_LT_AT] = ACTIONS(6991),
    [anon_sym_LT_AT_AT] = ACTIONS(6993),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6993),
    [anon_sym_new] = ACTIONS(6991),
    [anon_sym_return_BANG] = ACTIONS(6993),
    [anon_sym_yield] = ACTIONS(6991),
    [anon_sym_yield_BANG] = ACTIONS(6993),
    [anon_sym_lazy] = ACTIONS(6991),
    [anon_sym_assert] = ACTIONS(6991),
    [anon_sym_upcast] = ACTIONS(6991),
    [anon_sym_downcast] = ACTIONS(6991),
    [anon_sym_for] = ACTIONS(6991),
    [anon_sym_while] = ACTIONS(6991),
    [anon_sym_if] = ACTIONS(6991),
    [anon_sym_fun] = ACTIONS(6991),
    [anon_sym_try] = ACTIONS(6991),
    [anon_sym_match] = ACTIONS(6991),
    [anon_sym_match_BANG] = ACTIONS(6993),
    [anon_sym_function] = ACTIONS(6991),
    [anon_sym_use] = ACTIONS(6991),
    [anon_sym_use_BANG] = ACTIONS(6993),
    [anon_sym_do_BANG] = ACTIONS(6993),
    [anon_sym_begin] = ACTIONS(6991),
    [aux_sym_char_token1] = ACTIONS(6993),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6991),
    [anon_sym_DQUOTE] = ACTIONS(6991),
    [anon_sym_AT_DQUOTE] = ACTIONS(6993),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6993),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6993),
    [sym_bool] = ACTIONS(6991),
    [sym_unit] = ACTIONS(6993),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6991),
    [sym_op_identifier] = ACTIONS(6993),
    [anon_sym_PLUS] = ACTIONS(6991),
    [anon_sym_DASH] = ACTIONS(6991),
    [anon_sym_PLUS_DOT] = ACTIONS(6993),
    [anon_sym_DASH_DOT] = ACTIONS(6993),
    [anon_sym_PERCENT] = ACTIONS(6993),
    [anon_sym_AMP_AMP] = ACTIONS(6993),
    [anon_sym_TILDE] = ACTIONS(6995),
    [aux_sym_prefix_op_token1] = ACTIONS(6993),
    [sym_int] = ACTIONS(6991),
    [sym_xint] = ACTIONS(6993),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6993),
  },
  [4288] = {
    [sym_block_comment] = STATE(4288),
    [sym_compiler_directive_decl] = STATE(4288),
    [sym_fsi_directive_decl] = STATE(4288),
    [sym_preproc_line] = STATE(4288),
    [sym_identifier] = ACTIONS(6318),
    [anon_sym_return] = ACTIONS(6318),
    [anon_sym_do] = ACTIONS(6318),
    [anon_sym_let] = ACTIONS(6318),
    [anon_sym_let_BANG] = ACTIONS(6316),
    [anon_sym_LPAREN] = ACTIONS(6318),
    [anon_sym_null] = ACTIONS(6318),
    [anon_sym_AMP] = ACTIONS(6318),
    [anon_sym_LBRACK] = ACTIONS(6318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6316),
    [anon_sym_LBRACE] = ACTIONS(6318),
    [anon_sym_LT_AT] = ACTIONS(6318),
    [anon_sym_LT_AT_AT] = ACTIONS(6316),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6316),
    [anon_sym_new] = ACTIONS(6318),
    [anon_sym_return_BANG] = ACTIONS(6316),
    [anon_sym_yield] = ACTIONS(6318),
    [anon_sym_yield_BANG] = ACTIONS(6316),
    [anon_sym_lazy] = ACTIONS(6318),
    [anon_sym_assert] = ACTIONS(6318),
    [anon_sym_upcast] = ACTIONS(6318),
    [anon_sym_downcast] = ACTIONS(6318),
    [anon_sym_for] = ACTIONS(6318),
    [anon_sym_while] = ACTIONS(6318),
    [anon_sym_if] = ACTIONS(6318),
    [anon_sym_fun] = ACTIONS(6318),
    [anon_sym_try] = ACTIONS(6318),
    [anon_sym_match] = ACTIONS(6318),
    [anon_sym_match_BANG] = ACTIONS(6316),
    [anon_sym_function] = ACTIONS(6318),
    [anon_sym_use] = ACTIONS(6318),
    [anon_sym_use_BANG] = ACTIONS(6316),
    [anon_sym_do_BANG] = ACTIONS(6316),
    [anon_sym_begin] = ACTIONS(6318),
    [aux_sym_char_token1] = ACTIONS(6316),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6318),
    [anon_sym_DQUOTE] = ACTIONS(6318),
    [anon_sym_AT_DQUOTE] = ACTIONS(6316),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6316),
    [sym_bool] = ACTIONS(6318),
    [sym_unit] = ACTIONS(6316),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6318),
    [sym_op_identifier] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6318),
    [anon_sym_DASH] = ACTIONS(6318),
    [anon_sym_PLUS_DOT] = ACTIONS(6316),
    [anon_sym_DASH_DOT] = ACTIONS(6316),
    [anon_sym_PERCENT] = ACTIONS(6316),
    [anon_sym_AMP_AMP] = ACTIONS(6316),
    [anon_sym_TILDE] = ACTIONS(6316),
    [aux_sym_prefix_op_token1] = ACTIONS(6316),
    [sym_int] = ACTIONS(6318),
    [sym_xint] = ACTIONS(6316),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6316),
    [anon_sym_POUNDendif] = ACTIONS(6316),
  },
  [4289] = {
    [sym_block_comment] = STATE(4289),
    [sym_compiler_directive_decl] = STATE(4289),
    [sym_fsi_directive_decl] = STATE(4289),
    [sym_preproc_line] = STATE(4289),
    [sym_identifier] = ACTIONS(6288),
    [anon_sym_return] = ACTIONS(6288),
    [anon_sym_do] = ACTIONS(6288),
    [anon_sym_let] = ACTIONS(6288),
    [anon_sym_let_BANG] = ACTIONS(6286),
    [anon_sym_LPAREN] = ACTIONS(6288),
    [anon_sym_null] = ACTIONS(6288),
    [anon_sym_AMP] = ACTIONS(6288),
    [anon_sym_LBRACK] = ACTIONS(6288),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6286),
    [anon_sym_LBRACE] = ACTIONS(6288),
    [anon_sym_LT_AT] = ACTIONS(6288),
    [anon_sym_LT_AT_AT] = ACTIONS(6286),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6286),
    [anon_sym_new] = ACTIONS(6288),
    [anon_sym_return_BANG] = ACTIONS(6286),
    [anon_sym_yield] = ACTIONS(6288),
    [anon_sym_yield_BANG] = ACTIONS(6286),
    [anon_sym_lazy] = ACTIONS(6288),
    [anon_sym_assert] = ACTIONS(6288),
    [anon_sym_upcast] = ACTIONS(6288),
    [anon_sym_downcast] = ACTIONS(6288),
    [anon_sym_for] = ACTIONS(6288),
    [anon_sym_while] = ACTIONS(6288),
    [anon_sym_if] = ACTIONS(6288),
    [anon_sym_fun] = ACTIONS(6288),
    [anon_sym_try] = ACTIONS(6288),
    [anon_sym_match] = ACTIONS(6288),
    [anon_sym_match_BANG] = ACTIONS(6286),
    [anon_sym_function] = ACTIONS(6288),
    [anon_sym_use] = ACTIONS(6288),
    [anon_sym_use_BANG] = ACTIONS(6286),
    [anon_sym_do_BANG] = ACTIONS(6286),
    [anon_sym_begin] = ACTIONS(6288),
    [aux_sym_char_token1] = ACTIONS(6286),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6288),
    [anon_sym_DQUOTE] = ACTIONS(6288),
    [anon_sym_AT_DQUOTE] = ACTIONS(6286),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6286),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6286),
    [sym_bool] = ACTIONS(6288),
    [sym_unit] = ACTIONS(6286),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6288),
    [sym_op_identifier] = ACTIONS(6286),
    [anon_sym_PLUS] = ACTIONS(6288),
    [anon_sym_DASH] = ACTIONS(6288),
    [anon_sym_PLUS_DOT] = ACTIONS(6286),
    [anon_sym_DASH_DOT] = ACTIONS(6286),
    [anon_sym_PERCENT] = ACTIONS(6286),
    [anon_sym_AMP_AMP] = ACTIONS(6286),
    [anon_sym_TILDE] = ACTIONS(6286),
    [aux_sym_prefix_op_token1] = ACTIONS(6286),
    [sym_int] = ACTIONS(6288),
    [sym_xint] = ACTIONS(6286),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6286),
    [anon_sym_POUNDendif] = ACTIONS(6286),
  },
  [4290] = {
    [sym_block_comment] = STATE(4290),
    [sym_compiler_directive_decl] = STATE(4290),
    [sym_fsi_directive_decl] = STATE(4290),
    [sym_preproc_line] = STATE(4290),
    [sym_identifier] = ACTIONS(6302),
    [anon_sym_return] = ACTIONS(6302),
    [anon_sym_do] = ACTIONS(6302),
    [anon_sym_and] = ACTIONS(6302),
    [anon_sym_let] = ACTIONS(6302),
    [anon_sym_let_BANG] = ACTIONS(6300),
    [anon_sym_LPAREN] = ACTIONS(6302),
    [anon_sym_null] = ACTIONS(6302),
    [anon_sym_AMP] = ACTIONS(6302),
    [anon_sym_LBRACK] = ACTIONS(6302),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6300),
    [anon_sym_LBRACE] = ACTIONS(6302),
    [anon_sym_LT_AT] = ACTIONS(6302),
    [anon_sym_LT_AT_AT] = ACTIONS(6300),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6300),
    [anon_sym_new] = ACTIONS(6302),
    [anon_sym_return_BANG] = ACTIONS(6300),
    [anon_sym_yield] = ACTIONS(6302),
    [anon_sym_yield_BANG] = ACTIONS(6300),
    [anon_sym_lazy] = ACTIONS(6302),
    [anon_sym_assert] = ACTIONS(6302),
    [anon_sym_upcast] = ACTIONS(6302),
    [anon_sym_downcast] = ACTIONS(6302),
    [anon_sym_for] = ACTIONS(6302),
    [anon_sym_while] = ACTIONS(6302),
    [anon_sym_if] = ACTIONS(6302),
    [anon_sym_fun] = ACTIONS(6302),
    [anon_sym_try] = ACTIONS(6302),
    [anon_sym_match] = ACTIONS(6302),
    [anon_sym_match_BANG] = ACTIONS(6300),
    [anon_sym_function] = ACTIONS(6302),
    [anon_sym_use] = ACTIONS(6302),
    [anon_sym_use_BANG] = ACTIONS(6300),
    [anon_sym_do_BANG] = ACTIONS(6300),
    [anon_sym_begin] = ACTIONS(6302),
    [aux_sym_char_token1] = ACTIONS(6300),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6302),
    [anon_sym_DQUOTE] = ACTIONS(6302),
    [anon_sym_AT_DQUOTE] = ACTIONS(6300),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6300),
    [sym_bool] = ACTIONS(6302),
    [sym_unit] = ACTIONS(6300),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6302),
    [sym_op_identifier] = ACTIONS(6300),
    [anon_sym_PLUS] = ACTIONS(6302),
    [anon_sym_DASH] = ACTIONS(6302),
    [anon_sym_PLUS_DOT] = ACTIONS(6300),
    [anon_sym_DASH_DOT] = ACTIONS(6300),
    [anon_sym_PERCENT] = ACTIONS(6300),
    [anon_sym_AMP_AMP] = ACTIONS(6300),
    [anon_sym_TILDE] = ACTIONS(6300),
    [aux_sym_prefix_op_token1] = ACTIONS(6300),
    [sym_int] = ACTIONS(6302),
    [sym_xint] = ACTIONS(6300),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6300),
  },
  [4291] = {
    [sym_block_comment] = STATE(4291),
    [sym_compiler_directive_decl] = STATE(4291),
    [sym_fsi_directive_decl] = STATE(4291),
    [sym_preproc_line] = STATE(4291),
    [sym_identifier] = ACTIONS(6998),
    [anon_sym_return] = ACTIONS(6998),
    [anon_sym_do] = ACTIONS(6998),
    [anon_sym_let] = ACTIONS(6998),
    [anon_sym_let_BANG] = ACTIONS(7000),
    [anon_sym_LPAREN] = ACTIONS(6998),
    [anon_sym_null] = ACTIONS(6998),
    [anon_sym_AMP] = ACTIONS(6998),
    [anon_sym_LBRACK] = ACTIONS(6998),
    [anon_sym_LBRACK_PIPE] = ACTIONS(7000),
    [anon_sym_LBRACE] = ACTIONS(6998),
    [anon_sym_LT_AT] = ACTIONS(6998),
    [anon_sym_LT_AT_AT] = ACTIONS(7000),
    [anon_sym_LBRACE_PIPE] = ACTIONS(7000),
    [anon_sym_new] = ACTIONS(6998),
    [anon_sym_return_BANG] = ACTIONS(7000),
    [anon_sym_yield] = ACTIONS(6998),
    [anon_sym_yield_BANG] = ACTIONS(7000),
    [anon_sym_lazy] = ACTIONS(6998),
    [anon_sym_assert] = ACTIONS(6998),
    [anon_sym_upcast] = ACTIONS(6998),
    [anon_sym_downcast] = ACTIONS(6998),
    [anon_sym_for] = ACTIONS(6998),
    [anon_sym_while] = ACTIONS(6998),
    [anon_sym_if] = ACTIONS(6998),
    [anon_sym_fun] = ACTIONS(6998),
    [anon_sym_try] = ACTIONS(6998),
    [anon_sym_match] = ACTIONS(6998),
    [anon_sym_match_BANG] = ACTIONS(7000),
    [anon_sym_function] = ACTIONS(6998),
    [anon_sym_use] = ACTIONS(6998),
    [anon_sym_use_BANG] = ACTIONS(7000),
    [anon_sym_do_BANG] = ACTIONS(7000),
    [anon_sym_begin] = ACTIONS(6998),
    [aux_sym_char_token1] = ACTIONS(7000),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6998),
    [anon_sym_DQUOTE] = ACTIONS(6998),
    [anon_sym_AT_DQUOTE] = ACTIONS(7000),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7000),
    [sym_bool] = ACTIONS(6998),
    [sym_unit] = ACTIONS(7000),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6998),
    [sym_op_identifier] = ACTIONS(7000),
    [anon_sym_PLUS] = ACTIONS(6998),
    [anon_sym_DASH] = ACTIONS(6998),
    [anon_sym_PLUS_DOT] = ACTIONS(7000),
    [anon_sym_DASH_DOT] = ACTIONS(7000),
    [anon_sym_PERCENT] = ACTIONS(7000),
    [anon_sym_AMP_AMP] = ACTIONS(7000),
    [anon_sym_TILDE] = ACTIONS(7000),
    [aux_sym_prefix_op_token1] = ACTIONS(7000),
    [sym_int] = ACTIONS(6998),
    [sym_xint] = ACTIONS(7000),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(7000),
  },
  [4292] = {
    [sym_block_comment] = STATE(4292),
    [sym_compiler_directive_decl] = STATE(4292),
    [sym_fsi_directive_decl] = STATE(4292),
    [sym_preproc_line] = STATE(4292),
    [sym_identifier] = ACTIONS(6987),
    [anon_sym_return] = ACTIONS(6987),
    [anon_sym_do] = ACTIONS(6987),
    [anon_sym_let] = ACTIONS(6987),
    [anon_sym_let_BANG] = ACTIONS(6989),
    [anon_sym_LPAREN] = ACTIONS(6987),
    [anon_sym_null] = ACTIONS(6987),
    [anon_sym_AMP] = ACTIONS(6987),
    [anon_sym_LBRACK] = ACTIONS(6987),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6989),
    [anon_sym_LBRACE] = ACTIONS(6987),
    [anon_sym_LT_AT] = ACTIONS(6987),
    [anon_sym_LT_AT_AT] = ACTIONS(6989),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6989),
    [anon_sym_new] = ACTIONS(6987),
    [anon_sym_return_BANG] = ACTIONS(6989),
    [anon_sym_yield] = ACTIONS(6987),
    [anon_sym_yield_BANG] = ACTIONS(6989),
    [anon_sym_lazy] = ACTIONS(6987),
    [anon_sym_assert] = ACTIONS(6987),
    [anon_sym_upcast] = ACTIONS(6987),
    [anon_sym_downcast] = ACTIONS(6987),
    [anon_sym_for] = ACTIONS(6987),
    [anon_sym_while] = ACTIONS(6987),
    [anon_sym_if] = ACTIONS(6987),
    [anon_sym_fun] = ACTIONS(6987),
    [anon_sym_try] = ACTIONS(6987),
    [anon_sym_match] = ACTIONS(6987),
    [anon_sym_match_BANG] = ACTIONS(6989),
    [anon_sym_function] = ACTIONS(6987),
    [anon_sym_use] = ACTIONS(6987),
    [anon_sym_use_BANG] = ACTIONS(6989),
    [anon_sym_do_BANG] = ACTIONS(6989),
    [anon_sym_begin] = ACTIONS(6987),
    [aux_sym_char_token1] = ACTIONS(6989),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6987),
    [anon_sym_DQUOTE] = ACTIONS(6987),
    [anon_sym_AT_DQUOTE] = ACTIONS(6989),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6989),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6989),
    [sym_bool] = ACTIONS(6987),
    [sym_unit] = ACTIONS(6989),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6987),
    [sym_op_identifier] = ACTIONS(6989),
    [anon_sym_PLUS] = ACTIONS(6987),
    [anon_sym_DASH] = ACTIONS(6987),
    [anon_sym_PLUS_DOT] = ACTIONS(6989),
    [anon_sym_DASH_DOT] = ACTIONS(6989),
    [anon_sym_PERCENT] = ACTIONS(6989),
    [anon_sym_AMP_AMP] = ACTIONS(6989),
    [anon_sym_TILDE] = ACTIONS(6989),
    [aux_sym_prefix_op_token1] = ACTIONS(6989),
    [sym_int] = ACTIONS(6987),
    [sym_xint] = ACTIONS(6989),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6989),
  },
  [4293] = {
    [sym_block_comment] = STATE(4293),
    [sym_compiler_directive_decl] = STATE(4293),
    [sym_fsi_directive_decl] = STATE(4293),
    [sym_preproc_line] = STATE(4293),
    [sym_identifier] = ACTIONS(6302),
    [anon_sym_return] = ACTIONS(6302),
    [anon_sym_do] = ACTIONS(6302),
    [anon_sym_let] = ACTIONS(6302),
    [anon_sym_let_BANG] = ACTIONS(6300),
    [anon_sym_LPAREN] = ACTIONS(6302),
    [anon_sym_null] = ACTIONS(6302),
    [anon_sym_AMP] = ACTIONS(6302),
    [anon_sym_LBRACK] = ACTIONS(6302),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6300),
    [anon_sym_LBRACE] = ACTIONS(6302),
    [anon_sym_LT_AT] = ACTIONS(6302),
    [anon_sym_LT_AT_AT] = ACTIONS(6300),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6300),
    [anon_sym_new] = ACTIONS(6302),
    [anon_sym_return_BANG] = ACTIONS(6300),
    [anon_sym_yield] = ACTIONS(6302),
    [anon_sym_yield_BANG] = ACTIONS(6300),
    [anon_sym_lazy] = ACTIONS(6302),
    [anon_sym_assert] = ACTIONS(6302),
    [anon_sym_upcast] = ACTIONS(6302),
    [anon_sym_downcast] = ACTIONS(6302),
    [anon_sym_for] = ACTIONS(6302),
    [anon_sym_while] = ACTIONS(6302),
    [anon_sym_if] = ACTIONS(6302),
    [anon_sym_fun] = ACTIONS(6302),
    [anon_sym_try] = ACTIONS(6302),
    [anon_sym_match] = ACTIONS(6302),
    [anon_sym_match_BANG] = ACTIONS(6300),
    [anon_sym_function] = ACTIONS(6302),
    [anon_sym_use] = ACTIONS(6302),
    [anon_sym_use_BANG] = ACTIONS(6300),
    [anon_sym_do_BANG] = ACTIONS(6300),
    [anon_sym_begin] = ACTIONS(6302),
    [aux_sym_char_token1] = ACTIONS(6300),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6302),
    [anon_sym_DQUOTE] = ACTIONS(6302),
    [anon_sym_AT_DQUOTE] = ACTIONS(6300),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6300),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6300),
    [sym_bool] = ACTIONS(6302),
    [sym_unit] = ACTIONS(6300),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6302),
    [sym_op_identifier] = ACTIONS(6300),
    [anon_sym_PLUS] = ACTIONS(6302),
    [anon_sym_DASH] = ACTIONS(6302),
    [anon_sym_PLUS_DOT] = ACTIONS(6300),
    [anon_sym_DASH_DOT] = ACTIONS(6300),
    [anon_sym_PERCENT] = ACTIONS(6300),
    [anon_sym_AMP_AMP] = ACTIONS(6300),
    [anon_sym_TILDE] = ACTIONS(6300),
    [aux_sym_prefix_op_token1] = ACTIONS(6300),
    [sym_int] = ACTIONS(6302),
    [sym_xint] = ACTIONS(6300),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6300),
  },
  [4294] = {
    [sym_block_comment] = STATE(4294),
    [sym_compiler_directive_decl] = STATE(4294),
    [sym_fsi_directive_decl] = STATE(4294),
    [sym_preproc_line] = STATE(4294),
    [sym_identifier] = ACTIONS(7002),
    [anon_sym_return] = ACTIONS(7002),
    [anon_sym_do] = ACTIONS(7002),
    [anon_sym_let] = ACTIONS(7002),
    [anon_sym_let_BANG] = ACTIONS(7004),
    [anon_sym_LPAREN] = ACTIONS(7002),
    [anon_sym_null] = ACTIONS(7002),
    [anon_sym_AMP] = ACTIONS(7002),
    [anon_sym_LBRACK] = ACTIONS(7002),
    [anon_sym_LBRACK_PIPE] = ACTIONS(7004),
    [anon_sym_LBRACE] = ACTIONS(7002),
    [anon_sym_LT_AT] = ACTIONS(7002),
    [anon_sym_LT_AT_AT] = ACTIONS(7004),
    [anon_sym_LBRACE_PIPE] = ACTIONS(7004),
    [anon_sym_new] = ACTIONS(7002),
    [anon_sym_return_BANG] = ACTIONS(7004),
    [anon_sym_yield] = ACTIONS(7002),
    [anon_sym_yield_BANG] = ACTIONS(7004),
    [anon_sym_lazy] = ACTIONS(7002),
    [anon_sym_assert] = ACTIONS(7002),
    [anon_sym_upcast] = ACTIONS(7002),
    [anon_sym_downcast] = ACTIONS(7002),
    [anon_sym_for] = ACTIONS(7002),
    [anon_sym_while] = ACTIONS(7002),
    [anon_sym_if] = ACTIONS(7002),
    [anon_sym_fun] = ACTIONS(7002),
    [anon_sym_try] = ACTIONS(7002),
    [anon_sym_match] = ACTIONS(7002),
    [anon_sym_match_BANG] = ACTIONS(7004),
    [anon_sym_function] = ACTIONS(7002),
    [anon_sym_use] = ACTIONS(7002),
    [anon_sym_use_BANG] = ACTIONS(7004),
    [anon_sym_do_BANG] = ACTIONS(7004),
    [anon_sym_begin] = ACTIONS(7002),
    [aux_sym_char_token1] = ACTIONS(7004),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(7002),
    [anon_sym_DQUOTE] = ACTIONS(7002),
    [anon_sym_AT_DQUOTE] = ACTIONS(7004),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7004),
    [sym_bool] = ACTIONS(7002),
    [sym_unit] = ACTIONS(7004),
    [anon_sym_LPAREN_PIPE] = ACTIONS(7002),
    [sym_op_identifier] = ACTIONS(7004),
    [anon_sym_PLUS] = ACTIONS(7002),
    [anon_sym_DASH] = ACTIONS(7002),
    [anon_sym_PLUS_DOT] = ACTIONS(7004),
    [anon_sym_DASH_DOT] = ACTIONS(7004),
    [anon_sym_PERCENT] = ACTIONS(7004),
    [anon_sym_AMP_AMP] = ACTIONS(7004),
    [anon_sym_TILDE] = ACTIONS(7004),
    [aux_sym_prefix_op_token1] = ACTIONS(7004),
    [sym_int] = ACTIONS(7002),
    [sym_xint] = ACTIONS(7004),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(7004),
  },
  [4295] = {
    [sym_block_comment] = STATE(4295),
    [sym_compiler_directive_decl] = STATE(4295),
    [sym_fsi_directive_decl] = STATE(4295),
    [sym_preproc_line] = STATE(4295),
    [sym_identifier] = ACTIONS(6318),
    [anon_sym_return] = ACTIONS(6318),
    [anon_sym_do] = ACTIONS(6318),
    [anon_sym_let] = ACTIONS(6318),
    [anon_sym_let_BANG] = ACTIONS(6316),
    [anon_sym_LPAREN] = ACTIONS(6318),
    [anon_sym_null] = ACTIONS(6318),
    [anon_sym_AMP] = ACTIONS(6318),
    [anon_sym_LBRACK] = ACTIONS(6318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6316),
    [anon_sym_LBRACE] = ACTIONS(6318),
    [anon_sym_LT_AT] = ACTIONS(6318),
    [anon_sym_LT_AT_AT] = ACTIONS(6316),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6316),
    [anon_sym_new] = ACTIONS(6318),
    [anon_sym_return_BANG] = ACTIONS(6316),
    [anon_sym_yield] = ACTIONS(6318),
    [anon_sym_yield_BANG] = ACTIONS(6316),
    [anon_sym_lazy] = ACTIONS(6318),
    [anon_sym_assert] = ACTIONS(6318),
    [anon_sym_upcast] = ACTIONS(6318),
    [anon_sym_downcast] = ACTIONS(6318),
    [anon_sym_for] = ACTIONS(6318),
    [anon_sym_while] = ACTIONS(6318),
    [anon_sym_if] = ACTIONS(6318),
    [anon_sym_fun] = ACTIONS(6318),
    [anon_sym_try] = ACTIONS(6318),
    [anon_sym_match] = ACTIONS(6318),
    [anon_sym_match_BANG] = ACTIONS(6316),
    [anon_sym_function] = ACTIONS(6318),
    [anon_sym_use] = ACTIONS(6318),
    [anon_sym_use_BANG] = ACTIONS(6316),
    [anon_sym_do_BANG] = ACTIONS(6316),
    [anon_sym_begin] = ACTIONS(6318),
    [aux_sym_char_token1] = ACTIONS(6316),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6318),
    [anon_sym_DQUOTE] = ACTIONS(6318),
    [anon_sym_AT_DQUOTE] = ACTIONS(6316),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6316),
    [sym_bool] = ACTIONS(6318),
    [sym_unit] = ACTIONS(6316),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6318),
    [sym_op_identifier] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6318),
    [anon_sym_DASH] = ACTIONS(6318),
    [anon_sym_PLUS_DOT] = ACTIONS(6316),
    [anon_sym_DASH_DOT] = ACTIONS(6316),
    [anon_sym_PERCENT] = ACTIONS(6316),
    [anon_sym_AMP_AMP] = ACTIONS(6316),
    [anon_sym_TILDE] = ACTIONS(6316),
    [aux_sym_prefix_op_token1] = ACTIONS(6316),
    [sym_int] = ACTIONS(6318),
    [sym_xint] = ACTIONS(6316),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6316),
  },
  [4296] = {
    [sym_block_comment] = STATE(4296),
    [sym_compiler_directive_decl] = STATE(4296),
    [sym_fsi_directive_decl] = STATE(4296),
    [sym_preproc_line] = STATE(4296),
    [sym_identifier] = ACTIONS(7006),
    [anon_sym_return] = ACTIONS(7006),
    [anon_sym_do] = ACTIONS(7006),
    [anon_sym_let] = ACTIONS(7006),
    [anon_sym_let_BANG] = ACTIONS(7008),
    [anon_sym_LPAREN] = ACTIONS(7006),
    [anon_sym_null] = ACTIONS(7006),
    [anon_sym_AMP] = ACTIONS(7006),
    [anon_sym_LBRACK] = ACTIONS(7006),
    [anon_sym_LBRACK_PIPE] = ACTIONS(7008),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [anon_sym_LT_AT] = ACTIONS(7006),
    [anon_sym_LT_AT_AT] = ACTIONS(7008),
    [anon_sym_LBRACE_PIPE] = ACTIONS(7008),
    [anon_sym_new] = ACTIONS(7006),
    [anon_sym_return_BANG] = ACTIONS(7008),
    [anon_sym_yield] = ACTIONS(7006),
    [anon_sym_yield_BANG] = ACTIONS(7008),
    [anon_sym_lazy] = ACTIONS(7006),
    [anon_sym_assert] = ACTIONS(7006),
    [anon_sym_upcast] = ACTIONS(7006),
    [anon_sym_downcast] = ACTIONS(7006),
    [anon_sym_for] = ACTIONS(7006),
    [anon_sym_while] = ACTIONS(7006),
    [anon_sym_if] = ACTIONS(7006),
    [anon_sym_fun] = ACTIONS(7006),
    [anon_sym_try] = ACTIONS(7006),
    [anon_sym_match] = ACTIONS(7006),
    [anon_sym_match_BANG] = ACTIONS(7008),
    [anon_sym_function] = ACTIONS(7006),
    [anon_sym_use] = ACTIONS(7006),
    [anon_sym_use_BANG] = ACTIONS(7008),
    [anon_sym_do_BANG] = ACTIONS(7008),
    [anon_sym_begin] = ACTIONS(7006),
    [aux_sym_char_token1] = ACTIONS(7008),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(7006),
    [anon_sym_DQUOTE] = ACTIONS(7006),
    [anon_sym_AT_DQUOTE] = ACTIONS(7008),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7008),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7008),
    [sym_bool] = ACTIONS(7006),
    [sym_unit] = ACTIONS(7008),
    [anon_sym_LPAREN_PIPE] = ACTIONS(7006),
    [sym_op_identifier] = ACTIONS(7008),
    [anon_sym_PLUS] = ACTIONS(7006),
    [anon_sym_DASH] = ACTIONS(7006),
    [anon_sym_PLUS_DOT] = ACTIONS(7008),
    [anon_sym_DASH_DOT] = ACTIONS(7008),
    [anon_sym_PERCENT] = ACTIONS(7008),
    [anon_sym_AMP_AMP] = ACTIONS(7008),
    [anon_sym_TILDE] = ACTIONS(7008),
    [aux_sym_prefix_op_token1] = ACTIONS(7008),
    [sym_int] = ACTIONS(7006),
    [sym_xint] = ACTIONS(7008),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(7008),
  },
  [4297] = {
    [sym_block_comment] = STATE(4297),
    [sym_compiler_directive_decl] = STATE(4297),
    [sym_fsi_directive_decl] = STATE(4297),
    [sym_preproc_line] = STATE(4297),
    [sym_identifier] = ACTIONS(6458),
    [anon_sym_return] = ACTIONS(6458),
    [anon_sym_do] = ACTIONS(6458),
    [anon_sym_let] = ACTIONS(6458),
    [anon_sym_let_BANG] = ACTIONS(6456),
    [anon_sym_LPAREN] = ACTIONS(6458),
    [anon_sym_null] = ACTIONS(6458),
    [anon_sym_AMP] = ACTIONS(6458),
    [anon_sym_LBRACK] = ACTIONS(6458),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6456),
    [anon_sym_LBRACE] = ACTIONS(6458),
    [anon_sym_LT_AT] = ACTIONS(6458),
    [anon_sym_LT_AT_AT] = ACTIONS(6456),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6456),
    [anon_sym_new] = ACTIONS(6458),
    [anon_sym_return_BANG] = ACTIONS(6456),
    [anon_sym_yield] = ACTIONS(6458),
    [anon_sym_yield_BANG] = ACTIONS(6456),
    [anon_sym_lazy] = ACTIONS(6458),
    [anon_sym_assert] = ACTIONS(6458),
    [anon_sym_upcast] = ACTIONS(6458),
    [anon_sym_downcast] = ACTIONS(6458),
    [anon_sym_for] = ACTIONS(6458),
    [anon_sym_while] = ACTIONS(6458),
    [anon_sym_if] = ACTIONS(6458),
    [anon_sym_fun] = ACTIONS(6458),
    [anon_sym_try] = ACTIONS(6458),
    [anon_sym_match] = ACTIONS(6458),
    [anon_sym_match_BANG] = ACTIONS(6456),
    [anon_sym_function] = ACTIONS(6458),
    [anon_sym_use] = ACTIONS(6458),
    [anon_sym_use_BANG] = ACTIONS(6456),
    [anon_sym_do_BANG] = ACTIONS(6456),
    [anon_sym_begin] = ACTIONS(6458),
    [aux_sym_char_token1] = ACTIONS(6456),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6458),
    [anon_sym_DQUOTE] = ACTIONS(6458),
    [anon_sym_AT_DQUOTE] = ACTIONS(6456),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6456),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6456),
    [sym_bool] = ACTIONS(6458),
    [sym_unit] = ACTIONS(6456),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6458),
    [sym_op_identifier] = ACTIONS(6456),
    [anon_sym_PLUS] = ACTIONS(6458),
    [anon_sym_DASH] = ACTIONS(6458),
    [anon_sym_PLUS_DOT] = ACTIONS(6456),
    [anon_sym_DASH_DOT] = ACTIONS(6456),
    [anon_sym_PERCENT] = ACTIONS(6456),
    [anon_sym_AMP_AMP] = ACTIONS(6456),
    [anon_sym_TILDE] = ACTIONS(6456),
    [aux_sym_prefix_op_token1] = ACTIONS(6456),
    [sym_int] = ACTIONS(6458),
    [sym_xint] = ACTIONS(6456),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6456),
  },
  [4298] = {
    [sym_block_comment] = STATE(4298),
    [sym_compiler_directive_decl] = STATE(4298),
    [sym_fsi_directive_decl] = STATE(4298),
    [sym_preproc_line] = STATE(4298),
    [sym_identifier] = ACTIONS(7006),
    [anon_sym_return] = ACTIONS(7006),
    [anon_sym_do] = ACTIONS(7006),
    [anon_sym_let] = ACTIONS(7006),
    [anon_sym_let_BANG] = ACTIONS(7008),
    [anon_sym_LPAREN] = ACTIONS(7006),
    [anon_sym_null] = ACTIONS(7006),
    [anon_sym_AMP] = ACTIONS(7006),
    [anon_sym_LBRACK] = ACTIONS(7006),
    [anon_sym_LBRACK_PIPE] = ACTIONS(7008),
    [anon_sym_LBRACE] = ACTIONS(7006),
    [anon_sym_LT_AT] = ACTIONS(7006),
    [anon_sym_LT_AT_AT] = ACTIONS(7008),
    [anon_sym_LBRACE_PIPE] = ACTIONS(7008),
    [anon_sym_new] = ACTIONS(7006),
    [anon_sym_return_BANG] = ACTIONS(7008),
    [anon_sym_yield] = ACTIONS(7006),
    [anon_sym_yield_BANG] = ACTIONS(7008),
    [anon_sym_lazy] = ACTIONS(7006),
    [anon_sym_assert] = ACTIONS(7006),
    [anon_sym_upcast] = ACTIONS(7006),
    [anon_sym_downcast] = ACTIONS(7006),
    [anon_sym_for] = ACTIONS(7006),
    [anon_sym_while] = ACTIONS(7006),
    [anon_sym_if] = ACTIONS(7006),
    [anon_sym_fun] = ACTIONS(7006),
    [anon_sym_try] = ACTIONS(7006),
    [anon_sym_match] = ACTIONS(7006),
    [anon_sym_match_BANG] = ACTIONS(7008),
    [anon_sym_function] = ACTIONS(7006),
    [anon_sym_use] = ACTIONS(7006),
    [anon_sym_use_BANG] = ACTIONS(7008),
    [anon_sym_do_BANG] = ACTIONS(7008),
    [anon_sym_begin] = ACTIONS(7006),
    [aux_sym_char_token1] = ACTIONS(7008),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(7006),
    [anon_sym_DQUOTE] = ACTIONS(7006),
    [anon_sym_AT_DQUOTE] = ACTIONS(7008),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7008),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(7008),
    [sym_bool] = ACTIONS(7006),
    [sym_unit] = ACTIONS(7008),
    [anon_sym_LPAREN_PIPE] = ACTIONS(7006),
    [sym_op_identifier] = ACTIONS(7008),
    [anon_sym_PLUS] = ACTIONS(7006),
    [anon_sym_DASH] = ACTIONS(7006),
    [anon_sym_PLUS_DOT] = ACTIONS(7008),
    [anon_sym_DASH_DOT] = ACTIONS(7008),
    [anon_sym_PERCENT] = ACTIONS(7008),
    [anon_sym_AMP_AMP] = ACTIONS(7008),
    [anon_sym_TILDE] = ACTIONS(7008),
    [aux_sym_prefix_op_token1] = ACTIONS(7008),
    [sym_int] = ACTIONS(7006),
    [sym_xint] = ACTIONS(7008),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(7008),
  },
  [4299] = {
    [sym_block_comment] = STATE(4299),
    [sym_compiler_directive_decl] = STATE(4299),
    [sym_fsi_directive_decl] = STATE(4299),
    [sym_preproc_line] = STATE(4299),
    [sym_identifier] = ACTIONS(6288),
    [anon_sym_return] = ACTIONS(6288),
    [anon_sym_do] = ACTIONS(6288),
    [anon_sym_let] = ACTIONS(6288),
    [anon_sym_let_BANG] = ACTIONS(6286),
    [anon_sym_LPAREN] = ACTIONS(6288),
    [anon_sym_null] = ACTIONS(6288),
    [anon_sym_AMP] = ACTIONS(6288),
    [anon_sym_LBRACK] = ACTIONS(6288),
    [anon_sym_LBRACK_PIPE] = ACTIONS(6286),
    [anon_sym_LBRACE] = ACTIONS(6288),
    [anon_sym_LT_AT] = ACTIONS(6288),
    [anon_sym_LT_AT_AT] = ACTIONS(6286),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6286),
    [anon_sym_new] = ACTIONS(6288),
    [anon_sym_return_BANG] = ACTIONS(6286),
    [anon_sym_yield] = ACTIONS(6288),
    [anon_sym_yield_BANG] = ACTIONS(6286),
    [anon_sym_lazy] = ACTIONS(6288),
    [anon_sym_assert] = ACTIONS(6288),
    [anon_sym_upcast] = ACTIONS(6288),
    [anon_sym_downcast] = ACTIONS(6288),
    [anon_sym_for] = ACTIONS(6288),
    [anon_sym_while] = ACTIONS(6288),
    [anon_sym_if] = ACTIONS(6288),
    [anon_sym_fun] = ACTIONS(6288),
    [anon_sym_try] = ACTIONS(6288),
    [anon_sym_match] = ACTIONS(6288),
    [anon_sym_match_BANG] = ACTIONS(6286),
    [anon_sym_function] = ACTIONS(6288),
    [anon_sym_use] = ACTIONS(6288),
    [anon_sym_use_BANG] = ACTIONS(6286),
    [anon_sym_do_BANG] = ACTIONS(6286),
    [anon_sym_begin] = ACTIONS(6288),
    [aux_sym_char_token1] = ACTIONS(6286),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(6288),
    [anon_sym_DQUOTE] = ACTIONS(6288),
    [anon_sym_AT_DQUOTE] = ACTIONS(6286),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6286),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(6286),
    [sym_bool] = ACTIONS(6288),
    [sym_unit] = ACTIONS(6286),
    [anon_sym_LPAREN_PIPE] = ACTIONS(6288),
    [sym_op_identifier] = ACTIONS(6286),
    [anon_sym_PLUS] = ACTIONS(6288),
    [anon_sym_DASH] = ACTIONS(6288),
    [anon_sym_PLUS_DOT] = ACTIONS(6286),
    [anon_sym_DASH_DOT] = ACTIONS(6286),
    [anon_sym_PERCENT] = ACTIONS(6286),
    [anon_sym_AMP_AMP] = ACTIONS(6286),
    [anon_sym_TILDE] = ACTIONS(6286),
    [aux_sym_prefix_op_token1] = ACTIONS(6286),
    [sym_int] = ACTIONS(6288),
    [sym_xint] = ACTIONS(6286),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(6286),
  },
  [4300] = {
    [sym_block_comment] = STATE(4300),
    [sym_compiler_directive_decl] = STATE(4300),
    [sym_fsi_directive_decl] = STATE(4300),
    [sym_preproc_line] = STATE(4300),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_return] = ACTIONS(3700),
    [anon_sym_do] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_let_BANG] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3700),
    [anon_sym_null] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3700),
    [anon_sym_LT_AT] = ACTIONS(3700),
    [anon_sym_LT_AT_AT] = ACTIONS(3698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_return_BANG] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_yield_BANG] = ACTIONS(3698),
    [anon_sym_lazy] = ACTIONS(3700),
    [anon_sym_assert] = ACTIONS(3700),
    [anon_sym_upcast] = ACTIONS(3700),
    [anon_sym_downcast] = ACTIONS(3700),
    [anon_sym_for] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(3700),
    [anon_sym_if] = ACTIONS(3700),
    [anon_sym_fun] = ACTIONS(3700),
    [anon_sym_try] = ACTIONS(3700),
    [anon_sym_match] = ACTIONS(3700),
    [anon_sym_match_BANG] = ACTIONS(3698),
    [anon_sym_function] = ACTIONS(3700),
    [anon_sym_use] = ACTIONS(3700),
    [anon_sym_use_BANG] = ACTIONS(3698),
    [anon_sym_do_BANG] = ACTIONS(3698),
    [anon_sym_begin] = ACTIONS(3700),
    [aux_sym_char_token1] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3700),
    [anon_sym_DQUOTE] = ACTIONS(3700),
    [anon_sym_AT_DQUOTE] = ACTIONS(3698),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3698),
    [sym_bool] = ACTIONS(3700),
    [sym_unit] = ACTIONS(3698),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3700),
    [sym_op_identifier] = ACTIONS(3698),
    [anon_sym_PLUS] = ACTIONS(3700),
    [anon_sym_DASH] = ACTIONS(3700),
    [anon_sym_PLUS_DOT] = ACTIONS(3698),
    [anon_sym_DASH_DOT] = ACTIONS(3698),
    [anon_sym_PERCENT] = ACTIONS(3698),
    [anon_sym_AMP_AMP] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [aux_sym_prefix_op_token1] = ACTIONS(3698),
    [sym_int] = ACTIONS(3700),
    [sym_xint] = ACTIONS(3698),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3698),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6714), 1,
      sym_identifier,
    ACTIONS(6716), 1,
      anon_sym_LPAREN,
    ACTIONS(6720), 1,
      anon_sym_LBRACK,
    ACTIONS(6722), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(6724), 1,
      anon_sym_LBRACE,
    ACTIONS(6728), 1,
      aux_sym_char_token1,
    ACTIONS(6730), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(6732), 1,
      anon_sym_DQUOTE,
    ACTIONS(6734), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(6736), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6738), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6740), 1,
      sym_bool,
    ACTIONS(6742), 1,
      sym_unit,
    ACTIONS(6744), 1,
      sym_int,
    ACTIONS(6746), 1,
      sym_xint,
    STATE(4304), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(5738), 1,
      sym_float,
    STATE(6239), 1,
      sym_format_triple_quoted_string,
    STATE(6294), 1,
      sym__atomic_pattern,
    ACTIONS(6718), 2,
      anon_sym_null,
      anon_sym__,
    STATE(6238), 2,
      sym_format_string,
      sym__string_literal,
    ACTIONS(7010), 3,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DASH_GT,
    STATE(4301), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6228), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(6237), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [127] = 34,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6714), 1,
      sym_identifier,
    ACTIONS(6716), 1,
      anon_sym_LPAREN,
    ACTIONS(6720), 1,
      anon_sym_LBRACK,
    ACTIONS(6722), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(6724), 1,
      anon_sym_LBRACE,
    ACTIONS(6726), 1,
      anon_sym_LT2,
    ACTIONS(6728), 1,
      aux_sym_char_token1,
    ACTIONS(6730), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(6732), 1,
      anon_sym_DQUOTE,
    ACTIONS(6734), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(6736), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6738), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6740), 1,
      sym_bool,
    ACTIONS(6742), 1,
      sym_unit,
    ACTIONS(6744), 1,
      sym_int,
    ACTIONS(6746), 1,
      sym_xint,
    STATE(4301), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(4309), 1,
      sym_type_arguments,
    STATE(5738), 1,
      sym_float,
    STATE(6239), 1,
      sym_format_triple_quoted_string,
    STATE(6294), 1,
      sym__atomic_pattern,
    STATE(9378), 1,
      sym_argument_patterns,
    ACTIONS(6718), 2,
      anon_sym_null,
      anon_sym__,
    STATE(6238), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4302), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6228), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(6237), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [258] = 34,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6714), 1,
      sym_identifier,
    ACTIONS(6716), 1,
      anon_sym_LPAREN,
    ACTIONS(6720), 1,
      anon_sym_LBRACK,
    ACTIONS(6722), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(6724), 1,
      anon_sym_LBRACE,
    ACTIONS(6726), 1,
      anon_sym_LT2,
    ACTIONS(6728), 1,
      aux_sym_char_token1,
    ACTIONS(6730), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(6732), 1,
      anon_sym_DQUOTE,
    ACTIONS(6734), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(6736), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6738), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6740), 1,
      sym_bool,
    ACTIONS(6742), 1,
      sym_unit,
    ACTIONS(6744), 1,
      sym_int,
    ACTIONS(6746), 1,
      sym_xint,
    STATE(4301), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(4311), 1,
      sym_type_arguments,
    STATE(5738), 1,
      sym_float,
    STATE(6239), 1,
      sym_format_triple_quoted_string,
    STATE(6294), 1,
      sym__atomic_pattern,
    STATE(9998), 1,
      sym_argument_patterns,
    ACTIONS(6718), 2,
      anon_sym_null,
      anon_sym__,
    STATE(6238), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4303), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6228), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(6237), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [389] = 31,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7012), 1,
      sym_identifier,
    ACTIONS(7017), 1,
      anon_sym_LPAREN,
    ACTIONS(7023), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(7029), 1,
      anon_sym_LBRACE,
    ACTIONS(7032), 1,
      aux_sym_char_token1,
    ACTIONS(7035), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(7038), 1,
      anon_sym_DQUOTE,
    ACTIONS(7041), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(7044), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(7047), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(7050), 1,
      sym_bool,
    ACTIONS(7053), 1,
      sym_unit,
    ACTIONS(7056), 1,
      sym_int,
    ACTIONS(7059), 1,
      sym_xint,
    STATE(5738), 1,
      sym_float,
    STATE(6239), 1,
      sym_format_triple_quoted_string,
    STATE(6294), 1,
      sym__atomic_pattern,
    ACTIONS(7020), 2,
      anon_sym_null,
      anon_sym__,
    STATE(6238), 2,
      sym_format_string,
      sym__string_literal,
    ACTIONS(7015), 3,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DASH_GT,
    STATE(4304), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_argument_patterns_repeat1,
    STATE(6228), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(6237), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [514] = 33,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6714), 1,
      sym_identifier,
    ACTIONS(6716), 1,
      anon_sym_LPAREN,
    ACTIONS(6720), 1,
      anon_sym_LBRACK,
    ACTIONS(6722), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(6724), 1,
      anon_sym_LBRACE,
    ACTIONS(6728), 1,
      aux_sym_char_token1,
    ACTIONS(6730), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(6732), 1,
      anon_sym_DQUOTE,
    ACTIONS(6734), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(6736), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6738), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6740), 1,
      sym_bool,
    ACTIONS(6742), 1,
      sym_unit,
    ACTIONS(6744), 1,
      sym_int,
    ACTIONS(6746), 1,
      sym_xint,
    STATE(4301), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(5738), 1,
      sym_float,
    STATE(6239), 1,
      sym_format_triple_quoted_string,
    STATE(6294), 1,
      sym__atomic_pattern,
    STATE(9541), 1,
      sym_argument_patterns,
    STATE(9548), 1,
      sym__property_accessor_body,
    ACTIONS(6718), 2,
      anon_sym_null,
      anon_sym__,
    STATE(6238), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4305), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6228), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(6237), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [642] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6714), 1,
      sym_identifier,
    ACTIONS(6716), 1,
      anon_sym_LPAREN,
    ACTIONS(6720), 1,
      anon_sym_LBRACK,
    ACTIONS(6722), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(6724), 1,
      anon_sym_LBRACE,
    ACTIONS(6728), 1,
      aux_sym_char_token1,
    ACTIONS(6730), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(6732), 1,
      anon_sym_DQUOTE,
    ACTIONS(6734), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(6736), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6738), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6740), 1,
      sym_bool,
    ACTIONS(6742), 1,
      sym_unit,
    ACTIONS(6744), 1,
      sym_int,
    ACTIONS(6746), 1,
      sym_xint,
    STATE(4301), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(5738), 1,
      sym_float,
    STATE(6239), 1,
      sym_format_triple_quoted_string,
    STATE(6294), 1,
      sym__atomic_pattern,
    STATE(10436), 1,
      sym_argument_patterns,
    ACTIONS(6718), 2,
      anon_sym_null,
      anon_sym__,
    STATE(6238), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4306), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6228), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(6237), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [767] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6714), 1,
      sym_identifier,
    ACTIONS(6716), 1,
      anon_sym_LPAREN,
    ACTIONS(6720), 1,
      anon_sym_LBRACK,
    ACTIONS(6722), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(6724), 1,
      anon_sym_LBRACE,
    ACTIONS(6728), 1,
      aux_sym_char_token1,
    ACTIONS(6730), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(6732), 1,
      anon_sym_DQUOTE,
    ACTIONS(6734), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(6736), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6738), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6740), 1,
      sym_bool,
    ACTIONS(6742), 1,
      sym_unit,
    ACTIONS(6744), 1,
      sym_int,
    ACTIONS(6746), 1,
      sym_xint,
    STATE(4301), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(5738), 1,
      sym_float,
    STATE(6239), 1,
      sym_format_triple_quoted_string,
    STATE(6294), 1,
      sym__atomic_pattern,
    STATE(10632), 1,
      sym_argument_patterns,
    ACTIONS(6718), 2,
      anon_sym_null,
      anon_sym__,
    STATE(6238), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4307), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6228), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(6237), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [892] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6714), 1,
      sym_identifier,
    ACTIONS(6716), 1,
      anon_sym_LPAREN,
    ACTIONS(6720), 1,
      anon_sym_LBRACK,
    ACTIONS(6722), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(6724), 1,
      anon_sym_LBRACE,
    ACTIONS(6728), 1,
      aux_sym_char_token1,
    ACTIONS(6730), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(6732), 1,
      anon_sym_DQUOTE,
    ACTIONS(6734), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(6736), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6738), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6740), 1,
      sym_bool,
    ACTIONS(6742), 1,
      sym_unit,
    ACTIONS(6744), 1,
      sym_int,
    ACTIONS(6746), 1,
      sym_xint,
    STATE(4301), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(5738), 1,
      sym_float,
    STATE(6239), 1,
      sym_format_triple_quoted_string,
    STATE(6294), 1,
      sym__atomic_pattern,
    STATE(10291), 1,
      sym_argument_patterns,
    ACTIONS(6718), 2,
      anon_sym_null,
      anon_sym__,
    STATE(6238), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4308), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6228), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(6237), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [1017] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6714), 1,
      sym_identifier,
    ACTIONS(6716), 1,
      anon_sym_LPAREN,
    ACTIONS(6720), 1,
      anon_sym_LBRACK,
    ACTIONS(6722), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(6724), 1,
      anon_sym_LBRACE,
    ACTIONS(6728), 1,
      aux_sym_char_token1,
    ACTIONS(6730), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(6732), 1,
      anon_sym_DQUOTE,
    ACTIONS(6734), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(6736), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6738), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6740), 1,
      sym_bool,
    ACTIONS(6742), 1,
      sym_unit,
    ACTIONS(6744), 1,
      sym_int,
    ACTIONS(6746), 1,
      sym_xint,
    STATE(4301), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(5738), 1,
      sym_float,
    STATE(6239), 1,
      sym_format_triple_quoted_string,
    STATE(6294), 1,
      sym__atomic_pattern,
    STATE(9928), 1,
      sym_argument_patterns,
    ACTIONS(6718), 2,
      anon_sym_null,
      anon_sym__,
    STATE(6238), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4309), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6228), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(6237), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [1142] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6714), 1,
      sym_identifier,
    ACTIONS(6716), 1,
      anon_sym_LPAREN,
    ACTIONS(6720), 1,
      anon_sym_LBRACK,
    ACTIONS(6722), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(6724), 1,
      anon_sym_LBRACE,
    ACTIONS(6728), 1,
      aux_sym_char_token1,
    ACTIONS(6730), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(6732), 1,
      anon_sym_DQUOTE,
    ACTIONS(6734), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(6736), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6738), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6740), 1,
      sym_bool,
    ACTIONS(6742), 1,
      sym_unit,
    ACTIONS(6744), 1,
      sym_int,
    ACTIONS(6746), 1,
      sym_xint,
    STATE(4301), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(5738), 1,
      sym_float,
    STATE(6239), 1,
      sym_format_triple_quoted_string,
    STATE(6294), 1,
      sym__atomic_pattern,
    STATE(10505), 1,
      sym_argument_patterns,
    ACTIONS(6718), 2,
      anon_sym_null,
      anon_sym__,
    STATE(6238), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4310), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6228), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(6237), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [1267] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6714), 1,
      sym_identifier,
    ACTIONS(6716), 1,
      anon_sym_LPAREN,
    ACTIONS(6720), 1,
      anon_sym_LBRACK,
    ACTIONS(6722), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(6724), 1,
      anon_sym_LBRACE,
    ACTIONS(6728), 1,
      aux_sym_char_token1,
    ACTIONS(6730), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(6732), 1,
      anon_sym_DQUOTE,
    ACTIONS(6734), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(6736), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6738), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6740), 1,
      sym_bool,
    ACTIONS(6742), 1,
      sym_unit,
    ACTIONS(6744), 1,
      sym_int,
    ACTIONS(6746), 1,
      sym_xint,
    STATE(4301), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(5738), 1,
      sym_float,
    STATE(6239), 1,
      sym_format_triple_quoted_string,
    STATE(6294), 1,
      sym__atomic_pattern,
    STATE(9378), 1,
      sym_argument_patterns,
    ACTIONS(6718), 2,
      anon_sym_null,
      anon_sym__,
    STATE(6238), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4311), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6228), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(6237), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [1392] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6714), 1,
      sym_identifier,
    ACTIONS(6716), 1,
      anon_sym_LPAREN,
    ACTIONS(6720), 1,
      anon_sym_LBRACK,
    ACTIONS(6722), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(6724), 1,
      anon_sym_LBRACE,
    ACTIONS(6728), 1,
      aux_sym_char_token1,
    ACTIONS(6730), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(6732), 1,
      anon_sym_DQUOTE,
    ACTIONS(6734), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(6736), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6738), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6740), 1,
      sym_bool,
    ACTIONS(6742), 1,
      sym_unit,
    ACTIONS(6744), 1,
      sym_int,
    ACTIONS(6746), 1,
      sym_xint,
    STATE(4301), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(5738), 1,
      sym_float,
    STATE(6239), 1,
      sym_format_triple_quoted_string,
    STATE(6294), 1,
      sym__atomic_pattern,
    STATE(10898), 1,
      sym_argument_patterns,
    ACTIONS(6718), 2,
      anon_sym_null,
      anon_sym__,
    STATE(6238), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4312), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6228), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(6237), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [1517] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6714), 1,
      sym_identifier,
    ACTIONS(6716), 1,
      anon_sym_LPAREN,
    ACTIONS(6720), 1,
      anon_sym_LBRACK,
    ACTIONS(6722), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(6724), 1,
      anon_sym_LBRACE,
    ACTIONS(6728), 1,
      aux_sym_char_token1,
    ACTIONS(6730), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(6732), 1,
      anon_sym_DQUOTE,
    ACTIONS(6734), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(6736), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6738), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6740), 1,
      sym_bool,
    ACTIONS(6742), 1,
      sym_unit,
    ACTIONS(6744), 1,
      sym_int,
    ACTIONS(6746), 1,
      sym_xint,
    STATE(4301), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(5738), 1,
      sym_float,
    STATE(6239), 1,
      sym_format_triple_quoted_string,
    STATE(6294), 1,
      sym__atomic_pattern,
    STATE(11727), 1,
      sym_argument_patterns,
    ACTIONS(6718), 2,
      anon_sym_null,
      anon_sym__,
    STATE(6238), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4313), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6228), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(6237), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [1642] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6714), 1,
      sym_identifier,
    ACTIONS(6716), 1,
      anon_sym_LPAREN,
    ACTIONS(6720), 1,
      anon_sym_LBRACK,
    ACTIONS(6722), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(6724), 1,
      anon_sym_LBRACE,
    ACTIONS(6728), 1,
      aux_sym_char_token1,
    ACTIONS(6730), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(6732), 1,
      anon_sym_DQUOTE,
    ACTIONS(6734), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(6736), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6738), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6740), 1,
      sym_bool,
    ACTIONS(6742), 1,
      sym_unit,
    ACTIONS(6744), 1,
      sym_int,
    ACTIONS(6746), 1,
      sym_xint,
    STATE(4301), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(5738), 1,
      sym_float,
    STATE(6239), 1,
      sym_format_triple_quoted_string,
    STATE(6294), 1,
      sym__atomic_pattern,
    STATE(10690), 1,
      sym_argument_patterns,
    ACTIONS(6718), 2,
      anon_sym_null,
      anon_sym__,
    STATE(6238), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4314), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6228), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(6237), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [1767] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6714), 1,
      sym_identifier,
    ACTIONS(6716), 1,
      anon_sym_LPAREN,
    ACTIONS(6720), 1,
      anon_sym_LBRACK,
    ACTIONS(6722), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(6724), 1,
      anon_sym_LBRACE,
    ACTIONS(6728), 1,
      aux_sym_char_token1,
    ACTIONS(6730), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(6732), 1,
      anon_sym_DQUOTE,
    ACTIONS(6734), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(6736), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6738), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6740), 1,
      sym_bool,
    ACTIONS(6742), 1,
      sym_unit,
    ACTIONS(6744), 1,
      sym_int,
    ACTIONS(6746), 1,
      sym_xint,
    STATE(4301), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(5738), 1,
      sym_float,
    STATE(6239), 1,
      sym_format_triple_quoted_string,
    STATE(6294), 1,
      sym__atomic_pattern,
    STATE(10858), 1,
      sym_argument_patterns,
    ACTIONS(6718), 2,
      anon_sym_null,
      anon_sym__,
    STATE(6238), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4315), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6228), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(6237), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [1892] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6714), 1,
      sym_identifier,
    ACTIONS(6716), 1,
      anon_sym_LPAREN,
    ACTIONS(6720), 1,
      anon_sym_LBRACK,
    ACTIONS(6722), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(6724), 1,
      anon_sym_LBRACE,
    ACTIONS(6728), 1,
      aux_sym_char_token1,
    ACTIONS(6730), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(6732), 1,
      anon_sym_DQUOTE,
    ACTIONS(6734), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(6736), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6738), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6740), 1,
      sym_bool,
    ACTIONS(6742), 1,
      sym_unit,
    ACTIONS(6744), 1,
      sym_int,
    ACTIONS(6746), 1,
      sym_xint,
    STATE(4301), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(5738), 1,
      sym_float,
    STATE(6239), 1,
      sym_format_triple_quoted_string,
    STATE(6294), 1,
      sym__atomic_pattern,
    STATE(10297), 1,
      sym_argument_patterns,
    ACTIONS(6718), 2,
      anon_sym_null,
      anon_sym__,
    STATE(6238), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4316), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6228), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(6237), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [2017] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6714), 1,
      sym_identifier,
    ACTIONS(6716), 1,
      anon_sym_LPAREN,
    ACTIONS(6720), 1,
      anon_sym_LBRACK,
    ACTIONS(6722), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(6724), 1,
      anon_sym_LBRACE,
    ACTIONS(6728), 1,
      aux_sym_char_token1,
    ACTIONS(6730), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(6732), 1,
      anon_sym_DQUOTE,
    ACTIONS(6734), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(6736), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6738), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6740), 1,
      sym_bool,
    ACTIONS(6742), 1,
      sym_unit,
    ACTIONS(6744), 1,
      sym_int,
    ACTIONS(6746), 1,
      sym_xint,
    STATE(4301), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(5738), 1,
      sym_float,
    STATE(6239), 1,
      sym_format_triple_quoted_string,
    STATE(6294), 1,
      sym__atomic_pattern,
    STATE(10201), 1,
      sym_argument_patterns,
    ACTIONS(6718), 2,
      anon_sym_null,
      anon_sym__,
    STATE(6238), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4317), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6228), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(6237), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [2142] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6714), 1,
      sym_identifier,
    ACTIONS(6716), 1,
      anon_sym_LPAREN,
    ACTIONS(6720), 1,
      anon_sym_LBRACK,
    ACTIONS(6722), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(6724), 1,
      anon_sym_LBRACE,
    ACTIONS(6728), 1,
      aux_sym_char_token1,
    ACTIONS(6730), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(6732), 1,
      anon_sym_DQUOTE,
    ACTIONS(6734), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(6736), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6738), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6740), 1,
      sym_bool,
    ACTIONS(6742), 1,
      sym_unit,
    ACTIONS(6744), 1,
      sym_int,
    ACTIONS(6746), 1,
      sym_xint,
    STATE(4301), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(5738), 1,
      sym_float,
    STATE(6239), 1,
      sym_format_triple_quoted_string,
    STATE(6294), 1,
      sym__atomic_pattern,
    STATE(9998), 1,
      sym_argument_patterns,
    ACTIONS(6718), 2,
      anon_sym_null,
      anon_sym__,
    STATE(6238), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4318), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6228), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(6237), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [2267] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6714), 1,
      sym_identifier,
    ACTIONS(6716), 1,
      anon_sym_LPAREN,
    ACTIONS(6720), 1,
      anon_sym_LBRACK,
    ACTIONS(6722), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(6724), 1,
      anon_sym_LBRACE,
    ACTIONS(6728), 1,
      aux_sym_char_token1,
    ACTIONS(6730), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(6732), 1,
      anon_sym_DQUOTE,
    ACTIONS(6734), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(6736), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6738), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6740), 1,
      sym_bool,
    ACTIONS(6742), 1,
      sym_unit,
    ACTIONS(6744), 1,
      sym_int,
    ACTIONS(6746), 1,
      sym_xint,
    STATE(4301), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(5738), 1,
      sym_float,
    STATE(6239), 1,
      sym_format_triple_quoted_string,
    STATE(6294), 1,
      sym__atomic_pattern,
    STATE(10818), 1,
      sym_argument_patterns,
    ACTIONS(6718), 2,
      anon_sym_null,
      anon_sym__,
    STATE(6238), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4319), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6228), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(6237), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [2392] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6714), 1,
      sym_identifier,
    ACTIONS(6716), 1,
      anon_sym_LPAREN,
    ACTIONS(6720), 1,
      anon_sym_LBRACK,
    ACTIONS(6722), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(6724), 1,
      anon_sym_LBRACE,
    ACTIONS(6728), 1,
      aux_sym_char_token1,
    ACTIONS(6730), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(6732), 1,
      anon_sym_DQUOTE,
    ACTIONS(6734), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(6736), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6738), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6740), 1,
      sym_bool,
    ACTIONS(6742), 1,
      sym_unit,
    ACTIONS(6744), 1,
      sym_int,
    ACTIONS(6746), 1,
      sym_xint,
    STATE(4301), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(5738), 1,
      sym_float,
    STATE(6239), 1,
      sym_format_triple_quoted_string,
    STATE(6294), 1,
      sym__atomic_pattern,
    STATE(10776), 1,
      sym_argument_patterns,
    ACTIONS(6718), 2,
      anon_sym_null,
      anon_sym__,
    STATE(6238), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4320), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6228), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(6237), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [2517] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6714), 1,
      sym_identifier,
    ACTIONS(6716), 1,
      anon_sym_LPAREN,
    ACTIONS(6720), 1,
      anon_sym_LBRACK,
    ACTIONS(6722), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(6724), 1,
      anon_sym_LBRACE,
    ACTIONS(6728), 1,
      aux_sym_char_token1,
    ACTIONS(6730), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(6732), 1,
      anon_sym_DQUOTE,
    ACTIONS(6734), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(6736), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6738), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6740), 1,
      sym_bool,
    ACTIONS(6742), 1,
      sym_unit,
    ACTIONS(6744), 1,
      sym_int,
    ACTIONS(6746), 1,
      sym_xint,
    STATE(4301), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(5738), 1,
      sym_float,
    STATE(6239), 1,
      sym_format_triple_quoted_string,
    STATE(6294), 1,
      sym__atomic_pattern,
    STATE(10367), 1,
      sym_argument_patterns,
    ACTIONS(6718), 2,
      anon_sym_null,
      anon_sym__,
    STATE(6238), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4321), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6228), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(6237), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [2642] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6714), 1,
      sym_identifier,
    ACTIONS(6716), 1,
      anon_sym_LPAREN,
    ACTIONS(6720), 1,
      anon_sym_LBRACK,
    ACTIONS(6722), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(6724), 1,
      anon_sym_LBRACE,
    ACTIONS(6728), 1,
      aux_sym_char_token1,
    ACTIONS(6730), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(6732), 1,
      anon_sym_DQUOTE,
    ACTIONS(6734), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(6736), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6738), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6740), 1,
      sym_bool,
    ACTIONS(6742), 1,
      sym_unit,
    ACTIONS(6744), 1,
      sym_int,
    ACTIONS(6746), 1,
      sym_xint,
    STATE(4301), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(5738), 1,
      sym_float,
    STATE(6239), 1,
      sym_format_triple_quoted_string,
    STATE(6294), 1,
      sym__atomic_pattern,
    STATE(10734), 1,
      sym_argument_patterns,
    ACTIONS(6718), 2,
      anon_sym_null,
      anon_sym__,
    STATE(6238), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4322), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6228), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(6237), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [2767] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6714), 1,
      sym_identifier,
    ACTIONS(6716), 1,
      anon_sym_LPAREN,
    ACTIONS(6720), 1,
      anon_sym_LBRACK,
    ACTIONS(6722), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(6724), 1,
      anon_sym_LBRACE,
    ACTIONS(6728), 1,
      aux_sym_char_token1,
    ACTIONS(6730), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(6732), 1,
      anon_sym_DQUOTE,
    ACTIONS(6734), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(6736), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6738), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6740), 1,
      sym_bool,
    ACTIONS(6742), 1,
      sym_unit,
    ACTIONS(6744), 1,
      sym_int,
    ACTIONS(6746), 1,
      sym_xint,
    STATE(4301), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(5738), 1,
      sym_float,
    STATE(6239), 1,
      sym_format_triple_quoted_string,
    STATE(6294), 1,
      sym__atomic_pattern,
    STATE(10232), 1,
      sym_argument_patterns,
    ACTIONS(6718), 2,
      anon_sym_null,
      anon_sym__,
    STATE(6238), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4323), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6228), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(6237), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [2892] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6714), 1,
      sym_identifier,
    ACTIONS(6716), 1,
      anon_sym_LPAREN,
    ACTIONS(6720), 1,
      anon_sym_LBRACK,
    ACTIONS(6722), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(6724), 1,
      anon_sym_LBRACE,
    ACTIONS(6728), 1,
      aux_sym_char_token1,
    ACTIONS(6730), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(6732), 1,
      anon_sym_DQUOTE,
    ACTIONS(6734), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(6736), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6738), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6740), 1,
      sym_bool,
    ACTIONS(6742), 1,
      sym_unit,
    ACTIONS(6744), 1,
      sym_int,
    ACTIONS(6746), 1,
      sym_xint,
    STATE(4301), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(5738), 1,
      sym_float,
    STATE(6239), 1,
      sym_format_triple_quoted_string,
    STATE(6294), 1,
      sym__atomic_pattern,
    STATE(10573), 1,
      sym_argument_patterns,
    ACTIONS(6718), 2,
      anon_sym_null,
      anon_sym__,
    STATE(6238), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4324), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6228), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(6237), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [3017] = 24,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7062), 1,
      anon_sym_y,
    ACTIONS(7064), 1,
      anon_sym_uy,
    ACTIONS(7066), 1,
      anon_sym_s,
    ACTIONS(7068), 1,
      anon_sym_us,
    ACTIONS(7070), 1,
      anon_sym_l,
    ACTIONS(7072), 1,
      aux_sym_uint32_token1,
    ACTIONS(7074), 1,
      anon_sym_n,
    ACTIONS(7076), 1,
      anon_sym_un,
    ACTIONS(7078), 1,
      anon_sym_L,
    ACTIONS(7080), 1,
      aux_sym_uint64_token1,
    ACTIONS(7082), 1,
      aux_sym_bignum_token1,
    ACTIONS(7084), 1,
      aux_sym_decimal_token1,
    ACTIONS(7086), 1,
      anon_sym_DOT2,
    ACTIONS(7088), 1,
      aux_sym_float_token1,
    STATE(4325), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3193), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3191), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [3122] = 24,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7090), 1,
      anon_sym_y,
    ACTIONS(7092), 1,
      anon_sym_uy,
    ACTIONS(7094), 1,
      anon_sym_s,
    ACTIONS(7096), 1,
      anon_sym_us,
    ACTIONS(7098), 1,
      anon_sym_l,
    ACTIONS(7100), 1,
      aux_sym_uint32_token1,
    ACTIONS(7102), 1,
      anon_sym_n,
    ACTIONS(7104), 1,
      anon_sym_un,
    ACTIONS(7106), 1,
      anon_sym_L,
    ACTIONS(7108), 1,
      aux_sym_uint64_token1,
    ACTIONS(7110), 1,
      aux_sym_bignum_token1,
    ACTIONS(7112), 1,
      aux_sym_decimal_token1,
    ACTIONS(7114), 1,
      anon_sym_DOT2,
    ACTIONS(7116), 1,
      aux_sym_float_token1,
    STATE(4326), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3193), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3191), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [3227] = 24,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7118), 1,
      anon_sym_y,
    ACTIONS(7120), 1,
      anon_sym_uy,
    ACTIONS(7122), 1,
      anon_sym_s,
    ACTIONS(7124), 1,
      anon_sym_us,
    ACTIONS(7126), 1,
      anon_sym_l,
    ACTIONS(7128), 1,
      aux_sym_uint32_token1,
    ACTIONS(7130), 1,
      anon_sym_n,
    ACTIONS(7132), 1,
      anon_sym_un,
    ACTIONS(7134), 1,
      anon_sym_L,
    ACTIONS(7136), 1,
      aux_sym_uint64_token1,
    ACTIONS(7138), 1,
      aux_sym_bignum_token1,
    ACTIONS(7140), 1,
      aux_sym_decimal_token1,
    ACTIONS(7142), 1,
      anon_sym_DOT2,
    ACTIONS(7144), 1,
      aux_sym_float_token1,
    STATE(4327), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3193), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3191), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [3331] = 24,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7146), 1,
      anon_sym_y,
    ACTIONS(7148), 1,
      anon_sym_uy,
    ACTIONS(7150), 1,
      anon_sym_s,
    ACTIONS(7152), 1,
      anon_sym_us,
    ACTIONS(7154), 1,
      anon_sym_l,
    ACTIONS(7156), 1,
      aux_sym_uint32_token1,
    ACTIONS(7158), 1,
      anon_sym_n,
    ACTIONS(7160), 1,
      anon_sym_un,
    ACTIONS(7162), 1,
      anon_sym_L,
    ACTIONS(7164), 1,
      aux_sym_uint64_token1,
    ACTIONS(7166), 1,
      aux_sym_bignum_token1,
    ACTIONS(7168), 1,
      aux_sym_decimal_token1,
    ACTIONS(7170), 1,
      anon_sym_DOT2,
    ACTIONS(7172), 1,
      aux_sym_float_token1,
    STATE(4328), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3193), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3191), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [3435] = 24,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7174), 1,
      anon_sym_y,
    ACTIONS(7176), 1,
      anon_sym_uy,
    ACTIONS(7178), 1,
      anon_sym_s,
    ACTIONS(7180), 1,
      anon_sym_us,
    ACTIONS(7182), 1,
      anon_sym_l,
    ACTIONS(7184), 1,
      aux_sym_uint32_token1,
    ACTIONS(7186), 1,
      anon_sym_n,
    ACTIONS(7188), 1,
      anon_sym_un,
    ACTIONS(7190), 1,
      anon_sym_L,
    ACTIONS(7192), 1,
      aux_sym_uint64_token1,
    ACTIONS(7194), 1,
      aux_sym_bignum_token1,
    ACTIONS(7196), 1,
      aux_sym_decimal_token1,
    ACTIONS(7198), 1,
      anon_sym_DOT2,
    ACTIONS(7200), 1,
      aux_sym_float_token1,
    STATE(4329), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3193), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3191), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [3538] = 22,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7090), 1,
      anon_sym_y,
    ACTIONS(7092), 1,
      anon_sym_uy,
    ACTIONS(7094), 1,
      anon_sym_s,
    ACTIONS(7096), 1,
      anon_sym_us,
    ACTIONS(7098), 1,
      anon_sym_l,
    ACTIONS(7100), 1,
      aux_sym_uint32_token1,
    ACTIONS(7102), 1,
      anon_sym_n,
    ACTIONS(7104), 1,
      anon_sym_un,
    ACTIONS(7106), 1,
      anon_sym_L,
    ACTIONS(7108), 1,
      aux_sym_uint64_token1,
    ACTIONS(7202), 1,
      anon_sym_lf,
    ACTIONS(7204), 1,
      anon_sym_LF,
    STATE(4330), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3193), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3191), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [3637] = 22,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7062), 1,
      anon_sym_y,
    ACTIONS(7064), 1,
      anon_sym_uy,
    ACTIONS(7066), 1,
      anon_sym_s,
    ACTIONS(7068), 1,
      anon_sym_us,
    ACTIONS(7070), 1,
      anon_sym_l,
    ACTIONS(7072), 1,
      aux_sym_uint32_token1,
    ACTIONS(7074), 1,
      anon_sym_n,
    ACTIONS(7076), 1,
      anon_sym_un,
    ACTIONS(7078), 1,
      anon_sym_L,
    ACTIONS(7080), 1,
      aux_sym_uint64_token1,
    ACTIONS(7206), 1,
      anon_sym_lf,
    ACTIONS(7208), 1,
      anon_sym_LF,
    STATE(4331), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3193), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3191), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [3736] = 22,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7146), 1,
      anon_sym_y,
    ACTIONS(7148), 1,
      anon_sym_uy,
    ACTIONS(7150), 1,
      anon_sym_s,
    ACTIONS(7152), 1,
      anon_sym_us,
    ACTIONS(7154), 1,
      anon_sym_l,
    ACTIONS(7156), 1,
      aux_sym_uint32_token1,
    ACTIONS(7158), 1,
      anon_sym_n,
    ACTIONS(7160), 1,
      anon_sym_un,
    ACTIONS(7162), 1,
      anon_sym_L,
    ACTIONS(7164), 1,
      aux_sym_uint64_token1,
    ACTIONS(7210), 1,
      anon_sym_lf,
    ACTIONS(7212), 1,
      anon_sym_LF,
    STATE(4332), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3193), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3191), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [3834] = 22,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7118), 1,
      anon_sym_y,
    ACTIONS(7120), 1,
      anon_sym_uy,
    ACTIONS(7122), 1,
      anon_sym_s,
    ACTIONS(7124), 1,
      anon_sym_us,
    ACTIONS(7126), 1,
      anon_sym_l,
    ACTIONS(7128), 1,
      aux_sym_uint32_token1,
    ACTIONS(7130), 1,
      anon_sym_n,
    ACTIONS(7132), 1,
      anon_sym_un,
    ACTIONS(7134), 1,
      anon_sym_L,
    ACTIONS(7136), 1,
      aux_sym_uint64_token1,
    ACTIONS(7214), 1,
      anon_sym_lf,
    ACTIONS(7216), 1,
      anon_sym_LF,
    STATE(4333), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3193), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3191), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [3932] = 22,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7174), 1,
      anon_sym_y,
    ACTIONS(7176), 1,
      anon_sym_uy,
    ACTIONS(7178), 1,
      anon_sym_s,
    ACTIONS(7180), 1,
      anon_sym_us,
    ACTIONS(7182), 1,
      anon_sym_l,
    ACTIONS(7184), 1,
      aux_sym_uint32_token1,
    ACTIONS(7186), 1,
      anon_sym_n,
    ACTIONS(7188), 1,
      anon_sym_un,
    ACTIONS(7190), 1,
      anon_sym_L,
    ACTIONS(7192), 1,
      aux_sym_uint64_token1,
    ACTIONS(7218), 1,
      anon_sym_lf,
    ACTIONS(7220), 1,
      anon_sym_LF,
    STATE(4334), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3193), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3191), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4029] = 20,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7222), 1,
      sym_identifier,
    ACTIONS(7228), 1,
      anon_sym_DASH_GT,
    ACTIONS(7230), 1,
      anon_sym_when,
    ACTIONS(7232), 1,
      anon_sym_STAR,
    ACTIONS(7234), 1,
      anon_sym_LT2,
    ACTIONS(7236), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4420), 1,
      aux_sym_compound_type_repeat1,
    STATE(4536), 1,
      sym_type_arguments,
    STATE(4549), 1,
      sym_long_identifier,
    STATE(5005), 1,
      sym_type_argument_constraints,
    STATE(4335), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7226), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(7224), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4121] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7238), 1,
      anon_sym_or,
    STATE(4346), 1,
      aux_sym_type_argument_repeat1,
    STATE(4336), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4196] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7222), 1,
      sym_identifier,
    ACTIONS(7228), 1,
      anon_sym_DASH_GT,
    ACTIONS(7232), 1,
      anon_sym_STAR,
    ACTIONS(7234), 1,
      anon_sym_LT2,
    ACTIONS(7236), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4420), 1,
      aux_sym_compound_type_repeat1,
    STATE(4536), 1,
      sym_type_arguments,
    STATE(4549), 1,
      sym_long_identifier,
    STATE(4337), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3427), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3425), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4283] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7240), 1,
      sym_identifier,
    ACTIONS(7242), 1,
      anon_sym_DASH_GT,
    ACTIONS(7244), 1,
      anon_sym_STAR,
    ACTIONS(7246), 1,
      anon_sym_LT2,
    ACTIONS(7248), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4470), 1,
      aux_sym_compound_type_repeat1,
    STATE(4494), 1,
      sym_long_identifier,
    STATE(4502), 1,
      sym_type_arguments,
    STATE(4338), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3407), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3403), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4370] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7240), 1,
      sym_identifier,
    ACTIONS(7242), 1,
      anon_sym_DASH_GT,
    ACTIONS(7244), 1,
      anon_sym_STAR,
    ACTIONS(7246), 1,
      anon_sym_LT2,
    ACTIONS(7248), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4470), 1,
      aux_sym_compound_type_repeat1,
    STATE(4494), 1,
      sym_long_identifier,
    STATE(4502), 1,
      sym_type_arguments,
    STATE(4339), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3419), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3417), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4457] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7222), 1,
      sym_identifier,
    ACTIONS(7228), 1,
      anon_sym_DASH_GT,
    ACTIONS(7232), 1,
      anon_sym_STAR,
    ACTIONS(7234), 1,
      anon_sym_LT2,
    ACTIONS(7236), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4420), 1,
      aux_sym_compound_type_repeat1,
    STATE(4536), 1,
      sym_type_arguments,
    STATE(4549), 1,
      sym_long_identifier,
    STATE(4340), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3419), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3417), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4544] = 20,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7250), 1,
      sym_identifier,
    ACTIONS(7252), 1,
      anon_sym_DASH_GT,
    ACTIONS(7254), 1,
      anon_sym_when,
    ACTIONS(7256), 1,
      anon_sym_STAR,
    ACTIONS(7258), 1,
      anon_sym_LT2,
    ACTIONS(7260), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4511), 1,
      aux_sym_compound_type_repeat1,
    STATE(4591), 1,
      sym_long_identifier,
    STATE(4652), 1,
      sym_type_arguments,
    STATE(5100), 1,
      sym_type_argument_constraints,
    STATE(4341), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7226), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(7224), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4635] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7262), 1,
      anon_sym_or,
    STATE(4344), 1,
      aux_sym_type_argument_repeat1,
    STATE(4342), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4710] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7264), 1,
      anon_sym_or,
    STATE(4343), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3480), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4783] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7262), 1,
      anon_sym_or,
    STATE(4352), 1,
      aux_sym_type_argument_repeat1,
    STATE(4344), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3476), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3474), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4858] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7240), 1,
      sym_identifier,
    ACTIONS(7242), 1,
      anon_sym_DASH_GT,
    ACTIONS(7244), 1,
      anon_sym_STAR,
    ACTIONS(7246), 1,
      anon_sym_LT2,
    ACTIONS(7248), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4470), 1,
      aux_sym_compound_type_repeat1,
    STATE(4494), 1,
      sym_long_identifier,
    STATE(4502), 1,
      sym_type_arguments,
    STATE(4345), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3431), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3429), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4945] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7238), 1,
      anon_sym_or,
    STATE(4343), 1,
      aux_sym_type_argument_repeat1,
    STATE(4346), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3476), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3474), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5020] = 20,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7267), 1,
      sym_identifier,
    ACTIONS(7269), 1,
      anon_sym_DASH_GT,
    ACTIONS(7271), 1,
      anon_sym_when,
    ACTIONS(7273), 1,
      anon_sym_STAR,
    ACTIONS(7275), 1,
      anon_sym_LT2,
    ACTIONS(7277), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4504), 1,
      aux_sym_compound_type_repeat1,
    STATE(4658), 1,
      sym_type_arguments,
    STATE(4673), 1,
      sym_long_identifier,
    STATE(5126), 1,
      sym_type_argument_constraints,
    STATE(4347), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7226), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(7224), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5111] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7222), 1,
      sym_identifier,
    ACTIONS(7228), 1,
      anon_sym_DASH_GT,
    ACTIONS(7232), 1,
      anon_sym_STAR,
    ACTIONS(7234), 1,
      anon_sym_LT2,
    ACTIONS(7236), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4420), 1,
      aux_sym_compound_type_repeat1,
    STATE(4536), 1,
      sym_type_arguments,
    STATE(4549), 1,
      sym_long_identifier,
    STATE(4348), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3431), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3429), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5198] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7242), 1,
      anon_sym_DASH_GT,
    ACTIONS(7244), 1,
      anon_sym_STAR,
    ACTIONS(7246), 1,
      anon_sym_LT2,
    ACTIONS(7248), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4470), 1,
      aux_sym_compound_type_repeat1,
    STATE(4494), 1,
      sym_long_identifier,
    STATE(4502), 1,
      sym_type_arguments,
    STATE(4349), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7279), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7281), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5283] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7242), 1,
      anon_sym_DASH_GT,
    ACTIONS(7244), 1,
      anon_sym_STAR,
    ACTIONS(7246), 1,
      anon_sym_LT2,
    ACTIONS(7248), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4470), 1,
      aux_sym_compound_type_repeat1,
    STATE(4494), 1,
      sym_long_identifier,
    STATE(4502), 1,
      sym_type_arguments,
    STATE(4350), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7283), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7285), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5368] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7222), 1,
      sym_identifier,
    ACTIONS(7228), 1,
      anon_sym_DASH_GT,
    ACTIONS(7232), 1,
      anon_sym_STAR,
    ACTIONS(7234), 1,
      anon_sym_LT2,
    ACTIONS(7236), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4420), 1,
      aux_sym_compound_type_repeat1,
    STATE(4536), 1,
      sym_type_arguments,
    STATE(4549), 1,
      sym_long_identifier,
    STATE(4351), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3407), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3403), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5455] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7287), 1,
      anon_sym_or,
    STATE(4352), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3480), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5528] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7240), 1,
      sym_identifier,
    ACTIONS(7242), 1,
      anon_sym_DASH_GT,
    ACTIONS(7244), 1,
      anon_sym_STAR,
    ACTIONS(7246), 1,
      anon_sym_LT2,
    ACTIONS(7248), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4470), 1,
      aux_sym_compound_type_repeat1,
    STATE(4494), 1,
      sym_long_identifier,
    STATE(4502), 1,
      sym_type_arguments,
    STATE(4353), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3427), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3425), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5615] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7290), 1,
      anon_sym_or,
    STATE(4394), 1,
      aux_sym_type_argument_repeat1,
    STATE(4354), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3476), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3474), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5689] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7267), 1,
      sym_identifier,
    ACTIONS(7269), 1,
      anon_sym_DASH_GT,
    ACTIONS(7273), 1,
      anon_sym_STAR,
    ACTIONS(7275), 1,
      anon_sym_LT2,
    ACTIONS(7277), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4504), 1,
      aux_sym_compound_type_repeat1,
    STATE(4658), 1,
      sym_type_arguments,
    STATE(4673), 1,
      sym_long_identifier,
    STATE(4355), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3427), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3425), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5775] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7292), 1,
      sym_identifier,
    ACTIONS(7294), 1,
      anon_sym_DASH_GT,
    ACTIONS(7296), 1,
      anon_sym_STAR,
    ACTIONS(7298), 1,
      anon_sym_LT2,
    ACTIONS(7300), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4489), 1,
      aux_sym_compound_type_repeat1,
    STATE(4667), 1,
      sym_long_identifier,
    STATE(4671), 1,
      sym_type_arguments,
    STATE(4356), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3419), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3417), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5861] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7302), 1,
      anon_sym_DASH_GT,
    ACTIONS(7304), 1,
      anon_sym_STAR,
    ACTIONS(7306), 1,
      anon_sym_LT2,
    ACTIONS(7308), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4528), 1,
      aux_sym_compound_type_repeat1,
    STATE(4635), 1,
      sym_long_identifier,
    STATE(4664), 1,
      sym_type_arguments,
    STATE(4357), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7279), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7281), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5945] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7310), 1,
      sym_identifier,
    ACTIONS(7316), 1,
      anon_sym_DASH_GT,
    ACTIONS(7318), 1,
      anon_sym_STAR,
    ACTIONS(7320), 1,
      anon_sym_LT2,
    ACTIONS(7322), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4515), 1,
      aux_sym_compound_type_repeat1,
    STATE(4593), 1,
      sym_long_identifier,
    STATE(4648), 1,
      sym_type_arguments,
    STATE(4358), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7314), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(7312), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6031] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7302), 1,
      anon_sym_DASH_GT,
    ACTIONS(7304), 1,
      anon_sym_STAR,
    ACTIONS(7306), 1,
      anon_sym_LT2,
    ACTIONS(7308), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7324), 1,
      sym_identifier,
    STATE(4528), 1,
      aux_sym_compound_type_repeat1,
    STATE(4635), 1,
      sym_long_identifier,
    STATE(4664), 1,
      sym_type_arguments,
    STATE(4359), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3419), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3417), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6117] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7294), 1,
      anon_sym_DASH_GT,
    ACTIONS(7296), 1,
      anon_sym_STAR,
    ACTIONS(7298), 1,
      anon_sym_LT2,
    ACTIONS(7300), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4489), 1,
      aux_sym_compound_type_repeat1,
    STATE(4667), 1,
      sym_long_identifier,
    STATE(4671), 1,
      sym_type_arguments,
    STATE(4360), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7279), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7281), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6201] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7326), 1,
      anon_sym_or,
    STATE(4366), 1,
      aux_sym_type_argument_repeat1,
    STATE(4361), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6275] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7294), 1,
      anon_sym_DASH_GT,
    ACTIONS(7296), 1,
      anon_sym_STAR,
    ACTIONS(7298), 1,
      anon_sym_LT2,
    ACTIONS(7300), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4489), 1,
      aux_sym_compound_type_repeat1,
    STATE(4667), 1,
      sym_long_identifier,
    STATE(4671), 1,
      sym_type_arguments,
    STATE(4362), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7283), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7285), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6359] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7250), 1,
      sym_identifier,
    ACTIONS(7252), 1,
      anon_sym_DASH_GT,
    ACTIONS(7256), 1,
      anon_sym_STAR,
    ACTIONS(7258), 1,
      anon_sym_LT2,
    ACTIONS(7260), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4511), 1,
      aux_sym_compound_type_repeat1,
    STATE(4591), 1,
      sym_long_identifier,
    STATE(4652), 1,
      sym_type_arguments,
    STATE(4363), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3427), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3425), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6445] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7310), 1,
      sym_identifier,
    ACTIONS(7316), 1,
      anon_sym_DASH_GT,
    ACTIONS(7318), 1,
      anon_sym_STAR,
    ACTIONS(7320), 1,
      anon_sym_LT2,
    ACTIONS(7322), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4515), 1,
      aux_sym_compound_type_repeat1,
    STATE(4593), 1,
      sym_long_identifier,
    STATE(4648), 1,
      sym_type_arguments,
    STATE(4364), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3407), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3403), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6531] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7310), 1,
      sym_identifier,
    ACTIONS(7316), 1,
      anon_sym_DASH_GT,
    ACTIONS(7318), 1,
      anon_sym_STAR,
    ACTIONS(7320), 1,
      anon_sym_LT2,
    ACTIONS(7322), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4515), 1,
      aux_sym_compound_type_repeat1,
    STATE(4593), 1,
      sym_long_identifier,
    STATE(4648), 1,
      sym_type_arguments,
    STATE(4365), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3427), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3425), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6617] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7326), 1,
      anon_sym_or,
    STATE(4379), 1,
      aux_sym_type_argument_repeat1,
    STATE(4366), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3476), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3474), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6691] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7328), 1,
      anon_sym_or,
    STATE(4367), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3480), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6763] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7310), 1,
      sym_identifier,
    ACTIONS(7316), 1,
      anon_sym_DASH_GT,
    ACTIONS(7318), 1,
      anon_sym_STAR,
    ACTIONS(7320), 1,
      anon_sym_LT2,
    ACTIONS(7322), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4515), 1,
      aux_sym_compound_type_repeat1,
    STATE(4593), 1,
      sym_long_identifier,
    STATE(4648), 1,
      sym_type_arguments,
    STATE(4368), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3431), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3429), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6849] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7250), 1,
      sym_identifier,
    ACTIONS(7252), 1,
      anon_sym_DASH_GT,
    ACTIONS(7256), 1,
      anon_sym_STAR,
    ACTIONS(7258), 1,
      anon_sym_LT2,
    ACTIONS(7260), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4511), 1,
      aux_sym_compound_type_repeat1,
    STATE(4591), 1,
      sym_long_identifier,
    STATE(4652), 1,
      sym_type_arguments,
    STATE(4369), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3431), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3429), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6935] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4370), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3480), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7005] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7331), 1,
      anon_sym_or,
    STATE(4372), 1,
      aux_sym_type_argument_repeat1,
    STATE(4371), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3476), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3474), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7079] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7333), 1,
      anon_sym_or,
    STATE(4372), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3480), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7151] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7250), 1,
      sym_identifier,
    ACTIONS(7252), 1,
      anon_sym_DASH_GT,
    ACTIONS(7256), 1,
      anon_sym_STAR,
    ACTIONS(7258), 1,
      anon_sym_LT2,
    ACTIONS(7260), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4511), 1,
      aux_sym_compound_type_repeat1,
    STATE(4591), 1,
      sym_long_identifier,
    STATE(4652), 1,
      sym_type_arguments,
    STATE(4373), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3419), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3417), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7237] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4374), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3480), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7307] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7336), 1,
      anon_sym_or,
    STATE(4393), 1,
      aux_sym_type_argument_repeat1,
    STATE(4375), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7381] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7250), 1,
      sym_identifier,
    ACTIONS(7252), 1,
      anon_sym_DASH_GT,
    ACTIONS(7256), 1,
      anon_sym_STAR,
    ACTIONS(7258), 1,
      anon_sym_LT2,
    ACTIONS(7260), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4511), 1,
      aux_sym_compound_type_repeat1,
    STATE(4591), 1,
      sym_long_identifier,
    STATE(4652), 1,
      sym_type_arguments,
    STATE(4376), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3407), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3403), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7467] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4377), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3511), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3509), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7537] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7267), 1,
      sym_identifier,
    ACTIONS(7269), 1,
      anon_sym_DASH_GT,
    ACTIONS(7273), 1,
      anon_sym_STAR,
    ACTIONS(7275), 1,
      anon_sym_LT2,
    ACTIONS(7277), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4504), 1,
      aux_sym_compound_type_repeat1,
    STATE(4658), 1,
      sym_type_arguments,
    STATE(4673), 1,
      sym_long_identifier,
    STATE(4378), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3419), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3417), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7623] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7338), 1,
      anon_sym_or,
    STATE(4379), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3480), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7695] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7341), 1,
      anon_sym_or,
    STATE(4367), 1,
      aux_sym_type_argument_repeat1,
    STATE(4380), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3476), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3474), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7769] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7331), 1,
      anon_sym_or,
    STATE(4371), 1,
      aux_sym_type_argument_repeat1,
    STATE(4381), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7843] = 20,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7250), 1,
      sym_identifier,
    ACTIONS(7252), 1,
      anon_sym_DASH_GT,
    ACTIONS(7256), 1,
      anon_sym_STAR,
    ACTIONS(7258), 1,
      anon_sym_LT2,
    ACTIONS(7260), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7343), 1,
      anon_sym_when,
    STATE(4511), 1,
      aux_sym_compound_type_repeat1,
    STATE(4591), 1,
      sym_long_identifier,
    STATE(4652), 1,
      sym_type_arguments,
    STATE(5100), 1,
      sym_type_argument_constraints,
    STATE(4382), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7226), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(7224), 17,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7933] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7302), 1,
      anon_sym_DASH_GT,
    ACTIONS(7304), 1,
      anon_sym_STAR,
    ACTIONS(7306), 1,
      anon_sym_LT2,
    ACTIONS(7308), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7324), 1,
      sym_identifier,
    STATE(4528), 1,
      aux_sym_compound_type_repeat1,
    STATE(4635), 1,
      sym_long_identifier,
    STATE(4664), 1,
      sym_type_arguments,
    STATE(4383), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3431), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3429), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8019] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7292), 1,
      sym_identifier,
    ACTIONS(7294), 1,
      anon_sym_DASH_GT,
    ACTIONS(7296), 1,
      anon_sym_STAR,
    ACTIONS(7298), 1,
      anon_sym_LT2,
    ACTIONS(7300), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4489), 1,
      aux_sym_compound_type_repeat1,
    STATE(4667), 1,
      sym_long_identifier,
    STATE(4671), 1,
      sym_type_arguments,
    STATE(4384), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3431), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3429), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8105] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7345), 1,
      anon_sym_DOT,
    STATE(4396), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4385), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3451), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3449), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8179] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4386), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3511), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3509), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8249] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7302), 1,
      anon_sym_DASH_GT,
    ACTIONS(7304), 1,
      anon_sym_STAR,
    ACTIONS(7306), 1,
      anon_sym_LT2,
    ACTIONS(7308), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7324), 1,
      sym_identifier,
    STATE(4528), 1,
      aux_sym_compound_type_repeat1,
    STATE(4635), 1,
      sym_long_identifier,
    STATE(4664), 1,
      sym_type_arguments,
    STATE(4387), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3427), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3425), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8335] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7347), 1,
      anon_sym_or,
    STATE(4388), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3480), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8407] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7302), 1,
      anon_sym_DASH_GT,
    ACTIONS(7304), 1,
      anon_sym_STAR,
    ACTIONS(7306), 1,
      anon_sym_LT2,
    ACTIONS(7308), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7324), 1,
      sym_identifier,
    STATE(4528), 1,
      aux_sym_compound_type_repeat1,
    STATE(4635), 1,
      sym_long_identifier,
    STATE(4664), 1,
      sym_type_arguments,
    STATE(4389), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3407), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3403), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8493] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7310), 1,
      sym_identifier,
    ACTIONS(7316), 1,
      anon_sym_DASH_GT,
    ACTIONS(7318), 1,
      anon_sym_STAR,
    ACTIONS(7320), 1,
      anon_sym_LT2,
    ACTIONS(7322), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4515), 1,
      aux_sym_compound_type_repeat1,
    STATE(4593), 1,
      sym_long_identifier,
    STATE(4648), 1,
      sym_type_arguments,
    STATE(4390), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3419), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3417), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8579] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7302), 1,
      anon_sym_DASH_GT,
    ACTIONS(7304), 1,
      anon_sym_STAR,
    ACTIONS(7306), 1,
      anon_sym_LT2,
    ACTIONS(7308), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4528), 1,
      aux_sym_compound_type_repeat1,
    STATE(4635), 1,
      sym_long_identifier,
    STATE(4664), 1,
      sym_type_arguments,
    STATE(4391), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7283), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7285), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8663] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7350), 1,
      anon_sym_DOT,
    STATE(4392), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3487), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8735] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7336), 1,
      anon_sym_or,
    STATE(4388), 1,
      aux_sym_type_argument_repeat1,
    STATE(4393), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3476), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3474), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8809] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7353), 1,
      anon_sym_or,
    STATE(4394), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3480), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8881] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7292), 1,
      sym_identifier,
    ACTIONS(7294), 1,
      anon_sym_DASH_GT,
    ACTIONS(7296), 1,
      anon_sym_STAR,
    ACTIONS(7298), 1,
      anon_sym_LT2,
    ACTIONS(7300), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4489), 1,
      aux_sym_compound_type_repeat1,
    STATE(4667), 1,
      sym_long_identifier,
    STATE(4671), 1,
      sym_type_arguments,
    STATE(4395), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3427), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3425), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8967] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7356), 1,
      anon_sym_DOT,
    STATE(4396), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3487), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9039] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7359), 1,
      anon_sym_DOT,
    STATE(4398), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4397), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3494), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3492), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9113] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7359), 1,
      anon_sym_DOT,
    STATE(4392), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4398), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3451), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3449), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9187] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7292), 1,
      sym_identifier,
    ACTIONS(7294), 1,
      anon_sym_DASH_GT,
    ACTIONS(7296), 1,
      anon_sym_STAR,
    ACTIONS(7298), 1,
      anon_sym_LT2,
    ACTIONS(7300), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4489), 1,
      aux_sym_compound_type_repeat1,
    STATE(4667), 1,
      sym_long_identifier,
    STATE(4671), 1,
      sym_type_arguments,
    STATE(4399), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3407), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3403), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9273] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7290), 1,
      anon_sym_or,
    STATE(4354), 1,
      aux_sym_type_argument_repeat1,
    STATE(4400), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9347] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7267), 1,
      sym_identifier,
    ACTIONS(7269), 1,
      anon_sym_DASH_GT,
    ACTIONS(7273), 1,
      anon_sym_STAR,
    ACTIONS(7275), 1,
      anon_sym_LT2,
    ACTIONS(7277), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4504), 1,
      aux_sym_compound_type_repeat1,
    STATE(4658), 1,
      sym_type_arguments,
    STATE(4673), 1,
      sym_long_identifier,
    STATE(4401), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3407), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3403), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9433] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7341), 1,
      anon_sym_or,
    STATE(4380), 1,
      aux_sym_type_argument_repeat1,
    STATE(4402), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9507] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7345), 1,
      anon_sym_DOT,
    STATE(4385), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4403), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3494), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3492), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9581] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7267), 1,
      sym_identifier,
    ACTIONS(7269), 1,
      anon_sym_DASH_GT,
    ACTIONS(7273), 1,
      anon_sym_STAR,
    ACTIONS(7275), 1,
      anon_sym_LT2,
    ACTIONS(7277), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4504), 1,
      aux_sym_compound_type_repeat1,
    STATE(4658), 1,
      sym_type_arguments,
    STATE(4673), 1,
      sym_long_identifier,
    STATE(4404), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3431), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3429), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9667] = 20,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7361), 1,
      sym_identifier,
    ACTIONS(7363), 1,
      anon_sym_DASH_GT,
    ACTIONS(7365), 1,
      anon_sym_when,
    ACTIONS(7367), 1,
      anon_sym_STAR,
    ACTIONS(7369), 1,
      anon_sym_LT2,
    ACTIONS(7371), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4653), 1,
      aux_sym_compound_type_repeat1,
    STATE(4680), 1,
      sym_type_arguments,
    STATE(4699), 1,
      sym_long_identifier,
    STATE(5283), 1,
      sym_type_argument_constraints,
    STATE(4405), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7226), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(7224), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9757] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4406), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3480), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9826] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4407), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9895] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7373), 1,
      sym_identifier,
    ACTIONS(7375), 1,
      anon_sym_DASH_GT,
    ACTIONS(7377), 1,
      anon_sym_STAR,
    ACTIONS(7379), 1,
      anon_sym_LT2,
    ACTIONS(7381), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4623), 1,
      aux_sym_compound_type_repeat1,
    STATE(4697), 1,
      sym_long_identifier,
    STATE(4705), 1,
      sym_type_arguments,
    STATE(4408), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7314), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(7312), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9980] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7302), 1,
      anon_sym_DASH_GT,
    ACTIONS(7304), 1,
      anon_sym_STAR,
    ACTIONS(7308), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4528), 1,
      aux_sym_compound_type_repeat1,
    STATE(4635), 1,
      sym_long_identifier,
    STATE(4664), 1,
      sym_type_arguments,
    STATE(4409), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7279), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7281), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10061] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7383), 1,
      anon_sym_STAR,
    STATE(4410), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3427), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3425), 22,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10132] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7386), 1,
      anon_sym_or,
    STATE(4462), 1,
      aux_sym_type_argument_repeat1,
    STATE(4411), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10205] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7373), 1,
      sym_identifier,
    ACTIONS(7375), 1,
      anon_sym_DASH_GT,
    ACTIONS(7377), 1,
      anon_sym_STAR,
    ACTIONS(7379), 1,
      anon_sym_LT2,
    ACTIONS(7381), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4623), 1,
      aux_sym_compound_type_repeat1,
    STATE(4697), 1,
      sym_long_identifier,
    STATE(4705), 1,
      sym_type_arguments,
    STATE(4412), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3419), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3417), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10290] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7388), 1,
      anon_sym_or,
    STATE(4418), 1,
      aux_sym_type_argument_repeat1,
    STATE(4413), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10363] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7390), 1,
      anon_sym_or,
    STATE(4414), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3480), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10434] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7393), 1,
      anon_sym_DOT,
    STATE(4415), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3487), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10505] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7396), 1,
      anon_sym_DASH_GT,
    ACTIONS(7398), 1,
      anon_sym_STAR,
    ACTIONS(7400), 1,
      anon_sym_LT2,
    ACTIONS(7402), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4604), 1,
      aux_sym_compound_type_repeat1,
    STATE(4730), 1,
      sym_long_identifier,
    STATE(4746), 1,
      sym_type_arguments,
    STATE(4416), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7283), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7285), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10588] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7404), 1,
      anon_sym_or,
    STATE(4417), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3480), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10659] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7388), 1,
      anon_sym_or,
    STATE(4431), 1,
      aux_sym_type_argument_repeat1,
    STATE(4418), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3476), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3474), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10732] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7407), 1,
      anon_sym_DOT,
    STATE(4468), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4419), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3451), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3449), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10805] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7232), 1,
      anon_sym_STAR,
    STATE(4410), 1,
      aux_sym_compound_type_repeat1,
    STATE(4420), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3468), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3466), 22,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10878] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7396), 1,
      anon_sym_DASH_GT,
    ACTIONS(7398), 1,
      anon_sym_STAR,
    ACTIONS(7400), 1,
      anon_sym_LT2,
    ACTIONS(7402), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4604), 1,
      aux_sym_compound_type_repeat1,
    STATE(4730), 1,
      sym_long_identifier,
    STATE(4746), 1,
      sym_type_arguments,
    STATE(4421), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7279), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7281), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10961] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7361), 1,
      sym_identifier,
    ACTIONS(7363), 1,
      anon_sym_DASH_GT,
    ACTIONS(7367), 1,
      anon_sym_STAR,
    ACTIONS(7369), 1,
      anon_sym_LT2,
    ACTIONS(7371), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4653), 1,
      aux_sym_compound_type_repeat1,
    STATE(4680), 1,
      sym_type_arguments,
    STATE(4699), 1,
      sym_long_identifier,
    STATE(4422), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3427), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3425), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11046] = 19,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7250), 1,
      sym_identifier,
    ACTIONS(7252), 1,
      anon_sym_DASH_GT,
    ACTIONS(7256), 1,
      anon_sym_STAR,
    ACTIONS(7258), 1,
      anon_sym_LT2,
    ACTIONS(7260), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4511), 1,
      aux_sym_compound_type_repeat1,
    STATE(4591), 1,
      sym_long_identifier,
    STATE(4652), 1,
      sym_type_arguments,
    STATE(5193), 1,
      sym_type_argument_constraints,
    STATE(4423), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7226), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(7224), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11133] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7396), 1,
      anon_sym_DASH_GT,
    ACTIONS(7398), 1,
      anon_sym_STAR,
    ACTIONS(7400), 1,
      anon_sym_LT2,
    ACTIONS(7402), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7409), 1,
      sym_identifier,
    STATE(4604), 1,
      aux_sym_compound_type_repeat1,
    STATE(4730), 1,
      sym_long_identifier,
    STATE(4746), 1,
      sym_type_arguments,
    STATE(4424), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3419), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3417), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11218] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4425), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3487), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11287] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4426), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3511), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3509), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11356] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7411), 1,
      sym_identifier,
    ACTIONS(7413), 1,
      anon_sym_DASH_GT,
    ACTIONS(7415), 1,
      anon_sym_STAR,
    ACTIONS(7417), 1,
      anon_sym_LT2,
    ACTIONS(7419), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4607), 1,
      aux_sym_compound_type_repeat1,
    STATE(4742), 1,
      sym_type_arguments,
    STATE(4750), 1,
      sym_long_identifier,
    STATE(4427), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3419), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3417), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11441] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4428), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3487), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11510] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4429), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3480), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11579] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7421), 1,
      anon_sym_or,
    STATE(4414), 1,
      aux_sym_type_argument_repeat1,
    STATE(4430), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3476), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3474), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11652] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7423), 1,
      anon_sym_or,
    STATE(4431), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3480), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11723] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7426), 1,
      anon_sym_COLON_GT,
    STATE(4432), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3513), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11794] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7411), 1,
      sym_identifier,
    ACTIONS(7413), 1,
      anon_sym_DASH_GT,
    ACTIONS(7415), 1,
      anon_sym_STAR,
    ACTIONS(7417), 1,
      anon_sym_LT2,
    ACTIONS(7419), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4607), 1,
      aux_sym_compound_type_repeat1,
    STATE(4742), 1,
      sym_type_arguments,
    STATE(4750), 1,
      sym_long_identifier,
    STATE(4433), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3431), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3429), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11879] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4434), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3511), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3509), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11948] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7373), 1,
      sym_identifier,
    ACTIONS(7375), 1,
      anon_sym_DASH_GT,
    ACTIONS(7377), 1,
      anon_sym_STAR,
    ACTIONS(7379), 1,
      anon_sym_LT2,
    ACTIONS(7381), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4623), 1,
      aux_sym_compound_type_repeat1,
    STATE(4697), 1,
      sym_long_identifier,
    STATE(4705), 1,
      sym_type_arguments,
    STATE(4435), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3431), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3429), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12033] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7361), 1,
      sym_identifier,
    ACTIONS(7363), 1,
      anon_sym_DASH_GT,
    ACTIONS(7367), 1,
      anon_sym_STAR,
    ACTIONS(7369), 1,
      anon_sym_LT2,
    ACTIONS(7371), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4653), 1,
      aux_sym_compound_type_repeat1,
    STATE(4680), 1,
      sym_type_arguments,
    STATE(4699), 1,
      sym_long_identifier,
    STATE(4436), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3407), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3403), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12118] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4437), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3511), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3509), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12187] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7428), 1,
      anon_sym_DOT,
    STATE(4451), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4438), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3451), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3449), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12260] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7430), 1,
      anon_sym_DOT,
    STATE(4445), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4439), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3494), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3492), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12333] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7432), 1,
      anon_sym_COLON_GT,
    STATE(4440), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3513), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12404] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7434), 1,
      anon_sym_or,
    STATE(4441), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3480), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12475] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7373), 1,
      sym_identifier,
    ACTIONS(7375), 1,
      anon_sym_DASH_GT,
    ACTIONS(7377), 1,
      anon_sym_STAR,
    ACTIONS(7379), 1,
      anon_sym_LT2,
    ACTIONS(7381), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4623), 1,
      aux_sym_compound_type_repeat1,
    STATE(4697), 1,
      sym_long_identifier,
    STATE(4705), 1,
      sym_type_arguments,
    STATE(4442), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3427), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3425), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12560] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7373), 1,
      sym_identifier,
    ACTIONS(7375), 1,
      anon_sym_DASH_GT,
    ACTIONS(7377), 1,
      anon_sym_STAR,
    ACTIONS(7379), 1,
      anon_sym_LT2,
    ACTIONS(7381), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4623), 1,
      aux_sym_compound_type_repeat1,
    STATE(4697), 1,
      sym_long_identifier,
    STATE(4705), 1,
      sym_type_arguments,
    STATE(4443), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3407), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3403), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12645] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7437), 1,
      anon_sym_DOT,
    STATE(4444), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3487), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12716] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7430), 1,
      anon_sym_DOT,
    STATE(4465), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4445), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3451), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3449), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12789] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7407), 1,
      anon_sym_DOT,
    STATE(4419), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4446), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3494), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3492), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12862] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7440), 1,
      sym_identifier,
    ACTIONS(7442), 1,
      anon_sym_DASH_GT,
    ACTIONS(7444), 1,
      anon_sym_STAR,
    ACTIONS(7446), 1,
      anon_sym_LT2,
    ACTIONS(7448), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4650), 1,
      aux_sym_compound_type_repeat1,
    STATE(4688), 1,
      sym_type_arguments,
    STATE(4711), 1,
      sym_long_identifier,
    STATE(4447), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7314), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(7312), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12947] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7440), 1,
      sym_identifier,
    ACTIONS(7442), 1,
      anon_sym_DASH_GT,
    ACTIONS(7444), 1,
      anon_sym_STAR,
    ACTIONS(7446), 1,
      anon_sym_LT2,
    ACTIONS(7448), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4650), 1,
      aux_sym_compound_type_repeat1,
    STATE(4688), 1,
      sym_type_arguments,
    STATE(4711), 1,
      sym_long_identifier,
    STATE(4448), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3419), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3417), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13032] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4449), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3480), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13101] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7450), 1,
      anon_sym_or,
    STATE(4476), 1,
      aux_sym_type_argument_repeat1,
    STATE(4450), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13174] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7452), 1,
      anon_sym_DOT,
    STATE(4451), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3487), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13245] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7455), 1,
      anon_sym_DOT,
    STATE(4458), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4452), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3494), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3492), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13318] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7440), 1,
      sym_identifier,
    ACTIONS(7442), 1,
      anon_sym_DASH_GT,
    ACTIONS(7444), 1,
      anon_sym_STAR,
    ACTIONS(7446), 1,
      anon_sym_LT2,
    ACTIONS(7448), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4650), 1,
      aux_sym_compound_type_repeat1,
    STATE(4688), 1,
      sym_type_arguments,
    STATE(4711), 1,
      sym_long_identifier,
    STATE(4453), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3431), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3429), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13403] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7428), 1,
      anon_sym_DOT,
    STATE(4438), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4454), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3494), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3492), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13476] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4455), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13545] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7361), 1,
      sym_identifier,
    ACTIONS(7363), 1,
      anon_sym_DASH_GT,
    ACTIONS(7367), 1,
      anon_sym_STAR,
    ACTIONS(7369), 1,
      anon_sym_LT2,
    ACTIONS(7371), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4653), 1,
      aux_sym_compound_type_repeat1,
    STATE(4680), 1,
      sym_type_arguments,
    STATE(4699), 1,
      sym_long_identifier,
    STATE(4456), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3419), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3417), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13630] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7457), 1,
      anon_sym_or,
    STATE(4481), 1,
      aux_sym_type_argument_repeat1,
    STATE(4457), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13703] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7455), 1,
      anon_sym_DOT,
    STATE(4415), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4458), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3451), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3449), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13776] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7396), 1,
      anon_sym_DASH_GT,
    ACTIONS(7398), 1,
      anon_sym_STAR,
    ACTIONS(7400), 1,
      anon_sym_LT2,
    ACTIONS(7402), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7409), 1,
      sym_identifier,
    STATE(4604), 1,
      aux_sym_compound_type_repeat1,
    STATE(4730), 1,
      sym_long_identifier,
    STATE(4746), 1,
      sym_type_arguments,
    STATE(4459), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3407), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3403), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13861] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    STATE(4466), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4460), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3494), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3492), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13934] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7411), 1,
      sym_identifier,
    ACTIONS(7413), 1,
      anon_sym_DASH_GT,
    ACTIONS(7415), 1,
      anon_sym_STAR,
    ACTIONS(7417), 1,
      anon_sym_LT2,
    ACTIONS(7419), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4607), 1,
      aux_sym_compound_type_repeat1,
    STATE(4742), 1,
      sym_type_arguments,
    STATE(4750), 1,
      sym_long_identifier,
    STATE(4461), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3427), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3425), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14019] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7386), 1,
      anon_sym_or,
    STATE(4479), 1,
      aux_sym_type_argument_repeat1,
    STATE(4462), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3476), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3474), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14092] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4463), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3480), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14161] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7361), 1,
      sym_identifier,
    ACTIONS(7363), 1,
      anon_sym_DASH_GT,
    ACTIONS(7367), 1,
      anon_sym_STAR,
    ACTIONS(7369), 1,
      anon_sym_LT2,
    ACTIONS(7371), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4653), 1,
      aux_sym_compound_type_repeat1,
    STATE(4680), 1,
      sym_type_arguments,
    STATE(4699), 1,
      sym_long_identifier,
    STATE(4464), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3431), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3429), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14246] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7461), 1,
      anon_sym_DOT,
    STATE(4465), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3487), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14317] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    STATE(4444), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4466), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3451), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3449), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14390] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7411), 1,
      sym_identifier,
    ACTIONS(7413), 1,
      anon_sym_DASH_GT,
    ACTIONS(7415), 1,
      anon_sym_STAR,
    ACTIONS(7417), 1,
      anon_sym_LT2,
    ACTIONS(7419), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4607), 1,
      aux_sym_compound_type_repeat1,
    STATE(4742), 1,
      sym_type_arguments,
    STATE(4750), 1,
      sym_long_identifier,
    STATE(4467), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3407), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3403), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14475] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7464), 1,
      anon_sym_DOT,
    STATE(4468), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3487), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14546] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7302), 1,
      anon_sym_DASH_GT,
    ACTIONS(7304), 1,
      anon_sym_STAR,
    ACTIONS(7308), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4528), 1,
      aux_sym_compound_type_repeat1,
    STATE(4635), 1,
      sym_long_identifier,
    STATE(4664), 1,
      sym_type_arguments,
    STATE(4469), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7283), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7285), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14627] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7244), 1,
      anon_sym_STAR,
    STATE(4478), 1,
      aux_sym_compound_type_repeat1,
    STATE(4470), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3468), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3466), 22,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14700] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7396), 1,
      anon_sym_DASH_GT,
    ACTIONS(7398), 1,
      anon_sym_STAR,
    ACTIONS(7400), 1,
      anon_sym_LT2,
    ACTIONS(7402), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7409), 1,
      sym_identifier,
    STATE(4604), 1,
      aux_sym_compound_type_repeat1,
    STATE(4730), 1,
      sym_long_identifier,
    STATE(4746), 1,
      sym_type_arguments,
    STATE(4471), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3427), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3425), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14785] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4472), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3480), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14854] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7415), 1,
      anon_sym_STAR,
    ACTIONS(7417), 1,
      anon_sym_LT2,
    ACTIONS(7419), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4607), 1,
      aux_sym_compound_type_repeat1,
    STATE(4742), 1,
      sym_type_arguments,
    STATE(4750), 1,
      sym_long_identifier,
    STATE(4473), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7283), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7285), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14935] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7415), 1,
      anon_sym_STAR,
    ACTIONS(7417), 1,
      anon_sym_LT2,
    ACTIONS(7419), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4607), 1,
      aux_sym_compound_type_repeat1,
    STATE(4742), 1,
      sym_type_arguments,
    STATE(4750), 1,
      sym_long_identifier,
    STATE(4474), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7279), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7281), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15016] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7396), 1,
      anon_sym_DASH_GT,
    ACTIONS(7398), 1,
      anon_sym_STAR,
    ACTIONS(7400), 1,
      anon_sym_LT2,
    ACTIONS(7402), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7409), 1,
      sym_identifier,
    STATE(4604), 1,
      aux_sym_compound_type_repeat1,
    STATE(4730), 1,
      sym_long_identifier,
    STATE(4746), 1,
      sym_type_arguments,
    STATE(4475), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3431), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3429), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15101] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7450), 1,
      anon_sym_or,
    STATE(4441), 1,
      aux_sym_type_argument_repeat1,
    STATE(4476), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3476), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3474), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15174] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7421), 1,
      anon_sym_or,
    STATE(4430), 1,
      aux_sym_type_argument_repeat1,
    STATE(4477), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15247] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7467), 1,
      anon_sym_STAR,
    STATE(4478), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3427), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3425), 22,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15318] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7470), 1,
      anon_sym_or,
    STATE(4479), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3480), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15389] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4480), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3511), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3509), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15458] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7457), 1,
      anon_sym_or,
    STATE(4417), 1,
      aux_sym_type_argument_repeat1,
    STATE(4481), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3476), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3474), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15531] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7440), 1,
      sym_identifier,
    ACTIONS(7442), 1,
      anon_sym_DASH_GT,
    ACTIONS(7444), 1,
      anon_sym_STAR,
    ACTIONS(7446), 1,
      anon_sym_LT2,
    ACTIONS(7448), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4650), 1,
      aux_sym_compound_type_repeat1,
    STATE(4688), 1,
      sym_type_arguments,
    STATE(4711), 1,
      sym_long_identifier,
    STATE(4482), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3407), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3403), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15616] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4483), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3511), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3509), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15685] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7440), 1,
      sym_identifier,
    ACTIONS(7442), 1,
      anon_sym_DASH_GT,
    ACTIONS(7444), 1,
      anon_sym_STAR,
    ACTIONS(7446), 1,
      anon_sym_LT2,
    ACTIONS(7448), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4650), 1,
      aux_sym_compound_type_repeat1,
    STATE(4688), 1,
      sym_type_arguments,
    STATE(4711), 1,
      sym_long_identifier,
    STATE(4484), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3427), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3425), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15770] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7473), 1,
      anon_sym_LT2,
    STATE(4485), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3505), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3503), 22,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15840] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7475), 1,
      anon_sym_STAR,
    STATE(4486), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3427), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3425), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15910] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4487), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3519), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3517), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15978] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4488), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16046] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7296), 1,
      anon_sym_STAR,
    STATE(4512), 1,
      aux_sym_compound_type_repeat1,
    STATE(4489), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3468), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3466), 21,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16118] = 39,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7478), 1,
      anon_sym_do,
    ACTIONS(7480), 1,
      anon_sym_let,
    ACTIONS(7482), 1,
      anon_sym_let_BANG,
    ACTIONS(7484), 1,
      anon_sym_new,
    ACTIONS(7486), 1,
      anon_sym_with,
    ACTIONS(7490), 1,
      anon_sym_static,
    ACTIONS(7492), 1,
      anon_sym_member,
    ACTIONS(7494), 1,
      anon_sym_interface,
    ACTIONS(7496), 1,
      anon_sym_abstract,
    ACTIONS(7498), 1,
      anon_sym_val,
    ACTIONS(7500), 1,
      anon_sym_inherit,
    ACTIONS(7502), 1,
      anon_sym_POUNDif,
    ACTIONS(7504), 1,
      anon_sym_POUNDendif,
    ACTIONS(7506), 1,
      anon_sym_POUNDelse,
    ACTIONS(7508), 1,
      sym__newline,
    STATE(4545), 1,
      aux_sym_preproc_if_in_class_definition_repeat1,
    STATE(4939), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6315), 1,
      sym__class_type_body_inner,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6385), 1,
      sym_additional_constr_defn,
    STATE(6407), 1,
      sym_function_or_value_defn,
    STATE(7109), 1,
      sym_attributes,
    STATE(11492), 1,
      sym_preproc_else_in_class_definition,
    STATE(11882), 1,
      sym_access_modifier,
    ACTIONS(7488), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6384), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6409), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6410), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4490), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [16244] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4491), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16312] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4492), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3527), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3525), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16380] = 39,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7478), 1,
      anon_sym_do,
    ACTIONS(7480), 1,
      anon_sym_let,
    ACTIONS(7482), 1,
      anon_sym_let_BANG,
    ACTIONS(7484), 1,
      anon_sym_new,
    ACTIONS(7486), 1,
      anon_sym_with,
    ACTIONS(7490), 1,
      anon_sym_static,
    ACTIONS(7492), 1,
      anon_sym_member,
    ACTIONS(7494), 1,
      anon_sym_interface,
    ACTIONS(7496), 1,
      anon_sym_abstract,
    ACTIONS(7498), 1,
      anon_sym_val,
    ACTIONS(7500), 1,
      anon_sym_inherit,
    ACTIONS(7502), 1,
      anon_sym_POUNDif,
    ACTIONS(7506), 1,
      anon_sym_POUNDelse,
    ACTIONS(7508), 1,
      sym__newline,
    ACTIONS(7510), 1,
      anon_sym_POUNDendif,
    STATE(4670), 1,
      aux_sym_preproc_if_in_class_definition_repeat1,
    STATE(4939), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6315), 1,
      sym__class_type_body_inner,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6385), 1,
      sym_additional_constr_defn,
    STATE(6407), 1,
      sym_function_or_value_defn,
    STATE(7109), 1,
      sym_attributes,
    STATE(11815), 1,
      sym_preproc_else_in_class_definition,
    STATE(11882), 1,
      sym_access_modifier,
    ACTIONS(7488), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6384), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6409), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6410), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4493), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [16506] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4494), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3531), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3529), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16574] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7512), 1,
      anon_sym_DOT,
    STATE(4495), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3487), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16644] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7515), 1,
      anon_sym_COLON_GT,
    STATE(4496), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3513), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16714] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4497), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3535), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3533), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16782] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4498), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3523), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3521), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16850] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7517), 1,
      anon_sym_DOT,
    STATE(4574), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4499), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3494), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3492), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16922] = 39,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7478), 1,
      anon_sym_do,
    ACTIONS(7480), 1,
      anon_sym_let,
    ACTIONS(7482), 1,
      anon_sym_let_BANG,
    ACTIONS(7484), 1,
      anon_sym_new,
    ACTIONS(7486), 1,
      anon_sym_with,
    ACTIONS(7490), 1,
      anon_sym_static,
    ACTIONS(7492), 1,
      anon_sym_member,
    ACTIONS(7494), 1,
      anon_sym_interface,
    ACTIONS(7496), 1,
      anon_sym_abstract,
    ACTIONS(7498), 1,
      anon_sym_val,
    ACTIONS(7500), 1,
      anon_sym_inherit,
    ACTIONS(7502), 1,
      anon_sym_POUNDif,
    ACTIONS(7506), 1,
      anon_sym_POUNDelse,
    ACTIONS(7508), 1,
      sym__newline,
    ACTIONS(7519), 1,
      anon_sym_POUNDendif,
    STATE(4493), 1,
      aux_sym_preproc_if_in_class_definition_repeat1,
    STATE(4939), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6315), 1,
      sym__class_type_body_inner,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6385), 1,
      sym_additional_constr_defn,
    STATE(6407), 1,
      sym_function_or_value_defn,
    STATE(7109), 1,
      sym_attributes,
    STATE(11823), 1,
      sym_preproc_else_in_class_definition,
    STATE(11882), 1,
      sym_access_modifier,
    ACTIONS(7488), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6384), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6409), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6410), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4500), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [17048] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7521), 1,
      sym_identifier,
    ACTIONS(7523), 1,
      anon_sym_DASH_GT,
    ACTIONS(7525), 1,
      anon_sym_STAR,
    ACTIONS(7527), 1,
      anon_sym_LT2,
    ACTIONS(7529), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4714), 1,
      aux_sym_compound_type_repeat1,
    STATE(4783), 1,
      sym_long_identifier,
    STATE(4789), 1,
      sym_type_arguments,
    STATE(4501), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3419), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3417), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17132] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4502), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3562), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3560), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17200] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7531), 1,
      anon_sym_COLON_GT,
    STATE(4503), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3513), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17270] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7273), 1,
      anon_sym_STAR,
    STATE(4510), 1,
      aux_sym_compound_type_repeat1,
    STATE(4504), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3468), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3466), 21,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17342] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7533), 1,
      anon_sym_STAR,
    STATE(4505), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3427), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3425), 22,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17412] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4506), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3551), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3549), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17480] = 39,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7478), 1,
      anon_sym_do,
    ACTIONS(7480), 1,
      anon_sym_let,
    ACTIONS(7482), 1,
      anon_sym_let_BANG,
    ACTIONS(7484), 1,
      anon_sym_new,
    ACTIONS(7486), 1,
      anon_sym_with,
    ACTIONS(7490), 1,
      anon_sym_static,
    ACTIONS(7492), 1,
      anon_sym_member,
    ACTIONS(7494), 1,
      anon_sym_interface,
    ACTIONS(7496), 1,
      anon_sym_abstract,
    ACTIONS(7498), 1,
      anon_sym_val,
    ACTIONS(7500), 1,
      anon_sym_inherit,
    ACTIONS(7502), 1,
      anon_sym_POUNDif,
    ACTIONS(7506), 1,
      anon_sym_POUNDelse,
    ACTIONS(7508), 1,
      sym__newline,
    ACTIONS(7536), 1,
      anon_sym_POUNDendif,
    STATE(4670), 1,
      aux_sym_preproc_if_in_class_definition_repeat1,
    STATE(4939), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6315), 1,
      sym__class_type_body_inner,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6385), 1,
      sym_additional_constr_defn,
    STATE(6407), 1,
      sym_function_or_value_defn,
    STATE(7109), 1,
      sym_attributes,
    STATE(11567), 1,
      sym_preproc_else_in_class_definition,
    STATE(11882), 1,
      sym_access_modifier,
    ACTIONS(7488), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6384), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6409), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6410), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4507), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [17606] = 39,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7478), 1,
      anon_sym_do,
    ACTIONS(7480), 1,
      anon_sym_let,
    ACTIONS(7482), 1,
      anon_sym_let_BANG,
    ACTIONS(7484), 1,
      anon_sym_new,
    ACTIONS(7486), 1,
      anon_sym_with,
    ACTIONS(7490), 1,
      anon_sym_static,
    ACTIONS(7492), 1,
      anon_sym_member,
    ACTIONS(7494), 1,
      anon_sym_interface,
    ACTIONS(7496), 1,
      anon_sym_abstract,
    ACTIONS(7498), 1,
      anon_sym_val,
    ACTIONS(7500), 1,
      anon_sym_inherit,
    ACTIONS(7502), 1,
      anon_sym_POUNDif,
    ACTIONS(7506), 1,
      anon_sym_POUNDelse,
    ACTIONS(7508), 1,
      sym__newline,
    ACTIONS(7538), 1,
      anon_sym_POUNDendif,
    STATE(4507), 1,
      aux_sym_preproc_if_in_class_definition_repeat1,
    STATE(4939), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6315), 1,
      sym__class_type_body_inner,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6385), 1,
      sym_additional_constr_defn,
    STATE(6407), 1,
      sym_function_or_value_defn,
    STATE(7109), 1,
      sym_attributes,
    STATE(11572), 1,
      sym_preproc_else_in_class_definition,
    STATE(11882), 1,
      sym_access_modifier,
    ACTIONS(7488), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6384), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6409), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6410), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4508), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [17732] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4509), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3535), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3533), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17800] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7540), 1,
      anon_sym_STAR,
    STATE(4510), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3427), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3425), 21,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17870] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7256), 1,
      anon_sym_STAR,
    STATE(4570), 1,
      aux_sym_compound_type_repeat1,
    STATE(4511), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3468), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3466), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17942] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7543), 1,
      anon_sym_STAR,
    STATE(4512), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3427), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3425), 21,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18012] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7546), 1,
      anon_sym_or,
    STATE(4539), 1,
      aux_sym_type_argument_repeat1,
    STATE(4513), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18084] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7548), 1,
      anon_sym_LT2,
    STATE(4514), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3505), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3503), 22,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18154] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7318), 1,
      anon_sym_STAR,
    STATE(4505), 1,
      aux_sym_compound_type_repeat1,
    STATE(4515), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3468), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3466), 22,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18226] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7550), 1,
      anon_sym_COLON_GT,
    STATE(4516), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3513), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18296] = 39,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7478), 1,
      anon_sym_do,
    ACTIONS(7480), 1,
      anon_sym_let,
    ACTIONS(7482), 1,
      anon_sym_let_BANG,
    ACTIONS(7484), 1,
      anon_sym_new,
    ACTIONS(7486), 1,
      anon_sym_with,
    ACTIONS(7490), 1,
      anon_sym_static,
    ACTIONS(7492), 1,
      anon_sym_member,
    ACTIONS(7494), 1,
      anon_sym_interface,
    ACTIONS(7496), 1,
      anon_sym_abstract,
    ACTIONS(7498), 1,
      anon_sym_val,
    ACTIONS(7500), 1,
      anon_sym_inherit,
    ACTIONS(7502), 1,
      anon_sym_POUNDif,
    ACTIONS(7506), 1,
      anon_sym_POUNDelse,
    ACTIONS(7508), 1,
      sym__newline,
    ACTIONS(7552), 1,
      anon_sym_POUNDendif,
    STATE(4522), 1,
      aux_sym_preproc_if_in_class_definition_repeat1,
    STATE(4939), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6315), 1,
      sym__class_type_body_inner,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6385), 1,
      sym_additional_constr_defn,
    STATE(6407), 1,
      sym_function_or_value_defn,
    STATE(7109), 1,
      sym_attributes,
    STATE(11421), 1,
      sym_preproc_else_in_class_definition,
    STATE(11882), 1,
      sym_access_modifier,
    ACTIONS(7488), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6384), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6409), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6410), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4517), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [18422] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4518), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3480), 15,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18490] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4519), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3513), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18558] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4520), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3513), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18626] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4521), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3487), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18694] = 39,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7478), 1,
      anon_sym_do,
    ACTIONS(7480), 1,
      anon_sym_let,
    ACTIONS(7482), 1,
      anon_sym_let_BANG,
    ACTIONS(7484), 1,
      anon_sym_new,
    ACTIONS(7486), 1,
      anon_sym_with,
    ACTIONS(7490), 1,
      anon_sym_static,
    ACTIONS(7492), 1,
      anon_sym_member,
    ACTIONS(7494), 1,
      anon_sym_interface,
    ACTIONS(7496), 1,
      anon_sym_abstract,
    ACTIONS(7498), 1,
      anon_sym_val,
    ACTIONS(7500), 1,
      anon_sym_inherit,
    ACTIONS(7502), 1,
      anon_sym_POUNDif,
    ACTIONS(7506), 1,
      anon_sym_POUNDelse,
    ACTIONS(7508), 1,
      sym__newline,
    ACTIONS(7554), 1,
      anon_sym_POUNDendif,
    STATE(4670), 1,
      aux_sym_preproc_if_in_class_definition_repeat1,
    STATE(4939), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6315), 1,
      sym__class_type_body_inner,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6385), 1,
      sym_additional_constr_defn,
    STATE(6407), 1,
      sym_function_or_value_defn,
    STATE(7109), 1,
      sym_attributes,
    STATE(11412), 1,
      sym_preproc_else_in_class_definition,
    STATE(11882), 1,
      sym_access_modifier,
    ACTIONS(7488), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6384), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6409), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6410), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4522), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [18820] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7556), 1,
      anon_sym_DOT,
    STATE(4582), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4523), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3494), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3492), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18892] = 39,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7478), 1,
      anon_sym_do,
    ACTIONS(7480), 1,
      anon_sym_let,
    ACTIONS(7482), 1,
      anon_sym_let_BANG,
    ACTIONS(7484), 1,
      anon_sym_new,
    ACTIONS(7486), 1,
      anon_sym_with,
    ACTIONS(7490), 1,
      anon_sym_static,
    ACTIONS(7492), 1,
      anon_sym_member,
    ACTIONS(7494), 1,
      anon_sym_interface,
    ACTIONS(7496), 1,
      anon_sym_abstract,
    ACTIONS(7498), 1,
      anon_sym_val,
    ACTIONS(7500), 1,
      anon_sym_inherit,
    ACTIONS(7502), 1,
      anon_sym_POUNDif,
    ACTIONS(7506), 1,
      anon_sym_POUNDelse,
    ACTIONS(7508), 1,
      sym__newline,
    ACTIONS(7558), 1,
      anon_sym_POUNDendif,
    STATE(4527), 1,
      aux_sym_preproc_if_in_class_definition_repeat1,
    STATE(4939), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6315), 1,
      sym__class_type_body_inner,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6385), 1,
      sym_additional_constr_defn,
    STATE(6407), 1,
      sym_function_or_value_defn,
    STATE(7109), 1,
      sym_attributes,
    STATE(10317), 1,
      sym_preproc_else_in_class_definition,
    STATE(11882), 1,
      sym_access_modifier,
    ACTIONS(7488), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6384), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6409), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6410), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4524), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [19018] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7560), 1,
      anon_sym_DOT,
    STATE(4573), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4525), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3494), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3492), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [19090] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7521), 1,
      sym_identifier,
    ACTIONS(7523), 1,
      anon_sym_DASH_GT,
    ACTIONS(7525), 1,
      anon_sym_STAR,
    ACTIONS(7527), 1,
      anon_sym_LT2,
    ACTIONS(7529), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4714), 1,
      aux_sym_compound_type_repeat1,
    STATE(4783), 1,
      sym_long_identifier,
    STATE(4789), 1,
      sym_type_arguments,
    STATE(4526), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7314), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(7312), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [19174] = 39,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7478), 1,
      anon_sym_do,
    ACTIONS(7480), 1,
      anon_sym_let,
    ACTIONS(7482), 1,
      anon_sym_let_BANG,
    ACTIONS(7484), 1,
      anon_sym_new,
    ACTIONS(7486), 1,
      anon_sym_with,
    ACTIONS(7490), 1,
      anon_sym_static,
    ACTIONS(7492), 1,
      anon_sym_member,
    ACTIONS(7494), 1,
      anon_sym_interface,
    ACTIONS(7496), 1,
      anon_sym_abstract,
    ACTIONS(7498), 1,
      anon_sym_val,
    ACTIONS(7500), 1,
      anon_sym_inherit,
    ACTIONS(7502), 1,
      anon_sym_POUNDif,
    ACTIONS(7506), 1,
      anon_sym_POUNDelse,
    ACTIONS(7508), 1,
      sym__newline,
    ACTIONS(7562), 1,
      anon_sym_POUNDendif,
    STATE(4670), 1,
      aux_sym_preproc_if_in_class_definition_repeat1,
    STATE(4939), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6315), 1,
      sym__class_type_body_inner,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6385), 1,
      sym_additional_constr_defn,
    STATE(6407), 1,
      sym_function_or_value_defn,
    STATE(7109), 1,
      sym_attributes,
    STATE(10973), 1,
      sym_preproc_else_in_class_definition,
    STATE(11882), 1,
      sym_access_modifier,
    ACTIONS(7488), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6384), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6409), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6410), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4527), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [19300] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7304), 1,
      anon_sym_STAR,
    STATE(4486), 1,
      aux_sym_compound_type_repeat1,
    STATE(4528), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3468), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3466), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [19372] = 39,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7478), 1,
      anon_sym_do,
    ACTIONS(7480), 1,
      anon_sym_let,
    ACTIONS(7482), 1,
      anon_sym_let_BANG,
    ACTIONS(7484), 1,
      anon_sym_new,
    ACTIONS(7486), 1,
      anon_sym_with,
    ACTIONS(7490), 1,
      anon_sym_static,
    ACTIONS(7492), 1,
      anon_sym_member,
    ACTIONS(7494), 1,
      anon_sym_interface,
    ACTIONS(7496), 1,
      anon_sym_abstract,
    ACTIONS(7498), 1,
      anon_sym_val,
    ACTIONS(7500), 1,
      anon_sym_inherit,
    ACTIONS(7502), 1,
      anon_sym_POUNDif,
    ACTIONS(7506), 1,
      anon_sym_POUNDelse,
    ACTIONS(7508), 1,
      sym__newline,
    ACTIONS(7564), 1,
      anon_sym_POUNDendif,
    STATE(4548), 1,
      aux_sym_preproc_if_in_class_definition_repeat1,
    STATE(4939), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6315), 1,
      sym__class_type_body_inner,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6385), 1,
      sym_additional_constr_defn,
    STATE(6407), 1,
      sym_function_or_value_defn,
    STATE(7109), 1,
      sym_attributes,
    STATE(11882), 1,
      sym_access_modifier,
    STATE(11959), 1,
      sym_preproc_else_in_class_definition,
    ACTIONS(7488), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6384), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6409), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6410), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4529), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [19498] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4530), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3551), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3549), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [19566] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7250), 1,
      sym_identifier,
    ACTIONS(7252), 1,
      anon_sym_DASH_GT,
    ACTIONS(7256), 1,
      anon_sym_STAR,
    ACTIONS(7258), 1,
      anon_sym_LT2,
    ACTIONS(7260), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4511), 1,
      aux_sym_compound_type_repeat1,
    STATE(4591), 1,
      sym_long_identifier,
    STATE(4652), 1,
      sym_type_arguments,
    STATE(4531), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7314), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(7312), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [19650] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4532), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3511), 15,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3509), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [19718] = 39,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7478), 1,
      anon_sym_do,
    ACTIONS(7480), 1,
      anon_sym_let,
    ACTIONS(7482), 1,
      anon_sym_let_BANG,
    ACTIONS(7484), 1,
      anon_sym_new,
    ACTIONS(7486), 1,
      anon_sym_with,
    ACTIONS(7490), 1,
      anon_sym_static,
    ACTIONS(7492), 1,
      anon_sym_member,
    ACTIONS(7494), 1,
      anon_sym_interface,
    ACTIONS(7496), 1,
      anon_sym_abstract,
    ACTIONS(7498), 1,
      anon_sym_val,
    ACTIONS(7500), 1,
      anon_sym_inherit,
    ACTIONS(7502), 1,
      anon_sym_POUNDif,
    ACTIONS(7506), 1,
      anon_sym_POUNDelse,
    ACTIONS(7508), 1,
      sym__newline,
    ACTIONS(7566), 1,
      anon_sym_POUNDendif,
    STATE(4670), 1,
      aux_sym_preproc_if_in_class_definition_repeat1,
    STATE(4939), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6315), 1,
      sym__class_type_body_inner,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6385), 1,
      sym_additional_constr_defn,
    STATE(6407), 1,
      sym_function_or_value_defn,
    STATE(7109), 1,
      sym_attributes,
    STATE(11646), 1,
      sym_preproc_else_in_class_definition,
    STATE(11882), 1,
      sym_access_modifier,
    ACTIONS(7488), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6384), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6409), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6410), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4533), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [19844] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4534), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3487), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [19912] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4535), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [19980] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4536), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3562), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3560), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20048] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4537), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3480), 15,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20116] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7568), 1,
      anon_sym_COLON_GT,
    STATE(4538), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3513), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20186] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7546), 1,
      anon_sym_or,
    STATE(4553), 1,
      aux_sym_type_argument_repeat1,
    STATE(4539), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3476), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3474), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20258] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4540), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20326] = 39,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7478), 1,
      anon_sym_do,
    ACTIONS(7480), 1,
      anon_sym_let,
    ACTIONS(7482), 1,
      anon_sym_let_BANG,
    ACTIONS(7484), 1,
      anon_sym_new,
    ACTIONS(7486), 1,
      anon_sym_with,
    ACTIONS(7490), 1,
      anon_sym_static,
    ACTIONS(7492), 1,
      anon_sym_member,
    ACTIONS(7494), 1,
      anon_sym_interface,
    ACTIONS(7496), 1,
      anon_sym_abstract,
    ACTIONS(7498), 1,
      anon_sym_val,
    ACTIONS(7500), 1,
      anon_sym_inherit,
    ACTIONS(7502), 1,
      anon_sym_POUNDif,
    ACTIONS(7506), 1,
      anon_sym_POUNDelse,
    ACTIONS(7508), 1,
      sym__newline,
    ACTIONS(7570), 1,
      anon_sym_POUNDendif,
    STATE(4533), 1,
      aux_sym_preproc_if_in_class_definition_repeat1,
    STATE(4939), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6315), 1,
      sym__class_type_body_inner,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6385), 1,
      sym_additional_constr_defn,
    STATE(6407), 1,
      sym_function_or_value_defn,
    STATE(7109), 1,
      sym_attributes,
    STATE(11651), 1,
      sym_preproc_else_in_class_definition,
    STATE(11882), 1,
      sym_access_modifier,
    ACTIONS(7488), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6384), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6409), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6410), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4541), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [20452] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7521), 1,
      sym_identifier,
    ACTIONS(7523), 1,
      anon_sym_DASH_GT,
    ACTIONS(7525), 1,
      anon_sym_STAR,
    ACTIONS(7527), 1,
      anon_sym_LT2,
    ACTIONS(7529), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4714), 1,
      aux_sym_compound_type_repeat1,
    STATE(4783), 1,
      sym_long_identifier,
    STATE(4789), 1,
      sym_type_arguments,
    STATE(4542), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3407), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3403), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20536] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7521), 1,
      sym_identifier,
    ACTIONS(7523), 1,
      anon_sym_DASH_GT,
    ACTIONS(7525), 1,
      anon_sym_STAR,
    ACTIONS(7527), 1,
      anon_sym_LT2,
    ACTIONS(7529), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4714), 1,
      aux_sym_compound_type_repeat1,
    STATE(4783), 1,
      sym_long_identifier,
    STATE(4789), 1,
      sym_type_arguments,
    STATE(4543), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3427), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3425), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20620] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4544), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3487), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20688] = 39,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7478), 1,
      anon_sym_do,
    ACTIONS(7480), 1,
      anon_sym_let,
    ACTIONS(7482), 1,
      anon_sym_let_BANG,
    ACTIONS(7484), 1,
      anon_sym_new,
    ACTIONS(7486), 1,
      anon_sym_with,
    ACTIONS(7490), 1,
      anon_sym_static,
    ACTIONS(7492), 1,
      anon_sym_member,
    ACTIONS(7494), 1,
      anon_sym_interface,
    ACTIONS(7496), 1,
      anon_sym_abstract,
    ACTIONS(7498), 1,
      anon_sym_val,
    ACTIONS(7500), 1,
      anon_sym_inherit,
    ACTIONS(7502), 1,
      anon_sym_POUNDif,
    ACTIONS(7506), 1,
      anon_sym_POUNDelse,
    ACTIONS(7508), 1,
      sym__newline,
    ACTIONS(7572), 1,
      anon_sym_POUNDendif,
    STATE(4670), 1,
      aux_sym_preproc_if_in_class_definition_repeat1,
    STATE(4939), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6315), 1,
      sym__class_type_body_inner,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6385), 1,
      sym_additional_constr_defn,
    STATE(6407), 1,
      sym_function_or_value_defn,
    STATE(7109), 1,
      sym_attributes,
    STATE(11484), 1,
      sym_preproc_else_in_class_definition,
    STATE(11882), 1,
      sym_access_modifier,
    ACTIONS(7488), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6384), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6409), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6410), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4545), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [20814] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4546), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3480), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20882] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4547), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3547), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3545), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20950] = 39,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7478), 1,
      anon_sym_do,
    ACTIONS(7480), 1,
      anon_sym_let,
    ACTIONS(7482), 1,
      anon_sym_let_BANG,
    ACTIONS(7484), 1,
      anon_sym_new,
    ACTIONS(7486), 1,
      anon_sym_with,
    ACTIONS(7490), 1,
      anon_sym_static,
    ACTIONS(7492), 1,
      anon_sym_member,
    ACTIONS(7494), 1,
      anon_sym_interface,
    ACTIONS(7496), 1,
      anon_sym_abstract,
    ACTIONS(7498), 1,
      anon_sym_val,
    ACTIONS(7500), 1,
      anon_sym_inherit,
    ACTIONS(7502), 1,
      anon_sym_POUNDif,
    ACTIONS(7506), 1,
      anon_sym_POUNDelse,
    ACTIONS(7508), 1,
      sym__newline,
    ACTIONS(7574), 1,
      anon_sym_POUNDendif,
    STATE(4670), 1,
      aux_sym_preproc_if_in_class_definition_repeat1,
    STATE(4939), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6315), 1,
      sym__class_type_body_inner,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6385), 1,
      sym_additional_constr_defn,
    STATE(6407), 1,
      sym_function_or_value_defn,
    STATE(7109), 1,
      sym_attributes,
    STATE(11882), 1,
      sym_access_modifier,
    STATE(11938), 1,
      sym_preproc_else_in_class_definition,
    ACTIONS(7488), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6384), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6409), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6410), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4548), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [21076] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4549), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3531), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3529), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21144] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4550), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3543), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3541), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21212] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4551), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3539), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3537), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21280] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4552), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3487), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21348] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7576), 1,
      anon_sym_or,
    STATE(4553), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3480), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21418] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7579), 1,
      anon_sym_DOT,
    STATE(4583), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4554), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3494), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3492), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21490] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7581), 1,
      anon_sym_COLON_GT,
    STATE(4555), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3513), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21560] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4556), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3527), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3525), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21628] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7583), 1,
      anon_sym_DOT,
    STATE(4560), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4557), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3451), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3449), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21700] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4558), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21768] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7583), 1,
      anon_sym_DOT,
    STATE(4557), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4559), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3494), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3492), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21840] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7585), 1,
      anon_sym_DOT,
    STATE(4560), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3487), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21910] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4561), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3519), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3517), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21978] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7588), 1,
      anon_sym_DOT,
    STATE(4562), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3487), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22048] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7591), 1,
      anon_sym_DOT,
    STATE(4563), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3487), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22118] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4564), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3480), 15,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22186] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7521), 1,
      sym_identifier,
    ACTIONS(7523), 1,
      anon_sym_DASH_GT,
    ACTIONS(7525), 1,
      anon_sym_STAR,
    ACTIONS(7527), 1,
      anon_sym_LT2,
    ACTIONS(7529), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4714), 1,
      aux_sym_compound_type_repeat1,
    STATE(4783), 1,
      sym_long_identifier,
    STATE(4789), 1,
      sym_type_arguments,
    STATE(4565), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3431), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(3429), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22270] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4566), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3547), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3545), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22338] = 39,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7478), 1,
      anon_sym_do,
    ACTIONS(7480), 1,
      anon_sym_let,
    ACTIONS(7482), 1,
      anon_sym_let_BANG,
    ACTIONS(7484), 1,
      anon_sym_new,
    ACTIONS(7486), 1,
      anon_sym_with,
    ACTIONS(7490), 1,
      anon_sym_static,
    ACTIONS(7492), 1,
      anon_sym_member,
    ACTIONS(7494), 1,
      anon_sym_interface,
    ACTIONS(7496), 1,
      anon_sym_abstract,
    ACTIONS(7498), 1,
      anon_sym_val,
    ACTIONS(7500), 1,
      anon_sym_inherit,
    ACTIONS(7502), 1,
      anon_sym_POUNDif,
    ACTIONS(7506), 1,
      anon_sym_POUNDelse,
    ACTIONS(7508), 1,
      sym__newline,
    ACTIONS(7594), 1,
      anon_sym_POUNDendif,
    STATE(4575), 1,
      aux_sym_preproc_if_in_class_definition_repeat1,
    STATE(4939), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6315), 1,
      sym__class_type_body_inner,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6385), 1,
      sym_additional_constr_defn,
    STATE(6407), 1,
      sym_function_or_value_defn,
    STATE(7109), 1,
      sym_attributes,
    STATE(11704), 1,
      sym_preproc_else_in_class_definition,
    STATE(11882), 1,
      sym_access_modifier,
    ACTIONS(7488), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6384), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6409), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6410), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4567), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [22464] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4568), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3543), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3541), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22532] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4569), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3523), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3521), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22600] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7596), 1,
      anon_sym_STAR,
    STATE(4570), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3427), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3425), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22670] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4571), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3511), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3509), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22738] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6596), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(6598), 1,
      anon_sym_DQUOTE,
    ACTIONS(6600), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(6602), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6604), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(6610), 1,
      sym_int,
    ACTIONS(6612), 1,
      sym_xint,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7599), 1,
      aux_sym_char_token1,
    STATE(688), 1,
      sym_const,
    STATE(4220), 1,
      sym_float,
    STATE(4265), 1,
      sym_format_triple_quoted_string,
    STATE(10153), 1,
      sym_static_parameter_value,
    ACTIONS(6608), 2,
      sym_bool,
      sym_unit,
    STATE(4266), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4572), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4234), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [22832] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7560), 1,
      anon_sym_DOT,
    STATE(4495), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4573), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3451), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3449), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22904] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7517), 1,
      anon_sym_DOT,
    STATE(4577), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4574), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3451), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3449), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22976] = 39,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7478), 1,
      anon_sym_do,
    ACTIONS(7480), 1,
      anon_sym_let,
    ACTIONS(7482), 1,
      anon_sym_let_BANG,
    ACTIONS(7484), 1,
      anon_sym_new,
    ACTIONS(7486), 1,
      anon_sym_with,
    ACTIONS(7490), 1,
      anon_sym_static,
    ACTIONS(7492), 1,
      anon_sym_member,
    ACTIONS(7494), 1,
      anon_sym_interface,
    ACTIONS(7496), 1,
      anon_sym_abstract,
    ACTIONS(7498), 1,
      anon_sym_val,
    ACTIONS(7500), 1,
      anon_sym_inherit,
    ACTIONS(7502), 1,
      anon_sym_POUNDif,
    ACTIONS(7506), 1,
      anon_sym_POUNDelse,
    ACTIONS(7508), 1,
      sym__newline,
    ACTIONS(7601), 1,
      anon_sym_POUNDendif,
    STATE(4670), 1,
      aux_sym_preproc_if_in_class_definition_repeat1,
    STATE(4939), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6315), 1,
      sym__class_type_body_inner,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6385), 1,
      sym_additional_constr_defn,
    STATE(6407), 1,
      sym_function_or_value_defn,
    STATE(7109), 1,
      sym_attributes,
    STATE(11726), 1,
      sym_preproc_else_in_class_definition,
    STATE(11882), 1,
      sym_access_modifier,
    ACTIONS(7488), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6384), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6409), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6410), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4575), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [23102] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4576), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3487), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23170] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7603), 1,
      anon_sym_DOT,
    STATE(4577), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3487), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23240] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4578), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3511), 15,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3509), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23308] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4579), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3511), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3509), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23376] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4580), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3511), 15,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3509), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23444] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4581), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3539), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3537), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23512] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7556), 1,
      anon_sym_DOT,
    STATE(4563), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4582), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3451), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3449), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23584] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7579), 1,
      anon_sym_DOT,
    STATE(4562), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4583), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3451), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3449), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23656] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4584), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3480), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23724] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4585), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3535), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3533), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23791] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4586), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23858] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4587), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23925] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7606), 1,
      anon_sym_STAR,
    STATE(4588), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3427), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3425), 19,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23994] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7609), 1,
      anon_sym_DOT,
    STATE(4589), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3487), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24063] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4590), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3535), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3533), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24130] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4591), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3531), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3529), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24197] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7612), 1,
      anon_sym_DOT,
    STATE(4589), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4592), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3451), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3449), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24268] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4593), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3531), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3529), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24335] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7612), 1,
      anon_sym_DOT,
    STATE(4592), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4594), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3494), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3492), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24406] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4595), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3539), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3537), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24473] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4596), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3487), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24540] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4597), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3487), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24607] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4598), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3543), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3541), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24674] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4599), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3547), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3545), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24741] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4600), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3487), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24808] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7614), 1,
      anon_sym_STAR,
    STATE(4601), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3427), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3425), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24877] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4602), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24944] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7617), 1,
      anon_sym_COLON_GT,
    STATE(4603), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3513), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25013] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7398), 1,
      anon_sym_STAR,
    STATE(4588), 1,
      aux_sym_compound_type_repeat1,
    STATE(4604), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3468), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3466), 19,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25084] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4605), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25151] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4606), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3539), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3537), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25218] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7415), 1,
      anon_sym_STAR,
    STATE(4616), 1,
      aux_sym_compound_type_repeat1,
    STATE(4607), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3468), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3466), 19,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25289] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4608), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3487), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25356] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4609), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3547), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3545), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25423] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4610), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3523), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3521), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25490] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4611), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3513), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25557] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4612), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3543), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3541), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25624] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7619), 1,
      anon_sym_LT2,
    STATE(4613), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3505), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3503), 22,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25693] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4614), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3527), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3525), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25760] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4615), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25827] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7621), 1,
      anon_sym_STAR,
    STATE(4616), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3427), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3425), 19,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25896] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4617), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3519), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3517), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25963] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4618), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3480), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26030] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4619), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3513), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26097] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4620), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3523), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3521), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26164] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4621), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3539), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3537), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26231] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7624), 1,
      anon_sym_COLON_GT,
    STATE(4622), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3513), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26300] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7377), 1,
      anon_sym_STAR,
    STATE(4672), 1,
      aux_sym_compound_type_repeat1,
    STATE(4623), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3468), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3466), 21,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26371] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7626), 1,
      anon_sym_COLON_GT,
    STATE(4624), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3513), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26440] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4625), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3547), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3545), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26507] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4626), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3519), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3517), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26574] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4627), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3543), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3541), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26641] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4628), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3543), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3541), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26708] = 22,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7628), 1,
      aux_sym_char_token1,
    ACTIONS(7630), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(7632), 1,
      anon_sym_DQUOTE,
    ACTIONS(7634), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(7636), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(7638), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(7642), 1,
      sym_int,
    ACTIONS(7644), 1,
      sym_xint,
    STATE(8884), 1,
      sym_float,
    STATE(9521), 1,
      sym_const,
    STATE(10150), 1,
      sym_format_triple_quoted_string,
    ACTIONS(7640), 2,
      sym_bool,
      sym_unit,
    STATE(10155), 2,
      sym_format_string,
      sym__string_literal,
    STATE(4629), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(10156), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [26799] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4630), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3527), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3525), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26866] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4631), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3523), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3521), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26933] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4632), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3519), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3517), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27000] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4633), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3527), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3525), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27067] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7646), 1,
      anon_sym_LT2,
    STATE(4634), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3505), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3503), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27136] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4635), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3531), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3529), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27203] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7648), 1,
      anon_sym_COLON_GT,
    STATE(4636), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3513), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27272] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4637), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3547), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3545), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27339] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4638), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3519), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3517), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27406] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4639), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3513), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27473] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4640), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3539), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3537), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27540] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4641), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3511), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3509), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27607] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7650), 1,
      anon_sym_STAR,
    STATE(4642), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3427), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3425), 19,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27676] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4643), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3523), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3521), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27743] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4644), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3539), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3537), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27810] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4645), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3519), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3517), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27877] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4646), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3551), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3549), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27944] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4647), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3527), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3525), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28011] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4648), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3562), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3560), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28078] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4649), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3543), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3541), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28145] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7444), 1,
      anon_sym_STAR,
    STATE(4601), 1,
      aux_sym_compound_type_repeat1,
    STATE(4650), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3468), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3466), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28216] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4651), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3547), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3545), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28283] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4652), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3562), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3560), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28350] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7367), 1,
      anon_sym_STAR,
    STATE(4642), 1,
      aux_sym_compound_type_repeat1,
    STATE(4653), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3468), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3466), 19,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28421] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7653), 1,
      anon_sym_LT2,
    STATE(4654), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3505), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3503), 21,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28490] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4655), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3551), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3549), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28557] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4656), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3535), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3533), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28624] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4657), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3487), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28691] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4658), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3562), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3560), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28758] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7655), 1,
      anon_sym_COLON_GT,
    STATE(4659), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3513), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28827] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4660), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3551), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3549), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28894] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7657), 1,
      anon_sym_LT2,
    STATE(4661), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3505), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3503), 21,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28963] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4662), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3551), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3549), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29030] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4663), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3513), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29097] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4664), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3562), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3560), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29164] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4665), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3551), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3549), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29231] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4666), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3523), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3521), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29298] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4667), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3531), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3529), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29365] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7659), 1,
      anon_sym_LT2,
    STATE(4668), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3505), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3503), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29434] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4669), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3535), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3533), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29501] = 36,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7661), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7664), 1,
      anon_sym_do,
    ACTIONS(7667), 1,
      anon_sym_let,
    ACTIONS(7670), 1,
      anon_sym_let_BANG,
    ACTIONS(7673), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7676), 1,
      anon_sym_new,
    ACTIONS(7679), 1,
      anon_sym_with,
    ACTIONS(7685), 1,
      anon_sym_static,
    ACTIONS(7688), 1,
      anon_sym_member,
    ACTIONS(7691), 1,
      anon_sym_interface,
    ACTIONS(7694), 1,
      anon_sym_abstract,
    ACTIONS(7697), 1,
      anon_sym_val,
    ACTIONS(7700), 1,
      anon_sym_inherit,
    ACTIONS(7703), 1,
      anon_sym_POUNDif,
    ACTIONS(7708), 1,
      sym__newline,
    STATE(4939), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6315), 1,
      sym__class_type_body_inner,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6385), 1,
      sym_additional_constr_defn,
    STATE(6407), 1,
      sym_function_or_value_defn,
    STATE(7109), 1,
      sym_attributes,
    STATE(11882), 1,
      sym_access_modifier,
    ACTIONS(7682), 2,
      anon_sym_default,
      anon_sym_override,
    ACTIONS(7706), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6384), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6409), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6410), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4670), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_preproc_if_in_class_definition_repeat1,
  [29620] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4671), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3562), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3560), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29687] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7711), 1,
      anon_sym_STAR,
    STATE(4672), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3427), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3425), 21,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29756] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4673), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3531), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3529), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29823] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4674), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3513), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29890] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4675), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3535), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3533), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29957] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4676), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3527), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3525), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30024] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7714), 1,
      anon_sym_DOT,
    STATE(4677), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3487), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 20,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30092] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4678), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3539), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3537), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30158] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4679), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3539), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3537), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30224] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4680), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3562), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3560), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30290] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4681), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3551), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3549), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30356] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4682), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3551), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3549), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30422] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4683), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3543), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3541), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30488] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4684), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3543), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3541), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30554] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7717), 1,
      anon_sym_LT2,
    STATE(4685), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3505), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3503), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30622] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4686), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3513), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30688] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4687), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3551), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3549), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30754] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4688), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3562), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3560), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30820] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4689), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3539), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3537), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30886] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7719), 1,
      anon_sym_LT2,
    STATE(4690), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3505), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3503), 19,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30954] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4691), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3513), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31020] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6560), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7723), 1,
      anon_sym_LPAREN,
    ACTIONS(7725), 1,
      anon_sym__,
    ACTIONS(7727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(7729), 1,
      anon_sym_POUND,
    STATE(579), 1,
      sym__type,
    STATE(4038), 1,
      sym__static_type_identifier,
    STATE(4159), 1,
      sym_type_argument,
    STATE(4192), 1,
      sym_long_identifier,
    STATE(9085), 1,
      sym_attribute,
    STATE(9740), 1,
      sym__object_construction,
    STATE(11909), 1,
      sym__attribute_target,
    ACTIONS(7731), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4692), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7721), 9,
      anon_sym_module,
      anon_sym_assembly,
      anon_sym_return,
      anon_sym_field,
      anon_sym_property,
      anon_sym_param,
      anon_sym_type,
      anon_sym_constructor,
      anon_sym_event,
    STATE(4190), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [31112] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7733), 1,
      aux_sym_float_token1,
    STATE(4693), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3604), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3602), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31180] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4694), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3547), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3545), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31246] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6560), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7723), 1,
      anon_sym_LPAREN,
    ACTIONS(7725), 1,
      anon_sym__,
    ACTIONS(7727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(7729), 1,
      anon_sym_POUND,
    STATE(579), 1,
      sym__type,
    STATE(4038), 1,
      sym__static_type_identifier,
    STATE(4159), 1,
      sym_type_argument,
    STATE(4192), 1,
      sym_long_identifier,
    STATE(9359), 1,
      sym_attribute,
    STATE(9740), 1,
      sym__object_construction,
    STATE(11909), 1,
      sym__attribute_target,
    ACTIONS(7731), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4695), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7721), 9,
      anon_sym_module,
      anon_sym_assembly,
      anon_sym_return,
      anon_sym_field,
      anon_sym_property,
      anon_sym_param,
      anon_sym_type,
      anon_sym_constructor,
      anon_sym_event,
    STATE(4190), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [31338] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4696), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3535), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3533), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31404] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4697), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3531), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3529), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31470] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6560), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7723), 1,
      anon_sym_LPAREN,
    ACTIONS(7725), 1,
      anon_sym__,
    ACTIONS(7727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(7729), 1,
      anon_sym_POUND,
    STATE(579), 1,
      sym__type,
    STATE(4038), 1,
      sym__static_type_identifier,
    STATE(4159), 1,
      sym_type_argument,
    STATE(4192), 1,
      sym_long_identifier,
    STATE(9162), 1,
      sym_attribute,
    STATE(9740), 1,
      sym__object_construction,
    STATE(11909), 1,
      sym__attribute_target,
    ACTIONS(7731), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4698), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7721), 9,
      anon_sym_module,
      anon_sym_assembly,
      anon_sym_return,
      anon_sym_field,
      anon_sym_property,
      anon_sym_param,
      anon_sym_type,
      anon_sym_constructor,
      anon_sym_event,
    STATE(4190), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [31562] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4699), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3531), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3529), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31628] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6560), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7723), 1,
      anon_sym_LPAREN,
    ACTIONS(7725), 1,
      anon_sym__,
    ACTIONS(7727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(7729), 1,
      anon_sym_POUND,
    STATE(579), 1,
      sym__type,
    STATE(4038), 1,
      sym__static_type_identifier,
    STATE(4159), 1,
      sym_type_argument,
    STATE(4192), 1,
      sym_long_identifier,
    STATE(9180), 1,
      sym_attribute,
    STATE(9740), 1,
      sym__object_construction,
    STATE(11909), 1,
      sym__attribute_target,
    ACTIONS(7731), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4700), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7721), 9,
      anon_sym_module,
      anon_sym_assembly,
      anon_sym_return,
      anon_sym_field,
      anon_sym_property,
      anon_sym_param,
      anon_sym_type,
      anon_sym_constructor,
      anon_sym_event,
    STATE(4190), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [31720] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4701), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3513), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31786] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7735), 1,
      anon_sym_STAR,
    STATE(4702), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3427), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3425), 19,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31854] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7738), 1,
      anon_sym_LT2,
    STATE(4703), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3505), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3503), 21,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31922] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4704), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3551), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3549), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31988] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4705), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3562), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3560), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32054] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4706), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3535), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3533), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32120] = 37,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7740), 1,
      anon_sym_do,
    ACTIONS(7742), 1,
      anon_sym_let,
    ACTIONS(7744), 1,
      anon_sym_let_BANG,
    ACTIONS(7746), 1,
      anon_sym_new,
    ACTIONS(7748), 1,
      anon_sym_with,
    ACTIONS(7752), 1,
      anon_sym_static,
    ACTIONS(7754), 1,
      anon_sym_member,
    ACTIONS(7756), 1,
      anon_sym_interface,
    ACTIONS(7758), 1,
      anon_sym_abstract,
    ACTIONS(7760), 1,
      anon_sym_val,
    ACTIONS(7762), 1,
      anon_sym_inherit,
    ACTIONS(7764), 1,
      anon_sym_POUNDif,
    ACTIONS(7766), 1,
      anon_sym_POUNDendif,
    ACTIONS(7768), 1,
      sym__newline,
    STATE(4747), 1,
      aux_sym_preproc_if_in_class_definition_repeat1,
    STATE(5159), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6446), 1,
      sym_additional_constr_defn,
    STATE(6493), 1,
      sym__class_type_body_inner,
    STATE(6529), 1,
      sym_function_or_value_defn,
    STATE(7172), 1,
      sym_attributes,
    STATE(11912), 1,
      sym_access_modifier,
    ACTIONS(7750), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6477), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6530), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6438), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4707), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [32240] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4708), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3527), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3525), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32306] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4709), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3513), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32372] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4710), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3535), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3533), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32438] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4711), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3531), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3529), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32504] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4712), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3519), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3517), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32570] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4713), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3523), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3521), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32636] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7525), 1,
      anon_sym_STAR,
    STATE(4702), 1,
      aux_sym_compound_type_repeat1,
    STATE(4714), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3468), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3466), 19,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32706] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4715), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3527), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3525), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32772] = 37,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7740), 1,
      anon_sym_do,
    ACTIONS(7742), 1,
      anon_sym_let,
    ACTIONS(7744), 1,
      anon_sym_let_BANG,
    ACTIONS(7746), 1,
      anon_sym_new,
    ACTIONS(7748), 1,
      anon_sym_with,
    ACTIONS(7752), 1,
      anon_sym_static,
    ACTIONS(7754), 1,
      anon_sym_member,
    ACTIONS(7756), 1,
      anon_sym_interface,
    ACTIONS(7758), 1,
      anon_sym_abstract,
    ACTIONS(7760), 1,
      anon_sym_val,
    ACTIONS(7762), 1,
      anon_sym_inherit,
    ACTIONS(7764), 1,
      anon_sym_POUNDif,
    ACTIONS(7768), 1,
      sym__newline,
    ACTIONS(7770), 1,
      anon_sym_POUNDendif,
    STATE(4707), 1,
      aux_sym_preproc_if_in_class_definition_repeat1,
    STATE(5159), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6446), 1,
      sym_additional_constr_defn,
    STATE(6493), 1,
      sym__class_type_body_inner,
    STATE(6529), 1,
      sym_function_or_value_defn,
    STATE(7172), 1,
      sym_attributes,
    STATE(11912), 1,
      sym_access_modifier,
    ACTIONS(7750), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6477), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6530), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6438), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4716), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [32892] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7772), 1,
      anon_sym_DOT,
    STATE(4677), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4717), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3451), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3449), 20,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32962] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4718), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3527), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3525), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33028] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4719), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3519), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3517), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33094] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4720), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3523), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3521), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33160] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4721), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3547), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3545), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33226] = 24,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7774), 1,
      anon_sym_y,
    ACTIONS(7776), 1,
      anon_sym_uy,
    ACTIONS(7778), 1,
      anon_sym_s,
    ACTIONS(7780), 1,
      anon_sym_us,
    ACTIONS(7782), 1,
      anon_sym_l,
    ACTIONS(7784), 1,
      aux_sym_uint32_token1,
    ACTIONS(7786), 1,
      anon_sym_n,
    ACTIONS(7788), 1,
      anon_sym_un,
    ACTIONS(7790), 1,
      anon_sym_L,
    ACTIONS(7792), 1,
      aux_sym_uint64_token1,
    ACTIONS(7794), 1,
      aux_sym_bignum_token1,
    ACTIONS(7796), 1,
      aux_sym_decimal_token1,
    ACTIONS(7798), 1,
      anon_sym_DOT2,
    ACTIONS(7800), 1,
      aux_sym_float_token1,
    STATE(4722), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3193), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3191), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [33320] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4723), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3523), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3521), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33386] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4724), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3519), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3517), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33452] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6560), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7723), 1,
      anon_sym_LPAREN,
    ACTIONS(7725), 1,
      anon_sym__,
    ACTIONS(7727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(7729), 1,
      anon_sym_POUND,
    STATE(579), 1,
      sym__type,
    STATE(4038), 1,
      sym__static_type_identifier,
    STATE(4159), 1,
      sym_type_argument,
    STATE(4192), 1,
      sym_long_identifier,
    STATE(9740), 1,
      sym__object_construction,
    STATE(9958), 1,
      sym_attribute,
    STATE(11909), 1,
      sym__attribute_target,
    ACTIONS(7731), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4725), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7721), 9,
      anon_sym_module,
      anon_sym_assembly,
      anon_sym_return,
      anon_sym_field,
      anon_sym_property,
      anon_sym_param,
      anon_sym_type,
      anon_sym_constructor,
      anon_sym_event,
    STATE(4190), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [33544] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4726), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3519), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3517), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33610] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4727), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3527), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3525), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33676] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7802), 1,
      anon_sym_COLON_GT,
    STATE(4728), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3513), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33744] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6560), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7723), 1,
      anon_sym_LPAREN,
    ACTIONS(7725), 1,
      anon_sym__,
    ACTIONS(7727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(7729), 1,
      anon_sym_POUND,
    STATE(579), 1,
      sym__type,
    STATE(4038), 1,
      sym__static_type_identifier,
    STATE(4159), 1,
      sym_type_argument,
    STATE(4192), 1,
      sym_long_identifier,
    STATE(9204), 1,
      sym_attribute,
    STATE(9740), 1,
      sym__object_construction,
    STATE(11909), 1,
      sym__attribute_target,
    ACTIONS(7731), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4729), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7721), 9,
      anon_sym_module,
      anon_sym_assembly,
      anon_sym_return,
      anon_sym_field,
      anon_sym_property,
      anon_sym_param,
      anon_sym_type,
      anon_sym_constructor,
      anon_sym_event,
    STATE(4190), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [33836] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4730), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3531), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3529), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33902] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6560), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7723), 1,
      anon_sym_LPAREN,
    ACTIONS(7725), 1,
      anon_sym__,
    ACTIONS(7727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(7729), 1,
      anon_sym_POUND,
    STATE(579), 1,
      sym__type,
    STATE(4038), 1,
      sym__static_type_identifier,
    STATE(4159), 1,
      sym_type_argument,
    STATE(4192), 1,
      sym_long_identifier,
    STATE(9294), 1,
      sym_attribute,
    STATE(9740), 1,
      sym__object_construction,
    STATE(11909), 1,
      sym__attribute_target,
    ACTIONS(7731), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4731), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7721), 9,
      anon_sym_module,
      anon_sym_assembly,
      anon_sym_return,
      anon_sym_field,
      anon_sym_property,
      anon_sym_param,
      anon_sym_type,
      anon_sym_constructor,
      anon_sym_event,
    STATE(4190), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [33994] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4732), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3535), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3533), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34060] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4733), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3547), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3545), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34126] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4734), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3523), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3521), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34192] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4735), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3543), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3541), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34258] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4736), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3539), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3537), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34324] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7804), 1,
      anon_sym_LT2,
    STATE(4737), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3505), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3503), 19,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34392] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4738), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3519), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3517), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34458] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7772), 1,
      anon_sym_DOT,
    STATE(4717), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4739), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3494), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3492), 20,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34528] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4740), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3523), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3521), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34594] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4741), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3551), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3549), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34660] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4742), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3562), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3560), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34726] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4743), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3539), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3537), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34792] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4744), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34858] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4745), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3547), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3545), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34924] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4746), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3562), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3560), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34990] = 36,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7661), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7673), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7706), 1,
      anon_sym_POUNDendif,
    ACTIONS(7806), 1,
      anon_sym_do,
    ACTIONS(7809), 1,
      anon_sym_let,
    ACTIONS(7812), 1,
      anon_sym_let_BANG,
    ACTIONS(7815), 1,
      anon_sym_new,
    ACTIONS(7818), 1,
      anon_sym_with,
    ACTIONS(7824), 1,
      anon_sym_static,
    ACTIONS(7827), 1,
      anon_sym_member,
    ACTIONS(7830), 1,
      anon_sym_interface,
    ACTIONS(7833), 1,
      anon_sym_abstract,
    ACTIONS(7836), 1,
      anon_sym_val,
    ACTIONS(7839), 1,
      anon_sym_inherit,
    ACTIONS(7842), 1,
      anon_sym_POUNDif,
    ACTIONS(7845), 1,
      sym__newline,
    STATE(5159), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6446), 1,
      sym_additional_constr_defn,
    STATE(6493), 1,
      sym__class_type_body_inner,
    STATE(6529), 1,
      sym_function_or_value_defn,
    STATE(7172), 1,
      sym_attributes,
    STATE(11912), 1,
      sym_access_modifier,
    ACTIONS(7821), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6477), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6530), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6438), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4747), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_preproc_if_in_class_definition_repeat1,
  [35108] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4748), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3547), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3545), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [35174] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4749), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3535), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3533), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [35240] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4750), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3531), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3529), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [35306] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7848), 1,
      anon_sym_LT2,
    STATE(4751), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3505), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3503), 19,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [35374] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4752), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3487), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [35440] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4753), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3527), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3525), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [35506] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7850), 1,
      aux_sym_float_token1,
    STATE(4754), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3604), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3602), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [35574] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4755), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3543), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3541), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [35640] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4756), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3543), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3541), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [35706] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4757), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3513), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [35772] = 36,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6862), 1,
      anon_sym_let,
    ACTIONS(6864), 1,
      anon_sym_let_BANG,
    ACTIONS(6900), 1,
      anon_sym_POUNDif,
    ACTIONS(7852), 1,
      anon_sym_do,
    ACTIONS(7854), 1,
      anon_sym_new,
    ACTIONS(7856), 1,
      anon_sym_with,
    ACTIONS(7860), 1,
      anon_sym_static,
    ACTIONS(7862), 1,
      anon_sym_member,
    ACTIONS(7864), 1,
      anon_sym_interface,
    ACTIONS(7866), 1,
      anon_sym_abstract,
    ACTIONS(7868), 1,
      anon_sym_val,
    ACTIONS(7870), 1,
      anon_sym_inherit,
    ACTIONS(7872), 1,
      sym__dedent,
    STATE(5324), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6835), 1,
      sym_function_or_value_defn,
    STATE(6864), 1,
      sym_additional_constr_defn,
    STATE(7100), 1,
      sym_attributes,
    STATE(9306), 1,
      sym__class_type_body_inner,
    STATE(10247), 1,
      sym__class_type_body,
    STATE(11317), 1,
      sym_access_modifier,
    ACTIONS(7858), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6862), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(9527), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6840), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4758), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [35889] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7874), 1,
      anon_sym_DOT,
    STATE(4759), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3487), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [35956] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4760), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3547), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3545), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [36021] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7877), 1,
      anon_sym_DOT,
    STATE(4765), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4761), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3451), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3449), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [36090] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7879), 1,
      anon_sym_or,
    STATE(4770), 1,
      aux_sym_type_argument_repeat1,
    STATE(4762), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3476), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3474), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [36159] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7881), 1,
      anon_sym_DOT,
    STATE(4782), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4763), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3451), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3449), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [36228] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7883), 1,
      anon_sym_DOT,
    STATE(4808), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4764), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3781), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3778), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [36297] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7885), 1,
      anon_sym_DOT,
    STATE(4765), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3487), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [36364] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4766), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3728), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3726), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [36429] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4767), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3604), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3602), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [36494] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4768), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3604), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3602), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [36559] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7879), 1,
      anon_sym_or,
    STATE(4762), 1,
      aux_sym_type_argument_repeat1,
    STATE(4769), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [36628] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7888), 1,
      anon_sym_or,
    STATE(4770), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3480), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [36695] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7772), 1,
      anon_sym_DOT,
    ACTIONS(7891), 1,
      anon_sym_EQ,
    STATE(4717), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4771), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3781), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3778), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [36766] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7897), 1,
      anon_sym_and,
    STATE(4777), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(4772), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7893), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7895), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [36835] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4773), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3523), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3521), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [36900] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4774), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3519), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3517), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [36965] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7899), 1,
      sym_int,
    STATE(4775), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3753), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3751), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [37032] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7901), 1,
      anon_sym_or,
    STATE(4776), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3480), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [37099] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7897), 1,
      anon_sym_and,
    STATE(4780), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(4777), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7904), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7906), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [37168] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4778), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3728), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3726), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [37233] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4779), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3527), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3525), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [37298] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7912), 1,
      anon_sym_and,
    STATE(4780), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(7908), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7910), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [37365] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7084), 1,
      aux_sym_decimal_token1,
    ACTIONS(7206), 1,
      anon_sym_f,
    STATE(4781), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3193), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3191), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [37434] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7915), 1,
      anon_sym_DOT,
    STATE(4782), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3487), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [37501] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4783), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3531), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3529), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [37566] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4784), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3535), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3533), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [37631] = 36,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6862), 1,
      anon_sym_let,
    ACTIONS(6864), 1,
      anon_sym_let_BANG,
    ACTIONS(6900), 1,
      anon_sym_POUNDif,
    ACTIONS(7852), 1,
      anon_sym_do,
    ACTIONS(7854), 1,
      anon_sym_new,
    ACTIONS(7856), 1,
      anon_sym_with,
    ACTIONS(7860), 1,
      anon_sym_static,
    ACTIONS(7862), 1,
      anon_sym_member,
    ACTIONS(7864), 1,
      anon_sym_interface,
    ACTIONS(7866), 1,
      anon_sym_abstract,
    ACTIONS(7868), 1,
      anon_sym_val,
    ACTIONS(7870), 1,
      anon_sym_inherit,
    ACTIONS(7918), 1,
      sym__dedent,
    STATE(5324), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6835), 1,
      sym_function_or_value_defn,
    STATE(6864), 1,
      sym_additional_constr_defn,
    STATE(7100), 1,
      sym_attributes,
    STATE(9306), 1,
      sym__class_type_body_inner,
    STATE(10253), 1,
      sym__class_type_body,
    STATE(11317), 1,
      sym_access_modifier,
    ACTIONS(7858), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6862), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(9527), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6840), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4785), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [37748] = 36,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6862), 1,
      anon_sym_let,
    ACTIONS(6864), 1,
      anon_sym_let_BANG,
    ACTIONS(6900), 1,
      anon_sym_POUNDif,
    ACTIONS(7852), 1,
      anon_sym_do,
    ACTIONS(7854), 1,
      anon_sym_new,
    ACTIONS(7856), 1,
      anon_sym_with,
    ACTIONS(7860), 1,
      anon_sym_static,
    ACTIONS(7862), 1,
      anon_sym_member,
    ACTIONS(7864), 1,
      anon_sym_interface,
    ACTIONS(7866), 1,
      anon_sym_abstract,
    ACTIONS(7868), 1,
      anon_sym_val,
    ACTIONS(7870), 1,
      anon_sym_inherit,
    ACTIONS(7920), 1,
      sym__dedent,
    STATE(5324), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6835), 1,
      sym_function_or_value_defn,
    STATE(6864), 1,
      sym_additional_constr_defn,
    STATE(7100), 1,
      sym_attributes,
    STATE(9306), 1,
      sym__class_type_body_inner,
    STATE(10272), 1,
      sym__class_type_body,
    STATE(11317), 1,
      sym_access_modifier,
    ACTIONS(7858), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6862), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(9527), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6840), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4786), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [37865] = 36,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6862), 1,
      anon_sym_let,
    ACTIONS(6864), 1,
      anon_sym_let_BANG,
    ACTIONS(6900), 1,
      anon_sym_POUNDif,
    ACTIONS(7852), 1,
      anon_sym_do,
    ACTIONS(7854), 1,
      anon_sym_new,
    ACTIONS(7856), 1,
      anon_sym_with,
    ACTIONS(7860), 1,
      anon_sym_static,
    ACTIONS(7862), 1,
      anon_sym_member,
    ACTIONS(7864), 1,
      anon_sym_interface,
    ACTIONS(7866), 1,
      anon_sym_abstract,
    ACTIONS(7868), 1,
      anon_sym_val,
    ACTIONS(7870), 1,
      anon_sym_inherit,
    ACTIONS(7922), 1,
      sym__dedent,
    STATE(5324), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6835), 1,
      sym_function_or_value_defn,
    STATE(6864), 1,
      sym_additional_constr_defn,
    STATE(7100), 1,
      sym_attributes,
    STATE(9306), 1,
      sym__class_type_body_inner,
    STATE(10254), 1,
      sym__class_type_body,
    STATE(11317), 1,
      sym_access_modifier,
    ACTIONS(7858), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6862), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(9527), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6840), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4787), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [37982] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7112), 1,
      aux_sym_decimal_token1,
    ACTIONS(7202), 1,
      anon_sym_f,
    STATE(4788), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3193), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3191), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [38051] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4789), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3562), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3560), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [38116] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4790), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3551), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3549), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [38181] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7924), 1,
      anon_sym_or,
    STATE(4776), 1,
      aux_sym_type_argument_repeat1,
    STATE(4791), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3476), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3474), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [38250] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7883), 1,
      anon_sym_DOT,
    STATE(4808), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4792), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3494), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3492), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [38319] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7926), 1,
      aux_sym_float_token1,
    STATE(4793), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3604), 15,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3602), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [38386] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7772), 1,
      anon_sym_DOT,
    STATE(4717), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4794), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3781), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3778), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [38455] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7928), 1,
      aux_sym_float_token1,
    STATE(4795), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3604), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3602), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [38522] = 36,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6862), 1,
      anon_sym_let,
    ACTIONS(6864), 1,
      anon_sym_let_BANG,
    ACTIONS(6900), 1,
      anon_sym_POUNDif,
    ACTIONS(7852), 1,
      anon_sym_do,
    ACTIONS(7854), 1,
      anon_sym_new,
    ACTIONS(7856), 1,
      anon_sym_with,
    ACTIONS(7860), 1,
      anon_sym_static,
    ACTIONS(7862), 1,
      anon_sym_member,
    ACTIONS(7864), 1,
      anon_sym_interface,
    ACTIONS(7866), 1,
      anon_sym_abstract,
    ACTIONS(7868), 1,
      anon_sym_val,
    ACTIONS(7870), 1,
      anon_sym_inherit,
    ACTIONS(7930), 1,
      sym__dedent,
    STATE(5324), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6835), 1,
      sym_function_or_value_defn,
    STATE(6864), 1,
      sym_additional_constr_defn,
    STATE(7100), 1,
      sym_attributes,
    STATE(9306), 1,
      sym__class_type_body_inner,
    STATE(11078), 1,
      sym__class_type_body,
    STATE(11317), 1,
      sym_access_modifier,
    ACTIONS(7858), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6862), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(9527), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6840), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4796), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [38639] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7924), 1,
      anon_sym_or,
    STATE(4791), 1,
      aux_sym_type_argument_repeat1,
    STATE(4797), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [38708] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4798), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3487), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 21,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [38773] = 36,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6862), 1,
      anon_sym_let,
    ACTIONS(6864), 1,
      anon_sym_let_BANG,
    ACTIONS(6900), 1,
      anon_sym_POUNDif,
    ACTIONS(7852), 1,
      anon_sym_do,
    ACTIONS(7854), 1,
      anon_sym_new,
    ACTIONS(7856), 1,
      anon_sym_with,
    ACTIONS(7860), 1,
      anon_sym_static,
    ACTIONS(7862), 1,
      anon_sym_member,
    ACTIONS(7864), 1,
      anon_sym_interface,
    ACTIONS(7866), 1,
      anon_sym_abstract,
    ACTIONS(7868), 1,
      anon_sym_val,
    ACTIONS(7870), 1,
      anon_sym_inherit,
    ACTIONS(7932), 1,
      sym__dedent,
    STATE(5324), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6835), 1,
      sym_function_or_value_defn,
    STATE(6864), 1,
      sym_additional_constr_defn,
    STATE(7100), 1,
      sym_attributes,
    STATE(9306), 1,
      sym__class_type_body_inner,
    STATE(10200), 1,
      sym__class_type_body,
    STATE(11317), 1,
      sym_access_modifier,
    ACTIONS(7858), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6862), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(9527), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6840), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4799), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [38890] = 36,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6862), 1,
      anon_sym_let,
    ACTIONS(6864), 1,
      anon_sym_let_BANG,
    ACTIONS(6900), 1,
      anon_sym_POUNDif,
    ACTIONS(7852), 1,
      anon_sym_do,
    ACTIONS(7854), 1,
      anon_sym_new,
    ACTIONS(7856), 1,
      anon_sym_with,
    ACTIONS(7860), 1,
      anon_sym_static,
    ACTIONS(7862), 1,
      anon_sym_member,
    ACTIONS(7864), 1,
      anon_sym_interface,
    ACTIONS(7866), 1,
      anon_sym_abstract,
    ACTIONS(7868), 1,
      anon_sym_val,
    ACTIONS(7870), 1,
      anon_sym_inherit,
    ACTIONS(7934), 1,
      sym__dedent,
    STATE(5324), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6835), 1,
      sym_function_or_value_defn,
    STATE(6864), 1,
      sym_additional_constr_defn,
    STATE(7100), 1,
      sym_attributes,
    STATE(9306), 1,
      sym__class_type_body_inner,
    STATE(10187), 1,
      sym__class_type_body,
    STATE(11317), 1,
      sym_access_modifier,
    ACTIONS(7858), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6862), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(9527), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6840), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4800), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [39007] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7936), 1,
      sym_int,
    STATE(4801), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3753), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3751), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [39074] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7938), 1,
      anon_sym_LT2,
    STATE(4802), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3505), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3503), 19,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [39141] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4803), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3543), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3541), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [39206] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7881), 1,
      anon_sym_DOT,
    STATE(4763), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4804), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3494), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3492), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [39275] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4805), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3513), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [39340] = 36,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6862), 1,
      anon_sym_let,
    ACTIONS(6864), 1,
      anon_sym_let_BANG,
    ACTIONS(6900), 1,
      anon_sym_POUNDif,
    ACTIONS(7852), 1,
      anon_sym_do,
    ACTIONS(7854), 1,
      anon_sym_new,
    ACTIONS(7856), 1,
      anon_sym_with,
    ACTIONS(7860), 1,
      anon_sym_static,
    ACTIONS(7862), 1,
      anon_sym_member,
    ACTIONS(7864), 1,
      anon_sym_interface,
    ACTIONS(7866), 1,
      anon_sym_abstract,
    ACTIONS(7868), 1,
      anon_sym_val,
    ACTIONS(7870), 1,
      anon_sym_inherit,
    ACTIONS(7940), 1,
      sym__dedent,
    STATE(5324), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6835), 1,
      sym_function_or_value_defn,
    STATE(6864), 1,
      sym_additional_constr_defn,
    STATE(7100), 1,
      sym_attributes,
    STATE(9306), 1,
      sym__class_type_body_inner,
    STATE(10256), 1,
      sym__class_type_body,
    STATE(11317), 1,
      sym_access_modifier,
    ACTIONS(7858), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6862), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(9527), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6840), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4806), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [39457] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7877), 1,
      anon_sym_DOT,
    STATE(4761), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4807), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3494), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3492), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [39526] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7883), 1,
      anon_sym_DOT,
    STATE(4759), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4808), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3451), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3449), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [39595] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4809), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3539), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3537), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [39660] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7942), 1,
      anon_sym_and,
    STATE(4810), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(7908), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7910), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [39726] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4811), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7945), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7947), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [39790] = 35,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6862), 1,
      anon_sym_let,
    ACTIONS(6864), 1,
      anon_sym_let_BANG,
    ACTIONS(6900), 1,
      anon_sym_POUNDif,
    ACTIONS(7852), 1,
      anon_sym_do,
    ACTIONS(7854), 1,
      anon_sym_new,
    ACTIONS(7856), 1,
      anon_sym_with,
    ACTIONS(7860), 1,
      anon_sym_static,
    ACTIONS(7862), 1,
      anon_sym_member,
    ACTIONS(7864), 1,
      anon_sym_interface,
    ACTIONS(7866), 1,
      anon_sym_abstract,
    ACTIONS(7868), 1,
      anon_sym_val,
    ACTIONS(7870), 1,
      anon_sym_inherit,
    STATE(5324), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6835), 1,
      sym_function_or_value_defn,
    STATE(6864), 1,
      sym_additional_constr_defn,
    STATE(7100), 1,
      sym_attributes,
    STATE(9306), 1,
      sym__class_type_body_inner,
    STATE(11317), 1,
      sym_access_modifier,
    STATE(11741), 1,
      sym__class_type_body,
    ACTIONS(7858), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6862), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(9527), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6840), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4812), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [39904] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7949), 1,
      anon_sym_EQ,
    ACTIONS(7951), 1,
      anon_sym_DOT,
    STATE(4856), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4813), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3781), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3778), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [39974] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7140), 1,
      aux_sym_decimal_token1,
    ACTIONS(7214), 1,
      anon_sym_f,
    STATE(4814), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3193), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3191), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [40042] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7951), 1,
      anon_sym_DOT,
    ACTIONS(7953), 1,
      anon_sym_EQ,
    STATE(4856), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4815), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3781), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3778), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [40112] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7951), 1,
      anon_sym_DOT,
    ACTIONS(7955), 1,
      anon_sym_EQ,
    STATE(4856), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4816), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3781), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3778), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [40182] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7957), 1,
      anon_sym_DOT,
    STATE(4817), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3487), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [40248] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7960), 1,
      anon_sym_and,
    STATE(4818), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(7908), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7910), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [40314] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4826), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(4819), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7963), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7965), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [40380] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7967), 1,
      anon_sym_and,
    STATE(4921), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(4820), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7893), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7895), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [40448] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4821), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3728), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3726), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [40512] = 29,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7969), 1,
      sym_identifier,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7973), 1,
      anon_sym_LPAREN,
    ACTIONS(7975), 1,
      anon_sym__,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(7979), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_POUND,
    STATE(5009), 1,
      aux_sym_curried_spec_repeat1,
    STATE(5341), 1,
      sym__static_type_identifier,
    STATE(5353), 1,
      sym__type,
    STATE(5434), 1,
      sym_type_argument,
    STATE(5484), 1,
      sym_attributes,
    STATE(5528), 1,
      sym_long_identifier,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(6351), 1,
      sym_curried_spec,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(7983), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4822), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5525), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [40614] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5462), 1,
      anon_sym_COMMA,
    STATE(4908), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(4823), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7985), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7987), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [40682] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7993), 1,
      anon_sym_LT2,
    STATE(4824), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7989), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7991), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [40748] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4826), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(4825), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7995), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7997), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [40814] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5369), 1,
      anon_sym_COMMA,
    STATE(4901), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(4826), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7985), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7987), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [40882] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4827), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3487), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 20,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [40946] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7999), 1,
      anon_sym_or,
    STATE(4835), 1,
      aux_sym_type_argument_repeat1,
    STATE(4828), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3476), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3474), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [41014] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8001), 1,
      anon_sym_or,
    STATE(4829), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3480), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [41080] = 29,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7969), 1,
      sym_identifier,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7973), 1,
      anon_sym_LPAREN,
    ACTIONS(7975), 1,
      anon_sym__,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(7979), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_POUND,
    STATE(5009), 1,
      aux_sym_curried_spec_repeat1,
    STATE(5341), 1,
      sym__static_type_identifier,
    STATE(5353), 1,
      sym__type,
    STATE(5434), 1,
      sym_type_argument,
    STATE(5484), 1,
      sym_attributes,
    STATE(5528), 1,
      sym_long_identifier,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(6344), 1,
      sym_curried_spec,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(7983), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4830), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5525), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [41182] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7877), 1,
      anon_sym_DOT,
    STATE(4761), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4831), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3781), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3778), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [41250] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8004), 1,
      aux_sym_float_token1,
    STATE(4832), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3604), 15,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3602), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [41316] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8006), 1,
      anon_sym_or,
    STATE(4829), 1,
      aux_sym_type_argument_repeat1,
    STATE(4833), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3476), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3474), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [41384] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4834), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3511), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3509), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [41448] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8008), 1,
      anon_sym_or,
    STATE(4835), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3480), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [41514] = 29,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(8011), 1,
      sym_identifier,
    ACTIONS(8013), 1,
      anon_sym_LPAREN,
    ACTIONS(8015), 1,
      anon_sym__,
    ACTIONS(8017), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8019), 1,
      anon_sym_POUND,
    STATE(5048), 1,
      aux_sym_curried_spec_repeat1,
    STATE(5361), 1,
      sym__type,
    STATE(5402), 1,
      sym__static_type_identifier,
    STATE(5484), 1,
      sym_attributes,
    STATE(5488), 1,
      sym_type_argument,
    STATE(5627), 1,
      sym_long_identifier,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(6437), 1,
      sym_curried_spec,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(8021), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4836), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5557), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [41616] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4837), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7908), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7910), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [41680] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4838), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7283), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7285), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [41744] = 22,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7774), 1,
      anon_sym_y,
    ACTIONS(7776), 1,
      anon_sym_uy,
    ACTIONS(7778), 1,
      anon_sym_s,
    ACTIONS(7780), 1,
      anon_sym_us,
    ACTIONS(7782), 1,
      anon_sym_l,
    ACTIONS(7784), 1,
      aux_sym_uint32_token1,
    ACTIONS(7786), 1,
      anon_sym_n,
    ACTIONS(7788), 1,
      anon_sym_un,
    ACTIONS(7790), 1,
      anon_sym_L,
    ACTIONS(7792), 1,
      aux_sym_uint64_token1,
    ACTIONS(8023), 1,
      anon_sym_lf,
    ACTIONS(8025), 1,
      anon_sym_LF,
    STATE(4839), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3193), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3191), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [41832] = 29,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(8027), 1,
      sym_identifier,
    ACTIONS(8029), 1,
      anon_sym_LPAREN,
    ACTIONS(8031), 1,
      anon_sym__,
    ACTIONS(8033), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8035), 1,
      anon_sym_POUND,
    STATE(5010), 1,
      aux_sym_curried_spec_repeat1,
    STATE(5475), 1,
      sym__static_type_identifier,
    STATE(5484), 1,
      sym_attributes,
    STATE(5549), 1,
      sym__type,
    STATE(5630), 1,
      sym_type_argument,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(6183), 1,
      sym_long_identifier,
    STATE(6901), 1,
      sym_curried_spec,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(8037), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4840), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6184), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [41934] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4823), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(4841), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7995), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7997), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [42000] = 29,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(8011), 1,
      sym_identifier,
    ACTIONS(8013), 1,
      anon_sym_LPAREN,
    ACTIONS(8015), 1,
      anon_sym__,
    ACTIONS(8017), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8019), 1,
      anon_sym_POUND,
    STATE(5048), 1,
      aux_sym_curried_spec_repeat1,
    STATE(5361), 1,
      sym__type,
    STATE(5402), 1,
      sym__static_type_identifier,
    STATE(5484), 1,
      sym_attributes,
    STATE(5488), 1,
      sym_type_argument,
    STATE(5627), 1,
      sym_long_identifier,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(6454), 1,
      sym_curried_spec,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(8021), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4842), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5557), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [42102] = 35,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6862), 1,
      anon_sym_let,
    ACTIONS(6864), 1,
      anon_sym_let_BANG,
    ACTIONS(6900), 1,
      anon_sym_POUNDif,
    ACTIONS(7852), 1,
      anon_sym_do,
    ACTIONS(7854), 1,
      anon_sym_new,
    ACTIONS(7856), 1,
      anon_sym_with,
    ACTIONS(7860), 1,
      anon_sym_static,
    ACTIONS(7862), 1,
      anon_sym_member,
    ACTIONS(7864), 1,
      anon_sym_interface,
    ACTIONS(7866), 1,
      anon_sym_abstract,
    ACTIONS(7868), 1,
      anon_sym_val,
    ACTIONS(7870), 1,
      anon_sym_inherit,
    STATE(5324), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6835), 1,
      sym_function_or_value_defn,
    STATE(6864), 1,
      sym_additional_constr_defn,
    STATE(7100), 1,
      sym_attributes,
    STATE(9306), 1,
      sym__class_type_body_inner,
    STATE(11317), 1,
      sym_access_modifier,
    STATE(11822), 1,
      sym__class_type_body,
    ACTIONS(7858), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6862), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(9527), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6840), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4843), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [42216] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4844), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7945), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7947), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [42280] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8039), 1,
      sym_int,
    STATE(4845), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3753), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3751), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [42346] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7951), 1,
      anon_sym_DOT,
    ACTIONS(8041), 1,
      anon_sym_EQ,
    STATE(4856), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4846), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3781), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3778), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [42416] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4847), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8043), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8045), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [42480] = 29,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6866), 1,
      anon_sym_LPAREN,
    ACTIONS(6868), 1,
      anon_sym__,
    ACTIONS(6874), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6880), 1,
      anon_sym_POUND,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(8047), 1,
      sym_identifier,
    STATE(4957), 1,
      aux_sym_curried_spec_repeat1,
    STATE(5484), 1,
      sym_attributes,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(6214), 1,
      sym__static_type_identifier,
    STATE(6258), 1,
      sym__type,
    STATE(6488), 1,
      sym_type_argument,
    STATE(6600), 1,
      sym_long_identifier,
    STATE(7430), 1,
      sym_curried_spec,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(6882), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4848), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6550), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [42582] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4849), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3604), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3602), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [42646] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8049), 1,
      anon_sym_and,
    STATE(4923), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(4850), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7904), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7906), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [42714] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4851), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3511), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3509), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [42778] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4852), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8051), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8053), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [42842] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7951), 1,
      anon_sym_DOT,
    ACTIONS(8055), 1,
      anon_sym_EQ,
    STATE(4856), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4853), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3781), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3778), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [42912] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4854), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8057), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8059), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [42976] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7951), 1,
      anon_sym_DOT,
    ACTIONS(8061), 1,
      anon_sym_EQ,
    STATE(4856), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4855), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3781), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3778), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [43046] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7951), 1,
      anon_sym_DOT,
    STATE(4817), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4856), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3451), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3449), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [43114] = 29,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(8063), 1,
      sym_identifier,
    ACTIONS(8065), 1,
      anon_sym_LPAREN,
    ACTIONS(8067), 1,
      anon_sym__,
    ACTIONS(8069), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8071), 1,
      anon_sym_POUND,
    STATE(5079), 1,
      aux_sym_curried_spec_repeat1,
    STATE(5379), 1,
      sym__type,
    STATE(5407), 1,
      sym__static_type_identifier,
    STATE(5484), 1,
      sym_attributes,
    STATE(5510), 1,
      sym_type_argument,
    STATE(5638), 1,
      sym_long_identifier,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(6469), 1,
      sym_curried_spec,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(8073), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4857), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5590), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [43216] = 35,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6862), 1,
      anon_sym_let,
    ACTIONS(6864), 1,
      anon_sym_let_BANG,
    ACTIONS(6900), 1,
      anon_sym_POUNDif,
    ACTIONS(7852), 1,
      anon_sym_do,
    ACTIONS(7854), 1,
      anon_sym_new,
    ACTIONS(7856), 1,
      anon_sym_with,
    ACTIONS(7860), 1,
      anon_sym_static,
    ACTIONS(7862), 1,
      anon_sym_member,
    ACTIONS(7864), 1,
      anon_sym_interface,
    ACTIONS(7866), 1,
      anon_sym_abstract,
    ACTIONS(7868), 1,
      anon_sym_val,
    ACTIONS(7870), 1,
      anon_sym_inherit,
    STATE(5324), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6835), 1,
      sym_function_or_value_defn,
    STATE(6864), 1,
      sym_additional_constr_defn,
    STATE(7100), 1,
      sym_attributes,
    STATE(9306), 1,
      sym__class_type_body_inner,
    STATE(11317), 1,
      sym_access_modifier,
    STATE(11888), 1,
      sym__class_type_body,
    ACTIONS(7858), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6862), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(9527), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6840), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4858), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [43330] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4859), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8057), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8059), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [43394] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4860), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8043), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8045), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [43458] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4861), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3604), 15,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3602), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [43522] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7951), 1,
      anon_sym_DOT,
    ACTIONS(8075), 1,
      anon_sym_EQ,
    STATE(4856), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4862), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3781), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3778), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [43592] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7951), 1,
      anon_sym_DOT,
    ACTIONS(8077), 1,
      anon_sym_EQ,
    STATE(4856), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4863), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3781), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3778), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [43662] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4864), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8051), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8053), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [43726] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7951), 1,
      anon_sym_DOT,
    ACTIONS(8079), 1,
      anon_sym_EQ,
    STATE(4856), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4865), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3781), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3778), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [43796] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8006), 1,
      anon_sym_or,
    STATE(4833), 1,
      aux_sym_type_argument_repeat1,
    STATE(4866), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [43864] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8081), 1,
      anon_sym_and,
    STATE(4818), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(4867), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7904), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7906), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [43932] = 35,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6862), 1,
      anon_sym_let,
    ACTIONS(6864), 1,
      anon_sym_let_BANG,
    ACTIONS(6900), 1,
      anon_sym_POUNDif,
    ACTIONS(7852), 1,
      anon_sym_do,
    ACTIONS(7854), 1,
      anon_sym_new,
    ACTIONS(7856), 1,
      anon_sym_with,
    ACTIONS(7860), 1,
      anon_sym_static,
    ACTIONS(7862), 1,
      anon_sym_member,
    ACTIONS(7864), 1,
      anon_sym_interface,
    ACTIONS(7866), 1,
      anon_sym_abstract,
    ACTIONS(7868), 1,
      anon_sym_val,
    ACTIONS(7870), 1,
      anon_sym_inherit,
    STATE(5324), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6835), 1,
      sym_function_or_value_defn,
    STATE(6864), 1,
      sym_additional_constr_defn,
    STATE(7100), 1,
      sym_attributes,
    STATE(9306), 1,
      sym__class_type_body_inner,
    STATE(10267), 1,
      sym__class_type_body,
    STATE(11317), 1,
      sym_access_modifier,
    ACTIONS(7858), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6862), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(9527), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6840), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4868), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [44046] = 29,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(8083), 1,
      sym_identifier,
    ACTIONS(8085), 1,
      anon_sym_LPAREN,
    ACTIONS(8087), 1,
      anon_sym__,
    ACTIONS(8089), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8091), 1,
      anon_sym_POUND,
    STATE(2987), 1,
      sym__type,
    STATE(3174), 1,
      sym__static_type_identifier,
    STATE(3579), 1,
      sym_type_argument,
    STATE(3606), 1,
      sym_long_identifier,
    STATE(3758), 1,
      sym_curried_spec,
    STATE(4963), 1,
      aux_sym_curried_spec_repeat1,
    STATE(5484), 1,
      sym_attributes,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(8093), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4869), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3611), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [44148] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4870), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7283), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7285), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [44212] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7951), 1,
      anon_sym_DOT,
    ACTIONS(8095), 1,
      anon_sym_EQ,
    STATE(4856), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4871), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3781), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3778), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [44282] = 29,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(8063), 1,
      sym_identifier,
    ACTIONS(8065), 1,
      anon_sym_LPAREN,
    ACTIONS(8067), 1,
      anon_sym__,
    ACTIONS(8069), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8071), 1,
      anon_sym_POUND,
    STATE(5079), 1,
      aux_sym_curried_spec_repeat1,
    STATE(5379), 1,
      sym__type,
    STATE(5407), 1,
      sym__static_type_identifier,
    STATE(5484), 1,
      sym_attributes,
    STATE(5510), 1,
      sym_type_argument,
    STATE(5638), 1,
      sym_long_identifier,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(6483), 1,
      sym_curried_spec,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(8073), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4872), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5590), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [44384] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7881), 1,
      anon_sym_DOT,
    STATE(4763), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4873), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3781), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3778), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [44452] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7951), 1,
      anon_sym_DOT,
    ACTIONS(8097), 1,
      anon_sym_EQ,
    STATE(4856), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4874), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3781), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3778), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [44522] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4875), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7279), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7281), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [44586] = 29,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(8099), 1,
      sym_identifier,
    ACTIONS(8101), 1,
      anon_sym_LPAREN,
    ACTIONS(8103), 1,
      anon_sym__,
    ACTIONS(8105), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8107), 1,
      anon_sym_POUND,
    STATE(4938), 1,
      aux_sym_curried_spec_repeat1,
    STATE(5464), 1,
      sym__static_type_identifier,
    STATE(5474), 1,
      sym__type,
    STATE(5484), 1,
      sym_attributes,
    STATE(5618), 1,
      sym_type_argument,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(6164), 1,
      sym_long_identifier,
    STATE(6575), 1,
      sym_curried_spec,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(8109), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4876), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6161), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [44688] = 29,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(8111), 1,
      sym_identifier,
    ACTIONS(8113), 1,
      anon_sym_LPAREN,
    ACTIONS(8115), 1,
      anon_sym__,
    ACTIONS(8117), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8119), 1,
      anon_sym_POUND,
    STATE(4954), 1,
      aux_sym_curried_spec_repeat1,
    STATE(5455), 1,
      sym__type,
    STATE(5463), 1,
      sym__static_type_identifier,
    STATE(5484), 1,
      sym_attributes,
    STATE(5566), 1,
      sym_type_argument,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(6046), 1,
      sym_long_identifier,
    STATE(6538), 1,
      sym_curried_spec,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(8121), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4877), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5996), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [44790] = 29,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6866), 1,
      anon_sym_LPAREN,
    ACTIONS(6868), 1,
      anon_sym__,
    ACTIONS(6874), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6880), 1,
      anon_sym_POUND,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(8047), 1,
      sym_identifier,
    STATE(4957), 1,
      aux_sym_curried_spec_repeat1,
    STATE(5484), 1,
      sym_attributes,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(6214), 1,
      sym__static_type_identifier,
    STATE(6258), 1,
      sym__type,
    STATE(6488), 1,
      sym_type_argument,
    STATE(6600), 1,
      sym_long_identifier,
    STATE(7462), 1,
      sym_curried_spec,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(6882), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4878), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6550), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [44892] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4879), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3728), 15,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3726), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [44956] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8123), 1,
      sym_int,
    STATE(4880), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3753), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3751), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [45022] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4881), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7279), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7281), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [45086] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4882), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3487), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 19,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [45150] = 29,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(8027), 1,
      sym_identifier,
    ACTIONS(8029), 1,
      anon_sym_LPAREN,
    ACTIONS(8031), 1,
      anon_sym__,
    ACTIONS(8033), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8035), 1,
      anon_sym_POUND,
    STATE(5010), 1,
      aux_sym_curried_spec_repeat1,
    STATE(5475), 1,
      sym__static_type_identifier,
    STATE(5484), 1,
      sym_attributes,
    STATE(5549), 1,
      sym__type,
    STATE(5630), 1,
      sym_type_argument,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(6183), 1,
      sym_long_identifier,
    STATE(6937), 1,
      sym_curried_spec,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(8037), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4883), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6184), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [45252] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8125), 1,
      anon_sym_and,
    STATE(4886), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(4884), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7893), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7895), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [45320] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4885), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7908), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7910), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [45384] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8125), 1,
      anon_sym_and,
    STATE(4888), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(4886), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7904), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7906), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [45452] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4823), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(4887), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8127), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8129), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [45518] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8131), 1,
      anon_sym_and,
    STATE(4888), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(7908), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7910), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [45584] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4823), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(4889), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8134), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8136), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [45650] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4890), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3480), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [45714] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7951), 1,
      anon_sym_DOT,
    STATE(4856), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4891), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3494), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3492), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [45782] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4823), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(4892), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8138), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8140), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [45848] = 29,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(8142), 1,
      sym_identifier,
    ACTIONS(8144), 1,
      anon_sym_LPAREN,
    ACTIONS(8146), 1,
      anon_sym__,
    ACTIONS(8148), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8150), 1,
      anon_sym_POUND,
    STATE(5007), 1,
      aux_sym_curried_spec_repeat1,
    STATE(5484), 1,
      sym_attributes,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(6211), 1,
      sym__type,
    STATE(6273), 1,
      sym__static_type_identifier,
    STATE(6417), 1,
      sym_type_argument,
    STATE(6603), 1,
      sym_long_identifier,
    STATE(7397), 1,
      sym_curried_spec,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(8152), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4893), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6604), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [45950] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7951), 1,
      anon_sym_DOT,
    ACTIONS(8154), 1,
      anon_sym_EQ,
    STATE(4856), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4894), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3781), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3778), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [46020] = 29,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(8083), 1,
      sym_identifier,
    ACTIONS(8085), 1,
      anon_sym_LPAREN,
    ACTIONS(8087), 1,
      anon_sym__,
    ACTIONS(8089), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8091), 1,
      anon_sym_POUND,
    STATE(2987), 1,
      sym__type,
    STATE(3174), 1,
      sym__static_type_identifier,
    STATE(3579), 1,
      sym_type_argument,
    STATE(3606), 1,
      sym_long_identifier,
    STATE(3744), 1,
      sym_curried_spec,
    STATE(4963), 1,
      aux_sym_curried_spec_repeat1,
    STATE(5484), 1,
      sym_attributes,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(8093), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4895), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3611), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [46122] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7951), 1,
      anon_sym_DOT,
    ACTIONS(8156), 1,
      anon_sym_EQ,
    STATE(4856), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4896), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3781), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3778), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [46192] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4823), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(4897), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8158), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8160), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [46258] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7951), 1,
      anon_sym_DOT,
    ACTIONS(8162), 1,
      anon_sym_EQ,
    STATE(4856), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4898), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3781), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3778), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [46328] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5367), 1,
      anon_sym_as,
    ACTIONS(5369), 1,
      anon_sym_COMMA,
    ACTIONS(5371), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    ACTIONS(5375), 1,
      anon_sym_AMP,
    STATE(4826), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(4899), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8164), 11,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8166), 15,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [46404] = 29,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(8111), 1,
      sym_identifier,
    ACTIONS(8113), 1,
      anon_sym_LPAREN,
    ACTIONS(8115), 1,
      anon_sym__,
    ACTIONS(8117), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8119), 1,
      anon_sym_POUND,
    STATE(4954), 1,
      aux_sym_curried_spec_repeat1,
    STATE(5455), 1,
      sym__type,
    STATE(5463), 1,
      sym__static_type_identifier,
    STATE(5484), 1,
      sym_attributes,
    STATE(5566), 1,
      sym_type_argument,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(6046), 1,
      sym_long_identifier,
    STATE(6699), 1,
      sym_curried_spec,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(8121), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4900), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5996), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [46506] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8168), 1,
      anon_sym_COMMA,
    STATE(4901), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(8127), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8129), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [46572] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7999), 1,
      anon_sym_or,
    STATE(4828), 1,
      aux_sym_type_argument_repeat1,
    STATE(4902), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [46640] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4826), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(4903), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8158), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8160), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [46706] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4826), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(4904), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8138), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8140), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [46772] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4826), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(4905), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8134), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8136), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [46838] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4826), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(4906), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8127), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8129), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [46904] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8171), 1,
      anon_sym_DOT,
    STATE(4907), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4228), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4226), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [46970] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8173), 1,
      anon_sym_COMMA,
    STATE(4908), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(8127), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8129), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [47036] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4909), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3480), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [47100] = 29,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(8142), 1,
      sym_identifier,
    ACTIONS(8144), 1,
      anon_sym_LPAREN,
    ACTIONS(8146), 1,
      anon_sym__,
    ACTIONS(8148), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8150), 1,
      anon_sym_POUND,
    STATE(5007), 1,
      aux_sym_curried_spec_repeat1,
    STATE(5484), 1,
      sym_attributes,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(6211), 1,
      sym__type,
    STATE(6273), 1,
      sym__static_type_identifier,
    STATE(6417), 1,
      sym_type_argument,
    STATE(6603), 1,
      sym_long_identifier,
    STATE(7379), 1,
      sym_curried_spec,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(8152), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4910), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6604), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [47202] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7951), 1,
      anon_sym_DOT,
    ACTIONS(8176), 1,
      anon_sym_EQ,
    STATE(4856), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4911), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3781), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3778), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [47272] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5460), 1,
      anon_sym_as,
    ACTIONS(5462), 1,
      anon_sym_COMMA,
    ACTIONS(5464), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5466), 1,
      anon_sym_PIPE,
    ACTIONS(5468), 1,
      anon_sym_AMP,
    STATE(4823), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(4912), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8164), 11,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8166), 15,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [47348] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8081), 1,
      anon_sym_and,
    STATE(4867), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(4913), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7893), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7895), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [47416] = 29,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(8178), 1,
      sym_identifier,
    ACTIONS(8180), 1,
      anon_sym_LPAREN,
    ACTIONS(8182), 1,
      anon_sym__,
    ACTIONS(8184), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8186), 1,
      anon_sym_POUND,
    STATE(4960), 1,
      aux_sym_curried_spec_repeat1,
    STATE(5363), 1,
      sym__static_type_identifier,
    STATE(5398), 1,
      sym__type,
    STATE(5484), 1,
      sym_attributes,
    STATE(5552), 1,
      sym_type_argument,
    STATE(5597), 1,
      sym_long_identifier,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(6495), 1,
      sym_curried_spec,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(8188), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4914), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5568), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [47518] = 29,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(8178), 1,
      sym_identifier,
    ACTIONS(8180), 1,
      anon_sym_LPAREN,
    ACTIONS(8182), 1,
      anon_sym__,
    ACTIONS(8184), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8186), 1,
      anon_sym_POUND,
    STATE(4960), 1,
      aux_sym_curried_spec_repeat1,
    STATE(5363), 1,
      sym__static_type_identifier,
    STATE(5398), 1,
      sym__type,
    STATE(5484), 1,
      sym_attributes,
    STATE(5552), 1,
      sym_type_argument,
    STATE(5597), 1,
      sym_long_identifier,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(6512), 1,
      sym_curried_spec,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(8188), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4915), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5568), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [47620] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7168), 1,
      aux_sym_decimal_token1,
    ACTIONS(7210), 1,
      anon_sym_f,
    STATE(4916), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3193), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3191), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [47688] = 29,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(8099), 1,
      sym_identifier,
    ACTIONS(8101), 1,
      anon_sym_LPAREN,
    ACTIONS(8103), 1,
      anon_sym__,
    ACTIONS(8105), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8107), 1,
      anon_sym_POUND,
    STATE(4938), 1,
      aux_sym_curried_spec_repeat1,
    STATE(5464), 1,
      sym__static_type_identifier,
    STATE(5474), 1,
      sym__type,
    STATE(5484), 1,
      sym_attributes,
    STATE(5618), 1,
      sym_type_argument,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(6164), 1,
      sym_long_identifier,
    STATE(6556), 1,
      sym_curried_spec,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(8109), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4917), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6161), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [47790] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8190), 1,
      anon_sym_DOT,
    STATE(4918), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4228), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4226), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [47856] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7951), 1,
      anon_sym_DOT,
    ACTIONS(8192), 1,
      anon_sym_EQ,
    STATE(4856), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4919), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3781), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3778), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [47926] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8049), 1,
      anon_sym_and,
    STATE(4850), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(4920), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7893), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7895), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [47994] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7967), 1,
      anon_sym_and,
    STATE(4810), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(4921), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7904), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7906), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [48062] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4922), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3487), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 20,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [48126] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8194), 1,
      anon_sym_and,
    STATE(4923), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(7908), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7910), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [48192] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4823), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(4924), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7963), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7965), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [48258] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5000), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(4925), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7963), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7965), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [48323] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4926), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8197), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8199), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [48386] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4927), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4228), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4226), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [48449] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4928), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8201), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8203), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [48512] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4929), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8205), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8207), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [48575] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4930), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8209), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8211), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [48638] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4931), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7945), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7947), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [48701] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4932), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4100), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4098), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [48764] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4933), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8043), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8045), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [48827] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4934), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4064), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4062), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [48890] = 35,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8213), 1,
      anon_sym_EQ,
    ACTIONS(8215), 1,
      anon_sym_do,
    ACTIONS(8217), 1,
      anon_sym_let,
    ACTIONS(8219), 1,
      anon_sym_let_BANG,
    ACTIONS(8221), 1,
      anon_sym_LPAREN,
    ACTIONS(8223), 1,
      anon_sym_new,
    ACTIONS(8225), 1,
      anon_sym_with,
    ACTIONS(8229), 1,
      anon_sym_static,
    ACTIONS(8231), 1,
      anon_sym_member,
    ACTIONS(8233), 1,
      anon_sym_interface,
    ACTIONS(8235), 1,
      anon_sym_abstract,
    ACTIONS(8237), 1,
      anon_sym_val,
    ACTIONS(8239), 1,
      anon_sym_POUNDif,
    STATE(2668), 1,
      aux_sym__type_extension_inner,
    STATE(3854), 1,
      sym_function_or_value_defn,
    STATE(3864), 1,
      sym_additional_constr_defn,
    STATE(4111), 1,
      sym_type_extension_elements,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7038), 1,
      sym_attributes,
    STATE(9573), 1,
      sym_access_modifier,
    STATE(11478), 1,
      sym_primary_constr_args,
    ACTIONS(8227), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(3863), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(3860), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4935), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [49003] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4936), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4064), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4062), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [49066] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4937), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8057), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8059), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [49129] = 28,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(8099), 1,
      sym_identifier,
    ACTIONS(8101), 1,
      anon_sym_LPAREN,
    ACTIONS(8103), 1,
      anon_sym__,
    ACTIONS(8105), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8107), 1,
      anon_sym_POUND,
    STATE(5108), 1,
      aux_sym_curried_spec_repeat1,
    STATE(5464), 1,
      sym__static_type_identifier,
    STATE(5477), 1,
      sym__type,
    STATE(5484), 1,
      sym_attributes,
    STATE(5618), 1,
      sym_type_argument,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(6164), 1,
      sym_long_identifier,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(8109), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4938), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6161), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [49228] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5107), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(4967), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6385), 1,
      sym_additional_constr_defn,
    STATE(6407), 1,
      sym_function_or_value_defn,
    STATE(7109), 1,
      sym_attributes,
    STATE(11882), 1,
      sym_access_modifier,
    STATE(6384), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6410), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4939), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5105), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [49309] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4940), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8051), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8053), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [49372] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4941), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8241), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8243), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [49435] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4942), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8245), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8247), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [49498] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4943), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4212), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4210), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [49561] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4944), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4224), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4222), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [49624] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8249), 1,
      sym_int,
    STATE(4945), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3753), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3751), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [49689] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4946), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8251), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8253), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [49752] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8255), 1,
      anon_sym_and,
    STATE(4947), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(7908), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7910), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [49817] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4948), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7283), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7285), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [49880] = 35,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8221), 1,
      anon_sym_LPAREN,
    ACTIONS(8258), 1,
      anon_sym_EQ,
    ACTIONS(8260), 1,
      anon_sym_do,
    ACTIONS(8262), 1,
      anon_sym_let,
    ACTIONS(8264), 1,
      anon_sym_let_BANG,
    ACTIONS(8266), 1,
      anon_sym_new,
    ACTIONS(8268), 1,
      anon_sym_with,
    ACTIONS(8272), 1,
      anon_sym_static,
    ACTIONS(8274), 1,
      anon_sym_member,
    ACTIONS(8276), 1,
      anon_sym_interface,
    ACTIONS(8278), 1,
      anon_sym_abstract,
    ACTIONS(8280), 1,
      anon_sym_val,
    ACTIONS(8282), 1,
      anon_sym_POUNDif,
    STATE(5327), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6801), 1,
      sym_additional_constr_defn,
    STATE(6824), 1,
      sym_function_or_value_defn,
    STATE(7028), 1,
      sym_attributes,
    STATE(9050), 1,
      sym_type_extension_elements,
    STATE(9731), 1,
      sym_access_modifier,
    STATE(11891), 1,
      sym_primary_constr_args,
    ACTIONS(8270), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6908), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6757), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4949), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [49993] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4950), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8284), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8286), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [50056] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7196), 1,
      aux_sym_decimal_token1,
    ACTIONS(7218), 1,
      anon_sym_f,
    STATE(4951), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3193), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3191), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [50123] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4952), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8288), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8290), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [50186] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8292), 1,
      anon_sym_DOT,
    STATE(4953), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4228), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4226), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [50251] = 28,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(8111), 1,
      sym_identifier,
    ACTIONS(8113), 1,
      anon_sym_LPAREN,
    ACTIONS(8115), 1,
      anon_sym__,
    ACTIONS(8117), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8119), 1,
      anon_sym_POUND,
    STATE(5108), 1,
      aux_sym_curried_spec_repeat1,
    STATE(5463), 1,
      sym__static_type_identifier,
    STATE(5466), 1,
      sym__type,
    STATE(5484), 1,
      sym_attributes,
    STATE(5566), 1,
      sym_type_argument,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(6046), 1,
      sym_long_identifier,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(8121), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4954), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5996), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [50350] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4955), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4224), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4222), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [50413] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5000), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(4956), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7995), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7997), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [50478] = 28,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6866), 1,
      anon_sym_LPAREN,
    ACTIONS(6868), 1,
      anon_sym__,
    ACTIONS(6874), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6880), 1,
      anon_sym_POUND,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(8047), 1,
      sym_identifier,
    STATE(5108), 1,
      aux_sym_curried_spec_repeat1,
    STATE(5484), 1,
      sym_attributes,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(6214), 1,
      sym__static_type_identifier,
    STATE(6255), 1,
      sym__type,
    STATE(6488), 1,
      sym_type_argument,
    STATE(6600), 1,
      sym_long_identifier,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(6882), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4957), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6550), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [50577] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4958), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8288), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8290), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [50640] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4959), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3950), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3948), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [50703] = 28,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(8178), 1,
      sym_identifier,
    ACTIONS(8180), 1,
      anon_sym_LPAREN,
    ACTIONS(8182), 1,
      anon_sym__,
    ACTIONS(8184), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8186), 1,
      anon_sym_POUND,
    STATE(5108), 1,
      aux_sym_curried_spec_repeat1,
    STATE(5363), 1,
      sym__static_type_identifier,
    STATE(5388), 1,
      sym__type,
    STATE(5484), 1,
      sym_attributes,
    STATE(5552), 1,
      sym_type_argument,
    STATE(5597), 1,
      sym_long_identifier,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(8188), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4960), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5568), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [50802] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4961), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8284), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8286), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [50865] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4962), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3976), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3974), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [50928] = 28,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(8083), 1,
      sym_identifier,
    ACTIONS(8085), 1,
      anon_sym_LPAREN,
    ACTIONS(8087), 1,
      anon_sym__,
    ACTIONS(8089), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8091), 1,
      anon_sym_POUND,
    STATE(2999), 1,
      sym__type,
    STATE(3174), 1,
      sym__static_type_identifier,
    STATE(3579), 1,
      sym_type_argument,
    STATE(3606), 1,
      sym_long_identifier,
    STATE(5108), 1,
      aux_sym_curried_spec_repeat1,
    STATE(5484), 1,
      sym_attributes,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(8093), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4963), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3611), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [51027] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8294), 1,
      anon_sym_and,
    STATE(4947), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(4964), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7904), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7906), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [51094] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4965), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4212), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4210), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [51157] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4966), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4208), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4206), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [51220] = 30,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5051), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5063), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8296), 1,
      anon_sym_do,
    ACTIONS(8299), 1,
      anon_sym_let,
    ACTIONS(8302), 1,
      anon_sym_let_BANG,
    ACTIONS(8305), 1,
      anon_sym_new,
    ACTIONS(8311), 1,
      anon_sym_static,
    ACTIONS(8314), 1,
      anon_sym_member,
    ACTIONS(8317), 1,
      anon_sym_interface,
    ACTIONS(8320), 1,
      anon_sym_abstract,
    ACTIONS(8323), 1,
      anon_sym_val,
    ACTIONS(8326), 1,
      anon_sym_POUNDif,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6385), 1,
      sym_additional_constr_defn,
    STATE(6407), 1,
      sym_function_or_value_defn,
    STATE(7109), 1,
      sym_attributes,
    STATE(11882), 1,
      sym_access_modifier,
    ACTIONS(8308), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6384), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6410), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    ACTIONS(5047), 5,
      sym__newline,
      anon_sym_with,
      anon_sym_inherit,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(4967), 5,
      aux_sym__type_extension_inner,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [51323] = 34,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7478), 1,
      anon_sym_do,
    ACTIONS(7480), 1,
      anon_sym_let,
    ACTIONS(7482), 1,
      anon_sym_let_BANG,
    ACTIONS(7484), 1,
      anon_sym_new,
    ACTIONS(7486), 1,
      anon_sym_with,
    ACTIONS(7490), 1,
      anon_sym_static,
    ACTIONS(7492), 1,
      anon_sym_member,
    ACTIONS(7494), 1,
      anon_sym_interface,
    ACTIONS(7496), 1,
      anon_sym_abstract,
    ACTIONS(7498), 1,
      anon_sym_val,
    ACTIONS(7500), 1,
      anon_sym_inherit,
    ACTIONS(7502), 1,
      anon_sym_POUNDif,
    STATE(4939), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6317), 1,
      sym__class_type_body_inner,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6385), 1,
      sym_additional_constr_defn,
    STATE(6407), 1,
      sym_function_or_value_defn,
    STATE(7109), 1,
      sym_attributes,
    STATE(11882), 1,
      sym_access_modifier,
    ACTIONS(7488), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6384), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6409), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6410), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4968), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [51434] = 35,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8221), 1,
      anon_sym_LPAREN,
    ACTIONS(8329), 1,
      anon_sym_EQ,
    ACTIONS(8331), 1,
      anon_sym_do,
    ACTIONS(8333), 1,
      anon_sym_let,
    ACTIONS(8335), 1,
      anon_sym_let_BANG,
    ACTIONS(8337), 1,
      anon_sym_new,
    ACTIONS(8339), 1,
      anon_sym_with,
    ACTIONS(8343), 1,
      anon_sym_static,
    ACTIONS(8345), 1,
      anon_sym_member,
    ACTIONS(8347), 1,
      anon_sym_interface,
    ACTIONS(8349), 1,
      anon_sym_abstract,
    ACTIONS(8351), 1,
      anon_sym_val,
    ACTIONS(8353), 1,
      anon_sym_POUNDif,
    STATE(5251), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6641), 1,
      sym_additional_constr_defn,
    STATE(6714), 1,
      sym_function_or_value_defn,
    STATE(7026), 1,
      sym_attributes,
    STATE(8899), 1,
      sym_type_extension_elements,
    STATE(9678), 1,
      sym_access_modifier,
    STATE(11871), 1,
      sym_primary_constr_args,
    ACTIONS(8341), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6638), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6713), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(4969), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [51547] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4970), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4130), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4128), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [51610] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4971), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3885), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3883), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [51673] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4972), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3976), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3974), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [51736] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4973), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8355), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8357), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [51799] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4974), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8359), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8361), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [51862] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4975), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4186), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4184), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [51925] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4976), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8201), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8203), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [51988] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4977), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3935), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3933), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52051] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4978), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8205), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8207), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52114] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4979), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7279), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7281), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52177] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4980), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4130), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4128), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52240] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4981), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7908), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7910), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52303] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4982), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8209), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8211), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52366] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4983), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3885), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3883), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52429] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4984), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3935), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3933), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52492] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4985), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3954), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3952), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52555] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8363), 1,
      anon_sym_or,
    STATE(5075), 1,
      aux_sym_type_argument_repeat1,
    STATE(4986), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52622] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4987), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3950), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3948), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52685] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4988), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8197), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8199), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52748] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4989), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8359), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8361), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52811] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4990), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7989), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7991), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52874] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4991), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52937] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8365), 1,
      anon_sym_LT2,
    STATE(4992), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7989), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7991), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53002] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4993), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3604), 15,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3602), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53065] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4994), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3958), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3956), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53128] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8367), 1,
      anon_sym_LT2,
    STATE(4995), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7989), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7991), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53193] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4996), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3962), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3960), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53256] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4997), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4232), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4230), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53319] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4998), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8241), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8243), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53382] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4999), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4126), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4124), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53445] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5613), 1,
      anon_sym_COMMA,
    STATE(5072), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5000), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7985), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7987), 17,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53512] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5001), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3954), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3952), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53575] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5002), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8369), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8371), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53638] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5003), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8373), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8375), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53701] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8381), 1,
      anon_sym_as,
    STATE(5004), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8377), 11,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8379), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53766] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5005), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8383), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8385), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53829] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5006), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7989), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7991), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53892] = 28,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(8142), 1,
      sym_identifier,
    ACTIONS(8144), 1,
      anon_sym_LPAREN,
    ACTIONS(8146), 1,
      anon_sym__,
    ACTIONS(8148), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8150), 1,
      anon_sym_POUND,
    STATE(5108), 1,
      aux_sym_curried_spec_repeat1,
    STATE(5484), 1,
      sym_attributes,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(6217), 1,
      sym__type,
    STATE(6273), 1,
      sym__static_type_identifier,
    STATE(6417), 1,
      sym_type_argument,
    STATE(6603), 1,
      sym_long_identifier,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(8152), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5007), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6604), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [53991] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5008), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4122), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4120), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [54054] = 28,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7969), 1,
      sym_identifier,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7973), 1,
      anon_sym_LPAREN,
    ACTIONS(7975), 1,
      anon_sym__,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(7979), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_POUND,
    STATE(5108), 1,
      aux_sym_curried_spec_repeat1,
    STATE(5341), 1,
      sym__static_type_identifier,
    STATE(5357), 1,
      sym__type,
    STATE(5434), 1,
      sym_type_argument,
    STATE(5484), 1,
      sym_attributes,
    STATE(5528), 1,
      sym_long_identifier,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(7983), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5009), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5525), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [54153] = 28,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(8027), 1,
      sym_identifier,
    ACTIONS(8029), 1,
      anon_sym_LPAREN,
    ACTIONS(8031), 1,
      anon_sym__,
    ACTIONS(8033), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8035), 1,
      anon_sym_POUND,
    STATE(5108), 1,
      aux_sym_curried_spec_repeat1,
    STATE(5475), 1,
      sym__static_type_identifier,
    STATE(5484), 1,
      sym_attributes,
    STATE(5548), 1,
      sym__type,
    STATE(5630), 1,
      sym_type_argument,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(6183), 1,
      sym_long_identifier,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(8037), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5010), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6184), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [54252] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5011), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4118), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4116), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [54315] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5012), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4208), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4206), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [54378] = 34,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6862), 1,
      anon_sym_let,
    ACTIONS(6864), 1,
      anon_sym_let_BANG,
    ACTIONS(6900), 1,
      anon_sym_POUNDif,
    ACTIONS(7852), 1,
      anon_sym_do,
    ACTIONS(7854), 1,
      anon_sym_new,
    ACTIONS(7856), 1,
      anon_sym_with,
    ACTIONS(7860), 1,
      anon_sym_static,
    ACTIONS(7862), 1,
      anon_sym_member,
    ACTIONS(7864), 1,
      anon_sym_interface,
    ACTIONS(7866), 1,
      anon_sym_abstract,
    ACTIONS(7868), 1,
      anon_sym_val,
    ACTIONS(7870), 1,
      anon_sym_inherit,
    STATE(5324), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6835), 1,
      sym_function_or_value_defn,
    STATE(6864), 1,
      sym_additional_constr_defn,
    STATE(7100), 1,
      sym_attributes,
    STATE(9677), 1,
      sym__class_type_body_inner,
    STATE(11317), 1,
      sym_access_modifier,
    ACTIONS(7858), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6862), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(9527), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6840), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5013), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [54489] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5014), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4112), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4110), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [54552] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5015), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3487), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [54615] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5016), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4108), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4106), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [54678] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5017), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8251), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8253), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [54741] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5018), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3889), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3887), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [54804] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5019), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3511), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3509), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [54867] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5020), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3958), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3956), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [54930] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5021), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4093), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4091), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [54993] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5022), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4228), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4226), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55056] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5023), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4086), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4084), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55119] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5024), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3962), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3960), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55182] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5025), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4082), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4080), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55245] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5026), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4232), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4230), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55308] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5027), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4054), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4052), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55371] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5028), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4018), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4016), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55434] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5029), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4126), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4124), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55497] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5030), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3845), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3843), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55560] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5653), 1,
      anon_sym_as,
    ACTIONS(5655), 1,
      anon_sym_COMMA,
    ACTIONS(5661), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5663), 1,
      anon_sym_PIPE,
    ACTIONS(5665), 1,
      anon_sym_AMP,
    STATE(5058), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5031), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8164), 12,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8166), 13,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55635] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8387), 1,
      anon_sym_COMMA,
    STATE(5032), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(8127), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8129), 16,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55700] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5033), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4003), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4001), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55763] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5034), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3996), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3994), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55826] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5058), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5035), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8158), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8160), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55891] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5036), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3972), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3970), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55954] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5037), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3480), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [56017] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5038), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [56080] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5039), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3728), 15,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3726), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [56143] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5040), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3511), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3509), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [56206] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5041), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3480), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [56269] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8390), 1,
      anon_sym_DOT,
    STATE(5042), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4228), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4226), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [56334] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8294), 1,
      anon_sym_and,
    STATE(4964), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(5043), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7893), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7895), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [56401] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5044), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3946), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3944), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [56464] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5058), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5045), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7963), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7965), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [56529] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8392), 1,
      anon_sym_LT2,
    STATE(5046), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7989), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7991), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [56594] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5058), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5047), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8138), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8140), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [56659] = 28,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(8011), 1,
      sym_identifier,
    ACTIONS(8013), 1,
      anon_sym_LPAREN,
    ACTIONS(8015), 1,
      anon_sym__,
    ACTIONS(8017), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8019), 1,
      anon_sym_POUND,
    STATE(5108), 1,
      aux_sym_curried_spec_repeat1,
    STATE(5394), 1,
      sym__type,
    STATE(5402), 1,
      sym__static_type_identifier,
    STATE(5484), 1,
      sym_attributes,
    STATE(5488), 1,
      sym_type_argument,
    STATE(5627), 1,
      sym_long_identifier,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(8021), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5048), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5557), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [56758] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8394), 1,
      anon_sym_or,
    STATE(5049), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3480), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [56823] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5058), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5050), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8134), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8136), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [56888] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5058), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5051), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8127), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8129), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [56953] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5052), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3889), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3887), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [57016] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5053), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4186), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4184), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [57079] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5054), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3927), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3925), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [57142] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7951), 1,
      anon_sym_DOT,
    STATE(4856), 1,
      aux_sym_long_identifier_repeat1,
    STATE(5055), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3781), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3778), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [57209] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5058), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5056), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7995), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7997), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [57274] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5057), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4122), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4120), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [57337] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5655), 1,
      anon_sym_COMMA,
    STATE(5032), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5058), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7985), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7987), 16,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [57404] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5059), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4100), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4098), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [57467] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5060), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4170), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4168), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [57530] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5061), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3193), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3191), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [57593] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5062), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4104), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4102), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [57656] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5063), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7945), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7947), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [57719] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5000), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5064), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8127), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8129), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [57784] = 34,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7740), 1,
      anon_sym_do,
    ACTIONS(7742), 1,
      anon_sym_let,
    ACTIONS(7744), 1,
      anon_sym_let_BANG,
    ACTIONS(7746), 1,
      anon_sym_new,
    ACTIONS(7748), 1,
      anon_sym_with,
    ACTIONS(7752), 1,
      anon_sym_static,
    ACTIONS(7754), 1,
      anon_sym_member,
    ACTIONS(7756), 1,
      anon_sym_interface,
    ACTIONS(7758), 1,
      anon_sym_abstract,
    ACTIONS(7760), 1,
      anon_sym_val,
    ACTIONS(7762), 1,
      anon_sym_inherit,
    ACTIONS(7764), 1,
      anon_sym_POUNDif,
    STATE(5159), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6446), 1,
      sym_additional_constr_defn,
    STATE(6497), 1,
      sym__class_type_body_inner,
    STATE(6529), 1,
      sym_function_or_value_defn,
    STATE(7172), 1,
      sym_attributes,
    STATE(11912), 1,
      sym_access_modifier,
    ACTIONS(7750), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6477), 2,
      sym_type_extension_elements,
      sym_class_inherits_decl,
    STATE(6530), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6438), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5065), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [57895] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5066), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8355), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8357), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [57958] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5000), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5067), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8134), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8136), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [58023] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5000), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5068), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8138), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8140), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [58088] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5000), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5069), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8158), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8160), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [58153] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5070), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4118), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4116), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [58216] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5071), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4112), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4110), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [58279] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8397), 1,
      anon_sym_COMMA,
    STATE(5072), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(8127), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8129), 17,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [58344] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5611), 1,
      anon_sym_as,
    ACTIONS(5613), 1,
      anon_sym_COMMA,
    ACTIONS(5615), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5617), 1,
      anon_sym_PIPE,
    ACTIONS(5619), 1,
      anon_sym_AMP,
    STATE(5000), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5073), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8164), 11,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8166), 14,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [58419] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5074), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4108), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4106), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [58482] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8363), 1,
      anon_sym_or,
    STATE(5049), 1,
      aux_sym_type_argument_repeat1,
    STATE(5075), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3476), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3474), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [58549] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5076), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8400), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8402), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [58612] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5077), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4093), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4091), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [58675] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5078), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8043), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8045), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [58738] = 28,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(8063), 1,
      sym_identifier,
    ACTIONS(8065), 1,
      anon_sym_LPAREN,
    ACTIONS(8067), 1,
      anon_sym__,
    ACTIONS(8069), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8071), 1,
      anon_sym_POUND,
    STATE(5108), 1,
      aux_sym_curried_spec_repeat1,
    STATE(5393), 1,
      sym__type,
    STATE(5407), 1,
      sym__static_type_identifier,
    STATE(5484), 1,
      sym_attributes,
    STATE(5510), 1,
      sym_type_argument,
    STATE(5638), 1,
      sym_long_identifier,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(8073), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5079), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5590), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [58837] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8404), 1,
      anon_sym_as,
    STATE(5080), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8377), 11,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8379), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [58902] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5081), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4078), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4076), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [58965] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5082), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4086), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4084), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [59028] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5083), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8400), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8402), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [59091] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5084), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4082), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4080), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [59154] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5085), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8051), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8053), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [59217] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5086), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4054), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4052), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [59280] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5087), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4018), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4016), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [59343] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5088), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3845), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3843), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [59406] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5089), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4003), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4001), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [59469] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5090), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3996), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3994), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [59532] = 35,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8221), 1,
      anon_sym_LPAREN,
    ACTIONS(8406), 1,
      anon_sym_EQ,
    ACTIONS(8408), 1,
      anon_sym_do,
    ACTIONS(8410), 1,
      anon_sym_let,
    ACTIONS(8412), 1,
      anon_sym_let_BANG,
    ACTIONS(8414), 1,
      anon_sym_new,
    ACTIONS(8416), 1,
      anon_sym_with,
    ACTIONS(8420), 1,
      anon_sym_static,
    ACTIONS(8422), 1,
      anon_sym_member,
    ACTIONS(8424), 1,
      anon_sym_interface,
    ACTIONS(8426), 1,
      anon_sym_abstract,
    ACTIONS(8428), 1,
      anon_sym_val,
    ACTIONS(8430), 1,
      anon_sym_POUNDif,
    STATE(5265), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6697), 1,
      sym_additional_constr_defn,
    STATE(6732), 1,
      sym_function_or_value_defn,
    STATE(7033), 1,
      sym_attributes,
    STATE(8924), 1,
      sym_type_extension_elements,
    STATE(9613), 1,
      sym_access_modifier,
    STATE(11843), 1,
      sym_primary_constr_args,
    ACTIONS(8418), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6701), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6731), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5091), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [59645] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5092), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8057), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8059), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [59708] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5093), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8432), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8434), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [59771] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5094), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3972), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3970), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [59834] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5095), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4078), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4076), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [59897] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5096), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3946), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3944), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [59960] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5097), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3927), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3925), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [60023] = 35,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8213), 1,
      anon_sym_EQ,
    ACTIONS(8215), 1,
      anon_sym_do,
    ACTIONS(8217), 1,
      anon_sym_let,
    ACTIONS(8219), 1,
      anon_sym_let_BANG,
    ACTIONS(8221), 1,
      anon_sym_LPAREN,
    ACTIONS(8223), 1,
      anon_sym_new,
    ACTIONS(8225), 1,
      anon_sym_with,
    ACTIONS(8229), 1,
      anon_sym_static,
    ACTIONS(8233), 1,
      anon_sym_interface,
    ACTIONS(8235), 1,
      anon_sym_abstract,
    ACTIONS(8237), 1,
      anon_sym_val,
    ACTIONS(8239), 1,
      anon_sym_POUNDif,
    ACTIONS(8436), 1,
      anon_sym_member,
    STATE(2598), 1,
      aux_sym__type_extension_inner,
    STATE(3854), 1,
      sym_function_or_value_defn,
    STATE(3864), 1,
      sym_additional_constr_defn,
    STATE(4111), 1,
      sym_type_extension_elements,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7063), 1,
      sym_attributes,
    STATE(9573), 1,
      sym_access_modifier,
    STATE(11478), 1,
      sym_primary_constr_args,
    ACTIONS(8227), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(3863), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(3860), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5098), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [60136] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5099), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7283), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7285), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [60199] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5100), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8383), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8385), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [60262] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5101), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4170), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4168), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [60325] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5102), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8373), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8375), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [60388] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5103), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4104), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4102), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [60451] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5104), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8369), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8371), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [60514] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5105), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7908), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7910), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [60577] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5106), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7279), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7281), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [60640] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5107), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8432), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8434), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [60703] = 27,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8438), 1,
      sym_identifier,
    ACTIONS(8441), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(8444), 1,
      anon_sym_LPAREN,
    ACTIONS(8447), 1,
      anon_sym__,
    ACTIONS(8450), 1,
      anon_sym_QMARK,
    ACTIONS(8453), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8456), 1,
      anon_sym_POUND,
    STATE(5484), 1,
      sym_attributes,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(8347), 1,
      sym__type,
    STATE(9031), 1,
      sym_argument_spec,
    STATE(10301), 1,
      sym_arguments_spec,
    ACTIONS(8459), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5108), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_curried_spec_repeat1,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [60800] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5109), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3193), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3191), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [60863] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5110), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8245), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8247), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [60926] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5111), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7989), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7991), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [60988] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5112), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8369), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8371), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [61050] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5113), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3935), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3933), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [61112] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5114), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3885), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3883), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [61174] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5115), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8241), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8243), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [61236] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5116), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8245), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8247), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [61298] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5117), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4100), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4098), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [61360] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5118), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4078), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4076), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [61422] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5119), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8400), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8402), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [61484] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5120), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4130), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4128), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [61546] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5121), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3950), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3948), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [61608] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5122), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3954), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3952), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [61670] = 30,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5051), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5063), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8462), 1,
      anon_sym_do,
    ACTIONS(8465), 1,
      anon_sym_let,
    ACTIONS(8468), 1,
      anon_sym_let_BANG,
    ACTIONS(8471), 1,
      anon_sym_new,
    ACTIONS(8477), 1,
      anon_sym_static,
    ACTIONS(8480), 1,
      anon_sym_member,
    ACTIONS(8483), 1,
      anon_sym_interface,
    ACTIONS(8486), 1,
      anon_sym_abstract,
    ACTIONS(8489), 1,
      anon_sym_val,
    ACTIONS(8492), 1,
      anon_sym_POUNDif,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6446), 1,
      sym_additional_constr_defn,
    STATE(6529), 1,
      sym_function_or_value_defn,
    STATE(7172), 1,
      sym_attributes,
    STATE(11912), 1,
      sym_access_modifier,
    ACTIONS(8474), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6530), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6438), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    ACTIONS(5047), 4,
      sym__newline,
      anon_sym_with,
      anon_sym_inherit,
      anon_sym_POUNDendif,
    STATE(5123), 5,
      aux_sym__type_extension_inner,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [61772] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5124), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3511), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3509), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [61834] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5188), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5125), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7963), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7965), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [61898] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5126), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8383), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8385), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [61960] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5127), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8251), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8253), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62022] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5128), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8373), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8375), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62084] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5129), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4064), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4062), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62146] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5130), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8432), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8434), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62208] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5131), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4170), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4168), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62270] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5132), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4104), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4102), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62332] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5133), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3193), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3191), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62394] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5134), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8355), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8357), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62456] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5135), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3927), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3925), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62518] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5136), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3946), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3944), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62580] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5137), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8209), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8211), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62642] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5138), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8205), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8207), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62704] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5139), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4082), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4080), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62766] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5140), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7279), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7281), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62828] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5141), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3972), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3970), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62890] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5142), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8355), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8357), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62952] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5143), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8245), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8247), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63014] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5144), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3996), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3994), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63076] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5145), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8241), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8243), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63138] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5146), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3480), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3478), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63200] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5147), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4003), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4001), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63262] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5148), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3845), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3843), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63324] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5149), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7908), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7910), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63386] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5150), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4018), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4016), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63448] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5151), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4224), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4222), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63510] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5152), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7989), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7991), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63572] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8495), 1,
      anon_sym_as,
    STATE(5153), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8377), 12,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8379), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63636] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5154), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4054), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4052), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63698] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5155), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4082), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4080), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63760] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5156), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4086), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4084), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63822] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5157), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63884] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5158), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4093), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4091), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63946] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5107), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5123), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6446), 1,
      sym_additional_constr_defn,
    STATE(6529), 1,
      sym_function_or_value_defn,
    STATE(7172), 1,
      sym_attributes,
    STATE(11912), 1,
      sym_access_modifier,
    STATE(6530), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6438), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5159), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5105), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [64026] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5160), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4108), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4106), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [64088] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8497), 1,
      anon_sym_LT2,
    STATE(5161), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7989), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7991), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [64152] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5162), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4228), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4226), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [64214] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5163), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4112), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4110), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [64276] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5164), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4212), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4210), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [64338] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5165), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4118), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4116), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [64400] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5166), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4122), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4120), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [64462] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5167), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4228), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4226), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [64524] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5168), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4208), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4206), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [64586] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5188), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5169), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7995), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7997), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [64650] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5170), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4126), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4124), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [64712] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5171), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4232), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4230), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [64774] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5172), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3962), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3960), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [64836] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5173), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3958), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3956), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [64898] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5174), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3958), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3956), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [64960] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5175), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4100), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4098), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [65022] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5176), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8359), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8361), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [65084] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5177), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8197), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8199), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [65146] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5178), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3954), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3952), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [65208] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5179), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3950), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3948), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [65270] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5180), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3935), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3933), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [65332] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5181), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3885), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3883), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [65394] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5182), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4130), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4128), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [65456] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5183), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8197), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8199), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [65518] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5184), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3962), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3960), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [65580] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5185), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4232), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4230), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [65642] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5186), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4126), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4124), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [65704] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5187), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8432), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8434), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [65766] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5815), 1,
      anon_sym_COMMA,
    STATE(5204), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5188), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7985), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7987), 15,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [65832] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5189), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8369), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8371), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [65894] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5190), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8373), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8375), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [65956] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5191), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3889), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3887), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [66018] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5192), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4122), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4120), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [66080] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5193), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8383), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8385), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [66142] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5194), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4170), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4168), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [66204] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5195), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8359), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8361), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [66266] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5196), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4118), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4116), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [66328] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5197), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4112), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4110), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [66390] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5198), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4108), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4106), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [66452] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5199), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4093), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4091), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [66514] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5200), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8400), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8402), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [66576] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5201), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8288), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8290), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [66638] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5202), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8284), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8286), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [66700] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5813), 1,
      anon_sym_as,
    ACTIONS(5815), 1,
      anon_sym_COMMA,
    ACTIONS(5817), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5819), 1,
      anon_sym_PIPE,
    ACTIONS(5821), 1,
      anon_sym_AMP,
    STATE(5188), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5203), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8164), 12,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8166), 12,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [66774] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8499), 1,
      anon_sym_COMMA,
    STATE(5204), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(8127), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8129), 15,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [66838] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5205), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4086), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4084), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [66900] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5206), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4186), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4184), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [66962] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5188), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5207), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8158), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8160), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [67026] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5208), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8051), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8053), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [67088] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5188), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5209), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8138), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8140), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [67152] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5210), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4054), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4052), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [67214] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5188), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5211), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8134), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8136), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [67278] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5212), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8284), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8286), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [67340] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5188), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5213), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8127), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8129), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [67404] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5214), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8288), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8290), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [67466] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5460), 1,
      anon_sym_as,
    ACTIONS(5462), 1,
      anon_sym_COMMA,
    ACTIONS(5464), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5466), 1,
      anon_sym_PIPE,
    ACTIONS(5468), 1,
      anon_sym_AMP,
    ACTIONS(8506), 1,
      anon_sym_COLON,
    STATE(4823), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5215), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8502), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8504), 13,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [67542] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5216), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3976), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3974), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [67604] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5217), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4018), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4016), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [67666] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5218), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [67728] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5219), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4224), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4222), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [67790] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5220), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8201), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8203), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [67852] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5221), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4078), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4076), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [67914] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8508), 1,
      anon_sym_as,
    STATE(5222), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8377), 11,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8379), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [67978] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5223), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4104), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4102), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [68040] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5224), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4212), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4210), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [68102] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5225), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3845), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3843), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [68164] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5226), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3193), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3191), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [68226] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5227), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4003), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4001), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [68288] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8510), 1,
      anon_sym_DOT,
    STATE(5228), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4228), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4226), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [68352] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5229), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7283), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7285), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [68414] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5230), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3889), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3887), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [68476] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5231), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3996), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3994), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [68538] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5232), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3972), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3970), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [68600] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5233), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7945), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7947), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [68662] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5234), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3976), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3974), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [68724] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5235), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8251), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8253), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [68786] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5236), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8043), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8045), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [68848] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5237), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4186), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4184), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [68910] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5238), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3946), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3944), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [68972] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5239), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3927), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3925), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [69034] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5240), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8057), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8059), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [69096] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5241), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8201), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8203), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [69158] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5242), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8205), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8207), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [69220] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5243), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8209), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8211), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [69282] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5244), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4208), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4206), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [69344] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5245), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4064), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4062), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [69406] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5246), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3946), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3944), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [69467] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5247), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4122), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4120), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [69528] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5248), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3950), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3948), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [69589] = 33,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8520), 1,
      anon_sym_with,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    ACTIONS(8536), 1,
      sym__dedent,
    STATE(5331), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    STATE(11736), 1,
      sym_type_extension_elements,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5249), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [69696] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5250), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8241), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8243), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [69757] = 30,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8331), 1,
      anon_sym_do,
    ACTIONS(8333), 1,
      anon_sym_let,
    ACTIONS(8335), 1,
      anon_sym_let_BANG,
    ACTIONS(8337), 1,
      anon_sym_new,
    ACTIONS(8343), 1,
      anon_sym_static,
    ACTIONS(8345), 1,
      anon_sym_member,
    ACTIONS(8347), 1,
      anon_sym_interface,
    ACTIONS(8349), 1,
      anon_sym_abstract,
    ACTIONS(8351), 1,
      anon_sym_val,
    ACTIONS(8353), 1,
      anon_sym_POUNDif,
    STATE(5294), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6641), 1,
      sym_additional_constr_defn,
    STATE(6714), 1,
      sym_function_or_value_defn,
    STATE(7180), 1,
      sym_attributes,
    STATE(11932), 1,
      sym_access_modifier,
    ACTIONS(8341), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6638), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6713), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    ACTIONS(5105), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
    STATE(5251), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [69858] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5252), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4228), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4226), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [69919] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5253), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8400), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8402), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [69980] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5254), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4100), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4098), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [70041] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5255), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4093), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4091), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [70102] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5256), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8245), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8247), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [70163] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5257), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3935), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3933), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [70224] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5258), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3496), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [70285] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5259), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8209), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8211), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [70346] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5260), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8355), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8357), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [70407] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5261), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4208), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4206), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [70468] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5262), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3885), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3883), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [70529] = 33,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8520), 1,
      anon_sym_with,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    ACTIONS(8538), 1,
      sym__dedent,
    STATE(5331), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    STATE(11825), 1,
      sym_type_extension_elements,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5263), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [70636] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5264), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4186), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4184), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [70697] = 30,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8408), 1,
      anon_sym_do,
    ACTIONS(8410), 1,
      anon_sym_let,
    ACTIONS(8412), 1,
      anon_sym_let_BANG,
    ACTIONS(8414), 1,
      anon_sym_new,
    ACTIONS(8420), 1,
      anon_sym_static,
    ACTIONS(8422), 1,
      anon_sym_member,
    ACTIONS(8424), 1,
      anon_sym_interface,
    ACTIONS(8426), 1,
      anon_sym_abstract,
    ACTIONS(8428), 1,
      anon_sym_val,
    ACTIONS(8430), 1,
      anon_sym_POUNDif,
    STATE(5304), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6697), 1,
      sym_additional_constr_defn,
    STATE(6732), 1,
      sym_function_or_value_defn,
    STATE(7118), 1,
      sym_attributes,
    STATE(11922), 1,
      sym_access_modifier,
    ACTIONS(8418), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6701), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6731), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    ACTIONS(5105), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(5265), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [70798] = 33,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8520), 1,
      anon_sym_with,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    ACTIONS(8540), 1,
      sym__dedent,
    STATE(5331), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    STATE(11820), 1,
      sym_type_extension_elements,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5266), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [70905] = 33,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8520), 1,
      anon_sym_with,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    ACTIONS(8542), 1,
      sym__dedent,
    STATE(5331), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    STATE(11707), 1,
      sym_type_extension_elements,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5267), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [71012] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5268), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4170), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4168), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [71073] = 33,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8520), 1,
      anon_sym_with,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    ACTIONS(8544), 1,
      sym__dedent,
    STATE(5331), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(10242), 1,
      sym_type_extension_elements,
    STATE(11240), 1,
      sym_access_modifier,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5269), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [71180] = 33,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8520), 1,
      anon_sym_with,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    ACTIONS(8546), 1,
      sym__dedent,
    STATE(5331), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    STATE(11807), 1,
      sym_type_extension_elements,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5270), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [71287] = 33,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8520), 1,
      anon_sym_with,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    ACTIONS(8548), 1,
      sym__dedent,
    STATE(5331), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    STATE(11802), 1,
      sym_type_extension_elements,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5271), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [71394] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5272), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8251), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8253), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [71455] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5273), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4212), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4210), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [71516] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5274), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8432), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8434), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [71577] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5275), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8205), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8207), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [71638] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5276), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8369), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8371), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [71699] = 33,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8520), 1,
      anon_sym_with,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    ACTIONS(8550), 1,
      sym__dedent,
    STATE(5331), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    STATE(11898), 1,
      sym_type_extension_elements,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5277), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [71806] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5278), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8373), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8375), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [71867] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5279), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4104), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4102), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [71928] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5280), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8284), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8286), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [71989] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5281), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3193), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3191), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [72050] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5282), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8288), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8290), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [72111] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5283), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8383), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8385), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [72172] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5284), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3976), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3974), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [72233] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5285), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3954), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3952), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [72294] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5286), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4130), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4128), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [72355] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5287), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8197), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8199), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [72416] = 33,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8520), 1,
      anon_sym_with,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    ACTIONS(8552), 1,
      sym__dedent,
    STATE(5331), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    STATE(11712), 1,
      sym_type_extension_elements,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5288), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [72523] = 33,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8520), 1,
      anon_sym_with,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    ACTIONS(8554), 1,
      sym__dedent,
    STATE(5331), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    STATE(11910), 1,
      sym_type_extension_elements,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5289), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [72630] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5290), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8201), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8203), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [72691] = 26,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(8556), 1,
      sym_identifier,
    STATE(5484), 1,
      sym_attributes,
    STATE(5725), 1,
      sym_argument_name_spec,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7593), 1,
      aux_sym_attributes_repeat1,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8237), 1,
      sym__attribute_set,
    STATE(8347), 1,
      sym__type,
    STATE(9644), 1,
      sym_argument_spec,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5291), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [72784] = 33,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8520), 1,
      anon_sym_with,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    ACTIONS(8558), 1,
      sym__dedent,
    STATE(5331), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(10807), 1,
      sym_type_extension_elements,
    STATE(11240), 1,
      sym_access_modifier,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5292), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [72891] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5293), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7989), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(7991), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [72952] = 30,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5051), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5063), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8560), 1,
      anon_sym_do,
    ACTIONS(8563), 1,
      anon_sym_let,
    ACTIONS(8566), 1,
      anon_sym_let_BANG,
    ACTIONS(8569), 1,
      anon_sym_new,
    ACTIONS(8575), 1,
      anon_sym_static,
    ACTIONS(8578), 1,
      anon_sym_member,
    ACTIONS(8581), 1,
      anon_sym_interface,
    ACTIONS(8584), 1,
      anon_sym_abstract,
    ACTIONS(8587), 1,
      anon_sym_val,
    ACTIONS(8590), 1,
      anon_sym_POUNDif,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6641), 1,
      sym_additional_constr_defn,
    STATE(6714), 1,
      sym_function_or_value_defn,
    STATE(7180), 1,
      sym_attributes,
    STATE(11932), 1,
      sym_access_modifier,
    ACTIONS(8572), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6638), 2,
      sym_interface_implementation,
      sym_member_defn,
    ACTIONS(5047), 3,
      sym__newline,
      sym__dedent,
      anon_sym_and,
    STATE(6713), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5294), 5,
      aux_sym__type_extension_inner,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [73053] = 33,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8520), 1,
      anon_sym_with,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    ACTIONS(8593), 1,
      sym__dedent,
    STATE(5331), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    STATE(11260), 1,
      sym_type_extension_elements,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5295), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [73160] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5296), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3889), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3887), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [73221] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5297), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3958), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3956), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [73282] = 33,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8520), 1,
      anon_sym_with,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    ACTIONS(8595), 1,
      sym__dedent,
    STATE(5331), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11213), 1,
      sym_type_extension_elements,
    STATE(11240), 1,
      sym_access_modifier,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5298), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [73389] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5299), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3962), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3960), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [73450] = 33,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8520), 1,
      anon_sym_with,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    ACTIONS(8597), 1,
      sym__dedent,
    STATE(5331), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    STATE(11952), 1,
      sym_type_extension_elements,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5300), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [73557] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5301), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4232), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4230), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [73618] = 33,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8520), 1,
      anon_sym_with,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    ACTIONS(8599), 1,
      sym__dedent,
    STATE(5331), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    STATE(11746), 1,
      sym_type_extension_elements,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5302), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [73725] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5303), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4126), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4124), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [73786] = 30,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5051), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5063), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8601), 1,
      anon_sym_do,
    ACTIONS(8604), 1,
      anon_sym_let,
    ACTIONS(8607), 1,
      anon_sym_let_BANG,
    ACTIONS(8610), 1,
      anon_sym_new,
    ACTIONS(8616), 1,
      anon_sym_static,
    ACTIONS(8619), 1,
      anon_sym_member,
    ACTIONS(8622), 1,
      anon_sym_interface,
    ACTIONS(8625), 1,
      anon_sym_abstract,
    ACTIONS(8628), 1,
      anon_sym_val,
    ACTIONS(8631), 1,
      anon_sym_POUNDif,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6697), 1,
      sym_additional_constr_defn,
    STATE(6732), 1,
      sym_function_or_value_defn,
    STATE(7118), 1,
      sym_attributes,
    STATE(11922), 1,
      sym_access_modifier,
    ACTIONS(8613), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6701), 2,
      sym_interface_implementation,
      sym_member_defn,
    ACTIONS(5047), 3,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(6731), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5304), 5,
      aux_sym__type_extension_inner,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [73887] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8634), 1,
      anon_sym_as,
    STATE(5305), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8377), 12,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8379), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [73950] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5306), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4118), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4116), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [74011] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5307), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4224), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4222), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [74072] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5308), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4112), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4110), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [74133] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5309), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4108), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4106), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [74194] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5310), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4064), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4062), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [74255] = 33,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8520), 1,
      anon_sym_with,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    ACTIONS(8636), 1,
      sym__dedent,
    STATE(5331), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    STATE(11963), 1,
      sym_type_extension_elements,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5311), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [74362] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5312), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3927), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3925), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [74423] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5313), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3972), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3970), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [74484] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5314), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3996), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3994), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [74545] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5315), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8359), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8361), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [74606] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5316), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4003), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4001), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [74667] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5317), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3845), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3843), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [74728] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5318), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4018), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4016), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [74789] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5319), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4054), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4052), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [74850] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5320), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4082), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4080), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [74911] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5321), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4086), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4084), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [74972] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5322), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4078), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4076), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [75033] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8640), 1,
      anon_sym_DASH_GT,
    ACTIONS(8642), 1,
      anon_sym_STAR,
    ACTIONS(8644), 1,
      anon_sym_LT2,
    ACTIONS(8646), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5439), 1,
      aux_sym_compound_type_repeat1,
    STATE(5497), 1,
      sym_long_identifier,
    STATE(5531), 1,
      sym_type_arguments,
    STATE(6333), 1,
      sym__object_members,
    STATE(5323), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5377), 7,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(5381), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
  [75111] = 31,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6862), 1,
      anon_sym_let,
    ACTIONS(6864), 1,
      anon_sym_let_BANG,
    ACTIONS(6900), 1,
      anon_sym_POUNDif,
    ACTIONS(7852), 1,
      anon_sym_do,
    ACTIONS(7854), 1,
      anon_sym_new,
    ACTIONS(7860), 1,
      anon_sym_static,
    ACTIONS(7862), 1,
      anon_sym_member,
    ACTIONS(7864), 1,
      anon_sym_interface,
    ACTIONS(7866), 1,
      anon_sym_abstract,
    ACTIONS(7868), 1,
      anon_sym_val,
    STATE(5325), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6835), 1,
      sym_function_or_value_defn,
    STATE(6864), 1,
      sym_additional_constr_defn,
    STATE(7100), 1,
      sym_attributes,
    STATE(11317), 1,
      sym_access_modifier,
    ACTIONS(5105), 2,
      sym__newline,
      sym__dedent,
    ACTIONS(7858), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6862), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6840), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5324), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [75213] = 30,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5051), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5063), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8648), 1,
      anon_sym_do,
    ACTIONS(8651), 1,
      anon_sym_let,
    ACTIONS(8654), 1,
      anon_sym_let_BANG,
    ACTIONS(8657), 1,
      anon_sym_new,
    ACTIONS(8663), 1,
      anon_sym_static,
    ACTIONS(8666), 1,
      anon_sym_member,
    ACTIONS(8669), 1,
      anon_sym_interface,
    ACTIONS(8672), 1,
      anon_sym_abstract,
    ACTIONS(8675), 1,
      anon_sym_val,
    ACTIONS(8678), 1,
      anon_sym_POUNDif,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6835), 1,
      sym_function_or_value_defn,
    STATE(6864), 1,
      sym_additional_constr_defn,
    STATE(7100), 1,
      sym_attributes,
    STATE(11317), 1,
      sym_access_modifier,
    ACTIONS(5047), 2,
      sym__newline,
      sym__dedent,
    ACTIONS(8660), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6862), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6840), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5325), 5,
      aux_sym__type_extension_inner,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [75313] = 30,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5051), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5063), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8681), 1,
      anon_sym_do,
    ACTIONS(8684), 1,
      anon_sym_let,
    ACTIONS(8687), 1,
      anon_sym_let_BANG,
    ACTIONS(8690), 1,
      anon_sym_new,
    ACTIONS(8696), 1,
      anon_sym_static,
    ACTIONS(8699), 1,
      anon_sym_member,
    ACTIONS(8702), 1,
      anon_sym_interface,
    ACTIONS(8705), 1,
      anon_sym_abstract,
    ACTIONS(8708), 1,
      anon_sym_val,
    ACTIONS(8711), 1,
      anon_sym_POUNDif,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6801), 1,
      sym_additional_constr_defn,
    STATE(6824), 1,
      sym_function_or_value_defn,
    STATE(7170), 1,
      sym_attributes,
    STATE(11942), 1,
      sym_access_modifier,
    ACTIONS(5047), 2,
      anon_sym_and,
      anon_sym_POUNDendif,
    ACTIONS(8693), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6908), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6757), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5326), 5,
      aux_sym__type_extension_inner,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [75413] = 30,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8260), 1,
      anon_sym_do,
    ACTIONS(8262), 1,
      anon_sym_let,
    ACTIONS(8264), 1,
      anon_sym_let_BANG,
    ACTIONS(8266), 1,
      anon_sym_new,
    ACTIONS(8272), 1,
      anon_sym_static,
    ACTIONS(8274), 1,
      anon_sym_member,
    ACTIONS(8276), 1,
      anon_sym_interface,
    ACTIONS(8278), 1,
      anon_sym_abstract,
    ACTIONS(8280), 1,
      anon_sym_val,
    ACTIONS(8282), 1,
      anon_sym_POUNDif,
    STATE(5326), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6801), 1,
      sym_additional_constr_defn,
    STATE(6824), 1,
      sym_function_or_value_defn,
    STATE(7170), 1,
      sym_attributes,
    STATE(11942), 1,
      sym_access_modifier,
    ACTIONS(8270), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6908), 2,
      sym_interface_implementation,
      sym_member_defn,
    ACTIONS(5105), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(6757), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5327), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [75513] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5601), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8714), 1,
      anon_sym_DOT,
    STATE(5411), 1,
      aux_sym_long_identifier_repeat1,
    STATE(5328), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3494), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [75578] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8716), 1,
      anon_sym_or,
    STATE(5329), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3478), 12,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3480), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [75639] = 30,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5047), 1,
      sym__dedent,
    ACTIONS(5051), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5063), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8719), 1,
      anon_sym_do,
    ACTIONS(8722), 1,
      anon_sym_let,
    ACTIONS(8725), 1,
      anon_sym_let_BANG,
    ACTIONS(8728), 1,
      anon_sym_new,
    ACTIONS(8734), 1,
      anon_sym_static,
    ACTIONS(8737), 1,
      anon_sym_member,
    ACTIONS(8740), 1,
      anon_sym_interface,
    ACTIONS(8743), 1,
      anon_sym_abstract,
    ACTIONS(8746), 1,
      anon_sym_val,
    ACTIONS(8749), 1,
      anon_sym_POUNDif,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    ACTIONS(8731), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5330), 5,
      aux_sym__type_extension_inner,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [75738] = 31,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5105), 1,
      sym__dedent,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    STATE(5330), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5331), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [75839] = 31,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    ACTIONS(8752), 1,
      sym__dedent,
    STATE(5330), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5332), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [75940] = 31,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    ACTIONS(8754), 1,
      sym__dedent,
    STATE(5330), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5333), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [76041] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3494), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8756), 1,
      anon_sym_EQ,
    ACTIONS(8760), 1,
      anon_sym_COLON,
    ACTIONS(8764), 1,
      anon_sym_DOT,
    ACTIONS(8766), 1,
      anon_sym_of,
    STATE(6355), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3492), 4,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    STATE(5334), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8758), 6,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_POUNDif,
    ACTIONS(8762), 11,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [76114] = 31,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    ACTIONS(8768), 1,
      sym__dedent,
    STATE(5330), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5335), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [76215] = 31,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    ACTIONS(8770), 1,
      sym__dedent,
    STATE(5330), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5336), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [76316] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8772), 1,
      sym_identifier,
    ACTIONS(8774), 1,
      anon_sym_with,
    ACTIONS(8776), 1,
      anon_sym_DASH_GT,
    ACTIONS(8778), 1,
      anon_sym_STAR,
    ACTIONS(8780), 1,
      anon_sym_LT2,
    ACTIONS(8782), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5493), 1,
      aux_sym_compound_type_repeat1,
    STATE(5629), 1,
      sym_long_identifier,
    STATE(5631), 1,
      sym_type_arguments,
    STATE(6570), 1,
      sym__object_members,
    STATE(5337), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5377), 6,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(5381), 11,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [76395] = 31,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    ACTIONS(8784), 1,
      sym__dedent,
    STATE(5330), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5338), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [76496] = 31,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    ACTIONS(8786), 1,
      sym__dedent,
    STATE(5330), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5339), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [76597] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8640), 1,
      anon_sym_DASH_GT,
    ACTIONS(8642), 1,
      anon_sym_STAR,
    ACTIONS(8644), 1,
      anon_sym_LT2,
    ACTIONS(8646), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5439), 1,
      aux_sym_compound_type_repeat1,
    STATE(5497), 1,
      sym_long_identifier,
    STATE(5531), 1,
      sym_type_arguments,
    STATE(5340), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5984), 7,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(5986), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
  [76672] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8788), 1,
      anon_sym_or,
    STATE(5352), 1,
      aux_sym_type_argument_repeat1,
    STATE(5341), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 12,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3498), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [76735] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8640), 1,
      anon_sym_DASH_GT,
    ACTIONS(8642), 1,
      anon_sym_STAR,
    ACTIONS(8644), 1,
      anon_sym_LT2,
    ACTIONS(8646), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5439), 1,
      aux_sym_compound_type_repeat1,
    STATE(5497), 1,
      sym_long_identifier,
    STATE(5531), 1,
      sym_type_arguments,
    STATE(5342), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5996), 7,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(5998), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
  [76810] = 31,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    ACTIONS(8790), 1,
      sym__dedent,
    STATE(5330), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5343), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [76911] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8640), 1,
      anon_sym_DASH_GT,
    ACTIONS(8642), 1,
      anon_sym_STAR,
    ACTIONS(8644), 1,
      anon_sym_LT2,
    ACTIONS(8646), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5439), 1,
      aux_sym_compound_type_repeat1,
    STATE(5497), 1,
      sym_long_identifier,
    STATE(5531), 1,
      sym_type_arguments,
    STATE(5344), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3417), 7,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3419), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
  [76986] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8640), 1,
      anon_sym_DASH_GT,
    ACTIONS(8642), 1,
      anon_sym_STAR,
    ACTIONS(8644), 1,
      anon_sym_LT2,
    ACTIONS(8646), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5439), 1,
      aux_sym_compound_type_repeat1,
    STATE(5497), 1,
      sym_long_identifier,
    STATE(5531), 1,
      sym_type_arguments,
    STATE(5345), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3429), 7,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3431), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
  [77061] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8792), 1,
      anon_sym_DOT,
    STATE(5346), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4100), 12,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_with,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4098), 14,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [77122] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8640), 1,
      anon_sym_DASH_GT,
    ACTIONS(8642), 1,
      anon_sym_STAR,
    ACTIONS(8644), 1,
      anon_sym_LT2,
    ACTIONS(8646), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5439), 1,
      aux_sym_compound_type_repeat1,
    STATE(5497), 1,
      sym_long_identifier,
    STATE(5531), 1,
      sym_type_arguments,
    STATE(5347), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3425), 7,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3427), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
  [77197] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8640), 1,
      anon_sym_DASH_GT,
    ACTIONS(8642), 1,
      anon_sym_STAR,
    ACTIONS(8644), 1,
      anon_sym_LT2,
    ACTIONS(8646), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5439), 1,
      aux_sym_compound_type_repeat1,
    STATE(5497), 1,
      sym_long_identifier,
    STATE(5531), 1,
      sym_type_arguments,
    STATE(5348), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3403), 7,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3407), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
  [77272] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8794), 1,
      sym_identifier,
    ACTIONS(8796), 1,
      anon_sym_DASH_GT,
    ACTIONS(8798), 1,
      anon_sym_STAR,
    ACTIONS(8800), 1,
      anon_sym_LT2,
    ACTIONS(8802), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5534), 1,
      aux_sym_compound_type_repeat1,
    STATE(5579), 1,
      sym_type_arguments,
    STATE(5606), 1,
      sym_long_identifier,
    STATE(6523), 1,
      sym__object_members,
    STATE(5349), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5377), 6,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(5381), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
  [77349] = 31,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    ACTIONS(8804), 1,
      sym__dedent,
    STATE(5330), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5350), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [77450] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8806), 1,
      sym_identifier,
    ACTIONS(8808), 1,
      anon_sym_with,
    ACTIONS(8810), 1,
      anon_sym_DASH_GT,
    ACTIONS(8812), 1,
      anon_sym_STAR,
    ACTIONS(8814), 1,
      anon_sym_LT2,
    ACTIONS(8816), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5502), 1,
      aux_sym_compound_type_repeat1,
    STATE(5621), 1,
      sym_type_arguments,
    STATE(5626), 1,
      sym_long_identifier,
    STATE(6589), 1,
      sym__object_members,
    STATE(5351), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5377), 6,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(5381), 11,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [77529] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8788), 1,
      anon_sym_or,
    STATE(5329), 1,
      aux_sym_type_argument_repeat1,
    STATE(5352), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3474), 12,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3476), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [77592] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8644), 1,
      anon_sym_LT2,
    ACTIONS(8646), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5439), 1,
      aux_sym_compound_type_repeat1,
    STATE(5497), 1,
      sym_long_identifier,
    STATE(5531), 1,
      sym_type_arguments,
    ACTIONS(5609), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    STATE(5353), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5605), 7,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(5607), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
  [77665] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8640), 1,
      anon_sym_DASH_GT,
    ACTIONS(8642), 1,
      anon_sym_STAR,
    ACTIONS(8644), 1,
      anon_sym_LT2,
    ACTIONS(8646), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5439), 1,
      aux_sym_compound_type_repeat1,
    STATE(5497), 1,
      sym_long_identifier,
    STATE(5531), 1,
      sym_type_arguments,
    STATE(5354), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6030), 7,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(6032), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
  [77740] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8640), 1,
      anon_sym_DASH_GT,
    ACTIONS(8642), 1,
      anon_sym_STAR,
    ACTIONS(8644), 1,
      anon_sym_LT2,
    ACTIONS(8646), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5439), 1,
      aux_sym_compound_type_repeat1,
    STATE(5497), 1,
      sym_long_identifier,
    STATE(5531), 1,
      sym_type_arguments,
    STATE(5355), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6022), 7,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(6024), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
  [77815] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8640), 1,
      anon_sym_DASH_GT,
    ACTIONS(8642), 1,
      anon_sym_STAR,
    ACTIONS(8644), 1,
      anon_sym_LT2,
    ACTIONS(8646), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5439), 1,
      aux_sym_compound_type_repeat1,
    STATE(5497), 1,
      sym_long_identifier,
    STATE(5531), 1,
      sym_type_arguments,
    STATE(5356), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6008), 7,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(6010), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
  [77890] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8644), 1,
      anon_sym_LT2,
    ACTIONS(8646), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5439), 1,
      aux_sym_compound_type_repeat1,
    STATE(5497), 1,
      sym_long_identifier,
    STATE(5531), 1,
      sym_type_arguments,
    ACTIONS(5609), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    STATE(5357), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5621), 7,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(5623), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
  [77963] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5358), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4224), 12,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_with,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4222), 14,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [78021] = 30,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    STATE(5333), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5359), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [78119] = 30,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    STATE(5339), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5360), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [78217] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8806), 1,
      sym_identifier,
    ACTIONS(8814), 1,
      anon_sym_LT2,
    ACTIONS(8816), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5502), 1,
      aux_sym_compound_type_repeat1,
    STATE(5621), 1,
      sym_type_arguments,
    STATE(5626), 1,
      sym_long_identifier,
    ACTIONS(5609), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    STATE(5361), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5605), 6,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(5607), 12,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [78289] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5601), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8818), 1,
      anon_sym_DOT,
    STATE(5428), 1,
      aux_sym_long_identifier_repeat1,
    STATE(5362), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3494), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [78353] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8820), 1,
      anon_sym_or,
    STATE(5400), 1,
      aux_sym_type_argument_repeat1,
    STATE(5363), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3498), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [78415] = 30,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    STATE(5336), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5364), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [78513] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8772), 1,
      sym_identifier,
    ACTIONS(8776), 1,
      anon_sym_DASH_GT,
    ACTIONS(8778), 1,
      anon_sym_STAR,
    ACTIONS(8780), 1,
      anon_sym_LT2,
    ACTIONS(8782), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5493), 1,
      aux_sym_compound_type_repeat1,
    STATE(5629), 1,
      sym_long_identifier,
    STATE(5631), 1,
      sym_type_arguments,
    STATE(5365), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3429), 6,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(3431), 12,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [78587] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5366), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3478), 12,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3480), 14,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [78645] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8772), 1,
      sym_identifier,
    ACTIONS(8776), 1,
      anon_sym_DASH_GT,
    ACTIONS(8778), 1,
      anon_sym_STAR,
    ACTIONS(8780), 1,
      anon_sym_LT2,
    ACTIONS(8782), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5493), 1,
      aux_sym_compound_type_repeat1,
    STATE(5629), 1,
      sym_long_identifier,
    STATE(5631), 1,
      sym_type_arguments,
    STATE(5367), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3425), 6,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(3427), 12,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [78719] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8772), 1,
      sym_identifier,
    ACTIONS(8776), 1,
      anon_sym_DASH_GT,
    ACTIONS(8778), 1,
      anon_sym_STAR,
    ACTIONS(8780), 1,
      anon_sym_LT2,
    ACTIONS(8782), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5493), 1,
      aux_sym_compound_type_repeat1,
    STATE(5629), 1,
      sym_long_identifier,
    STATE(5631), 1,
      sym_type_arguments,
    STATE(5368), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3403), 6,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(3407), 12,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [78793] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5369), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4212), 12,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_with,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4210), 14,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [78851] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8794), 1,
      sym_identifier,
    ACTIONS(8796), 1,
      anon_sym_DASH_GT,
    ACTIONS(8798), 1,
      anon_sym_STAR,
    ACTIONS(8800), 1,
      anon_sym_LT2,
    ACTIONS(8802), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5534), 1,
      aux_sym_compound_type_repeat1,
    STATE(5579), 1,
      sym_type_arguments,
    STATE(5606), 1,
      sym_long_identifier,
    STATE(5370), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6022), 6,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(6024), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
  [78925] = 24,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3193), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8822), 1,
      anon_sym_y,
    ACTIONS(8824), 1,
      anon_sym_uy,
    ACTIONS(8826), 1,
      anon_sym_s,
    ACTIONS(8828), 1,
      anon_sym_us,
    ACTIONS(8830), 1,
      anon_sym_l,
    ACTIONS(8832), 1,
      aux_sym_uint32_token1,
    ACTIONS(8834), 1,
      anon_sym_n,
    ACTIONS(8836), 1,
      anon_sym_un,
    ACTIONS(8838), 1,
      anon_sym_L,
    ACTIONS(8840), 1,
      aux_sym_uint64_token1,
    ACTIONS(8842), 1,
      aux_sym_bignum_token1,
    ACTIONS(8844), 1,
      aux_sym_decimal_token1,
    ACTIONS(8846), 1,
      anon_sym_DOT2,
    ACTIONS(8848), 1,
      aux_sym_float_token1,
    STATE(5371), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3191), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [79011] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8794), 1,
      sym_identifier,
    ACTIONS(8796), 1,
      anon_sym_DASH_GT,
    ACTIONS(8798), 1,
      anon_sym_STAR,
    ACTIONS(8800), 1,
      anon_sym_LT2,
    ACTIONS(8802), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5534), 1,
      aux_sym_compound_type_repeat1,
    STATE(5579), 1,
      sym_type_arguments,
    STATE(5606), 1,
      sym_long_identifier,
    STATE(5372), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5984), 6,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(5986), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
  [79085] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8850), 1,
      anon_sym_DOT,
    STATE(5373), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3485), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3487), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [79145] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5374), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3509), 12,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3511), 14,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [79203] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8794), 1,
      sym_identifier,
    ACTIONS(8796), 1,
      anon_sym_DASH_GT,
    ACTIONS(8798), 1,
      anon_sym_STAR,
    ACTIONS(8800), 1,
      anon_sym_LT2,
    ACTIONS(8802), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5534), 1,
      aux_sym_compound_type_repeat1,
    STATE(5579), 1,
      sym_type_arguments,
    STATE(5606), 1,
      sym_long_identifier,
    STATE(5375), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5996), 6,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(5998), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
  [79277] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8853), 1,
      anon_sym_or,
    STATE(5376), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3478), 11,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3480), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [79337] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5601), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8856), 1,
      anon_sym_DOT,
    STATE(5425), 1,
      aux_sym_long_identifier_repeat1,
    STATE(5377), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 10,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3494), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [79401] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5378), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4208), 12,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_with,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4206), 14,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [79459] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8772), 1,
      sym_identifier,
    ACTIONS(8780), 1,
      anon_sym_LT2,
    ACTIONS(8782), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5493), 1,
      aux_sym_compound_type_repeat1,
    STATE(5629), 1,
      sym_long_identifier,
    STATE(5631), 1,
      sym_type_arguments,
    ACTIONS(5609), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    STATE(5379), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5605), 6,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(5607), 12,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [79531] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8858), 1,
      anon_sym_or,
    STATE(5376), 1,
      aux_sym_type_argument_repeat1,
    STATE(5380), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3474), 11,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3476), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [79593] = 30,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    STATE(5335), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5381), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [79691] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5382), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4186), 12,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_with,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4184), 14,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [79749] = 30,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    STATE(5338), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5383), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [79847] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8714), 1,
      anon_sym_DOT,
    STATE(5411), 1,
      aux_sym_long_identifier_repeat1,
    STATE(5384), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3494), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [79909] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8794), 1,
      sym_identifier,
    ACTIONS(8796), 1,
      anon_sym_DASH_GT,
    ACTIONS(8798), 1,
      anon_sym_STAR,
    ACTIONS(8800), 1,
      anon_sym_LT2,
    ACTIONS(8802), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5534), 1,
      aux_sym_compound_type_repeat1,
    STATE(5579), 1,
      sym_type_arguments,
    STATE(5606), 1,
      sym_long_identifier,
    STATE(5385), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6008), 6,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(6010), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
  [79983] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5386), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8860), 12,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_with,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8862), 14,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [80041] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8794), 1,
      sym_identifier,
    ACTIONS(8796), 1,
      anon_sym_DASH_GT,
    ACTIONS(8798), 1,
      anon_sym_STAR,
    ACTIONS(8800), 1,
      anon_sym_LT2,
    ACTIONS(8802), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5534), 1,
      aux_sym_compound_type_repeat1,
    STATE(5579), 1,
      sym_type_arguments,
    STATE(5606), 1,
      sym_long_identifier,
    STATE(5387), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3417), 6,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3419), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
  [80115] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8794), 1,
      sym_identifier,
    ACTIONS(8800), 1,
      anon_sym_LT2,
    ACTIONS(8802), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5534), 1,
      aux_sym_compound_type_repeat1,
    STATE(5579), 1,
      sym_type_arguments,
    STATE(5606), 1,
      sym_long_identifier,
    ACTIONS(5609), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    STATE(5388), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5621), 6,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(5623), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
  [80187] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8794), 1,
      sym_identifier,
    ACTIONS(8796), 1,
      anon_sym_DASH_GT,
    ACTIONS(8798), 1,
      anon_sym_STAR,
    ACTIONS(8800), 1,
      anon_sym_LT2,
    ACTIONS(8802), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5534), 1,
      aux_sym_compound_type_repeat1,
    STATE(5579), 1,
      sym_type_arguments,
    STATE(5606), 1,
      sym_long_identifier,
    STATE(5389), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6030), 6,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(6032), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
  [80261] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8794), 1,
      sym_identifier,
    ACTIONS(8796), 1,
      anon_sym_DASH_GT,
    ACTIONS(8798), 1,
      anon_sym_STAR,
    ACTIONS(8800), 1,
      anon_sym_LT2,
    ACTIONS(8802), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5534), 1,
      aux_sym_compound_type_repeat1,
    STATE(5579), 1,
      sym_type_arguments,
    STATE(5606), 1,
      sym_long_identifier,
    STATE(5390), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3429), 6,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3431), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
  [80335] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5391), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8864), 12,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_with,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(8866), 14,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [80393] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5392), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4100), 12,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_with,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(4098), 14,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [80451] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8772), 1,
      sym_identifier,
    ACTIONS(8780), 1,
      anon_sym_LT2,
    ACTIONS(8782), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5493), 1,
      aux_sym_compound_type_repeat1,
    STATE(5629), 1,
      sym_long_identifier,
    STATE(5631), 1,
      sym_type_arguments,
    ACTIONS(5609), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    STATE(5393), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5621), 6,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(5623), 12,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [80523] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8806), 1,
      sym_identifier,
    ACTIONS(8814), 1,
      anon_sym_LT2,
    ACTIONS(8816), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5502), 1,
      aux_sym_compound_type_repeat1,
    STATE(5621), 1,
      sym_type_arguments,
    STATE(5626), 1,
      sym_long_identifier,
    ACTIONS(5609), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    STATE(5394), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5621), 6,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(5623), 12,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [80595] = 30,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    STATE(5332), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5395), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [80693] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8868), 1,
      anon_sym_or,
    STATE(5396), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3478), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3480), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [80753] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8871), 1,
      sym_identifier,
    ACTIONS(8873), 1,
      anon_sym_with,
    ACTIONS(8875), 1,
      anon_sym_DASH_GT,
    ACTIONS(8877), 1,
      anon_sym_STAR,
    ACTIONS(8879), 1,
      anon_sym_LT2,
    ACTIONS(8881), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5577), 1,
      aux_sym_compound_type_repeat1,
    STATE(6085), 1,
      sym_type_arguments,
    STATE(6112), 1,
      sym_long_identifier,
    STATE(6882), 1,
      sym__object_members,
    STATE(5397), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5377), 6,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(5381), 10,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [80831] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8794), 1,
      sym_identifier,
    ACTIONS(8800), 1,
      anon_sym_LT2,
    ACTIONS(8802), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5534), 1,
      aux_sym_compound_type_repeat1,
    STATE(5579), 1,
      sym_type_arguments,
    STATE(5606), 1,
      sym_long_identifier,
    ACTIONS(5609), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    STATE(5398), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5605), 6,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(5607), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
  [80903] = 30,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    STATE(5343), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5399), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [81001] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8820), 1,
      anon_sym_or,
    STATE(5396), 1,
      aux_sym_type_argument_repeat1,
    STATE(5400), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3474), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3476), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [81063] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8772), 1,
      sym_identifier,
    ACTIONS(8776), 1,
      anon_sym_DASH_GT,
    ACTIONS(8778), 1,
      anon_sym_STAR,
    ACTIONS(8780), 1,
      anon_sym_LT2,
    ACTIONS(8782), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5493), 1,
      aux_sym_compound_type_repeat1,
    STATE(5629), 1,
      sym_long_identifier,
    STATE(5631), 1,
      sym_type_arguments,
    STATE(5401), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3417), 6,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(3419), 12,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [81137] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8858), 1,
      anon_sym_or,
    STATE(5380), 1,
      aux_sym_type_argument_repeat1,
    STATE(5402), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 11,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3498), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [81199] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8806), 1,
      sym_identifier,
    ACTIONS(8810), 1,
      anon_sym_DASH_GT,
    ACTIONS(8812), 1,
      anon_sym_STAR,
    ACTIONS(8814), 1,
      anon_sym_LT2,
    ACTIONS(8816), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5502), 1,
      aux_sym_compound_type_repeat1,
    STATE(5621), 1,
      sym_type_arguments,
    STATE(5626), 1,
      sym_long_identifier,
    STATE(5403), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3417), 6,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3419), 12,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [81273] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5601), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8883), 1,
      anon_sym_DOT,
    STATE(5445), 1,
      aux_sym_long_identifier_repeat1,
    STATE(5404), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3494), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [81337] = 30,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8512), 1,
      anon_sym_do,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(8524), 1,
      anon_sym_static,
    ACTIONS(8526), 1,
      anon_sym_member,
    ACTIONS(8528), 1,
      anon_sym_interface,
    ACTIONS(8530), 1,
      anon_sym_abstract,
    ACTIONS(8532), 1,
      anon_sym_val,
    ACTIONS(8534), 1,
      anon_sym_POUNDif,
    STATE(5350), 1,
      aux_sym__type_extension_inner,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6965), 1,
      sym_function_or_value_defn,
    STATE(6973), 1,
      sym_additional_constr_defn,
    STATE(7157), 1,
      sym_attributes,
    STATE(11240), 1,
      sym_access_modifier,
    ACTIONS(8522), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6972), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6967), 3,
      sym__class_function_or_value_defn,
      sym__type_defn_elements,
      sym_preproc_if_in_class_definition,
    STATE(5405), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [81435] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8794), 1,
      sym_identifier,
    ACTIONS(8796), 1,
      anon_sym_DASH_GT,
    ACTIONS(8798), 1,
      anon_sym_STAR,
    ACTIONS(8800), 1,
      anon_sym_LT2,
    ACTIONS(8802), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5534), 1,
      aux_sym_compound_type_repeat1,
    STATE(5579), 1,
      sym_type_arguments,
    STATE(5606), 1,
      sym_long_identifier,
    STATE(5406), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3425), 6,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3427), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
  [81509] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8885), 1,
      anon_sym_or,
    STATE(5408), 1,
      aux_sym_type_argument_repeat1,
    STATE(5407), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3498), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [81571] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8885), 1,
      anon_sym_or,
    STATE(5414), 1,
      aux_sym_type_argument_repeat1,
    STATE(5408), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3474), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3476), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [81633] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8806), 1,
      sym_identifier,
    ACTIONS(8810), 1,
      anon_sym_DASH_GT,
    ACTIONS(8812), 1,
      anon_sym_STAR,
    ACTIONS(8814), 1,
      anon_sym_LT2,
    ACTIONS(8816), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5502), 1,
      aux_sym_compound_type_repeat1,
    STATE(5621), 1,
      sym_type_arguments,
    STATE(5626), 1,
      sym_long_identifier,
    STATE(5409), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3403), 6,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3407), 12,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [81707] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8794), 1,
      sym_identifier,
    ACTIONS(8796), 1,
      anon_sym_DASH_GT,
    ACTIONS(8798), 1,
      anon_sym_STAR,
    ACTIONS(8800), 1,
      anon_sym_LT2,
    ACTIONS(8802), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5534), 1,
      aux_sym_compound_type_repeat1,
    STATE(5579), 1,
      sym_type_arguments,
    STATE(5606), 1,
      sym_long_identifier,
    STATE(5410), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3403), 6,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3407), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
  [81781] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8714), 1,
      anon_sym_DOT,
    STATE(5373), 1,
      aux_sym_long_identifier_repeat1,
    STATE(5411), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3449), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3451), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [81843] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8887), 1,
      sym_identifier,
    ACTIONS(8889), 1,
      anon_sym_with,
    ACTIONS(8891), 1,
      anon_sym_DASH_GT,
    ACTIONS(8893), 1,
      anon_sym_STAR,
    ACTIONS(8895), 1,
      anon_sym_LT2,
    ACTIONS(8897), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5599), 1,
      aux_sym_compound_type_repeat1,
    STATE(6169), 1,
      sym_type_arguments,
    STATE(6175), 1,
      sym_long_identifier,
    STATE(6855), 1,
      sym__object_members,
    STATE(5412), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5377), 5,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(5381), 11,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [81921] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8806), 1,
      sym_identifier,
    ACTIONS(8810), 1,
      anon_sym_DASH_GT,
    ACTIONS(8812), 1,
      anon_sym_STAR,
    ACTIONS(8814), 1,
      anon_sym_LT2,
    ACTIONS(8816), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5502), 1,
      aux_sym_compound_type_repeat1,
    STATE(5621), 1,
      sym_type_arguments,
    STATE(5626), 1,
      sym_long_identifier,
    STATE(5413), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3429), 6,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3431), 12,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [81995] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8899), 1,
      anon_sym_or,
    STATE(5414), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3478), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3480), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [82055] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8806), 1,
      sym_identifier,
    ACTIONS(8810), 1,
      anon_sym_DASH_GT,
    ACTIONS(8812), 1,
      anon_sym_STAR,
    ACTIONS(8814), 1,
      anon_sym_LT2,
    ACTIONS(8816), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5502), 1,
      aux_sym_compound_type_repeat1,
    STATE(5621), 1,
      sym_type_arguments,
    STATE(5626), 1,
      sym_long_identifier,
    STATE(5415), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3425), 6,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3427), 12,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [82129] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5601), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8902), 1,
      anon_sym_DOT,
    STATE(5529), 1,
      aux_sym_long_identifier_repeat1,
    STATE(5416), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3494), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [82192] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5601), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8904), 1,
      anon_sym_DOT,
    STATE(5554), 1,
      aux_sym_long_identifier_repeat1,
    STATE(5417), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 9,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3494), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [82255] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5418), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3485), 12,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3487), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [82312] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8772), 1,
      sym_identifier,
    ACTIONS(8776), 1,
      anon_sym_DASH_GT,
    ACTIONS(8778), 1,
      anon_sym_STAR,
    ACTIONS(8780), 1,
      anon_sym_LT2,
    ACTIONS(8782), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5493), 1,
      aux_sym_compound_type_repeat1,
    STATE(5629), 1,
      sym_long_identifier,
    STATE(5631), 1,
      sym_type_arguments,
    STATE(5419), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5984), 6,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(5986), 11,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [82385] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8906), 1,
      anon_sym_or,
    STATE(5420), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3478), 10,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3480), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [82444] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8909), 1,
      sym_identifier,
    ACTIONS(8915), 1,
      anon_sym_DASH_GT,
    ACTIONS(8917), 1,
      anon_sym_LT2,
    ACTIONS(8919), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5574), 1,
      aux_sym_compound_type_repeat1,
    STATE(6125), 1,
      sym_long_identifier,
    STATE(6154), 1,
      sym_type_arguments,
    STATE(5421), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8911), 7,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_POUNDif,
    ACTIONS(8913), 11,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [82515] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8772), 1,
      sym_identifier,
    ACTIONS(8776), 1,
      anon_sym_DASH_GT,
    ACTIONS(8778), 1,
      anon_sym_STAR,
    ACTIONS(8780), 1,
      anon_sym_LT2,
    ACTIONS(8782), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5493), 1,
      aux_sym_compound_type_repeat1,
    STATE(5629), 1,
      sym_long_identifier,
    STATE(5631), 1,
      sym_type_arguments,
    STATE(5422), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5996), 6,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(5998), 11,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [82588] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8921), 1,
      anon_sym_or,
    STATE(5420), 1,
      aux_sym_type_argument_repeat1,
    STATE(5423), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3474), 10,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3476), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [82649] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8806), 1,
      sym_identifier,
    ACTIONS(8810), 1,
      anon_sym_DASH_GT,
    ACTIONS(8812), 1,
      anon_sym_STAR,
    ACTIONS(8814), 1,
      anon_sym_LT2,
    ACTIONS(8816), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5502), 1,
      aux_sym_compound_type_repeat1,
    STATE(5621), 1,
      sym_type_arguments,
    STATE(5626), 1,
      sym_long_identifier,
    STATE(5424), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6008), 6,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(6010), 11,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [82722] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8856), 1,
      anon_sym_DOT,
    STATE(5426), 1,
      aux_sym_long_identifier_repeat1,
    STATE(5425), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3449), 10,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3451), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [82783] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8923), 1,
      anon_sym_DOT,
    STATE(5426), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3485), 10,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3487), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [82842] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8772), 1,
      sym_identifier,
    ACTIONS(8776), 1,
      anon_sym_DASH_GT,
    ACTIONS(8778), 1,
      anon_sym_STAR,
    ACTIONS(8780), 1,
      anon_sym_LT2,
    ACTIONS(8782), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5493), 1,
      aux_sym_compound_type_repeat1,
    STATE(5629), 1,
      sym_long_identifier,
    STATE(5631), 1,
      sym_type_arguments,
    STATE(5427), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6008), 6,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(6010), 11,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [82915] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8818), 1,
      anon_sym_DOT,
    STATE(5429), 1,
      aux_sym_long_identifier_repeat1,
    STATE(5428), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3449), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3451), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [82976] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8926), 1,
      anon_sym_DOT,
    STATE(5429), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3485), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3487), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [83035] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8806), 1,
      sym_identifier,
    ACTIONS(8810), 1,
      anon_sym_DASH_GT,
    ACTIONS(8812), 1,
      anon_sym_STAR,
    ACTIONS(8814), 1,
      anon_sym_LT2,
    ACTIONS(8816), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5502), 1,
      aux_sym_compound_type_repeat1,
    STATE(5621), 1,
      sym_type_arguments,
    STATE(5626), 1,
      sym_long_identifier,
    STATE(5430), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5996), 6,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(5998), 11,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [83108] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8909), 1,
      sym_identifier,
    ACTIONS(8915), 1,
      anon_sym_DASH_GT,
    ACTIONS(8917), 1,
      anon_sym_LT2,
    ACTIONS(8919), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8933), 1,
      anon_sym_STAR,
    STATE(5574), 1,
      aux_sym_compound_type_repeat1,
    STATE(6125), 1,
      sym_long_identifier,
    STATE(6154), 1,
      sym_type_arguments,
    STATE(5431), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8929), 6,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_POUNDif,
    ACTIONS(8931), 11,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [83181] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8772), 1,
      sym_identifier,
    ACTIONS(8776), 1,
      anon_sym_DASH_GT,
    ACTIONS(8778), 1,
      anon_sym_STAR,
    ACTIONS(8780), 1,
      anon_sym_LT2,
    ACTIONS(8782), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5493), 1,
      aux_sym_compound_type_repeat1,
    STATE(5629), 1,
      sym_long_identifier,
    STATE(5631), 1,
      sym_type_arguments,
    STATE(5432), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6030), 6,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(6032), 11,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [83254] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8935), 1,
      anon_sym_or,
    STATE(5433), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3478), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3480), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [83313] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8938), 1,
      anon_sym_COLON_GT,
    STATE(5434), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3515), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [83372] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5435), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3509), 11,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3511), 14,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [83429] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8772), 1,
      sym_identifier,
    ACTIONS(8776), 1,
      anon_sym_DASH_GT,
    ACTIONS(8778), 1,
      anon_sym_STAR,
    ACTIONS(8780), 1,
      anon_sym_LT2,
    ACTIONS(8782), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5493), 1,
      aux_sym_compound_type_repeat1,
    STATE(5629), 1,
      sym_long_identifier,
    STATE(5631), 1,
      sym_type_arguments,
    STATE(5436), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6022), 6,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(6024), 11,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [83502] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5437), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3509), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3511), 14,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [83559] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8806), 1,
      sym_identifier,
    ACTIONS(8810), 1,
      anon_sym_DASH_GT,
    ACTIONS(8812), 1,
      anon_sym_STAR,
    ACTIONS(8814), 1,
      anon_sym_LT2,
    ACTIONS(8816), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5502), 1,
      aux_sym_compound_type_repeat1,
    STATE(5621), 1,
      sym_type_arguments,
    STATE(5626), 1,
      sym_long_identifier,
    STATE(5438), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5984), 6,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(5986), 11,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [83632] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8642), 1,
      anon_sym_STAR,
    STATE(5450), 1,
      aux_sym_compound_type_repeat1,
    STATE(5439), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3466), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3468), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [83693] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8940), 1,
      anon_sym_or,
    STATE(5433), 1,
      aux_sym_type_argument_repeat1,
    STATE(5440), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3474), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3476), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [83754] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8909), 1,
      sym_identifier,
    ACTIONS(8915), 1,
      anon_sym_DASH_GT,
    ACTIONS(8917), 1,
      anon_sym_LT2,
    ACTIONS(8919), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8933), 1,
      anon_sym_STAR,
    ACTIONS(8942), 1,
      anon_sym_with,
    STATE(5574), 1,
      aux_sym_compound_type_repeat1,
    STATE(6125), 1,
      sym_long_identifier,
    STATE(6154), 1,
      sym_type_arguments,
    STATE(7062), 1,
      sym__object_members,
    STATE(5441), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5377), 5,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(5381), 10,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [83831] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5442), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3478), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3480), 14,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [83888] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5443), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3478), 11,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3480), 14,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [83945] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8909), 1,
      sym_identifier,
    ACTIONS(8915), 1,
      anon_sym_DASH_GT,
    ACTIONS(8917), 1,
      anon_sym_LT2,
    ACTIONS(8919), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8933), 1,
      anon_sym_STAR,
    STATE(5574), 1,
      aux_sym_compound_type_repeat1,
    STATE(6125), 1,
      sym_long_identifier,
    STATE(6154), 1,
      sym_type_arguments,
    STATE(5444), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3429), 6,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_POUNDif,
    ACTIONS(3431), 11,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [84018] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8883), 1,
      anon_sym_DOT,
    STATE(5448), 1,
      aux_sym_long_identifier_repeat1,
    STATE(5445), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3449), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3451), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [84079] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8909), 1,
      sym_identifier,
    ACTIONS(8915), 1,
      anon_sym_DASH_GT,
    ACTIONS(8917), 1,
      anon_sym_LT2,
    ACTIONS(8919), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8933), 1,
      anon_sym_STAR,
    STATE(5574), 1,
      aux_sym_compound_type_repeat1,
    STATE(6125), 1,
      sym_long_identifier,
    STATE(6154), 1,
      sym_type_arguments,
    STATE(5446), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3425), 6,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_POUNDif,
    ACTIONS(3427), 11,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [84152] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8871), 1,
      sym_identifier,
    ACTIONS(8875), 1,
      anon_sym_DASH_GT,
    ACTIONS(8877), 1,
      anon_sym_STAR,
    ACTIONS(8879), 1,
      anon_sym_LT2,
    ACTIONS(8881), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5577), 1,
      aux_sym_compound_type_repeat1,
    STATE(6085), 1,
      sym_type_arguments,
    STATE(6112), 1,
      sym_long_identifier,
    STATE(5447), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3429), 6,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(3431), 11,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [84225] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8944), 1,
      anon_sym_DOT,
    STATE(5448), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3485), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3487), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [84284] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8909), 1,
      sym_identifier,
    ACTIONS(8915), 1,
      anon_sym_DASH_GT,
    ACTIONS(8917), 1,
      anon_sym_LT2,
    ACTIONS(8919), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5574), 1,
      aux_sym_compound_type_repeat1,
    STATE(6125), 1,
      sym_long_identifier,
    STATE(6154), 1,
      sym_type_arguments,
    STATE(5449), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8947), 7,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_POUNDif,
    ACTIONS(8949), 11,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [84355] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8951), 1,
      anon_sym_STAR,
    STATE(5450), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3425), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3427), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [84414] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8954), 1,
      anon_sym_or,
    STATE(5451), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3478), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3480), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [84473] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8806), 1,
      sym_identifier,
    ACTIONS(8810), 1,
      anon_sym_DASH_GT,
    ACTIONS(8812), 1,
      anon_sym_STAR,
    ACTIONS(8814), 1,
      anon_sym_LT2,
    ACTIONS(8816), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5502), 1,
      aux_sym_compound_type_repeat1,
    STATE(5621), 1,
      sym_type_arguments,
    STATE(5626), 1,
      sym_long_identifier,
    STATE(5452), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6022), 6,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(6024), 11,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [84546] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8957), 1,
      anon_sym_or,
    STATE(5451), 1,
      aux_sym_type_argument_repeat1,
    STATE(5453), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3474), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3476), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [84607] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8883), 1,
      anon_sym_DOT,
    STATE(5445), 1,
      aux_sym_long_identifier_repeat1,
    STATE(5454), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3494), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [84668] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8871), 1,
      sym_identifier,
    ACTIONS(8879), 1,
      anon_sym_LT2,
    ACTIONS(8881), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5577), 1,
      aux_sym_compound_type_repeat1,
    STATE(6085), 1,
      sym_type_arguments,
    STATE(6112), 1,
      sym_long_identifier,
    ACTIONS(5609), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    STATE(5455), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5605), 6,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(5607), 11,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [84739] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8871), 1,
      sym_identifier,
    ACTIONS(8875), 1,
      anon_sym_DASH_GT,
    ACTIONS(8877), 1,
      anon_sym_STAR,
    ACTIONS(8879), 1,
      anon_sym_LT2,
    ACTIONS(8881), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5577), 1,
      aux_sym_compound_type_repeat1,
    STATE(6085), 1,
      sym_type_arguments,
    STATE(6112), 1,
      sym_long_identifier,
    STATE(5456), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3417), 6,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(3419), 11,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [84812] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8856), 1,
      anon_sym_DOT,
    STATE(5425), 1,
      aux_sym_long_identifier_repeat1,
    STATE(5457), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 10,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3494), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [84873] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8909), 1,
      sym_identifier,
    ACTIONS(8915), 1,
      anon_sym_DASH_GT,
    ACTIONS(8917), 1,
      anon_sym_LT2,
    ACTIONS(8919), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8933), 1,
      anon_sym_STAR,
    STATE(5574), 1,
      aux_sym_compound_type_repeat1,
    STATE(6125), 1,
      sym_long_identifier,
    STATE(6154), 1,
      sym_type_arguments,
    STATE(5458), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3417), 6,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_POUNDif,
    ACTIONS(3419), 11,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [84946] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5459), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 12,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3498), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [85003] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8909), 1,
      sym_identifier,
    ACTIONS(8915), 1,
      anon_sym_DASH_GT,
    ACTIONS(8917), 1,
      anon_sym_LT2,
    ACTIONS(8919), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8933), 1,
      anon_sym_STAR,
    STATE(5574), 1,
      aux_sym_compound_type_repeat1,
    STATE(6125), 1,
      sym_long_identifier,
    STATE(6154), 1,
      sym_type_arguments,
    STATE(5460), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3403), 6,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_POUNDif,
    ACTIONS(3407), 11,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [85076] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8871), 1,
      sym_identifier,
    ACTIONS(8875), 1,
      anon_sym_DASH_GT,
    ACTIONS(8877), 1,
      anon_sym_STAR,
    ACTIONS(8879), 1,
      anon_sym_LT2,
    ACTIONS(8881), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5577), 1,
      aux_sym_compound_type_repeat1,
    STATE(6085), 1,
      sym_type_arguments,
    STATE(6112), 1,
      sym_long_identifier,
    STATE(5461), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3403), 6,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(3407), 11,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [85149] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8871), 1,
      sym_identifier,
    ACTIONS(8875), 1,
      anon_sym_DASH_GT,
    ACTIONS(8877), 1,
      anon_sym_STAR,
    ACTIONS(8879), 1,
      anon_sym_LT2,
    ACTIONS(8881), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5577), 1,
      aux_sym_compound_type_repeat1,
    STATE(6085), 1,
      sym_type_arguments,
    STATE(6112), 1,
      sym_long_identifier,
    STATE(5462), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3425), 6,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(3427), 11,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [85222] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8957), 1,
      anon_sym_or,
    STATE(5453), 1,
      aux_sym_type_argument_repeat1,
    STATE(5463), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3498), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [85283] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8921), 1,
      anon_sym_or,
    STATE(5423), 1,
      aux_sym_type_argument_repeat1,
    STATE(5464), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 10,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3498), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [85344] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8887), 1,
      sym_identifier,
    ACTIONS(8891), 1,
      anon_sym_DASH_GT,
    ACTIONS(8893), 1,
      anon_sym_STAR,
    ACTIONS(8895), 1,
      anon_sym_LT2,
    ACTIONS(8897), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5599), 1,
      aux_sym_compound_type_repeat1,
    STATE(6169), 1,
      sym_type_arguments,
    STATE(6175), 1,
      sym_long_identifier,
    STATE(5465), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3429), 5,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3431), 12,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [85417] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8871), 1,
      sym_identifier,
    ACTIONS(8879), 1,
      anon_sym_LT2,
    ACTIONS(8881), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5577), 1,
      aux_sym_compound_type_repeat1,
    STATE(6085), 1,
      sym_type_arguments,
    STATE(6112), 1,
      sym_long_identifier,
    ACTIONS(5609), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    STATE(5466), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5621), 6,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(5623), 11,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [85488] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8887), 1,
      sym_identifier,
    ACTIONS(8891), 1,
      anon_sym_DASH_GT,
    ACTIONS(8893), 1,
      anon_sym_STAR,
    ACTIONS(8895), 1,
      anon_sym_LT2,
    ACTIONS(8897), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5599), 1,
      aux_sym_compound_type_repeat1,
    STATE(6169), 1,
      sym_type_arguments,
    STATE(6175), 1,
      sym_long_identifier,
    STATE(5467), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3425), 5,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3427), 12,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [85561] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8887), 1,
      sym_identifier,
    ACTIONS(8891), 1,
      anon_sym_DASH_GT,
    ACTIONS(8893), 1,
      anon_sym_STAR,
    ACTIONS(8895), 1,
      anon_sym_LT2,
    ACTIONS(8897), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5599), 1,
      aux_sym_compound_type_repeat1,
    STATE(6169), 1,
      sym_type_arguments,
    STATE(6175), 1,
      sym_long_identifier,
    STATE(5468), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3403), 5,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3407), 12,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [85634] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8818), 1,
      anon_sym_DOT,
    STATE(5428), 1,
      aux_sym_long_identifier_repeat1,
    STATE(5469), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3494), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [85695] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8806), 1,
      sym_identifier,
    ACTIONS(8810), 1,
      anon_sym_DASH_GT,
    ACTIONS(8812), 1,
      anon_sym_STAR,
    ACTIONS(8814), 1,
      anon_sym_LT2,
    ACTIONS(8816), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5502), 1,
      aux_sym_compound_type_repeat1,
    STATE(5621), 1,
      sym_type_arguments,
    STATE(5626), 1,
      sym_long_identifier,
    STATE(5470), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6030), 6,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(6032), 11,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [85768] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8887), 1,
      sym_identifier,
    ACTIONS(8891), 1,
      anon_sym_DASH_GT,
    ACTIONS(8893), 1,
      anon_sym_STAR,
    ACTIONS(8895), 1,
      anon_sym_LT2,
    ACTIONS(8897), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5599), 1,
      aux_sym_compound_type_repeat1,
    STATE(6169), 1,
      sym_type_arguments,
    STATE(6175), 1,
      sym_long_identifier,
    STATE(5471), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3417), 5,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3419), 12,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [85841] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8959), 1,
      anon_sym_COLON,
    ACTIONS(8961), 1,
      anon_sym_DOT,
    STATE(5540), 1,
      aux_sym_long_identifier_repeat1,
    STATE(5472), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3494), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [85904] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5473), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3509), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3511), 14,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [85961] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8887), 1,
      sym_identifier,
    ACTIONS(8895), 1,
      anon_sym_LT2,
    ACTIONS(8897), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5599), 1,
      aux_sym_compound_type_repeat1,
    STATE(6169), 1,
      sym_type_arguments,
    STATE(6175), 1,
      sym_long_identifier,
    ACTIONS(5609), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    STATE(5474), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5605), 5,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(5607), 12,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [86032] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8940), 1,
      anon_sym_or,
    STATE(5440), 1,
      aux_sym_type_argument_repeat1,
    STATE(5475), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3498), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [86093] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5476), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3478), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3480), 14,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [86150] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8887), 1,
      sym_identifier,
    ACTIONS(8895), 1,
      anon_sym_LT2,
    ACTIONS(8897), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5599), 1,
      aux_sym_compound_type_repeat1,
    STATE(6169), 1,
      sym_type_arguments,
    STATE(6175), 1,
      sym_long_identifier,
    ACTIONS(5609), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    STATE(5477), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5621), 5,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(5623), 12,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [86221] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8909), 1,
      sym_identifier,
    ACTIONS(8915), 1,
      anon_sym_DASH_GT,
    ACTIONS(8917), 1,
      anon_sym_LT2,
    ACTIONS(8919), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8933), 1,
      anon_sym_STAR,
    STATE(5574), 1,
      aux_sym_compound_type_repeat1,
    STATE(6125), 1,
      sym_long_identifier,
    STATE(6154), 1,
      sym_type_arguments,
    STATE(5478), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8963), 6,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_POUNDif,
    ACTIONS(8965), 11,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [86294] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5479), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3537), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3539), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [86350] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    ACTIONS(8969), 1,
      anon_sym_GT,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7601), 1,
      sym__type,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(11446), 1,
      sym_types,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5480), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [86428] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8887), 1,
      sym_identifier,
    ACTIONS(8891), 1,
      anon_sym_DASH_GT,
    ACTIONS(8893), 1,
      anon_sym_STAR,
    ACTIONS(8895), 1,
      anon_sym_LT2,
    ACTIONS(8897), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5599), 1,
      aux_sym_compound_type_repeat1,
    STATE(6169), 1,
      sym_type_arguments,
    STATE(6175), 1,
      sym_long_identifier,
    STATE(5481), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6030), 5,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(6032), 11,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [86500] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    ACTIONS(8971), 1,
      anon_sym_GT,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7601), 1,
      sym__type,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(11284), 1,
      sym_types,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5482), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [86578] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    ACTIONS(8973), 1,
      anon_sym_GT,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7601), 1,
      sym__type,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(11859), 1,
      sym_types,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5483), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [86656] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7977), 1,
      anon_sym_QMARK,
    ACTIONS(8556), 1,
      sym_identifier,
    STATE(5937), 1,
      sym_argument_name_spec,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8390), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5484), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [86734] = 22,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3193), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8822), 1,
      anon_sym_y,
    ACTIONS(8824), 1,
      anon_sym_uy,
    ACTIONS(8826), 1,
      anon_sym_s,
    ACTIONS(8828), 1,
      anon_sym_us,
    ACTIONS(8832), 1,
      aux_sym_uint32_token1,
    ACTIONS(8834), 1,
      anon_sym_n,
    ACTIONS(8836), 1,
      anon_sym_un,
    ACTIONS(8840), 1,
      aux_sym_uint64_token1,
    ACTIONS(8975), 1,
      anon_sym_l,
    ACTIONS(8977), 1,
      anon_sym_L,
    ACTIONS(8979), 1,
      anon_sym_lf,
    ACTIONS(8981), 1,
      anon_sym_LF,
    STATE(5485), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3191), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [86814] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    ACTIONS(8983), 1,
      anon_sym_GT,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7601), 1,
      sym__type,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(11601), 1,
      sym_types,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5486), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [86892] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8887), 1,
      sym_identifier,
    ACTIONS(8891), 1,
      anon_sym_DASH_GT,
    ACTIONS(8893), 1,
      anon_sym_STAR,
    ACTIONS(8895), 1,
      anon_sym_LT2,
    ACTIONS(8897), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5599), 1,
      aux_sym_compound_type_repeat1,
    STATE(6169), 1,
      sym_type_arguments,
    STATE(6175), 1,
      sym_long_identifier,
    STATE(5487), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6008), 5,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(6010), 11,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [86964] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8985), 1,
      anon_sym_COLON_GT,
    STATE(5488), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 10,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3515), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [87022] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8871), 1,
      sym_identifier,
    ACTIONS(8875), 1,
      anon_sym_DASH_GT,
    ACTIONS(8877), 1,
      anon_sym_STAR,
    ACTIONS(8879), 1,
      anon_sym_LT2,
    ACTIONS(8881), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5577), 1,
      aux_sym_compound_type_repeat1,
    STATE(6085), 1,
      sym_type_arguments,
    STATE(6112), 1,
      sym_long_identifier,
    STATE(5489), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6008), 6,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(6010), 10,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [87094] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    ACTIONS(8987), 1,
      anon_sym_GT,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7601), 1,
      sym__type,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(11195), 1,
      sym_types,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5490), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [87172] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8887), 1,
      sym_identifier,
    ACTIONS(8891), 1,
      anon_sym_DASH_GT,
    ACTIONS(8893), 1,
      anon_sym_STAR,
    ACTIONS(8895), 1,
      anon_sym_LT2,
    ACTIONS(8897), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5599), 1,
      aux_sym_compound_type_repeat1,
    STATE(6169), 1,
      sym_type_arguments,
    STATE(6175), 1,
      sym_long_identifier,
    STATE(5491), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5996), 5,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(5998), 11,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [87244] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5492), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3478), 10,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3480), 14,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [87300] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8778), 1,
      anon_sym_STAR,
    STATE(5504), 1,
      aux_sym_compound_type_repeat1,
    STATE(5493), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3466), 9,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3468), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [87360] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8887), 1,
      sym_identifier,
    ACTIONS(8891), 1,
      anon_sym_DASH_GT,
    ACTIONS(8893), 1,
      anon_sym_STAR,
    ACTIONS(8895), 1,
      anon_sym_LT2,
    ACTIONS(8897), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5599), 1,
      aux_sym_compound_type_repeat1,
    STATE(6169), 1,
      sym_type_arguments,
    STATE(6175), 1,
      sym_long_identifier,
    STATE(5494), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5984), 5,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(5986), 11,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [87432] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8871), 1,
      sym_identifier,
    ACTIONS(8875), 1,
      anon_sym_DASH_GT,
    ACTIONS(8877), 1,
      anon_sym_STAR,
    ACTIONS(8879), 1,
      anon_sym_LT2,
    ACTIONS(8881), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5577), 1,
      aux_sym_compound_type_repeat1,
    STATE(6085), 1,
      sym_type_arguments,
    STATE(6112), 1,
      sym_long_identifier,
    STATE(5495), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6030), 6,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(6032), 10,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [87504] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8887), 1,
      sym_identifier,
    ACTIONS(8891), 1,
      anon_sym_DASH_GT,
    ACTIONS(8893), 1,
      anon_sym_STAR,
    ACTIONS(8895), 1,
      anon_sym_LT2,
    ACTIONS(8897), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5599), 1,
      aux_sym_compound_type_repeat1,
    STATE(6169), 1,
      sym_type_arguments,
    STATE(6175), 1,
      sym_long_identifier,
    STATE(5496), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6022), 5,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(6024), 11,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [87576] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5497), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3529), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3531), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [87632] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5498), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3509), 10,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3511), 14,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [87688] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8904), 1,
      anon_sym_DOT,
    STATE(5554), 1,
      aux_sym_long_identifier_repeat1,
    STATE(5499), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 9,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3494), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [87748] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8871), 1,
      sym_identifier,
    ACTIONS(8875), 1,
      anon_sym_DASH_GT,
    ACTIONS(8877), 1,
      anon_sym_STAR,
    ACTIONS(8879), 1,
      anon_sym_LT2,
    ACTIONS(8881), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5577), 1,
      aux_sym_compound_type_repeat1,
    STATE(6085), 1,
      sym_type_arguments,
    STATE(6112), 1,
      sym_long_identifier,
    STATE(5500), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5996), 6,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(5998), 10,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [87820] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    ACTIONS(8989), 1,
      anon_sym_GT,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7601), 1,
      sym__type,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(11149), 1,
      sym_types,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5501), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [87898] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8812), 1,
      anon_sym_STAR,
    STATE(5512), 1,
      aux_sym_compound_type_repeat1,
    STATE(5502), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3466), 9,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3468), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [87958] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5503), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3485), 11,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3487), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [88014] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8991), 1,
      anon_sym_STAR,
    STATE(5504), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3425), 9,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3427), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [88072] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    ACTIONS(8994), 1,
      anon_sym_GT,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7601), 1,
      sym__type,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(11780), 1,
      sym_types,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5505), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [88150] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    ACTIONS(8996), 1,
      anon_sym_GT,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7601), 1,
      sym__type,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(11361), 1,
      sym_types,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5506), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [88228] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    ACTIONS(8998), 1,
      anon_sym_GT,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7601), 1,
      sym__type,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(11525), 1,
      sym_types,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5507), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [88306] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8871), 1,
      sym_identifier,
    ACTIONS(8875), 1,
      anon_sym_DASH_GT,
    ACTIONS(8877), 1,
      anon_sym_STAR,
    ACTIONS(8879), 1,
      anon_sym_LT2,
    ACTIONS(8881), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5577), 1,
      aux_sym_compound_type_repeat1,
    STATE(6085), 1,
      sym_type_arguments,
    STATE(6112), 1,
      sym_long_identifier,
    STATE(5508), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5984), 6,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(5986), 10,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [88378] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9000), 1,
      anon_sym_STAR,
    STATE(5509), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3425), 9,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3427), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [88436] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9003), 1,
      anon_sym_COLON_GT,
    STATE(5510), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3515), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [88494] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5523), 1,
      aux_sym_attributes_repeat1,
    STATE(5816), 1,
      sym__attribute_set,
    STATE(5511), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9005), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(9007), 12,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [88554] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9009), 1,
      anon_sym_STAR,
    STATE(5512), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3425), 9,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3427), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [88612] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    ACTIONS(9012), 1,
      anon_sym_GT,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7601), 1,
      sym__type,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(11103), 1,
      sym_types,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5513), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [88690] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5514), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3485), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3487), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [88746] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    ACTIONS(9014), 1,
      anon_sym_GT,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7601), 1,
      sym__type,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(11212), 1,
      sym_types,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5515), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [88824] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5516), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3498), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [88880] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8902), 1,
      anon_sym_DOT,
    STATE(5529), 1,
      aux_sym_long_identifier_repeat1,
    STATE(5517), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3494), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [88940] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5518), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3498), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [88996] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    ACTIONS(9016), 1,
      anon_sym_GT,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7601), 1,
      sym__type,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(10954), 1,
      sym_types,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5519), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [89074] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5520), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3545), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3547), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [89130] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5521), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3541), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3543), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [89186] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8029), 1,
      anon_sym_LPAREN,
    ACTIONS(8031), 1,
      anon_sym__,
    ACTIONS(8033), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8035), 1,
      anon_sym_POUND,
    ACTIONS(9018), 1,
      sym_identifier,
    STATE(5449), 1,
      sym__type,
    STATE(5475), 1,
      sym__static_type_identifier,
    STATE(5630), 1,
      sym_type_argument,
    STATE(6183), 1,
      sym_long_identifier,
    STATE(6401), 1,
      sym_union_type_field,
    STATE(6668), 1,
      sym_union_type_fields,
    ACTIONS(8037), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5522), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6184), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [89264] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9022), 1,
      anon_sym_LBRACK_LT,
    STATE(5816), 1,
      sym__attribute_set,
    STATE(5523), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_attributes_repeat1,
    ACTIONS(9020), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(9025), 11,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [89324] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5524), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3478), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3480), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [89380] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5525), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3515), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [89436] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5526), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 11,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3498), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [89492] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8029), 1,
      anon_sym_LPAREN,
    ACTIONS(8031), 1,
      anon_sym__,
    ACTIONS(8033), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8035), 1,
      anon_sym_POUND,
    ACTIONS(9018), 1,
      sym_identifier,
    STATE(5449), 1,
      sym__type,
    STATE(5475), 1,
      sym__static_type_identifier,
    STATE(5630), 1,
      sym_type_argument,
    STATE(6183), 1,
      sym_long_identifier,
    STATE(6401), 1,
      sym_union_type_field,
    STATE(6707), 1,
      sym_union_type_fields,
    ACTIONS(8037), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5527), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6184), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [89570] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9027), 1,
      anon_sym_LT2,
    STATE(5528), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3503), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3505), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [89628] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8902), 1,
      anon_sym_DOT,
    STATE(5532), 1,
      aux_sym_long_identifier_repeat1,
    STATE(5529), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3449), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3451), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [89688] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5530), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3549), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3551), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [89744] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5531), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3560), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3562), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [89800] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9029), 1,
      anon_sym_DOT,
    STATE(5532), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3485), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3487), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [89858] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    ACTIONS(9032), 1,
      anon_sym_GT,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7601), 1,
      sym__type,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(11058), 1,
      sym_types,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5533), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [89936] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8798), 1,
      anon_sym_STAR,
    STATE(5509), 1,
      aux_sym_compound_type_repeat1,
    STATE(5534), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3466), 9,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3468), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [89996] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8871), 1,
      sym_identifier,
    ACTIONS(8875), 1,
      anon_sym_DASH_GT,
    ACTIONS(8877), 1,
      anon_sym_STAR,
    ACTIONS(8879), 1,
      anon_sym_LT2,
    ACTIONS(8881), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5577), 1,
      aux_sym_compound_type_repeat1,
    STATE(6085), 1,
      sym_type_arguments,
    STATE(6112), 1,
      sym_long_identifier,
    STATE(5535), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6022), 6,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(6024), 10,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [90068] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    ACTIONS(9034), 1,
      anon_sym_GT,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7601), 1,
      sym__type,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(11012), 1,
      sym_types,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5536), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [90146] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5537), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3509), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3511), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [90202] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5538), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3485), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3487), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [90258] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    ACTIONS(9036), 1,
      anon_sym_GT,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7601), 1,
      sym__type,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(12077), 1,
      sym_types,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5539), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [90336] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8961), 1,
      anon_sym_DOT,
    STATE(5544), 1,
      aux_sym_long_identifier_repeat1,
    STATE(5540), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3449), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3451), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [90396] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5541), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3533), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3535), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [90452] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5542), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3509), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3511), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [90508] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5543), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3478), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3480), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [90564] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9038), 1,
      anon_sym_DOT,
    STATE(5544), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3485), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3487), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [90622] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8961), 1,
      anon_sym_DOT,
    STATE(5540), 1,
      aux_sym_long_identifier_repeat1,
    STATE(5545), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3494), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [90682] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9041), 1,
      anon_sym_DOT,
    STATE(5546), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3485), 9,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3487), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [90740] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    ACTIONS(9044), 1,
      anon_sym_GT,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7601), 1,
      sym__type,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(11680), 1,
      sym_types,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5547), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [90818] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8909), 1,
      sym_identifier,
    ACTIONS(8917), 1,
      anon_sym_LT2,
    ACTIONS(8919), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5574), 1,
      aux_sym_compound_type_repeat1,
    STATE(6125), 1,
      sym_long_identifier,
    STATE(6154), 1,
      sym_type_arguments,
    ACTIONS(5609), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    STATE(5548), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5621), 5,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(5623), 11,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [90888] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8909), 1,
      sym_identifier,
    ACTIONS(8917), 1,
      anon_sym_LT2,
    ACTIONS(8919), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5574), 1,
      aux_sym_compound_type_repeat1,
    STATE(6125), 1,
      sym_long_identifier,
    STATE(6154), 1,
      sym_type_arguments,
    ACTIONS(5609), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    STATE(5549), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5605), 5,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(5607), 11,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [90958] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5601), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8961), 1,
      anon_sym_DOT,
    STATE(5540), 1,
      aux_sym_long_identifier_repeat1,
    STATE(5550), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 9,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3494), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [91020] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5551), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3521), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3523), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [91076] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9046), 1,
      anon_sym_COLON_GT,
    STATE(5552), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3515), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [91134] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5553), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3525), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3527), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [91190] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8904), 1,
      anon_sym_DOT,
    STATE(5546), 1,
      aux_sym_long_identifier_repeat1,
    STATE(5554), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3449), 9,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3451), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [91250] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5555), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3517), 11,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3519), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [91306] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8909), 1,
      sym_identifier,
    ACTIONS(8915), 1,
      anon_sym_DASH_GT,
    ACTIONS(8917), 1,
      anon_sym_LT2,
    ACTIONS(8919), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8933), 1,
      anon_sym_STAR,
    STATE(5574), 1,
      aux_sym_compound_type_repeat1,
    STATE(6125), 1,
      sym_long_identifier,
    STATE(6154), 1,
      sym_type_arguments,
    STATE(5556), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5984), 5,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(5986), 10,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [91377] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5557), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 10,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3515), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [91432] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5558), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3517), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3519), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [91487] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9048), 1,
      sym_identifier,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    STATE(4949), 1,
      sym_type_name,
    STATE(6326), 1,
      sym_long_identifier,
    STATE(8059), 1,
      sym_attributes,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8536), 1,
      sym_access_modifier,
    STATE(8552), 1,
      sym__type_defn_body,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(11774), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5559), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(9038), 8,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_interface_type_defn,
      sym_anon_type_defn,
  [91568] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5560), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3521), 10,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3523), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [91623] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9048), 1,
      sym_identifier,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    STATE(4030), 1,
      sym__type_defn_body,
    STATE(4935), 1,
      sym_type_name,
    STATE(6326), 1,
      sym_long_identifier,
    STATE(8059), 1,
      sym_attributes,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8536), 1,
      sym_access_modifier,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(11774), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5561), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4135), 8,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_interface_type_defn,
      sym_anon_type_defn,
  [91704] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9048), 1,
      sym_identifier,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    STATE(4005), 1,
      sym__type_defn_body,
    STATE(5098), 1,
      sym_type_name,
    STATE(6326), 1,
      sym_long_identifier,
    STATE(8059), 1,
      sym_attributes,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8536), 1,
      sym_access_modifier,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(11774), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5562), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4135), 8,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_interface_type_defn,
      sym_anon_type_defn,
  [91785] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9048), 1,
      sym_identifier,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    STATE(4949), 1,
      sym_type_name,
    STATE(6326), 1,
      sym_long_identifier,
    STATE(8059), 1,
      sym_attributes,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8536), 1,
      sym_access_modifier,
    STATE(8545), 1,
      sym__type_defn_body,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(11774), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5563), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(9038), 8,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_interface_type_defn,
      sym_anon_type_defn,
  [91866] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8909), 1,
      sym_identifier,
    ACTIONS(8915), 1,
      anon_sym_DASH_GT,
    ACTIONS(8917), 1,
      anon_sym_LT2,
    ACTIONS(8919), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8933), 1,
      anon_sym_STAR,
    STATE(5574), 1,
      aux_sym_compound_type_repeat1,
    STATE(6125), 1,
      sym_long_identifier,
    STATE(6154), 1,
      sym_type_arguments,
    STATE(5564), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6022), 5,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(6024), 10,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [91937] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8909), 1,
      sym_identifier,
    ACTIONS(8915), 1,
      anon_sym_DASH_GT,
    ACTIONS(8917), 1,
      anon_sym_LT2,
    ACTIONS(8919), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8933), 1,
      anon_sym_STAR,
    STATE(5574), 1,
      aux_sym_compound_type_repeat1,
    STATE(6125), 1,
      sym_long_identifier,
    STATE(6154), 1,
      sym_type_arguments,
    STATE(5565), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6030), 5,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(6032), 10,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [92008] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9052), 1,
      anon_sym_COLON_GT,
    STATE(5566), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3515), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [92065] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9054), 1,
      anon_sym_DOT,
    STATE(5583), 1,
      aux_sym_long_identifier_repeat1,
    STATE(5567), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3451), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_of,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3449), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [92124] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5568), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3515), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [92179] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5569), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3485), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3487), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [92234] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5570), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3517), 10,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3519), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [92289] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5571), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3549), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3551), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [92344] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5572), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3498), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [92399] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5573), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3485), 10,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3487), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [92454] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8933), 1,
      anon_sym_STAR,
    STATE(5578), 1,
      aux_sym_compound_type_repeat1,
    STATE(5574), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3466), 9,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3468), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [92513] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9048), 1,
      sym_identifier,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    STATE(4012), 1,
      sym__type_defn_body,
    STATE(5098), 1,
      sym_type_name,
    STATE(6326), 1,
      sym_long_identifier,
    STATE(8059), 1,
      sym_attributes,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8536), 1,
      sym_access_modifier,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(11774), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5575), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4135), 8,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_interface_type_defn,
      sym_anon_type_defn,
  [92594] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9048), 1,
      sym_identifier,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    STATE(5091), 1,
      sym_type_name,
    STATE(6326), 1,
      sym_long_identifier,
    STATE(8059), 1,
      sym_attributes,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8312), 1,
      sym__type_defn_body,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8536), 1,
      sym_access_modifier,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(11774), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5576), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(8914), 8,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_interface_type_defn,
      sym_anon_type_defn,
  [92675] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8877), 1,
      anon_sym_STAR,
    STATE(5615), 1,
      aux_sym_compound_type_repeat1,
    STATE(5577), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3466), 9,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3468), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [92734] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9056), 1,
      anon_sym_STAR,
    STATE(5578), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3425), 9,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3427), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [92791] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5579), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3560), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3562), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [92846] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9048), 1,
      sym_identifier,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    STATE(4099), 1,
      sym__type_defn_body,
    STATE(4935), 1,
      sym_type_name,
    STATE(6326), 1,
      sym_long_identifier,
    STATE(8059), 1,
      sym_attributes,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8536), 1,
      sym_access_modifier,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(11774), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5580), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4135), 8,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_interface_type_defn,
      sym_anon_type_defn,
  [92927] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9048), 1,
      sym_identifier,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    STATE(5091), 1,
      sym_type_name,
    STATE(6326), 1,
      sym_long_identifier,
    STATE(8059), 1,
      sym_attributes,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8536), 1,
      sym_access_modifier,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(8803), 1,
      sym__type_defn_body,
    STATE(11774), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5581), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(8914), 8,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_interface_type_defn,
      sym_anon_type_defn,
  [93008] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5582), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3498), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [93063] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9059), 1,
      anon_sym_DOT,
    STATE(5583), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3487), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_of,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [93120] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9048), 1,
      sym_identifier,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    STATE(4138), 1,
      sym__type_defn_body,
    STATE(5098), 1,
      sym_type_name,
    STATE(6326), 1,
      sym_long_identifier,
    STATE(8059), 1,
      sym_attributes,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8536), 1,
      sym_access_modifier,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(11774), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5584), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4135), 8,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_interface_type_defn,
      sym_anon_type_defn,
  [93201] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5585), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3485), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3487), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [93256] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9048), 1,
      sym_identifier,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    STATE(4099), 1,
      sym__type_defn_body,
    STATE(5098), 1,
      sym_type_name,
    STATE(6326), 1,
      sym_long_identifier,
    STATE(8059), 1,
      sym_attributes,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8536), 1,
      sym_access_modifier,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(11774), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5586), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4135), 8,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_interface_type_defn,
      sym_anon_type_defn,
  [93337] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5587), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3525), 10,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3527), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [93392] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9062), 1,
      aux_sym_float_token1,
    STATE(5588), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3602), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
    ACTIONS(3604), 11,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
  [93449] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5589), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3537), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3539), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [93504] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5590), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3515), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [93559] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5591), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3541), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3543), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [93614] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5592), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3545), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3547), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [93669] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5593), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3541), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3543), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [93724] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5594), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3521), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3523), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [93779] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9048), 1,
      sym_identifier,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    STATE(4029), 1,
      sym__type_defn_body,
    STATE(4935), 1,
      sym_type_name,
    STATE(6326), 1,
      sym_long_identifier,
    STATE(8059), 1,
      sym_attributes,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8536), 1,
      sym_access_modifier,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(11774), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5595), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4135), 8,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_interface_type_defn,
      sym_anon_type_defn,
  [93860] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9048), 1,
      sym_identifier,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    STATE(5091), 1,
      sym_type_name,
    STATE(6326), 1,
      sym_long_identifier,
    STATE(8059), 1,
      sym_attributes,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8301), 1,
      sym__type_defn_body,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8536), 1,
      sym_access_modifier,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(11774), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5596), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(8914), 8,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_interface_type_defn,
      sym_anon_type_defn,
  [93941] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9064), 1,
      anon_sym_LT2,
    STATE(5597), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3503), 9,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3505), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [93998] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5598), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3533), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3535), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [94053] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8893), 1,
      anon_sym_STAR,
    STATE(5636), 1,
      aux_sym_compound_type_repeat1,
    STATE(5599), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3466), 8,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3468), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [94112] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5600), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3533), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3535), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [94167] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8029), 1,
      anon_sym_LPAREN,
    ACTIONS(8031), 1,
      anon_sym__,
    ACTIONS(8033), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8035), 1,
      anon_sym_POUND,
    ACTIONS(9018), 1,
      sym_identifier,
    STATE(5449), 1,
      sym__type,
    STATE(5475), 1,
      sym__static_type_identifier,
    STATE(5630), 1,
      sym_type_argument,
    STATE(6183), 1,
      sym_long_identifier,
    STATE(6426), 1,
      sym_union_type_field,
    ACTIONS(8037), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5601), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6184), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [94242] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5602), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3545), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3547), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [94297] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5603), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3517), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3519), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [94352] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5604), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3537), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3539), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [94407] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9048), 1,
      sym_identifier,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    STATE(4949), 1,
      sym_type_name,
    STATE(6326), 1,
      sym_long_identifier,
    STATE(8059), 1,
      sym_attributes,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8536), 1,
      sym_access_modifier,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(9027), 1,
      sym__type_defn_body,
    STATE(11774), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5605), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(9038), 8,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_interface_type_defn,
      sym_anon_type_defn,
  [94488] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5606), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3529), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3531), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [94543] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8909), 1,
      sym_identifier,
    ACTIONS(8915), 1,
      anon_sym_DASH_GT,
    ACTIONS(8917), 1,
      anon_sym_LT2,
    ACTIONS(8919), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8933), 1,
      anon_sym_STAR,
    STATE(5574), 1,
      aux_sym_compound_type_repeat1,
    STATE(6125), 1,
      sym_long_identifier,
    STATE(6154), 1,
      sym_type_arguments,
    STATE(5607), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5996), 5,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(5998), 10,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [94614] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5608), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3537), 10,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3539), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [94669] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5609), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3525), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3527), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [94724] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5610), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3541), 10,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3543), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [94779] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9054), 1,
      anon_sym_DOT,
    STATE(5567), 1,
      aux_sym_long_identifier_repeat1,
    STATE(5611), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3494), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_of,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3492), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [94838] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9048), 1,
      sym_identifier,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    STATE(4949), 1,
      sym_type_name,
    STATE(6326), 1,
      sym_long_identifier,
    STATE(8059), 1,
      sym_attributes,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8536), 1,
      sym_access_modifier,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(9021), 1,
      sym__type_defn_body,
    STATE(11774), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5612), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(9038), 8,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_interface_type_defn,
      sym_anon_type_defn,
  [94919] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5613), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3545), 10,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3547), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [94974] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8909), 1,
      sym_identifier,
    ACTIONS(8915), 1,
      anon_sym_DASH_GT,
    ACTIONS(8917), 1,
      anon_sym_LT2,
    ACTIONS(8919), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(8933), 1,
      anon_sym_STAR,
    STATE(5574), 1,
      aux_sym_compound_type_repeat1,
    STATE(6125), 1,
      sym_long_identifier,
    STATE(6154), 1,
      sym_type_arguments,
    STATE(5614), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6008), 5,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_POUNDif,
    ACTIONS(6010), 10,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [95045] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9066), 1,
      anon_sym_STAR,
    STATE(5615), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3425), 9,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3427), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [95102] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9048), 1,
      sym_identifier,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    STATE(4138), 1,
      sym__type_defn_body,
    STATE(4935), 1,
      sym_type_name,
    STATE(6326), 1,
      sym_long_identifier,
    STATE(8059), 1,
      sym_attributes,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8536), 1,
      sym_access_modifier,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(11774), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5616), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4135), 8,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_interface_type_defn,
      sym_anon_type_defn,
  [95183] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5617), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 10,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3498), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [95238] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9069), 1,
      anon_sym_COLON_GT,
    STATE(5618), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 9,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3515), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [95295] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5619), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3533), 10,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3535), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [95350] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9048), 1,
      sym_identifier,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    STATE(4969), 1,
      sym_type_name,
    STATE(6326), 1,
      sym_long_identifier,
    STATE(8059), 1,
      sym_attributes,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8536), 1,
      sym_access_modifier,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(8907), 1,
      sym__type_defn_body,
    STATE(11774), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5620), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(8894), 8,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_interface_type_defn,
      sym_anon_type_defn,
  [95431] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5621), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3560), 10,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3562), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [95486] = 24,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3193), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9071), 1,
      anon_sym_y,
    ACTIONS(9073), 1,
      anon_sym_uy,
    ACTIONS(9075), 1,
      anon_sym_s,
    ACTIONS(9077), 1,
      anon_sym_us,
    ACTIONS(9079), 1,
      anon_sym_l,
    ACTIONS(9081), 1,
      aux_sym_uint32_token1,
    ACTIONS(9083), 1,
      anon_sym_n,
    ACTIONS(9085), 1,
      anon_sym_un,
    ACTIONS(9087), 1,
      anon_sym_L,
    ACTIONS(9089), 1,
      aux_sym_uint64_token1,
    ACTIONS(9091), 1,
      aux_sym_bignum_token1,
    ACTIONS(9093), 1,
      aux_sym_decimal_token1,
    ACTIONS(9095), 1,
      anon_sym_DOT2,
    ACTIONS(9097), 1,
      aux_sym_float_token1,
    STATE(5622), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3191), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [95569] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9048), 1,
      sym_identifier,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    STATE(5091), 1,
      sym_type_name,
    STATE(6326), 1,
      sym_long_identifier,
    STATE(8059), 1,
      sym_attributes,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8536), 1,
      sym_access_modifier,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(8863), 1,
      sym__type_defn_body,
    STATE(11774), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5623), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(8914), 8,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_interface_type_defn,
      sym_anon_type_defn,
  [95650] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5624), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3549), 10,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3551), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [95705] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9048), 1,
      sym_identifier,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    STATE(4969), 1,
      sym_type_name,
    STATE(6326), 1,
      sym_long_identifier,
    STATE(8059), 1,
      sym_attributes,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8362), 1,
      sym__type_defn_body,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8536), 1,
      sym_access_modifier,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(11774), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5625), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(8894), 8,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_interface_type_defn,
      sym_anon_type_defn,
  [95786] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5626), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3529), 10,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3531), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [95841] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9099), 1,
      anon_sym_LT2,
    STATE(5627), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3503), 9,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    ACTIONS(3505), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [95898] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6560), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7723), 1,
      anon_sym_LPAREN,
    ACTIONS(7725), 1,
      anon_sym__,
    ACTIONS(7727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(7729), 1,
      anon_sym_POUND,
    STATE(579), 1,
      sym__type,
    STATE(4038), 1,
      sym__static_type_identifier,
    STATE(4159), 1,
      sym_type_argument,
    STATE(4192), 1,
      sym_long_identifier,
    STATE(9953), 1,
      sym__object_construction,
    ACTIONS(7731), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5628), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4190), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [95973] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5629), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3529), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3531), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [96028] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9101), 1,
      anon_sym_COLON_GT,
    STATE(5630), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3515), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [96085] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5631), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3560), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3562), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [96140] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9048), 1,
      sym_identifier,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    STATE(4969), 1,
      sym_type_name,
    STATE(6326), 1,
      sym_long_identifier,
    STATE(8059), 1,
      sym_attributes,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8399), 1,
      sym__type_defn_body,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8536), 1,
      sym_access_modifier,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(11774), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5632), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(8894), 8,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_interface_type_defn,
      sym_anon_type_defn,
  [96221] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5633), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3521), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3523), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [96276] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5634), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3549), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3551), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [96331] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5635), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3525), 10,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3527), 13,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      sym_identifier,
  [96386] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9103), 1,
      anon_sym_STAR,
    STATE(5636), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3425), 8,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3427), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [96443] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9048), 1,
      sym_identifier,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    STATE(4969), 1,
      sym_type_name,
    STATE(6326), 1,
      sym_long_identifier,
    STATE(8059), 1,
      sym_attributes,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8536), 1,
      sym_access_modifier,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(8916), 1,
      sym__type_defn_body,
    STATE(11774), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5637), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(8894), 8,
      sym_type_extension,
      sym_delegate_type_defn,
      sym_type_abbrev_defn,
      sym_record_type_defn,
      sym_enum_type_defn,
      sym_union_type_defn,
      sym_interface_type_defn,
      sym_anon_type_defn,
  [96524] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9106), 1,
      anon_sym_LT2,
    STATE(5638), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3503), 9,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3505), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [96581] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8096), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5639), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [96653] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9108), 1,
      sym_identifier,
    ACTIONS(9110), 1,
      anon_sym_LPAREN,
    ACTIONS(9112), 1,
      anon_sym__,
    ACTIONS(9114), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9116), 1,
      anon_sym_POUND,
    STATE(6834), 1,
      sym__static_type_identifier,
    STATE(6899), 1,
      sym__type,
    STATE(7121), 1,
      sym_type_argument,
    STATE(7307), 1,
      sym_long_identifier,
    ACTIONS(9118), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5640), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7300), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [96725] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8214), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5641), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [96797] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8074), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5642), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [96869] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8030), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5643), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [96941] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8101), 1,
      anon_sym_LPAREN,
    ACTIONS(8103), 1,
      anon_sym__,
    ACTIONS(8105), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8107), 1,
      anon_sym_POUND,
    ACTIONS(8887), 1,
      sym_identifier,
    STATE(5464), 1,
      sym__static_type_identifier,
    STATE(5496), 1,
      sym__type,
    STATE(5618), 1,
      sym_type_argument,
    STATE(6164), 1,
      sym_long_identifier,
    ACTIONS(8109), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5644), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6161), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [97013] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8040), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5645), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [97085] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5646), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3539), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3537), 12,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [97139] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8101), 1,
      anon_sym_LPAREN,
    ACTIONS(8103), 1,
      anon_sym__,
    ACTIONS(8105), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8107), 1,
      anon_sym_POUND,
    ACTIONS(8887), 1,
      sym_identifier,
    STATE(5464), 1,
      sym__static_type_identifier,
    STATE(5481), 1,
      sym__type,
    STATE(5618), 1,
      sym_type_argument,
    STATE(6164), 1,
      sym_long_identifier,
    ACTIONS(8109), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5647), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6161), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [97211] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8184), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5648), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [97283] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8253), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5649), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [97355] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8050), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5650), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [97427] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3650), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9120), 1,
      anon_sym_LPAREN,
    ACTIONS(9122), 1,
      anon_sym__,
    ACTIONS(9124), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9126), 1,
      anon_sym_POUND,
    STATE(1258), 1,
      sym__type,
    STATE(1400), 1,
      sym__static_type_identifier,
    STATE(1518), 1,
      sym_long_identifier,
    STATE(1526), 1,
      sym_type_argument,
    ACTIONS(9128), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5651), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1527), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [97499] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3650), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9120), 1,
      anon_sym_LPAREN,
    ACTIONS(9122), 1,
      anon_sym__,
    ACTIONS(9124), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9126), 1,
      anon_sym_POUND,
    STATE(1280), 1,
      sym__type,
    STATE(1400), 1,
      sym__static_type_identifier,
    STATE(1518), 1,
      sym_long_identifier,
    STATE(1526), 1,
      sym_type_argument,
    ACTIONS(9128), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5652), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1527), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [97571] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4898), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9130), 1,
      anon_sym_LPAREN,
    ACTIONS(9132), 1,
      anon_sym__,
    ACTIONS(9134), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9136), 1,
      anon_sym_POUND,
    STATE(2350), 1,
      sym__type,
    STATE(2560), 1,
      sym__static_type_identifier,
    STATE(2665), 1,
      sym_long_identifier,
    STATE(2666), 1,
      sym_type_argument,
    ACTIONS(9138), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5653), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2670), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [97643] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6492), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9140), 1,
      anon_sym_LPAREN,
    ACTIONS(9142), 1,
      anon_sym__,
    ACTIONS(9144), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9146), 1,
      anon_sym_POUND,
    STATE(3995), 1,
      sym__static_type_identifier,
    STATE(3998), 1,
      sym__type,
    STATE(4009), 1,
      sym_type_argument,
    STATE(4015), 1,
      sym_long_identifier,
    ACTIONS(9148), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5654), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4021), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [97715] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(7985), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5655), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [97787] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3650), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9120), 1,
      anon_sym_LPAREN,
    ACTIONS(9122), 1,
      anon_sym__,
    ACTIONS(9124), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9126), 1,
      anon_sym_POUND,
    STATE(1251), 1,
      sym__type,
    STATE(1400), 1,
      sym__static_type_identifier,
    STATE(1518), 1,
      sym_long_identifier,
    STATE(1526), 1,
      sym_type_argument,
    ACTIONS(9128), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5656), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1527), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [97859] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(7940), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5657), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [97931] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9150), 1,
      sym_identifier,
    ACTIONS(9152), 1,
      anon_sym_LPAREN,
    ACTIONS(9154), 1,
      anon_sym__,
    ACTIONS(9156), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9158), 1,
      anon_sym_POUND,
    STATE(6537), 1,
      sym__type,
    STATE(6637), 1,
      sym__static_type_identifier,
    STATE(7067), 1,
      sym_type_argument,
    STATE(7156), 1,
      sym_long_identifier,
    ACTIONS(9160), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5658), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7166), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [98003] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3592), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9162), 1,
      anon_sym_LPAREN,
    ACTIONS(9164), 1,
      anon_sym__,
    ACTIONS(9166), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9168), 1,
      anon_sym_POUND,
    STATE(1235), 1,
      sym__type,
    STATE(1290), 1,
      sym__static_type_identifier,
    STATE(1440), 1,
      sym_long_identifier,
    STATE(1441), 1,
      sym_type_argument,
    ACTIONS(9170), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5659), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1444), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [98075] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8101), 1,
      anon_sym_LPAREN,
    ACTIONS(8103), 1,
      anon_sym__,
    ACTIONS(8105), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8107), 1,
      anon_sym_POUND,
    ACTIONS(8887), 1,
      sym_identifier,
    STATE(5464), 1,
      sym__static_type_identifier,
    STATE(5487), 1,
      sym__type,
    STATE(5618), 1,
      sym_type_argument,
    STATE(6164), 1,
      sym_long_identifier,
    ACTIONS(8109), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5660), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6161), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [98147] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5661), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3543), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3541), 12,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [98201] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8113), 1,
      anon_sym_LPAREN,
    ACTIONS(8115), 1,
      anon_sym__,
    ACTIONS(8117), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8119), 1,
      anon_sym_POUND,
    ACTIONS(8871), 1,
      sym_identifier,
    STATE(5397), 1,
      sym__type,
    STATE(5463), 1,
      sym__static_type_identifier,
    STATE(5566), 1,
      sym_type_argument,
    STATE(6046), 1,
      sym_long_identifier,
    ACTIONS(8121), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5662), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5996), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [98273] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3592), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9162), 1,
      anon_sym_LPAREN,
    ACTIONS(9164), 1,
      anon_sym__,
    ACTIONS(9166), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9168), 1,
      anon_sym_POUND,
    STATE(1241), 1,
      sym__type,
    STATE(1290), 1,
      sym__static_type_identifier,
    STATE(1440), 1,
      sym_long_identifier,
    STATE(1441), 1,
      sym_type_argument,
    ACTIONS(9170), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5663), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1444), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [98345] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3592), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9162), 1,
      anon_sym_LPAREN,
    ACTIONS(9164), 1,
      anon_sym__,
    ACTIONS(9166), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9168), 1,
      anon_sym_POUND,
    STATE(1239), 1,
      sym__type,
    STATE(1290), 1,
      sym__static_type_identifier,
    STATE(1440), 1,
      sym_long_identifier,
    STATE(1441), 1,
      sym_type_argument,
    ACTIONS(9170), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5664), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1444), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [98417] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9172), 1,
      sym_identifier,
    ACTIONS(9174), 1,
      anon_sym_LPAREN,
    ACTIONS(9176), 1,
      anon_sym__,
    ACTIONS(9178), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9180), 1,
      anon_sym_POUND,
    STATE(6963), 1,
      sym__type,
    STATE(7022), 1,
      sym__static_type_identifier,
    STATE(7217), 1,
      sym_type_argument,
    STATE(7507), 1,
      sym_long_identifier,
    ACTIONS(9182), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5665), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7514), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [98489] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9184), 1,
      sym_identifier,
    ACTIONS(9186), 1,
      anon_sym_LPAREN,
    ACTIONS(9188), 1,
      anon_sym__,
    ACTIONS(9190), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9192), 1,
      anon_sym_POUND,
    STATE(6653), 1,
      sym__type,
    STATE(6768), 1,
      sym__static_type_identifier,
    STATE(7163), 1,
      sym_type_argument,
    STATE(7261), 1,
      sym_long_identifier,
    ACTIONS(9194), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5666), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7250), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [98561] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3664), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9196), 1,
      anon_sym_LPAREN,
    ACTIONS(9198), 1,
      anon_sym__,
    ACTIONS(9200), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9202), 1,
      anon_sym_POUND,
    STATE(1255), 1,
      sym__type,
    STATE(1449), 1,
      sym__static_type_identifier,
    STATE(1497), 1,
      sym_long_identifier,
    STATE(1500), 1,
      sym_type_argument,
    ACTIONS(9204), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5667), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1503), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [98633] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3664), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9196), 1,
      anon_sym_LPAREN,
    ACTIONS(9198), 1,
      anon_sym__,
    ACTIONS(9200), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9202), 1,
      anon_sym_POUND,
    STATE(1270), 1,
      sym__type,
    STATE(1449), 1,
      sym__static_type_identifier,
    STATE(1497), 1,
      sym_long_identifier,
    STATE(1500), 1,
      sym_type_argument,
    ACTIONS(9204), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5668), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1503), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [98705] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3664), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9196), 1,
      anon_sym_LPAREN,
    ACTIONS(9198), 1,
      anon_sym__,
    ACTIONS(9200), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9202), 1,
      anon_sym_POUND,
    STATE(1275), 1,
      sym__type,
    STATE(1449), 1,
      sym__static_type_identifier,
    STATE(1497), 1,
      sym_long_identifier,
    STATE(1500), 1,
      sym_type_argument,
    ACTIONS(9204), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5669), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1503), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [98777] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9150), 1,
      sym_identifier,
    ACTIONS(9152), 1,
      anon_sym_LPAREN,
    ACTIONS(9154), 1,
      anon_sym__,
    ACTIONS(9156), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9158), 1,
      anon_sym_POUND,
    STATE(6572), 1,
      sym__type,
    STATE(6637), 1,
      sym__static_type_identifier,
    STATE(7067), 1,
      sym_type_argument,
    STATE(7156), 1,
      sym_long_identifier,
    ACTIONS(9160), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5670), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7166), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [98849] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8101), 1,
      anon_sym_LPAREN,
    ACTIONS(8103), 1,
      anon_sym__,
    ACTIONS(8105), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8107), 1,
      anon_sym_POUND,
    ACTIONS(8887), 1,
      sym_identifier,
    STATE(5464), 1,
      sym__static_type_identifier,
    STATE(5491), 1,
      sym__type,
    STATE(5618), 1,
      sym_type_argument,
    STATE(6164), 1,
      sym_long_identifier,
    ACTIONS(8109), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5671), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6161), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [98921] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5672), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3547), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3545), 12,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [98975] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9206), 1,
      sym_identifier,
    ACTIONS(9208), 1,
      anon_sym_LPAREN,
    ACTIONS(9210), 1,
      anon_sym__,
    ACTIONS(9212), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9214), 1,
      anon_sym_POUND,
    STATE(7782), 1,
      sym__static_type_identifier,
    STATE(7847), 1,
      sym__type,
    STATE(8321), 1,
      sym_type_argument,
    STATE(8479), 1,
      sym_long_identifier,
    ACTIONS(9216), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5673), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(8478), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [99047] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7292), 1,
      sym_identifier,
    ACTIONS(9218), 1,
      anon_sym_LPAREN,
    ACTIONS(9220), 1,
      anon_sym__,
    ACTIONS(9222), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9224), 1,
      anon_sym_POUND,
    STATE(4381), 1,
      sym__static_type_identifier,
    STATE(4384), 1,
      sym__type,
    STATE(4516), 1,
      sym_type_argument,
    STATE(4654), 1,
      sym_long_identifier,
    ACTIONS(9226), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5674), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4639), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [99119] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8101), 1,
      anon_sym_LPAREN,
    ACTIONS(8103), 1,
      anon_sym__,
    ACTIONS(8105), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8107), 1,
      anon_sym_POUND,
    ACTIONS(8887), 1,
      sym_identifier,
    STATE(5464), 1,
      sym__static_type_identifier,
    STATE(5494), 1,
      sym__type,
    STATE(5618), 1,
      sym_type_argument,
    STATE(6164), 1,
      sym_long_identifier,
    ACTIONS(8109), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5675), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6161), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [99191] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7292), 1,
      sym_identifier,
    ACTIONS(9218), 1,
      anon_sym_LPAREN,
    ACTIONS(9220), 1,
      anon_sym__,
    ACTIONS(9222), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9224), 1,
      anon_sym_POUND,
    STATE(4381), 1,
      sym__static_type_identifier,
    STATE(4395), 1,
      sym__type,
    STATE(4516), 1,
      sym_type_argument,
    STATE(4654), 1,
      sym_long_identifier,
    ACTIONS(9226), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5676), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4639), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [99263] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7373), 1,
      sym_identifier,
    ACTIONS(9228), 1,
      anon_sym_LPAREN,
    ACTIONS(9230), 1,
      anon_sym__,
    ACTIONS(9232), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9234), 1,
      anon_sym_POUND,
    STATE(4408), 1,
      sym__type,
    STATE(4477), 1,
      sym__static_type_identifier,
    STATE(4622), 1,
      sym_type_argument,
    STATE(4703), 1,
      sym_long_identifier,
    ACTIONS(9236), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5677), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [99335] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7292), 1,
      sym_identifier,
    ACTIONS(9218), 1,
      anon_sym_LPAREN,
    ACTIONS(9220), 1,
      anon_sym__,
    ACTIONS(9222), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9224), 1,
      anon_sym_POUND,
    STATE(4381), 1,
      sym__static_type_identifier,
    STATE(4399), 1,
      sym__type,
    STATE(4516), 1,
      sym_type_argument,
    STATE(4654), 1,
      sym_long_identifier,
    ACTIONS(9226), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5678), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4639), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [99407] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6492), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9140), 1,
      anon_sym_LPAREN,
    ACTIONS(9142), 1,
      anon_sym__,
    ACTIONS(9144), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9146), 1,
      anon_sym_POUND,
    STATE(3994), 1,
      sym__type,
    STATE(3995), 1,
      sym__static_type_identifier,
    STATE(4009), 1,
      sym_type_argument,
    STATE(4015), 1,
      sym_long_identifier,
    ACTIONS(9148), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5679), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4021), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [99479] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4553), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9238), 1,
      anon_sym_LPAREN,
    ACTIONS(9240), 1,
      anon_sym__,
    ACTIONS(9242), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9244), 1,
      anon_sym_POUND,
    STATE(2208), 1,
      sym__static_type_identifier,
    STATE(2254), 1,
      sym_long_identifier,
    STATE(2255), 1,
      sym_type_argument,
    STATE(2500), 1,
      sym__type,
    ACTIONS(9246), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5680), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2258), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [99551] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7292), 1,
      sym_identifier,
    ACTIONS(9218), 1,
      anon_sym_LPAREN,
    ACTIONS(9220), 1,
      anon_sym__,
    ACTIONS(9222), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9224), 1,
      anon_sym_POUND,
    STATE(4356), 1,
      sym__type,
    STATE(4381), 1,
      sym__static_type_identifier,
    STATE(4516), 1,
      sym_type_argument,
    STATE(4654), 1,
      sym_long_identifier,
    ACTIONS(9226), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5681), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4639), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [99623] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8145), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5682), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [99695] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8138), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5683), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [99767] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6492), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9140), 1,
      anon_sym_LPAREN,
    ACTIONS(9142), 1,
      anon_sym__,
    ACTIONS(9144), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9146), 1,
      anon_sym_POUND,
    STATE(3993), 1,
      sym__type,
    STATE(3995), 1,
      sym__static_type_identifier,
    STATE(4009), 1,
      sym_type_argument,
    STATE(4015), 1,
      sym_long_identifier,
    ACTIONS(9148), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5684), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4021), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [99839] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8132), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5685), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [99911] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9248), 1,
      sym_identifier,
    ACTIONS(9250), 1,
      anon_sym_LPAREN,
    ACTIONS(9252), 1,
      anon_sym__,
    ACTIONS(9254), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9256), 1,
      anon_sym_POUND,
    STATE(6499), 1,
      sym__type,
    STATE(6690), 1,
      sym__static_type_identifier,
    STATE(7044), 1,
      sym_type_argument,
    STATE(7140), 1,
      sym_long_identifier,
    ACTIONS(9258), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5686), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7138), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [99983] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6492), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9140), 1,
      anon_sym_LPAREN,
    ACTIONS(9142), 1,
      anon_sym__,
    ACTIONS(9144), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9146), 1,
      anon_sym_POUND,
    STATE(3992), 1,
      sym__type,
    STATE(3995), 1,
      sym__static_type_identifier,
    STATE(4009), 1,
      sym_type_argument,
    STATE(4015), 1,
      sym_long_identifier,
    ACTIONS(9148), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5687), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4021), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [100055] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6492), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9140), 1,
      anon_sym_LPAREN,
    ACTIONS(9142), 1,
      anon_sym__,
    ACTIONS(9144), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9146), 1,
      anon_sym_POUND,
    STATE(3990), 1,
      sym__type,
    STATE(3995), 1,
      sym__static_type_identifier,
    STATE(4009), 1,
      sym_type_argument,
    STATE(4015), 1,
      sym_long_identifier,
    ACTIONS(9148), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5688), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4021), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [100127] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7411), 1,
      sym_identifier,
    ACTIONS(9260), 1,
      anon_sym_LPAREN,
    ACTIONS(9262), 1,
      anon_sym__,
    ACTIONS(9264), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9266), 1,
      anon_sym_POUND,
    STATE(4433), 1,
      sym__type,
    STATE(4457), 1,
      sym__static_type_identifier,
    STATE(4603), 1,
      sym_type_argument,
    STATE(4737), 1,
      sym_long_identifier,
    ACTIONS(9268), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5689), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4709), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [100199] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9206), 1,
      sym_identifier,
    ACTIONS(9208), 1,
      anon_sym_LPAREN,
    ACTIONS(9210), 1,
      anon_sym__,
    ACTIONS(9212), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9214), 1,
      anon_sym_POUND,
    STATE(7703), 1,
      sym__type,
    STATE(7782), 1,
      sym__static_type_identifier,
    STATE(8321), 1,
      sym_type_argument,
    STATE(8479), 1,
      sym_long_identifier,
    ACTIONS(9216), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5690), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(8478), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [100271] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7411), 1,
      sym_identifier,
    ACTIONS(9260), 1,
      anon_sym_LPAREN,
    ACTIONS(9262), 1,
      anon_sym__,
    ACTIONS(9264), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9266), 1,
      anon_sym_POUND,
    STATE(4457), 1,
      sym__static_type_identifier,
    STATE(4461), 1,
      sym__type,
    STATE(4603), 1,
      sym_type_argument,
    STATE(4737), 1,
      sym_long_identifier,
    ACTIONS(9268), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5691), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4709), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [100343] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7411), 1,
      sym_identifier,
    ACTIONS(9260), 1,
      anon_sym_LPAREN,
    ACTIONS(9262), 1,
      anon_sym__,
    ACTIONS(9264), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9266), 1,
      anon_sym_POUND,
    STATE(4457), 1,
      sym__static_type_identifier,
    STATE(4467), 1,
      sym__type,
    STATE(4603), 1,
      sym_type_argument,
    STATE(4737), 1,
      sym_long_identifier,
    ACTIONS(9268), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5692), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4709), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [100415] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7411), 1,
      sym_identifier,
    ACTIONS(9260), 1,
      anon_sym_LPAREN,
    ACTIONS(9262), 1,
      anon_sym__,
    ACTIONS(9264), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9266), 1,
      anon_sym_POUND,
    STATE(4427), 1,
      sym__type,
    STATE(4457), 1,
      sym__static_type_identifier,
    STATE(4603), 1,
      sym_type_argument,
    STATE(4737), 1,
      sym_long_identifier,
    ACTIONS(9268), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5693), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4709), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [100487] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8079), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5694), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [100559] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(7978), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5695), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [100631] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8104), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5696), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [100703] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4553), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9238), 1,
      anon_sym_LPAREN,
    ACTIONS(9240), 1,
      anon_sym__,
    ACTIONS(9242), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9244), 1,
      anon_sym_POUND,
    STATE(1645), 1,
      sym__type,
    STATE(2208), 1,
      sym__static_type_identifier,
    STATE(2254), 1,
      sym_long_identifier,
    STATE(2255), 1,
      sym_type_argument,
    ACTIONS(9246), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5697), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2258), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [100775] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8113), 1,
      anon_sym_LPAREN,
    ACTIONS(8115), 1,
      anon_sym__,
    ACTIONS(8117), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8119), 1,
      anon_sym_POUND,
    ACTIONS(8871), 1,
      sym_identifier,
    STATE(5463), 1,
      sym__static_type_identifier,
    STATE(5535), 1,
      sym__type,
    STATE(5566), 1,
      sym_type_argument,
    STATE(6046), 1,
      sym_long_identifier,
    ACTIONS(8121), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5698), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5996), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [100847] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4553), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9238), 1,
      anon_sym_LPAREN,
    ACTIONS(9240), 1,
      anon_sym__,
    ACTIONS(9242), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9244), 1,
      anon_sym_POUND,
    STATE(1637), 1,
      sym__type,
    STATE(2208), 1,
      sym__static_type_identifier,
    STATE(2254), 1,
      sym_long_identifier,
    STATE(2255), 1,
      sym_type_argument,
    ACTIONS(9246), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5699), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2258), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [100919] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4553), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9238), 1,
      anon_sym_LPAREN,
    ACTIONS(9240), 1,
      anon_sym__,
    ACTIONS(9242), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9244), 1,
      anon_sym_POUND,
    STATE(1610), 1,
      sym__type,
    STATE(2208), 1,
      sym__static_type_identifier,
    STATE(2254), 1,
      sym_long_identifier,
    STATE(2255), 1,
      sym_type_argument,
    ACTIONS(9246), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5700), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2258), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [100991] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9150), 1,
      sym_identifier,
    ACTIONS(9152), 1,
      anon_sym_LPAREN,
    ACTIONS(9154), 1,
      anon_sym__,
    ACTIONS(9156), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9158), 1,
      anon_sym_POUND,
    STATE(6552), 1,
      sym__type,
    STATE(6637), 1,
      sym__static_type_identifier,
    STATE(7067), 1,
      sym_type_argument,
    STATE(7156), 1,
      sym_long_identifier,
    ACTIONS(9160), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5701), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7166), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [101063] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9150), 1,
      sym_identifier,
    ACTIONS(9152), 1,
      anon_sym_LPAREN,
    ACTIONS(9154), 1,
      anon_sym__,
    ACTIONS(9156), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9158), 1,
      anon_sym_POUND,
    STATE(6548), 1,
      sym__type,
    STATE(6637), 1,
      sym__static_type_identifier,
    STATE(7067), 1,
      sym_type_argument,
    STATE(7156), 1,
      sym_long_identifier,
    ACTIONS(9160), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5702), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7166), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [101135] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9150), 1,
      sym_identifier,
    ACTIONS(9152), 1,
      anon_sym_LPAREN,
    ACTIONS(9154), 1,
      anon_sym__,
    ACTIONS(9156), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9158), 1,
      anon_sym_POUND,
    STATE(6546), 1,
      sym__type,
    STATE(6637), 1,
      sym__static_type_identifier,
    STATE(7067), 1,
      sym_type_argument,
    STATE(7156), 1,
      sym_long_identifier,
    ACTIONS(9160), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5703), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7166), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [101207] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9150), 1,
      sym_identifier,
    ACTIONS(9152), 1,
      anon_sym_LPAREN,
    ACTIONS(9154), 1,
      anon_sym__,
    ACTIONS(9156), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9158), 1,
      anon_sym_POUND,
    STATE(6633), 1,
      sym__type,
    STATE(6637), 1,
      sym__static_type_identifier,
    STATE(7067), 1,
      sym_type_argument,
    STATE(7156), 1,
      sym_long_identifier,
    ACTIONS(9160), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5704), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7166), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [101279] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8027), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5705), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [101351] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8033), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5706), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [101423] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7240), 1,
      sym_identifier,
    ACTIONS(9270), 1,
      anon_sym_LPAREN,
    ACTIONS(9272), 1,
      anon_sym__,
    ACTIONS(9274), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9276), 1,
      anon_sym_POUND,
    STATE(4342), 1,
      sym__static_type_identifier,
    STATE(4345), 1,
      sym__type,
    STATE(4432), 1,
      sym_type_argument,
    STATE(4514), 1,
      sym_long_identifier,
    ACTIONS(9278), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5707), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4519), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [101495] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8180), 1,
      anon_sym_LPAREN,
    ACTIONS(8182), 1,
      anon_sym__,
    ACTIONS(8184), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8186), 1,
      anon_sym_POUND,
    ACTIONS(8794), 1,
      sym_identifier,
    STATE(5363), 1,
      sym__static_type_identifier,
    STATE(5372), 1,
      sym__type,
    STATE(5552), 1,
      sym_type_argument,
    STATE(5597), 1,
      sym_long_identifier,
    ACTIONS(8188), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5708), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5568), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [101567] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8071), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5709), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [101639] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3716), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9280), 1,
      anon_sym_LPAREN,
    ACTIONS(9282), 1,
      anon_sym__,
    ACTIONS(9284), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9286), 1,
      anon_sym_POUND,
    STATE(1265), 1,
      sym__type,
    STATE(1420), 1,
      sym__static_type_identifier,
    STATE(1501), 1,
      sym_long_identifier,
    STATE(1513), 1,
      sym_type_argument,
    ACTIONS(9288), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5710), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1515), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [101711] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8180), 1,
      anon_sym_LPAREN,
    ACTIONS(8182), 1,
      anon_sym__,
    ACTIONS(8184), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8186), 1,
      anon_sym_POUND,
    ACTIONS(8794), 1,
      sym_identifier,
    STATE(5363), 1,
      sym__static_type_identifier,
    STATE(5375), 1,
      sym__type,
    STATE(5552), 1,
      sym_type_argument,
    STATE(5597), 1,
      sym_long_identifier,
    ACTIONS(8188), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5711), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5568), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [101783] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8113), 1,
      anon_sym_LPAREN,
    ACTIONS(8115), 1,
      anon_sym__,
    ACTIONS(8117), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8119), 1,
      anon_sym_POUND,
    ACTIONS(8871), 1,
      sym_identifier,
    STATE(5463), 1,
      sym__static_type_identifier,
    STATE(5495), 1,
      sym__type,
    STATE(5566), 1,
      sym_type_argument,
    STATE(6046), 1,
      sym_long_identifier,
    ACTIONS(8121), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5712), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5996), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [101855] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7240), 1,
      sym_identifier,
    ACTIONS(9270), 1,
      anon_sym_LPAREN,
    ACTIONS(9272), 1,
      anon_sym__,
    ACTIONS(9274), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9276), 1,
      anon_sym_POUND,
    STATE(4342), 1,
      sym__static_type_identifier,
    STATE(4350), 1,
      sym__type,
    STATE(4432), 1,
      sym_type_argument,
    STATE(4514), 1,
      sym_long_identifier,
    ACTIONS(9278), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5713), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4519), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [101927] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7240), 1,
      sym_identifier,
    ACTIONS(9270), 1,
      anon_sym_LPAREN,
    ACTIONS(9272), 1,
      anon_sym__,
    ACTIONS(9274), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9276), 1,
      anon_sym_POUND,
    STATE(4342), 1,
      sym__static_type_identifier,
    STATE(4353), 1,
      sym__type,
    STATE(4432), 1,
      sym_type_argument,
    STATE(4514), 1,
      sym_long_identifier,
    ACTIONS(9278), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5714), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4519), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [101999] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8180), 1,
      anon_sym_LPAREN,
    ACTIONS(8182), 1,
      anon_sym__,
    ACTIONS(8184), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8186), 1,
      anon_sym_POUND,
    ACTIONS(8794), 1,
      sym_identifier,
    STATE(5363), 1,
      sym__static_type_identifier,
    STATE(5385), 1,
      sym__type,
    STATE(5552), 1,
      sym_type_argument,
    STATE(5597), 1,
      sym_long_identifier,
    ACTIONS(8188), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5715), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5568), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [102071] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7240), 1,
      sym_identifier,
    ACTIONS(9270), 1,
      anon_sym_LPAREN,
    ACTIONS(9272), 1,
      anon_sym__,
    ACTIONS(9274), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9276), 1,
      anon_sym_POUND,
    STATE(4338), 1,
      sym__type,
    STATE(4342), 1,
      sym__static_type_identifier,
    STATE(4432), 1,
      sym_type_argument,
    STATE(4514), 1,
      sym_long_identifier,
    ACTIONS(9278), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5716), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4519), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [102143] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7240), 1,
      sym_identifier,
    ACTIONS(9270), 1,
      anon_sym_LPAREN,
    ACTIONS(9272), 1,
      anon_sym__,
    ACTIONS(9274), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9276), 1,
      anon_sym_POUND,
    STATE(4339), 1,
      sym__type,
    STATE(4342), 1,
      sym__static_type_identifier,
    STATE(4432), 1,
      sym_type_argument,
    STATE(4514), 1,
      sym_long_identifier,
    ACTIONS(9278), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5717), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4519), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [102215] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9290), 1,
      sym_identifier,
    ACTIONS(9292), 1,
      anon_sym_LPAREN,
    ACTIONS(9294), 1,
      anon_sym__,
    ACTIONS(9296), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9298), 1,
      anon_sym_POUND,
    STATE(6632), 1,
      sym__static_type_identifier,
    STATE(6820), 1,
      sym__type,
    STATE(6949), 1,
      sym_type_argument,
    STATE(7089), 1,
      sym_long_identifier,
    ACTIONS(9300), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5718), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7154), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [102287] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8197), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5719), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [102359] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7240), 1,
      sym_identifier,
    ACTIONS(9270), 1,
      anon_sym_LPAREN,
    ACTIONS(9272), 1,
      anon_sym__,
    ACTIONS(9274), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9276), 1,
      anon_sym_POUND,
    STATE(4342), 1,
      sym__static_type_identifier,
    STATE(4349), 1,
      sym__type,
    STATE(4432), 1,
      sym_type_argument,
    STATE(4514), 1,
      sym_long_identifier,
    ACTIONS(9278), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5720), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4519), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [102431] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8133), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5721), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [102503] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9302), 1,
      sym_identifier,
    ACTIONS(9304), 1,
      anon_sym_LPAREN,
    ACTIONS(9306), 1,
      anon_sym__,
    ACTIONS(9308), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9310), 1,
      anon_sym_POUND,
    STATE(8034), 1,
      sym__type,
    STATE(8177), 1,
      sym__static_type_identifier,
    STATE(8520), 1,
      sym_type_argument,
    STATE(8580), 1,
      sym_long_identifier,
    ACTIONS(9312), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5722), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(8581), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [102575] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5379), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8085), 1,
      anon_sym_LPAREN,
    ACTIONS(8087), 1,
      anon_sym__,
    ACTIONS(8089), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8091), 1,
      anon_sym_POUND,
    STATE(3174), 1,
      sym__static_type_identifier,
    STATE(3470), 1,
      sym__type,
    STATE(3579), 1,
      sym_type_argument,
    STATE(3606), 1,
      sym_long_identifier,
    ACTIONS(8093), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5723), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3611), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [102647] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9302), 1,
      sym_identifier,
    ACTIONS(9304), 1,
      anon_sym_LPAREN,
    ACTIONS(9306), 1,
      anon_sym__,
    ACTIONS(9308), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9310), 1,
      anon_sym_POUND,
    STATE(8025), 1,
      sym__type,
    STATE(8177), 1,
      sym__static_type_identifier,
    STATE(8520), 1,
      sym_type_argument,
    STATE(8580), 1,
      sym_long_identifier,
    ACTIONS(9312), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5724), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(8581), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [102719] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8390), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5725), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [102791] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8296), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5726), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [102863] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5727), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9314), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(9316), 12,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [102917] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8180), 1,
      anon_sym_LPAREN,
    ACTIONS(8182), 1,
      anon_sym__,
    ACTIONS(8184), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8186), 1,
      anon_sym_POUND,
    ACTIONS(8794), 1,
      sym_identifier,
    STATE(5363), 1,
      sym__static_type_identifier,
    STATE(5389), 1,
      sym__type,
    STATE(5552), 1,
      sym_type_argument,
    STATE(5597), 1,
      sym_long_identifier,
    ACTIONS(8188), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5728), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5568), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [102989] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8113), 1,
      anon_sym_LPAREN,
    ACTIONS(8115), 1,
      anon_sym__,
    ACTIONS(8117), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8119), 1,
      anon_sym_POUND,
    ACTIONS(8871), 1,
      sym_identifier,
    STATE(5463), 1,
      sym__static_type_identifier,
    STATE(5489), 1,
      sym__type,
    STATE(5566), 1,
      sym_type_argument,
    STATE(6046), 1,
      sym_long_identifier,
    ACTIONS(8121), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5729), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5996), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [103061] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9302), 1,
      sym_identifier,
    ACTIONS(9304), 1,
      anon_sym_LPAREN,
    ACTIONS(9306), 1,
      anon_sym__,
    ACTIONS(9308), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9310), 1,
      anon_sym_POUND,
    STATE(7967), 1,
      sym__type,
    STATE(8177), 1,
      sym__static_type_identifier,
    STATE(8520), 1,
      sym_type_argument,
    STATE(8580), 1,
      sym_long_identifier,
    ACTIONS(9312), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5730), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(8581), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [103133] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9302), 1,
      sym_identifier,
    ACTIONS(9304), 1,
      anon_sym_LPAREN,
    ACTIONS(9306), 1,
      anon_sym__,
    ACTIONS(9308), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9310), 1,
      anon_sym_POUND,
    STATE(8121), 1,
      sym__type,
    STATE(8177), 1,
      sym__static_type_identifier,
    STATE(8520), 1,
      sym_type_argument,
    STATE(8580), 1,
      sym_long_identifier,
    ACTIONS(9312), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5731), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(8581), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [103205] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(7797), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5732), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [103277] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8042), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5733), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [103349] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8090), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5734), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [103421] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8202), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5735), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [103493] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9290), 1,
      sym_identifier,
    ACTIONS(9292), 1,
      anon_sym_LPAREN,
    ACTIONS(9294), 1,
      anon_sym__,
    ACTIONS(9296), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9298), 1,
      anon_sym_POUND,
    STATE(6632), 1,
      sym__static_type_identifier,
    STATE(6745), 1,
      sym__type,
    STATE(6949), 1,
      sym_type_argument,
    STATE(7089), 1,
      sym_long_identifier,
    ACTIONS(9300), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5736), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7154), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [103565] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8238), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5737), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [103637] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7796), 1,
      aux_sym_decimal_token1,
    ACTIONS(8023), 1,
      anon_sym_f,
    STATE(5738), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3193), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3191), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [103695] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7324), 1,
      sym_identifier,
    ACTIONS(9318), 1,
      anon_sym_LPAREN,
    ACTIONS(9320), 1,
      anon_sym__,
    ACTIONS(9322), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9324), 1,
      anon_sym_POUND,
    STATE(4357), 1,
      sym__type,
    STATE(4361), 1,
      sym__static_type_identifier,
    STATE(4496), 1,
      sym_type_argument,
    STATE(4668), 1,
      sym_long_identifier,
    ACTIONS(9326), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5739), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4674), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [103767] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8180), 1,
      anon_sym_LPAREN,
    ACTIONS(8182), 1,
      anon_sym__,
    ACTIONS(8184), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8186), 1,
      anon_sym_POUND,
    ACTIONS(8794), 1,
      sym_identifier,
    STATE(5363), 1,
      sym__static_type_identifier,
    STATE(5370), 1,
      sym__type,
    STATE(5552), 1,
      sym_type_argument,
    STATE(5597), 1,
      sym_long_identifier,
    ACTIONS(8188), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5740), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5568), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [103839] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7324), 1,
      sym_identifier,
    ACTIONS(9318), 1,
      anon_sym_LPAREN,
    ACTIONS(9320), 1,
      anon_sym__,
    ACTIONS(9322), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9324), 1,
      anon_sym_POUND,
    STATE(4361), 1,
      sym__static_type_identifier,
    STATE(4391), 1,
      sym__type,
    STATE(4496), 1,
      sym_type_argument,
    STATE(4668), 1,
      sym_long_identifier,
    ACTIONS(9326), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5741), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4674), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [103911] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6866), 1,
      anon_sym_LPAREN,
    ACTIONS(6868), 1,
      anon_sym__,
    ACTIONS(6874), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6880), 1,
      anon_sym_POUND,
    ACTIONS(9328), 1,
      sym_identifier,
    STATE(6214), 1,
      sym__static_type_identifier,
    STATE(6240), 1,
      sym__type,
    STATE(6488), 1,
      sym_type_argument,
    STATE(6600), 1,
      sym_long_identifier,
    ACTIONS(6882), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5742), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6550), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [103983] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6866), 1,
      anon_sym_LPAREN,
    ACTIONS(6868), 1,
      anon_sym__,
    ACTIONS(6874), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6880), 1,
      anon_sym_POUND,
    ACTIONS(9328), 1,
      sym_identifier,
    STATE(6214), 1,
      sym__static_type_identifier,
    STATE(6270), 1,
      sym__type,
    STATE(6488), 1,
      sym_type_argument,
    STATE(6600), 1,
      sym_long_identifier,
    ACTIONS(6882), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5743), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6550), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [104055] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6866), 1,
      anon_sym_LPAREN,
    ACTIONS(6868), 1,
      anon_sym__,
    ACTIONS(6874), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6880), 1,
      anon_sym_POUND,
    ACTIONS(9328), 1,
      sym_identifier,
    STATE(6214), 1,
      sym__static_type_identifier,
    STATE(6271), 1,
      sym__type,
    STATE(6488), 1,
      sym_type_argument,
    STATE(6600), 1,
      sym_long_identifier,
    ACTIONS(6882), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5744), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6550), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [104127] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6560), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7723), 1,
      anon_sym_LPAREN,
    ACTIONS(7725), 1,
      anon_sym__,
    ACTIONS(7727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(7729), 1,
      anon_sym_POUND,
    STATE(4035), 1,
      sym__type,
    STATE(4038), 1,
      sym__static_type_identifier,
    STATE(4159), 1,
      sym_type_argument,
    STATE(4192), 1,
      sym_long_identifier,
    ACTIONS(7731), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5745), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4190), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [104199] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6866), 1,
      anon_sym_LPAREN,
    ACTIONS(6868), 1,
      anon_sym__,
    ACTIONS(6874), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6880), 1,
      anon_sym_POUND,
    ACTIONS(9328), 1,
      sym_identifier,
    STATE(6214), 1,
      sym__static_type_identifier,
    STATE(6296), 1,
      sym__type,
    STATE(6488), 1,
      sym_type_argument,
    STATE(6600), 1,
      sym_long_identifier,
    ACTIONS(6882), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5746), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6550), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [104271] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8120), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5747), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [104343] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8069), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5748), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [104415] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8113), 1,
      anon_sym_LPAREN,
    ACTIONS(8115), 1,
      anon_sym__,
    ACTIONS(8117), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8119), 1,
      anon_sym_POUND,
    ACTIONS(8871), 1,
      sym_identifier,
    STATE(5463), 1,
      sym__static_type_identifier,
    STATE(5500), 1,
      sym__type,
    STATE(5566), 1,
      sym_type_argument,
    STATE(6046), 1,
      sym_long_identifier,
    ACTIONS(8121), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5749), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5996), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [104487] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7230), 1,
      sym__type,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5750), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [104559] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(7977), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5751), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [104631] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8195), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5752), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [104703] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8292), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5753), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [104775] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8198), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5754), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [104847] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8260), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5755), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [104919] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8222), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5756), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [104991] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4798), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9330), 1,
      anon_sym_LPAREN,
    ACTIONS(9332), 1,
      anon_sym__,
    ACTIONS(9334), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9336), 1,
      anon_sym_POUND,
    STATE(2267), 1,
      sym__type,
    STATE(2354), 1,
      sym__static_type_identifier,
    STATE(2499), 1,
      sym_type_argument,
    STATE(2503), 1,
      sym_long_identifier,
    ACTIONS(9338), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5757), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2483), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [105063] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8067), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5758), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [105135] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8167), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5759), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [105207] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7250), 1,
      sym_identifier,
    ACTIONS(9340), 1,
      anon_sym_LPAREN,
    ACTIONS(9342), 1,
      anon_sym__,
    ACTIONS(9344), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9346), 1,
      anon_sym_POUND,
    STATE(4402), 1,
      sym__static_type_identifier,
    STATE(4531), 1,
      sym__type,
    STATE(4538), 1,
      sym_type_argument,
    STATE(4634), 1,
      sym_long_identifier,
    ACTIONS(9348), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5760), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4619), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [105279] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8099), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5761), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [105351] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8101), 1,
      anon_sym_LPAREN,
    ACTIONS(8103), 1,
      anon_sym__,
    ACTIONS(8105), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8107), 1,
      anon_sym_POUND,
    ACTIONS(8887), 1,
      sym_identifier,
    STATE(5412), 1,
      sym__type,
    STATE(5464), 1,
      sym__static_type_identifier,
    STATE(5618), 1,
      sym_type_argument,
    STATE(6164), 1,
      sym_long_identifier,
    ACTIONS(8109), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5762), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6161), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [105423] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8113), 1,
      anon_sym_LPAREN,
    ACTIONS(8115), 1,
      anon_sym__,
    ACTIONS(8117), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8119), 1,
      anon_sym_POUND,
    ACTIONS(8871), 1,
      sym_identifier,
    STATE(5463), 1,
      sym__static_type_identifier,
    STATE(5508), 1,
      sym__type,
    STATE(5566), 1,
      sym_type_argument,
    STATE(6046), 1,
      sym_long_identifier,
    ACTIONS(8121), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5763), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5996), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [105495] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8101), 1,
      anon_sym_LPAREN,
    ACTIONS(8103), 1,
      anon_sym__,
    ACTIONS(8105), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8107), 1,
      anon_sym_POUND,
    ACTIONS(8887), 1,
      sym_identifier,
    STATE(5464), 1,
      sym__static_type_identifier,
    STATE(5465), 1,
      sym__type,
    STATE(5618), 1,
      sym_type_argument,
    STATE(6164), 1,
      sym_long_identifier,
    ACTIONS(8109), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5764), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6161), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [105567] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4874), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9350), 1,
      anon_sym_LPAREN,
    ACTIONS(9352), 1,
      anon_sym__,
    ACTIONS(9354), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9356), 1,
      anon_sym_POUND,
    STATE(2325), 1,
      sym__type,
    STATE(2569), 1,
      sym__static_type_identifier,
    STATE(2615), 1,
      sym_long_identifier,
    STATE(2708), 1,
      sym_type_argument,
    ACTIONS(9358), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5765), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2710), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [105639] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8037), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5766), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [105711] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8158), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5767), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [105783] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8169), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5768), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [105855] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8000), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5769), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [105927] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8101), 1,
      anon_sym_LPAREN,
    ACTIONS(8103), 1,
      anon_sym__,
    ACTIONS(8105), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8107), 1,
      anon_sym_POUND,
    ACTIONS(8887), 1,
      sym_identifier,
    STATE(5464), 1,
      sym__static_type_identifier,
    STATE(5467), 1,
      sym__type,
    STATE(5618), 1,
      sym_type_argument,
    STATE(6164), 1,
      sym_long_identifier,
    ACTIONS(8109), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5770), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6161), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [105999] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8101), 1,
      anon_sym_LPAREN,
    ACTIONS(8103), 1,
      anon_sym__,
    ACTIONS(8105), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8107), 1,
      anon_sym_POUND,
    ACTIONS(8887), 1,
      sym_identifier,
    STATE(5464), 1,
      sym__static_type_identifier,
    STATE(5468), 1,
      sym__type,
    STATE(5618), 1,
      sym_type_argument,
    STATE(6164), 1,
      sym_long_identifier,
    ACTIONS(8109), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5771), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6161), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [106071] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8266), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5772), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [106143] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8101), 1,
      anon_sym_LPAREN,
    ACTIONS(8103), 1,
      anon_sym__,
    ACTIONS(8105), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8107), 1,
      anon_sym_POUND,
    ACTIONS(8887), 1,
      sym_identifier,
    STATE(5464), 1,
      sym__static_type_identifier,
    STATE(5471), 1,
      sym__type,
    STATE(5618), 1,
      sym_type_argument,
    STATE(6164), 1,
      sym_long_identifier,
    ACTIONS(8109), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5773), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6161), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [106215] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5379), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8085), 1,
      anon_sym_LPAREN,
    ACTIONS(8087), 1,
      anon_sym__,
    ACTIONS(8089), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8091), 1,
      anon_sym_POUND,
    STATE(3036), 1,
      sym__type,
    STATE(3174), 1,
      sym__static_type_identifier,
    STATE(3579), 1,
      sym_type_argument,
    STATE(3606), 1,
      sym_long_identifier,
    ACTIONS(8093), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5774), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3611), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [106287] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(7964), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5775), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [106359] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5379), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8085), 1,
      anon_sym_LPAREN,
    ACTIONS(8087), 1,
      anon_sym__,
    ACTIONS(8089), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8091), 1,
      anon_sym_POUND,
    STATE(2974), 1,
      sym__type,
    STATE(3174), 1,
      sym__static_type_identifier,
    STATE(3579), 1,
      sym_type_argument,
    STATE(3606), 1,
      sym_long_identifier,
    ACTIONS(8093), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5776), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3611), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [106431] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5379), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8085), 1,
      anon_sym_LPAREN,
    ACTIONS(8087), 1,
      anon_sym__,
    ACTIONS(8089), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8091), 1,
      anon_sym_POUND,
    STATE(3000), 1,
      sym__type,
    STATE(3174), 1,
      sym__static_type_identifier,
    STATE(3579), 1,
      sym_type_argument,
    STATE(3606), 1,
      sym_long_identifier,
    ACTIONS(8093), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5777), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3611), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [106503] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5379), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8085), 1,
      anon_sym_LPAREN,
    ACTIONS(8087), 1,
      anon_sym__,
    ACTIONS(8089), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8091), 1,
      anon_sym_POUND,
    STATE(2970), 1,
      sym__type,
    STATE(3174), 1,
      sym__static_type_identifier,
    STATE(3579), 1,
      sym_type_argument,
    STATE(3606), 1,
      sym_long_identifier,
    ACTIONS(8093), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5778), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3611), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [106575] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8105), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5779), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [106647] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8057), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5780), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [106719] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5781), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9360), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(9362), 12,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [106773] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8118), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5782), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [106845] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9184), 1,
      sym_identifier,
    ACTIONS(9186), 1,
      anon_sym_LPAREN,
    ACTIONS(9188), 1,
      anon_sym__,
    ACTIONS(9190), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9192), 1,
      anon_sym_POUND,
    STATE(6768), 1,
      sym__static_type_identifier,
    STATE(6859), 1,
      sym__type,
    STATE(7163), 1,
      sym_type_argument,
    STATE(7261), 1,
      sym_long_identifier,
    ACTIONS(9194), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5783), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7250), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [106917] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9184), 1,
      sym_identifier,
    ACTIONS(9186), 1,
      anon_sym_LPAREN,
    ACTIONS(9188), 1,
      anon_sym__,
    ACTIONS(9190), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9192), 1,
      anon_sym_POUND,
    STATE(6768), 1,
      sym__static_type_identifier,
    STATE(6833), 1,
      sym__type,
    STATE(7163), 1,
      sym_type_argument,
    STATE(7261), 1,
      sym_long_identifier,
    ACTIONS(9194), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5784), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7250), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [106989] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9364), 1,
      sym_identifier,
    ACTIONS(9366), 1,
      anon_sym_LPAREN,
    ACTIONS(9368), 1,
      anon_sym__,
    ACTIONS(9370), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9372), 1,
      anon_sym_POUND,
    STATE(6884), 1,
      sym__static_type_identifier,
    STATE(6922), 1,
      sym__type,
    STATE(7122), 1,
      sym_type_argument,
    STATE(7339), 1,
      sym_long_identifier,
    ACTIONS(9374), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5785), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7289), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [107061] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9364), 1,
      sym_identifier,
    ACTIONS(9366), 1,
      anon_sym_LPAREN,
    ACTIONS(9368), 1,
      anon_sym__,
    ACTIONS(9370), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9372), 1,
      anon_sym_POUND,
    STATE(6853), 1,
      sym__type,
    STATE(6884), 1,
      sym__static_type_identifier,
    STATE(7122), 1,
      sym_type_argument,
    STATE(7339), 1,
      sym_long_identifier,
    ACTIONS(9374), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5786), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7289), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [107133] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8131), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5787), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [107205] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9184), 1,
      sym_identifier,
    ACTIONS(9186), 1,
      anon_sym_LPAREN,
    ACTIONS(9188), 1,
      anon_sym__,
    ACTIONS(9190), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9192), 1,
      anon_sym_POUND,
    STATE(6768), 1,
      sym__static_type_identifier,
    STATE(6823), 1,
      sym__type,
    STATE(7163), 1,
      sym_type_argument,
    STATE(7261), 1,
      sym_long_identifier,
    ACTIONS(9194), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5788), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7250), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [107277] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9364), 1,
      sym_identifier,
    ACTIONS(9366), 1,
      anon_sym_LPAREN,
    ACTIONS(9368), 1,
      anon_sym__,
    ACTIONS(9370), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9372), 1,
      anon_sym_POUND,
    STATE(6858), 1,
      sym__type,
    STATE(6884), 1,
      sym__static_type_identifier,
    STATE(7122), 1,
      sym_type_argument,
    STATE(7339), 1,
      sym_long_identifier,
    ACTIONS(9374), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5789), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7289), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [107349] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4526), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9376), 1,
      anon_sym_LPAREN,
    ACTIONS(9378), 1,
      anon_sym__,
    ACTIONS(9380), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9382), 1,
      anon_sym_POUND,
    STATE(1654), 1,
      sym__type,
    STATE(2127), 1,
      sym__static_type_identifier,
    STATE(2228), 1,
      sym_type_argument,
    STATE(2246), 1,
      sym_long_identifier,
    ACTIONS(9384), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5790), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2253), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [107421] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4526), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9376), 1,
      anon_sym_LPAREN,
    ACTIONS(9378), 1,
      anon_sym__,
    ACTIONS(9380), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9382), 1,
      anon_sym_POUND,
    STATE(1653), 1,
      sym__type,
    STATE(2127), 1,
      sym__static_type_identifier,
    STATE(2228), 1,
      sym_type_argument,
    STATE(2246), 1,
      sym_long_identifier,
    ACTIONS(9384), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5791), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2253), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [107493] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5792), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9386), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(9388), 12,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [107547] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9364), 1,
      sym_identifier,
    ACTIONS(9366), 1,
      anon_sym_LPAREN,
    ACTIONS(9368), 1,
      anon_sym__,
    ACTIONS(9370), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9372), 1,
      anon_sym_POUND,
    STATE(6810), 1,
      sym__type,
    STATE(6884), 1,
      sym__static_type_identifier,
    STATE(7122), 1,
      sym_type_argument,
    STATE(7339), 1,
      sym_long_identifier,
    ACTIONS(9374), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5793), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7289), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [107619] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8134), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5794), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [107691] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8029), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5795), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [107763] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8028), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5796), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [107835] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5797), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3537), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3539), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [107889] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4526), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9376), 1,
      anon_sym_LPAREN,
    ACTIONS(9378), 1,
      anon_sym__,
    ACTIONS(9380), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9382), 1,
      anon_sym_POUND,
    STATE(1601), 1,
      sym__type,
    STATE(2127), 1,
      sym__static_type_identifier,
    STATE(2228), 1,
      sym_type_argument,
    STATE(2246), 1,
      sym_long_identifier,
    ACTIONS(9384), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5798), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2253), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [107961] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9184), 1,
      sym_identifier,
    ACTIONS(9186), 1,
      anon_sym_LPAREN,
    ACTIONS(9188), 1,
      anon_sym__,
    ACTIONS(9190), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9192), 1,
      anon_sym_POUND,
    STATE(6768), 1,
      sym__static_type_identifier,
    STATE(6892), 1,
      sym__type,
    STATE(7163), 1,
      sym_type_argument,
    STATE(7261), 1,
      sym_long_identifier,
    ACTIONS(9194), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5799), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7250), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [108033] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8178), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5800), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [108105] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7409), 1,
      sym_identifier,
    ACTIONS(9390), 1,
      anon_sym_LPAREN,
    ACTIONS(9392), 1,
      anon_sym__,
    ACTIONS(9394), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9396), 1,
      anon_sym_POUND,
    STATE(4413), 1,
      sym__static_type_identifier,
    STATE(4475), 1,
      sym__type,
    STATE(4624), 1,
      sym_type_argument,
    STATE(4751), 1,
      sym_long_identifier,
    ACTIONS(9398), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5801), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4757), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [108177] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(7891), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5802), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [108249] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8201), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5803), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [108321] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8144), 1,
      anon_sym_LPAREN,
    ACTIONS(8146), 1,
      anon_sym__,
    ACTIONS(8148), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8150), 1,
      anon_sym_POUND,
    ACTIONS(9400), 1,
      sym_identifier,
    STATE(6273), 1,
      sym__static_type_identifier,
    STATE(6376), 1,
      sym__type,
    STATE(6417), 1,
      sym_type_argument,
    STATE(6603), 1,
      sym_long_identifier,
    ACTIONS(8152), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5804), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6604), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [108393] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7411), 1,
      sym_identifier,
    ACTIONS(9260), 1,
      anon_sym_LPAREN,
    ACTIONS(9262), 1,
      anon_sym__,
    ACTIONS(9264), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9266), 1,
      anon_sym_POUND,
    STATE(4457), 1,
      sym__static_type_identifier,
    STATE(4474), 1,
      sym__type,
    STATE(4603), 1,
      sym_type_argument,
    STATE(4737), 1,
      sym_long_identifier,
    ACTIONS(9268), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5805), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4709), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [108465] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7411), 1,
      sym_identifier,
    ACTIONS(9260), 1,
      anon_sym_LPAREN,
    ACTIONS(9262), 1,
      anon_sym__,
    ACTIONS(9264), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9266), 1,
      anon_sym_POUND,
    STATE(4457), 1,
      sym__static_type_identifier,
    STATE(4473), 1,
      sym__type,
    STATE(4603), 1,
      sym_type_argument,
    STATE(4737), 1,
      sym_long_identifier,
    ACTIONS(9268), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5806), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4709), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [108537] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3710), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9402), 1,
      anon_sym_LPAREN,
    ACTIONS(9404), 1,
      anon_sym__,
    ACTIONS(9406), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9408), 1,
      anon_sym_POUND,
    STATE(1271), 1,
      sym__type,
    STATE(1421), 1,
      sym__static_type_identifier,
    STATE(1540), 1,
      sym_long_identifier,
    STATE(1550), 1,
      sym_type_argument,
    ACTIONS(9410), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5807), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1538), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [108609] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9412), 1,
      sym_int,
    STATE(5808), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3753), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(3751), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [108665] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3710), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9402), 1,
      anon_sym_LPAREN,
    ACTIONS(9404), 1,
      anon_sym__,
    ACTIONS(9406), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9408), 1,
      anon_sym_POUND,
    STATE(1260), 1,
      sym__type,
    STATE(1421), 1,
      sym__static_type_identifier,
    STATE(1540), 1,
      sym_long_identifier,
    STATE(1550), 1,
      sym_type_argument,
    ACTIONS(9410), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5809), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1538), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [108737] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5810), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3541), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3543), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [108791] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3710), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9402), 1,
      anon_sym_LPAREN,
    ACTIONS(9404), 1,
      anon_sym__,
    ACTIONS(9406), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9408), 1,
      anon_sym_POUND,
    STATE(1259), 1,
      sym__type,
    STATE(1421), 1,
      sym__static_type_identifier,
    STATE(1540), 1,
      sym_long_identifier,
    STATE(1550), 1,
      sym_type_argument,
    ACTIONS(9410), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5811), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1538), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [108863] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8144), 1,
      anon_sym_LPAREN,
    ACTIONS(8146), 1,
      anon_sym__,
    ACTIONS(8148), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8150), 1,
      anon_sym_POUND,
    ACTIONS(9400), 1,
      sym_identifier,
    STATE(6273), 1,
      sym__static_type_identifier,
    STATE(6329), 1,
      sym__type,
    STATE(6417), 1,
      sym_type_argument,
    STATE(6603), 1,
      sym_long_identifier,
    ACTIONS(8152), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5812), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6604), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [108935] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8200), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5813), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [109007] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9364), 1,
      sym_identifier,
    ACTIONS(9366), 1,
      anon_sym_LPAREN,
    ACTIONS(9368), 1,
      anon_sym__,
    ACTIONS(9370), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9372), 1,
      anon_sym_POUND,
    STATE(6765), 1,
      sym__type,
    STATE(6884), 1,
      sym__static_type_identifier,
    STATE(7122), 1,
      sym_type_argument,
    STATE(7339), 1,
      sym_long_identifier,
    ACTIONS(9374), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5814), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7289), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [109079] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7409), 1,
      sym_identifier,
    ACTIONS(9390), 1,
      anon_sym_LPAREN,
    ACTIONS(9392), 1,
      anon_sym__,
    ACTIONS(9394), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9396), 1,
      anon_sym_POUND,
    STATE(4413), 1,
      sym__static_type_identifier,
    STATE(4471), 1,
      sym__type,
    STATE(4624), 1,
      sym_type_argument,
    STATE(4751), 1,
      sym_long_identifier,
    ACTIONS(9398), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5815), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4757), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [109151] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(5816), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9414), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(9416), 12,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [109205] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8144), 1,
      anon_sym_LPAREN,
    ACTIONS(8146), 1,
      anon_sym__,
    ACTIONS(8148), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8150), 1,
      anon_sym_POUND,
    ACTIONS(9400), 1,
      sym_identifier,
    STATE(6273), 1,
      sym__static_type_identifier,
    STATE(6357), 1,
      sym__type,
    STATE(6417), 1,
      sym_type_argument,
    STATE(6603), 1,
      sym_long_identifier,
    ACTIONS(8152), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5817), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6604), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [109277] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8106), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5818), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [109349] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5819), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3545), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3547), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [109403] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9364), 1,
      sym_identifier,
    ACTIONS(9366), 1,
      anon_sym_LPAREN,
    ACTIONS(9368), 1,
      anon_sym__,
    ACTIONS(9370), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9372), 1,
      anon_sym_POUND,
    STATE(6805), 1,
      sym__type,
    STATE(6884), 1,
      sym__static_type_identifier,
    STATE(7122), 1,
      sym_type_argument,
    STATE(7339), 1,
      sym_long_identifier,
    ACTIONS(9374), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5820), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7289), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [109475] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8231), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5821), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [109547] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5379), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8085), 1,
      anon_sym_LPAREN,
    ACTIONS(8087), 1,
      anon_sym__,
    ACTIONS(8089), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8091), 1,
      anon_sym_POUND,
    STATE(3174), 1,
      sym__static_type_identifier,
    STATE(3496), 1,
      sym__type,
    STATE(3579), 1,
      sym_type_argument,
    STATE(3606), 1,
      sym_long_identifier,
    ACTIONS(8093), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5822), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3611), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [109619] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8144), 1,
      anon_sym_LPAREN,
    ACTIONS(8146), 1,
      anon_sym__,
    ACTIONS(8148), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8150), 1,
      anon_sym_POUND,
    ACTIONS(9400), 1,
      sym_identifier,
    STATE(6273), 1,
      sym__static_type_identifier,
    STATE(6335), 1,
      sym__type,
    STATE(6417), 1,
      sym_type_argument,
    STATE(6603), 1,
      sym_long_identifier,
    ACTIONS(8152), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5823), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6604), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [109691] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8261), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5824), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [109763] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8240), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5825), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [109835] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4870), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9418), 1,
      anon_sym_LPAREN,
    ACTIONS(9420), 1,
      anon_sym__,
    ACTIONS(9422), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9424), 1,
      anon_sym_POUND,
    STATE(2303), 1,
      sym__type,
    STATE(2601), 1,
      sym__static_type_identifier,
    STATE(2696), 1,
      sym_type_argument,
    STATE(2698), 1,
      sym_long_identifier,
    ACTIONS(9426), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5826), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2691), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [109907] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8038), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5827), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [109979] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8144), 1,
      anon_sym_LPAREN,
    ACTIONS(8146), 1,
      anon_sym__,
    ACTIONS(8148), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8150), 1,
      anon_sym_POUND,
    ACTIONS(9400), 1,
      sym_identifier,
    STATE(6273), 1,
      sym__static_type_identifier,
    STATE(6372), 1,
      sym__type,
    STATE(6417), 1,
      sym_type_argument,
    STATE(6603), 1,
      sym_long_identifier,
    ACTIONS(8152), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5828), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6604), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [110051] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8219), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5829), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [110123] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7409), 1,
      sym_identifier,
    ACTIONS(9390), 1,
      anon_sym_LPAREN,
    ACTIONS(9392), 1,
      anon_sym__,
    ACTIONS(9394), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9396), 1,
      anon_sym_POUND,
    STATE(4413), 1,
      sym__static_type_identifier,
    STATE(4459), 1,
      sym__type,
    STATE(4624), 1,
      sym_type_argument,
    STATE(4751), 1,
      sym_long_identifier,
    ACTIONS(9398), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5830), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4757), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [110195] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8063), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5831), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [110267] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8211), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5832), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [110339] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7409), 1,
      sym_identifier,
    ACTIONS(9390), 1,
      anon_sym_LPAREN,
    ACTIONS(9392), 1,
      anon_sym__,
    ACTIONS(9394), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9396), 1,
      anon_sym_POUND,
    STATE(4413), 1,
      sym__static_type_identifier,
    STATE(4424), 1,
      sym__type,
    STATE(4624), 1,
      sym_type_argument,
    STATE(4751), 1,
      sym_long_identifier,
    ACTIONS(9398), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5833), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4757), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [110411] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8141), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5834), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [110483] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9428), 1,
      sym_identifier,
    ACTIONS(9430), 1,
      anon_sym_LPAREN,
    ACTIONS(9432), 1,
      anon_sym__,
    ACTIONS(9434), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9436), 1,
      anon_sym_POUND,
    STATE(6767), 1,
      sym__static_type_identifier,
    STATE(6897), 1,
      sym__type,
    STATE(7165), 1,
      sym_type_argument,
    STATE(7251), 1,
      sym_long_identifier,
    ACTIONS(9438), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5835), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7247), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [110555] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8174), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5836), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [110627] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8029), 1,
      anon_sym_LPAREN,
    ACTIONS(8031), 1,
      anon_sym__,
    ACTIONS(8033), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8035), 1,
      anon_sym_POUND,
    ACTIONS(8909), 1,
      sym_identifier,
    STATE(5421), 1,
      sym__type,
    STATE(5475), 1,
      sym__static_type_identifier,
    STATE(5630), 1,
      sym_type_argument,
    STATE(6183), 1,
      sym_long_identifier,
    ACTIONS(8037), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5837), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6184), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [110699] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8112), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5838), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [110771] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7649), 1,
      sym__type,
    STATE(7708), 1,
      sym_long_identifier,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5839), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [110843] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8003), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5840), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [110915] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8009), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5841), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [110987] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8024), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5842), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [111059] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8012), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5843), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [111131] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7324), 1,
      sym_identifier,
    ACTIONS(9318), 1,
      anon_sym_LPAREN,
    ACTIONS(9320), 1,
      anon_sym__,
    ACTIONS(9322), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9324), 1,
      anon_sym_POUND,
    STATE(4361), 1,
      sym__static_type_identifier,
    STATE(4383), 1,
      sym__type,
    STATE(4496), 1,
      sym_type_argument,
    STATE(4668), 1,
      sym_long_identifier,
    ACTIONS(9326), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5844), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4674), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [111203] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8097), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5845), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [111275] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7324), 1,
      sym_identifier,
    ACTIONS(9318), 1,
      anon_sym_LPAREN,
    ACTIONS(9320), 1,
      anon_sym__,
    ACTIONS(9322), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9324), 1,
      anon_sym_POUND,
    STATE(4361), 1,
      sym__static_type_identifier,
    STATE(4387), 1,
      sym__type,
    STATE(4496), 1,
      sym_type_argument,
    STATE(4668), 1,
      sym_long_identifier,
    ACTIONS(9326), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5846), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4674), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [111347] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8117), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5847), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [111419] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7292), 1,
      sym_identifier,
    ACTIONS(9218), 1,
      anon_sym_LPAREN,
    ACTIONS(9220), 1,
      anon_sym__,
    ACTIONS(9222), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9224), 1,
      anon_sym_POUND,
    STATE(4360), 1,
      sym__type,
    STATE(4381), 1,
      sym__static_type_identifier,
    STATE(4516), 1,
      sym_type_argument,
    STATE(4654), 1,
      sym_long_identifier,
    ACTIONS(9226), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5848), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4639), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [111491] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7292), 1,
      sym_identifier,
    ACTIONS(9218), 1,
      anon_sym_LPAREN,
    ACTIONS(9220), 1,
      anon_sym__,
    ACTIONS(9222), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9224), 1,
      anon_sym_POUND,
    STATE(4362), 1,
      sym__type,
    STATE(4381), 1,
      sym__static_type_identifier,
    STATE(4516), 1,
      sym_type_argument,
    STATE(4654), 1,
      sym_long_identifier,
    ACTIONS(9226), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5849), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4639), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [111563] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9440), 1,
      sym_identifier,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym__,
    ACTIONS(9446), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9448), 1,
      anon_sym_POUND,
    STATE(6541), 1,
      sym__type,
    STATE(6689), 1,
      sym__static_type_identifier,
    STATE(6942), 1,
      sym_type_argument,
    STATE(7119), 1,
      sym_long_identifier,
    ACTIONS(9450), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5850), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7153), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [111635] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9440), 1,
      sym_identifier,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym__,
    ACTIONS(9446), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9448), 1,
      anon_sym_POUND,
    STATE(6598), 1,
      sym__type,
    STATE(6689), 1,
      sym__static_type_identifier,
    STATE(6942), 1,
      sym_type_argument,
    STATE(7119), 1,
      sym_long_identifier,
    ACTIONS(9450), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5851), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7153), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [111707] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9440), 1,
      sym_identifier,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym__,
    ACTIONS(9446), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9448), 1,
      anon_sym_POUND,
    STATE(6631), 1,
      sym__type,
    STATE(6689), 1,
      sym__static_type_identifier,
    STATE(6942), 1,
      sym_type_argument,
    STATE(7119), 1,
      sym_long_identifier,
    ACTIONS(9450), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5852), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7153), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [111779] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9440), 1,
      sym_identifier,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym__,
    ACTIONS(9446), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9448), 1,
      anon_sym_POUND,
    STATE(6689), 1,
      sym__static_type_identifier,
    STATE(6692), 1,
      sym__type,
    STATE(6942), 1,
      sym_type_argument,
    STATE(7119), 1,
      sym_long_identifier,
    ACTIONS(9450), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5853), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7153), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [111851] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7324), 1,
      sym_identifier,
    ACTIONS(9318), 1,
      anon_sym_LPAREN,
    ACTIONS(9320), 1,
      anon_sym__,
    ACTIONS(9322), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9324), 1,
      anon_sym_POUND,
    STATE(4361), 1,
      sym__static_type_identifier,
    STATE(4389), 1,
      sym__type,
    STATE(4496), 1,
      sym_type_argument,
    STATE(4668), 1,
      sym_long_identifier,
    ACTIONS(9326), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5854), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4674), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [111923] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8212), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5855), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [111995] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8289), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5856), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [112067] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8086), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5857), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [112139] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9452), 1,
      sym_identifier,
    ACTIONS(9454), 1,
      anon_sym_LPAREN,
    ACTIONS(9456), 1,
      anon_sym__,
    ACTIONS(9458), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9460), 1,
      anon_sym_POUND,
    STATE(6525), 1,
      sym__type,
    STATE(6736), 1,
      sym__static_type_identifier,
    STATE(7084), 1,
      sym_type_argument,
    STATE(7161), 1,
      sym_long_identifier,
    ACTIONS(9462), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5858), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7164), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [112211] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9464), 1,
      sym_identifier,
    ACTIONS(9466), 1,
      anon_sym_LPAREN,
    ACTIONS(9468), 1,
      anon_sym__,
    ACTIONS(9470), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9472), 1,
      anon_sym_POUND,
    STATE(6867), 1,
      sym__type,
    STATE(6871), 1,
      sym__static_type_identifier,
    STATE(7181), 1,
      sym_type_argument,
    STATE(7231), 1,
      sym_long_identifier,
    ACTIONS(9474), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5859), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7232), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [112283] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8284), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5860), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [112355] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7324), 1,
      sym_identifier,
    ACTIONS(9318), 1,
      anon_sym_LPAREN,
    ACTIONS(9320), 1,
      anon_sym__,
    ACTIONS(9322), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9324), 1,
      anon_sym_POUND,
    STATE(4359), 1,
      sym__type,
    STATE(4361), 1,
      sym__static_type_identifier,
    STATE(4496), 1,
      sym_type_argument,
    STATE(4668), 1,
      sym_long_identifier,
    ACTIONS(9326), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5861), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4674), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [112427] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8180), 1,
      anon_sym_LPAREN,
    ACTIONS(8182), 1,
      anon_sym__,
    ACTIONS(8184), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8186), 1,
      anon_sym_POUND,
    ACTIONS(8794), 1,
      sym_identifier,
    STATE(5349), 1,
      sym__type,
    STATE(5363), 1,
      sym__static_type_identifier,
    STATE(5552), 1,
      sym_type_argument,
    STATE(5597), 1,
      sym_long_identifier,
    ACTIONS(8188), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5862), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5568), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [112499] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3608), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9476), 1,
      anon_sym_LPAREN,
    ACTIONS(9478), 1,
      anon_sym__,
    ACTIONS(9480), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9482), 1,
      anon_sym_POUND,
    STATE(1240), 1,
      sym__type,
    STATE(1309), 1,
      sym__static_type_identifier,
    STATE(1344), 1,
      sym_long_identifier,
    STATE(1348), 1,
      sym_type_argument,
    ACTIONS(9484), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5863), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1353), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [112571] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8210), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5864), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [112643] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8004), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5865), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [112715] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8192), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5866), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [112787] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3405), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9486), 1,
      anon_sym_LPAREN,
    ACTIONS(9488), 1,
      anon_sym__,
    ACTIONS(9490), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9492), 1,
      anon_sym_POUND,
    STATE(1201), 1,
      sym__type,
    STATE(1212), 1,
      sym__static_type_identifier,
    STATE(1213), 1,
      sym_long_identifier,
    STATE(1215), 1,
      sym_type_argument,
    ACTIONS(9494), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5867), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1228), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [112859] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5379), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8085), 1,
      anon_sym_LPAREN,
    ACTIONS(8087), 1,
      anon_sym__,
    ACTIONS(8089), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8091), 1,
      anon_sym_POUND,
    STATE(3174), 1,
      sym__static_type_identifier,
    STATE(3569), 1,
      sym__type,
    STATE(3579), 1,
      sym_type_argument,
    STATE(3606), 1,
      sym_long_identifier,
    ACTIONS(8093), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5868), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3611), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [112931] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8142), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5869), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [113003] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7308), 1,
      sym__type,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5870), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [113075] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7331), 1,
      sym__type,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5871), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [113147] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9172), 1,
      sym_identifier,
    ACTIONS(9174), 1,
      anon_sym_LPAREN,
    ACTIONS(9176), 1,
      anon_sym__,
    ACTIONS(9178), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9180), 1,
      anon_sym_POUND,
    STATE(6989), 1,
      sym__type,
    STATE(7022), 1,
      sym__static_type_identifier,
    STATE(7217), 1,
      sym_type_argument,
    STATE(7507), 1,
      sym_long_identifier,
    ACTIONS(9182), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5872), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7514), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [113219] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9172), 1,
      sym_identifier,
    ACTIONS(9174), 1,
      anon_sym_LPAREN,
    ACTIONS(9176), 1,
      anon_sym__,
    ACTIONS(9178), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9180), 1,
      anon_sym_POUND,
    STATE(6977), 1,
      sym__type,
    STATE(7022), 1,
      sym__static_type_identifier,
    STATE(7217), 1,
      sym_type_argument,
    STATE(7507), 1,
      sym_long_identifier,
    ACTIONS(9182), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5873), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7514), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [113291] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9172), 1,
      sym_identifier,
    ACTIONS(9174), 1,
      anon_sym_LPAREN,
    ACTIONS(9176), 1,
      anon_sym__,
    ACTIONS(9178), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9180), 1,
      anon_sym_POUND,
    STATE(6971), 1,
      sym__type,
    STATE(7022), 1,
      sym__static_type_identifier,
    STATE(7217), 1,
      sym_type_argument,
    STATE(7507), 1,
      sym_long_identifier,
    ACTIONS(9182), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5874), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7514), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [113363] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9172), 1,
      sym_identifier,
    ACTIONS(9174), 1,
      anon_sym_LPAREN,
    ACTIONS(9176), 1,
      anon_sym__,
    ACTIONS(9178), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9180), 1,
      anon_sym_POUND,
    STATE(6980), 1,
      sym__type,
    STATE(7022), 1,
      sym__static_type_identifier,
    STATE(7217), 1,
      sym_type_argument,
    STATE(7507), 1,
      sym_long_identifier,
    ACTIONS(9182), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5875), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7514), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [113435] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8054), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5876), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [113507] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8276), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5877), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [113579] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8277), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5878), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [113651] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9496), 1,
      sym_identifier,
    ACTIONS(9498), 1,
      anon_sym_LPAREN,
    ACTIONS(9500), 1,
      anon_sym__,
    ACTIONS(9502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9504), 1,
      anon_sym_POUND,
    STATE(6424), 1,
      sym__type,
    STATE(6451), 1,
      sym__static_type_identifier,
    STATE(6924), 1,
      sym_type_argument,
    STATE(6952), 1,
      sym_long_identifier,
    ACTIONS(9506), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5879), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6960), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [113723] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9496), 1,
      sym_identifier,
    ACTIONS(9498), 1,
      anon_sym_LPAREN,
    ACTIONS(9500), 1,
      anon_sym__,
    ACTIONS(9502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9504), 1,
      anon_sym_POUND,
    STATE(6421), 1,
      sym__type,
    STATE(6451), 1,
      sym__static_type_identifier,
    STATE(6924), 1,
      sym_type_argument,
    STATE(6952), 1,
      sym_long_identifier,
    ACTIONS(9506), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5880), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6960), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [113795] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8065), 1,
      anon_sym_LPAREN,
    ACTIONS(8067), 1,
      anon_sym__,
    ACTIONS(8069), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8071), 1,
      anon_sym_POUND,
    ACTIONS(8772), 1,
      sym_identifier,
    STATE(5407), 1,
      sym__static_type_identifier,
    STATE(5419), 1,
      sym__type,
    STATE(5510), 1,
      sym_type_argument,
    STATE(5638), 1,
      sym_long_identifier,
    ACTIONS(8073), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5881), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5590), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [113867] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8218), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5882), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [113939] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9508), 1,
      sym_identifier,
    ACTIONS(9510), 1,
      anon_sym_LPAREN,
    ACTIONS(9512), 1,
      anon_sym__,
    ACTIONS(9514), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9516), 1,
      anon_sym_POUND,
    STATE(7671), 1,
      sym__type,
    STATE(7946), 1,
      sym__static_type_identifier,
    STATE(8427), 1,
      sym_type_argument,
    STATE(8507), 1,
      sym_long_identifier,
    ACTIONS(9518), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5883), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(8500), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [114011] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8168), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5884), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [114083] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8065), 1,
      anon_sym_LPAREN,
    ACTIONS(8067), 1,
      anon_sym__,
    ACTIONS(8069), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8071), 1,
      anon_sym_POUND,
    ACTIONS(8772), 1,
      sym_identifier,
    STATE(5407), 1,
      sym__static_type_identifier,
    STATE(5422), 1,
      sym__type,
    STATE(5510), 1,
      sym_type_argument,
    STATE(5638), 1,
      sym_long_identifier,
    ACTIONS(8073), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5885), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5590), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [114155] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(7736), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5886), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [114227] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4888), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9520), 1,
      anon_sym_LPAREN,
    ACTIONS(9522), 1,
      anon_sym__,
    ACTIONS(9524), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9526), 1,
      anon_sym_POUND,
    STATE(2336), 1,
      sym__type,
    STATE(2564), 1,
      sym__static_type_identifier,
    STATE(2616), 1,
      sym_long_identifier,
    STATE(2677), 1,
      sym_type_argument,
    ACTIONS(9528), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5887), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2688), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [114299] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9496), 1,
      sym_identifier,
    ACTIONS(9498), 1,
      anon_sym_LPAREN,
    ACTIONS(9500), 1,
      anon_sym__,
    ACTIONS(9502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9504), 1,
      anon_sym_POUND,
    STATE(6427), 1,
      sym__type,
    STATE(6451), 1,
      sym__static_type_identifier,
    STATE(6924), 1,
      sym_type_argument,
    STATE(6952), 1,
      sym_long_identifier,
    ACTIONS(9506), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5888), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6960), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [114371] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9290), 1,
      sym_identifier,
    ACTIONS(9292), 1,
      anon_sym_LPAREN,
    ACTIONS(9294), 1,
      anon_sym__,
    ACTIONS(9296), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9298), 1,
      anon_sym_POUND,
    STATE(6632), 1,
      sym__static_type_identifier,
    STATE(6657), 1,
      sym__type,
    STATE(6949), 1,
      sym_type_argument,
    STATE(7089), 1,
      sym_long_identifier,
    ACTIONS(9300), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5889), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7154), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [114443] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9496), 1,
      sym_identifier,
    ACTIONS(9498), 1,
      anon_sym_LPAREN,
    ACTIONS(9500), 1,
      anon_sym__,
    ACTIONS(9502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9504), 1,
      anon_sym_POUND,
    STATE(6449), 1,
      sym__type,
    STATE(6451), 1,
      sym__static_type_identifier,
    STATE(6924), 1,
      sym_type_argument,
    STATE(6952), 1,
      sym_long_identifier,
    ACTIONS(9506), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5890), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6960), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [114515] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8144), 1,
      anon_sym_LPAREN,
    ACTIONS(8146), 1,
      anon_sym__,
    ACTIONS(8148), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8150), 1,
      anon_sym_POUND,
    ACTIONS(9400), 1,
      sym_identifier,
    STATE(6273), 1,
      sym__static_type_identifier,
    STATE(6417), 1,
      sym_type_argument,
    STATE(6603), 1,
      sym_long_identifier,
    STATE(7737), 1,
      sym__type,
    ACTIONS(8152), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5891), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6604), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [114587] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8082), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5892), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [114659] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8065), 1,
      anon_sym_LPAREN,
    ACTIONS(8067), 1,
      anon_sym__,
    ACTIONS(8069), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8071), 1,
      anon_sym_POUND,
    ACTIONS(8772), 1,
      sym_identifier,
    STATE(5407), 1,
      sym__static_type_identifier,
    STATE(5427), 1,
      sym__type,
    STATE(5510), 1,
      sym_type_argument,
    STATE(5638), 1,
      sym_long_identifier,
    ACTIONS(8073), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5893), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5590), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [114731] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9530), 1,
      sym_identifier,
    ACTIONS(9532), 1,
      anon_sym_LPAREN,
    ACTIONS(9534), 1,
      anon_sym__,
    ACTIONS(9536), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9538), 1,
      anon_sym_POUND,
    STATE(6455), 1,
      sym__type,
    STATE(6515), 1,
      sym__static_type_identifier,
    STATE(6914), 1,
      sym_type_argument,
    STATE(7020), 1,
      sym_long_identifier,
    ACTIONS(9540), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5894), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7047), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [114803] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8029), 1,
      anon_sym_LPAREN,
    ACTIONS(8031), 1,
      anon_sym__,
    ACTIONS(8033), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8035), 1,
      anon_sym_POUND,
    ACTIONS(8909), 1,
      sym_identifier,
    STATE(5441), 1,
      sym__type,
    STATE(5475), 1,
      sym__static_type_identifier,
    STATE(5630), 1,
      sym_type_argument,
    STATE(6183), 1,
      sym_long_identifier,
    ACTIONS(8037), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5895), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6184), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [114875] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9530), 1,
      sym_identifier,
    ACTIONS(9532), 1,
      anon_sym_LPAREN,
    ACTIONS(9534), 1,
      anon_sym__,
    ACTIONS(9536), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9538), 1,
      anon_sym_POUND,
    STATE(6440), 1,
      sym__type,
    STATE(6515), 1,
      sym__static_type_identifier,
    STATE(6914), 1,
      sym_type_argument,
    STATE(7020), 1,
      sym_long_identifier,
    ACTIONS(9540), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5896), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7047), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [114947] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9440), 1,
      sym_identifier,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym__,
    ACTIONS(9446), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9448), 1,
      anon_sym_POUND,
    STATE(6669), 1,
      sym__type,
    STATE(6689), 1,
      sym__static_type_identifier,
    STATE(6942), 1,
      sym_type_argument,
    STATE(7119), 1,
      sym_long_identifier,
    ACTIONS(9450), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5897), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7153), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [115019] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3405), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9486), 1,
      anon_sym_LPAREN,
    ACTIONS(9488), 1,
      anon_sym__,
    ACTIONS(9490), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9492), 1,
      anon_sym_POUND,
    STATE(1197), 1,
      sym__type,
    STATE(1212), 1,
      sym__static_type_identifier,
    STATE(1213), 1,
      sym_long_identifier,
    STATE(1215), 1,
      sym_type_argument,
    ACTIONS(9494), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5898), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1228), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [115091] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3405), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9486), 1,
      anon_sym_LPAREN,
    ACTIONS(9488), 1,
      anon_sym__,
    ACTIONS(9490), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9492), 1,
      anon_sym_POUND,
    STATE(1194), 1,
      sym__type,
    STATE(1212), 1,
      sym__static_type_identifier,
    STATE(1213), 1,
      sym_long_identifier,
    STATE(1215), 1,
      sym_type_argument,
    ACTIONS(9494), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5899), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1228), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [115163] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9290), 1,
      sym_identifier,
    ACTIONS(9292), 1,
      anon_sym_LPAREN,
    ACTIONS(9294), 1,
      anon_sym__,
    ACTIONS(9296), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9298), 1,
      anon_sym_POUND,
    STATE(6624), 1,
      sym__type,
    STATE(6632), 1,
      sym__static_type_identifier,
    STATE(6949), 1,
      sym_type_argument,
    STATE(7089), 1,
      sym_long_identifier,
    ACTIONS(9300), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5900), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7154), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [115235] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5901), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3602), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
    ACTIONS(3604), 11,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
  [115289] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9530), 1,
      sym_identifier,
    ACTIONS(9532), 1,
      anon_sym_LPAREN,
    ACTIONS(9534), 1,
      anon_sym__,
    ACTIONS(9536), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9538), 1,
      anon_sym_POUND,
    STATE(6439), 1,
      sym__type,
    STATE(6515), 1,
      sym__static_type_identifier,
    STATE(6914), 1,
      sym_type_argument,
    STATE(7020), 1,
      sym_long_identifier,
    ACTIONS(9540), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5902), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7047), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [115361] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9530), 1,
      sym_identifier,
    ACTIONS(9532), 1,
      anon_sym_LPAREN,
    ACTIONS(9534), 1,
      anon_sym__,
    ACTIONS(9536), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9538), 1,
      anon_sym_POUND,
    STATE(6389), 1,
      sym__type,
    STATE(6515), 1,
      sym__static_type_identifier,
    STATE(6914), 1,
      sym_type_argument,
    STATE(7020), 1,
      sym_long_identifier,
    ACTIONS(9540), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5903), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7047), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [115433] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7250), 1,
      sym_identifier,
    ACTIONS(9340), 1,
      anon_sym_LPAREN,
    ACTIONS(9342), 1,
      anon_sym__,
    ACTIONS(9344), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9346), 1,
      anon_sym_POUND,
    STATE(4341), 1,
      sym__type,
    STATE(4402), 1,
      sym__static_type_identifier,
    STATE(4538), 1,
      sym_type_argument,
    STATE(4634), 1,
      sym_long_identifier,
    ACTIONS(9348), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5904), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4619), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [115505] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9530), 1,
      sym_identifier,
    ACTIONS(9532), 1,
      anon_sym_LPAREN,
    ACTIONS(9534), 1,
      anon_sym__,
    ACTIONS(9536), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9538), 1,
      anon_sym_POUND,
    STATE(6428), 1,
      sym__type,
    STATE(6515), 1,
      sym__static_type_identifier,
    STATE(6914), 1,
      sym_type_argument,
    STATE(7020), 1,
      sym_long_identifier,
    ACTIONS(9540), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5905), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7047), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [115577] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(7983), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5906), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [115649] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8217), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5907), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [115721] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8065), 1,
      anon_sym_LPAREN,
    ACTIONS(8067), 1,
      anon_sym__,
    ACTIONS(8069), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8071), 1,
      anon_sym_POUND,
    ACTIONS(8772), 1,
      sym_identifier,
    STATE(5407), 1,
      sym__static_type_identifier,
    STATE(5432), 1,
      sym__type,
    STATE(5510), 1,
      sym_type_argument,
    STATE(5638), 1,
      sym_long_identifier,
    ACTIONS(8073), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5908), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5590), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [115793] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8060), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5909), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [115865] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3664), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9196), 1,
      anon_sym_LPAREN,
    ACTIONS(9198), 1,
      anon_sym__,
    ACTIONS(9200), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9202), 1,
      anon_sym_POUND,
    STATE(1254), 1,
      sym__type,
    STATE(1449), 1,
      sym__static_type_identifier,
    STATE(1497), 1,
      sym_long_identifier,
    STATE(1500), 1,
      sym_type_argument,
    ACTIONS(9204), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5910), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1503), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [115937] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3405), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9486), 1,
      anon_sym_LPAREN,
    ACTIONS(9488), 1,
      anon_sym__,
    ACTIONS(9490), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9492), 1,
      anon_sym_POUND,
    STATE(1195), 1,
      sym__type,
    STATE(1212), 1,
      sym__static_type_identifier,
    STATE(1213), 1,
      sym_long_identifier,
    STATE(1215), 1,
      sym_type_argument,
    ACTIONS(9494), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5911), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1228), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [116009] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8065), 1,
      anon_sym_LPAREN,
    ACTIONS(8067), 1,
      anon_sym__,
    ACTIONS(8069), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8071), 1,
      anon_sym_POUND,
    ACTIONS(8772), 1,
      sym_identifier,
    STATE(5407), 1,
      sym__static_type_identifier,
    STATE(5436), 1,
      sym__type,
    STATE(5510), 1,
      sym_type_argument,
    STATE(5638), 1,
      sym_long_identifier,
    ACTIONS(8073), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5912), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5590), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [116081] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5379), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8085), 1,
      anon_sym_LPAREN,
    ACTIONS(8087), 1,
      anon_sym__,
    ACTIONS(8089), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8091), 1,
      anon_sym_POUND,
    STATE(2818), 1,
      sym__type,
    STATE(3174), 1,
      sym__static_type_identifier,
    STATE(3579), 1,
      sym_type_argument,
    STATE(3606), 1,
      sym_long_identifier,
    ACTIONS(8093), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5913), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3611), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [116153] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8179), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5914), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [116225] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8103), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5915), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [116297] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8144), 1,
      anon_sym_LPAREN,
    ACTIONS(8146), 1,
      anon_sym__,
    ACTIONS(8148), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8150), 1,
      anon_sym_POUND,
    ACTIONS(9400), 1,
      sym_identifier,
    STATE(6273), 1,
      sym__static_type_identifier,
    STATE(6417), 1,
      sym_type_argument,
    STATE(6603), 1,
      sym_long_identifier,
    STATE(7936), 1,
      sym__type,
    ACTIONS(8152), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5916), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6604), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [116369] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8151), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5917), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [116441] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8263), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5918), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [116513] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(7969), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5919), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [116585] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8036), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5920), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [116657] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7440), 1,
      sym_identifier,
    ACTIONS(9542), 1,
      anon_sym_LPAREN,
    ACTIONS(9544), 1,
      anon_sym__,
    ACTIONS(9546), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9548), 1,
      anon_sym_POUND,
    STATE(4448), 1,
      sym__type,
    STATE(4450), 1,
      sym__static_type_identifier,
    STATE(4659), 1,
      sym_type_argument,
    STATE(4685), 1,
      sym_long_identifier,
    ACTIONS(9550), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5921), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4686), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [116729] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7440), 1,
      sym_identifier,
    ACTIONS(9542), 1,
      anon_sym_LPAREN,
    ACTIONS(9544), 1,
      anon_sym__,
    ACTIONS(9546), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9548), 1,
      anon_sym_POUND,
    STATE(4450), 1,
      sym__static_type_identifier,
    STATE(4482), 1,
      sym__type,
    STATE(4659), 1,
      sym_type_argument,
    STATE(4685), 1,
      sym_long_identifier,
    ACTIONS(9550), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5922), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4686), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [116801] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7440), 1,
      sym_identifier,
    ACTIONS(9542), 1,
      anon_sym_LPAREN,
    ACTIONS(9544), 1,
      anon_sym__,
    ACTIONS(9546), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9548), 1,
      anon_sym_POUND,
    STATE(4450), 1,
      sym__static_type_identifier,
    STATE(4484), 1,
      sym__type,
    STATE(4659), 1,
      sym_type_argument,
    STATE(4685), 1,
      sym_long_identifier,
    ACTIONS(9550), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5923), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4686), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [116873] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8144), 1,
      anon_sym_LPAREN,
    ACTIONS(8146), 1,
      anon_sym__,
    ACTIONS(8148), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8150), 1,
      anon_sym_POUND,
    ACTIONS(9400), 1,
      sym_identifier,
    STATE(6273), 1,
      sym__static_type_identifier,
    STATE(6417), 1,
      sym_type_argument,
    STATE(6603), 1,
      sym_long_identifier,
    STATE(7813), 1,
      sym__type,
    ACTIONS(8152), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5924), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6604), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [116945] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7440), 1,
      sym_identifier,
    ACTIONS(9542), 1,
      anon_sym_LPAREN,
    ACTIONS(9544), 1,
      anon_sym__,
    ACTIONS(9546), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9548), 1,
      anon_sym_POUND,
    STATE(4450), 1,
      sym__static_type_identifier,
    STATE(4453), 1,
      sym__type,
    STATE(4659), 1,
      sym_type_argument,
    STATE(4685), 1,
      sym_long_identifier,
    ACTIONS(9550), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5925), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4686), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [117017] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8176), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5926), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [117089] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9108), 1,
      sym_identifier,
    ACTIONS(9110), 1,
      anon_sym_LPAREN,
    ACTIONS(9112), 1,
      anon_sym__,
    ACTIONS(9114), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9116), 1,
      anon_sym_POUND,
    STATE(6834), 1,
      sym__static_type_identifier,
    STATE(6842), 1,
      sym__type,
    STATE(7121), 1,
      sym_type_argument,
    STATE(7307), 1,
      sym_long_identifier,
    ACTIONS(9118), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5927), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7300), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [117161] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5928), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3537), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3539), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [117215] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(7800), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5929), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [117287] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7329), 1,
      sym__type,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5930), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [117359] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8274), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5931), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [117431] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3592), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9162), 1,
      anon_sym_LPAREN,
    ACTIONS(9164), 1,
      anon_sym__,
    ACTIONS(9166), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9168), 1,
      anon_sym_POUND,
    STATE(1233), 1,
      sym__type,
    STATE(1290), 1,
      sym__static_type_identifier,
    STATE(1440), 1,
      sym_long_identifier,
    STATE(1441), 1,
      sym_type_argument,
    ACTIONS(9170), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5932), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1444), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [117503] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7310), 1,
      sym_identifier,
    ACTIONS(9552), 1,
      anon_sym_LPAREN,
    ACTIONS(9554), 1,
      anon_sym__,
    ACTIONS(9556), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9558), 1,
      anon_sym_POUND,
    STATE(4358), 1,
      sym__type,
    STATE(4400), 1,
      sym__static_type_identifier,
    STATE(4555), 1,
      sym_type_argument,
    STATE(4613), 1,
      sym_long_identifier,
    ACTIONS(9560), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5933), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4611), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [117575] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9108), 1,
      sym_identifier,
    ACTIONS(9110), 1,
      anon_sym_LPAREN,
    ACTIONS(9112), 1,
      anon_sym__,
    ACTIONS(9114), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9116), 1,
      anon_sym_POUND,
    STATE(6834), 1,
      sym__static_type_identifier,
    STATE(6848), 1,
      sym__type,
    STATE(7121), 1,
      sym_type_argument,
    STATE(7307), 1,
      sym_long_identifier,
    ACTIONS(9118), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5934), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7300), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [117647] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(7960), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5935), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [117719] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8065), 1,
      anon_sym_LPAREN,
    ACTIONS(8067), 1,
      anon_sym__,
    ACTIONS(8069), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8071), 1,
      anon_sym_POUND,
    ACTIONS(8772), 1,
      sym_identifier,
    STATE(5337), 1,
      sym__type,
    STATE(5407), 1,
      sym__static_type_identifier,
    STATE(5510), 1,
      sym_type_argument,
    STATE(5638), 1,
      sym_long_identifier,
    ACTIONS(8073), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5936), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5590), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [117791] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8349), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5937), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [117863] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4870), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9418), 1,
      anon_sym_LPAREN,
    ACTIONS(9420), 1,
      anon_sym__,
    ACTIONS(9422), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9424), 1,
      anon_sym_POUND,
    STATE(2356), 1,
      sym__type,
    STATE(2601), 1,
      sym__static_type_identifier,
    STATE(2696), 1,
      sym_type_argument,
    STATE(2698), 1,
      sym_long_identifier,
    ACTIONS(9426), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5938), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2691), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [117935] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8153), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5939), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [118007] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8203), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5940), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [118079] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5941), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3541), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3543), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [118133] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5379), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8085), 1,
      anon_sym_LPAREN,
    ACTIONS(8087), 1,
      anon_sym__,
    ACTIONS(8089), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8091), 1,
      anon_sym_POUND,
    STATE(3174), 1,
      sym__static_type_identifier,
    STATE(3573), 1,
      sym__type,
    STATE(3579), 1,
      sym_type_argument,
    STATE(3606), 1,
      sym_long_identifier,
    ACTIONS(8093), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5942), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3611), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [118205] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9108), 1,
      sym_identifier,
    ACTIONS(9110), 1,
      anon_sym_LPAREN,
    ACTIONS(9112), 1,
      anon_sym__,
    ACTIONS(9114), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9116), 1,
      anon_sym_POUND,
    STATE(6802), 1,
      sym__type,
    STATE(6834), 1,
      sym__static_type_identifier,
    STATE(7121), 1,
      sym_type_argument,
    STATE(7307), 1,
      sym_long_identifier,
    ACTIONS(9118), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5943), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7300), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [118277] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8157), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5944), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [118349] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7250), 1,
      sym_identifier,
    ACTIONS(9340), 1,
      anon_sym_LPAREN,
    ACTIONS(9342), 1,
      anon_sym__,
    ACTIONS(9344), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9346), 1,
      anon_sym_POUND,
    STATE(4373), 1,
      sym__type,
    STATE(4402), 1,
      sym__static_type_identifier,
    STATE(4538), 1,
      sym_type_argument,
    STATE(4634), 1,
      sym_long_identifier,
    ACTIONS(9348), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5945), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4619), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [118421] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7250), 1,
      sym_identifier,
    ACTIONS(9340), 1,
      anon_sym_LPAREN,
    ACTIONS(9342), 1,
      anon_sym__,
    ACTIONS(9344), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9346), 1,
      anon_sym_POUND,
    STATE(4376), 1,
      sym__type,
    STATE(4402), 1,
      sym__static_type_identifier,
    STATE(4538), 1,
      sym_type_argument,
    STATE(4634), 1,
      sym_long_identifier,
    ACTIONS(9348), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5946), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4619), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [118493] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4888), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9520), 1,
      anon_sym_LPAREN,
    ACTIONS(9522), 1,
      anon_sym__,
    ACTIONS(9524), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9526), 1,
      anon_sym_POUND,
    STATE(2338), 1,
      sym__type,
    STATE(2564), 1,
      sym__static_type_identifier,
    STATE(2616), 1,
      sym_long_identifier,
    STATE(2677), 1,
      sym_type_argument,
    ACTIONS(9528), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5947), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2688), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [118565] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4888), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9520), 1,
      anon_sym_LPAREN,
    ACTIONS(9522), 1,
      anon_sym__,
    ACTIONS(9524), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9526), 1,
      anon_sym_POUND,
    STATE(2337), 1,
      sym__type,
    STATE(2564), 1,
      sym__static_type_identifier,
    STATE(2616), 1,
      sym_long_identifier,
    STATE(2677), 1,
      sym_type_argument,
    ACTIONS(9528), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5948), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2688), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [118637] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4888), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9520), 1,
      anon_sym_LPAREN,
    ACTIONS(9522), 1,
      anon_sym__,
    ACTIONS(9524), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9526), 1,
      anon_sym_POUND,
    STATE(2319), 1,
      sym__type,
    STATE(2564), 1,
      sym__static_type_identifier,
    STATE(2616), 1,
      sym_long_identifier,
    STATE(2677), 1,
      sym_type_argument,
    ACTIONS(9528), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5949), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2688), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [118709] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7250), 1,
      sym_identifier,
    ACTIONS(9340), 1,
      anon_sym_LPAREN,
    ACTIONS(9342), 1,
      anon_sym__,
    ACTIONS(9344), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9346), 1,
      anon_sym_POUND,
    STATE(4363), 1,
      sym__type,
    STATE(4402), 1,
      sym__static_type_identifier,
    STATE(4538), 1,
      sym_type_argument,
    STATE(4634), 1,
      sym_long_identifier,
    ACTIONS(9348), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5950), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4619), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [118781] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7250), 1,
      sym_identifier,
    ACTIONS(9340), 1,
      anon_sym_LPAREN,
    ACTIONS(9342), 1,
      anon_sym__,
    ACTIONS(9344), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9346), 1,
      anon_sym_POUND,
    STATE(4369), 1,
      sym__type,
    STATE(4402), 1,
      sym__static_type_identifier,
    STATE(4538), 1,
      sym_type_argument,
    STATE(4634), 1,
      sym_long_identifier,
    ACTIONS(9348), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5951), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4619), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [118853] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8287), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5952), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [118925] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6560), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7723), 1,
      anon_sym_LPAREN,
    ACTIONS(7725), 1,
      anon_sym__,
    ACTIONS(7727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(7729), 1,
      anon_sym_POUND,
    STATE(4038), 1,
      sym__static_type_identifier,
    STATE(4041), 1,
      sym__type,
    STATE(4159), 1,
      sym_type_argument,
    STATE(4192), 1,
      sym_long_identifier,
    ACTIONS(7731), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5953), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4190), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [118997] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5379), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8085), 1,
      anon_sym_LPAREN,
    ACTIONS(8087), 1,
      anon_sym__,
    ACTIONS(8089), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8091), 1,
      anon_sym_POUND,
    STATE(3174), 1,
      sym__static_type_identifier,
    STATE(3516), 1,
      sym__type,
    STATE(3579), 1,
      sym_type_argument,
    STATE(3606), 1,
      sym_long_identifier,
    ACTIONS(8093), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5954), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3611), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [119069] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8013), 1,
      anon_sym_LPAREN,
    ACTIONS(8015), 1,
      anon_sym__,
    ACTIONS(8017), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8019), 1,
      anon_sym_POUND,
    ACTIONS(8806), 1,
      sym_identifier,
    STATE(5402), 1,
      sym__static_type_identifier,
    STATE(5438), 1,
      sym__type,
    STATE(5488), 1,
      sym_type_argument,
    STATE(5627), 1,
      sym_long_identifier,
    ACTIONS(8021), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5955), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5557), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [119141] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8013), 1,
      anon_sym_LPAREN,
    ACTIONS(8015), 1,
      anon_sym__,
    ACTIONS(8017), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8019), 1,
      anon_sym_POUND,
    ACTIONS(8806), 1,
      sym_identifier,
    STATE(5402), 1,
      sym__static_type_identifier,
    STATE(5430), 1,
      sym__type,
    STATE(5488), 1,
      sym_type_argument,
    STATE(5627), 1,
      sym_long_identifier,
    ACTIONS(8021), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5956), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5557), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [119213] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7409), 1,
      sym_identifier,
    ACTIONS(9390), 1,
      anon_sym_LPAREN,
    ACTIONS(9392), 1,
      anon_sym__,
    ACTIONS(9394), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9396), 1,
      anon_sym_POUND,
    STATE(4413), 1,
      sym__static_type_identifier,
    STATE(4416), 1,
      sym__type,
    STATE(4624), 1,
      sym_type_argument,
    STATE(4751), 1,
      sym_long_identifier,
    ACTIONS(9398), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5957), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4757), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [119285] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3650), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9120), 1,
      anon_sym_LPAREN,
    ACTIONS(9122), 1,
      anon_sym__,
    ACTIONS(9124), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9126), 1,
      anon_sym_POUND,
    STATE(1277), 1,
      sym__type,
    STATE(1400), 1,
      sym__static_type_identifier,
    STATE(1518), 1,
      sym_long_identifier,
    STATE(1526), 1,
      sym_type_argument,
    ACTIONS(9128), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5958), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1527), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [119357] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7643), 1,
      sym__type,
    STATE(7708), 1,
      sym_long_identifier,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5959), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [119429] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8013), 1,
      anon_sym_LPAREN,
    ACTIONS(8015), 1,
      anon_sym__,
    ACTIONS(8017), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8019), 1,
      anon_sym_POUND,
    ACTIONS(8806), 1,
      sym_identifier,
    STATE(5402), 1,
      sym__static_type_identifier,
    STATE(5424), 1,
      sym__type,
    STATE(5488), 1,
      sym_type_argument,
    STATE(5627), 1,
      sym_long_identifier,
    ACTIONS(8021), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5960), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5557), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [119501] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7409), 1,
      sym_identifier,
    ACTIONS(9390), 1,
      anon_sym_LPAREN,
    ACTIONS(9392), 1,
      anon_sym__,
    ACTIONS(9394), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9396), 1,
      anon_sym_POUND,
    STATE(4413), 1,
      sym__static_type_identifier,
    STATE(4421), 1,
      sym__type,
    STATE(4624), 1,
      sym_type_argument,
    STATE(4751), 1,
      sym_long_identifier,
    ACTIONS(9398), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5961), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4757), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [119573] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5962), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3545), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3547), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [119627] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7521), 1,
      sym_identifier,
    ACTIONS(9562), 1,
      anon_sym_LPAREN,
    ACTIONS(9564), 1,
      anon_sym__,
    ACTIONS(9566), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9568), 1,
      anon_sym_POUND,
    STATE(4501), 1,
      sym__type,
    STATE(4513), 1,
      sym__static_type_identifier,
    STATE(4728), 1,
      sym_type_argument,
    STATE(4802), 1,
      sym_long_identifier,
    ACTIONS(9570), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5963), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4805), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [119699] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7521), 1,
      sym_identifier,
    ACTIONS(9562), 1,
      anon_sym_LPAREN,
    ACTIONS(9564), 1,
      anon_sym__,
    ACTIONS(9566), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9568), 1,
      anon_sym_POUND,
    STATE(4513), 1,
      sym__static_type_identifier,
    STATE(4542), 1,
      sym__type,
    STATE(4728), 1,
      sym_type_argument,
    STATE(4802), 1,
      sym_long_identifier,
    ACTIONS(9570), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5964), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4805), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [119771] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7521), 1,
      sym_identifier,
    ACTIONS(9562), 1,
      anon_sym_LPAREN,
    ACTIONS(9564), 1,
      anon_sym__,
    ACTIONS(9566), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9568), 1,
      anon_sym_POUND,
    STATE(4513), 1,
      sym__static_type_identifier,
    STATE(4543), 1,
      sym__type,
    STATE(4728), 1,
      sym_type_argument,
    STATE(4802), 1,
      sym_long_identifier,
    ACTIONS(9570), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5965), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4805), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [119843] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7521), 1,
      sym_identifier,
    ACTIONS(9562), 1,
      anon_sym_LPAREN,
    ACTIONS(9564), 1,
      anon_sym__,
    ACTIONS(9566), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9568), 1,
      anon_sym_POUND,
    STATE(4513), 1,
      sym__static_type_identifier,
    STATE(4565), 1,
      sym__type,
    STATE(4728), 1,
      sym_type_argument,
    STATE(4802), 1,
      sym_long_identifier,
    ACTIONS(9570), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5966), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4805), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [119915] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8013), 1,
      anon_sym_LPAREN,
    ACTIONS(8015), 1,
      anon_sym__,
    ACTIONS(8017), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8019), 1,
      anon_sym_POUND,
    ACTIONS(8806), 1,
      sym_identifier,
    STATE(5402), 1,
      sym__static_type_identifier,
    STATE(5470), 1,
      sym__type,
    STATE(5488), 1,
      sym_type_argument,
    STATE(5627), 1,
      sym_long_identifier,
    ACTIONS(8021), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5967), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5557), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [119987] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8283), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5968), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [120059] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6560), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7723), 1,
      anon_sym_LPAREN,
    ACTIONS(7725), 1,
      anon_sym__,
    ACTIONS(7727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(7729), 1,
      anon_sym_POUND,
    STATE(4032), 1,
      sym__type,
    STATE(4038), 1,
      sym__static_type_identifier,
    STATE(4159), 1,
      sym_type_argument,
    STATE(4192), 1,
      sym_long_identifier,
    ACTIONS(7731), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5969), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4190), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [120131] = 24,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3193), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9572), 1,
      anon_sym_y,
    ACTIONS(9574), 1,
      anon_sym_uy,
    ACTIONS(9576), 1,
      anon_sym_s,
    ACTIONS(9578), 1,
      anon_sym_us,
    ACTIONS(9580), 1,
      anon_sym_l,
    ACTIONS(9582), 1,
      aux_sym_uint32_token1,
    ACTIONS(9584), 1,
      anon_sym_n,
    ACTIONS(9586), 1,
      anon_sym_un,
    ACTIONS(9588), 1,
      anon_sym_L,
    ACTIONS(9590), 1,
      aux_sym_uint64_token1,
    ACTIONS(9592), 1,
      aux_sym_bignum_token1,
    ACTIONS(9594), 1,
      aux_sym_decimal_token1,
    ACTIONS(9596), 1,
      anon_sym_DOT2,
    ACTIONS(9598), 1,
      aux_sym_float_token1,
    STATE(5970), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3191), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [120213] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8068), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5971), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [120285] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8013), 1,
      anon_sym_LPAREN,
    ACTIONS(8015), 1,
      anon_sym__,
    ACTIONS(8017), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8019), 1,
      anon_sym_POUND,
    ACTIONS(8806), 1,
      sym_identifier,
    STATE(5402), 1,
      sym__static_type_identifier,
    STATE(5452), 1,
      sym__type,
    STATE(5488), 1,
      sym_type_argument,
    STATE(5627), 1,
      sym_long_identifier,
    ACTIONS(8021), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5972), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5557), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [120357] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6765), 1,
      sym_identifier,
    ACTIONS(9600), 1,
      anon_sym_LPAREN,
    ACTIONS(9602), 1,
      anon_sym__,
    ACTIONS(9604), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9606), 1,
      anon_sym_POUND,
    STATE(580), 1,
      sym__type,
    STATE(4112), 1,
      sym__static_type_identifier,
    STATE(4181), 1,
      sym_type_argument,
    STATE(4200), 1,
      sym_long_identifier,
    ACTIONS(9608), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5973), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4209), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [120429] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9290), 1,
      sym_identifier,
    ACTIONS(9292), 1,
      anon_sym_LPAREN,
    ACTIONS(9294), 1,
      anon_sym__,
    ACTIONS(9296), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9298), 1,
      anon_sym_POUND,
    STATE(6536), 1,
      sym__type,
    STATE(6632), 1,
      sym__static_type_identifier,
    STATE(6949), 1,
      sym_type_argument,
    STATE(7089), 1,
      sym_long_identifier,
    ACTIONS(9300), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5974), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7154), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [120501] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7361), 1,
      sym_identifier,
    ACTIONS(9610), 1,
      anon_sym_LPAREN,
    ACTIONS(9612), 1,
      anon_sym__,
    ACTIONS(9614), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9616), 1,
      anon_sym_POUND,
    STATE(4411), 1,
      sym__static_type_identifier,
    STATE(4456), 1,
      sym__type,
    STATE(4636), 1,
      sym_type_argument,
    STATE(4690), 1,
      sym_long_identifier,
    ACTIONS(9618), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5975), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4691), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [120573] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6560), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7723), 1,
      anon_sym_LPAREN,
    ACTIONS(7725), 1,
      anon_sym__,
    ACTIONS(7727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(7729), 1,
      anon_sym_POUND,
    STATE(4038), 1,
      sym__static_type_identifier,
    STATE(4039), 1,
      sym__type,
    STATE(4159), 1,
      sym_type_argument,
    STATE(4192), 1,
      sym_long_identifier,
    ACTIONS(7731), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5976), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4190), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [120645] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9290), 1,
      sym_identifier,
    ACTIONS(9292), 1,
      anon_sym_LPAREN,
    ACTIONS(9294), 1,
      anon_sym__,
    ACTIONS(9296), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9298), 1,
      anon_sym_POUND,
    STATE(6578), 1,
      sym__type,
    STATE(6632), 1,
      sym__static_type_identifier,
    STATE(6949), 1,
      sym_type_argument,
    STATE(7089), 1,
      sym_long_identifier,
    ACTIONS(9300), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5977), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7154), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [120717] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7361), 1,
      sym_identifier,
    ACTIONS(9610), 1,
      anon_sym_LPAREN,
    ACTIONS(9612), 1,
      anon_sym__,
    ACTIONS(9614), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9616), 1,
      anon_sym_POUND,
    STATE(4411), 1,
      sym__static_type_identifier,
    STATE(4436), 1,
      sym__type,
    STATE(4636), 1,
      sym_type_argument,
    STATE(4690), 1,
      sym_long_identifier,
    ACTIONS(9618), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5978), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4691), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [120789] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7361), 1,
      sym_identifier,
    ACTIONS(9610), 1,
      anon_sym_LPAREN,
    ACTIONS(9612), 1,
      anon_sym__,
    ACTIONS(9614), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9616), 1,
      anon_sym_POUND,
    STATE(4411), 1,
      sym__static_type_identifier,
    STATE(4422), 1,
      sym__type,
    STATE(4636), 1,
      sym_type_argument,
    STATE(4690), 1,
      sym_long_identifier,
    ACTIONS(9618), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5979), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4691), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [120861] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7361), 1,
      sym_identifier,
    ACTIONS(9610), 1,
      anon_sym_LPAREN,
    ACTIONS(9612), 1,
      anon_sym__,
    ACTIONS(9614), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9616), 1,
      anon_sym_POUND,
    STATE(4411), 1,
      sym__static_type_identifier,
    STATE(4464), 1,
      sym__type,
    STATE(4636), 1,
      sym_type_argument,
    STATE(4690), 1,
      sym_long_identifier,
    ACTIONS(9618), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5980), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4691), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [120933] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9290), 1,
      sym_identifier,
    ACTIONS(9292), 1,
      anon_sym_LPAREN,
    ACTIONS(9294), 1,
      anon_sym__,
    ACTIONS(9296), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9298), 1,
      anon_sym_POUND,
    STATE(6542), 1,
      sym__type,
    STATE(6632), 1,
      sym__static_type_identifier,
    STATE(6949), 1,
      sym_type_argument,
    STATE(7089), 1,
      sym_long_identifier,
    ACTIONS(9300), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5981), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7154), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [121005] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8110), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5982), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [121077] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9290), 1,
      sym_identifier,
    ACTIONS(9292), 1,
      anon_sym_LPAREN,
    ACTIONS(9294), 1,
      anon_sym__,
    ACTIONS(9296), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9298), 1,
      anon_sym_POUND,
    STATE(6627), 1,
      sym__type,
    STATE(6632), 1,
      sym__static_type_identifier,
    STATE(6949), 1,
      sym_type_argument,
    STATE(7089), 1,
      sym_long_identifier,
    ACTIONS(9300), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5983), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7154), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [121149] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8144), 1,
      anon_sym_LPAREN,
    ACTIONS(8146), 1,
      anon_sym__,
    ACTIONS(8148), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8150), 1,
      anon_sym_POUND,
    ACTIONS(9400), 1,
      sym_identifier,
    STATE(6273), 1,
      sym__static_type_identifier,
    STATE(6286), 1,
      sym__type,
    STATE(6417), 1,
      sym_type_argument,
    STATE(6603), 1,
      sym_long_identifier,
    ACTIONS(8152), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5984), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6604), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [121221] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8144), 1,
      anon_sym_LPAREN,
    ACTIONS(8146), 1,
      anon_sym__,
    ACTIONS(8148), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8150), 1,
      anon_sym_POUND,
    ACTIONS(9400), 1,
      sym_identifier,
    STATE(6273), 1,
      sym__static_type_identifier,
    STATE(6300), 1,
      sym__type,
    STATE(6417), 1,
      sym_type_argument,
    STATE(6603), 1,
      sym_long_identifier,
    ACTIONS(8152), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5985), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6604), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [121293] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8144), 1,
      anon_sym_LPAREN,
    ACTIONS(8146), 1,
      anon_sym__,
    ACTIONS(8148), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8150), 1,
      anon_sym_POUND,
    ACTIONS(9400), 1,
      sym_identifier,
    STATE(6251), 1,
      sym__type,
    STATE(6273), 1,
      sym__static_type_identifier,
    STATE(6417), 1,
      sym_type_argument,
    STATE(6603), 1,
      sym_long_identifier,
    ACTIONS(8152), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5986), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6604), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [121365] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8144), 1,
      anon_sym_LPAREN,
    ACTIONS(8146), 1,
      anon_sym__,
    ACTIONS(8148), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8150), 1,
      anon_sym_POUND,
    ACTIONS(9400), 1,
      sym_identifier,
    STATE(6273), 1,
      sym__static_type_identifier,
    STATE(6305), 1,
      sym__type,
    STATE(6417), 1,
      sym_type_argument,
    STATE(6603), 1,
      sym_long_identifier,
    ACTIONS(8152), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5987), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6604), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [121437] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8205), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5988), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [121509] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(7744), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5989), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [121581] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9248), 1,
      sym_identifier,
    ACTIONS(9250), 1,
      anon_sym_LPAREN,
    ACTIONS(9252), 1,
      anon_sym__,
    ACTIONS(9254), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9256), 1,
      anon_sym_POUND,
    STATE(6690), 1,
      sym__static_type_identifier,
    STATE(6904), 1,
      sym__type,
    STATE(7044), 1,
      sym_type_argument,
    STATE(7140), 1,
      sym_long_identifier,
    ACTIONS(9258), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5990), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7138), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [121653] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9248), 1,
      sym_identifier,
    ACTIONS(9250), 1,
      anon_sym_LPAREN,
    ACTIONS(9252), 1,
      anon_sym__,
    ACTIONS(9254), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9256), 1,
      anon_sym_POUND,
    STATE(6690), 1,
      sym__static_type_identifier,
    STATE(7044), 1,
      sym_type_argument,
    STATE(7046), 1,
      sym__type,
    STATE(7140), 1,
      sym_long_identifier,
    ACTIONS(9258), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5991), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7138), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [121725] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8013), 1,
      anon_sym_LPAREN,
    ACTIONS(8015), 1,
      anon_sym__,
    ACTIONS(8017), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8019), 1,
      anon_sym_POUND,
    ACTIONS(8806), 1,
      sym_identifier,
    STATE(5351), 1,
      sym__type,
    STATE(5402), 1,
      sym__static_type_identifier,
    STATE(5488), 1,
      sym_type_argument,
    STATE(5627), 1,
      sym_long_identifier,
    ACTIONS(8021), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5992), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5557), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [121797] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(7971), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5993), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [121869] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4812), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9620), 1,
      anon_sym_LPAREN,
    ACTIONS(9622), 1,
      anon_sym__,
    ACTIONS(9624), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9626), 1,
      anon_sym_POUND,
    STATE(2291), 1,
      sym__type,
    STATE(2447), 1,
      sym__static_type_identifier,
    STATE(2550), 1,
      sym_long_identifier,
    STATE(2611), 1,
      sym_type_argument,
    ACTIONS(9628), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5994), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2606), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [121941] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8281), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5995), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [122013] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5996), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3515), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [122067] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8113), 1,
      anon_sym_LPAREN,
    ACTIONS(8115), 1,
      anon_sym__,
    ACTIONS(8117), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8119), 1,
      anon_sym_POUND,
    ACTIONS(8871), 1,
      sym_identifier,
    STATE(5456), 1,
      sym__type,
    STATE(5463), 1,
      sym__static_type_identifier,
    STATE(5566), 1,
      sym_type_argument,
    STATE(6046), 1,
      sym_long_identifier,
    ACTIONS(8121), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5997), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5996), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [122139] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8113), 1,
      anon_sym_LPAREN,
    ACTIONS(8115), 1,
      anon_sym__,
    ACTIONS(8117), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8119), 1,
      anon_sym_POUND,
    ACTIONS(8871), 1,
      sym_identifier,
    STATE(5461), 1,
      sym__type,
    STATE(5463), 1,
      sym__static_type_identifier,
    STATE(5566), 1,
      sym_type_argument,
    STATE(6046), 1,
      sym_long_identifier,
    ACTIONS(8121), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5998), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5996), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [122211] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8113), 1,
      anon_sym_LPAREN,
    ACTIONS(8115), 1,
      anon_sym__,
    ACTIONS(8117), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8119), 1,
      anon_sym_POUND,
    ACTIONS(8871), 1,
      sym_identifier,
    STATE(5462), 1,
      sym__type,
    STATE(5463), 1,
      sym__static_type_identifier,
    STATE(5566), 1,
      sym_type_argument,
    STATE(6046), 1,
      sym_long_identifier,
    ACTIONS(8121), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5999), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5996), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [122283] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8113), 1,
      anon_sym_LPAREN,
    ACTIONS(8115), 1,
      anon_sym__,
    ACTIONS(8117), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8119), 1,
      anon_sym_POUND,
    ACTIONS(8871), 1,
      sym_identifier,
    STATE(5447), 1,
      sym__type,
    STATE(5463), 1,
      sym__static_type_identifier,
    STATE(5566), 1,
      sym_type_argument,
    STATE(6046), 1,
      sym_long_identifier,
    ACTIONS(8121), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6000), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5996), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [122355] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8029), 1,
      anon_sym_LPAREN,
    ACTIONS(8031), 1,
      anon_sym__,
    ACTIONS(8033), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8035), 1,
      anon_sym_POUND,
    ACTIONS(8909), 1,
      sym_identifier,
    STATE(5431), 1,
      sym__type,
    STATE(5475), 1,
      sym__static_type_identifier,
    STATE(5630), 1,
      sym_type_argument,
    STATE(6183), 1,
      sym_long_identifier,
    ACTIONS(8037), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6001), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6184), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [122427] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4898), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9130), 1,
      anon_sym_LPAREN,
    ACTIONS(9132), 1,
      anon_sym__,
    ACTIONS(9134), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9136), 1,
      anon_sym_POUND,
    STATE(2320), 1,
      sym__type,
    STATE(2560), 1,
      sym__static_type_identifier,
    STATE(2665), 1,
      sym_long_identifier,
    STATE(2666), 1,
      sym_type_argument,
    ACTIONS(9138), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6002), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2670), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [122499] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4898), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9130), 1,
      anon_sym_LPAREN,
    ACTIONS(9132), 1,
      anon_sym__,
    ACTIONS(9134), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9136), 1,
      anon_sym_POUND,
    STATE(2328), 1,
      sym__type,
    STATE(2560), 1,
      sym__static_type_identifier,
    STATE(2665), 1,
      sym_long_identifier,
    STATE(2666), 1,
      sym_type_argument,
    ACTIONS(9138), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6003), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2670), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [122571] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4898), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9130), 1,
      anon_sym_LPAREN,
    ACTIONS(9132), 1,
      anon_sym__,
    ACTIONS(9134), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9136), 1,
      anon_sym_POUND,
    STATE(2349), 1,
      sym__type,
    STATE(2560), 1,
      sym__static_type_identifier,
    STATE(2665), 1,
      sym_long_identifier,
    STATE(2666), 1,
      sym_type_argument,
    ACTIONS(9138), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6004), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2670), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [122643] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8101), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6005), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [122715] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8144), 1,
      anon_sym_LPAREN,
    ACTIONS(8146), 1,
      anon_sym__,
    ACTIONS(8148), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8150), 1,
      anon_sym_POUND,
    ACTIONS(9400), 1,
      sym_identifier,
    STATE(6273), 1,
      sym__static_type_identifier,
    STATE(6417), 1,
      sym_type_argument,
    STATE(6603), 1,
      sym_long_identifier,
    STATE(7716), 1,
      sym__type,
    ACTIONS(8152), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6006), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6604), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [122787] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7973), 1,
      anon_sym_LPAREN,
    ACTIONS(7975), 1,
      anon_sym__,
    ACTIONS(7979), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_POUND,
    ACTIONS(8638), 1,
      sym_identifier,
    STATE(5340), 1,
      sym__type,
    STATE(5341), 1,
      sym__static_type_identifier,
    STATE(5434), 1,
      sym_type_argument,
    STATE(5528), 1,
      sym_long_identifier,
    ACTIONS(7983), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6007), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5525), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [122859] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8029), 1,
      anon_sym_LPAREN,
    ACTIONS(8031), 1,
      anon_sym__,
    ACTIONS(8033), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8035), 1,
      anon_sym_POUND,
    ACTIONS(8909), 1,
      sym_identifier,
    STATE(5458), 1,
      sym__type,
    STATE(5475), 1,
      sym__static_type_identifier,
    STATE(5630), 1,
      sym_type_argument,
    STATE(6183), 1,
      sym_long_identifier,
    ACTIONS(8037), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6008), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6184), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [122931] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6009), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3517), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3519), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [122985] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7692), 1,
      sym__type,
    STATE(7708), 1,
      sym_long_identifier,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6010), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [123057] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8180), 1,
      anon_sym_LPAREN,
    ACTIONS(8182), 1,
      anon_sym__,
    ACTIONS(8184), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8186), 1,
      anon_sym_POUND,
    ACTIONS(8794), 1,
      sym_identifier,
    STATE(5363), 1,
      sym__static_type_identifier,
    STATE(5390), 1,
      sym__type,
    STATE(5552), 1,
      sym_type_argument,
    STATE(5597), 1,
      sym_long_identifier,
    ACTIONS(8188), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6011), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5568), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [123129] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7973), 1,
      anon_sym_LPAREN,
    ACTIONS(7975), 1,
      anon_sym__,
    ACTIONS(7979), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_POUND,
    ACTIONS(8638), 1,
      sym_identifier,
    STATE(5341), 1,
      sym__static_type_identifier,
    STATE(5342), 1,
      sym__type,
    STATE(5434), 1,
      sym_type_argument,
    STATE(5528), 1,
      sym_long_identifier,
    ACTIONS(7983), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6012), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5525), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [123201] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8180), 1,
      anon_sym_LPAREN,
    ACTIONS(8182), 1,
      anon_sym__,
    ACTIONS(8184), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8186), 1,
      anon_sym_POUND,
    ACTIONS(8794), 1,
      sym_identifier,
    STATE(5363), 1,
      sym__static_type_identifier,
    STATE(5406), 1,
      sym__type,
    STATE(5552), 1,
      sym_type_argument,
    STATE(5597), 1,
      sym_long_identifier,
    ACTIONS(8188), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6013), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5568), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [123273] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8029), 1,
      anon_sym_LPAREN,
    ACTIONS(8031), 1,
      anon_sym__,
    ACTIONS(8033), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8035), 1,
      anon_sym_POUND,
    ACTIONS(8909), 1,
      sym_identifier,
    STATE(5460), 1,
      sym__type,
    STATE(5475), 1,
      sym__static_type_identifier,
    STATE(5630), 1,
      sym_type_argument,
    STATE(6183), 1,
      sym_long_identifier,
    ACTIONS(8037), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6014), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6184), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [123345] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8029), 1,
      anon_sym_LPAREN,
    ACTIONS(8031), 1,
      anon_sym__,
    ACTIONS(8033), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8035), 1,
      anon_sym_POUND,
    ACTIONS(8909), 1,
      sym_identifier,
    STATE(5446), 1,
      sym__type,
    STATE(5475), 1,
      sym__static_type_identifier,
    STATE(5630), 1,
      sym_type_argument,
    STATE(6183), 1,
      sym_long_identifier,
    ACTIONS(8037), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6015), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6184), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [123417] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7324), 1,
      sym_identifier,
    ACTIONS(9318), 1,
      anon_sym_LPAREN,
    ACTIONS(9320), 1,
      anon_sym__,
    ACTIONS(9322), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9324), 1,
      anon_sym_POUND,
    STATE(4361), 1,
      sym__static_type_identifier,
    STATE(4469), 1,
      sym__type,
    STATE(4496), 1,
      sym_type_argument,
    STATE(4668), 1,
      sym_long_identifier,
    ACTIONS(9326), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6016), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4674), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [123489] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8029), 1,
      anon_sym_LPAREN,
    ACTIONS(8031), 1,
      anon_sym__,
    ACTIONS(8033), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8035), 1,
      anon_sym_POUND,
    ACTIONS(8909), 1,
      sym_identifier,
    STATE(5444), 1,
      sym__type,
    STATE(5475), 1,
      sym__static_type_identifier,
    STATE(5630), 1,
      sym_type_argument,
    STATE(6183), 1,
      sym_long_identifier,
    ACTIONS(8037), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6017), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6184), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [123561] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8083), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6018), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [123633] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7973), 1,
      anon_sym_LPAREN,
    ACTIONS(7975), 1,
      anon_sym__,
    ACTIONS(7979), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_POUND,
    ACTIONS(8638), 1,
      sym_identifier,
    STATE(5341), 1,
      sym__static_type_identifier,
    STATE(5356), 1,
      sym__type,
    STATE(5434), 1,
      sym_type_argument,
    STATE(5528), 1,
      sym_long_identifier,
    ACTIONS(7983), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6019), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5525), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [123705] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8035), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6020), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [123777] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7324), 1,
      sym_identifier,
    ACTIONS(9318), 1,
      anon_sym_LPAREN,
    ACTIONS(9320), 1,
      anon_sym__,
    ACTIONS(9322), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9324), 1,
      anon_sym_POUND,
    STATE(4361), 1,
      sym__static_type_identifier,
    STATE(4409), 1,
      sym__type,
    STATE(4496), 1,
      sym_type_argument,
    STATE(4668), 1,
      sym_long_identifier,
    ACTIONS(9326), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6021), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4674), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [123849] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8180), 1,
      anon_sym_LPAREN,
    ACTIONS(8182), 1,
      anon_sym__,
    ACTIONS(8184), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8186), 1,
      anon_sym_POUND,
    ACTIONS(8794), 1,
      sym_identifier,
    STATE(5363), 1,
      sym__static_type_identifier,
    STATE(5410), 1,
      sym__type,
    STATE(5552), 1,
      sym_type_argument,
    STATE(5597), 1,
      sym_long_identifier,
    ACTIONS(8188), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6022), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5568), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [123921] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7310), 1,
      sym_identifier,
    ACTIONS(9552), 1,
      anon_sym_LPAREN,
    ACTIONS(9554), 1,
      anon_sym__,
    ACTIONS(9556), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9558), 1,
      anon_sym_POUND,
    STATE(4390), 1,
      sym__type,
    STATE(4400), 1,
      sym__static_type_identifier,
    STATE(4555), 1,
      sym_type_argument,
    STATE(4613), 1,
      sym_long_identifier,
    ACTIONS(9560), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6023), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4611), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [123993] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8180), 1,
      anon_sym_LPAREN,
    ACTIONS(8182), 1,
      anon_sym__,
    ACTIONS(8184), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8186), 1,
      anon_sym_POUND,
    ACTIONS(8794), 1,
      sym_identifier,
    STATE(5363), 1,
      sym__static_type_identifier,
    STATE(5387), 1,
      sym__type,
    STATE(5552), 1,
      sym_type_argument,
    STATE(5597), 1,
      sym_long_identifier,
    ACTIONS(8188), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6024), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5568), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [124065] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6765), 1,
      sym_identifier,
    ACTIONS(9600), 1,
      anon_sym_LPAREN,
    ACTIONS(9602), 1,
      anon_sym__,
    ACTIONS(9604), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9606), 1,
      anon_sym_POUND,
    STATE(583), 1,
      sym__type,
    STATE(4112), 1,
      sym__static_type_identifier,
    STATE(4181), 1,
      sym_type_argument,
    STATE(4200), 1,
      sym_long_identifier,
    ACTIONS(9608), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6025), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4209), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [124137] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7310), 1,
      sym_identifier,
    ACTIONS(9552), 1,
      anon_sym_LPAREN,
    ACTIONS(9554), 1,
      anon_sym__,
    ACTIONS(9556), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9558), 1,
      anon_sym_POUND,
    STATE(4364), 1,
      sym__type,
    STATE(4400), 1,
      sym__static_type_identifier,
    STATE(4555), 1,
      sym_type_argument,
    STATE(4613), 1,
      sym_long_identifier,
    ACTIONS(9560), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6026), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4611), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [124209] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7310), 1,
      sym_identifier,
    ACTIONS(9552), 1,
      anon_sym_LPAREN,
    ACTIONS(9554), 1,
      anon_sym__,
    ACTIONS(9556), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9558), 1,
      anon_sym_POUND,
    STATE(4365), 1,
      sym__type,
    STATE(4400), 1,
      sym__static_type_identifier,
    STATE(4555), 1,
      sym_type_argument,
    STATE(4613), 1,
      sym_long_identifier,
    ACTIONS(9560), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6027), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4611), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [124281] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(7827), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6028), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [124353] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8254), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6029), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [124425] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7973), 1,
      anon_sym_LPAREN,
    ACTIONS(7975), 1,
      anon_sym__,
    ACTIONS(7979), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_POUND,
    ACTIONS(8638), 1,
      sym_identifier,
    STATE(5341), 1,
      sym__static_type_identifier,
    STATE(5354), 1,
      sym__type,
    STATE(5434), 1,
      sym_type_argument,
    STATE(5528), 1,
      sym_long_identifier,
    ACTIONS(7983), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6030), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5525), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [124497] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7310), 1,
      sym_identifier,
    ACTIONS(9552), 1,
      anon_sym_LPAREN,
    ACTIONS(9554), 1,
      anon_sym__,
    ACTIONS(9556), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9558), 1,
      anon_sym_POUND,
    STATE(4368), 1,
      sym__type,
    STATE(4400), 1,
      sym__static_type_identifier,
    STATE(4555), 1,
      sym_type_argument,
    STATE(4613), 1,
      sym_long_identifier,
    ACTIONS(9560), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6031), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4611), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [124569] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8029), 1,
      anon_sym_LPAREN,
    ACTIONS(8031), 1,
      anon_sym__,
    ACTIONS(8033), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8035), 1,
      anon_sym_POUND,
    ACTIONS(8909), 1,
      sym_identifier,
    STATE(5475), 1,
      sym__static_type_identifier,
    STATE(5564), 1,
      sym__type,
    STATE(5630), 1,
      sym_type_argument,
    STATE(6183), 1,
      sym_long_identifier,
    ACTIONS(8037), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6032), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6184), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [124641] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6033), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3726), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
    ACTIONS(3728), 11,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
  [124695] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8046), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6034), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [124767] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(7957), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6035), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [124839] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7973), 1,
      anon_sym_LPAREN,
    ACTIONS(7975), 1,
      anon_sym__,
    ACTIONS(7979), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_POUND,
    ACTIONS(8638), 1,
      sym_identifier,
    STATE(5341), 1,
      sym__static_type_identifier,
    STATE(5355), 1,
      sym__type,
    STATE(5434), 1,
      sym_type_argument,
    STATE(5528), 1,
      sym_long_identifier,
    ACTIONS(7983), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6036), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5525), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [124911] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9508), 1,
      sym_identifier,
    ACTIONS(9510), 1,
      anon_sym_LPAREN,
    ACTIONS(9512), 1,
      anon_sym__,
    ACTIONS(9514), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9516), 1,
      anon_sym_POUND,
    STATE(7862), 1,
      sym__type,
    STATE(7946), 1,
      sym__static_type_identifier,
    STATE(8427), 1,
      sym_type_argument,
    STATE(8507), 1,
      sym_long_identifier,
    ACTIONS(9518), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6037), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(8500), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [124983] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9508), 1,
      sym_identifier,
    ACTIONS(9510), 1,
      anon_sym_LPAREN,
    ACTIONS(9512), 1,
      anon_sym__,
    ACTIONS(9514), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9516), 1,
      anon_sym_POUND,
    STATE(7875), 1,
      sym__type,
    STATE(7946), 1,
      sym__static_type_identifier,
    STATE(8427), 1,
      sym_type_argument,
    STATE(8507), 1,
      sym_long_identifier,
    ACTIONS(9518), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6038), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(8500), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [125055] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9508), 1,
      sym_identifier,
    ACTIONS(9510), 1,
      anon_sym_LPAREN,
    ACTIONS(9512), 1,
      anon_sym__,
    ACTIONS(9514), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9516), 1,
      anon_sym_POUND,
    STATE(7876), 1,
      sym__type,
    STATE(7946), 1,
      sym__static_type_identifier,
    STATE(8427), 1,
      sym_type_argument,
    STATE(8507), 1,
      sym_long_identifier,
    ACTIONS(9518), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6039), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(8500), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [125127] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9508), 1,
      sym_identifier,
    ACTIONS(9510), 1,
      anon_sym_LPAREN,
    ACTIONS(9512), 1,
      anon_sym__,
    ACTIONS(9514), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9516), 1,
      anon_sym_POUND,
    STATE(7924), 1,
      sym__type,
    STATE(7946), 1,
      sym__static_type_identifier,
    STATE(8427), 1,
      sym_type_argument,
    STATE(8507), 1,
      sym_long_identifier,
    ACTIONS(9518), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6040), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(8500), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [125199] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7222), 1,
      sym_identifier,
    ACTIONS(9630), 1,
      anon_sym_LPAREN,
    ACTIONS(9632), 1,
      anon_sym__,
    ACTIONS(9634), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9636), 1,
      anon_sym_POUND,
    STATE(4336), 1,
      sym__static_type_identifier,
    STATE(4340), 1,
      sym__type,
    STATE(4440), 1,
      sym_type_argument,
    STATE(4485), 1,
      sym_long_identifier,
    ACTIONS(9638), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6041), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4520), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [125271] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8186), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6042), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [125343] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7222), 1,
      sym_identifier,
    ACTIONS(9630), 1,
      anon_sym_LPAREN,
    ACTIONS(9632), 1,
      anon_sym__,
    ACTIONS(9634), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9636), 1,
      anon_sym_POUND,
    STATE(4336), 1,
      sym__static_type_identifier,
    STATE(4351), 1,
      sym__type,
    STATE(4440), 1,
      sym_type_argument,
    STATE(4485), 1,
      sym_long_identifier,
    ACTIONS(9638), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6043), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4520), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [125415] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7222), 1,
      sym_identifier,
    ACTIONS(9630), 1,
      anon_sym_LPAREN,
    ACTIONS(9632), 1,
      anon_sym__,
    ACTIONS(9634), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9636), 1,
      anon_sym_POUND,
    STATE(4336), 1,
      sym__static_type_identifier,
    STATE(4337), 1,
      sym__type,
    STATE(4440), 1,
      sym_type_argument,
    STATE(4485), 1,
      sym_long_identifier,
    ACTIONS(9638), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6044), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4520), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [125487] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8193), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6045), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [125559] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9640), 1,
      anon_sym_LT2,
    STATE(6046), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3503), 9,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3505), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [125615] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7222), 1,
      sym_identifier,
    ACTIONS(9630), 1,
      anon_sym_LPAREN,
    ACTIONS(9632), 1,
      anon_sym__,
    ACTIONS(9634), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9636), 1,
      anon_sym_POUND,
    STATE(4336), 1,
      sym__static_type_identifier,
    STATE(4348), 1,
      sym__type,
    STATE(4440), 1,
      sym_type_argument,
    STATE(4485), 1,
      sym_long_identifier,
    ACTIONS(9638), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6047), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4520), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [125687] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8150), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6048), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [125759] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4526), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9376), 1,
      anon_sym_LPAREN,
    ACTIONS(9378), 1,
      anon_sym__,
    ACTIONS(9380), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9382), 1,
      anon_sym_POUND,
    STATE(1657), 1,
      sym__type,
    STATE(2127), 1,
      sym__static_type_identifier,
    STATE(2228), 1,
      sym_type_argument,
    STATE(2246), 1,
      sym_long_identifier,
    ACTIONS(9384), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6049), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2253), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [125831] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8196), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6050), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [125903] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8029), 1,
      anon_sym_LPAREN,
    ACTIONS(8031), 1,
      anon_sym__,
    ACTIONS(8033), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8035), 1,
      anon_sym_POUND,
    ACTIONS(8909), 1,
      sym_identifier,
    STATE(5475), 1,
      sym__static_type_identifier,
    STATE(5565), 1,
      sym__type,
    STATE(5630), 1,
      sym_type_argument,
    STATE(6183), 1,
      sym_long_identifier,
    ACTIONS(8037), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6051), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6184), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [125975] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8065), 1,
      anon_sym_LPAREN,
    ACTIONS(8067), 1,
      anon_sym__,
    ACTIONS(8069), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8071), 1,
      anon_sym_POUND,
    ACTIONS(8772), 1,
      sym_identifier,
    STATE(5365), 1,
      sym__type,
    STATE(5407), 1,
      sym__static_type_identifier,
    STATE(5510), 1,
      sym_type_argument,
    STATE(5638), 1,
      sym_long_identifier,
    ACTIONS(8073), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6052), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5590), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [126047] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8065), 1,
      anon_sym_LPAREN,
    ACTIONS(8067), 1,
      anon_sym__,
    ACTIONS(8069), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8071), 1,
      anon_sym_POUND,
    ACTIONS(8772), 1,
      sym_identifier,
    STATE(5367), 1,
      sym__type,
    STATE(5407), 1,
      sym__static_type_identifier,
    STATE(5510), 1,
      sym_type_argument,
    STATE(5638), 1,
      sym_long_identifier,
    ACTIONS(8073), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6053), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5590), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [126119] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8136), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6054), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [126191] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8065), 1,
      anon_sym_LPAREN,
    ACTIONS(8067), 1,
      anon_sym__,
    ACTIONS(8069), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8071), 1,
      anon_sym_POUND,
    ACTIONS(8772), 1,
      sym_identifier,
    STATE(5368), 1,
      sym__type,
    STATE(5407), 1,
      sym__static_type_identifier,
    STATE(5510), 1,
      sym_type_argument,
    STATE(5638), 1,
      sym_long_identifier,
    ACTIONS(8073), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6055), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5590), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [126263] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8065), 1,
      anon_sym_LPAREN,
    ACTIONS(8067), 1,
      anon_sym__,
    ACTIONS(8069), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8071), 1,
      anon_sym_POUND,
    ACTIONS(8772), 1,
      sym_identifier,
    STATE(5401), 1,
      sym__type,
    STATE(5407), 1,
      sym__static_type_identifier,
    STATE(5510), 1,
      sym_type_argument,
    STATE(5638), 1,
      sym_long_identifier,
    ACTIONS(8073), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6056), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5590), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [126335] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9108), 1,
      sym_identifier,
    ACTIONS(9110), 1,
      anon_sym_LPAREN,
    ACTIONS(9112), 1,
      anon_sym__,
    ACTIONS(9114), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9116), 1,
      anon_sym_POUND,
    STATE(6834), 1,
      sym__static_type_identifier,
    STATE(6857), 1,
      sym__type,
    STATE(7121), 1,
      sym_type_argument,
    STATE(7307), 1,
      sym_long_identifier,
    ACTIONS(9118), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6057), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7300), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [126407] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8080), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6058), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [126479] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(7976), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6059), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [126551] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6492), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9140), 1,
      anon_sym_LPAREN,
    ACTIONS(9142), 1,
      anon_sym__,
    ACTIONS(9144), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9146), 1,
      anon_sym_POUND,
    STATE(3995), 1,
      sym__static_type_identifier,
    STATE(3996), 1,
      sym__type,
    STATE(4009), 1,
      sym_type_argument,
    STATE(4015), 1,
      sym_long_identifier,
    ACTIONS(9148), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6060), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4021), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [126623] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7647), 1,
      sym__type,
    STATE(7708), 1,
      sym_long_identifier,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6061), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [126695] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9464), 1,
      sym_identifier,
    ACTIONS(9466), 1,
      anon_sym_LPAREN,
    ACTIONS(9468), 1,
      anon_sym__,
    ACTIONS(9470), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9472), 1,
      anon_sym_POUND,
    STATE(6826), 1,
      sym__type,
    STATE(6871), 1,
      sym__static_type_identifier,
    STATE(7181), 1,
      sym_type_argument,
    STATE(7231), 1,
      sym_long_identifier,
    ACTIONS(9474), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6062), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7232), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [126767] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8241), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6063), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [126839] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9464), 1,
      sym_identifier,
    ACTIONS(9466), 1,
      anon_sym_LPAREN,
    ACTIONS(9468), 1,
      anon_sym__,
    ACTIONS(9470), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9472), 1,
      anon_sym_POUND,
    STATE(6798), 1,
      sym__type,
    STATE(6871), 1,
      sym__static_type_identifier,
    STATE(7181), 1,
      sym_type_argument,
    STATE(7231), 1,
      sym_long_identifier,
    ACTIONS(9474), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6064), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7232), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [126911] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9464), 1,
      sym_identifier,
    ACTIONS(9466), 1,
      anon_sym_LPAREN,
    ACTIONS(9468), 1,
      anon_sym__,
    ACTIONS(9470), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9472), 1,
      anon_sym_POUND,
    STATE(6797), 1,
      sym__type,
    STATE(6871), 1,
      sym__static_type_identifier,
    STATE(7181), 1,
      sym_type_argument,
    STATE(7231), 1,
      sym_long_identifier,
    ACTIONS(9474), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6065), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7232), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [126983] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9464), 1,
      sym_identifier,
    ACTIONS(9466), 1,
      anon_sym_LPAREN,
    ACTIONS(9468), 1,
      anon_sym__,
    ACTIONS(9470), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9472), 1,
      anon_sym_POUND,
    STATE(6794), 1,
      sym__type,
    STATE(6871), 1,
      sym__static_type_identifier,
    STATE(7181), 1,
      sym_type_argument,
    STATE(7231), 1,
      sym_long_identifier,
    ACTIONS(9474), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6066), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7232), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [127055] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4798), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9330), 1,
      anon_sym_LPAREN,
    ACTIONS(9332), 1,
      anon_sym__,
    ACTIONS(9334), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9336), 1,
      anon_sym_POUND,
    STATE(2269), 1,
      sym__type,
    STATE(2354), 1,
      sym__static_type_identifier,
    STATE(2499), 1,
      sym_type_argument,
    STATE(2503), 1,
      sym_long_identifier,
    ACTIONS(9338), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6067), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2483), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [127127] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7521), 1,
      sym_identifier,
    ACTIONS(9562), 1,
      anon_sym_LPAREN,
    ACTIONS(9564), 1,
      anon_sym__,
    ACTIONS(9566), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9568), 1,
      anon_sym_POUND,
    STATE(4513), 1,
      sym__static_type_identifier,
    STATE(4526), 1,
      sym__type,
    STATE(4728), 1,
      sym_type_argument,
    STATE(4802), 1,
      sym_long_identifier,
    ACTIONS(9570), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6068), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4805), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [127199] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7973), 1,
      anon_sym_LPAREN,
    ACTIONS(7975), 1,
      anon_sym__,
    ACTIONS(7979), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_POUND,
    ACTIONS(8638), 1,
      sym_identifier,
    STATE(5323), 1,
      sym__type,
    STATE(5341), 1,
      sym__static_type_identifier,
    STATE(5434), 1,
      sym_type_argument,
    STATE(5528), 1,
      sym_long_identifier,
    ACTIONS(7983), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6069), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5525), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [127271] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9452), 1,
      sym_identifier,
    ACTIONS(9454), 1,
      anon_sym_LPAREN,
    ACTIONS(9456), 1,
      anon_sym__,
    ACTIONS(9458), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9460), 1,
      anon_sym_POUND,
    STATE(6704), 1,
      sym__type,
    STATE(6736), 1,
      sym__static_type_identifier,
    STATE(7084), 1,
      sym_type_argument,
    STATE(7161), 1,
      sym_long_identifier,
    ACTIONS(9462), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6070), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7164), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [127343] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9452), 1,
      sym_identifier,
    ACTIONS(9454), 1,
      anon_sym_LPAREN,
    ACTIONS(9456), 1,
      anon_sym__,
    ACTIONS(9458), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9460), 1,
      anon_sym_POUND,
    STATE(6673), 1,
      sym__type,
    STATE(6736), 1,
      sym__static_type_identifier,
    STATE(7084), 1,
      sym_type_argument,
    STATE(7161), 1,
      sym_long_identifier,
    ACTIONS(9462), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6071), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7164), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [127415] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9452), 1,
      sym_identifier,
    ACTIONS(9454), 1,
      anon_sym_LPAREN,
    ACTIONS(9456), 1,
      anon_sym__,
    ACTIONS(9458), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9460), 1,
      anon_sym_POUND,
    STATE(6672), 1,
      sym__type,
    STATE(6736), 1,
      sym__static_type_identifier,
    STATE(7084), 1,
      sym_type_argument,
    STATE(7161), 1,
      sym_long_identifier,
    ACTIONS(9462), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6072), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7164), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [127487] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9452), 1,
      sym_identifier,
    ACTIONS(9454), 1,
      anon_sym_LPAREN,
    ACTIONS(9456), 1,
      anon_sym__,
    ACTIONS(9458), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9460), 1,
      anon_sym_POUND,
    STATE(6565), 1,
      sym__type,
    STATE(6736), 1,
      sym__static_type_identifier,
    STATE(7084), 1,
      sym_type_argument,
    STATE(7161), 1,
      sym_long_identifier,
    ACTIONS(9462), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6073), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7164), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [127559] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3710), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9402), 1,
      anon_sym_LPAREN,
    ACTIONS(9404), 1,
      anon_sym__,
    ACTIONS(9406), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9408), 1,
      anon_sym_POUND,
    STATE(1256), 1,
      sym__type,
    STATE(1421), 1,
      sym__static_type_identifier,
    STATE(1540), 1,
      sym_long_identifier,
    STATE(1550), 1,
      sym_type_argument,
    ACTIONS(9410), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6074), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1538), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [127631] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6765), 1,
      sym_identifier,
    ACTIONS(9600), 1,
      anon_sym_LPAREN,
    ACTIONS(9602), 1,
      anon_sym__,
    ACTIONS(9604), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9606), 1,
      anon_sym_POUND,
    STATE(582), 1,
      sym__type,
    STATE(4112), 1,
      sym__static_type_identifier,
    STATE(4181), 1,
      sym_type_argument,
    STATE(4200), 1,
      sym_long_identifier,
    ACTIONS(9608), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6075), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4209), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [127703] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8029), 1,
      anon_sym_LPAREN,
    ACTIONS(8031), 1,
      anon_sym__,
    ACTIONS(8033), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8035), 1,
      anon_sym_POUND,
    ACTIONS(8909), 1,
      sym_identifier,
    STATE(5475), 1,
      sym__static_type_identifier,
    STATE(5614), 1,
      sym__type,
    STATE(5630), 1,
      sym_type_argument,
    STATE(6183), 1,
      sym_long_identifier,
    ACTIONS(8037), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6076), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6184), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [127775] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8051), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6077), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [127847] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8255), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6078), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [127919] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8144), 1,
      anon_sym_LPAREN,
    ACTIONS(8146), 1,
      anon_sym__,
    ACTIONS(8148), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8150), 1,
      anon_sym_POUND,
    ACTIONS(9400), 1,
      sym_identifier,
    STATE(6273), 1,
      sym__static_type_identifier,
    STATE(6417), 1,
      sym_type_argument,
    STATE(6603), 1,
      sym_long_identifier,
    STATE(7846), 1,
      sym__type,
    ACTIONS(8152), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6079), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6604), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [127991] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4812), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9620), 1,
      anon_sym_LPAREN,
    ACTIONS(9622), 1,
      anon_sym__,
    ACTIONS(9624), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9626), 1,
      anon_sym_POUND,
    STATE(2273), 1,
      sym__type,
    STATE(2447), 1,
      sym__static_type_identifier,
    STATE(2550), 1,
      sym_long_identifier,
    STATE(2611), 1,
      sym_type_argument,
    ACTIONS(9628), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6080), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2606), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [128063] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4812), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9620), 1,
      anon_sym_LPAREN,
    ACTIONS(9622), 1,
      anon_sym__,
    ACTIONS(9624), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9626), 1,
      anon_sym_POUND,
    STATE(2302), 1,
      sym__type,
    STATE(2447), 1,
      sym__static_type_identifier,
    STATE(2550), 1,
      sym_long_identifier,
    STATE(2611), 1,
      sym_type_argument,
    ACTIONS(9628), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6081), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2606), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [128135] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4798), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9330), 1,
      anon_sym_LPAREN,
    ACTIONS(9332), 1,
      anon_sym__,
    ACTIONS(9334), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9336), 1,
      anon_sym_POUND,
    STATE(2268), 1,
      sym__type,
    STATE(2354), 1,
      sym__static_type_identifier,
    STATE(2499), 1,
      sym_type_argument,
    STATE(2503), 1,
      sym_long_identifier,
    ACTIONS(9338), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6082), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2483), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [128207] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6083), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3549), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3551), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [128261] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4812), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9620), 1,
      anon_sym_LPAREN,
    ACTIONS(9622), 1,
      anon_sym__,
    ACTIONS(9624), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9626), 1,
      anon_sym_POUND,
    STATE(2288), 1,
      sym__type,
    STATE(2447), 1,
      sym__static_type_identifier,
    STATE(2550), 1,
      sym_long_identifier,
    STATE(2611), 1,
      sym_type_argument,
    ACTIONS(9628), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6084), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2606), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [128333] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6085), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3560), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3562), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [128387] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4798), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9330), 1,
      anon_sym_LPAREN,
    ACTIONS(9332), 1,
      anon_sym__,
    ACTIONS(9334), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9336), 1,
      anon_sym_POUND,
    STATE(2265), 1,
      sym__type,
    STATE(2354), 1,
      sym__static_type_identifier,
    STATE(2499), 1,
      sym_type_argument,
    STATE(2503), 1,
      sym_long_identifier,
    ACTIONS(9338), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6086), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2483), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [128459] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8144), 1,
      anon_sym_LPAREN,
    ACTIONS(8146), 1,
      anon_sym__,
    ACTIONS(8148), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8150), 1,
      anon_sym_POUND,
    ACTIONS(9400), 1,
      sym_identifier,
    STATE(6273), 1,
      sym__static_type_identifier,
    STATE(6417), 1,
      sym_type_argument,
    STATE(6603), 1,
      sym_long_identifier,
    STATE(7749), 1,
      sym__type,
    ACTIONS(8152), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6087), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6604), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [128531] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9248), 1,
      sym_identifier,
    ACTIONS(9250), 1,
      anon_sym_LPAREN,
    ACTIONS(9252), 1,
      anon_sym__,
    ACTIONS(9254), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9256), 1,
      anon_sym_POUND,
    STATE(6664), 1,
      sym__type,
    STATE(6690), 1,
      sym__static_type_identifier,
    STATE(7044), 1,
      sym_type_argument,
    STATE(7140), 1,
      sym_long_identifier,
    ACTIONS(9258), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6088), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7138), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [128603] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9248), 1,
      sym_identifier,
    ACTIONS(9250), 1,
      anon_sym_LPAREN,
    ACTIONS(9252), 1,
      anon_sym__,
    ACTIONS(9254), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9256), 1,
      anon_sym_POUND,
    STATE(6681), 1,
      sym__type,
    STATE(6690), 1,
      sym__static_type_identifier,
    STATE(7044), 1,
      sym_type_argument,
    STATE(7140), 1,
      sym_long_identifier,
    ACTIONS(9258), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6089), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7138), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [128675] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9248), 1,
      sym_identifier,
    ACTIONS(9250), 1,
      anon_sym_LPAREN,
    ACTIONS(9252), 1,
      anon_sym__,
    ACTIONS(9254), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9256), 1,
      anon_sym_POUND,
    STATE(6683), 1,
      sym__type,
    STATE(6690), 1,
      sym__static_type_identifier,
    STATE(7044), 1,
      sym_type_argument,
    STATE(7140), 1,
      sym_long_identifier,
    ACTIONS(9258), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6090), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7138), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [128747] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9108), 1,
      sym_identifier,
    ACTIONS(9110), 1,
      anon_sym_LPAREN,
    ACTIONS(9112), 1,
      anon_sym__,
    ACTIONS(9114), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9116), 1,
      anon_sym_POUND,
    STATE(6760), 1,
      sym__type,
    STATE(6834), 1,
      sym__static_type_identifier,
    STATE(7121), 1,
      sym_type_argument,
    STATE(7307), 1,
      sym_long_identifier,
    ACTIONS(9118), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6091), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7300), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [128819] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9248), 1,
      sym_identifier,
    ACTIONS(9250), 1,
      anon_sym_LPAREN,
    ACTIONS(9252), 1,
      anon_sym__,
    ACTIONS(9254), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9256), 1,
      anon_sym_POUND,
    STATE(6690), 1,
      sym__static_type_identifier,
    STATE(6725), 1,
      sym__type,
    STATE(7044), 1,
      sym_type_argument,
    STATE(7140), 1,
      sym_long_identifier,
    ACTIONS(9258), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6092), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7138), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [128891] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8029), 1,
      anon_sym_LPAREN,
    ACTIONS(8031), 1,
      anon_sym__,
    ACTIONS(8033), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8035), 1,
      anon_sym_POUND,
    ACTIONS(8909), 1,
      sym_identifier,
    STATE(5475), 1,
      sym__static_type_identifier,
    STATE(5607), 1,
      sym__type,
    STATE(5630), 1,
      sym_type_argument,
    STATE(6183), 1,
      sym_long_identifier,
    ACTIONS(8037), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6093), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6184), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [128963] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6094), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3487), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_of,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3485), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [129017] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8188), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6095), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [129089] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8247), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6096), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [129161] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6866), 1,
      anon_sym_LPAREN,
    ACTIONS(6868), 1,
      anon_sym__,
    ACTIONS(6874), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6880), 1,
      anon_sym_POUND,
    ACTIONS(9328), 1,
      sym_identifier,
    STATE(6214), 1,
      sym__static_type_identifier,
    STATE(6360), 1,
      sym__type,
    STATE(6488), 1,
      sym_type_argument,
    STATE(6600), 1,
      sym_long_identifier,
    ACTIONS(6882), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6097), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6550), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [129233] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8029), 1,
      anon_sym_LPAREN,
    ACTIONS(8031), 1,
      anon_sym__,
    ACTIONS(8033), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8035), 1,
      anon_sym_POUND,
    ACTIONS(8909), 1,
      sym_identifier,
    STATE(5475), 1,
      sym__static_type_identifier,
    STATE(5556), 1,
      sym__type,
    STATE(5630), 1,
      sym_type_argument,
    STATE(6183), 1,
      sym_long_identifier,
    ACTIONS(8037), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6098), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6184), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [129305] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3716), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9280), 1,
      anon_sym_LPAREN,
    ACTIONS(9282), 1,
      anon_sym__,
    ACTIONS(9284), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9286), 1,
      anon_sym_POUND,
    STATE(1263), 1,
      sym__type,
    STATE(1420), 1,
      sym__static_type_identifier,
    STATE(1501), 1,
      sym_long_identifier,
    STATE(1513), 1,
      sym_type_argument,
    ACTIONS(9288), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6099), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1515), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [129377] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6866), 1,
      anon_sym_LPAREN,
    ACTIONS(6868), 1,
      anon_sym__,
    ACTIONS(6874), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6880), 1,
      anon_sym_POUND,
    ACTIONS(9328), 1,
      sym_identifier,
    STATE(6214), 1,
      sym__static_type_identifier,
    STATE(6311), 1,
      sym__type,
    STATE(6488), 1,
      sym_type_argument,
    STATE(6600), 1,
      sym_long_identifier,
    ACTIONS(6882), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6100), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6550), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [129449] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4870), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9418), 1,
      anon_sym_LPAREN,
    ACTIONS(9420), 1,
      anon_sym__,
    ACTIONS(9422), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9424), 1,
      anon_sym_POUND,
    STATE(2355), 1,
      sym__type,
    STATE(2601), 1,
      sym__static_type_identifier,
    STATE(2696), 1,
      sym_type_argument,
    STATE(2698), 1,
      sym_long_identifier,
    ACTIONS(9426), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6101), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2691), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [129521] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9496), 1,
      sym_identifier,
    ACTIONS(9498), 1,
      anon_sym_LPAREN,
    ACTIONS(9500), 1,
      anon_sym__,
    ACTIONS(9502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9504), 1,
      anon_sym_POUND,
    STATE(6451), 1,
      sym__static_type_identifier,
    STATE(6511), 1,
      sym__type,
    STATE(6924), 1,
      sym_type_argument,
    STATE(6952), 1,
      sym_long_identifier,
    ACTIONS(9506), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6102), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6960), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [129593] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3716), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9280), 1,
      anon_sym_LPAREN,
    ACTIONS(9282), 1,
      anon_sym__,
    ACTIONS(9284), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9286), 1,
      anon_sym_POUND,
    STATE(1266), 1,
      sym__type,
    STATE(1420), 1,
      sym__static_type_identifier,
    STATE(1501), 1,
      sym_long_identifier,
    STATE(1513), 1,
      sym_type_argument,
    ACTIONS(9288), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6103), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1515), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [129665] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8006), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6104), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [129737] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(7999), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6105), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [129809] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3716), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9280), 1,
      anon_sym_LPAREN,
    ACTIONS(9282), 1,
      anon_sym__,
    ACTIONS(9284), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9286), 1,
      anon_sym_POUND,
    STATE(1273), 1,
      sym__type,
    STATE(1420), 1,
      sym__static_type_identifier,
    STATE(1501), 1,
      sym_long_identifier,
    STATE(1513), 1,
      sym_type_argument,
    ACTIONS(9288), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6106), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1515), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [129881] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4870), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9418), 1,
      anon_sym_LPAREN,
    ACTIONS(9420), 1,
      anon_sym__,
    ACTIONS(9422), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9424), 1,
      anon_sym_POUND,
    STATE(2306), 1,
      sym__type,
    STATE(2601), 1,
      sym__static_type_identifier,
    STATE(2696), 1,
      sym_type_argument,
    STATE(2698), 1,
      sym_long_identifier,
    ACTIONS(9426), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6107), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2691), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [129953] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8295), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6108), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [130025] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4870), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9418), 1,
      anon_sym_LPAREN,
    ACTIONS(9420), 1,
      anon_sym__,
    ACTIONS(9422), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9424), 1,
      anon_sym_POUND,
    STATE(2308), 1,
      sym__type,
    STATE(2601), 1,
      sym__static_type_identifier,
    STATE(2696), 1,
      sym_type_argument,
    STATE(2698), 1,
      sym_long_identifier,
    ACTIONS(9426), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6109), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2691), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [130097] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6866), 1,
      anon_sym_LPAREN,
    ACTIONS(6868), 1,
      anon_sym__,
    ACTIONS(6874), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6880), 1,
      anon_sym_POUND,
    ACTIONS(9328), 1,
      sym_identifier,
    STATE(6214), 1,
      sym__static_type_identifier,
    STATE(6309), 1,
      sym__type,
    STATE(6488), 1,
      sym_type_argument,
    STATE(6600), 1,
      sym_long_identifier,
    ACTIONS(6882), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6110), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6550), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [130169] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6111), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3533), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3535), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [130223] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6112), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3529), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3531), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [130277] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9428), 1,
      sym_identifier,
    ACTIONS(9430), 1,
      anon_sym_LPAREN,
    ACTIONS(9432), 1,
      anon_sym__,
    ACTIONS(9434), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9436), 1,
      anon_sym_POUND,
    STATE(6752), 1,
      sym__type,
    STATE(6767), 1,
      sym__static_type_identifier,
    STATE(7165), 1,
      sym_type_argument,
    STATE(7251), 1,
      sym_long_identifier,
    ACTIONS(9438), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6113), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7247), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [130349] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9428), 1,
      sym_identifier,
    ACTIONS(9430), 1,
      anon_sym_LPAREN,
    ACTIONS(9432), 1,
      anon_sym__,
    ACTIONS(9434), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9436), 1,
      anon_sym_POUND,
    STATE(6767), 1,
      sym__static_type_identifier,
    STATE(6910), 1,
      sym__type,
    STATE(7165), 1,
      sym_type_argument,
    STATE(7251), 1,
      sym_long_identifier,
    ACTIONS(9438), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6114), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7247), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [130421] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6115), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3521), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3523), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [130475] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6116), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3525), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3527), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [130529] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8187), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6117), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [130601] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9496), 1,
      sym_identifier,
    ACTIONS(9498), 1,
      anon_sym_LPAREN,
    ACTIONS(9500), 1,
      anon_sym__,
    ACTIONS(9502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9504), 1,
      anon_sym_POUND,
    STATE(6451), 1,
      sym__static_type_identifier,
    STATE(6460), 1,
      sym__type,
    STATE(6924), 1,
      sym_type_argument,
    STATE(6952), 1,
      sym_long_identifier,
    ACTIONS(9506), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6118), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6960), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [130673] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3608), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9476), 1,
      anon_sym_LPAREN,
    ACTIONS(9478), 1,
      anon_sym__,
    ACTIONS(9480), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9482), 1,
      anon_sym_POUND,
    STATE(1244), 1,
      sym__type,
    STATE(1309), 1,
      sym__static_type_identifier,
    STATE(1344), 1,
      sym_long_identifier,
    STATE(1348), 1,
      sym_type_argument,
    ACTIONS(9484), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6119), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1353), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [130745] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9428), 1,
      sym_identifier,
    ACTIONS(9430), 1,
      anon_sym_LPAREN,
    ACTIONS(9432), 1,
      anon_sym__,
    ACTIONS(9434), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9436), 1,
      anon_sym_POUND,
    STATE(6767), 1,
      sym__static_type_identifier,
    STATE(6865), 1,
      sym__type,
    STATE(7165), 1,
      sym_type_argument,
    STATE(7251), 1,
      sym_long_identifier,
    ACTIONS(9438), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6120), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7247), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [130817] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3608), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9476), 1,
      anon_sym_LPAREN,
    ACTIONS(9478), 1,
      anon_sym__,
    ACTIONS(9480), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9482), 1,
      anon_sym_POUND,
    STATE(1237), 1,
      sym__type,
    STATE(1309), 1,
      sym__static_type_identifier,
    STATE(1344), 1,
      sym_long_identifier,
    STATE(1348), 1,
      sym_type_argument,
    ACTIONS(9484), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6121), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1353), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [130889] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6122), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3525), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3527), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [130943] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9428), 1,
      sym_identifier,
    ACTIONS(9430), 1,
      anon_sym_LPAREN,
    ACTIONS(9432), 1,
      anon_sym__,
    ACTIONS(9434), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9436), 1,
      anon_sym_POUND,
    STATE(6767), 1,
      sym__static_type_identifier,
    STATE(6830), 1,
      sym__type,
    STATE(7165), 1,
      sym_type_argument,
    STATE(7251), 1,
      sym_long_identifier,
    ACTIONS(9438), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6123), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7247), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [131015] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6124), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3537), 9,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3539), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [131069] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6125), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3529), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3531), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [131123] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6126), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3533), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3535), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [131177] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6127), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3541), 9,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3543), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [131231] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6128), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3545), 9,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3547), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [131285] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3608), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9476), 1,
      anon_sym_LPAREN,
    ACTIONS(9478), 1,
      anon_sym__,
    ACTIONS(9480), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9482), 1,
      anon_sym_POUND,
    STATE(1238), 1,
      sym__type,
    STATE(1309), 1,
      sym__static_type_identifier,
    STATE(1344), 1,
      sym_long_identifier,
    STATE(1348), 1,
      sym_type_argument,
    ACTIONS(9484), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6129), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1353), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [131357] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6130), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3517), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3519), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [131411] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6866), 1,
      anon_sym_LPAREN,
    ACTIONS(6868), 1,
      anon_sym__,
    ACTIONS(6874), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6880), 1,
      anon_sym_POUND,
    ACTIONS(9328), 1,
      sym_identifier,
    STATE(6214), 1,
      sym__static_type_identifier,
    STATE(6398), 1,
      sym__type,
    STATE(6488), 1,
      sym_type_argument,
    STATE(6600), 1,
      sym_long_identifier,
    ACTIONS(6882), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6131), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6550), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [131483] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8220), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6132), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [131555] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4874), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9350), 1,
      anon_sym_LPAREN,
    ACTIONS(9352), 1,
      anon_sym__,
    ACTIONS(9354), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9356), 1,
      anon_sym_POUND,
    STATE(2348), 1,
      sym__type,
    STATE(2569), 1,
      sym__static_type_identifier,
    STATE(2615), 1,
      sym_long_identifier,
    STATE(2708), 1,
      sym_type_argument,
    ACTIONS(9358), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6133), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2710), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [131627] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4874), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9350), 1,
      anon_sym_LPAREN,
    ACTIONS(9352), 1,
      anon_sym__,
    ACTIONS(9354), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9356), 1,
      anon_sym_POUND,
    STATE(2310), 1,
      sym__type,
    STATE(2569), 1,
      sym__static_type_identifier,
    STATE(2615), 1,
      sym_long_identifier,
    STATE(2708), 1,
      sym_type_argument,
    ACTIONS(9358), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6134), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2710), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [131699] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6866), 1,
      anon_sym_LPAREN,
    ACTIONS(6868), 1,
      anon_sym__,
    ACTIONS(6874), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6880), 1,
      anon_sym_POUND,
    ACTIONS(9328), 1,
      sym_identifier,
    STATE(6214), 1,
      sym__static_type_identifier,
    STATE(6488), 1,
      sym_type_argument,
    STATE(6600), 1,
      sym_long_identifier,
    STATE(8128), 1,
      sym__type,
    ACTIONS(6882), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6135), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6550), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [131771] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4874), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9350), 1,
      anon_sym_LPAREN,
    ACTIONS(9352), 1,
      anon_sym__,
    ACTIONS(9354), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9356), 1,
      anon_sym_POUND,
    STATE(2309), 1,
      sym__type,
    STATE(2569), 1,
      sym__static_type_identifier,
    STATE(2615), 1,
      sym_long_identifier,
    STATE(2708), 1,
      sym_type_argument,
    ACTIONS(9358), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6136), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2710), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [131843] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6866), 1,
      anon_sym_LPAREN,
    ACTIONS(6868), 1,
      anon_sym__,
    ACTIONS(6874), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6880), 1,
      anon_sym_POUND,
    ACTIONS(9328), 1,
      sym_identifier,
    STATE(6214), 1,
      sym__static_type_identifier,
    STATE(6314), 1,
      sym__type,
    STATE(6488), 1,
      sym_type_argument,
    STATE(6600), 1,
      sym_long_identifier,
    ACTIONS(6882), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6137), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6550), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [131915] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9508), 1,
      sym_identifier,
    ACTIONS(9510), 1,
      anon_sym_LPAREN,
    ACTIONS(9512), 1,
      anon_sym__,
    ACTIONS(9514), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9516), 1,
      anon_sym_POUND,
    STATE(7916), 1,
      sym__type,
    STATE(7946), 1,
      sym__static_type_identifier,
    STATE(8427), 1,
      sym_type_argument,
    STATE(8507), 1,
      sym_long_identifier,
    ACTIONS(9518), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6138), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(8500), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [131987] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6765), 1,
      sym_identifier,
    ACTIONS(9600), 1,
      anon_sym_LPAREN,
    ACTIONS(9602), 1,
      anon_sym__,
    ACTIONS(9604), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9606), 1,
      anon_sym_POUND,
    STATE(4096), 1,
      sym__type,
    STATE(4112), 1,
      sym__static_type_identifier,
    STATE(4181), 1,
      sym_type_argument,
    STATE(4200), 1,
      sym_long_identifier,
    ACTIONS(9608), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6139), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4209), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [132059] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6765), 1,
      sym_identifier,
    ACTIONS(9600), 1,
      anon_sym_LPAREN,
    ACTIONS(9602), 1,
      anon_sym__,
    ACTIONS(9604), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9606), 1,
      anon_sym_POUND,
    STATE(4112), 1,
      sym__static_type_identifier,
    STATE(4132), 1,
      sym__type,
    STATE(4181), 1,
      sym_type_argument,
    STATE(4200), 1,
      sym_long_identifier,
    ACTIONS(9608), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6140), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4209), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [132131] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8148), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6141), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [132203] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6765), 1,
      sym_identifier,
    ACTIONS(9600), 1,
      anon_sym_LPAREN,
    ACTIONS(9602), 1,
      anon_sym__,
    ACTIONS(9604), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9606), 1,
      anon_sym_POUND,
    STATE(4112), 1,
      sym__static_type_identifier,
    STATE(4128), 1,
      sym__type,
    STATE(4181), 1,
      sym_type_argument,
    STATE(4200), 1,
      sym_long_identifier,
    ACTIONS(9608), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6142), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4209), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [132275] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6765), 1,
      sym_identifier,
    ACTIONS(9600), 1,
      anon_sym_LPAREN,
    ACTIONS(9602), 1,
      anon_sym__,
    ACTIONS(9604), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9606), 1,
      anon_sym_POUND,
    STATE(4112), 1,
      sym__static_type_identifier,
    STATE(4121), 1,
      sym__type,
    STATE(4181), 1,
      sym_type_argument,
    STATE(4200), 1,
      sym_long_identifier,
    ACTIONS(9608), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6143), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4209), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [132347] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9302), 1,
      sym_identifier,
    ACTIONS(9304), 1,
      anon_sym_LPAREN,
    ACTIONS(9306), 1,
      anon_sym__,
    ACTIONS(9308), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9310), 1,
      anon_sym_POUND,
    STATE(8177), 1,
      sym__static_type_identifier,
    STATE(8250), 1,
      sym__type,
    STATE(8520), 1,
      sym_type_argument,
    STATE(8580), 1,
      sym_long_identifier,
    ACTIONS(9312), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6144), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(8581), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [132419] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6145), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3521), 10,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3523), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [132473] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8047), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6146), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [132545] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9206), 1,
      sym_identifier,
    ACTIONS(9208), 1,
      anon_sym_LPAREN,
    ACTIONS(9210), 1,
      anon_sym__,
    ACTIONS(9212), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9214), 1,
      anon_sym_POUND,
    STATE(7782), 1,
      sym__static_type_identifier,
    STATE(7792), 1,
      sym__type,
    STATE(8321), 1,
      sym_type_argument,
    STATE(8479), 1,
      sym_long_identifier,
    ACTIONS(9216), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6147), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(8478), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [132617] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7973), 1,
      anon_sym_LPAREN,
    ACTIONS(7975), 1,
      anon_sym__,
    ACTIONS(7979), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_POUND,
    ACTIONS(8638), 1,
      sym_identifier,
    STATE(5341), 1,
      sym__static_type_identifier,
    STATE(5344), 1,
      sym__type,
    STATE(5434), 1,
      sym_type_argument,
    STATE(5528), 1,
      sym_long_identifier,
    ACTIONS(7983), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6148), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5525), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [132689] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9206), 1,
      sym_identifier,
    ACTIONS(9208), 1,
      anon_sym_LPAREN,
    ACTIONS(9210), 1,
      anon_sym__,
    ACTIONS(9212), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9214), 1,
      anon_sym_POUND,
    STATE(7782), 1,
      sym__static_type_identifier,
    STATE(7788), 1,
      sym__type,
    STATE(8321), 1,
      sym_type_argument,
    STATE(8479), 1,
      sym_long_identifier,
    ACTIONS(9216), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6149), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(8478), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [132761] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7973), 1,
      anon_sym_LPAREN,
    ACTIONS(7975), 1,
      anon_sym__,
    ACTIONS(7979), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_POUND,
    ACTIONS(8638), 1,
      sym_identifier,
    STATE(5341), 1,
      sym__static_type_identifier,
    STATE(5348), 1,
      sym__type,
    STATE(5434), 1,
      sym_type_argument,
    STATE(5528), 1,
      sym_long_identifier,
    ACTIONS(7983), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6150), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5525), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [132833] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8078), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6151), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [132905] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7973), 1,
      anon_sym_LPAREN,
    ACTIONS(7975), 1,
      anon_sym__,
    ACTIONS(7979), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_POUND,
    ACTIONS(8638), 1,
      sym_identifier,
    STATE(5341), 1,
      sym__static_type_identifier,
    STATE(5347), 1,
      sym__type,
    STATE(5434), 1,
      sym_type_argument,
    STATE(5528), 1,
      sym_long_identifier,
    ACTIONS(7983), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6152), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5525), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [132977] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7973), 1,
      anon_sym_LPAREN,
    ACTIONS(7975), 1,
      anon_sym__,
    ACTIONS(7979), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_POUND,
    ACTIONS(8638), 1,
      sym_identifier,
    STATE(5341), 1,
      sym__static_type_identifier,
    STATE(5345), 1,
      sym__type,
    STATE(5434), 1,
      sym_type_argument,
    STATE(5528), 1,
      sym_long_identifier,
    ACTIONS(7983), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6153), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5525), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [133049] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6154), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3560), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3562), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [133103] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9206), 1,
      sym_identifier,
    ACTIONS(9208), 1,
      anon_sym_LPAREN,
    ACTIONS(9210), 1,
      anon_sym__,
    ACTIONS(9212), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9214), 1,
      anon_sym_POUND,
    STATE(7782), 1,
      sym__static_type_identifier,
    STATE(7787), 1,
      sym__type,
    STATE(8321), 1,
      sym_type_argument,
    STATE(8479), 1,
      sym_long_identifier,
    ACTIONS(9216), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6155), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(8478), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [133175] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8081), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6156), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [133247] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7373), 1,
      sym_identifier,
    ACTIONS(9228), 1,
      anon_sym_LPAREN,
    ACTIONS(9230), 1,
      anon_sym__,
    ACTIONS(9232), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9234), 1,
      anon_sym_POUND,
    STATE(4412), 1,
      sym__type,
    STATE(4477), 1,
      sym__static_type_identifier,
    STATE(4622), 1,
      sym_type_argument,
    STATE(4703), 1,
      sym_long_identifier,
    ACTIONS(9236), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6157), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [133319] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7373), 1,
      sym_identifier,
    ACTIONS(9228), 1,
      anon_sym_LPAREN,
    ACTIONS(9230), 1,
      anon_sym__,
    ACTIONS(9232), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9234), 1,
      anon_sym_POUND,
    STATE(4443), 1,
      sym__type,
    STATE(4477), 1,
      sym__static_type_identifier,
    STATE(4622), 1,
      sym_type_argument,
    STATE(4703), 1,
      sym_long_identifier,
    ACTIONS(9236), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6158), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [133391] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9206), 1,
      sym_identifier,
    ACTIONS(9208), 1,
      anon_sym_LPAREN,
    ACTIONS(9210), 1,
      anon_sym__,
    ACTIONS(9212), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9214), 1,
      anon_sym_POUND,
    STATE(7747), 1,
      sym__type,
    STATE(7782), 1,
      sym__static_type_identifier,
    STATE(8321), 1,
      sym_type_argument,
    STATE(8479), 1,
      sym_long_identifier,
    ACTIONS(9216), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6159), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(8478), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [133463] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6160), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3549), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3551), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [133517] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6161), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 9,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3515), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [133571] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7373), 1,
      sym_identifier,
    ACTIONS(9228), 1,
      anon_sym_LPAREN,
    ACTIONS(9230), 1,
      anon_sym__,
    ACTIONS(9232), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9234), 1,
      anon_sym_POUND,
    STATE(4442), 1,
      sym__type,
    STATE(4477), 1,
      sym__static_type_identifier,
    STATE(4622), 1,
      sym_type_argument,
    STATE(4703), 1,
      sym_long_identifier,
    ACTIONS(9236), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6162), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [133643] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8029), 1,
      anon_sym_LPAREN,
    ACTIONS(8031), 1,
      anon_sym__,
    ACTIONS(8033), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8035), 1,
      anon_sym_POUND,
    ACTIONS(8909), 1,
      sym_identifier,
    STATE(5475), 1,
      sym__static_type_identifier,
    STATE(5478), 1,
      sym__type,
    STATE(5630), 1,
      sym_type_argument,
    STATE(6183), 1,
      sym_long_identifier,
    ACTIONS(8037), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6163), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6184), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [133715] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9642), 1,
      anon_sym_LT2,
    STATE(6164), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3503), 8,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3505), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [133771] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8043), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6165), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [133843] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7373), 1,
      sym_identifier,
    ACTIONS(9228), 1,
      anon_sym_LPAREN,
    ACTIONS(9230), 1,
      anon_sym__,
    ACTIONS(9232), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9234), 1,
      anon_sym_POUND,
    STATE(4435), 1,
      sym__type,
    STATE(4477), 1,
      sym__static_type_identifier,
    STATE(4622), 1,
      sym_type_argument,
    STATE(4703), 1,
      sym_long_identifier,
    ACTIONS(9236), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6166), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [133915] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(7994), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6167), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [133987] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6168), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3549), 9,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3551), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [134041] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6169), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3560), 9,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3562), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [134095] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8013), 1,
      anon_sym_LPAREN,
    ACTIONS(8015), 1,
      anon_sym__,
    ACTIONS(8017), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8019), 1,
      anon_sym_POUND,
    ACTIONS(8806), 1,
      sym_identifier,
    STATE(5402), 1,
      sym__static_type_identifier,
    STATE(5413), 1,
      sym__type,
    STATE(5488), 1,
      sym_type_argument,
    STATE(5627), 1,
      sym_long_identifier,
    ACTIONS(8021), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6170), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5557), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [134167] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9302), 1,
      sym_identifier,
    ACTIONS(9304), 1,
      anon_sym_LPAREN,
    ACTIONS(9306), 1,
      anon_sym__,
    ACTIONS(9308), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9310), 1,
      anon_sym_POUND,
    STATE(8177), 1,
      sym__static_type_identifier,
    STATE(8185), 1,
      sym__type,
    STATE(8520), 1,
      sym_type_argument,
    STATE(8580), 1,
      sym_long_identifier,
    ACTIONS(9312), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6171), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(8581), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [134239] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(8026), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6172), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [134311] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7267), 1,
      sym_identifier,
    ACTIONS(9644), 1,
      anon_sym_LPAREN,
    ACTIONS(9646), 1,
      anon_sym__,
    ACTIONS(9648), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9650), 1,
      anon_sym_POUND,
    STATE(4375), 1,
      sym__static_type_identifier,
    STATE(4378), 1,
      sym__type,
    STATE(4503), 1,
      sym_type_argument,
    STATE(4661), 1,
      sym_long_identifier,
    ACTIONS(9652), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6173), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4663), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [134383] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6174), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3533), 9,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3535), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [134437] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6175), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3529), 9,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3531), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [134491] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7267), 1,
      sym_identifier,
    ACTIONS(9644), 1,
      anon_sym_LPAREN,
    ACTIONS(9646), 1,
      anon_sym__,
    ACTIONS(9648), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9650), 1,
      anon_sym_POUND,
    STATE(4375), 1,
      sym__static_type_identifier,
    STATE(4401), 1,
      sym__type,
    STATE(4503), 1,
      sym_type_argument,
    STATE(4661), 1,
      sym_long_identifier,
    ACTIONS(9652), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6176), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4663), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [134563] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(7962), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6177), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [134635] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7440), 1,
      sym_identifier,
    ACTIONS(9542), 1,
      anon_sym_LPAREN,
    ACTIONS(9544), 1,
      anon_sym__,
    ACTIONS(9546), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9548), 1,
      anon_sym_POUND,
    STATE(4447), 1,
      sym__type,
    STATE(4450), 1,
      sym__static_type_identifier,
    STATE(4659), 1,
      sym_type_argument,
    STATE(4685), 1,
      sym_long_identifier,
    ACTIONS(9550), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6178), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4686), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [134707] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7267), 1,
      sym_identifier,
    ACTIONS(9644), 1,
      anon_sym_LPAREN,
    ACTIONS(9646), 1,
      anon_sym__,
    ACTIONS(9648), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9650), 1,
      anon_sym_POUND,
    STATE(4355), 1,
      sym__type,
    STATE(4375), 1,
      sym__static_type_identifier,
    STATE(4503), 1,
      sym_type_argument,
    STATE(4661), 1,
      sym_long_identifier,
    ACTIONS(9652), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6179), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4663), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [134779] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7267), 1,
      sym_identifier,
    ACTIONS(9644), 1,
      anon_sym_LPAREN,
    ACTIONS(9646), 1,
      anon_sym__,
    ACTIONS(9648), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9650), 1,
      anon_sym_POUND,
    STATE(4375), 1,
      sym__static_type_identifier,
    STATE(4404), 1,
      sym__type,
    STATE(4503), 1,
      sym_type_argument,
    STATE(4661), 1,
      sym_long_identifier,
    ACTIONS(9652), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6180), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4663), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [134851] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6866), 1,
      anon_sym_LPAREN,
    ACTIONS(6868), 1,
      anon_sym__,
    ACTIONS(6874), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6880), 1,
      anon_sym_POUND,
    ACTIONS(9328), 1,
      sym_identifier,
    STATE(6199), 1,
      sym__type,
    STATE(6214), 1,
      sym__static_type_identifier,
    STATE(6488), 1,
      sym_type_argument,
    STATE(6600), 1,
      sym_long_identifier,
    ACTIONS(6882), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6181), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(6550), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [134923] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6182), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3525), 9,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3527), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [134977] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9654), 1,
      anon_sym_LT2,
    STATE(6183), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3503), 9,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3505), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [135033] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6184), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 10,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
    ACTIONS(3515), 12,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [135087] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6185), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3517), 9,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3519), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [135141] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6186), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3521), 9,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
    ACTIONS(3523), 13,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [135195] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4553), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9238), 1,
      anon_sym_LPAREN,
    ACTIONS(9240), 1,
      anon_sym__,
    ACTIONS(9242), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(9244), 1,
      anon_sym_POUND,
    STATE(1611), 1,
      sym__type,
    STATE(2208), 1,
      sym__static_type_identifier,
    STATE(2254), 1,
      sym_long_identifier,
    STATE(2255), 1,
      sym_type_argument,
    ACTIONS(9246), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6187), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2258), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [135267] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8013), 1,
      anon_sym_LPAREN,
    ACTIONS(8015), 1,
      anon_sym__,
    ACTIONS(8017), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8019), 1,
      anon_sym_POUND,
    ACTIONS(8806), 1,
      sym_identifier,
    STATE(5402), 1,
      sym__static_type_identifier,
    STATE(5403), 1,
      sym__type,
    STATE(5488), 1,
      sym_type_argument,
    STATE(5627), 1,
      sym_long_identifier,
    ACTIONS(8021), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6188), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5557), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [135339] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(7965), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6189), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [135411] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8013), 1,
      anon_sym_LPAREN,
    ACTIONS(8015), 1,
      anon_sym__,
    ACTIONS(8017), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8019), 1,
      anon_sym_POUND,
    ACTIONS(8806), 1,
      sym_identifier,
    STATE(5402), 1,
      sym__static_type_identifier,
    STATE(5409), 1,
      sym__type,
    STATE(5488), 1,
      sym_type_argument,
    STATE(5627), 1,
      sym_long_identifier,
    ACTIONS(8021), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6190), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5557), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [135483] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(7973), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6191), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [135555] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8013), 1,
      anon_sym_LPAREN,
    ACTIONS(8015), 1,
      anon_sym__,
    ACTIONS(8017), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(8019), 1,
      anon_sym_POUND,
    ACTIONS(8806), 1,
      sym_identifier,
    STATE(5402), 1,
      sym__static_type_identifier,
    STATE(5415), 1,
      sym__type,
    STATE(5488), 1,
      sym_type_argument,
    STATE(5627), 1,
      sym_long_identifier,
    ACTIONS(8021), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6192), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5557), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [135627] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(7990), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6193), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [135699] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6582), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6586), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6590), 1,
      anon_sym_POUND,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(7287), 1,
      sym__static_type_identifier,
    STATE(7584), 1,
      sym_type_argument,
    STATE(7708), 1,
      sym_long_identifier,
    STATE(7979), 1,
      sym__type,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(6194), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(7701), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [135771] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6200), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    ACTIONS(9005), 2,
      anon_sym_let,
      anon_sym_LPAREN,
    STATE(6195), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9007), 16,
      anon_sym_module,
      anon_sym_type,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym__,
      anon_sym_new,
      anon_sym_CARET,
      anon_sym_SQUOTE,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_exception,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [135830] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6158), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9656), 1,
      anon_sym_and,
    STATE(6201), 1,
      aux_sym__function_or_value_defns_repeat1,
    STATE(6196), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6156), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [135887] = 22,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3193), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9071), 1,
      anon_sym_y,
    ACTIONS(9073), 1,
      anon_sym_uy,
    ACTIONS(9075), 1,
      anon_sym_s,
    ACTIONS(9077), 1,
      anon_sym_us,
    ACTIONS(9081), 1,
      aux_sym_uint32_token1,
    ACTIONS(9083), 1,
      anon_sym_n,
    ACTIONS(9085), 1,
      anon_sym_un,
    ACTIONS(9089), 1,
      aux_sym_uint64_token1,
    ACTIONS(9658), 1,
      anon_sym_l,
    ACTIONS(9660), 1,
      anon_sym_L,
    ACTIONS(9662), 1,
      anon_sym_lf,
    ACTIONS(9664), 1,
      anon_sym_LF,
    STATE(6197), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3191), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [135964] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6192), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9656), 1,
      anon_sym_and,
    STATE(6196), 1,
      aux_sym__function_or_value_defns_repeat1,
    STATE(6198), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6190), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [136021] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(1027), 1,
      anon_sym_with,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9328), 1,
      sym_identifier,
    ACTIONS(9666), 1,
      anon_sym_DASH_GT,
    ACTIONS(9668), 1,
      anon_sym_STAR,
    ACTIONS(9670), 1,
      anon_sym_LT2,
    ACTIONS(9672), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6416), 1,
      aux_sym_compound_type_repeat1,
    STATE(6698), 1,
      sym_type_arguments,
    STATE(6730), 1,
      sym_long_identifier,
    STATE(7587), 1,
      sym__object_members,
    ACTIONS(5377), 3,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(6199), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5381), 8,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [136094] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9674), 1,
      anon_sym_LBRACK_LT,
    STATE(6370), 1,
      sym__attribute_set,
    ACTIONS(9020), 2,
      anon_sym_let,
      anon_sym_LPAREN,
    STATE(6200), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_attributes_repeat1,
    ACTIONS(9025), 16,
      anon_sym_module,
      anon_sym_type,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym__,
      anon_sym_new,
      anon_sym_CARET,
      anon_sym_SQUOTE,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_exception,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [136151] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6117), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9677), 1,
      anon_sym_and,
    STATE(6201), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__function_or_value_defns_repeat1,
    ACTIONS(6115), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [136206] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6202), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4086), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(4084), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [136258] = 25,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9680), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(9683), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(9686), 1,
      anon_sym_new,
    ACTIONS(9692), 1,
      anon_sym_static,
    ACTIONS(9695), 1,
      anon_sym_member,
    ACTIONS(9698), 1,
      anon_sym_interface,
    ACTIONS(9701), 1,
      anon_sym_abstract,
    ACTIONS(9704), 1,
      anon_sym_val,
    ACTIONS(9707), 1,
      sym__dedent,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7519), 1,
      sym__type_defn_elements,
    STATE(7525), 1,
      sym_additional_constr_defn,
    STATE(7949), 1,
      sym_attributes,
    STATE(11862), 1,
      sym_access_modifier,
    ACTIONS(9689), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7524), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6203), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_interface_type_defn_repeat1,
  [136340] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6204), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4208), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(4206), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [136392] = 26,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7920), 1,
      sym__dedent,
    ACTIONS(9709), 1,
      anon_sym_new,
    ACTIONS(9713), 1,
      anon_sym_static,
    ACTIONS(9715), 1,
      anon_sym_member,
    ACTIONS(9717), 1,
      anon_sym_interface,
    ACTIONS(9719), 1,
      anon_sym_abstract,
    ACTIONS(9721), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6304), 1,
      aux_sym_interface_type_defn_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7519), 1,
      sym__type_defn_elements,
    STATE(7525), 1,
      sym_additional_constr_defn,
    STATE(7949), 1,
      sym_attributes,
    STATE(11862), 1,
      sym_access_modifier,
    ACTIONS(9711), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7524), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6205), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [136476] = 26,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9709), 1,
      anon_sym_new,
    ACTIONS(9713), 1,
      anon_sym_static,
    ACTIONS(9715), 1,
      anon_sym_member,
    ACTIONS(9717), 1,
      anon_sym_interface,
    ACTIONS(9719), 1,
      anon_sym_abstract,
    ACTIONS(9721), 1,
      anon_sym_val,
    ACTIONS(9723), 1,
      sym__dedent,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6203), 1,
      aux_sym_interface_type_defn_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7519), 1,
      sym__type_defn_elements,
    STATE(7525), 1,
      sym_additional_constr_defn,
    STATE(7949), 1,
      sym_attributes,
    STATE(11862), 1,
      sym_access_modifier,
    ACTIONS(9711), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7524), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6206), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [136560] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9725), 1,
      anon_sym_or,
    STATE(6207), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3478), 8,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3480), 10,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [136614] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6208), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4212), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(4210), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [136666] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6209), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8251), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(8253), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [136718] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9728), 1,
      anon_sym_or,
    STATE(6207), 1,
      aux_sym_type_argument_repeat1,
    STATE(6210), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3474), 8,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3476), 10,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [136774] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9400), 1,
      sym_identifier,
    ACTIONS(9730), 1,
      anon_sym_LT2,
    ACTIONS(9732), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6501), 1,
      aux_sym_compound_type_repeat1,
    STATE(6558), 1,
      sym_long_identifier,
    STATE(6573), 1,
      sym_type_arguments,
    ACTIONS(5609), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    ACTIONS(5605), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(6211), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5607), 8,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [136840] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6302), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6212), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6300), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [136892] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3700), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6213), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3698), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [136944] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9728), 1,
      anon_sym_or,
    STATE(6210), 1,
      aux_sym_type_argument_repeat1,
    STATE(6214), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 8,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3498), 10,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [137000] = 26,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7918), 1,
      sym__dedent,
    ACTIONS(9709), 1,
      anon_sym_new,
    ACTIONS(9713), 1,
      anon_sym_static,
    ACTIONS(9715), 1,
      anon_sym_member,
    ACTIONS(9717), 1,
      anon_sym_interface,
    ACTIONS(9719), 1,
      anon_sym_abstract,
    ACTIONS(9721), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6290), 1,
      aux_sym_interface_type_defn_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7519), 1,
      sym__type_defn_elements,
    STATE(7525), 1,
      sym_additional_constr_defn,
    STATE(7949), 1,
      sym_attributes,
    STATE(11862), 1,
      sym_access_modifier,
    ACTIONS(9711), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7524), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6215), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137084] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6216), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4224), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(4222), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [137136] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9400), 1,
      sym_identifier,
    ACTIONS(9730), 1,
      anon_sym_LT2,
    ACTIONS(9732), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6501), 1,
      aux_sym_compound_type_repeat1,
    STATE(6558), 1,
      sym_long_identifier,
    STATE(6573), 1,
      sym_type_arguments,
    ACTIONS(5609), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    ACTIONS(5621), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(6217), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5623), 8,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [137202] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6318), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6218), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6316), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [137254] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5601), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8764), 1,
      anon_sym_DOT,
    STATE(6355), 1,
      aux_sym_long_identifier_repeat1,
    STATE(6219), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 7,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3494), 10,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [137312] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6220), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4078), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(4076), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [137364] = 26,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7930), 1,
      sym__dedent,
    ACTIONS(9709), 1,
      anon_sym_new,
    ACTIONS(9713), 1,
      anon_sym_static,
    ACTIONS(9715), 1,
      anon_sym_member,
    ACTIONS(9717), 1,
      anon_sym_interface,
    ACTIONS(9719), 1,
      anon_sym_abstract,
    ACTIONS(9721), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6299), 1,
      aux_sym_interface_type_defn_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7519), 1,
      sym__type_defn_elements,
    STATE(7525), 1,
      sym_additional_constr_defn,
    STATE(7949), 1,
      sym_attributes,
    STATE(11862), 1,
      sym_access_modifier,
    ACTIONS(9711), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7524), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6221), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137448] = 26,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9709), 1,
      anon_sym_new,
    ACTIONS(9713), 1,
      anon_sym_static,
    ACTIONS(9715), 1,
      anon_sym_member,
    ACTIONS(9717), 1,
      anon_sym_interface,
    ACTIONS(9719), 1,
      anon_sym_abstract,
    ACTIONS(9721), 1,
      anon_sym_val,
    ACTIONS(9734), 1,
      sym__dedent,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6203), 1,
      aux_sym_interface_type_defn_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7519), 1,
      sym__type_defn_elements,
    STATE(7525), 1,
      sym_additional_constr_defn,
    STATE(7949), 1,
      sym_attributes,
    STATE(11862), 1,
      sym_access_modifier,
    ACTIONS(9711), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7524), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6222), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137532] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6124), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9736), 1,
      anon_sym_COMMA,
    STATE(6223), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6122), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [137586] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6124), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9738), 1,
      anon_sym_COMMA,
    STATE(6224), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6122), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [137640] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9740), 1,
      anon_sym_or,
    STATE(6225), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3478), 9,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3480), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [137694] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(239), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9743), 1,
      anon_sym_COMMA,
    STATE(6226), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(237), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [137748] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(239), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9745), 1,
      anon_sym_COMMA,
    STATE(6227), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(237), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [137802] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6228), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9747), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(9749), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [137854] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6184), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9751), 1,
      anon_sym_COMMA,
    STATE(6229), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6182), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [137908] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6184), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9753), 1,
      anon_sym_COMMA,
    STATE(6230), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6182), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [137962] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6231), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4100), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(4098), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [138014] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9755), 1,
      anon_sym_or,
    STATE(6225), 1,
      aux_sym_type_argument_repeat1,
    STATE(6232), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3474), 9,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3476), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [138070] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6134), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9757), 1,
      anon_sym_COMMA,
    STATE(6233), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6132), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [138124] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9759), 1,
      anon_sym_DOT,
    STATE(6249), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3451), 2,
      anon_sym_let,
      anon_sym_LPAREN,
    STATE(6234), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3449), 16,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_LT2,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [138180] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6134), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9761), 1,
      anon_sym_COMMA,
    STATE(6235), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6132), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [138234] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6236), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4104), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(4102), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [138286] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6237), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3193), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3191), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [138338] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6238), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3927), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3925), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [138390] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6239), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3946), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3944), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [138442] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9328), 1,
      sym_identifier,
    ACTIONS(9666), 1,
      anon_sym_DASH_GT,
    ACTIONS(9668), 1,
      anon_sym_STAR,
    ACTIONS(9670), 1,
      anon_sym_LT2,
    ACTIONS(9672), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6416), 1,
      aux_sym_compound_type_repeat1,
    STATE(6698), 1,
      sym_type_arguments,
    STATE(6730), 1,
      sym_long_identifier,
    ACTIONS(3417), 3,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(6240), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3419), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [138510] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3492), 1,
      anon_sym_LT2,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9759), 1,
      anon_sym_DOT,
    STATE(6234), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(9765), 2,
      anon_sym_let,
      anon_sym_LPAREN,
    STATE(6241), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9763), 15,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [138568] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6242), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3996), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3994), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [138620] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6243), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4064), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(4062), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [138672] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6244), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4003), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(4001), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [138724] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6245), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3845), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3843), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [138776] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6192), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9767), 1,
      anon_sym_and,
    STATE(6277), 1,
      aux_sym__function_or_value_defns_repeat1,
    STATE(6246), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6190), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [138832] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6247), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4018), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(4016), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [138884] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6248), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4054), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(4052), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [138936] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9769), 1,
      anon_sym_DOT,
    ACTIONS(3487), 2,
      anon_sym_let,
      anon_sym_LPAREN,
    STATE(6249), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3485), 16,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_LT2,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [138990] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6250), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4082), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(4080), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [139042] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9400), 1,
      sym_identifier,
    ACTIONS(9730), 1,
      anon_sym_LT2,
    ACTIONS(9732), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(9772), 1,
      anon_sym_DASH_GT,
    ACTIONS(9774), 1,
      anon_sym_STAR,
    STATE(6501), 1,
      aux_sym_compound_type_repeat1,
    STATE(6558), 1,
      sym_long_identifier,
    STATE(6573), 1,
      sym_type_arguments,
    ACTIONS(3425), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(6251), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3427), 8,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [139110] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6252), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4093), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(4091), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [139162] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6253), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4108), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(4106), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [139214] = 26,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7932), 1,
      sym__dedent,
    ACTIONS(9709), 1,
      anon_sym_new,
    ACTIONS(9713), 1,
      anon_sym_static,
    ACTIONS(9715), 1,
      anon_sym_member,
    ACTIONS(9717), 1,
      anon_sym_interface,
    ACTIONS(9719), 1,
      anon_sym_abstract,
    ACTIONS(9721), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6206), 1,
      aux_sym_interface_type_defn_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7519), 1,
      sym__type_defn_elements,
    STATE(7525), 1,
      sym_additional_constr_defn,
    STATE(7949), 1,
      sym_attributes,
    STATE(11862), 1,
      sym_access_modifier,
    ACTIONS(9711), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7524), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6254), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139298] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9328), 1,
      sym_identifier,
    ACTIONS(9670), 1,
      anon_sym_LT2,
    ACTIONS(9672), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6416), 1,
      aux_sym_compound_type_repeat1,
    STATE(6698), 1,
      sym_type_arguments,
    STATE(6730), 1,
      sym_long_identifier,
    ACTIONS(5609), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    ACTIONS(5621), 3,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(6255), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5623), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [139364] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6256), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8201), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(8203), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [139416] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6257), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4112), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(4110), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [139468] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9328), 1,
      sym_identifier,
    ACTIONS(9670), 1,
      anon_sym_LT2,
    ACTIONS(9672), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6416), 1,
      aux_sym_compound_type_repeat1,
    STATE(6698), 1,
      sym_type_arguments,
    STATE(6730), 1,
      sym_long_identifier,
    ACTIONS(5609), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    ACTIONS(5605), 3,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(6258), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5607), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [139534] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6259), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4118), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(4116), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [139586] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6260), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4122), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(4120), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [139638] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6261), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8205), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(8207), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [139690] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6262), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4126), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(4124), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [139742] = 26,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9709), 1,
      anon_sym_new,
    ACTIONS(9713), 1,
      anon_sym_static,
    ACTIONS(9715), 1,
      anon_sym_member,
    ACTIONS(9717), 1,
      anon_sym_interface,
    ACTIONS(9719), 1,
      anon_sym_abstract,
    ACTIONS(9721), 1,
      anon_sym_val,
    ACTIONS(9776), 1,
      sym__dedent,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6203), 1,
      aux_sym_interface_type_defn_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7519), 1,
      sym__type_defn_elements,
    STATE(7525), 1,
      sym_additional_constr_defn,
    STATE(7949), 1,
      sym_attributes,
    STATE(11862), 1,
      sym_access_modifier,
    ACTIONS(9711), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7524), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6263), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139826] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6264), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4232), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(4230), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [139878] = 26,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7940), 1,
      sym__dedent,
    ACTIONS(9709), 1,
      anon_sym_new,
    ACTIONS(9713), 1,
      anon_sym_static,
    ACTIONS(9715), 1,
      anon_sym_member,
    ACTIONS(9717), 1,
      anon_sym_interface,
    ACTIONS(9719), 1,
      anon_sym_abstract,
    ACTIONS(9721), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6272), 1,
      aux_sym_interface_type_defn_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7519), 1,
      sym__type_defn_elements,
    STATE(7525), 1,
      sym_additional_constr_defn,
    STATE(7949), 1,
      sym_attributes,
    STATE(11862), 1,
      sym_access_modifier,
    ACTIONS(9711), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7524), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6265), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139962] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6428), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6266), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6426), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [140014] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6267), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4186), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(4184), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [140066] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6268), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3962), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3960), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [140118] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6269), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3958), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3956), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [140170] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9328), 1,
      sym_identifier,
    ACTIONS(9666), 1,
      anon_sym_DASH_GT,
    ACTIONS(9668), 1,
      anon_sym_STAR,
    ACTIONS(9670), 1,
      anon_sym_LT2,
    ACTIONS(9672), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6416), 1,
      aux_sym_compound_type_repeat1,
    STATE(6698), 1,
      sym_type_arguments,
    STATE(6730), 1,
      sym_long_identifier,
    ACTIONS(3403), 3,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(6270), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3407), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [140238] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9328), 1,
      sym_identifier,
    ACTIONS(9666), 1,
      anon_sym_DASH_GT,
    ACTIONS(9668), 1,
      anon_sym_STAR,
    ACTIONS(9670), 1,
      anon_sym_LT2,
    ACTIONS(9672), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6416), 1,
      aux_sym_compound_type_repeat1,
    STATE(6698), 1,
      sym_type_arguments,
    STATE(6730), 1,
      sym_long_identifier,
    ACTIONS(3425), 3,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(6271), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3427), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [140306] = 26,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9709), 1,
      anon_sym_new,
    ACTIONS(9713), 1,
      anon_sym_static,
    ACTIONS(9715), 1,
      anon_sym_member,
    ACTIONS(9717), 1,
      anon_sym_interface,
    ACTIONS(9719), 1,
      anon_sym_abstract,
    ACTIONS(9721), 1,
      anon_sym_val,
    ACTIONS(9778), 1,
      sym__dedent,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6203), 1,
      aux_sym_interface_type_defn_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7519), 1,
      sym__type_defn_elements,
    STATE(7525), 1,
      sym_additional_constr_defn,
    STATE(7949), 1,
      sym_attributes,
    STATE(11862), 1,
      sym_access_modifier,
    ACTIONS(9711), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7524), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6272), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140390] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9755), 1,
      anon_sym_or,
    STATE(6232), 1,
      aux_sym_type_argument_repeat1,
    STATE(6273), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 9,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3498), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [140446] = 26,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9709), 1,
      anon_sym_new,
    ACTIONS(9713), 1,
      anon_sym_static,
    ACTIONS(9715), 1,
      anon_sym_member,
    ACTIONS(9717), 1,
      anon_sym_interface,
    ACTIONS(9719), 1,
      anon_sym_abstract,
    ACTIONS(9721), 1,
      anon_sym_val,
    ACTIONS(9780), 1,
      sym__dedent,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6203), 1,
      aux_sym_interface_type_defn_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7519), 1,
      sym__type_defn_elements,
    STATE(7525), 1,
      sym_additional_constr_defn,
    STATE(7949), 1,
      sym_attributes,
    STATE(11862), 1,
      sym_access_modifier,
    ACTIONS(9711), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7524), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6274), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140530] = 26,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9709), 1,
      anon_sym_new,
    ACTIONS(9713), 1,
      anon_sym_static,
    ACTIONS(9715), 1,
      anon_sym_member,
    ACTIONS(9717), 1,
      anon_sym_interface,
    ACTIONS(9719), 1,
      anon_sym_abstract,
    ACTIONS(9721), 1,
      anon_sym_val,
    ACTIONS(9782), 1,
      sym__dedent,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6203), 1,
      aux_sym_interface_type_defn_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7519), 1,
      sym__type_defn_elements,
    STATE(7525), 1,
      sym_additional_constr_defn,
    STATE(7949), 1,
      sym_attributes,
    STATE(11862), 1,
      sym_access_modifier,
    ACTIONS(9711), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7524), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6275), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140614] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6276), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9784), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(9786), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [140666] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6158), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9767), 1,
      anon_sym_and,
    STATE(6279), 1,
      aux_sym__function_or_value_defns_repeat1,
    STATE(6277), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6156), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [140722] = 26,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7922), 1,
      sym__dedent,
    ACTIONS(9709), 1,
      anon_sym_new,
    ACTIONS(9713), 1,
      anon_sym_static,
    ACTIONS(9715), 1,
      anon_sym_member,
    ACTIONS(9717), 1,
      anon_sym_interface,
    ACTIONS(9719), 1,
      anon_sym_abstract,
    ACTIONS(9721), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6275), 1,
      aux_sym_interface_type_defn_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7519), 1,
      sym__type_defn_elements,
    STATE(7525), 1,
      sym_additional_constr_defn,
    STATE(7949), 1,
      sym_attributes,
    STATE(11862), 1,
      sym_access_modifier,
    ACTIONS(9711), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7524), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6278), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140806] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6117), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9788), 1,
      anon_sym_and,
    STATE(6279), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__function_or_value_defns_repeat1,
    ACTIONS(6115), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [140860] = 26,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9709), 1,
      anon_sym_new,
    ACTIONS(9713), 1,
      anon_sym_static,
    ACTIONS(9715), 1,
      anon_sym_member,
    ACTIONS(9717), 1,
      anon_sym_interface,
    ACTIONS(9719), 1,
      anon_sym_abstract,
    ACTIONS(9721), 1,
      anon_sym_val,
    ACTIONS(9791), 1,
      sym__dedent,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6203), 1,
      aux_sym_interface_type_defn_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7519), 1,
      sym__type_defn_elements,
    STATE(7525), 1,
      sym_additional_constr_defn,
    STATE(7949), 1,
      sym_attributes,
    STATE(11862), 1,
      sym_access_modifier,
    ACTIONS(9711), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7524), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6280), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140944] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6281), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3954), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3952), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [140996] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6282), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3950), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3948), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [141048] = 26,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7934), 1,
      sym__dedent,
    ACTIONS(9709), 1,
      anon_sym_new,
    ACTIONS(9713), 1,
      anon_sym_static,
    ACTIONS(9715), 1,
      anon_sym_member,
    ACTIONS(9717), 1,
      anon_sym_interface,
    ACTIONS(9719), 1,
      anon_sym_abstract,
    ACTIONS(9721), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6302), 1,
      aux_sym_interface_type_defn_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7519), 1,
      sym__type_defn_elements,
    STATE(7525), 1,
      sym_additional_constr_defn,
    STATE(7949), 1,
      sym_attributes,
    STATE(11862), 1,
      sym_access_modifier,
    ACTIONS(9711), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7524), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6283), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141132] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6284), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4170), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(4168), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [141184] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6285), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3976), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3974), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [141236] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9400), 1,
      sym_identifier,
    ACTIONS(9730), 1,
      anon_sym_LT2,
    ACTIONS(9732), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(9772), 1,
      anon_sym_DASH_GT,
    ACTIONS(9774), 1,
      anon_sym_STAR,
    STATE(6501), 1,
      aux_sym_compound_type_repeat1,
    STATE(6558), 1,
      sym_long_identifier,
    STATE(6573), 1,
      sym_type_arguments,
    ACTIONS(3417), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(6286), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3419), 8,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [141304] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6287), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3935), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3933), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [141356] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6288), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3885), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3883), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [141408] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8756), 1,
      anon_sym_EQ,
    ACTIONS(8760), 1,
      anon_sym_COLON,
    ACTIONS(8762), 1,
      anon_sym_let,
    ACTIONS(9793), 1,
      anon_sym_of,
    STATE(6289), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8758), 16,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [141466] = 26,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9709), 1,
      anon_sym_new,
    ACTIONS(9713), 1,
      anon_sym_static,
    ACTIONS(9715), 1,
      anon_sym_member,
    ACTIONS(9717), 1,
      anon_sym_interface,
    ACTIONS(9719), 1,
      anon_sym_abstract,
    ACTIONS(9721), 1,
      anon_sym_val,
    ACTIONS(9795), 1,
      sym__dedent,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6203), 1,
      aux_sym_interface_type_defn_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7519), 1,
      sym__type_defn_elements,
    STATE(7525), 1,
      sym_additional_constr_defn,
    STATE(7949), 1,
      sym_attributes,
    STATE(11862), 1,
      sym_access_modifier,
    ACTIONS(9711), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7524), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6290), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141550] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6291), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4130), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(4128), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [141602] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6292), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3972), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3970), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [141654] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3492), 1,
      anon_sym_LT2,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9759), 1,
      anon_sym_DOT,
    STATE(6234), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(9799), 2,
      anon_sym_let,
      anon_sym_LPAREN,
    STATE(6293), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9797), 15,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [141712] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6294), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9801), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(9803), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [141764] = 26,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7872), 1,
      sym__dedent,
    ACTIONS(9709), 1,
      anon_sym_new,
    ACTIONS(9713), 1,
      anon_sym_static,
    ACTIONS(9715), 1,
      anon_sym_member,
    ACTIONS(9717), 1,
      anon_sym_interface,
    ACTIONS(9719), 1,
      anon_sym_abstract,
    ACTIONS(9721), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6274), 1,
      aux_sym_interface_type_defn_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7519), 1,
      sym__type_defn_elements,
    STATE(7525), 1,
      sym_additional_constr_defn,
    STATE(7949), 1,
      sym_attributes,
    STATE(11862), 1,
      sym_access_modifier,
    ACTIONS(9711), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7524), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6295), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141848] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9328), 1,
      sym_identifier,
    ACTIONS(9666), 1,
      anon_sym_DASH_GT,
    ACTIONS(9668), 1,
      anon_sym_STAR,
    ACTIONS(9670), 1,
      anon_sym_LT2,
    ACTIONS(9672), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6416), 1,
      aux_sym_compound_type_repeat1,
    STATE(6698), 1,
      sym_type_arguments,
    STATE(6730), 1,
      sym_long_identifier,
    ACTIONS(3429), 3,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(6296), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3431), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [141916] = 26,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9709), 1,
      anon_sym_new,
    ACTIONS(9713), 1,
      anon_sym_static,
    ACTIONS(9715), 1,
      anon_sym_member,
    ACTIONS(9717), 1,
      anon_sym_interface,
    ACTIONS(9719), 1,
      anon_sym_abstract,
    ACTIONS(9721), 1,
      anon_sym_val,
    ACTIONS(9805), 1,
      sym__dedent,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6203), 1,
      aux_sym_interface_type_defn_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7519), 1,
      sym__type_defn_elements,
    STATE(7525), 1,
      sym_additional_constr_defn,
    STATE(7949), 1,
      sym_attributes,
    STATE(11862), 1,
      sym_access_modifier,
    ACTIONS(9711), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7524), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6297), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142000] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6298), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8209), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(8211), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [142052] = 26,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9709), 1,
      anon_sym_new,
    ACTIONS(9713), 1,
      anon_sym_static,
    ACTIONS(9715), 1,
      anon_sym_member,
    ACTIONS(9717), 1,
      anon_sym_interface,
    ACTIONS(9719), 1,
      anon_sym_abstract,
    ACTIONS(9721), 1,
      anon_sym_val,
    ACTIONS(9807), 1,
      sym__dedent,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6203), 1,
      aux_sym_interface_type_defn_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7519), 1,
      sym__type_defn_elements,
    STATE(7525), 1,
      sym_additional_constr_defn,
    STATE(7949), 1,
      sym_attributes,
    STATE(11862), 1,
      sym_access_modifier,
    ACTIONS(9711), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7524), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6299), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142136] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9400), 1,
      sym_identifier,
    ACTIONS(9730), 1,
      anon_sym_LT2,
    ACTIONS(9732), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(9772), 1,
      anon_sym_DASH_GT,
    ACTIONS(9774), 1,
      anon_sym_STAR,
    STATE(6501), 1,
      aux_sym_compound_type_repeat1,
    STATE(6558), 1,
      sym_long_identifier,
    STATE(6573), 1,
      sym_type_arguments,
    ACTIONS(3403), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(6300), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3407), 8,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [142204] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6301), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8284), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(8286), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [142256] = 26,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9709), 1,
      anon_sym_new,
    ACTIONS(9713), 1,
      anon_sym_static,
    ACTIONS(9715), 1,
      anon_sym_member,
    ACTIONS(9717), 1,
      anon_sym_interface,
    ACTIONS(9719), 1,
      anon_sym_abstract,
    ACTIONS(9721), 1,
      anon_sym_val,
    ACTIONS(9809), 1,
      sym__dedent,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6203), 1,
      aux_sym_interface_type_defn_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7519), 1,
      sym__type_defn_elements,
    STATE(7525), 1,
      sym_additional_constr_defn,
    STATE(7949), 1,
      sym_attributes,
    STATE(11862), 1,
      sym_access_modifier,
    ACTIONS(9711), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7524), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6302), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142340] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5601), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9811), 1,
      anon_sym_DOT,
    STATE(6324), 1,
      aux_sym_long_identifier_repeat1,
    STATE(6303), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3494), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [142398] = 26,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9709), 1,
      anon_sym_new,
    ACTIONS(9713), 1,
      anon_sym_static,
    ACTIONS(9715), 1,
      anon_sym_member,
    ACTIONS(9717), 1,
      anon_sym_interface,
    ACTIONS(9719), 1,
      anon_sym_abstract,
    ACTIONS(9721), 1,
      anon_sym_val,
    ACTIONS(9813), 1,
      sym__dedent,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6203), 1,
      aux_sym_interface_type_defn_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7519), 1,
      sym__type_defn_elements,
    STATE(7525), 1,
      sym_additional_constr_defn,
    STATE(7949), 1,
      sym_attributes,
    STATE(11862), 1,
      sym_access_modifier,
    ACTIONS(9711), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7524), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6304), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142482] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9400), 1,
      sym_identifier,
    ACTIONS(9730), 1,
      anon_sym_LT2,
    ACTIONS(9732), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(9772), 1,
      anon_sym_DASH_GT,
    ACTIONS(9774), 1,
      anon_sym_STAR,
    STATE(6501), 1,
      aux_sym_compound_type_repeat1,
    STATE(6558), 1,
      sym_long_identifier,
    STATE(6573), 1,
      sym_type_arguments,
    ACTIONS(3429), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(6305), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3431), 8,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [142550] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3492), 1,
      anon_sym_LT2,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9759), 1,
      anon_sym_DOT,
    STATE(6234), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(9817), 2,
      anon_sym_let,
      anon_sym_LPAREN,
    STATE(6306), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9815), 15,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [142608] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6307), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8288), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(8290), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [142660] = 22,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3193), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9572), 1,
      anon_sym_y,
    ACTIONS(9574), 1,
      anon_sym_uy,
    ACTIONS(9576), 1,
      anon_sym_s,
    ACTIONS(9578), 1,
      anon_sym_us,
    ACTIONS(9582), 1,
      aux_sym_uint32_token1,
    ACTIONS(9584), 1,
      anon_sym_n,
    ACTIONS(9586), 1,
      anon_sym_un,
    ACTIONS(9590), 1,
      aux_sym_uint64_token1,
    ACTIONS(9819), 1,
      anon_sym_l,
    ACTIONS(9821), 1,
      anon_sym_L,
    ACTIONS(9823), 1,
      anon_sym_lf,
    ACTIONS(9825), 1,
      anon_sym_LF,
    STATE(6308), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3191), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [142736] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9328), 1,
      sym_identifier,
    ACTIONS(9666), 1,
      anon_sym_DASH_GT,
    ACTIONS(9668), 1,
      anon_sym_STAR,
    ACTIONS(9670), 1,
      anon_sym_LT2,
    ACTIONS(9672), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6416), 1,
      aux_sym_compound_type_repeat1,
    STATE(6698), 1,
      sym_type_arguments,
    STATE(6730), 1,
      sym_long_identifier,
    ACTIONS(6008), 3,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(6309), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6010), 8,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [142803] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6318), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6310), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6316), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [142854] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9328), 1,
      sym_identifier,
    ACTIONS(9666), 1,
      anon_sym_DASH_GT,
    ACTIONS(9668), 1,
      anon_sym_STAR,
    ACTIONS(9670), 1,
      anon_sym_LT2,
    ACTIONS(9672), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6416), 1,
      aux_sym_compound_type_repeat1,
    STATE(6698), 1,
      sym_type_arguments,
    STATE(6730), 1,
      sym_long_identifier,
    ACTIONS(5996), 3,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(6311), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5998), 8,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [142921] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3700), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6312), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3698), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [142972] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9827), 1,
      anon_sym_LT2,
    STATE(6727), 1,
      sym_type_arguments,
    ACTIONS(9817), 2,
      anon_sym_let,
      anon_sym_LPAREN,
    STATE(6313), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9815), 15,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [143027] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9328), 1,
      sym_identifier,
    ACTIONS(9666), 1,
      anon_sym_DASH_GT,
    ACTIONS(9668), 1,
      anon_sym_STAR,
    ACTIONS(9670), 1,
      anon_sym_LT2,
    ACTIONS(9672), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6416), 1,
      aux_sym_compound_type_repeat1,
    STATE(6698), 1,
      sym_type_arguments,
    STATE(6730), 1,
      sym_long_identifier,
    ACTIONS(6022), 3,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(6314), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6024), 8,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [143094] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9831), 1,
      anon_sym_let,
    STATE(6315), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9829), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [143145] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6316), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3547), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3545), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [143196] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9833), 1,
      anon_sym_let,
    STATE(6317), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7706), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [143247] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6318), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3478), 8,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3480), 11,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [143298] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6288), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6319), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6286), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [143349] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6344), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6320), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6342), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [143400] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8764), 1,
      anon_sym_DOT,
    STATE(6355), 1,
      aux_sym_long_identifier_repeat1,
    STATE(6321), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 7,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3494), 10,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [143455] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6336), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6322), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6334), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [143506] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6280), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6323), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6278), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [143557] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9811), 1,
      anon_sym_DOT,
    STATE(6408), 1,
      aux_sym_long_identifier_repeat1,
    STATE(6324), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3449), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3451), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [143612] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9837), 1,
      anon_sym_let,
    STATE(6325), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9835), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [143663] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9827), 1,
      anon_sym_LT2,
    STATE(6678), 1,
      sym_type_arguments,
    ACTIONS(9799), 2,
      anon_sym_let,
      anon_sym_LPAREN,
    STATE(6326), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9797), 15,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [143718] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4975), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6327), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4973), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [143769] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6328), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3543), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3541), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [143820] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9400), 1,
      sym_identifier,
    ACTIONS(9730), 1,
      anon_sym_LT2,
    ACTIONS(9732), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(9772), 1,
      anon_sym_DASH_GT,
    ACTIONS(9774), 1,
      anon_sym_STAR,
    STATE(6501), 1,
      aux_sym_compound_type_repeat1,
    STATE(6558), 1,
      sym_long_identifier,
    STATE(6573), 1,
      sym_type_arguments,
    ACTIONS(5996), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(6329), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5998), 7,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [143887] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9386), 2,
      anon_sym_let,
      anon_sym_LPAREN,
    STATE(6330), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9388), 17,
      anon_sym_module,
      anon_sym_LBRACK_LT,
      anon_sym_type,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym__,
      anon_sym_new,
      anon_sym_CARET,
      anon_sym_SQUOTE,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_exception,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [143938] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6331), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3509), 8,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3511), 11,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [143989] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6380), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6332), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6378), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [144040] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6392), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6333), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6390), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [144091] = 25,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9709), 1,
      anon_sym_new,
    ACTIONS(9713), 1,
      anon_sym_static,
    ACTIONS(9715), 1,
      anon_sym_member,
    ACTIONS(9717), 1,
      anon_sym_interface,
    ACTIONS(9719), 1,
      anon_sym_abstract,
    ACTIONS(9721), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6280), 1,
      aux_sym_interface_type_defn_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7519), 1,
      sym__type_defn_elements,
    STATE(7525), 1,
      sym_additional_constr_defn,
    STATE(7949), 1,
      sym_attributes,
    STATE(11862), 1,
      sym_access_modifier,
    ACTIONS(9711), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7524), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6334), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144172] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9400), 1,
      sym_identifier,
    ACTIONS(9730), 1,
      anon_sym_LT2,
    ACTIONS(9732), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(9772), 1,
      anon_sym_DASH_GT,
    ACTIONS(9774), 1,
      anon_sym_STAR,
    STATE(6501), 1,
      aux_sym_compound_type_repeat1,
    STATE(6558), 1,
      sym_long_identifier,
    STATE(6573), 1,
      sym_type_arguments,
    ACTIONS(6030), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(6335), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6032), 7,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [144239] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9811), 1,
      anon_sym_DOT,
    STATE(6324), 1,
      aux_sym_long_identifier_repeat1,
    STATE(6336), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3494), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [144294] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6396), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6337), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6394), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [144345] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8760), 1,
      anon_sym_COLON,
    ACTIONS(8762), 1,
      anon_sym_let,
    ACTIONS(9793), 1,
      anon_sym_of,
    STATE(6338), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8758), 16,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [144400] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6376), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6339), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6374), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [144451] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6134), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9839), 1,
      anon_sym_COMMA,
    STATE(6340), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6132), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [144504] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6823), 1,
      anon_sym_let,
    STATE(6341), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6821), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [144555] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6024), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6342), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6022), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [144606] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3700), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6343), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3698), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [144657] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6170), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6344), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6168), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [144708] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(2692), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6345), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2690), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [144759] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6404), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6346), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6402), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [144810] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6420), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6347), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6418), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [144861] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6428), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6348), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6426), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [144912] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4975), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6349), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4973), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [144963] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6032), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6350), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6030), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [145014] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6274), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6351), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6272), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [145065] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6134), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9841), 1,
      anon_sym_COMMA,
    STATE(6352), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6132), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [145118] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6416), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6353), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6414), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [145169] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6322), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6354), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6320), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [145220] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8764), 1,
      anon_sym_DOT,
    STATE(6363), 1,
      aux_sym_long_identifier_repeat1,
    STATE(6355), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3449), 7,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3451), 10,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [145275] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6436), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6356), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6434), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [145326] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9400), 1,
      sym_identifier,
    ACTIONS(9730), 1,
      anon_sym_LT2,
    ACTIONS(9732), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(9772), 1,
      anon_sym_DASH_GT,
    ACTIONS(9774), 1,
      anon_sym_STAR,
    STATE(6501), 1,
      aux_sym_compound_type_repeat1,
    STATE(6558), 1,
      sym_long_identifier,
    STATE(6573), 1,
      sym_type_arguments,
    ACTIONS(6008), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(6357), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6010), 7,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [145393] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6318), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6358), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6316), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [145444] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6408), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6359), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6406), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [145495] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9328), 1,
      sym_identifier,
    ACTIONS(9666), 1,
      anon_sym_DASH_GT,
    ACTIONS(9668), 1,
      anon_sym_STAR,
    ACTIONS(9670), 1,
      anon_sym_LT2,
    ACTIONS(9672), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6416), 1,
      aux_sym_compound_type_repeat1,
    STATE(6698), 1,
      sym_type_arguments,
    STATE(6730), 1,
      sym_long_identifier,
    ACTIONS(5984), 3,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(6360), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5986), 8,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [145562] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6361), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3539), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3537), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [145613] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6400), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6362), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6398), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [145664] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9843), 1,
      anon_sym_DOT,
    STATE(6363), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3485), 7,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3487), 10,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [145717] = 25,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9709), 1,
      anon_sym_new,
    ACTIONS(9713), 1,
      anon_sym_static,
    ACTIONS(9715), 1,
      anon_sym_member,
    ACTIONS(9717), 1,
      anon_sym_interface,
    ACTIONS(9719), 1,
      anon_sym_abstract,
    ACTIONS(9721), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6297), 1,
      aux_sym_interface_type_defn_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7519), 1,
      sym__type_defn_elements,
    STATE(7525), 1,
      sym_additional_constr_defn,
    STATE(7949), 1,
      sym_attributes,
    STATE(11862), 1,
      sym_access_modifier,
    ACTIONS(9711), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7524), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6364), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145798] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6302), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6365), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6300), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [145849] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9848), 1,
      anon_sym_let,
    ACTIONS(9850), 1,
      anon_sym_STAR,
    STATE(6413), 1,
      aux_sym_union_type_fields_repeat1,
    STATE(6366), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9846), 16,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [145904] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6340), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6367), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6338), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [145955] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9854), 1,
      anon_sym_let,
    STATE(6368), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9852), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [146006] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6326), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6369), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6324), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [146057] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9414), 2,
      anon_sym_let,
      anon_sym_LPAREN,
    STATE(6370), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9416), 17,
      anon_sym_module,
      anon_sym_LBRACK_LT,
      anon_sym_type,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym__,
      anon_sym_new,
      anon_sym_CARET,
      anon_sym_SQUOTE,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_exception,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [146108] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6296), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6371), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6294), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [146159] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9400), 1,
      sym_identifier,
    ACTIONS(9730), 1,
      anon_sym_LT2,
    ACTIONS(9732), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(9772), 1,
      anon_sym_DASH_GT,
    ACTIONS(9774), 1,
      anon_sym_STAR,
    STATE(6501), 1,
      aux_sym_compound_type_repeat1,
    STATE(6558), 1,
      sym_long_identifier,
    STATE(6573), 1,
      sym_type_arguments,
    ACTIONS(6022), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(6372), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6024), 7,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [146226] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6010), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6373), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6008), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [146277] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6454), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6374), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6452), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [146328] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6375), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3478), 9,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3480), 10,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [146379] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9400), 1,
      sym_identifier,
    ACTIONS(9730), 1,
      anon_sym_LT2,
    ACTIONS(9732), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(9772), 1,
      anon_sym_DASH_GT,
    ACTIONS(9774), 1,
      anon_sym_STAR,
    STATE(6501), 1,
      aux_sym_compound_type_repeat1,
    STATE(6558), 1,
      sym_long_identifier,
    STATE(6573), 1,
      sym_type_arguments,
    ACTIONS(5984), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(6376), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5986), 7,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [146446] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6292), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6377), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6290), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [146497] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6302), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6378), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6300), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [146548] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4975), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6379), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4973), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [146599] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9858), 1,
      anon_sym_COLON,
    ACTIONS(9860), 1,
      anon_sym_let,
    ACTIONS(9862), 1,
      anon_sym_of,
    STATE(6380), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9856), 16,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [146654] = 25,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9709), 1,
      anon_sym_new,
    ACTIONS(9713), 1,
      anon_sym_static,
    ACTIONS(9715), 1,
      anon_sym_member,
    ACTIONS(9717), 1,
      anon_sym_interface,
    ACTIONS(9719), 1,
      anon_sym_abstract,
    ACTIONS(9721), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6263), 1,
      aux_sym_interface_type_defn_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7519), 1,
      sym__type_defn_elements,
    STATE(7525), 1,
      sym_additional_constr_defn,
    STATE(7949), 1,
      sym_attributes,
    STATE(11862), 1,
      sym_access_modifier,
    ACTIONS(9711), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7524), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6381), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146735] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6306), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6382), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6304), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [146786] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6388), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6383), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6386), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [146837] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6444), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6384), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6442), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [146888] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6448), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6385), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6446), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [146939] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6134), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6386), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6132), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [146990] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6124), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9864), 1,
      anon_sym_COMMA,
    STATE(6387), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6122), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [147043] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(2692), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6388), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2690), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [147094] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9530), 1,
      sym_identifier,
    ACTIONS(9866), 1,
      anon_sym_DASH_GT,
    ACTIONS(9868), 1,
      anon_sym_when,
    ACTIONS(9870), 1,
      anon_sym_STAR,
    ACTIONS(9872), 1,
      anon_sym_LT2,
    ACTIONS(9874), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6929), 1,
      aux_sym_compound_type_repeat1,
    STATE(6947), 1,
      sym_type_arguments,
    STATE(7001), 1,
      sym_long_identifier,
    STATE(8052), 1,
      sym_type_argument_constraints,
    ACTIONS(7226), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(6389), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7224), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [147165] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6458), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6390), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6456), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [147216] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(2692), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6391), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2690), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [147267] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6384), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6392), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6382), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [147318] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6330), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6393), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6328), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [147369] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9360), 2,
      anon_sym_let,
      anon_sym_LPAREN,
    STATE(6394), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9362), 17,
      anon_sym_module,
      anon_sym_LBRACK_LT,
      anon_sym_type,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym__,
      anon_sym_new,
      anon_sym_CARET,
      anon_sym_SQUOTE,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_exception,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [147420] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6124), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9876), 1,
      anon_sym_COMMA,
    STATE(6395), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6122), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [147473] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6314), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6396), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6312), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [147524] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6388), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6397), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6386), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [147575] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9328), 1,
      sym_identifier,
    ACTIONS(9666), 1,
      anon_sym_DASH_GT,
    ACTIONS(9668), 1,
      anon_sym_STAR,
    ACTIONS(9670), 1,
      anon_sym_LT2,
    ACTIONS(9672), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6416), 1,
      aux_sym_compound_type_repeat1,
    STATE(6698), 1,
      sym_type_arguments,
    STATE(6730), 1,
      sym_long_identifier,
    ACTIONS(6030), 3,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(6398), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6032), 8,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [147642] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6399), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3509), 9,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3511), 10,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [147693] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6310), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6400), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6308), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [147744] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9850), 1,
      anon_sym_STAR,
    ACTIONS(9880), 1,
      anon_sym_let,
    STATE(6366), 1,
      aux_sym_union_type_fields_repeat1,
    STATE(6401), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9878), 16,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [147799] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6412), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6402), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6410), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [147850] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6184), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9882), 1,
      anon_sym_COMMA,
    STATE(6403), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6182), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [147903] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6184), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9884), 1,
      anon_sym_COMMA,
    STATE(6404), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6182), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [147956] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3487), 2,
      anon_sym_let,
      anon_sym_LPAREN,
    STATE(6405), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3485), 17,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_DOT,
      anon_sym_new,
      anon_sym_with,
      anon_sym_LT2,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [148007] = 25,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9709), 1,
      anon_sym_new,
    ACTIONS(9713), 1,
      anon_sym_static,
    ACTIONS(9715), 1,
      anon_sym_member,
    ACTIONS(9717), 1,
      anon_sym_interface,
    ACTIONS(9719), 1,
      anon_sym_abstract,
    ACTIONS(9721), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6222), 1,
      aux_sym_interface_type_defn_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7519), 1,
      sym__type_defn_elements,
    STATE(7525), 1,
      sym_additional_constr_defn,
    STATE(7949), 1,
      sym_attributes,
    STATE(11862), 1,
      sym_access_modifier,
    ACTIONS(9711), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7524), 2,
      sym_interface_implementation,
      sym_member_defn,
    STATE(6406), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148088] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6432), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6407), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6430), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [148139] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9886), 1,
      anon_sym_DOT,
    STATE(6408), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3485), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3487), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [148192] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9891), 1,
      anon_sym_let,
    STATE(6409), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9889), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [148243] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6440), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6410), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6438), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [148294] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(239), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9893), 1,
      anon_sym_COMMA,
    STATE(6411), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(237), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [148347] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6284), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6412), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6282), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [148398] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9897), 1,
      anon_sym_let,
    ACTIONS(9899), 1,
      anon_sym_STAR,
    STATE(6413), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_union_type_fields_repeat1,
    ACTIONS(9895), 16,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [148451] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9827), 1,
      anon_sym_LT2,
    STATE(6577), 1,
      sym_type_arguments,
    ACTIONS(9765), 2,
      anon_sym_let,
      anon_sym_LPAREN,
    STATE(6414), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9763), 15,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [148506] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(239), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9902), 1,
      anon_sym_COMMA,
    STATE(6415), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(237), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [148559] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9668), 1,
      anon_sym_STAR,
    STATE(6476), 1,
      aux_sym_compound_type_repeat1,
    STATE(6416), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3466), 6,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3468), 10,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [148613] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9904), 1,
      anon_sym_COLON_GT,
    STATE(6417), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3515), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [148665] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6454), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6418), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6452), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [148715] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(239), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9906), 1,
      anon_sym_COMMA,
    STATE(6419), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(237), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [148767] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6184), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9908), 1,
      anon_sym_COMMA,
    STATE(6420), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6182), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [148819] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9496), 1,
      sym_identifier,
    ACTIONS(9910), 1,
      anon_sym_DASH_GT,
    ACTIONS(9912), 1,
      anon_sym_STAR,
    ACTIONS(9914), 1,
      anon_sym_LT2,
    ACTIONS(9916), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6909), 1,
      aux_sym_compound_type_repeat1,
    STATE(6970), 1,
      sym_type_arguments,
    STATE(6979), 1,
      sym_long_identifier,
    ACTIONS(3427), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(6421), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3425), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [148885] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9918), 1,
      anon_sym_or,
    ACTIONS(3480), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6422), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3478), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [148937] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6184), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9921), 1,
      anon_sym_COMMA,
    STATE(6423), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6182), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [148989] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9496), 1,
      sym_identifier,
    ACTIONS(9910), 1,
      anon_sym_DASH_GT,
    ACTIONS(9912), 1,
      anon_sym_STAR,
    ACTIONS(9914), 1,
      anon_sym_LT2,
    ACTIONS(9916), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6909), 1,
      aux_sym_compound_type_repeat1,
    STATE(6970), 1,
      sym_type_arguments,
    STATE(6979), 1,
      sym_long_identifier,
    ACTIONS(3431), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(6424), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3429), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [149055] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6024), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6425), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6022), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [149105] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9897), 1,
      anon_sym_let,
    STATE(6426), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9895), 17,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_new,
      anon_sym_with,
      anon_sym_STAR,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [149155] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9496), 1,
      sym_identifier,
    ACTIONS(9910), 1,
      anon_sym_DASH_GT,
    ACTIONS(9912), 1,
      anon_sym_STAR,
    ACTIONS(9914), 1,
      anon_sym_LT2,
    ACTIONS(9916), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6909), 1,
      aux_sym_compound_type_repeat1,
    STATE(6970), 1,
      sym_type_arguments,
    STATE(6979), 1,
      sym_long_identifier,
    ACTIONS(3407), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(6427), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3403), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [149221] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9530), 1,
      sym_identifier,
    ACTIONS(9866), 1,
      anon_sym_DASH_GT,
    ACTIONS(9870), 1,
      anon_sym_STAR,
    ACTIONS(9872), 1,
      anon_sym_LT2,
    ACTIONS(9874), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6929), 1,
      aux_sym_compound_type_repeat1,
    STATE(6947), 1,
      sym_type_arguments,
    STATE(7001), 1,
      sym_long_identifier,
    ACTIONS(3431), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    STATE(6428), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3429), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [149287] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6124), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9923), 1,
      anon_sym_COMMA,
    STATE(6429), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6122), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [149339] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6322), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6430), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6320), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [149389] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6124), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9925), 1,
      anon_sym_COMMA,
    STATE(6431), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6122), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [149441] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6124), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9927), 1,
      anon_sym_COMMA,
    STATE(6432), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6122), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [149493] = 24,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9929), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(9932), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(9935), 1,
      anon_sym_new,
    ACTIONS(9941), 1,
      anon_sym_static,
    ACTIONS(9944), 1,
      anon_sym_member,
    ACTIONS(9947), 1,
      anon_sym_abstract,
    ACTIONS(9950), 1,
      anon_sym_val,
    ACTIONS(9953), 1,
      sym__newline,
    ACTIONS(9956), 1,
      sym__dedent,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7566), 1,
      sym_member_defn,
    STATE(7634), 1,
      sym_additional_constr_defn,
    STATE(7920), 1,
      sym_attributes,
    STATE(11902), 1,
      sym_access_modifier,
    ACTIONS(9938), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6433), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__member_defns_repeat1,
  [149571] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6434), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3485), 9,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3487), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [149621] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6435), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 9,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3498), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [149671] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6134), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9958), 1,
      anon_sym_COMMA,
    STATE(6436), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6132), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [149723] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6274), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9960), 1,
      anon_sym_with,
    STATE(6437), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6272), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [149775] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6440), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6438), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6438), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [149825] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9530), 1,
      sym_identifier,
    ACTIONS(9866), 1,
      anon_sym_DASH_GT,
    ACTIONS(9870), 1,
      anon_sym_STAR,
    ACTIONS(9872), 1,
      anon_sym_LT2,
    ACTIONS(9874), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6929), 1,
      aux_sym_compound_type_repeat1,
    STATE(6947), 1,
      sym_type_arguments,
    STATE(7001), 1,
      sym_long_identifier,
    ACTIONS(3427), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    STATE(6439), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3425), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [149891] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9530), 1,
      sym_identifier,
    ACTIONS(9866), 1,
      anon_sym_DASH_GT,
    ACTIONS(9870), 1,
      anon_sym_STAR,
    ACTIONS(9872), 1,
      anon_sym_LT2,
    ACTIONS(9874), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6929), 1,
      aux_sym_compound_type_repeat1,
    STATE(6947), 1,
      sym_type_arguments,
    STATE(7001), 1,
      sym_long_identifier,
    ACTIONS(3407), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    STATE(6440), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3403), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [149957] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6124), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9962), 1,
      anon_sym_COMMA,
    STATE(6441), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6122), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [150009] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6134), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9964), 1,
      anon_sym_COMMA,
    STATE(6442), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6132), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [150061] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9966), 1,
      anon_sym_or,
    ACTIONS(3480), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(6443), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3478), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [150113] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3700), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6444), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3698), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [150163] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6284), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6445), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6282), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [150213] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6448), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6446), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6446), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [150263] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6192), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9969), 1,
      anon_sym_and,
    STATE(6517), 1,
      aux_sym__function_or_value_defns_repeat1,
    STATE(6447), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6190), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [150317] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(239), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9971), 1,
      anon_sym_COMMA,
    STATE(6448), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(237), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [150369] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9496), 1,
      sym_identifier,
    ACTIONS(9910), 1,
      anon_sym_DASH_GT,
    ACTIONS(9912), 1,
      anon_sym_STAR,
    ACTIONS(9914), 1,
      anon_sym_LT2,
    ACTIONS(9916), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6909), 1,
      aux_sym_compound_type_repeat1,
    STATE(6970), 1,
      sym_type_arguments,
    STATE(6979), 1,
      sym_long_identifier,
    ACTIONS(3419), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(6449), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3417), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [150435] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9975), 1,
      anon_sym_let,
    ACTIONS(9977), 1,
      anon_sym_PIPE,
    STATE(6496), 1,
      aux_sym_union_type_cases_repeat1,
    STATE(6450), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9973), 15,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [150489] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9979), 1,
      anon_sym_or,
    STATE(6504), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(3498), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6451), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [150543] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(239), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9981), 1,
      anon_sym_COMMA,
    STATE(6452), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(237), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [150595] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6184), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9983), 1,
      anon_sym_COMMA,
    STATE(6453), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6182), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [150647] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6170), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9985), 1,
      anon_sym_with,
    STATE(6454), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6168), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [150699] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9530), 1,
      sym_identifier,
    ACTIONS(9866), 1,
      anon_sym_DASH_GT,
    ACTIONS(9870), 1,
      anon_sym_STAR,
    ACTIONS(9872), 1,
      anon_sym_LT2,
    ACTIONS(9874), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6929), 1,
      aux_sym_compound_type_repeat1,
    STATE(6947), 1,
      sym_type_arguments,
    STATE(7001), 1,
      sym_long_identifier,
    ACTIONS(3419), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    STATE(6455), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3417), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [150765] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6184), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9987), 1,
      anon_sym_COMMA,
    STATE(6456), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6182), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [150817] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6292), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6457), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6290), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [150867] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6306), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6458), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6304), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [150917] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6134), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9989), 1,
      anon_sym_COMMA,
    STATE(6459), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6132), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [150969] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9496), 1,
      sym_identifier,
    ACTIONS(9910), 1,
      anon_sym_DASH_GT,
    ACTIONS(9912), 1,
      anon_sym_STAR,
    ACTIONS(9914), 1,
      anon_sym_LT2,
    ACTIONS(9916), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6909), 1,
      aux_sym_compound_type_repeat1,
    STATE(6970), 1,
      sym_type_arguments,
    STATE(6979), 1,
      sym_long_identifier,
    ACTIONS(7279), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(6460), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7281), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [151035] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6302), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6461), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6300), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [151085] = 25,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9991), 1,
      anon_sym_new,
    ACTIONS(9995), 1,
      anon_sym_static,
    ACTIONS(9997), 1,
      anon_sym_member,
    ACTIONS(9999), 1,
      anon_sym_abstract,
    ACTIONS(10001), 1,
      anon_sym_val,
    ACTIONS(10003), 1,
      sym__newline,
    ACTIONS(10005), 1,
      sym__dedent,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6433), 1,
      aux_sym__member_defns_repeat1,
    STATE(7566), 1,
      sym_member_defn,
    STATE(7634), 1,
      sym_additional_constr_defn,
    STATE(7920), 1,
      sym_attributes,
    STATE(11902), 1,
      sym_access_modifier,
    ACTIONS(9993), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6462), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [151165] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6134), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10007), 1,
      anon_sym_COMMA,
    STATE(6463), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6132), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [151217] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6340), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6464), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6338), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [151267] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(2692), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6465), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2690), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [151317] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6318), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6466), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6316), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [151367] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6330), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6467), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6328), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [151417] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6314), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6468), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6312), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [151467] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6274), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10009), 1,
      anon_sym_with,
    STATE(6469), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6272), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [151519] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4975), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6470), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4973), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [151569] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6400), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6471), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6398), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [151619] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6408), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6472), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6406), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [151669] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6436), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6473), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6434), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [151719] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6474), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3485), 8,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3487), 10,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [151769] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10011), 1,
      anon_sym_or,
    STATE(6443), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(3476), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(6475), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3474), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [151823] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10013), 1,
      anon_sym_STAR,
    STATE(6476), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3425), 6,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3427), 10,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [151875] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9891), 1,
      anon_sym_let,
    STATE(6477), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9889), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [151925] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6326), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6478), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6324), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [151975] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6134), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6479), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6132), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [152025] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9975), 1,
      anon_sym_let,
    ACTIONS(9977), 1,
      anon_sym_PIPE,
    STATE(6521), 1,
      aux_sym_union_type_cases_repeat1,
    STATE(6480), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9973), 15,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [152079] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4975), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6481), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4973), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [152129] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6296), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6482), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6294), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [152179] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6170), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10016), 1,
      anon_sym_with,
    STATE(6483), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6168), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [152231] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6344), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6484), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6342), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [152281] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6388), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6485), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6386), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [152331] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6388), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6486), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6386), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [152381] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6336), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6487), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6334), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [152431] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10018), 1,
      anon_sym_COLON_GT,
    STATE(6488), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 7,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3515), 10,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [152483] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6489), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 8,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3498), 10,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [152533] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6280), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6490), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6278), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [152583] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6380), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6491), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6378), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [152633] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6823), 1,
      anon_sym_let,
    STATE(6492), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6821), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [152683] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9831), 1,
      anon_sym_let,
    STATE(6493), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9829), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [152733] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6416), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6494), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6414), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [152783] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6274), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6495), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6272), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [152833] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10022), 1,
      anon_sym_let,
    ACTIONS(10024), 1,
      anon_sym_PIPE,
    STATE(6496), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_union_type_cases_repeat1,
    ACTIONS(10020), 15,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [152885] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9833), 1,
      anon_sym_let,
    STATE(6497), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7706), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [152935] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6032), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6498), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6030), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [152985] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9248), 1,
      sym_identifier,
    ACTIONS(10027), 1,
      anon_sym_DASH_GT,
    ACTIONS(10029), 1,
      anon_sym_when,
    ACTIONS(10031), 1,
      anon_sym_STAR,
    ACTIONS(10033), 1,
      anon_sym_LT2,
    ACTIONS(10035), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7068), 1,
      aux_sym_compound_type_repeat1,
    STATE(7173), 1,
      sym_type_arguments,
    STATE(7203), 1,
      sym_long_identifier,
    STATE(7366), 1,
      sym_type_argument_constraints,
    ACTIONS(7226), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(6499), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7224), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [153055] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6117), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10037), 1,
      anon_sym_and,
    STATE(6500), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__function_or_value_defns_repeat1,
    ACTIONS(6115), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [153107] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9774), 1,
      anon_sym_STAR,
    STATE(6518), 1,
      aux_sym_compound_type_repeat1,
    STATE(6501), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3466), 7,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3468), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [153161] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6310), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6502), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6308), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [153211] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6010), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6503), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6008), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [153261] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9979), 1,
      anon_sym_or,
    STATE(6422), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(3476), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6504), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3474), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [153315] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6288), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6505), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6286), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [153365] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6420), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6506), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6418), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [153415] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6458), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6507), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6456), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [153465] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(2692), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6508), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2690), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [153515] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6404), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6509), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6402), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [153565] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4975), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6510), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4973), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [153615] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9496), 1,
      sym_identifier,
    ACTIONS(9910), 1,
      anon_sym_DASH_GT,
    ACTIONS(9912), 1,
      anon_sym_STAR,
    ACTIONS(9914), 1,
      anon_sym_LT2,
    ACTIONS(9916), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6909), 1,
      aux_sym_compound_type_repeat1,
    STATE(6970), 1,
      sym_type_arguments,
    STATE(6979), 1,
      sym_long_identifier,
    ACTIONS(7283), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(6511), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7285), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [153681] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6170), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6512), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6168), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [153731] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(2692), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6513), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2690), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [153781] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6117), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10040), 1,
      anon_sym_and,
    STATE(6514), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__function_or_value_defns_repeat1,
    ACTIONS(6115), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [153833] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10011), 1,
      anon_sym_or,
    STATE(6475), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(3498), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(6515), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [153887] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6158), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10043), 1,
      anon_sym_and,
    STATE(6514), 1,
      aux_sym__function_or_value_defns_repeat1,
    STATE(6516), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6156), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [153941] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6158), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9969), 1,
      anon_sym_and,
    STATE(6500), 1,
      aux_sym__function_or_value_defns_repeat1,
    STATE(6517), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6156), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [153995] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10045), 1,
      anon_sym_STAR,
    STATE(6518), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3425), 7,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3427), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [154047] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6396), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6519), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6394), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [154097] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6384), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6520), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6382), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [154147] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9977), 1,
      anon_sym_PIPE,
    ACTIONS(10050), 1,
      anon_sym_let,
    STATE(6496), 1,
      aux_sym_union_type_cases_repeat1,
    STATE(6521), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(10048), 15,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [154201] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6376), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6522), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6374), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [154251] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6392), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6523), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6390), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [154301] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6412), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6524), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6410), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [154351] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9452), 1,
      sym_identifier,
    ACTIONS(10052), 1,
      anon_sym_DASH_GT,
    ACTIONS(10054), 1,
      anon_sym_when,
    ACTIONS(10056), 1,
      anon_sym_STAR,
    ACTIONS(10058), 1,
      anon_sym_LT2,
    ACTIONS(10060), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7050), 1,
      aux_sym_compound_type_repeat1,
    STATE(7134), 1,
      sym_long_identifier,
    STATE(7142), 1,
      sym_type_arguments,
    STATE(8396), 1,
      sym_type_argument_constraints,
    ACTIONS(7226), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(6525), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7224), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [154421] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6192), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10043), 1,
      anon_sym_and,
    STATE(6516), 1,
      aux_sym__function_or_value_defns_repeat1,
    STATE(6526), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6190), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [154475] = 25,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9991), 1,
      anon_sym_new,
    ACTIONS(9995), 1,
      anon_sym_static,
    ACTIONS(9997), 1,
      anon_sym_member,
    ACTIONS(9999), 1,
      anon_sym_abstract,
    ACTIONS(10001), 1,
      anon_sym_val,
    ACTIONS(10003), 1,
      sym__newline,
    ACTIONS(10062), 1,
      sym__dedent,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6462), 1,
      aux_sym__member_defns_repeat1,
    STATE(7566), 1,
      sym_member_defn,
    STATE(7634), 1,
      sym_additional_constr_defn,
    STATE(7920), 1,
      sym_attributes,
    STATE(11902), 1,
      sym_access_modifier,
    ACTIONS(9993), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6527), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154555] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9837), 1,
      anon_sym_let,
    STATE(6528), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9835), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [154605] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6432), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6529), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6430), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [154655] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6444), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6530), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6442), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [154705] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9977), 1,
      anon_sym_PIPE,
    ACTIONS(10066), 1,
      anon_sym_let,
    STATE(6450), 1,
      aux_sym_union_type_cases_repeat1,
    STATE(6531), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(10064), 15,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [154759] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9854), 1,
      anon_sym_let,
    STATE(6532), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9852), 17,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_inherit,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [154809] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(239), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10068), 1,
      anon_sym_COMMA,
    STATE(6533), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(237), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [154861] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6534), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3549), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3551), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [154910] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6134), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10070), 1,
      anon_sym_COMMA,
    STATE(6535), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6132), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [154961] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9290), 1,
      sym_identifier,
    ACTIONS(10072), 1,
      anon_sym_DASH_GT,
    ACTIONS(10074), 1,
      anon_sym_STAR,
    ACTIONS(10076), 1,
      anon_sym_LT2,
    ACTIONS(10078), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7080), 1,
      aux_sym_compound_type_repeat1,
    STATE(7143), 1,
      sym_long_identifier,
    STATE(7147), 1,
      sym_type_arguments,
    ACTIONS(3431), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(6536), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3429), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [155026] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9150), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      anon_sym_DASH_GT,
    ACTIONS(10082), 1,
      anon_sym_STAR,
    ACTIONS(10084), 1,
      anon_sym_LT2,
    ACTIONS(10086), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6969), 1,
      aux_sym_compound_type_repeat1,
    STATE(7128), 1,
      sym_long_identifier,
    STATE(7149), 1,
      sym_type_arguments,
    ACTIONS(7279), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(6537), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7281), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [155091] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6274), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10088), 1,
      anon_sym_with,
    STATE(6538), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6272), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [155142] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10090), 1,
      anon_sym_or,
    STATE(6576), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(3476), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(6539), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3474), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [155195] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6428), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6540), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6426), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [155244] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9440), 1,
      sym_identifier,
    ACTIONS(10092), 1,
      anon_sym_DASH_GT,
    ACTIONS(10094), 1,
      anon_sym_STAR,
    ACTIONS(10096), 1,
      anon_sym_LT2,
    ACTIONS(10098), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7029), 1,
      aux_sym_compound_type_repeat1,
    STATE(7094), 1,
      sym_type_arguments,
    STATE(7111), 1,
      sym_long_identifier,
    ACTIONS(3419), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(6541), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3417), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [155309] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9290), 1,
      sym_identifier,
    ACTIONS(10072), 1,
      anon_sym_DASH_GT,
    ACTIONS(10074), 1,
      anon_sym_STAR,
    ACTIONS(10076), 1,
      anon_sym_LT2,
    ACTIONS(10078), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7080), 1,
      aux_sym_compound_type_repeat1,
    STATE(7143), 1,
      sym_long_identifier,
    STATE(7147), 1,
      sym_type_arguments,
    ACTIONS(3407), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(6542), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3403), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [155374] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6384), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6543), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6382), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [155423] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4975), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6544), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4973), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [155472] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6545), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3511), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_or,
      sym_identifier,
    ACTIONS(3509), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [155521] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9150), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      anon_sym_DASH_GT,
    ACTIONS(10082), 1,
      anon_sym_STAR,
    ACTIONS(10084), 1,
      anon_sym_LT2,
    ACTIONS(10086), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6969), 1,
      aux_sym_compound_type_repeat1,
    STATE(7128), 1,
      sym_long_identifier,
    STATE(7149), 1,
      sym_type_arguments,
    ACTIONS(3407), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(6546), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3403), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [155586] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6340), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6547), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6338), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [155635] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9150), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      anon_sym_DASH_GT,
    ACTIONS(10082), 1,
      anon_sym_STAR,
    ACTIONS(10084), 1,
      anon_sym_LT2,
    ACTIONS(10086), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6969), 1,
      aux_sym_compound_type_repeat1,
    STATE(7128), 1,
      sym_long_identifier,
    STATE(7149), 1,
      sym_type_arguments,
    ACTIONS(3427), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(6548), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3425), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [155700] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6549), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3480), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_or,
      sym_identifier,
    ACTIONS(3478), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [155749] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6550), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 7,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3515), 10,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [155798] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6404), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6551), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6402), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [155847] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9150), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      anon_sym_DASH_GT,
    ACTIONS(10082), 1,
      anon_sym_STAR,
    ACTIONS(10084), 1,
      anon_sym_LT2,
    ACTIONS(10086), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6969), 1,
      aux_sym_compound_type_repeat1,
    STATE(7128), 1,
      sym_long_identifier,
    STATE(7149), 1,
      sym_type_arguments,
    ACTIONS(3431), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(6552), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3429), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [155912] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6117), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10100), 1,
      anon_sym_and,
    STATE(6553), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__function_or_value_defns_repeat1,
    ACTIONS(6115), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [155963] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6554), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3521), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3523), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [156012] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6555), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3517), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3519), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [156061] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6274), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10103), 1,
      anon_sym_with,
    STATE(6556), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6272), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [156112] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6557), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3525), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3527), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [156161] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6558), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3529), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3531), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [156210] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6559), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3533), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3535), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [156259] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9248), 1,
      sym_identifier,
    ACTIONS(10027), 1,
      anon_sym_DASH_GT,
    ACTIONS(10031), 1,
      anon_sym_STAR,
    ACTIONS(10033), 1,
      anon_sym_LT2,
    ACTIONS(10035), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(10105), 1,
      anon_sym_when,
    STATE(7068), 1,
      aux_sym_compound_type_repeat1,
    STATE(7173), 1,
      sym_type_arguments,
    STATE(7203), 1,
      sym_long_identifier,
    STATE(7366), 1,
      sym_type_argument_constraints,
    ACTIONS(7226), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(6560), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7224), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [156328] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6124), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10107), 1,
      anon_sym_COMMA,
    STATE(6561), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6122), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [156379] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(2692), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6562), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2690), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [156428] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6336), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6563), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6334), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [156477] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6124), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10109), 1,
      anon_sym_COMMA,
    STATE(6564), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6122), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [156528] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9452), 1,
      sym_identifier,
    ACTIONS(10052), 1,
      anon_sym_DASH_GT,
    ACTIONS(10056), 1,
      anon_sym_STAR,
    ACTIONS(10058), 1,
      anon_sym_LT2,
    ACTIONS(10060), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7050), 1,
      aux_sym_compound_type_repeat1,
    STATE(7134), 1,
      sym_long_identifier,
    STATE(7142), 1,
      sym_type_arguments,
    ACTIONS(3431), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    STATE(6565), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3429), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [156593] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10111), 1,
      anon_sym_DOT,
    STATE(6568), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3451), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6566), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3449), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [156646] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6280), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6567), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6278), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [156695] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10113), 1,
      anon_sym_DOT,
    ACTIONS(3487), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6568), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3485), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [156746] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6380), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6569), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6378), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [156795] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6392), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6570), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6390), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [156844] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10118), 2,
      anon_sym_let,
      anon_sym_LPAREN,
    STATE(6571), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(10116), 15,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [156893] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9150), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      anon_sym_DASH_GT,
    ACTIONS(10082), 1,
      anon_sym_STAR,
    ACTIONS(10084), 1,
      anon_sym_LT2,
    ACTIONS(10086), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6969), 1,
      aux_sym_compound_type_repeat1,
    STATE(7128), 1,
      sym_long_identifier,
    STATE(7149), 1,
      sym_type_arguments,
    ACTIONS(7283), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(6572), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7285), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [156958] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6573), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3560), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3562), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [157007] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(239), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10120), 1,
      anon_sym_COMMA,
    STATE(6574), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(237), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [157058] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6170), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10122), 1,
      anon_sym_with,
    STATE(6575), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6168), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [157109] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10124), 1,
      anon_sym_or,
    ACTIONS(3480), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(6576), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3478), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [157160] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10129), 2,
      anon_sym_let,
      anon_sym_LPAREN,
    STATE(6577), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(10127), 15,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [157209] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9290), 1,
      sym_identifier,
    ACTIONS(10072), 1,
      anon_sym_DASH_GT,
    ACTIONS(10074), 1,
      anon_sym_STAR,
    ACTIONS(10076), 1,
      anon_sym_LT2,
    ACTIONS(10078), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7080), 1,
      aux_sym_compound_type_repeat1,
    STATE(7143), 1,
      sym_long_identifier,
    STATE(7147), 1,
      sym_type_arguments,
    ACTIONS(3427), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(6578), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3425), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [157274] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6192), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10131), 1,
      anon_sym_and,
    STATE(6700), 1,
      aux_sym__function_or_value_defns_repeat1,
    STATE(6579), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6190), 14,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [157327] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(239), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10133), 1,
      anon_sym_COMMA,
    STATE(6580), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(237), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [157378] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6296), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6581), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6294), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [157427] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(2692), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6582), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2690), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [157476] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4975), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6583), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4973), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [157525] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6404), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6584), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6402), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [157574] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6184), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10135), 1,
      anon_sym_COMMA,
    STATE(6585), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6182), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [157625] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6184), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10137), 1,
      anon_sym_COMMA,
    STATE(6586), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6182), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [157676] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6396), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6587), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6394), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [157725] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6376), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6588), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6374), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [157774] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6392), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6589), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6390), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [157823] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6024), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6590), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6022), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [157872] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6412), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6591), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6410), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [157921] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6302), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6592), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6300), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [157970] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4975), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6593), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4973), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [158019] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6380), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6594), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6378), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [158068] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6280), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6595), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6278), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [158117] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6396), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6596), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6394), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [158166] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6134), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10139), 1,
      anon_sym_COMMA,
    STATE(6597), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6132), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [158217] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9440), 1,
      sym_identifier,
    ACTIONS(10092), 1,
      anon_sym_DASH_GT,
    ACTIONS(10094), 1,
      anon_sym_STAR,
    ACTIONS(10096), 1,
      anon_sym_LT2,
    ACTIONS(10098), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7029), 1,
      aux_sym_compound_type_repeat1,
    STATE(7094), 1,
      sym_type_arguments,
    STATE(7111), 1,
      sym_long_identifier,
    ACTIONS(3407), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(6598), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3403), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [158282] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6314), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6599), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6312), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [158331] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10141), 1,
      anon_sym_LT2,
    STATE(6600), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3503), 6,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3505), 10,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [158382] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6336), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6601), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6334), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [158431] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6376), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6602), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6374), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [158480] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10143), 1,
      anon_sym_LT2,
    STATE(6603), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3503), 7,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3505), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [158531] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6604), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3515), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [158580] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10145), 1,
      anon_sym_DOT,
    STATE(6721), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3494), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(6605), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [158633] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6124), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10147), 1,
      anon_sym_COMMA,
    STATE(6606), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6122), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [158684] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6420), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6607), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6418), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [158733] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6124), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10149), 1,
      anon_sym_COMMA,
    STATE(6608), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6122), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [158784] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6032), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6609), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6030), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [158833] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6024), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6610), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6022), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [158882] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10111), 1,
      anon_sym_DOT,
    STATE(6566), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3494), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6611), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [158935] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6612), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3537), 7,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3539), 10,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [158984] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6330), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6613), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6328), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [159033] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(239), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10151), 1,
      anon_sym_COMMA,
    STATE(6614), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(237), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [159084] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6288), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6615), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6286), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [159133] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(239), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10153), 1,
      anon_sym_COMMA,
    STATE(6616), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(237), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [159184] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6184), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10155), 1,
      anon_sym_COMMA,
    STATE(6617), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6182), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [159235] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6322), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6618), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6320), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [159284] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6318), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6619), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6316), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [159333] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6184), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10157), 1,
      anon_sym_COMMA,
    STATE(6620), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6182), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [159384] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(2692), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6621), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2690), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [159433] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6416), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6622), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6414), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [159482] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6134), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10159), 1,
      anon_sym_COMMA,
    STATE(6623), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6132), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [159533] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9290), 1,
      sym_identifier,
    ACTIONS(10072), 1,
      anon_sym_DASH_GT,
    ACTIONS(10074), 1,
      anon_sym_STAR,
    ACTIONS(10076), 1,
      anon_sym_LT2,
    ACTIONS(10078), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7080), 1,
      aux_sym_compound_type_repeat1,
    STATE(7143), 1,
      sym_long_identifier,
    STATE(7147), 1,
      sym_type_arguments,
    ACTIONS(7279), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(6624), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7281), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [159598] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10022), 1,
      anon_sym_let,
    STATE(6625), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(10020), 16,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [159647] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6436), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6626), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6434), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [159696] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9290), 1,
      sym_identifier,
    ACTIONS(10072), 1,
      anon_sym_DASH_GT,
    ACTIONS(10074), 1,
      anon_sym_STAR,
    ACTIONS(10076), 1,
      anon_sym_LT2,
    ACTIONS(10078), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7080), 1,
      aux_sym_compound_type_repeat1,
    STATE(7143), 1,
      sym_long_identifier,
    STATE(7147), 1,
      sym_type_arguments,
    ACTIONS(3419), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(6627), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3417), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [159761] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6408), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6628), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6406), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [159810] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6400), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6629), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6398), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [159859] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6388), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6630), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6386), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [159908] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9440), 1,
      sym_identifier,
    ACTIONS(10092), 1,
      anon_sym_DASH_GT,
    ACTIONS(10094), 1,
      anon_sym_STAR,
    ACTIONS(10096), 1,
      anon_sym_LT2,
    ACTIONS(10098), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7029), 1,
      aux_sym_compound_type_repeat1,
    STATE(7094), 1,
      sym_type_arguments,
    STATE(7111), 1,
      sym_long_identifier,
    ACTIONS(3427), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(6631), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3425), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [159973] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10161), 1,
      anon_sym_or,
    STATE(6718), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(3498), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6632), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [160026] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9150), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      anon_sym_DASH_GT,
    ACTIONS(10082), 1,
      anon_sym_STAR,
    ACTIONS(10084), 1,
      anon_sym_LT2,
    ACTIONS(10086), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(6969), 1,
      aux_sym_compound_type_repeat1,
    STATE(7128), 1,
      sym_long_identifier,
    STATE(7149), 1,
      sym_type_arguments,
    ACTIONS(3419), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(6633), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3417), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [160091] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6288), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6634), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6286), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [160140] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6454), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6635), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6452), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [160189] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6388), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6636), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6386), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [160238] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10163), 1,
      anon_sym_or,
    STATE(6739), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(3498), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6637), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [160291] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6444), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6638), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6442), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [160340] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6388), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6639), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6386), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [160389] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6388), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6640), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6386), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [160438] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6448), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6641), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6446), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [160487] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3700), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6642), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3698), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [160536] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6458), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6643), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6456), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [160585] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9817), 2,
      anon_sym_let,
      anon_sym_LPAREN,
    STATE(6644), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9815), 15,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [160634] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6296), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6645), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6294), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [160683] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6158), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10165), 1,
      anon_sym_and,
    STATE(6553), 1,
      aux_sym__function_or_value_defns_repeat1,
    STATE(6646), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6156), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [160736] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6647), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3545), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3547), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [160785] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6648), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3480), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      anon_sym_or,
      sym_identifier,
    ACTIONS(3478), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [160834] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10167), 1,
      anon_sym_or,
    STATE(6654), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(3476), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(6649), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3474), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [160887] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4975), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6650), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4973), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [160936] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6326), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6651), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6324), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [160985] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(2692), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6652), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2690), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [161034] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9184), 1,
      sym_identifier,
    ACTIONS(10169), 1,
      anon_sym_DASH_GT,
    ACTIONS(10171), 1,
      anon_sym_when,
    ACTIONS(10173), 1,
      anon_sym_STAR,
    ACTIONS(10175), 1,
      anon_sym_LT2,
    ACTIONS(10177), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7137), 1,
      aux_sym_compound_type_repeat1,
    STATE(7216), 1,
      sym_long_identifier,
    STATE(7290), 1,
      sym_type_arguments,
    STATE(7366), 1,
      sym_type_argument_constraints,
    ACTIONS(7226), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
    ACTIONS(7224), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6653), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161103] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10179), 1,
      anon_sym_or,
    ACTIONS(3480), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(6654), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3478), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [161154] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10182), 1,
      anon_sym_or,
    STATE(6710), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(3476), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(6655), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3474), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [161207] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6344), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6656), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6342), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [161256] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9290), 1,
      sym_identifier,
    ACTIONS(10072), 1,
      anon_sym_DASH_GT,
    ACTIONS(10074), 1,
      anon_sym_STAR,
    ACTIONS(10076), 1,
      anon_sym_LT2,
    ACTIONS(10078), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7080), 1,
      aux_sym_compound_type_repeat1,
    STATE(7143), 1,
      sym_long_identifier,
    STATE(7147), 1,
      sym_type_arguments,
    ACTIONS(7283), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(6657), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7285), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [161321] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6384), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6658), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6382), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [161370] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6659), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3511), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      anon_sym_or,
      sym_identifier,
    ACTIONS(3509), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [161419] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3547), 2,
      anon_sym_let,
      anon_sym_LPAREN,
    STATE(6660), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3545), 15,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [161468] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4975), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6661), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4973), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [161517] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6428), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6662), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6426), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [161566] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(2692), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6663), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2690), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [161615] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9248), 1,
      sym_identifier,
    ACTIONS(10027), 1,
      anon_sym_DASH_GT,
    ACTIONS(10031), 1,
      anon_sym_STAR,
    ACTIONS(10033), 1,
      anon_sym_LT2,
    ACTIONS(10035), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7068), 1,
      aux_sym_compound_type_repeat1,
    STATE(7173), 1,
      sym_type_arguments,
    STATE(7203), 1,
      sym_long_identifier,
    ACTIONS(3431), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    STATE(6664), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3429), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [161680] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6284), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6665), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6282), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [161729] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6134), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10184), 1,
      anon_sym_COMMA,
    STATE(6666), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6132), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [161780] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6667), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3541), 7,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3543), 10,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [161829] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8965), 1,
      anon_sym_let,
    STATE(6668), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8963), 16,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [161878] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9440), 1,
      sym_identifier,
    ACTIONS(10092), 1,
      anon_sym_DASH_GT,
    ACTIONS(10094), 1,
      anon_sym_STAR,
    ACTIONS(10096), 1,
      anon_sym_LT2,
    ACTIONS(10098), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7029), 1,
      aux_sym_compound_type_repeat1,
    STATE(7094), 1,
      sym_type_arguments,
    STATE(7111), 1,
      sym_long_identifier,
    ACTIONS(7314), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(6669), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7312), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [161943] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6670), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3545), 7,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3547), 10,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [161992] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6292), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6671), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6290), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [162041] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9452), 1,
      sym_identifier,
    ACTIONS(10052), 1,
      anon_sym_DASH_GT,
    ACTIONS(10056), 1,
      anon_sym_STAR,
    ACTIONS(10058), 1,
      anon_sym_LT2,
    ACTIONS(10060), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7050), 1,
      aux_sym_compound_type_repeat1,
    STATE(7134), 1,
      sym_long_identifier,
    STATE(7142), 1,
      sym_type_arguments,
    ACTIONS(3427), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    STATE(6672), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3425), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [162106] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9452), 1,
      sym_identifier,
    ACTIONS(10052), 1,
      anon_sym_DASH_GT,
    ACTIONS(10056), 1,
      anon_sym_STAR,
    ACTIONS(10058), 1,
      anon_sym_LT2,
    ACTIONS(10060), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7050), 1,
      aux_sym_compound_type_repeat1,
    STATE(7134), 1,
      sym_long_identifier,
    STATE(7142), 1,
      sym_type_arguments,
    ACTIONS(3407), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    STATE(6673), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3403), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [162171] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6306), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6674), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6304), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [162220] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6302), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6675), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6300), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [162269] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6134), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6676), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6132), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [162318] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6420), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6677), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6418), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [162367] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10188), 2,
      anon_sym_let,
      anon_sym_LPAREN,
    STATE(6678), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(10186), 15,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [162416] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6679), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3521), 7,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3523), 10,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [162465] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6032), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6680), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6030), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [162514] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9248), 1,
      sym_identifier,
    ACTIONS(10027), 1,
      anon_sym_DASH_GT,
    ACTIONS(10031), 1,
      anon_sym_STAR,
    ACTIONS(10033), 1,
      anon_sym_LT2,
    ACTIONS(10035), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7068), 1,
      aux_sym_compound_type_repeat1,
    STATE(7173), 1,
      sym_type_arguments,
    STATE(7203), 1,
      sym_long_identifier,
    ACTIONS(3427), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    STATE(6681), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3425), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [162579] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6310), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6682), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6308), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [162628] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9248), 1,
      sym_identifier,
    ACTIONS(10027), 1,
      anon_sym_DASH_GT,
    ACTIONS(10031), 1,
      anon_sym_STAR,
    ACTIONS(10033), 1,
      anon_sym_LT2,
    ACTIONS(10035), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7068), 1,
      aux_sym_compound_type_repeat1,
    STATE(7173), 1,
      sym_type_arguments,
    STATE(7203), 1,
      sym_long_identifier,
    ACTIONS(3407), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    STATE(6683), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3403), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [162693] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6310), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6684), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6308), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [162742] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6314), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6685), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6312), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [162791] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6134), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6686), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6132), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [162840] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6330), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6687), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6328), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [162889] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6412), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6688), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6410), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [162938] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10182), 1,
      anon_sym_or,
    STATE(6655), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(3498), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(6689), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [162991] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10090), 1,
      anon_sym_or,
    STATE(6539), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(3498), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(6690), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [163044] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6416), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6691), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6414), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [163093] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9440), 1,
      sym_identifier,
    ACTIONS(10092), 1,
      anon_sym_DASH_GT,
    ACTIONS(10094), 1,
      anon_sym_STAR,
    ACTIONS(10096), 1,
      anon_sym_LT2,
    ACTIONS(10098), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7029), 1,
      aux_sym_compound_type_repeat1,
    STATE(7094), 1,
      sym_type_arguments,
    STATE(7111), 1,
      sym_long_identifier,
    ACTIONS(3431), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(6692), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3429), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [163158] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6693), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3517), 7,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3519), 10,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [163207] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6117), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10190), 1,
      anon_sym_and,
    STATE(6694), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__function_or_value_defns_repeat1,
    ACTIONS(6115), 14,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [163258] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6695), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3549), 7,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3551), 10,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [163307] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6192), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10165), 1,
      anon_sym_and,
    STATE(6646), 1,
      aux_sym__function_or_value_defns_repeat1,
    STATE(6696), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6190), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [163360] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6448), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6697), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6446), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [163409] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6698), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3560), 7,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3562), 10,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [163458] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6170), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10193), 1,
      anon_sym_with,
    STATE(6699), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6168), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [163509] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6158), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10131), 1,
      anon_sym_and,
    STATE(6694), 1,
      aux_sym__function_or_value_defns_repeat1,
    STATE(6700), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6156), 14,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [163562] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6444), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6701), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6442), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [163611] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6306), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6702), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6304), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [163660] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6436), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6703), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6434), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [163709] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9452), 1,
      sym_identifier,
    ACTIONS(10052), 1,
      anon_sym_DASH_GT,
    ACTIONS(10056), 1,
      anon_sym_STAR,
    ACTIONS(10058), 1,
      anon_sym_LT2,
    ACTIONS(10060), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7050), 1,
      aux_sym_compound_type_repeat1,
    STATE(7134), 1,
      sym_long_identifier,
    STATE(7142), 1,
      sym_type_arguments,
    ACTIONS(3419), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    STATE(6704), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3417), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [163774] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10195), 1,
      anon_sym_or,
    ACTIONS(3480), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6705), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3478), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [163825] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4975), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6706), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4973), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [163874] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8931), 1,
      anon_sym_let,
    STATE(6707), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8929), 16,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [163923] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6318), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6708), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6316), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [163972] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3539), 2,
      anon_sym_let,
      anon_sym_LPAREN,
    STATE(6709), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3537), 15,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [164021] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10198), 1,
      anon_sym_or,
    ACTIONS(3480), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(6710), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3478), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [164072] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6711), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3525), 7,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3527), 10,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [164121] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6408), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6712), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6406), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [164170] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6440), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6713), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6438), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [164219] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6432), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6714), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6430), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [164268] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6292), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6715), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6290), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [164317] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6284), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6716), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6282), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [164366] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6344), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6717), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6342), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [164415] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10161), 1,
      anon_sym_or,
    STATE(6705), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(3476), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6718), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3474), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [164468] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6458), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6719), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6456), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [164517] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3543), 2,
      anon_sym_let,
      anon_sym_LPAREN,
    STATE(6720), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3541), 15,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [164566] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10145), 1,
      anon_sym_DOT,
    STATE(6728), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3451), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(6721), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3449), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [164619] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6454), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6722), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6452), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [164668] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(2692), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6723), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2690), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [164717] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9765), 2,
      anon_sym_let,
      anon_sym_LPAREN,
    STATE(6724), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9763), 15,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [164766] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9248), 1,
      sym_identifier,
    ACTIONS(10027), 1,
      anon_sym_DASH_GT,
    ACTIONS(10031), 1,
      anon_sym_STAR,
    ACTIONS(10033), 1,
      anon_sym_LT2,
    ACTIONS(10035), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7068), 1,
      aux_sym_compound_type_repeat1,
    STATE(7173), 1,
      sym_type_arguments,
    STATE(7203), 1,
      sym_long_identifier,
    ACTIONS(3419), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    STATE(6725), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3417), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [164831] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6010), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6726), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6008), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [164880] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10203), 2,
      anon_sym_let,
      anon_sym_LPAREN,
    STATE(6727), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(10201), 15,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [164929] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10205), 1,
      anon_sym_DOT,
    ACTIONS(3487), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(6728), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3485), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [164980] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6729), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3537), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3539), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [165029] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6730), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3529), 7,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3531), 10,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [165078] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6440), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6731), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6438), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [165127] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6432), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6732), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6430), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [165176] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6733), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3533), 7,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3535), 10,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [165225] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6400), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6734), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6398), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [165274] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6340), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6735), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6338), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [165323] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10167), 1,
      anon_sym_or,
    STATE(6649), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(3498), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(6736), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [165376] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6326), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6737), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6324), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [165425] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6010), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6738), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6008), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [165474] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10163), 1,
      anon_sym_or,
    STATE(6743), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(3476), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6739), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3474), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [165527] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6322), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6740), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6320), 16,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [165576] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3700), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6741), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3698), 16,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [165625] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6742), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3541), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3543), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [165674] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10208), 1,
      anon_sym_or,
    ACTIONS(3480), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6743), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3478), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [165725] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6744), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3480), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      anon_sym_or,
      sym_identifier,
    ACTIONS(3478), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [165773] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9290), 1,
      sym_identifier,
    ACTIONS(10072), 1,
      anon_sym_DASH_GT,
    ACTIONS(10074), 1,
      anon_sym_STAR,
    ACTIONS(10078), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7080), 1,
      aux_sym_compound_type_repeat1,
    STATE(7143), 1,
      sym_long_identifier,
    STATE(7147), 1,
      sym_type_arguments,
    ACTIONS(7283), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(6745), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7285), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [165835] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6314), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6746), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6312), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [165883] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6388), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6747), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6386), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [165931] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6748), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3480), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_or,
      sym_identifier,
    ACTIONS(3478), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [165979] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6388), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6749), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6386), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [166027] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6750), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3511), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_or,
      sym_identifier,
    ACTIONS(3509), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [166075] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6330), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6751), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6328), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [166123] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9428), 1,
      sym_identifier,
    ACTIONS(10211), 1,
      anon_sym_DASH_GT,
    ACTIONS(10213), 1,
      anon_sym_STAR,
    ACTIONS(10215), 1,
      anon_sym_LT2,
    ACTIONS(10217), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7158), 1,
      aux_sym_compound_type_repeat1,
    STATE(7249), 1,
      sym_long_identifier,
    STATE(7266), 1,
      sym_type_arguments,
    ACTIONS(3419), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(6752), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3417), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [166187] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(239), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10219), 1,
      anon_sym_COMMA,
    STATE(6753), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(237), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [166237] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6310), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6754), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6308), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [166285] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(2692), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6755), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2690), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [166333] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(2692), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6756), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2690), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [166381] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6440), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6757), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6438), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [166429] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6758), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3511), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_or,
      sym_identifier,
    ACTIONS(3509), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [166477] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6380), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6759), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6378), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [166525] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9108), 1,
      sym_identifier,
    ACTIONS(10221), 1,
      anon_sym_DASH_GT,
    ACTIONS(10223), 1,
      anon_sym_STAR,
    ACTIONS(10225), 1,
      anon_sym_LT2,
    ACTIONS(10227), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7105), 1,
      aux_sym_compound_type_repeat1,
    STATE(7317), 1,
      sym_type_arguments,
    STATE(7327), 1,
      sym_long_identifier,
    ACTIONS(7283), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
    ACTIONS(7285), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6760), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166589] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6322), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6761), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6320), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [166637] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6408), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6762), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6406), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [166685] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6318), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6763), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6316), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [166733] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4975), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6764), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4973), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [166781] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9364), 1,
      sym_identifier,
    ACTIONS(10229), 1,
      anon_sym_STAR,
    ACTIONS(10231), 1,
      anon_sym_LT2,
    ACTIONS(10233), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7096), 1,
      aux_sym_compound_type_repeat1,
    STATE(7322), 1,
      sym_long_identifier,
    STATE(7330), 1,
      sym_type_arguments,
    ACTIONS(7283), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
    STATE(6765), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7285), 5,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
  [166843] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9991), 1,
      anon_sym_new,
    ACTIONS(9995), 1,
      anon_sym_static,
    ACTIONS(9997), 1,
      anon_sym_member,
    ACTIONS(9999), 1,
      anon_sym_abstract,
    ACTIONS(10001), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6527), 1,
      sym_member_defn,
    STATE(7634), 1,
      sym_additional_constr_defn,
    STATE(7920), 1,
      sym_attributes,
    STATE(11728), 1,
      sym__member_defns,
    STATE(11902), 1,
      sym_access_modifier,
    ACTIONS(9993), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6766), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166917] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10235), 1,
      anon_sym_or,
    STATE(6920), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(3498), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(6767), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [166969] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10237), 1,
      anon_sym_or,
    STATE(6788), 1,
      aux_sym_type_argument_repeat1,
    STATE(6768), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3496), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [167021] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6280), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6769), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6278), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [167069] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10239), 1,
      anon_sym_DOT,
    STATE(6930), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3494), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(6770), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [167121] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6400), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6771), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6398), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [167169] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6404), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6772), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6402), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [167217] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10241), 1,
      anon_sym_DOT,
    STATE(6926), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3494), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(6773), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [167269] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9991), 1,
      anon_sym_new,
    ACTIONS(9995), 1,
      anon_sym_static,
    ACTIONS(9997), 1,
      anon_sym_member,
    ACTIONS(9999), 1,
      anon_sym_abstract,
    ACTIONS(10001), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6527), 1,
      sym_member_defn,
    STATE(7634), 1,
      sym_additional_constr_defn,
    STATE(7920), 1,
      sym_attributes,
    STATE(11816), 1,
      sym__member_defns,
    STATE(11902), 1,
      sym_access_modifier,
    ACTIONS(9993), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6774), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167343] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6416), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6775), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6414), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [167391] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3487), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(6776), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3485), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [167439] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(2692), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6777), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2690), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [167487] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10243), 1,
      anon_sym_y,
    ACTIONS(10245), 1,
      anon_sym_uy,
    ACTIONS(10247), 1,
      anon_sym_s,
    ACTIONS(10249), 1,
      anon_sym_us,
    ACTIONS(10251), 1,
      anon_sym_l,
    ACTIONS(10253), 1,
      aux_sym_uint32_token1,
    ACTIONS(10255), 1,
      anon_sym_n,
    ACTIONS(10257), 1,
      anon_sym_un,
    ACTIONS(10259), 1,
      anon_sym_L,
    ACTIONS(10261), 1,
      aux_sym_uint64_token1,
    ACTIONS(10263), 1,
      aux_sym_bignum_token1,
    ACTIONS(10265), 1,
      aux_sym_decimal_token1,
    ACTIONS(10267), 1,
      anon_sym_DOT2,
    ACTIONS(10269), 1,
      aux_sym_float_token1,
    ACTIONS(3191), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(6778), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167561] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6318), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6779), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6316), 15,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [167609] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6336), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6780), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6334), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [167657] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(239), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10271), 1,
      anon_sym_COMMA,
    STATE(6781), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(237), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [167707] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6124), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10273), 1,
      anon_sym_COMMA,
    STATE(6782), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6122), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [167757] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6288), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6783), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6286), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [167805] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3498), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6784), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [167853] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10275), 1,
      anon_sym_DOT,
    STATE(6790), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3494), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6785), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [167905] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10277), 1,
      anon_sym_or,
    ACTIONS(3480), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(6786), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3478), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [167955] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6416), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6787), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6414), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [168003] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10237), 1,
      anon_sym_or,
    STATE(6792), 1,
      aux_sym_type_argument_repeat1,
    STATE(6788), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3476), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3474), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [168055] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6124), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10280), 1,
      anon_sym_COMMA,
    STATE(6789), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6122), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [168105] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10275), 1,
      anon_sym_DOT,
    STATE(6791), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3451), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6790), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3449), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [168157] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10282), 1,
      anon_sym_DOT,
    ACTIONS(3487), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6791), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3485), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [168207] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10285), 1,
      anon_sym_or,
    ACTIONS(3480), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    STATE(6792), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3478), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [168257] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10288), 1,
      anon_sym_DOT,
    STATE(6849), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3494), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(6793), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [168309] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9464), 1,
      sym_identifier,
    ACTIONS(10290), 1,
      anon_sym_DASH_GT,
    ACTIONS(10292), 1,
      anon_sym_STAR,
    ACTIONS(10294), 1,
      anon_sym_LT2,
    ACTIONS(10296), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7193), 1,
      aux_sym_compound_type_repeat1,
    STATE(7233), 1,
      sym_long_identifier,
    STATE(7268), 1,
      sym_type_arguments,
    ACTIONS(3431), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(6794), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3429), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [168373] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6795), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3480), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_or,
      sym_identifier,
    ACTIONS(3478), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [168421] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9991), 1,
      anon_sym_new,
    ACTIONS(9995), 1,
      anon_sym_static,
    ACTIONS(9997), 1,
      anon_sym_member,
    ACTIONS(9999), 1,
      anon_sym_abstract,
    ACTIONS(10001), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6527), 1,
      sym_member_defn,
    STATE(7634), 1,
      sym_additional_constr_defn,
    STATE(7920), 1,
      sym_attributes,
    STATE(11568), 1,
      sym__member_defns,
    STATE(11902), 1,
      sym_access_modifier,
    ACTIONS(9993), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6796), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168495] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9464), 1,
      sym_identifier,
    ACTIONS(10290), 1,
      anon_sym_DASH_GT,
    ACTIONS(10292), 1,
      anon_sym_STAR,
    ACTIONS(10294), 1,
      anon_sym_LT2,
    ACTIONS(10296), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7193), 1,
      aux_sym_compound_type_repeat1,
    STATE(7233), 1,
      sym_long_identifier,
    STATE(7268), 1,
      sym_type_arguments,
    ACTIONS(3427), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(6797), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3425), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [168559] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9464), 1,
      sym_identifier,
    ACTIONS(10290), 1,
      anon_sym_DASH_GT,
    ACTIONS(10292), 1,
      anon_sym_STAR,
    ACTIONS(10294), 1,
      anon_sym_LT2,
    ACTIONS(10296), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7193), 1,
      aux_sym_compound_type_repeat1,
    STATE(7233), 1,
      sym_long_identifier,
    STATE(7268), 1,
      sym_type_arguments,
    ACTIONS(3407), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(6798), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3403), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [168623] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3498), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(6799), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [168671] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6184), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10298), 1,
      anon_sym_COMMA,
    STATE(6800), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6182), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [168721] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6448), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6801), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6446), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [168769] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9108), 1,
      sym_identifier,
    ACTIONS(10221), 1,
      anon_sym_DASH_GT,
    ACTIONS(10223), 1,
      anon_sym_STAR,
    ACTIONS(10225), 1,
      anon_sym_LT2,
    ACTIONS(10227), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7105), 1,
      aux_sym_compound_type_repeat1,
    STATE(7317), 1,
      sym_type_arguments,
    STATE(7327), 1,
      sym_long_identifier,
    ACTIONS(3417), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3419), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
    STATE(6802), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168833] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6032), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6803), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6030), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [168881] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6396), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6804), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6394), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [168929] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9364), 1,
      sym_identifier,
    ACTIONS(10229), 1,
      anon_sym_STAR,
    ACTIONS(10231), 1,
      anon_sym_LT2,
    ACTIONS(10233), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7096), 1,
      aux_sym_compound_type_repeat1,
    STATE(7322), 1,
      sym_long_identifier,
    STATE(7330), 1,
      sym_type_arguments,
    ACTIONS(7279), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
    STATE(6805), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7281), 5,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
  [168991] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3480), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_or,
      sym_identifier,
    STATE(6806), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3478), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [169039] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6376), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6807), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6374), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [169087] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6024), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6808), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6022), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [169135] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6330), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6809), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6328), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [169183] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9364), 1,
      sym_identifier,
    ACTIONS(10229), 1,
      anon_sym_STAR,
    ACTIONS(10231), 1,
      anon_sym_LT2,
    ACTIONS(10233), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(10300), 1,
      anon_sym_DASH_GT,
    STATE(7096), 1,
      aux_sym_compound_type_repeat1,
    STATE(7322), 1,
      sym_long_identifier,
    STATE(7330), 1,
      sym_type_arguments,
    ACTIONS(3417), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3419), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
    STATE(6810), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169247] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6428), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6811), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6426), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [169295] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6314), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6812), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6312), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [169343] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6340), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6813), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6338), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [169391] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6326), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6814), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6324), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [169439] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6458), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6815), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6456), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [169487] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6288), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6816), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6286), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [169535] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6420), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6817), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6418), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [169583] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3700), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6818), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3698), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [169631] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6296), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6819), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6294), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [169679] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9290), 1,
      sym_identifier,
    ACTIONS(10072), 1,
      anon_sym_DASH_GT,
    ACTIONS(10074), 1,
      anon_sym_STAR,
    ACTIONS(10078), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7080), 1,
      aux_sym_compound_type_repeat1,
    STATE(7143), 1,
      sym_long_identifier,
    STATE(7147), 1,
      sym_type_arguments,
    ACTIONS(7279), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(6820), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7281), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [169741] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4975), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6821), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4973), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [169789] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9991), 1,
      anon_sym_new,
    ACTIONS(9995), 1,
      anon_sym_static,
    ACTIONS(9997), 1,
      anon_sym_member,
    ACTIONS(9999), 1,
      anon_sym_abstract,
    ACTIONS(10001), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6527), 1,
      sym_member_defn,
    STATE(7634), 1,
      sym_additional_constr_defn,
    STATE(7920), 1,
      sym_attributes,
    STATE(11414), 1,
      sym__member_defns,
    STATE(11902), 1,
      sym_access_modifier,
    ACTIONS(9993), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6822), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169863] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9184), 1,
      sym_identifier,
    ACTIONS(10169), 1,
      anon_sym_DASH_GT,
    ACTIONS(10173), 1,
      anon_sym_STAR,
    ACTIONS(10175), 1,
      anon_sym_LT2,
    ACTIONS(10177), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7137), 1,
      aux_sym_compound_type_repeat1,
    STATE(7216), 1,
      sym_long_identifier,
    STATE(7290), 1,
      sym_type_arguments,
    ACTIONS(3403), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3407), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
    STATE(6823), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169927] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6432), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6824), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6430), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [169975] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3487), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6825), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3485), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [170023] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9464), 1,
      sym_identifier,
    ACTIONS(10290), 1,
      anon_sym_DASH_GT,
    ACTIONS(10292), 1,
      anon_sym_STAR,
    ACTIONS(10294), 1,
      anon_sym_LT2,
    ACTIONS(10296), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7193), 1,
      aux_sym_compound_type_repeat1,
    STATE(7233), 1,
      sym_long_identifier,
    STATE(7268), 1,
      sym_type_arguments,
    ACTIONS(3419), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(6826), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3417), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [170087] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6827), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3511), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      anon_sym_or,
      sym_identifier,
    ACTIONS(3509), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [170135] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10302), 1,
      anon_sym_DOT,
    STATE(6888), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3494), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6828), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [170187] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6010), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6829), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6008), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [170235] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9428), 1,
      sym_identifier,
    ACTIONS(10211), 1,
      anon_sym_DASH_GT,
    ACTIONS(10213), 1,
      anon_sym_STAR,
    ACTIONS(10215), 1,
      anon_sym_LT2,
    ACTIONS(10217), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7158), 1,
      aux_sym_compound_type_repeat1,
    STATE(7249), 1,
      sym_long_identifier,
    STATE(7266), 1,
      sym_type_arguments,
    ACTIONS(3431), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(6830), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3429), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [170299] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6326), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6831), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6324), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [170347] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6454), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6832), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6452), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [170395] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9184), 1,
      sym_identifier,
    ACTIONS(10169), 1,
      anon_sym_DASH_GT,
    ACTIONS(10173), 1,
      anon_sym_STAR,
    ACTIONS(10175), 1,
      anon_sym_LT2,
    ACTIONS(10177), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7137), 1,
      aux_sym_compound_type_repeat1,
    STATE(7216), 1,
      sym_long_identifier,
    STATE(7290), 1,
      sym_type_arguments,
    ACTIONS(3425), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3427), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
    STATE(6833), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170459] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10304), 1,
      anon_sym_or,
    STATE(6850), 1,
      aux_sym_type_argument_repeat1,
    STATE(6834), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(3496), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [170511] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6432), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6835), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6430), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [170559] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10306), 1,
      anon_sym_DOT,
    ACTIONS(3487), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(6836), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3485), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [170609] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6388), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6837), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6386), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [170657] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6436), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6838), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6434), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [170705] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6388), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6839), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6386), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [170753] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6440), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6840), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6438), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [170801] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10309), 1,
      anon_sym_DOT,
    ACTIONS(3487), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(6841), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3485), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [170851] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9108), 1,
      sym_identifier,
    ACTIONS(10221), 1,
      anon_sym_DASH_GT,
    ACTIONS(10223), 1,
      anon_sym_STAR,
    ACTIONS(10225), 1,
      anon_sym_LT2,
    ACTIONS(10227), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7105), 1,
      aux_sym_compound_type_repeat1,
    STATE(7317), 1,
      sym_type_arguments,
    STATE(7327), 1,
      sym_long_identifier,
    ACTIONS(3429), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3431), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
    STATE(6842), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170915] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6384), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6843), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6382), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [170963] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10312), 1,
      anon_sym_or,
    STATE(6921), 1,
      aux_sym_type_argument_repeat1,
    STATE(6844), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3476), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3474), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [171015] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(2692), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6845), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2690), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [171063] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9991), 1,
      anon_sym_new,
    ACTIONS(9995), 1,
      anon_sym_static,
    ACTIONS(9997), 1,
      anon_sym_member,
    ACTIONS(9999), 1,
      anon_sym_abstract,
    ACTIONS(10001), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6527), 1,
      sym_member_defn,
    STATE(7634), 1,
      sym_additional_constr_defn,
    STATE(7920), 1,
      sym_attributes,
    STATE(11902), 1,
      sym_access_modifier,
    STATE(11939), 1,
      sym__member_defns,
    ACTIONS(9993), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6846), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171137] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4975), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6847), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4973), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [171185] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9108), 1,
      sym_identifier,
    ACTIONS(10221), 1,
      anon_sym_DASH_GT,
    ACTIONS(10223), 1,
      anon_sym_STAR,
    ACTIONS(10225), 1,
      anon_sym_LT2,
    ACTIONS(10227), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7105), 1,
      aux_sym_compound_type_repeat1,
    STATE(7317), 1,
      sym_type_arguments,
    STATE(7327), 1,
      sym_long_identifier,
    ACTIONS(3425), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3427), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
    STATE(6848), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171249] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10288), 1,
      anon_sym_DOT,
    STATE(6841), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3451), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(6849), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3449), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [171301] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10304), 1,
      anon_sym_or,
    STATE(6872), 1,
      aux_sym_type_argument_repeat1,
    STATE(6850), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3476), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(3474), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [171353] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6302), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6851), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6300), 15,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [171401] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6436), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6852), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6434), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [171449] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9364), 1,
      sym_identifier,
    ACTIONS(10229), 1,
      anon_sym_STAR,
    ACTIONS(10231), 1,
      anon_sym_LT2,
    ACTIONS(10233), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(10300), 1,
      anon_sym_DASH_GT,
    STATE(7096), 1,
      aux_sym_compound_type_repeat1,
    STATE(7322), 1,
      sym_long_identifier,
    STATE(7330), 1,
      sym_type_arguments,
    ACTIONS(3425), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3427), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
    STATE(6853), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171513] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6184), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10314), 1,
      anon_sym_COMMA,
    STATE(6854), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6182), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [171563] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6392), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6855), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6390), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [171611] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6318), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6856), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6316), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [171659] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9108), 1,
      sym_identifier,
    ACTIONS(10221), 1,
      anon_sym_DASH_GT,
    ACTIONS(10223), 1,
      anon_sym_STAR,
    ACTIONS(10225), 1,
      anon_sym_LT2,
    ACTIONS(10227), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7105), 1,
      aux_sym_compound_type_repeat1,
    STATE(7317), 1,
      sym_type_arguments,
    STATE(7327), 1,
      sym_long_identifier,
    ACTIONS(7279), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
    ACTIONS(7281), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6857), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171723] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9364), 1,
      sym_identifier,
    ACTIONS(10229), 1,
      anon_sym_STAR,
    ACTIONS(10231), 1,
      anon_sym_LT2,
    ACTIONS(10233), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(10300), 1,
      anon_sym_DASH_GT,
    STATE(7096), 1,
      aux_sym_compound_type_repeat1,
    STATE(7322), 1,
      sym_long_identifier,
    STATE(7330), 1,
      sym_type_arguments,
    ACTIONS(3403), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3407), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
    STATE(6858), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171787] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9184), 1,
      sym_identifier,
    ACTIONS(10169), 1,
      anon_sym_DASH_GT,
    ACTIONS(10173), 1,
      anon_sym_STAR,
    ACTIONS(10175), 1,
      anon_sym_LT2,
    ACTIONS(10177), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7137), 1,
      aux_sym_compound_type_repeat1,
    STATE(7216), 1,
      sym_long_identifier,
    STATE(7290), 1,
      sym_type_arguments,
    ACTIONS(3429), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3431), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
    STATE(6859), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171851] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4975), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6860), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4973), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [171899] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9991), 1,
      anon_sym_new,
    ACTIONS(9995), 1,
      anon_sym_static,
    ACTIONS(9997), 1,
      anon_sym_member,
    ACTIONS(9999), 1,
      anon_sym_abstract,
    ACTIONS(10001), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6527), 1,
      sym_member_defn,
    STATE(7634), 1,
      sym_additional_constr_defn,
    STATE(7920), 1,
      sym_attributes,
    STATE(10938), 1,
      sym__member_defns,
    STATE(11902), 1,
      sym_access_modifier,
    ACTIONS(9993), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6861), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171973] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6444), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6862), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6442), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [172021] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6296), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6863), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6294), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [172069] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6448), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6864), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6446), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [172117] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9428), 1,
      sym_identifier,
    ACTIONS(10211), 1,
      anon_sym_DASH_GT,
    ACTIONS(10213), 1,
      anon_sym_STAR,
    ACTIONS(10215), 1,
      anon_sym_LT2,
    ACTIONS(10217), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7158), 1,
      aux_sym_compound_type_repeat1,
    STATE(7249), 1,
      sym_long_identifier,
    STATE(7266), 1,
      sym_type_arguments,
    ACTIONS(3427), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(6865), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3425), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [172181] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6024), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6866), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6022), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [172229] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9464), 1,
      sym_identifier,
    ACTIONS(10290), 1,
      anon_sym_DASH_GT,
    ACTIONS(10292), 1,
      anon_sym_STAR,
    ACTIONS(10294), 1,
      anon_sym_LT2,
    ACTIONS(10296), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7193), 1,
      aux_sym_compound_type_repeat1,
    STATE(7233), 1,
      sym_long_identifier,
    STATE(7268), 1,
      sym_type_arguments,
    ACTIONS(7314), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(6867), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7312), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [172293] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6344), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6868), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6342), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [172341] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6302), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6869), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6300), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [172389] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6284), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6870), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6282), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [172437] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10316), 1,
      anon_sym_or,
    STATE(6916), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(3498), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(6871), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [172489] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10318), 1,
      anon_sym_or,
    ACTIONS(3480), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(6872), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3478), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [172539] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6292), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6873), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6290), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [172587] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3511), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_or,
      sym_identifier,
    STATE(6874), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3509), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [172635] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6306), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6875), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6304), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [172683] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4975), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6876), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4973), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [172731] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6306), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6877), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6304), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [172779] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9991), 1,
      anon_sym_new,
    ACTIONS(9995), 1,
      anon_sym_static,
    ACTIONS(9997), 1,
      anon_sym_member,
    ACTIONS(9999), 1,
      anon_sym_abstract,
    ACTIONS(10001), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6527), 1,
      sym_member_defn,
    STATE(7634), 1,
      sym_additional_constr_defn,
    STATE(7920), 1,
      sym_attributes,
    STATE(11320), 1,
      sym__member_defns,
    STATE(11902), 1,
      sym_access_modifier,
    ACTIONS(9993), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6878), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172853] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6458), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6879), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6456), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [172901] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6880), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3480), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      anon_sym_or,
      sym_identifier,
    ACTIONS(3478), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [172949] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6032), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6881), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6030), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [172997] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6392), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6882), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6390), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [173045] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10321), 1,
      anon_sym_STAR,
    ACTIONS(3427), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(6883), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3425), 10,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [173095] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10312), 1,
      anon_sym_or,
    STATE(6844), 1,
      aux_sym_type_argument_repeat1,
    STATE(6884), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3496), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [173147] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6885), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3511), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      anon_sym_or,
      sym_identifier,
    ACTIONS(3509), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [173195] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6408), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6886), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6406), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [173243] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6400), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6887), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6398), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [173291] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10302), 1,
      anon_sym_DOT,
    STATE(6891), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3451), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6888), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3449), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [173343] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6134), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6889), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6132), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [173391] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6340), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6890), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6338), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [173439] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10324), 1,
      anon_sym_DOT,
    ACTIONS(3487), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6891), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3485), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [173489] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9184), 1,
      sym_identifier,
    ACTIONS(10169), 1,
      anon_sym_DASH_GT,
    ACTIONS(10173), 1,
      anon_sym_STAR,
    ACTIONS(10175), 1,
      anon_sym_LT2,
    ACTIONS(10177), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7137), 1,
      aux_sym_compound_type_repeat1,
    STATE(7216), 1,
      sym_long_identifier,
    STATE(7290), 1,
      sym_type_arguments,
    ACTIONS(3417), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3419), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
    STATE(6892), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173553] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3700), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6893), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3698), 15,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [173601] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6376), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6894), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6374), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [173649] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6396), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6895), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6394), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [173697] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6302), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6896), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6300), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [173745] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9428), 1,
      sym_identifier,
    ACTIONS(10211), 1,
      anon_sym_DASH_GT,
    ACTIONS(10213), 1,
      anon_sym_STAR,
    ACTIONS(10215), 1,
      anon_sym_LT2,
    ACTIONS(10217), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7158), 1,
      aux_sym_compound_type_repeat1,
    STATE(7249), 1,
      sym_long_identifier,
    STATE(7266), 1,
      sym_type_arguments,
    ACTIONS(7314), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(6897), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7312), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [173809] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10327), 1,
      anon_sym_DOT,
    ACTIONS(3487), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(6898), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3485), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [173859] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9108), 1,
      sym_identifier,
    ACTIONS(10221), 1,
      anon_sym_DASH_GT,
    ACTIONS(10223), 1,
      anon_sym_STAR,
    ACTIONS(10225), 1,
      anon_sym_LT2,
    ACTIONS(10227), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7105), 1,
      aux_sym_compound_type_repeat1,
    STATE(7317), 1,
      sym_type_arguments,
    STATE(7327), 1,
      sym_long_identifier,
    ACTIONS(3403), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3407), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
    STATE(6899), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173923] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10330), 1,
      anon_sym_STAR,
    ACTIONS(3427), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6900), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3425), 10,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [173973] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6274), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10333), 1,
      anon_sym_with,
    STATE(6901), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6272), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [174023] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4975), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6902), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4973), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [174071] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6404), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6903), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6402), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [174119] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9248), 1,
      sym_identifier,
    ACTIONS(10027), 1,
      anon_sym_DASH_GT,
    ACTIONS(10031), 1,
      anon_sym_STAR,
    ACTIONS(10033), 1,
      anon_sym_LT2,
    ACTIONS(10035), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7068), 1,
      aux_sym_compound_type_repeat1,
    STATE(7173), 1,
      sym_type_arguments,
    STATE(7203), 1,
      sym_long_identifier,
    STATE(7366), 1,
      sym_type_argument_constraints,
    ACTIONS(7226), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    ACTIONS(7224), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6904), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174185] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6322), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6905), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6320), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [174233] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6010), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6906), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6008), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [174281] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6336), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6907), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6334), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [174329] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6444), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6908), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6442), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [174377] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9912), 1,
      anon_sym_STAR,
    STATE(6900), 1,
      aux_sym_compound_type_repeat1,
    ACTIONS(3468), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6909), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3466), 10,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [174429] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9428), 1,
      sym_identifier,
    ACTIONS(10211), 1,
      anon_sym_DASH_GT,
    ACTIONS(10213), 1,
      anon_sym_STAR,
    ACTIONS(10215), 1,
      anon_sym_LT2,
    ACTIONS(10217), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7158), 1,
      aux_sym_compound_type_repeat1,
    STATE(7249), 1,
      sym_long_identifier,
    STATE(7266), 1,
      sym_type_arguments,
    ACTIONS(3407), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(6910), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3403), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [174493] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(2692), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6911), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2690), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [174541] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6428), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6912), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6426), 15,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [174589] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6454), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6913), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6452), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [174637] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10335), 1,
      anon_sym_COLON_GT,
    ACTIONS(3515), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(6914), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [174687] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9991), 1,
      anon_sym_new,
    ACTIONS(9995), 1,
      anon_sym_static,
    ACTIONS(9997), 1,
      anon_sym_member,
    ACTIONS(9999), 1,
      anon_sym_abstract,
    ACTIONS(10001), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6527), 1,
      sym_member_defn,
    STATE(7634), 1,
      sym_additional_constr_defn,
    STATE(7920), 1,
      sym_attributes,
    STATE(11647), 1,
      sym__member_defns,
    STATE(11902), 1,
      sym_access_modifier,
    ACTIONS(9993), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6915), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174761] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10316), 1,
      anon_sym_or,
    STATE(6940), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(3476), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(6916), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3474), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [174813] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6420), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6917), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6418), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [174861] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6284), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6918), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6282), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [174909] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3700), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6919), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3698), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [174957] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10235), 1,
      anon_sym_or,
    STATE(6786), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(3476), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(6920), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3474), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [175009] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10337), 1,
      anon_sym_or,
    ACTIONS(3480), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(6921), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3478), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [175059] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9364), 1,
      sym_identifier,
    ACTIONS(10229), 1,
      anon_sym_STAR,
    ACTIONS(10231), 1,
      anon_sym_LT2,
    ACTIONS(10233), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(10300), 1,
      anon_sym_DASH_GT,
    STATE(7096), 1,
      aux_sym_compound_type_repeat1,
    STATE(7322), 1,
      sym_long_identifier,
    STATE(7330), 1,
      sym_type_arguments,
    ACTIONS(3429), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3431), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
    STATE(6922), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175123] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6412), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6923), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6410), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [175171] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10340), 1,
      anon_sym_COLON_GT,
    ACTIONS(3515), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6924), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [175221] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6412), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6925), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6410), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [175269] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10241), 1,
      anon_sym_DOT,
    STATE(6898), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3451), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(6926), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3449), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [175321] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6280), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6927), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6278), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [175369] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(2692), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6928), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2690), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [175417] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9870), 1,
      anon_sym_STAR,
    STATE(6883), 1,
      aux_sym_compound_type_repeat1,
    ACTIONS(3468), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(6929), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3466), 10,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [175469] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10239), 1,
      anon_sym_DOT,
    STATE(6836), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3451), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(6930), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3449), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [175521] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6134), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10342), 1,
      anon_sym_COMMA,
    STATE(6931), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6132), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [175571] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9991), 1,
      anon_sym_new,
    ACTIONS(9995), 1,
      anon_sym_static,
    ACTIONS(9997), 1,
      anon_sym_member,
    ACTIONS(9999), 1,
      anon_sym_abstract,
    ACTIONS(10001), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6527), 1,
      sym_member_defn,
    STATE(7634), 1,
      sym_additional_constr_defn,
    STATE(7920), 1,
      sym_attributes,
    STATE(11444), 1,
      sym__member_defns,
    STATE(11902), 1,
      sym_access_modifier,
    ACTIONS(9993), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6932), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175645] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6380), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6933), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6378), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [175693] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6292), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6934), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6290), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [175741] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6310), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6935), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6308), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [175789] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6344), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6936), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6342), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [175837] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6170), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10344), 1,
      anon_sym_with,
    STATE(6937), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6168), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [175887] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6134), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10346), 1,
      anon_sym_COMMA,
    STATE(6938), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6132), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [175937] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6134), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6939), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6132), 15,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [175985] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10348), 1,
      anon_sym_or,
    ACTIONS(3480), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(6940), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3478), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [176035] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6384), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6941), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6382), 15,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_and,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
      anon_sym_POUNDendif,
  [176083] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10351), 1,
      anon_sym_COLON_GT,
    ACTIONS(3515), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(6942), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [176132] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3476), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10353), 1,
      anon_sym_or,
    STATE(6994), 1,
      aux_sym_type_argument_repeat1,
    STATE(6943), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3474), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [176183] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6944), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3480), 6,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      anon_sym_or,
      sym_identifier,
    ACTIONS(3478), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [176230] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3511), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_or,
      sym_identifier,
    STATE(6945), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3509), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [176277] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6310), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6946), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6308), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [176324] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3562), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(6947), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3560), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [176371] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3551), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(6948), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3549), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [176418] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10355), 1,
      anon_sym_COLON_GT,
    ACTIONS(3515), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6949), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [176467] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6396), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6950), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6394), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [176514] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3551), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6951), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3549), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [176561] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10357), 1,
      anon_sym_LT2,
    ACTIONS(3505), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6952), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3503), 10,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [176610] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6376), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6953), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6374), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [176657] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6024), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6954), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6022), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [176704] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6955), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3511), 6,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      anon_sym_or,
      sym_identifier,
    ACTIONS(3509), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [176751] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6134), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6956), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6132), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [176798] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6306), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6957), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6304), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [176845] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3480), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_or,
      sym_identifier,
    STATE(6958), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3478), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [176892] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6296), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6959), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6294), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [176939] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3515), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6960), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [176986] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(2692), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6961), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2690), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [177033] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4975), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6962), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4973), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [177080] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9172), 1,
      sym_identifier,
    ACTIONS(10359), 1,
      anon_sym_DASH_GT,
    ACTIONS(10361), 1,
      anon_sym_STAR,
    ACTIONS(10363), 1,
      anon_sym_LT2,
    ACTIONS(10365), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7248), 1,
      aux_sym_compound_type_repeat1,
    STATE(7417), 1,
      sym_long_identifier,
    STATE(7474), 1,
      sym_type_arguments,
    ACTIONS(7314), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
    ACTIONS(7312), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6963), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177143] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3511), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_or,
      sym_identifier,
    STATE(6964), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3509), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [177190] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6432), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6965), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6430), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [177237] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6420), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6966), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6418), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [177284] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6440), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6967), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6438), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [177331] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6032), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6968), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6030), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [177378] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10082), 1,
      anon_sym_STAR,
    STATE(7019), 1,
      aux_sym_compound_type_repeat1,
    ACTIONS(3468), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6969), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3466), 9,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [177429] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3562), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6970), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3560), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [177476] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9172), 1,
      sym_identifier,
    ACTIONS(10359), 1,
      anon_sym_DASH_GT,
    ACTIONS(10361), 1,
      anon_sym_STAR,
    ACTIONS(10363), 1,
      anon_sym_LT2,
    ACTIONS(10365), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7248), 1,
      aux_sym_compound_type_repeat1,
    STATE(7417), 1,
      sym_long_identifier,
    STATE(7474), 1,
      sym_type_arguments,
    ACTIONS(3407), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
    ACTIONS(3403), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6971), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177539] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6444), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6972), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6442), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [177586] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6448), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6973), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6446), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [177633] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3535), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6974), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3533), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [177680] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6280), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6975), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6278), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [177727] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6458), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6976), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6456), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [177774] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9172), 1,
      sym_identifier,
    ACTIONS(10359), 1,
      anon_sym_DASH_GT,
    ACTIONS(10361), 1,
      anon_sym_STAR,
    ACTIONS(10363), 1,
      anon_sym_LT2,
    ACTIONS(10365), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7248), 1,
      aux_sym_compound_type_repeat1,
    STATE(7417), 1,
      sym_long_identifier,
    STATE(7474), 1,
      sym_type_arguments,
    ACTIONS(3427), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
    ACTIONS(3425), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6977), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177837] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6292), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6978), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6290), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [177884] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3531), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6979), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3529), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [177931] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9172), 1,
      sym_identifier,
    ACTIONS(10359), 1,
      anon_sym_DASH_GT,
    ACTIONS(10361), 1,
      anon_sym_STAR,
    ACTIONS(10363), 1,
      anon_sym_LT2,
    ACTIONS(10365), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7248), 1,
      aux_sym_compound_type_repeat1,
    STATE(7417), 1,
      sym_long_identifier,
    STATE(7474), 1,
      sym_type_arguments,
    ACTIONS(3419), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
    ACTIONS(3417), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6980), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177994] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6314), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6981), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6312), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [178041] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6330), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6982), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6328), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [178088] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3487), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(6983), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3485), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [178135] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6416), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6984), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6414), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [178182] = 22,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6862), 1,
      anon_sym_let,
    ACTIONS(6864), 1,
      anon_sym_let_BANG,
    ACTIONS(6876), 1,
      anon_sym_new,
    ACTIONS(10367), 1,
      sym_identifier,
    ACTIONS(10369), 1,
      anon_sym_do,
    ACTIONS(10373), 1,
      anon_sym_static,
    ACTIONS(10375), 1,
      anon_sym_member,
    ACTIONS(10377), 1,
      anon_sym_abstract,
    ACTIONS(10379), 1,
      anon_sym_val,
    STATE(6843), 1,
      sym_function_or_value_defn,
    STATE(6936), 1,
      sym_additional_constr_defn,
    STATE(11317), 1,
      sym_access_modifier,
    ACTIONS(10371), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(6985), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178253] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3498), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(6986), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [178300] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10381), 1,
      anon_sym_DOT,
    ACTIONS(3487), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    STATE(6987), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3485), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [178349] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10384), 1,
      anon_sym_DOT,
    STATE(7053), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3494), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(6988), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_EQ2,
  [178400] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9172), 1,
      sym_identifier,
    ACTIONS(10359), 1,
      anon_sym_DASH_GT,
    ACTIONS(10361), 1,
      anon_sym_STAR,
    ACTIONS(10363), 1,
      anon_sym_LT2,
    ACTIONS(10365), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7248), 1,
      aux_sym_compound_type_repeat1,
    STATE(7417), 1,
      sym_long_identifier,
    STATE(7474), 1,
      sym_type_arguments,
    ACTIONS(3431), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
    ACTIONS(3429), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6989), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178463] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3539), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(6990), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3537), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [178510] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6288), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6991), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6286), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [178557] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10386), 1,
      anon_sym_STAR,
    ACTIONS(3427), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6992), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3425), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [178606] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3527), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6993), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3525), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [178653] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3480), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10389), 1,
      anon_sym_or,
    STATE(6994), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3478), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [178702] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6384), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6995), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6382), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [178749] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3487), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(6996), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3485), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [178796] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6344), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6997), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6342), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [178843] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(2692), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6998), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2690), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [178890] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3535), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(6999), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3533), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [178937] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10392), 1,
      anon_sym_STAR,
    ACTIONS(3427), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7000), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3425), 10,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [178986] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3531), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7001), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3529), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [179033] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6284), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7002), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6282), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [179080] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10395), 1,
      anon_sym_DOT,
    STATE(6987), 1,
      aux_sym_long_identifier_repeat1,
    STATE(7003), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3451), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3449), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [179131] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3527), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7004), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3525), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [179178] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3519), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7005), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3517), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [179225] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6388), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7006), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6386), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [179272] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6318), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7007), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6316), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [179319] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7008), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3480), 6,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      anon_sym_or,
      sym_identifier,
    ACTIONS(3478), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [179366] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3523), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7009), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3521), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [179413] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10397), 1,
      anon_sym_or,
    ACTIONS(3480), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(7010), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3478), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [179462] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6412), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7011), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6410), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [179509] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3543), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7012), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3541), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [179556] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6302), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7013), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6300), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [179603] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3487), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7014), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3485), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [179650] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10400), 1,
      anon_sym_DOT,
    ACTIONS(3487), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7015), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3485), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [179699] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3519), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7016), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3517), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [179746] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10403), 1,
      anon_sym_STAR,
    ACTIONS(3427), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7017), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3425), 9,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [179795] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3700), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7018), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3698), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [179842] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10406), 1,
      anon_sym_STAR,
    ACTIONS(3427), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7019), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3425), 9,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [179891] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10409), 1,
      anon_sym_LT2,
    ACTIONS(3505), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7020), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3503), 10,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [179940] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10411), 1,
      anon_sym_DOT,
    ACTIONS(3487), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7021), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3485), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [179989] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10414), 1,
      anon_sym_or,
    STATE(7055), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(3498), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(7022), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [180040] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10416), 1,
      anon_sym_DOT,
    STATE(7021), 1,
      aux_sym_long_identifier_repeat1,
    STATE(7023), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3451), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3449), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [180091] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10418), 1,
      anon_sym_DOT,
    STATE(7043), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3451), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7024), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3449), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [180142] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10420), 1,
      anon_sym_STAR,
    ACTIONS(3427), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7025), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3425), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [180191] = 22,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8333), 1,
      anon_sym_let,
    ACTIONS(8335), 1,
      anon_sym_let_BANG,
    ACTIONS(8337), 1,
      anon_sym_new,
    ACTIONS(10423), 1,
      anon_sym_do,
    ACTIONS(10425), 1,
      anon_sym_LPAREN,
    ACTIONS(10429), 1,
      anon_sym_static,
    ACTIONS(10431), 1,
      anon_sym_member,
    ACTIONS(10433), 1,
      anon_sym_abstract,
    ACTIONS(10435), 1,
      anon_sym_val,
    STATE(6658), 1,
      sym_function_or_value_defn,
    STATE(6717), 1,
      sym_additional_constr_defn,
    STATE(9684), 1,
      sym_access_modifier,
    ACTIONS(10427), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7026), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180262] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3487), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7027), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3485), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [180309] = 22,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8262), 1,
      anon_sym_let,
    ACTIONS(8264), 1,
      anon_sym_let_BANG,
    ACTIONS(8266), 1,
      anon_sym_new,
    ACTIONS(10425), 1,
      anon_sym_LPAREN,
    ACTIONS(10437), 1,
      anon_sym_do,
    ACTIONS(10441), 1,
      anon_sym_static,
    ACTIONS(10443), 1,
      anon_sym_member,
    ACTIONS(10445), 1,
      anon_sym_abstract,
    ACTIONS(10447), 1,
      anon_sym_val,
    STATE(6868), 1,
      sym_additional_constr_defn,
    STATE(6941), 1,
      sym_function_or_value_defn,
    STATE(9738), 1,
      sym_access_modifier,
    ACTIONS(10439), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7028), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180380] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10094), 1,
      anon_sym_STAR,
    STATE(7000), 1,
      aux_sym_compound_type_repeat1,
    ACTIONS(3468), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7029), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3466), 10,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [180431] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10418), 1,
      anon_sym_DOT,
    STATE(7024), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3494), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7030), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [180482] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10449), 1,
      anon_sym_DOT,
    ACTIONS(3487), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(7031), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3485), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_EQ2,
  [180531] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6436), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7032), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6434), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [180578] = 22,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8410), 1,
      anon_sym_let,
    ACTIONS(8412), 1,
      anon_sym_let_BANG,
    ACTIONS(8414), 1,
      anon_sym_new,
    ACTIONS(10425), 1,
      anon_sym_LPAREN,
    ACTIONS(10452), 1,
      anon_sym_do,
    ACTIONS(10456), 1,
      anon_sym_static,
    ACTIONS(10458), 1,
      anon_sym_member,
    ACTIONS(10460), 1,
      anon_sym_abstract,
    ACTIONS(10462), 1,
      anon_sym_val,
    STATE(6543), 1,
      sym_function_or_value_defn,
    STATE(6656), 1,
      sym_additional_constr_defn,
    STATE(9618), 1,
      sym_access_modifier,
    ACTIONS(10454), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7033), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180649] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6326), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7034), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6324), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [180696] = 22,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9991), 1,
      anon_sym_new,
    ACTIONS(9995), 1,
      anon_sym_static,
    ACTIONS(9997), 1,
      anon_sym_member,
    ACTIONS(9999), 1,
      anon_sym_abstract,
    ACTIONS(10001), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7594), 1,
      sym_member_defn,
    STATE(7634), 1,
      sym_additional_constr_defn,
    STATE(7920), 1,
      sym_attributes,
    STATE(11902), 1,
      sym_access_modifier,
    ACTIONS(9993), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7035), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180767] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7036), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3511), 6,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      anon_sym_or,
      sym_identifier,
    ACTIONS(3509), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [180814] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6408), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7037), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6406), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [180861] = 22,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8217), 1,
      anon_sym_let,
    ACTIONS(8219), 1,
      anon_sym_let_BANG,
    ACTIONS(8223), 1,
      anon_sym_new,
    ACTIONS(10425), 1,
      anon_sym_LPAREN,
    ACTIONS(10464), 1,
      anon_sym_do,
    ACTIONS(10468), 1,
      anon_sym_static,
    ACTIONS(10470), 1,
      anon_sym_member,
    ACTIONS(10472), 1,
      anon_sym_abstract,
    ACTIONS(10474), 1,
      anon_sym_val,
    STATE(3814), 1,
      sym_additional_constr_defn,
    STATE(3820), 1,
      sym_function_or_value_defn,
    STATE(10028), 1,
      sym_access_modifier,
    ACTIONS(10466), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7038), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180932] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6400), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7039), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6398), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [180979] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6340), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7040), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6338), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [181026] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3547), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7041), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3545), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [181073] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10476), 1,
      anon_sym_DOT,
    STATE(7015), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3451), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7042), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3449), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [181124] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10478), 1,
      anon_sym_DOT,
    ACTIONS(3487), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7043), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3485), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [181173] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10481), 1,
      anon_sym_COLON_GT,
    ACTIONS(3515), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7044), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [181222] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7045), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3511), 6,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      anon_sym_or,
      sym_identifier,
    ACTIONS(3509), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [181269] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9248), 1,
      sym_identifier,
    ACTIONS(10027), 1,
      anon_sym_DASH_GT,
    ACTIONS(10031), 1,
      anon_sym_STAR,
    ACTIONS(10033), 1,
      anon_sym_LT2,
    ACTIONS(10035), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7068), 1,
      aux_sym_compound_type_repeat1,
    STATE(7173), 1,
      sym_type_arguments,
    STATE(7203), 1,
      sym_long_identifier,
    ACTIONS(7314), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    ACTIONS(7312), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(7046), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181332] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3515), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7047), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [181379] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3523), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7048), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3521), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [181426] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10483), 1,
      anon_sym_DOT,
    ACTIONS(3487), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(7049), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3485), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [181475] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10056), 1,
      anon_sym_STAR,
    STATE(7017), 1,
      aux_sym_compound_type_repeat1,
    ACTIONS(3468), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7050), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3466), 9,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [181526] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3543), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7051), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3541), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [181573] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10416), 1,
      anon_sym_DOT,
    STATE(7023), 1,
      aux_sym_long_identifier_repeat1,
    STATE(7052), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3494), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3492), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [181624] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10384), 1,
      anon_sym_DOT,
    STATE(7031), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3451), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(7053), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3449), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_EQ2,
  [181675] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10486), 1,
      anon_sym_DOT,
    STATE(7049), 1,
      aux_sym_long_identifier_repeat1,
    STATE(7054), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3451), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(3449), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [181726] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10414), 1,
      anon_sym_or,
    STATE(7010), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(3476), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(7055), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3474), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [181777] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10476), 1,
      anon_sym_DOT,
    STATE(7042), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3494), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7056), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [181828] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3487), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7057), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3485), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [181875] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(2692), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7058), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2690), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [181922] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10486), 1,
      anon_sym_DOT,
    STATE(7054), 1,
      aux_sym_long_identifier_repeat1,
    STATE(7059), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3494), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(3492), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [181973] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10488), 1,
      anon_sym_LBRACK_LT,
    STATE(7246), 1,
      sym__attribute_set,
    ACTIONS(9025), 2,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
    STATE(7060), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_attributes_repeat1,
    ACTIONS(9020), 10,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [182024] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6404), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7061), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6402), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [182071] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6392), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7062), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6390), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [182118] = 22,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8217), 1,
      anon_sym_let,
    ACTIONS(8219), 1,
      anon_sym_let_BANG,
    ACTIONS(8223), 1,
      anon_sym_new,
    ACTIONS(10425), 1,
      anon_sym_LPAREN,
    ACTIONS(10464), 1,
      anon_sym_do,
    ACTIONS(10468), 1,
      anon_sym_static,
    ACTIONS(10472), 1,
      anon_sym_abstract,
    ACTIONS(10474), 1,
      anon_sym_val,
    ACTIONS(10491), 1,
      anon_sym_member,
    STATE(3814), 1,
      sym_additional_constr_defn,
    STATE(3820), 1,
      sym_function_or_value_defn,
    STATE(10028), 1,
      sym_access_modifier,
    ACTIONS(10466), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7063), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182189] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7064), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3480), 6,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      anon_sym_or,
      sym_identifier,
    ACTIONS(3478), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [182236] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3539), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7065), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3537), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [182283] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3753), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10493), 1,
      sym_int,
    STATE(7066), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3751), 13,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
      anon_sym_f,
      aux_sym_decimal_token1,
  [182332] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10495), 1,
      anon_sym_COLON_GT,
    ACTIONS(3515), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7067), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [182381] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10031), 1,
      anon_sym_STAR,
    STATE(7025), 1,
      aux_sym_compound_type_repeat1,
    ACTIONS(3468), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7068), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3466), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [182432] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4975), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7069), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4973), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [182479] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3604), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10497), 1,
      aux_sym_float_token1,
    STATE(7070), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3602), 13,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
      anon_sym_f,
      aux_sym_decimal_token1,
  [182528] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6322), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7071), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6320), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [182575] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6010), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7072), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6008), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [182622] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6380), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7073), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6378), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [182669] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3498), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7074), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [182716] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4975), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7075), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4973), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [182763] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3498), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7076), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [182810] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6858), 1,
      anon_sym_LBRACK_LT,
    STATE(7060), 1,
      aux_sym_attributes_repeat1,
    STATE(7246), 1,
      sym__attribute_set,
    ACTIONS(9007), 2,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
    STATE(7077), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9005), 10,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [182863] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3498), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7078), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [182910] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3498), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7079), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [182957] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10074), 1,
      anon_sym_STAR,
    STATE(6992), 1,
      aux_sym_compound_type_repeat1,
    ACTIONS(3468), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7080), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3466), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [183008] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6454), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7081), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6452), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [183055] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10395), 1,
      anon_sym_DOT,
    STATE(7003), 1,
      aux_sym_long_identifier_repeat1,
    STATE(7082), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3494), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3492), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [183106] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3498), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10353), 1,
      anon_sym_or,
    STATE(6943), 1,
      aux_sym_type_argument_repeat1,
    STATE(7083), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [183157] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10499), 1,
      anon_sym_COLON_GT,
    ACTIONS(3515), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7084), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [183206] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3480), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_or,
      sym_identifier,
    STATE(7085), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3478), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [183253] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3547), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7086), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3545), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [183300] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6388), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7087), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6386), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [183347] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6336), 1,
      anon_sym_let,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7088), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6334), 14,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      anon_sym_POUNDif,
  [183394] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10501), 1,
      anon_sym_LT2,
    ACTIONS(3505), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7089), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3503), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [183442] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3527), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7090), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3525), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [183488] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7091), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3496), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [183534] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7092), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3487), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(3485), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [183580] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3551), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7093), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3549), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [183626] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3562), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7094), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3560), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [183672] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7095), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3487), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3485), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [183718] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10229), 1,
      anon_sym_STAR,
    STATE(7104), 1,
      aux_sym_compound_type_repeat1,
    STATE(7096), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3468), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3466), 7,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [183768] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10503), 1,
      anon_sym_or,
    ACTIONS(3480), 3,
      anon_sym_COLON,
      anon_sym_with,
      sym_identifier,
    STATE(7097), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3478), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [183816] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10506), 1,
      anon_sym_STAR,
    ACTIONS(3427), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7098), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3425), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [183864] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8057), 1,
      anon_sym_COLON,
    STATE(7099), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8059), 13,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [183910] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6862), 1,
      anon_sym_let,
    ACTIONS(6864), 1,
      anon_sym_let_BANG,
    ACTIONS(7854), 1,
      anon_sym_new,
    ACTIONS(10509), 1,
      anon_sym_do,
    ACTIONS(10513), 1,
      anon_sym_static,
    ACTIONS(10515), 1,
      anon_sym_member,
    ACTIONS(10517), 1,
      anon_sym_abstract,
    ACTIONS(10519), 1,
      anon_sym_val,
    STATE(6843), 1,
      sym_function_or_value_defn,
    STATE(6936), 1,
      sym_additional_constr_defn,
    STATE(11317), 1,
      sym_access_modifier,
    ACTIONS(10511), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7100), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183978] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8043), 1,
      anon_sym_COLON,
    STATE(7101), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8045), 13,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [184024] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3487), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10521), 1,
      anon_sym_DOT,
    STATE(7102), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3485), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [184072] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3498), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7103), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [184118] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10524), 1,
      anon_sym_STAR,
    ACTIONS(3427), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7104), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3425), 7,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [184166] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10223), 1,
      anon_sym_STAR,
    STATE(7151), 1,
      aux_sym_compound_type_repeat1,
    STATE(7105), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3468), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(3466), 7,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [184216] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3535), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7106), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3533), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [184262] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3498), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7107), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [184308] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3523), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7108), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3521), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [184354] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7480), 1,
      anon_sym_let,
    ACTIONS(7482), 1,
      anon_sym_let_BANG,
    ACTIONS(7484), 1,
      anon_sym_new,
    ACTIONS(10527), 1,
      anon_sym_do,
    ACTIONS(10531), 1,
      anon_sym_static,
    ACTIONS(10533), 1,
      anon_sym_member,
    ACTIONS(10535), 1,
      anon_sym_abstract,
    ACTIONS(10537), 1,
      anon_sym_val,
    STATE(6320), 1,
      sym_additional_constr_defn,
    STATE(6392), 1,
      sym_function_or_value_defn,
    STATE(11882), 1,
      sym_access_modifier,
    ACTIONS(10529), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7109), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184422] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3519), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7110), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3517), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [184468] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3531), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7111), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3529), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [184514] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8217), 1,
      anon_sym_let,
    ACTIONS(8219), 1,
      anon_sym_let_BANG,
    ACTIONS(8223), 1,
      anon_sym_new,
    ACTIONS(10464), 1,
      anon_sym_do,
    ACTIONS(10468), 1,
      anon_sym_static,
    ACTIONS(10472), 1,
      anon_sym_abstract,
    ACTIONS(10474), 1,
      anon_sym_val,
    ACTIONS(10491), 1,
      anon_sym_member,
    STATE(3814), 1,
      sym_additional_constr_defn,
    STATE(3820), 1,
      sym_function_or_value_defn,
    STATE(10931), 1,
      sym_access_modifier,
    ACTIONS(10466), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7112), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184582] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7945), 1,
      anon_sym_COLON,
    STATE(7113), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7947), 13,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [184628] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3193), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8844), 1,
      aux_sym_decimal_token1,
    ACTIONS(8979), 1,
      anon_sym_f,
    STATE(7114), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3191), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [184678] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3451), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10539), 1,
      anon_sym_DOT,
    STATE(7102), 1,
      aux_sym_long_identifier_repeat1,
    STATE(7115), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3449), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [184728] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3527), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7116), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3525), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [184774] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3487), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7117), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3485), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [184820] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8410), 1,
      anon_sym_let,
    ACTIONS(8412), 1,
      anon_sym_let_BANG,
    ACTIONS(8414), 1,
      anon_sym_new,
    ACTIONS(10452), 1,
      anon_sym_do,
    ACTIONS(10456), 1,
      anon_sym_static,
    ACTIONS(10458), 1,
      anon_sym_member,
    ACTIONS(10460), 1,
      anon_sym_abstract,
    ACTIONS(10462), 1,
      anon_sym_val,
    STATE(6543), 1,
      sym_function_or_value_defn,
    STATE(6656), 1,
      sym_additional_constr_defn,
    STATE(11922), 1,
      sym_access_modifier,
    ACTIONS(10454), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7118), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184888] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10541), 1,
      anon_sym_LT2,
    ACTIONS(3505), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7119), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3503), 10,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [184936] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3728), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7120), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3726), 13,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
      anon_sym_f,
      aux_sym_decimal_token1,
  [184982] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10543), 1,
      anon_sym_COLON_GT,
    STATE(7121), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(3513), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [185030] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10545), 1,
      anon_sym_COLON_GT,
    STATE(7122), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3513), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [185078] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7123), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3487), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3485), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [185124] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3604), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7124), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3602), 13,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
      anon_sym_f,
      aux_sym_decimal_token1,
  [185170] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3494), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10539), 1,
      anon_sym_DOT,
    STATE(7115), 1,
      aux_sym_long_identifier_repeat1,
    STATE(7125), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [185220] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8051), 1,
      anon_sym_COLON,
    STATE(7126), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8053), 13,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [185266] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3523), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7127), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3521), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [185312] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3531), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7128), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3529), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [185358] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3535), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7129), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3533), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [185404] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3519), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7130), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3517), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [185450] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3527), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7131), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3525), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [185496] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3523), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7132), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3521), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [185542] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3519), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7133), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3517), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [185588] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3531), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7134), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3529), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [185634] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3535), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7135), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3533), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [185680] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3487), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(7136), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3485), 10,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_EQ2,
  [185726] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10173), 1,
      anon_sym_STAR,
    STATE(7197), 1,
      aux_sym_compound_type_repeat1,
    STATE(7137), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3468), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3466), 7,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [185776] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3515), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7138), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [185822] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7283), 1,
      anon_sym_COLON,
    STATE(7139), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7285), 13,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [185868] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10547), 1,
      anon_sym_LT2,
    ACTIONS(3505), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7140), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3503), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [185916] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3519), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7141), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3517), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [185962] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3562), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7142), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3560), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [186008] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3531), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7143), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3529), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [186054] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3535), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7144), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3533), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [186100] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7145), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3496), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [186146] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3523), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7146), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3521), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [186192] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3562), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7147), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3560), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [186238] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3551), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7148), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3549), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [186284] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3562), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7149), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3560), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [186330] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3551), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7150), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3549), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [186376] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10549), 1,
      anon_sym_STAR,
    ACTIONS(3427), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(7151), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3425), 7,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [186424] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3551), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7152), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3549), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [186470] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3515), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7153), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [186516] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3515), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7154), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [186562] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3523), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7155), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3521), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [186608] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10552), 1,
      anon_sym_LT2,
    ACTIONS(3505), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7156), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3503), 9,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [186656] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(8518), 1,
      anon_sym_new,
    ACTIONS(10554), 1,
      anon_sym_do,
    ACTIONS(10558), 1,
      anon_sym_static,
    ACTIONS(10560), 1,
      anon_sym_member,
    ACTIONS(10562), 1,
      anon_sym_abstract,
    ACTIONS(10564), 1,
      anon_sym_val,
    STATE(6995), 1,
      sym_function_or_value_defn,
    STATE(6997), 1,
      sym_additional_constr_defn,
    STATE(11240), 1,
      sym_access_modifier,
    ACTIONS(10556), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7157), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186724] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10213), 1,
      anon_sym_STAR,
    STATE(7098), 1,
      aux_sym_compound_type_repeat1,
    ACTIONS(3468), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7158), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3466), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [186774] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3511), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7159), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3509), 13,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
      anon_sym_or,
  [186820] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10243), 1,
      anon_sym_y,
    ACTIONS(10245), 1,
      anon_sym_uy,
    ACTIONS(10247), 1,
      anon_sym_s,
    ACTIONS(10249), 1,
      anon_sym_us,
    ACTIONS(10253), 1,
      aux_sym_uint32_token1,
    ACTIONS(10255), 1,
      anon_sym_n,
    ACTIONS(10257), 1,
      anon_sym_un,
    ACTIONS(10261), 1,
      aux_sym_uint64_token1,
    ACTIONS(10566), 1,
      anon_sym_l,
    ACTIONS(10568), 1,
      anon_sym_L,
    ACTIONS(10570), 1,
      anon_sym_lf,
    ACTIONS(10572), 1,
      anon_sym_LF,
    ACTIONS(3191), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(7160), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186888] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10574), 1,
      anon_sym_LT2,
    ACTIONS(3505), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7161), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3503), 9,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [186936] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8217), 1,
      anon_sym_let,
    ACTIONS(8219), 1,
      anon_sym_let_BANG,
    ACTIONS(8223), 1,
      anon_sym_new,
    ACTIONS(10464), 1,
      anon_sym_do,
    ACTIONS(10468), 1,
      anon_sym_static,
    ACTIONS(10470), 1,
      anon_sym_member,
    ACTIONS(10472), 1,
      anon_sym_abstract,
    ACTIONS(10474), 1,
      anon_sym_val,
    STATE(3814), 1,
      sym_additional_constr_defn,
    STATE(3820), 1,
      sym_function_or_value_defn,
    STATE(10931), 1,
      sym_access_modifier,
    ACTIONS(10466), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7162), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187004] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10576), 1,
      anon_sym_COLON_GT,
    STATE(7163), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3513), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [187052] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3515), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7164), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [187098] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10578), 1,
      anon_sym_COLON_GT,
    ACTIONS(3515), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7165), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [187146] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3515), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7166), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [187192] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7167), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3480), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_or,
      sym_identifier,
    ACTIONS(3478), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [187238] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3535), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7168), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3533), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [187284] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3551), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7169), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3549), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [187330] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8262), 1,
      anon_sym_let,
    ACTIONS(8264), 1,
      anon_sym_let_BANG,
    ACTIONS(8266), 1,
      anon_sym_new,
    ACTIONS(10437), 1,
      anon_sym_do,
    ACTIONS(10441), 1,
      anon_sym_static,
    ACTIONS(10443), 1,
      anon_sym_member,
    ACTIONS(10445), 1,
      anon_sym_abstract,
    ACTIONS(10447), 1,
      anon_sym_val,
    STATE(6868), 1,
      sym_additional_constr_defn,
    STATE(6941), 1,
      sym_function_or_value_defn,
    STATE(11942), 1,
      sym_access_modifier,
    ACTIONS(10439), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7170), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187398] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3539), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7171), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3537), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [187444] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7742), 1,
      anon_sym_let,
    ACTIONS(7744), 1,
      anon_sym_let_BANG,
    ACTIONS(7746), 1,
      anon_sym_new,
    ACTIONS(10580), 1,
      anon_sym_do,
    ACTIONS(10584), 1,
      anon_sym_static,
    ACTIONS(10586), 1,
      anon_sym_member,
    ACTIONS(10588), 1,
      anon_sym_abstract,
    ACTIONS(10590), 1,
      anon_sym_val,
    STATE(6484), 1,
      sym_additional_constr_defn,
    STATE(6520), 1,
      sym_function_or_value_defn,
    STATE(11912), 1,
      sym_access_modifier,
    ACTIONS(10582), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7172), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187512] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3562), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7173), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3560), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [187558] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3543), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7174), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3541), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [187604] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3480), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7175), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3478), 13,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
      anon_sym_or,
  [187650] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3547), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7176), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3545), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [187696] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10592), 1,
      anon_sym_STAR,
    ACTIONS(3427), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7177), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3425), 9,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [187744] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3527), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7178), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3525), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [187790] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7179), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3511), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_or,
      sym_identifier,
    ACTIONS(3509), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [187836] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8333), 1,
      anon_sym_let,
    ACTIONS(8335), 1,
      anon_sym_let_BANG,
    ACTIONS(8337), 1,
      anon_sym_new,
    ACTIONS(10423), 1,
      anon_sym_do,
    ACTIONS(10429), 1,
      anon_sym_static,
    ACTIONS(10431), 1,
      anon_sym_member,
    ACTIONS(10433), 1,
      anon_sym_abstract,
    ACTIONS(10435), 1,
      anon_sym_val,
    STATE(6658), 1,
      sym_function_or_value_defn,
    STATE(6717), 1,
      sym_additional_constr_defn,
    STATE(11932), 1,
      sym_access_modifier,
    ACTIONS(10427), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7180), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187904] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10595), 1,
      anon_sym_COLON_GT,
    ACTIONS(3515), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7181), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [187952] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3519), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7182), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3517), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [187998] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3527), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7183), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3525), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [188044] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3547), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7184), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3545), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [188090] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3547), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7185), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3545), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [188136] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3543), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7186), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3541), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [188182] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10597), 1,
      anon_sym_or,
    STATE(7097), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(3476), 3,
      anon_sym_COLON,
      anon_sym_with,
      sym_identifier,
    STATE(7187), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3474), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [188232] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3539), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7188), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3537), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [188278] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3539), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7189), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3537), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [188324] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3547), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7190), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3545), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [188370] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3539), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7191), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3537), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [188416] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3543), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7192), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3541), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [188462] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10292), 1,
      anon_sym_STAR,
    STATE(7177), 1,
      aux_sym_compound_type_repeat1,
    ACTIONS(3468), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7193), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3466), 9,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [188512] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7279), 1,
      anon_sym_COLON,
    STATE(7194), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7281), 13,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [188558] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3543), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7195), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3541), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [188604] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3487), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7196), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3485), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [188650] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10599), 1,
      anon_sym_STAR,
    ACTIONS(3427), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    STATE(7197), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3425), 7,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [188698] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3547), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7198), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3545), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [188744] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3539), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(7199), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3537), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [188790] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3543), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7200), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3541), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [188836] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7201), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3498), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(3496), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [188882] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7908), 1,
      anon_sym_COLON,
    STATE(7202), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7910), 13,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [188928] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3531), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(7203), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3529), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [188974] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10610), 1,
      anon_sym_DQUOTE,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    STATE(7208), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7204), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189031] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10620), 1,
      anon_sym_DQUOTE,
    STATE(7209), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7205), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189088] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3498), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(7206), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [189133] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3527), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7207), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3525), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [189178] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10622), 1,
      anon_sym_DQUOTE,
    STATE(7336), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7208), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189235] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10624), 1,
      anon_sym_DQUOTE,
    STATE(7336), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7209), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189292] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10626), 1,
      anon_sym_and,
    STATE(7298), 1,
      aux_sym__function_or_value_defns_repeat1,
    STATE(7210), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6156), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [189339] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10628), 1,
      anon_sym_DQUOTE,
    STATE(7336), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7211), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189396] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3551), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7212), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3549), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [189441] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10630), 1,
      anon_sym_DQUOTE,
    STATE(7336), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7213), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189498] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3547), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7214), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3545), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [189543] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3539), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7215), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3537), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [189588] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7216), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3531), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3529), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [189633] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10632), 1,
      anon_sym_COLON_GT,
    ACTIONS(3515), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(7217), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [189680] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7218), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3535), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3533), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [189725] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3543), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7219), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3541), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [189770] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3543), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7220), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3541), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [189815] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3539), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7221), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3537), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [189860] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10634), 1,
      anon_sym_DQUOTE,
    STATE(7336), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7222), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189917] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10636), 1,
      anon_sym_DQUOTE,
    STATE(7222), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7223), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189974] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3547), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7224), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3545), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [190019] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10638), 1,
      anon_sym_DQUOTE,
    STATE(7211), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7225), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190076] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7226), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3527), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3525), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [190121] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3511), 4,
      anon_sym_COLON,
      anon_sym_with,
      anon_sym_or,
      sym_identifier,
    STATE(7227), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3509), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [190166] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3535), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7228), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3533), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [190211] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10640), 1,
      anon_sym_DQUOTE,
    STATE(7213), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7229), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190268] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3419), 1,
      anon_sym_with,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    ACTIONS(3417), 4,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(7230), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190329] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10650), 1,
      anon_sym_LT2,
    ACTIONS(3505), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7231), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3503), 9,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [190376] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3515), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7232), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [190421] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3531), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7233), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3529), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [190466] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10652), 1,
      anon_sym_DQUOTE,
    STATE(7236), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7234), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190523] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10654), 1,
      anon_sym_DQUOTE,
    STATE(7259), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7235), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190580] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10656), 1,
      anon_sym_DQUOTE,
    STATE(7336), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7236), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190637] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10658), 1,
      anon_sym_DQUOTE,
    STATE(7336), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7237), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190694] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10660), 1,
      anon_sym_DQUOTE,
    STATE(7237), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7238), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190751] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3519), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7239), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3517), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [190796] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3523), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7240), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3521), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [190841] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10662), 1,
      anon_sym_and,
    STATE(7283), 1,
      aux_sym__function_or_value_defns_repeat1,
    STATE(7241), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6190), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [190888] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10664), 1,
      anon_sym_DQUOTE,
    STATE(7336), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7242), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190945] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7243), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3519), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3517), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [190990] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10666), 1,
      anon_sym_DQUOTE,
    STATE(7260), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7244), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191047] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10668), 1,
      anon_sym_DQUOTE,
    STATE(7336), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7245), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191104] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9416), 3,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
    STATE(7246), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9414), 10,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [191149] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3515), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7247), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [191194] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10361), 1,
      anon_sym_STAR,
    STATE(7279), 1,
      aux_sym_compound_type_repeat1,
    ACTIONS(3468), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(7248), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3466), 7,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [191243] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3531), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7249), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3529), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [191288] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7250), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3513), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [191333] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10670), 1,
      anon_sym_LT2,
    ACTIONS(3505), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7251), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3503), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [191380] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7252), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3539), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3537), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [191425] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7253), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3539), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(3537), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [191470] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10672), 1,
      anon_sym_DQUOTE,
    STATE(7336), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7254), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191527] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10674), 1,
      anon_sym_DQUOTE,
    STATE(7254), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7255), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191584] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7256), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3543), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3541), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [191629] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9388), 3,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
    STATE(7257), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9386), 10,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [191674] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10676), 1,
      anon_sym_DQUOTE,
    STATE(7336), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7258), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191731] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10678), 1,
      anon_sym_DQUOTE,
    STATE(7336), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7259), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191788] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10680), 1,
      anon_sym_DQUOTE,
    STATE(7336), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7260), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191845] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10682), 1,
      anon_sym_LT2,
    STATE(7261), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3505), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3503), 7,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [191892] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7262), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3547), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3545), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [191937] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3551), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7263), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3549), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [191982] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7264), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3539), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3537), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [192027] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10684), 1,
      anon_sym_DQUOTE,
    STATE(7245), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7265), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192084] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3562), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7266), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3560), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [192129] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7267), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3543), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3541), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [192174] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3562), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7268), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3560), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [192219] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10686), 1,
      anon_sym_DQUOTE,
    STATE(7242), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7269), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192276] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7270), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3547), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3545), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [192321] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10688), 1,
      anon_sym_DQUOTE,
    STATE(7273), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7271), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192378] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7272), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3547), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(3545), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [192423] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10690), 1,
      anon_sym_DQUOTE,
    STATE(7336), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7273), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192480] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10692), 1,
      anon_sym_DQUOTE,
    STATE(7277), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7274), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192537] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10694), 1,
      anon_sym_DQUOTE,
    STATE(7258), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7275), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192594] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3498), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7276), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [192639] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10696), 1,
      anon_sym_DQUOTE,
    STATE(7336), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7277), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192696] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10698), 1,
      anon_sym_DQUOTE,
    STATE(7292), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7278), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192753] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10700), 1,
      anon_sym_STAR,
    ACTIONS(3427), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(7279), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3425), 7,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [192800] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10703), 1,
      anon_sym_DQUOTE,
    STATE(7336), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7280), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192857] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7281), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3523), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3521), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [192902] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10705), 1,
      anon_sym_DQUOTE,
    STATE(7288), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7282), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192959] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10662), 1,
      anon_sym_and,
    STATE(7299), 1,
      aux_sym__function_or_value_defns_repeat1,
    STATE(7283), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6156), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [193006] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10707), 1,
      anon_sym_DQUOTE,
    STATE(7336), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7284), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193063] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10709), 1,
      anon_sym_DQUOTE,
    STATE(7280), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7285), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193120] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7286), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3519), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3517), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [193165] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10597), 1,
      anon_sym_or,
    STATE(7187), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(3498), 2,
      anon_sym_with,
      sym_identifier,
    STATE(7287), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [193214] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10711), 1,
      anon_sym_DQUOTE,
    STATE(7336), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7288), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193271] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7289), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3513), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [193316] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7290), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3562), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3560), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [193361] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10626), 1,
      anon_sym_and,
    STATE(7210), 1,
      aux_sym__function_or_value_defns_repeat1,
    STATE(7291), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6190), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [193408] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10713), 1,
      anon_sym_DQUOTE,
    STATE(7336), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7292), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193465] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3519), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7293), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3517), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [193510] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7294), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3551), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3549), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [193555] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10715), 1,
      anon_sym_DQUOTE,
    STATE(7284), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7295), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193612] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10717), 1,
      anon_sym_DQUOTE,
    STATE(7336), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7296), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193669] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3535), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7297), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3533), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [193714] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10719), 1,
      anon_sym_and,
    STATE(7298), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__function_or_value_defns_repeat1,
    ACTIONS(6115), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [193759] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10722), 1,
      anon_sym_and,
    STATE(7299), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__function_or_value_defns_repeat1,
    ACTIONS(6115), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [193804] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7300), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3515), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(3513), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [193849] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10725), 1,
      anon_sym_DQUOTE,
    STATE(7306), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7301), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193906] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10727), 1,
      anon_sym_DQUOTE,
    STATE(7336), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7302), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193963] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9362), 3,
      anon_sym_LBRACK_LT,
      anon_sym_let_BANG,
      aux_sym_access_modifier_token1,
    STATE(7303), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9360), 10,
      anon_sym_do,
      anon_sym_let,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [194008] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10729), 1,
      anon_sym_DQUOTE,
    STATE(7336), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7304), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194065] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10731), 1,
      anon_sym_DQUOTE,
    STATE(7304), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7305), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194122] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10733), 1,
      anon_sym_DQUOTE,
    STATE(7336), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7306), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194179] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10735), 1,
      anon_sym_LT2,
    STATE(7307), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3505), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(3503), 7,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [194226] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3407), 1,
      anon_sym_with,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    ACTIONS(3403), 4,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(7308), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194287] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10737), 1,
      anon_sym_DQUOTE,
    STATE(7296), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7309), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194344] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10739), 1,
      anon_sym_DQUOTE,
    STATE(7312), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7310), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194401] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10741), 1,
      anon_sym_DQUOTE,
    STATE(7302), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7311), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194458] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10743), 1,
      anon_sym_DQUOTE,
    STATE(7336), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7312), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194515] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7313), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3543), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(3541), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [194560] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7314), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3523), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3521), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [194605] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7315), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3523), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(3521), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [194650] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7316), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3551), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(3549), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [194695] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7317), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3562), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(3560), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [194740] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7318), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3527), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3525), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [194785] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7319), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3519), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(3517), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [194830] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10745), 1,
      anon_sym_DQUOTE,
    STATE(7321), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7320), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194887] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10747), 1,
      anon_sym_DQUOTE,
    STATE(7336), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7321), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194944] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7322), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3531), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3529), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [194989] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3480), 4,
      anon_sym_COLON,
      anon_sym_with,
      anon_sym_or,
      sym_identifier,
    STATE(7323), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3478), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [195034] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3487), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7324), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3485), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [195079] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7325), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3535), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3533), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [195124] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7326), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3535), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(3533), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [195169] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7327), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3531), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(3529), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [195214] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10749), 1,
      anon_sym_DQUOTE,
    STATE(7336), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7328), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195271] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3431), 1,
      anon_sym_with,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    ACTIONS(3429), 4,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(7329), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195332] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7330), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3562), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3560), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [195377] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3427), 1,
      anon_sym_with,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    ACTIONS(3425), 4,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(7331), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195438] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3523), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7332), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3521), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [195483] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7333), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3551), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3549), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [195528] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10751), 1,
      anon_sym_DQUOTE,
    STATE(7336), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7334), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195585] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7335), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3527), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(3525), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [195630] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10759), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10762), 1,
      anon_sym_LBRACE2,
    ACTIONS(10765), 1,
      anon_sym_DQUOTE,
    ACTIONS(10767), 1,
      sym__inside_string_marker,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10753), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10756), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7336), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_format_string_repeat1,
  [195685] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3527), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(7337), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3525), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [195730] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10770), 1,
      anon_sym_DQUOTE,
    STATE(7328), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7338), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195787] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10772), 1,
      anon_sym_LT2,
    STATE(7339), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3505), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(3503), 7,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [195834] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10606), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(10608), 1,
      anon_sym_LBRACE2,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10618), 1,
      sym__inside_string_marker,
    ACTIONS(10774), 1,
      anon_sym_DQUOTE,
    STATE(7334), 1,
      aux_sym_format_string_repeat1,
    STATE(8155), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10602), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(8144), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(10604), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7340), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195891] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10782), 1,
      anon_sym_DQUOTE,
    ACTIONS(10784), 1,
      anon_sym_DQUOTEB,
    STATE(7352), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7341), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195945] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10786), 1,
      anon_sym_DQUOTE,
    ACTIONS(10788), 1,
      anon_sym_DQUOTEB,
    STATE(7352), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7342), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195999] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10790), 1,
      anon_sym_DQUOTE,
    ACTIONS(10792), 1,
      anon_sym_DQUOTEB,
    STATE(7489), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7343), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196053] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7344), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3698), 12,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [196095] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7480), 1,
      anon_sym_let,
    ACTIONS(7482), 1,
      anon_sym_let_BANG,
    ACTIONS(10794), 1,
      anon_sym_do,
    ACTIONS(10796), 1,
      anon_sym_member,
    ACTIONS(10798), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6322), 1,
      sym_value_declaration,
    STATE(6345), 1,
      sym_function_or_value_defn,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6391), 1,
      sym_do,
    STATE(8770), 1,
      sym_attributes,
    STATE(7345), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196159] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10800), 1,
      anon_sym_DQUOTE,
    ACTIONS(10802), 1,
      anon_sym_DQUOTEB,
    STATE(7352), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7346), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196213] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3604), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10804), 1,
      aux_sym_float_token1,
    STATE(7347), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3602), 10,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_f,
      aux_sym_decimal_token1,
  [196259] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7348), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3698), 12,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [196301] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10806), 1,
      anon_sym_DQUOTE,
    ACTIONS(10808), 1,
      anon_sym_DQUOTEB,
    STATE(7346), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7349), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196355] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8333), 1,
      anon_sym_let,
    ACTIONS(8335), 1,
      anon_sym_let_BANG,
    ACTIONS(10435), 1,
      anon_sym_val,
    ACTIONS(10810), 1,
      anon_sym_do,
    ACTIONS(10812), 1,
      anon_sym_member,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6621), 1,
      sym_do,
    STATE(6652), 1,
      sym_function_or_value_defn,
    STATE(6717), 1,
      sym_value_declaration,
    STATE(8616), 1,
      sym_attributes,
    STATE(7350), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196419] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8197), 1,
      anon_sym_COLON,
    STATE(7351), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8199), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [196463] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10823), 1,
      anon_sym_DQUOTE,
    ACTIONS(10825), 1,
      anon_sym_DQUOTEB,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10814), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10820), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10817), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7352), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__string_literal_repeat1,
  [196515] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(10827), 1,
      anon_sym_do,
    ACTIONS(10829), 1,
      anon_sym_member,
    ACTIONS(10831), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6961), 1,
      sym_do,
    STATE(7058), 1,
      sym_function_or_value_defn,
    STATE(7088), 1,
      sym_value_declaration,
    STATE(8735), 1,
      sym_attributes,
    STATE(7353), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196579] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8359), 1,
      anon_sym_COLON,
    STATE(7354), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8361), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [196623] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10833), 1,
      anon_sym_DQUOTE,
    ACTIONS(10835), 1,
      anon_sym_DQUOTEB,
    STATE(7352), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7355), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196677] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10837), 1,
      anon_sym_DQUOTE,
    ACTIONS(10839), 1,
      anon_sym_DQUOTEB,
    STATE(7355), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7356), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196731] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10841), 1,
      anon_sym_COMMA,
    STATE(7357), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6122), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [196775] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10843), 1,
      anon_sym_COMMA,
    STATE(7358), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6122), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [196819] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10845), 1,
      anon_sym_DQUOTE,
    ACTIONS(10847), 1,
      anon_sym_DQUOTEB,
    STATE(7363), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7359), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196873] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(7360), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8402), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [196917] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3523), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(7361), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3521), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [196961] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10849), 1,
      anon_sym_DQUOTE,
    ACTIONS(10851), 1,
      anon_sym_DQUOTEB,
    STATE(7352), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7362), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197015] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10853), 1,
      anon_sym_DQUOTE,
    ACTIONS(10855), 1,
      anon_sym_DQUOTEB,
    STATE(7352), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7363), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197069] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4104), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7364), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4102), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [197113] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3193), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7365), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3191), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [197157] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8383), 1,
      anon_sym_COLON,
    STATE(7366), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8385), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [197201] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10857), 1,
      anon_sym_DQUOTE,
    ACTIONS(10859), 1,
      anon_sym_DQUOTEB,
    STATE(7362), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7367), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197255] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10861), 1,
      anon_sym_DQUOTE,
    ACTIONS(10863), 1,
      anon_sym_DQUOTEB,
    STATE(7380), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7368), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197309] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10865), 1,
      anon_sym_DQUOTE,
    ACTIONS(10867), 1,
      anon_sym_DQUOTEB,
    STATE(7376), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7369), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197363] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3927), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7370), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3925), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [197407] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3946), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7371), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3944), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [197451] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8355), 1,
      anon_sym_COLON,
    STATE(7372), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8357), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [197495] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10869), 1,
      anon_sym_DQUOTE,
    ACTIONS(10871), 1,
      anon_sym_DQUOTEB,
    STATE(7352), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7373), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197549] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8333), 1,
      anon_sym_let,
    ACTIONS(8335), 1,
      anon_sym_let_BANG,
    ACTIONS(10873), 1,
      anon_sym_do,
    ACTIONS(10875), 1,
      anon_sym_member,
    ACTIONS(10877), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6563), 1,
      sym_value_declaration,
    STATE(6582), 1,
      sym_function_or_value_defn,
    STATE(6621), 1,
      sym_do,
    STATE(8616), 1,
      sym_attributes,
    STATE(7374), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197613] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10879), 1,
      anon_sym_DQUOTE,
    ACTIONS(10881), 1,
      anon_sym_DQUOTEB,
    STATE(7373), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7375), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197667] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10883), 1,
      anon_sym_DQUOTE,
    ACTIONS(10885), 1,
      anon_sym_DQUOTEB,
    STATE(7352), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7376), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197721] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7377), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6426), 12,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [197763] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8251), 1,
      anon_sym_COLON,
    STATE(7378), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8253), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [197807] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10887), 1,
      anon_sym_with,
    STATE(7379), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6168), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [197851] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10889), 1,
      anon_sym_DQUOTE,
    ACTIONS(10891), 1,
      anon_sym_DQUOTEB,
    STATE(7352), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7380), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197905] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10893), 1,
      anon_sym_do,
    ACTIONS(10895), 1,
      anon_sym_let,
    ACTIONS(10897), 1,
      anon_sym_let_BANG,
    ACTIONS(10899), 1,
      anon_sym_member,
    ACTIONS(10901), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7539), 1,
      sym_do,
    STATE(7585), 1,
      sym_value_declaration,
    STATE(7604), 1,
      sym_function_or_value_defn,
    STATE(8762), 1,
      sym_attributes,
    STATE(7381), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197969] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3753), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10903), 1,
      sym_int,
    STATE(7382), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3751), 10,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_f,
      aux_sym_decimal_token1,
  [198015] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3498), 3,
      anon_sym_COLON,
      anon_sym_with,
      sym_identifier,
    STATE(7383), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [198059] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(10564), 1,
      anon_sym_val,
    ACTIONS(10905), 1,
      anon_sym_do,
    ACTIONS(10907), 1,
      anon_sym_member,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6961), 1,
      sym_do,
    STATE(6997), 1,
      sym_value_declaration,
    STATE(6998), 1,
      sym_function_or_value_defn,
    STATE(8735), 1,
      sym_attributes,
    STATE(7384), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198123] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7385), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6426), 12,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [198165] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8209), 1,
      anon_sym_COLON,
    STATE(7386), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8211), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [198209] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8205), 1,
      anon_sym_COLON,
    STATE(7387), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8207), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [198253] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8201), 1,
      anon_sym_COLON,
    STATE(7388), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8203), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [198297] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6862), 1,
      anon_sym_let,
    ACTIONS(6864), 1,
      anon_sym_let_BANG,
    ACTIONS(10519), 1,
      anon_sym_val,
    ACTIONS(10909), 1,
      anon_sym_do,
    ACTIONS(10911), 1,
      anon_sym_member,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6756), 1,
      sym_function_or_value_defn,
    STATE(6777), 1,
      sym_do,
    STATE(6936), 1,
      sym_value_declaration,
    STATE(8625), 1,
      sym_attributes,
    STATE(7389), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198361] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10913), 1,
      anon_sym_DQUOTE,
    ACTIONS(10915), 1,
      anon_sym_DQUOTEB,
    STATE(7398), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7390), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198415] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10917), 1,
      anon_sym_DQUOTE,
    ACTIONS(10919), 1,
      anon_sym_DQUOTEB,
    STATE(7352), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7391), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198469] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3519), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(7392), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3517), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [198513] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10921), 1,
      anon_sym_DQUOTE,
    ACTIONS(10923), 1,
      anon_sym_DQUOTEB,
    STATE(7395), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7393), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198567] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10925), 1,
      anon_sym_DQUOTE,
    ACTIONS(10927), 1,
      anon_sym_DQUOTEB,
    STATE(7352), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7394), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198621] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10929), 1,
      anon_sym_DQUOTE,
    ACTIONS(10931), 1,
      anon_sym_DQUOTEB,
    STATE(7352), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7395), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198675] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10933), 1,
      anon_sym_DOT,
    STATE(7464), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3494), 2,
      anon_sym_with,
      sym_identifier,
    STATE(7396), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [198723] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10935), 1,
      anon_sym_with,
    STATE(7397), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6272), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [198767] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10937), 1,
      anon_sym_DQUOTE,
    ACTIONS(10939), 1,
      anon_sym_DQUOTEB,
    STATE(7352), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7398), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198821] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10941), 1,
      anon_sym_DQUOTE,
    ACTIONS(10943), 1,
      anon_sym_DQUOTEB,
    STATE(7394), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7399), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198875] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8373), 1,
      anon_sym_COLON,
    STATE(7400), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8375), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [198919] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4130), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7401), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4128), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [198963] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8369), 1,
      anon_sym_COLON,
    STATE(7402), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8371), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [199007] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10945), 1,
      anon_sym_DQUOTE,
    ACTIONS(10947), 1,
      anon_sym_DQUOTEB,
    STATE(7444), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7403), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199061] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10949), 1,
      anon_sym_DQUOTE,
    ACTIONS(10951), 1,
      anon_sym_DQUOTEB,
    STATE(7352), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7404), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199115] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3527), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(7405), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3525), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [199159] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10953), 1,
      anon_sym_DQUOTE,
    ACTIONS(10955), 1,
      anon_sym_DQUOTEB,
    STATE(7391), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7406), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199213] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3972), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7407), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3970), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [199257] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8245), 1,
      anon_sym_COLON,
    STATE(7408), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8247), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [199301] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7409), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6300), 12,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [199343] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7480), 1,
      anon_sym_let,
    ACTIONS(7482), 1,
      anon_sym_let_BANG,
    ACTIONS(10537), 1,
      anon_sym_val,
    ACTIONS(10957), 1,
      anon_sym_do,
    ACTIONS(10959), 1,
      anon_sym_member,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6320), 1,
      sym_value_declaration,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6388), 1,
      sym_function_or_value_defn,
    STATE(6391), 1,
      sym_do,
    STATE(8770), 1,
      sym_attributes,
    STATE(7410), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199407] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10961), 1,
      anon_sym_DQUOTE,
    ACTIONS(10963), 1,
      anon_sym_DQUOTEB,
    STATE(7404), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7411), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199461] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3996), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7412), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3994), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [199505] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4064), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7413), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4062), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [199549] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4003), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7414), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4001), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [199593] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3845), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7415), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3843), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [199637] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4018), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7416), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4016), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [199681] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3531), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(7417), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3529), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [199725] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6862), 1,
      anon_sym_let,
    ACTIONS(6864), 1,
      anon_sym_let_BANG,
    ACTIONS(10965), 1,
      anon_sym_do,
    ACTIONS(10967), 1,
      anon_sym_member,
    ACTIONS(10969), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6755), 1,
      sym_function_or_value_defn,
    STATE(6777), 1,
      sym_do,
    STATE(6780), 1,
      sym_value_declaration,
    STATE(8625), 1,
      sym_attributes,
    STATE(7418), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199789] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8241), 1,
      anon_sym_COLON,
    STATE(7419), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8243), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [199833] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3885), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7420), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3883), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [199877] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10971), 1,
      anon_sym_DQUOTE,
    ACTIONS(10973), 1,
      anon_sym_DQUOTEB,
    STATE(7352), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7421), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199931] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7422), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6316), 12,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [199973] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7423), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3698), 12,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [200015] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3535), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(7424), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3533), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [200059] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4054), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7425), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4052), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [200103] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10975), 1,
      anon_sym_DQUOTE,
    ACTIONS(10977), 1,
      anon_sym_DQUOTEB,
    STATE(7421), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7426), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200157] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7427), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6300), 12,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [200199] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10979), 1,
      anon_sym_COMMA,
    STATE(7428), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6122), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [200243] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10981), 1,
      anon_sym_DQUOTE,
    ACTIONS(10983), 1,
      anon_sym_DQUOTEB,
    STATE(7432), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7429), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200297] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10985), 1,
      anon_sym_with,
    STATE(7430), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6168), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [200341] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8432), 1,
      anon_sym_COLON,
    STATE(7431), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8434), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [200385] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10987), 1,
      anon_sym_DQUOTE,
    ACTIONS(10989), 1,
      anon_sym_DQUOTEB,
    STATE(7352), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7432), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200439] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10991), 1,
      anon_sym_COMMA,
    STATE(7433), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(237), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [200483] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4082), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7434), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4080), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [200527] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10993), 1,
      anon_sym_COMMA,
    STATE(7435), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6122), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [200571] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8288), 1,
      anon_sym_COLON,
    STATE(7436), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8290), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [200615] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8284), 1,
      anon_sym_COLON,
    STATE(7437), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8286), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [200659] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7989), 1,
      anon_sym_COLON,
    ACTIONS(10995), 1,
      anon_sym_LT2,
    STATE(7438), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7991), 10,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
  [200705] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4093), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7439), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4091), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [200749] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10997), 1,
      anon_sym_DQUOTE,
    ACTIONS(10999), 1,
      anon_sym_DQUOTEB,
    STATE(7352), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7440), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200803] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11001), 1,
      anon_sym_DQUOTE,
    ACTIONS(11003), 1,
      anon_sym_DQUOTEB,
    STATE(7352), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7441), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200857] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3935), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7442), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3933), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [200901] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3976), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7443), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3974), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [200945] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11005), 1,
      anon_sym_DQUOTE,
    ACTIONS(11007), 1,
      anon_sym_DQUOTEB,
    STATE(7352), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7444), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200999] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3950), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7445), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3948), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [201043] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3547), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(7446), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3545), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [201087] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7989), 1,
      anon_sym_COLON,
    STATE(7447), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7991), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [201131] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3543), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(7448), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3541), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [201175] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3539), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(7449), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3537), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [201219] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8377), 1,
      anon_sym_COLON,
    ACTIONS(11009), 1,
      anon_sym_as,
    STATE(7450), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8379), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [201265] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3954), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7451), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3952), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [201309] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11011), 1,
      anon_sym_COMMA,
    STATE(7452), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(237), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [201353] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4108), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7453), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4106), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [201397] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11013), 1,
      anon_sym_COMMA,
    STATE(7454), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(237), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [201441] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4112), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7455), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4110), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [201485] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4118), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7456), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4116), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [201529] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11015), 1,
      anon_sym_DQUOTE,
    ACTIONS(11017), 1,
      anon_sym_DQUOTEB,
    STATE(7441), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7457), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201583] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4122), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7458), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4120), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [201627] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11019), 1,
      anon_sym_DQUOTE,
    ACTIONS(11021), 1,
      anon_sym_DQUOTEB,
    STATE(7440), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7459), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201681] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11023), 1,
      anon_sym_DQUOTE,
    ACTIONS(11025), 1,
      anon_sym_DQUOTEB,
    STATE(7476), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7460), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201735] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4126), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7461), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4124), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [201779] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11027), 1,
      anon_sym_with,
    STATE(7462), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6272), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [201823] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11029), 1,
      anon_sym_COMMA,
    STATE(7463), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6182), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [201867] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10933), 1,
      anon_sym_DOT,
    STATE(7485), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3451), 2,
      anon_sym_with,
      sym_identifier,
    STATE(7464), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3449), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [201915] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8262), 1,
      anon_sym_let,
    ACTIONS(8264), 1,
      anon_sym_let_BANG,
    ACTIONS(11031), 1,
      anon_sym_do,
    ACTIONS(11033), 1,
      anon_sym_member,
    ACTIONS(11035), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6907), 1,
      sym_value_declaration,
    STATE(6911), 1,
      sym_function_or_value_defn,
    STATE(6928), 1,
      sym_do,
    STATE(8789), 1,
      sym_attributes,
    STATE(7465), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201979] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11037), 1,
      anon_sym_COMMA,
    STATE(7466), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6182), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [202023] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11039), 1,
      anon_sym_DQUOTE,
    ACTIONS(11041), 1,
      anon_sym_DQUOTEB,
    STATE(7472), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7467), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202077] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4232), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7468), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4230), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [202121] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11043), 1,
      anon_sym_COMMA,
    STATE(7469), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6132), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [202165] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11045), 1,
      anon_sym_DQUOTE,
    ACTIONS(11047), 1,
      anon_sym_DQUOTEB,
    STATE(7341), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7470), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202219] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3494), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11049), 1,
      anon_sym_DOT,
    STATE(7499), 1,
      aux_sym_long_identifier_repeat1,
    STATE(7471), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 9,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_LT2,
  [202267] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11051), 1,
      anon_sym_DQUOTE,
    ACTIONS(11053), 1,
      anon_sym_DQUOTEB,
    STATE(7352), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7472), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202321] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11055), 1,
      anon_sym_COMMA,
    STATE(7473), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6132), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [202365] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3562), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(7474), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3560), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [202409] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3962), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7475), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3960), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [202453] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11057), 1,
      anon_sym_DQUOTE,
    ACTIONS(11059), 1,
      anon_sym_DQUOTEB,
    STATE(7352), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7476), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202507] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3958), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7477), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3956), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [202551] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3551), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(7478), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3549), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [202595] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7742), 1,
      anon_sym_let,
    ACTIONS(7744), 1,
      anon_sym_let_BANG,
    ACTIONS(10590), 1,
      anon_sym_val,
    ACTIONS(11061), 1,
      anon_sym_do,
    ACTIONS(11063), 1,
      anon_sym_member,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6465), 1,
      sym_do,
    STATE(6484), 1,
      sym_value_declaration,
    STATE(6513), 1,
      sym_function_or_value_defn,
    STATE(8635), 1,
      sym_attributes,
    STATE(7479), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202659] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10893), 1,
      anon_sym_do,
    ACTIONS(10895), 1,
      anon_sym_let,
    ACTIONS(10897), 1,
      anon_sym_let_BANG,
    ACTIONS(11065), 1,
      anon_sym_member,
    ACTIONS(11067), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7539), 1,
      sym_do,
    STATE(7551), 1,
      sym_value_declaration,
    STATE(7604), 1,
      sym_function_or_value_defn,
    STATE(8762), 1,
      sym_attributes,
    STATE(7480), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202723] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7481), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6316), 12,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [202765] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11069), 1,
      anon_sym_DQUOTE,
    ACTIONS(11071), 1,
      anon_sym_DQUOTEB,
    STATE(7342), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7482), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202819] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8410), 1,
      anon_sym_let,
    ACTIONS(8412), 1,
      anon_sym_let_BANG,
    ACTIONS(11073), 1,
      anon_sym_do,
    ACTIONS(11075), 1,
      anon_sym_member,
    ACTIONS(11077), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6562), 1,
      sym_function_or_value_defn,
    STATE(6601), 1,
      sym_value_declaration,
    STATE(6723), 1,
      sym_do,
    STATE(8675), 1,
      sym_attributes,
    STATE(7483), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202883] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11079), 1,
      anon_sym_DQUOTE,
    ACTIONS(11081), 1,
      anon_sym_DQUOTEB,
    STATE(7352), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7484), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202937] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11083), 1,
      anon_sym_DOT,
    ACTIONS(3487), 2,
      anon_sym_with,
      sym_identifier,
    STATE(7485), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3485), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [202983] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8262), 1,
      anon_sym_let,
    ACTIONS(8264), 1,
      anon_sym_let_BANG,
    ACTIONS(10447), 1,
      anon_sym_val,
    ACTIONS(11086), 1,
      anon_sym_do,
    ACTIONS(11088), 1,
      anon_sym_member,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6845), 1,
      sym_function_or_value_defn,
    STATE(6868), 1,
      sym_value_declaration,
    STATE(6928), 1,
      sym_do,
    STATE(8789), 1,
      sym_attributes,
    STATE(7486), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203047] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11090), 1,
      anon_sym_DQUOTE,
    ACTIONS(11092), 1,
      anon_sym_DQUOTEB,
    STATE(7352), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7487), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203101] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8217), 1,
      anon_sym_let,
    ACTIONS(8219), 1,
      anon_sym_let_BANG,
    ACTIONS(11094), 1,
      anon_sym_do,
    ACTIONS(11096), 1,
      anon_sym_member,
    ACTIONS(11098), 1,
      anon_sym_val,
    STATE(3810), 1,
      sym_value_declaration,
    STATE(3843), 1,
      sym_function_or_value_defn,
    STATE(3847), 1,
      sym_do,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(8753), 1,
      sym_attributes,
    STATE(7488), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203165] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11100), 1,
      anon_sym_DQUOTE,
    ACTIONS(11102), 1,
      anon_sym_DQUOTEB,
    STATE(7352), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7489), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203219] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11104), 1,
      anon_sym_DQUOTE,
    ACTIONS(11106), 1,
      anon_sym_DQUOTEB,
    STATE(7487), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7490), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203273] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4170), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7491), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4168), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [203317] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11108), 1,
      anon_sym_DQUOTE,
    ACTIONS(11110), 1,
      anon_sym_DQUOTEB,
    STATE(7484), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7492), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203371] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11112), 1,
      anon_sym_COMMA,
    STATE(7493), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6132), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [203415] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11114), 1,
      anon_sym_DQUOTE,
    ACTIONS(11116), 1,
      anon_sym_DQUOTEB,
    STATE(7352), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7494), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203469] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3487), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11118), 1,
      anon_sym_DOT,
    STATE(7495), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3485), 9,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_LT2,
  [203515] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7742), 1,
      anon_sym_let,
    ACTIONS(7744), 1,
      anon_sym_let_BANG,
    ACTIONS(11121), 1,
      anon_sym_do,
    ACTIONS(11123), 1,
      anon_sym_member,
    ACTIONS(11125), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6465), 1,
      sym_do,
    STATE(6487), 1,
      sym_value_declaration,
    STATE(6508), 1,
      sym_function_or_value_defn,
    STATE(8635), 1,
      sym_attributes,
    STATE(7496), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203579] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11127), 1,
      anon_sym_DQUOTE,
    ACTIONS(11129), 1,
      anon_sym_DQUOTEB,
    STATE(7494), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7497), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203633] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11131), 1,
      anon_sym_do,
    ACTIONS(11133), 1,
      anon_sym_let,
    ACTIONS(11135), 1,
      anon_sym_let_BANG,
    ACTIONS(11137), 1,
      anon_sym_member,
    ACTIONS(11139), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7563), 1,
      sym_function_or_value_defn,
    STATE(7583), 1,
      sym_do,
    STATE(7627), 1,
      sym_value_declaration,
    STATE(8773), 1,
      sym_attributes,
    STATE(7498), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203697] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3451), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11049), 1,
      anon_sym_DOT,
    STATE(7495), 1,
      aux_sym_long_identifier_repeat1,
    STATE(7499), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3449), 9,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_LT2,
  [203745] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11141), 1,
      anon_sym_COMMA,
    STATE(7500), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(237), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [203789] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4086), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7501), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4084), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [203833] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8410), 1,
      anon_sym_let,
    ACTIONS(8412), 1,
      anon_sym_let_BANG,
    ACTIONS(10462), 1,
      anon_sym_val,
    ACTIONS(11143), 1,
      anon_sym_do,
    ACTIONS(11145), 1,
      anon_sym_member,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(6656), 1,
      sym_value_declaration,
    STATE(6663), 1,
      sym_function_or_value_defn,
    STATE(6723), 1,
      sym_do,
    STATE(8675), 1,
      sym_attributes,
    STATE(7502), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203897] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8217), 1,
      anon_sym_let,
    ACTIONS(8219), 1,
      anon_sym_let_BANG,
    ACTIONS(10474), 1,
      anon_sym_val,
    ACTIONS(11147), 1,
      anon_sym_do,
    ACTIONS(11149), 1,
      anon_sym_member,
    STATE(3813), 1,
      sym_function_or_value_defn,
    STATE(3814), 1,
      sym_value_declaration,
    STATE(3847), 1,
      sym_do,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(8753), 1,
      sym_attributes,
    STATE(7503), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203961] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11151), 1,
      anon_sym_DQUOTE,
    ACTIONS(11153), 1,
      anon_sym_DQUOTEB,
    STATE(7511), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7504), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204015] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11155), 1,
      anon_sym_COMMA,
    STATE(7505), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6182), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [204059] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11157), 1,
      anon_sym_COMMA,
    STATE(7506), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6132), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [204103] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11159), 1,
      anon_sym_LT2,
    ACTIONS(3505), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(7507), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3503), 7,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [204149] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11131), 1,
      anon_sym_do,
    ACTIONS(11133), 1,
      anon_sym_let,
    ACTIONS(11135), 1,
      anon_sym_let_BANG,
    ACTIONS(11161), 1,
      anon_sym_member,
    ACTIONS(11163), 1,
      anon_sym_val,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7563), 1,
      sym_function_or_value_defn,
    STATE(7583), 1,
      sym_do,
    STATE(7625), 1,
      sym_value_declaration,
    STATE(8773), 1,
      sym_attributes,
    STATE(7508), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204213] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11165), 1,
      anon_sym_DQUOTE,
    ACTIONS(11167), 1,
      anon_sym_DQUOTEB,
    STATE(7513), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7509), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204267] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4078), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7510), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4076), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [204311] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11169), 1,
      anon_sym_DQUOTE,
    ACTIONS(11171), 1,
      anon_sym_DQUOTEB,
    STATE(7352), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7511), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204365] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11173), 1,
      anon_sym_COMMA,
    STATE(7512), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6182), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [204409] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11175), 1,
      anon_sym_DQUOTE,
    ACTIONS(11177), 1,
      anon_sym_DQUOTEB,
    STATE(7352), 1,
      aux_sym__string_literal_repeat1,
    STATE(8137), 1,
      sym__string_char,
    STATE(8227), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(10776), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(10780), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(10778), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7513), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204463] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3515), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(7514), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [204507] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7515), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6386), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [204548] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7516), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6386), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [204589] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7517), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4973), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [204630] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7518), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6286), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [204671] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7519), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(11179), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [204712] = 19,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11183), 1,
      anon_sym_inline,
    ACTIONS(11185), 1,
      anon_sym_val,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3444), 1,
      sym_property_or_ident,
    STATE(3814), 1,
      sym_method_or_prop_defn,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(8554), 1,
      sym_access_modifier,
    STATE(7520), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204773] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7521), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6282), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [204814] = 19,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11191), 1,
      anon_sym_inline,
    ACTIONS(11193), 1,
      anon_sym_val,
    STATE(3205), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6320), 1,
      sym_method_or_prop_defn,
    STATE(8512), 1,
      sym_access_modifier,
    STATE(7522), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204875] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    STATE(7620), 1,
      aux_sym_compound_type_repeat1,
    ACTIONS(3468), 2,
      anon_sym_with,
      sym_identifier,
    STATE(7523), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3466), 7,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [204922] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7524), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6442), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [204963] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7525), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6446), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [205004] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7526), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6410), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [205045] = 19,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11195), 1,
      anon_sym_inline,
    ACTIONS(11197), 1,
      anon_sym_val,
    STATE(3327), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6563), 1,
      sym_method_or_prop_defn,
    STATE(8446), 1,
      sym_access_modifier,
    STATE(7527), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205106] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7528), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6308), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [205147] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3487), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7529), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3485), 10,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LT2,
  [205190] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11205), 1,
      anon_sym_DQUOTE,
    STATE(7633), 1,
      aux_sym__string_literal_repeat1,
    STATE(8326), 1,
      sym__string_char,
    STATE(8436), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11199), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(11203), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11201), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7530), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205241] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7531), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6304), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [205282] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7532), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6132), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [205323] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7533), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6290), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [205364] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3498), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11207), 1,
      anon_sym_or,
    STATE(7545), 1,
      aux_sym_type_argument_repeat1,
    STATE(7534), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [205411] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7904), 1,
      anon_sym_COLON,
    ACTIONS(11209), 1,
      anon_sym_and,
    STATE(7606), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(7535), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7906), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [205458] = 19,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11211), 1,
      anon_sym_inline,
    ACTIONS(11213), 1,
      anon_sym_val,
    STATE(3360), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(7627), 1,
      sym_method_or_prop_defn,
    STATE(8553), 1,
      sym_access_modifier,
    STATE(7536), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205519] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3487), 2,
      anon_sym_with,
      sym_identifier,
    STATE(7537), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3485), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [205562] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7538), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4973), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [205603] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7539), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2690), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [205644] = 19,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11215), 1,
      anon_sym_inline,
    ACTIONS(11217), 1,
      anon_sym_val,
    STATE(3205), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6322), 1,
      sym_method_or_prop_defn,
    STATE(8474), 1,
      sym_access_modifier,
    STATE(7540), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205705] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7541), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6290), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [205746] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7542), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6286), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [205787] = 19,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11219), 1,
      anon_sym_inline,
    ACTIONS(11221), 1,
      anon_sym_val,
    STATE(3327), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6717), 1,
      sym_method_or_prop_defn,
    STATE(8445), 1,
      sym_access_modifier,
    STATE(7543), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205848] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3193), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9093), 1,
      aux_sym_decimal_token1,
    ACTIONS(9662), 1,
      anon_sym_f,
    STATE(7544), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3191), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [205895] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3476), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11207), 1,
      anon_sym_or,
    STATE(7572), 1,
      aux_sym_type_argument_repeat1,
    STATE(7545), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3474), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [205942] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7546), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6030), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [205983] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7547), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6304), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [206024] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7548), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6132), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [206065] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7549), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6282), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [206106] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7550), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6456), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [206147] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7551), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6342), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [206188] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7552), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6308), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [206229] = 19,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11223), 1,
      anon_sym_inline,
    ACTIONS(11225), 1,
      anon_sym_val,
    STATE(3360), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(7625), 1,
      sym_method_or_prop_defn,
    STATE(8561), 1,
      sym_access_modifier,
    STATE(7553), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206290] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7893), 1,
      anon_sym_COLON,
    ACTIONS(11209), 1,
      anon_sym_and,
    STATE(7535), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(7554), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7895), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [206337] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7555), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6410), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [206378] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11227), 1,
      anon_sym_LBRACK_LT,
    STATE(8237), 1,
      sym__attribute_set,
    ACTIONS(9020), 4,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_POUND,
      sym_identifier,
    ACTIONS(9025), 4,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7556), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_attributes_repeat1,
  [206425] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7557), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6452), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [206466] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(10823), 1,
      anon_sym_DQUOTE,
    STATE(8326), 1,
      sym__string_char,
    STATE(8436), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11230), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(11236), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11233), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7558), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__string_literal_repeat1,
  [206515] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7559), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6316), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [206556] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7560), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6008), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [206597] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7561), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6456), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [206638] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7562), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6324), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [206679] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7563), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2690), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [206720] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7564), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6414), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [206761] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3604), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11239), 1,
      aux_sym_float_token1,
    STATE(7565), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3602), 9,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_f,
      aux_sym_decimal_token1,
  [206806] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7566), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(11241), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [206847] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3487), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11243), 1,
      anon_sym_DOT,
    STATE(7567), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3485), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [206892] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3451), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11246), 1,
      anon_sym_DOT,
    STATE(7567), 1,
      aux_sym_long_identifier_repeat1,
    STATE(7568), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3449), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [206939] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7569), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6338), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [206980] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7570), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6300), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [207021] = 19,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11248), 1,
      anon_sym_inline,
    ACTIONS(11250), 1,
      anon_sym_val,
    STATE(3490), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6780), 1,
      sym_method_or_prop_defn,
    STATE(8514), 1,
      sym_access_modifier,
    STATE(7571), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207082] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3480), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11252), 1,
      anon_sym_or,
    STATE(7572), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3478), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [207127] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7573), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6418), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [207168] = 19,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11255), 1,
      anon_sym_inline,
    ACTIONS(11257), 1,
      anon_sym_val,
    STATE(3358), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(7551), 1,
      sym_method_or_prop_defn,
    STATE(8558), 1,
      sym_access_modifier,
    STATE(7574), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207229] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3494), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11246), 1,
      anon_sym_DOT,
    STATE(7568), 1,
      aux_sym_long_identifier_repeat1,
    STATE(7575), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [207276] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7576), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6452), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [207317] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7577), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6398), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [207358] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7578), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6406), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [207399] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7579), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6434), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [207440] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7580), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6414), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [207481] = 19,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11259), 1,
      anon_sym_inline,
    ACTIONS(11261), 1,
      anon_sym_val,
    STATE(3394), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6484), 1,
      sym_method_or_prop_defn,
    STATE(8469), 1,
      sym_access_modifier,
    STATE(7581), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207542] = 19,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11263), 1,
      anon_sym_inline,
    ACTIONS(11265), 1,
      anon_sym_val,
    STATE(3394), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6487), 1,
      sym_method_or_prop_defn,
    STATE(8459), 1,
      sym_access_modifier,
    STATE(7582), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207603] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7583), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2690), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [207644] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11267), 1,
      anon_sym_COLON_GT,
    ACTIONS(3515), 2,
      anon_sym_with,
      sym_identifier,
    STATE(7584), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [207689] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7585), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6334), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [207730] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7586), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6278), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [207771] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7587), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6390), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [207812] = 19,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(10371), 1,
      anon_sym_inline,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11269), 1,
      anon_sym_val,
    STATE(3490), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6936), 1,
      sym_method_or_prop_defn,
    STATE(8486), 1,
      sym_access_modifier,
    STATE(7588), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207873] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7589), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6030), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [207914] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7590), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6418), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [207955] = 19,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11271), 1,
      anon_sym_inline,
    ACTIONS(11273), 1,
      anon_sym_val,
    STATE(3444), 1,
      sym_property_or_ident,
    STATE(3810), 1,
      sym_method_or_prop_defn,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(8525), 1,
      sym_access_modifier,
    STATE(7591), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208016] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11275), 1,
      anon_sym_DQUOTE,
    STATE(7558), 1,
      aux_sym__string_literal_repeat1,
    STATE(8326), 1,
      sym__string_char,
    STATE(8436), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11199), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(11203), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11201), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7592), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208067] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7971), 1,
      anon_sym_LBRACK_LT,
    STATE(7556), 1,
      aux_sym_attributes_repeat1,
    STATE(8237), 1,
      sym__attribute_set,
    ACTIONS(9005), 4,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_POUND,
      sym_identifier,
    ACTIONS(9007), 4,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7593), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208116] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7594), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9956), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [208157] = 19,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11277), 1,
      anon_sym_inline,
    ACTIONS(11279), 1,
      anon_sym_val,
    STATE(3446), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6997), 1,
      sym_method_or_prop_defn,
    STATE(8521), 1,
      sym_access_modifier,
    STATE(7595), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208218] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3753), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11281), 1,
      sym_int,
    STATE(7596), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3751), 9,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_f,
      aux_sym_decimal_token1,
  [208263] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7597), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6022), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [208304] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7598), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6378), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [208345] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7599), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6374), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [208386] = 19,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11283), 1,
      anon_sym_inline,
    ACTIONS(11285), 1,
      anon_sym_val,
    STATE(3230), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6601), 1,
      sym_method_or_prop_defn,
    STATE(8454), 1,
      sym_access_modifier,
    STATE(7600), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208447] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(11289), 1,
      anon_sym_COMMA,
    ACTIONS(11291), 1,
      anon_sym_GT,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(9323), 1,
      aux_sym_types_repeat1,
    STATE(7601), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208508] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11293), 1,
      anon_sym_DQUOTE,
    STATE(7592), 1,
      aux_sym__string_literal_repeat1,
    STATE(8326), 1,
      sym__string_char,
    STATE(8436), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11199), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(11203), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11201), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7602), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208559] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7603), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6434), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [208600] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7604), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2690), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [208641] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7605), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6406), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [208682] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7908), 1,
      anon_sym_COLON,
    ACTIONS(11295), 1,
      anon_sym_and,
    STATE(7606), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(7910), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [208727] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7607), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6394), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [208768] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3604), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7608), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3602), 10,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_f,
      aux_sym_decimal_token1,
  [208811] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7609), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6022), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [208852] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7610), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6398), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [208893] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3728), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7611), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3726), 10,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_f,
      aux_sym_decimal_token1,
  [208936] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7612), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6386), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [208977] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7613), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6374), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [209018] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7614), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6338), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [209059] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7615), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6316), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [209100] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7616), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6300), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [209141] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7617), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6386), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [209182] = 19,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11271), 1,
      anon_sym_inline,
    ACTIONS(11298), 1,
      anon_sym_val,
    STATE(3444), 1,
      sym_property_or_ident,
    STATE(3810), 1,
      sym_method_or_prop_defn,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(8525), 1,
      sym_access_modifier,
    STATE(7618), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209243] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7619), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6008), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [209284] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11300), 1,
      anon_sym_STAR,
    ACTIONS(3427), 2,
      anon_sym_with,
      sym_identifier,
    STATE(7620), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3425), 7,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [209329] = 19,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11303), 1,
      anon_sym_inline,
    ACTIONS(11305), 1,
      anon_sym_val,
    STATE(3447), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6868), 1,
      sym_method_or_prop_defn,
    STATE(8441), 1,
      sym_access_modifier,
    STATE(7621), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209390] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7622), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6378), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [209431] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7623), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6278), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [209472] = 19,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11307), 1,
      anon_sym_inline,
    ACTIONS(11309), 1,
      anon_sym_val,
    STATE(3230), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6656), 1,
      sym_method_or_prop_defn,
    STATE(8458), 1,
      sym_access_modifier,
    STATE(7624), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209533] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7625), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6334), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [209574] = 19,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11311), 1,
      anon_sym_inline,
    ACTIONS(11313), 1,
      anon_sym_val,
    STATE(3446), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(7088), 1,
      sym_method_or_prop_defn,
    STATE(8438), 1,
      sym_access_modifier,
    STATE(7626), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209635] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7627), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6342), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [209676] = 19,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11315), 1,
      anon_sym_inline,
    ACTIONS(11317), 1,
      anon_sym_val,
    STATE(3358), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(7585), 1,
      sym_method_or_prop_defn,
    STATE(8548), 1,
      sym_access_modifier,
    STATE(7628), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209737] = 19,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11183), 1,
      anon_sym_inline,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11319), 1,
      anon_sym_val,
    STATE(3444), 1,
      sym_property_or_ident,
    STATE(3814), 1,
      sym_method_or_prop_defn,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(8554), 1,
      sym_access_modifier,
    STATE(7629), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209798] = 19,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11321), 1,
      anon_sym_inline,
    ACTIONS(11323), 1,
      anon_sym_val,
    STATE(3447), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6907), 1,
      sym_method_or_prop_defn,
    STATE(8457), 1,
      sym_access_modifier,
    STATE(7630), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209859] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7631), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6394), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [209900] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7632), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3698), 11,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_interface,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [209941] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11325), 1,
      anon_sym_DQUOTE,
    STATE(7558), 1,
      aux_sym__string_literal_repeat1,
    STATE(8326), 1,
      sym__string_char,
    STATE(8436), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11199), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(11203), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11201), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(7633), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209992] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7634), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6446), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [210033] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8686), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7635), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210089] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8722), 1,
      sym_attributes,
    STATE(8797), 1,
      sym_type_argument_defn,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7636), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210145] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11321), 1,
      anon_sym_inline,
    STATE(3447), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6907), 1,
      sym_method_or_prop_defn,
    STATE(8457), 1,
      sym_access_modifier,
    STATE(7637), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210203] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7893), 1,
      anon_sym_COLON,
    ACTIONS(11331), 1,
      anon_sym_and,
    STATE(7931), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(7638), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7895), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [210249] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11333), 1,
      anon_sym_inline,
    STATE(3447), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6866), 1,
      sym_method_or_prop_defn,
    STATE(8468), 1,
      sym_access_modifier,
    STATE(7639), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210307] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7904), 1,
      anon_sym_COLON,
    ACTIONS(11335), 1,
      anon_sym_and,
    STATE(7642), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(7640), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7906), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
  [210353] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11341), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11343), 1,
      anon_sym_DQUOTEB,
    STATE(7645), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7641), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210403] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7908), 1,
      anon_sym_COLON,
    ACTIONS(11345), 1,
      anon_sym_and,
    STATE(7642), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(7910), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
  [210447] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11348), 1,
      anon_sym_EQ,
    ACTIONS(11350), 1,
      anon_sym_with,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(7643), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210505] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11315), 1,
      anon_sym_inline,
    STATE(3358), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(7585), 1,
      sym_method_or_prop_defn,
    STATE(8548), 1,
      sym_access_modifier,
    STATE(7644), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210563] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11358), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11360), 1,
      anon_sym_DQUOTEB,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11355), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11352), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7645), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_verbatim_string_repeat1,
  [210611] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8722), 1,
      sym_attributes,
    STATE(8759), 1,
      sym_type_argument_defn,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7646), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210667] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    ACTIONS(11362), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(7647), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210723] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(10914), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7648), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210781] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11368), 1,
      anon_sym_EQ,
    ACTIONS(11370), 1,
      anon_sym_with,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(7649), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210839] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11372), 1,
      anon_sym_or,
    STATE(7656), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(3476), 2,
      anon_sym_and,
      sym_identifier,
    STATE(7650), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3474), 6,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [210885] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11374), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11376), 1,
      anon_sym_DQUOTEB,
    STATE(7641), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7651), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210935] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11378), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11380), 1,
      anon_sym_DQUOTEB,
    STATE(7645), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7652), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210985] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3498), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11382), 1,
      anon_sym_or,
    STATE(7908), 1,
      aux_sym_type_argument_repeat1,
    STATE(7653), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [211031] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(10952), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7654), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211089] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11384), 1,
      sym_identifier,
    ACTIONS(11386), 1,
      anon_sym_LPAREN,
    ACTIONS(11388), 1,
      anon_sym__,
    ACTIONS(11390), 1,
      anon_sym_POUND,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(7438), 1,
      sym_long_identifier,
    STATE(7447), 1,
      sym_type_argument,
    STATE(7450), 1,
      sym_atomic_type,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7655), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211145] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11392), 1,
      anon_sym_or,
    ACTIONS(3480), 2,
      anon_sym_and,
      sym_identifier,
    STATE(7656), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3478), 6,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [211189] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(10218), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7657), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211247] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11395), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11397), 1,
      anon_sym_DQUOTEB,
    STATE(7670), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7658), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211297] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(10648), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7659), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211355] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11399), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11401), 1,
      anon_sym_DQUOTEB,
    STATE(7652), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7660), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211405] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3527), 2,
      anon_sym_with,
      sym_identifier,
    STATE(7661), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3525), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [211447] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11403), 1,
      sym_identifier,
    ACTIONS(11405), 1,
      anon_sym_LPAREN,
    ACTIONS(11407), 1,
      anon_sym__,
    ACTIONS(11409), 1,
      anon_sym_POUND,
    STATE(7653), 1,
      sym__static_type_identifier,
    STATE(8007), 1,
      sym_long_identifier,
    STATE(8422), 1,
      sym_atomic_type,
    STATE(8423), 1,
      sym_type_argument,
    ACTIONS(11411), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7662), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211503] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11413), 1,
      anon_sym_inline,
    STATE(3358), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(7609), 1,
      sym_method_or_prop_defn,
    STATE(8539), 1,
      sym_access_modifier,
    STATE(7663), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211561] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11415), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11417), 1,
      anon_sym_DQUOTEB,
    STATE(7675), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7664), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211611] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8164), 1,
      anon_sym_COLON,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11421), 1,
      anon_sym_COMMA,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      anon_sym_PIPE,
    ACTIONS(11427), 1,
      anon_sym_AMP,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(8166), 3,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_LT2,
    STATE(7665), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211665] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(10271), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7666), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211723] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(11268), 1,
      sym_record_fields,
    STATE(7667), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211781] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11429), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11431), 1,
      anon_sym_DQUOTEB,
    STATE(7690), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7668), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211831] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8722), 1,
      sym_attributes,
    STATE(8732), 1,
      sym_type_argument_defn,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7669), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211887] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11433), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11435), 1,
      anon_sym_DQUOTEB,
    STATE(7645), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7670), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211937] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7283), 1,
      anon_sym_and,
    ACTIONS(7285), 1,
      anon_sym_GT,
    ACTIONS(9508), 1,
      sym_identifier,
    ACTIONS(11437), 1,
      anon_sym_DASH_GT,
    ACTIONS(11439), 1,
      anon_sym_STAR,
    ACTIONS(11441), 1,
      anon_sym_LT2,
    ACTIONS(11443), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(8435), 1,
      aux_sym_compound_type_repeat1,
    STATE(8497), 1,
      sym_long_identifier,
    STATE(8505), 1,
      sym_type_arguments,
    STATE(7671), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211995] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8127), 1,
      anon_sym_COLON,
    ACTIONS(11445), 1,
      anon_sym_COMMA,
    STATE(7672), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(8129), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [212039] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7908), 1,
      anon_sym_COLON,
    STATE(7673), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7910), 9,
      sym__newline,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [212081] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8158), 1,
      anon_sym_COLON,
    STATE(7854), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(7674), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8160), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [212125] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11448), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11450), 1,
      anon_sym_DQUOTEB,
    STATE(7645), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7675), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212175] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(10965), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7676), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212233] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8685), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7677), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212289] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(11272), 1,
      sym_record_fields,
    STATE(7678), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212347] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8158), 1,
      anon_sym_COLON,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(7679), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8160), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [212391] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11452), 1,
      sym_identifier,
    ACTIONS(11454), 1,
      anon_sym_LPAREN,
    ACTIONS(11456), 1,
      anon_sym__,
    ACTIONS(11458), 1,
      anon_sym_POUND,
    STATE(7534), 1,
      sym__static_type_identifier,
    STATE(7890), 1,
      sym_long_identifier,
    STATE(8021), 1,
      sym_atomic_type,
    STATE(8053), 1,
      sym_type_argument,
    ACTIONS(11460), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7680), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212447] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8138), 1,
      anon_sym_COLON,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(7681), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8140), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [212491] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3531), 2,
      anon_sym_with,
      sym_identifier,
    STATE(7682), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3529), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [212533] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11176), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7683), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212591] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8134), 1,
      anon_sym_COLON,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(7684), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8136), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [212635] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(10937), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7685), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212693] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8701), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7686), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212749] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8691), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7687), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212805] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8680), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7688), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212861] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11462), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11464), 1,
      anon_sym_DQUOTEB,
    STATE(7645), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7689), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212911] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11466), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11468), 1,
      anon_sym_DQUOTEB,
    STATE(7645), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7690), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212961] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8608), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7691), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213017] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11470), 1,
      anon_sym_EQ,
    ACTIONS(11472), 1,
      anon_sym_with,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(7692), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213075] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8611), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7693), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213131] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10933), 1,
      anon_sym_DOT,
    ACTIONS(11474), 1,
      anon_sym_EQ,
    STATE(7464), 1,
      aux_sym_long_identifier_repeat1,
    STATE(7694), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 7,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
  [213177] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11476), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11478), 1,
      anon_sym_DQUOTEB,
    STATE(7689), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7695), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213227] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6726), 1,
      anon_sym_LT2,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11421), 1,
      anon_sym_COMMA,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      anon_sym_PIPE,
    ACTIONS(11427), 1,
      anon_sym_AMP,
    ACTIONS(11480), 1,
      anon_sym_EQ,
    ACTIONS(11482), 1,
      anon_sym_COLON,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(9724), 1,
      sym_type_arguments,
    STATE(7696), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213285] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11484), 1,
      anon_sym_inline,
    STATE(3394), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6425), 1,
      sym_method_or_prop_defn,
    STATE(8517), 1,
      sym_access_modifier,
    STATE(7697), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213343] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11486), 1,
      sym_identifier,
    ACTIONS(11488), 1,
      anon_sym_PIPE,
    ACTIONS(11490), 1,
      anon_sym_LBRACE,
    ACTIONS(11492), 1,
      anon_sym_new,
    STATE(5292), 1,
      sym_union_type_cases,
    STATE(6531), 1,
      sym_union_type_case,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(10202), 1,
      sym_attributes,
    STATE(7698), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213401] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8615), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7699), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213457] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11311), 1,
      anon_sym_inline,
    STATE(3446), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(7088), 1,
      sym_method_or_prop_defn,
    STATE(8438), 1,
      sym_access_modifier,
    STATE(7700), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213515] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3515), 2,
      anon_sym_with,
      sym_identifier,
    STATE(7701), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [213557] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8722), 1,
      sym_attributes,
    STATE(8740), 1,
      sym_type_argument_defn,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7702), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213613] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11494), 1,
      sym_identifier,
    ACTIONS(11496), 1,
      anon_sym_DASH_GT,
    ACTIONS(11498), 1,
      anon_sym_STAR,
    ACTIONS(11500), 1,
      anon_sym_LT2,
    ACTIONS(11502), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(8325), 1,
      aux_sym_compound_type_repeat1,
    STATE(8477), 1,
      sym_long_identifier,
    STATE(8483), 1,
      sym_type_arguments,
    ACTIONS(6507), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(7703), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213669] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7908), 1,
      anon_sym_COLON,
    ACTIONS(11504), 1,
      anon_sym_and,
    STATE(7704), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(7910), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [213713] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(10874), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7705), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213771] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11507), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11509), 1,
      anon_sym_DQUOTEB,
    STATE(7721), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7706), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213821] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8127), 1,
      anon_sym_COLON,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(7707), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8129), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [213865] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11511), 1,
      anon_sym_LT2,
    ACTIONS(3505), 2,
      anon_sym_with,
      sym_identifier,
    STATE(7708), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3503), 7,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [213909] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8051), 1,
      anon_sym_COLON,
    STATE(7709), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8053), 9,
      sym__newline,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [213951] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11513), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11515), 1,
      anon_sym_DQUOTEB,
    STATE(7711), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7710), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214001] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11517), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11519), 1,
      anon_sym_DQUOTEB,
    STATE(7645), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7711), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214051] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8633), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7712), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214107] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11190), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7713), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214165] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3476), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11521), 1,
      anon_sym_or,
    STATE(7748), 1,
      aux_sym_type_argument_repeat1,
    STATE(7714), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3474), 7,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [214211] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    ACTIONS(11523), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(7715), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214267] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9730), 1,
      anon_sym_LT2,
    ACTIONS(9732), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(9772), 1,
      anon_sym_DASH_GT,
    ACTIONS(9774), 1,
      anon_sym_STAR,
    ACTIONS(11525), 1,
      sym_identifier,
    STATE(6501), 1,
      aux_sym_compound_type_repeat1,
    STATE(6558), 1,
      sym_long_identifier,
    STATE(6573), 1,
      sym_type_arguments,
    ACTIONS(6507), 2,
      sym__newline,
      sym__dedent,
    STATE(7716), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214323] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8618), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7717), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214379] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11283), 1,
      anon_sym_inline,
    STATE(3230), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6601), 1,
      sym_method_or_prop_defn,
    STATE(8454), 1,
      sym_access_modifier,
    STATE(7718), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214437] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11263), 1,
      anon_sym_inline,
    STATE(3394), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6487), 1,
      sym_method_or_prop_defn,
    STATE(8459), 1,
      sym_access_modifier,
    STATE(7719), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214495] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(10990), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7720), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214553] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11527), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11529), 1,
      anon_sym_DQUOTEB,
    STATE(7645), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7721), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214603] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11531), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11533), 1,
      anon_sym_DQUOTEB,
    STATE(7645), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7722), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214653] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7985), 1,
      anon_sym_COLON,
    ACTIONS(11421), 1,
      anon_sym_COMMA,
    STATE(7672), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(7723), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7987), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [214699] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8624), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7724), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214755] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11535), 1,
      anon_sym_inline,
    STATE(3446), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6954), 1,
      sym_method_or_prop_defn,
    STATE(8538), 1,
      sym_access_modifier,
    STATE(7725), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214813] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7279), 1,
      anon_sym_COLON,
    STATE(7726), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7281), 9,
      sym__newline,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [214855] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11537), 1,
      anon_sym_COLON,
    ACTIONS(11539), 1,
      anon_sym_as,
    ACTIONS(11541), 1,
      anon_sym_COMMA,
    ACTIONS(11543), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11545), 1,
      anon_sym_PIPE,
    ACTIONS(11547), 1,
      anon_sym_AMP,
    ACTIONS(11549), 1,
      sym__newline,
    ACTIONS(11551), 1,
      sym__dedent,
    STATE(7995), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(9068), 1,
      aux_sym__list_pattern_content_repeat1,
    STATE(7727), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214913] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3535), 2,
      anon_sym_with,
      sym_identifier,
    STATE(7728), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3533), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [214955] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8630), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7729), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215011] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(10223), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7730), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215069] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8640), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7731), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215125] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11553), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11555), 1,
      anon_sym_DQUOTEB,
    STATE(7722), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7732), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215175] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11002), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7733), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215233] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8644), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7734), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215289] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11136), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7735), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215347] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11557), 1,
      anon_sym_EQ,
    ACTIONS(11559), 1,
      anon_sym_with,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(7736), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215405] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9730), 1,
      anon_sym_LT2,
    ACTIONS(9732), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(9772), 1,
      anon_sym_DASH_GT,
    ACTIONS(9774), 1,
      anon_sym_STAR,
    ACTIONS(11525), 1,
      sym_identifier,
    STATE(6501), 1,
      aux_sym_compound_type_repeat1,
    STATE(6558), 1,
      sym_long_identifier,
    STATE(6573), 1,
      sym_type_arguments,
    ACTIONS(11561), 2,
      sym__newline,
      sym__dedent,
    STATE(7737), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215461] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8647), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7738), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215517] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11563), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11565), 1,
      anon_sym_DQUOTEB,
    STATE(7869), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7739), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215567] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11486), 1,
      sym_identifier,
    ACTIONS(11488), 1,
      anon_sym_PIPE,
    ACTIONS(11492), 1,
      anon_sym_new,
    ACTIONS(11567), 1,
      anon_sym_LBRACE,
    STATE(5266), 1,
      sym_union_type_cases,
    STATE(6531), 1,
      sym_union_type_case,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(10202), 1,
      sym_attributes,
    STATE(7740), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215625] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(10589), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7741), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215683] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8722), 1,
      sym_attributes,
    STATE(8780), 1,
      sym_type_argument_defn,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7742), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215739] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11569), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11571), 1,
      anon_sym_DQUOTEB,
    STATE(7645), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7743), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215789] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11573), 1,
      anon_sym_EQ,
    ACTIONS(11575), 1,
      anon_sym_with,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(7744), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215847] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8650), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7745), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215903] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(10649), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7746), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215961] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11494), 1,
      sym_identifier,
    ACTIONS(11496), 1,
      anon_sym_DASH_GT,
    ACTIONS(11498), 1,
      anon_sym_STAR,
    ACTIONS(11500), 1,
      anon_sym_LT2,
    ACTIONS(11502), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(8325), 1,
      aux_sym_compound_type_repeat1,
    STATE(8477), 1,
      sym_long_identifier,
    STATE(8483), 1,
      sym_type_arguments,
    ACTIONS(3417), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(7747), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216017] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3480), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11577), 1,
      anon_sym_or,
    STATE(7748), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3478), 7,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [216061] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9730), 1,
      anon_sym_LT2,
    ACTIONS(9732), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(9772), 1,
      anon_sym_DASH_GT,
    ACTIONS(9774), 1,
      anon_sym_STAR,
    ACTIONS(11525), 1,
      sym_identifier,
    STATE(6501), 1,
      aux_sym_compound_type_repeat1,
    STATE(6558), 1,
      sym_long_identifier,
    STATE(6573), 1,
      sym_type_arguments,
    ACTIONS(11580), 2,
      sym__newline,
      sym__dedent,
    STATE(7749), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216117] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11582), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11584), 1,
      anon_sym_DQUOTEB,
    STATE(7743), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7750), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216167] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8653), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7751), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216223] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11172), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7752), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216281] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11248), 1,
      anon_sym_inline,
    STATE(3490), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6780), 1,
      sym_method_or_prop_defn,
    STATE(8514), 1,
      sym_access_modifier,
    STATE(7753), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216339] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11168), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7754), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216397] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11164), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7755), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216455] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7893), 1,
      anon_sym_COLON,
    ACTIONS(11586), 1,
      anon_sym_and,
    STATE(7910), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(7756), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7895), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [216501] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8666), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7757), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216557] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8722), 1,
      sym_attributes,
    STATE(8966), 1,
      sym_type_argument_defn,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7758), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216613] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11160), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7759), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216671] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11486), 1,
      sym_identifier,
    ACTIONS(11488), 1,
      anon_sym_PIPE,
    ACTIONS(11492), 1,
      anon_sym_new,
    ACTIONS(11588), 1,
      anon_sym_LBRACE,
    STATE(5249), 1,
      sym_union_type_cases,
    STATE(6531), 1,
      sym_union_type_case,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(10202), 1,
      sym_attributes,
    STATE(7760), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216729] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    ACTIONS(11590), 1,
      sym__dedent,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9605), 1,
      sym_record_field,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7761), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216787] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11592), 1,
      anon_sym_inline,
    STATE(3230), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6610), 1,
      sym_method_or_prop_defn,
    STATE(8453), 1,
      sym_access_modifier,
    STATE(7762), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216845] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11537), 1,
      anon_sym_COLON,
    ACTIONS(11539), 1,
      anon_sym_as,
    ACTIONS(11541), 1,
      anon_sym_COMMA,
    ACTIONS(11543), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11545), 1,
      anon_sym_PIPE,
    ACTIONS(11547), 1,
      anon_sym_AMP,
    ACTIONS(11549), 1,
      sym__newline,
    ACTIONS(11594), 1,
      sym__dedent,
    STATE(7995), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(9110), 1,
      aux_sym__list_pattern_content_repeat1,
    STATE(7763), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216903] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(10834), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7764), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216961] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(10186), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7765), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217019] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11596), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11598), 1,
      anon_sym_DQUOTEB,
    STATE(7778), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7766), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217069] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11600), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11602), 1,
      anon_sym_DQUOTEB,
    STATE(7645), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7767), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217119] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11604), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11606), 1,
      anon_sym_DQUOTEB,
    STATE(7645), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7768), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217169] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8676), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7769), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217225] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11152), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7770), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217283] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8722), 1,
      sym_attributes,
    STATE(8760), 1,
      sym_type_argument_defn,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7771), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217339] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8684), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7772), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217395] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(11343), 1,
      sym_record_fields,
    STATE(7773), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217453] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(11347), 1,
      sym_record_fields,
    STATE(7774), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217511] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11608), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11610), 1,
      anon_sym_DQUOTEB,
    STATE(7767), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7775), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217561] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11148), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7776), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217619] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7995), 1,
      anon_sym_COLON,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(7777), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7997), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [217663] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11612), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11614), 1,
      anon_sym_DQUOTEB,
    STATE(7645), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7778), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217713] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8714), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7779), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217769] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11616), 1,
      sym_identifier,
    ACTIONS(11618), 1,
      anon_sym_LPAREN,
    ACTIONS(11620), 1,
      anon_sym__,
    ACTIONS(11622), 1,
      anon_sym_POUND,
    STATE(4769), 1,
      sym__static_type_identifier,
    STATE(4990), 1,
      sym_type_argument,
    STATE(4992), 1,
      sym_long_identifier,
    STATE(5080), 1,
      sym_atomic_type,
    ACTIONS(11624), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7780), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217825] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(10978), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7781), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217883] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3498), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11521), 1,
      anon_sym_or,
    STATE(7714), 1,
      aux_sym_type_argument_repeat1,
    STATE(7782), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 7,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [217929] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7893), 1,
      anon_sym_COLON,
    ACTIONS(11626), 1,
      anon_sym_and,
    STATE(7860), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(7783), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7895), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [217975] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11014), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7784), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218033] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11628), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11630), 1,
      anon_sym_DQUOTEB,
    STATE(7768), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7785), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218083] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3487), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7786), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3485), 9,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DOT,
      anon_sym_LT2,
  [218125] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11494), 1,
      sym_identifier,
    ACTIONS(11496), 1,
      anon_sym_DASH_GT,
    ACTIONS(11498), 1,
      anon_sym_STAR,
    ACTIONS(11500), 1,
      anon_sym_LT2,
    ACTIONS(11502), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(8325), 1,
      aux_sym_compound_type_repeat1,
    STATE(8477), 1,
      sym_long_identifier,
    STATE(8483), 1,
      sym_type_arguments,
    ACTIONS(3403), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(7787), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218181] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11494), 1,
      sym_identifier,
    ACTIONS(11496), 1,
      anon_sym_DASH_GT,
    ACTIONS(11498), 1,
      anon_sym_STAR,
    ACTIONS(11500), 1,
      anon_sym_LT2,
    ACTIONS(11502), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(8325), 1,
      aux_sym_compound_type_repeat1,
    STATE(8477), 1,
      sym_long_identifier,
    STATE(8483), 1,
      sym_type_arguments,
    ACTIONS(3425), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(7788), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218237] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11632), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11634), 1,
      anon_sym_DQUOTEB,
    STATE(7801), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7789), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218287] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11636), 1,
      anon_sym_inline,
    STATE(3205), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6342), 1,
      sym_method_or_prop_defn,
    STATE(8473), 1,
      sym_access_modifier,
    STATE(7790), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218345] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8642), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7791), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218401] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11494), 1,
      sym_identifier,
    ACTIONS(11496), 1,
      anon_sym_DASH_GT,
    ACTIONS(11498), 1,
      anon_sym_STAR,
    ACTIONS(11500), 1,
      anon_sym_LT2,
    ACTIONS(11502), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(8325), 1,
      aux_sym_compound_type_repeat1,
    STATE(8477), 1,
      sym_long_identifier,
    STATE(8483), 1,
      sym_type_arguments,
    ACTIONS(3429), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(7792), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218457] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7283), 1,
      anon_sym_COLON,
    STATE(7793), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7285), 9,
      sym__newline,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [218499] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11144), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7794), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218557] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8695), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7795), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218613] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11140), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7796), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218671] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11638), 1,
      anon_sym_EQ,
    ACTIONS(11640), 1,
      anon_sym_with,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(7797), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218729] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11080), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7798), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218787] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11024), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7799), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218845] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11642), 1,
      anon_sym_EQ,
    ACTIONS(11644), 1,
      anon_sym_with,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(7800), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218903] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11646), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11648), 1,
      anon_sym_DQUOTEB,
    STATE(7645), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7801), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218953] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8704), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7802), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219009] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11650), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11652), 1,
      anon_sym_DQUOTEB,
    STATE(7645), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7803), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219059] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11654), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11656), 1,
      anon_sym_DQUOTEB,
    STATE(7645), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7804), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219109] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11658), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11660), 1,
      anon_sym_DQUOTEB,
    STATE(7645), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7805), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219159] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11097), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7806), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219217] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8722), 1,
      sym_attributes,
    STATE(8747), 1,
      sym_type_argument_defn,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7807), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219273] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(10314), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7808), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219331] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8057), 1,
      anon_sym_COLON,
    STATE(7809), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8059), 9,
      sym__newline,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [219373] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    ACTIONS(11662), 1,
      sym__dedent,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9605), 1,
      sym_record_field,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7810), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219431] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8043), 1,
      anon_sym_COLON,
    STATE(7811), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8045), 9,
      sym__newline,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [219473] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7945), 1,
      anon_sym_COLON,
    STATE(7812), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7947), 9,
      sym__newline,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [219515] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9730), 1,
      anon_sym_LT2,
    ACTIONS(9732), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(9772), 1,
      anon_sym_DASH_GT,
    ACTIONS(9774), 1,
      anon_sym_STAR,
    ACTIONS(11525), 1,
      sym_identifier,
    STATE(6501), 1,
      aux_sym_compound_type_repeat1,
    STATE(6558), 1,
      sym_long_identifier,
    STATE(6573), 1,
      sym_type_arguments,
    ACTIONS(6511), 2,
      sym__newline,
      sym__dedent,
    STATE(7813), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219571] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11664), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11666), 1,
      anon_sym_DQUOTEB,
    STATE(7805), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7814), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219621] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11486), 1,
      sym_identifier,
    ACTIONS(11488), 1,
      anon_sym_PIPE,
    ACTIONS(11492), 1,
      anon_sym_new,
    ACTIONS(11668), 1,
      anon_sym_LBRACE,
    STATE(5300), 1,
      sym_union_type_cases,
    STATE(6531), 1,
      sym_union_type_case,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(10202), 1,
      sym_attributes,
    STATE(7815), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219679] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8710), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7816), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219735] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11132), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7817), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219793] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11128), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7818), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219851] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3604), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7819), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3602), 9,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_f,
      aux_sym_decimal_token1,
  [219893] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11670), 1,
      anon_sym_inline,
    STATE(3360), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(7597), 1,
      sym_method_or_prop_defn,
    STATE(8542), 1,
      sym_access_modifier,
    STATE(7820), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219951] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3523), 2,
      anon_sym_with,
      sym_identifier,
    STATE(7821), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3521), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [219993] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(10792), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7822), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220051] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11672), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11674), 1,
      anon_sym_DQUOTEB,
    STATE(7804), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7823), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220101] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11033), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7824), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220159] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8715), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7825), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220215] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8722), 1,
      sym_attributes,
    STATE(8723), 1,
      sym_type_argument_defn,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7826), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220271] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11676), 1,
      anon_sym_EQ,
    ACTIONS(11678), 1,
      anon_sym_with,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(7827), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220329] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11680), 1,
      sym_identifier,
    ACTIONS(11682), 1,
      anon_sym_LPAREN,
    ACTIONS(11684), 1,
      anon_sym__,
    ACTIONS(11686), 1,
      anon_sym_POUND,
    STATE(4986), 1,
      sym__static_type_identifier,
    STATE(5161), 1,
      sym_long_identifier,
    STATE(5293), 1,
      sym_type_argument,
    STATE(5305), 1,
      sym_atomic_type,
    ACTIONS(11688), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7828), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220385] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8722), 1,
      sym_attributes,
    STATE(8729), 1,
      sym_type_argument_defn,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7829), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220441] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11041), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7830), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220499] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(10706), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7831), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220557] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11124), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7832), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220615] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11120), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7833), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220673] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11116), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7834), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220731] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3511), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7835), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3509), 9,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_or,
  [220773] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(10522), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7836), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220831] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11112), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7837), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220889] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11690), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11692), 1,
      anon_sym_DQUOTEB,
    STATE(7803), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7838), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220939] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6726), 1,
      anon_sym_LT2,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11421), 1,
      anon_sym_COMMA,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      anon_sym_PIPE,
    ACTIONS(11427), 1,
      anon_sym_AMP,
    ACTIONS(11694), 1,
      anon_sym_EQ,
    ACTIONS(11696), 1,
      anon_sym_COLON,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(9788), 1,
      sym_type_arguments,
    STATE(7839), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220997] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3519), 2,
      anon_sym_with,
      sym_identifier,
    STATE(7840), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3517), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [221039] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11698), 1,
      anon_sym_inline,
    STATE(3444), 1,
      sym_property_or_ident,
    STATE(3798), 1,
      sym_method_or_prop_defn,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(8529), 1,
      sym_access_modifier,
    STATE(7841), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221097] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7963), 1,
      anon_sym_COLON,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(7842), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7965), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [221141] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8722), 1,
      sym_attributes,
    STATE(8734), 1,
      sym_type_argument_defn,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7843), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221197] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11700), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11702), 1,
      anon_sym_DQUOTEB,
    STATE(7874), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7844), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221247] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11704), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11706), 1,
      anon_sym_DQUOTEB,
    STATE(7858), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7845), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221297] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9730), 1,
      anon_sym_LT2,
    ACTIONS(9732), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(9772), 1,
      anon_sym_DASH_GT,
    ACTIONS(9774), 1,
      anon_sym_STAR,
    ACTIONS(11525), 1,
      sym_identifier,
    STATE(6501), 1,
      aux_sym_compound_type_repeat1,
    STATE(6558), 1,
      sym_long_identifier,
    STATE(6573), 1,
      sym_type_arguments,
    ACTIONS(11708), 2,
      sym__newline,
      sym__dedent,
    STATE(7846), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221353] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11494), 1,
      sym_identifier,
    ACTIONS(11496), 1,
      anon_sym_DASH_GT,
    ACTIONS(11498), 1,
      anon_sym_STAR,
    ACTIONS(11500), 1,
      anon_sym_LT2,
    ACTIONS(11502), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(8325), 1,
      aux_sym_compound_type_repeat1,
    STATE(8477), 1,
      sym_long_identifier,
    STATE(8483), 1,
      sym_type_arguments,
    ACTIONS(6511), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(7847), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221409] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11710), 1,
      sym_identifier,
    ACTIONS(11712), 1,
      anon_sym_LPAREN,
    ACTIONS(11714), 1,
      anon_sym__,
    ACTIONS(11716), 1,
      anon_sym_POUND,
    STATE(4902), 1,
      sym__static_type_identifier,
    STATE(5046), 1,
      sym_long_identifier,
    STATE(5152), 1,
      sym_type_argument,
    STATE(5153), 1,
      sym_atomic_type,
    ACTIONS(11718), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7848), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221465] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8659), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7849), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221521] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8722), 1,
      sym_attributes,
    STATE(8738), 1,
      sym_type_argument_defn,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7850), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221577] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7908), 1,
      anon_sym_COLON,
    ACTIONS(11720), 1,
      anon_sym_and,
    STATE(7851), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(7910), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [221621] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11223), 1,
      anon_sym_inline,
    STATE(3360), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(7625), 1,
      sym_method_or_prop_defn,
    STATE(8561), 1,
      sym_access_modifier,
    STATE(7852), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221679] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3539), 2,
      anon_sym_with,
      sym_identifier,
    STATE(7853), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3537), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [221721] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7985), 1,
      anon_sym_COLON,
    ACTIONS(11723), 1,
      anon_sym_COMMA,
    STATE(7873), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(7854), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7987), 7,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [221767] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7995), 1,
      anon_sym_COLON,
    STATE(7854), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(7855), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7997), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [221811] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11108), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7856), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221869] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8722), 1,
      sym_attributes,
    STATE(8746), 1,
      sym_type_argument_defn,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7857), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221925] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11725), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11727), 1,
      anon_sym_DQUOTEB,
    STATE(7645), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7858), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221975] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11104), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7859), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222033] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7904), 1,
      anon_sym_COLON,
    ACTIONS(11626), 1,
      anon_sym_and,
    STATE(7704), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(7860), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7906), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [222079] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11384), 1,
      sym_identifier,
    ACTIONS(11386), 1,
      anon_sym_LPAREN,
    ACTIONS(11388), 1,
      anon_sym__,
    ACTIONS(11729), 1,
      anon_sym_POUND,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(7438), 1,
      sym_long_identifier,
    STATE(7447), 1,
      sym_type_argument,
    STATE(7450), 1,
      sym_atomic_type,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7861), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222135] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3429), 1,
      anon_sym_GT,
    ACTIONS(3431), 1,
      anon_sym_and,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9508), 1,
      sym_identifier,
    ACTIONS(11437), 1,
      anon_sym_DASH_GT,
    ACTIONS(11439), 1,
      anon_sym_STAR,
    ACTIONS(11441), 1,
      anon_sym_LT2,
    ACTIONS(11443), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(8435), 1,
      aux_sym_compound_type_repeat1,
    STATE(8497), 1,
      sym_long_identifier,
    STATE(8505), 1,
      sym_type_arguments,
    STATE(7862), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222193] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8722), 1,
      sym_attributes,
    STATE(8754), 1,
      sym_type_argument_defn,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7863), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222249] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3193), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9594), 1,
      aux_sym_decimal_token1,
    ACTIONS(9823), 1,
      anon_sym_f,
    STATE(7864), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3191), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [222295] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11731), 1,
      sym_identifier,
    ACTIONS(11733), 1,
      anon_sym_LPAREN,
    ACTIONS(11735), 1,
      anon_sym__,
    ACTIONS(11737), 1,
      anon_sym_POUND,
    STATE(4797), 1,
      sym__static_type_identifier,
    STATE(4824), 1,
      sym_long_identifier,
    STATE(5004), 1,
      sym_atomic_type,
    STATE(5006), 1,
      sym_type_argument,
    ACTIONS(11739), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7865), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222351] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7908), 1,
      anon_sym_COLON,
    ACTIONS(11741), 1,
      anon_sym_and,
    STATE(7866), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(7910), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [222395] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8669), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7867), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222451] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7893), 1,
      anon_sym_COLON,
    ACTIONS(11335), 1,
      anon_sym_and,
    STATE(7640), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(7868), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7895), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
  [222497] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11744), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11746), 1,
      anon_sym_DQUOTEB,
    STATE(7645), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7869), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222547] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11748), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11750), 1,
      anon_sym_DQUOTEB,
    STATE(7645), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7870), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222597] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11752), 1,
      anon_sym_inline,
    STATE(3490), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6808), 1,
      sym_method_or_prop_defn,
    STATE(8563), 1,
      sym_access_modifier,
    STATE(7871), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222655] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8164), 1,
      anon_sym_COLON,
    ACTIONS(11723), 1,
      anon_sym_COMMA,
    ACTIONS(11754), 1,
      anon_sym_as,
    ACTIONS(11756), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11758), 1,
      anon_sym_PIPE,
    ACTIONS(11760), 1,
      anon_sym_AMP,
    STATE(7854), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(8166), 3,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(7872), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222709] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8127), 1,
      anon_sym_COLON,
    ACTIONS(11762), 1,
      anon_sym_COMMA,
    STATE(7873), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(8129), 7,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [222753] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11765), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11767), 1,
      anon_sym_DQUOTEB,
    STATE(7645), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7874), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222803] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3425), 1,
      anon_sym_GT,
    ACTIONS(3427), 1,
      anon_sym_and,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9508), 1,
      sym_identifier,
    ACTIONS(11437), 1,
      anon_sym_DASH_GT,
    ACTIONS(11439), 1,
      anon_sym_STAR,
    ACTIONS(11441), 1,
      anon_sym_LT2,
    ACTIONS(11443), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(8435), 1,
      aux_sym_compound_type_repeat1,
    STATE(8497), 1,
      sym_long_identifier,
    STATE(8505), 1,
      sym_type_arguments,
    STATE(7875), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222861] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3403), 1,
      anon_sym_GT,
    ACTIONS(3407), 1,
      anon_sym_and,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9508), 1,
      sym_identifier,
    ACTIONS(11437), 1,
      anon_sym_DASH_GT,
    ACTIONS(11439), 1,
      anon_sym_STAR,
    ACTIONS(11441), 1,
      anon_sym_LT2,
    ACTIONS(11443), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(8435), 1,
      aux_sym_compound_type_repeat1,
    STATE(8497), 1,
      sym_long_identifier,
    STATE(8505), 1,
      sym_type_arguments,
    STATE(7876), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222919] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3543), 2,
      anon_sym_with,
      sym_identifier,
    STATE(7877), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3541), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [222961] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11769), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11771), 1,
      anon_sym_DQUOTEB,
    STATE(7893), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7878), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223011] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11100), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7879), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223069] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8722), 1,
      sym_attributes,
    STATE(8757), 1,
      sym_type_argument_defn,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7880), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223125] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8722), 1,
      sym_attributes,
    STATE(8764), 1,
      sym_type_argument_defn,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7881), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223181] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3547), 2,
      anon_sym_with,
      sym_identifier,
    STATE(7882), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3545), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [223223] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11271), 1,
      anon_sym_inline,
    STATE(3444), 1,
      sym_property_or_ident,
    STATE(3810), 1,
      sym_method_or_prop_defn,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(8525), 1,
      sym_access_modifier,
    STATE(7883), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223281] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11773), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11775), 1,
      anon_sym_DQUOTEB,
    STATE(7645), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7884), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223331] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3480), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11777), 1,
      anon_sym_or,
    STATE(7885), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3478), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [223375] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11096), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7886), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223433] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8677), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7887), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223489] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11780), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11782), 1,
      anon_sym_DQUOTEB,
    STATE(7870), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7888), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223539] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11784), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11786), 1,
      anon_sym_DQUOTEB,
    STATE(7645), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7889), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223589] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7989), 1,
      anon_sym_COLON,
    ACTIONS(11788), 1,
      anon_sym_LT2,
    STATE(7890), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7991), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [223633] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11790), 1,
      anon_sym_EQ,
    ACTIONS(11792), 1,
      anon_sym_with,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(7891), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223691] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11794), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11796), 1,
      anon_sym_DQUOTEB,
    STATE(7884), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7892), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223741] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11798), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11800), 1,
      anon_sym_DQUOTEB,
    STATE(7645), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7893), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223791] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8696), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7894), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223847] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8722), 1,
      sym_attributes,
    STATE(8769), 1,
      sym_type_argument_defn,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7895), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223903] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11802), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11804), 1,
      anon_sym_DQUOTEB,
    STATE(7645), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7896), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223953] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11049), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7897), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224011] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6726), 1,
      anon_sym_LT2,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11421), 1,
      anon_sym_COMMA,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      anon_sym_PIPE,
    ACTIONS(11427), 1,
      anon_sym_AMP,
    ACTIONS(11806), 1,
      anon_sym_EQ,
    ACTIONS(11808), 1,
      anon_sym_COLON,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(9966), 1,
      sym_type_arguments,
    STATE(7898), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224069] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11092), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7899), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224127] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11810), 1,
      sym_identifier,
    ACTIONS(11812), 1,
      anon_sym_LPAREN,
    ACTIONS(11814), 1,
      anon_sym__,
    ACTIONS(11816), 1,
      anon_sym_POUND,
    STATE(4866), 1,
      sym__static_type_identifier,
    STATE(4995), 1,
      sym_long_identifier,
    STATE(5111), 1,
      sym_type_argument,
    STATE(5222), 1,
      sym_atomic_type,
    ACTIONS(11818), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7900), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224183] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11215), 1,
      anon_sym_inline,
    STATE(3205), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6322), 1,
      sym_method_or_prop_defn,
    STATE(8474), 1,
      sym_access_modifier,
    STATE(7901), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224241] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7963), 1,
      anon_sym_COLON,
    STATE(7854), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(7902), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7965), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [224285] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11820), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11822), 1,
      anon_sym_DQUOTEB,
    STATE(7889), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7903), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224335] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11195), 1,
      anon_sym_inline,
    STATE(3327), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6563), 1,
      sym_method_or_prop_defn,
    STATE(8446), 1,
      sym_access_modifier,
    STATE(7904), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224393] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(10384), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7905), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224451] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11824), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11826), 1,
      anon_sym_DQUOTEB,
    STATE(7896), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7906), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224501] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8637), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7907), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224557] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3476), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11382), 1,
      anon_sym_or,
    STATE(7885), 1,
      aux_sym_type_argument_repeat1,
    STATE(7908), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3474), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [224603] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8623), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7909), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224659] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7904), 1,
      anon_sym_COLON,
    ACTIONS(11586), 1,
      anon_sym_and,
    STATE(7851), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(7910), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7906), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [224705] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11088), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7911), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224763] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8627), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7912), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224819] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11055), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7913), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224877] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8722), 1,
      sym_attributes,
    STATE(8785), 1,
      sym_type_argument_defn,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7914), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224933] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11084), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7915), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224991] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7279), 1,
      anon_sym_and,
    ACTIONS(7281), 1,
      anon_sym_GT,
    ACTIONS(9508), 1,
      sym_identifier,
    ACTIONS(11437), 1,
      anon_sym_DASH_GT,
    ACTIONS(11439), 1,
      anon_sym_STAR,
    ACTIONS(11441), 1,
      anon_sym_LT2,
    ACTIONS(11443), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(8435), 1,
      aux_sym_compound_type_repeat1,
    STATE(8497), 1,
      sym_long_identifier,
    STATE(8505), 1,
      sym_type_arguments,
    STATE(7916), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225049] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(11407), 1,
      sym_record_fields,
    STATE(7917), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225107] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(11411), 1,
      sym_record_fields,
    STATE(7918), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225165] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8705), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7919), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225221] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9991), 1,
      anon_sym_new,
    ACTIONS(11139), 1,
      anon_sym_val,
    ACTIONS(11830), 1,
      anon_sym_static,
    ACTIONS(11832), 1,
      anon_sym_member,
    ACTIONS(11834), 1,
      anon_sym_abstract,
    STATE(7627), 1,
      sym_additional_constr_defn,
    STATE(11902), 1,
      sym_access_modifier,
    ACTIONS(11828), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7920), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225277] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8722), 1,
      sym_attributes,
    STATE(8771), 1,
      sym_type_argument_defn,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7921), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225333] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11060), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7922), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225391] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8722), 1,
      sym_attributes,
    STATE(8791), 1,
      sym_type_argument_defn,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7923), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225447] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3417), 1,
      anon_sym_GT,
    ACTIONS(3419), 1,
      anon_sym_and,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9508), 1,
      sym_identifier,
    ACTIONS(11437), 1,
      anon_sym_DASH_GT,
    ACTIONS(11439), 1,
      anon_sym_STAR,
    ACTIONS(11441), 1,
      anon_sym_LT2,
    ACTIONS(11443), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(8435), 1,
      aux_sym_compound_type_repeat1,
    STATE(8497), 1,
      sym_long_identifier,
    STATE(8505), 1,
      sym_type_arguments,
    STATE(7924), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225505] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8722), 1,
      sym_attributes,
    STATE(8772), 1,
      sym_type_argument_defn,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7925), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225561] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8722), 1,
      sym_attributes,
    STATE(8763), 1,
      sym_type_argument_defn,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7926), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225617] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8711), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7927), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225673] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3562), 2,
      anon_sym_with,
      sym_identifier,
    STATE(7928), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3560), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [225715] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(10453), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7929), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225773] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3551), 2,
      anon_sym_with,
      sym_identifier,
    STATE(7930), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3549), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [225815] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7904), 1,
      anon_sym_COLON,
    ACTIONS(11331), 1,
      anon_sym_and,
    STATE(7866), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(7931), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7906), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [225861] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8127), 1,
      anon_sym_COLON,
    STATE(7854), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(7932), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8129), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [225905] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11076), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7933), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225963] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11836), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11838), 1,
      anon_sym_DQUOTEB,
    STATE(7955), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7934), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226013] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8722), 1,
      sym_attributes,
    STATE(8725), 1,
      sym_type_argument_defn,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7935), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226069] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9730), 1,
      anon_sym_LT2,
    ACTIONS(9732), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(9772), 1,
      anon_sym_DASH_GT,
    ACTIONS(9774), 1,
      anon_sym_STAR,
    ACTIONS(11525), 1,
      sym_identifier,
    STATE(6501), 1,
      aux_sym_compound_type_repeat1,
    STATE(6558), 1,
      sym_long_identifier,
    STATE(6573), 1,
      sym_type_arguments,
    ACTIONS(11840), 2,
      sym__newline,
      sym__dedent,
    STATE(7936), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226125] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8722), 1,
      sym_attributes,
    STATE(8800), 1,
      sym_type_argument_defn,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7937), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226181] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8722), 1,
      sym_attributes,
    STATE(8778), 1,
      sym_type_argument_defn,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7938), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226237] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8134), 1,
      anon_sym_COLON,
    STATE(7854), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(7939), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8136), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [226281] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11842), 1,
      anon_sym_EQ,
    ACTIONS(11844), 1,
      anon_sym_with,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(7940), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226339] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8722), 1,
      sym_attributes,
    STATE(8730), 1,
      sym_type_argument_defn,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7941), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226395] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11072), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7942), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226453] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11846), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11848), 1,
      anon_sym_DQUOTEB,
    STATE(7954), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7943), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226503] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8138), 1,
      anon_sym_COLON,
    STATE(7854), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(7944), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8140), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [226547] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(10750), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7945), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226605] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11372), 1,
      anon_sym_or,
    STATE(7650), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(3498), 2,
      anon_sym_and,
      sym_identifier,
    STATE(7946), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 6,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [226651] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(11850), 1,
      anon_sym_inline,
    STATE(3327), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6590), 1,
      sym_method_or_prop_defn,
    STATE(8456), 1,
      sym_access_modifier,
    STATE(7947), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226709] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3728), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7948), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3726), 9,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_f,
      aux_sym_decimal_token1,
  [226751] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9709), 1,
      anon_sym_new,
    ACTIONS(11067), 1,
      anon_sym_val,
    ACTIONS(11854), 1,
      anon_sym_static,
    ACTIONS(11856), 1,
      anon_sym_member,
    ACTIONS(11858), 1,
      anon_sym_abstract,
    STATE(7551), 1,
      sym_additional_constr_defn,
    STATE(11862), 1,
      sym_access_modifier,
    ACTIONS(11852), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(7949), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226807] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3480), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7950), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3478), 9,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_or,
  [226849] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11064), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7951), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226907] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(6195), 1,
      aux_sym_attributes_repeat1,
    STATE(6370), 1,
      sym__attribute_set,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(8657), 1,
      sym_type_argument_defn,
    STATE(8722), 1,
      sym_attributes,
    STATE(9058), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7952), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226963] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11384), 1,
      sym_identifier,
    ACTIONS(11386), 1,
      anon_sym_LPAREN,
    ACTIONS(11388), 1,
      anon_sym__,
    ACTIONS(11860), 1,
      anon_sym_POUND,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(7438), 1,
      sym_long_identifier,
    STATE(7447), 1,
      sym_type_argument,
    STATE(7450), 1,
      sym_atomic_type,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(7953), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227019] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11862), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11864), 1,
      anon_sym_DQUOTEB,
    STATE(7645), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7954), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227069] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11866), 1,
      anon_sym_DQUOTE2,
    ACTIONS(11868), 1,
      anon_sym_DQUOTEB,
    STATE(7645), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8515), 1,
      sym__verbatim_string_char,
    STATE(8527), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(11339), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(11337), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(7955), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227119] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9048), 1,
      sym_record_field,
    STATE(11068), 1,
      sym_record_fields,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(7956), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227177] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(11870), 1,
      anon_sym_GT,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(7957), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227232] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8051), 1,
      anon_sym_COLON,
    STATE(7958), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8053), 8,
      sym__newline,
      sym__dedent,
      anon_sym_and,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [227273] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4078), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7959), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4076), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [227314] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(11872), 1,
      anon_sym_COMMA,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(7960), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227369] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3444), 1,
      sym_property_or_ident,
    STATE(3814), 1,
      sym_method_or_prop_defn,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(8554), 1,
      sym_access_modifier,
    STATE(7961), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227424] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(11874), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(7962), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227479] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3480), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7963), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3478), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
  [227520] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(11876), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(7964), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227575] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(11878), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(7965), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227630] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3327), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6590), 1,
      sym_method_or_prop_defn,
    STATE(8456), 1,
      sym_access_modifier,
    STATE(7966), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227685] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3403), 1,
      anon_sym_POUNDendif,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11880), 1,
      sym_identifier,
    ACTIONS(11882), 1,
      anon_sym_DASH_GT,
    ACTIONS(11884), 1,
      anon_sym_STAR,
    ACTIONS(11886), 1,
      anon_sym_LT2,
    ACTIONS(11888), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(8524), 1,
      aux_sym_compound_type_repeat1,
    STATE(8574), 1,
      sym_long_identifier,
    STATE(8577), 1,
      sym_type_arguments,
    STATE(7967), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227740] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11890), 1,
      anon_sym_DOT,
    ACTIONS(3487), 2,
      anon_sym_and,
      sym_identifier,
    ACTIONS(3485), 5,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    STATE(7968), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
  [227783] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(11893), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(7969), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227838] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8201), 1,
      anon_sym_COLON,
    STATE(7970), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8203), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [227879] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(11895), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(7971), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227934] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3954), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7972), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3952), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [227975] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(11897), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(7973), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [228030] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8205), 1,
      anon_sym_COLON,
    STATE(7974), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8207), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [228071] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3950), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7975), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3948), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [228112] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(11899), 1,
      anon_sym_GT,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(7976), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [228167] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(11901), 1,
      anon_sym_COMMA,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(7977), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [228222] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(11903), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(7978), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [228277] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(11905), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(7979), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [228332] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11907), 1,
      anon_sym_COLON,
    ACTIONS(11909), 1,
      anon_sym_COMMA,
    ACTIONS(11911), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11913), 1,
      anon_sym_PIPE,
    ACTIONS(11915), 1,
      anon_sym_AMP,
    ACTIONS(11917), 1,
      anon_sym_DASH_GT,
    ACTIONS(11919), 1,
      anon_sym_when,
    STATE(8259), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(7980), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [228387] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3476), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11921), 1,
      anon_sym_or,
    STATE(8002), 1,
      aux_sym_type_argument_repeat1,
    STATE(7981), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3474), 6,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
  [228432] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3935), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7982), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3933), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [228473] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(11923), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(7983), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [228528] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3327), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6609), 1,
      sym_method_or_prop_defn,
    STATE(8466), 1,
      sym_access_modifier,
    STATE(7984), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [228583] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(11925), 1,
      anon_sym_GT,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(7985), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [228638] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9360), 4,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_POUND,
      sym_identifier,
    STATE(7986), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9362), 5,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
      anon_sym_CARET,
      anon_sym_SQUOTE,
  [228679] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7963), 1,
      anon_sym_COLON,
    STATE(8259), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(7987), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7965), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
  [228722] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11927), 1,
      anon_sym_LPAREN,
    ACTIONS(11931), 1,
      anon_sym_not,
    ACTIONS(11933), 1,
      anon_sym_enum,
    ACTIONS(11935), 1,
      anon_sym_delegate,
    STATE(7988), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(11929), 5,
      anon_sym_null,
      anon_sym_struct,
      anon_sym_unmanaged,
      anon_sym_equality,
      anon_sym_comparison,
  [228769] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11907), 1,
      anon_sym_COLON,
    ACTIONS(11909), 1,
      anon_sym_COMMA,
    ACTIONS(11911), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11913), 1,
      anon_sym_PIPE,
    ACTIONS(11915), 1,
      anon_sym_AMP,
    ACTIONS(11937), 1,
      anon_sym_DASH_GT,
    ACTIONS(11939), 1,
      anon_sym_when,
    STATE(8259), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(7989), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [228824] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(11941), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(7990), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [228879] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11723), 1,
      anon_sym_COMMA,
    ACTIONS(11754), 1,
      anon_sym_as,
    ACTIONS(11756), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11758), 1,
      anon_sym_PIPE,
    ACTIONS(11760), 1,
      anon_sym_AMP,
    ACTIONS(11943), 1,
      anon_sym_COLON,
    ACTIONS(11945), 1,
      anon_sym_RPAREN,
    ACTIONS(11947), 1,
      sym__newline,
    STATE(7854), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(7991), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [228934] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3447), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6803), 1,
      sym_method_or_prop_defn,
    STATE(8482), 1,
      sym_access_modifier,
    STATE(7992), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [228989] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8209), 1,
      anon_sym_COLON,
    STATE(7993), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8211), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [229030] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(11949), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(7994), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [229085] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7985), 1,
      anon_sym_COLON,
    ACTIONS(11541), 1,
      anon_sym_COMMA,
    STATE(8147), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(7995), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7987), 6,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [229130] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7995), 1,
      anon_sym_COLON,
    STATE(7995), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(7996), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7997), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [229173] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3885), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7997), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3883), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [229214] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11951), 1,
      anon_sym_LPAREN,
    ACTIONS(11955), 1,
      anon_sym_not,
    ACTIONS(11957), 1,
      anon_sym_enum,
    ACTIONS(11959), 1,
      anon_sym_delegate,
    STATE(7998), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(11953), 5,
      anon_sym_null,
      anon_sym_struct,
      anon_sym_unmanaged,
      anon_sym_equality,
      anon_sym_comparison,
  [229261] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(11961), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(7999), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [229316] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(11963), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8000), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [229371] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4130), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8001), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4128), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [229412] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3480), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11965), 1,
      anon_sym_or,
    STATE(8002), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(3478), 6,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
  [229455] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(11968), 1,
      anon_sym_GT,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8003), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [229510] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(11970), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8004), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [229565] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11907), 1,
      anon_sym_COLON,
    ACTIONS(11909), 1,
      anon_sym_COMMA,
    ACTIONS(11911), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11913), 1,
      anon_sym_PIPE,
    ACTIONS(11915), 1,
      anon_sym_AMP,
    ACTIONS(11972), 1,
      anon_sym_DASH_GT,
    ACTIONS(11974), 1,
      anon_sym_when,
    STATE(8259), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8005), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [229620] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(11976), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8006), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [229675] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7989), 1,
      anon_sym_COLON,
    ACTIONS(11978), 1,
      anon_sym_LT2,
    STATE(8007), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7991), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [229718] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3447), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6866), 1,
      sym_method_or_prop_defn,
    STATE(8468), 1,
      sym_access_modifier,
    STATE(8008), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [229773] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(11980), 1,
      anon_sym_GT,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8009), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [229828] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8057), 1,
      anon_sym_COLON,
    STATE(8010), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8059), 8,
      sym__newline,
      sym__dedent,
      anon_sym_and,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [229869] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3447), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6907), 1,
      sym_method_or_prop_defn,
    STATE(8457), 1,
      sym_access_modifier,
    STATE(8011), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [229924] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(11982), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8012), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [229979] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3444), 1,
      sym_property_or_ident,
    STATE(3810), 1,
      sym_method_or_prop_defn,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(8525), 1,
      sym_access_modifier,
    STATE(8013), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [230034] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4104), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8014), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4102), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [230075] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7908), 1,
      anon_sym_COLON,
    ACTIONS(11984), 1,
      anon_sym_and,
    STATE(8015), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(7910), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
  [230118] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7963), 1,
      anon_sym_COLON,
    STATE(7995), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8016), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7965), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [230161] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3193), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8017), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3191), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [230202] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3446), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6954), 1,
      sym_method_or_prop_defn,
    STATE(8538), 1,
      sym_access_modifier,
    STATE(8018), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [230257] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3490), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6881), 1,
      sym_method_or_prop_defn,
    STATE(8490), 1,
      sym_access_modifier,
    STATE(8019), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [230312] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3205), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6320), 1,
      sym_method_or_prop_defn,
    STATE(8512), 1,
      sym_access_modifier,
    STATE(8020), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [230367] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8377), 1,
      anon_sym_COLON,
    ACTIONS(11987), 1,
      anon_sym_as,
    STATE(8021), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8379), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [230410] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3444), 1,
      sym_property_or_ident,
    STATE(3762), 1,
      sym_method_or_prop_defn,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(8443), 1,
      sym_access_modifier,
    STATE(8022), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [230465] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9314), 4,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_new,
      sym_identifier,
    STATE(8023), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9316), 5,
      anon_sym_LBRACK_LT,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_CARET,
      anon_sym_SQUOTE,
  [230506] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(11989), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8024), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [230561] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3425), 1,
      anon_sym_POUNDendif,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11880), 1,
      sym_identifier,
    ACTIONS(11882), 1,
      anon_sym_DASH_GT,
    ACTIONS(11884), 1,
      anon_sym_STAR,
    ACTIONS(11886), 1,
      anon_sym_LT2,
    ACTIONS(11888), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(8524), 1,
      aux_sym_compound_type_repeat1,
    STATE(8574), 1,
      sym_long_identifier,
    STATE(8577), 1,
      sym_type_arguments,
    STATE(8025), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [230616] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(11991), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8026), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [230671] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(11993), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8027), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [230726] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(11995), 1,
      anon_sym_GT,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8028), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [230781] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(11997), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8029), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [230836] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(11999), 1,
      anon_sym_GT,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8030), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [230891] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8355), 1,
      anon_sym_COLON,
    STATE(8031), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8357), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [230932] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3327), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6563), 1,
      sym_method_or_prop_defn,
    STATE(8446), 1,
      sym_access_modifier,
    STATE(8032), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [230987] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12001), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8033), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [231042] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3429), 1,
      anon_sym_POUNDendif,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11880), 1,
      sym_identifier,
    ACTIONS(11882), 1,
      anon_sym_DASH_GT,
    ACTIONS(11884), 1,
      anon_sym_STAR,
    ACTIONS(11886), 1,
      anon_sym_LT2,
    ACTIONS(11888), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(8524), 1,
      aux_sym_compound_type_repeat1,
    STATE(8574), 1,
      sym_long_identifier,
    STATE(8577), 1,
      sym_type_arguments,
    STATE(8034), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [231097] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12003), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8035), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [231152] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12005), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8036), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [231207] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12007), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8037), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [231262] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12009), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8038), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [231317] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12011), 4,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_POUND,
      sym_identifier,
    STATE(8039), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(12013), 5,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
      anon_sym_CARET,
      anon_sym_SQUOTE,
  [231358] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12015), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8040), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [231413] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12017), 1,
      anon_sym_LBRACK_LT,
    STATE(8480), 1,
      sym__attribute_set,
    ACTIONS(9020), 3,
      anon_sym_mutable,
      anon_sym__,
      sym_identifier,
    ACTIONS(9025), 3,
      aux_sym_access_modifier_token1,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8041), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_attributes_repeat1,
  [231458] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12020), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8042), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [231513] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12022), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8043), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [231568] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3205), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6322), 1,
      sym_method_or_prop_defn,
    STATE(8474), 1,
      sym_access_modifier,
    STATE(8044), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [231623] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9666), 1,
      anon_sym_DASH_GT,
    ACTIONS(9668), 1,
      anon_sym_STAR,
    ACTIONS(9670), 1,
      anon_sym_LT2,
    ACTIONS(9672), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(12024), 1,
      sym_identifier,
    ACTIONS(12026), 1,
      sym__dedent,
    STATE(6416), 1,
      aux_sym_compound_type_repeat1,
    STATE(6698), 1,
      sym_type_arguments,
    STATE(6730), 1,
      sym_long_identifier,
    STATE(8045), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [231678] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12028), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8046), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [231733] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12030), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8047), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [231788] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7904), 1,
      anon_sym_COLON,
    ACTIONS(12032), 1,
      anon_sym_and,
    STATE(8015), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(8048), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7906), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
  [231833] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11723), 1,
      anon_sym_COMMA,
    ACTIONS(11754), 1,
      anon_sym_as,
    ACTIONS(11756), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11758), 1,
      anon_sym_PIPE,
    ACTIONS(11760), 1,
      anon_sym_AMP,
    ACTIONS(11943), 1,
      anon_sym_COLON,
    ACTIONS(11947), 1,
      sym__newline,
    ACTIONS(12034), 1,
      anon_sym_RPAREN,
    STATE(7854), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8049), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [231888] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12036), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8050), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [231943] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12038), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8051), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [231998] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8383), 1,
      anon_sym_COLON,
    STATE(8052), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8385), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [232039] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7989), 1,
      anon_sym_COLON,
    STATE(8053), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7991), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [232080] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12040), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8054), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [232135] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11907), 1,
      anon_sym_COLON,
    ACTIONS(11909), 1,
      anon_sym_COMMA,
    ACTIONS(11911), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11913), 1,
      anon_sym_PIPE,
    ACTIONS(11915), 1,
      anon_sym_AMP,
    ACTIONS(12042), 1,
      anon_sym_DASH_GT,
    ACTIONS(12044), 1,
      anon_sym_when,
    STATE(8259), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8055), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [232190] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9666), 1,
      anon_sym_DASH_GT,
    ACTIONS(9668), 1,
      anon_sym_STAR,
    ACTIONS(9670), 1,
      anon_sym_LT2,
    ACTIONS(9672), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(12024), 1,
      sym_identifier,
    ACTIONS(12046), 1,
      sym__dedent,
    STATE(6416), 1,
      aux_sym_compound_type_repeat1,
    STATE(6698), 1,
      sym_type_arguments,
    STATE(6730), 1,
      sym_long_identifier,
    STATE(8056), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [232245] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12048), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8057), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [232300] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3360), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(7627), 1,
      sym_method_or_prop_defn,
    STATE(8553), 1,
      sym_access_modifier,
    STATE(8058), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [232355] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12050), 1,
      sym_identifier,
    STATE(6313), 1,
      sym_long_identifier,
    STATE(8448), 1,
      sym_access_modifier,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(11546), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8059), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [232408] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12052), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8060), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [232463] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11907), 1,
      anon_sym_COLON,
    ACTIONS(11909), 1,
      anon_sym_COMMA,
    ACTIONS(11911), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11913), 1,
      anon_sym_PIPE,
    ACTIONS(11915), 1,
      anon_sym_AMP,
    ACTIONS(12054), 1,
      anon_sym_DASH_GT,
    ACTIONS(12056), 1,
      anon_sym_when,
    STATE(8259), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8061), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [232518] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8158), 1,
      anon_sym_COLON,
    STATE(8259), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8062), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8160), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
  [232561] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12058), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8063), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [232616] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11723), 1,
      anon_sym_COMMA,
    ACTIONS(11754), 1,
      anon_sym_as,
    ACTIONS(11756), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11758), 1,
      anon_sym_PIPE,
    ACTIONS(11760), 1,
      anon_sym_AMP,
    ACTIONS(11943), 1,
      anon_sym_COLON,
    ACTIONS(11947), 1,
      sym__newline,
    ACTIONS(12060), 1,
      anon_sym_RPAREN,
    STATE(7854), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8064), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [232671] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3927), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8065), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3925), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [232712] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3946), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8066), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3944), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [232753] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12062), 1,
      anon_sym_COMMA,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8067), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [232808] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12064), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8068), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [232863] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12066), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8069), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [232918] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11723), 1,
      anon_sym_COMMA,
    ACTIONS(11754), 1,
      anon_sym_as,
    ACTIONS(11756), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11758), 1,
      anon_sym_PIPE,
    ACTIONS(11760), 1,
      anon_sym_AMP,
    ACTIONS(11943), 1,
      anon_sym_COLON,
    ACTIONS(11947), 1,
      sym__newline,
    ACTIONS(12068), 1,
      anon_sym_RPAREN,
    STATE(7854), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8070), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [232973] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12070), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8071), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [233028] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12072), 1,
      anon_sym_DOT,
    STATE(8239), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3494), 2,
      anon_sym_and,
      sym_identifier,
    STATE(8072), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 5,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [233073] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3327), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6717), 1,
      sym_method_or_prop_defn,
    STATE(8445), 1,
      sym_access_modifier,
    STATE(8073), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [233128] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12074), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8074), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [233183] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3447), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6868), 1,
      sym_method_or_prop_defn,
    STATE(8441), 1,
      sym_access_modifier,
    STATE(8075), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [233238] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3511), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8076), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3509), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
  [233279] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(8077), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8402), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [233320] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12076), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8078), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [233375] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12078), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8079), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [233430] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12080), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8080), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [233485] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12082), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8081), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [233540] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12084), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8082), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [233595] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12086), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8083), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [233650] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8288), 1,
      anon_sym_COLON,
    STATE(8084), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8290), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [233691] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3358), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(7585), 1,
      sym_method_or_prop_defn,
    STATE(8548), 1,
      sym_access_modifier,
    STATE(8085), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [233746] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12088), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8086), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [233801] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8284), 1,
      anon_sym_COLON,
    STATE(8087), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8286), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [233842] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8043), 1,
      anon_sym_COLON,
    STATE(8088), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8045), 8,
      sym__newline,
      sym__dedent,
      anon_sym_and,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [233883] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12090), 1,
      anon_sym_DOT,
    STATE(8282), 1,
      aux_sym_long_identifier_repeat1,
    STATE(8089), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 7,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [233926] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12092), 1,
      anon_sym_COMMA,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8090), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [233981] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11907), 1,
      anon_sym_COLON,
    ACTIONS(11909), 1,
      anon_sym_COMMA,
    ACTIONS(11911), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11913), 1,
      anon_sym_PIPE,
    ACTIONS(11915), 1,
      anon_sym_AMP,
    ACTIONS(12094), 1,
      anon_sym_DASH_GT,
    ACTIONS(12096), 1,
      anon_sym_when,
    STATE(8259), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8091), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [234036] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3358), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(7609), 1,
      sym_method_or_prop_defn,
    STATE(8539), 1,
      sym_access_modifier,
    STATE(8092), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [234091] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3360), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(7625), 1,
      sym_method_or_prop_defn,
    STATE(8561), 1,
      sym_access_modifier,
    STATE(8093), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [234146] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3958), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8094), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3956), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [234187] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7279), 1,
      anon_sym_COLON,
    STATE(8095), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7281), 8,
      sym__newline,
      sym__dedent,
      anon_sym_and,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [234228] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12098), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8096), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [234283] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12100), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8097), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [234338] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11907), 1,
      anon_sym_COLON,
    ACTIONS(11909), 1,
      anon_sym_COMMA,
    ACTIONS(11911), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11913), 1,
      anon_sym_PIPE,
    ACTIONS(11915), 1,
      anon_sym_AMP,
    ACTIONS(12102), 1,
      anon_sym_DASH_GT,
    ACTIONS(12104), 1,
      anon_sym_when,
    STATE(8259), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8098), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [234393] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12106), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8099), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [234448] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3962), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8100), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3960), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [234489] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12108), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8101), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [234544] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11723), 1,
      anon_sym_COMMA,
    ACTIONS(11754), 1,
      anon_sym_as,
    ACTIONS(11756), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11758), 1,
      anon_sym_PIPE,
    ACTIONS(11760), 1,
      anon_sym_AMP,
    ACTIONS(11943), 1,
      anon_sym_COLON,
    STATE(7854), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(12110), 2,
      sym__newline,
      anon_sym_RPAREN,
    STATE(8102), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [234597] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12112), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8103), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [234652] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12114), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8104), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [234707] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12116), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8105), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [234762] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12118), 1,
      anon_sym_GT,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8106), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [234817] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9386), 4,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_POUND,
      sym_identifier,
    STATE(8107), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9388), 5,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
      anon_sym_CARET,
      anon_sym_SQUOTE,
  [234858] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8127), 1,
      anon_sym_COLON,
    STATE(7995), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8108), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8129), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [234901] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3490), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6808), 1,
      sym_method_or_prop_defn,
    STATE(8563), 1,
      sym_access_modifier,
    STATE(8109), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [234956] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12120), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8110), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [235011] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(11364), 1,
      sym_identifier,
    ACTIONS(11366), 1,
      anon_sym_mutable,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8820), 1,
      sym_attributes,
    STATE(9605), 1,
      sym_record_field,
    STATE(11191), 1,
      sym_access_modifier,
    STATE(8111), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [235066] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12122), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8112), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [235121] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8134), 1,
      anon_sym_COLON,
    STATE(7995), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8113), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8136), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [235164] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11723), 1,
      anon_sym_COMMA,
    ACTIONS(11754), 1,
      anon_sym_as,
    ACTIONS(11756), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11758), 1,
      anon_sym_PIPE,
    ACTIONS(11760), 1,
      anon_sym_AMP,
    ACTIONS(11943), 1,
      anon_sym_COLON,
    STATE(7854), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(11947), 2,
      sym__newline,
      anon_sym_RPAREN,
    STATE(8114), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [235217] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3976), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8115), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3974), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [235258] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(11358), 1,
      anon_sym_DQUOTE2,
    STATE(8585), 1,
      sym__verbatim_string_char,
    STATE(8586), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(12127), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(12124), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(8116), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_verbatim_string_repeat1,
  [235303] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12130), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8117), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [235358] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12132), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8118), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [235413] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8138), 1,
      anon_sym_COLON,
    STATE(7995), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8119), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8140), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [235456] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12134), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8120), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [235511] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3417), 1,
      anon_sym_POUNDendif,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11880), 1,
      sym_identifier,
    ACTIONS(11882), 1,
      anon_sym_DASH_GT,
    ACTIONS(11884), 1,
      anon_sym_STAR,
    ACTIONS(11886), 1,
      anon_sym_LT2,
    ACTIONS(11888), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(8524), 1,
      aux_sym_compound_type_repeat1,
    STATE(8574), 1,
      sym_long_identifier,
    STATE(8577), 1,
      sym_type_arguments,
    STATE(8121), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [235566] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11537), 1,
      anon_sym_COLON,
    ACTIONS(11539), 1,
      anon_sym_as,
    ACTIONS(11541), 1,
      anon_sym_COMMA,
    ACTIONS(11543), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11545), 1,
      anon_sym_PIPE,
    ACTIONS(11547), 1,
      anon_sym_AMP,
    STATE(7995), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(12136), 2,
      sym__newline,
      sym__dedent,
    STATE(8122), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [235619] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3444), 1,
      sym_property_or_ident,
    STATE(3798), 1,
      sym_method_or_prop_defn,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(8529), 1,
      sym_access_modifier,
    STATE(8123), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [235674] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3480), 3,
      anon_sym_and,
      anon_sym_or,
      sym_identifier,
    STATE(8124), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3478), 6,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [235715] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8158), 1,
      anon_sym_COLON,
    STATE(7995), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8125), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8160), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [235758] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3360), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(7597), 1,
      sym_method_or_prop_defn,
    STATE(8542), 1,
      sym_access_modifier,
    STATE(8126), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [235813] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9666), 1,
      anon_sym_DASH_GT,
    ACTIONS(9668), 1,
      anon_sym_STAR,
    ACTIONS(9670), 1,
      anon_sym_LT2,
    ACTIONS(9672), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(12024), 1,
      sym_identifier,
    ACTIONS(12138), 1,
      sym__dedent,
    STATE(6416), 1,
      aux_sym_compound_type_repeat1,
    STATE(6698), 1,
      sym_type_arguments,
    STATE(6730), 1,
      sym_long_identifier,
    STATE(8127), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [235868] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9666), 1,
      anon_sym_DASH_GT,
    ACTIONS(9668), 1,
      anon_sym_STAR,
    ACTIONS(9670), 1,
      anon_sym_LT2,
    ACTIONS(9672), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(12024), 1,
      sym_identifier,
    ACTIONS(12140), 1,
      sym__dedent,
    STATE(6416), 1,
      aux_sym_compound_type_repeat1,
    STATE(6698), 1,
      sym_type_arguments,
    STATE(6730), 1,
      sym_long_identifier,
    STATE(8128), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [235923] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12142), 1,
      anon_sym_LPAREN,
    ACTIONS(12146), 1,
      anon_sym_not,
    ACTIONS(12148), 1,
      anon_sym_enum,
    ACTIONS(12150), 1,
      anon_sym_delegate,
    STATE(8129), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(12144), 5,
      anon_sym_null,
      anon_sym_struct,
      anon_sym_unmanaged,
      anon_sym_equality,
      anon_sym_comparison,
  [235970] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8164), 1,
      anon_sym_COLON,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11909), 1,
      anon_sym_COMMA,
    ACTIONS(11911), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11913), 1,
      anon_sym_PIPE,
    ACTIONS(11915), 1,
      anon_sym_AMP,
    STATE(8259), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(8166), 2,
      anon_sym_DASH_GT,
      anon_sym_when,
    STATE(8130), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [236023] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12152), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8131), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [236078] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12154), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8132), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [236133] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12156), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8133), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [236188] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12158), 1,
      anon_sym_GT,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8134), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [236243] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8127), 1,
      anon_sym_COLON,
    ACTIONS(12160), 1,
      anon_sym_COMMA,
    STATE(8135), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(8129), 6,
      anon_sym_as,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
  [236286] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12163), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8136), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [236341] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(12167), 4,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
      anon_sym_DQUOTE,
    STATE(8137), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(12165), 5,
      sym__inside_string_marker,
      sym__escape_char,
      sym__non_escape_char,
      aux_sym__simple_string_char_token1,
      anon_sym_DQUOTEB,
  [236380] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12169), 1,
      anon_sym_GT,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8138), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [236435] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3972), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8139), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3970), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [236476] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8373), 1,
      anon_sym_COLON,
    STATE(8140), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8375), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [236517] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12171), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8141), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [236572] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12173), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8142), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [236627] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3205), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6342), 1,
      sym_method_or_prop_defn,
    STATE(8473), 1,
      sym_access_modifier,
    STATE(8143), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [236682] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(12175), 4,
      sym__inside_string_marker,
      sym__escape_char,
      sym__non_escape_char,
      anon_sym_LBRACE2,
    STATE(8144), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(12177), 5,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
      aux_sym__simple_string_char_token1,
      anon_sym_DQUOTE,
  [236721] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12179), 1,
      anon_sym_GT,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8145), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [236776] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(12181), 4,
      sym__inside_string_marker,
      sym__escape_char,
      sym__non_escape_char,
      anon_sym_LBRACE2,
    STATE(8146), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(12183), 5,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
      aux_sym__simple_string_char_token1,
      anon_sym_DQUOTE,
  [236815] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8127), 1,
      anon_sym_COLON,
    ACTIONS(12185), 1,
      anon_sym_COMMA,
    STATE(8147), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(8129), 6,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [236858] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12188), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8148), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [236913] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(12194), 1,
      anon_sym_DQUOTE2,
    STATE(8180), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8585), 1,
      sym__verbatim_string_char,
    STATE(8586), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(12192), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(12190), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(8149), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [236960] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12196), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8150), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [237015] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12198), 1,
      anon_sym_GT,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8151), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [237070] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3446), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6968), 1,
      sym_method_or_prop_defn,
    STATE(8562), 1,
      sym_access_modifier,
    STATE(8152), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [237125] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12200), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8153), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [237180] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3360), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(7589), 1,
      sym_method_or_prop_defn,
    STATE(8523), 1,
      sym_access_modifier,
    STATE(8154), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [237235] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(12202), 4,
      sym__inside_string_marker,
      sym__escape_char,
      sym__non_escape_char,
      anon_sym_LBRACE2,
    STATE(8155), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(12204), 5,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
      aux_sym__simple_string_char_token1,
      anon_sym_DQUOTE,
  [237274] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    STATE(8041), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    ACTIONS(9005), 3,
      anon_sym_mutable,
      anon_sym__,
      sym_identifier,
    ACTIONS(9007), 3,
      aux_sym_access_modifier_token1,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8156), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [237321] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12206), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8157), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [237376] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12208), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8158), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [237431] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3511), 3,
      anon_sym_and,
      anon_sym_or,
      sym_identifier,
    STATE(8159), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3509), 6,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [237472] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4170), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8160), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4168), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [237513] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8138), 1,
      anon_sym_COLON,
    STATE(8259), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8161), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8140), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
  [237556] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12210), 1,
      anon_sym_LPAREN,
    ACTIONS(12214), 1,
      anon_sym_not,
    ACTIONS(12216), 1,
      anon_sym_enum,
    ACTIONS(12218), 1,
      anon_sym_delegate,
    STATE(8162), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(12212), 5,
      anon_sym_null,
      anon_sym_struct,
      anon_sym_unmanaged,
      anon_sym_equality,
      anon_sym_comparison,
  [237603] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8164), 1,
      anon_sym_COLON,
    ACTIONS(11539), 1,
      anon_sym_as,
    ACTIONS(11541), 1,
      anon_sym_COMMA,
    ACTIONS(11543), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11545), 1,
      anon_sym_PIPE,
    ACTIONS(11547), 1,
      anon_sym_AMP,
    STATE(7995), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(8166), 2,
      sym__newline,
      sym__dedent,
    STATE(8163), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [237656] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8432), 1,
      anon_sym_COLON,
    STATE(8164), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8434), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [237697] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8241), 1,
      anon_sym_COLON,
    STATE(8165), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8243), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [237738] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11907), 1,
      anon_sym_COLON,
    ACTIONS(11909), 1,
      anon_sym_COMMA,
    ACTIONS(11911), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11913), 1,
      anon_sym_PIPE,
    ACTIONS(11915), 1,
      anon_sym_AMP,
    ACTIONS(12220), 1,
      anon_sym_DASH_GT,
    ACTIONS(12222), 1,
      anon_sym_when,
    STATE(8259), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8166), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [237793] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12224), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8167), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [237848] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12226), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8168), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [237903] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12228), 1,
      anon_sym_COMMA,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8169), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [237958] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8134), 1,
      anon_sym_COLON,
    STATE(8259), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8170), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8136), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
  [238001] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(12230), 4,
      sym__inside_string_marker,
      sym__escape_char,
      sym__non_escape_char,
      anon_sym_LBRACE2,
    STATE(8171), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(12232), 5,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
      aux_sym__simple_string_char_token1,
      anon_sym_DQUOTE,
  [238040] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12234), 1,
      anon_sym_LPAREN,
    ACTIONS(12238), 1,
      anon_sym_not,
    ACTIONS(12240), 1,
      anon_sym_enum,
    ACTIONS(12242), 1,
      anon_sym_delegate,
    STATE(8172), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(12236), 5,
      anon_sym_null,
      anon_sym_struct,
      anon_sym_unmanaged,
      anon_sym_equality,
      anon_sym_comparison,
  [238087] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8369), 1,
      anon_sym_COLON,
    STATE(8173), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8371), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [238128] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12244), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8174), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [238183] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11723), 1,
      anon_sym_COMMA,
    ACTIONS(11754), 1,
      anon_sym_as,
    ACTIONS(11756), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11758), 1,
      anon_sym_PIPE,
    ACTIONS(11760), 1,
      anon_sym_AMP,
    ACTIONS(11943), 1,
      anon_sym_COLON,
    STATE(7854), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(12246), 2,
      sym__newline,
      anon_sym_RBRACE,
    STATE(8175), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [238236] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12248), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8176), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [238291] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3498), 1,
      sym_identifier,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11921), 1,
      anon_sym_or,
    STATE(7981), 1,
      aux_sym_type_argument_repeat1,
    STATE(8177), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 6,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
  [238336] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12250), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8178), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [238391] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12252), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8179), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [238446] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(12254), 1,
      anon_sym_DQUOTE2,
    STATE(8116), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(8585), 1,
      sym__verbatim_string_char,
    STATE(8586), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(12192), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(12190), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(8180), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [238493] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8127), 1,
      anon_sym_COLON,
    STATE(8259), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8181), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8129), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
  [238536] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11907), 1,
      anon_sym_COLON,
    ACTIONS(11909), 1,
      anon_sym_COMMA,
    ACTIONS(11911), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11913), 1,
      anon_sym_PIPE,
    ACTIONS(11915), 1,
      anon_sym_AMP,
    ACTIONS(12256), 1,
      anon_sym_DASH_GT,
    ACTIONS(12258), 1,
      anon_sym_when,
    STATE(8259), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8182), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [238591] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4122), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8183), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4120), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [238632] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12260), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8184), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [238687] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6511), 1,
      anon_sym_POUNDendif,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11880), 1,
      sym_identifier,
    ACTIONS(11882), 1,
      anon_sym_DASH_GT,
    ACTIONS(11884), 1,
      anon_sym_STAR,
    ACTIONS(11886), 1,
      anon_sym_LT2,
    ACTIONS(11888), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(8524), 1,
      aux_sym_compound_type_repeat1,
    STATE(8574), 1,
      sym_long_identifier,
    STATE(8577), 1,
      sym_type_arguments,
    STATE(8185), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [238742] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12262), 1,
      anon_sym_GT,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8186), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [238797] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12264), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8187), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [238852] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12266), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8188), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [238907] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3230), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6680), 1,
      sym_method_or_prop_defn,
    STATE(8450), 1,
      sym_access_modifier,
    STATE(8189), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [238962] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11907), 1,
      anon_sym_COLON,
    ACTIONS(11909), 1,
      anon_sym_COMMA,
    ACTIONS(11911), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11913), 1,
      anon_sym_PIPE,
    ACTIONS(11915), 1,
      anon_sym_AMP,
    ACTIONS(12268), 1,
      anon_sym_DASH_GT,
    ACTIONS(12270), 1,
      anon_sym_when,
    STATE(8259), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8190), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [239017] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7283), 1,
      anon_sym_COLON,
    STATE(8191), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7285), 8,
      sym__newline,
      sym__dedent,
      anon_sym_and,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [239058] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12272), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8192), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [239113] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12274), 1,
      anon_sym_GT,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8193), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [239168] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8245), 1,
      anon_sym_COLON,
    STATE(8194), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8247), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [239209] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12276), 1,
      anon_sym_COMMA,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8195), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [239264] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12278), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8196), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [239319] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12280), 1,
      anon_sym_COMMA,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8197), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [239374] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12282), 1,
      anon_sym_GT,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8198), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [239429] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4064), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8199), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4062), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [239470] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12284), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8200), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [239525] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12286), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8201), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [239580] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12288), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8202), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [239635] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12290), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8203), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [239690] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11907), 1,
      anon_sym_COLON,
    ACTIONS(11909), 1,
      anon_sym_COMMA,
    ACTIONS(11911), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11913), 1,
      anon_sym_PIPE,
    ACTIONS(11915), 1,
      anon_sym_AMP,
    ACTIONS(12292), 1,
      anon_sym_DASH_GT,
    ACTIONS(12294), 1,
      anon_sym_when,
    STATE(8259), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8204), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [239745] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12296), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8205), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [239800] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3996), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8206), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3994), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [239841] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3230), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6656), 1,
      sym_method_or_prop_defn,
    STATE(8458), 1,
      sym_access_modifier,
    STATE(8207), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [239896] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7995), 1,
      anon_sym_COLON,
    STATE(8259), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8208), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7997), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
  [239939] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4003), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8209), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4001), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [239980] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12298), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8210), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [240035] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12300), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8211), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [240090] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12302), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8212), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [240145] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3490), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6780), 1,
      sym_method_or_prop_defn,
    STATE(8514), 1,
      sym_access_modifier,
    STATE(8213), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [240200] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12304), 1,
      anon_sym_GT,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8214), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [240255] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12306), 1,
      anon_sym_DOT,
    STATE(8215), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3485), 7,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [240296] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3230), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6610), 1,
      sym_method_or_prop_defn,
    STATE(8453), 1,
      sym_access_modifier,
    STATE(8216), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [240351] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12309), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8217), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [240406] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12311), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8218), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [240461] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12313), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8219), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [240516] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12315), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8220), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [240571] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3358), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(7551), 1,
      sym_method_or_prop_defn,
    STATE(8558), 1,
      sym_access_modifier,
    STATE(8221), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [240626] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12317), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8222), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [240681] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3446), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6997), 1,
      sym_method_or_prop_defn,
    STATE(8521), 1,
      sym_access_modifier,
    STATE(8223), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [240736] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3394), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6498), 1,
      sym_method_or_prop_defn,
    STATE(8551), 1,
      sym_access_modifier,
    STATE(8224), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [240791] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3845), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8225), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3843), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [240832] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3205), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6350), 1,
      sym_method_or_prop_defn,
    STATE(8467), 1,
      sym_access_modifier,
    STATE(8226), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [240887] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(12204), 4,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
      anon_sym_DQUOTE,
    STATE(8227), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(12202), 5,
      sym__inside_string_marker,
      sym__escape_char,
      sym__non_escape_char,
      aux_sym__simple_string_char_token1,
      anon_sym_DQUOTEB,
  [240926] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(12232), 4,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
      anon_sym_DQUOTE,
    STATE(8228), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(12230), 5,
      sym__inside_string_marker,
      sym__escape_char,
      sym__non_escape_char,
      aux_sym__simple_string_char_token1,
      anon_sym_DQUOTEB,
  [240965] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11723), 1,
      anon_sym_COMMA,
    ACTIONS(11754), 1,
      anon_sym_as,
    ACTIONS(11756), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11758), 1,
      anon_sym_PIPE,
    ACTIONS(11760), 1,
      anon_sym_AMP,
    ACTIONS(11943), 1,
      anon_sym_COLON,
    ACTIONS(11947), 1,
      sym__newline,
    ACTIONS(12319), 1,
      anon_sym_RPAREN,
    STATE(7854), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8229), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [241020] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7908), 1,
      anon_sym_COLON,
    STATE(8230), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7910), 8,
      sym__newline,
      sym__dedent,
      anon_sym_and,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [241061] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12321), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8231), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [241116] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11723), 1,
      anon_sym_COMMA,
    ACTIONS(11754), 1,
      anon_sym_as,
    ACTIONS(11756), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11758), 1,
      anon_sym_PIPE,
    ACTIONS(11760), 1,
      anon_sym_AMP,
    ACTIONS(11943), 1,
      anon_sym_COLON,
    ACTIONS(11947), 1,
      sym__newline,
    ACTIONS(12323), 1,
      anon_sym_RPAREN,
    STATE(7854), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8232), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [241171] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12325), 1,
      anon_sym_LPAREN,
    ACTIONS(12329), 1,
      anon_sym_not,
    ACTIONS(12331), 1,
      anon_sym_enum,
    ACTIONS(12333), 1,
      anon_sym_delegate,
    STATE(8233), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(12327), 5,
      anon_sym_null,
      anon_sym_struct,
      anon_sym_unmanaged,
      anon_sym_equality,
      anon_sym_comparison,
  [241218] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11907), 1,
      anon_sym_COLON,
    ACTIONS(11909), 1,
      anon_sym_COMMA,
    ACTIONS(11911), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11913), 1,
      anon_sym_PIPE,
    ACTIONS(11915), 1,
      anon_sym_AMP,
    ACTIONS(12335), 1,
      anon_sym_DASH_GT,
    ACTIONS(12337), 1,
      anon_sym_when,
    STATE(8259), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8234), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [241273] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3480), 2,
      anon_sym_or,
      sym_identifier,
    STATE(8235), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3478), 7,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [241314] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11723), 1,
      anon_sym_COMMA,
    ACTIONS(11754), 1,
      anon_sym_as,
    ACTIONS(11756), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11758), 1,
      anon_sym_PIPE,
    ACTIONS(11760), 1,
      anon_sym_AMP,
    ACTIONS(11943), 1,
      anon_sym_COLON,
    ACTIONS(11947), 1,
      sym__newline,
    ACTIONS(12339), 1,
      anon_sym_RPAREN,
    STATE(7854), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8236), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [241369] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9414), 4,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_POUND,
      sym_identifier,
    STATE(8237), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(9416), 5,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
      anon_sym_CARET,
      anon_sym_SQUOTE,
  [241410] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12341), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8238), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [241465] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12072), 1,
      anon_sym_DOT,
    STATE(7968), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3451), 2,
      anon_sym_and,
      sym_identifier,
    STATE(8239), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3449), 5,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [241510] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12343), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8240), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [241565] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12345), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8241), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [241620] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11907), 1,
      anon_sym_COLON,
    ACTIONS(11909), 1,
      anon_sym_COMMA,
    ACTIONS(11911), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11913), 1,
      anon_sym_PIPE,
    ACTIONS(11915), 1,
      anon_sym_AMP,
    ACTIONS(12347), 1,
      anon_sym_DASH_GT,
    ACTIONS(12349), 1,
      anon_sym_when,
    STATE(8259), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8242), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [241675] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7945), 1,
      anon_sym_COLON,
    STATE(8243), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7947), 8,
      sym__newline,
      sym__dedent,
      anon_sym_and,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [241716] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3394), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6484), 1,
      sym_method_or_prop_defn,
    STATE(8469), 1,
      sym_access_modifier,
    STATE(8244), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [241771] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11907), 1,
      anon_sym_COLON,
    ACTIONS(11909), 1,
      anon_sym_COMMA,
    ACTIONS(11911), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11913), 1,
      anon_sym_PIPE,
    ACTIONS(11915), 1,
      anon_sym_AMP,
    ACTIONS(12351), 1,
      anon_sym_DASH_GT,
    ACTIONS(12353), 1,
      anon_sym_when,
    STATE(8259), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8245), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [241826] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8251), 1,
      anon_sym_COLON,
    STATE(8246), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8253), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [241867] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12355), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8247), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [241922] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4018), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8248), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4016), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [241963] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4054), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8249), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4052), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [242004] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6507), 1,
      anon_sym_POUNDendif,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11880), 1,
      sym_identifier,
    ACTIONS(11882), 1,
      anon_sym_DASH_GT,
    ACTIONS(11884), 1,
      anon_sym_STAR,
    ACTIONS(11886), 1,
      anon_sym_LT2,
    ACTIONS(11888), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(8524), 1,
      aux_sym_compound_type_repeat1,
    STATE(8574), 1,
      sym_long_identifier,
    STATE(8577), 1,
      sym_type_arguments,
    STATE(8250), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [242059] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11907), 1,
      anon_sym_COLON,
    ACTIONS(11909), 1,
      anon_sym_COMMA,
    ACTIONS(11911), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11913), 1,
      anon_sym_PIPE,
    ACTIONS(11915), 1,
      anon_sym_AMP,
    ACTIONS(12357), 1,
      anon_sym_DASH_GT,
    ACTIONS(12359), 1,
      anon_sym_when,
    STATE(8259), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8251), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [242114] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4126), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8252), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4124), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [242155] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12361), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8253), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [242210] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12363), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8254), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [242265] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12365), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8255), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [242320] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8359), 1,
      anon_sym_COLON,
    STATE(8256), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8361), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [242361] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3446), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(7088), 1,
      sym_method_or_prop_defn,
    STATE(8438), 1,
      sym_access_modifier,
    STATE(8257), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [242416] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8197), 1,
      anon_sym_COLON,
    STATE(8258), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8199), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [242457] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7985), 1,
      anon_sym_COLON,
    ACTIONS(11909), 1,
      anon_sym_COMMA,
    STATE(8135), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8259), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7987), 6,
      anon_sym_as,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
  [242502] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12367), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8260), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [242557] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12369), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8261), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [242612] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4082), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8262), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4080), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [242653] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12371), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8263), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [242708] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12373), 1,
      anon_sym_LPAREN,
    ACTIONS(12377), 1,
      anon_sym_not,
    ACTIONS(12379), 1,
      anon_sym_enum,
    ACTIONS(12381), 1,
      anon_sym_delegate,
    STATE(8264), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(12375), 5,
      anon_sym_null,
      anon_sym_struct,
      anon_sym_unmanaged,
      anon_sym_equality,
      anon_sym_comparison,
  [242755] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4232), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8265), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4230), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [242796] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12383), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8266), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [242851] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3498), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8267), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [242892] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4118), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8268), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4116), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [242933] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4086), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8269), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4084), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [242974] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11723), 1,
      anon_sym_COMMA,
    ACTIONS(11754), 1,
      anon_sym_as,
    ACTIONS(11756), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11758), 1,
      anon_sym_PIPE,
    ACTIONS(11760), 1,
      anon_sym_AMP,
    ACTIONS(11943), 1,
      anon_sym_COLON,
    ACTIONS(11947), 1,
      sym__newline,
    ACTIONS(12385), 1,
      anon_sym_RPAREN,
    STATE(7854), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8270), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [243029] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3230), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6601), 1,
      sym_method_or_prop_defn,
    STATE(8454), 1,
      sym_access_modifier,
    STATE(8271), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [243084] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11907), 1,
      anon_sym_COLON,
    ACTIONS(11909), 1,
      anon_sym_COMMA,
    ACTIONS(11911), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11913), 1,
      anon_sym_PIPE,
    ACTIONS(11915), 1,
      anon_sym_AMP,
    ACTIONS(12387), 1,
      anon_sym_DASH_GT,
    ACTIONS(12389), 1,
      anon_sym_when,
    STATE(8259), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8272), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [243139] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3394), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6487), 1,
      sym_method_or_prop_defn,
    STATE(8459), 1,
      sym_access_modifier,
    STATE(8273), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [243194] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12391), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8274), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [243249] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4093), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8275), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4091), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [243290] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12393), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8276), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [243345] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12395), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8277), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [243400] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11907), 1,
      anon_sym_COLON,
    ACTIONS(11909), 1,
      anon_sym_COMMA,
    ACTIONS(11911), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11913), 1,
      anon_sym_PIPE,
    ACTIONS(11915), 1,
      anon_sym_AMP,
    ACTIONS(12397), 1,
      anon_sym_DASH_GT,
    ACTIONS(12399), 1,
      anon_sym_when,
    STATE(8259), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8278), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [243455] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3511), 2,
      anon_sym_or,
      sym_identifier,
    STATE(8279), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3509), 7,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [243496] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3358), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(7546), 1,
      sym_method_or_prop_defn,
    STATE(8530), 1,
      sym_access_modifier,
    STATE(8280), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [243551] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12401), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8281), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [243606] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12090), 1,
      anon_sym_DOT,
    STATE(8215), 1,
      aux_sym_long_identifier_repeat1,
    STATE(8282), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3449), 7,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [243649] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12403), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8283), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [243704] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12405), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8284), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [243759] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3490), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6936), 1,
      sym_method_or_prop_defn,
    STATE(8486), 1,
      sym_access_modifier,
    STATE(8285), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [243814] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(11181), 1,
      sym_identifier,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    STATE(3394), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6425), 1,
      sym_method_or_prop_defn,
    STATE(8517), 1,
      sym_access_modifier,
    STATE(8286), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [243869] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12407), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8287), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [243924] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4108), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8288), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4106), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [243965] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12409), 1,
      anon_sym_COMMA,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8289), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [244020] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4112), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8290), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4110), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [244061] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9666), 1,
      anon_sym_DASH_GT,
    ACTIONS(9668), 1,
      anon_sym_STAR,
    ACTIONS(9670), 1,
      anon_sym_LT2,
    ACTIONS(9672), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(12024), 1,
      sym_identifier,
    ACTIONS(12411), 1,
      sym__dedent,
    STATE(6416), 1,
      aux_sym_compound_type_repeat1,
    STATE(6698), 1,
      sym_type_arguments,
    STATE(6730), 1,
      sym_long_identifier,
    STATE(8291), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [244116] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12413), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8292), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [244171] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12415), 1,
      anon_sym_LPAREN,
    ACTIONS(12419), 1,
      anon_sym_not,
    ACTIONS(12421), 1,
      anon_sym_enum,
    ACTIONS(12423), 1,
      anon_sym_delegate,
    STATE(8293), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(12417), 5,
      anon_sym_null,
      anon_sym_struct,
      anon_sym_unmanaged,
      anon_sym_equality,
      anon_sym_comparison,
  [244218] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7893), 1,
      anon_sym_COLON,
    ACTIONS(12032), 1,
      anon_sym_and,
    STATE(8048), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(8294), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7895), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
  [244263] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12425), 1,
      anon_sym_EQ,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8295), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [244318] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10642), 1,
      anon_sym_DASH_GT,
    ACTIONS(10644), 1,
      anon_sym_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    ACTIONS(12427), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    STATE(8296), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [244373] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3972), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8297), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3970), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [244413] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3487), 2,
      anon_sym_and,
      sym_identifier,
    STATE(8298), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3485), 6,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [244453] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3193), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8299), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3191), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [244493] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11421), 1,
      anon_sym_COMMA,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      anon_sym_PIPE,
    ACTIONS(11427), 1,
      anon_sym_AMP,
    ACTIONS(12429), 1,
      anon_sym_EQ,
    ACTIONS(12431), 1,
      anon_sym_COLON,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8300), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [244545] = 15,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12433), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(12435), 1,
      anon_sym_and,
    STATE(8426), 1,
      aux_sym_type_definition_repeat1,
    STATE(8813), 1,
      aux_sym_attributes_repeat1,
    STATE(9964), 1,
      sym__attribute_set,
    STATE(10281), 1,
      sym_attributes,
    ACTIONS(6524), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8301), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [244595] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3958), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8302), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3956), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [244635] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11421), 1,
      anon_sym_COMMA,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      anon_sym_PIPE,
    ACTIONS(11427), 1,
      anon_sym_AMP,
    ACTIONS(12431), 1,
      anon_sym_COLON,
    ACTIONS(12437), 1,
      anon_sym_EQ,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8303), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [244687] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4104), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8304), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4102), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [244727] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8432), 1,
      anon_sym_COLON,
    STATE(8305), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8434), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [244767] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8197), 1,
      anon_sym_COLON,
    STATE(8306), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8199), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [244807] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8359), 1,
      anon_sym_COLON,
    STATE(8307), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8361), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [244847] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4078), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8308), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4076), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [244887] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(12439), 1,
      anon_sym_COLON,
    ACTIONS(12441), 1,
      anon_sym_COMMA,
    ACTIONS(12443), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12445), 1,
      anon_sym_PIPE,
    ACTIONS(12447), 1,
      anon_sym_AMP,
    ACTIONS(12449), 1,
      anon_sym_in,
    STATE(8310), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8309), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [244939] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7985), 1,
      anon_sym_COLON,
    ACTIONS(12441), 1,
      anon_sym_COMMA,
    STATE(8348), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8310), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7987), 5,
      anon_sym_as,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
  [244983] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3498), 2,
      anon_sym_and,
      sym_identifier,
    STATE(8311), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 6,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [245023] = 15,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12433), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(12435), 1,
      anon_sym_and,
    STATE(8385), 1,
      aux_sym_type_definition_repeat1,
    STATE(8813), 1,
      aux_sym_attributes_repeat1,
    STATE(9964), 1,
      sym__attribute_set,
    STATE(10281), 1,
      sym_attributes,
    ACTIONS(6532), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8312), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [245073] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8313), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3485), 8,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [245111] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8284), 1,
      anon_sym_COLON,
    STATE(8314), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8286), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [245151] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12451), 1,
      anon_sym_DOT,
    STATE(8355), 1,
      aux_sym_long_identifier_repeat1,
    STATE(8315), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3449), 6,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
  [245193] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12451), 1,
      anon_sym_DOT,
    STATE(8315), 1,
      aux_sym_long_identifier_repeat1,
    STATE(8316), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 6,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
  [245235] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(35), 1,
      anon_sym_let,
    ACTIONS(37), 1,
      anon_sym_let_BANG,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12453), 1,
      anon_sym_module,
    ACTIONS(12455), 1,
      anon_sym_type,
    ACTIONS(12457), 1,
      anon_sym_do,
    ACTIONS(12459), 1,
      anon_sym_exception,
    STATE(4167), 1,
      sym_do,
    STATE(4179), 1,
      sym_function_or_value_defn,
    STATE(8317), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [245287] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11421), 1,
      anon_sym_COMMA,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      anon_sym_PIPE,
    ACTIONS(11427), 1,
      anon_sym_AMP,
    ACTIONS(12431), 1,
      anon_sym_COLON,
    ACTIONS(12461), 1,
      anon_sym_EQ,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8318), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [245339] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8288), 1,
      anon_sym_COLON,
    STATE(8319), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8290), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [245379] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(12439), 1,
      anon_sym_COLON,
    ACTIONS(12441), 1,
      anon_sym_COMMA,
    ACTIONS(12443), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12445), 1,
      anon_sym_PIPE,
    ACTIONS(12447), 1,
      anon_sym_AMP,
    ACTIONS(12463), 1,
      anon_sym_in,
    STATE(8310), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8320), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [245431] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12465), 1,
      anon_sym_COLON_GT,
    STATE(8321), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 7,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [245471] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11421), 1,
      anon_sym_COMMA,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      anon_sym_PIPE,
    ACTIONS(11427), 1,
      anon_sym_AMP,
    ACTIONS(12431), 1,
      anon_sym_COLON,
    ACTIONS(12467), 1,
      anon_sym_EQ,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8322), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [245523] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4232), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8323), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4230), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [245563] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11131), 1,
      anon_sym_do,
    ACTIONS(11133), 1,
      anon_sym_let,
    ACTIONS(11135), 1,
      anon_sym_let_BANG,
    ACTIONS(12469), 1,
      anon_sym_module,
    ACTIONS(12471), 1,
      anon_sym_type,
    ACTIONS(12473), 1,
      anon_sym_exception,
    STATE(7515), 1,
      sym_function_or_value_defn,
    STATE(7516), 1,
      sym_do,
    STATE(8324), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [245615] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11498), 1,
      anon_sym_STAR,
    STATE(8333), 1,
      aux_sym_compound_type_repeat1,
    STATE(8325), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3466), 6,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [245657] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(12165), 4,
      sym__inside_string_marker,
      sym__escape_char,
      sym__non_escape_char,
      aux_sym__simple_string_char_token1,
    ACTIONS(12167), 4,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
      anon_sym_DQUOTE,
    STATE(8326), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [245695] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4126), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8327), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4124), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [245735] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11421), 1,
      anon_sym_COMMA,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      anon_sym_PIPE,
    ACTIONS(11427), 1,
      anon_sym_AMP,
    ACTIONS(12431), 1,
      anon_sym_COLON,
    ACTIONS(12475), 1,
      anon_sym_EQ,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8328), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [245787] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8251), 1,
      anon_sym_COLON,
    STATE(8329), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8253), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [245827] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7995), 1,
      anon_sym_COLON,
    STATE(8310), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8330), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7997), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
  [245869] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12477), 1,
      anon_sym_module,
    ACTIONS(12479), 1,
      anon_sym_type,
    ACTIONS(12481), 1,
      anon_sym_do,
    ACTIONS(12483), 1,
      anon_sym_let,
    ACTIONS(12485), 1,
      anon_sym_let_BANG,
    ACTIONS(12487), 1,
      anon_sym_exception,
    STATE(11626), 1,
      sym_do,
    STATE(12118), 1,
      sym_function_or_value_defn,
    STATE(8331), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [245921] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4122), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8332), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4120), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [245961] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12489), 1,
      anon_sym_STAR,
    STATE(8333), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(3425), 6,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [246001] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3954), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8334), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3952), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [246041] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3950), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8335), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3948), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [246081] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4118), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8336), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4116), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [246121] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7963), 1,
      anon_sym_COLON,
    STATE(8310), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8337), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7965), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
  [246163] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4112), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8338), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4110), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [246203] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3962), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8339), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3960), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [246243] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4108), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8340), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4106), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [246283] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8127), 1,
      anon_sym_COLON,
    STATE(8310), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8341), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8129), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
  [246325] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4093), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8342), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4091), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [246365] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8134), 1,
      anon_sym_COLON,
    STATE(8310), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8343), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8136), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
  [246407] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8201), 1,
      anon_sym_COLON,
    STATE(8344), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8203), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [246447] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8158), 1,
      anon_sym_COLON,
    STATE(8310), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8345), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8160), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
  [246489] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4086), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8346), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4084), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [246529] = 15,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    ACTIONS(5609), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    STATE(8347), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [246579] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8127), 1,
      anon_sym_COLON,
    ACTIONS(12492), 1,
      anon_sym_COMMA,
    ACTIONS(8129), 5,
      anon_sym_as,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
    STATE(8348), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
  [246621] = 15,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    ACTIONS(12495), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    STATE(8349), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [246671] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8164), 1,
      anon_sym_COLON,
    ACTIONS(8166), 1,
      anon_sym_in,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(12441), 1,
      anon_sym_COMMA,
    ACTIONS(12443), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12445), 1,
      anon_sym_PIPE,
    ACTIONS(12447), 1,
      anon_sym_AMP,
    STATE(8310), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8350), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [246723] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3885), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8351), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3883), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [246763] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3976), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8352), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3974), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [246803] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4082), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8353), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4080), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [246843] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4054), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8354), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4052), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [246883] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12497), 1,
      anon_sym_DOT,
    STATE(8355), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(3485), 6,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
  [246923] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11421), 1,
      anon_sym_COMMA,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      anon_sym_PIPE,
    ACTIONS(11427), 1,
      anon_sym_AMP,
    ACTIONS(12431), 1,
      anon_sym_COLON,
    ACTIONS(12500), 1,
      anon_sym_EQ,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8356), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [246975] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4130), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8357), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4128), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [247015] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(35), 1,
      anon_sym_let,
    ACTIONS(37), 1,
      anon_sym_let_BANG,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12455), 1,
      anon_sym_type,
    ACTIONS(12457), 1,
      anon_sym_do,
    ACTIONS(12459), 1,
      anon_sym_exception,
    ACTIONS(12502), 1,
      anon_sym_module,
    STATE(4167), 1,
      sym_do,
    STATE(4179), 1,
      sym_function_or_value_defn,
    STATE(8358), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [247067] = 15,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12433), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(12504), 1,
      anon_sym_and,
    STATE(8410), 1,
      aux_sym_type_definition_repeat1,
    STATE(8813), 1,
      aux_sym_attributes_repeat1,
    STATE(9964), 1,
      sym__attribute_set,
    STATE(10225), 1,
      sym_attributes,
    ACTIONS(6549), 2,
      sym__newline,
      sym__dedent,
    STATE(8359), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [247117] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4018), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8360), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4016), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [247157] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(35), 1,
      anon_sym_let,
    ACTIONS(37), 1,
      anon_sym_let_BANG,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12453), 1,
      anon_sym_module,
    ACTIONS(12457), 1,
      anon_sym_do,
    ACTIONS(12459), 1,
      anon_sym_exception,
    ACTIONS(12506), 1,
      anon_sym_type,
    STATE(4167), 1,
      sym_do,
    STATE(4179), 1,
      sym_function_or_value_defn,
    STATE(8361), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [247209] = 15,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12433), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(12504), 1,
      anon_sym_and,
    STATE(8388), 1,
      aux_sym_type_definition_repeat1,
    STATE(8813), 1,
      aux_sym_attributes_repeat1,
    STATE(9964), 1,
      sym__attribute_set,
    STATE(10225), 1,
      sym_attributes,
    ACTIONS(6524), 2,
      sym__newline,
      sym__dedent,
    STATE(8362), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [247259] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3845), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8363), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3843), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [247299] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6424), 1,
      anon_sym_RPAREN,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11421), 1,
      anon_sym_COMMA,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      anon_sym_PIPE,
    ACTIONS(11427), 1,
      anon_sym_AMP,
    ACTIONS(12431), 1,
      anon_sym_COLON,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8364), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [247351] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4003), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8365), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4001), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [247391] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3996), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8366), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3994), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [247431] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12508), 1,
      anon_sym_module,
    ACTIONS(12510), 1,
      anon_sym_type,
    ACTIONS(12512), 1,
      anon_sym_do,
    ACTIONS(12514), 1,
      anon_sym_let,
    ACTIONS(12516), 1,
      anon_sym_let_BANG,
    ACTIONS(12518), 1,
      anon_sym_exception,
    STATE(9712), 1,
      sym_do,
    STATE(9716), 1,
      sym_function_or_value_defn,
    STATE(8367), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [247483] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8368), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 8,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [247521] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(12439), 1,
      anon_sym_COLON,
    ACTIONS(12441), 1,
      anon_sym_COMMA,
    ACTIONS(12443), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12445), 1,
      anon_sym_PIPE,
    ACTIONS(12447), 1,
      anon_sym_AMP,
    ACTIONS(12520), 1,
      anon_sym_in,
    STATE(8310), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8369), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [247573] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(12439), 1,
      anon_sym_COLON,
    ACTIONS(12441), 1,
      anon_sym_COMMA,
    ACTIONS(12443), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12445), 1,
      anon_sym_PIPE,
    ACTIONS(12447), 1,
      anon_sym_AMP,
    ACTIONS(12522), 1,
      anon_sym_in,
    STATE(8310), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8370), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [247625] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(12439), 1,
      anon_sym_COLON,
    ACTIONS(12441), 1,
      anon_sym_COMMA,
    ACTIONS(12443), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12445), 1,
      anon_sym_PIPE,
    ACTIONS(12447), 1,
      anon_sym_AMP,
    ACTIONS(12524), 1,
      anon_sym_in,
    STATE(8310), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8371), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [247677] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(12439), 1,
      anon_sym_COLON,
    ACTIONS(12441), 1,
      anon_sym_COMMA,
    ACTIONS(12443), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12445), 1,
      anon_sym_PIPE,
    ACTIONS(12447), 1,
      anon_sym_AMP,
    ACTIONS(12526), 1,
      anon_sym_in,
    STATE(8310), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8372), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [247729] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8205), 1,
      anon_sym_COLON,
    STATE(8373), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8207), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [247769] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8369), 1,
      anon_sym_COLON,
    STATE(8374), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8371), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [247809] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(12439), 1,
      anon_sym_COLON,
    ACTIONS(12441), 1,
      anon_sym_COMMA,
    ACTIONS(12443), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12445), 1,
      anon_sym_PIPE,
    ACTIONS(12447), 1,
      anon_sym_AMP,
    ACTIONS(12528), 1,
      anon_sym_in,
    STATE(8310), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8375), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [247861] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(12439), 1,
      anon_sym_COLON,
    ACTIONS(12441), 1,
      anon_sym_COMMA,
    ACTIONS(12443), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12445), 1,
      anon_sym_PIPE,
    ACTIONS(12447), 1,
      anon_sym_AMP,
    ACTIONS(12530), 1,
      anon_sym_in,
    STATE(8310), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8376), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [247913] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11421), 1,
      anon_sym_COMMA,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      anon_sym_PIPE,
    ACTIONS(11427), 1,
      anon_sym_AMP,
    ACTIONS(12431), 1,
      anon_sym_COLON,
    ACTIONS(12532), 1,
      anon_sym_RPAREN,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8377), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [247965] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6332), 1,
      anon_sym_RPAREN,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11421), 1,
      anon_sym_COMMA,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      anon_sym_PIPE,
    ACTIONS(11427), 1,
      anon_sym_AMP,
    ACTIONS(12431), 1,
      anon_sym_COLON,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8378), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [248017] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8373), 1,
      anon_sym_COLON,
    STATE(8379), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8375), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [248057] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11421), 1,
      anon_sym_COMMA,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      anon_sym_PIPE,
    ACTIONS(11427), 1,
      anon_sym_AMP,
    ACTIONS(12431), 1,
      anon_sym_COLON,
    ACTIONS(12534), 1,
      anon_sym_EQ,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8380), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [248109] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11421), 1,
      anon_sym_COMMA,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      anon_sym_PIPE,
    ACTIONS(11427), 1,
      anon_sym_AMP,
    ACTIONS(12431), 1,
      anon_sym_COLON,
    ACTIONS(12536), 1,
      anon_sym_EQ,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8381), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [248161] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(12439), 1,
      anon_sym_COLON,
    ACTIONS(12441), 1,
      anon_sym_COMMA,
    ACTIONS(12443), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12445), 1,
      anon_sym_PIPE,
    ACTIONS(12447), 1,
      anon_sym_AMP,
    ACTIONS(12538), 1,
      anon_sym_in,
    STATE(8310), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8382), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [248213] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6543), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12540), 1,
      anon_sym_and,
    STATE(8813), 1,
      aux_sym_attributes_repeat1,
    STATE(9964), 1,
      sym__attribute_set,
    STATE(10281), 1,
      sym_attributes,
    ACTIONS(6539), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8383), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_definition_repeat1,
  [248261] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3927), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8384), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3925), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [248301] = 15,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12433), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(12435), 1,
      anon_sym_and,
    STATE(8383), 1,
      aux_sym_type_definition_repeat1,
    STATE(8813), 1,
      aux_sym_attributes_repeat1,
    STATE(9964), 1,
      sym__attribute_set,
    STATE(10281), 1,
      sym_attributes,
    ACTIONS(6549), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8385), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [248351] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11421), 1,
      anon_sym_COMMA,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      anon_sym_PIPE,
    ACTIONS(11427), 1,
      anon_sym_AMP,
    ACTIONS(12431), 1,
      anon_sym_COLON,
    ACTIONS(12543), 1,
      anon_sym_EQ,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8386), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [248403] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8209), 1,
      anon_sym_COLON,
    STATE(8387), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8211), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [248443] = 15,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12433), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(12504), 1,
      anon_sym_and,
    STATE(8410), 1,
      aux_sym_type_definition_repeat1,
    STATE(8813), 1,
      aux_sym_attributes_repeat1,
    STATE(9964), 1,
      sym__attribute_set,
    STATE(10225), 1,
      sym_attributes,
    ACTIONS(6532), 2,
      sym__newline,
      sym__dedent,
    STATE(8388), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [248493] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8355), 1,
      anon_sym_COLON,
    STATE(8389), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8357), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [248533] = 15,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10646), 1,
      anon_sym_LT2,
    ACTIONS(10648), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(11287), 1,
      sym_identifier,
    STATE(7523), 1,
      aux_sym_compound_type_repeat1,
    STATE(7682), 1,
      sym_long_identifier,
    STATE(7928), 1,
      sym_type_arguments,
    ACTIONS(12545), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    STATE(8390), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [248583] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5601), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10933), 1,
      anon_sym_DOT,
    STATE(7464), 1,
      aux_sym_long_identifier_repeat1,
    STATE(8391), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3492), 5,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
  [248627] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11421), 1,
      anon_sym_COMMA,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      anon_sym_PIPE,
    ACTIONS(11427), 1,
      anon_sym_AMP,
    ACTIONS(12431), 1,
      anon_sym_COLON,
    ACTIONS(12547), 1,
      anon_sym_EQ,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8392), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [248679] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4064), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8393), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4062), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [248719] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11421), 1,
      anon_sym_COMMA,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      anon_sym_PIPE,
    ACTIONS(11427), 1,
      anon_sym_AMP,
    ACTIONS(12431), 1,
      anon_sym_COLON,
    ACTIONS(12549), 1,
      anon_sym_EQ,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8394), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [248771] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3946), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8395), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3944), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [248811] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8383), 1,
      anon_sym_COLON,
    STATE(8396), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8385), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [248851] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4170), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8397), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4168), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [248891] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8245), 1,
      anon_sym_COLON,
    STATE(8398), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8247), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [248931] = 15,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12433), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(12504), 1,
      anon_sym_and,
    STATE(8359), 1,
      aux_sym_type_definition_repeat1,
    STATE(8813), 1,
      aux_sym_attributes_repeat1,
    STATE(9964), 1,
      sym__attribute_set,
    STATE(10225), 1,
      sym_attributes,
    ACTIONS(6532), 2,
      sym__newline,
      sym__dedent,
    STATE(8399), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [248981] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3498), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8400), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [249021] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11421), 1,
      anon_sym_COMMA,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      anon_sym_PIPE,
    ACTIONS(11427), 1,
      anon_sym_AMP,
    ACTIONS(12431), 1,
      anon_sym_COLON,
    ACTIONS(12551), 1,
      anon_sym_EQ,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8401), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [249073] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8241), 1,
      anon_sym_COLON,
    STATE(8402), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8243), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [249113] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8138), 1,
      anon_sym_COLON,
    STATE(8310), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8403), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8140), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
  [249155] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3935), 1,
      anon_sym_COLON,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8404), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3933), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [249195] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11421), 1,
      anon_sym_COMMA,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      anon_sym_PIPE,
    ACTIONS(11427), 1,
      anon_sym_AMP,
    ACTIONS(12431), 1,
      anon_sym_COLON,
    ACTIONS(12553), 1,
      anon_sym_EQ,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8405), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [249247] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11421), 1,
      anon_sym_COMMA,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      anon_sym_PIPE,
    ACTIONS(11427), 1,
      anon_sym_AMP,
    ACTIONS(12431), 1,
      anon_sym_COLON,
    ACTIONS(12555), 1,
      anon_sym_EQ,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8406), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [249299] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11421), 1,
      anon_sym_COMMA,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      anon_sym_PIPE,
    ACTIONS(11427), 1,
      anon_sym_AMP,
    ACTIONS(12431), 1,
      anon_sym_COLON,
    ACTIONS(12557), 1,
      anon_sym_EQ,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8407), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [249351] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(12439), 1,
      anon_sym_COLON,
    ACTIONS(12441), 1,
      anon_sym_COMMA,
    ACTIONS(12443), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12445), 1,
      anon_sym_PIPE,
    ACTIONS(12447), 1,
      anon_sym_AMP,
    ACTIONS(12559), 1,
      anon_sym_in,
    STATE(8310), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8408), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [249403] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11421), 1,
      anon_sym_COMMA,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      anon_sym_PIPE,
    ACTIONS(11427), 1,
      anon_sym_AMP,
    ACTIONS(12431), 1,
      anon_sym_COLON,
    ACTIONS(12561), 1,
      anon_sym_RPAREN,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8409), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [249455] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6543), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12563), 1,
      anon_sym_and,
    STATE(8813), 1,
      aux_sym_attributes_repeat1,
    STATE(9964), 1,
      sym__attribute_set,
    STATE(10225), 1,
      sym_attributes,
    ACTIONS(6539), 2,
      sym__newline,
      sym__dedent,
    STATE(8410), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_definition_repeat1,
  [249503] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(12439), 1,
      anon_sym_COLON,
    ACTIONS(12441), 1,
      anon_sym_COMMA,
    ACTIONS(12443), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12445), 1,
      anon_sym_PIPE,
    ACTIONS(12447), 1,
      anon_sym_AMP,
    ACTIONS(12566), 1,
      anon_sym_in,
    STATE(8310), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8411), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [249555] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(12439), 1,
      anon_sym_COLON,
    ACTIONS(12441), 1,
      anon_sym_COMMA,
    ACTIONS(12443), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12445), 1,
      anon_sym_PIPE,
    ACTIONS(12447), 1,
      anon_sym_AMP,
    ACTIONS(12568), 1,
      anon_sym_in,
    STATE(8310), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8412), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [249607] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(12439), 1,
      anon_sym_COLON,
    ACTIONS(12441), 1,
      anon_sym_COMMA,
    ACTIONS(12443), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12445), 1,
      anon_sym_PIPE,
    ACTIONS(12447), 1,
      anon_sym_AMP,
    ACTIONS(12570), 1,
      anon_sym_in,
    STATE(8310), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8413), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [249659] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(12439), 1,
      anon_sym_COLON,
    ACTIONS(12441), 1,
      anon_sym_COMMA,
    ACTIONS(12443), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12445), 1,
      anon_sym_PIPE,
    ACTIONS(12447), 1,
      anon_sym_AMP,
    ACTIONS(12572), 1,
      anon_sym_in,
    STATE(8310), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8414), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [249711] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(12439), 1,
      anon_sym_COLON,
    ACTIONS(12441), 1,
      anon_sym_COMMA,
    ACTIONS(12443), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12445), 1,
      anon_sym_PIPE,
    ACTIONS(12447), 1,
      anon_sym_AMP,
    ACTIONS(12574), 1,
      anon_sym_in,
    STATE(8310), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8415), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [249763] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11421), 1,
      anon_sym_COMMA,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      anon_sym_PIPE,
    ACTIONS(11427), 1,
      anon_sym_AMP,
    ACTIONS(12431), 1,
      anon_sym_COLON,
    ACTIONS(12576), 1,
      anon_sym_EQ,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8416), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [249815] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11421), 1,
      anon_sym_COMMA,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      anon_sym_PIPE,
    ACTIONS(11427), 1,
      anon_sym_AMP,
    ACTIONS(12431), 1,
      anon_sym_COLON,
    ACTIONS(12578), 1,
      anon_sym_EQ,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8417), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [249867] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11421), 1,
      anon_sym_COMMA,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      anon_sym_PIPE,
    ACTIONS(11427), 1,
      anon_sym_AMP,
    ACTIONS(12431), 1,
      anon_sym_COLON,
    ACTIONS(12580), 1,
      anon_sym_EQ,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8418), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [249919] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(8419), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8402), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [249959] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11421), 1,
      anon_sym_COMMA,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      anon_sym_PIPE,
    ACTIONS(11427), 1,
      anon_sym_AMP,
    ACTIONS(12431), 1,
      anon_sym_COLON,
    ACTIONS(12582), 1,
      anon_sym_EQ,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8420), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [250011] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(12439), 1,
      anon_sym_COLON,
    ACTIONS(12441), 1,
      anon_sym_COMMA,
    ACTIONS(12443), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12445), 1,
      anon_sym_PIPE,
    ACTIONS(12447), 1,
      anon_sym_AMP,
    ACTIONS(12584), 1,
      anon_sym_in,
    STATE(8310), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8421), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [250063] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8377), 1,
      anon_sym_COLON,
    ACTIONS(12586), 1,
      anon_sym_as,
    STATE(8422), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8379), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [250105] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7989), 1,
      anon_sym_COLON,
    STATE(8423), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7991), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [250145] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(11421), 1,
      anon_sym_COMMA,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      anon_sym_PIPE,
    ACTIONS(11427), 1,
      anon_sym_AMP,
    ACTIONS(12431), 1,
      anon_sym_COLON,
    ACTIONS(12588), 1,
      anon_sym_EQ,
    STATE(7723), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8424), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [250197] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3480), 2,
      anon_sym_or,
      sym_identifier,
    STATE(8425), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3478), 6,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
  [250237] = 15,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12433), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(12435), 1,
      anon_sym_and,
    STATE(8383), 1,
      aux_sym_type_definition_repeat1,
    STATE(8813), 1,
      aux_sym_attributes_repeat1,
    STATE(9964), 1,
      sym__attribute_set,
    STATE(10281), 1,
      sym_attributes,
    ACTIONS(6532), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8426), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [250287] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12590), 1,
      anon_sym_COLON_GT,
    ACTIONS(3515), 2,
      anon_sym_and,
      sym_identifier,
    STATE(8427), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 5,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [250329] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(12230), 4,
      sym__inside_string_marker,
      sym__escape_char,
      sym__non_escape_char,
      aux_sym__simple_string_char_token1,
    ACTIONS(12232), 4,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
      anon_sym_DQUOTE,
    STATE(8428), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [250367] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(12439), 1,
      anon_sym_COLON,
    ACTIONS(12441), 1,
      anon_sym_COMMA,
    ACTIONS(12443), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12445), 1,
      anon_sym_PIPE,
    ACTIONS(12447), 1,
      anon_sym_AMP,
    ACTIONS(12592), 1,
      anon_sym_in,
    STATE(8310), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8429), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [250419] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12594), 1,
      anon_sym_STAR,
    ACTIONS(3427), 2,
      anon_sym_and,
      sym_identifier,
    ACTIONS(3425), 4,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    STATE(8430), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
  [250461] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(12439), 1,
      anon_sym_COLON,
    ACTIONS(12441), 1,
      anon_sym_COMMA,
    ACTIONS(12443), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12445), 1,
      anon_sym_PIPE,
    ACTIONS(12447), 1,
      anon_sym_AMP,
    ACTIONS(12597), 1,
      anon_sym_in,
    STATE(8310), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8431), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [250513] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3511), 2,
      anon_sym_or,
      sym_identifier,
    STATE(8432), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3509), 6,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_POUNDendif,
  [250553] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(12439), 1,
      anon_sym_COLON,
    ACTIONS(12441), 1,
      anon_sym_COMMA,
    ACTIONS(12443), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12445), 1,
      anon_sym_PIPE,
    ACTIONS(12447), 1,
      anon_sym_AMP,
    ACTIONS(12599), 1,
      anon_sym_in,
    STATE(8310), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8433), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [250605] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(12439), 1,
      anon_sym_COLON,
    ACTIONS(12441), 1,
      anon_sym_COMMA,
    ACTIONS(12443), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12445), 1,
      anon_sym_PIPE,
    ACTIONS(12447), 1,
      anon_sym_AMP,
    ACTIONS(12601), 1,
      anon_sym_in,
    STATE(8310), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8434), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [250657] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11439), 1,
      anon_sym_STAR,
    STATE(8430), 1,
      aux_sym_compound_type_repeat1,
    ACTIONS(3468), 2,
      anon_sym_and,
      sym_identifier,
    ACTIONS(3466), 4,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    STATE(8435), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [250701] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(12202), 4,
      sym__inside_string_marker,
      sym__escape_char,
      sym__non_escape_char,
      aux_sym__simple_string_char_token1,
    ACTIONS(12204), 4,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
      anon_sym_DQUOTE,
    STATE(8436), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [250739] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      anon_sym_as,
    ACTIONS(12439), 1,
      anon_sym_COLON,
    ACTIONS(12441), 1,
      anon_sym_COMMA,
    ACTIONS(12443), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12445), 1,
      anon_sym_PIPE,
    ACTIONS(12447), 1,
      anon_sym_AMP,
    ACTIONS(12603), 1,
      anon_sym_in,
    STATE(8310), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(8437), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [250791] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3446), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6954), 1,
      sym_method_or_prop_defn,
    STATE(8438), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [250840] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(983), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2676), 1,
      sym_op_identifier,
    ACTIONS(12607), 1,
      sym_identifier,
    STATE(2423), 1,
      sym_long_identifier_or_op,
    STATE(2449), 1,
      sym_active_pattern,
    STATE(2458), 1,
      sym_long_identifier,
    STATE(2502), 1,
      sym__identifier_or_op,
    STATE(8439), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [250889] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    ACTIONS(12611), 1,
      anon_sym_default,
    STATE(4837), 1,
      sym_constraint,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(9383), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8440), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [250936] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3447), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6907), 1,
      sym_method_or_prop_defn,
    STATE(8441), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [250985] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    ACTIONS(12611), 1,
      anon_sym_default,
    STATE(4884), 1,
      sym_constraint,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(9383), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8442), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [251032] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3444), 1,
      sym_property_or_ident,
    STATE(3801), 1,
      sym_method_or_prop_defn,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(8443), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [251081] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(635), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3151), 1,
      sym_op_identifier,
    ACTIONS(12613), 1,
      sym_identifier,
    STATE(1953), 1,
      sym_active_pattern,
    STATE(2029), 1,
      sym_long_identifier_or_op,
    STATE(2077), 1,
      sym_long_identifier,
    STATE(2078), 1,
      sym__identifier_or_op,
    STATE(8444), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [251130] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3327), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6563), 1,
      sym_method_or_prop_defn,
    STATE(8445), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [251179] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3327), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6590), 1,
      sym_method_or_prop_defn,
    STATE(8446), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [251228] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12617), 3,
      anon_sym_LBRACE_PIPE,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    ACTIONS(12615), 4,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_POUND,
      sym_identifier,
    STATE(8447), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [251267] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12619), 1,
      sym_identifier,
    STATE(6414), 1,
      sym_long_identifier,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(11142), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8448), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [251314] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(1802), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3035), 1,
      sym_op_identifier,
    ACTIONS(12621), 1,
      sym_identifier,
    STATE(3332), 1,
      sym_long_identifier_or_op,
    STATE(3488), 1,
      sym_active_pattern,
    STATE(3530), 1,
      sym__identifier_or_op,
    STATE(3534), 1,
      sym_long_identifier,
    STATE(8449), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [251363] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3230), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6738), 1,
      sym_method_or_prop_defn,
    STATE(8450), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [251412] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    ACTIONS(12623), 1,
      anon_sym_default,
    STATE(7202), 1,
      sym_constraint,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(10154), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8451), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [251459] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    ACTIONS(12625), 1,
      anon_sym_default,
    STATE(8230), 1,
      sym_constraint,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(9428), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8452), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [251506] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3230), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6680), 1,
      sym_method_or_prop_defn,
    STATE(8453), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [251555] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3230), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6610), 1,
      sym_method_or_prop_defn,
    STATE(8454), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [251604] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    ACTIONS(12625), 1,
      anon_sym_default,
    STATE(7756), 1,
      sym_constraint,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(9428), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8455), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [251651] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3327), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6609), 1,
      sym_method_or_prop_defn,
    STATE(8456), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [251700] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3447), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6866), 1,
      sym_method_or_prop_defn,
    STATE(8457), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [251749] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3230), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6601), 1,
      sym_method_or_prop_defn,
    STATE(8458), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [251798] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3394), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6425), 1,
      sym_method_or_prop_defn,
    STATE(8459), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [251847] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(12230), 3,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
      anon_sym_DQUOTEB,
    ACTIONS(12232), 4,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
      anon_sym_DQUOTE2,
    STATE(8460), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [251884] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9360), 3,
      anon_sym_mutable,
      anon_sym__,
      sym_identifier,
    ACTIONS(9362), 4,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8461), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [251923] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    ACTIONS(12627), 1,
      anon_sym_default,
    STATE(7202), 1,
      sym_constraint,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(9608), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8462), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [251970] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    ACTIONS(12629), 1,
      anon_sym_default,
    STATE(4981), 1,
      sym_constraint,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(9523), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8463), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [252017] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(455), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3165), 1,
      sym_op_identifier,
    ACTIONS(12631), 1,
      sym_identifier,
    STATE(1747), 1,
      sym_long_identifier_or_op,
    STATE(1754), 1,
      sym_active_pattern,
    STATE(1822), 1,
      sym__identifier_or_op,
    STATE(1825), 1,
      sym_long_identifier,
    STATE(8464), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [252066] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(1193), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3175), 1,
      sym_op_identifier,
    ACTIONS(12633), 1,
      sym_identifier,
    STATE(3033), 1,
      sym_long_identifier_or_op,
    STATE(3102), 1,
      sym_long_identifier,
    STATE(3103), 1,
      sym__identifier_or_op,
    STATE(3172), 1,
      sym_active_pattern,
    STATE(8465), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [252115] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3327), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6726), 1,
      sym_method_or_prop_defn,
    STATE(8466), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [252164] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3205), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6373), 1,
      sym_method_or_prop_defn,
    STATE(8467), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [252213] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3447), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6803), 1,
      sym_method_or_prop_defn,
    STATE(8468), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [252262] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3394), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6487), 1,
      sym_method_or_prop_defn,
    STATE(8469), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [252311] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    ACTIONS(12635), 1,
      anon_sym_default,
    STATE(4885), 1,
      sym_constraint,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(9510), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8470), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [252358] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(1079), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3187), 1,
      sym_op_identifier,
    ACTIONS(12637), 1,
      sym_identifier,
    STATE(2793), 1,
      sym_long_identifier_or_op,
    STATE(2833), 1,
      sym_active_pattern,
    STATE(2883), 1,
      sym__identifier_or_op,
    STATE(2885), 1,
      sym_long_identifier,
    STATE(8471), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [252407] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    ACTIONS(12639), 1,
      anon_sym_default,
    STATE(7638), 1,
      sym_constraint,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(10041), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8472), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [252454] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3205), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6350), 1,
      sym_method_or_prop_defn,
    STATE(8473), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [252503] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3205), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6342), 1,
      sym_method_or_prop_defn,
    STATE(8474), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [252552] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8475), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3541), 7,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [252589] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8476), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3545), 7,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [252626] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8477), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3529), 7,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [252663] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8478), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 7,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [252700] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12641), 1,
      anon_sym_LT2,
    STATE(8479), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3503), 6,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [252739] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9414), 3,
      anon_sym_mutable,
      anon_sym__,
      sym_identifier,
    ACTIONS(9416), 4,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8480), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [252778] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8481), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3549), 7,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [252815] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3447), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6829), 1,
      sym_method_or_prop_defn,
    STATE(8482), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [252864] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8483), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3560), 7,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [252901] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8484), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3537), 7,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [252938] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8485), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3525), 7,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [252975] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3490), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6780), 1,
      sym_method_or_prop_defn,
    STATE(8486), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [253024] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8487), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3517), 7,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [253061] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8488), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3521), 7,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [253098] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(101), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(103), 1,
      sym_op_identifier,
    ACTIONS(12643), 1,
      sym_identifier,
    STATE(2363), 1,
      sym_long_identifier_or_op,
    STATE(2404), 1,
      sym_active_pattern,
    STATE(2465), 1,
      sym_long_identifier,
    STATE(2466), 1,
      sym__identifier_or_op,
    STATE(8489), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [253147] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3490), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6906), 1,
      sym_method_or_prop_defn,
    STATE(8490), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [253196] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    ACTIONS(12635), 1,
      anon_sym_default,
    STATE(4772), 1,
      sym_constraint,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(9510), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8491), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [253243] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3539), 2,
      anon_sym_and,
      sym_identifier,
    STATE(8492), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3537), 5,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [253282] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    ACTIONS(12645), 1,
      anon_sym_default,
    STATE(7673), 1,
      sym_constraint,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(10045), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8493), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [253329] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3543), 2,
      anon_sym_and,
      sym_identifier,
    STATE(8494), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3541), 5,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [253368] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3547), 2,
      anon_sym_and,
      sym_identifier,
    STATE(8495), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3545), 5,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [253407] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(365), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2366), 1,
      sym_op_identifier,
    ACTIONS(12647), 1,
      sym_identifier,
    STATE(1703), 1,
      sym__identifier_or_op,
    STATE(1704), 1,
      sym_long_identifier,
    STATE(1718), 1,
      sym_active_pattern,
    STATE(1722), 1,
      sym_long_identifier_or_op,
    STATE(8496), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [253456] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3531), 2,
      anon_sym_and,
      sym_identifier,
    STATE(8497), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3529), 5,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [253495] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    ACTIONS(12639), 1,
      anon_sym_default,
    STATE(7202), 1,
      sym_constraint,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(10041), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8498), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [253542] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9386), 3,
      anon_sym_mutable,
      anon_sym__,
      sym_identifier,
    ACTIONS(9388), 4,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8499), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [253581] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3515), 2,
      anon_sym_and,
      sym_identifier,
    STATE(8500), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 5,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [253620] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    ACTIONS(12645), 1,
      anon_sym_default,
    STATE(7554), 1,
      sym_constraint,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(10045), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8501), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [253667] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(723), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2644), 1,
      sym_op_identifier,
    ACTIONS(12649), 1,
      sym_identifier,
    STATE(1928), 1,
      sym_active_pattern,
    STATE(2054), 1,
      sym__identifier_or_op,
    STATE(2055), 1,
      sym_long_identifier,
    STATE(2089), 1,
      sym_long_identifier_or_op,
    STATE(8502), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [253716] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8503), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3533), 7,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
  [253753] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3551), 2,
      anon_sym_and,
      sym_identifier,
    STATE(8504), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3549), 5,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [253792] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3562), 2,
      anon_sym_and,
      sym_identifier,
    STATE(8505), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3560), 5,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [253831] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3535), 2,
      anon_sym_and,
      sym_identifier,
    STATE(8506), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3533), 5,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [253870] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12651), 1,
      anon_sym_LT2,
    ACTIONS(3505), 2,
      anon_sym_and,
      sym_identifier,
    ACTIONS(3503), 4,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
    STATE(8507), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [253911] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(827), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2618), 1,
      sym_op_identifier,
    ACTIONS(12653), 1,
      sym_identifier,
    STATE(1899), 1,
      sym__identifier_or_op,
    STATE(1932), 1,
      sym_active_pattern,
    STATE(1940), 1,
      sym_long_identifier,
    STATE(2144), 1,
      sym_long_identifier_or_op,
    STATE(8508), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [253960] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3519), 2,
      anon_sym_and,
      sym_identifier,
    STATE(8509), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3517), 5,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [253999] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3523), 2,
      anon_sym_and,
      sym_identifier,
    STATE(8510), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3521), 5,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [254038] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3527), 2,
      anon_sym_and,
      sym_identifier,
    STATE(8511), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3525), 5,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [254077] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3205), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6322), 1,
      sym_method_or_prop_defn,
    STATE(8512), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [254126] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(1904), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3073), 1,
      sym_op_identifier,
    ACTIONS(12655), 1,
      sym_identifier,
    STATE(3445), 1,
      sym_long_identifier,
    STATE(3466), 1,
      sym_active_pattern,
    STATE(3508), 1,
      sym_long_identifier_or_op,
    STATE(3577), 1,
      sym__identifier_or_op,
    STATE(8513), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [254175] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3490), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6808), 1,
      sym_method_or_prop_defn,
    STATE(8514), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [254224] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(12659), 3,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
      anon_sym_DQUOTEB,
    ACTIONS(12657), 4,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
      anon_sym_DQUOTE2,
    STATE(8515), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [254261] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(1710), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3025), 1,
      sym_op_identifier,
    ACTIONS(12661), 1,
      sym_identifier,
    STATE(3203), 1,
      sym_long_identifier,
    STATE(3362), 1,
      sym__identifier_or_op,
    STATE(3378), 1,
      sym_long_identifier_or_op,
    STATE(3576), 1,
      sym_active_pattern,
    STATE(8516), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [254310] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3394), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6498), 1,
      sym_method_or_prop_defn,
    STATE(8517), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [254359] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    ACTIONS(12663), 1,
      anon_sym_default,
    STATE(7783), 1,
      sym_constraint,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(9719), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8518), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [254406] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(209), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3095), 1,
      sym_op_identifier,
    ACTIONS(12665), 1,
      sym_identifier,
    STATE(1401), 1,
      sym_active_pattern,
    STATE(1439), 1,
      sym_long_identifier_or_op,
    STATE(1459), 1,
      sym__identifier_or_op,
    STATE(1469), 1,
      sym_long_identifier,
    STATE(8519), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [254455] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12667), 1,
      anon_sym_COLON_GT,
    STATE(8520), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 6,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
  [254494] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3446), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(7088), 1,
      sym_method_or_prop_defn,
    STATE(8521), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [254543] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12671), 3,
      anon_sym_LBRACE_PIPE,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    ACTIONS(12669), 4,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_POUND,
      sym_identifier,
    STATE(8522), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [254582] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3360), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(7560), 1,
      sym_method_or_prop_defn,
    STATE(8523), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [254631] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11884), 1,
      anon_sym_STAR,
    STATE(8531), 1,
      aux_sym_compound_type_repeat1,
    STATE(8524), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3466), 5,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
  [254672] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3444), 1,
      sym_property_or_ident,
    STATE(3798), 1,
      sym_method_or_prop_defn,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(8525), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [254721] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    ACTIONS(12623), 1,
      anon_sym_default,
    STATE(8294), 1,
      sym_constraint,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(10154), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8526), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [254768] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(12675), 3,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
      anon_sym_DQUOTEB,
    ACTIONS(12673), 4,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
      anon_sym_DQUOTE2,
    STATE(8527), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [254805] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(1380), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3055), 1,
      sym_op_identifier,
    ACTIONS(12677), 1,
      sym_identifier,
    STATE(3034), 1,
      sym_active_pattern,
    STATE(3117), 1,
      sym_long_identifier_or_op,
    STATE(3186), 1,
      sym__identifier_or_op,
    STATE(3187), 1,
      sym_long_identifier,
    STATE(8528), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [254854] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3444), 1,
      sym_property_or_ident,
    STATE(3762), 1,
      sym_method_or_prop_defn,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(8529), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [254903] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3358), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(7619), 1,
      sym_method_or_prop_defn,
    STATE(8530), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [254952] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12679), 1,
      anon_sym_STAR,
    ACTIONS(3425), 5,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
    STATE(8531), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
  [254991] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    ACTIONS(12682), 1,
      anon_sym_default,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(8936), 1,
      sym_constraint,
    STATE(10164), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8532), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [255038] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    ACTIONS(12684), 1,
      anon_sym_default,
    STATE(4920), 1,
      sym_constraint,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(9934), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8533), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [255085] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    ACTIONS(12663), 1,
      anon_sym_default,
    STATE(7202), 1,
      sym_constraint,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(9719), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8534), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [255132] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    ACTIONS(12686), 1,
      anon_sym_default,
    STATE(5105), 1,
      sym_constraint,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(9638), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8535), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [255179] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6584), 1,
      anon_sym__,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12050), 1,
      sym_identifier,
    STATE(6313), 1,
      sym_long_identifier,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(11546), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8536), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [255226] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    ACTIONS(12688), 1,
      anon_sym_default,
    STATE(5149), 1,
      sym_constraint,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(9835), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8537), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [255273] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3446), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6968), 1,
      sym_method_or_prop_defn,
    STATE(8538), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [255322] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3358), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(7546), 1,
      sym_method_or_prop_defn,
    STATE(8539), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [255371] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(1588), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3123), 1,
      sym_op_identifier,
    ACTIONS(12690), 1,
      sym_identifier,
    STATE(3256), 1,
      sym_long_identifier_or_op,
    STATE(3401), 1,
      sym__identifier_or_op,
    STATE(3562), 1,
      sym_active_pattern,
    STATE(3572), 1,
      sym_long_identifier,
    STATE(8540), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [255420] = 15,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6532), 1,
      anon_sym_POUNDendif,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12433), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(12692), 1,
      anon_sym_and,
    STATE(8544), 1,
      aux_sym_type_definition_repeat1,
    STATE(8813), 1,
      aux_sym_attributes_repeat1,
    STATE(9964), 1,
      sym__attribute_set,
    STATE(10211), 1,
      sym_attributes,
    STATE(8541), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [255469] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3360), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(7589), 1,
      sym_method_or_prop_defn,
    STATE(8542), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [255518] = 15,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6549), 1,
      anon_sym_POUNDendif,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12433), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(12692), 1,
      anon_sym_and,
    STATE(8544), 1,
      aux_sym_type_definition_repeat1,
    STATE(8813), 1,
      aux_sym_attributes_repeat1,
    STATE(9964), 1,
      sym__attribute_set,
    STATE(10211), 1,
      sym_attributes,
    STATE(8543), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [255567] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6539), 1,
      anon_sym_POUNDendif,
    ACTIONS(6543), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12694), 1,
      anon_sym_and,
    STATE(8813), 1,
      aux_sym_attributes_repeat1,
    STATE(9964), 1,
      sym__attribute_set,
    STATE(10211), 1,
      sym_attributes,
    STATE(8544), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_definition_repeat1,
  [255614] = 15,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6532), 1,
      anon_sym_POUNDendif,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12433), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(12692), 1,
      anon_sym_and,
    STATE(8543), 1,
      aux_sym_type_definition_repeat1,
    STATE(8813), 1,
      aux_sym_attributes_repeat1,
    STATE(9964), 1,
      sym__attribute_set,
    STATE(10211), 1,
      sym_attributes,
    STATE(8545), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [255663] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8546), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3496), 7,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
  [255700] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(547), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(3085), 1,
      sym_op_identifier,
    ACTIONS(12697), 1,
      sym_identifier,
    STATE(1951), 1,
      sym_long_identifier,
    STATE(1952), 1,
      sym__identifier_or_op,
    STATE(2011), 1,
      sym_long_identifier_or_op,
    STATE(2071), 1,
      sym_active_pattern,
    STATE(8547), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [255749] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3358), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(7609), 1,
      sym_method_or_prop_defn,
    STATE(8548), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [255798] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    ACTIONS(12682), 1,
      anon_sym_default,
    STATE(7202), 1,
      sym_constraint,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(10164), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8549), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [255845] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    ACTIONS(12688), 1,
      anon_sym_default,
    STATE(5043), 1,
      sym_constraint,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(9835), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8550), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [255892] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3394), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6503), 1,
      sym_method_or_prop_defn,
    STATE(8551), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [255941] = 15,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6524), 1,
      anon_sym_POUNDendif,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12433), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(12692), 1,
      anon_sym_and,
    STATE(8541), 1,
      aux_sym_type_definition_repeat1,
    STATE(8813), 1,
      aux_sym_attributes_repeat1,
    STATE(9964), 1,
      sym__attribute_set,
    STATE(10211), 1,
      sym_attributes,
    STATE(8552), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [255990] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3360), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(7625), 1,
      sym_method_or_prop_defn,
    STATE(8553), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [256039] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3444), 1,
      sym_property_or_ident,
    STATE(3810), 1,
      sym_method_or_prop_defn,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(8554), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [256088] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8555), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3485), 7,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
  [256125] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(12699), 1,
      sym_identifier,
    ACTIONS(12701), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12703), 1,
      sym_op_identifier,
    STATE(4303), 1,
      sym__identifier_or_op,
    STATE(6231), 1,
      sym_active_pattern,
    STATE(8776), 1,
      sym_access_modifier,
    STATE(8556), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [256174] = 15,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(12705), 1,
      sym_identifier,
    STATE(6480), 1,
      sym_union_type_case,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(8948), 1,
      sym_enum_type_case,
    STATE(10202), 1,
      sym_attributes,
    STATE(8557), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [256223] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3358), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(7585), 1,
      sym_method_or_prop_defn,
    STATE(8558), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [256272] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    ACTIONS(12686), 1,
      anon_sym_default,
    STATE(4913), 1,
      sym_constraint,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(9638), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8559), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [256319] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    ACTIONS(12684), 1,
      anon_sym_default,
    STATE(4837), 1,
      sym_constraint,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(9934), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8560), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [256366] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3360), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(7597), 1,
      sym_method_or_prop_defn,
    STATE(8561), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [256415] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3446), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(7072), 1,
      sym_method_or_prop_defn,
    STATE(8562), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [256464] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(11187), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(11189), 1,
      sym_op_identifier,
    ACTIONS(12605), 1,
      sym_identifier,
    STATE(3490), 1,
      sym_property_or_ident,
    STATE(5386), 1,
      sym__identifier_or_op,
    STATE(5392), 1,
      sym_active_pattern,
    STATE(6881), 1,
      sym_method_or_prop_defn,
    STATE(8563), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [256513] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(12701), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12703), 1,
      sym_op_identifier,
    ACTIONS(12707), 1,
      sym_identifier,
    STATE(6231), 1,
      sym_active_pattern,
    STATE(9274), 1,
      sym_property_or_ident,
    STATE(9706), 1,
      sym__identifier_or_op,
    STATE(8564), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [256559] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(12701), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12703), 1,
      sym_op_identifier,
    ACTIONS(12707), 1,
      sym_identifier,
    STATE(6231), 1,
      sym_active_pattern,
    STATE(9105), 1,
      sym_property_or_ident,
    STATE(9706), 1,
      sym__identifier_or_op,
    STATE(8565), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [256605] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(12701), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12703), 1,
      sym_op_identifier,
    ACTIONS(12707), 1,
      sym_identifier,
    STATE(6231), 1,
      sym_active_pattern,
    STATE(9076), 1,
      sym_property_or_ident,
    STATE(9706), 1,
      sym__identifier_or_op,
    STATE(8566), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [256651] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(12701), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12703), 1,
      sym_op_identifier,
    ACTIONS(12707), 1,
      sym_identifier,
    STATE(6231), 1,
      sym_active_pattern,
    STATE(8944), 1,
      sym_property_or_ident,
    STATE(9706), 1,
      sym__identifier_or_op,
    STATE(8567), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [256697] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(12701), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12703), 1,
      sym_op_identifier,
    ACTIONS(12707), 1,
      sym_identifier,
    STATE(6231), 1,
      sym_active_pattern,
    STATE(9250), 1,
      sym_property_or_ident,
    STATE(9706), 1,
      sym__identifier_or_op,
    STATE(8568), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [256743] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(12701), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12703), 1,
      sym_op_identifier,
    ACTIONS(12707), 1,
      sym_identifier,
    STATE(6231), 1,
      sym_active_pattern,
    STATE(8951), 1,
      sym_property_or_ident,
    STATE(9706), 1,
      sym__identifier_or_op,
    STATE(8569), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [256789] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8570), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3521), 6,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
  [256825] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(12701), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12703), 1,
      sym_op_identifier,
    ACTIONS(12707), 1,
      sym_identifier,
    STATE(6231), 1,
      sym_active_pattern,
    STATE(9136), 1,
      sym_property_or_ident,
    STATE(9706), 1,
      sym__identifier_or_op,
    STATE(8571), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [256871] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8572), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3517), 6,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
  [256907] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8573), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3525), 6,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
  [256943] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8574), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3529), 6,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
  [256979] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(12701), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12703), 1,
      sym_op_identifier,
    ACTIONS(12707), 1,
      sym_identifier,
    STATE(6231), 1,
      sym_active_pattern,
    STATE(9259), 1,
      sym_property_or_ident,
    STATE(9706), 1,
      sym__identifier_or_op,
    STATE(8575), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [257025] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8576), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3533), 6,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
  [257061] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8577), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3560), 6,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
  [257097] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(12701), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12703), 1,
      sym_op_identifier,
    ACTIONS(12707), 1,
      sym_identifier,
    STATE(6231), 1,
      sym_active_pattern,
    STATE(9289), 1,
      sym_property_or_ident,
    STATE(9706), 1,
      sym__identifier_or_op,
    STATE(8578), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [257143] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8579), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3549), 6,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
  [257179] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12709), 1,
      anon_sym_LT2,
    STATE(8580), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3503), 5,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
  [257217] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8581), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3513), 6,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
  [257253] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(12701), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12703), 1,
      sym_op_identifier,
    ACTIONS(12707), 1,
      sym_identifier,
    STATE(6231), 1,
      sym_active_pattern,
    STATE(9149), 1,
      sym_property_or_ident,
    STATE(9706), 1,
      sym__identifier_or_op,
    STATE(8582), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [257299] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8583), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3545), 6,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
  [257335] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8584), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3541), 6,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
  [257371] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(12659), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(12657), 4,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
      anon_sym_DQUOTE2,
    STATE(8585), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [257407] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(12675), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(12673), 4,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
      anon_sym_DQUOTE2,
    STATE(8586), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [257443] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(12701), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12703), 1,
      sym_op_identifier,
    ACTIONS(12707), 1,
      sym_identifier,
    STATE(6231), 1,
      sym_active_pattern,
    STATE(9079), 1,
      sym_property_or_ident,
    STATE(9706), 1,
      sym__identifier_or_op,
    STATE(8587), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [257489] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(12701), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12703), 1,
      sym_op_identifier,
    ACTIONS(12707), 1,
      sym_identifier,
    STATE(6231), 1,
      sym_active_pattern,
    STATE(9123), 1,
      sym_property_or_ident,
    STATE(9706), 1,
      sym__identifier_or_op,
    STATE(8588), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [257535] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(12701), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12703), 1,
      sym_op_identifier,
    ACTIONS(12707), 1,
      sym_identifier,
    STATE(6231), 1,
      sym_active_pattern,
    STATE(9088), 1,
      sym_property_or_ident,
    STATE(9706), 1,
      sym__identifier_or_op,
    STATE(8589), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [257581] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8590), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3537), 6,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
      anon_sym_POUNDendif,
  [257617] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(12701), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12703), 1,
      sym_op_identifier,
    ACTIONS(12707), 1,
      sym_identifier,
    STATE(6231), 1,
      sym_active_pattern,
    STATE(8996), 1,
      sym_property_or_ident,
    STATE(9706), 1,
      sym__identifier_or_op,
    STATE(8591), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [257663] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(12701), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12703), 1,
      sym_op_identifier,
    ACTIONS(12707), 1,
      sym_identifier,
    STATE(6231), 1,
      sym_active_pattern,
    STATE(9347), 1,
      sym_property_or_ident,
    STATE(9706), 1,
      sym__identifier_or_op,
    STATE(8592), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [257709] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(12701), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12703), 1,
      sym_op_identifier,
    ACTIONS(12707), 1,
      sym_identifier,
    STATE(6231), 1,
      sym_active_pattern,
    STATE(8982), 1,
      sym_property_or_ident,
    STATE(9706), 1,
      sym__identifier_or_op,
    STATE(8593), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [257755] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(12230), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(12232), 4,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
      anon_sym_DQUOTE2,
    STATE(8594), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [257791] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(12701), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12703), 1,
      sym_op_identifier,
    ACTIONS(12707), 1,
      sym_identifier,
    STATE(6231), 1,
      sym_active_pattern,
    STATE(9099), 1,
      sym_property_or_ident,
    STATE(9706), 1,
      sym__identifier_or_op,
    STATE(8595), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [257837] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(12711), 1,
      sym_identifier,
    STATE(6625), 1,
      sym_union_type_case,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(10202), 1,
      sym_attributes,
    STATE(8596), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [257883] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(12701), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12703), 1,
      sym_op_identifier,
    ACTIONS(12707), 1,
      sym_identifier,
    STATE(6231), 1,
      sym_active_pattern,
    STATE(9223), 1,
      sym_property_or_ident,
    STATE(9706), 1,
      sym__identifier_or_op,
    STATE(8597), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [257929] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9050), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(12711), 1,
      sym_identifier,
    STATE(6480), 1,
      sym_union_type_case,
    STATE(8156), 1,
      aux_sym_attributes_repeat1,
    STATE(8480), 1,
      sym__attribute_set,
    STATE(10202), 1,
      sym_attributes,
    STATE(8598), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [257975] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(12701), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12703), 1,
      sym_op_identifier,
    ACTIONS(12707), 1,
      sym_identifier,
    STATE(6231), 1,
      sym_active_pattern,
    STATE(9331), 1,
      sym_property_or_ident,
    STATE(9706), 1,
      sym__identifier_or_op,
    STATE(8599), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [258021] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(12701), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12703), 1,
      sym_op_identifier,
    ACTIONS(12707), 1,
      sym_identifier,
    STATE(6231), 1,
      sym_active_pattern,
    STATE(9254), 1,
      sym_property_or_ident,
    STATE(9706), 1,
      sym__identifier_or_op,
    STATE(8600), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [258067] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(12701), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12703), 1,
      sym_op_identifier,
    ACTIONS(12707), 1,
      sym_identifier,
    STATE(6231), 1,
      sym_active_pattern,
    STATE(9055), 1,
      sym_property_or_ident,
    STATE(9706), 1,
      sym__identifier_or_op,
    STATE(8601), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [258113] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(12701), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(12703), 1,
      sym_op_identifier,
    ACTIONS(12707), 1,
      sym_identifier,
    STATE(6231), 1,
      sym_active_pattern,
    STATE(9262), 1,
      sym_property_or_ident,
    STATE(9706), 1,
      sym__identifier_or_op,
    STATE(8602), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [258159] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12715), 1,
      anon_sym_GT,
    ACTIONS(12717), 1,
      anon_sym_when,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10504), 1,
      sym_type_argument_constraints,
    STATE(8603), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [258202] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12719), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(11081), 1,
      sym_type_argument_constraints,
    STATE(8604), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [258245] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(10554), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8605), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [258286] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12721), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10373), 1,
      sym_type_argument_constraints,
    STATE(8606), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [258329] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12723), 1,
      sym_identifier,
    ACTIONS(12725), 1,
      anon_sym_member,
    STATE(6563), 1,
      sym_member_signature,
    STATE(10038), 1,
      sym_access_modifier,
    STATE(8607), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [258372] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12727), 1,
      anon_sym_GT,
    STATE(8606), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10375), 1,
      sym_type_argument_constraints,
    STATE(8608), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [258415] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12729), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10976), 1,
      sym_type_argument_constraints,
    STATE(8609), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [258458] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12731), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10382), 1,
      sym_type_argument_constraints,
    STATE(8610), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [258501] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12733), 1,
      anon_sym_GT,
    STATE(8610), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10383), 1,
      sym_type_argument_constraints,
    STATE(8611), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [258544] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12735), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(11496), 1,
      sym_type_argument_constraints,
    STATE(8612), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [258587] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12737), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10391), 1,
      sym_type_argument_constraints,
    STATE(8613), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [258630] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(11156), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8614), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [258671] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12739), 1,
      anon_sym_GT,
    STATE(8613), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10392), 1,
      sym_type_argument_constraints,
    STATE(8615), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [258714] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8333), 1,
      anon_sym_let,
    ACTIONS(8335), 1,
      anon_sym_let_BANG,
    ACTIONS(12741), 1,
      anon_sym_do,
    STATE(6636), 1,
      sym_do,
    STATE(6640), 1,
      sym_function_or_value_defn,
    STATE(8616), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [258757] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12743), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10400), 1,
      sym_type_argument_constraints,
    STATE(8617), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [258800] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12745), 1,
      anon_sym_GT,
    STATE(8617), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10402), 1,
      sym_type_argument_constraints,
    STATE(8618), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [258843] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12747), 1,
      sym_identifier,
    ACTIONS(12749), 1,
      anon_sym_member,
    STATE(6907), 1,
      sym_member_signature,
    STATE(10149), 1,
      sym_access_modifier,
    STATE(8619), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [258886] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12751), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(11326), 1,
      sym_type_argument_constraints,
    STATE(8620), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [258929] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(209), 1,
      anon_sym_LPAREN_PIPE,
    STATE(1333), 1,
      sym__identifier_or_op,
    STATE(1401), 1,
      sym_active_pattern,
    ACTIONS(3095), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(8621), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [258970] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12753), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10409), 1,
      sym_type_argument_constraints,
    STATE(8622), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [259013] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12755), 1,
      anon_sym_GT,
    STATE(8634), 1,
      aux_sym_type_arguments_repeat1,
    STATE(12045), 1,
      sym_type_argument_constraints,
    STATE(8623), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [259056] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12757), 1,
      anon_sym_GT,
    STATE(8622), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10410), 1,
      sym_type_argument_constraints,
    STATE(8624), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [259099] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6862), 1,
      anon_sym_let,
    ACTIONS(6864), 1,
      anon_sym_let_BANG,
    ACTIONS(12759), 1,
      anon_sym_do,
    STATE(6747), 1,
      sym_do,
    STATE(6749), 1,
      sym_function_or_value_defn,
    STATE(8625), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [259142] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12763), 1,
      sym__indent,
    ACTIONS(12765), 1,
      sym__struct_begin,
    ACTIONS(12767), 1,
      sym__interface_begin,
    ACTIONS(12761), 2,
      anon_sym_begin,
      anon_sym_class,
    STATE(8626), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [259183] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12769), 1,
      anon_sym_GT,
    STATE(8612), 1,
      aux_sym_type_arguments_repeat1,
    STATE(11507), 1,
      sym_type_argument_constraints,
    STATE(8627), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [259226] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12771), 1,
      sym_identifier,
    ACTIONS(12773), 1,
      anon_sym_member,
    STATE(6780), 1,
      sym_member_signature,
    STATE(9792), 1,
      sym_access_modifier,
    STATE(8628), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [259269] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12775), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10420), 1,
      sym_type_argument_constraints,
    STATE(8629), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [259312] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12777), 1,
      anon_sym_GT,
    STATE(8629), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10421), 1,
      sym_type_argument_constraints,
    STATE(8630), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [259355] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(10483), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8631), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [259396] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12779), 1,
      sym_identifier,
    ACTIONS(12781), 1,
      anon_sym_member,
    STATE(6487), 1,
      sym_member_signature,
    STATE(9860), 1,
      sym_access_modifier,
    STATE(8632), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [259439] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12783), 1,
      anon_sym_GT,
    STATE(8609), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10988), 1,
      sym_type_argument_constraints,
    STATE(8633), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [259482] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12785), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(11969), 1,
      sym_type_argument_constraints,
    STATE(8634), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [259525] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7742), 1,
      anon_sym_let,
    ACTIONS(7744), 1,
      anon_sym_let_BANG,
    ACTIONS(12787), 1,
      anon_sym_do,
    STATE(6485), 1,
      sym_function_or_value_defn,
    STATE(6486), 1,
      sym_do,
    STATE(8635), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [259568] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12771), 1,
      sym_identifier,
    ACTIONS(12789), 1,
      anon_sym_member,
    STATE(6936), 1,
      sym_member_signature,
    STATE(9818), 1,
      sym_access_modifier,
    STATE(8636), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [259611] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12791), 1,
      anon_sym_GT,
    STATE(8620), 1,
      aux_sym_type_arguments_repeat1,
    STATE(11341), 1,
      sym_type_argument_constraints,
    STATE(8637), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [259654] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12793), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10430), 1,
      sym_type_argument_constraints,
    STATE(8638), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [259697] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12723), 1,
      sym_identifier,
    ACTIONS(12795), 1,
      anon_sym_member,
    STATE(6717), 1,
      sym_member_signature,
    STATE(10102), 1,
      sym_access_modifier,
    STATE(8639), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [259740] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12797), 1,
      anon_sym_GT,
    STATE(8638), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10431), 1,
      sym_type_argument_constraints,
    STATE(8640), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [259783] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12799), 1,
      sym_identifier,
    ACTIONS(12801), 1,
      anon_sym_member,
    STATE(3810), 1,
      sym_member_signature,
    STATE(9669), 1,
      sym_access_modifier,
    STATE(8641), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [259826] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12803), 1,
      anon_sym_GT,
    STATE(8652), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10935), 1,
      sym_type_argument_constraints,
    STATE(8642), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [259869] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12805), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10438), 1,
      sym_type_argument_constraints,
    STATE(8643), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [259912] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12807), 1,
      anon_sym_GT,
    STATE(8643), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10440), 1,
      sym_type_argument_constraints,
    STATE(8644), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [259955] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12809), 1,
      anon_sym_DQUOTE,
    ACTIONS(12811), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(12813), 1,
      sym__newline_not_aligned,
    STATE(11606), 1,
      sym_verbatim_string,
    STATE(11611), 1,
      sym__string_literal,
    STATE(8645), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [259998] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12815), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10448), 1,
      sym_type_argument_constraints,
    STATE(8646), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [260041] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12817), 1,
      anon_sym_GT,
    STATE(8646), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10449), 1,
      sym_type_argument_constraints,
    STATE(8647), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [260084] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12819), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10460), 1,
      sym_type_argument_constraints,
    STATE(8648), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [260127] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(12701), 1,
      anon_sym_LPAREN_PIPE,
    STATE(6231), 1,
      sym_active_pattern,
    STATE(11189), 1,
      sym__identifier_or_op,
    ACTIONS(12703), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(8649), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [260168] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12821), 1,
      anon_sym_GT,
    STATE(8648), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10461), 1,
      sym_type_argument_constraints,
    STATE(8650), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [260211] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12823), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10469), 1,
      sym_type_argument_constraints,
    STATE(8651), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [260254] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12825), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10923), 1,
      sym_type_argument_constraints,
    STATE(8652), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [260297] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12827), 1,
      anon_sym_GT,
    STATE(8651), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10471), 1,
      sym_type_argument_constraints,
    STATE(8653), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [260340] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12831), 1,
      sym__indent,
    ACTIONS(12833), 1,
      sym__struct_begin,
    ACTIONS(12835), 1,
      sym__interface_begin,
    ACTIONS(12829), 2,
      anon_sym_begin,
      anon_sym_class,
    STATE(8654), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [260381] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12779), 1,
      sym_identifier,
    ACTIONS(12837), 1,
      anon_sym_member,
    STATE(6484), 1,
      sym_member_signature,
    STATE(9808), 1,
      sym_access_modifier,
    STATE(8655), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [260424] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(365), 1,
      anon_sym_LPAREN_PIPE,
    STATE(1697), 1,
      sym__identifier_or_op,
    STATE(1718), 1,
      sym_active_pattern,
    ACTIONS(2366), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(8656), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [260465] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12839), 1,
      anon_sym_GT,
    STATE(8674), 1,
      aux_sym_type_arguments_repeat1,
    STATE(11133), 1,
      sym_type_argument_constraints,
    STATE(8657), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [260508] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5524), 1,
      anon_sym_LPAREN_PIPE,
    STATE(5018), 1,
      sym__identifier_or_op,
    STATE(5059), 1,
      sym_active_pattern,
    ACTIONS(5526), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(8658), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [260549] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12841), 1,
      anon_sym_GT,
    STATE(8662), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10903), 1,
      sym_type_argument_constraints,
    STATE(8659), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [260592] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12799), 1,
      sym_identifier,
    ACTIONS(12843), 1,
      anon_sym_member,
    STATE(3814), 1,
      sym_member_signature,
    STATE(9812), 1,
      sym_access_modifier,
    STATE(8660), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [260635] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5667), 1,
      anon_sym_LPAREN_PIPE,
    STATE(5175), 1,
      sym_active_pattern,
    STATE(5230), 1,
      sym__identifier_or_op,
    ACTIONS(5669), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(8661), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [260676] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12845), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10900), 1,
      sym_type_argument_constraints,
    STATE(8662), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [260719] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12847), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10477), 1,
      sym_type_argument_constraints,
    STATE(8663), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [260762] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(10250), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8664), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [260803] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(1588), 1,
      anon_sym_LPAREN_PIPE,
    STATE(3509), 1,
      sym__identifier_or_op,
    STATE(3562), 1,
      sym_active_pattern,
    ACTIONS(3123), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(8665), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [260844] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12849), 1,
      anon_sym_GT,
    STATE(8663), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10478), 1,
      sym_type_argument_constraints,
    STATE(8666), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [260887] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12851), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(11250), 1,
      sym_type_argument_constraints,
    STATE(8667), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [260930] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(10552), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8668), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [260971] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12853), 1,
      anon_sym_GT,
    STATE(8670), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10879), 1,
      sym_type_argument_constraints,
    STATE(8669), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [261014] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12855), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10876), 1,
      sym_type_argument_constraints,
    STATE(8670), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [261057] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12857), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(11574), 1,
      sym_type_argument_constraints,
    STATE(8671), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [261100] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12859), 1,
      sym_identifier,
    ACTIONS(12861), 1,
      anon_sym_member,
    STATE(6601), 1,
      sym_member_signature,
    STATE(9869), 1,
      sym_access_modifier,
    STATE(8672), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [261143] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12863), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10486), 1,
      sym_type_argument_constraints,
    STATE(8673), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [261186] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12865), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(11123), 1,
      sym_type_argument_constraints,
    STATE(8674), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [261229] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8410), 1,
      anon_sym_let,
    ACTIONS(8412), 1,
      anon_sym_let_BANG,
    ACTIONS(12867), 1,
      anon_sym_do,
    STATE(6630), 1,
      sym_do,
    STATE(6639), 1,
      sym_function_or_value_defn,
    STATE(8675), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [261272] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12869), 1,
      anon_sym_GT,
    STATE(8673), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10487), 1,
      sym_type_argument_constraints,
    STATE(8676), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [261315] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12871), 1,
      anon_sym_GT,
    STATE(8689), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10862), 1,
      sym_type_argument_constraints,
    STATE(8677), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [261358] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(10414), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8678), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [261399] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(1380), 1,
      anon_sym_LPAREN_PIPE,
    STATE(3028), 1,
      sym__identifier_or_op,
    STATE(3034), 1,
      sym_active_pattern,
    ACTIONS(3055), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(8679), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [261440] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12873), 1,
      anon_sym_GT,
    STATE(8681), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10335), 1,
      sym_type_argument_constraints,
    STATE(8680), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [261483] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12875), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10368), 1,
      sym_type_argument_constraints,
    STATE(8681), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [261526] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12877), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10493), 1,
      sym_type_argument_constraints,
    STATE(8682), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [261569] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12879), 1,
      sym_int,
    ACTIONS(3751), 4,
      sym__dedent,
      anon_sym_PIPE,
      anon_sym_f,
      aux_sym_decimal_token1,
    STATE(8683), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [261606] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12881), 1,
      anon_sym_GT,
    STATE(8682), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10494), 1,
      sym_type_argument_constraints,
    STATE(8684), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [261649] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12883), 1,
      anon_sym_GT,
    STATE(8671), 1,
      aux_sym_type_arguments_repeat1,
    STATE(11588), 1,
      sym_type_argument_constraints,
    STATE(8685), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [261692] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12885), 1,
      anon_sym_GT,
    STATE(8603), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10506), 1,
      sym_type_argument_constraints,
    STATE(8686), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [261735] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12887), 1,
      sym_identifier,
    ACTIONS(12889), 1,
      anon_sym_member,
    STATE(6997), 1,
      sym_member_signature,
    STATE(9633), 1,
      sym_access_modifier,
    STATE(8687), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [261778] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12891), 1,
      aux_sym_float_token1,
    ACTIONS(3602), 4,
      sym__dedent,
      anon_sym_PIPE,
      anon_sym_f,
      aux_sym_decimal_token1,
    STATE(8688), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [261815] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12893), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10859), 1,
      sym_type_argument_constraints,
    STATE(8689), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [261858] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(635), 1,
      anon_sym_LPAREN_PIPE,
    STATE(1953), 1,
      sym_active_pattern,
    STATE(2180), 1,
      sym__identifier_or_op,
    ACTIONS(3151), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(8690), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [261899] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12895), 1,
      anon_sym_GT,
    STATE(8697), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10364), 1,
      sym_type_argument_constraints,
    STATE(8691), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [261942] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(10266), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8692), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [261983] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12859), 1,
      sym_identifier,
    ACTIONS(12897), 1,
      anon_sym_member,
    STATE(6656), 1,
      sym_member_signature,
    STATE(9825), 1,
      sym_access_modifier,
    STATE(8693), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [262026] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12899), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10516), 1,
      sym_type_argument_constraints,
    STATE(8694), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [262069] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12901), 1,
      anon_sym_GT,
    STATE(8694), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10517), 1,
      sym_type_argument_constraints,
    STATE(8695), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [262112] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12903), 1,
      anon_sym_GT,
    STATE(8712), 1,
      aux_sym_type_arguments_repeat1,
    STATE(11842), 1,
      sym_type_argument_constraints,
    STATE(8696), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [262155] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12905), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10363), 1,
      sym_type_argument_constraints,
    STATE(8697), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [262198] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(10616), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8698), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [262239] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12907), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10525), 1,
      sym_type_argument_constraints,
    STATE(8699), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [262282] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(547), 1,
      anon_sym_LPAREN_PIPE,
    STATE(1982), 1,
      sym__identifier_or_op,
    STATE(2071), 1,
      sym_active_pattern,
    ACTIONS(3085), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(8700), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [262323] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12909), 1,
      anon_sym_GT,
    STATE(8702), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10356), 1,
      sym_type_argument_constraints,
    STATE(8701), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [262366] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12911), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10355), 1,
      sym_type_argument_constraints,
    STATE(8702), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [262409] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12913), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(11171), 1,
      sym_type_argument_constraints,
    STATE(8703), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [262452] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12915), 1,
      anon_sym_GT,
    STATE(8699), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10526), 1,
      sym_type_argument_constraints,
    STATE(8704), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [262495] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12917), 1,
      anon_sym_GT,
    STATE(8707), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10843), 1,
      sym_type_argument_constraints,
    STATE(8705), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [262538] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12887), 1,
      sym_identifier,
    ACTIONS(12919), 1,
      anon_sym_member,
    STATE(7088), 1,
      sym_member_signature,
    STATE(9601), 1,
      sym_access_modifier,
    STATE(8706), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [262581] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12921), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10839), 1,
      sym_type_argument_constraints,
    STATE(8707), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [262624] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12923), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10536), 1,
      sym_type_argument_constraints,
    STATE(8708), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [262667] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(1802), 1,
      anon_sym_LPAREN_PIPE,
    STATE(3488), 1,
      sym_active_pattern,
    STATE(3504), 1,
      sym__identifier_or_op,
    ACTIONS(3035), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(8709), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [262708] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12925), 1,
      anon_sym_GT,
    STATE(8708), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10538), 1,
      sym_type_argument_constraints,
    STATE(8710), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [262751] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12927), 1,
      anon_sym_GT,
    STATE(8717), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10824), 1,
      sym_type_argument_constraints,
    STATE(8711), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [262794] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12929), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(11826), 1,
      sym_type_argument_constraints,
    STATE(8712), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [262837] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12931), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10546), 1,
      sym_type_argument_constraints,
    STATE(8713), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [262880] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12933), 1,
      anon_sym_GT,
    STATE(8793), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10680), 1,
      sym_type_argument_constraints,
    STATE(8714), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [262923] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12935), 1,
      anon_sym_GT,
    STATE(8713), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10547), 1,
      sym_type_argument_constraints,
    STATE(8715), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [262966] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(827), 1,
      anon_sym_LPAREN_PIPE,
    STATE(1932), 1,
      sym_active_pattern,
    STATE(2226), 1,
      sym__identifier_or_op,
    ACTIONS(2618), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(8716), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [263007] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12937), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10820), 1,
      sym_type_argument_constraints,
    STATE(8717), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [263050] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(101), 1,
      anon_sym_LPAREN_PIPE,
    STATE(2376), 1,
      sym__identifier_or_op,
    STATE(2404), 1,
      sym_active_pattern,
    ACTIONS(103), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(8718), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [263091] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12939), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10558), 1,
      sym_type_argument_constraints,
    STATE(8719), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [263134] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12941), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(11037), 1,
      sym_type_argument_constraints,
    STATE(8720), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [263177] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12945), 1,
      sym__indent,
    ACTIONS(12947), 1,
      sym__struct_begin,
    ACTIONS(12949), 1,
      sym__interface_begin,
    ACTIONS(12943), 2,
      anon_sym_begin,
      anon_sym_class,
    STATE(8721), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [263218] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym__,
    STATE(7083), 1,
      sym__static_type_identifier,
    STATE(9360), 1,
      sym_type_argument,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8722), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [263259] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12951), 1,
      anon_sym_GT,
    STATE(8719), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10559), 1,
      sym_type_argument_constraints,
    STATE(8723), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [263302] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(983), 1,
      anon_sym_LPAREN_PIPE,
    STATE(2449), 1,
      sym_active_pattern,
    STATE(2538), 1,
      sym__identifier_or_op,
    ACTIONS(2676), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(8724), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [263343] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12953), 1,
      anon_sym_GT,
    STATE(8726), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10799), 1,
      sym_type_argument_constraints,
    STATE(8725), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [263386] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12955), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10796), 1,
      sym_type_argument_constraints,
    STATE(8726), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [263429] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(10674), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8727), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [263470] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12957), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10568), 1,
      sym_type_argument_constraints,
    STATE(8728), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [263513] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12959), 1,
      anon_sym_GT,
    STATE(8728), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10569), 1,
      sym_type_argument_constraints,
    STATE(8729), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [263556] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12961), 1,
      anon_sym_GT,
    STATE(8731), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10777), 1,
      sym_type_argument_constraints,
    STATE(8730), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [263599] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12963), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10774), 1,
      sym_type_argument_constraints,
    STATE(8731), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [263642] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12965), 1,
      anon_sym_GT,
    STATE(8667), 1,
      aux_sym_type_arguments_repeat1,
    STATE(11264), 1,
      sym_type_argument_constraints,
    STATE(8732), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [263685] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12967), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10577), 1,
      sym_type_argument_constraints,
    STATE(8733), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [263728] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12969), 1,
      anon_sym_GT,
    STATE(8733), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10578), 1,
      sym_type_argument_constraints,
    STATE(8734), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [263771] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8514), 1,
      anon_sym_let,
    ACTIONS(8516), 1,
      anon_sym_let_BANG,
    ACTIONS(12971), 1,
      anon_sym_do,
    STATE(7006), 1,
      sym_do,
    STATE(7087), 1,
      sym_function_or_value_defn,
    STATE(8735), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [263814] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12973), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(11654), 1,
      sym_type_argument_constraints,
    STATE(8736), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [263857] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12975), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10586), 1,
      sym_type_argument_constraints,
    STATE(8737), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [263900] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12977), 1,
      anon_sym_GT,
    STATE(8737), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10587), 1,
      sym_type_argument_constraints,
    STATE(8738), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [263943] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5841), 1,
      anon_sym_LPAREN_PIPE,
    STATE(5254), 1,
      sym_active_pattern,
    STATE(5296), 1,
      sym__identifier_or_op,
    ACTIONS(5843), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(8739), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [263984] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12979), 1,
      anon_sym_GT,
    STATE(8720), 1,
      aux_sym_type_arguments_repeat1,
    STATE(11045), 1,
      sym_type_argument_constraints,
    STATE(8740), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [264027] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5705), 1,
      anon_sym_LPAREN_PIPE,
    STATE(5117), 1,
      sym_active_pattern,
    STATE(5191), 1,
      sym__identifier_or_op,
    ACTIONS(5707), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(8741), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [264068] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12747), 1,
      sym_identifier,
    ACTIONS(12981), 1,
      anon_sym_member,
    STATE(6868), 1,
      sym_member_signature,
    STATE(10052), 1,
      sym_access_modifier,
    STATE(8742), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [264111] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(1710), 1,
      anon_sym_LPAREN_PIPE,
    STATE(3353), 1,
      sym__identifier_or_op,
    STATE(3576), 1,
      sym_active_pattern,
    ACTIONS(3025), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(8743), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [264152] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(1079), 1,
      anon_sym_LPAREN_PIPE,
    STATE(2833), 1,
      sym_active_pattern,
    STATE(2834), 1,
      sym__identifier_or_op,
    ACTIONS(3187), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(8744), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [264193] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12983), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10594), 1,
      sym_type_argument_constraints,
    STATE(8745), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [264236] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12985), 1,
      anon_sym_GT,
    STATE(8745), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10595), 1,
      sym_type_argument_constraints,
    STATE(8746), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [264279] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12987), 1,
      anon_sym_GT,
    STATE(8604), 1,
      aux_sym_type_arguments_repeat1,
    STATE(11089), 1,
      sym_type_argument_constraints,
    STATE(8747), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [264322] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(12701), 1,
      anon_sym_LPAREN_PIPE,
    STATE(6231), 1,
      sym_active_pattern,
    STATE(11233), 1,
      sym__identifier_or_op,
    ACTIONS(12703), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(8748), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [264363] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12989), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10604), 1,
      sym_type_argument_constraints,
    STATE(8749), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [264406] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(10721), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8750), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [264447] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12991), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(11423), 1,
      sym_type_argument_constraints,
    STATE(8751), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [264490] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12993), 1,
      sym_identifier,
    ACTIONS(12995), 1,
      anon_sym_member,
    STATE(6322), 1,
      sym_member_signature,
    STATE(9568), 1,
      sym_access_modifier,
    STATE(8752), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [264533] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8217), 1,
      anon_sym_let,
    ACTIONS(8219), 1,
      anon_sym_let_BANG,
    ACTIONS(12997), 1,
      anon_sym_do,
    STATE(3823), 1,
      sym_function_or_value_defn,
    STATE(3829), 1,
      sym_do,
    STATE(8753), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [264576] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(12999), 1,
      anon_sym_GT,
    STATE(8749), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10605), 1,
      sym_type_argument_constraints,
    STATE(8754), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [264619] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13001), 1,
      sym_identifier,
    ACTIONS(13003), 1,
      anon_sym_member,
    STATE(7551), 1,
      sym_member_signature,
    STATE(9415), 1,
      sym_access_modifier,
    STATE(8755), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [264662] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(13005), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10618), 1,
      sym_type_argument_constraints,
    STATE(8756), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [264705] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(13007), 1,
      anon_sym_GT,
    STATE(8756), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10619), 1,
      sym_type_argument_constraints,
    STATE(8757), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [264748] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3496), 1,
      anon_sym_COLON_GT,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10597), 1,
      anon_sym_or,
    STATE(7187), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(3498), 2,
      anon_sym_COLON,
      sym_identifier,
    STATE(8758), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [264789] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(13009), 1,
      anon_sym_GT,
    STATE(8779), 1,
      aux_sym_type_arguments_repeat1,
    STATE(11763), 1,
      sym_type_argument_constraints,
    STATE(8759), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [264832] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(13011), 1,
      anon_sym_GT,
    STATE(8703), 1,
      aux_sym_type_arguments_repeat1,
    STATE(11179), 1,
      sym_type_argument_constraints,
    STATE(8760), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [264875] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(13013), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10629), 1,
      sym_type_argument_constraints,
    STATE(8761), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [264918] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10893), 1,
      anon_sym_do,
    ACTIONS(10895), 1,
      anon_sym_let,
    ACTIONS(10897), 1,
      anon_sym_let_BANG,
    STATE(7612), 1,
      sym_do,
    STATE(7617), 1,
      sym_function_or_value_defn,
    STATE(8762), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [264961] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(13015), 1,
      anon_sym_GT,
    STATE(8766), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10754), 1,
      sym_type_argument_constraints,
    STATE(8763), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [265004] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(13017), 1,
      anon_sym_GT,
    STATE(8761), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10630), 1,
      sym_type_argument_constraints,
    STATE(8764), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [265047] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13019), 1,
      sym_identifier,
    ACTIONS(13021), 1,
      anon_sym_member,
    STATE(7625), 1,
      sym_member_signature,
    STATE(9535), 1,
      sym_access_modifier,
    STATE(8765), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [265090] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(13023), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10751), 1,
      sym_type_argument_constraints,
    STATE(8766), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [265133] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13001), 1,
      sym_identifier,
    ACTIONS(13025), 1,
      anon_sym_member,
    STATE(7585), 1,
      sym_member_signature,
    STATE(9446), 1,
      sym_access_modifier,
    STATE(8767), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [265176] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(13027), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10642), 1,
      sym_type_argument_constraints,
    STATE(8768), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [265219] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(13029), 1,
      anon_sym_GT,
    STATE(8768), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10643), 1,
      sym_type_argument_constraints,
    STATE(8769), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [265262] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7480), 1,
      anon_sym_let,
    ACTIONS(7482), 1,
      anon_sym_let_BANG,
    ACTIONS(13031), 1,
      anon_sym_do,
    STATE(6383), 1,
      sym_do,
    STATE(6397), 1,
      sym_function_or_value_defn,
    STATE(8770), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [265305] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(13033), 1,
      anon_sym_GT,
    STATE(8736), 1,
      aux_sym_type_arguments_repeat1,
    STATE(11665), 1,
      sym_type_argument_constraints,
    STATE(8771), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [265348] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(13035), 1,
      anon_sym_GT,
    STATE(8774), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10738), 1,
      sym_type_argument_constraints,
    STATE(8772), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [265391] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11131), 1,
      anon_sym_do,
    ACTIONS(11133), 1,
      anon_sym_let,
    ACTIONS(11135), 1,
      anon_sym_let_BANG,
    STATE(7515), 1,
      sym_function_or_value_defn,
    STATE(7516), 1,
      sym_do,
    STATE(8773), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [265434] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(13037), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10736), 1,
      sym_type_argument_constraints,
    STATE(8774), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [265477] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12993), 1,
      sym_identifier,
    ACTIONS(13039), 1,
      anon_sym_member,
    STATE(6320), 1,
      sym_member_signature,
    STATE(9503), 1,
      sym_access_modifier,
    STATE(8775), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [265520] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(12701), 1,
      anon_sym_LPAREN_PIPE,
    STATE(4302), 1,
      sym__identifier_or_op,
    STATE(6231), 1,
      sym_active_pattern,
    ACTIONS(12703), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(8776), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [265561] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(10764), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8777), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [265602] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(13041), 1,
      anon_sym_GT,
    STATE(8787), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10713), 1,
      sym_type_argument_constraints,
    STATE(8778), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [265645] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(13043), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(11747), 1,
      sym_type_argument_constraints,
    STATE(8779), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [265688] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(13045), 1,
      anon_sym_GT,
    STATE(8751), 1,
      aux_sym_type_arguments_repeat1,
    STATE(11433), 1,
      sym_type_argument_constraints,
    STATE(8780), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [265731] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(1904), 1,
      anon_sym_LPAREN_PIPE,
    STATE(3370), 1,
      sym__identifier_or_op,
    STATE(3466), 1,
      sym_active_pattern,
    ACTIONS(3073), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(8781), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [265772] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(13047), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10654), 1,
      sym_type_argument_constraints,
    STATE(8782), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [265815] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13051), 1,
      sym__indent,
    ACTIONS(13053), 1,
      sym__struct_begin,
    ACTIONS(13055), 1,
      sym__interface_begin,
    ACTIONS(13049), 2,
      anon_sym_begin,
      anon_sym_class,
    STATE(8783), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [265856] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(10344), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8784), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [265897] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(13057), 1,
      anon_sym_GT,
    STATE(8782), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10656), 1,
      sym_type_argument_constraints,
    STATE(8785), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [265940] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(723), 1,
      anon_sym_LPAREN_PIPE,
    STATE(1928), 1,
      sym_active_pattern,
    STATE(1968), 1,
      sym__identifier_or_op,
    ACTIONS(2644), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(8786), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [265981] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(13059), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10711), 1,
      sym_type_argument_constraints,
    STATE(8787), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [266024] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(455), 1,
      anon_sym_LPAREN_PIPE,
    STATE(1754), 1,
      sym_active_pattern,
    STATE(1818), 1,
      sym__identifier_or_op,
    ACTIONS(3165), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(8788), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [266065] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8262), 1,
      anon_sym_let,
    ACTIONS(8264), 1,
      anon_sym_let_BANG,
    ACTIONS(13061), 1,
      anon_sym_do,
    STATE(6837), 1,
      sym_function_or_value_defn,
    STATE(6839), 1,
      sym_do,
    STATE(8789), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [266108] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(13063), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10666), 1,
      sym_type_argument_constraints,
    STATE(8790), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [266151] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(13065), 1,
      anon_sym_GT,
    STATE(8790), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10668), 1,
      sym_type_argument_constraints,
    STATE(8791), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [266194] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(1193), 1,
      anon_sym_LPAREN_PIPE,
    STATE(3172), 1,
      sym_active_pattern,
    STATE(3199), 1,
      sym__identifier_or_op,
    ACTIONS(3175), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(8792), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [266235] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(13067), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10189), 1,
      sym_type_argument_constraints,
    STATE(8793), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [266278] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13019), 1,
      sym_identifier,
    ACTIONS(13069), 1,
      anon_sym_member,
    STATE(7627), 1,
      sym_member_signature,
    STATE(9459), 1,
      sym_access_modifier,
    STATE(8794), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [266321] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(13071), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10679), 1,
      sym_type_argument_constraints,
    STATE(8795), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [266364] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12609), 1,
      anon_sym__,
    STATE(8758), 1,
      sym__static_type_identifier,
    STATE(10806), 1,
      sym_type_argument,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8796), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [266405] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(13073), 1,
      anon_sym_GT,
    STATE(8795), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10681), 1,
      sym_type_argument_constraints,
    STATE(8797), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [266448] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5251), 1,
      anon_sym_LPAREN_PIPE,
    STATE(4932), 1,
      sym_active_pattern,
    STATE(5052), 1,
      sym__identifier_or_op,
    ACTIONS(5253), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(8798), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [266489] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(13075), 1,
      anon_sym_GT,
    STATE(8886), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10694), 1,
      sym_type_argument_constraints,
    STATE(8799), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [266532] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12713), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_when,
    ACTIONS(13077), 1,
      anon_sym_GT,
    STATE(8799), 1,
      aux_sym_type_arguments_repeat1,
    STATE(10695), 1,
      sym_type_argument_constraints,
    STATE(8800), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [266575] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12887), 1,
      sym_identifier,
    STATE(7088), 1,
      sym_member_signature,
    STATE(9601), 1,
      sym_access_modifier,
    STATE(8801), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [266615] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13079), 1,
      sym_identifier,
    ACTIONS(13081), 1,
      anon_sym_mutable,
    STATE(11265), 1,
      sym_access_modifier,
    STATE(8802), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [266655] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6850), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8803), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [266689] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13083), 1,
      anon_sym_new,
    ACTIONS(13085), 1,
      anon_sym_static,
    ACTIONS(13087), 1,
      anon_sym_member,
    STATE(11718), 1,
      sym_trait_member_constraint,
    STATE(8804), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [266729] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13089), 1,
      sym_identifier,
    ACTIONS(13091), 1,
      anon_sym_global,
    ACTIONS(13093), 1,
      anon_sym_rec,
    STATE(546), 1,
      sym_long_identifier,
    STATE(8805), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [266769] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13097), 1,
      sym__indent,
    ACTIONS(13099), 1,
      sym__struct_begin,
    ACTIONS(13095), 2,
      anon_sym_begin,
      anon_sym_class,
    STATE(8806), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [266807] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13101), 1,
      sym_identifier,
    STATE(553), 1,
      sym_long_identifier,
    STATE(9768), 1,
      sym_access_modifier,
    STATE(8807), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [266847] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13001), 1,
      sym_identifier,
    STATE(7609), 1,
      sym_member_signature,
    STATE(9421), 1,
      sym_access_modifier,
    STATE(8808), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [266887] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9025), 1,
      anon_sym_and,
    ACTIONS(13103), 1,
      anon_sym_LBRACK_LT,
    STATE(9964), 1,
      sym__attribute_set,
    STATE(8809), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_attributes_repeat1,
  [266925] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13106), 1,
      sym_identifier,
    ACTIONS(13108), 1,
      anon_sym_mutable,
    STATE(10519), 1,
      sym_access_modifier,
    STATE(8810), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [266965] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3741), 1,
      sym__dedent,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13110), 1,
      anon_sym_PIPE,
    ACTIONS(13113), 1,
      sym__newline,
    STATE(8811), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_rules_repeat1,
  [267003] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13116), 1,
      sym_identifier,
    ACTIONS(13118), 1,
      anon_sym_mutable,
    STATE(11448), 1,
      sym_access_modifier,
    STATE(8812), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [267043] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9007), 1,
      anon_sym_and,
    ACTIONS(12433), 1,
      anon_sym_LBRACK_LT,
    STATE(8809), 1,
      aux_sym_attributes_repeat1,
    STATE(9964), 1,
      sym__attribute_set,
    STATE(8813), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [267083] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6622), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
    STATE(8814), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [267117] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6618), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
    STATE(8815), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [267151] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13019), 1,
      sym_identifier,
    STATE(7625), 1,
      sym_member_signature,
    STATE(9535), 1,
      sym_access_modifier,
    STATE(8816), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [267191] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13120), 1,
      sym_identifier,
    STATE(558), 1,
      sym_long_identifier,
    STATE(10050), 1,
      sym_access_modifier,
    STATE(8817), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [267231] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3674), 1,
      sym__dedent,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13122), 1,
      anon_sym_PIPE,
    ACTIONS(13124), 1,
      sym__newline,
    STATE(8811), 1,
      aux_sym_rules_repeat1,
    STATE(8818), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [267271] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13126), 1,
      sym_identifier,
    ACTIONS(13128), 1,
      anon_sym_mutable,
    STATE(11235), 1,
      sym_access_modifier,
    STATE(8819), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [267311] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13130), 1,
      sym_identifier,
    ACTIONS(13132), 1,
      anon_sym_mutable,
    STATE(10716), 1,
      sym_access_modifier,
    STATE(8820), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [267351] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12993), 1,
      sym_identifier,
    STATE(6322), 1,
      sym_member_signature,
    STATE(9568), 1,
      sym_access_modifier,
    STATE(8821), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [267391] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6748), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
    STATE(8822), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [267425] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13001), 1,
      sym_identifier,
    STATE(7585), 1,
      sym_member_signature,
    STATE(9446), 1,
      sym_access_modifier,
    STATE(8823), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [267465] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13134), 1,
      sym_identifier,
    ACTIONS(13136), 1,
      anon_sym_mutable,
    STATE(11443), 1,
      sym_access_modifier,
    STATE(8824), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [267505] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6668), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
    STATE(8825), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [267539] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6674), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
    STATE(8826), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [267573] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6678), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8827), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [267607] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13138), 1,
      sym_identifier,
    ACTIONS(13140), 1,
      anon_sym_mutable,
    STATE(11254), 1,
      sym_access_modifier,
    STATE(8828), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [267647] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6752), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
    STATE(8829), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [267681] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6748), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8830), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [267715] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13142), 1,
      sym_identifier,
    ACTIONS(13144), 1,
      anon_sym_mutable,
    STATE(11477), 1,
      sym_access_modifier,
    STATE(8831), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [267755] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6761), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8832), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [267789] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6646), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8833), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [267823] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13085), 1,
      anon_sym_static,
    ACTIONS(13087), 1,
      anon_sym_member,
    ACTIONS(13146), 1,
      anon_sym_new,
    STATE(11920), 1,
      sym_trait_member_constraint,
    STATE(8834), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [267863] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13148), 1,
      sym_identifier,
    ACTIONS(13150), 1,
      anon_sym_mutable,
    STATE(11485), 1,
      sym_access_modifier,
    STATE(8835), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [267903] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6767), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8836), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [267937] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6797), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
    STATE(8837), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [267971] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13085), 1,
      anon_sym_static,
    ACTIONS(13087), 1,
      anon_sym_member,
    ACTIONS(13152), 1,
      anon_sym_new,
    STATE(11157), 1,
      sym_trait_member_constraint,
    STATE(8838), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [268011] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13019), 1,
      sym_identifier,
    STATE(7597), 1,
      sym_member_signature,
    STATE(9596), 1,
      sym_access_modifier,
    STATE(8839), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [268051] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6694), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8840), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [268085] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6801), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
    STATE(8841), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [268119] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12993), 1,
      sym_identifier,
    STATE(6342), 1,
      sym_member_signature,
    STATE(9617), 1,
      sym_access_modifier,
    STATE(8842), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [268159] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3691), 1,
      sym__dedent,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13122), 1,
      anon_sym_PIPE,
    ACTIONS(13124), 1,
      sym__newline,
    STATE(8811), 1,
      aux_sym_rules_repeat1,
    STATE(8843), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [268199] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6821), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8844), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [268233] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6652), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8845), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [268267] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12799), 1,
      sym_identifier,
    STATE(3810), 1,
      sym_member_signature,
    STATE(9669), 1,
      sym_access_modifier,
    STATE(8846), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [268307] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6817), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
    STATE(8847), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [268341] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3691), 1,
      sym__dedent,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13122), 1,
      anon_sym_PIPE,
    ACTIONS(13124), 1,
      sym__newline,
    STATE(8818), 1,
      aux_sym_rules_repeat1,
    STATE(8848), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [268381] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13154), 1,
      sym_identifier,
    ACTIONS(13156), 1,
      anon_sym_mutable,
    STATE(11435), 1,
      sym_access_modifier,
    STATE(8849), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [268421] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6646), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
    STATE(8850), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [268455] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6690), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8851), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [268489] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12887), 1,
      sym_identifier,
    STATE(6954), 1,
      sym_member_signature,
    STATE(9583), 1,
      sym_access_modifier,
    STATE(8852), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [268529] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13158), 1,
      sym_identifier,
    ACTIONS(13160), 1,
      anon_sym_mutable,
    STATE(11649), 1,
      sym_access_modifier,
    STATE(8853), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [268569] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6821), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
    STATE(8854), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [268603] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13162), 1,
      ts_builtin_sym_end,
    ACTIONS(13164), 1,
      anon_sym_namespace,
    STATE(9811), 1,
      sym_namespace,
    STATE(8855), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_file_repeat1,
  [268641] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13085), 1,
      anon_sym_static,
    ACTIONS(13087), 1,
      anon_sym_member,
    ACTIONS(13167), 1,
      anon_sym_new,
    STATE(11405), 1,
      sym_trait_member_constraint,
    STATE(8856), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [268681] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13169), 1,
      sym_identifier,
    STATE(9004), 1,
      sym_field_initializer,
    STATE(10334), 1,
      sym_long_identifier,
    STATE(10416), 1,
      sym_field_initializers,
    STATE(8857), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [268721] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9717), 1,
      anon_sym_interface,
    ACTIONS(13171), 1,
      sym__dedent,
    STATE(8921), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(9855), 1,
      sym_interface_implementation,
    STATE(8858), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [268761] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13173), 1,
      sym_identifier,
    ACTIONS(13175), 1,
      anon_sym_mutable,
    STATE(11645), 1,
      sym_access_modifier,
    STATE(8859), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [268801] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13179), 1,
      anon_sym_mutable,
    STATE(11637), 1,
      sym_access_modifier,
    STATE(8860), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [268841] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3726), 4,
      sym__dedent,
      anon_sym_PIPE,
      anon_sym_f,
      aux_sym_decimal_token1,
    STATE(8861), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [268875] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13085), 1,
      anon_sym_static,
    ACTIONS(13087), 1,
      anon_sym_member,
    ACTIONS(13181), 1,
      anon_sym_new,
    STATE(11641), 1,
      sym_trait_member_constraint,
    STATE(8862), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [268915] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6539), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8863), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [268949] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6767), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
    STATE(8864), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [268983] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13183), 1,
      sym_identifier,
    ACTIONS(13185), 1,
      anon_sym_mutable,
    STATE(11314), 1,
      sym_access_modifier,
    STATE(8865), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [269023] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13187), 1,
      sym_identifier,
    ACTIONS(13189), 1,
      anon_sym_mutable,
    STATE(11330), 1,
      sym_access_modifier,
    STATE(8866), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [269063] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13193), 1,
      sym__indent,
    ACTIONS(13195), 1,
      sym__struct_begin,
    ACTIONS(13191), 2,
      anon_sym_begin,
      anon_sym_class,
    STATE(8867), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [269101] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13197), 1,
      sym_identifier,
    ACTIONS(13199), 1,
      anon_sym_mutable,
    STATE(11490), 1,
      sym_access_modifier,
    STATE(8868), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [269141] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6817), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8869), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [269175] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3602), 4,
      sym__dedent,
      anon_sym_PIPE,
      anon_sym_f,
      aux_sym_decimal_token1,
    STATE(8870), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [269209] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13201), 1,
      sym_identifier,
    ACTIONS(13203), 1,
      anon_sym_mutable,
    STATE(11404), 1,
      sym_access_modifier,
    STATE(8871), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [269249] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13205), 1,
      sym_identifier,
    ACTIONS(13207), 1,
      anon_sym_mutable,
    STATE(11613), 1,
      sym_access_modifier,
    STATE(8872), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [269289] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6801), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8873), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [269323] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13209), 1,
      sym_identifier,
    ACTIONS(13211), 1,
      anon_sym_mutable,
    STATE(11608), 1,
      sym_access_modifier,
    STATE(8874), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [269363] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6797), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8875), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [269397] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13213), 1,
      sym_identifier,
    ACTIONS(13215), 1,
      anon_sym_mutable,
    STATE(11527), 1,
      sym_access_modifier,
    STATE(8876), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [269437] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6761), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
    STATE(8877), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [269471] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6652), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
    STATE(8878), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [269505] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6752), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8879), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [269539] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12747), 1,
      sym_identifier,
    STATE(6866), 1,
      sym_member_signature,
    STATE(10105), 1,
      sym_access_modifier,
    STATE(8880), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [269579] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13085), 1,
      anon_sym_static,
    ACTIONS(13087), 1,
      anon_sym_member,
    ACTIONS(13217), 1,
      anon_sym_new,
    STATE(11481), 1,
      sym_trait_member_constraint,
    STATE(8881), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [269619] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12859), 1,
      sym_identifier,
    STATE(6601), 1,
      sym_member_signature,
    STATE(9869), 1,
      sym_access_modifier,
    STATE(8882), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [269659] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6674), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8883), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [269693] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10265), 1,
      aux_sym_decimal_token1,
    ACTIONS(10570), 1,
      anon_sym_f,
    ACTIONS(3191), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(8884), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [269731] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13219), 1,
      sym_identifier,
    ACTIONS(13221), 1,
      anon_sym_mutable,
    STATE(11600), 1,
      sym_access_modifier,
    STATE(8885), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [269771] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13223), 1,
      anon_sym_COMMA,
    ACTIONS(13226), 2,
      anon_sym_GT,
      anon_sym_when,
    STATE(8886), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_arguments_repeat1,
  [269807] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6668), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8887), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [269841] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6618), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8888), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [269875] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13228), 1,
      sym_identifier,
    ACTIONS(13230), 1,
      anon_sym_mutable,
    STATE(10997), 1,
      sym_access_modifier,
    STATE(8889), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [269915] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13232), 1,
      anon_sym_and,
    STATE(8911), 1,
      aux_sym__function_or_value_defns_repeat1,
    ACTIONS(6156), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8890), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [269953] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6622), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8891), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [269987] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12859), 1,
      sym_identifier,
    STATE(6610), 1,
      sym_member_signature,
    STATE(9902), 1,
      sym_access_modifier,
    STATE(8892), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [270027] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13236), 1,
      sym__indent,
    ACTIONS(13238), 1,
      sym__struct_begin,
    ACTIONS(13234), 2,
      anon_sym_begin,
      anon_sym_class,
    STATE(8893), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [270065] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6842), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
    STATE(8894), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [270099] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13240), 1,
      sym_identifier,
    ACTIONS(13242), 1,
      anon_sym_mutable,
    STATE(11573), 1,
      sym_access_modifier,
    STATE(8895), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [270139] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9717), 1,
      anon_sym_interface,
    ACTIONS(13244), 1,
      sym__dedent,
    STATE(8901), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(9855), 1,
      sym_interface_implementation,
    STATE(8896), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [270179] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13246), 1,
      sym_identifier,
    ACTIONS(13248), 1,
      anon_sym_mutable,
    STATE(11394), 1,
      sym_access_modifier,
    STATE(8897), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [270219] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13250), 1,
      sym_identifier,
    ACTIONS(13252), 1,
      anon_sym_mutable,
    STATE(11380), 1,
      sym_access_modifier,
    STATE(8898), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [270259] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6791), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
    STATE(8899), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [270293] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12723), 1,
      sym_identifier,
    STATE(6590), 1,
      sym_member_signature,
    STATE(9823), 1,
      sym_access_modifier,
    STATE(8900), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [270333] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13254), 1,
      anon_sym_interface,
    ACTIONS(13257), 1,
      sym__dedent,
    STATE(9855), 1,
      sym_interface_implementation,
    STATE(8901), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__object_expression_inner_repeat1,
  [270371] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13259), 1,
      sym_identifier,
    ACTIONS(13261), 1,
      anon_sym_mutable,
    STATE(10274), 1,
      sym_access_modifier,
    STATE(8902), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [270411] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13263), 1,
      sym_identifier,
    ACTIONS(13265), 1,
      anon_sym_mutable,
    STATE(11569), 1,
      sym_access_modifier,
    STATE(8903), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [270451] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13267), 1,
      sym_identifier,
    ACTIONS(13269), 1,
      anon_sym_mutable,
    STATE(11561), 1,
      sym_access_modifier,
    STATE(8904), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [270491] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9717), 1,
      anon_sym_interface,
    ACTIONS(13271), 1,
      sym__dedent,
    STATE(8896), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(9855), 1,
      sym_interface_implementation,
    STATE(8905), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [270531] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3734), 1,
      sym__dedent,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13122), 1,
      anon_sym_PIPE,
    ACTIONS(13124), 1,
      sym__newline,
    STATE(8843), 1,
      aux_sym_rules_repeat1,
    STATE(8906), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [270571] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6539), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
    STATE(8907), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [270605] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12799), 1,
      sym_identifier,
    STATE(3798), 1,
      sym_member_signature,
    STATE(9942), 1,
      sym_access_modifier,
    STATE(8908), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [270645] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13232), 1,
      anon_sym_and,
    STATE(8890), 1,
      aux_sym__function_or_value_defns_repeat1,
    ACTIONS(6190), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8909), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [270683] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13275), 1,
      sym__indent,
    ACTIONS(13277), 1,
      sym__struct_begin,
    ACTIONS(13273), 2,
      anon_sym_begin,
      anon_sym_class,
    STATE(8910), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [270721] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13279), 1,
      anon_sym_and,
    ACTIONS(6115), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8911), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__function_or_value_defns_repeat1,
  [270757] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(2563), 1,
      ts_builtin_sym_end,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13282), 1,
      anon_sym_namespace,
    STATE(8855), 1,
      aux_sym_file_repeat1,
    STATE(9811), 1,
      sym_namespace,
    STATE(8912), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [270797] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12771), 1,
      sym_identifier,
    STATE(6808), 1,
      sym_member_signature,
    STATE(9770), 1,
      sym_access_modifier,
    STATE(8913), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [270837] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6842), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8914), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [270871] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12779), 1,
      sym_identifier,
    STATE(6487), 1,
      sym_member_signature,
    STATE(9860), 1,
      sym_access_modifier,
    STATE(8915), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [270911] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6850), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
    STATE(8916), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [270945] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13284), 1,
      sym_identifier,
    ACTIONS(13286), 1,
      anon_sym_mutable,
    STATE(11532), 1,
      sym_access_modifier,
    STATE(8917), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [270985] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13085), 1,
      anon_sym_static,
    ACTIONS(13087), 1,
      anon_sym_member,
    ACTIONS(13288), 1,
      anon_sym_new,
    STATE(11810), 1,
      sym_trait_member_constraint,
    STATE(8918), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [271025] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12771), 1,
      sym_identifier,
    STATE(6780), 1,
      sym_member_signature,
    STATE(9792), 1,
      sym_access_modifier,
    STATE(8919), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [271065] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13085), 1,
      anon_sym_static,
    ACTIONS(13087), 1,
      anon_sym_member,
    ACTIONS(13290), 1,
      anon_sym_new,
    STATE(11564), 1,
      sym_trait_member_constraint,
    STATE(8920), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [271105] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9717), 1,
      anon_sym_interface,
    ACTIONS(13292), 1,
      sym__dedent,
    STATE(8901), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(9855), 1,
      sym_interface_implementation,
    STATE(8921), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [271145] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6694), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
    STATE(8922), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [271179] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12723), 1,
      sym_identifier,
    STATE(6563), 1,
      sym_member_signature,
    STATE(10038), 1,
      sym_access_modifier,
    STATE(8923), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [271219] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6791), 4,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8924), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [271253] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13294), 1,
      sym_identifier,
    ACTIONS(13296), 1,
      anon_sym_mutable,
    STATE(11519), 1,
      sym_access_modifier,
    STATE(8925), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [271293] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12779), 1,
      sym_identifier,
    STATE(6425), 1,
      sym_member_signature,
    STATE(9922), 1,
      sym_access_modifier,
    STATE(8926), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [271333] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6678), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
    STATE(8927), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [271367] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6690), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
    STATE(8928), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [271401] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13298), 1,
      sym_identifier,
    ACTIONS(13300), 1,
      anon_sym_mutable,
    STATE(11340), 1,
      sym_access_modifier,
    STATE(8929), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [271441] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12747), 1,
      sym_identifier,
    STATE(6907), 1,
      sym_member_signature,
    STATE(10149), 1,
      sym_access_modifier,
    STATE(8930), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [271481] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13302), 1,
      anon_sym_PIPE_RBRACK,
    ACTIONS(13304), 1,
      sym__indent,
    STATE(11025), 1,
      sym__list_element,
    STATE(8931), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [271518] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11590), 1,
      sym__dedent,
    ACTIONS(13306), 1,
      sym__newline,
    STATE(8935), 1,
      aux_sym_record_fields_repeat1,
    STATE(8932), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [271555] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13308), 1,
      sym_identifier,
    STATE(9308), 1,
      sym_field_pattern,
    STATE(11399), 1,
      sym_long_identifier,
    STATE(8933), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [271592] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6156), 1,
      anon_sym_POUNDendif,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13310), 1,
      anon_sym_and,
    STATE(8937), 1,
      aux_sym__function_or_value_defns_repeat1,
    STATE(8934), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [271629] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13312), 1,
      sym__newline,
    ACTIONS(13315), 1,
      sym__dedent,
    STATE(8935), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_record_fields_repeat1,
  [271664] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7895), 1,
      anon_sym_GT,
    ACTIONS(13317), 1,
      anon_sym_and,
    STATE(9267), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(8936), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [271701] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6115), 1,
      anon_sym_POUNDendif,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13319), 1,
      anon_sym_and,
    STATE(8937), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__function_or_value_defns_repeat1,
  [271736] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6190), 1,
      anon_sym_POUNDendif,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13310), 1,
      anon_sym_and,
    STATE(8934), 1,
      aux_sym__function_or_value_defns_repeat1,
    STATE(8938), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [271773] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(9278), 1,
      sym_property_accessor,
    ACTIONS(13322), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(8939), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [271808] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6426), 3,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8940), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [271841] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6821), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(8941), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [271874] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13324), 1,
      sym_identifier,
    STATE(11270), 1,
      sym_access_modifier,
    STATE(8942), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [271911] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6300), 3,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8943), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [271944] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13326), 1,
      anon_sym_EQ,
    ACTIONS(13328), 1,
      anon_sym_COLON,
    STATE(6866), 1,
      sym__val_property_defn,
    STATE(8944), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [271981] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6316), 3,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(8945), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [272014] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13330), 1,
      anon_sym_COMMA,
    ACTIONS(13333), 1,
      anon_sym_GT,
    STATE(8946), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_attributes_repeat1,
  [272049] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13335), 1,
      anon_sym_with,
    ACTIONS(13337), 1,
      anon_sym_finally,
    ACTIONS(13339), 1,
      sym__newline,
    STATE(8947), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [272086] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13341), 1,
      anon_sym_PIPE,
    ACTIONS(13343), 1,
      sym__dedent,
    STATE(9312), 1,
      aux_sym_enum_type_cases_repeat1,
    STATE(8948), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [272123] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6726), 1,
      anon_sym_LT2,
    ACTIONS(13345), 1,
      anon_sym_COLON,
    STATE(11838), 1,
      sym_type_arguments,
    STATE(8949), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [272160] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13079), 1,
      sym_identifier,
    STATE(11265), 1,
      sym_access_modifier,
    STATE(8950), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [272197] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13347), 1,
      anon_sym_EQ,
    ACTIONS(13349), 1,
      anon_sym_COLON,
    STATE(6498), 1,
      sym__val_property_defn,
    STATE(8951), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [272234] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13351), 1,
      anon_sym_RBRACE,
    ACTIONS(13353), 1,
      sym__newline,
    STATE(9093), 1,
      aux_sym_record_pattern_repeat1,
    STATE(8952), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [272271] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13213), 1,
      sym_identifier,
    STATE(11527), 1,
      sym_access_modifier,
    STATE(8953), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [272308] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13355), 1,
      anon_sym_RPAREN,
    ACTIONS(13357), 1,
      sym__newline,
    STATE(9120), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(8954), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [272345] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6726), 1,
      anon_sym_LT2,
    ACTIONS(13359), 1,
      anon_sym_COLON,
    STATE(11759), 1,
      sym_type_arguments,
    STATE(8955), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [272382] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(13361), 1,
      anon_sym_RBRACK,
    STATE(10967), 1,
      sym__list_element,
    STATE(8956), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [272419] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(13363), 1,
      anon_sym_PIPE_RBRACK,
    STATE(10966), 1,
      sym__list_element,
    STATE(8957), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [272456] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13365), 1,
      anon_sym_with,
    ACTIONS(13367), 1,
      anon_sym_finally,
    ACTIONS(13369), 1,
      sym__newline,
    STATE(8958), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [272493] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13308), 1,
      sym_identifier,
    STATE(9229), 1,
      sym_field_pattern,
    STATE(11399), 1,
      sym_long_identifier,
    STATE(8959), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [272530] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13373), 1,
      sym__dedent,
    STATE(8963), 1,
      aux_sym__property_defn_repeat1,
    STATE(8960), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [272567] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13375), 1,
      anon_sym_EQ,
    ACTIONS(13377), 1,
      anon_sym_as,
    STATE(11131), 1,
      sym_class_as_reference,
    STATE(8961), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [272604] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13379), 1,
      sym__newline,
    ACTIONS(13381), 1,
      sym__dedent,
    STATE(9198), 1,
      aux_sym__class_type_body_repeat1,
    STATE(8962), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [272641] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13383), 1,
      sym__dedent,
    STATE(9101), 1,
      aux_sym__property_defn_repeat1,
    STATE(8963), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [272678] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13385), 1,
      anon_sym_PIPE,
    ACTIONS(13387), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9293), 1,
      aux_sym_active_pattern_repeat1,
    STATE(8964), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [272715] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13389), 1,
      sym__dedent,
    STATE(8973), 1,
      aux_sym__property_defn_repeat1,
    STATE(8965), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [272752] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13226), 3,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_when,
    STATE(8966), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [272785] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6622), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(8967), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [272818] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6618), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(8968), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [272851] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13391), 1,
      anon_sym_PIPE,
    ACTIONS(13393), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9293), 1,
      aux_sym_active_pattern_repeat1,
    STATE(8969), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [272888] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(9160), 1,
      sym_property_accessor,
    ACTIONS(13322), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(8970), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [272923] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13284), 1,
      sym_identifier,
    STATE(11532), 1,
      sym_access_modifier,
    STATE(8971), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [272960] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13395), 1,
      sym__newline,
    ACTIONS(13397), 1,
      sym__dedent,
    STATE(9193), 1,
      aux_sym__module_body_repeat1,
    STATE(8972), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [272997] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13399), 1,
      sym__dedent,
    STATE(9101), 1,
      aux_sym__property_defn_repeat1,
    STATE(8973), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [273034] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13401), 1,
      anon_sym_PIPE,
    ACTIONS(13403), 1,
      anon_sym_PIPE_RPAREN,
    STATE(8992), 1,
      aux_sym_active_pattern_repeat1,
    STATE(8974), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [273071] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6668), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(8975), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [273104] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6674), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(8976), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [273137] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13138), 1,
      sym_identifier,
    STATE(11254), 1,
      sym_access_modifier,
    STATE(8977), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [273174] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(2632), 1,
      sym__static_type_identifier,
    ACTIONS(9138), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8978), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [273209] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13405), 1,
      anon_sym_PIPE,
    ACTIONS(13407), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9293), 1,
      aux_sym_active_pattern_repeat1,
    STATE(8979), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [273246] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13353), 1,
      sym__newline,
    ACTIONS(13409), 1,
      anon_sym_RBRACE,
    STATE(8952), 1,
      aux_sym_record_pattern_repeat1,
    STATE(8980), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [273283] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(4000), 1,
      sym__static_type_identifier,
    ACTIONS(9148), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8981), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [273318] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13411), 1,
      anon_sym_EQ,
    ACTIONS(13413), 1,
      anon_sym_COLON,
    STATE(6590), 1,
      sym__val_property_defn,
    STATE(8982), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [273355] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13415), 1,
      anon_sym_DASH_GT,
    ACTIONS(13417), 1,
      anon_sym_STAR,
    STATE(9232), 1,
      aux_sym_arguments_spec_repeat1,
    STATE(8983), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [273392] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13419), 1,
      anon_sym_PIPE,
    ACTIONS(13421), 1,
      anon_sym_PIPE_RPAREN,
    STATE(8964), 1,
      aux_sym_active_pattern_repeat1,
    STATE(8984), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [273429] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11362), 1,
      anon_sym_GT,
    ACTIONS(13423), 1,
      anon_sym_COMMA,
    STATE(8985), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_types_repeat1,
  [273464] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6752), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(8986), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [273497] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13357), 1,
      sym__newline,
    ACTIONS(13426), 1,
      anon_sym_RPAREN,
    STATE(8954), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(8987), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [273534] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6797), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(8988), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [273567] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6801), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(8989), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [273600] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6817), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(8990), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [273633] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6652), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(8991), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [273666] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13428), 1,
      anon_sym_PIPE,
    ACTIONS(13430), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9293), 1,
      aux_sym_active_pattern_repeat1,
    STATE(8992), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [273703] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6694), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(8993), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [273736] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(13432), 1,
      anon_sym_RBRACK,
    STATE(11216), 1,
      sym__list_element,
    STATE(8994), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [273773] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(13434), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11214), 1,
      sym__list_element,
    STATE(8995), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [273810] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13436), 1,
      anon_sym_EQ,
    ACTIONS(13438), 1,
      anon_sym_COLON,
    STATE(3798), 1,
      sym__val_property_defn,
    STATE(8996), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [273847] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6646), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(8997), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [273880] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7085), 1,
      sym__static_type_identifier,
    ACTIONS(9438), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(8998), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [273915] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13440), 1,
      sym__dedent,
    STATE(9101), 1,
      aux_sym__property_defn_repeat1,
    STATE(8999), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [273952] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(13442), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11295), 1,
      sym__list_element,
    STATE(9000), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [273989] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13444), 1,
      sym__dedent,
    STATE(9101), 1,
      aux_sym__property_defn_repeat1,
    STATE(9001), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [274026] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13446), 1,
      anon_sym_COMMA,
    ACTIONS(13448), 1,
      anon_sym_RBRACK,
    STATE(9358), 1,
      aux_sym_slice_ranges_repeat1,
    STATE(9002), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [274063] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(13450), 1,
      anon_sym_RBRACK,
    STATE(11296), 1,
      sym__list_element,
    STATE(9003), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [274100] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13452), 1,
      sym__newline,
    ACTIONS(13454), 1,
      sym__dedent,
    STATE(9221), 1,
      aux_sym_field_initializers_repeat1,
    STATE(9004), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [274137] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13456), 1,
      anon_sym_PIPE,
    ACTIONS(13458), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9043), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9005), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [274174] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13460), 1,
      sym_identifier,
    STATE(11536), 1,
      sym_access_modifier,
    STATE(9006), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [274211] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13462), 1,
      sym__dedent,
    STATE(9257), 1,
      aux_sym__property_defn_repeat1,
    STATE(9007), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [274248] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13464), 1,
      sym_identifier,
    STATE(10725), 1,
      sym_access_modifier,
    STATE(9008), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [274285] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13466), 1,
      anon_sym_PIPE,
    ACTIONS(13468), 1,
      anon_sym_PIPE_RPAREN,
    STATE(8969), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9009), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [274322] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6726), 1,
      anon_sym_LT2,
    ACTIONS(13470), 1,
      anon_sym_COLON,
    STATE(11956), 1,
      sym_type_arguments,
    STATE(9010), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [274359] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6767), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(9011), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [274392] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6748), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(9012), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [274425] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13472), 1,
      anon_sym_PIPE,
    ACTIONS(13474), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9293), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9013), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [274462] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13476), 1,
      anon_sym_PIPE_RBRACK,
    ACTIONS(13478), 1,
      sym__indent,
    STATE(11531), 1,
      sym__list_pattern_content,
    STATE(9014), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [274499] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6690), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(9015), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [274532] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6678), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(9016), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [274565] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13187), 1,
      sym_identifier,
    STATE(11330), 1,
      sym_access_modifier,
    STATE(9017), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [274602] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(9362), 1,
      sym_property_accessor,
    ACTIONS(13322), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(9018), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [274637] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13478), 1,
      sym__indent,
    ACTIONS(13480), 1,
      anon_sym_RBRACK,
    STATE(11533), 1,
      sym__list_pattern_content,
    STATE(9019), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [274674] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(2643), 1,
      sym__static_type_identifier,
    ACTIONS(9528), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9020), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [274709] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6850), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(9021), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [274742] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13482), 1,
      sym__dedent,
    STATE(8999), 1,
      aux_sym__property_defn_repeat1,
    STATE(9022), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [274779] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3698), 3,
      sym__newline,
      anon_sym_with,
      anon_sym_finally,
    STATE(9023), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [274812] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(13484), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11542), 1,
      sym__list_element,
    STATE(9024), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [274849] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13486), 1,
      sym__dedent,
    STATE(9101), 1,
      aux_sym__property_defn_repeat1,
    STATE(9025), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [274886] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(13488), 1,
      anon_sym_RBRACK,
    STATE(11547), 1,
      sym__list_element,
    STATE(9026), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [274923] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6539), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(9027), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [274956] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6761), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(9028), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [274989] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13490), 1,
      anon_sym_with,
    ACTIONS(13492), 1,
      anon_sym_finally,
    ACTIONS(13494), 1,
      sym__newline,
    STATE(9029), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [275026] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13308), 1,
      sym_identifier,
    STATE(9114), 1,
      sym_field_pattern,
    STATE(11399), 1,
      sym_long_identifier,
    STATE(9030), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [275063] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13417), 1,
      anon_sym_STAR,
    ACTIONS(13496), 1,
      anon_sym_DASH_GT,
    STATE(8983), 1,
      aux_sym_arguments_spec_repeat1,
    STATE(9031), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [275100] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13308), 1,
      sym_identifier,
    STATE(9329), 1,
      sym_field_pattern,
    STATE(11399), 1,
      sym_long_identifier,
    STATE(9032), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [275137] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13448), 1,
      sym__dedent,
    ACTIONS(13498), 1,
      anon_sym_COMMA,
    STATE(9191), 1,
      aux_sym_slice_ranges_repeat1,
    STATE(9033), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [275174] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13500), 1,
      anon_sym_with,
    ACTIONS(13502), 1,
      anon_sym_finally,
    ACTIONS(13504), 1,
      sym__newline,
    STATE(9034), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [275211] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3741), 3,
      sym__newline,
      sym__dedent,
      anon_sym_PIPE,
    STATE(9035), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [275244] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3698), 3,
      anon_sym_and,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(9036), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [275277] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(4075), 1,
      sym__static_type_identifier,
    ACTIONS(7731), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9037), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [275312] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6842), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(9038), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [275345] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3798), 3,
      sym__newline,
      sym__dedent,
      anon_sym_PIPE,
    STATE(9039), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [275378] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13506), 1,
      sym__dedent,
    STATE(9101), 1,
      aux_sym__property_defn_repeat1,
    STATE(9040), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [275415] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13263), 1,
      sym_identifier,
    STATE(11569), 1,
      sym_access_modifier,
    STATE(9041), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [275452] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13508), 1,
      sym__dedent,
    STATE(9040), 1,
      aux_sym__property_defn_repeat1,
    STATE(9042), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [275489] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13510), 1,
      anon_sym_PIPE,
    ACTIONS(13512), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9293), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9043), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [275526] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13514), 1,
      sym__dedent,
    STATE(9025), 1,
      aux_sym__property_defn_repeat1,
    STATE(9044), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [275563] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13130), 1,
      sym_identifier,
    STATE(10716), 1,
      sym_access_modifier,
    STATE(9045), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [275600] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13516), 1,
      anon_sym_PIPE,
    ACTIONS(13518), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9057), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9046), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [275637] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13520), 1,
      sym__dedent,
    STATE(9101), 1,
      aux_sym__property_defn_repeat1,
    STATE(9047), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [275674] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13522), 1,
      sym__newline,
    ACTIONS(13524), 1,
      sym__dedent,
    STATE(8932), 1,
      aux_sym_record_fields_repeat1,
    STATE(9048), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [275711] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13526), 1,
      anon_sym_GT_RBRACK,
    ACTIONS(13528), 1,
      sym__newline,
    STATE(9049), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__attribute_set_repeat1,
  [275746] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6791), 3,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(9050), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [275779] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6318), 1,
      sym__static_type_identifier,
    ACTIONS(6882), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9051), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [275814] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6726), 1,
      anon_sym_LT2,
    ACTIONS(13531), 1,
      anon_sym_COLON,
    STATE(11663), 1,
      sym_type_arguments,
    STATE(9052), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [275851] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13377), 1,
      anon_sym_as,
    ACTIONS(13533), 1,
      anon_sym_EQ,
    STATE(10986), 1,
      sym_class_as_reference,
    STATE(9053), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [275888] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13535), 1,
      sym_identifier,
    STATE(11000), 1,
      sym_access_modifier,
    STATE(9054), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [275925] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13537), 1,
      anon_sym_EQ,
    ACTIONS(13539), 1,
      anon_sym_COLON,
    STATE(3762), 1,
      sym__val_property_defn,
    STATE(9055), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [275962] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13541), 1,
      sym__newline,
    ACTIONS(13544), 1,
      sym__dedent,
    STATE(9056), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_field_initializers_repeat1,
  [275997] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13546), 1,
      anon_sym_PIPE,
    ACTIONS(13548), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9293), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9057), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [276034] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13550), 3,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_when,
    STATE(9058), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [276067] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13552), 1,
      sym__dedent,
    STATE(9047), 1,
      aux_sym__property_defn_repeat1,
    STATE(9059), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [276104] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(1507), 1,
      sym__static_type_identifier,
    ACTIONS(9128), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9060), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [276139] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(1316), 1,
      sym__static_type_identifier,
    ACTIONS(9170), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9061), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [276174] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(1512), 1,
      sym__static_type_identifier,
    ACTIONS(9204), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9062), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [276209] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13240), 1,
      sym_identifier,
    STATE(11573), 1,
      sym_access_modifier,
    STATE(9063), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [276246] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(9213), 1,
      sym_property_accessor,
    ACTIONS(13322), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(9064), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [276281] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13357), 1,
      sym__newline,
    ACTIONS(13554), 1,
      anon_sym_RPAREN,
    STATE(9120), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(9065), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [276318] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(2243), 1,
      sym__static_type_identifier,
    ACTIONS(9246), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9066), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [276353] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(4463), 1,
      sym__static_type_identifier,
    ACTIONS(9226), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9067), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [276388] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11549), 1,
      sym__newline,
    ACTIONS(13556), 1,
      sym__dedent,
    STATE(9078), 1,
      aux_sym__list_pattern_content_repeat1,
    STATE(9068), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [276425] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(4537), 1,
      sym__static_type_identifier,
    ACTIONS(9268), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9069), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [276460] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(13558), 1,
      anon_sym_RBRACK,
    STATE(12099), 1,
      sym__list_element,
    STATE(9070), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [276497] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13560), 1,
      anon_sym_with,
    ACTIONS(13562), 1,
      anon_sym_finally,
    ACTIONS(13564), 1,
      sym__newline,
    STATE(9071), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [276534] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13566), 1,
      anon_sym_COMMA,
    ACTIONS(13569), 1,
      sym__dedent,
    STATE(9072), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_slice_ranges_repeat1,
  [276569] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(13571), 1,
      anon_sym_PIPE_RBRACK,
    STATE(12098), 1,
      sym__list_element,
    STATE(9073), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [276606] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6748), 1,
      sym__static_type_identifier,
    ACTIONS(9160), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9074), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [276641] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13573), 1,
      sym__newline,
    ACTIONS(13576), 1,
      sym__dedent,
    STATE(9075), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__list_elements_repeat1,
  [276676] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13578), 1,
      anon_sym_EQ,
    ACTIONS(13580), 1,
      anon_sym_COLON,
    STATE(7589), 1,
      sym__val_property_defn,
    STATE(9076), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [276713] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13582), 1,
      sym__newline,
    ACTIONS(13584), 1,
      sym__dedent,
    STATE(9075), 1,
      aux_sym__list_elements_repeat1,
    STATE(9077), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [276750] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12136), 1,
      sym__dedent,
    ACTIONS(13586), 1,
      sym__newline,
    STATE(9078), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__list_pattern_content_repeat1,
  [276785] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13589), 1,
      anon_sym_EQ,
    ACTIONS(13591), 1,
      anon_sym_COLON,
    STATE(6350), 1,
      sym__val_property_defn,
    STATE(9079), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [276822] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(4370), 1,
      sym__static_type_identifier,
    ACTIONS(9278), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9080), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [276857] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13308), 1,
      sym_identifier,
    STATE(9150), 1,
      sym_field_pattern,
    STATE(11399), 1,
      sym_long_identifier,
    STATE(9081), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [276894] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13298), 1,
      sym_identifier,
    STATE(11340), 1,
      sym_access_modifier,
    STATE(9082), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [276931] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13593), 1,
      anon_sym_with,
    ACTIONS(13595), 1,
      anon_sym_finally,
    ACTIONS(13597), 1,
      sym__newline,
    STATE(9083), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [276968] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13599), 1,
      sym_identifier,
    STATE(11577), 1,
      sym_access_modifier,
    STATE(9084), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [277005] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13601), 1,
      anon_sym_GT_RBRACK,
    ACTIONS(13603), 1,
      sym__newline,
    STATE(9104), 1,
      aux_sym__attribute_set_repeat1,
    STATE(9085), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [277042] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8425), 1,
      sym__static_type_identifier,
    ACTIONS(9312), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9086), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [277077] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13605), 1,
      anon_sym_PIPE,
    ACTIONS(13607), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9096), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9087), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [277114] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13326), 1,
      anon_sym_EQ,
    ACTIONS(13328), 1,
      anon_sym_COLON,
    STATE(6803), 1,
      sym__val_property_defn,
    STATE(9088), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [277151] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13478), 1,
      sym__indent,
    ACTIONS(13609), 1,
      anon_sym_RBRACK,
    STATE(12091), 1,
      sym__list_pattern_content,
    STATE(9089), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [277188] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13478), 1,
      sym__indent,
    ACTIONS(13611), 1,
      anon_sym_PIPE_RBRACK,
    STATE(12090), 1,
      sym__list_pattern_content,
    STATE(9090), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [277225] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(1519), 1,
      sym__static_type_identifier,
    ACTIONS(9410), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9091), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [277260] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5492), 1,
      sym__static_type_identifier,
    ACTIONS(8109), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9092), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [277295] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13613), 1,
      anon_sym_RBRACE,
    ACTIONS(13615), 1,
      sym__newline,
    STATE(9093), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_record_pattern_repeat1,
  [277330] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(13618), 1,
      anon_sym_RBRACK,
    STATE(11739), 1,
      sym__list_element,
    STATE(9094), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [277367] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(13620), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11738), 1,
      sym__list_element,
    STATE(9095), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [277404] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13622), 1,
      anon_sym_PIPE,
    ACTIONS(13624), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9293), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9096), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [277441] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13626), 1,
      anon_sym_PIPE,
    ACTIONS(13628), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9013), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9097), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [277478] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6944), 1,
      sym__static_type_identifier,
    ACTIONS(9374), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9098), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [277513] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13630), 1,
      anon_sym_EQ,
    ACTIONS(13632), 1,
      anon_sym_COLON,
    STATE(6610), 1,
      sym__val_property_defn,
    STATE(9099), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [277550] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13634), 1,
      anon_sym_PIPE,
    ACTIONS(13636), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9119), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9100), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [277587] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13638), 1,
      anon_sym_and,
    ACTIONS(13641), 1,
      sym__dedent,
    STATE(9101), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__property_defn_repeat1,
  [277622] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6726), 1,
      anon_sym_LT2,
    ACTIONS(13643), 1,
      anon_sym_COLON,
    STATE(11587), 1,
      sym_type_arguments,
    STATE(9102), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [277659] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13106), 1,
      sym_identifier,
    STATE(10519), 1,
      sym_access_modifier,
    STATE(9103), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [277696] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13603), 1,
      sym__newline,
    ACTIONS(13645), 1,
      anon_sym_GT_RBRACK,
    STATE(9049), 1,
      aux_sym__attribute_set_repeat1,
    STATE(9104), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [277733] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13347), 1,
      anon_sym_EQ,
    ACTIONS(13349), 1,
      anon_sym_COLON,
    STATE(6425), 1,
      sym__val_property_defn,
    STATE(9105), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [277770] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13353), 1,
      sym__newline,
    ACTIONS(13647), 1,
      anon_sym_RBRACE,
    STATE(9093), 1,
      aux_sym_record_pattern_repeat1,
    STATE(9106), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [277807] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7323), 1,
      sym__static_type_identifier,
    ACTIONS(6592), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9107), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [277842] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(4518), 1,
      sym__static_type_identifier,
    ACTIONS(9398), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9108), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [277877] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13649), 1,
      sym_identifier,
    STATE(11494), 1,
      sym_access_modifier,
    STATE(9109), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [277914] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11549), 1,
      sym__newline,
    ACTIONS(11551), 1,
      sym__dedent,
    STATE(9078), 1,
      aux_sym__list_pattern_content_repeat1,
    STATE(9110), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [277951] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13357), 1,
      sym__newline,
    ACTIONS(13651), 1,
      anon_sym_RPAREN,
    STATE(9129), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(9111), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [277988] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13603), 1,
      sym__newline,
    ACTIONS(13653), 1,
      anon_sym_GT_RBRACK,
    STATE(9049), 1,
      aux_sym__attribute_set_repeat1,
    STATE(9112), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [278025] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13655), 1,
      sym__dedent,
    STATE(9001), 1,
      aux_sym__property_defn_repeat1,
    STATE(9113), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [278062] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13353), 1,
      sym__newline,
    ACTIONS(13657), 1,
      anon_sym_RBRACE,
    STATE(9130), 1,
      aux_sym_record_pattern_repeat1,
    STATE(9114), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [278099] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(4449), 1,
      sym__static_type_identifier,
    ACTIONS(9326), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9115), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [278134] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13353), 1,
      sym__newline,
    ACTIONS(13659), 1,
      anon_sym_RBRACE,
    STATE(9093), 1,
      aux_sym_record_pattern_repeat1,
    STATE(9116), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [278171] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13357), 1,
      sym__newline,
    ACTIONS(13661), 1,
      anon_sym_RPAREN,
    STATE(9120), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(9117), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [278208] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13663), 1,
      sym_identifier,
    STATE(11345), 1,
      sym_access_modifier,
    STATE(9118), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [278245] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13665), 1,
      anon_sym_PIPE,
    ACTIONS(13667), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9293), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9119), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [278282] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13669), 1,
      anon_sym_RPAREN,
    ACTIONS(13671), 1,
      sym__newline,
    STATE(9120), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_named_field_pattern_repeat1,
  [278317] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(13674), 1,
      anon_sym_RBRACK,
    STATE(11165), 1,
      sym__list_element,
    STATE(9121), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [278354] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13676), 1,
      anon_sym_PIPE,
    ACTIONS(13678), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9131), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9122), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [278391] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13630), 1,
      anon_sym_EQ,
    ACTIONS(13632), 1,
      anon_sym_COLON,
    STATE(6680), 1,
      sym__val_property_defn,
    STATE(9123), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [278428] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6549), 1,
      sym__static_type_identifier,
    ACTIONS(9506), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9124), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [278463] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(13680), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11163), 1,
      sym__list_element,
    STATE(9125), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [278500] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6806), 1,
      sym__static_type_identifier,
    ACTIONS(9450), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9126), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [278535] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(9042), 1,
      sym_property_accessor,
    ACTIONS(13322), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(9127), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [278570] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3839), 3,
      sym__newline,
      sym__dedent,
      anon_sym_PIPE,
    STATE(9128), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [278603] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13357), 1,
      sym__newline,
    ACTIONS(13682), 1,
      anon_sym_RPAREN,
    STATE(9120), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(9129), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [278640] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13353), 1,
      sym__newline,
    ACTIONS(13684), 1,
      anon_sym_RBRACE,
    STATE(9093), 1,
      aux_sym_record_pattern_repeat1,
    STATE(9130), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [278677] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13686), 1,
      anon_sym_PIPE,
    ACTIONS(13688), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9293), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9131), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [278714] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13353), 1,
      sym__newline,
    ACTIONS(13690), 1,
      anon_sym_RBRACE,
    STATE(9093), 1,
      aux_sym_record_pattern_repeat1,
    STATE(9132), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [278751] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(1225), 1,
      sym__static_type_identifier,
    ACTIONS(9494), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9133), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [278786] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13692), 1,
      anon_sym_POUNDendif,
    ACTIONS(13694), 1,
      anon_sym_POUNDelse,
    STATE(11987), 1,
      sym_preproc_else,
    STATE(9134), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [278823] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13696), 1,
      anon_sym_PIPE,
    ACTIONS(13698), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9168), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9135), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [278860] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13700), 1,
      anon_sym_EQ,
    ACTIONS(13702), 1,
      anon_sym_COLON,
    STATE(6808), 1,
      sym__val_property_defn,
    STATE(9136), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [278897] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13704), 1,
      anon_sym_PIPE,
    ACTIONS(13706), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9293), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9137), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [278934] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(13708), 1,
      anon_sym_RBRACK,
    STATE(11028), 1,
      sym__list_element,
    STATE(9138), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [278971] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13308), 1,
      sym_identifier,
    STATE(8980), 1,
      sym_field_pattern,
    STATE(11399), 1,
      sym_long_identifier,
    STATE(9139), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [279008] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7008), 1,
      sym__static_type_identifier,
    ACTIONS(9118), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9140), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [279043] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13710), 1,
      anon_sym_with,
    ACTIONS(13712), 1,
      anon_sym_finally,
    ACTIONS(13714), 1,
      sym__newline,
    STATE(9141), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [279080] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13209), 1,
      sym_identifier,
    STATE(11608), 1,
      sym_access_modifier,
    STATE(9142), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [279117] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13716), 1,
      anon_sym_PIPE,
    ACTIONS(13718), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9293), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9143), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [279154] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13720), 1,
      anon_sym_with,
    ACTIONS(13722), 1,
      anon_sym_finally,
    ACTIONS(13724), 1,
      sym__newline,
    STATE(9144), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [279191] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13603), 1,
      sym__newline,
    ACTIONS(13726), 1,
      anon_sym_GT_RBRACK,
    STATE(9049), 1,
      aux_sym__attribute_set_repeat1,
    STATE(9145), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [279228] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3826), 3,
      sym__newline,
      sym__dedent,
      anon_sym_PIPE,
    STATE(9146), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [279261] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6795), 1,
      sym__static_type_identifier,
    ACTIONS(9300), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9147), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [279296] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7167), 1,
      sym__static_type_identifier,
    ACTIONS(9182), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9148), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [279331] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13436), 1,
      anon_sym_EQ,
    ACTIONS(13438), 1,
      anon_sym_COLON,
    STATE(3762), 1,
      sym__val_property_defn,
    STATE(9149), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [279368] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13353), 1,
      sym__newline,
    ACTIONS(13728), 1,
      anon_sym_RBRACE,
    STATE(9116), 1,
      aux_sym_record_pattern_repeat1,
    STATE(9150), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [279405] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5476), 1,
      sym__static_type_identifier,
    ACTIONS(8188), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9151), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [279440] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13205), 1,
      sym_identifier,
    STATE(11613), 1,
      sym_access_modifier,
    STATE(9152), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [279477] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13730), 1,
      sym__dedent,
    STATE(9156), 1,
      aux_sym__property_defn_repeat1,
    STATE(9153), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [279514] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13357), 1,
      sym__newline,
    ACTIONS(13732), 1,
      anon_sym_RPAREN,
    STATE(9117), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(9154), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [279551] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6726), 1,
      anon_sym_LT2,
    ACTIONS(13734), 1,
      anon_sym_COLON,
    STATE(11506), 1,
      sym_type_arguments,
    STATE(9155), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [279588] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13736), 1,
      sym__dedent,
    STATE(9101), 1,
      aux_sym__property_defn_repeat1,
    STATE(9156), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [279625] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13738), 1,
      anon_sym_PIPE,
    ACTIONS(13740), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9166), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9157), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [279662] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7950), 1,
      sym__static_type_identifier,
    ACTIONS(11460), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9158), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [279697] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13742), 1,
      anon_sym_COMMA,
    ACTIONS(13744), 1,
      anon_sym_GT,
    STATE(9345), 1,
      aux_sym_type_attributes_repeat1,
    STATE(9159), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [279734] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13746), 1,
      sym__dedent,
    STATE(9164), 1,
      aux_sym__property_defn_repeat1,
    STATE(9160), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [279771] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6648), 1,
      sym__static_type_identifier,
    ACTIONS(9540), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9161), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [279806] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13603), 1,
      sym__newline,
    ACTIONS(13748), 1,
      anon_sym_GT_RBRACK,
    STATE(9112), 1,
      aux_sym__attribute_set_repeat1,
    STATE(9162), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [279843] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8124), 1,
      sym__static_type_identifier,
    ACTIONS(9518), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9163), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [279878] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13750), 1,
      sym__dedent,
    STATE(9101), 1,
      aux_sym__property_defn_repeat1,
    STATE(9164), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [279915] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13752), 1,
      sym_identifier,
    STATE(11897), 1,
      sym_access_modifier,
    STATE(9165), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [279952] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13754), 1,
      anon_sym_PIPE,
    ACTIONS(13756), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9293), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9166), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [279989] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13758), 1,
      sym__dedent,
    STATE(9219), 1,
      aux_sym__property_defn_repeat1,
    STATE(9167), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [280026] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13760), 1,
      anon_sym_PIPE,
    ACTIONS(13762), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9293), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9168), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [280063] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13764), 1,
      anon_sym_PIPE,
    ACTIONS(13766), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9143), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9169), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [280100] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13768), 1,
      sym_identifier,
    STATE(11617), 1,
      sym_access_modifier,
    STATE(9170), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [280137] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13353), 1,
      sym__newline,
    ACTIONS(13770), 1,
      anon_sym_RBRACE,
    STATE(9132), 1,
      aux_sym_record_pattern_repeat1,
    STATE(9171), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [280174] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(4909), 1,
      sym__static_type_identifier,
    ACTIONS(11624), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9172), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [280209] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5442), 1,
      sym__static_type_identifier,
    ACTIONS(8073), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9173), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [280244] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13772), 1,
      sym_identifier,
    STATE(11892), 1,
      sym_access_modifier,
    STATE(9174), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [280281] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13774), 1,
      anon_sym_PIPE,
    ACTIONS(13776), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9137), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9175), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [280318] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(1422), 1,
      sym__dedent,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13582), 1,
      sym__newline,
    STATE(9075), 1,
      aux_sym__list_elements_repeat1,
    STATE(9176), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [280355] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13246), 1,
      sym_identifier,
    STATE(11394), 1,
      sym_access_modifier,
    STATE(9177), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [280392] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13478), 1,
      sym__indent,
    ACTIONS(13778), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11610), 1,
      sym__list_pattern_content,
    STATE(9178), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [280429] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13478), 1,
      sym__indent,
    ACTIONS(13780), 1,
      anon_sym_RBRACK,
    STATE(11612), 1,
      sym__list_pattern_content,
    STATE(9179), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [280466] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13603), 1,
      sym__newline,
    ACTIONS(13782), 1,
      anon_sym_GT_RBRACK,
    STATE(9145), 1,
      aux_sym__attribute_set_repeat1,
    STATE(9180), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [280503] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13478), 1,
      sym__indent,
    ACTIONS(13784), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11366), 1,
      sym__list_pattern_content,
    STATE(9181), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [280540] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(13786), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11620), 1,
      sym__list_element,
    STATE(9182), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [280577] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(13788), 1,
      anon_sym_RBRACK,
    STATE(11627), 1,
      sym__list_element,
    STATE(9183), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [280614] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(2536), 1,
      sym__static_type_identifier,
    ACTIONS(9338), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9184), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [280649] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13790), 1,
      anon_sym_DOT,
    ACTIONS(4098), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    STATE(9185), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [280684] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13478), 1,
      sym__indent,
    ACTIONS(13792), 1,
      anon_sym_RBRACK,
    STATE(11367), 1,
      sym__list_pattern_content,
    STATE(9186), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [280721] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(13794), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11379), 1,
      sym__list_element,
    STATE(9187), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [280758] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(13796), 1,
      anon_sym_RBRACK,
    STATE(11381), 1,
      sym__list_element,
    STATE(9188), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [280795] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(9255), 1,
      sym_property_accessor,
    ACTIONS(13322), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(9189), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [280830] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13197), 1,
      sym_identifier,
    STATE(11490), 1,
      sym_access_modifier,
    STATE(9190), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [280867] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13498), 1,
      anon_sym_COMMA,
    ACTIONS(13798), 1,
      sym__dedent,
    STATE(9072), 1,
      aux_sym_slice_ranges_repeat1,
    STATE(9191), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [280904] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13800), 1,
      anon_sym_PIPE,
    ACTIONS(13802), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9201), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9192), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [280941] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13804), 1,
      sym__newline,
    ACTIONS(13807), 1,
      sym__dedent,
    STATE(9193), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__module_body_repeat1,
  [280976] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13308), 1,
      sym_identifier,
    STATE(9857), 1,
      sym_field_pattern,
    STATE(11399), 1,
      sym_long_identifier,
    STATE(9194), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [281013] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(1522), 1,
      sym__static_type_identifier,
    ACTIONS(9288), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9195), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [281048] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(4890), 1,
      sym__static_type_identifier,
    ACTIONS(11739), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9196), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [281083] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13173), 1,
      sym_identifier,
    STATE(11645), 1,
      sym_access_modifier,
    STATE(9197), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [281120] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13809), 1,
      sym__newline,
    ACTIONS(13812), 1,
      sym__dedent,
    STATE(9198), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__class_type_body_repeat1,
  [281155] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(13814), 1,
      anon_sym_RBRACK,
    STATE(11879), 1,
      sym__list_element,
    STATE(9199), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [281192] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(13816), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11878), 1,
      sym__list_element,
    STATE(9200), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [281229] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13818), 1,
      anon_sym_PIPE,
    ACTIONS(13820), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9293), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9201), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [281266] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6726), 1,
      anon_sym_LT2,
    ACTIONS(13822), 1,
      anon_sym_COLON,
    STATE(10500), 1,
      sym_type_arguments,
    STATE(9202), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [281303] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13824), 1,
      sym__dedent,
    STATE(9101), 1,
      aux_sym__property_defn_repeat1,
    STATE(9203), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [281340] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13603), 1,
      sym__newline,
    ACTIONS(13826), 1,
      anon_sym_GT_RBRACK,
    STATE(9218), 1,
      aux_sym__attribute_set_repeat1,
    STATE(9204), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [281377] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13478), 1,
      sym__indent,
    ACTIONS(13828), 1,
      anon_sym_RBRACK,
    STATE(11869), 1,
      sym__list_pattern_content,
    STATE(9205), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [281414] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13830), 1,
      sym_identifier,
    STATE(11200), 1,
      sym_access_modifier,
    STATE(9206), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [281451] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13478), 1,
      sym__indent,
    ACTIONS(13832), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11868), 1,
      sym__list_pattern_content,
    STATE(9207), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [281488] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13834), 1,
      sym_identifier,
    STATE(11877), 1,
      sym_access_modifier,
    STATE(9208), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [281525] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13201), 1,
      sym_identifier,
    STATE(11404), 1,
      sym_access_modifier,
    STATE(9209), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [281562] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13836), 1,
      anon_sym_PIPE,
    ACTIONS(13838), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9234), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9210), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [281599] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13169), 1,
      sym_identifier,
    STATE(9935), 1,
      sym_field_initializer,
    STATE(10334), 1,
      sym_long_identifier,
    STATE(9211), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [281636] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13840), 1,
      anon_sym_with,
    ACTIONS(13842), 1,
      anon_sym_finally,
    ACTIONS(13844), 1,
      sym__newline,
    STATE(9212), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [281673] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13846), 1,
      sym__dedent,
    STATE(9203), 1,
      aux_sym__property_defn_repeat1,
    STATE(9213), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [281710] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8235), 1,
      sym__static_type_identifier,
    ACTIONS(9216), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9214), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [281745] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13848), 1,
      sym__dedent,
    STATE(9101), 1,
      aux_sym__property_defn_repeat1,
    STATE(9215), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [281782] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13850), 1,
      sym_identifier,
    STATE(11872), 1,
      sym_access_modifier,
    STATE(9216), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [281819] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13308), 1,
      sym_identifier,
    STATE(9376), 1,
      sym_field_pattern,
    STATE(11399), 1,
      sym_long_identifier,
    STATE(9217), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [281856] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13603), 1,
      sym__newline,
    ACTIONS(13852), 1,
      anon_sym_GT_RBRACK,
    STATE(9049), 1,
      aux_sym__attribute_set_repeat1,
    STATE(9218), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [281893] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13854), 1,
      sym__dedent,
    STATE(9101), 1,
      aux_sym__property_defn_repeat1,
    STATE(9219), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [281930] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13158), 1,
      sym_identifier,
    STATE(11649), 1,
      sym_access_modifier,
    STATE(9220), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [281967] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13452), 1,
      sym__newline,
    ACTIONS(13856), 1,
      sym__dedent,
    STATE(9056), 1,
      aux_sym_field_initializers_repeat1,
    STATE(9221), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [282004] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13858), 1,
      anon_sym_with,
    ACTIONS(13860), 1,
      anon_sym_finally,
    ACTIONS(13862), 1,
      sym__newline,
    STATE(9222), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [282041] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13537), 1,
      anon_sym_EQ,
    ACTIONS(13539), 1,
      anon_sym_COLON,
    STATE(3798), 1,
      sym__val_property_defn,
    STATE(9223), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [282078] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13864), 1,
      sym__dedent,
    STATE(9215), 1,
      aux_sym__property_defn_repeat1,
    STATE(9224), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [282115] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13866), 1,
      sym__dedent,
    STATE(9101), 1,
      aux_sym__property_defn_repeat1,
    STATE(9225), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [282152] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5443), 1,
      sym__static_type_identifier,
    ACTIONS(8021), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9226), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [282187] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13868), 1,
      anon_sym_PIPE,
    ACTIONS(13870), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9236), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9227), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [282224] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13357), 1,
      sym__newline,
    ACTIONS(13872), 1,
      anon_sym_RPAREN,
    STATE(9244), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(9228), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [282261] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13353), 1,
      sym__newline,
    ACTIONS(13874), 1,
      anon_sym_RBRACE,
    STATE(9245), 1,
      aux_sym_record_pattern_repeat1,
    STATE(9229), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [282298] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13876), 1,
      sym__dedent,
    STATE(9225), 1,
      aux_sym__property_defn_repeat1,
    STATE(9230), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [282335] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7963), 1,
      sym__static_type_identifier,
    ACTIONS(11411), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9231), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [282370] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13878), 1,
      anon_sym_DASH_GT,
    ACTIONS(13880), 1,
      anon_sym_STAR,
    STATE(9232), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_arguments_spec_repeat1,
  [282405] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(4429), 1,
      sym__static_type_identifier,
    ACTIONS(9652), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9233), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [282440] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13883), 1,
      anon_sym_PIPE,
    ACTIONS(13885), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9293), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9234), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [282477] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13887), 1,
      sym__dedent,
    STATE(9101), 1,
      aux_sym__property_defn_repeat1,
    STATE(9235), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [282514] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13889), 1,
      anon_sym_PIPE,
    ACTIONS(13891), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9293), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9236), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [282551] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13893), 1,
      sym_identifier,
    STATE(11409), 1,
      sym_access_modifier,
    STATE(9237), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [282588] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6726), 1,
      anon_sym_LT2,
    ACTIONS(13895), 1,
      anon_sym_COLON,
    STATE(11432), 1,
      sym_type_arguments,
    STATE(9238), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [282625] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7175), 1,
      sym__static_type_identifier,
    ACTIONS(11329), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9239), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [282660] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(13897), 1,
      anon_sym_RBRACK,
    STATE(11118), 1,
      sym__list_element,
    STATE(9240), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [282697] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(13899), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11117), 1,
      sym__list_element,
    STATE(9241), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [282734] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(4546), 1,
      sym__static_type_identifier,
    ACTIONS(9236), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9242), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [282769] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13259), 1,
      sym_identifier,
    STATE(10274), 1,
      sym_access_modifier,
    STATE(9243), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [282806] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13357), 1,
      sym__newline,
    ACTIONS(13901), 1,
      anon_sym_RPAREN,
    STATE(9120), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(9244), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [282843] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13353), 1,
      sym__newline,
    ACTIONS(13903), 1,
      anon_sym_RBRACE,
    STATE(9093), 1,
      aux_sym_record_pattern_repeat1,
    STATE(9245), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [282880] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13905), 1,
      sym__dedent,
    STATE(9235), 1,
      aux_sym__property_defn_repeat1,
    STATE(9246), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [282917] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13353), 1,
      sym__newline,
    ACTIONS(13907), 1,
      anon_sym_RBRACE,
    STATE(9106), 1,
      aux_sym_record_pattern_repeat1,
    STATE(9247), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [282954] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13694), 1,
      anon_sym_POUNDelse,
    ACTIONS(13909), 1,
      anon_sym_POUNDendif,
    STATE(11830), 1,
      sym_preproc_else,
    STATE(9248), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [282991] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5366), 1,
      sym__static_type_identifier,
    ACTIONS(7983), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9249), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [283026] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13911), 1,
      anon_sym_EQ,
    ACTIONS(13913), 1,
      anon_sym_COLON,
    STATE(7546), 1,
      sym__val_property_defn,
    STATE(9250), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [283063] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13915), 1,
      sym_identifier,
    STATE(11852), 1,
      sym_access_modifier,
    STATE(9251), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [283100] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13917), 1,
      sym_identifier,
    STATE(11845), 1,
      sym_access_modifier,
    STATE(9252), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [283137] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13919), 1,
      sym_identifier,
    STATE(11653), 1,
      sym_access_modifier,
    STATE(9253), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [283174] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13921), 1,
      anon_sym_EQ,
    ACTIONS(13923), 1,
      anon_sym_COLON,
    STATE(6954), 1,
      sym__val_property_defn,
    STATE(9254), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [283211] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13925), 1,
      sym__dedent,
    STATE(9285), 1,
      aux_sym__property_defn_repeat1,
    STATE(9255), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [283248] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(4145), 1,
      sym__static_type_identifier,
    ACTIONS(9608), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9256), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [283283] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13927), 1,
      sym__dedent,
    STATE(9101), 1,
      aux_sym__property_defn_repeat1,
    STATE(9257), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [283320] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(9230), 1,
      sym_property_accessor,
    ACTIONS(13322), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(9258), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [283355] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13411), 1,
      anon_sym_EQ,
    ACTIONS(13413), 1,
      anon_sym_COLON,
    STATE(6609), 1,
      sym__val_property_defn,
    STATE(9259), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [283392] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13929), 1,
      anon_sym_PIPE,
    ACTIONS(13931), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9283), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9260), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [283429] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13933), 1,
      anon_sym_PIPE,
    ACTIONS(13935), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9270), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9261), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [283466] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13700), 1,
      anon_sym_EQ,
    ACTIONS(13702), 1,
      anon_sym_COLON,
    STATE(6881), 1,
      sym__val_property_defn,
    STATE(9262), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [283503] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(2690), 1,
      sym__static_type_identifier,
    ACTIONS(9358), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9263), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [283538] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13377), 1,
      anon_sym_as,
    ACTIONS(13937), 1,
      anon_sym_EQ,
    STATE(10258), 1,
      sym_class_as_reference,
    STATE(9264), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [283575] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(4584), 1,
      sym__static_type_identifier,
    ACTIONS(9550), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9265), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [283610] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13308), 1,
      sym_identifier,
    STATE(9171), 1,
      sym_field_pattern,
    STATE(11399), 1,
      sym_long_identifier,
    STATE(9266), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [283647] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7906), 1,
      anon_sym_GT,
    ACTIONS(13317), 1,
      anon_sym_and,
    STATE(9281), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(9267), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [283684] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13939), 1,
      sym__dedent,
    STATE(9277), 1,
      aux_sym__property_defn_repeat1,
    STATE(9268), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [283721] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(1331), 1,
      sym__static_type_identifier,
    ACTIONS(9484), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9269), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [283756] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13941), 1,
      anon_sym_PIPE,
    ACTIONS(13943), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9293), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9270), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [283793] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13148), 1,
      sym_identifier,
    STATE(11485), 1,
      sym_access_modifier,
    STATE(9271), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [283830] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13945), 1,
      anon_sym_with,
    ACTIONS(13947), 1,
      anon_sym_finally,
    ACTIONS(13949), 1,
      sym__newline,
    STATE(9272), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [283867] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(7064), 1,
      sym__static_type_identifier,
    ACTIONS(9194), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9273), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [283902] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13589), 1,
      anon_sym_EQ,
    ACTIONS(13591), 1,
      anon_sym_COLON,
    STATE(6342), 1,
      sym__val_property_defn,
    STATE(9274), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [283939] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13951), 1,
      anon_sym_with,
    ACTIONS(13953), 1,
      anon_sym_finally,
    ACTIONS(13955), 1,
      sym__newline,
    STATE(9275), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [283976] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(9849), 1,
      sym_property_accessor,
    ACTIONS(13322), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(9276), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [284011] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13957), 1,
      sym__dedent,
    STATE(9101), 1,
      aux_sym__property_defn_repeat1,
    STATE(9277), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [284048] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13959), 1,
      sym__dedent,
    STATE(9280), 1,
      aux_sym__property_defn_repeat1,
    STATE(9278), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [284085] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(2618), 1,
      sym__static_type_identifier,
    ACTIONS(9426), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9279), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [284120] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13961), 1,
      sym__dedent,
    STATE(9101), 1,
      aux_sym__property_defn_repeat1,
    STATE(9280), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [284157] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7910), 1,
      anon_sym_GT,
    ACTIONS(13963), 1,
      anon_sym_and,
    STATE(9281), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
  [284192] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(2586), 1,
      sym__static_type_identifier,
    ACTIONS(9628), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9282), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [284227] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13966), 1,
      anon_sym_PIPE,
    ACTIONS(13968), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9293), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9283), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [284264] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(9113), 1,
      sym_property_accessor,
    ACTIONS(13322), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(9284), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [284299] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(13970), 1,
      sym__dedent,
    STATE(9101), 1,
      aux_sym__property_defn_repeat1,
    STATE(9285), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [284336] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13377), 1,
      anon_sym_as,
    ACTIONS(13972), 1,
      anon_sym_EQ,
    STATE(10572), 1,
      sym_class_as_reference,
    STATE(9286), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [284373] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(13974), 1,
      anon_sym_RBRACK,
    STATE(11796), 1,
      sym__list_element,
    STATE(9287), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [284410] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6726), 1,
      anon_sym_LT2,
    ACTIONS(13976), 1,
      anon_sym_COLON,
    STATE(11339), 1,
      sym_type_arguments,
    STATE(9288), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [284447] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13578), 1,
      anon_sym_EQ,
    ACTIONS(13580), 1,
      anon_sym_COLON,
    STATE(7597), 1,
      sym__val_property_defn,
    STATE(9289), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [284484] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(13978), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11795), 1,
      sym__list_element,
    STATE(9290), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [284521] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13980), 1,
      anon_sym_PIPE,
    ACTIONS(13982), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9293), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9291), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [284558] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13353), 1,
      sym__newline,
    ACTIONS(13984), 1,
      anon_sym_RBRACE,
    STATE(9093), 1,
      aux_sym_record_pattern_repeat1,
    STATE(9292), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [284595] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13986), 1,
      anon_sym_PIPE,
    ACTIONS(13989), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9293), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_active_pattern_repeat1,
  [284630] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13603), 1,
      sym__newline,
    ACTIONS(13991), 1,
      anon_sym_GT_RBRACK,
    STATE(9302), 1,
      aux_sym__attribute_set_repeat1,
    STATE(9294), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [284667] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13694), 1,
      anon_sym_POUNDelse,
    ACTIONS(13993), 1,
      anon_sym_POUNDendif,
    STATE(10285), 1,
      sym_preproc_else,
    STATE(9295), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [284704] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5037), 1,
      sym__static_type_identifier,
    ACTIONS(11818), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9296), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [284739] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13357), 1,
      sym__newline,
    ACTIONS(13995), 1,
      anon_sym_RPAREN,
    STATE(9120), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(9297), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [284776] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(4472), 1,
      sym__static_type_identifier,
    ACTIONS(9348), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9298), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [284811] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13478), 1,
      sym__indent,
    ACTIONS(13997), 1,
      anon_sym_RBRACK,
    STATE(11787), 1,
      sym__list_pattern_content,
    STATE(9299), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [284848] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13478), 1,
      sym__indent,
    ACTIONS(13999), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11786), 1,
      sym__list_pattern_content,
    STATE(9300), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [284885] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14001), 1,
      anon_sym_PIPE,
    ACTIONS(14003), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9314), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9301), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [284922] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13603), 1,
      sym__newline,
    ACTIONS(14005), 1,
      anon_sym_GT_RBRACK,
    STATE(9049), 1,
      aux_sym__attribute_set_repeat1,
    STATE(9302), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [284959] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(14007), 1,
      anon_sym_RBRACK,
    STATE(11465), 1,
      sym__list_element,
    STATE(9303), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [284996] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(2240), 1,
      sym__static_type_identifier,
    ACTIONS(9384), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9304), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [285031] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6880), 1,
      sym__static_type_identifier,
    ACTIONS(9462), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9305), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [285066] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13379), 1,
      sym__newline,
    ACTIONS(14009), 1,
      sym__dedent,
    STATE(8962), 1,
      aux_sym__class_type_body_repeat1,
    STATE(9306), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [285103] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13357), 1,
      sym__newline,
    ACTIONS(14011), 1,
      anon_sym_RPAREN,
    STATE(9322), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(9307), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [285140] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13353), 1,
      sym__newline,
    ACTIONS(14013), 1,
      anon_sym_RBRACE,
    STATE(9324), 1,
      aux_sym_record_pattern_repeat1,
    STATE(9308), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [285177] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13134), 1,
      sym_identifier,
    STATE(11443), 1,
      sym_access_modifier,
    STATE(9309), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [285214] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(14015), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11464), 1,
      sym__list_element,
    STATE(9310), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [285251] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(9022), 1,
      sym_property_accessor,
    ACTIONS(13322), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(9311), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [285286] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13341), 1,
      anon_sym_PIPE,
    ACTIONS(14017), 1,
      sym__dedent,
    STATE(9369), 1,
      aux_sym_enum_type_cases_repeat1,
    STATE(9312), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [285323] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6958), 1,
      sym__static_type_identifier,
    ACTIONS(9474), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9313), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [285358] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14019), 1,
      anon_sym_PIPE,
    ACTIONS(14021), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9293), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9314), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [285395] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13569), 1,
      anon_sym_RBRACK,
    ACTIONS(14023), 1,
      anon_sym_COMMA,
    STATE(9315), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_slice_ranges_repeat1,
  [285430] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13353), 1,
      sym__newline,
    ACTIONS(14026), 1,
      anon_sym_RBRACE,
    STATE(9093), 1,
      aux_sym_record_pattern_repeat1,
    STATE(9316), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [285467] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14028), 1,
      anon_sym_PIPE,
    ACTIONS(14030), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9293), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9317), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [285504] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13116), 1,
      sym_identifier,
    STATE(11448), 1,
      sym_access_modifier,
    STATE(9318), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [285541] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13357), 1,
      sym__newline,
    ACTIONS(14032), 1,
      anon_sym_RPAREN,
    STATE(9120), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(9319), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [285578] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(4374), 1,
      sym__static_type_identifier,
    ACTIONS(9638), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9320), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [285613] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14034), 1,
      anon_sym_with,
    ACTIONS(14036), 1,
      anon_sym_finally,
    ACTIONS(14038), 1,
      sym__newline,
    STATE(9321), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [285650] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13357), 1,
      sym__newline,
    ACTIONS(14040), 1,
      anon_sym_RPAREN,
    STATE(9120), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(9322), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [285687] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11289), 1,
      anon_sym_COMMA,
    ACTIONS(14042), 1,
      anon_sym_GT,
    STATE(8985), 1,
      aux_sym_types_repeat1,
    STATE(9323), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [285724] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13353), 1,
      sym__newline,
    ACTIONS(14044), 1,
      anon_sym_RBRACE,
    STATE(9093), 1,
      aux_sym_record_pattern_repeat1,
    STATE(9324), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [285761] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13694), 1,
      anon_sym_POUNDelse,
    ACTIONS(14046), 1,
      anon_sym_POUNDendif,
    STATE(11754), 1,
      sym_preproc_else,
    STATE(9325), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [285798] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(4406), 1,
      sym__static_type_identifier,
    ACTIONS(9560), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9326), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [285833] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6726), 1,
      anon_sym_LT2,
    ACTIONS(14048), 1,
      anon_sym_COLON,
    STATE(11263), 1,
      sym_type_arguments,
    STATE(9327), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [285870] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(4618), 1,
      sym__static_type_identifier,
    ACTIONS(9570), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9328), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [285905] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13353), 1,
      sym__newline,
    ACTIONS(14050), 1,
      anon_sym_RBRACE,
    STATE(9292), 1,
      aux_sym_record_pattern_repeat1,
    STATE(9329), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [285942] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13357), 1,
      sym__newline,
    ACTIONS(14052), 1,
      anon_sym_RPAREN,
    STATE(9065), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(9330), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [285979] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13911), 1,
      anon_sym_EQ,
    ACTIONS(13913), 1,
      anon_sym_COLON,
    STATE(7609), 1,
      sym__val_property_defn,
    STATE(9331), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [286016] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14054), 1,
      anon_sym_PIPE,
    ACTIONS(14056), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9293), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9332), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [286053] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13478), 1,
      sym__indent,
    ACTIONS(14058), 1,
      anon_sym_RBRACK,
    STATE(11456), 1,
      sym__list_pattern_content,
    STATE(9333), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [286090] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13357), 1,
      sym__newline,
    ACTIONS(14060), 1,
      anon_sym_RPAREN,
    STATE(9297), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(9334), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [286127] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13478), 1,
      sym__indent,
    ACTIONS(14062), 1,
      anon_sym_RBRACK,
    STATE(11422), 1,
      sym__list_pattern_content,
    STATE(9335), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [286164] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5524), 1,
      sym__static_type_identifier,
    ACTIONS(8037), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9336), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [286199] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13478), 1,
      sym__indent,
    ACTIONS(14064), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11420), 1,
      sym__list_pattern_content,
    STATE(9337), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [286236] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5146), 1,
      sym__static_type_identifier,
    ACTIONS(11688), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9338), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [286271] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13308), 1,
      sym_identifier,
    STATE(9247), 1,
      sym_field_pattern,
    STATE(11399), 1,
      sym_long_identifier,
    STATE(9339), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [286308] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14066), 1,
      anon_sym_with,
    ACTIONS(14068), 1,
      anon_sym_finally,
    ACTIONS(14070), 1,
      sym__newline,
    STATE(9340), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [286345] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13478), 1,
      sym__indent,
    ACTIONS(14072), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11454), 1,
      sym__list_pattern_content,
    STATE(9341), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [286382] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(14074), 1,
      anon_sym_RBRACK,
    STATE(11073), 1,
      sym__list_element,
    STATE(9342), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [286419] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(3206), 1,
      sym__static_type_identifier,
    ACTIONS(8093), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9343), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [286454] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13603), 1,
      sym__newline,
    ACTIONS(14076), 1,
      anon_sym_GT_RBRACK,
    STATE(9049), 1,
      aux_sym__attribute_set_repeat1,
    STATE(9344), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [286491] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13742), 1,
      anon_sym_COMMA,
    ACTIONS(14078), 1,
      anon_sym_GT,
    STATE(8946), 1,
      aux_sym_type_attributes_repeat1,
    STATE(9345), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [286528] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(14080), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11071), 1,
      sym__list_element,
    STATE(9346), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [286565] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13921), 1,
      anon_sym_EQ,
    ACTIONS(13923), 1,
      anon_sym_COLON,
    STATE(6968), 1,
      sym__val_property_defn,
    STATE(9347), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [286602] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5543), 1,
      sym__static_type_identifier,
    ACTIONS(8121), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9348), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [286637] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14082), 1,
      anon_sym_PIPE,
    ACTIONS(14084), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9317), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9349), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [286674] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14086), 1,
      anon_sym_PIPE,
    ACTIONS(14088), 1,
      anon_sym_PIPE_RPAREN,
    STATE(8979), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9350), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [286711] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13357), 1,
      sym__newline,
    ACTIONS(14090), 1,
      anon_sym_RPAREN,
    STATE(9319), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(9351), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [286748] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(14092), 1,
      sym__dedent,
    STATE(9101), 1,
      aux_sym__property_defn_repeat1,
    STATE(9352), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [286785] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(1462), 1,
      sym__dedent,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13395), 1,
      sym__newline,
    STATE(8972), 1,
      aux_sym__module_body_repeat1,
    STATE(9353), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [286822] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6375), 1,
      sym__static_type_identifier,
    ACTIONS(8152), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9354), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [286857] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13478), 1,
      sym__indent,
    ACTIONS(14094), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11685), 1,
      sym__list_pattern_content,
    STATE(9355), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [286894] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13478), 1,
      sym__indent,
    ACTIONS(14096), 1,
      anon_sym_RBRACK,
    STATE(11686), 1,
      sym__list_pattern_content,
    STATE(9356), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [286931] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(4564), 1,
      sym__static_type_identifier,
    ACTIONS(9618), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9357), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [286966] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13446), 1,
      anon_sym_COMMA,
    ACTIONS(13798), 1,
      anon_sym_RBRACK,
    STATE(9315), 1,
      aux_sym_slice_ranges_repeat1,
    STATE(9358), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [287003] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13603), 1,
      sym__newline,
    ACTIONS(14098), 1,
      anon_sym_GT_RBRACK,
    STATE(9344), 1,
      aux_sym__attribute_set_repeat1,
    STATE(9359), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [287040] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14100), 3,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_when,
    STATE(9360), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [287073] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(14102), 1,
      sym__dedent,
    STATE(9101), 1,
      aux_sym__property_defn_repeat1,
    STATE(9361), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [287110] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(14104), 1,
      sym__dedent,
    STATE(9352), 1,
      aux_sym__property_defn_repeat1,
    STATE(9362), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [287147] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14106), 1,
      anon_sym_PIPE,
    ACTIONS(14108), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9332), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9363), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [287184] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(5041), 1,
      sym__static_type_identifier,
    ACTIONS(11718), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9364), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [287219] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14110), 1,
      anon_sym_PIPE,
    ACTIONS(14112), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9291), 1,
      aux_sym_active_pattern_repeat1,
    STATE(9365), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [287256] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14114), 1,
      anon_sym_with,
    ACTIONS(14116), 1,
      anon_sym_finally,
    ACTIONS(14118), 1,
      sym__newline,
    STATE(9366), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [287293] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(8965), 1,
      sym_property_accessor,
    ACTIONS(13322), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(9367), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [287328] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14120), 1,
      anon_sym_with,
    ACTIONS(14122), 1,
      anon_sym_finally,
    ACTIONS(14124), 1,
      sym__newline,
    STATE(9368), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [287365] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14126), 1,
      anon_sym_PIPE,
    ACTIONS(14129), 1,
      sym__dedent,
    STATE(9369), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_enum_type_cases_repeat1,
  [287400] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14131), 1,
      sym_identifier,
    STATE(11452), 1,
      sym_access_modifier,
    STATE(9370), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [287437] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(14133), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11695), 1,
      sym__list_element,
    STATE(9371), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [287474] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13304), 1,
      sym__indent,
    ACTIONS(14135), 1,
      anon_sym_RBRACK,
    STATE(11700), 1,
      sym__list_element,
    STATE(9372), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [287511] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(6744), 1,
      sym__static_type_identifier,
    ACTIONS(9258), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(9373), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [287546] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13371), 1,
      anon_sym_and,
    ACTIONS(14137), 1,
      sym__dedent,
    STATE(9361), 1,
      aux_sym__property_defn_repeat1,
    STATE(9374), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [287583] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5109), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14139), 1,
      sym_identifier,
    STATE(10207), 1,
      sym_access_modifier,
    STATE(9375), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [287620] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13353), 1,
      sym__newline,
    ACTIONS(14141), 1,
      anon_sym_RBRACE,
    STATE(9316), 1,
      aux_sym_record_pattern_repeat1,
    STATE(9376), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [287657] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14143), 1,
      anon_sym_get,
    ACTIONS(14145), 1,
      anon_sym_set,
    STATE(9377), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [287691] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14147), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    STATE(9378), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [287723] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14149), 1,
      sym__indent,
    STATE(9275), 1,
      sym__expression_block,
    STATE(9379), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [287757] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(11166), 1,
      sym__expression_block,
    STATE(9380), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [287791] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14153), 1,
      sym__indent,
    STATE(6358), 1,
      sym__expression_block,
    STATE(9381), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [287825] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14149), 1,
      sym__indent,
    STATE(9083), 1,
      sym__expression_block,
    STATE(9382), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [287859] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14155), 1,
      anon_sym_COLON,
    ACTIONS(14157), 1,
      anon_sym_COLON_GT,
    STATE(9383), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [287893] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14161), 1,
      anon_sym__,
    STATE(9384), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [287927] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14163), 1,
      sym__indent,
    STATE(11624), 1,
      sym__expression_block,
    STATE(9385), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [287961] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14153), 1,
      sym__indent,
    STATE(6365), 1,
      sym__expression_block,
    STATE(9386), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [287995] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14165), 1,
      sym__newline,
    ACTIONS(14167), 1,
      sym__indent,
    STATE(9387), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [288029] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14169), 1,
      sym__indent,
    STATE(1305), 1,
      sym__expression_block,
    STATE(9388), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [288063] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14171), 1,
      sym__indent,
    STATE(2195), 1,
      sym__expression_block,
    STATE(9389), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [288097] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14173), 1,
      sym__indent,
    STATE(6941), 1,
      sym__expression_block,
    STATE(9390), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [288131] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14149), 1,
      sym__indent,
    STATE(9141), 1,
      sym__expression_block,
    STATE(9391), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [288165] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14175), 1,
      anon_sym_get,
    ACTIONS(14177), 1,
      anon_sym_set,
    STATE(9392), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [288199] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14179), 1,
      sym__indent,
    STATE(10803), 1,
      sym__expression_block,
    STATE(9393), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [288233] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14181), 1,
      anon_sym__,
    STATE(9394), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [288267] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14129), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(9395), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [288299] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14183), 1,
      sym__newline,
    ACTIONS(14185), 1,
      sym__indent,
    STATE(9396), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [288333] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14149), 1,
      sym__indent,
    STATE(9212), 1,
      sym__expression_block,
    STATE(9397), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [288367] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14187), 1,
      anon_sym_get,
    ACTIONS(14189), 1,
      anon_sym_set,
    STATE(9398), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [288401] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14173), 1,
      sym__indent,
    STATE(6856), 1,
      sym__expression_block,
    STATE(9399), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [288435] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14191), 1,
      anon_sym_with,
    ACTIONS(14193), 1,
      anon_sym_finally,
    STATE(9400), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [288469] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14195), 1,
      anon_sym_get,
    ACTIONS(14197), 1,
      anon_sym_set,
    STATE(9401), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [288503] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(11194), 1,
      sym__expression_block,
    STATE(9402), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [288537] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14173), 1,
      sym__indent,
    STATE(6869), 1,
      sym__expression_block,
    STATE(9403), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [288571] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14199), 1,
      sym__indent,
    STATE(2346), 1,
      sym__expression_block,
    STATE(9404), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [288605] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14201), 1,
      anon_sym_EQ,
    ACTIONS(14203), 1,
      anon_sym_COLON,
    STATE(9405), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [288639] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14205), 1,
      anon_sym_get,
    ACTIONS(14207), 1,
      anon_sym_set,
    STATE(9406), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [288673] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14209), 1,
      sym__indent,
    STATE(7614), 1,
      sym__expression_block,
    STATE(9407), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [288707] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14211), 1,
      sym__indent,
    STATE(10093), 1,
      sym__expression_block,
    STATE(9408), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [288741] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14213), 1,
      sym__indent,
    STATE(3822), 1,
      sym__expression_block,
    STATE(9409), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [288775] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14179), 1,
      sym__indent,
    STATE(10845), 1,
      sym__expression_block,
    STATE(9410), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [288809] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14209), 1,
      sym__indent,
    STATE(7603), 1,
      sym__expression_block,
    STATE(9411), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [288843] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(11219), 1,
      sym__expression_block,
    STATE(9412), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [288877] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14173), 1,
      sym__indent,
    STATE(6860), 1,
      sym__expression_block,
    STATE(9413), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [288911] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14211), 1,
      sym__indent,
    STATE(10091), 1,
      sym__expression_block,
    STATE(9414), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [288945] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14215), 1,
      sym_identifier,
    STATE(7585), 1,
      sym_member_signature,
    STATE(9415), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [288979] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14217), 1,
      sym__indent,
    STATE(1680), 1,
      sym__expression_block,
    STATE(9416), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [289013] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14219), 1,
      sym__indent,
    STATE(2290), 1,
      sym__expression_block,
    STATE(9417), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [289047] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14221), 1,
      sym__indent,
    STATE(3045), 1,
      sym__expression_block,
    STATE(9418), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [289081] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14217), 1,
      sym__indent,
    STATE(1748), 1,
      sym__expression_block,
    STATE(9419), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [289115] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14209), 1,
      sym__indent,
    STATE(7564), 1,
      sym__expression_block,
    STATE(9420), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [289149] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14215), 1,
      sym_identifier,
    STATE(7546), 1,
      sym_member_signature,
    STATE(9421), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [289183] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14223), 1,
      sym__indent,
    STATE(1065), 1,
      sym__expression_block,
    STATE(9422), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [289217] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14225), 1,
      anon_sym_EQ,
    ACTIONS(14227), 1,
      anon_sym_COLON,
    STATE(9423), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [289251] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14229), 1,
      sym__indent,
    STATE(1933), 1,
      sym__expression_block,
    STATE(9424), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [289285] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14179), 1,
      sym__indent,
    STATE(10761), 1,
      sym__expression_block,
    STATE(9425), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [289319] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14209), 1,
      sym__indent,
    STATE(7573), 1,
      sym__expression_block,
    STATE(9426), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [289353] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14179), 1,
      sym__indent,
    STATE(10885), 1,
      sym__expression_block,
    STATE(9427), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [289387] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14231), 1,
      anon_sym_COLON,
    ACTIONS(14233), 1,
      anon_sym_COLON_GT,
    STATE(9428), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [289421] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14235), 1,
      sym__indent,
    STATE(6876), 1,
      sym__expression_block,
    STATE(9429), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [289455] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14237), 1,
      sym__indent,
    STATE(1392), 1,
      sym__expression_block,
    STATE(9430), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [289489] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14239), 1,
      anon_sym_EQ,
    ACTIONS(14241), 1,
      anon_sym_COLON,
    STATE(9431), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [289523] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14149), 1,
      sym__indent,
    STATE(9071), 1,
      sym__expression_block,
    STATE(9432), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [289557] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14243), 1,
      sym__indent,
    STATE(6543), 1,
      sym__expression_block,
    STATE(9433), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [289591] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14163), 1,
      sym__indent,
    STATE(12117), 1,
      sym__expression_block,
    STATE(9434), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [289625] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14199), 1,
      sym__indent,
    STATE(2324), 1,
      sym__expression_block,
    STATE(9435), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [289659] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9835), 2,
      sym__newline,
      sym__dedent,
    STATE(9436), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [289691] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14245), 1,
      sym__indent,
    STATE(2323), 1,
      sym__expression_block,
    STATE(9437), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [289725] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14247), 1,
      sym__indent,
    STATE(4290), 1,
      sym__expression_block,
    STATE(9438), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [289759] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14179), 1,
      sym__indent,
    STATE(10190), 1,
      sym__expression_block,
    STATE(9439), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [289793] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14249), 1,
      sym__indent,
    STATE(2438), 1,
      sym__expression_block,
    STATE(9440), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [289827] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14217), 1,
      sym__indent,
    STATE(1689), 1,
      sym__expression_block,
    STATE(9441), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [289861] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14223), 1,
      sym__indent,
    STATE(834), 1,
      sym__expression_block,
    STATE(9442), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [289895] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14251), 1,
      anon_sym__,
    STATE(9443), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [289929] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14253), 1,
      sym__indent,
    STATE(6327), 1,
      sym__expression_block,
    STATE(9444), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [289963] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14255), 1,
      sym__newline,
    ACTIONS(14257), 1,
      sym__indent,
    STATE(9445), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [289997] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14215), 1,
      sym_identifier,
    STATE(7609), 1,
      sym_member_signature,
    STATE(9446), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [290031] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(11147), 1,
      sym__expression_block,
    STATE(9447), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [290065] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14223), 1,
      sym__indent,
    STATE(1046), 1,
      sym__expression_block,
    STATE(9448), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [290099] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14163), 1,
      sym__indent,
    STATE(12116), 1,
      sym__expression_block,
    STATE(9449), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [290133] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14209), 1,
      sym__indent,
    STATE(7613), 1,
      sym__expression_block,
    STATE(9450), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [290167] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14209), 1,
      sym__indent,
    STATE(7631), 1,
      sym__expression_block,
    STATE(9451), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [290201] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14259), 1,
      sym__indent,
    STATE(1301), 1,
      sym__expression_block,
    STATE(9452), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [290235] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14217), 1,
      sym__indent,
    STATE(1855), 1,
      sym__expression_block,
    STATE(9453), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [290269] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14261), 1,
      sym__indent,
    STATE(1245), 1,
      sym__expression_block,
    STATE(9454), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [290303] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14263), 1,
      sym__indent,
    STATE(2735), 1,
      sym__expression_block,
    STATE(9455), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [290337] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14265), 1,
      sym__indent,
    STATE(6607), 1,
      sym__expression_block,
    STATE(9456), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [290371] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14267), 1,
      sym__indent,
    STATE(4273), 1,
      sym__expression_block,
    STATE(9457), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [290405] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14179), 1,
      sym__indent,
    STATE(10925), 1,
      sym__expression_block,
    STATE(9458), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [290439] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14269), 1,
      sym_identifier,
    STATE(7625), 1,
      sym_member_signature,
    STATE(9459), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [290473] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14173), 1,
      sym__indent,
    STATE(6903), 1,
      sym__expression_block,
    STATE(9460), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [290507] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14271), 1,
      anon_sym__,
    STATE(9461), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [290541] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14199), 1,
      sym__indent,
    STATE(2533), 1,
      sym__expression_block,
    STATE(9462), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [290575] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14273), 1,
      sym__newline,
    ACTIONS(14275), 1,
      sym__indent,
    STATE(9463), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [290609] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14277), 1,
      anon_sym_with,
    ACTIONS(14279), 1,
      anon_sym_finally,
    STATE(9464), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [290643] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14259), 1,
      sym__indent,
    STATE(1282), 1,
      sym__expression_block,
    STATE(9465), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [290677] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14281), 1,
      anon_sym_with,
    ACTIONS(14283), 1,
      anon_sym_finally,
    STATE(9466), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [290711] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14221), 1,
      sym__indent,
    STATE(3114), 1,
      sym__expression_block,
    STATE(9467), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [290745] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14199), 1,
      sym__indent,
    STATE(2517), 1,
      sym__expression_block,
    STATE(9468), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [290779] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14285), 1,
      sym__newline,
    ACTIONS(14287), 1,
      sym__indent,
    STATE(9469), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [290813] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14171), 1,
      sym__indent,
    STATE(1698), 1,
      sym__expression_block,
    STATE(9470), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [290847] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(11283), 1,
      sym__expression_block,
    STATE(9471), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [290881] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14171), 1,
      sym__indent,
    STATE(2016), 1,
      sym__expression_block,
    STATE(9472), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [290915] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14289), 1,
      sym__indent,
    STATE(2952), 1,
      sym__expression_block,
    STATE(9473), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [290949] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14171), 1,
      sym__indent,
    STATE(2015), 1,
      sym__expression_block,
    STATE(9474), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [290983] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14253), 1,
      sym__indent,
    STATE(6346), 1,
      sym__expression_block,
    STATE(9475), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [291017] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8866), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    STATE(9476), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [291049] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14265), 1,
      sym__indent,
    STATE(6675), 1,
      sym__expression_block,
    STATE(9477), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [291083] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14291), 1,
      sym__indent,
    STATE(4160), 1,
      sym__expression_block,
    STATE(9478), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [291117] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14293), 1,
      anon_sym_EQ,
    ACTIONS(14295), 1,
      anon_sym_COLON,
    STATE(9479), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [291151] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14259), 1,
      sym__indent,
    STATE(1346), 1,
      sym__expression_block,
    STATE(9480), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [291185] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14297), 1,
      anon_sym__,
    STATE(9481), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [291219] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14253), 1,
      sym__indent,
    STATE(6349), 1,
      sym__expression_block,
    STATE(9482), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [291253] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13569), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(9483), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [291285] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14253), 1,
      sym__indent,
    STATE(6339), 1,
      sym__expression_block,
    STATE(9484), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [291319] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13308), 1,
      sym_identifier,
    STATE(11215), 1,
      sym_long_identifier,
    STATE(9485), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [291353] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14217), 1,
      sym__indent,
    STATE(1724), 1,
      sym__expression_block,
    STATE(9486), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [291387] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14299), 1,
      sym__indent,
    STATE(3176), 1,
      sym__expression_block,
    STATE(9487), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [291421] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14149), 1,
      sym__indent,
    STATE(9340), 1,
      sym__expression_block,
    STATE(9488), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [291455] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14223), 1,
      sym__indent,
    STATE(1028), 1,
      sym__expression_block,
    STATE(9489), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [291489] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14301), 1,
      sym__indent,
    STATE(6779), 1,
      sym__expression_block,
    STATE(9490), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [291523] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6915), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(9491), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [291555] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14229), 1,
      sym__indent,
    STATE(1699), 1,
      sym__expression_block,
    STATE(9492), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [291589] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14179), 1,
      sym__indent,
    STATE(10336), 1,
      sym__expression_block,
    STATE(9493), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [291623] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(11299), 1,
      sym__expression_block,
    STATE(9494), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [291657] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14243), 1,
      sym__indent,
    STATE(6544), 1,
      sym__expression_block,
    STATE(9495), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [291691] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14199), 1,
      sym__indent,
    STATE(2446), 1,
      sym__expression_block,
    STATE(9496), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [291725] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14229), 1,
      sym__indent,
    STATE(2031), 1,
      sym__expression_block,
    STATE(9497), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [291759] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14199), 1,
      sym__indent,
    STATE(2445), 1,
      sym__expression_block,
    STATE(9498), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [291793] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14199), 1,
      sym__indent,
    STATE(2331), 1,
      sym__expression_block,
    STATE(9499), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [291827] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14247), 1,
      sym__indent,
    STATE(4285), 1,
      sym__expression_block,
    STATE(9500), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [291861] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14303), 1,
      sym__indent,
    STATE(4276), 1,
      sym__expression_block,
    STATE(9501), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [291895] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14229), 1,
      sym__indent,
    STATE(2039), 1,
      sym__expression_block,
    STATE(9502), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [291929] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14305), 1,
      sym_identifier,
    STATE(6322), 1,
      sym_member_signature,
    STATE(9503), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [291963] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6937), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(9504), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [291995] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14263), 1,
      sym__indent,
    STATE(2759), 1,
      sym__expression_block,
    STATE(9505), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [292029] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14307), 1,
      sym__newline,
    ACTIONS(14309), 1,
      sym__indent,
    STATE(9506), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [292063] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14253), 1,
      sym__indent,
    STATE(6392), 1,
      sym__expression_block,
    STATE(9507), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [292097] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14311), 1,
      sym_identifier,
    STATE(9395), 1,
      sym_enum_type_case,
    STATE(9508), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [292131] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14217), 1,
      sym__indent,
    STATE(1734), 1,
      sym__expression_block,
    STATE(9509), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [292165] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14313), 1,
      anon_sym_COLON,
    ACTIONS(14315), 1,
      anon_sym_COLON_GT,
    STATE(9510), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [292199] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14243), 1,
      sym__indent,
    STATE(6551), 1,
      sym__expression_block,
    STATE(9511), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [292233] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14259), 1,
      sym__indent,
    STATE(1371), 1,
      sym__expression_block,
    STATE(9512), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [292267] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14317), 1,
      sym__indent,
    STATE(7607), 1,
      sym__expression_block,
    STATE(9513), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [292301] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14319), 1,
      anon_sym__,
    STATE(9514), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [292335] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14219), 1,
      sym__indent,
    STATE(1972), 1,
      sym__expression_block,
    STATE(9515), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [292369] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14317), 1,
      sym__indent,
    STATE(7538), 1,
      sym__expression_block,
    STATE(9516), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [292403] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14223), 1,
      sym__indent,
    STATE(1077), 1,
      sym__expression_block,
    STATE(9517), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [292437] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6950), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(9518), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [292469] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14321), 1,
      anon_sym__,
    STATE(9519), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [292503] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14303), 1,
      sym__indent,
    STATE(4267), 1,
      sym__expression_block,
    STATE(9520), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [292537] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14323), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(9521), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [292569] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14223), 1,
      sym__indent,
    STATE(1109), 1,
      sym__expression_block,
    STATE(9522), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [292603] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14325), 1,
      anon_sym_COLON,
    ACTIONS(14327), 1,
      anon_sym_COLON_GT,
    STATE(9523), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [292637] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14199), 1,
      sym__indent,
    STATE(2373), 1,
      sym__expression_block,
    STATE(9524), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [292671] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14317), 1,
      sym__indent,
    STATE(7599), 1,
      sym__expression_block,
    STATE(9525), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [292705] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14329), 1,
      sym__newline,
    ACTIONS(14331), 1,
      sym__indent,
    STATE(9526), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [292739] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9889), 2,
      sym__newline,
      sym__dedent,
    STATE(9527), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [292771] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(11119), 1,
      sym__expression_block,
    STATE(9528), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [292805] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14171), 1,
      sym__indent,
    STATE(1905), 1,
      sym__expression_block,
    STATE(9529), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [292839] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14333), 1,
      sym__indent,
    STATE(2358), 1,
      sym__expression_block,
    STATE(9530), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [292873] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14179), 1,
      sym__indent,
    STATE(10718), 1,
      sym__expression_block,
    STATE(9531), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [292907] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14335), 1,
      sym__indent,
    STATE(3442), 1,
      sym__expression_block,
    STATE(9532), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [292941] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14337), 1,
      sym__indent,
    STATE(7007), 1,
      sym__expression_block,
    STATE(9533), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [292975] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11880), 1,
      sym_identifier,
    STATE(12104), 1,
      sym_long_identifier,
    STATE(9534), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [293009] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14269), 1,
      sym_identifier,
    STATE(7597), 1,
      sym_member_signature,
    STATE(9535), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [293043] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14339), 1,
      anon_sym_EQ,
    ACTIONS(14341), 1,
      anon_sym_COLON,
    STATE(9536), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [293077] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14343), 1,
      anon_sym_get,
    ACTIONS(14345), 1,
      anon_sym_set,
    STATE(9537), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [293111] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14253), 1,
      sym__indent,
    STATE(6337), 1,
      sym__expression_block,
    STATE(9538), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [293145] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14223), 1,
      sym__indent,
    STATE(898), 1,
      sym__expression_block,
    STATE(9539), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [293179] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14217), 1,
      sym__indent,
    STATE(1607), 1,
      sym__expression_block,
    STATE(9540), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [293213] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14347), 1,
      anon_sym_EQ,
    ACTIONS(14349), 1,
      anon_sym_COLON,
    STATE(9541), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [293247] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6821), 2,
      sym__newline,
      sym__dedent,
    STATE(9542), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [293279] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14351), 1,
      anon_sym__,
    STATE(9543), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [293313] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14229), 1,
      sym__indent,
    STATE(1705), 1,
      sym__expression_block,
    STATE(9544), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [293347] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14259), 1,
      sym__indent,
    STATE(1465), 1,
      sym__expression_block,
    STATE(9545), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [293381] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6933), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(9546), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [293413] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6911), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(9547), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [293445] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14353), 2,
      sym__dedent,
      anon_sym_and,
    STATE(9548), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [293477] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14355), 1,
      anon_sym_get,
    ACTIONS(14357), 1,
      anon_sym_set,
    STATE(9549), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [293511] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14359), 1,
      sym__newline,
    ACTIONS(14361), 1,
      sym__indent,
    STATE(9550), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [293545] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14363), 1,
      anon_sym_with,
    ACTIONS(14365), 1,
      anon_sym_finally,
    STATE(9551), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [293579] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14259), 1,
      sym__indent,
    STATE(1468), 1,
      sym__expression_block,
    STATE(9552), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [293613] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14367), 1,
      anon_sym__,
    STATE(9553), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [293647] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14369), 1,
      anon_sym_EQ,
    ACTIONS(14371), 1,
      anon_sym_COLON,
    STATE(9554), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [293681] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14373), 1,
      anon_sym_get,
    ACTIONS(14375), 1,
      anon_sym_set,
    STATE(9555), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [293715] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14259), 1,
      sym__indent,
    STATE(1287), 1,
      sym__expression_block,
    STATE(9556), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [293749] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14377), 1,
      sym__indent,
    STATE(1778), 1,
      sym__expression_block,
    STATE(9557), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [293783] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(11360), 1,
      sym__expression_block,
    STATE(9558), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [293817] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14379), 1,
      sym__indent,
    STATE(6461), 1,
      sym__expression_block,
    STATE(9559), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [293851] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14265), 1,
      sym__indent,
    STATE(6708), 1,
      sym__expression_block,
    STATE(9560), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [293885] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14381), 1,
      sym__indent,
    STATE(1295), 1,
      sym__expression_block,
    STATE(9561), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [293919] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14383), 1,
      sym__indent,
    STATE(3196), 1,
      sym__expression_block,
    STATE(9562), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [293953] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14385), 1,
      anon_sym_PIPE,
    ACTIONS(14387), 1,
      anon_sym_PIPE_RPAREN,
    STATE(9563), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [293987] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14389), 1,
      anon_sym_get,
    ACTIONS(14391), 1,
      anon_sym_set,
    STATE(9564), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [294021] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(11032), 1,
      sym__expression_block,
    STATE(9565), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [294055] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14393), 1,
      anon_sym_EQ,
    ACTIONS(14395), 1,
      anon_sym_COLON,
    STATE(9566), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [294089] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14337), 1,
      sym__indent,
    STATE(7040), 1,
      sym__expression_block,
    STATE(9567), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [294123] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14305), 1,
      sym_identifier,
    STATE(6342), 1,
      sym_member_signature,
    STATE(9568), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [294157] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14223), 1,
      sym__indent,
    STATE(1114), 1,
      sym__expression_block,
    STATE(9569), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [294191] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14379), 1,
      sym__indent,
    STATE(6466), 1,
      sym__expression_block,
    STATE(9570), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [294225] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14337), 1,
      sym__indent,
    STATE(7013), 1,
      sym__expression_block,
    STATE(9571), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [294259] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14171), 1,
      sym__indent,
    STATE(2022), 1,
      sym__expression_block,
    STATE(9572), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [294293] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10425), 1,
      anon_sym_LPAREN,
    ACTIONS(14397), 1,
      anon_sym_new,
    STATE(9573), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [294327] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14337), 1,
      sym__indent,
    STATE(7032), 1,
      sym__expression_block,
    STATE(9574), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [294361] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14261), 1,
      sym__indent,
    STATE(1207), 1,
      sym__expression_block,
    STATE(9575), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [294395] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14213), 1,
      sym__indent,
    STATE(3828), 1,
      sym__expression_block,
    STATE(9576), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [294429] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14171), 1,
      sym__indent,
    STATE(2723), 1,
      sym__expression_block,
    STATE(9577), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [294463] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14217), 1,
      sym__indent,
    STATE(1615), 1,
      sym__expression_block,
    STATE(9578), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [294497] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14399), 1,
      sym__indent,
    STATE(2794), 1,
      sym__expression_block,
    STATE(9579), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [294531] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14401), 1,
      sym__indent,
    STATE(3194), 1,
      sym__expression_block,
    STATE(9580), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [294565] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14337), 1,
      sym__indent,
    STATE(6984), 1,
      sym__expression_block,
    STATE(9581), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [294599] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(11382), 1,
      sym__expression_block,
    STATE(9582), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [294633] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14403), 1,
      sym_identifier,
    STATE(6968), 1,
      sym_member_signature,
    STATE(9583), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [294667] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(11202), 1,
      sym__expression_block,
    STATE(9584), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [294701] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14405), 1,
      anon_sym_with,
    ACTIONS(14407), 1,
      anon_sym_finally,
    STATE(9585), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [294735] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14173), 1,
      sym__indent,
    STATE(6764), 1,
      sym__expression_block,
    STATE(9586), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [294769] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14317), 1,
      sym__indent,
    STATE(7590), 1,
      sym__expression_block,
    STATE(9587), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [294803] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14409), 1,
      sym__newline,
    ACTIONS(14411), 1,
      sym__indent,
    STATE(9588), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [294837] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14337), 1,
      sym__indent,
    STATE(6966), 1,
      sym__expression_block,
    STATE(9589), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [294871] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14149), 1,
      sym__indent,
    STATE(9034), 1,
      sym__expression_block,
    STATE(9590), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [294905] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14267), 1,
      sym__indent,
    STATE(4241), 1,
      sym__expression_block,
    STATE(9591), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [294939] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14413), 1,
      anon_sym__,
    STATE(9592), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [294973] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14383), 1,
      sym__indent,
    STATE(3184), 1,
      sym__expression_block,
    STATE(9593), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [295007] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14383), 1,
      sym__indent,
    STATE(2805), 1,
      sym__expression_block,
    STATE(9594), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [295041] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14213), 1,
      sym__indent,
    STATE(3786), 1,
      sym__expression_block,
    STATE(9595), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [295075] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14269), 1,
      sym_identifier,
    STATE(7589), 1,
      sym_member_signature,
    STATE(9596), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [295109] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14317), 1,
      sym__indent,
    STATE(7580), 1,
      sym__expression_block,
    STATE(9597), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [295143] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14337), 1,
      sym__indent,
    STATE(6962), 1,
      sym__expression_block,
    STATE(9598), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [295177] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14415), 1,
      sym__indent,
    STATE(1700), 1,
      sym__expression_block,
    STATE(9599), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [295211] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14171), 1,
      sym__indent,
    STATE(1701), 1,
      sym__expression_block,
    STATE(9600), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [295245] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14403), 1,
      sym_identifier,
    STATE(6954), 1,
      sym_member_signature,
    STATE(9601), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [295279] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14149), 1,
      sym__indent,
    STATE(9368), 1,
      sym__expression_block,
    STATE(9602), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [295313] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14299), 1,
      sym__indent,
    STATE(3149), 1,
      sym__expression_block,
    STATE(9603), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [295347] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14213), 1,
      sym__indent,
    STATE(3818), 1,
      sym__expression_block,
    STATE(9604), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [295381] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13315), 2,
      sym__newline,
      sym__dedent,
    STATE(9605), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [295413] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14337), 1,
      sym__indent,
    STATE(6953), 1,
      sym__expression_block,
    STATE(9606), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [295447] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14169), 1,
      sym__indent,
    STATE(1553), 1,
      sym__expression_block,
    STATE(9607), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [295481] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14417), 1,
      anon_sym_COLON,
    ACTIONS(14419), 1,
      anon_sym_COLON_GT,
    STATE(9608), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [295515] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14337), 1,
      sym__indent,
    STATE(6950), 1,
      sym__expression_block,
    STATE(9609), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [295549] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14421), 1,
      sym__indent,
    STATE(2221), 1,
      sym__expression_block,
    STATE(9610), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [295583] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14317), 1,
      sym__indent,
    STATE(7579), 1,
      sym__expression_block,
    STATE(9611), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [295617] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14423), 1,
      anon_sym_get,
    ACTIONS(14425), 1,
      anon_sym_set,
    STATE(9612), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [295651] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10425), 1,
      anon_sym_LPAREN,
    ACTIONS(14427), 1,
      anon_sym_new,
    STATE(9613), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [295685] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14383), 1,
      sym__indent,
    STATE(3474), 1,
      sym__expression_block,
    STATE(9614), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [295719] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14253), 1,
      sym__indent,
    STATE(6347), 1,
      sym__expression_block,
    STATE(9615), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [295753] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14429), 1,
      anon_sym_EQ,
    ACTIONS(14431), 1,
      anon_sym_COLON,
    STATE(9616), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [295787] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14305), 1,
      sym_identifier,
    STATE(6350), 1,
      sym_member_signature,
    STATE(9617), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [295821] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14427), 1,
      anon_sym_new,
    ACTIONS(14433), 1,
      anon_sym_LPAREN,
    STATE(9618), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [295855] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14253), 1,
      sym__indent,
    STATE(6353), 1,
      sym__expression_block,
    STATE(9619), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [295889] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14179), 1,
      sym__indent,
    STATE(10406), 1,
      sym__expression_block,
    STATE(9620), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [295923] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14401), 1,
      sym__indent,
    STATE(3146), 1,
      sym__expression_block,
    STATE(9621), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [295957] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14435), 1,
      anon_sym__,
    STATE(9622), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [295991] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14317), 1,
      sym__indent,
    STATE(7569), 1,
      sym__expression_block,
    STATE(9623), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [296025] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14437), 1,
      anon_sym_get,
    ACTIONS(14439), 1,
      anon_sym_set,
    STATE(9624), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [296059] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14383), 1,
      sym__indent,
    STATE(3484), 1,
      sym__expression_block,
    STATE(9625), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [296093] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14333), 1,
      sym__indent,
    STATE(2315), 1,
      sym__expression_block,
    STATE(9626), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [296127] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14441), 1,
      sym__newline,
    ACTIONS(14443), 1,
      sym__indent,
    STATE(9627), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [296161] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14259), 1,
      sym__indent,
    STATE(1443), 1,
      sym__expression_block,
    STATE(9628), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [296195] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14445), 1,
      sym__newline,
    ACTIONS(14447), 1,
      sym__indent,
    STATE(9629), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [296229] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14449), 1,
      sym__indent,
    STATE(6212), 1,
      sym__expression_block,
    STATE(9630), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [296263] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14337), 1,
      sym__indent,
    STATE(7061), 1,
      sym__expression_block,
    STATE(9631), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [296297] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14229), 1,
      sym__indent,
    STATE(2168), 1,
      sym__expression_block,
    STATE(9632), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [296331] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14403), 1,
      sym_identifier,
    STATE(7088), 1,
      sym_member_signature,
    STATE(9633), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [296365] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14317), 1,
      sym__indent,
    STATE(9039), 1,
      sym__expression_block,
    STATE(9634), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [296399] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14451), 1,
      anon_sym__,
    STATE(9635), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [296433] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14453), 1,
      anon_sym_get,
    ACTIONS(14455), 1,
      anon_sym_set,
    STATE(9636), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [296467] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14457), 1,
      sym__newline,
    ACTIONS(14459), 1,
      sym__indent,
    STATE(9637), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [296501] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14461), 1,
      anon_sym_COLON,
    ACTIONS(14463), 1,
      anon_sym_COLON_GT,
    STATE(9638), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [296535] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14465), 1,
      sym__indent,
    STATE(1708), 1,
      sym__expression_block,
    STATE(9639), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [296569] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14337), 1,
      sym__indent,
    STATE(7069), 1,
      sym__expression_block,
    STATE(9640), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [296603] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14467), 1,
      anon_sym_get,
    ACTIONS(14469), 1,
      anon_sym_set,
    STATE(9641), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [296637] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14471), 1,
      anon_sym_get,
    ACTIONS(14473), 1,
      anon_sym_set,
    STATE(9642), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [296671] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6919), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(9643), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [296703] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13878), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    STATE(9644), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [296735] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14223), 1,
      sym__indent,
    STATE(1152), 1,
      sym__expression_block,
    STATE(9645), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [296769] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14475), 1,
      anon_sym__,
    STATE(9646), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [296803] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14223), 1,
      sym__indent,
    STATE(757), 1,
      sym__expression_block,
    STATE(9647), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [296837] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14449), 1,
      sym__indent,
    STATE(6218), 1,
      sym__expression_block,
    STATE(9648), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [296871] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14383), 1,
      sym__indent,
    STATE(3505), 1,
      sym__expression_block,
    STATE(9649), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [296905] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14383), 1,
      sym__indent,
    STATE(3506), 1,
      sym__expression_block,
    STATE(9650), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [296939] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14249), 1,
      sym__indent,
    STATE(2417), 1,
      sym__expression_block,
    STATE(9651), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [296973] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14383), 1,
      sym__indent,
    STATE(3046), 1,
      sym__expression_block,
    STATE(9652), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [297007] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14477), 1,
      sym__newline,
    ACTIONS(14479), 1,
      sym__indent,
    STATE(9653), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [297041] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14481), 1,
      anon_sym_with,
    ACTIONS(14483), 1,
      anon_sym_finally,
    STATE(9654), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [297075] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14485), 1,
      anon_sym_get,
    ACTIONS(14487), 1,
      anon_sym_set,
    STATE(9655), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [297109] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14489), 1,
      anon_sym_get,
    ACTIONS(14491), 1,
      anon_sym_set,
    STATE(9656), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [297143] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14237), 1,
      sym__indent,
    STATE(1624), 1,
      sym__expression_block,
    STATE(9657), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [297177] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14493), 1,
      sym__indent,
    STATE(2748), 1,
      sym__expression_block,
    STATE(9658), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [297211] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14213), 1,
      sym__indent,
    STATE(3804), 1,
      sym__expression_block,
    STATE(9659), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [297245] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14301), 1,
      sym__indent,
    STATE(6851), 1,
      sym__expression_block,
    STATE(9660), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [297279] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(10185), 1,
      sym__expression_block,
    STATE(9661), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [297313] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(11074), 1,
      sym__expression_block,
    STATE(9662), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [297347] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14253), 1,
      sym__indent,
    STATE(6356), 1,
      sym__expression_block,
    STATE(9663), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [297381] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14495), 1,
      sym__indent,
    STATE(2965), 1,
      sym__expression_block,
    STATE(9664), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [297415] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14337), 1,
      sym__indent,
    STATE(6995), 1,
      sym__expression_block,
    STATE(9665), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [297449] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14497), 1,
      sym__indent,
    STATE(2662), 1,
      sym__expression_block,
    STATE(9666), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [297483] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14499), 1,
      anon_sym_EQ,
    ACTIONS(14501), 1,
      anon_sym_COLON,
    STATE(9667), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [297517] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14253), 1,
      sym__indent,
    STATE(6367), 1,
      sym__expression_block,
    STATE(9668), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [297551] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14503), 1,
      sym_identifier,
    STATE(3798), 1,
      sym_member_signature,
    STATE(9669), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [297585] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14505), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(9670), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [297617] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14507), 1,
      anon_sym_EQ,
    ACTIONS(14509), 1,
      anon_sym_COLON,
    STATE(9671), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [297651] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6943), 2,
      sym__newline,
      sym__dedent,
    STATE(9672), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [297683] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14265), 1,
      sym__indent,
    STATE(6547), 1,
      sym__expression_block,
    STATE(9673), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [297717] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14399), 1,
      sym__indent,
    STATE(2577), 1,
      sym__expression_block,
    STATE(9674), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [297751] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14511), 1,
      sym__indent,
    STATE(9726), 1,
      sym__expression_block,
    STATE(9675), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [297785] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14171), 1,
      sym__indent,
    STATE(1717), 1,
      sym__expression_block,
    STATE(9676), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [297819] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13812), 2,
      sym__newline,
      sym__dedent,
    STATE(9677), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [297851] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10425), 1,
      anon_sym_LPAREN,
    ACTIONS(14513), 1,
      anon_sym_new,
    STATE(9678), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [297885] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14245), 1,
      sym__indent,
    STATE(3191), 1,
      sym__expression_block,
    STATE(9679), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [297919] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14179), 1,
      sym__indent,
    STATE(10667), 1,
      sym__expression_block,
    STATE(9680), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [297953] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14317), 1,
      sym__indent,
    STATE(9128), 1,
      sym__expression_block,
    STATE(9681), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [297987] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14515), 1,
      sym__indent,
    STATE(1681), 1,
      sym__expression_block,
    STATE(9682), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [298021] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14209), 1,
      sym__indent,
    STATE(7616), 1,
      sym__expression_block,
    STATE(9683), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [298055] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14433), 1,
      anon_sym_LPAREN,
    ACTIONS(14513), 1,
      anon_sym_new,
    STATE(9684), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [298089] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14517), 1,
      anon_sym_EQ,
    ACTIONS(14519), 1,
      anon_sym_COLON,
    STATE(9685), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [298123] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14521), 1,
      anon_sym_get,
    ACTIONS(14523), 1,
      anon_sym_set,
    STATE(9686), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [298157] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(11467), 1,
      sym__expression_block,
    STATE(9687), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [298191] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(11057), 1,
      sym__expression_block,
    STATE(9688), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [298225] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14525), 1,
      anon_sym_with,
    ACTIONS(14527), 1,
      anon_sym_finally,
    STATE(9689), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [298259] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14383), 1,
      sym__indent,
    STATE(3566), 1,
      sym__expression_block,
    STATE(9690), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [298293] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14529), 1,
      sym__newline,
    ACTIONS(14531), 1,
      sym__indent,
    STATE(9691), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [298327] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14223), 1,
      sym__indent,
    STATE(937), 1,
      sym__expression_block,
    STATE(9692), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [298361] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14171), 1,
      sym__indent,
    STATE(3511), 1,
      sym__expression_block,
    STATE(9693), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [298395] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14533), 1,
      sym_identifier,
    STATE(9672), 1,
      sym_long_identifier,
    STATE(9694), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [298429] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14209), 1,
      sym__indent,
    STATE(7615), 1,
      sym__expression_block,
    STATE(9695), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [298463] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14179), 1,
      sym__indent,
    STATE(10252), 1,
      sym__expression_block,
    STATE(9696), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [298497] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14535), 1,
      anon_sym_get,
    ACTIONS(14537), 1,
      anon_sym_set,
    STATE(9697), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [298531] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14493), 1,
      sym__indent,
    STATE(2727), 1,
      sym__expression_block,
    STATE(9698), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [298565] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6929), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(9699), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [298597] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14539), 1,
      anon_sym__,
    STATE(9700), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [298631] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14541), 1,
      sym__indent,
    STATE(2679), 1,
      sym__expression_block,
    STATE(9701), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [298665] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14317), 1,
      sym__indent,
    STATE(7570), 1,
      sym__expression_block,
    STATE(9702), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [298699] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14291), 1,
      sym__indent,
    STATE(4164), 1,
      sym__expression_block,
    STATE(9703), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [298733] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(11010), 1,
      sym__expression_block,
    STATE(9704), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [298767] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14493), 1,
      sym__indent,
    STATE(2881), 1,
      sym__expression_block,
    STATE(9705), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [298801] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8862), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    STATE(9706), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [298833] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2690), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(9707), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [298865] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14235), 1,
      sym__indent,
    STATE(6917), 1,
      sym__expression_block,
    STATE(9708), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [298899] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14173), 1,
      sym__indent,
    STATE(6902), 1,
      sym__expression_block,
    STATE(9709), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [298933] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14381), 1,
      sym__indent,
    STATE(1311), 1,
      sym__expression_block,
    STATE(9710), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [298967] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14543), 2,
      anon_sym_RBRACK,
      anon_sym_PIPE_RBRACK,
    STATE(9711), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [298999] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6386), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(9712), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [299031] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2138), 2,
      sym__newline,
      sym__dedent,
    STATE(9713), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [299063] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14545), 1,
      sym__indent,
    STATE(1608), 1,
      sym__expression_block,
    STATE(9714), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [299097] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14213), 1,
      sym__indent,
    STATE(3779), 1,
      sym__expression_block,
    STATE(9715), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [299131] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6386), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(9716), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [299163] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14547), 1,
      sym__indent,
    STATE(3128), 1,
      sym__expression_block,
    STATE(9717), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [299197] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14465), 1,
      sym__indent,
    STATE(1727), 1,
      sym__expression_block,
    STATE(9718), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [299231] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14417), 1,
      anon_sym_COLON,
    ACTIONS(14549), 1,
      anon_sym_COLON_GT,
    STATE(9719), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [299265] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6902), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(9720), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [299297] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14493), 1,
      sym__indent,
    STATE(2866), 1,
      sym__expression_block,
    STATE(9721), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [299331] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14551), 1,
      sym__newline,
    ACTIONS(14553), 1,
      sym__indent,
    STATE(9722), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [299365] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14555), 1,
      sym__indent,
    STATE(1566), 1,
      sym__expression_block,
    STATE(9723), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [299399] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11806), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    STATE(9724), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [299431] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14253), 1,
      sym__indent,
    STATE(6379), 1,
      sym__expression_block,
    STATE(9725), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [299465] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4973), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(9726), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [299497] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14557), 1,
      sym__indent,
    STATE(7427), 1,
      sym__expression_block,
    STATE(9727), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [299531] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14559), 1,
      sym__indent,
    STATE(2603), 1,
      sym__expression_block,
    STATE(9728), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [299565] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14421), 1,
      sym__indent,
    STATE(2272), 1,
      sym__expression_block,
    STATE(9729), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [299599] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14229), 1,
      sym__indent,
    STATE(1713), 1,
      sym__expression_block,
    STATE(9730), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [299633] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10425), 1,
      anon_sym_LPAREN,
    ACTIONS(14561), 1,
      anon_sym_new,
    STATE(9731), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [299667] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14563), 1,
      anon_sym__,
    STATE(9732), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [299701] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14149), 1,
      sym__indent,
    STATE(9321), 1,
      sym__expression_block,
    STATE(9733), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [299735] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14223), 1,
      sym__indent,
    STATE(799), 1,
      sym__expression_block,
    STATE(9734), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [299769] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14565), 1,
      anon_sym__,
    STATE(9735), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [299803] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14289), 1,
      sym__indent,
    STATE(3451), 1,
      sym__expression_block,
    STATE(9736), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [299837] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(11029), 1,
      sym__expression_block,
    STATE(9737), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [299871] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14433), 1,
      anon_sym_LPAREN,
    ACTIONS(14561), 1,
      anon_sym_new,
    STATE(9738), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [299905] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14567), 1,
      anon_sym_get,
    ACTIONS(14569), 1,
      anon_sym_set,
    STATE(9739), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [299939] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14571), 2,
      sym__newline,
      anon_sym_GT_RBRACK,
    STATE(9740), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [299971] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14573), 1,
      sym__newline,
    ACTIONS(14575), 1,
      sym__indent,
    STATE(9741), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [300005] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14223), 1,
      sym__indent,
    STATE(1143), 1,
      sym__expression_block,
    STATE(9742), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [300039] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14557), 1,
      sym__indent,
    STATE(7481), 1,
      sym__expression_block,
    STATE(9743), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [300073] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14229), 1,
      sym__indent,
    STATE(2129), 1,
      sym__expression_block,
    STATE(9744), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [300107] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14209), 1,
      sym__indent,
    STATE(7517), 1,
      sym__expression_block,
    STATE(9745), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [300141] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14577), 1,
      sym__indent,
    STATE(2539), 1,
      sym__expression_block,
    STATE(9746), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [300175] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14579), 1,
      anon_sym_get,
    ACTIONS(14581), 1,
      anon_sym_set,
    STATE(9747), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [300209] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14583), 1,
      anon_sym_get,
    ACTIONS(14585), 1,
      anon_sym_set,
    STATE(9748), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [300243] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14243), 1,
      sym__indent,
    STATE(6583), 1,
      sym__expression_block,
    STATE(9749), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [300277] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14493), 1,
      sym__indent,
    STATE(2824), 1,
      sym__expression_block,
    STATE(9750), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [300311] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14265), 1,
      sym__indent,
    STATE(6658), 1,
      sym__expression_block,
    STATE(9751), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [300345] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14587), 1,
      sym__indent,
    STATE(3012), 1,
      sym__expression_block,
    STATE(9752), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [300379] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14493), 1,
      sym__indent,
    STATE(2820), 1,
      sym__expression_block,
    STATE(9753), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [300413] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14589), 1,
      anon_sym_get,
    ACTIONS(14591), 1,
      anon_sym_set,
    STATE(9754), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [300447] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14235), 1,
      sym__indent,
    STATE(6890), 1,
      sym__expression_block,
    STATE(9755), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [300481] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14493), 1,
      sym__indent,
    STATE(2753), 1,
      sym__expression_block,
    STATE(9756), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [300515] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14593), 1,
      anon_sym_EQ,
    ACTIONS(14595), 1,
      anon_sym_COLON,
    STATE(9757), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [300549] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14235), 1,
      sym__indent,
    STATE(6838), 1,
      sym__expression_block,
    STATE(9758), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [300583] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14597), 1,
      sym__indent,
    STATE(2788), 1,
      sym__expression_block,
    STATE(9759), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [300617] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14317), 1,
      sym__indent,
    STATE(7559), 1,
      sym__expression_block,
    STATE(9760), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [300651] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14599), 1,
      sym__indent,
    STATE(2890), 1,
      sym__expression_block,
    STATE(9761), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [300685] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14289), 1,
      sym__indent,
    STATE(3155), 1,
      sym__expression_block,
    STATE(9762), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [300719] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14601), 1,
      anon_sym__,
    STATE(9763), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [300753] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14603), 1,
      sym__indent,
    STATE(2313), 1,
      sym__expression_block,
    STATE(9764), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [300787] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14605), 1,
      sym__newline,
    ACTIONS(14607), 1,
      sym__indent,
    STATE(9765), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [300821] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14289), 1,
      sym__indent,
    STATE(3315), 1,
      sym__expression_block,
    STATE(9766), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [300855] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14609), 1,
      anon_sym_with,
    ACTIONS(14611), 1,
      anon_sym_finally,
    STATE(9767), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [300889] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14613), 1,
      sym_identifier,
    STATE(558), 1,
      sym_long_identifier,
    STATE(9768), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [300923] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14235), 1,
      sym__indent,
    STATE(6775), 1,
      sym__expression_block,
    STATE(9769), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [300957] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14615), 1,
      sym_identifier,
    STATE(6881), 1,
      sym_member_signature,
    STATE(9770), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [300991] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14617), 1,
      anon_sym_EQ,
    ACTIONS(14619), 1,
      anon_sym_COLON,
    STATE(9771), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [301025] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14621), 1,
      sym__indent,
    STATE(4239), 1,
      sym__expression_block,
    STATE(9772), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [301059] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14235), 1,
      sym__indent,
    STATE(6804), 1,
      sym__expression_block,
    STATE(9773), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [301093] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14623), 1,
      sym_identifier,
    STATE(548), 1,
      sym_long_identifier,
    STATE(9774), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [301127] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14547), 1,
      sym__indent,
    STATE(2967), 1,
      sym__expression_block,
    STATE(9775), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [301161] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14289), 1,
      sym__indent,
    STATE(3309), 1,
      sym__expression_block,
    STATE(9776), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [301195] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14547), 1,
      sym__indent,
    STATE(2994), 1,
      sym__expression_block,
    STATE(9777), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [301229] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14497), 1,
      sym__indent,
    STATE(2343), 1,
      sym__expression_block,
    STATE(9778), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [301263] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(11523), 1,
      sym__expression_block,
    STATE(9779), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [301297] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14545), 1,
      sym__indent,
    STATE(1399), 1,
      sym__expression_block,
    STATE(9780), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [301331] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14587), 1,
      sym__indent,
    STATE(3086), 1,
      sym__expression_block,
    STATE(9781), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [301365] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13308), 1,
      sym_identifier,
    STATE(10220), 1,
      sym_long_identifier,
    STATE(9782), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [301399] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14547), 1,
      sym__indent,
    STATE(2993), 1,
      sym__expression_block,
    STATE(9783), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [301433] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14587), 1,
      sym__indent,
    STATE(2896), 1,
      sym__expression_block,
    STATE(9784), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [301467] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14223), 1,
      sym__indent,
    STATE(4293), 1,
      sym__expression_block,
    STATE(9785), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [301501] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14223), 1,
      sym__indent,
    STATE(770), 1,
      sym__expression_block,
    STATE(9786), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [301535] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14379), 1,
      sym__indent,
    STATE(6470), 1,
      sym__expression_block,
    STATE(9787), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [301569] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14625), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    STATE(9788), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [301601] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14627), 1,
      anon_sym_EQ,
    ACTIONS(14629), 1,
      anon_sym_COLON,
    STATE(9789), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [301635] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14235), 1,
      sym__indent,
    STATE(6821), 1,
      sym__expression_block,
    STATE(9790), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [301669] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14223), 1,
      sym__indent,
    STATE(1013), 1,
      sym__expression_block,
    STATE(9791), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [301703] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14615), 1,
      sym_identifier,
    STATE(6808), 1,
      sym_member_signature,
    STATE(9792), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [301737] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14229), 1,
      sym__indent,
    STATE(1663), 1,
      sym__expression_block,
    STATE(9793), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [301771] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14631), 1,
      sym__indent,
    STATE(8943), 1,
      sym__expression_block,
    STATE(9794), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [301805] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14555), 1,
      sym__indent,
    STATE(1731), 1,
      sym__expression_block,
    STATE(9795), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [301839] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14379), 1,
      sym__indent,
    STATE(6494), 1,
      sym__expression_block,
    STATE(9796), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [301873] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14235), 1,
      sym__indent,
    STATE(6807), 1,
      sym__expression_block,
    STATE(9797), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [301907] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14633), 1,
      sym__indent,
    STATE(2954), 1,
      sym__expression_block,
    STATE(9798), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [301941] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13669), 2,
      sym__newline,
      anon_sym_RPAREN,
    STATE(9799), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [301973] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14635), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    STATE(9800), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [302005] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(1416), 2,
      sym__dedent,
      anon_sym_COMMA,
    STATE(9801), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [302037] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11523), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(9802), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [302069] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14587), 1,
      sym__indent,
    STATE(3403), 1,
      sym__expression_block,
    STATE(9803), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [302103] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14637), 1,
      sym__newline,
    ACTIONS(14639), 1,
      sym__indent,
    STATE(9804), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [302137] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(11548), 1,
      sym__expression_block,
    STATE(9805), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [302171] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14603), 1,
      sym__indent,
    STATE(2333), 1,
      sym__expression_block,
    STATE(9806), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [302205] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14265), 1,
      sym__indent,
    STATE(6622), 1,
      sym__expression_block,
    STATE(9807), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [302239] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14641), 1,
      sym_identifier,
    STATE(6487), 1,
      sym_member_signature,
    STATE(9808), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [302273] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14587), 1,
      sym__indent,
    STATE(3376), 1,
      sym__expression_block,
    STATE(9809), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [302307] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14643), 1,
      anon_sym_with,
    ACTIONS(14645), 1,
      anon_sym_finally,
    STATE(9810), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [302341] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14647), 2,
      ts_builtin_sym_end,
      anon_sym_namespace,
    STATE(9811), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [302373] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14503), 1,
      sym_identifier,
    STATE(3810), 1,
      sym_member_signature,
    STATE(9812), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [302407] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14223), 1,
      sym__indent,
    STATE(1095), 1,
      sym__expression_block,
    STATE(9813), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [302441] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13308), 1,
      sym_identifier,
    STATE(10205), 1,
      sym_long_identifier,
    STATE(9814), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [302475] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14631), 1,
      sym__indent,
    STATE(8945), 1,
      sym__expression_block,
    STATE(9815), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [302509] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14149), 1,
      sym__indent,
    STATE(8947), 1,
      sym__expression_block,
    STATE(9816), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [302543] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14235), 1,
      sym__indent,
    STATE(6772), 1,
      sym__expression_block,
    STATE(9817), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [302577] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14615), 1,
      sym_identifier,
    STATE(6780), 1,
      sym_member_signature,
    STATE(9818), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [302611] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14289), 1,
      sym__indent,
    STATE(3212), 1,
      sym__expression_block,
    STATE(9819), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [302645] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14493), 1,
      sym__indent,
    STATE(2856), 1,
      sym__expression_block,
    STATE(9820), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [302679] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14265), 1,
      sym__indent,
    STATE(6593), 1,
      sym__expression_block,
    STATE(9821), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [302713] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14235), 1,
      sym__indent,
    STATE(6847), 1,
      sym__expression_block,
    STATE(9822), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [302747] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14649), 1,
      sym_identifier,
    STATE(6609), 1,
      sym_member_signature,
    STATE(9823), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [302781] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14651), 1,
      sym__newline,
    ACTIONS(14653), 1,
      sym__indent,
    STATE(9824), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [302815] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14655), 1,
      sym_identifier,
    STATE(6601), 1,
      sym_member_signature,
    STATE(9825), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [302849] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14657), 1,
      sym__indent,
    STATE(1631), 1,
      sym__expression_block,
    STATE(9826), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [302883] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9852), 2,
      sym__newline,
      sym__dedent,
    STATE(9827), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [302915] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14659), 1,
      anon_sym__,
    STATE(9828), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [302949] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14223), 1,
      sym__indent,
    STATE(1181), 1,
      sym__expression_block,
    STATE(9829), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [302983] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14265), 1,
      sym__indent,
    STATE(6584), 1,
      sym__expression_block,
    STATE(9830), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [303017] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14587), 1,
      sym__indent,
    STATE(3307), 1,
      sym__expression_block,
    STATE(9831), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [303051] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14587), 1,
      sym__indent,
    STATE(3299), 1,
      sym__expression_block,
    STATE(9832), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [303085] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14587), 1,
      sym__indent,
    STATE(3162), 1,
      sym__expression_block,
    STATE(9833), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [303119] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6915), 2,
      sym__newline,
      sym__dedent,
    STATE(9834), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [303151] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14661), 1,
      anon_sym_COLON,
    ACTIONS(14663), 1,
      anon_sym_COLON_GT,
    STATE(9835), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [303185] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13308), 1,
      sym_identifier,
    STATE(11719), 1,
      sym_long_identifier,
    STATE(9836), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [303219] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14223), 1,
      sym__indent,
    STATE(4295), 1,
      sym__expression_block,
    STATE(9837), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [303253] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14249), 1,
      sym__indent,
    STATE(2304), 1,
      sym__expression_block,
    STATE(9838), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [303287] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14665), 1,
      anon_sym_EQ,
    ACTIONS(14667), 1,
      anon_sym_COLON,
    STATE(9839), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [303321] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14289), 1,
      sym__indent,
    STATE(3200), 1,
      sym__expression_block,
    STATE(9840), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [303355] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14379), 1,
      sym__indent,
    STATE(6519), 1,
      sym__expression_block,
    STATE(9841), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [303389] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14249), 1,
      sym__indent,
    STATE(2474), 1,
      sym__expression_block,
    STATE(9842), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [303423] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14547), 1,
      sym__indent,
    STATE(2978), 1,
      sym__expression_block,
    STATE(9843), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [303457] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14669), 2,
      anon_sym_RBRACK,
      anon_sym_PIPE_RBRACK,
    STATE(9844), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [303489] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14379), 1,
      sym__indent,
    STATE(6522), 1,
      sym__expression_block,
    STATE(9845), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [303523] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14671), 1,
      anon_sym__,
    STATE(9846), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [303557] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14149), 1,
      sym__indent,
    STATE(9366), 1,
      sym__expression_block,
    STATE(9847), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [303591] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14673), 1,
      sym__indent,
    STATE(1839), 1,
      sym__expression_block,
    STATE(9848), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [303625] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13641), 2,
      sym__dedent,
      anon_sym_and,
    STATE(9849), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [303657] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14547), 1,
      sym__indent,
    STATE(2996), 1,
      sym__expression_block,
    STATE(9850), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [303691] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14675), 1,
      sym__newline,
    ACTIONS(14677), 1,
      sym__indent,
    STATE(9851), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [303725] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14235), 1,
      sym__indent,
    STATE(6843), 1,
      sym__expression_block,
    STATE(9852), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [303759] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14379), 1,
      sym__indent,
    STATE(6481), 1,
      sym__expression_block,
    STATE(9853), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [303793] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14243), 1,
      sym__indent,
    STATE(6596), 1,
      sym__expression_block,
    STATE(9854), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [303827] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14679), 2,
      sym__dedent,
      anon_sym_interface,
    STATE(9855), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [303859] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14243), 1,
      sym__indent,
    STATE(6602), 1,
      sym__expression_block,
    STATE(9856), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [303893] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13613), 2,
      sym__newline,
      anon_sym_RBRACE,
    STATE(9857), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [303925] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14259), 1,
      sym__indent,
    STATE(1250), 1,
      sym__expression_block,
    STATE(9858), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [303959] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14599), 1,
      sym__indent,
    STATE(2570), 1,
      sym__expression_block,
    STATE(9859), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [303993] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14641), 1,
      sym_identifier,
    STATE(6425), 1,
      sym_member_signature,
    STATE(9860), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [304027] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14681), 1,
      sym__indent,
    STATE(4284), 1,
      sym__expression_block,
    STATE(9861), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [304061] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6937), 2,
      sym__newline,
      sym__dedent,
    STATE(9862), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [304093] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6950), 2,
      sym__newline,
      sym__dedent,
    STATE(9863), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [304125] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14213), 1,
      sym__indent,
    STATE(3776), 1,
      sym__expression_block,
    STATE(9864), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [304159] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14683), 1,
      sym__newline,
    ACTIONS(14685), 1,
      sym__indent,
    STATE(9865), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [304193] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14179), 1,
      sym__indent,
    STATE(11730), 1,
      sym__expression_block,
    STATE(9866), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [304227] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14149), 1,
      sym__indent,
    STATE(9144), 1,
      sym__expression_block,
    STATE(9867), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [304261] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14687), 1,
      anon_sym__,
    STATE(9868), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [304295] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14655), 1,
      sym_identifier,
    STATE(6610), 1,
      sym_member_signature,
    STATE(9869), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [304329] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14689), 1,
      anon_sym_with,
    STATE(8905), 1,
      sym__object_members,
    STATE(9870), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [304363] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14335), 1,
      sym__indent,
    STATE(1780), 1,
      sym__expression_block,
    STATE(9871), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [304397] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14223), 1,
      sym__indent,
    STATE(880), 1,
      sym__expression_block,
    STATE(9872), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [304431] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(11743), 1,
      sym__expression_block,
    STATE(9873), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [304465] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14691), 1,
      anon_sym__,
    STATE(9874), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [304499] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14693), 1,
      sym__indent,
    STATE(4226), 1,
      sym__expression_block,
    STATE(9875), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [304533] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14681), 1,
      sym__indent,
    STATE(4288), 1,
      sym__expression_block,
    STATE(9876), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [304567] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14249), 1,
      sym__indent,
    STATE(2468), 1,
      sym__expression_block,
    STATE(9877), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [304601] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14695), 1,
      sym__newline,
    ACTIONS(14697), 1,
      sym__indent,
    STATE(9878), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [304635] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14699), 1,
      sym__indent,
    STATE(1630), 1,
      sym__expression_block,
    STATE(9879), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [304669] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14149), 1,
      sym__indent,
    STATE(9272), 1,
      sym__expression_block,
    STATE(9880), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [304703] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14265), 1,
      sym__indent,
    STATE(6661), 1,
      sym__expression_block,
    STATE(9881), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [304737] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14701), 1,
      anon_sym_do,
    ACTIONS(14703), 1,
      anon_sym_DASH_GT,
    STATE(9882), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [304771] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14705), 1,
      sym__indent,
    STATE(2912), 1,
      sym__expression_block,
    STATE(9883), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [304805] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14707), 1,
      anon_sym_with,
    ACTIONS(14709), 1,
      anon_sym_finally,
    STATE(9884), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [304839] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14711), 1,
      anon_sym__,
    STATE(9885), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [304873] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14547), 1,
      sym__indent,
    STATE(2769), 1,
      sym__expression_block,
    STATE(9886), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [304907] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(10968), 1,
      sym__expression_block,
    STATE(9887), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [304941] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(11599), 1,
      sym__expression_block,
    STATE(9888), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [304975] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14289), 1,
      sym__indent,
    STATE(3183), 1,
      sym__expression_block,
    STATE(9889), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [305009] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14291), 1,
      sym__indent,
    STATE(4140), 1,
      sym__expression_block,
    STATE(9890), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [305043] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14621), 1,
      sym__indent,
    STATE(4271), 1,
      sym__expression_block,
    STATE(9891), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [305077] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14713), 1,
      sym__indent,
    STATE(2667), 1,
      sym__expression_block,
    STATE(9892), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [305111] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6943), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(9893), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [305143] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14547), 1,
      sym__indent,
    STATE(2925), 1,
      sym__expression_block,
    STATE(9894), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [305177] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14245), 1,
      sym__indent,
    STATE(3168), 1,
      sym__expression_block,
    STATE(9895), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [305211] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14715), 2,
      sym__dedent,
      anon_sym_COMMA,
    STATE(9896), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [305243] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14717), 1,
      anon_sym_EQ,
    ACTIONS(14719), 1,
      anon_sym_COLON,
    STATE(9897), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [305277] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14243), 1,
      sym__indent,
    STATE(6677), 1,
      sym__expression_block,
    STATE(9898), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [305311] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14721), 1,
      anon_sym_EQ,
    ACTIONS(14723), 1,
      anon_sym_COLON,
    STATE(9899), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [305345] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14199), 1,
      sym__indent,
    STATE(2755), 1,
      sym__expression_block,
    STATE(9900), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [305379] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14379), 1,
      sym__indent,
    STATE(6506), 1,
      sym__expression_block,
    STATE(9901), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [305413] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14655), 1,
      sym_identifier,
    STATE(6680), 1,
      sym_member_signature,
    STATE(9902), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [305447] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14243), 1,
      sym__indent,
    STATE(6691), 1,
      sym__expression_block,
    STATE(9903), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [305481] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14235), 1,
      sym__indent,
    STATE(6896), 1,
      sym__expression_block,
    STATE(9904), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [305515] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14587), 1,
      sym__indent,
    STATE(3382), 1,
      sym__expression_block,
    STATE(9905), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [305549] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13569), 2,
      sym__dedent,
      anon_sym_COMMA,
    STATE(9906), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [305581] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14673), 1,
      sym__indent,
    STATE(1887), 1,
      sym__expression_block,
    STATE(9907), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [305615] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14577), 1,
      sym__indent,
    STATE(2729), 1,
      sym__expression_block,
    STATE(9908), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [305649] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14335), 1,
      sym__indent,
    STATE(1765), 1,
      sym__expression_block,
    STATE(9909), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [305683] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14725), 1,
      sym__indent,
    STATE(1283), 1,
      sym__expression_block,
    STATE(9910), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [305717] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14217), 1,
      sym__indent,
    STATE(1570), 1,
      sym__expression_block,
    STATE(9911), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [305751] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(11629), 1,
      sym__expression_block,
    STATE(9912), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [305785] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14727), 1,
      sym__indent,
    STATE(1885), 1,
      sym__expression_block,
    STATE(9913), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [305819] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14729), 1,
      sym__indent,
    STATE(4227), 1,
      sym__expression_block,
    STATE(9914), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [305853] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14243), 1,
      sym__indent,
    STATE(6703), 1,
      sym__expression_block,
    STATE(9915), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [305887] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14213), 1,
      sym__indent,
    STATE(3859), 1,
      sym__expression_block,
    STATE(9916), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [305921] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14217), 1,
      sym__indent,
    STATE(3111), 1,
      sym__expression_block,
    STATE(9917), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [305955] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11494), 1,
      sym_identifier,
    STATE(9893), 1,
      sym_long_identifier,
    STATE(9918), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [305989] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14495), 1,
      sym__indent,
    STATE(2829), 1,
      sym__expression_block,
    STATE(9919), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [306023] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14731), 2,
      anon_sym_RBRACK,
      anon_sym_PIPE_RBRACK,
    STATE(9920), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [306055] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14243), 1,
      sym__indent,
    STATE(6592), 1,
      sym__expression_block,
    STATE(9921), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [306089] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14641), 1,
      sym_identifier,
    STATE(6498), 1,
      sym_member_signature,
    STATE(9922), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [306123] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(10870), 1,
      sym__expression_block,
    STATE(9923), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [306157] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14623), 1,
      sym_identifier,
    STATE(4173), 1,
      sym_long_identifier,
    STATE(9924), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [306191] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6933), 2,
      sym__newline,
      sym__dedent,
    STATE(9925), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [306223] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6911), 2,
      sym__newline,
      sym__dedent,
    STATE(9926), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [306255] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14733), 1,
      anon_sym_with,
    ACTIONS(14735), 1,
      anon_sym_finally,
    STATE(9927), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [306289] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14737), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    STATE(9928), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [306321] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14335), 1,
      sym__indent,
    STATE(2157), 1,
      sym__expression_block,
    STATE(9929), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [306355] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13308), 1,
      sym_identifier,
    STATE(10228), 1,
      sym_long_identifier,
    STATE(9930), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [306389] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14739), 1,
      sym__indent,
    STATE(1467), 1,
      sym__expression_block,
    STATE(9931), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [306423] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3698), 2,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(9932), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [306455] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14657), 1,
      sym__indent,
    STATE(1664), 1,
      sym__expression_block,
    STATE(9933), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [306489] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14155), 1,
      anon_sym_COLON,
    ACTIONS(14741), 1,
      anon_sym_COLON_GT,
    STATE(9934), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [306523] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13544), 2,
      sym__newline,
      sym__dedent,
    STATE(9935), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [306555] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14727), 1,
      sym__indent,
    STATE(1894), 1,
      sym__expression_block,
    STATE(9936), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [306589] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14559), 1,
      sym__indent,
    STATE(2823), 1,
      sym__expression_block,
    STATE(9937), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [306623] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14213), 1,
      sym__indent,
    STATE(3844), 1,
      sym__expression_block,
    STATE(9938), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [306657] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14743), 1,
      sym__indent,
    STATE(7422), 1,
      sym__expression_block,
    STATE(9939), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [306691] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6919), 2,
      sym__newline,
      sym__dedent,
    STATE(9940), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [306723] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14745), 1,
      anon_sym__,
    STATE(9941), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [306757] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14503), 1,
      sym_identifier,
    STATE(3762), 1,
      sym_member_signature,
    STATE(9942), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [306791] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14249), 1,
      sym__indent,
    STATE(2294), 1,
      sym__expression_block,
    STATE(9943), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [306825] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14223), 1,
      sym__indent,
    STATE(774), 1,
      sym__expression_block,
    STATE(9944), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [306859] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14747), 1,
      sym__newline,
    ACTIONS(14749), 1,
      sym__indent,
    STATE(9945), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [306893] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14243), 1,
      sym__indent,
    STATE(6735), 1,
      sym__expression_block,
    STATE(9946), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [306927] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14705), 1,
      sym__indent,
    STATE(2945), 1,
      sym__expression_block,
    STATE(9947), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [306961] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14379), 1,
      sym__indent,
    STATE(6473), 1,
      sym__expression_block,
    STATE(9948), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [306995] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14335), 1,
      sym__indent,
    STATE(2137), 1,
      sym__expression_block,
    STATE(9949), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [307029] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14243), 1,
      sym__indent,
    STATE(6619), 1,
      sym__expression_block,
    STATE(9950), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [307063] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14751), 1,
      anon_sym_get,
    ACTIONS(14753), 1,
      anon_sym_set,
    STATE(9951), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [307097] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14555), 1,
      sym__indent,
    STATE(1626), 1,
      sym__expression_block,
    STATE(9952), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [307131] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14755), 2,
      sym__newline,
      anon_sym_GT_RBRACK,
    STATE(9953), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [307163] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14547), 1,
      sym__indent,
    STATE(2887), 1,
      sym__expression_block,
    STATE(9954), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [307197] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6929), 2,
      sym__newline,
      sym__dedent,
    STATE(9955), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [307229] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14179), 1,
      sym__indent,
    STATE(10199), 1,
      sym__expression_block,
    STATE(9956), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [307263] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14757), 1,
      anon_sym__,
    STATE(9957), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [307297] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13526), 2,
      sym__newline,
      anon_sym_GT_RBRACK,
    STATE(9958), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [307329] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14179), 1,
      sym__indent,
    STATE(10544), 1,
      sym__expression_block,
    STATE(9959), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [307363] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14759), 1,
      anon_sym__,
    STATE(9960), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [307397] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14761), 1,
      anon_sym_get,
    ACTIONS(14763), 1,
      anon_sym_set,
    STATE(9961), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [307431] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14379), 1,
      sym__indent,
    STATE(6464), 1,
      sym__expression_block,
    STATE(9962), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [307465] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14765), 1,
      sym__newline,
    ACTIONS(14767), 1,
      sym__indent,
    STATE(9963), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [307499] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9416), 2,
      anon_sym_LBRACK_LT,
      anon_sym_and,
    STATE(9964), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [307531] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14769), 1,
      anon_sym_with,
    ACTIONS(14771), 1,
      anon_sym_finally,
    STATE(9965), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [307565] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11694), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    STATE(9966), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [307597] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14223), 1,
      sym__indent,
    STATE(1155), 1,
      sym__expression_block,
    STATE(9967), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [307631] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(11676), 1,
      sym__expression_block,
    STATE(9968), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [307665] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14773), 1,
      anon_sym_get,
    ACTIONS(14775), 1,
      anon_sym_set,
    STATE(9969), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [307699] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14777), 1,
      anon_sym_DQUOTE,
    STATE(12102), 1,
      sym__string_literal,
    STATE(9970), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [307733] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14779), 1,
      sym__newline,
    ACTIONS(14781), 1,
      sym__indent,
    STATE(9971), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [307767] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(12100), 1,
      sym__expression_block,
    STATE(9972), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [307801] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14555), 1,
      sym__indent,
    STATE(1750), 1,
      sym__expression_block,
    STATE(9973), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [307835] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14783), 1,
      anon_sym_get,
    ACTIONS(14785), 1,
      anon_sym_set,
    STATE(9974), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [307869] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14213), 1,
      sym__indent,
    STATE(3811), 1,
      sym__expression_block,
    STATE(9975), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [307903] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14555), 1,
      sym__indent,
    STATE(1757), 1,
      sym__expression_block,
    STATE(9976), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [307937] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14787), 1,
      anon_sym_EQ,
    ACTIONS(14789), 1,
      anon_sym_COLON,
    STATE(9977), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [307971] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14791), 2,
      anon_sym_RBRACK,
      anon_sym_PIPE_RBRACK,
    STATE(9978), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [308003] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14335), 1,
      sym__indent,
    STATE(2115), 1,
      sym__expression_block,
    STATE(9979), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [308037] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14179), 1,
      sym__indent,
    STATE(10608), 1,
      sym__expression_block,
    STATE(9980), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [308071] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14289), 1,
      sym__indent,
    STATE(3189), 1,
      sym__expression_block,
    STATE(9981), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [308105] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6902), 2,
      sym__newline,
      sym__dedent,
    STATE(9982), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [308137] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14265), 1,
      sym__indent,
    STATE(6626), 1,
      sym__expression_block,
    STATE(9983), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [308171] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14793), 1,
      anon_sym_EQ,
    ACTIONS(14795), 1,
      anon_sym_COLON,
    STATE(9984), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [308205] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9388), 2,
      anon_sym_LBRACK_LT,
      anon_sym_and,
    STATE(9985), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [308237] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14335), 1,
      sym__indent,
    STATE(2107), 1,
      sym__expression_block,
    STATE(9986), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [308271] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14715), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(9987), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [308303] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14335), 1,
      sym__indent,
    STATE(1790), 1,
      sym__expression_block,
    STATE(9988), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [308337] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(11701), 1,
      sym__expression_block,
    STATE(9989), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [308371] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14515), 1,
      sym__indent,
    STATE(1842), 1,
      sym__expression_block,
    STATE(9990), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [308405] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14777), 1,
      anon_sym_DQUOTE,
    STATE(11655), 1,
      sym__string_literal,
    STATE(9991), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [308439] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14729), 1,
      sym__indent,
    STATE(4224), 1,
      sym__expression_block,
    STATE(9992), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [308473] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(12074), 1,
      sym__expression_block,
    STATE(9993), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [308507] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9362), 2,
      anon_sym_LBRACK_LT,
      anon_sym_and,
    STATE(9994), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [308539] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14739), 1,
      sym__indent,
    STATE(1612), 1,
      sym__expression_block,
    STATE(9995), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [308573] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14797), 1,
      sym__indent,
    STATE(1616), 1,
      sym__expression_block,
    STATE(9996), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [308607] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14799), 1,
      anon_sym__,
    STATE(9997), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [308641] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14801), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    STATE(9998), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [308673] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14245), 1,
      sym__indent,
    STATE(3423), 1,
      sym__expression_block,
    STATE(9999), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [308707] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(1416), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(10000), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [308739] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14803), 1,
      anon_sym_EQ,
    ACTIONS(14805), 1,
      anon_sym_COLON,
    STATE(10001), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [308773] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14807), 1,
      anon_sym_with,
    ACTIONS(14809), 1,
      anon_sym_finally,
    STATE(10002), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [308807] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14811), 1,
      sym__newline,
    ACTIONS(14813), 1,
      sym__indent,
    STATE(10003), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [308841] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14699), 1,
      sym__indent,
    STATE(1324), 1,
      sym__expression_block,
    STATE(10004), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [308875] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14777), 1,
      anon_sym_DQUOTE,
    STATE(11966), 1,
      sym__string_literal,
    STATE(10005), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [308909] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14815), 1,
      anon_sym__,
    STATE(10006), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [308943] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14515), 1,
      sym__indent,
    STATE(1834), 1,
      sym__expression_block,
    STATE(10007), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [308977] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14493), 1,
      sym__indent,
    STATE(2695), 1,
      sym__expression_block,
    STATE(10008), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [309011] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14253), 1,
      sym__indent,
    STATE(6378), 1,
      sym__expression_block,
    STATE(10009), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [309045] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14223), 1,
      sym__indent,
    STATE(1177), 1,
      sym__expression_block,
    STATE(10010), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [309079] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12809), 1,
      anon_sym_DQUOTE,
    STATE(11973), 1,
      sym__string_literal,
    STATE(10011), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [309113] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14515), 1,
      sym__indent,
    STATE(1986), 1,
      sym__expression_block,
    STATE(10012), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [309147] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14693), 1,
      sym__indent,
    STATE(4230), 1,
      sym__expression_block,
    STATE(10013), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [309181] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14265), 1,
      sym__indent,
    STATE(6650), 1,
      sym__expression_block,
    STATE(10014), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [309215] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14817), 1,
      anon_sym__,
    STATE(10015), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [309249] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14149), 1,
      sym__indent,
    STATE(9222), 1,
      sym__expression_block,
    STATE(10016), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [309283] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14819), 1,
      anon_sym__,
    STATE(10017), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [309317] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14797), 1,
      sym__indent,
    STATE(1627), 1,
      sym__expression_block,
    STATE(10018), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [309351] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14149), 1,
      sym__indent,
    STATE(9029), 1,
      sym__expression_block,
    STATE(10019), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [309385] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14249), 1,
      sym__indent,
    STATE(2335), 1,
      sym__expression_block,
    STATE(10020), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [309419] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13308), 1,
      sym_identifier,
    STATE(10284), 1,
      sym_long_identifier,
    STATE(10021), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [309453] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14821), 1,
      sym__newline,
    ACTIONS(14823), 1,
      sym__indent,
    STATE(10022), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [309487] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14213), 1,
      sym__indent,
    STATE(3846), 1,
      sym__expression_block,
    STATE(10023), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [309521] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14337), 1,
      sym__indent,
    STATE(7075), 1,
      sym__expression_block,
    STATE(10024), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [309555] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14825), 1,
      anon_sym__,
    STATE(10025), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [309589] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13308), 1,
      sym_identifier,
    STATE(10276), 1,
      sym_long_identifier,
    STATE(10026), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [309623] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14515), 1,
      sym__indent,
    STATE(1991), 1,
      sym__expression_block,
    STATE(10027), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [309657] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14397), 1,
      anon_sym_new,
    ACTIONS(14433), 1,
      anon_sym_LPAREN,
    STATE(10028), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [309691] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14495), 1,
      sym__indent,
    STATE(3156), 1,
      sym__expression_block,
    STATE(10029), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [309725] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13308), 1,
      sym_identifier,
    STATE(10219), 1,
      sym_long_identifier,
    STATE(10030), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [309759] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14827), 1,
      anon_sym_EQ,
    ACTIONS(14829), 1,
      anon_sym_COLON,
    STATE(10031), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [309793] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14597), 1,
      sym__indent,
    STATE(2607), 1,
      sym__expression_block,
    STATE(10032), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [309827] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14831), 1,
      anon_sym_EQ,
    ACTIONS(14833), 1,
      anon_sym_COLON,
    STATE(10033), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [309861] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14335), 1,
      sym__indent,
    STATE(2024), 1,
      sym__expression_block,
    STATE(10034), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [309895] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14835), 1,
      anon_sym__,
    STATE(10035), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [309929] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14379), 1,
      sym__indent,
    STATE(6520), 1,
      sym__expression_block,
    STATE(10036), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [309963] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14837), 1,
      anon_sym_with,
    ACTIONS(14839), 1,
      anon_sym_finally,
    STATE(10037), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [309997] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14649), 1,
      sym_identifier,
    STATE(6590), 1,
      sym_member_signature,
    STATE(10038), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [310031] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14841), 1,
      anon_sym__,
    STATE(10039), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [310065] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14843), 1,
      anon_sym_get,
    ACTIONS(14845), 1,
      anon_sym_set,
    STATE(10040), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [310099] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14417), 1,
      anon_sym_COLON,
    ACTIONS(14847), 1,
      anon_sym_COLON_GT,
    STATE(10041), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [310133] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14223), 1,
      sym__indent,
    STATE(861), 1,
      sym__expression_block,
    STATE(10042), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [310167] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14849), 1,
      anon_sym__,
    STATE(10043), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [310201] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14851), 1,
      anon_sym_get,
    ACTIONS(14853), 1,
      anon_sym_set,
    STATE(10044), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [310235] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14855), 1,
      anon_sym_COLON,
    ACTIONS(14857), 1,
      anon_sym_COLON_GT,
    STATE(10045), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [310269] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14515), 1,
      sym__indent,
    STATE(2005), 1,
      sym__expression_block,
    STATE(10046), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [310303] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14515), 1,
      sym__indent,
    STATE(2006), 1,
      sym__expression_block,
    STATE(10047), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [310337] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14515), 1,
      sym__indent,
    STATE(1833), 1,
      sym__expression_block,
    STATE(10048), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [310371] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14249), 1,
      sym__indent,
    STATE(2332), 1,
      sym__expression_block,
    STATE(10049), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [310405] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14859), 1,
      sym_identifier,
    STATE(557), 1,
      sym_long_identifier,
    STATE(10050), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [310439] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14253), 1,
      sym__indent,
    STATE(6310), 1,
      sym__expression_block,
    STATE(10051), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [310473] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14861), 1,
      sym_identifier,
    STATE(6907), 1,
      sym_member_signature,
    STATE(10052), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [310507] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14149), 1,
      sym__indent,
    STATE(8958), 1,
      sym__expression_block,
    STATE(10053), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [310541] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14243), 1,
      sym__indent,
    STATE(6706), 1,
      sym__expression_block,
    STATE(10054), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [310575] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14863), 1,
      sym__indent,
    STATE(2507), 1,
      sym__expression_block,
    STATE(10055), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [310609] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14865), 1,
      anon_sym_EQ,
    ACTIONS(14867), 1,
      anon_sym_COLON,
    STATE(10056), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [310643] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14235), 1,
      sym__indent,
    STATE(6763), 1,
      sym__expression_block,
    STATE(10057), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [310677] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14869), 1,
      anon_sym__,
    STATE(10058), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [310711] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14245), 1,
      sym__indent,
    STATE(3150), 1,
      sym__expression_block,
    STATE(10059), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [310745] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14871), 1,
      anon_sym__,
    STATE(10060), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [310779] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14873), 1,
      anon_sym_get,
    ACTIONS(14875), 1,
      anon_sym_set,
    STATE(10061), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [310813] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14511), 1,
      sym__indent,
    STATE(10173), 1,
      sym__expression_block,
    STATE(10062), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [310847] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14245), 1,
      sym__indent,
    STATE(3320), 1,
      sym__expression_block,
    STATE(10063), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [310881] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14495), 1,
      sym__indent,
    STATE(2852), 1,
      sym__expression_block,
    STATE(10064), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [310915] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14495), 1,
      sym__indent,
    STATE(3104), 1,
      sym__expression_block,
    STATE(10065), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [310949] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14877), 1,
      anon_sym_EQ,
    ACTIONS(14879), 1,
      anon_sym_COLON,
    STATE(10066), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [310983] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14245), 1,
      sym__indent,
    STATE(3319), 1,
      sym__expression_block,
    STATE(10067), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [311017] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14223), 1,
      sym__indent,
    STATE(877), 1,
      sym__expression_block,
    STATE(10068), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [311051] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14179), 1,
      sym__indent,
    STATE(10475), 1,
      sym__expression_block,
    STATE(10069), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [311085] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14495), 1,
      sym__indent,
    STATE(3099), 1,
      sym__expression_block,
    STATE(10070), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [311119] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14265), 1,
      sym__indent,
    STATE(6588), 1,
      sym__expression_block,
    STATE(10071), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [311153] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14881), 1,
      anon_sym__,
    STATE(10072), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [311187] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14883), 1,
      anon_sym_get,
    ACTIONS(14885), 1,
      anon_sym_set,
    STATE(10073), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [311221] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14223), 1,
      sym__indent,
    STATE(1175), 1,
      sym__expression_block,
    STATE(10074), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [311255] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14887), 1,
      anon_sym_get,
    ACTIONS(14889), 1,
      anon_sym_set,
    STATE(10075), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [311289] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14265), 1,
      sym__indent,
    STATE(6587), 1,
      sym__expression_block,
    STATE(10076), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [311323] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14555), 1,
      sym__indent,
    STATE(1776), 1,
      sym__expression_block,
    STATE(10077), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [311357] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14249), 1,
      sym__indent,
    STATE(2368), 1,
      sym__expression_block,
    STATE(10078), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [311391] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14495), 1,
      sym__indent,
    STATE(2916), 1,
      sym__expression_block,
    STATE(10079), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [311425] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14379), 1,
      sym__indent,
    STATE(6510), 1,
      sym__expression_block,
    STATE(10080), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [311459] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14891), 1,
      anon_sym_get,
    ACTIONS(14893), 1,
      anon_sym_set,
    STATE(10081), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [311493] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14173), 1,
      sym__indent,
    STATE(6813), 1,
      sym__expression_block,
    STATE(10082), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [311527] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14895), 1,
      anon_sym__,
    STATE(10083), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [311561] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14179), 1,
      sym__indent,
    STATE(10255), 1,
      sym__expression_block,
    STATE(10084), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [311595] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14777), 1,
      anon_sym_DQUOTE,
    STATE(11870), 1,
      sym__string_literal,
    STATE(10085), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [311629] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14173), 1,
      sym__indent,
    STATE(6852), 1,
      sym__expression_block,
    STATE(10086), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [311663] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(11880), 1,
      sym__expression_block,
    STATE(10087), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [311697] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14249), 1,
      sym__indent,
    STATE(2362), 1,
      sym__expression_block,
    STATE(10088), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [311731] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14863), 1,
      sym__indent,
    STATE(2719), 1,
      sym__expression_block,
    STATE(10089), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [311765] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14897), 1,
      anon_sym__,
    STATE(10090), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [311799] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6300), 2,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(10091), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [311831] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14899), 1,
      sym__newline,
    ACTIONS(14901), 1,
      sym__indent,
    STATE(10092), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [311865] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6316), 2,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(10093), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [311897] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3698), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(10094), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [311929] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14903), 1,
      sym__indent,
    STATE(3018), 1,
      sym__expression_block,
    STATE(10095), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [311963] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14173), 1,
      sym__indent,
    STATE(6787), 1,
      sym__expression_block,
    STATE(10096), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [311997] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4062), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(10097), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [312029] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14905), 1,
      anon_sym__,
    STATE(10098), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [312063] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14907), 1,
      anon_sym_EQ,
    ACTIONS(14909), 1,
      anon_sym_COLON,
    STATE(10099), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [312097] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4168), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(10100), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [312129] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4076), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(10101), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [312161] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14649), 1,
      sym_identifier,
    STATE(6563), 1,
      sym_member_signature,
    STATE(10102), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [312195] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3974), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(10103), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [312227] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14515), 1,
      sym__indent,
    STATE(2041), 1,
      sym__expression_block,
    STATE(10104), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [312261] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14861), 1,
      sym_identifier,
    STATE(6803), 1,
      sym_member_signature,
    STATE(10105), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [312295] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14379), 1,
      sym__indent,
    STATE(6509), 1,
      sym__expression_block,
    STATE(10106), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [312329] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4102), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(10107), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [312361] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(11858), 1,
      sym__expression_block,
    STATE(10108), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [312395] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14173), 1,
      sym__indent,
    STATE(6817), 1,
      sym__expression_block,
    STATE(10109), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [312429] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14555), 1,
      sym__indent,
    STATE(1643), 1,
      sym__expression_block,
    STATE(10110), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [312463] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14495), 1,
      sym__indent,
    STATE(2888), 1,
      sym__expression_block,
    STATE(10111), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [312497] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4128), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(10112), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [312529] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3883), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(10113), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [312561] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3933), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(10114), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [312593] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3948), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(10115), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [312625] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14911), 1,
      anon_sym__,
    STATE(10116), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [312659] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14913), 1,
      anon_sym_with,
    ACTIONS(14915), 1,
      anon_sym_finally,
    STATE(10117), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [312693] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14917), 1,
      sym__newline,
    ACTIONS(14919), 1,
      sym__indent,
    STATE(10118), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [312727] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3952), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(10119), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [312759] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3956), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(10120), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [312791] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14921), 1,
      anon_sym__,
    STATE(10121), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [312825] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3960), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(10122), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [312857] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14245), 1,
      sym__indent,
    STATE(3013), 1,
      sym__expression_block,
    STATE(10123), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [312891] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4230), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(10124), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [312923] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4124), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(10125), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [312955] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4120), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(10126), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [312987] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4116), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(10127), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [313019] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4110), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(10128), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [313051] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14511), 1,
      sym__indent,
    STATE(10180), 1,
      sym__expression_block,
    STATE(10129), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [313085] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14725), 1,
      sym__indent,
    STATE(1558), 1,
      sym__expression_block,
    STATE(10130), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [313119] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14923), 1,
      sym__newline,
    ACTIONS(14925), 1,
      sym__indent,
    STATE(10131), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [313153] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14927), 1,
      anon_sym_with,
    ACTIONS(14929), 1,
      anon_sym_finally,
    STATE(10132), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [313187] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4106), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(10133), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [313219] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4091), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(10134), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [313251] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4084), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(10135), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [313283] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4080), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(10136), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [313315] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14931), 1,
      sym__newline,
    ACTIONS(14933), 1,
      sym__indent,
    STATE(10137), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [313349] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14377), 1,
      sym__indent,
    STATE(1808), 1,
      sym__expression_block,
    STATE(10138), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [313383] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4052), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(10139), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [313415] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14935), 1,
      anon_sym__,
    STATE(10140), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [313449] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(11778), 1,
      sym__expression_block,
    STATE(10141), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [313483] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4016), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(10142), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [313515] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3843), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(10143), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [313547] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4001), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(10144), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [313579] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3994), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(10145), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [313611] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3970), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(10146), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [313643] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14213), 1,
      sym__indent,
    STATE(3833), 1,
      sym__expression_block,
    STATE(10147), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [313677] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14223), 1,
      sym__indent,
    STATE(910), 1,
      sym__expression_block,
    STATE(10148), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [313711] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14861), 1,
      sym_identifier,
    STATE(6866), 1,
      sym_member_signature,
    STATE(10149), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [313745] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3944), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(10150), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [313777] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14937), 1,
      anon_sym_EQ,
    ACTIONS(14939), 1,
      anon_sym_COLON,
    STATE(10151), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [313811] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13333), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(10152), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [313843] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14941), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(10153), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [313875] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14417), 1,
      anon_sym_COLON,
    ACTIONS(14943), 1,
      anon_sym_COLON_GT,
    STATE(10154), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [313909] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3925), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(10155), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [313941] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3191), 2,
      sym__dedent,
      anon_sym_PIPE,
    STATE(10156), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [313973] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14213), 1,
      sym__indent,
    STATE(3820), 1,
      sym__expression_block,
    STATE(10157), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [314007] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6286), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(10158), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [314039] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14945), 1,
      anon_sym__,
    STATE(10159), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [314073] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14245), 1,
      sym__indent,
    STATE(3295), 1,
      sym__expression_block,
    STATE(10160), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [314107] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14173), 1,
      sym__indent,
    STATE(6894), 1,
      sym__expression_block,
    STATE(10161), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [314141] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14173), 1,
      sym__indent,
    STATE(6895), 1,
      sym__expression_block,
    STATE(10162), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [314175] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6456), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(10163), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [314207] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14417), 1,
      anon_sym_COLON,
    ACTIONS(14947), 1,
      anon_sym_COLON_GT,
    STATE(10164), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [314241] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14495), 1,
      sym__indent,
    STATE(3040), 1,
      sym__expression_block,
    STATE(10165), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [314275] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14633), 1,
      sym__indent,
    STATE(2917), 1,
      sym__expression_block,
    STATE(10166), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [314309] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14949), 1,
      anon_sym__,
    STATE(10167), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [314343] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14555), 1,
      sym__indent,
    STATE(1635), 1,
      sym__expression_block,
    STATE(10168), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [314377] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14903), 1,
      sym__indent,
    STATE(3060), 1,
      sym__expression_block,
    STATE(10169), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [314411] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14495), 1,
      sym__indent,
    STATE(3063), 1,
      sym__expression_block,
    STATE(10170), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [314445] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14335), 1,
      sym__indent,
    STATE(1622), 1,
      sym__expression_block,
    STATE(10171), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [314479] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14743), 1,
      sym__indent,
    STATE(7409), 1,
      sym__expression_block,
    STATE(10172), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [314513] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6316), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(10173), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [314545] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14951), 1,
      anon_sym_EQ,
    ACTIONS(14953), 1,
      anon_sym_COLON,
    STATE(10174), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [314579] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14555), 1,
      sym__indent,
    STATE(1797), 1,
      sym__expression_block,
    STATE(10175), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [314613] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14777), 1,
      anon_sym_DQUOTE,
    STATE(11772), 1,
      sym__string_literal,
    STATE(10176), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [314647] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6426), 2,
      anon_sym_and,
      anon_sym_POUNDendif,
    STATE(10177), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [314679] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14151), 1,
      sym__indent,
    STATE(11797), 1,
      sym__expression_block,
    STATE(10178), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [314713] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14955), 1,
      sym__newline,
    ACTIONS(14957), 1,
      sym__indent,
    STATE(10179), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [314747] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6300), 2,
      anon_sym_POUNDendif,
      anon_sym_POUNDelse,
    STATE(10180), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [314779] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14959), 1,
      anon_sym__,
    STATE(10181), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [314813] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14245), 1,
      sym__indent,
    STATE(3281), 1,
      sym__expression_block,
    STATE(10182), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [314847] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14159), 1,
      sym_identifier,
    ACTIONS(14961), 1,
      anon_sym__,
    STATE(10183), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [314881] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14963), 1,
      anon_sym_EQ,
    ACTIONS(14965), 1,
      anon_sym_COLON,
    STATE(10184), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [314915] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14967), 1,
      anon_sym_RPAREN,
    STATE(10185), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [314946] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14969), 1,
      sym__dedent,
    STATE(10186), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [314977] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9809), 1,
      sym__dedent,
    STATE(10187), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315008] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14971), 1,
      anon_sym_RBRACE,
    STATE(10188), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315039] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14973), 1,
      anon_sym_GT,
    STATE(10189), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315070] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14975), 1,
      anon_sym_then,
    STATE(10190), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315101] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14977), 1,
      sym__triple_quoted_content,
    STATE(10191), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315132] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14979), 1,
      sym__triple_quoted_content,
    STATE(10192), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315163] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14981), 1,
      sym_identifier,
    STATE(10193), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315194] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14983), 1,
      anon_sym_then,
    STATE(10194), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315225] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14985), 1,
      anon_sym_COLON,
    STATE(10195), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315256] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14987), 1,
      anon_sym_COLON,
    STATE(10196), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315287] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14989), 1,
      anon_sym_RBRACE,
    STATE(10197), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315318] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14991), 1,
      anon_sym_COLON,
    STATE(10198), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315349] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14993), 1,
      anon_sym_then,
    STATE(10199), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315380] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9723), 1,
      sym__dedent,
    STATE(10200), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315411] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14995), 1,
      anon_sym_DASH_GT,
    STATE(10201), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315442] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14997), 1,
      sym_identifier,
    STATE(10202), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315473] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14999), 1,
      anon_sym_COLON,
    STATE(10203), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315504] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15001), 1,
      anon_sym_EQ,
    STATE(10204), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315535] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15003), 1,
      anon_sym_of,
    STATE(10205), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315566] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15005), 1,
      sym__newline_not_aligned,
    STATE(10206), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315597] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15007), 1,
      sym_identifier,
    STATE(10207), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315628] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15009), 1,
      anon_sym_do,
    STATE(10208), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315659] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15011), 1,
      sym__dedent,
    STATE(10209), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315690] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15013), 1,
      sym__newline_not_aligned,
    STATE(10210), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315721] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15015), 1,
      anon_sym_and,
    STATE(10211), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315752] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15017), 1,
      anon_sym_PIPE,
    STATE(10212), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315783] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15019), 1,
      sym__dedent,
    STATE(10213), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315814] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15021), 1,
      sym__dedent,
    STATE(10214), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315845] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15023), 1,
      anon_sym_do,
    STATE(10215), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315876] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15025), 1,
      sym__newline_not_aligned,
    STATE(10216), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315907] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15027), 1,
      anon_sym_COLON,
    STATE(10217), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315938] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15029), 1,
      sym__dedent,
    STATE(10218), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [315969] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15031), 1,
      anon_sym_of,
    STATE(10219), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316000] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15033), 1,
      anon_sym_of,
    STATE(10220), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316031] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15035), 1,
      anon_sym_COLON,
    STATE(10221), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316062] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15037), 1,
      sym__dedent,
    STATE(10222), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316093] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15039), 1,
      sym__dedent,
    STATE(10223), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316124] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15041), 1,
      sym__dedent,
    STATE(10224), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316155] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15043), 1,
      anon_sym_and,
    STATE(10225), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316186] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15045), 1,
      sym__newline_not_aligned,
    STATE(10226), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316217] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15047), 1,
      sym__newline_not_aligned,
    STATE(10227), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316248] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15049), 1,
      anon_sym_of,
    STATE(10228), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316279] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15051), 1,
      anon_sym_COLON,
    STATE(10229), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316310] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15053), 1,
      sym__newline_not_aligned,
    STATE(10230), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316341] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15055), 1,
      anon_sym_EQ,
    STATE(10231), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316372] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15057), 1,
      anon_sym_DASH_GT,
    STATE(10232), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316403] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15059), 1,
      sym__dedent,
    STATE(10233), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316434] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15061), 1,
      anon_sym_do,
    STATE(10234), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316465] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15063), 1,
      anon_sym_then,
    STATE(10235), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316496] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15065), 1,
      sym_identifier,
    STATE(10236), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316527] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15067), 1,
      anon_sym_PIPE,
    STATE(10237), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316558] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15069), 1,
      sym__triple_quoted_content,
    STATE(10238), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316589] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15071), 1,
      sym__dedent,
    STATE(10239), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316620] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15073), 1,
      sym__triple_quoted_content,
    STATE(10240), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316651] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15075), 1,
      sym__indent,
    STATE(10241), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316682] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8558), 1,
      sym__dedent,
    STATE(10242), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316713] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15077), 1,
      anon_sym_RBRACE,
    STATE(10243), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316744] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15079), 1,
      anon_sym_COLON,
    STATE(10244), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316775] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15081), 1,
      anon_sym_COLON,
    STATE(10245), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316806] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15083), 1,
      anon_sym_RBRACE,
    STATE(10246), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316837] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9780), 1,
      sym__dedent,
    STATE(10247), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316868] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15085), 1,
      anon_sym_COLON,
    STATE(10248), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316899] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6578), 1,
      anon_sym_EQ,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(10249), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316930] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15087), 1,
      anon_sym_COLON,
    STATE(10250), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316961] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15089), 1,
      anon_sym_COLON,
    STATE(10251), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [316992] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15091), 1,
      anon_sym_then,
    STATE(10252), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317023] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9795), 1,
      sym__dedent,
    STATE(10253), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317054] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9782), 1,
      sym__dedent,
    STATE(10254), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317085] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15093), 1,
      anon_sym_then,
    STATE(10255), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317116] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9778), 1,
      sym__dedent,
    STATE(10256), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317147] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15095), 1,
      anon_sym_EQ,
    STATE(10257), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317178] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13533), 1,
      anon_sym_EQ,
    STATE(10258), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317209] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15097), 1,
      anon_sym_RBRACE,
    STATE(10259), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317240] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15099), 1,
      anon_sym_COLON,
    STATE(10260), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317271] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15101), 1,
      anon_sym_COLON,
    STATE(10261), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317302] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15103), 1,
      sym__dedent,
    STATE(10262), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317333] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15105), 1,
      anon_sym_PIPE,
    STATE(10263), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317364] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15107), 1,
      sym__indent,
    STATE(10264), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317395] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15109), 1,
      anon_sym_POUNDendif,
    STATE(10265), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317426] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15111), 1,
      anon_sym_COLON,
    STATE(10266), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317457] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15113), 1,
      sym__dedent,
    STATE(10267), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317488] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15115), 1,
      sym__newline_not_aligned,
    STATE(10268), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317519] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15117), 1,
      anon_sym_COLON,
    STATE(10269), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317550] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15119), 1,
      anon_sym_COLON,
    STATE(10270), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317581] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15121), 1,
      sym__dedent,
    STATE(10271), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317612] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9813), 1,
      sym__dedent,
    STATE(10272), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317643] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15123), 1,
      anon_sym_COLON,
    STATE(10273), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317674] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15125), 1,
      sym_identifier,
    STATE(10274), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317705] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15127), 1,
      anon_sym_RBRACE,
    STATE(10275), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317736] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15129), 1,
      anon_sym_of,
    STATE(10276), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317767] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15131), 1,
      anon_sym_COLON,
    STATE(10277), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317798] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15133), 1,
      sym__dedent,
    STATE(10278), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317829] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15135), 1,
      anon_sym_RBRACE,
    STATE(10279), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317860] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15137), 1,
      sym__dedent,
    STATE(10280), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317891] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15139), 1,
      anon_sym_and,
    STATE(10281), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317922] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15141), 1,
      sym__newline_not_aligned,
    STATE(10282), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317953] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15143), 1,
      sym__newline_not_aligned,
    STATE(10283), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [317984] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15145), 1,
      anon_sym_of,
    STATE(10284), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318015] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15147), 1,
      anon_sym_POUNDendif,
    STATE(10285), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318046] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15149), 1,
      anon_sym_EQ,
    STATE(10286), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318077] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15151), 1,
      sym__triple_quoted_content,
    STATE(10287), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318108] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15153), 1,
      sym__triple_quoted_content,
    STATE(10288), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318139] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15155), 1,
      sym_identifier,
    STATE(10289), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318170] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15157), 1,
      anon_sym_then,
    STATE(10290), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318201] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15159), 1,
      anon_sym_DASH_GT,
    STATE(10291), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318232] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15161), 1,
      sym_identifier,
    STATE(10292), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318263] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15163), 1,
      anon_sym_PIPE_RPAREN,
    STATE(10293), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318294] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15165), 1,
      sym_identifier,
    STATE(10294), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318325] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15167), 1,
      anon_sym_then,
    STATE(10295), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318356] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15169), 1,
      sym_identifier,
    STATE(10296), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318387] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15171), 1,
      anon_sym_DASH_GT,
    STATE(10297), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318418] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15173), 1,
      sym__triple_quoted_content,
    STATE(10298), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318449] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15175), 1,
      sym__triple_quoted_content,
    STATE(10299), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318480] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15177), 1,
      anon_sym_EQ,
    STATE(10300), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318511] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15179), 1,
      anon_sym_DASH_GT,
    STATE(10301), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318542] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15181), 1,
      sym_identifier,
    STATE(10302), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318573] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15183), 1,
      sym_identifier,
    STATE(10303), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318604] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15185), 1,
      sym__newline_not_aligned,
    STATE(10304), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318635] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15187), 1,
      sym_identifier,
    STATE(10305), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318666] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15189), 1,
      sym__dedent,
    STATE(10306), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318697] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15191), 1,
      sym__dedent,
    STATE(10307), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318728] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15193), 1,
      sym_identifier,
    STATE(10308), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318759] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15195), 1,
      sym_identifier,
    STATE(10309), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318790] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15197), 1,
      sym_identifier,
    STATE(10310), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318821] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15199), 1,
      sym_identifier,
    STATE(10311), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318852] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15201), 1,
      sym_identifier,
    STATE(10312), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318883] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15203), 1,
      sym__dedent,
    STATE(10313), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318914] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15205), 1,
      sym__dedent,
    STATE(10314), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318945] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15207), 1,
      sym_identifier,
    STATE(10315), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [318976] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15209), 1,
      sym_identifier,
    STATE(10316), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319007] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15211), 1,
      anon_sym_POUNDendif,
    STATE(10317), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319038] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15213), 1,
      sym_identifier,
    STATE(10318), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319069] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15215), 1,
      anon_sym_COLON,
    STATE(10319), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319100] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15217), 1,
      sym__newline_not_aligned,
    STATE(10320), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319131] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15219), 1,
      sym_identifier,
    STATE(10321), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319162] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15221), 1,
      sym_identifier,
    STATE(10322), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319193] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15223), 1,
      sym__indent,
    STATE(10323), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319224] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14701), 1,
      anon_sym_do,
    STATE(10324), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319255] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15225), 1,
      sym_identifier,
    STATE(10325), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319286] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15227), 1,
      sym_identifier,
    STATE(10326), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319317] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15229), 1,
      anon_sym_PIPE,
    STATE(10327), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319348] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15231), 1,
      sym_identifier,
    STATE(10328), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319379] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15233), 1,
      sym__dedent,
    STATE(10329), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319410] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15235), 1,
      sym_identifier,
    STATE(10330), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319441] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15237), 1,
      anon_sym_COLON,
    STATE(10331), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319472] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15239), 1,
      sym_identifier,
    STATE(10332), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319503] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15241), 1,
      sym_identifier,
    STATE(10333), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319534] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5343), 1,
      anon_sym_EQ2,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(10334), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319565] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12875), 1,
      anon_sym_GT,
    STATE(10335), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319596] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15243), 1,
      anon_sym_then,
    STATE(10336), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319627] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15245), 1,
      sym_identifier,
    STATE(10337), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319658] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15247), 1,
      anon_sym_end,
    STATE(10338), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319689] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15249), 1,
      sym_identifier,
    STATE(10339), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319720] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15251), 1,
      sym_identifier,
    STATE(10340), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319751] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15253), 1,
      anon_sym_COLON,
    STATE(10341), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319782] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15255), 1,
      sym_identifier,
    STATE(10342), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319813] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15257), 1,
      sym_identifier,
    STATE(10343), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319844] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15259), 1,
      anon_sym_COLON,
    STATE(10344), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319875] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15261), 1,
      anon_sym_COLON,
    STATE(10345), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319906] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15263), 1,
      sym_identifier,
    STATE(10346), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319937] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15265), 1,
      sym_identifier,
    STATE(10347), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319968] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15267), 1,
      sym_identifier,
    STATE(10348), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [319999] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15269), 1,
      anon_sym_COLON,
    STATE(10349), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320030] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15271), 1,
      sym_identifier,
    STATE(10350), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320061] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15273), 1,
      sym_identifier,
    STATE(10351), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320092] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15275), 1,
      sym_identifier,
    STATE(10352), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320123] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15277), 1,
      sym_identifier,
    STATE(10353), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320154] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15279), 1,
      sym_identifier,
    STATE(10354), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320185] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15281), 1,
      anon_sym_GT,
    STATE(10355), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320216] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12911), 1,
      anon_sym_GT,
    STATE(10356), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320247] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15283), 1,
      sym__triple_quoted_content,
    STATE(10357), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320278] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15285), 1,
      sym__triple_quoted_content,
    STATE(10358), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320309] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15287), 1,
      sym_identifier,
    STATE(10359), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320340] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15289), 1,
      anon_sym_then,
    STATE(10360), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320371] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15291), 1,
      sym_identifier,
    STATE(10361), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320402] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15293), 1,
      sym_identifier,
    STATE(10362), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320433] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15295), 1,
      anon_sym_GT,
    STATE(10363), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320464] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12905), 1,
      anon_sym_GT,
    STATE(10364), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320495] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15297), 1,
      sym_identifier,
    STATE(10365), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320526] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15299), 1,
      sym_identifier,
    STATE(10366), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320557] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15301), 1,
      anon_sym_DASH_GT,
    STATE(10367), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320588] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15303), 1,
      anon_sym_GT,
    STATE(10368), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320619] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15305), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10369), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320650] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15307), 1,
      anon_sym_EQ,
    STATE(10370), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320681] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15309), 1,
      sym_identifier,
    STATE(10371), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320712] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15311), 1,
      sym_identifier,
    STATE(10372), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320743] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15313), 1,
      anon_sym_GT,
    STATE(10373), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320774] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15315), 1,
      sym__newline_not_aligned,
    STATE(10374), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320805] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12721), 1,
      anon_sym_GT,
    STATE(10375), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320836] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15317), 1,
      sym__dedent,
    STATE(10376), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320867] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15319), 1,
      sym__dedent,
    STATE(10377), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320898] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15321), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10378), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320929] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15323), 1,
      anon_sym_GT,
    STATE(10379), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320960] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15325), 1,
      sym_identifier,
    STATE(10380), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [320991] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15327), 1,
      sym_identifier,
    STATE(10381), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321022] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15329), 1,
      anon_sym_GT,
    STATE(10382), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321053] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12731), 1,
      anon_sym_GT,
    STATE(10383), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321084] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15331), 1,
      sym__dedent,
    STATE(10384), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321115] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15333), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10385), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321146] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15335), 1,
      anon_sym_GT,
    STATE(10386), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321177] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15337), 1,
      sym_identifier,
    STATE(10387), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321208] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15339), 1,
      sym_identifier,
    STATE(10388), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321239] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15341), 1,
      anon_sym_COLON,
    STATE(10389), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321270] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15343), 1,
      sym__newline_not_aligned,
    STATE(10390), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321301] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15345), 1,
      anon_sym_GT,
    STATE(10391), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321332] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12737), 1,
      anon_sym_GT,
    STATE(10392), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321363] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15347), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10393), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321394] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15349), 1,
      anon_sym_do,
    STATE(10394), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321425] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15351), 1,
      anon_sym_GT,
    STATE(10395), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321456] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15353), 1,
      sym_identifier,
    STATE(10396), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321487] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15355), 1,
      anon_sym_PIPE,
    STATE(10397), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321518] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15357), 1,
      sym_identifier,
    STATE(10398), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321549] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15359), 1,
      sym__dedent,
    STATE(10399), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321580] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15361), 1,
      anon_sym_GT,
    STATE(10400), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321611] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15363), 1,
      anon_sym_COLON,
    STATE(10401), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321642] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12743), 1,
      anon_sym_GT,
    STATE(10402), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321673] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15365), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10403), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321704] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15367), 1,
      anon_sym_GT,
    STATE(10404), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321735] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15369), 1,
      anon_sym_GT,
    STATE(10405), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321766] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15371), 1,
      anon_sym_then,
    STATE(10406), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321797] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15373), 1,
      sym_identifier,
    STATE(10407), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321828] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15375), 1,
      sym_identifier,
    STATE(10408), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321859] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15377), 1,
      anon_sym_GT,
    STATE(10409), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321890] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12753), 1,
      anon_sym_GT,
    STATE(10410), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321921] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15379), 1,
      anon_sym_COLON,
    STATE(10411), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321952] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15381), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10412), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [321983] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15383), 1,
      anon_sym_GT,
    STATE(10413), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322014] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15385), 1,
      anon_sym_COLON,
    STATE(10414), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322045] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15387), 1,
      anon_sym_COLON,
    STATE(10415), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322076] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15389), 1,
      sym__dedent,
    STATE(10416), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322107] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15391), 1,
      sym_identifier,
    STATE(10417), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322138] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15393), 1,
      sym_identifier,
    STATE(10418), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322169] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15395), 1,
      anon_sym_COLON,
    STATE(10419), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322200] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15397), 1,
      anon_sym_GT,
    STATE(10420), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322231] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12775), 1,
      anon_sym_GT,
    STATE(10421), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322262] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15399), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10422), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322293] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15401), 1,
      anon_sym_GT,
    STATE(10423), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322324] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15403), 1,
      sym_identifier,
    STATE(10424), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322355] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15405), 1,
      sym_identifier,
    STATE(10425), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322386] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15407), 1,
      sym__triple_quoted_content,
    STATE(10426), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322417] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15409), 1,
      sym__triple_quoted_content,
    STATE(10427), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322448] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15411), 1,
      sym_identifier,
    STATE(10428), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322479] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15413), 1,
      anon_sym_then,
    STATE(10429), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322510] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15415), 1,
      anon_sym_GT,
    STATE(10430), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322541] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12793), 1,
      anon_sym_GT,
    STATE(10431), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322572] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15417), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10432), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322603] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15419), 1,
      anon_sym_GT,
    STATE(10433), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322634] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15421), 1,
      sym__dedent,
    STATE(10434), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322665] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15423), 1,
      sym_identifier,
    STATE(10435), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322696] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15425), 1,
      anon_sym_DASH_GT,
    STATE(10436), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322727] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15427), 1,
      sym_identifier,
    STATE(10437), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322758] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15429), 1,
      anon_sym_GT,
    STATE(10438), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322789] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15431), 1,
      anon_sym_EQ,
    STATE(10439), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322820] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12805), 1,
      anon_sym_GT,
    STATE(10440), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322851] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15433), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10441), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322882] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15435), 1,
      anon_sym_GT,
    STATE(10442), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322913] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15437), 1,
      sym__newline_not_aligned,
    STATE(10443), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322944] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15439), 1,
      sym_identifier,
    STATE(10444), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [322975] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15441), 1,
      sym__dedent,
    STATE(10445), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323006] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15443), 1,
      sym__dedent,
    STATE(10446), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323037] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15445), 1,
      sym_identifier,
    STATE(10447), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323068] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15447), 1,
      anon_sym_GT,
    STATE(10448), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323099] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12815), 1,
      anon_sym_GT,
    STATE(10449), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323130] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15449), 1,
      sym_identifier,
    STATE(10450), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323161] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15451), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10451), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323192] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15453), 1,
      sym__indent,
    STATE(10452), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323223] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15455), 1,
      sym__dedent,
    STATE(10453), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323254] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15457), 1,
      anon_sym_GT,
    STATE(10454), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323285] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(2126), 1,
      anon_sym_POUNDendif,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(10455), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323316] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15459), 1,
      sym_identifier,
    STATE(10456), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323347] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15461), 1,
      sym_identifier,
    STATE(10457), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323378] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15463), 1,
      anon_sym_COLON,
    STATE(10458), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323409] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15465), 1,
      sym__newline_not_aligned,
    STATE(10459), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323440] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15467), 1,
      anon_sym_GT,
    STATE(10460), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323471] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12819), 1,
      anon_sym_GT,
    STATE(10461), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323502] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15469), 1,
      anon_sym_GT,
    STATE(10462), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323533] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15471), 1,
      anon_sym_do,
    STATE(10463), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323564] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15473), 1,
      anon_sym_GT,
    STATE(10464), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323595] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15475), 1,
      sym_identifier,
    STATE(10465), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323626] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15477), 1,
      anon_sym_PIPE,
    STATE(10466), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323657] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15479), 1,
      sym_identifier,
    STATE(10467), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323688] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15481), 1,
      sym__dedent,
    STATE(10468), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323719] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15483), 1,
      anon_sym_GT,
    STATE(10469), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323750] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15485), 1,
      anon_sym_COLON,
    STATE(10470), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323781] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12823), 1,
      anon_sym_GT,
    STATE(10471), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323812] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15487), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10472), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323843] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15489), 1,
      anon_sym_GT,
    STATE(10473), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323874] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15491), 1,
      sym_identifier,
    STATE(10474), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323905] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15493), 1,
      anon_sym_then,
    STATE(10475), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323936] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15495), 1,
      sym_identifier,
    STATE(10476), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323967] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15497), 1,
      anon_sym_GT,
    STATE(10477), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [323998] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12847), 1,
      anon_sym_GT,
    STATE(10478), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324029] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15499), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10479), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324060] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15501), 1,
      anon_sym_COLON,
    STATE(10480), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324091] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15503), 1,
      anon_sym_GT,
    STATE(10481), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324122] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15505), 1,
      sym_identifier,
    STATE(10482), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324153] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15507), 1,
      anon_sym_COLON,
    STATE(10483), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324184] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15509), 1,
      anon_sym_COLON,
    STATE(10484), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324215] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15511), 1,
      sym_identifier,
    STATE(10485), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324246] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15513), 1,
      anon_sym_GT,
    STATE(10486), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324277] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12863), 1,
      anon_sym_GT,
    STATE(10487), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324308] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15515), 1,
      anon_sym_COLON,
    STATE(10488), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324339] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15517), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10489), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324370] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15519), 1,
      anon_sym_GT,
    STATE(10490), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324401] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15521), 1,
      sym_identifier,
    STATE(10491), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324432] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15523), 1,
      sym_identifier,
    STATE(10492), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324463] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15525), 1,
      anon_sym_GT,
    STATE(10493), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324494] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12877), 1,
      anon_sym_GT,
    STATE(10494), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324525] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15527), 1,
      sym__triple_quoted_content,
    STATE(10495), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324556] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15529), 1,
      sym__triple_quoted_content,
    STATE(10496), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324587] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15531), 1,
      sym_identifier,
    STATE(10497), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324618] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15533), 1,
      anon_sym_then,
    STATE(10498), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324649] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15535), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10499), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324680] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15537), 1,
      anon_sym_COLON,
    STATE(10500), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324711] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15539), 1,
      anon_sym_GT,
    STATE(10501), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324742] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15541), 1,
      sym_identifier,
    STATE(10502), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324773] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15543), 1,
      sym_identifier,
    STATE(10503), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324804] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15545), 1,
      anon_sym_GT,
    STATE(10504), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324835] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15547), 1,
      anon_sym_DASH_GT,
    STATE(10505), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324866] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12715), 1,
      anon_sym_GT,
    STATE(10506), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324897] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15549), 1,
      sym__indent,
    STATE(10507), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324928] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15551), 1,
      anon_sym_EQ,
    STATE(10508), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324959] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15553), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10509), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [324990] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15555), 1,
      anon_sym_GT,
    STATE(10510), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325021] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15557), 1,
      sym_identifier,
    STATE(10511), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325052] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15559), 1,
      sym__newline_not_aligned,
    STATE(10512), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325083] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15561), 1,
      sym_identifier,
    STATE(10513), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325114] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15563), 1,
      sym__dedent,
    STATE(10514), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325145] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15565), 1,
      sym__dedent,
    STATE(10515), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325176] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15567), 1,
      anon_sym_GT,
    STATE(10516), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325207] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12899), 1,
      anon_sym_GT,
    STATE(10517), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325238] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15569), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10518), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325269] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15571), 1,
      sym_identifier,
    STATE(10519), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325300] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15573), 1,
      anon_sym_GT,
    STATE(10520), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325331] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15575), 1,
      anon_sym_COLON,
    STATE(10521), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325362] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15577), 1,
      sym__dedent,
    STATE(10522), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325393] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15579), 1,
      sym_identifier,
    STATE(10523), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325424] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15581), 1,
      sym_identifier,
    STATE(10524), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325455] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15583), 1,
      anon_sym_GT,
    STATE(10525), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325486] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12907), 1,
      anon_sym_GT,
    STATE(10526), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325517] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15585), 1,
      anon_sym_COLON,
    STATE(10527), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325548] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15587), 1,
      sym__newline_not_aligned,
    STATE(10528), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325579] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15589), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10529), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325610] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15591), 1,
      anon_sym_GT,
    STATE(10530), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325641] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15593), 1,
      anon_sym_COLON,
    STATE(10531), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325672] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15595), 1,
      anon_sym_do,
    STATE(10532), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325703] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15597), 1,
      sym_identifier,
    STATE(10533), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325734] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15599), 1,
      sym_identifier,
    STATE(10534), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325765] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15601), 1,
      anon_sym_PIPE,
    STATE(10535), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325796] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15603), 1,
      anon_sym_GT,
    STATE(10536), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325827] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15605), 1,
      sym__dedent,
    STATE(10537), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325858] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12923), 1,
      anon_sym_GT,
    STATE(10538), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325889] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15607), 1,
      anon_sym_COLON,
    STATE(10539), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325920] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15609), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10540), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325951] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15611), 1,
      anon_sym_GT,
    STATE(10541), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [325982] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15613), 1,
      sym_identifier,
    STATE(10542), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326013] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15615), 1,
      sym__indent,
    STATE(10543), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326044] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15617), 1,
      anon_sym_then,
    STATE(10544), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326075] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15619), 1,
      sym_identifier,
    STATE(10545), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326106] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15621), 1,
      anon_sym_GT,
    STATE(10546), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326137] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12931), 1,
      anon_sym_GT,
    STATE(10547), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326168] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15623), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10548), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326199] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15625), 1,
      anon_sym_COLON,
    STATE(10549), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326230] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15627), 1,
      anon_sym_GT,
    STATE(10550), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326261] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15629), 1,
      sym_identifier,
    STATE(10551), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326292] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15631), 1,
      anon_sym_COLON,
    STATE(10552), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326323] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15633), 1,
      anon_sym_COLON,
    STATE(10553), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326354] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15635), 1,
      anon_sym_COLON,
    STATE(10554), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326385] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15637), 1,
      sym_identifier,
    STATE(10555), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326416] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15639), 1,
      sym_identifier,
    STATE(10556), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326447] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15641), 1,
      anon_sym_COLON,
    STATE(10557), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326478] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15643), 1,
      anon_sym_GT,
    STATE(10558), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326509] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12939), 1,
      anon_sym_GT,
    STATE(10559), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326540] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15645), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10560), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326571] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15647), 1,
      anon_sym_GT,
    STATE(10561), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326602] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15649), 1,
      sym_identifier,
    STATE(10562), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326633] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15651), 1,
      sym_identifier,
    STATE(10563), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326664] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15653), 1,
      sym__triple_quoted_content,
    STATE(10564), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326695] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15655), 1,
      sym__triple_quoted_content,
    STATE(10565), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326726] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15657), 1,
      sym_identifier,
    STATE(10566), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326757] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15659), 1,
      anon_sym_then,
    STATE(10567), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326788] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15661), 1,
      anon_sym_GT,
    STATE(10568), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326819] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12957), 1,
      anon_sym_GT,
    STATE(10569), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326850] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15663), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10570), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326881] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15665), 1,
      anon_sym_GT,
    STATE(10571), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326912] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13937), 1,
      anon_sym_EQ,
    STATE(10572), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326943] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15667), 1,
      anon_sym_DASH_GT,
    STATE(10573), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [326974] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15669), 1,
      sym_identifier,
    STATE(10574), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327005] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15671), 1,
      sym_identifier,
    STATE(10575), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327036] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15673), 1,
      anon_sym_EQ,
    STATE(10576), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327067] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15675), 1,
      anon_sym_GT,
    STATE(10577), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327098] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12967), 1,
      anon_sym_GT,
    STATE(10578), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327129] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15677), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10579), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327160] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15679), 1,
      sym__newline_not_aligned,
    STATE(10580), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327191] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15681), 1,
      sym__dedent,
    STATE(10581), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327222] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15683), 1,
      sym__dedent,
    STATE(10582), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327253] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15685), 1,
      anon_sym_GT,
    STATE(10583), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327284] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15687), 1,
      sym_identifier,
    STATE(10584), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327315] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15689), 1,
      sym_identifier,
    STATE(10585), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327346] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15691), 1,
      anon_sym_GT,
    STATE(10586), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327377] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12975), 1,
      anon_sym_GT,
    STATE(10587), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327408] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15693), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10588), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327439] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15695), 1,
      sym__dedent,
    STATE(10589), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327470] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15697), 1,
      anon_sym_GT,
    STATE(10590), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327501] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15699), 1,
      sym_identifier,
    STATE(10591), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327532] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15701), 1,
      sym_identifier,
    STATE(10592), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327563] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15703), 1,
      anon_sym_COLON,
    STATE(10593), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327594] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15705), 1,
      anon_sym_GT,
    STATE(10594), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327625] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12983), 1,
      anon_sym_GT,
    STATE(10595), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327656] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15707), 1,
      anon_sym_do,
    STATE(10596), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327687] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15709), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10597), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327718] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15711), 1,
      anon_sym_GT,
    STATE(10598), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327749] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15713), 1,
      anon_sym_PIPE,
    STATE(10599), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327780] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15715), 1,
      sym_identifier,
    STATE(10600), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327811] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15717), 1,
      sym__dedent,
    STATE(10601), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327842] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15719), 1,
      sym_identifier,
    STATE(10602), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327873] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15721), 1,
      anon_sym_COLON,
    STATE(10603), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327904] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15723), 1,
      anon_sym_GT,
    STATE(10604), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327935] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12989), 1,
      anon_sym_GT,
    STATE(10605), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327966] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15725), 1,
      sym__dedent,
    STATE(10606), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [327997] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15727), 1,
      sym__dedent,
    STATE(10607), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328028] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15729), 1,
      anon_sym_then,
    STATE(10608), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328059] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15731), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10609), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328090] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15733), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(10610), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328121] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15735), 1,
      sym__dedent,
    STATE(10611), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328152] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15737), 1,
      sym_identifier,
    STATE(10612), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328183] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15739), 1,
      anon_sym_COLON,
    STATE(10613), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328214] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15741), 1,
      sym_identifier,
    STATE(10614), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328245] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15743), 1,
      sym__dedent,
    STATE(10615), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328276] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15745), 1,
      anon_sym_COLON,
    STATE(10616), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328307] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15747), 1,
      anon_sym_COLON,
    STATE(10617), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328338] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15749), 1,
      anon_sym_GT,
    STATE(10618), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328369] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13005), 1,
      anon_sym_GT,
    STATE(10619), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328400] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15751), 1,
      anon_sym_COLON,
    STATE(10620), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328431] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15753), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10621), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328462] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15755), 1,
      anon_sym_GT,
    STATE(10622), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328493] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15757), 1,
      sym_identifier,
    STATE(10623), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328524] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15759), 1,
      sym__triple_quoted_content,
    STATE(10624), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328555] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15761), 1,
      sym__triple_quoted_content,
    STATE(10625), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328586] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15763), 1,
      sym_identifier,
    STATE(10626), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328617] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15765), 1,
      anon_sym_then,
    STATE(10627), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328648] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15767), 1,
      sym_identifier,
    STATE(10628), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328679] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15769), 1,
      anon_sym_GT,
    STATE(10629), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328710] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13013), 1,
      anon_sym_GT,
    STATE(10630), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328741] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15771), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10631), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328772] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15773), 1,
      anon_sym_DASH_GT,
    STATE(10632), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328803] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15775), 1,
      anon_sym_GT,
    STATE(10633), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328834] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15777), 1,
      sym__indent,
    STATE(10634), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328865] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15779), 1,
      anon_sym_EQ,
    STATE(10635), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328896] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15781), 1,
      anon_sym_of,
    STATE(10636), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328927] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15783), 1,
      sym_identifier,
    STATE(10637), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328958] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15785), 1,
      sym_identifier,
    STATE(10638), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [328989] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15787), 1,
      sym__newline_not_aligned,
    STATE(10639), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329020] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15789), 1,
      sym__dedent,
    STATE(10640), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329051] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15791), 1,
      sym__dedent,
    STATE(10641), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329082] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15793), 1,
      anon_sym_GT,
    STATE(10642), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329113] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13027), 1,
      anon_sym_GT,
    STATE(10643), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329144] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15795), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10644), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329175] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15797), 1,
      sym__indent,
    STATE(10645), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329206] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15799), 1,
      sym_int,
    STATE(10646), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329237] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15801), 1,
      anon_sym_GT,
    STATE(10647), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329268] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15803), 1,
      sym__dedent,
    STATE(10648), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329299] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15805), 1,
      sym__dedent,
    STATE(10649), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329330] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15807), 1,
      sym_identifier,
    STATE(10650), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329361] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15809), 1,
      sym_int,
    STATE(10651), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329392] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15811), 1,
      anon_sym_COLON,
    STATE(10652), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329423] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15813), 1,
      sym_identifier,
    STATE(10653), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329454] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15815), 1,
      anon_sym_GT,
    STATE(10654), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329485] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15817), 1,
      anon_sym_do,
    STATE(10655), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329516] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13047), 1,
      anon_sym_GT,
    STATE(10656), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329547] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15819), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10657), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329578] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15821), 1,
      anon_sym_PIPE,
    STATE(10658), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329609] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15823), 1,
      sym_int,
    STATE(10659), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329640] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15825), 1,
      sym__dedent,
    STATE(10660), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329671] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15827), 1,
      anon_sym_GT,
    STATE(10661), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329702] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15829), 1,
      anon_sym_COLON,
    STATE(10662), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329733] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15831), 1,
      sym_identifier,
    STATE(10663), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329764] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15833), 1,
      sym_int,
    STATE(10664), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329795] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15835), 1,
      sym_identifier,
    STATE(10665), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329826] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15837), 1,
      anon_sym_GT,
    STATE(10666), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329857] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15839), 1,
      anon_sym_then,
    STATE(10667), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329888] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13063), 1,
      anon_sym_GT,
    STATE(10668), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329919] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15841), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10669), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329950] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15843), 1,
      sym_int,
    STATE(10670), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [329981] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15845), 1,
      anon_sym_GT,
    STATE(10671), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330012] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15847), 1,
      anon_sym_COLON,
    STATE(10672), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330043] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15849), 1,
      sym_identifier,
    STATE(10673), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330074] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15851), 1,
      anon_sym_COLON,
    STATE(10674), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330105] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15853), 1,
      anon_sym_COLON,
    STATE(10675), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330136] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15855), 1,
      sym_int,
    STATE(10676), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330167] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15857), 1,
      sym_identifier,
    STATE(10677), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330198] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15859), 1,
      anon_sym_COLON,
    STATE(10678), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330229] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15861), 1,
      anon_sym_GT,
    STATE(10679), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330260] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13067), 1,
      anon_sym_GT,
    STATE(10680), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330291] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13071), 1,
      anon_sym_GT,
    STATE(10681), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330322] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15863), 1,
      sym__triple_quoted_content,
    STATE(10682), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330353] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15865), 1,
      sym__triple_quoted_content,
    STATE(10683), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330384] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15867), 1,
      sym_identifier,
    STATE(10684), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330415] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15869), 1,
      anon_sym_then,
    STATE(10685), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330446] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15871), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10686), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330477] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15873), 1,
      sym_int,
    STATE(10687), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330508] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15875), 1,
      anon_sym_GT,
    STATE(10688), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330539] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15877), 1,
      sym_identifier,
    STATE(10689), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330570] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15879), 1,
      anon_sym_DASH_GT,
    STATE(10690), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330601] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15881), 1,
      sym_int,
    STATE(10691), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330632] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15883), 1,
      sym_identifier,
    STATE(10692), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330663] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15885), 1,
      anon_sym_EQ,
    STATE(10693), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330694] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15887), 1,
      anon_sym_GT,
    STATE(10694), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330725] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13075), 1,
      anon_sym_GT,
    STATE(10695), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330756] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15889), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10696), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330787] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15891), 1,
      sym__newline_not_aligned,
    STATE(10697), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330818] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15893), 1,
      sym__dedent,
    STATE(10698), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330849] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15895), 1,
      sym__dedent,
    STATE(10699), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330880] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15897), 1,
      sym_int,
    STATE(10700), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330911] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15899), 1,
      anon_sym_GT,
    STATE(10701), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330942] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15901), 1,
      sym_identifier,
    STATE(10702), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [330973] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15903), 1,
      sym__indent,
    STATE(10703), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331004] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15905), 1,
      sym_int,
    STATE(10704), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331035] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15907), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10705), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331066] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15909), 1,
      sym__dedent,
    STATE(10706), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331097] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15911), 1,
      sym_int,
    STATE(10707), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331128] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15913), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(10708), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331159] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15915), 1,
      anon_sym_do,
    STATE(10709), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331190] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15917), 1,
      sym_identifier,
    STATE(10710), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331221] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15919), 1,
      anon_sym_GT,
    STATE(10711), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331252] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15921), 1,
      anon_sym_PIPE,
    STATE(10712), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331283] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13059), 1,
      anon_sym_GT,
    STATE(10713), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331314] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15923), 1,
      sym__dedent,
    STATE(10714), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331345] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15925), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10715), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331376] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15927), 1,
      sym_identifier,
    STATE(10716), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331407] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15929), 1,
      anon_sym_COLON,
    STATE(10717), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331438] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15931), 1,
      anon_sym_then,
    STATE(10718), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331469] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15933), 1,
      sym_identifier,
    STATE(10719), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331500] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15935), 1,
      sym__dedent,
    STATE(10720), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331531] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15937), 1,
      anon_sym_COLON,
    STATE(10721), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331562] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15939), 1,
      anon_sym_GT,
    STATE(10722), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331593] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15941), 1,
      sym_identifier,
    STATE(10723), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331624] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15943), 1,
      sym_int,
    STATE(10724), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331655] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15945), 1,
      sym_identifier,
    STATE(10725), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331686] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15947), 1,
      sym__triple_quoted_content,
    STATE(10726), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331717] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15949), 1,
      sym__triple_quoted_content,
    STATE(10727), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331748] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15951), 1,
      sym_identifier,
    STATE(10728), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331779] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15953), 1,
      anon_sym_then,
    STATE(10729), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331810] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15955), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(10730), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331841] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6568), 1,
      anon_sym_EQ,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(10731), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331872] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15957), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(10732), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331903] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6562), 1,
      anon_sym_EQ,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(10733), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331934] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15959), 1,
      anon_sym_DASH_GT,
    STATE(10734), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331965] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15961), 1,
      sym_identifier,
    STATE(10735), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [331996] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15963), 1,
      anon_sym_GT,
    STATE(10736), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332027] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15965), 1,
      anon_sym_EQ,
    STATE(10737), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332058] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13037), 1,
      anon_sym_GT,
    STATE(10738), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332089] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15967), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10739), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332120] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15969), 1,
      sym_int,
    STATE(10740), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332151] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15971), 1,
      sym__newline_not_aligned,
    STATE(10741), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332182] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15973), 1,
      sym__dedent,
    STATE(10742), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332213] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15975), 1,
      sym__dedent,
    STATE(10743), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332244] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15977), 1,
      anon_sym_GT,
    STATE(10744), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332275] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15979), 1,
      sym_identifier,
    STATE(10745), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332306] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15981), 1,
      sym_int,
    STATE(10746), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332337] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15983), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(10747), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332368] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15985), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(10748), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332399] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15987), 1,
      sym_identifier,
    STATE(10749), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332430] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15989), 1,
      sym__dedent,
    STATE(10750), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332461] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15991), 1,
      anon_sym_GT,
    STATE(10751), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332492] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15993), 1,
      sym__dedent,
    STATE(10752), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332523] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15995), 1,
      anon_sym_do,
    STATE(10753), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332554] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13023), 1,
      anon_sym_GT,
    STATE(10754), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332585] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15997), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10755), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332616] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(15999), 1,
      anon_sym_PIPE,
    STATE(10756), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332647] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16001), 1,
      sym_int,
    STATE(10757), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332678] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16003), 1,
      sym__dedent,
    STATE(10758), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332709] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16005), 1,
      sym__indent,
    STATE(10759), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332740] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16007), 1,
      anon_sym_POUNDendif,
    STATE(10760), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332771] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16009), 1,
      anon_sym_then,
    STATE(10761), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332802] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16011), 1,
      anon_sym_GT,
    STATE(10762), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332833] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16013), 1,
      sym_identifier,
    STATE(10763), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332864] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16015), 1,
      anon_sym_COLON,
    STATE(10764), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332895] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16017), 1,
      sym_int,
    STATE(10765), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332926] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16019), 1,
      sym_int,
    STATE(10766), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332957] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16021), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(10767), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [332988] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16023), 1,
      sym__triple_quoted_content,
    STATE(10768), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333019] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16025), 1,
      sym__triple_quoted_content,
    STATE(10769), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333050] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16027), 1,
      sym_identifier,
    STATE(10770), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333081] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16029), 1,
      anon_sym_then,
    STATE(10771), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333112] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16031), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(10772), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333143] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16033), 1,
      sym_identifier,
    STATE(10773), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333174] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16035), 1,
      anon_sym_GT,
    STATE(10774), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333205] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16037), 1,
      anon_sym_PIPE_RPAREN,
    STATE(10775), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333236] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16039), 1,
      anon_sym_DASH_GT,
    STATE(10776), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333267] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12963), 1,
      anon_sym_GT,
    STATE(10777), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333298] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16041), 1,
      anon_sym_PIPE_RPAREN,
    STATE(10778), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333329] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16043), 1,
      anon_sym_EQ,
    STATE(10779), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333360] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16045), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10780), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333391] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16047), 1,
      sym_int,
    STATE(10781), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333422] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16049), 1,
      anon_sym_PIPE_RPAREN,
    STATE(10782), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333453] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16051), 1,
      sym__newline_not_aligned,
    STATE(10783), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333484] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16053), 1,
      sym__dedent,
    STATE(10784), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333515] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16055), 1,
      sym__dedent,
    STATE(10785), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333546] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16057), 1,
      anon_sym_GT,
    STATE(10786), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333577] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16059), 1,
      sym_identifier,
    STATE(10787), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333608] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16061), 1,
      sym_int,
    STATE(10788), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333639] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16063), 1,
      anon_sym_end,
    STATE(10789), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333670] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16065), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(10790), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333701] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16067), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(10791), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333732] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16069), 1,
      sym__dedent,
    STATE(10792), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333763] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16071), 1,
      sym_int,
    STATE(10793), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333794] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16073), 1,
      anon_sym_PIPE,
    STATE(10794), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333825] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16075), 1,
      anon_sym_do,
    STATE(10795), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333856] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16077), 1,
      anon_sym_GT,
    STATE(10796), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333887] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16079), 1,
      anon_sym_PIPE_RPAREN,
    STATE(10797), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333918] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16081), 1,
      anon_sym_PIPE,
    STATE(10798), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333949] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12955), 1,
      anon_sym_GT,
    STATE(10799), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [333980] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16083), 1,
      sym__dedent,
    STATE(10800), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334011] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16085), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10801), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334042] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16087), 1,
      sym_int,
    STATE(10802), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334073] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16089), 1,
      anon_sym_then,
    STATE(10803), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334104] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16091), 1,
      anon_sym_PIPE_RPAREN,
    STATE(10804), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334135] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16093), 1,
      anon_sym_GT,
    STATE(10805), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334166] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16095), 1,
      anon_sym_COLON,
    STATE(10806), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334197] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16097), 1,
      sym__dedent,
    STATE(10807), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334228] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16099), 1,
      sym_identifier,
    STATE(10808), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334259] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16101), 1,
      anon_sym_do,
    STATE(10809), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334290] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16103), 1,
      sym__triple_quoted_content,
    STATE(10810), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334321] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16105), 1,
      sym__triple_quoted_content,
    STATE(10811), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334352] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16107), 1,
      sym_identifier,
    STATE(10812), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334383] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16109), 1,
      anon_sym_then,
    STATE(10813), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334414] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16111), 1,
      sym_int,
    STATE(10814), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334445] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16113), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10815), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334476] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16115), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(10816), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334507] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16117), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(10817), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334538] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16119), 1,
      anon_sym_DASH_GT,
    STATE(10818), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334569] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16121), 1,
      sym_identifier,
    STATE(10819), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334600] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16123), 1,
      anon_sym_GT,
    STATE(10820), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334631] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16125), 1,
      anon_sym_EQ,
    STATE(10821), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334662] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16127), 1,
      anon_sym_RBRACE,
    STATE(10822), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334693] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16129), 1,
      anon_sym_PIPE_RPAREN,
    STATE(10823), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334724] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12937), 1,
      anon_sym_GT,
    STATE(10824), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334755] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16131), 1,
      sym__newline_not_aligned,
    STATE(10825), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334786] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16133), 1,
      sym__dedent,
    STATE(10826), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334817] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16135), 1,
      sym__dedent,
    STATE(10827), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334848] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16137), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10828), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334879] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16139), 1,
      sym_int,
    STATE(10829), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334910] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16141), 1,
      anon_sym_PIPE_RPAREN,
    STATE(10830), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334941] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16143), 1,
      anon_sym_GT,
    STATE(10831), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [334972] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16145), 1,
      sym_identifier,
    STATE(10832), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335003] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16147), 1,
      sym_int,
    STATE(10833), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335034] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16149), 1,
      sym__dedent,
    STATE(10834), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335065] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16151), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(10835), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335096] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16153), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(10836), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335127] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16155), 1,
      anon_sym_do,
    STATE(10837), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335158] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16157), 1,
      sym_identifier,
    STATE(10838), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335189] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16159), 1,
      anon_sym_GT,
    STATE(10839), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335220] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16161), 1,
      anon_sym_PIPE,
    STATE(10840), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335251] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16163), 1,
      anon_sym_PIPE_RPAREN,
    STATE(10841), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335282] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16165), 1,
      sym__dedent,
    STATE(10842), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335313] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12921), 1,
      anon_sym_GT,
    STATE(10843), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335344] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16167), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10844), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335375] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16169), 1,
      anon_sym_then,
    STATE(10845), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335406] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16171), 1,
      sym_identifier,
    STATE(10846), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335437] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16173), 1,
      anon_sym_PIPE_RPAREN,
    STATE(10847), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335468] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16175), 1,
      anon_sym_GT,
    STATE(10848), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335499] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16177), 1,
      sym_identifier,
    STATE(10849), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335530] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16179), 1,
      sym__triple_quoted_content,
    STATE(10850), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335561] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16181), 1,
      sym__triple_quoted_content,
    STATE(10851), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335592] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16183), 1,
      sym_identifier,
    STATE(10852), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335623] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16185), 1,
      anon_sym_then,
    STATE(10853), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335654] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16187), 1,
      sym_int,
    STATE(10854), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335685] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16189), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(10855), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335716] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16191), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(10856), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335747] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16193), 1,
      sym_identifier,
    STATE(10857), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335778] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16195), 1,
      anon_sym_DASH_GT,
    STATE(10858), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335809] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16197), 1,
      anon_sym_GT,
    STATE(10859), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335840] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16199), 1,
      anon_sym_PIPE_RPAREN,
    STATE(10860), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335871] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16201), 1,
      anon_sym_EQ,
    STATE(10861), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335902] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12893), 1,
      anon_sym_GT,
    STATE(10862), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335933] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16203), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10863), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335964] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16205), 1,
      sym_int,
    STATE(10864), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [335995] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16207), 1,
      sym__newline_not_aligned,
    STATE(10865), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336026] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16209), 1,
      sym__dedent,
    STATE(10866), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336057] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16211), 1,
      sym__dedent,
    STATE(10867), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336088] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16213), 1,
      anon_sym_PIPE_RPAREN,
    STATE(10868), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336119] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16215), 1,
      anon_sym_GT,
    STATE(10869), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336150] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16217), 1,
      anon_sym_RPAREN,
    STATE(10870), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336181] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16219), 1,
      sym_int,
    STATE(10871), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336212] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16221), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(10872), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336243] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16223), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(10873), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336274] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16225), 1,
      sym__dedent,
    STATE(10874), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336305] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16227), 1,
      sym_identifier,
    STATE(10875), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336336] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16229), 1,
      anon_sym_GT,
    STATE(10876), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336367] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16231), 1,
      anon_sym_do,
    STATE(10877), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336398] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16233), 1,
      anon_sym_PIPE_RPAREN,
    STATE(10878), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336429] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12855), 1,
      anon_sym_GT,
    STATE(10879), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336460] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16235), 1,
      anon_sym_PIPE,
    STATE(10880), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336491] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16237), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10881), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336522] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16239), 1,
      sym__dedent,
    STATE(10882), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336553] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16241), 1,
      sym_int,
    STATE(10883), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336584] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16243), 1,
      anon_sym_PIPE_RPAREN,
    STATE(10884), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336615] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16245), 1,
      anon_sym_then,
    STATE(10885), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336646] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16247), 1,
      anon_sym_GT,
    STATE(10886), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336677] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16249), 1,
      anon_sym_end,
    STATE(10887), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336708] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16251), 1,
      sym_identifier,
    STATE(10888), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336739] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16253), 1,
      sym_int,
    STATE(10889), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336770] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16255), 1,
      sym__triple_quoted_content,
    STATE(10890), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336801] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16257), 1,
      sym__triple_quoted_content,
    STATE(10891), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336832] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16259), 1,
      sym_identifier,
    STATE(10892), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336863] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16261), 1,
      anon_sym_then,
    STATE(10893), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336894] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16263), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(10894), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336925] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16265), 1,
      sym_identifier,
    STATE(10895), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336956] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16267), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(10896), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [336987] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16269), 1,
      sym_identifier,
    STATE(10897), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337018] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16271), 1,
      anon_sym_DASH_GT,
    STATE(10898), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337049] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16273), 1,
      anon_sym_end,
    STATE(10899), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337080] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16275), 1,
      anon_sym_GT,
    STATE(10900), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337111] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16277), 1,
      anon_sym_EQ,
    STATE(10901), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337142] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16279), 1,
      anon_sym_PIPE_RPAREN,
    STATE(10902), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337173] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12845), 1,
      anon_sym_GT,
    STATE(10903), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337204] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16281), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10904), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337235] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16283), 1,
      sym__newline_not_aligned,
    STATE(10905), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337266] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16285), 1,
      sym__dedent,
    STATE(10906), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337297] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16287), 1,
      sym__dedent,
    STATE(10907), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337328] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16289), 1,
      sym_int,
    STATE(10908), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337359] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16291), 1,
      anon_sym_PIPE_RPAREN,
    STATE(10909), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337390] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16293), 1,
      sym__indent,
    STATE(10910), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337421] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16295), 1,
      anon_sym_GT,
    STATE(10911), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337452] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16297), 1,
      sym__dedent,
    STATE(10912), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337483] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16299), 1,
      sym_identifier,
    STATE(10913), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337514] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16301), 1,
      sym__dedent,
    STATE(10914), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337545] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16303), 1,
      sym_int,
    STATE(10915), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337576] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16305), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(10916), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337607] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16307), 1,
      anon_sym_do,
    STATE(10917), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337638] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16309), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(10918), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337669] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16311), 1,
      sym_identifier,
    STATE(10919), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337700] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16313), 1,
      anon_sym_PIPE,
    STATE(10920), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337731] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16315), 1,
      sym__dedent,
    STATE(10921), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337762] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16317), 1,
      sym__dedent,
    STATE(10922), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337793] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16319), 1,
      anon_sym_GT,
    STATE(10923), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337824] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16321), 1,
      anon_sym_RBRACE,
    STATE(10924), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337855] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16323), 1,
      anon_sym_then,
    STATE(10925), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337886] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16325), 1,
      anon_sym_POUNDendif,
    STATE(10926), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337917] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16327), 1,
      sym__triple_quoted_content,
    STATE(10927), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337948] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16329), 1,
      sym__triple_quoted_content,
    STATE(10928), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [337979] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16331), 1,
      sym_identifier,
    STATE(10929), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338010] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16333), 1,
      anon_sym_PIPE_RPAREN,
    STATE(10930), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338041] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14397), 1,
      anon_sym_new,
    STATE(10931), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338072] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16335), 1,
      anon_sym_COLON,
    STATE(10932), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338103] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16337), 1,
      anon_sym_EQ,
    STATE(10933), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338134] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16339), 1,
      sym__dedent,
    STATE(10934), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338165] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12825), 1,
      anon_sym_GT,
    STATE(10935), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338196] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16341), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10936), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338227] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16343), 1,
      sym__dedent,
    STATE(10937), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338258] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16345), 1,
      sym__dedent,
    STATE(10938), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338289] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16347), 1,
      anon_sym_POUNDendif,
    STATE(10939), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338320] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16349), 1,
      anon_sym_PIPE,
    STATE(10940), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338351] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16351), 1,
      sym_int,
    STATE(10941), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338382] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16353), 1,
      anon_sym_PIPE_RPAREN,
    STATE(10942), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338413] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16355), 1,
      sym__triple_quoted_content,
    STATE(10943), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338444] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16357), 1,
      sym__triple_quoted_content,
    STATE(10944), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338475] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16359), 1,
      sym_identifier,
    STATE(10945), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338506] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16361), 1,
      anon_sym_end,
    STATE(10946), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338537] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16363), 1,
      anon_sym_COLON,
    STATE(10947), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338568] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16365), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10948), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338599] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16367), 1,
      anon_sym_EQ,
    STATE(10949), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338630] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16369), 1,
      anon_sym_RBRACE,
    STATE(10950), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338661] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16371), 1,
      anon_sym_GT,
    STATE(10951), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338692] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16373), 1,
      sym__dedent,
    STATE(10952), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338723] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16375), 1,
      sym__dedent,
    STATE(10953), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338754] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16377), 1,
      anon_sym_GT,
    STATE(10954), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338785] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16379), 1,
      anon_sym_RBRACK,
    STATE(10955), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338816] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16381), 1,
      sym__triple_quoted_content,
    STATE(10956), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338847] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16383), 1,
      sym__triple_quoted_content,
    STATE(10957), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338878] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16385), 1,
      sym_identifier,
    STATE(10958), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338909] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16387), 1,
      sym__dedent,
    STATE(10959), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338940] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16389), 1,
      sym_identifier,
    STATE(10960), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [338971] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16391), 1,
      sym_int,
    STATE(10961), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339002] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16393), 1,
      anon_sym_EQ,
    STATE(10962), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339033] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16395), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(10963), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339064] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16397), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(10964), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339095] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16399), 1,
      sym__dedent,
    STATE(10965), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339126] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16401), 1,
      anon_sym_PIPE_RBRACK,
    STATE(10966), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339157] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16403), 1,
      anon_sym_RBRACK,
    STATE(10967), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339188] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16405), 1,
      anon_sym_RPAREN,
    STATE(10968), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339219] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16407), 1,
      sym__triple_quoted_content,
    STATE(10969), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339250] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16409), 1,
      sym__triple_quoted_content,
    STATE(10970), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339281] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16411), 1,
      sym_identifier,
    STATE(10971), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339312] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16413), 1,
      sym_identifier,
    STATE(10972), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339343] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16415), 1,
      anon_sym_POUNDendif,
    STATE(10973), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339374] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16417), 1,
      sym__dedent,
    STATE(10974), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339405] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16419), 1,
      anon_sym_EQ,
    STATE(10975), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339436] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16421), 1,
      anon_sym_GT,
    STATE(10976), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339467] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16423), 1,
      anon_sym_RBRACE,
    STATE(10977), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339498] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16425), 1,
      sym__dedent,
    STATE(10978), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339529] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16427), 1,
      anon_sym_POUNDendif,
    STATE(10979), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339560] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16429), 1,
      anon_sym_PIPE_RPAREN,
    STATE(10980), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339591] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16431), 1,
      sym__triple_quoted_content,
    STATE(10981), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339622] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16433), 1,
      sym__triple_quoted_content,
    STATE(10982), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339653] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16435), 1,
      sym_identifier,
    STATE(10983), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339684] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16437), 1,
      sym__dedent,
    STATE(10984), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339715] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16439), 1,
      sym__newline_not_aligned,
    STATE(10985), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339746] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13375), 1,
      anon_sym_EQ,
    STATE(10986), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339777] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16441), 1,
      anon_sym_EQ,
    STATE(10987), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339808] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12729), 1,
      anon_sym_GT,
    STATE(10988), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339839] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16443), 1,
      anon_sym_PIPE_RBRACE,
    STATE(10989), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339870] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16445), 1,
      sym__dedent,
    STATE(10990), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339901] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16447), 1,
      anon_sym_POUNDendif,
    STATE(10991), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339932] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16449), 1,
      sym_int,
    STATE(10992), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339963] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16451), 1,
      sym__triple_quoted_content,
    STATE(10993), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [339994] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16453), 1,
      sym__triple_quoted_content,
    STATE(10994), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340025] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16455), 1,
      sym_identifier,
    STATE(10995), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340056] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16457), 1,
      anon_sym_PIPE_RPAREN,
    STATE(10996), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340087] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16459), 1,
      sym_identifier,
    STATE(10997), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340118] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16461), 1,
      anon_sym_end,
    STATE(10998), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340149] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16463), 1,
      anon_sym_EQ,
    STATE(10999), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340180] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16465), 1,
      sym_identifier,
    STATE(11000), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340211] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16467), 1,
      anon_sym_PIPE_RBRACE,
    STATE(11001), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340242] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16469), 1,
      sym__dedent,
    STATE(11002), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340273] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16471), 1,
      anon_sym_RBRACE,
    STATE(11003), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340304] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16473), 1,
      anon_sym_end,
    STATE(11004), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340335] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16475), 1,
      sym__triple_quoted_content,
    STATE(11005), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340366] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16477), 1,
      sym__triple_quoted_content,
    STATE(11006), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340397] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16479), 1,
      sym_identifier,
    STATE(11007), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340428] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16481), 1,
      anon_sym_GT,
    STATE(11008), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340459] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16483), 1,
      anon_sym_COLON,
    STATE(11009), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340490] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16485), 1,
      anon_sym_RPAREN,
    STATE(11010), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340521] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16487), 1,
      anon_sym_EQ,
    STATE(11011), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340552] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16489), 1,
      anon_sym_GT,
    STATE(11012), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340583] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16491), 1,
      anon_sym_RBRACK,
    STATE(11013), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340614] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16493), 1,
      sym__dedent,
    STATE(11014), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340645] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16495), 1,
      sym__dedent,
    STATE(11015), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340676] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16497), 1,
      sym_identifier,
    STATE(11016), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340707] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16499), 1,
      sym__triple_quoted_content,
    STATE(11017), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340738] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16501), 1,
      sym__triple_quoted_content,
    STATE(11018), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340769] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16503), 1,
      sym_int,
    STATE(11019), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340800] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16505), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(11020), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340831] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16507), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(11021), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340862] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16509), 1,
      anon_sym_EQ,
    STATE(11022), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340893] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16511), 1,
      sym__dedent,
    STATE(11023), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340924] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16513), 1,
      sym__dedent,
    STATE(11024), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340955] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16515), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11025), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [340986] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16517), 1,
      sym__triple_quoted_content,
    STATE(11026), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341017] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16519), 1,
      sym__triple_quoted_content,
    STATE(11027), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341048] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16521), 1,
      anon_sym_RBRACK,
    STATE(11028), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341079] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16523), 1,
      anon_sym_RPAREN,
    STATE(11029), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341110] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16525), 1,
      sym_identifier,
    STATE(11030), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341141] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16527), 1,
      anon_sym_EQ,
    STATE(11031), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341172] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16529), 1,
      anon_sym_RPAREN,
    STATE(11032), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341203] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16531), 1,
      sym__dedent,
    STATE(11033), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341234] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16533), 1,
      sym__dedent,
    STATE(11034), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341265] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16535), 1,
      sym__triple_quoted_content,
    STATE(11035), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341296] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16537), 1,
      sym__triple_quoted_content,
    STATE(11036), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341327] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16539), 1,
      anon_sym_GT,
    STATE(11037), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341358] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16541), 1,
      anon_sym_RBRACE,
    STATE(11038), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341389] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16543), 1,
      anon_sym_POUNDendif,
    STATE(11039), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341420] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16545), 1,
      anon_sym_PIPE_RPAREN,
    STATE(11040), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341451] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16547), 1,
      sym__dedent,
    STATE(11041), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341482] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16549), 1,
      sym__dedent,
    STATE(11042), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341513] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16551), 1,
      sym__triple_quoted_content,
    STATE(11043), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341544] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16553), 1,
      sym__triple_quoted_content,
    STATE(11044), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341575] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12941), 1,
      anon_sym_GT,
    STATE(11045), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341606] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16555), 1,
      anon_sym_PIPE_RBRACE,
    STATE(11046), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341637] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16557), 1,
      anon_sym_POUNDendif,
    STATE(11047), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341668] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16559), 1,
      sym_int,
    STATE(11048), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341699] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16561), 1,
      sym__dedent,
    STATE(11049), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341730] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16563), 1,
      anon_sym_PIPE_RPAREN,
    STATE(11050), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341761] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16565), 1,
      anon_sym_end,
    STATE(11051), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341792] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16567), 1,
      anon_sym_PIPE_RBRACE,
    STATE(11052), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341823] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16569), 1,
      anon_sym_RBRACE,
    STATE(11053), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341854] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16571), 1,
      anon_sym_struct,
    STATE(11054), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341885] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16573), 1,
      sym__dedent,
    STATE(11055), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341916] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16575), 1,
      anon_sym_GT,
    STATE(11056), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341947] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16577), 1,
      anon_sym_RPAREN,
    STATE(11057), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [341978] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16579), 1,
      anon_sym_GT,
    STATE(11058), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342009] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16581), 1,
      anon_sym_RBRACK,
    STATE(11059), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342040] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16583), 1,
      sym__dedent,
    STATE(11060), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342071] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16585), 1,
      anon_sym_LT2,
    STATE(11061), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342102] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16587), 1,
      sym__dedent,
    STATE(11062), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342133] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16589), 1,
      anon_sym_LT2,
    STATE(11063), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342164] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16591), 1,
      sym__dedent,
    STATE(11064), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342195] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8756), 1,
      anon_sym_EQ,
    STATE(11065), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342226] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16593), 1,
      sym_identifier,
    STATE(11066), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342257] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16595), 1,
      sym_int,
    STATE(11067), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342288] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16597), 1,
      sym__dedent,
    STATE(11068), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342319] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16599), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(11069), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342350] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16601), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(11070), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342381] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16603), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11071), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342412] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16605), 1,
      sym__dedent,
    STATE(11072), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342443] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16607), 1,
      anon_sym_RBRACK,
    STATE(11073), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342474] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16609), 1,
      anon_sym_RPAREN,
    STATE(11074), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342505] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16611), 1,
      anon_sym_RBRACE,
    STATE(11075), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342536] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16613), 1,
      sym__dedent,
    STATE(11076), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342567] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16615), 1,
      sym_identifier,
    STATE(11077), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342598] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9807), 1,
      sym__dedent,
    STATE(11078), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342629] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16617), 1,
      sym__dedent,
    STATE(11079), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342660] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16619), 1,
      sym__dedent,
    STATE(11080), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342691] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16621), 1,
      anon_sym_GT,
    STATE(11081), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342722] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16623), 1,
      anon_sym_RBRACE,
    STATE(11082), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342753] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16625), 1,
      anon_sym_POUNDendif,
    STATE(11083), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342784] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16627), 1,
      sym__dedent,
    STATE(11084), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342815] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16629), 1,
      anon_sym_PIPE_RPAREN,
    STATE(11085), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342846] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16631), 1,
      anon_sym_RBRACK,
    STATE(11086), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342877] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16633), 1,
      sym__dedent,
    STATE(11087), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342908] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16635), 1,
      sym__dedent,
    STATE(11088), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342939] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12719), 1,
      anon_sym_GT,
    STATE(11089), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [342970] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16637), 1,
      anon_sym_PIPE_RBRACE,
    STATE(11090), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343001] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16639), 1,
      anon_sym_POUNDendif,
    STATE(11091), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343032] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16641), 1,
      sym__dedent,
    STATE(11092), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343063] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16643), 1,
      sym_int,
    STATE(11093), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343094] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16645), 1,
      anon_sym_PIPE_RPAREN,
    STATE(11094), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343125] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16647), 1,
      anon_sym_end,
    STATE(11095), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343156] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16649), 1,
      sym__dedent,
    STATE(11096), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343187] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16651), 1,
      sym__dedent,
    STATE(11097), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343218] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16653), 1,
      anon_sym_PIPE_RBRACE,
    STATE(11098), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343249] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16655), 1,
      anon_sym_RBRACE,
    STATE(11099), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343280] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16657), 1,
      sym__dedent,
    STATE(11100), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343311] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16659), 1,
      anon_sym_GT,
    STATE(11101), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343342] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16661), 1,
      sym__dedent,
    STATE(11102), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343373] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16663), 1,
      anon_sym_GT,
    STATE(11103), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343404] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16665), 1,
      sym__dedent,
    STATE(11104), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343435] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16667), 1,
      anon_sym_RBRACK,
    STATE(11105), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343466] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16669), 1,
      sym__indent,
    STATE(11106), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343497] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16671), 1,
      sym_identifier,
    STATE(11107), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343528] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16673), 1,
      sym__dedent,
    STATE(11108), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343559] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16675), 1,
      sym_identifier,
    STATE(11109), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343590] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16677), 1,
      sym__indent,
    STATE(11110), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343621] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16679), 1,
      sym_int,
    STATE(11111), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343652] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16681), 1,
      sym__dedent,
    STATE(11112), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343683] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16683), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(11113), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343714] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16685), 1,
      sym__indent,
    STATE(11114), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343745] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16687), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(11115), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343776] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16689), 1,
      sym__dedent,
    STATE(11116), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343807] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16691), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11117), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343838] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16693), 1,
      anon_sym_RBRACK,
    STATE(11118), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343869] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16695), 1,
      anon_sym_RPAREN,
    STATE(11119), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343900] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16697), 1,
      sym__dedent,
    STATE(11120), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343931] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16699), 1,
      sym_identifier,
    STATE(11121), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343962] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16701), 1,
      sym__dedent,
    STATE(11122), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [343993] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16703), 1,
      anon_sym_GT,
    STATE(11123), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344024] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16705), 1,
      sym__dedent,
    STATE(11124), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344055] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16707), 1,
      anon_sym_RBRACE,
    STATE(11125), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344086] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16709), 1,
      anon_sym_POUNDendif,
    STATE(11126), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344117] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16711), 1,
      anon_sym_PIPE_RPAREN,
    STATE(11127), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344148] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16713), 1,
      sym__dedent,
    STATE(11128), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344179] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16715), 1,
      anon_sym_COLON,
    STATE(11129), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344210] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16717), 1,
      sym__dedent,
    STATE(11130), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344241] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16719), 1,
      anon_sym_EQ,
    STATE(11131), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344272] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16721), 1,
      sym__dedent,
    STATE(11132), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344303] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12865), 1,
      anon_sym_GT,
    STATE(11133), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344334] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16723), 1,
      anon_sym_PIPE_RBRACE,
    STATE(11134), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344365] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16725), 1,
      anon_sym_POUNDendif,
    STATE(11135), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344396] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16727), 1,
      sym__dedent,
    STATE(11136), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344427] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16729), 1,
      sym_int,
    STATE(11137), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344458] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16731), 1,
      anon_sym_PIPE_RPAREN,
    STATE(11138), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344489] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16733), 1,
      anon_sym_end,
    STATE(11139), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344520] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16735), 1,
      sym__dedent,
    STATE(11140), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344551] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16737), 1,
      anon_sym_end,
    STATE(11141), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344582] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16739), 1,
      sym_identifier,
    STATE(11142), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344613] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16741), 1,
      anon_sym_PIPE_RBRACE,
    STATE(11143), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344644] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16743), 1,
      sym__dedent,
    STATE(11144), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344675] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16745), 1,
      anon_sym_RBRACE,
    STATE(11145), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344706] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16747), 1,
      anon_sym_GT,
    STATE(11146), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344737] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16749), 1,
      anon_sym_RPAREN,
    STATE(11147), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344768] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16751), 1,
      sym__dedent,
    STATE(11148), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344799] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16753), 1,
      anon_sym_GT,
    STATE(11149), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344830] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16755), 1,
      anon_sym_GT,
    STATE(11150), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344861] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16757), 1,
      anon_sym_RBRACK,
    STATE(11151), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344892] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16759), 1,
      sym__dedent,
    STATE(11152), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344923] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16761), 1,
      anon_sym_COLON,
    STATE(11153), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344954] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16763), 1,
      sym__dedent,
    STATE(11154), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [344985] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16765), 1,
      anon_sym_member,
    STATE(11155), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345016] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16767), 1,
      anon_sym_COLON,
    STATE(11156), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345047] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16769), 1,
      anon_sym_RPAREN,
    STATE(11157), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345078] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16771), 1,
      sym_identifier,
    STATE(11158), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345109] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16773), 1,
      sym_int,
    STATE(11159), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345140] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16775), 1,
      sym__dedent,
    STATE(11160), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345171] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16777), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(11161), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345202] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16779), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(11162), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345233] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16781), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11163), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345264] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16783), 1,
      sym__dedent,
    STATE(11164), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345295] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16785), 1,
      anon_sym_RBRACK,
    STATE(11165), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345326] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16787), 1,
      anon_sym_RPAREN,
    STATE(11166), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345357] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16789), 1,
      anon_sym_DASH_GT,
    STATE(11167), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345388] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16791), 1,
      sym__dedent,
    STATE(11168), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345419] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16793), 1,
      anon_sym_RBRACE,
    STATE(11169), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345450] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16795), 1,
      sym__dedent,
    STATE(11170), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345481] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16797), 1,
      anon_sym_GT,
    STATE(11171), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345512] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16799), 1,
      sym__dedent,
    STATE(11172), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345543] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16801), 1,
      anon_sym_RBRACE,
    STATE(11173), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345574] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16803), 1,
      anon_sym_POUNDendif,
    STATE(11174), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345605] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16805), 1,
      anon_sym_PIPE_RPAREN,
    STATE(11175), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345636] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16807), 1,
      sym__dedent,
    STATE(11176), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345667] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16809), 1,
      sym__dedent,
    STATE(11177), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345698] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16811), 1,
      anon_sym_set,
    STATE(11178), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345729] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12913), 1,
      anon_sym_GT,
    STATE(11179), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345760] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16813), 1,
      anon_sym_PIPE_RBRACE,
    STATE(11180), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345791] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16811), 1,
      anon_sym_get,
    STATE(11181), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345822] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16815), 1,
      anon_sym_POUNDendif,
    STATE(11182), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345853] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16817), 1,
      sym_int,
    STATE(11183), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345884] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16819), 1,
      anon_sym_PIPE_RPAREN,
    STATE(11184), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345915] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16821), 1,
      anon_sym_end,
    STATE(11185), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345946] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16823), 1,
      anon_sym_unit,
    STATE(11186), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [345977] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16825), 1,
      anon_sym_PIPE_RBRACE,
    STATE(11187), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346008] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16827), 1,
      anon_sym_RBRACE,
    STATE(11188), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346039] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16829), 1,
      anon_sym_COLON,
    STATE(11189), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346070] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16831), 1,
      sym__dedent,
    STATE(11190), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346101] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16833), 1,
      sym_identifier,
    STATE(11191), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346132] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16835), 1,
      anon_sym_GT,
    STATE(11192), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346163] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16837), 1,
      anon_sym_COLON,
    STATE(11193), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346194] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16839), 1,
      anon_sym_RPAREN,
    STATE(11194), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346225] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16841), 1,
      anon_sym_GT,
    STATE(11195), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346256] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16843), 1,
      anon_sym_RBRACK,
    STATE(11196), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346287] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16845), 1,
      sym__indent,
    STATE(11197), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346318] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16847), 1,
      sym__dedent,
    STATE(11198), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346349] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16849), 1,
      sym_identifier,
    STATE(11199), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346380] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16851), 1,
      sym_identifier,
    STATE(11200), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346411] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6576), 1,
      anon_sym_EQ,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(11201), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346442] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16853), 1,
      anon_sym_RPAREN,
    STATE(11202), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346473] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6456), 1,
      anon_sym_POUNDendif,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(11203), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346504] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6286), 1,
      anon_sym_POUNDendif,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(11204), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346535] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16855), 1,
      sym_int,
    STATE(11205), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346566] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16857), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(11206), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346597] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16859), 1,
      sym__indent,
    STATE(11207), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346628] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16861), 1,
      sym_identifier,
    STATE(11208), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346659] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16863), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(11209), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346690] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16865), 1,
      sym_identifier,
    STATE(11210), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346721] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16867), 1,
      sym_identifier,
    STATE(11211), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346752] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16869), 1,
      anon_sym_GT,
    STATE(11212), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346783] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8593), 1,
      sym__dedent,
    STATE(11213), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346814] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16871), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11214), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346845] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16873), 1,
      anon_sym_of,
    STATE(11215), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346876] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16875), 1,
      anon_sym_RBRACK,
    STATE(11216), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346907] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16877), 1,
      sym__indent,
    STATE(11217), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346938] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16879), 1,
      sym__indent,
    STATE(11218), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [346969] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16881), 1,
      anon_sym_RPAREN,
    STATE(11219), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347000] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16883), 1,
      sym_identifier,
    STATE(11220), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347031] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16885), 1,
      sym__dedent,
    STATE(11221), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347062] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16887), 1,
      sym__indent,
    STATE(11222), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347093] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16889), 1,
      anon_sym_set,
    STATE(11223), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347124] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16891), 1,
      sym_identifier,
    STATE(11224), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347155] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16889), 1,
      anon_sym_get,
    STATE(11225), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347186] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16893), 1,
      anon_sym_set,
    STATE(11226), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347217] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16893), 1,
      anon_sym_get,
    STATE(11227), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347248] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16895), 1,
      anon_sym_EQ,
    STATE(11228), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347279] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16897), 1,
      sym__indent,
    STATE(11229), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347310] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16899), 1,
      sym__indent,
    STATE(11230), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347341] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16901), 1,
      sym__indent,
    STATE(11231), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347372] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16903), 1,
      anon_sym_set,
    STATE(11232), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347403] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16905), 1,
      anon_sym_COLON,
    STATE(11233), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347434] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16907), 1,
      anon_sym_get,
    STATE(11234), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347465] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16909), 1,
      sym_identifier,
    STATE(11235), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347496] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16907), 1,
      anon_sym_set,
    STATE(11236), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347527] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16911), 1,
      anon_sym_get,
    STATE(11237), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347558] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16911), 1,
      anon_sym_set,
    STATE(11238), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347589] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16913), 1,
      anon_sym_get,
    STATE(11239), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347620] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16915), 1,
      anon_sym_new,
    STATE(11240), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347651] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16913), 1,
      anon_sym_set,
    STATE(11241), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347682] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16903), 1,
      anon_sym_get,
    STATE(11242), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347713] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16917), 1,
      sym__indent,
    STATE(11243), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347744] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16919), 1,
      sym_identifier,
    STATE(11244), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347775] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16921), 1,
      anon_sym_EQ,
    STATE(11245), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347806] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16923), 1,
      anon_sym_EQ,
    STATE(11246), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347837] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16925), 1,
      sym__dedent,
    STATE(11247), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347868] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16927), 1,
      sym__indent,
    STATE(11248), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347899] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16929), 1,
      sym__dedent,
    STATE(11249), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347930] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16931), 1,
      anon_sym_GT,
    STATE(11250), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347961] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16933), 1,
      sym__indent,
    STATE(11251), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [347992] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16935), 1,
      anon_sym_RBRACE,
    STATE(11252), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348023] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16937), 1,
      anon_sym_POUNDendif,
    STATE(11253), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348054] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16939), 1,
      sym_identifier,
    STATE(11254), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348085] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16941), 1,
      sym__indent,
    STATE(11255), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348116] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16943), 1,
      anon_sym_PIPE_RPAREN,
    STATE(11256), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348147] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16945), 1,
      sym__indent,
    STATE(11257), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348178] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16947), 1,
      sym__indent,
    STATE(11258), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348209] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16949), 1,
      sym__dedent,
    STATE(11259), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348240] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16951), 1,
      sym__dedent,
    STATE(11260), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348271] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16953), 1,
      sym__indent,
    STATE(11261), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348302] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16955), 1,
      anon_sym_EQ,
    STATE(11262), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348333] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16957), 1,
      anon_sym_COLON,
    STATE(11263), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348364] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12851), 1,
      anon_sym_GT,
    STATE(11264), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348395] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16959), 1,
      sym_identifier,
    STATE(11265), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348426] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16961), 1,
      anon_sym_PIPE_RBRACE,
    STATE(11266), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348457] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16963), 1,
      anon_sym_POUNDendif,
    STATE(11267), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348488] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16965), 1,
      sym__dedent,
    STATE(11268), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348519] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16967), 1,
      sym__indent,
    STATE(11269), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348550] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16969), 1,
      sym_identifier,
    STATE(11270), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348581] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16971), 1,
      anon_sym_LT2,
    STATE(11271), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348612] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16973), 1,
      sym__dedent,
    STATE(11272), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348643] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16975), 1,
      sym_int,
    STATE(11273), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348674] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16977), 1,
      anon_sym_DASH_GT,
    STATE(11274), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348705] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16979), 1,
      sym__dedent,
    STATE(11275), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348736] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16981), 1,
      anon_sym_PIPE_RPAREN,
    STATE(11276), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348767] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16983), 1,
      anon_sym_end,
    STATE(11277), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348798] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16985), 1,
      anon_sym_PIPE_RBRACE,
    STATE(11278), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348829] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16987), 1,
      anon_sym_RBRACE,
    STATE(11279), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348860] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16989), 1,
      anon_sym_set,
    STATE(11280), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348891] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16989), 1,
      anon_sym_get,
    STATE(11281), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348922] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16991), 1,
      anon_sym_GT,
    STATE(11282), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348953] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16993), 1,
      anon_sym_RPAREN,
    STATE(11283), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [348984] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16995), 1,
      anon_sym_GT,
    STATE(11284), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349015] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16997), 1,
      anon_sym_RBRACK,
    STATE(11285), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349046] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(16999), 1,
      sym__dedent,
    STATE(11286), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349077] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17001), 1,
      sym__indent,
    STATE(11287), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349108] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17003), 1,
      sym_identifier,
    STATE(11288), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349139] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17005), 1,
      sym_identifier,
    STATE(11289), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349170] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17007), 1,
      sym_identifier,
    STATE(11290), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349201] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17009), 1,
      sym_identifier,
    STATE(11291), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349232] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17011), 1,
      sym_int,
    STATE(11292), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349263] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17013), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(11293), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349294] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17015), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(11294), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349325] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17017), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11295), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349356] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17019), 1,
      anon_sym_RBRACK,
    STATE(11296), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349387] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17021), 1,
      sym__indent,
    STATE(11297), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349418] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17023), 1,
      sym__indent,
    STATE(11298), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349449] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17025), 1,
      anon_sym_RPAREN,
    STATE(11299), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349480] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17027), 1,
      anon_sym_RBRACE,
    STATE(11300), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349511] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17029), 1,
      anon_sym_get,
    STATE(11301), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349542] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17031), 1,
      sym__indent,
    STATE(11302), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349573] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17029), 1,
      anon_sym_set,
    STATE(11303), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349604] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17033), 1,
      sym_identifier,
    STATE(11304), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349635] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17035), 1,
      anon_sym_get,
    STATE(11305), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349666] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17037), 1,
      sym__dedent,
    STATE(11306), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349697] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17035), 1,
      anon_sym_set,
    STATE(11307), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349728] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17039), 1,
      anon_sym_EQ,
    STATE(11308), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349759] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17041), 1,
      sym__indent,
    STATE(11309), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349790] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17043), 1,
      sym__indent,
    STATE(11310), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349821] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17045), 1,
      sym__indent,
    STATE(11311), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349852] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17047), 1,
      anon_sym_get,
    STATE(11312), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349883] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17047), 1,
      anon_sym_set,
    STATE(11313), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349914] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17049), 1,
      sym_identifier,
    STATE(11314), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349945] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17051), 1,
      sym__dedent,
    STATE(11315), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [349976] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17053), 1,
      anon_sym_get,
    STATE(11316), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350007] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17055), 1,
      anon_sym_new,
    STATE(11317), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350038] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17053), 1,
      anon_sym_set,
    STATE(11318), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350069] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17057), 1,
      sym__indent,
    STATE(11319), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350100] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17059), 1,
      sym__dedent,
    STATE(11320), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350131] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17061), 1,
      anon_sym_EQ,
    STATE(11321), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350162] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17063), 1,
      anon_sym_EQ,
    STATE(11322), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350193] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17065), 1,
      sym__dedent,
    STATE(11323), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350224] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17067), 1,
      sym__indent,
    STATE(11324), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350255] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17069), 1,
      sym__dedent,
    STATE(11325), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350286] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17071), 1,
      anon_sym_GT,
    STATE(11326), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350317] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17073), 1,
      sym__indent,
    STATE(11327), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350348] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17075), 1,
      anon_sym_RBRACE,
    STATE(11328), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350379] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17077), 1,
      anon_sym_POUNDendif,
    STATE(11329), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350410] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17079), 1,
      sym_identifier,
    STATE(11330), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350441] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17081), 1,
      sym__indent,
    STATE(11331), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350472] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17083), 1,
      anon_sym_PIPE_RPAREN,
    STATE(11332), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350503] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17085), 1,
      sym__indent,
    STATE(11333), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350534] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17087), 1,
      sym__indent,
    STATE(11334), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350565] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(1450), 1,
      sym__dedent,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(11335), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350596] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17089), 1,
      sym__indent,
    STATE(11336), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350627] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17091), 1,
      anon_sym_EQ,
    STATE(11337), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350658] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17093), 1,
      sym__dedent,
    STATE(11338), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350689] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17095), 1,
      anon_sym_COLON,
    STATE(11339), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350720] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17097), 1,
      sym_identifier,
    STATE(11340), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350751] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12751), 1,
      anon_sym_GT,
    STATE(11341), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350782] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17099), 1,
      anon_sym_PIPE_RBRACE,
    STATE(11342), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350813] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17101), 1,
      sym__dedent,
    STATE(11343), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350844] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17103), 1,
      sym__indent,
    STATE(11344), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350875] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17105), 1,
      sym_identifier,
    STATE(11345), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350906] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17107), 1,
      anon_sym_LT2,
    STATE(11346), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350937] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17109), 1,
      sym__dedent,
    STATE(11347), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350968] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17111), 1,
      anon_sym_POUNDendif,
    STATE(11348), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [350999] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17113), 1,
      anon_sym_DASH_GT,
    STATE(11349), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351030] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17115), 1,
      sym_int,
    STATE(11350), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351061] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17117), 1,
      anon_sym_PIPE_RPAREN,
    STATE(11351), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351092] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17119), 1,
      anon_sym_end,
    STATE(11352), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351123] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17121), 1,
      sym__indent,
    STATE(11353), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351154] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17123), 1,
      sym_identifier,
    STATE(11354), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351185] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17125), 1,
      anon_sym_PIPE_RBRACE,
    STATE(11355), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351216] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17127), 1,
      sym_identifier,
    STATE(11356), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351247] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17129), 1,
      sym_identifier,
    STATE(11357), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351278] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17131), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(11358), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351309] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17133), 1,
      anon_sym_GT,
    STATE(11359), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351340] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17135), 1,
      anon_sym_RPAREN,
    STATE(11360), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351371] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17137), 1,
      anon_sym_GT,
    STATE(11361), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351402] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17139), 1,
      anon_sym_RBRACK,
    STATE(11362), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351433] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17141), 1,
      sym__indent,
    STATE(11363), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351464] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17143), 1,
      sym__indent,
    STATE(11364), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351495] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17145), 1,
      sym__dedent,
    STATE(11365), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351526] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17147), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11366), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351557] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17149), 1,
      anon_sym_RBRACK,
    STATE(11367), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351588] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17151), 1,
      sym__indent,
    STATE(11368), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351619] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17153), 1,
      sym_identifier,
    STATE(11369), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351650] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17155), 1,
      sym_identifier,
    STATE(11370), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351681] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17157), 1,
      sym_int,
    STATE(11371), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351712] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17159), 1,
      sym_identifier,
    STATE(11372), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351743] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17161), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(11373), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351774] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17163), 1,
      anon_sym_EQ,
    STATE(11374), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351805] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17165), 1,
      sym__indent,
    STATE(11375), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351836] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17167), 1,
      sym__indent,
    STATE(11376), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351867] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17169), 1,
      sym__indent,
    STATE(11377), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351898] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17171), 1,
      sym_identifier,
    STATE(11378), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351929] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17173), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11379), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351960] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17175), 1,
      sym_identifier,
    STATE(11380), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [351991] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17177), 1,
      anon_sym_RBRACK,
    STATE(11381), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352022] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17179), 1,
      anon_sym_RPAREN,
    STATE(11382), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352053] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17181), 1,
      sym_identifier,
    STATE(11383), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352084] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17183), 1,
      sym__indent,
    STATE(11384), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352115] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4076), 1,
      sym__newline_not_aligned,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(11385), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352146] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17185), 1,
      anon_sym_EQ,
    STATE(11386), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352177] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17187), 1,
      anon_sym_EQ,
    STATE(11387), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352208] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17189), 1,
      anon_sym_get,
    STATE(11388), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352239] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17189), 1,
      anon_sym_set,
    STATE(11389), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352270] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17191), 1,
      anon_sym_get,
    STATE(11390), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352301] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17193), 1,
      sym__indent,
    STATE(11391), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352332] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17191), 1,
      anon_sym_set,
    STATE(11392), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352363] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17195), 1,
      anon_sym_get,
    STATE(11393), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352394] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17197), 1,
      sym_identifier,
    STATE(11394), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352425] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17199), 1,
      sym__indent,
    STATE(11395), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352456] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17195), 1,
      anon_sym_set,
    STATE(11396), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352487] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17201), 1,
      sym__indent,
    STATE(11397), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352518] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17203), 1,
      sym__indent,
    STATE(11398), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352549] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17205), 1,
      anon_sym_EQ,
    STATE(11399), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352580] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17207), 1,
      sym__indent,
    STATE(11400), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352611] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17209), 1,
      anon_sym_EQ,
    STATE(11401), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352642] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17211), 1,
      anon_sym_get,
    STATE(11402), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352673] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17211), 1,
      anon_sym_set,
    STATE(11403), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352704] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17213), 1,
      sym_identifier,
    STATE(11404), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352735] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17215), 1,
      anon_sym_RPAREN,
    STATE(11405), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352766] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17217), 1,
      anon_sym_struct,
    STATE(11406), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352797] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17219), 1,
      sym__dedent,
    STATE(11407), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352828] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17221), 1,
      sym__indent,
    STATE(11408), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352859] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17223), 1,
      sym_identifier,
    STATE(11409), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352890] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17225), 1,
      anon_sym_LT2,
    STATE(11410), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352921] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17227), 1,
      sym__dedent,
    STATE(11411), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352952] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17229), 1,
      anon_sym_POUNDendif,
    STATE(11412), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [352983] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17231), 1,
      anon_sym_DASH_GT,
    STATE(11413), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353014] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17233), 1,
      sym__dedent,
    STATE(11414), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353045] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17235), 1,
      sym__dedent,
    STATE(11415), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353076] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17237), 1,
      sym__dedent,
    STATE(11416), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353107] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17239), 1,
      sym__indent,
    STATE(11417), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353138] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17241), 1,
      sym_identifier,
    STATE(11418), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353169] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17243), 1,
      sym_identifier,
    STATE(11419), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353200] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17245), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11420), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353231] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17247), 1,
      anon_sym_POUNDendif,
    STATE(11421), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353262] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17249), 1,
      anon_sym_RBRACK,
    STATE(11422), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353293] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17251), 1,
      anon_sym_GT,
    STATE(11423), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353324] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17253), 1,
      sym__indent,
    STATE(11424), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353355] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17255), 1,
      anon_sym_RBRACE,
    STATE(11425), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353386] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17257), 1,
      anon_sym_POUNDendif,
    STATE(11426), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353417] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17259), 1,
      sym__indent,
    STATE(11427), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353448] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17261), 1,
      anon_sym_PIPE_RPAREN,
    STATE(11428), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353479] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17263), 1,
      sym_identifier,
    STATE(11429), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353510] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17265), 1,
      sym__dedent,
    STATE(11430), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353541] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17267), 1,
      anon_sym_GT,
    STATE(11431), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353572] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17269), 1,
      anon_sym_COLON,
    STATE(11432), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353603] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12991), 1,
      anon_sym_GT,
    STATE(11433), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353634] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17271), 1,
      anon_sym_PIPE_RBRACE,
    STATE(11434), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353665] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17273), 1,
      sym_identifier,
    STATE(11435), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353696] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17275), 1,
      anon_sym_POUNDendif,
    STATE(11436), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353727] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17277), 1,
      sym_int,
    STATE(11437), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353758] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17279), 1,
      anon_sym_PIPE_RPAREN,
    STATE(11438), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353789] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17281), 1,
      anon_sym_end,
    STATE(11439), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353820] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17283), 1,
      sym__indent,
    STATE(11440), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353851] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17285), 1,
      anon_sym_PIPE_RBRACE,
    STATE(11441), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353882] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17287), 1,
      anon_sym_RBRACE,
    STATE(11442), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353913] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17289), 1,
      sym_identifier,
    STATE(11443), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353944] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17291), 1,
      sym__dedent,
    STATE(11444), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [353975] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17293), 1,
      anon_sym_GT,
    STATE(11445), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354006] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17295), 1,
      anon_sym_GT,
    STATE(11446), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354037] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17297), 1,
      anon_sym_RBRACK,
    STATE(11447), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354068] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17299), 1,
      sym_identifier,
    STATE(11448), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354099] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17301), 1,
      sym__dedent,
    STATE(11449), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354130] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17303), 1,
      sym_identifier,
    STATE(11450), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354161] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17305), 1,
      sym__indent,
    STATE(11451), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354192] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17307), 1,
      sym_identifier,
    STATE(11452), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354223] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17309), 1,
      anon_sym_LT2,
    STATE(11453), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354254] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17311), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11454), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354285] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17313), 1,
      anon_sym_DASH_GT,
    STATE(11455), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354316] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17315), 1,
      anon_sym_RBRACK,
    STATE(11456), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354347] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17317), 1,
      sym_identifier,
    STATE(11457), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354378] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17319), 1,
      sym_int,
    STATE(11458), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354409] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17321), 1,
      sym__indent,
    STATE(11459), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354440] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17323), 1,
      sym_identifier,
    STATE(11460), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354471] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17325), 1,
      sym_identifier,
    STATE(11461), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354502] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17327), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(11462), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354533] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17329), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(11463), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354564] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17331), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11464), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354595] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17333), 1,
      anon_sym_RBRACK,
    STATE(11465), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354626] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17335), 1,
      sym__indent,
    STATE(11466), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354657] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17337), 1,
      anon_sym_RPAREN,
    STATE(11467), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354688] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17339), 1,
      sym_identifier,
    STATE(11468), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354719] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17341), 1,
      sym__indent,
    STATE(11469), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354750] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17343), 1,
      anon_sym_get,
    STATE(11470), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354781] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17345), 1,
      sym_identifier,
    STATE(11471), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354812] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17343), 1,
      anon_sym_set,
    STATE(11472), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354843] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17347), 1,
      anon_sym_get,
    STATE(11473), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354874] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17347), 1,
      anon_sym_set,
    STATE(11474), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354905] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17349), 1,
      anon_sym_get,
    STATE(11475), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354936] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17349), 1,
      anon_sym_set,
    STATE(11476), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354967] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17351), 1,
      sym_identifier,
    STATE(11477), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [354998] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17353), 1,
      anon_sym_EQ,
    STATE(11478), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355029] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17355), 1,
      anon_sym_get,
    STATE(11479), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355060] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17355), 1,
      anon_sym_set,
    STATE(11480), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355091] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17357), 1,
      anon_sym_RPAREN,
    STATE(11481), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355122] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17359), 1,
      sym__indent,
    STATE(11482), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355153] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17361), 1,
      anon_sym_struct,
    STATE(11483), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355184] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17363), 1,
      anon_sym_POUNDendif,
    STATE(11484), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355215] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17365), 1,
      sym_identifier,
    STATE(11485), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355246] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17367), 1,
      sym__indent,
    STATE(11486), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355277] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17369), 1,
      sym__dedent,
    STATE(11487), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355308] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17371), 1,
      sym_identifier,
    STATE(11488), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355339] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17373), 1,
      sym_identifier,
    STATE(11489), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355370] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17375), 1,
      sym_identifier,
    STATE(11490), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355401] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17377), 1,
      sym__dedent,
    STATE(11491), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355432] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17379), 1,
      anon_sym_POUNDendif,
    STATE(11492), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355463] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17381), 1,
      sym__indent,
    STATE(11493), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355494] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17383), 1,
      sym_identifier,
    STATE(11494), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355525] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17385), 1,
      anon_sym_LT2,
    STATE(11495), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355556] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17387), 1,
      anon_sym_GT,
    STATE(11496), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355587] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17389), 1,
      anon_sym_DASH_GT,
    STATE(11497), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355618] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17391), 1,
      anon_sym_RBRACE,
    STATE(11498), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355649] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17393), 1,
      anon_sym_POUNDendif,
    STATE(11499), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355680] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17395), 1,
      anon_sym_PIPE_RPAREN,
    STATE(11500), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355711] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17397), 1,
      sym__indent,
    STATE(11501), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355742] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17399), 1,
      sym_identifier,
    STATE(11502), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355773] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17401), 1,
      sym_identifier,
    STATE(11503), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355804] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17403), 1,
      sym__dedent,
    STATE(11504), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355835] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17405), 1,
      anon_sym_GT,
    STATE(11505), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355866] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17407), 1,
      anon_sym_COLON,
    STATE(11506), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355897] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12735), 1,
      anon_sym_GT,
    STATE(11507), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355928] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17409), 1,
      sym__indent,
    STATE(11508), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355959] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17411), 1,
      anon_sym_PIPE_RBRACE,
    STATE(11509), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [355990] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17413), 1,
      anon_sym_POUNDendif,
    STATE(11510), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356021] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17415), 1,
      sym__indent,
    STATE(11511), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356052] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17417), 1,
      sym_int,
    STATE(11512), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356083] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17419), 1,
      sym_identifier,
    STATE(11513), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356114] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17421), 1,
      anon_sym_PIPE_RPAREN,
    STATE(11514), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356145] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17423), 1,
      sym__indent,
    STATE(11515), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356176] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17425), 1,
      anon_sym_end,
    STATE(11516), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356207] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17427), 1,
      anon_sym_PIPE_RBRACE,
    STATE(11517), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356238] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17429), 1,
      anon_sym_RBRACE,
    STATE(11518), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356269] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17431), 1,
      sym_identifier,
    STATE(11519), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356300] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17433), 1,
      sym_identifier,
    STATE(11520), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356331] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17435), 1,
      anon_sym_and,
    STATE(11521), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356362] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17437), 1,
      anon_sym_GT,
    STATE(11522), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356393] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17439), 1,
      anon_sym_RPAREN,
    STATE(11523), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356424] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17441), 1,
      sym__indent,
    STATE(11524), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356455] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17443), 1,
      anon_sym_GT,
    STATE(11525), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356486] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17445), 1,
      anon_sym_RBRACK,
    STATE(11526), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356517] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17447), 1,
      sym_identifier,
    STATE(11527), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356548] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17449), 1,
      sym__indent,
    STATE(11528), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356579] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17451), 1,
      sym__dedent,
    STATE(11529), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356610] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17453), 1,
      sym_identifier,
    STATE(11530), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356641] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17455), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11531), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356672] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17457), 1,
      sym_identifier,
    STATE(11532), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356703] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17459), 1,
      anon_sym_RBRACK,
    STATE(11533), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356734] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17461), 1,
      sym_identifier,
    STATE(11534), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356765] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17463), 1,
      sym__indent,
    STATE(11535), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356796] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17465), 1,
      sym_identifier,
    STATE(11536), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356827] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17467), 1,
      anon_sym_LT2,
    STATE(11537), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356858] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17469), 1,
      sym_int,
    STATE(11538), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356889] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17471), 1,
      anon_sym_DASH_GT,
    STATE(11539), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356920] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17473), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(11540), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356951] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17475), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(11541), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [356982] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17477), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11542), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357013] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17479), 1,
      sym__indent,
    STATE(11543), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357044] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17481), 1,
      sym_identifier,
    STATE(11544), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357075] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17483), 1,
      sym_identifier,
    STATE(11545), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357106] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17485), 1,
      sym_identifier,
    STATE(11546), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357137] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17487), 1,
      anon_sym_RBRACK,
    STATE(11547), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357168] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17489), 1,
      anon_sym_RPAREN,
    STATE(11548), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357199] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17491), 1,
      sym__newline_not_aligned,
    STATE(11549), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357230] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17493), 1,
      sym__indent,
    STATE(11550), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357261] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17495), 1,
      sym_identifier,
    STATE(11551), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357292] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4168), 1,
      sym__newline_not_aligned,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(11552), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357323] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17497), 1,
      sym__indent,
    STATE(11553), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357354] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17499), 1,
      anon_sym_get,
    STATE(11554), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357385] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17501), 1,
      sym_identifier,
    STATE(11555), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357416] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17499), 1,
      anon_sym_set,
    STATE(11556), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357447] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17503), 1,
      anon_sym_get,
    STATE(11557), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357478] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17503), 1,
      anon_sym_set,
    STATE(11558), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357509] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17505), 1,
      anon_sym_get,
    STATE(11559), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357540] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17505), 1,
      anon_sym_set,
    STATE(11560), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357571] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17507), 1,
      sym_identifier,
    STATE(11561), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357602] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17509), 1,
      anon_sym_get,
    STATE(11562), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357633] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17509), 1,
      anon_sym_set,
    STATE(11563), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357664] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17511), 1,
      anon_sym_RPAREN,
    STATE(11564), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357695] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17513), 1,
      anon_sym_struct,
    STATE(11565), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357726] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17515), 1,
      sym__indent,
    STATE(11566), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357757] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17517), 1,
      anon_sym_POUNDendif,
    STATE(11567), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357788] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17519), 1,
      sym__dedent,
    STATE(11568), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357819] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17521), 1,
      sym_identifier,
    STATE(11569), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357850] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17523), 1,
      sym__dedent,
    STATE(11570), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357881] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17525), 1,
      sym__dedent,
    STATE(11571), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357912] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17527), 1,
      anon_sym_POUNDendif,
    STATE(11572), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357943] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17529), 1,
      sym_identifier,
    STATE(11573), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [357974] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17531), 1,
      anon_sym_GT,
    STATE(11574), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358005] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17533), 1,
      anon_sym_RBRACE,
    STATE(11575), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358036] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17535), 1,
      sym__indent,
    STATE(11576), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358067] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17537), 1,
      sym_identifier,
    STATE(11577), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358098] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17539), 1,
      anon_sym_LT2,
    STATE(11578), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358129] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17541), 1,
      anon_sym_POUNDendif,
    STATE(11579), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358160] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17543), 1,
      anon_sym_DASH_GT,
    STATE(11580), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358191] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17545), 1,
      anon_sym_PIPE_RPAREN,
    STATE(11581), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358222] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17547), 1,
      sym__dedent,
    STATE(11582), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358253] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17549), 1,
      anon_sym_GT,
    STATE(11583), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358284] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17551), 1,
      sym__indent,
    STATE(11584), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358315] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17553), 1,
      sym_identifier,
    STATE(11585), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358346] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17555), 1,
      sym_identifier,
    STATE(11586), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358377] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17557), 1,
      anon_sym_COLON,
    STATE(11587), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358408] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12857), 1,
      anon_sym_GT,
    STATE(11588), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358439] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17559), 1,
      anon_sym_PIPE_RBRACE,
    STATE(11589), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358470] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17561), 1,
      anon_sym_POUNDendif,
    STATE(11590), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358501] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17563), 1,
      sym__indent,
    STATE(11591), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358532] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17565), 1,
      sym_int,
    STATE(11592), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358563] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17567), 1,
      anon_sym_PIPE_RPAREN,
    STATE(11593), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358594] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17569), 1,
      anon_sym_end,
    STATE(11594), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358625] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17571), 1,
      anon_sym_PIPE_RBRACE,
    STATE(11595), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358656] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17573), 1,
      anon_sym_RBRACE,
    STATE(11596), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358687] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17575), 1,
      sym_identifier,
    STATE(11597), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358718] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17577), 1,
      anon_sym_GT,
    STATE(11598), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358749] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17579), 1,
      anon_sym_RPAREN,
    STATE(11599), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358780] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17581), 1,
      sym_identifier,
    STATE(11600), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358811] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17583), 1,
      anon_sym_GT,
    STATE(11601), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358842] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17585), 1,
      sym__indent,
    STATE(11602), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358873] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17587), 1,
      anon_sym_RBRACK,
    STATE(11603), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358904] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17589), 1,
      sym__dedent,
    STATE(11604), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358935] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17591), 1,
      sym__indent,
    STATE(11605), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358966] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17593), 1,
      sym__newline_not_aligned,
    STATE(11606), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [358997] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17595), 1,
      sym_identifier,
    STATE(11607), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359028] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17597), 1,
      sym_identifier,
    STATE(11608), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359059] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17599), 1,
      sym__indent,
    STATE(11609), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359090] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17601), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11610), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359121] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17603), 1,
      sym__newline_not_aligned,
    STATE(11611), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359152] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17605), 1,
      anon_sym_RBRACK,
    STATE(11612), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359183] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17607), 1,
      sym_identifier,
    STATE(11613), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359214] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17609), 1,
      anon_sym_RBRACE,
    STATE(11614), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359245] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17611), 1,
      sym_int,
    STATE(11615), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359276] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17613), 1,
      sym__indent,
    STATE(11616), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359307] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17615), 1,
      sym_identifier,
    STATE(11617), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359338] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17617), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(11618), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359369] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17619), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(11619), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359400] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17621), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11620), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359431] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17623), 1,
      sym__indent,
    STATE(11621), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359462] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17625), 1,
      sym_identifier,
    STATE(11622), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359493] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17627), 1,
      sym_identifier,
    STATE(11623), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359524] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4973), 1,
      anon_sym_POUNDendif,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(11624), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359555] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3974), 1,
      sym__newline_not_aligned,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(11625), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359586] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6386), 1,
      anon_sym_POUNDendif,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(11626), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359617] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17629), 1,
      anon_sym_RBRACK,
    STATE(11627), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359648] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17631), 1,
      sym__indent,
    STATE(11628), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359679] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17633), 1,
      anon_sym_RPAREN,
    STATE(11629), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359710] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4062), 1,
      sym__newline_not_aligned,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(11630), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359741] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17635), 1,
      sym_identifier,
    STATE(11631), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359772] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17637), 1,
      anon_sym_get,
    STATE(11632), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359803] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17637), 1,
      anon_sym_set,
    STATE(11633), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359834] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17639), 1,
      anon_sym_get,
    STATE(11634), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359865] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17639), 1,
      anon_sym_set,
    STATE(11635), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359896] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17641), 1,
      anon_sym_get,
    STATE(11636), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359927] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17643), 1,
      sym_identifier,
    STATE(11637), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359958] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17641), 1,
      anon_sym_set,
    STATE(11638), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [359989] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17645), 1,
      anon_sym_get,
    STATE(11639), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360020] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17645), 1,
      anon_sym_set,
    STATE(11640), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360051] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17647), 1,
      anon_sym_RPAREN,
    STATE(11641), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360082] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17649), 1,
      sym__indent,
    STATE(11642), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360113] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3698), 1,
      anon_sym_RPAREN,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(11643), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360144] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17651), 1,
      anon_sym_struct,
    STATE(11644), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360175] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17653), 1,
      sym_identifier,
    STATE(11645), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360206] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17655), 1,
      anon_sym_POUNDendif,
    STATE(11646), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360237] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17657), 1,
      sym__dedent,
    STATE(11647), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360268] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17659), 1,
      sym__dedent,
    STATE(11648), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360299] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17661), 1,
      sym_identifier,
    STATE(11649), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360330] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17663), 1,
      sym__dedent,
    STATE(11650), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360361] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17665), 1,
      anon_sym_POUNDendif,
    STATE(11651), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360392] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17667), 1,
      sym__indent,
    STATE(11652), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360423] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17669), 1,
      sym_identifier,
    STATE(11653), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360454] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17671), 1,
      anon_sym_GT,
    STATE(11654), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360485] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(17673), 1,
      aux_sym_fsi_directive_decl_token1,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(11655), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360514] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17675), 1,
      anon_sym_POUNDendif,
    STATE(11656), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360545] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17677), 1,
      sym__indent,
    STATE(11657), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360576] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17679), 1,
      sym_identifier,
    STATE(11658), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360607] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17681), 1,
      sym_identifier,
    STATE(11659), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360638] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17683), 1,
      anon_sym_PIPE_RPAREN,
    STATE(11660), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360669] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17685), 1,
      sym__dedent,
    STATE(11661), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360700] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17687), 1,
      anon_sym_GT,
    STATE(11662), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360731] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17689), 1,
      anon_sym_COLON,
    STATE(11663), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360762] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17691), 1,
      sym__indent,
    STATE(11664), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360793] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12973), 1,
      anon_sym_GT,
    STATE(11665), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360824] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17693), 1,
      anon_sym_PIPE_RBRACE,
    STATE(11666), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360855] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17695), 1,
      sym__indent,
    STATE(11667), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360886] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17697), 1,
      anon_sym_POUNDendif,
    STATE(11668), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360917] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17699), 1,
      sym_int,
    STATE(11669), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360948] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17701), 1,
      anon_sym_PIPE_RPAREN,
    STATE(11670), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [360979] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17703), 1,
      anon_sym_end,
    STATE(11671), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361010] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17705), 1,
      anon_sym_PIPE_RBRACE,
    STATE(11672), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361041] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17707), 1,
      anon_sym_RBRACE,
    STATE(11673), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361072] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17709), 1,
      sym_identifier,
    STATE(11674), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361103] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17711), 1,
      anon_sym_GT,
    STATE(11675), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361134] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17713), 1,
      anon_sym_RPAREN,
    STATE(11676), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361165] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17715), 1,
      sym__indent,
    STATE(11677), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361196] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17717), 1,
      sym_identifier,
    STATE(11678), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361227] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17719), 1,
      sym_identifier,
    STATE(11679), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361258] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17721), 1,
      anon_sym_GT,
    STATE(11680), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361289] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17723), 1,
      anon_sym_RBRACK,
    STATE(11681), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361320] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17725), 1,
      sym__dedent,
    STATE(11682), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361351] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17727), 1,
      sym_identifier,
    STATE(11683), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361382] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17729), 1,
      sym__indent,
    STATE(11684), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361413] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17731), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11685), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361444] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17733), 1,
      anon_sym_RBRACK,
    STATE(11686), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361475] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17735), 1,
      sym__newline_not_aligned,
    STATE(11687), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361506] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17737), 1,
      sym_identifier,
    STATE(11688), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361537] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17739), 1,
      sym_int,
    STATE(11689), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361568] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17741), 1,
      sym_identifier,
    STATE(11690), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361599] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17743), 1,
      sym_int,
    STATE(11691), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361630] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17745), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(11692), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361661] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17747), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(11693), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361692] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17749), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(11694), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361723] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17751), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11695), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361754] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17753), 1,
      sym__indent,
    STATE(11696), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361785] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17755), 1,
      sym_identifier,
    STATE(11697), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361816] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17757), 1,
      sym_identifier,
    STATE(11698), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361847] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17759), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(11699), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361878] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17761), 1,
      anon_sym_RBRACK,
    STATE(11700), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361909] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17763), 1,
      anon_sym_RPAREN,
    STATE(11701), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361940] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17765), 1,
      sym_identifier,
    STATE(11702), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [361971] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17767), 1,
      sym__indent,
    STATE(11703), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362002] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17769), 1,
      anon_sym_POUNDendif,
    STATE(11704), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362033] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17771), 1,
      anon_sym_get,
    STATE(11705), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362064] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17771), 1,
      anon_sym_set,
    STATE(11706), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362095] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17773), 1,
      sym__dedent,
    STATE(11707), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362126] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17775), 1,
      anon_sym_get,
    STATE(11708), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362157] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17775), 1,
      anon_sym_set,
    STATE(11709), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362188] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17777), 1,
      anon_sym_get,
    STATE(11710), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362219] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17777), 1,
      anon_sym_set,
    STATE(11711), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362250] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8542), 1,
      sym__dedent,
    STATE(11712), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362281] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17779), 1,
      anon_sym_get,
    STATE(11713), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362312] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17779), 1,
      anon_sym_set,
    STATE(11714), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362343] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17781), 1,
      sym__indent,
    STATE(11715), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362374] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17783), 1,
      sym_identifier,
    STATE(11716), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362405] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17785), 1,
      sym_identifier,
    STATE(11717), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362436] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17787), 1,
      anon_sym_RPAREN,
    STATE(11718), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362467] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17789), 1,
      anon_sym_of,
    STATE(11719), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362498] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17791), 1,
      anon_sym_EQ,
    STATE(11720), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362529] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17793), 1,
      anon_sym_end,
    STATE(11721), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362560] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17795), 1,
      sym__indent,
    STATE(11722), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362591] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17797), 1,
      anon_sym_struct,
    STATE(11723), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362622] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17799), 1,
      sym__dedent,
    STATE(11724), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362653] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17801), 1,
      anon_sym_end,
    STATE(11725), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362684] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17803), 1,
      anon_sym_POUNDendif,
    STATE(11726), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362715] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17805), 1,
      anon_sym_DASH_GT,
    STATE(11727), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362746] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17807), 1,
      sym__dedent,
    STATE(11728), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362777] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17809), 1,
      sym__dedent,
    STATE(11729), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362808] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17811), 1,
      anon_sym_then,
    STATE(11730), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362839] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17813), 1,
      anon_sym_end,
    STATE(11731), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362870] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17815), 1,
      anon_sym_end,
    STATE(11732), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362901] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17817), 1,
      sym__indent,
    STATE(11733), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362932] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17819), 1,
      sym_identifier,
    STATE(11734), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362963] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17821), 1,
      sym_identifier,
    STATE(11735), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [362994] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17823), 1,
      sym__dedent,
    STATE(11736), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363025] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17825), 1,
      sym__dedent,
    STATE(11737), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363056] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17827), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11738), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363087] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17829), 1,
      anon_sym_RBRACK,
    STATE(11739), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363118] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17831), 1,
      sym__indent,
    STATE(11740), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363149] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17833), 1,
      sym__dedent,
    STATE(11741), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363180] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17835), 1,
      anon_sym_PIPE_RBRACE,
    STATE(11742), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363211] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17837), 1,
      anon_sym_RPAREN,
    STATE(11743), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363242] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17839), 1,
      sym_identifier,
    STATE(11744), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363273] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17841), 1,
      anon_sym_end,
    STATE(11745), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363304] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8536), 1,
      sym__dedent,
    STATE(11746), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363335] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17843), 1,
      anon_sym_GT,
    STATE(11747), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363366] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17845), 1,
      sym__dedent,
    STATE(11748), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363397] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17847), 1,
      anon_sym_RBRACE,
    STATE(11749), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363428] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17849), 1,
      anon_sym_POUNDendif,
    STATE(11750), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363459] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17851), 1,
      sym__indent,
    STATE(11751), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363490] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17853), 1,
      sym_identifier,
    STATE(11752), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363521] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17855), 1,
      sym_identifier,
    STATE(11753), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363552] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17857), 1,
      anon_sym_POUNDendif,
    STATE(11754), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363583] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17859), 1,
      anon_sym_PIPE_RPAREN,
    STATE(11755), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363614] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17861), 1,
      sym__dedent,
    STATE(11756), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363645] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17863), 1,
      anon_sym_GT,
    STATE(11757), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363676] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17865), 1,
      sym__indent,
    STATE(11758), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363707] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17867), 1,
      anon_sym_COLON,
    STATE(11759), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363738] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17869), 1,
      sym__dedent,
    STATE(11760), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363769] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17871), 1,
      sym__dedent,
    STATE(11761), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363800] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17873), 1,
      sym__dedent,
    STATE(11762), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363831] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(13043), 1,
      anon_sym_GT,
    STATE(11763), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363862] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17875), 1,
      anon_sym_PIPE_RBRACE,
    STATE(11764), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363893] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17877), 1,
      sym__dedent,
    STATE(11765), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363924] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17879), 1,
      sym_identifier,
    STATE(11766), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363955] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17881), 1,
      anon_sym_POUNDendif,
    STATE(11767), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [363986] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17883), 1,
      sym_int,
    STATE(11768), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364017] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17885), 1,
      anon_sym_PIPE_RPAREN,
    STATE(11769), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364048] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17887), 1,
      anon_sym_end,
    STATE(11770), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364079] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17889), 1,
      sym_identifier,
    STATE(11771), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364110] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(17891), 1,
      aux_sym_fsi_directive_decl_token1,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(11772), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364139] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17893), 1,
      anon_sym_RBRACE,
    STATE(11773), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364170] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17895), 1,
      sym_identifier,
    STATE(11774), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364201] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17897), 1,
      sym_identifier,
    STATE(11775), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364232] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17899), 1,
      sym_identifier,
    STATE(11776), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364263] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17901), 1,
      anon_sym_GT,
    STATE(11777), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364294] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17903), 1,
      anon_sym_RPAREN,
    STATE(11778), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364325] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17905), 1,
      sym_identifier,
    STATE(11779), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364356] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17907), 1,
      anon_sym_GT,
    STATE(11780), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364387] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17909), 1,
      anon_sym_RBRACK,
    STATE(11781), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364418] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17911), 1,
      sym_identifier,
    STATE(11782), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364449] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17913), 1,
      sym__dedent,
    STATE(11783), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364480] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17915), 1,
      sym_identifier,
    STATE(11784), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364511] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17917), 1,
      sym_identifier,
    STATE(11785), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364542] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17919), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11786), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364573] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17921), 1,
      anon_sym_RBRACK,
    STATE(11787), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364604] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17923), 1,
      sym_identifier,
    STATE(11788), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364635] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17925), 1,
      sym_identifier,
    STATE(11789), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364666] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17927), 1,
      sym_int,
    STATE(11790), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364697] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17929), 1,
      sym_identifier,
    STATE(11791), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364728] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17931), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(11792), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364759] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17933), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(11793), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364790] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17935), 1,
      sym_identifier,
    STATE(11794), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364821] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17937), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11795), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364852] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17939), 1,
      anon_sym_RBRACK,
    STATE(11796), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364883] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17941), 1,
      anon_sym_RPAREN,
    STATE(11797), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364914] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17943), 1,
      sym_identifier,
    STATE(11798), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364945] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17945), 1,
      sym_identifier,
    STATE(11799), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [364976] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17947), 1,
      anon_sym_get,
    STATE(11800), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365007] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17947), 1,
      anon_sym_set,
    STATE(11801), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365038] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17949), 1,
      sym__dedent,
    STATE(11802), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365069] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17951), 1,
      anon_sym_get,
    STATE(11803), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365100] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17951), 1,
      anon_sym_set,
    STATE(11804), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365131] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17953), 1,
      anon_sym_get,
    STATE(11805), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365162] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17953), 1,
      anon_sym_set,
    STATE(11806), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365193] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8548), 1,
      sym__dedent,
    STATE(11807), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365224] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17955), 1,
      anon_sym_get,
    STATE(11808), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365255] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17955), 1,
      anon_sym_set,
    STATE(11809), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365286] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17957), 1,
      anon_sym_RPAREN,
    STATE(11810), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365317] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17959), 1,
      anon_sym_end,
    STATE(11811), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365348] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17961), 1,
      anon_sym_struct,
    STATE(11812), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365379] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17963), 1,
      sym__dedent,
    STATE(11813), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365410] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17965), 1,
      anon_sym_end,
    STATE(11814), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365441] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17967), 1,
      anon_sym_POUNDendif,
    STATE(11815), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365472] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17969), 1,
      sym__dedent,
    STATE(11816), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365503] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17971), 1,
      sym__dedent,
    STATE(11817), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365534] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17973), 1,
      anon_sym_end,
    STATE(11818), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365565] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17975), 1,
      anon_sym_end,
    STATE(11819), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365596] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17977), 1,
      sym__dedent,
    STATE(11820), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365627] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17979), 1,
      sym__dedent,
    STATE(11821), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365658] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17981), 1,
      sym__dedent,
    STATE(11822), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365689] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17983), 1,
      anon_sym_POUNDendif,
    STATE(11823), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365720] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17985), 1,
      anon_sym_end,
    STATE(11824), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365751] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8540), 1,
      sym__dedent,
    STATE(11825), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365782] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17987), 1,
      anon_sym_GT,
    STATE(11826), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365813] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17989), 1,
      sym__dedent,
    STATE(11827), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365844] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17991), 1,
      anon_sym_RBRACE,
    STATE(11828), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365875] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17993), 1,
      anon_sym_POUNDendif,
    STATE(11829), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365906] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17995), 1,
      anon_sym_POUNDendif,
    STATE(11830), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365937] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17997), 1,
      anon_sym_PIPE_RPAREN,
    STATE(11831), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365968] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(17999), 1,
      sym__dedent,
    STATE(11832), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [365999] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18001), 1,
      sym__indent,
    STATE(11833), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366030] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18003), 1,
      sym__indent,
    STATE(11834), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366061] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18005), 1,
      anon_sym_GT,
    STATE(11835), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366092] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18007), 1,
      sym__indent,
    STATE(11836), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366123] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18009), 1,
      sym__indent,
    STATE(11837), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366154] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18011), 1,
      anon_sym_COLON,
    STATE(11838), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366185] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18013), 1,
      sym__dedent,
    STATE(11839), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366216] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18015), 1,
      sym__dedent,
    STATE(11840), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366247] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18017), 1,
      sym__dedent,
    STATE(11841), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366278] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12929), 1,
      anon_sym_GT,
    STATE(11842), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366309] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18019), 1,
      anon_sym_EQ,
    STATE(11843), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366340] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18021), 1,
      anon_sym_PIPE_RBRACE,
    STATE(11844), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366371] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18023), 1,
      sym_identifier,
    STATE(11845), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366402] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18025), 1,
      sym__dedent,
    STATE(11846), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366433] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18027), 1,
      sym__indent,
    STATE(11847), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366464] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18029), 1,
      anon_sym_POUNDendif,
    STATE(11848), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366495] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18031), 1,
      sym_int,
    STATE(11849), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366526] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18033), 1,
      anon_sym_PIPE_RPAREN,
    STATE(11850), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366557] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18035), 1,
      anon_sym_end,
    STATE(11851), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366588] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18037), 1,
      sym_identifier,
    STATE(11852), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366619] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18039), 1,
      anon_sym_PIPE_RBRACE,
    STATE(11853), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366650] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18041), 1,
      anon_sym_RBRACE,
    STATE(11854), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366681] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18043), 1,
      sym_identifier,
    STATE(11855), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366712] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18045), 1,
      anon_sym_unit,
    STATE(11856), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366743] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18047), 1,
      anon_sym_GT,
    STATE(11857), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366774] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18049), 1,
      anon_sym_RPAREN,
    STATE(11858), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366805] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18051), 1,
      anon_sym_GT,
    STATE(11859), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366836] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18053), 1,
      anon_sym_RBRACK,
    STATE(11860), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366867] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18055), 1,
      sym__dedent,
    STATE(11861), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366898] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18057), 1,
      anon_sym_new,
    STATE(11862), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366929] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18059), 1,
      sym__indent,
    STATE(11863), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366960] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18061), 1,
      sym__indent,
    STATE(11864), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [366991] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18063), 1,
      sym_identifier,
    STATE(11865), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367022] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18065), 1,
      sym__indent,
    STATE(11866), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367053] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18067), 1,
      sym__indent,
    STATE(11867), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367084] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18069), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11868), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367115] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18071), 1,
      anon_sym_RBRACK,
    STATE(11869), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367146] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(18073), 1,
      aux_sym_fsi_directive_decl_token1,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(11870), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367175] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18075), 1,
      anon_sym_EQ,
    STATE(11871), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367206] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18077), 1,
      sym_identifier,
    STATE(11872), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367237] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18079), 1,
      sym_int,
    STATE(11873), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367268] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18081), 1,
      sym__indent,
    STATE(11874), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367299] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18083), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(11875), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367330] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18085), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(11876), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367361] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18087), 1,
      sym_identifier,
    STATE(11877), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367392] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18089), 1,
      anon_sym_PIPE_RBRACK,
    STATE(11878), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367423] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18091), 1,
      anon_sym_RBRACK,
    STATE(11879), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367454] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18093), 1,
      anon_sym_RPAREN,
    STATE(11880), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367485] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18095), 1,
      anon_sym_unit,
    STATE(11881), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367516] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18097), 1,
      anon_sym_new,
    STATE(11882), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367547] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18099), 1,
      sym__indent,
    STATE(11883), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367578] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18101), 1,
      sym__indent,
    STATE(11884), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367609] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18103), 1,
      sym_identifier,
    STATE(11885), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367640] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18105), 1,
      sym__indent,
    STATE(11886), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367671] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18107), 1,
      sym__indent,
    STATE(11887), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367702] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18109), 1,
      sym__dedent,
    STATE(11888), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367733] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(4076), 1,
      aux_sym_fsi_directive_decl_token1,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(11889), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367762] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(4168), 1,
      aux_sym_fsi_directive_decl_token1,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(11890), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367791] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18111), 1,
      anon_sym_EQ,
    STATE(11891), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367822] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18113), 1,
      sym_identifier,
    STATE(11892), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367853] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3698), 1,
      anon_sym_then,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(11893), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367884] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18115), 1,
      sym__indent,
    STATE(11894), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367915] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18117), 1,
      anon_sym_get,
    STATE(11895), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367946] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18117), 1,
      anon_sym_set,
    STATE(11896), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [367977] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18119), 1,
      sym_identifier,
    STATE(11897), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368008] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18121), 1,
      sym__dedent,
    STATE(11898), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368039] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18123), 1,
      anon_sym_get,
    STATE(11899), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368070] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18123), 1,
      anon_sym_set,
    STATE(11900), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368101] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18125), 1,
      anon_sym_unit,
    STATE(11901), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368132] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18127), 1,
      anon_sym_new,
    STATE(11902), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368163] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18129), 1,
      sym__indent,
    STATE(11903), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368194] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18131), 1,
      sym__indent,
    STATE(11904), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368225] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18133), 1,
      anon_sym_get,
    STATE(11905), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368256] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18135), 1,
      sym__indent,
    STATE(11906), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368287] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18137), 1,
      sym__indent,
    STATE(11907), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368318] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18133), 1,
      anon_sym_set,
    STATE(11908), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368349] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18139), 1,
      anon_sym_COLON,
    STATE(11909), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368380] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8550), 1,
      sym__dedent,
    STATE(11910), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368411] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18141), 1,
      anon_sym_unit,
    STATE(11911), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368442] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18143), 1,
      anon_sym_new,
    STATE(11912), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368473] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18145), 1,
      sym__indent,
    STATE(11913), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368504] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18147), 1,
      sym__indent,
    STATE(11914), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368535] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18149), 1,
      anon_sym_get,
    STATE(11915), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368566] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18151), 1,
      sym__indent,
    STATE(11916), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368597] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18153), 1,
      sym__indent,
    STATE(11917), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368628] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18149), 1,
      anon_sym_set,
    STATE(11918), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368659] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18155), 1,
      sym_identifier,
    STATE(11919), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368690] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18157), 1,
      anon_sym_RPAREN,
    STATE(11920), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368721] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18159), 1,
      anon_sym_unit,
    STATE(11921), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368752] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14427), 1,
      anon_sym_new,
    STATE(11922), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368783] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18161), 1,
      sym__indent,
    STATE(11923), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368814] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18163), 1,
      sym__indent,
    STATE(11924), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368845] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18165), 1,
      anon_sym_end,
    STATE(11925), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368876] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18167), 1,
      sym__indent,
    STATE(11926), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368907] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18169), 1,
      sym__indent,
    STATE(11927), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368938] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18171), 1,
      anon_sym_struct,
    STATE(11928), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [368969] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18173), 1,
      sym__indent,
    STATE(11929), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369000] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18175), 1,
      sym__dedent,
    STATE(11930), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369031] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18177), 1,
      anon_sym_unit,
    STATE(11931), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369062] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14513), 1,
      anon_sym_new,
    STATE(11932), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369093] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18179), 1,
      sym__indent,
    STATE(11933), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369124] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18181), 1,
      sym__indent,
    STATE(11934), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369155] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18183), 1,
      anon_sym_end,
    STATE(11935), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369186] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18185), 1,
      sym__indent,
    STATE(11936), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369217] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18187), 1,
      sym__indent,
    STATE(11937), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369248] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18189), 1,
      anon_sym_POUNDendif,
    STATE(11938), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369279] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18191), 1,
      sym__dedent,
    STATE(11939), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369310] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18193), 1,
      sym__dedent,
    STATE(11940), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369341] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18195), 1,
      anon_sym_unit,
    STATE(11941), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369372] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(14561), 1,
      anon_sym_new,
    STATE(11942), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369403] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18197), 1,
      sym__indent,
    STATE(11943), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369434] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18199), 1,
      sym__indent,
    STATE(11944), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369465] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18201), 1,
      anon_sym_COLON,
    STATE(11945), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369496] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18203), 1,
      sym__indent,
    STATE(11946), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369527] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18205), 1,
      sym__indent,
    STATE(11947), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369558] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18207), 1,
      anon_sym_end,
    STATE(11948), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369589] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18209), 1,
      anon_sym_end,
    STATE(11949), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369620] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18211), 1,
      sym__indent,
    STATE(11950), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369651] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18213), 1,
      sym__indent,
    STATE(11951), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369682] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18215), 1,
      sym__dedent,
    STATE(11952), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369713] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18217), 1,
      sym__indent,
    STATE(11953), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369744] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18219), 1,
      sym__indent,
    STATE(11954), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369775] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18221), 1,
      sym__dedent,
    STATE(11955), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369806] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18223), 1,
      anon_sym_COLON,
    STATE(11956), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369837] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18225), 1,
      sym__indent,
    STATE(11957), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369868] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18227), 1,
      sym__indent,
    STATE(11958), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369899] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18229), 1,
      anon_sym_POUNDendif,
    STATE(11959), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369930] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18231), 1,
      sym__indent,
    STATE(11960), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369961] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18233), 1,
      sym__indent,
    STATE(11961), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [369992] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18235), 1,
      anon_sym_end,
    STATE(11962), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370023] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8597), 1,
      sym__dedent,
    STATE(11963), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370054] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18237), 1,
      sym__indent,
    STATE(11964), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370085] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18239), 1,
      sym__indent,
    STATE(11965), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370116] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(18241), 1,
      aux_sym_fsi_directive_decl_token1,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(11966), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370145] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18243), 1,
      sym__indent,
    STATE(11967), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370176] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18245), 1,
      sym__indent,
    STATE(11968), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370207] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18247), 1,
      anon_sym_GT,
    STATE(11969), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370238] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(2690), 1,
      anon_sym_POUNDendif,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(11970), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370269] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18249), 1,
      sym__indent,
    STATE(11971), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370300] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18251), 1,
      sym__indent,
    STATE(11972), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370331] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18253), 1,
      sym__newline_not_aligned,
    STATE(11973), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370362] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18255), 1,
      sym__indent,
    STATE(11974), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370393] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18257), 1,
      sym__indent,
    STATE(11975), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370424] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18259), 1,
      sym__dedent,
    STATE(11976), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370455] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18261), 1,
      anon_sym_RBRACE,
    STATE(11977), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370486] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18263), 1,
      sym__indent,
    STATE(11978), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370517] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18265), 1,
      sym__indent,
    STATE(11979), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370548] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18267), 1,
      anon_sym_STAR_RPAREN,
    STATE(11980), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370579] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18269), 1,
      sym__indent,
    STATE(11981), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370610] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18271), 1,
      sym__indent,
    STATE(11982), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370641] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18273), 1,
      anon_sym_POUNDendif,
    STATE(11983), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370672] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18275), 1,
      sym_block_comment_content,
    STATE(11984), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370703] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18277), 1,
      sym__indent,
    STATE(11985), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370734] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18279), 1,
      sym__indent,
    STATE(11986), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370765] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18281), 1,
      anon_sym_POUNDendif,
    STATE(11987), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370796] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18283), 1,
      sym__indent,
    STATE(11988), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370827] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18285), 1,
      sym__indent,
    STATE(11989), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370858] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18287), 1,
      anon_sym_PIPE_RPAREN,
    STATE(11990), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370889] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18289), 1,
      sym__dedent,
    STATE(11991), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370920] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18291), 1,
      sym__indent,
    STATE(11992), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370951] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18293), 1,
      sym__indent,
    STATE(11993), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [370982] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18295), 1,
      anon_sym_then,
    STATE(11994), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371013] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18297), 1,
      sym__indent,
    STATE(11995), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371044] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18299), 1,
      sym__indent,
    STATE(11996), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371075] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18301), 1,
      anon_sym_GT,
    STATE(11997), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371106] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18303), 1,
      sym_identifier,
    STATE(11998), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371137] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18305), 1,
      sym__indent,
    STATE(11999), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371168] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18307), 1,
      sym_identifier,
    STATE(12000), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371199] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18309), 1,
      sym__indent,
    STATE(12001), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371230] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18311), 1,
      sym__dedent,
    STATE(12002), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371261] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18313), 1,
      sym__indent,
    STATE(12003), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371292] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18315), 1,
      sym__dedent,
    STATE(12004), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371323] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18317), 1,
      sym__indent,
    STATE(12005), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371354] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18319), 1,
      sym__indent,
    STATE(12006), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371385] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18321), 1,
      sym__indent,
    STATE(12007), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371416] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18323), 1,
      sym__indent,
    STATE(12008), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371447] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18325), 1,
      sym__indent,
    STATE(12009), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371478] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18327), 1,
      sym__indent,
    STATE(12010), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371509] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18329), 1,
      sym__indent,
    STATE(12011), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371540] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18331), 1,
      sym__indent,
    STATE(12012), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371571] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18333), 1,
      sym__indent,
    STATE(12013), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371602] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18335), 1,
      sym__indent,
    STATE(12014), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371633] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18337), 1,
      sym__indent,
    STATE(12015), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371664] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18339), 1,
      sym__indent,
    STATE(12016), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371695] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18341), 1,
      sym__indent,
    STATE(12017), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371726] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18343), 1,
      sym__indent,
    STATE(12018), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371757] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18345), 1,
      sym__indent,
    STATE(12019), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371788] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18347), 1,
      sym__indent,
    STATE(12020), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371819] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18349), 1,
      sym__indent,
    STATE(12021), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371850] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18351), 1,
      sym__indent,
    STATE(12022), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371881] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18353), 1,
      sym__indent,
    STATE(12023), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371912] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18355), 1,
      sym__indent,
    STATE(12024), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371943] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18357), 1,
      sym__indent,
    STATE(12025), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [371974] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18359), 1,
      sym__indent,
    STATE(12026), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372005] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18361), 1,
      sym__indent,
    STATE(12027), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372036] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18363), 1,
      sym__indent,
    STATE(12028), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372067] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18365), 1,
      sym__indent,
    STATE(12029), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372098] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18367), 1,
      sym__indent,
    STATE(12030), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372129] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18369), 1,
      sym__indent,
    STATE(12031), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372160] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18371), 1,
      sym__indent,
    STATE(12032), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372191] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18373), 1,
      sym__indent,
    STATE(12033), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372222] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18375), 1,
      sym__indent,
    STATE(12034), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372253] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18377), 1,
      sym__indent,
    STATE(12035), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372284] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18379), 1,
      sym__indent,
    STATE(12036), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372315] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18381), 1,
      sym__indent,
    STATE(12037), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372346] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18383), 1,
      sym__indent,
    STATE(12038), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372377] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18385), 1,
      sym__indent,
    STATE(12039), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372408] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18387), 1,
      sym__indent,
    STATE(12040), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372439] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18389), 1,
      sym__indent,
    STATE(12041), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372470] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18391), 1,
      sym__indent,
    STATE(12042), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372501] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18393), 1,
      sym__indent,
    STATE(12043), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372532] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18395), 1,
      sym__dedent,
    STATE(12044), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372563] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(12785), 1,
      anon_sym_GT,
    STATE(12045), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372594] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18397), 1,
      anon_sym_PIPE_RBRACE,
    STATE(12046), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372625] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18399), 1,
      sym__dedent,
    STATE(12047), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372656] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18401), 1,
      anon_sym_POUNDendif,
    STATE(12048), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372687] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18403), 1,
      sym_int,
    STATE(12049), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372718] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18405), 1,
      anon_sym_PIPE_RPAREN,
    STATE(12050), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372749] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18407), 1,
      anon_sym_end,
    STATE(12051), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372780] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(2563), 1,
      ts_builtin_sym_end,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(12052), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372811] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18409), 1,
      anon_sym_PIPE_RBRACE,
    STATE(12053), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372842] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18411), 1,
      anon_sym_RBRACE,
    STATE(12054), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372873] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18413), 1,
      ts_builtin_sym_end,
    STATE(12055), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372904] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18415), 1,
      sym_identifier,
    STATE(12056), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372935] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18417), 1,
      sym__indent,
    STATE(12057), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372966] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18419), 1,
      sym__indent,
    STATE(12058), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [372997] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18421), 1,
      anon_sym_LT2,
    STATE(12059), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373028] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18423), 1,
      anon_sym_COLON,
    STATE(12060), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373059] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18425), 1,
      sym_identifier,
    STATE(12061), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373090] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18427), 1,
      anon_sym_GT,
    STATE(12062), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373121] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18429), 1,
      sym__indent,
    STATE(12063), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373152] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18431), 1,
      sym__indent,
    STATE(12064), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373183] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18433), 1,
      anon_sym_LT2,
    STATE(12065), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373214] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18435), 1,
      anon_sym_COLON,
    STATE(12066), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373245] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18437), 1,
      sym_identifier,
    STATE(12067), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373276] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18439), 1,
      sym__triple_quoted_content,
    STATE(12068), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373307] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18441), 1,
      sym__indent,
    STATE(12069), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373338] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18443), 1,
      sym__indent,
    STATE(12070), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373369] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18445), 1,
      anon_sym_LT2,
    STATE(12071), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373400] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18447), 1,
      anon_sym_COLON,
    STATE(12072), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373431] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18449), 1,
      sym__triple_quoted_content,
    STATE(12073), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373462] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18451), 1,
      anon_sym_RPAREN,
    STATE(12074), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373493] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18453), 1,
      anon_sym_LT2,
    STATE(12075), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373524] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18455), 1,
      anon_sym_COLON,
    STATE(12076), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373555] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18457), 1,
      anon_sym_GT,
    STATE(12077), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373586] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18459), 1,
      anon_sym_RBRACK,
    STATE(12078), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373617] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18461), 1,
      anon_sym_LT2,
    STATE(12079), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373648] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18463), 1,
      anon_sym_COLON,
    STATE(12080), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373679] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18465), 1,
      sym__dedent,
    STATE(12081), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373710] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18467), 1,
      sym__indent,
    STATE(12082), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373741] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18469), 1,
      anon_sym_LT2,
    STATE(12083), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373772] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18471), 1,
      anon_sym_COLON,
    STATE(12084), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373803] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6821), 1,
      sym__dedent,
    STATE(12085), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373834] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18473), 1,
      sym_identifier,
    STATE(12086), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373865] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18475), 1,
      anon_sym_LT2,
    STATE(12087), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373896] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18477), 1,
      anon_sym_COLON,
    STATE(12088), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373927] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18479), 1,
      sym__indent,
    STATE(12089), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373958] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18481), 1,
      anon_sym_PIPE_RBRACK,
    STATE(12090), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [373989] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18483), 1,
      anon_sym_RBRACK,
    STATE(12091), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [374020] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18485), 1,
      sym_identifier,
    STATE(12092), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [374051] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18487), 1,
      sym__indent,
    STATE(12093), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [374082] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18489), 1,
      sym__indent,
    STATE(12094), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [374113] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18491), 1,
      sym_int,
    STATE(12095), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [374144] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18493), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(12096), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [374175] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18495), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(12097), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [374206] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18497), 1,
      anon_sym_PIPE_RBRACK,
    STATE(12098), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [374237] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18499), 1,
      anon_sym_RBRACK,
    STATE(12099), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [374268] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18501), 1,
      anon_sym_RPAREN,
    STATE(12100), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [374299] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18503), 1,
      sym_identifier,
    STATE(12101), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [374330] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(219), 1,
      sym_line_comment,
    ACTIONS(10612), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(10614), 1,
      anon_sym_POUNDlight,
    ACTIONS(10616), 1,
      anon_sym_POUNDr,
    ACTIONS(18505), 1,
      aux_sym_fsi_directive_decl_token1,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(12102), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [374359] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6950), 1,
      anon_sym_POUNDendif,
    STATE(12103), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [374390] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6943), 1,
      anon_sym_POUNDendif,
    STATE(12104), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [374421] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18507), 1,
      sym_int,
    STATE(12105), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [374452] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6937), 1,
      anon_sym_POUNDendif,
    STATE(12106), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [374483] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18509), 1,
      sym__newline_not_aligned,
    STATE(12107), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [374514] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3698), 1,
      anon_sym_POUNDendif,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(12108), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [374545] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6915), 1,
      anon_sym_POUNDendif,
    STATE(12109), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [374576] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6911), 1,
      anon_sym_POUNDendif,
    STATE(12110), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [374607] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(18511), 1,
      anon_sym_and,
    STATE(12111), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [374638] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6933), 1,
      anon_sym_POUNDendif,
    STATE(12112), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [374669] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6929), 1,
      anon_sym_POUNDendif,
    STATE(12113), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [374700] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6919), 1,
      anon_sym_POUNDendif,
    STATE(12114), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [374731] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6902), 1,
      anon_sym_POUNDendif,
    STATE(12115), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [374762] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6316), 1,
      anon_sym_POUNDendif,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(12116), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [374793] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6300), 1,
      anon_sym_POUNDendif,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(12117), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [374824] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(6386), 1,
      anon_sym_POUNDendif,
    ACTIONS(6614), 1,
      anon_sym_LPAREN_STAR,
    STATE(12118), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [374855] = 1,
    ACTIONS(18513), 1,
      ts_builtin_sym_end,
  [374859] = 1,
    ACTIONS(18515), 1,
      ts_builtin_sym_end,
  [374863] = 1,
    ACTIONS(18517), 1,
      ts_builtin_sym_end,
  [374867] = 1,
    ACTIONS(6902), 1,
      ts_builtin_sym_end,
  [374871] = 1,
    ACTIONS(18519), 1,
      ts_builtin_sym_end,
  [374875] = 1,
    ACTIONS(18521), 1,
      ts_builtin_sym_end,
  [374879] = 1,
    ACTIONS(18523), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(4301)] = 0,
  [SMALL_STATE(4302)] = 127,
  [SMALL_STATE(4303)] = 258,
  [SMALL_STATE(4304)] = 389,
  [SMALL_STATE(4305)] = 514,
  [SMALL_STATE(4306)] = 642,
  [SMALL_STATE(4307)] = 767,
  [SMALL_STATE(4308)] = 892,
  [SMALL_STATE(4309)] = 1017,
  [SMALL_STATE(4310)] = 1142,
  [SMALL_STATE(4311)] = 1267,
  [SMALL_STATE(4312)] = 1392,
  [SMALL_STATE(4313)] = 1517,
  [SMALL_STATE(4314)] = 1642,
  [SMALL_STATE(4315)] = 1767,
  [SMALL_STATE(4316)] = 1892,
  [SMALL_STATE(4317)] = 2017,
  [SMALL_STATE(4318)] = 2142,
  [SMALL_STATE(4319)] = 2267,
  [SMALL_STATE(4320)] = 2392,
  [SMALL_STATE(4321)] = 2517,
  [SMALL_STATE(4322)] = 2642,
  [SMALL_STATE(4323)] = 2767,
  [SMALL_STATE(4324)] = 2892,
  [SMALL_STATE(4325)] = 3017,
  [SMALL_STATE(4326)] = 3122,
  [SMALL_STATE(4327)] = 3227,
  [SMALL_STATE(4328)] = 3331,
  [SMALL_STATE(4329)] = 3435,
  [SMALL_STATE(4330)] = 3538,
  [SMALL_STATE(4331)] = 3637,
  [SMALL_STATE(4332)] = 3736,
  [SMALL_STATE(4333)] = 3834,
  [SMALL_STATE(4334)] = 3932,
  [SMALL_STATE(4335)] = 4029,
  [SMALL_STATE(4336)] = 4121,
  [SMALL_STATE(4337)] = 4196,
  [SMALL_STATE(4338)] = 4283,
  [SMALL_STATE(4339)] = 4370,
  [SMALL_STATE(4340)] = 4457,
  [SMALL_STATE(4341)] = 4544,
  [SMALL_STATE(4342)] = 4635,
  [SMALL_STATE(4343)] = 4710,
  [SMALL_STATE(4344)] = 4783,
  [SMALL_STATE(4345)] = 4858,
  [SMALL_STATE(4346)] = 4945,
  [SMALL_STATE(4347)] = 5020,
  [SMALL_STATE(4348)] = 5111,
  [SMALL_STATE(4349)] = 5198,
  [SMALL_STATE(4350)] = 5283,
  [SMALL_STATE(4351)] = 5368,
  [SMALL_STATE(4352)] = 5455,
  [SMALL_STATE(4353)] = 5528,
  [SMALL_STATE(4354)] = 5615,
  [SMALL_STATE(4355)] = 5689,
  [SMALL_STATE(4356)] = 5775,
  [SMALL_STATE(4357)] = 5861,
  [SMALL_STATE(4358)] = 5945,
  [SMALL_STATE(4359)] = 6031,
  [SMALL_STATE(4360)] = 6117,
  [SMALL_STATE(4361)] = 6201,
  [SMALL_STATE(4362)] = 6275,
  [SMALL_STATE(4363)] = 6359,
  [SMALL_STATE(4364)] = 6445,
  [SMALL_STATE(4365)] = 6531,
  [SMALL_STATE(4366)] = 6617,
  [SMALL_STATE(4367)] = 6691,
  [SMALL_STATE(4368)] = 6763,
  [SMALL_STATE(4369)] = 6849,
  [SMALL_STATE(4370)] = 6935,
  [SMALL_STATE(4371)] = 7005,
  [SMALL_STATE(4372)] = 7079,
  [SMALL_STATE(4373)] = 7151,
  [SMALL_STATE(4374)] = 7237,
  [SMALL_STATE(4375)] = 7307,
  [SMALL_STATE(4376)] = 7381,
  [SMALL_STATE(4377)] = 7467,
  [SMALL_STATE(4378)] = 7537,
  [SMALL_STATE(4379)] = 7623,
  [SMALL_STATE(4380)] = 7695,
  [SMALL_STATE(4381)] = 7769,
  [SMALL_STATE(4382)] = 7843,
  [SMALL_STATE(4383)] = 7933,
  [SMALL_STATE(4384)] = 8019,
  [SMALL_STATE(4385)] = 8105,
  [SMALL_STATE(4386)] = 8179,
  [SMALL_STATE(4387)] = 8249,
  [SMALL_STATE(4388)] = 8335,
  [SMALL_STATE(4389)] = 8407,
  [SMALL_STATE(4390)] = 8493,
  [SMALL_STATE(4391)] = 8579,
  [SMALL_STATE(4392)] = 8663,
  [SMALL_STATE(4393)] = 8735,
  [SMALL_STATE(4394)] = 8809,
  [SMALL_STATE(4395)] = 8881,
  [SMALL_STATE(4396)] = 8967,
  [SMALL_STATE(4397)] = 9039,
  [SMALL_STATE(4398)] = 9113,
  [SMALL_STATE(4399)] = 9187,
  [SMALL_STATE(4400)] = 9273,
  [SMALL_STATE(4401)] = 9347,
  [SMALL_STATE(4402)] = 9433,
  [SMALL_STATE(4403)] = 9507,
  [SMALL_STATE(4404)] = 9581,
  [SMALL_STATE(4405)] = 9667,
  [SMALL_STATE(4406)] = 9757,
  [SMALL_STATE(4407)] = 9826,
  [SMALL_STATE(4408)] = 9895,
  [SMALL_STATE(4409)] = 9980,
  [SMALL_STATE(4410)] = 10061,
  [SMALL_STATE(4411)] = 10132,
  [SMALL_STATE(4412)] = 10205,
  [SMALL_STATE(4413)] = 10290,
  [SMALL_STATE(4414)] = 10363,
  [SMALL_STATE(4415)] = 10434,
  [SMALL_STATE(4416)] = 10505,
  [SMALL_STATE(4417)] = 10588,
  [SMALL_STATE(4418)] = 10659,
  [SMALL_STATE(4419)] = 10732,
  [SMALL_STATE(4420)] = 10805,
  [SMALL_STATE(4421)] = 10878,
  [SMALL_STATE(4422)] = 10961,
  [SMALL_STATE(4423)] = 11046,
  [SMALL_STATE(4424)] = 11133,
  [SMALL_STATE(4425)] = 11218,
  [SMALL_STATE(4426)] = 11287,
  [SMALL_STATE(4427)] = 11356,
  [SMALL_STATE(4428)] = 11441,
  [SMALL_STATE(4429)] = 11510,
  [SMALL_STATE(4430)] = 11579,
  [SMALL_STATE(4431)] = 11652,
  [SMALL_STATE(4432)] = 11723,
  [SMALL_STATE(4433)] = 11794,
  [SMALL_STATE(4434)] = 11879,
  [SMALL_STATE(4435)] = 11948,
  [SMALL_STATE(4436)] = 12033,
  [SMALL_STATE(4437)] = 12118,
  [SMALL_STATE(4438)] = 12187,
  [SMALL_STATE(4439)] = 12260,
  [SMALL_STATE(4440)] = 12333,
  [SMALL_STATE(4441)] = 12404,
  [SMALL_STATE(4442)] = 12475,
  [SMALL_STATE(4443)] = 12560,
  [SMALL_STATE(4444)] = 12645,
  [SMALL_STATE(4445)] = 12716,
  [SMALL_STATE(4446)] = 12789,
  [SMALL_STATE(4447)] = 12862,
  [SMALL_STATE(4448)] = 12947,
  [SMALL_STATE(4449)] = 13032,
  [SMALL_STATE(4450)] = 13101,
  [SMALL_STATE(4451)] = 13174,
  [SMALL_STATE(4452)] = 13245,
  [SMALL_STATE(4453)] = 13318,
  [SMALL_STATE(4454)] = 13403,
  [SMALL_STATE(4455)] = 13476,
  [SMALL_STATE(4456)] = 13545,
  [SMALL_STATE(4457)] = 13630,
  [SMALL_STATE(4458)] = 13703,
  [SMALL_STATE(4459)] = 13776,
  [SMALL_STATE(4460)] = 13861,
  [SMALL_STATE(4461)] = 13934,
  [SMALL_STATE(4462)] = 14019,
  [SMALL_STATE(4463)] = 14092,
  [SMALL_STATE(4464)] = 14161,
  [SMALL_STATE(4465)] = 14246,
  [SMALL_STATE(4466)] = 14317,
  [SMALL_STATE(4467)] = 14390,
  [SMALL_STATE(4468)] = 14475,
  [SMALL_STATE(4469)] = 14546,
  [SMALL_STATE(4470)] = 14627,
  [SMALL_STATE(4471)] = 14700,
  [SMALL_STATE(4472)] = 14785,
  [SMALL_STATE(4473)] = 14854,
  [SMALL_STATE(4474)] = 14935,
  [SMALL_STATE(4475)] = 15016,
  [SMALL_STATE(4476)] = 15101,
  [SMALL_STATE(4477)] = 15174,
  [SMALL_STATE(4478)] = 15247,
  [SMALL_STATE(4479)] = 15318,
  [SMALL_STATE(4480)] = 15389,
  [SMALL_STATE(4481)] = 15458,
  [SMALL_STATE(4482)] = 15531,
  [SMALL_STATE(4483)] = 15616,
  [SMALL_STATE(4484)] = 15685,
  [SMALL_STATE(4485)] = 15770,
  [SMALL_STATE(4486)] = 15840,
  [SMALL_STATE(4487)] = 15910,
  [SMALL_STATE(4488)] = 15978,
  [SMALL_STATE(4489)] = 16046,
  [SMALL_STATE(4490)] = 16118,
  [SMALL_STATE(4491)] = 16244,
  [SMALL_STATE(4492)] = 16312,
  [SMALL_STATE(4493)] = 16380,
  [SMALL_STATE(4494)] = 16506,
  [SMALL_STATE(4495)] = 16574,
  [SMALL_STATE(4496)] = 16644,
  [SMALL_STATE(4497)] = 16714,
  [SMALL_STATE(4498)] = 16782,
  [SMALL_STATE(4499)] = 16850,
  [SMALL_STATE(4500)] = 16922,
  [SMALL_STATE(4501)] = 17048,
  [SMALL_STATE(4502)] = 17132,
  [SMALL_STATE(4503)] = 17200,
  [SMALL_STATE(4504)] = 17270,
  [SMALL_STATE(4505)] = 17342,
  [SMALL_STATE(4506)] = 17412,
  [SMALL_STATE(4507)] = 17480,
  [SMALL_STATE(4508)] = 17606,
  [SMALL_STATE(4509)] = 17732,
  [SMALL_STATE(4510)] = 17800,
  [SMALL_STATE(4511)] = 17870,
  [SMALL_STATE(4512)] = 17942,
  [SMALL_STATE(4513)] = 18012,
  [SMALL_STATE(4514)] = 18084,
  [SMALL_STATE(4515)] = 18154,
  [SMALL_STATE(4516)] = 18226,
  [SMALL_STATE(4517)] = 18296,
  [SMALL_STATE(4518)] = 18422,
  [SMALL_STATE(4519)] = 18490,
  [SMALL_STATE(4520)] = 18558,
  [SMALL_STATE(4521)] = 18626,
  [SMALL_STATE(4522)] = 18694,
  [SMALL_STATE(4523)] = 18820,
  [SMALL_STATE(4524)] = 18892,
  [SMALL_STATE(4525)] = 19018,
  [SMALL_STATE(4526)] = 19090,
  [SMALL_STATE(4527)] = 19174,
  [SMALL_STATE(4528)] = 19300,
  [SMALL_STATE(4529)] = 19372,
  [SMALL_STATE(4530)] = 19498,
  [SMALL_STATE(4531)] = 19566,
  [SMALL_STATE(4532)] = 19650,
  [SMALL_STATE(4533)] = 19718,
  [SMALL_STATE(4534)] = 19844,
  [SMALL_STATE(4535)] = 19912,
  [SMALL_STATE(4536)] = 19980,
  [SMALL_STATE(4537)] = 20048,
  [SMALL_STATE(4538)] = 20116,
  [SMALL_STATE(4539)] = 20186,
  [SMALL_STATE(4540)] = 20258,
  [SMALL_STATE(4541)] = 20326,
  [SMALL_STATE(4542)] = 20452,
  [SMALL_STATE(4543)] = 20536,
  [SMALL_STATE(4544)] = 20620,
  [SMALL_STATE(4545)] = 20688,
  [SMALL_STATE(4546)] = 20814,
  [SMALL_STATE(4547)] = 20882,
  [SMALL_STATE(4548)] = 20950,
  [SMALL_STATE(4549)] = 21076,
  [SMALL_STATE(4550)] = 21144,
  [SMALL_STATE(4551)] = 21212,
  [SMALL_STATE(4552)] = 21280,
  [SMALL_STATE(4553)] = 21348,
  [SMALL_STATE(4554)] = 21418,
  [SMALL_STATE(4555)] = 21490,
  [SMALL_STATE(4556)] = 21560,
  [SMALL_STATE(4557)] = 21628,
  [SMALL_STATE(4558)] = 21700,
  [SMALL_STATE(4559)] = 21768,
  [SMALL_STATE(4560)] = 21840,
  [SMALL_STATE(4561)] = 21910,
  [SMALL_STATE(4562)] = 21978,
  [SMALL_STATE(4563)] = 22048,
  [SMALL_STATE(4564)] = 22118,
  [SMALL_STATE(4565)] = 22186,
  [SMALL_STATE(4566)] = 22270,
  [SMALL_STATE(4567)] = 22338,
  [SMALL_STATE(4568)] = 22464,
  [SMALL_STATE(4569)] = 22532,
  [SMALL_STATE(4570)] = 22600,
  [SMALL_STATE(4571)] = 22670,
  [SMALL_STATE(4572)] = 22738,
  [SMALL_STATE(4573)] = 22832,
  [SMALL_STATE(4574)] = 22904,
  [SMALL_STATE(4575)] = 22976,
  [SMALL_STATE(4576)] = 23102,
  [SMALL_STATE(4577)] = 23170,
  [SMALL_STATE(4578)] = 23240,
  [SMALL_STATE(4579)] = 23308,
  [SMALL_STATE(4580)] = 23376,
  [SMALL_STATE(4581)] = 23444,
  [SMALL_STATE(4582)] = 23512,
  [SMALL_STATE(4583)] = 23584,
  [SMALL_STATE(4584)] = 23656,
  [SMALL_STATE(4585)] = 23724,
  [SMALL_STATE(4586)] = 23791,
  [SMALL_STATE(4587)] = 23858,
  [SMALL_STATE(4588)] = 23925,
  [SMALL_STATE(4589)] = 23994,
  [SMALL_STATE(4590)] = 24063,
  [SMALL_STATE(4591)] = 24130,
  [SMALL_STATE(4592)] = 24197,
  [SMALL_STATE(4593)] = 24268,
  [SMALL_STATE(4594)] = 24335,
  [SMALL_STATE(4595)] = 24406,
  [SMALL_STATE(4596)] = 24473,
  [SMALL_STATE(4597)] = 24540,
  [SMALL_STATE(4598)] = 24607,
  [SMALL_STATE(4599)] = 24674,
  [SMALL_STATE(4600)] = 24741,
  [SMALL_STATE(4601)] = 24808,
  [SMALL_STATE(4602)] = 24877,
  [SMALL_STATE(4603)] = 24944,
  [SMALL_STATE(4604)] = 25013,
  [SMALL_STATE(4605)] = 25084,
  [SMALL_STATE(4606)] = 25151,
  [SMALL_STATE(4607)] = 25218,
  [SMALL_STATE(4608)] = 25289,
  [SMALL_STATE(4609)] = 25356,
  [SMALL_STATE(4610)] = 25423,
  [SMALL_STATE(4611)] = 25490,
  [SMALL_STATE(4612)] = 25557,
  [SMALL_STATE(4613)] = 25624,
  [SMALL_STATE(4614)] = 25693,
  [SMALL_STATE(4615)] = 25760,
  [SMALL_STATE(4616)] = 25827,
  [SMALL_STATE(4617)] = 25896,
  [SMALL_STATE(4618)] = 25963,
  [SMALL_STATE(4619)] = 26030,
  [SMALL_STATE(4620)] = 26097,
  [SMALL_STATE(4621)] = 26164,
  [SMALL_STATE(4622)] = 26231,
  [SMALL_STATE(4623)] = 26300,
  [SMALL_STATE(4624)] = 26371,
  [SMALL_STATE(4625)] = 26440,
  [SMALL_STATE(4626)] = 26507,
  [SMALL_STATE(4627)] = 26574,
  [SMALL_STATE(4628)] = 26641,
  [SMALL_STATE(4629)] = 26708,
  [SMALL_STATE(4630)] = 26799,
  [SMALL_STATE(4631)] = 26866,
  [SMALL_STATE(4632)] = 26933,
  [SMALL_STATE(4633)] = 27000,
  [SMALL_STATE(4634)] = 27067,
  [SMALL_STATE(4635)] = 27136,
  [SMALL_STATE(4636)] = 27203,
  [SMALL_STATE(4637)] = 27272,
  [SMALL_STATE(4638)] = 27339,
  [SMALL_STATE(4639)] = 27406,
  [SMALL_STATE(4640)] = 27473,
  [SMALL_STATE(4641)] = 27540,
  [SMALL_STATE(4642)] = 27607,
  [SMALL_STATE(4643)] = 27676,
  [SMALL_STATE(4644)] = 27743,
  [SMALL_STATE(4645)] = 27810,
  [SMALL_STATE(4646)] = 27877,
  [SMALL_STATE(4647)] = 27944,
  [SMALL_STATE(4648)] = 28011,
  [SMALL_STATE(4649)] = 28078,
  [SMALL_STATE(4650)] = 28145,
  [SMALL_STATE(4651)] = 28216,
  [SMALL_STATE(4652)] = 28283,
  [SMALL_STATE(4653)] = 28350,
  [SMALL_STATE(4654)] = 28421,
  [SMALL_STATE(4655)] = 28490,
  [SMALL_STATE(4656)] = 28557,
  [SMALL_STATE(4657)] = 28624,
  [SMALL_STATE(4658)] = 28691,
  [SMALL_STATE(4659)] = 28758,
  [SMALL_STATE(4660)] = 28827,
  [SMALL_STATE(4661)] = 28894,
  [SMALL_STATE(4662)] = 28963,
  [SMALL_STATE(4663)] = 29030,
  [SMALL_STATE(4664)] = 29097,
  [SMALL_STATE(4665)] = 29164,
  [SMALL_STATE(4666)] = 29231,
  [SMALL_STATE(4667)] = 29298,
  [SMALL_STATE(4668)] = 29365,
  [SMALL_STATE(4669)] = 29434,
  [SMALL_STATE(4670)] = 29501,
  [SMALL_STATE(4671)] = 29620,
  [SMALL_STATE(4672)] = 29687,
  [SMALL_STATE(4673)] = 29756,
  [SMALL_STATE(4674)] = 29823,
  [SMALL_STATE(4675)] = 29890,
  [SMALL_STATE(4676)] = 29957,
  [SMALL_STATE(4677)] = 30024,
  [SMALL_STATE(4678)] = 30092,
  [SMALL_STATE(4679)] = 30158,
  [SMALL_STATE(4680)] = 30224,
  [SMALL_STATE(4681)] = 30290,
  [SMALL_STATE(4682)] = 30356,
  [SMALL_STATE(4683)] = 30422,
  [SMALL_STATE(4684)] = 30488,
  [SMALL_STATE(4685)] = 30554,
  [SMALL_STATE(4686)] = 30622,
  [SMALL_STATE(4687)] = 30688,
  [SMALL_STATE(4688)] = 30754,
  [SMALL_STATE(4689)] = 30820,
  [SMALL_STATE(4690)] = 30886,
  [SMALL_STATE(4691)] = 30954,
  [SMALL_STATE(4692)] = 31020,
  [SMALL_STATE(4693)] = 31112,
  [SMALL_STATE(4694)] = 31180,
  [SMALL_STATE(4695)] = 31246,
  [SMALL_STATE(4696)] = 31338,
  [SMALL_STATE(4697)] = 31404,
  [SMALL_STATE(4698)] = 31470,
  [SMALL_STATE(4699)] = 31562,
  [SMALL_STATE(4700)] = 31628,
  [SMALL_STATE(4701)] = 31720,
  [SMALL_STATE(4702)] = 31786,
  [SMALL_STATE(4703)] = 31854,
  [SMALL_STATE(4704)] = 31922,
  [SMALL_STATE(4705)] = 31988,
  [SMALL_STATE(4706)] = 32054,
  [SMALL_STATE(4707)] = 32120,
  [SMALL_STATE(4708)] = 32240,
  [SMALL_STATE(4709)] = 32306,
  [SMALL_STATE(4710)] = 32372,
  [SMALL_STATE(4711)] = 32438,
  [SMALL_STATE(4712)] = 32504,
  [SMALL_STATE(4713)] = 32570,
  [SMALL_STATE(4714)] = 32636,
  [SMALL_STATE(4715)] = 32706,
  [SMALL_STATE(4716)] = 32772,
  [SMALL_STATE(4717)] = 32892,
  [SMALL_STATE(4718)] = 32962,
  [SMALL_STATE(4719)] = 33028,
  [SMALL_STATE(4720)] = 33094,
  [SMALL_STATE(4721)] = 33160,
  [SMALL_STATE(4722)] = 33226,
  [SMALL_STATE(4723)] = 33320,
  [SMALL_STATE(4724)] = 33386,
  [SMALL_STATE(4725)] = 33452,
  [SMALL_STATE(4726)] = 33544,
  [SMALL_STATE(4727)] = 33610,
  [SMALL_STATE(4728)] = 33676,
  [SMALL_STATE(4729)] = 33744,
  [SMALL_STATE(4730)] = 33836,
  [SMALL_STATE(4731)] = 33902,
  [SMALL_STATE(4732)] = 33994,
  [SMALL_STATE(4733)] = 34060,
  [SMALL_STATE(4734)] = 34126,
  [SMALL_STATE(4735)] = 34192,
  [SMALL_STATE(4736)] = 34258,
  [SMALL_STATE(4737)] = 34324,
  [SMALL_STATE(4738)] = 34392,
  [SMALL_STATE(4739)] = 34458,
  [SMALL_STATE(4740)] = 34528,
  [SMALL_STATE(4741)] = 34594,
  [SMALL_STATE(4742)] = 34660,
  [SMALL_STATE(4743)] = 34726,
  [SMALL_STATE(4744)] = 34792,
  [SMALL_STATE(4745)] = 34858,
  [SMALL_STATE(4746)] = 34924,
  [SMALL_STATE(4747)] = 34990,
  [SMALL_STATE(4748)] = 35108,
  [SMALL_STATE(4749)] = 35174,
  [SMALL_STATE(4750)] = 35240,
  [SMALL_STATE(4751)] = 35306,
  [SMALL_STATE(4752)] = 35374,
  [SMALL_STATE(4753)] = 35440,
  [SMALL_STATE(4754)] = 35506,
  [SMALL_STATE(4755)] = 35574,
  [SMALL_STATE(4756)] = 35640,
  [SMALL_STATE(4757)] = 35706,
  [SMALL_STATE(4758)] = 35772,
  [SMALL_STATE(4759)] = 35889,
  [SMALL_STATE(4760)] = 35956,
  [SMALL_STATE(4761)] = 36021,
  [SMALL_STATE(4762)] = 36090,
  [SMALL_STATE(4763)] = 36159,
  [SMALL_STATE(4764)] = 36228,
  [SMALL_STATE(4765)] = 36297,
  [SMALL_STATE(4766)] = 36364,
  [SMALL_STATE(4767)] = 36429,
  [SMALL_STATE(4768)] = 36494,
  [SMALL_STATE(4769)] = 36559,
  [SMALL_STATE(4770)] = 36628,
  [SMALL_STATE(4771)] = 36695,
  [SMALL_STATE(4772)] = 36766,
  [SMALL_STATE(4773)] = 36835,
  [SMALL_STATE(4774)] = 36900,
  [SMALL_STATE(4775)] = 36965,
  [SMALL_STATE(4776)] = 37032,
  [SMALL_STATE(4777)] = 37099,
  [SMALL_STATE(4778)] = 37168,
  [SMALL_STATE(4779)] = 37233,
  [SMALL_STATE(4780)] = 37298,
  [SMALL_STATE(4781)] = 37365,
  [SMALL_STATE(4782)] = 37434,
  [SMALL_STATE(4783)] = 37501,
  [SMALL_STATE(4784)] = 37566,
  [SMALL_STATE(4785)] = 37631,
  [SMALL_STATE(4786)] = 37748,
  [SMALL_STATE(4787)] = 37865,
  [SMALL_STATE(4788)] = 37982,
  [SMALL_STATE(4789)] = 38051,
  [SMALL_STATE(4790)] = 38116,
  [SMALL_STATE(4791)] = 38181,
  [SMALL_STATE(4792)] = 38250,
  [SMALL_STATE(4793)] = 38319,
  [SMALL_STATE(4794)] = 38386,
  [SMALL_STATE(4795)] = 38455,
  [SMALL_STATE(4796)] = 38522,
  [SMALL_STATE(4797)] = 38639,
  [SMALL_STATE(4798)] = 38708,
  [SMALL_STATE(4799)] = 38773,
  [SMALL_STATE(4800)] = 38890,
  [SMALL_STATE(4801)] = 39007,
  [SMALL_STATE(4802)] = 39074,
  [SMALL_STATE(4803)] = 39141,
  [SMALL_STATE(4804)] = 39206,
  [SMALL_STATE(4805)] = 39275,
  [SMALL_STATE(4806)] = 39340,
  [SMALL_STATE(4807)] = 39457,
  [SMALL_STATE(4808)] = 39526,
  [SMALL_STATE(4809)] = 39595,
  [SMALL_STATE(4810)] = 39660,
  [SMALL_STATE(4811)] = 39726,
  [SMALL_STATE(4812)] = 39790,
  [SMALL_STATE(4813)] = 39904,
  [SMALL_STATE(4814)] = 39974,
  [SMALL_STATE(4815)] = 40042,
  [SMALL_STATE(4816)] = 40112,
  [SMALL_STATE(4817)] = 40182,
  [SMALL_STATE(4818)] = 40248,
  [SMALL_STATE(4819)] = 40314,
  [SMALL_STATE(4820)] = 40380,
  [SMALL_STATE(4821)] = 40448,
  [SMALL_STATE(4822)] = 40512,
  [SMALL_STATE(4823)] = 40614,
  [SMALL_STATE(4824)] = 40682,
  [SMALL_STATE(4825)] = 40748,
  [SMALL_STATE(4826)] = 40814,
  [SMALL_STATE(4827)] = 40882,
  [SMALL_STATE(4828)] = 40946,
  [SMALL_STATE(4829)] = 41014,
  [SMALL_STATE(4830)] = 41080,
  [SMALL_STATE(4831)] = 41182,
  [SMALL_STATE(4832)] = 41250,
  [SMALL_STATE(4833)] = 41316,
  [SMALL_STATE(4834)] = 41384,
  [SMALL_STATE(4835)] = 41448,
  [SMALL_STATE(4836)] = 41514,
  [SMALL_STATE(4837)] = 41616,
  [SMALL_STATE(4838)] = 41680,
  [SMALL_STATE(4839)] = 41744,
  [SMALL_STATE(4840)] = 41832,
  [SMALL_STATE(4841)] = 41934,
  [SMALL_STATE(4842)] = 42000,
  [SMALL_STATE(4843)] = 42102,
  [SMALL_STATE(4844)] = 42216,
  [SMALL_STATE(4845)] = 42280,
  [SMALL_STATE(4846)] = 42346,
  [SMALL_STATE(4847)] = 42416,
  [SMALL_STATE(4848)] = 42480,
  [SMALL_STATE(4849)] = 42582,
  [SMALL_STATE(4850)] = 42646,
  [SMALL_STATE(4851)] = 42714,
  [SMALL_STATE(4852)] = 42778,
  [SMALL_STATE(4853)] = 42842,
  [SMALL_STATE(4854)] = 42912,
  [SMALL_STATE(4855)] = 42976,
  [SMALL_STATE(4856)] = 43046,
  [SMALL_STATE(4857)] = 43114,
  [SMALL_STATE(4858)] = 43216,
  [SMALL_STATE(4859)] = 43330,
  [SMALL_STATE(4860)] = 43394,
  [SMALL_STATE(4861)] = 43458,
  [SMALL_STATE(4862)] = 43522,
  [SMALL_STATE(4863)] = 43592,
  [SMALL_STATE(4864)] = 43662,
  [SMALL_STATE(4865)] = 43726,
  [SMALL_STATE(4866)] = 43796,
  [SMALL_STATE(4867)] = 43864,
  [SMALL_STATE(4868)] = 43932,
  [SMALL_STATE(4869)] = 44046,
  [SMALL_STATE(4870)] = 44148,
  [SMALL_STATE(4871)] = 44212,
  [SMALL_STATE(4872)] = 44282,
  [SMALL_STATE(4873)] = 44384,
  [SMALL_STATE(4874)] = 44452,
  [SMALL_STATE(4875)] = 44522,
  [SMALL_STATE(4876)] = 44586,
  [SMALL_STATE(4877)] = 44688,
  [SMALL_STATE(4878)] = 44790,
  [SMALL_STATE(4879)] = 44892,
  [SMALL_STATE(4880)] = 44956,
  [SMALL_STATE(4881)] = 45022,
  [SMALL_STATE(4882)] = 45086,
  [SMALL_STATE(4883)] = 45150,
  [SMALL_STATE(4884)] = 45252,
  [SMALL_STATE(4885)] = 45320,
  [SMALL_STATE(4886)] = 45384,
  [SMALL_STATE(4887)] = 45452,
  [SMALL_STATE(4888)] = 45518,
  [SMALL_STATE(4889)] = 45584,
  [SMALL_STATE(4890)] = 45650,
  [SMALL_STATE(4891)] = 45714,
  [SMALL_STATE(4892)] = 45782,
  [SMALL_STATE(4893)] = 45848,
  [SMALL_STATE(4894)] = 45950,
  [SMALL_STATE(4895)] = 46020,
  [SMALL_STATE(4896)] = 46122,
  [SMALL_STATE(4897)] = 46192,
  [SMALL_STATE(4898)] = 46258,
  [SMALL_STATE(4899)] = 46328,
  [SMALL_STATE(4900)] = 46404,
  [SMALL_STATE(4901)] = 46506,
  [SMALL_STATE(4902)] = 46572,
  [SMALL_STATE(4903)] = 46640,
  [SMALL_STATE(4904)] = 46706,
  [SMALL_STATE(4905)] = 46772,
  [SMALL_STATE(4906)] = 46838,
  [SMALL_STATE(4907)] = 46904,
  [SMALL_STATE(4908)] = 46970,
  [SMALL_STATE(4909)] = 47036,
  [SMALL_STATE(4910)] = 47100,
  [SMALL_STATE(4911)] = 47202,
  [SMALL_STATE(4912)] = 47272,
  [SMALL_STATE(4913)] = 47348,
  [SMALL_STATE(4914)] = 47416,
  [SMALL_STATE(4915)] = 47518,
  [SMALL_STATE(4916)] = 47620,
  [SMALL_STATE(4917)] = 47688,
  [SMALL_STATE(4918)] = 47790,
  [SMALL_STATE(4919)] = 47856,
  [SMALL_STATE(4920)] = 47926,
  [SMALL_STATE(4921)] = 47994,
  [SMALL_STATE(4922)] = 48062,
  [SMALL_STATE(4923)] = 48126,
  [SMALL_STATE(4924)] = 48192,
  [SMALL_STATE(4925)] = 48258,
  [SMALL_STATE(4926)] = 48323,
  [SMALL_STATE(4927)] = 48386,
  [SMALL_STATE(4928)] = 48449,
  [SMALL_STATE(4929)] = 48512,
  [SMALL_STATE(4930)] = 48575,
  [SMALL_STATE(4931)] = 48638,
  [SMALL_STATE(4932)] = 48701,
  [SMALL_STATE(4933)] = 48764,
  [SMALL_STATE(4934)] = 48827,
  [SMALL_STATE(4935)] = 48890,
  [SMALL_STATE(4936)] = 49003,
  [SMALL_STATE(4937)] = 49066,
  [SMALL_STATE(4938)] = 49129,
  [SMALL_STATE(4939)] = 49228,
  [SMALL_STATE(4940)] = 49309,
  [SMALL_STATE(4941)] = 49372,
  [SMALL_STATE(4942)] = 49435,
  [SMALL_STATE(4943)] = 49498,
  [SMALL_STATE(4944)] = 49561,
  [SMALL_STATE(4945)] = 49624,
  [SMALL_STATE(4946)] = 49689,
  [SMALL_STATE(4947)] = 49752,
  [SMALL_STATE(4948)] = 49817,
  [SMALL_STATE(4949)] = 49880,
  [SMALL_STATE(4950)] = 49993,
  [SMALL_STATE(4951)] = 50056,
  [SMALL_STATE(4952)] = 50123,
  [SMALL_STATE(4953)] = 50186,
  [SMALL_STATE(4954)] = 50251,
  [SMALL_STATE(4955)] = 50350,
  [SMALL_STATE(4956)] = 50413,
  [SMALL_STATE(4957)] = 50478,
  [SMALL_STATE(4958)] = 50577,
  [SMALL_STATE(4959)] = 50640,
  [SMALL_STATE(4960)] = 50703,
  [SMALL_STATE(4961)] = 50802,
  [SMALL_STATE(4962)] = 50865,
  [SMALL_STATE(4963)] = 50928,
  [SMALL_STATE(4964)] = 51027,
  [SMALL_STATE(4965)] = 51094,
  [SMALL_STATE(4966)] = 51157,
  [SMALL_STATE(4967)] = 51220,
  [SMALL_STATE(4968)] = 51323,
  [SMALL_STATE(4969)] = 51434,
  [SMALL_STATE(4970)] = 51547,
  [SMALL_STATE(4971)] = 51610,
  [SMALL_STATE(4972)] = 51673,
  [SMALL_STATE(4973)] = 51736,
  [SMALL_STATE(4974)] = 51799,
  [SMALL_STATE(4975)] = 51862,
  [SMALL_STATE(4976)] = 51925,
  [SMALL_STATE(4977)] = 51988,
  [SMALL_STATE(4978)] = 52051,
  [SMALL_STATE(4979)] = 52114,
  [SMALL_STATE(4980)] = 52177,
  [SMALL_STATE(4981)] = 52240,
  [SMALL_STATE(4982)] = 52303,
  [SMALL_STATE(4983)] = 52366,
  [SMALL_STATE(4984)] = 52429,
  [SMALL_STATE(4985)] = 52492,
  [SMALL_STATE(4986)] = 52555,
  [SMALL_STATE(4987)] = 52622,
  [SMALL_STATE(4988)] = 52685,
  [SMALL_STATE(4989)] = 52748,
  [SMALL_STATE(4990)] = 52811,
  [SMALL_STATE(4991)] = 52874,
  [SMALL_STATE(4992)] = 52937,
  [SMALL_STATE(4993)] = 53002,
  [SMALL_STATE(4994)] = 53065,
  [SMALL_STATE(4995)] = 53128,
  [SMALL_STATE(4996)] = 53193,
  [SMALL_STATE(4997)] = 53256,
  [SMALL_STATE(4998)] = 53319,
  [SMALL_STATE(4999)] = 53382,
  [SMALL_STATE(5000)] = 53445,
  [SMALL_STATE(5001)] = 53512,
  [SMALL_STATE(5002)] = 53575,
  [SMALL_STATE(5003)] = 53638,
  [SMALL_STATE(5004)] = 53701,
  [SMALL_STATE(5005)] = 53766,
  [SMALL_STATE(5006)] = 53829,
  [SMALL_STATE(5007)] = 53892,
  [SMALL_STATE(5008)] = 53991,
  [SMALL_STATE(5009)] = 54054,
  [SMALL_STATE(5010)] = 54153,
  [SMALL_STATE(5011)] = 54252,
  [SMALL_STATE(5012)] = 54315,
  [SMALL_STATE(5013)] = 54378,
  [SMALL_STATE(5014)] = 54489,
  [SMALL_STATE(5015)] = 54552,
  [SMALL_STATE(5016)] = 54615,
  [SMALL_STATE(5017)] = 54678,
  [SMALL_STATE(5018)] = 54741,
  [SMALL_STATE(5019)] = 54804,
  [SMALL_STATE(5020)] = 54867,
  [SMALL_STATE(5021)] = 54930,
  [SMALL_STATE(5022)] = 54993,
  [SMALL_STATE(5023)] = 55056,
  [SMALL_STATE(5024)] = 55119,
  [SMALL_STATE(5025)] = 55182,
  [SMALL_STATE(5026)] = 55245,
  [SMALL_STATE(5027)] = 55308,
  [SMALL_STATE(5028)] = 55371,
  [SMALL_STATE(5029)] = 55434,
  [SMALL_STATE(5030)] = 55497,
  [SMALL_STATE(5031)] = 55560,
  [SMALL_STATE(5032)] = 55635,
  [SMALL_STATE(5033)] = 55700,
  [SMALL_STATE(5034)] = 55763,
  [SMALL_STATE(5035)] = 55826,
  [SMALL_STATE(5036)] = 55891,
  [SMALL_STATE(5037)] = 55954,
  [SMALL_STATE(5038)] = 56017,
  [SMALL_STATE(5039)] = 56080,
  [SMALL_STATE(5040)] = 56143,
  [SMALL_STATE(5041)] = 56206,
  [SMALL_STATE(5042)] = 56269,
  [SMALL_STATE(5043)] = 56334,
  [SMALL_STATE(5044)] = 56401,
  [SMALL_STATE(5045)] = 56464,
  [SMALL_STATE(5046)] = 56529,
  [SMALL_STATE(5047)] = 56594,
  [SMALL_STATE(5048)] = 56659,
  [SMALL_STATE(5049)] = 56758,
  [SMALL_STATE(5050)] = 56823,
  [SMALL_STATE(5051)] = 56888,
  [SMALL_STATE(5052)] = 56953,
  [SMALL_STATE(5053)] = 57016,
  [SMALL_STATE(5054)] = 57079,
  [SMALL_STATE(5055)] = 57142,
  [SMALL_STATE(5056)] = 57209,
  [SMALL_STATE(5057)] = 57274,
  [SMALL_STATE(5058)] = 57337,
  [SMALL_STATE(5059)] = 57404,
  [SMALL_STATE(5060)] = 57467,
  [SMALL_STATE(5061)] = 57530,
  [SMALL_STATE(5062)] = 57593,
  [SMALL_STATE(5063)] = 57656,
  [SMALL_STATE(5064)] = 57719,
  [SMALL_STATE(5065)] = 57784,
  [SMALL_STATE(5066)] = 57895,
  [SMALL_STATE(5067)] = 57958,
  [SMALL_STATE(5068)] = 58023,
  [SMALL_STATE(5069)] = 58088,
  [SMALL_STATE(5070)] = 58153,
  [SMALL_STATE(5071)] = 58216,
  [SMALL_STATE(5072)] = 58279,
  [SMALL_STATE(5073)] = 58344,
  [SMALL_STATE(5074)] = 58419,
  [SMALL_STATE(5075)] = 58482,
  [SMALL_STATE(5076)] = 58549,
  [SMALL_STATE(5077)] = 58612,
  [SMALL_STATE(5078)] = 58675,
  [SMALL_STATE(5079)] = 58738,
  [SMALL_STATE(5080)] = 58837,
  [SMALL_STATE(5081)] = 58902,
  [SMALL_STATE(5082)] = 58965,
  [SMALL_STATE(5083)] = 59028,
  [SMALL_STATE(5084)] = 59091,
  [SMALL_STATE(5085)] = 59154,
  [SMALL_STATE(5086)] = 59217,
  [SMALL_STATE(5087)] = 59280,
  [SMALL_STATE(5088)] = 59343,
  [SMALL_STATE(5089)] = 59406,
  [SMALL_STATE(5090)] = 59469,
  [SMALL_STATE(5091)] = 59532,
  [SMALL_STATE(5092)] = 59645,
  [SMALL_STATE(5093)] = 59708,
  [SMALL_STATE(5094)] = 59771,
  [SMALL_STATE(5095)] = 59834,
  [SMALL_STATE(5096)] = 59897,
  [SMALL_STATE(5097)] = 59960,
  [SMALL_STATE(5098)] = 60023,
  [SMALL_STATE(5099)] = 60136,
  [SMALL_STATE(5100)] = 60199,
  [SMALL_STATE(5101)] = 60262,
  [SMALL_STATE(5102)] = 60325,
  [SMALL_STATE(5103)] = 60388,
  [SMALL_STATE(5104)] = 60451,
  [SMALL_STATE(5105)] = 60514,
  [SMALL_STATE(5106)] = 60577,
  [SMALL_STATE(5107)] = 60640,
  [SMALL_STATE(5108)] = 60703,
  [SMALL_STATE(5109)] = 60800,
  [SMALL_STATE(5110)] = 60863,
  [SMALL_STATE(5111)] = 60926,
  [SMALL_STATE(5112)] = 60988,
  [SMALL_STATE(5113)] = 61050,
  [SMALL_STATE(5114)] = 61112,
  [SMALL_STATE(5115)] = 61174,
  [SMALL_STATE(5116)] = 61236,
  [SMALL_STATE(5117)] = 61298,
  [SMALL_STATE(5118)] = 61360,
  [SMALL_STATE(5119)] = 61422,
  [SMALL_STATE(5120)] = 61484,
  [SMALL_STATE(5121)] = 61546,
  [SMALL_STATE(5122)] = 61608,
  [SMALL_STATE(5123)] = 61670,
  [SMALL_STATE(5124)] = 61772,
  [SMALL_STATE(5125)] = 61834,
  [SMALL_STATE(5126)] = 61898,
  [SMALL_STATE(5127)] = 61960,
  [SMALL_STATE(5128)] = 62022,
  [SMALL_STATE(5129)] = 62084,
  [SMALL_STATE(5130)] = 62146,
  [SMALL_STATE(5131)] = 62208,
  [SMALL_STATE(5132)] = 62270,
  [SMALL_STATE(5133)] = 62332,
  [SMALL_STATE(5134)] = 62394,
  [SMALL_STATE(5135)] = 62456,
  [SMALL_STATE(5136)] = 62518,
  [SMALL_STATE(5137)] = 62580,
  [SMALL_STATE(5138)] = 62642,
  [SMALL_STATE(5139)] = 62704,
  [SMALL_STATE(5140)] = 62766,
  [SMALL_STATE(5141)] = 62828,
  [SMALL_STATE(5142)] = 62890,
  [SMALL_STATE(5143)] = 62952,
  [SMALL_STATE(5144)] = 63014,
  [SMALL_STATE(5145)] = 63076,
  [SMALL_STATE(5146)] = 63138,
  [SMALL_STATE(5147)] = 63200,
  [SMALL_STATE(5148)] = 63262,
  [SMALL_STATE(5149)] = 63324,
  [SMALL_STATE(5150)] = 63386,
  [SMALL_STATE(5151)] = 63448,
  [SMALL_STATE(5152)] = 63510,
  [SMALL_STATE(5153)] = 63572,
  [SMALL_STATE(5154)] = 63636,
  [SMALL_STATE(5155)] = 63698,
  [SMALL_STATE(5156)] = 63760,
  [SMALL_STATE(5157)] = 63822,
  [SMALL_STATE(5158)] = 63884,
  [SMALL_STATE(5159)] = 63946,
  [SMALL_STATE(5160)] = 64026,
  [SMALL_STATE(5161)] = 64088,
  [SMALL_STATE(5162)] = 64152,
  [SMALL_STATE(5163)] = 64214,
  [SMALL_STATE(5164)] = 64276,
  [SMALL_STATE(5165)] = 64338,
  [SMALL_STATE(5166)] = 64400,
  [SMALL_STATE(5167)] = 64462,
  [SMALL_STATE(5168)] = 64524,
  [SMALL_STATE(5169)] = 64586,
  [SMALL_STATE(5170)] = 64650,
  [SMALL_STATE(5171)] = 64712,
  [SMALL_STATE(5172)] = 64774,
  [SMALL_STATE(5173)] = 64836,
  [SMALL_STATE(5174)] = 64898,
  [SMALL_STATE(5175)] = 64960,
  [SMALL_STATE(5176)] = 65022,
  [SMALL_STATE(5177)] = 65084,
  [SMALL_STATE(5178)] = 65146,
  [SMALL_STATE(5179)] = 65208,
  [SMALL_STATE(5180)] = 65270,
  [SMALL_STATE(5181)] = 65332,
  [SMALL_STATE(5182)] = 65394,
  [SMALL_STATE(5183)] = 65456,
  [SMALL_STATE(5184)] = 65518,
  [SMALL_STATE(5185)] = 65580,
  [SMALL_STATE(5186)] = 65642,
  [SMALL_STATE(5187)] = 65704,
  [SMALL_STATE(5188)] = 65766,
  [SMALL_STATE(5189)] = 65832,
  [SMALL_STATE(5190)] = 65894,
  [SMALL_STATE(5191)] = 65956,
  [SMALL_STATE(5192)] = 66018,
  [SMALL_STATE(5193)] = 66080,
  [SMALL_STATE(5194)] = 66142,
  [SMALL_STATE(5195)] = 66204,
  [SMALL_STATE(5196)] = 66266,
  [SMALL_STATE(5197)] = 66328,
  [SMALL_STATE(5198)] = 66390,
  [SMALL_STATE(5199)] = 66452,
  [SMALL_STATE(5200)] = 66514,
  [SMALL_STATE(5201)] = 66576,
  [SMALL_STATE(5202)] = 66638,
  [SMALL_STATE(5203)] = 66700,
  [SMALL_STATE(5204)] = 66774,
  [SMALL_STATE(5205)] = 66838,
  [SMALL_STATE(5206)] = 66900,
  [SMALL_STATE(5207)] = 66962,
  [SMALL_STATE(5208)] = 67026,
  [SMALL_STATE(5209)] = 67088,
  [SMALL_STATE(5210)] = 67152,
  [SMALL_STATE(5211)] = 67214,
  [SMALL_STATE(5212)] = 67278,
  [SMALL_STATE(5213)] = 67340,
  [SMALL_STATE(5214)] = 67404,
  [SMALL_STATE(5215)] = 67466,
  [SMALL_STATE(5216)] = 67542,
  [SMALL_STATE(5217)] = 67604,
  [SMALL_STATE(5218)] = 67666,
  [SMALL_STATE(5219)] = 67728,
  [SMALL_STATE(5220)] = 67790,
  [SMALL_STATE(5221)] = 67852,
  [SMALL_STATE(5222)] = 67914,
  [SMALL_STATE(5223)] = 67978,
  [SMALL_STATE(5224)] = 68040,
  [SMALL_STATE(5225)] = 68102,
  [SMALL_STATE(5226)] = 68164,
  [SMALL_STATE(5227)] = 68226,
  [SMALL_STATE(5228)] = 68288,
  [SMALL_STATE(5229)] = 68352,
  [SMALL_STATE(5230)] = 68414,
  [SMALL_STATE(5231)] = 68476,
  [SMALL_STATE(5232)] = 68538,
  [SMALL_STATE(5233)] = 68600,
  [SMALL_STATE(5234)] = 68662,
  [SMALL_STATE(5235)] = 68724,
  [SMALL_STATE(5236)] = 68786,
  [SMALL_STATE(5237)] = 68848,
  [SMALL_STATE(5238)] = 68910,
  [SMALL_STATE(5239)] = 68972,
  [SMALL_STATE(5240)] = 69034,
  [SMALL_STATE(5241)] = 69096,
  [SMALL_STATE(5242)] = 69158,
  [SMALL_STATE(5243)] = 69220,
  [SMALL_STATE(5244)] = 69282,
  [SMALL_STATE(5245)] = 69344,
  [SMALL_STATE(5246)] = 69406,
  [SMALL_STATE(5247)] = 69467,
  [SMALL_STATE(5248)] = 69528,
  [SMALL_STATE(5249)] = 69589,
  [SMALL_STATE(5250)] = 69696,
  [SMALL_STATE(5251)] = 69757,
  [SMALL_STATE(5252)] = 69858,
  [SMALL_STATE(5253)] = 69919,
  [SMALL_STATE(5254)] = 69980,
  [SMALL_STATE(5255)] = 70041,
  [SMALL_STATE(5256)] = 70102,
  [SMALL_STATE(5257)] = 70163,
  [SMALL_STATE(5258)] = 70224,
  [SMALL_STATE(5259)] = 70285,
  [SMALL_STATE(5260)] = 70346,
  [SMALL_STATE(5261)] = 70407,
  [SMALL_STATE(5262)] = 70468,
  [SMALL_STATE(5263)] = 70529,
  [SMALL_STATE(5264)] = 70636,
  [SMALL_STATE(5265)] = 70697,
  [SMALL_STATE(5266)] = 70798,
  [SMALL_STATE(5267)] = 70905,
  [SMALL_STATE(5268)] = 71012,
  [SMALL_STATE(5269)] = 71073,
  [SMALL_STATE(5270)] = 71180,
  [SMALL_STATE(5271)] = 71287,
  [SMALL_STATE(5272)] = 71394,
  [SMALL_STATE(5273)] = 71455,
  [SMALL_STATE(5274)] = 71516,
  [SMALL_STATE(5275)] = 71577,
  [SMALL_STATE(5276)] = 71638,
  [SMALL_STATE(5277)] = 71699,
  [SMALL_STATE(5278)] = 71806,
  [SMALL_STATE(5279)] = 71867,
  [SMALL_STATE(5280)] = 71928,
  [SMALL_STATE(5281)] = 71989,
  [SMALL_STATE(5282)] = 72050,
  [SMALL_STATE(5283)] = 72111,
  [SMALL_STATE(5284)] = 72172,
  [SMALL_STATE(5285)] = 72233,
  [SMALL_STATE(5286)] = 72294,
  [SMALL_STATE(5287)] = 72355,
  [SMALL_STATE(5288)] = 72416,
  [SMALL_STATE(5289)] = 72523,
  [SMALL_STATE(5290)] = 72630,
  [SMALL_STATE(5291)] = 72691,
  [SMALL_STATE(5292)] = 72784,
  [SMALL_STATE(5293)] = 72891,
  [SMALL_STATE(5294)] = 72952,
  [SMALL_STATE(5295)] = 73053,
  [SMALL_STATE(5296)] = 73160,
  [SMALL_STATE(5297)] = 73221,
  [SMALL_STATE(5298)] = 73282,
  [SMALL_STATE(5299)] = 73389,
  [SMALL_STATE(5300)] = 73450,
  [SMALL_STATE(5301)] = 73557,
  [SMALL_STATE(5302)] = 73618,
  [SMALL_STATE(5303)] = 73725,
  [SMALL_STATE(5304)] = 73786,
  [SMALL_STATE(5305)] = 73887,
  [SMALL_STATE(5306)] = 73950,
  [SMALL_STATE(5307)] = 74011,
  [SMALL_STATE(5308)] = 74072,
  [SMALL_STATE(5309)] = 74133,
  [SMALL_STATE(5310)] = 74194,
  [SMALL_STATE(5311)] = 74255,
  [SMALL_STATE(5312)] = 74362,
  [SMALL_STATE(5313)] = 74423,
  [SMALL_STATE(5314)] = 74484,
  [SMALL_STATE(5315)] = 74545,
  [SMALL_STATE(5316)] = 74606,
  [SMALL_STATE(5317)] = 74667,
  [SMALL_STATE(5318)] = 74728,
  [SMALL_STATE(5319)] = 74789,
  [SMALL_STATE(5320)] = 74850,
  [SMALL_STATE(5321)] = 74911,
  [SMALL_STATE(5322)] = 74972,
  [SMALL_STATE(5323)] = 75033,
  [SMALL_STATE(5324)] = 75111,
  [SMALL_STATE(5325)] = 75213,
  [SMALL_STATE(5326)] = 75313,
  [SMALL_STATE(5327)] = 75413,
  [SMALL_STATE(5328)] = 75513,
  [SMALL_STATE(5329)] = 75578,
  [SMALL_STATE(5330)] = 75639,
  [SMALL_STATE(5331)] = 75738,
  [SMALL_STATE(5332)] = 75839,
  [SMALL_STATE(5333)] = 75940,
  [SMALL_STATE(5334)] = 76041,
  [SMALL_STATE(5335)] = 76114,
  [SMALL_STATE(5336)] = 76215,
  [SMALL_STATE(5337)] = 76316,
  [SMALL_STATE(5338)] = 76395,
  [SMALL_STATE(5339)] = 76496,
  [SMALL_STATE(5340)] = 76597,
  [SMALL_STATE(5341)] = 76672,
  [SMALL_STATE(5342)] = 76735,
  [SMALL_STATE(5343)] = 76810,
  [SMALL_STATE(5344)] = 76911,
  [SMALL_STATE(5345)] = 76986,
  [SMALL_STATE(5346)] = 77061,
  [SMALL_STATE(5347)] = 77122,
  [SMALL_STATE(5348)] = 77197,
  [SMALL_STATE(5349)] = 77272,
  [SMALL_STATE(5350)] = 77349,
  [SMALL_STATE(5351)] = 77450,
  [SMALL_STATE(5352)] = 77529,
  [SMALL_STATE(5353)] = 77592,
  [SMALL_STATE(5354)] = 77665,
  [SMALL_STATE(5355)] = 77740,
  [SMALL_STATE(5356)] = 77815,
  [SMALL_STATE(5357)] = 77890,
  [SMALL_STATE(5358)] = 77963,
  [SMALL_STATE(5359)] = 78021,
  [SMALL_STATE(5360)] = 78119,
  [SMALL_STATE(5361)] = 78217,
  [SMALL_STATE(5362)] = 78289,
  [SMALL_STATE(5363)] = 78353,
  [SMALL_STATE(5364)] = 78415,
  [SMALL_STATE(5365)] = 78513,
  [SMALL_STATE(5366)] = 78587,
  [SMALL_STATE(5367)] = 78645,
  [SMALL_STATE(5368)] = 78719,
  [SMALL_STATE(5369)] = 78793,
  [SMALL_STATE(5370)] = 78851,
  [SMALL_STATE(5371)] = 78925,
  [SMALL_STATE(5372)] = 79011,
  [SMALL_STATE(5373)] = 79085,
  [SMALL_STATE(5374)] = 79145,
  [SMALL_STATE(5375)] = 79203,
  [SMALL_STATE(5376)] = 79277,
  [SMALL_STATE(5377)] = 79337,
  [SMALL_STATE(5378)] = 79401,
  [SMALL_STATE(5379)] = 79459,
  [SMALL_STATE(5380)] = 79531,
  [SMALL_STATE(5381)] = 79593,
  [SMALL_STATE(5382)] = 79691,
  [SMALL_STATE(5383)] = 79749,
  [SMALL_STATE(5384)] = 79847,
  [SMALL_STATE(5385)] = 79909,
  [SMALL_STATE(5386)] = 79983,
  [SMALL_STATE(5387)] = 80041,
  [SMALL_STATE(5388)] = 80115,
  [SMALL_STATE(5389)] = 80187,
  [SMALL_STATE(5390)] = 80261,
  [SMALL_STATE(5391)] = 80335,
  [SMALL_STATE(5392)] = 80393,
  [SMALL_STATE(5393)] = 80451,
  [SMALL_STATE(5394)] = 80523,
  [SMALL_STATE(5395)] = 80595,
  [SMALL_STATE(5396)] = 80693,
  [SMALL_STATE(5397)] = 80753,
  [SMALL_STATE(5398)] = 80831,
  [SMALL_STATE(5399)] = 80903,
  [SMALL_STATE(5400)] = 81001,
  [SMALL_STATE(5401)] = 81063,
  [SMALL_STATE(5402)] = 81137,
  [SMALL_STATE(5403)] = 81199,
  [SMALL_STATE(5404)] = 81273,
  [SMALL_STATE(5405)] = 81337,
  [SMALL_STATE(5406)] = 81435,
  [SMALL_STATE(5407)] = 81509,
  [SMALL_STATE(5408)] = 81571,
  [SMALL_STATE(5409)] = 81633,
  [SMALL_STATE(5410)] = 81707,
  [SMALL_STATE(5411)] = 81781,
  [SMALL_STATE(5412)] = 81843,
  [SMALL_STATE(5413)] = 81921,
  [SMALL_STATE(5414)] = 81995,
  [SMALL_STATE(5415)] = 82055,
  [SMALL_STATE(5416)] = 82129,
  [SMALL_STATE(5417)] = 82192,
  [SMALL_STATE(5418)] = 82255,
  [SMALL_STATE(5419)] = 82312,
  [SMALL_STATE(5420)] = 82385,
  [SMALL_STATE(5421)] = 82444,
  [SMALL_STATE(5422)] = 82515,
  [SMALL_STATE(5423)] = 82588,
  [SMALL_STATE(5424)] = 82649,
  [SMALL_STATE(5425)] = 82722,
  [SMALL_STATE(5426)] = 82783,
  [SMALL_STATE(5427)] = 82842,
  [SMALL_STATE(5428)] = 82915,
  [SMALL_STATE(5429)] = 82976,
  [SMALL_STATE(5430)] = 83035,
  [SMALL_STATE(5431)] = 83108,
  [SMALL_STATE(5432)] = 83181,
  [SMALL_STATE(5433)] = 83254,
  [SMALL_STATE(5434)] = 83313,
  [SMALL_STATE(5435)] = 83372,
  [SMALL_STATE(5436)] = 83429,
  [SMALL_STATE(5437)] = 83502,
  [SMALL_STATE(5438)] = 83559,
  [SMALL_STATE(5439)] = 83632,
  [SMALL_STATE(5440)] = 83693,
  [SMALL_STATE(5441)] = 83754,
  [SMALL_STATE(5442)] = 83831,
  [SMALL_STATE(5443)] = 83888,
  [SMALL_STATE(5444)] = 83945,
  [SMALL_STATE(5445)] = 84018,
  [SMALL_STATE(5446)] = 84079,
  [SMALL_STATE(5447)] = 84152,
  [SMALL_STATE(5448)] = 84225,
  [SMALL_STATE(5449)] = 84284,
  [SMALL_STATE(5450)] = 84355,
  [SMALL_STATE(5451)] = 84414,
  [SMALL_STATE(5452)] = 84473,
  [SMALL_STATE(5453)] = 84546,
  [SMALL_STATE(5454)] = 84607,
  [SMALL_STATE(5455)] = 84668,
  [SMALL_STATE(5456)] = 84739,
  [SMALL_STATE(5457)] = 84812,
  [SMALL_STATE(5458)] = 84873,
  [SMALL_STATE(5459)] = 84946,
  [SMALL_STATE(5460)] = 85003,
  [SMALL_STATE(5461)] = 85076,
  [SMALL_STATE(5462)] = 85149,
  [SMALL_STATE(5463)] = 85222,
  [SMALL_STATE(5464)] = 85283,
  [SMALL_STATE(5465)] = 85344,
  [SMALL_STATE(5466)] = 85417,
  [SMALL_STATE(5467)] = 85488,
  [SMALL_STATE(5468)] = 85561,
  [SMALL_STATE(5469)] = 85634,
  [SMALL_STATE(5470)] = 85695,
  [SMALL_STATE(5471)] = 85768,
  [SMALL_STATE(5472)] = 85841,
  [SMALL_STATE(5473)] = 85904,
  [SMALL_STATE(5474)] = 85961,
  [SMALL_STATE(5475)] = 86032,
  [SMALL_STATE(5476)] = 86093,
  [SMALL_STATE(5477)] = 86150,
  [SMALL_STATE(5478)] = 86221,
  [SMALL_STATE(5479)] = 86294,
  [SMALL_STATE(5480)] = 86350,
  [SMALL_STATE(5481)] = 86428,
  [SMALL_STATE(5482)] = 86500,
  [SMALL_STATE(5483)] = 86578,
  [SMALL_STATE(5484)] = 86656,
  [SMALL_STATE(5485)] = 86734,
  [SMALL_STATE(5486)] = 86814,
  [SMALL_STATE(5487)] = 86892,
  [SMALL_STATE(5488)] = 86964,
  [SMALL_STATE(5489)] = 87022,
  [SMALL_STATE(5490)] = 87094,
  [SMALL_STATE(5491)] = 87172,
  [SMALL_STATE(5492)] = 87244,
  [SMALL_STATE(5493)] = 87300,
  [SMALL_STATE(5494)] = 87360,
  [SMALL_STATE(5495)] = 87432,
  [SMALL_STATE(5496)] = 87504,
  [SMALL_STATE(5497)] = 87576,
  [SMALL_STATE(5498)] = 87632,
  [SMALL_STATE(5499)] = 87688,
  [SMALL_STATE(5500)] = 87748,
  [SMALL_STATE(5501)] = 87820,
  [SMALL_STATE(5502)] = 87898,
  [SMALL_STATE(5503)] = 87958,
  [SMALL_STATE(5504)] = 88014,
  [SMALL_STATE(5505)] = 88072,
  [SMALL_STATE(5506)] = 88150,
  [SMALL_STATE(5507)] = 88228,
  [SMALL_STATE(5508)] = 88306,
  [SMALL_STATE(5509)] = 88378,
  [SMALL_STATE(5510)] = 88436,
  [SMALL_STATE(5511)] = 88494,
  [SMALL_STATE(5512)] = 88554,
  [SMALL_STATE(5513)] = 88612,
  [SMALL_STATE(5514)] = 88690,
  [SMALL_STATE(5515)] = 88746,
  [SMALL_STATE(5516)] = 88824,
  [SMALL_STATE(5517)] = 88880,
  [SMALL_STATE(5518)] = 88940,
  [SMALL_STATE(5519)] = 88996,
  [SMALL_STATE(5520)] = 89074,
  [SMALL_STATE(5521)] = 89130,
  [SMALL_STATE(5522)] = 89186,
  [SMALL_STATE(5523)] = 89264,
  [SMALL_STATE(5524)] = 89324,
  [SMALL_STATE(5525)] = 89380,
  [SMALL_STATE(5526)] = 89436,
  [SMALL_STATE(5527)] = 89492,
  [SMALL_STATE(5528)] = 89570,
  [SMALL_STATE(5529)] = 89628,
  [SMALL_STATE(5530)] = 89688,
  [SMALL_STATE(5531)] = 89744,
  [SMALL_STATE(5532)] = 89800,
  [SMALL_STATE(5533)] = 89858,
  [SMALL_STATE(5534)] = 89936,
  [SMALL_STATE(5535)] = 89996,
  [SMALL_STATE(5536)] = 90068,
  [SMALL_STATE(5537)] = 90146,
  [SMALL_STATE(5538)] = 90202,
  [SMALL_STATE(5539)] = 90258,
  [SMALL_STATE(5540)] = 90336,
  [SMALL_STATE(5541)] = 90396,
  [SMALL_STATE(5542)] = 90452,
  [SMALL_STATE(5543)] = 90508,
  [SMALL_STATE(5544)] = 90564,
  [SMALL_STATE(5545)] = 90622,
  [SMALL_STATE(5546)] = 90682,
  [SMALL_STATE(5547)] = 90740,
  [SMALL_STATE(5548)] = 90818,
  [SMALL_STATE(5549)] = 90888,
  [SMALL_STATE(5550)] = 90958,
  [SMALL_STATE(5551)] = 91020,
  [SMALL_STATE(5552)] = 91076,
  [SMALL_STATE(5553)] = 91134,
  [SMALL_STATE(5554)] = 91190,
  [SMALL_STATE(5555)] = 91250,
  [SMALL_STATE(5556)] = 91306,
  [SMALL_STATE(5557)] = 91377,
  [SMALL_STATE(5558)] = 91432,
  [SMALL_STATE(5559)] = 91487,
  [SMALL_STATE(5560)] = 91568,
  [SMALL_STATE(5561)] = 91623,
  [SMALL_STATE(5562)] = 91704,
  [SMALL_STATE(5563)] = 91785,
  [SMALL_STATE(5564)] = 91866,
  [SMALL_STATE(5565)] = 91937,
  [SMALL_STATE(5566)] = 92008,
  [SMALL_STATE(5567)] = 92065,
  [SMALL_STATE(5568)] = 92124,
  [SMALL_STATE(5569)] = 92179,
  [SMALL_STATE(5570)] = 92234,
  [SMALL_STATE(5571)] = 92289,
  [SMALL_STATE(5572)] = 92344,
  [SMALL_STATE(5573)] = 92399,
  [SMALL_STATE(5574)] = 92454,
  [SMALL_STATE(5575)] = 92513,
  [SMALL_STATE(5576)] = 92594,
  [SMALL_STATE(5577)] = 92675,
  [SMALL_STATE(5578)] = 92734,
  [SMALL_STATE(5579)] = 92791,
  [SMALL_STATE(5580)] = 92846,
  [SMALL_STATE(5581)] = 92927,
  [SMALL_STATE(5582)] = 93008,
  [SMALL_STATE(5583)] = 93063,
  [SMALL_STATE(5584)] = 93120,
  [SMALL_STATE(5585)] = 93201,
  [SMALL_STATE(5586)] = 93256,
  [SMALL_STATE(5587)] = 93337,
  [SMALL_STATE(5588)] = 93392,
  [SMALL_STATE(5589)] = 93449,
  [SMALL_STATE(5590)] = 93504,
  [SMALL_STATE(5591)] = 93559,
  [SMALL_STATE(5592)] = 93614,
  [SMALL_STATE(5593)] = 93669,
  [SMALL_STATE(5594)] = 93724,
  [SMALL_STATE(5595)] = 93779,
  [SMALL_STATE(5596)] = 93860,
  [SMALL_STATE(5597)] = 93941,
  [SMALL_STATE(5598)] = 93998,
  [SMALL_STATE(5599)] = 94053,
  [SMALL_STATE(5600)] = 94112,
  [SMALL_STATE(5601)] = 94167,
  [SMALL_STATE(5602)] = 94242,
  [SMALL_STATE(5603)] = 94297,
  [SMALL_STATE(5604)] = 94352,
  [SMALL_STATE(5605)] = 94407,
  [SMALL_STATE(5606)] = 94488,
  [SMALL_STATE(5607)] = 94543,
  [SMALL_STATE(5608)] = 94614,
  [SMALL_STATE(5609)] = 94669,
  [SMALL_STATE(5610)] = 94724,
  [SMALL_STATE(5611)] = 94779,
  [SMALL_STATE(5612)] = 94838,
  [SMALL_STATE(5613)] = 94919,
  [SMALL_STATE(5614)] = 94974,
  [SMALL_STATE(5615)] = 95045,
  [SMALL_STATE(5616)] = 95102,
  [SMALL_STATE(5617)] = 95183,
  [SMALL_STATE(5618)] = 95238,
  [SMALL_STATE(5619)] = 95295,
  [SMALL_STATE(5620)] = 95350,
  [SMALL_STATE(5621)] = 95431,
  [SMALL_STATE(5622)] = 95486,
  [SMALL_STATE(5623)] = 95569,
  [SMALL_STATE(5624)] = 95650,
  [SMALL_STATE(5625)] = 95705,
  [SMALL_STATE(5626)] = 95786,
  [SMALL_STATE(5627)] = 95841,
  [SMALL_STATE(5628)] = 95898,
  [SMALL_STATE(5629)] = 95973,
  [SMALL_STATE(5630)] = 96028,
  [SMALL_STATE(5631)] = 96085,
  [SMALL_STATE(5632)] = 96140,
  [SMALL_STATE(5633)] = 96221,
  [SMALL_STATE(5634)] = 96276,
  [SMALL_STATE(5635)] = 96331,
  [SMALL_STATE(5636)] = 96386,
  [SMALL_STATE(5637)] = 96443,
  [SMALL_STATE(5638)] = 96524,
  [SMALL_STATE(5639)] = 96581,
  [SMALL_STATE(5640)] = 96653,
  [SMALL_STATE(5641)] = 96725,
  [SMALL_STATE(5642)] = 96797,
  [SMALL_STATE(5643)] = 96869,
  [SMALL_STATE(5644)] = 96941,
  [SMALL_STATE(5645)] = 97013,
  [SMALL_STATE(5646)] = 97085,
  [SMALL_STATE(5647)] = 97139,
  [SMALL_STATE(5648)] = 97211,
  [SMALL_STATE(5649)] = 97283,
  [SMALL_STATE(5650)] = 97355,
  [SMALL_STATE(5651)] = 97427,
  [SMALL_STATE(5652)] = 97499,
  [SMALL_STATE(5653)] = 97571,
  [SMALL_STATE(5654)] = 97643,
  [SMALL_STATE(5655)] = 97715,
  [SMALL_STATE(5656)] = 97787,
  [SMALL_STATE(5657)] = 97859,
  [SMALL_STATE(5658)] = 97931,
  [SMALL_STATE(5659)] = 98003,
  [SMALL_STATE(5660)] = 98075,
  [SMALL_STATE(5661)] = 98147,
  [SMALL_STATE(5662)] = 98201,
  [SMALL_STATE(5663)] = 98273,
  [SMALL_STATE(5664)] = 98345,
  [SMALL_STATE(5665)] = 98417,
  [SMALL_STATE(5666)] = 98489,
  [SMALL_STATE(5667)] = 98561,
  [SMALL_STATE(5668)] = 98633,
  [SMALL_STATE(5669)] = 98705,
  [SMALL_STATE(5670)] = 98777,
  [SMALL_STATE(5671)] = 98849,
  [SMALL_STATE(5672)] = 98921,
  [SMALL_STATE(5673)] = 98975,
  [SMALL_STATE(5674)] = 99047,
  [SMALL_STATE(5675)] = 99119,
  [SMALL_STATE(5676)] = 99191,
  [SMALL_STATE(5677)] = 99263,
  [SMALL_STATE(5678)] = 99335,
  [SMALL_STATE(5679)] = 99407,
  [SMALL_STATE(5680)] = 99479,
  [SMALL_STATE(5681)] = 99551,
  [SMALL_STATE(5682)] = 99623,
  [SMALL_STATE(5683)] = 99695,
  [SMALL_STATE(5684)] = 99767,
  [SMALL_STATE(5685)] = 99839,
  [SMALL_STATE(5686)] = 99911,
  [SMALL_STATE(5687)] = 99983,
  [SMALL_STATE(5688)] = 100055,
  [SMALL_STATE(5689)] = 100127,
  [SMALL_STATE(5690)] = 100199,
  [SMALL_STATE(5691)] = 100271,
  [SMALL_STATE(5692)] = 100343,
  [SMALL_STATE(5693)] = 100415,
  [SMALL_STATE(5694)] = 100487,
  [SMALL_STATE(5695)] = 100559,
  [SMALL_STATE(5696)] = 100631,
  [SMALL_STATE(5697)] = 100703,
  [SMALL_STATE(5698)] = 100775,
  [SMALL_STATE(5699)] = 100847,
  [SMALL_STATE(5700)] = 100919,
  [SMALL_STATE(5701)] = 100991,
  [SMALL_STATE(5702)] = 101063,
  [SMALL_STATE(5703)] = 101135,
  [SMALL_STATE(5704)] = 101207,
  [SMALL_STATE(5705)] = 101279,
  [SMALL_STATE(5706)] = 101351,
  [SMALL_STATE(5707)] = 101423,
  [SMALL_STATE(5708)] = 101495,
  [SMALL_STATE(5709)] = 101567,
  [SMALL_STATE(5710)] = 101639,
  [SMALL_STATE(5711)] = 101711,
  [SMALL_STATE(5712)] = 101783,
  [SMALL_STATE(5713)] = 101855,
  [SMALL_STATE(5714)] = 101927,
  [SMALL_STATE(5715)] = 101999,
  [SMALL_STATE(5716)] = 102071,
  [SMALL_STATE(5717)] = 102143,
  [SMALL_STATE(5718)] = 102215,
  [SMALL_STATE(5719)] = 102287,
  [SMALL_STATE(5720)] = 102359,
  [SMALL_STATE(5721)] = 102431,
  [SMALL_STATE(5722)] = 102503,
  [SMALL_STATE(5723)] = 102575,
  [SMALL_STATE(5724)] = 102647,
  [SMALL_STATE(5725)] = 102719,
  [SMALL_STATE(5726)] = 102791,
  [SMALL_STATE(5727)] = 102863,
  [SMALL_STATE(5728)] = 102917,
  [SMALL_STATE(5729)] = 102989,
  [SMALL_STATE(5730)] = 103061,
  [SMALL_STATE(5731)] = 103133,
  [SMALL_STATE(5732)] = 103205,
  [SMALL_STATE(5733)] = 103277,
  [SMALL_STATE(5734)] = 103349,
  [SMALL_STATE(5735)] = 103421,
  [SMALL_STATE(5736)] = 103493,
  [SMALL_STATE(5737)] = 103565,
  [SMALL_STATE(5738)] = 103637,
  [SMALL_STATE(5739)] = 103695,
  [SMALL_STATE(5740)] = 103767,
  [SMALL_STATE(5741)] = 103839,
  [SMALL_STATE(5742)] = 103911,
  [SMALL_STATE(5743)] = 103983,
  [SMALL_STATE(5744)] = 104055,
  [SMALL_STATE(5745)] = 104127,
  [SMALL_STATE(5746)] = 104199,
  [SMALL_STATE(5747)] = 104271,
  [SMALL_STATE(5748)] = 104343,
  [SMALL_STATE(5749)] = 104415,
  [SMALL_STATE(5750)] = 104487,
  [SMALL_STATE(5751)] = 104559,
  [SMALL_STATE(5752)] = 104631,
  [SMALL_STATE(5753)] = 104703,
  [SMALL_STATE(5754)] = 104775,
  [SMALL_STATE(5755)] = 104847,
  [SMALL_STATE(5756)] = 104919,
  [SMALL_STATE(5757)] = 104991,
  [SMALL_STATE(5758)] = 105063,
  [SMALL_STATE(5759)] = 105135,
  [SMALL_STATE(5760)] = 105207,
  [SMALL_STATE(5761)] = 105279,
  [SMALL_STATE(5762)] = 105351,
  [SMALL_STATE(5763)] = 105423,
  [SMALL_STATE(5764)] = 105495,
  [SMALL_STATE(5765)] = 105567,
  [SMALL_STATE(5766)] = 105639,
  [SMALL_STATE(5767)] = 105711,
  [SMALL_STATE(5768)] = 105783,
  [SMALL_STATE(5769)] = 105855,
  [SMALL_STATE(5770)] = 105927,
  [SMALL_STATE(5771)] = 105999,
  [SMALL_STATE(5772)] = 106071,
  [SMALL_STATE(5773)] = 106143,
  [SMALL_STATE(5774)] = 106215,
  [SMALL_STATE(5775)] = 106287,
  [SMALL_STATE(5776)] = 106359,
  [SMALL_STATE(5777)] = 106431,
  [SMALL_STATE(5778)] = 106503,
  [SMALL_STATE(5779)] = 106575,
  [SMALL_STATE(5780)] = 106647,
  [SMALL_STATE(5781)] = 106719,
  [SMALL_STATE(5782)] = 106773,
  [SMALL_STATE(5783)] = 106845,
  [SMALL_STATE(5784)] = 106917,
  [SMALL_STATE(5785)] = 106989,
  [SMALL_STATE(5786)] = 107061,
  [SMALL_STATE(5787)] = 107133,
  [SMALL_STATE(5788)] = 107205,
  [SMALL_STATE(5789)] = 107277,
  [SMALL_STATE(5790)] = 107349,
  [SMALL_STATE(5791)] = 107421,
  [SMALL_STATE(5792)] = 107493,
  [SMALL_STATE(5793)] = 107547,
  [SMALL_STATE(5794)] = 107619,
  [SMALL_STATE(5795)] = 107691,
  [SMALL_STATE(5796)] = 107763,
  [SMALL_STATE(5797)] = 107835,
  [SMALL_STATE(5798)] = 107889,
  [SMALL_STATE(5799)] = 107961,
  [SMALL_STATE(5800)] = 108033,
  [SMALL_STATE(5801)] = 108105,
  [SMALL_STATE(5802)] = 108177,
  [SMALL_STATE(5803)] = 108249,
  [SMALL_STATE(5804)] = 108321,
  [SMALL_STATE(5805)] = 108393,
  [SMALL_STATE(5806)] = 108465,
  [SMALL_STATE(5807)] = 108537,
  [SMALL_STATE(5808)] = 108609,
  [SMALL_STATE(5809)] = 108665,
  [SMALL_STATE(5810)] = 108737,
  [SMALL_STATE(5811)] = 108791,
  [SMALL_STATE(5812)] = 108863,
  [SMALL_STATE(5813)] = 108935,
  [SMALL_STATE(5814)] = 109007,
  [SMALL_STATE(5815)] = 109079,
  [SMALL_STATE(5816)] = 109151,
  [SMALL_STATE(5817)] = 109205,
  [SMALL_STATE(5818)] = 109277,
  [SMALL_STATE(5819)] = 109349,
  [SMALL_STATE(5820)] = 109403,
  [SMALL_STATE(5821)] = 109475,
  [SMALL_STATE(5822)] = 109547,
  [SMALL_STATE(5823)] = 109619,
  [SMALL_STATE(5824)] = 109691,
  [SMALL_STATE(5825)] = 109763,
  [SMALL_STATE(5826)] = 109835,
  [SMALL_STATE(5827)] = 109907,
  [SMALL_STATE(5828)] = 109979,
  [SMALL_STATE(5829)] = 110051,
  [SMALL_STATE(5830)] = 110123,
  [SMALL_STATE(5831)] = 110195,
  [SMALL_STATE(5832)] = 110267,
  [SMALL_STATE(5833)] = 110339,
  [SMALL_STATE(5834)] = 110411,
  [SMALL_STATE(5835)] = 110483,
  [SMALL_STATE(5836)] = 110555,
  [SMALL_STATE(5837)] = 110627,
  [SMALL_STATE(5838)] = 110699,
  [SMALL_STATE(5839)] = 110771,
  [SMALL_STATE(5840)] = 110843,
  [SMALL_STATE(5841)] = 110915,
  [SMALL_STATE(5842)] = 110987,
  [SMALL_STATE(5843)] = 111059,
  [SMALL_STATE(5844)] = 111131,
  [SMALL_STATE(5845)] = 111203,
  [SMALL_STATE(5846)] = 111275,
  [SMALL_STATE(5847)] = 111347,
  [SMALL_STATE(5848)] = 111419,
  [SMALL_STATE(5849)] = 111491,
  [SMALL_STATE(5850)] = 111563,
  [SMALL_STATE(5851)] = 111635,
  [SMALL_STATE(5852)] = 111707,
  [SMALL_STATE(5853)] = 111779,
  [SMALL_STATE(5854)] = 111851,
  [SMALL_STATE(5855)] = 111923,
  [SMALL_STATE(5856)] = 111995,
  [SMALL_STATE(5857)] = 112067,
  [SMALL_STATE(5858)] = 112139,
  [SMALL_STATE(5859)] = 112211,
  [SMALL_STATE(5860)] = 112283,
  [SMALL_STATE(5861)] = 112355,
  [SMALL_STATE(5862)] = 112427,
  [SMALL_STATE(5863)] = 112499,
  [SMALL_STATE(5864)] = 112571,
  [SMALL_STATE(5865)] = 112643,
  [SMALL_STATE(5866)] = 112715,
  [SMALL_STATE(5867)] = 112787,
  [SMALL_STATE(5868)] = 112859,
  [SMALL_STATE(5869)] = 112931,
  [SMALL_STATE(5870)] = 113003,
  [SMALL_STATE(5871)] = 113075,
  [SMALL_STATE(5872)] = 113147,
  [SMALL_STATE(5873)] = 113219,
  [SMALL_STATE(5874)] = 113291,
  [SMALL_STATE(5875)] = 113363,
  [SMALL_STATE(5876)] = 113435,
  [SMALL_STATE(5877)] = 113507,
  [SMALL_STATE(5878)] = 113579,
  [SMALL_STATE(5879)] = 113651,
  [SMALL_STATE(5880)] = 113723,
  [SMALL_STATE(5881)] = 113795,
  [SMALL_STATE(5882)] = 113867,
  [SMALL_STATE(5883)] = 113939,
  [SMALL_STATE(5884)] = 114011,
  [SMALL_STATE(5885)] = 114083,
  [SMALL_STATE(5886)] = 114155,
  [SMALL_STATE(5887)] = 114227,
  [SMALL_STATE(5888)] = 114299,
  [SMALL_STATE(5889)] = 114371,
  [SMALL_STATE(5890)] = 114443,
  [SMALL_STATE(5891)] = 114515,
  [SMALL_STATE(5892)] = 114587,
  [SMALL_STATE(5893)] = 114659,
  [SMALL_STATE(5894)] = 114731,
  [SMALL_STATE(5895)] = 114803,
  [SMALL_STATE(5896)] = 114875,
  [SMALL_STATE(5897)] = 114947,
  [SMALL_STATE(5898)] = 115019,
  [SMALL_STATE(5899)] = 115091,
  [SMALL_STATE(5900)] = 115163,
  [SMALL_STATE(5901)] = 115235,
  [SMALL_STATE(5902)] = 115289,
  [SMALL_STATE(5903)] = 115361,
  [SMALL_STATE(5904)] = 115433,
  [SMALL_STATE(5905)] = 115505,
  [SMALL_STATE(5906)] = 115577,
  [SMALL_STATE(5907)] = 115649,
  [SMALL_STATE(5908)] = 115721,
  [SMALL_STATE(5909)] = 115793,
  [SMALL_STATE(5910)] = 115865,
  [SMALL_STATE(5911)] = 115937,
  [SMALL_STATE(5912)] = 116009,
  [SMALL_STATE(5913)] = 116081,
  [SMALL_STATE(5914)] = 116153,
  [SMALL_STATE(5915)] = 116225,
  [SMALL_STATE(5916)] = 116297,
  [SMALL_STATE(5917)] = 116369,
  [SMALL_STATE(5918)] = 116441,
  [SMALL_STATE(5919)] = 116513,
  [SMALL_STATE(5920)] = 116585,
  [SMALL_STATE(5921)] = 116657,
  [SMALL_STATE(5922)] = 116729,
  [SMALL_STATE(5923)] = 116801,
  [SMALL_STATE(5924)] = 116873,
  [SMALL_STATE(5925)] = 116945,
  [SMALL_STATE(5926)] = 117017,
  [SMALL_STATE(5927)] = 117089,
  [SMALL_STATE(5928)] = 117161,
  [SMALL_STATE(5929)] = 117215,
  [SMALL_STATE(5930)] = 117287,
  [SMALL_STATE(5931)] = 117359,
  [SMALL_STATE(5932)] = 117431,
  [SMALL_STATE(5933)] = 117503,
  [SMALL_STATE(5934)] = 117575,
  [SMALL_STATE(5935)] = 117647,
  [SMALL_STATE(5936)] = 117719,
  [SMALL_STATE(5937)] = 117791,
  [SMALL_STATE(5938)] = 117863,
  [SMALL_STATE(5939)] = 117935,
  [SMALL_STATE(5940)] = 118007,
  [SMALL_STATE(5941)] = 118079,
  [SMALL_STATE(5942)] = 118133,
  [SMALL_STATE(5943)] = 118205,
  [SMALL_STATE(5944)] = 118277,
  [SMALL_STATE(5945)] = 118349,
  [SMALL_STATE(5946)] = 118421,
  [SMALL_STATE(5947)] = 118493,
  [SMALL_STATE(5948)] = 118565,
  [SMALL_STATE(5949)] = 118637,
  [SMALL_STATE(5950)] = 118709,
  [SMALL_STATE(5951)] = 118781,
  [SMALL_STATE(5952)] = 118853,
  [SMALL_STATE(5953)] = 118925,
  [SMALL_STATE(5954)] = 118997,
  [SMALL_STATE(5955)] = 119069,
  [SMALL_STATE(5956)] = 119141,
  [SMALL_STATE(5957)] = 119213,
  [SMALL_STATE(5958)] = 119285,
  [SMALL_STATE(5959)] = 119357,
  [SMALL_STATE(5960)] = 119429,
  [SMALL_STATE(5961)] = 119501,
  [SMALL_STATE(5962)] = 119573,
  [SMALL_STATE(5963)] = 119627,
  [SMALL_STATE(5964)] = 119699,
  [SMALL_STATE(5965)] = 119771,
  [SMALL_STATE(5966)] = 119843,
  [SMALL_STATE(5967)] = 119915,
  [SMALL_STATE(5968)] = 119987,
  [SMALL_STATE(5969)] = 120059,
  [SMALL_STATE(5970)] = 120131,
  [SMALL_STATE(5971)] = 120213,
  [SMALL_STATE(5972)] = 120285,
  [SMALL_STATE(5973)] = 120357,
  [SMALL_STATE(5974)] = 120429,
  [SMALL_STATE(5975)] = 120501,
  [SMALL_STATE(5976)] = 120573,
  [SMALL_STATE(5977)] = 120645,
  [SMALL_STATE(5978)] = 120717,
  [SMALL_STATE(5979)] = 120789,
  [SMALL_STATE(5980)] = 120861,
  [SMALL_STATE(5981)] = 120933,
  [SMALL_STATE(5982)] = 121005,
  [SMALL_STATE(5983)] = 121077,
  [SMALL_STATE(5984)] = 121149,
  [SMALL_STATE(5985)] = 121221,
  [SMALL_STATE(5986)] = 121293,
  [SMALL_STATE(5987)] = 121365,
  [SMALL_STATE(5988)] = 121437,
  [SMALL_STATE(5989)] = 121509,
  [SMALL_STATE(5990)] = 121581,
  [SMALL_STATE(5991)] = 121653,
  [SMALL_STATE(5992)] = 121725,
  [SMALL_STATE(5993)] = 121797,
  [SMALL_STATE(5994)] = 121869,
  [SMALL_STATE(5995)] = 121941,
  [SMALL_STATE(5996)] = 122013,
  [SMALL_STATE(5997)] = 122067,
  [SMALL_STATE(5998)] = 122139,
  [SMALL_STATE(5999)] = 122211,
  [SMALL_STATE(6000)] = 122283,
  [SMALL_STATE(6001)] = 122355,
  [SMALL_STATE(6002)] = 122427,
  [SMALL_STATE(6003)] = 122499,
  [SMALL_STATE(6004)] = 122571,
  [SMALL_STATE(6005)] = 122643,
  [SMALL_STATE(6006)] = 122715,
  [SMALL_STATE(6007)] = 122787,
  [SMALL_STATE(6008)] = 122859,
  [SMALL_STATE(6009)] = 122931,
  [SMALL_STATE(6010)] = 122985,
  [SMALL_STATE(6011)] = 123057,
  [SMALL_STATE(6012)] = 123129,
  [SMALL_STATE(6013)] = 123201,
  [SMALL_STATE(6014)] = 123273,
  [SMALL_STATE(6015)] = 123345,
  [SMALL_STATE(6016)] = 123417,
  [SMALL_STATE(6017)] = 123489,
  [SMALL_STATE(6018)] = 123561,
  [SMALL_STATE(6019)] = 123633,
  [SMALL_STATE(6020)] = 123705,
  [SMALL_STATE(6021)] = 123777,
  [SMALL_STATE(6022)] = 123849,
  [SMALL_STATE(6023)] = 123921,
  [SMALL_STATE(6024)] = 123993,
  [SMALL_STATE(6025)] = 124065,
  [SMALL_STATE(6026)] = 124137,
  [SMALL_STATE(6027)] = 124209,
  [SMALL_STATE(6028)] = 124281,
  [SMALL_STATE(6029)] = 124353,
  [SMALL_STATE(6030)] = 124425,
  [SMALL_STATE(6031)] = 124497,
  [SMALL_STATE(6032)] = 124569,
  [SMALL_STATE(6033)] = 124641,
  [SMALL_STATE(6034)] = 124695,
  [SMALL_STATE(6035)] = 124767,
  [SMALL_STATE(6036)] = 124839,
  [SMALL_STATE(6037)] = 124911,
  [SMALL_STATE(6038)] = 124983,
  [SMALL_STATE(6039)] = 125055,
  [SMALL_STATE(6040)] = 125127,
  [SMALL_STATE(6041)] = 125199,
  [SMALL_STATE(6042)] = 125271,
  [SMALL_STATE(6043)] = 125343,
  [SMALL_STATE(6044)] = 125415,
  [SMALL_STATE(6045)] = 125487,
  [SMALL_STATE(6046)] = 125559,
  [SMALL_STATE(6047)] = 125615,
  [SMALL_STATE(6048)] = 125687,
  [SMALL_STATE(6049)] = 125759,
  [SMALL_STATE(6050)] = 125831,
  [SMALL_STATE(6051)] = 125903,
  [SMALL_STATE(6052)] = 125975,
  [SMALL_STATE(6053)] = 126047,
  [SMALL_STATE(6054)] = 126119,
  [SMALL_STATE(6055)] = 126191,
  [SMALL_STATE(6056)] = 126263,
  [SMALL_STATE(6057)] = 126335,
  [SMALL_STATE(6058)] = 126407,
  [SMALL_STATE(6059)] = 126479,
  [SMALL_STATE(6060)] = 126551,
  [SMALL_STATE(6061)] = 126623,
  [SMALL_STATE(6062)] = 126695,
  [SMALL_STATE(6063)] = 126767,
  [SMALL_STATE(6064)] = 126839,
  [SMALL_STATE(6065)] = 126911,
  [SMALL_STATE(6066)] = 126983,
  [SMALL_STATE(6067)] = 127055,
  [SMALL_STATE(6068)] = 127127,
  [SMALL_STATE(6069)] = 127199,
  [SMALL_STATE(6070)] = 127271,
  [SMALL_STATE(6071)] = 127343,
  [SMALL_STATE(6072)] = 127415,
  [SMALL_STATE(6073)] = 127487,
  [SMALL_STATE(6074)] = 127559,
  [SMALL_STATE(6075)] = 127631,
  [SMALL_STATE(6076)] = 127703,
  [SMALL_STATE(6077)] = 127775,
  [SMALL_STATE(6078)] = 127847,
  [SMALL_STATE(6079)] = 127919,
  [SMALL_STATE(6080)] = 127991,
  [SMALL_STATE(6081)] = 128063,
  [SMALL_STATE(6082)] = 128135,
  [SMALL_STATE(6083)] = 128207,
  [SMALL_STATE(6084)] = 128261,
  [SMALL_STATE(6085)] = 128333,
  [SMALL_STATE(6086)] = 128387,
  [SMALL_STATE(6087)] = 128459,
  [SMALL_STATE(6088)] = 128531,
  [SMALL_STATE(6089)] = 128603,
  [SMALL_STATE(6090)] = 128675,
  [SMALL_STATE(6091)] = 128747,
  [SMALL_STATE(6092)] = 128819,
  [SMALL_STATE(6093)] = 128891,
  [SMALL_STATE(6094)] = 128963,
  [SMALL_STATE(6095)] = 129017,
  [SMALL_STATE(6096)] = 129089,
  [SMALL_STATE(6097)] = 129161,
  [SMALL_STATE(6098)] = 129233,
  [SMALL_STATE(6099)] = 129305,
  [SMALL_STATE(6100)] = 129377,
  [SMALL_STATE(6101)] = 129449,
  [SMALL_STATE(6102)] = 129521,
  [SMALL_STATE(6103)] = 129593,
  [SMALL_STATE(6104)] = 129665,
  [SMALL_STATE(6105)] = 129737,
  [SMALL_STATE(6106)] = 129809,
  [SMALL_STATE(6107)] = 129881,
  [SMALL_STATE(6108)] = 129953,
  [SMALL_STATE(6109)] = 130025,
  [SMALL_STATE(6110)] = 130097,
  [SMALL_STATE(6111)] = 130169,
  [SMALL_STATE(6112)] = 130223,
  [SMALL_STATE(6113)] = 130277,
  [SMALL_STATE(6114)] = 130349,
  [SMALL_STATE(6115)] = 130421,
  [SMALL_STATE(6116)] = 130475,
  [SMALL_STATE(6117)] = 130529,
  [SMALL_STATE(6118)] = 130601,
  [SMALL_STATE(6119)] = 130673,
  [SMALL_STATE(6120)] = 130745,
  [SMALL_STATE(6121)] = 130817,
  [SMALL_STATE(6122)] = 130889,
  [SMALL_STATE(6123)] = 130943,
  [SMALL_STATE(6124)] = 131015,
  [SMALL_STATE(6125)] = 131069,
  [SMALL_STATE(6126)] = 131123,
  [SMALL_STATE(6127)] = 131177,
  [SMALL_STATE(6128)] = 131231,
  [SMALL_STATE(6129)] = 131285,
  [SMALL_STATE(6130)] = 131357,
  [SMALL_STATE(6131)] = 131411,
  [SMALL_STATE(6132)] = 131483,
  [SMALL_STATE(6133)] = 131555,
  [SMALL_STATE(6134)] = 131627,
  [SMALL_STATE(6135)] = 131699,
  [SMALL_STATE(6136)] = 131771,
  [SMALL_STATE(6137)] = 131843,
  [SMALL_STATE(6138)] = 131915,
  [SMALL_STATE(6139)] = 131987,
  [SMALL_STATE(6140)] = 132059,
  [SMALL_STATE(6141)] = 132131,
  [SMALL_STATE(6142)] = 132203,
  [SMALL_STATE(6143)] = 132275,
  [SMALL_STATE(6144)] = 132347,
  [SMALL_STATE(6145)] = 132419,
  [SMALL_STATE(6146)] = 132473,
  [SMALL_STATE(6147)] = 132545,
  [SMALL_STATE(6148)] = 132617,
  [SMALL_STATE(6149)] = 132689,
  [SMALL_STATE(6150)] = 132761,
  [SMALL_STATE(6151)] = 132833,
  [SMALL_STATE(6152)] = 132905,
  [SMALL_STATE(6153)] = 132977,
  [SMALL_STATE(6154)] = 133049,
  [SMALL_STATE(6155)] = 133103,
  [SMALL_STATE(6156)] = 133175,
  [SMALL_STATE(6157)] = 133247,
  [SMALL_STATE(6158)] = 133319,
  [SMALL_STATE(6159)] = 133391,
  [SMALL_STATE(6160)] = 133463,
  [SMALL_STATE(6161)] = 133517,
  [SMALL_STATE(6162)] = 133571,
  [SMALL_STATE(6163)] = 133643,
  [SMALL_STATE(6164)] = 133715,
  [SMALL_STATE(6165)] = 133771,
  [SMALL_STATE(6166)] = 133843,
  [SMALL_STATE(6167)] = 133915,
  [SMALL_STATE(6168)] = 133987,
  [SMALL_STATE(6169)] = 134041,
  [SMALL_STATE(6170)] = 134095,
  [SMALL_STATE(6171)] = 134167,
  [SMALL_STATE(6172)] = 134239,
  [SMALL_STATE(6173)] = 134311,
  [SMALL_STATE(6174)] = 134383,
  [SMALL_STATE(6175)] = 134437,
  [SMALL_STATE(6176)] = 134491,
  [SMALL_STATE(6177)] = 134563,
  [SMALL_STATE(6178)] = 134635,
  [SMALL_STATE(6179)] = 134707,
  [SMALL_STATE(6180)] = 134779,
  [SMALL_STATE(6181)] = 134851,
  [SMALL_STATE(6182)] = 134923,
  [SMALL_STATE(6183)] = 134977,
  [SMALL_STATE(6184)] = 135033,
  [SMALL_STATE(6185)] = 135087,
  [SMALL_STATE(6186)] = 135141,
  [SMALL_STATE(6187)] = 135195,
  [SMALL_STATE(6188)] = 135267,
  [SMALL_STATE(6189)] = 135339,
  [SMALL_STATE(6190)] = 135411,
  [SMALL_STATE(6191)] = 135483,
  [SMALL_STATE(6192)] = 135555,
  [SMALL_STATE(6193)] = 135627,
  [SMALL_STATE(6194)] = 135699,
  [SMALL_STATE(6195)] = 135771,
  [SMALL_STATE(6196)] = 135830,
  [SMALL_STATE(6197)] = 135887,
  [SMALL_STATE(6198)] = 135964,
  [SMALL_STATE(6199)] = 136021,
  [SMALL_STATE(6200)] = 136094,
  [SMALL_STATE(6201)] = 136151,
  [SMALL_STATE(6202)] = 136206,
  [SMALL_STATE(6203)] = 136258,
  [SMALL_STATE(6204)] = 136340,
  [SMALL_STATE(6205)] = 136392,
  [SMALL_STATE(6206)] = 136476,
  [SMALL_STATE(6207)] = 136560,
  [SMALL_STATE(6208)] = 136614,
  [SMALL_STATE(6209)] = 136666,
  [SMALL_STATE(6210)] = 136718,
  [SMALL_STATE(6211)] = 136774,
  [SMALL_STATE(6212)] = 136840,
  [SMALL_STATE(6213)] = 136892,
  [SMALL_STATE(6214)] = 136944,
  [SMALL_STATE(6215)] = 137000,
  [SMALL_STATE(6216)] = 137084,
  [SMALL_STATE(6217)] = 137136,
  [SMALL_STATE(6218)] = 137202,
  [SMALL_STATE(6219)] = 137254,
  [SMALL_STATE(6220)] = 137312,
  [SMALL_STATE(6221)] = 137364,
  [SMALL_STATE(6222)] = 137448,
  [SMALL_STATE(6223)] = 137532,
  [SMALL_STATE(6224)] = 137586,
  [SMALL_STATE(6225)] = 137640,
  [SMALL_STATE(6226)] = 137694,
  [SMALL_STATE(6227)] = 137748,
  [SMALL_STATE(6228)] = 137802,
  [SMALL_STATE(6229)] = 137854,
  [SMALL_STATE(6230)] = 137908,
  [SMALL_STATE(6231)] = 137962,
  [SMALL_STATE(6232)] = 138014,
  [SMALL_STATE(6233)] = 138070,
  [SMALL_STATE(6234)] = 138124,
  [SMALL_STATE(6235)] = 138180,
  [SMALL_STATE(6236)] = 138234,
  [SMALL_STATE(6237)] = 138286,
  [SMALL_STATE(6238)] = 138338,
  [SMALL_STATE(6239)] = 138390,
  [SMALL_STATE(6240)] = 138442,
  [SMALL_STATE(6241)] = 138510,
  [SMALL_STATE(6242)] = 138568,
  [SMALL_STATE(6243)] = 138620,
  [SMALL_STATE(6244)] = 138672,
  [SMALL_STATE(6245)] = 138724,
  [SMALL_STATE(6246)] = 138776,
  [SMALL_STATE(6247)] = 138832,
  [SMALL_STATE(6248)] = 138884,
  [SMALL_STATE(6249)] = 138936,
  [SMALL_STATE(6250)] = 138990,
  [SMALL_STATE(6251)] = 139042,
  [SMALL_STATE(6252)] = 139110,
  [SMALL_STATE(6253)] = 139162,
  [SMALL_STATE(6254)] = 139214,
  [SMALL_STATE(6255)] = 139298,
  [SMALL_STATE(6256)] = 139364,
  [SMALL_STATE(6257)] = 139416,
  [SMALL_STATE(6258)] = 139468,
  [SMALL_STATE(6259)] = 139534,
  [SMALL_STATE(6260)] = 139586,
  [SMALL_STATE(6261)] = 139638,
  [SMALL_STATE(6262)] = 139690,
  [SMALL_STATE(6263)] = 139742,
  [SMALL_STATE(6264)] = 139826,
  [SMALL_STATE(6265)] = 139878,
  [SMALL_STATE(6266)] = 139962,
  [SMALL_STATE(6267)] = 140014,
  [SMALL_STATE(6268)] = 140066,
  [SMALL_STATE(6269)] = 140118,
  [SMALL_STATE(6270)] = 140170,
  [SMALL_STATE(6271)] = 140238,
  [SMALL_STATE(6272)] = 140306,
  [SMALL_STATE(6273)] = 140390,
  [SMALL_STATE(6274)] = 140446,
  [SMALL_STATE(6275)] = 140530,
  [SMALL_STATE(6276)] = 140614,
  [SMALL_STATE(6277)] = 140666,
  [SMALL_STATE(6278)] = 140722,
  [SMALL_STATE(6279)] = 140806,
  [SMALL_STATE(6280)] = 140860,
  [SMALL_STATE(6281)] = 140944,
  [SMALL_STATE(6282)] = 140996,
  [SMALL_STATE(6283)] = 141048,
  [SMALL_STATE(6284)] = 141132,
  [SMALL_STATE(6285)] = 141184,
  [SMALL_STATE(6286)] = 141236,
  [SMALL_STATE(6287)] = 141304,
  [SMALL_STATE(6288)] = 141356,
  [SMALL_STATE(6289)] = 141408,
  [SMALL_STATE(6290)] = 141466,
  [SMALL_STATE(6291)] = 141550,
  [SMALL_STATE(6292)] = 141602,
  [SMALL_STATE(6293)] = 141654,
  [SMALL_STATE(6294)] = 141712,
  [SMALL_STATE(6295)] = 141764,
  [SMALL_STATE(6296)] = 141848,
  [SMALL_STATE(6297)] = 141916,
  [SMALL_STATE(6298)] = 142000,
  [SMALL_STATE(6299)] = 142052,
  [SMALL_STATE(6300)] = 142136,
  [SMALL_STATE(6301)] = 142204,
  [SMALL_STATE(6302)] = 142256,
  [SMALL_STATE(6303)] = 142340,
  [SMALL_STATE(6304)] = 142398,
  [SMALL_STATE(6305)] = 142482,
  [SMALL_STATE(6306)] = 142550,
  [SMALL_STATE(6307)] = 142608,
  [SMALL_STATE(6308)] = 142660,
  [SMALL_STATE(6309)] = 142736,
  [SMALL_STATE(6310)] = 142803,
  [SMALL_STATE(6311)] = 142854,
  [SMALL_STATE(6312)] = 142921,
  [SMALL_STATE(6313)] = 142972,
  [SMALL_STATE(6314)] = 143027,
  [SMALL_STATE(6315)] = 143094,
  [SMALL_STATE(6316)] = 143145,
  [SMALL_STATE(6317)] = 143196,
  [SMALL_STATE(6318)] = 143247,
  [SMALL_STATE(6319)] = 143298,
  [SMALL_STATE(6320)] = 143349,
  [SMALL_STATE(6321)] = 143400,
  [SMALL_STATE(6322)] = 143455,
  [SMALL_STATE(6323)] = 143506,
  [SMALL_STATE(6324)] = 143557,
  [SMALL_STATE(6325)] = 143612,
  [SMALL_STATE(6326)] = 143663,
  [SMALL_STATE(6327)] = 143718,
  [SMALL_STATE(6328)] = 143769,
  [SMALL_STATE(6329)] = 143820,
  [SMALL_STATE(6330)] = 143887,
  [SMALL_STATE(6331)] = 143938,
  [SMALL_STATE(6332)] = 143989,
  [SMALL_STATE(6333)] = 144040,
  [SMALL_STATE(6334)] = 144091,
  [SMALL_STATE(6335)] = 144172,
  [SMALL_STATE(6336)] = 144239,
  [SMALL_STATE(6337)] = 144294,
  [SMALL_STATE(6338)] = 144345,
  [SMALL_STATE(6339)] = 144400,
  [SMALL_STATE(6340)] = 144451,
  [SMALL_STATE(6341)] = 144504,
  [SMALL_STATE(6342)] = 144555,
  [SMALL_STATE(6343)] = 144606,
  [SMALL_STATE(6344)] = 144657,
  [SMALL_STATE(6345)] = 144708,
  [SMALL_STATE(6346)] = 144759,
  [SMALL_STATE(6347)] = 144810,
  [SMALL_STATE(6348)] = 144861,
  [SMALL_STATE(6349)] = 144912,
  [SMALL_STATE(6350)] = 144963,
  [SMALL_STATE(6351)] = 145014,
  [SMALL_STATE(6352)] = 145065,
  [SMALL_STATE(6353)] = 145118,
  [SMALL_STATE(6354)] = 145169,
  [SMALL_STATE(6355)] = 145220,
  [SMALL_STATE(6356)] = 145275,
  [SMALL_STATE(6357)] = 145326,
  [SMALL_STATE(6358)] = 145393,
  [SMALL_STATE(6359)] = 145444,
  [SMALL_STATE(6360)] = 145495,
  [SMALL_STATE(6361)] = 145562,
  [SMALL_STATE(6362)] = 145613,
  [SMALL_STATE(6363)] = 145664,
  [SMALL_STATE(6364)] = 145717,
  [SMALL_STATE(6365)] = 145798,
  [SMALL_STATE(6366)] = 145849,
  [SMALL_STATE(6367)] = 145904,
  [SMALL_STATE(6368)] = 145955,
  [SMALL_STATE(6369)] = 146006,
  [SMALL_STATE(6370)] = 146057,
  [SMALL_STATE(6371)] = 146108,
  [SMALL_STATE(6372)] = 146159,
  [SMALL_STATE(6373)] = 146226,
  [SMALL_STATE(6374)] = 146277,
  [SMALL_STATE(6375)] = 146328,
  [SMALL_STATE(6376)] = 146379,
  [SMALL_STATE(6377)] = 146446,
  [SMALL_STATE(6378)] = 146497,
  [SMALL_STATE(6379)] = 146548,
  [SMALL_STATE(6380)] = 146599,
  [SMALL_STATE(6381)] = 146654,
  [SMALL_STATE(6382)] = 146735,
  [SMALL_STATE(6383)] = 146786,
  [SMALL_STATE(6384)] = 146837,
  [SMALL_STATE(6385)] = 146888,
  [SMALL_STATE(6386)] = 146939,
  [SMALL_STATE(6387)] = 146990,
  [SMALL_STATE(6388)] = 147043,
  [SMALL_STATE(6389)] = 147094,
  [SMALL_STATE(6390)] = 147165,
  [SMALL_STATE(6391)] = 147216,
  [SMALL_STATE(6392)] = 147267,
  [SMALL_STATE(6393)] = 147318,
  [SMALL_STATE(6394)] = 147369,
  [SMALL_STATE(6395)] = 147420,
  [SMALL_STATE(6396)] = 147473,
  [SMALL_STATE(6397)] = 147524,
  [SMALL_STATE(6398)] = 147575,
  [SMALL_STATE(6399)] = 147642,
  [SMALL_STATE(6400)] = 147693,
  [SMALL_STATE(6401)] = 147744,
  [SMALL_STATE(6402)] = 147799,
  [SMALL_STATE(6403)] = 147850,
  [SMALL_STATE(6404)] = 147903,
  [SMALL_STATE(6405)] = 147956,
  [SMALL_STATE(6406)] = 148007,
  [SMALL_STATE(6407)] = 148088,
  [SMALL_STATE(6408)] = 148139,
  [SMALL_STATE(6409)] = 148192,
  [SMALL_STATE(6410)] = 148243,
  [SMALL_STATE(6411)] = 148294,
  [SMALL_STATE(6412)] = 148347,
  [SMALL_STATE(6413)] = 148398,
  [SMALL_STATE(6414)] = 148451,
  [SMALL_STATE(6415)] = 148506,
  [SMALL_STATE(6416)] = 148559,
  [SMALL_STATE(6417)] = 148613,
  [SMALL_STATE(6418)] = 148665,
  [SMALL_STATE(6419)] = 148715,
  [SMALL_STATE(6420)] = 148767,
  [SMALL_STATE(6421)] = 148819,
  [SMALL_STATE(6422)] = 148885,
  [SMALL_STATE(6423)] = 148937,
  [SMALL_STATE(6424)] = 148989,
  [SMALL_STATE(6425)] = 149055,
  [SMALL_STATE(6426)] = 149105,
  [SMALL_STATE(6427)] = 149155,
  [SMALL_STATE(6428)] = 149221,
  [SMALL_STATE(6429)] = 149287,
  [SMALL_STATE(6430)] = 149339,
  [SMALL_STATE(6431)] = 149389,
  [SMALL_STATE(6432)] = 149441,
  [SMALL_STATE(6433)] = 149493,
  [SMALL_STATE(6434)] = 149571,
  [SMALL_STATE(6435)] = 149621,
  [SMALL_STATE(6436)] = 149671,
  [SMALL_STATE(6437)] = 149723,
  [SMALL_STATE(6438)] = 149775,
  [SMALL_STATE(6439)] = 149825,
  [SMALL_STATE(6440)] = 149891,
  [SMALL_STATE(6441)] = 149957,
  [SMALL_STATE(6442)] = 150009,
  [SMALL_STATE(6443)] = 150061,
  [SMALL_STATE(6444)] = 150113,
  [SMALL_STATE(6445)] = 150163,
  [SMALL_STATE(6446)] = 150213,
  [SMALL_STATE(6447)] = 150263,
  [SMALL_STATE(6448)] = 150317,
  [SMALL_STATE(6449)] = 150369,
  [SMALL_STATE(6450)] = 150435,
  [SMALL_STATE(6451)] = 150489,
  [SMALL_STATE(6452)] = 150543,
  [SMALL_STATE(6453)] = 150595,
  [SMALL_STATE(6454)] = 150647,
  [SMALL_STATE(6455)] = 150699,
  [SMALL_STATE(6456)] = 150765,
  [SMALL_STATE(6457)] = 150817,
  [SMALL_STATE(6458)] = 150867,
  [SMALL_STATE(6459)] = 150917,
  [SMALL_STATE(6460)] = 150969,
  [SMALL_STATE(6461)] = 151035,
  [SMALL_STATE(6462)] = 151085,
  [SMALL_STATE(6463)] = 151165,
  [SMALL_STATE(6464)] = 151217,
  [SMALL_STATE(6465)] = 151267,
  [SMALL_STATE(6466)] = 151317,
  [SMALL_STATE(6467)] = 151367,
  [SMALL_STATE(6468)] = 151417,
  [SMALL_STATE(6469)] = 151467,
  [SMALL_STATE(6470)] = 151519,
  [SMALL_STATE(6471)] = 151569,
  [SMALL_STATE(6472)] = 151619,
  [SMALL_STATE(6473)] = 151669,
  [SMALL_STATE(6474)] = 151719,
  [SMALL_STATE(6475)] = 151769,
  [SMALL_STATE(6476)] = 151823,
  [SMALL_STATE(6477)] = 151875,
  [SMALL_STATE(6478)] = 151925,
  [SMALL_STATE(6479)] = 151975,
  [SMALL_STATE(6480)] = 152025,
  [SMALL_STATE(6481)] = 152079,
  [SMALL_STATE(6482)] = 152129,
  [SMALL_STATE(6483)] = 152179,
  [SMALL_STATE(6484)] = 152231,
  [SMALL_STATE(6485)] = 152281,
  [SMALL_STATE(6486)] = 152331,
  [SMALL_STATE(6487)] = 152381,
  [SMALL_STATE(6488)] = 152431,
  [SMALL_STATE(6489)] = 152483,
  [SMALL_STATE(6490)] = 152533,
  [SMALL_STATE(6491)] = 152583,
  [SMALL_STATE(6492)] = 152633,
  [SMALL_STATE(6493)] = 152683,
  [SMALL_STATE(6494)] = 152733,
  [SMALL_STATE(6495)] = 152783,
  [SMALL_STATE(6496)] = 152833,
  [SMALL_STATE(6497)] = 152885,
  [SMALL_STATE(6498)] = 152935,
  [SMALL_STATE(6499)] = 152985,
  [SMALL_STATE(6500)] = 153055,
  [SMALL_STATE(6501)] = 153107,
  [SMALL_STATE(6502)] = 153161,
  [SMALL_STATE(6503)] = 153211,
  [SMALL_STATE(6504)] = 153261,
  [SMALL_STATE(6505)] = 153315,
  [SMALL_STATE(6506)] = 153365,
  [SMALL_STATE(6507)] = 153415,
  [SMALL_STATE(6508)] = 153465,
  [SMALL_STATE(6509)] = 153515,
  [SMALL_STATE(6510)] = 153565,
  [SMALL_STATE(6511)] = 153615,
  [SMALL_STATE(6512)] = 153681,
  [SMALL_STATE(6513)] = 153731,
  [SMALL_STATE(6514)] = 153781,
  [SMALL_STATE(6515)] = 153833,
  [SMALL_STATE(6516)] = 153887,
  [SMALL_STATE(6517)] = 153941,
  [SMALL_STATE(6518)] = 153995,
  [SMALL_STATE(6519)] = 154047,
  [SMALL_STATE(6520)] = 154097,
  [SMALL_STATE(6521)] = 154147,
  [SMALL_STATE(6522)] = 154201,
  [SMALL_STATE(6523)] = 154251,
  [SMALL_STATE(6524)] = 154301,
  [SMALL_STATE(6525)] = 154351,
  [SMALL_STATE(6526)] = 154421,
  [SMALL_STATE(6527)] = 154475,
  [SMALL_STATE(6528)] = 154555,
  [SMALL_STATE(6529)] = 154605,
  [SMALL_STATE(6530)] = 154655,
  [SMALL_STATE(6531)] = 154705,
  [SMALL_STATE(6532)] = 154759,
  [SMALL_STATE(6533)] = 154809,
  [SMALL_STATE(6534)] = 154861,
  [SMALL_STATE(6535)] = 154910,
  [SMALL_STATE(6536)] = 154961,
  [SMALL_STATE(6537)] = 155026,
  [SMALL_STATE(6538)] = 155091,
  [SMALL_STATE(6539)] = 155142,
  [SMALL_STATE(6540)] = 155195,
  [SMALL_STATE(6541)] = 155244,
  [SMALL_STATE(6542)] = 155309,
  [SMALL_STATE(6543)] = 155374,
  [SMALL_STATE(6544)] = 155423,
  [SMALL_STATE(6545)] = 155472,
  [SMALL_STATE(6546)] = 155521,
  [SMALL_STATE(6547)] = 155586,
  [SMALL_STATE(6548)] = 155635,
  [SMALL_STATE(6549)] = 155700,
  [SMALL_STATE(6550)] = 155749,
  [SMALL_STATE(6551)] = 155798,
  [SMALL_STATE(6552)] = 155847,
  [SMALL_STATE(6553)] = 155912,
  [SMALL_STATE(6554)] = 155963,
  [SMALL_STATE(6555)] = 156012,
  [SMALL_STATE(6556)] = 156061,
  [SMALL_STATE(6557)] = 156112,
  [SMALL_STATE(6558)] = 156161,
  [SMALL_STATE(6559)] = 156210,
  [SMALL_STATE(6560)] = 156259,
  [SMALL_STATE(6561)] = 156328,
  [SMALL_STATE(6562)] = 156379,
  [SMALL_STATE(6563)] = 156428,
  [SMALL_STATE(6564)] = 156477,
  [SMALL_STATE(6565)] = 156528,
  [SMALL_STATE(6566)] = 156593,
  [SMALL_STATE(6567)] = 156646,
  [SMALL_STATE(6568)] = 156695,
  [SMALL_STATE(6569)] = 156746,
  [SMALL_STATE(6570)] = 156795,
  [SMALL_STATE(6571)] = 156844,
  [SMALL_STATE(6572)] = 156893,
  [SMALL_STATE(6573)] = 156958,
  [SMALL_STATE(6574)] = 157007,
  [SMALL_STATE(6575)] = 157058,
  [SMALL_STATE(6576)] = 157109,
  [SMALL_STATE(6577)] = 157160,
  [SMALL_STATE(6578)] = 157209,
  [SMALL_STATE(6579)] = 157274,
  [SMALL_STATE(6580)] = 157327,
  [SMALL_STATE(6581)] = 157378,
  [SMALL_STATE(6582)] = 157427,
  [SMALL_STATE(6583)] = 157476,
  [SMALL_STATE(6584)] = 157525,
  [SMALL_STATE(6585)] = 157574,
  [SMALL_STATE(6586)] = 157625,
  [SMALL_STATE(6587)] = 157676,
  [SMALL_STATE(6588)] = 157725,
  [SMALL_STATE(6589)] = 157774,
  [SMALL_STATE(6590)] = 157823,
  [SMALL_STATE(6591)] = 157872,
  [SMALL_STATE(6592)] = 157921,
  [SMALL_STATE(6593)] = 157970,
  [SMALL_STATE(6594)] = 158019,
  [SMALL_STATE(6595)] = 158068,
  [SMALL_STATE(6596)] = 158117,
  [SMALL_STATE(6597)] = 158166,
  [SMALL_STATE(6598)] = 158217,
  [SMALL_STATE(6599)] = 158282,
  [SMALL_STATE(6600)] = 158331,
  [SMALL_STATE(6601)] = 158382,
  [SMALL_STATE(6602)] = 158431,
  [SMALL_STATE(6603)] = 158480,
  [SMALL_STATE(6604)] = 158531,
  [SMALL_STATE(6605)] = 158580,
  [SMALL_STATE(6606)] = 158633,
  [SMALL_STATE(6607)] = 158684,
  [SMALL_STATE(6608)] = 158733,
  [SMALL_STATE(6609)] = 158784,
  [SMALL_STATE(6610)] = 158833,
  [SMALL_STATE(6611)] = 158882,
  [SMALL_STATE(6612)] = 158935,
  [SMALL_STATE(6613)] = 158984,
  [SMALL_STATE(6614)] = 159033,
  [SMALL_STATE(6615)] = 159084,
  [SMALL_STATE(6616)] = 159133,
  [SMALL_STATE(6617)] = 159184,
  [SMALL_STATE(6618)] = 159235,
  [SMALL_STATE(6619)] = 159284,
  [SMALL_STATE(6620)] = 159333,
  [SMALL_STATE(6621)] = 159384,
  [SMALL_STATE(6622)] = 159433,
  [SMALL_STATE(6623)] = 159482,
  [SMALL_STATE(6624)] = 159533,
  [SMALL_STATE(6625)] = 159598,
  [SMALL_STATE(6626)] = 159647,
  [SMALL_STATE(6627)] = 159696,
  [SMALL_STATE(6628)] = 159761,
  [SMALL_STATE(6629)] = 159810,
  [SMALL_STATE(6630)] = 159859,
  [SMALL_STATE(6631)] = 159908,
  [SMALL_STATE(6632)] = 159973,
  [SMALL_STATE(6633)] = 160026,
  [SMALL_STATE(6634)] = 160091,
  [SMALL_STATE(6635)] = 160140,
  [SMALL_STATE(6636)] = 160189,
  [SMALL_STATE(6637)] = 160238,
  [SMALL_STATE(6638)] = 160291,
  [SMALL_STATE(6639)] = 160340,
  [SMALL_STATE(6640)] = 160389,
  [SMALL_STATE(6641)] = 160438,
  [SMALL_STATE(6642)] = 160487,
  [SMALL_STATE(6643)] = 160536,
  [SMALL_STATE(6644)] = 160585,
  [SMALL_STATE(6645)] = 160634,
  [SMALL_STATE(6646)] = 160683,
  [SMALL_STATE(6647)] = 160736,
  [SMALL_STATE(6648)] = 160785,
  [SMALL_STATE(6649)] = 160834,
  [SMALL_STATE(6650)] = 160887,
  [SMALL_STATE(6651)] = 160936,
  [SMALL_STATE(6652)] = 160985,
  [SMALL_STATE(6653)] = 161034,
  [SMALL_STATE(6654)] = 161103,
  [SMALL_STATE(6655)] = 161154,
  [SMALL_STATE(6656)] = 161207,
  [SMALL_STATE(6657)] = 161256,
  [SMALL_STATE(6658)] = 161321,
  [SMALL_STATE(6659)] = 161370,
  [SMALL_STATE(6660)] = 161419,
  [SMALL_STATE(6661)] = 161468,
  [SMALL_STATE(6662)] = 161517,
  [SMALL_STATE(6663)] = 161566,
  [SMALL_STATE(6664)] = 161615,
  [SMALL_STATE(6665)] = 161680,
  [SMALL_STATE(6666)] = 161729,
  [SMALL_STATE(6667)] = 161780,
  [SMALL_STATE(6668)] = 161829,
  [SMALL_STATE(6669)] = 161878,
  [SMALL_STATE(6670)] = 161943,
  [SMALL_STATE(6671)] = 161992,
  [SMALL_STATE(6672)] = 162041,
  [SMALL_STATE(6673)] = 162106,
  [SMALL_STATE(6674)] = 162171,
  [SMALL_STATE(6675)] = 162220,
  [SMALL_STATE(6676)] = 162269,
  [SMALL_STATE(6677)] = 162318,
  [SMALL_STATE(6678)] = 162367,
  [SMALL_STATE(6679)] = 162416,
  [SMALL_STATE(6680)] = 162465,
  [SMALL_STATE(6681)] = 162514,
  [SMALL_STATE(6682)] = 162579,
  [SMALL_STATE(6683)] = 162628,
  [SMALL_STATE(6684)] = 162693,
  [SMALL_STATE(6685)] = 162742,
  [SMALL_STATE(6686)] = 162791,
  [SMALL_STATE(6687)] = 162840,
  [SMALL_STATE(6688)] = 162889,
  [SMALL_STATE(6689)] = 162938,
  [SMALL_STATE(6690)] = 162991,
  [SMALL_STATE(6691)] = 163044,
  [SMALL_STATE(6692)] = 163093,
  [SMALL_STATE(6693)] = 163158,
  [SMALL_STATE(6694)] = 163207,
  [SMALL_STATE(6695)] = 163258,
  [SMALL_STATE(6696)] = 163307,
  [SMALL_STATE(6697)] = 163360,
  [SMALL_STATE(6698)] = 163409,
  [SMALL_STATE(6699)] = 163458,
  [SMALL_STATE(6700)] = 163509,
  [SMALL_STATE(6701)] = 163562,
  [SMALL_STATE(6702)] = 163611,
  [SMALL_STATE(6703)] = 163660,
  [SMALL_STATE(6704)] = 163709,
  [SMALL_STATE(6705)] = 163774,
  [SMALL_STATE(6706)] = 163825,
  [SMALL_STATE(6707)] = 163874,
  [SMALL_STATE(6708)] = 163923,
  [SMALL_STATE(6709)] = 163972,
  [SMALL_STATE(6710)] = 164021,
  [SMALL_STATE(6711)] = 164072,
  [SMALL_STATE(6712)] = 164121,
  [SMALL_STATE(6713)] = 164170,
  [SMALL_STATE(6714)] = 164219,
  [SMALL_STATE(6715)] = 164268,
  [SMALL_STATE(6716)] = 164317,
  [SMALL_STATE(6717)] = 164366,
  [SMALL_STATE(6718)] = 164415,
  [SMALL_STATE(6719)] = 164468,
  [SMALL_STATE(6720)] = 164517,
  [SMALL_STATE(6721)] = 164566,
  [SMALL_STATE(6722)] = 164619,
  [SMALL_STATE(6723)] = 164668,
  [SMALL_STATE(6724)] = 164717,
  [SMALL_STATE(6725)] = 164766,
  [SMALL_STATE(6726)] = 164831,
  [SMALL_STATE(6727)] = 164880,
  [SMALL_STATE(6728)] = 164929,
  [SMALL_STATE(6729)] = 164980,
  [SMALL_STATE(6730)] = 165029,
  [SMALL_STATE(6731)] = 165078,
  [SMALL_STATE(6732)] = 165127,
  [SMALL_STATE(6733)] = 165176,
  [SMALL_STATE(6734)] = 165225,
  [SMALL_STATE(6735)] = 165274,
  [SMALL_STATE(6736)] = 165323,
  [SMALL_STATE(6737)] = 165376,
  [SMALL_STATE(6738)] = 165425,
  [SMALL_STATE(6739)] = 165474,
  [SMALL_STATE(6740)] = 165527,
  [SMALL_STATE(6741)] = 165576,
  [SMALL_STATE(6742)] = 165625,
  [SMALL_STATE(6743)] = 165674,
  [SMALL_STATE(6744)] = 165725,
  [SMALL_STATE(6745)] = 165773,
  [SMALL_STATE(6746)] = 165835,
  [SMALL_STATE(6747)] = 165883,
  [SMALL_STATE(6748)] = 165931,
  [SMALL_STATE(6749)] = 165979,
  [SMALL_STATE(6750)] = 166027,
  [SMALL_STATE(6751)] = 166075,
  [SMALL_STATE(6752)] = 166123,
  [SMALL_STATE(6753)] = 166187,
  [SMALL_STATE(6754)] = 166237,
  [SMALL_STATE(6755)] = 166285,
  [SMALL_STATE(6756)] = 166333,
  [SMALL_STATE(6757)] = 166381,
  [SMALL_STATE(6758)] = 166429,
  [SMALL_STATE(6759)] = 166477,
  [SMALL_STATE(6760)] = 166525,
  [SMALL_STATE(6761)] = 166589,
  [SMALL_STATE(6762)] = 166637,
  [SMALL_STATE(6763)] = 166685,
  [SMALL_STATE(6764)] = 166733,
  [SMALL_STATE(6765)] = 166781,
  [SMALL_STATE(6766)] = 166843,
  [SMALL_STATE(6767)] = 166917,
  [SMALL_STATE(6768)] = 166969,
  [SMALL_STATE(6769)] = 167021,
  [SMALL_STATE(6770)] = 167069,
  [SMALL_STATE(6771)] = 167121,
  [SMALL_STATE(6772)] = 167169,
  [SMALL_STATE(6773)] = 167217,
  [SMALL_STATE(6774)] = 167269,
  [SMALL_STATE(6775)] = 167343,
  [SMALL_STATE(6776)] = 167391,
  [SMALL_STATE(6777)] = 167439,
  [SMALL_STATE(6778)] = 167487,
  [SMALL_STATE(6779)] = 167561,
  [SMALL_STATE(6780)] = 167609,
  [SMALL_STATE(6781)] = 167657,
  [SMALL_STATE(6782)] = 167707,
  [SMALL_STATE(6783)] = 167757,
  [SMALL_STATE(6784)] = 167805,
  [SMALL_STATE(6785)] = 167853,
  [SMALL_STATE(6786)] = 167905,
  [SMALL_STATE(6787)] = 167955,
  [SMALL_STATE(6788)] = 168003,
  [SMALL_STATE(6789)] = 168055,
  [SMALL_STATE(6790)] = 168105,
  [SMALL_STATE(6791)] = 168157,
  [SMALL_STATE(6792)] = 168207,
  [SMALL_STATE(6793)] = 168257,
  [SMALL_STATE(6794)] = 168309,
  [SMALL_STATE(6795)] = 168373,
  [SMALL_STATE(6796)] = 168421,
  [SMALL_STATE(6797)] = 168495,
  [SMALL_STATE(6798)] = 168559,
  [SMALL_STATE(6799)] = 168623,
  [SMALL_STATE(6800)] = 168671,
  [SMALL_STATE(6801)] = 168721,
  [SMALL_STATE(6802)] = 168769,
  [SMALL_STATE(6803)] = 168833,
  [SMALL_STATE(6804)] = 168881,
  [SMALL_STATE(6805)] = 168929,
  [SMALL_STATE(6806)] = 168991,
  [SMALL_STATE(6807)] = 169039,
  [SMALL_STATE(6808)] = 169087,
  [SMALL_STATE(6809)] = 169135,
  [SMALL_STATE(6810)] = 169183,
  [SMALL_STATE(6811)] = 169247,
  [SMALL_STATE(6812)] = 169295,
  [SMALL_STATE(6813)] = 169343,
  [SMALL_STATE(6814)] = 169391,
  [SMALL_STATE(6815)] = 169439,
  [SMALL_STATE(6816)] = 169487,
  [SMALL_STATE(6817)] = 169535,
  [SMALL_STATE(6818)] = 169583,
  [SMALL_STATE(6819)] = 169631,
  [SMALL_STATE(6820)] = 169679,
  [SMALL_STATE(6821)] = 169741,
  [SMALL_STATE(6822)] = 169789,
  [SMALL_STATE(6823)] = 169863,
  [SMALL_STATE(6824)] = 169927,
  [SMALL_STATE(6825)] = 169975,
  [SMALL_STATE(6826)] = 170023,
  [SMALL_STATE(6827)] = 170087,
  [SMALL_STATE(6828)] = 170135,
  [SMALL_STATE(6829)] = 170187,
  [SMALL_STATE(6830)] = 170235,
  [SMALL_STATE(6831)] = 170299,
  [SMALL_STATE(6832)] = 170347,
  [SMALL_STATE(6833)] = 170395,
  [SMALL_STATE(6834)] = 170459,
  [SMALL_STATE(6835)] = 170511,
  [SMALL_STATE(6836)] = 170559,
  [SMALL_STATE(6837)] = 170609,
  [SMALL_STATE(6838)] = 170657,
  [SMALL_STATE(6839)] = 170705,
  [SMALL_STATE(6840)] = 170753,
  [SMALL_STATE(6841)] = 170801,
  [SMALL_STATE(6842)] = 170851,
  [SMALL_STATE(6843)] = 170915,
  [SMALL_STATE(6844)] = 170963,
  [SMALL_STATE(6845)] = 171015,
  [SMALL_STATE(6846)] = 171063,
  [SMALL_STATE(6847)] = 171137,
  [SMALL_STATE(6848)] = 171185,
  [SMALL_STATE(6849)] = 171249,
  [SMALL_STATE(6850)] = 171301,
  [SMALL_STATE(6851)] = 171353,
  [SMALL_STATE(6852)] = 171401,
  [SMALL_STATE(6853)] = 171449,
  [SMALL_STATE(6854)] = 171513,
  [SMALL_STATE(6855)] = 171563,
  [SMALL_STATE(6856)] = 171611,
  [SMALL_STATE(6857)] = 171659,
  [SMALL_STATE(6858)] = 171723,
  [SMALL_STATE(6859)] = 171787,
  [SMALL_STATE(6860)] = 171851,
  [SMALL_STATE(6861)] = 171899,
  [SMALL_STATE(6862)] = 171973,
  [SMALL_STATE(6863)] = 172021,
  [SMALL_STATE(6864)] = 172069,
  [SMALL_STATE(6865)] = 172117,
  [SMALL_STATE(6866)] = 172181,
  [SMALL_STATE(6867)] = 172229,
  [SMALL_STATE(6868)] = 172293,
  [SMALL_STATE(6869)] = 172341,
  [SMALL_STATE(6870)] = 172389,
  [SMALL_STATE(6871)] = 172437,
  [SMALL_STATE(6872)] = 172489,
  [SMALL_STATE(6873)] = 172539,
  [SMALL_STATE(6874)] = 172587,
  [SMALL_STATE(6875)] = 172635,
  [SMALL_STATE(6876)] = 172683,
  [SMALL_STATE(6877)] = 172731,
  [SMALL_STATE(6878)] = 172779,
  [SMALL_STATE(6879)] = 172853,
  [SMALL_STATE(6880)] = 172901,
  [SMALL_STATE(6881)] = 172949,
  [SMALL_STATE(6882)] = 172997,
  [SMALL_STATE(6883)] = 173045,
  [SMALL_STATE(6884)] = 173095,
  [SMALL_STATE(6885)] = 173147,
  [SMALL_STATE(6886)] = 173195,
  [SMALL_STATE(6887)] = 173243,
  [SMALL_STATE(6888)] = 173291,
  [SMALL_STATE(6889)] = 173343,
  [SMALL_STATE(6890)] = 173391,
  [SMALL_STATE(6891)] = 173439,
  [SMALL_STATE(6892)] = 173489,
  [SMALL_STATE(6893)] = 173553,
  [SMALL_STATE(6894)] = 173601,
  [SMALL_STATE(6895)] = 173649,
  [SMALL_STATE(6896)] = 173697,
  [SMALL_STATE(6897)] = 173745,
  [SMALL_STATE(6898)] = 173809,
  [SMALL_STATE(6899)] = 173859,
  [SMALL_STATE(6900)] = 173923,
  [SMALL_STATE(6901)] = 173973,
  [SMALL_STATE(6902)] = 174023,
  [SMALL_STATE(6903)] = 174071,
  [SMALL_STATE(6904)] = 174119,
  [SMALL_STATE(6905)] = 174185,
  [SMALL_STATE(6906)] = 174233,
  [SMALL_STATE(6907)] = 174281,
  [SMALL_STATE(6908)] = 174329,
  [SMALL_STATE(6909)] = 174377,
  [SMALL_STATE(6910)] = 174429,
  [SMALL_STATE(6911)] = 174493,
  [SMALL_STATE(6912)] = 174541,
  [SMALL_STATE(6913)] = 174589,
  [SMALL_STATE(6914)] = 174637,
  [SMALL_STATE(6915)] = 174687,
  [SMALL_STATE(6916)] = 174761,
  [SMALL_STATE(6917)] = 174813,
  [SMALL_STATE(6918)] = 174861,
  [SMALL_STATE(6919)] = 174909,
  [SMALL_STATE(6920)] = 174957,
  [SMALL_STATE(6921)] = 175009,
  [SMALL_STATE(6922)] = 175059,
  [SMALL_STATE(6923)] = 175123,
  [SMALL_STATE(6924)] = 175171,
  [SMALL_STATE(6925)] = 175221,
  [SMALL_STATE(6926)] = 175269,
  [SMALL_STATE(6927)] = 175321,
  [SMALL_STATE(6928)] = 175369,
  [SMALL_STATE(6929)] = 175417,
  [SMALL_STATE(6930)] = 175469,
  [SMALL_STATE(6931)] = 175521,
  [SMALL_STATE(6932)] = 175571,
  [SMALL_STATE(6933)] = 175645,
  [SMALL_STATE(6934)] = 175693,
  [SMALL_STATE(6935)] = 175741,
  [SMALL_STATE(6936)] = 175789,
  [SMALL_STATE(6937)] = 175837,
  [SMALL_STATE(6938)] = 175887,
  [SMALL_STATE(6939)] = 175937,
  [SMALL_STATE(6940)] = 175985,
  [SMALL_STATE(6941)] = 176035,
  [SMALL_STATE(6942)] = 176083,
  [SMALL_STATE(6943)] = 176132,
  [SMALL_STATE(6944)] = 176183,
  [SMALL_STATE(6945)] = 176230,
  [SMALL_STATE(6946)] = 176277,
  [SMALL_STATE(6947)] = 176324,
  [SMALL_STATE(6948)] = 176371,
  [SMALL_STATE(6949)] = 176418,
  [SMALL_STATE(6950)] = 176467,
  [SMALL_STATE(6951)] = 176514,
  [SMALL_STATE(6952)] = 176561,
  [SMALL_STATE(6953)] = 176610,
  [SMALL_STATE(6954)] = 176657,
  [SMALL_STATE(6955)] = 176704,
  [SMALL_STATE(6956)] = 176751,
  [SMALL_STATE(6957)] = 176798,
  [SMALL_STATE(6958)] = 176845,
  [SMALL_STATE(6959)] = 176892,
  [SMALL_STATE(6960)] = 176939,
  [SMALL_STATE(6961)] = 176986,
  [SMALL_STATE(6962)] = 177033,
  [SMALL_STATE(6963)] = 177080,
  [SMALL_STATE(6964)] = 177143,
  [SMALL_STATE(6965)] = 177190,
  [SMALL_STATE(6966)] = 177237,
  [SMALL_STATE(6967)] = 177284,
  [SMALL_STATE(6968)] = 177331,
  [SMALL_STATE(6969)] = 177378,
  [SMALL_STATE(6970)] = 177429,
  [SMALL_STATE(6971)] = 177476,
  [SMALL_STATE(6972)] = 177539,
  [SMALL_STATE(6973)] = 177586,
  [SMALL_STATE(6974)] = 177633,
  [SMALL_STATE(6975)] = 177680,
  [SMALL_STATE(6976)] = 177727,
  [SMALL_STATE(6977)] = 177774,
  [SMALL_STATE(6978)] = 177837,
  [SMALL_STATE(6979)] = 177884,
  [SMALL_STATE(6980)] = 177931,
  [SMALL_STATE(6981)] = 177994,
  [SMALL_STATE(6982)] = 178041,
  [SMALL_STATE(6983)] = 178088,
  [SMALL_STATE(6984)] = 178135,
  [SMALL_STATE(6985)] = 178182,
  [SMALL_STATE(6986)] = 178253,
  [SMALL_STATE(6987)] = 178300,
  [SMALL_STATE(6988)] = 178349,
  [SMALL_STATE(6989)] = 178400,
  [SMALL_STATE(6990)] = 178463,
  [SMALL_STATE(6991)] = 178510,
  [SMALL_STATE(6992)] = 178557,
  [SMALL_STATE(6993)] = 178606,
  [SMALL_STATE(6994)] = 178653,
  [SMALL_STATE(6995)] = 178702,
  [SMALL_STATE(6996)] = 178749,
  [SMALL_STATE(6997)] = 178796,
  [SMALL_STATE(6998)] = 178843,
  [SMALL_STATE(6999)] = 178890,
  [SMALL_STATE(7000)] = 178937,
  [SMALL_STATE(7001)] = 178986,
  [SMALL_STATE(7002)] = 179033,
  [SMALL_STATE(7003)] = 179080,
  [SMALL_STATE(7004)] = 179131,
  [SMALL_STATE(7005)] = 179178,
  [SMALL_STATE(7006)] = 179225,
  [SMALL_STATE(7007)] = 179272,
  [SMALL_STATE(7008)] = 179319,
  [SMALL_STATE(7009)] = 179366,
  [SMALL_STATE(7010)] = 179413,
  [SMALL_STATE(7011)] = 179462,
  [SMALL_STATE(7012)] = 179509,
  [SMALL_STATE(7013)] = 179556,
  [SMALL_STATE(7014)] = 179603,
  [SMALL_STATE(7015)] = 179650,
  [SMALL_STATE(7016)] = 179699,
  [SMALL_STATE(7017)] = 179746,
  [SMALL_STATE(7018)] = 179795,
  [SMALL_STATE(7019)] = 179842,
  [SMALL_STATE(7020)] = 179891,
  [SMALL_STATE(7021)] = 179940,
  [SMALL_STATE(7022)] = 179989,
  [SMALL_STATE(7023)] = 180040,
  [SMALL_STATE(7024)] = 180091,
  [SMALL_STATE(7025)] = 180142,
  [SMALL_STATE(7026)] = 180191,
  [SMALL_STATE(7027)] = 180262,
  [SMALL_STATE(7028)] = 180309,
  [SMALL_STATE(7029)] = 180380,
  [SMALL_STATE(7030)] = 180431,
  [SMALL_STATE(7031)] = 180482,
  [SMALL_STATE(7032)] = 180531,
  [SMALL_STATE(7033)] = 180578,
  [SMALL_STATE(7034)] = 180649,
  [SMALL_STATE(7035)] = 180696,
  [SMALL_STATE(7036)] = 180767,
  [SMALL_STATE(7037)] = 180814,
  [SMALL_STATE(7038)] = 180861,
  [SMALL_STATE(7039)] = 180932,
  [SMALL_STATE(7040)] = 180979,
  [SMALL_STATE(7041)] = 181026,
  [SMALL_STATE(7042)] = 181073,
  [SMALL_STATE(7043)] = 181124,
  [SMALL_STATE(7044)] = 181173,
  [SMALL_STATE(7045)] = 181222,
  [SMALL_STATE(7046)] = 181269,
  [SMALL_STATE(7047)] = 181332,
  [SMALL_STATE(7048)] = 181379,
  [SMALL_STATE(7049)] = 181426,
  [SMALL_STATE(7050)] = 181475,
  [SMALL_STATE(7051)] = 181526,
  [SMALL_STATE(7052)] = 181573,
  [SMALL_STATE(7053)] = 181624,
  [SMALL_STATE(7054)] = 181675,
  [SMALL_STATE(7055)] = 181726,
  [SMALL_STATE(7056)] = 181777,
  [SMALL_STATE(7057)] = 181828,
  [SMALL_STATE(7058)] = 181875,
  [SMALL_STATE(7059)] = 181922,
  [SMALL_STATE(7060)] = 181973,
  [SMALL_STATE(7061)] = 182024,
  [SMALL_STATE(7062)] = 182071,
  [SMALL_STATE(7063)] = 182118,
  [SMALL_STATE(7064)] = 182189,
  [SMALL_STATE(7065)] = 182236,
  [SMALL_STATE(7066)] = 182283,
  [SMALL_STATE(7067)] = 182332,
  [SMALL_STATE(7068)] = 182381,
  [SMALL_STATE(7069)] = 182432,
  [SMALL_STATE(7070)] = 182479,
  [SMALL_STATE(7071)] = 182528,
  [SMALL_STATE(7072)] = 182575,
  [SMALL_STATE(7073)] = 182622,
  [SMALL_STATE(7074)] = 182669,
  [SMALL_STATE(7075)] = 182716,
  [SMALL_STATE(7076)] = 182763,
  [SMALL_STATE(7077)] = 182810,
  [SMALL_STATE(7078)] = 182863,
  [SMALL_STATE(7079)] = 182910,
  [SMALL_STATE(7080)] = 182957,
  [SMALL_STATE(7081)] = 183008,
  [SMALL_STATE(7082)] = 183055,
  [SMALL_STATE(7083)] = 183106,
  [SMALL_STATE(7084)] = 183157,
  [SMALL_STATE(7085)] = 183206,
  [SMALL_STATE(7086)] = 183253,
  [SMALL_STATE(7087)] = 183300,
  [SMALL_STATE(7088)] = 183347,
  [SMALL_STATE(7089)] = 183394,
  [SMALL_STATE(7090)] = 183442,
  [SMALL_STATE(7091)] = 183488,
  [SMALL_STATE(7092)] = 183534,
  [SMALL_STATE(7093)] = 183580,
  [SMALL_STATE(7094)] = 183626,
  [SMALL_STATE(7095)] = 183672,
  [SMALL_STATE(7096)] = 183718,
  [SMALL_STATE(7097)] = 183768,
  [SMALL_STATE(7098)] = 183816,
  [SMALL_STATE(7099)] = 183864,
  [SMALL_STATE(7100)] = 183910,
  [SMALL_STATE(7101)] = 183978,
  [SMALL_STATE(7102)] = 184024,
  [SMALL_STATE(7103)] = 184072,
  [SMALL_STATE(7104)] = 184118,
  [SMALL_STATE(7105)] = 184166,
  [SMALL_STATE(7106)] = 184216,
  [SMALL_STATE(7107)] = 184262,
  [SMALL_STATE(7108)] = 184308,
  [SMALL_STATE(7109)] = 184354,
  [SMALL_STATE(7110)] = 184422,
  [SMALL_STATE(7111)] = 184468,
  [SMALL_STATE(7112)] = 184514,
  [SMALL_STATE(7113)] = 184582,
  [SMALL_STATE(7114)] = 184628,
  [SMALL_STATE(7115)] = 184678,
  [SMALL_STATE(7116)] = 184728,
  [SMALL_STATE(7117)] = 184774,
  [SMALL_STATE(7118)] = 184820,
  [SMALL_STATE(7119)] = 184888,
  [SMALL_STATE(7120)] = 184936,
  [SMALL_STATE(7121)] = 184982,
  [SMALL_STATE(7122)] = 185030,
  [SMALL_STATE(7123)] = 185078,
  [SMALL_STATE(7124)] = 185124,
  [SMALL_STATE(7125)] = 185170,
  [SMALL_STATE(7126)] = 185220,
  [SMALL_STATE(7127)] = 185266,
  [SMALL_STATE(7128)] = 185312,
  [SMALL_STATE(7129)] = 185358,
  [SMALL_STATE(7130)] = 185404,
  [SMALL_STATE(7131)] = 185450,
  [SMALL_STATE(7132)] = 185496,
  [SMALL_STATE(7133)] = 185542,
  [SMALL_STATE(7134)] = 185588,
  [SMALL_STATE(7135)] = 185634,
  [SMALL_STATE(7136)] = 185680,
  [SMALL_STATE(7137)] = 185726,
  [SMALL_STATE(7138)] = 185776,
  [SMALL_STATE(7139)] = 185822,
  [SMALL_STATE(7140)] = 185868,
  [SMALL_STATE(7141)] = 185916,
  [SMALL_STATE(7142)] = 185962,
  [SMALL_STATE(7143)] = 186008,
  [SMALL_STATE(7144)] = 186054,
  [SMALL_STATE(7145)] = 186100,
  [SMALL_STATE(7146)] = 186146,
  [SMALL_STATE(7147)] = 186192,
  [SMALL_STATE(7148)] = 186238,
  [SMALL_STATE(7149)] = 186284,
  [SMALL_STATE(7150)] = 186330,
  [SMALL_STATE(7151)] = 186376,
  [SMALL_STATE(7152)] = 186424,
  [SMALL_STATE(7153)] = 186470,
  [SMALL_STATE(7154)] = 186516,
  [SMALL_STATE(7155)] = 186562,
  [SMALL_STATE(7156)] = 186608,
  [SMALL_STATE(7157)] = 186656,
  [SMALL_STATE(7158)] = 186724,
  [SMALL_STATE(7159)] = 186774,
  [SMALL_STATE(7160)] = 186820,
  [SMALL_STATE(7161)] = 186888,
  [SMALL_STATE(7162)] = 186936,
  [SMALL_STATE(7163)] = 187004,
  [SMALL_STATE(7164)] = 187052,
  [SMALL_STATE(7165)] = 187098,
  [SMALL_STATE(7166)] = 187146,
  [SMALL_STATE(7167)] = 187192,
  [SMALL_STATE(7168)] = 187238,
  [SMALL_STATE(7169)] = 187284,
  [SMALL_STATE(7170)] = 187330,
  [SMALL_STATE(7171)] = 187398,
  [SMALL_STATE(7172)] = 187444,
  [SMALL_STATE(7173)] = 187512,
  [SMALL_STATE(7174)] = 187558,
  [SMALL_STATE(7175)] = 187604,
  [SMALL_STATE(7176)] = 187650,
  [SMALL_STATE(7177)] = 187696,
  [SMALL_STATE(7178)] = 187744,
  [SMALL_STATE(7179)] = 187790,
  [SMALL_STATE(7180)] = 187836,
  [SMALL_STATE(7181)] = 187904,
  [SMALL_STATE(7182)] = 187952,
  [SMALL_STATE(7183)] = 187998,
  [SMALL_STATE(7184)] = 188044,
  [SMALL_STATE(7185)] = 188090,
  [SMALL_STATE(7186)] = 188136,
  [SMALL_STATE(7187)] = 188182,
  [SMALL_STATE(7188)] = 188232,
  [SMALL_STATE(7189)] = 188278,
  [SMALL_STATE(7190)] = 188324,
  [SMALL_STATE(7191)] = 188370,
  [SMALL_STATE(7192)] = 188416,
  [SMALL_STATE(7193)] = 188462,
  [SMALL_STATE(7194)] = 188512,
  [SMALL_STATE(7195)] = 188558,
  [SMALL_STATE(7196)] = 188604,
  [SMALL_STATE(7197)] = 188650,
  [SMALL_STATE(7198)] = 188698,
  [SMALL_STATE(7199)] = 188744,
  [SMALL_STATE(7200)] = 188790,
  [SMALL_STATE(7201)] = 188836,
  [SMALL_STATE(7202)] = 188882,
  [SMALL_STATE(7203)] = 188928,
  [SMALL_STATE(7204)] = 188974,
  [SMALL_STATE(7205)] = 189031,
  [SMALL_STATE(7206)] = 189088,
  [SMALL_STATE(7207)] = 189133,
  [SMALL_STATE(7208)] = 189178,
  [SMALL_STATE(7209)] = 189235,
  [SMALL_STATE(7210)] = 189292,
  [SMALL_STATE(7211)] = 189339,
  [SMALL_STATE(7212)] = 189396,
  [SMALL_STATE(7213)] = 189441,
  [SMALL_STATE(7214)] = 189498,
  [SMALL_STATE(7215)] = 189543,
  [SMALL_STATE(7216)] = 189588,
  [SMALL_STATE(7217)] = 189633,
  [SMALL_STATE(7218)] = 189680,
  [SMALL_STATE(7219)] = 189725,
  [SMALL_STATE(7220)] = 189770,
  [SMALL_STATE(7221)] = 189815,
  [SMALL_STATE(7222)] = 189860,
  [SMALL_STATE(7223)] = 189917,
  [SMALL_STATE(7224)] = 189974,
  [SMALL_STATE(7225)] = 190019,
  [SMALL_STATE(7226)] = 190076,
  [SMALL_STATE(7227)] = 190121,
  [SMALL_STATE(7228)] = 190166,
  [SMALL_STATE(7229)] = 190211,
  [SMALL_STATE(7230)] = 190268,
  [SMALL_STATE(7231)] = 190329,
  [SMALL_STATE(7232)] = 190376,
  [SMALL_STATE(7233)] = 190421,
  [SMALL_STATE(7234)] = 190466,
  [SMALL_STATE(7235)] = 190523,
  [SMALL_STATE(7236)] = 190580,
  [SMALL_STATE(7237)] = 190637,
  [SMALL_STATE(7238)] = 190694,
  [SMALL_STATE(7239)] = 190751,
  [SMALL_STATE(7240)] = 190796,
  [SMALL_STATE(7241)] = 190841,
  [SMALL_STATE(7242)] = 190888,
  [SMALL_STATE(7243)] = 190945,
  [SMALL_STATE(7244)] = 190990,
  [SMALL_STATE(7245)] = 191047,
  [SMALL_STATE(7246)] = 191104,
  [SMALL_STATE(7247)] = 191149,
  [SMALL_STATE(7248)] = 191194,
  [SMALL_STATE(7249)] = 191243,
  [SMALL_STATE(7250)] = 191288,
  [SMALL_STATE(7251)] = 191333,
  [SMALL_STATE(7252)] = 191380,
  [SMALL_STATE(7253)] = 191425,
  [SMALL_STATE(7254)] = 191470,
  [SMALL_STATE(7255)] = 191527,
  [SMALL_STATE(7256)] = 191584,
  [SMALL_STATE(7257)] = 191629,
  [SMALL_STATE(7258)] = 191674,
  [SMALL_STATE(7259)] = 191731,
  [SMALL_STATE(7260)] = 191788,
  [SMALL_STATE(7261)] = 191845,
  [SMALL_STATE(7262)] = 191892,
  [SMALL_STATE(7263)] = 191937,
  [SMALL_STATE(7264)] = 191982,
  [SMALL_STATE(7265)] = 192027,
  [SMALL_STATE(7266)] = 192084,
  [SMALL_STATE(7267)] = 192129,
  [SMALL_STATE(7268)] = 192174,
  [SMALL_STATE(7269)] = 192219,
  [SMALL_STATE(7270)] = 192276,
  [SMALL_STATE(7271)] = 192321,
  [SMALL_STATE(7272)] = 192378,
  [SMALL_STATE(7273)] = 192423,
  [SMALL_STATE(7274)] = 192480,
  [SMALL_STATE(7275)] = 192537,
  [SMALL_STATE(7276)] = 192594,
  [SMALL_STATE(7277)] = 192639,
  [SMALL_STATE(7278)] = 192696,
  [SMALL_STATE(7279)] = 192753,
  [SMALL_STATE(7280)] = 192800,
  [SMALL_STATE(7281)] = 192857,
  [SMALL_STATE(7282)] = 192902,
  [SMALL_STATE(7283)] = 192959,
  [SMALL_STATE(7284)] = 193006,
  [SMALL_STATE(7285)] = 193063,
  [SMALL_STATE(7286)] = 193120,
  [SMALL_STATE(7287)] = 193165,
  [SMALL_STATE(7288)] = 193214,
  [SMALL_STATE(7289)] = 193271,
  [SMALL_STATE(7290)] = 193316,
  [SMALL_STATE(7291)] = 193361,
  [SMALL_STATE(7292)] = 193408,
  [SMALL_STATE(7293)] = 193465,
  [SMALL_STATE(7294)] = 193510,
  [SMALL_STATE(7295)] = 193555,
  [SMALL_STATE(7296)] = 193612,
  [SMALL_STATE(7297)] = 193669,
  [SMALL_STATE(7298)] = 193714,
  [SMALL_STATE(7299)] = 193759,
  [SMALL_STATE(7300)] = 193804,
  [SMALL_STATE(7301)] = 193849,
  [SMALL_STATE(7302)] = 193906,
  [SMALL_STATE(7303)] = 193963,
  [SMALL_STATE(7304)] = 194008,
  [SMALL_STATE(7305)] = 194065,
  [SMALL_STATE(7306)] = 194122,
  [SMALL_STATE(7307)] = 194179,
  [SMALL_STATE(7308)] = 194226,
  [SMALL_STATE(7309)] = 194287,
  [SMALL_STATE(7310)] = 194344,
  [SMALL_STATE(7311)] = 194401,
  [SMALL_STATE(7312)] = 194458,
  [SMALL_STATE(7313)] = 194515,
  [SMALL_STATE(7314)] = 194560,
  [SMALL_STATE(7315)] = 194605,
  [SMALL_STATE(7316)] = 194650,
  [SMALL_STATE(7317)] = 194695,
  [SMALL_STATE(7318)] = 194740,
  [SMALL_STATE(7319)] = 194785,
  [SMALL_STATE(7320)] = 194830,
  [SMALL_STATE(7321)] = 194887,
  [SMALL_STATE(7322)] = 194944,
  [SMALL_STATE(7323)] = 194989,
  [SMALL_STATE(7324)] = 195034,
  [SMALL_STATE(7325)] = 195079,
  [SMALL_STATE(7326)] = 195124,
  [SMALL_STATE(7327)] = 195169,
  [SMALL_STATE(7328)] = 195214,
  [SMALL_STATE(7329)] = 195271,
  [SMALL_STATE(7330)] = 195332,
  [SMALL_STATE(7331)] = 195377,
  [SMALL_STATE(7332)] = 195438,
  [SMALL_STATE(7333)] = 195483,
  [SMALL_STATE(7334)] = 195528,
  [SMALL_STATE(7335)] = 195585,
  [SMALL_STATE(7336)] = 195630,
  [SMALL_STATE(7337)] = 195685,
  [SMALL_STATE(7338)] = 195730,
  [SMALL_STATE(7339)] = 195787,
  [SMALL_STATE(7340)] = 195834,
  [SMALL_STATE(7341)] = 195891,
  [SMALL_STATE(7342)] = 195945,
  [SMALL_STATE(7343)] = 195999,
  [SMALL_STATE(7344)] = 196053,
  [SMALL_STATE(7345)] = 196095,
  [SMALL_STATE(7346)] = 196159,
  [SMALL_STATE(7347)] = 196213,
  [SMALL_STATE(7348)] = 196259,
  [SMALL_STATE(7349)] = 196301,
  [SMALL_STATE(7350)] = 196355,
  [SMALL_STATE(7351)] = 196419,
  [SMALL_STATE(7352)] = 196463,
  [SMALL_STATE(7353)] = 196515,
  [SMALL_STATE(7354)] = 196579,
  [SMALL_STATE(7355)] = 196623,
  [SMALL_STATE(7356)] = 196677,
  [SMALL_STATE(7357)] = 196731,
  [SMALL_STATE(7358)] = 196775,
  [SMALL_STATE(7359)] = 196819,
  [SMALL_STATE(7360)] = 196873,
  [SMALL_STATE(7361)] = 196917,
  [SMALL_STATE(7362)] = 196961,
  [SMALL_STATE(7363)] = 197015,
  [SMALL_STATE(7364)] = 197069,
  [SMALL_STATE(7365)] = 197113,
  [SMALL_STATE(7366)] = 197157,
  [SMALL_STATE(7367)] = 197201,
  [SMALL_STATE(7368)] = 197255,
  [SMALL_STATE(7369)] = 197309,
  [SMALL_STATE(7370)] = 197363,
  [SMALL_STATE(7371)] = 197407,
  [SMALL_STATE(7372)] = 197451,
  [SMALL_STATE(7373)] = 197495,
  [SMALL_STATE(7374)] = 197549,
  [SMALL_STATE(7375)] = 197613,
  [SMALL_STATE(7376)] = 197667,
  [SMALL_STATE(7377)] = 197721,
  [SMALL_STATE(7378)] = 197763,
  [SMALL_STATE(7379)] = 197807,
  [SMALL_STATE(7380)] = 197851,
  [SMALL_STATE(7381)] = 197905,
  [SMALL_STATE(7382)] = 197969,
  [SMALL_STATE(7383)] = 198015,
  [SMALL_STATE(7384)] = 198059,
  [SMALL_STATE(7385)] = 198123,
  [SMALL_STATE(7386)] = 198165,
  [SMALL_STATE(7387)] = 198209,
  [SMALL_STATE(7388)] = 198253,
  [SMALL_STATE(7389)] = 198297,
  [SMALL_STATE(7390)] = 198361,
  [SMALL_STATE(7391)] = 198415,
  [SMALL_STATE(7392)] = 198469,
  [SMALL_STATE(7393)] = 198513,
  [SMALL_STATE(7394)] = 198567,
  [SMALL_STATE(7395)] = 198621,
  [SMALL_STATE(7396)] = 198675,
  [SMALL_STATE(7397)] = 198723,
  [SMALL_STATE(7398)] = 198767,
  [SMALL_STATE(7399)] = 198821,
  [SMALL_STATE(7400)] = 198875,
  [SMALL_STATE(7401)] = 198919,
  [SMALL_STATE(7402)] = 198963,
  [SMALL_STATE(7403)] = 199007,
  [SMALL_STATE(7404)] = 199061,
  [SMALL_STATE(7405)] = 199115,
  [SMALL_STATE(7406)] = 199159,
  [SMALL_STATE(7407)] = 199213,
  [SMALL_STATE(7408)] = 199257,
  [SMALL_STATE(7409)] = 199301,
  [SMALL_STATE(7410)] = 199343,
  [SMALL_STATE(7411)] = 199407,
  [SMALL_STATE(7412)] = 199461,
  [SMALL_STATE(7413)] = 199505,
  [SMALL_STATE(7414)] = 199549,
  [SMALL_STATE(7415)] = 199593,
  [SMALL_STATE(7416)] = 199637,
  [SMALL_STATE(7417)] = 199681,
  [SMALL_STATE(7418)] = 199725,
  [SMALL_STATE(7419)] = 199789,
  [SMALL_STATE(7420)] = 199833,
  [SMALL_STATE(7421)] = 199877,
  [SMALL_STATE(7422)] = 199931,
  [SMALL_STATE(7423)] = 199973,
  [SMALL_STATE(7424)] = 200015,
  [SMALL_STATE(7425)] = 200059,
  [SMALL_STATE(7426)] = 200103,
  [SMALL_STATE(7427)] = 200157,
  [SMALL_STATE(7428)] = 200199,
  [SMALL_STATE(7429)] = 200243,
  [SMALL_STATE(7430)] = 200297,
  [SMALL_STATE(7431)] = 200341,
  [SMALL_STATE(7432)] = 200385,
  [SMALL_STATE(7433)] = 200439,
  [SMALL_STATE(7434)] = 200483,
  [SMALL_STATE(7435)] = 200527,
  [SMALL_STATE(7436)] = 200571,
  [SMALL_STATE(7437)] = 200615,
  [SMALL_STATE(7438)] = 200659,
  [SMALL_STATE(7439)] = 200705,
  [SMALL_STATE(7440)] = 200749,
  [SMALL_STATE(7441)] = 200803,
  [SMALL_STATE(7442)] = 200857,
  [SMALL_STATE(7443)] = 200901,
  [SMALL_STATE(7444)] = 200945,
  [SMALL_STATE(7445)] = 200999,
  [SMALL_STATE(7446)] = 201043,
  [SMALL_STATE(7447)] = 201087,
  [SMALL_STATE(7448)] = 201131,
  [SMALL_STATE(7449)] = 201175,
  [SMALL_STATE(7450)] = 201219,
  [SMALL_STATE(7451)] = 201265,
  [SMALL_STATE(7452)] = 201309,
  [SMALL_STATE(7453)] = 201353,
  [SMALL_STATE(7454)] = 201397,
  [SMALL_STATE(7455)] = 201441,
  [SMALL_STATE(7456)] = 201485,
  [SMALL_STATE(7457)] = 201529,
  [SMALL_STATE(7458)] = 201583,
  [SMALL_STATE(7459)] = 201627,
  [SMALL_STATE(7460)] = 201681,
  [SMALL_STATE(7461)] = 201735,
  [SMALL_STATE(7462)] = 201779,
  [SMALL_STATE(7463)] = 201823,
  [SMALL_STATE(7464)] = 201867,
  [SMALL_STATE(7465)] = 201915,
  [SMALL_STATE(7466)] = 201979,
  [SMALL_STATE(7467)] = 202023,
  [SMALL_STATE(7468)] = 202077,
  [SMALL_STATE(7469)] = 202121,
  [SMALL_STATE(7470)] = 202165,
  [SMALL_STATE(7471)] = 202219,
  [SMALL_STATE(7472)] = 202267,
  [SMALL_STATE(7473)] = 202321,
  [SMALL_STATE(7474)] = 202365,
  [SMALL_STATE(7475)] = 202409,
  [SMALL_STATE(7476)] = 202453,
  [SMALL_STATE(7477)] = 202507,
  [SMALL_STATE(7478)] = 202551,
  [SMALL_STATE(7479)] = 202595,
  [SMALL_STATE(7480)] = 202659,
  [SMALL_STATE(7481)] = 202723,
  [SMALL_STATE(7482)] = 202765,
  [SMALL_STATE(7483)] = 202819,
  [SMALL_STATE(7484)] = 202883,
  [SMALL_STATE(7485)] = 202937,
  [SMALL_STATE(7486)] = 202983,
  [SMALL_STATE(7487)] = 203047,
  [SMALL_STATE(7488)] = 203101,
  [SMALL_STATE(7489)] = 203165,
  [SMALL_STATE(7490)] = 203219,
  [SMALL_STATE(7491)] = 203273,
  [SMALL_STATE(7492)] = 203317,
  [SMALL_STATE(7493)] = 203371,
  [SMALL_STATE(7494)] = 203415,
  [SMALL_STATE(7495)] = 203469,
  [SMALL_STATE(7496)] = 203515,
  [SMALL_STATE(7497)] = 203579,
  [SMALL_STATE(7498)] = 203633,
  [SMALL_STATE(7499)] = 203697,
  [SMALL_STATE(7500)] = 203745,
  [SMALL_STATE(7501)] = 203789,
  [SMALL_STATE(7502)] = 203833,
  [SMALL_STATE(7503)] = 203897,
  [SMALL_STATE(7504)] = 203961,
  [SMALL_STATE(7505)] = 204015,
  [SMALL_STATE(7506)] = 204059,
  [SMALL_STATE(7507)] = 204103,
  [SMALL_STATE(7508)] = 204149,
  [SMALL_STATE(7509)] = 204213,
  [SMALL_STATE(7510)] = 204267,
  [SMALL_STATE(7511)] = 204311,
  [SMALL_STATE(7512)] = 204365,
  [SMALL_STATE(7513)] = 204409,
  [SMALL_STATE(7514)] = 204463,
  [SMALL_STATE(7515)] = 204507,
  [SMALL_STATE(7516)] = 204548,
  [SMALL_STATE(7517)] = 204589,
  [SMALL_STATE(7518)] = 204630,
  [SMALL_STATE(7519)] = 204671,
  [SMALL_STATE(7520)] = 204712,
  [SMALL_STATE(7521)] = 204773,
  [SMALL_STATE(7522)] = 204814,
  [SMALL_STATE(7523)] = 204875,
  [SMALL_STATE(7524)] = 204922,
  [SMALL_STATE(7525)] = 204963,
  [SMALL_STATE(7526)] = 205004,
  [SMALL_STATE(7527)] = 205045,
  [SMALL_STATE(7528)] = 205106,
  [SMALL_STATE(7529)] = 205147,
  [SMALL_STATE(7530)] = 205190,
  [SMALL_STATE(7531)] = 205241,
  [SMALL_STATE(7532)] = 205282,
  [SMALL_STATE(7533)] = 205323,
  [SMALL_STATE(7534)] = 205364,
  [SMALL_STATE(7535)] = 205411,
  [SMALL_STATE(7536)] = 205458,
  [SMALL_STATE(7537)] = 205519,
  [SMALL_STATE(7538)] = 205562,
  [SMALL_STATE(7539)] = 205603,
  [SMALL_STATE(7540)] = 205644,
  [SMALL_STATE(7541)] = 205705,
  [SMALL_STATE(7542)] = 205746,
  [SMALL_STATE(7543)] = 205787,
  [SMALL_STATE(7544)] = 205848,
  [SMALL_STATE(7545)] = 205895,
  [SMALL_STATE(7546)] = 205942,
  [SMALL_STATE(7547)] = 205983,
  [SMALL_STATE(7548)] = 206024,
  [SMALL_STATE(7549)] = 206065,
  [SMALL_STATE(7550)] = 206106,
  [SMALL_STATE(7551)] = 206147,
  [SMALL_STATE(7552)] = 206188,
  [SMALL_STATE(7553)] = 206229,
  [SMALL_STATE(7554)] = 206290,
  [SMALL_STATE(7555)] = 206337,
  [SMALL_STATE(7556)] = 206378,
  [SMALL_STATE(7557)] = 206425,
  [SMALL_STATE(7558)] = 206466,
  [SMALL_STATE(7559)] = 206515,
  [SMALL_STATE(7560)] = 206556,
  [SMALL_STATE(7561)] = 206597,
  [SMALL_STATE(7562)] = 206638,
  [SMALL_STATE(7563)] = 206679,
  [SMALL_STATE(7564)] = 206720,
  [SMALL_STATE(7565)] = 206761,
  [SMALL_STATE(7566)] = 206806,
  [SMALL_STATE(7567)] = 206847,
  [SMALL_STATE(7568)] = 206892,
  [SMALL_STATE(7569)] = 206939,
  [SMALL_STATE(7570)] = 206980,
  [SMALL_STATE(7571)] = 207021,
  [SMALL_STATE(7572)] = 207082,
  [SMALL_STATE(7573)] = 207127,
  [SMALL_STATE(7574)] = 207168,
  [SMALL_STATE(7575)] = 207229,
  [SMALL_STATE(7576)] = 207276,
  [SMALL_STATE(7577)] = 207317,
  [SMALL_STATE(7578)] = 207358,
  [SMALL_STATE(7579)] = 207399,
  [SMALL_STATE(7580)] = 207440,
  [SMALL_STATE(7581)] = 207481,
  [SMALL_STATE(7582)] = 207542,
  [SMALL_STATE(7583)] = 207603,
  [SMALL_STATE(7584)] = 207644,
  [SMALL_STATE(7585)] = 207689,
  [SMALL_STATE(7586)] = 207730,
  [SMALL_STATE(7587)] = 207771,
  [SMALL_STATE(7588)] = 207812,
  [SMALL_STATE(7589)] = 207873,
  [SMALL_STATE(7590)] = 207914,
  [SMALL_STATE(7591)] = 207955,
  [SMALL_STATE(7592)] = 208016,
  [SMALL_STATE(7593)] = 208067,
  [SMALL_STATE(7594)] = 208116,
  [SMALL_STATE(7595)] = 208157,
  [SMALL_STATE(7596)] = 208218,
  [SMALL_STATE(7597)] = 208263,
  [SMALL_STATE(7598)] = 208304,
  [SMALL_STATE(7599)] = 208345,
  [SMALL_STATE(7600)] = 208386,
  [SMALL_STATE(7601)] = 208447,
  [SMALL_STATE(7602)] = 208508,
  [SMALL_STATE(7603)] = 208559,
  [SMALL_STATE(7604)] = 208600,
  [SMALL_STATE(7605)] = 208641,
  [SMALL_STATE(7606)] = 208682,
  [SMALL_STATE(7607)] = 208727,
  [SMALL_STATE(7608)] = 208768,
  [SMALL_STATE(7609)] = 208811,
  [SMALL_STATE(7610)] = 208852,
  [SMALL_STATE(7611)] = 208893,
  [SMALL_STATE(7612)] = 208936,
  [SMALL_STATE(7613)] = 208977,
  [SMALL_STATE(7614)] = 209018,
  [SMALL_STATE(7615)] = 209059,
  [SMALL_STATE(7616)] = 209100,
  [SMALL_STATE(7617)] = 209141,
  [SMALL_STATE(7618)] = 209182,
  [SMALL_STATE(7619)] = 209243,
  [SMALL_STATE(7620)] = 209284,
  [SMALL_STATE(7621)] = 209329,
  [SMALL_STATE(7622)] = 209390,
  [SMALL_STATE(7623)] = 209431,
  [SMALL_STATE(7624)] = 209472,
  [SMALL_STATE(7625)] = 209533,
  [SMALL_STATE(7626)] = 209574,
  [SMALL_STATE(7627)] = 209635,
  [SMALL_STATE(7628)] = 209676,
  [SMALL_STATE(7629)] = 209737,
  [SMALL_STATE(7630)] = 209798,
  [SMALL_STATE(7631)] = 209859,
  [SMALL_STATE(7632)] = 209900,
  [SMALL_STATE(7633)] = 209941,
  [SMALL_STATE(7634)] = 209992,
  [SMALL_STATE(7635)] = 210033,
  [SMALL_STATE(7636)] = 210089,
  [SMALL_STATE(7637)] = 210145,
  [SMALL_STATE(7638)] = 210203,
  [SMALL_STATE(7639)] = 210249,
  [SMALL_STATE(7640)] = 210307,
  [SMALL_STATE(7641)] = 210353,
  [SMALL_STATE(7642)] = 210403,
  [SMALL_STATE(7643)] = 210447,
  [SMALL_STATE(7644)] = 210505,
  [SMALL_STATE(7645)] = 210563,
  [SMALL_STATE(7646)] = 210611,
  [SMALL_STATE(7647)] = 210667,
  [SMALL_STATE(7648)] = 210723,
  [SMALL_STATE(7649)] = 210781,
  [SMALL_STATE(7650)] = 210839,
  [SMALL_STATE(7651)] = 210885,
  [SMALL_STATE(7652)] = 210935,
  [SMALL_STATE(7653)] = 210985,
  [SMALL_STATE(7654)] = 211031,
  [SMALL_STATE(7655)] = 211089,
  [SMALL_STATE(7656)] = 211145,
  [SMALL_STATE(7657)] = 211189,
  [SMALL_STATE(7658)] = 211247,
  [SMALL_STATE(7659)] = 211297,
  [SMALL_STATE(7660)] = 211355,
  [SMALL_STATE(7661)] = 211405,
  [SMALL_STATE(7662)] = 211447,
  [SMALL_STATE(7663)] = 211503,
  [SMALL_STATE(7664)] = 211561,
  [SMALL_STATE(7665)] = 211611,
  [SMALL_STATE(7666)] = 211665,
  [SMALL_STATE(7667)] = 211723,
  [SMALL_STATE(7668)] = 211781,
  [SMALL_STATE(7669)] = 211831,
  [SMALL_STATE(7670)] = 211887,
  [SMALL_STATE(7671)] = 211937,
  [SMALL_STATE(7672)] = 211995,
  [SMALL_STATE(7673)] = 212039,
  [SMALL_STATE(7674)] = 212081,
  [SMALL_STATE(7675)] = 212125,
  [SMALL_STATE(7676)] = 212175,
  [SMALL_STATE(7677)] = 212233,
  [SMALL_STATE(7678)] = 212289,
  [SMALL_STATE(7679)] = 212347,
  [SMALL_STATE(7680)] = 212391,
  [SMALL_STATE(7681)] = 212447,
  [SMALL_STATE(7682)] = 212491,
  [SMALL_STATE(7683)] = 212533,
  [SMALL_STATE(7684)] = 212591,
  [SMALL_STATE(7685)] = 212635,
  [SMALL_STATE(7686)] = 212693,
  [SMALL_STATE(7687)] = 212749,
  [SMALL_STATE(7688)] = 212805,
  [SMALL_STATE(7689)] = 212861,
  [SMALL_STATE(7690)] = 212911,
  [SMALL_STATE(7691)] = 212961,
  [SMALL_STATE(7692)] = 213017,
  [SMALL_STATE(7693)] = 213075,
  [SMALL_STATE(7694)] = 213131,
  [SMALL_STATE(7695)] = 213177,
  [SMALL_STATE(7696)] = 213227,
  [SMALL_STATE(7697)] = 213285,
  [SMALL_STATE(7698)] = 213343,
  [SMALL_STATE(7699)] = 213401,
  [SMALL_STATE(7700)] = 213457,
  [SMALL_STATE(7701)] = 213515,
  [SMALL_STATE(7702)] = 213557,
  [SMALL_STATE(7703)] = 213613,
  [SMALL_STATE(7704)] = 213669,
  [SMALL_STATE(7705)] = 213713,
  [SMALL_STATE(7706)] = 213771,
  [SMALL_STATE(7707)] = 213821,
  [SMALL_STATE(7708)] = 213865,
  [SMALL_STATE(7709)] = 213909,
  [SMALL_STATE(7710)] = 213951,
  [SMALL_STATE(7711)] = 214001,
  [SMALL_STATE(7712)] = 214051,
  [SMALL_STATE(7713)] = 214107,
  [SMALL_STATE(7714)] = 214165,
  [SMALL_STATE(7715)] = 214211,
  [SMALL_STATE(7716)] = 214267,
  [SMALL_STATE(7717)] = 214323,
  [SMALL_STATE(7718)] = 214379,
  [SMALL_STATE(7719)] = 214437,
  [SMALL_STATE(7720)] = 214495,
  [SMALL_STATE(7721)] = 214553,
  [SMALL_STATE(7722)] = 214603,
  [SMALL_STATE(7723)] = 214653,
  [SMALL_STATE(7724)] = 214699,
  [SMALL_STATE(7725)] = 214755,
  [SMALL_STATE(7726)] = 214813,
  [SMALL_STATE(7727)] = 214855,
  [SMALL_STATE(7728)] = 214913,
  [SMALL_STATE(7729)] = 214955,
  [SMALL_STATE(7730)] = 215011,
  [SMALL_STATE(7731)] = 215069,
  [SMALL_STATE(7732)] = 215125,
  [SMALL_STATE(7733)] = 215175,
  [SMALL_STATE(7734)] = 215233,
  [SMALL_STATE(7735)] = 215289,
  [SMALL_STATE(7736)] = 215347,
  [SMALL_STATE(7737)] = 215405,
  [SMALL_STATE(7738)] = 215461,
  [SMALL_STATE(7739)] = 215517,
  [SMALL_STATE(7740)] = 215567,
  [SMALL_STATE(7741)] = 215625,
  [SMALL_STATE(7742)] = 215683,
  [SMALL_STATE(7743)] = 215739,
  [SMALL_STATE(7744)] = 215789,
  [SMALL_STATE(7745)] = 215847,
  [SMALL_STATE(7746)] = 215903,
  [SMALL_STATE(7747)] = 215961,
  [SMALL_STATE(7748)] = 216017,
  [SMALL_STATE(7749)] = 216061,
  [SMALL_STATE(7750)] = 216117,
  [SMALL_STATE(7751)] = 216167,
  [SMALL_STATE(7752)] = 216223,
  [SMALL_STATE(7753)] = 216281,
  [SMALL_STATE(7754)] = 216339,
  [SMALL_STATE(7755)] = 216397,
  [SMALL_STATE(7756)] = 216455,
  [SMALL_STATE(7757)] = 216501,
  [SMALL_STATE(7758)] = 216557,
  [SMALL_STATE(7759)] = 216613,
  [SMALL_STATE(7760)] = 216671,
  [SMALL_STATE(7761)] = 216729,
  [SMALL_STATE(7762)] = 216787,
  [SMALL_STATE(7763)] = 216845,
  [SMALL_STATE(7764)] = 216903,
  [SMALL_STATE(7765)] = 216961,
  [SMALL_STATE(7766)] = 217019,
  [SMALL_STATE(7767)] = 217069,
  [SMALL_STATE(7768)] = 217119,
  [SMALL_STATE(7769)] = 217169,
  [SMALL_STATE(7770)] = 217225,
  [SMALL_STATE(7771)] = 217283,
  [SMALL_STATE(7772)] = 217339,
  [SMALL_STATE(7773)] = 217395,
  [SMALL_STATE(7774)] = 217453,
  [SMALL_STATE(7775)] = 217511,
  [SMALL_STATE(7776)] = 217561,
  [SMALL_STATE(7777)] = 217619,
  [SMALL_STATE(7778)] = 217663,
  [SMALL_STATE(7779)] = 217713,
  [SMALL_STATE(7780)] = 217769,
  [SMALL_STATE(7781)] = 217825,
  [SMALL_STATE(7782)] = 217883,
  [SMALL_STATE(7783)] = 217929,
  [SMALL_STATE(7784)] = 217975,
  [SMALL_STATE(7785)] = 218033,
  [SMALL_STATE(7786)] = 218083,
  [SMALL_STATE(7787)] = 218125,
  [SMALL_STATE(7788)] = 218181,
  [SMALL_STATE(7789)] = 218237,
  [SMALL_STATE(7790)] = 218287,
  [SMALL_STATE(7791)] = 218345,
  [SMALL_STATE(7792)] = 218401,
  [SMALL_STATE(7793)] = 218457,
  [SMALL_STATE(7794)] = 218499,
  [SMALL_STATE(7795)] = 218557,
  [SMALL_STATE(7796)] = 218613,
  [SMALL_STATE(7797)] = 218671,
  [SMALL_STATE(7798)] = 218729,
  [SMALL_STATE(7799)] = 218787,
  [SMALL_STATE(7800)] = 218845,
  [SMALL_STATE(7801)] = 218903,
  [SMALL_STATE(7802)] = 218953,
  [SMALL_STATE(7803)] = 219009,
  [SMALL_STATE(7804)] = 219059,
  [SMALL_STATE(7805)] = 219109,
  [SMALL_STATE(7806)] = 219159,
  [SMALL_STATE(7807)] = 219217,
  [SMALL_STATE(7808)] = 219273,
  [SMALL_STATE(7809)] = 219331,
  [SMALL_STATE(7810)] = 219373,
  [SMALL_STATE(7811)] = 219431,
  [SMALL_STATE(7812)] = 219473,
  [SMALL_STATE(7813)] = 219515,
  [SMALL_STATE(7814)] = 219571,
  [SMALL_STATE(7815)] = 219621,
  [SMALL_STATE(7816)] = 219679,
  [SMALL_STATE(7817)] = 219735,
  [SMALL_STATE(7818)] = 219793,
  [SMALL_STATE(7819)] = 219851,
  [SMALL_STATE(7820)] = 219893,
  [SMALL_STATE(7821)] = 219951,
  [SMALL_STATE(7822)] = 219993,
  [SMALL_STATE(7823)] = 220051,
  [SMALL_STATE(7824)] = 220101,
  [SMALL_STATE(7825)] = 220159,
  [SMALL_STATE(7826)] = 220215,
  [SMALL_STATE(7827)] = 220271,
  [SMALL_STATE(7828)] = 220329,
  [SMALL_STATE(7829)] = 220385,
  [SMALL_STATE(7830)] = 220441,
  [SMALL_STATE(7831)] = 220499,
  [SMALL_STATE(7832)] = 220557,
  [SMALL_STATE(7833)] = 220615,
  [SMALL_STATE(7834)] = 220673,
  [SMALL_STATE(7835)] = 220731,
  [SMALL_STATE(7836)] = 220773,
  [SMALL_STATE(7837)] = 220831,
  [SMALL_STATE(7838)] = 220889,
  [SMALL_STATE(7839)] = 220939,
  [SMALL_STATE(7840)] = 220997,
  [SMALL_STATE(7841)] = 221039,
  [SMALL_STATE(7842)] = 221097,
  [SMALL_STATE(7843)] = 221141,
  [SMALL_STATE(7844)] = 221197,
  [SMALL_STATE(7845)] = 221247,
  [SMALL_STATE(7846)] = 221297,
  [SMALL_STATE(7847)] = 221353,
  [SMALL_STATE(7848)] = 221409,
  [SMALL_STATE(7849)] = 221465,
  [SMALL_STATE(7850)] = 221521,
  [SMALL_STATE(7851)] = 221577,
  [SMALL_STATE(7852)] = 221621,
  [SMALL_STATE(7853)] = 221679,
  [SMALL_STATE(7854)] = 221721,
  [SMALL_STATE(7855)] = 221767,
  [SMALL_STATE(7856)] = 221811,
  [SMALL_STATE(7857)] = 221869,
  [SMALL_STATE(7858)] = 221925,
  [SMALL_STATE(7859)] = 221975,
  [SMALL_STATE(7860)] = 222033,
  [SMALL_STATE(7861)] = 222079,
  [SMALL_STATE(7862)] = 222135,
  [SMALL_STATE(7863)] = 222193,
  [SMALL_STATE(7864)] = 222249,
  [SMALL_STATE(7865)] = 222295,
  [SMALL_STATE(7866)] = 222351,
  [SMALL_STATE(7867)] = 222395,
  [SMALL_STATE(7868)] = 222451,
  [SMALL_STATE(7869)] = 222497,
  [SMALL_STATE(7870)] = 222547,
  [SMALL_STATE(7871)] = 222597,
  [SMALL_STATE(7872)] = 222655,
  [SMALL_STATE(7873)] = 222709,
  [SMALL_STATE(7874)] = 222753,
  [SMALL_STATE(7875)] = 222803,
  [SMALL_STATE(7876)] = 222861,
  [SMALL_STATE(7877)] = 222919,
  [SMALL_STATE(7878)] = 222961,
  [SMALL_STATE(7879)] = 223011,
  [SMALL_STATE(7880)] = 223069,
  [SMALL_STATE(7881)] = 223125,
  [SMALL_STATE(7882)] = 223181,
  [SMALL_STATE(7883)] = 223223,
  [SMALL_STATE(7884)] = 223281,
  [SMALL_STATE(7885)] = 223331,
  [SMALL_STATE(7886)] = 223375,
  [SMALL_STATE(7887)] = 223433,
  [SMALL_STATE(7888)] = 223489,
  [SMALL_STATE(7889)] = 223539,
  [SMALL_STATE(7890)] = 223589,
  [SMALL_STATE(7891)] = 223633,
  [SMALL_STATE(7892)] = 223691,
  [SMALL_STATE(7893)] = 223741,
  [SMALL_STATE(7894)] = 223791,
  [SMALL_STATE(7895)] = 223847,
  [SMALL_STATE(7896)] = 223903,
  [SMALL_STATE(7897)] = 223953,
  [SMALL_STATE(7898)] = 224011,
  [SMALL_STATE(7899)] = 224069,
  [SMALL_STATE(7900)] = 224127,
  [SMALL_STATE(7901)] = 224183,
  [SMALL_STATE(7902)] = 224241,
  [SMALL_STATE(7903)] = 224285,
  [SMALL_STATE(7904)] = 224335,
  [SMALL_STATE(7905)] = 224393,
  [SMALL_STATE(7906)] = 224451,
  [SMALL_STATE(7907)] = 224501,
  [SMALL_STATE(7908)] = 224557,
  [SMALL_STATE(7909)] = 224603,
  [SMALL_STATE(7910)] = 224659,
  [SMALL_STATE(7911)] = 224705,
  [SMALL_STATE(7912)] = 224763,
  [SMALL_STATE(7913)] = 224819,
  [SMALL_STATE(7914)] = 224877,
  [SMALL_STATE(7915)] = 224933,
  [SMALL_STATE(7916)] = 224991,
  [SMALL_STATE(7917)] = 225049,
  [SMALL_STATE(7918)] = 225107,
  [SMALL_STATE(7919)] = 225165,
  [SMALL_STATE(7920)] = 225221,
  [SMALL_STATE(7921)] = 225277,
  [SMALL_STATE(7922)] = 225333,
  [SMALL_STATE(7923)] = 225391,
  [SMALL_STATE(7924)] = 225447,
  [SMALL_STATE(7925)] = 225505,
  [SMALL_STATE(7926)] = 225561,
  [SMALL_STATE(7927)] = 225617,
  [SMALL_STATE(7928)] = 225673,
  [SMALL_STATE(7929)] = 225715,
  [SMALL_STATE(7930)] = 225773,
  [SMALL_STATE(7931)] = 225815,
  [SMALL_STATE(7932)] = 225861,
  [SMALL_STATE(7933)] = 225905,
  [SMALL_STATE(7934)] = 225963,
  [SMALL_STATE(7935)] = 226013,
  [SMALL_STATE(7936)] = 226069,
  [SMALL_STATE(7937)] = 226125,
  [SMALL_STATE(7938)] = 226181,
  [SMALL_STATE(7939)] = 226237,
  [SMALL_STATE(7940)] = 226281,
  [SMALL_STATE(7941)] = 226339,
  [SMALL_STATE(7942)] = 226395,
  [SMALL_STATE(7943)] = 226453,
  [SMALL_STATE(7944)] = 226503,
  [SMALL_STATE(7945)] = 226547,
  [SMALL_STATE(7946)] = 226605,
  [SMALL_STATE(7947)] = 226651,
  [SMALL_STATE(7948)] = 226709,
  [SMALL_STATE(7949)] = 226751,
  [SMALL_STATE(7950)] = 226807,
  [SMALL_STATE(7951)] = 226849,
  [SMALL_STATE(7952)] = 226907,
  [SMALL_STATE(7953)] = 226963,
  [SMALL_STATE(7954)] = 227019,
  [SMALL_STATE(7955)] = 227069,
  [SMALL_STATE(7956)] = 227119,
  [SMALL_STATE(7957)] = 227177,
  [SMALL_STATE(7958)] = 227232,
  [SMALL_STATE(7959)] = 227273,
  [SMALL_STATE(7960)] = 227314,
  [SMALL_STATE(7961)] = 227369,
  [SMALL_STATE(7962)] = 227424,
  [SMALL_STATE(7963)] = 227479,
  [SMALL_STATE(7964)] = 227520,
  [SMALL_STATE(7965)] = 227575,
  [SMALL_STATE(7966)] = 227630,
  [SMALL_STATE(7967)] = 227685,
  [SMALL_STATE(7968)] = 227740,
  [SMALL_STATE(7969)] = 227783,
  [SMALL_STATE(7970)] = 227838,
  [SMALL_STATE(7971)] = 227879,
  [SMALL_STATE(7972)] = 227934,
  [SMALL_STATE(7973)] = 227975,
  [SMALL_STATE(7974)] = 228030,
  [SMALL_STATE(7975)] = 228071,
  [SMALL_STATE(7976)] = 228112,
  [SMALL_STATE(7977)] = 228167,
  [SMALL_STATE(7978)] = 228222,
  [SMALL_STATE(7979)] = 228277,
  [SMALL_STATE(7980)] = 228332,
  [SMALL_STATE(7981)] = 228387,
  [SMALL_STATE(7982)] = 228432,
  [SMALL_STATE(7983)] = 228473,
  [SMALL_STATE(7984)] = 228528,
  [SMALL_STATE(7985)] = 228583,
  [SMALL_STATE(7986)] = 228638,
  [SMALL_STATE(7987)] = 228679,
  [SMALL_STATE(7988)] = 228722,
  [SMALL_STATE(7989)] = 228769,
  [SMALL_STATE(7990)] = 228824,
  [SMALL_STATE(7991)] = 228879,
  [SMALL_STATE(7992)] = 228934,
  [SMALL_STATE(7993)] = 228989,
  [SMALL_STATE(7994)] = 229030,
  [SMALL_STATE(7995)] = 229085,
  [SMALL_STATE(7996)] = 229130,
  [SMALL_STATE(7997)] = 229173,
  [SMALL_STATE(7998)] = 229214,
  [SMALL_STATE(7999)] = 229261,
  [SMALL_STATE(8000)] = 229316,
  [SMALL_STATE(8001)] = 229371,
  [SMALL_STATE(8002)] = 229412,
  [SMALL_STATE(8003)] = 229455,
  [SMALL_STATE(8004)] = 229510,
  [SMALL_STATE(8005)] = 229565,
  [SMALL_STATE(8006)] = 229620,
  [SMALL_STATE(8007)] = 229675,
  [SMALL_STATE(8008)] = 229718,
  [SMALL_STATE(8009)] = 229773,
  [SMALL_STATE(8010)] = 229828,
  [SMALL_STATE(8011)] = 229869,
  [SMALL_STATE(8012)] = 229924,
  [SMALL_STATE(8013)] = 229979,
  [SMALL_STATE(8014)] = 230034,
  [SMALL_STATE(8015)] = 230075,
  [SMALL_STATE(8016)] = 230118,
  [SMALL_STATE(8017)] = 230161,
  [SMALL_STATE(8018)] = 230202,
  [SMALL_STATE(8019)] = 230257,
  [SMALL_STATE(8020)] = 230312,
  [SMALL_STATE(8021)] = 230367,
  [SMALL_STATE(8022)] = 230410,
  [SMALL_STATE(8023)] = 230465,
  [SMALL_STATE(8024)] = 230506,
  [SMALL_STATE(8025)] = 230561,
  [SMALL_STATE(8026)] = 230616,
  [SMALL_STATE(8027)] = 230671,
  [SMALL_STATE(8028)] = 230726,
  [SMALL_STATE(8029)] = 230781,
  [SMALL_STATE(8030)] = 230836,
  [SMALL_STATE(8031)] = 230891,
  [SMALL_STATE(8032)] = 230932,
  [SMALL_STATE(8033)] = 230987,
  [SMALL_STATE(8034)] = 231042,
  [SMALL_STATE(8035)] = 231097,
  [SMALL_STATE(8036)] = 231152,
  [SMALL_STATE(8037)] = 231207,
  [SMALL_STATE(8038)] = 231262,
  [SMALL_STATE(8039)] = 231317,
  [SMALL_STATE(8040)] = 231358,
  [SMALL_STATE(8041)] = 231413,
  [SMALL_STATE(8042)] = 231458,
  [SMALL_STATE(8043)] = 231513,
  [SMALL_STATE(8044)] = 231568,
  [SMALL_STATE(8045)] = 231623,
  [SMALL_STATE(8046)] = 231678,
  [SMALL_STATE(8047)] = 231733,
  [SMALL_STATE(8048)] = 231788,
  [SMALL_STATE(8049)] = 231833,
  [SMALL_STATE(8050)] = 231888,
  [SMALL_STATE(8051)] = 231943,
  [SMALL_STATE(8052)] = 231998,
  [SMALL_STATE(8053)] = 232039,
  [SMALL_STATE(8054)] = 232080,
  [SMALL_STATE(8055)] = 232135,
  [SMALL_STATE(8056)] = 232190,
  [SMALL_STATE(8057)] = 232245,
  [SMALL_STATE(8058)] = 232300,
  [SMALL_STATE(8059)] = 232355,
  [SMALL_STATE(8060)] = 232408,
  [SMALL_STATE(8061)] = 232463,
  [SMALL_STATE(8062)] = 232518,
  [SMALL_STATE(8063)] = 232561,
  [SMALL_STATE(8064)] = 232616,
  [SMALL_STATE(8065)] = 232671,
  [SMALL_STATE(8066)] = 232712,
  [SMALL_STATE(8067)] = 232753,
  [SMALL_STATE(8068)] = 232808,
  [SMALL_STATE(8069)] = 232863,
  [SMALL_STATE(8070)] = 232918,
  [SMALL_STATE(8071)] = 232973,
  [SMALL_STATE(8072)] = 233028,
  [SMALL_STATE(8073)] = 233073,
  [SMALL_STATE(8074)] = 233128,
  [SMALL_STATE(8075)] = 233183,
  [SMALL_STATE(8076)] = 233238,
  [SMALL_STATE(8077)] = 233279,
  [SMALL_STATE(8078)] = 233320,
  [SMALL_STATE(8079)] = 233375,
  [SMALL_STATE(8080)] = 233430,
  [SMALL_STATE(8081)] = 233485,
  [SMALL_STATE(8082)] = 233540,
  [SMALL_STATE(8083)] = 233595,
  [SMALL_STATE(8084)] = 233650,
  [SMALL_STATE(8085)] = 233691,
  [SMALL_STATE(8086)] = 233746,
  [SMALL_STATE(8087)] = 233801,
  [SMALL_STATE(8088)] = 233842,
  [SMALL_STATE(8089)] = 233883,
  [SMALL_STATE(8090)] = 233926,
  [SMALL_STATE(8091)] = 233981,
  [SMALL_STATE(8092)] = 234036,
  [SMALL_STATE(8093)] = 234091,
  [SMALL_STATE(8094)] = 234146,
  [SMALL_STATE(8095)] = 234187,
  [SMALL_STATE(8096)] = 234228,
  [SMALL_STATE(8097)] = 234283,
  [SMALL_STATE(8098)] = 234338,
  [SMALL_STATE(8099)] = 234393,
  [SMALL_STATE(8100)] = 234448,
  [SMALL_STATE(8101)] = 234489,
  [SMALL_STATE(8102)] = 234544,
  [SMALL_STATE(8103)] = 234597,
  [SMALL_STATE(8104)] = 234652,
  [SMALL_STATE(8105)] = 234707,
  [SMALL_STATE(8106)] = 234762,
  [SMALL_STATE(8107)] = 234817,
  [SMALL_STATE(8108)] = 234858,
  [SMALL_STATE(8109)] = 234901,
  [SMALL_STATE(8110)] = 234956,
  [SMALL_STATE(8111)] = 235011,
  [SMALL_STATE(8112)] = 235066,
  [SMALL_STATE(8113)] = 235121,
  [SMALL_STATE(8114)] = 235164,
  [SMALL_STATE(8115)] = 235217,
  [SMALL_STATE(8116)] = 235258,
  [SMALL_STATE(8117)] = 235303,
  [SMALL_STATE(8118)] = 235358,
  [SMALL_STATE(8119)] = 235413,
  [SMALL_STATE(8120)] = 235456,
  [SMALL_STATE(8121)] = 235511,
  [SMALL_STATE(8122)] = 235566,
  [SMALL_STATE(8123)] = 235619,
  [SMALL_STATE(8124)] = 235674,
  [SMALL_STATE(8125)] = 235715,
  [SMALL_STATE(8126)] = 235758,
  [SMALL_STATE(8127)] = 235813,
  [SMALL_STATE(8128)] = 235868,
  [SMALL_STATE(8129)] = 235923,
  [SMALL_STATE(8130)] = 235970,
  [SMALL_STATE(8131)] = 236023,
  [SMALL_STATE(8132)] = 236078,
  [SMALL_STATE(8133)] = 236133,
  [SMALL_STATE(8134)] = 236188,
  [SMALL_STATE(8135)] = 236243,
  [SMALL_STATE(8136)] = 236286,
  [SMALL_STATE(8137)] = 236341,
  [SMALL_STATE(8138)] = 236380,
  [SMALL_STATE(8139)] = 236435,
  [SMALL_STATE(8140)] = 236476,
  [SMALL_STATE(8141)] = 236517,
  [SMALL_STATE(8142)] = 236572,
  [SMALL_STATE(8143)] = 236627,
  [SMALL_STATE(8144)] = 236682,
  [SMALL_STATE(8145)] = 236721,
  [SMALL_STATE(8146)] = 236776,
  [SMALL_STATE(8147)] = 236815,
  [SMALL_STATE(8148)] = 236858,
  [SMALL_STATE(8149)] = 236913,
  [SMALL_STATE(8150)] = 236960,
  [SMALL_STATE(8151)] = 237015,
  [SMALL_STATE(8152)] = 237070,
  [SMALL_STATE(8153)] = 237125,
  [SMALL_STATE(8154)] = 237180,
  [SMALL_STATE(8155)] = 237235,
  [SMALL_STATE(8156)] = 237274,
  [SMALL_STATE(8157)] = 237321,
  [SMALL_STATE(8158)] = 237376,
  [SMALL_STATE(8159)] = 237431,
  [SMALL_STATE(8160)] = 237472,
  [SMALL_STATE(8161)] = 237513,
  [SMALL_STATE(8162)] = 237556,
  [SMALL_STATE(8163)] = 237603,
  [SMALL_STATE(8164)] = 237656,
  [SMALL_STATE(8165)] = 237697,
  [SMALL_STATE(8166)] = 237738,
  [SMALL_STATE(8167)] = 237793,
  [SMALL_STATE(8168)] = 237848,
  [SMALL_STATE(8169)] = 237903,
  [SMALL_STATE(8170)] = 237958,
  [SMALL_STATE(8171)] = 238001,
  [SMALL_STATE(8172)] = 238040,
  [SMALL_STATE(8173)] = 238087,
  [SMALL_STATE(8174)] = 238128,
  [SMALL_STATE(8175)] = 238183,
  [SMALL_STATE(8176)] = 238236,
  [SMALL_STATE(8177)] = 238291,
  [SMALL_STATE(8178)] = 238336,
  [SMALL_STATE(8179)] = 238391,
  [SMALL_STATE(8180)] = 238446,
  [SMALL_STATE(8181)] = 238493,
  [SMALL_STATE(8182)] = 238536,
  [SMALL_STATE(8183)] = 238591,
  [SMALL_STATE(8184)] = 238632,
  [SMALL_STATE(8185)] = 238687,
  [SMALL_STATE(8186)] = 238742,
  [SMALL_STATE(8187)] = 238797,
  [SMALL_STATE(8188)] = 238852,
  [SMALL_STATE(8189)] = 238907,
  [SMALL_STATE(8190)] = 238962,
  [SMALL_STATE(8191)] = 239017,
  [SMALL_STATE(8192)] = 239058,
  [SMALL_STATE(8193)] = 239113,
  [SMALL_STATE(8194)] = 239168,
  [SMALL_STATE(8195)] = 239209,
  [SMALL_STATE(8196)] = 239264,
  [SMALL_STATE(8197)] = 239319,
  [SMALL_STATE(8198)] = 239374,
  [SMALL_STATE(8199)] = 239429,
  [SMALL_STATE(8200)] = 239470,
  [SMALL_STATE(8201)] = 239525,
  [SMALL_STATE(8202)] = 239580,
  [SMALL_STATE(8203)] = 239635,
  [SMALL_STATE(8204)] = 239690,
  [SMALL_STATE(8205)] = 239745,
  [SMALL_STATE(8206)] = 239800,
  [SMALL_STATE(8207)] = 239841,
  [SMALL_STATE(8208)] = 239896,
  [SMALL_STATE(8209)] = 239939,
  [SMALL_STATE(8210)] = 239980,
  [SMALL_STATE(8211)] = 240035,
  [SMALL_STATE(8212)] = 240090,
  [SMALL_STATE(8213)] = 240145,
  [SMALL_STATE(8214)] = 240200,
  [SMALL_STATE(8215)] = 240255,
  [SMALL_STATE(8216)] = 240296,
  [SMALL_STATE(8217)] = 240351,
  [SMALL_STATE(8218)] = 240406,
  [SMALL_STATE(8219)] = 240461,
  [SMALL_STATE(8220)] = 240516,
  [SMALL_STATE(8221)] = 240571,
  [SMALL_STATE(8222)] = 240626,
  [SMALL_STATE(8223)] = 240681,
  [SMALL_STATE(8224)] = 240736,
  [SMALL_STATE(8225)] = 240791,
  [SMALL_STATE(8226)] = 240832,
  [SMALL_STATE(8227)] = 240887,
  [SMALL_STATE(8228)] = 240926,
  [SMALL_STATE(8229)] = 240965,
  [SMALL_STATE(8230)] = 241020,
  [SMALL_STATE(8231)] = 241061,
  [SMALL_STATE(8232)] = 241116,
  [SMALL_STATE(8233)] = 241171,
  [SMALL_STATE(8234)] = 241218,
  [SMALL_STATE(8235)] = 241273,
  [SMALL_STATE(8236)] = 241314,
  [SMALL_STATE(8237)] = 241369,
  [SMALL_STATE(8238)] = 241410,
  [SMALL_STATE(8239)] = 241465,
  [SMALL_STATE(8240)] = 241510,
  [SMALL_STATE(8241)] = 241565,
  [SMALL_STATE(8242)] = 241620,
  [SMALL_STATE(8243)] = 241675,
  [SMALL_STATE(8244)] = 241716,
  [SMALL_STATE(8245)] = 241771,
  [SMALL_STATE(8246)] = 241826,
  [SMALL_STATE(8247)] = 241867,
  [SMALL_STATE(8248)] = 241922,
  [SMALL_STATE(8249)] = 241963,
  [SMALL_STATE(8250)] = 242004,
  [SMALL_STATE(8251)] = 242059,
  [SMALL_STATE(8252)] = 242114,
  [SMALL_STATE(8253)] = 242155,
  [SMALL_STATE(8254)] = 242210,
  [SMALL_STATE(8255)] = 242265,
  [SMALL_STATE(8256)] = 242320,
  [SMALL_STATE(8257)] = 242361,
  [SMALL_STATE(8258)] = 242416,
  [SMALL_STATE(8259)] = 242457,
  [SMALL_STATE(8260)] = 242502,
  [SMALL_STATE(8261)] = 242557,
  [SMALL_STATE(8262)] = 242612,
  [SMALL_STATE(8263)] = 242653,
  [SMALL_STATE(8264)] = 242708,
  [SMALL_STATE(8265)] = 242755,
  [SMALL_STATE(8266)] = 242796,
  [SMALL_STATE(8267)] = 242851,
  [SMALL_STATE(8268)] = 242892,
  [SMALL_STATE(8269)] = 242933,
  [SMALL_STATE(8270)] = 242974,
  [SMALL_STATE(8271)] = 243029,
  [SMALL_STATE(8272)] = 243084,
  [SMALL_STATE(8273)] = 243139,
  [SMALL_STATE(8274)] = 243194,
  [SMALL_STATE(8275)] = 243249,
  [SMALL_STATE(8276)] = 243290,
  [SMALL_STATE(8277)] = 243345,
  [SMALL_STATE(8278)] = 243400,
  [SMALL_STATE(8279)] = 243455,
  [SMALL_STATE(8280)] = 243496,
  [SMALL_STATE(8281)] = 243551,
  [SMALL_STATE(8282)] = 243606,
  [SMALL_STATE(8283)] = 243649,
  [SMALL_STATE(8284)] = 243704,
  [SMALL_STATE(8285)] = 243759,
  [SMALL_STATE(8286)] = 243814,
  [SMALL_STATE(8287)] = 243869,
  [SMALL_STATE(8288)] = 243924,
  [SMALL_STATE(8289)] = 243965,
  [SMALL_STATE(8290)] = 244020,
  [SMALL_STATE(8291)] = 244061,
  [SMALL_STATE(8292)] = 244116,
  [SMALL_STATE(8293)] = 244171,
  [SMALL_STATE(8294)] = 244218,
  [SMALL_STATE(8295)] = 244263,
  [SMALL_STATE(8296)] = 244318,
  [SMALL_STATE(8297)] = 244373,
  [SMALL_STATE(8298)] = 244413,
  [SMALL_STATE(8299)] = 244453,
  [SMALL_STATE(8300)] = 244493,
  [SMALL_STATE(8301)] = 244545,
  [SMALL_STATE(8302)] = 244595,
  [SMALL_STATE(8303)] = 244635,
  [SMALL_STATE(8304)] = 244687,
  [SMALL_STATE(8305)] = 244727,
  [SMALL_STATE(8306)] = 244767,
  [SMALL_STATE(8307)] = 244807,
  [SMALL_STATE(8308)] = 244847,
  [SMALL_STATE(8309)] = 244887,
  [SMALL_STATE(8310)] = 244939,
  [SMALL_STATE(8311)] = 244983,
  [SMALL_STATE(8312)] = 245023,
  [SMALL_STATE(8313)] = 245073,
  [SMALL_STATE(8314)] = 245111,
  [SMALL_STATE(8315)] = 245151,
  [SMALL_STATE(8316)] = 245193,
  [SMALL_STATE(8317)] = 245235,
  [SMALL_STATE(8318)] = 245287,
  [SMALL_STATE(8319)] = 245339,
  [SMALL_STATE(8320)] = 245379,
  [SMALL_STATE(8321)] = 245431,
  [SMALL_STATE(8322)] = 245471,
  [SMALL_STATE(8323)] = 245523,
  [SMALL_STATE(8324)] = 245563,
  [SMALL_STATE(8325)] = 245615,
  [SMALL_STATE(8326)] = 245657,
  [SMALL_STATE(8327)] = 245695,
  [SMALL_STATE(8328)] = 245735,
  [SMALL_STATE(8329)] = 245787,
  [SMALL_STATE(8330)] = 245827,
  [SMALL_STATE(8331)] = 245869,
  [SMALL_STATE(8332)] = 245921,
  [SMALL_STATE(8333)] = 245961,
  [SMALL_STATE(8334)] = 246001,
  [SMALL_STATE(8335)] = 246041,
  [SMALL_STATE(8336)] = 246081,
  [SMALL_STATE(8337)] = 246121,
  [SMALL_STATE(8338)] = 246163,
  [SMALL_STATE(8339)] = 246203,
  [SMALL_STATE(8340)] = 246243,
  [SMALL_STATE(8341)] = 246283,
  [SMALL_STATE(8342)] = 246325,
  [SMALL_STATE(8343)] = 246365,
  [SMALL_STATE(8344)] = 246407,
  [SMALL_STATE(8345)] = 246447,
  [SMALL_STATE(8346)] = 246489,
  [SMALL_STATE(8347)] = 246529,
  [SMALL_STATE(8348)] = 246579,
  [SMALL_STATE(8349)] = 246621,
  [SMALL_STATE(8350)] = 246671,
  [SMALL_STATE(8351)] = 246723,
  [SMALL_STATE(8352)] = 246763,
  [SMALL_STATE(8353)] = 246803,
  [SMALL_STATE(8354)] = 246843,
  [SMALL_STATE(8355)] = 246883,
  [SMALL_STATE(8356)] = 246923,
  [SMALL_STATE(8357)] = 246975,
  [SMALL_STATE(8358)] = 247015,
  [SMALL_STATE(8359)] = 247067,
  [SMALL_STATE(8360)] = 247117,
  [SMALL_STATE(8361)] = 247157,
  [SMALL_STATE(8362)] = 247209,
  [SMALL_STATE(8363)] = 247259,
  [SMALL_STATE(8364)] = 247299,
  [SMALL_STATE(8365)] = 247351,
  [SMALL_STATE(8366)] = 247391,
  [SMALL_STATE(8367)] = 247431,
  [SMALL_STATE(8368)] = 247483,
  [SMALL_STATE(8369)] = 247521,
  [SMALL_STATE(8370)] = 247573,
  [SMALL_STATE(8371)] = 247625,
  [SMALL_STATE(8372)] = 247677,
  [SMALL_STATE(8373)] = 247729,
  [SMALL_STATE(8374)] = 247769,
  [SMALL_STATE(8375)] = 247809,
  [SMALL_STATE(8376)] = 247861,
  [SMALL_STATE(8377)] = 247913,
  [SMALL_STATE(8378)] = 247965,
  [SMALL_STATE(8379)] = 248017,
  [SMALL_STATE(8380)] = 248057,
  [SMALL_STATE(8381)] = 248109,
  [SMALL_STATE(8382)] = 248161,
  [SMALL_STATE(8383)] = 248213,
  [SMALL_STATE(8384)] = 248261,
  [SMALL_STATE(8385)] = 248301,
  [SMALL_STATE(8386)] = 248351,
  [SMALL_STATE(8387)] = 248403,
  [SMALL_STATE(8388)] = 248443,
  [SMALL_STATE(8389)] = 248493,
  [SMALL_STATE(8390)] = 248533,
  [SMALL_STATE(8391)] = 248583,
  [SMALL_STATE(8392)] = 248627,
  [SMALL_STATE(8393)] = 248679,
  [SMALL_STATE(8394)] = 248719,
  [SMALL_STATE(8395)] = 248771,
  [SMALL_STATE(8396)] = 248811,
  [SMALL_STATE(8397)] = 248851,
  [SMALL_STATE(8398)] = 248891,
  [SMALL_STATE(8399)] = 248931,
  [SMALL_STATE(8400)] = 248981,
  [SMALL_STATE(8401)] = 249021,
  [SMALL_STATE(8402)] = 249073,
  [SMALL_STATE(8403)] = 249113,
  [SMALL_STATE(8404)] = 249155,
  [SMALL_STATE(8405)] = 249195,
  [SMALL_STATE(8406)] = 249247,
  [SMALL_STATE(8407)] = 249299,
  [SMALL_STATE(8408)] = 249351,
  [SMALL_STATE(8409)] = 249403,
  [SMALL_STATE(8410)] = 249455,
  [SMALL_STATE(8411)] = 249503,
  [SMALL_STATE(8412)] = 249555,
  [SMALL_STATE(8413)] = 249607,
  [SMALL_STATE(8414)] = 249659,
  [SMALL_STATE(8415)] = 249711,
  [SMALL_STATE(8416)] = 249763,
  [SMALL_STATE(8417)] = 249815,
  [SMALL_STATE(8418)] = 249867,
  [SMALL_STATE(8419)] = 249919,
  [SMALL_STATE(8420)] = 249959,
  [SMALL_STATE(8421)] = 250011,
  [SMALL_STATE(8422)] = 250063,
  [SMALL_STATE(8423)] = 250105,
  [SMALL_STATE(8424)] = 250145,
  [SMALL_STATE(8425)] = 250197,
  [SMALL_STATE(8426)] = 250237,
  [SMALL_STATE(8427)] = 250287,
  [SMALL_STATE(8428)] = 250329,
  [SMALL_STATE(8429)] = 250367,
  [SMALL_STATE(8430)] = 250419,
  [SMALL_STATE(8431)] = 250461,
  [SMALL_STATE(8432)] = 250513,
  [SMALL_STATE(8433)] = 250553,
  [SMALL_STATE(8434)] = 250605,
  [SMALL_STATE(8435)] = 250657,
  [SMALL_STATE(8436)] = 250701,
  [SMALL_STATE(8437)] = 250739,
  [SMALL_STATE(8438)] = 250791,
  [SMALL_STATE(8439)] = 250840,
  [SMALL_STATE(8440)] = 250889,
  [SMALL_STATE(8441)] = 250936,
  [SMALL_STATE(8442)] = 250985,
  [SMALL_STATE(8443)] = 251032,
  [SMALL_STATE(8444)] = 251081,
  [SMALL_STATE(8445)] = 251130,
  [SMALL_STATE(8446)] = 251179,
  [SMALL_STATE(8447)] = 251228,
  [SMALL_STATE(8448)] = 251267,
  [SMALL_STATE(8449)] = 251314,
  [SMALL_STATE(8450)] = 251363,
  [SMALL_STATE(8451)] = 251412,
  [SMALL_STATE(8452)] = 251459,
  [SMALL_STATE(8453)] = 251506,
  [SMALL_STATE(8454)] = 251555,
  [SMALL_STATE(8455)] = 251604,
  [SMALL_STATE(8456)] = 251651,
  [SMALL_STATE(8457)] = 251700,
  [SMALL_STATE(8458)] = 251749,
  [SMALL_STATE(8459)] = 251798,
  [SMALL_STATE(8460)] = 251847,
  [SMALL_STATE(8461)] = 251884,
  [SMALL_STATE(8462)] = 251923,
  [SMALL_STATE(8463)] = 251970,
  [SMALL_STATE(8464)] = 252017,
  [SMALL_STATE(8465)] = 252066,
  [SMALL_STATE(8466)] = 252115,
  [SMALL_STATE(8467)] = 252164,
  [SMALL_STATE(8468)] = 252213,
  [SMALL_STATE(8469)] = 252262,
  [SMALL_STATE(8470)] = 252311,
  [SMALL_STATE(8471)] = 252358,
  [SMALL_STATE(8472)] = 252407,
  [SMALL_STATE(8473)] = 252454,
  [SMALL_STATE(8474)] = 252503,
  [SMALL_STATE(8475)] = 252552,
  [SMALL_STATE(8476)] = 252589,
  [SMALL_STATE(8477)] = 252626,
  [SMALL_STATE(8478)] = 252663,
  [SMALL_STATE(8479)] = 252700,
  [SMALL_STATE(8480)] = 252739,
  [SMALL_STATE(8481)] = 252778,
  [SMALL_STATE(8482)] = 252815,
  [SMALL_STATE(8483)] = 252864,
  [SMALL_STATE(8484)] = 252901,
  [SMALL_STATE(8485)] = 252938,
  [SMALL_STATE(8486)] = 252975,
  [SMALL_STATE(8487)] = 253024,
  [SMALL_STATE(8488)] = 253061,
  [SMALL_STATE(8489)] = 253098,
  [SMALL_STATE(8490)] = 253147,
  [SMALL_STATE(8491)] = 253196,
  [SMALL_STATE(8492)] = 253243,
  [SMALL_STATE(8493)] = 253282,
  [SMALL_STATE(8494)] = 253329,
  [SMALL_STATE(8495)] = 253368,
  [SMALL_STATE(8496)] = 253407,
  [SMALL_STATE(8497)] = 253456,
  [SMALL_STATE(8498)] = 253495,
  [SMALL_STATE(8499)] = 253542,
  [SMALL_STATE(8500)] = 253581,
  [SMALL_STATE(8501)] = 253620,
  [SMALL_STATE(8502)] = 253667,
  [SMALL_STATE(8503)] = 253716,
  [SMALL_STATE(8504)] = 253753,
  [SMALL_STATE(8505)] = 253792,
  [SMALL_STATE(8506)] = 253831,
  [SMALL_STATE(8507)] = 253870,
  [SMALL_STATE(8508)] = 253911,
  [SMALL_STATE(8509)] = 253960,
  [SMALL_STATE(8510)] = 253999,
  [SMALL_STATE(8511)] = 254038,
  [SMALL_STATE(8512)] = 254077,
  [SMALL_STATE(8513)] = 254126,
  [SMALL_STATE(8514)] = 254175,
  [SMALL_STATE(8515)] = 254224,
  [SMALL_STATE(8516)] = 254261,
  [SMALL_STATE(8517)] = 254310,
  [SMALL_STATE(8518)] = 254359,
  [SMALL_STATE(8519)] = 254406,
  [SMALL_STATE(8520)] = 254455,
  [SMALL_STATE(8521)] = 254494,
  [SMALL_STATE(8522)] = 254543,
  [SMALL_STATE(8523)] = 254582,
  [SMALL_STATE(8524)] = 254631,
  [SMALL_STATE(8525)] = 254672,
  [SMALL_STATE(8526)] = 254721,
  [SMALL_STATE(8527)] = 254768,
  [SMALL_STATE(8528)] = 254805,
  [SMALL_STATE(8529)] = 254854,
  [SMALL_STATE(8530)] = 254903,
  [SMALL_STATE(8531)] = 254952,
  [SMALL_STATE(8532)] = 254991,
  [SMALL_STATE(8533)] = 255038,
  [SMALL_STATE(8534)] = 255085,
  [SMALL_STATE(8535)] = 255132,
  [SMALL_STATE(8536)] = 255179,
  [SMALL_STATE(8537)] = 255226,
  [SMALL_STATE(8538)] = 255273,
  [SMALL_STATE(8539)] = 255322,
  [SMALL_STATE(8540)] = 255371,
  [SMALL_STATE(8541)] = 255420,
  [SMALL_STATE(8542)] = 255469,
  [SMALL_STATE(8543)] = 255518,
  [SMALL_STATE(8544)] = 255567,
  [SMALL_STATE(8545)] = 255614,
  [SMALL_STATE(8546)] = 255663,
  [SMALL_STATE(8547)] = 255700,
  [SMALL_STATE(8548)] = 255749,
  [SMALL_STATE(8549)] = 255798,
  [SMALL_STATE(8550)] = 255845,
  [SMALL_STATE(8551)] = 255892,
  [SMALL_STATE(8552)] = 255941,
  [SMALL_STATE(8553)] = 255990,
  [SMALL_STATE(8554)] = 256039,
  [SMALL_STATE(8555)] = 256088,
  [SMALL_STATE(8556)] = 256125,
  [SMALL_STATE(8557)] = 256174,
  [SMALL_STATE(8558)] = 256223,
  [SMALL_STATE(8559)] = 256272,
  [SMALL_STATE(8560)] = 256319,
  [SMALL_STATE(8561)] = 256366,
  [SMALL_STATE(8562)] = 256415,
  [SMALL_STATE(8563)] = 256464,
  [SMALL_STATE(8564)] = 256513,
  [SMALL_STATE(8565)] = 256559,
  [SMALL_STATE(8566)] = 256605,
  [SMALL_STATE(8567)] = 256651,
  [SMALL_STATE(8568)] = 256697,
  [SMALL_STATE(8569)] = 256743,
  [SMALL_STATE(8570)] = 256789,
  [SMALL_STATE(8571)] = 256825,
  [SMALL_STATE(8572)] = 256871,
  [SMALL_STATE(8573)] = 256907,
  [SMALL_STATE(8574)] = 256943,
  [SMALL_STATE(8575)] = 256979,
  [SMALL_STATE(8576)] = 257025,
  [SMALL_STATE(8577)] = 257061,
  [SMALL_STATE(8578)] = 257097,
  [SMALL_STATE(8579)] = 257143,
  [SMALL_STATE(8580)] = 257179,
  [SMALL_STATE(8581)] = 257217,
  [SMALL_STATE(8582)] = 257253,
  [SMALL_STATE(8583)] = 257299,
  [SMALL_STATE(8584)] = 257335,
  [SMALL_STATE(8585)] = 257371,
  [SMALL_STATE(8586)] = 257407,
  [SMALL_STATE(8587)] = 257443,
  [SMALL_STATE(8588)] = 257489,
  [SMALL_STATE(8589)] = 257535,
  [SMALL_STATE(8590)] = 257581,
  [SMALL_STATE(8591)] = 257617,
  [SMALL_STATE(8592)] = 257663,
  [SMALL_STATE(8593)] = 257709,
  [SMALL_STATE(8594)] = 257755,
  [SMALL_STATE(8595)] = 257791,
  [SMALL_STATE(8596)] = 257837,
  [SMALL_STATE(8597)] = 257883,
  [SMALL_STATE(8598)] = 257929,
  [SMALL_STATE(8599)] = 257975,
  [SMALL_STATE(8600)] = 258021,
  [SMALL_STATE(8601)] = 258067,
  [SMALL_STATE(8602)] = 258113,
  [SMALL_STATE(8603)] = 258159,
  [SMALL_STATE(8604)] = 258202,
  [SMALL_STATE(8605)] = 258245,
  [SMALL_STATE(8606)] = 258286,
  [SMALL_STATE(8607)] = 258329,
  [SMALL_STATE(8608)] = 258372,
  [SMALL_STATE(8609)] = 258415,
  [SMALL_STATE(8610)] = 258458,
  [SMALL_STATE(8611)] = 258501,
  [SMALL_STATE(8612)] = 258544,
  [SMALL_STATE(8613)] = 258587,
  [SMALL_STATE(8614)] = 258630,
  [SMALL_STATE(8615)] = 258671,
  [SMALL_STATE(8616)] = 258714,
  [SMALL_STATE(8617)] = 258757,
  [SMALL_STATE(8618)] = 258800,
  [SMALL_STATE(8619)] = 258843,
  [SMALL_STATE(8620)] = 258886,
  [SMALL_STATE(8621)] = 258929,
  [SMALL_STATE(8622)] = 258970,
  [SMALL_STATE(8623)] = 259013,
  [SMALL_STATE(8624)] = 259056,
  [SMALL_STATE(8625)] = 259099,
  [SMALL_STATE(8626)] = 259142,
  [SMALL_STATE(8627)] = 259183,
  [SMALL_STATE(8628)] = 259226,
  [SMALL_STATE(8629)] = 259269,
  [SMALL_STATE(8630)] = 259312,
  [SMALL_STATE(8631)] = 259355,
  [SMALL_STATE(8632)] = 259396,
  [SMALL_STATE(8633)] = 259439,
  [SMALL_STATE(8634)] = 259482,
  [SMALL_STATE(8635)] = 259525,
  [SMALL_STATE(8636)] = 259568,
  [SMALL_STATE(8637)] = 259611,
  [SMALL_STATE(8638)] = 259654,
  [SMALL_STATE(8639)] = 259697,
  [SMALL_STATE(8640)] = 259740,
  [SMALL_STATE(8641)] = 259783,
  [SMALL_STATE(8642)] = 259826,
  [SMALL_STATE(8643)] = 259869,
  [SMALL_STATE(8644)] = 259912,
  [SMALL_STATE(8645)] = 259955,
  [SMALL_STATE(8646)] = 259998,
  [SMALL_STATE(8647)] = 260041,
  [SMALL_STATE(8648)] = 260084,
  [SMALL_STATE(8649)] = 260127,
  [SMALL_STATE(8650)] = 260168,
  [SMALL_STATE(8651)] = 260211,
  [SMALL_STATE(8652)] = 260254,
  [SMALL_STATE(8653)] = 260297,
  [SMALL_STATE(8654)] = 260340,
  [SMALL_STATE(8655)] = 260381,
  [SMALL_STATE(8656)] = 260424,
  [SMALL_STATE(8657)] = 260465,
  [SMALL_STATE(8658)] = 260508,
  [SMALL_STATE(8659)] = 260549,
  [SMALL_STATE(8660)] = 260592,
  [SMALL_STATE(8661)] = 260635,
  [SMALL_STATE(8662)] = 260676,
  [SMALL_STATE(8663)] = 260719,
  [SMALL_STATE(8664)] = 260762,
  [SMALL_STATE(8665)] = 260803,
  [SMALL_STATE(8666)] = 260844,
  [SMALL_STATE(8667)] = 260887,
  [SMALL_STATE(8668)] = 260930,
  [SMALL_STATE(8669)] = 260971,
  [SMALL_STATE(8670)] = 261014,
  [SMALL_STATE(8671)] = 261057,
  [SMALL_STATE(8672)] = 261100,
  [SMALL_STATE(8673)] = 261143,
  [SMALL_STATE(8674)] = 261186,
  [SMALL_STATE(8675)] = 261229,
  [SMALL_STATE(8676)] = 261272,
  [SMALL_STATE(8677)] = 261315,
  [SMALL_STATE(8678)] = 261358,
  [SMALL_STATE(8679)] = 261399,
  [SMALL_STATE(8680)] = 261440,
  [SMALL_STATE(8681)] = 261483,
  [SMALL_STATE(8682)] = 261526,
  [SMALL_STATE(8683)] = 261569,
  [SMALL_STATE(8684)] = 261606,
  [SMALL_STATE(8685)] = 261649,
  [SMALL_STATE(8686)] = 261692,
  [SMALL_STATE(8687)] = 261735,
  [SMALL_STATE(8688)] = 261778,
  [SMALL_STATE(8689)] = 261815,
  [SMALL_STATE(8690)] = 261858,
  [SMALL_STATE(8691)] = 261899,
  [SMALL_STATE(8692)] = 261942,
  [SMALL_STATE(8693)] = 261983,
  [SMALL_STATE(8694)] = 262026,
  [SMALL_STATE(8695)] = 262069,
  [SMALL_STATE(8696)] = 262112,
  [SMALL_STATE(8697)] = 262155,
  [SMALL_STATE(8698)] = 262198,
  [SMALL_STATE(8699)] = 262239,
  [SMALL_STATE(8700)] = 262282,
  [SMALL_STATE(8701)] = 262323,
  [SMALL_STATE(8702)] = 262366,
  [SMALL_STATE(8703)] = 262409,
  [SMALL_STATE(8704)] = 262452,
  [SMALL_STATE(8705)] = 262495,
  [SMALL_STATE(8706)] = 262538,
  [SMALL_STATE(8707)] = 262581,
  [SMALL_STATE(8708)] = 262624,
  [SMALL_STATE(8709)] = 262667,
  [SMALL_STATE(8710)] = 262708,
  [SMALL_STATE(8711)] = 262751,
  [SMALL_STATE(8712)] = 262794,
  [SMALL_STATE(8713)] = 262837,
  [SMALL_STATE(8714)] = 262880,
  [SMALL_STATE(8715)] = 262923,
  [SMALL_STATE(8716)] = 262966,
  [SMALL_STATE(8717)] = 263007,
  [SMALL_STATE(8718)] = 263050,
  [SMALL_STATE(8719)] = 263091,
  [SMALL_STATE(8720)] = 263134,
  [SMALL_STATE(8721)] = 263177,
  [SMALL_STATE(8722)] = 263218,
  [SMALL_STATE(8723)] = 263259,
  [SMALL_STATE(8724)] = 263302,
  [SMALL_STATE(8725)] = 263343,
  [SMALL_STATE(8726)] = 263386,
  [SMALL_STATE(8727)] = 263429,
  [SMALL_STATE(8728)] = 263470,
  [SMALL_STATE(8729)] = 263513,
  [SMALL_STATE(8730)] = 263556,
  [SMALL_STATE(8731)] = 263599,
  [SMALL_STATE(8732)] = 263642,
  [SMALL_STATE(8733)] = 263685,
  [SMALL_STATE(8734)] = 263728,
  [SMALL_STATE(8735)] = 263771,
  [SMALL_STATE(8736)] = 263814,
  [SMALL_STATE(8737)] = 263857,
  [SMALL_STATE(8738)] = 263900,
  [SMALL_STATE(8739)] = 263943,
  [SMALL_STATE(8740)] = 263984,
  [SMALL_STATE(8741)] = 264027,
  [SMALL_STATE(8742)] = 264068,
  [SMALL_STATE(8743)] = 264111,
  [SMALL_STATE(8744)] = 264152,
  [SMALL_STATE(8745)] = 264193,
  [SMALL_STATE(8746)] = 264236,
  [SMALL_STATE(8747)] = 264279,
  [SMALL_STATE(8748)] = 264322,
  [SMALL_STATE(8749)] = 264363,
  [SMALL_STATE(8750)] = 264406,
  [SMALL_STATE(8751)] = 264447,
  [SMALL_STATE(8752)] = 264490,
  [SMALL_STATE(8753)] = 264533,
  [SMALL_STATE(8754)] = 264576,
  [SMALL_STATE(8755)] = 264619,
  [SMALL_STATE(8756)] = 264662,
  [SMALL_STATE(8757)] = 264705,
  [SMALL_STATE(8758)] = 264748,
  [SMALL_STATE(8759)] = 264789,
  [SMALL_STATE(8760)] = 264832,
  [SMALL_STATE(8761)] = 264875,
  [SMALL_STATE(8762)] = 264918,
  [SMALL_STATE(8763)] = 264961,
  [SMALL_STATE(8764)] = 265004,
  [SMALL_STATE(8765)] = 265047,
  [SMALL_STATE(8766)] = 265090,
  [SMALL_STATE(8767)] = 265133,
  [SMALL_STATE(8768)] = 265176,
  [SMALL_STATE(8769)] = 265219,
  [SMALL_STATE(8770)] = 265262,
  [SMALL_STATE(8771)] = 265305,
  [SMALL_STATE(8772)] = 265348,
  [SMALL_STATE(8773)] = 265391,
  [SMALL_STATE(8774)] = 265434,
  [SMALL_STATE(8775)] = 265477,
  [SMALL_STATE(8776)] = 265520,
  [SMALL_STATE(8777)] = 265561,
  [SMALL_STATE(8778)] = 265602,
  [SMALL_STATE(8779)] = 265645,
  [SMALL_STATE(8780)] = 265688,
  [SMALL_STATE(8781)] = 265731,
  [SMALL_STATE(8782)] = 265772,
  [SMALL_STATE(8783)] = 265815,
  [SMALL_STATE(8784)] = 265856,
  [SMALL_STATE(8785)] = 265897,
  [SMALL_STATE(8786)] = 265940,
  [SMALL_STATE(8787)] = 265981,
  [SMALL_STATE(8788)] = 266024,
  [SMALL_STATE(8789)] = 266065,
  [SMALL_STATE(8790)] = 266108,
  [SMALL_STATE(8791)] = 266151,
  [SMALL_STATE(8792)] = 266194,
  [SMALL_STATE(8793)] = 266235,
  [SMALL_STATE(8794)] = 266278,
  [SMALL_STATE(8795)] = 266321,
  [SMALL_STATE(8796)] = 266364,
  [SMALL_STATE(8797)] = 266405,
  [SMALL_STATE(8798)] = 266448,
  [SMALL_STATE(8799)] = 266489,
  [SMALL_STATE(8800)] = 266532,
  [SMALL_STATE(8801)] = 266575,
  [SMALL_STATE(8802)] = 266615,
  [SMALL_STATE(8803)] = 266655,
  [SMALL_STATE(8804)] = 266689,
  [SMALL_STATE(8805)] = 266729,
  [SMALL_STATE(8806)] = 266769,
  [SMALL_STATE(8807)] = 266807,
  [SMALL_STATE(8808)] = 266847,
  [SMALL_STATE(8809)] = 266887,
  [SMALL_STATE(8810)] = 266925,
  [SMALL_STATE(8811)] = 266965,
  [SMALL_STATE(8812)] = 267003,
  [SMALL_STATE(8813)] = 267043,
  [SMALL_STATE(8814)] = 267083,
  [SMALL_STATE(8815)] = 267117,
  [SMALL_STATE(8816)] = 267151,
  [SMALL_STATE(8817)] = 267191,
  [SMALL_STATE(8818)] = 267231,
  [SMALL_STATE(8819)] = 267271,
  [SMALL_STATE(8820)] = 267311,
  [SMALL_STATE(8821)] = 267351,
  [SMALL_STATE(8822)] = 267391,
  [SMALL_STATE(8823)] = 267425,
  [SMALL_STATE(8824)] = 267465,
  [SMALL_STATE(8825)] = 267505,
  [SMALL_STATE(8826)] = 267539,
  [SMALL_STATE(8827)] = 267573,
  [SMALL_STATE(8828)] = 267607,
  [SMALL_STATE(8829)] = 267647,
  [SMALL_STATE(8830)] = 267681,
  [SMALL_STATE(8831)] = 267715,
  [SMALL_STATE(8832)] = 267755,
  [SMALL_STATE(8833)] = 267789,
  [SMALL_STATE(8834)] = 267823,
  [SMALL_STATE(8835)] = 267863,
  [SMALL_STATE(8836)] = 267903,
  [SMALL_STATE(8837)] = 267937,
  [SMALL_STATE(8838)] = 267971,
  [SMALL_STATE(8839)] = 268011,
  [SMALL_STATE(8840)] = 268051,
  [SMALL_STATE(8841)] = 268085,
  [SMALL_STATE(8842)] = 268119,
  [SMALL_STATE(8843)] = 268159,
  [SMALL_STATE(8844)] = 268199,
  [SMALL_STATE(8845)] = 268233,
  [SMALL_STATE(8846)] = 268267,
  [SMALL_STATE(8847)] = 268307,
  [SMALL_STATE(8848)] = 268341,
  [SMALL_STATE(8849)] = 268381,
  [SMALL_STATE(8850)] = 268421,
  [SMALL_STATE(8851)] = 268455,
  [SMALL_STATE(8852)] = 268489,
  [SMALL_STATE(8853)] = 268529,
  [SMALL_STATE(8854)] = 268569,
  [SMALL_STATE(8855)] = 268603,
  [SMALL_STATE(8856)] = 268641,
  [SMALL_STATE(8857)] = 268681,
  [SMALL_STATE(8858)] = 268721,
  [SMALL_STATE(8859)] = 268761,
  [SMALL_STATE(8860)] = 268801,
  [SMALL_STATE(8861)] = 268841,
  [SMALL_STATE(8862)] = 268875,
  [SMALL_STATE(8863)] = 268915,
  [SMALL_STATE(8864)] = 268949,
  [SMALL_STATE(8865)] = 268983,
  [SMALL_STATE(8866)] = 269023,
  [SMALL_STATE(8867)] = 269063,
  [SMALL_STATE(8868)] = 269101,
  [SMALL_STATE(8869)] = 269141,
  [SMALL_STATE(8870)] = 269175,
  [SMALL_STATE(8871)] = 269209,
  [SMALL_STATE(8872)] = 269249,
  [SMALL_STATE(8873)] = 269289,
  [SMALL_STATE(8874)] = 269323,
  [SMALL_STATE(8875)] = 269363,
  [SMALL_STATE(8876)] = 269397,
  [SMALL_STATE(8877)] = 269437,
  [SMALL_STATE(8878)] = 269471,
  [SMALL_STATE(8879)] = 269505,
  [SMALL_STATE(8880)] = 269539,
  [SMALL_STATE(8881)] = 269579,
  [SMALL_STATE(8882)] = 269619,
  [SMALL_STATE(8883)] = 269659,
  [SMALL_STATE(8884)] = 269693,
  [SMALL_STATE(8885)] = 269731,
  [SMALL_STATE(8886)] = 269771,
  [SMALL_STATE(8887)] = 269807,
  [SMALL_STATE(8888)] = 269841,
  [SMALL_STATE(8889)] = 269875,
  [SMALL_STATE(8890)] = 269915,
  [SMALL_STATE(8891)] = 269953,
  [SMALL_STATE(8892)] = 269987,
  [SMALL_STATE(8893)] = 270027,
  [SMALL_STATE(8894)] = 270065,
  [SMALL_STATE(8895)] = 270099,
  [SMALL_STATE(8896)] = 270139,
  [SMALL_STATE(8897)] = 270179,
  [SMALL_STATE(8898)] = 270219,
  [SMALL_STATE(8899)] = 270259,
  [SMALL_STATE(8900)] = 270293,
  [SMALL_STATE(8901)] = 270333,
  [SMALL_STATE(8902)] = 270371,
  [SMALL_STATE(8903)] = 270411,
  [SMALL_STATE(8904)] = 270451,
  [SMALL_STATE(8905)] = 270491,
  [SMALL_STATE(8906)] = 270531,
  [SMALL_STATE(8907)] = 270571,
  [SMALL_STATE(8908)] = 270605,
  [SMALL_STATE(8909)] = 270645,
  [SMALL_STATE(8910)] = 270683,
  [SMALL_STATE(8911)] = 270721,
  [SMALL_STATE(8912)] = 270757,
  [SMALL_STATE(8913)] = 270797,
  [SMALL_STATE(8914)] = 270837,
  [SMALL_STATE(8915)] = 270871,
  [SMALL_STATE(8916)] = 270911,
  [SMALL_STATE(8917)] = 270945,
  [SMALL_STATE(8918)] = 270985,
  [SMALL_STATE(8919)] = 271025,
  [SMALL_STATE(8920)] = 271065,
  [SMALL_STATE(8921)] = 271105,
  [SMALL_STATE(8922)] = 271145,
  [SMALL_STATE(8923)] = 271179,
  [SMALL_STATE(8924)] = 271219,
  [SMALL_STATE(8925)] = 271253,
  [SMALL_STATE(8926)] = 271293,
  [SMALL_STATE(8927)] = 271333,
  [SMALL_STATE(8928)] = 271367,
  [SMALL_STATE(8929)] = 271401,
  [SMALL_STATE(8930)] = 271441,
  [SMALL_STATE(8931)] = 271481,
  [SMALL_STATE(8932)] = 271518,
  [SMALL_STATE(8933)] = 271555,
  [SMALL_STATE(8934)] = 271592,
  [SMALL_STATE(8935)] = 271629,
  [SMALL_STATE(8936)] = 271664,
  [SMALL_STATE(8937)] = 271701,
  [SMALL_STATE(8938)] = 271736,
  [SMALL_STATE(8939)] = 271773,
  [SMALL_STATE(8940)] = 271808,
  [SMALL_STATE(8941)] = 271841,
  [SMALL_STATE(8942)] = 271874,
  [SMALL_STATE(8943)] = 271911,
  [SMALL_STATE(8944)] = 271944,
  [SMALL_STATE(8945)] = 271981,
  [SMALL_STATE(8946)] = 272014,
  [SMALL_STATE(8947)] = 272049,
  [SMALL_STATE(8948)] = 272086,
  [SMALL_STATE(8949)] = 272123,
  [SMALL_STATE(8950)] = 272160,
  [SMALL_STATE(8951)] = 272197,
  [SMALL_STATE(8952)] = 272234,
  [SMALL_STATE(8953)] = 272271,
  [SMALL_STATE(8954)] = 272308,
  [SMALL_STATE(8955)] = 272345,
  [SMALL_STATE(8956)] = 272382,
  [SMALL_STATE(8957)] = 272419,
  [SMALL_STATE(8958)] = 272456,
  [SMALL_STATE(8959)] = 272493,
  [SMALL_STATE(8960)] = 272530,
  [SMALL_STATE(8961)] = 272567,
  [SMALL_STATE(8962)] = 272604,
  [SMALL_STATE(8963)] = 272641,
  [SMALL_STATE(8964)] = 272678,
  [SMALL_STATE(8965)] = 272715,
  [SMALL_STATE(8966)] = 272752,
  [SMALL_STATE(8967)] = 272785,
  [SMALL_STATE(8968)] = 272818,
  [SMALL_STATE(8969)] = 272851,
  [SMALL_STATE(8970)] = 272888,
  [SMALL_STATE(8971)] = 272923,
  [SMALL_STATE(8972)] = 272960,
  [SMALL_STATE(8973)] = 272997,
  [SMALL_STATE(8974)] = 273034,
  [SMALL_STATE(8975)] = 273071,
  [SMALL_STATE(8976)] = 273104,
  [SMALL_STATE(8977)] = 273137,
  [SMALL_STATE(8978)] = 273174,
  [SMALL_STATE(8979)] = 273209,
  [SMALL_STATE(8980)] = 273246,
  [SMALL_STATE(8981)] = 273283,
  [SMALL_STATE(8982)] = 273318,
  [SMALL_STATE(8983)] = 273355,
  [SMALL_STATE(8984)] = 273392,
  [SMALL_STATE(8985)] = 273429,
  [SMALL_STATE(8986)] = 273464,
  [SMALL_STATE(8987)] = 273497,
  [SMALL_STATE(8988)] = 273534,
  [SMALL_STATE(8989)] = 273567,
  [SMALL_STATE(8990)] = 273600,
  [SMALL_STATE(8991)] = 273633,
  [SMALL_STATE(8992)] = 273666,
  [SMALL_STATE(8993)] = 273703,
  [SMALL_STATE(8994)] = 273736,
  [SMALL_STATE(8995)] = 273773,
  [SMALL_STATE(8996)] = 273810,
  [SMALL_STATE(8997)] = 273847,
  [SMALL_STATE(8998)] = 273880,
  [SMALL_STATE(8999)] = 273915,
  [SMALL_STATE(9000)] = 273952,
  [SMALL_STATE(9001)] = 273989,
  [SMALL_STATE(9002)] = 274026,
  [SMALL_STATE(9003)] = 274063,
  [SMALL_STATE(9004)] = 274100,
  [SMALL_STATE(9005)] = 274137,
  [SMALL_STATE(9006)] = 274174,
  [SMALL_STATE(9007)] = 274211,
  [SMALL_STATE(9008)] = 274248,
  [SMALL_STATE(9009)] = 274285,
  [SMALL_STATE(9010)] = 274322,
  [SMALL_STATE(9011)] = 274359,
  [SMALL_STATE(9012)] = 274392,
  [SMALL_STATE(9013)] = 274425,
  [SMALL_STATE(9014)] = 274462,
  [SMALL_STATE(9015)] = 274499,
  [SMALL_STATE(9016)] = 274532,
  [SMALL_STATE(9017)] = 274565,
  [SMALL_STATE(9018)] = 274602,
  [SMALL_STATE(9019)] = 274637,
  [SMALL_STATE(9020)] = 274674,
  [SMALL_STATE(9021)] = 274709,
  [SMALL_STATE(9022)] = 274742,
  [SMALL_STATE(9023)] = 274779,
  [SMALL_STATE(9024)] = 274812,
  [SMALL_STATE(9025)] = 274849,
  [SMALL_STATE(9026)] = 274886,
  [SMALL_STATE(9027)] = 274923,
  [SMALL_STATE(9028)] = 274956,
  [SMALL_STATE(9029)] = 274989,
  [SMALL_STATE(9030)] = 275026,
  [SMALL_STATE(9031)] = 275063,
  [SMALL_STATE(9032)] = 275100,
  [SMALL_STATE(9033)] = 275137,
  [SMALL_STATE(9034)] = 275174,
  [SMALL_STATE(9035)] = 275211,
  [SMALL_STATE(9036)] = 275244,
  [SMALL_STATE(9037)] = 275277,
  [SMALL_STATE(9038)] = 275312,
  [SMALL_STATE(9039)] = 275345,
  [SMALL_STATE(9040)] = 275378,
  [SMALL_STATE(9041)] = 275415,
  [SMALL_STATE(9042)] = 275452,
  [SMALL_STATE(9043)] = 275489,
  [SMALL_STATE(9044)] = 275526,
  [SMALL_STATE(9045)] = 275563,
  [SMALL_STATE(9046)] = 275600,
  [SMALL_STATE(9047)] = 275637,
  [SMALL_STATE(9048)] = 275674,
  [SMALL_STATE(9049)] = 275711,
  [SMALL_STATE(9050)] = 275746,
  [SMALL_STATE(9051)] = 275779,
  [SMALL_STATE(9052)] = 275814,
  [SMALL_STATE(9053)] = 275851,
  [SMALL_STATE(9054)] = 275888,
  [SMALL_STATE(9055)] = 275925,
  [SMALL_STATE(9056)] = 275962,
  [SMALL_STATE(9057)] = 275997,
  [SMALL_STATE(9058)] = 276034,
  [SMALL_STATE(9059)] = 276067,
  [SMALL_STATE(9060)] = 276104,
  [SMALL_STATE(9061)] = 276139,
  [SMALL_STATE(9062)] = 276174,
  [SMALL_STATE(9063)] = 276209,
  [SMALL_STATE(9064)] = 276246,
  [SMALL_STATE(9065)] = 276281,
  [SMALL_STATE(9066)] = 276318,
  [SMALL_STATE(9067)] = 276353,
  [SMALL_STATE(9068)] = 276388,
  [SMALL_STATE(9069)] = 276425,
  [SMALL_STATE(9070)] = 276460,
  [SMALL_STATE(9071)] = 276497,
  [SMALL_STATE(9072)] = 276534,
  [SMALL_STATE(9073)] = 276569,
  [SMALL_STATE(9074)] = 276606,
  [SMALL_STATE(9075)] = 276641,
  [SMALL_STATE(9076)] = 276676,
  [SMALL_STATE(9077)] = 276713,
  [SMALL_STATE(9078)] = 276750,
  [SMALL_STATE(9079)] = 276785,
  [SMALL_STATE(9080)] = 276822,
  [SMALL_STATE(9081)] = 276857,
  [SMALL_STATE(9082)] = 276894,
  [SMALL_STATE(9083)] = 276931,
  [SMALL_STATE(9084)] = 276968,
  [SMALL_STATE(9085)] = 277005,
  [SMALL_STATE(9086)] = 277042,
  [SMALL_STATE(9087)] = 277077,
  [SMALL_STATE(9088)] = 277114,
  [SMALL_STATE(9089)] = 277151,
  [SMALL_STATE(9090)] = 277188,
  [SMALL_STATE(9091)] = 277225,
  [SMALL_STATE(9092)] = 277260,
  [SMALL_STATE(9093)] = 277295,
  [SMALL_STATE(9094)] = 277330,
  [SMALL_STATE(9095)] = 277367,
  [SMALL_STATE(9096)] = 277404,
  [SMALL_STATE(9097)] = 277441,
  [SMALL_STATE(9098)] = 277478,
  [SMALL_STATE(9099)] = 277513,
  [SMALL_STATE(9100)] = 277550,
  [SMALL_STATE(9101)] = 277587,
  [SMALL_STATE(9102)] = 277622,
  [SMALL_STATE(9103)] = 277659,
  [SMALL_STATE(9104)] = 277696,
  [SMALL_STATE(9105)] = 277733,
  [SMALL_STATE(9106)] = 277770,
  [SMALL_STATE(9107)] = 277807,
  [SMALL_STATE(9108)] = 277842,
  [SMALL_STATE(9109)] = 277877,
  [SMALL_STATE(9110)] = 277914,
  [SMALL_STATE(9111)] = 277951,
  [SMALL_STATE(9112)] = 277988,
  [SMALL_STATE(9113)] = 278025,
  [SMALL_STATE(9114)] = 278062,
  [SMALL_STATE(9115)] = 278099,
  [SMALL_STATE(9116)] = 278134,
  [SMALL_STATE(9117)] = 278171,
  [SMALL_STATE(9118)] = 278208,
  [SMALL_STATE(9119)] = 278245,
  [SMALL_STATE(9120)] = 278282,
  [SMALL_STATE(9121)] = 278317,
  [SMALL_STATE(9122)] = 278354,
  [SMALL_STATE(9123)] = 278391,
  [SMALL_STATE(9124)] = 278428,
  [SMALL_STATE(9125)] = 278463,
  [SMALL_STATE(9126)] = 278500,
  [SMALL_STATE(9127)] = 278535,
  [SMALL_STATE(9128)] = 278570,
  [SMALL_STATE(9129)] = 278603,
  [SMALL_STATE(9130)] = 278640,
  [SMALL_STATE(9131)] = 278677,
  [SMALL_STATE(9132)] = 278714,
  [SMALL_STATE(9133)] = 278751,
  [SMALL_STATE(9134)] = 278786,
  [SMALL_STATE(9135)] = 278823,
  [SMALL_STATE(9136)] = 278860,
  [SMALL_STATE(9137)] = 278897,
  [SMALL_STATE(9138)] = 278934,
  [SMALL_STATE(9139)] = 278971,
  [SMALL_STATE(9140)] = 279008,
  [SMALL_STATE(9141)] = 279043,
  [SMALL_STATE(9142)] = 279080,
  [SMALL_STATE(9143)] = 279117,
  [SMALL_STATE(9144)] = 279154,
  [SMALL_STATE(9145)] = 279191,
  [SMALL_STATE(9146)] = 279228,
  [SMALL_STATE(9147)] = 279261,
  [SMALL_STATE(9148)] = 279296,
  [SMALL_STATE(9149)] = 279331,
  [SMALL_STATE(9150)] = 279368,
  [SMALL_STATE(9151)] = 279405,
  [SMALL_STATE(9152)] = 279440,
  [SMALL_STATE(9153)] = 279477,
  [SMALL_STATE(9154)] = 279514,
  [SMALL_STATE(9155)] = 279551,
  [SMALL_STATE(9156)] = 279588,
  [SMALL_STATE(9157)] = 279625,
  [SMALL_STATE(9158)] = 279662,
  [SMALL_STATE(9159)] = 279697,
  [SMALL_STATE(9160)] = 279734,
  [SMALL_STATE(9161)] = 279771,
  [SMALL_STATE(9162)] = 279806,
  [SMALL_STATE(9163)] = 279843,
  [SMALL_STATE(9164)] = 279878,
  [SMALL_STATE(9165)] = 279915,
  [SMALL_STATE(9166)] = 279952,
  [SMALL_STATE(9167)] = 279989,
  [SMALL_STATE(9168)] = 280026,
  [SMALL_STATE(9169)] = 280063,
  [SMALL_STATE(9170)] = 280100,
  [SMALL_STATE(9171)] = 280137,
  [SMALL_STATE(9172)] = 280174,
  [SMALL_STATE(9173)] = 280209,
  [SMALL_STATE(9174)] = 280244,
  [SMALL_STATE(9175)] = 280281,
  [SMALL_STATE(9176)] = 280318,
  [SMALL_STATE(9177)] = 280355,
  [SMALL_STATE(9178)] = 280392,
  [SMALL_STATE(9179)] = 280429,
  [SMALL_STATE(9180)] = 280466,
  [SMALL_STATE(9181)] = 280503,
  [SMALL_STATE(9182)] = 280540,
  [SMALL_STATE(9183)] = 280577,
  [SMALL_STATE(9184)] = 280614,
  [SMALL_STATE(9185)] = 280649,
  [SMALL_STATE(9186)] = 280684,
  [SMALL_STATE(9187)] = 280721,
  [SMALL_STATE(9188)] = 280758,
  [SMALL_STATE(9189)] = 280795,
  [SMALL_STATE(9190)] = 280830,
  [SMALL_STATE(9191)] = 280867,
  [SMALL_STATE(9192)] = 280904,
  [SMALL_STATE(9193)] = 280941,
  [SMALL_STATE(9194)] = 280976,
  [SMALL_STATE(9195)] = 281013,
  [SMALL_STATE(9196)] = 281048,
  [SMALL_STATE(9197)] = 281083,
  [SMALL_STATE(9198)] = 281120,
  [SMALL_STATE(9199)] = 281155,
  [SMALL_STATE(9200)] = 281192,
  [SMALL_STATE(9201)] = 281229,
  [SMALL_STATE(9202)] = 281266,
  [SMALL_STATE(9203)] = 281303,
  [SMALL_STATE(9204)] = 281340,
  [SMALL_STATE(9205)] = 281377,
  [SMALL_STATE(9206)] = 281414,
  [SMALL_STATE(9207)] = 281451,
  [SMALL_STATE(9208)] = 281488,
  [SMALL_STATE(9209)] = 281525,
  [SMALL_STATE(9210)] = 281562,
  [SMALL_STATE(9211)] = 281599,
  [SMALL_STATE(9212)] = 281636,
  [SMALL_STATE(9213)] = 281673,
  [SMALL_STATE(9214)] = 281710,
  [SMALL_STATE(9215)] = 281745,
  [SMALL_STATE(9216)] = 281782,
  [SMALL_STATE(9217)] = 281819,
  [SMALL_STATE(9218)] = 281856,
  [SMALL_STATE(9219)] = 281893,
  [SMALL_STATE(9220)] = 281930,
  [SMALL_STATE(9221)] = 281967,
  [SMALL_STATE(9222)] = 282004,
  [SMALL_STATE(9223)] = 282041,
  [SMALL_STATE(9224)] = 282078,
  [SMALL_STATE(9225)] = 282115,
  [SMALL_STATE(9226)] = 282152,
  [SMALL_STATE(9227)] = 282187,
  [SMALL_STATE(9228)] = 282224,
  [SMALL_STATE(9229)] = 282261,
  [SMALL_STATE(9230)] = 282298,
  [SMALL_STATE(9231)] = 282335,
  [SMALL_STATE(9232)] = 282370,
  [SMALL_STATE(9233)] = 282405,
  [SMALL_STATE(9234)] = 282440,
  [SMALL_STATE(9235)] = 282477,
  [SMALL_STATE(9236)] = 282514,
  [SMALL_STATE(9237)] = 282551,
  [SMALL_STATE(9238)] = 282588,
  [SMALL_STATE(9239)] = 282625,
  [SMALL_STATE(9240)] = 282660,
  [SMALL_STATE(9241)] = 282697,
  [SMALL_STATE(9242)] = 282734,
  [SMALL_STATE(9243)] = 282769,
  [SMALL_STATE(9244)] = 282806,
  [SMALL_STATE(9245)] = 282843,
  [SMALL_STATE(9246)] = 282880,
  [SMALL_STATE(9247)] = 282917,
  [SMALL_STATE(9248)] = 282954,
  [SMALL_STATE(9249)] = 282991,
  [SMALL_STATE(9250)] = 283026,
  [SMALL_STATE(9251)] = 283063,
  [SMALL_STATE(9252)] = 283100,
  [SMALL_STATE(9253)] = 283137,
  [SMALL_STATE(9254)] = 283174,
  [SMALL_STATE(9255)] = 283211,
  [SMALL_STATE(9256)] = 283248,
  [SMALL_STATE(9257)] = 283283,
  [SMALL_STATE(9258)] = 283320,
  [SMALL_STATE(9259)] = 283355,
  [SMALL_STATE(9260)] = 283392,
  [SMALL_STATE(9261)] = 283429,
  [SMALL_STATE(9262)] = 283466,
  [SMALL_STATE(9263)] = 283503,
  [SMALL_STATE(9264)] = 283538,
  [SMALL_STATE(9265)] = 283575,
  [SMALL_STATE(9266)] = 283610,
  [SMALL_STATE(9267)] = 283647,
  [SMALL_STATE(9268)] = 283684,
  [SMALL_STATE(9269)] = 283721,
  [SMALL_STATE(9270)] = 283756,
  [SMALL_STATE(9271)] = 283793,
  [SMALL_STATE(9272)] = 283830,
  [SMALL_STATE(9273)] = 283867,
  [SMALL_STATE(9274)] = 283902,
  [SMALL_STATE(9275)] = 283939,
  [SMALL_STATE(9276)] = 283976,
  [SMALL_STATE(9277)] = 284011,
  [SMALL_STATE(9278)] = 284048,
  [SMALL_STATE(9279)] = 284085,
  [SMALL_STATE(9280)] = 284120,
  [SMALL_STATE(9281)] = 284157,
  [SMALL_STATE(9282)] = 284192,
  [SMALL_STATE(9283)] = 284227,
  [SMALL_STATE(9284)] = 284264,
  [SMALL_STATE(9285)] = 284299,
  [SMALL_STATE(9286)] = 284336,
  [SMALL_STATE(9287)] = 284373,
  [SMALL_STATE(9288)] = 284410,
  [SMALL_STATE(9289)] = 284447,
  [SMALL_STATE(9290)] = 284484,
  [SMALL_STATE(9291)] = 284521,
  [SMALL_STATE(9292)] = 284558,
  [SMALL_STATE(9293)] = 284595,
  [SMALL_STATE(9294)] = 284630,
  [SMALL_STATE(9295)] = 284667,
  [SMALL_STATE(9296)] = 284704,
  [SMALL_STATE(9297)] = 284739,
  [SMALL_STATE(9298)] = 284776,
  [SMALL_STATE(9299)] = 284811,
  [SMALL_STATE(9300)] = 284848,
  [SMALL_STATE(9301)] = 284885,
  [SMALL_STATE(9302)] = 284922,
  [SMALL_STATE(9303)] = 284959,
  [SMALL_STATE(9304)] = 284996,
  [SMALL_STATE(9305)] = 285031,
  [SMALL_STATE(9306)] = 285066,
  [SMALL_STATE(9307)] = 285103,
  [SMALL_STATE(9308)] = 285140,
  [SMALL_STATE(9309)] = 285177,
  [SMALL_STATE(9310)] = 285214,
  [SMALL_STATE(9311)] = 285251,
  [SMALL_STATE(9312)] = 285286,
  [SMALL_STATE(9313)] = 285323,
  [SMALL_STATE(9314)] = 285358,
  [SMALL_STATE(9315)] = 285395,
  [SMALL_STATE(9316)] = 285430,
  [SMALL_STATE(9317)] = 285467,
  [SMALL_STATE(9318)] = 285504,
  [SMALL_STATE(9319)] = 285541,
  [SMALL_STATE(9320)] = 285578,
  [SMALL_STATE(9321)] = 285613,
  [SMALL_STATE(9322)] = 285650,
  [SMALL_STATE(9323)] = 285687,
  [SMALL_STATE(9324)] = 285724,
  [SMALL_STATE(9325)] = 285761,
  [SMALL_STATE(9326)] = 285798,
  [SMALL_STATE(9327)] = 285833,
  [SMALL_STATE(9328)] = 285870,
  [SMALL_STATE(9329)] = 285905,
  [SMALL_STATE(9330)] = 285942,
  [SMALL_STATE(9331)] = 285979,
  [SMALL_STATE(9332)] = 286016,
  [SMALL_STATE(9333)] = 286053,
  [SMALL_STATE(9334)] = 286090,
  [SMALL_STATE(9335)] = 286127,
  [SMALL_STATE(9336)] = 286164,
  [SMALL_STATE(9337)] = 286199,
  [SMALL_STATE(9338)] = 286236,
  [SMALL_STATE(9339)] = 286271,
  [SMALL_STATE(9340)] = 286308,
  [SMALL_STATE(9341)] = 286345,
  [SMALL_STATE(9342)] = 286382,
  [SMALL_STATE(9343)] = 286419,
  [SMALL_STATE(9344)] = 286454,
  [SMALL_STATE(9345)] = 286491,
  [SMALL_STATE(9346)] = 286528,
  [SMALL_STATE(9347)] = 286565,
  [SMALL_STATE(9348)] = 286602,
  [SMALL_STATE(9349)] = 286637,
  [SMALL_STATE(9350)] = 286674,
  [SMALL_STATE(9351)] = 286711,
  [SMALL_STATE(9352)] = 286748,
  [SMALL_STATE(9353)] = 286785,
  [SMALL_STATE(9354)] = 286822,
  [SMALL_STATE(9355)] = 286857,
  [SMALL_STATE(9356)] = 286894,
  [SMALL_STATE(9357)] = 286931,
  [SMALL_STATE(9358)] = 286966,
  [SMALL_STATE(9359)] = 287003,
  [SMALL_STATE(9360)] = 287040,
  [SMALL_STATE(9361)] = 287073,
  [SMALL_STATE(9362)] = 287110,
  [SMALL_STATE(9363)] = 287147,
  [SMALL_STATE(9364)] = 287184,
  [SMALL_STATE(9365)] = 287219,
  [SMALL_STATE(9366)] = 287256,
  [SMALL_STATE(9367)] = 287293,
  [SMALL_STATE(9368)] = 287328,
  [SMALL_STATE(9369)] = 287365,
  [SMALL_STATE(9370)] = 287400,
  [SMALL_STATE(9371)] = 287437,
  [SMALL_STATE(9372)] = 287474,
  [SMALL_STATE(9373)] = 287511,
  [SMALL_STATE(9374)] = 287546,
  [SMALL_STATE(9375)] = 287583,
  [SMALL_STATE(9376)] = 287620,
  [SMALL_STATE(9377)] = 287657,
  [SMALL_STATE(9378)] = 287691,
  [SMALL_STATE(9379)] = 287723,
  [SMALL_STATE(9380)] = 287757,
  [SMALL_STATE(9381)] = 287791,
  [SMALL_STATE(9382)] = 287825,
  [SMALL_STATE(9383)] = 287859,
  [SMALL_STATE(9384)] = 287893,
  [SMALL_STATE(9385)] = 287927,
  [SMALL_STATE(9386)] = 287961,
  [SMALL_STATE(9387)] = 287995,
  [SMALL_STATE(9388)] = 288029,
  [SMALL_STATE(9389)] = 288063,
  [SMALL_STATE(9390)] = 288097,
  [SMALL_STATE(9391)] = 288131,
  [SMALL_STATE(9392)] = 288165,
  [SMALL_STATE(9393)] = 288199,
  [SMALL_STATE(9394)] = 288233,
  [SMALL_STATE(9395)] = 288267,
  [SMALL_STATE(9396)] = 288299,
  [SMALL_STATE(9397)] = 288333,
  [SMALL_STATE(9398)] = 288367,
  [SMALL_STATE(9399)] = 288401,
  [SMALL_STATE(9400)] = 288435,
  [SMALL_STATE(9401)] = 288469,
  [SMALL_STATE(9402)] = 288503,
  [SMALL_STATE(9403)] = 288537,
  [SMALL_STATE(9404)] = 288571,
  [SMALL_STATE(9405)] = 288605,
  [SMALL_STATE(9406)] = 288639,
  [SMALL_STATE(9407)] = 288673,
  [SMALL_STATE(9408)] = 288707,
  [SMALL_STATE(9409)] = 288741,
  [SMALL_STATE(9410)] = 288775,
  [SMALL_STATE(9411)] = 288809,
  [SMALL_STATE(9412)] = 288843,
  [SMALL_STATE(9413)] = 288877,
  [SMALL_STATE(9414)] = 288911,
  [SMALL_STATE(9415)] = 288945,
  [SMALL_STATE(9416)] = 288979,
  [SMALL_STATE(9417)] = 289013,
  [SMALL_STATE(9418)] = 289047,
  [SMALL_STATE(9419)] = 289081,
  [SMALL_STATE(9420)] = 289115,
  [SMALL_STATE(9421)] = 289149,
  [SMALL_STATE(9422)] = 289183,
  [SMALL_STATE(9423)] = 289217,
  [SMALL_STATE(9424)] = 289251,
  [SMALL_STATE(9425)] = 289285,
  [SMALL_STATE(9426)] = 289319,
  [SMALL_STATE(9427)] = 289353,
  [SMALL_STATE(9428)] = 289387,
  [SMALL_STATE(9429)] = 289421,
  [SMALL_STATE(9430)] = 289455,
  [SMALL_STATE(9431)] = 289489,
  [SMALL_STATE(9432)] = 289523,
  [SMALL_STATE(9433)] = 289557,
  [SMALL_STATE(9434)] = 289591,
  [SMALL_STATE(9435)] = 289625,
  [SMALL_STATE(9436)] = 289659,
  [SMALL_STATE(9437)] = 289691,
  [SMALL_STATE(9438)] = 289725,
  [SMALL_STATE(9439)] = 289759,
  [SMALL_STATE(9440)] = 289793,
  [SMALL_STATE(9441)] = 289827,
  [SMALL_STATE(9442)] = 289861,
  [SMALL_STATE(9443)] = 289895,
  [SMALL_STATE(9444)] = 289929,
  [SMALL_STATE(9445)] = 289963,
  [SMALL_STATE(9446)] = 289997,
  [SMALL_STATE(9447)] = 290031,
  [SMALL_STATE(9448)] = 290065,
  [SMALL_STATE(9449)] = 290099,
  [SMALL_STATE(9450)] = 290133,
  [SMALL_STATE(9451)] = 290167,
  [SMALL_STATE(9452)] = 290201,
  [SMALL_STATE(9453)] = 290235,
  [SMALL_STATE(9454)] = 290269,
  [SMALL_STATE(9455)] = 290303,
  [SMALL_STATE(9456)] = 290337,
  [SMALL_STATE(9457)] = 290371,
  [SMALL_STATE(9458)] = 290405,
  [SMALL_STATE(9459)] = 290439,
  [SMALL_STATE(9460)] = 290473,
  [SMALL_STATE(9461)] = 290507,
  [SMALL_STATE(9462)] = 290541,
  [SMALL_STATE(9463)] = 290575,
  [SMALL_STATE(9464)] = 290609,
  [SMALL_STATE(9465)] = 290643,
  [SMALL_STATE(9466)] = 290677,
  [SMALL_STATE(9467)] = 290711,
  [SMALL_STATE(9468)] = 290745,
  [SMALL_STATE(9469)] = 290779,
  [SMALL_STATE(9470)] = 290813,
  [SMALL_STATE(9471)] = 290847,
  [SMALL_STATE(9472)] = 290881,
  [SMALL_STATE(9473)] = 290915,
  [SMALL_STATE(9474)] = 290949,
  [SMALL_STATE(9475)] = 290983,
  [SMALL_STATE(9476)] = 291017,
  [SMALL_STATE(9477)] = 291049,
  [SMALL_STATE(9478)] = 291083,
  [SMALL_STATE(9479)] = 291117,
  [SMALL_STATE(9480)] = 291151,
  [SMALL_STATE(9481)] = 291185,
  [SMALL_STATE(9482)] = 291219,
  [SMALL_STATE(9483)] = 291253,
  [SMALL_STATE(9484)] = 291285,
  [SMALL_STATE(9485)] = 291319,
  [SMALL_STATE(9486)] = 291353,
  [SMALL_STATE(9487)] = 291387,
  [SMALL_STATE(9488)] = 291421,
  [SMALL_STATE(9489)] = 291455,
  [SMALL_STATE(9490)] = 291489,
  [SMALL_STATE(9491)] = 291523,
  [SMALL_STATE(9492)] = 291555,
  [SMALL_STATE(9493)] = 291589,
  [SMALL_STATE(9494)] = 291623,
  [SMALL_STATE(9495)] = 291657,
  [SMALL_STATE(9496)] = 291691,
  [SMALL_STATE(9497)] = 291725,
  [SMALL_STATE(9498)] = 291759,
  [SMALL_STATE(9499)] = 291793,
  [SMALL_STATE(9500)] = 291827,
  [SMALL_STATE(9501)] = 291861,
  [SMALL_STATE(9502)] = 291895,
  [SMALL_STATE(9503)] = 291929,
  [SMALL_STATE(9504)] = 291963,
  [SMALL_STATE(9505)] = 291995,
  [SMALL_STATE(9506)] = 292029,
  [SMALL_STATE(9507)] = 292063,
  [SMALL_STATE(9508)] = 292097,
  [SMALL_STATE(9509)] = 292131,
  [SMALL_STATE(9510)] = 292165,
  [SMALL_STATE(9511)] = 292199,
  [SMALL_STATE(9512)] = 292233,
  [SMALL_STATE(9513)] = 292267,
  [SMALL_STATE(9514)] = 292301,
  [SMALL_STATE(9515)] = 292335,
  [SMALL_STATE(9516)] = 292369,
  [SMALL_STATE(9517)] = 292403,
  [SMALL_STATE(9518)] = 292437,
  [SMALL_STATE(9519)] = 292469,
  [SMALL_STATE(9520)] = 292503,
  [SMALL_STATE(9521)] = 292537,
  [SMALL_STATE(9522)] = 292569,
  [SMALL_STATE(9523)] = 292603,
  [SMALL_STATE(9524)] = 292637,
  [SMALL_STATE(9525)] = 292671,
  [SMALL_STATE(9526)] = 292705,
  [SMALL_STATE(9527)] = 292739,
  [SMALL_STATE(9528)] = 292771,
  [SMALL_STATE(9529)] = 292805,
  [SMALL_STATE(9530)] = 292839,
  [SMALL_STATE(9531)] = 292873,
  [SMALL_STATE(9532)] = 292907,
  [SMALL_STATE(9533)] = 292941,
  [SMALL_STATE(9534)] = 292975,
  [SMALL_STATE(9535)] = 293009,
  [SMALL_STATE(9536)] = 293043,
  [SMALL_STATE(9537)] = 293077,
  [SMALL_STATE(9538)] = 293111,
  [SMALL_STATE(9539)] = 293145,
  [SMALL_STATE(9540)] = 293179,
  [SMALL_STATE(9541)] = 293213,
  [SMALL_STATE(9542)] = 293247,
  [SMALL_STATE(9543)] = 293279,
  [SMALL_STATE(9544)] = 293313,
  [SMALL_STATE(9545)] = 293347,
  [SMALL_STATE(9546)] = 293381,
  [SMALL_STATE(9547)] = 293413,
  [SMALL_STATE(9548)] = 293445,
  [SMALL_STATE(9549)] = 293477,
  [SMALL_STATE(9550)] = 293511,
  [SMALL_STATE(9551)] = 293545,
  [SMALL_STATE(9552)] = 293579,
  [SMALL_STATE(9553)] = 293613,
  [SMALL_STATE(9554)] = 293647,
  [SMALL_STATE(9555)] = 293681,
  [SMALL_STATE(9556)] = 293715,
  [SMALL_STATE(9557)] = 293749,
  [SMALL_STATE(9558)] = 293783,
  [SMALL_STATE(9559)] = 293817,
  [SMALL_STATE(9560)] = 293851,
  [SMALL_STATE(9561)] = 293885,
  [SMALL_STATE(9562)] = 293919,
  [SMALL_STATE(9563)] = 293953,
  [SMALL_STATE(9564)] = 293987,
  [SMALL_STATE(9565)] = 294021,
  [SMALL_STATE(9566)] = 294055,
  [SMALL_STATE(9567)] = 294089,
  [SMALL_STATE(9568)] = 294123,
  [SMALL_STATE(9569)] = 294157,
  [SMALL_STATE(9570)] = 294191,
  [SMALL_STATE(9571)] = 294225,
  [SMALL_STATE(9572)] = 294259,
  [SMALL_STATE(9573)] = 294293,
  [SMALL_STATE(9574)] = 294327,
  [SMALL_STATE(9575)] = 294361,
  [SMALL_STATE(9576)] = 294395,
  [SMALL_STATE(9577)] = 294429,
  [SMALL_STATE(9578)] = 294463,
  [SMALL_STATE(9579)] = 294497,
  [SMALL_STATE(9580)] = 294531,
  [SMALL_STATE(9581)] = 294565,
  [SMALL_STATE(9582)] = 294599,
  [SMALL_STATE(9583)] = 294633,
  [SMALL_STATE(9584)] = 294667,
  [SMALL_STATE(9585)] = 294701,
  [SMALL_STATE(9586)] = 294735,
  [SMALL_STATE(9587)] = 294769,
  [SMALL_STATE(9588)] = 294803,
  [SMALL_STATE(9589)] = 294837,
  [SMALL_STATE(9590)] = 294871,
  [SMALL_STATE(9591)] = 294905,
  [SMALL_STATE(9592)] = 294939,
  [SMALL_STATE(9593)] = 294973,
  [SMALL_STATE(9594)] = 295007,
  [SMALL_STATE(9595)] = 295041,
  [SMALL_STATE(9596)] = 295075,
  [SMALL_STATE(9597)] = 295109,
  [SMALL_STATE(9598)] = 295143,
  [SMALL_STATE(9599)] = 295177,
  [SMALL_STATE(9600)] = 295211,
  [SMALL_STATE(9601)] = 295245,
  [SMALL_STATE(9602)] = 295279,
  [SMALL_STATE(9603)] = 295313,
  [SMALL_STATE(9604)] = 295347,
  [SMALL_STATE(9605)] = 295381,
  [SMALL_STATE(9606)] = 295413,
  [SMALL_STATE(9607)] = 295447,
  [SMALL_STATE(9608)] = 295481,
  [SMALL_STATE(9609)] = 295515,
  [SMALL_STATE(9610)] = 295549,
  [SMALL_STATE(9611)] = 295583,
  [SMALL_STATE(9612)] = 295617,
  [SMALL_STATE(9613)] = 295651,
  [SMALL_STATE(9614)] = 295685,
  [SMALL_STATE(9615)] = 295719,
  [SMALL_STATE(9616)] = 295753,
  [SMALL_STATE(9617)] = 295787,
  [SMALL_STATE(9618)] = 295821,
  [SMALL_STATE(9619)] = 295855,
  [SMALL_STATE(9620)] = 295889,
  [SMALL_STATE(9621)] = 295923,
  [SMALL_STATE(9622)] = 295957,
  [SMALL_STATE(9623)] = 295991,
  [SMALL_STATE(9624)] = 296025,
  [SMALL_STATE(9625)] = 296059,
  [SMALL_STATE(9626)] = 296093,
  [SMALL_STATE(9627)] = 296127,
  [SMALL_STATE(9628)] = 296161,
  [SMALL_STATE(9629)] = 296195,
  [SMALL_STATE(9630)] = 296229,
  [SMALL_STATE(9631)] = 296263,
  [SMALL_STATE(9632)] = 296297,
  [SMALL_STATE(9633)] = 296331,
  [SMALL_STATE(9634)] = 296365,
  [SMALL_STATE(9635)] = 296399,
  [SMALL_STATE(9636)] = 296433,
  [SMALL_STATE(9637)] = 296467,
  [SMALL_STATE(9638)] = 296501,
  [SMALL_STATE(9639)] = 296535,
  [SMALL_STATE(9640)] = 296569,
  [SMALL_STATE(9641)] = 296603,
  [SMALL_STATE(9642)] = 296637,
  [SMALL_STATE(9643)] = 296671,
  [SMALL_STATE(9644)] = 296703,
  [SMALL_STATE(9645)] = 296735,
  [SMALL_STATE(9646)] = 296769,
  [SMALL_STATE(9647)] = 296803,
  [SMALL_STATE(9648)] = 296837,
  [SMALL_STATE(9649)] = 296871,
  [SMALL_STATE(9650)] = 296905,
  [SMALL_STATE(9651)] = 296939,
  [SMALL_STATE(9652)] = 296973,
  [SMALL_STATE(9653)] = 297007,
  [SMALL_STATE(9654)] = 297041,
  [SMALL_STATE(9655)] = 297075,
  [SMALL_STATE(9656)] = 297109,
  [SMALL_STATE(9657)] = 297143,
  [SMALL_STATE(9658)] = 297177,
  [SMALL_STATE(9659)] = 297211,
  [SMALL_STATE(9660)] = 297245,
  [SMALL_STATE(9661)] = 297279,
  [SMALL_STATE(9662)] = 297313,
  [SMALL_STATE(9663)] = 297347,
  [SMALL_STATE(9664)] = 297381,
  [SMALL_STATE(9665)] = 297415,
  [SMALL_STATE(9666)] = 297449,
  [SMALL_STATE(9667)] = 297483,
  [SMALL_STATE(9668)] = 297517,
  [SMALL_STATE(9669)] = 297551,
  [SMALL_STATE(9670)] = 297585,
  [SMALL_STATE(9671)] = 297617,
  [SMALL_STATE(9672)] = 297651,
  [SMALL_STATE(9673)] = 297683,
  [SMALL_STATE(9674)] = 297717,
  [SMALL_STATE(9675)] = 297751,
  [SMALL_STATE(9676)] = 297785,
  [SMALL_STATE(9677)] = 297819,
  [SMALL_STATE(9678)] = 297851,
  [SMALL_STATE(9679)] = 297885,
  [SMALL_STATE(9680)] = 297919,
  [SMALL_STATE(9681)] = 297953,
  [SMALL_STATE(9682)] = 297987,
  [SMALL_STATE(9683)] = 298021,
  [SMALL_STATE(9684)] = 298055,
  [SMALL_STATE(9685)] = 298089,
  [SMALL_STATE(9686)] = 298123,
  [SMALL_STATE(9687)] = 298157,
  [SMALL_STATE(9688)] = 298191,
  [SMALL_STATE(9689)] = 298225,
  [SMALL_STATE(9690)] = 298259,
  [SMALL_STATE(9691)] = 298293,
  [SMALL_STATE(9692)] = 298327,
  [SMALL_STATE(9693)] = 298361,
  [SMALL_STATE(9694)] = 298395,
  [SMALL_STATE(9695)] = 298429,
  [SMALL_STATE(9696)] = 298463,
  [SMALL_STATE(9697)] = 298497,
  [SMALL_STATE(9698)] = 298531,
  [SMALL_STATE(9699)] = 298565,
  [SMALL_STATE(9700)] = 298597,
  [SMALL_STATE(9701)] = 298631,
  [SMALL_STATE(9702)] = 298665,
  [SMALL_STATE(9703)] = 298699,
  [SMALL_STATE(9704)] = 298733,
  [SMALL_STATE(9705)] = 298767,
  [SMALL_STATE(9706)] = 298801,
  [SMALL_STATE(9707)] = 298833,
  [SMALL_STATE(9708)] = 298865,
  [SMALL_STATE(9709)] = 298899,
  [SMALL_STATE(9710)] = 298933,
  [SMALL_STATE(9711)] = 298967,
  [SMALL_STATE(9712)] = 298999,
  [SMALL_STATE(9713)] = 299031,
  [SMALL_STATE(9714)] = 299063,
  [SMALL_STATE(9715)] = 299097,
  [SMALL_STATE(9716)] = 299131,
  [SMALL_STATE(9717)] = 299163,
  [SMALL_STATE(9718)] = 299197,
  [SMALL_STATE(9719)] = 299231,
  [SMALL_STATE(9720)] = 299265,
  [SMALL_STATE(9721)] = 299297,
  [SMALL_STATE(9722)] = 299331,
  [SMALL_STATE(9723)] = 299365,
  [SMALL_STATE(9724)] = 299399,
  [SMALL_STATE(9725)] = 299431,
  [SMALL_STATE(9726)] = 299465,
  [SMALL_STATE(9727)] = 299497,
  [SMALL_STATE(9728)] = 299531,
  [SMALL_STATE(9729)] = 299565,
  [SMALL_STATE(9730)] = 299599,
  [SMALL_STATE(9731)] = 299633,
  [SMALL_STATE(9732)] = 299667,
  [SMALL_STATE(9733)] = 299701,
  [SMALL_STATE(9734)] = 299735,
  [SMALL_STATE(9735)] = 299769,
  [SMALL_STATE(9736)] = 299803,
  [SMALL_STATE(9737)] = 299837,
  [SMALL_STATE(9738)] = 299871,
  [SMALL_STATE(9739)] = 299905,
  [SMALL_STATE(9740)] = 299939,
  [SMALL_STATE(9741)] = 299971,
  [SMALL_STATE(9742)] = 300005,
  [SMALL_STATE(9743)] = 300039,
  [SMALL_STATE(9744)] = 300073,
  [SMALL_STATE(9745)] = 300107,
  [SMALL_STATE(9746)] = 300141,
  [SMALL_STATE(9747)] = 300175,
  [SMALL_STATE(9748)] = 300209,
  [SMALL_STATE(9749)] = 300243,
  [SMALL_STATE(9750)] = 300277,
  [SMALL_STATE(9751)] = 300311,
  [SMALL_STATE(9752)] = 300345,
  [SMALL_STATE(9753)] = 300379,
  [SMALL_STATE(9754)] = 300413,
  [SMALL_STATE(9755)] = 300447,
  [SMALL_STATE(9756)] = 300481,
  [SMALL_STATE(9757)] = 300515,
  [SMALL_STATE(9758)] = 300549,
  [SMALL_STATE(9759)] = 300583,
  [SMALL_STATE(9760)] = 300617,
  [SMALL_STATE(9761)] = 300651,
  [SMALL_STATE(9762)] = 300685,
  [SMALL_STATE(9763)] = 300719,
  [SMALL_STATE(9764)] = 300753,
  [SMALL_STATE(9765)] = 300787,
  [SMALL_STATE(9766)] = 300821,
  [SMALL_STATE(9767)] = 300855,
  [SMALL_STATE(9768)] = 300889,
  [SMALL_STATE(9769)] = 300923,
  [SMALL_STATE(9770)] = 300957,
  [SMALL_STATE(9771)] = 300991,
  [SMALL_STATE(9772)] = 301025,
  [SMALL_STATE(9773)] = 301059,
  [SMALL_STATE(9774)] = 301093,
  [SMALL_STATE(9775)] = 301127,
  [SMALL_STATE(9776)] = 301161,
  [SMALL_STATE(9777)] = 301195,
  [SMALL_STATE(9778)] = 301229,
  [SMALL_STATE(9779)] = 301263,
  [SMALL_STATE(9780)] = 301297,
  [SMALL_STATE(9781)] = 301331,
  [SMALL_STATE(9782)] = 301365,
  [SMALL_STATE(9783)] = 301399,
  [SMALL_STATE(9784)] = 301433,
  [SMALL_STATE(9785)] = 301467,
  [SMALL_STATE(9786)] = 301501,
  [SMALL_STATE(9787)] = 301535,
  [SMALL_STATE(9788)] = 301569,
  [SMALL_STATE(9789)] = 301601,
  [SMALL_STATE(9790)] = 301635,
  [SMALL_STATE(9791)] = 301669,
  [SMALL_STATE(9792)] = 301703,
  [SMALL_STATE(9793)] = 301737,
  [SMALL_STATE(9794)] = 301771,
  [SMALL_STATE(9795)] = 301805,
  [SMALL_STATE(9796)] = 301839,
  [SMALL_STATE(9797)] = 301873,
  [SMALL_STATE(9798)] = 301907,
  [SMALL_STATE(9799)] = 301941,
  [SMALL_STATE(9800)] = 301973,
  [SMALL_STATE(9801)] = 302005,
  [SMALL_STATE(9802)] = 302037,
  [SMALL_STATE(9803)] = 302069,
  [SMALL_STATE(9804)] = 302103,
  [SMALL_STATE(9805)] = 302137,
  [SMALL_STATE(9806)] = 302171,
  [SMALL_STATE(9807)] = 302205,
  [SMALL_STATE(9808)] = 302239,
  [SMALL_STATE(9809)] = 302273,
  [SMALL_STATE(9810)] = 302307,
  [SMALL_STATE(9811)] = 302341,
  [SMALL_STATE(9812)] = 302373,
  [SMALL_STATE(9813)] = 302407,
  [SMALL_STATE(9814)] = 302441,
  [SMALL_STATE(9815)] = 302475,
  [SMALL_STATE(9816)] = 302509,
  [SMALL_STATE(9817)] = 302543,
  [SMALL_STATE(9818)] = 302577,
  [SMALL_STATE(9819)] = 302611,
  [SMALL_STATE(9820)] = 302645,
  [SMALL_STATE(9821)] = 302679,
  [SMALL_STATE(9822)] = 302713,
  [SMALL_STATE(9823)] = 302747,
  [SMALL_STATE(9824)] = 302781,
  [SMALL_STATE(9825)] = 302815,
  [SMALL_STATE(9826)] = 302849,
  [SMALL_STATE(9827)] = 302883,
  [SMALL_STATE(9828)] = 302915,
  [SMALL_STATE(9829)] = 302949,
  [SMALL_STATE(9830)] = 302983,
  [SMALL_STATE(9831)] = 303017,
  [SMALL_STATE(9832)] = 303051,
  [SMALL_STATE(9833)] = 303085,
  [SMALL_STATE(9834)] = 303119,
  [SMALL_STATE(9835)] = 303151,
  [SMALL_STATE(9836)] = 303185,
  [SMALL_STATE(9837)] = 303219,
  [SMALL_STATE(9838)] = 303253,
  [SMALL_STATE(9839)] = 303287,
  [SMALL_STATE(9840)] = 303321,
  [SMALL_STATE(9841)] = 303355,
  [SMALL_STATE(9842)] = 303389,
  [SMALL_STATE(9843)] = 303423,
  [SMALL_STATE(9844)] = 303457,
  [SMALL_STATE(9845)] = 303489,
  [SMALL_STATE(9846)] = 303523,
  [SMALL_STATE(9847)] = 303557,
  [SMALL_STATE(9848)] = 303591,
  [SMALL_STATE(9849)] = 303625,
  [SMALL_STATE(9850)] = 303657,
  [SMALL_STATE(9851)] = 303691,
  [SMALL_STATE(9852)] = 303725,
  [SMALL_STATE(9853)] = 303759,
  [SMALL_STATE(9854)] = 303793,
  [SMALL_STATE(9855)] = 303827,
  [SMALL_STATE(9856)] = 303859,
  [SMALL_STATE(9857)] = 303893,
  [SMALL_STATE(9858)] = 303925,
  [SMALL_STATE(9859)] = 303959,
  [SMALL_STATE(9860)] = 303993,
  [SMALL_STATE(9861)] = 304027,
  [SMALL_STATE(9862)] = 304061,
  [SMALL_STATE(9863)] = 304093,
  [SMALL_STATE(9864)] = 304125,
  [SMALL_STATE(9865)] = 304159,
  [SMALL_STATE(9866)] = 304193,
  [SMALL_STATE(9867)] = 304227,
  [SMALL_STATE(9868)] = 304261,
  [SMALL_STATE(9869)] = 304295,
  [SMALL_STATE(9870)] = 304329,
  [SMALL_STATE(9871)] = 304363,
  [SMALL_STATE(9872)] = 304397,
  [SMALL_STATE(9873)] = 304431,
  [SMALL_STATE(9874)] = 304465,
  [SMALL_STATE(9875)] = 304499,
  [SMALL_STATE(9876)] = 304533,
  [SMALL_STATE(9877)] = 304567,
  [SMALL_STATE(9878)] = 304601,
  [SMALL_STATE(9879)] = 304635,
  [SMALL_STATE(9880)] = 304669,
  [SMALL_STATE(9881)] = 304703,
  [SMALL_STATE(9882)] = 304737,
  [SMALL_STATE(9883)] = 304771,
  [SMALL_STATE(9884)] = 304805,
  [SMALL_STATE(9885)] = 304839,
  [SMALL_STATE(9886)] = 304873,
  [SMALL_STATE(9887)] = 304907,
  [SMALL_STATE(9888)] = 304941,
  [SMALL_STATE(9889)] = 304975,
  [SMALL_STATE(9890)] = 305009,
  [SMALL_STATE(9891)] = 305043,
  [SMALL_STATE(9892)] = 305077,
  [SMALL_STATE(9893)] = 305111,
  [SMALL_STATE(9894)] = 305143,
  [SMALL_STATE(9895)] = 305177,
  [SMALL_STATE(9896)] = 305211,
  [SMALL_STATE(9897)] = 305243,
  [SMALL_STATE(9898)] = 305277,
  [SMALL_STATE(9899)] = 305311,
  [SMALL_STATE(9900)] = 305345,
  [SMALL_STATE(9901)] = 305379,
  [SMALL_STATE(9902)] = 305413,
  [SMALL_STATE(9903)] = 305447,
  [SMALL_STATE(9904)] = 305481,
  [SMALL_STATE(9905)] = 305515,
  [SMALL_STATE(9906)] = 305549,
  [SMALL_STATE(9907)] = 305581,
  [SMALL_STATE(9908)] = 305615,
  [SMALL_STATE(9909)] = 305649,
  [SMALL_STATE(9910)] = 305683,
  [SMALL_STATE(9911)] = 305717,
  [SMALL_STATE(9912)] = 305751,
  [SMALL_STATE(9913)] = 305785,
  [SMALL_STATE(9914)] = 305819,
  [SMALL_STATE(9915)] = 305853,
  [SMALL_STATE(9916)] = 305887,
  [SMALL_STATE(9917)] = 305921,
  [SMALL_STATE(9918)] = 305955,
  [SMALL_STATE(9919)] = 305989,
  [SMALL_STATE(9920)] = 306023,
  [SMALL_STATE(9921)] = 306055,
  [SMALL_STATE(9922)] = 306089,
  [SMALL_STATE(9923)] = 306123,
  [SMALL_STATE(9924)] = 306157,
  [SMALL_STATE(9925)] = 306191,
  [SMALL_STATE(9926)] = 306223,
  [SMALL_STATE(9927)] = 306255,
  [SMALL_STATE(9928)] = 306289,
  [SMALL_STATE(9929)] = 306321,
  [SMALL_STATE(9930)] = 306355,
  [SMALL_STATE(9931)] = 306389,
  [SMALL_STATE(9932)] = 306423,
  [SMALL_STATE(9933)] = 306455,
  [SMALL_STATE(9934)] = 306489,
  [SMALL_STATE(9935)] = 306523,
  [SMALL_STATE(9936)] = 306555,
  [SMALL_STATE(9937)] = 306589,
  [SMALL_STATE(9938)] = 306623,
  [SMALL_STATE(9939)] = 306657,
  [SMALL_STATE(9940)] = 306691,
  [SMALL_STATE(9941)] = 306723,
  [SMALL_STATE(9942)] = 306757,
  [SMALL_STATE(9943)] = 306791,
  [SMALL_STATE(9944)] = 306825,
  [SMALL_STATE(9945)] = 306859,
  [SMALL_STATE(9946)] = 306893,
  [SMALL_STATE(9947)] = 306927,
  [SMALL_STATE(9948)] = 306961,
  [SMALL_STATE(9949)] = 306995,
  [SMALL_STATE(9950)] = 307029,
  [SMALL_STATE(9951)] = 307063,
  [SMALL_STATE(9952)] = 307097,
  [SMALL_STATE(9953)] = 307131,
  [SMALL_STATE(9954)] = 307163,
  [SMALL_STATE(9955)] = 307197,
  [SMALL_STATE(9956)] = 307229,
  [SMALL_STATE(9957)] = 307263,
  [SMALL_STATE(9958)] = 307297,
  [SMALL_STATE(9959)] = 307329,
  [SMALL_STATE(9960)] = 307363,
  [SMALL_STATE(9961)] = 307397,
  [SMALL_STATE(9962)] = 307431,
  [SMALL_STATE(9963)] = 307465,
  [SMALL_STATE(9964)] = 307499,
  [SMALL_STATE(9965)] = 307531,
  [SMALL_STATE(9966)] = 307565,
  [SMALL_STATE(9967)] = 307597,
  [SMALL_STATE(9968)] = 307631,
  [SMALL_STATE(9969)] = 307665,
  [SMALL_STATE(9970)] = 307699,
  [SMALL_STATE(9971)] = 307733,
  [SMALL_STATE(9972)] = 307767,
  [SMALL_STATE(9973)] = 307801,
  [SMALL_STATE(9974)] = 307835,
  [SMALL_STATE(9975)] = 307869,
  [SMALL_STATE(9976)] = 307903,
  [SMALL_STATE(9977)] = 307937,
  [SMALL_STATE(9978)] = 307971,
  [SMALL_STATE(9979)] = 308003,
  [SMALL_STATE(9980)] = 308037,
  [SMALL_STATE(9981)] = 308071,
  [SMALL_STATE(9982)] = 308105,
  [SMALL_STATE(9983)] = 308137,
  [SMALL_STATE(9984)] = 308171,
  [SMALL_STATE(9985)] = 308205,
  [SMALL_STATE(9986)] = 308237,
  [SMALL_STATE(9987)] = 308271,
  [SMALL_STATE(9988)] = 308303,
  [SMALL_STATE(9989)] = 308337,
  [SMALL_STATE(9990)] = 308371,
  [SMALL_STATE(9991)] = 308405,
  [SMALL_STATE(9992)] = 308439,
  [SMALL_STATE(9993)] = 308473,
  [SMALL_STATE(9994)] = 308507,
  [SMALL_STATE(9995)] = 308539,
  [SMALL_STATE(9996)] = 308573,
  [SMALL_STATE(9997)] = 308607,
  [SMALL_STATE(9998)] = 308641,
  [SMALL_STATE(9999)] = 308673,
  [SMALL_STATE(10000)] = 308707,
  [SMALL_STATE(10001)] = 308739,
  [SMALL_STATE(10002)] = 308773,
  [SMALL_STATE(10003)] = 308807,
  [SMALL_STATE(10004)] = 308841,
  [SMALL_STATE(10005)] = 308875,
  [SMALL_STATE(10006)] = 308909,
  [SMALL_STATE(10007)] = 308943,
  [SMALL_STATE(10008)] = 308977,
  [SMALL_STATE(10009)] = 309011,
  [SMALL_STATE(10010)] = 309045,
  [SMALL_STATE(10011)] = 309079,
  [SMALL_STATE(10012)] = 309113,
  [SMALL_STATE(10013)] = 309147,
  [SMALL_STATE(10014)] = 309181,
  [SMALL_STATE(10015)] = 309215,
  [SMALL_STATE(10016)] = 309249,
  [SMALL_STATE(10017)] = 309283,
  [SMALL_STATE(10018)] = 309317,
  [SMALL_STATE(10019)] = 309351,
  [SMALL_STATE(10020)] = 309385,
  [SMALL_STATE(10021)] = 309419,
  [SMALL_STATE(10022)] = 309453,
  [SMALL_STATE(10023)] = 309487,
  [SMALL_STATE(10024)] = 309521,
  [SMALL_STATE(10025)] = 309555,
  [SMALL_STATE(10026)] = 309589,
  [SMALL_STATE(10027)] = 309623,
  [SMALL_STATE(10028)] = 309657,
  [SMALL_STATE(10029)] = 309691,
  [SMALL_STATE(10030)] = 309725,
  [SMALL_STATE(10031)] = 309759,
  [SMALL_STATE(10032)] = 309793,
  [SMALL_STATE(10033)] = 309827,
  [SMALL_STATE(10034)] = 309861,
  [SMALL_STATE(10035)] = 309895,
  [SMALL_STATE(10036)] = 309929,
  [SMALL_STATE(10037)] = 309963,
  [SMALL_STATE(10038)] = 309997,
  [SMALL_STATE(10039)] = 310031,
  [SMALL_STATE(10040)] = 310065,
  [SMALL_STATE(10041)] = 310099,
  [SMALL_STATE(10042)] = 310133,
  [SMALL_STATE(10043)] = 310167,
  [SMALL_STATE(10044)] = 310201,
  [SMALL_STATE(10045)] = 310235,
  [SMALL_STATE(10046)] = 310269,
  [SMALL_STATE(10047)] = 310303,
  [SMALL_STATE(10048)] = 310337,
  [SMALL_STATE(10049)] = 310371,
  [SMALL_STATE(10050)] = 310405,
  [SMALL_STATE(10051)] = 310439,
  [SMALL_STATE(10052)] = 310473,
  [SMALL_STATE(10053)] = 310507,
  [SMALL_STATE(10054)] = 310541,
  [SMALL_STATE(10055)] = 310575,
  [SMALL_STATE(10056)] = 310609,
  [SMALL_STATE(10057)] = 310643,
  [SMALL_STATE(10058)] = 310677,
  [SMALL_STATE(10059)] = 310711,
  [SMALL_STATE(10060)] = 310745,
  [SMALL_STATE(10061)] = 310779,
  [SMALL_STATE(10062)] = 310813,
  [SMALL_STATE(10063)] = 310847,
  [SMALL_STATE(10064)] = 310881,
  [SMALL_STATE(10065)] = 310915,
  [SMALL_STATE(10066)] = 310949,
  [SMALL_STATE(10067)] = 310983,
  [SMALL_STATE(10068)] = 311017,
  [SMALL_STATE(10069)] = 311051,
  [SMALL_STATE(10070)] = 311085,
  [SMALL_STATE(10071)] = 311119,
  [SMALL_STATE(10072)] = 311153,
  [SMALL_STATE(10073)] = 311187,
  [SMALL_STATE(10074)] = 311221,
  [SMALL_STATE(10075)] = 311255,
  [SMALL_STATE(10076)] = 311289,
  [SMALL_STATE(10077)] = 311323,
  [SMALL_STATE(10078)] = 311357,
  [SMALL_STATE(10079)] = 311391,
  [SMALL_STATE(10080)] = 311425,
  [SMALL_STATE(10081)] = 311459,
  [SMALL_STATE(10082)] = 311493,
  [SMALL_STATE(10083)] = 311527,
  [SMALL_STATE(10084)] = 311561,
  [SMALL_STATE(10085)] = 311595,
  [SMALL_STATE(10086)] = 311629,
  [SMALL_STATE(10087)] = 311663,
  [SMALL_STATE(10088)] = 311697,
  [SMALL_STATE(10089)] = 311731,
  [SMALL_STATE(10090)] = 311765,
  [SMALL_STATE(10091)] = 311799,
  [SMALL_STATE(10092)] = 311831,
  [SMALL_STATE(10093)] = 311865,
  [SMALL_STATE(10094)] = 311897,
  [SMALL_STATE(10095)] = 311929,
  [SMALL_STATE(10096)] = 311963,
  [SMALL_STATE(10097)] = 311997,
  [SMALL_STATE(10098)] = 312029,
  [SMALL_STATE(10099)] = 312063,
  [SMALL_STATE(10100)] = 312097,
  [SMALL_STATE(10101)] = 312129,
  [SMALL_STATE(10102)] = 312161,
  [SMALL_STATE(10103)] = 312195,
  [SMALL_STATE(10104)] = 312227,
  [SMALL_STATE(10105)] = 312261,
  [SMALL_STATE(10106)] = 312295,
  [SMALL_STATE(10107)] = 312329,
  [SMALL_STATE(10108)] = 312361,
  [SMALL_STATE(10109)] = 312395,
  [SMALL_STATE(10110)] = 312429,
  [SMALL_STATE(10111)] = 312463,
  [SMALL_STATE(10112)] = 312497,
  [SMALL_STATE(10113)] = 312529,
  [SMALL_STATE(10114)] = 312561,
  [SMALL_STATE(10115)] = 312593,
  [SMALL_STATE(10116)] = 312625,
  [SMALL_STATE(10117)] = 312659,
  [SMALL_STATE(10118)] = 312693,
  [SMALL_STATE(10119)] = 312727,
  [SMALL_STATE(10120)] = 312759,
  [SMALL_STATE(10121)] = 312791,
  [SMALL_STATE(10122)] = 312825,
  [SMALL_STATE(10123)] = 312857,
  [SMALL_STATE(10124)] = 312891,
  [SMALL_STATE(10125)] = 312923,
  [SMALL_STATE(10126)] = 312955,
  [SMALL_STATE(10127)] = 312987,
  [SMALL_STATE(10128)] = 313019,
  [SMALL_STATE(10129)] = 313051,
  [SMALL_STATE(10130)] = 313085,
  [SMALL_STATE(10131)] = 313119,
  [SMALL_STATE(10132)] = 313153,
  [SMALL_STATE(10133)] = 313187,
  [SMALL_STATE(10134)] = 313219,
  [SMALL_STATE(10135)] = 313251,
  [SMALL_STATE(10136)] = 313283,
  [SMALL_STATE(10137)] = 313315,
  [SMALL_STATE(10138)] = 313349,
  [SMALL_STATE(10139)] = 313383,
  [SMALL_STATE(10140)] = 313415,
  [SMALL_STATE(10141)] = 313449,
  [SMALL_STATE(10142)] = 313483,
  [SMALL_STATE(10143)] = 313515,
  [SMALL_STATE(10144)] = 313547,
  [SMALL_STATE(10145)] = 313579,
  [SMALL_STATE(10146)] = 313611,
  [SMALL_STATE(10147)] = 313643,
  [SMALL_STATE(10148)] = 313677,
  [SMALL_STATE(10149)] = 313711,
  [SMALL_STATE(10150)] = 313745,
  [SMALL_STATE(10151)] = 313777,
  [SMALL_STATE(10152)] = 313811,
  [SMALL_STATE(10153)] = 313843,
  [SMALL_STATE(10154)] = 313875,
  [SMALL_STATE(10155)] = 313909,
  [SMALL_STATE(10156)] = 313941,
  [SMALL_STATE(10157)] = 313973,
  [SMALL_STATE(10158)] = 314007,
  [SMALL_STATE(10159)] = 314039,
  [SMALL_STATE(10160)] = 314073,
  [SMALL_STATE(10161)] = 314107,
  [SMALL_STATE(10162)] = 314141,
  [SMALL_STATE(10163)] = 314175,
  [SMALL_STATE(10164)] = 314207,
  [SMALL_STATE(10165)] = 314241,
  [SMALL_STATE(10166)] = 314275,
  [SMALL_STATE(10167)] = 314309,
  [SMALL_STATE(10168)] = 314343,
  [SMALL_STATE(10169)] = 314377,
  [SMALL_STATE(10170)] = 314411,
  [SMALL_STATE(10171)] = 314445,
  [SMALL_STATE(10172)] = 314479,
  [SMALL_STATE(10173)] = 314513,
  [SMALL_STATE(10174)] = 314545,
  [SMALL_STATE(10175)] = 314579,
  [SMALL_STATE(10176)] = 314613,
  [SMALL_STATE(10177)] = 314647,
  [SMALL_STATE(10178)] = 314679,
  [SMALL_STATE(10179)] = 314713,
  [SMALL_STATE(10180)] = 314747,
  [SMALL_STATE(10181)] = 314779,
  [SMALL_STATE(10182)] = 314813,
  [SMALL_STATE(10183)] = 314847,
  [SMALL_STATE(10184)] = 314881,
  [SMALL_STATE(10185)] = 314915,
  [SMALL_STATE(10186)] = 314946,
  [SMALL_STATE(10187)] = 314977,
  [SMALL_STATE(10188)] = 315008,
  [SMALL_STATE(10189)] = 315039,
  [SMALL_STATE(10190)] = 315070,
  [SMALL_STATE(10191)] = 315101,
  [SMALL_STATE(10192)] = 315132,
  [SMALL_STATE(10193)] = 315163,
  [SMALL_STATE(10194)] = 315194,
  [SMALL_STATE(10195)] = 315225,
  [SMALL_STATE(10196)] = 315256,
  [SMALL_STATE(10197)] = 315287,
  [SMALL_STATE(10198)] = 315318,
  [SMALL_STATE(10199)] = 315349,
  [SMALL_STATE(10200)] = 315380,
  [SMALL_STATE(10201)] = 315411,
  [SMALL_STATE(10202)] = 315442,
  [SMALL_STATE(10203)] = 315473,
  [SMALL_STATE(10204)] = 315504,
  [SMALL_STATE(10205)] = 315535,
  [SMALL_STATE(10206)] = 315566,
  [SMALL_STATE(10207)] = 315597,
  [SMALL_STATE(10208)] = 315628,
  [SMALL_STATE(10209)] = 315659,
  [SMALL_STATE(10210)] = 315690,
  [SMALL_STATE(10211)] = 315721,
  [SMALL_STATE(10212)] = 315752,
  [SMALL_STATE(10213)] = 315783,
  [SMALL_STATE(10214)] = 315814,
  [SMALL_STATE(10215)] = 315845,
  [SMALL_STATE(10216)] = 315876,
  [SMALL_STATE(10217)] = 315907,
  [SMALL_STATE(10218)] = 315938,
  [SMALL_STATE(10219)] = 315969,
  [SMALL_STATE(10220)] = 316000,
  [SMALL_STATE(10221)] = 316031,
  [SMALL_STATE(10222)] = 316062,
  [SMALL_STATE(10223)] = 316093,
  [SMALL_STATE(10224)] = 316124,
  [SMALL_STATE(10225)] = 316155,
  [SMALL_STATE(10226)] = 316186,
  [SMALL_STATE(10227)] = 316217,
  [SMALL_STATE(10228)] = 316248,
  [SMALL_STATE(10229)] = 316279,
  [SMALL_STATE(10230)] = 316310,
  [SMALL_STATE(10231)] = 316341,
  [SMALL_STATE(10232)] = 316372,
  [SMALL_STATE(10233)] = 316403,
  [SMALL_STATE(10234)] = 316434,
  [SMALL_STATE(10235)] = 316465,
  [SMALL_STATE(10236)] = 316496,
  [SMALL_STATE(10237)] = 316527,
  [SMALL_STATE(10238)] = 316558,
  [SMALL_STATE(10239)] = 316589,
  [SMALL_STATE(10240)] = 316620,
  [SMALL_STATE(10241)] = 316651,
  [SMALL_STATE(10242)] = 316682,
  [SMALL_STATE(10243)] = 316713,
  [SMALL_STATE(10244)] = 316744,
  [SMALL_STATE(10245)] = 316775,
  [SMALL_STATE(10246)] = 316806,
  [SMALL_STATE(10247)] = 316837,
  [SMALL_STATE(10248)] = 316868,
  [SMALL_STATE(10249)] = 316899,
  [SMALL_STATE(10250)] = 316930,
  [SMALL_STATE(10251)] = 316961,
  [SMALL_STATE(10252)] = 316992,
  [SMALL_STATE(10253)] = 317023,
  [SMALL_STATE(10254)] = 317054,
  [SMALL_STATE(10255)] = 317085,
  [SMALL_STATE(10256)] = 317116,
  [SMALL_STATE(10257)] = 317147,
  [SMALL_STATE(10258)] = 317178,
  [SMALL_STATE(10259)] = 317209,
  [SMALL_STATE(10260)] = 317240,
  [SMALL_STATE(10261)] = 317271,
  [SMALL_STATE(10262)] = 317302,
  [SMALL_STATE(10263)] = 317333,
  [SMALL_STATE(10264)] = 317364,
  [SMALL_STATE(10265)] = 317395,
  [SMALL_STATE(10266)] = 317426,
  [SMALL_STATE(10267)] = 317457,
  [SMALL_STATE(10268)] = 317488,
  [SMALL_STATE(10269)] = 317519,
  [SMALL_STATE(10270)] = 317550,
  [SMALL_STATE(10271)] = 317581,
  [SMALL_STATE(10272)] = 317612,
  [SMALL_STATE(10273)] = 317643,
  [SMALL_STATE(10274)] = 317674,
  [SMALL_STATE(10275)] = 317705,
  [SMALL_STATE(10276)] = 317736,
  [SMALL_STATE(10277)] = 317767,
  [SMALL_STATE(10278)] = 317798,
  [SMALL_STATE(10279)] = 317829,
  [SMALL_STATE(10280)] = 317860,
  [SMALL_STATE(10281)] = 317891,
  [SMALL_STATE(10282)] = 317922,
  [SMALL_STATE(10283)] = 317953,
  [SMALL_STATE(10284)] = 317984,
  [SMALL_STATE(10285)] = 318015,
  [SMALL_STATE(10286)] = 318046,
  [SMALL_STATE(10287)] = 318077,
  [SMALL_STATE(10288)] = 318108,
  [SMALL_STATE(10289)] = 318139,
  [SMALL_STATE(10290)] = 318170,
  [SMALL_STATE(10291)] = 318201,
  [SMALL_STATE(10292)] = 318232,
  [SMALL_STATE(10293)] = 318263,
  [SMALL_STATE(10294)] = 318294,
  [SMALL_STATE(10295)] = 318325,
  [SMALL_STATE(10296)] = 318356,
  [SMALL_STATE(10297)] = 318387,
  [SMALL_STATE(10298)] = 318418,
  [SMALL_STATE(10299)] = 318449,
  [SMALL_STATE(10300)] = 318480,
  [SMALL_STATE(10301)] = 318511,
  [SMALL_STATE(10302)] = 318542,
  [SMALL_STATE(10303)] = 318573,
  [SMALL_STATE(10304)] = 318604,
  [SMALL_STATE(10305)] = 318635,
  [SMALL_STATE(10306)] = 318666,
  [SMALL_STATE(10307)] = 318697,
  [SMALL_STATE(10308)] = 318728,
  [SMALL_STATE(10309)] = 318759,
  [SMALL_STATE(10310)] = 318790,
  [SMALL_STATE(10311)] = 318821,
  [SMALL_STATE(10312)] = 318852,
  [SMALL_STATE(10313)] = 318883,
  [SMALL_STATE(10314)] = 318914,
  [SMALL_STATE(10315)] = 318945,
  [SMALL_STATE(10316)] = 318976,
  [SMALL_STATE(10317)] = 319007,
  [SMALL_STATE(10318)] = 319038,
  [SMALL_STATE(10319)] = 319069,
  [SMALL_STATE(10320)] = 319100,
  [SMALL_STATE(10321)] = 319131,
  [SMALL_STATE(10322)] = 319162,
  [SMALL_STATE(10323)] = 319193,
  [SMALL_STATE(10324)] = 319224,
  [SMALL_STATE(10325)] = 319255,
  [SMALL_STATE(10326)] = 319286,
  [SMALL_STATE(10327)] = 319317,
  [SMALL_STATE(10328)] = 319348,
  [SMALL_STATE(10329)] = 319379,
  [SMALL_STATE(10330)] = 319410,
  [SMALL_STATE(10331)] = 319441,
  [SMALL_STATE(10332)] = 319472,
  [SMALL_STATE(10333)] = 319503,
  [SMALL_STATE(10334)] = 319534,
  [SMALL_STATE(10335)] = 319565,
  [SMALL_STATE(10336)] = 319596,
  [SMALL_STATE(10337)] = 319627,
  [SMALL_STATE(10338)] = 319658,
  [SMALL_STATE(10339)] = 319689,
  [SMALL_STATE(10340)] = 319720,
  [SMALL_STATE(10341)] = 319751,
  [SMALL_STATE(10342)] = 319782,
  [SMALL_STATE(10343)] = 319813,
  [SMALL_STATE(10344)] = 319844,
  [SMALL_STATE(10345)] = 319875,
  [SMALL_STATE(10346)] = 319906,
  [SMALL_STATE(10347)] = 319937,
  [SMALL_STATE(10348)] = 319968,
  [SMALL_STATE(10349)] = 319999,
  [SMALL_STATE(10350)] = 320030,
  [SMALL_STATE(10351)] = 320061,
  [SMALL_STATE(10352)] = 320092,
  [SMALL_STATE(10353)] = 320123,
  [SMALL_STATE(10354)] = 320154,
  [SMALL_STATE(10355)] = 320185,
  [SMALL_STATE(10356)] = 320216,
  [SMALL_STATE(10357)] = 320247,
  [SMALL_STATE(10358)] = 320278,
  [SMALL_STATE(10359)] = 320309,
  [SMALL_STATE(10360)] = 320340,
  [SMALL_STATE(10361)] = 320371,
  [SMALL_STATE(10362)] = 320402,
  [SMALL_STATE(10363)] = 320433,
  [SMALL_STATE(10364)] = 320464,
  [SMALL_STATE(10365)] = 320495,
  [SMALL_STATE(10366)] = 320526,
  [SMALL_STATE(10367)] = 320557,
  [SMALL_STATE(10368)] = 320588,
  [SMALL_STATE(10369)] = 320619,
  [SMALL_STATE(10370)] = 320650,
  [SMALL_STATE(10371)] = 320681,
  [SMALL_STATE(10372)] = 320712,
  [SMALL_STATE(10373)] = 320743,
  [SMALL_STATE(10374)] = 320774,
  [SMALL_STATE(10375)] = 320805,
  [SMALL_STATE(10376)] = 320836,
  [SMALL_STATE(10377)] = 320867,
  [SMALL_STATE(10378)] = 320898,
  [SMALL_STATE(10379)] = 320929,
  [SMALL_STATE(10380)] = 320960,
  [SMALL_STATE(10381)] = 320991,
  [SMALL_STATE(10382)] = 321022,
  [SMALL_STATE(10383)] = 321053,
  [SMALL_STATE(10384)] = 321084,
  [SMALL_STATE(10385)] = 321115,
  [SMALL_STATE(10386)] = 321146,
  [SMALL_STATE(10387)] = 321177,
  [SMALL_STATE(10388)] = 321208,
  [SMALL_STATE(10389)] = 321239,
  [SMALL_STATE(10390)] = 321270,
  [SMALL_STATE(10391)] = 321301,
  [SMALL_STATE(10392)] = 321332,
  [SMALL_STATE(10393)] = 321363,
  [SMALL_STATE(10394)] = 321394,
  [SMALL_STATE(10395)] = 321425,
  [SMALL_STATE(10396)] = 321456,
  [SMALL_STATE(10397)] = 321487,
  [SMALL_STATE(10398)] = 321518,
  [SMALL_STATE(10399)] = 321549,
  [SMALL_STATE(10400)] = 321580,
  [SMALL_STATE(10401)] = 321611,
  [SMALL_STATE(10402)] = 321642,
  [SMALL_STATE(10403)] = 321673,
  [SMALL_STATE(10404)] = 321704,
  [SMALL_STATE(10405)] = 321735,
  [SMALL_STATE(10406)] = 321766,
  [SMALL_STATE(10407)] = 321797,
  [SMALL_STATE(10408)] = 321828,
  [SMALL_STATE(10409)] = 321859,
  [SMALL_STATE(10410)] = 321890,
  [SMALL_STATE(10411)] = 321921,
  [SMALL_STATE(10412)] = 321952,
  [SMALL_STATE(10413)] = 321983,
  [SMALL_STATE(10414)] = 322014,
  [SMALL_STATE(10415)] = 322045,
  [SMALL_STATE(10416)] = 322076,
  [SMALL_STATE(10417)] = 322107,
  [SMALL_STATE(10418)] = 322138,
  [SMALL_STATE(10419)] = 322169,
  [SMALL_STATE(10420)] = 322200,
  [SMALL_STATE(10421)] = 322231,
  [SMALL_STATE(10422)] = 322262,
  [SMALL_STATE(10423)] = 322293,
  [SMALL_STATE(10424)] = 322324,
  [SMALL_STATE(10425)] = 322355,
  [SMALL_STATE(10426)] = 322386,
  [SMALL_STATE(10427)] = 322417,
  [SMALL_STATE(10428)] = 322448,
  [SMALL_STATE(10429)] = 322479,
  [SMALL_STATE(10430)] = 322510,
  [SMALL_STATE(10431)] = 322541,
  [SMALL_STATE(10432)] = 322572,
  [SMALL_STATE(10433)] = 322603,
  [SMALL_STATE(10434)] = 322634,
  [SMALL_STATE(10435)] = 322665,
  [SMALL_STATE(10436)] = 322696,
  [SMALL_STATE(10437)] = 322727,
  [SMALL_STATE(10438)] = 322758,
  [SMALL_STATE(10439)] = 322789,
  [SMALL_STATE(10440)] = 322820,
  [SMALL_STATE(10441)] = 322851,
  [SMALL_STATE(10442)] = 322882,
  [SMALL_STATE(10443)] = 322913,
  [SMALL_STATE(10444)] = 322944,
  [SMALL_STATE(10445)] = 322975,
  [SMALL_STATE(10446)] = 323006,
  [SMALL_STATE(10447)] = 323037,
  [SMALL_STATE(10448)] = 323068,
  [SMALL_STATE(10449)] = 323099,
  [SMALL_STATE(10450)] = 323130,
  [SMALL_STATE(10451)] = 323161,
  [SMALL_STATE(10452)] = 323192,
  [SMALL_STATE(10453)] = 323223,
  [SMALL_STATE(10454)] = 323254,
  [SMALL_STATE(10455)] = 323285,
  [SMALL_STATE(10456)] = 323316,
  [SMALL_STATE(10457)] = 323347,
  [SMALL_STATE(10458)] = 323378,
  [SMALL_STATE(10459)] = 323409,
  [SMALL_STATE(10460)] = 323440,
  [SMALL_STATE(10461)] = 323471,
  [SMALL_STATE(10462)] = 323502,
  [SMALL_STATE(10463)] = 323533,
  [SMALL_STATE(10464)] = 323564,
  [SMALL_STATE(10465)] = 323595,
  [SMALL_STATE(10466)] = 323626,
  [SMALL_STATE(10467)] = 323657,
  [SMALL_STATE(10468)] = 323688,
  [SMALL_STATE(10469)] = 323719,
  [SMALL_STATE(10470)] = 323750,
  [SMALL_STATE(10471)] = 323781,
  [SMALL_STATE(10472)] = 323812,
  [SMALL_STATE(10473)] = 323843,
  [SMALL_STATE(10474)] = 323874,
  [SMALL_STATE(10475)] = 323905,
  [SMALL_STATE(10476)] = 323936,
  [SMALL_STATE(10477)] = 323967,
  [SMALL_STATE(10478)] = 323998,
  [SMALL_STATE(10479)] = 324029,
  [SMALL_STATE(10480)] = 324060,
  [SMALL_STATE(10481)] = 324091,
  [SMALL_STATE(10482)] = 324122,
  [SMALL_STATE(10483)] = 324153,
  [SMALL_STATE(10484)] = 324184,
  [SMALL_STATE(10485)] = 324215,
  [SMALL_STATE(10486)] = 324246,
  [SMALL_STATE(10487)] = 324277,
  [SMALL_STATE(10488)] = 324308,
  [SMALL_STATE(10489)] = 324339,
  [SMALL_STATE(10490)] = 324370,
  [SMALL_STATE(10491)] = 324401,
  [SMALL_STATE(10492)] = 324432,
  [SMALL_STATE(10493)] = 324463,
  [SMALL_STATE(10494)] = 324494,
  [SMALL_STATE(10495)] = 324525,
  [SMALL_STATE(10496)] = 324556,
  [SMALL_STATE(10497)] = 324587,
  [SMALL_STATE(10498)] = 324618,
  [SMALL_STATE(10499)] = 324649,
  [SMALL_STATE(10500)] = 324680,
  [SMALL_STATE(10501)] = 324711,
  [SMALL_STATE(10502)] = 324742,
  [SMALL_STATE(10503)] = 324773,
  [SMALL_STATE(10504)] = 324804,
  [SMALL_STATE(10505)] = 324835,
  [SMALL_STATE(10506)] = 324866,
  [SMALL_STATE(10507)] = 324897,
  [SMALL_STATE(10508)] = 324928,
  [SMALL_STATE(10509)] = 324959,
  [SMALL_STATE(10510)] = 324990,
  [SMALL_STATE(10511)] = 325021,
  [SMALL_STATE(10512)] = 325052,
  [SMALL_STATE(10513)] = 325083,
  [SMALL_STATE(10514)] = 325114,
  [SMALL_STATE(10515)] = 325145,
  [SMALL_STATE(10516)] = 325176,
  [SMALL_STATE(10517)] = 325207,
  [SMALL_STATE(10518)] = 325238,
  [SMALL_STATE(10519)] = 325269,
  [SMALL_STATE(10520)] = 325300,
  [SMALL_STATE(10521)] = 325331,
  [SMALL_STATE(10522)] = 325362,
  [SMALL_STATE(10523)] = 325393,
  [SMALL_STATE(10524)] = 325424,
  [SMALL_STATE(10525)] = 325455,
  [SMALL_STATE(10526)] = 325486,
  [SMALL_STATE(10527)] = 325517,
  [SMALL_STATE(10528)] = 325548,
  [SMALL_STATE(10529)] = 325579,
  [SMALL_STATE(10530)] = 325610,
  [SMALL_STATE(10531)] = 325641,
  [SMALL_STATE(10532)] = 325672,
  [SMALL_STATE(10533)] = 325703,
  [SMALL_STATE(10534)] = 325734,
  [SMALL_STATE(10535)] = 325765,
  [SMALL_STATE(10536)] = 325796,
  [SMALL_STATE(10537)] = 325827,
  [SMALL_STATE(10538)] = 325858,
  [SMALL_STATE(10539)] = 325889,
  [SMALL_STATE(10540)] = 325920,
  [SMALL_STATE(10541)] = 325951,
  [SMALL_STATE(10542)] = 325982,
  [SMALL_STATE(10543)] = 326013,
  [SMALL_STATE(10544)] = 326044,
  [SMALL_STATE(10545)] = 326075,
  [SMALL_STATE(10546)] = 326106,
  [SMALL_STATE(10547)] = 326137,
  [SMALL_STATE(10548)] = 326168,
  [SMALL_STATE(10549)] = 326199,
  [SMALL_STATE(10550)] = 326230,
  [SMALL_STATE(10551)] = 326261,
  [SMALL_STATE(10552)] = 326292,
  [SMALL_STATE(10553)] = 326323,
  [SMALL_STATE(10554)] = 326354,
  [SMALL_STATE(10555)] = 326385,
  [SMALL_STATE(10556)] = 326416,
  [SMALL_STATE(10557)] = 326447,
  [SMALL_STATE(10558)] = 326478,
  [SMALL_STATE(10559)] = 326509,
  [SMALL_STATE(10560)] = 326540,
  [SMALL_STATE(10561)] = 326571,
  [SMALL_STATE(10562)] = 326602,
  [SMALL_STATE(10563)] = 326633,
  [SMALL_STATE(10564)] = 326664,
  [SMALL_STATE(10565)] = 326695,
  [SMALL_STATE(10566)] = 326726,
  [SMALL_STATE(10567)] = 326757,
  [SMALL_STATE(10568)] = 326788,
  [SMALL_STATE(10569)] = 326819,
  [SMALL_STATE(10570)] = 326850,
  [SMALL_STATE(10571)] = 326881,
  [SMALL_STATE(10572)] = 326912,
  [SMALL_STATE(10573)] = 326943,
  [SMALL_STATE(10574)] = 326974,
  [SMALL_STATE(10575)] = 327005,
  [SMALL_STATE(10576)] = 327036,
  [SMALL_STATE(10577)] = 327067,
  [SMALL_STATE(10578)] = 327098,
  [SMALL_STATE(10579)] = 327129,
  [SMALL_STATE(10580)] = 327160,
  [SMALL_STATE(10581)] = 327191,
  [SMALL_STATE(10582)] = 327222,
  [SMALL_STATE(10583)] = 327253,
  [SMALL_STATE(10584)] = 327284,
  [SMALL_STATE(10585)] = 327315,
  [SMALL_STATE(10586)] = 327346,
  [SMALL_STATE(10587)] = 327377,
  [SMALL_STATE(10588)] = 327408,
  [SMALL_STATE(10589)] = 327439,
  [SMALL_STATE(10590)] = 327470,
  [SMALL_STATE(10591)] = 327501,
  [SMALL_STATE(10592)] = 327532,
  [SMALL_STATE(10593)] = 327563,
  [SMALL_STATE(10594)] = 327594,
  [SMALL_STATE(10595)] = 327625,
  [SMALL_STATE(10596)] = 327656,
  [SMALL_STATE(10597)] = 327687,
  [SMALL_STATE(10598)] = 327718,
  [SMALL_STATE(10599)] = 327749,
  [SMALL_STATE(10600)] = 327780,
  [SMALL_STATE(10601)] = 327811,
  [SMALL_STATE(10602)] = 327842,
  [SMALL_STATE(10603)] = 327873,
  [SMALL_STATE(10604)] = 327904,
  [SMALL_STATE(10605)] = 327935,
  [SMALL_STATE(10606)] = 327966,
  [SMALL_STATE(10607)] = 327997,
  [SMALL_STATE(10608)] = 328028,
  [SMALL_STATE(10609)] = 328059,
  [SMALL_STATE(10610)] = 328090,
  [SMALL_STATE(10611)] = 328121,
  [SMALL_STATE(10612)] = 328152,
  [SMALL_STATE(10613)] = 328183,
  [SMALL_STATE(10614)] = 328214,
  [SMALL_STATE(10615)] = 328245,
  [SMALL_STATE(10616)] = 328276,
  [SMALL_STATE(10617)] = 328307,
  [SMALL_STATE(10618)] = 328338,
  [SMALL_STATE(10619)] = 328369,
  [SMALL_STATE(10620)] = 328400,
  [SMALL_STATE(10621)] = 328431,
  [SMALL_STATE(10622)] = 328462,
  [SMALL_STATE(10623)] = 328493,
  [SMALL_STATE(10624)] = 328524,
  [SMALL_STATE(10625)] = 328555,
  [SMALL_STATE(10626)] = 328586,
  [SMALL_STATE(10627)] = 328617,
  [SMALL_STATE(10628)] = 328648,
  [SMALL_STATE(10629)] = 328679,
  [SMALL_STATE(10630)] = 328710,
  [SMALL_STATE(10631)] = 328741,
  [SMALL_STATE(10632)] = 328772,
  [SMALL_STATE(10633)] = 328803,
  [SMALL_STATE(10634)] = 328834,
  [SMALL_STATE(10635)] = 328865,
  [SMALL_STATE(10636)] = 328896,
  [SMALL_STATE(10637)] = 328927,
  [SMALL_STATE(10638)] = 328958,
  [SMALL_STATE(10639)] = 328989,
  [SMALL_STATE(10640)] = 329020,
  [SMALL_STATE(10641)] = 329051,
  [SMALL_STATE(10642)] = 329082,
  [SMALL_STATE(10643)] = 329113,
  [SMALL_STATE(10644)] = 329144,
  [SMALL_STATE(10645)] = 329175,
  [SMALL_STATE(10646)] = 329206,
  [SMALL_STATE(10647)] = 329237,
  [SMALL_STATE(10648)] = 329268,
  [SMALL_STATE(10649)] = 329299,
  [SMALL_STATE(10650)] = 329330,
  [SMALL_STATE(10651)] = 329361,
  [SMALL_STATE(10652)] = 329392,
  [SMALL_STATE(10653)] = 329423,
  [SMALL_STATE(10654)] = 329454,
  [SMALL_STATE(10655)] = 329485,
  [SMALL_STATE(10656)] = 329516,
  [SMALL_STATE(10657)] = 329547,
  [SMALL_STATE(10658)] = 329578,
  [SMALL_STATE(10659)] = 329609,
  [SMALL_STATE(10660)] = 329640,
  [SMALL_STATE(10661)] = 329671,
  [SMALL_STATE(10662)] = 329702,
  [SMALL_STATE(10663)] = 329733,
  [SMALL_STATE(10664)] = 329764,
  [SMALL_STATE(10665)] = 329795,
  [SMALL_STATE(10666)] = 329826,
  [SMALL_STATE(10667)] = 329857,
  [SMALL_STATE(10668)] = 329888,
  [SMALL_STATE(10669)] = 329919,
  [SMALL_STATE(10670)] = 329950,
  [SMALL_STATE(10671)] = 329981,
  [SMALL_STATE(10672)] = 330012,
  [SMALL_STATE(10673)] = 330043,
  [SMALL_STATE(10674)] = 330074,
  [SMALL_STATE(10675)] = 330105,
  [SMALL_STATE(10676)] = 330136,
  [SMALL_STATE(10677)] = 330167,
  [SMALL_STATE(10678)] = 330198,
  [SMALL_STATE(10679)] = 330229,
  [SMALL_STATE(10680)] = 330260,
  [SMALL_STATE(10681)] = 330291,
  [SMALL_STATE(10682)] = 330322,
  [SMALL_STATE(10683)] = 330353,
  [SMALL_STATE(10684)] = 330384,
  [SMALL_STATE(10685)] = 330415,
  [SMALL_STATE(10686)] = 330446,
  [SMALL_STATE(10687)] = 330477,
  [SMALL_STATE(10688)] = 330508,
  [SMALL_STATE(10689)] = 330539,
  [SMALL_STATE(10690)] = 330570,
  [SMALL_STATE(10691)] = 330601,
  [SMALL_STATE(10692)] = 330632,
  [SMALL_STATE(10693)] = 330663,
  [SMALL_STATE(10694)] = 330694,
  [SMALL_STATE(10695)] = 330725,
  [SMALL_STATE(10696)] = 330756,
  [SMALL_STATE(10697)] = 330787,
  [SMALL_STATE(10698)] = 330818,
  [SMALL_STATE(10699)] = 330849,
  [SMALL_STATE(10700)] = 330880,
  [SMALL_STATE(10701)] = 330911,
  [SMALL_STATE(10702)] = 330942,
  [SMALL_STATE(10703)] = 330973,
  [SMALL_STATE(10704)] = 331004,
  [SMALL_STATE(10705)] = 331035,
  [SMALL_STATE(10706)] = 331066,
  [SMALL_STATE(10707)] = 331097,
  [SMALL_STATE(10708)] = 331128,
  [SMALL_STATE(10709)] = 331159,
  [SMALL_STATE(10710)] = 331190,
  [SMALL_STATE(10711)] = 331221,
  [SMALL_STATE(10712)] = 331252,
  [SMALL_STATE(10713)] = 331283,
  [SMALL_STATE(10714)] = 331314,
  [SMALL_STATE(10715)] = 331345,
  [SMALL_STATE(10716)] = 331376,
  [SMALL_STATE(10717)] = 331407,
  [SMALL_STATE(10718)] = 331438,
  [SMALL_STATE(10719)] = 331469,
  [SMALL_STATE(10720)] = 331500,
  [SMALL_STATE(10721)] = 331531,
  [SMALL_STATE(10722)] = 331562,
  [SMALL_STATE(10723)] = 331593,
  [SMALL_STATE(10724)] = 331624,
  [SMALL_STATE(10725)] = 331655,
  [SMALL_STATE(10726)] = 331686,
  [SMALL_STATE(10727)] = 331717,
  [SMALL_STATE(10728)] = 331748,
  [SMALL_STATE(10729)] = 331779,
  [SMALL_STATE(10730)] = 331810,
  [SMALL_STATE(10731)] = 331841,
  [SMALL_STATE(10732)] = 331872,
  [SMALL_STATE(10733)] = 331903,
  [SMALL_STATE(10734)] = 331934,
  [SMALL_STATE(10735)] = 331965,
  [SMALL_STATE(10736)] = 331996,
  [SMALL_STATE(10737)] = 332027,
  [SMALL_STATE(10738)] = 332058,
  [SMALL_STATE(10739)] = 332089,
  [SMALL_STATE(10740)] = 332120,
  [SMALL_STATE(10741)] = 332151,
  [SMALL_STATE(10742)] = 332182,
  [SMALL_STATE(10743)] = 332213,
  [SMALL_STATE(10744)] = 332244,
  [SMALL_STATE(10745)] = 332275,
  [SMALL_STATE(10746)] = 332306,
  [SMALL_STATE(10747)] = 332337,
  [SMALL_STATE(10748)] = 332368,
  [SMALL_STATE(10749)] = 332399,
  [SMALL_STATE(10750)] = 332430,
  [SMALL_STATE(10751)] = 332461,
  [SMALL_STATE(10752)] = 332492,
  [SMALL_STATE(10753)] = 332523,
  [SMALL_STATE(10754)] = 332554,
  [SMALL_STATE(10755)] = 332585,
  [SMALL_STATE(10756)] = 332616,
  [SMALL_STATE(10757)] = 332647,
  [SMALL_STATE(10758)] = 332678,
  [SMALL_STATE(10759)] = 332709,
  [SMALL_STATE(10760)] = 332740,
  [SMALL_STATE(10761)] = 332771,
  [SMALL_STATE(10762)] = 332802,
  [SMALL_STATE(10763)] = 332833,
  [SMALL_STATE(10764)] = 332864,
  [SMALL_STATE(10765)] = 332895,
  [SMALL_STATE(10766)] = 332926,
  [SMALL_STATE(10767)] = 332957,
  [SMALL_STATE(10768)] = 332988,
  [SMALL_STATE(10769)] = 333019,
  [SMALL_STATE(10770)] = 333050,
  [SMALL_STATE(10771)] = 333081,
  [SMALL_STATE(10772)] = 333112,
  [SMALL_STATE(10773)] = 333143,
  [SMALL_STATE(10774)] = 333174,
  [SMALL_STATE(10775)] = 333205,
  [SMALL_STATE(10776)] = 333236,
  [SMALL_STATE(10777)] = 333267,
  [SMALL_STATE(10778)] = 333298,
  [SMALL_STATE(10779)] = 333329,
  [SMALL_STATE(10780)] = 333360,
  [SMALL_STATE(10781)] = 333391,
  [SMALL_STATE(10782)] = 333422,
  [SMALL_STATE(10783)] = 333453,
  [SMALL_STATE(10784)] = 333484,
  [SMALL_STATE(10785)] = 333515,
  [SMALL_STATE(10786)] = 333546,
  [SMALL_STATE(10787)] = 333577,
  [SMALL_STATE(10788)] = 333608,
  [SMALL_STATE(10789)] = 333639,
  [SMALL_STATE(10790)] = 333670,
  [SMALL_STATE(10791)] = 333701,
  [SMALL_STATE(10792)] = 333732,
  [SMALL_STATE(10793)] = 333763,
  [SMALL_STATE(10794)] = 333794,
  [SMALL_STATE(10795)] = 333825,
  [SMALL_STATE(10796)] = 333856,
  [SMALL_STATE(10797)] = 333887,
  [SMALL_STATE(10798)] = 333918,
  [SMALL_STATE(10799)] = 333949,
  [SMALL_STATE(10800)] = 333980,
  [SMALL_STATE(10801)] = 334011,
  [SMALL_STATE(10802)] = 334042,
  [SMALL_STATE(10803)] = 334073,
  [SMALL_STATE(10804)] = 334104,
  [SMALL_STATE(10805)] = 334135,
  [SMALL_STATE(10806)] = 334166,
  [SMALL_STATE(10807)] = 334197,
  [SMALL_STATE(10808)] = 334228,
  [SMALL_STATE(10809)] = 334259,
  [SMALL_STATE(10810)] = 334290,
  [SMALL_STATE(10811)] = 334321,
  [SMALL_STATE(10812)] = 334352,
  [SMALL_STATE(10813)] = 334383,
  [SMALL_STATE(10814)] = 334414,
  [SMALL_STATE(10815)] = 334445,
  [SMALL_STATE(10816)] = 334476,
  [SMALL_STATE(10817)] = 334507,
  [SMALL_STATE(10818)] = 334538,
  [SMALL_STATE(10819)] = 334569,
  [SMALL_STATE(10820)] = 334600,
  [SMALL_STATE(10821)] = 334631,
  [SMALL_STATE(10822)] = 334662,
  [SMALL_STATE(10823)] = 334693,
  [SMALL_STATE(10824)] = 334724,
  [SMALL_STATE(10825)] = 334755,
  [SMALL_STATE(10826)] = 334786,
  [SMALL_STATE(10827)] = 334817,
  [SMALL_STATE(10828)] = 334848,
  [SMALL_STATE(10829)] = 334879,
  [SMALL_STATE(10830)] = 334910,
  [SMALL_STATE(10831)] = 334941,
  [SMALL_STATE(10832)] = 334972,
  [SMALL_STATE(10833)] = 335003,
  [SMALL_STATE(10834)] = 335034,
  [SMALL_STATE(10835)] = 335065,
  [SMALL_STATE(10836)] = 335096,
  [SMALL_STATE(10837)] = 335127,
  [SMALL_STATE(10838)] = 335158,
  [SMALL_STATE(10839)] = 335189,
  [SMALL_STATE(10840)] = 335220,
  [SMALL_STATE(10841)] = 335251,
  [SMALL_STATE(10842)] = 335282,
  [SMALL_STATE(10843)] = 335313,
  [SMALL_STATE(10844)] = 335344,
  [SMALL_STATE(10845)] = 335375,
  [SMALL_STATE(10846)] = 335406,
  [SMALL_STATE(10847)] = 335437,
  [SMALL_STATE(10848)] = 335468,
  [SMALL_STATE(10849)] = 335499,
  [SMALL_STATE(10850)] = 335530,
  [SMALL_STATE(10851)] = 335561,
  [SMALL_STATE(10852)] = 335592,
  [SMALL_STATE(10853)] = 335623,
  [SMALL_STATE(10854)] = 335654,
  [SMALL_STATE(10855)] = 335685,
  [SMALL_STATE(10856)] = 335716,
  [SMALL_STATE(10857)] = 335747,
  [SMALL_STATE(10858)] = 335778,
  [SMALL_STATE(10859)] = 335809,
  [SMALL_STATE(10860)] = 335840,
  [SMALL_STATE(10861)] = 335871,
  [SMALL_STATE(10862)] = 335902,
  [SMALL_STATE(10863)] = 335933,
  [SMALL_STATE(10864)] = 335964,
  [SMALL_STATE(10865)] = 335995,
  [SMALL_STATE(10866)] = 336026,
  [SMALL_STATE(10867)] = 336057,
  [SMALL_STATE(10868)] = 336088,
  [SMALL_STATE(10869)] = 336119,
  [SMALL_STATE(10870)] = 336150,
  [SMALL_STATE(10871)] = 336181,
  [SMALL_STATE(10872)] = 336212,
  [SMALL_STATE(10873)] = 336243,
  [SMALL_STATE(10874)] = 336274,
  [SMALL_STATE(10875)] = 336305,
  [SMALL_STATE(10876)] = 336336,
  [SMALL_STATE(10877)] = 336367,
  [SMALL_STATE(10878)] = 336398,
  [SMALL_STATE(10879)] = 336429,
  [SMALL_STATE(10880)] = 336460,
  [SMALL_STATE(10881)] = 336491,
  [SMALL_STATE(10882)] = 336522,
  [SMALL_STATE(10883)] = 336553,
  [SMALL_STATE(10884)] = 336584,
  [SMALL_STATE(10885)] = 336615,
  [SMALL_STATE(10886)] = 336646,
  [SMALL_STATE(10887)] = 336677,
  [SMALL_STATE(10888)] = 336708,
  [SMALL_STATE(10889)] = 336739,
  [SMALL_STATE(10890)] = 336770,
  [SMALL_STATE(10891)] = 336801,
  [SMALL_STATE(10892)] = 336832,
  [SMALL_STATE(10893)] = 336863,
  [SMALL_STATE(10894)] = 336894,
  [SMALL_STATE(10895)] = 336925,
  [SMALL_STATE(10896)] = 336956,
  [SMALL_STATE(10897)] = 336987,
  [SMALL_STATE(10898)] = 337018,
  [SMALL_STATE(10899)] = 337049,
  [SMALL_STATE(10900)] = 337080,
  [SMALL_STATE(10901)] = 337111,
  [SMALL_STATE(10902)] = 337142,
  [SMALL_STATE(10903)] = 337173,
  [SMALL_STATE(10904)] = 337204,
  [SMALL_STATE(10905)] = 337235,
  [SMALL_STATE(10906)] = 337266,
  [SMALL_STATE(10907)] = 337297,
  [SMALL_STATE(10908)] = 337328,
  [SMALL_STATE(10909)] = 337359,
  [SMALL_STATE(10910)] = 337390,
  [SMALL_STATE(10911)] = 337421,
  [SMALL_STATE(10912)] = 337452,
  [SMALL_STATE(10913)] = 337483,
  [SMALL_STATE(10914)] = 337514,
  [SMALL_STATE(10915)] = 337545,
  [SMALL_STATE(10916)] = 337576,
  [SMALL_STATE(10917)] = 337607,
  [SMALL_STATE(10918)] = 337638,
  [SMALL_STATE(10919)] = 337669,
  [SMALL_STATE(10920)] = 337700,
  [SMALL_STATE(10921)] = 337731,
  [SMALL_STATE(10922)] = 337762,
  [SMALL_STATE(10923)] = 337793,
  [SMALL_STATE(10924)] = 337824,
  [SMALL_STATE(10925)] = 337855,
  [SMALL_STATE(10926)] = 337886,
  [SMALL_STATE(10927)] = 337917,
  [SMALL_STATE(10928)] = 337948,
  [SMALL_STATE(10929)] = 337979,
  [SMALL_STATE(10930)] = 338010,
  [SMALL_STATE(10931)] = 338041,
  [SMALL_STATE(10932)] = 338072,
  [SMALL_STATE(10933)] = 338103,
  [SMALL_STATE(10934)] = 338134,
  [SMALL_STATE(10935)] = 338165,
  [SMALL_STATE(10936)] = 338196,
  [SMALL_STATE(10937)] = 338227,
  [SMALL_STATE(10938)] = 338258,
  [SMALL_STATE(10939)] = 338289,
  [SMALL_STATE(10940)] = 338320,
  [SMALL_STATE(10941)] = 338351,
  [SMALL_STATE(10942)] = 338382,
  [SMALL_STATE(10943)] = 338413,
  [SMALL_STATE(10944)] = 338444,
  [SMALL_STATE(10945)] = 338475,
  [SMALL_STATE(10946)] = 338506,
  [SMALL_STATE(10947)] = 338537,
  [SMALL_STATE(10948)] = 338568,
  [SMALL_STATE(10949)] = 338599,
  [SMALL_STATE(10950)] = 338630,
  [SMALL_STATE(10951)] = 338661,
  [SMALL_STATE(10952)] = 338692,
  [SMALL_STATE(10953)] = 338723,
  [SMALL_STATE(10954)] = 338754,
  [SMALL_STATE(10955)] = 338785,
  [SMALL_STATE(10956)] = 338816,
  [SMALL_STATE(10957)] = 338847,
  [SMALL_STATE(10958)] = 338878,
  [SMALL_STATE(10959)] = 338909,
  [SMALL_STATE(10960)] = 338940,
  [SMALL_STATE(10961)] = 338971,
  [SMALL_STATE(10962)] = 339002,
  [SMALL_STATE(10963)] = 339033,
  [SMALL_STATE(10964)] = 339064,
  [SMALL_STATE(10965)] = 339095,
  [SMALL_STATE(10966)] = 339126,
  [SMALL_STATE(10967)] = 339157,
  [SMALL_STATE(10968)] = 339188,
  [SMALL_STATE(10969)] = 339219,
  [SMALL_STATE(10970)] = 339250,
  [SMALL_STATE(10971)] = 339281,
  [SMALL_STATE(10972)] = 339312,
  [SMALL_STATE(10973)] = 339343,
  [SMALL_STATE(10974)] = 339374,
  [SMALL_STATE(10975)] = 339405,
  [SMALL_STATE(10976)] = 339436,
  [SMALL_STATE(10977)] = 339467,
  [SMALL_STATE(10978)] = 339498,
  [SMALL_STATE(10979)] = 339529,
  [SMALL_STATE(10980)] = 339560,
  [SMALL_STATE(10981)] = 339591,
  [SMALL_STATE(10982)] = 339622,
  [SMALL_STATE(10983)] = 339653,
  [SMALL_STATE(10984)] = 339684,
  [SMALL_STATE(10985)] = 339715,
  [SMALL_STATE(10986)] = 339746,
  [SMALL_STATE(10987)] = 339777,
  [SMALL_STATE(10988)] = 339808,
  [SMALL_STATE(10989)] = 339839,
  [SMALL_STATE(10990)] = 339870,
  [SMALL_STATE(10991)] = 339901,
  [SMALL_STATE(10992)] = 339932,
  [SMALL_STATE(10993)] = 339963,
  [SMALL_STATE(10994)] = 339994,
  [SMALL_STATE(10995)] = 340025,
  [SMALL_STATE(10996)] = 340056,
  [SMALL_STATE(10997)] = 340087,
  [SMALL_STATE(10998)] = 340118,
  [SMALL_STATE(10999)] = 340149,
  [SMALL_STATE(11000)] = 340180,
  [SMALL_STATE(11001)] = 340211,
  [SMALL_STATE(11002)] = 340242,
  [SMALL_STATE(11003)] = 340273,
  [SMALL_STATE(11004)] = 340304,
  [SMALL_STATE(11005)] = 340335,
  [SMALL_STATE(11006)] = 340366,
  [SMALL_STATE(11007)] = 340397,
  [SMALL_STATE(11008)] = 340428,
  [SMALL_STATE(11009)] = 340459,
  [SMALL_STATE(11010)] = 340490,
  [SMALL_STATE(11011)] = 340521,
  [SMALL_STATE(11012)] = 340552,
  [SMALL_STATE(11013)] = 340583,
  [SMALL_STATE(11014)] = 340614,
  [SMALL_STATE(11015)] = 340645,
  [SMALL_STATE(11016)] = 340676,
  [SMALL_STATE(11017)] = 340707,
  [SMALL_STATE(11018)] = 340738,
  [SMALL_STATE(11019)] = 340769,
  [SMALL_STATE(11020)] = 340800,
  [SMALL_STATE(11021)] = 340831,
  [SMALL_STATE(11022)] = 340862,
  [SMALL_STATE(11023)] = 340893,
  [SMALL_STATE(11024)] = 340924,
  [SMALL_STATE(11025)] = 340955,
  [SMALL_STATE(11026)] = 340986,
  [SMALL_STATE(11027)] = 341017,
  [SMALL_STATE(11028)] = 341048,
  [SMALL_STATE(11029)] = 341079,
  [SMALL_STATE(11030)] = 341110,
  [SMALL_STATE(11031)] = 341141,
  [SMALL_STATE(11032)] = 341172,
  [SMALL_STATE(11033)] = 341203,
  [SMALL_STATE(11034)] = 341234,
  [SMALL_STATE(11035)] = 341265,
  [SMALL_STATE(11036)] = 341296,
  [SMALL_STATE(11037)] = 341327,
  [SMALL_STATE(11038)] = 341358,
  [SMALL_STATE(11039)] = 341389,
  [SMALL_STATE(11040)] = 341420,
  [SMALL_STATE(11041)] = 341451,
  [SMALL_STATE(11042)] = 341482,
  [SMALL_STATE(11043)] = 341513,
  [SMALL_STATE(11044)] = 341544,
  [SMALL_STATE(11045)] = 341575,
  [SMALL_STATE(11046)] = 341606,
  [SMALL_STATE(11047)] = 341637,
  [SMALL_STATE(11048)] = 341668,
  [SMALL_STATE(11049)] = 341699,
  [SMALL_STATE(11050)] = 341730,
  [SMALL_STATE(11051)] = 341761,
  [SMALL_STATE(11052)] = 341792,
  [SMALL_STATE(11053)] = 341823,
  [SMALL_STATE(11054)] = 341854,
  [SMALL_STATE(11055)] = 341885,
  [SMALL_STATE(11056)] = 341916,
  [SMALL_STATE(11057)] = 341947,
  [SMALL_STATE(11058)] = 341978,
  [SMALL_STATE(11059)] = 342009,
  [SMALL_STATE(11060)] = 342040,
  [SMALL_STATE(11061)] = 342071,
  [SMALL_STATE(11062)] = 342102,
  [SMALL_STATE(11063)] = 342133,
  [SMALL_STATE(11064)] = 342164,
  [SMALL_STATE(11065)] = 342195,
  [SMALL_STATE(11066)] = 342226,
  [SMALL_STATE(11067)] = 342257,
  [SMALL_STATE(11068)] = 342288,
  [SMALL_STATE(11069)] = 342319,
  [SMALL_STATE(11070)] = 342350,
  [SMALL_STATE(11071)] = 342381,
  [SMALL_STATE(11072)] = 342412,
  [SMALL_STATE(11073)] = 342443,
  [SMALL_STATE(11074)] = 342474,
  [SMALL_STATE(11075)] = 342505,
  [SMALL_STATE(11076)] = 342536,
  [SMALL_STATE(11077)] = 342567,
  [SMALL_STATE(11078)] = 342598,
  [SMALL_STATE(11079)] = 342629,
  [SMALL_STATE(11080)] = 342660,
  [SMALL_STATE(11081)] = 342691,
  [SMALL_STATE(11082)] = 342722,
  [SMALL_STATE(11083)] = 342753,
  [SMALL_STATE(11084)] = 342784,
  [SMALL_STATE(11085)] = 342815,
  [SMALL_STATE(11086)] = 342846,
  [SMALL_STATE(11087)] = 342877,
  [SMALL_STATE(11088)] = 342908,
  [SMALL_STATE(11089)] = 342939,
  [SMALL_STATE(11090)] = 342970,
  [SMALL_STATE(11091)] = 343001,
  [SMALL_STATE(11092)] = 343032,
  [SMALL_STATE(11093)] = 343063,
  [SMALL_STATE(11094)] = 343094,
  [SMALL_STATE(11095)] = 343125,
  [SMALL_STATE(11096)] = 343156,
  [SMALL_STATE(11097)] = 343187,
  [SMALL_STATE(11098)] = 343218,
  [SMALL_STATE(11099)] = 343249,
  [SMALL_STATE(11100)] = 343280,
  [SMALL_STATE(11101)] = 343311,
  [SMALL_STATE(11102)] = 343342,
  [SMALL_STATE(11103)] = 343373,
  [SMALL_STATE(11104)] = 343404,
  [SMALL_STATE(11105)] = 343435,
  [SMALL_STATE(11106)] = 343466,
  [SMALL_STATE(11107)] = 343497,
  [SMALL_STATE(11108)] = 343528,
  [SMALL_STATE(11109)] = 343559,
  [SMALL_STATE(11110)] = 343590,
  [SMALL_STATE(11111)] = 343621,
  [SMALL_STATE(11112)] = 343652,
  [SMALL_STATE(11113)] = 343683,
  [SMALL_STATE(11114)] = 343714,
  [SMALL_STATE(11115)] = 343745,
  [SMALL_STATE(11116)] = 343776,
  [SMALL_STATE(11117)] = 343807,
  [SMALL_STATE(11118)] = 343838,
  [SMALL_STATE(11119)] = 343869,
  [SMALL_STATE(11120)] = 343900,
  [SMALL_STATE(11121)] = 343931,
  [SMALL_STATE(11122)] = 343962,
  [SMALL_STATE(11123)] = 343993,
  [SMALL_STATE(11124)] = 344024,
  [SMALL_STATE(11125)] = 344055,
  [SMALL_STATE(11126)] = 344086,
  [SMALL_STATE(11127)] = 344117,
  [SMALL_STATE(11128)] = 344148,
  [SMALL_STATE(11129)] = 344179,
  [SMALL_STATE(11130)] = 344210,
  [SMALL_STATE(11131)] = 344241,
  [SMALL_STATE(11132)] = 344272,
  [SMALL_STATE(11133)] = 344303,
  [SMALL_STATE(11134)] = 344334,
  [SMALL_STATE(11135)] = 344365,
  [SMALL_STATE(11136)] = 344396,
  [SMALL_STATE(11137)] = 344427,
  [SMALL_STATE(11138)] = 344458,
  [SMALL_STATE(11139)] = 344489,
  [SMALL_STATE(11140)] = 344520,
  [SMALL_STATE(11141)] = 344551,
  [SMALL_STATE(11142)] = 344582,
  [SMALL_STATE(11143)] = 344613,
  [SMALL_STATE(11144)] = 344644,
  [SMALL_STATE(11145)] = 344675,
  [SMALL_STATE(11146)] = 344706,
  [SMALL_STATE(11147)] = 344737,
  [SMALL_STATE(11148)] = 344768,
  [SMALL_STATE(11149)] = 344799,
  [SMALL_STATE(11150)] = 344830,
  [SMALL_STATE(11151)] = 344861,
  [SMALL_STATE(11152)] = 344892,
  [SMALL_STATE(11153)] = 344923,
  [SMALL_STATE(11154)] = 344954,
  [SMALL_STATE(11155)] = 344985,
  [SMALL_STATE(11156)] = 345016,
  [SMALL_STATE(11157)] = 345047,
  [SMALL_STATE(11158)] = 345078,
  [SMALL_STATE(11159)] = 345109,
  [SMALL_STATE(11160)] = 345140,
  [SMALL_STATE(11161)] = 345171,
  [SMALL_STATE(11162)] = 345202,
  [SMALL_STATE(11163)] = 345233,
  [SMALL_STATE(11164)] = 345264,
  [SMALL_STATE(11165)] = 345295,
  [SMALL_STATE(11166)] = 345326,
  [SMALL_STATE(11167)] = 345357,
  [SMALL_STATE(11168)] = 345388,
  [SMALL_STATE(11169)] = 345419,
  [SMALL_STATE(11170)] = 345450,
  [SMALL_STATE(11171)] = 345481,
  [SMALL_STATE(11172)] = 345512,
  [SMALL_STATE(11173)] = 345543,
  [SMALL_STATE(11174)] = 345574,
  [SMALL_STATE(11175)] = 345605,
  [SMALL_STATE(11176)] = 345636,
  [SMALL_STATE(11177)] = 345667,
  [SMALL_STATE(11178)] = 345698,
  [SMALL_STATE(11179)] = 345729,
  [SMALL_STATE(11180)] = 345760,
  [SMALL_STATE(11181)] = 345791,
  [SMALL_STATE(11182)] = 345822,
  [SMALL_STATE(11183)] = 345853,
  [SMALL_STATE(11184)] = 345884,
  [SMALL_STATE(11185)] = 345915,
  [SMALL_STATE(11186)] = 345946,
  [SMALL_STATE(11187)] = 345977,
  [SMALL_STATE(11188)] = 346008,
  [SMALL_STATE(11189)] = 346039,
  [SMALL_STATE(11190)] = 346070,
  [SMALL_STATE(11191)] = 346101,
  [SMALL_STATE(11192)] = 346132,
  [SMALL_STATE(11193)] = 346163,
  [SMALL_STATE(11194)] = 346194,
  [SMALL_STATE(11195)] = 346225,
  [SMALL_STATE(11196)] = 346256,
  [SMALL_STATE(11197)] = 346287,
  [SMALL_STATE(11198)] = 346318,
  [SMALL_STATE(11199)] = 346349,
  [SMALL_STATE(11200)] = 346380,
  [SMALL_STATE(11201)] = 346411,
  [SMALL_STATE(11202)] = 346442,
  [SMALL_STATE(11203)] = 346473,
  [SMALL_STATE(11204)] = 346504,
  [SMALL_STATE(11205)] = 346535,
  [SMALL_STATE(11206)] = 346566,
  [SMALL_STATE(11207)] = 346597,
  [SMALL_STATE(11208)] = 346628,
  [SMALL_STATE(11209)] = 346659,
  [SMALL_STATE(11210)] = 346690,
  [SMALL_STATE(11211)] = 346721,
  [SMALL_STATE(11212)] = 346752,
  [SMALL_STATE(11213)] = 346783,
  [SMALL_STATE(11214)] = 346814,
  [SMALL_STATE(11215)] = 346845,
  [SMALL_STATE(11216)] = 346876,
  [SMALL_STATE(11217)] = 346907,
  [SMALL_STATE(11218)] = 346938,
  [SMALL_STATE(11219)] = 346969,
  [SMALL_STATE(11220)] = 347000,
  [SMALL_STATE(11221)] = 347031,
  [SMALL_STATE(11222)] = 347062,
  [SMALL_STATE(11223)] = 347093,
  [SMALL_STATE(11224)] = 347124,
  [SMALL_STATE(11225)] = 347155,
  [SMALL_STATE(11226)] = 347186,
  [SMALL_STATE(11227)] = 347217,
  [SMALL_STATE(11228)] = 347248,
  [SMALL_STATE(11229)] = 347279,
  [SMALL_STATE(11230)] = 347310,
  [SMALL_STATE(11231)] = 347341,
  [SMALL_STATE(11232)] = 347372,
  [SMALL_STATE(11233)] = 347403,
  [SMALL_STATE(11234)] = 347434,
  [SMALL_STATE(11235)] = 347465,
  [SMALL_STATE(11236)] = 347496,
  [SMALL_STATE(11237)] = 347527,
  [SMALL_STATE(11238)] = 347558,
  [SMALL_STATE(11239)] = 347589,
  [SMALL_STATE(11240)] = 347620,
  [SMALL_STATE(11241)] = 347651,
  [SMALL_STATE(11242)] = 347682,
  [SMALL_STATE(11243)] = 347713,
  [SMALL_STATE(11244)] = 347744,
  [SMALL_STATE(11245)] = 347775,
  [SMALL_STATE(11246)] = 347806,
  [SMALL_STATE(11247)] = 347837,
  [SMALL_STATE(11248)] = 347868,
  [SMALL_STATE(11249)] = 347899,
  [SMALL_STATE(11250)] = 347930,
  [SMALL_STATE(11251)] = 347961,
  [SMALL_STATE(11252)] = 347992,
  [SMALL_STATE(11253)] = 348023,
  [SMALL_STATE(11254)] = 348054,
  [SMALL_STATE(11255)] = 348085,
  [SMALL_STATE(11256)] = 348116,
  [SMALL_STATE(11257)] = 348147,
  [SMALL_STATE(11258)] = 348178,
  [SMALL_STATE(11259)] = 348209,
  [SMALL_STATE(11260)] = 348240,
  [SMALL_STATE(11261)] = 348271,
  [SMALL_STATE(11262)] = 348302,
  [SMALL_STATE(11263)] = 348333,
  [SMALL_STATE(11264)] = 348364,
  [SMALL_STATE(11265)] = 348395,
  [SMALL_STATE(11266)] = 348426,
  [SMALL_STATE(11267)] = 348457,
  [SMALL_STATE(11268)] = 348488,
  [SMALL_STATE(11269)] = 348519,
  [SMALL_STATE(11270)] = 348550,
  [SMALL_STATE(11271)] = 348581,
  [SMALL_STATE(11272)] = 348612,
  [SMALL_STATE(11273)] = 348643,
  [SMALL_STATE(11274)] = 348674,
  [SMALL_STATE(11275)] = 348705,
  [SMALL_STATE(11276)] = 348736,
  [SMALL_STATE(11277)] = 348767,
  [SMALL_STATE(11278)] = 348798,
  [SMALL_STATE(11279)] = 348829,
  [SMALL_STATE(11280)] = 348860,
  [SMALL_STATE(11281)] = 348891,
  [SMALL_STATE(11282)] = 348922,
  [SMALL_STATE(11283)] = 348953,
  [SMALL_STATE(11284)] = 348984,
  [SMALL_STATE(11285)] = 349015,
  [SMALL_STATE(11286)] = 349046,
  [SMALL_STATE(11287)] = 349077,
  [SMALL_STATE(11288)] = 349108,
  [SMALL_STATE(11289)] = 349139,
  [SMALL_STATE(11290)] = 349170,
  [SMALL_STATE(11291)] = 349201,
  [SMALL_STATE(11292)] = 349232,
  [SMALL_STATE(11293)] = 349263,
  [SMALL_STATE(11294)] = 349294,
  [SMALL_STATE(11295)] = 349325,
  [SMALL_STATE(11296)] = 349356,
  [SMALL_STATE(11297)] = 349387,
  [SMALL_STATE(11298)] = 349418,
  [SMALL_STATE(11299)] = 349449,
  [SMALL_STATE(11300)] = 349480,
  [SMALL_STATE(11301)] = 349511,
  [SMALL_STATE(11302)] = 349542,
  [SMALL_STATE(11303)] = 349573,
  [SMALL_STATE(11304)] = 349604,
  [SMALL_STATE(11305)] = 349635,
  [SMALL_STATE(11306)] = 349666,
  [SMALL_STATE(11307)] = 349697,
  [SMALL_STATE(11308)] = 349728,
  [SMALL_STATE(11309)] = 349759,
  [SMALL_STATE(11310)] = 349790,
  [SMALL_STATE(11311)] = 349821,
  [SMALL_STATE(11312)] = 349852,
  [SMALL_STATE(11313)] = 349883,
  [SMALL_STATE(11314)] = 349914,
  [SMALL_STATE(11315)] = 349945,
  [SMALL_STATE(11316)] = 349976,
  [SMALL_STATE(11317)] = 350007,
  [SMALL_STATE(11318)] = 350038,
  [SMALL_STATE(11319)] = 350069,
  [SMALL_STATE(11320)] = 350100,
  [SMALL_STATE(11321)] = 350131,
  [SMALL_STATE(11322)] = 350162,
  [SMALL_STATE(11323)] = 350193,
  [SMALL_STATE(11324)] = 350224,
  [SMALL_STATE(11325)] = 350255,
  [SMALL_STATE(11326)] = 350286,
  [SMALL_STATE(11327)] = 350317,
  [SMALL_STATE(11328)] = 350348,
  [SMALL_STATE(11329)] = 350379,
  [SMALL_STATE(11330)] = 350410,
  [SMALL_STATE(11331)] = 350441,
  [SMALL_STATE(11332)] = 350472,
  [SMALL_STATE(11333)] = 350503,
  [SMALL_STATE(11334)] = 350534,
  [SMALL_STATE(11335)] = 350565,
  [SMALL_STATE(11336)] = 350596,
  [SMALL_STATE(11337)] = 350627,
  [SMALL_STATE(11338)] = 350658,
  [SMALL_STATE(11339)] = 350689,
  [SMALL_STATE(11340)] = 350720,
  [SMALL_STATE(11341)] = 350751,
  [SMALL_STATE(11342)] = 350782,
  [SMALL_STATE(11343)] = 350813,
  [SMALL_STATE(11344)] = 350844,
  [SMALL_STATE(11345)] = 350875,
  [SMALL_STATE(11346)] = 350906,
  [SMALL_STATE(11347)] = 350937,
  [SMALL_STATE(11348)] = 350968,
  [SMALL_STATE(11349)] = 350999,
  [SMALL_STATE(11350)] = 351030,
  [SMALL_STATE(11351)] = 351061,
  [SMALL_STATE(11352)] = 351092,
  [SMALL_STATE(11353)] = 351123,
  [SMALL_STATE(11354)] = 351154,
  [SMALL_STATE(11355)] = 351185,
  [SMALL_STATE(11356)] = 351216,
  [SMALL_STATE(11357)] = 351247,
  [SMALL_STATE(11358)] = 351278,
  [SMALL_STATE(11359)] = 351309,
  [SMALL_STATE(11360)] = 351340,
  [SMALL_STATE(11361)] = 351371,
  [SMALL_STATE(11362)] = 351402,
  [SMALL_STATE(11363)] = 351433,
  [SMALL_STATE(11364)] = 351464,
  [SMALL_STATE(11365)] = 351495,
  [SMALL_STATE(11366)] = 351526,
  [SMALL_STATE(11367)] = 351557,
  [SMALL_STATE(11368)] = 351588,
  [SMALL_STATE(11369)] = 351619,
  [SMALL_STATE(11370)] = 351650,
  [SMALL_STATE(11371)] = 351681,
  [SMALL_STATE(11372)] = 351712,
  [SMALL_STATE(11373)] = 351743,
  [SMALL_STATE(11374)] = 351774,
  [SMALL_STATE(11375)] = 351805,
  [SMALL_STATE(11376)] = 351836,
  [SMALL_STATE(11377)] = 351867,
  [SMALL_STATE(11378)] = 351898,
  [SMALL_STATE(11379)] = 351929,
  [SMALL_STATE(11380)] = 351960,
  [SMALL_STATE(11381)] = 351991,
  [SMALL_STATE(11382)] = 352022,
  [SMALL_STATE(11383)] = 352053,
  [SMALL_STATE(11384)] = 352084,
  [SMALL_STATE(11385)] = 352115,
  [SMALL_STATE(11386)] = 352146,
  [SMALL_STATE(11387)] = 352177,
  [SMALL_STATE(11388)] = 352208,
  [SMALL_STATE(11389)] = 352239,
  [SMALL_STATE(11390)] = 352270,
  [SMALL_STATE(11391)] = 352301,
  [SMALL_STATE(11392)] = 352332,
  [SMALL_STATE(11393)] = 352363,
  [SMALL_STATE(11394)] = 352394,
  [SMALL_STATE(11395)] = 352425,
  [SMALL_STATE(11396)] = 352456,
  [SMALL_STATE(11397)] = 352487,
  [SMALL_STATE(11398)] = 352518,
  [SMALL_STATE(11399)] = 352549,
  [SMALL_STATE(11400)] = 352580,
  [SMALL_STATE(11401)] = 352611,
  [SMALL_STATE(11402)] = 352642,
  [SMALL_STATE(11403)] = 352673,
  [SMALL_STATE(11404)] = 352704,
  [SMALL_STATE(11405)] = 352735,
  [SMALL_STATE(11406)] = 352766,
  [SMALL_STATE(11407)] = 352797,
  [SMALL_STATE(11408)] = 352828,
  [SMALL_STATE(11409)] = 352859,
  [SMALL_STATE(11410)] = 352890,
  [SMALL_STATE(11411)] = 352921,
  [SMALL_STATE(11412)] = 352952,
  [SMALL_STATE(11413)] = 352983,
  [SMALL_STATE(11414)] = 353014,
  [SMALL_STATE(11415)] = 353045,
  [SMALL_STATE(11416)] = 353076,
  [SMALL_STATE(11417)] = 353107,
  [SMALL_STATE(11418)] = 353138,
  [SMALL_STATE(11419)] = 353169,
  [SMALL_STATE(11420)] = 353200,
  [SMALL_STATE(11421)] = 353231,
  [SMALL_STATE(11422)] = 353262,
  [SMALL_STATE(11423)] = 353293,
  [SMALL_STATE(11424)] = 353324,
  [SMALL_STATE(11425)] = 353355,
  [SMALL_STATE(11426)] = 353386,
  [SMALL_STATE(11427)] = 353417,
  [SMALL_STATE(11428)] = 353448,
  [SMALL_STATE(11429)] = 353479,
  [SMALL_STATE(11430)] = 353510,
  [SMALL_STATE(11431)] = 353541,
  [SMALL_STATE(11432)] = 353572,
  [SMALL_STATE(11433)] = 353603,
  [SMALL_STATE(11434)] = 353634,
  [SMALL_STATE(11435)] = 353665,
  [SMALL_STATE(11436)] = 353696,
  [SMALL_STATE(11437)] = 353727,
  [SMALL_STATE(11438)] = 353758,
  [SMALL_STATE(11439)] = 353789,
  [SMALL_STATE(11440)] = 353820,
  [SMALL_STATE(11441)] = 353851,
  [SMALL_STATE(11442)] = 353882,
  [SMALL_STATE(11443)] = 353913,
  [SMALL_STATE(11444)] = 353944,
  [SMALL_STATE(11445)] = 353975,
  [SMALL_STATE(11446)] = 354006,
  [SMALL_STATE(11447)] = 354037,
  [SMALL_STATE(11448)] = 354068,
  [SMALL_STATE(11449)] = 354099,
  [SMALL_STATE(11450)] = 354130,
  [SMALL_STATE(11451)] = 354161,
  [SMALL_STATE(11452)] = 354192,
  [SMALL_STATE(11453)] = 354223,
  [SMALL_STATE(11454)] = 354254,
  [SMALL_STATE(11455)] = 354285,
  [SMALL_STATE(11456)] = 354316,
  [SMALL_STATE(11457)] = 354347,
  [SMALL_STATE(11458)] = 354378,
  [SMALL_STATE(11459)] = 354409,
  [SMALL_STATE(11460)] = 354440,
  [SMALL_STATE(11461)] = 354471,
  [SMALL_STATE(11462)] = 354502,
  [SMALL_STATE(11463)] = 354533,
  [SMALL_STATE(11464)] = 354564,
  [SMALL_STATE(11465)] = 354595,
  [SMALL_STATE(11466)] = 354626,
  [SMALL_STATE(11467)] = 354657,
  [SMALL_STATE(11468)] = 354688,
  [SMALL_STATE(11469)] = 354719,
  [SMALL_STATE(11470)] = 354750,
  [SMALL_STATE(11471)] = 354781,
  [SMALL_STATE(11472)] = 354812,
  [SMALL_STATE(11473)] = 354843,
  [SMALL_STATE(11474)] = 354874,
  [SMALL_STATE(11475)] = 354905,
  [SMALL_STATE(11476)] = 354936,
  [SMALL_STATE(11477)] = 354967,
  [SMALL_STATE(11478)] = 354998,
  [SMALL_STATE(11479)] = 355029,
  [SMALL_STATE(11480)] = 355060,
  [SMALL_STATE(11481)] = 355091,
  [SMALL_STATE(11482)] = 355122,
  [SMALL_STATE(11483)] = 355153,
  [SMALL_STATE(11484)] = 355184,
  [SMALL_STATE(11485)] = 355215,
  [SMALL_STATE(11486)] = 355246,
  [SMALL_STATE(11487)] = 355277,
  [SMALL_STATE(11488)] = 355308,
  [SMALL_STATE(11489)] = 355339,
  [SMALL_STATE(11490)] = 355370,
  [SMALL_STATE(11491)] = 355401,
  [SMALL_STATE(11492)] = 355432,
  [SMALL_STATE(11493)] = 355463,
  [SMALL_STATE(11494)] = 355494,
  [SMALL_STATE(11495)] = 355525,
  [SMALL_STATE(11496)] = 355556,
  [SMALL_STATE(11497)] = 355587,
  [SMALL_STATE(11498)] = 355618,
  [SMALL_STATE(11499)] = 355649,
  [SMALL_STATE(11500)] = 355680,
  [SMALL_STATE(11501)] = 355711,
  [SMALL_STATE(11502)] = 355742,
  [SMALL_STATE(11503)] = 355773,
  [SMALL_STATE(11504)] = 355804,
  [SMALL_STATE(11505)] = 355835,
  [SMALL_STATE(11506)] = 355866,
  [SMALL_STATE(11507)] = 355897,
  [SMALL_STATE(11508)] = 355928,
  [SMALL_STATE(11509)] = 355959,
  [SMALL_STATE(11510)] = 355990,
  [SMALL_STATE(11511)] = 356021,
  [SMALL_STATE(11512)] = 356052,
  [SMALL_STATE(11513)] = 356083,
  [SMALL_STATE(11514)] = 356114,
  [SMALL_STATE(11515)] = 356145,
  [SMALL_STATE(11516)] = 356176,
  [SMALL_STATE(11517)] = 356207,
  [SMALL_STATE(11518)] = 356238,
  [SMALL_STATE(11519)] = 356269,
  [SMALL_STATE(11520)] = 356300,
  [SMALL_STATE(11521)] = 356331,
  [SMALL_STATE(11522)] = 356362,
  [SMALL_STATE(11523)] = 356393,
  [SMALL_STATE(11524)] = 356424,
  [SMALL_STATE(11525)] = 356455,
  [SMALL_STATE(11526)] = 356486,
  [SMALL_STATE(11527)] = 356517,
  [SMALL_STATE(11528)] = 356548,
  [SMALL_STATE(11529)] = 356579,
  [SMALL_STATE(11530)] = 356610,
  [SMALL_STATE(11531)] = 356641,
  [SMALL_STATE(11532)] = 356672,
  [SMALL_STATE(11533)] = 356703,
  [SMALL_STATE(11534)] = 356734,
  [SMALL_STATE(11535)] = 356765,
  [SMALL_STATE(11536)] = 356796,
  [SMALL_STATE(11537)] = 356827,
  [SMALL_STATE(11538)] = 356858,
  [SMALL_STATE(11539)] = 356889,
  [SMALL_STATE(11540)] = 356920,
  [SMALL_STATE(11541)] = 356951,
  [SMALL_STATE(11542)] = 356982,
  [SMALL_STATE(11543)] = 357013,
  [SMALL_STATE(11544)] = 357044,
  [SMALL_STATE(11545)] = 357075,
  [SMALL_STATE(11546)] = 357106,
  [SMALL_STATE(11547)] = 357137,
  [SMALL_STATE(11548)] = 357168,
  [SMALL_STATE(11549)] = 357199,
  [SMALL_STATE(11550)] = 357230,
  [SMALL_STATE(11551)] = 357261,
  [SMALL_STATE(11552)] = 357292,
  [SMALL_STATE(11553)] = 357323,
  [SMALL_STATE(11554)] = 357354,
  [SMALL_STATE(11555)] = 357385,
  [SMALL_STATE(11556)] = 357416,
  [SMALL_STATE(11557)] = 357447,
  [SMALL_STATE(11558)] = 357478,
  [SMALL_STATE(11559)] = 357509,
  [SMALL_STATE(11560)] = 357540,
  [SMALL_STATE(11561)] = 357571,
  [SMALL_STATE(11562)] = 357602,
  [SMALL_STATE(11563)] = 357633,
  [SMALL_STATE(11564)] = 357664,
  [SMALL_STATE(11565)] = 357695,
  [SMALL_STATE(11566)] = 357726,
  [SMALL_STATE(11567)] = 357757,
  [SMALL_STATE(11568)] = 357788,
  [SMALL_STATE(11569)] = 357819,
  [SMALL_STATE(11570)] = 357850,
  [SMALL_STATE(11571)] = 357881,
  [SMALL_STATE(11572)] = 357912,
  [SMALL_STATE(11573)] = 357943,
  [SMALL_STATE(11574)] = 357974,
  [SMALL_STATE(11575)] = 358005,
  [SMALL_STATE(11576)] = 358036,
  [SMALL_STATE(11577)] = 358067,
  [SMALL_STATE(11578)] = 358098,
  [SMALL_STATE(11579)] = 358129,
  [SMALL_STATE(11580)] = 358160,
  [SMALL_STATE(11581)] = 358191,
  [SMALL_STATE(11582)] = 358222,
  [SMALL_STATE(11583)] = 358253,
  [SMALL_STATE(11584)] = 358284,
  [SMALL_STATE(11585)] = 358315,
  [SMALL_STATE(11586)] = 358346,
  [SMALL_STATE(11587)] = 358377,
  [SMALL_STATE(11588)] = 358408,
  [SMALL_STATE(11589)] = 358439,
  [SMALL_STATE(11590)] = 358470,
  [SMALL_STATE(11591)] = 358501,
  [SMALL_STATE(11592)] = 358532,
  [SMALL_STATE(11593)] = 358563,
  [SMALL_STATE(11594)] = 358594,
  [SMALL_STATE(11595)] = 358625,
  [SMALL_STATE(11596)] = 358656,
  [SMALL_STATE(11597)] = 358687,
  [SMALL_STATE(11598)] = 358718,
  [SMALL_STATE(11599)] = 358749,
  [SMALL_STATE(11600)] = 358780,
  [SMALL_STATE(11601)] = 358811,
  [SMALL_STATE(11602)] = 358842,
  [SMALL_STATE(11603)] = 358873,
  [SMALL_STATE(11604)] = 358904,
  [SMALL_STATE(11605)] = 358935,
  [SMALL_STATE(11606)] = 358966,
  [SMALL_STATE(11607)] = 358997,
  [SMALL_STATE(11608)] = 359028,
  [SMALL_STATE(11609)] = 359059,
  [SMALL_STATE(11610)] = 359090,
  [SMALL_STATE(11611)] = 359121,
  [SMALL_STATE(11612)] = 359152,
  [SMALL_STATE(11613)] = 359183,
  [SMALL_STATE(11614)] = 359214,
  [SMALL_STATE(11615)] = 359245,
  [SMALL_STATE(11616)] = 359276,
  [SMALL_STATE(11617)] = 359307,
  [SMALL_STATE(11618)] = 359338,
  [SMALL_STATE(11619)] = 359369,
  [SMALL_STATE(11620)] = 359400,
  [SMALL_STATE(11621)] = 359431,
  [SMALL_STATE(11622)] = 359462,
  [SMALL_STATE(11623)] = 359493,
  [SMALL_STATE(11624)] = 359524,
  [SMALL_STATE(11625)] = 359555,
  [SMALL_STATE(11626)] = 359586,
  [SMALL_STATE(11627)] = 359617,
  [SMALL_STATE(11628)] = 359648,
  [SMALL_STATE(11629)] = 359679,
  [SMALL_STATE(11630)] = 359710,
  [SMALL_STATE(11631)] = 359741,
  [SMALL_STATE(11632)] = 359772,
  [SMALL_STATE(11633)] = 359803,
  [SMALL_STATE(11634)] = 359834,
  [SMALL_STATE(11635)] = 359865,
  [SMALL_STATE(11636)] = 359896,
  [SMALL_STATE(11637)] = 359927,
  [SMALL_STATE(11638)] = 359958,
  [SMALL_STATE(11639)] = 359989,
  [SMALL_STATE(11640)] = 360020,
  [SMALL_STATE(11641)] = 360051,
  [SMALL_STATE(11642)] = 360082,
  [SMALL_STATE(11643)] = 360113,
  [SMALL_STATE(11644)] = 360144,
  [SMALL_STATE(11645)] = 360175,
  [SMALL_STATE(11646)] = 360206,
  [SMALL_STATE(11647)] = 360237,
  [SMALL_STATE(11648)] = 360268,
  [SMALL_STATE(11649)] = 360299,
  [SMALL_STATE(11650)] = 360330,
  [SMALL_STATE(11651)] = 360361,
  [SMALL_STATE(11652)] = 360392,
  [SMALL_STATE(11653)] = 360423,
  [SMALL_STATE(11654)] = 360454,
  [SMALL_STATE(11655)] = 360485,
  [SMALL_STATE(11656)] = 360514,
  [SMALL_STATE(11657)] = 360545,
  [SMALL_STATE(11658)] = 360576,
  [SMALL_STATE(11659)] = 360607,
  [SMALL_STATE(11660)] = 360638,
  [SMALL_STATE(11661)] = 360669,
  [SMALL_STATE(11662)] = 360700,
  [SMALL_STATE(11663)] = 360731,
  [SMALL_STATE(11664)] = 360762,
  [SMALL_STATE(11665)] = 360793,
  [SMALL_STATE(11666)] = 360824,
  [SMALL_STATE(11667)] = 360855,
  [SMALL_STATE(11668)] = 360886,
  [SMALL_STATE(11669)] = 360917,
  [SMALL_STATE(11670)] = 360948,
  [SMALL_STATE(11671)] = 360979,
  [SMALL_STATE(11672)] = 361010,
  [SMALL_STATE(11673)] = 361041,
  [SMALL_STATE(11674)] = 361072,
  [SMALL_STATE(11675)] = 361103,
  [SMALL_STATE(11676)] = 361134,
  [SMALL_STATE(11677)] = 361165,
  [SMALL_STATE(11678)] = 361196,
  [SMALL_STATE(11679)] = 361227,
  [SMALL_STATE(11680)] = 361258,
  [SMALL_STATE(11681)] = 361289,
  [SMALL_STATE(11682)] = 361320,
  [SMALL_STATE(11683)] = 361351,
  [SMALL_STATE(11684)] = 361382,
  [SMALL_STATE(11685)] = 361413,
  [SMALL_STATE(11686)] = 361444,
  [SMALL_STATE(11687)] = 361475,
  [SMALL_STATE(11688)] = 361506,
  [SMALL_STATE(11689)] = 361537,
  [SMALL_STATE(11690)] = 361568,
  [SMALL_STATE(11691)] = 361599,
  [SMALL_STATE(11692)] = 361630,
  [SMALL_STATE(11693)] = 361661,
  [SMALL_STATE(11694)] = 361692,
  [SMALL_STATE(11695)] = 361723,
  [SMALL_STATE(11696)] = 361754,
  [SMALL_STATE(11697)] = 361785,
  [SMALL_STATE(11698)] = 361816,
  [SMALL_STATE(11699)] = 361847,
  [SMALL_STATE(11700)] = 361878,
  [SMALL_STATE(11701)] = 361909,
  [SMALL_STATE(11702)] = 361940,
  [SMALL_STATE(11703)] = 361971,
  [SMALL_STATE(11704)] = 362002,
  [SMALL_STATE(11705)] = 362033,
  [SMALL_STATE(11706)] = 362064,
  [SMALL_STATE(11707)] = 362095,
  [SMALL_STATE(11708)] = 362126,
  [SMALL_STATE(11709)] = 362157,
  [SMALL_STATE(11710)] = 362188,
  [SMALL_STATE(11711)] = 362219,
  [SMALL_STATE(11712)] = 362250,
  [SMALL_STATE(11713)] = 362281,
  [SMALL_STATE(11714)] = 362312,
  [SMALL_STATE(11715)] = 362343,
  [SMALL_STATE(11716)] = 362374,
  [SMALL_STATE(11717)] = 362405,
  [SMALL_STATE(11718)] = 362436,
  [SMALL_STATE(11719)] = 362467,
  [SMALL_STATE(11720)] = 362498,
  [SMALL_STATE(11721)] = 362529,
  [SMALL_STATE(11722)] = 362560,
  [SMALL_STATE(11723)] = 362591,
  [SMALL_STATE(11724)] = 362622,
  [SMALL_STATE(11725)] = 362653,
  [SMALL_STATE(11726)] = 362684,
  [SMALL_STATE(11727)] = 362715,
  [SMALL_STATE(11728)] = 362746,
  [SMALL_STATE(11729)] = 362777,
  [SMALL_STATE(11730)] = 362808,
  [SMALL_STATE(11731)] = 362839,
  [SMALL_STATE(11732)] = 362870,
  [SMALL_STATE(11733)] = 362901,
  [SMALL_STATE(11734)] = 362932,
  [SMALL_STATE(11735)] = 362963,
  [SMALL_STATE(11736)] = 362994,
  [SMALL_STATE(11737)] = 363025,
  [SMALL_STATE(11738)] = 363056,
  [SMALL_STATE(11739)] = 363087,
  [SMALL_STATE(11740)] = 363118,
  [SMALL_STATE(11741)] = 363149,
  [SMALL_STATE(11742)] = 363180,
  [SMALL_STATE(11743)] = 363211,
  [SMALL_STATE(11744)] = 363242,
  [SMALL_STATE(11745)] = 363273,
  [SMALL_STATE(11746)] = 363304,
  [SMALL_STATE(11747)] = 363335,
  [SMALL_STATE(11748)] = 363366,
  [SMALL_STATE(11749)] = 363397,
  [SMALL_STATE(11750)] = 363428,
  [SMALL_STATE(11751)] = 363459,
  [SMALL_STATE(11752)] = 363490,
  [SMALL_STATE(11753)] = 363521,
  [SMALL_STATE(11754)] = 363552,
  [SMALL_STATE(11755)] = 363583,
  [SMALL_STATE(11756)] = 363614,
  [SMALL_STATE(11757)] = 363645,
  [SMALL_STATE(11758)] = 363676,
  [SMALL_STATE(11759)] = 363707,
  [SMALL_STATE(11760)] = 363738,
  [SMALL_STATE(11761)] = 363769,
  [SMALL_STATE(11762)] = 363800,
  [SMALL_STATE(11763)] = 363831,
  [SMALL_STATE(11764)] = 363862,
  [SMALL_STATE(11765)] = 363893,
  [SMALL_STATE(11766)] = 363924,
  [SMALL_STATE(11767)] = 363955,
  [SMALL_STATE(11768)] = 363986,
  [SMALL_STATE(11769)] = 364017,
  [SMALL_STATE(11770)] = 364048,
  [SMALL_STATE(11771)] = 364079,
  [SMALL_STATE(11772)] = 364110,
  [SMALL_STATE(11773)] = 364139,
  [SMALL_STATE(11774)] = 364170,
  [SMALL_STATE(11775)] = 364201,
  [SMALL_STATE(11776)] = 364232,
  [SMALL_STATE(11777)] = 364263,
  [SMALL_STATE(11778)] = 364294,
  [SMALL_STATE(11779)] = 364325,
  [SMALL_STATE(11780)] = 364356,
  [SMALL_STATE(11781)] = 364387,
  [SMALL_STATE(11782)] = 364418,
  [SMALL_STATE(11783)] = 364449,
  [SMALL_STATE(11784)] = 364480,
  [SMALL_STATE(11785)] = 364511,
  [SMALL_STATE(11786)] = 364542,
  [SMALL_STATE(11787)] = 364573,
  [SMALL_STATE(11788)] = 364604,
  [SMALL_STATE(11789)] = 364635,
  [SMALL_STATE(11790)] = 364666,
  [SMALL_STATE(11791)] = 364697,
  [SMALL_STATE(11792)] = 364728,
  [SMALL_STATE(11793)] = 364759,
  [SMALL_STATE(11794)] = 364790,
  [SMALL_STATE(11795)] = 364821,
  [SMALL_STATE(11796)] = 364852,
  [SMALL_STATE(11797)] = 364883,
  [SMALL_STATE(11798)] = 364914,
  [SMALL_STATE(11799)] = 364945,
  [SMALL_STATE(11800)] = 364976,
  [SMALL_STATE(11801)] = 365007,
  [SMALL_STATE(11802)] = 365038,
  [SMALL_STATE(11803)] = 365069,
  [SMALL_STATE(11804)] = 365100,
  [SMALL_STATE(11805)] = 365131,
  [SMALL_STATE(11806)] = 365162,
  [SMALL_STATE(11807)] = 365193,
  [SMALL_STATE(11808)] = 365224,
  [SMALL_STATE(11809)] = 365255,
  [SMALL_STATE(11810)] = 365286,
  [SMALL_STATE(11811)] = 365317,
  [SMALL_STATE(11812)] = 365348,
  [SMALL_STATE(11813)] = 365379,
  [SMALL_STATE(11814)] = 365410,
  [SMALL_STATE(11815)] = 365441,
  [SMALL_STATE(11816)] = 365472,
  [SMALL_STATE(11817)] = 365503,
  [SMALL_STATE(11818)] = 365534,
  [SMALL_STATE(11819)] = 365565,
  [SMALL_STATE(11820)] = 365596,
  [SMALL_STATE(11821)] = 365627,
  [SMALL_STATE(11822)] = 365658,
  [SMALL_STATE(11823)] = 365689,
  [SMALL_STATE(11824)] = 365720,
  [SMALL_STATE(11825)] = 365751,
  [SMALL_STATE(11826)] = 365782,
  [SMALL_STATE(11827)] = 365813,
  [SMALL_STATE(11828)] = 365844,
  [SMALL_STATE(11829)] = 365875,
  [SMALL_STATE(11830)] = 365906,
  [SMALL_STATE(11831)] = 365937,
  [SMALL_STATE(11832)] = 365968,
  [SMALL_STATE(11833)] = 365999,
  [SMALL_STATE(11834)] = 366030,
  [SMALL_STATE(11835)] = 366061,
  [SMALL_STATE(11836)] = 366092,
  [SMALL_STATE(11837)] = 366123,
  [SMALL_STATE(11838)] = 366154,
  [SMALL_STATE(11839)] = 366185,
  [SMALL_STATE(11840)] = 366216,
  [SMALL_STATE(11841)] = 366247,
  [SMALL_STATE(11842)] = 366278,
  [SMALL_STATE(11843)] = 366309,
  [SMALL_STATE(11844)] = 366340,
  [SMALL_STATE(11845)] = 366371,
  [SMALL_STATE(11846)] = 366402,
  [SMALL_STATE(11847)] = 366433,
  [SMALL_STATE(11848)] = 366464,
  [SMALL_STATE(11849)] = 366495,
  [SMALL_STATE(11850)] = 366526,
  [SMALL_STATE(11851)] = 366557,
  [SMALL_STATE(11852)] = 366588,
  [SMALL_STATE(11853)] = 366619,
  [SMALL_STATE(11854)] = 366650,
  [SMALL_STATE(11855)] = 366681,
  [SMALL_STATE(11856)] = 366712,
  [SMALL_STATE(11857)] = 366743,
  [SMALL_STATE(11858)] = 366774,
  [SMALL_STATE(11859)] = 366805,
  [SMALL_STATE(11860)] = 366836,
  [SMALL_STATE(11861)] = 366867,
  [SMALL_STATE(11862)] = 366898,
  [SMALL_STATE(11863)] = 366929,
  [SMALL_STATE(11864)] = 366960,
  [SMALL_STATE(11865)] = 366991,
  [SMALL_STATE(11866)] = 367022,
  [SMALL_STATE(11867)] = 367053,
  [SMALL_STATE(11868)] = 367084,
  [SMALL_STATE(11869)] = 367115,
  [SMALL_STATE(11870)] = 367146,
  [SMALL_STATE(11871)] = 367175,
  [SMALL_STATE(11872)] = 367206,
  [SMALL_STATE(11873)] = 367237,
  [SMALL_STATE(11874)] = 367268,
  [SMALL_STATE(11875)] = 367299,
  [SMALL_STATE(11876)] = 367330,
  [SMALL_STATE(11877)] = 367361,
  [SMALL_STATE(11878)] = 367392,
  [SMALL_STATE(11879)] = 367423,
  [SMALL_STATE(11880)] = 367454,
  [SMALL_STATE(11881)] = 367485,
  [SMALL_STATE(11882)] = 367516,
  [SMALL_STATE(11883)] = 367547,
  [SMALL_STATE(11884)] = 367578,
  [SMALL_STATE(11885)] = 367609,
  [SMALL_STATE(11886)] = 367640,
  [SMALL_STATE(11887)] = 367671,
  [SMALL_STATE(11888)] = 367702,
  [SMALL_STATE(11889)] = 367733,
  [SMALL_STATE(11890)] = 367762,
  [SMALL_STATE(11891)] = 367791,
  [SMALL_STATE(11892)] = 367822,
  [SMALL_STATE(11893)] = 367853,
  [SMALL_STATE(11894)] = 367884,
  [SMALL_STATE(11895)] = 367915,
  [SMALL_STATE(11896)] = 367946,
  [SMALL_STATE(11897)] = 367977,
  [SMALL_STATE(11898)] = 368008,
  [SMALL_STATE(11899)] = 368039,
  [SMALL_STATE(11900)] = 368070,
  [SMALL_STATE(11901)] = 368101,
  [SMALL_STATE(11902)] = 368132,
  [SMALL_STATE(11903)] = 368163,
  [SMALL_STATE(11904)] = 368194,
  [SMALL_STATE(11905)] = 368225,
  [SMALL_STATE(11906)] = 368256,
  [SMALL_STATE(11907)] = 368287,
  [SMALL_STATE(11908)] = 368318,
  [SMALL_STATE(11909)] = 368349,
  [SMALL_STATE(11910)] = 368380,
  [SMALL_STATE(11911)] = 368411,
  [SMALL_STATE(11912)] = 368442,
  [SMALL_STATE(11913)] = 368473,
  [SMALL_STATE(11914)] = 368504,
  [SMALL_STATE(11915)] = 368535,
  [SMALL_STATE(11916)] = 368566,
  [SMALL_STATE(11917)] = 368597,
  [SMALL_STATE(11918)] = 368628,
  [SMALL_STATE(11919)] = 368659,
  [SMALL_STATE(11920)] = 368690,
  [SMALL_STATE(11921)] = 368721,
  [SMALL_STATE(11922)] = 368752,
  [SMALL_STATE(11923)] = 368783,
  [SMALL_STATE(11924)] = 368814,
  [SMALL_STATE(11925)] = 368845,
  [SMALL_STATE(11926)] = 368876,
  [SMALL_STATE(11927)] = 368907,
  [SMALL_STATE(11928)] = 368938,
  [SMALL_STATE(11929)] = 368969,
  [SMALL_STATE(11930)] = 369000,
  [SMALL_STATE(11931)] = 369031,
  [SMALL_STATE(11932)] = 369062,
  [SMALL_STATE(11933)] = 369093,
  [SMALL_STATE(11934)] = 369124,
  [SMALL_STATE(11935)] = 369155,
  [SMALL_STATE(11936)] = 369186,
  [SMALL_STATE(11937)] = 369217,
  [SMALL_STATE(11938)] = 369248,
  [SMALL_STATE(11939)] = 369279,
  [SMALL_STATE(11940)] = 369310,
  [SMALL_STATE(11941)] = 369341,
  [SMALL_STATE(11942)] = 369372,
  [SMALL_STATE(11943)] = 369403,
  [SMALL_STATE(11944)] = 369434,
  [SMALL_STATE(11945)] = 369465,
  [SMALL_STATE(11946)] = 369496,
  [SMALL_STATE(11947)] = 369527,
  [SMALL_STATE(11948)] = 369558,
  [SMALL_STATE(11949)] = 369589,
  [SMALL_STATE(11950)] = 369620,
  [SMALL_STATE(11951)] = 369651,
  [SMALL_STATE(11952)] = 369682,
  [SMALL_STATE(11953)] = 369713,
  [SMALL_STATE(11954)] = 369744,
  [SMALL_STATE(11955)] = 369775,
  [SMALL_STATE(11956)] = 369806,
  [SMALL_STATE(11957)] = 369837,
  [SMALL_STATE(11958)] = 369868,
  [SMALL_STATE(11959)] = 369899,
  [SMALL_STATE(11960)] = 369930,
  [SMALL_STATE(11961)] = 369961,
  [SMALL_STATE(11962)] = 369992,
  [SMALL_STATE(11963)] = 370023,
  [SMALL_STATE(11964)] = 370054,
  [SMALL_STATE(11965)] = 370085,
  [SMALL_STATE(11966)] = 370116,
  [SMALL_STATE(11967)] = 370145,
  [SMALL_STATE(11968)] = 370176,
  [SMALL_STATE(11969)] = 370207,
  [SMALL_STATE(11970)] = 370238,
  [SMALL_STATE(11971)] = 370269,
  [SMALL_STATE(11972)] = 370300,
  [SMALL_STATE(11973)] = 370331,
  [SMALL_STATE(11974)] = 370362,
  [SMALL_STATE(11975)] = 370393,
  [SMALL_STATE(11976)] = 370424,
  [SMALL_STATE(11977)] = 370455,
  [SMALL_STATE(11978)] = 370486,
  [SMALL_STATE(11979)] = 370517,
  [SMALL_STATE(11980)] = 370548,
  [SMALL_STATE(11981)] = 370579,
  [SMALL_STATE(11982)] = 370610,
  [SMALL_STATE(11983)] = 370641,
  [SMALL_STATE(11984)] = 370672,
  [SMALL_STATE(11985)] = 370703,
  [SMALL_STATE(11986)] = 370734,
  [SMALL_STATE(11987)] = 370765,
  [SMALL_STATE(11988)] = 370796,
  [SMALL_STATE(11989)] = 370827,
  [SMALL_STATE(11990)] = 370858,
  [SMALL_STATE(11991)] = 370889,
  [SMALL_STATE(11992)] = 370920,
  [SMALL_STATE(11993)] = 370951,
  [SMALL_STATE(11994)] = 370982,
  [SMALL_STATE(11995)] = 371013,
  [SMALL_STATE(11996)] = 371044,
  [SMALL_STATE(11997)] = 371075,
  [SMALL_STATE(11998)] = 371106,
  [SMALL_STATE(11999)] = 371137,
  [SMALL_STATE(12000)] = 371168,
  [SMALL_STATE(12001)] = 371199,
  [SMALL_STATE(12002)] = 371230,
  [SMALL_STATE(12003)] = 371261,
  [SMALL_STATE(12004)] = 371292,
  [SMALL_STATE(12005)] = 371323,
  [SMALL_STATE(12006)] = 371354,
  [SMALL_STATE(12007)] = 371385,
  [SMALL_STATE(12008)] = 371416,
  [SMALL_STATE(12009)] = 371447,
  [SMALL_STATE(12010)] = 371478,
  [SMALL_STATE(12011)] = 371509,
  [SMALL_STATE(12012)] = 371540,
  [SMALL_STATE(12013)] = 371571,
  [SMALL_STATE(12014)] = 371602,
  [SMALL_STATE(12015)] = 371633,
  [SMALL_STATE(12016)] = 371664,
  [SMALL_STATE(12017)] = 371695,
  [SMALL_STATE(12018)] = 371726,
  [SMALL_STATE(12019)] = 371757,
  [SMALL_STATE(12020)] = 371788,
  [SMALL_STATE(12021)] = 371819,
  [SMALL_STATE(12022)] = 371850,
  [SMALL_STATE(12023)] = 371881,
  [SMALL_STATE(12024)] = 371912,
  [SMALL_STATE(12025)] = 371943,
  [SMALL_STATE(12026)] = 371974,
  [SMALL_STATE(12027)] = 372005,
  [SMALL_STATE(12028)] = 372036,
  [SMALL_STATE(12029)] = 372067,
  [SMALL_STATE(12030)] = 372098,
  [SMALL_STATE(12031)] = 372129,
  [SMALL_STATE(12032)] = 372160,
  [SMALL_STATE(12033)] = 372191,
  [SMALL_STATE(12034)] = 372222,
  [SMALL_STATE(12035)] = 372253,
  [SMALL_STATE(12036)] = 372284,
  [SMALL_STATE(12037)] = 372315,
  [SMALL_STATE(12038)] = 372346,
  [SMALL_STATE(12039)] = 372377,
  [SMALL_STATE(12040)] = 372408,
  [SMALL_STATE(12041)] = 372439,
  [SMALL_STATE(12042)] = 372470,
  [SMALL_STATE(12043)] = 372501,
  [SMALL_STATE(12044)] = 372532,
  [SMALL_STATE(12045)] = 372563,
  [SMALL_STATE(12046)] = 372594,
  [SMALL_STATE(12047)] = 372625,
  [SMALL_STATE(12048)] = 372656,
  [SMALL_STATE(12049)] = 372687,
  [SMALL_STATE(12050)] = 372718,
  [SMALL_STATE(12051)] = 372749,
  [SMALL_STATE(12052)] = 372780,
  [SMALL_STATE(12053)] = 372811,
  [SMALL_STATE(12054)] = 372842,
  [SMALL_STATE(12055)] = 372873,
  [SMALL_STATE(12056)] = 372904,
  [SMALL_STATE(12057)] = 372935,
  [SMALL_STATE(12058)] = 372966,
  [SMALL_STATE(12059)] = 372997,
  [SMALL_STATE(12060)] = 373028,
  [SMALL_STATE(12061)] = 373059,
  [SMALL_STATE(12062)] = 373090,
  [SMALL_STATE(12063)] = 373121,
  [SMALL_STATE(12064)] = 373152,
  [SMALL_STATE(12065)] = 373183,
  [SMALL_STATE(12066)] = 373214,
  [SMALL_STATE(12067)] = 373245,
  [SMALL_STATE(12068)] = 373276,
  [SMALL_STATE(12069)] = 373307,
  [SMALL_STATE(12070)] = 373338,
  [SMALL_STATE(12071)] = 373369,
  [SMALL_STATE(12072)] = 373400,
  [SMALL_STATE(12073)] = 373431,
  [SMALL_STATE(12074)] = 373462,
  [SMALL_STATE(12075)] = 373493,
  [SMALL_STATE(12076)] = 373524,
  [SMALL_STATE(12077)] = 373555,
  [SMALL_STATE(12078)] = 373586,
  [SMALL_STATE(12079)] = 373617,
  [SMALL_STATE(12080)] = 373648,
  [SMALL_STATE(12081)] = 373679,
  [SMALL_STATE(12082)] = 373710,
  [SMALL_STATE(12083)] = 373741,
  [SMALL_STATE(12084)] = 373772,
  [SMALL_STATE(12085)] = 373803,
  [SMALL_STATE(12086)] = 373834,
  [SMALL_STATE(12087)] = 373865,
  [SMALL_STATE(12088)] = 373896,
  [SMALL_STATE(12089)] = 373927,
  [SMALL_STATE(12090)] = 373958,
  [SMALL_STATE(12091)] = 373989,
  [SMALL_STATE(12092)] = 374020,
  [SMALL_STATE(12093)] = 374051,
  [SMALL_STATE(12094)] = 374082,
  [SMALL_STATE(12095)] = 374113,
  [SMALL_STATE(12096)] = 374144,
  [SMALL_STATE(12097)] = 374175,
  [SMALL_STATE(12098)] = 374206,
  [SMALL_STATE(12099)] = 374237,
  [SMALL_STATE(12100)] = 374268,
  [SMALL_STATE(12101)] = 374299,
  [SMALL_STATE(12102)] = 374330,
  [SMALL_STATE(12103)] = 374359,
  [SMALL_STATE(12104)] = 374390,
  [SMALL_STATE(12105)] = 374421,
  [SMALL_STATE(12106)] = 374452,
  [SMALL_STATE(12107)] = 374483,
  [SMALL_STATE(12108)] = 374514,
  [SMALL_STATE(12109)] = 374545,
  [SMALL_STATE(12110)] = 374576,
  [SMALL_STATE(12111)] = 374607,
  [SMALL_STATE(12112)] = 374638,
  [SMALL_STATE(12113)] = 374669,
  [SMALL_STATE(12114)] = 374700,
  [SMALL_STATE(12115)] = 374731,
  [SMALL_STATE(12116)] = 374762,
  [SMALL_STATE(12117)] = 374793,
  [SMALL_STATE(12118)] = 374824,
  [SMALL_STATE(12119)] = 374855,
  [SMALL_STATE(12120)] = 374859,
  [SMALL_STATE(12121)] = 374863,
  [SMALL_STATE(12122)] = 374867,
  [SMALL_STATE(12123)] = 374871,
  [SMALL_STATE(12124)] = 374875,
  [SMALL_STATE(12125)] = 374879,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11984),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10011),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12107),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10005),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12105),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12105),
  [17] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_file, 0, 0, 0),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2344),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8805),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8807),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9924),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4698),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5561),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9877),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3207),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3207),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9873),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2393),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4294),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9094),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9095),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12094),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(824),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12093),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3930),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(829),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9866),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4313),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9847),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(835),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12089),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12086),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12086),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9842),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12082),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9836),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2397),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7275),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7403),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7739),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12073),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12068),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2403),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2403),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12067),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2404),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4294),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4291),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4292),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1234),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9970),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12056),
  [119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefixed_expression, 2, 0, 0),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1288),
  [123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefixed_expression, 2, 0, 0),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4296),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5867),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(949),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9628),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3469),
  [135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3469),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9528),
  [139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1329),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4296),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9240),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9241),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11703),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(902),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(906),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8519),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11972),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5867),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3897),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1040),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4320),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9379),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(914),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11696),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5513),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11771),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11771),
  [187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9628),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11974),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9565),
  [193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7269),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7460),
  [199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7844),
  [201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11017),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11018),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1317),
  [207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10971),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1401),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4292),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1182),
  [217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11698),
  [223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__low_prec_app, 2, 0, 0),
  [225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__low_prec_app, 2, 0, 0),
  [227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_infix_expression, 3, 0, 0),
  [229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_infix_expression, 3, 0, 0),
  [231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_expression, 5, 0, 43),
  [233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_expression, 5, 0, 43),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__val_property_defn, 4, 0, 0),
  [239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__val_property_defn, 4, 0, 0),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10040),
  [243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 4, 0, 0),
  [245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 4, 0, 0),
  [247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__val_property_defn, 2, 0, 0),
  [249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__val_property_defn, 2, 0, 0),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9612),
  [253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mutate_expression, 3, 0, 19),
  [255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mutate_expression, 3, 0, 19),
  [257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 3, 0, 0),
  [259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 3, 0, 0),
  [261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 17),
  [263] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 17),
  [265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_expression, 2, 0, 7),
  [267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_expression, 2, 0, 7),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11766),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11766),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1183),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1669),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5863),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(942),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9453),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9687),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1882),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9303),
  [303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9310),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11550),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(839),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8496),
  [313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11934),
  [315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5863),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3931),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4310),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10016),
  [327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11543),
  [333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(907),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5480),
  [339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11782),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11782),
  [343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9453),
  [345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11936),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9661),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7274),
  [353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7426),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7814),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10927),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10928),
  [361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1844),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10852),
  [367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1718),
  [369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1186),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11586),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1620),
  [379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5932),
  [381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9795),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9737),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1715),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9138),
  [393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8931),
  [395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11740),
  [397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(924),
  [401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8464),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11986),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5932),
  [409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3892),
  [411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1003),
  [413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4315),
  [415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9391),
  [417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1000),
  [419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11733),
  [423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1159),
  [425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5536),
  [429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11785),
  [431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11785),
  [433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9795),
  [435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11988),
  [437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9704),
  [439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7204),
  [443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7490),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7888),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11035),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11036),
  [451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1858),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10995),
  [457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1754),
  [459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1187),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11735),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9974),
  [469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9961),
  [471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1696),
  [473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5910),
  [475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9424),
  [479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9662),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1944),
  [485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9342),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9346),
  [489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(918),
  [493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8547),
  [495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11979),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5910),
  [501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3894),
  [503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1027),
  [505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4319),
  [507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9397),
  [509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(909),
  [511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11715),
  [515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1118),
  [517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5533),
  [521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11788),
  [523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11788),
  [525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9424),
  [527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11981),
  [529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9688),
  [531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7223),
  [535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7504),
  [537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7934),
  [539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11026),
  [541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11027),
  [543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1923),
  [545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1947),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10983),
  [549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2071),
  [551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1190),
  [553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11717),
  [557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1890),
  [559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5958),
  [561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10104),
  [565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9887),
  [567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2069),
  [571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8956),
  [573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8957),
  [575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11758),
  [577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(931),
  [579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(932),
  [581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8444),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11993),
  [585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5958),
  [589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3890),
  [591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(992),
  [593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4312),
  [595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9432),
  [597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(892),
  [599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11751),
  [603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1049),
  [605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5519),
  [609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11794),
  [611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11794),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10104),
  [615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11995),
  [617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9923),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7235),
  [623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7459),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7823),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11043),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11044),
  [631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2052),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2040),
  [635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11007),
  [637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1953),
  [639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1189),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11753),
  [645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1861),
  [649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5710),
  [651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(936),
  [653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9412),
  [655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1996),
  [659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8994),
  [661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8995),
  [663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11664),
  [665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8502),
  [671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11958),
  [673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5710),
  [677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3923),
  [679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1128),
  [681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4314),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9602),
  [685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11657),
  [691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1080),
  [693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5490),
  [697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11791),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11791),
  [701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10034),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11960),
  [705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9402),
  [707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7340),
  [711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7343),
  [713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7651),
  [715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10981),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10982),
  [719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2070),
  [721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10945),
  [725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1928),
  [727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1188),
  [729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11722),
  [733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10034),
  [737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11659),
  [739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10075),
  [743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10061),
  [745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9641),
  [747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9537),
  [749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1874),
  [751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6074),
  [753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(946),
  [755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9389),
  [757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9989),
  [759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2162),
  [763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9372),
  [765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9371),
  [767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11424),
  [769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8508),
  [775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11904),
  [777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6074),
  [781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3952),
  [783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(782),
  [785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4316),
  [787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9590),
  [789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11417),
  [795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1069),
  [797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5547),
  [801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11775),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11775),
  [805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9389),
  [807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11906),
  [809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9968),
  [811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1929),
  [813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7265),
  [815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7467),
  [817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7845),
  [819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10426),
  [821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10427),
  [823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1930),
  [825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10428),
  [829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1932),
  [831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1193),
  [833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11419),
  [837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9401),
  [841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9549),
  [843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9392),
  [845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9748),
  [847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9739),
  [849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9377),
  [851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9686),
  [853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9642),
  [855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6049),
  [857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9842),
  [861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11667),
  [865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8489),
  [869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6049),
  [873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5515),
  [879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11418),
  [881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11418),
  [883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9584),
  [885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2404),
  [889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1231),
  [891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11744),
  [895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 1, 0, 0),
  [899] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 1, 0, 0),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2351),
  [909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6187),
  [911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9524),
  [915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10178),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2365),
  [921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9287),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9290),
  [925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(788),
  [927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(787),
  [929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8439),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11884),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6187),
  [937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3955),
  [939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(807),
  [941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4317),
  [943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9816),
  [945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(958),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11353),
  [951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(997),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5505),
  [957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11354),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11354),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9524),
  [963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11886),
  [965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10141),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7225),
  [971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7470),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7892),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10287),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10288),
  [979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2509),
  [981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10359),
  [985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2449),
  [987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1243),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11357),
  [993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11363),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2742),
  [999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5757),
  [1001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1002),
  [1003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9820),
  [1005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10343),
  [1007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9380),
  [1009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2884),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9121),
  [1015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9125),
  [1017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11684),
  [1019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(881),
  [1021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(882),
  [1023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8471),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11965),
  [1027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11255),
  [1029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [1031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5757),
  [1033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3918),
  [1035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1075),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4322),
  [1039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9488),
  [1041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(916),
  [1043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [1045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11677),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1171),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [1051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5501),
  [1053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11734),
  [1055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11734),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9820),
  [1059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11967),
  [1061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9447),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2956),
  [1065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7305),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7359),
  [1069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7710),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10993),
  [1073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10994),
  [1075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2955),
  [1077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2819),
  [1079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10958),
  [1081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2833),
  [1083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1384),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11679),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [1091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [1093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [1097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(889),
  [1099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11658),
  [1101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11658),
  [1103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1523),
  [1105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [1107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 1, 0, 0), SHIFT(12109),
  [1110] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 1, 0, 0), SHIFT(575),
  [1113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2814),
  [1117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5994),
  [1119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1149),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9717),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9912),
  [1125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3145),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9183),
  [1131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9182),
  [1133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11466),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(795),
  [1137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8465),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11914),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [1145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5994),
  [1147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3937),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(814),
  [1151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4321),
  [1153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9382),
  [1155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(952),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [1159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11459),
  [1161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(945),
  [1163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5486),
  [1167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11585),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11585),
  [1171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9717),
  [1173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11916),
  [1175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9888),
  [1177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3107),
  [1179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7238),
  [1181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7482),
  [1183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7878),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10810),
  [1187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10811),
  [1189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3108),
  [1191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3118),
  [1193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10770),
  [1195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3172),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1489),
  [1199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [1201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11461),
  [1203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(776),
  [1205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [1207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [1209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3949),
  [1211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(865),
  [1213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11502),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11502),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [1219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1531),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [1225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_elements, 1, 0, 0),
  [1227] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 1, 0, 0), SHIFT(9491),
  [1230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 1, 0, 0), SHIFT(9834),
  [1233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 1, 0, 0), SHIFT(4151),
  [1236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(887),
  [1238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [1240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [1242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3951),
  [1244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [1246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11544),
  [1248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11544),
  [1250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1473),
  [1252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(944),
  [1254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [1256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [1258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1096),
  [1260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11779),
  [1262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11779),
  [1264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1548),
  [1266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [1268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(856),
  [1270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [1272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [1274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [1276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11460),
  [1278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11460),
  [1280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1496),
  [1282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [1284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [1286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [1288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [1290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [1292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [1294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [1296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2847),
  [1298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2795),
  [1300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5826),
  [1302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(978),
  [1304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9701),
  [1306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9494),
  [1308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [1310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3165),
  [1312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9003),
  [1314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9000),
  [1316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11628),
  [1318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(868),
  [1320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(869),
  [1322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8528),
  [1324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11951),
  [1326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [1328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5826),
  [1330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3908),
  [1332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [1334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4307),
  [1336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(993),
  [1338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9733),
  [1340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(929),
  [1342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [1344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11621),
  [1346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(959),
  [1348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [1350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5482),
  [1352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11752),
  [1354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11752),
  [1356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10029),
  [1358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [1360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11953),
  [1362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9471),
  [1364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3106),
  [1366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7320),
  [1368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7356),
  [1370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7695),
  [1372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10969),
  [1374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10970),
  [1376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3105),
  [1378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3144),
  [1380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10929),
  [1382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3034),
  [1384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1510),
  [1386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [1388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11623),
  [1390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [1392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0),
  [1394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [1396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [1398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3497),
  [1400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_accessor_body, 3, 0, 0),
  [1402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_accessor_body, 3, 0, 0),
  [1404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(977),
  [1406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [1408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [1410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_accessor_body, 5, 0, 0),
  [1412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_accessor_body, 5, 0, 0),
  [1414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3093),
  [1416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_range, 1, 0, 0),
  [1418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2377),
  [1420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [1422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_elements, 2, 0, 0),
  [1424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [1426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10029),
  [1428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 3, 0, 0),
  [1430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [1432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1001),
  [1434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [1436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_elements_repeat1, 2, 0, 17),
  [1438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3285),
  [1440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(778),
  [1442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [1444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1023),
  [1446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1162),
  [1448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10703),
  [1450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comp_or_range_expression, 1, 0, 0),
  [1452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [1454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1169),
  [1456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9892),
  [1458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1142),
  [1460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [1462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module_body, 1, 0, 0),
  [1464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3312),
  [1466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1133),
  [1468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [1470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 1, 0, 0),
  [1472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1041),
  [1474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2462),
  [1476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1031),
  [1478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2989),
  [1480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3418),
  [1482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1004),
  [1484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [1486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(994),
  [1488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6444),
  [1490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11277),
  [1492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1020),
  [1494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [1496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [1498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1101),
  [1500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11716),
  [1502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11716),
  [1504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1589),
  [1506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [1508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [1510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6368),
  [1512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3002),
  [1514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5653),
  [1516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(890),
  [1518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9905),
  [1520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9972),
  [1522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [1524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3420),
  [1526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9070),
  [1528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9073),
  [1530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [1532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(854),
  [1534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8540),
  [1536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11834),
  [1538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [1540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5653),
  [1542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3886),
  [1544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1146),
  [1546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4308),
  [1548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10019),
  [1550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(970),
  [1552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [1554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11207),
  [1556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [1558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [1560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5539),
  [1562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11208),
  [1564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11208),
  [1566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9905),
  [1568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11836),
  [1570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9993),
  [1572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3545),
  [1574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7278),
  [1576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7406),
  [1578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7785),
  [1580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10240),
  [1582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10238),
  [1584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3546),
  [1586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3342),
  [1588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10236),
  [1590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3562),
  [1592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [1594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [1596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11211),
  [1598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__object_construction, 2, 0, 0),
  [1600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5680),
  [1602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1045),
  [1604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [1606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [1608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5680),
  [1610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3927),
  [1612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9418),
  [1614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [1616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11697),
  [1618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11697),
  [1620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1554),
  [1622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [1624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9681),
  [1626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11671),
  [1628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9653),
  [1630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [1632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3035),
  [1634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5765),
  [1636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1076),
  [1638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9736),
  [1640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9582),
  [1642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [1644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3553),
  [1646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9188),
  [1648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9187),
  [1650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11591),
  [1652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(860),
  [1654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(862),
  [1656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8516),
  [1658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11944),
  [1660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [1662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5765),
  [1664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3929),
  [1666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1148),
  [1668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4324),
  [1670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9880),
  [1672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [1674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [1676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11584),
  [1678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(979),
  [1680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [1682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5506),
  [1684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11678),
  [1686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11678),
  [1688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9736),
  [1690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11946),
  [1692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9558),
  [1694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3266),
  [1696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7282),
  [1698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7399),
  [1700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7775),
  [1702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10943),
  [1704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10944),
  [1706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3265),
  [1708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3431),
  [1710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10892),
  [1712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3576),
  [1714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1575),
  [1716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [1718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11545),
  [1720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [1722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3008),
  [1724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5938),
  [1726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1151),
  [1728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9437),
  [1730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9805),
  [1732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [1734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3455),
  [1736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9026),
  [1738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9024),
  [1740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11508),
  [1742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [1744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(820),
  [1746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8449),
  [1748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11924),
  [1750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [1752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5938),
  [1754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3936),
  [1756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1036),
  [1758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4306),
  [1760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9867),
  [1762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(950),
  [1764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [1766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11501),
  [1768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [1770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [1772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5507),
  [1774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11622),
  [1776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11622),
  [1778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9999),
  [1780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [1782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11926),
  [1784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9779),
  [1786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3352),
  [1788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7205),
  [1790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7509),
  [1792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7943),
  [1794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10850),
  [1796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10851),
  [1798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3351),
  [1800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3383),
  [1802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10812),
  [1804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3488),
  [1806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1586),
  [1808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [1810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11503),
  [1812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [1814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9599),
  [1816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__slice_range_special, 2, 0, 26),
  [1818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9999),
  [1820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11217),
  [1822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2190),
  [1824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [1826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3097),
  [1828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5887),
  [1830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1022),
  [1832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9690),
  [1834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10087),
  [1836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [1838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3541),
  [1840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9199),
  [1842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9200),
  [1844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11297),
  [1846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [1848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [1850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8513),
  [1852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11864),
  [1854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [1856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5887),
  [1858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3941),
  [1860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(955),
  [1862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4323),
  [1864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10053),
  [1866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(960),
  [1868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [1870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11287),
  [1872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(893),
  [1874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [1876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5483),
  [1878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11288),
  [1880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11288),
  [1882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9690),
  [1884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11866),
  [1886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10108),
  [1888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3453),
  [1890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7244),
  [1892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7457),
  [1894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7838),
  [1896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10191),
  [1898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10192),
  [1900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3449),
  [1902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3535),
  [1904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10193),
  [1906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3466),
  [1908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1572),
  [1910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [1912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11291),
  [1914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [1916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 3, 0, 41),
  [1918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11770),
  [1920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2801),
  [1922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9626),
  [1924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9550),
  [1926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [1928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9765),
  [1930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [1932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9580),
  [1934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__slice_range_special, 3, 0, 40),
  [1936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9594),
  [1938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11594),
  [1940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9900),
  [1942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11851),
  [1944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9907),
  [1946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3072),
  [1948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2923),
  [1950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [1952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9878),
  [1954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [1956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11643),
  [1958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3269),
  [1960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11516),
  [1962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9577),
  [1964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9798),
  [1966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9764),
  [1968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9963),
  [1970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [1972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9784),
  [1974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11439),
  [1976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9886),
  [1978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12051),
  [1980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9463),
  [1982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [1984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3363),
  [1986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10131),
  [1988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [1990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9603),
  [1992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [1994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [1996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [1998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [2000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [2002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [2004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [2006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11352),
  [2008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10123),
  [2010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1738),
  [2012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [2014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9933),
  [2016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [2018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9023),
  [2020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9932),
  [2022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2406),
  [2024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10118),
  [2026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [2028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [2030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4144),
  [2032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6312),
  [2034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9911),
  [2036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [2038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_parameter_value, 2, 0, 0),
  [2040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2783),
  [2042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10095),
  [2044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10789),
  [2046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4270),
  [2048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8146),
  [2050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [2052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2789),
  [2054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6213),
  [2056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9396),
  [2058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [2060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3178),
  [2062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3406),
  [2064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11185),
  [2066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9473),
  [2068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7423),
  [2070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [2072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2654),
  [2074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9036),
  [2076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9883),
  [2078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4282),
  [2080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6919),
  [2082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [2084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3188),
  [2086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9469),
  [2088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [2090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10003),
  [2092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [2094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2900),
  [2096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [2098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7344),
  [2100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11139),
  [2102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3127),
  [2104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6893),
  [2106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4223),
  [2108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3832),
  [2110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9664),
  [2112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6532),
  [2114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [2116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12108),
  [2118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9639),
  [2120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4225),
  [2122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2711),
  [2124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [2126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else, 2, 0, 0),
  [2128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [2130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9588),
  [2132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [2134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [2136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11095),
  [2138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__module_body_repeat1, 2, 0, 17),
  [2140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2067),
  [2142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [2144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10171),
  [2146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7632),
  [2148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11893),
  [2150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3533),
  [2152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2806),
  [2154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2841),
  [2156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4275),
  [2158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9455),
  [2160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_comp_expression, 6, 0, 0),
  [2162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6642),
  [2164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2700),
  [2166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [2168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1393),
  [2170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2869),
  [2172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9943),
  [2174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9804),
  [2176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [2178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4243),
  [2180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6741),
  [2182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2746),
  [2184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9827),
  [2186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10179),
  [2188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [2190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9691),
  [2192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [2194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1965),
  [2196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [2198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2352),
  [2200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11051),
  [2202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10008),
  [2204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 5, 0, 0),
  [2206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3166),
  [2208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9710),
  [2210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [2212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4300),
  [2214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3167),
  [2216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6343),
  [2218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2444),
  [2220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2802),
  [2222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2648),
  [2224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2032),
  [2226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [2228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10998),
  [2230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [2232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9919),
  [2234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9824),
  [2236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10094),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2721),
  [2242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9682),
  [2244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [2246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [2248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9723),
  [2250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7348),
  [2252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9913),
  [2254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [2256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9793),
  [2258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2960),
  [2260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10138),
  [2262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4281),
  [2264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6818),
  [2266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7018),
  [2268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2747),
  [2270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9996),
  [2272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9858),
  [2274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2859),
  [2276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10946),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [2280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2798),
  [2282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10048),
  [2284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9470),
  [2286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9499),
  [2288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10110),
  [2290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9990),
  [2292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9562),
  [2294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9676),
  [2296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9775),
  [2298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9838),
  [2300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9652),
  [2302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9954),
  [2304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9658),
  [2306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9988),
  [2308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9952),
  [2310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10059),
  [2312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9404),
  [2314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9730),
  [2316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9756),
  [2318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9556),
  [2320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9752),
  [2322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9679),
  [2324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9416),
  [2326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9833),
  [2328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10020),
  [2330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9452),
  [2332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9540),
  [2334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10079),
  [2336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9762),
  [2338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9981),
  [2340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10064),
  [2342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9492),
  [2344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9871),
  [2346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9252),
  [2348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9918),
  [2350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5596),
  [2352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9917),
  [2354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3413),
  [2356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3413),
  [2358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11933),
  [2360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [2362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10021),
  [2364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [2366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [2368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10085),
  [2370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11210),
  [2372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [2374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [2376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [2378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [2380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [2382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2375),
  [2384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0),
  [2386] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(2344),
  [2389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0),
  [2391] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(9206),
  [2394] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(9924),
  [2397] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(4698),
  [2400] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(1178),
  [2403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(5562),
  [2406] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(9877),
  [2409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(3207),
  [2412] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(3207),
  [2415] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(9873),
  [2418] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(2393),
  [2421] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(4294),
  [2424] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(9094),
  [2427] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(9095),
  [2430] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(12094),
  [2433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(824),
  [2436] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(825),
  [2439] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(12093),
  [2442] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(1178),
  [2445] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(3930),
  [2448] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(829),
  [2451] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(9866),
  [2454] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(4313),
  [2457] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(9847),
  [2460] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(835),
  [2463] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(835),
  [2466] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(12089),
  [2469] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(11418),
  [2472] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(11418),
  [2475] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(9842),
  [2478] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(12082),
  [2481] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(9836),
  [2484] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(2397),
  [2487] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(7275),
  [2490] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(7403),
  [2493] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(7739),
  [2496] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(12073),
  [2499] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(12068),
  [2502] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(2403),
  [2505] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(2403),
  [2508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(12067),
  [2511] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(2404),
  [2514] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(4294),
  [2517] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(4291),
  [2520] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(4292),
  [2523] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(1231),
  [2526] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(1261),
  [2529] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(9970),
  [2532] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(12056),
  [2535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace, 2, 0, 0),
  [2537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace, 2, 0, 0),
  [2539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9206),
  [2541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5562),
  [2543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace, 2, 0, 1),
  [2545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace, 2, 0, 1),
  [2547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace, 3, 0, 0),
  [2549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace, 3, 0, 0),
  [2551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace, 3, 0, 9),
  [2553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace, 3, 0, 9),
  [2555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace, 3, 0, 1),
  [2557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace, 3, 0, 1),
  [2559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace, 4, 0, 9),
  [2561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace, 4, 0, 9),
  [2563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_file, 1, 0, 0),
  [2565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_module, 4, 0, 10),
  [2567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_module, 2, 0, 1),
  [2569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_module, 5, 0, 31),
  [2571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_module, 3, 0, 1),
  [2573] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(793),
  [2576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(5561),
  [2579] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(793),
  [2582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(12086),
  [2585] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(12086),
  [2588] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(1234),
  [2591] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat2, 2, 0, 0), SHIFT_REPEAT(1310),
  [2594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_module, 4, 0, 31),
  [2596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_module, 3, 0, 10),
  [2598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9216),
  [2600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9694),
  [2602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5625),
  [2604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9693),
  [2606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3286),
  [2608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3286),
  [2610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11903),
  [2612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [2614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9930),
  [2616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [2618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1932),
  [2620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10176),
  [2622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11290),
  [2624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9174),
  [2626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9534),
  [2628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5559),
  [2630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9532),
  [2632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3498),
  [2634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3498),
  [2636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11957),
  [2638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [2640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9814),
  [2642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [2644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [2646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9991),
  [2648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11356),
  [2650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3889),
  [2652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [2654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9801),
  [2656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [2658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2604),
  [2660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__object_construction, 1, 0, 0),
  [2662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11883),
  [2664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [2666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5976),
  [2668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5969),
  [2670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7779),
  [2672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4184),
  [2674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [2676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2449),
  [2678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2602),
  [2680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6140),
  [2682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6142),
  [2684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7857),
  [2686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4202),
  [2688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6528),
  [2690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_declaration, 1, 0, 0),
  [2692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value_declaration, 1, 0, 0),
  [2694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9436),
  [2696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6325),
  [2698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2775),
  [2700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(833),
  [2702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3885),
  [2704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [2706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10000),
  [2708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [2710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2990),
  [2712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [2714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3041),
  [2716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [2718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [2720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3221),
  [2722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2435),
  [2724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [2726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2876),
  [2728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3095),
  [2730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2832),
  [2732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [2734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [2736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3290),
  [2738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2973),
  [2740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3475),
  [2742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [2744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3402),
  [2746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3321),
  [2748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3500),
  [2750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [2752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [2754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2532),
  [2756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2002),
  [2758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3314),
  [2760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [2762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3283),
  [2764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2920),
  [2766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(894),
  [2768] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1669),
  [2771] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1113),
  [2774] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(9453),
  [2777] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3469),
  [2780] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3469),
  [2783] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(9687),
  [2786] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1882),
  [2789] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(4294),
  [2792] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(9303),
  [2795] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(9310),
  [2798] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(11933),
  [2801] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(839),
  [2804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(840),
  [2807] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(11934),
  [2810] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1113),
  [2813] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3931),
  [2816] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(797),
  [2819] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(9866),
  [2822] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(4310),
  [2825] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(10016),
  [2828] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(941),
  [2831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(941),
  [2834] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(11543),
  [2837] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(11658),
  [2840] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(11658),
  [2843] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(9453),
  [2846] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(11936),
  [2849] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1843),
  [2852] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(7274),
  [2855] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(7426),
  [2858] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(7814),
  [2861] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(10927),
  [2864] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(10928),
  [2867] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1844),
  [2870] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1844),
  [2873] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(10852),
  [2876] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1718),
  [2879] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(4294),
  [2882] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(4291),
  [2885] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(4292),
  [2888] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1523),
  [2891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1618),
  [2894] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(11586),
  [2897] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(901),
  [2900] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1861),
  [2903] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1020),
  [2906] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(10034),
  [2909] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(9412),
  [2912] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1996),
  [2915] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(8994),
  [2918] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(8995),
  [2921] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(11957),
  [2924] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(874),
  [2927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(875),
  [2930] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(11958),
  [2933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1020),
  [2936] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3923),
  [2939] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1128),
  [2942] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(4314),
  [2945] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(9602),
  [2948] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(926),
  [2951] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(926),
  [2954] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(11657),
  [2957] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(11716),
  [2960] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(11716),
  [2963] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(10034),
  [2966] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(11960),
  [2969] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2035),
  [2972] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(7340),
  [2975] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(7343),
  [2978] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(7651),
  [2981] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(10981),
  [2984] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(10982),
  [2987] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2070),
  [2990] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2070),
  [2993] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(10945),
  [2996] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1928),
  [2999] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1589),
  [3002] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1753),
  [3005] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(11659),
  [3008] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1107),
  [3011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_expression, 1, 0, 0),
  [3013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [3015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_expression, 2, 0, 0),
  [3017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_parameter_value, 1, 0, 0),
  [3019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11943),
  [3021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [3023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3265),
  [3025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3576),
  [3027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__slice_range_special, 2, 0, 27),
  [3029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11923),
  [3031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [3033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3351),
  [3035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3488),
  [3037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9945),
  [3039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [3041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [3043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9865),
  [3045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [3047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9506),
  [3049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11950),
  [3051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [3053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3105),
  [3055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3034),
  [3057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [3059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9851),
  [3061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [3063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [3065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9526),
  [3067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11863),
  [3069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [3071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3449),
  [3073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3466),
  [3075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [3077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [3079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11978),
  [3081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [3083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1923),
  [3085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [3087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [3089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11971),
  [3091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [3093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [3095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [3097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [3099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10092),
  [3101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9445),
  [3103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9722),
  [3105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [3107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [3109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10137),
  [3111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [3113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9741),
  [3115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9627),
  [3117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11833),
  [3119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [3121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3546),
  [3123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3562),
  [3125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [3127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9637),
  [3129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [3131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9971),
  [3133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [3135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [3137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [3139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [3141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [3143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9387),
  [3145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11992),
  [3147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [3149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [3151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [3153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [3155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9629),
  [3157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10022),
  [3159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11985),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [3163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [3167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [3169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11913),
  [3171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [3173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3108),
  [3175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3172),
  [3177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [3179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [3181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11964),
  [3183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [3185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2955),
  [3187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2833),
  [3189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [3191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const, 1, 0, 0),
  [3193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const, 1, 0, 0),
  [3195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1315),
  [3197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1382),
  [3199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1385),
  [3201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1395),
  [3203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1396),
  [3205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1398),
  [3207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1403),
  [3209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1404),
  [3211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1407),
  [3213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1408),
  [3215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1409),
  [3217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1462),
  [3219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [3221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10765),
  [3223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1358),
  [3225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1357),
  [3227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1880),
  [3229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1866),
  [3231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1867),
  [3233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1868),
  [3235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1869),
  [3237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1870),
  [3239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1873),
  [3241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1877),
  [3243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1878),
  [3245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1683),
  [3247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1879),
  [3249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1881),
  [3251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1583),
  [3253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10704),
  [3255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1837),
  [3257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1836),
  [3259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1835),
  [3261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1832),
  [3263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1831),
  [3265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1830),
  [3267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1829),
  [3269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1828),
  [3271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1827),
  [3273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1826),
  [3275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1821),
  [3277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1820),
  [3279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1562),
  [3281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10691),
  [3283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2094),
  [3285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2099),
  [3287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2100),
  [3289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2101),
  [3291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2103),
  [3293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2106),
  [3295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2109),
  [3297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2113),
  [3299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2131),
  [3301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2143),
  [3303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2149),
  [3305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2152),
  [3307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1609),
  [3309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10664),
  [3311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2073),
  [3313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2074),
  [3315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2081),
  [3317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2085),
  [3319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2095),
  [3321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2096),
  [3323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2104),
  [3325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2105),
  [3327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2108),
  [3329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2110),
  [3331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2111),
  [3333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2112),
  [3335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1679),
  [3337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10651),
  [3339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2063),
  [3341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1900),
  [3343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1901),
  [3345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1902),
  [3347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1903),
  [3349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1908),
  [3351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1911),
  [3353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1912),
  [3355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1914),
  [3357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1915),
  [3359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1917),
  [3361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1918),
  [3363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1595),
  [3365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10676),
  [3367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1819),
  [3369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1817),
  [3371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1883),
  [3373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1884),
  [3375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1958),
  [3377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1960),
  [3379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1962),
  [3381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1963),
  [3383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1966),
  [3385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1967),
  [3387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2007),
  [3389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2013),
  [3391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2018),
  [3393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2045),
  [3395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2047),
  [3397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2048),
  [3399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1891),
  [3401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10746),
  [3403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, 0, 0),
  [3405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1211),
  [3407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, 0, 0),
  [3409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5899),
  [3411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5898),
  [3413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7751),
  [3415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [3417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_flexible_type, 2, 0, 0),
  [3419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_flexible_type, 2, 0, 0),
  [3421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2159),
  [3423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2161),
  [3425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0),
  [3427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0),
  [3429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constrained_type, 3, 0, 0),
  [3431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constrained_type, 3, 0, 0),
  [3433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2138),
  [3435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2139),
  [3437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1920),
  [3439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1922),
  [3441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typecast_expression, 3, 0, 0),
  [3443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typecast_expression, 3, 0, 0),
  [3445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2049),
  [3447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2066),
  [3449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_long_identifier, 2, 0, 0),
  [3451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_long_identifier, 2, 0, 0),
  [3453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10328),
  [3455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 4, 0, 20),
  [3457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 4, 0, 20),
  [3459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9480),
  [3461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9393),
  [3463] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5898),
  [3466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_type, 2, 0, 0),
  [3468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_type, 2, 0, 0),
  [3470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 3, 0, 20),
  [3472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 3, 0, 20),
  [3474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument, 2, 0, 0),
  [3476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_argument, 2, 0, 0),
  [3478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0),
  [3480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0),
  [3482] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9133),
  [3485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0),
  [3487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0),
  [3489] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10328),
  [3492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_long_identifier, 1, 0, 0),
  [3494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0),
  [3496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument, 1, 0, 0),
  [3498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_argument, 1, 0, 0),
  [3500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1, 0, 0), SHIFT(9133),
  [3503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_type, 1, 0, 0),
  [3505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_simple_type, 1, 0, 0),
  [3507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4105),
  [3509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__static_type_identifier, 2, 0, 0),
  [3511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__static_type_identifier, 2, 0, 0),
  [3513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1, 0, 0),
  [3515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1, 0, 0),
  [3517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 4, 0, 0),
  [3519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 4, 0, 0),
  [3521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anon_record_type, 5, 0, 28),
  [3523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anon_record_type, 5, 0, 28),
  [3525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 3, 0, 0),
  [3527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 3, 0, 0),
  [3529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_postfix_type, 2, 0, 0),
  [3531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_postfix_type, 2, 0, 0),
  [3533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paren_type, 3, 0, 0),
  [3535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_paren_type, 3, 0, 0),
  [3537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3, 0, 0),
  [3539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3, 0, 0),
  [3541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4, 0, 0),
  [3543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4, 0, 0),
  [3545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5, 0, 0),
  [3547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5, 0, 0),
  [3549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_type, 2, 0, 0),
  [3551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_type, 2, 0, 0),
  [3553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0),
  [3555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0),
  [3557] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(9393),
  [3560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_type, 2, 0, 0),
  [3562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_type, 2, 0, 0),
  [3564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2486),
  [3566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2487),
  [3568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2489),
  [3570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2490),
  [3572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2491),
  [3574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2492),
  [3576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2493),
  [3578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2494),
  [3580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2495),
  [3582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2496),
  [3584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2498),
  [3586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2501),
  [3588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2271),
  [3590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11689),
  [3592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1289),
  [3594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5663),
  [3596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5659),
  [3598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7687),
  [3600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [3602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_float, 3, 0, 16),
  [3604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_float, 3, 0, 16),
  [3606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10757),
  [3608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1314),
  [3610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6121),
  [3612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6129),
  [3614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7880),
  [3616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [3618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2457),
  [3620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2456),
  [3622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2454),
  [3624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2453),
  [3626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2451),
  [3628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2450),
  [3630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2443),
  [3632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2441),
  [3634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2440),
  [3636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2436),
  [3638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2434),
  [3640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2433),
  [3642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2301),
  [3644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11691),
  [3646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elif_expression, 4, 0, 65),
  [3648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elif_expression, 4, 0, 65),
  [3650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1466),
  [3652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5652),
  [3654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5651),
  [3656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7686),
  [3658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [3660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2432),
  [3662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2429),
  [3664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1406),
  [3666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5668),
  [3668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5667),
  [3670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7688),
  [3672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [3674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rules, 3, 0, 0),
  [3676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rules, 3, 0, 0),
  [3678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3873),
  [3680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3, 0, 0), SHIFT(10840),
  [3683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_expression, 6, 0, 0),
  [3685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_expression, 6, 0, 0),
  [3687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1322),
  [3689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_expression, 2, 0, 0),
  [3691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rules, 2, 0, 0),
  [3693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rules, 2, 0, 0),
  [3695] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2, 0, 0), SHIFT(10840),
  [3698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_block, 3, 0, 0),
  [3700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_block, 3, 0, 0),
  [3702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5809),
  [3704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5811),
  [3706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7849),
  [3708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [3710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1430),
  [3712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2511),
  [3714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2512),
  [3716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1364),
  [3718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6103),
  [3720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6099),
  [3722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7816),
  [3724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [3726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_float, 5, 0, 45),
  [3728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_float, 5, 0, 45),
  [3730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_expression_repeat1, 1, 0, 0),
  [3732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 1, 0, 0),
  [3734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rules, 1, 0, 0),
  [3736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rules, 1, 0, 0),
  [3738] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1, 0, 0), SHIFT(10840),
  [3741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0),
  [3743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0),
  [3745] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(3873),
  [3748] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(10840),
  [3751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_float, 2, 0, 6),
  [3753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_float, 2, 0, 6),
  [3755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1236),
  [3757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequential_expression, 2, 0, 0),
  [3759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequential_expression, 2, 0, 0),
  [3761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10175),
  [3763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9427),
  [3765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0),
  [3767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0),
  [3769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(853),
  [3772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_expression, 4, 0, 0),
  [3774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_expression, 4, 0, 0),
  [3776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1372),
  [3778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0),
  [3781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0),
  [3784] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(10371),
  [3788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10305),
  [3790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1, 0, 0), SHIFT(9061),
  [3793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10396),
  [3796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10396),
  [3798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule, 3, 0, 42),
  [3800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rule, 3, 0, 42),
  [3802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5659),
  [3805] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10305),
  [3808] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9061),
  [3811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_expression, 8, 0, 0),
  [3813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_expression, 8, 0, 0),
  [3815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1419),
  [3817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10371),
  [3819] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10371),
  [3822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9509),
  [3824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9959),
  [3826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 3, 0, 0),
  [3828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 3, 0, 0),
  [3830] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9269),
  [3833] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6129),
  [3836] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1, 0, 0), SHIFT(9269),
  [3839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule, 5, 0, 64),
  [3841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rule, 5, 0, 64),
  [3843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sbyte, 2, 0, 0),
  [3845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sbyte, 2, 0, 0),
  [3847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9632),
  [3849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9410),
  [3851] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9195),
  [3854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression, 7, 0, 57),
  [3856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_expression, 7, 0, 57),
  [3858] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(9427),
  [3861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_expression, 7, 0, 0),
  [3863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_expression, 7, 0, 0),
  [3865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_application_expression, 1, 0, 0),
  [3867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_application_expression, 1, 0, 0),
  [3869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9929),
  [3871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9531),
  [3873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ce_expression, 6, 0, 51),
  [3875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ce_expression, 6, 0, 51),
  [3877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10600),
  [3879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0),
  [3881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0),
  [3883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_triple_quoted_string, 3, 0, 0),
  [3885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_triple_quoted_string, 3, 0, 0),
  [3887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_long_identifier_or_op, 3, 0, 0),
  [3889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_long_identifier_or_op, 3, 0, 0),
  [3891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_expression, 6, 0, 56),
  [3893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_expression, 6, 0, 56),
  [3895] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5811),
  [3898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression, 6, 0, 50),
  [3900] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_expression, 6, 0, 50),
  [3902] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(9959),
  [3905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression, 6, 0, 0),
  [3907] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_expression, 6, 0, 0),
  [3909] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(763),
  [3912] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6099),
  [3915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 5, 0, 49),
  [3917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 5, 0, 49),
  [3919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__high_prec_app, 2, 0, 0),
  [3921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__high_prec_app, 2, 0, 0),
  [3923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4137),
  [3925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 1, 0, 0),
  [3927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 1, 0, 0),
  [3929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__else_expression, 2, 0, 48),
  [3931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__else_expression, 2, 0, 48),
  [3933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_verbatim_bytearray, 3, 0, 0),
  [3935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_verbatim_bytearray, 3, 0, 0),
  [3937] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5651),
  [3940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_expression, 5, 0, 30),
  [3942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_expression, 5, 0, 30),
  [3944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_triple_quoted_string, 1, 0, 0),
  [3946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_triple_quoted_string, 1, 0, 0),
  [3948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bytearray, 3, 0, 0),
  [3950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bytearray, 3, 0, 0),
  [3952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_string, 3, 0, 0),
  [3954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_string, 3, 0, 0),
  [3956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ieee64, 2, 0, 0),
  [3958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ieee64, 2, 0, 0),
  [3960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ieee32, 2, 0, 0),
  [3962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ieee32, 2, 0, 0),
  [3964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_expression, 5, 0, 46),
  [3966] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_expression, 5, 0, 46),
  [3968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10348),
  [3970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_string, 2, 0, 0),
  [3972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_string, 2, 0, 0),
  [3974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_verbatim_string, 3, 0, 0),
  [3976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_verbatim_string, 3, 0, 0),
  [3978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_begin_end_expression, 5, 0, 28),
  [3980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_begin_end_expression, 5, 0, 28),
  [3982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression, 5, 0, 0),
  [3984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_expression, 5, 0, 0),
  [3986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_expression, 5, 0, 0),
  [3988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_expression, 5, 0, 0),
  [3990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_expression, 5, 0, 0),
  [3992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_expression, 5, 0, 0),
  [3994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bytearray, 2, 0, 0),
  [3996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bytearray, 2, 0, 0),
  [3998] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10348),
  [4001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_verbatim_bytearray, 2, 0, 0),
  [4003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_verbatim_bytearray, 2, 0, 0),
  [4005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paren_expression, 3, 0, 0),
  [4007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_paren_expression, 3, 0, 0),
  [4009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_expression, 3, 0, 0),
  [4011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_expression, 3, 0, 0),
  [4013] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5667),
  [4016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_byte, 2, 0, 0),
  [4018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_byte, 2, 0, 0),
  [4020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 3, 0, 0),
  [4022] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 3, 0, 0),
  [4024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2938),
  [4026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2937),
  [4028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2936),
  [4030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2935),
  [4032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2934),
  [4034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2933),
  [4036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2932),
  [4038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2930),
  [4040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2910),
  [4042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2909),
  [4044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2908),
  [4046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2907),
  [4048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2682),
  [4050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10814),
  [4052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_int16, 2, 0, 0),
  [4054] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_int16, 2, 0, 0),
  [4056] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10302),
  [4059] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9062),
  [4062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_verbatim_string, 2, 0, 0),
  [4064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_verbatim_string, 2, 0, 0),
  [4066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10302),
  [4068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9572),
  [4070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9493),
  [4072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_expression, 3, 0, 0),
  [4074] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_expression, 3, 0, 0),
  [4076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_literal, 2, 0, 0),
  [4078] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_literal, 2, 0, 0),
  [4080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_uint16, 2, 0, 0),
  [4082] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_uint16, 2, 0, 0),
  [4084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_int32, 2, 0, 0),
  [4086] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_int32, 2, 0, 0),
  [4088] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9091),
  [4091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_uint32, 2, 0, 0),
  [4093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_uint32, 2, 0, 0),
  [4095] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1, 0, 0), SHIFT(9060),
  [4098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier_or_op, 1, 0, 0),
  [4100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__identifier_or_op, 1, 0, 0),
  [4102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_char, 1, 0, 0),
  [4104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_char, 1, 0, 0),
  [4106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nativeint, 2, 0, 0),
  [4108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nativeint, 2, 0, 0),
  [4110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unativeint, 2, 0, 0),
  [4112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unativeint, 2, 0, 0),
  [4114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10308),
  [4116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_int64, 2, 0, 0),
  [4118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_int64, 2, 0, 0),
  [4120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_uint64, 2, 0, 0),
  [4122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_uint64, 2, 0, 0),
  [4124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bignum, 2, 0, 0),
  [4126] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bignum, 2, 0, 0),
  [4128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_triple_quoted_string, 3, 0, 0),
  [4130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_triple_quoted_string, 3, 0, 0),
  [4132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10308),
  [4135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_expression, 9, 0, 0),
  [4137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_expression, 9, 0, 0),
  [4139] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1, 0, 0), SHIFT(9195),
  [4142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1, 0, 0), SHIFT(9091),
  [4145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anon_record_expression, 5, 0, 28),
  [4147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anon_record_expression, 5, 0, 28),
  [4149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_brace_expression, 5, 0, 28),
  [4151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_brace_expression, 5, 0, 28),
  [4153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10600),
  [4156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_expression, 2, 0, 0),
  [4158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_expression, 2, 0, 0),
  [4160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 2, 0, 0),
  [4162] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 2, 0, 0),
  [4164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10012),
  [4166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9458),
  [4168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_literal, 3, 0, 0),
  [4170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_literal, 3, 0, 0),
  [4172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dot_expression, 3, 0, 18),
  [4174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dot_expression, 3, 0, 18),
  [4176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4057),
  [4178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_expression, 3, 0, 0),
  [4180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_expression, 3, 0, 0),
  [4182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_expression, 2, 0, 0),
  [4184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_active_pattern, 3, 0, 15),
  [4186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_active_pattern, 3, 0, 15),
  [4188] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1, 0, 0), SHIFT(9062),
  [4191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 4, 0, 33),
  [4193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 4, 0, 33),
  [4195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__high_prec_app, 4, 0, 0),
  [4197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__high_prec_app, 4, 0, 0),
  [4199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_expression, 4, 0, 0),
  [4201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_expression, 4, 0, 0),
  [4203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9060),
  [4206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_active_pattern, 4, 0, 15),
  [4208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_active_pattern, 4, 0, 15),
  [4210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_active_pattern, 5, 0, 44),
  [4212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_active_pattern, 5, 0, 44),
  [4214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 4, 0, 0),
  [4216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 4, 0, 0),
  [4218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 4, 0, 32),
  [4220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 4, 0, 32),
  [4222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_active_pattern, 6, 0, 55),
  [4224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_active_pattern, 6, 0, 55),
  [4226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_long_identifier_or_op, 1, 0, 0),
  [4228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_long_identifier_or_op, 1, 0, 0),
  [4230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decimal, 2, 0, 0),
  [4232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decimal, 2, 0, 0),
  [4234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_expression, 4, 0, 30),
  [4236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_expression, 4, 0, 30),
  [4238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression, 4, 0, 28),
  [4240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_expression, 4, 0, 28),
  [4242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_expression, 4, 0, 0),
  [4244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_expression, 4, 0, 0),
  [4246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fun_expression, 4, 0, 0),
  [4248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fun_expression, 4, 0, 0),
  [4250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8621),
  [4252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10700),
  [4254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(9531),
  [4257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3164),
  [4259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3159),
  [4261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3153),
  [4263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3152),
  [4265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3143),
  [4267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3139),
  [4269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3133),
  [4271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3126),
  [4273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3124),
  [4275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3120),
  [4277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3115),
  [4279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3113),
  [4281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2751),
  [4283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11067),
  [4285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2620),
  [4287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11538),
  [4289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4051),
  [4291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4120),
  [4293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3081),
  [4295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3080),
  [4297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3079),
  [4299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3078),
  [4301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3077),
  [4303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3076),
  [4305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3075),
  [4307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3074),
  [4309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3070),
  [4311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3068),
  [4313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3059),
  [4315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3058),
  [4317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2762),
  [4319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10854),
  [4321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(9493),
  [4324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4060),
  [4326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2776),
  [4328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10915),
  [4330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(9410),
  [4333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10687),
  [4335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4139),
  [4337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(9458),
  [4340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2767),
  [4342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10724),
  [4344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3775),
  [4346] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3, 0, 0), SHIFT(10920),
  [4349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3852),
  [4351] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3, 0, 0), SHIFT(10599),
  [4354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2, 0, 0), SHIFT(10599),
  [4357] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1, 0, 0), SHIFT(10599),
  [4360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10659),
  [4362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1530),
  [4364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3556),
  [4366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3555),
  [4368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3554),
  [4370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3552),
  [4372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3551),
  [4374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3550),
  [4376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3549),
  [4378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3548),
  [4380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3543),
  [4382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3542),
  [4384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3539),
  [4386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3538),
  [4388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2953),
  [4390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11873),
  [4392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10646),
  [4394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1806),
  [4396] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(3852),
  [4399] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(10599),
  [4402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1755),
  [4404] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(3775),
  [4407] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(10920),
  [4410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3417),
  [4412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3415),
  [4414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3414),
  [4416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3409),
  [4418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3408),
  [4420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3405),
  [4422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3400),
  [4424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3399),
  [4426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3398),
  [4428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3397),
  [4430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3396),
  [4432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3395),
  [4434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2886),
  [4436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11790),
  [4438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2905),
  [4440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2904),
  [4442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3251),
  [4444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3248),
  [4446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3247),
  [4448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3246),
  [4450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3245),
  [4452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3244),
  [4454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3243),
  [4456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3242),
  [4458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3241),
  [4460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3240),
  [4462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3237),
  [4464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3233),
  [4466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2787),
  [4468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10889),
  [4470] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2, 0, 0), SHIFT(10920),
  [4473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10670),
  [4475] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1, 0, 0), SHIFT(10920),
  [4478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1474),
  [4480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3343),
  [4482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3341),
  [4484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3335),
  [4486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3334),
  [4488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3333),
  [4490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3331),
  [4492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3330),
  [4494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3328),
  [4496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3324),
  [4498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3323),
  [4500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3322),
  [4502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3318),
  [4504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2842),
  [4506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11019),
  [4508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2784),
  [4510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10833),
  [4512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10740),
  [4514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1579),
  [4516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3796),
  [4518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3, 0, 0), SHIFT(10756),
  [4521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3834),
  [4523] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1, 0, 0), SHIFT(10880),
  [4526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2197),
  [4528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5791),
  [4530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5790),
  [4532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7921),
  [4534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2239),
  [4536] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10650),
  [4539] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(3796),
  [4542] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(10756),
  [4545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3056),
  [4547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3055),
  [4549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1774),
  [4551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1561),
  [4553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1974),
  [4555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5699),
  [4557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5697),
  [4559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7702),
  [4561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [4563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3768),
  [4565] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1, 0, 0), SHIFT(10940),
  [4568] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(10310),
  [4572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3795),
  [4574] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3, 0, 0), SHIFT(10397),
  [4577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2185),
  [4579] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1, 0, 0), SHIFT(10756),
  [4582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1773),
  [4584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10310),
  [4587] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2, 0, 0), SHIFT(10756),
  [4590] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1, 0, 0), SHIFT(10397),
  [4593] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(903),
  [4596] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2, 0, 0), SHIFT(10880),
  [4599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10310),
  [4601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1809),
  [4603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3112),
  [4605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3109),
  [4607] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1161),
  [4610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2, 0, 0), SHIFT(10940),
  [4613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2214),
  [4615] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2, 0, 0), SHIFT(10397),
  [4618] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3, 0, 0), SHIFT(10940),
  [4621] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(10650),
  [4625] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(3795),
  [4628] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(10397),
  [4631] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(3768),
  [4634] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(10940),
  [4637] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(3834),
  [4640] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(10880),
  [4643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10650),
  [4645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1565),
  [4647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1723),
  [4649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1970),
  [4651] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3, 0, 0), SHIFT(10880),
  [4654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11109),
  [4656] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(11109),
  [4659] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(10316),
  [4663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1913),
  [4665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2121),
  [4667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2209),
  [4669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3317),
  [4671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3311),
  [4673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8656),
  [4675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2217),
  [4677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2213),
  [4679] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10303),
  [4682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10303),
  [4684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2192),
  [4686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10502),
  [4688] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10502),
  [4691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1121),
  [4694] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1082),
  [4697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2136),
  [4699] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10316),
  [4702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10316),
  [4704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3537),
  [4706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3536),
  [4708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8788),
  [4710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1992),
  [4712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1964),
  [4714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3393),
  [4716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3391),
  [4718] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(10502),
  [4722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3232),
  [4724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3231),
  [4726] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1053),
  [4729] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(11109),
  [4733] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(10303),
  [4737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1593),
  [4739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8716),
  [4741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8700),
  [4743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10888),
  [4745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9462),
  [4747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9696),
  [4749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11158),
  [4751] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10888),
  [4754] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(11158),
  [4757] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9304),
  [4760] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9066),
  [4763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8786),
  [4765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8690),
  [4767] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1, 0, 0), SHIFT(9304),
  [4770] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1066),
  [4773] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5697),
  [4776] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5790),
  [4779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9440),
  [4781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9439),
  [4783] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1, 0, 0), SHIFT(9066),
  [4786] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(9439),
  [4789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4106),
  [4791] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(9696),
  [4794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4070),
  [4796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11669),
  [4798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2305),
  [4800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6082),
  [4802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6067),
  [4804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7802),
  [4806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [4808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10766),
  [4810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2266),
  [4812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2530),
  [4814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6081),
  [4816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6084),
  [4818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7895),
  [4820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2591),
  [4822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3769),
  [4824] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3, 0, 0), SHIFT(10327),
  [4827] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1, 0, 0), SHIFT(10327),
  [4830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3791),
  [4832] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1, 0, 0), SHIFT(10263),
  [4835] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(3769),
  [4838] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(10327),
  [4841] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2, 0, 0), SHIFT(10263),
  [4844] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3, 0, 0), SHIFT(10263),
  [4847] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(3791),
  [4850] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(10263),
  [4853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2520),
  [4855] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2, 0, 0), SHIFT(10327),
  [4858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2264),
  [4860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6109),
  [4862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7881),
  [4864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2699),
  [4866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2525),
  [4868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10340),
  [4870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2556),
  [4872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6107),
  [4874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2568),
  [4876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6134),
  [4878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6136),
  [4880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7863),
  [4882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2703),
  [4884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11369),
  [4886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11688),
  [4888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2571),
  [4890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5948),
  [4892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5947),
  [4894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7771),
  [4896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2653),
  [4898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2590),
  [4900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6003),
  [4902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6002),
  [4904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7669),
  [4906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2646),
  [4908] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10340),
  [4911] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9184),
  [4914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2548),
  [4916] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(11688),
  [4919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2516),
  [4921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2415),
  [4923] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(921),
  [4926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9705),
  [4928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9425),
  [4930] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(11688),
  [4934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2531),
  [4936] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6067),
  [4939] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(11369),
  [4943] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(11369),
  [4946] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1, 0, 0), SHIFT(9184),
  [4949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10417),
  [4951] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1090),
  [4954] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(9425),
  [4957] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9282),
  [4960] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6084),
  [4963] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(988),
  [4966] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1, 0, 0), SHIFT(9282),
  [4969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8724),
  [4971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8718),
  [4973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do, 2, 0, 0),
  [4975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do, 2, 0, 0),
  [4977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9850),
  [4979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9620),
  [4981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4119),
  [4983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10165),
  [4985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9680),
  [4987] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10417),
  [4990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4104),
  [4992] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9279),
  [4995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10407),
  [4997] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(9680),
  [5000] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9020),
  [5003] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6136),
  [5006] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1, 0, 0), SHIFT(8978),
  [5009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11512),
  [5011] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6109),
  [5014] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1, 0, 0), SHIFT(9020),
  [5017] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6002),
  [5020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9614),
  [5022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9956),
  [5024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10387),
  [5026] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1, 0, 0), SHIFT(9263),
  [5029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9803),
  [5031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10084),
  [5033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10723),
  [5035] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10407),
  [5038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10802),
  [5040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9840),
  [5042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9980),
  [5044] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9263),
  [5047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0),
  [5049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0),
  [5051] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(4698),
  [5054] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(10157),
  [5057] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(3520),
  [5060] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(3520),
  [5063] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(8023),
  [5066] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(3920),
  [5069] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(7961),
  [5072] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(7503),
  [5075] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(7629),
  [5078] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(5913),
  [5081] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(8660),
  [5084] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(8889),
  [5087] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(11488),
  [5090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10182),
  [5092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10069),
  [5094] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10723),
  [5097] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10745),
  [5100] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(9620),
  [5103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10745),
  [5105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_extension_elements, 1, 0, 0),
  [5107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_extension_elements, 1, 0, 0),
  [5109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8023),
  [5111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7961),
  [5113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7503),
  [5115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7629),
  [5117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5913),
  [5119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8660),
  [5121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8889),
  [5123] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1, 0, 0), SHIFT(9279),
  [5126] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(10600),
  [5130] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(11158),
  [5134] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10387),
  [5137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5947),
  [5140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(8978),
  [5143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4136),
  [5145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4127),
  [5147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10707),
  [5149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2561),
  [5151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(10084),
  [5154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3869),
  [5156] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2, 0, 0), SHIFT(10798),
  [5159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(7520),
  [5162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10908),
  [5164] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3, 0, 0), SHIFT(10798),
  [5167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10793),
  [5169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(3869),
  [5172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(10798),
  [5175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(9956),
  [5178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4055),
  [5180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7520),
  [5182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2574),
  [5184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(10069),
  [5187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2927),
  [5189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11048),
  [5191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4107),
  [5193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1, 0, 0), SHIFT(10798),
  [5196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(9980),
  [5199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3817),
  [5201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1, 0, 0), SHIFT(10466),
  [5204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2, 0, 0), SHIFT(10466),
  [5207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4764),
  [5209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4729),
  [5211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8556),
  [5213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3738),
  [5215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5727),
  [5217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3783),
  [5219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7351),
  [5221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7354),
  [5223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3984),
  [5225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7655),
  [5227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9335),
  [5229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9337),
  [5231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9339),
  [5233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4305),
  [5235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7364),
  [5237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7309),
  [5239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7368),
  [5241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7668),
  [5243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10299),
  [5245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10298),
  [5247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7365),
  [5249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7365),
  [5251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10296),
  [5253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4932),
  [5255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5371),
  [5257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5485),
  [5259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1167),
  [5262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11849),
  [5264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11768),
  [5266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3, 0, 0), SHIFT(10466),
  [5269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(3817),
  [5272] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(10466),
  [5275] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(10491),
  [5279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10491),
  [5281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2948),
  [5283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10637),
  [5286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2697),
  [5288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2865),
  [5290] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(3764),
  [5293] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(10712),
  [5296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3764),
  [5298] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3, 0, 0), SHIFT(10712),
  [5301] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2, 0, 0), SHIFT(10712),
  [5304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2642),
  [5306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10829),
  [5308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2619),
  [5310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3020),
  [5312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10883),
  [5314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10637),
  [5316] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(10637),
  [5320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2638),
  [5322] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1, 0, 0), SHIFT(10712),
  [5325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10992),
  [5327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10491),
  [5330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2764),
  [5332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2773),
  [5334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3874),
  [5336] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1, 0, 0), SHIFT(10535),
  [5339] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(10523),
  [5343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [5345] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2, 0, 0), SHIFT(10535),
  [5348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3461),
  [5350] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(10763),
  [5354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3, 0, 0), SHIFT(10535),
  [5357] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(3874),
  [5360] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(10535),
  [5363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier_pattern, 2, 0, 0),
  [5365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier_pattern, 2, 0, 0),
  [5367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11683),
  [5369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3887),
  [5371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3964),
  [5373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3958),
  [5375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3957),
  [5377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_implementation, 2, 0, 0),
  [5379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3443),
  [5381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_implementation, 2, 0, 0),
  [5383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10507),
  [5385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5776),
  [5387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5777),
  [5389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7912),
  [5391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3600),
  [5393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3025),
  [5395] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(3827),
  [5398] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(10212),
  [5401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3827),
  [5403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3, 0, 0), SHIFT(10212),
  [5406] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10960),
  [5409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3802),
  [5411] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1, 0, 0), SHIFT(10658),
  [5414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2779),
  [5416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(828),
  [5419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(951),
  [5422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10960),
  [5424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3064),
  [5426] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2, 0, 0), SHIFT(10658),
  [5429] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2, 0, 0), SHIFT(10212),
  [5432] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3, 0, 0), SHIFT(10658),
  [5435] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(3802),
  [5438] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(10658),
  [5441] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10523),
  [5444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8744),
  [5446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2734),
  [5448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3098),
  [5450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10763),
  [5452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(823),
  [5455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(791),
  [5458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3458),
  [5460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11865),
  [5462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3963),
  [5464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3896),
  [5466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3902),
  [5468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3904),
  [5470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3840),
  [5472] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1, 0, 0), SHIFT(10237),
  [5475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3014),
  [5477] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(10960),
  [5481] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1093),
  [5484] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1, 0, 0), SHIFT(10212),
  [5487] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10763),
  [5490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4794),
  [5492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3787),
  [5494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8258),
  [5496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8256),
  [5498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3915),
  [5500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7680),
  [5502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9205),
  [5504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9207),
  [5506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8959),
  [5508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8014),
  [5510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7229),
  [5512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7497),
  [5514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7906),
  [5516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10495),
  [5518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10496),
  [5520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8017),
  [5522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8017),
  [5524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10566),
  [5526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5059),
  [5528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5622),
  [5530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6197),
  [5532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(3840),
  [5535] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(10237),
  [5538] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2, 0, 0), SHIFT(10237),
  [5541] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3, 0, 0), SHIFT(10237),
  [5544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(858),
  [5547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3249),
  [5549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2733),
  [5551] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(961),
  [5554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10523),
  [5556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2979),
  [5558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier_pattern, 1, 0, 0),
  [5560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3880),
  [5562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier_pattern, 1, 0, 0),
  [5564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4988),
  [5566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4989),
  [5568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3981),
  [5570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7865),
  [5572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9179),
  [5574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9178),
  [5576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9081),
  [5578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5103),
  [5580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7285),
  [5582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7393),
  [5584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7706),
  [5586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10726),
  [5588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10727),
  [5590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5109),
  [5592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5109),
  [5594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4325),
  [5596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4331),
  [5598] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(981),
  [5601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8447),
  [5603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10846),
  [5605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curried_spec, 1, 0, 0),
  [5607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curried_spec, 1, 0, 0),
  [5609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_spec, 1, 0, 0),
  [5611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11450),
  [5613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3948),
  [5615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3946),
  [5617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3943),
  [5619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3939),
  [5621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curried_spec, 2, 0, 0),
  [5623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curried_spec, 2, 0, 0),
  [5625] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(11597),
  [5629] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(10673),
  [5633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3473),
  [5635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3272),
  [5637] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(896),
  [5640] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(10623),
  [5644] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(11597),
  [5647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3485),
  [5649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11597),
  [5651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4873),
  [5653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11530),
  [5655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3985),
  [5657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3956),
  [5659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7861),
  [5661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3986),
  [5663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3987),
  [5665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3989),
  [5667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10626),
  [5669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5175),
  [5671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4831),
  [5673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3861),
  [5675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8306),
  [5677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8307),
  [5679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3977),
  [5681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7662),
  [5683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9019),
  [5685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9014),
  [5687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9139),
  [5689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8304),
  [5691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7255),
  [5693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7429),
  [5695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7789),
  [5697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10768),
  [5699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10769),
  [5701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8299),
  [5703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8299),
  [5705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10728),
  [5707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5117),
  [5709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5970),
  [5711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6308),
  [5713] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(11534),
  [5717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8792),
  [5719] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1050),
  [5722] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1100),
  [5725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3806),
  [5727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4926),
  [5729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4974),
  [5731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3893),
  [5733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7780),
  [5735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9299),
  [5737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9300),
  [5739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8933),
  [5741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5062),
  [5743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7271),
  [5745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7411),
  [5747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7750),
  [5749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10564),
  [5751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10565),
  [5753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5061),
  [5755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5061),
  [5757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4326),
  [5759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4330),
  [5761] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(11534),
  [5764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3296),
  [5766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3211),
  [5768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9343),
  [5770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3371),
  [5772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10623),
  [5775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9343),
  [5778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10673),
  [5781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10673),
  [5783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10623),
  [5785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8679),
  [5787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3270),
  [5789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3267),
  [5791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11534),
  [5793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3454),
  [5795] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(966),
  [5798] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(884),
  [5801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8743),
  [5803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9484),
  [5805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5839),
  [5807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11440),
  [5809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7677),
  [5811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3264),
  [5813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11784),
  [5815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3914),
  [5817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3913),
  [5819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3912),
  [5821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3910),
  [5823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3218),
  [5825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9856),
  [5827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5886),
  [5829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11482),
  [5831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3202),
  [5833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3302),
  [5835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5055),
  [5837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3969),
  [5839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7953),
  [5841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10289),
  [5843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5254),
  [5845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3855),
  [5847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5177),
  [5849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5176),
  [5851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3959),
  [5853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7848),
  [5855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9333),
  [5857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9341),
  [5859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9217),
  [5861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5223),
  [5863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7234),
  [5865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7492),
  [5867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7903),
  [5869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10890),
  [5871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10891),
  [5873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5226),
  [5875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5226),
  [5877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4327),
  [5879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4333),
  [5881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10071),
  [5883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5929),
  [5885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11524),
  [5887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3339),
  [5889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12114),
  [5891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12103),
  [5893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9450),
  [5895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5802),
  [5897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11391),
  [5899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9525),
  [5901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5959),
  [5903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11566),
  [5905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3379),
  [5907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9845),
  [5909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5989),
  [5911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11605),
  [5913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3419),
  [5915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3325),
  [5917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9940),
  [5919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9863),
  [5921] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10846),
  [5924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9604),
  [5926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6028),
  [5928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10543),
  [5930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8781),
  [5932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9606),
  [5934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5732),
  [5936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11327),
  [5938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10161),
  [5940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6010),
  [5942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11642),
  [5944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3826),
  [5946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5183),
  [5948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5195),
  [5950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3975),
  [5952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7900),
  [5954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9186),
  [5956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9181),
  [5958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9266),
  [5960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5132),
  [5962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7301),
  [5964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7375),
  [5966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7732),
  [5968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10956),
  [5970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10957),
  [5972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5133),
  [5974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5133),
  [5976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4328),
  [5978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4332),
  [5980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9643),
  [5982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3471),
  [5984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_defn, 8, 0, 0),
  [5986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_defn, 8, 0, 0),
  [5988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3479),
  [5990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9797),
  [5992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5657),
  [5994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11251),
  [5996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_defn, 7, 0, 0),
  [5998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_defn, 7, 0, 0),
  [6000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3499),
  [6002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4176),
  [6004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9518),
  [6006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3515),
  [6008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_defn, 6, 0, 0),
  [6010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_defn, 6, 0, 0),
  [6012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3495),
  [6014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3526),
  [6016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8709),
  [6018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3547),
  [6020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3563),
  [6022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_defn, 4, 0, 0),
  [6024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_defn, 4, 0, 0),
  [6026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4153),
  [6028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8665),
  [6030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_defn, 5, 0, 0),
  [6032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_defn, 5, 0, 0),
  [6034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3574),
  [6036] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5777),
  [6039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5778),
  [6041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3865),
  [6043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5287),
  [6045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5315),
  [6047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3954),
  [6049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7828),
  [6051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9356),
  [6053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9355),
  [6055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9032),
  [6057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5279),
  [6059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7310),
  [6061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7367),
  [6063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7660),
  [6065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10624),
  [6067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10625),
  [6069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5281),
  [6071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5281),
  [6073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4329),
  [6075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4334),
  [6077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4131),
  [6079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3831),
  [6081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3878),
  [6083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3836),
  [6085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3794),
  [6087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3782),
  [6089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3763),
  [6091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3856),
  [6093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3792),
  [6095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3871),
  [6097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3845),
  [6099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3766),
  [6101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3875),
  [6103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3772),
  [6105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3767),
  [6107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3773),
  [6109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3799),
  [6111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3857),
  [6113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9456),
  [6115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, 0, 23),
  [6117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, 0, 23),
  [6119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, 0, 23), SHIFT_REPEAT(3583),
  [6122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_signature, 5, 0, 0),
  [6124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_signature, 5, 0, 0),
  [6126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11181),
  [6128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10109),
  [6130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9962),
  [6132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__val_property_defn, 6, 0, 0),
  [6134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__val_property_defn, 6, 0, 0),
  [6136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11281),
  [6138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11178),
  [6140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9901),
  [6142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11280),
  [6144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9623),
  [6146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11223),
  [6148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11225),
  [6150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9587),
  [6152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10023),
  [6154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9673),
  [6156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_or_value_defns, 2, 0, 23),
  [6158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_or_value_defns, 2, 0, 23),
  [6160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3583),
  [6162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10082),
  [6164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9946),
  [6166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9898),
  [6168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_signature, 3, 0, 0),
  [6170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_signature, 3, 0, 0),
  [6172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10044),
  [6174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9668),
  [6176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9615),
  [6178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9407),
  [6180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9426),
  [6182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_signature, 6, 0, 0),
  [6184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_signature, 6, 0, 0),
  [6186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11226),
  [6188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9567),
  [6190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_or_value_defns, 1, 0, 13),
  [6192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_or_value_defns, 1, 0, 13),
  [6194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9589),
  [6196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9755),
  [6198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9708),
  [6200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11227),
  [6202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9975),
  [6204] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(4764),
  [6207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0),
  [6209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(4729),
  [6212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(3806),
  [6215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(4926),
  [6218] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(4974),
  [6221] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(3893),
  [6224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(7780),
  [6227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(9299),
  [6230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(9300),
  [6233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(8933),
  [6236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(5062),
  [6239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(7271),
  [6242] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(7411),
  [6245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(7750),
  [6248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(10564),
  [6251] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(10565),
  [6254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(5061),
  [6257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(5061),
  [6260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(10296),
  [6263] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(4932),
  [6266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(4326),
  [6269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(4330),
  [6272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_signature, 4, 0, 0),
  [6274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_signature, 4, 0, 0),
  [6276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9655),
  [6278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_or_prop_defn, 2, 0, 35),
  [6280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_or_prop_defn, 2, 0, 35),
  [6282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_defn, 6, 0, 50),
  [6284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_defn, 6, 0, 50),
  [6286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_or_value_defn, 2, 0, 4),
  [6288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_or_value_defn, 2, 0, 4),
  [6290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_signature, 7, 0, 0),
  [6292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_signature, 7, 0, 0),
  [6294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_class_definition, 4, 0, 30),
  [6296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_class_definition, 4, 0, 30),
  [6298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4771),
  [6300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_or_value_defn_body, 5, 0, 54),
  [6302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_or_value_defn_body, 5, 0, 54),
  [6304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_defn, 7, 0, 74),
  [6306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_defn, 7, 0, 74),
  [6308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_signature, 8, 0, 0),
  [6310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_signature, 8, 0, 0),
  [6312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_class_definition, 5, 0, 46),
  [6314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_class_definition, 5, 0, 46),
  [6316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_or_value_defn_body, 3, 0, 25),
  [6318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_or_value_defn_body, 3, 0, 25),
  [6320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_class_definition, 6, 0, 56),
  [6322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_class_definition, 6, 0, 56),
  [6324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__object_members, 4, 0, 28),
  [6326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__object_members, 4, 0, 28),
  [6328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_class_definition, 5, 0, 30),
  [6330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_class_definition, 5, 0, 30),
  [6332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9264),
  [6334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_defn, 3, 0, 0),
  [6336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_defn, 3, 0, 0),
  [6338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_defn, 4, 0, 68),
  [6340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_defn, 4, 0, 68),
  [6342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_defn, 2, 0, 0),
  [6344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_defn, 2, 0, 0),
  [6346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4257),
  [6348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4256),
  [6350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4255),
  [6352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4254),
  [6354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4253),
  [6356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4252),
  [6358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4251),
  [6360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4250),
  [6362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4249),
  [6364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4248),
  [6366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4247),
  [6368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4246),
  [6370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4219),
  [6372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11205),
  [6374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_defn, 2, 0, 0),
  [6376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_defn, 2, 0, 0),
  [6378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_or_prop_defn, 2, 0, 36),
  [6380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_or_prop_defn, 2, 0, 36),
  [6382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_function_or_value_defn, 2, 0, 0),
  [6384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_function_or_value_defn, 2, 0, 0),
  [6386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_declaration, 2, 0, 0),
  [6388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value_declaration, 2, 0, 0),
  [6390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_implementation, 3, 0, 37),
  [6392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_implementation, 3, 0, 37),
  [6394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_additional_constr_defn, 4, 0, 0),
  [6396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_additional_constr_defn, 4, 0, 0),
  [6398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_defn, 4, 0, 28),
  [6400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_defn, 4, 0, 28),
  [6402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_function_or_value_defn, 3, 0, 0),
  [6404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_function_or_value_defn, 3, 0, 0),
  [6406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_or_prop_defn, 5, 0, 67),
  [6408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_or_prop_defn, 5, 0, 67),
  [6410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__val_property_defn, 8, 0, 0),
  [6412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__val_property_defn, 8, 0, 0),
  [6414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_additional_constr_defn, 5, 0, 0),
  [6416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_additional_constr_defn, 5, 0, 0),
  [6418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_defn, 3, 0, 60),
  [6420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_defn, 3, 0, 60),
  [6422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9286),
  [6424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9053),
  [6426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, 0, 4),
  [6428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, 0, 4),
  [6430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_function_or_value_defn, 1, 0, 0),
  [6432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_function_or_value_defn, 1, 0, 0),
  [6434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_defn, 4, 0, 0),
  [6436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_defn, 4, 0, 0),
  [6438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 1, 0, 0),
  [6440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__type_extension_inner, 1, 0, 0),
  [6442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_defn_elements, 1, 0, 0),
  [6444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_defn_elements, 1, 0, 0),
  [6446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_defn, 1, 0, 0),
  [6448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_defn, 1, 0, 0),
  [6450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3978),
  [6452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_defn, 5, 0, 71),
  [6454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_defn, 5, 0, 71),
  [6456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_or_value_defn, 3, 0, 12),
  [6458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_or_value_defn, 3, 0, 12),
  [6460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4919),
  [6462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4898),
  [6464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4894),
  [6466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4911),
  [6468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4815),
  [6470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4853),
  [6472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4863),
  [6474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4871),
  [6476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4865),
  [6478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4855),
  [6480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4813),
  [6482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4862),
  [6484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4846),
  [6486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4816),
  [6488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4896),
  [6490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4874),
  [6492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4003),
  [6494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5684),
  [6496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5687),
  [6498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7712),
  [6500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4028),
  [6502] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(8981),
  [6505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8981),
  [6507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exception_definition, 5, 0, 47),
  [6509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exception_definition, 5, 0, 47),
  [6511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exception_definition, 4, 0, 29),
  [6513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exception_definition, 4, 0, 29),
  [6515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4245),
  [6517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4244),
  [6519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10663),
  [6522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10663),
  [6524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 2, 0, 0),
  [6526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 2, 0, 0),
  [6528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5586),
  [6530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5688),
  [6532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 3, 0, 0),
  [6534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 3, 0, 0),
  [6536] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5687),
  [6539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0),
  [6541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0),
  [6543] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(4731),
  [6546] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(5586),
  [6549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 4, 0, 0),
  [6551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 4, 0, 0),
  [6553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4086),
  [6555] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(5580),
  [6558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5580),
  [6560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4069),
  [6562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11197),
  [6564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12092),
  [6566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9037),
  [6568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10759),
  [6570] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9037),
  [6573] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(12092),
  [6576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11602),
  [6578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10264),
  [6580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7694),
  [6582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5726),
  [6584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7383),
  [6586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11837),
  [6588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4614),
  [6590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5750),
  [6592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12101),
  [6594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4272),
  [6596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7311),
  [6598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7369),
  [6600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7664),
  [6602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10682),
  [6604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10683),
  [6606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4234),
  [6608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4234),
  [6610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3816),
  [6612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3999),
  [6614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11984),
  [6616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8485),
  [6618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_type_defn, 10, 0, 73),
  [6620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_type_defn, 10, 0, 73),
  [6622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_type_defn, 11, 0, 75),
  [6624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_type_defn, 11, 0, 75),
  [6626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [6628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7661),
  [6630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7226),
  [6632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4630),
  [6634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2704),
  [6636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4753),
  [6638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [6640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7183),
  [6642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7116),
  [6644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [6646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anon_type_defn, 6, 0, 50),
  [6648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anon_type_defn, 6, 0, 50),
  [6650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4492),
  [6652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anon_type_defn, 6, 0, 59),
  [6654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anon_type_defn, 6, 0, 59),
  [6656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4715),
  [6658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8573),
  [6660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7004),
  [6662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4779),
  [6664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11855),
  [6666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [6668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_type_defn, 9, 0, 72),
  [6670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_type_defn, 9, 0, 72),
  [6672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4718),
  [6674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anon_type_defn, 8, 0, 57),
  [6676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anon_type_defn, 8, 0, 57),
  [6678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_abbrev_defn, 5, 0, 51),
  [6680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_abbrev_defn, 5, 0, 51),
  [6682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6557),
  [6684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6116),
  [6686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6182),
  [6688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7090),
  [6690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_type_defn, 5, 0, 51),
  [6692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_type_defn, 5, 0, 51),
  [6694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type_defn, 6, 0, 58),
  [6696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type_defn, 6, 0, 58),
  [6698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6122),
  [6700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4676),
  [6702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4556),
  [6704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7318),
  [6706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4026),
  [6708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7337),
  [6710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7405),
  [6712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7207),
  [6714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5611),
  [6716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3979),
  [6718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6228),
  [6720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9089),
  [6722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9090),
  [6724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9030),
  [6726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7894),
  [6728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6236),
  [6730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7338),
  [6732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7349),
  [6734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7658),
  [6736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10357),
  [6738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10358),
  [6740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6237),
  [6742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6237),
  [6744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4722),
  [6746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4839),
  [6748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anon_type_defn, 5, 0, 51),
  [6750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anon_type_defn, 5, 0, 51),
  [6752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anon_type_defn, 7, 0, 69),
  [6754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anon_type_defn, 7, 0, 69),
  [6756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4727),
  [6758] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(11855),
  [6761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_type_defn, 5, 0, 51),
  [6763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_type_defn, 5, 0, 51),
  [6765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4170),
  [6767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type_defn, 5, 0, 51),
  [6769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type_defn, 5, 0, 51),
  [6771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4633),
  [6773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6993),
  [6775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7178),
  [6777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2597),
  [6779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [6781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [6783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2675),
  [6785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6711),
  [6787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7335),
  [6789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7131),
  [6791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_extension, 2, 0, 0),
  [6793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_extension, 2, 0, 0),
  [6795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9256),
  [6797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_type_defn, 7, 0, 50),
  [6799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_type_defn, 7, 0, 50),
  [6801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anon_type_defn, 7, 0, 50),
  [6803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anon_type_defn, 7, 0, 50),
  [6805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5635),
  [6807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4186),
  [6809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8511),
  [6811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5609),
  [6813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2527),
  [6815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [6817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type_defn, 7, 0, 66),
  [6819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type_defn, 7, 0, 66),
  [6821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_extension_elements, 4, 0, 28),
  [6823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_extension_elements, 4, 0, 28),
  [6825] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9256),
  [6828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5587),
  [6830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2629),
  [6832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4647),
  [6834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4708),
  [6836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3602),
  [6838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5553),
  [6840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4211),
  [6842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_defn_body, 1, 0, 0),
  [6844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_defn_body, 1, 0, 0),
  [6846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2659),
  [6848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [6850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 3, 0, 0),
  [6852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 3, 0, 0),
  [6854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [6856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5334),
  [6858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4695),
  [6860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9852),
  [6862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3217),
  [6864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3217),
  [6866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6054),
  [6868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6489),
  [6870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8557),
  [6872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12057),
  [6874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11975),
  [6876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3925),
  [6878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11222),
  [6880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5742),
  [6882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10919),
  [6884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10636),
  [6886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8285),
  [6888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7389),
  [6890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7588),
  [6892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5662),
  [6894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8636),
  [6896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8819),
  [6898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10634),
  [6900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11224),
  [6902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fsi_directive_decl, 3, 0, 8),
  [6904] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fsi_directive_decl, 3, 0, 8),
  [6906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12069),
  [6908] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10380),
  [6911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_defn, 7, 0, 57),
  [6913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_defn, 7, 0, 57),
  [6915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, 0, 30),
  [6917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, 0, 30),
  [6919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_abbrev, 7, 0, 57),
  [6921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_abbrev, 7, 0, 57),
  [6923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10645),
  [6925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5953),
  [6927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12063),
  [6929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_defn, 8, 0, 70),
  [6931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_defn, 8, 0, 70),
  [6933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 6, 0, 56),
  [6935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 6, 0, 56),
  [6937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_defn, 6, 0, 50),
  [6939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_defn, 6, 0, 50),
  [6941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10380),
  [6943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_decl, 2, 0, 0),
  [6945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_decl, 2, 0, 0),
  [6947] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5969),
  [6950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_abbrev, 6, 0, 50),
  [6952] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_abbrev, 6, 0, 50),
  [6954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6143),
  [6956] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6142),
  [6959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4116),
  [6961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11183),
  [6963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4134),
  [6965] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, 0, 23), SHIFT_REPEAT(3591),
  [6968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3591),
  [6970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3590),
  [6972] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, 0, 23), SHIFT_REPEAT(3590),
  [6975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4199),
  [6977] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, 0, 23), SHIFT_REPEAT(3582),
  [6980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3582),
  [6982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3588),
  [6984] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, 0, 23), SHIFT_REPEAT(3588),
  [6987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefix_op, 1, 0, 0),
  [6989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefix_op, 1, 0, 0),
  [6991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_prefix_op_repeat1, 2, 0, 0),
  [6993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_prefix_op_repeat1, 2, 0, 0),
  [6995] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_prefix_op_repeat1, 2, 0, 0), SHIFT_REPEAT(4291),
  [6998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_prefix_op_repeat1, 1, 0, 0),
  [7000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_prefix_op_repeat1, 1, 0, 0),
  [7002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__infix_or_prefix_op, 1, 0, 0),
  [7004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__infix_or_prefix_op, 1, 0, 0),
  [7006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_infix_op, 1, 0, 0),
  [7008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_infix_op, 1, 0, 0),
  [7010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_patterns, 1, 0, 0),
  [7012] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(5611),
  [7015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0),
  [7017] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(3979),
  [7020] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(6228),
  [7023] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(9089),
  [7026] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(9090),
  [7029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(9030),
  [7032] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(6236),
  [7035] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7338),
  [7038] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7349),
  [7041] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7658),
  [7044] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(10357),
  [7047] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(10358),
  [7050] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(6237),
  [7053] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(6237),
  [7056] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(4722),
  [7059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(4839),
  [7062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5088),
  [7064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5087),
  [7066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5086),
  [7068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5084),
  [7070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5082),
  [7072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5077),
  [7074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5074),
  [7076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5071),
  [7078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5070),
  [7080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5057),
  [7082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5029),
  [7084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5026),
  [7086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4775),
  [7088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11159),
  [7090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5030),
  [7092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5028),
  [7094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5027),
  [7096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5025),
  [7098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5023),
  [7100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5021),
  [7102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5016),
  [7104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5014),
  [7106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5011),
  [7108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5008),
  [7110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4999),
  [7112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4997),
  [7114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4801),
  [7116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11371),
  [7118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5225),
  [7120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5217),
  [7122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5210),
  [7124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5139),
  [7126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5205),
  [7128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5199),
  [7130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5198),
  [7132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5197),
  [7134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5196),
  [7136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5192),
  [7138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5186),
  [7140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5185),
  [7142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4845),
  [7144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10961),
  [7146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5148),
  [7148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5150),
  [7150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5154),
  [7152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5155),
  [7154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5156),
  [7156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5158),
  [7158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5160),
  [7160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5163),
  [7162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5165),
  [7164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5166),
  [7166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5170),
  [7168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5171),
  [7170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4880),
  [7172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10871),
  [7174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5317),
  [7176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5318),
  [7178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5319),
  [7180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5320),
  [7182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5321),
  [7184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5255),
  [7186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5309),
  [7188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5308),
  [7190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5306),
  [7192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5247),
  [7194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5303),
  [7196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5301),
  [7198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4945),
  [7200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11292),
  [7202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4996),
  [7204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4994),
  [7206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5024),
  [7208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5020),
  [7210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5172),
  [7212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5174),
  [7214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5184),
  [7216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5173),
  [7218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5299),
  [7220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5297),
  [7222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4403),
  [7224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_pattern, 3, 0, 0),
  [7226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_pattern, 3, 0, 0),
  [7228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6043),
  [7230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8491),
  [7232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6044),
  [7234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7636),
  [7236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4530),
  [7238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9320),
  [7240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4397),
  [7242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5716),
  [7244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5714),
  [7246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7717),
  [7248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4506),
  [7250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4446),
  [7252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5946),
  [7254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8442),
  [7256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5950),
  [7258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7927),
  [7260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4655),
  [7262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9080),
  [7264] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9320),
  [7267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4452),
  [7269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6176),
  [7271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8559),
  [7273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6179),
  [7275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7829),
  [7277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4660),
  [7279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint, 3, 0, 0),
  [7281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 3, 0, 0),
  [7283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint, 4, 0, 0),
  [7285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 4, 0, 0),
  [7287] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9080),
  [7290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9326),
  [7292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4454),
  [7294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5678),
  [7296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5676),
  [7298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7691),
  [7300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4662),
  [7302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5854),
  [7304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5846),
  [7306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7738),
  [7308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4665),
  [7310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4460),
  [7312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_atomic_type, 2, 0, 0),
  [7314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_atomic_type, 2, 0, 0),
  [7316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6026),
  [7318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6027),
  [7320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7937),
  [7322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4646),
  [7324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4439),
  [7326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9115),
  [7328] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9298),
  [7331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9067),
  [7333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9067),
  [7336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9233),
  [7338] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9115),
  [7341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9298),
  [7343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8533),
  [7345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10444),
  [7347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9233),
  [7350] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10315),
  [7353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9326),
  [7356] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10444),
  [7359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10315),
  [7361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4554),
  [7363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5978),
  [7365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8550),
  [7367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5979),
  [7369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7941),
  [7371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4681),
  [7373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4525),
  [7375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6158),
  [7377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6162),
  [7379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7843),
  [7381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4704),
  [7383] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6044),
  [7386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9357),
  [7388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9108),
  [7390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9242),
  [7393] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10353),
  [7396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5830),
  [7398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5815),
  [7400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7734),
  [7402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4682),
  [7404] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9069),
  [7407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10555),
  [7409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4523),
  [7411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4499),
  [7413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5692),
  [7415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5691),
  [7417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7693),
  [7419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4741),
  [7421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9242),
  [7423] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9108),
  [7426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5707),
  [7428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10309),
  [7430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10325),
  [7432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6047),
  [7434] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9265),
  [7437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10456),
  [7440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4559),
  [7442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5922),
  [7444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5923),
  [7446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7919),
  [7448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4687),
  [7450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9265),
  [7452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10309),
  [7455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10353),
  [7457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9069),
  [7459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10456),
  [7461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10325),
  [7464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10555),
  [7467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5714),
  [7470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9357),
  [7473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4084),
  [7475] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5846),
  [7478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9507),
  [7480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3411),
  [7482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3411),
  [7484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3906),
  [7486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11368),
  [7488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8020),
  [7490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7410),
  [7492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7522),
  [7494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6069),
  [7496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8775),
  [7498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8849),
  [7500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11248),
  [7502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11370),
  [7504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6482),
  [7506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4716),
  [7508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4968),
  [7510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6982),
  [7512] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10361),
  [7515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5844),
  [7517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10311),
  [7519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6959),
  [7521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4594),
  [7523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5964),
  [7525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5965),
  [7527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7935),
  [7529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4790),
  [7531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6180),
  [7533] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6027),
  [7536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6687),
  [7538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6645),
  [7540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6179),
  [7543] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5676),
  [7546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9328),
  [7548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4062),
  [7550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5674),
  [7552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6863),
  [7554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6809),
  [7556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10322),
  [7558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3781),
  [7560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10361),
  [7562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3808),
  [7564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6819),
  [7566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6613),
  [7568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5951),
  [7570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6581),
  [7572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6467),
  [7574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6751),
  [7576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9328),
  [7579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10533),
  [7581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6031),
  [7583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10562),
  [7585] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10562),
  [7588] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10533),
  [7591] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10322),
  [7594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6371),
  [7596] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5950),
  [7599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4272),
  [7601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6393),
  [7603] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10311),
  [7606] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5815),
  [7609] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10542),
  [7612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10542),
  [7614] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5923),
  [7617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5689),
  [7619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4083),
  [7621] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5691),
  [7624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6166),
  [7626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5801),
  [7628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10107),
  [7630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7295),
  [7632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7390),
  [7634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7766),
  [7636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11005),
  [7638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11006),
  [7640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10156),
  [7642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6778),
  [7644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7160),
  [7646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4046),
  [7648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5980),
  [7650] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5979),
  [7653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4054),
  [7655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5925),
  [7657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4129),
  [7659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4098),
  [7661] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(4698),
  [7664] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(9507),
  [7667] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(3411),
  [7670] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(3411),
  [7673] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8023),
  [7676] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(3906),
  [7679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(11368),
  [7682] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8020),
  [7685] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(7410),
  [7688] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(7522),
  [7691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(6069),
  [7694] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8775),
  [7697] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8849),
  [7700] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(11248),
  [7703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(11370),
  [7706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0),
  [7708] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(4968),
  [7711] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6162),
  [7714] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(11066),
  [7717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4072),
  [7719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4065),
  [7721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11945),
  [7723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5721),
  [7725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4172),
  [7727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11929),
  [7729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5745),
  [7731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11919),
  [7733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11137),
  [7735] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5965),
  [7738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4130),
  [7740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10036),
  [7742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3544),
  [7744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3544),
  [7746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3935),
  [7748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11511),
  [7750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8244),
  [7752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7479),
  [7754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7581),
  [7756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5862),
  [7758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8655),
  [7760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8885),
  [7762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11324),
  [7764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11513),
  [7766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_class_definition, 2, 0, 0),
  [7768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5065),
  [7770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_class_definition, 1, 0, 0),
  [7772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11066),
  [7774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6245),
  [7776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6247),
  [7778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6248),
  [7780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6250),
  [7782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6202),
  [7784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6252),
  [7786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6253),
  [7788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6257),
  [7790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6259),
  [7792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6260),
  [7794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6262),
  [7796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6264),
  [7798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5808),
  [7800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11615),
  [7802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5966),
  [7804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4056),
  [7806] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(10036),
  [7809] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(3544),
  [7812] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(3544),
  [7815] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(3935),
  [7818] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(11511),
  [7821] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8244),
  [7824] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(7479),
  [7827] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(7581),
  [7830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(5862),
  [7833] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8655),
  [7836] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8885),
  [7839] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(11324),
  [7842] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(11513),
  [7845] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(5065),
  [7848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4093),
  [7850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11350),
  [7852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9852),
  [7854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3925),
  [7856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11222),
  [7858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8285),
  [7860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7389),
  [7862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7588),
  [7864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5662),
  [7866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8636),
  [7868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8819),
  [7870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10634),
  [7872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11935),
  [7874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(11690),
  [7877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10808),
  [7879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9172),
  [7881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10913),
  [7883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11690),
  [7885] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10808),
  [7888] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9172),
  [7891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3970),
  [7893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_argument_constraints, 2, 0, 0),
  [7895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument_constraints, 2, 0, 0),
  [7897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8470),
  [7899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4693),
  [7901] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9196),
  [7904] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_argument_constraints, 3, 0, 0),
  [7906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument_constraints, 3, 0, 0),
  [7908] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2, 0, 0),
  [7910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2, 0, 0),
  [7912] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2, 0, 0), SHIFT_REPEAT(8470),
  [7915] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10913),
  [7918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10338),
  [7920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11725),
  [7922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11962),
  [7924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9196),
  [7926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10941),
  [7928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10864),
  [7930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11004),
  [7932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11814),
  [7934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11824),
  [7936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4754),
  [7938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4068),
  [7940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11745),
  [7942] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2, 0, 0), SHIFT_REPEAT(8463),
  [7945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint, 9, 0, 0),
  [7947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 9, 0, 0),
  [7949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [7951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11457),
  [7953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [7955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [7957] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(11457),
  [7960] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2, 0, 0), SHIFT_REPEAT(8535),
  [7963] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_optional_pattern, 2, 0, 0),
  [7965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_pattern, 2, 0, 0),
  [7967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8463),
  [7969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5328),
  [7971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4700),
  [7973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5860),
  [7975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5459),
  [7977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10294),
  [7979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12018),
  [7981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6148),
  [7983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10545),
  [7985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_pattern, 2, 0, 0),
  [7987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_pattern, 2, 0, 0),
  [7989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_atomic_type, 1, 0, 0),
  [7991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_atomic_type, 1, 0, 0),
  [7993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4177),
  [7995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_pattern, 2, 0, 0),
  [7997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_pattern, 2, 0, 0),
  [7999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9364),
  [8001] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9296),
  [8004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11273),
  [8006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9296),
  [8008] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9364),
  [8011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5377),
  [8013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5845),
  [8015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5526),
  [8017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12021),
  [8019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6188),
  [8021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10513),
  [8023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6268),
  [8025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6269),
  [8027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5550),
  [8029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5914),
  [8031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5572),
  [8033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12008),
  [8035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6008),
  [8037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10665),
  [8039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4793),
  [8041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [8043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint, 8, 0, 0),
  [8045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 8, 0, 0),
  [8047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6219),
  [8049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8560),
  [8051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint, 5, 0, 0),
  [8053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 5, 0, 0),
  [8055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [8057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint, 6, 0, 0),
  [8059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 6, 0, 0),
  [8061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [8063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5362),
  [8065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5832),
  [8067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5516),
  [8069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12025),
  [8071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6056),
  [8073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10476),
  [8075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [8077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [8079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [8081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8535),
  [8083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2986),
  [8085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5988),
  [8087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3584),
  [8089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11887),
  [8091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5774),
  [8093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11702),
  [8095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [8097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [8099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5417),
  [8101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5769),
  [8103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5617),
  [8105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12035),
  [8107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5773),
  [8109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10381),
  [8111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5416),
  [8113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5918),
  [8115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5582),
  [8117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12007),
  [8119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5997),
  [8121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10677),
  [8123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4795),
  [8125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8440),
  [8127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2, 0, 0),
  [8129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2, 0, 0),
  [8131] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2, 0, 0), SHIFT_REPEAT(8440),
  [8134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cons_pattern, 3, 0, 0),
  [8136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cons_pattern, 3, 0, 0),
  [8138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_disjunct_pattern, 3, 0, 0),
  [8140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_disjunct_pattern, 3, 0, 0),
  [8142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6303),
  [8144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5920),
  [8146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6435),
  [8148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12006),
  [8150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5984),
  [8152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10692),
  [8154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [8156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [8158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conjunct_pattern, 3, 0, 0),
  [8160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conjunct_pattern, 3, 0, 0),
  [8162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [8164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier_pattern, 3, 0, 0),
  [8166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier_pattern, 3, 0, 0),
  [8168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(3887),
  [8171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8658),
  [8173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(3963),
  [8176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [8178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5404),
  [8180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5825),
  [8182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5518),
  [8184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12027),
  [8186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6024),
  [8188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10457),
  [8190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8798),
  [8192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [8194] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2, 0, 0), SHIFT_REPEAT(8560),
  [8197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern, 1, 0, 0),
  [8199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern, 1, 0, 0),
  [8201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 3, 0, 24),
  [8203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 3, 0, 24),
  [8205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 3, 0, 24),
  [8207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 3, 0, 24),
  [8209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_pattern, 3, 0, 0),
  [8211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_pattern, 3, 0, 0),
  [8213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8626),
  [8215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10157),
  [8217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3520),
  [8219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3520),
  [8221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3848),
  [8223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3920),
  [8225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11515),
  [8227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7961),
  [8229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7503),
  [8231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7520),
  [8233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5913),
  [8235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8660),
  [8237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8889),
  [8239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11488),
  [8241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_paren_pattern, 3, 0, 0),
  [8243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paren_pattern, 3, 0, 0),
  [8245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_field_pattern, 3, 0, 0),
  [8247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_field_pattern, 3, 0, 0),
  [8249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4832),
  [8251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_pattern, 4, 0, 0),
  [8253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_pattern, 4, 0, 0),
  [8255] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2, 0, 0), SHIFT_REPEAT(8537),
  [8258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8654),
  [8260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9390),
  [8262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3575),
  [8264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3575),
  [8266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3883),
  [8268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11553),
  [8270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8075),
  [8272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7486),
  [8274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7621),
  [8276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5762),
  [8278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8742),
  [8280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8860),
  [8282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11555),
  [8284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 2, 0, 0),
  [8286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 2, 0, 0),
  [8288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 2, 0, 0),
  [8290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 2, 0, 0),
  [8292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8741),
  [8294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8537),
  [8296] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(9507),
  [8299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(3411),
  [8302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(3411),
  [8305] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(3906),
  [8308] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(8020),
  [8311] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(7410),
  [8314] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(7522),
  [8317] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(6069),
  [8320] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(8775),
  [8323] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(8849),
  [8326] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(11370),
  [8329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8721),
  [8331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9751),
  [8333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3513),
  [8335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3513),
  [8337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3919),
  [8339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11469),
  [8341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8073),
  [8343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7350),
  [8345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7543),
  [8347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5936),
  [8349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8639),
  [8351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8925),
  [8353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11471),
  [8355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_pattern, 3, 0, 0),
  [8357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_pattern, 3, 0, 0),
  [8359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern, 1, 0, 3),
  [8361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern, 1, 0, 3),
  [8363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9338),
  [8365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4174),
  [8367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4152),
  [8369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_atomic_type, 3, 0, 0),
  [8371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_atomic_type, 3, 0, 0),
  [8373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_check_pattern, 4, 0, 0),
  [8375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_check_pattern, 4, 0, 0),
  [8377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_check_pattern, 2, 0, 0),
  [8379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_check_pattern, 2, 0, 0),
  [8381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11674),
  [8383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_pattern, 4, 0, 39),
  [8385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_pattern, 4, 0, 39),
  [8387] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(3985),
  [8390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8661),
  [8392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4171),
  [8394] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9338),
  [8397] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(3948),
  [8400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_atomic_type, 4, 0, 0),
  [8402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_atomic_type, 4, 0, 0),
  [8404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11799),
  [8406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8783),
  [8408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9433),
  [8410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3476),
  [8412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3476),
  [8414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3911),
  [8416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11427),
  [8418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8207),
  [8420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7502),
  [8422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7624),
  [8424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5992),
  [8426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8693),
  [8428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8831),
  [8430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11429),
  [8432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_field_pattern, 4, 0, 0),
  [8434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_field_pattern, 4, 0, 0),
  [8436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7629),
  [8438] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curried_spec_repeat1, 2, 0, 0), SHIFT_REPEAT(8391),
  [8441] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curried_spec_repeat1, 2, 0, 0), SHIFT_REPEAT(4700),
  [8444] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curried_spec_repeat1, 2, 0, 0), SHIFT_REPEAT(5726),
  [8447] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curried_spec_repeat1, 2, 0, 0), SHIFT_REPEAT(7383),
  [8450] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curried_spec_repeat1, 2, 0, 0), SHIFT_REPEAT(10294),
  [8453] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curried_spec_repeat1, 2, 0, 0), SHIFT_REPEAT(11837),
  [8456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curried_spec_repeat1, 2, 0, 0), SHIFT_REPEAT(5750),
  [8459] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curried_spec_repeat1, 2, 0, 0), SHIFT_REPEAT(12101),
  [8462] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(10036),
  [8465] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(3544),
  [8468] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(3544),
  [8471] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(3935),
  [8474] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(8244),
  [8477] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(7479),
  [8480] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(7581),
  [8483] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(5862),
  [8486] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(8655),
  [8489] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(8885),
  [8492] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(11513),
  [8495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11520),
  [8497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4165),
  [8499] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(3914),
  [8502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 1, 0, 0),
  [8504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 1, 0, 0),
  [8506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5904),
  [8508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11378),
  [8510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8739),
  [8512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9665),
  [8514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3291),
  [8516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3291),
  [8518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3884),
  [8520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11302),
  [8522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8223),
  [8524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7384),
  [8526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7595),
  [8528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5895),
  [8530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8687),
  [8532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8865),
  [8534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11304),
  [8536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8993),
  [8538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8864),
  [8540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8922),
  [8542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8968),
  [8544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4097),
  [8546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8825),
  [8548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8815),
  [8550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8888),
  [8552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8975),
  [8554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8887),
  [8556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8391),
  [8558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4081),
  [8560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(9751),
  [8563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(3513),
  [8566] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(3513),
  [8569] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(3919),
  [8572] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(8073),
  [8575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(7350),
  [8578] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(7543),
  [8581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(5936),
  [8584] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(8639),
  [8587] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(8925),
  [8590] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(11471),
  [8593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4049),
  [8595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4071),
  [8597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8840),
  [8599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9011),
  [8601] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(9433),
  [8604] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(3476),
  [8607] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(3476),
  [8610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(3911),
  [8613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(8207),
  [8616] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(7502),
  [8619] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(7624),
  [8622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(5992),
  [8625] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(8693),
  [8628] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(8831),
  [8631] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(11429),
  [8634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11776),
  [8636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8836),
  [8638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5384),
  [8640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6150),
  [8642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6152),
  [8644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7850),
  [8646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5530),
  [8648] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(9852),
  [8651] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(3217),
  [8654] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(3217),
  [8657] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(3925),
  [8660] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(8285),
  [8663] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(7389),
  [8666] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(7588),
  [8669] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(5662),
  [8672] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(8636),
  [8675] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(8819),
  [8678] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(11224),
  [8681] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(9390),
  [8684] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(3575),
  [8687] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(3575),
  [8690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(3883),
  [8693] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(8075),
  [8696] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(7486),
  [8699] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(7621),
  [8702] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(5762),
  [8705] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(8742),
  [8708] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(8860),
  [8711] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(11555),
  [8714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10365),
  [8716] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9249),
  [8719] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(9665),
  [8722] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(3291),
  [8725] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(3291),
  [8728] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(3884),
  [8731] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(8223),
  [8734] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(7384),
  [8737] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(7595),
  [8740] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(5895),
  [8743] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(8687),
  [8746] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(8865),
  [8749] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_extension_inner, 2, 0, 0), SHIFT_REPEAT(11304),
  [8752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8941),
  [8754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4124),
  [8756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4629),
  [8758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type_case, 1, 0, 0),
  [8760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6163),
  [8762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type_case, 1, 0, 0),
  [8764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10612),
  [8766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5522),
  [8768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8844),
  [8770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8854),
  [8772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5469),
  [8774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11528),
  [8776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6055),
  [8778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6053),
  [8780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7795),
  [8782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5634),
  [8784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9542),
  [8786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12085),
  [8788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9249),
  [8790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6341),
  [8792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10551),
  [8794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5454),
  [8796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6022),
  [8798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6013),
  [8800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7772),
  [8802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5571),
  [8804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6492),
  [8806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5457),
  [8808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11486),
  [8810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6190),
  [8812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6192),
  [8814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7826),
  [8816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5624),
  [8818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10339),
  [8820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9151),
  [8822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7415),
  [8824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7416),
  [8826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7425),
  [8828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7434),
  [8830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7501),
  [8832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7439),
  [8834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7453),
  [8836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7455),
  [8838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7456),
  [8840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7458),
  [8842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7461),
  [8844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7468),
  [8846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7066),
  [8848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12095),
  [8850] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10365),
  [8853] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9226),
  [8856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10351),
  [8858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9226),
  [8860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_or_ident, 1, 0, 0),
  [8862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_or_ident, 1, 0, 0),
  [8864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_or_ident, 3, 0, 52),
  [8866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_or_ident, 3, 0, 52),
  [8868] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9151),
  [8871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5517),
  [8873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11331),
  [8875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5998),
  [8877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5999),
  [8879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7925),
  [8881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6083),
  [8883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10333),
  [8885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9173),
  [8887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5499),
  [8889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11609),
  [8891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5771),
  [8893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5770),
  [8895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7729),
  [8897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6168),
  [8899] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9173),
  [8902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10474),
  [8904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10318),
  [8906] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9092),
  [8909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5545),
  [8911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type_field, 3, 0, 0),
  [8913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type_field, 3, 0, 0),
  [8915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6014),
  [8917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7938),
  [8919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6160),
  [8921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9092),
  [8923] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10351),
  [8926] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10339),
  [8929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type_case, 4, 0, 0),
  [8931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type_case, 4, 0, 0),
  [8933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6015),
  [8935] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9336),
  [8938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6153),
  [8940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9336),
  [8942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11395),
  [8944] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10333),
  [8947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type_field, 1, 0, 0),
  [8949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type_field, 1, 0, 0),
  [8951] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6152),
  [8954] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9348),
  [8957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9348),
  [8959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5837),
  [8961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10465),
  [8963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type_case, 3, 0, 0),
  [8965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type_case, 3, 0, 0),
  [8967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7396),
  [8969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [8971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3116),
  [8973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3510),
  [8975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7501),
  [8977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7456),
  [8979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7475),
  [8981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7477),
  [8983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3023),
  [8985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6170),
  [8987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2090),
  [8989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2790),
  [8991] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6053),
  [8994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2424),
  [8996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3373),
  [8998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3329),
  [9000] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6013),
  [9003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6052),
  [9005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributes, 1, 0, 0),
  [9007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributes, 1, 0, 0),
  [9009] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6192),
  [9012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [9014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [9016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [9018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5472),
  [9020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributes_repeat1, 2, 0, 0),
  [9022] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributes_repeat1, 2, 0, 0), SHIFT_REPEAT(4729),
  [9025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributes_repeat1, 2, 0, 0),
  [9027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4133),
  [9029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10474),
  [9032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [9034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [9036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3253),
  [9038] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10465),
  [9041] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10318),
  [9044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [9046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6011),
  [9048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6293),
  [9050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4692),
  [9052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6000),
  [9054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11289),
  [9056] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6015),
  [9059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(11289),
  [9062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11592),
  [9064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4115),
  [9066] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5999),
  [9069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5764),
  [9071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8225),
  [9073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8248),
  [9075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8249),
  [9077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8262),
  [9079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8269),
  [9081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8275),
  [9083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8288),
  [9085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8290),
  [9087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8268),
  [9089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8183),
  [9091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8252),
  [9093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8265),
  [9095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7382),
  [9097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11458),
  [9099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4126),
  [9101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6017),
  [9103] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5770),
  [9106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4118),
  [9108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7059),
  [9110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5821),
  [9112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7201),
  [9114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12029),
  [9116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5943),
  [9118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10437),
  [9120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5735),
  [9122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1534),
  [9124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12043),
  [9126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5656),
  [9128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10342),
  [9130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5694),
  [9132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2684),
  [9134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11927),
  [9136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6004),
  [9138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11244),
  [9140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6078),
  [9142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4008),
  [9144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11968),
  [9146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5679),
  [9148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10972),
  [9150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6828),
  [9152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5759),
  [9154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7078),
  [9156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12038),
  [9158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5704),
  [9160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10362),
  [9162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5737),
  [9164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1388),
  [9166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12042),
  [9168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5664),
  [9170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10347),
  [9172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6988),
  [9174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6063),
  [9176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7206),
  [9178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11947),
  [9180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5875),
  [9182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11107),
  [9184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7082),
  [9186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6156),
  [9188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7091),
  [9190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11954),
  [9192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5799),
  [9194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11121),
  [9196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5753),
  [9198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1499),
  [9200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12041),
  [9202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5669),
  [9204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10350),
  [9206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8089),
  [9208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5842),
  [9210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8368),
  [9212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12022),
  [9214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6159),
  [9216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10503),
  [9218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5755),
  [9220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4488),
  [9222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12040),
  [9224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5681),
  [9226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10352),
  [9228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5855),
  [9230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4587),
  [9232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12019),
  [9234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6157),
  [9236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10534),
  [9238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6117),
  [9240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2250),
  [9242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11961),
  [9244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5700),
  [9246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11030),
  [9248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6770),
  [9250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5648),
  [9252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7074),
  [9254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11917),
  [9256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6092),
  [9258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11468),
  [9260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5756),
  [9262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4602),
  [9264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12039),
  [9266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5693),
  [9268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10354),
  [9270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5761),
  [9272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4407),
  [9274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12037),
  [9276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5717),
  [9278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10366),
  [9280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5838),
  [9282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1495),
  [9284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12023),
  [9286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6106),
  [9288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10492),
  [9290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6785),
  [9292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5824),
  [9294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7079),
  [9296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12028),
  [9298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5983),
  [9300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10447),
  [9302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8316),
  [9304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5766),
  [9306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8546),
  [9308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12036),
  [9310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5731),
  [9312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10372),
  [9314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_access_modifier, 1, 0, 0),
  [9316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_access_modifier, 1, 0, 0),
  [9318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5782),
  [9320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4535),
  [9322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12032),
  [9324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5861),
  [9326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10408),
  [9328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6321),
  [9330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5834),
  [9332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2545),
  [9334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12024),
  [9336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6086),
  [9338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10485),
  [9340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5940),
  [9342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4558),
  [9344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12001),
  [9346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5945),
  [9348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10773),
  [9350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5865),
  [9352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2635),
  [9354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12016),
  [9356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6133),
  [9358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10563),
  [9360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__attribute_set, 4, 0, 0),
  [9362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attribute_set, 4, 0, 0),
  [9364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7052),
  [9366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5775),
  [9368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7145),
  [9370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12034),
  [9372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5793),
  [9374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10388),
  [9376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5829),
  [9378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2232),
  [9380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11867),
  [9382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5798),
  [9384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11798),
  [9386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__attribute_set, 3, 0, 0),
  [9388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attribute_set, 3, 0, 0),
  [9390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5780),
  [9392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4605),
  [9394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12033),
  [9396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5833),
  [9398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10398),
  [9400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6336),
  [9402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6020),
  [9404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [9406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11982),
  [9408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5807),
  [9410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10897),
  [9412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5588),
  [9414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributes_repeat1, 1, 0, 0),
  [9416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributes_repeat1, 1, 0, 0),
  [9418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5877),
  [9420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2623),
  [9422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12014),
  [9424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6101),
  [9426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10585),
  [9428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7030),
  [9430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5733),
  [9432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7103),
  [9434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11907),
  [9436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6113),
  [9438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11489),
  [9440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6793),
  [9442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5993),
  [9444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7076),
  [9446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11989),
  [9448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5850),
  [9450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10875),
  [9452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6773),
  [9454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5884),
  [9456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6986),
  [9458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12012),
  [9460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6070),
  [9462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10614),
  [9464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7056),
  [9466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5892),
  [9468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7107),
  [9470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12011),
  [9472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6062),
  [9474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10628),
  [9476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5869),
  [9478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1410),
  [9480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12015),
  [9482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6119),
  [9484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10575),
  [9486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5803),
  [9488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1229),
  [9490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12030),
  [9492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5911),
  [9494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10425),
  [9496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6611),
  [9498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5800),
  [9500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6784),
  [9502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12031),
  [9504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5890),
  [9506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10418),
  [9508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8072),
  [9510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5831),
  [9512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8311),
  [9514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12026),
  [9516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6040),
  [9518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10467),
  [9520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5876),
  [9522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2716),
  [9524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11937),
  [9526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5949),
  [9528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11220),
  [9530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6605),
  [9532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5971),
  [9534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6799),
  [9536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11996),
  [9538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5894),
  [9540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10857),
  [9542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5944),
  [9544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4615),
  [9546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11999),
  [9548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5921),
  [9550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10719),
  [9552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5909),
  [9554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4491),
  [9556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12009),
  [9558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6023),
  [9560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10653),
  [9562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5931),
  [9564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4744),
  [9566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12003),
  [9568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5963),
  [9570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10749),
  [9572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8363),
  [9574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8360),
  [9576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8354),
  [9578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8353),
  [9580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8346),
  [9582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8342),
  [9584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8340),
  [9586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8338),
  [9588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8336),
  [9590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8332),
  [9592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8327),
  [9594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8323),
  [9596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7596),
  [9598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11111),
  [9600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5864),
  [9602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4191),
  [9604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12017),
  [9606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6139),
  [9608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10556),
  [9610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5926),
  [9612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4586),
  [9614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12005),
  [9616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5975),
  [9618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10735),
  [9620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5882),
  [9622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2583),
  [9624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12013),
  [9626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6080),
  [9628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10592),
  [9630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5906),
  [9632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4455),
  [9634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12010),
  [9636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6041),
  [9638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10638),
  [9640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4077),
  [9642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4078),
  [9644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5847),
  [9646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4540),
  [9648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12020),
  [9650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6173),
  [9652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10524),
  [9654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4082),
  [9656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3585),
  [9658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8269),
  [9660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8268),
  [9662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8100),
  [9664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8094),
  [9666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5743),
  [9668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5744),
  [9670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7791),
  [9672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6695),
  [9674] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributes_repeat1, 2, 0, 0), SHIFT_REPEAT(4698),
  [9677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, 0, 23), SHIFT_REPEAT(3585),
  [9680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_type_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(4698),
  [9683] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_type_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(8023),
  [9686] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_type_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(3882),
  [9689] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_type_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(8221),
  [9692] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_type_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(7480),
  [9695] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_type_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(7574),
  [9698] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_type_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(6181),
  [9701] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_type_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(8755),
  [9704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_type_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(8898),
  [9707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interface_type_defn_repeat1, 2, 0, 0),
  [9709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3882),
  [9711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8221),
  [9713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7480),
  [9715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7574),
  [9717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6181),
  [9719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8755),
  [9721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8898),
  [9723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11811),
  [9725] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9051),
  [9728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9051),
  [9730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7926),
  [9732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6534),
  [9734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11818),
  [9736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11640),
  [9738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11639),
  [9740] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9354),
  [9743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11638),
  [9745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11636),
  [9747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__atomic_pattern, 1, 0, 0),
  [9749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__atomic_pattern, 1, 0, 0),
  [9751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11635),
  [9753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11634),
  [9755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9354),
  [9757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11633),
  [9759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11789),
  [9761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11632),
  [9763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 3, 0, 22),
  [9765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 3, 0, 22),
  [9767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3596),
  [9769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(11789),
  [9772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5985),
  [9774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5986),
  [9776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11731),
  [9778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11732),
  [9780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11925),
  [9782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11949),
  [9784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__atomic_pattern, 3, 0, 0),
  [9786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__atomic_pattern, 3, 0, 0),
  [9788] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, 0, 23), SHIFT_REPEAT(3596),
  [9791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11948),
  [9793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5522),
  [9795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10887),
  [9797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 1, 0, 2),
  [9799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 1, 0, 2),
  [9801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_argument_patterns_repeat1, 1, 0, 0),
  [9803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 1, 0, 0),
  [9805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10899),
  [9807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11141),
  [9809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11819),
  [9811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10482),
  [9813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11721),
  [9815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 2, 0, 11),
  [9817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 2, 0, 11),
  [9819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8346),
  [9821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8336),
  [9823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8339),
  [9825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8302),
  [9827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7909),
  [9829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 1, 0, 0),
  [9831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 1, 0, 0),
  [9833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_class_definition_repeat1, 2, 0, 0),
  [9835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_inherits_decl, 4, 0, 28),
  [9837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_inherits_decl, 4, 0, 28),
  [9839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11301),
  [9841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11303),
  [9843] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10612),
  [9846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type_fields, 2, 0, 0),
  [9848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type_fields, 2, 0, 0),
  [9850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5601),
  [9852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_inherits_decl, 5, 0, 71),
  [9854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_inherits_decl, 5, 0, 71),
  [9856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type_case, 2, 0, 0),
  [9858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6001),
  [9860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type_case, 2, 0, 0),
  [9862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5527),
  [9864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11318),
  [9866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5896),
  [9868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8501),
  [9870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5902),
  [9872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7887),
  [9874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6948),
  [9876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11316),
  [9878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type_fields, 1, 0, 0),
  [9880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type_fields, 1, 0, 0),
  [9882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11305),
  [9884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11307),
  [9886] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10482),
  [9889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_type_body_inner, 1, 0, 0),
  [9891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_type_body_inner, 1, 0, 0),
  [9893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11312),
  [9895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_union_type_fields_repeat1, 2, 0, 0),
  [9897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_union_type_fields_repeat1, 2, 0, 0),
  [9899] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_type_fields_repeat1, 2, 0, 0), SHIFT_REPEAT(5601),
  [9902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11313),
  [9904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5987),
  [9906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11475),
  [9908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11474),
  [9910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5888),
  [9912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5880),
  [9914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7745),
  [9916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6951),
  [9918] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9124),
  [9921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11473),
  [9923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11563),
  [9925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11479),
  [9927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11480),
  [9929] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2, 0, 0), SHIFT_REPEAT(4698),
  [9932] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2, 0, 0), SHIFT_REPEAT(8023),
  [9935] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2, 0, 0), SHIFT_REPEAT(3926),
  [9938] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2, 0, 0), SHIFT_REPEAT(8058),
  [9941] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2, 0, 0), SHIFT_REPEAT(7498),
  [9944] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2, 0, 0), SHIFT_REPEAT(7536),
  [9947] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2, 0, 0), SHIFT_REPEAT(8794),
  [9950] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2, 0, 0), SHIFT_REPEAT(8904),
  [9953] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2, 0, 0), SHIFT_REPEAT(7035),
  [9956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2, 0, 0),
  [9958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11472),
  [9960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9969),
  [9962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11562),
  [9964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11470),
  [9966] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9161),
  [9969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3580),
  [9971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11560),
  [9973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type_cases, 2, 0, 0),
  [9975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type_cases, 2, 0, 0),
  [9977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8596),
  [9979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9124),
  [9981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11559),
  [9983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11558),
  [9985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9951),
  [9987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11557),
  [9989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11556),
  [9991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3926),
  [9993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8058),
  [9995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7498),
  [9997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7536),
  [9999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8794),
  [10001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8904),
  [10003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7035),
  [10005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__member_defns, 2, 0, 0),
  [10007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11554),
  [10009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9636),
  [10011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9161),
  [10013] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5744),
  [10016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9697),
  [10018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5746),
  [10020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_union_type_cases_repeat1, 2, 0, 0),
  [10022] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_union_type_cases_repeat1, 2, 0, 0),
  [10024] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_type_cases_repeat1, 2, 0, 0), SHIFT_REPEAT(8596),
  [10027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6090),
  [10029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8518),
  [10031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6089),
  [10033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7907),
  [10035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7169),
  [10037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, 0, 23), SHIFT_REPEAT(3580),
  [10040] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, 0, 23), SHIFT_REPEAT(3581),
  [10043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3581),
  [10045] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5986),
  [10048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type_cases, 3, 0, 0),
  [10050] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type_cases, 3, 0, 0),
  [10052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6071),
  [10054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8455),
  [10056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6072),
  [10058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7914),
  [10060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7152),
  [10062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__member_defns, 1, 0, 0),
  [10064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type_cases, 1, 0, 0),
  [10066] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type_cases, 1, 0, 0),
  [10068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11476),
  [10070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11895),
  [10072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5981),
  [10074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5977),
  [10076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7769),
  [10078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7148),
  [10080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5703),
  [10082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5702),
  [10084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7699),
  [10086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7150),
  [10088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9747),
  [10090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9373),
  [10092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5851),
  [10094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5852),
  [10096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7867),
  [10098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7093),
  [10100] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, 0, 23), SHIFT_REPEAT(3586),
  [10103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10073),
  [10105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8472),
  [10107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11232),
  [10109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11242),
  [10111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10326),
  [10113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10326),
  [10116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 4, 0, 34),
  [10118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 4, 0, 34),
  [10120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11241),
  [10122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10081),
  [10124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9373),
  [10127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 4, 0, 22),
  [10129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 4, 0, 22),
  [10131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3595),
  [10133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11239),
  [10135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11238),
  [10137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11237),
  [10139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11236),
  [10141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4108),
  [10143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4076),
  [10145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10584),
  [10147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11918),
  [10149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11915),
  [10151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11908),
  [10153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11905),
  [10155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11900),
  [10157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11899),
  [10159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11896),
  [10161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9147),
  [10163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9074),
  [10165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3586),
  [10167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9305),
  [10169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5788),
  [10171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8526),
  [10173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5784),
  [10175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7807),
  [10177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7294),
  [10179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9305),
  [10182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9126),
  [10184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11234),
  [10186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 2, 0, 2),
  [10188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 2, 0, 2),
  [10190] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, 0, 23), SHIFT_REPEAT(3595),
  [10193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9754),
  [10195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9147),
  [10198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9126),
  [10201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 3, 0, 11),
  [10203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 3, 0, 11),
  [10205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10584),
  [10208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9074),
  [10211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6114),
  [10213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6120),
  [10215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7742),
  [10217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7263),
  [10219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11806),
  [10221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5640),
  [10223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5934),
  [10225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7757),
  [10227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7316),
  [10229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5786),
  [10231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7731),
  [10233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7333),
  [10235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8998),
  [10237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9273),
  [10239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10787),
  [10241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10424),
  [10243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10143),
  [10245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10142),
  [10247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10139),
  [10249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10136),
  [10251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10135),
  [10253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10134),
  [10255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10133),
  [10257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10128),
  [10259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10127),
  [10261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10126),
  [10263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10125),
  [10265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10124),
  [10267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8683),
  [10269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10788),
  [10271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11805),
  [10273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11808),
  [10275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10332),
  [10277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(8998),
  [10280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11809),
  [10282] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10332),
  [10285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9273),
  [10288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10591),
  [10290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6064),
  [10292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6065),
  [10294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7923),
  [10296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7212),
  [10298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11804),
  [10300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5789),
  [10302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10312),
  [10304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9140),
  [10306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10787),
  [10309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10591),
  [10312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9098),
  [10314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11803),
  [10316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9313),
  [10318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9140),
  [10321] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5902),
  [10324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10312),
  [10327] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10424),
  [10330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5880),
  [10333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9555),
  [10335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5905),
  [10337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9098),
  [10340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5879),
  [10342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11800),
  [10344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9564),
  [10346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11801),
  [10348] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9313),
  [10351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5853),
  [10353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9239),
  [10355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5974),
  [10357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4101),
  [10359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5874),
  [10361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5873),
  [10363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7952),
  [10365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7478),
  [10367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6380),
  [10369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9817),
  [10371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8213),
  [10373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7418),
  [10375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7571),
  [10377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8628),
  [10379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8828),
  [10381] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10689),
  [10384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10702),
  [10386] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5977),
  [10389] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9239),
  [10392] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5852),
  [10395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10689),
  [10397] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9148),
  [10400] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10435),
  [10403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6072),
  [10406] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5702),
  [10409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4067),
  [10411] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10321),
  [10414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9148),
  [10416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10321),
  [10418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10832),
  [10420] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6089),
  [10423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9830),
  [10425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3809),
  [10427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8032),
  [10429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7374),
  [10431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7527),
  [10433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8607),
  [10435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8876),
  [10437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9460),
  [10439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8011),
  [10441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7465),
  [10443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7630),
  [10445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8619),
  [10447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8859),
  [10449] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10702),
  [10452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9511),
  [10454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8271),
  [10456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7483),
  [10458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7600),
  [10460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8672),
  [10462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8835),
  [10464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10147),
  [10466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8013),
  [10468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7488),
  [10470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7591),
  [10472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8641),
  [10474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8810),
  [10476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10435),
  [10478] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10832),
  [10481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6088),
  [10483] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10330),
  [10486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10330),
  [10488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributes_repeat1, 2, 0, 0), SHIFT_REPEAT(4695),
  [10491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7618),
  [10493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7070),
  [10495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5701),
  [10497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12049),
  [10499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6073),
  [10501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4110),
  [10503] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9107),
  [10506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6120),
  [10509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9817),
  [10511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8213),
  [10513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7418),
  [10515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7571),
  [10517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8628),
  [10519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8828),
  [10521] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(11016),
  [10524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5786),
  [10527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9475),
  [10529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8044),
  [10531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7345),
  [10533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7540),
  [10535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8752),
  [10537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8824),
  [10539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11016),
  [10541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4079),
  [10543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5927),
  [10545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5785),
  [10547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4058),
  [10549] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5934),
  [10552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4059),
  [10554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9631),
  [10556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8257),
  [10558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7353),
  [10560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7626),
  [10562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8706),
  [10564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8866),
  [10566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10135),
  [10568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10127),
  [10570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10122),
  [10572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10120),
  [10574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4102),
  [10576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5783),
  [10578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6123),
  [10580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10106),
  [10582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8273),
  [10584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7496),
  [10586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7582),
  [10588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8632),
  [10590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8874),
  [10592] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6065),
  [10595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6066),
  [10597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9107),
  [10599] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5784),
  [10602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8155),
  [10604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8155),
  [10606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8171),
  [10608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [10610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1850),
  [10612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10011),
  [10614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12107),
  [10616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10005),
  [10618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8171),
  [10620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3349),
  [10622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1816),
  [10624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3277),
  [10626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3589),
  [10628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2402),
  [10630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7972),
  [10632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5872),
  [10634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1938),
  [10636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1909),
  [10638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2463),
  [10640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8139),
  [10642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5870),
  [10644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5871),
  [10646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7646),
  [10648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7930),
  [10650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4089),
  [10652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5232),
  [10654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2059),
  [10656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5122),
  [10658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3016),
  [10660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3179),
  [10662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3593),
  [10664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1356),
  [10666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3440),
  [10668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2204),
  [10670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4087),
  [10672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8334),
  [10674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8297),
  [10676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2421),
  [10678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2140),
  [10680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3389),
  [10682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4053),
  [10684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1954),
  [10686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1365),
  [10688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5036),
  [10690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4985),
  [10692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1849),
  [10694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2475),
  [10696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1886),
  [10698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3561),
  [10700] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5873),
  [10703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5001),
  [10705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3255),
  [10707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10119),
  [10709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5094),
  [10711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3229),
  [10713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3523),
  [10715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10146),
  [10717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7451),
  [10719] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, 0, 23), SHIFT_REPEAT(3589),
  [10722] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, 0, 23), SHIFT_REPEAT(3593),
  [10725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5141),
  [10727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4238),
  [10729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2903),
  [10731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2943),
  [10733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5178),
  [10735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4109),
  [10737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7407),
  [10739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5313),
  [10741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4263),
  [10743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5285),
  [10745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3085),
  [10747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3053),
  [10749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6281),
  [10751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2164),
  [10753] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_format_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8155),
  [10756] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_format_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8155),
  [10759] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_format_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8171),
  [10762] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_format_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1032),
  [10765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_format_string_repeat1, 2, 0, 0),
  [10767] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_format_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8171),
  [10770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6292),
  [10772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4085),
  [10774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2079),
  [10776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8227),
  [10778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8227),
  [10780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8228),
  [10782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2370),
  [10784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2400),
  [10786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3123),
  [10788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3061),
  [10790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1979),
  [10792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [10794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9444),
  [10796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7790),
  [10798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8812),
  [10800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6284),
  [10802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6282),
  [10804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11437),
  [10806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6220),
  [10808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6242),
  [10810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9821),
  [10812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7904),
  [10814] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(8227),
  [10817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(8227),
  [10820] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(8228),
  [10823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__string_literal_repeat1, 2, 0, 0),
  [10825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__string_literal_repeat1, 2, 0, 0),
  [10827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9598),
  [10829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7725),
  [10831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8929),
  [10833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3017),
  [10835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3051),
  [10837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3006),
  [10839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2969),
  [10841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11713),
  [10843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11714),
  [10845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2810),
  [10847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2941),
  [10849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5268),
  [10851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5248),
  [10853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2821),
  [10855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2901),
  [10857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5322),
  [10859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5314),
  [10861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7510),
  [10863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7412),
  [10865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4279),
  [10867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4260),
  [10869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5131),
  [10871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5179),
  [10873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9881),
  [10875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7947),
  [10877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8917),
  [10879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5118),
  [10881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5144),
  [10883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4235),
  [10885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4236),
  [10887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9624),
  [10889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7491),
  [10891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7445),
  [10893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9745),
  [10895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3531),
  [10897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3531),
  [10899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7663),
  [10901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8871),
  [10903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7347),
  [10905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9640),
  [10907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7700),
  [10909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9822),
  [10911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7753),
  [10913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10101),
  [10915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10145),
  [10917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3214),
  [10919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3522),
  [10921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5095),
  [10923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5090),
  [10925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3438),
  [10927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3228),
  [10929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5060),
  [10931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4987),
  [10933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11199),
  [10935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9656),
  [10937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10100),
  [10939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10115),
  [10941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3421),
  [10943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [10945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2476),
  [10947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2481),
  [10949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5101),
  [10951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4959),
  [10953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3257),
  [10955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3559),
  [10957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9482),
  [10959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7901),
  [10961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5081),
  [10963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5034),
  [10965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9790),
  [10967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7871),
  [10969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8802),
  [10971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1848),
  [10973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [10975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1852),
  [10977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1854),
  [10979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11403),
  [10981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8308),
  [10983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8366),
  [10985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9406),
  [10987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8397),
  [10989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8335),
  [10991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11711),
  [10993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11402),
  [10995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4178),
  [10997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2210),
  [10999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [11001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3355),
  [11003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3388),
  [11005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2419),
  [11007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2411),
  [11009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10895),
  [11011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11396),
  [11013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11393),
  [11015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3313),
  [11017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3437),
  [11019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2207),
  [11021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [11023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1394),
  [11025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [11027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9398),
  [11029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11392),
  [11031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9413),
  [11033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7639),
  [11035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8853),
  [11037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11390),
  [11039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1906),
  [11041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [11043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11705),
  [11045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2367),
  [11047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2461),
  [11049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10849),
  [11051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1924),
  [11053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [11055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11706),
  [11057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1438),
  [11059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [11061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10080),
  [11063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7719),
  [11065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7644),
  [11067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8897),
  [11069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3069),
  [11071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3170),
  [11073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9749),
  [11075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7762),
  [11077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8868),
  [11079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5194),
  [11081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5121),
  [11083] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(11199),
  [11086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9709),
  [11088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7637),
  [11090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1762),
  [11092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [11094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9715),
  [11096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7841),
  [11098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8902),
  [11100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2020),
  [11102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2165),
  [11104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1763),
  [11106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [11108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5221),
  [11110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5231),
  [11112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11388),
  [11114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8160),
  [11116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7975),
  [11118] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10849),
  [11121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9853),
  [11123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7697),
  [11125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8872),
  [11127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7959),
  [11129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8206),
  [11131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9516),
  [11133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3377),
  [11135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3377),
  [11137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7852),
  [11139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8903),
  [11141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11710),
  [11143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9495),
  [11145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7718),
  [11147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9409),
  [11149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7883),
  [11151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2061),
  [11153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [11155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11708),
  [11157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11389),
  [11159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4088),
  [11161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7820),
  [11163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8895),
  [11165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3216),
  [11167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3347),
  [11169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2145),
  [11171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [11173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11709),
  [11175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3208),
  [11177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3268),
  [11179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interface_type_defn_repeat1, 1, 0, 0),
  [11181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5346),
  [11183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8013),
  [11185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8597),
  [11187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10684),
  [11189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5392),
  [11191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8044),
  [11193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8564),
  [11195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7966),
  [11197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8575),
  [11199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8436),
  [11201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8436),
  [11203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8428),
  [11205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11385),
  [11207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9158),
  [11209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8493),
  [11211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8093),
  [11213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8578),
  [11215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8143),
  [11217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8587),
  [11219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8032),
  [11221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8593),
  [11223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8126),
  [11225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8566),
  [11227] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributes_repeat1, 2, 0, 0), SHIFT_REPEAT(4700),
  [11230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(8436),
  [11233] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(8436),
  [11236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(8428),
  [11239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11093),
  [11241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 1, 0, 0),
  [11243] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10574),
  [11246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10574),
  [11248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8109),
  [11250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8602),
  [11252] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9158),
  [11255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8085),
  [11257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8599),
  [11259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8273),
  [11261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8565),
  [11263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8286),
  [11265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8569),
  [11267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5930),
  [11269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8571),
  [11271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8123),
  [11273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8601),
  [11275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11890),
  [11277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8257),
  [11279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8600),
  [11281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7565),
  [11283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8216),
  [11285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8588),
  [11287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7396),
  [11289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6061),
  [11291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_types, 1, 0, 0),
  [11293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11889),
  [11295] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2, 0, 0), SHIFT_REPEAT(8493),
  [11298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8582),
  [11300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5871),
  [11303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8011),
  [11305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8567),
  [11307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8271),
  [11309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8595),
  [11311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8018),
  [11313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8592),
  [11315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8092),
  [11317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8568),
  [11319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8591),
  [11321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8008),
  [11323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8589),
  [11325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11552),
  [11327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7276),
  [11329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11885),
  [11331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8498),
  [11333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7992),
  [11335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8462),
  [11337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8527),
  [11339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8460),
  [11341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2227),
  [11343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [11345] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2, 0, 0), SHIFT_REPEAT(8462),
  [11348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9611),
  [11350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11576),
  [11352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_verbatim_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8527),
  [11355] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_verbatim_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8460),
  [11358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_verbatim_string_repeat1, 2, 0, 0),
  [11360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_verbatim_string_repeat1, 2, 0, 0),
  [11362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_types_repeat1, 2, 0, 0),
  [11364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11193),
  [11366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9045),
  [11368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9663),
  [11370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11451),
  [11372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9163),
  [11374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2199),
  [11376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [11378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5284),
  [11380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5257),
  [11382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9231),
  [11384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7125),
  [11386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5836),
  [11388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7276),
  [11390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5835),
  [11392] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9163),
  [11395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6243),
  [11397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6244),
  [11399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5310),
  [11401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5316),
  [11403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7575),
  [11405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5649),
  [11407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8400),
  [11409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5859),
  [11411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10819),
  [11413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8280),
  [11415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4274),
  [11417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4258),
  [11419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11372),
  [11421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3901),
  [11423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3900),
  [11425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3899),
  [11427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3898),
  [11429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7413),
  [11431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7414),
  [11433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6285),
  [11435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6287),
  [11437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6039),
  [11439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6038),
  [11441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7635),
  [11443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8504),
  [11445] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(3901),
  [11448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4269),
  [11450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4262),
  [11452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7471),
  [11454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5866),
  [11456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8267),
  [11458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5897),
  [11460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11631),
  [11462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2983),
  [11464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3050),
  [11466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7443),
  [11468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7442),
  [11470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10086),
  [11472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11652),
  [11474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4572),
  [11476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3004),
  [11478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3082),
  [11480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_declaration_left, 1, 0, 0),
  [11482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value_declaration_left, 1, 0, 0),
  [11484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8224),
  [11486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6338),
  [11488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8598),
  [11490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10241),
  [11492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3917),
  [11494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8089),
  [11496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6155),
  [11498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6149),
  [11500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7825),
  [11502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8481),
  [11504] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2, 0, 0), SHIFT_REPEAT(8534),
  [11507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4936),
  [11509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5089),
  [11511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4052),
  [11513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2864),
  [11515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2939),
  [11517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2862),
  [11519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2899),
  [11521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9214),
  [11523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_attribute, 1, 0, 0),
  [11525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6336),
  [11527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4962),
  [11529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4977),
  [11531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5234),
  [11533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5180),
  [11535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8152),
  [11537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5858),
  [11539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11607),
  [11541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3947),
  [11543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3945),
  [11545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3942),
  [11547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3940),
  [11549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3916),
  [11551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9920),
  [11553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5129),
  [11555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5147),
  [11557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9915),
  [11559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11493),
  [11561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_field, 6, 0, 0),
  [11563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2484),
  [11565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [11567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12064),
  [11569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4972),
  [11571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4984),
  [11573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9948),
  [11575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11616),
  [11577] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9214),
  [11580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_field, 4, 0, 0),
  [11582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4934),
  [11584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5033),
  [11586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8452),
  [11588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12070),
  [11590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_fields, 2, 0, 0),
  [11592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8189),
  [11594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9844),
  [11596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10097),
  [11598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10144),
  [11600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3354),
  [11602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3226),
  [11604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3521),
  [11606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3519),
  [11608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3345),
  [11610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3252),
  [11612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10103),
  [11614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10114),
  [11616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4792),
  [11618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6095),
  [11620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5038),
  [11622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6178),
  [11624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11383),
  [11626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8534),
  [11628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3558),
  [11630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3557),
  [11632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8393),
  [11634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8365),
  [11636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8226),
  [11638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9574),
  [11640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11344),
  [11642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9983),
  [11644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11535),
  [11646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8352),
  [11648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8404),
  [11650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3387),
  [11652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3385),
  [11654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2181),
  [11656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2150),
  [11658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1875),
  [11660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [11662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_fields, 3, 0, 0),
  [11664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1876),
  [11666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [11668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12058),
  [11670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8154),
  [11672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2177),
  [11674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [11676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9916),
  [11678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10910),
  [11680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4891),
  [11682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6018),
  [11684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5258),
  [11686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6068),
  [11688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11077),
  [11690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3201),
  [11692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3427),
  [11694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_declaration_left, 3, 0, 0),
  [11696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value_declaration_left, 3, 0, 0),
  [11698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8022),
  [11700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1390),
  [11702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [11704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2030),
  [11706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [11708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_field, 3, 0, 0),
  [11710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4804),
  [11712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5705),
  [11714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5218),
  [11716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5760),
  [11718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10710),
  [11720] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2, 0, 0), SHIFT_REPEAT(8452),
  [11723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3971),
  [11725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2017),
  [11727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [11729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5991),
  [11731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4739),
  [11733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5709),
  [11735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4991),
  [11737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5933),
  [11739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10838),
  [11741] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2, 0, 0), SHIFT_REPEAT(8498),
  [11744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2392),
  [11746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2391),
  [11748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1775),
  [11750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [11752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8019),
  [11754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11998),
  [11756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3972),
  [11758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3973),
  [11760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3974),
  [11762] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(3971),
  [11765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1366),
  [11767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [11769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3003),
  [11771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3169),
  [11773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2399),
  [11775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [11777] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9231),
  [11780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1810),
  [11782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [11784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5216),
  [11786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5113),
  [11788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4180),
  [11790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9411),
  [11792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11408),
  [11794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2460),
  [11796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2459),
  [11798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3007),
  [11800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3052),
  [11802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8115),
  [11804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7982),
  [11806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_declaration_left, 2, 0, 0),
  [11808] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value_declaration_left, 2, 0, 0),
  [11810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4807),
  [11812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5915),
  [11814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5157),
  [11816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5677),
  [11818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10602),
  [11820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5245),
  [11822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5227),
  [11824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8199),
  [11826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8209),
  [11828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8093),
  [11830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7508),
  [11832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7553),
  [11834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8765),
  [11836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1969),
  [11838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [11840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_field, 5, 0, 0),
  [11842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9758),
  [11844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11269),
  [11846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3236),
  [11848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3346),
  [11850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7984),
  [11852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8085),
  [11854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7381),
  [11856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7628),
  [11858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8767),
  [11860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5665),
  [11862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3227),
  [11864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3262),
  [11866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2046),
  [11868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1941),
  [11870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4860),
  [11872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5796),
  [11874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9683),
  [11876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7325),
  [11878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9630),
  [11880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8316),
  [11882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5730),
  [11884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5724),
  [11886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7724),
  [11888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8579),
  [11890] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10337),
  [11893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9904),
  [11895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7106),
  [11897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9559),
  [11899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4854),
  [11901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5683),
  [11903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_member_constraint, 4, 0, 0),
  [11905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9501),
  [11907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5990),
  [11909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3928),
  [11911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3965),
  [11913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3961),
  [11915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3921),
  [11917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9718),
  [11919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [11921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9086),
  [11923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4509),
  [11925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7101),
  [11927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8881),
  [11929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4979),
  [11931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11483),
  [11933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11537),
  [11935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12083),
  [11937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9634),
  [11939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [11941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9434),
  [11943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5903),
  [11945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4941),
  [11947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_field, 1, 0, 0),
  [11949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9386),
  [11951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8834),
  [11953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7726),
  [11955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11928),
  [11957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11271),
  [11959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12059),
  [11961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9403),
  [11963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6174),
  [11965] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(9086),
  [11968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4937),
  [11970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2685),
  [11972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10166),
  [11974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [11976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9414),
  [11978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4143),
  [11980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4933),
  [11982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4931),
  [11984] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2, 0, 0), SHIFT_REPEAT(8451),
  [11987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12061),
  [11989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8503),
  [11991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9727),
  [11993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5189),
  [11995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7811),
  [11997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7812),
  [11999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4847),
  [12001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9595),
  [12003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [12005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6559),
  [12007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8576),
  [12009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9591),
  [12011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_curried_spec_repeat1, 2, 0, 0),
  [12013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_curried_spec_repeat1, 2, 0, 0),
  [12015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4844),
  [12017] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributes_repeat1, 2, 0, 0), SHIFT_REPEAT(4692),
  [12020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7297),
  [12022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9794),
  [12024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6321),
  [12026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8927),
  [12028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4811),
  [12030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7113),
  [12032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8451),
  [12034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7419),
  [12036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_member_constraint, 5, 0, 0),
  [12038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9702),
  [12040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [12042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10018),
  [12044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [12046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9016),
  [12048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4732),
  [12050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6306),
  [12052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4675),
  [12054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9826),
  [12056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [12058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8506),
  [12060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5145),
  [12062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5643),
  [12064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6999),
  [12066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [12068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5115),
  [12070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5002),
  [12072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10337),
  [12074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [12076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9861),
  [12078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2680),
  [12080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [12082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7218),
  [12084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7228),
  [12086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5276),
  [12088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [12090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10511),
  [12092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5841),
  [12094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9621),
  [12096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [12098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9921),
  [12100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5619),
  [12102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9936),
  [12104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [12106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4497),
  [12108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10129),
  [12110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_field, 3, 0, 0),
  [12112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5112),
  [12114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9785),
  [12116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [12118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7809),
  [12120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9875),
  [12122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [12124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_verbatim_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8586),
  [12127] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_verbatim_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8594),
  [12130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4656),
  [12132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4585),
  [12134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [12136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_pattern_content_repeat1, 2, 0, 0),
  [12138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8827),
  [12140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_signature, 3, 0, 0),
  [12142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8918),
  [12144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4875),
  [12146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11812),
  [12148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11346),
  [12150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12065),
  [12152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5233),
  [12154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8243),
  [12156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4183),
  [12158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5236),
  [12160] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(3928),
  [12163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6733),
  [12165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__string_literal_repeat1, 1, 0, 0),
  [12167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__string_literal_repeat1, 1, 0, 0),
  [12169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8088),
  [12171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2524),
  [12173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [12175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_format_string_repeat1, 1, 0, 0),
  [12177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_format_string_repeat1, 1, 0, 0),
  [12179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8010),
  [12181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_string_eval, 3, 0, 0),
  [12183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_string_eval, 3, 0, 0),
  [12185] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(3947),
  [12188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10009),
  [12190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8586),
  [12192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8594),
  [12194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11630),
  [12196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9914),
  [12198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5240),
  [12200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [12202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_char, 1, 0, 0),
  [12204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_char, 1, 0, 0),
  [12206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4710),
  [12208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9438),
  [12210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8856),
  [12212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5106),
  [12214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11406),
  [12216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11578),
  [12218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12087),
  [12220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9947),
  [12222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [12224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7129),
  [12226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7135),
  [12228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5794),
  [12230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_string_char, 1, 0, 0),
  [12232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_string_char, 1, 0, 0),
  [12234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8920),
  [12236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8095),
  [12238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11565),
  [12240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11495),
  [12242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12079),
  [12244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7402),
  [12246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 3, 0, 0),
  [12248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4696),
  [12250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6974),
  [12252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6126),
  [12254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11625),
  [12256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9505),
  [12258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [12260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7168),
  [12262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5092),
  [12264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [12266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5104),
  [12268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9530),
  [12270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [12272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8173),
  [12274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5078),
  [12276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5655),
  [12278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5063),
  [12280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6045),
  [12282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7099),
  [12284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [12286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [12288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [12290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4590),
  [12292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9848),
  [12294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [12296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3610),
  [12298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4207),
  [12300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5598),
  [12302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4706),
  [12304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4859),
  [12306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10511),
  [12309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [12311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2609),
  [12313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2256),
  [12315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10172),
  [12317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4749),
  [12319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5250),
  [12321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7326),
  [12323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4998),
  [12325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8804),
  [12327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5140),
  [12329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11723),
  [12331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11410),
  [12333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12071),
  [12335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10169),
  [12337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [12339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8402),
  [12341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [12343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5600),
  [12345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7424),
  [12347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9467),
  [12349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [12351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9561),
  [12353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [12355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9477),
  [12357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9487),
  [12359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [12361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8374),
  [12363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [12365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4017),
  [12367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4669),
  [12369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7144),
  [12371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6111),
  [12373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8862),
  [12375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4881),
  [12377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11644),
  [12379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11453),
  [12381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12075),
  [12383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9890),
  [12385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8165),
  [12387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9557),
  [12389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [12391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4784),
  [12393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2705),
  [12395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9891),
  [12397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9806),
  [12399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [12401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [12403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [12405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5541),
  [12407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9571),
  [12409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6035),
  [12411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4074),
  [12413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [12415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8838),
  [12417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7194),
  [12419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11054),
  [12421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11061),
  [12423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11063),
  [12425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9660),
  [12427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7728),
  [12429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9513),
  [12431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5686),
  [12433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4731),
  [12435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5623),
  [12437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9903),
  [12439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5666),
  [12441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3950),
  [12443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3932),
  [12445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3922),
  [12447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3895),
  [12449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [12451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10346),
  [12453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9008),
  [12455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5595),
  [12457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9478),
  [12459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9485),
  [12461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9796),
  [12463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [12465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6147),
  [12467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9609),
  [12469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9208),
  [12471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5632),
  [12473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10030),
  [12475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9854),
  [12477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9165),
  [12479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5563),
  [12481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9385),
  [12483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3560),
  [12485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3560),
  [12487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9782),
  [12489] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6149),
  [12492] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(3950),
  [12495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_spec, 3, 0, 0),
  [12497] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(10346),
  [12500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10096),
  [12502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8817),
  [12504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5620),
  [12506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5575),
  [12508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9251),
  [12510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5576),
  [12512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9675),
  [12514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3338),
  [12516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3338),
  [12518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10026),
  [12520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [12522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [12524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [12526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [12528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [12530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [12532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6276),
  [12534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9769),
  [12536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9576),
  [12538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [12540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(5623),
  [12543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9841),
  [12545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_spec, 2, 0, 0),
  [12547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9773),
  [12549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9581),
  [12551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9597),
  [12553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9619),
  [12555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9451),
  [12557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9538),
  [12559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [12561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8961),
  [12563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(5620),
  [12566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [12568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [12570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [12572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [12574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [12576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9807),
  [12578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9938),
  [12580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10162),
  [12582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9420),
  [12584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [12586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11551),
  [12588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10076),
  [12590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6037),
  [12592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [12594] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6038),
  [12597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [12599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [12601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [12603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [12605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5346),
  [12607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [12609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7383),
  [12611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8750),
  [12613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [12615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_name_spec, 2, 0, 61),
  [12617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_name_spec, 2, 0, 61),
  [12619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6241),
  [12621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3008),
  [12623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8614),
  [12625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8727),
  [12627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8668),
  [12629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8777),
  [12631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [12633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2814),
  [12635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8698),
  [12637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2742),
  [12639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8664),
  [12641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4047),
  [12643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [12645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8692),
  [12647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [12649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [12651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4117),
  [12653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [12655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3097),
  [12657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_verbatim_string_repeat1, 1, 0, 0),
  [12659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_verbatim_string_repeat1, 1, 0, 0),
  [12661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3035),
  [12663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8631),
  [12665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [12667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5722),
  [12669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_name_spec, 3, 0, 1),
  [12671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_name_spec, 3, 0, 1),
  [12673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__verbatim_string_char, 1, 0, 0),
  [12675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__verbatim_string_char, 1, 0, 0),
  [12677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2795),
  [12679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5724),
  [12682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8605),
  [12684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8784),
  [12686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8796),
  [12688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8678),
  [12690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3002),
  [12692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5605),
  [12694] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(5605),
  [12697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [12699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6231),
  [12701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10497),
  [12703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6231),
  [12705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6289),
  [12707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9185),
  [12709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4066),
  [12711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6338),
  [12713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7758),
  [12715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8494),
  [12717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8532),
  [12719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7267),
  [12721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4612),
  [12723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9155),
  [12725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8900),
  [12727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4621),
  [12729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4022),
  [12731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4684),
  [12733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4679),
  [12735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3601),
  [12737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7195),
  [12739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7189),
  [12741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10014),
  [12743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4550),
  [12745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4551),
  [12747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9327),
  [12749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8880),
  [12751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7186),
  [12753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8584),
  [12755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6709),
  [12757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8590),
  [12759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9429),
  [12761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11106),
  [12763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4158),
  [12765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11114),
  [12767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11110),
  [12769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3609),
  [12771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9010),
  [12773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8913),
  [12775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6127),
  [12777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6124),
  [12779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9288),
  [12781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8926),
  [12783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4019),
  [12785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6720),
  [12787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9787),
  [12789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8919),
  [12791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7188),
  [12793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7256),
  [12795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8923),
  [12797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7252),
  [12799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9202),
  [12801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8908),
  [12803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6612),
  [12805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4755),
  [12807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4743),
  [12809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7530),
  [12811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8149),
  [12813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12123),
  [12815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4649),
  [12817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4644),
  [12819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7051),
  [12821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7065),
  [12823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [12825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6667),
  [12827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [12829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11377),
  [12831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4147),
  [12833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11376),
  [12835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11894),
  [12837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8915),
  [12839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7449),
  [12841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [12843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8846),
  [12845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [12847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7313),
  [12849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7253),
  [12851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2657),
  [12853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7191),
  [12855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7200),
  [12857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5661),
  [12859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9102),
  [12861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8892),
  [12863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7192),
  [12865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7448),
  [12867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10054),
  [12869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7199),
  [12871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6990),
  [12873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [12875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [12877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5593),
  [12879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8688),
  [12881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5604),
  [12883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5646),
  [12885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8492),
  [12887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8949),
  [12889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8801),
  [12891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10781),
  [12893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7012),
  [12895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [12897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8882),
  [12899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5591),
  [12901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5589),
  [12903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6361),
  [12905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [12907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [12909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [12911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [12913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2633),
  [12915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2416),
  [12917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4678),
  [12919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8852),
  [12921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4756),
  [12923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [12925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [12927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4606),
  [12929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6328),
  [12931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8475),
  [12933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4195),
  [12935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8484),
  [12937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4627),
  [12939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5610),
  [12941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [12943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11311),
  [12945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4161),
  [12947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11310),
  [12949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11874),
  [12951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5608),
  [12953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4809),
  [12955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4803),
  [12957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4598),
  [12959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4595),
  [12961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4736),
  [12963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4735),
  [12965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2687),
  [12967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4683),
  [12969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4689),
  [12971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10024),
  [12973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [12975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5521),
  [12977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5479),
  [12979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2233),
  [12981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8930),
  [12983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4204),
  [12985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4203),
  [12987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7264),
  [12989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2663),
  [12991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7219),
  [12993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9052),
  [12995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8842),
  [12997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9864),
  [12999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2655),
  [13001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8955),
  [13003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8823),
  [13005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [13007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [13009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7853),
  [13011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2701),
  [13013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [13015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6729),
  [13017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2647),
  [13019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9238),
  [13021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8839),
  [13023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6742),
  [13025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8808),
  [13027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2595),
  [13029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2594),
  [13031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9725),
  [13033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2247),
  [13035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5797),
  [13037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5810),
  [13039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8821),
  [13041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5928),
  [13043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7877),
  [13045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7221),
  [13047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7174),
  [13049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11231),
  [13051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4141),
  [13053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11230),
  [13055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11847),
  [13057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7171),
  [13059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5941),
  [13061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9586),
  [13063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7220),
  [13065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7215),
  [13067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4197),
  [13069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8816),
  [13071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4568),
  [13073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4581),
  [13075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4628),
  [13077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4640),
  [13079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10251),
  [13081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8942),
  [13083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12072),
  [13085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11155),
  [13087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8649),
  [13089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4043),
  [13091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [13093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9774),
  [13095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11334),
  [13097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4843),
  [13099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11333),
  [13101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4044),
  [13103] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributes_repeat1, 2, 0, 0), SHIFT_REPEAT(4731),
  [13106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10521),
  [13108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9243),
  [13110] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(3777),
  [13113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(10794),
  [13116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10341),
  [13118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9370),
  [13120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4036),
  [13122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3777),
  [13124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10794),
  [13126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10270),
  [13128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8977),
  [13130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10717),
  [13132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9375),
  [13134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10331),
  [13136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9318),
  [13138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10261),
  [13140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8950),
  [13142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10389),
  [13144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9271),
  [13146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12060),
  [13148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10401),
  [13150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9190),
  [13152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11153),
  [13154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10319),
  [13156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9309),
  [13158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10672),
  [13160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9253),
  [13162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_file_repeat1, 2, 0, 0),
  [13164] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat1, 2, 0, 0), SHIFT_REPEAT(8805),
  [13167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12088),
  [13169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6988),
  [13171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_expression, 3, 0, 37),
  [13173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10662),
  [13175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9220),
  [13177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10652),
  [13179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9197),
  [13181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12076),
  [13183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10217),
  [13185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9017),
  [13187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10203),
  [13189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9082),
  [13191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11258),
  [13193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4858),
  [13195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11257),
  [13197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10411),
  [13199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9109),
  [13201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10260),
  [13203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9237),
  [13205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10613),
  [13207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9170),
  [13209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10603),
  [13211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9152),
  [13213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10470),
  [13215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8971),
  [13217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12084),
  [13219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10593),
  [13221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9142),
  [13223] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2, 0, 0), SHIFT_REPEAT(7758),
  [13226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2, 0, 0),
  [13228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11009),
  [13230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9103),
  [13232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3598),
  [13234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11398),
  [13236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4812),
  [13238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11397),
  [13240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10549),
  [13242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9084),
  [13244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_expression, 6, 0, 63),
  [13246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10245),
  [13248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9209),
  [13250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10229),
  [13252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9177),
  [13254] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__object_expression_inner_repeat1, 2, 0, 0), SHIFT_REPEAT(6181),
  [13257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__object_expression_inner_repeat1, 2, 0, 0),
  [13259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10273),
  [13261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9054),
  [13263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10539),
  [13265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9063),
  [13267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10527),
  [13269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9041),
  [13271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_expression, 5, 0, 63),
  [13273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10323),
  [13275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4868),
  [13277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10452),
  [13279] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, 0, 23), SHIFT_REPEAT(3598),
  [13282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8805),
  [13284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10480),
  [13286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9006),
  [13288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12066),
  [13290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12080),
  [13292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_expression, 4, 0, 37),
  [13294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10458),
  [13296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8953),
  [13298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10198),
  [13300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9118),
  [13302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [13304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [13306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7810),
  [13308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5611),
  [13310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3599),
  [13312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_fields_repeat1, 2, 0, 0), SHIFT_REPEAT(8111),
  [13315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_record_fields_repeat1, 2, 0, 0),
  [13317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8549),
  [13319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, 0, 23), SHIFT_REPEAT(3599),
  [13322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4305),
  [13324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10248),
  [13326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [13328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6058),
  [13330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_attributes_repeat1, 2, 0, 0), SHIFT_REPEAT(4198),
  [13333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_attributes_repeat1, 2, 0, 0),
  [13335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3653),
  [13337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9496),
  [13339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10132),
  [13341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9508),
  [13343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_type_cases, 2, 0, 0),
  [13345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4883),
  [13347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [13349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6029),
  [13351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8329),
  [13353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9194),
  [13355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5187),
  [13357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3797),
  [13359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4848),
  [13361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2044),
  [13363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [13365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3642),
  [13367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9649),
  [13369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10117),
  [13371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9276),
  [13373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6771),
  [13375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_constr_args, 5, 0, 0),
  [13377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10450),
  [13379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5013),
  [13381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_type_body, 2, 0, 0),
  [13383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6832),
  [13385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9443),
  [13387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5168),
  [13389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6870),
  [13391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9735),
  [13393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [13395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [13397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module_body, 2, 0, 0),
  [13399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6875),
  [13401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9960),
  [13403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3540),
  [13405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9553),
  [13407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [13409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8387),
  [13411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [13413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5968),
  [13415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments_spec, 2, 0, 0),
  [13417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5291),
  [13419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9461),
  [13421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5206),
  [13423] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_types_repeat1, 2, 0, 0), SHIFT_REPEAT(6061),
  [13426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5116),
  [13428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9997),
  [13430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3514),
  [13432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [13434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [13436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [13438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5642),
  [13440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6458),
  [13442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3157),
  [13444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3788),
  [13446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [13448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_ranges, 1, 0, 0),
  [13450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3158),
  [13452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9211),
  [13454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializers, 1, 0, 0),
  [13456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9394),
  [13458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5382),
  [13460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10484),
  [13462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3830),
  [13464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10731),
  [13466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9763),
  [13468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [13470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4900),
  [13472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9868),
  [13474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [13476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8319),
  [13478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3867),
  [13480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8314),
  [13482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6445),
  [13484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3424),
  [13486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6418),
  [13488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3425),
  [13490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3639),
  [13492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9831),
  [13494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10002),
  [13496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments_spec, 1, 0, 0),
  [13498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [13500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3662),
  [13502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9474),
  [13504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9965),
  [13506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6702),
  [13508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6716),
  [13510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9384),
  [13512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5378),
  [13514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6471),
  [13516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10015),
  [13518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3135),
  [13520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6722),
  [13522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7761),
  [13524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_fields, 1, 0, 0),
  [13526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__attribute_set_repeat1, 2, 0, 0),
  [13528] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__attribute_set_repeat1, 2, 0, 0), SHIFT_REPEAT(4725),
  [13531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4830),
  [13533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_constr_args, 4, 0, 0),
  [13535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10932),
  [13537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [13539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5779),
  [13541] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_initializers_repeat1, 2, 0, 0), SHIFT_REPEAT(9211),
  [13544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_initializers_repeat1, 2, 0, 0),
  [13546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10017),
  [13548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3154),
  [13550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument_defn, 1, 0, 0),
  [13552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6734),
  [13554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7431),
  [13556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9978),
  [13558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3386),
  [13560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3722),
  [13562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10046),
  [13564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9927),
  [13566] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_slice_ranges_repeat1, 2, 0, 0), SHIFT_REPEAT(651),
  [13569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_slice_ranges_repeat1, 2, 0, 0),
  [13571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3384),
  [13573] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_elements_repeat1, 2, 0, 0), SHIFT_REPEAT(800),
  [13576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_elements_repeat1, 2, 0, 0),
  [13578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [13580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5995),
  [13582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [13584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_elements, 3, 0, 0),
  [13586] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_pattern_content_repeat1, 2, 0, 0), SHIFT_REPEAT(3916),
  [13589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [13591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5907),
  [13593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3699),
  [13595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9783),
  [13597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9884),
  [13599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10553),
  [13601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8499),
  [13603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4725),
  [13605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10035),
  [13607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [13609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6301),
  [13611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6307),
  [13613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_record_pattern_repeat1, 2, 0, 0),
  [13615] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(9194),
  [13618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2546),
  [13620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2470),
  [13622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10043),
  [13624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [13626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9828),
  [13628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [13630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [13632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5939),
  [13634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10006),
  [13636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5053),
  [13638] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__property_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(9276),
  [13641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__property_defn_repeat1, 2, 0, 0),
  [13643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4842),
  [13645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8461),
  [13647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7378),
  [13649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10415),
  [13651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8194),
  [13653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6394),
  [13655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3774),
  [13657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6298),
  [13659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4946),
  [13661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8305),
  [13663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10196),
  [13665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10025),
  [13667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5012),
  [13669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_field_pattern_repeat1, 2, 0, 0),
  [13671] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_field_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(3797),
  [13674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2858),
  [13676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10072),
  [13678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2839),
  [13680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2857),
  [13682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8164),
  [13684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6209),
  [13686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10083),
  [13688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2850),
  [13690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5235),
  [13692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9491),
  [13694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [13696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9481),
  [13698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5237),
  [13700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [13702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5748),
  [13704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9519),
  [13706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4966),
  [13708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [13710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3633),
  [13712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9976),
  [13714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9810),
  [13716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9846),
  [13718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2478),
  [13720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3614),
  [13722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10067),
  [13724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9767),
  [13726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7986),
  [13728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4930),
  [13730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6887),
  [13732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8398),
  [13734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4872),
  [13736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6913),
  [13738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10159),
  [13740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [13742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4198),
  [13744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_attributes, 1, 0, 0),
  [13746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6918),
  [13748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6330),
  [13750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6877),
  [13752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11387),
  [13754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10167),
  [13756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [13758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6629),
  [13760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9514),
  [13762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5244),
  [13764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9874),
  [13766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2547),
  [13768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10617),
  [13770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5243),
  [13772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11374),
  [13774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9543),
  [13776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4975),
  [13778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4958),
  [13780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4961),
  [13782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8107),
  [13784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5214),
  [13786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3132),
  [13788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3136),
  [13790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12000),
  [13792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5212),
  [13794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3452),
  [13796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3456),
  [13798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_ranges, 2, 0, 0),
  [13800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10181),
  [13802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2175),
  [13804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__module_body_repeat1, 2, 0, 0), SHIFT_REPEAT(576),
  [13807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__module_body_repeat1, 2, 0, 0),
  [13809] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__class_type_body_repeat1, 2, 0, 0), SHIFT_REPEAT(5013),
  [13812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__class_type_body_repeat1, 2, 0, 0),
  [13814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3570),
  [13816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3567),
  [13818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10183),
  [13820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [13822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4895),
  [13824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6382),
  [13826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5792),
  [13828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8087),
  [13830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11201),
  [13832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8084),
  [13834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11322),
  [13836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10121),
  [13838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3524),
  [13840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3648),
  [13842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9502),
  [13844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9689),
  [13846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6412),
  [13848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6374),
  [13850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11308),
  [13852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5781),
  [13854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6635),
  [13856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializers, 2, 0, 0),
  [13858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3626),
  [13860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9441),
  [13862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9654),
  [13864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6362),
  [13866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7531),
  [13868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10058),
  [13870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [13872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5110),
  [13874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7993),
  [13876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7549),
  [13878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_arguments_spec_repeat1, 2, 0, 0),
  [13880] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_spec_repeat1, 2, 0, 0), SHIFT_REPEAT(5291),
  [13883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10140),
  [13885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3501),
  [13887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7557),
  [13889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10039),
  [13891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [13893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10269),
  [13895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4910),
  [13897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [13899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [13901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5107),
  [13903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8246),
  [13905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7577),
  [13907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7386),
  [13909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9834),
  [13911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [13913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5857),
  [13915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11246),
  [13917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11228),
  [13919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10675),
  [13921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [13923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5813),
  [13925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6665),
  [13927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3870),
  [13929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9592),
  [13931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3125),
  [13933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10098),
  [13935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [13937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_constr_args, 3, 0, 0),
  [13939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7039),
  [13941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9885),
  [13943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [13945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3612),
  [13947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9776),
  [13949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9551),
  [13951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3673),
  [13953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9545),
  [13955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9585),
  [13957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7081),
  [13959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7002),
  [13961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6957),
  [13963] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2, 0, 0), SHIFT_REPEAT(8549),
  [13966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9635),
  [13968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3038),
  [13970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6674),
  [13972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_constr_args, 2, 0, 0),
  [13974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2371),
  [13976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4915),
  [13978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [13980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9732),
  [13982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3426),
  [13984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5272),
  [13986] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_active_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(10292),
  [13989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_active_pattern_repeat1, 2, 0, 0),
  [13991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9985),
  [13993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4151),
  [13995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5093),
  [13997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4950),
  [13999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4952),
  [14001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10116),
  [14003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3372),
  [14005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9994),
  [14007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [14009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_type_body, 1, 0, 0),
  [14011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5256),
  [14013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4982),
  [14015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [14017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_type_cases, 3, 0, 0),
  [14019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10090),
  [14021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3367),
  [14023] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_slice_ranges_repeat1, 2, 0, 0), SHIFT_REPEAT(649),
  [14026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5127),
  [14028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9941),
  [14030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5261),
  [14032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5130),
  [14034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3682),
  [14036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10070),
  [14038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9464),
  [14040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5274),
  [14042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_types, 2, 0, 0),
  [14044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5017),
  [14046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12109),
  [14048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4876),
  [14050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5259),
  [14052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7408),
  [14054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9622),
  [14056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6204),
  [14058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5202),
  [14060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4942),
  [14062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7437),
  [14064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7436),
  [14066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3707),
  [14068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9750),
  [14070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9466),
  [14072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5201),
  [14074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [14076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7303),
  [14078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_attributes, 2, 0, 0),
  [14080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [14082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9957),
  [14084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5264),
  [14086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10060),
  [14088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2386),
  [14090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5143),
  [14092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7547),
  [14094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5282),
  [14096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5280),
  [14098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7257),
  [14100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument_defn, 2, 0, 0),
  [14102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7576),
  [14104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7521),
  [14106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9646),
  [14108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6267),
  [14110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9700),
  [14112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3435),
  [14114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3649),
  [14116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10078),
  [14118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10037),
  [14120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3693),
  [14122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9979),
  [14124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9400),
  [14126] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_type_cases_repeat1, 2, 0, 0), SHIFT_REPEAT(9508),
  [14129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_type_cases_repeat1, 2, 0, 0),
  [14131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10345),
  [14133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [14135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [14137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7610),
  [14139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10221),
  [14141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5137),
  [14143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6753),
  [14145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6781),
  [14147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration_left, 4, 0, 0),
  [14149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [14151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [14153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [14155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8129),
  [14157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5739),
  [14159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9563),
  [14161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11175),
  [14163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [14165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3685),
  [14167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3713),
  [14169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [14171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [14173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [14175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7473),
  [14177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7469),
  [14179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [14181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11184),
  [14183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3617),
  [14185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3721),
  [14187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7512),
  [14189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7505),
  [14191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3615),
  [14193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9949),
  [14195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7433),
  [14197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7500),
  [14199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [14201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9992),
  [14203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6048),
  [14205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7358),
  [14207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7357),
  [14209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [14211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [14213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [14215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8955),
  [14217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [14219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [14221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [14223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [14225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9760),
  [14227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6077),
  [14229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [14231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8172),
  [14233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5658),
  [14235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [14237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [14239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9703),
  [14241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5772),
  [14243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [14245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [14247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [14249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [14251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11256),
  [14253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [14255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3686),
  [14257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3712),
  [14259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [14261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [14263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [14265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [14267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [14269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9238),
  [14271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11276),
  [14273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3715),
  [14275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3710),
  [14277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3700),
  [14279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10170),
  [14281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3711),
  [14283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9721),
  [14285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3714),
  [14287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3672),
  [14289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [14291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [14293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10062),
  [14295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6005),
  [14297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11138),
  [14299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [14301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [14303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [14305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9052),
  [14307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3720),
  [14309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3668),
  [14311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11065),
  [14313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8264),
  [14315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5720),
  [14317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [14319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11127),
  [14321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11332),
  [14323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_type_case, 3, 0, 0),
  [14325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7988),
  [14327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5805),
  [14329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3678),
  [14331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3706),
  [14333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [14335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [14337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [14339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9408),
  [14341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6104),
  [14343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6436),
  [14345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6442),
  [14347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [14349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5747),
  [14351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11351),
  [14353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_accessor, 2, 0, 0),
  [14355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6938),
  [14357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6931),
  [14359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3677),
  [14361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3661),
  [14363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3674),
  [14365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9819),
  [14367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10293),
  [14369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9560),
  [14371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6096),
  [14373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6800),
  [14375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6854),
  [14377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [14379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [14381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [14383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [14385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_active_pattern_repeat1, 2, 0, 15),
  [14387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_active_pattern_repeat1, 2, 0, 15),
  [14389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6789),
  [14391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6782),
  [14393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10013),
  [14395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5982),
  [14397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3962),
  [14399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [14401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [14403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8949),
  [14405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3657),
  [14407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9512),
  [14409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3679),
  [14411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3630),
  [14413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11094),
  [14415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [14417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8293),
  [14419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5820),
  [14421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [14423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3734),
  [14425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3735),
  [14427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3934),
  [14429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9399),
  [14431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6105),
  [14433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3851),
  [14435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11428),
  [14437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7428),
  [14439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7435),
  [14441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3656),
  [14443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3697),
  [14445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3651),
  [14447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3698),
  [14449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [14451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11085),
  [14453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6420),
  [14455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6423),
  [14457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3655),
  [14459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3654),
  [14461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8162),
  [14463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5848),
  [14465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [14467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6533),
  [14469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6419),
  [14471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7452),
  [14473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7454),
  [14475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11438),
  [14477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3650),
  [14479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3691),
  [14481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3646),
  [14483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9486),
  [14485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3749),
  [14487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3755),
  [14489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7463),
  [14491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7466),
  [14493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [14495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [14497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [14499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9490),
  [14501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6108),
  [14503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9202),
  [14505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__static_parameter, 1, 0, 0),
  [14507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9533),
  [14509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5952),
  [14511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [14513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3924),
  [14515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [14517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9381),
  [14519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6167),
  [14521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7506),
  [14523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7493),
  [14525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3645),
  [14527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9744),
  [14529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3644),
  [14531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3636),
  [14533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7575),
  [14535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6432),
  [14537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6431),
  [14539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11050),
  [14541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [14543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_element, 3, 0, 0),
  [14545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [14547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [14549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5900),
  [14551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3643),
  [14553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3625),
  [14555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [14557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [14559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [14561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3944),
  [14563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11040),
  [14565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11500),
  [14567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6623),
  [14569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6535),
  [14571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, 0, 0),
  [14573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3622),
  [14575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3683),
  [14577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [14579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6617),
  [14581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6620),
  [14583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6614),
  [14585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6616),
  [14587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [14589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6606),
  [14591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6608),
  [14593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9449),
  [14595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6193),
  [14597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [14599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [14601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11514),
  [14603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [14605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3620),
  [14607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3680),
  [14609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3619),
  [14611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10160),
  [14613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4033),
  [14615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9010),
  [14617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9939),
  [14619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6132),
  [14621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [14623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4043),
  [14625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_declaration_left, 4, 0, 0),
  [14627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10057),
  [14629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5919),
  [14631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [14633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [14635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration_left, 2, 0, 0),
  [14637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3689),
  [14639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3717),
  [14641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9288),
  [14643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3631),
  [14645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10077),
  [14647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_file_repeat1, 1, 0, 0),
  [14649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9155),
  [14651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3629),
  [14653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3704),
  [14655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9102),
  [14657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [14659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10996),
  [14661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8233),
  [14663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5961),
  [14665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9520),
  [14667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6194),
  [14669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_pattern_content, 3, 0, 38),
  [14671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11581),
  [14673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [14675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3688),
  [14677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3670),
  [14679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__object_expression_inner_repeat1, 1, 0, 0),
  [14681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [14683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3623),
  [14685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3613),
  [14687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10980),
  [14689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11255),
  [14691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11593),
  [14693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [14695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3695),
  [14697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3666),
  [14699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [14701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9600),
  [14703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [14705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [14707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3696),
  [14709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9843),
  [14711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10775),
  [14713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [14715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_range, 1, 0, 14),
  [14717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9772),
  [14719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5878),
  [14721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10051),
  [14723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6141),
  [14725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [14727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [14729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [14731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_pattern_content, 4, 0, 53),
  [14733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3671),
  [14735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10027),
  [14737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration_left, 5, 0, 0),
  [14739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [14741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6021),
  [14743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [14745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11660),
  [14747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3701),
  [14749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3660),
  [14751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6429),
  [14753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6441),
  [14755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, 0, 0),
  [14757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11670),
  [14759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10942),
  [14761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6448),
  [14763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6452),
  [14765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3708),
  [14767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3658),
  [14769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3667),
  [14771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9529),
  [14773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6453),
  [14775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6456),
  [14777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7602),
  [14779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3702),
  [14781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3716),
  [14783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6459),
  [14785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6463),
  [14787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9457),
  [14789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5827),
  [14791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_pattern_content, 5, 0, 62),
  [14793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9837),
  [14795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5696),
  [14797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [14799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10930),
  [14801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration_left, 3, 0, 0),
  [14803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9950),
  [14805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5639),
  [14807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3676),
  [14809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9809),
  [14811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3681),
  [14813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3621),
  [14815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12050),
  [14817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10909),
  [14819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10902),
  [14821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3718),
  [14823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3627),
  [14825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11990),
  [14827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9876),
  [14829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6151),
  [14831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9570),
  [14833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6191),
  [14835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10884),
  [14837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3663),
  [14839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9651),
  [14841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10797),
  [14843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3732),
  [14845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3729),
  [14847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5718),
  [14849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10878),
  [14851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3730),
  [14853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3726),
  [14855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7998),
  [14857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6118),
  [14859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4045),
  [14861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9327),
  [14863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [14865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9648),
  [14867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6189),
  [14869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10804),
  [14871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10778),
  [14873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6597),
  [14875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6666),
  [14877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9815),
  [14879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6165),
  [14881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10868),
  [14883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6585),
  [14885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6586),
  [14887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6574),
  [14889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6580),
  [14891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6561),
  [14893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6564),
  [14895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10860),
  [14897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11755),
  [14899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3624),
  [14901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3692),
  [14903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [14905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10782),
  [14907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9659),
  [14909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5706),
  [14911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11769),
  [14913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3694),
  [14915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9625),
  [14917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3687),
  [14919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3635),
  [14921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11850),
  [14923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3628),
  [14925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3641),
  [14927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3632),
  [14929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9468),
  [14931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3684),
  [14933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3637),
  [14935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11831),
  [14937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9743),
  [14939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6172),
  [14941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_static_parameter, 3, 0, 0),
  [14943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6057),
  [14945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10847),
  [14947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6138),
  [14949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10841),
  [14951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9695),
  [14953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6177),
  [14955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3669),
  [14957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3618),
  [14959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10830),
  [14961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10823),
  [14963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9500),
  [14965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5767),
  [14967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [14969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10422),
  [14971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5270),
  [14973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4187),
  [14975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9729),
  [14977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11793),
  [14979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11792),
  [14981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9301),
  [14983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9515),
  [14985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6098),
  [14987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6093),
  [14989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5271),
  [14991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6076),
  [14993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9579),
  [14995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9498),
  [14997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6380),
  [14999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6051),
  [15001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9489),
  [15003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6171),
  [15005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [15007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10531),
  [15009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9781),
  [15011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11828),
  [15013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [15015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5612),
  [15017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3835),
  [15019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11773),
  [15021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11742),
  [15023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9593),
  [15025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4500),
  [15027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6032),
  [15029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11844),
  [15031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6006),
  [15033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6144),
  [15035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5916),
  [15037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11853),
  [15039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11764),
  [15041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11854),
  [15043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5637),
  [15045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [15047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [15049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5924),
  [15051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6137),
  [15053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4567),
  [15055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9647),
  [15057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9650),
  [15059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4149),
  [15061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9435),
  [15063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9674),
  [15065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9210),
  [15067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3825),
  [15069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11875),
  [15071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11749),
  [15073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11876),
  [15075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7806),
  [15077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5277),
  [15079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5763),
  [15081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6131),
  [15083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5289),
  [15085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5749),
  [15087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5736),
  [15089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5729),
  [15091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9417),
  [15093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9761),
  [15095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_as_reference, 2, 0, 0),
  [15097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [15099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6110),
  [15101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5712),
  [15103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11977),
  [15105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3803),
  [15107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [15109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2482),
  [15111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6102),
  [15113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4061),
  [15115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4529),
  [15117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6100),
  [15119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5698),
  [15121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12046),
  [15123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5954),
  [15125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10932),
  [15127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5288),
  [15129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5690),
  [15131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6097),
  [15133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12053),
  [15135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5267),
  [15137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12054),
  [15139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5581),
  [15141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [15143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [15145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5673),
  [15147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4166),
  [15149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9829),
  [15151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11694),
  [15153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11692),
  [15155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9349),
  [15157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9430),
  [15159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9832),
  [15161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9563),
  [15163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2523),
  [15165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10947),
  [15167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9859),
  [15169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9100),
  [15171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9472),
  [15173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12096),
  [15175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12097),
  [15177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9422),
  [15179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8039),
  [15181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [15183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [15185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [15187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [15189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11673),
  [15191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11672),
  [15193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [15195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4534),
  [15197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [15199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4597),
  [15201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6996),
  [15203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2480),
  [15205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11666),
  [15207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4428),
  [15209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [15211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3800),
  [15213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5573),
  [15215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6036),
  [15217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4541),
  [15219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7095),
  [15221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4596),
  [15223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4796),
  [15225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4544),
  [15227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6825),
  [15229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3771),
  [15231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [15233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11614),
  [15235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7092),
  [15237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6030),
  [15239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7057),
  [15241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5538),
  [15243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9657),
  [15245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8298),
  [15247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4063),
  [15249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5514),
  [15251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [15253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6019),
  [15255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1514),
  [15257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9870),
  [15259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6016),
  [15261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6012),
  [15263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8555),
  [15265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [15267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [15269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6007),
  [15271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [15273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5503),
  [15275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4480),
  [15277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4521),
  [15279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4578),
  [15281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [15283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11619),
  [15285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11618),
  [15287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9169),
  [15289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9746),
  [15291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4657),
  [15293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6758),
  [15295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [15297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5418),
  [15299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4377),
  [15301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9777),
  [15303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [15305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6186),
  [15307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9791),
  [15309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [15311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8432),
  [15313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4609),
  [15315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [15317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11596),
  [15319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11595),
  [15321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [15323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [15325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4194),
  [15327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5498),
  [15329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4694),
  [15331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11589),
  [15333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [15335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [15337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [15339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6955),
  [15341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5972),
  [15343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4508),
  [15345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7198),
  [15347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [15349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9894),
  [15351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [15353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [15355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3784),
  [15357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4532),
  [15359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11575),
  [15361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4547),
  [15363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5967),
  [15365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4610),
  [15367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4626),
  [15369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7360),
  [15371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9908),
  [15373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [15375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4483),
  [15377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8583),
  [15379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5960),
  [15381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4740),
  [15383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4738),
  [15385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5957),
  [15387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5956),
  [15389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11023),
  [15391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [15393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6545),
  [15395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5955),
  [15397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6128),
  [15399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7108),
  [15401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7110),
  [15403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6983),
  [15405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [15407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11541),
  [15409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11540),
  [15411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9009),
  [15413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10032),
  [15415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7262),
  [15417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4498),
  [15419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4487),
  [15421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2521),
  [15423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7196),
  [15425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10063),
  [15427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7036),
  [15429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4745),
  [15431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10068),
  [15433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8570),
  [15435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8572),
  [15437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [15439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4425),
  [15441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11518),
  [15443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11517),
  [15445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6750),
  [15447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4651),
  [15449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10257),
  [15451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7314),
  [15453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6221),
  [15455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11509),
  [15457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6185),
  [15459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4552),
  [15461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5473),
  [15463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5912),
  [15465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4490),
  [15467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7041),
  [15469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5558),
  [15471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9895),
  [15473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7286),
  [15475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5569),
  [15477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3821),
  [15479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8159),
  [15481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11498),
  [15483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [15485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5908),
  [15487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4723),
  [15489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4724),
  [15491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5585),
  [15493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9759),
  [15495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5437),
  [15497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7272),
  [15499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4631),
  [15501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5893),
  [15503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4632),
  [15505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6434),
  [15507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5889),
  [15509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5885),
  [15511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2544),
  [15513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7190),
  [15515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5881),
  [15517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7009),
  [15519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7005),
  [15521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2880),
  [15523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [15525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5592),
  [15527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11463),
  [15529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11462),
  [15531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9363),
  [15533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9388),
  [15535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [15537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4869),
  [15539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [15541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [15543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8279),
  [15545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8495),
  [15547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9419),
  [15549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6861),
  [15551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9442),
  [15553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7315),
  [15555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7319),
  [15557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8313),
  [15559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [15561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5435),
  [15563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11442),
  [15565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11441),
  [15567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5602),
  [15569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7127),
  [15571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10273),
  [15573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7130),
  [15575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5942),
  [15577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11434),
  [15579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3057),
  [15581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4426),
  [15583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2422),
  [15585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5828),
  [15587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4517),
  [15589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5633),
  [15591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5570),
  [15593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5891),
  [15595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9578),
  [15597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4600),
  [15599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4579),
  [15601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3872),
  [15603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [15605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11425),
  [15607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5823),
  [15609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8510),
  [15611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8509),
  [15613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4752),
  [15615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2772),
  [15617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9607),
  [15619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5374),
  [15621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8476),
  [15623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5594),
  [15625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5817),
  [15627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5603),
  [15629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5391),
  [15631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5814),
  [15633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5812),
  [15635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5883),
  [15637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4576),
  [15639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4156),
  [15641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5804),
  [15643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5613),
  [15645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [15647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [15649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4608),
  [15651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2624),
  [15653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11358),
  [15655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11373),
  [15657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9175),
  [15659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9728),
  [15661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4599),
  [15663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [15665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [15667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9766),
  [15669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7786),
  [15671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [15673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9786),
  [15675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4721),
  [15677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8488),
  [15679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [15681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11300),
  [15683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11355),
  [15685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8487),
  [15687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6776),
  [15689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2622),
  [15691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5520),
  [15693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5560),
  [15695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11342),
  [15697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4712),
  [15699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7027),
  [15701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [15703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5740),
  [15705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4206),
  [15707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9889),
  [15709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4643),
  [15711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4645),
  [15713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3850),
  [15715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [15717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11328),
  [15719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5040),
  [15721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5728),
  [15723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2664),
  [15725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_type_cases, 1, 0, 0),
  [15727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4095),
  [15729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9937),
  [15731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4713),
  [15733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [15735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4091),
  [15737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6474),
  [15739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5715),
  [15741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6885),
  [15743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4080),
  [15745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5713),
  [15747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5711),
  [15749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [15751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5708),
  [15753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5551),
  [15755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5555),
  [15757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3204),
  [15759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11294),
  [15761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11293),
  [15763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8984),
  [15765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10055),
  [15767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6964),
  [15769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2640),
  [15771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4205),
  [15773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10065),
  [15775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4210),
  [15777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6075),
  [15779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10074),
  [15781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6135),
  [15783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2800),
  [15785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4386),
  [15787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [15789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11279),
  [15791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11278),
  [15793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2596),
  [15795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2641),
  [15797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7746),
  [15799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [15801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [15803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11266),
  [15805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11075),
  [15807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [15809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [15811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5644),
  [15813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4437),
  [15815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7176),
  [15817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10111),
  [15819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [15821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3785),
  [15823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [15825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11252),
  [15827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [15829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5647),
  [15831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4006),
  [15833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [15835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5537),
  [15837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7224),
  [15839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10089),
  [15841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2671),
  [15843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [15845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2674),
  [15847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5660),
  [15849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3468),
  [15851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5670),
  [15853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5671),
  [15855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [15857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5542),
  [15859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5675),
  [15861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4566),
  [15863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11209),
  [15865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11206),
  [15867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9005),
  [15869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10004),
  [15871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [15873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [15875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [15877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7123),
  [15879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9986),
  [15881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [15883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6399),
  [15885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9967),
  [15887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4625),
  [15889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7155),
  [15891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [15893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11188),
  [15895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11187),
  [15897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [15899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7133),
  [15901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7136),
  [15903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8857),
  [15905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [15907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4196),
  [15909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11180),
  [15911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2743),
  [15913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [15915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9909),
  [15917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5019),
  [15919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5962),
  [15921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3761),
  [15923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11173),
  [15925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7240),
  [15927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10221),
  [15929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6087),
  [15931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9879),
  [15933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4571),
  [15935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4168),
  [15937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5741),
  [15939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7239),
  [15941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2678),
  [15943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2781),
  [15945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10249),
  [15947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11162),
  [15949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11161),
  [15951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9135),
  [15953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9778),
  [15955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [15957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [15959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9753),
  [15961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4580),
  [15963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5819),
  [15965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9734),
  [15967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4569),
  [15969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [15971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [15973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11145),
  [15975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11143),
  [15977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4561),
  [15979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [15981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [15983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1945),
  [15985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [15987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4641),
  [15989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11134),
  [15991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6647),
  [15993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10259),
  [15995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9698),
  [15997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4666),
  [15999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3790),
  [16001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [16003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11125),
  [16005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [16007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [16009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9666),
  [16011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4638),
  [16013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2998),
  [16015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5806),
  [16017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [16019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [16021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [16023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11115),
  [16025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11113),
  [16027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9260),
  [16029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9575),
  [16031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [16033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4434),
  [16035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4733),
  [16037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [16039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9552),
  [16041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [16043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9539),
  [16045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6115),
  [16047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8861),
  [16049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [16051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [16053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11099),
  [16055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11098),
  [16057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6009),
  [16059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7014),
  [16061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8870),
  [16063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2425),
  [16065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10112),
  [16067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10113),
  [16069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11090),
  [16071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2778),
  [16073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3760),
  [16075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9465),
  [16077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4760),
  [16079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [16081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3881),
  [16083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11082),
  [16085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6145),
  [16087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2713),
  [16089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9454),
  [16091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [16093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6130),
  [16095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5849),
  [16097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4122),
  [16099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4922),
  [16101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10049),
  [16103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11070),
  [16105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11069),
  [16107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9365),
  [16109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9780),
  [16111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2712),
  [16113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [16115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2897),
  [16117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2898),
  [16119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9497),
  [16121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8076),
  [16123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4637),
  [16125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9522),
  [16127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2439),
  [16129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2187),
  [16131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [16133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11053),
  [16135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11052),
  [16137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6554),
  [16139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2957),
  [16141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2184),
  [16143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6555),
  [16145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7117),
  [16147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2962),
  [16149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11046),
  [16151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [16153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [16155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9544),
  [16157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4851),
  [16159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4748),
  [16161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3862),
  [16163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [16165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11038),
  [16167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4720),
  [16169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9714),
  [16171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3592),
  [16173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [16175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4719),
  [16177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7529),
  [16179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11021),
  [16181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11020),
  [16183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9097),
  [16185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9910),
  [16187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2782),
  [16189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3048),
  [16191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3049),
  [16193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6659),
  [16195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9973),
  [16197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7086),
  [16199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2855),
  [16201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10010),
  [16203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4773),
  [16205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4821),
  [16207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [16209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11003),
  [16211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11001),
  [16213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2851),
  [16215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4774),
  [16217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [16219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4849),
  [16221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5182),
  [16223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5181),
  [16225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10989),
  [16227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6874),
  [16229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7185),
  [16231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10168),
  [16233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [16235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3815),
  [16237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4620),
  [16239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10977),
  [16241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2828),
  [16243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [16245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10130),
  [16247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4617),
  [16249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4114),
  [16251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2245),
  [16253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2786),
  [16255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10964),
  [16257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10963),
  [16259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8974),
  [16261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9931),
  [16263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3224),
  [16265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7400),
  [16267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3225),
  [16269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [16271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10047),
  [16273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4113),
  [16275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [16277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10042),
  [16279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3190),
  [16281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4734),
  [16283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [16285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10950),
  [16287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10948),
  [16289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2732),
  [16291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3163),
  [16293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9284),
  [16295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4726),
  [16297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3837),
  [16299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4882),
  [16301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10936),
  [16303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2766),
  [16305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [16307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10007),
  [16309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [16311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6331),
  [16313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3765),
  [16315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [16317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10924),
  [16319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6670),
  [16321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [16323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9995),
  [16325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [16327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10918),
  [16329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10916),
  [16331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9046),
  [16333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3477),
  [16335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5822),
  [16337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9944),
  [16339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1976),
  [16341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7048),
  [16343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10904),
  [16345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3807),
  [16347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [16349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3770),
  [16351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4879),
  [16353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3489),
  [16355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10896),
  [16357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10894),
  [16359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9087),
  [16361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [16363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8522),
  [16365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1993),
  [16367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9872),
  [16369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [16371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7016),
  [16373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10881),
  [16375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [16377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [16379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [16381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10873),
  [16383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10872),
  [16385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9122),
  [16387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [16389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3138),
  [16391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4861),
  [16393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9813),
  [16395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5120),
  [16397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5114),
  [16399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10863),
  [16401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2033),
  [16403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [16405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [16407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10856),
  [16409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10855),
  [16411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9157),
  [16413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4004),
  [16415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3805),
  [16417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4163),
  [16419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9742),
  [16421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4025),
  [16423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [16425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10844),
  [16427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [16429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [16431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10836),
  [16433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10835),
  [16435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9192),
  [16437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [16439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4524),
  [16441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9692),
  [16443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7146),
  [16445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10828),
  [16447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [16449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2803),
  [16451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10817),
  [16453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10816),
  [16455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9227),
  [16457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [16459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10521),
  [16461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [16463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9645),
  [16465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11129),
  [16467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [16469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10801),
  [16471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [16473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4092),
  [16475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10791),
  [16477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10790),
  [16479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9261),
  [16481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7182),
  [16483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5868),
  [16485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [16487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9569),
  [16489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [16491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [16493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10780),
  [16495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [16497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7324),
  [16499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10772),
  [16501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10767),
  [16503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2809),
  [16505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3258),
  [16507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3259),
  [16509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9517),
  [16511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_field_expression, 5, 0, 51),
  [16513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10755),
  [16515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [16517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10748),
  [16519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10747),
  [16521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [16523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [16525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [16527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9448),
  [16529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [16531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10739),
  [16533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [16535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10732),
  [16537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10730),
  [16539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [16541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2212),
  [16543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [16545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3416),
  [16547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10715),
  [16549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [16551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10708),
  [16553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10610),
  [16555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [16557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [16559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2765),
  [16561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10696),
  [16563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3422),
  [16565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [16567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [16569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [16571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7139),
  [16573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10686),
  [16575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [16577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [16579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2092),
  [16581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [16583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10669),
  [16585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5754),
  [16587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [16589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5752),
  [16591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10657),
  [16593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4798),
  [16595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2728),
  [16597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10644),
  [16599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3043),
  [16601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3044),
  [16603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [16605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10631),
  [16607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [16609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [16611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5298),
  [16613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10621),
  [16615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5124),
  [16617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [16619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10609),
  [16621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7270),
  [16623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [16625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [16627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10597),
  [16629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2995),
  [16631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2378),
  [16633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [16635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10588),
  [16637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6679),
  [16639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [16641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10579),
  [16643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7948),
  [16645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3021),
  [16647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [16649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10570),
  [16651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11169),
  [16653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [16655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [16657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10560),
  [16659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6693),
  [16661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [16663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [16665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10548),
  [16667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [16669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4785),
  [16671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7179),
  [16673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10540),
  [16675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [16677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6364),
  [16679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7819),
  [16681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10529),
  [16683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8357),
  [16685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6215),
  [16687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8351),
  [16689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10518),
  [16691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [16693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [16695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [16697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10509),
  [16699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7045),
  [16701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2929),
  [16703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7446),
  [16705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10499),
  [16707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2915),
  [16709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2906),
  [16711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5219),
  [16713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10489),
  [16715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5723),
  [16717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2895),
  [16719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_constr_args, 6, 0, 0),
  [16721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10479),
  [16723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4016),
  [16725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2875),
  [16727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10472),
  [16729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4766),
  [16731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5224),
  [16733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2868),
  [16735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10451),
  [16737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4073),
  [16739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6571),
  [16741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2863),
  [16743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10369),
  [16745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2861),
  [16747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4020),
  [16749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2853),
  [16751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10441),
  [16753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2849),
  [16755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4188),
  [16757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2848),
  [16759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10432),
  [16761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11186),
  [16763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [16765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8748),
  [16767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6091),
  [16769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7126),
  [16771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [16773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4767),
  [16775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10412),
  [16777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4970),
  [16779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4971),
  [16781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2808),
  [16783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10403),
  [16785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2811),
  [16787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2812),
  [16789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6146),
  [16791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10393),
  [16793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5295),
  [16795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2186),
  [16797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2628),
  [16799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10385),
  [16801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2179),
  [16803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [16805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5358),
  [16807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10378),
  [16809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [16811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3780),
  [16813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [16815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [16817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4212),
  [16819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5369),
  [16821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [16823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11167),
  [16825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [16827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [16829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5695),
  [16831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10705),
  [16833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10717),
  [16835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [16837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6079),
  [16839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [16841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [16843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [16845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [16847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [16849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7537),
  [16851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10733),
  [16853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2380),
  [16855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4215),
  [16857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4277),
  [16859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3616),
  [16861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10286),
  [16863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4242),
  [16865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10283),
  [16867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10282),
  [16869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [16871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2065),
  [16873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6060),
  [16875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [16877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [16879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [16881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [16883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2656),
  [16885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9711),
  [16887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5383),
  [16889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3789),
  [16891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10268),
  [16893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3793),
  [16895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11218),
  [16897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [16899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6278),
  [16901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4787),
  [16903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6873),
  [16905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5650),
  [16907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6923),
  [16909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10261),
  [16911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6754),
  [16913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6889),
  [16915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3888),
  [16917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [16919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2672),
  [16921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11229),
  [16923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11243),
  [16925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6762),
  [16927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6025),
  [16929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3019),
  [16931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2649),
  [16933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2771),
  [16935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3026),
  [16937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3027),
  [16939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10251),
  [16941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6846),
  [16943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5151),
  [16945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6295),
  [16947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4758),
  [16949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3030),
  [16951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4050),
  [16953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [16955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11261),
  [16957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4917),
  [16959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10248),
  [16961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7281),
  [16963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3042),
  [16965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10246),
  [16967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8970),
  [16969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10244),
  [16971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5818),
  [16973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10243),
  [16975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5039),
  [16977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5795),
  [16979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [16981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5164),
  [16983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3047),
  [16985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3065),
  [16987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3066),
  [16989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3838),
  [16991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7243),
  [16993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3090),
  [16995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3091),
  [16997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3092),
  [16999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3096),
  [17001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3634),
  [17003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10231),
  [17005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6094),
  [17007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10227),
  [17009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10226),
  [17011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4993),
  [17013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5286),
  [17015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5262),
  [17017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3129),
  [17019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3130),
  [17021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [17023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [17025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3131),
  [17027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3209),
  [17029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6524),
  [17031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5360),
  [17033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10216),
  [17035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6502),
  [17037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10815),
  [17039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11298),
  [17041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [17043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6283),
  [17045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4800),
  [17047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6479),
  [17049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10203),
  [17051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10822),
  [17053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6457),
  [17055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3917),
  [17057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [17059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6831),
  [17061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11309),
  [17063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11319),
  [17065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6472),
  [17067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5973),
  [17069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3250),
  [17071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7184),
  [17073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2760),
  [17075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3239),
  [17077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3238),
  [17079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10198),
  [17081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6774),
  [17083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4944),
  [17085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6254),
  [17087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4799),
  [17089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [17091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11336),
  [17093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3235),
  [17095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4914),
  [17097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10196),
  [17099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7361),
  [17101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10188),
  [17103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8939),
  [17105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10195),
  [17107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6059),
  [17109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10197),
  [17111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3220),
  [17113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6034),
  [17115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4778),
  [17117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4965),
  [17119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3219),
  [17121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3640),
  [17123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10204),
  [17125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3210),
  [17127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10206),
  [17129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10210),
  [17131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4983),
  [17133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7392),
  [17135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3278),
  [17137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3279),
  [17139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3282),
  [17141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [17143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [17145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3300),
  [17147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5242),
  [17149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5241),
  [17151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5399),
  [17153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [17155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10230),
  [17157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4768),
  [17159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7372),
  [17161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4980),
  [17163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11364),
  [17165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [17167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6265),
  [17169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4806),
  [17171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5128),
  [17173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3407),
  [17175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10245),
  [17177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3410),
  [17179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3412),
  [17181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4834),
  [17183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [17185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11375),
  [17187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11384),
  [17189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7526),
  [17191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7528),
  [17193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2758),
  [17195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7532),
  [17197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10260),
  [17199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6766),
  [17201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6205),
  [17203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4786),
  [17205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3980),
  [17207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [17209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11400),
  [17211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7533),
  [17213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10269),
  [17215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5085),
  [17217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5099),
  [17219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10275),
  [17221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9018),
  [17223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10277),
  [17225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5917),
  [17227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10279),
  [17229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6761),
  [17231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5787),
  [17233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6478),
  [17235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7578),
  [17237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [17239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3652),
  [17241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10300),
  [17243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10304),
  [17245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7387),
  [17247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6812),
  [17249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7388),
  [17251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7214),
  [17253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [17255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [17257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [17259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5381),
  [17261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6216),
  [17263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10320),
  [17265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [17267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5119),
  [17269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4893),
  [17271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2715),
  [17273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10331),
  [17275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [17277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7611),
  [17279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6208),
  [17281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [17283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2744),
  [17285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [17287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [17289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10341),
  [17291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6651),
  [17293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2706),
  [17295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [17297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [17299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10345),
  [17301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [17303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5134),
  [17305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9064),
  [17307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10349),
  [17309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5641),
  [17311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5138),
  [17313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5645),
  [17315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5220),
  [17317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5015),
  [17319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7608),
  [17321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3665),
  [17323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10370),
  [17325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10374),
  [17327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8001),
  [17329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7997),
  [17331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [17333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [17335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [17337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [17339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6827),
  [17341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5364),
  [17343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6688),
  [17345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10390),
  [17347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6682),
  [17349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6676),
  [17351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10401),
  [17353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8910),
  [17355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6671),
  [17357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4940),
  [17359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2739),
  [17361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4948),
  [17363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6430),
  [17365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10411),
  [17367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6796),
  [17369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6628),
  [17371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10985),
  [17373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6945),
  [17375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10415),
  [17377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3271),
  [17379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6468),
  [17381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9127),
  [17383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10419),
  [17385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5682),
  [17387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3603),
  [17389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5685),
  [17391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3273),
  [17393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3274),
  [17395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2196),
  [17397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3675),
  [17399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10439),
  [17401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10443),
  [17403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3275),
  [17405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5200),
  [17407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4857),
  [17409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [17411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2661),
  [17413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3284),
  [17415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5405),
  [17417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2669),
  [17419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10459),
  [17421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2225),
  [17423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5359),
  [17425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3287),
  [17427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3297),
  [17429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3298),
  [17431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10470),
  [17433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5190),
  [17435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5616),
  [17437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2686),
  [17439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3304),
  [17441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2738),
  [17443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3305),
  [17445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3310),
  [17447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10480),
  [17449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6932),
  [17451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3316),
  [17453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5142),
  [17455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8373),
  [17457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10484),
  [17459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8344),
  [17461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3482),
  [17463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9189),
  [17465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10488),
  [17467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5840),
  [17469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2676),
  [17471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5843),
  [17473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [17475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [17477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3364),
  [17479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3690),
  [17481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10508),
  [17483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10512),
  [17485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6724),
  [17487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [17489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3366),
  [17491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [17493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [17495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8379),
  [17497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5395),
  [17499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6591),
  [17501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10528),
  [17503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6684),
  [17505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6686),
  [17507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10539),
  [17509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6715),
  [17511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7958),
  [17513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8191),
  [17515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2737),
  [17517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6740),
  [17519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6737),
  [17521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10549),
  [17523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6712),
  [17525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3022),
  [17527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6685),
  [17529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10553),
  [17531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5672),
  [17533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3015),
  [17535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9258),
  [17537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10557),
  [17539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6042),
  [17541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3011),
  [17543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6050),
  [17545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [17547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3010),
  [17549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8419),
  [17551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3703),
  [17553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10576),
  [17555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10580),
  [17557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4836),
  [17559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7132),
  [17561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2976),
  [17563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [17565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6033),
  [17567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2428),
  [17569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2982),
  [17571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2991),
  [17573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3083),
  [17575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3356),
  [17577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7141),
  [17579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2981),
  [17581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10603),
  [17583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2984),
  [17585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [17587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2988),
  [17589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2992),
  [17591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2731),
  [17593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12125),
  [17595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8389),
  [17597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10613),
  [17599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6878),
  [17601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4929),
  [17603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12124),
  [17605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4928),
  [17607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10617),
  [17609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2170),
  [17611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5901),
  [17613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9311),
  [17615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10620),
  [17617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6291),
  [17619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6288),
  [17621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3073),
  [17623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3709),
  [17625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10635),
  [17627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10639),
  [17629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3084),
  [17631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [17633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3087),
  [17635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7835),
  [17637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6402),
  [17639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6400),
  [17641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6386),
  [17643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10662),
  [17645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6377),
  [17647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4864),
  [17649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2725),
  [17651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4870),
  [17653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10672),
  [17655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6618),
  [17657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6369),
  [17659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6359),
  [17661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10675),
  [17663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [17665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6599),
  [17667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9367),
  [17669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10678),
  [17671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [17673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12115),
  [17675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [17677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3723),
  [17679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10693),
  [17681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10697),
  [17683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5307),
  [17685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [17687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5083),
  [17689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4822),
  [17691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [17693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7332),
  [17695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [17697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [17699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [17701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5273),
  [17703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [17705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [17707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [17709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5003),
  [17711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7293),
  [17713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1984),
  [17715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3705),
  [17717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10737),
  [17719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10741),
  [17721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [17723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [17725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [17727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4973),
  [17729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [17731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5275),
  [17733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5290),
  [17735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [17737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [17739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2293),
  [17741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4827),
  [17743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [17745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2395),
  [17747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [17749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2396),
  [17751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2198),
  [17753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3659),
  [17755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10779),
  [17757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10783),
  [17759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [17761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2201),
  [17763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2203),
  [17765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3223),
  [17767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [17769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6396),
  [17771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7555),
  [17773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8967),
  [17775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7552),
  [17777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7548),
  [17779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7541),
  [17781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3638),
  [17783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10821),
  [17785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10825),
  [17787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5208),
  [17789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5654),
  [17791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10148),
  [17793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8976),
  [17795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [17797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5229),
  [17799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12113),
  [17801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8986),
  [17803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6354),
  [17805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10088),
  [17807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7034),
  [17809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7605),
  [17811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__if_branch, 2, 0, 5),
  [17813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8988),
  [17815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8989),
  [17817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3647),
  [17819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10861),
  [17821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10865),
  [17823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8990),
  [17825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2549),
  [17827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [17829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2469),
  [17831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [17833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8997),
  [17835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2510),
  [17837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2479),
  [17839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11549),
  [17841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8991),
  [17843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7882),
  [17845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12110),
  [17847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [17849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [17851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3719),
  [17853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10901),
  [17855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10905),
  [17857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12112),
  [17859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3368),
  [17861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [17863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5253),
  [17865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [17867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4878),
  [17869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9028),
  [17871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9012),
  [17873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9015),
  [17875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3607),
  [17877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12106),
  [17879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10933),
  [17881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2526),
  [17883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2902),
  [17885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3361),
  [17887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2522),
  [17889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10949),
  [17891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9982),
  [17893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2508),
  [17895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6644),
  [17897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10962),
  [17899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5278),
  [17901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3608),
  [17903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [17905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10975),
  [17907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2360),
  [17909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [17911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10987),
  [17913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [17915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5260),
  [17917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10999),
  [17919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4978),
  [17921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4976),
  [17923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11011),
  [17925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6405),
  [17927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2831),
  [17929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11022),
  [17931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3374),
  [17933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3375),
  [17935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11031),
  [17937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [17939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2401),
  [17941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [17943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [17945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5102),
  [17947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7011),
  [17949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8814),
  [17951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6946),
  [17953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6956),
  [17955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6978),
  [17957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4852),
  [17959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8826),
  [17961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4838),
  [17963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9955),
  [17965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8829),
  [17967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7071),
  [17969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6814),
  [17971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7037),
  [17973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8837),
  [17975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8841),
  [17977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8847),
  [17979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3460),
  [17981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8850),
  [17983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6981),
  [17985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8878),
  [17987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6316),
  [17989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9926),
  [17991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3463),
  [17993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3464),
  [17995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9925),
  [17997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3465),
  [17999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3512),
  [18001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [18003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [18005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5076),
  [18007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [18009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7666),
  [18011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4840),
  [18013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8877),
  [18015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8822),
  [18017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8928),
  [18019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8867),
  [18021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2261),
  [18023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11245),
  [18025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9862),
  [18027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6334),
  [18029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3478),
  [18031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2827),
  [18033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3480),
  [18035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3481),
  [18037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11262),
  [18039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3486),
  [18041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3487),
  [18043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4162),
  [18045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11274),
  [18047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [18049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3492),
  [18051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3493),
  [18053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3494),
  [18055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3502),
  [18057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3903),
  [18059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [18061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [18063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5066),
  [18065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [18067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7657),
  [18069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7974),
  [18071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7970),
  [18073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9720),
  [18075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8806),
  [18077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11321),
  [18079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2894),
  [18081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6406),
  [18083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3517),
  [18085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3518),
  [18087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11337),
  [18089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3525),
  [18091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3527),
  [18093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3529),
  [18095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11349),
  [18097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3907),
  [18099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [18101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [18103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7159),
  [18105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [18107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7730),
  [18109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8833),
  [18111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8893),
  [18113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11386),
  [18115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6381),
  [18117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6925),
  [18119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11401),
  [18121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8891),
  [18123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6935),
  [18125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11413),
  [18127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3933),
  [18129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [18131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [18133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6939),
  [18135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [18137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7808),
  [18139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5628),
  [18141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11455),
  [18143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3938),
  [18145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [18147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [18149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6934),
  [18151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [18153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7905),
  [18155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4064),
  [18157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7709),
  [18159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11497),
  [18161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [18163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [18165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8883),
  [18167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [18169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7929),
  [18171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7793),
  [18173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7713),
  [18175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9699),
  [18177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11539),
  [18179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [18181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [18183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8879),
  [18185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [18187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7836),
  [18189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6905),
  [18191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7562),
  [18193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6886),
  [18195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11580),
  [18197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [18199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [18201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attribute_target, 1, 0, 0),
  [18203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [18205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7741),
  [18207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8875),
  [18209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8873),
  [18211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [18213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [18215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8869),
  [18217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [18219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7659),
  [18221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3462),
  [18223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4877),
  [18225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [18227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [18229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6746),
  [18231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [18233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7831),
  [18235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8845),
  [18237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [18239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [18241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12122),
  [18243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [18245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7945),
  [18247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6660),
  [18249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [18251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [18253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12121),
  [18255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [18257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7822),
  [18259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9547),
  [18261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3432),
  [18263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [18265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [18267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12120),
  [18269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [18271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7764),
  [18273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3430),
  [18275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11980),
  [18277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [18279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [18281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9546),
  [18283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [18285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7705),
  [18287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4955),
  [18289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3429),
  [18291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [18293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [18295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9610),
  [18297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [18299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7648),
  [18301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8077),
  [18303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8031),
  [18305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7685),
  [18307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9476),
  [18309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7654),
  [18311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8832),
  [18313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7676),
  [18315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8830),
  [18317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7781),
  [18319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7720),
  [18321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7733),
  [18323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7784),
  [18325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7799),
  [18327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7824),
  [18329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7830),
  [18331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7897),
  [18333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7913),
  [18335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7922),
  [18337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7951),
  [18339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7956),
  [18341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7942),
  [18343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7933),
  [18345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7798),
  [18347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7915),
  [18349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7911),
  [18351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7899),
  [18353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7886),
  [18355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7879),
  [18357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7859),
  [18359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7856),
  [18361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7837),
  [18363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7834),
  [18365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7833),
  [18367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7832),
  [18369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7818),
  [18371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7817),
  [18373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7735),
  [18375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7796),
  [18377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7794),
  [18379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7776),
  [18381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7770),
  [18383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7765),
  [18385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7759),
  [18387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7755),
  [18389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7754),
  [18391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7752),
  [18393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7683),
  [18395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8851),
  [18397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7821),
  [18399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9504),
  [18401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3392),
  [18403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7120),
  [18405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4943),
  [18407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3381),
  [18409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3369),
  [18411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [18413] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [18415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11687),
  [18417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7667),
  [18419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7678),
  [18421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5935),
  [18423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11856),
  [18425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8140),
  [18427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7840),
  [18429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7773),
  [18431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7774),
  [18433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5856),
  [18435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11881),
  [18437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9350),
  [18439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11693),
  [18441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7917),
  [18443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7918),
  [18445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5768),
  [18447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11901),
  [18449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11699),
  [18451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3337),
  [18453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5758),
  [18455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11911),
  [18457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3336),
  [18459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3326),
  [18461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5751),
  [18463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11921),
  [18465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3308),
  [18467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [18469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5734),
  [18471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11931),
  [18473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11720),
  [18475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5719),
  [18477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11941),
  [18479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3664),
  [18481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6261),
  [18483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6256),
  [18485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4048),
  [18487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [18489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [18491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7124),
  [18493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7401),
  [18495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7420),
  [18497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3263),
  [18499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3289),
  [18501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3292),
  [18503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7227),
  [18505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4142),
  [18507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8645),
  [18509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12119),
  [18511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5584),
  [18513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compiler_directive_decl, 2, 0, 0),
  [18515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_comment, 3, 0, 0),
  [18517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compiler_directive_decl, 3, 0, 8),
  [18519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_line, 3, 0, 0),
  [18521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_line, 4, 0, 21),
  [18523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_line, 4, 0, 0),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__newline = 0,
  ts_external_token__indent = 1,
  ts_external_token__dedent = 2,
  ts_external_token_then = 3,
  ts_external_token_else = 4,
  ts_external_token_elif = 5,
  ts_external_token_POUNDif = 6,
  ts_external_token_POUNDelse = 7,
  ts_external_token_POUNDendif = 8,
  ts_external_token_class = 9,
  ts_external_token__struct_begin = 10,
  ts_external_token__interface_begin = 11,
  ts_external_token_end = 12,
  ts_external_token_and = 13,
  ts_external_token__triple_quoted_content = 14,
  ts_external_token_block_comment_content = 15,
  ts_external_token__inside_string_marker = 16,
  ts_external_token__newline_not_aligned = 17,
  ts_external_token__tuple_marker = 18,
  ts_external_token__error_sentinel = 19,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__newline] = sym__newline,
  [ts_external_token__indent] = sym__indent,
  [ts_external_token__dedent] = sym__dedent,
  [ts_external_token_then] = anon_sym_then,
  [ts_external_token_else] = anon_sym_else,
  [ts_external_token_elif] = anon_sym_elif,
  [ts_external_token_POUNDif] = anon_sym_POUNDif,
  [ts_external_token_POUNDelse] = anon_sym_POUNDelse,
  [ts_external_token_POUNDendif] = anon_sym_POUNDendif,
  [ts_external_token_class] = anon_sym_class,
  [ts_external_token__struct_begin] = sym__struct_begin,
  [ts_external_token__interface_begin] = sym__interface_begin,
  [ts_external_token_end] = anon_sym_end,
  [ts_external_token_and] = anon_sym_and,
  [ts_external_token__triple_quoted_content] = sym__triple_quoted_content,
  [ts_external_token_block_comment_content] = sym_block_comment_content,
  [ts_external_token__inside_string_marker] = sym__inside_string_marker,
  [ts_external_token__newline_not_aligned] = sym__newline_not_aligned,
  [ts_external_token__tuple_marker] = sym__tuple_marker,
  [ts_external_token__error_sentinel] = sym__error_sentinel,
};

static const bool ts_external_scanner_states[48][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token__dedent] = true,
    [ts_external_token_then] = true,
    [ts_external_token_else] = true,
    [ts_external_token_elif] = true,
    [ts_external_token_POUNDif] = true,
    [ts_external_token_class] = true,
    [ts_external_token__struct_begin] = true,
    [ts_external_token__interface_begin] = true,
    [ts_external_token_end] = true,
    [ts_external_token_and] = true,
    [ts_external_token__triple_quoted_content] = true,
    [ts_external_token_block_comment_content] = true,
    [ts_external_token__inside_string_marker] = true,
    [ts_external_token__newline_not_aligned] = true,
    [ts_external_token__tuple_marker] = true,
    [ts_external_token__error_sentinel] = true,
  },
  [2] = {
    [ts_external_token_POUNDif] = true,
  },
  [3] = {
    [ts_external_token__newline] = true,
    [ts_external_token_POUNDif] = true,
    [ts_external_token_and] = true,
  },
  [4] = {
    [ts_external_token__newline] = true,
    [ts_external_token_POUNDif] = true,
    [ts_external_token_POUNDelse] = true,
    [ts_external_token_POUNDendif] = true,
  },
  [5] = {
    [ts_external_token__newline] = true,
    [ts_external_token_POUNDif] = true,
    [ts_external_token_POUNDelse] = true,
    [ts_external_token_POUNDendif] = true,
    [ts_external_token_and] = true,
  },
  [6] = {
    [ts_external_token__newline] = true,
    [ts_external_token__dedent] = true,
    [ts_external_token_POUNDif] = true,
    [ts_external_token_and] = true,
  },
  [7] = {
    [ts_external_token__newline] = true,
    [ts_external_token_POUNDif] = true,
    [ts_external_token_POUNDendif] = true,
    [ts_external_token_and] = true,
  },
  [8] = {
    [ts_external_token__newline] = true,
    [ts_external_token_POUNDif] = true,
    [ts_external_token_POUNDendif] = true,
  },
  [9] = {
    [ts_external_token__newline] = true,
    [ts_external_token__dedent] = true,
    [ts_external_token_POUNDif] = true,
  },
  [10] = {
    [ts_external_token__newline] = true,
    [ts_external_token_POUNDif] = true,
  },
  [11] = {
    [ts_external_token__dedent] = true,
    [ts_external_token_POUNDif] = true,
  },
  [12] = {
    [ts_external_token_POUNDif] = true,
    [ts_external_token_POUNDelse] = true,
    [ts_external_token_POUNDendif] = true,
  },
  [13] = {
    [ts_external_token_POUNDif] = true,
    [ts_external_token__tuple_marker] = true,
  },
  [14] = {
    [ts_external_token_POUNDif] = true,
    [ts_external_token_POUNDendif] = true,
  },
  [15] = {
    [ts_external_token__newline] = true,
    [ts_external_token_else] = true,
    [ts_external_token_elif] = true,
    [ts_external_token_POUNDif] = true,
    [ts_external_token_and] = true,
  },
  [16] = {
    [ts_external_token__newline] = true,
    [ts_external_token_else] = true,
    [ts_external_token_elif] = true,
    [ts_external_token_POUNDif] = true,
    [ts_external_token_POUNDelse] = true,
    [ts_external_token_POUNDendif] = true,
    [ts_external_token_and] = true,
  },
  [17] = {
    [ts_external_token__newline] = true,
    [ts_external_token_else] = true,
    [ts_external_token_elif] = true,
    [ts_external_token_POUNDif] = true,
    [ts_external_token_POUNDelse] = true,
    [ts_external_token_POUNDendif] = true,
  },
  [18] = {
    [ts_external_token__newline] = true,
    [ts_external_token__dedent] = true,
    [ts_external_token_else] = true,
    [ts_external_token_elif] = true,
    [ts_external_token_POUNDif] = true,
    [ts_external_token_and] = true,
  },
  [19] = {
    [ts_external_token__newline] = true,
    [ts_external_token_else] = true,
    [ts_external_token_elif] = true,
    [ts_external_token_POUNDif] = true,
    [ts_external_token_POUNDendif] = true,
  },
  [20] = {
    [ts_external_token__newline] = true,
    [ts_external_token__dedent] = true,
    [ts_external_token_else] = true,
    [ts_external_token_elif] = true,
    [ts_external_token_POUNDif] = true,
  },
  [21] = {
    [ts_external_token__newline] = true,
    [ts_external_token_else] = true,
    [ts_external_token_elif] = true,
    [ts_external_token_POUNDif] = true,
    [ts_external_token_POUNDendif] = true,
    [ts_external_token_and] = true,
  },
  [22] = {
    [ts_external_token__newline] = true,
    [ts_external_token_else] = true,
    [ts_external_token_elif] = true,
    [ts_external_token_POUNDif] = true,
  },
  [23] = {
    [ts_external_token_POUNDif] = true,
    [ts_external_token_and] = true,
  },
  [24] = {
    [ts_external_token__newline] = true,
  },
  [25] = {
    [ts_external_token__newline] = true,
    [ts_external_token__dedent] = true,
  },
  [26] = {
    [ts_external_token_POUNDif] = true,
    [ts_external_token_POUNDelse] = true,
    [ts_external_token_POUNDendif] = true,
    [ts_external_token_and] = true,
  },
  [27] = {
    [ts_external_token_POUNDif] = true,
    [ts_external_token_POUNDendif] = true,
    [ts_external_token_and] = true,
  },
  [28] = {
    [ts_external_token__newline] = true,
    [ts_external_token_and] = true,
  },
  [29] = {
    [ts_external_token__newline] = true,
    [ts_external_token__dedent] = true,
    [ts_external_token_and] = true,
  },
  [30] = {
    [ts_external_token_and] = true,
  },
  [31] = {
    [ts_external_token__dedent] = true,
  },
  [32] = {
    [ts_external_token__dedent] = true,
    [ts_external_token_POUNDif] = true,
    [ts_external_token_and] = true,
  },
  [33] = {
    [ts_external_token__inside_string_marker] = true,
  },
  [34] = {
    [ts_external_token__dedent] = true,
    [ts_external_token_and] = true,
  },
  [35] = {
    [ts_external_token_POUNDelse] = true,
    [ts_external_token_POUNDendif] = true,
  },
  [36] = {
    [ts_external_token_POUNDendif] = true,
  },
  [37] = {
    [ts_external_token_POUNDelse] = true,
    [ts_external_token_POUNDendif] = true,
    [ts_external_token_and] = true,
  },
  [38] = {
    [ts_external_token_POUNDendif] = true,
    [ts_external_token_and] = true,
  },
  [39] = {
    [ts_external_token__indent] = true,
    [ts_external_token_class] = true,
    [ts_external_token__struct_begin] = true,
    [ts_external_token__interface_begin] = true,
  },
  [40] = {
    [ts_external_token__newline_not_aligned] = true,
  },
  [41] = {
    [ts_external_token__indent] = true,
    [ts_external_token_class] = true,
    [ts_external_token__struct_begin] = true,
  },
  [42] = {
    [ts_external_token__indent] = true,
  },
  [43] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
  },
  [44] = {
    [ts_external_token_then] = true,
  },
  [45] = {
    [ts_external_token__triple_quoted_content] = true,
  },
  [46] = {
    [ts_external_token_end] = true,
  },
  [47] = {
    [ts_external_token_block_comment_content] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_fsharp_external_scanner_create(void);
void tree_sitter_fsharp_external_scanner_destroy(void *);
bool tree_sitter_fsharp_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_fsharp_external_scanner_serialize(void *, char *);
void tree_sitter_fsharp_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_fsharp(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_fsharp_external_scanner_create,
      tree_sitter_fsharp_external_scanner_destroy,
      tree_sitter_fsharp_external_scanner_scan,
      tree_sitter_fsharp_external_scanner_serialize,
      tree_sitter_fsharp_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
